'''
# `data_akamai_imaging_policy_image`

Refer to the Terraform Registry for docs: [`data_akamai_imaging_policy_image`](https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image).
'''
import abc
import builtins
import datetime
import enum
import typing

import jsii
import publication
import typing_extensions

from typeguard import check_type

from .._jsii import *

import cdktf as _cdktf_9a9027ec
import constructs as _constructs_77d1e7e8


class DataAkamaiImagingPolicyImage(
    _cdktf_9a9027ec.TerraformDataSource,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImage",
):
    '''Represents a {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image akamai_imaging_policy_image}.'''

    def __init__(
        self,
        scope: _constructs_77d1e7e8.Construct,
        id_: builtins.str,
        *,
        policy: typing.Union["DataAkamaiImagingPolicyImagePolicy", typing.Dict[builtins.str, typing.Any]],
        id: typing.Optional[builtins.str] = None,
        connection: typing.Optional[typing.Union[typing.Union[_cdktf_9a9027ec.SSHProvisionerConnection, typing.Dict[builtins.str, typing.Any]], typing.Union[_cdktf_9a9027ec.WinrmProvisionerConnection, typing.Dict[builtins.str, typing.Any]]]] = None,
        count: typing.Optional[typing.Union[jsii.Number, _cdktf_9a9027ec.TerraformCount]] = None,
        depends_on: typing.Optional[typing.Sequence[_cdktf_9a9027ec.ITerraformDependable]] = None,
        for_each: typing.Optional[_cdktf_9a9027ec.ITerraformIterator] = None,
        lifecycle: typing.Optional[typing.Union[_cdktf_9a9027ec.TerraformResourceLifecycle, typing.Dict[builtins.str, typing.Any]]] = None,
        provider: typing.Optional[_cdktf_9a9027ec.TerraformProvider] = None,
        provisioners: typing.Optional[typing.Sequence[typing.Union[typing.Union[_cdktf_9a9027ec.FileProvisioner, typing.Dict[builtins.str, typing.Any]], typing.Union[_cdktf_9a9027ec.LocalExecProvisioner, typing.Dict[builtins.str, typing.Any]], typing.Union[_cdktf_9a9027ec.RemoteExecProvisioner, typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''Create a new {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image akamai_imaging_policy_image} Data Source.

        :param scope: The scope in which to define this construct.
        :param id_: The scoped construct ID. Must be unique amongst siblings in the same scope
        :param policy: policy block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#policy DataAkamaiImagingPolicyImage#policy}
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#id DataAkamaiImagingPolicyImage#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param connection: 
        :param count: 
        :param depends_on: 
        :param for_each: 
        :param lifecycle: 
        :param provider: 
        :param provisioners: 
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa67c1d35fafc500927c6cfd2ed6b5a56b41b20dc0efa603a18f43fcb542e636)
            check_type(argname="argument scope", value=scope, expected_type=type_hints["scope"])
            check_type(argname="argument id_", value=id_, expected_type=type_hints["id_"])
        config = DataAkamaiImagingPolicyImageConfig(
            policy=policy,
            id=id,
            connection=connection,
            count=count,
            depends_on=depends_on,
            for_each=for_each,
            lifecycle=lifecycle,
            provider=provider,
            provisioners=provisioners,
        )

        jsii.create(self.__class__, self, [scope, id_, config])

    @jsii.member(jsii_name="generateConfigForImport")
    @builtins.classmethod
    def generate_config_for_import(
        cls,
        scope: _constructs_77d1e7e8.Construct,
        import_to_id: builtins.str,
        import_from_id: builtins.str,
        provider: typing.Optional[_cdktf_9a9027ec.TerraformProvider] = None,
    ) -> _cdktf_9a9027ec.ImportableResource:
        '''Generates CDKTF code for importing a DataAkamaiImagingPolicyImage resource upon running "cdktf plan ".

        :param scope: The scope in which to define this construct.
        :param import_to_id: The construct id used in the generated config for the DataAkamaiImagingPolicyImage to import.
        :param import_from_id: The id of the existing DataAkamaiImagingPolicyImage that should be imported. Refer to the {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#import import section} in the documentation of this resource for the id to use
        :param provider: ? Optional instance of the provider where the DataAkamaiImagingPolicyImage to import is found.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__12208aeca9df727eca81de92357d1ca9e98355f64090f7e76a6846ca2fe8f6c6)
            check_type(argname="argument scope", value=scope, expected_type=type_hints["scope"])
            check_type(argname="argument import_to_id", value=import_to_id, expected_type=type_hints["import_to_id"])
            check_type(argname="argument import_from_id", value=import_from_id, expected_type=type_hints["import_from_id"])
            check_type(argname="argument provider", value=provider, expected_type=type_hints["provider"])
        return typing.cast(_cdktf_9a9027ec.ImportableResource, jsii.sinvoke(cls, "generateConfigForImport", [scope, import_to_id, import_from_id, provider]))

    @jsii.member(jsii_name="putPolicy")
    def put_policy(
        self,
        *,
        breakpoints: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyBreakpoints", typing.Dict[builtins.str, typing.Any]]] = None,
        hosts: typing.Optional[typing.Sequence[builtins.str]] = None,
        output: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyOutput", typing.Dict[builtins.str, typing.Any]]] = None,
        post_breakpoint_transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformations", typing.Dict[builtins.str, typing.Any]]]]] = None,
        rollout_duration: typing.Optional[builtins.str] = None,
        serve_stale_duration: typing.Optional[builtins.str] = None,
        transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformations", typing.Dict[builtins.str, typing.Any]]]]] = None,
        variables: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyVariables", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param breakpoints: breakpoints block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#breakpoints DataAkamaiImagingPolicyImage#breakpoints}
        :param hosts: Hosts that are allowed for image/video URLs within transformations or variables. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hosts DataAkamaiImagingPolicyImage#hosts}
        :param output: output block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#output DataAkamaiImagingPolicyImage#output}
        :param post_breakpoint_transformations: post_breakpoint_transformations block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#post_breakpoint_transformations DataAkamaiImagingPolicyImage#post_breakpoint_transformations}
        :param rollout_duration: The amount of time in seconds that the policy takes to rollout. During the rollout an increasing proportion of images/videos will begin to use the new policy instead of the cached images/videos from the previous version. This value has no effect on the staging network. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rollout_duration DataAkamaiImagingPolicyImage#rollout_duration}
        :param serve_stale_duration: The amount of time in seconds that the policy will serve stale images. During the serve stale period realtime images will attempt to use the offline image from the previous policy version first if possible. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#serve_stale_duration DataAkamaiImagingPolicyImage#serve_stale_duration}
        :param transformations: transformations block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        :param variables: variables block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#variables DataAkamaiImagingPolicyImage#variables}
        '''
        value = DataAkamaiImagingPolicyImagePolicy(
            breakpoints=breakpoints,
            hosts=hosts,
            output=output,
            post_breakpoint_transformations=post_breakpoint_transformations,
            rollout_duration=rollout_duration,
            serve_stale_duration=serve_stale_duration,
            transformations=transformations,
            variables=variables,
        )

        return typing.cast(None, jsii.invoke(self, "putPolicy", [value]))

    @jsii.member(jsii_name="resetId")
    def reset_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetId", []))

    @jsii.member(jsii_name="synthesizeAttributes")
    def _synthesize_attributes(self) -> typing.Mapping[builtins.str, typing.Any]:
        return typing.cast(typing.Mapping[builtins.str, typing.Any], jsii.invoke(self, "synthesizeAttributes", []))

    @jsii.member(jsii_name="synthesizeHclAttributes")
    def _synthesize_hcl_attributes(self) -> typing.Mapping[builtins.str, typing.Any]:
        return typing.cast(typing.Mapping[builtins.str, typing.Any], jsii.invoke(self, "synthesizeHclAttributes", []))

    @jsii.python.classproperty
    @jsii.member(jsii_name="tfResourceType")
    def TF_RESOURCE_TYPE(cls) -> builtins.str:
        return typing.cast(builtins.str, jsii.sget(cls, "tfResourceType"))

    @builtins.property
    @jsii.member(jsii_name="json")
    def json(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "json"))

    @builtins.property
    @jsii.member(jsii_name="policy")
    def policy(self) -> "DataAkamaiImagingPolicyImagePolicyOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyOutputReference", jsii.get(self, "policy"))

    @builtins.property
    @jsii.member(jsii_name="idInput")
    def id_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "idInput"))

    @builtins.property
    @jsii.member(jsii_name="policyInput")
    def policy_input(self) -> typing.Optional["DataAkamaiImagingPolicyImagePolicy"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicy"], jsii.get(self, "policyInput"))

    @builtins.property
    @jsii.member(jsii_name="id")
    def id(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "id"))

    @id.setter
    def id(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b930b5b17ea8b3d384536756bae63dec69e365cdbb040e79df56b4d6973e1ae6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "id", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImageConfig",
    jsii_struct_bases=[_cdktf_9a9027ec.TerraformMetaArguments],
    name_mapping={
        "connection": "connection",
        "count": "count",
        "depends_on": "dependsOn",
        "for_each": "forEach",
        "lifecycle": "lifecycle",
        "provider": "provider",
        "provisioners": "provisioners",
        "policy": "policy",
        "id": "id",
    },
)
class DataAkamaiImagingPolicyImageConfig(_cdktf_9a9027ec.TerraformMetaArguments):
    def __init__(
        self,
        *,
        connection: typing.Optional[typing.Union[typing.Union[_cdktf_9a9027ec.SSHProvisionerConnection, typing.Dict[builtins.str, typing.Any]], typing.Union[_cdktf_9a9027ec.WinrmProvisionerConnection, typing.Dict[builtins.str, typing.Any]]]] = None,
        count: typing.Optional[typing.Union[jsii.Number, _cdktf_9a9027ec.TerraformCount]] = None,
        depends_on: typing.Optional[typing.Sequence[_cdktf_9a9027ec.ITerraformDependable]] = None,
        for_each: typing.Optional[_cdktf_9a9027ec.ITerraformIterator] = None,
        lifecycle: typing.Optional[typing.Union[_cdktf_9a9027ec.TerraformResourceLifecycle, typing.Dict[builtins.str, typing.Any]]] = None,
        provider: typing.Optional[_cdktf_9a9027ec.TerraformProvider] = None,
        provisioners: typing.Optional[typing.Sequence[typing.Union[typing.Union[_cdktf_9a9027ec.FileProvisioner, typing.Dict[builtins.str, typing.Any]], typing.Union[_cdktf_9a9027ec.LocalExecProvisioner, typing.Dict[builtins.str, typing.Any]], typing.Union[_cdktf_9a9027ec.RemoteExecProvisioner, typing.Dict[builtins.str, typing.Any]]]]] = None,
        policy: typing.Union["DataAkamaiImagingPolicyImagePolicy", typing.Dict[builtins.str, typing.Any]],
        id: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param connection: 
        :param count: 
        :param depends_on: 
        :param for_each: 
        :param lifecycle: 
        :param provider: 
        :param provisioners: 
        :param policy: policy block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#policy DataAkamaiImagingPolicyImage#policy}
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#id DataAkamaiImagingPolicyImage#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        '''
        if isinstance(lifecycle, dict):
            lifecycle = _cdktf_9a9027ec.TerraformResourceLifecycle(**lifecycle)
        if isinstance(policy, dict):
            policy = DataAkamaiImagingPolicyImagePolicy(**policy)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d8d7cdf78b038e598e98235478653ac3d6f5d113341fbb6b0a3926758360e960)
            check_type(argname="argument connection", value=connection, expected_type=type_hints["connection"])
            check_type(argname="argument count", value=count, expected_type=type_hints["count"])
            check_type(argname="argument depends_on", value=depends_on, expected_type=type_hints["depends_on"])
            check_type(argname="argument for_each", value=for_each, expected_type=type_hints["for_each"])
            check_type(argname="argument lifecycle", value=lifecycle, expected_type=type_hints["lifecycle"])
            check_type(argname="argument provider", value=provider, expected_type=type_hints["provider"])
            check_type(argname="argument provisioners", value=provisioners, expected_type=type_hints["provisioners"])
            check_type(argname="argument policy", value=policy, expected_type=type_hints["policy"])
            check_type(argname="argument id", value=id, expected_type=type_hints["id"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "policy": policy,
        }
        if connection is not None:
            self._values["connection"] = connection
        if count is not None:
            self._values["count"] = count
        if depends_on is not None:
            self._values["depends_on"] = depends_on
        if for_each is not None:
            self._values["for_each"] = for_each
        if lifecycle is not None:
            self._values["lifecycle"] = lifecycle
        if provider is not None:
            self._values["provider"] = provider
        if provisioners is not None:
            self._values["provisioners"] = provisioners
        if id is not None:
            self._values["id"] = id

    @builtins.property
    def connection(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.SSHProvisionerConnection, _cdktf_9a9027ec.WinrmProvisionerConnection]]:
        '''
        :stability: experimental
        '''
        result = self._values.get("connection")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.SSHProvisionerConnection, _cdktf_9a9027ec.WinrmProvisionerConnection]], result)

    @builtins.property
    def count(
        self,
    ) -> typing.Optional[typing.Union[jsii.Number, _cdktf_9a9027ec.TerraformCount]]:
        '''
        :stability: experimental
        '''
        result = self._values.get("count")
        return typing.cast(typing.Optional[typing.Union[jsii.Number, _cdktf_9a9027ec.TerraformCount]], result)

    @builtins.property
    def depends_on(
        self,
    ) -> typing.Optional[typing.List[_cdktf_9a9027ec.ITerraformDependable]]:
        '''
        :stability: experimental
        '''
        result = self._values.get("depends_on")
        return typing.cast(typing.Optional[typing.List[_cdktf_9a9027ec.ITerraformDependable]], result)

    @builtins.property
    def for_each(self) -> typing.Optional[_cdktf_9a9027ec.ITerraformIterator]:
        '''
        :stability: experimental
        '''
        result = self._values.get("for_each")
        return typing.cast(typing.Optional[_cdktf_9a9027ec.ITerraformIterator], result)

    @builtins.property
    def lifecycle(self) -> typing.Optional[_cdktf_9a9027ec.TerraformResourceLifecycle]:
        '''
        :stability: experimental
        '''
        result = self._values.get("lifecycle")
        return typing.cast(typing.Optional[_cdktf_9a9027ec.TerraformResourceLifecycle], result)

    @builtins.property
    def provider(self) -> typing.Optional[_cdktf_9a9027ec.TerraformProvider]:
        '''
        :stability: experimental
        '''
        result = self._values.get("provider")
        return typing.cast(typing.Optional[_cdktf_9a9027ec.TerraformProvider], result)

    @builtins.property
    def provisioners(
        self,
    ) -> typing.Optional[typing.List[typing.Union[_cdktf_9a9027ec.FileProvisioner, _cdktf_9a9027ec.LocalExecProvisioner, _cdktf_9a9027ec.RemoteExecProvisioner]]]:
        '''
        :stability: experimental
        '''
        result = self._values.get("provisioners")
        return typing.cast(typing.Optional[typing.List[typing.Union[_cdktf_9a9027ec.FileProvisioner, _cdktf_9a9027ec.LocalExecProvisioner, _cdktf_9a9027ec.RemoteExecProvisioner]]], result)

    @builtins.property
    def policy(self) -> "DataAkamaiImagingPolicyImagePolicy":
        '''policy block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#policy DataAkamaiImagingPolicyImage#policy}
        '''
        result = self._values.get("policy")
        assert result is not None, "Required property 'policy' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicy", result)

    @builtins.property
    def id(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#id DataAkamaiImagingPolicyImage#id}.

        Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
        If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        '''
        result = self._values.get("id")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImageConfig(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicy",
    jsii_struct_bases=[],
    name_mapping={
        "breakpoints": "breakpoints",
        "hosts": "hosts",
        "output": "output",
        "post_breakpoint_transformations": "postBreakpointTransformations",
        "rollout_duration": "rolloutDuration",
        "serve_stale_duration": "serveStaleDuration",
        "transformations": "transformations",
        "variables": "variables",
    },
)
class DataAkamaiImagingPolicyImagePolicy:
    def __init__(
        self,
        *,
        breakpoints: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyBreakpoints", typing.Dict[builtins.str, typing.Any]]] = None,
        hosts: typing.Optional[typing.Sequence[builtins.str]] = None,
        output: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyOutput", typing.Dict[builtins.str, typing.Any]]] = None,
        post_breakpoint_transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformations", typing.Dict[builtins.str, typing.Any]]]]] = None,
        rollout_duration: typing.Optional[builtins.str] = None,
        serve_stale_duration: typing.Optional[builtins.str] = None,
        transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformations", typing.Dict[builtins.str, typing.Any]]]]] = None,
        variables: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyVariables", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param breakpoints: breakpoints block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#breakpoints DataAkamaiImagingPolicyImage#breakpoints}
        :param hosts: Hosts that are allowed for image/video URLs within transformations or variables. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hosts DataAkamaiImagingPolicyImage#hosts}
        :param output: output block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#output DataAkamaiImagingPolicyImage#output}
        :param post_breakpoint_transformations: post_breakpoint_transformations block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#post_breakpoint_transformations DataAkamaiImagingPolicyImage#post_breakpoint_transformations}
        :param rollout_duration: The amount of time in seconds that the policy takes to rollout. During the rollout an increasing proportion of images/videos will begin to use the new policy instead of the cached images/videos from the previous version. This value has no effect on the staging network. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rollout_duration DataAkamaiImagingPolicyImage#rollout_duration}
        :param serve_stale_duration: The amount of time in seconds that the policy will serve stale images. During the serve stale period realtime images will attempt to use the offline image from the previous policy version first if possible. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#serve_stale_duration DataAkamaiImagingPolicyImage#serve_stale_duration}
        :param transformations: transformations block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        :param variables: variables block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#variables DataAkamaiImagingPolicyImage#variables}
        '''
        if isinstance(breakpoints, dict):
            breakpoints = DataAkamaiImagingPolicyImagePolicyBreakpoints(**breakpoints)
        if isinstance(output, dict):
            output = DataAkamaiImagingPolicyImagePolicyOutput(**output)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2c1b3a76e154edd3464ad8e197ec85a4e1e0747d79aea73d07f128eacae44a2d)
            check_type(argname="argument breakpoints", value=breakpoints, expected_type=type_hints["breakpoints"])
            check_type(argname="argument hosts", value=hosts, expected_type=type_hints["hosts"])
            check_type(argname="argument output", value=output, expected_type=type_hints["output"])
            check_type(argname="argument post_breakpoint_transformations", value=post_breakpoint_transformations, expected_type=type_hints["post_breakpoint_transformations"])
            check_type(argname="argument rollout_duration", value=rollout_duration, expected_type=type_hints["rollout_duration"])
            check_type(argname="argument serve_stale_duration", value=serve_stale_duration, expected_type=type_hints["serve_stale_duration"])
            check_type(argname="argument transformations", value=transformations, expected_type=type_hints["transformations"])
            check_type(argname="argument variables", value=variables, expected_type=type_hints["variables"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if breakpoints is not None:
            self._values["breakpoints"] = breakpoints
        if hosts is not None:
            self._values["hosts"] = hosts
        if output is not None:
            self._values["output"] = output
        if post_breakpoint_transformations is not None:
            self._values["post_breakpoint_transformations"] = post_breakpoint_transformations
        if rollout_duration is not None:
            self._values["rollout_duration"] = rollout_duration
        if serve_stale_duration is not None:
            self._values["serve_stale_duration"] = serve_stale_duration
        if transformations is not None:
            self._values["transformations"] = transformations
        if variables is not None:
            self._values["variables"] = variables

    @builtins.property
    def breakpoints(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyBreakpoints"]:
        '''breakpoints block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#breakpoints DataAkamaiImagingPolicyImage#breakpoints}
        '''
        result = self._values.get("breakpoints")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyBreakpoints"], result)

    @builtins.property
    def hosts(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Hosts that are allowed for image/video URLs within transformations or variables.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hosts DataAkamaiImagingPolicyImage#hosts}
        '''
        result = self._values.get("hosts")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def output(self) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyOutput"]:
        '''output block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#output DataAkamaiImagingPolicyImage#output}
        '''
        result = self._values.get("output")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyOutput"], result)

    @builtins.property
    def post_breakpoint_transformations(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformations"]]]:
        '''post_breakpoint_transformations block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#post_breakpoint_transformations DataAkamaiImagingPolicyImage#post_breakpoint_transformations}
        '''
        result = self._values.get("post_breakpoint_transformations")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformations"]]], result)

    @builtins.property
    def rollout_duration(self) -> typing.Optional[builtins.str]:
        '''The amount of time in seconds that the policy takes to rollout.

        During the rollout an increasing proportion of images/videos will begin to use the new policy instead of the cached images/videos from the previous version. This value has no effect on the staging network.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rollout_duration DataAkamaiImagingPolicyImage#rollout_duration}
        '''
        result = self._values.get("rollout_duration")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def serve_stale_duration(self) -> typing.Optional[builtins.str]:
        '''The amount of time in seconds that the policy will serve stale images.

        During the serve stale period realtime images will attempt to use the offline image from the previous policy version first if possible.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#serve_stale_duration DataAkamaiImagingPolicyImage#serve_stale_duration}
        '''
        result = self._values.get("serve_stale_duration")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def transformations(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformations"]]]:
        '''transformations block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        result = self._values.get("transformations")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformations"]]], result)

    @builtins.property
    def variables(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyVariables"]]]:
        '''variables block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#variables DataAkamaiImagingPolicyImage#variables}
        '''
        result = self._values.get("variables")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyVariables"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicy(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyBreakpoints",
    jsii_struct_bases=[],
    name_mapping={"widths": "widths"},
)
class DataAkamaiImagingPolicyImagePolicyBreakpoints:
    def __init__(
        self,
        *,
        widths: typing.Optional[typing.Sequence[jsii.Number]] = None,
    ) -> None:
        '''
        :param widths: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#widths DataAkamaiImagingPolicyImage#widths}.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__477bd190572fab7b7278674e6e4fcd87f8266b73b0b91e6749371f80d1fbece3)
            check_type(argname="argument widths", value=widths, expected_type=type_hints["widths"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if widths is not None:
            self._values["widths"] = widths

    @builtins.property
    def widths(self) -> typing.Optional[typing.List[jsii.Number]]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#widths DataAkamaiImagingPolicyImage#widths}.'''
        result = self._values.get("widths")
        return typing.cast(typing.Optional[typing.List[jsii.Number]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyBreakpoints(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyBreakpointsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyBreakpointsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__594b130aa84b81dc1fc3b006bf83dddda4a0858060150b97ce080ca11c8b7568)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetWidths")
    def reset_widths(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidths", []))

    @builtins.property
    @jsii.member(jsii_name="widthsInput")
    def widths_input(self) -> typing.Optional[typing.List[jsii.Number]]:
        return typing.cast(typing.Optional[typing.List[jsii.Number]], jsii.get(self, "widthsInput"))

    @builtins.property
    @jsii.member(jsii_name="widths")
    def widths(self) -> typing.List[jsii.Number]:
        return typing.cast(typing.List[jsii.Number], jsii.get(self, "widths"))

    @widths.setter
    def widths(self, value: typing.List[jsii.Number]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f1a3cca8ecef95116dc959890ebcbca3aeeb93a391032e31db8c1b25ec6e751)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widths", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyBreakpoints]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyBreakpoints], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyBreakpoints],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__379aa6372b50c29089fa535ed9872904f1d31137509a34519d92d60459e5b817)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyOutput",
    jsii_struct_bases=[],
    name_mapping={
        "adaptive_quality": "adaptiveQuality",
        "allowed_formats": "allowedFormats",
        "allow_pristine_on_downsize": "allowPristineOnDownsize",
        "forced_formats": "forcedFormats",
        "perceptual_quality": "perceptualQuality",
        "perceptual_quality_floor": "perceptualQualityFloor",
        "perceptual_quality_var": "perceptualQualityVar",
        "prefer_modern_formats": "preferModernFormats",
        "quality": "quality",
        "quality_var": "qualityVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyOutput:
    def __init__(
        self,
        *,
        adaptive_quality: typing.Optional[builtins.str] = None,
        allowed_formats: typing.Optional[typing.Sequence[builtins.str]] = None,
        allow_pristine_on_downsize: typing.Optional[builtins.str] = None,
        forced_formats: typing.Optional[typing.Sequence[builtins.str]] = None,
        perceptual_quality: typing.Optional[builtins.str] = None,
        perceptual_quality_floor: typing.Optional[builtins.str] = None,
        perceptual_quality_var: typing.Optional[builtins.str] = None,
        prefer_modern_formats: typing.Optional[builtins.str] = None,
        quality: typing.Optional[builtins.str] = None,
        quality_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param adaptive_quality: Override the quality of image to serve when Image & Video Manager detects a slow connection. Specifying lower values lets users with slow connections browse your site with reduced load times without impacting the quality of images for users with faster connections. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#adaptive_quality DataAkamaiImagingPolicyImage#adaptive_quality}
        :param allowed_formats: The graphics file formats allowed for browser specific results. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allowed_formats DataAkamaiImagingPolicyImage#allowed_formats}
        :param allow_pristine_on_downsize: Whether a pristine image wider than the requested breakpoint is allowed as a derivative image if it has the fewest bytes. This will not have an affect if transformations are present. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_pristine_on_downsize DataAkamaiImagingPolicyImage#allow_pristine_on_downsize}
        :param forced_formats: The forced extra formats for the ``imFormat`` query parameter, which requests a specific browser type. By default, Image and Video Manager detects the browser and returns the appropriate image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#forced_formats DataAkamaiImagingPolicyImage#forced_formats}
        :param perceptual_quality: Mutually exclusive with quality. The perceptual quality to use when comparing resulting images, which overrides the ``quality`` setting. Perceptual quality tunes each image format's quality parameter dynamically based on the human-perceived quality of the output image. This can result in better byte savings (as compared to using regular quality) as many images can be encoded at a much lower quality without compromising perception of the image. In addition, certain images may need to be encoded at a slightly higher quality in order to maintain human-perceived quality. Values are tiered ``high``, ``mediumHigh``, ``medium``, ``mediumLow``, or ``low``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#perceptual_quality DataAkamaiImagingPolicyImage#perceptual_quality}
        :param perceptual_quality_floor: Only applies with perceptualQuality set. Sets a minimum image quality to respect when using perceptual quality. Perceptual quality will not reduce the quality below this value even if it determines the compressed image to be acceptably visually similar. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#perceptual_quality_floor DataAkamaiImagingPolicyImage#perceptual_quality_floor}
        :param perceptual_quality_var: Mutually exclusive with quality. The perceptual quality to use when comparing resulting images, which overrides the ``quality`` setting. Perceptual quality tunes each image format's quality parameter dynamically based on the human-perceived quality of the output image. This can result in better byte savings (as compared to using regular quality) as many images can be encoded at a much lower quality without compromising perception of the image. In addition, certain images may need to be encoded at a slightly higher quality in order to maintain human-perceived quality. Values are tiered ``high``, ``mediumHigh``, ``medium``, ``mediumLow``, or ``low``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#perceptual_quality_var DataAkamaiImagingPolicyImage#perceptual_quality_var}
        :param prefer_modern_formats: Whether derivative image formats should be selected with a preference for modern formats (such as WebP and Avif) instead the format that results in the fewest bytes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#prefer_modern_formats DataAkamaiImagingPolicyImage#prefer_modern_formats}
        :param quality: Mutually exclusive with perceptualQuality, used by default if neither is specified. The chosen quality of the output images. Using a quality value from 1-100 resembles JPEG quality across output formats. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#quality DataAkamaiImagingPolicyImage#quality}
        :param quality_var: Mutually exclusive with perceptualQuality, used by default if neither is specified. The chosen quality of the output images. Using a quality value from 1-100 resembles JPEG quality across output formats. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#quality_var DataAkamaiImagingPolicyImage#quality_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f4d1d604f1cc694898a17245fce9fd53f5a65ede319a256a9964a9dcfc9dc34)
            check_type(argname="argument adaptive_quality", value=adaptive_quality, expected_type=type_hints["adaptive_quality"])
            check_type(argname="argument allowed_formats", value=allowed_formats, expected_type=type_hints["allowed_formats"])
            check_type(argname="argument allow_pristine_on_downsize", value=allow_pristine_on_downsize, expected_type=type_hints["allow_pristine_on_downsize"])
            check_type(argname="argument forced_formats", value=forced_formats, expected_type=type_hints["forced_formats"])
            check_type(argname="argument perceptual_quality", value=perceptual_quality, expected_type=type_hints["perceptual_quality"])
            check_type(argname="argument perceptual_quality_floor", value=perceptual_quality_floor, expected_type=type_hints["perceptual_quality_floor"])
            check_type(argname="argument perceptual_quality_var", value=perceptual_quality_var, expected_type=type_hints["perceptual_quality_var"])
            check_type(argname="argument prefer_modern_formats", value=prefer_modern_formats, expected_type=type_hints["prefer_modern_formats"])
            check_type(argname="argument quality", value=quality, expected_type=type_hints["quality"])
            check_type(argname="argument quality_var", value=quality_var, expected_type=type_hints["quality_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if adaptive_quality is not None:
            self._values["adaptive_quality"] = adaptive_quality
        if allowed_formats is not None:
            self._values["allowed_formats"] = allowed_formats
        if allow_pristine_on_downsize is not None:
            self._values["allow_pristine_on_downsize"] = allow_pristine_on_downsize
        if forced_formats is not None:
            self._values["forced_formats"] = forced_formats
        if perceptual_quality is not None:
            self._values["perceptual_quality"] = perceptual_quality
        if perceptual_quality_floor is not None:
            self._values["perceptual_quality_floor"] = perceptual_quality_floor
        if perceptual_quality_var is not None:
            self._values["perceptual_quality_var"] = perceptual_quality_var
        if prefer_modern_formats is not None:
            self._values["prefer_modern_formats"] = prefer_modern_formats
        if quality is not None:
            self._values["quality"] = quality
        if quality_var is not None:
            self._values["quality_var"] = quality_var

    @builtins.property
    def adaptive_quality(self) -> typing.Optional[builtins.str]:
        '''Override the quality of image to serve when Image & Video Manager detects a slow connection.

        Specifying lower values lets users with slow connections browse your site with reduced load times without impacting the quality of images for users with faster connections.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#adaptive_quality DataAkamaiImagingPolicyImage#adaptive_quality}
        '''
        result = self._values.get("adaptive_quality")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def allowed_formats(self) -> typing.Optional[typing.List[builtins.str]]:
        '''The graphics file formats allowed for browser specific results.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allowed_formats DataAkamaiImagingPolicyImage#allowed_formats}
        '''
        result = self._values.get("allowed_formats")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def allow_pristine_on_downsize(self) -> typing.Optional[builtins.str]:
        '''Whether a pristine image wider than the requested breakpoint is allowed as a derivative image if it has the fewest bytes.

        This will not have an affect if transformations are present.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_pristine_on_downsize DataAkamaiImagingPolicyImage#allow_pristine_on_downsize}
        '''
        result = self._values.get("allow_pristine_on_downsize")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def forced_formats(self) -> typing.Optional[typing.List[builtins.str]]:
        '''The forced extra formats for the ``imFormat`` query parameter, which requests a specific browser type.

        By default, Image and Video Manager detects the browser and returns the appropriate image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#forced_formats DataAkamaiImagingPolicyImage#forced_formats}
        '''
        result = self._values.get("forced_formats")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def perceptual_quality(self) -> typing.Optional[builtins.str]:
        '''Mutually exclusive with quality.

        The perceptual quality to use when comparing resulting images, which overrides the ``quality`` setting. Perceptual quality tunes each image format's quality parameter dynamically based on the human-perceived quality of the output image. This can result in better byte savings (as compared to using regular quality) as many images can be encoded at a much lower quality without compromising perception of the image. In addition, certain images may need to be encoded at a slightly higher quality in order to maintain human-perceived quality. Values are tiered ``high``, ``mediumHigh``, ``medium``, ``mediumLow``, or ``low``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#perceptual_quality DataAkamaiImagingPolicyImage#perceptual_quality}
        '''
        result = self._values.get("perceptual_quality")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def perceptual_quality_floor(self) -> typing.Optional[builtins.str]:
        '''Only applies with perceptualQuality set.

        Sets a minimum image quality to respect when using perceptual quality. Perceptual quality will not reduce the quality below this value even if it determines the compressed image to be acceptably visually similar.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#perceptual_quality_floor DataAkamaiImagingPolicyImage#perceptual_quality_floor}
        '''
        result = self._values.get("perceptual_quality_floor")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def perceptual_quality_var(self) -> typing.Optional[builtins.str]:
        '''Mutually exclusive with quality.

        The perceptual quality to use when comparing resulting images, which overrides the ``quality`` setting. Perceptual quality tunes each image format's quality parameter dynamically based on the human-perceived quality of the output image. This can result in better byte savings (as compared to using regular quality) as many images can be encoded at a much lower quality without compromising perception of the image. In addition, certain images may need to be encoded at a slightly higher quality in order to maintain human-perceived quality. Values are tiered ``high``, ``mediumHigh``, ``medium``, ``mediumLow``, or ``low``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#perceptual_quality_var DataAkamaiImagingPolicyImage#perceptual_quality_var}
        '''
        result = self._values.get("perceptual_quality_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def prefer_modern_formats(self) -> typing.Optional[builtins.str]:
        '''Whether derivative image formats should be selected with a preference for modern formats (such as WebP and Avif) instead the format that results in the fewest bytes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#prefer_modern_formats DataAkamaiImagingPolicyImage#prefer_modern_formats}
        '''
        result = self._values.get("prefer_modern_formats")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def quality(self) -> typing.Optional[builtins.str]:
        '''Mutually exclusive with perceptualQuality, used by default if neither is specified.

        The chosen quality of the output images. Using a quality value from 1-100 resembles JPEG quality across output formats.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#quality DataAkamaiImagingPolicyImage#quality}
        '''
        result = self._values.get("quality")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def quality_var(self) -> typing.Optional[builtins.str]:
        '''Mutually exclusive with perceptualQuality, used by default if neither is specified.

        The chosen quality of the output images. Using a quality value from 1-100 resembles JPEG quality across output formats.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#quality_var DataAkamaiImagingPolicyImage#quality_var}
        '''
        result = self._values.get("quality_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyOutput(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyOutputOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyOutputOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cb8c7ae57fcbc8a210b6f919669723cb78ee9c6d2bcec3d57c4d8dbf93f690ba)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetAdaptiveQuality")
    def reset_adaptive_quality(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAdaptiveQuality", []))

    @jsii.member(jsii_name="resetAllowedFormats")
    def reset_allowed_formats(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowedFormats", []))

    @jsii.member(jsii_name="resetAllowPristineOnDownsize")
    def reset_allow_pristine_on_downsize(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowPristineOnDownsize", []))

    @jsii.member(jsii_name="resetForcedFormats")
    def reset_forced_formats(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetForcedFormats", []))

    @jsii.member(jsii_name="resetPerceptualQuality")
    def reset_perceptual_quality(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPerceptualQuality", []))

    @jsii.member(jsii_name="resetPerceptualQualityFloor")
    def reset_perceptual_quality_floor(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPerceptualQualityFloor", []))

    @jsii.member(jsii_name="resetPerceptualQualityVar")
    def reset_perceptual_quality_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPerceptualQualityVar", []))

    @jsii.member(jsii_name="resetPreferModernFormats")
    def reset_prefer_modern_formats(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPreferModernFormats", []))

    @jsii.member(jsii_name="resetQuality")
    def reset_quality(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetQuality", []))

    @jsii.member(jsii_name="resetQualityVar")
    def reset_quality_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetQualityVar", []))

    @builtins.property
    @jsii.member(jsii_name="adaptiveQualityInput")
    def adaptive_quality_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "adaptiveQualityInput"))

    @builtins.property
    @jsii.member(jsii_name="allowedFormatsInput")
    def allowed_formats_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "allowedFormatsInput"))

    @builtins.property
    @jsii.member(jsii_name="allowPristineOnDownsizeInput")
    def allow_pristine_on_downsize_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowPristineOnDownsizeInput"))

    @builtins.property
    @jsii.member(jsii_name="forcedFormatsInput")
    def forced_formats_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "forcedFormatsInput"))

    @builtins.property
    @jsii.member(jsii_name="perceptualQualityFloorInput")
    def perceptual_quality_floor_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "perceptualQualityFloorInput"))

    @builtins.property
    @jsii.member(jsii_name="perceptualQualityInput")
    def perceptual_quality_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "perceptualQualityInput"))

    @builtins.property
    @jsii.member(jsii_name="perceptualQualityVarInput")
    def perceptual_quality_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "perceptualQualityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="preferModernFormatsInput")
    def prefer_modern_formats_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "preferModernFormatsInput"))

    @builtins.property
    @jsii.member(jsii_name="qualityInput")
    def quality_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "qualityInput"))

    @builtins.property
    @jsii.member(jsii_name="qualityVarInput")
    def quality_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "qualityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="adaptiveQuality")
    def adaptive_quality(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "adaptiveQuality"))

    @adaptive_quality.setter
    def adaptive_quality(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7e82c87e485e4458f45a26dae70ae9bd4102d31daa461982a90ea71a34a2b2ca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "adaptiveQuality", value)

    @builtins.property
    @jsii.member(jsii_name="allowedFormats")
    def allowed_formats(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "allowedFormats"))

    @allowed_formats.setter
    def allowed_formats(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9865feec89c557fd6ee787a4752c5fb1b5f0b7d2498926e1bc9adec256dcd1c0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowedFormats", value)

    @builtins.property
    @jsii.member(jsii_name="allowPristineOnDownsize")
    def allow_pristine_on_downsize(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowPristineOnDownsize"))

    @allow_pristine_on_downsize.setter
    def allow_pristine_on_downsize(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5cbb7b53383b4afbe3c1f4effc2f035b57b24fbc5cfeeac72185b979abd63b10)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowPristineOnDownsize", value)

    @builtins.property
    @jsii.member(jsii_name="forcedFormats")
    def forced_formats(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "forcedFormats"))

    @forced_formats.setter
    def forced_formats(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a8d8e2b92099ce70c6cec999cfabff256f5eb0ace25dfcf743c8675da930b03)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "forcedFormats", value)

    @builtins.property
    @jsii.member(jsii_name="perceptualQuality")
    def perceptual_quality(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "perceptualQuality"))

    @perceptual_quality.setter
    def perceptual_quality(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d570a44457842ba89bbbee1079810dc7bc3c7f6980be042b746a1e57be7189d4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "perceptualQuality", value)

    @builtins.property
    @jsii.member(jsii_name="perceptualQualityFloor")
    def perceptual_quality_floor(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "perceptualQualityFloor"))

    @perceptual_quality_floor.setter
    def perceptual_quality_floor(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f20de6facc1442aabf78e216d6378e6f042b5cd0eb4c37d0b468e3c470886334)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "perceptualQualityFloor", value)

    @builtins.property
    @jsii.member(jsii_name="perceptualQualityVar")
    def perceptual_quality_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "perceptualQualityVar"))

    @perceptual_quality_var.setter
    def perceptual_quality_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__38566ea236a4a1b8c34138798baa44288c486ea9066b611276f07f4f2edb839f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "perceptualQualityVar", value)

    @builtins.property
    @jsii.member(jsii_name="preferModernFormats")
    def prefer_modern_formats(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "preferModernFormats"))

    @prefer_modern_formats.setter
    def prefer_modern_formats(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fd49b222dd1f8a79ace3940442e0e26f7152efa375c8775bc559d83d4820ea42)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "preferModernFormats", value)

    @builtins.property
    @jsii.member(jsii_name="quality")
    def quality(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "quality"))

    @quality.setter
    def quality(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8478235b2fbe4d9092bf5b5f00d700180345840ece943a1506a6d476953d3813)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "quality", value)

    @builtins.property
    @jsii.member(jsii_name="qualityVar")
    def quality_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "qualityVar"))

    @quality_var.setter
    def quality_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a7e2fe17b00172a513eb5d1de2a7e91180d21ca24d6d5a735637cc76bc844963)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "qualityVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyOutput]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyOutput], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyOutput],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__90391d6b3e07b93c300d416f0f5d592cc70cc7a96f3f8ed3545b228b0a9e0be5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2e57fe01c1c2ef852e84bd23913a18be40aa9b63c44f88b06fe7d5cfa89b1770)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putBreakpoints")
    def put_breakpoints(
        self,
        *,
        widths: typing.Optional[typing.Sequence[jsii.Number]] = None,
    ) -> None:
        '''
        :param widths: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#widths DataAkamaiImagingPolicyImage#widths}.
        '''
        value = DataAkamaiImagingPolicyImagePolicyBreakpoints(widths=widths)

        return typing.cast(None, jsii.invoke(self, "putBreakpoints", [value]))

    @jsii.member(jsii_name="putOutput")
    def put_output(
        self,
        *,
        adaptive_quality: typing.Optional[builtins.str] = None,
        allowed_formats: typing.Optional[typing.Sequence[builtins.str]] = None,
        allow_pristine_on_downsize: typing.Optional[builtins.str] = None,
        forced_formats: typing.Optional[typing.Sequence[builtins.str]] = None,
        perceptual_quality: typing.Optional[builtins.str] = None,
        perceptual_quality_floor: typing.Optional[builtins.str] = None,
        perceptual_quality_var: typing.Optional[builtins.str] = None,
        prefer_modern_formats: typing.Optional[builtins.str] = None,
        quality: typing.Optional[builtins.str] = None,
        quality_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param adaptive_quality: Override the quality of image to serve when Image & Video Manager detects a slow connection. Specifying lower values lets users with slow connections browse your site with reduced load times without impacting the quality of images for users with faster connections. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#adaptive_quality DataAkamaiImagingPolicyImage#adaptive_quality}
        :param allowed_formats: The graphics file formats allowed for browser specific results. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allowed_formats DataAkamaiImagingPolicyImage#allowed_formats}
        :param allow_pristine_on_downsize: Whether a pristine image wider than the requested breakpoint is allowed as a derivative image if it has the fewest bytes. This will not have an affect if transformations are present. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_pristine_on_downsize DataAkamaiImagingPolicyImage#allow_pristine_on_downsize}
        :param forced_formats: The forced extra formats for the ``imFormat`` query parameter, which requests a specific browser type. By default, Image and Video Manager detects the browser and returns the appropriate image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#forced_formats DataAkamaiImagingPolicyImage#forced_formats}
        :param perceptual_quality: Mutually exclusive with quality. The perceptual quality to use when comparing resulting images, which overrides the ``quality`` setting. Perceptual quality tunes each image format's quality parameter dynamically based on the human-perceived quality of the output image. This can result in better byte savings (as compared to using regular quality) as many images can be encoded at a much lower quality without compromising perception of the image. In addition, certain images may need to be encoded at a slightly higher quality in order to maintain human-perceived quality. Values are tiered ``high``, ``mediumHigh``, ``medium``, ``mediumLow``, or ``low``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#perceptual_quality DataAkamaiImagingPolicyImage#perceptual_quality}
        :param perceptual_quality_floor: Only applies with perceptualQuality set. Sets a minimum image quality to respect when using perceptual quality. Perceptual quality will not reduce the quality below this value even if it determines the compressed image to be acceptably visually similar. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#perceptual_quality_floor DataAkamaiImagingPolicyImage#perceptual_quality_floor}
        :param perceptual_quality_var: Mutually exclusive with quality. The perceptual quality to use when comparing resulting images, which overrides the ``quality`` setting. Perceptual quality tunes each image format's quality parameter dynamically based on the human-perceived quality of the output image. This can result in better byte savings (as compared to using regular quality) as many images can be encoded at a much lower quality without compromising perception of the image. In addition, certain images may need to be encoded at a slightly higher quality in order to maintain human-perceived quality. Values are tiered ``high``, ``mediumHigh``, ``medium``, ``mediumLow``, or ``low``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#perceptual_quality_var DataAkamaiImagingPolicyImage#perceptual_quality_var}
        :param prefer_modern_formats: Whether derivative image formats should be selected with a preference for modern formats (such as WebP and Avif) instead the format that results in the fewest bytes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#prefer_modern_formats DataAkamaiImagingPolicyImage#prefer_modern_formats}
        :param quality: Mutually exclusive with perceptualQuality, used by default if neither is specified. The chosen quality of the output images. Using a quality value from 1-100 resembles JPEG quality across output formats. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#quality DataAkamaiImagingPolicyImage#quality}
        :param quality_var: Mutually exclusive with perceptualQuality, used by default if neither is specified. The chosen quality of the output images. Using a quality value from 1-100 resembles JPEG quality across output formats. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#quality_var DataAkamaiImagingPolicyImage#quality_var}
        '''
        value = DataAkamaiImagingPolicyImagePolicyOutput(
            adaptive_quality=adaptive_quality,
            allowed_formats=allowed_formats,
            allow_pristine_on_downsize=allow_pristine_on_downsize,
            forced_formats=forced_formats,
            perceptual_quality=perceptual_quality,
            perceptual_quality_floor=perceptual_quality_floor,
            perceptual_quality_var=perceptual_quality_var,
            prefer_modern_formats=prefer_modern_formats,
            quality=quality,
            quality_var=quality_var,
        )

        return typing.cast(None, jsii.invoke(self, "putOutput", [value]))

    @jsii.member(jsii_name="putPostBreakpointTransformations")
    def put_post_breakpoint_transformations(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformations", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df7417ffb42a9ac5a522db56d5f2740bd9bc543918c51d2e11c03b34cd48fc4b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putPostBreakpointTransformations", [value]))

    @jsii.member(jsii_name="putTransformations")
    def put_transformations(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformations", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e473e31d417c6339ff05fc3d507c7176badbd9b5b1504b13787ab32fff33ae2c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTransformations", [value]))

    @jsii.member(jsii_name="putVariables")
    def put_variables(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyVariables", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4d5d0ac517fecc025e0e5c66885da8b53c32fb543fe4f65da42469772398c57d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putVariables", [value]))

    @jsii.member(jsii_name="resetBreakpoints")
    def reset_breakpoints(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBreakpoints", []))

    @jsii.member(jsii_name="resetHosts")
    def reset_hosts(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHosts", []))

    @jsii.member(jsii_name="resetOutput")
    def reset_output(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOutput", []))

    @jsii.member(jsii_name="resetPostBreakpointTransformations")
    def reset_post_breakpoint_transformations(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPostBreakpointTransformations", []))

    @jsii.member(jsii_name="resetRolloutDuration")
    def reset_rollout_duration(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRolloutDuration", []))

    @jsii.member(jsii_name="resetServeStaleDuration")
    def reset_serve_stale_duration(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetServeStaleDuration", []))

    @jsii.member(jsii_name="resetTransformations")
    def reset_transformations(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformations", []))

    @jsii.member(jsii_name="resetVariables")
    def reset_variables(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVariables", []))

    @builtins.property
    @jsii.member(jsii_name="breakpoints")
    def breakpoints(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyBreakpointsOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyBreakpointsOutputReference, jsii.get(self, "breakpoints"))

    @builtins.property
    @jsii.member(jsii_name="output")
    def output(self) -> DataAkamaiImagingPolicyImagePolicyOutputOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyOutputOutputReference, jsii.get(self, "output"))

    @builtins.property
    @jsii.member(jsii_name="postBreakpointTransformations")
    def post_breakpoint_transformations(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsList", jsii.get(self, "postBreakpointTransformations"))

    @builtins.property
    @jsii.member(jsii_name="transformations")
    def transformations(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsList", jsii.get(self, "transformations"))

    @builtins.property
    @jsii.member(jsii_name="variables")
    def variables(self) -> "DataAkamaiImagingPolicyImagePolicyVariablesList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyVariablesList", jsii.get(self, "variables"))

    @builtins.property
    @jsii.member(jsii_name="breakpointsInput")
    def breakpoints_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyBreakpoints]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyBreakpoints], jsii.get(self, "breakpointsInput"))

    @builtins.property
    @jsii.member(jsii_name="hostsInput")
    def hosts_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "hostsInput"))

    @builtins.property
    @jsii.member(jsii_name="outputInput")
    def output_input(self) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyOutput]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyOutput], jsii.get(self, "outputInput"))

    @builtins.property
    @jsii.member(jsii_name="postBreakpointTransformationsInput")
    def post_breakpoint_transformations_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformations"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformations"]]], jsii.get(self, "postBreakpointTransformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="rolloutDurationInput")
    def rollout_duration_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "rolloutDurationInput"))

    @builtins.property
    @jsii.member(jsii_name="serveStaleDurationInput")
    def serve_stale_duration_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "serveStaleDurationInput"))

    @builtins.property
    @jsii.member(jsii_name="transformationsInput")
    def transformations_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformations"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformations"]]], jsii.get(self, "transformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="variablesInput")
    def variables_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyVariables"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyVariables"]]], jsii.get(self, "variablesInput"))

    @builtins.property
    @jsii.member(jsii_name="hosts")
    def hosts(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "hosts"))

    @hosts.setter
    def hosts(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3bd1f551bad641b8d4f7c27b878a5e8004d426379f58cba3e59e1f9bc88cabb3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hosts", value)

    @builtins.property
    @jsii.member(jsii_name="rolloutDuration")
    def rollout_duration(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "rolloutDuration"))

    @rollout_duration.setter
    def rollout_duration(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8301bbd82fd533487fb6feb8acbd44fe2068b7d2d3a5f910351b1cfead682e9c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "rolloutDuration", value)

    @builtins.property
    @jsii.member(jsii_name="serveStaleDuration")
    def serve_stale_duration(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "serveStaleDuration"))

    @serve_stale_duration.setter
    def serve_stale_duration(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7673294f5bdc7f8084acf97c74cf54710f4587ed6bc41df220b81305f5bccefb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "serveStaleDuration", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(self) -> typing.Optional[DataAkamaiImagingPolicyImagePolicy]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicy], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicy],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__62e9b5a7cd4a7c197844b1666787df30dd43c8c34ffdab75af9760313ff310d5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformations",
    jsii_struct_bases=[],
    name_mapping={
        "background_color": "backgroundColor",
        "blur": "blur",
        "chroma_key": "chromaKey",
        "composite": "composite",
        "compound": "compound",
        "contrast": "contrast",
        "goop": "goop",
        "grayscale": "grayscale",
        "hsl": "hsl",
        "hsv": "hsv",
        "if_dimension": "ifDimension",
        "if_orientation": "ifOrientation",
        "max_colors": "maxColors",
        "mirror": "mirror",
        "mono_hue": "monoHue",
        "opacity": "opacity",
        "remove_color": "removeColor",
        "unsharp_mask": "unsharpMask",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformations:
    def __init__(
        self,
        *,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsBackgroundColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsBlur", typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsChromaKey", typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsComposite", typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompound", typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsContrast", typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsGoop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsGrayscale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsHsl", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsHsv", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimension", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientation", typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsMaxColors", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsMirror", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsMonoHue", typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsOpacity", typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsRemoveColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsUnsharpMask", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8beb93906b00713bc3abdfa02ab3d41b996448f7e228f5fd0da288c2d0611b11)
            check_type(argname="argument background_color", value=background_color, expected_type=type_hints["background_color"])
            check_type(argname="argument blur", value=blur, expected_type=type_hints["blur"])
            check_type(argname="argument chroma_key", value=chroma_key, expected_type=type_hints["chroma_key"])
            check_type(argname="argument composite", value=composite, expected_type=type_hints["composite"])
            check_type(argname="argument compound", value=compound, expected_type=type_hints["compound"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument goop", value=goop, expected_type=type_hints["goop"])
            check_type(argname="argument grayscale", value=grayscale, expected_type=type_hints["grayscale"])
            check_type(argname="argument hsl", value=hsl, expected_type=type_hints["hsl"])
            check_type(argname="argument hsv", value=hsv, expected_type=type_hints["hsv"])
            check_type(argname="argument if_dimension", value=if_dimension, expected_type=type_hints["if_dimension"])
            check_type(argname="argument if_orientation", value=if_orientation, expected_type=type_hints["if_orientation"])
            check_type(argname="argument max_colors", value=max_colors, expected_type=type_hints["max_colors"])
            check_type(argname="argument mirror", value=mirror, expected_type=type_hints["mirror"])
            check_type(argname="argument mono_hue", value=mono_hue, expected_type=type_hints["mono_hue"])
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument remove_color", value=remove_color, expected_type=type_hints["remove_color"])
            check_type(argname="argument unsharp_mask", value=unsharp_mask, expected_type=type_hints["unsharp_mask"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if background_color is not None:
            self._values["background_color"] = background_color
        if blur is not None:
            self._values["blur"] = blur
        if chroma_key is not None:
            self._values["chroma_key"] = chroma_key
        if composite is not None:
            self._values["composite"] = composite
        if compound is not None:
            self._values["compound"] = compound
        if contrast is not None:
            self._values["contrast"] = contrast
        if goop is not None:
            self._values["goop"] = goop
        if grayscale is not None:
            self._values["grayscale"] = grayscale
        if hsl is not None:
            self._values["hsl"] = hsl
        if hsv is not None:
            self._values["hsv"] = hsv
        if if_dimension is not None:
            self._values["if_dimension"] = if_dimension
        if if_orientation is not None:
            self._values["if_orientation"] = if_orientation
        if max_colors is not None:
            self._values["max_colors"] = max_colors
        if mirror is not None:
            self._values["mirror"] = mirror
        if mono_hue is not None:
            self._values["mono_hue"] = mono_hue
        if opacity is not None:
            self._values["opacity"] = opacity
        if remove_color is not None:
            self._values["remove_color"] = remove_color
        if unsharp_mask is not None:
            self._values["unsharp_mask"] = unsharp_mask

    @builtins.property
    def background_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsBackgroundColor"]]]:
        '''background_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        '''
        result = self._values.get("background_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsBackgroundColor"]]], result)

    @builtins.property
    def blur(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsBlur"]]]:
        '''blur block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        '''
        result = self._values.get("blur")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsBlur"]]], result)

    @builtins.property
    def chroma_key(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsChromaKey"]]]:
        '''chroma_key block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        '''
        result = self._values.get("chroma_key")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsChromaKey"]]], result)

    @builtins.property
    def composite(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsComposite"]]]:
        '''composite block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        '''
        result = self._values.get("composite")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsComposite"]]], result)

    @builtins.property
    def compound(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompound"]]]:
        '''compound block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        '''
        result = self._values.get("compound")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompound"]]], result)

    @builtins.property
    def contrast(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsContrast"]]]:
        '''contrast block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsContrast"]]], result)

    @builtins.property
    def goop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsGoop"]]]:
        '''goop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        '''
        result = self._values.get("goop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsGoop"]]], result)

    @builtins.property
    def grayscale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsGrayscale"]]]:
        '''grayscale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        '''
        result = self._values.get("grayscale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsGrayscale"]]], result)

    @builtins.property
    def hsl(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsHsl"]]]:
        '''hsl block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        '''
        result = self._values.get("hsl")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsHsl"]]], result)

    @builtins.property
    def hsv(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsHsv"]]]:
        '''hsv block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        '''
        result = self._values.get("hsv")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsHsv"]]], result)

    @builtins.property
    def if_dimension(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimension"]]]:
        '''if_dimension block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        '''
        result = self._values.get("if_dimension")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimension"]]], result)

    @builtins.property
    def if_orientation(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientation"]]]:
        '''if_orientation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        '''
        result = self._values.get("if_orientation")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientation"]]], result)

    @builtins.property
    def max_colors(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsMaxColors"]]]:
        '''max_colors block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        '''
        result = self._values.get("max_colors")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsMaxColors"]]], result)

    @builtins.property
    def mirror(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsMirror"]]]:
        '''mirror block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        '''
        result = self._values.get("mirror")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsMirror"]]], result)

    @builtins.property
    def mono_hue(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsMonoHue"]]]:
        '''mono_hue block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        '''
        result = self._values.get("mono_hue")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsMonoHue"]]], result)

    @builtins.property
    def opacity(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsOpacity"]]]:
        '''opacity block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsOpacity"]]], result)

    @builtins.property
    def remove_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsRemoveColor"]]]:
        '''remove_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        '''
        result = self._values.get("remove_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsRemoveColor"]]], result)

    @builtins.property
    def unsharp_mask(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsUnsharpMask"]]]:
        '''unsharp_mask block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        result = self._values.get("unsharp_mask")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsUnsharpMask"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformations(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsBackgroundColor",
    jsii_struct_bases=[],
    name_mapping={"color": "color", "color_var": "colorVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsBackgroundColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__976d40ac512762121b9a06c4c05641195b5ae224d696e0418c134298024140df)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsBackgroundColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsBackgroundColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsBackgroundColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a9fd2b0eff845a2649d2bf0e03f7d2e79460ba3dadd02d382b6feed79411538)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsBackgroundColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__86da6f9a53bc6e0c1665d60428e392b2e12938e8a5f131a5eb15aadbe76c197e)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsBackgroundColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cbe2fbe167543f9da42392e55b8c564b1f92664f4592d6bb1efbc709d9b1f01e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fdc2de47033188fcc8c919664e5857001972d1ad3764061b643ec38b3c3833a5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d8e195cc06c2ceec73b93b3d4ec05ec4b5a162e3c84e9d054db3dea8aee33190)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsBackgroundColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsBackgroundColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__16b63b565b615b8aa4246f8f5fb8667649ee036df1908f245128556b5a7b8feb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsBackgroundColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsBackgroundColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__65d1b82a6e78ecb32be58ba02bc6eeafc762f28eec45479f2a290c08a39805b7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a60252d25462107435bc0bc03928c82a9e6e0d9536f93c809b9bf1591f2ba1f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ef5f68b12adea26df6d251fe32ccd8fad9214ba4de2722ca25eff41984e77eff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsBackgroundColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsBackgroundColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsBackgroundColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__60962546c8480862e300b3efb581fa72368c3a7ec97f453195d0a4efb65fb08d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsBlur",
    jsii_struct_bases=[],
    name_mapping={"sigma": "sigma", "sigma_var": "sigmaVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsBlur:
    def __init__(
        self,
        *,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param sigma: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f28fcf4d90c1211834e669ae4fecff33a72a57d5e5c7c9903e9ef863a3822e7b)
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsBlur(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsBlurList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsBlurList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a01703b61e9ed537ef90b54334bb95d556e5be475b78f3dc7f3369cba16c4be8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsBlurOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6504f0be5949718275273fafb98de7df93d6f54ac2681919342974313c8b9f5d)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsBlurOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ef5a783bd3c4b7bd8778bb59609e90003cd84f447739941481ff0f64db23cd1a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b243ec7f2c0c0de3d5a31ec7e5ec15bc4d1da9275372becb0fa151f7b7a9a2c9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4dee906bb90210e80f4eb5e5cef6305f92187ec34b73b6eb0427dda8059aae6e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsBlur]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsBlur]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e6d4dfd92ad03e0778740291f4405bee32e32814890e3637a5074583e2c9f7f2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsBlurOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsBlurOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__83fcc61d131f68b4390387f73d802f6eeaf1a2b1e6d9b0f51a06611850731960)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f92388c2a790f956e1891e1fc34d0661649d1998e0e0a05f1302109585e9679e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__497ff54eaaf14391c35c84d6bcffd9be1f294827f30972f11c2f0931e514809e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsBlur]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsBlur]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsBlur]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d0cbf67a0d37689bef2899544aaea315be1fd2c0e2fe8344c2f436b662d2f6ec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsChromaKey",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_feather": "hueFeather",
        "hue_feather_var": "hueFeatherVar",
        "hue_tolerance": "hueTolerance",
        "hue_tolerance_var": "hueToleranceVar",
        "hue_var": "hueVar",
        "lightness_feather": "lightnessFeather",
        "lightness_feather_var": "lightnessFeatherVar",
        "lightness_tolerance": "lightnessTolerance",
        "lightness_tolerance_var": "lightnessToleranceVar",
        "saturation_feather": "saturationFeather",
        "saturation_feather_var": "saturationFeatherVar",
        "saturation_tolerance": "saturationTolerance",
        "saturation_tolerance_var": "saturationToleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsChromaKey:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_feather: typing.Optional[builtins.str] = None,
        hue_feather_var: typing.Optional[builtins.str] = None,
        hue_tolerance: typing.Optional[builtins.str] = None,
        hue_tolerance_var: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness_feather: typing.Optional[builtins.str] = None,
        lightness_feather_var: typing.Optional[builtins.str] = None,
        lightness_tolerance: typing.Optional[builtins.str] = None,
        lightness_tolerance_var: typing.Optional[builtins.str] = None,
        saturation_feather: typing.Optional[builtins.str] = None,
        saturation_feather_var: typing.Optional[builtins.str] = None,
        saturation_tolerance: typing.Optional[builtins.str] = None,
        saturation_tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_feather: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        :param hue_feather_var: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        :param hue_tolerance: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        :param hue_tolerance_var: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        :param hue_var: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness_feather: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        :param lightness_feather_var: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        :param lightness_tolerance: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        :param lightness_tolerance_var: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        :param saturation_feather: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        :param saturation_feather_var: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        :param saturation_tolerance: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        :param saturation_tolerance_var: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3537e283ef6378332e02ae28a8b34504f6ff29416f837eab551064b4af914a12)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_feather", value=hue_feather, expected_type=type_hints["hue_feather"])
            check_type(argname="argument hue_feather_var", value=hue_feather_var, expected_type=type_hints["hue_feather_var"])
            check_type(argname="argument hue_tolerance", value=hue_tolerance, expected_type=type_hints["hue_tolerance"])
            check_type(argname="argument hue_tolerance_var", value=hue_tolerance_var, expected_type=type_hints["hue_tolerance_var"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness_feather", value=lightness_feather, expected_type=type_hints["lightness_feather"])
            check_type(argname="argument lightness_feather_var", value=lightness_feather_var, expected_type=type_hints["lightness_feather_var"])
            check_type(argname="argument lightness_tolerance", value=lightness_tolerance, expected_type=type_hints["lightness_tolerance"])
            check_type(argname="argument lightness_tolerance_var", value=lightness_tolerance_var, expected_type=type_hints["lightness_tolerance_var"])
            check_type(argname="argument saturation_feather", value=saturation_feather, expected_type=type_hints["saturation_feather"])
            check_type(argname="argument saturation_feather_var", value=saturation_feather_var, expected_type=type_hints["saturation_feather_var"])
            check_type(argname="argument saturation_tolerance", value=saturation_tolerance, expected_type=type_hints["saturation_tolerance"])
            check_type(argname="argument saturation_tolerance_var", value=saturation_tolerance_var, expected_type=type_hints["saturation_tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_feather is not None:
            self._values["hue_feather"] = hue_feather
        if hue_feather_var is not None:
            self._values["hue_feather_var"] = hue_feather_var
        if hue_tolerance is not None:
            self._values["hue_tolerance"] = hue_tolerance
        if hue_tolerance_var is not None:
            self._values["hue_tolerance_var"] = hue_tolerance_var
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness_feather is not None:
            self._values["lightness_feather"] = lightness_feather
        if lightness_feather_var is not None:
            self._values["lightness_feather_var"] = lightness_feather_var
        if lightness_tolerance is not None:
            self._values["lightness_tolerance"] = lightness_tolerance
        if lightness_tolerance_var is not None:
            self._values["lightness_tolerance_var"] = lightness_tolerance_var
        if saturation_feather is not None:
            self._values["saturation_feather"] = saturation_feather
        if saturation_feather_var is not None:
            self._values["saturation_feather_var"] = saturation_feather_var
        if saturation_tolerance is not None:
            self._values["saturation_tolerance"] = saturation_tolerance
        if saturation_tolerance_var is not None:
            self._values["saturation_tolerance_var"] = saturation_tolerance_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        '''
        result = self._values.get("hue_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        '''
        result = self._values.get("hue_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        '''
        result = self._values.get("hue_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        '''
        result = self._values.get("hue_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        '''
        result = self._values.get("lightness_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        '''
        result = self._values.get("lightness_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        '''
        result = self._values.get("lightness_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        '''
        result = self._values.get("lightness_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        '''
        result = self._values.get("saturation_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        '''
        result = self._values.get("saturation_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        '''
        result = self._values.get("saturation_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        result = self._values.get("saturation_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsChromaKey(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsChromaKeyList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsChromaKeyList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3c7fed91cfd2a685ae7db944076a50f77402053c5946931ecb6046d45dce7720)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsChromaKeyOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__79b7062e73057ce589281ea00f5221d31c838570c971188a9d19efd0f30d02e0)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsChromaKeyOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__00eeb6b020e4649506bc6475c7c905a90c8099b082d1567df2f722d8cc306432)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__26a89787f3e8c1a9a36c49e921f1445d3fca856abb6e60f25e2cac2a85fd732d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__84b2ccebf08ef35ae1991187423cb44c5c917a1a6f01741ab93a2c549c59f208)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsChromaKey]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsChromaKey]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cb001d39f0f613d1c04869c8ae1f12fddbc325e328c838f2215cd7440e6ac569)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsChromaKeyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsChromaKeyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__00e5decc2fbeee0260d3807595c4f0dc5d078c43bcd8d171ff297d5771c74ece)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueFeather")
    def reset_hue_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeather", []))

    @jsii.member(jsii_name="resetHueFeatherVar")
    def reset_hue_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeatherVar", []))

    @jsii.member(jsii_name="resetHueTolerance")
    def reset_hue_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueTolerance", []))

    @jsii.member(jsii_name="resetHueToleranceVar")
    def reset_hue_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueToleranceVar", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightnessFeather")
    def reset_lightness_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeather", []))

    @jsii.member(jsii_name="resetLightnessFeatherVar")
    def reset_lightness_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeatherVar", []))

    @jsii.member(jsii_name="resetLightnessTolerance")
    def reset_lightness_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessTolerance", []))

    @jsii.member(jsii_name="resetLightnessToleranceVar")
    def reset_lightness_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessToleranceVar", []))

    @jsii.member(jsii_name="resetSaturationFeather")
    def reset_saturation_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeather", []))

    @jsii.member(jsii_name="resetSaturationFeatherVar")
    def reset_saturation_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeatherVar", []))

    @jsii.member(jsii_name="resetSaturationTolerance")
    def reset_saturation_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationTolerance", []))

    @jsii.member(jsii_name="resetSaturationToleranceVar")
    def reset_saturation_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherInput")
    def hue_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVarInput")
    def hue_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceInput")
    def hue_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVarInput")
    def hue_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherInput")
    def lightness_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVarInput")
    def lightness_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceInput")
    def lightness_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVarInput")
    def lightness_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherInput")
    def saturation_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVarInput")
    def saturation_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceInput")
    def saturation_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVarInput")
    def saturation_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1cb8d60be6c6e690bfadd2d8e0446209d3baa3e9f0e705425ffe5f722943d67c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeather")
    def hue_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeather"))

    @hue_feather.setter
    def hue_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7a6e56bba1033f6f68e19754e27a03f38c17afa5f40f5556b82c5fa3d84444b5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeather", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVar")
    def hue_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeatherVar"))

    @hue_feather_var.setter
    def hue_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f07eba4078fe1eb65d23db0b86bc9b5937af7d5bb08b7c278bf08f841802e505)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueTolerance")
    def hue_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueTolerance"))

    @hue_tolerance.setter
    def hue_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__884d509e1c8720b64d9a977325b611fd12f4829e13494e8f7c890d880b620daa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVar")
    def hue_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueToleranceVar"))

    @hue_tolerance_var.setter
    def hue_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__25ad86e2c526ed3800843a91296ccc42d7d04d6f3daba072dc9aaa903e1dedf5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3081b58925fceb00a3c28a45a1187e88435539e4ae5461567ecf6d4b67ab38ef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeather")
    def lightness_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeather"))

    @lightness_feather.setter
    def lightness_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cb72462616f7baf88a50794c56836cef7432046717084bb76d15f67d49f1ea3f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeather", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVar")
    def lightness_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeatherVar"))

    @lightness_feather_var.setter
    def lightness_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1492e21dea319a9d3f9b5de467a2a671aa55a83fb9e61e5a58452e9abbc921f4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessTolerance")
    def lightness_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessTolerance"))

    @lightness_tolerance.setter
    def lightness_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__90b75488b132f5f9ade340f0fb9c644330611ebbd13252996af5a7990050d1fb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVar")
    def lightness_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessToleranceVar"))

    @lightness_tolerance_var.setter
    def lightness_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__205403a63e53b3439e220b34a47136338855cdb9c2952cd9070e44118c66811d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeather")
    def saturation_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeather"))

    @saturation_feather.setter
    def saturation_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a263120ea55789f598e31b56fe8caa83336dbd35485600aaa3a8d3b9b19095aa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeather", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVar")
    def saturation_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeatherVar"))

    @saturation_feather_var.setter
    def saturation_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__31f64a49490be03a7c16e39051ce937cbe588368c7aa74a1a3deb292fd0f3d74)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationTolerance")
    def saturation_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationTolerance"))

    @saturation_tolerance.setter
    def saturation_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d172c2830d9a258d2fc1e5309ad335aac86bed351180f4cb9a2ffe6f1c9a6e29)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVar")
    def saturation_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationToleranceVar"))

    @saturation_tolerance_var.setter
    def saturation_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6a669c504d218bc8b1d00f11e718aff85083f3d230a497d3ac8567bc02c185f4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsChromaKey]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsChromaKey]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsChromaKey]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f1e3b78a3fbffb3ec1b9a88fcacadc84edf2e7c55507149d3e731b2803d2e7f4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsComposite",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "placement": "placement",
        "placement_var": "placementVar",
        "scale": "scale",
        "scale_dimension": "scaleDimension",
        "scale_dimension_var": "scaleDimensionVar",
        "scale_var": "scaleVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsComposite:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        placement: typing.Optional[builtins.str] = None,
        placement_var: typing.Optional[builtins.str] = None,
        scale: typing.Optional[builtins.str] = None,
        scale_dimension: typing.Optional[builtins.str] = None,
        scale_dimension_var: typing.Optional[builtins.str] = None,
        scale_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param placement: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        :param placement_var: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        :param scale: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param scale_dimension: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        :param scale_dimension_var: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        :param scale_var: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        :param x_position: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c23de0ff5152b6b84ee6361f12bee30b53273acdb5601827ed5ca6f0d3bf003f)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument placement", value=placement, expected_type=type_hints["placement"])
            check_type(argname="argument placement_var", value=placement_var, expected_type=type_hints["placement_var"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument scale_dimension", value=scale_dimension, expected_type=type_hints["scale_dimension"])
            check_type(argname="argument scale_dimension_var", value=scale_dimension_var, expected_type=type_hints["scale_dimension_var"])
            check_type(argname="argument scale_var", value=scale_var, expected_type=type_hints["scale_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if placement is not None:
            self._values["placement"] = placement
        if placement_var is not None:
            self._values["placement_var"] = placement_var
        if scale is not None:
            self._values["scale"] = scale
        if scale_dimension is not None:
            self._values["scale_dimension"] = scale_dimension
        if scale_dimension_var is not None:
            self._values["scale_dimension_var"] = scale_dimension_var
        if scale_var is not None:
            self._values["scale_var"] = scale_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        '''
        result = self._values.get("placement")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement_var(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        '''
        result = self._values.get("placement_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        '''
        result = self._values.get("scale_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        '''
        result = self._values.get("scale_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        '''
        result = self._values.get("scale_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsComposite(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImage",
    jsii_struct_bases=[],
    name_mapping={
        "box_image": "boxImage",
        "circle_image": "circleImage",
        "text_image": "textImage",
        "url_image": "urlImage",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImage:
    def __init__(
        self,
        *,
        box_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImage", typing.Dict[builtins.str, typing.Any]]]]] = None,
        circle_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImage", typing.Dict[builtins.str, typing.Any]]]]] = None,
        text_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImage", typing.Dict[builtins.str, typing.Any]]]]] = None,
        url_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImage", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param box_image: box_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#box_image DataAkamaiImagingPolicyImage#box_image}
        :param circle_image: circle_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#circle_image DataAkamaiImagingPolicyImage#circle_image}
        :param text_image: text_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text_image DataAkamaiImagingPolicyImage#text_image}
        :param url_image: url_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url_image DataAkamaiImagingPolicyImage#url_image}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a06c3cd53c47d16a8db647fb185fbf2095899595a2e4d1c07d68a6aeff0891b)
            check_type(argname="argument box_image", value=box_image, expected_type=type_hints["box_image"])
            check_type(argname="argument circle_image", value=circle_image, expected_type=type_hints["circle_image"])
            check_type(argname="argument text_image", value=text_image, expected_type=type_hints["text_image"])
            check_type(argname="argument url_image", value=url_image, expected_type=type_hints["url_image"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if box_image is not None:
            self._values["box_image"] = box_image
        if circle_image is not None:
            self._values["circle_image"] = circle_image
        if text_image is not None:
            self._values["text_image"] = text_image
        if url_image is not None:
            self._values["url_image"] = url_image

    @builtins.property
    def box_image(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImage"]]]:
        '''box_image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#box_image DataAkamaiImagingPolicyImage#box_image}
        '''
        result = self._values.get("box_image")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImage"]]], result)

    @builtins.property
    def circle_image(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImage"]]]:
        '''circle_image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#circle_image DataAkamaiImagingPolicyImage#circle_image}
        '''
        result = self._values.get("circle_image")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImage"]]], result)

    @builtins.property
    def text_image(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImage"]]]:
        '''text_image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text_image DataAkamaiImagingPolicyImage#text_image}
        '''
        result = self._values.get("text_image")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImage"]]], result)

    @builtins.property
    def url_image(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImage"]]]:
        '''url_image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url_image DataAkamaiImagingPolicyImage#url_image}
        '''
        result = self._values.get("url_image")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImage"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImage",
    jsii_struct_bases=[],
    name_mapping={
        "color": "color",
        "color_var": "colorVar",
        "height": "height",
        "height_var": "heightVar",
        "transformation": "transformation",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImage:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        transformation: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The fill color of the box, not the edge of the box. The API supports hexadecimal representation and CSS hexadecimal color values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The fill color of the box, not the edge of the box. The API supports hexadecimal representation and CSS hexadecimal color values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        :param height: The height of the box in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height of the box in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param transformation: transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        :param width: The width of the box in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width of the box in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(transformation, dict):
            transformation = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformation(**transformation)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8f77b64cdb950bd2afa85377b18a87464c0bc9068e94e6a6d1899c4f9d401039)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument transformation", value=transformation, expected_type=type_hints["transformation"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if transformation is not None:
            self._values["transformation"] = transformation
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The fill color of the box, not the edge of the box.

        The API supports hexadecimal representation and CSS hexadecimal color values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The fill color of the box, not the edge of the box.

        The API supports hexadecimal representation and CSS hexadecimal color values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height of the box in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height of the box in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def transformation(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformation"]:
        '''transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        '''
        result = self._values.get("transformation")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformation"], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width of the box in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width of the box in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__decc57ece0e7a5432f83856a2127a9fb5ab98d0cce93b0bcadd5888c00fda574)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__54f276a51b35c93f7f2ad3fff7affc66de34e60366841b24d48922c8e7216539)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cfd387d151d4efb58104e7e0b059c4456305e887eda96718f2734530f254d05e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d57a150c0c4bb4858d163c498830670f7e846d99e1ba2ff65ad19d00d618f757)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__998d6d4ad80374912244d6e7953fa89c7c817d97615c3fe244d92edb264aad88)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImage]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImage]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImage]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cb1e333d6ab73b6e75c67f1f1d1c120764594869762fc216fef2bbb681484bb1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b565ce474ee8c65a018a5906b6cf00c46560598cdffc5a779698000d5ae85640)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformation")
    def put_transformation(
        self,
        *,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationBackgroundColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationBlur", typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationChromaKey", typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationComposite", typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationCompound", typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationContrast", typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationGoop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationGrayscale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationHsl", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationHsv", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimension", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientation", typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationMaxColors", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationMirror", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationMonoHue", typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationOpacity", typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationRemoveColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationUnsharpMask", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformation(
            background_color=background_color,
            blur=blur,
            chroma_key=chroma_key,
            composite=composite,
            compound=compound,
            contrast=contrast,
            goop=goop,
            grayscale=grayscale,
            hsl=hsl,
            hsv=hsv,
            if_dimension=if_dimension,
            if_orientation=if_orientation,
            max_colors=max_colors,
            mirror=mirror,
            mono_hue=mono_hue,
            opacity=opacity,
            remove_color=remove_color,
            unsharp_mask=unsharp_mask,
        )

        return typing.cast(None, jsii.invoke(self, "putTransformation", [value]))

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetTransformation")
    def reset_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformation", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="transformation")
    def transformation(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationOutputReference", jsii.get(self, "transformation"))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="transformationInput")
    def transformation_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformation"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformation"], jsii.get(self, "transformationInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__049a51a4f10c77d3bde60286d57e403da2cfa353b50a5d8a290b62f310dc5ca5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__efdfd4418d8f79f417a02b96e1cb271e72607082c477f0a72dfa7811d9ba9c17)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__237b22f610f5502358224fd96a6d590c485b902c14822fb807dedcee4f720f34)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4fbf2c678791697d5431435eb2b4e7e52614c26458de165c3f268bbebe0957a7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3d4bf41906f893a7b26324e546f05b8348bacd2a6855b57edaf45c7a5ef16344)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9b53dc277019a12406bca00b913a4327ef0db9e42759632fac329a98c38d2e7f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImage]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImage]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImage]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__909caf71150ea14c668198fd3e8794be16629634f62748121bbec70b83fc4b09)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformation",
    jsii_struct_bases=[],
    name_mapping={
        "background_color": "backgroundColor",
        "blur": "blur",
        "chroma_key": "chromaKey",
        "composite": "composite",
        "compound": "compound",
        "contrast": "contrast",
        "goop": "goop",
        "grayscale": "grayscale",
        "hsl": "hsl",
        "hsv": "hsv",
        "if_dimension": "ifDimension",
        "if_orientation": "ifOrientation",
        "max_colors": "maxColors",
        "mirror": "mirror",
        "mono_hue": "monoHue",
        "opacity": "opacity",
        "remove_color": "removeColor",
        "unsharp_mask": "unsharpMask",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformation:
    def __init__(
        self,
        *,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationBackgroundColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationBlur", typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationChromaKey", typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationComposite", typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationCompound", typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationContrast", typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationGoop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationGrayscale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationHsl", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationHsv", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimension", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientation", typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationMaxColors", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationMirror", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationMonoHue", typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationOpacity", typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationRemoveColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationUnsharpMask", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a41e2d9f1b36900b603335110addc1fb8f74c03a3098f1495e539eadc77f46b)
            check_type(argname="argument background_color", value=background_color, expected_type=type_hints["background_color"])
            check_type(argname="argument blur", value=blur, expected_type=type_hints["blur"])
            check_type(argname="argument chroma_key", value=chroma_key, expected_type=type_hints["chroma_key"])
            check_type(argname="argument composite", value=composite, expected_type=type_hints["composite"])
            check_type(argname="argument compound", value=compound, expected_type=type_hints["compound"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument goop", value=goop, expected_type=type_hints["goop"])
            check_type(argname="argument grayscale", value=grayscale, expected_type=type_hints["grayscale"])
            check_type(argname="argument hsl", value=hsl, expected_type=type_hints["hsl"])
            check_type(argname="argument hsv", value=hsv, expected_type=type_hints["hsv"])
            check_type(argname="argument if_dimension", value=if_dimension, expected_type=type_hints["if_dimension"])
            check_type(argname="argument if_orientation", value=if_orientation, expected_type=type_hints["if_orientation"])
            check_type(argname="argument max_colors", value=max_colors, expected_type=type_hints["max_colors"])
            check_type(argname="argument mirror", value=mirror, expected_type=type_hints["mirror"])
            check_type(argname="argument mono_hue", value=mono_hue, expected_type=type_hints["mono_hue"])
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument remove_color", value=remove_color, expected_type=type_hints["remove_color"])
            check_type(argname="argument unsharp_mask", value=unsharp_mask, expected_type=type_hints["unsharp_mask"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if background_color is not None:
            self._values["background_color"] = background_color
        if blur is not None:
            self._values["blur"] = blur
        if chroma_key is not None:
            self._values["chroma_key"] = chroma_key
        if composite is not None:
            self._values["composite"] = composite
        if compound is not None:
            self._values["compound"] = compound
        if contrast is not None:
            self._values["contrast"] = contrast
        if goop is not None:
            self._values["goop"] = goop
        if grayscale is not None:
            self._values["grayscale"] = grayscale
        if hsl is not None:
            self._values["hsl"] = hsl
        if hsv is not None:
            self._values["hsv"] = hsv
        if if_dimension is not None:
            self._values["if_dimension"] = if_dimension
        if if_orientation is not None:
            self._values["if_orientation"] = if_orientation
        if max_colors is not None:
            self._values["max_colors"] = max_colors
        if mirror is not None:
            self._values["mirror"] = mirror
        if mono_hue is not None:
            self._values["mono_hue"] = mono_hue
        if opacity is not None:
            self._values["opacity"] = opacity
        if remove_color is not None:
            self._values["remove_color"] = remove_color
        if unsharp_mask is not None:
            self._values["unsharp_mask"] = unsharp_mask

    @builtins.property
    def background_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationBackgroundColor"]]]:
        '''background_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        '''
        result = self._values.get("background_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationBackgroundColor"]]], result)

    @builtins.property
    def blur(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationBlur"]]]:
        '''blur block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        '''
        result = self._values.get("blur")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationBlur"]]], result)

    @builtins.property
    def chroma_key(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationChromaKey"]]]:
        '''chroma_key block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        '''
        result = self._values.get("chroma_key")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationChromaKey"]]], result)

    @builtins.property
    def composite(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationComposite"]]]:
        '''composite block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        '''
        result = self._values.get("composite")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationComposite"]]], result)

    @builtins.property
    def compound(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationCompound"]]]:
        '''compound block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        '''
        result = self._values.get("compound")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationCompound"]]], result)

    @builtins.property
    def contrast(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationContrast"]]]:
        '''contrast block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationContrast"]]], result)

    @builtins.property
    def goop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationGoop"]]]:
        '''goop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        '''
        result = self._values.get("goop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationGoop"]]], result)

    @builtins.property
    def grayscale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationGrayscale"]]]:
        '''grayscale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        '''
        result = self._values.get("grayscale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationGrayscale"]]], result)

    @builtins.property
    def hsl(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationHsl"]]]:
        '''hsl block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        '''
        result = self._values.get("hsl")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationHsl"]]], result)

    @builtins.property
    def hsv(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationHsv"]]]:
        '''hsv block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        '''
        result = self._values.get("hsv")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationHsv"]]], result)

    @builtins.property
    def if_dimension(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimension"]]]:
        '''if_dimension block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        '''
        result = self._values.get("if_dimension")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimension"]]], result)

    @builtins.property
    def if_orientation(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientation"]]]:
        '''if_orientation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        '''
        result = self._values.get("if_orientation")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientation"]]], result)

    @builtins.property
    def max_colors(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationMaxColors"]]]:
        '''max_colors block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        '''
        result = self._values.get("max_colors")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationMaxColors"]]], result)

    @builtins.property
    def mirror(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationMirror"]]]:
        '''mirror block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        '''
        result = self._values.get("mirror")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationMirror"]]], result)

    @builtins.property
    def mono_hue(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationMonoHue"]]]:
        '''mono_hue block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        '''
        result = self._values.get("mono_hue")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationMonoHue"]]], result)

    @builtins.property
    def opacity(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationOpacity"]]]:
        '''opacity block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationOpacity"]]], result)

    @builtins.property
    def remove_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationRemoveColor"]]]:
        '''remove_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        '''
        result = self._values.get("remove_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationRemoveColor"]]], result)

    @builtins.property
    def unsharp_mask(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationUnsharpMask"]]]:
        '''unsharp_mask block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        result = self._values.get("unsharp_mask")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationUnsharpMask"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationBackgroundColor",
    jsii_struct_bases=[],
    name_mapping={"color": "color", "color_var": "colorVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationBackgroundColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c7516b84ad9fbf9cb80181286ebf6d3e2308382de0193ba902fd570196a5d895)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationBackgroundColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationBackgroundColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationBackgroundColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__07126573444fd935b00c07e59174860a26e7dd487c006f52a5938f915bac90ce)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationBackgroundColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4f032ef2ec537a4f82ce8b951f58a98d351514e24d5e1547fee056bad6ebc1ed)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationBackgroundColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2e9d063b19845c2466f2d12d6c0e5a10aaa7e394f38b2e8760a9f94e1195c708)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5eddaed39bc85e60f57e155623977ffc75b0f9f74640598d7da3c8c7c9433c79)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c6a9433231242d549a81ef3bad8a1a671ed63cbe26e699e7bf6ea2bd967a19a9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationBackgroundColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationBackgroundColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a51a1979c3eee534685168abad5f1c30ca4287bfbcc7838274bd4293bd9f214)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationBackgroundColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationBackgroundColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ceec05b3806a1b4f8b76cdd9f6cecc8f1ffd4e19304320ae83a3cde282a8b06)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a826a28fcaf9ff2969595096f2470a0fb98fa838ff7b1e686d3b61e14fc22f45)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f5ca294505f3c6d23518b391a523fcbf3e43b524a0c9bbaa02f7c9c8696ec565)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationBackgroundColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationBackgroundColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationBackgroundColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__19905e439b4b130735ae7fcc9f8132c9896653fa737629199f82c4b9ba4c6b48)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationBlur",
    jsii_struct_bases=[],
    name_mapping={"sigma": "sigma", "sigma_var": "sigmaVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationBlur:
    def __init__(
        self,
        *,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param sigma: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__024fbe2c4d6c3e20e049e0126adba8a3f6a39abcde9e074380cc99a7acdfb355)
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationBlur(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationBlurList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationBlurList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c47f03ac290112c6e1490c3780e3869b315009a2b3a17e954288c0953cecc33d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationBlurOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c29e69359157c54e067979faf0475e28aad1de70cacbbd0e66f432095ab157ec)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationBlurOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__576aa4acb89ccf2e6f83ae3249de07de35b5b040db06c77b327e5e5ccaf97999)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__572e85357b6d0b0bbeff58a5d08546d3e4fcea863277e64f7b71cb62dfbde787)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8bd8aefafe020a58150534b88f7bf3093a1cfb3670206db05f3929fdcc39040f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationBlur]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationBlur]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__45f86b458cc009962efd80555bc489fbc9ba9cf680a36443d76381ca389a3112)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationBlurOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationBlurOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ee7113d62f887e1005fa0715dde3b5a863ac150497f8b4527215807d5e95b6bc)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5b5e2a5b1abec87b3519a0f9ef1e1b63b946278eb1401c6a2df2424f9514cfd0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0a93986fd5d2f52317a7258887e5fb42b1793b9b2eae298debd2e2662439ba9e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationBlur]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationBlur]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationBlur]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c7bd87d9a5cb5e647d353db5fa5c183f414a62e0368a4ccbda40e2d986001dc8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationChromaKey",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_feather": "hueFeather",
        "hue_feather_var": "hueFeatherVar",
        "hue_tolerance": "hueTolerance",
        "hue_tolerance_var": "hueToleranceVar",
        "hue_var": "hueVar",
        "lightness_feather": "lightnessFeather",
        "lightness_feather_var": "lightnessFeatherVar",
        "lightness_tolerance": "lightnessTolerance",
        "lightness_tolerance_var": "lightnessToleranceVar",
        "saturation_feather": "saturationFeather",
        "saturation_feather_var": "saturationFeatherVar",
        "saturation_tolerance": "saturationTolerance",
        "saturation_tolerance_var": "saturationToleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationChromaKey:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_feather: typing.Optional[builtins.str] = None,
        hue_feather_var: typing.Optional[builtins.str] = None,
        hue_tolerance: typing.Optional[builtins.str] = None,
        hue_tolerance_var: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness_feather: typing.Optional[builtins.str] = None,
        lightness_feather_var: typing.Optional[builtins.str] = None,
        lightness_tolerance: typing.Optional[builtins.str] = None,
        lightness_tolerance_var: typing.Optional[builtins.str] = None,
        saturation_feather: typing.Optional[builtins.str] = None,
        saturation_feather_var: typing.Optional[builtins.str] = None,
        saturation_tolerance: typing.Optional[builtins.str] = None,
        saturation_tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_feather: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        :param hue_feather_var: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        :param hue_tolerance: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        :param hue_tolerance_var: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        :param hue_var: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness_feather: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        :param lightness_feather_var: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        :param lightness_tolerance: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        :param lightness_tolerance_var: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        :param saturation_feather: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        :param saturation_feather_var: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        :param saturation_tolerance: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        :param saturation_tolerance_var: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a85341ea1d18901d387bdae8478a8072ab8a1a7a5f8e3428fc61767f97415621)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_feather", value=hue_feather, expected_type=type_hints["hue_feather"])
            check_type(argname="argument hue_feather_var", value=hue_feather_var, expected_type=type_hints["hue_feather_var"])
            check_type(argname="argument hue_tolerance", value=hue_tolerance, expected_type=type_hints["hue_tolerance"])
            check_type(argname="argument hue_tolerance_var", value=hue_tolerance_var, expected_type=type_hints["hue_tolerance_var"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness_feather", value=lightness_feather, expected_type=type_hints["lightness_feather"])
            check_type(argname="argument lightness_feather_var", value=lightness_feather_var, expected_type=type_hints["lightness_feather_var"])
            check_type(argname="argument lightness_tolerance", value=lightness_tolerance, expected_type=type_hints["lightness_tolerance"])
            check_type(argname="argument lightness_tolerance_var", value=lightness_tolerance_var, expected_type=type_hints["lightness_tolerance_var"])
            check_type(argname="argument saturation_feather", value=saturation_feather, expected_type=type_hints["saturation_feather"])
            check_type(argname="argument saturation_feather_var", value=saturation_feather_var, expected_type=type_hints["saturation_feather_var"])
            check_type(argname="argument saturation_tolerance", value=saturation_tolerance, expected_type=type_hints["saturation_tolerance"])
            check_type(argname="argument saturation_tolerance_var", value=saturation_tolerance_var, expected_type=type_hints["saturation_tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_feather is not None:
            self._values["hue_feather"] = hue_feather
        if hue_feather_var is not None:
            self._values["hue_feather_var"] = hue_feather_var
        if hue_tolerance is not None:
            self._values["hue_tolerance"] = hue_tolerance
        if hue_tolerance_var is not None:
            self._values["hue_tolerance_var"] = hue_tolerance_var
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness_feather is not None:
            self._values["lightness_feather"] = lightness_feather
        if lightness_feather_var is not None:
            self._values["lightness_feather_var"] = lightness_feather_var
        if lightness_tolerance is not None:
            self._values["lightness_tolerance"] = lightness_tolerance
        if lightness_tolerance_var is not None:
            self._values["lightness_tolerance_var"] = lightness_tolerance_var
        if saturation_feather is not None:
            self._values["saturation_feather"] = saturation_feather
        if saturation_feather_var is not None:
            self._values["saturation_feather_var"] = saturation_feather_var
        if saturation_tolerance is not None:
            self._values["saturation_tolerance"] = saturation_tolerance
        if saturation_tolerance_var is not None:
            self._values["saturation_tolerance_var"] = saturation_tolerance_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        '''
        result = self._values.get("hue_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        '''
        result = self._values.get("hue_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        '''
        result = self._values.get("hue_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        '''
        result = self._values.get("hue_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        '''
        result = self._values.get("lightness_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        '''
        result = self._values.get("lightness_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        '''
        result = self._values.get("lightness_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        '''
        result = self._values.get("lightness_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        '''
        result = self._values.get("saturation_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        '''
        result = self._values.get("saturation_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        '''
        result = self._values.get("saturation_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        result = self._values.get("saturation_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationChromaKey(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationChromaKeyList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationChromaKeyList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bde985197598c6f8770149787e988447f73f69c2782d3f788203f8c370d875a4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationChromaKeyOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cdc0d0144b72c3378229c71ea410705e8e2d74999ce74a296e2b8685df961d37)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationChromaKeyOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__559b569bf07a57064c9255ca58822b3a6d35ab44867e22d0a28bc0f91de0134a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a7ffa7149aa8eabd2013b57f4515ff496f6dd61b1df6fc6989e17a0b429c10a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__01dbb2352eab63bb83dc5594d58d3a0b85a6e93a1cca8e81cbb5b1d65c277929)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationChromaKey]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationChromaKey]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b3c9dd70aa8b2fc5c98def03b574fa1194fca5e002c6719097a47bcf6f99dca8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationChromaKeyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationChromaKeyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fea18893142bc9b983ccaca2927e24f15f6e2b82eb4703bf90e430f7634494e6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueFeather")
    def reset_hue_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeather", []))

    @jsii.member(jsii_name="resetHueFeatherVar")
    def reset_hue_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeatherVar", []))

    @jsii.member(jsii_name="resetHueTolerance")
    def reset_hue_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueTolerance", []))

    @jsii.member(jsii_name="resetHueToleranceVar")
    def reset_hue_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueToleranceVar", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightnessFeather")
    def reset_lightness_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeather", []))

    @jsii.member(jsii_name="resetLightnessFeatherVar")
    def reset_lightness_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeatherVar", []))

    @jsii.member(jsii_name="resetLightnessTolerance")
    def reset_lightness_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessTolerance", []))

    @jsii.member(jsii_name="resetLightnessToleranceVar")
    def reset_lightness_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessToleranceVar", []))

    @jsii.member(jsii_name="resetSaturationFeather")
    def reset_saturation_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeather", []))

    @jsii.member(jsii_name="resetSaturationFeatherVar")
    def reset_saturation_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeatherVar", []))

    @jsii.member(jsii_name="resetSaturationTolerance")
    def reset_saturation_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationTolerance", []))

    @jsii.member(jsii_name="resetSaturationToleranceVar")
    def reset_saturation_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherInput")
    def hue_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVarInput")
    def hue_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceInput")
    def hue_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVarInput")
    def hue_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherInput")
    def lightness_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVarInput")
    def lightness_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceInput")
    def lightness_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVarInput")
    def lightness_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherInput")
    def saturation_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVarInput")
    def saturation_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceInput")
    def saturation_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVarInput")
    def saturation_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eea83ec26b26df793220d25f27376cf58d6e5e4232d44294eb08a50abf3b70c2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeather")
    def hue_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeather"))

    @hue_feather.setter
    def hue_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__28993c749f9cd50da969b54ece8854183977e82280e67c375801e0ad4e183553)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeather", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVar")
    def hue_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeatherVar"))

    @hue_feather_var.setter
    def hue_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4605c71bcb1f9b0cbf34e71a3e82bc60c9a81fb71216840a2d2f853972b2971d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueTolerance")
    def hue_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueTolerance"))

    @hue_tolerance.setter
    def hue_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3fe9ac067d13c6576f60288a7594a38ba76da4f3182706a3a866f5818397d739)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVar")
    def hue_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueToleranceVar"))

    @hue_tolerance_var.setter
    def hue_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__36399603787a6f9b000a8b3dfa20312539ae5a5aaa4aab5f29decccc02fd3bea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__afd5a0284ab4eb43f9627d159335d8d7debdd2901d5e0494271df7861ae2b092)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeather")
    def lightness_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeather"))

    @lightness_feather.setter
    def lightness_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__189764658ab39ff92970f5dbc30cae305149275074e057da135087a2d8a5b342)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeather", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVar")
    def lightness_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeatherVar"))

    @lightness_feather_var.setter
    def lightness_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d33d27cf9909f28ab3fe888032a8d657e77dae7da27f7b9be14bcfcd631d8bc4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessTolerance")
    def lightness_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessTolerance"))

    @lightness_tolerance.setter
    def lightness_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__da5c272ed13e23f49fb80c3b96c4530e86e836f21634a4689e9ce78ff16b1fd9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVar")
    def lightness_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessToleranceVar"))

    @lightness_tolerance_var.setter
    def lightness_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__75c55ef6a9ca244551bee066762aee8a64fa8713117d1dc1ae864625468cec7d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeather")
    def saturation_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeather"))

    @saturation_feather.setter
    def saturation_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6a4874e253ef323ea853562f4450b8f190d02a5f22d77e4e6007c0e5d3cbf6d7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeather", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVar")
    def saturation_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeatherVar"))

    @saturation_feather_var.setter
    def saturation_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1af15c392bb9731af476f686871e421601fa2f82efb557d7f18c6e84704ae960)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationTolerance")
    def saturation_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationTolerance"))

    @saturation_tolerance.setter
    def saturation_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c8345cf48240aaabc47a1bf1a780fe9a961e9fc5043a799597f62be7866a3fa7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVar")
    def saturation_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationToleranceVar"))

    @saturation_tolerance_var.setter
    def saturation_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d9461cdbea7b9939f3e2bc1f0ad5c31f24194d33b68946d59e2e6afddd5cc29b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationChromaKey]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationChromaKey]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationChromaKey]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5b409a66f631b9c03ed5f139b294f00e4cd709ec5708080e59d452cfff494d13)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationComposite",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "placement": "placement",
        "placement_var": "placementVar",
        "scale": "scale",
        "scale_dimension": "scaleDimension",
        "scale_dimension_var": "scaleDimensionVar",
        "scale_var": "scaleVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationComposite:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationCompositeImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        placement: typing.Optional[builtins.str] = None,
        placement_var: typing.Optional[builtins.str] = None,
        scale: typing.Optional[builtins.str] = None,
        scale_dimension: typing.Optional[builtins.str] = None,
        scale_dimension_var: typing.Optional[builtins.str] = None,
        scale_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param placement: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        :param placement_var: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        :param scale: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param scale_dimension: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        :param scale_dimension_var: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        :param scale_var: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        :param x_position: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationCompositeImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eb4a6420c0fb3ed08140a1c2544ebef75dece6ee271d6ab45f84a6b72504b5e3)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument placement", value=placement, expected_type=type_hints["placement"])
            check_type(argname="argument placement_var", value=placement_var, expected_type=type_hints["placement_var"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument scale_dimension", value=scale_dimension, expected_type=type_hints["scale_dimension"])
            check_type(argname="argument scale_dimension_var", value=scale_dimension_var, expected_type=type_hints["scale_dimension_var"])
            check_type(argname="argument scale_var", value=scale_var, expected_type=type_hints["scale_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if placement is not None:
            self._values["placement"] = placement
        if placement_var is not None:
            self._values["placement_var"] = placement_var
        if scale is not None:
            self._values["scale"] = scale
        if scale_dimension is not None:
            self._values["scale_dimension"] = scale_dimension
        if scale_dimension_var is not None:
            self._values["scale_dimension_var"] = scale_dimension_var
        if scale_var is not None:
            self._values["scale_var"] = scale_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationCompositeImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationCompositeImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        '''
        result = self._values.get("placement")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement_var(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        '''
        result = self._values.get("placement_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        '''
        result = self._values.get("scale_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        '''
        result = self._values.get("scale_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        '''
        result = self._values.get("scale_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationComposite(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationCompositeImage",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationCompositeImage:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationCompositeImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationCompositeImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationCompositeImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f7dca4e664c383b68ddf57f7042c65c94382a55ace4b32878b605b7329fee19)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationCompositeImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationCompositeImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0e4fb25109de7847c6afcc0f7784a76b50185264f93c26ad0adfd9ebe4a8bcf8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationCompositeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationCompositeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f7e1c6633aa79c4a9598a2eddfd0ed8eb0e13ae75047eb76fadb3a2002700f1b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationCompositeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3d66d08b0ffdd84348716f668c76cca9d7d00ccba80446b537674c0bd9209d8c)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationCompositeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__089977f2cd7d9baf4eb8cac41619cf1146708f31dd38027ba0ddc49c35cda30e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ebf1f9a172400f4ae966eae06c5d3696ff81409c6fa5fec317025a353a18405)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0cb0d65112ff278c914f868e5ce7282b58e600a04a54415960b1bed3959873f6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationComposite]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationComposite]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bbca7cb78668911cf2cd62134449e4a3c6c7364812cd2fcfdb4e85ff115c2e52)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationCompositeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationCompositeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1bc9b590d9464d0d4e05df34e02bab2848ececd9ad36acb0a1af4e0a9525a08e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationCompositeImage()

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPlacement")
    def reset_placement(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacement", []))

    @jsii.member(jsii_name="resetPlacementVar")
    def reset_placement_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacementVar", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetScaleDimension")
    def reset_scale_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimension", []))

    @jsii.member(jsii_name="resetScaleDimensionVar")
    def reset_scale_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimensionVar", []))

    @jsii.member(jsii_name="resetScaleVar")
    def reset_scale_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationCompositeImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationCompositeImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationCompositeImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="placementInput")
    def placement_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementInput"))

    @builtins.property
    @jsii.member(jsii_name="placementVarInput")
    def placement_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionInput")
    def scale_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVarInput")
    def scale_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleVarInput")
    def scale_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ed4726df97d32a5fe7cf55115015a91012a6977f433c15b16bd66fc344b1f259)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__09aab185a9cb98e2fc45e12c1452aac40d7d94d2d4dacb949d767a84d9a5e15b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="placement")
    def placement(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placement"))

    @placement.setter
    def placement(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3fab3f7a9fb014fcd6fdb98f348db2b250417ec39e028088722eb87491143293)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placement", value)

    @builtins.property
    @jsii.member(jsii_name="placementVar")
    def placement_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placementVar"))

    @placement_var.setter
    def placement_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8bec1eff093e8a3444e1100bf892593bf084e8fbbdd308d53ecc15aa7320288f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placementVar", value)

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scale"))

    @scale.setter
    def scale(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a9ee97765287d67b86433c80c7daea77ae59e421a29cf92a536f744b430d2ac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scale", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimension")
    def scale_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimension"))

    @scale_dimension.setter
    def scale_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c94d23daceab03db0323f5ecff4d38de188f52f2db180697834b2b42d48e149b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimension", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVar")
    def scale_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimensionVar"))

    @scale_dimension_var.setter
    def scale_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__01232143b94a474a467597c867929b7e33d98c47c8bcd6b84dde65d43f9bd3b7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="scaleVar")
    def scale_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleVar"))

    @scale_var.setter
    def scale_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6140c12e4fbc571b3c10f9a4cfed92ddc06768cf58cfe69c222e978444642fe4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0a1ed7236dc5231d458fcdaf65c0b2c15600ec02ad26117405d621771f78c56d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__59a910d67f675710013c23ae6a6bf0e3aba3eaf50ddb2323c99bb35ba48eb706)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3fb452070e2892ff9a862c26ae351f17d1b24b61c9ea53512f4f4ea623219c04)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7bd9f852cf122f2bbab845cbf25feea86924d6dee99fcc767a7265d39e741456)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationComposite]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationComposite]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationComposite]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a1299b0eedcedea304994cbc89e2fa94570f6f57c6b1e1468cdacd8ba03871b1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationCompound",
    jsii_struct_bases=[],
    name_mapping={"transformations": "transformations"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationCompound:
    def __init__(
        self,
        *,
        transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param transformations: transformations block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aa34a01ad5d40ad511d82e0b0372d1b99c3f5f0071c0f2a85678c3565736ed23)
            check_type(argname="argument transformations", value=transformations, expected_type=type_hints["transformations"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if transformations is not None:
            self._values["transformations"] = transformations

    @builtins.property
    def transformations(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationCompoundTransformations"]]]:
        '''transformations block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        result = self._values.get("transformations")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationCompoundTransformations"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationCompound(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationCompoundList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationCompoundList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0d7b122f2f54b030f4758525b552ccb320d587befd16117e7c8e425636b0a5e0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationCompoundOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7a75edb2cc2f32eafa8c90356470de279b25d70d16d1b690c0ff403f26929fef)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationCompoundOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3b2e2ee12ceaccf65c396591589f1c6596a740e4aa174d520e4961c3265132c4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d601e72dcd7ee6e59b343a82cbb195ec1381a1ff8a521af02c24d69d918653e0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__603c3bb4c90197d638866f640990da70464f549cdc758317c2afe903a9cd758e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationCompound]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationCompound]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b9787e9e71fd71130c7066cb4b9d4754bbd2d2739ac80e26a75b6d4b13b1e4d2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationCompoundOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationCompoundOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3c6cd10848741c9e932530fd9bc15ac205c3e3afaab3af03c12adb895f463f41)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformations")
    def put_transformations(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd3c7e521196f3f61368a3017395876d513458746f2f97c4dd80488ca63f12bf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTransformations", [value]))

    @jsii.member(jsii_name="resetTransformations")
    def reset_transformations(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformations", []))

    @builtins.property
    @jsii.member(jsii_name="transformations")
    def transformations(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationCompoundTransformationsList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationCompoundTransformationsList", jsii.get(self, "transformations"))

    @builtins.property
    @jsii.member(jsii_name="transformationsInput")
    def transformations_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationCompoundTransformations"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationCompoundTransformations"]]], jsii.get(self, "transformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationCompound]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationCompound]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationCompound]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8da5d89591da112973a042e5e6bd11c0baf2f7ce1e2dc260383d3e58bacf86be)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationCompoundTransformations",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationCompoundTransformations:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationCompoundTransformations(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationCompoundTransformationsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationCompoundTransformationsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__48b4694cf1cf1bd0bfae5fc8f9cbcc4085b30d133f7ba41c76543add3dc28184)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationCompoundTransformationsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7e53fdebba95ed04e354bcf6f23b23502c0f15bb8a6b224b340320bc804feebd)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationCompoundTransformationsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bad2ec70abed85e0a1f8b282a7f05e95c323ac7722a94ffbd0c1140da7a8a8cb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__64beff1b7191de3b04af7134fc24db931a35c992dd6a2c08eba408f03cd8b202)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dc7881ae0001918ad6b66e559c56fa66cf0a2d429dc11be6092e096c914bfe85)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationCompoundTransformations]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationCompoundTransformations]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationCompoundTransformations]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ad3d7982988fb8106f63e03754497915a61a78f9b587e197bc3df7a1a99878c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationCompoundTransformationsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationCompoundTransformationsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e444d22bc18e70c42a8ab58f8aa6a501bed2a1b7b8ebe0df48561f84a88d3d75)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationCompoundTransformations]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationCompoundTransformations]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationCompoundTransformations]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8461a5cdb7ba1f3b3cf24d455d5bcb3f1f06bb6b65e174528b1e6df68a30e8bd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationContrast",
    jsii_struct_bases=[],
    name_mapping={
        "brightness": "brightness",
        "brightness_var": "brightnessVar",
        "contrast": "contrast",
        "contrast_var": "contrastVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationContrast:
    def __init__(
        self,
        *,
        brightness: typing.Optional[builtins.str] = None,
        brightness_var: typing.Optional[builtins.str] = None,
        contrast: typing.Optional[builtins.str] = None,
        contrast_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param brightness: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        :param brightness_var: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        :param contrast: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param contrast_var: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0f4f8155cdc3f7e7d50e414e7b3fcfa8fa8d48d29867f2c3042c620358891f19)
            check_type(argname="argument brightness", value=brightness, expected_type=type_hints["brightness"])
            check_type(argname="argument brightness_var", value=brightness_var, expected_type=type_hints["brightness_var"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument contrast_var", value=contrast_var, expected_type=type_hints["contrast_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if brightness is not None:
            self._values["brightness"] = brightness
        if brightness_var is not None:
            self._values["brightness_var"] = brightness_var
        if contrast is not None:
            self._values["contrast"] = contrast
        if contrast_var is not None:
            self._values["contrast_var"] = contrast_var

    @builtins.property
    def brightness(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        '''
        result = self._values.get("brightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def brightness_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        '''
        result = self._values.get("brightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        result = self._values.get("contrast_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationContrast(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationContrastList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationContrastList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__212e65c82f9758940b2e25aad8c6ec861be81a51e3a5c4108cee1d877200befa)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationContrastOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7b3c6bc76140d9b7c9ea49b65b828dfeea8742c3180c8fa07b060172271eba9f)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationContrastOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f1a5b20af2524c1db4610214496f3f90a27a9c12a70677ca5999c60dd3ac77d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c634cc7a29f08156523177cb5eacf78aaea313ba6ae56b686d53df52cf1d0b9b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2c5eea8add26bf3b84a170c8d3103c3c4ff35ec100f7f81d257d0989206b6ce1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationContrast]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationContrast]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ebce33f5281baded9210681e59356261c5eb03ba57b0606a020d9b74cf2b9c1d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationContrastOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationContrastOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__112ddc6732cfd27e22e10ac6154f556ab9dda5eedea11c32776a4a9c00fa391f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetBrightness")
    def reset_brightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightness", []))

    @jsii.member(jsii_name="resetBrightnessVar")
    def reset_brightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightnessVar", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetContrastVar")
    def reset_contrast_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrastVar", []))

    @builtins.property
    @jsii.member(jsii_name="brightnessInput")
    def brightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="brightnessVarInput")
    def brightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastVarInput")
    def contrast_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="brightness")
    def brightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightness"))

    @brightness.setter
    def brightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7ada9ac6df45eb0561ce6ca429c4c5a582923a17ea8c01c6abc6fc7e641280f2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightness", value)

    @builtins.property
    @jsii.member(jsii_name="brightnessVar")
    def brightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightnessVar"))

    @brightness_var.setter
    def brightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__35cbaea641f1142d8e24b485fe47dc752d16358d1d05a5124d9d9ebc2bae1b92)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrast"))

    @contrast.setter
    def contrast(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ca6aa835a968ba79ad8bba5bcc874676473cb83be408c1d21d1f4478c4f044c3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrast", value)

    @builtins.property
    @jsii.member(jsii_name="contrastVar")
    def contrast_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrastVar"))

    @contrast_var.setter
    def contrast_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d2a7c0eca18225d26ce6caf90e1e74973ac4fc76a6a0455845513bee886f1c66)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrastVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationContrast]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationContrast]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationContrast]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__44387a456769275e366206bf4f7056838cae609e63954e8aa05543dcaff95598)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationGoop",
    jsii_struct_bases=[],
    name_mapping={
        "chaos": "chaos",
        "chaos_var": "chaosVar",
        "density": "density",
        "density_var": "densityVar",
        "power": "power",
        "power_var": "powerVar",
        "seed": "seed",
        "seed_var": "seedVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationGoop:
    def __init__(
        self,
        *,
        chaos: typing.Optional[builtins.str] = None,
        chaos_var: typing.Optional[builtins.str] = None,
        density: typing.Optional[builtins.str] = None,
        density_var: typing.Optional[builtins.str] = None,
        power: typing.Optional[builtins.str] = None,
        power_var: typing.Optional[builtins.str] = None,
        seed: typing.Optional[builtins.str] = None,
        seed_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param chaos: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        :param chaos_var: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        :param density: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        :param density_var: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        :param power: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        :param power_var: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        :param seed: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        :param seed_var: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4bcf82039a11e9616dcc50398574e2dd01d8535e0f6f871d767db1f479521f07)
            check_type(argname="argument chaos", value=chaos, expected_type=type_hints["chaos"])
            check_type(argname="argument chaos_var", value=chaos_var, expected_type=type_hints["chaos_var"])
            check_type(argname="argument density", value=density, expected_type=type_hints["density"])
            check_type(argname="argument density_var", value=density_var, expected_type=type_hints["density_var"])
            check_type(argname="argument power", value=power, expected_type=type_hints["power"])
            check_type(argname="argument power_var", value=power_var, expected_type=type_hints["power_var"])
            check_type(argname="argument seed", value=seed, expected_type=type_hints["seed"])
            check_type(argname="argument seed_var", value=seed_var, expected_type=type_hints["seed_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if chaos is not None:
            self._values["chaos"] = chaos
        if chaos_var is not None:
            self._values["chaos_var"] = chaos_var
        if density is not None:
            self._values["density"] = density
        if density_var is not None:
            self._values["density_var"] = density_var
        if power is not None:
            self._values["power"] = power
        if power_var is not None:
            self._values["power_var"] = power_var
        if seed is not None:
            self._values["seed"] = seed
        if seed_var is not None:
            self._values["seed_var"] = seed_var

    @builtins.property
    def chaos(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        '''
        result = self._values.get("chaos")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def chaos_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        '''
        result = self._values.get("chaos_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        '''
        result = self._values.get("density")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density_var(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        '''
        result = self._values.get("density_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        '''
        result = self._values.get("power")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power_var(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        '''
        result = self._values.get("power_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        '''
        result = self._values.get("seed")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed_var(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        result = self._values.get("seed_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationGoop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationGoopList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationGoopList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__547bd95b62134c163d7c5205f656c6a0f5a33d3b089c477d8cdc08d24178dce1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationGoopOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ffa73fcdb818126459441395b873ea63da104d02fd31928ab94df1d08ee49cb9)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationGoopOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__011983243b8586ed222ec7dcecd6f54b67616ec005bdbca44f2ef8965d01f329)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d805bc996d868e8b67fca15001c9b78da5a9633d632ea69305b65603aec128fe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f14d5cc7fc5c8f85c1730b046810387f0aed394d892d01f9d52a2e7ab54c6d73)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationGoop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationGoop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cfc63797d17ba9d6465be606875425bd43ec976f857512cbe884dc9569a35457)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationGoopOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationGoopOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f8ca2e09bf03df76f3b2d4f7c76f8a6228240a36681d915243d9962c6c6ebd9b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetChaos")
    def reset_chaos(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaos", []))

    @jsii.member(jsii_name="resetChaosVar")
    def reset_chaos_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaosVar", []))

    @jsii.member(jsii_name="resetDensity")
    def reset_density(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensity", []))

    @jsii.member(jsii_name="resetDensityVar")
    def reset_density_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensityVar", []))

    @jsii.member(jsii_name="resetPower")
    def reset_power(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPower", []))

    @jsii.member(jsii_name="resetPowerVar")
    def reset_power_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPowerVar", []))

    @jsii.member(jsii_name="resetSeed")
    def reset_seed(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeed", []))

    @jsii.member(jsii_name="resetSeedVar")
    def reset_seed_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeedVar", []))

    @builtins.property
    @jsii.member(jsii_name="chaosInput")
    def chaos_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosInput"))

    @builtins.property
    @jsii.member(jsii_name="chaosVarInput")
    def chaos_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosVarInput"))

    @builtins.property
    @jsii.member(jsii_name="densityInput")
    def density_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityInput"))

    @builtins.property
    @jsii.member(jsii_name="densityVarInput")
    def density_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="powerInput")
    def power_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerInput"))

    @builtins.property
    @jsii.member(jsii_name="powerVarInput")
    def power_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerVarInput"))

    @builtins.property
    @jsii.member(jsii_name="seedInput")
    def seed_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedInput"))

    @builtins.property
    @jsii.member(jsii_name="seedVarInput")
    def seed_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedVarInput"))

    @builtins.property
    @jsii.member(jsii_name="chaos")
    def chaos(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaos"))

    @chaos.setter
    def chaos(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ce94c68c156a9be25ef0ca3e375728a87f5c982e4030f12d7f5c72cb06c3e56e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaos", value)

    @builtins.property
    @jsii.member(jsii_name="chaosVar")
    def chaos_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaosVar"))

    @chaos_var.setter
    def chaos_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__970936bd35dbd39dc5e625a8bedcce864ba4a05bbe77e10c68b3ed23bc494496)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaosVar", value)

    @builtins.property
    @jsii.member(jsii_name="density")
    def density(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "density"))

    @density.setter
    def density(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__87beca86071bb5f157b5acd8df89bd0e51084c646faed24b2b61a1f6db28cd39)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "density", value)

    @builtins.property
    @jsii.member(jsii_name="densityVar")
    def density_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "densityVar"))

    @density_var.setter
    def density_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e6df81f47bc69b84490650439935e747bae194189c8f5ceecc4ea6a95b1c9ed5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "densityVar", value)

    @builtins.property
    @jsii.member(jsii_name="power")
    def power(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "power"))

    @power.setter
    def power(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__78ebf68855ce5f78b4fdafd232de39b1e1a3ff32a3066f1664ad29b128971c62)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "power", value)

    @builtins.property
    @jsii.member(jsii_name="powerVar")
    def power_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "powerVar"))

    @power_var.setter
    def power_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1ecad76c4ce00840d70fb82cd8fba067d23938282f9d901db7a2b82f7a482394)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "powerVar", value)

    @builtins.property
    @jsii.member(jsii_name="seed")
    def seed(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seed"))

    @seed.setter
    def seed(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fb1d1b346d8fffd769618b0bec62907f92118099f485e6527497ec2093b8a1be)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seed", value)

    @builtins.property
    @jsii.member(jsii_name="seedVar")
    def seed_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seedVar"))

    @seed_var.setter
    def seed_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__332c8dce216c8712000cec2ccfca5a491ea7a6d2d2ebe0d381b063affa21b453)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seedVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationGoop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationGoop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationGoop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__587f5e107856bd2658d6bcde6136eb522ca7b8f1b58f6314c062204bf4b4ad33)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationGrayscale",
    jsii_struct_bases=[],
    name_mapping={"type": "type", "type_var": "typeVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationGrayscale:
    def __init__(
        self,
        *,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param type: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c1be3c29686b2cf64b942e31a63b3c4b55e261dc15d877dc11c325cf62586bbe)
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationGrayscale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationGrayscaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationGrayscaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d5eac30f69df4fb56dda059c5a2e9465b8c89d0ad87ae9a3f372d182151627f7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationGrayscaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__77dea154488001178f4549ffb3363973c9032f457045104229766136f065db97)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationGrayscaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f74c99790fc682849a7834020856bcce90e150b86faac038700e17ec03be716a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ce752a335f0034202c253960cce20954d2e5791720a5046cc41ac42ba49cf93)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bd01ef319760f8402793a787b04bb064592fb53492d3d6150ddef0bbb929b428)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationGrayscale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationGrayscale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d6b59470d27f53f8cab3678b3ed61d5944c436286ca1d9dc5e76f7fecc9da99d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationGrayscaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationGrayscaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aa227e22333527dcdd70f9983d5c8a82bb04f756ef94560a828fb0fc6446a5bc)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ffe1087a386d5d0a791eed45e29f1813fcccef158a1cacd2552473313ba6848f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a59caf3053e15a0211de37e590d80fad5fc4dcc88c1fd375088b058e44930e47)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationGrayscale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationGrayscale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationGrayscale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b1e6d2a0b78358dc4849f6a25f360074fef031666815582578bf0717831fb832)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationHsl",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "lightness": "lightness",
        "lightness_var": "lightnessVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationHsl:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness: typing.Optional[builtins.str] = None,
        lightness_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        :param lightness_var: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__80fd7db9b2e78fe100b974146056b49f0ff30369f544b2dfa3c2b3e9dad30709)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness", value=lightness, expected_type=type_hints["lightness"])
            check_type(argname="argument lightness_var", value=lightness_var, expected_type=type_hints["lightness_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness is not None:
            self._values["lightness"] = lightness
        if lightness_var is not None:
            self._values["lightness_var"] = lightness_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        '''
        result = self._values.get("lightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        '''
        result = self._values.get("lightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationHsl(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationHslList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationHslList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3d9a22791c37e5f3cfbd93ff351a6fa823e4a96eef85635fea35f0442f0ed8d4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationHslOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a52040d78270e90489a1d7be80cbd976b76705b9261c57f904bff19120e4727a)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationHslOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d30fd7ef122500473c0c6715e61a79566ca6356e8c7fe3139f64eb5cdfe1e5e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a49307b48c48aa37f466b6feb099ce0a5d520c6768517c2f96b1ea5c02e333f5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cc15d3af838617b8f068de0aa04f903411972eb43a1b0c98e9dbef4140e26d04)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationHsl]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationHsl]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__14d957580e61039a8001b7aa1668872949bafad57820cf9738e7663ae74db1e0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationHslOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationHslOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5db76bad99f31b6655058d11da8383602144dd0525cd4bf0335114d2b2452677)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightness")
    def reset_lightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightness", []))

    @jsii.member(jsii_name="resetLightnessVar")
    def reset_lightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessInput")
    def lightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessVarInput")
    def lightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bbd09e770458a941ae449ead5b2c6e7a0b52194ee963ebf7db3f3704b5afa586)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4eca61c1c389ecc3b96d47a0298a46b30dfdb468a727142f4cecf1365f16702b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightness")
    def lightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightness"))

    @lightness.setter
    def lightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__49c428c9bec9dfb7e7a6796de2fd075b5123f6e7458cd84b266c85f0c619e2fd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightness", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessVar")
    def lightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessVar"))

    @lightness_var.setter
    def lightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8ceff101dc0f95eb4cb2cf8d706bcd1b5906629bfc0ac922435227874bcc0b80)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bda90747219ad5cf7ad7c4f92624e6a55f2794123645cee9d8042f1d42f217d9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dab5829db86a11e1d460d548721def1a9720789420bfb521de1e4414cd299016)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationHsl]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationHsl]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationHsl]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__39e528a8f9a9adf50b88e01a914aac700515fb56fdc037f44beef95fd0bcb715)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationHsv",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationHsv:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        :param value: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__87a9f2a678049c6bd7a704c61490751454bce617a696a8c43180f564ec0b48e8)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationHsv(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationHsvList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationHsvList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1d6d025d27beb2846498f81af2655c223254e28c7abf007367dd2562fba553a0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationHsvOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ebeb109440b23e69c33e4261900ff3a08d32f33962445a2e746416f86962ef7)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationHsvOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4b1e80ed08b67aecb7744cf22af6cb66cc7af2e9c7f80b17e7ebb943768f6b33)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__19470275f412fa2e28d750da9343419c876608530a0869f9bb9505c436a660d4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3e8bb2329f2f04f077a18dbfc454170c327e1c025714dd9c4cb5a32e5323e3d8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationHsv]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationHsv]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2468c2cdebe2dda0788b2138bf049f06e26cde4c72ab98e8ef5937b7035e77bf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationHsvOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationHsvOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d591f42d1c1bd9398ab6aa654ab297a0fa56879944eec7ab398675ec94e2e16)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd99ca3675ca6b6e8e700478de3b171e796dc45952ff5208feb0e4be67db883f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5926ecbce4c93960399c0c46e09c33117b983969b5bce4c96f15de81918d8596)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5c81860c0919f16bbaeb541fe2d61b7c1cf3aaa31c2be0067c7ec0a30747fab3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6071b58fb38b66373895562029112d74052cd8d775e5190f73242e879eeca65f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__11b051a066cacfb50c43a260bdb548510b8c9bb9e674914d4874460dd151c7db)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__950a63b1bb20d684cb35db65f4676b88dc42e4ee7bb1a8ccdd4024b887c38c9b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationHsv]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationHsv]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationHsv]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ca6966a05e6cd203c3cf6a8d40c12ede047e80884e729d22c7889787690fb9ea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimension",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "dimension": "dimension",
        "dimension_var": "dimensionVar",
        "equal": "equal",
        "greater_than": "greaterThan",
        "less_than": "lessThan",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimension:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimensionDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        dimension: typing.Optional[builtins.str] = None,
        dimension_var: typing.Optional[builtins.str] = None,
        equal: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimensionEqual", typing.Dict[builtins.str, typing.Any]]] = None,
        greater_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimensionGreaterThan", typing.Dict[builtins.str, typing.Any]]] = None,
        less_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimensionLessThan", typing.Dict[builtins.str, typing.Any]]] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param dimension: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        :param dimension_var: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        :param equal: equal block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        :param greater_than: greater_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        :param less_than: less_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        :param value: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimensionDefault(**default)
        if isinstance(equal, dict):
            equal = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimensionEqual(**equal)
        if isinstance(greater_than, dict):
            greater_than = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimensionGreaterThan(**greater_than)
        if isinstance(less_than, dict):
            less_than = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimensionLessThan(**less_than)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__212df54b4be700cd3fe45156205efec0314be0ca57d21023953ad7720c898893)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument dimension", value=dimension, expected_type=type_hints["dimension"])
            check_type(argname="argument dimension_var", value=dimension_var, expected_type=type_hints["dimension_var"])
            check_type(argname="argument equal", value=equal, expected_type=type_hints["equal"])
            check_type(argname="argument greater_than", value=greater_than, expected_type=type_hints["greater_than"])
            check_type(argname="argument less_than", value=less_than, expected_type=type_hints["less_than"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if dimension is not None:
            self._values["dimension"] = dimension
        if dimension_var is not None:
            self._values["dimension_var"] = dimension_var
        if equal is not None:
            self._values["equal"] = equal
        if greater_than is not None:
            self._values["greater_than"] = greater_than
        if less_than is not None:
            self._values["less_than"] = less_than
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimensionDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimensionDefault"], result)

    @builtins.property
    def dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        '''
        result = self._values.get("dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        '''
        result = self._values.get("dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def equal(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimensionEqual"]:
        '''equal block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        '''
        result = self._values.get("equal")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimensionEqual"], result)

    @builtins.property
    def greater_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimensionGreaterThan"]:
        '''greater_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        '''
        result = self._values.get("greater_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimensionGreaterThan"], result)

    @builtins.property
    def less_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimensionLessThan"]:
        '''less_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        '''
        result = self._values.get("less_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimensionLessThan"], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimension(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimensionDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimensionDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimensionDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimensionDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimensionDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__03d7a978eadfd80c38dfe97da565f6dd75b4dc0d5b8125bbd1bc83b8c940accd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimensionDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimensionDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a03c4b903e10b46d6c663c935909500dbd19aaba7e0ef0ed8e0ba70fb0a872f9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimensionEqual",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimensionEqual:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimensionEqual(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimensionEqualOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimensionEqualOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ed4b3ff4b21e79c6eaf2948eec61ec4c961e1b90100e8bac8220cf0499fdbccc)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimensionEqual], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimensionEqual],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__19fc4895b8fca6b38b74128338bb968ecf7390efc7a80f1bcbe869bc53976ba1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimensionGreaterThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimensionGreaterThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimensionGreaterThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimensionGreaterThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimensionGreaterThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__85f3ab6f2d3c0897bf9007926ac49fe5b0dbbba19e516d44fc24c84cae9f47f4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimensionGreaterThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimensionGreaterThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0d642bebb1a18dc628c6ea523142319c1c70c3a113ad6f6f465caf9adf0d6b99)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimensionLessThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimensionLessThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimensionLessThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimensionLessThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimensionLessThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ed7d6dba26de36e67ccd0c95807377840fd810a3ecadde17bf940645b4d7a063)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimensionLessThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimensionLessThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b8065b18c74174cf74843a7532e0ccb8f68dc3164b491b733db26f7f8b5aa8f6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimensionList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimensionList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__81580f1cb57f92e0ca7a07c9b4edf25f7a4e7cb89a6e99154ad2b2e9926777fb)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimensionOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aa1a109ada74671cd41c3add302cd2f9429471ae49bc80bc289f101dc36eec6e)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimensionOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d9b873c97d12cbf1106843ea45801fbc23ec375010296dfe54f62f688efa485f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a75d958a600dca1ea082a58ee9646be25cb8110e3c25a7b72a862e0fe666d8e0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__821c8c144efe2ec9e79fba692cddb5b41bc96c302e6c29141ec849b316a98a80)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimension]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimension]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4558d9728035bfc41b4cc06be47ba28c450f4029e5920be16edc7b8ee6f6b12c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimensionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimensionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5de0c09275e16dbd481a377d86f5f42cb190558e223eb48c8f48bb1069453751)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimensionDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putEqual")
    def put_equal(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimensionEqual()

        return typing.cast(None, jsii.invoke(self, "putEqual", [value]))

    @jsii.member(jsii_name="putGreaterThan")
    def put_greater_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimensionGreaterThan()

        return typing.cast(None, jsii.invoke(self, "putGreaterThan", [value]))

    @jsii.member(jsii_name="putLessThan")
    def put_less_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimensionLessThan()

        return typing.cast(None, jsii.invoke(self, "putLessThan", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetDimension")
    def reset_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimension", []))

    @jsii.member(jsii_name="resetDimensionVar")
    def reset_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimensionVar", []))

    @jsii.member(jsii_name="resetEqual")
    def reset_equal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEqual", []))

    @jsii.member(jsii_name="resetGreaterThan")
    def reset_greater_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGreaterThan", []))

    @jsii.member(jsii_name="resetLessThan")
    def reset_less_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLessThan", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimensionDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimensionDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="equal")
    def equal(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimensionEqualOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimensionEqualOutputReference, jsii.get(self, "equal"))

    @builtins.property
    @jsii.member(jsii_name="greaterThan")
    def greater_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimensionGreaterThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimensionGreaterThanOutputReference, jsii.get(self, "greaterThan"))

    @builtins.property
    @jsii.member(jsii_name="lessThan")
    def less_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimensionLessThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimensionLessThanOutputReference, jsii.get(self, "lessThan"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimensionDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionInput")
    def dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionVarInput")
    def dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="equalInput")
    def equal_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimensionEqual], jsii.get(self, "equalInput"))

    @builtins.property
    @jsii.member(jsii_name="greaterThanInput")
    def greater_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimensionGreaterThan], jsii.get(self, "greaterThanInput"))

    @builtins.property
    @jsii.member(jsii_name="lessThanInput")
    def less_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimensionLessThan], jsii.get(self, "lessThanInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="dimension")
    def dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimension"))

    @dimension.setter
    def dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__afe970ad58b771bdbae97439e1060b56341cd1854d323e8e255c2b769128cd30)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimension", value)

    @builtins.property
    @jsii.member(jsii_name="dimensionVar")
    def dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimensionVar"))

    @dimension_var.setter
    def dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__616fc838d3fccbef6f94fc60ae3ef7c0ae1a74cf2d4a4b880561ddbcc8709804)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0be27c54efb83ca1e773a00641965d88159e865c54d73d1211c1531ad83a30b5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__53caf7e561eaca06c94d64c3e1b83719f96f5b47230cefd67337e4c615eb55a6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimension]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimension]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimension]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e22e32026b418517482b2a26de4ed10e5fa7a5293859e45f6c8d2c462994734f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientation",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "landscape": "landscape",
        "portrait": "portrait",
        "square": "square",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientation:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientationDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        landscape: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientationLandscape", typing.Dict[builtins.str, typing.Any]]] = None,
        portrait: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientationPortrait", typing.Dict[builtins.str, typing.Any]]] = None,
        square: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientationSquare", typing.Dict[builtins.str, typing.Any]]] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param landscape: landscape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        :param portrait: portrait block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        :param square: square block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientationDefault(**default)
        if isinstance(landscape, dict):
            landscape = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientationLandscape(**landscape)
        if isinstance(portrait, dict):
            portrait = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientationPortrait(**portrait)
        if isinstance(square, dict):
            square = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientationSquare(**square)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e2d5d23195160cb67f8c6038c4280284543af3885011a60282ba6566c954728e)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument landscape", value=landscape, expected_type=type_hints["landscape"])
            check_type(argname="argument portrait", value=portrait, expected_type=type_hints["portrait"])
            check_type(argname="argument square", value=square, expected_type=type_hints["square"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if landscape is not None:
            self._values["landscape"] = landscape
        if portrait is not None:
            self._values["portrait"] = portrait
        if square is not None:
            self._values["square"] = square

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientationDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientationDefault"], result)

    @builtins.property
    def landscape(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientationLandscape"]:
        '''landscape block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        '''
        result = self._values.get("landscape")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientationLandscape"], result)

    @builtins.property
    def portrait(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientationPortrait"]:
        '''portrait block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        '''
        result = self._values.get("portrait")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientationPortrait"], result)

    @builtins.property
    def square(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientationSquare"]:
        '''square block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        result = self._values.get("square")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientationSquare"], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientationDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientationDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientationDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientationDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientationDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__59defac740695d3755426da41c5173cf97c8cad826e26d89303560cd7e532c82)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientationDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientationDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__79a84293e4d9a4434cdbf41fb3f3d16f93ecdd1bee5a9cbd7fe6afa5fd71f05f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientationLandscape",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientationLandscape:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientationLandscape(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientationLandscapeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientationLandscapeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__57e5c0ea87b6b8b6f95b49d1a5db9e35192f2307c901592136212280916a8f2f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientationLandscape], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientationLandscape],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9eeb988701243fd426c66fd62ef186d5326537f92f06de6af0df85c040b95219)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientationList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientationList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dcde249cd0713afafe27eb07ff8e5dd310d9ace9ce150b56ecac7a105824a730)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientationOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5124a41f0ca539659d018314846627a32a24e6e578fb9f995761954b4d0ca5ef)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientationOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a9556945ecf92eda4c959980fafed2aec00d51f7fe80b8e708d59270102115a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aa45c7d8a0937e4b46e1c8f49230a3126ca21dbf809ab825ac90b816fa5348fe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c1b563e622fe72530fbc28691eb04c705ab466d83fcc197a39f671c8bd80e4b5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientation]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientation]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__77d836e0a36eb9a4e5c3d0ba2d341b5dc266efad7a162f14794855b014ba9758)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f660849db76825bb04f850bd613e0ab2c17ed54674d5d6efe056039b6e76299)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientationDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putLandscape")
    def put_landscape(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientationLandscape()

        return typing.cast(None, jsii.invoke(self, "putLandscape", [value]))

    @jsii.member(jsii_name="putPortrait")
    def put_portrait(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientationPortrait()

        return typing.cast(None, jsii.invoke(self, "putPortrait", [value]))

    @jsii.member(jsii_name="putSquare")
    def put_square(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientationSquare()

        return typing.cast(None, jsii.invoke(self, "putSquare", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetLandscape")
    def reset_landscape(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLandscape", []))

    @jsii.member(jsii_name="resetPortrait")
    def reset_portrait(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPortrait", []))

    @jsii.member(jsii_name="resetSquare")
    def reset_square(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSquare", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientationDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientationDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="landscape")
    def landscape(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientationLandscapeOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientationLandscapeOutputReference, jsii.get(self, "landscape"))

    @builtins.property
    @jsii.member(jsii_name="portrait")
    def portrait(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientationPortraitOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientationPortraitOutputReference", jsii.get(self, "portrait"))

    @builtins.property
    @jsii.member(jsii_name="square")
    def square(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientationSquareOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientationSquareOutputReference", jsii.get(self, "square"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientationDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="landscapeInput")
    def landscape_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientationLandscape], jsii.get(self, "landscapeInput"))

    @builtins.property
    @jsii.member(jsii_name="portraitInput")
    def portrait_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientationPortrait"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientationPortrait"], jsii.get(self, "portraitInput"))

    @builtins.property
    @jsii.member(jsii_name="squareInput")
    def square_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientationSquare"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientationSquare"], jsii.get(self, "squareInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientation]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientation]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientation]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1026e275d605ef843ead56b444ee207cef21b9a8bccf35e9761990a0288d625d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientationPortrait",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientationPortrait:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientationPortrait(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientationPortraitOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientationPortraitOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__265e00e6ceeedf97131c1a7ad64c8c51cc609e4bf5907eff8878498e0cf4d318)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientationPortrait]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientationPortrait], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientationPortrait],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7a92af7212bab10910c6fa24529c9aa6e4a75038cf02aee17fd14902eb60569c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientationSquare",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientationSquare:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientationSquare(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientationSquareOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientationSquareOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7bc06b0666e6c1d622347de006a560b32370f69309ff30a341441c6189ce1879)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientationSquare]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientationSquare], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientationSquare],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6a96e8fca7f386cad888d3c4583dd406e199805683cef1a228f255929e737232)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationMaxColors",
    jsii_struct_bases=[],
    name_mapping={"colors": "colors", "colors_var": "colorsVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationMaxColors:
    def __init__(
        self,
        *,
        colors: typing.Optional[builtins.str] = None,
        colors_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param colors: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        :param colors_var: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0a9360c4b2acf000b2d1a6ebae155b34637821f3f3e0907781264dc32b39fa16)
            check_type(argname="argument colors", value=colors, expected_type=type_hints["colors"])
            check_type(argname="argument colors_var", value=colors_var, expected_type=type_hints["colors_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if colors is not None:
            self._values["colors"] = colors
        if colors_var is not None:
            self._values["colors_var"] = colors_var

    @builtins.property
    def colors(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        '''
        result = self._values.get("colors")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def colors_var(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        result = self._values.get("colors_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationMaxColors(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationMaxColorsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationMaxColorsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ff7de3861555824a2fd3ff9d3492469cb4f8cd4e206facebffd96f28843119d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationMaxColorsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9aa59fe1432000db8e4fd613148d249f04af58fe317554c2b253cce152c1ce31)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationMaxColorsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__25908ea80e49b3e04c8b1ca75af0637553edd7ba903e3b7078c73e4858bc9c25)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ed83e8e57e7ab80a066a9227f6ae9c53ff50a187acb8e27429e8cb86e31c555)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ebe12d59fbead1fe1a9beeab68397112044a0072d10b2c094c51368631636cd5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationMaxColors]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationMaxColors]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__68d0adcfac81b5a10095f8c7fea7a27df697b738fd6e0ed83d66617adeaf8c18)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationMaxColorsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationMaxColorsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5d9c36b3f160b7fe144429cb5b7256c103215a4fe8edeab0140d9457056948e6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColors")
    def reset_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColors", []))

    @jsii.member(jsii_name="resetColorsVar")
    def reset_colors_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorsVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorsInput")
    def colors_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsInput"))

    @builtins.property
    @jsii.member(jsii_name="colorsVarInput")
    def colors_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsVarInput"))

    @builtins.property
    @jsii.member(jsii_name="colors")
    def colors(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colors"))

    @colors.setter
    def colors(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5a893fa221787c9fe32463ec000ac06c3875528adf0015f4b6e9d955cd461d21)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colors", value)

    @builtins.property
    @jsii.member(jsii_name="colorsVar")
    def colors_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorsVar"))

    @colors_var.setter
    def colors_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cdf5616293d8975e3d32bf8e29e3808c3437fc43488291776d097078cfdd0371)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorsVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationMaxColors]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationMaxColors]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationMaxColors]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__07525ccde2e419426c2c125f344b6cc88d7cddfd3c26b12a5ea76cd0d891e071)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationMirror",
    jsii_struct_bases=[],
    name_mapping={
        "horizontal": "horizontal",
        "horizontal_var": "horizontalVar",
        "vertical": "vertical",
        "vertical_var": "verticalVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationMirror:
    def __init__(
        self,
        *,
        horizontal: typing.Optional[builtins.str] = None,
        horizontal_var: typing.Optional[builtins.str] = None,
        vertical: typing.Optional[builtins.str] = None,
        vertical_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param horizontal: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        :param horizontal_var: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        :param vertical: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        :param vertical_var: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__89a277028825afa2f7e04c0ebaea5465da9c377a601a15f8b6f2af4dbcb5fddc)
            check_type(argname="argument horizontal", value=horizontal, expected_type=type_hints["horizontal"])
            check_type(argname="argument horizontal_var", value=horizontal_var, expected_type=type_hints["horizontal_var"])
            check_type(argname="argument vertical", value=vertical, expected_type=type_hints["vertical"])
            check_type(argname="argument vertical_var", value=vertical_var, expected_type=type_hints["vertical_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if horizontal is not None:
            self._values["horizontal"] = horizontal
        if horizontal_var is not None:
            self._values["horizontal_var"] = horizontal_var
        if vertical is not None:
            self._values["vertical"] = vertical
        if vertical_var is not None:
            self._values["vertical_var"] = vertical_var

    @builtins.property
    def horizontal(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        '''
        result = self._values.get("horizontal")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def horizontal_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        '''
        result = self._values.get("horizontal_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        '''
        result = self._values.get("vertical")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        result = self._values.get("vertical_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationMirror(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationMirrorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationMirrorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__58bacf3f8e6eadccf88deb8f083e2caf5054ac1841cbee2e2da0bfd68a8412a5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationMirrorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7ad25f5122d8d9fbd4074e85ab45257a81983fcf2281dab8782e131ae455b2d4)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationMirrorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aacea49a7e348fc5a9d5ec997e8b0a3dafee0da09e3ef23d285021424063d71e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b011f7ae1fdc5f27e788705d176f548e2f8d9b3e9c83c050ff9df0e74354685a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e5ed3527ce043ddf6b013c7ec2c14507b4b468f00f8117e98fc7db67152c36f1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationMirror]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationMirror]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__76f419e44d27ea73cc7ed604d0ad0928293e8cb6c0f5d565cff13833173b54c8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationMirrorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationMirrorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b3f3105acdc50c75c8c07b0e9192710e1a4347b95c656cb98985c299a5d6ea41)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHorizontal")
    def reset_horizontal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontal", []))

    @jsii.member(jsii_name="resetHorizontalVar")
    def reset_horizontal_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontalVar", []))

    @jsii.member(jsii_name="resetVertical")
    def reset_vertical(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVertical", []))

    @jsii.member(jsii_name="resetVerticalVar")
    def reset_vertical_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVerticalVar", []))

    @builtins.property
    @jsii.member(jsii_name="horizontalInput")
    def horizontal_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontalVarInput")
    def horizontal_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalInput")
    def vertical_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalVarInput")
    def vertical_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontal")
    def horizontal(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontal"))

    @horizontal.setter
    def horizontal(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__49eab2fab1a8be75a2c4ef91ce4b2b7848f41941949dfbd9eb52ff679dd710fd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontal", value)

    @builtins.property
    @jsii.member(jsii_name="horizontalVar")
    def horizontal_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontalVar"))

    @horizontal_var.setter
    def horizontal_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ee466154889621523c08fda81c92c37d312ff2329d967faab442a13488d9e2a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontalVar", value)

    @builtins.property
    @jsii.member(jsii_name="vertical")
    def vertical(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "vertical"))

    @vertical.setter
    def vertical(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__597bf8bcde6aae53823e92d7ef736a84407dad1385835314a8890a15ee915441)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "vertical", value)

    @builtins.property
    @jsii.member(jsii_name="verticalVar")
    def vertical_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "verticalVar"))

    @vertical_var.setter
    def vertical_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cdedd1d7842e3871b1a676f42d50257574b699c85f6dc274ad69ec15765f52ce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "verticalVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationMirror]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationMirror]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationMirror]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a37becbf27520724aa143a4a4dac3fdff3af0438f6e5d6f39277cfa5a763cfc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationMonoHue",
    jsii_struct_bases=[],
    name_mapping={"hue": "hue", "hue_var": "hueVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationMonoHue:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a6ff833e012461ea627546751679501703b9696790d86a8c833b28178494dcae)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationMonoHue(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationMonoHueList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationMonoHueList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bdfda82cb045266f9ba9bc52ea6f355bd9edbecce65075d744cf7412f9d5d562)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationMonoHueOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__733be3069ff8605ee8b65d33e4aba142af7c07e6fe2e6b5bb55a06e0cf5acab0)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationMonoHueOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__026cef8933abda4fad87718bb5ad509ba4fe9fef28f0f06c2c965c8dbb1d2684)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0af192f8907a6801ac5eadb323d8bd63f6002d93a23d3e4dedbadf241ca2fe4d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ff679b785eb8d48d0fea9872e7ec3ec8351ef21a611ecb9b89b7af2f1b9acf14)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationMonoHue]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationMonoHue]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e87de3c8ec4801fa5c28232cc5627187f2826bfbe4f7cd77eea0b85156e1d600)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationMonoHueOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationMonoHueOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__44b46cb3ba10accc931cae38fad472d2014fcbf9c83bd5707a9dccecc2bce516)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e468b8e8fd9bdaca7c13aaf8c2e60ba2b5f567ee76196b113b31fae3fc3e57f2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4f0de94fc477a25559b8693ae92a874ac3d302004ab1dc6335675046dc3e18c4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationMonoHue]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationMonoHue]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationMonoHue]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__228398da930f04f485278774a41633aca460e22f6885f0ba8a7af6375234e7c9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationOpacity",
    jsii_struct_bases=[],
    name_mapping={"opacity": "opacity", "opacity_var": "opacityVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationOpacity:
    def __init__(
        self,
        *,
        opacity: typing.Optional[builtins.str] = None,
        opacity_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param opacity: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param opacity_var: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cee1d1062c270902eecfcaf370a1fb16ad28208e5b1377258d277038e9f162e7)
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument opacity_var", value=opacity_var, expected_type=type_hints["opacity_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if opacity is not None:
            self._values["opacity"] = opacity
        if opacity_var is not None:
            self._values["opacity_var"] = opacity_var

    @builtins.property
    def opacity(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def opacity_var(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        result = self._values.get("opacity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationOpacity(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationOpacityList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationOpacityList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3fcd353e86501990071f0836a3c78e2d3216dd229fb9e05e78f2bd97b1a64f71)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationOpacityOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bbea731316e3127d40fe97e289d1bf548597d86079567ab3b9c2058b0d85eef8)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationOpacityOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a7b067a8496eda9eac0203ebe1d11db1138659ca4f872513290898b629de654e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f1ef1573ee2fe5a18fa81827d024694aea5c654fa14a50d18be9d881eed90323)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fc1557e25845b0521ff722c48cc8be95a0f4cacb5266ff816f254f3a098938be)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationOpacity]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationOpacity]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__87adac9df8e906b04ce79d3585bcab3a4b01dbe627da30edde956e08ca8522f3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationOpacityOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationOpacityOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__17102c29344858b13915917d994be436167a10e8c073f939a388cf70770c896e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetOpacityVar")
    def reset_opacity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacityVar", []))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityVarInput")
    def opacity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacity"))

    @opacity.setter
    def opacity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cf04d2c84fa79980ad1be810f6005ee6ec9a9e52562110ab216ea68dae0782b8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacity", value)

    @builtins.property
    @jsii.member(jsii_name="opacityVar")
    def opacity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacityVar"))

    @opacity_var.setter
    def opacity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cb419d4922bfa6cb6a1298fa9332c8347497baa928341ecf77125f33e26526d7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacityVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationOpacity]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationOpacity]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationOpacity]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1e2878c41f37ee84720230c461dd3c17f3fcf1cc0fbb86a64944e90fc225ec53)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d7eb8315b7a2e936baa02daf7c91ae8b3212f5f76a3df4a3121140b6587a4b2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putBackgroundColor")
    def put_background_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__643e5afa8c7ace823171e24982a5fb53591ccf62d2f6c7e19e99b8c347c28271)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBackgroundColor", [value]))

    @jsii.member(jsii_name="putBlur")
    def put_blur(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationBlur, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f20ecb4732897a7b6911417cef9cbc6809062fd5c9d2f7d57b0bca90669d3dd0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBlur", [value]))

    @jsii.member(jsii_name="putChromaKey")
    def put_chroma_key(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationChromaKey, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c1ffd10bbadcff6f7dda7288446e0000ab67147830e0526e17b1065b50f21021)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putChromaKey", [value]))

    @jsii.member(jsii_name="putComposite")
    def put_composite(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationComposite, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7cf71cd1d98db6bff381b49a36967eaf5f644fd7206411150af983b185e4ca3a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putComposite", [value]))

    @jsii.member(jsii_name="putCompound")
    def put_compound(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationCompound, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9f955051c652c0c2911b50956941e857ac6ba9dbadde01876a3b271b2b40f9e5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCompound", [value]))

    @jsii.member(jsii_name="putContrast")
    def put_contrast(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationContrast, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__633f5c737ec80fed3f51048b0661527ab4a6e644164bdfe3a58a207aa0d3d240)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putContrast", [value]))

    @jsii.member(jsii_name="putGoop")
    def put_goop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationGoop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__01cc5424358163b8342af73000c8d7c3587698f4672b753b8dc2d9f0c2734523)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGoop", [value]))

    @jsii.member(jsii_name="putGrayscale")
    def put_grayscale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationGrayscale, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__89c4af0fc725a216d89e1dc03addc4c4a6836e3c659e1d9325cb3434353c8ee5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGrayscale", [value]))

    @jsii.member(jsii_name="putHsl")
    def put_hsl(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationHsl, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a490f7e720350c00a4248e0006cf2cbc753eb857c8ac7a4b911b0e633b02fe5a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsl", [value]))

    @jsii.member(jsii_name="putHsv")
    def put_hsv(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationHsv, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d2578f7470e98a419f1cc2b7fd471e90c8f4877d3e497edb92bfe3d8feeb6c5f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsv", [value]))

    @jsii.member(jsii_name="putIfDimension")
    def put_if_dimension(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimension, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c2c804268a445952f4530cd35b90c0c7b14443b86769fe0c119638d2fe5e2d4b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfDimension", [value]))

    @jsii.member(jsii_name="putIfOrientation")
    def put_if_orientation(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__285a6d07dd2336d8864db84ac2c470b1f4fd9ef8d93fe58a0405c559ffbc3461)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfOrientation", [value]))

    @jsii.member(jsii_name="putMaxColors")
    def put_max_colors(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationMaxColors, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0adc5e10bf2b1ad6bfbabf0c06aeb8a6bff3a78b06d4922006b96a7af3f450e3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMaxColors", [value]))

    @jsii.member(jsii_name="putMirror")
    def put_mirror(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationMirror, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d5212163a2ff0893e97201ec5c1f605c396800970f356d9d57eebd4a15023f3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMirror", [value]))

    @jsii.member(jsii_name="putMonoHue")
    def put_mono_hue(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationMonoHue, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__053b99279c6db6da83b340ed4627fa2f060bed7157ccee6d86f49c5f17ed0ff2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMonoHue", [value]))

    @jsii.member(jsii_name="putOpacity")
    def put_opacity(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationOpacity, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f98f31cd950fa2cf9da1ef36840577a8fb073add078259ec4294cbfe6af7e27)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putOpacity", [value]))

    @jsii.member(jsii_name="putRemoveColor")
    def put_remove_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationRemoveColor", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c573d6d907ae511a7582e1df5dfbfeb0d856f572e24f4be184c27dac7297062b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRemoveColor", [value]))

    @jsii.member(jsii_name="putUnsharpMask")
    def put_unsharp_mask(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationUnsharpMask", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__81b296e6903d2193dc3d5c3b765347f794345ac73392c4f4f38488492c85c317)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putUnsharpMask", [value]))

    @jsii.member(jsii_name="resetBackgroundColor")
    def reset_background_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBackgroundColor", []))

    @jsii.member(jsii_name="resetBlur")
    def reset_blur(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBlur", []))

    @jsii.member(jsii_name="resetChromaKey")
    def reset_chroma_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChromaKey", []))

    @jsii.member(jsii_name="resetComposite")
    def reset_composite(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetComposite", []))

    @jsii.member(jsii_name="resetCompound")
    def reset_compound(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCompound", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetGoop")
    def reset_goop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGoop", []))

    @jsii.member(jsii_name="resetGrayscale")
    def reset_grayscale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGrayscale", []))

    @jsii.member(jsii_name="resetHsl")
    def reset_hsl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsl", []))

    @jsii.member(jsii_name="resetHsv")
    def reset_hsv(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsv", []))

    @jsii.member(jsii_name="resetIfDimension")
    def reset_if_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfDimension", []))

    @jsii.member(jsii_name="resetIfOrientation")
    def reset_if_orientation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfOrientation", []))

    @jsii.member(jsii_name="resetMaxColors")
    def reset_max_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxColors", []))

    @jsii.member(jsii_name="resetMirror")
    def reset_mirror(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMirror", []))

    @jsii.member(jsii_name="resetMonoHue")
    def reset_mono_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonoHue", []))

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetRemoveColor")
    def reset_remove_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRemoveColor", []))

    @jsii.member(jsii_name="resetUnsharpMask")
    def reset_unsharp_mask(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUnsharpMask", []))

    @builtins.property
    @jsii.member(jsii_name="backgroundColor")
    def background_color(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationBackgroundColorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationBackgroundColorList, jsii.get(self, "backgroundColor"))

    @builtins.property
    @jsii.member(jsii_name="blur")
    def blur(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationBlurList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationBlurList, jsii.get(self, "blur"))

    @builtins.property
    @jsii.member(jsii_name="chromaKey")
    def chroma_key(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationChromaKeyList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationChromaKeyList, jsii.get(self, "chromaKey"))

    @builtins.property
    @jsii.member(jsii_name="composite")
    def composite(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationCompositeList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationCompositeList, jsii.get(self, "composite"))

    @builtins.property
    @jsii.member(jsii_name="compound")
    def compound(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationCompoundList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationCompoundList, jsii.get(self, "compound"))

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationContrastList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationContrastList, jsii.get(self, "contrast"))

    @builtins.property
    @jsii.member(jsii_name="goop")
    def goop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationGoopList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationGoopList, jsii.get(self, "goop"))

    @builtins.property
    @jsii.member(jsii_name="grayscale")
    def grayscale(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationGrayscaleList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationGrayscaleList, jsii.get(self, "grayscale"))

    @builtins.property
    @jsii.member(jsii_name="hsl")
    def hsl(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationHslList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationHslList, jsii.get(self, "hsl"))

    @builtins.property
    @jsii.member(jsii_name="hsv")
    def hsv(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationHsvList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationHsvList, jsii.get(self, "hsv"))

    @builtins.property
    @jsii.member(jsii_name="ifDimension")
    def if_dimension(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimensionList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimensionList, jsii.get(self, "ifDimension"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientation")
    def if_orientation(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientationList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientationList, jsii.get(self, "ifOrientation"))

    @builtins.property
    @jsii.member(jsii_name="maxColors")
    def max_colors(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationMaxColorsList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationMaxColorsList, jsii.get(self, "maxColors"))

    @builtins.property
    @jsii.member(jsii_name="mirror")
    def mirror(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationMirrorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationMirrorList, jsii.get(self, "mirror"))

    @builtins.property
    @jsii.member(jsii_name="monoHue")
    def mono_hue(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationMonoHueList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationMonoHueList, jsii.get(self, "monoHue"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationOpacityList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationOpacityList, jsii.get(self, "opacity"))

    @builtins.property
    @jsii.member(jsii_name="removeColor")
    def remove_color(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationRemoveColorList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationRemoveColorList", jsii.get(self, "removeColor"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMask")
    def unsharp_mask(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationUnsharpMaskList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationUnsharpMaskList", jsii.get(self, "unsharpMask"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColorInput")
    def background_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationBackgroundColor]]], jsii.get(self, "backgroundColorInput"))

    @builtins.property
    @jsii.member(jsii_name="blurInput")
    def blur_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationBlur]]], jsii.get(self, "blurInput"))

    @builtins.property
    @jsii.member(jsii_name="chromaKeyInput")
    def chroma_key_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationChromaKey]]], jsii.get(self, "chromaKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="compositeInput")
    def composite_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationComposite]]], jsii.get(self, "compositeInput"))

    @builtins.property
    @jsii.member(jsii_name="compoundInput")
    def compound_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationCompound]]], jsii.get(self, "compoundInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationContrast]]], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="goopInput")
    def goop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationGoop]]], jsii.get(self, "goopInput"))

    @builtins.property
    @jsii.member(jsii_name="grayscaleInput")
    def grayscale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationGrayscale]]], jsii.get(self, "grayscaleInput"))

    @builtins.property
    @jsii.member(jsii_name="hslInput")
    def hsl_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationHsl]]], jsii.get(self, "hslInput"))

    @builtins.property
    @jsii.member(jsii_name="hsvInput")
    def hsv_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationHsv]]], jsii.get(self, "hsvInput"))

    @builtins.property
    @jsii.member(jsii_name="ifDimensionInput")
    def if_dimension_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimension]]], jsii.get(self, "ifDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientationInput")
    def if_orientation_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientation]]], jsii.get(self, "ifOrientationInput"))

    @builtins.property
    @jsii.member(jsii_name="maxColorsInput")
    def max_colors_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationMaxColors]]], jsii.get(self, "maxColorsInput"))

    @builtins.property
    @jsii.member(jsii_name="mirrorInput")
    def mirror_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationMirror]]], jsii.get(self, "mirrorInput"))

    @builtins.property
    @jsii.member(jsii_name="monoHueInput")
    def mono_hue_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationMonoHue]]], jsii.get(self, "monoHueInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationOpacity]]], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="removeColorInput")
    def remove_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationRemoveColor"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationRemoveColor"]]], jsii.get(self, "removeColorInput"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMaskInput")
    def unsharp_mask_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationUnsharpMask"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationUnsharpMask"]]], jsii.get(self, "unsharpMaskInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__41b8050e9d546c4a88e7ca338d0eed68df8b0316ada4ba61d9838bd9fd8fd8dd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationRemoveColor",
    jsii_struct_bases=[],
    name_mapping={
        "color": "color",
        "color_var": "colorVar",
        "feather": "feather",
        "feather_var": "featherVar",
        "tolerance": "tolerance",
        "tolerance_var": "toleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationRemoveColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
        feather: typing.Optional[builtins.str] = None,
        feather_var: typing.Optional[builtins.str] = None,
        tolerance: typing.Optional[builtins.str] = None,
        tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        :param feather: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        :param feather_var: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        :param tolerance: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        :param tolerance_var: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c018529f6ad5283391ef474f49533fb1cffdd12845a637d8810c1bf79d2e67e1)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
            check_type(argname="argument feather", value=feather, expected_type=type_hints["feather"])
            check_type(argname="argument feather_var", value=feather_var, expected_type=type_hints["feather_var"])
            check_type(argname="argument tolerance", value=tolerance, expected_type=type_hints["tolerance"])
            check_type(argname="argument tolerance_var", value=tolerance_var, expected_type=type_hints["tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var
        if feather is not None:
            self._values["feather"] = feather
        if feather_var is not None:
            self._values["feather_var"] = feather_var
        if tolerance is not None:
            self._values["tolerance"] = tolerance
        if tolerance_var is not None:
            self._values["tolerance_var"] = tolerance_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        '''
        result = self._values.get("feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather_var(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        '''
        result = self._values.get("feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        '''
        result = self._values.get("tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance_var(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        result = self._values.get("tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationRemoveColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationRemoveColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationRemoveColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6ca1bcc62d35134d56e59a1eef36cdd668dcbcb94e27cd79a662673d33c2de59)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationRemoveColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6cdc7c060a022f4bf89b43c3650e112d20fff144d2f214bc14cb6491b7f195e4)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationRemoveColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__de09fb5cee98408fda97e43db168935131939e524e91bdab544ef763cba79b2f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__92de8e1cecf48e7e3bbc72e741420301e2f40e97715d9321d99dd11a561c119f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1057d2108b49d77e9b549d7b8e1e401a8c6a095f166fc1516e2043b32a506e81)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationRemoveColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationRemoveColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationRemoveColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__61b4cea047a5f9a5bc1addea0016a67f74452f7c2de78bd42dd76fa998ec02da)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationRemoveColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationRemoveColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c06af81a31aa7c3f55c9aeab944216f29fb22467a65128b7f40dae0e41123a43)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @jsii.member(jsii_name="resetFeather")
    def reset_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeather", []))

    @jsii.member(jsii_name="resetFeatherVar")
    def reset_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatherVar", []))

    @jsii.member(jsii_name="resetTolerance")
    def reset_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTolerance", []))

    @jsii.member(jsii_name="resetToleranceVar")
    def reset_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featherInput")
    def feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherInput"))

    @builtins.property
    @jsii.member(jsii_name="featherVarInput")
    def feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceInput")
    def tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceVarInput")
    def tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9754c72736a8c9335a466066af259985d8f6a26f7cbc1f5723b4df1b735eeab5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__800763dee824faa006edf2faa5c9ed02756a9ff1a58acafb8d1711f8e6a41376)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="feather")
    def feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "feather"))

    @feather.setter
    def feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc47d9f6885b5edd5cc9160e100476696cc5cf9a364dc4e8cb8cac47f0bef9d9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "feather", value)

    @builtins.property
    @jsii.member(jsii_name="featherVar")
    def feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featherVar"))

    @feather_var.setter
    def feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6d39186680ef9c533e6b14ca57e657607c6fabc8a80af1276f9ffab03cbc6ee1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featherVar", value)

    @builtins.property
    @jsii.member(jsii_name="tolerance")
    def tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tolerance"))

    @tolerance.setter
    def tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb9212377c99964b82b20de5ad27cb95f61986865ce909b23271bbe67da431da)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tolerance", value)

    @builtins.property
    @jsii.member(jsii_name="toleranceVar")
    def tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "toleranceVar"))

    @tolerance_var.setter
    def tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e5ed04841755441b2a92111b70aad6bb92fb86a2f1b58af917a2ec6fdc842a26)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "toleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationRemoveColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationRemoveColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationRemoveColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e384f59d52f786abecb6cf90904809d8a2692863d62f29a8eca17ffbdac421d0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationUnsharpMask",
    jsii_struct_bases=[],
    name_mapping={
        "gain": "gain",
        "gain_var": "gainVar",
        "sigma": "sigma",
        "sigma_var": "sigmaVar",
        "threshold": "threshold",
        "threshold_var": "thresholdVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationUnsharpMask:
    def __init__(
        self,
        *,
        gain: typing.Optional[builtins.str] = None,
        gain_var: typing.Optional[builtins.str] = None,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
        threshold: typing.Optional[builtins.str] = None,
        threshold_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param gain: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        :param gain_var: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        :param sigma: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        :param threshold: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        :param threshold_var: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a88b67fc66abf97e62ce7a8566cc33e857a1791be8b0ed39e89851ed09fa9de8)
            check_type(argname="argument gain", value=gain, expected_type=type_hints["gain"])
            check_type(argname="argument gain_var", value=gain_var, expected_type=type_hints["gain_var"])
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
            check_type(argname="argument threshold", value=threshold, expected_type=type_hints["threshold"])
            check_type(argname="argument threshold_var", value=threshold_var, expected_type=type_hints["threshold_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if gain is not None:
            self._values["gain"] = gain
        if gain_var is not None:
            self._values["gain_var"] = gain_var
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var
        if threshold is not None:
            self._values["threshold"] = threshold
        if threshold_var is not None:
            self._values["threshold_var"] = threshold_var

    @builtins.property
    def gain(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        '''
        result = self._values.get("gain")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gain_var(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        '''
        result = self._values.get("gain_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        '''
        result = self._values.get("threshold")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold_var(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        result = self._values.get("threshold_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationUnsharpMask(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationUnsharpMaskList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationUnsharpMaskList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8e1a37120c0d8a074e462f9fda9c678fe2ec5f099ce0ee100fe50ee40de9ca12)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationUnsharpMaskOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__11d73233b55a4b0565002f5f1f7f2b05aba1a49210af465f1b1a9a2849336cee)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationUnsharpMaskOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d6356b350ff2130c7650d53753fe464d4de7537b21d373669a377443e1a5ba25)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b4eb61b2ca5c9451c3d1d14693505d508bff121a724c2ea910f6a55028d529e5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ac63e61e44eca8597f090af66c0e7e21eeca56a57ec3cadf9bcccb5301f23cc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationUnsharpMask]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationUnsharpMask]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationUnsharpMask]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6a1f714bbb8457139892d65d18d2a39e06bd2a07a1b16699e2e76111b8b94612)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationUnsharpMaskOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationUnsharpMaskOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b41585dde81fe5361c8f1131f3b789ea6e3b00eb71a6f5ff59c9dc92c80ac8f8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetGain")
    def reset_gain(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGain", []))

    @jsii.member(jsii_name="resetGainVar")
    def reset_gain_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGainVar", []))

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @jsii.member(jsii_name="resetThreshold")
    def reset_threshold(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThreshold", []))

    @jsii.member(jsii_name="resetThresholdVar")
    def reset_threshold_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThresholdVar", []))

    @builtins.property
    @jsii.member(jsii_name="gainInput")
    def gain_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainInput"))

    @builtins.property
    @jsii.member(jsii_name="gainVarInput")
    def gain_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdInput")
    def threshold_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdVarInput")
    def threshold_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gain")
    def gain(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gain"))

    @gain.setter
    def gain(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a030fe2cbfe1a5761a4a341f6d3cbf78eda1ae65e57c79fd1f72567812ec6b35)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gain", value)

    @builtins.property
    @jsii.member(jsii_name="gainVar")
    def gain_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gainVar"))

    @gain_var.setter
    def gain_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab8c0dc2efc5dee4866c3d0369451776a52a1abc663ba56029f5d61d38b164d3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gainVar", value)

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b31351651b634fc369dd1bca51e8a5e6ba9bd766c76958fe759a23a5c713a03d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a69b9a1495281352b9fc00f49e56b9b957177e53b893a906ca32ff4139c8078)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="threshold")
    def threshold(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "threshold"))

    @threshold.setter
    def threshold(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__50f8709aaeb98922e6135af64a9886d2fbfa4ebd17986d51a64cc06ebecdeee1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "threshold", value)

    @builtins.property
    @jsii.member(jsii_name="thresholdVar")
    def threshold_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "thresholdVar"))

    @threshold_var.setter
    def threshold_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8b7bdd24421aac324364de408a41afae4ca2945a6ca3922440fc06e003ef9357)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "thresholdVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationUnsharpMask]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationUnsharpMask]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationUnsharpMask]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3c9cbf3933ca44c5dc5dea11a339852288122225bac0d2d20e030e588f638246)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImage",
    jsii_struct_bases=[],
    name_mapping={
        "color": "color",
        "color_var": "colorVar",
        "diameter": "diameter",
        "diameter_var": "diameterVar",
        "transformation": "transformation",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImage:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
        diameter: typing.Optional[builtins.str] = None,
        diameter_var: typing.Optional[builtins.str] = None,
        transformation: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The fill color of the circle. The API supports hexadecimal representation and CSS hexadecimal color values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The fill color of the circle. The API supports hexadecimal representation and CSS hexadecimal color values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        :param diameter: The diameter of the circle. The diameter will be the width and the height of the image in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#diameter DataAkamaiImagingPolicyImage#diameter}
        :param diameter_var: The diameter of the circle. The diameter will be the width and the height of the image in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#diameter_var DataAkamaiImagingPolicyImage#diameter_var}
        :param transformation: transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        :param width: The width of the box in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width of the box in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(transformation, dict):
            transformation = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformation(**transformation)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9126c933f1e9fe655d56dafac6cbbc8de912dc9c9b43ea09673811b940c8c1bd)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
            check_type(argname="argument diameter", value=diameter, expected_type=type_hints["diameter"])
            check_type(argname="argument diameter_var", value=diameter_var, expected_type=type_hints["diameter_var"])
            check_type(argname="argument transformation", value=transformation, expected_type=type_hints["transformation"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var
        if diameter is not None:
            self._values["diameter"] = diameter
        if diameter_var is not None:
            self._values["diameter_var"] = diameter_var
        if transformation is not None:
            self._values["transformation"] = transformation
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The fill color of the circle. The API supports hexadecimal representation and CSS hexadecimal color values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The fill color of the circle. The API supports hexadecimal representation and CSS hexadecimal color values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def diameter(self) -> typing.Optional[builtins.str]:
        '''The diameter of the circle. The diameter will be the width and the height of the image in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#diameter DataAkamaiImagingPolicyImage#diameter}
        '''
        result = self._values.get("diameter")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def diameter_var(self) -> typing.Optional[builtins.str]:
        '''The diameter of the circle. The diameter will be the width and the height of the image in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#diameter_var DataAkamaiImagingPolicyImage#diameter_var}
        '''
        result = self._values.get("diameter_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def transformation(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformation"]:
        '''transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        '''
        result = self._values.get("transformation")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformation"], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width of the box in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width of the box in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1d777cc181d8e91734e55e17172b6cc7ea76e2bad56df318b0fbbcf3e8759ecf)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2476f0ae46f66cf63152c18dd22575b34c9c581c3d2956f1cdaf8bd9344ae705)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0b255fc3bb2b5b66e50b3ebbff62a0de6c06adac99a0f2d8f6478ff50def2495)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ff7aa9a9486ae0ebf3f9d68184c5893c76a7d2a0b9a5cef4ff4d69a4ecdbc19)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea40cbebe885366241ee41cd18dbd9bb593fbaf2f393980ea85edc5478dcfd40)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImage]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImage]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImage]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__04547e6c92bb9a1071fa83e655fb917fb6d6cc07971d834446fd1fdce7d8ec74)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e596a053b5781a2571f6e9cffe350654a7cd2967a2509fe977ee607541231d67)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformation")
    def put_transformation(
        self,
        *,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationBackgroundColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationBlur", typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationChromaKey", typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationComposite", typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationCompound", typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationContrast", typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationGoop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationGrayscale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationHsl", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationHsv", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimension", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientation", typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationMaxColors", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationMirror", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationMonoHue", typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationOpacity", typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationRemoveColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationUnsharpMask", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformation(
            background_color=background_color,
            blur=blur,
            chroma_key=chroma_key,
            composite=composite,
            compound=compound,
            contrast=contrast,
            goop=goop,
            grayscale=grayscale,
            hsl=hsl,
            hsv=hsv,
            if_dimension=if_dimension,
            if_orientation=if_orientation,
            max_colors=max_colors,
            mirror=mirror,
            mono_hue=mono_hue,
            opacity=opacity,
            remove_color=remove_color,
            unsharp_mask=unsharp_mask,
        )

        return typing.cast(None, jsii.invoke(self, "putTransformation", [value]))

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @jsii.member(jsii_name="resetDiameter")
    def reset_diameter(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDiameter", []))

    @jsii.member(jsii_name="resetDiameterVar")
    def reset_diameter_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDiameterVar", []))

    @jsii.member(jsii_name="resetTransformation")
    def reset_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformation", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="transformation")
    def transformation(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationOutputReference", jsii.get(self, "transformation"))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="diameterInput")
    def diameter_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "diameterInput"))

    @builtins.property
    @jsii.member(jsii_name="diameterVarInput")
    def diameter_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "diameterVarInput"))

    @builtins.property
    @jsii.member(jsii_name="transformationInput")
    def transformation_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformation"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformation"], jsii.get(self, "transformationInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e0e89ff14aa671beb6d699c92fe48c934ee1ac4585d523cf4fbd7b6eb006b5fb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1b89d2f4bf760a9ebb827bb02ec4b895146e16b3901038108d262427cae2ecfb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="diameter")
    def diameter(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "diameter"))

    @diameter.setter
    def diameter(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__31f54c886eff8312485a99196e034adbb57dd8a7b8586a17d3c281ba3eebcc0f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "diameter", value)

    @builtins.property
    @jsii.member(jsii_name="diameterVar")
    def diameter_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "diameterVar"))

    @diameter_var.setter
    def diameter_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a77858ade57d61d6f4915612387b8d597669b37372f6501bd08dceabf9cc29da)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "diameterVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d11622c4018a8af38246a3e1d7c9ddb133d5a0a449a56d83d24f1d54a3b017ca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bfe4e2b1100dd966ccc24d7482068ec12ada6190380acdbeb69c2a2a28557b94)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImage]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImage]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImage]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__49bd69255f38084e9628fd504d1529f228d36556571ecb4de1c26f9924719b4a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformation",
    jsii_struct_bases=[],
    name_mapping={
        "background_color": "backgroundColor",
        "blur": "blur",
        "chroma_key": "chromaKey",
        "composite": "composite",
        "compound": "compound",
        "contrast": "contrast",
        "goop": "goop",
        "grayscale": "grayscale",
        "hsl": "hsl",
        "hsv": "hsv",
        "if_dimension": "ifDimension",
        "if_orientation": "ifOrientation",
        "max_colors": "maxColors",
        "mirror": "mirror",
        "mono_hue": "monoHue",
        "opacity": "opacity",
        "remove_color": "removeColor",
        "unsharp_mask": "unsharpMask",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformation:
    def __init__(
        self,
        *,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationBackgroundColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationBlur", typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationChromaKey", typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationComposite", typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationCompound", typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationContrast", typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationGoop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationGrayscale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationHsl", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationHsv", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimension", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientation", typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationMaxColors", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationMirror", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationMonoHue", typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationOpacity", typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationRemoveColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationUnsharpMask", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a8fcd2e13e6398a77596ce77b187931d6ac9ef08f8d32d6a75ce40631dcaed3c)
            check_type(argname="argument background_color", value=background_color, expected_type=type_hints["background_color"])
            check_type(argname="argument blur", value=blur, expected_type=type_hints["blur"])
            check_type(argname="argument chroma_key", value=chroma_key, expected_type=type_hints["chroma_key"])
            check_type(argname="argument composite", value=composite, expected_type=type_hints["composite"])
            check_type(argname="argument compound", value=compound, expected_type=type_hints["compound"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument goop", value=goop, expected_type=type_hints["goop"])
            check_type(argname="argument grayscale", value=grayscale, expected_type=type_hints["grayscale"])
            check_type(argname="argument hsl", value=hsl, expected_type=type_hints["hsl"])
            check_type(argname="argument hsv", value=hsv, expected_type=type_hints["hsv"])
            check_type(argname="argument if_dimension", value=if_dimension, expected_type=type_hints["if_dimension"])
            check_type(argname="argument if_orientation", value=if_orientation, expected_type=type_hints["if_orientation"])
            check_type(argname="argument max_colors", value=max_colors, expected_type=type_hints["max_colors"])
            check_type(argname="argument mirror", value=mirror, expected_type=type_hints["mirror"])
            check_type(argname="argument mono_hue", value=mono_hue, expected_type=type_hints["mono_hue"])
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument remove_color", value=remove_color, expected_type=type_hints["remove_color"])
            check_type(argname="argument unsharp_mask", value=unsharp_mask, expected_type=type_hints["unsharp_mask"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if background_color is not None:
            self._values["background_color"] = background_color
        if blur is not None:
            self._values["blur"] = blur
        if chroma_key is not None:
            self._values["chroma_key"] = chroma_key
        if composite is not None:
            self._values["composite"] = composite
        if compound is not None:
            self._values["compound"] = compound
        if contrast is not None:
            self._values["contrast"] = contrast
        if goop is not None:
            self._values["goop"] = goop
        if grayscale is not None:
            self._values["grayscale"] = grayscale
        if hsl is not None:
            self._values["hsl"] = hsl
        if hsv is not None:
            self._values["hsv"] = hsv
        if if_dimension is not None:
            self._values["if_dimension"] = if_dimension
        if if_orientation is not None:
            self._values["if_orientation"] = if_orientation
        if max_colors is not None:
            self._values["max_colors"] = max_colors
        if mirror is not None:
            self._values["mirror"] = mirror
        if mono_hue is not None:
            self._values["mono_hue"] = mono_hue
        if opacity is not None:
            self._values["opacity"] = opacity
        if remove_color is not None:
            self._values["remove_color"] = remove_color
        if unsharp_mask is not None:
            self._values["unsharp_mask"] = unsharp_mask

    @builtins.property
    def background_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationBackgroundColor"]]]:
        '''background_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        '''
        result = self._values.get("background_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationBackgroundColor"]]], result)

    @builtins.property
    def blur(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationBlur"]]]:
        '''blur block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        '''
        result = self._values.get("blur")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationBlur"]]], result)

    @builtins.property
    def chroma_key(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationChromaKey"]]]:
        '''chroma_key block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        '''
        result = self._values.get("chroma_key")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationChromaKey"]]], result)

    @builtins.property
    def composite(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationComposite"]]]:
        '''composite block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        '''
        result = self._values.get("composite")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationComposite"]]], result)

    @builtins.property
    def compound(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationCompound"]]]:
        '''compound block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        '''
        result = self._values.get("compound")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationCompound"]]], result)

    @builtins.property
    def contrast(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationContrast"]]]:
        '''contrast block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationContrast"]]], result)

    @builtins.property
    def goop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationGoop"]]]:
        '''goop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        '''
        result = self._values.get("goop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationGoop"]]], result)

    @builtins.property
    def grayscale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationGrayscale"]]]:
        '''grayscale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        '''
        result = self._values.get("grayscale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationGrayscale"]]], result)

    @builtins.property
    def hsl(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationHsl"]]]:
        '''hsl block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        '''
        result = self._values.get("hsl")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationHsl"]]], result)

    @builtins.property
    def hsv(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationHsv"]]]:
        '''hsv block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        '''
        result = self._values.get("hsv")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationHsv"]]], result)

    @builtins.property
    def if_dimension(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimension"]]]:
        '''if_dimension block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        '''
        result = self._values.get("if_dimension")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimension"]]], result)

    @builtins.property
    def if_orientation(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientation"]]]:
        '''if_orientation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        '''
        result = self._values.get("if_orientation")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientation"]]], result)

    @builtins.property
    def max_colors(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationMaxColors"]]]:
        '''max_colors block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        '''
        result = self._values.get("max_colors")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationMaxColors"]]], result)

    @builtins.property
    def mirror(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationMirror"]]]:
        '''mirror block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        '''
        result = self._values.get("mirror")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationMirror"]]], result)

    @builtins.property
    def mono_hue(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationMonoHue"]]]:
        '''mono_hue block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        '''
        result = self._values.get("mono_hue")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationMonoHue"]]], result)

    @builtins.property
    def opacity(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationOpacity"]]]:
        '''opacity block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationOpacity"]]], result)

    @builtins.property
    def remove_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationRemoveColor"]]]:
        '''remove_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        '''
        result = self._values.get("remove_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationRemoveColor"]]], result)

    @builtins.property
    def unsharp_mask(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationUnsharpMask"]]]:
        '''unsharp_mask block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        result = self._values.get("unsharp_mask")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationUnsharpMask"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationBackgroundColor",
    jsii_struct_bases=[],
    name_mapping={"color": "color", "color_var": "colorVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationBackgroundColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd3b2e38dfe2ffd5ed9d3575f18a9d22f16d0a6cf8a7d7734c1d5df24b1f05c8)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationBackgroundColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationBackgroundColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationBackgroundColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5c670d1c7792188a2f821ba12c24670836aeea06b94e06f12405a49273d60a87)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationBackgroundColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a697efddaddbea9e3161eff230e5ef34e76487897a1a89ff3dedbeeeb91e74a)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationBackgroundColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__87d268d59f0c66d20851cdde4b427250e1246813744f4838a3149c239f28da6e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9e607f375ac74738352aed861f1b89b018d5e273ad12e818d22666c85a76d3ed)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc5e9f926fab8aaf9800b751d98dab67f0167fe2242ba6e9d39104d981b42155)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationBackgroundColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationBackgroundColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bd611e9eafdcedb24ab5fbcdd2805157121caf22e4c6b8173320a51d88afb783)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationBackgroundColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationBackgroundColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f0562c87b4d55989e8a81e46b42f1ac7f892b5e33887676b2c3270d83437e1b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__40018fce9c395594c151cdbcfef8ed73576bc96f5d5a01c33128681faa2db608)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6d2fb59fe300b692130cfe575ad7cd6825ff3c8af0ea7b3a090436c52164357e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationBackgroundColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationBackgroundColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationBackgroundColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__14f66b516cfd15451fcd89a4d4d0155ce2eac6e8458bd0d7de90201d34e21a70)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationBlur",
    jsii_struct_bases=[],
    name_mapping={"sigma": "sigma", "sigma_var": "sigmaVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationBlur:
    def __init__(
        self,
        *,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param sigma: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1855417c117ab1cd4bb0707a2c37ad8860a0e1e20721a731bf3e5365eccdd53a)
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationBlur(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationBlurList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationBlurList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__818cbd31d1ad041695cc5289a46370a591550d04013cad6308e6143d2e790a05)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationBlurOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ad83c16c0a6164009419d0a5967c9c3d2e82bd50b200a8dcdd5eb554d417c32f)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationBlurOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0f21f49ba1e440ab5a417d5455b1b5f43f92a0472cdd9dc4ef45a5318ad48db4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ae4a405de956dcd5d3958a55e39ef850d795858433550a8f24a808b28b43ea51)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__92b8a84add5cdd4133f84e28d1b160cc4e9dad2ef5ef34fbb743f22a36774984)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationBlur]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationBlur]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__87e5ac896d6ac8028687be91ae2069e4a35eed7e510256f8c500e8c933a4cc83)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationBlurOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationBlurOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4093b1b960fce3850f538598b54296309a4cb4d85be690e5388f82bb1ee4663f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__601242082242ac7c01a8f8b9fa879aa550e4083811356e7c819f6040a701c15e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__21b55ba1ce8bcee02e00f7b6dd367904cd184f8a9bdefc6a096186c463264d44)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationBlur]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationBlur]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationBlur]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ec2718fa1b4a0b65575cf396f9c772752206ea168465c4075f4fa4a9ebfd7147)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationChromaKey",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_feather": "hueFeather",
        "hue_feather_var": "hueFeatherVar",
        "hue_tolerance": "hueTolerance",
        "hue_tolerance_var": "hueToleranceVar",
        "hue_var": "hueVar",
        "lightness_feather": "lightnessFeather",
        "lightness_feather_var": "lightnessFeatherVar",
        "lightness_tolerance": "lightnessTolerance",
        "lightness_tolerance_var": "lightnessToleranceVar",
        "saturation_feather": "saturationFeather",
        "saturation_feather_var": "saturationFeatherVar",
        "saturation_tolerance": "saturationTolerance",
        "saturation_tolerance_var": "saturationToleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationChromaKey:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_feather: typing.Optional[builtins.str] = None,
        hue_feather_var: typing.Optional[builtins.str] = None,
        hue_tolerance: typing.Optional[builtins.str] = None,
        hue_tolerance_var: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness_feather: typing.Optional[builtins.str] = None,
        lightness_feather_var: typing.Optional[builtins.str] = None,
        lightness_tolerance: typing.Optional[builtins.str] = None,
        lightness_tolerance_var: typing.Optional[builtins.str] = None,
        saturation_feather: typing.Optional[builtins.str] = None,
        saturation_feather_var: typing.Optional[builtins.str] = None,
        saturation_tolerance: typing.Optional[builtins.str] = None,
        saturation_tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_feather: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        :param hue_feather_var: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        :param hue_tolerance: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        :param hue_tolerance_var: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        :param hue_var: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness_feather: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        :param lightness_feather_var: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        :param lightness_tolerance: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        :param lightness_tolerance_var: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        :param saturation_feather: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        :param saturation_feather_var: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        :param saturation_tolerance: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        :param saturation_tolerance_var: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__354b1c511b2093dd6200df0b478125ddff1e8fa2c29988c782a79a57341e3018)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_feather", value=hue_feather, expected_type=type_hints["hue_feather"])
            check_type(argname="argument hue_feather_var", value=hue_feather_var, expected_type=type_hints["hue_feather_var"])
            check_type(argname="argument hue_tolerance", value=hue_tolerance, expected_type=type_hints["hue_tolerance"])
            check_type(argname="argument hue_tolerance_var", value=hue_tolerance_var, expected_type=type_hints["hue_tolerance_var"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness_feather", value=lightness_feather, expected_type=type_hints["lightness_feather"])
            check_type(argname="argument lightness_feather_var", value=lightness_feather_var, expected_type=type_hints["lightness_feather_var"])
            check_type(argname="argument lightness_tolerance", value=lightness_tolerance, expected_type=type_hints["lightness_tolerance"])
            check_type(argname="argument lightness_tolerance_var", value=lightness_tolerance_var, expected_type=type_hints["lightness_tolerance_var"])
            check_type(argname="argument saturation_feather", value=saturation_feather, expected_type=type_hints["saturation_feather"])
            check_type(argname="argument saturation_feather_var", value=saturation_feather_var, expected_type=type_hints["saturation_feather_var"])
            check_type(argname="argument saturation_tolerance", value=saturation_tolerance, expected_type=type_hints["saturation_tolerance"])
            check_type(argname="argument saturation_tolerance_var", value=saturation_tolerance_var, expected_type=type_hints["saturation_tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_feather is not None:
            self._values["hue_feather"] = hue_feather
        if hue_feather_var is not None:
            self._values["hue_feather_var"] = hue_feather_var
        if hue_tolerance is not None:
            self._values["hue_tolerance"] = hue_tolerance
        if hue_tolerance_var is not None:
            self._values["hue_tolerance_var"] = hue_tolerance_var
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness_feather is not None:
            self._values["lightness_feather"] = lightness_feather
        if lightness_feather_var is not None:
            self._values["lightness_feather_var"] = lightness_feather_var
        if lightness_tolerance is not None:
            self._values["lightness_tolerance"] = lightness_tolerance
        if lightness_tolerance_var is not None:
            self._values["lightness_tolerance_var"] = lightness_tolerance_var
        if saturation_feather is not None:
            self._values["saturation_feather"] = saturation_feather
        if saturation_feather_var is not None:
            self._values["saturation_feather_var"] = saturation_feather_var
        if saturation_tolerance is not None:
            self._values["saturation_tolerance"] = saturation_tolerance
        if saturation_tolerance_var is not None:
            self._values["saturation_tolerance_var"] = saturation_tolerance_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        '''
        result = self._values.get("hue_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        '''
        result = self._values.get("hue_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        '''
        result = self._values.get("hue_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        '''
        result = self._values.get("hue_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        '''
        result = self._values.get("lightness_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        '''
        result = self._values.get("lightness_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        '''
        result = self._values.get("lightness_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        '''
        result = self._values.get("lightness_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        '''
        result = self._values.get("saturation_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        '''
        result = self._values.get("saturation_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        '''
        result = self._values.get("saturation_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        result = self._values.get("saturation_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationChromaKey(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationChromaKeyList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationChromaKeyList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a81ac16586e935b035fe69eab6bf5b483d5823155f86f28359e63997f4f04eb5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationChromaKeyOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1e3beaf0afe35c725fa84dfc624c80a2c994e1fa90d8999b897f3717abe00bc5)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationChromaKeyOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__56b591354cef1a12d8953489482c1e3254496efedb6a09b687c10e816d788d40)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fdb4ac0e50241716383c552221952dedb6937777bdacafad15306aaa2e23d5f5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6db078f2a1664ac312599447b35db4aeb952ce74e0436fc943512fddc8d586af)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationChromaKey]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationChromaKey]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ec61d9d2cd2940857cf671e92e8d37df6b8bdcfdafe095e7ba0128cfb710b35)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationChromaKeyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationChromaKeyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e4a1f0ff04c9b24ddfbf299805455e9f71a3523db257daf993093431184d806c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueFeather")
    def reset_hue_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeather", []))

    @jsii.member(jsii_name="resetHueFeatherVar")
    def reset_hue_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeatherVar", []))

    @jsii.member(jsii_name="resetHueTolerance")
    def reset_hue_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueTolerance", []))

    @jsii.member(jsii_name="resetHueToleranceVar")
    def reset_hue_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueToleranceVar", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightnessFeather")
    def reset_lightness_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeather", []))

    @jsii.member(jsii_name="resetLightnessFeatherVar")
    def reset_lightness_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeatherVar", []))

    @jsii.member(jsii_name="resetLightnessTolerance")
    def reset_lightness_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessTolerance", []))

    @jsii.member(jsii_name="resetLightnessToleranceVar")
    def reset_lightness_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessToleranceVar", []))

    @jsii.member(jsii_name="resetSaturationFeather")
    def reset_saturation_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeather", []))

    @jsii.member(jsii_name="resetSaturationFeatherVar")
    def reset_saturation_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeatherVar", []))

    @jsii.member(jsii_name="resetSaturationTolerance")
    def reset_saturation_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationTolerance", []))

    @jsii.member(jsii_name="resetSaturationToleranceVar")
    def reset_saturation_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherInput")
    def hue_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVarInput")
    def hue_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceInput")
    def hue_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVarInput")
    def hue_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherInput")
    def lightness_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVarInput")
    def lightness_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceInput")
    def lightness_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVarInput")
    def lightness_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherInput")
    def saturation_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVarInput")
    def saturation_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceInput")
    def saturation_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVarInput")
    def saturation_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b5467e1c772ecb331f615ae44788b3ad59ee4ddd8a6beabce63dad74dd6c2f98)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeather")
    def hue_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeather"))

    @hue_feather.setter
    def hue_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__74c180bd9f8465ccfa4f0a5c1ce769fa003d1f5570aba9f16a57de3d5eaac0ad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeather", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVar")
    def hue_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeatherVar"))

    @hue_feather_var.setter
    def hue_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__62b5286710af52346524673b808bea5ca595f06419d45640f63569cded838180)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueTolerance")
    def hue_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueTolerance"))

    @hue_tolerance.setter
    def hue_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e58f9b8bbede3cc06ad159a286155ba5f97b547d8217cd5db511dde6484317d9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVar")
    def hue_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueToleranceVar"))

    @hue_tolerance_var.setter
    def hue_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6a51b5e47dcdb803a3101d64578ff38388e79448d38808423dc9387d960848c3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__00456b2023b539beadd4355b37b12088cec5b90a8c5b7318e7e8e1d2cf032e2b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeather")
    def lightness_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeather"))

    @lightness_feather.setter
    def lightness_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__baf3894b15869a2bcaef0992d86d8d63679ac27d12d86f3d411e2716b056e7dc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeather", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVar")
    def lightness_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeatherVar"))

    @lightness_feather_var.setter
    def lightness_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d188ba066d1d011ce8b4ab0eaa3726ed934ae6641b9fb8a32c1329feec2315e8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessTolerance")
    def lightness_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessTolerance"))

    @lightness_tolerance.setter
    def lightness_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1927558053f8e2deb6907e4cb94d2db35a9a06da1b2f88ecbbf791f8748e98e5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVar")
    def lightness_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessToleranceVar"))

    @lightness_tolerance_var.setter
    def lightness_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7f421164fcb2d5483210d7e634aa3bc785948c6080e7e6208ce3c67409cbd852)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeather")
    def saturation_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeather"))

    @saturation_feather.setter
    def saturation_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cc98fe159a1913872982465acb7c26c9e1d82a02ddc5e5a222bca5b7765a7ec3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeather", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVar")
    def saturation_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeatherVar"))

    @saturation_feather_var.setter
    def saturation_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d9083c6d68580e3df8c1bb73302c16dfdd9172b56ce3b10db3ecb27f4164ff9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationTolerance")
    def saturation_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationTolerance"))

    @saturation_tolerance.setter
    def saturation_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5a6e9a5ee24ca5752dd7c392deffd6c3cc1ffc7b5400db68d2116616a478e273)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVar")
    def saturation_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationToleranceVar"))

    @saturation_tolerance_var.setter
    def saturation_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5d37a6bbfd6cd746710d4be747c35bec6b64a72ec7e3f3af6868edbcba70251b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationChromaKey]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationChromaKey]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationChromaKey]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__25cacf61fedf6e0115417bae0aab22081e2496ebd27a58355b8f25eb169574c9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationComposite",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "placement": "placement",
        "placement_var": "placementVar",
        "scale": "scale",
        "scale_dimension": "scaleDimension",
        "scale_dimension_var": "scaleDimensionVar",
        "scale_var": "scaleVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationComposite:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationCompositeImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        placement: typing.Optional[builtins.str] = None,
        placement_var: typing.Optional[builtins.str] = None,
        scale: typing.Optional[builtins.str] = None,
        scale_dimension: typing.Optional[builtins.str] = None,
        scale_dimension_var: typing.Optional[builtins.str] = None,
        scale_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param placement: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        :param placement_var: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        :param scale: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param scale_dimension: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        :param scale_dimension_var: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        :param scale_var: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        :param x_position: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationCompositeImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ade6ca27cce3aa50e706835fde18e333a55bcedb472fa26b14494d006f45a8d0)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument placement", value=placement, expected_type=type_hints["placement"])
            check_type(argname="argument placement_var", value=placement_var, expected_type=type_hints["placement_var"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument scale_dimension", value=scale_dimension, expected_type=type_hints["scale_dimension"])
            check_type(argname="argument scale_dimension_var", value=scale_dimension_var, expected_type=type_hints["scale_dimension_var"])
            check_type(argname="argument scale_var", value=scale_var, expected_type=type_hints["scale_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if placement is not None:
            self._values["placement"] = placement
        if placement_var is not None:
            self._values["placement_var"] = placement_var
        if scale is not None:
            self._values["scale"] = scale
        if scale_dimension is not None:
            self._values["scale_dimension"] = scale_dimension
        if scale_dimension_var is not None:
            self._values["scale_dimension_var"] = scale_dimension_var
        if scale_var is not None:
            self._values["scale_var"] = scale_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationCompositeImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationCompositeImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        '''
        result = self._values.get("placement")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement_var(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        '''
        result = self._values.get("placement_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        '''
        result = self._values.get("scale_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        '''
        result = self._values.get("scale_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        '''
        result = self._values.get("scale_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationComposite(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationCompositeImage",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationCompositeImage:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationCompositeImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationCompositeImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationCompositeImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f40a2b31cb8f512f786d9604467effabae40108a105d50d33c33361c74741803)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationCompositeImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationCompositeImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5d30d70e27fb456088754ba1da7491f7b8a3f8ddb52cf02ebef4ecf5d0329e4f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationCompositeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationCompositeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aa73112c8acdcde30fbb860cba4862c177d68ac90767dc2f942935f1fb13f4b7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationCompositeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4c21f6deea8aefface0cb3a18dd3c7da449fc3681270f1a6f1f2395f241f41a2)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationCompositeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__616125d4e1adce896e2ffe1278cbd5cacbbcab6a7131ae8a5ab9adf5b4fbe6e2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9f87cff3814ae825a5021c55267df8a0ca8d22340ba1252f25a5f43a05870bef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ccfa573362d0f7544ad2d5db78fe34f62d6e5fba05da78137bb9cff3dabc36ee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationComposite]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationComposite]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cbd2d41359af69781ae6464c8d1c6648c8aa586bcd078b51b1b99cfd061733af)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationCompositeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationCompositeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__59c7cebc14c4cadca26c992d69e55b6ae2b4864efa7a09bfd3b4dfad0f4b1911)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationCompositeImage()

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPlacement")
    def reset_placement(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacement", []))

    @jsii.member(jsii_name="resetPlacementVar")
    def reset_placement_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacementVar", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetScaleDimension")
    def reset_scale_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimension", []))

    @jsii.member(jsii_name="resetScaleDimensionVar")
    def reset_scale_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimensionVar", []))

    @jsii.member(jsii_name="resetScaleVar")
    def reset_scale_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationCompositeImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationCompositeImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationCompositeImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="placementInput")
    def placement_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementInput"))

    @builtins.property
    @jsii.member(jsii_name="placementVarInput")
    def placement_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionInput")
    def scale_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVarInput")
    def scale_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleVarInput")
    def scale_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4b8fbb5ba5bf500fa2f0c05746d6a4174e0091b1e3833ec64f39641bdac5da51)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__865891c766994b481172e275c0ded8b4acea8f28b5311951c67d6f433ae3efb4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="placement")
    def placement(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placement"))

    @placement.setter
    def placement(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7db20e7a9ba5223b425edbf03c8853e459c86715833b0ab3bc7792b6d19647ae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placement", value)

    @builtins.property
    @jsii.member(jsii_name="placementVar")
    def placement_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placementVar"))

    @placement_var.setter
    def placement_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__543c648ec973c8780a9bb8c9c17383c44fa6700487ec3456df040fea261bb113)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placementVar", value)

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scale"))

    @scale.setter
    def scale(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea7c6ef7e926c1901fb13cfc5b730bbf346bf3cedaa0b0855fc0bea974ef3525)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scale", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimension")
    def scale_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimension"))

    @scale_dimension.setter
    def scale_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__08fb530b572d1882928b5e76e0c58f2a4ab4004be930429c4eabd24d5645c2f9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimension", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVar")
    def scale_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimensionVar"))

    @scale_dimension_var.setter
    def scale_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__010c6d1ed4ad4234139735ea33be8a810b8818a0e1f656ef2b2a95886606c99e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="scaleVar")
    def scale_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleVar"))

    @scale_var.setter
    def scale_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6d127d2523bac2c03330f01313ddd512adfa5226dbb1c109e2d9c3435f4d883a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__35dec374c34a80cca3073ea1dce7bb2d8a1abd555e1cb7aec2b885b0cf00bf48)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__03f5b5ee573ee96bd2ee540a00d6d3624318055b75d19752bef6ef8c4f615a01)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__083b61943456d32e6bea368fed70469604572bc4744882174ddc34989c5d5f32)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__33f1c75e4baa79ade28810e3e24c4c78e8292057e85fc4dbcd2ce7a2bb6d2a76)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationComposite]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationComposite]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationComposite]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__178466af9477fe83f2d8bde89b8bd6a383b729482ba947adb9c3dcbad4c736c8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationCompound",
    jsii_struct_bases=[],
    name_mapping={"transformations": "transformations"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationCompound:
    def __init__(
        self,
        *,
        transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param transformations: transformations block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f45da4ad82c576d3e41c02e52298d9e7e5d5e070a0d0b90ef58df3032bae1554)
            check_type(argname="argument transformations", value=transformations, expected_type=type_hints["transformations"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if transformations is not None:
            self._values["transformations"] = transformations

    @builtins.property
    def transformations(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationCompoundTransformations"]]]:
        '''transformations block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        result = self._values.get("transformations")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationCompoundTransformations"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationCompound(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationCompoundList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationCompoundList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f7ed6a7a1c05f8bc1b26c5ccbb7f05fef358a0c6fa827b6fd2818b3e295b5ba4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationCompoundOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f2c77fb71d8075f6fd9d26dea49ccf70bb6eb624e1ddf28bca6041ff4c1a3c6c)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationCompoundOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7c6ce0b62fd1d1509fcd7bd6b1cc5672cac9db2a2d767d491c48bf93b3ad89a5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eec68300a6fe6da19fcf111e58fd9796081ce40ecb829a3cd36fa2e7be563658)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d77d2fd9405fe27948bed2cfe17b3a3496cd846fa01e833298141c1589f97987)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationCompound]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationCompound]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0da511d89c052f29322b7fcd658fd6888418121fce5a2f702fdfafc9fcd81882)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationCompoundOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationCompoundOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ea283026488b309ca06fff3e73cc6866b0692228c6a69d8c18813c33c4d7623)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformations")
    def put_transformations(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__636fcedfe0e976cffd06659f970db7e47cd3827c0a8e6e2423273b337fab6f4b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTransformations", [value]))

    @jsii.member(jsii_name="resetTransformations")
    def reset_transformations(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformations", []))

    @builtins.property
    @jsii.member(jsii_name="transformations")
    def transformations(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationCompoundTransformationsList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationCompoundTransformationsList", jsii.get(self, "transformations"))

    @builtins.property
    @jsii.member(jsii_name="transformationsInput")
    def transformations_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationCompoundTransformations"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationCompoundTransformations"]]], jsii.get(self, "transformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationCompound]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationCompound]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationCompound]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2b8a2b03812044d725a869e0da2ef33b8b97683451fe984d2449902cfacb179e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationCompoundTransformations",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationCompoundTransformations:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationCompoundTransformations(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationCompoundTransformationsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationCompoundTransformationsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__44690673bd2c88fa78110ca29b5f662b561dab896ba11d3c3390dab1bc447c95)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationCompoundTransformationsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7a1e73043e6729e6503b2f4253ff979e35131f1d0ca05d83370a55a86815166b)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationCompoundTransformationsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bff04c95b8ad16fcd8e83e72eb7acccecdeaf1dfb85c8186ce0a7cfb5dbfddd0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__54bbded1ba57fb021c61010ce189eb5c4428188391097599f6d7fa625623e54b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__924b1b221e8da626cb8bbb279f73addae55ca37e9496e274aabd40a9cd45b002)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationCompoundTransformations]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationCompoundTransformations]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationCompoundTransformations]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__80ec4859478df7a16cb4c8b0baca9ff2fc397ac40dc389c04dbf2bc1173ea474)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationCompoundTransformationsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationCompoundTransformationsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5d4f3b6e539f390cb6b963a9a47acc16bd39f6f9761e8e21858b0e226bd7ab38)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationCompoundTransformations]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationCompoundTransformations]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationCompoundTransformations]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__29d57a1856b91e83575941491ca8b5e10debc12cfe79805592af3f8686be4301)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationContrast",
    jsii_struct_bases=[],
    name_mapping={
        "brightness": "brightness",
        "brightness_var": "brightnessVar",
        "contrast": "contrast",
        "contrast_var": "contrastVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationContrast:
    def __init__(
        self,
        *,
        brightness: typing.Optional[builtins.str] = None,
        brightness_var: typing.Optional[builtins.str] = None,
        contrast: typing.Optional[builtins.str] = None,
        contrast_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param brightness: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        :param brightness_var: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        :param contrast: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param contrast_var: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f75980ab9ef918fdf6a1a330d8bf1ea5e0c33da98e00efd6cc2937c92e37fb1f)
            check_type(argname="argument brightness", value=brightness, expected_type=type_hints["brightness"])
            check_type(argname="argument brightness_var", value=brightness_var, expected_type=type_hints["brightness_var"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument contrast_var", value=contrast_var, expected_type=type_hints["contrast_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if brightness is not None:
            self._values["brightness"] = brightness
        if brightness_var is not None:
            self._values["brightness_var"] = brightness_var
        if contrast is not None:
            self._values["contrast"] = contrast
        if contrast_var is not None:
            self._values["contrast_var"] = contrast_var

    @builtins.property
    def brightness(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        '''
        result = self._values.get("brightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def brightness_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        '''
        result = self._values.get("brightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        result = self._values.get("contrast_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationContrast(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationContrastList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationContrastList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a96cca5970db039d1ce761491e6e837ddcad476fff3c720272671a955f2a304)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationContrastOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fd0857b6ef146987a1b2252fbe026cd9f3fe3455b7f81072cfe25822577758bf)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationContrastOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aaac040964db9f148768399037ac393f017b2614cd35081ab527c68c883356ab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__219e2d35e13a23f6b35ab99ca448890e24eba747b2129590e4ea0b272d20a42c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c3f42c940d99e1237dbc89ca4412d461b65a5577485b6679b6edc9a448416abe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationContrast]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationContrast]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d2ed9ee6685b105dafede8ad1b57f86ec1fe701f7b9d04b75eecb47ad89a75d2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationContrastOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationContrastOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a5368356c26b99739f42bd5baab2d80ba4c5cc0cc9c673dacaf610d6f114ace)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetBrightness")
    def reset_brightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightness", []))

    @jsii.member(jsii_name="resetBrightnessVar")
    def reset_brightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightnessVar", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetContrastVar")
    def reset_contrast_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrastVar", []))

    @builtins.property
    @jsii.member(jsii_name="brightnessInput")
    def brightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="brightnessVarInput")
    def brightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastVarInput")
    def contrast_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="brightness")
    def brightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightness"))

    @brightness.setter
    def brightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cb84073f92e6029df0aac64852355feebe56f745e6e9f7bb7db73a18155aecda)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightness", value)

    @builtins.property
    @jsii.member(jsii_name="brightnessVar")
    def brightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightnessVar"))

    @brightness_var.setter
    def brightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__23d7a57e6692bd683807f8d0a86a515d5ff535388ba71765bb05d95b4c229efa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrast"))

    @contrast.setter
    def contrast(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6a26d5e14f4454c568a78207628fc70767ae611be33eed4650df94119c36151e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrast", value)

    @builtins.property
    @jsii.member(jsii_name="contrastVar")
    def contrast_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrastVar"))

    @contrast_var.setter
    def contrast_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a72bb8c4b695e382ef91bcc08280620186d0bae0bbb55ee5c42bdc0cc28e7a05)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrastVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationContrast]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationContrast]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationContrast]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__62be4e2314e8304f5101d9d56c9db7757e7cbd0b0a5a357f23428973fb3f605f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationGoop",
    jsii_struct_bases=[],
    name_mapping={
        "chaos": "chaos",
        "chaos_var": "chaosVar",
        "density": "density",
        "density_var": "densityVar",
        "power": "power",
        "power_var": "powerVar",
        "seed": "seed",
        "seed_var": "seedVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationGoop:
    def __init__(
        self,
        *,
        chaos: typing.Optional[builtins.str] = None,
        chaos_var: typing.Optional[builtins.str] = None,
        density: typing.Optional[builtins.str] = None,
        density_var: typing.Optional[builtins.str] = None,
        power: typing.Optional[builtins.str] = None,
        power_var: typing.Optional[builtins.str] = None,
        seed: typing.Optional[builtins.str] = None,
        seed_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param chaos: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        :param chaos_var: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        :param density: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        :param density_var: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        :param power: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        :param power_var: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        :param seed: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        :param seed_var: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ec18be64f0fa8b9cc30183aa0c114d200517cb27b162861e42e9560e2695eb3)
            check_type(argname="argument chaos", value=chaos, expected_type=type_hints["chaos"])
            check_type(argname="argument chaos_var", value=chaos_var, expected_type=type_hints["chaos_var"])
            check_type(argname="argument density", value=density, expected_type=type_hints["density"])
            check_type(argname="argument density_var", value=density_var, expected_type=type_hints["density_var"])
            check_type(argname="argument power", value=power, expected_type=type_hints["power"])
            check_type(argname="argument power_var", value=power_var, expected_type=type_hints["power_var"])
            check_type(argname="argument seed", value=seed, expected_type=type_hints["seed"])
            check_type(argname="argument seed_var", value=seed_var, expected_type=type_hints["seed_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if chaos is not None:
            self._values["chaos"] = chaos
        if chaos_var is not None:
            self._values["chaos_var"] = chaos_var
        if density is not None:
            self._values["density"] = density
        if density_var is not None:
            self._values["density_var"] = density_var
        if power is not None:
            self._values["power"] = power
        if power_var is not None:
            self._values["power_var"] = power_var
        if seed is not None:
            self._values["seed"] = seed
        if seed_var is not None:
            self._values["seed_var"] = seed_var

    @builtins.property
    def chaos(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        '''
        result = self._values.get("chaos")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def chaos_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        '''
        result = self._values.get("chaos_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        '''
        result = self._values.get("density")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density_var(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        '''
        result = self._values.get("density_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        '''
        result = self._values.get("power")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power_var(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        '''
        result = self._values.get("power_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        '''
        result = self._values.get("seed")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed_var(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        result = self._values.get("seed_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationGoop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationGoopList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationGoopList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a4def1f1de59ab868e0654f6a708f709a689a74e8bf287074809e9ff06b7144)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationGoopOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__65f6c654f0265043195d4c746ebd6f43c78cfe08efba725c0b01010ccd98ad7e)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationGoopOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__75372c5de13a13b1f754a163e4b6d50e824ef12662cda1a49e6c23b4cb050df7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b97e69fe6955a337048553989fcc449e5708e87c6c41e53245b165654f47f77e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b157c6643cbc207d742a6fab0f735d0afbd4c5de2996858d1254596c8750dd93)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationGoop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationGoop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__30bb2717098e81d92c4b845ba0c9618a0dfa46f3b50c58251f714d25a58b8fbb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationGoopOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationGoopOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b96d9697f41a2ca4a25f61bf810f5bb923a5daabc6b26f7c70b622807faf3eeb)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetChaos")
    def reset_chaos(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaos", []))

    @jsii.member(jsii_name="resetChaosVar")
    def reset_chaos_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaosVar", []))

    @jsii.member(jsii_name="resetDensity")
    def reset_density(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensity", []))

    @jsii.member(jsii_name="resetDensityVar")
    def reset_density_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensityVar", []))

    @jsii.member(jsii_name="resetPower")
    def reset_power(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPower", []))

    @jsii.member(jsii_name="resetPowerVar")
    def reset_power_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPowerVar", []))

    @jsii.member(jsii_name="resetSeed")
    def reset_seed(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeed", []))

    @jsii.member(jsii_name="resetSeedVar")
    def reset_seed_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeedVar", []))

    @builtins.property
    @jsii.member(jsii_name="chaosInput")
    def chaos_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosInput"))

    @builtins.property
    @jsii.member(jsii_name="chaosVarInput")
    def chaos_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosVarInput"))

    @builtins.property
    @jsii.member(jsii_name="densityInput")
    def density_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityInput"))

    @builtins.property
    @jsii.member(jsii_name="densityVarInput")
    def density_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="powerInput")
    def power_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerInput"))

    @builtins.property
    @jsii.member(jsii_name="powerVarInput")
    def power_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerVarInput"))

    @builtins.property
    @jsii.member(jsii_name="seedInput")
    def seed_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedInput"))

    @builtins.property
    @jsii.member(jsii_name="seedVarInput")
    def seed_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedVarInput"))

    @builtins.property
    @jsii.member(jsii_name="chaos")
    def chaos(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaos"))

    @chaos.setter
    def chaos(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__90093e265f46484284bed96f652294db65db354e2a819ea59b13a745071d6515)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaos", value)

    @builtins.property
    @jsii.member(jsii_name="chaosVar")
    def chaos_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaosVar"))

    @chaos_var.setter
    def chaos_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f244d959ee5fe3770348c9025082394af6939d506692edf73cb913526226c9bf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaosVar", value)

    @builtins.property
    @jsii.member(jsii_name="density")
    def density(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "density"))

    @density.setter
    def density(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9065325cc6603e63f72a733bf64a050c0a4b5b14a9cdc97b6c4c48ccba42723d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "density", value)

    @builtins.property
    @jsii.member(jsii_name="densityVar")
    def density_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "densityVar"))

    @density_var.setter
    def density_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b013d13e70b2676b33d28ce34b2e91f5afbd71548e63062b5d578eb5dc9524df)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "densityVar", value)

    @builtins.property
    @jsii.member(jsii_name="power")
    def power(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "power"))

    @power.setter
    def power(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__47eb53d0e6538af541dff7f48372c1a4832baf4b2ad36bfacea1d2f831dde517)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "power", value)

    @builtins.property
    @jsii.member(jsii_name="powerVar")
    def power_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "powerVar"))

    @power_var.setter
    def power_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c4f3fe770d2f4da7ddfc7bcf22f4fb937f63d6db73afd6dd42980df8583ad5e2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "powerVar", value)

    @builtins.property
    @jsii.member(jsii_name="seed")
    def seed(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seed"))

    @seed.setter
    def seed(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2b0a078a19a05f83c3e11d0160ecc4728373f875ebf21d31a2baa4ec5d011bec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seed", value)

    @builtins.property
    @jsii.member(jsii_name="seedVar")
    def seed_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seedVar"))

    @seed_var.setter
    def seed_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9cd817602cec308554d797fa9a74aab39b172e8b272e895a23a71a786bbee304)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seedVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationGoop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationGoop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationGoop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a1ac0f91093914261683418d0fec303093b11c41bbc21080512f0e76295e6f8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationGrayscale",
    jsii_struct_bases=[],
    name_mapping={"type": "type", "type_var": "typeVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationGrayscale:
    def __init__(
        self,
        *,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param type: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__091e48c6f1f0ac338561bab12e4ab3fcbc8788cee285d80bde30b14701c4f7ba)
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationGrayscale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationGrayscaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationGrayscaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8eb2591efe135126298c15c81a35361af8fbde9dfe1e19599cb9b6db9960d4ca)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationGrayscaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac83130bd6f7a3528c49d898151f273af95bc5f6df15dc760473b6c7ddfc431a)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationGrayscaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5fbf52e76816c1ffc8ec76053f3ed0f49e9283e897b36ca6b7359de8e8350f7e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__69297025b16b27cb999e64fed1d81412d6a7e4bf1b4b8958a72e4282e446173a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f26d03b6a2c7f71960121f7b016b24752abc198c3aa9e8b9daa60e3de2f6b0f5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationGrayscale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationGrayscale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2fa01d9aaa693e8622b4d63aa66627a4926dd7bd14c8471b355d57d40d5f39c2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationGrayscaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationGrayscaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0905a01aef554c90e820dd60908966e388a50ce155423f2e420e29bedee63214)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a990448a5ce60bdefadcde6e8956f9b3c380e20294405ec69e9a9c97d9b6f32)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a9784ef1499b2f17b1efcc2bf6816f4ae36c42e5f2b60df00643b4ded4e0b00)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationGrayscale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationGrayscale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationGrayscale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__76e241bce9727ef4fb534abb2d134e393d853ede179ef0b49f658679d729e081)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationHsl",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "lightness": "lightness",
        "lightness_var": "lightnessVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationHsl:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness: typing.Optional[builtins.str] = None,
        lightness_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        :param lightness_var: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3afa630941a9e8c66558ea5f8d103374a8457d315a4f36c2c0e910e1a7d15f7a)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness", value=lightness, expected_type=type_hints["lightness"])
            check_type(argname="argument lightness_var", value=lightness_var, expected_type=type_hints["lightness_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness is not None:
            self._values["lightness"] = lightness
        if lightness_var is not None:
            self._values["lightness_var"] = lightness_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        '''
        result = self._values.get("lightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        '''
        result = self._values.get("lightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationHsl(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationHslList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationHslList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dcf1dd7edc2915c9f7b63706c85022135e2b3bff29c9289f6cb902826f3c6630)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationHslOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d96a8296c8e63a456c2b9c1cf13ce3b31e96d23bdf168ed1805c56326d4f3b9a)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationHslOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__59dd153dc44c3a423961f7d1b7b556f6a3d335fd023ec12b453068323657ae0e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__63177f580ce55e8791ec719775b45ffc1a5356d8531b812edba50cdf80189801)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0796f7028e49c9f5fe0042b095f6f96c5a75e01dab1e39d5493118725658ed43)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationHsl]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationHsl]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__293f5dc43b7201a6a546a268aa50656d4a8934471e4151572bff15f21a981e60)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationHslOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationHslOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__00da61606105f832a8518b98c5a112d6bbae52b01dc64aa9757f6390a2f21fa2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightness")
    def reset_lightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightness", []))

    @jsii.member(jsii_name="resetLightnessVar")
    def reset_lightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessInput")
    def lightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessVarInput")
    def lightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d250f66952f7cffd55f6e0cfb9292d8e71435807555f57f4038bc70203da33b4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__562867db2089d940c366a8043c2a2e585ca99d9a73b6d26af320523d9b220f8c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightness")
    def lightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightness"))

    @lightness.setter
    def lightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f002fe49c52876db99fa5140e939d54e3f2c4548e156c30898f5daa9125d09fd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightness", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessVar")
    def lightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessVar"))

    @lightness_var.setter
    def lightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4784cd8783bbd9efdc166c81ceb1c5df7e5041401902d9d54d6f9285c19372ba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7ff57dd9937348fdfe4f647839d10fa74591da4c3d4b965a715d4d732e37c978)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__57205ddc8b6801d0524e021c62629b274ac8d4d1b03c57c8847059c2c1086152)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationHsl]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationHsl]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationHsl]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__acedd5eb7f67c6e7369ed51c47210efe362b874454a22b4b740d7fbca6d1ff07)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationHsv",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationHsv:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        :param value: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab5a6979e2d7f01a6ff6078da2010913d3d62bc72b104d630a108e4ad527ae34)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationHsv(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationHsvList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationHsvList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b0153091adaea502c106bcad4d88021c5a72c24cf3571fb7148c29a77d0a31a3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationHsvOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__661643f76b5b699cfe383196679f3a0d788afc218ca03d55b15721a165bd831b)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationHsvOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__527537d6d715d4ec556cf1e5f275ca65a8b605866fa62996c438b22dd8e5d1ac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e5f7b97ef4e4d84c88cdce056b354a09378216da2375d1908dce315703ce93e3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1be65c6e3e2ba120b787c415845a796b5e4e80d99e10c7a72c3d6aa15b56bc17)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationHsv]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationHsv]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb04c14fdc9f6af4f745341b3caf13aa762e0de800eb93e7575ecb1a4fb2b9d3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationHsvOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationHsvOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fe39a71a8cde3711d1d3172309581cbaa02a07c8b07f6c0f20f68d9947788ad2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8d5f2a99c5853d4e175df91c990235ae05c4eb9185bb1bc51b507a3f1bc851cf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b5cbc2d733fbe37c5f8fd5d4af94bd6b24b515449fdd4e258366967872646311)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5663df2929c04d9c61288cf84cfff0a730c7510f5268fb0eff5a5af0447de277)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e836982babf27b8e6232e74875dc0202421df41d5da5e1a6ccf29637542780d4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__65f141fa72f7ceeb18b9bb00aad88cf14de11aca2a293b85e0145d9fa7af2eb3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__62cce188d1a45718455dc7f768a8bd3cc9c75d728df8385b6ee73019486211e0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationHsv]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationHsv]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationHsv]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__de128c049fb5b46953c1ef73e9ecf7d7266db34bdfc4f0c8c7772614bf19ca1b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimension",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "dimension": "dimension",
        "dimension_var": "dimensionVar",
        "equal": "equal",
        "greater_than": "greaterThan",
        "less_than": "lessThan",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimension:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimensionDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        dimension: typing.Optional[builtins.str] = None,
        dimension_var: typing.Optional[builtins.str] = None,
        equal: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimensionEqual", typing.Dict[builtins.str, typing.Any]]] = None,
        greater_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimensionGreaterThan", typing.Dict[builtins.str, typing.Any]]] = None,
        less_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimensionLessThan", typing.Dict[builtins.str, typing.Any]]] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param dimension: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        :param dimension_var: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        :param equal: equal block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        :param greater_than: greater_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        :param less_than: less_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        :param value: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimensionDefault(**default)
        if isinstance(equal, dict):
            equal = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimensionEqual(**equal)
        if isinstance(greater_than, dict):
            greater_than = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimensionGreaterThan(**greater_than)
        if isinstance(less_than, dict):
            less_than = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimensionLessThan(**less_than)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5d15ad4143c51b89b6a70f1f84668a3d765d0e5bea04d2e173d65d0935a5ee8e)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument dimension", value=dimension, expected_type=type_hints["dimension"])
            check_type(argname="argument dimension_var", value=dimension_var, expected_type=type_hints["dimension_var"])
            check_type(argname="argument equal", value=equal, expected_type=type_hints["equal"])
            check_type(argname="argument greater_than", value=greater_than, expected_type=type_hints["greater_than"])
            check_type(argname="argument less_than", value=less_than, expected_type=type_hints["less_than"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if dimension is not None:
            self._values["dimension"] = dimension
        if dimension_var is not None:
            self._values["dimension_var"] = dimension_var
        if equal is not None:
            self._values["equal"] = equal
        if greater_than is not None:
            self._values["greater_than"] = greater_than
        if less_than is not None:
            self._values["less_than"] = less_than
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimensionDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimensionDefault"], result)

    @builtins.property
    def dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        '''
        result = self._values.get("dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        '''
        result = self._values.get("dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def equal(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimensionEqual"]:
        '''equal block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        '''
        result = self._values.get("equal")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimensionEqual"], result)

    @builtins.property
    def greater_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimensionGreaterThan"]:
        '''greater_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        '''
        result = self._values.get("greater_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimensionGreaterThan"], result)

    @builtins.property
    def less_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimensionLessThan"]:
        '''less_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        '''
        result = self._values.get("less_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimensionLessThan"], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimension(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimensionDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimensionDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimensionDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimensionDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimensionDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__68a9ca553e11ffce9b87cdaa7fe4781f4dcacbe1465b9ecb64492473f98460fc)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimensionDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimensionDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dc41421a63074a18db54133c10710d1d9b8f93dea5b1eca69de729e69cd3d560)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimensionEqual",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimensionEqual:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimensionEqual(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimensionEqualOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimensionEqualOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dabe29a160960349637421a5db716c2d894a6c048b893d1bf1ae4731869ebffd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimensionEqual], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimensionEqual],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__00564e741f83eee514a6b7343d0b9d7e717107e185a65841791f2a120478f6d9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimensionGreaterThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimensionGreaterThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimensionGreaterThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimensionGreaterThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimensionGreaterThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b48ab31d0d4ff3c1df2b74fd538f10eb79ff118fb09215d101f386929a719012)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimensionGreaterThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimensionGreaterThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8feaf2daf102bfb418431d08e25e2624cacb01b799a3998f2f723cdba78fa46f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimensionLessThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimensionLessThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimensionLessThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimensionLessThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimensionLessThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__86f792ccef692cde277cf1699e69369650dccdc6fd731b1956186e93a8cbf406)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimensionLessThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimensionLessThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0aeb5ae2f6591d82f18813d8a639bcd7ef5a0c63e751d17e8a2c354508b0788a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimensionList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimensionList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__60757ec94928bb6a2407a35cbfd5fd76eb342be7b9542d76c553f061c1757626)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimensionOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__050900cdc6e60b962de4f33d69d9e93dca8282d1d3489e397a997659f9cf6ddc)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimensionOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8ad9f9045f20e8c6a641a757ea2399e49041ab881177d14aad9371c7c3b84823)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0a3d2805b385906eaa0305056c5afdf8e1a39f5ad271640aebc74e640c2a1a49)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0f7c289c1fb64da1d3cdd49e8a471f8424df4e12f1e2377279e9332b79baed1c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimension]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimension]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__47deede0b5e217abd735e37493fd7376b210aa12acda5b83a58d3935933d6e6d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimensionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimensionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c61ef3985381d769a63f977f2ca79dae444673a8e69e36b7c8adaa51b37b80b3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimensionDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putEqual")
    def put_equal(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimensionEqual()

        return typing.cast(None, jsii.invoke(self, "putEqual", [value]))

    @jsii.member(jsii_name="putGreaterThan")
    def put_greater_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimensionGreaterThan()

        return typing.cast(None, jsii.invoke(self, "putGreaterThan", [value]))

    @jsii.member(jsii_name="putLessThan")
    def put_less_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimensionLessThan()

        return typing.cast(None, jsii.invoke(self, "putLessThan", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetDimension")
    def reset_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimension", []))

    @jsii.member(jsii_name="resetDimensionVar")
    def reset_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimensionVar", []))

    @jsii.member(jsii_name="resetEqual")
    def reset_equal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEqual", []))

    @jsii.member(jsii_name="resetGreaterThan")
    def reset_greater_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGreaterThan", []))

    @jsii.member(jsii_name="resetLessThan")
    def reset_less_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLessThan", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimensionDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimensionDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="equal")
    def equal(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimensionEqualOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimensionEqualOutputReference, jsii.get(self, "equal"))

    @builtins.property
    @jsii.member(jsii_name="greaterThan")
    def greater_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimensionGreaterThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimensionGreaterThanOutputReference, jsii.get(self, "greaterThan"))

    @builtins.property
    @jsii.member(jsii_name="lessThan")
    def less_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimensionLessThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimensionLessThanOutputReference, jsii.get(self, "lessThan"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimensionDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionInput")
    def dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionVarInput")
    def dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="equalInput")
    def equal_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimensionEqual], jsii.get(self, "equalInput"))

    @builtins.property
    @jsii.member(jsii_name="greaterThanInput")
    def greater_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimensionGreaterThan], jsii.get(self, "greaterThanInput"))

    @builtins.property
    @jsii.member(jsii_name="lessThanInput")
    def less_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimensionLessThan], jsii.get(self, "lessThanInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="dimension")
    def dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimension"))

    @dimension.setter
    def dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4e7f9de566984c08fb7b48046890c0ab2dab2128deb0a9410fd01c3a653e78b3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimension", value)

    @builtins.property
    @jsii.member(jsii_name="dimensionVar")
    def dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimensionVar"))

    @dimension_var.setter
    def dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__99889450179dc8f9d80ba29796e2785f12cb3953e310e772d9e33bad2da0c9be)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ef59934f474333b20cee523e3bc54b69364a931d6bb916cc9037cfee76d4160)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__82802c1f87194946bd37510980ac3df078c41110986d993fcb1d9a010716a61d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimension]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimension]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimension]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a0e7c5f04f10e2e27c0cac07d8ee0ae2707040be04cd1936a51b5855e5bb7c44)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientation",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "landscape": "landscape",
        "portrait": "portrait",
        "square": "square",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientation:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientationDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        landscape: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientationLandscape", typing.Dict[builtins.str, typing.Any]]] = None,
        portrait: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientationPortrait", typing.Dict[builtins.str, typing.Any]]] = None,
        square: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientationSquare", typing.Dict[builtins.str, typing.Any]]] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param landscape: landscape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        :param portrait: portrait block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        :param square: square block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientationDefault(**default)
        if isinstance(landscape, dict):
            landscape = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientationLandscape(**landscape)
        if isinstance(portrait, dict):
            portrait = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientationPortrait(**portrait)
        if isinstance(square, dict):
            square = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientationSquare(**square)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ffe0c99bc70af028350ddba5fd396369511293851aaa44554aa9935f8a04947)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument landscape", value=landscape, expected_type=type_hints["landscape"])
            check_type(argname="argument portrait", value=portrait, expected_type=type_hints["portrait"])
            check_type(argname="argument square", value=square, expected_type=type_hints["square"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if landscape is not None:
            self._values["landscape"] = landscape
        if portrait is not None:
            self._values["portrait"] = portrait
        if square is not None:
            self._values["square"] = square

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientationDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientationDefault"], result)

    @builtins.property
    def landscape(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientationLandscape"]:
        '''landscape block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        '''
        result = self._values.get("landscape")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientationLandscape"], result)

    @builtins.property
    def portrait(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientationPortrait"]:
        '''portrait block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        '''
        result = self._values.get("portrait")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientationPortrait"], result)

    @builtins.property
    def square(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientationSquare"]:
        '''square block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        result = self._values.get("square")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientationSquare"], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientationDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientationDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientationDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientationDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientationDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ee6b8dc75d6554f08d8cac23cfc52b330b7669f9cb1d973f484217dd625e8c78)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientationDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientationDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d6a898b673e457bd9c6d1a69cf43cde7e0b3a3dfeda74c9aec60baf4f500961)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientationLandscape",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientationLandscape:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientationLandscape(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientationLandscapeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientationLandscapeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f948c3f60de141e290ab48539d7b349c8fc5fa20e1e72f2ea034307ad4db39e5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientationLandscape], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientationLandscape],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0b87c4a16141f22c412f048129626c41ed799c2c6c0a0cc730bc2ca74f376889)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientationList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientationList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__51c96f4598217d8a820f870397d27b59410436debf403ec2cdad028fed2b8be2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientationOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__006f1ea31a7f02fc13865e9743d327e87603cec55139f1cc092baae6c4186eeb)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientationOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__240a7f175383f646efcaf978642674ddbc6bff197cd742ef778f69012ca6dd5d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__386aeb0f2023c047fa76669cf5e819b757a3f8d0f8f66bcb6da2b24383516040)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bfb5e8788ca678f4ca8e6bba6a7cab776a9a307e0ba97e74ba851de9b08afcd9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientation]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientation]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6c71a71832ea8e9dcfadbf146b666db27af31776c9448ebc3bfb72f85be5325f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e0755058892cd23924e4be2077fc37b11fd7dddba38ad4eb80e163dedbff5bb4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientationDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putLandscape")
    def put_landscape(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientationLandscape()

        return typing.cast(None, jsii.invoke(self, "putLandscape", [value]))

    @jsii.member(jsii_name="putPortrait")
    def put_portrait(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientationPortrait()

        return typing.cast(None, jsii.invoke(self, "putPortrait", [value]))

    @jsii.member(jsii_name="putSquare")
    def put_square(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientationSquare()

        return typing.cast(None, jsii.invoke(self, "putSquare", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetLandscape")
    def reset_landscape(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLandscape", []))

    @jsii.member(jsii_name="resetPortrait")
    def reset_portrait(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPortrait", []))

    @jsii.member(jsii_name="resetSquare")
    def reset_square(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSquare", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientationDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientationDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="landscape")
    def landscape(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientationLandscapeOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientationLandscapeOutputReference, jsii.get(self, "landscape"))

    @builtins.property
    @jsii.member(jsii_name="portrait")
    def portrait(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientationPortraitOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientationPortraitOutputReference", jsii.get(self, "portrait"))

    @builtins.property
    @jsii.member(jsii_name="square")
    def square(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientationSquareOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientationSquareOutputReference", jsii.get(self, "square"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientationDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="landscapeInput")
    def landscape_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientationLandscape], jsii.get(self, "landscapeInput"))

    @builtins.property
    @jsii.member(jsii_name="portraitInput")
    def portrait_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientationPortrait"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientationPortrait"], jsii.get(self, "portraitInput"))

    @builtins.property
    @jsii.member(jsii_name="squareInput")
    def square_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientationSquare"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientationSquare"], jsii.get(self, "squareInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientation]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientation]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientation]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ba3960247647de912511fa20068615b55c5d07e328282a8232f653e6f432ac5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientationPortrait",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientationPortrait:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientationPortrait(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientationPortraitOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientationPortraitOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ddae767565bf8bb72be9ffa667d7e04e254c2d9dab2ac958077c0727259dd891)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientationPortrait]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientationPortrait], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientationPortrait],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab8f537d88b31b1292ca2ea1ac464561129fe3e62b20c3158439f2e938e43a34)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientationSquare",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientationSquare:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientationSquare(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientationSquareOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientationSquareOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b2312cd3204d69cfe99f9c72091cda26bc0b8ab63a8ce5b68be7e43b0c3d399f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientationSquare]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientationSquare], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientationSquare],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__61acc2ca277899c81d40dccae575d7657be03d8d0fe1dff26f217589a76d52b7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationMaxColors",
    jsii_struct_bases=[],
    name_mapping={"colors": "colors", "colors_var": "colorsVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationMaxColors:
    def __init__(
        self,
        *,
        colors: typing.Optional[builtins.str] = None,
        colors_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param colors: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        :param colors_var: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6445a908d7bdd51b80bbd602846ac871656c5b65b4f949bddc9c7500fa21d3ed)
            check_type(argname="argument colors", value=colors, expected_type=type_hints["colors"])
            check_type(argname="argument colors_var", value=colors_var, expected_type=type_hints["colors_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if colors is not None:
            self._values["colors"] = colors
        if colors_var is not None:
            self._values["colors_var"] = colors_var

    @builtins.property
    def colors(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        '''
        result = self._values.get("colors")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def colors_var(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        result = self._values.get("colors_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationMaxColors(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationMaxColorsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationMaxColorsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d59b30c49ad39faa5ba4c46fe8351608c237127981c8ce9775df6b93a5c40bd7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationMaxColorsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1e5921aebe30e68f6d106687da7f0f07fcd7f0cdbac3ca3aff9c73b9c4649590)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationMaxColorsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__24641d39cfaf8e091bcffdf1ce0ee4ec19b78e4e881f8f5fe0321f79a71f195a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7a97b40f9b309ffbb3a251b114316647f35048c18970effbb308ac169ec2774d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__805d0af57f96f8c0bc1c46ec8ad7da9675383a263bec6f022477ba380d5924cd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationMaxColors]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationMaxColors]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__63996b81a837f51477e1a505d73698a2bbe3dee2f6ceb159f2ae046be014cb7f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationMaxColorsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationMaxColorsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7e7bd75c57f5db853344eb12f05a7843db366dd01dd138da55a6cc6655bcf631)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColors")
    def reset_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColors", []))

    @jsii.member(jsii_name="resetColorsVar")
    def reset_colors_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorsVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorsInput")
    def colors_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsInput"))

    @builtins.property
    @jsii.member(jsii_name="colorsVarInput")
    def colors_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsVarInput"))

    @builtins.property
    @jsii.member(jsii_name="colors")
    def colors(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colors"))

    @colors.setter
    def colors(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d592b287413f3e51db9013f622d21b68702bdb13cae2dcab01cc64db2b5b1f9c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colors", value)

    @builtins.property
    @jsii.member(jsii_name="colorsVar")
    def colors_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorsVar"))

    @colors_var.setter
    def colors_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a6a91adc39d6eba330ec1d217f1c6bc871e0a6c17071f9e6cb5c2c3dd84e7d5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorsVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationMaxColors]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationMaxColors]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationMaxColors]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__38158a77ab77d148fe72fa9c7ab237adfd25e18dda2d071dc5523094acd444ea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationMirror",
    jsii_struct_bases=[],
    name_mapping={
        "horizontal": "horizontal",
        "horizontal_var": "horizontalVar",
        "vertical": "vertical",
        "vertical_var": "verticalVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationMirror:
    def __init__(
        self,
        *,
        horizontal: typing.Optional[builtins.str] = None,
        horizontal_var: typing.Optional[builtins.str] = None,
        vertical: typing.Optional[builtins.str] = None,
        vertical_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param horizontal: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        :param horizontal_var: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        :param vertical: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        :param vertical_var: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__59689a63a2dc456ade4d01c9acc994b3ec8a6c9b92ce6e5f8b6867ca37316dce)
            check_type(argname="argument horizontal", value=horizontal, expected_type=type_hints["horizontal"])
            check_type(argname="argument horizontal_var", value=horizontal_var, expected_type=type_hints["horizontal_var"])
            check_type(argname="argument vertical", value=vertical, expected_type=type_hints["vertical"])
            check_type(argname="argument vertical_var", value=vertical_var, expected_type=type_hints["vertical_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if horizontal is not None:
            self._values["horizontal"] = horizontal
        if horizontal_var is not None:
            self._values["horizontal_var"] = horizontal_var
        if vertical is not None:
            self._values["vertical"] = vertical
        if vertical_var is not None:
            self._values["vertical_var"] = vertical_var

    @builtins.property
    def horizontal(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        '''
        result = self._values.get("horizontal")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def horizontal_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        '''
        result = self._values.get("horizontal_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        '''
        result = self._values.get("vertical")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        result = self._values.get("vertical_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationMirror(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationMirrorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationMirrorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b068c6c294358483d07b4ac5a0eceb0db555a3064b1177504f815d146ba04f7d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationMirrorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d73ceecfd7959a6bd5533a815f3ff881c9a4a7c95fe9eb0601f4cb58cb7db02f)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationMirrorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e1c4f3f5b62d3fe89cec18fcd8bf1fbbb5dd84326bcd6ec2eb1ecb1764796740)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb822302aaaf2d0e00bbbeb40d9d71802e5a37f583e50835e34c1263863e8b19)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__940caba4c48cee69936b0d246b0354ca1a63c55ba258b0088af147fb1a347417)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationMirror]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationMirror]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ca3e29d15e8f97c2b628d951b00e9cf00cdfbb41a47e320d35897bd5677d4079)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationMirrorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationMirrorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b78815adf5a8f8afb7095a831c86bb1405c5c3fdb39363e1b9399f103b88ee58)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHorizontal")
    def reset_horizontal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontal", []))

    @jsii.member(jsii_name="resetHorizontalVar")
    def reset_horizontal_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontalVar", []))

    @jsii.member(jsii_name="resetVertical")
    def reset_vertical(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVertical", []))

    @jsii.member(jsii_name="resetVerticalVar")
    def reset_vertical_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVerticalVar", []))

    @builtins.property
    @jsii.member(jsii_name="horizontalInput")
    def horizontal_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontalVarInput")
    def horizontal_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalInput")
    def vertical_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalVarInput")
    def vertical_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontal")
    def horizontal(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontal"))

    @horizontal.setter
    def horizontal(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d3a86126d4e7f67dbc3a8c099f6d12cbc14caa238d3340160113c5ccd0fcec2c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontal", value)

    @builtins.property
    @jsii.member(jsii_name="horizontalVar")
    def horizontal_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontalVar"))

    @horizontal_var.setter
    def horizontal_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__89c3369bd62c0616453e005ccc4d4ef8a7a2e003784a3df9bb811ad5c4e795db)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontalVar", value)

    @builtins.property
    @jsii.member(jsii_name="vertical")
    def vertical(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "vertical"))

    @vertical.setter
    def vertical(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__61e971f3ead57d21cb6579e8665c823cf42abba7d24e9cae34248859710c005e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "vertical", value)

    @builtins.property
    @jsii.member(jsii_name="verticalVar")
    def vertical_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "verticalVar"))

    @vertical_var.setter
    def vertical_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__67d1baa097e4255ac429947bfb7e4c6a18e5dd83210f557fb86f2fbf67f5aadd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "verticalVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationMirror]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationMirror]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationMirror]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f0366ae5f6d9e0a1fd8ce81967168acb6602d7ae6232d796716412df6ac2be69)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationMonoHue",
    jsii_struct_bases=[],
    name_mapping={"hue": "hue", "hue_var": "hueVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationMonoHue:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__222aca57811b977610b69ae1bf1916b1a3e19774f51d45ff655ac9df4179633f)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationMonoHue(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationMonoHueList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationMonoHueList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d0fb5c33be98de7571d36d28394491ac2254e9918722a7dc94305cd555c5a686)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationMonoHueOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f21559ca5f36d440d3513334d0f9ab1788c7a642ca08e7bbb2e99d67a25c6cd1)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationMonoHueOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d72477adf9909a7edb7fa7696904cb23f6a25b4f2416801096f20a0b0e6d43c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__25d8f69e02aa5b5f1825abdbad8ebf1070b88b9b3b88349c202b11ff4310cd9a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__82f2bde01066b443106fec80f05e0913f81429aea4500afbc5ed3a29b1c38392)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationMonoHue]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationMonoHue]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a9cf90d4a7ce29d13a4ef6f5386cd701a478321ee56751e1f07da6a5ffe4d0bf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationMonoHueOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationMonoHueOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d981d6422e44f4899ea7afd97faf67e42631ed33d65f67bbd7ca2dd9b45c1ed4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__303c567fc1bb906ded394d65a105f1c27cbc15747ab7426011b0ecefd61604b9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6fba506271e2079bbb03a8d393fd729072eb52ef97fa1e31ba368b4ff7cb37ba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationMonoHue]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationMonoHue]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationMonoHue]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__631ea7d54fa78439c5c2586e43bf37e00060455ef05106f0f0c716166e5abf8a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationOpacity",
    jsii_struct_bases=[],
    name_mapping={"opacity": "opacity", "opacity_var": "opacityVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationOpacity:
    def __init__(
        self,
        *,
        opacity: typing.Optional[builtins.str] = None,
        opacity_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param opacity: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param opacity_var: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__33ebb8ca819b73400c76f940e2ff527908de7d67972c4a98371ee6b782502f7b)
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument opacity_var", value=opacity_var, expected_type=type_hints["opacity_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if opacity is not None:
            self._values["opacity"] = opacity
        if opacity_var is not None:
            self._values["opacity_var"] = opacity_var

    @builtins.property
    def opacity(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def opacity_var(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        result = self._values.get("opacity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationOpacity(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationOpacityList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationOpacityList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ec9f2111c80b759046391c13d29239e79eb941d9b02e2486f0f450f3befdd7dd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationOpacityOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e1d44a43256e3e7ba907aa4d7318d2ef3bf023b15eb5c0a9bb36af577841713)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationOpacityOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eceb01b81a16bdd53bfb86b7ccbd34d8b2f462ffb7ee9f5633966e29f1110a97)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ce5c222e14bcde597f32e209d5ac1cdeba6f8e6492e14ee9a4dea879128b3112)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6bc847b113c60254dacaff3e0e5a169ee3ac953831c1855094f753dafb4a0f39)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationOpacity]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationOpacity]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f026fe96ee29e629ed25bdbe9d641a2aacba62679c078f8aae0a55c6a8856c09)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationOpacityOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationOpacityOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__419ee6e2a120d560806f983fed69f5cf9af37892208d617e6867ad337d799290)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetOpacityVar")
    def reset_opacity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacityVar", []))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityVarInput")
    def opacity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacity"))

    @opacity.setter
    def opacity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6d338110470ed02a4263327938c885267dc6c6faedef9b892357bbbc5d775dff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacity", value)

    @builtins.property
    @jsii.member(jsii_name="opacityVar")
    def opacity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacityVar"))

    @opacity_var.setter
    def opacity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cfb2e222cd69cd74f31a6d4df7725083f8293aabebf5d33dac3973c03f283e4b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacityVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationOpacity]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationOpacity]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationOpacity]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__35dedabc0c7e96c1866ecbad2b9a1cc646f64af60759822ae48c51059a5b7cd8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b495807561f17bc0dea6b18d0a83bdcdff1c3b76331b9877776d539152c9ab19)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putBackgroundColor")
    def put_background_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b35625678f6d33a606df0cc1aff1133b5cdc1470ff4505092d43cee5548baf0a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBackgroundColor", [value]))

    @jsii.member(jsii_name="putBlur")
    def put_blur(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationBlur, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__79801d8e88e58d44064f9e438405213c61f83e47f125c3318bb406887a4306ac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBlur", [value]))

    @jsii.member(jsii_name="putChromaKey")
    def put_chroma_key(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationChromaKey, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0bbc10cdddcac67731b7f66eb5f7281fd406aab2d92aa5b24f397d8b740e329b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putChromaKey", [value]))

    @jsii.member(jsii_name="putComposite")
    def put_composite(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationComposite, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5d40e18a6f7d9d71f60b4934e5a1ee08465e64fffbd9ab993c90bcb96e0ab109)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putComposite", [value]))

    @jsii.member(jsii_name="putCompound")
    def put_compound(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationCompound, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__262e2fbea1fce22d44a159459989cf6157e43ba2cb6d1d7e03d154791c3b498f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCompound", [value]))

    @jsii.member(jsii_name="putContrast")
    def put_contrast(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationContrast, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a5f785d08645c5aba22442e773d200f32b36033f5fd3a37a98404200f14c41d2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putContrast", [value]))

    @jsii.member(jsii_name="putGoop")
    def put_goop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationGoop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c79ef0269855d8f70bbb4bfe52667d998ab438fc279fe0a9bf372454373ffbd1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGoop", [value]))

    @jsii.member(jsii_name="putGrayscale")
    def put_grayscale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationGrayscale, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7916bb474a62505596531c5614dd5dc61cbd6518cb712a8507b1a4b07788ade5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGrayscale", [value]))

    @jsii.member(jsii_name="putHsl")
    def put_hsl(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationHsl, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8b7c0874c1bae6a913444922dfbe6f7d3b9cd43c841951cda2695e7ea2052bc1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsl", [value]))

    @jsii.member(jsii_name="putHsv")
    def put_hsv(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationHsv, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7518cd222ae6902b4be6fa7527c965d8ffbfc574cbd8215ee1eadcc2b0b6f516)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsv", [value]))

    @jsii.member(jsii_name="putIfDimension")
    def put_if_dimension(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimension, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__40fc721443cb4dd21604f713bcd1dd713f0eb3ca1d31b6c4e6112b9475361349)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfDimension", [value]))

    @jsii.member(jsii_name="putIfOrientation")
    def put_if_orientation(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__32a73f6db2390e216f348c003cb2092f0e39b3a9c30bed407333cfcab873befa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfOrientation", [value]))

    @jsii.member(jsii_name="putMaxColors")
    def put_max_colors(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationMaxColors, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7b57ea443575e7f0f70dfed9eed5f511acaeff6e7489fad13f740bea5b25c9a0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMaxColors", [value]))

    @jsii.member(jsii_name="putMirror")
    def put_mirror(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationMirror, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3e9aec9d6265714c9799f5b6890431170e97cb645d7b8d29d2c41c7cec25c6dc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMirror", [value]))

    @jsii.member(jsii_name="putMonoHue")
    def put_mono_hue(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationMonoHue, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3b91acedf530e7baf7e294780662641068b7cdd8cfc80e32b8a392258f20821d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMonoHue", [value]))

    @jsii.member(jsii_name="putOpacity")
    def put_opacity(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationOpacity, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f269cac0a92f15f38e24bc39e782a63b9a57c5d75b334e2a1a5a5344ae261603)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putOpacity", [value]))

    @jsii.member(jsii_name="putRemoveColor")
    def put_remove_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationRemoveColor", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f1fe53d9581370258e7b5f69e4506364a1c45d33df2b11194808dc249ebde7b5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRemoveColor", [value]))

    @jsii.member(jsii_name="putUnsharpMask")
    def put_unsharp_mask(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationUnsharpMask", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__167f8dbadaea677e68a32f0103a005796d7f70f2a923b551cad73d6c44c53deb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putUnsharpMask", [value]))

    @jsii.member(jsii_name="resetBackgroundColor")
    def reset_background_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBackgroundColor", []))

    @jsii.member(jsii_name="resetBlur")
    def reset_blur(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBlur", []))

    @jsii.member(jsii_name="resetChromaKey")
    def reset_chroma_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChromaKey", []))

    @jsii.member(jsii_name="resetComposite")
    def reset_composite(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetComposite", []))

    @jsii.member(jsii_name="resetCompound")
    def reset_compound(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCompound", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetGoop")
    def reset_goop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGoop", []))

    @jsii.member(jsii_name="resetGrayscale")
    def reset_grayscale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGrayscale", []))

    @jsii.member(jsii_name="resetHsl")
    def reset_hsl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsl", []))

    @jsii.member(jsii_name="resetHsv")
    def reset_hsv(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsv", []))

    @jsii.member(jsii_name="resetIfDimension")
    def reset_if_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfDimension", []))

    @jsii.member(jsii_name="resetIfOrientation")
    def reset_if_orientation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfOrientation", []))

    @jsii.member(jsii_name="resetMaxColors")
    def reset_max_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxColors", []))

    @jsii.member(jsii_name="resetMirror")
    def reset_mirror(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMirror", []))

    @jsii.member(jsii_name="resetMonoHue")
    def reset_mono_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonoHue", []))

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetRemoveColor")
    def reset_remove_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRemoveColor", []))

    @jsii.member(jsii_name="resetUnsharpMask")
    def reset_unsharp_mask(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUnsharpMask", []))

    @builtins.property
    @jsii.member(jsii_name="backgroundColor")
    def background_color(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationBackgroundColorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationBackgroundColorList, jsii.get(self, "backgroundColor"))

    @builtins.property
    @jsii.member(jsii_name="blur")
    def blur(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationBlurList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationBlurList, jsii.get(self, "blur"))

    @builtins.property
    @jsii.member(jsii_name="chromaKey")
    def chroma_key(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationChromaKeyList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationChromaKeyList, jsii.get(self, "chromaKey"))

    @builtins.property
    @jsii.member(jsii_name="composite")
    def composite(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationCompositeList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationCompositeList, jsii.get(self, "composite"))

    @builtins.property
    @jsii.member(jsii_name="compound")
    def compound(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationCompoundList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationCompoundList, jsii.get(self, "compound"))

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationContrastList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationContrastList, jsii.get(self, "contrast"))

    @builtins.property
    @jsii.member(jsii_name="goop")
    def goop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationGoopList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationGoopList, jsii.get(self, "goop"))

    @builtins.property
    @jsii.member(jsii_name="grayscale")
    def grayscale(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationGrayscaleList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationGrayscaleList, jsii.get(self, "grayscale"))

    @builtins.property
    @jsii.member(jsii_name="hsl")
    def hsl(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationHslList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationHslList, jsii.get(self, "hsl"))

    @builtins.property
    @jsii.member(jsii_name="hsv")
    def hsv(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationHsvList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationHsvList, jsii.get(self, "hsv"))

    @builtins.property
    @jsii.member(jsii_name="ifDimension")
    def if_dimension(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimensionList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimensionList, jsii.get(self, "ifDimension"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientation")
    def if_orientation(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientationList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientationList, jsii.get(self, "ifOrientation"))

    @builtins.property
    @jsii.member(jsii_name="maxColors")
    def max_colors(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationMaxColorsList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationMaxColorsList, jsii.get(self, "maxColors"))

    @builtins.property
    @jsii.member(jsii_name="mirror")
    def mirror(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationMirrorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationMirrorList, jsii.get(self, "mirror"))

    @builtins.property
    @jsii.member(jsii_name="monoHue")
    def mono_hue(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationMonoHueList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationMonoHueList, jsii.get(self, "monoHue"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationOpacityList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationOpacityList, jsii.get(self, "opacity"))

    @builtins.property
    @jsii.member(jsii_name="removeColor")
    def remove_color(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationRemoveColorList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationRemoveColorList", jsii.get(self, "removeColor"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMask")
    def unsharp_mask(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationUnsharpMaskList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationUnsharpMaskList", jsii.get(self, "unsharpMask"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColorInput")
    def background_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationBackgroundColor]]], jsii.get(self, "backgroundColorInput"))

    @builtins.property
    @jsii.member(jsii_name="blurInput")
    def blur_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationBlur]]], jsii.get(self, "blurInput"))

    @builtins.property
    @jsii.member(jsii_name="chromaKeyInput")
    def chroma_key_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationChromaKey]]], jsii.get(self, "chromaKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="compositeInput")
    def composite_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationComposite]]], jsii.get(self, "compositeInput"))

    @builtins.property
    @jsii.member(jsii_name="compoundInput")
    def compound_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationCompound]]], jsii.get(self, "compoundInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationContrast]]], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="goopInput")
    def goop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationGoop]]], jsii.get(self, "goopInput"))

    @builtins.property
    @jsii.member(jsii_name="grayscaleInput")
    def grayscale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationGrayscale]]], jsii.get(self, "grayscaleInput"))

    @builtins.property
    @jsii.member(jsii_name="hslInput")
    def hsl_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationHsl]]], jsii.get(self, "hslInput"))

    @builtins.property
    @jsii.member(jsii_name="hsvInput")
    def hsv_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationHsv]]], jsii.get(self, "hsvInput"))

    @builtins.property
    @jsii.member(jsii_name="ifDimensionInput")
    def if_dimension_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimension]]], jsii.get(self, "ifDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientationInput")
    def if_orientation_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientation]]], jsii.get(self, "ifOrientationInput"))

    @builtins.property
    @jsii.member(jsii_name="maxColorsInput")
    def max_colors_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationMaxColors]]], jsii.get(self, "maxColorsInput"))

    @builtins.property
    @jsii.member(jsii_name="mirrorInput")
    def mirror_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationMirror]]], jsii.get(self, "mirrorInput"))

    @builtins.property
    @jsii.member(jsii_name="monoHueInput")
    def mono_hue_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationMonoHue]]], jsii.get(self, "monoHueInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationOpacity]]], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="removeColorInput")
    def remove_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationRemoveColor"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationRemoveColor"]]], jsii.get(self, "removeColorInput"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMaskInput")
    def unsharp_mask_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationUnsharpMask"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationUnsharpMask"]]], jsii.get(self, "unsharpMaskInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c8c895adc00d6767ffd659d5a6ff6a5b5bc635d64b407f54fccc15ddd52865be)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationRemoveColor",
    jsii_struct_bases=[],
    name_mapping={
        "color": "color",
        "color_var": "colorVar",
        "feather": "feather",
        "feather_var": "featherVar",
        "tolerance": "tolerance",
        "tolerance_var": "toleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationRemoveColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
        feather: typing.Optional[builtins.str] = None,
        feather_var: typing.Optional[builtins.str] = None,
        tolerance: typing.Optional[builtins.str] = None,
        tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        :param feather: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        :param feather_var: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        :param tolerance: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        :param tolerance_var: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c9400272d78970b499087f9f95983433bfaeea80d99b8f81c7ee965f3e6325e2)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
            check_type(argname="argument feather", value=feather, expected_type=type_hints["feather"])
            check_type(argname="argument feather_var", value=feather_var, expected_type=type_hints["feather_var"])
            check_type(argname="argument tolerance", value=tolerance, expected_type=type_hints["tolerance"])
            check_type(argname="argument tolerance_var", value=tolerance_var, expected_type=type_hints["tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var
        if feather is not None:
            self._values["feather"] = feather
        if feather_var is not None:
            self._values["feather_var"] = feather_var
        if tolerance is not None:
            self._values["tolerance"] = tolerance
        if tolerance_var is not None:
            self._values["tolerance_var"] = tolerance_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        '''
        result = self._values.get("feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather_var(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        '''
        result = self._values.get("feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        '''
        result = self._values.get("tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance_var(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        result = self._values.get("tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationRemoveColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationRemoveColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationRemoveColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__937d8264c71c7ae3fd0adfac9cad7cee420597c18bf6e434dddeb6be6ebc898b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationRemoveColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8fbb912a9b61ac9672a3f4ee44fe2642b9e154fe8d8f6d61a35860fe0e2a11e7)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationRemoveColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ea7cac2a951c25ce9f82cd46fce2006e7a8365b95f711004db76f507669f27d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b50667679033c46acb1daf4767a08aa1694ccb303fab760268d4cd1744194c28)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__68458ede47475746314dd80d39bf3ad448c5fb189600355916e5640d29c70604)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationRemoveColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationRemoveColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationRemoveColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b99788274bb6e7510bd625ea0242f2b0524dd3433b9e37bb1432e46b7ed705e6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationRemoveColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationRemoveColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dab035e5d4401bcae5085b51da9e415118c0dbc72420f0226d3a5bfbc545f6c6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @jsii.member(jsii_name="resetFeather")
    def reset_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeather", []))

    @jsii.member(jsii_name="resetFeatherVar")
    def reset_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatherVar", []))

    @jsii.member(jsii_name="resetTolerance")
    def reset_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTolerance", []))

    @jsii.member(jsii_name="resetToleranceVar")
    def reset_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featherInput")
    def feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherInput"))

    @builtins.property
    @jsii.member(jsii_name="featherVarInput")
    def feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceInput")
    def tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceVarInput")
    def tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__68bf51163432bff1b4badc4d2b0d6fd0aadb3151af0d5998e766881d9f42033b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ad268115e5f7040fde39e42ead487801ae2b07c5ae034c1af651ff77769f0d83)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="feather")
    def feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "feather"))

    @feather.setter
    def feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df11ae6c168a3718f6c1ce0b5c2ce3f2152082c4cf86b06062dfb5478df4fe41)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "feather", value)

    @builtins.property
    @jsii.member(jsii_name="featherVar")
    def feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featherVar"))

    @feather_var.setter
    def feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2f49dee4f687efbf8955ea7c4729c420410e7652c6933724327b83b0fa885209)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featherVar", value)

    @builtins.property
    @jsii.member(jsii_name="tolerance")
    def tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tolerance"))

    @tolerance.setter
    def tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ef6fd22f21807a81ce850d0afd3475d81877f1cae73faa5c7a97bd450680e3bf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tolerance", value)

    @builtins.property
    @jsii.member(jsii_name="toleranceVar")
    def tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "toleranceVar"))

    @tolerance_var.setter
    def tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8d250ba37fe240735204ac0f1c3250ab792a357bdba0c894c241d8e406e1f75d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "toleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationRemoveColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationRemoveColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationRemoveColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d226c4a24ffb06bd601b75e0bf480f465609b53c3729de33b6a7bf2f87e414c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationUnsharpMask",
    jsii_struct_bases=[],
    name_mapping={
        "gain": "gain",
        "gain_var": "gainVar",
        "sigma": "sigma",
        "sigma_var": "sigmaVar",
        "threshold": "threshold",
        "threshold_var": "thresholdVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationUnsharpMask:
    def __init__(
        self,
        *,
        gain: typing.Optional[builtins.str] = None,
        gain_var: typing.Optional[builtins.str] = None,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
        threshold: typing.Optional[builtins.str] = None,
        threshold_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param gain: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        :param gain_var: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        :param sigma: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        :param threshold: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        :param threshold_var: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ec41a3530795a6e70b113baa0af5c3f868735d8ec47066d7de13f7c25743c84)
            check_type(argname="argument gain", value=gain, expected_type=type_hints["gain"])
            check_type(argname="argument gain_var", value=gain_var, expected_type=type_hints["gain_var"])
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
            check_type(argname="argument threshold", value=threshold, expected_type=type_hints["threshold"])
            check_type(argname="argument threshold_var", value=threshold_var, expected_type=type_hints["threshold_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if gain is not None:
            self._values["gain"] = gain
        if gain_var is not None:
            self._values["gain_var"] = gain_var
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var
        if threshold is not None:
            self._values["threshold"] = threshold
        if threshold_var is not None:
            self._values["threshold_var"] = threshold_var

    @builtins.property
    def gain(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        '''
        result = self._values.get("gain")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gain_var(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        '''
        result = self._values.get("gain_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        '''
        result = self._values.get("threshold")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold_var(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        result = self._values.get("threshold_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationUnsharpMask(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationUnsharpMaskList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationUnsharpMaskList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__23801c329df86da2d87804d94654e524582dc4f7b3e57b8c29d5e122000e1e0a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationUnsharpMaskOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8fc264c14b41af5b1026e17858e95c231366664b23fa88c94c18efe7b91b6c9a)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationUnsharpMaskOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__090f349f8353b468f9daf3d545722b79e3ab0635feb4f5f42a921bb70f9f30bc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__16c76c9482ae9c9bd4860947399fc9836294ff6bf7248242c75fd5d7f6976ecc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9bf55f22a7507f049c2e9a49f245816bfe67ca2de8fe20b1e276d706636e8294)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationUnsharpMask]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationUnsharpMask]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationUnsharpMask]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__52bb6090f07f9115c0ceb95646615248f3040a6a26e3c5685f2a9c8fca675b0f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationUnsharpMaskOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationUnsharpMaskOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d93702de80a5d13806913ccc9d4287d87eef776ec06a964781623d756125c54c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetGain")
    def reset_gain(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGain", []))

    @jsii.member(jsii_name="resetGainVar")
    def reset_gain_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGainVar", []))

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @jsii.member(jsii_name="resetThreshold")
    def reset_threshold(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThreshold", []))

    @jsii.member(jsii_name="resetThresholdVar")
    def reset_threshold_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThresholdVar", []))

    @builtins.property
    @jsii.member(jsii_name="gainInput")
    def gain_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainInput"))

    @builtins.property
    @jsii.member(jsii_name="gainVarInput")
    def gain_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdInput")
    def threshold_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdVarInput")
    def threshold_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gain")
    def gain(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gain"))

    @gain.setter
    def gain(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bcfdac06d2fa2d5740a4810463963ad1d51c00f0e28c23c5bc3a45741ed4677b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gain", value)

    @builtins.property
    @jsii.member(jsii_name="gainVar")
    def gain_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gainVar"))

    @gain_var.setter
    def gain_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__788e7b5d0247b37dddfbcdadf9a8a1439c233044045f566dd41679ff29bffb15)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gainVar", value)

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fbbd0227a41016bb003300ad4578d266ef8dfda64e82f9dec8f6a8ddfe004d36)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1a59ef46c294e900b0bc3e33e29eb952f2e93f82a7c959e379c709fdc7aeba9b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="threshold")
    def threshold(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "threshold"))

    @threshold.setter
    def threshold(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dacab95fb111f14ff32ceec1aafa2a02f9525ab5e29cd5a5336b3cd7e1d55f79)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "threshold", value)

    @builtins.property
    @jsii.member(jsii_name="thresholdVar")
    def threshold_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "thresholdVar"))

    @threshold_var.setter
    def threshold_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d4cfe1766068355e7436b8e2639936cac786fee8796b5a9d437c1f0610bbc242)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "thresholdVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationUnsharpMask]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationUnsharpMask]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationUnsharpMask]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9b49bd2c7694ba6e15e1d557f48ec7416fda314eb952c78d37265ce9c7f24b4f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__72348421cec61decf25f7223adc2a04dca8bd9196f925a6dd073485c2d0bfe5e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putBoxImage")
    def put_box_image(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImage, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0fcc1a7950cc794ce7201ddbeb87265e0f52c3f26813c05965ff6c1a2909ff44)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBoxImage", [value]))

    @jsii.member(jsii_name="putCircleImage")
    def put_circle_image(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImage, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ff40a90784a8917afea3b190a942351239a2363c67fe0294f68a2fbb013e915e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCircleImage", [value]))

    @jsii.member(jsii_name="putTextImage")
    def put_text_image(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImage", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e89ef357da70aadf67136aa2e46029523aa841bfe0ac12934cd816784af41eac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTextImage", [value]))

    @jsii.member(jsii_name="putUrlImage")
    def put_url_image(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImage", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e386f0094e8754c4314475affe7840ad1d68460c5bd73a5e9a7fd8905231f50)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putUrlImage", [value]))

    @jsii.member(jsii_name="resetBoxImage")
    def reset_box_image(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBoxImage", []))

    @jsii.member(jsii_name="resetCircleImage")
    def reset_circle_image(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCircleImage", []))

    @jsii.member(jsii_name="resetTextImage")
    def reset_text_image(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTextImage", []))

    @jsii.member(jsii_name="resetUrlImage")
    def reset_url_image(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUrlImage", []))

    @builtins.property
    @jsii.member(jsii_name="boxImage")
    def box_image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageList, jsii.get(self, "boxImage"))

    @builtins.property
    @jsii.member(jsii_name="circleImage")
    def circle_image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageList, jsii.get(self, "circleImage"))

    @builtins.property
    @jsii.member(jsii_name="textImage")
    def text_image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageList", jsii.get(self, "textImage"))

    @builtins.property
    @jsii.member(jsii_name="urlImage")
    def url_image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageList", jsii.get(self, "urlImage"))

    @builtins.property
    @jsii.member(jsii_name="boxImageInput")
    def box_image_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImage]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImage]]], jsii.get(self, "boxImageInput"))

    @builtins.property
    @jsii.member(jsii_name="circleImageInput")
    def circle_image_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImage]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImage]]], jsii.get(self, "circleImageInput"))

    @builtins.property
    @jsii.member(jsii_name="textImageInput")
    def text_image_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImage"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImage"]]], jsii.get(self, "textImageInput"))

    @builtins.property
    @jsii.member(jsii_name="urlImageInput")
    def url_image_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImage"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImage"]]], jsii.get(self, "urlImageInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8dd273e953c49d32ca01cf35ba851ed956e0ef1dd440ac2962e0564adc1153d2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImage",
    jsii_struct_bases=[],
    name_mapping={
        "fill": "fill",
        "fill_var": "fillVar",
        "size": "size",
        "size_var": "sizeVar",
        "stroke": "stroke",
        "stroke_size": "strokeSize",
        "stroke_size_var": "strokeSizeVar",
        "stroke_var": "strokeVar",
        "text": "text",
        "text_var": "textVar",
        "transformation": "transformation",
        "typeface": "typeface",
        "typeface_var": "typefaceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImage:
    def __init__(
        self,
        *,
        fill: typing.Optional[builtins.str] = None,
        fill_var: typing.Optional[builtins.str] = None,
        size: typing.Optional[builtins.str] = None,
        size_var: typing.Optional[builtins.str] = None,
        stroke: typing.Optional[builtins.str] = None,
        stroke_size: typing.Optional[builtins.str] = None,
        stroke_size_var: typing.Optional[builtins.str] = None,
        stroke_var: typing.Optional[builtins.str] = None,
        text: typing.Optional[builtins.str] = None,
        text_var: typing.Optional[builtins.str] = None,
        transformation: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        typeface: typing.Optional[builtins.str] = None,
        typeface_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fill: The main fill color of the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill DataAkamaiImagingPolicyImage#fill}
        :param fill_var: The main fill color of the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_var DataAkamaiImagingPolicyImage#fill_var}
        :param size: The size in pixels to render the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#size DataAkamaiImagingPolicyImage#size}
        :param size_var: The size in pixels to render the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#size_var DataAkamaiImagingPolicyImage#size_var}
        :param stroke: The color for the outline of the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke DataAkamaiImagingPolicyImage#stroke}
        :param stroke_size: The thickness in points for the outline of the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_size DataAkamaiImagingPolicyImage#stroke_size}
        :param stroke_size_var: The thickness in points for the outline of the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_size_var DataAkamaiImagingPolicyImage#stroke_size_var}
        :param stroke_var: The color for the outline of the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_var DataAkamaiImagingPolicyImage#stroke_var}
        :param text: The line of text to render. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text DataAkamaiImagingPolicyImage#text}
        :param text_var: The line of text to render. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text_var DataAkamaiImagingPolicyImage#text_var}
        :param transformation: transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        :param typeface: The font family to apply to the text image. This may be a URL to a TrueType or WOFF (v1) typeface, or a string that refers to one of the standard built-in browser fonts. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#typeface DataAkamaiImagingPolicyImage#typeface}
        :param typeface_var: The font family to apply to the text image. This may be a URL to a TrueType or WOFF (v1) typeface, or a string that refers to one of the standard built-in browser fonts. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#typeface_var DataAkamaiImagingPolicyImage#typeface_var}
        '''
        if isinstance(transformation, dict):
            transformation = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformation(**transformation)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6cc8b68c0f68abff9602c79287497059fbd19e4f2579388b9045ab9ec0b1bf22)
            check_type(argname="argument fill", value=fill, expected_type=type_hints["fill"])
            check_type(argname="argument fill_var", value=fill_var, expected_type=type_hints["fill_var"])
            check_type(argname="argument size", value=size, expected_type=type_hints["size"])
            check_type(argname="argument size_var", value=size_var, expected_type=type_hints["size_var"])
            check_type(argname="argument stroke", value=stroke, expected_type=type_hints["stroke"])
            check_type(argname="argument stroke_size", value=stroke_size, expected_type=type_hints["stroke_size"])
            check_type(argname="argument stroke_size_var", value=stroke_size_var, expected_type=type_hints["stroke_size_var"])
            check_type(argname="argument stroke_var", value=stroke_var, expected_type=type_hints["stroke_var"])
            check_type(argname="argument text", value=text, expected_type=type_hints["text"])
            check_type(argname="argument text_var", value=text_var, expected_type=type_hints["text_var"])
            check_type(argname="argument transformation", value=transformation, expected_type=type_hints["transformation"])
            check_type(argname="argument typeface", value=typeface, expected_type=type_hints["typeface"])
            check_type(argname="argument typeface_var", value=typeface_var, expected_type=type_hints["typeface_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fill is not None:
            self._values["fill"] = fill
        if fill_var is not None:
            self._values["fill_var"] = fill_var
        if size is not None:
            self._values["size"] = size
        if size_var is not None:
            self._values["size_var"] = size_var
        if stroke is not None:
            self._values["stroke"] = stroke
        if stroke_size is not None:
            self._values["stroke_size"] = stroke_size
        if stroke_size_var is not None:
            self._values["stroke_size_var"] = stroke_size_var
        if stroke_var is not None:
            self._values["stroke_var"] = stroke_var
        if text is not None:
            self._values["text"] = text
        if text_var is not None:
            self._values["text_var"] = text_var
        if transformation is not None:
            self._values["transformation"] = transformation
        if typeface is not None:
            self._values["typeface"] = typeface
        if typeface_var is not None:
            self._values["typeface_var"] = typeface_var

    @builtins.property
    def fill(self) -> typing.Optional[builtins.str]:
        '''The main fill color of the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill DataAkamaiImagingPolicyImage#fill}
        '''
        result = self._values.get("fill")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fill_var(self) -> typing.Optional[builtins.str]:
        '''The main fill color of the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_var DataAkamaiImagingPolicyImage#fill_var}
        '''
        result = self._values.get("fill_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def size(self) -> typing.Optional[builtins.str]:
        '''The size in pixels to render the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#size DataAkamaiImagingPolicyImage#size}
        '''
        result = self._values.get("size")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def size_var(self) -> typing.Optional[builtins.str]:
        '''The size in pixels to render the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#size_var DataAkamaiImagingPolicyImage#size_var}
        '''
        result = self._values.get("size_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def stroke(self) -> typing.Optional[builtins.str]:
        '''The color for the outline of the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke DataAkamaiImagingPolicyImage#stroke}
        '''
        result = self._values.get("stroke")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def stroke_size(self) -> typing.Optional[builtins.str]:
        '''The thickness in points for the outline of the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_size DataAkamaiImagingPolicyImage#stroke_size}
        '''
        result = self._values.get("stroke_size")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def stroke_size_var(self) -> typing.Optional[builtins.str]:
        '''The thickness in points for the outline of the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_size_var DataAkamaiImagingPolicyImage#stroke_size_var}
        '''
        result = self._values.get("stroke_size_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def stroke_var(self) -> typing.Optional[builtins.str]:
        '''The color for the outline of the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_var DataAkamaiImagingPolicyImage#stroke_var}
        '''
        result = self._values.get("stroke_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def text(self) -> typing.Optional[builtins.str]:
        '''The line of text to render.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text DataAkamaiImagingPolicyImage#text}
        '''
        result = self._values.get("text")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def text_var(self) -> typing.Optional[builtins.str]:
        '''The line of text to render.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text_var DataAkamaiImagingPolicyImage#text_var}
        '''
        result = self._values.get("text_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def transformation(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformation"]:
        '''transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        '''
        result = self._values.get("transformation")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformation"], result)

    @builtins.property
    def typeface(self) -> typing.Optional[builtins.str]:
        '''The font family to apply to the text image.

        This may be a URL to a TrueType or WOFF (v1) typeface, or a string that refers to one of the standard built-in browser fonts.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#typeface DataAkamaiImagingPolicyImage#typeface}
        '''
        result = self._values.get("typeface")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def typeface_var(self) -> typing.Optional[builtins.str]:
        '''The font family to apply to the text image.

        This may be a URL to a TrueType or WOFF (v1) typeface, or a string that refers to one of the standard built-in browser fonts.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#typeface_var DataAkamaiImagingPolicyImage#typeface_var}
        '''
        result = self._values.get("typeface_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c052a2df5744963f6b77b420a4dcf64ee8774f37195d2d2b7434b6c72149a2cc)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7226aab622b6742537ff223ee351270056a4d8d429067ab5e81f9fac96932f99)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d4a31e34cfc56c6c841848432ba5011e1ff3acc05df55df5988a4ecd36eff361)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a9c3f0ee751b846a558b7aea8d6fde3e24d086e0687c6c625ace182f741b6d77)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b80b815e31e3782d330c64870abbd203a4953b91c1062d0d1b5b5f97a7d504ca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImage]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImage]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImage]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2222267fa54995696ab60579435da512ee3adf20235562ec481b563f79798870)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2e4cb3725c675da0b6575a279dea25028db62fc4eee34b45509dc698eb615491)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformation")
    def put_transformation(
        self,
        *,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationBackgroundColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationBlur", typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationChromaKey", typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationComposite", typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationCompound", typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationContrast", typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationGoop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationGrayscale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationHsl", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationHsv", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimension", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientation", typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationMaxColors", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationMirror", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationMonoHue", typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationOpacity", typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationRemoveColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationUnsharpMask", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformation(
            background_color=background_color,
            blur=blur,
            chroma_key=chroma_key,
            composite=composite,
            compound=compound,
            contrast=contrast,
            goop=goop,
            grayscale=grayscale,
            hsl=hsl,
            hsv=hsv,
            if_dimension=if_dimension,
            if_orientation=if_orientation,
            max_colors=max_colors,
            mirror=mirror,
            mono_hue=mono_hue,
            opacity=opacity,
            remove_color=remove_color,
            unsharp_mask=unsharp_mask,
        )

        return typing.cast(None, jsii.invoke(self, "putTransformation", [value]))

    @jsii.member(jsii_name="resetFill")
    def reset_fill(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFill", []))

    @jsii.member(jsii_name="resetFillVar")
    def reset_fill_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFillVar", []))

    @jsii.member(jsii_name="resetSize")
    def reset_size(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSize", []))

    @jsii.member(jsii_name="resetSizeVar")
    def reset_size_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSizeVar", []))

    @jsii.member(jsii_name="resetStroke")
    def reset_stroke(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStroke", []))

    @jsii.member(jsii_name="resetStrokeSize")
    def reset_stroke_size(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStrokeSize", []))

    @jsii.member(jsii_name="resetStrokeSizeVar")
    def reset_stroke_size_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStrokeSizeVar", []))

    @jsii.member(jsii_name="resetStrokeVar")
    def reset_stroke_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStrokeVar", []))

    @jsii.member(jsii_name="resetText")
    def reset_text(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetText", []))

    @jsii.member(jsii_name="resetTextVar")
    def reset_text_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTextVar", []))

    @jsii.member(jsii_name="resetTransformation")
    def reset_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformation", []))

    @jsii.member(jsii_name="resetTypeface")
    def reset_typeface(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeface", []))

    @jsii.member(jsii_name="resetTypefaceVar")
    def reset_typeface_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypefaceVar", []))

    @builtins.property
    @jsii.member(jsii_name="transformation")
    def transformation(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationOutputReference", jsii.get(self, "transformation"))

    @builtins.property
    @jsii.member(jsii_name="fillInput")
    def fill_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fillInput"))

    @builtins.property
    @jsii.member(jsii_name="fillVarInput")
    def fill_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fillVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sizeInput")
    def size_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sizeInput"))

    @builtins.property
    @jsii.member(jsii_name="sizeVarInput")
    def size_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sizeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="strokeInput")
    def stroke_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "strokeInput"))

    @builtins.property
    @jsii.member(jsii_name="strokeSizeInput")
    def stroke_size_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "strokeSizeInput"))

    @builtins.property
    @jsii.member(jsii_name="strokeSizeVarInput")
    def stroke_size_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "strokeSizeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="strokeVarInput")
    def stroke_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "strokeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="textInput")
    def text_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "textInput"))

    @builtins.property
    @jsii.member(jsii_name="textVarInput")
    def text_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "textVarInput"))

    @builtins.property
    @jsii.member(jsii_name="transformationInput")
    def transformation_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformation"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformation"], jsii.get(self, "transformationInput"))

    @builtins.property
    @jsii.member(jsii_name="typefaceInput")
    def typeface_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typefaceInput"))

    @builtins.property
    @jsii.member(jsii_name="typefaceVarInput")
    def typeface_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typefaceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="fill")
    def fill(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fill"))

    @fill.setter
    def fill(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__22154e1b03baaf64a5c5178f41818996354dde1dd69d207af5f79f5e2df107d4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fill", value)

    @builtins.property
    @jsii.member(jsii_name="fillVar")
    def fill_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fillVar"))

    @fill_var.setter
    def fill_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2c61137e8945effd848a3f7381d4a879c7c3f6186d9078044ea4bc1e95ce8016)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fillVar", value)

    @builtins.property
    @jsii.member(jsii_name="size")
    def size(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "size"))

    @size.setter
    def size(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6d1d838cda98878fcc5bcad119b489702535413db14760d0d0acc970c2d3943d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "size", value)

    @builtins.property
    @jsii.member(jsii_name="sizeVar")
    def size_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sizeVar"))

    @size_var.setter
    def size_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f52b1df11bf7dd2241cc8c9bf03055bdb30ad3d7d8383aff11c28eead0f766df)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sizeVar", value)

    @builtins.property
    @jsii.member(jsii_name="stroke")
    def stroke(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "stroke"))

    @stroke.setter
    def stroke(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__daf3c1048186ac9ca10a0e9432c7b11c7ad6d54f005a3bd065f5471f7630efe4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "stroke", value)

    @builtins.property
    @jsii.member(jsii_name="strokeSize")
    def stroke_size(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "strokeSize"))

    @stroke_size.setter
    def stroke_size(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6d16ef06ad0359784925b3cec4b57b0f7ff8e59f8ad89e7e8c15940c95ecdeee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "strokeSize", value)

    @builtins.property
    @jsii.member(jsii_name="strokeSizeVar")
    def stroke_size_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "strokeSizeVar"))

    @stroke_size_var.setter
    def stroke_size_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c97c8000d26fec97078490c3c3ff26305e03203e37e81d0dd619759f2a16b5bf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "strokeSizeVar", value)

    @builtins.property
    @jsii.member(jsii_name="strokeVar")
    def stroke_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "strokeVar"))

    @stroke_var.setter
    def stroke_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0acdedb5de183a3cb96e8fc6669fce4ba973feb17b2afe467b56ea171bdb0ca8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "strokeVar", value)

    @builtins.property
    @jsii.member(jsii_name="text")
    def text(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "text"))

    @text.setter
    def text(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d763c1deae402a29f0ab950e12e769eadcfb45d326cfe7ee8bb6fd6047e925e0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "text", value)

    @builtins.property
    @jsii.member(jsii_name="textVar")
    def text_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "textVar"))

    @text_var.setter
    def text_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d8b438524501358770941326926d243c89074e26efe86bdfe3ac809fbfab6420)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "textVar", value)

    @builtins.property
    @jsii.member(jsii_name="typeface")
    def typeface(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeface"))

    @typeface.setter
    def typeface(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__70980bf861959843644b470827c3c1d07cdd13f24dbe87b0586edf9597a7d242)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeface", value)

    @builtins.property
    @jsii.member(jsii_name="typefaceVar")
    def typeface_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typefaceVar"))

    @typeface_var.setter
    def typeface_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__10952efe58e0bd1b9d4b6a505e504b6f99a7a9a46e94526ca5f73ba57214f084)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typefaceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImage]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImage]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImage]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c37ce04db105fbce4a187202d9bfb96af5352ee06e1adef90afc14f740837764)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformation",
    jsii_struct_bases=[],
    name_mapping={
        "background_color": "backgroundColor",
        "blur": "blur",
        "chroma_key": "chromaKey",
        "composite": "composite",
        "compound": "compound",
        "contrast": "contrast",
        "goop": "goop",
        "grayscale": "grayscale",
        "hsl": "hsl",
        "hsv": "hsv",
        "if_dimension": "ifDimension",
        "if_orientation": "ifOrientation",
        "max_colors": "maxColors",
        "mirror": "mirror",
        "mono_hue": "monoHue",
        "opacity": "opacity",
        "remove_color": "removeColor",
        "unsharp_mask": "unsharpMask",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformation:
    def __init__(
        self,
        *,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationBackgroundColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationBlur", typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationChromaKey", typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationComposite", typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationCompound", typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationContrast", typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationGoop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationGrayscale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationHsl", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationHsv", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimension", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientation", typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationMaxColors", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationMirror", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationMonoHue", typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationOpacity", typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationRemoveColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationUnsharpMask", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6b98c45e9cbc4362b5f0f14af3bcbc141355990c4e43458377591c99c35b026d)
            check_type(argname="argument background_color", value=background_color, expected_type=type_hints["background_color"])
            check_type(argname="argument blur", value=blur, expected_type=type_hints["blur"])
            check_type(argname="argument chroma_key", value=chroma_key, expected_type=type_hints["chroma_key"])
            check_type(argname="argument composite", value=composite, expected_type=type_hints["composite"])
            check_type(argname="argument compound", value=compound, expected_type=type_hints["compound"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument goop", value=goop, expected_type=type_hints["goop"])
            check_type(argname="argument grayscale", value=grayscale, expected_type=type_hints["grayscale"])
            check_type(argname="argument hsl", value=hsl, expected_type=type_hints["hsl"])
            check_type(argname="argument hsv", value=hsv, expected_type=type_hints["hsv"])
            check_type(argname="argument if_dimension", value=if_dimension, expected_type=type_hints["if_dimension"])
            check_type(argname="argument if_orientation", value=if_orientation, expected_type=type_hints["if_orientation"])
            check_type(argname="argument max_colors", value=max_colors, expected_type=type_hints["max_colors"])
            check_type(argname="argument mirror", value=mirror, expected_type=type_hints["mirror"])
            check_type(argname="argument mono_hue", value=mono_hue, expected_type=type_hints["mono_hue"])
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument remove_color", value=remove_color, expected_type=type_hints["remove_color"])
            check_type(argname="argument unsharp_mask", value=unsharp_mask, expected_type=type_hints["unsharp_mask"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if background_color is not None:
            self._values["background_color"] = background_color
        if blur is not None:
            self._values["blur"] = blur
        if chroma_key is not None:
            self._values["chroma_key"] = chroma_key
        if composite is not None:
            self._values["composite"] = composite
        if compound is not None:
            self._values["compound"] = compound
        if contrast is not None:
            self._values["contrast"] = contrast
        if goop is not None:
            self._values["goop"] = goop
        if grayscale is not None:
            self._values["grayscale"] = grayscale
        if hsl is not None:
            self._values["hsl"] = hsl
        if hsv is not None:
            self._values["hsv"] = hsv
        if if_dimension is not None:
            self._values["if_dimension"] = if_dimension
        if if_orientation is not None:
            self._values["if_orientation"] = if_orientation
        if max_colors is not None:
            self._values["max_colors"] = max_colors
        if mirror is not None:
            self._values["mirror"] = mirror
        if mono_hue is not None:
            self._values["mono_hue"] = mono_hue
        if opacity is not None:
            self._values["opacity"] = opacity
        if remove_color is not None:
            self._values["remove_color"] = remove_color
        if unsharp_mask is not None:
            self._values["unsharp_mask"] = unsharp_mask

    @builtins.property
    def background_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationBackgroundColor"]]]:
        '''background_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        '''
        result = self._values.get("background_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationBackgroundColor"]]], result)

    @builtins.property
    def blur(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationBlur"]]]:
        '''blur block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        '''
        result = self._values.get("blur")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationBlur"]]], result)

    @builtins.property
    def chroma_key(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationChromaKey"]]]:
        '''chroma_key block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        '''
        result = self._values.get("chroma_key")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationChromaKey"]]], result)

    @builtins.property
    def composite(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationComposite"]]]:
        '''composite block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        '''
        result = self._values.get("composite")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationComposite"]]], result)

    @builtins.property
    def compound(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationCompound"]]]:
        '''compound block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        '''
        result = self._values.get("compound")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationCompound"]]], result)

    @builtins.property
    def contrast(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationContrast"]]]:
        '''contrast block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationContrast"]]], result)

    @builtins.property
    def goop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationGoop"]]]:
        '''goop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        '''
        result = self._values.get("goop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationGoop"]]], result)

    @builtins.property
    def grayscale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationGrayscale"]]]:
        '''grayscale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        '''
        result = self._values.get("grayscale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationGrayscale"]]], result)

    @builtins.property
    def hsl(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationHsl"]]]:
        '''hsl block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        '''
        result = self._values.get("hsl")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationHsl"]]], result)

    @builtins.property
    def hsv(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationHsv"]]]:
        '''hsv block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        '''
        result = self._values.get("hsv")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationHsv"]]], result)

    @builtins.property
    def if_dimension(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimension"]]]:
        '''if_dimension block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        '''
        result = self._values.get("if_dimension")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimension"]]], result)

    @builtins.property
    def if_orientation(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientation"]]]:
        '''if_orientation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        '''
        result = self._values.get("if_orientation")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientation"]]], result)

    @builtins.property
    def max_colors(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationMaxColors"]]]:
        '''max_colors block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        '''
        result = self._values.get("max_colors")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationMaxColors"]]], result)

    @builtins.property
    def mirror(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationMirror"]]]:
        '''mirror block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        '''
        result = self._values.get("mirror")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationMirror"]]], result)

    @builtins.property
    def mono_hue(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationMonoHue"]]]:
        '''mono_hue block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        '''
        result = self._values.get("mono_hue")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationMonoHue"]]], result)

    @builtins.property
    def opacity(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationOpacity"]]]:
        '''opacity block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationOpacity"]]], result)

    @builtins.property
    def remove_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationRemoveColor"]]]:
        '''remove_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        '''
        result = self._values.get("remove_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationRemoveColor"]]], result)

    @builtins.property
    def unsharp_mask(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationUnsharpMask"]]]:
        '''unsharp_mask block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        result = self._values.get("unsharp_mask")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationUnsharpMask"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationBackgroundColor",
    jsii_struct_bases=[],
    name_mapping={"color": "color", "color_var": "colorVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationBackgroundColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__30522af3b6344b2c8885db16b029635632014bdfe6ff3f6179bf0c0b7d2cb60c)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationBackgroundColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationBackgroundColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationBackgroundColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dcea3d1088dd675df48b1e478efab6b05506aa032a0d541096642db50fb90f73)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationBackgroundColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__61a866810a9552b2cf991295c32701c85c72cb835e3ff7209e0031a3743a9e8d)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationBackgroundColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__92a9729c5161e54b485353997003bb31bd60e5bd90f28c6ece9a12b0ffb11852)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__95b785a62d883dbbf8eb2aac1e0f74fdcb8836d6ee6e2c51af235512c921595f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9977f4f782981f61503ad33d57e4dd024b4bf6f14ef63301e0d3ace55c09da83)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationBackgroundColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationBackgroundColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ca8775b06c9d8299dd81767aa6a0247e3c9c349b39b3490f179f6e902441f7d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationBackgroundColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationBackgroundColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ce77e447c6bb4c06fbe20a5863ddfffc7fd12db7573809f208a32c1b01a86fea)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2bef3eebd3dfff4cd822e57755606500ebee844eb9d039a6892eae3a2e58366e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__69fc3998f14516881bd08511eda808f67580d9789e3f7e50d5c0892c9a1498a3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationBackgroundColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationBackgroundColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationBackgroundColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__72ffb9518ea62fa2ed0f2a8c2400dbdf0560aa6ea52b3bfde14e198466db6eea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationBlur",
    jsii_struct_bases=[],
    name_mapping={"sigma": "sigma", "sigma_var": "sigmaVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationBlur:
    def __init__(
        self,
        *,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param sigma: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__05cfb3995700f931d3a6a0ad85fc3652a6360bc6f1a91fa970e82b833bdcc63c)
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationBlur(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationBlurList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationBlurList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__941494874811e49b05fa7efa3a9b78a0b5ca47c3e5b0ce554c89c3b1ff0f4eb7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationBlurOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d2d3f172e9095b73b91656a2168a3d5c2a1d3cee775e6676b67b3993b40fca23)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationBlurOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2e01fb2ab559b482921587ba51efda264ebce9255d90f9e871bbf5a11b59f0f0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a5b2630b8f1324f8acf6fedf04addbfc521c12c0b4550aac836ba01ceb8181d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__27670af9a053e024f65a9e264096f64c6e256097de245049211998d6e6e6ebbf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationBlur]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationBlur]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cb10aff993a95fe3578608cf5d696b1172176efef80ec9eda5208d54b252ba94)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationBlurOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationBlurOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b6d2fe43faae84271a6d79d26be68dcf7abfc0d6c083b332f52ae07e1dd2f7d4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c298adb5759c08fcba307ce80b14a6584c3f31d9ed79001c5b3c43572c4f5519)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__93e45ed2757e993096d28bfdfc98f13150a3841d64833b58c29ca19a9e53b4ff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationBlur]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationBlur]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationBlur]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a13715b4a8ee420105c9f500cdbc5f771d405de037374f9c8c173722815a574)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationChromaKey",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_feather": "hueFeather",
        "hue_feather_var": "hueFeatherVar",
        "hue_tolerance": "hueTolerance",
        "hue_tolerance_var": "hueToleranceVar",
        "hue_var": "hueVar",
        "lightness_feather": "lightnessFeather",
        "lightness_feather_var": "lightnessFeatherVar",
        "lightness_tolerance": "lightnessTolerance",
        "lightness_tolerance_var": "lightnessToleranceVar",
        "saturation_feather": "saturationFeather",
        "saturation_feather_var": "saturationFeatherVar",
        "saturation_tolerance": "saturationTolerance",
        "saturation_tolerance_var": "saturationToleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationChromaKey:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_feather: typing.Optional[builtins.str] = None,
        hue_feather_var: typing.Optional[builtins.str] = None,
        hue_tolerance: typing.Optional[builtins.str] = None,
        hue_tolerance_var: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness_feather: typing.Optional[builtins.str] = None,
        lightness_feather_var: typing.Optional[builtins.str] = None,
        lightness_tolerance: typing.Optional[builtins.str] = None,
        lightness_tolerance_var: typing.Optional[builtins.str] = None,
        saturation_feather: typing.Optional[builtins.str] = None,
        saturation_feather_var: typing.Optional[builtins.str] = None,
        saturation_tolerance: typing.Optional[builtins.str] = None,
        saturation_tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_feather: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        :param hue_feather_var: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        :param hue_tolerance: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        :param hue_tolerance_var: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        :param hue_var: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness_feather: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        :param lightness_feather_var: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        :param lightness_tolerance: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        :param lightness_tolerance_var: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        :param saturation_feather: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        :param saturation_feather_var: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        :param saturation_tolerance: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        :param saturation_tolerance_var: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6afce501b19dc8d19d402b611e65ab8118438dda500417b79c6f11fff217ac9b)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_feather", value=hue_feather, expected_type=type_hints["hue_feather"])
            check_type(argname="argument hue_feather_var", value=hue_feather_var, expected_type=type_hints["hue_feather_var"])
            check_type(argname="argument hue_tolerance", value=hue_tolerance, expected_type=type_hints["hue_tolerance"])
            check_type(argname="argument hue_tolerance_var", value=hue_tolerance_var, expected_type=type_hints["hue_tolerance_var"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness_feather", value=lightness_feather, expected_type=type_hints["lightness_feather"])
            check_type(argname="argument lightness_feather_var", value=lightness_feather_var, expected_type=type_hints["lightness_feather_var"])
            check_type(argname="argument lightness_tolerance", value=lightness_tolerance, expected_type=type_hints["lightness_tolerance"])
            check_type(argname="argument lightness_tolerance_var", value=lightness_tolerance_var, expected_type=type_hints["lightness_tolerance_var"])
            check_type(argname="argument saturation_feather", value=saturation_feather, expected_type=type_hints["saturation_feather"])
            check_type(argname="argument saturation_feather_var", value=saturation_feather_var, expected_type=type_hints["saturation_feather_var"])
            check_type(argname="argument saturation_tolerance", value=saturation_tolerance, expected_type=type_hints["saturation_tolerance"])
            check_type(argname="argument saturation_tolerance_var", value=saturation_tolerance_var, expected_type=type_hints["saturation_tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_feather is not None:
            self._values["hue_feather"] = hue_feather
        if hue_feather_var is not None:
            self._values["hue_feather_var"] = hue_feather_var
        if hue_tolerance is not None:
            self._values["hue_tolerance"] = hue_tolerance
        if hue_tolerance_var is not None:
            self._values["hue_tolerance_var"] = hue_tolerance_var
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness_feather is not None:
            self._values["lightness_feather"] = lightness_feather
        if lightness_feather_var is not None:
            self._values["lightness_feather_var"] = lightness_feather_var
        if lightness_tolerance is not None:
            self._values["lightness_tolerance"] = lightness_tolerance
        if lightness_tolerance_var is not None:
            self._values["lightness_tolerance_var"] = lightness_tolerance_var
        if saturation_feather is not None:
            self._values["saturation_feather"] = saturation_feather
        if saturation_feather_var is not None:
            self._values["saturation_feather_var"] = saturation_feather_var
        if saturation_tolerance is not None:
            self._values["saturation_tolerance"] = saturation_tolerance
        if saturation_tolerance_var is not None:
            self._values["saturation_tolerance_var"] = saturation_tolerance_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        '''
        result = self._values.get("hue_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        '''
        result = self._values.get("hue_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        '''
        result = self._values.get("hue_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        '''
        result = self._values.get("hue_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        '''
        result = self._values.get("lightness_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        '''
        result = self._values.get("lightness_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        '''
        result = self._values.get("lightness_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        '''
        result = self._values.get("lightness_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        '''
        result = self._values.get("saturation_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        '''
        result = self._values.get("saturation_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        '''
        result = self._values.get("saturation_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        result = self._values.get("saturation_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationChromaKey(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationChromaKeyList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationChromaKeyList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7a7c5d393e42df0725f3ca6bb7074f0acc07c231a8830834444268b0b38516c5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationChromaKeyOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ae7a720ca460df54705ba32f844138f04e5506fa4cba3e38b9b264ecf86e347)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationChromaKeyOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d8dff3c886e3030e54fb3482c8d2b8c09d6471a2acc4433d4e53949411a0bf5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__227267afe4c91d79c00a4a83abc49a32d361bd3d624052b937ccea9be3c9bfe7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__429ca8c73c5577e6ee9fe40d30e5afc492d4e9c30d23c04da12b93cc7614cb65)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationChromaKey]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationChromaKey]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__db4312433fbb2286507844f7c87235bf52b0c6d5880164e457dba34efe776850)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationChromaKeyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationChromaKeyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ee18730421b1421f0a7ff5876f08b6b84ca6a36c4856e0f9733ca4fc131e6e68)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueFeather")
    def reset_hue_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeather", []))

    @jsii.member(jsii_name="resetHueFeatherVar")
    def reset_hue_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeatherVar", []))

    @jsii.member(jsii_name="resetHueTolerance")
    def reset_hue_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueTolerance", []))

    @jsii.member(jsii_name="resetHueToleranceVar")
    def reset_hue_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueToleranceVar", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightnessFeather")
    def reset_lightness_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeather", []))

    @jsii.member(jsii_name="resetLightnessFeatherVar")
    def reset_lightness_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeatherVar", []))

    @jsii.member(jsii_name="resetLightnessTolerance")
    def reset_lightness_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessTolerance", []))

    @jsii.member(jsii_name="resetLightnessToleranceVar")
    def reset_lightness_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessToleranceVar", []))

    @jsii.member(jsii_name="resetSaturationFeather")
    def reset_saturation_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeather", []))

    @jsii.member(jsii_name="resetSaturationFeatherVar")
    def reset_saturation_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeatherVar", []))

    @jsii.member(jsii_name="resetSaturationTolerance")
    def reset_saturation_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationTolerance", []))

    @jsii.member(jsii_name="resetSaturationToleranceVar")
    def reset_saturation_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherInput")
    def hue_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVarInput")
    def hue_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceInput")
    def hue_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVarInput")
    def hue_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherInput")
    def lightness_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVarInput")
    def lightness_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceInput")
    def lightness_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVarInput")
    def lightness_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherInput")
    def saturation_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVarInput")
    def saturation_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceInput")
    def saturation_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVarInput")
    def saturation_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fc41b7809a75f640660ed8712e7c0474b7e055f4e7535722dfef9c5281cb1652)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeather")
    def hue_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeather"))

    @hue_feather.setter
    def hue_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__88749e49c031901dbe7a8d8f0c9e61e4361be455113322552a52451c38d7216d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeather", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVar")
    def hue_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeatherVar"))

    @hue_feather_var.setter
    def hue_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5429641f1f3013cf2049cf3dd3ca62aa27dc7fe193b9d9bf0a57828c381307c5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueTolerance")
    def hue_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueTolerance"))

    @hue_tolerance.setter
    def hue_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c862cd201e52f863702556a95beca697a8a33558818bb98a99ad9f8eb1df9cb0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVar")
    def hue_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueToleranceVar"))

    @hue_tolerance_var.setter
    def hue_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8b1600c99c086096ac140cb856ef2d7ba5d67fe4c4656387ef49d3b4d46f666e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e5fe72d179422f7b52555a485595271774ef4878acbbd34dc3e832733989224f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeather")
    def lightness_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeather"))

    @lightness_feather.setter
    def lightness_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eb042ba85cdeb3bdec521ada18bf0754aa88408d6fddb075b04b8508fb23566d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeather", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVar")
    def lightness_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeatherVar"))

    @lightness_feather_var.setter
    def lightness_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__afaabfb8a37d924a7d3d231b43c2224e76dcb4251a755aafe37f51df0fe3bf06)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessTolerance")
    def lightness_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessTolerance"))

    @lightness_tolerance.setter
    def lightness_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fe63fa645729bc4a91a75a2e674e7c8a06b205876c29784639aa1cca97bed075)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVar")
    def lightness_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessToleranceVar"))

    @lightness_tolerance_var.setter
    def lightness_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__634b5a9a37db8f68774526c65f302d0a69a5dc2f70ccfa9a3709c83b807ea3a4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeather")
    def saturation_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeather"))

    @saturation_feather.setter
    def saturation_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cf3d8fe889833bb06798ca78aef325130771c5b4f748a7949c9ae7784d7ddb40)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeather", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVar")
    def saturation_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeatherVar"))

    @saturation_feather_var.setter
    def saturation_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3dc3d875e51c15504b86ed06693afb3dfc66a6530adbc6fa79c493aafbadf9df)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationTolerance")
    def saturation_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationTolerance"))

    @saturation_tolerance.setter
    def saturation_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5b79d4ac78294510b0b9ebfdfd64278067d0ee34529a4bef9aeb5efaa30b5151)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVar")
    def saturation_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationToleranceVar"))

    @saturation_tolerance_var.setter
    def saturation_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a431a5fe0a739bdacb74e4796cbdf7fb3d8b7351f56e43ecb95ca02db7390ee7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationChromaKey]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationChromaKey]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationChromaKey]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aa17be3ecd3f87acb33c7958e732d0e8115894f92a2db2b6bd47e0d2c711d757)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationComposite",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "placement": "placement",
        "placement_var": "placementVar",
        "scale": "scale",
        "scale_dimension": "scaleDimension",
        "scale_dimension_var": "scaleDimensionVar",
        "scale_var": "scaleVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationComposite:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationCompositeImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        placement: typing.Optional[builtins.str] = None,
        placement_var: typing.Optional[builtins.str] = None,
        scale: typing.Optional[builtins.str] = None,
        scale_dimension: typing.Optional[builtins.str] = None,
        scale_dimension_var: typing.Optional[builtins.str] = None,
        scale_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param placement: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        :param placement_var: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        :param scale: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param scale_dimension: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        :param scale_dimension_var: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        :param scale_var: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        :param x_position: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationCompositeImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7e4aa1278f9a75e7ce2d51aabb9d78c4b76abb7e2ea28bb03dafe59c0591a66a)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument placement", value=placement, expected_type=type_hints["placement"])
            check_type(argname="argument placement_var", value=placement_var, expected_type=type_hints["placement_var"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument scale_dimension", value=scale_dimension, expected_type=type_hints["scale_dimension"])
            check_type(argname="argument scale_dimension_var", value=scale_dimension_var, expected_type=type_hints["scale_dimension_var"])
            check_type(argname="argument scale_var", value=scale_var, expected_type=type_hints["scale_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if placement is not None:
            self._values["placement"] = placement
        if placement_var is not None:
            self._values["placement_var"] = placement_var
        if scale is not None:
            self._values["scale"] = scale
        if scale_dimension is not None:
            self._values["scale_dimension"] = scale_dimension
        if scale_dimension_var is not None:
            self._values["scale_dimension_var"] = scale_dimension_var
        if scale_var is not None:
            self._values["scale_var"] = scale_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationCompositeImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationCompositeImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        '''
        result = self._values.get("placement")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement_var(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        '''
        result = self._values.get("placement_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        '''
        result = self._values.get("scale_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        '''
        result = self._values.get("scale_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        '''
        result = self._values.get("scale_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationComposite(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationCompositeImage",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationCompositeImage:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationCompositeImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationCompositeImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationCompositeImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0615ee2da717e17578e4097fe813c2d50541c3e7318384e2650696e3526c5a34)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationCompositeImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationCompositeImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d44e75989e49ad048a59713acd0bbfc2d61a35e948c017bd8fa97c8381b858a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationCompositeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationCompositeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aa6fa65e38eefdb24d2e7688d3201b24429df4d2b211a747d8927d68aa6e6a46)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationCompositeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7302fad2881e142ff9f7a167f9b6ee8ef7f32b0db4b154273c81ad3f5def9fef)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationCompositeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e70ff7b2b5b67a90a8fb593a1a73b1387044ab7a9b0944aac1f3a62c4b4d530)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c217e8855df29844b7e4efbe1725bad2e0e874123362e92c30198f1df4e1b7b6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f1a319057868d254ac84cde3482deee168557cbfa32667c9184a65942496d720)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationComposite]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationComposite]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e9ec462a0d4e43f7bab35b37320698e9014830205805704552505637fb81ddf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationCompositeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationCompositeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d4bde07127e3daae6625cd53e25f1d876d574c2a55a7a31f65686f6cbe6550fc)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationCompositeImage()

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPlacement")
    def reset_placement(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacement", []))

    @jsii.member(jsii_name="resetPlacementVar")
    def reset_placement_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacementVar", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetScaleDimension")
    def reset_scale_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimension", []))

    @jsii.member(jsii_name="resetScaleDimensionVar")
    def reset_scale_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimensionVar", []))

    @jsii.member(jsii_name="resetScaleVar")
    def reset_scale_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationCompositeImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationCompositeImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationCompositeImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="placementInput")
    def placement_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementInput"))

    @builtins.property
    @jsii.member(jsii_name="placementVarInput")
    def placement_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionInput")
    def scale_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVarInput")
    def scale_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleVarInput")
    def scale_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__54cafbe46adf84bc73ad86ce005aa8eb82eb7412bb36011316eacb2c64773aeb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b75a26a198d345784db6658b360c2dc2c835ea3444c31b6445df222c7e6ee89d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="placement")
    def placement(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placement"))

    @placement.setter
    def placement(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6054912ae93931da9f99a764f6f94b5790c29268626a3194b07ccf7ef582bd45)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placement", value)

    @builtins.property
    @jsii.member(jsii_name="placementVar")
    def placement_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placementVar"))

    @placement_var.setter
    def placement_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2992c214103089009fa83524d72fc788da0964ee0ef47991b5e9464c6cb44136)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placementVar", value)

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scale"))

    @scale.setter
    def scale(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b353257637dbaf480fc4c5e676f46b7e60b43302b562550d71146c8979c48b72)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scale", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimension")
    def scale_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimension"))

    @scale_dimension.setter
    def scale_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b933dc79832fea1c194f8698e32f479b4976fe52fde6295624dd3727fcaf5c8e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimension", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVar")
    def scale_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimensionVar"))

    @scale_dimension_var.setter
    def scale_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0028c7fbc9f656be3a2cef149ececda2f36197a8c0853605d51fb96643c5c235)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="scaleVar")
    def scale_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleVar"))

    @scale_var.setter
    def scale_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__27d618ff7a3f16816306857a2f521ef584422d014212f85e889b4f5ed8c413ef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d4bd8d29e7b891ca6df624e23bbd6d2e20fc9a6154ca11767e8d71d33df4889)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a0a454a3d294a747f7edfbf9b822995e5935584f6700410575a9109c0c244ad2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa6f42bf2c06018ddc689b673ff7994a7d0421d7bbb8e5f8b9ab2f3ee8affde7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1c2c92236773b8814548bd18235762b20316b3afc05f1cfdb478048bc99c06ed)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationComposite]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationComposite]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationComposite]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__66c1bd006788d164614978d525a2433c1af976ce9e4b3e75600ca2c46739e753)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationCompound",
    jsii_struct_bases=[],
    name_mapping={"transformations": "transformations"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationCompound:
    def __init__(
        self,
        *,
        transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param transformations: transformations block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__407566b7147b9d2ceb8c2e05416a2cc572b57954cfda9648983104fed5242b4d)
            check_type(argname="argument transformations", value=transformations, expected_type=type_hints["transformations"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if transformations is not None:
            self._values["transformations"] = transformations

    @builtins.property
    def transformations(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationCompoundTransformations"]]]:
        '''transformations block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        result = self._values.get("transformations")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationCompoundTransformations"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationCompound(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationCompoundList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationCompoundList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__31bfec7f8d143a35f93c84a56730cbabf678141ef16ecf77ab5783a739f63a04)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationCompoundOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__84e455f0d4280d6e4ee4d8f513b243d56984cb3858b03d44e5fb6cff0afc769a)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationCompoundOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__779ca093110a7b72c245b977638f0304fe0ac395e1c5281ddb7c2ccc87008ba3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__628091be3a7d23f149881ca9b220e2dff0435f0fb3e87efa4482d523898d2aa0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__039debaa949152495c8d090587216f0914069530e7a8205beaac833cb0af39cc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationCompound]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationCompound]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2f1a4fff9d562e1376c4f5d334b4a09cc2e22335768d2d6527fdba7d23a0f5e6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationCompoundOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationCompoundOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d24a908324dab3337523de99bc0130639c8c09bdf120a578e8ccd624e7e87a1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformations")
    def put_transformations(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9c01f3c1bd6435e96b0969f132efeda10f51c8ddc4c25031f1d27b17775640bb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTransformations", [value]))

    @jsii.member(jsii_name="resetTransformations")
    def reset_transformations(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformations", []))

    @builtins.property
    @jsii.member(jsii_name="transformations")
    def transformations(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationCompoundTransformationsList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationCompoundTransformationsList", jsii.get(self, "transformations"))

    @builtins.property
    @jsii.member(jsii_name="transformationsInput")
    def transformations_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationCompoundTransformations"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationCompoundTransformations"]]], jsii.get(self, "transformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationCompound]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationCompound]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationCompound]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4e06e0b16921febcd53487275a00167d7e389ae202210691caa350930f795699)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationCompoundTransformations",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationCompoundTransformations:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationCompoundTransformations(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationCompoundTransformationsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationCompoundTransformationsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c9e2c95f815e2e52591f11df5103695e80a7b781e13feb80d2e9a240f9ab4bd7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationCompoundTransformationsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0276ee3e5810bbeedf50c48ae95efbe334d77e98594072177a5844c68692b8ef)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationCompoundTransformationsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e25f54ab08c3938d4047d676f8268c883f05951cab3e5100961153fcf4f4c240)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d2bcb2e565108c9e0c6dc2221216391a9c26d9e35711eb1846878c89a66e32ab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__20202598f8889ebc68a2372b4412689afb0ced2f4c22f3ee9adc41e0ee8aa87c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationCompoundTransformations]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationCompoundTransformations]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationCompoundTransformations]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b88c0f37e104cc00ac5e240922f4e32fafab98eb9194da6aa87525a9e3fb86ce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationCompoundTransformationsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationCompoundTransformationsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab54377f70d8a3b29225e419b3810d9af5b3f7555455074cf71b4a31eee6fd58)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationCompoundTransformations]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationCompoundTransformations]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationCompoundTransformations]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__171d236f223af06edfd7d7414a8c44878376584c2d657860c1e9b97227b9db8c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationContrast",
    jsii_struct_bases=[],
    name_mapping={
        "brightness": "brightness",
        "brightness_var": "brightnessVar",
        "contrast": "contrast",
        "contrast_var": "contrastVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationContrast:
    def __init__(
        self,
        *,
        brightness: typing.Optional[builtins.str] = None,
        brightness_var: typing.Optional[builtins.str] = None,
        contrast: typing.Optional[builtins.str] = None,
        contrast_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param brightness: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        :param brightness_var: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        :param contrast: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param contrast_var: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8b75e5ce898f2f273cdfd004ba521227f19a823710db560cb51f49c232d8ec5b)
            check_type(argname="argument brightness", value=brightness, expected_type=type_hints["brightness"])
            check_type(argname="argument brightness_var", value=brightness_var, expected_type=type_hints["brightness_var"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument contrast_var", value=contrast_var, expected_type=type_hints["contrast_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if brightness is not None:
            self._values["brightness"] = brightness
        if brightness_var is not None:
            self._values["brightness_var"] = brightness_var
        if contrast is not None:
            self._values["contrast"] = contrast
        if contrast_var is not None:
            self._values["contrast_var"] = contrast_var

    @builtins.property
    def brightness(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        '''
        result = self._values.get("brightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def brightness_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        '''
        result = self._values.get("brightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        result = self._values.get("contrast_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationContrast(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationContrastList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationContrastList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__72ebcc0c758872d545f236d53651025e9c6adb05b7c7dfeb3d259e75cd53fff7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationContrastOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c9c21964ddd24ee6bf08b2cf8eeb3b25150a1fab2b432e113ae7cd9b339b40bd)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationContrastOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f4dab5573f560c3fca708b800679e7b690a55db419a3a498a51b3fad0c636b48)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__994bb6ae608a15d2b054f6577dbf5e3673b49255c4cb2e68c5ca5c14cfb0e1eb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5d242c2671c9a6735442f08ad8ea9cb7ea9c39ea72d3f271770231fd7452baad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationContrast]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationContrast]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__85743220209370b64756ac89639525918f641d24351b9e824afa80733beb3024)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationContrastOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationContrastOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__52fed364b3f01c7c61c1d33723fd8a5e417327bbd927910002743832734b1614)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetBrightness")
    def reset_brightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightness", []))

    @jsii.member(jsii_name="resetBrightnessVar")
    def reset_brightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightnessVar", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetContrastVar")
    def reset_contrast_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrastVar", []))

    @builtins.property
    @jsii.member(jsii_name="brightnessInput")
    def brightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="brightnessVarInput")
    def brightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastVarInput")
    def contrast_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="brightness")
    def brightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightness"))

    @brightness.setter
    def brightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b21b7c7100281e6196c2bd67c36a83d9ccfcdfbd6e5317263557697570e6bdb2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightness", value)

    @builtins.property
    @jsii.member(jsii_name="brightnessVar")
    def brightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightnessVar"))

    @brightness_var.setter
    def brightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__12d72c3bc4f6fbac86e039246b28e5c8323e668654e9f6692310096ca422980a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrast"))

    @contrast.setter
    def contrast(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c43a07a638df7e26ef5a6a55722c60419702621d5f04eab18bd4cef0de59412d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrast", value)

    @builtins.property
    @jsii.member(jsii_name="contrastVar")
    def contrast_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrastVar"))

    @contrast_var.setter
    def contrast_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fcee963c2368ce2e0268d13917ba939937a32a2aff204b444504ddcb359db54a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrastVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationContrast]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationContrast]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationContrast]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dedbd357bb51fed519e467d84d9b5b14e539c929327b16ca69a5c2e942af3e5f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationGoop",
    jsii_struct_bases=[],
    name_mapping={
        "chaos": "chaos",
        "chaos_var": "chaosVar",
        "density": "density",
        "density_var": "densityVar",
        "power": "power",
        "power_var": "powerVar",
        "seed": "seed",
        "seed_var": "seedVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationGoop:
    def __init__(
        self,
        *,
        chaos: typing.Optional[builtins.str] = None,
        chaos_var: typing.Optional[builtins.str] = None,
        density: typing.Optional[builtins.str] = None,
        density_var: typing.Optional[builtins.str] = None,
        power: typing.Optional[builtins.str] = None,
        power_var: typing.Optional[builtins.str] = None,
        seed: typing.Optional[builtins.str] = None,
        seed_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param chaos: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        :param chaos_var: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        :param density: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        :param density_var: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        :param power: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        :param power_var: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        :param seed: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        :param seed_var: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8230f36e560fbfdce628b3649fa8811e19134f1f7f743206236a870cb0196cbc)
            check_type(argname="argument chaos", value=chaos, expected_type=type_hints["chaos"])
            check_type(argname="argument chaos_var", value=chaos_var, expected_type=type_hints["chaos_var"])
            check_type(argname="argument density", value=density, expected_type=type_hints["density"])
            check_type(argname="argument density_var", value=density_var, expected_type=type_hints["density_var"])
            check_type(argname="argument power", value=power, expected_type=type_hints["power"])
            check_type(argname="argument power_var", value=power_var, expected_type=type_hints["power_var"])
            check_type(argname="argument seed", value=seed, expected_type=type_hints["seed"])
            check_type(argname="argument seed_var", value=seed_var, expected_type=type_hints["seed_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if chaos is not None:
            self._values["chaos"] = chaos
        if chaos_var is not None:
            self._values["chaos_var"] = chaos_var
        if density is not None:
            self._values["density"] = density
        if density_var is not None:
            self._values["density_var"] = density_var
        if power is not None:
            self._values["power"] = power
        if power_var is not None:
            self._values["power_var"] = power_var
        if seed is not None:
            self._values["seed"] = seed
        if seed_var is not None:
            self._values["seed_var"] = seed_var

    @builtins.property
    def chaos(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        '''
        result = self._values.get("chaos")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def chaos_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        '''
        result = self._values.get("chaos_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        '''
        result = self._values.get("density")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density_var(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        '''
        result = self._values.get("density_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        '''
        result = self._values.get("power")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power_var(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        '''
        result = self._values.get("power_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        '''
        result = self._values.get("seed")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed_var(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        result = self._values.get("seed_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationGoop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationGoopList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationGoopList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8786fd4a49d5c4a2f2c2c07368fb2e8f4c1c3006e518c70554b03d85b85bab97)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationGoopOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__43a06e65a296b3eca076f5211e1bb7a835ce5ae6ff348352261ef85b0fa3a916)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationGoopOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d9252d9c5911a2ae87f54a500381086893ce410c51a3ace2981ac2c03b36a649)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2f48ed24925133b0e6c649dfdf74c1a265f17e2c4fc13004ec4f615792ae39d5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__caebf66a0abe07ca41503a96c7d3f0bfc99813897e3249b6b294e2a7a2540752)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationGoop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationGoop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cc5e9dbfe0fe88ed7a8c7437b3ca50d75fec20e636d2569b61d43d2c756b1e4a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationGoopOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationGoopOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a48d7d2e516fcb9fc6d8692615cded4b142298f01a6ecf21f05f5762c9b1dc7b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetChaos")
    def reset_chaos(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaos", []))

    @jsii.member(jsii_name="resetChaosVar")
    def reset_chaos_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaosVar", []))

    @jsii.member(jsii_name="resetDensity")
    def reset_density(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensity", []))

    @jsii.member(jsii_name="resetDensityVar")
    def reset_density_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensityVar", []))

    @jsii.member(jsii_name="resetPower")
    def reset_power(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPower", []))

    @jsii.member(jsii_name="resetPowerVar")
    def reset_power_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPowerVar", []))

    @jsii.member(jsii_name="resetSeed")
    def reset_seed(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeed", []))

    @jsii.member(jsii_name="resetSeedVar")
    def reset_seed_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeedVar", []))

    @builtins.property
    @jsii.member(jsii_name="chaosInput")
    def chaos_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosInput"))

    @builtins.property
    @jsii.member(jsii_name="chaosVarInput")
    def chaos_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosVarInput"))

    @builtins.property
    @jsii.member(jsii_name="densityInput")
    def density_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityInput"))

    @builtins.property
    @jsii.member(jsii_name="densityVarInput")
    def density_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="powerInput")
    def power_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerInput"))

    @builtins.property
    @jsii.member(jsii_name="powerVarInput")
    def power_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerVarInput"))

    @builtins.property
    @jsii.member(jsii_name="seedInput")
    def seed_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedInput"))

    @builtins.property
    @jsii.member(jsii_name="seedVarInput")
    def seed_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedVarInput"))

    @builtins.property
    @jsii.member(jsii_name="chaos")
    def chaos(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaos"))

    @chaos.setter
    def chaos(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2972330de9cd3c6fcfa1763d7ca288990daefb858b90bb432d9e9a5cad343cc7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaos", value)

    @builtins.property
    @jsii.member(jsii_name="chaosVar")
    def chaos_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaosVar"))

    @chaos_var.setter
    def chaos_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a76a7f10211f51a3788f139986cc900f81be83247c1fd042db382bc6b941bb0a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaosVar", value)

    @builtins.property
    @jsii.member(jsii_name="density")
    def density(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "density"))

    @density.setter
    def density(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e5ef2eb2946981cef73de6d2fff8df858384b35f73e7fcaf34658caddaf72c34)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "density", value)

    @builtins.property
    @jsii.member(jsii_name="densityVar")
    def density_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "densityVar"))

    @density_var.setter
    def density_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aa05c98493e1c4aa1e5b5d660e678d7884a31cd1bf92109bfac36d480f2dfee5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "densityVar", value)

    @builtins.property
    @jsii.member(jsii_name="power")
    def power(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "power"))

    @power.setter
    def power(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1443f1d0f5f08b49d232889762f3f184260d0cc47006a4d822fe777dd242cdb4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "power", value)

    @builtins.property
    @jsii.member(jsii_name="powerVar")
    def power_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "powerVar"))

    @power_var.setter
    def power_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ac510949646cb0f4f2758f58d02fe7967371b12f6c639e9773fefe8afd27fb7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "powerVar", value)

    @builtins.property
    @jsii.member(jsii_name="seed")
    def seed(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seed"))

    @seed.setter
    def seed(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__95c5bb86b0e5dfcf957db137a201cd7dce81236ce6d20acf3c828db52a9c4f1f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seed", value)

    @builtins.property
    @jsii.member(jsii_name="seedVar")
    def seed_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seedVar"))

    @seed_var.setter
    def seed_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cf854c3a404160b094a3c8fda41b46e16693b319b2f20c585e761feff0a8b9e4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seedVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationGoop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationGoop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationGoop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5fefa7928a5de6c78f62d8d704465220508aa4611ac19cbd4111e43eddb5f8ed)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationGrayscale",
    jsii_struct_bases=[],
    name_mapping={"type": "type", "type_var": "typeVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationGrayscale:
    def __init__(
        self,
        *,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param type: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__419223a214c77c4ff60e38184f83d663d828bcb5af5483876d9f4b2a143da169)
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationGrayscale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationGrayscaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationGrayscaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8dea9d6416f2837c4cca2739d22a3b42d1b67d914910fba61c7624f2f7535e6a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationGrayscaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac073d3ba28975f2a4b702ae9af5b085cf98bf4e624353a926b8c8b5f01f3f44)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationGrayscaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__debb5bb1c30c3066d1d2e9b91361db14d8d37c822b6ed2ad35e7071154edcb2f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b3125597d658ed44f7cad70461e15605d822999b7930836c3b5fe398be436bdb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__387d5d3a3643ce772522429c1e57219b6b6ea2ed9d420811e5bd20b2e71e1ebc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationGrayscale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationGrayscale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c252ac705a360e4c7330ab446b7e6ca669ebf11ab6c46e2f2412e4c9f66044bf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationGrayscaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationGrayscaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc97f7a16a3dd3cbdd41575e892c8b01903dce1a6d2e775037c1b08055f70cb1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc14d6b5209c6e92a1aff7289d08fc5a9f7167cd04fdef448168c4571babdee5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ddca39d4cf69b50c53b78d027a79808996bb8911641b2c67ba1f4f2734ac69e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationGrayscale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationGrayscale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationGrayscale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__039c3742cb1215c080bfde9ec454fa4e1b569169747d2856f9231c5c48f99766)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationHsl",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "lightness": "lightness",
        "lightness_var": "lightnessVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationHsl:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness: typing.Optional[builtins.str] = None,
        lightness_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        :param lightness_var: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d9e8ee08de9db3c41188f481886003e64c025b8bf84ebde33168576e3660d1bc)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness", value=lightness, expected_type=type_hints["lightness"])
            check_type(argname="argument lightness_var", value=lightness_var, expected_type=type_hints["lightness_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness is not None:
            self._values["lightness"] = lightness
        if lightness_var is not None:
            self._values["lightness_var"] = lightness_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        '''
        result = self._values.get("lightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        '''
        result = self._values.get("lightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationHsl(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationHslList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationHslList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__84b2d15c116439556114319738bcc36ae93f926c5af1b6906bbe64d2aa72ef73)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationHslOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f0087856d3ac752a265064000b28e41616d46e0d2e294e9dd960cc85a71e85a1)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationHslOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__415d99812a43aafd5bd6a91b8eada998fc45f0f63716effdb90e2d4743932e24)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab38330ed806e1d68a6ff522aa0e503eea7737ad3ce4402cd0cbcf638be8da59)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2db093292249fa50fd73d4b8c8e7b5831af113eda7ff05dc82804a83fd1a6b50)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationHsl]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationHsl]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b0b0c40d1609933a5799c9a843e8251265d01bf9b2e62e345c94d1d8acb3d9cc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationHslOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationHslOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__490d68c90977a55a4c6f5f84c13176d82f5cbab14f288e05110ef1c49e267d31)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightness")
    def reset_lightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightness", []))

    @jsii.member(jsii_name="resetLightnessVar")
    def reset_lightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessInput")
    def lightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessVarInput")
    def lightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f1506c113fff91be31d9dead734ec53eada165bd55e0242bbb52ec44d239b046)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a97325856e902dbb583115e1ed805d770cf16eb07111c512cd50c02c0105d09)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightness")
    def lightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightness"))

    @lightness.setter
    def lightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fac375921d79160007878c81f318b9210c8949aab44fe7955b127f4af7aea202)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightness", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessVar")
    def lightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessVar"))

    @lightness_var.setter
    def lightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d42b70de44e8fa839177bb02d5bba66f90a0546b2171a66619a8e5748eed5021)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1c1ff9fb1b8ff44cf67d035de029de188a1b4a872567206b6364bfeba986fda1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__036c6d60d9829d6738ca7c16804393a2e99d5f5cbe969bab0d206eb9de671d5a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationHsl]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationHsl]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationHsl]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b54db4647d3c406f398ba28673a7ef9f196dba202a09b614fd82db849f724ea4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationHsv",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationHsv:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        :param value: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e5206de7401159b99278b3bdf0859883182e3b9ec85b78736741e250bc3f191e)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationHsv(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationHsvList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationHsvList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__62d89822bce4953262d38530cb93f0d66a5f5f103164b37ce8bec10aa7133c62)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationHsvOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__06a4e7833c2c2a493b6165446f42840ffc7912a54021a8d1b515ed240d890caa)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationHsvOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__14faa8953fb7fbcd91525fd08ce770d0a9b5dc7d44b9b80d818176c54cb32cac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4c5e9b50d0f4b6b0814d7deec5a251fa0931e83c48b53544bb1702ad84d600dd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ad76be511c99fd842d8500d6f26b0a633f42f87d7e653ef758060415755adf27)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationHsv]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationHsv]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c1141216ca100ef66bde67351c4552575eb80635f228ea5022e94024698ebfcb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationHsvOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationHsvOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f0c5c4e408b0c72712a39f9043e3c522739a145a16876f5944ffb6542ed4625)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0cb387abb298becf413a5caf7d2d5d6d35f7c680bd6977fbe1bff2d6a2898b7e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d1a3e7ebba20eb5b74df6d1f4dab014449bac59b9530bdb1efd36a427268d118)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__599dfb9485a39f159a88f701e60ab6c8ebea674685d805a5049f5cc2403b8159)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f370d15e1b1d3d97745bc2c5548dad44c45ade1cc932daf2a2fb490922512d6b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__79f8a022a78ddaf510ff5819401389fe5d2dd160459a10c66dade2c4e2c6a9db)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d4b0531a09edfd18416a72efc9028eca6c24827bd18820b1b48883fed63508ee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationHsv]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationHsv]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationHsv]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9db0884630f7291c6d362fe73a96810d2497cc314ad46d2ceed72cbbd51cf37c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimension",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "dimension": "dimension",
        "dimension_var": "dimensionVar",
        "equal": "equal",
        "greater_than": "greaterThan",
        "less_than": "lessThan",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimension:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimensionDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        dimension: typing.Optional[builtins.str] = None,
        dimension_var: typing.Optional[builtins.str] = None,
        equal: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimensionEqual", typing.Dict[builtins.str, typing.Any]]] = None,
        greater_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimensionGreaterThan", typing.Dict[builtins.str, typing.Any]]] = None,
        less_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimensionLessThan", typing.Dict[builtins.str, typing.Any]]] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param dimension: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        :param dimension_var: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        :param equal: equal block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        :param greater_than: greater_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        :param less_than: less_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        :param value: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimensionDefault(**default)
        if isinstance(equal, dict):
            equal = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimensionEqual(**equal)
        if isinstance(greater_than, dict):
            greater_than = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimensionGreaterThan(**greater_than)
        if isinstance(less_than, dict):
            less_than = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimensionLessThan(**less_than)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1549268f54979625174243b9d8441b6730698a36a8bfd657470960788941ba00)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument dimension", value=dimension, expected_type=type_hints["dimension"])
            check_type(argname="argument dimension_var", value=dimension_var, expected_type=type_hints["dimension_var"])
            check_type(argname="argument equal", value=equal, expected_type=type_hints["equal"])
            check_type(argname="argument greater_than", value=greater_than, expected_type=type_hints["greater_than"])
            check_type(argname="argument less_than", value=less_than, expected_type=type_hints["less_than"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if dimension is not None:
            self._values["dimension"] = dimension
        if dimension_var is not None:
            self._values["dimension_var"] = dimension_var
        if equal is not None:
            self._values["equal"] = equal
        if greater_than is not None:
            self._values["greater_than"] = greater_than
        if less_than is not None:
            self._values["less_than"] = less_than
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimensionDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimensionDefault"], result)

    @builtins.property
    def dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        '''
        result = self._values.get("dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        '''
        result = self._values.get("dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def equal(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimensionEqual"]:
        '''equal block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        '''
        result = self._values.get("equal")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimensionEqual"], result)

    @builtins.property
    def greater_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimensionGreaterThan"]:
        '''greater_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        '''
        result = self._values.get("greater_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimensionGreaterThan"], result)

    @builtins.property
    def less_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimensionLessThan"]:
        '''less_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        '''
        result = self._values.get("less_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimensionLessThan"], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimension(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimensionDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimensionDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimensionDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimensionDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimensionDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ce60d478003e47524dac468310f338dbd9705245927feeadb5e59aa4f5c07461)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimensionDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimensionDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f673e162f3014b4c51aafab253f3de53cbf06da5b4d1220cef40ee2d443c255)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimensionEqual",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimensionEqual:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimensionEqual(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimensionEqualOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimensionEqualOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e69b70a2a580b62154cd6992cbc568e31c211d6420d9b2d71e484013103d0205)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimensionEqual], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimensionEqual],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7afb524a7dc492d9ed4dd78671210d0e37fe36de1c58b9b10c407b97a961c8cc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimensionGreaterThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimensionGreaterThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimensionGreaterThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimensionGreaterThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimensionGreaterThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b6e097669a503fee0900e3393d243b554ee93873d3530d654d3b88ec8fdd2553)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimensionGreaterThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimensionGreaterThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__50a96789837d84f42c81f85af4669d4febf64a41acf7d49fcb9a63eec7bc2cd7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimensionLessThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimensionLessThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimensionLessThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimensionLessThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimensionLessThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ca25a2a4315f6318cc15317ff76b0f55fadebe2ef5f9ee564f00b4e828d16881)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimensionLessThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimensionLessThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__56442d15c0d3892223e1452aee156f63dd80ed82c077900ecb230669baed356f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimensionList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimensionList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f6135fdd135e6c868ce2fc4ff3f157298c48e365ca9e8527a0c33724d4d1ca8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimensionOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__28e3124521fd1d793cedc43bfe390a5bd285fc29d93fca122bc3b627c0e7faf9)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimensionOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fbfbef93f87ee6983fe8a37a5467290afa08bf4555161a974e917012f067e964)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a0bd213293487d0c9359d37e2a6c3b5ade20ab540da423a71a738adca060f467)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__38606966ec1870db622bf727e844553cb5954e11b09a3a15a7c9912a5be013cb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimension]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimension]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__653ebf475ec67dd0454bacb56db28b8b85df0ca6f6647214d520e90a9d4bfdda)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimensionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimensionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa8a7496b90b7ec28222e23ca86464a6b50ca4e373b234f8acdc6e3a506179f8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimensionDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putEqual")
    def put_equal(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimensionEqual()

        return typing.cast(None, jsii.invoke(self, "putEqual", [value]))

    @jsii.member(jsii_name="putGreaterThan")
    def put_greater_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimensionGreaterThan()

        return typing.cast(None, jsii.invoke(self, "putGreaterThan", [value]))

    @jsii.member(jsii_name="putLessThan")
    def put_less_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimensionLessThan()

        return typing.cast(None, jsii.invoke(self, "putLessThan", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetDimension")
    def reset_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimension", []))

    @jsii.member(jsii_name="resetDimensionVar")
    def reset_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimensionVar", []))

    @jsii.member(jsii_name="resetEqual")
    def reset_equal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEqual", []))

    @jsii.member(jsii_name="resetGreaterThan")
    def reset_greater_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGreaterThan", []))

    @jsii.member(jsii_name="resetLessThan")
    def reset_less_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLessThan", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimensionDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimensionDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="equal")
    def equal(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimensionEqualOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimensionEqualOutputReference, jsii.get(self, "equal"))

    @builtins.property
    @jsii.member(jsii_name="greaterThan")
    def greater_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimensionGreaterThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimensionGreaterThanOutputReference, jsii.get(self, "greaterThan"))

    @builtins.property
    @jsii.member(jsii_name="lessThan")
    def less_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimensionLessThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimensionLessThanOutputReference, jsii.get(self, "lessThan"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimensionDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionInput")
    def dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionVarInput")
    def dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="equalInput")
    def equal_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimensionEqual], jsii.get(self, "equalInput"))

    @builtins.property
    @jsii.member(jsii_name="greaterThanInput")
    def greater_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimensionGreaterThan], jsii.get(self, "greaterThanInput"))

    @builtins.property
    @jsii.member(jsii_name="lessThanInput")
    def less_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimensionLessThan], jsii.get(self, "lessThanInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="dimension")
    def dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimension"))

    @dimension.setter
    def dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ffdf155f09883df8105378db7d1359528cfc3ce11f563aca203830945040620d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimension", value)

    @builtins.property
    @jsii.member(jsii_name="dimensionVar")
    def dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimensionVar"))

    @dimension_var.setter
    def dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d9bc5ed99618e5238f7480108c70d835e772404bd26dae4e4dc4948b11322de0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7189940994a12a16dd837a5e636960a60566f7f9436a219452385ba9565bb159)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cb12d099c2f8f249d70e4ba13cc751e27d2831d35f9d8ee1705264342f387745)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimension]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimension]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimension]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__69a17b57036a02ddeeb506332bbc5a1698499cd804301942d977b0a813ae7a00)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientation",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "landscape": "landscape",
        "portrait": "portrait",
        "square": "square",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientation:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientationDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        landscape: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientationLandscape", typing.Dict[builtins.str, typing.Any]]] = None,
        portrait: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientationPortrait", typing.Dict[builtins.str, typing.Any]]] = None,
        square: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientationSquare", typing.Dict[builtins.str, typing.Any]]] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param landscape: landscape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        :param portrait: portrait block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        :param square: square block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientationDefault(**default)
        if isinstance(landscape, dict):
            landscape = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientationLandscape(**landscape)
        if isinstance(portrait, dict):
            portrait = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientationPortrait(**portrait)
        if isinstance(square, dict):
            square = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientationSquare(**square)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f81c4f58131fcf7d91c5fa8129ee07e6f3e0c39c9e19725ab2ca472c2dab70c)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument landscape", value=landscape, expected_type=type_hints["landscape"])
            check_type(argname="argument portrait", value=portrait, expected_type=type_hints["portrait"])
            check_type(argname="argument square", value=square, expected_type=type_hints["square"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if landscape is not None:
            self._values["landscape"] = landscape
        if portrait is not None:
            self._values["portrait"] = portrait
        if square is not None:
            self._values["square"] = square

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientationDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientationDefault"], result)

    @builtins.property
    def landscape(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientationLandscape"]:
        '''landscape block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        '''
        result = self._values.get("landscape")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientationLandscape"], result)

    @builtins.property
    def portrait(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientationPortrait"]:
        '''portrait block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        '''
        result = self._values.get("portrait")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientationPortrait"], result)

    @builtins.property
    def square(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientationSquare"]:
        '''square block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        result = self._values.get("square")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientationSquare"], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientationDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientationDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientationDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientationDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientationDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9f7cda12f445cf15ccb5ad881ef0467cfcc1ff52622f03fca4f34b51ff1f9cd7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientationDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientationDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__54b5f5b75693863fc9a79b0e53a589c56e1782a5654801c1aac27a5635226b26)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientationLandscape",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientationLandscape:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientationLandscape(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientationLandscapeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientationLandscapeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__41d61ba78512e1ba69b69be9583920d0403ecff047ed43ee01d324f4eb787d5d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientationLandscape], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientationLandscape],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d29ec9b0668a91e9b76963d96cfa26dfa368899ea0cb77c6936b1b0035f5f5fb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientationList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientationList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__41bd0fed47db4378f2c664d8db10b70e590122ca4dafe6a3fc520634d8180f10)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientationOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f443024667650cdfef5a00b23a0319eae443b1478892a88fbdd790a772a566f9)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientationOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__618296cd132ab334a36e53e96e6e88530bd073446b6e776f5c4abf2d714a9e4b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9aa02c5e5d2121df46166faa9fd895d54dcbeb570045da6bfa6707ca60b34de8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c3b41a7a76a0b04df40a798d1f4506b662e852c644d810c193a0d2b6c3ddcdf3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientation]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientation]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b9ba7e95edf24b1e62f1c0dc8235cc3dc4084188174782d6c79da3543ae9f213)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__61addde8f3edb7fc0ff0aa636f91f33e9dbc37438d0ce670c1e45debe3698009)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientationDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putLandscape")
    def put_landscape(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientationLandscape()

        return typing.cast(None, jsii.invoke(self, "putLandscape", [value]))

    @jsii.member(jsii_name="putPortrait")
    def put_portrait(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientationPortrait()

        return typing.cast(None, jsii.invoke(self, "putPortrait", [value]))

    @jsii.member(jsii_name="putSquare")
    def put_square(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientationSquare()

        return typing.cast(None, jsii.invoke(self, "putSquare", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetLandscape")
    def reset_landscape(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLandscape", []))

    @jsii.member(jsii_name="resetPortrait")
    def reset_portrait(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPortrait", []))

    @jsii.member(jsii_name="resetSquare")
    def reset_square(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSquare", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientationDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientationDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="landscape")
    def landscape(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientationLandscapeOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientationLandscapeOutputReference, jsii.get(self, "landscape"))

    @builtins.property
    @jsii.member(jsii_name="portrait")
    def portrait(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientationPortraitOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientationPortraitOutputReference", jsii.get(self, "portrait"))

    @builtins.property
    @jsii.member(jsii_name="square")
    def square(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientationSquareOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientationSquareOutputReference", jsii.get(self, "square"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientationDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="landscapeInput")
    def landscape_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientationLandscape], jsii.get(self, "landscapeInput"))

    @builtins.property
    @jsii.member(jsii_name="portraitInput")
    def portrait_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientationPortrait"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientationPortrait"], jsii.get(self, "portraitInput"))

    @builtins.property
    @jsii.member(jsii_name="squareInput")
    def square_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientationSquare"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientationSquare"], jsii.get(self, "squareInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientation]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientation]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientation]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e3c28d7117506165dd316a76bfe9fafa688f2fd6e73916083047d8546714909e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientationPortrait",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientationPortrait:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientationPortrait(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientationPortraitOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientationPortraitOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f7cc105b62b94cdd911894a6e588d8cd18d4592e307a01bbb7241f253243b981)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientationPortrait]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientationPortrait], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientationPortrait],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fc5deeadbfff2f2d7f2d9ec224189201829ca5d7cb8ab8ac9be7f987405492d2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientationSquare",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientationSquare:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientationSquare(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientationSquareOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientationSquareOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__21ac05cb83095546396d7e91682e0a41615b15e8110dd446b28f25166a0b29ad)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientationSquare]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientationSquare], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientationSquare],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b3d9d2e0d4ef45e0926c334b0be1546349ce53104953aa07c1b5986a517c2111)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationMaxColors",
    jsii_struct_bases=[],
    name_mapping={"colors": "colors", "colors_var": "colorsVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationMaxColors:
    def __init__(
        self,
        *,
        colors: typing.Optional[builtins.str] = None,
        colors_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param colors: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        :param colors_var: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ee74b8966ef14b1bcdac37bc43ecee9ad7d6a756bd98e2aba4377bd7ea1b0b71)
            check_type(argname="argument colors", value=colors, expected_type=type_hints["colors"])
            check_type(argname="argument colors_var", value=colors_var, expected_type=type_hints["colors_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if colors is not None:
            self._values["colors"] = colors
        if colors_var is not None:
            self._values["colors_var"] = colors_var

    @builtins.property
    def colors(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        '''
        result = self._values.get("colors")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def colors_var(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        result = self._values.get("colors_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationMaxColors(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationMaxColorsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationMaxColorsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8dbb3e10a26eb92673bd643458a4bbfea559c16ddd1cbd439f76efb9b6e916b8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationMaxColorsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a37738bc31773be9a478c44c0530179cffb702477a5e5beba9c74797dc8743d3)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationMaxColorsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f92e1df5078d90b61458f821fd709b933a3d11b54dc35e8665e1a12620668279)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__31d49566ae620e0c86716ccd93f9b5eec9ad0655b2514081efd1db64e814baed)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e877f17a9dfea0feec1c9c13a5a8643851853f770ea898c546999657e0b62219)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationMaxColors]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationMaxColors]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__572ee3a47f009a9daccc2139ac1a6dead1ef879a62ce90dea45579fa63ae9b0f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationMaxColorsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationMaxColorsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__66f8b8064b023e533f5ddde0f27f16c3f915e68bfdfbd5d344d7ce229f40cdcd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColors")
    def reset_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColors", []))

    @jsii.member(jsii_name="resetColorsVar")
    def reset_colors_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorsVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorsInput")
    def colors_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsInput"))

    @builtins.property
    @jsii.member(jsii_name="colorsVarInput")
    def colors_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsVarInput"))

    @builtins.property
    @jsii.member(jsii_name="colors")
    def colors(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colors"))

    @colors.setter
    def colors(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e66a49435bc024074e919b353534a46dd54b5089b4737238fbad822a24897d4f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colors", value)

    @builtins.property
    @jsii.member(jsii_name="colorsVar")
    def colors_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorsVar"))

    @colors_var.setter
    def colors_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0d20f27174f87a032eaf03fc9181db1263efd84d08b4cfc16c0c95f9e6d3fd14)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorsVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationMaxColors]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationMaxColors]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationMaxColors]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f2fcd526750114cebd078e536020c56d4894abe6bb68740f03fdc4ac91512a04)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationMirror",
    jsii_struct_bases=[],
    name_mapping={
        "horizontal": "horizontal",
        "horizontal_var": "horizontalVar",
        "vertical": "vertical",
        "vertical_var": "verticalVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationMirror:
    def __init__(
        self,
        *,
        horizontal: typing.Optional[builtins.str] = None,
        horizontal_var: typing.Optional[builtins.str] = None,
        vertical: typing.Optional[builtins.str] = None,
        vertical_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param horizontal: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        :param horizontal_var: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        :param vertical: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        :param vertical_var: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__54bc31c7438bd76f042087e06bd9e518ebe018a62f8d919726b779c14d3bee61)
            check_type(argname="argument horizontal", value=horizontal, expected_type=type_hints["horizontal"])
            check_type(argname="argument horizontal_var", value=horizontal_var, expected_type=type_hints["horizontal_var"])
            check_type(argname="argument vertical", value=vertical, expected_type=type_hints["vertical"])
            check_type(argname="argument vertical_var", value=vertical_var, expected_type=type_hints["vertical_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if horizontal is not None:
            self._values["horizontal"] = horizontal
        if horizontal_var is not None:
            self._values["horizontal_var"] = horizontal_var
        if vertical is not None:
            self._values["vertical"] = vertical
        if vertical_var is not None:
            self._values["vertical_var"] = vertical_var

    @builtins.property
    def horizontal(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        '''
        result = self._values.get("horizontal")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def horizontal_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        '''
        result = self._values.get("horizontal_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        '''
        result = self._values.get("vertical")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        result = self._values.get("vertical_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationMirror(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationMirrorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationMirrorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b39915ef499b698c51436e4632b90e54fe9c3a7c30b0440af7916343e10e9fb1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationMirrorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6142627f765bcaeb37466820d95ca349b80f3fffd1229a3f46ee8efda9d646eb)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationMirrorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c897b83d8623e63ec33e01318c713655dbc60a29b1ed6506e38e7861bd0783d5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6358ff04ec64daf38cdaa41d935adcf9ae3eaabeb8306487bec45a693a4c01e8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aedf47a47060d34e2ed314e4e36cb8e1c551c355691fc1ead3948645f8c813ac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationMirror]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationMirror]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__523d99639f6898ce9d27e852c00e6d3a738df22fee5d66b537224fe1302f5b72)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationMirrorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationMirrorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7f2fb577b03140203a39b2a1bb7439c762a9af4e998b1580f3d8564334a94472)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHorizontal")
    def reset_horizontal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontal", []))

    @jsii.member(jsii_name="resetHorizontalVar")
    def reset_horizontal_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontalVar", []))

    @jsii.member(jsii_name="resetVertical")
    def reset_vertical(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVertical", []))

    @jsii.member(jsii_name="resetVerticalVar")
    def reset_vertical_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVerticalVar", []))

    @builtins.property
    @jsii.member(jsii_name="horizontalInput")
    def horizontal_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontalVarInput")
    def horizontal_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalInput")
    def vertical_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalVarInput")
    def vertical_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontal")
    def horizontal(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontal"))

    @horizontal.setter
    def horizontal(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a4994080427ac787c6499d245cd315df3a462a8b550a62d5741ec9a223300e37)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontal", value)

    @builtins.property
    @jsii.member(jsii_name="horizontalVar")
    def horizontal_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontalVar"))

    @horizontal_var.setter
    def horizontal_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a6fe6da0850a1339b6346d0d7ef29ef026f83c751ad7238af4bc8438f1ebf98)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontalVar", value)

    @builtins.property
    @jsii.member(jsii_name="vertical")
    def vertical(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "vertical"))

    @vertical.setter
    def vertical(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d6ee10d1c20cdcb8dec63888aa9bcf419ccf5e00b4113467d6d8343c6c986452)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "vertical", value)

    @builtins.property
    @jsii.member(jsii_name="verticalVar")
    def vertical_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "verticalVar"))

    @vertical_var.setter
    def vertical_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__24095aeee9d52dc3d993becaf7a850d05e87377ebb641578c88e0584a8c94e1e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "verticalVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationMirror]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationMirror]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationMirror]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__161eb176d684e3cc9d864bb59e0b38bacf35faeff6d76ac675832ce69a466174)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationMonoHue",
    jsii_struct_bases=[],
    name_mapping={"hue": "hue", "hue_var": "hueVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationMonoHue:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__348f739a17648b30846f8126333850f3187d132d0490e2f9be3a7ddc68cce491)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationMonoHue(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationMonoHueList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationMonoHueList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__60cafb819311d849e6eaea6a61cbe4e7b6d8d25a44b2fc053a930e5b51150b15)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationMonoHueOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__739042e49b50ca4a2fabcb265d8aa2655d145e0066b8a9fbab61990f96a0320a)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationMonoHueOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a3ef1949709ae5ebabb3b98de644aa42e3908e0718e34e0b35148aa655f5d1ae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__35f0dcb33a78032530d7ac83b098aa254ca15882d32bea299d2369371e3b8faf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6b43181a4a1f276e01af69a22498ab3bdb194a49c4d4c76b5e3a3b2c9c12d6f4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationMonoHue]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationMonoHue]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af7201559e33568b996365d5bd11e25ea545e4f378a67143f02d0a2e82f0c2b9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationMonoHueOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationMonoHueOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__605100904f62217ae6c2f1cdd8e8c7b9b218ce4f560c301ec62a3d59ad8bba58)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a6ce7373ce35e295deec8e15a2c3eabc80b654f3e62ae974b0990a0f7f5c80a7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d0c83f520ed9b48d60d3a4eecbbb6fcd287f78e6802f657f4643e1d8d8abde7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationMonoHue]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationMonoHue]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationMonoHue]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__862a89cd17780bd5494c8d69e8b7ae46ab26c7fbf2b596085b1c16fda7df9b10)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationOpacity",
    jsii_struct_bases=[],
    name_mapping={"opacity": "opacity", "opacity_var": "opacityVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationOpacity:
    def __init__(
        self,
        *,
        opacity: typing.Optional[builtins.str] = None,
        opacity_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param opacity: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param opacity_var: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__34a95b040391bb739d5bc769ff0d2c62342d22b1638e8f2cecebe1f97309a611)
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument opacity_var", value=opacity_var, expected_type=type_hints["opacity_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if opacity is not None:
            self._values["opacity"] = opacity
        if opacity_var is not None:
            self._values["opacity_var"] = opacity_var

    @builtins.property
    def opacity(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def opacity_var(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        result = self._values.get("opacity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationOpacity(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationOpacityList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationOpacityList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__464f88ae3cbb41e9d3ccaa7677e37b7b7d181e2c9696092928833948d7ce47bd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationOpacityOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__23f4864ab98ae044204dce2c99ba212b973f3af1b962ca86443e6d75b9fba0ac)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationOpacityOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a0871afca369e4a4795b8cf8ada495c20db21d2ced8810e679f428c4c1c34f1b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a2db812761b7b9374684fb13fbfd466000f412e236fff744f51cd0ad0455301)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__15f9a21a040dfbf12ef89cd090da472061636268a70741e7cb0a77a21a47211e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationOpacity]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationOpacity]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3e131b8c9f7902a4fa1ad70371b3d2b96af87692865963717a74b270915ba5fa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationOpacityOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationOpacityOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__72a958a8f5d23904dafd2aef5b845c72918bc049e5981ff7dddf6f84479119a7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetOpacityVar")
    def reset_opacity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacityVar", []))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityVarInput")
    def opacity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacity"))

    @opacity.setter
    def opacity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3b7f8d1b4b18f9413c419b589fc320566d90575010c2f2bc1a2dfdc4d35087d7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacity", value)

    @builtins.property
    @jsii.member(jsii_name="opacityVar")
    def opacity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacityVar"))

    @opacity_var.setter
    def opacity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab6bbb37fa2dac8f404528a00f9b0d0b960d47cfb96d74f811b399cf660526b2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacityVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationOpacity]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationOpacity]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationOpacity]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c0560fa23096dabaffa41bac9693f9b4db0b1fb2fe180febdd0cb52eb3ca4745)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__05a2556b66e74f3d81e6ed9f06ab4bb7a44e6f5d2b254126d075e277247b1803)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putBackgroundColor")
    def put_background_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c8f925ae3d579f7930ba388d392c7f804a8fa044c18db64082a8b659404a04c1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBackgroundColor", [value]))

    @jsii.member(jsii_name="putBlur")
    def put_blur(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationBlur, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5d84594748dc1a7998bfb3db77aa83f058f21a42ce42ba2beb8ca7183817f946)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBlur", [value]))

    @jsii.member(jsii_name="putChromaKey")
    def put_chroma_key(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationChromaKey, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d51f549f29be296aa11b7f39f40322bcaaeb411f5ed92ad01c8b7b97a4f91903)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putChromaKey", [value]))

    @jsii.member(jsii_name="putComposite")
    def put_composite(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationComposite, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__14d855dc038c23b6265a694cc2a04c3003775811cecdbfd936bd8c05ad0811be)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putComposite", [value]))

    @jsii.member(jsii_name="putCompound")
    def put_compound(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationCompound, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a205bc8f3f9d4013ea878ae732f7dc49b1ff0339edbbb5427726c73b0bb8aeb9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCompound", [value]))

    @jsii.member(jsii_name="putContrast")
    def put_contrast(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationContrast, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1137efa6d71c7f730d05f514d90cb06d1466378603313a94e744daab58397846)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putContrast", [value]))

    @jsii.member(jsii_name="putGoop")
    def put_goop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationGoop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0bb91dd29853f220ebf14f39f6ea6fb9059aeab714f5ab75f863b88ed687e95f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGoop", [value]))

    @jsii.member(jsii_name="putGrayscale")
    def put_grayscale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationGrayscale, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ca88e68ce9bf4121f373b46ea2c9f91ddb1379481067e43cb4cd3b6ec3b00bbb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGrayscale", [value]))

    @jsii.member(jsii_name="putHsl")
    def put_hsl(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationHsl, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__09a8e096d8384e47d9ed58b850896eb517ebfd7c9173aed825d3d380f4895f3d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsl", [value]))

    @jsii.member(jsii_name="putHsv")
    def put_hsv(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationHsv, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c86a591d232abde6b703b5cc376e54e1565d848d4b26c470403b4c4b324be70d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsv", [value]))

    @jsii.member(jsii_name="putIfDimension")
    def put_if_dimension(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimension, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a8489380218bb1805ee40a560258d5a0091d4630e78759becd95b959ed0ac518)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfDimension", [value]))

    @jsii.member(jsii_name="putIfOrientation")
    def put_if_orientation(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8b200def2be2510fbeacd2894b882d09e16570b8b07fb59440e75ba0bb3bece0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfOrientation", [value]))

    @jsii.member(jsii_name="putMaxColors")
    def put_max_colors(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationMaxColors, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__674d93a72f0294e309894d65c15d75d79f723230ca2a008323f93cea1de5eba3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMaxColors", [value]))

    @jsii.member(jsii_name="putMirror")
    def put_mirror(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationMirror, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6907296151f9ed26e18c8a027e3d293a70cfaa58d8168d5a0f48a9b287506df9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMirror", [value]))

    @jsii.member(jsii_name="putMonoHue")
    def put_mono_hue(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationMonoHue, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aeb4b1bc88a1adaac1e3ea61c31d05e8b7712e540b4bb55d9bd91410d72b1bbd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMonoHue", [value]))

    @jsii.member(jsii_name="putOpacity")
    def put_opacity(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationOpacity, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__29efc2611373226d56bd7bc320a07c3c71c790025e0a0b1a1476fb9b4fae8f26)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putOpacity", [value]))

    @jsii.member(jsii_name="putRemoveColor")
    def put_remove_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationRemoveColor", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9c65c00bd311fbb9aedd0f2e83db27e12150202f860fd2d6d3b411cba8e59295)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRemoveColor", [value]))

    @jsii.member(jsii_name="putUnsharpMask")
    def put_unsharp_mask(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationUnsharpMask", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a18399c726eb362cff5715420105afef82051cfdbc0e6192bf9f43221429fb48)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putUnsharpMask", [value]))

    @jsii.member(jsii_name="resetBackgroundColor")
    def reset_background_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBackgroundColor", []))

    @jsii.member(jsii_name="resetBlur")
    def reset_blur(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBlur", []))

    @jsii.member(jsii_name="resetChromaKey")
    def reset_chroma_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChromaKey", []))

    @jsii.member(jsii_name="resetComposite")
    def reset_composite(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetComposite", []))

    @jsii.member(jsii_name="resetCompound")
    def reset_compound(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCompound", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetGoop")
    def reset_goop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGoop", []))

    @jsii.member(jsii_name="resetGrayscale")
    def reset_grayscale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGrayscale", []))

    @jsii.member(jsii_name="resetHsl")
    def reset_hsl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsl", []))

    @jsii.member(jsii_name="resetHsv")
    def reset_hsv(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsv", []))

    @jsii.member(jsii_name="resetIfDimension")
    def reset_if_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfDimension", []))

    @jsii.member(jsii_name="resetIfOrientation")
    def reset_if_orientation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfOrientation", []))

    @jsii.member(jsii_name="resetMaxColors")
    def reset_max_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxColors", []))

    @jsii.member(jsii_name="resetMirror")
    def reset_mirror(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMirror", []))

    @jsii.member(jsii_name="resetMonoHue")
    def reset_mono_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonoHue", []))

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetRemoveColor")
    def reset_remove_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRemoveColor", []))

    @jsii.member(jsii_name="resetUnsharpMask")
    def reset_unsharp_mask(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUnsharpMask", []))

    @builtins.property
    @jsii.member(jsii_name="backgroundColor")
    def background_color(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationBackgroundColorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationBackgroundColorList, jsii.get(self, "backgroundColor"))

    @builtins.property
    @jsii.member(jsii_name="blur")
    def blur(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationBlurList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationBlurList, jsii.get(self, "blur"))

    @builtins.property
    @jsii.member(jsii_name="chromaKey")
    def chroma_key(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationChromaKeyList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationChromaKeyList, jsii.get(self, "chromaKey"))

    @builtins.property
    @jsii.member(jsii_name="composite")
    def composite(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationCompositeList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationCompositeList, jsii.get(self, "composite"))

    @builtins.property
    @jsii.member(jsii_name="compound")
    def compound(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationCompoundList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationCompoundList, jsii.get(self, "compound"))

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationContrastList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationContrastList, jsii.get(self, "contrast"))

    @builtins.property
    @jsii.member(jsii_name="goop")
    def goop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationGoopList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationGoopList, jsii.get(self, "goop"))

    @builtins.property
    @jsii.member(jsii_name="grayscale")
    def grayscale(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationGrayscaleList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationGrayscaleList, jsii.get(self, "grayscale"))

    @builtins.property
    @jsii.member(jsii_name="hsl")
    def hsl(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationHslList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationHslList, jsii.get(self, "hsl"))

    @builtins.property
    @jsii.member(jsii_name="hsv")
    def hsv(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationHsvList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationHsvList, jsii.get(self, "hsv"))

    @builtins.property
    @jsii.member(jsii_name="ifDimension")
    def if_dimension(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimensionList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimensionList, jsii.get(self, "ifDimension"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientation")
    def if_orientation(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientationList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientationList, jsii.get(self, "ifOrientation"))

    @builtins.property
    @jsii.member(jsii_name="maxColors")
    def max_colors(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationMaxColorsList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationMaxColorsList, jsii.get(self, "maxColors"))

    @builtins.property
    @jsii.member(jsii_name="mirror")
    def mirror(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationMirrorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationMirrorList, jsii.get(self, "mirror"))

    @builtins.property
    @jsii.member(jsii_name="monoHue")
    def mono_hue(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationMonoHueList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationMonoHueList, jsii.get(self, "monoHue"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationOpacityList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationOpacityList, jsii.get(self, "opacity"))

    @builtins.property
    @jsii.member(jsii_name="removeColor")
    def remove_color(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationRemoveColorList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationRemoveColorList", jsii.get(self, "removeColor"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMask")
    def unsharp_mask(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationUnsharpMaskList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationUnsharpMaskList", jsii.get(self, "unsharpMask"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColorInput")
    def background_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationBackgroundColor]]], jsii.get(self, "backgroundColorInput"))

    @builtins.property
    @jsii.member(jsii_name="blurInput")
    def blur_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationBlur]]], jsii.get(self, "blurInput"))

    @builtins.property
    @jsii.member(jsii_name="chromaKeyInput")
    def chroma_key_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationChromaKey]]], jsii.get(self, "chromaKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="compositeInput")
    def composite_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationComposite]]], jsii.get(self, "compositeInput"))

    @builtins.property
    @jsii.member(jsii_name="compoundInput")
    def compound_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationCompound]]], jsii.get(self, "compoundInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationContrast]]], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="goopInput")
    def goop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationGoop]]], jsii.get(self, "goopInput"))

    @builtins.property
    @jsii.member(jsii_name="grayscaleInput")
    def grayscale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationGrayscale]]], jsii.get(self, "grayscaleInput"))

    @builtins.property
    @jsii.member(jsii_name="hslInput")
    def hsl_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationHsl]]], jsii.get(self, "hslInput"))

    @builtins.property
    @jsii.member(jsii_name="hsvInput")
    def hsv_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationHsv]]], jsii.get(self, "hsvInput"))

    @builtins.property
    @jsii.member(jsii_name="ifDimensionInput")
    def if_dimension_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimension]]], jsii.get(self, "ifDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientationInput")
    def if_orientation_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientation]]], jsii.get(self, "ifOrientationInput"))

    @builtins.property
    @jsii.member(jsii_name="maxColorsInput")
    def max_colors_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationMaxColors]]], jsii.get(self, "maxColorsInput"))

    @builtins.property
    @jsii.member(jsii_name="mirrorInput")
    def mirror_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationMirror]]], jsii.get(self, "mirrorInput"))

    @builtins.property
    @jsii.member(jsii_name="monoHueInput")
    def mono_hue_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationMonoHue]]], jsii.get(self, "monoHueInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationOpacity]]], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="removeColorInput")
    def remove_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationRemoveColor"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationRemoveColor"]]], jsii.get(self, "removeColorInput"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMaskInput")
    def unsharp_mask_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationUnsharpMask"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationUnsharpMask"]]], jsii.get(self, "unsharpMaskInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__46d1be4d3692d7cf864e084dfe6d853a69bc3d478d560d8420a167d32dff30c7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationRemoveColor",
    jsii_struct_bases=[],
    name_mapping={
        "color": "color",
        "color_var": "colorVar",
        "feather": "feather",
        "feather_var": "featherVar",
        "tolerance": "tolerance",
        "tolerance_var": "toleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationRemoveColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
        feather: typing.Optional[builtins.str] = None,
        feather_var: typing.Optional[builtins.str] = None,
        tolerance: typing.Optional[builtins.str] = None,
        tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        :param feather: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        :param feather_var: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        :param tolerance: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        :param tolerance_var: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7b6e0ae9644f7e7c7913e13eb7870fa0cc997c4b46ab3ca88474d384f0de9af2)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
            check_type(argname="argument feather", value=feather, expected_type=type_hints["feather"])
            check_type(argname="argument feather_var", value=feather_var, expected_type=type_hints["feather_var"])
            check_type(argname="argument tolerance", value=tolerance, expected_type=type_hints["tolerance"])
            check_type(argname="argument tolerance_var", value=tolerance_var, expected_type=type_hints["tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var
        if feather is not None:
            self._values["feather"] = feather
        if feather_var is not None:
            self._values["feather_var"] = feather_var
        if tolerance is not None:
            self._values["tolerance"] = tolerance
        if tolerance_var is not None:
            self._values["tolerance_var"] = tolerance_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        '''
        result = self._values.get("feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather_var(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        '''
        result = self._values.get("feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        '''
        result = self._values.get("tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance_var(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        result = self._values.get("tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationRemoveColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationRemoveColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationRemoveColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d72f93e2c2ebf1d8728f9b6652cb104dd54c65a80fac42760864ae380c12ed3f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationRemoveColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d99559320b2513c0d82d8b215ab0e256778079791d649413132d889a3babee8e)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationRemoveColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ae0f4ca06b18e6e9cb0a9a42d5b42cdc39d0ca6997921e038da24fddb9fb02cd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a22cc297e63691ada0f32fff7968520f0c92517d6b256da3e57a878043c0fe85)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e22956bdc0549144ab015ff5404d176957a02e3ec2a771b435e9346df197b006)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationRemoveColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationRemoveColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationRemoveColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__25a78ad1ac62d223dc3723525732b5aafee94f32e48a5c4a95f3230afbce0de7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationRemoveColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationRemoveColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7a1d725770ffdbe0c54c4ef6e0624a9e1420858375682f2e6a09a02b09ac163e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @jsii.member(jsii_name="resetFeather")
    def reset_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeather", []))

    @jsii.member(jsii_name="resetFeatherVar")
    def reset_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatherVar", []))

    @jsii.member(jsii_name="resetTolerance")
    def reset_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTolerance", []))

    @jsii.member(jsii_name="resetToleranceVar")
    def reset_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featherInput")
    def feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherInput"))

    @builtins.property
    @jsii.member(jsii_name="featherVarInput")
    def feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceInput")
    def tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceVarInput")
    def tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__03b2c0dd8ae3eb759efec0d1c5d1a4cea5a56408c27cf07b0791781a959a329b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6d4c78098b63842505fcf46fa9089f41bf4eebb4bc05caabc13f988f9971174b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="feather")
    def feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "feather"))

    @feather.setter
    def feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3f58cd09b69d3bdd3d8cfaaff31fbbd05dfdda2bfe83a4bda0fc9c2bacdf366a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "feather", value)

    @builtins.property
    @jsii.member(jsii_name="featherVar")
    def feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featherVar"))

    @feather_var.setter
    def feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__72892ecb51c858eb7c29bde49f0126a4df7a9d3782e99dd1ce85cf48ac5a51f9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featherVar", value)

    @builtins.property
    @jsii.member(jsii_name="tolerance")
    def tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tolerance"))

    @tolerance.setter
    def tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1424254df93c30cd5394607ec3ddf82660bcd475c5461490d45741b1ca237ac0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tolerance", value)

    @builtins.property
    @jsii.member(jsii_name="toleranceVar")
    def tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "toleranceVar"))

    @tolerance_var.setter
    def tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__86cedd077be6f54ee689b91408bdc8f7ab766b8db0c8ddf1bfb25f116e8ae02d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "toleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationRemoveColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationRemoveColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationRemoveColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__67606f5c0108fd2abf5f0d3cd9b623d96b49eb18a98c79b7326f3e76602631ce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationUnsharpMask",
    jsii_struct_bases=[],
    name_mapping={
        "gain": "gain",
        "gain_var": "gainVar",
        "sigma": "sigma",
        "sigma_var": "sigmaVar",
        "threshold": "threshold",
        "threshold_var": "thresholdVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationUnsharpMask:
    def __init__(
        self,
        *,
        gain: typing.Optional[builtins.str] = None,
        gain_var: typing.Optional[builtins.str] = None,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
        threshold: typing.Optional[builtins.str] = None,
        threshold_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param gain: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        :param gain_var: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        :param sigma: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        :param threshold: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        :param threshold_var: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__204988e024e53957e76e70d1b84352e608c59172d08091fd4aeb44ca8e3da00b)
            check_type(argname="argument gain", value=gain, expected_type=type_hints["gain"])
            check_type(argname="argument gain_var", value=gain_var, expected_type=type_hints["gain_var"])
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
            check_type(argname="argument threshold", value=threshold, expected_type=type_hints["threshold"])
            check_type(argname="argument threshold_var", value=threshold_var, expected_type=type_hints["threshold_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if gain is not None:
            self._values["gain"] = gain
        if gain_var is not None:
            self._values["gain_var"] = gain_var
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var
        if threshold is not None:
            self._values["threshold"] = threshold
        if threshold_var is not None:
            self._values["threshold_var"] = threshold_var

    @builtins.property
    def gain(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        '''
        result = self._values.get("gain")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gain_var(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        '''
        result = self._values.get("gain_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        '''
        result = self._values.get("threshold")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold_var(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        result = self._values.get("threshold_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationUnsharpMask(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationUnsharpMaskList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationUnsharpMaskList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b9e757548628c1363f8e86d6828bd2927e4a73feef049c0fc84f05859f3bc978)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationUnsharpMaskOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__066d6ef431717f8826fefe369fc32c9d437e5de7b13a1dcc998b47487f541518)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationUnsharpMaskOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a1771474422a6114f363887975788f21c34ff543a1dc853868d15137756a875e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f3d226440099891425a0ca8c5320c05c03e0bb3bc966c38588fc3f37199f0cb7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1825450b222c4d33c8893ea443ce19dedf23b9954004420734f5a821a0d0682a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationUnsharpMask]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationUnsharpMask]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationUnsharpMask]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ab65c9f087712c2d9259aada88876e5a1183f8214213cfbdd41c9a04ed965b9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationUnsharpMaskOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationUnsharpMaskOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__98a96d048016b78be7b8ff985bd144bcbe209365005050ccce99b8e2f16126a9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetGain")
    def reset_gain(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGain", []))

    @jsii.member(jsii_name="resetGainVar")
    def reset_gain_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGainVar", []))

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @jsii.member(jsii_name="resetThreshold")
    def reset_threshold(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThreshold", []))

    @jsii.member(jsii_name="resetThresholdVar")
    def reset_threshold_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThresholdVar", []))

    @builtins.property
    @jsii.member(jsii_name="gainInput")
    def gain_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainInput"))

    @builtins.property
    @jsii.member(jsii_name="gainVarInput")
    def gain_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdInput")
    def threshold_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdVarInput")
    def threshold_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gain")
    def gain(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gain"))

    @gain.setter
    def gain(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6ced05841df45dacb1e792bdaa6ea5e024196d3b05c0049b34d50f221734e51f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gain", value)

    @builtins.property
    @jsii.member(jsii_name="gainVar")
    def gain_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gainVar"))

    @gain_var.setter
    def gain_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__120e79d12aac42bdce3019afd23db94fd9cb8691035704ba550e8798ece1a5fb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gainVar", value)

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__180327b914a416ca08001282ab735469dbf61175cadadea5474e5ea72fab09c4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2961665ba53b4bb4341e4ba4ae6d152d9facbeeb5a7a99430d5c085a408a8c74)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="threshold")
    def threshold(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "threshold"))

    @threshold.setter
    def threshold(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3f87b95163cf114134fb79fc553b1d05de7d05206297cc3cfc9a0079a6c4dc0e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "threshold", value)

    @builtins.property
    @jsii.member(jsii_name="thresholdVar")
    def threshold_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "thresholdVar"))

    @threshold_var.setter
    def threshold_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__745f2bc04091a6ea860e90bfdf5a85e12861442766237d0201a012b261c90a67)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "thresholdVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationUnsharpMask]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationUnsharpMask]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationUnsharpMask]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ff2c6cf9a31122f01bcf6091046f4000b1436a9261f10c59d3ade345e6b1b531)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImage",
    jsii_struct_bases=[],
    name_mapping={
        "transformation": "transformation",
        "url": "url",
        "url_var": "urlVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImage:
    def __init__(
        self,
        *,
        transformation: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        url: typing.Optional[builtins.str] = None,
        url_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param transformation: transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        :param url: The URL of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url DataAkamaiImagingPolicyImage#url}
        :param url_var: The URL of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url_var DataAkamaiImagingPolicyImage#url_var}
        '''
        if isinstance(transformation, dict):
            transformation = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformation(**transformation)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__189f1c7ef76661c7a4118aacc3968a0d07a0693e95e4f5ea6fb3631af9fb124f)
            check_type(argname="argument transformation", value=transformation, expected_type=type_hints["transformation"])
            check_type(argname="argument url", value=url, expected_type=type_hints["url"])
            check_type(argname="argument url_var", value=url_var, expected_type=type_hints["url_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if transformation is not None:
            self._values["transformation"] = transformation
        if url is not None:
            self._values["url"] = url
        if url_var is not None:
            self._values["url_var"] = url_var

    @builtins.property
    def transformation(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformation"]:
        '''transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        '''
        result = self._values.get("transformation")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformation"], result)

    @builtins.property
    def url(self) -> typing.Optional[builtins.str]:
        '''The URL of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url DataAkamaiImagingPolicyImage#url}
        '''
        result = self._values.get("url")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def url_var(self) -> typing.Optional[builtins.str]:
        '''The URL of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url_var DataAkamaiImagingPolicyImage#url_var}
        '''
        result = self._values.get("url_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dd34e86b951718ebe0248bb2f2c5e01f89385412f97924c20c1c54446e97a4d2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6a4741310faa574301e0309e4fcc4cda0ea13767395a73eef9120bb4fa0f595c)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__76d91debdbe5d21481733d18378b126eceef580a188fbbce932e4f0f6e1c6ceb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__36bfd1f295bae91cc202a54c591bd43c9b05d7624d6e3c7a9277dbbd364bef34)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d2acce2f045c180cedd20620bdd07d68578a2d58b922a0734792bcf10284eb51)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImage]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImage]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImage]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a6d1d7ecbc9f507257551592f3f6324637fbe00be04e1958ce82ff0a544732f2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__91ddde01e98b4b6c0bd3689ab58d35b6f77367396a3072522cc62fcbb60fbc65)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformation")
    def put_transformation(
        self,
        *,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationBackgroundColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationBlur", typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationChromaKey", typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationComposite", typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationCompound", typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationContrast", typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationGoop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationGrayscale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationHsl", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationHsv", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfDimension", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfOrientation", typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationMaxColors", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationMirror", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationMonoHue", typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationOpacity", typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationRemoveColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationUnsharpMask", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformation(
            background_color=background_color,
            blur=blur,
            chroma_key=chroma_key,
            composite=composite,
            compound=compound,
            contrast=contrast,
            goop=goop,
            grayscale=grayscale,
            hsl=hsl,
            hsv=hsv,
            if_dimension=if_dimension,
            if_orientation=if_orientation,
            max_colors=max_colors,
            mirror=mirror,
            mono_hue=mono_hue,
            opacity=opacity,
            remove_color=remove_color,
            unsharp_mask=unsharp_mask,
        )

        return typing.cast(None, jsii.invoke(self, "putTransformation", [value]))

    @jsii.member(jsii_name="resetTransformation")
    def reset_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformation", []))

    @jsii.member(jsii_name="resetUrl")
    def reset_url(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUrl", []))

    @jsii.member(jsii_name="resetUrlVar")
    def reset_url_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUrlVar", []))

    @builtins.property
    @jsii.member(jsii_name="transformation")
    def transformation(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationOutputReference", jsii.get(self, "transformation"))

    @builtins.property
    @jsii.member(jsii_name="transformationInput")
    def transformation_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformation"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformation"], jsii.get(self, "transformationInput"))

    @builtins.property
    @jsii.member(jsii_name="urlInput")
    def url_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "urlInput"))

    @builtins.property
    @jsii.member(jsii_name="urlVarInput")
    def url_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "urlVarInput"))

    @builtins.property
    @jsii.member(jsii_name="url")
    def url(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "url"))

    @url.setter
    def url(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f5c7e8d912d280daad284e0575cdeab986540f24837aa6b86963c6e2467a9ed5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "url", value)

    @builtins.property
    @jsii.member(jsii_name="urlVar")
    def url_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "urlVar"))

    @url_var.setter
    def url_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a33572fe5c61ca64d0748298536c53ec671ef39c7a583b61cc842ce95e6d4fb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "urlVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImage]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImage]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImage]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c71c6a8ea21ae93f892d2fd193a773e9bf632bdda82b64363536de913e9f2646)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformation",
    jsii_struct_bases=[],
    name_mapping={
        "background_color": "backgroundColor",
        "blur": "blur",
        "chroma_key": "chromaKey",
        "composite": "composite",
        "compound": "compound",
        "contrast": "contrast",
        "goop": "goop",
        "grayscale": "grayscale",
        "hsl": "hsl",
        "hsv": "hsv",
        "if_dimension": "ifDimension",
        "if_orientation": "ifOrientation",
        "max_colors": "maxColors",
        "mirror": "mirror",
        "mono_hue": "monoHue",
        "opacity": "opacity",
        "remove_color": "removeColor",
        "unsharp_mask": "unsharpMask",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformation:
    def __init__(
        self,
        *,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationBackgroundColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationBlur", typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationChromaKey", typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationComposite", typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationCompound", typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationContrast", typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationGoop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationGrayscale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationHsl", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationHsv", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfDimension", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfOrientation", typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationMaxColors", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationMirror", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationMonoHue", typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationOpacity", typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationRemoveColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationUnsharpMask", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8b1b4f2d070cd94286cce46787c6c770bb43d361937cb6ed5d83940a5c7ae472)
            check_type(argname="argument background_color", value=background_color, expected_type=type_hints["background_color"])
            check_type(argname="argument blur", value=blur, expected_type=type_hints["blur"])
            check_type(argname="argument chroma_key", value=chroma_key, expected_type=type_hints["chroma_key"])
            check_type(argname="argument composite", value=composite, expected_type=type_hints["composite"])
            check_type(argname="argument compound", value=compound, expected_type=type_hints["compound"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument goop", value=goop, expected_type=type_hints["goop"])
            check_type(argname="argument grayscale", value=grayscale, expected_type=type_hints["grayscale"])
            check_type(argname="argument hsl", value=hsl, expected_type=type_hints["hsl"])
            check_type(argname="argument hsv", value=hsv, expected_type=type_hints["hsv"])
            check_type(argname="argument if_dimension", value=if_dimension, expected_type=type_hints["if_dimension"])
            check_type(argname="argument if_orientation", value=if_orientation, expected_type=type_hints["if_orientation"])
            check_type(argname="argument max_colors", value=max_colors, expected_type=type_hints["max_colors"])
            check_type(argname="argument mirror", value=mirror, expected_type=type_hints["mirror"])
            check_type(argname="argument mono_hue", value=mono_hue, expected_type=type_hints["mono_hue"])
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument remove_color", value=remove_color, expected_type=type_hints["remove_color"])
            check_type(argname="argument unsharp_mask", value=unsharp_mask, expected_type=type_hints["unsharp_mask"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if background_color is not None:
            self._values["background_color"] = background_color
        if blur is not None:
            self._values["blur"] = blur
        if chroma_key is not None:
            self._values["chroma_key"] = chroma_key
        if composite is not None:
            self._values["composite"] = composite
        if compound is not None:
            self._values["compound"] = compound
        if contrast is not None:
            self._values["contrast"] = contrast
        if goop is not None:
            self._values["goop"] = goop
        if grayscale is not None:
            self._values["grayscale"] = grayscale
        if hsl is not None:
            self._values["hsl"] = hsl
        if hsv is not None:
            self._values["hsv"] = hsv
        if if_dimension is not None:
            self._values["if_dimension"] = if_dimension
        if if_orientation is not None:
            self._values["if_orientation"] = if_orientation
        if max_colors is not None:
            self._values["max_colors"] = max_colors
        if mirror is not None:
            self._values["mirror"] = mirror
        if mono_hue is not None:
            self._values["mono_hue"] = mono_hue
        if opacity is not None:
            self._values["opacity"] = opacity
        if remove_color is not None:
            self._values["remove_color"] = remove_color
        if unsharp_mask is not None:
            self._values["unsharp_mask"] = unsharp_mask

    @builtins.property
    def background_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationBackgroundColor"]]]:
        '''background_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        '''
        result = self._values.get("background_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationBackgroundColor"]]], result)

    @builtins.property
    def blur(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationBlur"]]]:
        '''blur block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        '''
        result = self._values.get("blur")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationBlur"]]], result)

    @builtins.property
    def chroma_key(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationChromaKey"]]]:
        '''chroma_key block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        '''
        result = self._values.get("chroma_key")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationChromaKey"]]], result)

    @builtins.property
    def composite(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationComposite"]]]:
        '''composite block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        '''
        result = self._values.get("composite")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationComposite"]]], result)

    @builtins.property
    def compound(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationCompound"]]]:
        '''compound block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        '''
        result = self._values.get("compound")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationCompound"]]], result)

    @builtins.property
    def contrast(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationContrast"]]]:
        '''contrast block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationContrast"]]], result)

    @builtins.property
    def goop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationGoop"]]]:
        '''goop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        '''
        result = self._values.get("goop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationGoop"]]], result)

    @builtins.property
    def grayscale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationGrayscale"]]]:
        '''grayscale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        '''
        result = self._values.get("grayscale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationGrayscale"]]], result)

    @builtins.property
    def hsl(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationHsl"]]]:
        '''hsl block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        '''
        result = self._values.get("hsl")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationHsl"]]], result)

    @builtins.property
    def hsv(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationHsv"]]]:
        '''hsv block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        '''
        result = self._values.get("hsv")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationHsv"]]], result)

    @builtins.property
    def if_dimension(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfDimension"]]]:
        '''if_dimension block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        '''
        result = self._values.get("if_dimension")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfDimension"]]], result)

    @builtins.property
    def if_orientation(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfOrientation"]]]:
        '''if_orientation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        '''
        result = self._values.get("if_orientation")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfOrientation"]]], result)

    @builtins.property
    def max_colors(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationMaxColors"]]]:
        '''max_colors block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        '''
        result = self._values.get("max_colors")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationMaxColors"]]], result)

    @builtins.property
    def mirror(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationMirror"]]]:
        '''mirror block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        '''
        result = self._values.get("mirror")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationMirror"]]], result)

    @builtins.property
    def mono_hue(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationMonoHue"]]]:
        '''mono_hue block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        '''
        result = self._values.get("mono_hue")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationMonoHue"]]], result)

    @builtins.property
    def opacity(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationOpacity"]]]:
        '''opacity block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationOpacity"]]], result)

    @builtins.property
    def remove_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationRemoveColor"]]]:
        '''remove_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        '''
        result = self._values.get("remove_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationRemoveColor"]]], result)

    @builtins.property
    def unsharp_mask(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationUnsharpMask"]]]:
        '''unsharp_mask block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        result = self._values.get("unsharp_mask")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationUnsharpMask"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationBackgroundColor",
    jsii_struct_bases=[],
    name_mapping={"color": "color", "color_var": "colorVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationBackgroundColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a19d7e9480083a5049be4263022f78fd455df6720a0b13166117569dfd962f8)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationBackgroundColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationBackgroundColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationBackgroundColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__60e3fc0c4b4a1a82572460bcd4ac41554f7123d28ed6f63dcfb1209a08e83233)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationBackgroundColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4f3e0645ec3d5131c963ba080cd68fe3dd4483504cad2faefd72a3f4575bbadd)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationBackgroundColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__12e7be1e426d79096e8d865b500f4785bfd6ac1e7bef06757d4c705e8a94f579)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eaed16dbbee70cff1fa36fec7718fa09099ba2f070aea6f9b4a173312007537c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__55e6a5f364c83c61aceeb3ca4192c7d02d0f6569be52d4137daedfe6350018e5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationBackgroundColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationBackgroundColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c95884d9f438a896b68d436e478eba125514217073699e307a12e494721d462f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationBackgroundColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationBackgroundColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__996a8e1ba60f3c1d75414b10de2376e3dd30722371afac45fb8865a314e410cb)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__732a13a8a4c61cb433195fba1b01ddc7feda11b51d7bf4e4e5985028206c7bb2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__887d28806377d220ec353978b165398968a461e55d1706657012f20d660cc17c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationBackgroundColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationBackgroundColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationBackgroundColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d6b384da93936c126ae8c4ba379f7d86406388573df932a664ee54d25a37b97)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationBlur",
    jsii_struct_bases=[],
    name_mapping={"sigma": "sigma", "sigma_var": "sigmaVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationBlur:
    def __init__(
        self,
        *,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param sigma: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d41fcc37ff91bb1b1c2e2e0e65a7564b8f6d9804ab5860af82ae37c4d595871c)
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationBlur(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationBlurList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationBlurList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5580119f859029347697915dc9d15c7a9f23416cd24d0e3ada47e241d2ccea14)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationBlurOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__23db5611540586436e32f596a6709686527da646fd1ac4f7388b13bf56d28f8a)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationBlurOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c54197770a4636df89e715f52282123736b7ebdf10ba348ea5c742a21dd8f790)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f24f20f58012b8d128f7adde38b7117f14eee6f28cdd6e02199e5fe8b8105f0d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ccd6fa829c82e55894975912fc73dc38259bd7109279f2f2e624b18ed7da01f3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationBlur]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationBlur]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__973a6f49a4065221a8b4a7af7acdfee8c4fec6dcc5f5623d0e10a538432b6d22)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationBlurOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationBlurOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3c55e08c7473b165c24f5efc15c0fce6c3536b400086baf1744d3c7299f409f5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__03eab8e98fa385402cf09ed2ee0b453b7d0ac0e4b7890fa245e2e8ad56b01b9e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__95fb1f31c0c925a8d456af7d6f798bcc505309742e4079b49e53c20f6bfd5921)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationBlur]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationBlur]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationBlur]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__65f7c8a75a92f82ea7fea8815bc94cd2691017ce527b2dcb075f191d3a3bc153)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationChromaKey",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_feather": "hueFeather",
        "hue_feather_var": "hueFeatherVar",
        "hue_tolerance": "hueTolerance",
        "hue_tolerance_var": "hueToleranceVar",
        "hue_var": "hueVar",
        "lightness_feather": "lightnessFeather",
        "lightness_feather_var": "lightnessFeatherVar",
        "lightness_tolerance": "lightnessTolerance",
        "lightness_tolerance_var": "lightnessToleranceVar",
        "saturation_feather": "saturationFeather",
        "saturation_feather_var": "saturationFeatherVar",
        "saturation_tolerance": "saturationTolerance",
        "saturation_tolerance_var": "saturationToleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationChromaKey:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_feather: typing.Optional[builtins.str] = None,
        hue_feather_var: typing.Optional[builtins.str] = None,
        hue_tolerance: typing.Optional[builtins.str] = None,
        hue_tolerance_var: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness_feather: typing.Optional[builtins.str] = None,
        lightness_feather_var: typing.Optional[builtins.str] = None,
        lightness_tolerance: typing.Optional[builtins.str] = None,
        lightness_tolerance_var: typing.Optional[builtins.str] = None,
        saturation_feather: typing.Optional[builtins.str] = None,
        saturation_feather_var: typing.Optional[builtins.str] = None,
        saturation_tolerance: typing.Optional[builtins.str] = None,
        saturation_tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_feather: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        :param hue_feather_var: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        :param hue_tolerance: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        :param hue_tolerance_var: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        :param hue_var: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness_feather: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        :param lightness_feather_var: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        :param lightness_tolerance: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        :param lightness_tolerance_var: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        :param saturation_feather: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        :param saturation_feather_var: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        :param saturation_tolerance: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        :param saturation_tolerance_var: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__853f4172fd3f2dd60a08ac7ea59d14b9aaceaee678f1e7d0ec5c2b232e661ddc)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_feather", value=hue_feather, expected_type=type_hints["hue_feather"])
            check_type(argname="argument hue_feather_var", value=hue_feather_var, expected_type=type_hints["hue_feather_var"])
            check_type(argname="argument hue_tolerance", value=hue_tolerance, expected_type=type_hints["hue_tolerance"])
            check_type(argname="argument hue_tolerance_var", value=hue_tolerance_var, expected_type=type_hints["hue_tolerance_var"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness_feather", value=lightness_feather, expected_type=type_hints["lightness_feather"])
            check_type(argname="argument lightness_feather_var", value=lightness_feather_var, expected_type=type_hints["lightness_feather_var"])
            check_type(argname="argument lightness_tolerance", value=lightness_tolerance, expected_type=type_hints["lightness_tolerance"])
            check_type(argname="argument lightness_tolerance_var", value=lightness_tolerance_var, expected_type=type_hints["lightness_tolerance_var"])
            check_type(argname="argument saturation_feather", value=saturation_feather, expected_type=type_hints["saturation_feather"])
            check_type(argname="argument saturation_feather_var", value=saturation_feather_var, expected_type=type_hints["saturation_feather_var"])
            check_type(argname="argument saturation_tolerance", value=saturation_tolerance, expected_type=type_hints["saturation_tolerance"])
            check_type(argname="argument saturation_tolerance_var", value=saturation_tolerance_var, expected_type=type_hints["saturation_tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_feather is not None:
            self._values["hue_feather"] = hue_feather
        if hue_feather_var is not None:
            self._values["hue_feather_var"] = hue_feather_var
        if hue_tolerance is not None:
            self._values["hue_tolerance"] = hue_tolerance
        if hue_tolerance_var is not None:
            self._values["hue_tolerance_var"] = hue_tolerance_var
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness_feather is not None:
            self._values["lightness_feather"] = lightness_feather
        if lightness_feather_var is not None:
            self._values["lightness_feather_var"] = lightness_feather_var
        if lightness_tolerance is not None:
            self._values["lightness_tolerance"] = lightness_tolerance
        if lightness_tolerance_var is not None:
            self._values["lightness_tolerance_var"] = lightness_tolerance_var
        if saturation_feather is not None:
            self._values["saturation_feather"] = saturation_feather
        if saturation_feather_var is not None:
            self._values["saturation_feather_var"] = saturation_feather_var
        if saturation_tolerance is not None:
            self._values["saturation_tolerance"] = saturation_tolerance
        if saturation_tolerance_var is not None:
            self._values["saturation_tolerance_var"] = saturation_tolerance_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        '''
        result = self._values.get("hue_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        '''
        result = self._values.get("hue_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        '''
        result = self._values.get("hue_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        '''
        result = self._values.get("hue_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        '''
        result = self._values.get("lightness_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        '''
        result = self._values.get("lightness_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        '''
        result = self._values.get("lightness_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        '''
        result = self._values.get("lightness_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        '''
        result = self._values.get("saturation_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        '''
        result = self._values.get("saturation_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        '''
        result = self._values.get("saturation_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        result = self._values.get("saturation_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationChromaKey(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationChromaKeyList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationChromaKeyList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__65db4f8719c74e8c6360da25f81fb9e6ffcb4f95fe8e9b01817d4cfe3bab2520)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationChromaKeyOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__52912db8cb53a87b9246e4888a7afafa47efc5f1b79e8d0bd6a9c841ee4872bc)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationChromaKeyOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b0850fd535f86680b74f94bb6714adcd08eaeeafd154d5d7843fd68450a95384)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__28b457aefa2b39f574996e876a827e8803bb7656dcb3a5ff0866ae3b7fba20ca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8d5a9520fb001fc90764081c159110475d4882aa534b5526c6c01ec1d7572d66)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationChromaKey]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationChromaKey]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__62cf2baa97298cb5488fc52974ab2215f3184f973f60b88d18806e2bdf2171d3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationChromaKeyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationChromaKeyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5520cd0cd1c7c180e8eb2e48b44fe32c9a62d9d81667937d589d0f9fe36cd3bf)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueFeather")
    def reset_hue_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeather", []))

    @jsii.member(jsii_name="resetHueFeatherVar")
    def reset_hue_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeatherVar", []))

    @jsii.member(jsii_name="resetHueTolerance")
    def reset_hue_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueTolerance", []))

    @jsii.member(jsii_name="resetHueToleranceVar")
    def reset_hue_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueToleranceVar", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightnessFeather")
    def reset_lightness_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeather", []))

    @jsii.member(jsii_name="resetLightnessFeatherVar")
    def reset_lightness_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeatherVar", []))

    @jsii.member(jsii_name="resetLightnessTolerance")
    def reset_lightness_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessTolerance", []))

    @jsii.member(jsii_name="resetLightnessToleranceVar")
    def reset_lightness_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessToleranceVar", []))

    @jsii.member(jsii_name="resetSaturationFeather")
    def reset_saturation_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeather", []))

    @jsii.member(jsii_name="resetSaturationFeatherVar")
    def reset_saturation_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeatherVar", []))

    @jsii.member(jsii_name="resetSaturationTolerance")
    def reset_saturation_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationTolerance", []))

    @jsii.member(jsii_name="resetSaturationToleranceVar")
    def reset_saturation_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherInput")
    def hue_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVarInput")
    def hue_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceInput")
    def hue_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVarInput")
    def hue_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherInput")
    def lightness_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVarInput")
    def lightness_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceInput")
    def lightness_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVarInput")
    def lightness_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherInput")
    def saturation_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVarInput")
    def saturation_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceInput")
    def saturation_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVarInput")
    def saturation_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d015e5e01cac37af0c98385c1783c0e92d4a8f601c3b64f36c621d6d9cce685c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeather")
    def hue_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeather"))

    @hue_feather.setter
    def hue_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__43e59768ff94d3ad68275f1349010239903913c04936c111b7e6244c919bbf85)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeather", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVar")
    def hue_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeatherVar"))

    @hue_feather_var.setter
    def hue_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2681be63154b15c0ff0527a750d481ea559a9dc03c97ac012ac3d7c03e212077)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueTolerance")
    def hue_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueTolerance"))

    @hue_tolerance.setter
    def hue_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dccbe19783d96a0971af42d605c7b2a99b747aa994c19cb8cb5594754daa67b5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVar")
    def hue_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueToleranceVar"))

    @hue_tolerance_var.setter
    def hue_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__50f0e41594ab3ef2d25f60a9ef0aba5c5644d6309ecaa05d02672d34134f35f3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f9b58142f2ad61cee4de594e0e112fa12fe79a204b669167a1fd8c0322899789)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeather")
    def lightness_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeather"))

    @lightness_feather.setter
    def lightness_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__96970c448307a16bdd0ce0d009097e467a04df639abcfbfd6d3154f86747c15b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeather", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVar")
    def lightness_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeatherVar"))

    @lightness_feather_var.setter
    def lightness_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__512671a0e26fb180bc21fc9e3571cfc96e19ea30d553508759833e63a3412efb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessTolerance")
    def lightness_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessTolerance"))

    @lightness_tolerance.setter
    def lightness_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e35e3b42001ad9ef76056860e6832d66d6a3c984a5de31b525dfa33f263a878a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVar")
    def lightness_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessToleranceVar"))

    @lightness_tolerance_var.setter
    def lightness_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a1f69f6eae0d7c12abe2b3bce16eb420607c226a8a7228f215804dee45ebd67f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeather")
    def saturation_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeather"))

    @saturation_feather.setter
    def saturation_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd50b6bd173da340faea9894978e6ea0844f464c5e4fd3ebfe0cbb23afea9b49)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeather", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVar")
    def saturation_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeatherVar"))

    @saturation_feather_var.setter
    def saturation_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__26db547095b6a1ad1f76ec6c4a441fec0f1983ae965c24ee9ae6185f353bf47f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationTolerance")
    def saturation_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationTolerance"))

    @saturation_tolerance.setter
    def saturation_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f26c38aa033351c22104205cf34d516b502caebccb87ed2fe3bce4d20be2c4a4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVar")
    def saturation_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationToleranceVar"))

    @saturation_tolerance_var.setter
    def saturation_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__663fc47124e4da75c17e9ea906c1b117354aa54b8dc298fee9aa3a52016f11f5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationChromaKey]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationChromaKey]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationChromaKey]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__efdae642a77329c958de72b928d56a8f844ad5980929f45604d4cdd932cfe277)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationComposite",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "placement": "placement",
        "placement_var": "placementVar",
        "scale": "scale",
        "scale_dimension": "scaleDimension",
        "scale_dimension_var": "scaleDimensionVar",
        "scale_var": "scaleVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationComposite:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationCompositeImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        placement: typing.Optional[builtins.str] = None,
        placement_var: typing.Optional[builtins.str] = None,
        scale: typing.Optional[builtins.str] = None,
        scale_dimension: typing.Optional[builtins.str] = None,
        scale_dimension_var: typing.Optional[builtins.str] = None,
        scale_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param placement: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        :param placement_var: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        :param scale: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param scale_dimension: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        :param scale_dimension_var: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        :param scale_var: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        :param x_position: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationCompositeImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a5eebc3c7cacab485fac90b5ed72e2344d724fd78f743029d64ad6390abea0b)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument placement", value=placement, expected_type=type_hints["placement"])
            check_type(argname="argument placement_var", value=placement_var, expected_type=type_hints["placement_var"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument scale_dimension", value=scale_dimension, expected_type=type_hints["scale_dimension"])
            check_type(argname="argument scale_dimension_var", value=scale_dimension_var, expected_type=type_hints["scale_dimension_var"])
            check_type(argname="argument scale_var", value=scale_var, expected_type=type_hints["scale_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if placement is not None:
            self._values["placement"] = placement
        if placement_var is not None:
            self._values["placement_var"] = placement_var
        if scale is not None:
            self._values["scale"] = scale
        if scale_dimension is not None:
            self._values["scale_dimension"] = scale_dimension
        if scale_dimension_var is not None:
            self._values["scale_dimension_var"] = scale_dimension_var
        if scale_var is not None:
            self._values["scale_var"] = scale_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationCompositeImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationCompositeImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        '''
        result = self._values.get("placement")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement_var(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        '''
        result = self._values.get("placement_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        '''
        result = self._values.get("scale_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        '''
        result = self._values.get("scale_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        '''
        result = self._values.get("scale_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationComposite(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationCompositeImage",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationCompositeImage:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationCompositeImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationCompositeImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationCompositeImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__74bef026ebd0fe1c6afa7caa65fafb6bc60ecf0f8adff3528c1ddc030b995709)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationCompositeImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationCompositeImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4c8a3e39feadacc2dec042ac115201590f482a891d4759d441781d5fd2cd5e63)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationCompositeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationCompositeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a826465fea69bf5487067df7113b9dc1238a0874d8a138eebb3a82c42ab86deb)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationCompositeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6abb16e8b0a4cf5c8c9b45d04589644ade0663bfe205c929574cbcafb1b9ce65)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationCompositeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8dfa4caab97724eb3429706b8e8a6c23ae7c592388ed6866f2e4327f1fc4f3e1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e9f550c1175adc497aa37d71140b2616561b8d136b3e0aaf7f5362fe4d4dc855)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e8fa9ffbf5b344c46f28809cd13591044c5e3dd44361d2448c5e21b9053efe60)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationComposite]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationComposite]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a1e5748d9f6d5ebac1fb210fe1761b17cd2cb041ae2a35753becc4c08bad7ca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationCompositeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationCompositeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b52940bacbf3be3e817d460f10bf03f8b9a11359dfbaf03e2a8c7524c961b521)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationCompositeImage()

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPlacement")
    def reset_placement(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacement", []))

    @jsii.member(jsii_name="resetPlacementVar")
    def reset_placement_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacementVar", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetScaleDimension")
    def reset_scale_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimension", []))

    @jsii.member(jsii_name="resetScaleDimensionVar")
    def reset_scale_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimensionVar", []))

    @jsii.member(jsii_name="resetScaleVar")
    def reset_scale_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationCompositeImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationCompositeImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationCompositeImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="placementInput")
    def placement_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementInput"))

    @builtins.property
    @jsii.member(jsii_name="placementVarInput")
    def placement_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionInput")
    def scale_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVarInput")
    def scale_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleVarInput")
    def scale_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be30aa878081c9eec01770f86a0eb396efc7a2f1f451b51e98fcf6392f696879)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__02d6ab4d82829b85848769de973d9d39bcf54a84a9286d0081e69505451da0d1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="placement")
    def placement(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placement"))

    @placement.setter
    def placement(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8f9ab4fa58c29d03105554aa4aa30df6401b9df24dd7af8f01d80ca61679e384)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placement", value)

    @builtins.property
    @jsii.member(jsii_name="placementVar")
    def placement_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placementVar"))

    @placement_var.setter
    def placement_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ae606aa8195a006c81155be7593e35adf9800402092f3acde2b3f9e086e7d89a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placementVar", value)

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scale"))

    @scale.setter
    def scale(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__56759c9f3b54475105d6198f0f3fd622d1e805f91bc621a38e9b7b99f425a143)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scale", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimension")
    def scale_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimension"))

    @scale_dimension.setter
    def scale_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4573bf5d5bac3aaad6f4f263b853d2e3ffca1c1005a0155333b6ff8dd08ebd0a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimension", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVar")
    def scale_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimensionVar"))

    @scale_dimension_var.setter
    def scale_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0329a7a17abb089e0600096c814550ec0b138ee5eec09b02536f52e6bacceb1e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="scaleVar")
    def scale_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleVar"))

    @scale_var.setter
    def scale_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fe9fcb4e6fb451c1c818c70d94cd3e8d77022390616c8bb576dd587dc1737e28)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__73ea1db5000750e67b75d3baa0a245dd8982978a941dc7aa12d4d2f33a20a4a8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ff307364a6a321ace07367ea2402f7c8569d692dee4d4ce8785bb00ca4da0e94)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6972bb0e044de91504f328eaef14015036e28b457d0bb9927bd81d0a31b2bbc0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a20817a054d1c5a4f2e9c2145b5c27cb87f0d4df3715659e754d6f08c5daa79c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationComposite]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationComposite]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationComposite]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__87dd126f3896cff400f4f9f51606515de33c1f71dcaafcefb7d003447eda37ce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationCompound",
    jsii_struct_bases=[],
    name_mapping={"transformations": "transformations"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationCompound:
    def __init__(
        self,
        *,
        transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param transformations: transformations block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__912e245e086066e1d4ab776c392b40aa340d649a16c30a3b37ad770f943109fa)
            check_type(argname="argument transformations", value=transformations, expected_type=type_hints["transformations"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if transformations is not None:
            self._values["transformations"] = transformations

    @builtins.property
    def transformations(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationCompoundTransformations"]]]:
        '''transformations block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        result = self._values.get("transformations")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationCompoundTransformations"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationCompound(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationCompoundList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationCompoundList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5d226d245216f043782e9545201287ee242b7a99b93e20591070050faf00a3c2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationCompoundOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dd0d98f1e828bc8a9d8f230cb8124a5e7d75ca2fcddecb58f2d1d452632fa4ec)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationCompoundOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c7a13fb6d6543cd209e1b73bd13ca05d9d1162b4ad44e375fb9d046d8a8240ee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e846316d058b61eb2994a814e3d3d9906aabb3d4a645610ac64e465742cd22c7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e8eb972539d4b338161c9f7d9062ce8fea713226a75875d7430c3cb3ce5895c7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationCompound]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationCompound]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__96f5d435d11fa11027f7830b696fe61d1de5baf037e7559c90ab65cb770e027f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationCompoundOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationCompoundOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__47901395113d0227814855c19b612bb188aca6feac0f5381ea589ef4fdc4cd23)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformations")
    def put_transformations(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__96ac6f99d418b91397659e818c18cccb4d8759597eb8d43f36aa553fcee49a44)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTransformations", [value]))

    @jsii.member(jsii_name="resetTransformations")
    def reset_transformations(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformations", []))

    @builtins.property
    @jsii.member(jsii_name="transformations")
    def transformations(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationCompoundTransformationsList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationCompoundTransformationsList", jsii.get(self, "transformations"))

    @builtins.property
    @jsii.member(jsii_name="transformationsInput")
    def transformations_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationCompoundTransformations"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationCompoundTransformations"]]], jsii.get(self, "transformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationCompound]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationCompound]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationCompound]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2463ea4b66726064c6b5921b48819772bd60b193b9db19a56572de025b86e3a7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationCompoundTransformations",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationCompoundTransformations:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationCompoundTransformations(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationCompoundTransformationsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationCompoundTransformationsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b159f6a2da4a9b7ab1c13f15cbd690dd3af8445d9501216763845c5065282782)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationCompoundTransformationsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__afaa3cbab5a8c09ba7da2e16873e3cc3ed5bf9bbebae28d8f055b36f17403ade)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationCompoundTransformationsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1e84c886807fc6f5b54397fd1ab83bb4c50307fc04a12e238f571d4c63ea6457)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d0fd76aa6a13723d804d16cb22c1c12d4825a98f0e20a08e93f8e14483214263)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__097c2eb8b1fc4e2334fd10b1906fe4822e6d78a98dc5998a998d680159ae8001)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationCompoundTransformations]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationCompoundTransformations]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationCompoundTransformations]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c89a3e56c1b71335daf9b2568a570b9a03ea82cbea899f512737b166dc79d015)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationCompoundTransformationsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationCompoundTransformationsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cb01811388faf059949afa68f22b8e6fa914fcb5b7f5c1add22c535648589f40)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationCompoundTransformations]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationCompoundTransformations]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationCompoundTransformations]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3c1bc5a64a98615915000058d25b4cebf21ffd1ba10f47775bb803433e097e40)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationContrast",
    jsii_struct_bases=[],
    name_mapping={
        "brightness": "brightness",
        "brightness_var": "brightnessVar",
        "contrast": "contrast",
        "contrast_var": "contrastVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationContrast:
    def __init__(
        self,
        *,
        brightness: typing.Optional[builtins.str] = None,
        brightness_var: typing.Optional[builtins.str] = None,
        contrast: typing.Optional[builtins.str] = None,
        contrast_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param brightness: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        :param brightness_var: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        :param contrast: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param contrast_var: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d065744b4b72d4bf1c1b8dad79214232d52616be1d0f1f7776a6799b1964c85)
            check_type(argname="argument brightness", value=brightness, expected_type=type_hints["brightness"])
            check_type(argname="argument brightness_var", value=brightness_var, expected_type=type_hints["brightness_var"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument contrast_var", value=contrast_var, expected_type=type_hints["contrast_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if brightness is not None:
            self._values["brightness"] = brightness
        if brightness_var is not None:
            self._values["brightness_var"] = brightness_var
        if contrast is not None:
            self._values["contrast"] = contrast
        if contrast_var is not None:
            self._values["contrast_var"] = contrast_var

    @builtins.property
    def brightness(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        '''
        result = self._values.get("brightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def brightness_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        '''
        result = self._values.get("brightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        result = self._values.get("contrast_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationContrast(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationContrastList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationContrastList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__199bc96489956ebc4b1b33b1ad66966a8f4bc3ab466a9e1baef5adfd83f61874)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationContrastOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f5d2e0b9affb385864a7485b46da2e51b82bc73065b4e84e06e6d4a2895eb764)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationContrastOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a2e8e007fe3c1f22793e1639e63a31f074d94d2375c1960efeac03ae533b1818)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c15298014d99b2801a7f2f149d3c6d29f80c3d5c3400c436134757798b6ad398)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5db38f9d81830d9560ee56297b67f3ef2ddf7ddddc834155ede91553c82de377)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationContrast]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationContrast]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1441110b3d0ef59e0df0738a164c3524f4678545d6140ece40083c9a8d72fe0d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationContrastOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationContrastOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e0d563837aaf718934214888860e8d634877155b3922e8f78f7d64f20d5dc724)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetBrightness")
    def reset_brightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightness", []))

    @jsii.member(jsii_name="resetBrightnessVar")
    def reset_brightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightnessVar", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetContrastVar")
    def reset_contrast_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrastVar", []))

    @builtins.property
    @jsii.member(jsii_name="brightnessInput")
    def brightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="brightnessVarInput")
    def brightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastVarInput")
    def contrast_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="brightness")
    def brightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightness"))

    @brightness.setter
    def brightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__55f8276284ee68f7f33aff4a0dbc76b483bff3fd9c1b5e35874adbf0f3773d80)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightness", value)

    @builtins.property
    @jsii.member(jsii_name="brightnessVar")
    def brightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightnessVar"))

    @brightness_var.setter
    def brightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7e901bbbbf2093ecd055a0bf74ad96c5f9e74d0a77b759acb83a17d557c1cc11)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrast"))

    @contrast.setter
    def contrast(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d92fee028dc0080f8500ab235447e80b46fb6f6be19eb7b71edb2c01b43241c2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrast", value)

    @builtins.property
    @jsii.member(jsii_name="contrastVar")
    def contrast_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrastVar"))

    @contrast_var.setter
    def contrast_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fd99f1cccc505106cf96b3e58321ca8409b940fbafbfbd01ea0e800a1912d106)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrastVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationContrast]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationContrast]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationContrast]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e165edc14257f9a670e71d90ba18961b2018f9652a354278ab97c6882d203cec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationGoop",
    jsii_struct_bases=[],
    name_mapping={
        "chaos": "chaos",
        "chaos_var": "chaosVar",
        "density": "density",
        "density_var": "densityVar",
        "power": "power",
        "power_var": "powerVar",
        "seed": "seed",
        "seed_var": "seedVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationGoop:
    def __init__(
        self,
        *,
        chaos: typing.Optional[builtins.str] = None,
        chaos_var: typing.Optional[builtins.str] = None,
        density: typing.Optional[builtins.str] = None,
        density_var: typing.Optional[builtins.str] = None,
        power: typing.Optional[builtins.str] = None,
        power_var: typing.Optional[builtins.str] = None,
        seed: typing.Optional[builtins.str] = None,
        seed_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param chaos: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        :param chaos_var: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        :param density: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        :param density_var: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        :param power: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        :param power_var: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        :param seed: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        :param seed_var: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be5f14aff0bb08b5fee9409800b1ff48ac3d189774f872208a6ef16ee94c7e04)
            check_type(argname="argument chaos", value=chaos, expected_type=type_hints["chaos"])
            check_type(argname="argument chaos_var", value=chaos_var, expected_type=type_hints["chaos_var"])
            check_type(argname="argument density", value=density, expected_type=type_hints["density"])
            check_type(argname="argument density_var", value=density_var, expected_type=type_hints["density_var"])
            check_type(argname="argument power", value=power, expected_type=type_hints["power"])
            check_type(argname="argument power_var", value=power_var, expected_type=type_hints["power_var"])
            check_type(argname="argument seed", value=seed, expected_type=type_hints["seed"])
            check_type(argname="argument seed_var", value=seed_var, expected_type=type_hints["seed_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if chaos is not None:
            self._values["chaos"] = chaos
        if chaos_var is not None:
            self._values["chaos_var"] = chaos_var
        if density is not None:
            self._values["density"] = density
        if density_var is not None:
            self._values["density_var"] = density_var
        if power is not None:
            self._values["power"] = power
        if power_var is not None:
            self._values["power_var"] = power_var
        if seed is not None:
            self._values["seed"] = seed
        if seed_var is not None:
            self._values["seed_var"] = seed_var

    @builtins.property
    def chaos(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        '''
        result = self._values.get("chaos")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def chaos_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        '''
        result = self._values.get("chaos_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        '''
        result = self._values.get("density")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density_var(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        '''
        result = self._values.get("density_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        '''
        result = self._values.get("power")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power_var(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        '''
        result = self._values.get("power_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        '''
        result = self._values.get("seed")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed_var(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        result = self._values.get("seed_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationGoop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationGoopList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationGoopList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3885469baf060fefff5ead5983c6f16d8d6857f65765e99825175a72df9e50ed)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationGoopOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e2af40eda0f28d0036617405b0ec62ee763dce62511a9e422da8543d25e0aded)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationGoopOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d224657c19205a436b69f14b19f4bda02b7e4769c89c5029582507b78b6f3c25)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7f7123880e8f11c83123e4ee639a33bf52ae4d25549f0dbc2907fcf5ef4418c1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e047623900b3f6063f316321493e79f4349b6fd6ad43a0ecc3c9c52d633de219)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationGoop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationGoop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__387c8524fff90b809e91cdc2ab37fa4fe0112a2197668ae77fcf5332ef38a499)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationGoopOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationGoopOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c7d9216c9e256d8e28630b30ecea94c363eea06bd833c1e2391a38305ce3db87)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetChaos")
    def reset_chaos(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaos", []))

    @jsii.member(jsii_name="resetChaosVar")
    def reset_chaos_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaosVar", []))

    @jsii.member(jsii_name="resetDensity")
    def reset_density(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensity", []))

    @jsii.member(jsii_name="resetDensityVar")
    def reset_density_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensityVar", []))

    @jsii.member(jsii_name="resetPower")
    def reset_power(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPower", []))

    @jsii.member(jsii_name="resetPowerVar")
    def reset_power_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPowerVar", []))

    @jsii.member(jsii_name="resetSeed")
    def reset_seed(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeed", []))

    @jsii.member(jsii_name="resetSeedVar")
    def reset_seed_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeedVar", []))

    @builtins.property
    @jsii.member(jsii_name="chaosInput")
    def chaos_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosInput"))

    @builtins.property
    @jsii.member(jsii_name="chaosVarInput")
    def chaos_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosVarInput"))

    @builtins.property
    @jsii.member(jsii_name="densityInput")
    def density_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityInput"))

    @builtins.property
    @jsii.member(jsii_name="densityVarInput")
    def density_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="powerInput")
    def power_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerInput"))

    @builtins.property
    @jsii.member(jsii_name="powerVarInput")
    def power_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerVarInput"))

    @builtins.property
    @jsii.member(jsii_name="seedInput")
    def seed_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedInput"))

    @builtins.property
    @jsii.member(jsii_name="seedVarInput")
    def seed_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedVarInput"))

    @builtins.property
    @jsii.member(jsii_name="chaos")
    def chaos(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaos"))

    @chaos.setter
    def chaos(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__904a440c6a0940c97bf05534e6495d85c0de9aff1b6bc3bc26119c8a03df1bd9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaos", value)

    @builtins.property
    @jsii.member(jsii_name="chaosVar")
    def chaos_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaosVar"))

    @chaos_var.setter
    def chaos_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b3ef4c822add4aa465589be8ca8a23aa825496980fdad4b26bf4f0fec67ec4dc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaosVar", value)

    @builtins.property
    @jsii.member(jsii_name="density")
    def density(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "density"))

    @density.setter
    def density(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d1ae647a9553b4723b5c1693ae23e20d8723ab3c93dcbfdf6891679037ecf612)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "density", value)

    @builtins.property
    @jsii.member(jsii_name="densityVar")
    def density_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "densityVar"))

    @density_var.setter
    def density_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ba877e9e252f8facc17ec1f80f2583769dbc25ade3e9e6f9de6465eb1b8ca94)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "densityVar", value)

    @builtins.property
    @jsii.member(jsii_name="power")
    def power(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "power"))

    @power.setter
    def power(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b3786f9eca01f9ab141172612b30b368321cfc32207ffeb10f8c2b8fa01d30f5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "power", value)

    @builtins.property
    @jsii.member(jsii_name="powerVar")
    def power_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "powerVar"))

    @power_var.setter
    def power_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__69b8d0e70cde8b971ef19470dbb8fc200f4dd6939722cea1a1f83d6b1ade8a8d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "powerVar", value)

    @builtins.property
    @jsii.member(jsii_name="seed")
    def seed(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seed"))

    @seed.setter
    def seed(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3b72773f5e9e636befda35c5cbf0f8c723e9cb287598ed70ae426b92cdd792fc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seed", value)

    @builtins.property
    @jsii.member(jsii_name="seedVar")
    def seed_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seedVar"))

    @seed_var.setter
    def seed_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7bf8f8a4c487a955d844f101e28624ada025e0c5170a1407219a329919bf8339)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seedVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationGoop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationGoop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationGoop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__595939fd27469ead35661213b1c48719b99b042d432dca88923c9ab3e20e45ea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationGrayscale",
    jsii_struct_bases=[],
    name_mapping={"type": "type", "type_var": "typeVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationGrayscale:
    def __init__(
        self,
        *,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param type: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0914e1c8313fc066c2beb10d82890b9416d622d420e208042a39a752ad1f20d2)
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationGrayscale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationGrayscaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationGrayscaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__da268698e0f3aa2eb66d2dce5a1498c6c71817e770204320ba0688261677bdc6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationGrayscaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__41bfec46677883e64c098e05fc22b04ca91dbfe9a9cc6e9fb252a57573c838aa)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationGrayscaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8f2ce157eee0cf3833fafcd27df4fec90467cd1f952344f7dcedc85d733f0f7e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9539113b0b6ad79f7b0ab0ffabb91af8b688d3d03e8bb66ea81b0d037e8aa041)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__51a94ad4924a66c0d2aa77a8859e9f1db8932975e6a3bf115e0b75f060a66481)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationGrayscale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationGrayscale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8b7c4ff1e128ad673ceeac890e3712bfc09b3d056bdaeb647b588059134c96e9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationGrayscaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationGrayscaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c6bb3f441f9b85979e230ec201f304b3806c381254eb06ca7ea006f89fbb76fb)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b2713c3e38ae3a6e2d3a8b09ed8113d6839c83ad9b4f39908e1077430d8a754d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b6768c98897af14601de9db63a8fb94119a2e0dcc8104e886821368a688cc141)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationGrayscale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationGrayscale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationGrayscale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__91117a2c80c3119fe7479514c338ea200f5161c17942a4d08d79a1f33ae606dd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationHsl",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "lightness": "lightness",
        "lightness_var": "lightnessVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationHsl:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness: typing.Optional[builtins.str] = None,
        lightness_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        :param lightness_var: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3f16202dcac0f4606798592f9cc2c69aeef96b0956def92b4a5edcbab3d98756)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness", value=lightness, expected_type=type_hints["lightness"])
            check_type(argname="argument lightness_var", value=lightness_var, expected_type=type_hints["lightness_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness is not None:
            self._values["lightness"] = lightness
        if lightness_var is not None:
            self._values["lightness_var"] = lightness_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        '''
        result = self._values.get("lightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        '''
        result = self._values.get("lightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationHsl(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationHslList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationHslList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b1b5b82ef43d937f27b7d331b048a9d6de8abac4a8e8500f18c553bd2a10df4b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationHslOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3851744fbc96cd1da7e92eb3cab0eb1273993eb4d3d7f58eb3484fd83a14da2d)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationHslOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__42ce96e7def528c05e6ac653f0dde034e8f7ac50c5676949eff49241c803947a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__677f7650117b13820a3a96667d4bc3eecaca049542e0980b55b7b25f93e15faa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a4ab48af4e40f1b475a73208f80041086928eb9a117689a82d2082e2c6887850)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationHsl]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationHsl]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2709aafee2066e8abf95cc26fd846b8b3e3269ae4394ff2c1cfa3338032b20f4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationHslOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationHslOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__723af49bf369edce7aab5bf92828698e4ce83afd2793addd72e6b06ebfd5d9c4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightness")
    def reset_lightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightness", []))

    @jsii.member(jsii_name="resetLightnessVar")
    def reset_lightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessInput")
    def lightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessVarInput")
    def lightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fd1a9e2e01a8ad61dccc0f69c92b033f0b8880d2deae95cebd53a8b844cabddf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__928f99fe41ca15a111835ca432fc7668e926d63492d7c33f104bac0b0832b83b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightness")
    def lightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightness"))

    @lightness.setter
    def lightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d5af2434b02f3f4e6bdf6d5b817211bd55201c0c7430b4f63d1aec96f32e1081)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightness", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessVar")
    def lightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessVar"))

    @lightness_var.setter
    def lightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__43efca915ad5dc678a80a9f5b92c5c63a03b3a8531b3f56e944ea43c7c2e9bca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bbec86efc16e676707276e922a72e2fe25a5e58da37a66563455167c7f57358b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__de8c3638208001d84a6de0a15c19cc9aa958802ad625c764ca3a0d0339c11a21)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationHsl]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationHsl]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationHsl]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5d544a09852a78ba8171083b66ee4f984b59ac854ed7032b046fdb815b423c68)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationHsv",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationHsv:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        :param value: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__473c08c61de5f38da4095cb4c20f92d9b31aa080e94c700a52fdc8ac06749b2b)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationHsv(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationHsvList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationHsvList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bcd1a4de1d4f459f570e5339817e3979884cd5bdef40855198ade9fa69b2c742)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationHsvOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__38d4370388f2c9141122b03094b2d4240eb6fc7346a28f20dd66ace34d6eb11d)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationHsvOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b62cf54db2d29cd7af6ecbe4cfe643e03ce1d8d6704f656d4efcd691e1b55770)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ed7142dd04f3e2bfac93cb4248e8aaafdf7d1eb6c38c55194365c06f30d53af0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1a91317690c370c76072d912861ce82e5fab0a37835bc4a0da0bf51697bf7e86)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationHsv]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationHsv]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6ce192ca07d6cb602c7d07a8419442290c4da933d7c69c36dcfb44a4fd8fa056)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationHsvOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationHsvOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0a5b8c97d6e8236a7c37dc78782b5dda3967aed6c6635d7b2ee23476838dd9fc)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__661dfb8aa5b5f1c782a08d191b245a9af1b76729c90a5ed0ec5c8de495c4f58d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b8f07c361dfc6dc9b8ae01d951f59eee9357efc3c5df38a40a5b57680a00f589)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9287dd179a74c571b8b6893b689fe83d1ab0b3ac5e94064c1ba758d23017edba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7c1570a5fe98281ac99bbc5b56ddcda5783b985a3ee5d980e77a1566614a169f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ef360c83bfaf5ecfd48e6ae956186051e49a6e73e3fda8a54f71f3414a770c8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d826a71b7f71b7bacdf54d6e35e7b7db6f601466e9c0513b2181aa9d316ac4df)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationHsv]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationHsv]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationHsv]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb8bd4099febc7ea1b10737d3ac88b23937d8d63fdb0ed34ca124854d2491cb1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfDimension",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "dimension": "dimension",
        "dimension_var": "dimensionVar",
        "equal": "equal",
        "greater_than": "greaterThan",
        "less_than": "lessThan",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfDimension:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfDimensionDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        dimension: typing.Optional[builtins.str] = None,
        dimension_var: typing.Optional[builtins.str] = None,
        equal: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfDimensionEqual", typing.Dict[builtins.str, typing.Any]]] = None,
        greater_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfDimensionGreaterThan", typing.Dict[builtins.str, typing.Any]]] = None,
        less_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfDimensionLessThan", typing.Dict[builtins.str, typing.Any]]] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param dimension: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        :param dimension_var: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        :param equal: equal block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        :param greater_than: greater_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        :param less_than: less_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        :param value: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfDimensionDefault(**default)
        if isinstance(equal, dict):
            equal = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfDimensionEqual(**equal)
        if isinstance(greater_than, dict):
            greater_than = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfDimensionGreaterThan(**greater_than)
        if isinstance(less_than, dict):
            less_than = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfDimensionLessThan(**less_than)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__88cac9c38d5b59ba1f029d8321ae07dcd4989eefca94ebf01674138d8107d7de)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument dimension", value=dimension, expected_type=type_hints["dimension"])
            check_type(argname="argument dimension_var", value=dimension_var, expected_type=type_hints["dimension_var"])
            check_type(argname="argument equal", value=equal, expected_type=type_hints["equal"])
            check_type(argname="argument greater_than", value=greater_than, expected_type=type_hints["greater_than"])
            check_type(argname="argument less_than", value=less_than, expected_type=type_hints["less_than"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if dimension is not None:
            self._values["dimension"] = dimension
        if dimension_var is not None:
            self._values["dimension_var"] = dimension_var
        if equal is not None:
            self._values["equal"] = equal
        if greater_than is not None:
            self._values["greater_than"] = greater_than
        if less_than is not None:
            self._values["less_than"] = less_than
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfDimensionDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfDimensionDefault"], result)

    @builtins.property
    def dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        '''
        result = self._values.get("dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        '''
        result = self._values.get("dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def equal(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfDimensionEqual"]:
        '''equal block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        '''
        result = self._values.get("equal")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfDimensionEqual"], result)

    @builtins.property
    def greater_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfDimensionGreaterThan"]:
        '''greater_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        '''
        result = self._values.get("greater_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfDimensionGreaterThan"], result)

    @builtins.property
    def less_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfDimensionLessThan"]:
        '''less_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        '''
        result = self._values.get("less_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfDimensionLessThan"], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfDimension(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfDimensionDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfDimensionDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfDimensionDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfDimensionDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfDimensionDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__05d76e76add08414bb62c2dcc8c09aa174024e2ea8a97409bf62be410a36d66d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfDimensionDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfDimensionDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9efd555fb32868f09820a5451fb4ef6607646cc70631230713f532eef1c5255a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfDimensionEqual",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfDimensionEqual:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfDimensionEqual(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfDimensionEqualOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfDimensionEqualOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1229e4d41a4bb63b6a34b5c62411914e86b8342a8d580a41eb4755a43bc6b342)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfDimensionEqual], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfDimensionEqual],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__abbf587d88983d049f4a3a575e617bf0b2b1f1ed3cc6e242f75f4a8c6fd20393)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfDimensionGreaterThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfDimensionGreaterThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfDimensionGreaterThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfDimensionGreaterThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfDimensionGreaterThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df4517fd02743cbd05e99232201c01e98434c89df9d116d968c48166f448bd4c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfDimensionGreaterThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfDimensionGreaterThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__11be117227523b1707fc1f26e77b83ac740c010e8b1ad3457e8d0ab8da8cc15f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfDimensionLessThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfDimensionLessThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfDimensionLessThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfDimensionLessThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfDimensionLessThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f584d64be11c2b7c7109f7bf0c9cba78e87249c27d8af1311b82e244b29b3ccb)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfDimensionLessThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfDimensionLessThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__535b4c6da6c6ac88075cd20caf04c4e9d8e5f974357c13a5bc323757e1e9bcdd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfDimensionList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfDimensionList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a5f6c5616c1658a9678ec8c01b9f01f074f4080793d81ff5a8a39d72ba70daa5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfDimensionOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5dd8e12793c9da02fc3ea241a3f44ed3559f89c212b8581ad062bd7d503dabd3)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfDimensionOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2fe02936aad959c4afd2bafa8571d41f597ff6285d0dc895834d77c2ae474166)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e28882c9eb062edc92f9c41a9e31ecb604a4943323d29b776fc9f8d238d22c6c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c9ba17ad14975bd307ee670f80d22166f273eeb0de2ad688debd52ee8acef02e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfDimension]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfDimension]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7e2df4b7e05bfaa6a061a7031faf360ffa01376773030b024fbab8cc29810035)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfDimensionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfDimensionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e228f64348047854042e557ba61bc185fbffdee3959f6c1ecb328d60bf3faa7a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfDimensionDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putEqual")
    def put_equal(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfDimensionEqual()

        return typing.cast(None, jsii.invoke(self, "putEqual", [value]))

    @jsii.member(jsii_name="putGreaterThan")
    def put_greater_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfDimensionGreaterThan()

        return typing.cast(None, jsii.invoke(self, "putGreaterThan", [value]))

    @jsii.member(jsii_name="putLessThan")
    def put_less_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfDimensionLessThan()

        return typing.cast(None, jsii.invoke(self, "putLessThan", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetDimension")
    def reset_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimension", []))

    @jsii.member(jsii_name="resetDimensionVar")
    def reset_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimensionVar", []))

    @jsii.member(jsii_name="resetEqual")
    def reset_equal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEqual", []))

    @jsii.member(jsii_name="resetGreaterThan")
    def reset_greater_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGreaterThan", []))

    @jsii.member(jsii_name="resetLessThan")
    def reset_less_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLessThan", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfDimensionDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfDimensionDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="equal")
    def equal(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfDimensionEqualOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfDimensionEqualOutputReference, jsii.get(self, "equal"))

    @builtins.property
    @jsii.member(jsii_name="greaterThan")
    def greater_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfDimensionGreaterThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfDimensionGreaterThanOutputReference, jsii.get(self, "greaterThan"))

    @builtins.property
    @jsii.member(jsii_name="lessThan")
    def less_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfDimensionLessThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfDimensionLessThanOutputReference, jsii.get(self, "lessThan"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfDimensionDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionInput")
    def dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionVarInput")
    def dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="equalInput")
    def equal_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfDimensionEqual], jsii.get(self, "equalInput"))

    @builtins.property
    @jsii.member(jsii_name="greaterThanInput")
    def greater_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfDimensionGreaterThan], jsii.get(self, "greaterThanInput"))

    @builtins.property
    @jsii.member(jsii_name="lessThanInput")
    def less_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfDimensionLessThan], jsii.get(self, "lessThanInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="dimension")
    def dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimension"))

    @dimension.setter
    def dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__758803f659197a3b38530d4bc9a399009cdf3917251f4db2c0816493023d7eef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimension", value)

    @builtins.property
    @jsii.member(jsii_name="dimensionVar")
    def dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimensionVar"))

    @dimension_var.setter
    def dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d3250804385a991073971cd776875839fc34cc0cbf6093fb7c04889722b5a6ab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a2956189d791d22910bebb34149b43f889477a5615b2e95085823705c1f9f3ef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__843307562cfa6567be5b69a61c2f8dd601ada57cf66e994c3d88470a1458223e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfDimension]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfDimension]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfDimension]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c97c0ea7737d7079764263b1c68f745e60f56454bdace0aab5a1dfc3afcf54c4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfOrientation",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "landscape": "landscape",
        "portrait": "portrait",
        "square": "square",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfOrientation:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfOrientationDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        landscape: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfOrientationLandscape", typing.Dict[builtins.str, typing.Any]]] = None,
        portrait: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfOrientationPortrait", typing.Dict[builtins.str, typing.Any]]] = None,
        square: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfOrientationSquare", typing.Dict[builtins.str, typing.Any]]] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param landscape: landscape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        :param portrait: portrait block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        :param square: square block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfOrientationDefault(**default)
        if isinstance(landscape, dict):
            landscape = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfOrientationLandscape(**landscape)
        if isinstance(portrait, dict):
            portrait = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfOrientationPortrait(**portrait)
        if isinstance(square, dict):
            square = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfOrientationSquare(**square)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__342e7561ef7e857c3107541316ff871bc844ab6929b3eba5c6dfc5d17842d1b1)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument landscape", value=landscape, expected_type=type_hints["landscape"])
            check_type(argname="argument portrait", value=portrait, expected_type=type_hints["portrait"])
            check_type(argname="argument square", value=square, expected_type=type_hints["square"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if landscape is not None:
            self._values["landscape"] = landscape
        if portrait is not None:
            self._values["portrait"] = portrait
        if square is not None:
            self._values["square"] = square

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfOrientationDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfOrientationDefault"], result)

    @builtins.property
    def landscape(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfOrientationLandscape"]:
        '''landscape block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        '''
        result = self._values.get("landscape")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfOrientationLandscape"], result)

    @builtins.property
    def portrait(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfOrientationPortrait"]:
        '''portrait block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        '''
        result = self._values.get("portrait")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfOrientationPortrait"], result)

    @builtins.property
    def square(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfOrientationSquare"]:
        '''square block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        result = self._values.get("square")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfOrientationSquare"], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfOrientation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfOrientationDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfOrientationDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfOrientationDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfOrientationDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfOrientationDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3660eb5dc5071055945779e7af74ade8d471a20cb942b3ea60c19cbbd953f556)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfOrientationDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfOrientationDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__77bd8dd02e18552aa063aa90a358b223bbfe6182c2726730f0530a5124233aac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfOrientationLandscape",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfOrientationLandscape:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfOrientationLandscape(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfOrientationLandscapeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfOrientationLandscapeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7869819439947acb3f7798a64db23c4673559cd5eab175f24d9308294cf9192d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfOrientationLandscape], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfOrientationLandscape],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2b573250da8768633ef9e0bc2c28a7725bd8b3ff5886206f52e2039b06855da1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfOrientationList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfOrientationList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a2c6325a4410ab6014cdff464caf6ff596ce3e68b4fe1b591e83c7144df88a21)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfOrientationOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ada6cf0051e5aab7938ad2e3c7d3824f6a3442c846af9c654d2dabc473b7acbc)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfOrientationOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__60b89d93f410295e80648f25fd95ab75fee1b08cefc6a58a40c97cf8ab42e4d0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__36256afd2a8d06ff611ab6b8f2de90ab4d8300d9d462bd79532e31978f10ddf2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__007b763d0ae569395290ae731aa3ff44ee42624fa3193257246f88111e152937)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfOrientation]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfOrientation]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4d330f62c0e5679296fcc1d5bcc3a3dea96608fb941bac7509eac6d57df701ae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfOrientationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfOrientationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1bc2ae772e59f44f33c97b2aaf103ecbb8a513664291bca59dc449b33bfbe641)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfOrientationDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putLandscape")
    def put_landscape(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfOrientationLandscape()

        return typing.cast(None, jsii.invoke(self, "putLandscape", [value]))

    @jsii.member(jsii_name="putPortrait")
    def put_portrait(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfOrientationPortrait()

        return typing.cast(None, jsii.invoke(self, "putPortrait", [value]))

    @jsii.member(jsii_name="putSquare")
    def put_square(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfOrientationSquare()

        return typing.cast(None, jsii.invoke(self, "putSquare", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetLandscape")
    def reset_landscape(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLandscape", []))

    @jsii.member(jsii_name="resetPortrait")
    def reset_portrait(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPortrait", []))

    @jsii.member(jsii_name="resetSquare")
    def reset_square(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSquare", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfOrientationDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfOrientationDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="landscape")
    def landscape(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfOrientationLandscapeOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfOrientationLandscapeOutputReference, jsii.get(self, "landscape"))

    @builtins.property
    @jsii.member(jsii_name="portrait")
    def portrait(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfOrientationPortraitOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfOrientationPortraitOutputReference", jsii.get(self, "portrait"))

    @builtins.property
    @jsii.member(jsii_name="square")
    def square(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfOrientationSquareOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfOrientationSquareOutputReference", jsii.get(self, "square"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfOrientationDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="landscapeInput")
    def landscape_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfOrientationLandscape], jsii.get(self, "landscapeInput"))

    @builtins.property
    @jsii.member(jsii_name="portraitInput")
    def portrait_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfOrientationPortrait"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfOrientationPortrait"], jsii.get(self, "portraitInput"))

    @builtins.property
    @jsii.member(jsii_name="squareInput")
    def square_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfOrientationSquare"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfOrientationSquare"], jsii.get(self, "squareInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfOrientation]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfOrientation]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfOrientation]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6d4250fcba7c96469be39a863427b202659c58c6c4c724d608df273f9dc566eb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfOrientationPortrait",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfOrientationPortrait:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfOrientationPortrait(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfOrientationPortraitOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfOrientationPortraitOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__450616edd0d3994073df004e2b228fe2efe7b2c520ee68f55290a792e79b564d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfOrientationPortrait]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfOrientationPortrait], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfOrientationPortrait],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6b0b62c8d0573a1fb62fa1630125075c710271a9dd6a0f34ee75a15c8ed29228)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfOrientationSquare",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfOrientationSquare:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfOrientationSquare(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfOrientationSquareOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfOrientationSquareOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dd5b7026b6bd8ede01728df34508a239ced7772e624a50813b1af1634377bd6c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfOrientationSquare]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfOrientationSquare], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfOrientationSquare],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__faba454d30117fa4ee32fdc002b971f8461c2e097b2465d9612716e27e5ad035)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationMaxColors",
    jsii_struct_bases=[],
    name_mapping={"colors": "colors", "colors_var": "colorsVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationMaxColors:
    def __init__(
        self,
        *,
        colors: typing.Optional[builtins.str] = None,
        colors_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param colors: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        :param colors_var: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ff0bd53489417f5017f17367f3b1b4a06532e393f135119b44acb19ee365c201)
            check_type(argname="argument colors", value=colors, expected_type=type_hints["colors"])
            check_type(argname="argument colors_var", value=colors_var, expected_type=type_hints["colors_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if colors is not None:
            self._values["colors"] = colors
        if colors_var is not None:
            self._values["colors_var"] = colors_var

    @builtins.property
    def colors(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        '''
        result = self._values.get("colors")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def colors_var(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        result = self._values.get("colors_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationMaxColors(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationMaxColorsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationMaxColorsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__257714038a0383e9f8f30e71d54da602bcfe6b10f0b95db33319998e807c249e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationMaxColorsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__398007519ceb7ca23cfa6bbd4d361528cfa3cbb9dc1fba0bfd26ea1e7b38fa20)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationMaxColorsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dd7f8c8b2c2b91230a85d0752cf0547ed523983e3bb36393cb12c1b3ae3505a4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__31567fa75e116d93415b8272d101af956faed6462b608c1522551040064d1869)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f5c9fecba8408a3bf839f30d3be763f9d9175ff46e8793b856cfcd543e4824f7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationMaxColors]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationMaxColors]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__401ec9930af5eef9888cb98642bd1fb8e02ffc59519a62bd03ccecf4df32b743)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationMaxColorsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationMaxColorsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__03e5fbf7ba05b3018ca171c2b6e84e33f2306846d558f2215da62d04a6b89094)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColors")
    def reset_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColors", []))

    @jsii.member(jsii_name="resetColorsVar")
    def reset_colors_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorsVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorsInput")
    def colors_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsInput"))

    @builtins.property
    @jsii.member(jsii_name="colorsVarInput")
    def colors_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsVarInput"))

    @builtins.property
    @jsii.member(jsii_name="colors")
    def colors(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colors"))

    @colors.setter
    def colors(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c9d911b33d4fbf45b21973b638e046c00996fe711718f3ae1249c90697ca0cd7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colors", value)

    @builtins.property
    @jsii.member(jsii_name="colorsVar")
    def colors_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorsVar"))

    @colors_var.setter
    def colors_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a0790e83c1648d2015beab954304a6743af19948890f4635b961d415cc83296)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorsVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationMaxColors]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationMaxColors]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationMaxColors]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__597a6bd1a4988cefd6d89bc8468d04f36d14db22d0b99dbd530d48c506a9d957)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationMirror",
    jsii_struct_bases=[],
    name_mapping={
        "horizontal": "horizontal",
        "horizontal_var": "horizontalVar",
        "vertical": "vertical",
        "vertical_var": "verticalVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationMirror:
    def __init__(
        self,
        *,
        horizontal: typing.Optional[builtins.str] = None,
        horizontal_var: typing.Optional[builtins.str] = None,
        vertical: typing.Optional[builtins.str] = None,
        vertical_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param horizontal: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        :param horizontal_var: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        :param vertical: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        :param vertical_var: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e0752013560400418df32f91fb3e5a9109881790dba905aed064a45d5d76c8e5)
            check_type(argname="argument horizontal", value=horizontal, expected_type=type_hints["horizontal"])
            check_type(argname="argument horizontal_var", value=horizontal_var, expected_type=type_hints["horizontal_var"])
            check_type(argname="argument vertical", value=vertical, expected_type=type_hints["vertical"])
            check_type(argname="argument vertical_var", value=vertical_var, expected_type=type_hints["vertical_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if horizontal is not None:
            self._values["horizontal"] = horizontal
        if horizontal_var is not None:
            self._values["horizontal_var"] = horizontal_var
        if vertical is not None:
            self._values["vertical"] = vertical
        if vertical_var is not None:
            self._values["vertical_var"] = vertical_var

    @builtins.property
    def horizontal(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        '''
        result = self._values.get("horizontal")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def horizontal_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        '''
        result = self._values.get("horizontal_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        '''
        result = self._values.get("vertical")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        result = self._values.get("vertical_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationMirror(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationMirrorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationMirrorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1de7275ca5150c27f8ab34a3502ba27d83e87a598c68064178f13f035fe2a365)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationMirrorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cb4ee297b8ef275bfc09f777fbe8af359b847ed9895cb5c9b1d0d0dca8d5f621)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationMirrorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0cfd9f574722ce7b1e3b696a769971956bad29f83fb1193e2aaf82c5729f4796)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__61df5164eb39854de294e18ce406a9bb2a1d95ac7afacae5612c3f6efeb58e34)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb9aec9406decca5f28553f52d6132ee7e08821f0f41f100dbfbd01ed30286b7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationMirror]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationMirror]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d387babefe9f9d9e57b6202135d14c77bc7131770de897015601a13949b934d5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationMirrorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationMirrorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__868922dbe92859d174f1c10fdf28556c57b3b4bf201e418813681da27429e190)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHorizontal")
    def reset_horizontal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontal", []))

    @jsii.member(jsii_name="resetHorizontalVar")
    def reset_horizontal_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontalVar", []))

    @jsii.member(jsii_name="resetVertical")
    def reset_vertical(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVertical", []))

    @jsii.member(jsii_name="resetVerticalVar")
    def reset_vertical_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVerticalVar", []))

    @builtins.property
    @jsii.member(jsii_name="horizontalInput")
    def horizontal_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontalVarInput")
    def horizontal_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalInput")
    def vertical_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalVarInput")
    def vertical_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontal")
    def horizontal(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontal"))

    @horizontal.setter
    def horizontal(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__27ddff1bb59dacc97ae5293e794280e7bf70604c632e6209340935f20f5f29cb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontal", value)

    @builtins.property
    @jsii.member(jsii_name="horizontalVar")
    def horizontal_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontalVar"))

    @horizontal_var.setter
    def horizontal_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__40059d463f8a2adf16e20d9c87bb741ca8b9ca2787581f4471a2cd4ee2c43ba0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontalVar", value)

    @builtins.property
    @jsii.member(jsii_name="vertical")
    def vertical(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "vertical"))

    @vertical.setter
    def vertical(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__18d605c01acbc476f28b64a6832464589db983c9e3be21c3e9dd6bba54a5c595)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "vertical", value)

    @builtins.property
    @jsii.member(jsii_name="verticalVar")
    def vertical_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "verticalVar"))

    @vertical_var.setter
    def vertical_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f9dbe9093bab185d837249bb15b7d79ce8eebc356ce10f5f6e883379afc82a48)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "verticalVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationMirror]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationMirror]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationMirror]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9782310f905baf46cbe62b6025635dacc9c38dab9e9785ef4383a8d15b1266b6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationMonoHue",
    jsii_struct_bases=[],
    name_mapping={"hue": "hue", "hue_var": "hueVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationMonoHue:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__239fe0ec118b1cc368e9eaaf504ed46fff13d3e41bab2480a1bc303c5dce721a)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationMonoHue(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationMonoHueList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationMonoHueList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__42516506093a18c72b77f33564f297c3a4525eb08ae791a9f18b3087856cf0eb)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationMonoHueOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3339ebf0482874c4a926b405e01b77cf043b45529d0a85cc0debcf09d98e6116)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationMonoHueOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__740883ed96d118cf059889c1e71acac08a9689b7b33cf1975df862228e323e7b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b991a49d11a65db94a1911fb4c1de849e34e9199e42e0eb052679fc4193b7273)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__63dbbe0426530ff7633e6b395e738da8d9affd1721211d47772a5602e69efc6e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationMonoHue]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationMonoHue]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__755f751d5215ffbd0648b8f24a354b4f7270fda941144acc937032c475a097e2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationMonoHueOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationMonoHueOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__90bc3492ac214e1b5d8aac361c380d16aeeae5a92064517ebf771a9199c2e028)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b5170a4b9f25a9dfa8d4f303f6ce2e477bd7eec23734a3edabdf64c4c7fa10bd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9e66469a6eb3d607086f4bb6213b04ad230678aa9bd5c11eb5671e2765c54514)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationMonoHue]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationMonoHue]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationMonoHue]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4fc8f52cb24b40135f8e9b90b7d520b9a85290a38d85996e8d9d0c1d1c63f075)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationOpacity",
    jsii_struct_bases=[],
    name_mapping={"opacity": "opacity", "opacity_var": "opacityVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationOpacity:
    def __init__(
        self,
        *,
        opacity: typing.Optional[builtins.str] = None,
        opacity_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param opacity: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param opacity_var: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a1bcc1fc268c694953de7446675f89889e3f8b771c862ff0b55c4280dc009d3f)
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument opacity_var", value=opacity_var, expected_type=type_hints["opacity_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if opacity is not None:
            self._values["opacity"] = opacity
        if opacity_var is not None:
            self._values["opacity_var"] = opacity_var

    @builtins.property
    def opacity(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def opacity_var(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        result = self._values.get("opacity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationOpacity(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationOpacityList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationOpacityList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a4c646452a3cff964adc7d9d97c14dc7dbe18ad9baf5aaa55d07ff1579bd3877)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationOpacityOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ecd47719041a87579340d8713c4b6f76a6abb524b856cc127e0acc46ce69a2da)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationOpacityOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__658f4723871496a0af19159aed004bc4406fa7095300e37e535a1ef839df9cef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__160827182e4ceb4ed37220a136c535aa8d3299a466ed5bed0bacc36fb7ed0073)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7cae618d2a435568fa9bcc0529ebb3cae73f260e0e41288f4e27ed1a3555b07b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationOpacity]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationOpacity]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__03d8b591a60020f9c2f4538fc20234ec7324dda34ef61a58b5bcec0c44c4724a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationOpacityOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationOpacityOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__498e791613298289444630f406a742efcf2c4c2b37f8de356125e07fe418b0f1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetOpacityVar")
    def reset_opacity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacityVar", []))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityVarInput")
    def opacity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacity"))

    @opacity.setter
    def opacity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8e26653b7845337b1b58af6c7705526f40d23f8a48c5c23d5a60abc807a338e5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacity", value)

    @builtins.property
    @jsii.member(jsii_name="opacityVar")
    def opacity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacityVar"))

    @opacity_var.setter
    def opacity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5fd3e1ad4ce44cdad52ec5a151e39524b6b0fba1f6f0ce887d7aade0e1ccd69f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacityVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationOpacity]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationOpacity]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationOpacity]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__76330a198c2582a8965b6d6a594aadadf1c98d4b2e1815fc09093532924dd2f7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8e471b78a9c3e7cabe5198ce9a98c4cb5206fc2d27a4943ce4e567a753430cf6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putBackgroundColor")
    def put_background_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9f01a44bc51466362ed3766700bd12da7b6f90e1a5370f95ec2bf9dc1acf09c1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBackgroundColor", [value]))

    @jsii.member(jsii_name="putBlur")
    def put_blur(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationBlur, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__994e34616d3a9515cbada898c2037bdcaa20782418eec5cec9611f4ce3981fe7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBlur", [value]))

    @jsii.member(jsii_name="putChromaKey")
    def put_chroma_key(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationChromaKey, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__225cb0d28eacc536a82369e6bad8b636a69f682f1dc9bf0ca3dab93623323199)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putChromaKey", [value]))

    @jsii.member(jsii_name="putComposite")
    def put_composite(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationComposite, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a76a3bfaf227196dbc9c779242ae45d7a27b73e054741cc5f4625cc6989feba2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putComposite", [value]))

    @jsii.member(jsii_name="putCompound")
    def put_compound(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationCompound, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6bb7e26fe92275a04a1f88e24bb1f9dfeebe9b9101d8ebe6b53f1e6541ea3749)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCompound", [value]))

    @jsii.member(jsii_name="putContrast")
    def put_contrast(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationContrast, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eb129cb8a62c9140e1ca04a736d99cc5654fcb64dabd385df6110ea0dd0ba759)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putContrast", [value]))

    @jsii.member(jsii_name="putGoop")
    def put_goop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationGoop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__15c3fb21bb3c1fe10d34ea71e22d437dd6360e0b7e379d17869277ba68987c0c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGoop", [value]))

    @jsii.member(jsii_name="putGrayscale")
    def put_grayscale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationGrayscale, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__db9f677fc77afa15ca14adc05c08d0551508aef35487a245bb0fb8f53db922c1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGrayscale", [value]))

    @jsii.member(jsii_name="putHsl")
    def put_hsl(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationHsl, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__305ac829ca0b70cc3b4cce9a0802d831dd6d7303b677c4eee755a9e56293c1b5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsl", [value]))

    @jsii.member(jsii_name="putHsv")
    def put_hsv(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationHsv, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea810f60119a57d43b4fed3001614ead5aa86ab00ab7042f0fc1eacc1f5aa0a8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsv", [value]))

    @jsii.member(jsii_name="putIfDimension")
    def put_if_dimension(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfDimension, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__57cfa8a9d0c59471e9f37900b29ee6c58caf1ca71ed1aaad87d8c16060f32629)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfDimension", [value]))

    @jsii.member(jsii_name="putIfOrientation")
    def put_if_orientation(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f527a7cd86d3b6896a35aecff668733b698d7124afbf740e894e98810491ee3c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfOrientation", [value]))

    @jsii.member(jsii_name="putMaxColors")
    def put_max_colors(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationMaxColors, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be832f159b15764f8038e0ca94039be5290e6aade9cb96456d999e14589ea339)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMaxColors", [value]))

    @jsii.member(jsii_name="putMirror")
    def put_mirror(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationMirror, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dfec902a3891eb3ea82ae054808e81451e419fa5d57f1d61332fc6a00aefcece)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMirror", [value]))

    @jsii.member(jsii_name="putMonoHue")
    def put_mono_hue(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationMonoHue, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f8f8a571e78a46852d790da872971eb0e8225ce872d8c22818f71dfd83aa04cf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMonoHue", [value]))

    @jsii.member(jsii_name="putOpacity")
    def put_opacity(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationOpacity, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ef00c1758a80fcb5c5309564245c8c5da19e2025100dab37d22f18f024de8908)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putOpacity", [value]))

    @jsii.member(jsii_name="putRemoveColor")
    def put_remove_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationRemoveColor", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d1d6c7d6980d7bfed2689604fa04eb333be97aedda1ba0b91e6c396ebcd5e4dd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRemoveColor", [value]))

    @jsii.member(jsii_name="putUnsharpMask")
    def put_unsharp_mask(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationUnsharpMask", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6a6a67b89cb4b20788dad1e286f74b1866274321f065f5390061e3f9646aa211)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putUnsharpMask", [value]))

    @jsii.member(jsii_name="resetBackgroundColor")
    def reset_background_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBackgroundColor", []))

    @jsii.member(jsii_name="resetBlur")
    def reset_blur(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBlur", []))

    @jsii.member(jsii_name="resetChromaKey")
    def reset_chroma_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChromaKey", []))

    @jsii.member(jsii_name="resetComposite")
    def reset_composite(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetComposite", []))

    @jsii.member(jsii_name="resetCompound")
    def reset_compound(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCompound", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetGoop")
    def reset_goop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGoop", []))

    @jsii.member(jsii_name="resetGrayscale")
    def reset_grayscale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGrayscale", []))

    @jsii.member(jsii_name="resetHsl")
    def reset_hsl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsl", []))

    @jsii.member(jsii_name="resetHsv")
    def reset_hsv(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsv", []))

    @jsii.member(jsii_name="resetIfDimension")
    def reset_if_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfDimension", []))

    @jsii.member(jsii_name="resetIfOrientation")
    def reset_if_orientation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfOrientation", []))

    @jsii.member(jsii_name="resetMaxColors")
    def reset_max_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxColors", []))

    @jsii.member(jsii_name="resetMirror")
    def reset_mirror(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMirror", []))

    @jsii.member(jsii_name="resetMonoHue")
    def reset_mono_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonoHue", []))

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetRemoveColor")
    def reset_remove_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRemoveColor", []))

    @jsii.member(jsii_name="resetUnsharpMask")
    def reset_unsharp_mask(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUnsharpMask", []))

    @builtins.property
    @jsii.member(jsii_name="backgroundColor")
    def background_color(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationBackgroundColorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationBackgroundColorList, jsii.get(self, "backgroundColor"))

    @builtins.property
    @jsii.member(jsii_name="blur")
    def blur(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationBlurList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationBlurList, jsii.get(self, "blur"))

    @builtins.property
    @jsii.member(jsii_name="chromaKey")
    def chroma_key(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationChromaKeyList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationChromaKeyList, jsii.get(self, "chromaKey"))

    @builtins.property
    @jsii.member(jsii_name="composite")
    def composite(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationCompositeList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationCompositeList, jsii.get(self, "composite"))

    @builtins.property
    @jsii.member(jsii_name="compound")
    def compound(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationCompoundList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationCompoundList, jsii.get(self, "compound"))

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationContrastList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationContrastList, jsii.get(self, "contrast"))

    @builtins.property
    @jsii.member(jsii_name="goop")
    def goop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationGoopList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationGoopList, jsii.get(self, "goop"))

    @builtins.property
    @jsii.member(jsii_name="grayscale")
    def grayscale(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationGrayscaleList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationGrayscaleList, jsii.get(self, "grayscale"))

    @builtins.property
    @jsii.member(jsii_name="hsl")
    def hsl(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationHslList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationHslList, jsii.get(self, "hsl"))

    @builtins.property
    @jsii.member(jsii_name="hsv")
    def hsv(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationHsvList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationHsvList, jsii.get(self, "hsv"))

    @builtins.property
    @jsii.member(jsii_name="ifDimension")
    def if_dimension(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfDimensionList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfDimensionList, jsii.get(self, "ifDimension"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientation")
    def if_orientation(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfOrientationList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfOrientationList, jsii.get(self, "ifOrientation"))

    @builtins.property
    @jsii.member(jsii_name="maxColors")
    def max_colors(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationMaxColorsList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationMaxColorsList, jsii.get(self, "maxColors"))

    @builtins.property
    @jsii.member(jsii_name="mirror")
    def mirror(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationMirrorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationMirrorList, jsii.get(self, "mirror"))

    @builtins.property
    @jsii.member(jsii_name="monoHue")
    def mono_hue(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationMonoHueList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationMonoHueList, jsii.get(self, "monoHue"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationOpacityList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationOpacityList, jsii.get(self, "opacity"))

    @builtins.property
    @jsii.member(jsii_name="removeColor")
    def remove_color(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationRemoveColorList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationRemoveColorList", jsii.get(self, "removeColor"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMask")
    def unsharp_mask(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationUnsharpMaskList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationUnsharpMaskList", jsii.get(self, "unsharpMask"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColorInput")
    def background_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationBackgroundColor]]], jsii.get(self, "backgroundColorInput"))

    @builtins.property
    @jsii.member(jsii_name="blurInput")
    def blur_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationBlur]]], jsii.get(self, "blurInput"))

    @builtins.property
    @jsii.member(jsii_name="chromaKeyInput")
    def chroma_key_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationChromaKey]]], jsii.get(self, "chromaKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="compositeInput")
    def composite_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationComposite]]], jsii.get(self, "compositeInput"))

    @builtins.property
    @jsii.member(jsii_name="compoundInput")
    def compound_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationCompound]]], jsii.get(self, "compoundInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationContrast]]], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="goopInput")
    def goop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationGoop]]], jsii.get(self, "goopInput"))

    @builtins.property
    @jsii.member(jsii_name="grayscaleInput")
    def grayscale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationGrayscale]]], jsii.get(self, "grayscaleInput"))

    @builtins.property
    @jsii.member(jsii_name="hslInput")
    def hsl_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationHsl]]], jsii.get(self, "hslInput"))

    @builtins.property
    @jsii.member(jsii_name="hsvInput")
    def hsv_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationHsv]]], jsii.get(self, "hsvInput"))

    @builtins.property
    @jsii.member(jsii_name="ifDimensionInput")
    def if_dimension_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfDimension]]], jsii.get(self, "ifDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientationInput")
    def if_orientation_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfOrientation]]], jsii.get(self, "ifOrientationInput"))

    @builtins.property
    @jsii.member(jsii_name="maxColorsInput")
    def max_colors_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationMaxColors]]], jsii.get(self, "maxColorsInput"))

    @builtins.property
    @jsii.member(jsii_name="mirrorInput")
    def mirror_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationMirror]]], jsii.get(self, "mirrorInput"))

    @builtins.property
    @jsii.member(jsii_name="monoHueInput")
    def mono_hue_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationMonoHue]]], jsii.get(self, "monoHueInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationOpacity]]], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="removeColorInput")
    def remove_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationRemoveColor"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationRemoveColor"]]], jsii.get(self, "removeColorInput"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMaskInput")
    def unsharp_mask_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationUnsharpMask"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationUnsharpMask"]]], jsii.get(self, "unsharpMaskInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4d9139cd6fb3ecd403e63cfa95bb43f3757cc8d3a82409d4679361dafd8349e3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationRemoveColor",
    jsii_struct_bases=[],
    name_mapping={
        "color": "color",
        "color_var": "colorVar",
        "feather": "feather",
        "feather_var": "featherVar",
        "tolerance": "tolerance",
        "tolerance_var": "toleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationRemoveColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
        feather: typing.Optional[builtins.str] = None,
        feather_var: typing.Optional[builtins.str] = None,
        tolerance: typing.Optional[builtins.str] = None,
        tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        :param feather: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        :param feather_var: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        :param tolerance: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        :param tolerance_var: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__52efef93d0bafcb928e099369568891aeb76c1ab4a1ea2163e5004a526c45dee)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
            check_type(argname="argument feather", value=feather, expected_type=type_hints["feather"])
            check_type(argname="argument feather_var", value=feather_var, expected_type=type_hints["feather_var"])
            check_type(argname="argument tolerance", value=tolerance, expected_type=type_hints["tolerance"])
            check_type(argname="argument tolerance_var", value=tolerance_var, expected_type=type_hints["tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var
        if feather is not None:
            self._values["feather"] = feather
        if feather_var is not None:
            self._values["feather_var"] = feather_var
        if tolerance is not None:
            self._values["tolerance"] = tolerance
        if tolerance_var is not None:
            self._values["tolerance_var"] = tolerance_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        '''
        result = self._values.get("feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather_var(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        '''
        result = self._values.get("feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        '''
        result = self._values.get("tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance_var(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        result = self._values.get("tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationRemoveColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationRemoveColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationRemoveColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a4f924a9370f3498642ba798d96fb04d10249f1a8cea5ce69f9e03dacb621e2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationRemoveColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5a6963192ef58e7a4d5f39af0477a762c190bb4e432e4347764ddaa1e9b5c6ab)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationRemoveColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8611e9ea923f763329ac86b752a84dc677522c420c96464af8aee5865e83b038)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9bb95660df416de7f4d63455983a66dd050b4bf2e99a4439dcc4946ce3a9935d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__81f30b5e6cdff8b061a5c10b8cc2ff883ce8b3d9e7c11ab7dbff1442b0ed163c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationRemoveColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationRemoveColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationRemoveColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ca3c4ee9cb87a71470606a5a711b0807d1e4defac8f8f239146402fe4616cd6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationRemoveColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationRemoveColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__44ec84348fa9321b382991627f2c60f547a0d07015f529880ab020bbe310f9b9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @jsii.member(jsii_name="resetFeather")
    def reset_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeather", []))

    @jsii.member(jsii_name="resetFeatherVar")
    def reset_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatherVar", []))

    @jsii.member(jsii_name="resetTolerance")
    def reset_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTolerance", []))

    @jsii.member(jsii_name="resetToleranceVar")
    def reset_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featherInput")
    def feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherInput"))

    @builtins.property
    @jsii.member(jsii_name="featherVarInput")
    def feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceInput")
    def tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceVarInput")
    def tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__25a9262c210da64a9b81d610e47d51feb79e515f02105ff33c9ec85e8d20daaf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__91f805c3d306a43c56ec4d7d02bfbb22c0fc9f635e49a4daf7a6c1f60457be6d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="feather")
    def feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "feather"))

    @feather.setter
    def feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2bcee6dfc96bce75fe166a20c7b2fc4b5f5b2aa6c4a0311de386d4a081291a40)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "feather", value)

    @builtins.property
    @jsii.member(jsii_name="featherVar")
    def feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featherVar"))

    @feather_var.setter
    def feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e0e77d80357e485be35f1439fe4f6d7dd5722b174c544b27b4bad17552897ea2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featherVar", value)

    @builtins.property
    @jsii.member(jsii_name="tolerance")
    def tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tolerance"))

    @tolerance.setter
    def tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__93dd59b81cca7e29cda6aaf3f0190157d00aafef1b21df0ede4a46db34fb4d61)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tolerance", value)

    @builtins.property
    @jsii.member(jsii_name="toleranceVar")
    def tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "toleranceVar"))

    @tolerance_var.setter
    def tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f674e776b4bfd16378db90e61c5e69e6e5bbe628973f332623f373bc56a671ad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "toleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationRemoveColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationRemoveColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationRemoveColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b1f5a04d454ead0a941ba0c4c84c712f3c25a36e7a78a683176a6e958bb00c5d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationUnsharpMask",
    jsii_struct_bases=[],
    name_mapping={
        "gain": "gain",
        "gain_var": "gainVar",
        "sigma": "sigma",
        "sigma_var": "sigmaVar",
        "threshold": "threshold",
        "threshold_var": "thresholdVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationUnsharpMask:
    def __init__(
        self,
        *,
        gain: typing.Optional[builtins.str] = None,
        gain_var: typing.Optional[builtins.str] = None,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
        threshold: typing.Optional[builtins.str] = None,
        threshold_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param gain: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        :param gain_var: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        :param sigma: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        :param threshold: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        :param threshold_var: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c4f19dae1d999cac3641a12bc78a18a3a721a06fe6e9fdf426f4b518ff5838e3)
            check_type(argname="argument gain", value=gain, expected_type=type_hints["gain"])
            check_type(argname="argument gain_var", value=gain_var, expected_type=type_hints["gain_var"])
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
            check_type(argname="argument threshold", value=threshold, expected_type=type_hints["threshold"])
            check_type(argname="argument threshold_var", value=threshold_var, expected_type=type_hints["threshold_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if gain is not None:
            self._values["gain"] = gain
        if gain_var is not None:
            self._values["gain_var"] = gain_var
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var
        if threshold is not None:
            self._values["threshold"] = threshold
        if threshold_var is not None:
            self._values["threshold_var"] = threshold_var

    @builtins.property
    def gain(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        '''
        result = self._values.get("gain")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gain_var(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        '''
        result = self._values.get("gain_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        '''
        result = self._values.get("threshold")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold_var(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        result = self._values.get("threshold_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationUnsharpMask(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationUnsharpMaskList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationUnsharpMaskList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ad70b83c60212d96311993898b6d6c6c2983b3b82dce76878fb253082facbfa3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationUnsharpMaskOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e8776c21d4fffec63c2b86323a0930a97f24803e0c439d4104647159c38aa2ea)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationUnsharpMaskOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b415a687cd076e114b0a982ddd0d4c8ff14e868bf1e59e5bbd208518c026d214)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6ba0183f35e8c6acefe1272e0394c5afc8816a4870c304482ab8da0d530be09d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9b0b0907cc39e26f2cf0ae46a52bb1884a9181f0e261f8d5ca965bc4e6eec7e7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationUnsharpMask]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationUnsharpMask]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationUnsharpMask]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__436625e16b3b01bf6c975a06a174313780f4d164999b88726ca31fdef32126bc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationUnsharpMaskOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationUnsharpMaskOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ec317d6b101b32818bdb7872f7b05488edb215cc6806f2e414e7227278fdbcfe)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetGain")
    def reset_gain(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGain", []))

    @jsii.member(jsii_name="resetGainVar")
    def reset_gain_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGainVar", []))

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @jsii.member(jsii_name="resetThreshold")
    def reset_threshold(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThreshold", []))

    @jsii.member(jsii_name="resetThresholdVar")
    def reset_threshold_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThresholdVar", []))

    @builtins.property
    @jsii.member(jsii_name="gainInput")
    def gain_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainInput"))

    @builtins.property
    @jsii.member(jsii_name="gainVarInput")
    def gain_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdInput")
    def threshold_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdVarInput")
    def threshold_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gain")
    def gain(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gain"))

    @gain.setter
    def gain(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__80709e80d0a2d1571b7b65f1bdd8df9c2a68fcb12a1cde03cfb81daad7ee1344)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gain", value)

    @builtins.property
    @jsii.member(jsii_name="gainVar")
    def gain_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gainVar"))

    @gain_var.setter
    def gain_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7dd551882eb9dafa5f2515b66faa272e6826fee92c2202047971f3538468e5c7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gainVar", value)

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__220f23ff439048040011270b597fe08571311f8d42bbe579443faba93a166d8d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ff182a1db22c305bf21209d4c90743a22e60d9226efde4fdf5dbccbb4aa12c64)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="threshold")
    def threshold(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "threshold"))

    @threshold.setter
    def threshold(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__77053b189eb47ed5c6052fc952415da255a94bae305b4277d491c9bd7a88986e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "threshold", value)

    @builtins.property
    @jsii.member(jsii_name="thresholdVar")
    def threshold_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "thresholdVar"))

    @threshold_var.setter
    def threshold_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__68026356a8a607d2055e6c1a3bbaab1c33d92e7a8835d44bb96ac3c0e92a531e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "thresholdVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationUnsharpMask]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationUnsharpMask]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationUnsharpMask]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0a7643b219e2ce0e2a79aab901c47e9278f4e256a8b73a6a17c2f424467ea6d7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c1bafc0231d1fb7aec79bf9d38d39faac2cd017f26011d866681fba1ecf30352)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__545241e5c822c7101c451f29b6fded7f77d57c982355ff1e012b018539d0f012)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7758e69eadd2d3dbb3ffd98618684f2468876e920345bd4e8f71c3dbc06e6a7f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d69b827978f19ced5d73d18a13b21b7b4cfbffb44bb5ab0b4a0c5d8d8ed4593f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5c1e6f1765489182ccdc791e9683fa7e86432dd38410e8b69eec2f932e0a6039)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsComposite]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsComposite]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__65d0687df459135bd4f4733e80b66efb8d0158b65d9d606ddb99fff6bfd93352)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a58a89cf3ec0292fad32c99131830b4097894f09a81078ff417eb2bc438f82ba)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(
        self,
        *,
        box_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
        circle_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
        text_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
        url_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param box_image: box_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#box_image DataAkamaiImagingPolicyImage#box_image}
        :param circle_image: circle_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#circle_image DataAkamaiImagingPolicyImage#circle_image}
        :param text_image: text_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text_image DataAkamaiImagingPolicyImage#text_image}
        :param url_image: url_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url_image DataAkamaiImagingPolicyImage#url_image}
        '''
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImage(
            box_image=box_image,
            circle_image=circle_image,
            text_image=text_image,
            url_image=url_image,
        )

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPlacement")
    def reset_placement(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacement", []))

    @jsii.member(jsii_name="resetPlacementVar")
    def reset_placement_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacementVar", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetScaleDimension")
    def reset_scale_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimension", []))

    @jsii.member(jsii_name="resetScaleDimensionVar")
    def reset_scale_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimensionVar", []))

    @jsii.member(jsii_name="resetScaleVar")
    def reset_scale_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="placementInput")
    def placement_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementInput"))

    @builtins.property
    @jsii.member(jsii_name="placementVarInput")
    def placement_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionInput")
    def scale_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVarInput")
    def scale_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleVarInput")
    def scale_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3517d88edc4e1e552b4a24f293f589d3a92056efb4b63139c896f303d782bf03)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c8d1ea888993d0b37235134f9635c75336140189694e7a44808551676b8216b2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="placement")
    def placement(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placement"))

    @placement.setter
    def placement(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__924d3ec12ddfa343b9548221d9c326bdfebf4c21634c5236e31d8075e722ca7a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placement", value)

    @builtins.property
    @jsii.member(jsii_name="placementVar")
    def placement_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placementVar"))

    @placement_var.setter
    def placement_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__59bf97d57c5c05f810b31e3b2d5b0762f39dbfd31ce794fea0af13757c031bc9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placementVar", value)

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scale"))

    @scale.setter
    def scale(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__18cd906868d84cc7fffd9016856a110b63f6b883d41b12b95601ffa1bdd4def7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scale", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimension")
    def scale_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimension"))

    @scale_dimension.setter
    def scale_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4216d135407b2d70cde7698853b0b65236644fc2b266ca73bedb3095bd7ddd6d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimension", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVar")
    def scale_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimensionVar"))

    @scale_dimension_var.setter
    def scale_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0a9913efaaf2744d94a68661b9795b9507bdcbf61f62dca2378411a8d5b0b1bb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="scaleVar")
    def scale_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleVar"))

    @scale_var.setter
    def scale_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4913008fb4c086dc2f2c277259b5d8ca457fc803d267b50965777a35863b6842)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0e3fc7fb84cdc04bff006e534fc4b278049622b6005206b49b396cb05eb68585)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a7c09f791801a64722885de4f8bc85385c2a89e2b0f3e054b4844c87335902dd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__246a9db2664e4009356c28871602ad012cc4d202fc3964cbe3a3021495c307f5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2e75c7779852c86fb709ccbe513e115cd8c0f0ca467b01e7cbcc7633565a79ce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsComposite]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsComposite]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsComposite]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9faee3f765ec3b19d90a4070213da4eddb452158d891325249b7acfaca3656bd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompound",
    jsii_struct_bases=[],
    name_mapping={"transformations": "transformations"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompound:
    def __init__(
        self,
        *,
        transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param transformations: transformations block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a1f63fbcb308b17dfe8adc41d8c651f313f3e082f4fe08f7a2cb2fed9ddeeeb6)
            check_type(argname="argument transformations", value=transformations, expected_type=type_hints["transformations"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if transformations is not None:
            self._values["transformations"] = transformations

    @builtins.property
    def transformations(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformations"]]]:
        '''transformations block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        result = self._values.get("transformations")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformations"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompound(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c43381b92577b2aae4058b532e5642fbfdf32d63dc469dcd5df33043ef8635e1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb7081d96b9a7ed7057581dfb43e66da39f817d269e4dac6aacd1ecffb6ae5e1)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4f3ee31881d4dce9966fac9d77c389d18446aa2df0956d57446165fa16e4160f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a3c3eed571a05bba4f268d43367c0ab4b583a5b66acf0cf76e35cc025c0d8bd3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e11913bee00d5d8ac90f5663885463e3c0f56014048266a5f61236591afec9e2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompound]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompound]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7faa6f6377a0e44ef23eeecef066473fe635c90f3c89a30c06c797406b97da43)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__97a558bf6e7169b2778fa3274266101c849ae4db26081d594560b5dbbfd0a3fb)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformations")
    def put_transformations(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__131eb89f1e3c20fe7dc8f4e0595b4f86f441dcc2043b0fd9880974f3a5ed9bef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTransformations", [value]))

    @jsii.member(jsii_name="resetTransformations")
    def reset_transformations(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformations", []))

    @builtins.property
    @jsii.member(jsii_name="transformations")
    def transformations(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsList", jsii.get(self, "transformations"))

    @builtins.property
    @jsii.member(jsii_name="transformationsInput")
    def transformations_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformations"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformations"]]], jsii.get(self, "transformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompound]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompound]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompound]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0d861660bbeab2b66b583e5f9758123497d6d4a03aafe61b6830b3d08ce7fb91)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformations",
    jsii_struct_bases=[],
    name_mapping={
        "background_color": "backgroundColor",
        "blur": "blur",
        "chroma_key": "chromaKey",
        "composite": "composite",
        "compound": "compound",
        "contrast": "contrast",
        "goop": "goop",
        "grayscale": "grayscale",
        "hsl": "hsl",
        "hsv": "hsv",
        "if_dimension": "ifDimension",
        "if_orientation": "ifOrientation",
        "max_colors": "maxColors",
        "mirror": "mirror",
        "mono_hue": "monoHue",
        "opacity": "opacity",
        "remove_color": "removeColor",
        "unsharp_mask": "unsharpMask",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformations:
    def __init__(
        self,
        *,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsBackgroundColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsBlur", typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsChromaKey", typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsComposite", typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsContrast", typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsGoop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsGrayscale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsHsl", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsHsv", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimension", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientation", typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsMaxColors", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsMirror", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsMonoHue", typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsOpacity", typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsRemoveColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsUnsharpMask", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c951c2a8e44f0f6bb8f6a794aa1df990f8cc9f0445f371bc8ddc8124edcf4164)
            check_type(argname="argument background_color", value=background_color, expected_type=type_hints["background_color"])
            check_type(argname="argument blur", value=blur, expected_type=type_hints["blur"])
            check_type(argname="argument chroma_key", value=chroma_key, expected_type=type_hints["chroma_key"])
            check_type(argname="argument composite", value=composite, expected_type=type_hints["composite"])
            check_type(argname="argument compound", value=compound, expected_type=type_hints["compound"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument goop", value=goop, expected_type=type_hints["goop"])
            check_type(argname="argument grayscale", value=grayscale, expected_type=type_hints["grayscale"])
            check_type(argname="argument hsl", value=hsl, expected_type=type_hints["hsl"])
            check_type(argname="argument hsv", value=hsv, expected_type=type_hints["hsv"])
            check_type(argname="argument if_dimension", value=if_dimension, expected_type=type_hints["if_dimension"])
            check_type(argname="argument if_orientation", value=if_orientation, expected_type=type_hints["if_orientation"])
            check_type(argname="argument max_colors", value=max_colors, expected_type=type_hints["max_colors"])
            check_type(argname="argument mirror", value=mirror, expected_type=type_hints["mirror"])
            check_type(argname="argument mono_hue", value=mono_hue, expected_type=type_hints["mono_hue"])
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument remove_color", value=remove_color, expected_type=type_hints["remove_color"])
            check_type(argname="argument unsharp_mask", value=unsharp_mask, expected_type=type_hints["unsharp_mask"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if background_color is not None:
            self._values["background_color"] = background_color
        if blur is not None:
            self._values["blur"] = blur
        if chroma_key is not None:
            self._values["chroma_key"] = chroma_key
        if composite is not None:
            self._values["composite"] = composite
        if compound is not None:
            self._values["compound"] = compound
        if contrast is not None:
            self._values["contrast"] = contrast
        if goop is not None:
            self._values["goop"] = goop
        if grayscale is not None:
            self._values["grayscale"] = grayscale
        if hsl is not None:
            self._values["hsl"] = hsl
        if hsv is not None:
            self._values["hsv"] = hsv
        if if_dimension is not None:
            self._values["if_dimension"] = if_dimension
        if if_orientation is not None:
            self._values["if_orientation"] = if_orientation
        if max_colors is not None:
            self._values["max_colors"] = max_colors
        if mirror is not None:
            self._values["mirror"] = mirror
        if mono_hue is not None:
            self._values["mono_hue"] = mono_hue
        if opacity is not None:
            self._values["opacity"] = opacity
        if remove_color is not None:
            self._values["remove_color"] = remove_color
        if unsharp_mask is not None:
            self._values["unsharp_mask"] = unsharp_mask

    @builtins.property
    def background_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsBackgroundColor"]]]:
        '''background_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        '''
        result = self._values.get("background_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsBackgroundColor"]]], result)

    @builtins.property
    def blur(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsBlur"]]]:
        '''blur block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        '''
        result = self._values.get("blur")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsBlur"]]], result)

    @builtins.property
    def chroma_key(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsChromaKey"]]]:
        '''chroma_key block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        '''
        result = self._values.get("chroma_key")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsChromaKey"]]], result)

    @builtins.property
    def composite(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsComposite"]]]:
        '''composite block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        '''
        result = self._values.get("composite")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsComposite"]]], result)

    @builtins.property
    def compound(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompound]]]:
        '''compound block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        '''
        result = self._values.get("compound")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompound]]], result)

    @builtins.property
    def contrast(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsContrast"]]]:
        '''contrast block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsContrast"]]], result)

    @builtins.property
    def goop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsGoop"]]]:
        '''goop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        '''
        result = self._values.get("goop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsGoop"]]], result)

    @builtins.property
    def grayscale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsGrayscale"]]]:
        '''grayscale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        '''
        result = self._values.get("grayscale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsGrayscale"]]], result)

    @builtins.property
    def hsl(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsHsl"]]]:
        '''hsl block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        '''
        result = self._values.get("hsl")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsHsl"]]], result)

    @builtins.property
    def hsv(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsHsv"]]]:
        '''hsv block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        '''
        result = self._values.get("hsv")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsHsv"]]], result)

    @builtins.property
    def if_dimension(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimension"]]]:
        '''if_dimension block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        '''
        result = self._values.get("if_dimension")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimension"]]], result)

    @builtins.property
    def if_orientation(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientation"]]]:
        '''if_orientation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        '''
        result = self._values.get("if_orientation")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientation"]]], result)

    @builtins.property
    def max_colors(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsMaxColors"]]]:
        '''max_colors block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        '''
        result = self._values.get("max_colors")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsMaxColors"]]], result)

    @builtins.property
    def mirror(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsMirror"]]]:
        '''mirror block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        '''
        result = self._values.get("mirror")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsMirror"]]], result)

    @builtins.property
    def mono_hue(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsMonoHue"]]]:
        '''mono_hue block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        '''
        result = self._values.get("mono_hue")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsMonoHue"]]], result)

    @builtins.property
    def opacity(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsOpacity"]]]:
        '''opacity block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsOpacity"]]], result)

    @builtins.property
    def remove_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsRemoveColor"]]]:
        '''remove_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        '''
        result = self._values.get("remove_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsRemoveColor"]]], result)

    @builtins.property
    def unsharp_mask(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsUnsharpMask"]]]:
        '''unsharp_mask block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        result = self._values.get("unsharp_mask")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsUnsharpMask"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformations(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsBackgroundColor",
    jsii_struct_bases=[],
    name_mapping={"color": "color", "color_var": "colorVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsBackgroundColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__42497e51b6217f290465ba3f97aa7739503c1e70c0190cba2564e07e348f32c2)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsBackgroundColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsBackgroundColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsBackgroundColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1a6800ed89e1a280b1c7eb30d46b871087714c779f2b1ca7240f5964128e3947)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsBackgroundColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d3c598838f50e94581d3124c1092e168cf72176bfcc890ada2b04fbea0f2371)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsBackgroundColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fdfa506e6170fbdf717f32904a26441262aeb74f3a8ff84ed3725e84add9ea70)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fcaf500dbe1d036c75c01b298b57430b6820adc45a52950e10af77ff4fc29450)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__49527e39599077cc610f76b178e90cc6f0df3c60007af4175575fe6d0ddd1fd1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsBackgroundColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsBackgroundColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ff9edf1b4807177f5b6dcc3b91fe7f4bbb2f441924fa9505624acf5083b22257)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsBackgroundColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsBackgroundColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__71305ce1ff0ebdf8dab654afd26da386375a81e57e38378635b80825bdfd4bbd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__679b75c6339075fc47b2f1972dc7a3dfe3478ab29900fa79d57d946b484287a9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__09ac87cdd05b2b1307f94640d378edc1cdc1fb91fd886fed67c08225d845fa7b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsBackgroundColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsBackgroundColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsBackgroundColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7b97af21294394941a713ea4967fa74e47d68f6abf53c2779e396b7bc329674f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsBlur",
    jsii_struct_bases=[],
    name_mapping={"sigma": "sigma", "sigma_var": "sigmaVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsBlur:
    def __init__(
        self,
        *,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param sigma: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6562c7f0f32954bc047ac1c48b71c156d6f7179ee95b75e7cf0bc965eb04c503)
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsBlur(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsBlurList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsBlurList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__98e8e683f4ace09eb5b71ee38b45cd2697ce3e7ee59cada057bf4ad18695b1e9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsBlurOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__25de19294783acc4484f2dc31cbd743ea9d7dfe117c8c0d23330c259f4dc4bb4)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsBlurOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__697ba33497b016394b269a059b6401ee9ddecf14bdc3d1810e6687df0e764d5b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d6f3c9fc9d3e12e54ced661038682d25a492c95b7adcaeb1487bc1e83f5b9b3a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f3262a5e90d8181bd64a24552ecd678ca2e0a3d7ec8e1f90caba8341c341615f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsBlur]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsBlur]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__844be7430c0bf73d49031d7fabf9c93efa4b8a60128970396fb9baa2e881cb5f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsBlurOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsBlurOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__224fed1ea1c01c20334a0f766970feca9445e2fe13396be6c0b35c7e7ce281d6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0c28271968495080348266dbc22feafe7fc087e91e9b66d917981591d40733df)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__38ea4c76e7a5ef5f2ffda645f8eefdc29c9c41a6e82c7c9c1aa383fc8fdd1ff3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsBlur]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsBlur]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsBlur]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ca801cdc1d916eb54f87d66164cb66e5378642e59bef840e05fef571c3e78853)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsChromaKey",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_feather": "hueFeather",
        "hue_feather_var": "hueFeatherVar",
        "hue_tolerance": "hueTolerance",
        "hue_tolerance_var": "hueToleranceVar",
        "hue_var": "hueVar",
        "lightness_feather": "lightnessFeather",
        "lightness_feather_var": "lightnessFeatherVar",
        "lightness_tolerance": "lightnessTolerance",
        "lightness_tolerance_var": "lightnessToleranceVar",
        "saturation_feather": "saturationFeather",
        "saturation_feather_var": "saturationFeatherVar",
        "saturation_tolerance": "saturationTolerance",
        "saturation_tolerance_var": "saturationToleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsChromaKey:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_feather: typing.Optional[builtins.str] = None,
        hue_feather_var: typing.Optional[builtins.str] = None,
        hue_tolerance: typing.Optional[builtins.str] = None,
        hue_tolerance_var: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness_feather: typing.Optional[builtins.str] = None,
        lightness_feather_var: typing.Optional[builtins.str] = None,
        lightness_tolerance: typing.Optional[builtins.str] = None,
        lightness_tolerance_var: typing.Optional[builtins.str] = None,
        saturation_feather: typing.Optional[builtins.str] = None,
        saturation_feather_var: typing.Optional[builtins.str] = None,
        saturation_tolerance: typing.Optional[builtins.str] = None,
        saturation_tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_feather: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        :param hue_feather_var: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        :param hue_tolerance: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        :param hue_tolerance_var: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        :param hue_var: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness_feather: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        :param lightness_feather_var: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        :param lightness_tolerance: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        :param lightness_tolerance_var: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        :param saturation_feather: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        :param saturation_feather_var: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        :param saturation_tolerance: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        :param saturation_tolerance_var: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__efbaf35fb0036d27d9058e253d11fe11467b8b47479324a4835c1bc0583a29bb)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_feather", value=hue_feather, expected_type=type_hints["hue_feather"])
            check_type(argname="argument hue_feather_var", value=hue_feather_var, expected_type=type_hints["hue_feather_var"])
            check_type(argname="argument hue_tolerance", value=hue_tolerance, expected_type=type_hints["hue_tolerance"])
            check_type(argname="argument hue_tolerance_var", value=hue_tolerance_var, expected_type=type_hints["hue_tolerance_var"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness_feather", value=lightness_feather, expected_type=type_hints["lightness_feather"])
            check_type(argname="argument lightness_feather_var", value=lightness_feather_var, expected_type=type_hints["lightness_feather_var"])
            check_type(argname="argument lightness_tolerance", value=lightness_tolerance, expected_type=type_hints["lightness_tolerance"])
            check_type(argname="argument lightness_tolerance_var", value=lightness_tolerance_var, expected_type=type_hints["lightness_tolerance_var"])
            check_type(argname="argument saturation_feather", value=saturation_feather, expected_type=type_hints["saturation_feather"])
            check_type(argname="argument saturation_feather_var", value=saturation_feather_var, expected_type=type_hints["saturation_feather_var"])
            check_type(argname="argument saturation_tolerance", value=saturation_tolerance, expected_type=type_hints["saturation_tolerance"])
            check_type(argname="argument saturation_tolerance_var", value=saturation_tolerance_var, expected_type=type_hints["saturation_tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_feather is not None:
            self._values["hue_feather"] = hue_feather
        if hue_feather_var is not None:
            self._values["hue_feather_var"] = hue_feather_var
        if hue_tolerance is not None:
            self._values["hue_tolerance"] = hue_tolerance
        if hue_tolerance_var is not None:
            self._values["hue_tolerance_var"] = hue_tolerance_var
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness_feather is not None:
            self._values["lightness_feather"] = lightness_feather
        if lightness_feather_var is not None:
            self._values["lightness_feather_var"] = lightness_feather_var
        if lightness_tolerance is not None:
            self._values["lightness_tolerance"] = lightness_tolerance
        if lightness_tolerance_var is not None:
            self._values["lightness_tolerance_var"] = lightness_tolerance_var
        if saturation_feather is not None:
            self._values["saturation_feather"] = saturation_feather
        if saturation_feather_var is not None:
            self._values["saturation_feather_var"] = saturation_feather_var
        if saturation_tolerance is not None:
            self._values["saturation_tolerance"] = saturation_tolerance
        if saturation_tolerance_var is not None:
            self._values["saturation_tolerance_var"] = saturation_tolerance_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        '''
        result = self._values.get("hue_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        '''
        result = self._values.get("hue_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        '''
        result = self._values.get("hue_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        '''
        result = self._values.get("hue_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        '''
        result = self._values.get("lightness_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        '''
        result = self._values.get("lightness_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        '''
        result = self._values.get("lightness_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        '''
        result = self._values.get("lightness_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        '''
        result = self._values.get("saturation_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        '''
        result = self._values.get("saturation_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        '''
        result = self._values.get("saturation_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        result = self._values.get("saturation_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsChromaKey(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsChromaKeyList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsChromaKeyList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__963ae9b2c1877e66c62f92b3bcd83c42c0fb2c498936e62c12f69b38ce21db46)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsChromaKeyOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__17bb734eac2453847445152a45bb5e27506d7dfe3e1a45f15252b2ff92651de0)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsChromaKeyOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3f61d55b96ada200716d3d481f49583fba0aae9f82b2ae068ce161ff00f85fac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__56d58058cf8bf62100a2dc598799065ddb644487a682d9f89253cf4e701d127d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5de1cc654cb40ced373fc8ca891b6ac4749475311df4f70925fa19da1fd0d4c6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsChromaKey]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsChromaKey]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9024314d955c2cca61f3fef658274d8c277531a65f88bf39de5d67c539d18c61)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsChromaKeyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsChromaKeyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__681b14a4fc3c3b0cc17d553044701d12d67ea1dee95c78cfc5120aacefb86435)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueFeather")
    def reset_hue_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeather", []))

    @jsii.member(jsii_name="resetHueFeatherVar")
    def reset_hue_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeatherVar", []))

    @jsii.member(jsii_name="resetHueTolerance")
    def reset_hue_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueTolerance", []))

    @jsii.member(jsii_name="resetHueToleranceVar")
    def reset_hue_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueToleranceVar", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightnessFeather")
    def reset_lightness_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeather", []))

    @jsii.member(jsii_name="resetLightnessFeatherVar")
    def reset_lightness_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeatherVar", []))

    @jsii.member(jsii_name="resetLightnessTolerance")
    def reset_lightness_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessTolerance", []))

    @jsii.member(jsii_name="resetLightnessToleranceVar")
    def reset_lightness_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessToleranceVar", []))

    @jsii.member(jsii_name="resetSaturationFeather")
    def reset_saturation_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeather", []))

    @jsii.member(jsii_name="resetSaturationFeatherVar")
    def reset_saturation_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeatherVar", []))

    @jsii.member(jsii_name="resetSaturationTolerance")
    def reset_saturation_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationTolerance", []))

    @jsii.member(jsii_name="resetSaturationToleranceVar")
    def reset_saturation_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherInput")
    def hue_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVarInput")
    def hue_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceInput")
    def hue_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVarInput")
    def hue_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherInput")
    def lightness_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVarInput")
    def lightness_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceInput")
    def lightness_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVarInput")
    def lightness_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherInput")
    def saturation_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVarInput")
    def saturation_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceInput")
    def saturation_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVarInput")
    def saturation_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8bebe3ff53462afd0c07666d8f0c064f2a03dcb89dcfa6347dcab81ed71b01f5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeather")
    def hue_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeather"))

    @hue_feather.setter
    def hue_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e7d3bae4eb64af8511c890a5e0d716342857ee2e01269849f5d7c97bebf4e6d6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeather", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVar")
    def hue_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeatherVar"))

    @hue_feather_var.setter
    def hue_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a0460fbf6ab9237f3d0a19fc778802aab5f9d50f2a9ec30ab38f9a44cb622e08)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueTolerance")
    def hue_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueTolerance"))

    @hue_tolerance.setter
    def hue_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ec4fb600f404ab62be3e316e5d58f7390ab27d6cc370a720c10959307ee3e84)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVar")
    def hue_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueToleranceVar"))

    @hue_tolerance_var.setter
    def hue_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d451f19c920d44d2215fa2d01c0b96d6cb13d30f58113e2423d8098c31df3c58)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f448dab2a240d8cb27531738c190f5ddf373758c5c222ec04ef4fbb93eb4a64d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeather")
    def lightness_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeather"))

    @lightness_feather.setter
    def lightness_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fd266c1a89b7cbdda4eb73bf3ba4061b5c8f9dfb17b6223f0ede76d4a02765b2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeather", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVar")
    def lightness_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeatherVar"))

    @lightness_feather_var.setter
    def lightness_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9dcba3c690708ed9207c1dca26fd3a8373f1e7fc7bbe6f435143772c1e30509e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessTolerance")
    def lightness_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessTolerance"))

    @lightness_tolerance.setter
    def lightness_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__141800fec5410a22a9a5554e20d22d221d0891a980e616d6be0cc84d6e99a64c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVar")
    def lightness_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessToleranceVar"))

    @lightness_tolerance_var.setter
    def lightness_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__787777dcabf8db7b9fda0e57f0f5c6cf00925430ecc9b370318674d7e2728092)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeather")
    def saturation_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeather"))

    @saturation_feather.setter
    def saturation_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f74c103ccd9fe3c485a6b67b4ce686b07e812cdad709e35aeae93f62af04cf72)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeather", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVar")
    def saturation_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeatherVar"))

    @saturation_feather_var.setter
    def saturation_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__256289fbdd031f79729d15c1f7cd266eb540816ad13403d2b955463e94290e65)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationTolerance")
    def saturation_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationTolerance"))

    @saturation_tolerance.setter
    def saturation_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8d0a292b506e4df0853ac4bd36944f58b5bab7f4702f43bb01f90e45f295dda9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVar")
    def saturation_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationToleranceVar"))

    @saturation_tolerance_var.setter
    def saturation_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8cae80b2c5f9cb190d81de7e0392f3a654d3990d31768554b191a4cf46f8bd44)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsChromaKey]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsChromaKey]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsChromaKey]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a0386b2334f7b80e1f5d379a9015402307e5e1fcbd3597011fa2e135cb22666)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsComposite",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "placement": "placement",
        "placement_var": "placementVar",
        "scale": "scale",
        "scale_dimension": "scaleDimension",
        "scale_dimension_var": "scaleDimensionVar",
        "scale_var": "scaleVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsComposite:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        placement: typing.Optional[builtins.str] = None,
        placement_var: typing.Optional[builtins.str] = None,
        scale: typing.Optional[builtins.str] = None,
        scale_dimension: typing.Optional[builtins.str] = None,
        scale_dimension_var: typing.Optional[builtins.str] = None,
        scale_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param placement: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        :param placement_var: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        :param scale: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param scale_dimension: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        :param scale_dimension_var: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        :param scale_var: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        :param x_position: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cbd387dfabefe60783d2e7d2fe38ad3aef86de7fe702790e60cb84e7476ff4b3)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument placement", value=placement, expected_type=type_hints["placement"])
            check_type(argname="argument placement_var", value=placement_var, expected_type=type_hints["placement_var"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument scale_dimension", value=scale_dimension, expected_type=type_hints["scale_dimension"])
            check_type(argname="argument scale_dimension_var", value=scale_dimension_var, expected_type=type_hints["scale_dimension_var"])
            check_type(argname="argument scale_var", value=scale_var, expected_type=type_hints["scale_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if placement is not None:
            self._values["placement"] = placement
        if placement_var is not None:
            self._values["placement_var"] = placement_var
        if scale is not None:
            self._values["scale"] = scale
        if scale_dimension is not None:
            self._values["scale_dimension"] = scale_dimension
        if scale_dimension_var is not None:
            self._values["scale_dimension_var"] = scale_dimension_var
        if scale_var is not None:
            self._values["scale_var"] = scale_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        '''
        result = self._values.get("placement")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement_var(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        '''
        result = self._values.get("placement_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        '''
        result = self._values.get("scale_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        '''
        result = self._values.get("scale_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        '''
        result = self._values.get("scale_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsComposite(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImage",
    jsii_struct_bases=[],
    name_mapping={
        "box_image": "boxImage",
        "circle_image": "circleImage",
        "text_image": "textImage",
        "url_image": "urlImage",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImage:
    def __init__(
        self,
        *,
        box_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageBoxImage", typing.Dict[builtins.str, typing.Any]]]]] = None,
        circle_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageCircleImage", typing.Dict[builtins.str, typing.Any]]]]] = None,
        text_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageTextImage", typing.Dict[builtins.str, typing.Any]]]]] = None,
        url_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageUrlImage", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param box_image: box_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#box_image DataAkamaiImagingPolicyImage#box_image}
        :param circle_image: circle_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#circle_image DataAkamaiImagingPolicyImage#circle_image}
        :param text_image: text_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text_image DataAkamaiImagingPolicyImage#text_image}
        :param url_image: url_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url_image DataAkamaiImagingPolicyImage#url_image}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2b5ae45ac022af1eb5008f120750c2796dafdd87157c09859113982967f2f2c9)
            check_type(argname="argument box_image", value=box_image, expected_type=type_hints["box_image"])
            check_type(argname="argument circle_image", value=circle_image, expected_type=type_hints["circle_image"])
            check_type(argname="argument text_image", value=text_image, expected_type=type_hints["text_image"])
            check_type(argname="argument url_image", value=url_image, expected_type=type_hints["url_image"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if box_image is not None:
            self._values["box_image"] = box_image
        if circle_image is not None:
            self._values["circle_image"] = circle_image
        if text_image is not None:
            self._values["text_image"] = text_image
        if url_image is not None:
            self._values["url_image"] = url_image

    @builtins.property
    def box_image(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageBoxImage"]]]:
        '''box_image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#box_image DataAkamaiImagingPolicyImage#box_image}
        '''
        result = self._values.get("box_image")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageBoxImage"]]], result)

    @builtins.property
    def circle_image(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageCircleImage"]]]:
        '''circle_image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#circle_image DataAkamaiImagingPolicyImage#circle_image}
        '''
        result = self._values.get("circle_image")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageCircleImage"]]], result)

    @builtins.property
    def text_image(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageTextImage"]]]:
        '''text_image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text_image DataAkamaiImagingPolicyImage#text_image}
        '''
        result = self._values.get("text_image")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageTextImage"]]], result)

    @builtins.property
    def url_image(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageUrlImage"]]]:
        '''url_image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url_image DataAkamaiImagingPolicyImage#url_image}
        '''
        result = self._values.get("url_image")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageUrlImage"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageBoxImage",
    jsii_struct_bases=[],
    name_mapping={
        "color": "color",
        "color_var": "colorVar",
        "height": "height",
        "height_var": "heightVar",
        "transformation": "transformation",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageBoxImage:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        transformation: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageBoxImageTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The fill color of the box, not the edge of the box. The API supports hexadecimal representation and CSS hexadecimal color values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The fill color of the box, not the edge of the box. The API supports hexadecimal representation and CSS hexadecimal color values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        :param height: The height of the box in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height of the box in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param transformation: transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        :param width: The width of the box in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width of the box in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(transformation, dict):
            transformation = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageBoxImageTransformation(**transformation)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__adc1a8cda138857c4bb1155d6208e3180dcbdd8babca1885ce5efd79e1658976)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument transformation", value=transformation, expected_type=type_hints["transformation"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if transformation is not None:
            self._values["transformation"] = transformation
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The fill color of the box, not the edge of the box.

        The API supports hexadecimal representation and CSS hexadecimal color values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The fill color of the box, not the edge of the box.

        The API supports hexadecimal representation and CSS hexadecimal color values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height of the box in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height of the box in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def transformation(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageBoxImageTransformation"]:
        '''transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        '''
        result = self._values.get("transformation")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageBoxImageTransformation"], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width of the box in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width of the box in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageBoxImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageBoxImageList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageBoxImageList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__167e127a4081097c66d8b3fa4f5f09918294837c876120b6574dde7a9e10219d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageBoxImageOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2e773cdb652ea350964a4aff0221b529131f268992b4a95662c0e1da2f4afd1d)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageBoxImageOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4eac6f7c280ff9992b5abed3429ab4c465f718b3648b7eec9d8fb3c2b27fa361)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__271256439dd46784d5ede7ea09936a30232a19ec8faec665a0b30c24f1b559a4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2b56810540212e29d2f4dfdf4f883dc69d8789cf0f6a2734c03cea4cdd800f12)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageBoxImage]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageBoxImage]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageBoxImage]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c3ef3c5ebbd4b7f8c756d6df95662b53e717ecb44e942932dde02379964c867e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageBoxImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageBoxImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__24f2dd6607f4db527b0b12f41c8f9f444673acbdb51bcab8b1ebf45ecd179106)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformation")
    def put_transformation(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageBoxImageTransformation()

        return typing.cast(None, jsii.invoke(self, "putTransformation", [value]))

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetTransformation")
    def reset_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformation", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="transformation")
    def transformation(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageBoxImageTransformationOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageBoxImageTransformationOutputReference", jsii.get(self, "transformation"))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="transformationInput")
    def transformation_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageBoxImageTransformation"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageBoxImageTransformation"], jsii.get(self, "transformationInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ac536b6c8ed9f88feeed2daeb330cb321b1645b5eb9e8538dcc548b5a4a306b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__25ae43f79f5c42205cb2d6bb2f9689216b64c8c09412f507fe9985b9bffb51c9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a283112023befee96be1387767a66d6c0b28927c75c59cade7e4723eef6ab8e4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__30851a7fd164b369a9eee8b86eda189ac8da4f0c1a3377951d5b054c6cdb0a67)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea91117149b6b4bd1e274ee89e5936195f69106e9439ba4a4f8bcdf3abdc2f58)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__145b76766801e398f7e809e7d75d4f48b99b658387fcec4ab41ef7ebfd8ce808)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageBoxImage]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageBoxImage]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageBoxImage]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__71f2b92ac6cafcdc71dd918257aa7f3cbfe1aa499f5ea8db8b783198f45fdd37)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageBoxImageTransformation",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageBoxImageTransformation:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageBoxImageTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageBoxImageTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageBoxImageTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f99b0e1b97f48fc58ab4ad0a5015d2d07b45d93cea7208f2523650c9f3f8d3dd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageBoxImageTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageBoxImageTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageBoxImageTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7c620b70fff52170bbd06c82433de6d5c48d7ade10cce7301158edf4f50220fb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageCircleImage",
    jsii_struct_bases=[],
    name_mapping={
        "color": "color",
        "color_var": "colorVar",
        "diameter": "diameter",
        "diameter_var": "diameterVar",
        "transformation": "transformation",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageCircleImage:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
        diameter: typing.Optional[builtins.str] = None,
        diameter_var: typing.Optional[builtins.str] = None,
        transformation: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageCircleImageTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The fill color of the circle. The API supports hexadecimal representation and CSS hexadecimal color values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The fill color of the circle. The API supports hexadecimal representation and CSS hexadecimal color values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        :param diameter: The diameter of the circle. The diameter will be the width and the height of the image in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#diameter DataAkamaiImagingPolicyImage#diameter}
        :param diameter_var: The diameter of the circle. The diameter will be the width and the height of the image in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#diameter_var DataAkamaiImagingPolicyImage#diameter_var}
        :param transformation: transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        :param width: The width of the box in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width of the box in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(transformation, dict):
            transformation = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageCircleImageTransformation(**transformation)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c20ee8e3de861a2ed1a7cf370b45883a9d5b6050a5d696bc22520658d4c9949a)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
            check_type(argname="argument diameter", value=diameter, expected_type=type_hints["diameter"])
            check_type(argname="argument diameter_var", value=diameter_var, expected_type=type_hints["diameter_var"])
            check_type(argname="argument transformation", value=transformation, expected_type=type_hints["transformation"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var
        if diameter is not None:
            self._values["diameter"] = diameter
        if diameter_var is not None:
            self._values["diameter_var"] = diameter_var
        if transformation is not None:
            self._values["transformation"] = transformation
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The fill color of the circle. The API supports hexadecimal representation and CSS hexadecimal color values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The fill color of the circle. The API supports hexadecimal representation and CSS hexadecimal color values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def diameter(self) -> typing.Optional[builtins.str]:
        '''The diameter of the circle. The diameter will be the width and the height of the image in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#diameter DataAkamaiImagingPolicyImage#diameter}
        '''
        result = self._values.get("diameter")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def diameter_var(self) -> typing.Optional[builtins.str]:
        '''The diameter of the circle. The diameter will be the width and the height of the image in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#diameter_var DataAkamaiImagingPolicyImage#diameter_var}
        '''
        result = self._values.get("diameter_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def transformation(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageCircleImageTransformation"]:
        '''transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        '''
        result = self._values.get("transformation")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageCircleImageTransformation"], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width of the box in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width of the box in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageCircleImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageCircleImageList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageCircleImageList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4015aaa6301598577b9aa1e1a2469d2a32b13ce3a6aad9853043289e9b27f295)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageCircleImageOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ce3e583e885e1484f6f1b1e26a95c1cd06136e2eecae299793012bcdd54153ff)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageCircleImageOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__03af6f51cadee0efc6e3adf0c3f3f661fe6114f9b7808f8748849e76d827cb23)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__23f4b9cbe7d1376d483005cbbc2d1c796d255e64eec3c67b43e1ba3d983ccaf9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a84e48a16c65d85e9c3748a613c2b2055704a36dc28de9351f708f682b892de3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageCircleImage]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageCircleImage]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageCircleImage]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__506b53b6ba424e2f1a056407fa6fdd9d130f8fa07e5b87cd889fb768fff04f60)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageCircleImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageCircleImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ca8044939842497e19ebda7a5b1dc70153ea7b93749c9f7e3d9a71cf075326c8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformation")
    def put_transformation(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageCircleImageTransformation()

        return typing.cast(None, jsii.invoke(self, "putTransformation", [value]))

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @jsii.member(jsii_name="resetDiameter")
    def reset_diameter(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDiameter", []))

    @jsii.member(jsii_name="resetDiameterVar")
    def reset_diameter_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDiameterVar", []))

    @jsii.member(jsii_name="resetTransformation")
    def reset_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformation", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="transformation")
    def transformation(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageCircleImageTransformationOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageCircleImageTransformationOutputReference", jsii.get(self, "transformation"))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="diameterInput")
    def diameter_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "diameterInput"))

    @builtins.property
    @jsii.member(jsii_name="diameterVarInput")
    def diameter_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "diameterVarInput"))

    @builtins.property
    @jsii.member(jsii_name="transformationInput")
    def transformation_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageCircleImageTransformation"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageCircleImageTransformation"], jsii.get(self, "transformationInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__12dda14f0b010b7f1c38ca049a01271cbc1cd38aa07b825647aea0844e26b433)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__82998d78e25d025015f51489ed051b03c2778eaf03b96b9d4a7de66c08d80983)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="diameter")
    def diameter(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "diameter"))

    @diameter.setter
    def diameter(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a99fc73a52cc8547a4b3c88eaadc11937f72415c8584fa3485e435435e8713b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "diameter", value)

    @builtins.property
    @jsii.member(jsii_name="diameterVar")
    def diameter_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "diameterVar"))

    @diameter_var.setter
    def diameter_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be8817af6b9147ac6ac3386d953562d115717d885356451284e55efb8ecb7c97)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "diameterVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6a5dd98020752f60abc0b10d1eb1a5dde484abb77c0e883a447173c4bee5e199)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b5658cb9bbca8953780d9f3990defb8db3abcc96829076566e53c3797670ae50)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageCircleImage]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageCircleImage]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageCircleImage]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__79b2fbd42568ff70af58f2c1e1a0ff9cbdb9d4454f8a40415f51722582820f69)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageCircleImageTransformation",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageCircleImageTransformation:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageCircleImageTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageCircleImageTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageCircleImageTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6ae5ac9b562b840d95c2b6dfb13944d21f36ff4bcb7736ceca2bf31a0a2e63aa)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageCircleImageTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageCircleImageTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageCircleImageTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__80ac33568d191a5c75af7d5870e38351cf3a0877d0050078f5ecddf0742281c2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__adfcd5e0a15191723a1c21355b88b445e68e4e0df175caf5687babb82ddf8542)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putBoxImage")
    def put_box_image(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageBoxImage, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e4cc57292833a5859698b4572cd1ee3630b857301610fc27171dd387875513ba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBoxImage", [value]))

    @jsii.member(jsii_name="putCircleImage")
    def put_circle_image(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageCircleImage, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1eda4f46b81b725ac925ed769a3549fc71bbb7b7fa9d450428b4dc810f4bc01a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCircleImage", [value]))

    @jsii.member(jsii_name="putTextImage")
    def put_text_image(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageTextImage", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__750fe57f73b93aacb7146176ba867f0debaccfb22a78c1b5a35499a451521747)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTextImage", [value]))

    @jsii.member(jsii_name="putUrlImage")
    def put_url_image(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageUrlImage", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__83325459a02027517eb261bbce7d1c39444f8ea7e4911046014fe8843e8771e0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putUrlImage", [value]))

    @jsii.member(jsii_name="resetBoxImage")
    def reset_box_image(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBoxImage", []))

    @jsii.member(jsii_name="resetCircleImage")
    def reset_circle_image(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCircleImage", []))

    @jsii.member(jsii_name="resetTextImage")
    def reset_text_image(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTextImage", []))

    @jsii.member(jsii_name="resetUrlImage")
    def reset_url_image(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUrlImage", []))

    @builtins.property
    @jsii.member(jsii_name="boxImage")
    def box_image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageBoxImageList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageBoxImageList, jsii.get(self, "boxImage"))

    @builtins.property
    @jsii.member(jsii_name="circleImage")
    def circle_image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageCircleImageList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageCircleImageList, jsii.get(self, "circleImage"))

    @builtins.property
    @jsii.member(jsii_name="textImage")
    def text_image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageTextImageList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageTextImageList", jsii.get(self, "textImage"))

    @builtins.property
    @jsii.member(jsii_name="urlImage")
    def url_image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageUrlImageList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageUrlImageList", jsii.get(self, "urlImage"))

    @builtins.property
    @jsii.member(jsii_name="boxImageInput")
    def box_image_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageBoxImage]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageBoxImage]]], jsii.get(self, "boxImageInput"))

    @builtins.property
    @jsii.member(jsii_name="circleImageInput")
    def circle_image_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageCircleImage]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageCircleImage]]], jsii.get(self, "circleImageInput"))

    @builtins.property
    @jsii.member(jsii_name="textImageInput")
    def text_image_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageTextImage"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageTextImage"]]], jsii.get(self, "textImageInput"))

    @builtins.property
    @jsii.member(jsii_name="urlImageInput")
    def url_image_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageUrlImage"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageUrlImage"]]], jsii.get(self, "urlImageInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3219be2a960590f05bdf8b38904407b53295f2a8cdb401599ec7b5274b787fa1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageTextImage",
    jsii_struct_bases=[],
    name_mapping={
        "fill": "fill",
        "fill_var": "fillVar",
        "size": "size",
        "size_var": "sizeVar",
        "stroke": "stroke",
        "stroke_size": "strokeSize",
        "stroke_size_var": "strokeSizeVar",
        "stroke_var": "strokeVar",
        "text": "text",
        "text_var": "textVar",
        "transformation": "transformation",
        "typeface": "typeface",
        "typeface_var": "typefaceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageTextImage:
    def __init__(
        self,
        *,
        fill: typing.Optional[builtins.str] = None,
        fill_var: typing.Optional[builtins.str] = None,
        size: typing.Optional[builtins.str] = None,
        size_var: typing.Optional[builtins.str] = None,
        stroke: typing.Optional[builtins.str] = None,
        stroke_size: typing.Optional[builtins.str] = None,
        stroke_size_var: typing.Optional[builtins.str] = None,
        stroke_var: typing.Optional[builtins.str] = None,
        text: typing.Optional[builtins.str] = None,
        text_var: typing.Optional[builtins.str] = None,
        transformation: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageTextImageTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        typeface: typing.Optional[builtins.str] = None,
        typeface_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fill: The main fill color of the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill DataAkamaiImagingPolicyImage#fill}
        :param fill_var: The main fill color of the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_var DataAkamaiImagingPolicyImage#fill_var}
        :param size: The size in pixels to render the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#size DataAkamaiImagingPolicyImage#size}
        :param size_var: The size in pixels to render the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#size_var DataAkamaiImagingPolicyImage#size_var}
        :param stroke: The color for the outline of the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke DataAkamaiImagingPolicyImage#stroke}
        :param stroke_size: The thickness in points for the outline of the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_size DataAkamaiImagingPolicyImage#stroke_size}
        :param stroke_size_var: The thickness in points for the outline of the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_size_var DataAkamaiImagingPolicyImage#stroke_size_var}
        :param stroke_var: The color for the outline of the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_var DataAkamaiImagingPolicyImage#stroke_var}
        :param text: The line of text to render. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text DataAkamaiImagingPolicyImage#text}
        :param text_var: The line of text to render. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text_var DataAkamaiImagingPolicyImage#text_var}
        :param transformation: transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        :param typeface: The font family to apply to the text image. This may be a URL to a TrueType or WOFF (v1) typeface, or a string that refers to one of the standard built-in browser fonts. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#typeface DataAkamaiImagingPolicyImage#typeface}
        :param typeface_var: The font family to apply to the text image. This may be a URL to a TrueType or WOFF (v1) typeface, or a string that refers to one of the standard built-in browser fonts. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#typeface_var DataAkamaiImagingPolicyImage#typeface_var}
        '''
        if isinstance(transformation, dict):
            transformation = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageTextImageTransformation(**transformation)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bf9730e2501c28ef7702728838d3e0317a30a17e6fd035cd3be122d336e9c7bb)
            check_type(argname="argument fill", value=fill, expected_type=type_hints["fill"])
            check_type(argname="argument fill_var", value=fill_var, expected_type=type_hints["fill_var"])
            check_type(argname="argument size", value=size, expected_type=type_hints["size"])
            check_type(argname="argument size_var", value=size_var, expected_type=type_hints["size_var"])
            check_type(argname="argument stroke", value=stroke, expected_type=type_hints["stroke"])
            check_type(argname="argument stroke_size", value=stroke_size, expected_type=type_hints["stroke_size"])
            check_type(argname="argument stroke_size_var", value=stroke_size_var, expected_type=type_hints["stroke_size_var"])
            check_type(argname="argument stroke_var", value=stroke_var, expected_type=type_hints["stroke_var"])
            check_type(argname="argument text", value=text, expected_type=type_hints["text"])
            check_type(argname="argument text_var", value=text_var, expected_type=type_hints["text_var"])
            check_type(argname="argument transformation", value=transformation, expected_type=type_hints["transformation"])
            check_type(argname="argument typeface", value=typeface, expected_type=type_hints["typeface"])
            check_type(argname="argument typeface_var", value=typeface_var, expected_type=type_hints["typeface_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fill is not None:
            self._values["fill"] = fill
        if fill_var is not None:
            self._values["fill_var"] = fill_var
        if size is not None:
            self._values["size"] = size
        if size_var is not None:
            self._values["size_var"] = size_var
        if stroke is not None:
            self._values["stroke"] = stroke
        if stroke_size is not None:
            self._values["stroke_size"] = stroke_size
        if stroke_size_var is not None:
            self._values["stroke_size_var"] = stroke_size_var
        if stroke_var is not None:
            self._values["stroke_var"] = stroke_var
        if text is not None:
            self._values["text"] = text
        if text_var is not None:
            self._values["text_var"] = text_var
        if transformation is not None:
            self._values["transformation"] = transformation
        if typeface is not None:
            self._values["typeface"] = typeface
        if typeface_var is not None:
            self._values["typeface_var"] = typeface_var

    @builtins.property
    def fill(self) -> typing.Optional[builtins.str]:
        '''The main fill color of the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill DataAkamaiImagingPolicyImage#fill}
        '''
        result = self._values.get("fill")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fill_var(self) -> typing.Optional[builtins.str]:
        '''The main fill color of the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_var DataAkamaiImagingPolicyImage#fill_var}
        '''
        result = self._values.get("fill_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def size(self) -> typing.Optional[builtins.str]:
        '''The size in pixels to render the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#size DataAkamaiImagingPolicyImage#size}
        '''
        result = self._values.get("size")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def size_var(self) -> typing.Optional[builtins.str]:
        '''The size in pixels to render the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#size_var DataAkamaiImagingPolicyImage#size_var}
        '''
        result = self._values.get("size_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def stroke(self) -> typing.Optional[builtins.str]:
        '''The color for the outline of the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke DataAkamaiImagingPolicyImage#stroke}
        '''
        result = self._values.get("stroke")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def stroke_size(self) -> typing.Optional[builtins.str]:
        '''The thickness in points for the outline of the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_size DataAkamaiImagingPolicyImage#stroke_size}
        '''
        result = self._values.get("stroke_size")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def stroke_size_var(self) -> typing.Optional[builtins.str]:
        '''The thickness in points for the outline of the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_size_var DataAkamaiImagingPolicyImage#stroke_size_var}
        '''
        result = self._values.get("stroke_size_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def stroke_var(self) -> typing.Optional[builtins.str]:
        '''The color for the outline of the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_var DataAkamaiImagingPolicyImage#stroke_var}
        '''
        result = self._values.get("stroke_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def text(self) -> typing.Optional[builtins.str]:
        '''The line of text to render.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text DataAkamaiImagingPolicyImage#text}
        '''
        result = self._values.get("text")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def text_var(self) -> typing.Optional[builtins.str]:
        '''The line of text to render.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text_var DataAkamaiImagingPolicyImage#text_var}
        '''
        result = self._values.get("text_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def transformation(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageTextImageTransformation"]:
        '''transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        '''
        result = self._values.get("transformation")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageTextImageTransformation"], result)

    @builtins.property
    def typeface(self) -> typing.Optional[builtins.str]:
        '''The font family to apply to the text image.

        This may be a URL to a TrueType or WOFF (v1) typeface, or a string that refers to one of the standard built-in browser fonts.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#typeface DataAkamaiImagingPolicyImage#typeface}
        '''
        result = self._values.get("typeface")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def typeface_var(self) -> typing.Optional[builtins.str]:
        '''The font family to apply to the text image.

        This may be a URL to a TrueType or WOFF (v1) typeface, or a string that refers to one of the standard built-in browser fonts.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#typeface_var DataAkamaiImagingPolicyImage#typeface_var}
        '''
        result = self._values.get("typeface_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageTextImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageTextImageList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageTextImageList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0100f1fd5be3033e542e9ccbf78246f235c01b4418dbc200b7b594803a30bf1f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageTextImageOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be60452d326fc363cefeb96ba15f6111cba9ce6bf6becdd407b7964d50a3e76d)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageTextImageOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d101c5ce691162e8c1f2141ea6fc6a06b5faf034e682f35db54ecdaffbfe4ba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__37192b4a6dd34d4cf2eed8e198c738d93ba155245fc324cb99790ebb4ef8d695)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7efa482d4578a336ee8a468921802f98e9cd24f9c7ed78479a61df0a3128346f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageTextImage]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageTextImage]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageTextImage]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fc519effe6802c57209d91efd4748f119f80d2e5462c6f7560d280bfcb3dc23a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageTextImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageTextImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d20baa0934c9f064be0671e7bd8881c67d3333df29741d222baa42118ddd8ae5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformation")
    def put_transformation(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageTextImageTransformation()

        return typing.cast(None, jsii.invoke(self, "putTransformation", [value]))

    @jsii.member(jsii_name="resetFill")
    def reset_fill(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFill", []))

    @jsii.member(jsii_name="resetFillVar")
    def reset_fill_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFillVar", []))

    @jsii.member(jsii_name="resetSize")
    def reset_size(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSize", []))

    @jsii.member(jsii_name="resetSizeVar")
    def reset_size_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSizeVar", []))

    @jsii.member(jsii_name="resetStroke")
    def reset_stroke(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStroke", []))

    @jsii.member(jsii_name="resetStrokeSize")
    def reset_stroke_size(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStrokeSize", []))

    @jsii.member(jsii_name="resetStrokeSizeVar")
    def reset_stroke_size_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStrokeSizeVar", []))

    @jsii.member(jsii_name="resetStrokeVar")
    def reset_stroke_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStrokeVar", []))

    @jsii.member(jsii_name="resetText")
    def reset_text(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetText", []))

    @jsii.member(jsii_name="resetTextVar")
    def reset_text_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTextVar", []))

    @jsii.member(jsii_name="resetTransformation")
    def reset_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformation", []))

    @jsii.member(jsii_name="resetTypeface")
    def reset_typeface(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeface", []))

    @jsii.member(jsii_name="resetTypefaceVar")
    def reset_typeface_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypefaceVar", []))

    @builtins.property
    @jsii.member(jsii_name="transformation")
    def transformation(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageTextImageTransformationOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageTextImageTransformationOutputReference", jsii.get(self, "transformation"))

    @builtins.property
    @jsii.member(jsii_name="fillInput")
    def fill_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fillInput"))

    @builtins.property
    @jsii.member(jsii_name="fillVarInput")
    def fill_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fillVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sizeInput")
    def size_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sizeInput"))

    @builtins.property
    @jsii.member(jsii_name="sizeVarInput")
    def size_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sizeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="strokeInput")
    def stroke_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "strokeInput"))

    @builtins.property
    @jsii.member(jsii_name="strokeSizeInput")
    def stroke_size_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "strokeSizeInput"))

    @builtins.property
    @jsii.member(jsii_name="strokeSizeVarInput")
    def stroke_size_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "strokeSizeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="strokeVarInput")
    def stroke_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "strokeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="textInput")
    def text_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "textInput"))

    @builtins.property
    @jsii.member(jsii_name="textVarInput")
    def text_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "textVarInput"))

    @builtins.property
    @jsii.member(jsii_name="transformationInput")
    def transformation_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageTextImageTransformation"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageTextImageTransformation"], jsii.get(self, "transformationInput"))

    @builtins.property
    @jsii.member(jsii_name="typefaceInput")
    def typeface_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typefaceInput"))

    @builtins.property
    @jsii.member(jsii_name="typefaceVarInput")
    def typeface_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typefaceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="fill")
    def fill(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fill"))

    @fill.setter
    def fill(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__40dad0d0af44dedd3a735c4338d5d270c2c5385573874ad09613ac6b6f084895)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fill", value)

    @builtins.property
    @jsii.member(jsii_name="fillVar")
    def fill_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fillVar"))

    @fill_var.setter
    def fill_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dc7ed8765793a49942f3942ce979267e5a4922500b774735c9379c47f97d4eff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fillVar", value)

    @builtins.property
    @jsii.member(jsii_name="size")
    def size(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "size"))

    @size.setter
    def size(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a694ae7691f6d591e4bfaac3ec6b07dc9bb6c2c9c61630ef9848d2b2736eaed5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "size", value)

    @builtins.property
    @jsii.member(jsii_name="sizeVar")
    def size_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sizeVar"))

    @size_var.setter
    def size_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bcde19468b7852f00fcfc87399f56a964e3eb25f4a9df24ad6a7d2997258de29)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sizeVar", value)

    @builtins.property
    @jsii.member(jsii_name="stroke")
    def stroke(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "stroke"))

    @stroke.setter
    def stroke(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__56066c28b029e47f45b6bb26135dbafb26854fc0cec08a66875d422276d46348)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "stroke", value)

    @builtins.property
    @jsii.member(jsii_name="strokeSize")
    def stroke_size(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "strokeSize"))

    @stroke_size.setter
    def stroke_size(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9bb1d39cfe3dd3d41107f1b79d5621f7e3a200d96e8985777ab0f9ac0cb85ae6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "strokeSize", value)

    @builtins.property
    @jsii.member(jsii_name="strokeSizeVar")
    def stroke_size_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "strokeSizeVar"))

    @stroke_size_var.setter
    def stroke_size_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__972510bbad6925919885e3f779be3fc4b441d27735a2519ad2a0f60f8452f254)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "strokeSizeVar", value)

    @builtins.property
    @jsii.member(jsii_name="strokeVar")
    def stroke_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "strokeVar"))

    @stroke_var.setter
    def stroke_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5b982d180491a19c153cb414b32ebd83f4926fb05ba8fb12f47db54afa222327)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "strokeVar", value)

    @builtins.property
    @jsii.member(jsii_name="text")
    def text(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "text"))

    @text.setter
    def text(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f6ceff5283def79237e401922dce1094543986531bddb8b02fcb10aab42632f5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "text", value)

    @builtins.property
    @jsii.member(jsii_name="textVar")
    def text_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "textVar"))

    @text_var.setter
    def text_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5cbc1a1dd4eade2f42a82bd1e618aead69250d23b316b8a8e6afa679ff650f37)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "textVar", value)

    @builtins.property
    @jsii.member(jsii_name="typeface")
    def typeface(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeface"))

    @typeface.setter
    def typeface(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3346720bb4cd5053c5c70b245491551369136576c6179816feaeecce3089ae20)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeface", value)

    @builtins.property
    @jsii.member(jsii_name="typefaceVar")
    def typeface_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typefaceVar"))

    @typeface_var.setter
    def typeface_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1deb43fcfd0d3db00286683bb47baeced9c519dd6db85a5809c636cffd308f7c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typefaceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageTextImage]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageTextImage]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageTextImage]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__24c0d10f5e0536996b31f109320c506d3d028670a6a2bedeff41fd6e5c54baea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageTextImageTransformation",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageTextImageTransformation:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageTextImageTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageTextImageTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageTextImageTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6a9894f4e25528ac91d5af3d26876de657708571ca05bd68e7a223cab349c188)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageTextImageTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageTextImageTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageTextImageTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a4e168c50e2e3455274c470b36ca2a4133eea06ef0bf5dbdcdf46f5fe3c15c16)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageUrlImage",
    jsii_struct_bases=[],
    name_mapping={
        "transformation": "transformation",
        "url": "url",
        "url_var": "urlVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageUrlImage:
    def __init__(
        self,
        *,
        transformation: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageUrlImageTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        url: typing.Optional[builtins.str] = None,
        url_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param transformation: transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        :param url: The URL of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url DataAkamaiImagingPolicyImage#url}
        :param url_var: The URL of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url_var DataAkamaiImagingPolicyImage#url_var}
        '''
        if isinstance(transformation, dict):
            transformation = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageUrlImageTransformation(**transformation)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d1964489fe0313efa24971fb072f68b84452653fdde45f3895afcd16d6516314)
            check_type(argname="argument transformation", value=transformation, expected_type=type_hints["transformation"])
            check_type(argname="argument url", value=url, expected_type=type_hints["url"])
            check_type(argname="argument url_var", value=url_var, expected_type=type_hints["url_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if transformation is not None:
            self._values["transformation"] = transformation
        if url is not None:
            self._values["url"] = url
        if url_var is not None:
            self._values["url_var"] = url_var

    @builtins.property
    def transformation(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageUrlImageTransformation"]:
        '''transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        '''
        result = self._values.get("transformation")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageUrlImageTransformation"], result)

    @builtins.property
    def url(self) -> typing.Optional[builtins.str]:
        '''The URL of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url DataAkamaiImagingPolicyImage#url}
        '''
        result = self._values.get("url")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def url_var(self) -> typing.Optional[builtins.str]:
        '''The URL of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url_var DataAkamaiImagingPolicyImage#url_var}
        '''
        result = self._values.get("url_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageUrlImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageUrlImageList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageUrlImageList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6581d58d95cedf365cf0bba4f18114d304146a9dc1873932d8aaa6be67b9f741)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageUrlImageOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eb97a21cfbdc96aae56232c92beb065a010472889d9bf821bcaaec30cd30304b)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageUrlImageOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c09a6665b13e2fa2c6428f3515a47b254358c420c57c79da714cb15b5db9379b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a51f8008cde062669a052710e0708adec0defd40cb588ae349a266ba68ab088e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__28ec55b0822a95265ceed47f55baae64a97b30c8823365c2d5cb26980938e0de)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageUrlImage]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageUrlImage]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageUrlImage]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3f6319c800175c924c72d16e176c1e782e6a5891217a70ae3b35ea1138163311)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageUrlImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageUrlImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7f96810a6b1a2007f1229c67ce3be0bbdab071efe7b17253e60ffe2f85291b65)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformation")
    def put_transformation(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageUrlImageTransformation()

        return typing.cast(None, jsii.invoke(self, "putTransformation", [value]))

    @jsii.member(jsii_name="resetTransformation")
    def reset_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformation", []))

    @jsii.member(jsii_name="resetUrl")
    def reset_url(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUrl", []))

    @jsii.member(jsii_name="resetUrlVar")
    def reset_url_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUrlVar", []))

    @builtins.property
    @jsii.member(jsii_name="transformation")
    def transformation(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageUrlImageTransformationOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageUrlImageTransformationOutputReference", jsii.get(self, "transformation"))

    @builtins.property
    @jsii.member(jsii_name="transformationInput")
    def transformation_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageUrlImageTransformation"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageUrlImageTransformation"], jsii.get(self, "transformationInput"))

    @builtins.property
    @jsii.member(jsii_name="urlInput")
    def url_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "urlInput"))

    @builtins.property
    @jsii.member(jsii_name="urlVarInput")
    def url_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "urlVarInput"))

    @builtins.property
    @jsii.member(jsii_name="url")
    def url(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "url"))

    @url.setter
    def url(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__12050eb41632031428865bfa25c2ea10571bfdbf5e512bab9cf965685b1d65a0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "url", value)

    @builtins.property
    @jsii.member(jsii_name="urlVar")
    def url_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "urlVar"))

    @url_var.setter
    def url_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac93291b2001bdefaab87899f171bbc1eb2fdbfc57fee9f6d94248dda6806a4e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "urlVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageUrlImage]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageUrlImage]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageUrlImage]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d6da18af63ec9bf0de28b32d92a6068df1fcc6bbc7ea8ec676d3ef2c355d030f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageUrlImageTransformation",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageUrlImageTransformation:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageUrlImageTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageUrlImageTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageUrlImageTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__31449d4e495e61f614f3ab154251f51bd3d1973d88c82c391d2a74d226370fed)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageUrlImageTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageUrlImageTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageUrlImageTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__77e7356f8a5ba9b7fd40324c82d64ea0e7bf794d202f2557b4382c93066dc0fb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7b4eb8af8e98d525235fe8f43a22d84cdd2606e96d5d5e4ad0b4ab091daf1b84)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e0900d7c929f5301d7e59c9fa27229fc85b23530ce7519c44bdd59651f3c7494)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a0e7cd9100baacbcb8bbf9fba307ce7da4fbbc9eb7348dcbaf77e33331de34cc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b6c42389dd6020314067913dd7a9b038c9ddd752bfb848b100ba044eab9fe54c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__697080bb01b4b582d1799cc1d091d0befccd56c208695e8db29adfcbdfc7e845)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsComposite]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsComposite]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7565b5d8a085e0f9bab3947f7c7c4f6319264da1073d1bffa17e33917d0df11b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8c79198e338a530c6979b0fa1ad369057dfba101c64cda60adf56f4b50fc780b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(
        self,
        *,
        box_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageBoxImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
        circle_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageCircleImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
        text_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageTextImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
        url_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageUrlImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param box_image: box_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#box_image DataAkamaiImagingPolicyImage#box_image}
        :param circle_image: circle_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#circle_image DataAkamaiImagingPolicyImage#circle_image}
        :param text_image: text_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text_image DataAkamaiImagingPolicyImage#text_image}
        :param url_image: url_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url_image DataAkamaiImagingPolicyImage#url_image}
        '''
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImage(
            box_image=box_image,
            circle_image=circle_image,
            text_image=text_image,
            url_image=url_image,
        )

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPlacement")
    def reset_placement(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacement", []))

    @jsii.member(jsii_name="resetPlacementVar")
    def reset_placement_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacementVar", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetScaleDimension")
    def reset_scale_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimension", []))

    @jsii.member(jsii_name="resetScaleDimensionVar")
    def reset_scale_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimensionVar", []))

    @jsii.member(jsii_name="resetScaleVar")
    def reset_scale_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="placementInput")
    def placement_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementInput"))

    @builtins.property
    @jsii.member(jsii_name="placementVarInput")
    def placement_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionInput")
    def scale_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVarInput")
    def scale_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleVarInput")
    def scale_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6ff64a1dbaafaea0703e57e34679b29679f6843894c3fd8a470d4f968fed4a3f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__035f4c8bb1de96e35be97b27c3298c2ac15214319038be14b8a3b0453761fe2c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="placement")
    def placement(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placement"))

    @placement.setter
    def placement(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8034edc8411ea67a021f4568346726d7ffe40af5ad73833aab66ec419e3349e3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placement", value)

    @builtins.property
    @jsii.member(jsii_name="placementVar")
    def placement_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placementVar"))

    @placement_var.setter
    def placement_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1e0806bf3911443cfcb2f014f53ad59fdf3414650920ca24fdc6e5a4ddf65091)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placementVar", value)

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scale"))

    @scale.setter
    def scale(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__728e6e8ad988e1d3783e0f9ca4aef5ebf87ede9f9975b163716def4708a8166b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scale", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimension")
    def scale_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimension"))

    @scale_dimension.setter
    def scale_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dc2380e8fec085fd4f032cf26c847bfcb18bdb51df0d5251337bd064be9214d1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimension", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVar")
    def scale_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimensionVar"))

    @scale_dimension_var.setter
    def scale_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__85bbe61fd8e56f19266901e4d3aa5b67609dca544709b49149e3fce39479c688)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="scaleVar")
    def scale_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleVar"))

    @scale_var.setter
    def scale_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dc9e2e4f78bbec42f1e31b773da2db19d1eee283e63ac9dc8f4f82f583b73a63)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fe6a1a5cc6ccb54a673e9ed6b0afb0319c3a9506f8b9a36c178098ebbd69b94b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__985e4b540e6d6c17950eba51fbc37b13c0c9a47f8b8dc4913191a67bba51edc9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e6c44ebdb4d95a4532fb3d7857d6db1ba2f5ae96c795dd7a5cd42cf28daaccb7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c6f29d614028f4a65d97bb4906065ab2030fa3b723cdb98e2629eacc70e18793)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsComposite]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsComposite]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsComposite]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__01cbb1e960145028ce9fab8d224940b07f7b6db7cb77ef36ab9fb70ec93ab329)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsContrast",
    jsii_struct_bases=[],
    name_mapping={
        "brightness": "brightness",
        "brightness_var": "brightnessVar",
        "contrast": "contrast",
        "contrast_var": "contrastVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsContrast:
    def __init__(
        self,
        *,
        brightness: typing.Optional[builtins.str] = None,
        brightness_var: typing.Optional[builtins.str] = None,
        contrast: typing.Optional[builtins.str] = None,
        contrast_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param brightness: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        :param brightness_var: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        :param contrast: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param contrast_var: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2444e3cfa8a0a2d55a49596cb939e842d85e7cf4ede85fd9d230b3590439d4c8)
            check_type(argname="argument brightness", value=brightness, expected_type=type_hints["brightness"])
            check_type(argname="argument brightness_var", value=brightness_var, expected_type=type_hints["brightness_var"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument contrast_var", value=contrast_var, expected_type=type_hints["contrast_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if brightness is not None:
            self._values["brightness"] = brightness
        if brightness_var is not None:
            self._values["brightness_var"] = brightness_var
        if contrast is not None:
            self._values["contrast"] = contrast
        if contrast_var is not None:
            self._values["contrast_var"] = contrast_var

    @builtins.property
    def brightness(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        '''
        result = self._values.get("brightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def brightness_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        '''
        result = self._values.get("brightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        result = self._values.get("contrast_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsContrast(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsContrastList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsContrastList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0b6c5d97d83cd7062f754a6453b5300dd1c97374064b3b3d10f8ec8df543c0e8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsContrastOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7ba4dc1c596cec8ef8bebe0ea2ae4bedfe8f6dfed68c417152651c5680eb4097)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsContrastOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__61cc1dbb121c5a3e30ac36ee3eefc9fb2782aa1a3893dc571212d9e68fb17327)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8335d84dc0d0b40e4c450333fb455029072fe2cd214bdbeee567a3da11b84a29)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d3c8f09ada58869f1043181f3664d08c6fc113f56c4cb89f782bb7953118cee4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsContrast]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsContrast]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dccfcc99e11aef852caa51c3373363c1e7c7c3ddeea388ed8f03376617d9c088)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsContrastOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsContrastOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3cb95e9bed5b00c235a2e7babd8766b4cd079e09626686a6d9deca395315ae3d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetBrightness")
    def reset_brightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightness", []))

    @jsii.member(jsii_name="resetBrightnessVar")
    def reset_brightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightnessVar", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetContrastVar")
    def reset_contrast_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrastVar", []))

    @builtins.property
    @jsii.member(jsii_name="brightnessInput")
    def brightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="brightnessVarInput")
    def brightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastVarInput")
    def contrast_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="brightness")
    def brightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightness"))

    @brightness.setter
    def brightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e8bf57e199b52d801533f6ac039869fd968e8153f89d62b8b19ee03998c41d2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightness", value)

    @builtins.property
    @jsii.member(jsii_name="brightnessVar")
    def brightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightnessVar"))

    @brightness_var.setter
    def brightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3dda5fb39fe218c8456d9f5e45631ffa43790a85229c7ef45004a7d18a2a5dfa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrast"))

    @contrast.setter
    def contrast(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6ab541553716375accd528a0220a2b228e420766cf697bf257741aca3c9dba60)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrast", value)

    @builtins.property
    @jsii.member(jsii_name="contrastVar")
    def contrast_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrastVar"))

    @contrast_var.setter
    def contrast_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1ca62cca331ee8cb451e81a80aafbbed4920c27f470ecf0df40386afe4ea94be)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrastVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsContrast]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsContrast]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsContrast]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__efdd9b44407771ace1f4a164caf8e151bbcd50b01d4d1c8dadc920865d532850)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsGoop",
    jsii_struct_bases=[],
    name_mapping={
        "chaos": "chaos",
        "chaos_var": "chaosVar",
        "density": "density",
        "density_var": "densityVar",
        "power": "power",
        "power_var": "powerVar",
        "seed": "seed",
        "seed_var": "seedVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsGoop:
    def __init__(
        self,
        *,
        chaos: typing.Optional[builtins.str] = None,
        chaos_var: typing.Optional[builtins.str] = None,
        density: typing.Optional[builtins.str] = None,
        density_var: typing.Optional[builtins.str] = None,
        power: typing.Optional[builtins.str] = None,
        power_var: typing.Optional[builtins.str] = None,
        seed: typing.Optional[builtins.str] = None,
        seed_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param chaos: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        :param chaos_var: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        :param density: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        :param density_var: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        :param power: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        :param power_var: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        :param seed: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        :param seed_var: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__63e67c204fb49b9dca7ba65fa9d6ea49254e8d40bc0770245401251b315b53c8)
            check_type(argname="argument chaos", value=chaos, expected_type=type_hints["chaos"])
            check_type(argname="argument chaos_var", value=chaos_var, expected_type=type_hints["chaos_var"])
            check_type(argname="argument density", value=density, expected_type=type_hints["density"])
            check_type(argname="argument density_var", value=density_var, expected_type=type_hints["density_var"])
            check_type(argname="argument power", value=power, expected_type=type_hints["power"])
            check_type(argname="argument power_var", value=power_var, expected_type=type_hints["power_var"])
            check_type(argname="argument seed", value=seed, expected_type=type_hints["seed"])
            check_type(argname="argument seed_var", value=seed_var, expected_type=type_hints["seed_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if chaos is not None:
            self._values["chaos"] = chaos
        if chaos_var is not None:
            self._values["chaos_var"] = chaos_var
        if density is not None:
            self._values["density"] = density
        if density_var is not None:
            self._values["density_var"] = density_var
        if power is not None:
            self._values["power"] = power
        if power_var is not None:
            self._values["power_var"] = power_var
        if seed is not None:
            self._values["seed"] = seed
        if seed_var is not None:
            self._values["seed_var"] = seed_var

    @builtins.property
    def chaos(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        '''
        result = self._values.get("chaos")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def chaos_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        '''
        result = self._values.get("chaos_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        '''
        result = self._values.get("density")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density_var(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        '''
        result = self._values.get("density_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        '''
        result = self._values.get("power")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power_var(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        '''
        result = self._values.get("power_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        '''
        result = self._values.get("seed")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed_var(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        result = self._values.get("seed_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsGoop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsGoopList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsGoopList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0569fcfff59ec0896d933526d4f0a2c50f0b3d052bd6eb36bda01b50577216e2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsGoopOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__271c2ac66ce2fe5072167c88c8c3048bac45d61abcb64cfb26231e52861fc68e)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsGoopOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__348ae47ade40e2eee9ac3db1d717c776e9edb61fce013c20f3074a4b03fe2a6c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9874c6798ce8f59ba8044dba29de11a84c722841c008aac326aa3f7247c429c9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3c9a178a173915f8c80e076d29b2fa1d5a3c795441a192ba40cd9881ea1bf32a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsGoop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsGoop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__227fa05a41fc9c516289165806b651c429b038e3fd7d5299c0a58cc64c0b5104)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsGoopOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsGoopOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c07fe05f02297127d6266add7b70339a9f309e7c8103c89b94b27c58b7c59654)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetChaos")
    def reset_chaos(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaos", []))

    @jsii.member(jsii_name="resetChaosVar")
    def reset_chaos_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaosVar", []))

    @jsii.member(jsii_name="resetDensity")
    def reset_density(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensity", []))

    @jsii.member(jsii_name="resetDensityVar")
    def reset_density_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensityVar", []))

    @jsii.member(jsii_name="resetPower")
    def reset_power(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPower", []))

    @jsii.member(jsii_name="resetPowerVar")
    def reset_power_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPowerVar", []))

    @jsii.member(jsii_name="resetSeed")
    def reset_seed(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeed", []))

    @jsii.member(jsii_name="resetSeedVar")
    def reset_seed_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeedVar", []))

    @builtins.property
    @jsii.member(jsii_name="chaosInput")
    def chaos_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosInput"))

    @builtins.property
    @jsii.member(jsii_name="chaosVarInput")
    def chaos_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosVarInput"))

    @builtins.property
    @jsii.member(jsii_name="densityInput")
    def density_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityInput"))

    @builtins.property
    @jsii.member(jsii_name="densityVarInput")
    def density_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="powerInput")
    def power_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerInput"))

    @builtins.property
    @jsii.member(jsii_name="powerVarInput")
    def power_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerVarInput"))

    @builtins.property
    @jsii.member(jsii_name="seedInput")
    def seed_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedInput"))

    @builtins.property
    @jsii.member(jsii_name="seedVarInput")
    def seed_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedVarInput"))

    @builtins.property
    @jsii.member(jsii_name="chaos")
    def chaos(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaos"))

    @chaos.setter
    def chaos(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d70a7344577ee1a33852969147fb1c2f925af7e2d8ea0c715cbfb2555a1af35d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaos", value)

    @builtins.property
    @jsii.member(jsii_name="chaosVar")
    def chaos_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaosVar"))

    @chaos_var.setter
    def chaos_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__50b4137fed5730ace846cb9600088721a4c8afe9792ab52728ca0aed82f79d05)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaosVar", value)

    @builtins.property
    @jsii.member(jsii_name="density")
    def density(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "density"))

    @density.setter
    def density(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__24bb26d50c29fdc5bad2a2a736a5679bf207174cb278b24842cbdee343047443)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "density", value)

    @builtins.property
    @jsii.member(jsii_name="densityVar")
    def density_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "densityVar"))

    @density_var.setter
    def density_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c7d864344b960d096e2a4c04242fc46dd9cd39c2616948d94a817654fe0cd03c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "densityVar", value)

    @builtins.property
    @jsii.member(jsii_name="power")
    def power(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "power"))

    @power.setter
    def power(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5c7b3dac64054809dd369a1f88497bc520744bb1a174967e967532cc64b8d22d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "power", value)

    @builtins.property
    @jsii.member(jsii_name="powerVar")
    def power_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "powerVar"))

    @power_var.setter
    def power_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__443614e5b5d299dabce485613e23cc07e3238caa9017d09bda3c42a54ad00e38)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "powerVar", value)

    @builtins.property
    @jsii.member(jsii_name="seed")
    def seed(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seed"))

    @seed.setter
    def seed(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e2ec8da4952c0490fb316cbfd887dd9051273c76d55b4ecf440ef22d150621d3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seed", value)

    @builtins.property
    @jsii.member(jsii_name="seedVar")
    def seed_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seedVar"))

    @seed_var.setter
    def seed_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2f6d46414fec57831163a4b31bd4c9f669a337ab8072b0188d2f00eb0d5d4b23)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seedVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsGoop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsGoop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsGoop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ad69808a48c5025fa56c96b0c99834b170de9dc3d77440c57198c6f0dcb9fb35)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsGrayscale",
    jsii_struct_bases=[],
    name_mapping={"type": "type", "type_var": "typeVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsGrayscale:
    def __init__(
        self,
        *,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param type: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f598726c4a5a7c97ae5f09c7d372515b126e87acc41feda6dd4ba906d2680056)
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsGrayscale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsGrayscaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsGrayscaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__81211085cbb4f4a47605857278eb896362c7659c9c9cba5df59b840488c1343b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsGrayscaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d83d4ee33ffca821ae6c2a3684030532cb7fe8ec68f61b1b45f155c0629958a)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsGrayscaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0a6f617ea47c505fdfdf3d29bd751d296264f298e23f7f5432b62a646745caba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4932f305b1d5ac6c8025d8792c03c6307ddab83d768363fc1e92712819b2ab1a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__357f96f7f546394698db6912dda74783a6b960d2f4c7f0a839ef76dcc76f9c35)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsGrayscale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsGrayscale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__52370154ec51b516e7cd3e1e22dcece3095f02aa9bfff916ae5beaceaf19e3c8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsGrayscaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsGrayscaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e195a6ff98e6a64c29a9135ee554fc6fa5103edc02bbb3ef23a5d966d64bdbaa)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2194d5b6b0b07e372a4b0370807a5963c842c5287870caac1a1f15244b0c7c79)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f45c7083ad75001c620c37d10613ee87ffd043ecadfe6af2cdc985406726174)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsGrayscale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsGrayscale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsGrayscale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e9a96b3a8f548b8964297267b74764c1135b9b2a058f9cceec5649e2cb363b24)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsHsl",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "lightness": "lightness",
        "lightness_var": "lightnessVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsHsl:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness: typing.Optional[builtins.str] = None,
        lightness_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        :param lightness_var: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a59d4846754d9f75997eb29b8910c9047e5451a297238cd7b54f30485bccfc8b)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness", value=lightness, expected_type=type_hints["lightness"])
            check_type(argname="argument lightness_var", value=lightness_var, expected_type=type_hints["lightness_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness is not None:
            self._values["lightness"] = lightness
        if lightness_var is not None:
            self._values["lightness_var"] = lightness_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        '''
        result = self._values.get("lightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        '''
        result = self._values.get("lightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsHsl(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsHslList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsHslList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__699c7f9469a830a1cab773334b22b2d1ada45b2caca58eea6573aa3080d61a5a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsHslOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5243f747b2dc82a5da9828ba0ed3baaf3c5dcb8e84c6d3e4897a2ffc756ee985)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsHslOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__784a4b89c540c819c08709a4a99e40a8232592978cf2b0870cde59bd73798959)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f60cd2bcbb2d429105c2d6e7e6f156c2a8cf60707e9d3d57335dd4f98b99b8d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f6a0e2bb3a688ade9c93efe266c75f8794d5115d319f027373e8eabe30a0a5f5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsHsl]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsHsl]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__885f6e15b73b4101633c41005b84aa856ce003edfd4e95e9ebf5ef246e61194a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsHslOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsHslOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c982dc6d37df8597a5d1df3796310c13a3bc1b66d0f89d6afe55957d4fac6728)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightness")
    def reset_lightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightness", []))

    @jsii.member(jsii_name="resetLightnessVar")
    def reset_lightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessInput")
    def lightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessVarInput")
    def lightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fef7fb53bbdb36dafd27c12f8c252acf12d8591da9d99269dad73c186e2eed4d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1a3e7f2d2d30c216be32f54ff698c294b9c551acb017b55557ac7f66074a528c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightness")
    def lightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightness"))

    @lightness.setter
    def lightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a2126a9deaedb4c8afbbd8514df489813eba2b9290747db1035c1ce16de48274)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightness", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessVar")
    def lightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessVar"))

    @lightness_var.setter
    def lightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__137758d487331a2a1fb19bebfaf32e0f8c3dfafd12fec2435ea4383b6397176f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4db0844ac95feaf27a44f8517c1f5eb27c51e71f655044163770d1b6f52fa90f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f6319989a37d8ec448b4b085f51ba148b8c55084934bbbddb1f3307652431757)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsHsl]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsHsl]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsHsl]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ba8e35c41eec44891ca222ebe97892bbabd77779000519b4f72c36e5b1b1ffcf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsHsv",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsHsv:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        :param value: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f05978142a8de554cc1d5233609fbb269898c8690712f5f47a2222c7a89c187c)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsHsv(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsHsvList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsHsvList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a2da7806cc8870a9f83c82abb1d6df3b4b66562e59544927c2c91d72cfc4b482)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsHsvOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7688fa6cfde615d63e338a653fffee3abde33acf17357e7d5d4ff45d034e3716)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsHsvOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d95178279188f064abd3c06c3583c09ca501b959bd03d63920524498329b1fff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__17699db2ce4a58b2055829fd3d143321a21de9f31e0ffaee3039f8f6f7f85417)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c5bd71a798f05b0a9a996ecef853ffc82584ed0133b259ae507087cdd2d2ee2f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsHsv]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsHsv]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__751a903c3bcd6d93d2dbb43a2e21f7f375149a70eaab92f82ff4f045028b3423)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsHsvOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsHsvOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__db57d3afc64429cad08e11485bc49c490524f90c41e2971a5826b189c2f3ea24)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__76fbdce40eb008e30a78905260fb8720031009ca094c4f432cfbeb64fe4a3db8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac1033fcd03b628c3c3b4f22a46db9d6af1559b47e7319cefd9d0b3e55e370a8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__84c4646e1cdf1c42dca7103af562a9950e5bdfe64906abaf3d6ef4d2e3ce5d06)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__097d9260aafefd19805e1e690175185ce67298698512518be784aef5047a42ce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4fc4edb4b1fdf9dd17fd03d30085dfdc6a01857f6a7715f11005d6105bdce657)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1255e35d052c6d80af968f55ab1f8144700987368880a2fa94ef2796aea19cc7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsHsv]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsHsv]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsHsv]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__38fdb9e47841292e41a1c110a382287ac4a2852dacb13a197ff4d78a2d3ed911)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimension",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "dimension": "dimension",
        "dimension_var": "dimensionVar",
        "equal": "equal",
        "greater_than": "greaterThan",
        "less_than": "lessThan",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimension:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        dimension: typing.Optional[builtins.str] = None,
        dimension_var: typing.Optional[builtins.str] = None,
        equal: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqual", typing.Dict[builtins.str, typing.Any]]] = None,
        greater_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThan", typing.Dict[builtins.str, typing.Any]]] = None,
        less_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThan", typing.Dict[builtins.str, typing.Any]]] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param dimension: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        :param dimension_var: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        :param equal: equal block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        :param greater_than: greater_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        :param less_than: less_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        :param value: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefault(**default)
        if isinstance(equal, dict):
            equal = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqual(**equal)
        if isinstance(greater_than, dict):
            greater_than = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThan(**greater_than)
        if isinstance(less_than, dict):
            less_than = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThan(**less_than)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8339d7acb4cd20a470b4c07926df18edfcca1592a4ef1ffae7c3c35fa9f9eff3)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument dimension", value=dimension, expected_type=type_hints["dimension"])
            check_type(argname="argument dimension_var", value=dimension_var, expected_type=type_hints["dimension_var"])
            check_type(argname="argument equal", value=equal, expected_type=type_hints["equal"])
            check_type(argname="argument greater_than", value=greater_than, expected_type=type_hints["greater_than"])
            check_type(argname="argument less_than", value=less_than, expected_type=type_hints["less_than"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if dimension is not None:
            self._values["dimension"] = dimension
        if dimension_var is not None:
            self._values["dimension_var"] = dimension_var
        if equal is not None:
            self._values["equal"] = equal
        if greater_than is not None:
            self._values["greater_than"] = greater_than
        if less_than is not None:
            self._values["less_than"] = less_than
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefault"], result)

    @builtins.property
    def dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        '''
        result = self._values.get("dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        '''
        result = self._values.get("dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def equal(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqual"]:
        '''equal block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        '''
        result = self._values.get("equal")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqual"], result)

    @builtins.property
    def greater_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThan"]:
        '''greater_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        '''
        result = self._values.get("greater_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThan"], result)

    @builtins.property
    def less_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThan"]:
        '''less_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        '''
        result = self._values.get("less_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThan"], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimension(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefault",
    jsii_struct_bases=[],
    name_mapping={
        "background_color": "backgroundColor",
        "blur": "blur",
        "chroma_key": "chromaKey",
        "composite": "composite",
        "compound": "compound",
        "contrast": "contrast",
        "goop": "goop",
        "grayscale": "grayscale",
        "hsl": "hsl",
        "hsv": "hsv",
        "if_dimension": "ifDimension",
        "if_orientation": "ifOrientation",
        "max_colors": "maxColors",
        "mirror": "mirror",
        "mono_hue": "monoHue",
        "opacity": "opacity",
        "remove_color": "removeColor",
        "unsharp_mask": "unsharpMask",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefault:
    def __init__(
        self,
        *,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultBackgroundColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultBlur", typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultChromaKey", typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultComposite", typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultCompound", typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultContrast", typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultGoop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultGrayscale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultHsl", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultHsv", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfDimension", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfOrientation", typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultMaxColors", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultMirror", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultMonoHue", typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultOpacity", typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultRemoveColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultUnsharpMask", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a0fdb07f021cb21115bf647cf47747b146a32c9d983e92f91e83ad4c7cad8cf3)
            check_type(argname="argument background_color", value=background_color, expected_type=type_hints["background_color"])
            check_type(argname="argument blur", value=blur, expected_type=type_hints["blur"])
            check_type(argname="argument chroma_key", value=chroma_key, expected_type=type_hints["chroma_key"])
            check_type(argname="argument composite", value=composite, expected_type=type_hints["composite"])
            check_type(argname="argument compound", value=compound, expected_type=type_hints["compound"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument goop", value=goop, expected_type=type_hints["goop"])
            check_type(argname="argument grayscale", value=grayscale, expected_type=type_hints["grayscale"])
            check_type(argname="argument hsl", value=hsl, expected_type=type_hints["hsl"])
            check_type(argname="argument hsv", value=hsv, expected_type=type_hints["hsv"])
            check_type(argname="argument if_dimension", value=if_dimension, expected_type=type_hints["if_dimension"])
            check_type(argname="argument if_orientation", value=if_orientation, expected_type=type_hints["if_orientation"])
            check_type(argname="argument max_colors", value=max_colors, expected_type=type_hints["max_colors"])
            check_type(argname="argument mirror", value=mirror, expected_type=type_hints["mirror"])
            check_type(argname="argument mono_hue", value=mono_hue, expected_type=type_hints["mono_hue"])
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument remove_color", value=remove_color, expected_type=type_hints["remove_color"])
            check_type(argname="argument unsharp_mask", value=unsharp_mask, expected_type=type_hints["unsharp_mask"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if background_color is not None:
            self._values["background_color"] = background_color
        if blur is not None:
            self._values["blur"] = blur
        if chroma_key is not None:
            self._values["chroma_key"] = chroma_key
        if composite is not None:
            self._values["composite"] = composite
        if compound is not None:
            self._values["compound"] = compound
        if contrast is not None:
            self._values["contrast"] = contrast
        if goop is not None:
            self._values["goop"] = goop
        if grayscale is not None:
            self._values["grayscale"] = grayscale
        if hsl is not None:
            self._values["hsl"] = hsl
        if hsv is not None:
            self._values["hsv"] = hsv
        if if_dimension is not None:
            self._values["if_dimension"] = if_dimension
        if if_orientation is not None:
            self._values["if_orientation"] = if_orientation
        if max_colors is not None:
            self._values["max_colors"] = max_colors
        if mirror is not None:
            self._values["mirror"] = mirror
        if mono_hue is not None:
            self._values["mono_hue"] = mono_hue
        if opacity is not None:
            self._values["opacity"] = opacity
        if remove_color is not None:
            self._values["remove_color"] = remove_color
        if unsharp_mask is not None:
            self._values["unsharp_mask"] = unsharp_mask

    @builtins.property
    def background_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultBackgroundColor"]]]:
        '''background_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        '''
        result = self._values.get("background_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultBackgroundColor"]]], result)

    @builtins.property
    def blur(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultBlur"]]]:
        '''blur block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        '''
        result = self._values.get("blur")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultBlur"]]], result)

    @builtins.property
    def chroma_key(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultChromaKey"]]]:
        '''chroma_key block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        '''
        result = self._values.get("chroma_key")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultChromaKey"]]], result)

    @builtins.property
    def composite(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultComposite"]]]:
        '''composite block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        '''
        result = self._values.get("composite")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultComposite"]]], result)

    @builtins.property
    def compound(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultCompound"]]]:
        '''compound block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        '''
        result = self._values.get("compound")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultCompound"]]], result)

    @builtins.property
    def contrast(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultContrast"]]]:
        '''contrast block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultContrast"]]], result)

    @builtins.property
    def goop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultGoop"]]]:
        '''goop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        '''
        result = self._values.get("goop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultGoop"]]], result)

    @builtins.property
    def grayscale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultGrayscale"]]]:
        '''grayscale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        '''
        result = self._values.get("grayscale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultGrayscale"]]], result)

    @builtins.property
    def hsl(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultHsl"]]]:
        '''hsl block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        '''
        result = self._values.get("hsl")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultHsl"]]], result)

    @builtins.property
    def hsv(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultHsv"]]]:
        '''hsv block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        '''
        result = self._values.get("hsv")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultHsv"]]], result)

    @builtins.property
    def if_dimension(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfDimension"]]]:
        '''if_dimension block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        '''
        result = self._values.get("if_dimension")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfDimension"]]], result)

    @builtins.property
    def if_orientation(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfOrientation"]]]:
        '''if_orientation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        '''
        result = self._values.get("if_orientation")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfOrientation"]]], result)

    @builtins.property
    def max_colors(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultMaxColors"]]]:
        '''max_colors block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        '''
        result = self._values.get("max_colors")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultMaxColors"]]], result)

    @builtins.property
    def mirror(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultMirror"]]]:
        '''mirror block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        '''
        result = self._values.get("mirror")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultMirror"]]], result)

    @builtins.property
    def mono_hue(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultMonoHue"]]]:
        '''mono_hue block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        '''
        result = self._values.get("mono_hue")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultMonoHue"]]], result)

    @builtins.property
    def opacity(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultOpacity"]]]:
        '''opacity block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultOpacity"]]], result)

    @builtins.property
    def remove_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultRemoveColor"]]]:
        '''remove_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        '''
        result = self._values.get("remove_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultRemoveColor"]]], result)

    @builtins.property
    def unsharp_mask(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultUnsharpMask"]]]:
        '''unsharp_mask block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        result = self._values.get("unsharp_mask")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultUnsharpMask"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultBackgroundColor",
    jsii_struct_bases=[],
    name_mapping={"color": "color", "color_var": "colorVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultBackgroundColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__54362789079a10fc385e027e306aa2d3f19bf5f13566e21f6a25059a084e8220)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultBackgroundColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultBackgroundColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultBackgroundColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c1e3eef8846db725e63870fc142593dc96ef69543f1b46f9f139bb352845da2c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultBackgroundColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__367bdc231deccc06838415e5e0f4635d5019ea800a0daae326a53ac30f313727)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultBackgroundColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2b803b5a582cd90a101a5cae4efc3f2de2a8dbd87ab300971ce9f8d59ef4cb8c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__479409048d4541965045e75ab7039cbde8ee4e04cbd92c448f5302646df97100)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0e3514181cd20e1a4d56ccda7950ee4f665c60da7b62c9faf107076eb037513e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultBackgroundColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultBackgroundColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d96f77175ee87d31e271ea162de2223078a9251844aa8484ac98dd06a9e8565)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultBackgroundColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultBackgroundColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8e1d56131009599b8029095c42cc4ce51fce74835c75359c0235cc818aacb4e1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2b61bb4d2bea6b55c1677fbab9b18e8d9ea4827d411569babb3e34ba6c8cb2e8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8148925a5e68b5e0b85621659ac24842feb2db001754f99610a0dec011fb236b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultBackgroundColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultBackgroundColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultBackgroundColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__20184e89cf395229ff8220d80bf72d761ccc7dafc9547b21b0b22337dd67145a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultBlur",
    jsii_struct_bases=[],
    name_mapping={"sigma": "sigma", "sigma_var": "sigmaVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultBlur:
    def __init__(
        self,
        *,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param sigma: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8229beeb47cc2f69b10cc05701317bde6211c2d768bfe3876170b11e2edf2e0b)
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultBlur(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultBlurList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultBlurList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c40cc37377a65cdc1140fcb7f091d46cb3df6f8d1907b2019a17060d05b82355)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultBlurOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8610478af442f0d5fd2d3c766950c7d29c1ec6961f955fa8e697258df818d6af)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultBlurOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__30a71ea94cef95b179dc7abda1545a5265a2c0b68dd7306d35c3dc50c111b44b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c3ac4bd9584c61bdeb20efe3f02f8bfa96819c7945046f6d5da0caca97fe9dad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ebdb87377dfeebf02c08b87b81632ad0a6aaf8ef7ea8468cf4f40f9dcbf63fb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultBlur]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultBlur]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ffcf094431252c1de890e7942a3f10af3f0730e9c804a175fedc3c4f0ee0428)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultBlurOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultBlurOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0eaba432eaad7079e10e3481840ec53882927c1d8ca21a73713f615ad746c48a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0d32a894c72f0926afad68897f39fc8176afd9d363a8b98d6adccf6d0613e616)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d46ccef751d84e2db9f700fb64b654c4b1115f72fa54f111c0172f3f3f3c857f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultBlur]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultBlur]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultBlur]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ed9bb70af86f8526b6dd7dcc87e4196ca6b7876571b51af1452b223b2f44f24)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultChromaKey",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_feather": "hueFeather",
        "hue_feather_var": "hueFeatherVar",
        "hue_tolerance": "hueTolerance",
        "hue_tolerance_var": "hueToleranceVar",
        "hue_var": "hueVar",
        "lightness_feather": "lightnessFeather",
        "lightness_feather_var": "lightnessFeatherVar",
        "lightness_tolerance": "lightnessTolerance",
        "lightness_tolerance_var": "lightnessToleranceVar",
        "saturation_feather": "saturationFeather",
        "saturation_feather_var": "saturationFeatherVar",
        "saturation_tolerance": "saturationTolerance",
        "saturation_tolerance_var": "saturationToleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultChromaKey:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_feather: typing.Optional[builtins.str] = None,
        hue_feather_var: typing.Optional[builtins.str] = None,
        hue_tolerance: typing.Optional[builtins.str] = None,
        hue_tolerance_var: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness_feather: typing.Optional[builtins.str] = None,
        lightness_feather_var: typing.Optional[builtins.str] = None,
        lightness_tolerance: typing.Optional[builtins.str] = None,
        lightness_tolerance_var: typing.Optional[builtins.str] = None,
        saturation_feather: typing.Optional[builtins.str] = None,
        saturation_feather_var: typing.Optional[builtins.str] = None,
        saturation_tolerance: typing.Optional[builtins.str] = None,
        saturation_tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_feather: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        :param hue_feather_var: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        :param hue_tolerance: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        :param hue_tolerance_var: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        :param hue_var: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness_feather: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        :param lightness_feather_var: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        :param lightness_tolerance: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        :param lightness_tolerance_var: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        :param saturation_feather: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        :param saturation_feather_var: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        :param saturation_tolerance: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        :param saturation_tolerance_var: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__948b1c864d0c23af3e4650622481314f2715b51d78b86766c9b43550229e722c)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_feather", value=hue_feather, expected_type=type_hints["hue_feather"])
            check_type(argname="argument hue_feather_var", value=hue_feather_var, expected_type=type_hints["hue_feather_var"])
            check_type(argname="argument hue_tolerance", value=hue_tolerance, expected_type=type_hints["hue_tolerance"])
            check_type(argname="argument hue_tolerance_var", value=hue_tolerance_var, expected_type=type_hints["hue_tolerance_var"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness_feather", value=lightness_feather, expected_type=type_hints["lightness_feather"])
            check_type(argname="argument lightness_feather_var", value=lightness_feather_var, expected_type=type_hints["lightness_feather_var"])
            check_type(argname="argument lightness_tolerance", value=lightness_tolerance, expected_type=type_hints["lightness_tolerance"])
            check_type(argname="argument lightness_tolerance_var", value=lightness_tolerance_var, expected_type=type_hints["lightness_tolerance_var"])
            check_type(argname="argument saturation_feather", value=saturation_feather, expected_type=type_hints["saturation_feather"])
            check_type(argname="argument saturation_feather_var", value=saturation_feather_var, expected_type=type_hints["saturation_feather_var"])
            check_type(argname="argument saturation_tolerance", value=saturation_tolerance, expected_type=type_hints["saturation_tolerance"])
            check_type(argname="argument saturation_tolerance_var", value=saturation_tolerance_var, expected_type=type_hints["saturation_tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_feather is not None:
            self._values["hue_feather"] = hue_feather
        if hue_feather_var is not None:
            self._values["hue_feather_var"] = hue_feather_var
        if hue_tolerance is not None:
            self._values["hue_tolerance"] = hue_tolerance
        if hue_tolerance_var is not None:
            self._values["hue_tolerance_var"] = hue_tolerance_var
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness_feather is not None:
            self._values["lightness_feather"] = lightness_feather
        if lightness_feather_var is not None:
            self._values["lightness_feather_var"] = lightness_feather_var
        if lightness_tolerance is not None:
            self._values["lightness_tolerance"] = lightness_tolerance
        if lightness_tolerance_var is not None:
            self._values["lightness_tolerance_var"] = lightness_tolerance_var
        if saturation_feather is not None:
            self._values["saturation_feather"] = saturation_feather
        if saturation_feather_var is not None:
            self._values["saturation_feather_var"] = saturation_feather_var
        if saturation_tolerance is not None:
            self._values["saturation_tolerance"] = saturation_tolerance
        if saturation_tolerance_var is not None:
            self._values["saturation_tolerance_var"] = saturation_tolerance_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        '''
        result = self._values.get("hue_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        '''
        result = self._values.get("hue_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        '''
        result = self._values.get("hue_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        '''
        result = self._values.get("hue_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        '''
        result = self._values.get("lightness_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        '''
        result = self._values.get("lightness_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        '''
        result = self._values.get("lightness_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        '''
        result = self._values.get("lightness_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        '''
        result = self._values.get("saturation_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        '''
        result = self._values.get("saturation_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        '''
        result = self._values.get("saturation_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        result = self._values.get("saturation_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultChromaKey(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultChromaKeyList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultChromaKeyList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ca608809f62519f723441ccc54301309f5c8532ff9926b50b67a18f8ce01000)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultChromaKeyOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__290912e1cff16471922573d47c2faf21a3baad83d4e90d034c91a6cbe2e72a86)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultChromaKeyOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7f5a1925e24cb9f684cbf20bfebbf7e8a0c802f809c6360173ae883930c41e99)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9726aa5f20ba37b4e5f0abe10b17c306732c13e1a8bc1e1e74a514592a495ea5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7cd608ed493a1d3d219296573e86a1295de4581b418e74fb8827b11e1ca95cf4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultChromaKey]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultChromaKey]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__944d42e594a795799e6afb753c1f4af5be31097df31f1616b7c46c82806acd42)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultChromaKeyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultChromaKeyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__17a5502232221485023b5a236b47585a71da217bf0fd8abdc8f93c13237337f6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueFeather")
    def reset_hue_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeather", []))

    @jsii.member(jsii_name="resetHueFeatherVar")
    def reset_hue_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeatherVar", []))

    @jsii.member(jsii_name="resetHueTolerance")
    def reset_hue_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueTolerance", []))

    @jsii.member(jsii_name="resetHueToleranceVar")
    def reset_hue_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueToleranceVar", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightnessFeather")
    def reset_lightness_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeather", []))

    @jsii.member(jsii_name="resetLightnessFeatherVar")
    def reset_lightness_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeatherVar", []))

    @jsii.member(jsii_name="resetLightnessTolerance")
    def reset_lightness_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessTolerance", []))

    @jsii.member(jsii_name="resetLightnessToleranceVar")
    def reset_lightness_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessToleranceVar", []))

    @jsii.member(jsii_name="resetSaturationFeather")
    def reset_saturation_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeather", []))

    @jsii.member(jsii_name="resetSaturationFeatherVar")
    def reset_saturation_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeatherVar", []))

    @jsii.member(jsii_name="resetSaturationTolerance")
    def reset_saturation_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationTolerance", []))

    @jsii.member(jsii_name="resetSaturationToleranceVar")
    def reset_saturation_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherInput")
    def hue_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVarInput")
    def hue_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceInput")
    def hue_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVarInput")
    def hue_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherInput")
    def lightness_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVarInput")
    def lightness_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceInput")
    def lightness_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVarInput")
    def lightness_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherInput")
    def saturation_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVarInput")
    def saturation_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceInput")
    def saturation_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVarInput")
    def saturation_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4563256cae25d6ce8749021f0ddfe9d594a63f30f78993b34d51dbb76309238f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeather")
    def hue_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeather"))

    @hue_feather.setter
    def hue_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7b8852217a040822472d60f59b5cd49ef1bd2781aaebe20d54caaae0931af612)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeather", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVar")
    def hue_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeatherVar"))

    @hue_feather_var.setter
    def hue_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5d6340ac761af58caee587ae9137543a72ff1268fee8162566e6802a9eaebdac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueTolerance")
    def hue_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueTolerance"))

    @hue_tolerance.setter
    def hue_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4e6fc134216b9c442c45f8bea3d50e1352c32aaf84208c82c84ec5bb5ee5a2a1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVar")
    def hue_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueToleranceVar"))

    @hue_tolerance_var.setter
    def hue_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fbcd5e7eab21eb9ef818b92a5f75b8da4aea2d8d0ef9ec31a9652d64170a9e32)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__59777fa5d9f4ed790ad2412e610f009aab6633687aa47c3cd9e32c8409a45f3f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeather")
    def lightness_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeather"))

    @lightness_feather.setter
    def lightness_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__59b78cc1e599bcfbcf7e45b1700a1efa1615ae9c3308d056dad67e7e2fc5b0fa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeather", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVar")
    def lightness_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeatherVar"))

    @lightness_feather_var.setter
    def lightness_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8830751d0bf6659e8e2c73ae12229fca3bf8c1e2af36cf2266e59dd3a3948fd9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessTolerance")
    def lightness_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessTolerance"))

    @lightness_tolerance.setter
    def lightness_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__33be4eda34864306f94946de105c46a266e886524e3a8e85dc8acc5b830189d6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVar")
    def lightness_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessToleranceVar"))

    @lightness_tolerance_var.setter
    def lightness_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7ac26895c03bdf19aa412989deadbe8bdd31f2cfb516e5e604060bf0cc6eb3d7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeather")
    def saturation_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeather"))

    @saturation_feather.setter
    def saturation_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__031c8ba264dbbf52598e4af94d6fed263fb293f3e8b2b868f6c0b36363a6639d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeather", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVar")
    def saturation_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeatherVar"))

    @saturation_feather_var.setter
    def saturation_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__57582da4e28f2781b51bc430f99f00d47defbf168f72f39e29b57de3895b6b4e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationTolerance")
    def saturation_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationTolerance"))

    @saturation_tolerance.setter
    def saturation_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__edd6dc418b628dd9607dbda7aaf68da17c2939c5260d0cd5f0e7f58cbf43f343)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVar")
    def saturation_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationToleranceVar"))

    @saturation_tolerance_var.setter
    def saturation_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ad672b64511d1303cbfb2957b2f2d1f18a743552acabd74735fdfbbec29b9b3d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultChromaKey]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultChromaKey]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultChromaKey]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__94872793678ea13721f7ec61080396db4e60670adb7414471f0f1a658fec3102)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultComposite",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "placement": "placement",
        "placement_var": "placementVar",
        "scale": "scale",
        "scale_dimension": "scaleDimension",
        "scale_dimension_var": "scaleDimensionVar",
        "scale_var": "scaleVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultComposite:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultCompositeImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        placement: typing.Optional[builtins.str] = None,
        placement_var: typing.Optional[builtins.str] = None,
        scale: typing.Optional[builtins.str] = None,
        scale_dimension: typing.Optional[builtins.str] = None,
        scale_dimension_var: typing.Optional[builtins.str] = None,
        scale_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param placement: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        :param placement_var: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        :param scale: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param scale_dimension: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        :param scale_dimension_var: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        :param scale_var: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        :param x_position: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultCompositeImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__db91937991bd7805893ee80ef0bbc5cc7e03bd80bf7183125c4fb0d78d65f5cf)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument placement", value=placement, expected_type=type_hints["placement"])
            check_type(argname="argument placement_var", value=placement_var, expected_type=type_hints["placement_var"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument scale_dimension", value=scale_dimension, expected_type=type_hints["scale_dimension"])
            check_type(argname="argument scale_dimension_var", value=scale_dimension_var, expected_type=type_hints["scale_dimension_var"])
            check_type(argname="argument scale_var", value=scale_var, expected_type=type_hints["scale_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if placement is not None:
            self._values["placement"] = placement
        if placement_var is not None:
            self._values["placement_var"] = placement_var
        if scale is not None:
            self._values["scale"] = scale
        if scale_dimension is not None:
            self._values["scale_dimension"] = scale_dimension
        if scale_dimension_var is not None:
            self._values["scale_dimension_var"] = scale_dimension_var
        if scale_var is not None:
            self._values["scale_var"] = scale_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultCompositeImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultCompositeImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        '''
        result = self._values.get("placement")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement_var(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        '''
        result = self._values.get("placement_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        '''
        result = self._values.get("scale_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        '''
        result = self._values.get("scale_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        '''
        result = self._values.get("scale_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultComposite(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultCompositeImage",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultCompositeImage:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultCompositeImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultCompositeImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultCompositeImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__11e0af7069c4362273f951336cf08aeab265cfa6b3c633108641616e6319970d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultCompositeImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultCompositeImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__963cfc1eb4a2bed8d2139605b0b887b94e8128ff7b9c03516da30c021b84a1c6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultCompositeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultCompositeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0f691af0b89970b7e779e4eb07dbe5e217457ac38b8adf77cb51f3d2170ac6c6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultCompositeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b14ea0c64e5f412c80caadbc37c8093b65a529e5f9049ef96cc91454856ad04e)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultCompositeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0f436868de4315b852fe0c1ee073d077047ad84f684e499c1c4de6b492b5a88d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c81b52ae750eff7de886b6ad81fc313a37cbe9cba7ae6761665287c8f6dffdb3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__73971ecc1a7b18eafff7f11476149f42ba64354feda1581078699b662301aa45)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultComposite]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultComposite]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__267bbc8401b84a8b8fcc12fe753c0eb346ab6720eadd8089c707ee879ac78d51)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultCompositeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultCompositeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cf6f1b6ef548373305948c71a677216b3e16ca3a452489fc5ebec6552ee5f456)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultCompositeImage()

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPlacement")
    def reset_placement(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacement", []))

    @jsii.member(jsii_name="resetPlacementVar")
    def reset_placement_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacementVar", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetScaleDimension")
    def reset_scale_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimension", []))

    @jsii.member(jsii_name="resetScaleDimensionVar")
    def reset_scale_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimensionVar", []))

    @jsii.member(jsii_name="resetScaleVar")
    def reset_scale_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultCompositeImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultCompositeImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultCompositeImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="placementInput")
    def placement_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementInput"))

    @builtins.property
    @jsii.member(jsii_name="placementVarInput")
    def placement_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionInput")
    def scale_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVarInput")
    def scale_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleVarInput")
    def scale_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ec21286aa7a49bb346672f376cf9a116334212bccdc3a4012eb46bec02c695c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__62f5c98ba1e32bd0f146025b6fa87efec7291b9182bce2337aff7bd0a0573e2e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="placement")
    def placement(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placement"))

    @placement.setter
    def placement(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9bbbba53575122d524c481a03b7741ac95b8afcad4e39bb98031ce82dafca94a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placement", value)

    @builtins.property
    @jsii.member(jsii_name="placementVar")
    def placement_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placementVar"))

    @placement_var.setter
    def placement_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a46ca1929465a2316152323c023cc0369b16b4fb6cb8ac69c26761948ccaed70)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placementVar", value)

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scale"))

    @scale.setter
    def scale(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4486cd873a2364155866d90e390646d6a18a78463d1cc3ddc1c3b972c35917d4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scale", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimension")
    def scale_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimension"))

    @scale_dimension.setter
    def scale_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__691973c7897450fee028b1498da548b2be64546a0b491593b0080dd1c9468e3c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimension", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVar")
    def scale_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimensionVar"))

    @scale_dimension_var.setter
    def scale_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a73e561792ad3667eb787afaa4558bed6a3067d40e66417c14b217613d5abc0b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="scaleVar")
    def scale_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleVar"))

    @scale_var.setter
    def scale_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f62c51f8ca5f9cfd0307896563fe258c3760062e52b3a42407c2d4215bf9aa42)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a69526d47a76e4251b89116be43ac3d925d35c81d977f40817c032cfd7adcf8c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0dc24c1b8e88a628fb5c5e59180001684834c3b9fad5a0ec3431ec3f1c1356b5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7c3d87a14361b1f52eb0fff38772b210c041177ff6670bd431865951e7669cca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eb40e8f36609e15c2fc16e3838b72a1023e1e188a617eccd63f48730210e4d02)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultComposite]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultComposite]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultComposite]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f8cf40e052685a49721eec397cbde001cbeae7c0b202b8810c20754b685eb5c8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultCompound",
    jsii_struct_bases=[],
    name_mapping={"transformations": "transformations"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultCompound:
    def __init__(
        self,
        *,
        transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param transformations: transformations block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fcd5f9b7b5d6d600ca26138db185bacf449a04c8b5ac1ad321f19ab9a2a89f14)
            check_type(argname="argument transformations", value=transformations, expected_type=type_hints["transformations"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if transformations is not None:
            self._values["transformations"] = transformations

    @builtins.property
    def transformations(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultCompoundTransformations"]]]:
        '''transformations block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        result = self._values.get("transformations")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultCompoundTransformations"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultCompound(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultCompoundList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultCompoundList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ec358436b6a57fd5bd8dc01b8244927f2d89248f927382c6cea1ecad83483476)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultCompoundOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ebd7b3cc92337f7aae00472cdc509a01508960ea0f5988db1378621d8ee55eeb)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultCompoundOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c799961220c4f2c6581ec37004159b997a2882de93257624a037095400e2d5f3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__448336181cc92ca867205b77d2b4fe5400d49118e4d6b01bde84051d39930554)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8abd5879a3e2ad6a956a88a854bdd7ec2faac9c6690213ab476177707d99155d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultCompound]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultCompound]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d09d5cc02e46986746725aeb339d73cc9285289a8105907319304afcd0727096)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultCompoundOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultCompoundOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b1ed884af5d2d011503e813dd64a1878756c606884ea489e9721cdd4170aa81b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformations")
    def put_transformations(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7871d6eaaf678a64a46cdfb9d4652b8fe8f930c03b463f46e85d5d315fecf366)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTransformations", [value]))

    @jsii.member(jsii_name="resetTransformations")
    def reset_transformations(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformations", []))

    @builtins.property
    @jsii.member(jsii_name="transformations")
    def transformations(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultCompoundTransformationsList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultCompoundTransformationsList", jsii.get(self, "transformations"))

    @builtins.property
    @jsii.member(jsii_name="transformationsInput")
    def transformations_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultCompoundTransformations"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultCompoundTransformations"]]], jsii.get(self, "transformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultCompound]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultCompound]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultCompound]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__61b2d4233e44e78608d96d85e463236f38b78801c55de379e588484fe2680cc1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultCompoundTransformations",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultCompoundTransformations:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultCompoundTransformations(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultCompoundTransformationsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultCompoundTransformationsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e318d5f7a228e53ce7615bad308504d49f749e0b099e38426529db7fb91822d2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultCompoundTransformationsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f2e5aaedfcd9313a0562b3c0aa05bf585b99d6c5c39be306d48cf6c2ca15df66)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultCompoundTransformationsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7e0d6c6778156bee20484b8a7c31a112e1860624cee2319f52e46b9a8cd0e7c7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e5f92ca9fc096a59f27c6a9a24d2ead67286a6a0638260e96bd9dfb0e1617a70)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__47fc2f5e061b22c14f544010ac12fdadcfc394016fabf861181c81240bf22496)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultCompoundTransformations]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultCompoundTransformations]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultCompoundTransformations]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__67b31782f71cee01bf8268fd4389b948acfad14b1d844afe0fba2611f02750be)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultCompoundTransformationsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultCompoundTransformationsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__67148b033f272886582a4a88621d8b60292c7ec6fff6cce98b35f496f068cd0b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultCompoundTransformations]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultCompoundTransformations]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultCompoundTransformations]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__658fd47a509585c5a5722da4c0793f838a1d231580d25b1422909614e7895708)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultContrast",
    jsii_struct_bases=[],
    name_mapping={
        "brightness": "brightness",
        "brightness_var": "brightnessVar",
        "contrast": "contrast",
        "contrast_var": "contrastVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultContrast:
    def __init__(
        self,
        *,
        brightness: typing.Optional[builtins.str] = None,
        brightness_var: typing.Optional[builtins.str] = None,
        contrast: typing.Optional[builtins.str] = None,
        contrast_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param brightness: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        :param brightness_var: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        :param contrast: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param contrast_var: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2b130c8b510302f2dd710bbd9f9f0d1857733a2c0c6487a957a9d384edd54bda)
            check_type(argname="argument brightness", value=brightness, expected_type=type_hints["brightness"])
            check_type(argname="argument brightness_var", value=brightness_var, expected_type=type_hints["brightness_var"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument contrast_var", value=contrast_var, expected_type=type_hints["contrast_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if brightness is not None:
            self._values["brightness"] = brightness
        if brightness_var is not None:
            self._values["brightness_var"] = brightness_var
        if contrast is not None:
            self._values["contrast"] = contrast
        if contrast_var is not None:
            self._values["contrast_var"] = contrast_var

    @builtins.property
    def brightness(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        '''
        result = self._values.get("brightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def brightness_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        '''
        result = self._values.get("brightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        result = self._values.get("contrast_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultContrast(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultContrastList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultContrastList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a8eb57d6f5255740b916a458a978db23d43b91e263bdd47f7df94d1592dc9ecc)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultContrastOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c1151843458ade6892646f0d900582d740c83618cc69cd07cc527b5385f2269c)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultContrastOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__62a37c42d45c3c3aa410745180ed85862c9ff1c84db0f997da1228df906a8c07)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7ff89b100725a66f971471d6e8e1102fb63281daecd79c6580e2a0930e791e0a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e393784a09e3b83310c5c5efe31127270d892afa33d5bacf3a092a17051f2afb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultContrast]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultContrast]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__73ab056de33dd0cf1a6fef4d7e7aad5ef53494290a5e14380efd847287a6a1fa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultContrastOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultContrastOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__04b681046143b1fad5145369786290cff58c02fccf708eaffe0ec12222ad4cff)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetBrightness")
    def reset_brightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightness", []))

    @jsii.member(jsii_name="resetBrightnessVar")
    def reset_brightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightnessVar", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetContrastVar")
    def reset_contrast_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrastVar", []))

    @builtins.property
    @jsii.member(jsii_name="brightnessInput")
    def brightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="brightnessVarInput")
    def brightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastVarInput")
    def contrast_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="brightness")
    def brightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightness"))

    @brightness.setter
    def brightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f5fd1b57e800438fd26d5a2fe0fd45396815401ec7b3f5bef90d544e34672d94)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightness", value)

    @builtins.property
    @jsii.member(jsii_name="brightnessVar")
    def brightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightnessVar"))

    @brightness_var.setter
    def brightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__081e50b3a64a8151b1130037d1edddaeef76ce4563d38a2e59683eb9b3f79228)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrast"))

    @contrast.setter
    def contrast(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1ee12634fefbe7acb2e4fc1d6c45fef376bd90da473e694573be89b5edbe934b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrast", value)

    @builtins.property
    @jsii.member(jsii_name="contrastVar")
    def contrast_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrastVar"))

    @contrast_var.setter
    def contrast_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fca627b7bf9176e813d630965c0aec5ec624b8b26a81c9cd5b603ed7e98831a5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrastVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultContrast]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultContrast]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultContrast]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5a6022002b5f5f705bc6ef971104cd810947dc0ccf2852f25caa693359e083d2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultGoop",
    jsii_struct_bases=[],
    name_mapping={
        "chaos": "chaos",
        "chaos_var": "chaosVar",
        "density": "density",
        "density_var": "densityVar",
        "power": "power",
        "power_var": "powerVar",
        "seed": "seed",
        "seed_var": "seedVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultGoop:
    def __init__(
        self,
        *,
        chaos: typing.Optional[builtins.str] = None,
        chaos_var: typing.Optional[builtins.str] = None,
        density: typing.Optional[builtins.str] = None,
        density_var: typing.Optional[builtins.str] = None,
        power: typing.Optional[builtins.str] = None,
        power_var: typing.Optional[builtins.str] = None,
        seed: typing.Optional[builtins.str] = None,
        seed_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param chaos: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        :param chaos_var: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        :param density: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        :param density_var: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        :param power: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        :param power_var: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        :param seed: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        :param seed_var: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ae40307957c0be64dc45b8bd81479b3aeace8022e65924b87bb69fcb85ec01be)
            check_type(argname="argument chaos", value=chaos, expected_type=type_hints["chaos"])
            check_type(argname="argument chaos_var", value=chaos_var, expected_type=type_hints["chaos_var"])
            check_type(argname="argument density", value=density, expected_type=type_hints["density"])
            check_type(argname="argument density_var", value=density_var, expected_type=type_hints["density_var"])
            check_type(argname="argument power", value=power, expected_type=type_hints["power"])
            check_type(argname="argument power_var", value=power_var, expected_type=type_hints["power_var"])
            check_type(argname="argument seed", value=seed, expected_type=type_hints["seed"])
            check_type(argname="argument seed_var", value=seed_var, expected_type=type_hints["seed_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if chaos is not None:
            self._values["chaos"] = chaos
        if chaos_var is not None:
            self._values["chaos_var"] = chaos_var
        if density is not None:
            self._values["density"] = density
        if density_var is not None:
            self._values["density_var"] = density_var
        if power is not None:
            self._values["power"] = power
        if power_var is not None:
            self._values["power_var"] = power_var
        if seed is not None:
            self._values["seed"] = seed
        if seed_var is not None:
            self._values["seed_var"] = seed_var

    @builtins.property
    def chaos(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        '''
        result = self._values.get("chaos")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def chaos_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        '''
        result = self._values.get("chaos_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        '''
        result = self._values.get("density")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density_var(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        '''
        result = self._values.get("density_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        '''
        result = self._values.get("power")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power_var(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        '''
        result = self._values.get("power_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        '''
        result = self._values.get("seed")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed_var(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        result = self._values.get("seed_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultGoop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultGoopList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultGoopList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5d12347b38792e4d7a0bba4f953316fdd178dd0a786e871e9d6b7bd05e047753)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultGoopOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0f145d97cc1f6fb7fc489e38fefb6d27b4f3c71bc72d38f41941c80b9ab43650)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultGoopOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0eaaa070216abe5f8952af8492d19e5464527bee58ad16ddebe04f9557dbb1c3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__61574a0ad34b7480bf1e0066fcd116d4ef98fc061d63b857c2017467746a6da9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b9afa5f8577632f710520ec3eb0efdfb4ac8f639ebe5f9a4c8552b990cec67d6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultGoop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultGoop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7869f9ca3230e8b36ab758a0220543d9338d12d9fa5d5873b98e078ca57036fd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultGoopOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultGoopOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__53a01837b71aaad5e7254d5cef7a5a1ae9168dba5a0e011afa44be4bcc427d2d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetChaos")
    def reset_chaos(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaos", []))

    @jsii.member(jsii_name="resetChaosVar")
    def reset_chaos_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaosVar", []))

    @jsii.member(jsii_name="resetDensity")
    def reset_density(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensity", []))

    @jsii.member(jsii_name="resetDensityVar")
    def reset_density_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensityVar", []))

    @jsii.member(jsii_name="resetPower")
    def reset_power(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPower", []))

    @jsii.member(jsii_name="resetPowerVar")
    def reset_power_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPowerVar", []))

    @jsii.member(jsii_name="resetSeed")
    def reset_seed(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeed", []))

    @jsii.member(jsii_name="resetSeedVar")
    def reset_seed_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeedVar", []))

    @builtins.property
    @jsii.member(jsii_name="chaosInput")
    def chaos_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosInput"))

    @builtins.property
    @jsii.member(jsii_name="chaosVarInput")
    def chaos_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosVarInput"))

    @builtins.property
    @jsii.member(jsii_name="densityInput")
    def density_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityInput"))

    @builtins.property
    @jsii.member(jsii_name="densityVarInput")
    def density_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="powerInput")
    def power_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerInput"))

    @builtins.property
    @jsii.member(jsii_name="powerVarInput")
    def power_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerVarInput"))

    @builtins.property
    @jsii.member(jsii_name="seedInput")
    def seed_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedInput"))

    @builtins.property
    @jsii.member(jsii_name="seedVarInput")
    def seed_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedVarInput"))

    @builtins.property
    @jsii.member(jsii_name="chaos")
    def chaos(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaos"))

    @chaos.setter
    def chaos(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6cf23203e1725362c88c3d06bbf8f60898085e45e251727364c80cb7815ca049)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaos", value)

    @builtins.property
    @jsii.member(jsii_name="chaosVar")
    def chaos_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaosVar"))

    @chaos_var.setter
    def chaos_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__84d441d1f27bbb68c2917318ae3eb25b3dc7b23c4550b796be9a80ea973d41d2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaosVar", value)

    @builtins.property
    @jsii.member(jsii_name="density")
    def density(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "density"))

    @density.setter
    def density(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__46c5469b2bd361ed1482db26fb99a6f1fddcc45b63363aad66040ed320961ff7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "density", value)

    @builtins.property
    @jsii.member(jsii_name="densityVar")
    def density_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "densityVar"))

    @density_var.setter
    def density_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c9a54d8377a30e9975ba3ce8a000f0b0c5ab7440c53eef34667459fc5e6de6ef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "densityVar", value)

    @builtins.property
    @jsii.member(jsii_name="power")
    def power(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "power"))

    @power.setter
    def power(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__548d7b21791a475cce65c7832850511f3e57f39a7b509d9dfa4b8d564b530cb5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "power", value)

    @builtins.property
    @jsii.member(jsii_name="powerVar")
    def power_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "powerVar"))

    @power_var.setter
    def power_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3153a2f6efcc93dd688e84c8824288b3da41bad33d2ca61ae982af9c0bc6170a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "powerVar", value)

    @builtins.property
    @jsii.member(jsii_name="seed")
    def seed(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seed"))

    @seed.setter
    def seed(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa3869c95cf32982cd76791d9e1520754e72d77971533c6738c85e3f24df82f4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seed", value)

    @builtins.property
    @jsii.member(jsii_name="seedVar")
    def seed_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seedVar"))

    @seed_var.setter
    def seed_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a411e0757ff0ed3f99062a717c7e517c577c5b864f6aec4130e013f02a7e09a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seedVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultGoop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultGoop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultGoop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2b0fc876583da55bc44ac371505a6b736a93fd6e5ae8a4445d0b948ac7395a78)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultGrayscale",
    jsii_struct_bases=[],
    name_mapping={"type": "type", "type_var": "typeVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultGrayscale:
    def __init__(
        self,
        *,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param type: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f380993ce4654d8e36f0cc9d9e2fd037e1d1f958be853080c976ca603665fa4c)
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultGrayscale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultGrayscaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultGrayscaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__62fcdd494cb37e5651d737144f3032aa2a78b1f48fc8473818fb09858c54a70c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultGrayscaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a8d708204021acee14e23f50956712b36773b1b5ba518a719d07568b411d612d)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultGrayscaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__730f727fe34de628e6109d3280e7435da119daf024f4a8c009bba2f1d9284fa3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1ab835efb862a3a079e798926b27f2c51aa6252462714bb863142e1e2cca9324)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__70477ace5fb1d2d9fec7c58ad62a12f3b2b4f02de5dd0ae10acfb09b2a6cfa4a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultGrayscale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultGrayscale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__619751c0a1a291ab69c735016131341017f92792d8d0601e6f71abfbe15ab656)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultGrayscaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultGrayscaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3d8bed9ef2c656bf6d2c9c69de8899eb607ce2457b2fbf22e63e43baa2f43693)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__49f01b5c4bb80c5f9ae0a435a5ebdbc10b1f86892c4a58897a8a54d478d0c184)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__283b0a04b42f9eb9aca02a4595e8cc99b1feea5eccaa99cf30fce3152a6e5af9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultGrayscale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultGrayscale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultGrayscale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__450a65ec0d8a1e9835457c993ab52d426fdfa921571ea6cef1402ddfeeaf77bd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultHsl",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "lightness": "lightness",
        "lightness_var": "lightnessVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultHsl:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness: typing.Optional[builtins.str] = None,
        lightness_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        :param lightness_var: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3e96c320c20c0ebcfe00acb90db1237a51c4e446644b5b6e5aa742ea0f9694cc)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness", value=lightness, expected_type=type_hints["lightness"])
            check_type(argname="argument lightness_var", value=lightness_var, expected_type=type_hints["lightness_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness is not None:
            self._values["lightness"] = lightness
        if lightness_var is not None:
            self._values["lightness_var"] = lightness_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        '''
        result = self._values.get("lightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        '''
        result = self._values.get("lightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultHsl(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultHslList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultHslList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f01c610f20488db8cde3b75946b7e110f8ba4dcdf2550db8bd75ddcdf4e09333)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultHslOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__27b753d95656c6a9fda861badc86a886d7e7fa508f73dec26a2a507fd038933e)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultHslOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b19d6c179d8d3ed2f2c5c029b47301f711aac9b9ee3502d8c608915ac5fc695f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f5deb5b06433524028b9689afbc17c6f74f9c7548a05ff52b449c28c9613053e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__883ddc05d128bf38a4b27d4520f71cc97f1cb5c2cf76b424b0a05ccaaba476b8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultHsl]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultHsl]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b4cbd8e2c7ac183b74abf5f4f049576d9787dcc42cd743683f19b7cb704aea0b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultHslOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultHslOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eb276042f709e1c9dcff30cf8bf81d1a895359b2d26de553c5a32c99a73f7855)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightness")
    def reset_lightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightness", []))

    @jsii.member(jsii_name="resetLightnessVar")
    def reset_lightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessInput")
    def lightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessVarInput")
    def lightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc1a6099b7437d6f8f5cb26c55dbe8b139db70850d43cd2fdbefd58715148ec6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__778a96099472d64e357b18e09e3e26c6562f99c572836b2d5566ab9f26a0869d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightness")
    def lightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightness"))

    @lightness.setter
    def lightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d81398cf1ebddd618b1df15122c4b68123c468d038314cfc793aa1563c6667d7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightness", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessVar")
    def lightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessVar"))

    @lightness_var.setter
    def lightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a0730e34ec04aa08b9a29788797f14cc38c68045b5eb0322c13c98700e327af)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__58f2e5e3b0cc466ddcd5a5b5e2c0290fa34cad1f10f85e1c9d04c8f913728b35)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8b3458fb308e57493734584cc1ea3458e76a0a04761875004704d0ebda179d8b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultHsl]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultHsl]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultHsl]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__79020a745d884074b5dcab69bfd9b096f9b8fff0f11daf88869d56f65cc7dbd7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultHsv",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultHsv:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        :param value: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__29982be246ae7689443f5b9db1c17bced369961df53a0808b5161c278dcb6e4d)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultHsv(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultHsvList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultHsvList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f7098e3154bf861cc38cb82bd3d3d23d3ae6ffcc638822097f96aeb85abc565c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultHsvOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ce2a4caeedaa63d8f3a0bff50e0d109f43b93fd3cef6e479454c0054cde9c85f)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultHsvOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9b05bcb0ea7c27be74c299ba31fd857a6a7f623d1a3fabfc579e7cd3173ba582)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f949274f290b9b4a2f31b825d36c3134c0ab6e2a269b653368b726131c716ae7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3db29378787be4d63fc6e40c356ddd7951de77356493a44601142dcb99a4b659)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultHsv]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultHsv]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a4811524855123373d753aad74bb7854352c79ee6e8d6e88bc1c4550d0c0dd34)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultHsvOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultHsvOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__770b9b6ef6899c8f90abf611e43310ba5fcf0afe3c7011a537336709d731bfa6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__61b981211c0ad9443e867cbd3a6d6a051a57fe1e79cbb26a3d9c14822c5a0735)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__987776a123431f51a43afb8128f1e2e96ce89c6b95a0ee96b54b47d0d11078f7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e6b05067bdfb2472734d6c4b5ce0a386d98895930aefa9b3b6d06598bf10ee74)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b007de7e1f9ba0e0ee4d430ce55ddbabdd1ab2b9e0568f233c1af9129230a8fe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__97b4e6dbbb71c9ca35286687e4e0f031e32dbcf438bde38d487eae65a58ecff6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3c48435d582c4fbaaaaf4c544dbb51f9e6f00b936dc896cfc9b82ea814f3c4f7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultHsv]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultHsv]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultHsv]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1c77f25d82db08477df8b218cc4150718dfa385df0ae2f750f375581140e80bb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfDimension",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "dimension": "dimension",
        "dimension_var": "dimensionVar",
        "equal": "equal",
        "greater_than": "greaterThan",
        "less_than": "lessThan",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfDimension:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfDimensionDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        dimension: typing.Optional[builtins.str] = None,
        dimension_var: typing.Optional[builtins.str] = None,
        equal: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfDimensionEqual", typing.Dict[builtins.str, typing.Any]]] = None,
        greater_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfDimensionGreaterThan", typing.Dict[builtins.str, typing.Any]]] = None,
        less_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfDimensionLessThan", typing.Dict[builtins.str, typing.Any]]] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param dimension: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        :param dimension_var: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        :param equal: equal block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        :param greater_than: greater_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        :param less_than: less_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        :param value: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfDimensionDefault(**default)
        if isinstance(equal, dict):
            equal = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfDimensionEqual(**equal)
        if isinstance(greater_than, dict):
            greater_than = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfDimensionGreaterThan(**greater_than)
        if isinstance(less_than, dict):
            less_than = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfDimensionLessThan(**less_than)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f41132ef443eba540608905f0158a34a68597826db8843e02940aed9a80fd8a)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument dimension", value=dimension, expected_type=type_hints["dimension"])
            check_type(argname="argument dimension_var", value=dimension_var, expected_type=type_hints["dimension_var"])
            check_type(argname="argument equal", value=equal, expected_type=type_hints["equal"])
            check_type(argname="argument greater_than", value=greater_than, expected_type=type_hints["greater_than"])
            check_type(argname="argument less_than", value=less_than, expected_type=type_hints["less_than"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if dimension is not None:
            self._values["dimension"] = dimension
        if dimension_var is not None:
            self._values["dimension_var"] = dimension_var
        if equal is not None:
            self._values["equal"] = equal
        if greater_than is not None:
            self._values["greater_than"] = greater_than
        if less_than is not None:
            self._values["less_than"] = less_than
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfDimensionDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfDimensionDefault"], result)

    @builtins.property
    def dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        '''
        result = self._values.get("dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        '''
        result = self._values.get("dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def equal(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfDimensionEqual"]:
        '''equal block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        '''
        result = self._values.get("equal")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfDimensionEqual"], result)

    @builtins.property
    def greater_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfDimensionGreaterThan"]:
        '''greater_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        '''
        result = self._values.get("greater_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfDimensionGreaterThan"], result)

    @builtins.property
    def less_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfDimensionLessThan"]:
        '''less_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        '''
        result = self._values.get("less_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfDimensionLessThan"], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfDimension(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfDimensionDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfDimensionDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfDimensionDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfDimensionDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfDimensionDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b793a71f97d95f0cfc3913907d1941d28a4ec21cc4742f88221ff8a6be3d060c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfDimensionDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfDimensionDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1118d71f69ec08d9a7af65e136b750d9d23daf7cfe73c21264ceb12d6001388d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfDimensionEqual",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfDimensionEqual:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfDimensionEqual(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfDimensionEqualOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfDimensionEqualOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1a032a7d519ca721dab405153ca219884a985bc3da89a30c37b438776ca20afd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfDimensionEqual], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfDimensionEqual],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__70738aa51b6cfbbbd6deca3b0e625d4f1f780ebc4107680947ed40e9ccd73f1a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfDimensionGreaterThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfDimensionGreaterThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfDimensionGreaterThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfDimensionGreaterThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfDimensionGreaterThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bd10ef5bca104f7d98ef7d565c253e429125b70852595a12a3e41dae779b15d5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfDimensionGreaterThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfDimensionGreaterThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7b77c91ca397929926ad15fd553d4cb75991da9d86944ed6dae54d7c5f641098)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfDimensionLessThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfDimensionLessThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfDimensionLessThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfDimensionLessThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfDimensionLessThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d43dbb18c4553ab0eaea9486161f2c2e898630b92e4282879558c843bcfebc6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfDimensionLessThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfDimensionLessThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3dc6b728638cf61be9881c15e213e6ad3649cf40a8de5e3edee47e40f88f418c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfDimensionList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfDimensionList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea3d7db9971fe94cfb609f2000ee82eec8da095cc102f63e93d8b7c962905b01)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfDimensionOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d8ff43c71a2f6a95b8906f35644e8260a89242ca25df082466dc2af4d59cced)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfDimensionOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ca0602e4ae7995650a9e6333f554614ca029ba9009a0173d08dae078ba83209)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c884accee8edc8ded7d82e8bb7d5ccf1d4802175dce516ebd5388b9d01534dac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__232ef4f624c75790b8c53c20b1bfb166d9c7800352a757ddab0c2c84328425f2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfDimension]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfDimension]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9252424f5811da80ebe9f4848fd8fe2034a60fd02b60b033a7ff7f30d7e9c0cc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfDimensionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfDimensionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1373832baa79ac17d7fe2f8aba305166a5c6545559a28ec2fc3499e30bbc8485)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfDimensionDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putEqual")
    def put_equal(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfDimensionEqual()

        return typing.cast(None, jsii.invoke(self, "putEqual", [value]))

    @jsii.member(jsii_name="putGreaterThan")
    def put_greater_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfDimensionGreaterThan()

        return typing.cast(None, jsii.invoke(self, "putGreaterThan", [value]))

    @jsii.member(jsii_name="putLessThan")
    def put_less_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfDimensionLessThan()

        return typing.cast(None, jsii.invoke(self, "putLessThan", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetDimension")
    def reset_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimension", []))

    @jsii.member(jsii_name="resetDimensionVar")
    def reset_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimensionVar", []))

    @jsii.member(jsii_name="resetEqual")
    def reset_equal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEqual", []))

    @jsii.member(jsii_name="resetGreaterThan")
    def reset_greater_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGreaterThan", []))

    @jsii.member(jsii_name="resetLessThan")
    def reset_less_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLessThan", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfDimensionDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfDimensionDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="equal")
    def equal(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfDimensionEqualOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfDimensionEqualOutputReference, jsii.get(self, "equal"))

    @builtins.property
    @jsii.member(jsii_name="greaterThan")
    def greater_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfDimensionGreaterThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfDimensionGreaterThanOutputReference, jsii.get(self, "greaterThan"))

    @builtins.property
    @jsii.member(jsii_name="lessThan")
    def less_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfDimensionLessThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfDimensionLessThanOutputReference, jsii.get(self, "lessThan"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfDimensionDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionInput")
    def dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionVarInput")
    def dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="equalInput")
    def equal_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfDimensionEqual], jsii.get(self, "equalInput"))

    @builtins.property
    @jsii.member(jsii_name="greaterThanInput")
    def greater_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfDimensionGreaterThan], jsii.get(self, "greaterThanInput"))

    @builtins.property
    @jsii.member(jsii_name="lessThanInput")
    def less_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfDimensionLessThan], jsii.get(self, "lessThanInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="dimension")
    def dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimension"))

    @dimension.setter
    def dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5e7da3921d0b698e21eb24e42410f920b5306a59e91fde8611421505912c6a5d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimension", value)

    @builtins.property
    @jsii.member(jsii_name="dimensionVar")
    def dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimensionVar"))

    @dimension_var.setter
    def dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ae82506c260f34da5df5824e04494e2f3d73f73ab054a01d29f28b833b2fd00)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5148dd4af5995e9a3eac378cf7240e7fed0e2073b2a8846ca47bed1af9a2a538)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__556a0224453fa54b5653ef4bbd8497b86d5db324b1e0cc3c5e49b97a4af111f8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfDimension]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfDimension]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfDimension]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c7a4bf9125b36fc2862d98d0f8c58fc1ab10e3e68e88cae69a784752561639c4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfOrientation",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "landscape": "landscape",
        "portrait": "portrait",
        "square": "square",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfOrientation:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfOrientationDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        landscape: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfOrientationLandscape", typing.Dict[builtins.str, typing.Any]]] = None,
        portrait: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfOrientationPortrait", typing.Dict[builtins.str, typing.Any]]] = None,
        square: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfOrientationSquare", typing.Dict[builtins.str, typing.Any]]] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param landscape: landscape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        :param portrait: portrait block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        :param square: square block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfOrientationDefault(**default)
        if isinstance(landscape, dict):
            landscape = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfOrientationLandscape(**landscape)
        if isinstance(portrait, dict):
            portrait = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfOrientationPortrait(**portrait)
        if isinstance(square, dict):
            square = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfOrientationSquare(**square)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7ff2975a217e8f29af0008ae7ea90d3df0179cf6b1ee5c891ba5b2210681ac4a)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument landscape", value=landscape, expected_type=type_hints["landscape"])
            check_type(argname="argument portrait", value=portrait, expected_type=type_hints["portrait"])
            check_type(argname="argument square", value=square, expected_type=type_hints["square"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if landscape is not None:
            self._values["landscape"] = landscape
        if portrait is not None:
            self._values["portrait"] = portrait
        if square is not None:
            self._values["square"] = square

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfOrientationDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfOrientationDefault"], result)

    @builtins.property
    def landscape(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfOrientationLandscape"]:
        '''landscape block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        '''
        result = self._values.get("landscape")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfOrientationLandscape"], result)

    @builtins.property
    def portrait(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfOrientationPortrait"]:
        '''portrait block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        '''
        result = self._values.get("portrait")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfOrientationPortrait"], result)

    @builtins.property
    def square(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfOrientationSquare"]:
        '''square block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        result = self._values.get("square")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfOrientationSquare"], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfOrientation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfOrientationDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfOrientationDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfOrientationDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfOrientationDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfOrientationDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__587539e097b9738fb38af2a103899612686e22caff4e33b73824bd9c321b179d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfOrientationDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfOrientationDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be0b0db08f13a09d504846d369ee472ea9146db918ad4ea183b477251be9fda9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfOrientationLandscape",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfOrientationLandscape:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfOrientationLandscape(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfOrientationLandscapeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfOrientationLandscapeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__47b898319dfd7889f16b141ae4da56b5bdb3ec949bd6d8cb557799eea08987f8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfOrientationLandscape], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfOrientationLandscape],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__881205d38407106f62393ed6150f0b82f5ca305033b8ee53a79053abc6345599)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfOrientationList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfOrientationList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9df72537d6e8db7c53d83c06bbecbc618d55b8021b19adf70551622b2f5f79d0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfOrientationOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__661f786c06a3f313bd2534c19aa499415f6f4c069d78dc886901507ff698e98f)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfOrientationOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aa81fc1d0fbbc0d6d9cf306973541acc094d0e84ad3a0add6d85e29bc9e6e135)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__608ade6c8eb879e79dc2c2ef05b6457d194b2b50298b7cc0bd9aa295d0c64af2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__813baef2ab4ebc3e8593a2dad8ebe57e22a581b32c1123fb8e06bace14827357)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfOrientation]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfOrientation]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3305d17b04872fe5727c7a3bf91551ef0838c26c1f2033e634138e914f01a3b1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfOrientationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfOrientationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ef191c2fbc70c53e6f95c64f4c9dd7cda849d85c549179e96adaaf21d160e274)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfOrientationDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putLandscape")
    def put_landscape(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfOrientationLandscape()

        return typing.cast(None, jsii.invoke(self, "putLandscape", [value]))

    @jsii.member(jsii_name="putPortrait")
    def put_portrait(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfOrientationPortrait()

        return typing.cast(None, jsii.invoke(self, "putPortrait", [value]))

    @jsii.member(jsii_name="putSquare")
    def put_square(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfOrientationSquare()

        return typing.cast(None, jsii.invoke(self, "putSquare", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetLandscape")
    def reset_landscape(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLandscape", []))

    @jsii.member(jsii_name="resetPortrait")
    def reset_portrait(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPortrait", []))

    @jsii.member(jsii_name="resetSquare")
    def reset_square(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSquare", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfOrientationDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfOrientationDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="landscape")
    def landscape(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfOrientationLandscapeOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfOrientationLandscapeOutputReference, jsii.get(self, "landscape"))

    @builtins.property
    @jsii.member(jsii_name="portrait")
    def portrait(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfOrientationPortraitOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfOrientationPortraitOutputReference", jsii.get(self, "portrait"))

    @builtins.property
    @jsii.member(jsii_name="square")
    def square(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfOrientationSquareOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfOrientationSquareOutputReference", jsii.get(self, "square"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfOrientationDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="landscapeInput")
    def landscape_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfOrientationLandscape], jsii.get(self, "landscapeInput"))

    @builtins.property
    @jsii.member(jsii_name="portraitInput")
    def portrait_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfOrientationPortrait"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfOrientationPortrait"], jsii.get(self, "portraitInput"))

    @builtins.property
    @jsii.member(jsii_name="squareInput")
    def square_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfOrientationSquare"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfOrientationSquare"], jsii.get(self, "squareInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfOrientation]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfOrientation]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfOrientation]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4b5c1a8472fcaddde8f9f3b21d49a7923c2732f457516e125e0f0871e72e9f03)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfOrientationPortrait",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfOrientationPortrait:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfOrientationPortrait(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfOrientationPortraitOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfOrientationPortraitOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a90b479e23ef03ef265c05772ad6198f57914c619976359f56fb0b2029f6f77)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfOrientationPortrait]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfOrientationPortrait], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfOrientationPortrait],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cfda15fb9a80a87c1f22833720cb34dc751f2289355cdaed167ced2e69ff0cb0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfOrientationSquare",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfOrientationSquare:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfOrientationSquare(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfOrientationSquareOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfOrientationSquareOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a49442d17b1673e7810bab45bd444e3a8ac1eb1a58c4fa28a38fdd55344d3eb)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfOrientationSquare]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfOrientationSquare], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfOrientationSquare],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__391ea645cb6c98b392a780b9df01618481f3be8b7fbced86cf589fef5532cddb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultMaxColors",
    jsii_struct_bases=[],
    name_mapping={"colors": "colors", "colors_var": "colorsVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultMaxColors:
    def __init__(
        self,
        *,
        colors: typing.Optional[builtins.str] = None,
        colors_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param colors: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        :param colors_var: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__10096fd4f298cdbed6963a278aff07d986d16c4074862c5674d8901e57e0e157)
            check_type(argname="argument colors", value=colors, expected_type=type_hints["colors"])
            check_type(argname="argument colors_var", value=colors_var, expected_type=type_hints["colors_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if colors is not None:
            self._values["colors"] = colors
        if colors_var is not None:
            self._values["colors_var"] = colors_var

    @builtins.property
    def colors(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        '''
        result = self._values.get("colors")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def colors_var(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        result = self._values.get("colors_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultMaxColors(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultMaxColorsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultMaxColorsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__97c9e55c9327331f15a777cc250583c0d1b68d0ecba80c71f9f2d77d4fab0f8f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultMaxColorsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2b6c366ab0e52555d8ea45b036234c6cdf91c92db67b2fecf1c0757e01b157a6)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultMaxColorsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7839399583d49ce81d7a92b0a1909ffd1e68bd8f5685297ff7881d6a76d75432)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7f5e44100f8a08fb73fa85f71eedd0c36a9eac84cc0ee72d0769d8171ac5af7a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__77b57c1190d44c1237f5edce5e4f1d63f495065fe3d3e7fd1cf60785a0d4a188)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultMaxColors]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultMaxColors]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__12cda01744d10d727dd79610bc2b2cbf9a9b2a1416e87216a24a91b9f21996e2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultMaxColorsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultMaxColorsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__72b962dda4714b6bc5b4e2ff97772fab2aec13102bfc230e81fdcc15ded4f475)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColors")
    def reset_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColors", []))

    @jsii.member(jsii_name="resetColorsVar")
    def reset_colors_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorsVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorsInput")
    def colors_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsInput"))

    @builtins.property
    @jsii.member(jsii_name="colorsVarInput")
    def colors_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsVarInput"))

    @builtins.property
    @jsii.member(jsii_name="colors")
    def colors(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colors"))

    @colors.setter
    def colors(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d4e689afcaa6035ac8eb9ff115e689de475b20580b6e4f349ae6ae70de2ebc8d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colors", value)

    @builtins.property
    @jsii.member(jsii_name="colorsVar")
    def colors_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorsVar"))

    @colors_var.setter
    def colors_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d03489f9ba093f02d431af0866cf231abfcf9881d29ba2746309f897a7b22ba4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorsVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultMaxColors]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultMaxColors]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultMaxColors]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__59a14c35658e0d3b82d0a428f08d0b218f1c87bd94c9009e58d7cd1c2ba5ed9e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultMirror",
    jsii_struct_bases=[],
    name_mapping={
        "horizontal": "horizontal",
        "horizontal_var": "horizontalVar",
        "vertical": "vertical",
        "vertical_var": "verticalVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultMirror:
    def __init__(
        self,
        *,
        horizontal: typing.Optional[builtins.str] = None,
        horizontal_var: typing.Optional[builtins.str] = None,
        vertical: typing.Optional[builtins.str] = None,
        vertical_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param horizontal: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        :param horizontal_var: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        :param vertical: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        :param vertical_var: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__90518335a101f072ff06fdf9c78d73c59f33f345a699cb2bca72bc0c283156f3)
            check_type(argname="argument horizontal", value=horizontal, expected_type=type_hints["horizontal"])
            check_type(argname="argument horizontal_var", value=horizontal_var, expected_type=type_hints["horizontal_var"])
            check_type(argname="argument vertical", value=vertical, expected_type=type_hints["vertical"])
            check_type(argname="argument vertical_var", value=vertical_var, expected_type=type_hints["vertical_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if horizontal is not None:
            self._values["horizontal"] = horizontal
        if horizontal_var is not None:
            self._values["horizontal_var"] = horizontal_var
        if vertical is not None:
            self._values["vertical"] = vertical
        if vertical_var is not None:
            self._values["vertical_var"] = vertical_var

    @builtins.property
    def horizontal(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        '''
        result = self._values.get("horizontal")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def horizontal_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        '''
        result = self._values.get("horizontal_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        '''
        result = self._values.get("vertical")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        result = self._values.get("vertical_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultMirror(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultMirrorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultMirrorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4f8c61b66449c78337bdc8de64f8734d0a6d73512f8dfb9f1003dc9686e3f399)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultMirrorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__162319ef3557d889fea01f72cd4435787aa7efd0b9f2c363f8274204553fb6ea)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultMirrorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__20f746f11c089faefa029787b3be48487fc5b3acf1997744ff41b95cfc0f5df5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dcfd6880cdb808fe990e2ee5b3cd6dab899521880e4b438810c94c59e3135117)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8070d704bbd6451ffeecc68775a3b28baaa0acafde032563fc95ad40dcf9e02b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultMirror]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultMirror]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ac15a2383a3290087e1dda3723d6d7204696060c30232249181bfcc818ada0b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultMirrorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultMirrorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a87b8863c70f27326ad70da3ac6bedc0885bd17484a172eac2fc824e63816f0a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHorizontal")
    def reset_horizontal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontal", []))

    @jsii.member(jsii_name="resetHorizontalVar")
    def reset_horizontal_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontalVar", []))

    @jsii.member(jsii_name="resetVertical")
    def reset_vertical(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVertical", []))

    @jsii.member(jsii_name="resetVerticalVar")
    def reset_vertical_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVerticalVar", []))

    @builtins.property
    @jsii.member(jsii_name="horizontalInput")
    def horizontal_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontalVarInput")
    def horizontal_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalInput")
    def vertical_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalVarInput")
    def vertical_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontal")
    def horizontal(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontal"))

    @horizontal.setter
    def horizontal(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__297408093cfc87f35408c0fe3687693b27c2e19a6e96489cb8a8548d474983d5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontal", value)

    @builtins.property
    @jsii.member(jsii_name="horizontalVar")
    def horizontal_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontalVar"))

    @horizontal_var.setter
    def horizontal_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9fdefcc04459105638389745c839fcedde59029ebc68b71d7d5ae5ed4dbed708)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontalVar", value)

    @builtins.property
    @jsii.member(jsii_name="vertical")
    def vertical(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "vertical"))

    @vertical.setter
    def vertical(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__35572a2fe4b9eee9f979e0b102a838d09c337fe7226bfb53b57859ed069c65df)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "vertical", value)

    @builtins.property
    @jsii.member(jsii_name="verticalVar")
    def vertical_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "verticalVar"))

    @vertical_var.setter
    def vertical_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dd95747f176f4c9bfe188c46498a12c672d92baafe668a9ddfde79545e3b9cce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "verticalVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultMirror]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultMirror]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultMirror]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b67f34b846f852d5f7098d2dbce134e731ca535589500aeb68f82acac136add3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultMonoHue",
    jsii_struct_bases=[],
    name_mapping={"hue": "hue", "hue_var": "hueVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultMonoHue:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b8ca8e2808ff9ed5e5dd7199238fc94c03637c0794d497b9c639dc9bef4f5960)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultMonoHue(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultMonoHueList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultMonoHueList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ded1d8883855c543f50220596368ffb9a5dde448a30b7622af25e3a4de08b0d5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultMonoHueOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__25929aa2e29e6f4d6f47364f7dd69e7ae2bb4d2f4a18c6d2bd27761ea99a0ed8)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultMonoHueOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6a892437edc31ae2d38685b07a7fd46a49cd94a60b216b311f7bfbf0b968354b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2bea4471edd69d752178146f6004c4b702761cf0a776275daa1b543b0bd8dec7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6dc1f8885f29fea9d7430f213ac04ae840891dc22d4eb792138c3bf065afbd4b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultMonoHue]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultMonoHue]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ee38ae331e88a89eb9e93abfae4d087c6c9b35fd8c6985f90f26743e1fe56a0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultMonoHueOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultMonoHueOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__49c701103b1313024704df416b0d83a15bfc5470b47ae5af1e702796e910f475)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6a9a19738e39e318ebbb8c603fdbd3c4f6134cf9aae4b4e7d0383f3f616bf728)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__42f0c092cdac096d2a48a61c3b35f6fb077e60491cefd493976e543447d8a964)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultMonoHue]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultMonoHue]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultMonoHue]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b18363b4e1491bc775d4195cfb34e58c6b1abfbb320d9bc993cf9619c2389f77)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultOpacity",
    jsii_struct_bases=[],
    name_mapping={"opacity": "opacity", "opacity_var": "opacityVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultOpacity:
    def __init__(
        self,
        *,
        opacity: typing.Optional[builtins.str] = None,
        opacity_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param opacity: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param opacity_var: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c818503f719004a5441a5813087479a05ef1b4d4fce9823d0abe47dd37a2b136)
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument opacity_var", value=opacity_var, expected_type=type_hints["opacity_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if opacity is not None:
            self._values["opacity"] = opacity
        if opacity_var is not None:
            self._values["opacity_var"] = opacity_var

    @builtins.property
    def opacity(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def opacity_var(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        result = self._values.get("opacity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultOpacity(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultOpacityList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultOpacityList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ae3497e1b3651dbcc34e09a96943ab3b420f2dcbc51021ad56f6243b6f6a49d5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultOpacityOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cc719dfb54ca37d0e8afac2d0f85d52462dc0c97f4569a86683845995a0e537a)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultOpacityOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2f47cf50a1a8ebc45350d445f4fb0c2fc5c0fe57afc1f3bb16614c17927d2993)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__21b71400828a789c0f5423de6b5631380dfbd0729f958a3a884c74037bd4c1d6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a4c24d4cdb1646213c0f25706430e04685992de20b264293dfd78b19266c6b6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultOpacity]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultOpacity]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cf335d8f2b99c2b1e22d8358627397d2a2be49c63257bfe1adaef5a31163b9ae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultOpacityOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultOpacityOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__66609e30c4a062a7ae266db93660cd10cd6f8ae0733e7ba48b220d95ef98d129)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetOpacityVar")
    def reset_opacity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacityVar", []))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityVarInput")
    def opacity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacity"))

    @opacity.setter
    def opacity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6af82e1fce0490b85595954d3cff3a48a05e8b33c7bf51d6cb233e2de74823af)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacity", value)

    @builtins.property
    @jsii.member(jsii_name="opacityVar")
    def opacity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacityVar"))

    @opacity_var.setter
    def opacity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5b7d3d108fa615a2ef55942d39858ff1e1e80f23255b860b2ebdbe52ad17ce81)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacityVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultOpacity]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultOpacity]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultOpacity]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ade5aa94f282d2513922c0860aad01a422d44139912b7997581bf3f0b530a40)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8dd93561d1458bc72de249be1aef092ae7104f4bdda5be4d0f5fe6a4377b10fa)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putBackgroundColor")
    def put_background_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__41c14e0c50af74183409d6d397b9035e69e24a88864d3c2475346791d5736427)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBackgroundColor", [value]))

    @jsii.member(jsii_name="putBlur")
    def put_blur(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultBlur, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__61b47c8333e8cbf3e22b90e57fee8d82323cd8e9b4359fc36d4f0242fb4e8857)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBlur", [value]))

    @jsii.member(jsii_name="putChromaKey")
    def put_chroma_key(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultChromaKey, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__60b631948cbb2548bc88ae49324ad86e9107faab6685fbde5b64523dcc712161)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putChromaKey", [value]))

    @jsii.member(jsii_name="putComposite")
    def put_composite(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultComposite, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e57f37b17a2f42378500c84d1cd836ec75c649f826dcb1b09c80e756d43420b5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putComposite", [value]))

    @jsii.member(jsii_name="putCompound")
    def put_compound(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultCompound, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c20253e0310a15dec7c5c38f9d78ff19cd35726df04f5093709138adbfefdf1d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCompound", [value]))

    @jsii.member(jsii_name="putContrast")
    def put_contrast(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultContrast, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8d9b330fe3855a4edb2e95114b26f78e132b4632fd47a734421e7346b7bc3bcb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putContrast", [value]))

    @jsii.member(jsii_name="putGoop")
    def put_goop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultGoop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb637e4c7693efd7f4ca4873a4fbe181af91f23c14ef018682a8ff4c9afae8ce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGoop", [value]))

    @jsii.member(jsii_name="putGrayscale")
    def put_grayscale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultGrayscale, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f7bcdb7305160c5244e924cef9b2a8081d7bd55b3c9bdcfe9c5c848a11338a57)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGrayscale", [value]))

    @jsii.member(jsii_name="putHsl")
    def put_hsl(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultHsl, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1cf25dcadec20213acbef58a2f92bb600b73e51be73c020d6a89774b8319c69c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsl", [value]))

    @jsii.member(jsii_name="putHsv")
    def put_hsv(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultHsv, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b29dd83f9dfed69d1a89154dde3deb667e42394f69b1d30a5ce5119cf52ddca7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsv", [value]))

    @jsii.member(jsii_name="putIfDimension")
    def put_if_dimension(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfDimension, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__19b42e0780263ccc2a8e6254704f4a9e31bf722c03ce1e769269256bb460ed85)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfDimension", [value]))

    @jsii.member(jsii_name="putIfOrientation")
    def put_if_orientation(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__561006853a38939c01c9c38e6cfd0e0fdc1ad4ca3e07f84224b8fcbf0f071913)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfOrientation", [value]))

    @jsii.member(jsii_name="putMaxColors")
    def put_max_colors(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultMaxColors, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a056176415595e0ecfde80f7795c75b8266c1f29c7e16b86baccebeb57a4a3c9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMaxColors", [value]))

    @jsii.member(jsii_name="putMirror")
    def put_mirror(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultMirror, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dac30ed2639557cb87eb038b17ce9fa58da96ad68714ac486691cc6e47950e13)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMirror", [value]))

    @jsii.member(jsii_name="putMonoHue")
    def put_mono_hue(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultMonoHue, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__318abdd7e6caae76c9fa9bf8a40e77e8e0760dfcf3dbf4266e70c7a06dbfb390)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMonoHue", [value]))

    @jsii.member(jsii_name="putOpacity")
    def put_opacity(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultOpacity, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c8b3b5080a45fca14c09a301cec8ce399023a292343056b66f0fe93ac5dac53b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putOpacity", [value]))

    @jsii.member(jsii_name="putRemoveColor")
    def put_remove_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultRemoveColor", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0c8830a04288872cf4c23fc9da5e6583a463b3abbfce8d37131fc47381044cf3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRemoveColor", [value]))

    @jsii.member(jsii_name="putUnsharpMask")
    def put_unsharp_mask(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultUnsharpMask", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__582a94c4d04d46346fe4f4e1332c5666655b04f1ab6ccc2649ad479275fef03b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putUnsharpMask", [value]))

    @jsii.member(jsii_name="resetBackgroundColor")
    def reset_background_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBackgroundColor", []))

    @jsii.member(jsii_name="resetBlur")
    def reset_blur(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBlur", []))

    @jsii.member(jsii_name="resetChromaKey")
    def reset_chroma_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChromaKey", []))

    @jsii.member(jsii_name="resetComposite")
    def reset_composite(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetComposite", []))

    @jsii.member(jsii_name="resetCompound")
    def reset_compound(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCompound", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetGoop")
    def reset_goop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGoop", []))

    @jsii.member(jsii_name="resetGrayscale")
    def reset_grayscale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGrayscale", []))

    @jsii.member(jsii_name="resetHsl")
    def reset_hsl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsl", []))

    @jsii.member(jsii_name="resetHsv")
    def reset_hsv(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsv", []))

    @jsii.member(jsii_name="resetIfDimension")
    def reset_if_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfDimension", []))

    @jsii.member(jsii_name="resetIfOrientation")
    def reset_if_orientation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfOrientation", []))

    @jsii.member(jsii_name="resetMaxColors")
    def reset_max_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxColors", []))

    @jsii.member(jsii_name="resetMirror")
    def reset_mirror(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMirror", []))

    @jsii.member(jsii_name="resetMonoHue")
    def reset_mono_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonoHue", []))

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetRemoveColor")
    def reset_remove_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRemoveColor", []))

    @jsii.member(jsii_name="resetUnsharpMask")
    def reset_unsharp_mask(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUnsharpMask", []))

    @builtins.property
    @jsii.member(jsii_name="backgroundColor")
    def background_color(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultBackgroundColorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultBackgroundColorList, jsii.get(self, "backgroundColor"))

    @builtins.property
    @jsii.member(jsii_name="blur")
    def blur(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultBlurList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultBlurList, jsii.get(self, "blur"))

    @builtins.property
    @jsii.member(jsii_name="chromaKey")
    def chroma_key(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultChromaKeyList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultChromaKeyList, jsii.get(self, "chromaKey"))

    @builtins.property
    @jsii.member(jsii_name="composite")
    def composite(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultCompositeList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultCompositeList, jsii.get(self, "composite"))

    @builtins.property
    @jsii.member(jsii_name="compound")
    def compound(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultCompoundList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultCompoundList, jsii.get(self, "compound"))

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultContrastList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultContrastList, jsii.get(self, "contrast"))

    @builtins.property
    @jsii.member(jsii_name="goop")
    def goop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultGoopList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultGoopList, jsii.get(self, "goop"))

    @builtins.property
    @jsii.member(jsii_name="grayscale")
    def grayscale(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultGrayscaleList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultGrayscaleList, jsii.get(self, "grayscale"))

    @builtins.property
    @jsii.member(jsii_name="hsl")
    def hsl(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultHslList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultHslList, jsii.get(self, "hsl"))

    @builtins.property
    @jsii.member(jsii_name="hsv")
    def hsv(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultHsvList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultHsvList, jsii.get(self, "hsv"))

    @builtins.property
    @jsii.member(jsii_name="ifDimension")
    def if_dimension(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfDimensionList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfDimensionList, jsii.get(self, "ifDimension"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientation")
    def if_orientation(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfOrientationList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfOrientationList, jsii.get(self, "ifOrientation"))

    @builtins.property
    @jsii.member(jsii_name="maxColors")
    def max_colors(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultMaxColorsList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultMaxColorsList, jsii.get(self, "maxColors"))

    @builtins.property
    @jsii.member(jsii_name="mirror")
    def mirror(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultMirrorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultMirrorList, jsii.get(self, "mirror"))

    @builtins.property
    @jsii.member(jsii_name="monoHue")
    def mono_hue(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultMonoHueList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultMonoHueList, jsii.get(self, "monoHue"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultOpacityList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultOpacityList, jsii.get(self, "opacity"))

    @builtins.property
    @jsii.member(jsii_name="removeColor")
    def remove_color(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultRemoveColorList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultRemoveColorList", jsii.get(self, "removeColor"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMask")
    def unsharp_mask(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultUnsharpMaskList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultUnsharpMaskList", jsii.get(self, "unsharpMask"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColorInput")
    def background_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultBackgroundColor]]], jsii.get(self, "backgroundColorInput"))

    @builtins.property
    @jsii.member(jsii_name="blurInput")
    def blur_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultBlur]]], jsii.get(self, "blurInput"))

    @builtins.property
    @jsii.member(jsii_name="chromaKeyInput")
    def chroma_key_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultChromaKey]]], jsii.get(self, "chromaKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="compositeInput")
    def composite_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultComposite]]], jsii.get(self, "compositeInput"))

    @builtins.property
    @jsii.member(jsii_name="compoundInput")
    def compound_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultCompound]]], jsii.get(self, "compoundInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultContrast]]], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="goopInput")
    def goop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultGoop]]], jsii.get(self, "goopInput"))

    @builtins.property
    @jsii.member(jsii_name="grayscaleInput")
    def grayscale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultGrayscale]]], jsii.get(self, "grayscaleInput"))

    @builtins.property
    @jsii.member(jsii_name="hslInput")
    def hsl_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultHsl]]], jsii.get(self, "hslInput"))

    @builtins.property
    @jsii.member(jsii_name="hsvInput")
    def hsv_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultHsv]]], jsii.get(self, "hsvInput"))

    @builtins.property
    @jsii.member(jsii_name="ifDimensionInput")
    def if_dimension_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfDimension]]], jsii.get(self, "ifDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientationInput")
    def if_orientation_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfOrientation]]], jsii.get(self, "ifOrientationInput"))

    @builtins.property
    @jsii.member(jsii_name="maxColorsInput")
    def max_colors_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultMaxColors]]], jsii.get(self, "maxColorsInput"))

    @builtins.property
    @jsii.member(jsii_name="mirrorInput")
    def mirror_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultMirror]]], jsii.get(self, "mirrorInput"))

    @builtins.property
    @jsii.member(jsii_name="monoHueInput")
    def mono_hue_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultMonoHue]]], jsii.get(self, "monoHueInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultOpacity]]], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="removeColorInput")
    def remove_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultRemoveColor"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultRemoveColor"]]], jsii.get(self, "removeColorInput"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMaskInput")
    def unsharp_mask_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultUnsharpMask"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultUnsharpMask"]]], jsii.get(self, "unsharpMaskInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__375db144c27cfd1dcdcd71b8c57a81948d934cb0f93f4359592ebdabd22546d5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultRemoveColor",
    jsii_struct_bases=[],
    name_mapping={
        "color": "color",
        "color_var": "colorVar",
        "feather": "feather",
        "feather_var": "featherVar",
        "tolerance": "tolerance",
        "tolerance_var": "toleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultRemoveColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
        feather: typing.Optional[builtins.str] = None,
        feather_var: typing.Optional[builtins.str] = None,
        tolerance: typing.Optional[builtins.str] = None,
        tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        :param feather: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        :param feather_var: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        :param tolerance: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        :param tolerance_var: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__22bf5753842458369d7f0ff5f5b17d77bab08ce884d66659560cf23cc5454381)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
            check_type(argname="argument feather", value=feather, expected_type=type_hints["feather"])
            check_type(argname="argument feather_var", value=feather_var, expected_type=type_hints["feather_var"])
            check_type(argname="argument tolerance", value=tolerance, expected_type=type_hints["tolerance"])
            check_type(argname="argument tolerance_var", value=tolerance_var, expected_type=type_hints["tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var
        if feather is not None:
            self._values["feather"] = feather
        if feather_var is not None:
            self._values["feather_var"] = feather_var
        if tolerance is not None:
            self._values["tolerance"] = tolerance
        if tolerance_var is not None:
            self._values["tolerance_var"] = tolerance_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        '''
        result = self._values.get("feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather_var(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        '''
        result = self._values.get("feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        '''
        result = self._values.get("tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance_var(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        result = self._values.get("tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultRemoveColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultRemoveColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultRemoveColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__adf66352d63f142725b09df0d46bc5c29a1093aef7e975cdcfbecab4f3e6ca5f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultRemoveColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2034ce21bc6b66c9ffe4fd3c3981128f7664b9be6cf7e61ef7b76334f075f7e9)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultRemoveColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__48600d9338f1592b80dacd1b6fdc5dd4daac75994f0c8519b5b42a5174f936d0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d3d4659d1ff849ec130fe75786f04eba75e34794455b94b362df4d8c16336699)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__32b8fcaeebe5e70061290e9242dea2720f27ea9c8407c2f37c304fb49651c57e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultRemoveColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultRemoveColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultRemoveColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7c8a58591a8554896d43366553fcaa7c7b556b9d56bd1489d8dad8761bd2d61e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultRemoveColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultRemoveColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6fecc018846ae3cbc0532acb9e8dbd2ba9b1d523fa0fb86cf79ae65f9029eb15)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @jsii.member(jsii_name="resetFeather")
    def reset_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeather", []))

    @jsii.member(jsii_name="resetFeatherVar")
    def reset_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatherVar", []))

    @jsii.member(jsii_name="resetTolerance")
    def reset_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTolerance", []))

    @jsii.member(jsii_name="resetToleranceVar")
    def reset_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featherInput")
    def feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherInput"))

    @builtins.property
    @jsii.member(jsii_name="featherVarInput")
    def feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceInput")
    def tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceVarInput")
    def tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__318a2fcfdf012f6e242e53b59f22a6663abdb53fa43bbc2f5a45242f97d85766)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3f59960cd572ef01ce18e656e1a54f4f7902f91c70ca62e743514de5ee45daae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="feather")
    def feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "feather"))

    @feather.setter
    def feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__53bd24e80226ef66aaab6257bb97ea8f0422537be83b86f1bb48c71a9d4b73cc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "feather", value)

    @builtins.property
    @jsii.member(jsii_name="featherVar")
    def feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featherVar"))

    @feather_var.setter
    def feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5fa5580e1f182dd94628a111b96b7a7131471bf14ef852f91e201719ca412bdb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featherVar", value)

    @builtins.property
    @jsii.member(jsii_name="tolerance")
    def tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tolerance"))

    @tolerance.setter
    def tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cb03fa3f6d3c56dd166a462a36ff2b3ad8d6b02cd287eaaced90c4d7237936d2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tolerance", value)

    @builtins.property
    @jsii.member(jsii_name="toleranceVar")
    def tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "toleranceVar"))

    @tolerance_var.setter
    def tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__023e0d7dfc650ab31d161a78e4cc1d5d49e20140ae1568ecaf06ca684aa11b63)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "toleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultRemoveColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultRemoveColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultRemoveColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__57054c58c26eca01a343864be0d6bca1792a78272c822d3a4479d37511becc82)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultUnsharpMask",
    jsii_struct_bases=[],
    name_mapping={
        "gain": "gain",
        "gain_var": "gainVar",
        "sigma": "sigma",
        "sigma_var": "sigmaVar",
        "threshold": "threshold",
        "threshold_var": "thresholdVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultUnsharpMask:
    def __init__(
        self,
        *,
        gain: typing.Optional[builtins.str] = None,
        gain_var: typing.Optional[builtins.str] = None,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
        threshold: typing.Optional[builtins.str] = None,
        threshold_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param gain: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        :param gain_var: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        :param sigma: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        :param threshold: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        :param threshold_var: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5e10a922639234663c822868e279af2a14d90c410534f69af3edc85abbf3053d)
            check_type(argname="argument gain", value=gain, expected_type=type_hints["gain"])
            check_type(argname="argument gain_var", value=gain_var, expected_type=type_hints["gain_var"])
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
            check_type(argname="argument threshold", value=threshold, expected_type=type_hints["threshold"])
            check_type(argname="argument threshold_var", value=threshold_var, expected_type=type_hints["threshold_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if gain is not None:
            self._values["gain"] = gain
        if gain_var is not None:
            self._values["gain_var"] = gain_var
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var
        if threshold is not None:
            self._values["threshold"] = threshold
        if threshold_var is not None:
            self._values["threshold_var"] = threshold_var

    @builtins.property
    def gain(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        '''
        result = self._values.get("gain")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gain_var(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        '''
        result = self._values.get("gain_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        '''
        result = self._values.get("threshold")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold_var(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        result = self._values.get("threshold_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultUnsharpMask(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultUnsharpMaskList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultUnsharpMaskList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__25014995626339f81006668051a369bfed43eb7c409f3b52bba4363038b41e4c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultUnsharpMaskOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aee95ff319c4c0a792d722c88f76360aa7884e15f02e502ebc3a0e97f2bc2316)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultUnsharpMaskOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e1a6042bb46144f50cda0759fc3be3dac337d1ad21173dfe9f0c5d403b0b021a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e5b31938af7df49c23cd0953fc7816f963171bf342ea44790abd4f28984a8cb5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__72ebbffa05996929647749119015962f4b017b6c8e9e11956274208d762fc744)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultUnsharpMask]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultUnsharpMask]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultUnsharpMask]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e550524914e488a3eaa173f2c64684b6e87f5f462bf0b88cec4b5fab88afb4db)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultUnsharpMaskOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultUnsharpMaskOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fdb5d24684502cab5842c45e426a4a92477313d16a866b8027ccf5738a87311d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetGain")
    def reset_gain(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGain", []))

    @jsii.member(jsii_name="resetGainVar")
    def reset_gain_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGainVar", []))

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @jsii.member(jsii_name="resetThreshold")
    def reset_threshold(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThreshold", []))

    @jsii.member(jsii_name="resetThresholdVar")
    def reset_threshold_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThresholdVar", []))

    @builtins.property
    @jsii.member(jsii_name="gainInput")
    def gain_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainInput"))

    @builtins.property
    @jsii.member(jsii_name="gainVarInput")
    def gain_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdInput")
    def threshold_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdVarInput")
    def threshold_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gain")
    def gain(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gain"))

    @gain.setter
    def gain(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c06142965947d110de538402b05ce75ab19bb58f2d55f31376b2d13ad442814f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gain", value)

    @builtins.property
    @jsii.member(jsii_name="gainVar")
    def gain_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gainVar"))

    @gain_var.setter
    def gain_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bcba933c8ee9fcc96040b073e2a036ec04cb242a3523d7d1221aedaa01d90925)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gainVar", value)

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7de0e82b381dc15a0a7df723576783073a96c7f899d9f3f82baa5b69bba7e553)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__627bcfb3da71efd79f67ab2ddff5cc00b0139f8e317286918f4edae9ffa2327a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="threshold")
    def threshold(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "threshold"))

    @threshold.setter
    def threshold(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__62c27d532bc053b1b1f4758af062fe623ec70400b958dfce1b6bb11f20ebb74d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "threshold", value)

    @builtins.property
    @jsii.member(jsii_name="thresholdVar")
    def threshold_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "thresholdVar"))

    @threshold_var.setter
    def threshold_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8aba976153b9eb17ad5d7067f38f72381a03f0d063a348638183c03b6e349937)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "thresholdVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultUnsharpMask]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultUnsharpMask]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultUnsharpMask]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__66c087435d923f5a692ee0276aedf700feddc0a7afc50f903220cbf0293e0330)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqual",
    jsii_struct_bases=[],
    name_mapping={
        "background_color": "backgroundColor",
        "blur": "blur",
        "chroma_key": "chromaKey",
        "composite": "composite",
        "compound": "compound",
        "contrast": "contrast",
        "goop": "goop",
        "grayscale": "grayscale",
        "hsl": "hsl",
        "hsv": "hsv",
        "if_dimension": "ifDimension",
        "if_orientation": "ifOrientation",
        "max_colors": "maxColors",
        "mirror": "mirror",
        "mono_hue": "monoHue",
        "opacity": "opacity",
        "remove_color": "removeColor",
        "unsharp_mask": "unsharpMask",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqual:
    def __init__(
        self,
        *,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualBackgroundColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualBlur", typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualChromaKey", typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualComposite", typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualCompound", typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualContrast", typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualGoop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualGrayscale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualHsl", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualHsv", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfDimension", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfOrientation", typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualMaxColors", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualMirror", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualMonoHue", typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualOpacity", typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualRemoveColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualUnsharpMask", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8b18da53144e22782049a3bf0fa04975b8c13c137eb4229824e9d2f50cf682ef)
            check_type(argname="argument background_color", value=background_color, expected_type=type_hints["background_color"])
            check_type(argname="argument blur", value=blur, expected_type=type_hints["blur"])
            check_type(argname="argument chroma_key", value=chroma_key, expected_type=type_hints["chroma_key"])
            check_type(argname="argument composite", value=composite, expected_type=type_hints["composite"])
            check_type(argname="argument compound", value=compound, expected_type=type_hints["compound"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument goop", value=goop, expected_type=type_hints["goop"])
            check_type(argname="argument grayscale", value=grayscale, expected_type=type_hints["grayscale"])
            check_type(argname="argument hsl", value=hsl, expected_type=type_hints["hsl"])
            check_type(argname="argument hsv", value=hsv, expected_type=type_hints["hsv"])
            check_type(argname="argument if_dimension", value=if_dimension, expected_type=type_hints["if_dimension"])
            check_type(argname="argument if_orientation", value=if_orientation, expected_type=type_hints["if_orientation"])
            check_type(argname="argument max_colors", value=max_colors, expected_type=type_hints["max_colors"])
            check_type(argname="argument mirror", value=mirror, expected_type=type_hints["mirror"])
            check_type(argname="argument mono_hue", value=mono_hue, expected_type=type_hints["mono_hue"])
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument remove_color", value=remove_color, expected_type=type_hints["remove_color"])
            check_type(argname="argument unsharp_mask", value=unsharp_mask, expected_type=type_hints["unsharp_mask"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if background_color is not None:
            self._values["background_color"] = background_color
        if blur is not None:
            self._values["blur"] = blur
        if chroma_key is not None:
            self._values["chroma_key"] = chroma_key
        if composite is not None:
            self._values["composite"] = composite
        if compound is not None:
            self._values["compound"] = compound
        if contrast is not None:
            self._values["contrast"] = contrast
        if goop is not None:
            self._values["goop"] = goop
        if grayscale is not None:
            self._values["grayscale"] = grayscale
        if hsl is not None:
            self._values["hsl"] = hsl
        if hsv is not None:
            self._values["hsv"] = hsv
        if if_dimension is not None:
            self._values["if_dimension"] = if_dimension
        if if_orientation is not None:
            self._values["if_orientation"] = if_orientation
        if max_colors is not None:
            self._values["max_colors"] = max_colors
        if mirror is not None:
            self._values["mirror"] = mirror
        if mono_hue is not None:
            self._values["mono_hue"] = mono_hue
        if opacity is not None:
            self._values["opacity"] = opacity
        if remove_color is not None:
            self._values["remove_color"] = remove_color
        if unsharp_mask is not None:
            self._values["unsharp_mask"] = unsharp_mask

    @builtins.property
    def background_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualBackgroundColor"]]]:
        '''background_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        '''
        result = self._values.get("background_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualBackgroundColor"]]], result)

    @builtins.property
    def blur(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualBlur"]]]:
        '''blur block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        '''
        result = self._values.get("blur")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualBlur"]]], result)

    @builtins.property
    def chroma_key(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualChromaKey"]]]:
        '''chroma_key block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        '''
        result = self._values.get("chroma_key")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualChromaKey"]]], result)

    @builtins.property
    def composite(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualComposite"]]]:
        '''composite block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        '''
        result = self._values.get("composite")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualComposite"]]], result)

    @builtins.property
    def compound(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualCompound"]]]:
        '''compound block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        '''
        result = self._values.get("compound")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualCompound"]]], result)

    @builtins.property
    def contrast(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualContrast"]]]:
        '''contrast block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualContrast"]]], result)

    @builtins.property
    def goop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualGoop"]]]:
        '''goop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        '''
        result = self._values.get("goop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualGoop"]]], result)

    @builtins.property
    def grayscale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualGrayscale"]]]:
        '''grayscale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        '''
        result = self._values.get("grayscale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualGrayscale"]]], result)

    @builtins.property
    def hsl(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualHsl"]]]:
        '''hsl block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        '''
        result = self._values.get("hsl")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualHsl"]]], result)

    @builtins.property
    def hsv(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualHsv"]]]:
        '''hsv block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        '''
        result = self._values.get("hsv")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualHsv"]]], result)

    @builtins.property
    def if_dimension(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfDimension"]]]:
        '''if_dimension block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        '''
        result = self._values.get("if_dimension")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfDimension"]]], result)

    @builtins.property
    def if_orientation(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfOrientation"]]]:
        '''if_orientation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        '''
        result = self._values.get("if_orientation")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfOrientation"]]], result)

    @builtins.property
    def max_colors(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualMaxColors"]]]:
        '''max_colors block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        '''
        result = self._values.get("max_colors")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualMaxColors"]]], result)

    @builtins.property
    def mirror(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualMirror"]]]:
        '''mirror block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        '''
        result = self._values.get("mirror")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualMirror"]]], result)

    @builtins.property
    def mono_hue(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualMonoHue"]]]:
        '''mono_hue block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        '''
        result = self._values.get("mono_hue")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualMonoHue"]]], result)

    @builtins.property
    def opacity(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualOpacity"]]]:
        '''opacity block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualOpacity"]]], result)

    @builtins.property
    def remove_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualRemoveColor"]]]:
        '''remove_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        '''
        result = self._values.get("remove_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualRemoveColor"]]], result)

    @builtins.property
    def unsharp_mask(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualUnsharpMask"]]]:
        '''unsharp_mask block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        result = self._values.get("unsharp_mask")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualUnsharpMask"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqual(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualBackgroundColor",
    jsii_struct_bases=[],
    name_mapping={"color": "color", "color_var": "colorVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualBackgroundColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6d4f0743e910520263edfc55f5b6c1d73517a57877cfd36c119aa631bca411b0)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualBackgroundColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualBackgroundColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualBackgroundColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0a3d1f0f5c9f326777fb7c39d498af1e4b0f48b030cbc9bad3b4864941c92126)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualBackgroundColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a441157b1d35aa2007af57f4e157977d6aa437662acb52788b1699b8b431e001)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualBackgroundColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e6cb033ceef17a5b35a7325aa3221c75149589758c98f733e78e0888f92fda5b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d25b6082f684627775c53c72ec00e99b5334eac6b033a8e95c22532c05eec87e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__91c840483733ffa8b66061c7da4d570b1ee52de29fc9ab5d41ea9622932a42c3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualBackgroundColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualBackgroundColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eb675f6dc3ee570a658b5c98bd81e1587b40d7d5ee399c82e8e2a4e17de1c82c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualBackgroundColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualBackgroundColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ecb59e0ef96baa204aedb9c0fbbad2d3c3ed9341443847e466c19aaa750fdf04)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__17e2f760ea21209582a9b402ff80d306e05554a29a7509a9d8d783c34ba2638d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__86b753b42ba05b4b67a1a0a88e98ab1fef5c56303b0e43ceb417977c8b80e648)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualBackgroundColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualBackgroundColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualBackgroundColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__603739c4737d26d6d589f564d34321a333db522cbf1303fd6537cbb1c7f41383)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualBlur",
    jsii_struct_bases=[],
    name_mapping={"sigma": "sigma", "sigma_var": "sigmaVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualBlur:
    def __init__(
        self,
        *,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param sigma: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c6eaf61f2ff9d83e6e05edcfc7c80d7446fb449253e4a096f3cac607b7a89533)
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualBlur(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualBlurList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualBlurList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a900e711cc3e993e02c7c3b64d30c2ce4d3994d3cc0a543d0e0d84116c72559)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualBlurOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bdbaf96b6a8904a7b32d0291a2c8f38cb40d68f69b59811c1edae9685eecc329)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualBlurOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0c0848600270e567c373e733836d49d7f547eae64c80f1495a46d71da6ca458b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__383a7d5833f450245abd6023a48b7c5b5f2cd2e185ee99d030364a3b38bcc617)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b0491658467d80f00a6d801a9ef2de1197e08674a664c62c6633d2098c8d03e1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualBlur]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualBlur]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d47deff31a0e432b0ff190009abc2d1797c8d4d4c694689498773166a838bad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualBlurOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualBlurOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__93218bc1e69cf07e6322f3ca33f1ee3a146fdb32a0fcff208bcb3a43f2875ed7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__448c45700627867b7240b4536357b48b6b8a61fe9bb15929e2beb6e2c7c923f2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8210442a7a8a24cf0b036c64d56c727dbd1ef464bd4c110bff29498ec3c03b6f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualBlur]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualBlur]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualBlur]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__270a1bda1b771e62389df58d8cef772ea7216019a4b494c8e3b0f96d9d9562da)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualChromaKey",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_feather": "hueFeather",
        "hue_feather_var": "hueFeatherVar",
        "hue_tolerance": "hueTolerance",
        "hue_tolerance_var": "hueToleranceVar",
        "hue_var": "hueVar",
        "lightness_feather": "lightnessFeather",
        "lightness_feather_var": "lightnessFeatherVar",
        "lightness_tolerance": "lightnessTolerance",
        "lightness_tolerance_var": "lightnessToleranceVar",
        "saturation_feather": "saturationFeather",
        "saturation_feather_var": "saturationFeatherVar",
        "saturation_tolerance": "saturationTolerance",
        "saturation_tolerance_var": "saturationToleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualChromaKey:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_feather: typing.Optional[builtins.str] = None,
        hue_feather_var: typing.Optional[builtins.str] = None,
        hue_tolerance: typing.Optional[builtins.str] = None,
        hue_tolerance_var: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness_feather: typing.Optional[builtins.str] = None,
        lightness_feather_var: typing.Optional[builtins.str] = None,
        lightness_tolerance: typing.Optional[builtins.str] = None,
        lightness_tolerance_var: typing.Optional[builtins.str] = None,
        saturation_feather: typing.Optional[builtins.str] = None,
        saturation_feather_var: typing.Optional[builtins.str] = None,
        saturation_tolerance: typing.Optional[builtins.str] = None,
        saturation_tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_feather: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        :param hue_feather_var: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        :param hue_tolerance: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        :param hue_tolerance_var: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        :param hue_var: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness_feather: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        :param lightness_feather_var: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        :param lightness_tolerance: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        :param lightness_tolerance_var: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        :param saturation_feather: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        :param saturation_feather_var: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        :param saturation_tolerance: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        :param saturation_tolerance_var: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b6f40f48ddb64d03819253da0bd8677b0356eab73d918bec80d4e6ff123fb303)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_feather", value=hue_feather, expected_type=type_hints["hue_feather"])
            check_type(argname="argument hue_feather_var", value=hue_feather_var, expected_type=type_hints["hue_feather_var"])
            check_type(argname="argument hue_tolerance", value=hue_tolerance, expected_type=type_hints["hue_tolerance"])
            check_type(argname="argument hue_tolerance_var", value=hue_tolerance_var, expected_type=type_hints["hue_tolerance_var"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness_feather", value=lightness_feather, expected_type=type_hints["lightness_feather"])
            check_type(argname="argument lightness_feather_var", value=lightness_feather_var, expected_type=type_hints["lightness_feather_var"])
            check_type(argname="argument lightness_tolerance", value=lightness_tolerance, expected_type=type_hints["lightness_tolerance"])
            check_type(argname="argument lightness_tolerance_var", value=lightness_tolerance_var, expected_type=type_hints["lightness_tolerance_var"])
            check_type(argname="argument saturation_feather", value=saturation_feather, expected_type=type_hints["saturation_feather"])
            check_type(argname="argument saturation_feather_var", value=saturation_feather_var, expected_type=type_hints["saturation_feather_var"])
            check_type(argname="argument saturation_tolerance", value=saturation_tolerance, expected_type=type_hints["saturation_tolerance"])
            check_type(argname="argument saturation_tolerance_var", value=saturation_tolerance_var, expected_type=type_hints["saturation_tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_feather is not None:
            self._values["hue_feather"] = hue_feather
        if hue_feather_var is not None:
            self._values["hue_feather_var"] = hue_feather_var
        if hue_tolerance is not None:
            self._values["hue_tolerance"] = hue_tolerance
        if hue_tolerance_var is not None:
            self._values["hue_tolerance_var"] = hue_tolerance_var
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness_feather is not None:
            self._values["lightness_feather"] = lightness_feather
        if lightness_feather_var is not None:
            self._values["lightness_feather_var"] = lightness_feather_var
        if lightness_tolerance is not None:
            self._values["lightness_tolerance"] = lightness_tolerance
        if lightness_tolerance_var is not None:
            self._values["lightness_tolerance_var"] = lightness_tolerance_var
        if saturation_feather is not None:
            self._values["saturation_feather"] = saturation_feather
        if saturation_feather_var is not None:
            self._values["saturation_feather_var"] = saturation_feather_var
        if saturation_tolerance is not None:
            self._values["saturation_tolerance"] = saturation_tolerance
        if saturation_tolerance_var is not None:
            self._values["saturation_tolerance_var"] = saturation_tolerance_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        '''
        result = self._values.get("hue_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        '''
        result = self._values.get("hue_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        '''
        result = self._values.get("hue_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        '''
        result = self._values.get("hue_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        '''
        result = self._values.get("lightness_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        '''
        result = self._values.get("lightness_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        '''
        result = self._values.get("lightness_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        '''
        result = self._values.get("lightness_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        '''
        result = self._values.get("saturation_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        '''
        result = self._values.get("saturation_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        '''
        result = self._values.get("saturation_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        result = self._values.get("saturation_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualChromaKey(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualChromaKeyList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualChromaKeyList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__371f2352913436085014889995b0aa9ade1fd0f6f724b5ab4738cbf5120f8bfd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualChromaKeyOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9adfaab6dcaf4291f44afe8bcebdcff6b92e977a394bd1dc8fd90a0fd1bc3262)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualChromaKeyOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dbfb5741432c007f40e858599c8c74fa8263cd990f748e837595e56778a2cac1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__525c44bf65475d40b0053295ab65f56ff85d63e1d0b148116d3dfeec073bf287)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3040974d05bc2b60f85305442d0540d615b37aef9be3817cf678ce9a7fdb22b7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualChromaKey]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualChromaKey]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__677e7a86e3ecc28f0102847af3bdc5427b8ca3b5f83c63a79f7c971512558038)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualChromaKeyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualChromaKeyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__91351b79e53a9739bfad0b445d448014f7a61c8fcdc1b8dcfae5849fb1807668)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueFeather")
    def reset_hue_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeather", []))

    @jsii.member(jsii_name="resetHueFeatherVar")
    def reset_hue_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeatherVar", []))

    @jsii.member(jsii_name="resetHueTolerance")
    def reset_hue_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueTolerance", []))

    @jsii.member(jsii_name="resetHueToleranceVar")
    def reset_hue_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueToleranceVar", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightnessFeather")
    def reset_lightness_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeather", []))

    @jsii.member(jsii_name="resetLightnessFeatherVar")
    def reset_lightness_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeatherVar", []))

    @jsii.member(jsii_name="resetLightnessTolerance")
    def reset_lightness_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessTolerance", []))

    @jsii.member(jsii_name="resetLightnessToleranceVar")
    def reset_lightness_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessToleranceVar", []))

    @jsii.member(jsii_name="resetSaturationFeather")
    def reset_saturation_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeather", []))

    @jsii.member(jsii_name="resetSaturationFeatherVar")
    def reset_saturation_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeatherVar", []))

    @jsii.member(jsii_name="resetSaturationTolerance")
    def reset_saturation_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationTolerance", []))

    @jsii.member(jsii_name="resetSaturationToleranceVar")
    def reset_saturation_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherInput")
    def hue_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVarInput")
    def hue_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceInput")
    def hue_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVarInput")
    def hue_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherInput")
    def lightness_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVarInput")
    def lightness_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceInput")
    def lightness_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVarInput")
    def lightness_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherInput")
    def saturation_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVarInput")
    def saturation_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceInput")
    def saturation_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVarInput")
    def saturation_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c19c3a1edd07a76ba3ac48c577f95c45f6b53e15269c6e0c7fc27c1216a8d3ce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeather")
    def hue_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeather"))

    @hue_feather.setter
    def hue_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d33374b64ed9b3e8501180a389c9209d80752d34c5acab973854bcc172866519)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeather", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVar")
    def hue_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeatherVar"))

    @hue_feather_var.setter
    def hue_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4165a80ad5206d5fe28827d9a2597f404c4f5faea1bfdb82ab5ef9fe209cc2fa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueTolerance")
    def hue_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueTolerance"))

    @hue_tolerance.setter
    def hue_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9f801df48a0cfa927065fa2f5bd33755070a1f284dc925088d6be072241aa31e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVar")
    def hue_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueToleranceVar"))

    @hue_tolerance_var.setter
    def hue_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a6c49e025fc05a0911820cbea99c4d6a286620855ee7af159ab99249b10c7ec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bfd2929489993b032d3fe05602c24c61ba557ee01b8549d7664de25b45066ef6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeather")
    def lightness_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeather"))

    @lightness_feather.setter
    def lightness_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3c1ae986ddc64599e48c7a54096bfb558280e3f70f3feb02c0a2e9875bd6d0a4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeather", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVar")
    def lightness_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeatherVar"))

    @lightness_feather_var.setter
    def lightness_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__16f7829d941ab6fb8c91626d848fdc30c14173174b10fc61fd652c9ae5fec725)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessTolerance")
    def lightness_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessTolerance"))

    @lightness_tolerance.setter
    def lightness_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4159231f45566368e47f2814e2c7a32882df860e2db0fe7c618e71d5e2aa2228)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVar")
    def lightness_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessToleranceVar"))

    @lightness_tolerance_var.setter
    def lightness_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__48b8c07b354c1c507f6648f1df8c05c894c315e31d73e1a22add69dbd8a6c79d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeather")
    def saturation_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeather"))

    @saturation_feather.setter
    def saturation_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__453ce145b708691b5102da2fbcba940c5777f2d25c6d9d3e43c6928f04d80b64)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeather", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVar")
    def saturation_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeatherVar"))

    @saturation_feather_var.setter
    def saturation_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e8c29ed55fdba06764bcd5a3ec5f94b38fc9f542ff3bca81cae85ab106fa99d1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationTolerance")
    def saturation_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationTolerance"))

    @saturation_tolerance.setter
    def saturation_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e2dd1dc96d0c32d9390c3800a9cf305ae2ad688c08921981a08429469914b157)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVar")
    def saturation_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationToleranceVar"))

    @saturation_tolerance_var.setter
    def saturation_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ad3a5a94d924781dfa2bcab9b7ef1ff897875e7ff3022025f14de4a2ac16cd9d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualChromaKey]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualChromaKey]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualChromaKey]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5021b1de815be77dc653477f35401f3d59451cb958cd076502cdf7ccaddb2406)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualComposite",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "placement": "placement",
        "placement_var": "placementVar",
        "scale": "scale",
        "scale_dimension": "scaleDimension",
        "scale_dimension_var": "scaleDimensionVar",
        "scale_var": "scaleVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualComposite:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualCompositeImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        placement: typing.Optional[builtins.str] = None,
        placement_var: typing.Optional[builtins.str] = None,
        scale: typing.Optional[builtins.str] = None,
        scale_dimension: typing.Optional[builtins.str] = None,
        scale_dimension_var: typing.Optional[builtins.str] = None,
        scale_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param placement: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        :param placement_var: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        :param scale: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param scale_dimension: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        :param scale_dimension_var: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        :param scale_var: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        :param x_position: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualCompositeImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__53512a177c0fbf7bae60fa97c4ba62905144275996bfb137da5242a19a8db920)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument placement", value=placement, expected_type=type_hints["placement"])
            check_type(argname="argument placement_var", value=placement_var, expected_type=type_hints["placement_var"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument scale_dimension", value=scale_dimension, expected_type=type_hints["scale_dimension"])
            check_type(argname="argument scale_dimension_var", value=scale_dimension_var, expected_type=type_hints["scale_dimension_var"])
            check_type(argname="argument scale_var", value=scale_var, expected_type=type_hints["scale_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if placement is not None:
            self._values["placement"] = placement
        if placement_var is not None:
            self._values["placement_var"] = placement_var
        if scale is not None:
            self._values["scale"] = scale
        if scale_dimension is not None:
            self._values["scale_dimension"] = scale_dimension
        if scale_dimension_var is not None:
            self._values["scale_dimension_var"] = scale_dimension_var
        if scale_var is not None:
            self._values["scale_var"] = scale_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualCompositeImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualCompositeImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        '''
        result = self._values.get("placement")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement_var(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        '''
        result = self._values.get("placement_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        '''
        result = self._values.get("scale_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        '''
        result = self._values.get("scale_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        '''
        result = self._values.get("scale_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualComposite(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualCompositeImage",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualCompositeImage:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualCompositeImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualCompositeImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualCompositeImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a883000a2905d0eb887b70786a59aec9ce1ea18117996867d1f32260ee405462)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualCompositeImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualCompositeImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4f9cf66f287ac1b0ed99ad494a4ad928041db18d830898651f047583ffb86a46)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualCompositeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualCompositeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e9be1c419cf29ee90e2917e5c5b8c3723a63d15e2d8ba26edcd0e01a4a80a304)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualCompositeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4758fa19464b07eef323ddf928f35dd57c4e1f4fa7a1c5ac1c45b1e5951e1bb8)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualCompositeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7524311241389bb56b7cfa2e93a374d8e444d03196189ce3f7df09e533c226e3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f4ef84bedf4ac5f323e4900226503e8ac4650f1cf7de09f1510a2ab48dc353ca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__047e456a15d1d4d138e77ff562978d7a135c3352ca90d265b99e38435d82eee4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualComposite]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualComposite]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ef6c908b9387f4cab5d92f9bd51bdd1b92a870873179293eaba5201e5bb3904f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualCompositeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualCompositeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a52d056040d459035a473df2d8856d1579f94493ca1d04c2a779d4eb4048bfc)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualCompositeImage()

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPlacement")
    def reset_placement(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacement", []))

    @jsii.member(jsii_name="resetPlacementVar")
    def reset_placement_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacementVar", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetScaleDimension")
    def reset_scale_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimension", []))

    @jsii.member(jsii_name="resetScaleDimensionVar")
    def reset_scale_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimensionVar", []))

    @jsii.member(jsii_name="resetScaleVar")
    def reset_scale_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualCompositeImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualCompositeImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualCompositeImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="placementInput")
    def placement_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementInput"))

    @builtins.property
    @jsii.member(jsii_name="placementVarInput")
    def placement_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionInput")
    def scale_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVarInput")
    def scale_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleVarInput")
    def scale_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c01b1a65e3a794c1d8bc5a9dcd2d41a3281bf8f2d641048eaf8784c2e625a45e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2574f91deeca69f9ca9ce9817f21a3178eba5fb990548536c8d7f7a9fd2ec6a0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="placement")
    def placement(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placement"))

    @placement.setter
    def placement(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa91b9dd87b8a4c55f3d2ed091c683a446a0f3ad88d62a0475b179cb752831ca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placement", value)

    @builtins.property
    @jsii.member(jsii_name="placementVar")
    def placement_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placementVar"))

    @placement_var.setter
    def placement_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__abb2cb775bc739eaffc606120a571606e983e3c5fe2360e9f97f98c022dbc683)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placementVar", value)

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scale"))

    @scale.setter
    def scale(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4b0a91c9b1c35763129a61157052e8cd13ffbe2cd1837dbf9ebad0e91b2ec447)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scale", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimension")
    def scale_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimension"))

    @scale_dimension.setter
    def scale_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__10a59be6c3793546c8bb3c7462fd80c588dc8a9246bbeb23b6d22de9f124ce33)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimension", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVar")
    def scale_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimensionVar"))

    @scale_dimension_var.setter
    def scale_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aae5e7e002185851e5017a216f80993e1d275d566b59df0723f8d8f0acc05545)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="scaleVar")
    def scale_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleVar"))

    @scale_var.setter
    def scale_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f506938f5f5d74fa11b77e81c8dfb2a3564b7d7a973a52685f642ea36e6f8229)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c5bcc583e341a6f31f5704e3503a490ce385788ef2a18ecd5839912c101a22b9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__455ac6c777d7c2d678e3e3af6f2cd53ac83afcdb0b369745e5a050b725f1070d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3e74b2a375783627a7b48c86fa3fe8a3f4783eb419012fb1f465657edccbda9c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8f7d5aeb04507f739b5eb3c5ed62a1987bc64aaea1b646dcaf34b7136958d71b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualComposite]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualComposite]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualComposite]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__abb9fecf68b219424a019d8c54612971bc497ac94e55c2468f0405fd20f47de2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualCompound",
    jsii_struct_bases=[],
    name_mapping={"transformations": "transformations"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualCompound:
    def __init__(
        self,
        *,
        transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param transformations: transformations block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fe216face3d5cbd8fe1da2fc3bfd1e0499c8e15a7fda3b8989a0a58a19ff428f)
            check_type(argname="argument transformations", value=transformations, expected_type=type_hints["transformations"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if transformations is not None:
            self._values["transformations"] = transformations

    @builtins.property
    def transformations(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualCompoundTransformations"]]]:
        '''transformations block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        result = self._values.get("transformations")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualCompoundTransformations"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualCompound(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualCompoundList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualCompoundList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bad2c93c515959b9bb414703c0b335df59f6e0dd799ccecf15af51d3bcea60ce)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualCompoundOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__97cb32ba13d3053a8e38e94e50a949e18c820e28ff31ef05765b03fa82f72b94)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualCompoundOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__746e5ce8dd3a2340d247323851c08ad8969154d000082cdb8dff861476193216)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2cf53628c5391684f98e1b1ad930d37b23897dfc810cf4ae7f3016b6f91a97ed)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0693e705a545dab79f8859100c54e6e4d511bcb0d77a7608305f0cd2eb2c0510)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualCompound]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualCompound]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__62e9c408162a5fd14ccee847ca4e6ee56e1d60b96c12fc31ae3bb1748ef22bd1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualCompoundOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualCompoundOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a6ffb9b0642dccbbc3427d670e24542a58ba6009a5d36d27878bcd2edd339193)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformations")
    def put_transformations(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5227a5c7f3a116bcbfe35fe9b21b5d564e51edf963d0cf2eb605d196623f54cf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTransformations", [value]))

    @jsii.member(jsii_name="resetTransformations")
    def reset_transformations(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformations", []))

    @builtins.property
    @jsii.member(jsii_name="transformations")
    def transformations(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualCompoundTransformationsList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualCompoundTransformationsList", jsii.get(self, "transformations"))

    @builtins.property
    @jsii.member(jsii_name="transformationsInput")
    def transformations_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualCompoundTransformations"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualCompoundTransformations"]]], jsii.get(self, "transformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualCompound]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualCompound]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualCompound]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ce9eebcaa8443ed6d351f9f4494df54b4cb57bc744ac2e463fd55753051ade97)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualCompoundTransformations",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualCompoundTransformations:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualCompoundTransformations(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualCompoundTransformationsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualCompoundTransformationsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bcc906c908aa34ee1c2bb2b82c1eca123be30abc96fe8a0916521e15206b9b9a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualCompoundTransformationsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1ad2c250532ee8d864e8798cb93ba1da4af6328dbc9e994c6a2d24fcfc3a7d46)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualCompoundTransformationsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__504caaebf9b332ab868f8c441b5c32efb02584af96840a7535fec795fbd8d090)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e50a14027c1d9449ba9be4d5158d0b30196a0cb18a5652c31eca797c9e9c3882)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ce49de8c06823a1445815f6ec00bf4ba7ac279da0e0d7e3b8b687fe25aad3ec1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualCompoundTransformations]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualCompoundTransformations]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualCompoundTransformations]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b72b1eda688edebc4ffb3762a15b0e8e41542a5d96e1f99885f85fa81301a7cd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualCompoundTransformationsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualCompoundTransformationsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__62b02ddf7086ac6bc9f0d7d64eb83e06f878a349b03a3d3619df6bceae298b25)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualCompoundTransformations]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualCompoundTransformations]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualCompoundTransformations]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0d8682b3c054e0d0a1d14eeaa4e7ab76854f0904f573a364119033d5ab21156c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualContrast",
    jsii_struct_bases=[],
    name_mapping={
        "brightness": "brightness",
        "brightness_var": "brightnessVar",
        "contrast": "contrast",
        "contrast_var": "contrastVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualContrast:
    def __init__(
        self,
        *,
        brightness: typing.Optional[builtins.str] = None,
        brightness_var: typing.Optional[builtins.str] = None,
        contrast: typing.Optional[builtins.str] = None,
        contrast_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param brightness: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        :param brightness_var: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        :param contrast: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param contrast_var: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d963a52fa6710f64a0aa22f3e3c933d57e1640f31aa18dfcddfa4982dcd4dec6)
            check_type(argname="argument brightness", value=brightness, expected_type=type_hints["brightness"])
            check_type(argname="argument brightness_var", value=brightness_var, expected_type=type_hints["brightness_var"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument contrast_var", value=contrast_var, expected_type=type_hints["contrast_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if brightness is not None:
            self._values["brightness"] = brightness
        if brightness_var is not None:
            self._values["brightness_var"] = brightness_var
        if contrast is not None:
            self._values["contrast"] = contrast
        if contrast_var is not None:
            self._values["contrast_var"] = contrast_var

    @builtins.property
    def brightness(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        '''
        result = self._values.get("brightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def brightness_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        '''
        result = self._values.get("brightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        result = self._values.get("contrast_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualContrast(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualContrastList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualContrastList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ec25aa0e4c80354d456e228f22357cfe45b884fd70cb38db36cf2f5e842c057c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualContrastOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7a655a886b1c7e4c14b0376046614094cdb611b8632f71327ddaf5753e467c5c)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualContrastOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c7859d26793be6a64234382193865a5a532027158cafe92bb697f07f6de959b7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e6ab48314eb23f4eba45943497dd3ec8088c3d79d9cdca4ac55efe0484f14d6a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d0b062ad31a9b2b0ea1d717626673fb971a93bb89fdc02c3300850cd5a4fb24e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualContrast]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualContrast]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__15392a485ff716f1b52ebb73afa439d64d53060a5630c74f658d7513bd6bf307)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualContrastOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualContrastOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0aa383ad67c2862b873b6bf5d3453760d9bd8ae179f954fb401cedaf16410348)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetBrightness")
    def reset_brightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightness", []))

    @jsii.member(jsii_name="resetBrightnessVar")
    def reset_brightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightnessVar", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetContrastVar")
    def reset_contrast_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrastVar", []))

    @builtins.property
    @jsii.member(jsii_name="brightnessInput")
    def brightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="brightnessVarInput")
    def brightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastVarInput")
    def contrast_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="brightness")
    def brightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightness"))

    @brightness.setter
    def brightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d7c9836fa564eb5e819f47b18689d4bec3ff7c0e681195e60c77b036747334db)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightness", value)

    @builtins.property
    @jsii.member(jsii_name="brightnessVar")
    def brightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightnessVar"))

    @brightness_var.setter
    def brightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c3c60cbef0edcbb69b6c57ab99a3caf0a416350e69a77a8339ad0de1a59f66a2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrast"))

    @contrast.setter
    def contrast(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8e7210d4b1f9cf89d9e3792ff14faaf3d30e271e0e57d03aff272e28128038c3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrast", value)

    @builtins.property
    @jsii.member(jsii_name="contrastVar")
    def contrast_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrastVar"))

    @contrast_var.setter
    def contrast_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__14e06899df59e5523819a4d7692ac942d34d642800c2820b711e796d74c0fce2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrastVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualContrast]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualContrast]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualContrast]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9cea0926ab675e1bece1d0355511f34d40d2737a140365d1858d27297571a983)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualGoop",
    jsii_struct_bases=[],
    name_mapping={
        "chaos": "chaos",
        "chaos_var": "chaosVar",
        "density": "density",
        "density_var": "densityVar",
        "power": "power",
        "power_var": "powerVar",
        "seed": "seed",
        "seed_var": "seedVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualGoop:
    def __init__(
        self,
        *,
        chaos: typing.Optional[builtins.str] = None,
        chaos_var: typing.Optional[builtins.str] = None,
        density: typing.Optional[builtins.str] = None,
        density_var: typing.Optional[builtins.str] = None,
        power: typing.Optional[builtins.str] = None,
        power_var: typing.Optional[builtins.str] = None,
        seed: typing.Optional[builtins.str] = None,
        seed_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param chaos: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        :param chaos_var: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        :param density: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        :param density_var: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        :param power: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        :param power_var: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        :param seed: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        :param seed_var: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__067a7d4cfa876635f03c4f20d0dc96bd0c284e258f0e3c348873de3b91b23f67)
            check_type(argname="argument chaos", value=chaos, expected_type=type_hints["chaos"])
            check_type(argname="argument chaos_var", value=chaos_var, expected_type=type_hints["chaos_var"])
            check_type(argname="argument density", value=density, expected_type=type_hints["density"])
            check_type(argname="argument density_var", value=density_var, expected_type=type_hints["density_var"])
            check_type(argname="argument power", value=power, expected_type=type_hints["power"])
            check_type(argname="argument power_var", value=power_var, expected_type=type_hints["power_var"])
            check_type(argname="argument seed", value=seed, expected_type=type_hints["seed"])
            check_type(argname="argument seed_var", value=seed_var, expected_type=type_hints["seed_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if chaos is not None:
            self._values["chaos"] = chaos
        if chaos_var is not None:
            self._values["chaos_var"] = chaos_var
        if density is not None:
            self._values["density"] = density
        if density_var is not None:
            self._values["density_var"] = density_var
        if power is not None:
            self._values["power"] = power
        if power_var is not None:
            self._values["power_var"] = power_var
        if seed is not None:
            self._values["seed"] = seed
        if seed_var is not None:
            self._values["seed_var"] = seed_var

    @builtins.property
    def chaos(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        '''
        result = self._values.get("chaos")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def chaos_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        '''
        result = self._values.get("chaos_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        '''
        result = self._values.get("density")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density_var(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        '''
        result = self._values.get("density_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        '''
        result = self._values.get("power")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power_var(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        '''
        result = self._values.get("power_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        '''
        result = self._values.get("seed")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed_var(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        result = self._values.get("seed_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualGoop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualGoopList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualGoopList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ce140ebeae9a389ace9113601982fe0fd99b76dcd0ee15077ed5dd4048f037c5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualGoopOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2c776dd7d01ee7ba27635dcb4319b27904dd6bc1b5458dc89dc808b611e4283e)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualGoopOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__faf7d7c556c790e9afb6752c7b52d5831e8fbfcfed1f69d704459fc4302a4293)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__65b2b90726628b4d6789d8480e22a3e62d83064128c5a09a0d576540eab3a61f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ccde076eb6120b29cf88f5deeccc7b1189d41969a8acbdcf8996d76031cffdfe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualGoop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualGoop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7a71081585e80e78947c9aeb9ccff0faef72e03498a6e6be7245132dfdc729ba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualGoopOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualGoopOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__129c5e566217f6d2f6f11b12ffe21e6f0994e5ab32a282233c26a94baf8c5599)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetChaos")
    def reset_chaos(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaos", []))

    @jsii.member(jsii_name="resetChaosVar")
    def reset_chaos_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaosVar", []))

    @jsii.member(jsii_name="resetDensity")
    def reset_density(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensity", []))

    @jsii.member(jsii_name="resetDensityVar")
    def reset_density_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensityVar", []))

    @jsii.member(jsii_name="resetPower")
    def reset_power(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPower", []))

    @jsii.member(jsii_name="resetPowerVar")
    def reset_power_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPowerVar", []))

    @jsii.member(jsii_name="resetSeed")
    def reset_seed(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeed", []))

    @jsii.member(jsii_name="resetSeedVar")
    def reset_seed_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeedVar", []))

    @builtins.property
    @jsii.member(jsii_name="chaosInput")
    def chaos_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosInput"))

    @builtins.property
    @jsii.member(jsii_name="chaosVarInput")
    def chaos_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosVarInput"))

    @builtins.property
    @jsii.member(jsii_name="densityInput")
    def density_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityInput"))

    @builtins.property
    @jsii.member(jsii_name="densityVarInput")
    def density_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="powerInput")
    def power_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerInput"))

    @builtins.property
    @jsii.member(jsii_name="powerVarInput")
    def power_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerVarInput"))

    @builtins.property
    @jsii.member(jsii_name="seedInput")
    def seed_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedInput"))

    @builtins.property
    @jsii.member(jsii_name="seedVarInput")
    def seed_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedVarInput"))

    @builtins.property
    @jsii.member(jsii_name="chaos")
    def chaos(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaos"))

    @chaos.setter
    def chaos(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0445fdf54d7984d9ef4652c57222c053d5404d5b1040c50e5356e3e3d237f79b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaos", value)

    @builtins.property
    @jsii.member(jsii_name="chaosVar")
    def chaos_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaosVar"))

    @chaos_var.setter
    def chaos_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__826b3be548204dafdfb0a3b0a75b17280d6e626a255107f44535f004f55df960)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaosVar", value)

    @builtins.property
    @jsii.member(jsii_name="density")
    def density(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "density"))

    @density.setter
    def density(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__06eb9bae6f8f50e478a7e74dd1a23d1171140f03af9ad2eabdd617d5d7c60d71)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "density", value)

    @builtins.property
    @jsii.member(jsii_name="densityVar")
    def density_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "densityVar"))

    @density_var.setter
    def density_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ed06f6fa7bbe4927a0f489d4d25ec56324b91cb2623dfd821a00464a0d840dc6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "densityVar", value)

    @builtins.property
    @jsii.member(jsii_name="power")
    def power(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "power"))

    @power.setter
    def power(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2dfcab8356caed1d61f78744e28178226f6aaac439e5f66cb364357b5456ed92)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "power", value)

    @builtins.property
    @jsii.member(jsii_name="powerVar")
    def power_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "powerVar"))

    @power_var.setter
    def power_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fd7b54f919fac4d99ec6c6acb922e9e17a4503e70ec0e02838929af7522c6c75)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "powerVar", value)

    @builtins.property
    @jsii.member(jsii_name="seed")
    def seed(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seed"))

    @seed.setter
    def seed(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac9dbb390484dff99f2843dda297d71234355e5dac9528457649aaab4a89e263)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seed", value)

    @builtins.property
    @jsii.member(jsii_name="seedVar")
    def seed_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seedVar"))

    @seed_var.setter
    def seed_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea7a9ffd8356f59e8ef57611c67706f7973cab1675cc7b01a42ab65277f11f04)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seedVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualGoop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualGoop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualGoop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0bd3311553835ba78b6781b139bcbbfb559097db89e6d2be4f70a1694f6854fc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualGrayscale",
    jsii_struct_bases=[],
    name_mapping={"type": "type", "type_var": "typeVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualGrayscale:
    def __init__(
        self,
        *,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param type: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__15134fff2544b27358999c4da5aa797fa0f51e1f7a020e1b548a3e35707c718d)
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualGrayscale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualGrayscaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualGrayscaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4acc02c616360d2341d150c39aedefec3d2c31b3afccbeec093520b147047378)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualGrayscaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__373e52a0ecda6e3e29c4b804b0198fd58a2a159a7f674088ec152e85bba96462)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualGrayscaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__254e6168255d01d5d20de91a90513dc9a4e47058c5a82a3e421a2926363f6962)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0fbd222daa8d46c3ab7ad43b7eeeed09f525629effe45367192c515b4a632291)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5dc52aff9493a57ff6de4475c0540f5e927345416d0c8b26e0ed52e40c4df02f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualGrayscale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualGrayscale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ebf2bbfcddacfbf5fcbd7a98223947ccbb399a788e84b8f2ce21c032847ac8a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualGrayscaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualGrayscaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dab6bc26a0c41df0ec226545d37db2f3fae2eee9d21a2d4167557db75d663550)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f15a56f44a7a6e554800d437863b979eed7fcc94e5ae47e39d8b490055f9db00)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a2eabd14b3216aedd1e93f5a37cbd1654274c6412813f386ee443a1f843f97c3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualGrayscale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualGrayscale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualGrayscale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bbb9af519aa6aa8fa054853f549c33970b1c4f003b92ae661c259d6a1453897d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualHsl",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "lightness": "lightness",
        "lightness_var": "lightnessVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualHsl:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness: typing.Optional[builtins.str] = None,
        lightness_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        :param lightness_var: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__436b1c54ab479a152be3beb50582e447a3d7f876cecac10601ae40312d1d56e3)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness", value=lightness, expected_type=type_hints["lightness"])
            check_type(argname="argument lightness_var", value=lightness_var, expected_type=type_hints["lightness_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness is not None:
            self._values["lightness"] = lightness
        if lightness_var is not None:
            self._values["lightness_var"] = lightness_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        '''
        result = self._values.get("lightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        '''
        result = self._values.get("lightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualHsl(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualHslList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualHslList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c23033f9594f8de3b6632f5e028124c87bffe9167f7259bbdd0ca1c554b72291)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualHslOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2204404a64a8e39c3b8f100c08b44ca91ee4b491c7c98492bf35b51b833759bb)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualHslOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__864a9405d8f93f8ff005e33c1d3d590ab896144a1d762e4a48143476ade46b8c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c5e1606ec645d26f3038ef72933c0be2ca5319c55df37ff76c812421828d9023)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dad1d4c67638061f5df06e7bba9ce922a82a0c3c4153f98c82e57cb62b13ee0a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualHsl]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualHsl]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__94664d350dc798e84d9949b04562b005f0b6536d091962d6248c955214b5a67b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualHslOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualHslOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eb1e38c36ba9070d790027461f4cfc49806d02fb716e94423f43501a3253f640)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightness")
    def reset_lightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightness", []))

    @jsii.member(jsii_name="resetLightnessVar")
    def reset_lightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessInput")
    def lightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessVarInput")
    def lightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__befda91bc3eb3d9b0d18666b1ce08f9cef7cfdf7c44dbfff99f493c6d3935c7f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b3c4fa31fe597da38872fc4533bf366e95818e6a59f0cf62df368de7809b2f06)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightness")
    def lightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightness"))

    @lightness.setter
    def lightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4d5c1b2e4741fd13c85cf8e60e8ad198f1ce9cefbf75360954dd12e9ab61d2c7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightness", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessVar")
    def lightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessVar"))

    @lightness_var.setter
    def lightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__abd2c4c0162c44859b00f5270ca99abec560762de450c1044477038aef47649b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c5d9c7d4f56ee03fe0cb7abb995f97a1cbb8395194bd4a7c1d77ca9fa204f29c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc03d898d81b73e8b84fda2736cee02e0400db6fedaac8253fde806818af0b34)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualHsl]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualHsl]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualHsl]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__080d9740e5814b71133aac4f3392abd3bc02ef6ad077f357ff98ceb72b9b1ed8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualHsv",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualHsv:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        :param value: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__edfed2db995bd4844c73f0bf8a2aa7de8974359f847e8ad41ce64eccbc04a7da)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualHsv(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualHsvList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualHsvList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7cd17d25db43673e7406aee9415d21deb5295fcb99b0a7c1cfe1c79ff1f217f4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualHsvOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1418ffea966981792c648a7a5bd0a898a5d8a960c29bc3a642d0b08951e624f3)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualHsvOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f044c790fe8ff7e65f7517ca4db6db264e239ca465f8f8cd350e617a0a6f9b39)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0b3c629161f06e81eded95f63f648090e67a13b1bd8f199db965425a0f1c76e6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__94eb9331a45003714969448d50273d50553890789eeabb38bfffdf9cb9d2d57b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualHsv]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualHsv]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__611053185b9c650fd5b9a30e33310d957ddb13b4ea718ddc8e2b4b8cc2ee0c35)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualHsvOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualHsvOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d94fb7e761651cf2ff791ca2332e0289d43d2e21b1e492e9690de320a192b7be)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a82723311a1c27e3ea91d9f9c9c5b73f12035e4959e1a608648a2c0b1e361bdc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__98e53215336b00e0e93f3caf84c702518348deebc7dc99134b6c8f84b8594999)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__513247df4939ff876f728af1aa51ab96b92948b83f13f9e1c6d7a426d8203bca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac3a83f7a9dc2037a5136b4d94530685f1f036afdb27bb5d8d939d9a0e0094e4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__987c8fb7abb71cbee8488f06542d7964dda507c25a51a91f33c216eb346601b9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dc9f217b3b11babd90a92ea255aa027a83fc6a24edca13614adba6916bde294c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualHsv]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualHsv]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualHsv]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c5a8c7b76ab2569e25aeb344a95ef2fac150e3378dba90f9c59c5d9b67a54f9c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfDimension",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "dimension": "dimension",
        "dimension_var": "dimensionVar",
        "equal": "equal",
        "greater_than": "greaterThan",
        "less_than": "lessThan",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfDimension:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfDimensionDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        dimension: typing.Optional[builtins.str] = None,
        dimension_var: typing.Optional[builtins.str] = None,
        equal: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfDimensionEqual", typing.Dict[builtins.str, typing.Any]]] = None,
        greater_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfDimensionGreaterThan", typing.Dict[builtins.str, typing.Any]]] = None,
        less_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfDimensionLessThan", typing.Dict[builtins.str, typing.Any]]] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param dimension: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        :param dimension_var: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        :param equal: equal block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        :param greater_than: greater_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        :param less_than: less_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        :param value: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfDimensionDefault(**default)
        if isinstance(equal, dict):
            equal = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfDimensionEqual(**equal)
        if isinstance(greater_than, dict):
            greater_than = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfDimensionGreaterThan(**greater_than)
        if isinstance(less_than, dict):
            less_than = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfDimensionLessThan(**less_than)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f29aa500c3719ee4d75e0b653d0adac69e0c890179329be440d9041fc866c649)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument dimension", value=dimension, expected_type=type_hints["dimension"])
            check_type(argname="argument dimension_var", value=dimension_var, expected_type=type_hints["dimension_var"])
            check_type(argname="argument equal", value=equal, expected_type=type_hints["equal"])
            check_type(argname="argument greater_than", value=greater_than, expected_type=type_hints["greater_than"])
            check_type(argname="argument less_than", value=less_than, expected_type=type_hints["less_than"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if dimension is not None:
            self._values["dimension"] = dimension
        if dimension_var is not None:
            self._values["dimension_var"] = dimension_var
        if equal is not None:
            self._values["equal"] = equal
        if greater_than is not None:
            self._values["greater_than"] = greater_than
        if less_than is not None:
            self._values["less_than"] = less_than
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfDimensionDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfDimensionDefault"], result)

    @builtins.property
    def dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        '''
        result = self._values.get("dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        '''
        result = self._values.get("dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def equal(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfDimensionEqual"]:
        '''equal block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        '''
        result = self._values.get("equal")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfDimensionEqual"], result)

    @builtins.property
    def greater_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfDimensionGreaterThan"]:
        '''greater_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        '''
        result = self._values.get("greater_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfDimensionGreaterThan"], result)

    @builtins.property
    def less_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfDimensionLessThan"]:
        '''less_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        '''
        result = self._values.get("less_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfDimensionLessThan"], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfDimension(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfDimensionDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfDimensionDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfDimensionDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfDimensionDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfDimensionDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0654b6a4c7e83211604a004a58e48ebd70dcb75cd54c883f458ed7d23a866712)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfDimensionDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfDimensionDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b3cf4408c1869e1edef43223b3420339636255fd6909e8e98293943c01a0dda1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfDimensionEqual",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfDimensionEqual:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfDimensionEqual(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfDimensionEqualOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfDimensionEqualOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0529e9515971d7d5656ade6377af8b9425b9dc32b6460ffe205b3fb4ad7e022f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfDimensionEqual], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfDimensionEqual],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__938480248c25ba9aefe2b82c661525e28d7e55bb378473b95f1bc60cbc0c70ff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfDimensionGreaterThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfDimensionGreaterThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfDimensionGreaterThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfDimensionGreaterThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfDimensionGreaterThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3290f9d5a44672c3c5a7f68d5f7c396ce09f96e11f4cfa775b674accc7d948a2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfDimensionGreaterThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfDimensionGreaterThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cdff202e1fe067c9da3bb669e65bcb4a00fd4daee6a2f1b871547d71039f88ac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfDimensionLessThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfDimensionLessThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfDimensionLessThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfDimensionLessThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfDimensionLessThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__adb0fb53a4cea0da264d8bcb727fe4dd21c44319f8c6d28e90521481b0290abc)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfDimensionLessThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfDimensionLessThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__09b02f145c610c96c4459d5a633ffcca8719eb26122a79dfb85b46689df351a8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfDimensionList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfDimensionList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4841a02d86bb814c3aaad516201bded338ab5fa635f0da948b39cd4aec0ffc9d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfDimensionOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ed9819c2a913b7816a9f04637622d67787ab0d41bf4b85456e683ca6b4dcc54)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfDimensionOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ccb44572d86c7f52bb40956b3b5de1a17a2c3b3581c01dca17271e5d2d7935d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cca2286853b02cc08e3b21fe436e09356e2798fefd174526e62a3b7a0245b51b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ffba37f83a017d5899475d059e4386203127030ba4c2f0adf6054419480a7ae6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfDimension]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfDimension]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__67f617e25dd239f8398b76215eb5c15f1d858f0f08915f3fa1dab624353ef457)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfDimensionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfDimensionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dbfac6814ead4b950737170beb4351930e2fd9aa4bd758e16e021255ff0e29fe)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfDimensionDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putEqual")
    def put_equal(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfDimensionEqual()

        return typing.cast(None, jsii.invoke(self, "putEqual", [value]))

    @jsii.member(jsii_name="putGreaterThan")
    def put_greater_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfDimensionGreaterThan()

        return typing.cast(None, jsii.invoke(self, "putGreaterThan", [value]))

    @jsii.member(jsii_name="putLessThan")
    def put_less_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfDimensionLessThan()

        return typing.cast(None, jsii.invoke(self, "putLessThan", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetDimension")
    def reset_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimension", []))

    @jsii.member(jsii_name="resetDimensionVar")
    def reset_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimensionVar", []))

    @jsii.member(jsii_name="resetEqual")
    def reset_equal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEqual", []))

    @jsii.member(jsii_name="resetGreaterThan")
    def reset_greater_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGreaterThan", []))

    @jsii.member(jsii_name="resetLessThan")
    def reset_less_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLessThan", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfDimensionDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfDimensionDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="equal")
    def equal(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfDimensionEqualOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfDimensionEqualOutputReference, jsii.get(self, "equal"))

    @builtins.property
    @jsii.member(jsii_name="greaterThan")
    def greater_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfDimensionGreaterThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfDimensionGreaterThanOutputReference, jsii.get(self, "greaterThan"))

    @builtins.property
    @jsii.member(jsii_name="lessThan")
    def less_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfDimensionLessThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfDimensionLessThanOutputReference, jsii.get(self, "lessThan"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfDimensionDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionInput")
    def dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionVarInput")
    def dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="equalInput")
    def equal_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfDimensionEqual], jsii.get(self, "equalInput"))

    @builtins.property
    @jsii.member(jsii_name="greaterThanInput")
    def greater_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfDimensionGreaterThan], jsii.get(self, "greaterThanInput"))

    @builtins.property
    @jsii.member(jsii_name="lessThanInput")
    def less_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfDimensionLessThan], jsii.get(self, "lessThanInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="dimension")
    def dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimension"))

    @dimension.setter
    def dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__761e4c64641d93576499695192802f995972bb80d8aa003912a29878d675b980)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimension", value)

    @builtins.property
    @jsii.member(jsii_name="dimensionVar")
    def dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimensionVar"))

    @dimension_var.setter
    def dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__77e491f5fb857ddaffcc349dc86e24ca9ef300294f7e495243ce6199bad1fd74)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a6c81a28c62eb834de3b859a4c756c2bd8a5577aeff489a972f76538bedd264)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__86d578b6baa3fce4d6afe90f45b652e233c261a9732630b0607e46b8b5e04756)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfDimension]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfDimension]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfDimension]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__27be1902f161e58a1e9883ed7804536a687b58f14981b42160603f3154b0354b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfOrientation",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "landscape": "landscape",
        "portrait": "portrait",
        "square": "square",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfOrientation:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfOrientationDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        landscape: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfOrientationLandscape", typing.Dict[builtins.str, typing.Any]]] = None,
        portrait: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfOrientationPortrait", typing.Dict[builtins.str, typing.Any]]] = None,
        square: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfOrientationSquare", typing.Dict[builtins.str, typing.Any]]] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param landscape: landscape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        :param portrait: portrait block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        :param square: square block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfOrientationDefault(**default)
        if isinstance(landscape, dict):
            landscape = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfOrientationLandscape(**landscape)
        if isinstance(portrait, dict):
            portrait = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfOrientationPortrait(**portrait)
        if isinstance(square, dict):
            square = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfOrientationSquare(**square)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d1d7378eb2425ea63edb2b6df03aec75de6eb41d237f269d38e8b37a7d974bca)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument landscape", value=landscape, expected_type=type_hints["landscape"])
            check_type(argname="argument portrait", value=portrait, expected_type=type_hints["portrait"])
            check_type(argname="argument square", value=square, expected_type=type_hints["square"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if landscape is not None:
            self._values["landscape"] = landscape
        if portrait is not None:
            self._values["portrait"] = portrait
        if square is not None:
            self._values["square"] = square

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfOrientationDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfOrientationDefault"], result)

    @builtins.property
    def landscape(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfOrientationLandscape"]:
        '''landscape block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        '''
        result = self._values.get("landscape")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfOrientationLandscape"], result)

    @builtins.property
    def portrait(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfOrientationPortrait"]:
        '''portrait block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        '''
        result = self._values.get("portrait")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfOrientationPortrait"], result)

    @builtins.property
    def square(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfOrientationSquare"]:
        '''square block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        result = self._values.get("square")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfOrientationSquare"], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfOrientation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfOrientationDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfOrientationDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfOrientationDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfOrientationDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfOrientationDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__37dfc651e3e55e9a6e35b45f423b4c187530c0de2504440ee6bc5fbd17bce39e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfOrientationDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfOrientationDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4849bbdfa5c481805994ad9eca8dfa99f005b7c4356e9623291b39ee55bf16e6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfOrientationLandscape",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfOrientationLandscape:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfOrientationLandscape(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfOrientationLandscapeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfOrientationLandscapeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__90fd013239deda2990648295456e4eb682babcdc69ac03319ac809e9faa16395)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfOrientationLandscape], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfOrientationLandscape],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__33c43092a4890f967e77096363a6aaaf629fa06ea4d2972ae4a8b4a05fc6ae3a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfOrientationList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfOrientationList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__59434560e6bf8375a1e9f2a40bd56eaf5d3f15c31afea9b84e62a1d54beada39)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfOrientationOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3925de0d5cd9587cfaa5b382bedb19057c0445ce3c3adddb84cadbb523353c74)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfOrientationOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__304754fbcf25a3ae1638bbdd2be856a7e44f8f93ae3623e7eff6b42b215c5ec8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__01b5ce57033c75a56cf5bc4d73fd1a67a556eab01fb2daa9906caf825aff8ca4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__37a909ae60e7d40c91f75e209ca7a9f9676b423746bcf3f589041a459b5710f8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfOrientation]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfOrientation]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1faa8d78a89dbf5180f2087366ea4bdaea854f477abc1d9053bd32808c0b4ab8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfOrientationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfOrientationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c1ef88451355505d68dd1a1e2a06cf1c5d149d5f4bff23e45e261321ceee6897)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfOrientationDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putLandscape")
    def put_landscape(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfOrientationLandscape()

        return typing.cast(None, jsii.invoke(self, "putLandscape", [value]))

    @jsii.member(jsii_name="putPortrait")
    def put_portrait(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfOrientationPortrait()

        return typing.cast(None, jsii.invoke(self, "putPortrait", [value]))

    @jsii.member(jsii_name="putSquare")
    def put_square(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfOrientationSquare()

        return typing.cast(None, jsii.invoke(self, "putSquare", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetLandscape")
    def reset_landscape(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLandscape", []))

    @jsii.member(jsii_name="resetPortrait")
    def reset_portrait(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPortrait", []))

    @jsii.member(jsii_name="resetSquare")
    def reset_square(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSquare", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfOrientationDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfOrientationDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="landscape")
    def landscape(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfOrientationLandscapeOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfOrientationLandscapeOutputReference, jsii.get(self, "landscape"))

    @builtins.property
    @jsii.member(jsii_name="portrait")
    def portrait(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfOrientationPortraitOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfOrientationPortraitOutputReference", jsii.get(self, "portrait"))

    @builtins.property
    @jsii.member(jsii_name="square")
    def square(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfOrientationSquareOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfOrientationSquareOutputReference", jsii.get(self, "square"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfOrientationDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="landscapeInput")
    def landscape_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfOrientationLandscape], jsii.get(self, "landscapeInput"))

    @builtins.property
    @jsii.member(jsii_name="portraitInput")
    def portrait_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfOrientationPortrait"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfOrientationPortrait"], jsii.get(self, "portraitInput"))

    @builtins.property
    @jsii.member(jsii_name="squareInput")
    def square_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfOrientationSquare"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfOrientationSquare"], jsii.get(self, "squareInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfOrientation]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfOrientation]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfOrientation]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b9912f85ac7dae169acf6da7fd7e2f7ff6e0c67549c2b5c1f3d9a7131f51d12d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfOrientationPortrait",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfOrientationPortrait:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfOrientationPortrait(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfOrientationPortraitOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfOrientationPortraitOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d65b1d3bcd361e4be5a1e81bd022e56c4ef2b470a286a4a7fd5c13a581210d4c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfOrientationPortrait]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfOrientationPortrait], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfOrientationPortrait],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa296662e257c7e234c1b9c4090c26f2ebb6304f491687615ca319a0840eb31c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfOrientationSquare",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfOrientationSquare:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfOrientationSquare(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfOrientationSquareOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfOrientationSquareOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5c440c8fb819f4afdc15cb244da4cf26c5c199eb432b66d68c9f822599ddc0a4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfOrientationSquare]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfOrientationSquare], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfOrientationSquare],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b20e58accc1fb7b260f221f73126b136b5c7655228de237631c7be9357cc6ebf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualMaxColors",
    jsii_struct_bases=[],
    name_mapping={"colors": "colors", "colors_var": "colorsVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualMaxColors:
    def __init__(
        self,
        *,
        colors: typing.Optional[builtins.str] = None,
        colors_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param colors: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        :param colors_var: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ffdace73790e7ebceb27054f22661ec39694277cc1b7677927b746cbbec7edfb)
            check_type(argname="argument colors", value=colors, expected_type=type_hints["colors"])
            check_type(argname="argument colors_var", value=colors_var, expected_type=type_hints["colors_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if colors is not None:
            self._values["colors"] = colors
        if colors_var is not None:
            self._values["colors_var"] = colors_var

    @builtins.property
    def colors(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        '''
        result = self._values.get("colors")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def colors_var(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        result = self._values.get("colors_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualMaxColors(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualMaxColorsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualMaxColorsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6af21ab4a9d690ef1268b2daaff262613162822f5564e7acf4dde1c449fdead2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualMaxColorsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4548844a1156f04e02f4254bc0f421a7a1d354f9dbe87a02c7c7b5a8b4e26dbd)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualMaxColorsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cdfbd9a56d8f31eb9f68fa571c47d64c50b3ca753b02dfe82c981f452b404345)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__710b6caa077527c305911a017f23d87bc92a72f358370b2fe4b11f89db7c80d8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a6ddf69dcea0aa03121e5ed8c00ec0fed7bcf489df729a0ed7ea04ccda44644d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualMaxColors]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualMaxColors]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f0a94a5893b9582abc48ebf7c22a3ce08cd9b3ac3e821cb315aa5985a364d9b0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualMaxColorsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualMaxColorsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__43eb5f32359a965274254fe9e4e63fc1d894f426009832842317ed022bd2f317)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColors")
    def reset_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColors", []))

    @jsii.member(jsii_name="resetColorsVar")
    def reset_colors_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorsVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorsInput")
    def colors_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsInput"))

    @builtins.property
    @jsii.member(jsii_name="colorsVarInput")
    def colors_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsVarInput"))

    @builtins.property
    @jsii.member(jsii_name="colors")
    def colors(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colors"))

    @colors.setter
    def colors(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c8595a7b2a5a294972cf12e3109b8663c696b78a8df8bf87316601607a81da76)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colors", value)

    @builtins.property
    @jsii.member(jsii_name="colorsVar")
    def colors_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorsVar"))

    @colors_var.setter
    def colors_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ed471f2a089e075650c9dacbd31a71eed6aa9ddf7d4683dbab14b74bc7bc9fd3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorsVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualMaxColors]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualMaxColors]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualMaxColors]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cc7f641314bfda9173b09f2982ffe7a9e6ef2e3f6bbc999cbd0a604ef38a3a64)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualMirror",
    jsii_struct_bases=[],
    name_mapping={
        "horizontal": "horizontal",
        "horizontal_var": "horizontalVar",
        "vertical": "vertical",
        "vertical_var": "verticalVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualMirror:
    def __init__(
        self,
        *,
        horizontal: typing.Optional[builtins.str] = None,
        horizontal_var: typing.Optional[builtins.str] = None,
        vertical: typing.Optional[builtins.str] = None,
        vertical_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param horizontal: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        :param horizontal_var: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        :param vertical: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        :param vertical_var: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0b6a5f46c1a926c14f197eb7d30a880ddaab6b0bfb28495a79138597919aa3c5)
            check_type(argname="argument horizontal", value=horizontal, expected_type=type_hints["horizontal"])
            check_type(argname="argument horizontal_var", value=horizontal_var, expected_type=type_hints["horizontal_var"])
            check_type(argname="argument vertical", value=vertical, expected_type=type_hints["vertical"])
            check_type(argname="argument vertical_var", value=vertical_var, expected_type=type_hints["vertical_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if horizontal is not None:
            self._values["horizontal"] = horizontal
        if horizontal_var is not None:
            self._values["horizontal_var"] = horizontal_var
        if vertical is not None:
            self._values["vertical"] = vertical
        if vertical_var is not None:
            self._values["vertical_var"] = vertical_var

    @builtins.property
    def horizontal(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        '''
        result = self._values.get("horizontal")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def horizontal_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        '''
        result = self._values.get("horizontal_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        '''
        result = self._values.get("vertical")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        result = self._values.get("vertical_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualMirror(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualMirrorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualMirrorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8857ca39fc710e837f0c8c05c350ae9782d184aa85e104461b2f824a4124da08)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualMirrorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__05e600fe6d2e6ee55ce20d90d398ab221b4ae853fac78475dc2252173c66e68e)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualMirrorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__551b73e1b8ff62023b7ce993f274b211a11a8e57564b3e24bc96c7d68c0df14f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e69a1b2a0adc48363b34d6bf8a7d240a815ead395dcf203913f93b8f2c3ede44)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__35c46a2253a6a8034cc1be75b40361f979d2d282a62d33e64716b49d425145fe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualMirror]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualMirror]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__97e69851bc033e5e5f9dec1dce2fbc8678492351c11a12decead18c823bd8391)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualMirrorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualMirrorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4d0ac354a4f3f7a516eb6f384fe87b21d12fbf76a840b9c3a36f03d15914cd97)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHorizontal")
    def reset_horizontal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontal", []))

    @jsii.member(jsii_name="resetHorizontalVar")
    def reset_horizontal_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontalVar", []))

    @jsii.member(jsii_name="resetVertical")
    def reset_vertical(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVertical", []))

    @jsii.member(jsii_name="resetVerticalVar")
    def reset_vertical_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVerticalVar", []))

    @builtins.property
    @jsii.member(jsii_name="horizontalInput")
    def horizontal_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontalVarInput")
    def horizontal_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalInput")
    def vertical_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalVarInput")
    def vertical_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontal")
    def horizontal(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontal"))

    @horizontal.setter
    def horizontal(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c9a54a56e01f70a5cd90c412a205774e3e39778b666a89e71bbae1f4c2b46c1c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontal", value)

    @builtins.property
    @jsii.member(jsii_name="horizontalVar")
    def horizontal_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontalVar"))

    @horizontal_var.setter
    def horizontal_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8f7c666250584f0591c40061804e6813c76d06654c7d8ce012af9916ccb20b1b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontalVar", value)

    @builtins.property
    @jsii.member(jsii_name="vertical")
    def vertical(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "vertical"))

    @vertical.setter
    def vertical(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__affae258e5deae75b61f87ee23cb17dfc51109af1f595cbae572f1c0dde05334)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "vertical", value)

    @builtins.property
    @jsii.member(jsii_name="verticalVar")
    def vertical_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "verticalVar"))

    @vertical_var.setter
    def vertical_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__196877dd35edfe4b764aff40294ecac12a79a7193db1bf375b2e64f66eb1d4b0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "verticalVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualMirror]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualMirror]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualMirror]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__68cceb23f8200f9b65f1b57422199b51273847aaedc37eb9b880002cbde319e9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualMonoHue",
    jsii_struct_bases=[],
    name_mapping={"hue": "hue", "hue_var": "hueVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualMonoHue:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a4f7f1d8855c9cd4f7b807e21a14ff9e51a93e8384b691616ecdfb70e79574a6)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualMonoHue(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualMonoHueList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualMonoHueList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__71636c18f470bd63ec9273650d3bb72cfddcfcda624095e49125eff49938523a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualMonoHueOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dbe2b198b7002a69078ee9d066585ce05adc0e98e5a9bde513d6a7ae4b15e832)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualMonoHueOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af36bb0f3f61356b1e95a54fa25141bccda75bf6e0eb052afdf96e0de372ee1b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__afd6f2c4a9a75127c89efc7a4a1f9053306633d0aa13ab1c6046688b7c177284)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f81db770c21a40af1a5deb77c161b9ce94691688216a0b66302f6d387005383e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualMonoHue]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualMonoHue]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__606631799240506b401aad7af3e651f39eb8aca5ba272c624e211bb6677a610c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualMonoHueOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualMonoHueOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__152bb49caeec2e94a923c95ba328df2592b7e18ec9d69af3dacdb3ce05747d91)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__292ce903d22ad289e43f017f4303a2dbbf3cb9b6315720023e7286d4cacf276b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f7ab4387736d1be5fff542bf9433949fcdeda57cc9e62666b78b5b0e3f1a1c7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualMonoHue]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualMonoHue]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualMonoHue]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8e2591e64b016540f471b545b61fd2fef3fdb625f607a3158a175f58eeba642f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualOpacity",
    jsii_struct_bases=[],
    name_mapping={"opacity": "opacity", "opacity_var": "opacityVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualOpacity:
    def __init__(
        self,
        *,
        opacity: typing.Optional[builtins.str] = None,
        opacity_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param opacity: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param opacity_var: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac6c1f020828626eec1a1104c93e32b7d134fd2eba56a55e0435c786c88e4a5a)
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument opacity_var", value=opacity_var, expected_type=type_hints["opacity_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if opacity is not None:
            self._values["opacity"] = opacity
        if opacity_var is not None:
            self._values["opacity_var"] = opacity_var

    @builtins.property
    def opacity(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def opacity_var(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        result = self._values.get("opacity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualOpacity(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualOpacityList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualOpacityList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7e82e559edecf8d324d882379fac4964974a8c1af303fcf981fdddefc548c407)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualOpacityOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__41485b603b0f18ea8a1df1604377fa0c84a09616453d330d4d006d86339e20c5)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualOpacityOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__390527c8184b67630eae4552449db6774b5c1e9f2f739aacf0bd0c663b704e5b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b95b2fc4080c211fa0b063fe89d6e98c6729ff962de356b96286e1ecea19ed2f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__59eafa42947eaa79d5bf0aa2bac663d148aa4f417165afeded924ba760a67fe3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualOpacity]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualOpacity]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__38af1b0d72d5c2367555b92670a3fadd09124fc099d1f39564426b859310e81d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualOpacityOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualOpacityOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__40029822633917b6fd477dd97d08b39eea0a0f651909de33b4948fa9d6f613a0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetOpacityVar")
    def reset_opacity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacityVar", []))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityVarInput")
    def opacity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacity"))

    @opacity.setter
    def opacity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__428a1f4275275700d622c8500a30336103887eded5268491de64a3171ad1e013)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacity", value)

    @builtins.property
    @jsii.member(jsii_name="opacityVar")
    def opacity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacityVar"))

    @opacity_var.setter
    def opacity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4cd9850bc0dcb60320cfab96c2f0c1f3a904cb93e3ac5f156a5d872ce8989123)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacityVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualOpacity]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualOpacity]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualOpacity]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__87e7e1ed5ddff62e44e42f0de71047b392b6cea92e16da3bb7020f9160a8581b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4eafb1ffb18d16928687ec11da855c829dff4a9ccc25f67a2c1f18a533c8cbd3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putBackgroundColor")
    def put_background_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a2d1feade3a79d5f03e0d85a9eeb01670963fc231c7583efbdc99d405ebe124)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBackgroundColor", [value]))

    @jsii.member(jsii_name="putBlur")
    def put_blur(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualBlur, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8d31b59076f8899d4e738185e5a132a35d72cd78b4ef8f4cfe4bc2b643a915bd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBlur", [value]))

    @jsii.member(jsii_name="putChromaKey")
    def put_chroma_key(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualChromaKey, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__99c8d96d1617e6648f02bb1873d0accb2eb44b0c093ee2479cdb21144c4f35c2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putChromaKey", [value]))

    @jsii.member(jsii_name="putComposite")
    def put_composite(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualComposite, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2efc5b72d909dce8da0a2b4286425794b342d5c19d70114672076533636b0e81)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putComposite", [value]))

    @jsii.member(jsii_name="putCompound")
    def put_compound(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualCompound, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8478037e977d0c13267d2b89085179bc4d7460b50e386b1fb615542a44fdb658)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCompound", [value]))

    @jsii.member(jsii_name="putContrast")
    def put_contrast(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualContrast, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__40035561d80cd751952039c3f3e98ac2b51d6f60962dcb8a66ce6227ed26397e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putContrast", [value]))

    @jsii.member(jsii_name="putGoop")
    def put_goop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualGoop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__85e2a4aecde86be64a9ad2edc0f79f1159cd7252be3ff8dcac394ba4a2566c6e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGoop", [value]))

    @jsii.member(jsii_name="putGrayscale")
    def put_grayscale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualGrayscale, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a2dc145b6e8d7861a90affcb04f077439538a012e02bfa9c708266b953e5e45e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGrayscale", [value]))

    @jsii.member(jsii_name="putHsl")
    def put_hsl(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualHsl, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f599741b1418326774d47ef7bafe34e1e4322a3d53998e6c026d53b69efde3b5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsl", [value]))

    @jsii.member(jsii_name="putHsv")
    def put_hsv(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualHsv, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0f97a4354b132127d9ea2e11d28d4c3a8f819f936e6af77a2d392cfeb7033502)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsv", [value]))

    @jsii.member(jsii_name="putIfDimension")
    def put_if_dimension(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfDimension, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__767891cc1e5c6519722f9e71be857c299345737db4a31f42f7216002d8454e3d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfDimension", [value]))

    @jsii.member(jsii_name="putIfOrientation")
    def put_if_orientation(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__347cef4c6c2f15934325de9d2cb893fc7c6f943b6527f9a09d43c69e359f3b27)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfOrientation", [value]))

    @jsii.member(jsii_name="putMaxColors")
    def put_max_colors(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualMaxColors, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__866120067dff67732d51e9919b01ea07e2feb97fe2503f28621deb80af9fba04)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMaxColors", [value]))

    @jsii.member(jsii_name="putMirror")
    def put_mirror(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualMirror, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ebd99b1fed6bd18913ea039f540f963469c3dcd20845e98478335727722b6072)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMirror", [value]))

    @jsii.member(jsii_name="putMonoHue")
    def put_mono_hue(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualMonoHue, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a54a380aaa31e863789f81ecdf99c1c9bbd291223ebb2802b4b3cd925dafcbb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMonoHue", [value]))

    @jsii.member(jsii_name="putOpacity")
    def put_opacity(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualOpacity, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__edae2352b61096c8aeaa0e41fc731705fd834d8789441ff80d9089a1b99ecfe5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putOpacity", [value]))

    @jsii.member(jsii_name="putRemoveColor")
    def put_remove_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualRemoveColor", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f7f4ec77e3ac398b5fbe63567cfcbad70f621359eddea4c0007ec27fed84d041)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRemoveColor", [value]))

    @jsii.member(jsii_name="putUnsharpMask")
    def put_unsharp_mask(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualUnsharpMask", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c1730477695f243f125b879548305a4b3fce97893d277d79998efab8901f9cbd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putUnsharpMask", [value]))

    @jsii.member(jsii_name="resetBackgroundColor")
    def reset_background_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBackgroundColor", []))

    @jsii.member(jsii_name="resetBlur")
    def reset_blur(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBlur", []))

    @jsii.member(jsii_name="resetChromaKey")
    def reset_chroma_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChromaKey", []))

    @jsii.member(jsii_name="resetComposite")
    def reset_composite(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetComposite", []))

    @jsii.member(jsii_name="resetCompound")
    def reset_compound(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCompound", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetGoop")
    def reset_goop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGoop", []))

    @jsii.member(jsii_name="resetGrayscale")
    def reset_grayscale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGrayscale", []))

    @jsii.member(jsii_name="resetHsl")
    def reset_hsl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsl", []))

    @jsii.member(jsii_name="resetHsv")
    def reset_hsv(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsv", []))

    @jsii.member(jsii_name="resetIfDimension")
    def reset_if_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfDimension", []))

    @jsii.member(jsii_name="resetIfOrientation")
    def reset_if_orientation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfOrientation", []))

    @jsii.member(jsii_name="resetMaxColors")
    def reset_max_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxColors", []))

    @jsii.member(jsii_name="resetMirror")
    def reset_mirror(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMirror", []))

    @jsii.member(jsii_name="resetMonoHue")
    def reset_mono_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonoHue", []))

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetRemoveColor")
    def reset_remove_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRemoveColor", []))

    @jsii.member(jsii_name="resetUnsharpMask")
    def reset_unsharp_mask(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUnsharpMask", []))

    @builtins.property
    @jsii.member(jsii_name="backgroundColor")
    def background_color(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualBackgroundColorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualBackgroundColorList, jsii.get(self, "backgroundColor"))

    @builtins.property
    @jsii.member(jsii_name="blur")
    def blur(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualBlurList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualBlurList, jsii.get(self, "blur"))

    @builtins.property
    @jsii.member(jsii_name="chromaKey")
    def chroma_key(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualChromaKeyList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualChromaKeyList, jsii.get(self, "chromaKey"))

    @builtins.property
    @jsii.member(jsii_name="composite")
    def composite(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualCompositeList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualCompositeList, jsii.get(self, "composite"))

    @builtins.property
    @jsii.member(jsii_name="compound")
    def compound(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualCompoundList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualCompoundList, jsii.get(self, "compound"))

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualContrastList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualContrastList, jsii.get(self, "contrast"))

    @builtins.property
    @jsii.member(jsii_name="goop")
    def goop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualGoopList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualGoopList, jsii.get(self, "goop"))

    @builtins.property
    @jsii.member(jsii_name="grayscale")
    def grayscale(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualGrayscaleList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualGrayscaleList, jsii.get(self, "grayscale"))

    @builtins.property
    @jsii.member(jsii_name="hsl")
    def hsl(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualHslList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualHslList, jsii.get(self, "hsl"))

    @builtins.property
    @jsii.member(jsii_name="hsv")
    def hsv(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualHsvList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualHsvList, jsii.get(self, "hsv"))

    @builtins.property
    @jsii.member(jsii_name="ifDimension")
    def if_dimension(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfDimensionList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfDimensionList, jsii.get(self, "ifDimension"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientation")
    def if_orientation(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfOrientationList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfOrientationList, jsii.get(self, "ifOrientation"))

    @builtins.property
    @jsii.member(jsii_name="maxColors")
    def max_colors(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualMaxColorsList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualMaxColorsList, jsii.get(self, "maxColors"))

    @builtins.property
    @jsii.member(jsii_name="mirror")
    def mirror(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualMirrorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualMirrorList, jsii.get(self, "mirror"))

    @builtins.property
    @jsii.member(jsii_name="monoHue")
    def mono_hue(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualMonoHueList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualMonoHueList, jsii.get(self, "monoHue"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualOpacityList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualOpacityList, jsii.get(self, "opacity"))

    @builtins.property
    @jsii.member(jsii_name="removeColor")
    def remove_color(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualRemoveColorList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualRemoveColorList", jsii.get(self, "removeColor"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMask")
    def unsharp_mask(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualUnsharpMaskList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualUnsharpMaskList", jsii.get(self, "unsharpMask"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColorInput")
    def background_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualBackgroundColor]]], jsii.get(self, "backgroundColorInput"))

    @builtins.property
    @jsii.member(jsii_name="blurInput")
    def blur_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualBlur]]], jsii.get(self, "blurInput"))

    @builtins.property
    @jsii.member(jsii_name="chromaKeyInput")
    def chroma_key_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualChromaKey]]], jsii.get(self, "chromaKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="compositeInput")
    def composite_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualComposite]]], jsii.get(self, "compositeInput"))

    @builtins.property
    @jsii.member(jsii_name="compoundInput")
    def compound_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualCompound]]], jsii.get(self, "compoundInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualContrast]]], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="goopInput")
    def goop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualGoop]]], jsii.get(self, "goopInput"))

    @builtins.property
    @jsii.member(jsii_name="grayscaleInput")
    def grayscale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualGrayscale]]], jsii.get(self, "grayscaleInput"))

    @builtins.property
    @jsii.member(jsii_name="hslInput")
    def hsl_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualHsl]]], jsii.get(self, "hslInput"))

    @builtins.property
    @jsii.member(jsii_name="hsvInput")
    def hsv_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualHsv]]], jsii.get(self, "hsvInput"))

    @builtins.property
    @jsii.member(jsii_name="ifDimensionInput")
    def if_dimension_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfDimension]]], jsii.get(self, "ifDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientationInput")
    def if_orientation_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfOrientation]]], jsii.get(self, "ifOrientationInput"))

    @builtins.property
    @jsii.member(jsii_name="maxColorsInput")
    def max_colors_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualMaxColors]]], jsii.get(self, "maxColorsInput"))

    @builtins.property
    @jsii.member(jsii_name="mirrorInput")
    def mirror_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualMirror]]], jsii.get(self, "mirrorInput"))

    @builtins.property
    @jsii.member(jsii_name="monoHueInput")
    def mono_hue_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualMonoHue]]], jsii.get(self, "monoHueInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualOpacity]]], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="removeColorInput")
    def remove_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualRemoveColor"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualRemoveColor"]]], jsii.get(self, "removeColorInput"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMaskInput")
    def unsharp_mask_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualUnsharpMask"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualUnsharpMask"]]], jsii.get(self, "unsharpMaskInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqual], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqual],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e4b23ec89f0c7c64890fc7fc18cc98883accaae0d2f3ad0faae904b87fea42d3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualRemoveColor",
    jsii_struct_bases=[],
    name_mapping={
        "color": "color",
        "color_var": "colorVar",
        "feather": "feather",
        "feather_var": "featherVar",
        "tolerance": "tolerance",
        "tolerance_var": "toleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualRemoveColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
        feather: typing.Optional[builtins.str] = None,
        feather_var: typing.Optional[builtins.str] = None,
        tolerance: typing.Optional[builtins.str] = None,
        tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        :param feather: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        :param feather_var: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        :param tolerance: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        :param tolerance_var: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9cd9fa1200dc547d99048ec22631d0e173b540ca79803f2bf1e2f1d19d7bbfc8)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
            check_type(argname="argument feather", value=feather, expected_type=type_hints["feather"])
            check_type(argname="argument feather_var", value=feather_var, expected_type=type_hints["feather_var"])
            check_type(argname="argument tolerance", value=tolerance, expected_type=type_hints["tolerance"])
            check_type(argname="argument tolerance_var", value=tolerance_var, expected_type=type_hints["tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var
        if feather is not None:
            self._values["feather"] = feather
        if feather_var is not None:
            self._values["feather_var"] = feather_var
        if tolerance is not None:
            self._values["tolerance"] = tolerance
        if tolerance_var is not None:
            self._values["tolerance_var"] = tolerance_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        '''
        result = self._values.get("feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather_var(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        '''
        result = self._values.get("feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        '''
        result = self._values.get("tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance_var(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        result = self._values.get("tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualRemoveColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualRemoveColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualRemoveColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f95d9298e7396923ea514a84e2a9fd38f09fb712d0075303d7a9fc8fe88b8883)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualRemoveColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9424455b72cf927c89d018c852a4c1484cbf2d4c04af70ce1a5d1fb74866184b)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualRemoveColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__60a451c97ef587bb71fd04a5397abf7b699757b61b1e2db348d269c162faf043)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af12168d36fbaa8d9fd4a99d8cfae5cc763c5e9921fdca69444f422c25d85a02)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0af2988ed2f799743b54bab0ee097bc68b67c64a6bad18e440ab1148080fd7b0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualRemoveColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualRemoveColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualRemoveColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6474049534276ba170d60a91092fde9b258d3cc45ef968fa4c21aa696bc9c87d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualRemoveColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualRemoveColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5363a1aa43ba07cadca273ea3ef00c89663fd097d1b195729f726d35170483c8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @jsii.member(jsii_name="resetFeather")
    def reset_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeather", []))

    @jsii.member(jsii_name="resetFeatherVar")
    def reset_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatherVar", []))

    @jsii.member(jsii_name="resetTolerance")
    def reset_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTolerance", []))

    @jsii.member(jsii_name="resetToleranceVar")
    def reset_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featherInput")
    def feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherInput"))

    @builtins.property
    @jsii.member(jsii_name="featherVarInput")
    def feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceInput")
    def tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceVarInput")
    def tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__83da2c1d1115fda2fe10ff0f065a69d4779eccfe4e68c6065410b54056eef2b7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a1b2d90229238d0eba3c154a8017f7f8f0f3e8d4e292bdb1a5f1a34516e9321)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="feather")
    def feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "feather"))

    @feather.setter
    def feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eaedf91bd596da3333caa340bfb868601e622f32cef2c97aef8a48946360ae58)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "feather", value)

    @builtins.property
    @jsii.member(jsii_name="featherVar")
    def feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featherVar"))

    @feather_var.setter
    def feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b9ab71421431ad868963aab3ce7ee14aacbf9cf0b5cd06c590a2d834d9b897c2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featherVar", value)

    @builtins.property
    @jsii.member(jsii_name="tolerance")
    def tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tolerance"))

    @tolerance.setter
    def tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd9451ef08a15cf019f051d77d733fdaab4ee27861aef6e654819595f8b48fd8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tolerance", value)

    @builtins.property
    @jsii.member(jsii_name="toleranceVar")
    def tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "toleranceVar"))

    @tolerance_var.setter
    def tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__16a3e6003f97e6cfbce8a53e70018c4396fa0d37cbf402b0a2b4e40e97f93e56)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "toleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualRemoveColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualRemoveColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualRemoveColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__11b0845330de823e65557b1ed3a66a798e6558658f27269d0505256efdaa0c28)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualUnsharpMask",
    jsii_struct_bases=[],
    name_mapping={
        "gain": "gain",
        "gain_var": "gainVar",
        "sigma": "sigma",
        "sigma_var": "sigmaVar",
        "threshold": "threshold",
        "threshold_var": "thresholdVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualUnsharpMask:
    def __init__(
        self,
        *,
        gain: typing.Optional[builtins.str] = None,
        gain_var: typing.Optional[builtins.str] = None,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
        threshold: typing.Optional[builtins.str] = None,
        threshold_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param gain: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        :param gain_var: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        :param sigma: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        :param threshold: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        :param threshold_var: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5e458b25be57738a5e83d7c3b551abe900741a62687701d3c9d4e3ea8c97bff4)
            check_type(argname="argument gain", value=gain, expected_type=type_hints["gain"])
            check_type(argname="argument gain_var", value=gain_var, expected_type=type_hints["gain_var"])
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
            check_type(argname="argument threshold", value=threshold, expected_type=type_hints["threshold"])
            check_type(argname="argument threshold_var", value=threshold_var, expected_type=type_hints["threshold_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if gain is not None:
            self._values["gain"] = gain
        if gain_var is not None:
            self._values["gain_var"] = gain_var
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var
        if threshold is not None:
            self._values["threshold"] = threshold
        if threshold_var is not None:
            self._values["threshold_var"] = threshold_var

    @builtins.property
    def gain(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        '''
        result = self._values.get("gain")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gain_var(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        '''
        result = self._values.get("gain_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        '''
        result = self._values.get("threshold")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold_var(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        result = self._values.get("threshold_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualUnsharpMask(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualUnsharpMaskList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualUnsharpMaskList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__61abd9000a25df57ac28dabe0ed03bb92e0aaf22a2d39b6b15fb1a9bb606de9d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualUnsharpMaskOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3438459c30f2ffd31ef1dfe5defee35241d9c44da555c8dd4c0414fceae2c1b8)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualUnsharpMaskOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9de086c73af871de1480979ec29404be740cd406e5a78b2694528b0bc5e6b545)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4468e67e6b7c2879e8d005410b66f8c10fcc12718a084d6acf0847a5b8e07971)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fd710e23ea49ca06f2bc7d05355890624b3cd10442c3cdd0a561546af5b6b8fc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualUnsharpMask]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualUnsharpMask]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualUnsharpMask]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__899e5ef895eb473aa5d08464cf1395403f5b28237d8d4e863a2c5a2683ecd329)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualUnsharpMaskOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualUnsharpMaskOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__238f5f2d30811cbc1b309533e87712f24d20d4fbfd2d932af0fa5564cf4bd4ef)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetGain")
    def reset_gain(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGain", []))

    @jsii.member(jsii_name="resetGainVar")
    def reset_gain_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGainVar", []))

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @jsii.member(jsii_name="resetThreshold")
    def reset_threshold(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThreshold", []))

    @jsii.member(jsii_name="resetThresholdVar")
    def reset_threshold_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThresholdVar", []))

    @builtins.property
    @jsii.member(jsii_name="gainInput")
    def gain_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainInput"))

    @builtins.property
    @jsii.member(jsii_name="gainVarInput")
    def gain_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdInput")
    def threshold_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdVarInput")
    def threshold_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gain")
    def gain(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gain"))

    @gain.setter
    def gain(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__667cbc286735ebefb0215d315078788aa0506c4f9f9384219885f65358f0ec96)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gain", value)

    @builtins.property
    @jsii.member(jsii_name="gainVar")
    def gain_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gainVar"))

    @gain_var.setter
    def gain_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1cc11cb88823f61476a0f7a3b2cabe617f93cfb3784c5ec798a708509ee06c9b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gainVar", value)

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5b6f5ba8f25f2953600bc5429f6f7bd0035743599814c5b9871ff0e3c0d231ef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f4b5f12e51c660af5f520a549f8f25955ea8313ee2b2d07bc9a9f3b4f0b41cdb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="threshold")
    def threshold(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "threshold"))

    @threshold.setter
    def threshold(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0a56b9625f314c74706a202f2c0e41758677f80e7e719e7a002956dcf08bcc86)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "threshold", value)

    @builtins.property
    @jsii.member(jsii_name="thresholdVar")
    def threshold_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "thresholdVar"))

    @threshold_var.setter
    def threshold_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6b66eee0d7ce0a2fa3e16b0e56f3871b6d040a9c1dc8976f47735ed85bf9a8e5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "thresholdVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualUnsharpMask]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualUnsharpMask]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualUnsharpMask]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__706d0e2224f6b3a6b88b23fffdc0e86b68f403fcd315c5e5acb55a98dacbab62)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThan",
    jsii_struct_bases=[],
    name_mapping={
        "background_color": "backgroundColor",
        "blur": "blur",
        "chroma_key": "chromaKey",
        "composite": "composite",
        "compound": "compound",
        "contrast": "contrast",
        "goop": "goop",
        "grayscale": "grayscale",
        "hsl": "hsl",
        "hsv": "hsv",
        "if_dimension": "ifDimension",
        "if_orientation": "ifOrientation",
        "max_colors": "maxColors",
        "mirror": "mirror",
        "mono_hue": "monoHue",
        "opacity": "opacity",
        "remove_color": "removeColor",
        "unsharp_mask": "unsharpMask",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThan:
    def __init__(
        self,
        *,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanBackgroundColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanBlur", typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanChromaKey", typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanComposite", typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanCompound", typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanContrast", typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanGoop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanGrayscale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanHsl", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanHsv", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfDimension", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfOrientation", typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanMaxColors", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanMirror", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanMonoHue", typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanOpacity", typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanRemoveColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanUnsharpMask", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c7dda430a5f7c1b532ecdfc8d4191af62cbfdc46a4c9d67a95e1768bbfeb3329)
            check_type(argname="argument background_color", value=background_color, expected_type=type_hints["background_color"])
            check_type(argname="argument blur", value=blur, expected_type=type_hints["blur"])
            check_type(argname="argument chroma_key", value=chroma_key, expected_type=type_hints["chroma_key"])
            check_type(argname="argument composite", value=composite, expected_type=type_hints["composite"])
            check_type(argname="argument compound", value=compound, expected_type=type_hints["compound"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument goop", value=goop, expected_type=type_hints["goop"])
            check_type(argname="argument grayscale", value=grayscale, expected_type=type_hints["grayscale"])
            check_type(argname="argument hsl", value=hsl, expected_type=type_hints["hsl"])
            check_type(argname="argument hsv", value=hsv, expected_type=type_hints["hsv"])
            check_type(argname="argument if_dimension", value=if_dimension, expected_type=type_hints["if_dimension"])
            check_type(argname="argument if_orientation", value=if_orientation, expected_type=type_hints["if_orientation"])
            check_type(argname="argument max_colors", value=max_colors, expected_type=type_hints["max_colors"])
            check_type(argname="argument mirror", value=mirror, expected_type=type_hints["mirror"])
            check_type(argname="argument mono_hue", value=mono_hue, expected_type=type_hints["mono_hue"])
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument remove_color", value=remove_color, expected_type=type_hints["remove_color"])
            check_type(argname="argument unsharp_mask", value=unsharp_mask, expected_type=type_hints["unsharp_mask"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if background_color is not None:
            self._values["background_color"] = background_color
        if blur is not None:
            self._values["blur"] = blur
        if chroma_key is not None:
            self._values["chroma_key"] = chroma_key
        if composite is not None:
            self._values["composite"] = composite
        if compound is not None:
            self._values["compound"] = compound
        if contrast is not None:
            self._values["contrast"] = contrast
        if goop is not None:
            self._values["goop"] = goop
        if grayscale is not None:
            self._values["grayscale"] = grayscale
        if hsl is not None:
            self._values["hsl"] = hsl
        if hsv is not None:
            self._values["hsv"] = hsv
        if if_dimension is not None:
            self._values["if_dimension"] = if_dimension
        if if_orientation is not None:
            self._values["if_orientation"] = if_orientation
        if max_colors is not None:
            self._values["max_colors"] = max_colors
        if mirror is not None:
            self._values["mirror"] = mirror
        if mono_hue is not None:
            self._values["mono_hue"] = mono_hue
        if opacity is not None:
            self._values["opacity"] = opacity
        if remove_color is not None:
            self._values["remove_color"] = remove_color
        if unsharp_mask is not None:
            self._values["unsharp_mask"] = unsharp_mask

    @builtins.property
    def background_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanBackgroundColor"]]]:
        '''background_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        '''
        result = self._values.get("background_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanBackgroundColor"]]], result)

    @builtins.property
    def blur(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanBlur"]]]:
        '''blur block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        '''
        result = self._values.get("blur")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanBlur"]]], result)

    @builtins.property
    def chroma_key(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanChromaKey"]]]:
        '''chroma_key block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        '''
        result = self._values.get("chroma_key")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanChromaKey"]]], result)

    @builtins.property
    def composite(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanComposite"]]]:
        '''composite block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        '''
        result = self._values.get("composite")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanComposite"]]], result)

    @builtins.property
    def compound(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanCompound"]]]:
        '''compound block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        '''
        result = self._values.get("compound")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanCompound"]]], result)

    @builtins.property
    def contrast(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanContrast"]]]:
        '''contrast block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanContrast"]]], result)

    @builtins.property
    def goop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanGoop"]]]:
        '''goop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        '''
        result = self._values.get("goop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanGoop"]]], result)

    @builtins.property
    def grayscale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanGrayscale"]]]:
        '''grayscale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        '''
        result = self._values.get("grayscale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanGrayscale"]]], result)

    @builtins.property
    def hsl(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanHsl"]]]:
        '''hsl block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        '''
        result = self._values.get("hsl")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanHsl"]]], result)

    @builtins.property
    def hsv(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanHsv"]]]:
        '''hsv block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        '''
        result = self._values.get("hsv")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanHsv"]]], result)

    @builtins.property
    def if_dimension(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfDimension"]]]:
        '''if_dimension block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        '''
        result = self._values.get("if_dimension")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfDimension"]]], result)

    @builtins.property
    def if_orientation(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfOrientation"]]]:
        '''if_orientation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        '''
        result = self._values.get("if_orientation")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfOrientation"]]], result)

    @builtins.property
    def max_colors(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanMaxColors"]]]:
        '''max_colors block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        '''
        result = self._values.get("max_colors")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanMaxColors"]]], result)

    @builtins.property
    def mirror(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanMirror"]]]:
        '''mirror block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        '''
        result = self._values.get("mirror")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanMirror"]]], result)

    @builtins.property
    def mono_hue(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanMonoHue"]]]:
        '''mono_hue block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        '''
        result = self._values.get("mono_hue")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanMonoHue"]]], result)

    @builtins.property
    def opacity(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanOpacity"]]]:
        '''opacity block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanOpacity"]]], result)

    @builtins.property
    def remove_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanRemoveColor"]]]:
        '''remove_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        '''
        result = self._values.get("remove_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanRemoveColor"]]], result)

    @builtins.property
    def unsharp_mask(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanUnsharpMask"]]]:
        '''unsharp_mask block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        result = self._values.get("unsharp_mask")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanUnsharpMask"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanBackgroundColor",
    jsii_struct_bases=[],
    name_mapping={"color": "color", "color_var": "colorVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanBackgroundColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5a8461ce47273008f7ec90415bb7664cb85f28ce37801808c4a4ee1bf88f73e5)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanBackgroundColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanBackgroundColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanBackgroundColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ba831df5d53e38d5fe16d11ec7da2e50435ddbf3f650e1690b8858eb88e9ffe)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanBackgroundColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__87b47c286ae4a03878e3a50350bb536a07a66027b28132ecebb2aadfef8dd5ef)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanBackgroundColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9aaba333268f44f1f1e8e2597e6b72493e3bc1061596f58b68138bcb121f774a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0aeacb507ef6216da6e7bee0fd396e59f21b08c4fada083cd094028f002cbd89)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0449e82aeac677004e82b2ec726d362527051032c518c6d92c30649d5de36d2f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanBackgroundColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanBackgroundColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b617ac6049d6c7ab0b56f6090d48253299ad4dedea31e8fbe80a11eb7aeca3a8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanBackgroundColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanBackgroundColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8591574f58480f474e58d05c02f3f22875a51148d61d7f3f57d9aef9321ba0c6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ac14c8981262f82092f2e9cc2e0e80383096e4e1ff3d67daf599d162aa62ea4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d3e6105851380f5be71623a5943822199de37dc126db47cd4c4bf04b19534dbe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanBackgroundColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanBackgroundColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanBackgroundColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a81fd8ebdbc75f42dd4698f3f4c2d6d099486e5c826d8e51cc3d4b4ec090f2ca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanBlur",
    jsii_struct_bases=[],
    name_mapping={"sigma": "sigma", "sigma_var": "sigmaVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanBlur:
    def __init__(
        self,
        *,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param sigma: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__34e6473e702e4df5d891e9c19404245d429171a3bc4aab505eb3aaba96164ea8)
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanBlur(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanBlurList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanBlurList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2554b3beaaa2fcee16481350ebf017d5b9e4e666294ea26ec44ad9e6783fb5cb)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanBlurOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a2e05b60c722f154061fbc4a37efb35e6645078d3da10424b8eed6d2d8d7f9be)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanBlurOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ee62455a750f70c1f436a1f46ef876331cd15b1de0a5b4c770ce905419f94cc8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a18419b346580c9d5cfc893049e55941b0e4758d9505573a195f97e2bb414259)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e031589f52053b2fe2b23fec7dfb59c143c3bfd583cd93730a339137598473b7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanBlur]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanBlur]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ffe3144fd69b9437407f7a6790d739edab8ad42a60c82db455928b555571b6f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanBlurOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanBlurOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e1bb26e6adcf8fbae08e7ffed519b6a93423e74c2c55eb62f5e7538c92291735)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__89aaead51260fb027b815262ba240f4628697e31208bbe1fc580f1daf606d4d5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2179acb884ca45fa6fe018da9e8e592bbb43595ada5822beb1e464ad1dd97fa9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanBlur]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanBlur]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanBlur]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b52b4581911ceab56fe57b3384ee05e2007c4dc761093e5043851156d968f6b8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanChromaKey",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_feather": "hueFeather",
        "hue_feather_var": "hueFeatherVar",
        "hue_tolerance": "hueTolerance",
        "hue_tolerance_var": "hueToleranceVar",
        "hue_var": "hueVar",
        "lightness_feather": "lightnessFeather",
        "lightness_feather_var": "lightnessFeatherVar",
        "lightness_tolerance": "lightnessTolerance",
        "lightness_tolerance_var": "lightnessToleranceVar",
        "saturation_feather": "saturationFeather",
        "saturation_feather_var": "saturationFeatherVar",
        "saturation_tolerance": "saturationTolerance",
        "saturation_tolerance_var": "saturationToleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanChromaKey:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_feather: typing.Optional[builtins.str] = None,
        hue_feather_var: typing.Optional[builtins.str] = None,
        hue_tolerance: typing.Optional[builtins.str] = None,
        hue_tolerance_var: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness_feather: typing.Optional[builtins.str] = None,
        lightness_feather_var: typing.Optional[builtins.str] = None,
        lightness_tolerance: typing.Optional[builtins.str] = None,
        lightness_tolerance_var: typing.Optional[builtins.str] = None,
        saturation_feather: typing.Optional[builtins.str] = None,
        saturation_feather_var: typing.Optional[builtins.str] = None,
        saturation_tolerance: typing.Optional[builtins.str] = None,
        saturation_tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_feather: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        :param hue_feather_var: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        :param hue_tolerance: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        :param hue_tolerance_var: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        :param hue_var: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness_feather: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        :param lightness_feather_var: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        :param lightness_tolerance: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        :param lightness_tolerance_var: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        :param saturation_feather: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        :param saturation_feather_var: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        :param saturation_tolerance: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        :param saturation_tolerance_var: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__414275b6e8cab6c700b2ee938844b823931bb655bc02d05f2b395ae30ea15ab3)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_feather", value=hue_feather, expected_type=type_hints["hue_feather"])
            check_type(argname="argument hue_feather_var", value=hue_feather_var, expected_type=type_hints["hue_feather_var"])
            check_type(argname="argument hue_tolerance", value=hue_tolerance, expected_type=type_hints["hue_tolerance"])
            check_type(argname="argument hue_tolerance_var", value=hue_tolerance_var, expected_type=type_hints["hue_tolerance_var"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness_feather", value=lightness_feather, expected_type=type_hints["lightness_feather"])
            check_type(argname="argument lightness_feather_var", value=lightness_feather_var, expected_type=type_hints["lightness_feather_var"])
            check_type(argname="argument lightness_tolerance", value=lightness_tolerance, expected_type=type_hints["lightness_tolerance"])
            check_type(argname="argument lightness_tolerance_var", value=lightness_tolerance_var, expected_type=type_hints["lightness_tolerance_var"])
            check_type(argname="argument saturation_feather", value=saturation_feather, expected_type=type_hints["saturation_feather"])
            check_type(argname="argument saturation_feather_var", value=saturation_feather_var, expected_type=type_hints["saturation_feather_var"])
            check_type(argname="argument saturation_tolerance", value=saturation_tolerance, expected_type=type_hints["saturation_tolerance"])
            check_type(argname="argument saturation_tolerance_var", value=saturation_tolerance_var, expected_type=type_hints["saturation_tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_feather is not None:
            self._values["hue_feather"] = hue_feather
        if hue_feather_var is not None:
            self._values["hue_feather_var"] = hue_feather_var
        if hue_tolerance is not None:
            self._values["hue_tolerance"] = hue_tolerance
        if hue_tolerance_var is not None:
            self._values["hue_tolerance_var"] = hue_tolerance_var
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness_feather is not None:
            self._values["lightness_feather"] = lightness_feather
        if lightness_feather_var is not None:
            self._values["lightness_feather_var"] = lightness_feather_var
        if lightness_tolerance is not None:
            self._values["lightness_tolerance"] = lightness_tolerance
        if lightness_tolerance_var is not None:
            self._values["lightness_tolerance_var"] = lightness_tolerance_var
        if saturation_feather is not None:
            self._values["saturation_feather"] = saturation_feather
        if saturation_feather_var is not None:
            self._values["saturation_feather_var"] = saturation_feather_var
        if saturation_tolerance is not None:
            self._values["saturation_tolerance"] = saturation_tolerance
        if saturation_tolerance_var is not None:
            self._values["saturation_tolerance_var"] = saturation_tolerance_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        '''
        result = self._values.get("hue_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        '''
        result = self._values.get("hue_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        '''
        result = self._values.get("hue_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        '''
        result = self._values.get("hue_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        '''
        result = self._values.get("lightness_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        '''
        result = self._values.get("lightness_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        '''
        result = self._values.get("lightness_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        '''
        result = self._values.get("lightness_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        '''
        result = self._values.get("saturation_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        '''
        result = self._values.get("saturation_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        '''
        result = self._values.get("saturation_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        result = self._values.get("saturation_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanChromaKey(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanChromaKeyList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanChromaKeyList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7518cfd722694fe0a4c7b37e5764034559f48998807728b46030c5f512881e09)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanChromaKeyOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d2777827b8c99ca485938576956f1db02dc8480826721d4e3c3acbb6393290f4)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanChromaKeyOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__981687f23833c440f505fb9f0ebaf035c71e2d6db434e1fc82177f0697d35166)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5aa30d0e372fdbc6f85acf30372693b5acfd3328bfcee58184d020a6ec487f46)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b32e5d21d797de8516d9de5e128f1d0885b4dfaf97fe52f9a47929efcfc662eb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanChromaKey]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanChromaKey]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__afb7855cb31220628ee59db1e07d75ca803f66d4947fe4257b0ea87ccc3fb8c9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanChromaKeyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanChromaKeyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c0cf5262db8f3a88700b050656bb518d626c29534a0f96a5bedeb532768ecc2b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueFeather")
    def reset_hue_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeather", []))

    @jsii.member(jsii_name="resetHueFeatherVar")
    def reset_hue_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeatherVar", []))

    @jsii.member(jsii_name="resetHueTolerance")
    def reset_hue_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueTolerance", []))

    @jsii.member(jsii_name="resetHueToleranceVar")
    def reset_hue_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueToleranceVar", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightnessFeather")
    def reset_lightness_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeather", []))

    @jsii.member(jsii_name="resetLightnessFeatherVar")
    def reset_lightness_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeatherVar", []))

    @jsii.member(jsii_name="resetLightnessTolerance")
    def reset_lightness_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessTolerance", []))

    @jsii.member(jsii_name="resetLightnessToleranceVar")
    def reset_lightness_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessToleranceVar", []))

    @jsii.member(jsii_name="resetSaturationFeather")
    def reset_saturation_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeather", []))

    @jsii.member(jsii_name="resetSaturationFeatherVar")
    def reset_saturation_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeatherVar", []))

    @jsii.member(jsii_name="resetSaturationTolerance")
    def reset_saturation_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationTolerance", []))

    @jsii.member(jsii_name="resetSaturationToleranceVar")
    def reset_saturation_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherInput")
    def hue_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVarInput")
    def hue_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceInput")
    def hue_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVarInput")
    def hue_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherInput")
    def lightness_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVarInput")
    def lightness_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceInput")
    def lightness_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVarInput")
    def lightness_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherInput")
    def saturation_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVarInput")
    def saturation_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceInput")
    def saturation_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVarInput")
    def saturation_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cb8a6d8255863e139e3d84d5c869a9d7988a5a1b5e07fd1cf3796cec34724a1d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeather")
    def hue_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeather"))

    @hue_feather.setter
    def hue_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb2cb1b681652404311448f5ee0ece39e47508d42a2682eb1397a2d56a384353)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeather", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVar")
    def hue_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeatherVar"))

    @hue_feather_var.setter
    def hue_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__60a8ed1858072df0e2123a3b62dee766c35d55fa6ae4ee97de401605cb228977)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueTolerance")
    def hue_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueTolerance"))

    @hue_tolerance.setter
    def hue_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2e57e13e82a7eba270416e2741291ce3bb916abf62ffdbe6fd592bfd40e16f1b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVar")
    def hue_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueToleranceVar"))

    @hue_tolerance_var.setter
    def hue_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__75fffd307f05c62a6bd5e8f2e5b6bc6009ad030982e27fe4cfb031c270b60064)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bcd2dfb2ad04b92ce93603aca80f90cde8d367e1d039ece580c57a0b13b6d40d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeather")
    def lightness_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeather"))

    @lightness_feather.setter
    def lightness_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__17fde7f99a7281b35156c0b2b566820ef5827d6b70ed68d001e20e46708618e3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeather", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVar")
    def lightness_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeatherVar"))

    @lightness_feather_var.setter
    def lightness_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ccabea2cad56238702638f7814421cbdbf952a12f18c3de513369d928f4604c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessTolerance")
    def lightness_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessTolerance"))

    @lightness_tolerance.setter
    def lightness_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7e5b7c92c68dbae7340351a416e8edb948ac868cedfd5fde709aa70c45508bc1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVar")
    def lightness_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessToleranceVar"))

    @lightness_tolerance_var.setter
    def lightness_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__951c35d62d09d5c7c9740065e1ccb8141a4109f3759d5c9e4a55846c08af335c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeather")
    def saturation_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeather"))

    @saturation_feather.setter
    def saturation_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__743bc87c1b5c57c1b3722866f13f23786b65bd5788eccb4783485c36827ecb6a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeather", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVar")
    def saturation_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeatherVar"))

    @saturation_feather_var.setter
    def saturation_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ff27c1237477f55c6d27181056610827f91cb0d6597e362d2f5c7f7d5bd47f9a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationTolerance")
    def saturation_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationTolerance"))

    @saturation_tolerance.setter
    def saturation_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f52ec74f1e13d6910f1a30a17441754347e20f885ff95a44edc5fe00815525df)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVar")
    def saturation_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationToleranceVar"))

    @saturation_tolerance_var.setter
    def saturation_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bdf3b992a4c5265e50b43bd74b86a24280d0d3635d62027135c2b9dfeb0a6e66)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanChromaKey]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanChromaKey]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanChromaKey]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__95a51f258c56e45d11f0662cfb17dc60270feab115bd48a99838586353c976cb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanComposite",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "placement": "placement",
        "placement_var": "placementVar",
        "scale": "scale",
        "scale_dimension": "scaleDimension",
        "scale_dimension_var": "scaleDimensionVar",
        "scale_var": "scaleVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanComposite:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanCompositeImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        placement: typing.Optional[builtins.str] = None,
        placement_var: typing.Optional[builtins.str] = None,
        scale: typing.Optional[builtins.str] = None,
        scale_dimension: typing.Optional[builtins.str] = None,
        scale_dimension_var: typing.Optional[builtins.str] = None,
        scale_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param placement: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        :param placement_var: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        :param scale: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param scale_dimension: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        :param scale_dimension_var: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        :param scale_var: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        :param x_position: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanCompositeImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3abfbe8cb6377272959eb85b25aacb960956286bf7a7fea0cbd3b1e2391c97fd)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument placement", value=placement, expected_type=type_hints["placement"])
            check_type(argname="argument placement_var", value=placement_var, expected_type=type_hints["placement_var"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument scale_dimension", value=scale_dimension, expected_type=type_hints["scale_dimension"])
            check_type(argname="argument scale_dimension_var", value=scale_dimension_var, expected_type=type_hints["scale_dimension_var"])
            check_type(argname="argument scale_var", value=scale_var, expected_type=type_hints["scale_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if placement is not None:
            self._values["placement"] = placement
        if placement_var is not None:
            self._values["placement_var"] = placement_var
        if scale is not None:
            self._values["scale"] = scale
        if scale_dimension is not None:
            self._values["scale_dimension"] = scale_dimension
        if scale_dimension_var is not None:
            self._values["scale_dimension_var"] = scale_dimension_var
        if scale_var is not None:
            self._values["scale_var"] = scale_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanCompositeImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanCompositeImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        '''
        result = self._values.get("placement")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement_var(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        '''
        result = self._values.get("placement_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        '''
        result = self._values.get("scale_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        '''
        result = self._values.get("scale_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        '''
        result = self._values.get("scale_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanComposite(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanCompositeImage",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanCompositeImage:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanCompositeImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanCompositeImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanCompositeImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4c8fce1c6739afe597f87d9b9197028c23b21e2adaddce439a5fa82b3dc05f3c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanCompositeImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanCompositeImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e67fa400242bd4a60b8993fd622b8380781774feac92d63b35f1628fc86e9007)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanCompositeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanCompositeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ec9a3257a600539919ca6ff9a2712ae968faa692a6d63bef3cf17ebe14eaf082)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanCompositeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6cd9b94bfb8a1d796bb9314972c209671e38c64423ac313afb365632b5cfbd9c)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanCompositeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a1681d456e4ac42d3bf49c79bf17ebeef27ded2b3fbf02cb78bb792de9389fe0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd83249d39e0d626be31ebfd7f108f7943243abc6b8bdd3b0e4c9846ca31bf0c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f7c6ee9026a6d05bc79a809b8aedb35a969635a745fefed6c6b88f0dffcaad8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanComposite]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanComposite]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__810eacab11f92eb73029b4b6cce0206a0f91260a50d3e10aaa3d6608d3759acb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanCompositeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanCompositeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5bd53f0f56ffa3d0eea25b500bf59315f48b578ca2578d263e0ac2b608562bc3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanCompositeImage()

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPlacement")
    def reset_placement(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacement", []))

    @jsii.member(jsii_name="resetPlacementVar")
    def reset_placement_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacementVar", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetScaleDimension")
    def reset_scale_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimension", []))

    @jsii.member(jsii_name="resetScaleDimensionVar")
    def reset_scale_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimensionVar", []))

    @jsii.member(jsii_name="resetScaleVar")
    def reset_scale_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanCompositeImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanCompositeImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanCompositeImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="placementInput")
    def placement_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementInput"))

    @builtins.property
    @jsii.member(jsii_name="placementVarInput")
    def placement_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionInput")
    def scale_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVarInput")
    def scale_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleVarInput")
    def scale_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b089e74067122cc186c0b8d3f46bb4fa34877290ec2bed4df196b6b4684bcc17)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fd792b0fb18192a4eb64d35c69ac8a897111b37c5ecbbdcea4196b548c05b334)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="placement")
    def placement(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placement"))

    @placement.setter
    def placement(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__799d0c2c8fd0c4380b391f9822657ee3cae9ebef89186aa8095f503cfa3ec1b7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placement", value)

    @builtins.property
    @jsii.member(jsii_name="placementVar")
    def placement_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placementVar"))

    @placement_var.setter
    def placement_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6fdec0da66981591b8a872a8c20adfd06a865a3cb3d1f78520fca920dbd3c731)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placementVar", value)

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scale"))

    @scale.setter
    def scale(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__975499b13def20586372901ffeeaa0be583d7c232c78e2d1d01783a754192af9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scale", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimension")
    def scale_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimension"))

    @scale_dimension.setter
    def scale_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b5e88d42f38e0d3f8097300b9d1d1d573f1782b93d8d67762e53671f27459aed)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimension", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVar")
    def scale_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimensionVar"))

    @scale_dimension_var.setter
    def scale_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e04ad1fcc1674abb017d980896fb4fb80e9e0ad350e23ca97720978287c026f2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="scaleVar")
    def scale_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleVar"))

    @scale_var.setter
    def scale_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f3ce75c78a25e13d3b959648da2bdd2c9e493f7123bcb4e4956aa0a98eaa8ef3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5e4db4944943552bc2a4734fb218cd46d34c90bd962fac7f29aeadd4fa4e913e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__710357feaacd2e1ea20b8a14450cc2a047c58138a7cdd252346fc1ba181d818b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c6f86f51399267e952db15b70a5f746d5202ed2906149bc9554586b2089f7cb0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a4032fd9a5e876122fd62cb56b1e79df570a967ce40a5ca9159b60d1f4a1aef9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanComposite]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanComposite]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanComposite]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c797fac0e158089387de1181a9f6af78f9a0958051dd99861d9db64bb528a4e2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanCompound",
    jsii_struct_bases=[],
    name_mapping={"transformations": "transformations"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanCompound:
    def __init__(
        self,
        *,
        transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param transformations: transformations block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__07d0d49d42f0c0280d8827c0702310fe380c855dca9586ddd84e4a1ea9dfb35a)
            check_type(argname="argument transformations", value=transformations, expected_type=type_hints["transformations"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if transformations is not None:
            self._values["transformations"] = transformations

    @builtins.property
    def transformations(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanCompoundTransformations"]]]:
        '''transformations block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        result = self._values.get("transformations")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanCompoundTransformations"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanCompound(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanCompoundList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanCompoundList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__34552a1f98147b25547caaee5ead338b7e64cbdbc5e86d4f35b0c97f500af3b1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanCompoundOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__92de4d156cee6298bb977d36a63a1374c2f075d9f743d39c7454d1ac56b0a3b7)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanCompoundOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7656fcfbf5976127bf1131e5a99b98162bdf8fb2d6f0a80ec835ac60a1957ea5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__296fe60d25a19ec5b932918a65058faaedf13ee1f5fb82423b896deabe0a82b4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__81079465755ee68667ba82743c03c7ab8f2c952e02b7e0c86f51fe0e501008ee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanCompound]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanCompound]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c69174d6c2d9d530f713c923ced243886450508dce32219b488eb01de594837c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanCompoundOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanCompoundOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d6b91f241752cd8c360b002d44c1a3e69ba491ce6816a792d11319193275b3d9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformations")
    def put_transformations(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0abaefc0a6acd3ae48736066a3e5abfadd4d9b3f90f8eba98d04be7bdefc4947)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTransformations", [value]))

    @jsii.member(jsii_name="resetTransformations")
    def reset_transformations(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformations", []))

    @builtins.property
    @jsii.member(jsii_name="transformations")
    def transformations(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanCompoundTransformationsList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanCompoundTransformationsList", jsii.get(self, "transformations"))

    @builtins.property
    @jsii.member(jsii_name="transformationsInput")
    def transformations_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanCompoundTransformations"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanCompoundTransformations"]]], jsii.get(self, "transformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanCompound]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanCompound]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanCompound]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2f998cac078c08ab42b16614508c744c8ca1dc4c9ab9944f010e322a40d67cec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanCompoundTransformations",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanCompoundTransformations:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanCompoundTransformations(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanCompoundTransformationsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanCompoundTransformationsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d65b9915014f11a831ff1adea00d964855049da929c0854a6dd4841f0b266d00)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanCompoundTransformationsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4d905a8bf657a4f5ed059655b702739d19f66e331ea182867a359e6005d45c9c)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanCompoundTransformationsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6a52e4cf9e3a4f5ba4759d37e44fb6de8e1f2778ed19a461b128b9fed292d346)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cde2dbfc45e5ae0b29143f2e6204b6f3ff9897403150711edab6170c0ebab79e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__04e48118d3927ff84bcbfa8508d62531f0a9d799c09b94dcf4be74fd14e7a4e9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanCompoundTransformations]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanCompoundTransformations]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanCompoundTransformations]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af16abd08ce3c578d4984953497438e19567617ccd358ed5fb9912aefb02cb13)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanCompoundTransformationsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanCompoundTransformationsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a0c58e088f099e7984c04b43eb66ed2aaba14ca04916ac8f246719baa4e2c41e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanCompoundTransformations]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanCompoundTransformations]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanCompoundTransformations]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a479ec619594bec9950f6b0d49e9a83d95c8625b1332bd59b6b32e552506acc9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanContrast",
    jsii_struct_bases=[],
    name_mapping={
        "brightness": "brightness",
        "brightness_var": "brightnessVar",
        "contrast": "contrast",
        "contrast_var": "contrastVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanContrast:
    def __init__(
        self,
        *,
        brightness: typing.Optional[builtins.str] = None,
        brightness_var: typing.Optional[builtins.str] = None,
        contrast: typing.Optional[builtins.str] = None,
        contrast_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param brightness: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        :param brightness_var: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        :param contrast: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param contrast_var: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6b7d53507b2f82a88d474fac39f0e7683eddcd0afe52e4c36c80da56c842a36d)
            check_type(argname="argument brightness", value=brightness, expected_type=type_hints["brightness"])
            check_type(argname="argument brightness_var", value=brightness_var, expected_type=type_hints["brightness_var"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument contrast_var", value=contrast_var, expected_type=type_hints["contrast_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if brightness is not None:
            self._values["brightness"] = brightness
        if brightness_var is not None:
            self._values["brightness_var"] = brightness_var
        if contrast is not None:
            self._values["contrast"] = contrast
        if contrast_var is not None:
            self._values["contrast_var"] = contrast_var

    @builtins.property
    def brightness(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        '''
        result = self._values.get("brightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def brightness_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        '''
        result = self._values.get("brightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        result = self._values.get("contrast_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanContrast(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanContrastList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanContrastList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1a8cc488359c6e0e20d6bac99c5b1f40cb6a6454f0bf6d1f91798661fbbd0834)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanContrastOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ad97702e84f8162ef987fc4fbd0167894e4bcedb9bbc4c8d0c229d4aee067e9)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanContrastOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e1cb8b7e439fae766cf082f6e58f8c7e99376b34d0f6423b9dd7b2829362ca1c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__11948e18ad6900fd54c37d9d905f978d6d21a01d62ccdf8110991c41de1e98b7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__17bf628e7c7ae4e435a87f7dd72fcb4288b222231652f05fab3356fb23006c63)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanContrast]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanContrast]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__39e9c13f5d8d72561e8937435f60cdbc20d3e3a14b9788badb21caf2bb28ecdd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanContrastOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanContrastOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d3271d87270d2ab5e3f67cad585099f92d4bd5382e9aae3ab9d7b05d6682f9f6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetBrightness")
    def reset_brightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightness", []))

    @jsii.member(jsii_name="resetBrightnessVar")
    def reset_brightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightnessVar", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetContrastVar")
    def reset_contrast_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrastVar", []))

    @builtins.property
    @jsii.member(jsii_name="brightnessInput")
    def brightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="brightnessVarInput")
    def brightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastVarInput")
    def contrast_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="brightness")
    def brightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightness"))

    @brightness.setter
    def brightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__289c9f8cb365b190f523a8baf9a524d1092324b0e816bb8d84df4c1667171763)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightness", value)

    @builtins.property
    @jsii.member(jsii_name="brightnessVar")
    def brightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightnessVar"))

    @brightness_var.setter
    def brightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ac1df71a5d6f673a3b4f810d18a76e299ebcec505d0eb477c76c20364b519a2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrast"))

    @contrast.setter
    def contrast(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3da744d83495701a27325143291ff25683118588253ed2f08cd0ab2351cc60e6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrast", value)

    @builtins.property
    @jsii.member(jsii_name="contrastVar")
    def contrast_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrastVar"))

    @contrast_var.setter
    def contrast_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__514b31850211ba37b6b49ab0b2689d027f80dffb91cdcfd4f76a76b7f819b56c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrastVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanContrast]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanContrast]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanContrast]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6d910b9fc8e9c689b61d0e64ec5163c5284ffbba365f992fd55aae5805f24b16)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanGoop",
    jsii_struct_bases=[],
    name_mapping={
        "chaos": "chaos",
        "chaos_var": "chaosVar",
        "density": "density",
        "density_var": "densityVar",
        "power": "power",
        "power_var": "powerVar",
        "seed": "seed",
        "seed_var": "seedVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanGoop:
    def __init__(
        self,
        *,
        chaos: typing.Optional[builtins.str] = None,
        chaos_var: typing.Optional[builtins.str] = None,
        density: typing.Optional[builtins.str] = None,
        density_var: typing.Optional[builtins.str] = None,
        power: typing.Optional[builtins.str] = None,
        power_var: typing.Optional[builtins.str] = None,
        seed: typing.Optional[builtins.str] = None,
        seed_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param chaos: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        :param chaos_var: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        :param density: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        :param density_var: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        :param power: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        :param power_var: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        :param seed: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        :param seed_var: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__00d75455e21c56b9636e14e61a1185f64548f40f96096ae0af34b66664b3e995)
            check_type(argname="argument chaos", value=chaos, expected_type=type_hints["chaos"])
            check_type(argname="argument chaos_var", value=chaos_var, expected_type=type_hints["chaos_var"])
            check_type(argname="argument density", value=density, expected_type=type_hints["density"])
            check_type(argname="argument density_var", value=density_var, expected_type=type_hints["density_var"])
            check_type(argname="argument power", value=power, expected_type=type_hints["power"])
            check_type(argname="argument power_var", value=power_var, expected_type=type_hints["power_var"])
            check_type(argname="argument seed", value=seed, expected_type=type_hints["seed"])
            check_type(argname="argument seed_var", value=seed_var, expected_type=type_hints["seed_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if chaos is not None:
            self._values["chaos"] = chaos
        if chaos_var is not None:
            self._values["chaos_var"] = chaos_var
        if density is not None:
            self._values["density"] = density
        if density_var is not None:
            self._values["density_var"] = density_var
        if power is not None:
            self._values["power"] = power
        if power_var is not None:
            self._values["power_var"] = power_var
        if seed is not None:
            self._values["seed"] = seed
        if seed_var is not None:
            self._values["seed_var"] = seed_var

    @builtins.property
    def chaos(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        '''
        result = self._values.get("chaos")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def chaos_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        '''
        result = self._values.get("chaos_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        '''
        result = self._values.get("density")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density_var(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        '''
        result = self._values.get("density_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        '''
        result = self._values.get("power")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power_var(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        '''
        result = self._values.get("power_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        '''
        result = self._values.get("seed")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed_var(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        result = self._values.get("seed_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanGoop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanGoopList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanGoopList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__91dcf424181fb209baa2bae0a16cb0725ea3558a515e4f30a2d0b26a59a0992a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanGoopOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__346c9318fa72455c6bc3d3ffa2f06a936ac13b7314b09f2ae25c177ffcedbc84)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanGoopOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__db3c03e26fd0b1e7fe8570b680ec1d5d27372ec2db39a2ff3ae7a1b330a0f2f1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1ca62edc408d5a44687d190ce855f611da60f7990eac1e1fe264a20abeafee74)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__56c5eb59797ddc38d78248945ad2a8ae407ebec7f8fad8a47bdbee4d5ba36849)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanGoop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanGoop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8380dae7e2cb6e1ffad8b2473b8cea6d6b213f349c43055e058d6d7ff5ed66b2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanGoopOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanGoopOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__982a4526a47bca92b5f408822b29e680187a249c87b65ae467ee3ef0cbbaf11c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetChaos")
    def reset_chaos(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaos", []))

    @jsii.member(jsii_name="resetChaosVar")
    def reset_chaos_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaosVar", []))

    @jsii.member(jsii_name="resetDensity")
    def reset_density(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensity", []))

    @jsii.member(jsii_name="resetDensityVar")
    def reset_density_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensityVar", []))

    @jsii.member(jsii_name="resetPower")
    def reset_power(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPower", []))

    @jsii.member(jsii_name="resetPowerVar")
    def reset_power_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPowerVar", []))

    @jsii.member(jsii_name="resetSeed")
    def reset_seed(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeed", []))

    @jsii.member(jsii_name="resetSeedVar")
    def reset_seed_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeedVar", []))

    @builtins.property
    @jsii.member(jsii_name="chaosInput")
    def chaos_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosInput"))

    @builtins.property
    @jsii.member(jsii_name="chaosVarInput")
    def chaos_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosVarInput"))

    @builtins.property
    @jsii.member(jsii_name="densityInput")
    def density_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityInput"))

    @builtins.property
    @jsii.member(jsii_name="densityVarInput")
    def density_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="powerInput")
    def power_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerInput"))

    @builtins.property
    @jsii.member(jsii_name="powerVarInput")
    def power_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerVarInput"))

    @builtins.property
    @jsii.member(jsii_name="seedInput")
    def seed_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedInput"))

    @builtins.property
    @jsii.member(jsii_name="seedVarInput")
    def seed_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedVarInput"))

    @builtins.property
    @jsii.member(jsii_name="chaos")
    def chaos(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaos"))

    @chaos.setter
    def chaos(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be5fa1357e661f84a07a1570dc05811ffdfacb060b6eac9c2b9ccdad505d12e9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaos", value)

    @builtins.property
    @jsii.member(jsii_name="chaosVar")
    def chaos_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaosVar"))

    @chaos_var.setter
    def chaos_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c7a6f3d5ab2e12041f906546806d6770c5fee63ae47f4aca04b70f5fba17f470)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaosVar", value)

    @builtins.property
    @jsii.member(jsii_name="density")
    def density(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "density"))

    @density.setter
    def density(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1263c34d8dc30155ba6258686463e8c00bb4a450e9078d12c1c966c536285ce1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "density", value)

    @builtins.property
    @jsii.member(jsii_name="densityVar")
    def density_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "densityVar"))

    @density_var.setter
    def density_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8c20f5a015319bd0caab4178ea3b855da0c234f18936bc3151353482707809e0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "densityVar", value)

    @builtins.property
    @jsii.member(jsii_name="power")
    def power(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "power"))

    @power.setter
    def power(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__42d6ac88cd966696a6a5cc2b4b27189ad375dea72403123b9f561939d53654cf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "power", value)

    @builtins.property
    @jsii.member(jsii_name="powerVar")
    def power_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "powerVar"))

    @power_var.setter
    def power_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea4d8e7677b62b8e09ffaebb3761b06301030a20fd39009ccf6fe7480887eab7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "powerVar", value)

    @builtins.property
    @jsii.member(jsii_name="seed")
    def seed(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seed"))

    @seed.setter
    def seed(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4edda2985ce46e3521783fc68c933c82b4994126e6eaeddc8947a17e9fdeb086)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seed", value)

    @builtins.property
    @jsii.member(jsii_name="seedVar")
    def seed_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seedVar"))

    @seed_var.setter
    def seed_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__80e323bb828cf19f10d5f798694944f1c6a92889232d7b9a21033b65a45403c3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seedVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanGoop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanGoop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanGoop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__96b6977e0966339198e758b5c3bdf15036b42bc9fb0a43862efa364479b762ce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanGrayscale",
    jsii_struct_bases=[],
    name_mapping={"type": "type", "type_var": "typeVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanGrayscale:
    def __init__(
        self,
        *,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param type: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f89d9326e01968bcf7db151f611cfd04c250dc947e04a71ddd837972221c7fb)
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanGrayscale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanGrayscaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanGrayscaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__837106f5d11b949885a67bb88a59c09d75cc4c3edfadba9ba8dbf595b12063aa)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanGrayscaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b8b668a32c7bb4eb9ae61f23899aa3b213d2273270bfbd848d1c75ee6bed108c)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanGrayscaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__64058fe987f6772f51eea49dddc4b031fc88128cb780bd0642de2f9a7efd8d6b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7abab27fa62271033bb9eb7a5d1d439e64da19f9d3eabc7e7e023b7c15ab9636)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f40abac8892bc662300f3bdb95a3bb608f590196241ba383251b3dd4f049c56f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanGrayscale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanGrayscale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7bd7d0d3e6ae1b388554ca6a051feadfe0cd2b4580e8775046026fbab457389b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanGrayscaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanGrayscaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7309ef6fe1669a82bcbd9f756021c7b175b06e11031fdee364469c3a1beed015)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c24fabf11bb533bdfadbf34b705ed1a5f4b9d05aa2687718c1890c73b67e0f79)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d2470beb9152beafe8e965f452a6776205939deae817195ff2071b51dba369f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanGrayscale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanGrayscale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanGrayscale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0feb76f4d2e964691e276bf8044da5c36fc0c6935a35486d0338820da97cabc8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanHsl",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "lightness": "lightness",
        "lightness_var": "lightnessVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanHsl:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness: typing.Optional[builtins.str] = None,
        lightness_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        :param lightness_var: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b6f19068ea3e711b6a01dc30f4fa6cf81f5480bce2967a3f943cec1ab7a74fbd)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness", value=lightness, expected_type=type_hints["lightness"])
            check_type(argname="argument lightness_var", value=lightness_var, expected_type=type_hints["lightness_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness is not None:
            self._values["lightness"] = lightness
        if lightness_var is not None:
            self._values["lightness_var"] = lightness_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        '''
        result = self._values.get("lightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        '''
        result = self._values.get("lightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanHsl(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanHslList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanHslList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__41c8a106b2ad31f9b25070e8c73824ffb2fdfd7333a147b3690a34b4af7c5672)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanHslOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__77dc17cd485fd355eefae64041f8880b86b68934ed2bf0bfc5114b95c26d23e3)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanHslOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8f08ad53f82eefc95f1b4f3318170a1171873f76f4cf5cfddf91d292e663183b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fc7f51e9cb052df4854b5665500f8ddbafb0900af9aec66f27739d5986640388)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__13f76bb810372027265c84abded8547d5ecabe99b85d17f37dd351c42b64181c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanHsl]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanHsl]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5e0afb3ef7c4d46f6ab8c6b447f9dc5bc13acd74ee16bf0ea7d4ba076d03104b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanHslOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanHslOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__51f3429ec5747d13f5776aef8d96add0e4d5cb042563208eea4e84a3e1cd5fe8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightness")
    def reset_lightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightness", []))

    @jsii.member(jsii_name="resetLightnessVar")
    def reset_lightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessInput")
    def lightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessVarInput")
    def lightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c13d10684150ccafa153b054051faf2a64cc50e29f84d0fe5ec8dda1410e2f56)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__baccbc4a997b64f02ac2fffc72fd6ed96f397ab418ccec62c3df284a4009e10d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightness")
    def lightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightness"))

    @lightness.setter
    def lightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4d57d623fe0359248538a80eac4396a4d7d0780f57a61e965d972c5f87fd1a70)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightness", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessVar")
    def lightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessVar"))

    @lightness_var.setter
    def lightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8d4a07794e407615a8d28a38af4496028f1d6b431b2a4045a452addb9c5074cb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__408bf7493b86f27c2462cf5641e6c252a093b3cfd0ddc9ee2868d09eaf3458b9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__425cb5fdc15d6169c08c1988ec4f514d4082b48a6d893bc0033bcbb99b3138db)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanHsl]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanHsl]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanHsl]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0984d2e748e205527483606d6c1dbf7385857df9917a7a43d1cf3db333ca9724)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanHsv",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanHsv:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        :param value: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aa8394fe0dd2b7f0e44451a472d07cd058aca7547d2f2cc86539702f9c5fb3bd)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanHsv(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanHsvList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanHsvList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__61b6ee7b719da1ab9019ffed6081cac9bc51ae890e4884ee9a0c5b9c1a990548)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanHsvOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cbefb6eb9ac657279b48c9ff312849ae9fb715b239bfff04a630ee0fc935c55f)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanHsvOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e96359b303cf566539887c3ff853a0284de6fcc8d26428c3bab948d735ee036f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7f8fb55e6e36c486e33b7654158ec265b5dcd50dc08f6cd7def809edd1757229)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9b22df128950442d5ec29eabe07503e88421ed10461eee301a35cab1f89d0210)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanHsv]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanHsv]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ec39aadd428519216f467222d01db43f9ecb41fd67a995dcfd588b591be05c61)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanHsvOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanHsvOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c80054e1463c3bfccd3724e5903816993e3e0330c2893029a9d19e7f3ad8d244)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__680f4f401afa4983c3775de53690a0d7d67e6daa6a406afbe89a98cfde036f96)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5fc7304b9d54834213d42c25dc797851f84ac5448c5bd558819eb26d8e76c1db)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__da0f24f95016f2e179c1194db84008ef6f49fb672c8b28af25287af4558ccb33)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d7df6e866b177a601196a985689b544dbbe0caec070851f3ad39e3b4f23e2e05)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__669729276102ded74e6d61ed49e9e6541dfdb9305fc8e65ae62fe290f4704a4d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a5f5ce33d91d1c324c7e6aa1001856b4088567707463d076a412ad4995da6e42)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanHsv]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanHsv]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanHsv]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__48762d0054f22b3b432b4d0b328609828935f32099b466e8078991c70ed18079)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfDimension",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "dimension": "dimension",
        "dimension_var": "dimensionVar",
        "equal": "equal",
        "greater_than": "greaterThan",
        "less_than": "lessThan",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfDimension:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfDimensionDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        dimension: typing.Optional[builtins.str] = None,
        dimension_var: typing.Optional[builtins.str] = None,
        equal: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfDimensionEqual", typing.Dict[builtins.str, typing.Any]]] = None,
        greater_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfDimensionGreaterThan", typing.Dict[builtins.str, typing.Any]]] = None,
        less_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfDimensionLessThan", typing.Dict[builtins.str, typing.Any]]] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param dimension: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        :param dimension_var: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        :param equal: equal block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        :param greater_than: greater_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        :param less_than: less_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        :param value: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfDimensionDefault(**default)
        if isinstance(equal, dict):
            equal = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfDimensionEqual(**equal)
        if isinstance(greater_than, dict):
            greater_than = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfDimensionGreaterThan(**greater_than)
        if isinstance(less_than, dict):
            less_than = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfDimensionLessThan(**less_than)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5e9082fc662a8f60925b2af1bf3dcdc95674db8014f38badd2841cdc87792df7)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument dimension", value=dimension, expected_type=type_hints["dimension"])
            check_type(argname="argument dimension_var", value=dimension_var, expected_type=type_hints["dimension_var"])
            check_type(argname="argument equal", value=equal, expected_type=type_hints["equal"])
            check_type(argname="argument greater_than", value=greater_than, expected_type=type_hints["greater_than"])
            check_type(argname="argument less_than", value=less_than, expected_type=type_hints["less_than"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if dimension is not None:
            self._values["dimension"] = dimension
        if dimension_var is not None:
            self._values["dimension_var"] = dimension_var
        if equal is not None:
            self._values["equal"] = equal
        if greater_than is not None:
            self._values["greater_than"] = greater_than
        if less_than is not None:
            self._values["less_than"] = less_than
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfDimensionDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfDimensionDefault"], result)

    @builtins.property
    def dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        '''
        result = self._values.get("dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        '''
        result = self._values.get("dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def equal(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfDimensionEqual"]:
        '''equal block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        '''
        result = self._values.get("equal")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfDimensionEqual"], result)

    @builtins.property
    def greater_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfDimensionGreaterThan"]:
        '''greater_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        '''
        result = self._values.get("greater_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfDimensionGreaterThan"], result)

    @builtins.property
    def less_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfDimensionLessThan"]:
        '''less_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        '''
        result = self._values.get("less_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfDimensionLessThan"], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfDimension(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfDimensionDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfDimensionDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfDimensionDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfDimensionDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfDimensionDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b2085c5403081c8ca4e462cafbdec572bbfc5a74733ddc7a9179ad882ab8aea4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfDimensionDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfDimensionDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__67888f6f0f84174db5fca26be0e3291bc4977eac2458c3685ed1f784eaf9dc31)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfDimensionEqual",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfDimensionEqual:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfDimensionEqual(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfDimensionEqualOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfDimensionEqualOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b8dbf72c27c1da2160c9e2f0569f97e883e59d530c1edd27a5bc15c83f7e848d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfDimensionEqual], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfDimensionEqual],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eb52fdf0fb051bec657a20e52c4d0f55afa1037b71c11aefce81098ad6c64de3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfDimensionGreaterThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfDimensionGreaterThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfDimensionGreaterThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfDimensionGreaterThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfDimensionGreaterThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cdafd4285f4f7e4c693c83062c3aa2c4ec20ca7c2c2d109fab5ee22e182a5635)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfDimensionGreaterThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfDimensionGreaterThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8d74747a6fe21335d482e5dff2a13a21f53f6b4290a0eee973ecbb56210861fa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfDimensionLessThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfDimensionLessThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfDimensionLessThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfDimensionLessThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfDimensionLessThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__edca4961b2573b8dbe32e242a968355360525ba0a13dc07baab00edd8a383312)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfDimensionLessThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfDimensionLessThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2bc15faa99b21ccee09940791a648ea77585d1084e42473a2d3fe74fbdf14abc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfDimensionList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfDimensionList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__585afcc290660e0b8c04df834440c58cde8a8aacbde2dcf136322e3497eb5249)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfDimensionOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a06196616a833ce52b567b83a6dcbadbdf5cb1b917da39421731ebc1dddeb514)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfDimensionOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c9eb92024daa9231205f15e493f2a15264ffc38d9dedcdb3e564c7770ddde75c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f640cae4fad5f2153048ee09d286c6129960fd688207716cf9d66a27d098c666)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a5390cbe33c833a5893c63931f374851ad44021be448eb231697d811045deeb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfDimension]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfDimension]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__34d3d567218065cb98870d423fc54d5d47f1d97e1531fad0ba0a183de90dd22c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfDimensionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfDimensionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5bf4c031517b137ad6cc0dbef117a4e393d80cf558eed972b67597c0c7dd8e55)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfDimensionDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putEqual")
    def put_equal(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfDimensionEqual()

        return typing.cast(None, jsii.invoke(self, "putEqual", [value]))

    @jsii.member(jsii_name="putGreaterThan")
    def put_greater_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfDimensionGreaterThan()

        return typing.cast(None, jsii.invoke(self, "putGreaterThan", [value]))

    @jsii.member(jsii_name="putLessThan")
    def put_less_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfDimensionLessThan()

        return typing.cast(None, jsii.invoke(self, "putLessThan", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetDimension")
    def reset_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimension", []))

    @jsii.member(jsii_name="resetDimensionVar")
    def reset_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimensionVar", []))

    @jsii.member(jsii_name="resetEqual")
    def reset_equal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEqual", []))

    @jsii.member(jsii_name="resetGreaterThan")
    def reset_greater_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGreaterThan", []))

    @jsii.member(jsii_name="resetLessThan")
    def reset_less_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLessThan", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfDimensionDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfDimensionDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="equal")
    def equal(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfDimensionEqualOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfDimensionEqualOutputReference, jsii.get(self, "equal"))

    @builtins.property
    @jsii.member(jsii_name="greaterThan")
    def greater_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfDimensionGreaterThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfDimensionGreaterThanOutputReference, jsii.get(self, "greaterThan"))

    @builtins.property
    @jsii.member(jsii_name="lessThan")
    def less_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfDimensionLessThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfDimensionLessThanOutputReference, jsii.get(self, "lessThan"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfDimensionDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionInput")
    def dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionVarInput")
    def dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="equalInput")
    def equal_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfDimensionEqual], jsii.get(self, "equalInput"))

    @builtins.property
    @jsii.member(jsii_name="greaterThanInput")
    def greater_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfDimensionGreaterThan], jsii.get(self, "greaterThanInput"))

    @builtins.property
    @jsii.member(jsii_name="lessThanInput")
    def less_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfDimensionLessThan], jsii.get(self, "lessThanInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="dimension")
    def dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimension"))

    @dimension.setter
    def dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a3bf4032b56da982de1813c283a73887f6b371621117ed59f42388d31d7d96b6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimension", value)

    @builtins.property
    @jsii.member(jsii_name="dimensionVar")
    def dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimensionVar"))

    @dimension_var.setter
    def dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1d0dcf7715bc8f48f98048ebbc0f3c0289e9fb4a3d45dcef1985aeff9250ffac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__50540040af472c54ee8a6f5346d5ddc435e988f1f70813ff1feaf5a448f3ab57)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6682eab02106f66274caedfe5cf3c0e4e5c32298503265b1bb6f6b083c093a3e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfDimension]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfDimension]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfDimension]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9f03e1064e11740e5586e53e54cb4a2902008e7fc5f5f7faa051d690de6d8a98)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfOrientation",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "landscape": "landscape",
        "portrait": "portrait",
        "square": "square",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfOrientation:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfOrientationDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        landscape: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfOrientationLandscape", typing.Dict[builtins.str, typing.Any]]] = None,
        portrait: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfOrientationPortrait", typing.Dict[builtins.str, typing.Any]]] = None,
        square: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfOrientationSquare", typing.Dict[builtins.str, typing.Any]]] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param landscape: landscape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        :param portrait: portrait block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        :param square: square block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfOrientationDefault(**default)
        if isinstance(landscape, dict):
            landscape = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfOrientationLandscape(**landscape)
        if isinstance(portrait, dict):
            portrait = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfOrientationPortrait(**portrait)
        if isinstance(square, dict):
            square = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfOrientationSquare(**square)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__90f27e26a8969fe915c1b448c76f5d8c5d0ec7bc09c9724b920e35e900bfe360)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument landscape", value=landscape, expected_type=type_hints["landscape"])
            check_type(argname="argument portrait", value=portrait, expected_type=type_hints["portrait"])
            check_type(argname="argument square", value=square, expected_type=type_hints["square"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if landscape is not None:
            self._values["landscape"] = landscape
        if portrait is not None:
            self._values["portrait"] = portrait
        if square is not None:
            self._values["square"] = square

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfOrientationDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfOrientationDefault"], result)

    @builtins.property
    def landscape(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfOrientationLandscape"]:
        '''landscape block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        '''
        result = self._values.get("landscape")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfOrientationLandscape"], result)

    @builtins.property
    def portrait(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfOrientationPortrait"]:
        '''portrait block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        '''
        result = self._values.get("portrait")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfOrientationPortrait"], result)

    @builtins.property
    def square(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfOrientationSquare"]:
        '''square block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        result = self._values.get("square")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfOrientationSquare"], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfOrientation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfOrientationDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfOrientationDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfOrientationDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfOrientationDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfOrientationDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e043688d6a401143c75ee19ec92f78727da70ce0e2f513f8c3c3482ed2b76bd2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfOrientationDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfOrientationDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3dbf5516362cbd643c565fff90d2d946413100dbe4eb87c833938c26b88a82b0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfOrientationLandscape",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfOrientationLandscape:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfOrientationLandscape(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfOrientationLandscapeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfOrientationLandscapeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__62fda9052d2b57fecce93fa3e9d5a0d7def805a3689cda1839207d7a5fe9d88f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfOrientationLandscape], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfOrientationLandscape],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4213b456436f237f8b1af31a479250db617cd6cccbf6ceec7b12f99a0b0be4a9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfOrientationList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfOrientationList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c459b81197ea85e53ef73e7c5b00dd39145066661206ad3611431d02f29b13dd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfOrientationOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c9fd9637efcc03b9271ea7e93de5cc0a5f292a86dfdaf1303e7e12195c055276)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfOrientationOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__76a90d748c2e6206a3798a37af159524c07c283420cc40fb7b689c9bb9fba9e2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8ed7ea88d57d3935a05f8512716f563c7870a6c619fca681c40fdeb435d3fc27)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cfcb16dc70ff97370a913e7e5e001f5e79902386bb72cef77d7e11b7951d5253)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfOrientation]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfOrientation]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ca8dc4ae3e46a7c7e6e506b469db854cde987442c6c36c64860dfa08b7f537d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfOrientationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfOrientationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c8f0f3664e6e9e9bc4986eefb9339f6fa3df47204d710bc0675b319e389b3c84)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfOrientationDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putLandscape")
    def put_landscape(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfOrientationLandscape()

        return typing.cast(None, jsii.invoke(self, "putLandscape", [value]))

    @jsii.member(jsii_name="putPortrait")
    def put_portrait(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfOrientationPortrait()

        return typing.cast(None, jsii.invoke(self, "putPortrait", [value]))

    @jsii.member(jsii_name="putSquare")
    def put_square(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfOrientationSquare()

        return typing.cast(None, jsii.invoke(self, "putSquare", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetLandscape")
    def reset_landscape(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLandscape", []))

    @jsii.member(jsii_name="resetPortrait")
    def reset_portrait(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPortrait", []))

    @jsii.member(jsii_name="resetSquare")
    def reset_square(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSquare", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfOrientationDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfOrientationDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="landscape")
    def landscape(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfOrientationLandscapeOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfOrientationLandscapeOutputReference, jsii.get(self, "landscape"))

    @builtins.property
    @jsii.member(jsii_name="portrait")
    def portrait(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfOrientationPortraitOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfOrientationPortraitOutputReference", jsii.get(self, "portrait"))

    @builtins.property
    @jsii.member(jsii_name="square")
    def square(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfOrientationSquareOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfOrientationSquareOutputReference", jsii.get(self, "square"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfOrientationDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="landscapeInput")
    def landscape_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfOrientationLandscape], jsii.get(self, "landscapeInput"))

    @builtins.property
    @jsii.member(jsii_name="portraitInput")
    def portrait_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfOrientationPortrait"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfOrientationPortrait"], jsii.get(self, "portraitInput"))

    @builtins.property
    @jsii.member(jsii_name="squareInput")
    def square_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfOrientationSquare"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfOrientationSquare"], jsii.get(self, "squareInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfOrientation]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfOrientation]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfOrientation]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a4cf388a5dd7a176a6104affc9098480a46d3124d8b8539666e24bf2b5dffad6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfOrientationPortrait",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfOrientationPortrait:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfOrientationPortrait(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfOrientationPortraitOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfOrientationPortraitOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f0dbbf49f24a749d88c9bc4755b560259cecdecc9c00b55fbcc1d960052fa899)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfOrientationPortrait]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfOrientationPortrait], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfOrientationPortrait],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6763b10891a28badd240489b1d2d54b00d505982524da1ac4ab186ca917681a9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfOrientationSquare",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfOrientationSquare:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfOrientationSquare(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfOrientationSquareOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfOrientationSquareOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0fd579d0bbc788bd7c891d371d5d8a8ab2ee8dbf5a1e7682a89fd21361055375)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfOrientationSquare]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfOrientationSquare], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfOrientationSquare],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fb5c9878a3d909274dd72aa85185c354f7420714dc1b672d4d34d990622eb10f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanMaxColors",
    jsii_struct_bases=[],
    name_mapping={"colors": "colors", "colors_var": "colorsVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanMaxColors:
    def __init__(
        self,
        *,
        colors: typing.Optional[builtins.str] = None,
        colors_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param colors: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        :param colors_var: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ff91949a1f93374d30bbd363ad604aa0f3eb22ffa8ba6387988e9a07e07d59a6)
            check_type(argname="argument colors", value=colors, expected_type=type_hints["colors"])
            check_type(argname="argument colors_var", value=colors_var, expected_type=type_hints["colors_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if colors is not None:
            self._values["colors"] = colors
        if colors_var is not None:
            self._values["colors_var"] = colors_var

    @builtins.property
    def colors(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        '''
        result = self._values.get("colors")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def colors_var(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        result = self._values.get("colors_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanMaxColors(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanMaxColorsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanMaxColorsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__04d4f35767f48642227adb8a01e95b6319851e763ffa2155255e160fc0af144c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanMaxColorsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d32a1d427bcc8d29588d98cf9f829dd051a8afe777b61d673d44455ab39d5a35)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanMaxColorsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__193e61d28c6f0261abafcec0457eaab05eb0a3b0d7a1255789392af78d064a0b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__51cca25d91cd9b08bf80df2a79d48a0a07f90d816ed4319a6c37b3baf2d34144)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6287cf9bc8af5cd8a9bb852449d4489fba7d31f7850c4d716da94f5200b76455)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanMaxColors]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanMaxColors]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__29ed1299584ebd94125cf01b3d2a79fd3ca49a9e6e2ba2fa2627a6a941473de5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanMaxColorsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanMaxColorsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3d367ca01e6d9966677355fdcbe7c6300579e84af5d7814a71255f1e75f0a140)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColors")
    def reset_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColors", []))

    @jsii.member(jsii_name="resetColorsVar")
    def reset_colors_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorsVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorsInput")
    def colors_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsInput"))

    @builtins.property
    @jsii.member(jsii_name="colorsVarInput")
    def colors_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsVarInput"))

    @builtins.property
    @jsii.member(jsii_name="colors")
    def colors(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colors"))

    @colors.setter
    def colors(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a1ea4ea96fdf6b75c982243e2aafb3a705110fee2b4048f0cea6eec1573346e6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colors", value)

    @builtins.property
    @jsii.member(jsii_name="colorsVar")
    def colors_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorsVar"))

    @colors_var.setter
    def colors_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fe282b29f3eef6c508e9d91fe5bb7c7fe87147360e6ed74ddb1c4125cda2f63d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorsVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanMaxColors]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanMaxColors]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanMaxColors]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f406ffdd18d0e117eb3001242040bd02b1e033c22611d959699f7484fd2e5e14)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanMirror",
    jsii_struct_bases=[],
    name_mapping={
        "horizontal": "horizontal",
        "horizontal_var": "horizontalVar",
        "vertical": "vertical",
        "vertical_var": "verticalVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanMirror:
    def __init__(
        self,
        *,
        horizontal: typing.Optional[builtins.str] = None,
        horizontal_var: typing.Optional[builtins.str] = None,
        vertical: typing.Optional[builtins.str] = None,
        vertical_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param horizontal: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        :param horizontal_var: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        :param vertical: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        :param vertical_var: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__82404bebb7b30eb073c26c07f90f7f35516629d85c8039015e016f88357e4acb)
            check_type(argname="argument horizontal", value=horizontal, expected_type=type_hints["horizontal"])
            check_type(argname="argument horizontal_var", value=horizontal_var, expected_type=type_hints["horizontal_var"])
            check_type(argname="argument vertical", value=vertical, expected_type=type_hints["vertical"])
            check_type(argname="argument vertical_var", value=vertical_var, expected_type=type_hints["vertical_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if horizontal is not None:
            self._values["horizontal"] = horizontal
        if horizontal_var is not None:
            self._values["horizontal_var"] = horizontal_var
        if vertical is not None:
            self._values["vertical"] = vertical
        if vertical_var is not None:
            self._values["vertical_var"] = vertical_var

    @builtins.property
    def horizontal(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        '''
        result = self._values.get("horizontal")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def horizontal_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        '''
        result = self._values.get("horizontal_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        '''
        result = self._values.get("vertical")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        result = self._values.get("vertical_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanMirror(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanMirrorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanMirrorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0502f04a9328e9253068facf51ba8c8a6eed6c631cd786e3cea2f2e339cd719c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanMirrorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9516b4b830fed745dbf722f573b70f6826d03fdd9ee250e8a53b16a489f81ffb)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanMirrorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0211bb73ea0c280d16de7fb0d29072c2b9bf9be2d6b4906effc514494c8dd9c1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__413f980f7c41beab54294c70fbf592a65b34f9bdb7d7c1af3dbdee0838b2b111)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__504b011d77efa4f336ff176225a98d113e87b5368dfc74b048ca4aa5ec5dd55e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanMirror]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanMirror]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aa92763b6b838821fa526c6fd8d2942e874679674d2b5268e8b62e9d0e5d0a58)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanMirrorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanMirrorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d658f91e6830005d0c8cb9b121b04a8331318a78e58fb6b5f20fb35fde5f938a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHorizontal")
    def reset_horizontal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontal", []))

    @jsii.member(jsii_name="resetHorizontalVar")
    def reset_horizontal_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontalVar", []))

    @jsii.member(jsii_name="resetVertical")
    def reset_vertical(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVertical", []))

    @jsii.member(jsii_name="resetVerticalVar")
    def reset_vertical_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVerticalVar", []))

    @builtins.property
    @jsii.member(jsii_name="horizontalInput")
    def horizontal_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontalVarInput")
    def horizontal_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalInput")
    def vertical_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalVarInput")
    def vertical_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontal")
    def horizontal(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontal"))

    @horizontal.setter
    def horizontal(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e061270f8a46d552417788c7f9b20f736be0a43cb0ee72ccbb5d64e76c1e9a7a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontal", value)

    @builtins.property
    @jsii.member(jsii_name="horizontalVar")
    def horizontal_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontalVar"))

    @horizontal_var.setter
    def horizontal_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__52acf0d044830fcf091ff58178a4caf73941236283f44329660948bdd3a60ce2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontalVar", value)

    @builtins.property
    @jsii.member(jsii_name="vertical")
    def vertical(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "vertical"))

    @vertical.setter
    def vertical(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7c1d8bce35023b37a4799a6e7483e98fff53b51ed1171369dee146a3916d0d47)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "vertical", value)

    @builtins.property
    @jsii.member(jsii_name="verticalVar")
    def vertical_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "verticalVar"))

    @vertical_var.setter
    def vertical_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1bf3abbc24988acd433be9c9ebe55cd83ea7e1ba99317d4e45212b418c937c2f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "verticalVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanMirror]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanMirror]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanMirror]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__789f19bde56d148f926fb1509924050aae5d3416d0af6bbdb527b5390cbc9634)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanMonoHue",
    jsii_struct_bases=[],
    name_mapping={"hue": "hue", "hue_var": "hueVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanMonoHue:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b7e0a8aa181a8f06c6a12ac39492e425f2ddfe020f2d1f76f3517ba167f7331a)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanMonoHue(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanMonoHueList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanMonoHueList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__497010f67b2bfa086a87f5498c35eb3f6b873969c8ace5a9ba62494817d8a572)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanMonoHueOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__956c6e81b73806b705f17d804eb3980566d4478b99ac8297a22cc202cc623d1b)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanMonoHueOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0fc7209aca4f5455e74c7970fe0e97635132c5b760f36f398d5b8afda3e4291c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1065f23589c377c50e897eedf86f411b18fa9c9445bf22ba93c7d547205e08ca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__90a6a8f2d19869226887edcd4ce22bde74f2e9d4f193ddbdb8db06e35dbc50ab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanMonoHue]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanMonoHue]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ab2378430c4b71c0859582ed0827d95d9ca516ef3a8c3123b69690c08894213)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanMonoHueOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanMonoHueOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1caeb25b4d736dc6290c82a15f61e804c7721de8a4be031c5ab018cb589cd7fa)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d71f45d122c1d308989af7dfa20582280997152e435595cc18207a529bc5338c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c103f6ac64dc4217fa3b75f774d336564083d42774616f4c175ecd21a05829b1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanMonoHue]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanMonoHue]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanMonoHue]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__97e0599be5d5c94b08447d898177ab752a20669dbb2ad95758b85debce33b477)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanOpacity",
    jsii_struct_bases=[],
    name_mapping={"opacity": "opacity", "opacity_var": "opacityVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanOpacity:
    def __init__(
        self,
        *,
        opacity: typing.Optional[builtins.str] = None,
        opacity_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param opacity: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param opacity_var: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ebf4a00bca4223363af1037ecdd108ba115ff09bc4f48ec803a41b735f264f38)
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument opacity_var", value=opacity_var, expected_type=type_hints["opacity_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if opacity is not None:
            self._values["opacity"] = opacity
        if opacity_var is not None:
            self._values["opacity_var"] = opacity_var

    @builtins.property
    def opacity(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def opacity_var(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        result = self._values.get("opacity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanOpacity(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanOpacityList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanOpacityList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8e1de15ffe751083dd3afd1f70650d5a00258a1c8114d19ab20073de51dcafdd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanOpacityOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8d4a5e94105bfb02ea4de6f0f2cda990a44a8657a152325264ad8743c8b5468b)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanOpacityOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__055f2e928399347c61b082f1b59329d5dec739a740b61bba17f0e0662073692d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ca68aa9165c6939f46874e9a00a9f74224c609487d5dcf4cc6899cc1c51bc8f4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a7fb4d2aaa3191e6fb72cdcc1314877feadbfa073a06ab98545376fa9f925d8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanOpacity]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanOpacity]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__470c113abe2ebccb32ab25839d25fcdcdd65fd63e07e7e7e6c99654c6e0487d2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanOpacityOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanOpacityOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__424491a06280186befb7619b09a054474bbd0d718638dc1c7af0b6415ece958f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetOpacityVar")
    def reset_opacity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacityVar", []))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityVarInput")
    def opacity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacity"))

    @opacity.setter
    def opacity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f8f006a4b68c60adc5a0cd65e26401045d423d31c190e32afed7ae1c8e6c62a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacity", value)

    @builtins.property
    @jsii.member(jsii_name="opacityVar")
    def opacity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacityVar"))

    @opacity_var.setter
    def opacity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3d01b97f4e8e22d894b60f47f3777dcda2e1ee86670a9d37ca020a9f6c730e69)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacityVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanOpacity]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanOpacity]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanOpacity]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f7a4513f373c879376d675b2e6ba27a651b352bc0f0f0c2c7e9e23e957219d2e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0986610d9b1fa7ca6d8590798e7b2e4b144cb352edc382fd68271430d027d9c0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putBackgroundColor")
    def put_background_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7f78776aad4a2c4e0660a64bb66149bac9a9c6232311629582290d68ce389f0c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBackgroundColor", [value]))

    @jsii.member(jsii_name="putBlur")
    def put_blur(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanBlur, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dd2566a1ba45ba9813d5429d3f2148fc208677c3550ad2e9b212dd7aa3468af5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBlur", [value]))

    @jsii.member(jsii_name="putChromaKey")
    def put_chroma_key(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanChromaKey, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6c6b550eb63acd512eaca713ef4a7eda6980a13eff3bc662633806e442efd8fd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putChromaKey", [value]))

    @jsii.member(jsii_name="putComposite")
    def put_composite(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanComposite, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac2368ceb09be717d8fb24e04610d7969f28110f1f16f0e890b4f4c485244ece)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putComposite", [value]))

    @jsii.member(jsii_name="putCompound")
    def put_compound(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanCompound, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__07531ae5c25e1d12ac6c68b9e41d1d33bd92966966ef6c19e86e934e18c01898)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCompound", [value]))

    @jsii.member(jsii_name="putContrast")
    def put_contrast(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanContrast, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__60c0b448f0c67376134fb03bdf1182e3ce38cac3bbb26882b35a238623a71e9e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putContrast", [value]))

    @jsii.member(jsii_name="putGoop")
    def put_goop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanGoop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__748573d22c7c8e6e6b9c336885bc461ee5aafbd3d7e222591849ae698d3a0033)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGoop", [value]))

    @jsii.member(jsii_name="putGrayscale")
    def put_grayscale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanGrayscale, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e26850cc50283710eacc0b56126fe3db4c2e17c296e9cb005760e4f5e6a1a1f9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGrayscale", [value]))

    @jsii.member(jsii_name="putHsl")
    def put_hsl(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanHsl, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d9fb1d7653d74d7bf9cc02338b3e2c6335210730e50d0186565a1b72c06e4bed)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsl", [value]))

    @jsii.member(jsii_name="putHsv")
    def put_hsv(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanHsv, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e9416bcbfce0f8c6c5a36bafc0b40ede7f3fa1a4feebdb6b3c434d7f09d676d0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsv", [value]))

    @jsii.member(jsii_name="putIfDimension")
    def put_if_dimension(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfDimension, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6fad595cc057ffae96acae6349d262b05cb897e4792ca5cac882bdbb2aa914cf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfDimension", [value]))

    @jsii.member(jsii_name="putIfOrientation")
    def put_if_orientation(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8061770a2041768d2653d0bbdd6ccc692b9014f7905f96a54f15e33d8dfc3444)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfOrientation", [value]))

    @jsii.member(jsii_name="putMaxColors")
    def put_max_colors(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanMaxColors, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b5b616c494dd14335606eed7b5371b7571c3938033ad8b347e434c3b34a2711e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMaxColors", [value]))

    @jsii.member(jsii_name="putMirror")
    def put_mirror(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanMirror, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__040d36869259d03cb6a11aa3d7433d55786ad4daa62339a3a8c575ce3039c63f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMirror", [value]))

    @jsii.member(jsii_name="putMonoHue")
    def put_mono_hue(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanMonoHue, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cb86f33511c718a30abf98e160b07034919850d7ce2be405803592a84ba85fcf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMonoHue", [value]))

    @jsii.member(jsii_name="putOpacity")
    def put_opacity(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanOpacity, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__593ac8ec71c054640d96b00f6d1558f76eb54f19e93cbe82d5733b9e4a80db90)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putOpacity", [value]))

    @jsii.member(jsii_name="putRemoveColor")
    def put_remove_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanRemoveColor", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__67db673fc29778d89be44d132ddeb468c1286ac3ec48148eb3129d9f809481ee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRemoveColor", [value]))

    @jsii.member(jsii_name="putUnsharpMask")
    def put_unsharp_mask(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanUnsharpMask", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__88a4a99756fb9fe8db12b8ad96359d7cd41b88a96b9d18a92a771533db71d994)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putUnsharpMask", [value]))

    @jsii.member(jsii_name="resetBackgroundColor")
    def reset_background_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBackgroundColor", []))

    @jsii.member(jsii_name="resetBlur")
    def reset_blur(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBlur", []))

    @jsii.member(jsii_name="resetChromaKey")
    def reset_chroma_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChromaKey", []))

    @jsii.member(jsii_name="resetComposite")
    def reset_composite(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetComposite", []))

    @jsii.member(jsii_name="resetCompound")
    def reset_compound(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCompound", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetGoop")
    def reset_goop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGoop", []))

    @jsii.member(jsii_name="resetGrayscale")
    def reset_grayscale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGrayscale", []))

    @jsii.member(jsii_name="resetHsl")
    def reset_hsl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsl", []))

    @jsii.member(jsii_name="resetHsv")
    def reset_hsv(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsv", []))

    @jsii.member(jsii_name="resetIfDimension")
    def reset_if_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfDimension", []))

    @jsii.member(jsii_name="resetIfOrientation")
    def reset_if_orientation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfOrientation", []))

    @jsii.member(jsii_name="resetMaxColors")
    def reset_max_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxColors", []))

    @jsii.member(jsii_name="resetMirror")
    def reset_mirror(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMirror", []))

    @jsii.member(jsii_name="resetMonoHue")
    def reset_mono_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonoHue", []))

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetRemoveColor")
    def reset_remove_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRemoveColor", []))

    @jsii.member(jsii_name="resetUnsharpMask")
    def reset_unsharp_mask(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUnsharpMask", []))

    @builtins.property
    @jsii.member(jsii_name="backgroundColor")
    def background_color(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanBackgroundColorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanBackgroundColorList, jsii.get(self, "backgroundColor"))

    @builtins.property
    @jsii.member(jsii_name="blur")
    def blur(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanBlurList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanBlurList, jsii.get(self, "blur"))

    @builtins.property
    @jsii.member(jsii_name="chromaKey")
    def chroma_key(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanChromaKeyList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanChromaKeyList, jsii.get(self, "chromaKey"))

    @builtins.property
    @jsii.member(jsii_name="composite")
    def composite(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanCompositeList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanCompositeList, jsii.get(self, "composite"))

    @builtins.property
    @jsii.member(jsii_name="compound")
    def compound(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanCompoundList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanCompoundList, jsii.get(self, "compound"))

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanContrastList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanContrastList, jsii.get(self, "contrast"))

    @builtins.property
    @jsii.member(jsii_name="goop")
    def goop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanGoopList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanGoopList, jsii.get(self, "goop"))

    @builtins.property
    @jsii.member(jsii_name="grayscale")
    def grayscale(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanGrayscaleList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanGrayscaleList, jsii.get(self, "grayscale"))

    @builtins.property
    @jsii.member(jsii_name="hsl")
    def hsl(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanHslList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanHslList, jsii.get(self, "hsl"))

    @builtins.property
    @jsii.member(jsii_name="hsv")
    def hsv(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanHsvList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanHsvList, jsii.get(self, "hsv"))

    @builtins.property
    @jsii.member(jsii_name="ifDimension")
    def if_dimension(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfDimensionList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfDimensionList, jsii.get(self, "ifDimension"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientation")
    def if_orientation(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfOrientationList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfOrientationList, jsii.get(self, "ifOrientation"))

    @builtins.property
    @jsii.member(jsii_name="maxColors")
    def max_colors(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanMaxColorsList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanMaxColorsList, jsii.get(self, "maxColors"))

    @builtins.property
    @jsii.member(jsii_name="mirror")
    def mirror(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanMirrorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanMirrorList, jsii.get(self, "mirror"))

    @builtins.property
    @jsii.member(jsii_name="monoHue")
    def mono_hue(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanMonoHueList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanMonoHueList, jsii.get(self, "monoHue"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanOpacityList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanOpacityList, jsii.get(self, "opacity"))

    @builtins.property
    @jsii.member(jsii_name="removeColor")
    def remove_color(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanRemoveColorList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanRemoveColorList", jsii.get(self, "removeColor"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMask")
    def unsharp_mask(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanUnsharpMaskList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanUnsharpMaskList", jsii.get(self, "unsharpMask"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColorInput")
    def background_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanBackgroundColor]]], jsii.get(self, "backgroundColorInput"))

    @builtins.property
    @jsii.member(jsii_name="blurInput")
    def blur_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanBlur]]], jsii.get(self, "blurInput"))

    @builtins.property
    @jsii.member(jsii_name="chromaKeyInput")
    def chroma_key_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanChromaKey]]], jsii.get(self, "chromaKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="compositeInput")
    def composite_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanComposite]]], jsii.get(self, "compositeInput"))

    @builtins.property
    @jsii.member(jsii_name="compoundInput")
    def compound_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanCompound]]], jsii.get(self, "compoundInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanContrast]]], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="goopInput")
    def goop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanGoop]]], jsii.get(self, "goopInput"))

    @builtins.property
    @jsii.member(jsii_name="grayscaleInput")
    def grayscale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanGrayscale]]], jsii.get(self, "grayscaleInput"))

    @builtins.property
    @jsii.member(jsii_name="hslInput")
    def hsl_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanHsl]]], jsii.get(self, "hslInput"))

    @builtins.property
    @jsii.member(jsii_name="hsvInput")
    def hsv_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanHsv]]], jsii.get(self, "hsvInput"))

    @builtins.property
    @jsii.member(jsii_name="ifDimensionInput")
    def if_dimension_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfDimension]]], jsii.get(self, "ifDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientationInput")
    def if_orientation_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfOrientation]]], jsii.get(self, "ifOrientationInput"))

    @builtins.property
    @jsii.member(jsii_name="maxColorsInput")
    def max_colors_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanMaxColors]]], jsii.get(self, "maxColorsInput"))

    @builtins.property
    @jsii.member(jsii_name="mirrorInput")
    def mirror_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanMirror]]], jsii.get(self, "mirrorInput"))

    @builtins.property
    @jsii.member(jsii_name="monoHueInput")
    def mono_hue_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanMonoHue]]], jsii.get(self, "monoHueInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanOpacity]]], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="removeColorInput")
    def remove_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanRemoveColor"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanRemoveColor"]]], jsii.get(self, "removeColorInput"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMaskInput")
    def unsharp_mask_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanUnsharpMask"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanUnsharpMask"]]], jsii.get(self, "unsharpMaskInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7c787bdcc93dbeb4d62144de327aabbb5061c4c7a2f360fc5881e6902b75895f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanRemoveColor",
    jsii_struct_bases=[],
    name_mapping={
        "color": "color",
        "color_var": "colorVar",
        "feather": "feather",
        "feather_var": "featherVar",
        "tolerance": "tolerance",
        "tolerance_var": "toleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanRemoveColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
        feather: typing.Optional[builtins.str] = None,
        feather_var: typing.Optional[builtins.str] = None,
        tolerance: typing.Optional[builtins.str] = None,
        tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        :param feather: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        :param feather_var: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        :param tolerance: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        :param tolerance_var: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e2c571b64e1ed554ee2e786042a434581da344f5458c7ec4fef569598ff7f593)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
            check_type(argname="argument feather", value=feather, expected_type=type_hints["feather"])
            check_type(argname="argument feather_var", value=feather_var, expected_type=type_hints["feather_var"])
            check_type(argname="argument tolerance", value=tolerance, expected_type=type_hints["tolerance"])
            check_type(argname="argument tolerance_var", value=tolerance_var, expected_type=type_hints["tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var
        if feather is not None:
            self._values["feather"] = feather
        if feather_var is not None:
            self._values["feather_var"] = feather_var
        if tolerance is not None:
            self._values["tolerance"] = tolerance
        if tolerance_var is not None:
            self._values["tolerance_var"] = tolerance_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        '''
        result = self._values.get("feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather_var(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        '''
        result = self._values.get("feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        '''
        result = self._values.get("tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance_var(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        result = self._values.get("tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanRemoveColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanRemoveColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanRemoveColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ce24abaaea4c54644c22bedba3ace85b2f34b0561fcce8a314a300683b8cb364)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanRemoveColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__efafe05f7f850ec22f343280a79ff370240054c185345654e0116b374b216d99)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanRemoveColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7e3a1d83695153c6f03cf40052d95b4911d578b5deb8fb4e7817ac8e5918ecf9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d150986990bd9eb9e241bd542873d6a9a4cd5c96f552c764962fcfdd42f5b825)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3435c3b03a5199f0759ec44e9cd458b0107b283a4cba3963c3709cfa7fb4269a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanRemoveColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanRemoveColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanRemoveColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__361866000b4eb54c733b52232c6b2b5fef2a6759499109ea2fdd9888a8658180)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanRemoveColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanRemoveColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b5bdaa8ee61019dd2f29de61ce18e083d3961994a68b0eac85a8e77ab0bd591c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @jsii.member(jsii_name="resetFeather")
    def reset_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeather", []))

    @jsii.member(jsii_name="resetFeatherVar")
    def reset_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatherVar", []))

    @jsii.member(jsii_name="resetTolerance")
    def reset_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTolerance", []))

    @jsii.member(jsii_name="resetToleranceVar")
    def reset_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featherInput")
    def feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherInput"))

    @builtins.property
    @jsii.member(jsii_name="featherVarInput")
    def feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceInput")
    def tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceVarInput")
    def tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d2d6ada7335c3d9a94b166c5fe61ee1322bb48228504d7564f24186b47ef3395)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a6a027fc8a53ff68ad7290ed9526ac53504da7dc94bf7f9b36815a190d2c5e9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="feather")
    def feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "feather"))

    @feather.setter
    def feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__38f1ce7b4f875ad9cdc92a8451544a6921bc49f7b948ed6cd3f1a0caed36f4bc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "feather", value)

    @builtins.property
    @jsii.member(jsii_name="featherVar")
    def feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featherVar"))

    @feather_var.setter
    def feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f31f438314a1dd6898e5ed1095f7137b6eeb7323e731790a0854b7a3f8a77fa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featherVar", value)

    @builtins.property
    @jsii.member(jsii_name="tolerance")
    def tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tolerance"))

    @tolerance.setter
    def tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__33e849f963b9f9dec96e26257d6e451f1b92da821a10ec10471a7d70c1d6cbbe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tolerance", value)

    @builtins.property
    @jsii.member(jsii_name="toleranceVar")
    def tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "toleranceVar"))

    @tolerance_var.setter
    def tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e96450bca097d49a147521e7a65de0eca7602a1ddf6954f2867ab2316d4ed31c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "toleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanRemoveColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanRemoveColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanRemoveColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__15e7b9f9f51859c5cb0982d4a57cc8dd87481f75c1e704aa90409b96a3377b52)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanUnsharpMask",
    jsii_struct_bases=[],
    name_mapping={
        "gain": "gain",
        "gain_var": "gainVar",
        "sigma": "sigma",
        "sigma_var": "sigmaVar",
        "threshold": "threshold",
        "threshold_var": "thresholdVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanUnsharpMask:
    def __init__(
        self,
        *,
        gain: typing.Optional[builtins.str] = None,
        gain_var: typing.Optional[builtins.str] = None,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
        threshold: typing.Optional[builtins.str] = None,
        threshold_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param gain: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        :param gain_var: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        :param sigma: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        :param threshold: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        :param threshold_var: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__99e9cd14664840d3b3d0255c0a5e026a37cb0633e237a0823b7e6509dff5aedf)
            check_type(argname="argument gain", value=gain, expected_type=type_hints["gain"])
            check_type(argname="argument gain_var", value=gain_var, expected_type=type_hints["gain_var"])
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
            check_type(argname="argument threshold", value=threshold, expected_type=type_hints["threshold"])
            check_type(argname="argument threshold_var", value=threshold_var, expected_type=type_hints["threshold_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if gain is not None:
            self._values["gain"] = gain
        if gain_var is not None:
            self._values["gain_var"] = gain_var
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var
        if threshold is not None:
            self._values["threshold"] = threshold
        if threshold_var is not None:
            self._values["threshold_var"] = threshold_var

    @builtins.property
    def gain(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        '''
        result = self._values.get("gain")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gain_var(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        '''
        result = self._values.get("gain_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        '''
        result = self._values.get("threshold")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold_var(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        result = self._values.get("threshold_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanUnsharpMask(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanUnsharpMaskList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanUnsharpMaskList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bf5f31af99f7cbaf978f8ab71e9d952e1665df2318f84a360cfa74e637db4a76)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanUnsharpMaskOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fea578ab39e9ccde00607c0b7c2ff6cc624fbb92fbf363a4004be2b54abd967a)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanUnsharpMaskOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a3c9b4561211ade6f9d848b1a7f5bbc2439456d507ba44d2da94f3698a8df9b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5d820f6a1d5951beb93ba4df837df34930ffa797a2167c0775495a9d98d95921)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__241e88cf58b17cb9da131f6c8e656ab8ff08bcb33bb6bc75cf48567330238593)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanUnsharpMask]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanUnsharpMask]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanUnsharpMask]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d90aa1661575c8fb3061f55cb79e3b85ef0e7631551828799389b9626b79f943)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanUnsharpMaskOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanUnsharpMaskOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__479e8fdb1899fc714a39cb083e4cb68842679032095ad5cf6b40c166d77cca35)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetGain")
    def reset_gain(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGain", []))

    @jsii.member(jsii_name="resetGainVar")
    def reset_gain_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGainVar", []))

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @jsii.member(jsii_name="resetThreshold")
    def reset_threshold(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThreshold", []))

    @jsii.member(jsii_name="resetThresholdVar")
    def reset_threshold_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThresholdVar", []))

    @builtins.property
    @jsii.member(jsii_name="gainInput")
    def gain_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainInput"))

    @builtins.property
    @jsii.member(jsii_name="gainVarInput")
    def gain_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdInput")
    def threshold_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdVarInput")
    def threshold_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gain")
    def gain(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gain"))

    @gain.setter
    def gain(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__afa3fb5279dc58d268544b0b32fd2685ef3d876620e7cfa921bba7b51db6474e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gain", value)

    @builtins.property
    @jsii.member(jsii_name="gainVar")
    def gain_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gainVar"))

    @gain_var.setter
    def gain_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__61b375b53d12a83fa1f434c11efc9fbe9385aa4929f0d05213a86365d32639f4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gainVar", value)

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ad8b627e66e27f88d3e0cbd89692da87ef3253ed4f9409246c3586ab708ca103)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a6319ba26a0122833baa311245eac0c4ec9b91fe976a02b217ccbbabb239250)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="threshold")
    def threshold(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "threshold"))

    @threshold.setter
    def threshold(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__124e9c36696315993145e799a13463d9bf0f7622e8941d9dcfef48502b442ee2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "threshold", value)

    @builtins.property
    @jsii.member(jsii_name="thresholdVar")
    def threshold_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "thresholdVar"))

    @threshold_var.setter
    def threshold_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__feab78b0d985a07769c21be8356518c18fce295c2b5ea444008dd7da8f59d2fe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "thresholdVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanUnsharpMask]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanUnsharpMask]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanUnsharpMask]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5b3270a9d38690d2b6f37b4925143d1c4525f460cebcecc15c38ba364969dfad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThan",
    jsii_struct_bases=[],
    name_mapping={
        "background_color": "backgroundColor",
        "blur": "blur",
        "chroma_key": "chromaKey",
        "composite": "composite",
        "compound": "compound",
        "contrast": "contrast",
        "goop": "goop",
        "grayscale": "grayscale",
        "hsl": "hsl",
        "hsv": "hsv",
        "if_dimension": "ifDimension",
        "if_orientation": "ifOrientation",
        "max_colors": "maxColors",
        "mirror": "mirror",
        "mono_hue": "monoHue",
        "opacity": "opacity",
        "remove_color": "removeColor",
        "unsharp_mask": "unsharpMask",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThan:
    def __init__(
        self,
        *,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanBackgroundColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanBlur", typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanChromaKey", typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanComposite", typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanCompound", typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanContrast", typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanGoop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanGrayscale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanHsl", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanHsv", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfDimension", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfOrientation", typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanMaxColors", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanMirror", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanMonoHue", typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanOpacity", typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanRemoveColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanUnsharpMask", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__147d658f6a6aa120e8a9bd7706409108c0fffd41383c3b7353147f5bc40e12b0)
            check_type(argname="argument background_color", value=background_color, expected_type=type_hints["background_color"])
            check_type(argname="argument blur", value=blur, expected_type=type_hints["blur"])
            check_type(argname="argument chroma_key", value=chroma_key, expected_type=type_hints["chroma_key"])
            check_type(argname="argument composite", value=composite, expected_type=type_hints["composite"])
            check_type(argname="argument compound", value=compound, expected_type=type_hints["compound"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument goop", value=goop, expected_type=type_hints["goop"])
            check_type(argname="argument grayscale", value=grayscale, expected_type=type_hints["grayscale"])
            check_type(argname="argument hsl", value=hsl, expected_type=type_hints["hsl"])
            check_type(argname="argument hsv", value=hsv, expected_type=type_hints["hsv"])
            check_type(argname="argument if_dimension", value=if_dimension, expected_type=type_hints["if_dimension"])
            check_type(argname="argument if_orientation", value=if_orientation, expected_type=type_hints["if_orientation"])
            check_type(argname="argument max_colors", value=max_colors, expected_type=type_hints["max_colors"])
            check_type(argname="argument mirror", value=mirror, expected_type=type_hints["mirror"])
            check_type(argname="argument mono_hue", value=mono_hue, expected_type=type_hints["mono_hue"])
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument remove_color", value=remove_color, expected_type=type_hints["remove_color"])
            check_type(argname="argument unsharp_mask", value=unsharp_mask, expected_type=type_hints["unsharp_mask"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if background_color is not None:
            self._values["background_color"] = background_color
        if blur is not None:
            self._values["blur"] = blur
        if chroma_key is not None:
            self._values["chroma_key"] = chroma_key
        if composite is not None:
            self._values["composite"] = composite
        if compound is not None:
            self._values["compound"] = compound
        if contrast is not None:
            self._values["contrast"] = contrast
        if goop is not None:
            self._values["goop"] = goop
        if grayscale is not None:
            self._values["grayscale"] = grayscale
        if hsl is not None:
            self._values["hsl"] = hsl
        if hsv is not None:
            self._values["hsv"] = hsv
        if if_dimension is not None:
            self._values["if_dimension"] = if_dimension
        if if_orientation is not None:
            self._values["if_orientation"] = if_orientation
        if max_colors is not None:
            self._values["max_colors"] = max_colors
        if mirror is not None:
            self._values["mirror"] = mirror
        if mono_hue is not None:
            self._values["mono_hue"] = mono_hue
        if opacity is not None:
            self._values["opacity"] = opacity
        if remove_color is not None:
            self._values["remove_color"] = remove_color
        if unsharp_mask is not None:
            self._values["unsharp_mask"] = unsharp_mask

    @builtins.property
    def background_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanBackgroundColor"]]]:
        '''background_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        '''
        result = self._values.get("background_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanBackgroundColor"]]], result)

    @builtins.property
    def blur(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanBlur"]]]:
        '''blur block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        '''
        result = self._values.get("blur")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanBlur"]]], result)

    @builtins.property
    def chroma_key(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanChromaKey"]]]:
        '''chroma_key block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        '''
        result = self._values.get("chroma_key")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanChromaKey"]]], result)

    @builtins.property
    def composite(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanComposite"]]]:
        '''composite block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        '''
        result = self._values.get("composite")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanComposite"]]], result)

    @builtins.property
    def compound(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanCompound"]]]:
        '''compound block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        '''
        result = self._values.get("compound")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanCompound"]]], result)

    @builtins.property
    def contrast(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanContrast"]]]:
        '''contrast block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanContrast"]]], result)

    @builtins.property
    def goop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanGoop"]]]:
        '''goop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        '''
        result = self._values.get("goop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanGoop"]]], result)

    @builtins.property
    def grayscale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanGrayscale"]]]:
        '''grayscale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        '''
        result = self._values.get("grayscale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanGrayscale"]]], result)

    @builtins.property
    def hsl(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanHsl"]]]:
        '''hsl block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        '''
        result = self._values.get("hsl")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanHsl"]]], result)

    @builtins.property
    def hsv(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanHsv"]]]:
        '''hsv block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        '''
        result = self._values.get("hsv")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanHsv"]]], result)

    @builtins.property
    def if_dimension(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfDimension"]]]:
        '''if_dimension block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        '''
        result = self._values.get("if_dimension")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfDimension"]]], result)

    @builtins.property
    def if_orientation(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfOrientation"]]]:
        '''if_orientation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        '''
        result = self._values.get("if_orientation")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfOrientation"]]], result)

    @builtins.property
    def max_colors(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanMaxColors"]]]:
        '''max_colors block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        '''
        result = self._values.get("max_colors")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanMaxColors"]]], result)

    @builtins.property
    def mirror(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanMirror"]]]:
        '''mirror block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        '''
        result = self._values.get("mirror")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanMirror"]]], result)

    @builtins.property
    def mono_hue(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanMonoHue"]]]:
        '''mono_hue block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        '''
        result = self._values.get("mono_hue")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanMonoHue"]]], result)

    @builtins.property
    def opacity(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanOpacity"]]]:
        '''opacity block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanOpacity"]]], result)

    @builtins.property
    def remove_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanRemoveColor"]]]:
        '''remove_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        '''
        result = self._values.get("remove_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanRemoveColor"]]], result)

    @builtins.property
    def unsharp_mask(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanUnsharpMask"]]]:
        '''unsharp_mask block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        result = self._values.get("unsharp_mask")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanUnsharpMask"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanBackgroundColor",
    jsii_struct_bases=[],
    name_mapping={"color": "color", "color_var": "colorVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanBackgroundColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__44c448fcef6587b433dc1b675a37ff1a9075e0d83a74b403f0b8cb250dc9b6cd)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanBackgroundColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanBackgroundColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanBackgroundColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b45409b4d4877ff8947ad66ee052ec7d9300c080ca85b451aeae8572a8153f82)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanBackgroundColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__702736b00724501a89c6d562b01c06d7f9c33dc3d2fddb0e374cf826943626a0)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanBackgroundColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c5ce059fd618d3d117cff924562a9c0212ba00961473a688446fac385fa2ecbc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__17db5a07be999329e78179da1ef75a7b5c8482258026034586dd4baa3a3c058a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__12f450f33c68610fb8a3b1a4207996b26092e7e0898262c7b0d7b1240dd79399)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanBackgroundColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanBackgroundColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e673e1b29f6d01ed88d581d9d0e7646878d12abdc5f47d488395220fcf6ce8e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanBackgroundColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanBackgroundColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f2e6dc2a8e1b5b5da80054cdd12c9590df105cf5e42cf581b8d256a6d539cf12)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6915731cbf40aea5e179b0192e31339266ccebadc5738878c76790a3ed028ca1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fb12ee149a4bd124362d8d91799ba6b4d9d00ebcaf42f2234e325f0e7747925c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanBackgroundColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanBackgroundColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanBackgroundColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a66de82537a1af9cffe8b36ad13994fe861b975c34fecd664dd0cdbb43eeb7f6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanBlur",
    jsii_struct_bases=[],
    name_mapping={"sigma": "sigma", "sigma_var": "sigmaVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanBlur:
    def __init__(
        self,
        *,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param sigma: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fefc1dcb4ebfc18fe75a819cfa8a3f7bbd1f0314570f51051a5fcce6bf18edb1)
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanBlur(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanBlurList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanBlurList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e88ba89557adc3805b713d6ca745c4a006b8fe9cb781f5a51e7d61fa97918591)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanBlurOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__08af2de661b0901b87de3193ad8ad50af38654a08d3d77831f386d35e475003b)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanBlurOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fe962e2abc7f6445572bb424bacf3405135a5fb290d0367bd9e4391cce12ecf7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__79c4a39738a174412894daf8cc37ba92ccfd29d69142e299a5c3bd5fac446e80)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5e25639b45e9c90036cac5f43df3b231fee8860ab8a283bb4031147c259ba0c6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanBlur]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanBlur]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__849891222350537e5705c767f197476947850ff63418d39ebc6a5989f53434ef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanBlurOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanBlurOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1ef6368c14b46c3d81b91b6d4d5510b3c9a33d86c25e97ecea32ac5cc3cb9f4d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4d564b53e3ff7eaf8d57cdf7ddc667d55dc377b44506791baf33a73439168dc9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aa167f138f725e646c80f6d34a377c22d7a385b02d93587aad45df4bcecf37f9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanBlur]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanBlur]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanBlur]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1221049c9b3a710e4c2b47cc834e4726292b674ed81c18ff88e0a3b2c2112ae3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanChromaKey",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_feather": "hueFeather",
        "hue_feather_var": "hueFeatherVar",
        "hue_tolerance": "hueTolerance",
        "hue_tolerance_var": "hueToleranceVar",
        "hue_var": "hueVar",
        "lightness_feather": "lightnessFeather",
        "lightness_feather_var": "lightnessFeatherVar",
        "lightness_tolerance": "lightnessTolerance",
        "lightness_tolerance_var": "lightnessToleranceVar",
        "saturation_feather": "saturationFeather",
        "saturation_feather_var": "saturationFeatherVar",
        "saturation_tolerance": "saturationTolerance",
        "saturation_tolerance_var": "saturationToleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanChromaKey:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_feather: typing.Optional[builtins.str] = None,
        hue_feather_var: typing.Optional[builtins.str] = None,
        hue_tolerance: typing.Optional[builtins.str] = None,
        hue_tolerance_var: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness_feather: typing.Optional[builtins.str] = None,
        lightness_feather_var: typing.Optional[builtins.str] = None,
        lightness_tolerance: typing.Optional[builtins.str] = None,
        lightness_tolerance_var: typing.Optional[builtins.str] = None,
        saturation_feather: typing.Optional[builtins.str] = None,
        saturation_feather_var: typing.Optional[builtins.str] = None,
        saturation_tolerance: typing.Optional[builtins.str] = None,
        saturation_tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_feather: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        :param hue_feather_var: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        :param hue_tolerance: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        :param hue_tolerance_var: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        :param hue_var: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness_feather: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        :param lightness_feather_var: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        :param lightness_tolerance: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        :param lightness_tolerance_var: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        :param saturation_feather: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        :param saturation_feather_var: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        :param saturation_tolerance: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        :param saturation_tolerance_var: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__71a8e5d6a7c4da79e62e3ed877cec2c1688ae08fcdf03cca781394453beef959)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_feather", value=hue_feather, expected_type=type_hints["hue_feather"])
            check_type(argname="argument hue_feather_var", value=hue_feather_var, expected_type=type_hints["hue_feather_var"])
            check_type(argname="argument hue_tolerance", value=hue_tolerance, expected_type=type_hints["hue_tolerance"])
            check_type(argname="argument hue_tolerance_var", value=hue_tolerance_var, expected_type=type_hints["hue_tolerance_var"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness_feather", value=lightness_feather, expected_type=type_hints["lightness_feather"])
            check_type(argname="argument lightness_feather_var", value=lightness_feather_var, expected_type=type_hints["lightness_feather_var"])
            check_type(argname="argument lightness_tolerance", value=lightness_tolerance, expected_type=type_hints["lightness_tolerance"])
            check_type(argname="argument lightness_tolerance_var", value=lightness_tolerance_var, expected_type=type_hints["lightness_tolerance_var"])
            check_type(argname="argument saturation_feather", value=saturation_feather, expected_type=type_hints["saturation_feather"])
            check_type(argname="argument saturation_feather_var", value=saturation_feather_var, expected_type=type_hints["saturation_feather_var"])
            check_type(argname="argument saturation_tolerance", value=saturation_tolerance, expected_type=type_hints["saturation_tolerance"])
            check_type(argname="argument saturation_tolerance_var", value=saturation_tolerance_var, expected_type=type_hints["saturation_tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_feather is not None:
            self._values["hue_feather"] = hue_feather
        if hue_feather_var is not None:
            self._values["hue_feather_var"] = hue_feather_var
        if hue_tolerance is not None:
            self._values["hue_tolerance"] = hue_tolerance
        if hue_tolerance_var is not None:
            self._values["hue_tolerance_var"] = hue_tolerance_var
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness_feather is not None:
            self._values["lightness_feather"] = lightness_feather
        if lightness_feather_var is not None:
            self._values["lightness_feather_var"] = lightness_feather_var
        if lightness_tolerance is not None:
            self._values["lightness_tolerance"] = lightness_tolerance
        if lightness_tolerance_var is not None:
            self._values["lightness_tolerance_var"] = lightness_tolerance_var
        if saturation_feather is not None:
            self._values["saturation_feather"] = saturation_feather
        if saturation_feather_var is not None:
            self._values["saturation_feather_var"] = saturation_feather_var
        if saturation_tolerance is not None:
            self._values["saturation_tolerance"] = saturation_tolerance
        if saturation_tolerance_var is not None:
            self._values["saturation_tolerance_var"] = saturation_tolerance_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        '''
        result = self._values.get("hue_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        '''
        result = self._values.get("hue_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        '''
        result = self._values.get("hue_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        '''
        result = self._values.get("hue_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        '''
        result = self._values.get("lightness_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        '''
        result = self._values.get("lightness_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        '''
        result = self._values.get("lightness_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        '''
        result = self._values.get("lightness_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        '''
        result = self._values.get("saturation_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        '''
        result = self._values.get("saturation_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        '''
        result = self._values.get("saturation_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        result = self._values.get("saturation_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanChromaKey(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanChromaKeyList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanChromaKeyList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a875d46e6862d84489f6d8b34e584e002c0f432afeedcaaee710430bf9688f0d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanChromaKeyOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__491841a56c1dd9a0bb1d2d1cbe8f727fe3948c26b16c427097be570c73cab10d)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanChromaKeyOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__34c392d01a7695ab22b524a3342f3809d33b6e892cf59c8b161a5515bebb3358)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fd85be6c8bd5ec666269c2ac0d71bfb0b4f2cde0bc93d28eddec29f8d76c768d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__826a8586e0f16e0a93bacb2aee0c32a0a1aa6476f72550e7ea811e6bbf029d18)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanChromaKey]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanChromaKey]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__17e127205bcb9407d945d9e192ca955f6bddd040a3875acb0e01862c0e670c07)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanChromaKeyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanChromaKeyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bee3e2b959b6758e35c8038010a712a6911aef3c1fa5e674cef27900636f77a1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueFeather")
    def reset_hue_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeather", []))

    @jsii.member(jsii_name="resetHueFeatherVar")
    def reset_hue_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeatherVar", []))

    @jsii.member(jsii_name="resetHueTolerance")
    def reset_hue_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueTolerance", []))

    @jsii.member(jsii_name="resetHueToleranceVar")
    def reset_hue_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueToleranceVar", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightnessFeather")
    def reset_lightness_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeather", []))

    @jsii.member(jsii_name="resetLightnessFeatherVar")
    def reset_lightness_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeatherVar", []))

    @jsii.member(jsii_name="resetLightnessTolerance")
    def reset_lightness_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessTolerance", []))

    @jsii.member(jsii_name="resetLightnessToleranceVar")
    def reset_lightness_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessToleranceVar", []))

    @jsii.member(jsii_name="resetSaturationFeather")
    def reset_saturation_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeather", []))

    @jsii.member(jsii_name="resetSaturationFeatherVar")
    def reset_saturation_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeatherVar", []))

    @jsii.member(jsii_name="resetSaturationTolerance")
    def reset_saturation_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationTolerance", []))

    @jsii.member(jsii_name="resetSaturationToleranceVar")
    def reset_saturation_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherInput")
    def hue_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVarInput")
    def hue_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceInput")
    def hue_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVarInput")
    def hue_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherInput")
    def lightness_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVarInput")
    def lightness_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceInput")
    def lightness_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVarInput")
    def lightness_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherInput")
    def saturation_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVarInput")
    def saturation_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceInput")
    def saturation_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVarInput")
    def saturation_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f93ad3543ff930829ae24b4d49d2bc5fadbc6b34d98e1099d7dbd3f631d30b89)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeather")
    def hue_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeather"))

    @hue_feather.setter
    def hue_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7e363040d7d403aa307d4e388c5642213ffa995f284d85e304179baf2ef98c78)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeather", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVar")
    def hue_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeatherVar"))

    @hue_feather_var.setter
    def hue_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__52740c0e1ec6377f717c6e22014c94ff1499fd2ebf40779fa4e0f052636cd18f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueTolerance")
    def hue_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueTolerance"))

    @hue_tolerance.setter
    def hue_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd88e64b1f762240832c07bd06b05378db8813f95122d854e650c0e1a5c12c9e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVar")
    def hue_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueToleranceVar"))

    @hue_tolerance_var.setter
    def hue_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__40ef8091dc7fab59df346b7b24d5c2813cff2b98df84ec2e7ebeea9a0fbd7522)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d413bdcfc22d2d122bb244f63e260db51dedd7c04f2ff60ebe9a48e67b40a6a1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeather")
    def lightness_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeather"))

    @lightness_feather.setter
    def lightness_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__065382178b974a640196bf30021f072398cd9b69e1bbf54c1ad4811a163ca14a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeather", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVar")
    def lightness_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeatherVar"))

    @lightness_feather_var.setter
    def lightness_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__17bd4b072e2a6ecff73152b1f1ab9f774dfde1753c8647f8ca89e5120fb2618b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessTolerance")
    def lightness_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessTolerance"))

    @lightness_tolerance.setter
    def lightness_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9291b53102571139cc2a410d674bb1541e64d68c23cf70a5337764bc728a7ce3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVar")
    def lightness_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessToleranceVar"))

    @lightness_tolerance_var.setter
    def lightness_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d7efbef42def4299861632d3adf98b860ba0c123037b44bcf8bbe6d764de7051)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeather")
    def saturation_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeather"))

    @saturation_feather.setter
    def saturation_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__344fd65208c912182f4f61a5aa94a4a802851ab0ebe5c5bcbd314fd3813d5122)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeather", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVar")
    def saturation_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeatherVar"))

    @saturation_feather_var.setter
    def saturation_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__77a07584ff847e61fd801aae960fea409481f3b35a37184c92a5862be2bfd79e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationTolerance")
    def saturation_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationTolerance"))

    @saturation_tolerance.setter
    def saturation_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fb331e2dfb18b410a3a651c27ebb65611e6458d9bf2060f9d4aea56a61f41b72)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVar")
    def saturation_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationToleranceVar"))

    @saturation_tolerance_var.setter
    def saturation_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ca4f93d0376982888418abc16e879648dbd04389b63131d3e38d4133e0c750aa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanChromaKey]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanChromaKey]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanChromaKey]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f2a596af7cfb4d9117076b7d6d2ffdc2e5a25f0c9d65ef398faa1cbda113541f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanComposite",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "placement": "placement",
        "placement_var": "placementVar",
        "scale": "scale",
        "scale_dimension": "scaleDimension",
        "scale_dimension_var": "scaleDimensionVar",
        "scale_var": "scaleVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanComposite:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanCompositeImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        placement: typing.Optional[builtins.str] = None,
        placement_var: typing.Optional[builtins.str] = None,
        scale: typing.Optional[builtins.str] = None,
        scale_dimension: typing.Optional[builtins.str] = None,
        scale_dimension_var: typing.Optional[builtins.str] = None,
        scale_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param placement: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        :param placement_var: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        :param scale: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param scale_dimension: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        :param scale_dimension_var: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        :param scale_var: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        :param x_position: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanCompositeImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d8acb3ee6c3b8a61ee592947dfe3f0515183034efc167013216293c6ab557f5b)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument placement", value=placement, expected_type=type_hints["placement"])
            check_type(argname="argument placement_var", value=placement_var, expected_type=type_hints["placement_var"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument scale_dimension", value=scale_dimension, expected_type=type_hints["scale_dimension"])
            check_type(argname="argument scale_dimension_var", value=scale_dimension_var, expected_type=type_hints["scale_dimension_var"])
            check_type(argname="argument scale_var", value=scale_var, expected_type=type_hints["scale_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if placement is not None:
            self._values["placement"] = placement
        if placement_var is not None:
            self._values["placement_var"] = placement_var
        if scale is not None:
            self._values["scale"] = scale
        if scale_dimension is not None:
            self._values["scale_dimension"] = scale_dimension
        if scale_dimension_var is not None:
            self._values["scale_dimension_var"] = scale_dimension_var
        if scale_var is not None:
            self._values["scale_var"] = scale_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanCompositeImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanCompositeImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        '''
        result = self._values.get("placement")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement_var(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        '''
        result = self._values.get("placement_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        '''
        result = self._values.get("scale_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        '''
        result = self._values.get("scale_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        '''
        result = self._values.get("scale_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanComposite(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanCompositeImage",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanCompositeImage:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanCompositeImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanCompositeImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanCompositeImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f6798c1705688584f836f2c7562bc32c314bae5705e8b2fd45bb75dafe194b83)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanCompositeImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanCompositeImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__98632303a582fef39e35d8e3fedb98f0d13fdac9db21442432e6f8d3f9869aa0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanCompositeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanCompositeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__460da31349372b8e766dc1000ce8003c5013ba2a629fdfb1c9e260c2dd9671f6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanCompositeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e33faa9f6b6ae9f050fa9657939b7f86cbc9e130b2e85b8a3b0bb59cc7d47456)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanCompositeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e7ebe64df03818a36001ec9cc16782d6821ff374b75a2b3bd8b5a53a3e1a7bd6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3bb897dbf96843f2606a2d790b6794d08a6cc796d279a7df09bb4f22fac80488)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__068038ed72e6fc25261ee5ae92dd7b3dd93c89b4538b1b3fbf358f5528203a38)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanComposite]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanComposite]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab3da94750d37d30e25af4f8dcf7dfd7f73db386a6c5dcda8386f4093791fec5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanCompositeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanCompositeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a26fc50b73be860e301bfd2a76ff74f139cb8d5aeacb4691f29079afd539c87)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanCompositeImage()

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPlacement")
    def reset_placement(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacement", []))

    @jsii.member(jsii_name="resetPlacementVar")
    def reset_placement_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacementVar", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetScaleDimension")
    def reset_scale_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimension", []))

    @jsii.member(jsii_name="resetScaleDimensionVar")
    def reset_scale_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimensionVar", []))

    @jsii.member(jsii_name="resetScaleVar")
    def reset_scale_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanCompositeImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanCompositeImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanCompositeImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="placementInput")
    def placement_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementInput"))

    @builtins.property
    @jsii.member(jsii_name="placementVarInput")
    def placement_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionInput")
    def scale_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVarInput")
    def scale_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleVarInput")
    def scale_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f6f12618bd9eae779e44318e0fcee8cd370cff060835ce5507e530e5f4b8bc7e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1d99757c1c559415e9313718c0e6a65514e9a1b3f41e64d6609fd503a9c1f058)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="placement")
    def placement(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placement"))

    @placement.setter
    def placement(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0976da0c741518e6003323becc9240e9fee4ba2e923dc89220f3965fa8820f50)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placement", value)

    @builtins.property
    @jsii.member(jsii_name="placementVar")
    def placement_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placementVar"))

    @placement_var.setter
    def placement_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__85a06507dc6071d0b2a8bb4bae279d1bd9f9307f4741b5b3d0c3529865bc2a09)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placementVar", value)

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scale"))

    @scale.setter
    def scale(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__87f8598206adabd27f6e6269cd1f9bc5d7cfbfed9e1a6a776397a720448b2b33)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scale", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimension")
    def scale_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimension"))

    @scale_dimension.setter
    def scale_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__602b233d0f522720c1410717cc7d5659617bb3b01c3322cb03cc0e24cf567133)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimension", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVar")
    def scale_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimensionVar"))

    @scale_dimension_var.setter
    def scale_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__edd417922b2e0eb3a0f29efe74ccdad621b80be39d74a307dd394074d5b4d632)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="scaleVar")
    def scale_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleVar"))

    @scale_var.setter
    def scale_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__10ba891924f8de64d3d64a56d012387600d7e4472bb1f0d07ec16ab42075512c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__18df454944cf121bc86a26740cf08e0afa66e85b10ffe78496ec98086d9931ec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8f8c752b5d7f0ea8bca955ceb94c7c1001b7b0af2c35d520720dd807c4f98625)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2e4c9b527273ebcf04bf6157b9f5e4395785dd5bc48db67eae1353a1d44b27e1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a4e7f8d6b9466dcf6d206aa58fd6ad5f7de837eb83bc2b2807f097ec3c695bd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanComposite]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanComposite]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanComposite]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7027f67b1e934019f3e28fd3ab6e98713bf29489c9193bbbeecbc6816a61dda3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanCompound",
    jsii_struct_bases=[],
    name_mapping={"transformations": "transformations"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanCompound:
    def __init__(
        self,
        *,
        transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param transformations: transformations block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dd63bb968a999480f925a85c9a2610462162ba312b573b5b686e4ae8a6c6e2fd)
            check_type(argname="argument transformations", value=transformations, expected_type=type_hints["transformations"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if transformations is not None:
            self._values["transformations"] = transformations

    @builtins.property
    def transformations(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanCompoundTransformations"]]]:
        '''transformations block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        result = self._values.get("transformations")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanCompoundTransformations"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanCompound(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanCompoundList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanCompoundList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f979005b21cb797886a70be1175d8eb15900553da8f0f02da187cd6fe23e77bd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanCompoundOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f2eee1b46db593fd8a868473d72d049acf0c7554dc2f22fd261588bb2bda26a)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanCompoundOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__414acee4e28d435615c7b2148888bbf7d11f2e26ce0fe2704d64bd2dffc99788)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aab3104b914723b989f09032e21c7b568b075d57ab38df57838f0fb13e3457e4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0188b967eb1f66b8c4fe313408942d2ad02270e810fd5cf5d505d4b8cb01d3c3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanCompound]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanCompound]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__61228e233e81416c38ecc87e7616122d2430c5eccad6a634bd2dbcaba070c289)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanCompoundOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanCompoundOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d095c6d358d2fe8031edad9c1df478c01c2bf43e0bfaecf2798dde949ae237a7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformations")
    def put_transformations(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__15dec3c333f9da0e436f632d88799d17efbdc29c42b34dbdedaece266b0dc691)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTransformations", [value]))

    @jsii.member(jsii_name="resetTransformations")
    def reset_transformations(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformations", []))

    @builtins.property
    @jsii.member(jsii_name="transformations")
    def transformations(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanCompoundTransformationsList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanCompoundTransformationsList", jsii.get(self, "transformations"))

    @builtins.property
    @jsii.member(jsii_name="transformationsInput")
    def transformations_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanCompoundTransformations"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanCompoundTransformations"]]], jsii.get(self, "transformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanCompound]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanCompound]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanCompound]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a974581ed3cf2413bb7a70c6ab4b9f08afd1b1d5f5557cbbe91a7c48bcf08ae3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanCompoundTransformations",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanCompoundTransformations:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanCompoundTransformations(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanCompoundTransformationsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanCompoundTransformationsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__71c92870ebbc9841e7f6484259f340be8b01d7484d10cd4797c34b8139126190)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanCompoundTransformationsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d74a0e78ea1331944a0cecc5e8a20e1a6f56f525f45ae256a270cc5a6c9a9c4c)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanCompoundTransformationsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ec44f227a87d1575a83112bd633a8a7ae23608efad0b2179bb61298862a5e1a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d1ad71507e0f279b1b367e4373430a6c92b94519149b873adeea590b71e84d1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__21c627b6e96b7c062fe389835d64a372fe8ed490a8b9b18124a9eeca64be8c9c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanCompoundTransformations]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanCompoundTransformations]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanCompoundTransformations]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4cc28634bdcf9a7c60264f93340a0d0b2fd841f61129e74a8c7982b8010cbb85)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanCompoundTransformationsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanCompoundTransformationsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f57e12e5f7d5b600a015f0e554308a9a98c7de893f673011729f2f97a7886607)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanCompoundTransformations]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanCompoundTransformations]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanCompoundTransformations]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__198a506247fe3c4d108400058c8b61838c1555c77fdc33b96b7e112cb6da1049)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanContrast",
    jsii_struct_bases=[],
    name_mapping={
        "brightness": "brightness",
        "brightness_var": "brightnessVar",
        "contrast": "contrast",
        "contrast_var": "contrastVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanContrast:
    def __init__(
        self,
        *,
        brightness: typing.Optional[builtins.str] = None,
        brightness_var: typing.Optional[builtins.str] = None,
        contrast: typing.Optional[builtins.str] = None,
        contrast_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param brightness: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        :param brightness_var: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        :param contrast: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param contrast_var: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__376f504600bb76f41653d3a038a77f11875c8b8c941aa20e0a1c45737db211c6)
            check_type(argname="argument brightness", value=brightness, expected_type=type_hints["brightness"])
            check_type(argname="argument brightness_var", value=brightness_var, expected_type=type_hints["brightness_var"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument contrast_var", value=contrast_var, expected_type=type_hints["contrast_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if brightness is not None:
            self._values["brightness"] = brightness
        if brightness_var is not None:
            self._values["brightness_var"] = brightness_var
        if contrast is not None:
            self._values["contrast"] = contrast
        if contrast_var is not None:
            self._values["contrast_var"] = contrast_var

    @builtins.property
    def brightness(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        '''
        result = self._values.get("brightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def brightness_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        '''
        result = self._values.get("brightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        result = self._values.get("contrast_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanContrast(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanContrastList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanContrastList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1c33c742beeef63073a4abcdb2f7f28c6d53d6bd1e8a2cf8cb7839f5eb9687c1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanContrastOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__81ffa328d2ed6967852e6ec84db9df5e316d8f0f7389503af2dd8e0a4056ed86)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanContrastOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__105d2b3038c4006fa2637f48246f3cb54bf239730586228606f3c461b01b88c8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e23e0fed4fde9dc1b95b1e3bd8903f023035b7d7a26573eb53ba85b4623bc90c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1e2cbe506418ad4f2cddc0f2d8b0cc29d11ece49efd95b81c78aac488a15cbc3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanContrast]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanContrast]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f07ed1ed73c1bf3c24a7064d5365f0f6355fe95256182f967e5dcca53bf81689)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanContrastOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanContrastOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__98cb0b06dceffd7b6472df32e180d6ed43d1375d2eb16388d08f9807b35e6f0e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetBrightness")
    def reset_brightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightness", []))

    @jsii.member(jsii_name="resetBrightnessVar")
    def reset_brightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightnessVar", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetContrastVar")
    def reset_contrast_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrastVar", []))

    @builtins.property
    @jsii.member(jsii_name="brightnessInput")
    def brightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="brightnessVarInput")
    def brightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastVarInput")
    def contrast_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="brightness")
    def brightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightness"))

    @brightness.setter
    def brightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__31eebc19a38880c9a064754f37219d345021a94ff4456903ee84558c876c9150)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightness", value)

    @builtins.property
    @jsii.member(jsii_name="brightnessVar")
    def brightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightnessVar"))

    @brightness_var.setter
    def brightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__deebc98fefc85a96f65268aedf2c479e7262cb537d12a3045236e8e37f96ccc6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrast"))

    @contrast.setter
    def contrast(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__99b23010f25a8c93a554aa8f67ad707b4b16bb61f0f2e6a6aa845c4e949419a0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrast", value)

    @builtins.property
    @jsii.member(jsii_name="contrastVar")
    def contrast_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrastVar"))

    @contrast_var.setter
    def contrast_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__89a8a9553c49b7bd1c7174fd603acf5a817e209943e41495121941532fd66cda)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrastVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanContrast]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanContrast]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanContrast]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4cf413af77cc50c1ebbe39fe29b4b5817f209ca5e1eccedf5e3db1c4fbe68f8e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanGoop",
    jsii_struct_bases=[],
    name_mapping={
        "chaos": "chaos",
        "chaos_var": "chaosVar",
        "density": "density",
        "density_var": "densityVar",
        "power": "power",
        "power_var": "powerVar",
        "seed": "seed",
        "seed_var": "seedVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanGoop:
    def __init__(
        self,
        *,
        chaos: typing.Optional[builtins.str] = None,
        chaos_var: typing.Optional[builtins.str] = None,
        density: typing.Optional[builtins.str] = None,
        density_var: typing.Optional[builtins.str] = None,
        power: typing.Optional[builtins.str] = None,
        power_var: typing.Optional[builtins.str] = None,
        seed: typing.Optional[builtins.str] = None,
        seed_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param chaos: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        :param chaos_var: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        :param density: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        :param density_var: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        :param power: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        :param power_var: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        :param seed: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        :param seed_var: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2dd1c70287c84fe798ae909f4306cd4aaa4ad2a77d4a0f9a8979b281ff0b2ca1)
            check_type(argname="argument chaos", value=chaos, expected_type=type_hints["chaos"])
            check_type(argname="argument chaos_var", value=chaos_var, expected_type=type_hints["chaos_var"])
            check_type(argname="argument density", value=density, expected_type=type_hints["density"])
            check_type(argname="argument density_var", value=density_var, expected_type=type_hints["density_var"])
            check_type(argname="argument power", value=power, expected_type=type_hints["power"])
            check_type(argname="argument power_var", value=power_var, expected_type=type_hints["power_var"])
            check_type(argname="argument seed", value=seed, expected_type=type_hints["seed"])
            check_type(argname="argument seed_var", value=seed_var, expected_type=type_hints["seed_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if chaos is not None:
            self._values["chaos"] = chaos
        if chaos_var is not None:
            self._values["chaos_var"] = chaos_var
        if density is not None:
            self._values["density"] = density
        if density_var is not None:
            self._values["density_var"] = density_var
        if power is not None:
            self._values["power"] = power
        if power_var is not None:
            self._values["power_var"] = power_var
        if seed is not None:
            self._values["seed"] = seed
        if seed_var is not None:
            self._values["seed_var"] = seed_var

    @builtins.property
    def chaos(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        '''
        result = self._values.get("chaos")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def chaos_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        '''
        result = self._values.get("chaos_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        '''
        result = self._values.get("density")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density_var(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        '''
        result = self._values.get("density_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        '''
        result = self._values.get("power")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power_var(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        '''
        result = self._values.get("power_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        '''
        result = self._values.get("seed")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed_var(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        result = self._values.get("seed_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanGoop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanGoopList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanGoopList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8e175072b46d7c39d3a74e2c0449320eb22e527e876b5c9498d78ff7513558b5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanGoopOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dca39dc7830b97eafaef8ef13d84a1c4ed494cbabb96d99492b8e882f37033fc)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanGoopOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e4edcf52ef9f238e7d3c8e759fb76b0fde67453eb5d45d69b1a3d10e0f8a3763)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__85a641968eee1762ed142651e5c93494ef3f7f87731887cc2305c1efe55d1dbd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ce8f634500b67a423a0b476bfce08014a1b2fd24e105ca315e1771062ec5c8df)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanGoop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanGoop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4fcb4334b5a5274e360cc568fac52f2f66078fd170c24af65afa4900bd1dfb14)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanGoopOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanGoopOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6dc53be30a15b3930ebceda8dc42d14e64f35d133f45c82c3804fd77754d4681)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetChaos")
    def reset_chaos(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaos", []))

    @jsii.member(jsii_name="resetChaosVar")
    def reset_chaos_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaosVar", []))

    @jsii.member(jsii_name="resetDensity")
    def reset_density(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensity", []))

    @jsii.member(jsii_name="resetDensityVar")
    def reset_density_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensityVar", []))

    @jsii.member(jsii_name="resetPower")
    def reset_power(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPower", []))

    @jsii.member(jsii_name="resetPowerVar")
    def reset_power_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPowerVar", []))

    @jsii.member(jsii_name="resetSeed")
    def reset_seed(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeed", []))

    @jsii.member(jsii_name="resetSeedVar")
    def reset_seed_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeedVar", []))

    @builtins.property
    @jsii.member(jsii_name="chaosInput")
    def chaos_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosInput"))

    @builtins.property
    @jsii.member(jsii_name="chaosVarInput")
    def chaos_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosVarInput"))

    @builtins.property
    @jsii.member(jsii_name="densityInput")
    def density_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityInput"))

    @builtins.property
    @jsii.member(jsii_name="densityVarInput")
    def density_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="powerInput")
    def power_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerInput"))

    @builtins.property
    @jsii.member(jsii_name="powerVarInput")
    def power_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerVarInput"))

    @builtins.property
    @jsii.member(jsii_name="seedInput")
    def seed_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedInput"))

    @builtins.property
    @jsii.member(jsii_name="seedVarInput")
    def seed_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedVarInput"))

    @builtins.property
    @jsii.member(jsii_name="chaos")
    def chaos(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaos"))

    @chaos.setter
    def chaos(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bab3e77f278f0617626187a6775966e142366061774fab528e9b9f6c8e51f5d0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaos", value)

    @builtins.property
    @jsii.member(jsii_name="chaosVar")
    def chaos_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaosVar"))

    @chaos_var.setter
    def chaos_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb2c3434432f2a277d7ad53daf2dd48d07517c20ab33172d6f8ae21998cf2bff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaosVar", value)

    @builtins.property
    @jsii.member(jsii_name="density")
    def density(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "density"))

    @density.setter
    def density(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__17aa48cb5b7bbc3f4e8312fe4f8ec25947a8479dbe28c67eca3d31417fa3469e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "density", value)

    @builtins.property
    @jsii.member(jsii_name="densityVar")
    def density_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "densityVar"))

    @density_var.setter
    def density_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e346a8d3116e012f0cb7de4b01ddf4829e8e9354f28d3b0b60626c6f1d222beb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "densityVar", value)

    @builtins.property
    @jsii.member(jsii_name="power")
    def power(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "power"))

    @power.setter
    def power(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__39ffc3157c3f7fb1201364692906f64feab8710494357fcbd4ecace8612dd6e4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "power", value)

    @builtins.property
    @jsii.member(jsii_name="powerVar")
    def power_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "powerVar"))

    @power_var.setter
    def power_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3f0c7dc86620dfc435349c5ae06a0f781c7b8b6958c3dd32fb7425159e3d6210)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "powerVar", value)

    @builtins.property
    @jsii.member(jsii_name="seed")
    def seed(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seed"))

    @seed.setter
    def seed(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a619d25216f88e89cb3d3196cadfc0fd297ac0eba26559788140e3a31246bdc7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seed", value)

    @builtins.property
    @jsii.member(jsii_name="seedVar")
    def seed_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seedVar"))

    @seed_var.setter
    def seed_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__74f8613aa22c83d24520dda3d4729bf66a3b6d41b18f3cfbd6f25f008ddc0ee3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seedVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanGoop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanGoop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanGoop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__71c0e3f7d3cf994ac6c5d86599bbb1b2d177e2f2b0c85a0385db7751cd74b94b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanGrayscale",
    jsii_struct_bases=[],
    name_mapping={"type": "type", "type_var": "typeVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanGrayscale:
    def __init__(
        self,
        *,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param type: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ccdd246f5ec8a19eb9c43e4d0412a36c6bd9b5263b94af8e6b9744f3356e67e1)
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanGrayscale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanGrayscaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanGrayscaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ae9aa2d5a8b2a6121d5e57e958d24315e6b36e78c46de59e842ff8be56d4d654)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanGrayscaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aeac63093fc099fc0903a2bfcab4f43c421bfc991efb22fc9d3a50dd4d399667)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanGrayscaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a9b644818a8896ac217e933d74374d091aa33cb56a5377786ee39b5ece55824a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__07b048b984f860896450241db5dcf9dada8dca8cdf1a2cf0cc1b577a05c7e493)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__48b561b83195f86b8dc36f61679db26ce80cb934be62f53a2a368eed70c56d07)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanGrayscale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanGrayscale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cf91c0dd3417cdd105481e5d06ec359105c5805a5b0e4a94981aa86866bcf4bd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanGrayscaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanGrayscaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0d360b7410287e2527af591bf88147312ade4be21357d8d31fbea75efec3d1ab)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8edb67981ab33887ff161f9f343a6b67271901a78594d72ef2142160de235e48)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9e79d179025fc59c78374b4f13c77004046ca0e36e7fc3981d979208c171dac1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanGrayscale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanGrayscale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanGrayscale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__162ea4533d7ccb89d448f6038861b5799c02c55ce8109cbb4bdcfa15ac29b4a6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanHsl",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "lightness": "lightness",
        "lightness_var": "lightnessVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanHsl:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness: typing.Optional[builtins.str] = None,
        lightness_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        :param lightness_var: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b3945004c2076343cc965d48e92020f12660369f71d33856a333fb93eb288cf0)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness", value=lightness, expected_type=type_hints["lightness"])
            check_type(argname="argument lightness_var", value=lightness_var, expected_type=type_hints["lightness_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness is not None:
            self._values["lightness"] = lightness
        if lightness_var is not None:
            self._values["lightness_var"] = lightness_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        '''
        result = self._values.get("lightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        '''
        result = self._values.get("lightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanHsl(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanHslList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanHslList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e33b00f9b77e42fa623fb406d4631d5357ed6060942cf4beac7e42e8dac14145)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanHslOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a5cb4a1aaac80778180deebc7dd52b851eb12bbf6393969ff44b703ad8fd2a29)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanHslOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7e21292fe155f572dfc1e27e3246ca3598098b02a56b22342107b3f46aff51ef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__73caa724b46d9e9eb5ce655aba76fee78f89e8109ddb78bd70da697e9586966f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__15f6e8028bc4ef8473fb9c226ca22f0d9d91921e4f71c15c0e0b7ca9fe9b788a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanHsl]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanHsl]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4bc6030f58ad178b7ef1a87ded85dcc8d232da8f8770c806d0f46f764d848a61)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanHslOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanHslOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a3cd13f48f9ad629e5eded12b4a306eaacd00bf1b9c4b6721bada903747fbb13)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightness")
    def reset_lightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightness", []))

    @jsii.member(jsii_name="resetLightnessVar")
    def reset_lightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessInput")
    def lightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessVarInput")
    def lightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__26e23ed4687569f6369c908440a4f0163b8e7fe30d702f4b8d85d14801885cd6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5574bfcd24d66980313551956b0a439f1977957d03f485de43ca5363a334e7bc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightness")
    def lightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightness"))

    @lightness.setter
    def lightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3d88357ed7710e1f1cbd4db8c0844705da29a18c5e78f1f4ca436ca243cb4240)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightness", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessVar")
    def lightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessVar"))

    @lightness_var.setter
    def lightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5465bb97d95befe48aa7167dbb8ab5417ee301332069b847826fdb385629c467)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fce72852a305799d53a7441cafb29292646d7b284b35239bc2406073d2271093)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__228dd388bdf8a7d45a580370cf2c4434d1433d6f76a6abbbdb39371ede9ebdd4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanHsl]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanHsl]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanHsl]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ae48fd5bfbf0467439f0ffec2731a2e13188a0f3fea3d45f09e464f58034924c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanHsv",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanHsv:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        :param value: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7c8960f821555253853cc363aedc71cedd14b99e85717263718451fa15e621df)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanHsv(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanHsvList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanHsvList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d0f6e295c00aa9fe56811175cb703fdd09da47dcae976387b34317473c2f2c7e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanHsvOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6b172e180aae829a736f76af19f30bf17bc40f91d09cd969be466ba0645c84e3)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanHsvOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6c7f1f835ad8af23876c8c2d7cf0dacdba9ce54104574ae5a2429d7645267470)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a50da2d5e398e1b68539459ff79b72af6c54b0178b9818d87897294dd8243587)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ba43ae77d16f110bb97a7a5598dbd2e7ccf800e731d28055ea5d29fc6a00ed1b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanHsv]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanHsv]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f6ff2b5cf75461506a7b8c3a11561240743954d71070e56e195450e846e85f4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanHsvOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanHsvOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__64728fd8675c290eb2cc624e5b5d6795f21a5c04bf8ff6a73b61400f786e7aad)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4aa27f5fed662a642439a087f5a79fa74d8a8d6ec110bde3203c08c19922759d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f405b318ec95d9d616b0491c53e93c8c9d9e3bb252fb424a2f893db47fb5914a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1ab753dbe80c9be476ac33c67cc45cd62c272e4436f59427e09195f30cc05668)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a0e51fd92b3250f11622f7cacdc43ee33513780ce1ccaa1a8ec2a645426eb740)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ae0c1ba8fe7bac896199df978d78e245f249e6d4ed649cfb8439912b6315b0f9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0d255b8efa54c23c48b136c1e4d666d31ae3a3d827c923d41337f3679cca9c76)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanHsv]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanHsv]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanHsv]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6d124719e71a839eca47330cac4305bdbea5a4989c290d956e1210a3c8122e78)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfDimension",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "dimension": "dimension",
        "dimension_var": "dimensionVar",
        "equal": "equal",
        "greater_than": "greaterThan",
        "less_than": "lessThan",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfDimension:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfDimensionDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        dimension: typing.Optional[builtins.str] = None,
        dimension_var: typing.Optional[builtins.str] = None,
        equal: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfDimensionEqual", typing.Dict[builtins.str, typing.Any]]] = None,
        greater_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfDimensionGreaterThan", typing.Dict[builtins.str, typing.Any]]] = None,
        less_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfDimensionLessThan", typing.Dict[builtins.str, typing.Any]]] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param dimension: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        :param dimension_var: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        :param equal: equal block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        :param greater_than: greater_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        :param less_than: less_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        :param value: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfDimensionDefault(**default)
        if isinstance(equal, dict):
            equal = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfDimensionEqual(**equal)
        if isinstance(greater_than, dict):
            greater_than = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfDimensionGreaterThan(**greater_than)
        if isinstance(less_than, dict):
            less_than = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfDimensionLessThan(**less_than)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ed0fdeaf3622c6a5935bef6e88bd2e7fadeee1f617b36c8e3fb87a068daa4e4a)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument dimension", value=dimension, expected_type=type_hints["dimension"])
            check_type(argname="argument dimension_var", value=dimension_var, expected_type=type_hints["dimension_var"])
            check_type(argname="argument equal", value=equal, expected_type=type_hints["equal"])
            check_type(argname="argument greater_than", value=greater_than, expected_type=type_hints["greater_than"])
            check_type(argname="argument less_than", value=less_than, expected_type=type_hints["less_than"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if dimension is not None:
            self._values["dimension"] = dimension
        if dimension_var is not None:
            self._values["dimension_var"] = dimension_var
        if equal is not None:
            self._values["equal"] = equal
        if greater_than is not None:
            self._values["greater_than"] = greater_than
        if less_than is not None:
            self._values["less_than"] = less_than
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfDimensionDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfDimensionDefault"], result)

    @builtins.property
    def dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        '''
        result = self._values.get("dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        '''
        result = self._values.get("dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def equal(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfDimensionEqual"]:
        '''equal block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        '''
        result = self._values.get("equal")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfDimensionEqual"], result)

    @builtins.property
    def greater_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfDimensionGreaterThan"]:
        '''greater_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        '''
        result = self._values.get("greater_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfDimensionGreaterThan"], result)

    @builtins.property
    def less_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfDimensionLessThan"]:
        '''less_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        '''
        result = self._values.get("less_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfDimensionLessThan"], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfDimension(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfDimensionDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfDimensionDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfDimensionDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfDimensionDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfDimensionDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__728d1eb9c22a49a9a9282df7e0b7c1b241c3a61915802a8c5a7d50ee67411a20)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfDimensionDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfDimensionDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6a6ddbf9c3e64c8d5b2ba32957fbc21a1486f6b01cc1e9fefe57fc49b5be98f8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfDimensionEqual",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfDimensionEqual:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfDimensionEqual(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfDimensionEqualOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfDimensionEqualOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e1ee6993b7282bd2e367aaaa780169360199fc31fe0558f27e7f00544f77277e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfDimensionEqual], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfDimensionEqual],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b6dfc1a2a7341e66e37ab417deffeba41ec75eb596631e452ae02df13b0d03f6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfDimensionGreaterThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfDimensionGreaterThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfDimensionGreaterThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfDimensionGreaterThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfDimensionGreaterThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d90747323378d7ed9904e0212bf8e6651df03001d68573a1be1204f208b1c081)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfDimensionGreaterThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfDimensionGreaterThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ded1c57a9f6f3a0991eac331c8488ab6943f30ccc56ed9b5c5b8c8982c84eb21)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfDimensionLessThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfDimensionLessThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfDimensionLessThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfDimensionLessThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfDimensionLessThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5e767bbf010a1fd45bb775fb6b3937eeae28b5890a09c15afb776a9218a9f2e8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfDimensionLessThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfDimensionLessThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0774779189147eb613d378c5ab2a66a1aafe275048f2fbaa0b3288029176efc5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfDimensionList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfDimensionList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1a049e7c13d790f409e91746fd965140a5b8249f02e5b39b15352c47bc4bc816)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfDimensionOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f085042eeaf38eb4626cc91c4f29bbf458e2612be3199fc367b3652758c5393)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfDimensionOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1acf8059c6c0cd94c8c521053cf4a247088747a7fdd9030ad3312b1065a5248d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c34cf21a12fcf34245c0df4ab76795b6eeb07c838502cb257866d4aaa485ec65)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__288ce0c90af91b6ae4c4ac1db86f3dc64edf3d8bed70b167e0a26ef19e6fa4fa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfDimension]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfDimension]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__76f48459cc8ecb63962c9ef6e5ec1790408bd2cf70430dfd92fad7f57c595d93)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfDimensionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfDimensionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__96678c3443b62386f4cf62f72df81c7c13ad03a33bc6112ae2735ad6c8ef09b9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfDimensionDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putEqual")
    def put_equal(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfDimensionEqual()

        return typing.cast(None, jsii.invoke(self, "putEqual", [value]))

    @jsii.member(jsii_name="putGreaterThan")
    def put_greater_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfDimensionGreaterThan()

        return typing.cast(None, jsii.invoke(self, "putGreaterThan", [value]))

    @jsii.member(jsii_name="putLessThan")
    def put_less_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfDimensionLessThan()

        return typing.cast(None, jsii.invoke(self, "putLessThan", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetDimension")
    def reset_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimension", []))

    @jsii.member(jsii_name="resetDimensionVar")
    def reset_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimensionVar", []))

    @jsii.member(jsii_name="resetEqual")
    def reset_equal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEqual", []))

    @jsii.member(jsii_name="resetGreaterThan")
    def reset_greater_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGreaterThan", []))

    @jsii.member(jsii_name="resetLessThan")
    def reset_less_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLessThan", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfDimensionDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfDimensionDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="equal")
    def equal(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfDimensionEqualOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfDimensionEqualOutputReference, jsii.get(self, "equal"))

    @builtins.property
    @jsii.member(jsii_name="greaterThan")
    def greater_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfDimensionGreaterThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfDimensionGreaterThanOutputReference, jsii.get(self, "greaterThan"))

    @builtins.property
    @jsii.member(jsii_name="lessThan")
    def less_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfDimensionLessThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfDimensionLessThanOutputReference, jsii.get(self, "lessThan"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfDimensionDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionInput")
    def dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionVarInput")
    def dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="equalInput")
    def equal_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfDimensionEqual], jsii.get(self, "equalInput"))

    @builtins.property
    @jsii.member(jsii_name="greaterThanInput")
    def greater_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfDimensionGreaterThan], jsii.get(self, "greaterThanInput"))

    @builtins.property
    @jsii.member(jsii_name="lessThanInput")
    def less_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfDimensionLessThan], jsii.get(self, "lessThanInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="dimension")
    def dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimension"))

    @dimension.setter
    def dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__85e78d70479901e38e5aa1e006eb3b86cc2c861a98c6b36862ddb158a62c0baa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimension", value)

    @builtins.property
    @jsii.member(jsii_name="dimensionVar")
    def dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimensionVar"))

    @dimension_var.setter
    def dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__34d76e62e6a61a242f3a015e0ad328d5e54bb1db7d1b0e56100cd4979a0e7352)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2b346de7aa97698b6d87a96637bf45c19049c1072c1dfdac92acef635aeb0bba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2261d2f50429eea1c2382cac9cadba9ab1ea55ca3a286f1ae159b362a6f60dfc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfDimension]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfDimension]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfDimension]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__25cc91d1f5248a21d9125aa84fdc26a4077144d92a804f7e342cd4504b5ef221)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfOrientation",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "landscape": "landscape",
        "portrait": "portrait",
        "square": "square",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfOrientation:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfOrientationDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        landscape: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfOrientationLandscape", typing.Dict[builtins.str, typing.Any]]] = None,
        portrait: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfOrientationPortrait", typing.Dict[builtins.str, typing.Any]]] = None,
        square: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfOrientationSquare", typing.Dict[builtins.str, typing.Any]]] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param landscape: landscape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        :param portrait: portrait block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        :param square: square block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfOrientationDefault(**default)
        if isinstance(landscape, dict):
            landscape = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfOrientationLandscape(**landscape)
        if isinstance(portrait, dict):
            portrait = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfOrientationPortrait(**portrait)
        if isinstance(square, dict):
            square = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfOrientationSquare(**square)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e65df1c3f71f852f0fb2a452ded573279e172f6a789e3182c1ddef66e6b97e82)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument landscape", value=landscape, expected_type=type_hints["landscape"])
            check_type(argname="argument portrait", value=portrait, expected_type=type_hints["portrait"])
            check_type(argname="argument square", value=square, expected_type=type_hints["square"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if landscape is not None:
            self._values["landscape"] = landscape
        if portrait is not None:
            self._values["portrait"] = portrait
        if square is not None:
            self._values["square"] = square

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfOrientationDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfOrientationDefault"], result)

    @builtins.property
    def landscape(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfOrientationLandscape"]:
        '''landscape block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        '''
        result = self._values.get("landscape")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfOrientationLandscape"], result)

    @builtins.property
    def portrait(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfOrientationPortrait"]:
        '''portrait block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        '''
        result = self._values.get("portrait")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfOrientationPortrait"], result)

    @builtins.property
    def square(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfOrientationSquare"]:
        '''square block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        result = self._values.get("square")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfOrientationSquare"], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfOrientation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfOrientationDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfOrientationDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfOrientationDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfOrientationDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfOrientationDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d1ef295dd214702a9c8efd57bbee634e988e962af3368690a6244c1e4a17dcf)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfOrientationDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfOrientationDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1a57732c1aa5b3711b2905a934bd17e79ede3780292efcd8d5f614e68c281f61)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfOrientationLandscape",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfOrientationLandscape:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfOrientationLandscape(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfOrientationLandscapeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfOrientationLandscapeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a13d3f0c111ad6fb1f977e5d2fa94227efcf6227ab883eb41ee5d5e8c323cdb5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfOrientationLandscape], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfOrientationLandscape],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1d7f045c4c1fb1d389e6a34fa5993293e2cea0c20e3c4d86dedf8e350d07d876)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfOrientationList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfOrientationList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d5f04118c3f310d6b4d92dd8c1034e69efc0d134864bf7db2614dbc94e457092)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfOrientationOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b14e1495d91b96455d4f3ea2e7046d76604942e32d73550948d44477af01a8ba)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfOrientationOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__66b36c4722aa2d4e16175759379984f3043459f42f69057eaabcf402b61a6425)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__782d286a4981097410a163ba59d738b429aed1f0084bb8bef2fde547fbba0081)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__95633a6485abaded7cea148cee08afd402307fcf907c720c4b4b3f70d4764c23)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfOrientation]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfOrientation]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a5f86339f9bc6dd32292475897c337016bfae8ed912f0a5a25035d847f981a66)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfOrientationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfOrientationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__195a06e28f2878e1298771719f3aee853d68097fab02ee5407945bcd06bbb534)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfOrientationDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putLandscape")
    def put_landscape(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfOrientationLandscape()

        return typing.cast(None, jsii.invoke(self, "putLandscape", [value]))

    @jsii.member(jsii_name="putPortrait")
    def put_portrait(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfOrientationPortrait()

        return typing.cast(None, jsii.invoke(self, "putPortrait", [value]))

    @jsii.member(jsii_name="putSquare")
    def put_square(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfOrientationSquare()

        return typing.cast(None, jsii.invoke(self, "putSquare", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetLandscape")
    def reset_landscape(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLandscape", []))

    @jsii.member(jsii_name="resetPortrait")
    def reset_portrait(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPortrait", []))

    @jsii.member(jsii_name="resetSquare")
    def reset_square(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSquare", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfOrientationDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfOrientationDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="landscape")
    def landscape(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfOrientationLandscapeOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfOrientationLandscapeOutputReference, jsii.get(self, "landscape"))

    @builtins.property
    @jsii.member(jsii_name="portrait")
    def portrait(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfOrientationPortraitOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfOrientationPortraitOutputReference", jsii.get(self, "portrait"))

    @builtins.property
    @jsii.member(jsii_name="square")
    def square(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfOrientationSquareOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfOrientationSquareOutputReference", jsii.get(self, "square"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfOrientationDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="landscapeInput")
    def landscape_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfOrientationLandscape], jsii.get(self, "landscapeInput"))

    @builtins.property
    @jsii.member(jsii_name="portraitInput")
    def portrait_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfOrientationPortrait"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfOrientationPortrait"], jsii.get(self, "portraitInput"))

    @builtins.property
    @jsii.member(jsii_name="squareInput")
    def square_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfOrientationSquare"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfOrientationSquare"], jsii.get(self, "squareInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfOrientation]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfOrientation]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfOrientation]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9e714651de4ca327061229c8249210e662ab3ea3f70ac1e0c12f2eca4d458f93)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfOrientationPortrait",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfOrientationPortrait:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfOrientationPortrait(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfOrientationPortraitOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfOrientationPortraitOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f62e387f08e08fcdd79aa4caa8185aeb2e13662bb45818be845a78e238d2c487)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfOrientationPortrait]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfOrientationPortrait], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfOrientationPortrait],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bd142c8e49da179ca21d7c56df86615bca7fb8df61207cec3d735c703256af4a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfOrientationSquare",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfOrientationSquare:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfOrientationSquare(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfOrientationSquareOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfOrientationSquareOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1389baea2235e76b31cdbd00d8e19f33fccd84ed92b63a955d467a6f3ef65c9c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfOrientationSquare]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfOrientationSquare], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfOrientationSquare],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8c28d7530bccce6ba06daeaf319c61ecd02eab4a25323a8e9a80876039a6981e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanMaxColors",
    jsii_struct_bases=[],
    name_mapping={"colors": "colors", "colors_var": "colorsVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanMaxColors:
    def __init__(
        self,
        *,
        colors: typing.Optional[builtins.str] = None,
        colors_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param colors: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        :param colors_var: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9e18f8baffec2e0530cfbf25c379daf7da70d56e67101434eb5fce09f1f4e95f)
            check_type(argname="argument colors", value=colors, expected_type=type_hints["colors"])
            check_type(argname="argument colors_var", value=colors_var, expected_type=type_hints["colors_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if colors is not None:
            self._values["colors"] = colors
        if colors_var is not None:
            self._values["colors_var"] = colors_var

    @builtins.property
    def colors(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        '''
        result = self._values.get("colors")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def colors_var(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        result = self._values.get("colors_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanMaxColors(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanMaxColorsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanMaxColorsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e41de7cb9fa1a1d318c1971d17f69bfb486df6a5d9a4e38f320d655723e778c0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanMaxColorsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f25a796607b9fdc01f39c66d53b7b458c8a65fcb8de71b69af03f84f75b45cf)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanMaxColorsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a9342767d1502c64c226263d43e027a8085a738dea15f1581507e74a8fda451)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__40461a52a8015c4c43e027b3a8392b920ac99cb25ab1c94a23342df7fcaf5dca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__250c96aed5cc8d34636f0db9baf4a146c1c4e9d04f8a281f8ce6ad0ce631d5df)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanMaxColors]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanMaxColors]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7a21280b771b590e3d21e0933d6f3d5c3e8b5dae1b3aca8d34bc6920a3909a2b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanMaxColorsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanMaxColorsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ccfb091529eca96ff55010a35a40ffcc15d4483ef11f36ff8473fb99cf1161c4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColors")
    def reset_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColors", []))

    @jsii.member(jsii_name="resetColorsVar")
    def reset_colors_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorsVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorsInput")
    def colors_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsInput"))

    @builtins.property
    @jsii.member(jsii_name="colorsVarInput")
    def colors_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsVarInput"))

    @builtins.property
    @jsii.member(jsii_name="colors")
    def colors(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colors"))

    @colors.setter
    def colors(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a2fb378ee5420fc8b16f2b143966f59d62a9f7bf66ec081dc56460fc56e97ab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colors", value)

    @builtins.property
    @jsii.member(jsii_name="colorsVar")
    def colors_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorsVar"))

    @colors_var.setter
    def colors_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__efa5357878105e86743ae613c2c0dbc8cc5962d40502cfa8ec110c19d023493f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorsVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanMaxColors]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanMaxColors]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanMaxColors]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__97265f5bd6fb6ba14b144cb0de346759c7f03daed2b45ba55b7996b60f399ed7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanMirror",
    jsii_struct_bases=[],
    name_mapping={
        "horizontal": "horizontal",
        "horizontal_var": "horizontalVar",
        "vertical": "vertical",
        "vertical_var": "verticalVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanMirror:
    def __init__(
        self,
        *,
        horizontal: typing.Optional[builtins.str] = None,
        horizontal_var: typing.Optional[builtins.str] = None,
        vertical: typing.Optional[builtins.str] = None,
        vertical_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param horizontal: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        :param horizontal_var: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        :param vertical: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        :param vertical_var: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1250fe0f521d2d6281aba6ce8112fcb59c62fda7a05695a88b8df675ffa3e682)
            check_type(argname="argument horizontal", value=horizontal, expected_type=type_hints["horizontal"])
            check_type(argname="argument horizontal_var", value=horizontal_var, expected_type=type_hints["horizontal_var"])
            check_type(argname="argument vertical", value=vertical, expected_type=type_hints["vertical"])
            check_type(argname="argument vertical_var", value=vertical_var, expected_type=type_hints["vertical_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if horizontal is not None:
            self._values["horizontal"] = horizontal
        if horizontal_var is not None:
            self._values["horizontal_var"] = horizontal_var
        if vertical is not None:
            self._values["vertical"] = vertical
        if vertical_var is not None:
            self._values["vertical_var"] = vertical_var

    @builtins.property
    def horizontal(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        '''
        result = self._values.get("horizontal")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def horizontal_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        '''
        result = self._values.get("horizontal_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        '''
        result = self._values.get("vertical")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        result = self._values.get("vertical_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanMirror(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanMirrorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanMirrorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e38c09f52344063a8b067ea1046bf8e4918b56b67ea5bc9624b0c32685fbdb01)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanMirrorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__86b7e19e01305495e68c129022dcb8700e7bc234292b81b260847a1893372ecf)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanMirrorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__43aafb6f66963a6331dfe478c4e8d59851ca77d5121210656b874353d8add2a1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f6784a7cb1bf7b28c0c92ed2aca1e798bde0d0c4de089f070d501270176e419c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7ef5d7de594957537c553c5d47187c07cf928a1bee02bff9b05a9e1164ef29e7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanMirror]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanMirror]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__57f27a75ee0e967fc1fa2a81519efecd451335bf17936d5cfb016909999bc238)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanMirrorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanMirrorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__50aac53157cf287251646c199a22a52263e1dbc9174e1f573cb5ad256926d873)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHorizontal")
    def reset_horizontal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontal", []))

    @jsii.member(jsii_name="resetHorizontalVar")
    def reset_horizontal_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontalVar", []))

    @jsii.member(jsii_name="resetVertical")
    def reset_vertical(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVertical", []))

    @jsii.member(jsii_name="resetVerticalVar")
    def reset_vertical_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVerticalVar", []))

    @builtins.property
    @jsii.member(jsii_name="horizontalInput")
    def horizontal_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontalVarInput")
    def horizontal_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalInput")
    def vertical_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalVarInput")
    def vertical_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontal")
    def horizontal(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontal"))

    @horizontal.setter
    def horizontal(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__278fddd3a7783c77e842d4b67eeb1daf30abdaf7e967d39633d9be8373e6bd85)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontal", value)

    @builtins.property
    @jsii.member(jsii_name="horizontalVar")
    def horizontal_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontalVar"))

    @horizontal_var.setter
    def horizontal_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bddf6cbb1f1dbd11fe4bdabd17acddfee6a264a20a8e610153f1ed136d7232cf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontalVar", value)

    @builtins.property
    @jsii.member(jsii_name="vertical")
    def vertical(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "vertical"))

    @vertical.setter
    def vertical(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4af16bc7fa58a91d7e1b70f607db765c88a71df3a9935c0596bb8b114b07e83d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "vertical", value)

    @builtins.property
    @jsii.member(jsii_name="verticalVar")
    def vertical_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "verticalVar"))

    @vertical_var.setter
    def vertical_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__56cc810abe60e214765fd670d1655e76b797cf948187858d2a527b629403c298)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "verticalVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanMirror]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanMirror]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanMirror]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__822b127922cab1d4f3ad0c2b2af919fff97d39f5a24a12169ad58046298ebdc3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanMonoHue",
    jsii_struct_bases=[],
    name_mapping={"hue": "hue", "hue_var": "hueVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanMonoHue:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__64dc3e2627d7748667e9aec96a80cd24a5cc55536b0f0f1649e8a92f86985e6c)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanMonoHue(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanMonoHueList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanMonoHueList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__027d6fdf4ee8980826049b4ff9e97cfe73e70659cd56d700225d56400ffa63ba)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanMonoHueOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f077b1ff8508f0f1f745486063e71094745131a32f5bd9d8dbbba3d02b51d7ba)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanMonoHueOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f0fae1607cf6a68ca7c20a740dd8b5ee6a585d55db157a6c33fa5cbac93f3f47)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0802826c7bb2058e9fcf2d10a1ff66bb50134d8cf646a9c455cdc6811c733a77)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3f37c164f1b3468ae36d96b5885fe54ec3d5051fb5f4a471aed00f2af0ae3d32)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanMonoHue]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanMonoHue]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__66b03031b4a462bf0c279adb5b190f8de3d7ce2c7837eacd375be4a2de7b4434)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanMonoHueOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanMonoHueOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__34f681b4e342f24946505c2f61c228fe60cf0669c166add906223defc0f51a03)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__77b9ec359b6acf2b5cb5ab80297d3cb6dd9858a439c4ebf9420c4dab0def84b0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d28eb1f303a289610ff9db0c7d7fdc937d3c7954ebdeca16bf21c3c7be824f2a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanMonoHue]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanMonoHue]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanMonoHue]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b725dc9f5c4c1f5d1776c86c131f6e984e0b8eb471f09ee6e58aaf3c9cc0873d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanOpacity",
    jsii_struct_bases=[],
    name_mapping={"opacity": "opacity", "opacity_var": "opacityVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanOpacity:
    def __init__(
        self,
        *,
        opacity: typing.Optional[builtins.str] = None,
        opacity_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param opacity: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param opacity_var: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__adeebcaa470a532bf9cceaef36796ee9d5e3f095286f6d2d1909fa4c58addbc1)
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument opacity_var", value=opacity_var, expected_type=type_hints["opacity_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if opacity is not None:
            self._values["opacity"] = opacity
        if opacity_var is not None:
            self._values["opacity_var"] = opacity_var

    @builtins.property
    def opacity(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def opacity_var(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        result = self._values.get("opacity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanOpacity(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanOpacityList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanOpacityList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7ba94a663d75bddcdd676b9e355258c8e0e600f1d3901a392d34c1d0d32d0a7a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanOpacityOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7ab7b2165802b17f3dcaad20d39760dd0828c818a396cb5f0665c8b7a21ebe4e)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanOpacityOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d1bf0e0fedf79148cc3305d1295b6a1e6ad7bb470b58e0929220c5887026646)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cb07cb404c25a79414fdd3bde751ee51c7d85c9d83e262a52066b4c4bda6ffa5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__27656449028ec74571a4e55f0cb14e6e1862cfbf14c1bf2f887cfcd388b23f57)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanOpacity]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanOpacity]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b6098163968f8932d1f7d3ad4433791e23abc1e82f54235eced3b68112792812)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanOpacityOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanOpacityOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e2c68d00daa8ea55bf51714e99686b4d15a9709924305981e7a5d11a41a7ee73)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetOpacityVar")
    def reset_opacity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacityVar", []))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityVarInput")
    def opacity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacity"))

    @opacity.setter
    def opacity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a5ff49e2dde4d61727bef48500e88067e1e4e3b5749c1fbc44397b389bd1a103)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacity", value)

    @builtins.property
    @jsii.member(jsii_name="opacityVar")
    def opacity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacityVar"))

    @opacity_var.setter
    def opacity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__37b0e810e7c017f211949a403986baea10f31f040df9d91c6b2deb69833ece8a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacityVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanOpacity]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanOpacity]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanOpacity]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d3a397181f4908bd0d305dfbbc51c1e5aa96de1c51e24645aaa058c5867881a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a4a9cfd5563bebdfea86187fb8c43978a73faa23aa95d82421ce5e433ab8f152)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putBackgroundColor")
    def put_background_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d919a6041de90d618708c08da0e70b2ee8b6a8bb2d15b32638bb08eba52c0b0d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBackgroundColor", [value]))

    @jsii.member(jsii_name="putBlur")
    def put_blur(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanBlur, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1a3d3786125eef39889b2dd3653f11c39fc56b536782c428f3a931f2d63347f3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBlur", [value]))

    @jsii.member(jsii_name="putChromaKey")
    def put_chroma_key(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanChromaKey, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__316e27103600344a1036eaa490f3c458581b15230e1f0d80d9f6947aa1861dd2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putChromaKey", [value]))

    @jsii.member(jsii_name="putComposite")
    def put_composite(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanComposite, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__77b6e874cfd935a4ea4e8cc6cd44fe59317eb93d395ddcc78a1563db13d2b78e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putComposite", [value]))

    @jsii.member(jsii_name="putCompound")
    def put_compound(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanCompound, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8f6774eed65a83863f799e0723fcb57903c306465861e5ee78fb0c7199cf82e1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCompound", [value]))

    @jsii.member(jsii_name="putContrast")
    def put_contrast(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanContrast, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a3455ea1d43baa9ff5f03d36aec003b70a0ca4b0c4be3125268cc4742c39be3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putContrast", [value]))

    @jsii.member(jsii_name="putGoop")
    def put_goop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanGoop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__17cb93e0bd8ac76a1a8a1645609f009a14d097f31243b63c0f27b51469880e6f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGoop", [value]))

    @jsii.member(jsii_name="putGrayscale")
    def put_grayscale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanGrayscale, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c9ce0514cdf7035c15fbceaf731ecc4443366bf5508988b8097ae9e6d4a33d88)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGrayscale", [value]))

    @jsii.member(jsii_name="putHsl")
    def put_hsl(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanHsl, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d670a1228506c7e0d1c9df47d953c638fdecaadf15afcda4af0648868387e2e1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsl", [value]))

    @jsii.member(jsii_name="putHsv")
    def put_hsv(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanHsv, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ab4e7896067c6c0459052a0c68c755a04c3869d1dd92d12606c70ec751a36b1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsv", [value]))

    @jsii.member(jsii_name="putIfDimension")
    def put_if_dimension(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfDimension, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b0d6aad4c101f803664d4ef0d7feee7d5b20028a14ad2efac46dd8da97c661ed)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfDimension", [value]))

    @jsii.member(jsii_name="putIfOrientation")
    def put_if_orientation(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1b0c44f90fb0a0cbc334e3ece48afc29419702c0967023c3110076cfac580e4e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfOrientation", [value]))

    @jsii.member(jsii_name="putMaxColors")
    def put_max_colors(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanMaxColors, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f6db2ae2d7aaf6815293b6acb51e816ccd1279ad55b132265d49e1f38b46e52f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMaxColors", [value]))

    @jsii.member(jsii_name="putMirror")
    def put_mirror(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanMirror, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fccff4eaff1588808c987d71f7ac516707a906a199b47e5a0db16b3738e02bd7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMirror", [value]))

    @jsii.member(jsii_name="putMonoHue")
    def put_mono_hue(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanMonoHue, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__07bc335594710387c28af69b8c7950252bf5414522120ba81008675795078ae7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMonoHue", [value]))

    @jsii.member(jsii_name="putOpacity")
    def put_opacity(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanOpacity, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ad27c2ced80a844727f44236fae109daf594645c21594d919b01a8bc20351b7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putOpacity", [value]))

    @jsii.member(jsii_name="putRemoveColor")
    def put_remove_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanRemoveColor", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9c2d4df76649130421f3860fbffec9d95b621db0b57d56a21e80bb79f41a508f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRemoveColor", [value]))

    @jsii.member(jsii_name="putUnsharpMask")
    def put_unsharp_mask(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanUnsharpMask", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dcab4ce81925b3c98270c0026a641ad61d48de1e07a7c9b6b1d7600d157839e1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putUnsharpMask", [value]))

    @jsii.member(jsii_name="resetBackgroundColor")
    def reset_background_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBackgroundColor", []))

    @jsii.member(jsii_name="resetBlur")
    def reset_blur(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBlur", []))

    @jsii.member(jsii_name="resetChromaKey")
    def reset_chroma_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChromaKey", []))

    @jsii.member(jsii_name="resetComposite")
    def reset_composite(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetComposite", []))

    @jsii.member(jsii_name="resetCompound")
    def reset_compound(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCompound", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetGoop")
    def reset_goop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGoop", []))

    @jsii.member(jsii_name="resetGrayscale")
    def reset_grayscale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGrayscale", []))

    @jsii.member(jsii_name="resetHsl")
    def reset_hsl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsl", []))

    @jsii.member(jsii_name="resetHsv")
    def reset_hsv(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsv", []))

    @jsii.member(jsii_name="resetIfDimension")
    def reset_if_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfDimension", []))

    @jsii.member(jsii_name="resetIfOrientation")
    def reset_if_orientation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfOrientation", []))

    @jsii.member(jsii_name="resetMaxColors")
    def reset_max_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxColors", []))

    @jsii.member(jsii_name="resetMirror")
    def reset_mirror(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMirror", []))

    @jsii.member(jsii_name="resetMonoHue")
    def reset_mono_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonoHue", []))

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetRemoveColor")
    def reset_remove_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRemoveColor", []))

    @jsii.member(jsii_name="resetUnsharpMask")
    def reset_unsharp_mask(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUnsharpMask", []))

    @builtins.property
    @jsii.member(jsii_name="backgroundColor")
    def background_color(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanBackgroundColorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanBackgroundColorList, jsii.get(self, "backgroundColor"))

    @builtins.property
    @jsii.member(jsii_name="blur")
    def blur(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanBlurList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanBlurList, jsii.get(self, "blur"))

    @builtins.property
    @jsii.member(jsii_name="chromaKey")
    def chroma_key(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanChromaKeyList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanChromaKeyList, jsii.get(self, "chromaKey"))

    @builtins.property
    @jsii.member(jsii_name="composite")
    def composite(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanCompositeList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanCompositeList, jsii.get(self, "composite"))

    @builtins.property
    @jsii.member(jsii_name="compound")
    def compound(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanCompoundList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanCompoundList, jsii.get(self, "compound"))

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanContrastList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanContrastList, jsii.get(self, "contrast"))

    @builtins.property
    @jsii.member(jsii_name="goop")
    def goop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanGoopList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanGoopList, jsii.get(self, "goop"))

    @builtins.property
    @jsii.member(jsii_name="grayscale")
    def grayscale(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanGrayscaleList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanGrayscaleList, jsii.get(self, "grayscale"))

    @builtins.property
    @jsii.member(jsii_name="hsl")
    def hsl(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanHslList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanHslList, jsii.get(self, "hsl"))

    @builtins.property
    @jsii.member(jsii_name="hsv")
    def hsv(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanHsvList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanHsvList, jsii.get(self, "hsv"))

    @builtins.property
    @jsii.member(jsii_name="ifDimension")
    def if_dimension(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfDimensionList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfDimensionList, jsii.get(self, "ifDimension"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientation")
    def if_orientation(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfOrientationList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfOrientationList, jsii.get(self, "ifOrientation"))

    @builtins.property
    @jsii.member(jsii_name="maxColors")
    def max_colors(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanMaxColorsList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanMaxColorsList, jsii.get(self, "maxColors"))

    @builtins.property
    @jsii.member(jsii_name="mirror")
    def mirror(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanMirrorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanMirrorList, jsii.get(self, "mirror"))

    @builtins.property
    @jsii.member(jsii_name="monoHue")
    def mono_hue(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanMonoHueList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanMonoHueList, jsii.get(self, "monoHue"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanOpacityList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanOpacityList, jsii.get(self, "opacity"))

    @builtins.property
    @jsii.member(jsii_name="removeColor")
    def remove_color(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanRemoveColorList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanRemoveColorList", jsii.get(self, "removeColor"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMask")
    def unsharp_mask(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanUnsharpMaskList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanUnsharpMaskList", jsii.get(self, "unsharpMask"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColorInput")
    def background_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanBackgroundColor]]], jsii.get(self, "backgroundColorInput"))

    @builtins.property
    @jsii.member(jsii_name="blurInput")
    def blur_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanBlur]]], jsii.get(self, "blurInput"))

    @builtins.property
    @jsii.member(jsii_name="chromaKeyInput")
    def chroma_key_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanChromaKey]]], jsii.get(self, "chromaKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="compositeInput")
    def composite_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanComposite]]], jsii.get(self, "compositeInput"))

    @builtins.property
    @jsii.member(jsii_name="compoundInput")
    def compound_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanCompound]]], jsii.get(self, "compoundInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanContrast]]], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="goopInput")
    def goop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanGoop]]], jsii.get(self, "goopInput"))

    @builtins.property
    @jsii.member(jsii_name="grayscaleInput")
    def grayscale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanGrayscale]]], jsii.get(self, "grayscaleInput"))

    @builtins.property
    @jsii.member(jsii_name="hslInput")
    def hsl_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanHsl]]], jsii.get(self, "hslInput"))

    @builtins.property
    @jsii.member(jsii_name="hsvInput")
    def hsv_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanHsv]]], jsii.get(self, "hsvInput"))

    @builtins.property
    @jsii.member(jsii_name="ifDimensionInput")
    def if_dimension_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfDimension]]], jsii.get(self, "ifDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientationInput")
    def if_orientation_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfOrientation]]], jsii.get(self, "ifOrientationInput"))

    @builtins.property
    @jsii.member(jsii_name="maxColorsInput")
    def max_colors_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanMaxColors]]], jsii.get(self, "maxColorsInput"))

    @builtins.property
    @jsii.member(jsii_name="mirrorInput")
    def mirror_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanMirror]]], jsii.get(self, "mirrorInput"))

    @builtins.property
    @jsii.member(jsii_name="monoHueInput")
    def mono_hue_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanMonoHue]]], jsii.get(self, "monoHueInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanOpacity]]], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="removeColorInput")
    def remove_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanRemoveColor"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanRemoveColor"]]], jsii.get(self, "removeColorInput"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMaskInput")
    def unsharp_mask_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanUnsharpMask"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanUnsharpMask"]]], jsii.get(self, "unsharpMaskInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2e6a17435e5315effbe170d269a1bebdde9c63a7a8f96d235b0ae4556f5b3651)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanRemoveColor",
    jsii_struct_bases=[],
    name_mapping={
        "color": "color",
        "color_var": "colorVar",
        "feather": "feather",
        "feather_var": "featherVar",
        "tolerance": "tolerance",
        "tolerance_var": "toleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanRemoveColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
        feather: typing.Optional[builtins.str] = None,
        feather_var: typing.Optional[builtins.str] = None,
        tolerance: typing.Optional[builtins.str] = None,
        tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        :param feather: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        :param feather_var: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        :param tolerance: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        :param tolerance_var: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8c62c07d819c233ee50e8f736687daa5b94d6116b8a903dd6ee5597c207358b0)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
            check_type(argname="argument feather", value=feather, expected_type=type_hints["feather"])
            check_type(argname="argument feather_var", value=feather_var, expected_type=type_hints["feather_var"])
            check_type(argname="argument tolerance", value=tolerance, expected_type=type_hints["tolerance"])
            check_type(argname="argument tolerance_var", value=tolerance_var, expected_type=type_hints["tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var
        if feather is not None:
            self._values["feather"] = feather
        if feather_var is not None:
            self._values["feather_var"] = feather_var
        if tolerance is not None:
            self._values["tolerance"] = tolerance
        if tolerance_var is not None:
            self._values["tolerance_var"] = tolerance_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        '''
        result = self._values.get("feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather_var(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        '''
        result = self._values.get("feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        '''
        result = self._values.get("tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance_var(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        result = self._values.get("tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanRemoveColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanRemoveColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanRemoveColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5d14f6048b095bde20ff660705fe407c7f3a1a0de5044cd8fccb7350252e6bfd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanRemoveColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__644044dd3d93ceba8874463c167275cfda5eddda6114d630b4c1ef22b70e5ff2)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanRemoveColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__65a6508d53b40e1912c7a7a2149bb86e463ed21725d9ae1b41792c5594151f56)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b3fb8cd64ddc04736a8a040a3a3eb2eaee9b68bca71595355d85ff3808c1148f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bccc0f831362a51c1389e9b25c6679f2d27915646f8c1d281887523f2dbf652f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanRemoveColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanRemoveColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanRemoveColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8abca92266642fba8b8eea50f40fcee463b880dffe0da5afc9e4773a761608fb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanRemoveColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanRemoveColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa735a5104be4bcecfd21e553fdca0a80007fae69d9393faab94d6c891d1c877)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @jsii.member(jsii_name="resetFeather")
    def reset_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeather", []))

    @jsii.member(jsii_name="resetFeatherVar")
    def reset_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatherVar", []))

    @jsii.member(jsii_name="resetTolerance")
    def reset_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTolerance", []))

    @jsii.member(jsii_name="resetToleranceVar")
    def reset_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featherInput")
    def feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherInput"))

    @builtins.property
    @jsii.member(jsii_name="featherVarInput")
    def feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceInput")
    def tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceVarInput")
    def tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__37c4ec00e44391f28529ac494878d884ef4b473fbc461f6d97980370d71045c3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b69cee3e62a211e35982a91793d4595fcc8b4f3c5fbc9843e2a9ba5ddb462054)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="feather")
    def feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "feather"))

    @feather.setter
    def feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a3a98da7824e4af03f77b89d3d38155a4cdc1fb3b413c3da7ff4e950a65856dc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "feather", value)

    @builtins.property
    @jsii.member(jsii_name="featherVar")
    def feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featherVar"))

    @feather_var.setter
    def feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac5440cf7daa0b522e2a4fbfbfbb7d9fd07f7771d363c5e495d3989365a11590)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featherVar", value)

    @builtins.property
    @jsii.member(jsii_name="tolerance")
    def tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tolerance"))

    @tolerance.setter
    def tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__facbcafb347e8ead0c39e7f67a06bf7bd4b8a64b42cecc048bbb5c322978ccda)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tolerance", value)

    @builtins.property
    @jsii.member(jsii_name="toleranceVar")
    def tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "toleranceVar"))

    @tolerance_var.setter
    def tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__969a5ec3b03262ab71d27fda39f795652760aaa9c5634ebc13bc92c705b6a04d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "toleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanRemoveColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanRemoveColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanRemoveColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0f411719e7c9053615e7e92184ad3c625c410434594b1559b59027e025e1f758)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanUnsharpMask",
    jsii_struct_bases=[],
    name_mapping={
        "gain": "gain",
        "gain_var": "gainVar",
        "sigma": "sigma",
        "sigma_var": "sigmaVar",
        "threshold": "threshold",
        "threshold_var": "thresholdVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanUnsharpMask:
    def __init__(
        self,
        *,
        gain: typing.Optional[builtins.str] = None,
        gain_var: typing.Optional[builtins.str] = None,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
        threshold: typing.Optional[builtins.str] = None,
        threshold_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param gain: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        :param gain_var: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        :param sigma: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        :param threshold: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        :param threshold_var: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4db6d3a700a3603262793c03be473010c494f3e0812cada2e90503009824bbb6)
            check_type(argname="argument gain", value=gain, expected_type=type_hints["gain"])
            check_type(argname="argument gain_var", value=gain_var, expected_type=type_hints["gain_var"])
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
            check_type(argname="argument threshold", value=threshold, expected_type=type_hints["threshold"])
            check_type(argname="argument threshold_var", value=threshold_var, expected_type=type_hints["threshold_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if gain is not None:
            self._values["gain"] = gain
        if gain_var is not None:
            self._values["gain_var"] = gain_var
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var
        if threshold is not None:
            self._values["threshold"] = threshold
        if threshold_var is not None:
            self._values["threshold_var"] = threshold_var

    @builtins.property
    def gain(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        '''
        result = self._values.get("gain")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gain_var(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        '''
        result = self._values.get("gain_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        '''
        result = self._values.get("threshold")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold_var(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        result = self._values.get("threshold_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanUnsharpMask(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanUnsharpMaskList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanUnsharpMaskList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8c56e86202b9b264ef3d76b9aa2d5f824be3c4ac6278ea20a4138254c6eb1af1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanUnsharpMaskOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__63b6835760e55edcf58ad385f5d79fab52fc983c77a102400414da6e1f3176b5)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanUnsharpMaskOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3e6b57411000a23b5b6c222b0a44793655db7f7163db09dd9785a178dfd137cc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c16053644336067d2ccca66370245af1f5a09732d851a107245abc093ecbdefa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d37c1b9da5d0cc7957f7ea76e2ab1817b964f29da4a3e2ab134f012f6d53e647)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanUnsharpMask]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanUnsharpMask]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanUnsharpMask]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__397bf29c47db46af64859d127d5fd2b07f23a87f71da9f547583d4b414c52a7f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanUnsharpMaskOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanUnsharpMaskOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__28b9edcf05b70e25577f7e6d26deba9f7f201a90d0442394604e2a9f72ca75a0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetGain")
    def reset_gain(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGain", []))

    @jsii.member(jsii_name="resetGainVar")
    def reset_gain_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGainVar", []))

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @jsii.member(jsii_name="resetThreshold")
    def reset_threshold(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThreshold", []))

    @jsii.member(jsii_name="resetThresholdVar")
    def reset_threshold_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThresholdVar", []))

    @builtins.property
    @jsii.member(jsii_name="gainInput")
    def gain_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainInput"))

    @builtins.property
    @jsii.member(jsii_name="gainVarInput")
    def gain_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdInput")
    def threshold_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdVarInput")
    def threshold_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gain")
    def gain(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gain"))

    @gain.setter
    def gain(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__afa3a5db7d1e280e80b0ba6b9b6930a289a2a4caefc3f55694d2a73d0fd89b3c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gain", value)

    @builtins.property
    @jsii.member(jsii_name="gainVar")
    def gain_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gainVar"))

    @gain_var.setter
    def gain_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ebd33897bf1bfbdbba5cfe276f2acbddf0fdfcfa44d365ac1457f30ad31faec1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gainVar", value)

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e0ae300e3e7234f07e42ca341bbbb76f0416467592174a7f2359b79ad47e7086)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f92ec7af47a5ab057532b04c09e7df3d9e10909ee37d40ecc2ef228769b98461)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="threshold")
    def threshold(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "threshold"))

    @threshold.setter
    def threshold(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9203fa8f24ef7ed51cb891eb306f6158b3e1541b35d2a23f4ba28aae314b91ff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "threshold", value)

    @builtins.property
    @jsii.member(jsii_name="thresholdVar")
    def threshold_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "thresholdVar"))

    @threshold_var.setter
    def threshold_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7fc77c25078fadeef2dfbde207c08a2fe1fce0c25741caef03adc4e0ca3bd8d7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "thresholdVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanUnsharpMask]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanUnsharpMask]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanUnsharpMask]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__beeffe21160c4c9a186ce431e024f1d99c930d064f1b6b9f1dfd3c1b895e459e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__009b6ffd0f884ba4577011231a01e8cec12a87bfc9328d1fe83e8cbea37a68df)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0aecb0ef38f3c025f7bfc2423a429ed97123cf7e25a99cd0647aed366ddf2215)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ee95c1d2aba8f8dec2cd96a4ac4ff60218a528d247e1811378823bb978a6bdf5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c076694c3a04eb0f74f56ca02b12c6479b417b4297b53c528a4bd5cd5d53c775)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__21a25d35578b65150ac546c94b04d2a80963b73c4d059931565289e9fa17ed5f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimension]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimension]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e5b80a86b5825273c5a66bda78980d85aa6bf82fd8b6cb4a06a329415628d036)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0220485a64c6edab99e5fe0c448de18706c0a7b573114a1af750245afc7f86ea)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(
        self,
        *,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefault(
            background_color=background_color,
            blur=blur,
            chroma_key=chroma_key,
            composite=composite,
            compound=compound,
            contrast=contrast,
            goop=goop,
            grayscale=grayscale,
            hsl=hsl,
            hsv=hsv,
            if_dimension=if_dimension,
            if_orientation=if_orientation,
            max_colors=max_colors,
            mirror=mirror,
            mono_hue=mono_hue,
            opacity=opacity,
            remove_color=remove_color,
            unsharp_mask=unsharp_mask,
        )

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putEqual")
    def put_equal(
        self,
        *,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqual(
            background_color=background_color,
            blur=blur,
            chroma_key=chroma_key,
            composite=composite,
            compound=compound,
            contrast=contrast,
            goop=goop,
            grayscale=grayscale,
            hsl=hsl,
            hsv=hsv,
            if_dimension=if_dimension,
            if_orientation=if_orientation,
            max_colors=max_colors,
            mirror=mirror,
            mono_hue=mono_hue,
            opacity=opacity,
            remove_color=remove_color,
            unsharp_mask=unsharp_mask,
        )

        return typing.cast(None, jsii.invoke(self, "putEqual", [value]))

    @jsii.member(jsii_name="putGreaterThan")
    def put_greater_than(
        self,
        *,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThan(
            background_color=background_color,
            blur=blur,
            chroma_key=chroma_key,
            composite=composite,
            compound=compound,
            contrast=contrast,
            goop=goop,
            grayscale=grayscale,
            hsl=hsl,
            hsv=hsv,
            if_dimension=if_dimension,
            if_orientation=if_orientation,
            max_colors=max_colors,
            mirror=mirror,
            mono_hue=mono_hue,
            opacity=opacity,
            remove_color=remove_color,
            unsharp_mask=unsharp_mask,
        )

        return typing.cast(None, jsii.invoke(self, "putGreaterThan", [value]))

    @jsii.member(jsii_name="putLessThan")
    def put_less_than(
        self,
        *,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThan(
            background_color=background_color,
            blur=blur,
            chroma_key=chroma_key,
            composite=composite,
            compound=compound,
            contrast=contrast,
            goop=goop,
            grayscale=grayscale,
            hsl=hsl,
            hsv=hsv,
            if_dimension=if_dimension,
            if_orientation=if_orientation,
            max_colors=max_colors,
            mirror=mirror,
            mono_hue=mono_hue,
            opacity=opacity,
            remove_color=remove_color,
            unsharp_mask=unsharp_mask,
        )

        return typing.cast(None, jsii.invoke(self, "putLessThan", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetDimension")
    def reset_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimension", []))

    @jsii.member(jsii_name="resetDimensionVar")
    def reset_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimensionVar", []))

    @jsii.member(jsii_name="resetEqual")
    def reset_equal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEqual", []))

    @jsii.member(jsii_name="resetGreaterThan")
    def reset_greater_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGreaterThan", []))

    @jsii.member(jsii_name="resetLessThan")
    def reset_less_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLessThan", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="equal")
    def equal(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualOutputReference, jsii.get(self, "equal"))

    @builtins.property
    @jsii.member(jsii_name="greaterThan")
    def greater_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanOutputReference, jsii.get(self, "greaterThan"))

    @builtins.property
    @jsii.member(jsii_name="lessThan")
    def less_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanOutputReference, jsii.get(self, "lessThan"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionInput")
    def dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionVarInput")
    def dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="equalInput")
    def equal_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqual], jsii.get(self, "equalInput"))

    @builtins.property
    @jsii.member(jsii_name="greaterThanInput")
    def greater_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThan], jsii.get(self, "greaterThanInput"))

    @builtins.property
    @jsii.member(jsii_name="lessThanInput")
    def less_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThan], jsii.get(self, "lessThanInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="dimension")
    def dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimension"))

    @dimension.setter
    def dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7e5bb1ab43cb47de3577cd4b26504fba9dd85b607097c67ea2bfd89ed3f9a746)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimension", value)

    @builtins.property
    @jsii.member(jsii_name="dimensionVar")
    def dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimensionVar"))

    @dimension_var.setter
    def dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3b08e338975bed00909e49dbac5dd27b3427f47c6debeccd7115882a2419cbe1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9cc3f132fa8332dea449d576d55ac08c17c676a510f6a7c2e4af13fc629deb7a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6740627a01687e75c4b033ae82445e889c0fa7e02d38f913995575a62e8798b7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimension]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimension]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimension]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5e7247bc9c5f27c6210ae103f0b8d250e8362e37b6a571fcf51cb9045d491b5a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientation",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "landscape": "landscape",
        "portrait": "portrait",
        "square": "square",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientation:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        landscape: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscape", typing.Dict[builtins.str, typing.Any]]] = None,
        portrait: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortrait", typing.Dict[builtins.str, typing.Any]]] = None,
        square: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquare", typing.Dict[builtins.str, typing.Any]]] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param landscape: landscape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        :param portrait: portrait block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        :param square: square block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefault(**default)
        if isinstance(landscape, dict):
            landscape = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscape(**landscape)
        if isinstance(portrait, dict):
            portrait = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortrait(**portrait)
        if isinstance(square, dict):
            square = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquare(**square)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__805c231ad30e4e72ef994792b877e2647c1c908f891fd8036b42773c69be7131)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument landscape", value=landscape, expected_type=type_hints["landscape"])
            check_type(argname="argument portrait", value=portrait, expected_type=type_hints["portrait"])
            check_type(argname="argument square", value=square, expected_type=type_hints["square"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if landscape is not None:
            self._values["landscape"] = landscape
        if portrait is not None:
            self._values["portrait"] = portrait
        if square is not None:
            self._values["square"] = square

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefault"], result)

    @builtins.property
    def landscape(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscape"]:
        '''landscape block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        '''
        result = self._values.get("landscape")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscape"], result)

    @builtins.property
    def portrait(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortrait"]:
        '''portrait block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        '''
        result = self._values.get("portrait")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortrait"], result)

    @builtins.property
    def square(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquare"]:
        '''square block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        result = self._values.get("square")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquare"], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefault",
    jsii_struct_bases=[],
    name_mapping={
        "background_color": "backgroundColor",
        "blur": "blur",
        "chroma_key": "chromaKey",
        "composite": "composite",
        "compound": "compound",
        "contrast": "contrast",
        "goop": "goop",
        "grayscale": "grayscale",
        "hsl": "hsl",
        "hsv": "hsv",
        "if_dimension": "ifDimension",
        "if_orientation": "ifOrientation",
        "max_colors": "maxColors",
        "mirror": "mirror",
        "mono_hue": "monoHue",
        "opacity": "opacity",
        "remove_color": "removeColor",
        "unsharp_mask": "unsharpMask",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefault:
    def __init__(
        self,
        *,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultBackgroundColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultBlur", typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultChromaKey", typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultComposite", typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultCompound", typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultContrast", typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultGoop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultGrayscale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultHsl", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultHsv", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfDimension", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfOrientation", typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultMaxColors", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultMirror", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultMonoHue", typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultOpacity", typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultRemoveColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultUnsharpMask", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac5bf9604783cbf2493693a7e96cc10fd1487f2364f44c376c633c4c990c47d7)
            check_type(argname="argument background_color", value=background_color, expected_type=type_hints["background_color"])
            check_type(argname="argument blur", value=blur, expected_type=type_hints["blur"])
            check_type(argname="argument chroma_key", value=chroma_key, expected_type=type_hints["chroma_key"])
            check_type(argname="argument composite", value=composite, expected_type=type_hints["composite"])
            check_type(argname="argument compound", value=compound, expected_type=type_hints["compound"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument goop", value=goop, expected_type=type_hints["goop"])
            check_type(argname="argument grayscale", value=grayscale, expected_type=type_hints["grayscale"])
            check_type(argname="argument hsl", value=hsl, expected_type=type_hints["hsl"])
            check_type(argname="argument hsv", value=hsv, expected_type=type_hints["hsv"])
            check_type(argname="argument if_dimension", value=if_dimension, expected_type=type_hints["if_dimension"])
            check_type(argname="argument if_orientation", value=if_orientation, expected_type=type_hints["if_orientation"])
            check_type(argname="argument max_colors", value=max_colors, expected_type=type_hints["max_colors"])
            check_type(argname="argument mirror", value=mirror, expected_type=type_hints["mirror"])
            check_type(argname="argument mono_hue", value=mono_hue, expected_type=type_hints["mono_hue"])
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument remove_color", value=remove_color, expected_type=type_hints["remove_color"])
            check_type(argname="argument unsharp_mask", value=unsharp_mask, expected_type=type_hints["unsharp_mask"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if background_color is not None:
            self._values["background_color"] = background_color
        if blur is not None:
            self._values["blur"] = blur
        if chroma_key is not None:
            self._values["chroma_key"] = chroma_key
        if composite is not None:
            self._values["composite"] = composite
        if compound is not None:
            self._values["compound"] = compound
        if contrast is not None:
            self._values["contrast"] = contrast
        if goop is not None:
            self._values["goop"] = goop
        if grayscale is not None:
            self._values["grayscale"] = grayscale
        if hsl is not None:
            self._values["hsl"] = hsl
        if hsv is not None:
            self._values["hsv"] = hsv
        if if_dimension is not None:
            self._values["if_dimension"] = if_dimension
        if if_orientation is not None:
            self._values["if_orientation"] = if_orientation
        if max_colors is not None:
            self._values["max_colors"] = max_colors
        if mirror is not None:
            self._values["mirror"] = mirror
        if mono_hue is not None:
            self._values["mono_hue"] = mono_hue
        if opacity is not None:
            self._values["opacity"] = opacity
        if remove_color is not None:
            self._values["remove_color"] = remove_color
        if unsharp_mask is not None:
            self._values["unsharp_mask"] = unsharp_mask

    @builtins.property
    def background_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultBackgroundColor"]]]:
        '''background_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        '''
        result = self._values.get("background_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultBackgroundColor"]]], result)

    @builtins.property
    def blur(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultBlur"]]]:
        '''blur block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        '''
        result = self._values.get("blur")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultBlur"]]], result)

    @builtins.property
    def chroma_key(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultChromaKey"]]]:
        '''chroma_key block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        '''
        result = self._values.get("chroma_key")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultChromaKey"]]], result)

    @builtins.property
    def composite(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultComposite"]]]:
        '''composite block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        '''
        result = self._values.get("composite")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultComposite"]]], result)

    @builtins.property
    def compound(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultCompound"]]]:
        '''compound block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        '''
        result = self._values.get("compound")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultCompound"]]], result)

    @builtins.property
    def contrast(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultContrast"]]]:
        '''contrast block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultContrast"]]], result)

    @builtins.property
    def goop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultGoop"]]]:
        '''goop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        '''
        result = self._values.get("goop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultGoop"]]], result)

    @builtins.property
    def grayscale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultGrayscale"]]]:
        '''grayscale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        '''
        result = self._values.get("grayscale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultGrayscale"]]], result)

    @builtins.property
    def hsl(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultHsl"]]]:
        '''hsl block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        '''
        result = self._values.get("hsl")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultHsl"]]], result)

    @builtins.property
    def hsv(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultHsv"]]]:
        '''hsv block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        '''
        result = self._values.get("hsv")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultHsv"]]], result)

    @builtins.property
    def if_dimension(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfDimension"]]]:
        '''if_dimension block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        '''
        result = self._values.get("if_dimension")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfDimension"]]], result)

    @builtins.property
    def if_orientation(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfOrientation"]]]:
        '''if_orientation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        '''
        result = self._values.get("if_orientation")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfOrientation"]]], result)

    @builtins.property
    def max_colors(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultMaxColors"]]]:
        '''max_colors block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        '''
        result = self._values.get("max_colors")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultMaxColors"]]], result)

    @builtins.property
    def mirror(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultMirror"]]]:
        '''mirror block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        '''
        result = self._values.get("mirror")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultMirror"]]], result)

    @builtins.property
    def mono_hue(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultMonoHue"]]]:
        '''mono_hue block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        '''
        result = self._values.get("mono_hue")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultMonoHue"]]], result)

    @builtins.property
    def opacity(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultOpacity"]]]:
        '''opacity block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultOpacity"]]], result)

    @builtins.property
    def remove_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultRemoveColor"]]]:
        '''remove_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        '''
        result = self._values.get("remove_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultRemoveColor"]]], result)

    @builtins.property
    def unsharp_mask(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultUnsharpMask"]]]:
        '''unsharp_mask block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        result = self._values.get("unsharp_mask")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultUnsharpMask"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultBackgroundColor",
    jsii_struct_bases=[],
    name_mapping={"color": "color", "color_var": "colorVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultBackgroundColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a516ff8d83ede5d30e66794f72063b7a54263ac3913468714f5b779c414949ab)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultBackgroundColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultBackgroundColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultBackgroundColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2828bb7a5a54a93a6ae9ce7a9d96555ad4bd63a813badc5b8e1f80d6e859aa4e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultBackgroundColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__11afe6f059d48c9331be572e934767ba1691a632a00fbbd1284a87cf2c0127de)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultBackgroundColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e6122fb0d1ebfb814635c233ce38d449b79b745454479a625a33da94b19615a9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3c62ec95becf97c21775e8d37734cc1e4d3b91b224dd8d8f8476df8ea6218b8b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__24b383984be50f1524618167430682eee8c36739d52008cc8516e22a9f436973)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultBackgroundColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultBackgroundColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7bd629c6ca63cd629f14d2c5abed7fa20d9546d6520e4ae05ecb45b184deccc0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultBackgroundColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultBackgroundColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4d4efb0a86b7da3e1304a43013f9c2ff8eec868c5ca56704e9381ff52c5a4c47)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__45a42880753b8e0c43384566de89be775670a3bffb822a43293eb36df95255a8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cf7fd8d38f487282cfe4677fc5a6157e59605e29a1a2dd1e3a1cc3dbefe03114)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultBackgroundColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultBackgroundColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultBackgroundColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__27638b7f83b72b74344f31c26d46687fee2a8a8f9fa14cbbe86cd14f317ad2e9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultBlur",
    jsii_struct_bases=[],
    name_mapping={"sigma": "sigma", "sigma_var": "sigmaVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultBlur:
    def __init__(
        self,
        *,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param sigma: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b0aee1998a2f60c32838ed9b40b6f5d96f66cef263b8ab3b8697b0865f48f32c)
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultBlur(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultBlurList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultBlurList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3178606d9c66f166adb0f36a12eae355bfb3c4e442851dbef50ce58e18947a10)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultBlurOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c1899e16a186ea578fcc86b404109f2222a9074432d13929cadb99626291813d)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultBlurOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cbfef02ff25bd726b49b1f719dc1e4ebdd4546b222ad3484a3a65d66e0ba427a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__31c42daa9526a773a63c4522fcf376259c7d97b3bdac1c5675a35fae0d71d156)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d8f766a3a9f1ad5638e857e80d3520dbdcc3d8279b72407b0b108fc5798c8f83)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultBlur]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultBlur]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c2360fce046af5a251c1064242360a672ad4a07d230f257f48b989f6c93b7d55)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultBlurOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultBlurOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0da12cba22d40d199ed6f6911cf444dd5e17d6489acb4af766aa1c8f8996cde8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__079a66f77bf109614a25aae9bdd452cbb2fd7580f2d49891e70f0e5f3ef1669a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__974c7816cc9db7c3ba45954c017873bfeedfd52dac6f026db23440f25977d517)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultBlur]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultBlur]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultBlur]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b7c5145ff8ace8caefb9bab39bab5005557bc06a48272b812dc390db8b3933fa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultChromaKey",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_feather": "hueFeather",
        "hue_feather_var": "hueFeatherVar",
        "hue_tolerance": "hueTolerance",
        "hue_tolerance_var": "hueToleranceVar",
        "hue_var": "hueVar",
        "lightness_feather": "lightnessFeather",
        "lightness_feather_var": "lightnessFeatherVar",
        "lightness_tolerance": "lightnessTolerance",
        "lightness_tolerance_var": "lightnessToleranceVar",
        "saturation_feather": "saturationFeather",
        "saturation_feather_var": "saturationFeatherVar",
        "saturation_tolerance": "saturationTolerance",
        "saturation_tolerance_var": "saturationToleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultChromaKey:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_feather: typing.Optional[builtins.str] = None,
        hue_feather_var: typing.Optional[builtins.str] = None,
        hue_tolerance: typing.Optional[builtins.str] = None,
        hue_tolerance_var: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness_feather: typing.Optional[builtins.str] = None,
        lightness_feather_var: typing.Optional[builtins.str] = None,
        lightness_tolerance: typing.Optional[builtins.str] = None,
        lightness_tolerance_var: typing.Optional[builtins.str] = None,
        saturation_feather: typing.Optional[builtins.str] = None,
        saturation_feather_var: typing.Optional[builtins.str] = None,
        saturation_tolerance: typing.Optional[builtins.str] = None,
        saturation_tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_feather: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        :param hue_feather_var: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        :param hue_tolerance: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        :param hue_tolerance_var: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        :param hue_var: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness_feather: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        :param lightness_feather_var: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        :param lightness_tolerance: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        :param lightness_tolerance_var: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        :param saturation_feather: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        :param saturation_feather_var: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        :param saturation_tolerance: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        :param saturation_tolerance_var: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b0577b051e088b3e50ae8ad86f1bced41ea60af146738cffc493d71e0599b7fe)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_feather", value=hue_feather, expected_type=type_hints["hue_feather"])
            check_type(argname="argument hue_feather_var", value=hue_feather_var, expected_type=type_hints["hue_feather_var"])
            check_type(argname="argument hue_tolerance", value=hue_tolerance, expected_type=type_hints["hue_tolerance"])
            check_type(argname="argument hue_tolerance_var", value=hue_tolerance_var, expected_type=type_hints["hue_tolerance_var"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness_feather", value=lightness_feather, expected_type=type_hints["lightness_feather"])
            check_type(argname="argument lightness_feather_var", value=lightness_feather_var, expected_type=type_hints["lightness_feather_var"])
            check_type(argname="argument lightness_tolerance", value=lightness_tolerance, expected_type=type_hints["lightness_tolerance"])
            check_type(argname="argument lightness_tolerance_var", value=lightness_tolerance_var, expected_type=type_hints["lightness_tolerance_var"])
            check_type(argname="argument saturation_feather", value=saturation_feather, expected_type=type_hints["saturation_feather"])
            check_type(argname="argument saturation_feather_var", value=saturation_feather_var, expected_type=type_hints["saturation_feather_var"])
            check_type(argname="argument saturation_tolerance", value=saturation_tolerance, expected_type=type_hints["saturation_tolerance"])
            check_type(argname="argument saturation_tolerance_var", value=saturation_tolerance_var, expected_type=type_hints["saturation_tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_feather is not None:
            self._values["hue_feather"] = hue_feather
        if hue_feather_var is not None:
            self._values["hue_feather_var"] = hue_feather_var
        if hue_tolerance is not None:
            self._values["hue_tolerance"] = hue_tolerance
        if hue_tolerance_var is not None:
            self._values["hue_tolerance_var"] = hue_tolerance_var
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness_feather is not None:
            self._values["lightness_feather"] = lightness_feather
        if lightness_feather_var is not None:
            self._values["lightness_feather_var"] = lightness_feather_var
        if lightness_tolerance is not None:
            self._values["lightness_tolerance"] = lightness_tolerance
        if lightness_tolerance_var is not None:
            self._values["lightness_tolerance_var"] = lightness_tolerance_var
        if saturation_feather is not None:
            self._values["saturation_feather"] = saturation_feather
        if saturation_feather_var is not None:
            self._values["saturation_feather_var"] = saturation_feather_var
        if saturation_tolerance is not None:
            self._values["saturation_tolerance"] = saturation_tolerance
        if saturation_tolerance_var is not None:
            self._values["saturation_tolerance_var"] = saturation_tolerance_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        '''
        result = self._values.get("hue_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        '''
        result = self._values.get("hue_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        '''
        result = self._values.get("hue_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        '''
        result = self._values.get("hue_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        '''
        result = self._values.get("lightness_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        '''
        result = self._values.get("lightness_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        '''
        result = self._values.get("lightness_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        '''
        result = self._values.get("lightness_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        '''
        result = self._values.get("saturation_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        '''
        result = self._values.get("saturation_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        '''
        result = self._values.get("saturation_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        result = self._values.get("saturation_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultChromaKey(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultChromaKeyList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultChromaKeyList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__80c11e844b2139b71920aa1193ac40441197cf2fba9412481161acfbb16ba6e2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultChromaKeyOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d426e0e21edd234f3fc3ed7ebda2bfa7b01049c04ea2d40d073f310b562bd0ec)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultChromaKeyOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__74ec246b946191126eb8328ae4061f4ea1a5165e2dbf2abcc619f617e0779c99)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3510aa38587f6780bd6d8a77a8c26f026a9097a42beb8a7ce0fb6d5b9894d084)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0208d2a8259831ffa0c6967ac32909896542994216aaad1a5195f7654f136147)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultChromaKey]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultChromaKey]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__525f82ee94e9b3a3b73fa0d169132c48e8189566a3b73c8daf257e59fcd6e858)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultChromaKeyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultChromaKeyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab734ab5f2eafce623eb3d52dd472abd10eb4848e6691bb829af50494ce29120)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueFeather")
    def reset_hue_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeather", []))

    @jsii.member(jsii_name="resetHueFeatherVar")
    def reset_hue_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeatherVar", []))

    @jsii.member(jsii_name="resetHueTolerance")
    def reset_hue_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueTolerance", []))

    @jsii.member(jsii_name="resetHueToleranceVar")
    def reset_hue_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueToleranceVar", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightnessFeather")
    def reset_lightness_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeather", []))

    @jsii.member(jsii_name="resetLightnessFeatherVar")
    def reset_lightness_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeatherVar", []))

    @jsii.member(jsii_name="resetLightnessTolerance")
    def reset_lightness_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessTolerance", []))

    @jsii.member(jsii_name="resetLightnessToleranceVar")
    def reset_lightness_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessToleranceVar", []))

    @jsii.member(jsii_name="resetSaturationFeather")
    def reset_saturation_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeather", []))

    @jsii.member(jsii_name="resetSaturationFeatherVar")
    def reset_saturation_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeatherVar", []))

    @jsii.member(jsii_name="resetSaturationTolerance")
    def reset_saturation_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationTolerance", []))

    @jsii.member(jsii_name="resetSaturationToleranceVar")
    def reset_saturation_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherInput")
    def hue_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVarInput")
    def hue_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceInput")
    def hue_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVarInput")
    def hue_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherInput")
    def lightness_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVarInput")
    def lightness_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceInput")
    def lightness_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVarInput")
    def lightness_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherInput")
    def saturation_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVarInput")
    def saturation_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceInput")
    def saturation_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVarInput")
    def saturation_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__67778ed67ce49c69ae5cbcb87ab80e6b0d6ca1beb3f72dca10082aea9310e84f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeather")
    def hue_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeather"))

    @hue_feather.setter
    def hue_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c3a9abf65b36afc5c4f94636043b24fdc6fcdb5658dd489104ae5a7d7bad2782)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeather", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVar")
    def hue_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeatherVar"))

    @hue_feather_var.setter
    def hue_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1c7ea9c26d7a5f7964ab850530165aef438d5872c3cb52f2d91db585960cc522)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueTolerance")
    def hue_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueTolerance"))

    @hue_tolerance.setter
    def hue_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eade1d50ca29f6b114b175578f26d351780607a21e636971958cee53297d4793)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVar")
    def hue_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueToleranceVar"))

    @hue_tolerance_var.setter
    def hue_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__45b1f3b5afa9c9c9057393787b4d0ba9a04b5f1302e0a3f538b63a3f5978b7a5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0f09ab7ba44e76d9449d3b6ec26ea1d9d5141c5b0ba5910d3c4aa86da3b6310d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeather")
    def lightness_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeather"))

    @lightness_feather.setter
    def lightness_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__660067e6cff63fb97d04f4b4369d84699eea39f55d5cb0116c39e37dc2ff2eca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeather", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVar")
    def lightness_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeatherVar"))

    @lightness_feather_var.setter
    def lightness_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__72ed3290468f095822c32969a9f64ed07f5674ed13fa6fa0be7011d572912747)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessTolerance")
    def lightness_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessTolerance"))

    @lightness_tolerance.setter
    def lightness_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e685550440b21488d55779572d83a148ad0a1add69f49b414df6be3dbd178a53)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVar")
    def lightness_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessToleranceVar"))

    @lightness_tolerance_var.setter
    def lightness_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__79cbb446d1e6939c4a11b68ec9e5150ad815e27bfd91a2806e3bec9b73771ee9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeather")
    def saturation_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeather"))

    @saturation_feather.setter
    def saturation_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a9ba972542f9c85c075082a4d912f0eecd08cd1be83de06892d3c641d9447c78)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeather", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVar")
    def saturation_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeatherVar"))

    @saturation_feather_var.setter
    def saturation_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__571e6969f3a88e94358df985bea62b3f375ff0a063bbc2960e1b7424e68e891d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationTolerance")
    def saturation_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationTolerance"))

    @saturation_tolerance.setter
    def saturation_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ceb50482bdf9f9cbeb06d0a54908d71699d3b306b0b9b3c3ced47b9492b6ab4b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVar")
    def saturation_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationToleranceVar"))

    @saturation_tolerance_var.setter
    def saturation_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__757d8dc5c293bbb2eb1daf9f6bbc8936a6fc8e7ae317f0d76259300a907aecc1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultChromaKey]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultChromaKey]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultChromaKey]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7053e09db413eb3b580ec0f608ceda53e046641d533663754043d4d0541c8cf4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultComposite",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "placement": "placement",
        "placement_var": "placementVar",
        "scale": "scale",
        "scale_dimension": "scaleDimension",
        "scale_dimension_var": "scaleDimensionVar",
        "scale_var": "scaleVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultComposite:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultCompositeImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        placement: typing.Optional[builtins.str] = None,
        placement_var: typing.Optional[builtins.str] = None,
        scale: typing.Optional[builtins.str] = None,
        scale_dimension: typing.Optional[builtins.str] = None,
        scale_dimension_var: typing.Optional[builtins.str] = None,
        scale_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param placement: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        :param placement_var: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        :param scale: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param scale_dimension: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        :param scale_dimension_var: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        :param scale_var: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        :param x_position: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultCompositeImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2868d54324907e9ba87b1b2eb211e29b07e37b08bce7ce9e80e60610a6e4239a)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument placement", value=placement, expected_type=type_hints["placement"])
            check_type(argname="argument placement_var", value=placement_var, expected_type=type_hints["placement_var"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument scale_dimension", value=scale_dimension, expected_type=type_hints["scale_dimension"])
            check_type(argname="argument scale_dimension_var", value=scale_dimension_var, expected_type=type_hints["scale_dimension_var"])
            check_type(argname="argument scale_var", value=scale_var, expected_type=type_hints["scale_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if placement is not None:
            self._values["placement"] = placement
        if placement_var is not None:
            self._values["placement_var"] = placement_var
        if scale is not None:
            self._values["scale"] = scale
        if scale_dimension is not None:
            self._values["scale_dimension"] = scale_dimension
        if scale_dimension_var is not None:
            self._values["scale_dimension_var"] = scale_dimension_var
        if scale_var is not None:
            self._values["scale_var"] = scale_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultCompositeImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultCompositeImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        '''
        result = self._values.get("placement")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement_var(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        '''
        result = self._values.get("placement_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        '''
        result = self._values.get("scale_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        '''
        result = self._values.get("scale_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        '''
        result = self._values.get("scale_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultComposite(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultCompositeImage",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultCompositeImage:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultCompositeImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultCompositeImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultCompositeImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__24c3fca4dfb02aa37db08762341497f9f5d48da5f0ab0600cec6c65ed45dab11)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultCompositeImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultCompositeImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7dfa5184e9045b4f2d0a8c49b8e3447b6f6b70e1770e0c4c7ec31afe57b81b3b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultCompositeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultCompositeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1d5b5a23dccc5f7c7ea0a30d413f012904c2c04201513c158ab7af4f91b29e1f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultCompositeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__21013cb06714da948286be4c5945b658709477c71735d1e3a786df75587b32f5)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultCompositeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__92102155ce531b817614cdc9997bd9ebc958ba59502f6257520f2700dd08c9eb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__91f381df2ccce2efe6ef1a498040b6ae61db254d777a6848d661231fcf89d544)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__654e943a3d2a8ea5870164a7b15b1484d6102690ef8ef5256762ae8c76070558)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultComposite]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultComposite]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af1d5aee1948ec6d39069d018a6c82e3e7261ae6102844bf8c7ea998074ebf32)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultCompositeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultCompositeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6155734480e6414f41d09554f2ae1f97e2d5f6b1a4ac7b9f8f962716b38cec4c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultCompositeImage()

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPlacement")
    def reset_placement(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacement", []))

    @jsii.member(jsii_name="resetPlacementVar")
    def reset_placement_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacementVar", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetScaleDimension")
    def reset_scale_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimension", []))

    @jsii.member(jsii_name="resetScaleDimensionVar")
    def reset_scale_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimensionVar", []))

    @jsii.member(jsii_name="resetScaleVar")
    def reset_scale_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultCompositeImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultCompositeImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultCompositeImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="placementInput")
    def placement_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementInput"))

    @builtins.property
    @jsii.member(jsii_name="placementVarInput")
    def placement_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionInput")
    def scale_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVarInput")
    def scale_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleVarInput")
    def scale_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__59d7a26e9d7cfe9017bfb8cbb36fdc705fb2b16aed8bf9cebc83d2d7056d19f1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__566a80d65da014b63356a67eff0803277096f6b0bce5c014e0dc2324173381eb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="placement")
    def placement(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placement"))

    @placement.setter
    def placement(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bebb6b84daa604f6d43903c659292acba99eb1c9a49218502420fdfc098a7fba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placement", value)

    @builtins.property
    @jsii.member(jsii_name="placementVar")
    def placement_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placementVar"))

    @placement_var.setter
    def placement_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__751b8b6dc06e9366979044dc281a9561fed1cd507d827983a93624e79b8fed66)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placementVar", value)

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scale"))

    @scale.setter
    def scale(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d253a91fe661bd60f9747adccba77da45b902e0a1229d3199eaf3a483c58c825)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scale", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimension")
    def scale_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimension"))

    @scale_dimension.setter
    def scale_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c7dbf0bca343b6bbf80bac37e7e535249102a39be411bc18d9aea1b39bd3a985)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimension", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVar")
    def scale_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimensionVar"))

    @scale_dimension_var.setter
    def scale_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ebcfd0d0ef492bd0c5594ed7dee27e5d99bc5df542cbfcc199b8ae666a7798ae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="scaleVar")
    def scale_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleVar"))

    @scale_var.setter
    def scale_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4dc8cfa8c146a3f0b6f4296c50be546c93812c65d8fd3ab616af394ba096a0c3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c9baed8c220971f77a54d1cf4864f9e3d62ec28eb3f145db77d53ce08a46ef25)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__08f9b3d110a1c8d2a1474ee5a4aa84bdaf3dbe0fccbde05484f572381954c23d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d8b924aed1d95d5a3d9e51fc3b64c04f3b59f9709ce5ce39f91422adae1f770c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ecce1bf4f63e2e5a9d7c00dc46811b0435bf5bb996d22c547727c48d9f57aaa2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultComposite]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultComposite]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultComposite]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__11b024b1f15c792b9dfe89f2eafcc67b426e24f17cbe49f79a761ae8ee655eb1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultCompound",
    jsii_struct_bases=[],
    name_mapping={"transformations": "transformations"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultCompound:
    def __init__(
        self,
        *,
        transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param transformations: transformations block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__529696ae5fac9d0df253cd27a9cca3f0b9cc5dad60ac80635bc767b3d4fd5d8d)
            check_type(argname="argument transformations", value=transformations, expected_type=type_hints["transformations"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if transformations is not None:
            self._values["transformations"] = transformations

    @builtins.property
    def transformations(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultCompoundTransformations"]]]:
        '''transformations block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        result = self._values.get("transformations")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultCompoundTransformations"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultCompound(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultCompoundList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultCompoundList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4dd0d2e5567ce326017b5f980278185f849014a6d69599c2607cc251949640ad)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultCompoundOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ec5192255011e3d235bb98c9193cfec9972ccf4b93f2e968b1f279d3d884746)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultCompoundOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5da09188803f582f0a0548fefe687f47ac249d49453d71ea6e112973622825e9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__59775787804b06a67e40d5229c6c8dd084b0c84dfb7ff6f33c85bd92d67b0554)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5a3ae89b3ed05fdde3c33887d1926d85930d3895bdd391dc0239000df0d1856f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultCompound]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultCompound]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7af820c2457a93ac1480ff47c95b173612e5019e3c64f1c4c80ff2877e170ebf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultCompoundOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultCompoundOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cacafb5b1574b012b43159ef868ecb1de6c6821f5d2052d3478f36fbd537fe8c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformations")
    def put_transformations(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5b9963c2984f62ae3edaf4301ddd473fea44f658544f5a96d66470d5992b036e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTransformations", [value]))

    @jsii.member(jsii_name="resetTransformations")
    def reset_transformations(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformations", []))

    @builtins.property
    @jsii.member(jsii_name="transformations")
    def transformations(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultCompoundTransformationsList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultCompoundTransformationsList", jsii.get(self, "transformations"))

    @builtins.property
    @jsii.member(jsii_name="transformationsInput")
    def transformations_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultCompoundTransformations"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultCompoundTransformations"]]], jsii.get(self, "transformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultCompound]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultCompound]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultCompound]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cc4a39b23d3d3adec78ea99163056ff2ec2b431f27106d96b0ed304874724207)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultCompoundTransformations",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultCompoundTransformations:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultCompoundTransformations(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultCompoundTransformationsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultCompoundTransformationsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f71b916b8f73c1b36d1d9ade84b9f8451e4b8b14115af1a88aac25274cc12227)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultCompoundTransformationsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__113768365781bf640576dd79b7c944d02fac27daa87d17bd3286f753d43c6408)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultCompoundTransformationsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e0f98ff654a4af2da90060001f61fcf5730b63bc9c3c52013f892d485a48c97)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3dd7ceda790ee82b2573da14797ef4ff8ebc6b8533b1934781c4cb99a41d95c5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__21c4169cccda09d8dd12c5f77ac3c4241451eba3663237b9c5d4b2738b19021a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultCompoundTransformations]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultCompoundTransformations]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultCompoundTransformations]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ed413fa74988c130d76d8fc380701a9a2e4ef293952ac76164ee9db4124a3c7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultCompoundTransformationsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultCompoundTransformationsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a2c5db0bc175868415fcd524b86b37ca8d4e375285de8da09cef24b3df90f06e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultCompoundTransformations]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultCompoundTransformations]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultCompoundTransformations]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4cd5d393ba8f7d56a5a81f2507a594dc857e9535230afc95799b289d07e62459)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultContrast",
    jsii_struct_bases=[],
    name_mapping={
        "brightness": "brightness",
        "brightness_var": "brightnessVar",
        "contrast": "contrast",
        "contrast_var": "contrastVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultContrast:
    def __init__(
        self,
        *,
        brightness: typing.Optional[builtins.str] = None,
        brightness_var: typing.Optional[builtins.str] = None,
        contrast: typing.Optional[builtins.str] = None,
        contrast_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param brightness: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        :param brightness_var: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        :param contrast: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param contrast_var: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__892fe013e89efd4f5f6583c904f78d9aea4e3b82ffcbf723dc6351a536fc1eb0)
            check_type(argname="argument brightness", value=brightness, expected_type=type_hints["brightness"])
            check_type(argname="argument brightness_var", value=brightness_var, expected_type=type_hints["brightness_var"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument contrast_var", value=contrast_var, expected_type=type_hints["contrast_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if brightness is not None:
            self._values["brightness"] = brightness
        if brightness_var is not None:
            self._values["brightness_var"] = brightness_var
        if contrast is not None:
            self._values["contrast"] = contrast
        if contrast_var is not None:
            self._values["contrast_var"] = contrast_var

    @builtins.property
    def brightness(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        '''
        result = self._values.get("brightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def brightness_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        '''
        result = self._values.get("brightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        result = self._values.get("contrast_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultContrast(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultContrastList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultContrastList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__090d310d473cbba9cddc91c9556cc3f9968127865970ece2ba38b8f502b98849)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultContrastOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__32876eca495c273136d9a5be1cdf3f6741776297c07085681f5815f90187e088)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultContrastOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a9a9d82504efebc09f05c654391ded7e98f9e8aaeceaebe2e658c92fc43b38a3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a58295d3b8d8670da8939339f3ca685e4043324955fa0ff2f64221c17bb5933)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__393690427cf3ffdef4ff247bc1738308e2940505e7ed12963b049809cd76ebb3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultContrast]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultContrast]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__494db0e86471c7058d3ef4fe4fb318e20182beceb0f1382e32a03107f6b4769c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultContrastOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultContrastOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fbce997068a032b327942508c8b734a41665c55b20d4d47eb6de5b7cd8f9ddfd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetBrightness")
    def reset_brightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightness", []))

    @jsii.member(jsii_name="resetBrightnessVar")
    def reset_brightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightnessVar", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetContrastVar")
    def reset_contrast_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrastVar", []))

    @builtins.property
    @jsii.member(jsii_name="brightnessInput")
    def brightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="brightnessVarInput")
    def brightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastVarInput")
    def contrast_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="brightness")
    def brightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightness"))

    @brightness.setter
    def brightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a9a3af4dd6a3a4fdc0d694a3235e6e14b4948e572199ee0ba307cbd4e01a3b73)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightness", value)

    @builtins.property
    @jsii.member(jsii_name="brightnessVar")
    def brightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightnessVar"))

    @brightness_var.setter
    def brightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d32c0b181680705915efc6dd78fdcc1e50e19b1c98a5d6284e98e0844b5ffdc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrast"))

    @contrast.setter
    def contrast(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ce8f378b80ee0e72dbf5b1b85c0edfb63271f151298e488f9e2690993798c24)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrast", value)

    @builtins.property
    @jsii.member(jsii_name="contrastVar")
    def contrast_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrastVar"))

    @contrast_var.setter
    def contrast_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a0b7989132a51ee23956619472abfc85665a3c4c347f84cb2e74c4ba30aeeef6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrastVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultContrast]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultContrast]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultContrast]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f920baefc132d45e9d6a85e4a7a4f0f887f1d8b2f791a16d2b1766f1f89cb2e4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultGoop",
    jsii_struct_bases=[],
    name_mapping={
        "chaos": "chaos",
        "chaos_var": "chaosVar",
        "density": "density",
        "density_var": "densityVar",
        "power": "power",
        "power_var": "powerVar",
        "seed": "seed",
        "seed_var": "seedVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultGoop:
    def __init__(
        self,
        *,
        chaos: typing.Optional[builtins.str] = None,
        chaos_var: typing.Optional[builtins.str] = None,
        density: typing.Optional[builtins.str] = None,
        density_var: typing.Optional[builtins.str] = None,
        power: typing.Optional[builtins.str] = None,
        power_var: typing.Optional[builtins.str] = None,
        seed: typing.Optional[builtins.str] = None,
        seed_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param chaos: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        :param chaos_var: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        :param density: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        :param density_var: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        :param power: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        :param power_var: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        :param seed: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        :param seed_var: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__529afffe01434f48516c722b608c17207f416118b38bcec13ab055555399d2d4)
            check_type(argname="argument chaos", value=chaos, expected_type=type_hints["chaos"])
            check_type(argname="argument chaos_var", value=chaos_var, expected_type=type_hints["chaos_var"])
            check_type(argname="argument density", value=density, expected_type=type_hints["density"])
            check_type(argname="argument density_var", value=density_var, expected_type=type_hints["density_var"])
            check_type(argname="argument power", value=power, expected_type=type_hints["power"])
            check_type(argname="argument power_var", value=power_var, expected_type=type_hints["power_var"])
            check_type(argname="argument seed", value=seed, expected_type=type_hints["seed"])
            check_type(argname="argument seed_var", value=seed_var, expected_type=type_hints["seed_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if chaos is not None:
            self._values["chaos"] = chaos
        if chaos_var is not None:
            self._values["chaos_var"] = chaos_var
        if density is not None:
            self._values["density"] = density
        if density_var is not None:
            self._values["density_var"] = density_var
        if power is not None:
            self._values["power"] = power
        if power_var is not None:
            self._values["power_var"] = power_var
        if seed is not None:
            self._values["seed"] = seed
        if seed_var is not None:
            self._values["seed_var"] = seed_var

    @builtins.property
    def chaos(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        '''
        result = self._values.get("chaos")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def chaos_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        '''
        result = self._values.get("chaos_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        '''
        result = self._values.get("density")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density_var(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        '''
        result = self._values.get("density_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        '''
        result = self._values.get("power")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power_var(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        '''
        result = self._values.get("power_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        '''
        result = self._values.get("seed")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed_var(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        result = self._values.get("seed_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultGoop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultGoopList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultGoopList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__03a0437b03ca7f9551f13e254897fa771806722b44f68faf0a54eaf6d7468462)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultGoopOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d8c14bc557fd50379096b125ec9d616603f1f09f36059ae5b89b217061fe4dc6)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultGoopOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ed6bec4c2d9610d490dd77602ff1286970d773fcbdd8796520582007705002c8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__322d7470d243794b17943855ce2e288641a53baf54ae04007bdb35fbe0292751)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0cd17a6124962fec8bac63935a371d4c1dc4c50f06e7d7fd19ed9769301ed7ac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultGoop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultGoop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ada3406216f9bd62e8e7041f73c6b7e32eda17a779497e07732488cb2b7597c2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultGoopOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultGoopOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0a8df505c4e4c420a4786bd085482d03a7ebed7f94fc119510b17b706abb2e62)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetChaos")
    def reset_chaos(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaos", []))

    @jsii.member(jsii_name="resetChaosVar")
    def reset_chaos_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaosVar", []))

    @jsii.member(jsii_name="resetDensity")
    def reset_density(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensity", []))

    @jsii.member(jsii_name="resetDensityVar")
    def reset_density_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensityVar", []))

    @jsii.member(jsii_name="resetPower")
    def reset_power(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPower", []))

    @jsii.member(jsii_name="resetPowerVar")
    def reset_power_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPowerVar", []))

    @jsii.member(jsii_name="resetSeed")
    def reset_seed(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeed", []))

    @jsii.member(jsii_name="resetSeedVar")
    def reset_seed_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeedVar", []))

    @builtins.property
    @jsii.member(jsii_name="chaosInput")
    def chaos_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosInput"))

    @builtins.property
    @jsii.member(jsii_name="chaosVarInput")
    def chaos_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosVarInput"))

    @builtins.property
    @jsii.member(jsii_name="densityInput")
    def density_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityInput"))

    @builtins.property
    @jsii.member(jsii_name="densityVarInput")
    def density_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="powerInput")
    def power_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerInput"))

    @builtins.property
    @jsii.member(jsii_name="powerVarInput")
    def power_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerVarInput"))

    @builtins.property
    @jsii.member(jsii_name="seedInput")
    def seed_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedInput"))

    @builtins.property
    @jsii.member(jsii_name="seedVarInput")
    def seed_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedVarInput"))

    @builtins.property
    @jsii.member(jsii_name="chaos")
    def chaos(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaos"))

    @chaos.setter
    def chaos(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d90cdd8704ab891b16322f3e0015d10a4d11c16d21aa0e23f5f12950c984791)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaos", value)

    @builtins.property
    @jsii.member(jsii_name="chaosVar")
    def chaos_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaosVar"))

    @chaos_var.setter
    def chaos_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ddda0cea30e76b1f020e58bbcf45c68b984b2023dc96d65d1861eb2f8a674cec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaosVar", value)

    @builtins.property
    @jsii.member(jsii_name="density")
    def density(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "density"))

    @density.setter
    def density(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__98b79df36533b00b1a7d3872c792eb7cd89e014b75e07b4ec7946ebfb39268c6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "density", value)

    @builtins.property
    @jsii.member(jsii_name="densityVar")
    def density_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "densityVar"))

    @density_var.setter
    def density_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c65783653c75d7341f395d58c13b463880f7ae6a3d04bc2eaa827b28798394ae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "densityVar", value)

    @builtins.property
    @jsii.member(jsii_name="power")
    def power(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "power"))

    @power.setter
    def power(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2618cd0c8ad396ff7c84575f4759497f4666cac320d7f90f50905b58a7e00e28)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "power", value)

    @builtins.property
    @jsii.member(jsii_name="powerVar")
    def power_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "powerVar"))

    @power_var.setter
    def power_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b9a39cad98904157dbfa96a7076145582c7d39d5d55748e83ed9702879e0784c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "powerVar", value)

    @builtins.property
    @jsii.member(jsii_name="seed")
    def seed(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seed"))

    @seed.setter
    def seed(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b150a27a95227d7e307c20be13e62baf305c9d4d889c9ccb7d307e2c8cde45b1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seed", value)

    @builtins.property
    @jsii.member(jsii_name="seedVar")
    def seed_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seedVar"))

    @seed_var.setter
    def seed_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7563c3cb878316a53db9a8fa8eb4ad79f266e7dd2f9c37cf54bf3051a206b51b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seedVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultGoop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultGoop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultGoop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ead6881f643aba59c01a0ede89a890078e90e946a890892ac2eb208ee00d4b81)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultGrayscale",
    jsii_struct_bases=[],
    name_mapping={"type": "type", "type_var": "typeVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultGrayscale:
    def __init__(
        self,
        *,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param type: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d377288648aff375a66960c978e8e0137c8c2aa6ef75a687fbbd2e7833c9bd76)
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultGrayscale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultGrayscaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultGrayscaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__380547667f8ef03434b64bdc5e6cf2b062d26977bc77351d39e8286df51a0bf3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultGrayscaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a0370e77cf19786d73ae0f617c9361f74ffc85a7e4d8127cc4757241b945c2a1)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultGrayscaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bdc188252d404f49090759bf3e813ef27fd9fde60508fa3632844808fd9511e0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cbbc68fdac3aeffee65878f482c7509405e8d8cc3fe499806bff88124f6bb640)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c212eea415d1cb18943c59fc9114941efb0ef668824a5ca72df679bc77878b07)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultGrayscale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultGrayscale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1e87dae6686ab4e87a07c993dd51a8b3fa13e90b527e145d30488d30b5888e4f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultGrayscaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultGrayscaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__64511169ec308eed9bcc057634ad4db65e02bf36026ac540d191e3c00a568a3d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__72e2c67268af5e9c69b44d8277c21f208dfa003ae73e9316475c9063d653c273)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5855038a0d2510725253f81c0343f8a907232fda518584c7edf0c9c8dc009fce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultGrayscale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultGrayscale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultGrayscale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c50012bdb4094c3326ac6372c2c7efbff67dfed9e1ed081e337ac656aa1d48b8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultHsl",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "lightness": "lightness",
        "lightness_var": "lightnessVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultHsl:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness: typing.Optional[builtins.str] = None,
        lightness_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        :param lightness_var: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3f6bc199e544ea444dd4207746225796625a05093384c91b8c732bad949e5dbb)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness", value=lightness, expected_type=type_hints["lightness"])
            check_type(argname="argument lightness_var", value=lightness_var, expected_type=type_hints["lightness_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness is not None:
            self._values["lightness"] = lightness
        if lightness_var is not None:
            self._values["lightness_var"] = lightness_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        '''
        result = self._values.get("lightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        '''
        result = self._values.get("lightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultHsl(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultHslList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultHslList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1d17b7c7868a5cf7987851639b8f296cefef241bcc5519ffd2604ceb995fb0b2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultHslOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2de3aba25fb06601dc914011e9015303dd0368bfcd73de94be6c5b391b4cac42)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultHslOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a5aff2a090d46b20bae975161c3165370cfb90e8e0dc50827cc7247e29469118)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a1d0c040332653a300e59d3cfdd16059d12324ad49e9a445700890625eb4bfa3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3bbdbce28f409e6f8a3aaa3ce64925d3bd7cd9fe4776ce7e324f4bf813c43ac1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultHsl]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultHsl]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6b6e4c52d9199dd15a2496fd7193bc0575b170add3be3517128db6c4f9cb4f54)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultHslOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultHslOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__032ae0864f758ad7e35ca6a14d35486002e7c8e1af42345731b19e56f4fab43d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightness")
    def reset_lightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightness", []))

    @jsii.member(jsii_name="resetLightnessVar")
    def reset_lightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessInput")
    def lightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessVarInput")
    def lightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ff44b7562e1d978be09ae0a56b6fdd3a59d002dc5c5aeea50537c2d0256cd907)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d0b4343d63032c6fe8de1ea020ae013c9abf18ee75d39c67812e4e71ad922c29)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightness")
    def lightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightness"))

    @lightness.setter
    def lightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__78db65057e8a41425d93c479a308e6a7ce6b923bb6ac87f1d4462f200980b71d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightness", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessVar")
    def lightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessVar"))

    @lightness_var.setter
    def lightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3e462a583ce198c6feea681dee1f3c5157b8750c2841c6c7a1199a1e720e8f54)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__51480f99aa279670b5c53d1f06749574cb77d1ac3c443dcdbdb7fe5da3415d6d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0da030a234a8e042645d4a05dc73009cc34f18d5ea14545979181c2ebb3f62cb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultHsl]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultHsl]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultHsl]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__414ef4574b2a0cba2b783a2db5346e37d46c643b36f8f70bd7c8e2a0a244d43c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultHsv",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultHsv:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        :param value: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__234fae9561339bbffdbbfe8d4eae749b79b916d23f573bbe988260087a17b934)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultHsv(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultHsvList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultHsvList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f27c7d514ac7a7dbdd09cae5886586492f121f14517214a875e4c29b10b9ae51)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultHsvOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__46c41abc955086cb35ffc74d35bb01e3921fa7a14a38fcd29147d5b96828e838)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultHsvOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__414a442cbfa38f3d1696ba0ff3cce2e843f0d15aa50bd6f76dfed69e3c549980)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7c38033f76fb9aafcb0b3e9feaf696e442331158e8c353bee81027bde49bb2df)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__25def13ef3ca884056252cd17b6251c22e6de9c9c89fd4870a0164e3d48a636e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultHsv]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultHsv]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__64acb4adfd98f7da07aef5b0ed3a4d3d2349d6c88a2b950e8ec02ee20e8b56c8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultHsvOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultHsvOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a18e2fd597b6c4b51ae6d1266deb8fc3647f46128762bbd0e11942efcfa9c48)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__96f3381b31716f796639679905f07a9d9a10b9835150f16bbcbdb8275ba74213)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b75954d360592be25304bf90a2df57d48e88698214e6f167481cdf60530fbcb6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eb823d4e71b371ded6bd0afe7f93785d93695c08faafbccffabe49391002360e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__944d88804190edc981cfc3b581903b4ac174395c724855154905c68c8a69cc64)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0440814fa93e55ae9f2ddf4c7713fc03a2206d36530c1bd2d9d9d32e0f97f18c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4f663cade92a564ae304b74a596c79d66da8c56a641c0b183ca5ed3ca60e79ba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultHsv]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultHsv]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultHsv]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__78492eb7d30bb9820774a698c1f012dc859fe8c02614906e4796b5c46c10ed65)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfDimension",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "dimension": "dimension",
        "dimension_var": "dimensionVar",
        "equal": "equal",
        "greater_than": "greaterThan",
        "less_than": "lessThan",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfDimension:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfDimensionDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        dimension: typing.Optional[builtins.str] = None,
        dimension_var: typing.Optional[builtins.str] = None,
        equal: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfDimensionEqual", typing.Dict[builtins.str, typing.Any]]] = None,
        greater_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfDimensionGreaterThan", typing.Dict[builtins.str, typing.Any]]] = None,
        less_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfDimensionLessThan", typing.Dict[builtins.str, typing.Any]]] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param dimension: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        :param dimension_var: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        :param equal: equal block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        :param greater_than: greater_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        :param less_than: less_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        :param value: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfDimensionDefault(**default)
        if isinstance(equal, dict):
            equal = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfDimensionEqual(**equal)
        if isinstance(greater_than, dict):
            greater_than = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfDimensionGreaterThan(**greater_than)
        if isinstance(less_than, dict):
            less_than = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfDimensionLessThan(**less_than)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ec6fafd8260e8cfdec92f32a15f1cf29066e70168f04a13087d097b4e33abb3b)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument dimension", value=dimension, expected_type=type_hints["dimension"])
            check_type(argname="argument dimension_var", value=dimension_var, expected_type=type_hints["dimension_var"])
            check_type(argname="argument equal", value=equal, expected_type=type_hints["equal"])
            check_type(argname="argument greater_than", value=greater_than, expected_type=type_hints["greater_than"])
            check_type(argname="argument less_than", value=less_than, expected_type=type_hints["less_than"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if dimension is not None:
            self._values["dimension"] = dimension
        if dimension_var is not None:
            self._values["dimension_var"] = dimension_var
        if equal is not None:
            self._values["equal"] = equal
        if greater_than is not None:
            self._values["greater_than"] = greater_than
        if less_than is not None:
            self._values["less_than"] = less_than
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfDimensionDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfDimensionDefault"], result)

    @builtins.property
    def dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        '''
        result = self._values.get("dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        '''
        result = self._values.get("dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def equal(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfDimensionEqual"]:
        '''equal block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        '''
        result = self._values.get("equal")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfDimensionEqual"], result)

    @builtins.property
    def greater_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfDimensionGreaterThan"]:
        '''greater_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        '''
        result = self._values.get("greater_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfDimensionGreaterThan"], result)

    @builtins.property
    def less_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfDimensionLessThan"]:
        '''less_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        '''
        result = self._values.get("less_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfDimensionLessThan"], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfDimension(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfDimensionDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfDimensionDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfDimensionDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfDimensionDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfDimensionDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f64d185a23119e6a38e44a26305be4ae030314942c2f43392154c6ebc1cea96b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfDimensionDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfDimensionDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__96254eefa6282f558534fea6e045cb8900597a67c44fffa5edd2de9bb56fd198)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfDimensionEqual",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfDimensionEqual:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfDimensionEqual(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfDimensionEqualOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfDimensionEqualOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4e5b0059482f3c2c1dde1d7aca14619920061bdbb06d5fb92b7ef13a46fcfa46)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfDimensionEqual], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfDimensionEqual],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cf76269a193c03c4c90088722e311f99c53a8c8b5381586569374d562001c63f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfDimensionGreaterThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfDimensionGreaterThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfDimensionGreaterThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfDimensionGreaterThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfDimensionGreaterThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__70e2ee689f94f3d36cf943f2721531d200e752b1e11a3b2509ded864ff795d24)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfDimensionGreaterThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfDimensionGreaterThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b209b6e373ca86d8baa3cb8160c094f92b2568d9919b781507262ad3cd1725dc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfDimensionLessThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfDimensionLessThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfDimensionLessThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfDimensionLessThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfDimensionLessThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f1360716f0f87c92cc3df55542d46413c119e5b7d1ec75548839ebaccc86f94)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfDimensionLessThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfDimensionLessThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c1ad0953f35179e985996c11e9791dbbbcf4da0386989d8ae99a3f0c33724287)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfDimensionList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfDimensionList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2f2c12fc0ca82630c21a6658769dde5be93c063fb322d8826a707abfe79275b2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfDimensionOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7e6e05139047ba078b304b31a6753feeaa806e1956613411b22d990a09fd59ae)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfDimensionOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c36b551774485e4a26cabbe835505663ce63df32f52fa85d566595fa42dbbd10)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dc47b1195ffac9fdd5322911deae1810a78c71554132862cce0e8e6401cbea98)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c3fdf2a5d4d4925e79ab38d0f99d60c43e42fab510c98047504a1f7d8b1d177b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfDimension]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfDimension]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b58aca1d97c83724e092ecd80715b11e14d6a5d321d7c603d3630e1b8b2d2e77)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfDimensionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfDimensionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__64a9c9985040d46b6c8331092deea8b8d7a0f0c3075147f72d6393b14257b865)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfDimensionDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putEqual")
    def put_equal(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfDimensionEqual()

        return typing.cast(None, jsii.invoke(self, "putEqual", [value]))

    @jsii.member(jsii_name="putGreaterThan")
    def put_greater_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfDimensionGreaterThan()

        return typing.cast(None, jsii.invoke(self, "putGreaterThan", [value]))

    @jsii.member(jsii_name="putLessThan")
    def put_less_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfDimensionLessThan()

        return typing.cast(None, jsii.invoke(self, "putLessThan", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetDimension")
    def reset_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimension", []))

    @jsii.member(jsii_name="resetDimensionVar")
    def reset_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimensionVar", []))

    @jsii.member(jsii_name="resetEqual")
    def reset_equal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEqual", []))

    @jsii.member(jsii_name="resetGreaterThan")
    def reset_greater_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGreaterThan", []))

    @jsii.member(jsii_name="resetLessThan")
    def reset_less_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLessThan", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfDimensionDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfDimensionDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="equal")
    def equal(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfDimensionEqualOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfDimensionEqualOutputReference, jsii.get(self, "equal"))

    @builtins.property
    @jsii.member(jsii_name="greaterThan")
    def greater_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfDimensionGreaterThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfDimensionGreaterThanOutputReference, jsii.get(self, "greaterThan"))

    @builtins.property
    @jsii.member(jsii_name="lessThan")
    def less_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfDimensionLessThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfDimensionLessThanOutputReference, jsii.get(self, "lessThan"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfDimensionDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionInput")
    def dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionVarInput")
    def dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="equalInput")
    def equal_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfDimensionEqual], jsii.get(self, "equalInput"))

    @builtins.property
    @jsii.member(jsii_name="greaterThanInput")
    def greater_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfDimensionGreaterThan], jsii.get(self, "greaterThanInput"))

    @builtins.property
    @jsii.member(jsii_name="lessThanInput")
    def less_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfDimensionLessThan], jsii.get(self, "lessThanInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="dimension")
    def dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimension"))

    @dimension.setter
    def dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f89fb86a88a4bd87daadb004e0d139dbf317e71788a87ad6a062cd1939f51cea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimension", value)

    @builtins.property
    @jsii.member(jsii_name="dimensionVar")
    def dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimensionVar"))

    @dimension_var.setter
    def dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e9073ef153faba0343f14cb9c68aa3298af5d87c0ef23ddda056ba16a4541119)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eb127efa7705535501056304b7b2cd757d9b62ffd88252ff5a5d425594bf0897)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b7cac673a2873372a53105fe7734f920c91d677e28f874fd4b9508cf9c1d38a3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfDimension]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfDimension]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfDimension]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bbb57bf03c58081568848f631fd88783869c4e70a97ac20d38597ccdd6380488)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfOrientation",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "landscape": "landscape",
        "portrait": "portrait",
        "square": "square",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfOrientation:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfOrientationDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        landscape: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfOrientationLandscape", typing.Dict[builtins.str, typing.Any]]] = None,
        portrait: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfOrientationPortrait", typing.Dict[builtins.str, typing.Any]]] = None,
        square: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfOrientationSquare", typing.Dict[builtins.str, typing.Any]]] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param landscape: landscape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        :param portrait: portrait block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        :param square: square block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfOrientationDefault(**default)
        if isinstance(landscape, dict):
            landscape = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfOrientationLandscape(**landscape)
        if isinstance(portrait, dict):
            portrait = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfOrientationPortrait(**portrait)
        if isinstance(square, dict):
            square = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfOrientationSquare(**square)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c11a86e97615958865befb0e179a29405707c5ad34c3aecfb91883df8862f2d3)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument landscape", value=landscape, expected_type=type_hints["landscape"])
            check_type(argname="argument portrait", value=portrait, expected_type=type_hints["portrait"])
            check_type(argname="argument square", value=square, expected_type=type_hints["square"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if landscape is not None:
            self._values["landscape"] = landscape
        if portrait is not None:
            self._values["portrait"] = portrait
        if square is not None:
            self._values["square"] = square

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfOrientationDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfOrientationDefault"], result)

    @builtins.property
    def landscape(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfOrientationLandscape"]:
        '''landscape block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        '''
        result = self._values.get("landscape")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfOrientationLandscape"], result)

    @builtins.property
    def portrait(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfOrientationPortrait"]:
        '''portrait block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        '''
        result = self._values.get("portrait")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfOrientationPortrait"], result)

    @builtins.property
    def square(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfOrientationSquare"]:
        '''square block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        result = self._values.get("square")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfOrientationSquare"], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfOrientation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfOrientationDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfOrientationDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfOrientationDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfOrientationDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfOrientationDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc381d5a7f3ffb69237c61edb20c0fb6cdefaf8bb4eeae25c664214a4962245d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfOrientationDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfOrientationDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a4a0cfc171797e92b84ce4d2f91ff044e9b4f21728bac3e3da4fdbbcf26c457c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfOrientationLandscape",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfOrientationLandscape:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfOrientationLandscape(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfOrientationLandscapeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfOrientationLandscapeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac88d7703b1c805394265847e79e49563db36bd043d2bc0a861164b13c86d29a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfOrientationLandscape], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfOrientationLandscape],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4992d64467f26d626cbd23467b041bc3f1bdb915dfd2ffdeb986cf90bec770f6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfOrientationList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfOrientationList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__71242f33bb69fc804eefa8a5acbc834efbfb51fe279a556c1b77b5812374236e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfOrientationOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__56be4e9f3712dcbee7312c7afbd762854fe6131aba0a0027e696a564610705d9)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfOrientationOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__217b114ec580c0fa52f90428a51c4e7cbcb57b140ee9a8b74f38c648ef77a9a9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__214c68f045a7f3951f279fe0b937b50f6cfc392019b44a93d75e8cff63dce5b9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a5cc17fc91a5d3dc1db19bbb0a6b7bf23891548942be47b96d89c1c117fd5fc3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfOrientation]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfOrientation]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7b2d7253ed7aec3ce54ee8cf02b4397e5381e5f3673717fc12bd404135dc032a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfOrientationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfOrientationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__63b528764e4b5fc0795f9f856aafaf70544e96ac5d02e8a303edb02b46e5d704)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfOrientationDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putLandscape")
    def put_landscape(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfOrientationLandscape()

        return typing.cast(None, jsii.invoke(self, "putLandscape", [value]))

    @jsii.member(jsii_name="putPortrait")
    def put_portrait(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfOrientationPortrait()

        return typing.cast(None, jsii.invoke(self, "putPortrait", [value]))

    @jsii.member(jsii_name="putSquare")
    def put_square(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfOrientationSquare()

        return typing.cast(None, jsii.invoke(self, "putSquare", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetLandscape")
    def reset_landscape(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLandscape", []))

    @jsii.member(jsii_name="resetPortrait")
    def reset_portrait(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPortrait", []))

    @jsii.member(jsii_name="resetSquare")
    def reset_square(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSquare", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfOrientationDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfOrientationDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="landscape")
    def landscape(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfOrientationLandscapeOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfOrientationLandscapeOutputReference, jsii.get(self, "landscape"))

    @builtins.property
    @jsii.member(jsii_name="portrait")
    def portrait(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfOrientationPortraitOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfOrientationPortraitOutputReference", jsii.get(self, "portrait"))

    @builtins.property
    @jsii.member(jsii_name="square")
    def square(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfOrientationSquareOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfOrientationSquareOutputReference", jsii.get(self, "square"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfOrientationDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="landscapeInput")
    def landscape_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfOrientationLandscape], jsii.get(self, "landscapeInput"))

    @builtins.property
    @jsii.member(jsii_name="portraitInput")
    def portrait_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfOrientationPortrait"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfOrientationPortrait"], jsii.get(self, "portraitInput"))

    @builtins.property
    @jsii.member(jsii_name="squareInput")
    def square_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfOrientationSquare"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfOrientationSquare"], jsii.get(self, "squareInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfOrientation]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfOrientation]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfOrientation]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f4c154fbcdf84f01882802db0aab7ed26ab905140c191e084ac0f68e36b62734)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfOrientationPortrait",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfOrientationPortrait:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfOrientationPortrait(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfOrientationPortraitOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfOrientationPortraitOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ba11f8cd195bbd6da35af7ccec6f99749b4f6a150498092ee811460e2b7b5f68)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfOrientationPortrait]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfOrientationPortrait], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfOrientationPortrait],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0bba80ef6f470a319ad5438f094d780c12dfa30f2d8155bbd97b2eef75507b45)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfOrientationSquare",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfOrientationSquare:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfOrientationSquare(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfOrientationSquareOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfOrientationSquareOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__559d1d6d99c27e6c14b56ef0be79a06efe7711f007bae349f0c41b383fe1792a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfOrientationSquare]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfOrientationSquare], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfOrientationSquare],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__22882997b03412a5d21655cbbc96a9e73c16a60e6322ec553d1fab7e6057a1d6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultMaxColors",
    jsii_struct_bases=[],
    name_mapping={"colors": "colors", "colors_var": "colorsVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultMaxColors:
    def __init__(
        self,
        *,
        colors: typing.Optional[builtins.str] = None,
        colors_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param colors: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        :param colors_var: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__05f6ee7c2a1219e4e35922487385bfc748dc31b78de13950066c7f94bd480e05)
            check_type(argname="argument colors", value=colors, expected_type=type_hints["colors"])
            check_type(argname="argument colors_var", value=colors_var, expected_type=type_hints["colors_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if colors is not None:
            self._values["colors"] = colors
        if colors_var is not None:
            self._values["colors_var"] = colors_var

    @builtins.property
    def colors(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        '''
        result = self._values.get("colors")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def colors_var(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        result = self._values.get("colors_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultMaxColors(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultMaxColorsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultMaxColorsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__55251d830762992023a5cce48b3921e1737b8d3ded619d347ca42749f9a17f88)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultMaxColorsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ef2738598ebcb25e88bc7cfc4f18c540e9af641886c8cbad02207939d8b9026)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultMaxColorsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d8170aa28479574b5a72814b4dc5996ddc8a92190e3b2e8c944cab26301dd0f8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__45ee41ddce017ba27e9ceef2e6fd4f7b5808b21c0ea19658ddcd23705eca3355)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__49be627a24fa2f6aacae462dbfc3e7e1361fb1aeb6ea89e10765cc01b2632354)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultMaxColors]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultMaxColors]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__293950d0a2e014490d4837f53b61715c107501c3eb36eeeb4c6cfcdacd4bf601)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultMaxColorsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultMaxColorsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ad7b73620b2f4592ba4d45a5caeb17ae6385f9c4ecc8a52183fc5556eb2c0c31)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColors")
    def reset_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColors", []))

    @jsii.member(jsii_name="resetColorsVar")
    def reset_colors_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorsVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorsInput")
    def colors_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsInput"))

    @builtins.property
    @jsii.member(jsii_name="colorsVarInput")
    def colors_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsVarInput"))

    @builtins.property
    @jsii.member(jsii_name="colors")
    def colors(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colors"))

    @colors.setter
    def colors(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8d4d540714c65ebf263c421edd599639856e7093234e36d017f82473828788aa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colors", value)

    @builtins.property
    @jsii.member(jsii_name="colorsVar")
    def colors_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorsVar"))

    @colors_var.setter
    def colors_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9863aa556ba1535f574116948ff755eb34ce46c4a6bba02850418838056ae8c5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorsVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultMaxColors]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultMaxColors]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultMaxColors]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__67a164acb2f65f7367610207071255f88827f1553fac3ff4ecdca90242e11351)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultMirror",
    jsii_struct_bases=[],
    name_mapping={
        "horizontal": "horizontal",
        "horizontal_var": "horizontalVar",
        "vertical": "vertical",
        "vertical_var": "verticalVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultMirror:
    def __init__(
        self,
        *,
        horizontal: typing.Optional[builtins.str] = None,
        horizontal_var: typing.Optional[builtins.str] = None,
        vertical: typing.Optional[builtins.str] = None,
        vertical_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param horizontal: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        :param horizontal_var: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        :param vertical: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        :param vertical_var: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4189ffdc7cbc9aacddf724a40728f5a4eeacf9f9a89d66c90ea7c73f1717d3ce)
            check_type(argname="argument horizontal", value=horizontal, expected_type=type_hints["horizontal"])
            check_type(argname="argument horizontal_var", value=horizontal_var, expected_type=type_hints["horizontal_var"])
            check_type(argname="argument vertical", value=vertical, expected_type=type_hints["vertical"])
            check_type(argname="argument vertical_var", value=vertical_var, expected_type=type_hints["vertical_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if horizontal is not None:
            self._values["horizontal"] = horizontal
        if horizontal_var is not None:
            self._values["horizontal_var"] = horizontal_var
        if vertical is not None:
            self._values["vertical"] = vertical
        if vertical_var is not None:
            self._values["vertical_var"] = vertical_var

    @builtins.property
    def horizontal(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        '''
        result = self._values.get("horizontal")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def horizontal_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        '''
        result = self._values.get("horizontal_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        '''
        result = self._values.get("vertical")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        result = self._values.get("vertical_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultMirror(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultMirrorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultMirrorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8c64739fac9b0a67166e2297875f0f48308cd0c429b87a240ac50b60f4529504)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultMirrorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4b3fa0935aac00ec374867e65d79f5d96a3ab73c5a7246bf43f5d6f6d1bc2b7c)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultMirrorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__24ebcd69f4ff24fafde3a3b0ad00e557ae92f6285c6bb66f87875570b6a87ee0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__816736c7a89db9b7c2f38667f9d3984c3ac593e10e3c83c91beed7c6c3e26022)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a5376969aca685820cfa0ac73501a5be61a2608a2d213fdba0674a45451c50d7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultMirror]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultMirror]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e3482cd5c99ccbab493f00ed86ea373f382ee7068c68cc99b6ede68a1d8dce8f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultMirrorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultMirrorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8753731b577fc372a7acb23dc2a0081ac62be0dbb885d7a955dd3e734d1529cf)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHorizontal")
    def reset_horizontal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontal", []))

    @jsii.member(jsii_name="resetHorizontalVar")
    def reset_horizontal_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontalVar", []))

    @jsii.member(jsii_name="resetVertical")
    def reset_vertical(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVertical", []))

    @jsii.member(jsii_name="resetVerticalVar")
    def reset_vertical_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVerticalVar", []))

    @builtins.property
    @jsii.member(jsii_name="horizontalInput")
    def horizontal_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontalVarInput")
    def horizontal_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalInput")
    def vertical_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalVarInput")
    def vertical_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontal")
    def horizontal(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontal"))

    @horizontal.setter
    def horizontal(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__74387a46b180e81ed2288039d020d3c0e184c0d8ae9e7d59fe7b05640e3ba730)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontal", value)

    @builtins.property
    @jsii.member(jsii_name="horizontalVar")
    def horizontal_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontalVar"))

    @horizontal_var.setter
    def horizontal_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__83b6c7b9ff583c6abdb854f8553c33b3a272484bab066c4d41efef8e006fb8ec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontalVar", value)

    @builtins.property
    @jsii.member(jsii_name="vertical")
    def vertical(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "vertical"))

    @vertical.setter
    def vertical(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ad6042c85b5254ecd36110f5045ab0a121981cfc332cd64bfdee2f450d4cc6b7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "vertical", value)

    @builtins.property
    @jsii.member(jsii_name="verticalVar")
    def vertical_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "verticalVar"))

    @vertical_var.setter
    def vertical_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f3b7e46cbe47d5103c399e3c934de8f859769cae81b2bc8290b427d8e6e1e7e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "verticalVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultMirror]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultMirror]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultMirror]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3c8b79d70de76c312a248c006b1b56ad5e8659309e09fdeee45a92b489506768)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultMonoHue",
    jsii_struct_bases=[],
    name_mapping={"hue": "hue", "hue_var": "hueVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultMonoHue:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__773a93a6974c2e936cc07778c3d52e7a178c80e83c5ba7ac000dbdf34d19bc59)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultMonoHue(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultMonoHueList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultMonoHueList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f6084148b6dd64e19ad9e19ab26fe27ccadf49ab99bb248731157b6798638a07)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultMonoHueOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__add854a5426a9bbc196b7a3923b1f021c336e69eeb71704c8d1b06a66b21586f)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultMonoHueOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b7ccf756b1162068ae2db7711fcf827668a4881f7c5b7f55592d81722ea679e3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fb53db76fec603ca3ad6471ee93e40331a4266666a0040da6df6d877b629f5e4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__15030594b8ebe8d21f8d6d37797e802ab462280e541cb4c8efa8511a269cc260)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultMonoHue]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultMonoHue]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__85352c220550371816099120907b73352cd2d162ea9a4958103d5bd943a6a357)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultMonoHueOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultMonoHueOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__24b93d505b4f52e3f862234fad0a8ec7df205ad99129bc99d212029fe9b34551)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0008ba331d75197029206e2b30d7d9e238c70af76b3cdb46fb5daaee5d93bca1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__71017437cfa13f44056969a25f8cbca9fa02c6de9f74cfc437a4b3c23728008e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultMonoHue]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultMonoHue]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultMonoHue]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f884bb5c2fe5f500e78c8e22540fe01c55c0d063f5f84c516eb5c0d5825e1e2a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultOpacity",
    jsii_struct_bases=[],
    name_mapping={"opacity": "opacity", "opacity_var": "opacityVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultOpacity:
    def __init__(
        self,
        *,
        opacity: typing.Optional[builtins.str] = None,
        opacity_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param opacity: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param opacity_var: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__71db3ea10ac42e58378d347f590733fca63e8d46a2e64ea5350478c2b7106933)
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument opacity_var", value=opacity_var, expected_type=type_hints["opacity_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if opacity is not None:
            self._values["opacity"] = opacity
        if opacity_var is not None:
            self._values["opacity_var"] = opacity_var

    @builtins.property
    def opacity(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def opacity_var(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        result = self._values.get("opacity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultOpacity(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultOpacityList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultOpacityList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__94cb53e2e093c639c9b51fc9202b35750491e9a8c9758df5eaea246325893758)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultOpacityOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__71a6a6384fab8df02c3b8ce238c2b42fb53921857c8dce651ee5912e6ab99123)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultOpacityOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8682afa7f66816a7b6870774f8c28e2aac83f2aaa28663556a7d84cce54fd41d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a951d282a076935940942d9f5134ae20d23d4c2e879b7a69e963cb9959be408)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__55d837e8b9db4a4cc2e47dc2794561bfa879b0483374f56451a5721a598bd752)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultOpacity]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultOpacity]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d1d73e5d88e587bc6c6731bcd803b001824af7dd2affe4d61f9c46afff5569e6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultOpacityOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultOpacityOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__649e4f74ef3e9318586c0da2865366dceca29b9fbe76c582f76a063655f4f63d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetOpacityVar")
    def reset_opacity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacityVar", []))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityVarInput")
    def opacity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacity"))

    @opacity.setter
    def opacity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f36ee493d6f7b3b75b511ba38d501ef340b82f3a9b4046087d25219e194ee114)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacity", value)

    @builtins.property
    @jsii.member(jsii_name="opacityVar")
    def opacity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacityVar"))

    @opacity_var.setter
    def opacity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a38c7f2882789e4a5c53f86ba82942fc8dd0a8d29bbc8c031a769771eb59c593)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacityVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultOpacity]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultOpacity]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultOpacity]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__12c669a9da54955f26d6376ea1677d6c3098e3cca0111f564d3c1b57d7abe7a1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__220b283e84c4fa5371d049bb0129886c22af649663ba5f14165a2d6ef027be36)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putBackgroundColor")
    def put_background_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1242a4f1c29b6c539b0c0be1fbe93081223815adad974ce9f6680ffa999cad4b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBackgroundColor", [value]))

    @jsii.member(jsii_name="putBlur")
    def put_blur(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultBlur, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0f3c4eaeeef48efa96adab817d3ca67946a8c8d84dccf01d144a3ab4d35406f8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBlur", [value]))

    @jsii.member(jsii_name="putChromaKey")
    def put_chroma_key(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultChromaKey, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7030174b288cf809da59989594b34135b053a55e6088e6b970529fab57f583f4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putChromaKey", [value]))

    @jsii.member(jsii_name="putComposite")
    def put_composite(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultComposite, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5cf2a4098d6dfa4d6b89c37f7b8453efb8c49b0407a1defdacabcaf3aac26484)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putComposite", [value]))

    @jsii.member(jsii_name="putCompound")
    def put_compound(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultCompound, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__79a3c4e424a3a9eecf9ad1182cb2602f2ceee8de3d9b797825fd657937b3208d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCompound", [value]))

    @jsii.member(jsii_name="putContrast")
    def put_contrast(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultContrast, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__37f978df3d47d2bfea737f980b9afd4ddbaeb6137d06a58c30af6572d229fda7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putContrast", [value]))

    @jsii.member(jsii_name="putGoop")
    def put_goop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultGoop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c3acb415954423fa32dc3a556e9d04bec927eb02a654b116e87d861dca391c95)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGoop", [value]))

    @jsii.member(jsii_name="putGrayscale")
    def put_grayscale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultGrayscale, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ed92d4ca0ac2e7ed25de5805abe575a5c377d0b2599284cafdbd7b5ce67000e3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGrayscale", [value]))

    @jsii.member(jsii_name="putHsl")
    def put_hsl(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultHsl, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f7d9a8a065545eddd01ae21d200e96a9aaabd1d1d396d77bff8f20260c45e994)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsl", [value]))

    @jsii.member(jsii_name="putHsv")
    def put_hsv(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultHsv, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__973d20ad332542c8d0724a9c2b8ea9ada719557616ce03c135091aaf27a4a2fd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsv", [value]))

    @jsii.member(jsii_name="putIfDimension")
    def put_if_dimension(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfDimension, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a45b627d86d4e6bf0e366d18a6f3531a188dfe2cf90ed3c46a694cbc5563ba9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfDimension", [value]))

    @jsii.member(jsii_name="putIfOrientation")
    def put_if_orientation(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__362e147f0f9a31a0fd2980f21b8acdf0577a0b30cce1fc52205903edbfe78199)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfOrientation", [value]))

    @jsii.member(jsii_name="putMaxColors")
    def put_max_colors(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultMaxColors, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__49cf95f695d776254036c13d0366988dfd22d32f1a278309e94363a6218ad6aa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMaxColors", [value]))

    @jsii.member(jsii_name="putMirror")
    def put_mirror(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultMirror, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1ecf1c163cded56f15b68bc8fd9dfd4a67823217c91a4bde47d751156f7a727f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMirror", [value]))

    @jsii.member(jsii_name="putMonoHue")
    def put_mono_hue(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultMonoHue, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__12435fd3f912a9f764b21394c19d9fcff9cdfd35fa17948d74e8055954d3dd22)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMonoHue", [value]))

    @jsii.member(jsii_name="putOpacity")
    def put_opacity(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultOpacity, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5591b59efc14aea19a7e47b581ae791d5f2b520539bf8851012719e27c8a5326)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putOpacity", [value]))

    @jsii.member(jsii_name="putRemoveColor")
    def put_remove_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultRemoveColor", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__45b9617790364a75ee4598e6f5fc463393aebde9143fb9b688a5d2dd31fd4bff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRemoveColor", [value]))

    @jsii.member(jsii_name="putUnsharpMask")
    def put_unsharp_mask(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultUnsharpMask", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8bcc56e2ccb647ff9f09f0fdfcf111a52413b28aea2edda212975367e57f7e83)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putUnsharpMask", [value]))

    @jsii.member(jsii_name="resetBackgroundColor")
    def reset_background_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBackgroundColor", []))

    @jsii.member(jsii_name="resetBlur")
    def reset_blur(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBlur", []))

    @jsii.member(jsii_name="resetChromaKey")
    def reset_chroma_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChromaKey", []))

    @jsii.member(jsii_name="resetComposite")
    def reset_composite(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetComposite", []))

    @jsii.member(jsii_name="resetCompound")
    def reset_compound(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCompound", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetGoop")
    def reset_goop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGoop", []))

    @jsii.member(jsii_name="resetGrayscale")
    def reset_grayscale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGrayscale", []))

    @jsii.member(jsii_name="resetHsl")
    def reset_hsl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsl", []))

    @jsii.member(jsii_name="resetHsv")
    def reset_hsv(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsv", []))

    @jsii.member(jsii_name="resetIfDimension")
    def reset_if_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfDimension", []))

    @jsii.member(jsii_name="resetIfOrientation")
    def reset_if_orientation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfOrientation", []))

    @jsii.member(jsii_name="resetMaxColors")
    def reset_max_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxColors", []))

    @jsii.member(jsii_name="resetMirror")
    def reset_mirror(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMirror", []))

    @jsii.member(jsii_name="resetMonoHue")
    def reset_mono_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonoHue", []))

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetRemoveColor")
    def reset_remove_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRemoveColor", []))

    @jsii.member(jsii_name="resetUnsharpMask")
    def reset_unsharp_mask(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUnsharpMask", []))

    @builtins.property
    @jsii.member(jsii_name="backgroundColor")
    def background_color(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultBackgroundColorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultBackgroundColorList, jsii.get(self, "backgroundColor"))

    @builtins.property
    @jsii.member(jsii_name="blur")
    def blur(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultBlurList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultBlurList, jsii.get(self, "blur"))

    @builtins.property
    @jsii.member(jsii_name="chromaKey")
    def chroma_key(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultChromaKeyList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultChromaKeyList, jsii.get(self, "chromaKey"))

    @builtins.property
    @jsii.member(jsii_name="composite")
    def composite(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultCompositeList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultCompositeList, jsii.get(self, "composite"))

    @builtins.property
    @jsii.member(jsii_name="compound")
    def compound(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultCompoundList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultCompoundList, jsii.get(self, "compound"))

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultContrastList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultContrastList, jsii.get(self, "contrast"))

    @builtins.property
    @jsii.member(jsii_name="goop")
    def goop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultGoopList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultGoopList, jsii.get(self, "goop"))

    @builtins.property
    @jsii.member(jsii_name="grayscale")
    def grayscale(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultGrayscaleList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultGrayscaleList, jsii.get(self, "grayscale"))

    @builtins.property
    @jsii.member(jsii_name="hsl")
    def hsl(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultHslList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultHslList, jsii.get(self, "hsl"))

    @builtins.property
    @jsii.member(jsii_name="hsv")
    def hsv(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultHsvList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultHsvList, jsii.get(self, "hsv"))

    @builtins.property
    @jsii.member(jsii_name="ifDimension")
    def if_dimension(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfDimensionList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfDimensionList, jsii.get(self, "ifDimension"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientation")
    def if_orientation(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfOrientationList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfOrientationList, jsii.get(self, "ifOrientation"))

    @builtins.property
    @jsii.member(jsii_name="maxColors")
    def max_colors(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultMaxColorsList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultMaxColorsList, jsii.get(self, "maxColors"))

    @builtins.property
    @jsii.member(jsii_name="mirror")
    def mirror(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultMirrorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultMirrorList, jsii.get(self, "mirror"))

    @builtins.property
    @jsii.member(jsii_name="monoHue")
    def mono_hue(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultMonoHueList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultMonoHueList, jsii.get(self, "monoHue"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultOpacityList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultOpacityList, jsii.get(self, "opacity"))

    @builtins.property
    @jsii.member(jsii_name="removeColor")
    def remove_color(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultRemoveColorList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultRemoveColorList", jsii.get(self, "removeColor"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMask")
    def unsharp_mask(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultUnsharpMaskList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultUnsharpMaskList", jsii.get(self, "unsharpMask"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColorInput")
    def background_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultBackgroundColor]]], jsii.get(self, "backgroundColorInput"))

    @builtins.property
    @jsii.member(jsii_name="blurInput")
    def blur_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultBlur]]], jsii.get(self, "blurInput"))

    @builtins.property
    @jsii.member(jsii_name="chromaKeyInput")
    def chroma_key_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultChromaKey]]], jsii.get(self, "chromaKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="compositeInput")
    def composite_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultComposite]]], jsii.get(self, "compositeInput"))

    @builtins.property
    @jsii.member(jsii_name="compoundInput")
    def compound_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultCompound]]], jsii.get(self, "compoundInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultContrast]]], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="goopInput")
    def goop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultGoop]]], jsii.get(self, "goopInput"))

    @builtins.property
    @jsii.member(jsii_name="grayscaleInput")
    def grayscale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultGrayscale]]], jsii.get(self, "grayscaleInput"))

    @builtins.property
    @jsii.member(jsii_name="hslInput")
    def hsl_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultHsl]]], jsii.get(self, "hslInput"))

    @builtins.property
    @jsii.member(jsii_name="hsvInput")
    def hsv_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultHsv]]], jsii.get(self, "hsvInput"))

    @builtins.property
    @jsii.member(jsii_name="ifDimensionInput")
    def if_dimension_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfDimension]]], jsii.get(self, "ifDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientationInput")
    def if_orientation_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfOrientation]]], jsii.get(self, "ifOrientationInput"))

    @builtins.property
    @jsii.member(jsii_name="maxColorsInput")
    def max_colors_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultMaxColors]]], jsii.get(self, "maxColorsInput"))

    @builtins.property
    @jsii.member(jsii_name="mirrorInput")
    def mirror_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultMirror]]], jsii.get(self, "mirrorInput"))

    @builtins.property
    @jsii.member(jsii_name="monoHueInput")
    def mono_hue_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultMonoHue]]], jsii.get(self, "monoHueInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultOpacity]]], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="removeColorInput")
    def remove_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultRemoveColor"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultRemoveColor"]]], jsii.get(self, "removeColorInput"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMaskInput")
    def unsharp_mask_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultUnsharpMask"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultUnsharpMask"]]], jsii.get(self, "unsharpMaskInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f36c7b2efd2e06e73e89f480eb020a74182287446038874417ab63d7603dfb48)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultRemoveColor",
    jsii_struct_bases=[],
    name_mapping={
        "color": "color",
        "color_var": "colorVar",
        "feather": "feather",
        "feather_var": "featherVar",
        "tolerance": "tolerance",
        "tolerance_var": "toleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultRemoveColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
        feather: typing.Optional[builtins.str] = None,
        feather_var: typing.Optional[builtins.str] = None,
        tolerance: typing.Optional[builtins.str] = None,
        tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        :param feather: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        :param feather_var: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        :param tolerance: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        :param tolerance_var: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7281cc04d55d018f488e6b9aec9ef144f4c8affb287f23c0259b747eabc3b921)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
            check_type(argname="argument feather", value=feather, expected_type=type_hints["feather"])
            check_type(argname="argument feather_var", value=feather_var, expected_type=type_hints["feather_var"])
            check_type(argname="argument tolerance", value=tolerance, expected_type=type_hints["tolerance"])
            check_type(argname="argument tolerance_var", value=tolerance_var, expected_type=type_hints["tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var
        if feather is not None:
            self._values["feather"] = feather
        if feather_var is not None:
            self._values["feather_var"] = feather_var
        if tolerance is not None:
            self._values["tolerance"] = tolerance
        if tolerance_var is not None:
            self._values["tolerance_var"] = tolerance_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        '''
        result = self._values.get("feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather_var(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        '''
        result = self._values.get("feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        '''
        result = self._values.get("tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance_var(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        result = self._values.get("tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultRemoveColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultRemoveColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultRemoveColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2396225f17e624e9804a3bf070b9e48a30eb53f6aef3f4f5aaf88b7a33cd0eef)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultRemoveColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__52b10c07364830a7ba380beee34de9ce51663c66e2e1faab48bc06adc3b9de43)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultRemoveColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8e82724b520bba4ad307dfba6b027ff0ffebcca0b934e06b7cfa0f37ac1a1fcd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__93ae475a7d96cbc0311160717590c6f0f4e4ff47c3e2622db5d42ab706bc114d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__44e8eb2d1318b5d87cfe4b4618f9e19221c1475054bd544df6b7509aa67dbb4d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultRemoveColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultRemoveColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultRemoveColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__33e82a98f0dcac99c57f9aeb106735fb1dd27e308c1600e80a3dedf0adc439d9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultRemoveColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultRemoveColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8f904e3b239aca920f2ac3ef2817af089bd988ccf87ba3d0f7855f11cdc4aba6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @jsii.member(jsii_name="resetFeather")
    def reset_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeather", []))

    @jsii.member(jsii_name="resetFeatherVar")
    def reset_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatherVar", []))

    @jsii.member(jsii_name="resetTolerance")
    def reset_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTolerance", []))

    @jsii.member(jsii_name="resetToleranceVar")
    def reset_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featherInput")
    def feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherInput"))

    @builtins.property
    @jsii.member(jsii_name="featherVarInput")
    def feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceInput")
    def tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceVarInput")
    def tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6862a57cbeec1bbb7d64f9ff24a3feabf26f887adc2d0af37f46a70434a53e70)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__23c6f3e481a2bbc7dc30246ca1702b4966468a73017f99a8bc69cf881b9097df)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="feather")
    def feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "feather"))

    @feather.setter
    def feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3abceb114837ca71c649471d2c87a34c414207c70327f29d3742d3bdbda1f154)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "feather", value)

    @builtins.property
    @jsii.member(jsii_name="featherVar")
    def feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featherVar"))

    @feather_var.setter
    def feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ab19aafafb1c1be5231946b3012aa766ad018ae9854b52cb5a93460d490d6e5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featherVar", value)

    @builtins.property
    @jsii.member(jsii_name="tolerance")
    def tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tolerance"))

    @tolerance.setter
    def tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__647217f2efd5d2a88e76c31392841bde86a7f946f0b972066726445ab5f16652)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tolerance", value)

    @builtins.property
    @jsii.member(jsii_name="toleranceVar")
    def tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "toleranceVar"))

    @tolerance_var.setter
    def tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a980bee82a9d4536df5439aad576dfd2dd1ccb8c63c92a0b70633cf674f60690)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "toleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultRemoveColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultRemoveColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultRemoveColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5bb94718ea2aaecc0adc01c26525d7bb773bc3264c163ab6cbb62e8d314701e6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultUnsharpMask",
    jsii_struct_bases=[],
    name_mapping={
        "gain": "gain",
        "gain_var": "gainVar",
        "sigma": "sigma",
        "sigma_var": "sigmaVar",
        "threshold": "threshold",
        "threshold_var": "thresholdVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultUnsharpMask:
    def __init__(
        self,
        *,
        gain: typing.Optional[builtins.str] = None,
        gain_var: typing.Optional[builtins.str] = None,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
        threshold: typing.Optional[builtins.str] = None,
        threshold_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param gain: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        :param gain_var: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        :param sigma: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        :param threshold: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        :param threshold_var: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__524b8b77fe5467e764e0e6970b1afa76983b713096126a6dd085a940c93f7bba)
            check_type(argname="argument gain", value=gain, expected_type=type_hints["gain"])
            check_type(argname="argument gain_var", value=gain_var, expected_type=type_hints["gain_var"])
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
            check_type(argname="argument threshold", value=threshold, expected_type=type_hints["threshold"])
            check_type(argname="argument threshold_var", value=threshold_var, expected_type=type_hints["threshold_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if gain is not None:
            self._values["gain"] = gain
        if gain_var is not None:
            self._values["gain_var"] = gain_var
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var
        if threshold is not None:
            self._values["threshold"] = threshold
        if threshold_var is not None:
            self._values["threshold_var"] = threshold_var

    @builtins.property
    def gain(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        '''
        result = self._values.get("gain")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gain_var(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        '''
        result = self._values.get("gain_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        '''
        result = self._values.get("threshold")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold_var(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        result = self._values.get("threshold_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultUnsharpMask(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultUnsharpMaskList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultUnsharpMaskList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aa270a24dd0cd8cdc864317fc7dab1c7bc73e3bbabdeeaf859ce8b6b2c88756c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultUnsharpMaskOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2c039c89dc7bc45625b8d2e1821dcfdbd2256e97153b73ea386fd0f43f0c2d5d)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultUnsharpMaskOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__458c3f8691a85049bd27092b3952a25c5bc0efd518b1c3b7d15844d602a92ba6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dea95f59f55f425dd9a01229bf48f4d6954e74e406f583fee017f393caf505b9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f78edcd961863b3918f4be510de5ac20db456585f1c93b7766dd650b080ca5c8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultUnsharpMask]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultUnsharpMask]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultUnsharpMask]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f4b0371af609ae6b05458fa744314a5bc95c7603e377eb65cdfc03760c30df2b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultUnsharpMaskOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultUnsharpMaskOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__09c822a2decbf004764963940f829f464aa722fea9431a001d9a163150a2c1f6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetGain")
    def reset_gain(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGain", []))

    @jsii.member(jsii_name="resetGainVar")
    def reset_gain_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGainVar", []))

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @jsii.member(jsii_name="resetThreshold")
    def reset_threshold(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThreshold", []))

    @jsii.member(jsii_name="resetThresholdVar")
    def reset_threshold_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThresholdVar", []))

    @builtins.property
    @jsii.member(jsii_name="gainInput")
    def gain_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainInput"))

    @builtins.property
    @jsii.member(jsii_name="gainVarInput")
    def gain_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdInput")
    def threshold_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdVarInput")
    def threshold_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gain")
    def gain(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gain"))

    @gain.setter
    def gain(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d9492c6766a416965ed9a49c7a0d7672abd62bbd690dc0300315abf2c0c704a7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gain", value)

    @builtins.property
    @jsii.member(jsii_name="gainVar")
    def gain_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gainVar"))

    @gain_var.setter
    def gain_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__107b4a071f4d401129864f83fb5aa4032162e44c317cde75f5dea8558cccd9d3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gainVar", value)

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e0569dbba0362af37eecf4e67b1b9185d5759dde748a39014b27b511b68fc24a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8ff47db717875c62b43290a570426b4b50ee035effef44508745c7aa163294d8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="threshold")
    def threshold(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "threshold"))

    @threshold.setter
    def threshold(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e64c88a37c599fc191913227e9365fe7f0251f71b5e842750b67de40848f7fb0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "threshold", value)

    @builtins.property
    @jsii.member(jsii_name="thresholdVar")
    def threshold_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "thresholdVar"))

    @threshold_var.setter
    def threshold_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b22f4bc871af9923d0fa39cd682382700f89c4e62a7bd8808ed2e8c590a6d6f9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "thresholdVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultUnsharpMask]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultUnsharpMask]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultUnsharpMask]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e7e2c7744fe7acc87db6a180634c53e62125d273d0dadcff68f43a6e2e026bfd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscape",
    jsii_struct_bases=[],
    name_mapping={
        "background_color": "backgroundColor",
        "blur": "blur",
        "chroma_key": "chromaKey",
        "composite": "composite",
        "compound": "compound",
        "contrast": "contrast",
        "goop": "goop",
        "grayscale": "grayscale",
        "hsl": "hsl",
        "hsv": "hsv",
        "if_dimension": "ifDimension",
        "if_orientation": "ifOrientation",
        "max_colors": "maxColors",
        "mirror": "mirror",
        "mono_hue": "monoHue",
        "opacity": "opacity",
        "remove_color": "removeColor",
        "unsharp_mask": "unsharpMask",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscape:
    def __init__(
        self,
        *,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeBackgroundColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeBlur", typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeChromaKey", typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeComposite", typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeCompound", typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeContrast", typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeGoop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeGrayscale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeHsl", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeHsv", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfDimension", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfOrientation", typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeMaxColors", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeMirror", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeMonoHue", typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeOpacity", typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeRemoveColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeUnsharpMask", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6a78b0a62bcdeab874c1010c2c71fffcc9102cc875e5ae3514552a42c886a592)
            check_type(argname="argument background_color", value=background_color, expected_type=type_hints["background_color"])
            check_type(argname="argument blur", value=blur, expected_type=type_hints["blur"])
            check_type(argname="argument chroma_key", value=chroma_key, expected_type=type_hints["chroma_key"])
            check_type(argname="argument composite", value=composite, expected_type=type_hints["composite"])
            check_type(argname="argument compound", value=compound, expected_type=type_hints["compound"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument goop", value=goop, expected_type=type_hints["goop"])
            check_type(argname="argument grayscale", value=grayscale, expected_type=type_hints["grayscale"])
            check_type(argname="argument hsl", value=hsl, expected_type=type_hints["hsl"])
            check_type(argname="argument hsv", value=hsv, expected_type=type_hints["hsv"])
            check_type(argname="argument if_dimension", value=if_dimension, expected_type=type_hints["if_dimension"])
            check_type(argname="argument if_orientation", value=if_orientation, expected_type=type_hints["if_orientation"])
            check_type(argname="argument max_colors", value=max_colors, expected_type=type_hints["max_colors"])
            check_type(argname="argument mirror", value=mirror, expected_type=type_hints["mirror"])
            check_type(argname="argument mono_hue", value=mono_hue, expected_type=type_hints["mono_hue"])
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument remove_color", value=remove_color, expected_type=type_hints["remove_color"])
            check_type(argname="argument unsharp_mask", value=unsharp_mask, expected_type=type_hints["unsharp_mask"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if background_color is not None:
            self._values["background_color"] = background_color
        if blur is not None:
            self._values["blur"] = blur
        if chroma_key is not None:
            self._values["chroma_key"] = chroma_key
        if composite is not None:
            self._values["composite"] = composite
        if compound is not None:
            self._values["compound"] = compound
        if contrast is not None:
            self._values["contrast"] = contrast
        if goop is not None:
            self._values["goop"] = goop
        if grayscale is not None:
            self._values["grayscale"] = grayscale
        if hsl is not None:
            self._values["hsl"] = hsl
        if hsv is not None:
            self._values["hsv"] = hsv
        if if_dimension is not None:
            self._values["if_dimension"] = if_dimension
        if if_orientation is not None:
            self._values["if_orientation"] = if_orientation
        if max_colors is not None:
            self._values["max_colors"] = max_colors
        if mirror is not None:
            self._values["mirror"] = mirror
        if mono_hue is not None:
            self._values["mono_hue"] = mono_hue
        if opacity is not None:
            self._values["opacity"] = opacity
        if remove_color is not None:
            self._values["remove_color"] = remove_color
        if unsharp_mask is not None:
            self._values["unsharp_mask"] = unsharp_mask

    @builtins.property
    def background_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeBackgroundColor"]]]:
        '''background_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        '''
        result = self._values.get("background_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeBackgroundColor"]]], result)

    @builtins.property
    def blur(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeBlur"]]]:
        '''blur block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        '''
        result = self._values.get("blur")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeBlur"]]], result)

    @builtins.property
    def chroma_key(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeChromaKey"]]]:
        '''chroma_key block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        '''
        result = self._values.get("chroma_key")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeChromaKey"]]], result)

    @builtins.property
    def composite(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeComposite"]]]:
        '''composite block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        '''
        result = self._values.get("composite")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeComposite"]]], result)

    @builtins.property
    def compound(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeCompound"]]]:
        '''compound block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        '''
        result = self._values.get("compound")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeCompound"]]], result)

    @builtins.property
    def contrast(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeContrast"]]]:
        '''contrast block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeContrast"]]], result)

    @builtins.property
    def goop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeGoop"]]]:
        '''goop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        '''
        result = self._values.get("goop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeGoop"]]], result)

    @builtins.property
    def grayscale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeGrayscale"]]]:
        '''grayscale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        '''
        result = self._values.get("grayscale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeGrayscale"]]], result)

    @builtins.property
    def hsl(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeHsl"]]]:
        '''hsl block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        '''
        result = self._values.get("hsl")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeHsl"]]], result)

    @builtins.property
    def hsv(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeHsv"]]]:
        '''hsv block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        '''
        result = self._values.get("hsv")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeHsv"]]], result)

    @builtins.property
    def if_dimension(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfDimension"]]]:
        '''if_dimension block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        '''
        result = self._values.get("if_dimension")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfDimension"]]], result)

    @builtins.property
    def if_orientation(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfOrientation"]]]:
        '''if_orientation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        '''
        result = self._values.get("if_orientation")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfOrientation"]]], result)

    @builtins.property
    def max_colors(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeMaxColors"]]]:
        '''max_colors block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        '''
        result = self._values.get("max_colors")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeMaxColors"]]], result)

    @builtins.property
    def mirror(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeMirror"]]]:
        '''mirror block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        '''
        result = self._values.get("mirror")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeMirror"]]], result)

    @builtins.property
    def mono_hue(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeMonoHue"]]]:
        '''mono_hue block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        '''
        result = self._values.get("mono_hue")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeMonoHue"]]], result)

    @builtins.property
    def opacity(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeOpacity"]]]:
        '''opacity block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeOpacity"]]], result)

    @builtins.property
    def remove_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeRemoveColor"]]]:
        '''remove_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        '''
        result = self._values.get("remove_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeRemoveColor"]]], result)

    @builtins.property
    def unsharp_mask(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeUnsharpMask"]]]:
        '''unsharp_mask block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        result = self._values.get("unsharp_mask")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeUnsharpMask"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscape(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeBackgroundColor",
    jsii_struct_bases=[],
    name_mapping={"color": "color", "color_var": "colorVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeBackgroundColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d124b29bb963f913c993dba9c7b6adccd72b866e5bf2248b7f1888b25b9e8151)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeBackgroundColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeBackgroundColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeBackgroundColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0fbcb52a69f898e54b34c0be9d92b6f5d8408e777ef2a2a6b4035e94f7961e07)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeBackgroundColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__adace08618c21b350472b591ed7ad4084bb882c46a94dda02a7ee309516f5a5b)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeBackgroundColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d031dd1c65b7375f24c55dedd1fa6e388d0f6693e814dee0cf590dea120cd836)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7e07d8cf19c4d3b91779ab071f287a605f27e3b18b665ce368369dc0d390b9b1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b62129f0d435dbda0b3880c71888bb698449d4a881a0816fb277891c5865376d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeBackgroundColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeBackgroundColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__496b5bb9760ffd0601203eb7357aff0a4de115c9f56ab7aa684aa6909eb996ea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeBackgroundColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeBackgroundColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d26803333803f285ddc26163b06cc189a3b4097e1331fd5b79635903aeb8947a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eb3ead6223211ddc47b5da49efb2cf5a0386cf994f77f376952f03b362f64636)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__83fe220de3d08b091eda0643e9e7b4a00b5c93258a20f7fd93f72cf19687cc22)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeBackgroundColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeBackgroundColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeBackgroundColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4fd1156ed5f559ad7905819df8ad018486ab404f677f29cf5e14f95206e29e11)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeBlur",
    jsii_struct_bases=[],
    name_mapping={"sigma": "sigma", "sigma_var": "sigmaVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeBlur:
    def __init__(
        self,
        *,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param sigma: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7dccfad831c406b327472ddc071d86b2ec8008ba03410b7f2b98c6f5c0fa5d6c)
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeBlur(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeBlurList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeBlurList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__395209de5d9312e4ff0cf18bac7fa5b97e44893aca42727838e5b379207883f3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeBlurOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ad77d7d8e60336cbd199c9a5a0d97d50833ffb5348670ef9b2e879cb07ef1c79)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeBlurOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0af72e23ffa3ad373dee72dc2e295bf406011963229a2b4f0fce3eb6f5ad38f9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1b5bd543e674f161cc899b667fbbfd05f25d161d3ee8ddf779d3dea391ff8828)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c05d3664fef37d23955a31f80eeb9abea4c728a3f8b55b4f95ae087ba46c3d84)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeBlur]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeBlur]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__109e454bd90690ae6f7a5e284410e9811d7c150be1cced5809c2d32af92809af)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeBlurOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeBlurOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0f79fc0d0739c2880124d3b38af81440d80c02a4ee2a604d8c4077751163841e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__108e91a75a6c73226c52960b3c74553a3d64ad55078dcfd5f4e97178722e9a1e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__095804937911ebdef1051e2acdcf77ea49d80fcda62ee76d5dfbb35938f60225)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeBlur]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeBlur]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeBlur]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b3967fb7bbdf54ac8192769ac63bf1626d0df810ea36d624a24952c3b4648516)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeChromaKey",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_feather": "hueFeather",
        "hue_feather_var": "hueFeatherVar",
        "hue_tolerance": "hueTolerance",
        "hue_tolerance_var": "hueToleranceVar",
        "hue_var": "hueVar",
        "lightness_feather": "lightnessFeather",
        "lightness_feather_var": "lightnessFeatherVar",
        "lightness_tolerance": "lightnessTolerance",
        "lightness_tolerance_var": "lightnessToleranceVar",
        "saturation_feather": "saturationFeather",
        "saturation_feather_var": "saturationFeatherVar",
        "saturation_tolerance": "saturationTolerance",
        "saturation_tolerance_var": "saturationToleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeChromaKey:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_feather: typing.Optional[builtins.str] = None,
        hue_feather_var: typing.Optional[builtins.str] = None,
        hue_tolerance: typing.Optional[builtins.str] = None,
        hue_tolerance_var: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness_feather: typing.Optional[builtins.str] = None,
        lightness_feather_var: typing.Optional[builtins.str] = None,
        lightness_tolerance: typing.Optional[builtins.str] = None,
        lightness_tolerance_var: typing.Optional[builtins.str] = None,
        saturation_feather: typing.Optional[builtins.str] = None,
        saturation_feather_var: typing.Optional[builtins.str] = None,
        saturation_tolerance: typing.Optional[builtins.str] = None,
        saturation_tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_feather: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        :param hue_feather_var: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        :param hue_tolerance: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        :param hue_tolerance_var: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        :param hue_var: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness_feather: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        :param lightness_feather_var: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        :param lightness_tolerance: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        :param lightness_tolerance_var: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        :param saturation_feather: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        :param saturation_feather_var: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        :param saturation_tolerance: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        :param saturation_tolerance_var: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__780c8400f3ec8658b790d3175b9cdcd78939c6992822b560a47f67ec5301274e)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_feather", value=hue_feather, expected_type=type_hints["hue_feather"])
            check_type(argname="argument hue_feather_var", value=hue_feather_var, expected_type=type_hints["hue_feather_var"])
            check_type(argname="argument hue_tolerance", value=hue_tolerance, expected_type=type_hints["hue_tolerance"])
            check_type(argname="argument hue_tolerance_var", value=hue_tolerance_var, expected_type=type_hints["hue_tolerance_var"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness_feather", value=lightness_feather, expected_type=type_hints["lightness_feather"])
            check_type(argname="argument lightness_feather_var", value=lightness_feather_var, expected_type=type_hints["lightness_feather_var"])
            check_type(argname="argument lightness_tolerance", value=lightness_tolerance, expected_type=type_hints["lightness_tolerance"])
            check_type(argname="argument lightness_tolerance_var", value=lightness_tolerance_var, expected_type=type_hints["lightness_tolerance_var"])
            check_type(argname="argument saturation_feather", value=saturation_feather, expected_type=type_hints["saturation_feather"])
            check_type(argname="argument saturation_feather_var", value=saturation_feather_var, expected_type=type_hints["saturation_feather_var"])
            check_type(argname="argument saturation_tolerance", value=saturation_tolerance, expected_type=type_hints["saturation_tolerance"])
            check_type(argname="argument saturation_tolerance_var", value=saturation_tolerance_var, expected_type=type_hints["saturation_tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_feather is not None:
            self._values["hue_feather"] = hue_feather
        if hue_feather_var is not None:
            self._values["hue_feather_var"] = hue_feather_var
        if hue_tolerance is not None:
            self._values["hue_tolerance"] = hue_tolerance
        if hue_tolerance_var is not None:
            self._values["hue_tolerance_var"] = hue_tolerance_var
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness_feather is not None:
            self._values["lightness_feather"] = lightness_feather
        if lightness_feather_var is not None:
            self._values["lightness_feather_var"] = lightness_feather_var
        if lightness_tolerance is not None:
            self._values["lightness_tolerance"] = lightness_tolerance
        if lightness_tolerance_var is not None:
            self._values["lightness_tolerance_var"] = lightness_tolerance_var
        if saturation_feather is not None:
            self._values["saturation_feather"] = saturation_feather
        if saturation_feather_var is not None:
            self._values["saturation_feather_var"] = saturation_feather_var
        if saturation_tolerance is not None:
            self._values["saturation_tolerance"] = saturation_tolerance
        if saturation_tolerance_var is not None:
            self._values["saturation_tolerance_var"] = saturation_tolerance_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        '''
        result = self._values.get("hue_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        '''
        result = self._values.get("hue_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        '''
        result = self._values.get("hue_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        '''
        result = self._values.get("hue_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        '''
        result = self._values.get("lightness_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        '''
        result = self._values.get("lightness_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        '''
        result = self._values.get("lightness_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        '''
        result = self._values.get("lightness_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        '''
        result = self._values.get("saturation_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        '''
        result = self._values.get("saturation_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        '''
        result = self._values.get("saturation_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        result = self._values.get("saturation_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeChromaKey(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeChromaKeyList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeChromaKeyList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__244fd2fec8fa76861259e4ca3c1eb7bb389286c23da7619e9fe03c71ed42b8d5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeChromaKeyOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__08f84ed76ca3382e4fbc8b5e828722cdd05346954be929a5e39fd19a51a1acc1)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeChromaKeyOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__167422fd512a7d88c1e45b3c2567fc6987a1481804eebac000d9677ffe85888c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ed5d4ea1b9eff0ececc8834b21f15ccd47dc9e073cd9f056b20d178ea33a8597)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__70e059aa4a8bfff4d39c1d4d094f73099316af6c8fb4fc5d19a59eb0d0c569c2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeChromaKey]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeChromaKey]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f74162a5e6521904ed01e94593384805d48b5a15413e2ad97b9c39ac9d6c7ce6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeChromaKeyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeChromaKeyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__10b47290e9fe958d5b1131a45cd59897d31ec41a6a419c73a2314911d9d43471)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueFeather")
    def reset_hue_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeather", []))

    @jsii.member(jsii_name="resetHueFeatherVar")
    def reset_hue_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeatherVar", []))

    @jsii.member(jsii_name="resetHueTolerance")
    def reset_hue_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueTolerance", []))

    @jsii.member(jsii_name="resetHueToleranceVar")
    def reset_hue_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueToleranceVar", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightnessFeather")
    def reset_lightness_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeather", []))

    @jsii.member(jsii_name="resetLightnessFeatherVar")
    def reset_lightness_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeatherVar", []))

    @jsii.member(jsii_name="resetLightnessTolerance")
    def reset_lightness_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessTolerance", []))

    @jsii.member(jsii_name="resetLightnessToleranceVar")
    def reset_lightness_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessToleranceVar", []))

    @jsii.member(jsii_name="resetSaturationFeather")
    def reset_saturation_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeather", []))

    @jsii.member(jsii_name="resetSaturationFeatherVar")
    def reset_saturation_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeatherVar", []))

    @jsii.member(jsii_name="resetSaturationTolerance")
    def reset_saturation_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationTolerance", []))

    @jsii.member(jsii_name="resetSaturationToleranceVar")
    def reset_saturation_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherInput")
    def hue_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVarInput")
    def hue_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceInput")
    def hue_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVarInput")
    def hue_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherInput")
    def lightness_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVarInput")
    def lightness_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceInput")
    def lightness_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVarInput")
    def lightness_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherInput")
    def saturation_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVarInput")
    def saturation_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceInput")
    def saturation_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVarInput")
    def saturation_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8fbb7ecb08f28863e6f2ab03a2801895a7be231c6485dd6a7a8defb48cb15143)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeather")
    def hue_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeather"))

    @hue_feather.setter
    def hue_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d25bf2da94dda1cfb78016c83d00ea0f0f82c1fb94ff1d8f76a0f0540dbfb551)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeather", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVar")
    def hue_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeatherVar"))

    @hue_feather_var.setter
    def hue_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f4b737f47694d85f531bb8515ad46dacd4c1a244267fde41fb975d49eb0843a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueTolerance")
    def hue_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueTolerance"))

    @hue_tolerance.setter
    def hue_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9f9286b8e4fa517450ff7cca1c7d07a81e5b221fec0398627e84105c71ba9d04)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVar")
    def hue_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueToleranceVar"))

    @hue_tolerance_var.setter
    def hue_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__45ce930923ba47adf0f42db2b48f20148a8bb03f37aaf9537f0ddf3f86b43e58)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6d5aea4ac1c6fb3d909ed9a749c87b14e193b780afea763d391149b699c18557)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeather")
    def lightness_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeather"))

    @lightness_feather.setter
    def lightness_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__07edbb2e7094706e896a3869e068aeaf285c2a43d7a366558a577cd7e07d02a8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeather", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVar")
    def lightness_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeatherVar"))

    @lightness_feather_var.setter
    def lightness_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0aef1d3066ff27beb2dbfb6b33d37cc8f2458cceac542ffa0c91351ea41fd870)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessTolerance")
    def lightness_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessTolerance"))

    @lightness_tolerance.setter
    def lightness_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b3772465934ab5f85cd78e970607676da9ff907c2b6e151736b6b26d47a097ea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVar")
    def lightness_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessToleranceVar"))

    @lightness_tolerance_var.setter
    def lightness_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fca2b5b97acd26030c3aa07901879f81b958215c21cf7a8210388eb6c05680b2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeather")
    def saturation_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeather"))

    @saturation_feather.setter
    def saturation_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__69ffc30c5f63f6ffbf8aa6dbd1c27b23128a390ce0a806fb8f1cac7534bf7af6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeather", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVar")
    def saturation_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeatherVar"))

    @saturation_feather_var.setter
    def saturation_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d1a5cd571ea40b431778e1fe9d0a0a99f3870c1ada2f163fd56b5514b32c9da4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationTolerance")
    def saturation_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationTolerance"))

    @saturation_tolerance.setter
    def saturation_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__742c45149ea096925347e9221458544bd863ecef01e54ba5ab444cef67b26796)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVar")
    def saturation_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationToleranceVar"))

    @saturation_tolerance_var.setter
    def saturation_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__934e4cec63218500b5648e802dd9df18ad045c10956225671231d1eb736265d2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeChromaKey]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeChromaKey]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeChromaKey]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fc8914eea012ccfb6eecaf52d9a91ae6fbae1dfa833205e7e13ca3fdd0bcfc4c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeComposite",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "placement": "placement",
        "placement_var": "placementVar",
        "scale": "scale",
        "scale_dimension": "scaleDimension",
        "scale_dimension_var": "scaleDimensionVar",
        "scale_var": "scaleVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeComposite:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeCompositeImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        placement: typing.Optional[builtins.str] = None,
        placement_var: typing.Optional[builtins.str] = None,
        scale: typing.Optional[builtins.str] = None,
        scale_dimension: typing.Optional[builtins.str] = None,
        scale_dimension_var: typing.Optional[builtins.str] = None,
        scale_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param placement: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        :param placement_var: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        :param scale: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param scale_dimension: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        :param scale_dimension_var: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        :param scale_var: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        :param x_position: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeCompositeImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__147fab6bdfd76702551eaaed540a4bcbea6ad751e1acadcd107c614e6de1104c)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument placement", value=placement, expected_type=type_hints["placement"])
            check_type(argname="argument placement_var", value=placement_var, expected_type=type_hints["placement_var"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument scale_dimension", value=scale_dimension, expected_type=type_hints["scale_dimension"])
            check_type(argname="argument scale_dimension_var", value=scale_dimension_var, expected_type=type_hints["scale_dimension_var"])
            check_type(argname="argument scale_var", value=scale_var, expected_type=type_hints["scale_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if placement is not None:
            self._values["placement"] = placement
        if placement_var is not None:
            self._values["placement_var"] = placement_var
        if scale is not None:
            self._values["scale"] = scale
        if scale_dimension is not None:
            self._values["scale_dimension"] = scale_dimension
        if scale_dimension_var is not None:
            self._values["scale_dimension_var"] = scale_dimension_var
        if scale_var is not None:
            self._values["scale_var"] = scale_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeCompositeImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeCompositeImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        '''
        result = self._values.get("placement")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement_var(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        '''
        result = self._values.get("placement_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        '''
        result = self._values.get("scale_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        '''
        result = self._values.get("scale_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        '''
        result = self._values.get("scale_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeComposite(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeCompositeImage",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeCompositeImage:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeCompositeImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeCompositeImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeCompositeImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__17494e3047bb2e40b30f17226210ee4fe5ac6f0debc0067625c508abc22a6c13)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeCompositeImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeCompositeImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f7c13bfe5d54c243dbff6850f3421e397835708f19a64a114b47e13ea298c1ba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeCompositeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeCompositeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ed96e6a760678db709958ad1678861a76e735124d3712bd58e49d1238372e35)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeCompositeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__26dcafbb9d0f7835e9854025a51742ed9b3bb96d5fecf7947fd522fdeb87d5b6)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeCompositeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__805938747ce0ff3855b33512005296260574b269e4e0c9e88f8b77e7617b1ccb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__422ea4fb23a5cdc14bb3233bfb062ec687c176d20190844f08df0ceb9fe9883a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ec827606da7decc3429302467f93a1f086c9ca1c11f8e85a263949cdca5460f6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeComposite]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeComposite]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b100118fece193297d8f81cef2e0a8f36f62f2ecbc7120691e285d97e063cc03)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeCompositeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeCompositeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b5b2fd4798c3682797b92a6f84a9191ce391bb920c52e9e58dc4db3301e31bd9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeCompositeImage()

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPlacement")
    def reset_placement(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacement", []))

    @jsii.member(jsii_name="resetPlacementVar")
    def reset_placement_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacementVar", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetScaleDimension")
    def reset_scale_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimension", []))

    @jsii.member(jsii_name="resetScaleDimensionVar")
    def reset_scale_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimensionVar", []))

    @jsii.member(jsii_name="resetScaleVar")
    def reset_scale_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeCompositeImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeCompositeImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeCompositeImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="placementInput")
    def placement_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementInput"))

    @builtins.property
    @jsii.member(jsii_name="placementVarInput")
    def placement_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionInput")
    def scale_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVarInput")
    def scale_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleVarInput")
    def scale_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8ef7ad5ec46a315f39ab422fcb50d95f6af383327f40a59a4ba3adc8a64b7018)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__46457dda3f1ecdbf0173a9d3088e4080ded4858f53fc1938b5d4f7033b106d62)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="placement")
    def placement(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placement"))

    @placement.setter
    def placement(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__58895d2d668540965e6723992bcf51b55d362cc908f0ed2e441e37c2942c6175)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placement", value)

    @builtins.property
    @jsii.member(jsii_name="placementVar")
    def placement_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placementVar"))

    @placement_var.setter
    def placement_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a3cf90d949b38d496fff7bc5fdfee394b72569e0ec65413ad888b1a57a0ca7c8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placementVar", value)

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scale"))

    @scale.setter
    def scale(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f3148f2adbd9106e4fc127b0eb245a6e5e2c8b7f120f7a3ccd922d304405fc7b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scale", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimension")
    def scale_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimension"))

    @scale_dimension.setter
    def scale_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a18dd09f55ebdbaa3e51497c6ca48e01afa792463e67ec268f35eb699757a612)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimension", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVar")
    def scale_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimensionVar"))

    @scale_dimension_var.setter
    def scale_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__803a478eea620c2f4aea101ad2c139ff61bfc08f94c9cd390f3f86a25b3258b6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="scaleVar")
    def scale_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleVar"))

    @scale_var.setter
    def scale_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3771d5b2050a918e79cbe62b26c47dc9d930224f9b232a579d3758104cd9e715)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cdd20ae0598bf4f5ab17f688f6dc8e16a290db959dac4c00aeb777c46d9d096f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e568c7471bca4a5fbdb86d8829e2f82291fbbfc64d5140c12039dad4e8541620)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__efc6d202166791dd78e13513ef818b7211b1237c89a4fe8eec43826e991b01de)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a64ba81a4e35cad87991a732732b14b071af41fc0a4b34248690b8a5a8a6e55)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeComposite]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeComposite]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeComposite]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f4dd770d8e555b90b8a1a3dc06d3047119d172ada0b00e766cb8061425ac3d3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeCompound",
    jsii_struct_bases=[],
    name_mapping={"transformations": "transformations"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeCompound:
    def __init__(
        self,
        *,
        transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param transformations: transformations block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2740def14f2701ee5da18b8af8e13a33165b42ba81764899ba080ce12b5f1bf2)
            check_type(argname="argument transformations", value=transformations, expected_type=type_hints["transformations"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if transformations is not None:
            self._values["transformations"] = transformations

    @builtins.property
    def transformations(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeCompoundTransformations"]]]:
        '''transformations block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        result = self._values.get("transformations")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeCompoundTransformations"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeCompound(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeCompoundList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeCompoundList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8deffd8b583039e63c027a821cb1273c49a0f8fcbb588d825991f39bca32bcd4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeCompoundOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b19f8bdb79a779ccab85f101e240a4ca82aac7900c152b2012d0ae1f69662bc8)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeCompoundOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b0877ba3d26192e5c906428398c18024927846ed63cb1d368897296899d219a2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f454d810622615ae6012527ef3899eb241e7a1fbb08c2ad6dd3710de449934e3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dd8426ea6cd6cef26bbbca953d614a5c0f3f6ca31f0c7dd4399b0097edfdfbd8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeCompound]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeCompound]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a7d3f91896ebdc05f7810c62149bf7eeca9819c587f18779bad7156eac8b92f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeCompoundOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeCompoundOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d06ba39d40ca278affef3c508aec59be25615fa1cff7a561e63475be30ec5e4d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformations")
    def put_transformations(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ad5de9a8a4d6b5ea980903528a11f4e1239602ac2ec93a735ddd912a49545266)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTransformations", [value]))

    @jsii.member(jsii_name="resetTransformations")
    def reset_transformations(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformations", []))

    @builtins.property
    @jsii.member(jsii_name="transformations")
    def transformations(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeCompoundTransformationsList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeCompoundTransformationsList", jsii.get(self, "transformations"))

    @builtins.property
    @jsii.member(jsii_name="transformationsInput")
    def transformations_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeCompoundTransformations"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeCompoundTransformations"]]], jsii.get(self, "transformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeCompound]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeCompound]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeCompound]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c4577ff3e0011d8108f5d5ad34b12fbf358c09f162328421bde7033fac3a4a5c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeCompoundTransformations",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeCompoundTransformations:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeCompoundTransformations(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeCompoundTransformationsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeCompoundTransformationsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cc40d549e22a1dad7b5c11db7f4c937a03a15944cf939ffcb9eb034de8ca7f0a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeCompoundTransformationsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1be255678a79f227602016f356114de18048cb2d60795c7d50818d738ca602c3)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeCompoundTransformationsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__42ca61401b67a870b796eadc8539fdc5bb7a4abb56531669e04090d0ed5098a9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c1dac3bdcaa245baa59df2ab2ca1b6ccf5ff6361e60a4a2818723ce5bebb5c8a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__190e60c1a24288cd90b75de46297b1048ce1b0108cdc693cddec35397a466107)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeCompoundTransformations]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeCompoundTransformations]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeCompoundTransformations]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a3a1b34beba6aa19c68b6d1da5ddc2ec8191e03370876a6c9e42c549e922f9f8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeCompoundTransformationsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeCompoundTransformationsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fb00181974fd7806be8e27a7995ac29478597bb38bdd672a162539149235784e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeCompoundTransformations]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeCompoundTransformations]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeCompoundTransformations]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__049d139f40229960a67c9549e782c5b11b071ca07af6fa59339fbb8be5c42a6b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeContrast",
    jsii_struct_bases=[],
    name_mapping={
        "brightness": "brightness",
        "brightness_var": "brightnessVar",
        "contrast": "contrast",
        "contrast_var": "contrastVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeContrast:
    def __init__(
        self,
        *,
        brightness: typing.Optional[builtins.str] = None,
        brightness_var: typing.Optional[builtins.str] = None,
        contrast: typing.Optional[builtins.str] = None,
        contrast_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param brightness: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        :param brightness_var: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        :param contrast: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param contrast_var: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__65987736f2f0658b232a81d1e3674d56ac6734fd7a20694ebcb0ab7405d8b5cf)
            check_type(argname="argument brightness", value=brightness, expected_type=type_hints["brightness"])
            check_type(argname="argument brightness_var", value=brightness_var, expected_type=type_hints["brightness_var"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument contrast_var", value=contrast_var, expected_type=type_hints["contrast_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if brightness is not None:
            self._values["brightness"] = brightness
        if brightness_var is not None:
            self._values["brightness_var"] = brightness_var
        if contrast is not None:
            self._values["contrast"] = contrast
        if contrast_var is not None:
            self._values["contrast_var"] = contrast_var

    @builtins.property
    def brightness(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        '''
        result = self._values.get("brightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def brightness_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        '''
        result = self._values.get("brightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        result = self._values.get("contrast_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeContrast(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeContrastList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeContrastList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac0efeb1be68a4d27ac7968706a66f7c198d7101c8981b2ea2a771f880b3acd0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeContrastOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2147017bc9f8a9abd9c22dc66ade8d8bd3850c4930623ce553a2fe6fd8d7636e)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeContrastOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f85317fa97a55e26ff94763deb056986c6bff276066812f62c794352dd292853)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2f73230bdeb897b6d93801ebc98a26d46632bd3aa956b80ba2f95bfa103c5992)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8d1b42e3a22e7dd58c97ad397592be333c9ea03a5311fbcce3e09860ab4c770c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeContrast]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeContrast]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6c73b33e63dc344edc0c94a84791990d0603eafe06df4e53586f2aef6357deb0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeContrastOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeContrastOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__39bf37117ffa1e6012e96ec0138fd23912c606abbf3163fc5771d1e4c08710d6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetBrightness")
    def reset_brightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightness", []))

    @jsii.member(jsii_name="resetBrightnessVar")
    def reset_brightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightnessVar", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetContrastVar")
    def reset_contrast_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrastVar", []))

    @builtins.property
    @jsii.member(jsii_name="brightnessInput")
    def brightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="brightnessVarInput")
    def brightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastVarInput")
    def contrast_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="brightness")
    def brightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightness"))

    @brightness.setter
    def brightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fe87ad330e04aad9244192e65d5a02d322cbbe0c1bf88b2b6e8538ba17baa942)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightness", value)

    @builtins.property
    @jsii.member(jsii_name="brightnessVar")
    def brightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightnessVar"))

    @brightness_var.setter
    def brightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__677c7b23f6ca7ff7dde480bb2bb3beb56d1801780269b1c4cea5155697c22e23)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrast"))

    @contrast.setter
    def contrast(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f7943ce7b83eb82d3b59a3f8596751dff6b4bca879be8049d8edbe80a23c2c03)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrast", value)

    @builtins.property
    @jsii.member(jsii_name="contrastVar")
    def contrast_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrastVar"))

    @contrast_var.setter
    def contrast_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__969a58fc9da9618ddc961af01492f917c828d8f096a43087afada8df2e080c0e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrastVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeContrast]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeContrast]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeContrast]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dc0ba0027fe8968ad9a8ae2e1db7ff267a534fd0d4c963378eaa6e4503b50bb2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeGoop",
    jsii_struct_bases=[],
    name_mapping={
        "chaos": "chaos",
        "chaos_var": "chaosVar",
        "density": "density",
        "density_var": "densityVar",
        "power": "power",
        "power_var": "powerVar",
        "seed": "seed",
        "seed_var": "seedVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeGoop:
    def __init__(
        self,
        *,
        chaos: typing.Optional[builtins.str] = None,
        chaos_var: typing.Optional[builtins.str] = None,
        density: typing.Optional[builtins.str] = None,
        density_var: typing.Optional[builtins.str] = None,
        power: typing.Optional[builtins.str] = None,
        power_var: typing.Optional[builtins.str] = None,
        seed: typing.Optional[builtins.str] = None,
        seed_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param chaos: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        :param chaos_var: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        :param density: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        :param density_var: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        :param power: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        :param power_var: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        :param seed: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        :param seed_var: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d97333530d55e371a3bf22de57314a725279ad97ab2fd8a46c050de4fa80646a)
            check_type(argname="argument chaos", value=chaos, expected_type=type_hints["chaos"])
            check_type(argname="argument chaos_var", value=chaos_var, expected_type=type_hints["chaos_var"])
            check_type(argname="argument density", value=density, expected_type=type_hints["density"])
            check_type(argname="argument density_var", value=density_var, expected_type=type_hints["density_var"])
            check_type(argname="argument power", value=power, expected_type=type_hints["power"])
            check_type(argname="argument power_var", value=power_var, expected_type=type_hints["power_var"])
            check_type(argname="argument seed", value=seed, expected_type=type_hints["seed"])
            check_type(argname="argument seed_var", value=seed_var, expected_type=type_hints["seed_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if chaos is not None:
            self._values["chaos"] = chaos
        if chaos_var is not None:
            self._values["chaos_var"] = chaos_var
        if density is not None:
            self._values["density"] = density
        if density_var is not None:
            self._values["density_var"] = density_var
        if power is not None:
            self._values["power"] = power
        if power_var is not None:
            self._values["power_var"] = power_var
        if seed is not None:
            self._values["seed"] = seed
        if seed_var is not None:
            self._values["seed_var"] = seed_var

    @builtins.property
    def chaos(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        '''
        result = self._values.get("chaos")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def chaos_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        '''
        result = self._values.get("chaos_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        '''
        result = self._values.get("density")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density_var(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        '''
        result = self._values.get("density_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        '''
        result = self._values.get("power")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power_var(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        '''
        result = self._values.get("power_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        '''
        result = self._values.get("seed")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed_var(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        result = self._values.get("seed_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeGoop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeGoopList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeGoopList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__74b034ec479f9c48754cf7d2192f3b2d2ced0432c30fcd1592aaa8a034797ba7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeGoopOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ba41a463a103f99773b645b538d513adc6cf639bba8f21fcc117c3e163011a9e)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeGoopOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__70cb57ee280e41bd1f6b39b619f2787a9cbd70aaa9e6ebb55b3711e9f533ccfc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__36f6ef2dad66b873168decd3981d7b19e2311e57256bcf7d8fd156408ca0f2fd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ba1113b0eba1fabc0b7b010565c734b421178b241a15d105c3326e9cb40df2f4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeGoop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeGoop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0fd4ce7d90d66f2297d213f34a30ef09691d0a477a74bd2a5e59883234a75b52)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeGoopOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeGoopOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d22805551433b4ab12c4407781a03064c82ea18cf6dfb5b8205314c9a8d9b48f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetChaos")
    def reset_chaos(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaos", []))

    @jsii.member(jsii_name="resetChaosVar")
    def reset_chaos_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaosVar", []))

    @jsii.member(jsii_name="resetDensity")
    def reset_density(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensity", []))

    @jsii.member(jsii_name="resetDensityVar")
    def reset_density_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensityVar", []))

    @jsii.member(jsii_name="resetPower")
    def reset_power(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPower", []))

    @jsii.member(jsii_name="resetPowerVar")
    def reset_power_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPowerVar", []))

    @jsii.member(jsii_name="resetSeed")
    def reset_seed(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeed", []))

    @jsii.member(jsii_name="resetSeedVar")
    def reset_seed_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeedVar", []))

    @builtins.property
    @jsii.member(jsii_name="chaosInput")
    def chaos_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosInput"))

    @builtins.property
    @jsii.member(jsii_name="chaosVarInput")
    def chaos_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosVarInput"))

    @builtins.property
    @jsii.member(jsii_name="densityInput")
    def density_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityInput"))

    @builtins.property
    @jsii.member(jsii_name="densityVarInput")
    def density_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="powerInput")
    def power_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerInput"))

    @builtins.property
    @jsii.member(jsii_name="powerVarInput")
    def power_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerVarInput"))

    @builtins.property
    @jsii.member(jsii_name="seedInput")
    def seed_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedInput"))

    @builtins.property
    @jsii.member(jsii_name="seedVarInput")
    def seed_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedVarInput"))

    @builtins.property
    @jsii.member(jsii_name="chaos")
    def chaos(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaos"))

    @chaos.setter
    def chaos(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__306ce462bc009be671a2410c9bf122835df99eae49bfb500f67b578a6b514ca5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaos", value)

    @builtins.property
    @jsii.member(jsii_name="chaosVar")
    def chaos_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaosVar"))

    @chaos_var.setter
    def chaos_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c4afce29e6ca4d5588a5e407dc6ec9b7ce7514e7990c6643bd8588d2e12b7576)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaosVar", value)

    @builtins.property
    @jsii.member(jsii_name="density")
    def density(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "density"))

    @density.setter
    def density(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f3589f437e74f30b08afd52da272b5c0585ad718c3ee0cd42af39f1c34b40ad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "density", value)

    @builtins.property
    @jsii.member(jsii_name="densityVar")
    def density_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "densityVar"))

    @density_var.setter
    def density_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e5fb7d7c7ca3fe10517aadd4a8b4b9e447fe2a5bb6c5a08ea83c1991bc00ba98)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "densityVar", value)

    @builtins.property
    @jsii.member(jsii_name="power")
    def power(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "power"))

    @power.setter
    def power(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a90872fe948c7f0a5818c9bb01aff7eceb6fc0c922ab320af442349850549a24)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "power", value)

    @builtins.property
    @jsii.member(jsii_name="powerVar")
    def power_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "powerVar"))

    @power_var.setter
    def power_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0d1ebaec1a92a1c05a43cb211c42f79e7ee19de67d37241d4f2f2699da54eb67)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "powerVar", value)

    @builtins.property
    @jsii.member(jsii_name="seed")
    def seed(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seed"))

    @seed.setter
    def seed(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__41ce1b088735c45c46d88c83ed10064bf9d1ce0608b28116e486908831b5494d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seed", value)

    @builtins.property
    @jsii.member(jsii_name="seedVar")
    def seed_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seedVar"))

    @seed_var.setter
    def seed_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bfbe3912c34689c918ccde8abee1e9cfc29875260f4fe1bf16afb89b25f147d0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seedVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeGoop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeGoop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeGoop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1e740b3fe77be36c8f551ed0e903d197f8077f20610040cf7282ac3d9986cef4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeGrayscale",
    jsii_struct_bases=[],
    name_mapping={"type": "type", "type_var": "typeVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeGrayscale:
    def __init__(
        self,
        *,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param type: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__098fe338278841e28b59615afa16de5e8c7a1d6597b83f7ca83ade56f5565174)
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeGrayscale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeGrayscaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeGrayscaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__47bd750f8b74856a0a49858d340f0a49068e06a579ab741279924ea0226da0cc)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeGrayscaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6c1e28663dbe107f366d72971cd9fc25ba555b9421369bf3ada35b805c5fae4c)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeGrayscaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0b0089bb347d4bc6581642e0419bf1d8b1e40f5c8303bbf19760ace3771bf73a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__456031cfd0e58541e80035345036aba667bf8031288af1725653ae7d31319be3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c677691d834e2ba5b496e1fe06a088f0e720243395b16340da17f2307a6fc821)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeGrayscale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeGrayscale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1dae1037bf10bd8a74e3bbc2f495231abd44a077731707eae90691d553f3961e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeGrayscaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeGrayscaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__60f0e5a14b3dcb0baee1c3a005aa037cb09d231ac92b6ddcc6f214a501da1169)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f74e3f86214fd4722fc12ac1a8f9388306f97af92e85f36f4c985bceb7e281f7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0943fe4f7eec77eaeedd9de5482db8eb280c07ea979972524d2e82abb9c7e378)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeGrayscale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeGrayscale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeGrayscale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__efbe190248911686bb133fa2a4101cb79b83d8c07f7b171d1fc3857b05c39ff9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeHsl",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "lightness": "lightness",
        "lightness_var": "lightnessVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeHsl:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness: typing.Optional[builtins.str] = None,
        lightness_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        :param lightness_var: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8797d31387bdadbd51a7a9a11e3f5b656574cb3a57d7b715baa31feea4bbee34)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness", value=lightness, expected_type=type_hints["lightness"])
            check_type(argname="argument lightness_var", value=lightness_var, expected_type=type_hints["lightness_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness is not None:
            self._values["lightness"] = lightness
        if lightness_var is not None:
            self._values["lightness_var"] = lightness_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        '''
        result = self._values.get("lightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        '''
        result = self._values.get("lightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeHsl(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeHslList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeHslList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__041db53f79574d9e280b1c955628fe48436392526fc16e447c140a8d1c0826e5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeHslOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dbf062bffd5d9c3203e0935563df4a76a84b83e277f73413c644b540f2021ef7)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeHslOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c43821d815c617bd6d503bb1d84a2369db2d2536fac61918212e5fbc8151df15)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__42f71b5679e26666a205de23da96cf4774e496c5ab10e4b99797006531a7ee14)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e33b899b6d19f5c273681e486b38700bf19cd132bc00bbb7241869c6905163e1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeHsl]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeHsl]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__de1797f5d4fee475af8efb002051d3ded124656744dd1a7d881742e77e55c5be)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeHslOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeHslOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__74c1b01a25653f41358bf8e0125ad48b99153b5d352854d28dbac83b2a85760a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightness")
    def reset_lightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightness", []))

    @jsii.member(jsii_name="resetLightnessVar")
    def reset_lightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessInput")
    def lightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessVarInput")
    def lightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9789d132232c0e31c07b637eae85bf57314f7901b61cb83b6159665d41fff98d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9f558c3bb2d15a38717e72c70ff723b59d0007c6101b286c520dde418f6d4995)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightness")
    def lightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightness"))

    @lightness.setter
    def lightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e2396419f75643b1449c73a8a66cfce8b38a8b871158f5f3954d10df4479f7bc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightness", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessVar")
    def lightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessVar"))

    @lightness_var.setter
    def lightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__57a8d8a0fc1a9ff81213d07a5fa4271a26573ff4b4ca1ed1f38dd75743c9b35a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__61ca194074aa594b59fd2f2f767344a3d7000cd29626fff93d1ee04fea3f0dd7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__790b8f3db1e6da7d90ec5028b80aea578a990b80abeb5334d6f8d4cd3425dfb2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeHsl]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeHsl]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeHsl]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2e7acdac403e902189467b3bb6ec7f7b59d9359e527923e0081dc39ce819a2e0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeHsv",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeHsv:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        :param value: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__25cc74c0df52f0fa5b00d6b386df9b43d583b5d71809d2e8ef436db6bfbaf991)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeHsv(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeHsvList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeHsvList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0c6448965193b926934587dfa6e77c674adb9b6c187b00e428ff79f5e5aa1870)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeHsvOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3e5108e2e2f266913f2e93ef8847f3739160202d7774ec1979d43bd7d76012f4)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeHsvOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4d1c0cc83c1de1a875d2115987b1feb12dd15337c6c2857a1fff3ce8acbe1ea1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a57bf488b7825da548599ac5558c2a92e71f25c077a413f281e40d0431ee1d6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__abf2167a532179a04785b38928b0728c733a229bd69c06d546e8d62c6e2bf776)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeHsv]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeHsv]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__36c7046a9a38623b62a63c7bfd1f9601bbea28ca44e27c16476b2b2e097012f7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeHsvOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeHsvOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c903fe7cf7a82c43ad206df27caf986f2bf871603a0a9d7f048c04c324ee99d9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4578d285eeae04690fdfbc012cf7cbe16fb542bad0d1fe936514f00b9a5ea7d6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa2b1f1cbdc9d5c24b562744c25790fd4f93a4ab13ad48baa0fdb8eea5c872c1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9cbf93c15cd7e0c088fdbd68c09fe4bcaba6356a096c291a2421ff3230b8ba28)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fc6cf4c10989fa8310954e93e16e1c04c3e713cc9e56af918cb7fd7cde5ea085)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6774595ca4d0a74b5187f5a7e6eee755818e8df163aec8b8e1d4248e9c4346e4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b3525a81cf7646556476c73c907e57971f3e571bba53b5fc3167109928d9b852)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeHsv]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeHsv]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeHsv]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d643441e61756f7c582357c2241238244e334926a5d0ee22cc1c576db767790e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfDimension",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "dimension": "dimension",
        "dimension_var": "dimensionVar",
        "equal": "equal",
        "greater_than": "greaterThan",
        "less_than": "lessThan",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfDimension:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfDimensionDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        dimension: typing.Optional[builtins.str] = None,
        dimension_var: typing.Optional[builtins.str] = None,
        equal: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfDimensionEqual", typing.Dict[builtins.str, typing.Any]]] = None,
        greater_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfDimensionGreaterThan", typing.Dict[builtins.str, typing.Any]]] = None,
        less_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfDimensionLessThan", typing.Dict[builtins.str, typing.Any]]] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param dimension: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        :param dimension_var: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        :param equal: equal block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        :param greater_than: greater_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        :param less_than: less_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        :param value: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfDimensionDefault(**default)
        if isinstance(equal, dict):
            equal = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfDimensionEqual(**equal)
        if isinstance(greater_than, dict):
            greater_than = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfDimensionGreaterThan(**greater_than)
        if isinstance(less_than, dict):
            less_than = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfDimensionLessThan(**less_than)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__96122eba667f4949913412ff132c787675dd6dfa679dad9f5ad35f9d03b2a282)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument dimension", value=dimension, expected_type=type_hints["dimension"])
            check_type(argname="argument dimension_var", value=dimension_var, expected_type=type_hints["dimension_var"])
            check_type(argname="argument equal", value=equal, expected_type=type_hints["equal"])
            check_type(argname="argument greater_than", value=greater_than, expected_type=type_hints["greater_than"])
            check_type(argname="argument less_than", value=less_than, expected_type=type_hints["less_than"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if dimension is not None:
            self._values["dimension"] = dimension
        if dimension_var is not None:
            self._values["dimension_var"] = dimension_var
        if equal is not None:
            self._values["equal"] = equal
        if greater_than is not None:
            self._values["greater_than"] = greater_than
        if less_than is not None:
            self._values["less_than"] = less_than
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfDimensionDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfDimensionDefault"], result)

    @builtins.property
    def dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        '''
        result = self._values.get("dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        '''
        result = self._values.get("dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def equal(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfDimensionEqual"]:
        '''equal block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        '''
        result = self._values.get("equal")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfDimensionEqual"], result)

    @builtins.property
    def greater_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfDimensionGreaterThan"]:
        '''greater_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        '''
        result = self._values.get("greater_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfDimensionGreaterThan"], result)

    @builtins.property
    def less_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfDimensionLessThan"]:
        '''less_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        '''
        result = self._values.get("less_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfDimensionLessThan"], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfDimension(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfDimensionDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfDimensionDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfDimensionDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfDimensionDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfDimensionDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3fca683ef02815840548c50fd56518c10bc45698a19d2b8264fabf3a3a953b94)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfDimensionDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfDimensionDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__831628e183458f235b31fe4b85ffec963e8b1bb300417ff78b00a96ad4a66f02)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfDimensionEqual",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfDimensionEqual:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfDimensionEqual(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfDimensionEqualOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfDimensionEqualOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9cc4f41da40f41b48a883083410d17292958193d709e5eb62e7a6aa47267b623)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfDimensionEqual], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfDimensionEqual],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__622ee749fd03da4cc84e4346f0d1a76ce257dde414ad1c1f387345c2f52199d9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfDimensionGreaterThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfDimensionGreaterThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfDimensionGreaterThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfDimensionGreaterThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfDimensionGreaterThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__57c0b080e50c00532e81ddaa24070d4e1e811ab9c6afd0aa2a7f78c345651673)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfDimensionGreaterThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfDimensionGreaterThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__088382abc56ab6c6395f820ad60243c5115e88083b9f5ebb8d6df633dd85c8d3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfDimensionLessThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfDimensionLessThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfDimensionLessThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfDimensionLessThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfDimensionLessThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a1db9c9adc42665b60c905bc312f124e5dbc950c20e785df031352af68e89963)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfDimensionLessThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfDimensionLessThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__24b444cd1421ecfece10df09d2739819813ea76a0d60b97d0ed2186f95d9b88d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfDimensionList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfDimensionList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__03b112cbd759d059b55e5d12b7e4ca441f8882b6c49885cb7f1923071e16ef22)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfDimensionOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__63c5eee3cf1108a9a9f9a3c13b929a8703b2c6989bd35be7c1b33f65ebe6707a)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfDimensionOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5a1141a62e8bd3e1b2b0bf9c4c5f3e4ef95bfae89e436589d67ab4e3bc0d6880)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6d0ac6aa5c172a2243770d636a21d80a7348c8d9b82096927b35ced469181b18)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__983f7f8fce98282aac9d8052f882476e8c0ffb8ec37f3dd1588af6873355ecd3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfDimension]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfDimension]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aa892d69c7b24a4b0ad3625b6078747026915fad0645e0e72614e97e76247252)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfDimensionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfDimensionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d457d645d039d253c471c3eb6889d846cffdbf3bdf162331f5a47400ed105832)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfDimensionDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putEqual")
    def put_equal(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfDimensionEqual()

        return typing.cast(None, jsii.invoke(self, "putEqual", [value]))

    @jsii.member(jsii_name="putGreaterThan")
    def put_greater_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfDimensionGreaterThan()

        return typing.cast(None, jsii.invoke(self, "putGreaterThan", [value]))

    @jsii.member(jsii_name="putLessThan")
    def put_less_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfDimensionLessThan()

        return typing.cast(None, jsii.invoke(self, "putLessThan", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetDimension")
    def reset_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimension", []))

    @jsii.member(jsii_name="resetDimensionVar")
    def reset_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimensionVar", []))

    @jsii.member(jsii_name="resetEqual")
    def reset_equal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEqual", []))

    @jsii.member(jsii_name="resetGreaterThan")
    def reset_greater_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGreaterThan", []))

    @jsii.member(jsii_name="resetLessThan")
    def reset_less_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLessThan", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfDimensionDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfDimensionDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="equal")
    def equal(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfDimensionEqualOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfDimensionEqualOutputReference, jsii.get(self, "equal"))

    @builtins.property
    @jsii.member(jsii_name="greaterThan")
    def greater_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfDimensionGreaterThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfDimensionGreaterThanOutputReference, jsii.get(self, "greaterThan"))

    @builtins.property
    @jsii.member(jsii_name="lessThan")
    def less_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfDimensionLessThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfDimensionLessThanOutputReference, jsii.get(self, "lessThan"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfDimensionDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionInput")
    def dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionVarInput")
    def dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="equalInput")
    def equal_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfDimensionEqual], jsii.get(self, "equalInput"))

    @builtins.property
    @jsii.member(jsii_name="greaterThanInput")
    def greater_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfDimensionGreaterThan], jsii.get(self, "greaterThanInput"))

    @builtins.property
    @jsii.member(jsii_name="lessThanInput")
    def less_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfDimensionLessThan], jsii.get(self, "lessThanInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="dimension")
    def dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimension"))

    @dimension.setter
    def dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a3884425bda1e23363dccb858ecd301cdc5aadad02a3eca638d72573c359ddee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimension", value)

    @builtins.property
    @jsii.member(jsii_name="dimensionVar")
    def dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimensionVar"))

    @dimension_var.setter
    def dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a0afc2c3e3bfbaad149358b4ebc38be8fbbea3d4f3b1e9ddde0e6a5b159a4f18)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df23ea2b014ba91753029093f4ef7e22e393a7532c175a03d644c2d8dadcecec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__78a57bbc16b25402914b8b96d758b642feabf8fb535e9aabf1a93d2893c880d4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfDimension]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfDimension]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfDimension]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__33222cd1f6bc5e4802835d1538ec011136c07548cdfdaf41a493ac9fe2a58a73)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfOrientation",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "landscape": "landscape",
        "portrait": "portrait",
        "square": "square",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfOrientation:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfOrientationDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        landscape: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfOrientationLandscape", typing.Dict[builtins.str, typing.Any]]] = None,
        portrait: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfOrientationPortrait", typing.Dict[builtins.str, typing.Any]]] = None,
        square: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfOrientationSquare", typing.Dict[builtins.str, typing.Any]]] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param landscape: landscape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        :param portrait: portrait block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        :param square: square block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfOrientationDefault(**default)
        if isinstance(landscape, dict):
            landscape = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfOrientationLandscape(**landscape)
        if isinstance(portrait, dict):
            portrait = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfOrientationPortrait(**portrait)
        if isinstance(square, dict):
            square = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfOrientationSquare(**square)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__583178ac0c42de626967fad0630baaad9ad58244a9d360326e474c91bf87d470)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument landscape", value=landscape, expected_type=type_hints["landscape"])
            check_type(argname="argument portrait", value=portrait, expected_type=type_hints["portrait"])
            check_type(argname="argument square", value=square, expected_type=type_hints["square"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if landscape is not None:
            self._values["landscape"] = landscape
        if portrait is not None:
            self._values["portrait"] = portrait
        if square is not None:
            self._values["square"] = square

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfOrientationDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfOrientationDefault"], result)

    @builtins.property
    def landscape(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfOrientationLandscape"]:
        '''landscape block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        '''
        result = self._values.get("landscape")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfOrientationLandscape"], result)

    @builtins.property
    def portrait(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfOrientationPortrait"]:
        '''portrait block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        '''
        result = self._values.get("portrait")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfOrientationPortrait"], result)

    @builtins.property
    def square(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfOrientationSquare"]:
        '''square block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        result = self._values.get("square")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfOrientationSquare"], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfOrientation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfOrientationDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfOrientationDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfOrientationDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfOrientationDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfOrientationDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4d9d94d7185b497052215c6b42ce4299a246f9615cf106f1a64665de1548a374)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfOrientationDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfOrientationDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c9daea9982e26431696d9a1264a6a043283829b78befb335d9ada2656032b25e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfOrientationLandscape",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfOrientationLandscape:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfOrientationLandscape(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfOrientationLandscapeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfOrientationLandscapeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__78f7b8df4f140f39bc811b2e272ee9fa43ef4e5b2498d5356d23c10c16629c06)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfOrientationLandscape], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfOrientationLandscape],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__301ace19effd3a5af9f200ced929a1e2635658ed471597668deac01e252670f8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfOrientationList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfOrientationList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a1768e3736b3aba5781dd6671b63e4f93593c19458918df3a47d4e8213ecbb55)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfOrientationOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a7fae4a5661c872264cc9bbbff6ee30f97522d5438a638f6dd39871bab4245c9)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfOrientationOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8e6dea3a9b0ff065d8f18b7e87a3117303632298fd40fbd494edc2cebc35b132)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b18a12c6b139dc5b1ff87cb7e693aa7d2b905a443e75f0300c13693c9f31c9b5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__39720d8bcc962041e4433cf45ab0dc9d41a5bdd2b8a2e9223cc57b567978b7a0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfOrientation]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfOrientation]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__67e6eeb0fc166e2dcfcd86782ebd14b970e3ef66ec04a68f771f5d8d9c9ab38f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfOrientationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfOrientationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2dd4fbfbad9f817522f1f741b8185595f314ea6f5ec545b40a5527bfe6b45caa)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfOrientationDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putLandscape")
    def put_landscape(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfOrientationLandscape()

        return typing.cast(None, jsii.invoke(self, "putLandscape", [value]))

    @jsii.member(jsii_name="putPortrait")
    def put_portrait(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfOrientationPortrait()

        return typing.cast(None, jsii.invoke(self, "putPortrait", [value]))

    @jsii.member(jsii_name="putSquare")
    def put_square(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfOrientationSquare()

        return typing.cast(None, jsii.invoke(self, "putSquare", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetLandscape")
    def reset_landscape(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLandscape", []))

    @jsii.member(jsii_name="resetPortrait")
    def reset_portrait(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPortrait", []))

    @jsii.member(jsii_name="resetSquare")
    def reset_square(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSquare", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfOrientationDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfOrientationDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="landscape")
    def landscape(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfOrientationLandscapeOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfOrientationLandscapeOutputReference, jsii.get(self, "landscape"))

    @builtins.property
    @jsii.member(jsii_name="portrait")
    def portrait(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfOrientationPortraitOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfOrientationPortraitOutputReference", jsii.get(self, "portrait"))

    @builtins.property
    @jsii.member(jsii_name="square")
    def square(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfOrientationSquareOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfOrientationSquareOutputReference", jsii.get(self, "square"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfOrientationDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="landscapeInput")
    def landscape_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfOrientationLandscape], jsii.get(self, "landscapeInput"))

    @builtins.property
    @jsii.member(jsii_name="portraitInput")
    def portrait_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfOrientationPortrait"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfOrientationPortrait"], jsii.get(self, "portraitInput"))

    @builtins.property
    @jsii.member(jsii_name="squareInput")
    def square_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfOrientationSquare"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfOrientationSquare"], jsii.get(self, "squareInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfOrientation]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfOrientation]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfOrientation]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f4955f939b761f7432be03c72ec7fdcd6836bf6e348ffc56e2668b90eeadffbb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfOrientationPortrait",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfOrientationPortrait:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfOrientationPortrait(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfOrientationPortraitOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfOrientationPortraitOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e257599298310f12c5a68dc3e08edfdb06ee78df3e47db4b710e0fe0d4b8dfb4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfOrientationPortrait]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfOrientationPortrait], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfOrientationPortrait],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__57e443541087a9639db03e6461a0426b393c55802d620b75d596699b75798672)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfOrientationSquare",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfOrientationSquare:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfOrientationSquare(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfOrientationSquareOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfOrientationSquareOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e92db97ad0204d42affa43dc4461dbcf046426cbd8f64a6730c43df61b39e122)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfOrientationSquare]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfOrientationSquare], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfOrientationSquare],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c5ff14b76572b4454156cf1c98f9f3857b991a04e74082c2a08b136a164a3874)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeMaxColors",
    jsii_struct_bases=[],
    name_mapping={"colors": "colors", "colors_var": "colorsVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeMaxColors:
    def __init__(
        self,
        *,
        colors: typing.Optional[builtins.str] = None,
        colors_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param colors: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        :param colors_var: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0385c97105b540b48aaa74e11f4879240712f1575171b82296b9aba99777362e)
            check_type(argname="argument colors", value=colors, expected_type=type_hints["colors"])
            check_type(argname="argument colors_var", value=colors_var, expected_type=type_hints["colors_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if colors is not None:
            self._values["colors"] = colors
        if colors_var is not None:
            self._values["colors_var"] = colors_var

    @builtins.property
    def colors(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        '''
        result = self._values.get("colors")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def colors_var(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        result = self._values.get("colors_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeMaxColors(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeMaxColorsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeMaxColorsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8720a2b79a84ae8ab9e50119dfec9b1d5aa96a8e6d11e0072541e1137acdce44)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeMaxColorsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d0f0f9b8f62092408a82f6defc4a9a6772444127d1edc269376988976fed855c)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeMaxColorsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4233c7056e550f0016a8261b55eb5bb5203490f2c2b0814761e81bb31f685294)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e46b44fa941c4d51263127848f31f09697668a98ec47916d080ed759dd9c8375)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6820b1b65b040a72664dc74bbffd5278cc1690dcc4112365ad2f52c8a482e8ba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeMaxColors]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeMaxColors]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d8931c2294868894aa71e9ac59b767d2b9a517bb31780e25cedc90819ad85f8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeMaxColorsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeMaxColorsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3d171caae1b3f0e83c1297bd0e53304ee89b32c70a33bca0f94d61b5ad5e1cba)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColors")
    def reset_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColors", []))

    @jsii.member(jsii_name="resetColorsVar")
    def reset_colors_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorsVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorsInput")
    def colors_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsInput"))

    @builtins.property
    @jsii.member(jsii_name="colorsVarInput")
    def colors_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsVarInput"))

    @builtins.property
    @jsii.member(jsii_name="colors")
    def colors(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colors"))

    @colors.setter
    def colors(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__03ff65bb4899869bd32105300c07f3f60d6e4c330ab599444af6c9ccdfa4f093)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colors", value)

    @builtins.property
    @jsii.member(jsii_name="colorsVar")
    def colors_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorsVar"))

    @colors_var.setter
    def colors_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fef29891c03b44d48f1e902aed92d4de62f4626ee5664b57b7f593936d6513fe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorsVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeMaxColors]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeMaxColors]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeMaxColors]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d771f69e2312cce29497b6569eaee1d30d29f78013a6d590d7885a6228b910c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeMirror",
    jsii_struct_bases=[],
    name_mapping={
        "horizontal": "horizontal",
        "horizontal_var": "horizontalVar",
        "vertical": "vertical",
        "vertical_var": "verticalVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeMirror:
    def __init__(
        self,
        *,
        horizontal: typing.Optional[builtins.str] = None,
        horizontal_var: typing.Optional[builtins.str] = None,
        vertical: typing.Optional[builtins.str] = None,
        vertical_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param horizontal: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        :param horizontal_var: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        :param vertical: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        :param vertical_var: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4d2152bd662dc10d400175830a3bccd445aaabe10546b6daf90a9aba06b35d82)
            check_type(argname="argument horizontal", value=horizontal, expected_type=type_hints["horizontal"])
            check_type(argname="argument horizontal_var", value=horizontal_var, expected_type=type_hints["horizontal_var"])
            check_type(argname="argument vertical", value=vertical, expected_type=type_hints["vertical"])
            check_type(argname="argument vertical_var", value=vertical_var, expected_type=type_hints["vertical_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if horizontal is not None:
            self._values["horizontal"] = horizontal
        if horizontal_var is not None:
            self._values["horizontal_var"] = horizontal_var
        if vertical is not None:
            self._values["vertical"] = vertical
        if vertical_var is not None:
            self._values["vertical_var"] = vertical_var

    @builtins.property
    def horizontal(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        '''
        result = self._values.get("horizontal")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def horizontal_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        '''
        result = self._values.get("horizontal_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        '''
        result = self._values.get("vertical")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        result = self._values.get("vertical_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeMirror(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeMirrorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeMirrorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__97b4f7b81beb7e764fe1ee7d734cdb305d8aef5ec837a8c64702c4629a968b4f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeMirrorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e10f672c2aef6778984ea98f79d7fdea62d2f7f615af151fb5198db690963fb4)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeMirrorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d7ab0418dbcbcf4b99979fb8eab57e95793afbcb78bff5aace82c02142a3222d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1a045bef1acc8b046f3211f290d9883a7c4d28e3b0e5ba64784862274c7e2fbf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__84bd9afc85714c32d11a3189218f10d68af94e92225ea6ec68f9c36d03258e18)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeMirror]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeMirror]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a7f7f3c633ae574676ead54c1a8c60caacc05739204dd47759ae4ea17b6ba7bc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeMirrorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeMirrorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eda941b06d7087ebf9cbb51871bf9bae3cc1ebe6db37910d1af3e32edd3fb430)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHorizontal")
    def reset_horizontal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontal", []))

    @jsii.member(jsii_name="resetHorizontalVar")
    def reset_horizontal_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontalVar", []))

    @jsii.member(jsii_name="resetVertical")
    def reset_vertical(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVertical", []))

    @jsii.member(jsii_name="resetVerticalVar")
    def reset_vertical_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVerticalVar", []))

    @builtins.property
    @jsii.member(jsii_name="horizontalInput")
    def horizontal_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontalVarInput")
    def horizontal_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalInput")
    def vertical_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalVarInput")
    def vertical_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontal")
    def horizontal(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontal"))

    @horizontal.setter
    def horizontal(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9b123e2d97cf95e9830f32dc2063a3465ac16a2fd14a2c1e047a35d5901a4bf9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontal", value)

    @builtins.property
    @jsii.member(jsii_name="horizontalVar")
    def horizontal_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontalVar"))

    @horizontal_var.setter
    def horizontal_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f1c700cac2b1927f989eddcc5af52178b0e8126c01b3ede050162b5f732df385)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontalVar", value)

    @builtins.property
    @jsii.member(jsii_name="vertical")
    def vertical(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "vertical"))

    @vertical.setter
    def vertical(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c23877e9cc8fabeccac280e55dcf09d34652eca281477eaba073915c70876c89)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "vertical", value)

    @builtins.property
    @jsii.member(jsii_name="verticalVar")
    def vertical_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "verticalVar"))

    @vertical_var.setter
    def vertical_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a3e22503a36060b60d95786088964cae42ac3052042706c6582a7cd36c212689)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "verticalVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeMirror]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeMirror]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeMirror]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__285a6c0c736db11f8ac002fe1cd539cfff7c5a7e6b0193748e9918699d075d57)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeMonoHue",
    jsii_struct_bases=[],
    name_mapping={"hue": "hue", "hue_var": "hueVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeMonoHue:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e7c90cd880dd5b21f788c7064a734119b68e135b1c3dc6f564a2c848d451bd7f)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeMonoHue(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeMonoHueList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeMonoHueList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0a0fabdbee03fd6e112b07c4e6c708b1a9c02e5315d2ffd8d6f47ec258a52f93)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeMonoHueOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fb34ea444077158040d5e5af0f846272878cf5238b1e0eca16f3b2020f46b036)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeMonoHueOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__357c0a6806ae20bdcf98395793d1140286688bd77f6c3642f32260e436c91a85)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc59185b03ec7284476ce8514d121988558e41192d213404cac19ac4259c9e5c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6595a80c3d3267f7b5ca8a9639c03cde47777ef9a4c954e19d5e1daa6629b550)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeMonoHue]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeMonoHue]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__968fddea7c5e85827c158f111aac70eafe5e4ac18c8796a46211b41c6270ce5a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeMonoHueOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeMonoHueOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea3905c1b220c63845073ab0f7438c3fe3479e9f39bcb92f13ccae34f9b38cdd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__60a8c54643406fb6adcc20f45f075b1bfcbbcc6ca5ec8330d0fd5705e9806f8a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__41938d5d931c70c66b46a838a8e96a91e1d9fcf766085df2651ad74e4db4864d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeMonoHue]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeMonoHue]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeMonoHue]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ddd29dd24cf04cdb1a9d7452335f1695077b8597fa7e2867447a505741329a02)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeOpacity",
    jsii_struct_bases=[],
    name_mapping={"opacity": "opacity", "opacity_var": "opacityVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeOpacity:
    def __init__(
        self,
        *,
        opacity: typing.Optional[builtins.str] = None,
        opacity_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param opacity: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param opacity_var: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1a2dc1d6f01363b774fe03cd5e7b9e37f692ba97a9964833854de8a5c95c5d09)
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument opacity_var", value=opacity_var, expected_type=type_hints["opacity_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if opacity is not None:
            self._values["opacity"] = opacity
        if opacity_var is not None:
            self._values["opacity_var"] = opacity_var

    @builtins.property
    def opacity(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def opacity_var(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        result = self._values.get("opacity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeOpacity(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeOpacityList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeOpacityList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cbebeb51ca810fdd7af1cd396460839a8acdba29d4bb58fccfc3d8b03c79c93a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeOpacityOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__70bb5841a2f65a00b6c1e6336a74d4e3c50159f1c1c31ea871276192f135a0be)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeOpacityOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3d2ebe6c224ee1c823c75f891c33627e2e45763108eba8c8cf8341f956670785)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ac1cfb5978326497c6e746a4f00e7a348bf01325caf9e94783c00553f4f6a1f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ebf86acb821f4550430ef37204e385d23a60ff72f55539da5a1fb4e8f738edc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeOpacity]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeOpacity]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__90ad4b2d5f32f008c31518eb7fda076e331b56f6528e6303bb893711e19c9649)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeOpacityOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeOpacityOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3f9144d531ac04a671df28e1bfea9f6792d082435338e1ecec23da0cbca01af7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetOpacityVar")
    def reset_opacity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacityVar", []))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityVarInput")
    def opacity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacity"))

    @opacity.setter
    def opacity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2e6d2ff54d76511216b0e1f011b3c31f62634a3ae95140b32c337fa8a3121f86)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacity", value)

    @builtins.property
    @jsii.member(jsii_name="opacityVar")
    def opacity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacityVar"))

    @opacity_var.setter
    def opacity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b23b3bc1ac7f2d56509a955de4c4ee1b3d84fa4b8b21be813d543388cbc43b86)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacityVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeOpacity]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeOpacity]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeOpacity]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__504919608a2a4a46d9102f0df214d4a845355ce115c9fbc77281eafee012ad1a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3aae944c278310fd60eaf9750834232d5e894e9015bc13fd446e3d4d0331c075)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putBackgroundColor")
    def put_background_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bfbf01c7d76a391f7cd8f798724c7a0fc16d4368a301ca93c736c8fff4a9da46)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBackgroundColor", [value]))

    @jsii.member(jsii_name="putBlur")
    def put_blur(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeBlur, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__06ff82b195253ae005f50e92f5e125e9a079e3fd3ea992d6ec1ce4b768b927c7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBlur", [value]))

    @jsii.member(jsii_name="putChromaKey")
    def put_chroma_key(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeChromaKey, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__47199bccfb0787ed60d340702294a936cdf7ac06d53bba5b0e6a258910217f91)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putChromaKey", [value]))

    @jsii.member(jsii_name="putComposite")
    def put_composite(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeComposite, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7c3b1566ff990e513533e843440477d0df2c2c58aa9775e157475304eaebf695)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putComposite", [value]))

    @jsii.member(jsii_name="putCompound")
    def put_compound(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeCompound, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__384474008c1bf5af6c0c43d194f97ca8511f0c527554e34c9be01a836a0cfa83)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCompound", [value]))

    @jsii.member(jsii_name="putContrast")
    def put_contrast(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeContrast, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7e5e0027741af079ec98cd98ac22516211d6d50e53d1b29dbc69876514babea2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putContrast", [value]))

    @jsii.member(jsii_name="putGoop")
    def put_goop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeGoop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9c2944f6e0a350d2ad01672ede43ff975e7683688cec73755159ff800c5bb311)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGoop", [value]))

    @jsii.member(jsii_name="putGrayscale")
    def put_grayscale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeGrayscale, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__46603c5843dc7f14e8c86a4e309c94f4f753fe2867c4c3b2a55fa88a1d9f55cd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGrayscale", [value]))

    @jsii.member(jsii_name="putHsl")
    def put_hsl(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeHsl, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f136ed95e7e452efa42553de368d3354dbf29fd1ddfe8fbd476a2229d1ffb432)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsl", [value]))

    @jsii.member(jsii_name="putHsv")
    def put_hsv(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeHsv, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2bee93dae6392732c05ab7252c5328a9419ccc1595153d8e1c11088243feb152)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsv", [value]))

    @jsii.member(jsii_name="putIfDimension")
    def put_if_dimension(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfDimension, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__54af1d05d58db9bdefd7cc4634b9914646e1d2a5bb9b3e1271a8454a6a4cbd1e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfDimension", [value]))

    @jsii.member(jsii_name="putIfOrientation")
    def put_if_orientation(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a07972f780a43f8bc56306ca0751eb100a3d829b593998b5cc8b657a0a3c8a4d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfOrientation", [value]))

    @jsii.member(jsii_name="putMaxColors")
    def put_max_colors(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeMaxColors, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__282e5f806154f49fe8ea70bdc7d8040c23db82eea3225434f447380d9a9d6f51)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMaxColors", [value]))

    @jsii.member(jsii_name="putMirror")
    def put_mirror(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeMirror, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__659a3c0c995c3dabdf4b5f4e9f9132bcb0a11ba6524076a78678727ed8086b82)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMirror", [value]))

    @jsii.member(jsii_name="putMonoHue")
    def put_mono_hue(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeMonoHue, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__17a55cfd7696d1f12c79c5079138f4fc4bfe1b2e6a251a5d9804cd6d6a161568)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMonoHue", [value]))

    @jsii.member(jsii_name="putOpacity")
    def put_opacity(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeOpacity, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__293d8eec744b420766f695080e9426d964fdb06f2e01aeb46455e5eb37fedd73)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putOpacity", [value]))

    @jsii.member(jsii_name="putRemoveColor")
    def put_remove_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeRemoveColor", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a5c7bfc76efb97e700239e456d0bc7bcc528509e9af8f48f96b4de599048a50b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRemoveColor", [value]))

    @jsii.member(jsii_name="putUnsharpMask")
    def put_unsharp_mask(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeUnsharpMask", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a36ea135a9c73404bce195a540572b86bab94c2d0218e70d30c35c48dc095e3b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putUnsharpMask", [value]))

    @jsii.member(jsii_name="resetBackgroundColor")
    def reset_background_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBackgroundColor", []))

    @jsii.member(jsii_name="resetBlur")
    def reset_blur(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBlur", []))

    @jsii.member(jsii_name="resetChromaKey")
    def reset_chroma_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChromaKey", []))

    @jsii.member(jsii_name="resetComposite")
    def reset_composite(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetComposite", []))

    @jsii.member(jsii_name="resetCompound")
    def reset_compound(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCompound", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetGoop")
    def reset_goop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGoop", []))

    @jsii.member(jsii_name="resetGrayscale")
    def reset_grayscale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGrayscale", []))

    @jsii.member(jsii_name="resetHsl")
    def reset_hsl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsl", []))

    @jsii.member(jsii_name="resetHsv")
    def reset_hsv(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsv", []))

    @jsii.member(jsii_name="resetIfDimension")
    def reset_if_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfDimension", []))

    @jsii.member(jsii_name="resetIfOrientation")
    def reset_if_orientation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfOrientation", []))

    @jsii.member(jsii_name="resetMaxColors")
    def reset_max_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxColors", []))

    @jsii.member(jsii_name="resetMirror")
    def reset_mirror(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMirror", []))

    @jsii.member(jsii_name="resetMonoHue")
    def reset_mono_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonoHue", []))

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetRemoveColor")
    def reset_remove_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRemoveColor", []))

    @jsii.member(jsii_name="resetUnsharpMask")
    def reset_unsharp_mask(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUnsharpMask", []))

    @builtins.property
    @jsii.member(jsii_name="backgroundColor")
    def background_color(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeBackgroundColorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeBackgroundColorList, jsii.get(self, "backgroundColor"))

    @builtins.property
    @jsii.member(jsii_name="blur")
    def blur(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeBlurList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeBlurList, jsii.get(self, "blur"))

    @builtins.property
    @jsii.member(jsii_name="chromaKey")
    def chroma_key(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeChromaKeyList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeChromaKeyList, jsii.get(self, "chromaKey"))

    @builtins.property
    @jsii.member(jsii_name="composite")
    def composite(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeCompositeList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeCompositeList, jsii.get(self, "composite"))

    @builtins.property
    @jsii.member(jsii_name="compound")
    def compound(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeCompoundList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeCompoundList, jsii.get(self, "compound"))

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeContrastList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeContrastList, jsii.get(self, "contrast"))

    @builtins.property
    @jsii.member(jsii_name="goop")
    def goop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeGoopList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeGoopList, jsii.get(self, "goop"))

    @builtins.property
    @jsii.member(jsii_name="grayscale")
    def grayscale(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeGrayscaleList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeGrayscaleList, jsii.get(self, "grayscale"))

    @builtins.property
    @jsii.member(jsii_name="hsl")
    def hsl(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeHslList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeHslList, jsii.get(self, "hsl"))

    @builtins.property
    @jsii.member(jsii_name="hsv")
    def hsv(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeHsvList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeHsvList, jsii.get(self, "hsv"))

    @builtins.property
    @jsii.member(jsii_name="ifDimension")
    def if_dimension(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfDimensionList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfDimensionList, jsii.get(self, "ifDimension"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientation")
    def if_orientation(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfOrientationList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfOrientationList, jsii.get(self, "ifOrientation"))

    @builtins.property
    @jsii.member(jsii_name="maxColors")
    def max_colors(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeMaxColorsList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeMaxColorsList, jsii.get(self, "maxColors"))

    @builtins.property
    @jsii.member(jsii_name="mirror")
    def mirror(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeMirrorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeMirrorList, jsii.get(self, "mirror"))

    @builtins.property
    @jsii.member(jsii_name="monoHue")
    def mono_hue(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeMonoHueList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeMonoHueList, jsii.get(self, "monoHue"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeOpacityList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeOpacityList, jsii.get(self, "opacity"))

    @builtins.property
    @jsii.member(jsii_name="removeColor")
    def remove_color(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeRemoveColorList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeRemoveColorList", jsii.get(self, "removeColor"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMask")
    def unsharp_mask(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeUnsharpMaskList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeUnsharpMaskList", jsii.get(self, "unsharpMask"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColorInput")
    def background_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeBackgroundColor]]], jsii.get(self, "backgroundColorInput"))

    @builtins.property
    @jsii.member(jsii_name="blurInput")
    def blur_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeBlur]]], jsii.get(self, "blurInput"))

    @builtins.property
    @jsii.member(jsii_name="chromaKeyInput")
    def chroma_key_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeChromaKey]]], jsii.get(self, "chromaKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="compositeInput")
    def composite_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeComposite]]], jsii.get(self, "compositeInput"))

    @builtins.property
    @jsii.member(jsii_name="compoundInput")
    def compound_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeCompound]]], jsii.get(self, "compoundInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeContrast]]], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="goopInput")
    def goop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeGoop]]], jsii.get(self, "goopInput"))

    @builtins.property
    @jsii.member(jsii_name="grayscaleInput")
    def grayscale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeGrayscale]]], jsii.get(self, "grayscaleInput"))

    @builtins.property
    @jsii.member(jsii_name="hslInput")
    def hsl_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeHsl]]], jsii.get(self, "hslInput"))

    @builtins.property
    @jsii.member(jsii_name="hsvInput")
    def hsv_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeHsv]]], jsii.get(self, "hsvInput"))

    @builtins.property
    @jsii.member(jsii_name="ifDimensionInput")
    def if_dimension_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfDimension]]], jsii.get(self, "ifDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientationInput")
    def if_orientation_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfOrientation]]], jsii.get(self, "ifOrientationInput"))

    @builtins.property
    @jsii.member(jsii_name="maxColorsInput")
    def max_colors_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeMaxColors]]], jsii.get(self, "maxColorsInput"))

    @builtins.property
    @jsii.member(jsii_name="mirrorInput")
    def mirror_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeMirror]]], jsii.get(self, "mirrorInput"))

    @builtins.property
    @jsii.member(jsii_name="monoHueInput")
    def mono_hue_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeMonoHue]]], jsii.get(self, "monoHueInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeOpacity]]], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="removeColorInput")
    def remove_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeRemoveColor"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeRemoveColor"]]], jsii.get(self, "removeColorInput"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMaskInput")
    def unsharp_mask_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeUnsharpMask"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeUnsharpMask"]]], jsii.get(self, "unsharpMaskInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscape], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscape],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb4c58ce2eea82dbf053e88eb0915fc4a1ad433854b8283356b061c31338be02)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeRemoveColor",
    jsii_struct_bases=[],
    name_mapping={
        "color": "color",
        "color_var": "colorVar",
        "feather": "feather",
        "feather_var": "featherVar",
        "tolerance": "tolerance",
        "tolerance_var": "toleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeRemoveColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
        feather: typing.Optional[builtins.str] = None,
        feather_var: typing.Optional[builtins.str] = None,
        tolerance: typing.Optional[builtins.str] = None,
        tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        :param feather: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        :param feather_var: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        :param tolerance: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        :param tolerance_var: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__683c83ecb35a6b59cca3f44144c6c0ae8a260051c485fdd347627a89194b8c65)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
            check_type(argname="argument feather", value=feather, expected_type=type_hints["feather"])
            check_type(argname="argument feather_var", value=feather_var, expected_type=type_hints["feather_var"])
            check_type(argname="argument tolerance", value=tolerance, expected_type=type_hints["tolerance"])
            check_type(argname="argument tolerance_var", value=tolerance_var, expected_type=type_hints["tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var
        if feather is not None:
            self._values["feather"] = feather
        if feather_var is not None:
            self._values["feather_var"] = feather_var
        if tolerance is not None:
            self._values["tolerance"] = tolerance
        if tolerance_var is not None:
            self._values["tolerance_var"] = tolerance_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        '''
        result = self._values.get("feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather_var(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        '''
        result = self._values.get("feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        '''
        result = self._values.get("tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance_var(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        result = self._values.get("tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeRemoveColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeRemoveColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeRemoveColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__470eade09498e8b55bc7819b43a807a45c46217094a05f55f832141a75800672)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeRemoveColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__91731389016b722e8d643fa3f3edc04869c56e2091017272fb0e20fae6b7fd9c)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeRemoveColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__840f0f67169c582f0dcc28970dd00bc1c1187173a8d6ca6ad0d4be763819bef6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b7cefcbaf418519205ad8812f3820a1a1058ec5220371f3227ff4f59eab6079c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1559bb09353312ee976695cfed6b0e375ceb1e1ad79c64b0d7d37ae9eda935a7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeRemoveColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeRemoveColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeRemoveColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__830afb23def1c124b5eb115e4c903e25df378740406495ef47de443a1817db70)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeRemoveColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeRemoveColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cfb108b20fa71963459176d04f7de1a32597a078c11649c8add7838f417ff31b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @jsii.member(jsii_name="resetFeather")
    def reset_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeather", []))

    @jsii.member(jsii_name="resetFeatherVar")
    def reset_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatherVar", []))

    @jsii.member(jsii_name="resetTolerance")
    def reset_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTolerance", []))

    @jsii.member(jsii_name="resetToleranceVar")
    def reset_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featherInput")
    def feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherInput"))

    @builtins.property
    @jsii.member(jsii_name="featherVarInput")
    def feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceInput")
    def tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceVarInput")
    def tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9fdaa71fa328d8256bbb24588b737910829d01f2ce75409492e3b4c0407f0bdf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__19117757725fe870d059a2405068c05d02f74bc487faf83a00ffc0dc8ebdfba0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="feather")
    def feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "feather"))

    @feather.setter
    def feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b214a0f361fd3ce6b56eb4c8c58fae57e1e1c5882cba69c222bed6218c65a141)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "feather", value)

    @builtins.property
    @jsii.member(jsii_name="featherVar")
    def feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featherVar"))

    @feather_var.setter
    def feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f2bb6d97f5e31c25f772d6e537bee8c7ee41904b4a56f51ed3880451e77f4ec5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featherVar", value)

    @builtins.property
    @jsii.member(jsii_name="tolerance")
    def tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tolerance"))

    @tolerance.setter
    def tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f76ec517bb654e14a107b287bc09b903957b32cf0bc45be3ac33a52221b77194)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tolerance", value)

    @builtins.property
    @jsii.member(jsii_name="toleranceVar")
    def tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "toleranceVar"))

    @tolerance_var.setter
    def tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__28af722ce4ff0326a865f13041ed394aef1d76b8694c531246bf316605fc4fe6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "toleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeRemoveColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeRemoveColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeRemoveColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1b0739205b5b46c477e468bfba5984f6c9c4ce716623dc0d71568d34d0f0fe31)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeUnsharpMask",
    jsii_struct_bases=[],
    name_mapping={
        "gain": "gain",
        "gain_var": "gainVar",
        "sigma": "sigma",
        "sigma_var": "sigmaVar",
        "threshold": "threshold",
        "threshold_var": "thresholdVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeUnsharpMask:
    def __init__(
        self,
        *,
        gain: typing.Optional[builtins.str] = None,
        gain_var: typing.Optional[builtins.str] = None,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
        threshold: typing.Optional[builtins.str] = None,
        threshold_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param gain: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        :param gain_var: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        :param sigma: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        :param threshold: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        :param threshold_var: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b567c20cdca9641d6c6520da9cdb90818c158cf915de3d259149418ddc635876)
            check_type(argname="argument gain", value=gain, expected_type=type_hints["gain"])
            check_type(argname="argument gain_var", value=gain_var, expected_type=type_hints["gain_var"])
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
            check_type(argname="argument threshold", value=threshold, expected_type=type_hints["threshold"])
            check_type(argname="argument threshold_var", value=threshold_var, expected_type=type_hints["threshold_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if gain is not None:
            self._values["gain"] = gain
        if gain_var is not None:
            self._values["gain_var"] = gain_var
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var
        if threshold is not None:
            self._values["threshold"] = threshold
        if threshold_var is not None:
            self._values["threshold_var"] = threshold_var

    @builtins.property
    def gain(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        '''
        result = self._values.get("gain")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gain_var(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        '''
        result = self._values.get("gain_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        '''
        result = self._values.get("threshold")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold_var(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        result = self._values.get("threshold_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeUnsharpMask(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeUnsharpMaskList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeUnsharpMaskList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2163a2ab82f5a26a19b761e1d9e1429a733dd5607b6b93c1ce3d23cb6d4139f7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeUnsharpMaskOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__caac77bd9332127cd411ed86752862a07d58af8572ffa48f2953f4e7b1938cf0)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeUnsharpMaskOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cfd28fbdf7200955435429dea15c79c5504e39ae7f8fd4afd0a11a160f1498be)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3c50636c2c430a1e0444612fea763697343a90a02b329e42bb5ee00709cd4d77)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d11f09edac3d3910c9ec7b00562c1977fef5f6ceca3e50edf470540c8310b0a1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeUnsharpMask]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeUnsharpMask]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeUnsharpMask]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b7950538f436bda049841fda222beeb919d2a31bb07f277357fb831d552e5215)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeUnsharpMaskOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeUnsharpMaskOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bf65ba93aae467c2ae4979d31ed7fc414cafc9f39af1164a158db4a6f77f7691)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetGain")
    def reset_gain(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGain", []))

    @jsii.member(jsii_name="resetGainVar")
    def reset_gain_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGainVar", []))

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @jsii.member(jsii_name="resetThreshold")
    def reset_threshold(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThreshold", []))

    @jsii.member(jsii_name="resetThresholdVar")
    def reset_threshold_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThresholdVar", []))

    @builtins.property
    @jsii.member(jsii_name="gainInput")
    def gain_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainInput"))

    @builtins.property
    @jsii.member(jsii_name="gainVarInput")
    def gain_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdInput")
    def threshold_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdVarInput")
    def threshold_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gain")
    def gain(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gain"))

    @gain.setter
    def gain(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0145762261fc5039c49b68df671ef2f114c0e8c3d08db1bee6422f3ef5cd7df8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gain", value)

    @builtins.property
    @jsii.member(jsii_name="gainVar")
    def gain_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gainVar"))

    @gain_var.setter
    def gain_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d2833f2d63e8044dde86d21d2ab12c417fa35fc6e9986c9f532c9222b2130ea0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gainVar", value)

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5c6b9778495335fbdcf1e1be1e41ec458c91f9816a736f06a88c6ccf68b72556)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__719de5c2d65bfda2a1c18333d1fe79c9e33753cb79a04e26595163d5bbdbda8a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="threshold")
    def threshold(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "threshold"))

    @threshold.setter
    def threshold(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cc2d330d813d2e5ec2b1a9bb783c1f8c9bc21f9fcb8f796026a883a7c4bda35e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "threshold", value)

    @builtins.property
    @jsii.member(jsii_name="thresholdVar")
    def threshold_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "thresholdVar"))

    @threshold_var.setter
    def threshold_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__59bc5a1d8d7b880193e631c29122dd9b5770f02e2750994fd71ac6b5597cff2b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "thresholdVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeUnsharpMask]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeUnsharpMask]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeUnsharpMask]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bd7147ab15882c9648ceec89f5e724e05ae4cc92e747159fcc2495162ea082f4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c580c193ab339df9b6194ce03b83d5bc5f5f4bfd216354a8262bdef953fe24a2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0cb655c712e3c43d1044a4e18c99c2044110f7a1f901da9b362a488fb32152db)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ae5b22a927a742e77f7a35f3bc688492d7bc3498945459309705a143c967a0a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dcea2a95c76c6057c0fbf2cd4ffc955cae9146007f0b91eed478c69633f65f83)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fcd05c2138fcdcf51a49b7838767d261f6f97190ccaa315d6c7e209d334ce30f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientation]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientation]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__faee4a443ad525904bd614181be081a832959b7af57583d7e6c6cf3f814831fe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fb731bff5072687eea3cbb77c1f7e2689706fb46515d8543664b09f0bb76d9cc)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(
        self,
        *,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefault(
            background_color=background_color,
            blur=blur,
            chroma_key=chroma_key,
            composite=composite,
            compound=compound,
            contrast=contrast,
            goop=goop,
            grayscale=grayscale,
            hsl=hsl,
            hsv=hsv,
            if_dimension=if_dimension,
            if_orientation=if_orientation,
            max_colors=max_colors,
            mirror=mirror,
            mono_hue=mono_hue,
            opacity=opacity,
            remove_color=remove_color,
            unsharp_mask=unsharp_mask,
        )

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putLandscape")
    def put_landscape(
        self,
        *,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscape(
            background_color=background_color,
            blur=blur,
            chroma_key=chroma_key,
            composite=composite,
            compound=compound,
            contrast=contrast,
            goop=goop,
            grayscale=grayscale,
            hsl=hsl,
            hsv=hsv,
            if_dimension=if_dimension,
            if_orientation=if_orientation,
            max_colors=max_colors,
            mirror=mirror,
            mono_hue=mono_hue,
            opacity=opacity,
            remove_color=remove_color,
            unsharp_mask=unsharp_mask,
        )

        return typing.cast(None, jsii.invoke(self, "putLandscape", [value]))

    @jsii.member(jsii_name="putPortrait")
    def put_portrait(
        self,
        *,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitBackgroundColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitBlur", typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitChromaKey", typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitComposite", typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitCompound", typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitContrast", typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitGoop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitGrayscale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitHsl", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitHsv", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfDimension", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfOrientation", typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitMaxColors", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitMirror", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitMonoHue", typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitOpacity", typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitRemoveColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitUnsharpMask", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortrait(
            background_color=background_color,
            blur=blur,
            chroma_key=chroma_key,
            composite=composite,
            compound=compound,
            contrast=contrast,
            goop=goop,
            grayscale=grayscale,
            hsl=hsl,
            hsv=hsv,
            if_dimension=if_dimension,
            if_orientation=if_orientation,
            max_colors=max_colors,
            mirror=mirror,
            mono_hue=mono_hue,
            opacity=opacity,
            remove_color=remove_color,
            unsharp_mask=unsharp_mask,
        )

        return typing.cast(None, jsii.invoke(self, "putPortrait", [value]))

    @jsii.member(jsii_name="putSquare")
    def put_square(
        self,
        *,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareBackgroundColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareBlur", typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareChromaKey", typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareComposite", typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareCompound", typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareContrast", typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareGoop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareGrayscale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareHsl", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareHsv", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfDimension", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfOrientation", typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareMaxColors", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareMirror", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareMonoHue", typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareOpacity", typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareRemoveColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareUnsharpMask", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquare(
            background_color=background_color,
            blur=blur,
            chroma_key=chroma_key,
            composite=composite,
            compound=compound,
            contrast=contrast,
            goop=goop,
            grayscale=grayscale,
            hsl=hsl,
            hsv=hsv,
            if_dimension=if_dimension,
            if_orientation=if_orientation,
            max_colors=max_colors,
            mirror=mirror,
            mono_hue=mono_hue,
            opacity=opacity,
            remove_color=remove_color,
            unsharp_mask=unsharp_mask,
        )

        return typing.cast(None, jsii.invoke(self, "putSquare", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetLandscape")
    def reset_landscape(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLandscape", []))

    @jsii.member(jsii_name="resetPortrait")
    def reset_portrait(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPortrait", []))

    @jsii.member(jsii_name="resetSquare")
    def reset_square(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSquare", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="landscape")
    def landscape(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeOutputReference, jsii.get(self, "landscape"))

    @builtins.property
    @jsii.member(jsii_name="portrait")
    def portrait(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitOutputReference", jsii.get(self, "portrait"))

    @builtins.property
    @jsii.member(jsii_name="square")
    def square(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareOutputReference", jsii.get(self, "square"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="landscapeInput")
    def landscape_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscape], jsii.get(self, "landscapeInput"))

    @builtins.property
    @jsii.member(jsii_name="portraitInput")
    def portrait_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortrait"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortrait"], jsii.get(self, "portraitInput"))

    @builtins.property
    @jsii.member(jsii_name="squareInput")
    def square_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquare"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquare"], jsii.get(self, "squareInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientation]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientation]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientation]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__97bd561364abc4ba59624763d34354693f1f0e7cf62222ff234102a45b052ab6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortrait",
    jsii_struct_bases=[],
    name_mapping={
        "background_color": "backgroundColor",
        "blur": "blur",
        "chroma_key": "chromaKey",
        "composite": "composite",
        "compound": "compound",
        "contrast": "contrast",
        "goop": "goop",
        "grayscale": "grayscale",
        "hsl": "hsl",
        "hsv": "hsv",
        "if_dimension": "ifDimension",
        "if_orientation": "ifOrientation",
        "max_colors": "maxColors",
        "mirror": "mirror",
        "mono_hue": "monoHue",
        "opacity": "opacity",
        "remove_color": "removeColor",
        "unsharp_mask": "unsharpMask",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortrait:
    def __init__(
        self,
        *,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitBackgroundColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitBlur", typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitChromaKey", typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitComposite", typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitCompound", typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitContrast", typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitGoop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitGrayscale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitHsl", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitHsv", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfDimension", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfOrientation", typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitMaxColors", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitMirror", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitMonoHue", typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitOpacity", typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitRemoveColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitUnsharpMask", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__942f97ab6fbd22d8e623587ef897ce758afcccdb70bfbeb41669ea63a21877d0)
            check_type(argname="argument background_color", value=background_color, expected_type=type_hints["background_color"])
            check_type(argname="argument blur", value=blur, expected_type=type_hints["blur"])
            check_type(argname="argument chroma_key", value=chroma_key, expected_type=type_hints["chroma_key"])
            check_type(argname="argument composite", value=composite, expected_type=type_hints["composite"])
            check_type(argname="argument compound", value=compound, expected_type=type_hints["compound"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument goop", value=goop, expected_type=type_hints["goop"])
            check_type(argname="argument grayscale", value=grayscale, expected_type=type_hints["grayscale"])
            check_type(argname="argument hsl", value=hsl, expected_type=type_hints["hsl"])
            check_type(argname="argument hsv", value=hsv, expected_type=type_hints["hsv"])
            check_type(argname="argument if_dimension", value=if_dimension, expected_type=type_hints["if_dimension"])
            check_type(argname="argument if_orientation", value=if_orientation, expected_type=type_hints["if_orientation"])
            check_type(argname="argument max_colors", value=max_colors, expected_type=type_hints["max_colors"])
            check_type(argname="argument mirror", value=mirror, expected_type=type_hints["mirror"])
            check_type(argname="argument mono_hue", value=mono_hue, expected_type=type_hints["mono_hue"])
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument remove_color", value=remove_color, expected_type=type_hints["remove_color"])
            check_type(argname="argument unsharp_mask", value=unsharp_mask, expected_type=type_hints["unsharp_mask"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if background_color is not None:
            self._values["background_color"] = background_color
        if blur is not None:
            self._values["blur"] = blur
        if chroma_key is not None:
            self._values["chroma_key"] = chroma_key
        if composite is not None:
            self._values["composite"] = composite
        if compound is not None:
            self._values["compound"] = compound
        if contrast is not None:
            self._values["contrast"] = contrast
        if goop is not None:
            self._values["goop"] = goop
        if grayscale is not None:
            self._values["grayscale"] = grayscale
        if hsl is not None:
            self._values["hsl"] = hsl
        if hsv is not None:
            self._values["hsv"] = hsv
        if if_dimension is not None:
            self._values["if_dimension"] = if_dimension
        if if_orientation is not None:
            self._values["if_orientation"] = if_orientation
        if max_colors is not None:
            self._values["max_colors"] = max_colors
        if mirror is not None:
            self._values["mirror"] = mirror
        if mono_hue is not None:
            self._values["mono_hue"] = mono_hue
        if opacity is not None:
            self._values["opacity"] = opacity
        if remove_color is not None:
            self._values["remove_color"] = remove_color
        if unsharp_mask is not None:
            self._values["unsharp_mask"] = unsharp_mask

    @builtins.property
    def background_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitBackgroundColor"]]]:
        '''background_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        '''
        result = self._values.get("background_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitBackgroundColor"]]], result)

    @builtins.property
    def blur(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitBlur"]]]:
        '''blur block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        '''
        result = self._values.get("blur")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitBlur"]]], result)

    @builtins.property
    def chroma_key(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitChromaKey"]]]:
        '''chroma_key block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        '''
        result = self._values.get("chroma_key")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitChromaKey"]]], result)

    @builtins.property
    def composite(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitComposite"]]]:
        '''composite block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        '''
        result = self._values.get("composite")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitComposite"]]], result)

    @builtins.property
    def compound(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitCompound"]]]:
        '''compound block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        '''
        result = self._values.get("compound")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitCompound"]]], result)

    @builtins.property
    def contrast(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitContrast"]]]:
        '''contrast block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitContrast"]]], result)

    @builtins.property
    def goop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitGoop"]]]:
        '''goop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        '''
        result = self._values.get("goop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitGoop"]]], result)

    @builtins.property
    def grayscale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitGrayscale"]]]:
        '''grayscale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        '''
        result = self._values.get("grayscale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitGrayscale"]]], result)

    @builtins.property
    def hsl(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitHsl"]]]:
        '''hsl block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        '''
        result = self._values.get("hsl")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitHsl"]]], result)

    @builtins.property
    def hsv(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitHsv"]]]:
        '''hsv block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        '''
        result = self._values.get("hsv")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitHsv"]]], result)

    @builtins.property
    def if_dimension(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfDimension"]]]:
        '''if_dimension block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        '''
        result = self._values.get("if_dimension")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfDimension"]]], result)

    @builtins.property
    def if_orientation(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfOrientation"]]]:
        '''if_orientation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        '''
        result = self._values.get("if_orientation")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfOrientation"]]], result)

    @builtins.property
    def max_colors(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitMaxColors"]]]:
        '''max_colors block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        '''
        result = self._values.get("max_colors")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitMaxColors"]]], result)

    @builtins.property
    def mirror(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitMirror"]]]:
        '''mirror block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        '''
        result = self._values.get("mirror")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitMirror"]]], result)

    @builtins.property
    def mono_hue(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitMonoHue"]]]:
        '''mono_hue block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        '''
        result = self._values.get("mono_hue")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitMonoHue"]]], result)

    @builtins.property
    def opacity(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitOpacity"]]]:
        '''opacity block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitOpacity"]]], result)

    @builtins.property
    def remove_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitRemoveColor"]]]:
        '''remove_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        '''
        result = self._values.get("remove_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitRemoveColor"]]], result)

    @builtins.property
    def unsharp_mask(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitUnsharpMask"]]]:
        '''unsharp_mask block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        result = self._values.get("unsharp_mask")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitUnsharpMask"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortrait(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitBackgroundColor",
    jsii_struct_bases=[],
    name_mapping={"color": "color", "color_var": "colorVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitBackgroundColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ccc73246e9f9ccfc5a7d16c1be32091c21c1ab7453ca5e5164051a1229e731b)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitBackgroundColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitBackgroundColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitBackgroundColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5de58daf0d530678451ed8ad0d932ef9cafc978fa7d167dee4a40bb0082f7212)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitBackgroundColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d0e5c2ce6eec4a679030a2a3ecbbb700db8fece8041e3019e58319e61f012b7c)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitBackgroundColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ed18aab7668a01e122195a9e21678c2e4e7100e60985a3e9724a11ea9389bd60)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__abbb2401cf8469d03fce7f3d8e1bcdf9f1625d1d563b1b0a19626b0260864416)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__baeed38b45ff6318a77bc2a9595c2e2bbdbdc0e1a8e652b6cb0fc98434c7ddad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitBackgroundColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitBackgroundColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f3e8d69aa2bc8440035a3fb3df7e1fce69ac92c01fd6d68ece9e502df37e569f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitBackgroundColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitBackgroundColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fe927e42a0700f1412a7234352a356724df1e67ed0510185a8125c010cd5d438)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f0a2c483663f9906bec0ca905f4c5b0a0ff70d470df13093d144fbf0b76ae269)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2b1986cd2cc2e8106eb5fb8a083aed67b9d4562cf7c7cf918fff51005f5b3e4d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitBackgroundColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitBackgroundColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitBackgroundColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b0ca64e269fa38c00f6a4a2f17fd4f50c3bdbfb9402c82daa4908ae84a7657f6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitBlur",
    jsii_struct_bases=[],
    name_mapping={"sigma": "sigma", "sigma_var": "sigmaVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitBlur:
    def __init__(
        self,
        *,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param sigma: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2daeb6fb3866f59dab8a975cc1fc0195d9f198343ca144b8379abce43ceb2a50)
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitBlur(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitBlurList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitBlurList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4d1fc936da646a2246e2f16523011e9311a9094075480997a3db0f858616ef73)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitBlurOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b4577ab0f2e9ed74f72fd1c57eae732ed4b3a8629fd5fc8ea07d52879a6d6955)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitBlurOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8928c97341c3e15a7509e23389cc42af7f10feb49826d0f5819b4e99c9f0a774)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d34fdad195afa5ea4feb106ab4ed4dace300f6aa9b9ab8c7c20daa232bfc75c5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__daf9d3965116b37a7a45fcac23469f76684a01609903e08558133c1379ef0335)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitBlur]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitBlur]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2645807a81d3a0a8a2ace914e8f24bb28906aadfe8cfda1fc874ff0d23ae32d1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitBlurOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitBlurOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9f26ecb14c1d33d24b64aec86f6128a54a64173d8068bcf6b21139187454d662)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bfed10ad345ea729ee2143fed225bc3e0ddd889d2e9de66fefecf09793a70699)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__27bee2ddcde0e0247906d404dde9562e24f110c391ab8957a544d161797591b4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitBlur]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitBlur]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitBlur]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0deb93cf980534b7db2748a6b38a8d6206fcbf733421cc8f68259b7c0edd704f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitChromaKey",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_feather": "hueFeather",
        "hue_feather_var": "hueFeatherVar",
        "hue_tolerance": "hueTolerance",
        "hue_tolerance_var": "hueToleranceVar",
        "hue_var": "hueVar",
        "lightness_feather": "lightnessFeather",
        "lightness_feather_var": "lightnessFeatherVar",
        "lightness_tolerance": "lightnessTolerance",
        "lightness_tolerance_var": "lightnessToleranceVar",
        "saturation_feather": "saturationFeather",
        "saturation_feather_var": "saturationFeatherVar",
        "saturation_tolerance": "saturationTolerance",
        "saturation_tolerance_var": "saturationToleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitChromaKey:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_feather: typing.Optional[builtins.str] = None,
        hue_feather_var: typing.Optional[builtins.str] = None,
        hue_tolerance: typing.Optional[builtins.str] = None,
        hue_tolerance_var: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness_feather: typing.Optional[builtins.str] = None,
        lightness_feather_var: typing.Optional[builtins.str] = None,
        lightness_tolerance: typing.Optional[builtins.str] = None,
        lightness_tolerance_var: typing.Optional[builtins.str] = None,
        saturation_feather: typing.Optional[builtins.str] = None,
        saturation_feather_var: typing.Optional[builtins.str] = None,
        saturation_tolerance: typing.Optional[builtins.str] = None,
        saturation_tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_feather: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        :param hue_feather_var: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        :param hue_tolerance: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        :param hue_tolerance_var: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        :param hue_var: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness_feather: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        :param lightness_feather_var: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        :param lightness_tolerance: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        :param lightness_tolerance_var: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        :param saturation_feather: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        :param saturation_feather_var: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        :param saturation_tolerance: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        :param saturation_tolerance_var: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4c7804aab33ee264a5eb73998829b8a298d753b39fa2600de5f00e5db0bd489a)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_feather", value=hue_feather, expected_type=type_hints["hue_feather"])
            check_type(argname="argument hue_feather_var", value=hue_feather_var, expected_type=type_hints["hue_feather_var"])
            check_type(argname="argument hue_tolerance", value=hue_tolerance, expected_type=type_hints["hue_tolerance"])
            check_type(argname="argument hue_tolerance_var", value=hue_tolerance_var, expected_type=type_hints["hue_tolerance_var"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness_feather", value=lightness_feather, expected_type=type_hints["lightness_feather"])
            check_type(argname="argument lightness_feather_var", value=lightness_feather_var, expected_type=type_hints["lightness_feather_var"])
            check_type(argname="argument lightness_tolerance", value=lightness_tolerance, expected_type=type_hints["lightness_tolerance"])
            check_type(argname="argument lightness_tolerance_var", value=lightness_tolerance_var, expected_type=type_hints["lightness_tolerance_var"])
            check_type(argname="argument saturation_feather", value=saturation_feather, expected_type=type_hints["saturation_feather"])
            check_type(argname="argument saturation_feather_var", value=saturation_feather_var, expected_type=type_hints["saturation_feather_var"])
            check_type(argname="argument saturation_tolerance", value=saturation_tolerance, expected_type=type_hints["saturation_tolerance"])
            check_type(argname="argument saturation_tolerance_var", value=saturation_tolerance_var, expected_type=type_hints["saturation_tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_feather is not None:
            self._values["hue_feather"] = hue_feather
        if hue_feather_var is not None:
            self._values["hue_feather_var"] = hue_feather_var
        if hue_tolerance is not None:
            self._values["hue_tolerance"] = hue_tolerance
        if hue_tolerance_var is not None:
            self._values["hue_tolerance_var"] = hue_tolerance_var
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness_feather is not None:
            self._values["lightness_feather"] = lightness_feather
        if lightness_feather_var is not None:
            self._values["lightness_feather_var"] = lightness_feather_var
        if lightness_tolerance is not None:
            self._values["lightness_tolerance"] = lightness_tolerance
        if lightness_tolerance_var is not None:
            self._values["lightness_tolerance_var"] = lightness_tolerance_var
        if saturation_feather is not None:
            self._values["saturation_feather"] = saturation_feather
        if saturation_feather_var is not None:
            self._values["saturation_feather_var"] = saturation_feather_var
        if saturation_tolerance is not None:
            self._values["saturation_tolerance"] = saturation_tolerance
        if saturation_tolerance_var is not None:
            self._values["saturation_tolerance_var"] = saturation_tolerance_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        '''
        result = self._values.get("hue_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        '''
        result = self._values.get("hue_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        '''
        result = self._values.get("hue_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        '''
        result = self._values.get("hue_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        '''
        result = self._values.get("lightness_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        '''
        result = self._values.get("lightness_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        '''
        result = self._values.get("lightness_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        '''
        result = self._values.get("lightness_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        '''
        result = self._values.get("saturation_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        '''
        result = self._values.get("saturation_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        '''
        result = self._values.get("saturation_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        result = self._values.get("saturation_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitChromaKey(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitChromaKeyList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitChromaKeyList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b9eaba923e72866d669bc7091d8c1f6cd1b6aa162dc100f0be2855cab30bce8c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitChromaKeyOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0b5b47e54d8822c1a89bf455621d739099882a9f3df23c18ac617968aa7d4f53)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitChromaKeyOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__566b3a300f560044f3189ab212016a77dfe645065fabf7c681613e38606a85ce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7c37cbcf1d75924c839ae75796872a7046a20e5a5e6531a57d9b0aec644ddca2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__830e2624706e5312e671894947b5ea9bd2956aa3552012c141166032c5cd13bb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitChromaKey]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitChromaKey]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c3d0f106a5287f93ebfc519cb39a90a393fec512ef07de5b7c990eb2d05aa42b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitChromaKeyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitChromaKeyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ae272248c224f609f7ab3e2e49241987d8f2f83b7d94a295bba489f325bdae4d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueFeather")
    def reset_hue_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeather", []))

    @jsii.member(jsii_name="resetHueFeatherVar")
    def reset_hue_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeatherVar", []))

    @jsii.member(jsii_name="resetHueTolerance")
    def reset_hue_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueTolerance", []))

    @jsii.member(jsii_name="resetHueToleranceVar")
    def reset_hue_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueToleranceVar", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightnessFeather")
    def reset_lightness_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeather", []))

    @jsii.member(jsii_name="resetLightnessFeatherVar")
    def reset_lightness_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeatherVar", []))

    @jsii.member(jsii_name="resetLightnessTolerance")
    def reset_lightness_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessTolerance", []))

    @jsii.member(jsii_name="resetLightnessToleranceVar")
    def reset_lightness_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessToleranceVar", []))

    @jsii.member(jsii_name="resetSaturationFeather")
    def reset_saturation_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeather", []))

    @jsii.member(jsii_name="resetSaturationFeatherVar")
    def reset_saturation_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeatherVar", []))

    @jsii.member(jsii_name="resetSaturationTolerance")
    def reset_saturation_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationTolerance", []))

    @jsii.member(jsii_name="resetSaturationToleranceVar")
    def reset_saturation_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherInput")
    def hue_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVarInput")
    def hue_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceInput")
    def hue_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVarInput")
    def hue_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherInput")
    def lightness_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVarInput")
    def lightness_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceInput")
    def lightness_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVarInput")
    def lightness_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherInput")
    def saturation_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVarInput")
    def saturation_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceInput")
    def saturation_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVarInput")
    def saturation_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__882f3fb5bb078f28ec488ea3dbc8f72232947ebf51de39e771b5f7c252f22d45)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeather")
    def hue_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeather"))

    @hue_feather.setter
    def hue_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__89682f1d5b7c7ca697b632308e9cb6f8e299016fe1ad1e95f3696a2c3baa50af)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeather", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVar")
    def hue_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeatherVar"))

    @hue_feather_var.setter
    def hue_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4457265c5598b04082f99fca48fd461b7cee52ff19c9bdee15502bfdf53fefb1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueTolerance")
    def hue_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueTolerance"))

    @hue_tolerance.setter
    def hue_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c34118227668968ca1bebe1d202c7332eda8de4ff12242334f466773aefc7bc2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVar")
    def hue_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueToleranceVar"))

    @hue_tolerance_var.setter
    def hue_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__75153f65e4ec41ffe09921cc4810be69cd0f2f1ab4ecd3b3e3c419a408db30c7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__80fbe010552e3dfe5aab781065684fc7e362e7cce48aec7bab756c1f83b32795)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeather")
    def lightness_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeather"))

    @lightness_feather.setter
    def lightness_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__09b9c754c52f38a6dc65946a98f3c18aee59574e7a6d32b362da3b060628bf61)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeather", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVar")
    def lightness_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeatherVar"))

    @lightness_feather_var.setter
    def lightness_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ded47ec1cf40ea8ce4b3f58f1c414b93fed517525071c7ee3b359eb89aa72c65)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessTolerance")
    def lightness_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessTolerance"))

    @lightness_tolerance.setter
    def lightness_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ba13476013827637d80abd629dfd157a14a6902417cc0dc23b92767637beea1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVar")
    def lightness_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessToleranceVar"))

    @lightness_tolerance_var.setter
    def lightness_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__08925bd1bb8adcefe53e64999672bad2bee8e270617b35efc6a9587b153d533a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeather")
    def saturation_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeather"))

    @saturation_feather.setter
    def saturation_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ceafc20f632fdbaa50433cedb886494bfbf6c5bc825e1a679e6713d50a5fb3c6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeather", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVar")
    def saturation_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeatherVar"))

    @saturation_feather_var.setter
    def saturation_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__49be3e873c4fb30367bc6ebb629cc2020c7b83e81e982ee21896c29d86c26928)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationTolerance")
    def saturation_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationTolerance"))

    @saturation_tolerance.setter
    def saturation_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__72c6970c06ad1b2403f75618c9ebcc200ee30309b335560457b1b3bad8861650)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVar")
    def saturation_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationToleranceVar"))

    @saturation_tolerance_var.setter
    def saturation_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a5206f1e258d770b5d129d55dc8b38a269023f633a458f37f1a2feb1c1791dc6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitChromaKey]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitChromaKey]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitChromaKey]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5addc19f9aafbeee9032cdd39eb016fb9054defa066eba7a236a100bb670c23b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitComposite",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "placement": "placement",
        "placement_var": "placementVar",
        "scale": "scale",
        "scale_dimension": "scaleDimension",
        "scale_dimension_var": "scaleDimensionVar",
        "scale_var": "scaleVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitComposite:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitCompositeImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        placement: typing.Optional[builtins.str] = None,
        placement_var: typing.Optional[builtins.str] = None,
        scale: typing.Optional[builtins.str] = None,
        scale_dimension: typing.Optional[builtins.str] = None,
        scale_dimension_var: typing.Optional[builtins.str] = None,
        scale_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param placement: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        :param placement_var: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        :param scale: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param scale_dimension: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        :param scale_dimension_var: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        :param scale_var: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        :param x_position: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitCompositeImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bcc0f6701926c3ed1c19948a2c57197ed97625afe8730b110c26affa803ea4e6)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument placement", value=placement, expected_type=type_hints["placement"])
            check_type(argname="argument placement_var", value=placement_var, expected_type=type_hints["placement_var"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument scale_dimension", value=scale_dimension, expected_type=type_hints["scale_dimension"])
            check_type(argname="argument scale_dimension_var", value=scale_dimension_var, expected_type=type_hints["scale_dimension_var"])
            check_type(argname="argument scale_var", value=scale_var, expected_type=type_hints["scale_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if placement is not None:
            self._values["placement"] = placement
        if placement_var is not None:
            self._values["placement_var"] = placement_var
        if scale is not None:
            self._values["scale"] = scale
        if scale_dimension is not None:
            self._values["scale_dimension"] = scale_dimension
        if scale_dimension_var is not None:
            self._values["scale_dimension_var"] = scale_dimension_var
        if scale_var is not None:
            self._values["scale_var"] = scale_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitCompositeImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitCompositeImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        '''
        result = self._values.get("placement")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement_var(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        '''
        result = self._values.get("placement_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        '''
        result = self._values.get("scale_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        '''
        result = self._values.get("scale_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        '''
        result = self._values.get("scale_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitComposite(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitCompositeImage",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitCompositeImage:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitCompositeImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitCompositeImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitCompositeImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f182256c1fd2db3c6c279d154b683bbdec0628f1c06b3f25a9f4361b1fae6e4c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitCompositeImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitCompositeImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f234b5b6e5ddd8e32d62656423d3b6f1078d07e956a965723cfbb40208250df8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitCompositeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitCompositeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a42c8a4fd321dc05f20b61755e3d37cb67774efb7b7de98e11a102f242667a9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitCompositeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__beec97d6e6f6216f59f69385a9050e8be7d818785ca6a12adac6c22e3a9f9681)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitCompositeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__47cb2cca3796b208a75990649a4bb29be9625ea9f820468e9e7fd2fcc84cc5a3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__03e893e58861de872dc3fc465538858491f5d184160ef4ee71dc5782f59c0735)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__07e818987cf68d51532ce742c87dbc7422fa460b1dabcd8307647c5932f0a93f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitComposite]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitComposite]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__598d98e93e8e7912782f4f1f09d0b6ca704675f237732c8d501712b8c15ed848)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitCompositeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitCompositeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7c4c319dbf549b24d5419508dd94d2b095469f5724b31e25994836d4bbda8be4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitCompositeImage()

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPlacement")
    def reset_placement(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacement", []))

    @jsii.member(jsii_name="resetPlacementVar")
    def reset_placement_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacementVar", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetScaleDimension")
    def reset_scale_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimension", []))

    @jsii.member(jsii_name="resetScaleDimensionVar")
    def reset_scale_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimensionVar", []))

    @jsii.member(jsii_name="resetScaleVar")
    def reset_scale_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitCompositeImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitCompositeImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitCompositeImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="placementInput")
    def placement_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementInput"))

    @builtins.property
    @jsii.member(jsii_name="placementVarInput")
    def placement_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionInput")
    def scale_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVarInput")
    def scale_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleVarInput")
    def scale_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__15601ab0c405f606afda5c1fcc5493a7b1b57f978694c9d7eabf4686d1c14708)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fae37c5828e8261f9e09798ca8ff0ca5ae2106d5f166b78a7963b9f3308fd251)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="placement")
    def placement(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placement"))

    @placement.setter
    def placement(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1daa87d01c53f875be494d5c621f8c0d68e7d76d2684f81928231eba280f7789)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placement", value)

    @builtins.property
    @jsii.member(jsii_name="placementVar")
    def placement_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placementVar"))

    @placement_var.setter
    def placement_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__340621d37be302d53b9df298be23f448d6a1a1a0f0604e2f9d32223965fc3b8b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placementVar", value)

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scale"))

    @scale.setter
    def scale(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__467382f1cf4982dba3129834a0afb3810e34378801f6f51695e89fcf30f66517)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scale", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimension")
    def scale_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimension"))

    @scale_dimension.setter
    def scale_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ce55dfc060eeed040afd1f8d5573cd5565d4008bcf1f11726a557124a6d8a0b2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimension", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVar")
    def scale_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimensionVar"))

    @scale_dimension_var.setter
    def scale_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e7b8748f6c48795a10be63f8f5e2223cdf16ed0b46a6ffe0c82f011d7917b782)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="scaleVar")
    def scale_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleVar"))

    @scale_var.setter
    def scale_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1d0dfa3bb820086e2d112315b4fbfe1504c5cdf9eef759a933a7f1bf41a01533)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5314357a48caa037f55317d60cb9b957342eb4c1a7fbe2744fc61d93cbd77036)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__51c9df50f30dd774fa902e2a3a234001cc02f9dba40321eaf089694e8741c43f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c6ccbb138b2032587ed842e92e773feacfe92ecd9fa8f07c6e01c2c67adf5ab7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c0ee56f247b51723209e0ef489b3ea5d445173c8cca17685f35eecb0e1f9bbee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitComposite]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitComposite]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitComposite]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aa99fdf17d532657b52c7fc396921c839402f70422cf79290d1fe7f20d3ddfce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitCompound",
    jsii_struct_bases=[],
    name_mapping={"transformations": "transformations"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitCompound:
    def __init__(
        self,
        *,
        transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param transformations: transformations block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__220805c644e801dad2dec10609029316bfe2f9aa8a580c87e571bf22f3f630f5)
            check_type(argname="argument transformations", value=transformations, expected_type=type_hints["transformations"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if transformations is not None:
            self._values["transformations"] = transformations

    @builtins.property
    def transformations(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitCompoundTransformations"]]]:
        '''transformations block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        result = self._values.get("transformations")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitCompoundTransformations"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitCompound(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitCompoundList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitCompoundList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e2138a29eef57641100eb601c2909f40e3a624eb2ab70b0b498822a5190ac214)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitCompoundOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7ca5b2f53bb82e3cf5ec335b0ef1ef1be871af6ae04950206f58cc6b34a6f96f)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitCompoundOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__18e350d80be947ad5ca9688d24fb08f8060d31baf6b0fc78efb71864507ec281)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__06210c0ea0828e99408e083b9eef30cb204a2c6d7a6fd3b5f7dfd2fe0e0e6d16)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ab961fc72ce7d0b33bc9b3bbcf59fb67ef6b1db98a8af65f4865c4fbc18ae98)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitCompound]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitCompound]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a3d81415c040c0d5655b3383ad12fba81338aa5e71552b3856601209c9335128)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitCompoundOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitCompoundOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4fb74736bac8a63626d56e7113769f11b6bc8eba1a3c9ff3ec6722d17a47d79e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformations")
    def put_transformations(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4985420deaca92570682c40714e0519dc4baa4c546aeb940d0b114cb5011a85d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTransformations", [value]))

    @jsii.member(jsii_name="resetTransformations")
    def reset_transformations(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformations", []))

    @builtins.property
    @jsii.member(jsii_name="transformations")
    def transformations(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitCompoundTransformationsList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitCompoundTransformationsList", jsii.get(self, "transformations"))

    @builtins.property
    @jsii.member(jsii_name="transformationsInput")
    def transformations_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitCompoundTransformations"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitCompoundTransformations"]]], jsii.get(self, "transformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitCompound]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitCompound]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitCompound]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c6a2bdee05dc83dd6f205aa500afc199d8e2842cc39bcde0dcf7341e5dcd565d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitCompoundTransformations",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitCompoundTransformations:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitCompoundTransformations(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitCompoundTransformationsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitCompoundTransformationsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4bca5b888bf7472410eb4c62394799ea647fdfd3417fb3873e9c95cc75518dd9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitCompoundTransformationsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c9d6e8cda9203030faa1b40acadf7f1e799fad0c5836048a055d6f55d1b68c17)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitCompoundTransformationsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__82f5d8e7394aec5740025f854815938a043df39bd05d676cad1470f4bfdb9983)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f4bb680b3a6388d6d894c426148c436938b528bb9e5fed9b391a5c8e20c261d0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__119c5c21b4325ddb5e8148c29fdb58b198d9549f549bb1f1d44dec9be8dc1dd5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitCompoundTransformations]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitCompoundTransformations]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitCompoundTransformations]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__60941374e7ca61d056b7b71a6d5ab5906695a7461b98bbe228768cfcc44ccf0a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitCompoundTransformationsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitCompoundTransformationsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b36a00bd4c30540ccc7be3bf818db4cf389c89a39efafaf18e3222b74769309e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitCompoundTransformations]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitCompoundTransformations]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitCompoundTransformations]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e78dc460671f92028dc398419abe9363d2e04654c341b73f328ce81fdbdaaf87)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitContrast",
    jsii_struct_bases=[],
    name_mapping={
        "brightness": "brightness",
        "brightness_var": "brightnessVar",
        "contrast": "contrast",
        "contrast_var": "contrastVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitContrast:
    def __init__(
        self,
        *,
        brightness: typing.Optional[builtins.str] = None,
        brightness_var: typing.Optional[builtins.str] = None,
        contrast: typing.Optional[builtins.str] = None,
        contrast_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param brightness: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        :param brightness_var: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        :param contrast: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param contrast_var: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ce5b6f3ecbc84b7ed52da552803c8272790ff53f0d0241fb4ed3d853e14bea9c)
            check_type(argname="argument brightness", value=brightness, expected_type=type_hints["brightness"])
            check_type(argname="argument brightness_var", value=brightness_var, expected_type=type_hints["brightness_var"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument contrast_var", value=contrast_var, expected_type=type_hints["contrast_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if brightness is not None:
            self._values["brightness"] = brightness
        if brightness_var is not None:
            self._values["brightness_var"] = brightness_var
        if contrast is not None:
            self._values["contrast"] = contrast
        if contrast_var is not None:
            self._values["contrast_var"] = contrast_var

    @builtins.property
    def brightness(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        '''
        result = self._values.get("brightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def brightness_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        '''
        result = self._values.get("brightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        result = self._values.get("contrast_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitContrast(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitContrastList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitContrastList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__554c0b86c23ef3e93bdb4d6afdd2d3c016619e06a221344b2d7840a5c42add11)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitContrastOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__43a826a46ff08c189842de34308364ab41cd14ca3869fbc28e0d38e32527f659)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitContrastOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5afc394bdc081c5a450549acd4e40309516d888e0d7f8bfffd7a92a85a0b2c86)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1667bc37d0fe29238e6e4f29e54efb5b6ca33fe58d10fafb050bbc1cd92e09b9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af44c87dfb3161b2cbb703b220d89b3c9f04727de1204bc837e94d52227e3929)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitContrast]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitContrast]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a6a63898b77e950d3cc4f1475d482d9fcf0c9aa88c1bc1805e851f3962ce825)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitContrastOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitContrastOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0cef8bbe0c2c266d423f0afad27307a13b79a9f87c5a18df8a4880aaeba90fd6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetBrightness")
    def reset_brightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightness", []))

    @jsii.member(jsii_name="resetBrightnessVar")
    def reset_brightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightnessVar", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetContrastVar")
    def reset_contrast_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrastVar", []))

    @builtins.property
    @jsii.member(jsii_name="brightnessInput")
    def brightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="brightnessVarInput")
    def brightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastVarInput")
    def contrast_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="brightness")
    def brightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightness"))

    @brightness.setter
    def brightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dcf10a8d393dbd2f6c66f61c5706db9fa989176ee2c84e6d3c28a703a2f7d737)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightness", value)

    @builtins.property
    @jsii.member(jsii_name="brightnessVar")
    def brightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightnessVar"))

    @brightness_var.setter
    def brightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0a449c2a8ed06500c86f446e76a0330076aaf029844155586539acdbc490cb44)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrast"))

    @contrast.setter
    def contrast(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bf9b0921b4bd55c1f21028eb574c11eaa70bdfaa266c6a2e327a0cc7aa56c52c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrast", value)

    @builtins.property
    @jsii.member(jsii_name="contrastVar")
    def contrast_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrastVar"))

    @contrast_var.setter
    def contrast_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7987ce0649b43cf836b145fae32ffc212b5a58fdd9156b2d96eae7bf45ddb559)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrastVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitContrast]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitContrast]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitContrast]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e7e43ac52a58b219b259d27ebb480fb83a852c0629213aed40cf1585a3626fc8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitGoop",
    jsii_struct_bases=[],
    name_mapping={
        "chaos": "chaos",
        "chaos_var": "chaosVar",
        "density": "density",
        "density_var": "densityVar",
        "power": "power",
        "power_var": "powerVar",
        "seed": "seed",
        "seed_var": "seedVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitGoop:
    def __init__(
        self,
        *,
        chaos: typing.Optional[builtins.str] = None,
        chaos_var: typing.Optional[builtins.str] = None,
        density: typing.Optional[builtins.str] = None,
        density_var: typing.Optional[builtins.str] = None,
        power: typing.Optional[builtins.str] = None,
        power_var: typing.Optional[builtins.str] = None,
        seed: typing.Optional[builtins.str] = None,
        seed_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param chaos: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        :param chaos_var: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        :param density: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        :param density_var: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        :param power: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        :param power_var: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        :param seed: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        :param seed_var: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2f355ba5b17b2d60bc5cc0186ecd172fa8c3fe49503d2d8da2a16d71ebf8cc44)
            check_type(argname="argument chaos", value=chaos, expected_type=type_hints["chaos"])
            check_type(argname="argument chaos_var", value=chaos_var, expected_type=type_hints["chaos_var"])
            check_type(argname="argument density", value=density, expected_type=type_hints["density"])
            check_type(argname="argument density_var", value=density_var, expected_type=type_hints["density_var"])
            check_type(argname="argument power", value=power, expected_type=type_hints["power"])
            check_type(argname="argument power_var", value=power_var, expected_type=type_hints["power_var"])
            check_type(argname="argument seed", value=seed, expected_type=type_hints["seed"])
            check_type(argname="argument seed_var", value=seed_var, expected_type=type_hints["seed_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if chaos is not None:
            self._values["chaos"] = chaos
        if chaos_var is not None:
            self._values["chaos_var"] = chaos_var
        if density is not None:
            self._values["density"] = density
        if density_var is not None:
            self._values["density_var"] = density_var
        if power is not None:
            self._values["power"] = power
        if power_var is not None:
            self._values["power_var"] = power_var
        if seed is not None:
            self._values["seed"] = seed
        if seed_var is not None:
            self._values["seed_var"] = seed_var

    @builtins.property
    def chaos(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        '''
        result = self._values.get("chaos")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def chaos_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        '''
        result = self._values.get("chaos_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        '''
        result = self._values.get("density")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density_var(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        '''
        result = self._values.get("density_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        '''
        result = self._values.get("power")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power_var(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        '''
        result = self._values.get("power_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        '''
        result = self._values.get("seed")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed_var(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        result = self._values.get("seed_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitGoop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitGoopList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitGoopList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df16c466c21971ae7ed40a2100d8012657f63519ffe9ec7f9265e33c140acb8d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitGoopOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__104860896917a4f400ced5950ff55dbf98f4120618975a162d6203315153ce1a)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitGoopOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__902b99def684b4f179d1732003fff16b19bd6545fd48eddc13302b731398f612)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a98e2cff1b55d1986020abf640f6dce95206ca55ab0860f8cc9ac576e365b170)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__18486bbb66de6d247be275e66f075655a20b54cf7ddfb660670d416b23631a6d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitGoop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitGoop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__55f09c1ce54b3b7465ea2cd372e6e8b817148f33bcebe0f4ba6b5dd30ca13d56)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitGoopOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitGoopOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9522c2c7e42f8ed52fa2fe986c2c220a5240b07e850c107fff3284a593c3ae6d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetChaos")
    def reset_chaos(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaos", []))

    @jsii.member(jsii_name="resetChaosVar")
    def reset_chaos_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaosVar", []))

    @jsii.member(jsii_name="resetDensity")
    def reset_density(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensity", []))

    @jsii.member(jsii_name="resetDensityVar")
    def reset_density_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensityVar", []))

    @jsii.member(jsii_name="resetPower")
    def reset_power(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPower", []))

    @jsii.member(jsii_name="resetPowerVar")
    def reset_power_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPowerVar", []))

    @jsii.member(jsii_name="resetSeed")
    def reset_seed(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeed", []))

    @jsii.member(jsii_name="resetSeedVar")
    def reset_seed_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeedVar", []))

    @builtins.property
    @jsii.member(jsii_name="chaosInput")
    def chaos_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosInput"))

    @builtins.property
    @jsii.member(jsii_name="chaosVarInput")
    def chaos_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosVarInput"))

    @builtins.property
    @jsii.member(jsii_name="densityInput")
    def density_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityInput"))

    @builtins.property
    @jsii.member(jsii_name="densityVarInput")
    def density_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="powerInput")
    def power_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerInput"))

    @builtins.property
    @jsii.member(jsii_name="powerVarInput")
    def power_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerVarInput"))

    @builtins.property
    @jsii.member(jsii_name="seedInput")
    def seed_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedInput"))

    @builtins.property
    @jsii.member(jsii_name="seedVarInput")
    def seed_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedVarInput"))

    @builtins.property
    @jsii.member(jsii_name="chaos")
    def chaos(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaos"))

    @chaos.setter
    def chaos(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f616462948fb5e677e36d3f207a6d8e3547042375d041e0c7b7abf821525acfb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaos", value)

    @builtins.property
    @jsii.member(jsii_name="chaosVar")
    def chaos_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaosVar"))

    @chaos_var.setter
    def chaos_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__832e8de061407c584fec1d6ee2a6da1b74a227068fb15f62c706a02d6a85b6f5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaosVar", value)

    @builtins.property
    @jsii.member(jsii_name="density")
    def density(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "density"))

    @density.setter
    def density(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__07ef5a723320878d8d92ca1fafaf553fdaa5d581eaaf01c8aeab99e615e1469f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "density", value)

    @builtins.property
    @jsii.member(jsii_name="densityVar")
    def density_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "densityVar"))

    @density_var.setter
    def density_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__288a9aeec30adefd5aefc288a4b7ceafa847db767232cdc5c5e8734391a0424f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "densityVar", value)

    @builtins.property
    @jsii.member(jsii_name="power")
    def power(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "power"))

    @power.setter
    def power(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7467796eb07a3dad218027d1981753d94ff5f2e6b7d0102beba71cb2784f04ec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "power", value)

    @builtins.property
    @jsii.member(jsii_name="powerVar")
    def power_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "powerVar"))

    @power_var.setter
    def power_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6eb034ee9e6e6fefd3b5c2790abcccfb044acab983ff79d12e6bd62e4b28a7c6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "powerVar", value)

    @builtins.property
    @jsii.member(jsii_name="seed")
    def seed(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seed"))

    @seed.setter
    def seed(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ffffa4e1204da721c99f32ed41060424a3113a9d7c324766e0fe1ce1d31c6e06)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seed", value)

    @builtins.property
    @jsii.member(jsii_name="seedVar")
    def seed_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seedVar"))

    @seed_var.setter
    def seed_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fd93138df5931f8c623ba7a89b8cec5a81038b46f58bd5db1d23fcd4ba9037b1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seedVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitGoop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitGoop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitGoop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e6ea5b86e04eedcdc8910297ee6ab9ed38c7cc93d6e7e92753d642fd1cfcc06a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitGrayscale",
    jsii_struct_bases=[],
    name_mapping={"type": "type", "type_var": "typeVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitGrayscale:
    def __init__(
        self,
        *,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param type: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1165876772280eda2f5cea4be264652ef8f77ca47b98ab753dc3075deaa01825)
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitGrayscale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitGrayscaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitGrayscaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e26f757f90709c2ffbe375a153e0a35b123d7848e959fb591cdfe04810677d65)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitGrayscaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3e6f9a58fa912b831f49360c0455040f2d02b9e3cd293fca44ba06852992a8ba)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitGrayscaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fc5d6f33bd1901abdc628c8176d057261bc2d233bd0933a6191c007b75ee9fc6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6eaf2ce17c429aa9582665e24f7084140ebd9ce6ed12e7b0dd6a43493187c72b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a9a2823c8a83e8b94de6b97f7f7fac543e77f8fc3a29dcd987120c51326eabd2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitGrayscale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitGrayscale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__49fcf10a0b1d0c67bc5a269e5ab4c980231454733c562aa09204dd55cd5bae90)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitGrayscaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitGrayscaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f563df709c9f800df7a5dd96f1b64b3f8f920f30431ebbc04bb0b95412a9faf8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1c58e3578869817ad1f8444e75ad61d8af85d66f3e37973da1fba916b64826b2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0573382aa661ded8774916d106c2e26254f726fc028caf2d4151fad250c7c103)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitGrayscale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitGrayscale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitGrayscale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__15dfc0e9e6ff4e217d41a0d21146edc90d30b5efefe87403eab4e0ffdffad059)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitHsl",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "lightness": "lightness",
        "lightness_var": "lightnessVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitHsl:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness: typing.Optional[builtins.str] = None,
        lightness_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        :param lightness_var: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__63c17462c15f2251308e6b8f2f890158357bcbdce623aaf738af9ae4dae56f57)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness", value=lightness, expected_type=type_hints["lightness"])
            check_type(argname="argument lightness_var", value=lightness_var, expected_type=type_hints["lightness_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness is not None:
            self._values["lightness"] = lightness
        if lightness_var is not None:
            self._values["lightness_var"] = lightness_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        '''
        result = self._values.get("lightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        '''
        result = self._values.get("lightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitHsl(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitHslList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitHslList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a9c4217bfe656e32ed41b807cbca4c2ddbf1834b28fe09db83ed10aba10fbb60)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitHslOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__154d1dc9b977ddad7bf0df16a11e7b3e5a792f0f667b00acb2c49b6a8756d82c)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitHslOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__da2c50f86a8cef66bd75f0ee91fd58ea3fff755fe0f7835d968c02e37da430b1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b7e5560d4531e0c94cee07f36ac60a6647270cc1853e0675f9231fa9df8e1371)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6beb25236918a1f2bc05d4f12b8de8730240e82e5c5b1e456e45d95b04bfb556)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitHsl]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitHsl]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__262667d999030c44d1f93ead0ced7f46541738e1f76573dbaa100116c9e7d418)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitHslOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitHslOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0c53295b8a487f67305b5aaf55bd4cefc48d7832b0cf9640b5a6743c6aafcb40)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightness")
    def reset_lightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightness", []))

    @jsii.member(jsii_name="resetLightnessVar")
    def reset_lightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessInput")
    def lightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessVarInput")
    def lightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c35bcce3457c3dbc4f9e0ff002132d74d13251a741f1b9ddaf135d4b51078480)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4c187de574fa03e07a9b0ddbb5ef628adfa60de36187756c0c43fd11b7061109)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightness")
    def lightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightness"))

    @lightness.setter
    def lightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5e28720a6635df448c8f4627b5990ee7aa2d92dfaabe4b467df2ca3905821e68)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightness", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessVar")
    def lightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessVar"))

    @lightness_var.setter
    def lightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__56ab07ae212c3d9afc14af91626fb52568f3515d4504200c31b304c0ae77ff86)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__37793536b5482300f42ed6d1b6e82fbc565864b37f9ae54c7dfa15067a82f8cd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__41993557339bfce3a2d55c4e1747cc55e7899aed844000bfcd1e96b4f91a01d7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitHsl]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitHsl]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitHsl]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__572e7caa5ac22e800d05db6e391bc159f98b04dac42225d31f306f74a4b1d2c3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitHsv",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitHsv:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        :param value: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e9dbdebffea7761d6e733cbfb62110f0fdec6d9a39620085fb164ec9fc0f5cea)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitHsv(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitHsvList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitHsvList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1d8607f68f9caacf189bc749fe5318c693298fea8726c8d981beae68a6666df0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitHsvOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bf6772a8c1e2d9858aaf78ccab5962699ddf751337430fd37e4d0cf6399f287d)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitHsvOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c78927bed74f61507cf338773555e770f650c0f267223b10e91c90e965372f13)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6d9a78a7b73a14e04dd76007517ad7754e17115772ab60586e89c86e2c19d170)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a259d47a328f9054580494d0e7ce61a75e01b04ff11450935b307c13091358f0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitHsv]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitHsv]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dffe63efa2d02726cc87ba2aa7d70033fe77163619542e48af7f443db9e1688f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitHsvOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitHsvOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4d0be3abe28ea669b9e80459c2a675aeaa49f7cd232f89ddbf19de61eed97bc6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__03c411ce93b5363f8722ee2672ccbf502fe30f03c017beaee95a506c6457185e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3708838340e4d59eab60f83bbbd0bd2018071119e268f374e6892cd38bed8d55)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d274adc5658c6d23ee27937bad403e74bb6229f82c124a9f27dfdf39f57d2174)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e9687fc2358b4a5d2a77494a207afe667305e98f96caa67df5a86d8b46d58c8f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1cc896768cf6ff99d7ce83b5e2920035ee08a9a6a9c8898b11d37b7a498270bc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__48526e715a832c4d6286e69de9edc9df8a5d2c123310db0464e175df5e2431bb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitHsv]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitHsv]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitHsv]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4564e36ffa1704213e36f307990329a9773511a15529027496d75a0d259c5a63)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfDimension",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "dimension": "dimension",
        "dimension_var": "dimensionVar",
        "equal": "equal",
        "greater_than": "greaterThan",
        "less_than": "lessThan",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfDimension:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfDimensionDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        dimension: typing.Optional[builtins.str] = None,
        dimension_var: typing.Optional[builtins.str] = None,
        equal: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfDimensionEqual", typing.Dict[builtins.str, typing.Any]]] = None,
        greater_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfDimensionGreaterThan", typing.Dict[builtins.str, typing.Any]]] = None,
        less_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfDimensionLessThan", typing.Dict[builtins.str, typing.Any]]] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param dimension: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        :param dimension_var: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        :param equal: equal block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        :param greater_than: greater_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        :param less_than: less_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        :param value: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfDimensionDefault(**default)
        if isinstance(equal, dict):
            equal = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfDimensionEqual(**equal)
        if isinstance(greater_than, dict):
            greater_than = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfDimensionGreaterThan(**greater_than)
        if isinstance(less_than, dict):
            less_than = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfDimensionLessThan(**less_than)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__15608b8d71a220e06021322c7fec04c15a9a47d019ce8f9c7d7982a25d35ef26)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument dimension", value=dimension, expected_type=type_hints["dimension"])
            check_type(argname="argument dimension_var", value=dimension_var, expected_type=type_hints["dimension_var"])
            check_type(argname="argument equal", value=equal, expected_type=type_hints["equal"])
            check_type(argname="argument greater_than", value=greater_than, expected_type=type_hints["greater_than"])
            check_type(argname="argument less_than", value=less_than, expected_type=type_hints["less_than"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if dimension is not None:
            self._values["dimension"] = dimension
        if dimension_var is not None:
            self._values["dimension_var"] = dimension_var
        if equal is not None:
            self._values["equal"] = equal
        if greater_than is not None:
            self._values["greater_than"] = greater_than
        if less_than is not None:
            self._values["less_than"] = less_than
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfDimensionDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfDimensionDefault"], result)

    @builtins.property
    def dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        '''
        result = self._values.get("dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        '''
        result = self._values.get("dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def equal(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfDimensionEqual"]:
        '''equal block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        '''
        result = self._values.get("equal")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfDimensionEqual"], result)

    @builtins.property
    def greater_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfDimensionGreaterThan"]:
        '''greater_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        '''
        result = self._values.get("greater_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfDimensionGreaterThan"], result)

    @builtins.property
    def less_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfDimensionLessThan"]:
        '''less_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        '''
        result = self._values.get("less_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfDimensionLessThan"], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfDimension(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfDimensionDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfDimensionDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfDimensionDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfDimensionDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfDimensionDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3969773359984f054f152e066e79e508b870083791b9d2ad11fee60d3046eabd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfDimensionDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfDimensionDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8053d2bb62446886b77f730fee2d6d2edfc7a4a081f7dd450253520277b3de88)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfDimensionEqual",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfDimensionEqual:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfDimensionEqual(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfDimensionEqualOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfDimensionEqualOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2b4f95c111e20ef9094b485405ee729d934dfb903d3f1b8695ccb4dcdd2a1109)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfDimensionEqual], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfDimensionEqual],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bcb4b8bfdb86c3215880d1420da3ea02c00caeb22ed5fa2ece180512cfe96e93)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfDimensionGreaterThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfDimensionGreaterThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfDimensionGreaterThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfDimensionGreaterThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfDimensionGreaterThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a92ba29c8bc6ca02af1f0adfaf2db06e177b288e061fd1244147bdc238d4fdc4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfDimensionGreaterThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfDimensionGreaterThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__96514850734867bd17e732ec5454cc71f0c3f4d652d783d17e51376e73fd185d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfDimensionLessThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfDimensionLessThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfDimensionLessThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfDimensionLessThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfDimensionLessThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3505ca32b68187fa2cf7dcab666ca0d0a72e3839eca4020d27a1af6c0ef921d7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfDimensionLessThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfDimensionLessThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e5fd3a00061c4c1283feb7c6c4a75dbd01c85a0d508729bb8d1953ff40d36596)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfDimensionList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfDimensionList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9aa6fdf1edd6a9242619e7ff96108cfbfb62bf68fbcd87109f9d6d86aa11c862)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfDimensionOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6088ff6d3edecc5462478f58a574a3a8445b2a6cc034e38f8deee350ae491bfe)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfDimensionOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b34415d4cf2b92e05bd295a71ade6b0ceac1399a7d9093dd4f81f4e031a50437)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__98dc6ccc8831d6e662f94c3383208de102aaf67d66cec778ecd4d9a2c76705e9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__700f48490e998cea9b06ea32a867b5ca7bed90f17ea62ebf3cc718c6338d8a4b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfDimension]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfDimension]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c7d2f8894e90a40910e573a561835060ddd26f6e7efbafdcbfe23135daaf3c8b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfDimensionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfDimensionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2b0adc9de9e6de7e315d5056ab289ca4fcce7a7b80e4930eb55a0cfb7751e400)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfDimensionDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putEqual")
    def put_equal(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfDimensionEqual()

        return typing.cast(None, jsii.invoke(self, "putEqual", [value]))

    @jsii.member(jsii_name="putGreaterThan")
    def put_greater_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfDimensionGreaterThan()

        return typing.cast(None, jsii.invoke(self, "putGreaterThan", [value]))

    @jsii.member(jsii_name="putLessThan")
    def put_less_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfDimensionLessThan()

        return typing.cast(None, jsii.invoke(self, "putLessThan", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetDimension")
    def reset_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimension", []))

    @jsii.member(jsii_name="resetDimensionVar")
    def reset_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimensionVar", []))

    @jsii.member(jsii_name="resetEqual")
    def reset_equal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEqual", []))

    @jsii.member(jsii_name="resetGreaterThan")
    def reset_greater_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGreaterThan", []))

    @jsii.member(jsii_name="resetLessThan")
    def reset_less_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLessThan", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfDimensionDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfDimensionDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="equal")
    def equal(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfDimensionEqualOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfDimensionEqualOutputReference, jsii.get(self, "equal"))

    @builtins.property
    @jsii.member(jsii_name="greaterThan")
    def greater_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfDimensionGreaterThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfDimensionGreaterThanOutputReference, jsii.get(self, "greaterThan"))

    @builtins.property
    @jsii.member(jsii_name="lessThan")
    def less_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfDimensionLessThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfDimensionLessThanOutputReference, jsii.get(self, "lessThan"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfDimensionDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionInput")
    def dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionVarInput")
    def dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="equalInput")
    def equal_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfDimensionEqual], jsii.get(self, "equalInput"))

    @builtins.property
    @jsii.member(jsii_name="greaterThanInput")
    def greater_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfDimensionGreaterThan], jsii.get(self, "greaterThanInput"))

    @builtins.property
    @jsii.member(jsii_name="lessThanInput")
    def less_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfDimensionLessThan], jsii.get(self, "lessThanInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="dimension")
    def dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimension"))

    @dimension.setter
    def dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__084c2eef68770329d65bc305f423cce27dade471ee12257a2fa604e90c4dae89)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimension", value)

    @builtins.property
    @jsii.member(jsii_name="dimensionVar")
    def dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimensionVar"))

    @dimension_var.setter
    def dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1d08473e28d971f093f7ce4b774a3a27e44c57b2c732b8679e227ac25d709dd4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b352395d387bd74f77b3bc6d18c388eda60dcedf3c09ef384448dcb5ead86a43)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f8131e080a2212d6c7b9110ef409c82e164b07752758a97bd76be60b03e2029)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfDimension]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfDimension]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfDimension]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d078b4b71da67c491dbd170f55b4e45a04f38c863c7fa386a5f488071cad8d3e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfOrientation",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "landscape": "landscape",
        "portrait": "portrait",
        "square": "square",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfOrientation:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfOrientationDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        landscape: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfOrientationLandscape", typing.Dict[builtins.str, typing.Any]]] = None,
        portrait: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfOrientationPortrait", typing.Dict[builtins.str, typing.Any]]] = None,
        square: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfOrientationSquare", typing.Dict[builtins.str, typing.Any]]] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param landscape: landscape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        :param portrait: portrait block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        :param square: square block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfOrientationDefault(**default)
        if isinstance(landscape, dict):
            landscape = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfOrientationLandscape(**landscape)
        if isinstance(portrait, dict):
            portrait = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfOrientationPortrait(**portrait)
        if isinstance(square, dict):
            square = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfOrientationSquare(**square)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__775708bfd340cd5a2d2982527d5989a766ba07395e26534c6b22ab89aa5998f8)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument landscape", value=landscape, expected_type=type_hints["landscape"])
            check_type(argname="argument portrait", value=portrait, expected_type=type_hints["portrait"])
            check_type(argname="argument square", value=square, expected_type=type_hints["square"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if landscape is not None:
            self._values["landscape"] = landscape
        if portrait is not None:
            self._values["portrait"] = portrait
        if square is not None:
            self._values["square"] = square

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfOrientationDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfOrientationDefault"], result)

    @builtins.property
    def landscape(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfOrientationLandscape"]:
        '''landscape block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        '''
        result = self._values.get("landscape")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfOrientationLandscape"], result)

    @builtins.property
    def portrait(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfOrientationPortrait"]:
        '''portrait block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        '''
        result = self._values.get("portrait")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfOrientationPortrait"], result)

    @builtins.property
    def square(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfOrientationSquare"]:
        '''square block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        result = self._values.get("square")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfOrientationSquare"], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfOrientation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfOrientationDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfOrientationDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfOrientationDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfOrientationDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfOrientationDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e9b10c3488e819481be50e6da907b41e3be5efee295d5c7fb3358af4500e0803)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfOrientationDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfOrientationDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d0c7cb795d1334e13f23fc91707b05458c23e63e3987f53b57475497a895425c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfOrientationLandscape",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfOrientationLandscape:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfOrientationLandscape(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfOrientationLandscapeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfOrientationLandscapeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__51b76c4bfa90e846f11b47d57d3a5d6eb82bd1db8ee0992c63691090e702d188)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfOrientationLandscape], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfOrientationLandscape],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0c899d0efcc0000f356d50c6bf1d1ccc56e454f065d4f9db4014024dbbc984c8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfOrientationList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfOrientationList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__36df0c0d95c85b4015c657a9c4e757d8bb8ce5dc62909325ffadb0e7ec974a88)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfOrientationOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__997de73a6266a558ac7ad7ffca5557b49b1fc8e695fa2380e8e21ed78324a021)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfOrientationOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4c60f5d1aa0aefdb977ca1b3923962caff077cdf93ed05195479823943518a93)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6a15cff9870df0df72f6794e135754be8c14ea7f4ee8cbd91e6ddbdff73528b4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ccf899ded283d7a3de7d79e4962e261ed7b0ac70bd5d4fda5d43dc6db72d74ff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfOrientation]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfOrientation]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a62e4cd67bea0c4eac21e59f55ee70958e2bb7552cf073f804ca4e8435808f7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfOrientationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfOrientationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a03ed4caefbec78cdfa38131d873fd7d580bc42b2c6524fbb99bff93071e1a27)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfOrientationDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putLandscape")
    def put_landscape(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfOrientationLandscape()

        return typing.cast(None, jsii.invoke(self, "putLandscape", [value]))

    @jsii.member(jsii_name="putPortrait")
    def put_portrait(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfOrientationPortrait()

        return typing.cast(None, jsii.invoke(self, "putPortrait", [value]))

    @jsii.member(jsii_name="putSquare")
    def put_square(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfOrientationSquare()

        return typing.cast(None, jsii.invoke(self, "putSquare", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetLandscape")
    def reset_landscape(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLandscape", []))

    @jsii.member(jsii_name="resetPortrait")
    def reset_portrait(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPortrait", []))

    @jsii.member(jsii_name="resetSquare")
    def reset_square(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSquare", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfOrientationDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfOrientationDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="landscape")
    def landscape(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfOrientationLandscapeOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfOrientationLandscapeOutputReference, jsii.get(self, "landscape"))

    @builtins.property
    @jsii.member(jsii_name="portrait")
    def portrait(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfOrientationPortraitOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfOrientationPortraitOutputReference", jsii.get(self, "portrait"))

    @builtins.property
    @jsii.member(jsii_name="square")
    def square(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfOrientationSquareOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfOrientationSquareOutputReference", jsii.get(self, "square"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfOrientationDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="landscapeInput")
    def landscape_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfOrientationLandscape], jsii.get(self, "landscapeInput"))

    @builtins.property
    @jsii.member(jsii_name="portraitInput")
    def portrait_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfOrientationPortrait"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfOrientationPortrait"], jsii.get(self, "portraitInput"))

    @builtins.property
    @jsii.member(jsii_name="squareInput")
    def square_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfOrientationSquare"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfOrientationSquare"], jsii.get(self, "squareInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfOrientation]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfOrientation]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfOrientation]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6d6be929112ecd99e2a27f3af77d66024aa85698666221d4d31a7b47d82ca327)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfOrientationPortrait",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfOrientationPortrait:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfOrientationPortrait(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfOrientationPortraitOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfOrientationPortraitOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc660f84956e07c7639b1c7b8a676f619bbcd90c748e63f41c896e7cad4436e7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfOrientationPortrait]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfOrientationPortrait], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfOrientationPortrait],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__211ec7cc063bfddf52b480bd469815be98d6e6bcf261e6ccd726e79a1820d78e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfOrientationSquare",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfOrientationSquare:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfOrientationSquare(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfOrientationSquareOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfOrientationSquareOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__04817324992a823b76d73ff4c83c1cd573a77ae08728f5c94f7ac3972a8370b4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfOrientationSquare]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfOrientationSquare], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfOrientationSquare],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d67c7409ae73ec3d233a42d6342c741126ec3b4c7aeb5fd183c15d0f701df9d7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitMaxColors",
    jsii_struct_bases=[],
    name_mapping={"colors": "colors", "colors_var": "colorsVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitMaxColors:
    def __init__(
        self,
        *,
        colors: typing.Optional[builtins.str] = None,
        colors_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param colors: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        :param colors_var: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9acc97f447a21baf842a80992c0e16160c96566ed8c1c6f282fb5efff50bb2b7)
            check_type(argname="argument colors", value=colors, expected_type=type_hints["colors"])
            check_type(argname="argument colors_var", value=colors_var, expected_type=type_hints["colors_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if colors is not None:
            self._values["colors"] = colors
        if colors_var is not None:
            self._values["colors_var"] = colors_var

    @builtins.property
    def colors(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        '''
        result = self._values.get("colors")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def colors_var(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        result = self._values.get("colors_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitMaxColors(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitMaxColorsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitMaxColorsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__03b17621c51bc3dd4ac0b41c6e042f013b6c1d49f9a0c0f4e47f079048450d75)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitMaxColorsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d134e81dc3f74c855757354bec99c6093921af164d36eb129d76eaec2a712ae9)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitMaxColorsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d90c8376f61a9b755e6301c1c0e9e29667c3363d4b1a4faf5e36fb7cf7b3c5c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4f8370785bc753ce8bd5fd108c41d3fd31ef166d3e38846e106ad25511c38de2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a2eab7b426b804b95eb0d1aea3d91bd2ef79b73012759c4e1993e1057d3a778a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitMaxColors]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitMaxColors]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__50570590f823dd413f234ea231ead953f589db4ac918e33d49a4f6c9396712fe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitMaxColorsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitMaxColorsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e97defd5ce1fd92ebdf794fef7cadc2bab245860564d3b4cff26481e5ac8cb5d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColors")
    def reset_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColors", []))

    @jsii.member(jsii_name="resetColorsVar")
    def reset_colors_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorsVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorsInput")
    def colors_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsInput"))

    @builtins.property
    @jsii.member(jsii_name="colorsVarInput")
    def colors_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsVarInput"))

    @builtins.property
    @jsii.member(jsii_name="colors")
    def colors(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colors"))

    @colors.setter
    def colors(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__15d86bc3f72eb99b9eee06b4b52bda6fcbbbe4140be84dc1387c4cebce16c3f8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colors", value)

    @builtins.property
    @jsii.member(jsii_name="colorsVar")
    def colors_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorsVar"))

    @colors_var.setter
    def colors_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f2948025b03fd22d0afb7262e49aba0a441f4d4f5a541b29f606a15a07934335)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorsVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitMaxColors]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitMaxColors]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitMaxColors]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c04e558a54fa6a085f09114de290157adf9d222ca397682578684ce55d29a98b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitMirror",
    jsii_struct_bases=[],
    name_mapping={
        "horizontal": "horizontal",
        "horizontal_var": "horizontalVar",
        "vertical": "vertical",
        "vertical_var": "verticalVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitMirror:
    def __init__(
        self,
        *,
        horizontal: typing.Optional[builtins.str] = None,
        horizontal_var: typing.Optional[builtins.str] = None,
        vertical: typing.Optional[builtins.str] = None,
        vertical_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param horizontal: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        :param horizontal_var: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        :param vertical: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        :param vertical_var: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__55c7fe0aff36ffbea14bf36b2aa93e6a773c079154654b612f300c740c7f1023)
            check_type(argname="argument horizontal", value=horizontal, expected_type=type_hints["horizontal"])
            check_type(argname="argument horizontal_var", value=horizontal_var, expected_type=type_hints["horizontal_var"])
            check_type(argname="argument vertical", value=vertical, expected_type=type_hints["vertical"])
            check_type(argname="argument vertical_var", value=vertical_var, expected_type=type_hints["vertical_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if horizontal is not None:
            self._values["horizontal"] = horizontal
        if horizontal_var is not None:
            self._values["horizontal_var"] = horizontal_var
        if vertical is not None:
            self._values["vertical"] = vertical
        if vertical_var is not None:
            self._values["vertical_var"] = vertical_var

    @builtins.property
    def horizontal(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        '''
        result = self._values.get("horizontal")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def horizontal_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        '''
        result = self._values.get("horizontal_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        '''
        result = self._values.get("vertical")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        result = self._values.get("vertical_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitMirror(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitMirrorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitMirrorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e827f0279fcee1a3cb3d1848cd4b535f434d9dd7c6cc7adbc4f1401111df5c47)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitMirrorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b276f667d20ab6484453cfaec16ceba49ebf37f12b166420d1a648bc3136cd9c)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitMirrorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6d621a6fa49c1707e73803282aacb72d33f9e42238c4a7a13a114879d610288b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7be112cb654a8a58d660df24faa54ba074a7c740c31dee63ea071184deb7ddf2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__07dd0f5bf4d131c8eaa286a295b4c30eea3f7f1bda62e15672185ccd78eb1f41)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitMirror]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitMirror]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a5a808e54328dca77b4cd77cd894c1bc79b399aa089a53bec730d646f4f91955)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitMirrorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitMirrorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__22f5f5b7bd5de36388d0d502846f3c762ac6c5b584ad37e76cf8cf99603dceac)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHorizontal")
    def reset_horizontal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontal", []))

    @jsii.member(jsii_name="resetHorizontalVar")
    def reset_horizontal_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontalVar", []))

    @jsii.member(jsii_name="resetVertical")
    def reset_vertical(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVertical", []))

    @jsii.member(jsii_name="resetVerticalVar")
    def reset_vertical_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVerticalVar", []))

    @builtins.property
    @jsii.member(jsii_name="horizontalInput")
    def horizontal_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontalVarInput")
    def horizontal_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalInput")
    def vertical_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalVarInput")
    def vertical_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontal")
    def horizontal(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontal"))

    @horizontal.setter
    def horizontal(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__423ac422d8bdb651e3a091de7197b8d4d65033c325c850d8cfc8468c631dc0e1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontal", value)

    @builtins.property
    @jsii.member(jsii_name="horizontalVar")
    def horizontal_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontalVar"))

    @horizontal_var.setter
    def horizontal_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8f8d8803236fee6d59966b3864978948ad6b6cf4ee4e9307b7901418608008d2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontalVar", value)

    @builtins.property
    @jsii.member(jsii_name="vertical")
    def vertical(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "vertical"))

    @vertical.setter
    def vertical(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__054dea33b7218e18bdb93108d1e154f25250a2e1128512bcd542704baba521ab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "vertical", value)

    @builtins.property
    @jsii.member(jsii_name="verticalVar")
    def vertical_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "verticalVar"))

    @vertical_var.setter
    def vertical_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c17c0c9c90398356b356b766e74d3e1a39ee284365d5a18c79a906ea62586ee2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "verticalVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitMirror]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitMirror]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitMirror]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ffc726de7e267b5de6fb6995e36a51caf2c2b304a5ff4d1b02cd2064f5ac3f6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitMonoHue",
    jsii_struct_bases=[],
    name_mapping={"hue": "hue", "hue_var": "hueVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitMonoHue:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__679514f15f0d1be4ad71a385ad1e26ec797bd0763a01ea4536ac684931c80f77)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitMonoHue(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitMonoHueList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitMonoHueList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0f4e6cf990383309b1f73df1065437b6e90743ee271ea142a13652c71219b2ae)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitMonoHueOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f179db281b919683a2eadb9f3a4a7f1f0075bcbdadb23282180d89ad74481f1e)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitMonoHueOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a08becd9adedb29d11b293bf28454043a172f6860d552d4303fd9116d667fc8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8f79ca6c8eb4cf3d0504d40aeff870581b87b89a008e7d2f24287535c5e62b65)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1c8b7b971c8f850c7e72d26df3abc1df32a10055ee5afa5d20fcae9527c8927c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitMonoHue]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitMonoHue]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8576cae04b0143afb82416d82d1220d20330c956eb1fad4e8d275af01723d0f5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitMonoHueOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitMonoHueOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1d96cf1a27f425d828964895f324663de78ee78e615eeea7e980aeb9fd35a4ef)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0d4b5354e1c83ecf3c48f381f4831583b8810ed4a5e5c11a74a0423bf8453fcd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__82a389c4208a76b01813ba0ca3a4379e1f6af8a6310ba57b524da2df5da156a3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitMonoHue]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitMonoHue]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitMonoHue]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3f4a13773bef209a57c6b9f67d46ce6a17681f327f8c942927bb16e6ede485a5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitOpacity",
    jsii_struct_bases=[],
    name_mapping={"opacity": "opacity", "opacity_var": "opacityVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitOpacity:
    def __init__(
        self,
        *,
        opacity: typing.Optional[builtins.str] = None,
        opacity_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param opacity: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param opacity_var: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__254ce50fe265237bf29acc64202691dd2e7c5530eded839ecc04a640b94e0f1e)
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument opacity_var", value=opacity_var, expected_type=type_hints["opacity_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if opacity is not None:
            self._values["opacity"] = opacity
        if opacity_var is not None:
            self._values["opacity_var"] = opacity_var

    @builtins.property
    def opacity(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def opacity_var(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        result = self._values.get("opacity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitOpacity(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitOpacityList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitOpacityList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__49bea1358634580a5ec4e8b7f8ccc3bcd1f2975e95bdfa23d12d4ab25101511b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitOpacityOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0e016a58e8e0101604e4569f2c094f74d43e7f87455662957868247a7148c360)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitOpacityOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b6a08d3608930c43c023b8f064fc7d47a0fa36cbc046a9b65dc5b6a766423202)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6ebd9e386d16ba7da19a627c40404483f29a33551d2bab85c8c03b1c1794199a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fe8d4be6c7ee2e9053c1c55c960d7a1a60dbf3e1a446be88a02600f24f42cdb4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitOpacity]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitOpacity]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dbce8680f093c5f75ef2b2c46dca6509a4a3bf2b95a41f3c1e650cad23b13f5a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitOpacityOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitOpacityOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fd20d5a81175c7d701805d5072a4c7b9e4544c913d384675ddebc95c2988617d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetOpacityVar")
    def reset_opacity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacityVar", []))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityVarInput")
    def opacity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacity"))

    @opacity.setter
    def opacity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__07b2fcba5b7d2030c27c8afe0e95d708cdac10df64b34721c2084c071aec90e1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacity", value)

    @builtins.property
    @jsii.member(jsii_name="opacityVar")
    def opacity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacityVar"))

    @opacity_var.setter
    def opacity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__84517c51e77472b9ab76a891565aab14b5383348a4cd99877f7519f921910cbe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacityVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitOpacity]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitOpacity]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitOpacity]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fe492aa3de178e54155b88d7f8d7d0d254b159837e69cbf5153636652f9696ab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a74a91d569205ce15694ccfc6c702ab7217581ea3a0bcca4edbab15419c5175b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putBackgroundColor")
    def put_background_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d71ff311d248020043af4269c2bf248dda6b144068ff4f56c8d58d29fc5be8d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBackgroundColor", [value]))

    @jsii.member(jsii_name="putBlur")
    def put_blur(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitBlur, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__750e94e664e7e30f0cac7e77e6e49b5dc1380c01ec2ba6b3171a9511f5f3b1f8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBlur", [value]))

    @jsii.member(jsii_name="putChromaKey")
    def put_chroma_key(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitChromaKey, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f7b67d69612ba1c43bca139f346fb2c612b7d08bc7bd29e5f8c63e831fa7eedd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putChromaKey", [value]))

    @jsii.member(jsii_name="putComposite")
    def put_composite(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitComposite, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__761498b0915f9cb3c21bc9ed710046cc41747bfe2e25ec83290bcb76ae9cae09)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putComposite", [value]))

    @jsii.member(jsii_name="putCompound")
    def put_compound(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitCompound, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6d7d5275a43768f10c6c5247d5e8880441fe14d4c3e9d5d5d528f2b7d3bd9b97)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCompound", [value]))

    @jsii.member(jsii_name="putContrast")
    def put_contrast(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitContrast, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7dffd04ab72ea426677edc1f871b212cd591660f192cd251c1cdf5fe9d1ee89b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putContrast", [value]))

    @jsii.member(jsii_name="putGoop")
    def put_goop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitGoop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__33996432dbc4271892db15ecca68f4bbd18aa435781b18a3755e9dbe74b3cdf7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGoop", [value]))

    @jsii.member(jsii_name="putGrayscale")
    def put_grayscale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitGrayscale, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__67fd572009fc26a10af862c9ef5b69d330fbe23a5e8f259a9f514a5a84b1c2f4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGrayscale", [value]))

    @jsii.member(jsii_name="putHsl")
    def put_hsl(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitHsl, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d8f83cf5438b71f10f15d9c6e223cf89007fb1c0fe6ced086dcc98f150f508a0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsl", [value]))

    @jsii.member(jsii_name="putHsv")
    def put_hsv(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitHsv, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1289727d6c79fee9844b1f0990461d0b9a638e880342d870f3cdb33d4238d9c1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsv", [value]))

    @jsii.member(jsii_name="putIfDimension")
    def put_if_dimension(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfDimension, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1ea96b0c4273c341861b300fce6497de29bb6001e05036fd5a80e989c359e0dc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfDimension", [value]))

    @jsii.member(jsii_name="putIfOrientation")
    def put_if_orientation(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e7339e8490ec50b93a6214527606633d65bf7c830ace02a718b2c3ebe7141852)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfOrientation", [value]))

    @jsii.member(jsii_name="putMaxColors")
    def put_max_colors(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitMaxColors, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea50c06a9b1f57edff5eb329ea6aca42e5170b8b6ce33d4d8d8841f88c346d89)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMaxColors", [value]))

    @jsii.member(jsii_name="putMirror")
    def put_mirror(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitMirror, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__29463ffe2718322eee234f068fb72141f0e0f0543e481fba881bb822e77c3fd7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMirror", [value]))

    @jsii.member(jsii_name="putMonoHue")
    def put_mono_hue(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitMonoHue, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5003f21d8b70cf7555ddc0b37a14f2d5c1426e765a29e3e51f78ddacd20441a2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMonoHue", [value]))

    @jsii.member(jsii_name="putOpacity")
    def put_opacity(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitOpacity, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9b49d3e53781b744cf985019ae4554c89ef2c4d5d4f582d3043bf02b272876fc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putOpacity", [value]))

    @jsii.member(jsii_name="putRemoveColor")
    def put_remove_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitRemoveColor", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__60342ef79616bfd3e9c92434d80ab91fde01691f9743a2bc42f44712c8810d3f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRemoveColor", [value]))

    @jsii.member(jsii_name="putUnsharpMask")
    def put_unsharp_mask(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitUnsharpMask", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d8feae396bebdfea563446bea426a62d3b8119c4cb86b86f4a073710973d7603)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putUnsharpMask", [value]))

    @jsii.member(jsii_name="resetBackgroundColor")
    def reset_background_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBackgroundColor", []))

    @jsii.member(jsii_name="resetBlur")
    def reset_blur(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBlur", []))

    @jsii.member(jsii_name="resetChromaKey")
    def reset_chroma_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChromaKey", []))

    @jsii.member(jsii_name="resetComposite")
    def reset_composite(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetComposite", []))

    @jsii.member(jsii_name="resetCompound")
    def reset_compound(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCompound", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetGoop")
    def reset_goop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGoop", []))

    @jsii.member(jsii_name="resetGrayscale")
    def reset_grayscale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGrayscale", []))

    @jsii.member(jsii_name="resetHsl")
    def reset_hsl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsl", []))

    @jsii.member(jsii_name="resetHsv")
    def reset_hsv(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsv", []))

    @jsii.member(jsii_name="resetIfDimension")
    def reset_if_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfDimension", []))

    @jsii.member(jsii_name="resetIfOrientation")
    def reset_if_orientation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfOrientation", []))

    @jsii.member(jsii_name="resetMaxColors")
    def reset_max_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxColors", []))

    @jsii.member(jsii_name="resetMirror")
    def reset_mirror(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMirror", []))

    @jsii.member(jsii_name="resetMonoHue")
    def reset_mono_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonoHue", []))

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetRemoveColor")
    def reset_remove_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRemoveColor", []))

    @jsii.member(jsii_name="resetUnsharpMask")
    def reset_unsharp_mask(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUnsharpMask", []))

    @builtins.property
    @jsii.member(jsii_name="backgroundColor")
    def background_color(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitBackgroundColorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitBackgroundColorList, jsii.get(self, "backgroundColor"))

    @builtins.property
    @jsii.member(jsii_name="blur")
    def blur(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitBlurList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitBlurList, jsii.get(self, "blur"))

    @builtins.property
    @jsii.member(jsii_name="chromaKey")
    def chroma_key(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitChromaKeyList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitChromaKeyList, jsii.get(self, "chromaKey"))

    @builtins.property
    @jsii.member(jsii_name="composite")
    def composite(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitCompositeList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitCompositeList, jsii.get(self, "composite"))

    @builtins.property
    @jsii.member(jsii_name="compound")
    def compound(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitCompoundList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitCompoundList, jsii.get(self, "compound"))

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitContrastList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitContrastList, jsii.get(self, "contrast"))

    @builtins.property
    @jsii.member(jsii_name="goop")
    def goop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitGoopList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitGoopList, jsii.get(self, "goop"))

    @builtins.property
    @jsii.member(jsii_name="grayscale")
    def grayscale(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitGrayscaleList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitGrayscaleList, jsii.get(self, "grayscale"))

    @builtins.property
    @jsii.member(jsii_name="hsl")
    def hsl(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitHslList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitHslList, jsii.get(self, "hsl"))

    @builtins.property
    @jsii.member(jsii_name="hsv")
    def hsv(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitHsvList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitHsvList, jsii.get(self, "hsv"))

    @builtins.property
    @jsii.member(jsii_name="ifDimension")
    def if_dimension(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfDimensionList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfDimensionList, jsii.get(self, "ifDimension"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientation")
    def if_orientation(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfOrientationList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfOrientationList, jsii.get(self, "ifOrientation"))

    @builtins.property
    @jsii.member(jsii_name="maxColors")
    def max_colors(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitMaxColorsList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitMaxColorsList, jsii.get(self, "maxColors"))

    @builtins.property
    @jsii.member(jsii_name="mirror")
    def mirror(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitMirrorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitMirrorList, jsii.get(self, "mirror"))

    @builtins.property
    @jsii.member(jsii_name="monoHue")
    def mono_hue(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitMonoHueList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitMonoHueList, jsii.get(self, "monoHue"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitOpacityList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitOpacityList, jsii.get(self, "opacity"))

    @builtins.property
    @jsii.member(jsii_name="removeColor")
    def remove_color(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitRemoveColorList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitRemoveColorList", jsii.get(self, "removeColor"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMask")
    def unsharp_mask(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitUnsharpMaskList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitUnsharpMaskList", jsii.get(self, "unsharpMask"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColorInput")
    def background_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitBackgroundColor]]], jsii.get(self, "backgroundColorInput"))

    @builtins.property
    @jsii.member(jsii_name="blurInput")
    def blur_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitBlur]]], jsii.get(self, "blurInput"))

    @builtins.property
    @jsii.member(jsii_name="chromaKeyInput")
    def chroma_key_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitChromaKey]]], jsii.get(self, "chromaKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="compositeInput")
    def composite_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitComposite]]], jsii.get(self, "compositeInput"))

    @builtins.property
    @jsii.member(jsii_name="compoundInput")
    def compound_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitCompound]]], jsii.get(self, "compoundInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitContrast]]], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="goopInput")
    def goop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitGoop]]], jsii.get(self, "goopInput"))

    @builtins.property
    @jsii.member(jsii_name="grayscaleInput")
    def grayscale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitGrayscale]]], jsii.get(self, "grayscaleInput"))

    @builtins.property
    @jsii.member(jsii_name="hslInput")
    def hsl_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitHsl]]], jsii.get(self, "hslInput"))

    @builtins.property
    @jsii.member(jsii_name="hsvInput")
    def hsv_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitHsv]]], jsii.get(self, "hsvInput"))

    @builtins.property
    @jsii.member(jsii_name="ifDimensionInput")
    def if_dimension_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfDimension]]], jsii.get(self, "ifDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientationInput")
    def if_orientation_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfOrientation]]], jsii.get(self, "ifOrientationInput"))

    @builtins.property
    @jsii.member(jsii_name="maxColorsInput")
    def max_colors_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitMaxColors]]], jsii.get(self, "maxColorsInput"))

    @builtins.property
    @jsii.member(jsii_name="mirrorInput")
    def mirror_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitMirror]]], jsii.get(self, "mirrorInput"))

    @builtins.property
    @jsii.member(jsii_name="monoHueInput")
    def mono_hue_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitMonoHue]]], jsii.get(self, "monoHueInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitOpacity]]], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="removeColorInput")
    def remove_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitRemoveColor"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitRemoveColor"]]], jsii.get(self, "removeColorInput"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMaskInput")
    def unsharp_mask_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitUnsharpMask"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitUnsharpMask"]]], jsii.get(self, "unsharpMaskInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortrait]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortrait], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortrait],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7a3af66734a9ec890b4cde7186a443f6e183c15241d878bd90c0dc50a72bcea8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitRemoveColor",
    jsii_struct_bases=[],
    name_mapping={
        "color": "color",
        "color_var": "colorVar",
        "feather": "feather",
        "feather_var": "featherVar",
        "tolerance": "tolerance",
        "tolerance_var": "toleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitRemoveColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
        feather: typing.Optional[builtins.str] = None,
        feather_var: typing.Optional[builtins.str] = None,
        tolerance: typing.Optional[builtins.str] = None,
        tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        :param feather: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        :param feather_var: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        :param tolerance: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        :param tolerance_var: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__28ab2d30668199136e3f3c5fdea36c0426040f55ef5daefcc22b61d6efd77a78)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
            check_type(argname="argument feather", value=feather, expected_type=type_hints["feather"])
            check_type(argname="argument feather_var", value=feather_var, expected_type=type_hints["feather_var"])
            check_type(argname="argument tolerance", value=tolerance, expected_type=type_hints["tolerance"])
            check_type(argname="argument tolerance_var", value=tolerance_var, expected_type=type_hints["tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var
        if feather is not None:
            self._values["feather"] = feather
        if feather_var is not None:
            self._values["feather_var"] = feather_var
        if tolerance is not None:
            self._values["tolerance"] = tolerance
        if tolerance_var is not None:
            self._values["tolerance_var"] = tolerance_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        '''
        result = self._values.get("feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather_var(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        '''
        result = self._values.get("feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        '''
        result = self._values.get("tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance_var(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        result = self._values.get("tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitRemoveColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitRemoveColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitRemoveColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8d4b7e2e2febf109f41bf44bd98de8b7bbd61d2e1d119577d96d858b4ed9167d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitRemoveColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9c1d67233c21a03c629b2aa2b5b146b9794678887a3fc5e7f9a1494ddddebc2f)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitRemoveColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aab2df48ea1073e2d316195c00c0a8f7e50e70d637006f6b0b56ece9059cf06f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d469989314e9670a387c929729c74ac9dcc49f20a35c963d5dd071f6116eb05)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5cb8dc8e05e6720eca59f48befb9049d770241b6f96db2c78c4ccdc0cec53d32)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitRemoveColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitRemoveColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitRemoveColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__db31f0880ff1f1dc5cb2cec835b578116323b712b937449c1b68c99df87061f4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitRemoveColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitRemoveColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__77a01d37dcc859b8fde7d51e55324266fa7b7a6b92ac6390b5a652df5f7b09a1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @jsii.member(jsii_name="resetFeather")
    def reset_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeather", []))

    @jsii.member(jsii_name="resetFeatherVar")
    def reset_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatherVar", []))

    @jsii.member(jsii_name="resetTolerance")
    def reset_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTolerance", []))

    @jsii.member(jsii_name="resetToleranceVar")
    def reset_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featherInput")
    def feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherInput"))

    @builtins.property
    @jsii.member(jsii_name="featherVarInput")
    def feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceInput")
    def tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceVarInput")
    def tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__647a4d017d9bda6d63302d7609ba0f518b3f11071cca6741d1fc3327b782645a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1bc6e3071699b2b16a29c4403fa2eb1b5b2ae1d4a568ca5e8287b30d07a4122f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="feather")
    def feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "feather"))

    @feather.setter
    def feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b8fd45e7e74fb285032a2d2a9dbe63bc93f4de4bed1d588c7d39962ffe82ef1b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "feather", value)

    @builtins.property
    @jsii.member(jsii_name="featherVar")
    def feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featherVar"))

    @feather_var.setter
    def feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d21d85373141db6cfde272299dd968195ad872a834343e08c078a7bf0816a076)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featherVar", value)

    @builtins.property
    @jsii.member(jsii_name="tolerance")
    def tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tolerance"))

    @tolerance.setter
    def tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b528f6f6e7d5ec47f63eeed8926a97f76efa3c6a4bbcb09649147ccf88449c8d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tolerance", value)

    @builtins.property
    @jsii.member(jsii_name="toleranceVar")
    def tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "toleranceVar"))

    @tolerance_var.setter
    def tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8dde6058d2411e38fb0058b5a635109333bfd0c2dcbd0a3f5c5e8f1c324308cb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "toleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitRemoveColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitRemoveColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitRemoveColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4e16346d3dd821d15a85b5551a41612d054f86917872734685a9c5af8c4d8b10)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitUnsharpMask",
    jsii_struct_bases=[],
    name_mapping={
        "gain": "gain",
        "gain_var": "gainVar",
        "sigma": "sigma",
        "sigma_var": "sigmaVar",
        "threshold": "threshold",
        "threshold_var": "thresholdVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitUnsharpMask:
    def __init__(
        self,
        *,
        gain: typing.Optional[builtins.str] = None,
        gain_var: typing.Optional[builtins.str] = None,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
        threshold: typing.Optional[builtins.str] = None,
        threshold_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param gain: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        :param gain_var: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        :param sigma: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        :param threshold: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        :param threshold_var: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__57c2be2b68825b38dc3c231b28b19b0435b4f62a3d8de10d4aa117e9e5f22a5b)
            check_type(argname="argument gain", value=gain, expected_type=type_hints["gain"])
            check_type(argname="argument gain_var", value=gain_var, expected_type=type_hints["gain_var"])
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
            check_type(argname="argument threshold", value=threshold, expected_type=type_hints["threshold"])
            check_type(argname="argument threshold_var", value=threshold_var, expected_type=type_hints["threshold_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if gain is not None:
            self._values["gain"] = gain
        if gain_var is not None:
            self._values["gain_var"] = gain_var
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var
        if threshold is not None:
            self._values["threshold"] = threshold
        if threshold_var is not None:
            self._values["threshold_var"] = threshold_var

    @builtins.property
    def gain(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        '''
        result = self._values.get("gain")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gain_var(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        '''
        result = self._values.get("gain_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        '''
        result = self._values.get("threshold")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold_var(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        result = self._values.get("threshold_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitUnsharpMask(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitUnsharpMaskList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitUnsharpMaskList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4fee70a2a2ff4a65a23b90fb330c76862b700a259fce5a53f1097883441f7c4b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitUnsharpMaskOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__604bc0caac7e518524311ead35814b9800a06d2bd16106194b643b2f7d4d9dfa)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitUnsharpMaskOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2b0baa7656dbffc94382103295f56102c95c840cccee4e352d3d36bf338be79e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c8c3942ec710794369d4e0f8927977c636444e515edf2ae88417c0a0dadfe32f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__998f9bcd52f43ff88e1d15b084e70da6778d112e519bd6bc7b71549f0c365025)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitUnsharpMask]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitUnsharpMask]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitUnsharpMask]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__23f3295e183ba73550e08dad49543b7689119c8155ee6642f6cdc6768adffcae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitUnsharpMaskOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitUnsharpMaskOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__66a38dfd9e8947fc1ad4bcf237104ef4e7284a13b1861e10317c009525eaaaaa)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetGain")
    def reset_gain(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGain", []))

    @jsii.member(jsii_name="resetGainVar")
    def reset_gain_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGainVar", []))

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @jsii.member(jsii_name="resetThreshold")
    def reset_threshold(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThreshold", []))

    @jsii.member(jsii_name="resetThresholdVar")
    def reset_threshold_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThresholdVar", []))

    @builtins.property
    @jsii.member(jsii_name="gainInput")
    def gain_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainInput"))

    @builtins.property
    @jsii.member(jsii_name="gainVarInput")
    def gain_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdInput")
    def threshold_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdVarInput")
    def threshold_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gain")
    def gain(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gain"))

    @gain.setter
    def gain(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__76bc34afd497257ddf95372dbbbfe0e367965ecd6ce335f834ccceff767b3910)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gain", value)

    @builtins.property
    @jsii.member(jsii_name="gainVar")
    def gain_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gainVar"))

    @gain_var.setter
    def gain_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0b75aec390d053c589bfb062d442759ce34dfe515ba83c3b11e8f09d691b1ba0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gainVar", value)

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a52a51a0d278e82aeff88cf3a41410d0e34276e3463b52f95364b7a793566e7f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e8431ea32e50e09cf9732bbe4940aa030eb0ba6740058e1233b082c1be574b10)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="threshold")
    def threshold(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "threshold"))

    @threshold.setter
    def threshold(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7279e455bc214384fd212768f08d6141f6f6b67c4fdae8f86b2b533d2f63f5af)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "threshold", value)

    @builtins.property
    @jsii.member(jsii_name="thresholdVar")
    def threshold_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "thresholdVar"))

    @threshold_var.setter
    def threshold_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bca0102ece25d6122afc503120210f5ec6cd7cb0ee5783a65d6f7209704801b2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "thresholdVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitUnsharpMask]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitUnsharpMask]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitUnsharpMask]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f9cb676631d06fab7921179c7f480a0c9b9d578888ed10e841d672054dd0a6a0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquare",
    jsii_struct_bases=[],
    name_mapping={
        "background_color": "backgroundColor",
        "blur": "blur",
        "chroma_key": "chromaKey",
        "composite": "composite",
        "compound": "compound",
        "contrast": "contrast",
        "goop": "goop",
        "grayscale": "grayscale",
        "hsl": "hsl",
        "hsv": "hsv",
        "if_dimension": "ifDimension",
        "if_orientation": "ifOrientation",
        "max_colors": "maxColors",
        "mirror": "mirror",
        "mono_hue": "monoHue",
        "opacity": "opacity",
        "remove_color": "removeColor",
        "unsharp_mask": "unsharpMask",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquare:
    def __init__(
        self,
        *,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareBackgroundColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareBlur", typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareChromaKey", typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareComposite", typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareCompound", typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareContrast", typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareGoop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareGrayscale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareHsl", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareHsv", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfDimension", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfOrientation", typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareMaxColors", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareMirror", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareMonoHue", typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareOpacity", typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareRemoveColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareUnsharpMask", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__17bffb9f1e2f016c4955eb20e54d18b7791951f68d38aecfd4cda40c80016fde)
            check_type(argname="argument background_color", value=background_color, expected_type=type_hints["background_color"])
            check_type(argname="argument blur", value=blur, expected_type=type_hints["blur"])
            check_type(argname="argument chroma_key", value=chroma_key, expected_type=type_hints["chroma_key"])
            check_type(argname="argument composite", value=composite, expected_type=type_hints["composite"])
            check_type(argname="argument compound", value=compound, expected_type=type_hints["compound"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument goop", value=goop, expected_type=type_hints["goop"])
            check_type(argname="argument grayscale", value=grayscale, expected_type=type_hints["grayscale"])
            check_type(argname="argument hsl", value=hsl, expected_type=type_hints["hsl"])
            check_type(argname="argument hsv", value=hsv, expected_type=type_hints["hsv"])
            check_type(argname="argument if_dimension", value=if_dimension, expected_type=type_hints["if_dimension"])
            check_type(argname="argument if_orientation", value=if_orientation, expected_type=type_hints["if_orientation"])
            check_type(argname="argument max_colors", value=max_colors, expected_type=type_hints["max_colors"])
            check_type(argname="argument mirror", value=mirror, expected_type=type_hints["mirror"])
            check_type(argname="argument mono_hue", value=mono_hue, expected_type=type_hints["mono_hue"])
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument remove_color", value=remove_color, expected_type=type_hints["remove_color"])
            check_type(argname="argument unsharp_mask", value=unsharp_mask, expected_type=type_hints["unsharp_mask"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if background_color is not None:
            self._values["background_color"] = background_color
        if blur is not None:
            self._values["blur"] = blur
        if chroma_key is not None:
            self._values["chroma_key"] = chroma_key
        if composite is not None:
            self._values["composite"] = composite
        if compound is not None:
            self._values["compound"] = compound
        if contrast is not None:
            self._values["contrast"] = contrast
        if goop is not None:
            self._values["goop"] = goop
        if grayscale is not None:
            self._values["grayscale"] = grayscale
        if hsl is not None:
            self._values["hsl"] = hsl
        if hsv is not None:
            self._values["hsv"] = hsv
        if if_dimension is not None:
            self._values["if_dimension"] = if_dimension
        if if_orientation is not None:
            self._values["if_orientation"] = if_orientation
        if max_colors is not None:
            self._values["max_colors"] = max_colors
        if mirror is not None:
            self._values["mirror"] = mirror
        if mono_hue is not None:
            self._values["mono_hue"] = mono_hue
        if opacity is not None:
            self._values["opacity"] = opacity
        if remove_color is not None:
            self._values["remove_color"] = remove_color
        if unsharp_mask is not None:
            self._values["unsharp_mask"] = unsharp_mask

    @builtins.property
    def background_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareBackgroundColor"]]]:
        '''background_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        '''
        result = self._values.get("background_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareBackgroundColor"]]], result)

    @builtins.property
    def blur(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareBlur"]]]:
        '''blur block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        '''
        result = self._values.get("blur")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareBlur"]]], result)

    @builtins.property
    def chroma_key(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareChromaKey"]]]:
        '''chroma_key block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        '''
        result = self._values.get("chroma_key")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareChromaKey"]]], result)

    @builtins.property
    def composite(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareComposite"]]]:
        '''composite block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        '''
        result = self._values.get("composite")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareComposite"]]], result)

    @builtins.property
    def compound(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareCompound"]]]:
        '''compound block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        '''
        result = self._values.get("compound")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareCompound"]]], result)

    @builtins.property
    def contrast(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareContrast"]]]:
        '''contrast block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareContrast"]]], result)

    @builtins.property
    def goop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareGoop"]]]:
        '''goop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        '''
        result = self._values.get("goop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareGoop"]]], result)

    @builtins.property
    def grayscale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareGrayscale"]]]:
        '''grayscale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        '''
        result = self._values.get("grayscale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareGrayscale"]]], result)

    @builtins.property
    def hsl(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareHsl"]]]:
        '''hsl block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        '''
        result = self._values.get("hsl")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareHsl"]]], result)

    @builtins.property
    def hsv(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareHsv"]]]:
        '''hsv block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        '''
        result = self._values.get("hsv")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareHsv"]]], result)

    @builtins.property
    def if_dimension(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfDimension"]]]:
        '''if_dimension block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        '''
        result = self._values.get("if_dimension")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfDimension"]]], result)

    @builtins.property
    def if_orientation(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfOrientation"]]]:
        '''if_orientation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        '''
        result = self._values.get("if_orientation")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfOrientation"]]], result)

    @builtins.property
    def max_colors(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareMaxColors"]]]:
        '''max_colors block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        '''
        result = self._values.get("max_colors")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareMaxColors"]]], result)

    @builtins.property
    def mirror(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareMirror"]]]:
        '''mirror block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        '''
        result = self._values.get("mirror")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareMirror"]]], result)

    @builtins.property
    def mono_hue(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareMonoHue"]]]:
        '''mono_hue block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        '''
        result = self._values.get("mono_hue")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareMonoHue"]]], result)

    @builtins.property
    def opacity(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareOpacity"]]]:
        '''opacity block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareOpacity"]]], result)

    @builtins.property
    def remove_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareRemoveColor"]]]:
        '''remove_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        '''
        result = self._values.get("remove_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareRemoveColor"]]], result)

    @builtins.property
    def unsharp_mask(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareUnsharpMask"]]]:
        '''unsharp_mask block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        result = self._values.get("unsharp_mask")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareUnsharpMask"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquare(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareBackgroundColor",
    jsii_struct_bases=[],
    name_mapping={"color": "color", "color_var": "colorVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareBackgroundColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df2c658781d2d6f7ead6be87a1dd68690ab487a5923bf6078766c9c31733e367)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareBackgroundColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareBackgroundColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareBackgroundColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6391920febe57298ab54e1c8161a355ae1ddf8cec08429bc636ec1a067122b5f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareBackgroundColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__54e256c7cceadb229baf6439c0c91bdc1ae1327132dfe04ecce6ca16a30075b2)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareBackgroundColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bf3adb4e8c0415bdd897c17e0f1b0dc3e523c1f6e7bebfcac71bbfd55597c55b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bf4900c8028e0ac93a1497a05912567c4500d4107b9062648e60155e38ef007b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__edaee6fd6c843f0d917d0d2f3ca899bd183e837eac3c77fe2aca64eab4d76083)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareBackgroundColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareBackgroundColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f16d6109b1101e6283586092373ae3791266954b527f7695e7494eedfbe94c1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareBackgroundColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareBackgroundColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ed232c8f81d5ab979605f83152ae06a44f9bf6b0dc6f39ad84a8d38fbcef8314)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__93feb1afb6403863564f1e0ddc9a310f63c21057a73484b1b9a6d27a6f919d67)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c7eea26ceef55535aa13d74911f8e729ab3345a1cd6a071389d52db4c7fda8a5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareBackgroundColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareBackgroundColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareBackgroundColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a91af9d0da883911d43d6b94ca96c3b85947579287e503c8cbd53d606951180)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareBlur",
    jsii_struct_bases=[],
    name_mapping={"sigma": "sigma", "sigma_var": "sigmaVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareBlur:
    def __init__(
        self,
        *,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param sigma: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7698209bbc0c69a6bfe05ae8b3c4505f46cc95c17f2c115da7edad546d7a5e5a)
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareBlur(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareBlurList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareBlurList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7a7d2006fa28fea8672b0cf9a5af43dec806da374c17836d95a3e6ba72d7e089)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareBlurOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__29aa7b68e139d5067049759968efefd0ec5ffdb8b983d2ffb9872e4b10bea971)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareBlurOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__007070d260ca13cdf2532b97c718137541aec9f238eda25f5649ba07a1e4d9d8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ab2465851988c1ec9508a894cdb94ecc829a5d7c014c306a7df675c16bf8f8d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4057feacbb6b482071bf447c8eef878e88a72c4b0e3b181daf741ae91e0fdba7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareBlur]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareBlur]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6281b2fbc11677de9f9abc8078a8ec927a1103d20ac146fcfea45c675b4d5cb2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareBlurOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareBlurOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9dde47772b59ad8b92a1f9e710e160e700043711bf892376cba479fdb6cce149)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ca2fc79d843750553766bc5107a2672f92d47d3bcdcd632427edee7138974490)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__20dc426fcd736b260b8208e2b4e40d2cc2d0c93f86f1c826bf970ba9b1a8e41b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareBlur]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareBlur]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareBlur]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9b94b76f0d44844f0f93568d10091de117136c3e59735ca5d9a26ecc60ae0e2a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareChromaKey",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_feather": "hueFeather",
        "hue_feather_var": "hueFeatherVar",
        "hue_tolerance": "hueTolerance",
        "hue_tolerance_var": "hueToleranceVar",
        "hue_var": "hueVar",
        "lightness_feather": "lightnessFeather",
        "lightness_feather_var": "lightnessFeatherVar",
        "lightness_tolerance": "lightnessTolerance",
        "lightness_tolerance_var": "lightnessToleranceVar",
        "saturation_feather": "saturationFeather",
        "saturation_feather_var": "saturationFeatherVar",
        "saturation_tolerance": "saturationTolerance",
        "saturation_tolerance_var": "saturationToleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareChromaKey:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_feather: typing.Optional[builtins.str] = None,
        hue_feather_var: typing.Optional[builtins.str] = None,
        hue_tolerance: typing.Optional[builtins.str] = None,
        hue_tolerance_var: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness_feather: typing.Optional[builtins.str] = None,
        lightness_feather_var: typing.Optional[builtins.str] = None,
        lightness_tolerance: typing.Optional[builtins.str] = None,
        lightness_tolerance_var: typing.Optional[builtins.str] = None,
        saturation_feather: typing.Optional[builtins.str] = None,
        saturation_feather_var: typing.Optional[builtins.str] = None,
        saturation_tolerance: typing.Optional[builtins.str] = None,
        saturation_tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_feather: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        :param hue_feather_var: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        :param hue_tolerance: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        :param hue_tolerance_var: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        :param hue_var: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness_feather: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        :param lightness_feather_var: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        :param lightness_tolerance: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        :param lightness_tolerance_var: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        :param saturation_feather: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        :param saturation_feather_var: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        :param saturation_tolerance: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        :param saturation_tolerance_var: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4227710b5d1354c24532be9bd5f1601fcf6c8c0add1dd8cec470e93fe5c89c29)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_feather", value=hue_feather, expected_type=type_hints["hue_feather"])
            check_type(argname="argument hue_feather_var", value=hue_feather_var, expected_type=type_hints["hue_feather_var"])
            check_type(argname="argument hue_tolerance", value=hue_tolerance, expected_type=type_hints["hue_tolerance"])
            check_type(argname="argument hue_tolerance_var", value=hue_tolerance_var, expected_type=type_hints["hue_tolerance_var"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness_feather", value=lightness_feather, expected_type=type_hints["lightness_feather"])
            check_type(argname="argument lightness_feather_var", value=lightness_feather_var, expected_type=type_hints["lightness_feather_var"])
            check_type(argname="argument lightness_tolerance", value=lightness_tolerance, expected_type=type_hints["lightness_tolerance"])
            check_type(argname="argument lightness_tolerance_var", value=lightness_tolerance_var, expected_type=type_hints["lightness_tolerance_var"])
            check_type(argname="argument saturation_feather", value=saturation_feather, expected_type=type_hints["saturation_feather"])
            check_type(argname="argument saturation_feather_var", value=saturation_feather_var, expected_type=type_hints["saturation_feather_var"])
            check_type(argname="argument saturation_tolerance", value=saturation_tolerance, expected_type=type_hints["saturation_tolerance"])
            check_type(argname="argument saturation_tolerance_var", value=saturation_tolerance_var, expected_type=type_hints["saturation_tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_feather is not None:
            self._values["hue_feather"] = hue_feather
        if hue_feather_var is not None:
            self._values["hue_feather_var"] = hue_feather_var
        if hue_tolerance is not None:
            self._values["hue_tolerance"] = hue_tolerance
        if hue_tolerance_var is not None:
            self._values["hue_tolerance_var"] = hue_tolerance_var
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness_feather is not None:
            self._values["lightness_feather"] = lightness_feather
        if lightness_feather_var is not None:
            self._values["lightness_feather_var"] = lightness_feather_var
        if lightness_tolerance is not None:
            self._values["lightness_tolerance"] = lightness_tolerance
        if lightness_tolerance_var is not None:
            self._values["lightness_tolerance_var"] = lightness_tolerance_var
        if saturation_feather is not None:
            self._values["saturation_feather"] = saturation_feather
        if saturation_feather_var is not None:
            self._values["saturation_feather_var"] = saturation_feather_var
        if saturation_tolerance is not None:
            self._values["saturation_tolerance"] = saturation_tolerance
        if saturation_tolerance_var is not None:
            self._values["saturation_tolerance_var"] = saturation_tolerance_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        '''
        result = self._values.get("hue_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        '''
        result = self._values.get("hue_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        '''
        result = self._values.get("hue_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        '''
        result = self._values.get("hue_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        '''
        result = self._values.get("lightness_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        '''
        result = self._values.get("lightness_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        '''
        result = self._values.get("lightness_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        '''
        result = self._values.get("lightness_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        '''
        result = self._values.get("saturation_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        '''
        result = self._values.get("saturation_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        '''
        result = self._values.get("saturation_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        result = self._values.get("saturation_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareChromaKey(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareChromaKeyList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareChromaKeyList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b9c687c45cb3a0c23233ed2777b0f8b75c46f1bb9ffae28113847907bb97329c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareChromaKeyOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__90db1637745c1e75783bd3ae145e4e8e608fdd78dcb37d0cda43e2d93fa169f5)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareChromaKeyOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a1b6e2eb6c71b438476dbd80d79446dac707b189cc800052257faf734779f7a0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d610b0b31a6f0af79d828ee252e3a23475fae2e4f2d9f2c8bdd20202e366ac0f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb6c6776252cc07a0847b01c1e74626170b610c40f4d1d9bad8e23447b5c4ad4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareChromaKey]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareChromaKey]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ff20f259107c31b28e2118aa7c6ef0cca6e42cb4f51253d16530dde801abb561)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareChromaKeyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareChromaKeyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8cf3e0dcb4c4eeb92ad42d139d8c064013d4f4085d1a9d21654921befd52dfe9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueFeather")
    def reset_hue_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeather", []))

    @jsii.member(jsii_name="resetHueFeatherVar")
    def reset_hue_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeatherVar", []))

    @jsii.member(jsii_name="resetHueTolerance")
    def reset_hue_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueTolerance", []))

    @jsii.member(jsii_name="resetHueToleranceVar")
    def reset_hue_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueToleranceVar", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightnessFeather")
    def reset_lightness_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeather", []))

    @jsii.member(jsii_name="resetLightnessFeatherVar")
    def reset_lightness_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeatherVar", []))

    @jsii.member(jsii_name="resetLightnessTolerance")
    def reset_lightness_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessTolerance", []))

    @jsii.member(jsii_name="resetLightnessToleranceVar")
    def reset_lightness_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessToleranceVar", []))

    @jsii.member(jsii_name="resetSaturationFeather")
    def reset_saturation_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeather", []))

    @jsii.member(jsii_name="resetSaturationFeatherVar")
    def reset_saturation_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeatherVar", []))

    @jsii.member(jsii_name="resetSaturationTolerance")
    def reset_saturation_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationTolerance", []))

    @jsii.member(jsii_name="resetSaturationToleranceVar")
    def reset_saturation_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherInput")
    def hue_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVarInput")
    def hue_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceInput")
    def hue_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVarInput")
    def hue_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherInput")
    def lightness_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVarInput")
    def lightness_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceInput")
    def lightness_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVarInput")
    def lightness_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherInput")
    def saturation_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVarInput")
    def saturation_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceInput")
    def saturation_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVarInput")
    def saturation_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__19aae7ef7e1acdf8572aa1ee1c728c0d9dba2b8dca287544930f7caa4b1fddcc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeather")
    def hue_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeather"))

    @hue_feather.setter
    def hue_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a08251066b78e66a84f9fa45ecd1e25b09d00bc4fff1a2fedaa39042b3fed446)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeather", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVar")
    def hue_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeatherVar"))

    @hue_feather_var.setter
    def hue_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1815ceb4a97c0767e9b7da2314922adaa31495691f8266f9f7ef4aed41219b2b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueTolerance")
    def hue_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueTolerance"))

    @hue_tolerance.setter
    def hue_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e3ac7ea08b8dec0924197db21a6ae3f84642df8b3f99d30f8c76439fee7d6c2e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVar")
    def hue_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueToleranceVar"))

    @hue_tolerance_var.setter
    def hue_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7ad80f4ba9d78635b75486eba57e0b3f275dcfe01c7b24c5d5cd2373f9382a64)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d4cc8c50169e7472cacbd80b2eb3d875a91a6450f65863901979b65a68d71a7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeather")
    def lightness_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeather"))

    @lightness_feather.setter
    def lightness_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__019dc38d6d3552126e65dec122ffed82997bfaf76231bef8509c2e2e717ef4fb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeather", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVar")
    def lightness_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeatherVar"))

    @lightness_feather_var.setter
    def lightness_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__18c46d378f30c17a4aa456c1dd1f6c9a8d4def77c13c1bab0a335a135d4a4d54)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessTolerance")
    def lightness_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessTolerance"))

    @lightness_tolerance.setter
    def lightness_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__268c70dba9e82776636fb3042df0f12bcf79c488fb80833f4af8ceec4f979f89)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVar")
    def lightness_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessToleranceVar"))

    @lightness_tolerance_var.setter
    def lightness_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3152989252440c7c15b9bdd7c28e7d4cd116fe1b5e0e8a4fd1ce4f6b3436d453)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeather")
    def saturation_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeather"))

    @saturation_feather.setter
    def saturation_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a5c25123284f416c1d2675b6bb091274994530b53294f316c19cddbbbddf71a8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeather", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVar")
    def saturation_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeatherVar"))

    @saturation_feather_var.setter
    def saturation_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b6656fc522f1f5e0fbea1a3b87a04cbcfef1654837dffbd470030fc98a575e3c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationTolerance")
    def saturation_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationTolerance"))

    @saturation_tolerance.setter
    def saturation_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e47eaf42be07f47c1e26adb3d47edb5a92241006a54fa9c86ae22381a07138c7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVar")
    def saturation_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationToleranceVar"))

    @saturation_tolerance_var.setter
    def saturation_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab83506f6016267330ad16f6987acf8165216f4c04036532e96d429c3261f354)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareChromaKey]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareChromaKey]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareChromaKey]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__26eb5ea04c81ae3fdb5c9940683f05822659ac57ed7307a4c438b2590fece438)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareComposite",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "placement": "placement",
        "placement_var": "placementVar",
        "scale": "scale",
        "scale_dimension": "scaleDimension",
        "scale_dimension_var": "scaleDimensionVar",
        "scale_var": "scaleVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareComposite:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareCompositeImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        placement: typing.Optional[builtins.str] = None,
        placement_var: typing.Optional[builtins.str] = None,
        scale: typing.Optional[builtins.str] = None,
        scale_dimension: typing.Optional[builtins.str] = None,
        scale_dimension_var: typing.Optional[builtins.str] = None,
        scale_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param placement: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        :param placement_var: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        :param scale: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param scale_dimension: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        :param scale_dimension_var: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        :param scale_var: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        :param x_position: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareCompositeImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6019f83516f0ca67746b53d2068ff0ec033e95968e4842b02de90f4f53e1097f)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument placement", value=placement, expected_type=type_hints["placement"])
            check_type(argname="argument placement_var", value=placement_var, expected_type=type_hints["placement_var"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument scale_dimension", value=scale_dimension, expected_type=type_hints["scale_dimension"])
            check_type(argname="argument scale_dimension_var", value=scale_dimension_var, expected_type=type_hints["scale_dimension_var"])
            check_type(argname="argument scale_var", value=scale_var, expected_type=type_hints["scale_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if placement is not None:
            self._values["placement"] = placement
        if placement_var is not None:
            self._values["placement_var"] = placement_var
        if scale is not None:
            self._values["scale"] = scale
        if scale_dimension is not None:
            self._values["scale_dimension"] = scale_dimension
        if scale_dimension_var is not None:
            self._values["scale_dimension_var"] = scale_dimension_var
        if scale_var is not None:
            self._values["scale_var"] = scale_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareCompositeImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareCompositeImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        '''
        result = self._values.get("placement")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement_var(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        '''
        result = self._values.get("placement_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        '''
        result = self._values.get("scale_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        '''
        result = self._values.get("scale_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        '''
        result = self._values.get("scale_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareComposite(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareCompositeImage",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareCompositeImage:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareCompositeImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareCompositeImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareCompositeImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0d9e92eca5fc06ef0d6bbdcca1fca88050508335520e860c4d908769e439f1b5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareCompositeImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareCompositeImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__77a6929437bf6f0f8fc467c36ff891c86b8744105155d1c31d55a5f46486e539)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareCompositeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareCompositeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e59d698da09aadd9443ed12857d261eeb712ebfa6878e670c4109960382bc067)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareCompositeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b3c8892ce01cdbdd08767e6814efaea29083ea60594c74dd5c381f21883cc402)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareCompositeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4d4aacd7e317c027788e624a74520bd7fd62e540c5498b6a905b08f42632c17e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__720e478e16e249ba74be4f045659e8cd4112be891c3aaefdcd88aeb9f9fc52c3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ed0c47e0b70f760b33d2fc1ab1c13f0716365d2031c816cc37c0788e5c030933)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareComposite]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareComposite]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__807754e2fd9f4b262f229b81af450b07bcc95e31d4be7df84d944600ae59e4c0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareCompositeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareCompositeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f2c76fb670ab1ec2cb6b9b3a1b1f68325c33b8f25e99138dc2c160d11a0f7f69)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareCompositeImage()

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPlacement")
    def reset_placement(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacement", []))

    @jsii.member(jsii_name="resetPlacementVar")
    def reset_placement_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacementVar", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetScaleDimension")
    def reset_scale_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimension", []))

    @jsii.member(jsii_name="resetScaleDimensionVar")
    def reset_scale_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimensionVar", []))

    @jsii.member(jsii_name="resetScaleVar")
    def reset_scale_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareCompositeImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareCompositeImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareCompositeImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="placementInput")
    def placement_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementInput"))

    @builtins.property
    @jsii.member(jsii_name="placementVarInput")
    def placement_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionInput")
    def scale_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVarInput")
    def scale_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleVarInput")
    def scale_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ba2aa02e21123e0430ff874385c1dbd70f9945f0b644460f059c00654c52b900)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb343ececcd3f9f1d03a9ec9c8c74cdbbd156d6af67b16ba9d0f49c9acdb13a2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="placement")
    def placement(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placement"))

    @placement.setter
    def placement(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__800864ea4608ced74a3a6d723a8967b37f72ece441ff2a297baf8cbc5f1de311)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placement", value)

    @builtins.property
    @jsii.member(jsii_name="placementVar")
    def placement_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placementVar"))

    @placement_var.setter
    def placement_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6c33a823e7c459544b2312582e3d2759e6d9bd1d437f593687b425a0123247cb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placementVar", value)

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scale"))

    @scale.setter
    def scale(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eccd87bf11d8cf98e0f2b91848c6d5c158918d46fc56ccbac9b0097d450a241c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scale", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimension")
    def scale_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimension"))

    @scale_dimension.setter
    def scale_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cfc952091ab26806292719414cecad6f1ac4f93c441c9fa6c20c296ecebc3765)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimension", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVar")
    def scale_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimensionVar"))

    @scale_dimension_var.setter
    def scale_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__16aa0abbbb77c5cfc0f31e8def9e5e0c0c6dc7a32d6cacf9597400c0cb1cad87)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="scaleVar")
    def scale_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleVar"))

    @scale_var.setter
    def scale_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a227ed6bbd1ce00345198166da36060d0e45fe5429fe846088409a4b31ca2063)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab1feb09f5ead89589a2c1001ebbc9ace0e94da3f6cac62b834ddf71337b31c6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7dac3408093cd47f2dab2ecaf9b895c35735abaaf7ed3a4b3fb531c221b4aefa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__16540e10b830fac997c8811fcd1147a6f6e86a7b75e325dd94b22a1e6ac0af70)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0011c5faf56f3dc82d59a6bb4d707d2db35a63211e718b8231f7d28d67efb572)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareComposite]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareComposite]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareComposite]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1445499a56a01547bf5636083703304bd7af48c804e1d39c295d788985148e10)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareCompound",
    jsii_struct_bases=[],
    name_mapping={"transformations": "transformations"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareCompound:
    def __init__(
        self,
        *,
        transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param transformations: transformations block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6714535a739ed775f944eb278fc7f66d92b0b5249b037cd183e2da45ecddd7b3)
            check_type(argname="argument transformations", value=transformations, expected_type=type_hints["transformations"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if transformations is not None:
            self._values["transformations"] = transformations

    @builtins.property
    def transformations(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareCompoundTransformations"]]]:
        '''transformations block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        result = self._values.get("transformations")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareCompoundTransformations"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareCompound(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareCompoundList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareCompoundList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ae42bfd232692182837d1c391d6d4770de61a5f147eeb0c72b18b1fbc49c7bf0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareCompoundOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__182bc00c31765f2b075516b6507b9b88b6ece462774705f50837f02130164b3d)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareCompoundOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a839ad71e621a1bb7ed27cbc1650b6d917c5e202038d123402664723b9fe98f7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6da36de52a7a727f765827c4f046c83028d3384e626e5e7660122a7c0bda12a2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__32f3ae5f678b33e5d828dd343f22d968480df84e195534e42ed7f1c20a3a5a5f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareCompound]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareCompound]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__157fe11873a799ee6717979a5edc3d5157a8c6e0c8404c40f7265927262dcb4b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareCompoundOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareCompoundOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b96b3eabf0173c9de3958150bb4147df73c900290dbb3707c4281d645c55afe7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformations")
    def put_transformations(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ef68c9498388a78986cce7eb64753152d1427a45b40c3874728228bf39d96ea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTransformations", [value]))

    @jsii.member(jsii_name="resetTransformations")
    def reset_transformations(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformations", []))

    @builtins.property
    @jsii.member(jsii_name="transformations")
    def transformations(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareCompoundTransformationsList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareCompoundTransformationsList", jsii.get(self, "transformations"))

    @builtins.property
    @jsii.member(jsii_name="transformationsInput")
    def transformations_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareCompoundTransformations"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareCompoundTransformations"]]], jsii.get(self, "transformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareCompound]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareCompound]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareCompound]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e79d62507ed35ae0e2b18353014972e5a79b543749da9e4cd283dc93e1d373d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareCompoundTransformations",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareCompoundTransformations:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareCompoundTransformations(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareCompoundTransformationsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareCompoundTransformationsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__70858432ba75e97302c337d496293a9346314b9e7462db17daba20d055bfd5da)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareCompoundTransformationsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8d718afd25722ca7474ed9d0af20ab5df71df34c73c18ca6df895588365c99a4)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareCompoundTransformationsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__39ed477938d5f1d4a667a1556096f3aacde7349f08bdffba625b6165152768c2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e872bf68fa8cdde5fb57ce941fe1c58be3696330dc6368e6763c66719b3c45bc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7238012066000eb2ba6814620210728bc28de721924a1b2bfefc07b51c6c19c1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareCompoundTransformations]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareCompoundTransformations]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareCompoundTransformations]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2758516238f10c52d31cf61848f8e4821109b8070859d249be00c78f5b8c634f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareCompoundTransformationsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareCompoundTransformationsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6ca5d48bb94741f7a6bf04e6edafeaa840f8c316d484d31f874d4b770c7a2c7e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareCompoundTransformations]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareCompoundTransformations]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareCompoundTransformations]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e29de3113a6b051ceaeab97f747ca240f28bfdf7cf02cb729cc60ee0c949178d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareContrast",
    jsii_struct_bases=[],
    name_mapping={
        "brightness": "brightness",
        "brightness_var": "brightnessVar",
        "contrast": "contrast",
        "contrast_var": "contrastVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareContrast:
    def __init__(
        self,
        *,
        brightness: typing.Optional[builtins.str] = None,
        brightness_var: typing.Optional[builtins.str] = None,
        contrast: typing.Optional[builtins.str] = None,
        contrast_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param brightness: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        :param brightness_var: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        :param contrast: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param contrast_var: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__370f872ad7c8e3b646927459d2ee262a51371e839c04d62986a64e06b04644a7)
            check_type(argname="argument brightness", value=brightness, expected_type=type_hints["brightness"])
            check_type(argname="argument brightness_var", value=brightness_var, expected_type=type_hints["brightness_var"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument contrast_var", value=contrast_var, expected_type=type_hints["contrast_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if brightness is not None:
            self._values["brightness"] = brightness
        if brightness_var is not None:
            self._values["brightness_var"] = brightness_var
        if contrast is not None:
            self._values["contrast"] = contrast
        if contrast_var is not None:
            self._values["contrast_var"] = contrast_var

    @builtins.property
    def brightness(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        '''
        result = self._values.get("brightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def brightness_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        '''
        result = self._values.get("brightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        result = self._values.get("contrast_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareContrast(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareContrastList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareContrastList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f4ebf628f8ccd70a1605a8506f9f89e1c15845bc4dc797cebb61188fd82ca68)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareContrastOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1411712d31d7bc2d826d402947bd87b8163a0ef141c9d55fb86f383e13689f00)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareContrastOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4133954be6a41456f0eec455d36854cdba4b424cd60923553556064527f81ac2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__201ed8ce22d3421410b3b812ce2255479897472b83bf6dfd1bb478101a698d2a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__99d88873dd7b521d8aa637c310e2d24cd2772f22189614c381dd3172e346a7eb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareContrast]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareContrast]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f465873312287d2b086da97c52d8e2e6637ba59ac37a49a1615abee51b4e7818)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareContrastOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareContrastOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7fceb0ac52a7005499cfd6cc3973660744c8329f720ae4a3ae30b8cadcce87f1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetBrightness")
    def reset_brightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightness", []))

    @jsii.member(jsii_name="resetBrightnessVar")
    def reset_brightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightnessVar", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetContrastVar")
    def reset_contrast_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrastVar", []))

    @builtins.property
    @jsii.member(jsii_name="brightnessInput")
    def brightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="brightnessVarInput")
    def brightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastVarInput")
    def contrast_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="brightness")
    def brightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightness"))

    @brightness.setter
    def brightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6a9a86f10d78a8d2f6bf4c4b826f892a3878c9e2040f1cee2856270a1449128c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightness", value)

    @builtins.property
    @jsii.member(jsii_name="brightnessVar")
    def brightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightnessVar"))

    @brightness_var.setter
    def brightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__50cc91d45f2faea41812704d764f1480a73162e7dc1c34931803d20d682605f2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrast"))

    @contrast.setter
    def contrast(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1929a452f243bef00b55760ffb40ddf592d4dff30f13a7027795438513619614)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrast", value)

    @builtins.property
    @jsii.member(jsii_name="contrastVar")
    def contrast_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrastVar"))

    @contrast_var.setter
    def contrast_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0e50b130ce2f16dca92b2e47c5331aff273836ce4d92d2577d206924586f0cad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrastVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareContrast]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareContrast]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareContrast]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9bdb647c1adaa92379c8eaa95aa2ec6283a7b153117a2c9fdb7c93f3d7765330)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareGoop",
    jsii_struct_bases=[],
    name_mapping={
        "chaos": "chaos",
        "chaos_var": "chaosVar",
        "density": "density",
        "density_var": "densityVar",
        "power": "power",
        "power_var": "powerVar",
        "seed": "seed",
        "seed_var": "seedVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareGoop:
    def __init__(
        self,
        *,
        chaos: typing.Optional[builtins.str] = None,
        chaos_var: typing.Optional[builtins.str] = None,
        density: typing.Optional[builtins.str] = None,
        density_var: typing.Optional[builtins.str] = None,
        power: typing.Optional[builtins.str] = None,
        power_var: typing.Optional[builtins.str] = None,
        seed: typing.Optional[builtins.str] = None,
        seed_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param chaos: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        :param chaos_var: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        :param density: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        :param density_var: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        :param power: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        :param power_var: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        :param seed: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        :param seed_var: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__17dbaa5216c0902de3e5e46230f407fc84bd66f4e93123cc55f9686d32237dff)
            check_type(argname="argument chaos", value=chaos, expected_type=type_hints["chaos"])
            check_type(argname="argument chaos_var", value=chaos_var, expected_type=type_hints["chaos_var"])
            check_type(argname="argument density", value=density, expected_type=type_hints["density"])
            check_type(argname="argument density_var", value=density_var, expected_type=type_hints["density_var"])
            check_type(argname="argument power", value=power, expected_type=type_hints["power"])
            check_type(argname="argument power_var", value=power_var, expected_type=type_hints["power_var"])
            check_type(argname="argument seed", value=seed, expected_type=type_hints["seed"])
            check_type(argname="argument seed_var", value=seed_var, expected_type=type_hints["seed_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if chaos is not None:
            self._values["chaos"] = chaos
        if chaos_var is not None:
            self._values["chaos_var"] = chaos_var
        if density is not None:
            self._values["density"] = density
        if density_var is not None:
            self._values["density_var"] = density_var
        if power is not None:
            self._values["power"] = power
        if power_var is not None:
            self._values["power_var"] = power_var
        if seed is not None:
            self._values["seed"] = seed
        if seed_var is not None:
            self._values["seed_var"] = seed_var

    @builtins.property
    def chaos(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        '''
        result = self._values.get("chaos")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def chaos_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        '''
        result = self._values.get("chaos_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        '''
        result = self._values.get("density")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density_var(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        '''
        result = self._values.get("density_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        '''
        result = self._values.get("power")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power_var(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        '''
        result = self._values.get("power_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        '''
        result = self._values.get("seed")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed_var(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        result = self._values.get("seed_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareGoop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareGoopList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareGoopList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c523b38f70878a762dd5c8fa7a50098796f27992d1ba909a70f97c0a08f3ac26)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareGoopOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f634825ff34784bf382718e9bc4b344104aea67dbc6e1fed1309c2960a792c8b)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareGoopOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__28d1cb55fbead36e3069a9bb1f579c9617020a57adf38f910241965b7fcf9747)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__71f1e8b49524b35e504a8b7c82563986c179b8dbf5acc0485e1c5d0fa8352c21)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ef6e83a479f9ac58b0f1cf61dd7cb26f17d947c3b82bcbe67dab4e197de78c6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareGoop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareGoop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a35646504f33e30b20de25bdf5e296e6b0c01acecd89136e3d5f2ae68736ec6f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareGoopOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareGoopOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d4971a7dba1b946d51d90807bee950eaead943d627365ad549f0c2b735f12f8f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetChaos")
    def reset_chaos(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaos", []))

    @jsii.member(jsii_name="resetChaosVar")
    def reset_chaos_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaosVar", []))

    @jsii.member(jsii_name="resetDensity")
    def reset_density(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensity", []))

    @jsii.member(jsii_name="resetDensityVar")
    def reset_density_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensityVar", []))

    @jsii.member(jsii_name="resetPower")
    def reset_power(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPower", []))

    @jsii.member(jsii_name="resetPowerVar")
    def reset_power_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPowerVar", []))

    @jsii.member(jsii_name="resetSeed")
    def reset_seed(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeed", []))

    @jsii.member(jsii_name="resetSeedVar")
    def reset_seed_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeedVar", []))

    @builtins.property
    @jsii.member(jsii_name="chaosInput")
    def chaos_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosInput"))

    @builtins.property
    @jsii.member(jsii_name="chaosVarInput")
    def chaos_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosVarInput"))

    @builtins.property
    @jsii.member(jsii_name="densityInput")
    def density_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityInput"))

    @builtins.property
    @jsii.member(jsii_name="densityVarInput")
    def density_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="powerInput")
    def power_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerInput"))

    @builtins.property
    @jsii.member(jsii_name="powerVarInput")
    def power_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerVarInput"))

    @builtins.property
    @jsii.member(jsii_name="seedInput")
    def seed_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedInput"))

    @builtins.property
    @jsii.member(jsii_name="seedVarInput")
    def seed_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedVarInput"))

    @builtins.property
    @jsii.member(jsii_name="chaos")
    def chaos(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaos"))

    @chaos.setter
    def chaos(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9e095576d80620e199ad5611dbf4cacb2ceb71913240d839ee0a44a7d90e0a56)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaos", value)

    @builtins.property
    @jsii.member(jsii_name="chaosVar")
    def chaos_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaosVar"))

    @chaos_var.setter
    def chaos_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b3df806fb649246eedac7b8bab85332073b1fc0264c5c6887821ca49f122275a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaosVar", value)

    @builtins.property
    @jsii.member(jsii_name="density")
    def density(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "density"))

    @density.setter
    def density(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9472304f2d0a6c401a5a0c8275f5e791bc23b0098919810d77e062d2f6400c01)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "density", value)

    @builtins.property
    @jsii.member(jsii_name="densityVar")
    def density_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "densityVar"))

    @density_var.setter
    def density_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cfef8c374710a914e69a068a705299d3dc49a63643f2a4843278a3a05f1b1924)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "densityVar", value)

    @builtins.property
    @jsii.member(jsii_name="power")
    def power(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "power"))

    @power.setter
    def power(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__948fcb383d6ef05773fa0e3c686f91450059c91ee519554c75fa2ff80a72699b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "power", value)

    @builtins.property
    @jsii.member(jsii_name="powerVar")
    def power_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "powerVar"))

    @power_var.setter
    def power_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a3e0b0e025adfdc5a277756227d25d4bc0bd1816a850087ac491a0dd013efb5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "powerVar", value)

    @builtins.property
    @jsii.member(jsii_name="seed")
    def seed(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seed"))

    @seed.setter
    def seed(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__39a0e56c0a3356ad16a3b1dcae3ba134640b4fda1359ee634c80f76ba98c0551)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seed", value)

    @builtins.property
    @jsii.member(jsii_name="seedVar")
    def seed_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seedVar"))

    @seed_var.setter
    def seed_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac824785df9523e19c84fe8eacb1d69979780de681a0d48c8dc95f277345a016)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seedVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareGoop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareGoop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareGoop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e9f35bd88eaa08e63858c8bf2abaa56231886b9800ad91d13b795df85a49f7f1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareGrayscale",
    jsii_struct_bases=[],
    name_mapping={"type": "type", "type_var": "typeVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareGrayscale:
    def __init__(
        self,
        *,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param type: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab80dbe2d4529a17ae68c85a247adc7125b68fc9564a0767ac7c780d2c6713dc)
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareGrayscale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareGrayscaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareGrayscaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1126471097ab93349db8918ecd9ab09c9e93116f277d3a66e2f0ffb9332286f7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareGrayscaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bd33f2ea69b7d6655b8b73bed1c6d4e0d388577a187dab5a952692261cdb8196)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareGrayscaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c75d9e93fdb04ad586ad3608ef1e92a17eb0d5bdc1b6d8e2e81df41ec55d0f9f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__370be8a7d1fa7a3f4731fb486c0774c1d69823d5fe9fbcdf16a8bb7a0bed8862)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__12c40f5f64a22b350c9d1304b10314ab808e44a441b1a5cdf7f4c2d64075d2ff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareGrayscale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareGrayscale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__da31e7c3c9a77e1d596ddb4909c2de7bb75ebf648b82a9cf2be7c94107f180e8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareGrayscaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareGrayscaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a1e78cf9bce4f3651d4e1087343d9cd28cea9627d12382220d128de2bdc825e3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d779191f6b63221322c6313ad18d4d67a44293e5c2c595a58527582df620903)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a7f47b5e1ccc88f0fd3d02979e5f6bc421fe3710f5d5f400d05046ed540f38e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareGrayscale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareGrayscale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareGrayscale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3024b166a574a3ac218293ee193146350e24ecf7504a6ecf3bcb1264460c5d97)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareHsl",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "lightness": "lightness",
        "lightness_var": "lightnessVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareHsl:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness: typing.Optional[builtins.str] = None,
        lightness_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        :param lightness_var: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__228ddd1bbcb288adc6e115770ac593182b36828f1d84975c8746a1e786241528)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness", value=lightness, expected_type=type_hints["lightness"])
            check_type(argname="argument lightness_var", value=lightness_var, expected_type=type_hints["lightness_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness is not None:
            self._values["lightness"] = lightness
        if lightness_var is not None:
            self._values["lightness_var"] = lightness_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        '''
        result = self._values.get("lightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        '''
        result = self._values.get("lightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareHsl(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareHslList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareHslList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8f139bf519f597cb2428b6280e22a06d3ba89108f494f070bf4e9be5f9a028cb)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareHslOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f417d52b86a466f4e81a1e6e062bb364d31b8dc742f9398e9abaae36481e27e)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareHslOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9de474ec012add2ded9543ba22b963d86a04186b1be17ac5c3c38e49e869b8db)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fed8b1f70627ee59004b0644522f9638e4e2053baabcdd5da17c98aa35122192)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4767a7f08a7d9048181661b65cce678d4b09c0e88d65bdeb487ce77730d58b84)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareHsl]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareHsl]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5114c61ad004c200d8a2131db0ddca20c70e9413303f5e0ce0631f30bd0187b0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareHslOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareHslOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__653cf98549bb500ed668bbf32c4df2b08a082da119dafbbb24ceb0a1936426dd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightness")
    def reset_lightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightness", []))

    @jsii.member(jsii_name="resetLightnessVar")
    def reset_lightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessInput")
    def lightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessVarInput")
    def lightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__17b88bc52f4e23817433e097f1caa68c69228d1d9a12c51c98e6393caf331f13)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__100110c3c945f0d4cea666cd29ca48ff4061c5f78721417758d28e358c0de551)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightness")
    def lightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightness"))

    @lightness.setter
    def lightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__47c859d0b1823a268474ff068e0661b0d230df1a739af2735146d69c45cedf54)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightness", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessVar")
    def lightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessVar"))

    @lightness_var.setter
    def lightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8752f8f7308de3b71dd0d77303a1dae6c0031bc38e129c2e7a023fb8d5699445)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ce63dbffb6fab1724167598a4b19bbdb09add3e9da9966c7e77a1889c04ba0f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab021736f4f4db3406189b9c231e20b8624dfb594aed8b3a4554e03a4b33282d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareHsl]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareHsl]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareHsl]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__477af62adc38fcdd189c3de5091b3ae358288545934d698780a368fdf1f943f5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareHsv",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareHsv:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        :param value: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c84f330168e3e0b54aade7d17e9e3e1ad6fad1dd2b2b74bbad2e4bba2a228661)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareHsv(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareHsvList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareHsvList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__05b6be478eddeb2e31548fe7c6ebb55f70e21eb1627e164834a63fcb6a33165e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareHsvOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3992e3f8d2b5c644a3f8170e4641a121d2c4d8ca0b0683f65369a6c03bdc2854)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareHsvOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__90129498e2c490fa2211a7bdf53fad9cff12661b3d058d084eeccbef6d3701a3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f1b24fa3ceb45a246a18b21257234ede840b5be25580ab47bb4cefc48eadb59c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b06ca39b59390fbe62b97fbf262d9fbebb4202140ed492c3af25a9c1f2aecd41)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareHsv]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareHsv]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f423f50713313f2ac959672c15d5cdcb037b078b76fbd025065f3bf2f7a64abb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareHsvOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareHsvOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__40547a8fd483e1cca587ba8aa34f975db66cf089cba5b5fb264c2fd3a9940573)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__916a5f7fcaa380e2c2f257ec7319b7af476920f007eaee07221c9b32810cc0f9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f482c5bb6cb3de3def3f9d5d8500e450417c24b743806efa7137120252ab3f8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__54b400075d3067ffd50df8ae2c01b7dec0a7204ff7e28c7f071f4339e3e5f352)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__77a47fd1cf254782d7c0337521197f10d379c393134ac8ee87afb07bc2780dbe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ca6be21b76c25194f0aa60e1c5c070b2354aea5145ed608031df9b95cf4bb410)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__74b324c753ce86587412c3725d8b8c6dd7f1c72e8c61d8d618cbb81941cecedd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareHsv]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareHsv]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareHsv]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__694cdbbfff3d9edbfc72e4aa5b0289c8753eb835a00a471d7ab359bb331f299a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfDimension",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "dimension": "dimension",
        "dimension_var": "dimensionVar",
        "equal": "equal",
        "greater_than": "greaterThan",
        "less_than": "lessThan",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfDimension:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfDimensionDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        dimension: typing.Optional[builtins.str] = None,
        dimension_var: typing.Optional[builtins.str] = None,
        equal: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfDimensionEqual", typing.Dict[builtins.str, typing.Any]]] = None,
        greater_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfDimensionGreaterThan", typing.Dict[builtins.str, typing.Any]]] = None,
        less_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfDimensionLessThan", typing.Dict[builtins.str, typing.Any]]] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param dimension: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        :param dimension_var: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        :param equal: equal block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        :param greater_than: greater_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        :param less_than: less_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        :param value: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfDimensionDefault(**default)
        if isinstance(equal, dict):
            equal = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfDimensionEqual(**equal)
        if isinstance(greater_than, dict):
            greater_than = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfDimensionGreaterThan(**greater_than)
        if isinstance(less_than, dict):
            less_than = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfDimensionLessThan(**less_than)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3e2ebc942d2438687049f03a09c18ce3e566cabbc7dc74893333fa4a7b52a195)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument dimension", value=dimension, expected_type=type_hints["dimension"])
            check_type(argname="argument dimension_var", value=dimension_var, expected_type=type_hints["dimension_var"])
            check_type(argname="argument equal", value=equal, expected_type=type_hints["equal"])
            check_type(argname="argument greater_than", value=greater_than, expected_type=type_hints["greater_than"])
            check_type(argname="argument less_than", value=less_than, expected_type=type_hints["less_than"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if dimension is not None:
            self._values["dimension"] = dimension
        if dimension_var is not None:
            self._values["dimension_var"] = dimension_var
        if equal is not None:
            self._values["equal"] = equal
        if greater_than is not None:
            self._values["greater_than"] = greater_than
        if less_than is not None:
            self._values["less_than"] = less_than
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfDimensionDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfDimensionDefault"], result)

    @builtins.property
    def dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        '''
        result = self._values.get("dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        '''
        result = self._values.get("dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def equal(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfDimensionEqual"]:
        '''equal block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        '''
        result = self._values.get("equal")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfDimensionEqual"], result)

    @builtins.property
    def greater_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfDimensionGreaterThan"]:
        '''greater_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        '''
        result = self._values.get("greater_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfDimensionGreaterThan"], result)

    @builtins.property
    def less_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfDimensionLessThan"]:
        '''less_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        '''
        result = self._values.get("less_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfDimensionLessThan"], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfDimension(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfDimensionDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfDimensionDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfDimensionDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfDimensionDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfDimensionDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__937e1af6ecca8ea686457ca9d08ff3e328cc3a04ccea78d2772d675567198fe6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfDimensionDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfDimensionDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__83000bc5073943ad96aa182aba1767787609a3402307ee0e3145a295157cd321)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfDimensionEqual",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfDimensionEqual:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfDimensionEqual(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfDimensionEqualOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfDimensionEqualOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__84f386f81d78489bb8a4bd75f75709c05914905af95538ef9e6519f9d749e42c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfDimensionEqual], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfDimensionEqual],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1cebef8a6746e7562c60d8aabf56932b7673dfd330734dba482af810e12e532a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfDimensionGreaterThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfDimensionGreaterThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfDimensionGreaterThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfDimensionGreaterThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfDimensionGreaterThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2b174eb3233186e907a494b04f17dde833e5b80a23dbbeb58a72a9ff824118ff)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfDimensionGreaterThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfDimensionGreaterThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__265a450c820a51ed1df57174579f04f9bcbfffde2afc79f3e68d586192065a0d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfDimensionLessThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfDimensionLessThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfDimensionLessThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfDimensionLessThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfDimensionLessThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3fe44bc4429effa6904ec07796414102edeeebc6be3b4cc16752a0c0086d93a8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfDimensionLessThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfDimensionLessThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__083ceabd67def1676c4017034dfea6313534754c7a825977c16222e5860ed7dc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfDimensionList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfDimensionList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5251647e55330d7a540b6b85d7be0f94618fbdf9da6d52fe94283ea27ae25dc9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfDimensionOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__443c9401922e186e3fc977eb391a46ea4432cb43f7202885ed401a5384e48ce5)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfDimensionOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eeffb4dd8c533f2a7d21dad38849032133b81a223f70380f09ff5f8108234301)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3e8b7721325db97a5ad9f774b40284fb08e35c6f7f776162de687ceb38791c1b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ee59801dc2842c84f8a8e686229291ece99b2990621ba16ecdca4fe8f241edd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfDimension]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfDimension]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b4d721c7e603cbc5d09370e229241a936c4ef68217ca58c43cf4ac4029124064)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfDimensionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfDimensionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f374e7e02b874771e57c7d3bdddbb1ced69d299c042df5d300165edc0c2f4bc9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfDimensionDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putEqual")
    def put_equal(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfDimensionEqual()

        return typing.cast(None, jsii.invoke(self, "putEqual", [value]))

    @jsii.member(jsii_name="putGreaterThan")
    def put_greater_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfDimensionGreaterThan()

        return typing.cast(None, jsii.invoke(self, "putGreaterThan", [value]))

    @jsii.member(jsii_name="putLessThan")
    def put_less_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfDimensionLessThan()

        return typing.cast(None, jsii.invoke(self, "putLessThan", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetDimension")
    def reset_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimension", []))

    @jsii.member(jsii_name="resetDimensionVar")
    def reset_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimensionVar", []))

    @jsii.member(jsii_name="resetEqual")
    def reset_equal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEqual", []))

    @jsii.member(jsii_name="resetGreaterThan")
    def reset_greater_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGreaterThan", []))

    @jsii.member(jsii_name="resetLessThan")
    def reset_less_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLessThan", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfDimensionDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfDimensionDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="equal")
    def equal(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfDimensionEqualOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfDimensionEqualOutputReference, jsii.get(self, "equal"))

    @builtins.property
    @jsii.member(jsii_name="greaterThan")
    def greater_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfDimensionGreaterThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfDimensionGreaterThanOutputReference, jsii.get(self, "greaterThan"))

    @builtins.property
    @jsii.member(jsii_name="lessThan")
    def less_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfDimensionLessThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfDimensionLessThanOutputReference, jsii.get(self, "lessThan"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfDimensionDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionInput")
    def dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionVarInput")
    def dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="equalInput")
    def equal_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfDimensionEqual], jsii.get(self, "equalInput"))

    @builtins.property
    @jsii.member(jsii_name="greaterThanInput")
    def greater_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfDimensionGreaterThan], jsii.get(self, "greaterThanInput"))

    @builtins.property
    @jsii.member(jsii_name="lessThanInput")
    def less_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfDimensionLessThan], jsii.get(self, "lessThanInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="dimension")
    def dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimension"))

    @dimension.setter
    def dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7a4ce7b4a05f263cb34c50e512afad75e06e78e7fabb17334d8a485d97c54b84)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimension", value)

    @builtins.property
    @jsii.member(jsii_name="dimensionVar")
    def dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimensionVar"))

    @dimension_var.setter
    def dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5c999b6dcf97bf24146634984b34c185bfd25b2ecc252d37eb219211f70d2f78)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__517bfdd2b2902b5371025e7d629893fee0b4f94768da48a68809ce34b02f0543)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1b9f32a113b507aad0f890c6dc5f3666ad4385b774bdbaff4497709ac0a308b6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfDimension]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfDimension]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfDimension]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5284166aebce958082619ffa2488de1a5e181bc446d8475e510984dcb491d45c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfOrientation",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "landscape": "landscape",
        "portrait": "portrait",
        "square": "square",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfOrientation:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfOrientationDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        landscape: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfOrientationLandscape", typing.Dict[builtins.str, typing.Any]]] = None,
        portrait: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfOrientationPortrait", typing.Dict[builtins.str, typing.Any]]] = None,
        square: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfOrientationSquare", typing.Dict[builtins.str, typing.Any]]] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param landscape: landscape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        :param portrait: portrait block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        :param square: square block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfOrientationDefault(**default)
        if isinstance(landscape, dict):
            landscape = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfOrientationLandscape(**landscape)
        if isinstance(portrait, dict):
            portrait = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfOrientationPortrait(**portrait)
        if isinstance(square, dict):
            square = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfOrientationSquare(**square)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9f5aa301b642af4556cf3d9767fefc5e9586d7f9c6f52225d32b574087d0b91b)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument landscape", value=landscape, expected_type=type_hints["landscape"])
            check_type(argname="argument portrait", value=portrait, expected_type=type_hints["portrait"])
            check_type(argname="argument square", value=square, expected_type=type_hints["square"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if landscape is not None:
            self._values["landscape"] = landscape
        if portrait is not None:
            self._values["portrait"] = portrait
        if square is not None:
            self._values["square"] = square

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfOrientationDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfOrientationDefault"], result)

    @builtins.property
    def landscape(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfOrientationLandscape"]:
        '''landscape block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        '''
        result = self._values.get("landscape")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfOrientationLandscape"], result)

    @builtins.property
    def portrait(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfOrientationPortrait"]:
        '''portrait block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        '''
        result = self._values.get("portrait")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfOrientationPortrait"], result)

    @builtins.property
    def square(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfOrientationSquare"]:
        '''square block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        result = self._values.get("square")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfOrientationSquare"], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfOrientation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfOrientationDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfOrientationDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfOrientationDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfOrientationDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfOrientationDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__97caaa4de4b63c3d7c3895b53c9b14d7c160420122f465f469b2245deb87788f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfOrientationDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfOrientationDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__063f7329225462612f773a6ab2a1ca32bd61874811622d83464616900a47d884)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfOrientationLandscape",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfOrientationLandscape:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfOrientationLandscape(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfOrientationLandscapeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfOrientationLandscapeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6ba90f2b034f63fb2ecd36a6353b71f72536816f8cda8d507f1a477ee2477714)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfOrientationLandscape], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfOrientationLandscape],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0d9cbc2bf4b1251b60a99ad71c4c282d7368fcf5fa4a86d1f14ae6159964c55f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfOrientationList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfOrientationList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__87f2501e54480aab84a5c5f3eebce5ccbc3e742ea11aad831ce912dabfbe8927)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfOrientationOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7855d0f56087daafc1c129eff142ef18cc1fe5a7fda5ba183792243693527c94)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfOrientationOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2586ec42643094b9d7201ebc1833f4423740db8b1525a6d9889203d1c036d5ec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af465bc3b8162d6716164cc55dbd29d80a15fb3cc115e3608432033a65ddb473)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__10d3746677819063c439565326afbd07e03ff9b3b322d5e3ef7f16ccf85ff1b5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfOrientation]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfOrientation]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__78d4184ba8499a9280bf8cc53afe63d35cd75efbb95d44ea573b1efb6711e4f9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfOrientationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfOrientationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eccbe02bcb0261ff4170e5c13048e7b2ccc3eaa41854927416267b78c773c0ac)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfOrientationDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putLandscape")
    def put_landscape(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfOrientationLandscape()

        return typing.cast(None, jsii.invoke(self, "putLandscape", [value]))

    @jsii.member(jsii_name="putPortrait")
    def put_portrait(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfOrientationPortrait()

        return typing.cast(None, jsii.invoke(self, "putPortrait", [value]))

    @jsii.member(jsii_name="putSquare")
    def put_square(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfOrientationSquare()

        return typing.cast(None, jsii.invoke(self, "putSquare", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetLandscape")
    def reset_landscape(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLandscape", []))

    @jsii.member(jsii_name="resetPortrait")
    def reset_portrait(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPortrait", []))

    @jsii.member(jsii_name="resetSquare")
    def reset_square(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSquare", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfOrientationDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfOrientationDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="landscape")
    def landscape(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfOrientationLandscapeOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfOrientationLandscapeOutputReference, jsii.get(self, "landscape"))

    @builtins.property
    @jsii.member(jsii_name="portrait")
    def portrait(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfOrientationPortraitOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfOrientationPortraitOutputReference", jsii.get(self, "portrait"))

    @builtins.property
    @jsii.member(jsii_name="square")
    def square(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfOrientationSquareOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfOrientationSquareOutputReference", jsii.get(self, "square"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfOrientationDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="landscapeInput")
    def landscape_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfOrientationLandscape], jsii.get(self, "landscapeInput"))

    @builtins.property
    @jsii.member(jsii_name="portraitInput")
    def portrait_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfOrientationPortrait"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfOrientationPortrait"], jsii.get(self, "portraitInput"))

    @builtins.property
    @jsii.member(jsii_name="squareInput")
    def square_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfOrientationSquare"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfOrientationSquare"], jsii.get(self, "squareInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfOrientation]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfOrientation]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfOrientation]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__110fd1d217e51668350b742d1ae0660afe60e817a0afb6c93fded9c1179ee948)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfOrientationPortrait",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfOrientationPortrait:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfOrientationPortrait(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfOrientationPortraitOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfOrientationPortraitOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8097ab6f4673133d94d35d9cf18e39204ec1046d24008b49efd9aad4873b4eed)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfOrientationPortrait]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfOrientationPortrait], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfOrientationPortrait],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__255e178e0d8eb6a71c7406a86aa03817dfe75bd7dca2d0552497d71611acf234)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfOrientationSquare",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfOrientationSquare:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfOrientationSquare(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfOrientationSquareOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfOrientationSquareOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eac16d54fd1bd2fa6c0cffa236e174fbf055866cdb2797ce5d63f38dc47b5519)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfOrientationSquare]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfOrientationSquare], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfOrientationSquare],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__872aef803b7c54cec4969e3ee1d57efc33d2f8bf2e15585d13bd67e761bd036b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareMaxColors",
    jsii_struct_bases=[],
    name_mapping={"colors": "colors", "colors_var": "colorsVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareMaxColors:
    def __init__(
        self,
        *,
        colors: typing.Optional[builtins.str] = None,
        colors_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param colors: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        :param colors_var: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cbdfb3e1a6e22aada53af00473bb477ce7112ae912415acf5623ded8496c7661)
            check_type(argname="argument colors", value=colors, expected_type=type_hints["colors"])
            check_type(argname="argument colors_var", value=colors_var, expected_type=type_hints["colors_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if colors is not None:
            self._values["colors"] = colors
        if colors_var is not None:
            self._values["colors_var"] = colors_var

    @builtins.property
    def colors(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        '''
        result = self._values.get("colors")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def colors_var(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        result = self._values.get("colors_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareMaxColors(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareMaxColorsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareMaxColorsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f5ff0f7b729ff139f3ebabe02b6be93141e9d33cb5015b680986565ada001f7e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareMaxColorsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__86ea9e19306926b91c5db05ac64e43ec73a73d02694db0aa33f80f1a89cdec53)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareMaxColorsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f9fc013315c118568da7d0741aa55a2f4fb986bea9e5f1b96f1d0d033a4cfb27)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b814f513ad2067990c0bfe9cdec90da21370b5dbfb3cdd83ce14bfa902b3cb9b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2fb917d932a6e7a99e7d9a38a13286bd6f29c3d45e88ec75d13f8916b2f5d273)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareMaxColors]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareMaxColors]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ddd985849623afd2bfa136e2df6691a102e3f63d4969cf5c2207daec3c208185)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareMaxColorsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareMaxColorsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fbf762ee552d514cada93c918faee656a6bbf239f6ac209a2bbd33cff670bb37)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColors")
    def reset_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColors", []))

    @jsii.member(jsii_name="resetColorsVar")
    def reset_colors_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorsVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorsInput")
    def colors_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsInput"))

    @builtins.property
    @jsii.member(jsii_name="colorsVarInput")
    def colors_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsVarInput"))

    @builtins.property
    @jsii.member(jsii_name="colors")
    def colors(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colors"))

    @colors.setter
    def colors(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7212c82673e38bd160bdbf2e06efdb273da51c17c62c03333796da51aa3b385a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colors", value)

    @builtins.property
    @jsii.member(jsii_name="colorsVar")
    def colors_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorsVar"))

    @colors_var.setter
    def colors_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__803dd87832e56826b2e819c2a9f7cc07220aa673c35a80f912c34fc8694de889)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorsVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareMaxColors]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareMaxColors]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareMaxColors]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a33f2206217a54bcf9566557d3ce6cd018915f41b0fd9f2d1bd26db03533e9c7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareMirror",
    jsii_struct_bases=[],
    name_mapping={
        "horizontal": "horizontal",
        "horizontal_var": "horizontalVar",
        "vertical": "vertical",
        "vertical_var": "verticalVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareMirror:
    def __init__(
        self,
        *,
        horizontal: typing.Optional[builtins.str] = None,
        horizontal_var: typing.Optional[builtins.str] = None,
        vertical: typing.Optional[builtins.str] = None,
        vertical_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param horizontal: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        :param horizontal_var: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        :param vertical: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        :param vertical_var: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c5962d46655e19805a354326914c6f358d81ad5599166f249a4e0dd34055165d)
            check_type(argname="argument horizontal", value=horizontal, expected_type=type_hints["horizontal"])
            check_type(argname="argument horizontal_var", value=horizontal_var, expected_type=type_hints["horizontal_var"])
            check_type(argname="argument vertical", value=vertical, expected_type=type_hints["vertical"])
            check_type(argname="argument vertical_var", value=vertical_var, expected_type=type_hints["vertical_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if horizontal is not None:
            self._values["horizontal"] = horizontal
        if horizontal_var is not None:
            self._values["horizontal_var"] = horizontal_var
        if vertical is not None:
            self._values["vertical"] = vertical
        if vertical_var is not None:
            self._values["vertical_var"] = vertical_var

    @builtins.property
    def horizontal(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        '''
        result = self._values.get("horizontal")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def horizontal_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        '''
        result = self._values.get("horizontal_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        '''
        result = self._values.get("vertical")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        result = self._values.get("vertical_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareMirror(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareMirrorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareMirrorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__654b771f34efd027caf550a344a78ac4338fb5268055e254fc4d540d104e9dde)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareMirrorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab10db49fe7362c623aeaf5ac19189d6da0a24e8ad5e09985a459d113779087f)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareMirrorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6a920d9791723b0c7a8fb0c8661fadcd8953fef220db6f253fcd2ea29e839918)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7f1b104dbc12fa659eb6d9fecfc2a102d6781bcf4ed6336c310b254d202a7dbd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__22acd98e8dde60da9c484d3a34540870d54294db8c7b13803d5b85a673d04462)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareMirror]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareMirror]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6a109cb79d04b734a20b8ae1f6fa04f0cc86df8d5a3ee4f5b81c1080c8a9a56a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareMirrorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareMirrorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e2d5761c8fb9f39d514ac73cdee168b974e4fb50e58eb13f5194a03bbe2b8191)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHorizontal")
    def reset_horizontal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontal", []))

    @jsii.member(jsii_name="resetHorizontalVar")
    def reset_horizontal_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontalVar", []))

    @jsii.member(jsii_name="resetVertical")
    def reset_vertical(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVertical", []))

    @jsii.member(jsii_name="resetVerticalVar")
    def reset_vertical_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVerticalVar", []))

    @builtins.property
    @jsii.member(jsii_name="horizontalInput")
    def horizontal_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontalVarInput")
    def horizontal_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalInput")
    def vertical_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalVarInput")
    def vertical_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontal")
    def horizontal(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontal"))

    @horizontal.setter
    def horizontal(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fb100fd498675a16dd23b7e44b3661aec7686199663196e920b4b7c05361deea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontal", value)

    @builtins.property
    @jsii.member(jsii_name="horizontalVar")
    def horizontal_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontalVar"))

    @horizontal_var.setter
    def horizontal_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__57c93a4a732ad7b3c568de695c3b5a824ba7b6fea639b9bb44b05913a0e21908)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontalVar", value)

    @builtins.property
    @jsii.member(jsii_name="vertical")
    def vertical(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "vertical"))

    @vertical.setter
    def vertical(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4037577bf301e438712c6987bb3c787bcf28abede6b237b2402e7f28a1dfee2b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "vertical", value)

    @builtins.property
    @jsii.member(jsii_name="verticalVar")
    def vertical_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "verticalVar"))

    @vertical_var.setter
    def vertical_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__79d51ff8efe7dec89444a34e774f579014c3ba46d0e71122861081bfa4118514)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "verticalVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareMirror]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareMirror]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareMirror]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e2f779a70f21f10bb0bdea5923678e4ea1d33929b06e0409426feac44f205063)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareMonoHue",
    jsii_struct_bases=[],
    name_mapping={"hue": "hue", "hue_var": "hueVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareMonoHue:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0fb7dd79594a5cdff239932fb7f1f6040a13391e81c06cc48839bea6378b083c)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareMonoHue(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareMonoHueList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareMonoHueList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d732c730937d5a9f206301b3899c5a6af3c0d9ff7c904f67c14586c7389ab646)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareMonoHueOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7e0365b935d262205662fe435d85d83ca14db7611c38d63274a29d65991c09ae)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareMonoHueOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f757726dc1098523a4d679d5c79280f306c5b47f03a1a28d611219ce8dde04d6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7b7887aba44f7226fb4d226bf077500e01c9cc142e424a8e99042bcb0ac208dd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f764f284522ce5f49f32fb66236785b3b7781b461b014896ccf9c57104e81426)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareMonoHue]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareMonoHue]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b84df2d66dd55d16422ed4e763fb882d5b86e70754282cd60bfbeb5aa14f72fd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareMonoHueOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareMonoHueOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5b0cd27917bd3873be06a01b67fc471e53ab2006528b4558d92189e6c8feabdd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__41bd53f3a95054e75cd8580949ccf597ff4df28406ba9dc671ae44f60d306e5f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__044678719585b147ccd030710a400b6c9a11dd81fe0e0125a6b9f0ab5bc679a3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareMonoHue]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareMonoHue]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareMonoHue]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aa8b0fac638836ad43292573714177560e64a0fa7d9874daeefa4bd20c7a3887)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareOpacity",
    jsii_struct_bases=[],
    name_mapping={"opacity": "opacity", "opacity_var": "opacityVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareOpacity:
    def __init__(
        self,
        *,
        opacity: typing.Optional[builtins.str] = None,
        opacity_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param opacity: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param opacity_var: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7e81ab5afe7260d27802e5ed4de4522a7e6b49bea0c0680dd2ddf6af7e2606e4)
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument opacity_var", value=opacity_var, expected_type=type_hints["opacity_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if opacity is not None:
            self._values["opacity"] = opacity
        if opacity_var is not None:
            self._values["opacity_var"] = opacity_var

    @builtins.property
    def opacity(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def opacity_var(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        result = self._values.get("opacity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareOpacity(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareOpacityList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareOpacityList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b85814936120388b447704ab31dd76992fc923aa7c76a98f200c14a96df2b1ee)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareOpacityOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ae46b9ddf461531fb32a8b5bc1432f740da353bf0b08c52d20e2097b9316182)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareOpacityOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a0d7cb173d30ebc5446970e46a46900e0655ae1707bf597550b8924e05d3308c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__89f981d9ae677d8f7cc4f7f9804a7010d217ef7cd702838dae9a0a222e797004)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2504b8b9c570ebe66294660effb7dac1188de24cf7ae7681a1de2e2075e218fb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareOpacity]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareOpacity]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6a3f929352851572134e654722e41f6bc999479f417e343f4c26f587aa350daa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareOpacityOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareOpacityOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__31053e37ab51b9df190146fb207183442ba6a0f51e00261c59be272397b36848)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetOpacityVar")
    def reset_opacity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacityVar", []))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityVarInput")
    def opacity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacity"))

    @opacity.setter
    def opacity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6be04679177a9f6c91a3978ae63f85a368effc92d3597276ee845f9a297ae8b8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacity", value)

    @builtins.property
    @jsii.member(jsii_name="opacityVar")
    def opacity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacityVar"))

    @opacity_var.setter
    def opacity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f4e594a0b8343915cb4008f6e2009afccf1d41493108f97bd538bd3f5c75e8f9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacityVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareOpacity]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareOpacity]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareOpacity]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2da37df1a9f8820c8b0d450fce631a7a6d6651d6f49579764e8cb0872de20529)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4697819f6b04f85e3196af94bcaf8868c20cfd67e85501dd51d0bb4f8a5b7e01)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putBackgroundColor")
    def put_background_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__80eee45a22214c05d98612cc59ae783b8b6dd7011674970c3fe8b45c6085229a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBackgroundColor", [value]))

    @jsii.member(jsii_name="putBlur")
    def put_blur(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareBlur, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a37fc22d5f29870d434be13d668433274dee378a63dbedf1025ed0c637830652)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBlur", [value]))

    @jsii.member(jsii_name="putChromaKey")
    def put_chroma_key(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareChromaKey, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__51c2b7600fa7fde69cdd31f59f9e6368c78a39a98bca5f0a577d118ce8e871f3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putChromaKey", [value]))

    @jsii.member(jsii_name="putComposite")
    def put_composite(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareComposite, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2af4e95ade68d411503caef35cdb97e9a3e7bf3502dac2b5952ce97a7f104e48)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putComposite", [value]))

    @jsii.member(jsii_name="putCompound")
    def put_compound(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareCompound, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__384e2af871d4d8f9100e30a01a76af0eb314f2b48ccc12e304ea861c6cd0782d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCompound", [value]))

    @jsii.member(jsii_name="putContrast")
    def put_contrast(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareContrast, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__29832556ab43eaf8eebbe7376e9387849e23bec56681b5bfa39bf3c5ba322904)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putContrast", [value]))

    @jsii.member(jsii_name="putGoop")
    def put_goop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareGoop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a857bda28de0311a57a6d2a2da69dffd2851f58f7b9a8b90eefa17531cd1d008)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGoop", [value]))

    @jsii.member(jsii_name="putGrayscale")
    def put_grayscale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareGrayscale, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c868409930d40d01cfd7e0b60501f6d256cc61732fff8460786df9682cc40e8d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGrayscale", [value]))

    @jsii.member(jsii_name="putHsl")
    def put_hsl(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareHsl, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__461b7956bba78db27984714c1da17c26ae371202fcbc29e6318b83393366ac0c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsl", [value]))

    @jsii.member(jsii_name="putHsv")
    def put_hsv(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareHsv, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8b33bbe86dfe646c9988583653790bd263271946949ab0d935495d14a80f8b92)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsv", [value]))

    @jsii.member(jsii_name="putIfDimension")
    def put_if_dimension(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfDimension, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ebdddf03485d13bccdc35cc56c149057cf23629ae3755ab5ca267f68404dc0d4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfDimension", [value]))

    @jsii.member(jsii_name="putIfOrientation")
    def put_if_orientation(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a057913815f06a281a5b9b8ef46fab356b40ea12b1243e61ab09676cfdab91f8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfOrientation", [value]))

    @jsii.member(jsii_name="putMaxColors")
    def put_max_colors(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareMaxColors, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d07f206a46ab644682b21fc2c388e0fce753630c07ebddc432c9b816dbb4511c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMaxColors", [value]))

    @jsii.member(jsii_name="putMirror")
    def put_mirror(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareMirror, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c71c95d4f8d4bca2e8a3dff6b19f68f246650daae5da422e6649b86dd334e4e7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMirror", [value]))

    @jsii.member(jsii_name="putMonoHue")
    def put_mono_hue(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareMonoHue, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea8fd05e73c9bb45143608d769e940757b4eea22478a320353b63f9f6f1865f8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMonoHue", [value]))

    @jsii.member(jsii_name="putOpacity")
    def put_opacity(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareOpacity, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c59860aaf1309138cfc34fdb38284f74e4345faefac64223f5e9e84da8953996)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putOpacity", [value]))

    @jsii.member(jsii_name="putRemoveColor")
    def put_remove_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareRemoveColor", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__731f4877f71e592d542661968f470ac23d88af5fceccd0079d0f075683a8d3fc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRemoveColor", [value]))

    @jsii.member(jsii_name="putUnsharpMask")
    def put_unsharp_mask(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareUnsharpMask", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__deacb294ed86c95dd1e79fdad86a578bf233a4b23a66d1c9e4a5bbb174535c3a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putUnsharpMask", [value]))

    @jsii.member(jsii_name="resetBackgroundColor")
    def reset_background_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBackgroundColor", []))

    @jsii.member(jsii_name="resetBlur")
    def reset_blur(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBlur", []))

    @jsii.member(jsii_name="resetChromaKey")
    def reset_chroma_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChromaKey", []))

    @jsii.member(jsii_name="resetComposite")
    def reset_composite(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetComposite", []))

    @jsii.member(jsii_name="resetCompound")
    def reset_compound(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCompound", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetGoop")
    def reset_goop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGoop", []))

    @jsii.member(jsii_name="resetGrayscale")
    def reset_grayscale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGrayscale", []))

    @jsii.member(jsii_name="resetHsl")
    def reset_hsl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsl", []))

    @jsii.member(jsii_name="resetHsv")
    def reset_hsv(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsv", []))

    @jsii.member(jsii_name="resetIfDimension")
    def reset_if_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfDimension", []))

    @jsii.member(jsii_name="resetIfOrientation")
    def reset_if_orientation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfOrientation", []))

    @jsii.member(jsii_name="resetMaxColors")
    def reset_max_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxColors", []))

    @jsii.member(jsii_name="resetMirror")
    def reset_mirror(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMirror", []))

    @jsii.member(jsii_name="resetMonoHue")
    def reset_mono_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonoHue", []))

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetRemoveColor")
    def reset_remove_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRemoveColor", []))

    @jsii.member(jsii_name="resetUnsharpMask")
    def reset_unsharp_mask(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUnsharpMask", []))

    @builtins.property
    @jsii.member(jsii_name="backgroundColor")
    def background_color(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareBackgroundColorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareBackgroundColorList, jsii.get(self, "backgroundColor"))

    @builtins.property
    @jsii.member(jsii_name="blur")
    def blur(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareBlurList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareBlurList, jsii.get(self, "blur"))

    @builtins.property
    @jsii.member(jsii_name="chromaKey")
    def chroma_key(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareChromaKeyList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareChromaKeyList, jsii.get(self, "chromaKey"))

    @builtins.property
    @jsii.member(jsii_name="composite")
    def composite(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareCompositeList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareCompositeList, jsii.get(self, "composite"))

    @builtins.property
    @jsii.member(jsii_name="compound")
    def compound(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareCompoundList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareCompoundList, jsii.get(self, "compound"))

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareContrastList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareContrastList, jsii.get(self, "contrast"))

    @builtins.property
    @jsii.member(jsii_name="goop")
    def goop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareGoopList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareGoopList, jsii.get(self, "goop"))

    @builtins.property
    @jsii.member(jsii_name="grayscale")
    def grayscale(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareGrayscaleList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareGrayscaleList, jsii.get(self, "grayscale"))

    @builtins.property
    @jsii.member(jsii_name="hsl")
    def hsl(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareHslList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareHslList, jsii.get(self, "hsl"))

    @builtins.property
    @jsii.member(jsii_name="hsv")
    def hsv(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareHsvList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareHsvList, jsii.get(self, "hsv"))

    @builtins.property
    @jsii.member(jsii_name="ifDimension")
    def if_dimension(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfDimensionList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfDimensionList, jsii.get(self, "ifDimension"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientation")
    def if_orientation(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfOrientationList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfOrientationList, jsii.get(self, "ifOrientation"))

    @builtins.property
    @jsii.member(jsii_name="maxColors")
    def max_colors(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareMaxColorsList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareMaxColorsList, jsii.get(self, "maxColors"))

    @builtins.property
    @jsii.member(jsii_name="mirror")
    def mirror(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareMirrorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareMirrorList, jsii.get(self, "mirror"))

    @builtins.property
    @jsii.member(jsii_name="monoHue")
    def mono_hue(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareMonoHueList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareMonoHueList, jsii.get(self, "monoHue"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareOpacityList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareOpacityList, jsii.get(self, "opacity"))

    @builtins.property
    @jsii.member(jsii_name="removeColor")
    def remove_color(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareRemoveColorList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareRemoveColorList", jsii.get(self, "removeColor"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMask")
    def unsharp_mask(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareUnsharpMaskList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareUnsharpMaskList", jsii.get(self, "unsharpMask"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColorInput")
    def background_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareBackgroundColor]]], jsii.get(self, "backgroundColorInput"))

    @builtins.property
    @jsii.member(jsii_name="blurInput")
    def blur_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareBlur]]], jsii.get(self, "blurInput"))

    @builtins.property
    @jsii.member(jsii_name="chromaKeyInput")
    def chroma_key_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareChromaKey]]], jsii.get(self, "chromaKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="compositeInput")
    def composite_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareComposite]]], jsii.get(self, "compositeInput"))

    @builtins.property
    @jsii.member(jsii_name="compoundInput")
    def compound_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareCompound]]], jsii.get(self, "compoundInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareContrast]]], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="goopInput")
    def goop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareGoop]]], jsii.get(self, "goopInput"))

    @builtins.property
    @jsii.member(jsii_name="grayscaleInput")
    def grayscale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareGrayscale]]], jsii.get(self, "grayscaleInput"))

    @builtins.property
    @jsii.member(jsii_name="hslInput")
    def hsl_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareHsl]]], jsii.get(self, "hslInput"))

    @builtins.property
    @jsii.member(jsii_name="hsvInput")
    def hsv_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareHsv]]], jsii.get(self, "hsvInput"))

    @builtins.property
    @jsii.member(jsii_name="ifDimensionInput")
    def if_dimension_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfDimension]]], jsii.get(self, "ifDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientationInput")
    def if_orientation_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfOrientation]]], jsii.get(self, "ifOrientationInput"))

    @builtins.property
    @jsii.member(jsii_name="maxColorsInput")
    def max_colors_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareMaxColors]]], jsii.get(self, "maxColorsInput"))

    @builtins.property
    @jsii.member(jsii_name="mirrorInput")
    def mirror_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareMirror]]], jsii.get(self, "mirrorInput"))

    @builtins.property
    @jsii.member(jsii_name="monoHueInput")
    def mono_hue_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareMonoHue]]], jsii.get(self, "monoHueInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareOpacity]]], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="removeColorInput")
    def remove_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareRemoveColor"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareRemoveColor"]]], jsii.get(self, "removeColorInput"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMaskInput")
    def unsharp_mask_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareUnsharpMask"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareUnsharpMask"]]], jsii.get(self, "unsharpMaskInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquare]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquare], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquare],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b4f7b5abbc6a425b272d24ecd4c6cb2ccfd41f2fe04d0b636d743bd85759dab7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareRemoveColor",
    jsii_struct_bases=[],
    name_mapping={
        "color": "color",
        "color_var": "colorVar",
        "feather": "feather",
        "feather_var": "featherVar",
        "tolerance": "tolerance",
        "tolerance_var": "toleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareRemoveColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
        feather: typing.Optional[builtins.str] = None,
        feather_var: typing.Optional[builtins.str] = None,
        tolerance: typing.Optional[builtins.str] = None,
        tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        :param feather: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        :param feather_var: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        :param tolerance: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        :param tolerance_var: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0fb9dd7cdce2b9f54331897dca17b8e56286f082cc7511b81dd8fe86e628af11)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
            check_type(argname="argument feather", value=feather, expected_type=type_hints["feather"])
            check_type(argname="argument feather_var", value=feather_var, expected_type=type_hints["feather_var"])
            check_type(argname="argument tolerance", value=tolerance, expected_type=type_hints["tolerance"])
            check_type(argname="argument tolerance_var", value=tolerance_var, expected_type=type_hints["tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var
        if feather is not None:
            self._values["feather"] = feather
        if feather_var is not None:
            self._values["feather_var"] = feather_var
        if tolerance is not None:
            self._values["tolerance"] = tolerance
        if tolerance_var is not None:
            self._values["tolerance_var"] = tolerance_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        '''
        result = self._values.get("feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather_var(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        '''
        result = self._values.get("feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        '''
        result = self._values.get("tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance_var(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        result = self._values.get("tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareRemoveColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareRemoveColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareRemoveColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7f34e4a5199b2e503f380ad9865764fdbdb25ace1932fc218f05889ab883c6b8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareRemoveColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f2030c76a31910520554b5ae847a13dd45e6abd1913dad40a05dc460a4e3a548)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareRemoveColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__50006e0df4b5a928965183deefd9decde73fa772eaac4ad61d3570c51783daaa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__768c0c7ea882ab0dc8233cbd287eb042b7a07f96b141e6df0061250d08e756d1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__74dbe3f3536e222f2d2b0490b3bd716a7408d37262a3a5e6e539485b4ec7bac5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareRemoveColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareRemoveColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareRemoveColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__44ab206ccb25b25c87e1bf8f90c3958c9f7a57bc6ace1120acc15b011e5f1560)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareRemoveColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareRemoveColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1e0606b5e64824ca0390aad580b961c900f075cacd9b88aaed9594572cf1975c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @jsii.member(jsii_name="resetFeather")
    def reset_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeather", []))

    @jsii.member(jsii_name="resetFeatherVar")
    def reset_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatherVar", []))

    @jsii.member(jsii_name="resetTolerance")
    def reset_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTolerance", []))

    @jsii.member(jsii_name="resetToleranceVar")
    def reset_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featherInput")
    def feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherInput"))

    @builtins.property
    @jsii.member(jsii_name="featherVarInput")
    def feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceInput")
    def tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceVarInput")
    def tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d1b900c2505a559e477913c63132644cd9c5b406d7e47f0f9176ae54ae84a20)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d74397682c66f925c9159d1e968f3ba7d67aee91f3401876f6a2e43871303a81)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="feather")
    def feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "feather"))

    @feather.setter
    def feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__02d328a671435307da9642bd23c8b29b8901a7c424dd4df9c825c9ef0e08c46b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "feather", value)

    @builtins.property
    @jsii.member(jsii_name="featherVar")
    def feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featherVar"))

    @feather_var.setter
    def feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6cfee78f83c70a90cfaefa6e325e72c2ef05c44a5802e4f159a2dd69354df703)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featherVar", value)

    @builtins.property
    @jsii.member(jsii_name="tolerance")
    def tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tolerance"))

    @tolerance.setter
    def tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__89710d87e1e33e56d2f1b89735788732727dfee031dc945151941224d0000c6e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tolerance", value)

    @builtins.property
    @jsii.member(jsii_name="toleranceVar")
    def tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "toleranceVar"))

    @tolerance_var.setter
    def tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__74499561995c182ba7a7efdd3482d9108945ef193dc4a42ec3d8f9d13d145bac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "toleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareRemoveColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareRemoveColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareRemoveColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__82a1eabf99c4f7bb3e224a1bba7ca2e0b4491b44a6153619a067fa1c81b93537)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareUnsharpMask",
    jsii_struct_bases=[],
    name_mapping={
        "gain": "gain",
        "gain_var": "gainVar",
        "sigma": "sigma",
        "sigma_var": "sigmaVar",
        "threshold": "threshold",
        "threshold_var": "thresholdVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareUnsharpMask:
    def __init__(
        self,
        *,
        gain: typing.Optional[builtins.str] = None,
        gain_var: typing.Optional[builtins.str] = None,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
        threshold: typing.Optional[builtins.str] = None,
        threshold_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param gain: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        :param gain_var: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        :param sigma: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        :param threshold: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        :param threshold_var: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eaed53949806649ca8b1e0067c8a683b5ed3ee7272e8fa0e3bff9168ebccf0ea)
            check_type(argname="argument gain", value=gain, expected_type=type_hints["gain"])
            check_type(argname="argument gain_var", value=gain_var, expected_type=type_hints["gain_var"])
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
            check_type(argname="argument threshold", value=threshold, expected_type=type_hints["threshold"])
            check_type(argname="argument threshold_var", value=threshold_var, expected_type=type_hints["threshold_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if gain is not None:
            self._values["gain"] = gain
        if gain_var is not None:
            self._values["gain_var"] = gain_var
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var
        if threshold is not None:
            self._values["threshold"] = threshold
        if threshold_var is not None:
            self._values["threshold_var"] = threshold_var

    @builtins.property
    def gain(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        '''
        result = self._values.get("gain")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gain_var(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        '''
        result = self._values.get("gain_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        '''
        result = self._values.get("threshold")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold_var(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        result = self._values.get("threshold_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareUnsharpMask(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareUnsharpMaskList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareUnsharpMaskList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fac93d6a770961711acfe9d975b5f8b2b8e19aed55228cecd048e9a64f0f064c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareUnsharpMaskOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ac3ab471f97335a0240584551e4724486bec847c7ca227004c5630fc0fe17ae)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareUnsharpMaskOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d8844db09268b68fcff9d4e91760571d0231482e0ee84fa5820da0176eb204ca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d2585d6bbe42ef3b5459bf69e0f2be767be998956523ee463bf2ab3450217a9c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__457a8e60b1fcc5eac41c32be6bf6c9f6e77a3d00a2af0a18a368c5a9d927fd08)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareUnsharpMask]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareUnsharpMask]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareUnsharpMask]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e846e5fb9570b8b04d2ef724700fb040f49e08c9f0f83f40a838a56d53e92562)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareUnsharpMaskOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareUnsharpMaskOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e66c8a1d793661a9f24f6626f944f6854a33b016e1b3c201c74b2a338414948)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetGain")
    def reset_gain(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGain", []))

    @jsii.member(jsii_name="resetGainVar")
    def reset_gain_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGainVar", []))

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @jsii.member(jsii_name="resetThreshold")
    def reset_threshold(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThreshold", []))

    @jsii.member(jsii_name="resetThresholdVar")
    def reset_threshold_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThresholdVar", []))

    @builtins.property
    @jsii.member(jsii_name="gainInput")
    def gain_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainInput"))

    @builtins.property
    @jsii.member(jsii_name="gainVarInput")
    def gain_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdInput")
    def threshold_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdVarInput")
    def threshold_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gain")
    def gain(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gain"))

    @gain.setter
    def gain(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7af6f0178401ed323a823061b83074a7f7d1163f3f88366d31b8ee6a7caad033)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gain", value)

    @builtins.property
    @jsii.member(jsii_name="gainVar")
    def gain_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gainVar"))

    @gain_var.setter
    def gain_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__948ca200524cad816a3d608cc135820a7d57776ce0c403bda4852bcceacd9cb0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gainVar", value)

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d25eb45e51092d3b49ad20a658f4aa62b3ab958daed3701ac6602bab7f8c76b8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0b2c9858ea101988ffd1a56cac6ab2f3d5c87b74e21eb88bcc625fabfcf13f50)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="threshold")
    def threshold(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "threshold"))

    @threshold.setter
    def threshold(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__99329708ee5be92cc21f79301d776ac8a88e5cd0fa526e6cc0b7f206247e0843)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "threshold", value)

    @builtins.property
    @jsii.member(jsii_name="thresholdVar")
    def threshold_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "thresholdVar"))

    @threshold_var.setter
    def threshold_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__12a28824d7092a3cc4ef1763e7337459d4f01b36c976b936cc9706350aab8a49)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "thresholdVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareUnsharpMask]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareUnsharpMask]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareUnsharpMask]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bcdfc9068b84d48fb6f8d6ac8b5c057d1164d43d47eb7a98da5f6ac82870e71d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__42a8bed9830557a9a75fdb5be6fd2c72e6f0b5c268805958c6a70258ed80e808)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7ed10b86d77ee20ab5b7e75d48e7059d35b1677635f72979543f78faca0b4b8a)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__53bd4bffe7f26ed0ecb8db55894324e9e746fa19d930f2c833967a260f7b1793)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7c5a53b3d99ba111105bb792432fa1f8ca2eb44df2ffb403db5ce2f4eb0a46f1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e34f5b21d08a0019987c89fe3092a26e4cf437c21a38c4d048e50b3f2efd221)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformations]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformations]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformations]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__77772eebc1be9c1b149bb5dfbe5ea04985db5c88254ebc5c7a2da8217924ae06)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsMaxColors",
    jsii_struct_bases=[],
    name_mapping={"colors": "colors", "colors_var": "colorsVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsMaxColors:
    def __init__(
        self,
        *,
        colors: typing.Optional[builtins.str] = None,
        colors_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param colors: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        :param colors_var: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6b20dde4256df93d31e0e172b0f798c4b851be46c055d61ca205ace40c8a5e21)
            check_type(argname="argument colors", value=colors, expected_type=type_hints["colors"])
            check_type(argname="argument colors_var", value=colors_var, expected_type=type_hints["colors_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if colors is not None:
            self._values["colors"] = colors
        if colors_var is not None:
            self._values["colors_var"] = colors_var

    @builtins.property
    def colors(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        '''
        result = self._values.get("colors")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def colors_var(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        result = self._values.get("colors_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsMaxColors(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsMaxColorsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsMaxColorsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ad3f3613a146cea4649541c6ec1245f8dc1732cbfbba2025b8f2453d9062f93)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsMaxColorsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__27f0895b68435b02fe00812016cc8a9d4faa93c8ca9d325576444edd6d18eccb)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsMaxColorsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fe1fd98d4b71b107f1e3dda71e9bd16f3e14f4b082f21de0647f60ac90646e64)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e71d7439e8f8c710161e0a66463d77e1fc2612e16794fdde551c175cdaa35445)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a512df44a04f5bd9572f88e62ce2710d66de8075592fbd4619c19082fa56d453)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsMaxColors]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsMaxColors]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__74eec4675436296bcdeb400e94c1fcdb382cb88e1415b6f37d5bb78b55e909d1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsMaxColorsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsMaxColorsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1b3adc19236c3288d9de08570f555c7bd1ce910824a63a3be8c9222555fed49b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColors")
    def reset_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColors", []))

    @jsii.member(jsii_name="resetColorsVar")
    def reset_colors_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorsVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorsInput")
    def colors_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsInput"))

    @builtins.property
    @jsii.member(jsii_name="colorsVarInput")
    def colors_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsVarInput"))

    @builtins.property
    @jsii.member(jsii_name="colors")
    def colors(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colors"))

    @colors.setter
    def colors(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3c53cf649bd23dbc739f60187cc1c95923922bb187415fec4dd55bb816aa922c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colors", value)

    @builtins.property
    @jsii.member(jsii_name="colorsVar")
    def colors_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorsVar"))

    @colors_var.setter
    def colors_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__965ce476d4ed65af353ab1d3190109909e3274e5a010a2db81f1c55fbcbac596)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorsVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsMaxColors]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsMaxColors]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsMaxColors]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__06091002087d3cdc84b618b105ba250190868cc1c482782f4b5dd89f03cd4967)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsMirror",
    jsii_struct_bases=[],
    name_mapping={
        "horizontal": "horizontal",
        "horizontal_var": "horizontalVar",
        "vertical": "vertical",
        "vertical_var": "verticalVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsMirror:
    def __init__(
        self,
        *,
        horizontal: typing.Optional[builtins.str] = None,
        horizontal_var: typing.Optional[builtins.str] = None,
        vertical: typing.Optional[builtins.str] = None,
        vertical_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param horizontal: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        :param horizontal_var: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        :param vertical: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        :param vertical_var: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa25128a2ae0587b226051ff9017991270b0d882d2390421b8dd104a7e242a36)
            check_type(argname="argument horizontal", value=horizontal, expected_type=type_hints["horizontal"])
            check_type(argname="argument horizontal_var", value=horizontal_var, expected_type=type_hints["horizontal_var"])
            check_type(argname="argument vertical", value=vertical, expected_type=type_hints["vertical"])
            check_type(argname="argument vertical_var", value=vertical_var, expected_type=type_hints["vertical_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if horizontal is not None:
            self._values["horizontal"] = horizontal
        if horizontal_var is not None:
            self._values["horizontal_var"] = horizontal_var
        if vertical is not None:
            self._values["vertical"] = vertical
        if vertical_var is not None:
            self._values["vertical_var"] = vertical_var

    @builtins.property
    def horizontal(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        '''
        result = self._values.get("horizontal")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def horizontal_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        '''
        result = self._values.get("horizontal_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        '''
        result = self._values.get("vertical")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        result = self._values.get("vertical_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsMirror(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsMirrorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsMirrorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bea58e6680f59aa75afcf3dea5068e1fd421db839db6f2229a516d38993faf94)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsMirrorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9f931f43663b5f21a7b121a96ebdf9911ffa71438e5d49b60415793a7c154315)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsMirrorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bde9ec2b28d22f87a84af3b26b7e5e7c488a10c1e22c992e2e1c5f272c5ef9e4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__52417060be6491b25fb9a23f54ae8b20300581ab65361907ac0b904a30da6761)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4bcb3bbea7e265d58820fe3cdbdb9e7a7f1e96c30cf121c2823f1f0ffe7957fb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsMirror]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsMirror]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1159f5887e7936d7f279b1237abfe01942dc221cbfbb3957a3f5bf6b4ce54b05)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsMirrorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsMirrorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fb1115ae71e1e9b34e24f1033d7d6f3b9622050b30f45083e85889323d38db7a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHorizontal")
    def reset_horizontal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontal", []))

    @jsii.member(jsii_name="resetHorizontalVar")
    def reset_horizontal_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontalVar", []))

    @jsii.member(jsii_name="resetVertical")
    def reset_vertical(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVertical", []))

    @jsii.member(jsii_name="resetVerticalVar")
    def reset_vertical_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVerticalVar", []))

    @builtins.property
    @jsii.member(jsii_name="horizontalInput")
    def horizontal_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontalVarInput")
    def horizontal_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalInput")
    def vertical_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalVarInput")
    def vertical_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontal")
    def horizontal(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontal"))

    @horizontal.setter
    def horizontal(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1e3e3c0034c1f9b877fab62764aabe9ad31fb023f852b79e57f9db4f4fe226c0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontal", value)

    @builtins.property
    @jsii.member(jsii_name="horizontalVar")
    def horizontal_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontalVar"))

    @horizontal_var.setter
    def horizontal_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d43cff59eb0accf181d4a9ccdc8d2aa67c75113305c91953e1ecf37550be8d2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontalVar", value)

    @builtins.property
    @jsii.member(jsii_name="vertical")
    def vertical(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "vertical"))

    @vertical.setter
    def vertical(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e75cfbc3e63c1a4bf63d8d35ab6c60c0b564d1868bae4e9f5585458417cc56ca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "vertical", value)

    @builtins.property
    @jsii.member(jsii_name="verticalVar")
    def vertical_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "verticalVar"))

    @vertical_var.setter
    def vertical_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cbc9944fcfe0b238bef3ca520a0a3a5369db31d3013bb016e1dd821ed58579c0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "verticalVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsMirror]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsMirror]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsMirror]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__10b14a9e4d26816362abab12fc6f1b9f5dc1b1c4ec6ca65404b7a1eb13e92c64)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsMonoHue",
    jsii_struct_bases=[],
    name_mapping={"hue": "hue", "hue_var": "hueVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsMonoHue:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__021d1a2ea3c777b1a018d4f7327f919680b5ad144dbbc07eb97132cc9c0345ba)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsMonoHue(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsMonoHueList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsMonoHueList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9e2c4f46c952e05c738168ce3256528a605b061d0a75200fb9deddda00d5b258)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsMonoHueOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7ed69679a61a3f7817ec2ced0c98db28caedaad4c77592470093756f4c9cf7d9)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsMonoHueOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__db85fb5a133e7b25cd2076f8dcd2a1cc3650b33b957a332138a720991334a928)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a25c5bfaa2bef053211fb60de1148af24a497828f8e4f26ee67d16239fe6ee43)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6ece2d74e6195d2611a84d2bfb848c2fd57d5abe96c19d1ffbc3c83e32ff372c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsMonoHue]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsMonoHue]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f03af1b03352e30687cd0846bfbebdfc02dcf6e258cc68c06d424d98013d2b52)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsMonoHueOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsMonoHueOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a5809cb8f11aa0ed459aa7ef629eea7a6e1ac4a5ed5eb1f7310f4a82bfb37534)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5d2ea9844191f1a40eb6188551b40d73bad3385bab1dd73adf4d355af216d430)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ac6d71208afc70c8c5fa0d0e08ddcb7086a9a4d7cd2631857bff97315266377)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsMonoHue]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsMonoHue]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsMonoHue]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ff77ff8b76d025aa6d9dcd2bb48da0e14b070ecadc63db7f112041a52ee510f0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsOpacity",
    jsii_struct_bases=[],
    name_mapping={"opacity": "opacity", "opacity_var": "opacityVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsOpacity:
    def __init__(
        self,
        *,
        opacity: typing.Optional[builtins.str] = None,
        opacity_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param opacity: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param opacity_var: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f65f680fee4be041fb74daf24f8503ca03c1f02520bba6283f8ecb25dcc6043)
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument opacity_var", value=opacity_var, expected_type=type_hints["opacity_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if opacity is not None:
            self._values["opacity"] = opacity
        if opacity_var is not None:
            self._values["opacity_var"] = opacity_var

    @builtins.property
    def opacity(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def opacity_var(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        result = self._values.get("opacity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsOpacity(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsOpacityList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsOpacityList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__55a6b0bda801d449c080c64bb583149d76e6b97988582f5120c751d13be56a20)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsOpacityOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__27e2f3fd0f5d8fb982cec0f22d7b41a150ac7242316c6397af2ade80a370a7da)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsOpacityOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__676f9b7129c4a852e4664da16c1f739fff80d4c8e577caf379256ee8b1cb4803)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc82b8285a53188a4b01d513fba28c2707f3a703d318239e08652007927e884a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f21acd67f6b2ba5b9f8243923a1d94cb91f9f5123939b4db6bb142c93230d3ea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsOpacity]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsOpacity]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a2555dcbd7c5099430bb5c4aad56f3d522b4782ad2ad7ae660b4c1bce0e8a858)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsOpacityOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsOpacityOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f884b20caa93879979650c094465e396dda6c5bd5d12ff82afbde50fd79d493e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetOpacityVar")
    def reset_opacity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacityVar", []))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityVarInput")
    def opacity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacity"))

    @opacity.setter
    def opacity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aca68a6f450a276e70b7a4af61ca2eef7c2cb2392b8276b98a7f20e6304862bd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacity", value)

    @builtins.property
    @jsii.member(jsii_name="opacityVar")
    def opacity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacityVar"))

    @opacity_var.setter
    def opacity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__86adea0ffea112f37a7496d799b0cab646961a54135c8706c121274aa73150f0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacityVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsOpacity]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsOpacity]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsOpacity]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4b9cec68639d6a7c032140de76680cd8c811517fb5322cb92e26bf6224869292)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1d38a71f0d24f74079470f6ab93edb80074412b5edffa9542e265ea5589fbe72)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putBackgroundColor")
    def put_background_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0bfd9700851f6cdb86e853ca2cb79c756c0fcaed76df89c399cae6ce984f5596)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBackgroundColor", [value]))

    @jsii.member(jsii_name="putBlur")
    def put_blur(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsBlur, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__11e43ae178ddec3922a25c6f9c47775a9fe5721a99b827d6629e6fa0ed156a08)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBlur", [value]))

    @jsii.member(jsii_name="putChromaKey")
    def put_chroma_key(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsChromaKey, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7bdfd8c1f5dc85fb7e6ae1562944d741f0f865f6990f8817d3e354bd7bd24d1a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putChromaKey", [value]))

    @jsii.member(jsii_name="putComposite")
    def put_composite(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsComposite, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__716bb7ce39df9442cc4e0e2a3c66cbea6dd1da2a4cd714f0607ab4a78a3117fa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putComposite", [value]))

    @jsii.member(jsii_name="putCompound")
    def put_compound(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompound, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ebd80ffcc6038d1566a01ab1793587a607df8d45b02b7695567914f765d48422)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCompound", [value]))

    @jsii.member(jsii_name="putContrast")
    def put_contrast(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsContrast, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b991575f5877fca48617cdba4bbc104351c500a6699972b98393b18d6c2f1dd3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putContrast", [value]))

    @jsii.member(jsii_name="putGoop")
    def put_goop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsGoop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ba4e125adc1bd4db06f23309be6541760185076020a8328d1d0481576eafa68d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGoop", [value]))

    @jsii.member(jsii_name="putGrayscale")
    def put_grayscale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsGrayscale, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a3aa5db70bc8c1cca349c540d20b94f9cca239f849d53fa641c673b545893aa3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGrayscale", [value]))

    @jsii.member(jsii_name="putHsl")
    def put_hsl(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsHsl, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a5dc2fce06452ab5b9d8d0d364d6ecd36265e3c8bb99ab86e3e80835c35a0b5e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsl", [value]))

    @jsii.member(jsii_name="putHsv")
    def put_hsv(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsHsv, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ffe7d60a849455ef83257b9a6e9ba5843b76c4bcf1db15c53172f08f57926419)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsv", [value]))

    @jsii.member(jsii_name="putIfDimension")
    def put_if_dimension(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimension, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6ac6f178b9cdffa331d77c7214225947aecf9b75f4b48fcb62a63d5db5a0fdad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfDimension", [value]))

    @jsii.member(jsii_name="putIfOrientation")
    def put_if_orientation(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__29058343a9044ab334a847d289788f108b4772e704ffa89aa94bfd870579aab3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfOrientation", [value]))

    @jsii.member(jsii_name="putMaxColors")
    def put_max_colors(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsMaxColors, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d01f9624c805a5addc2460cc7b593dba5eba40da45d171a66f04c506ece7f30f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMaxColors", [value]))

    @jsii.member(jsii_name="putMirror")
    def put_mirror(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsMirror, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fb424cfed4f2975d652c54ea4ff15e639ae8ccc56f4d8451b8813447b308c59d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMirror", [value]))

    @jsii.member(jsii_name="putMonoHue")
    def put_mono_hue(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsMonoHue, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__42decacc63ab1e49e267d399368dfc70f62258a1b64e9be42cbe2fa163fe708d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMonoHue", [value]))

    @jsii.member(jsii_name="putOpacity")
    def put_opacity(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsOpacity, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__826fe023247ce86f466a2bd183d69459943f1e965d5931b2334f3b365c4bd08c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putOpacity", [value]))

    @jsii.member(jsii_name="putRemoveColor")
    def put_remove_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsRemoveColor", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8ba2400b769f0f71cd0d9770ce1fdcfa809bc8c781e72b3243ebe22055e170fb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRemoveColor", [value]))

    @jsii.member(jsii_name="putUnsharpMask")
    def put_unsharp_mask(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsUnsharpMask", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e3326b6bc064b1dd58b4e9225f727aa3d2be788b9e70a722b3218a208ad76396)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putUnsharpMask", [value]))

    @jsii.member(jsii_name="resetBackgroundColor")
    def reset_background_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBackgroundColor", []))

    @jsii.member(jsii_name="resetBlur")
    def reset_blur(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBlur", []))

    @jsii.member(jsii_name="resetChromaKey")
    def reset_chroma_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChromaKey", []))

    @jsii.member(jsii_name="resetComposite")
    def reset_composite(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetComposite", []))

    @jsii.member(jsii_name="resetCompound")
    def reset_compound(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCompound", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetGoop")
    def reset_goop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGoop", []))

    @jsii.member(jsii_name="resetGrayscale")
    def reset_grayscale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGrayscale", []))

    @jsii.member(jsii_name="resetHsl")
    def reset_hsl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsl", []))

    @jsii.member(jsii_name="resetHsv")
    def reset_hsv(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsv", []))

    @jsii.member(jsii_name="resetIfDimension")
    def reset_if_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfDimension", []))

    @jsii.member(jsii_name="resetIfOrientation")
    def reset_if_orientation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfOrientation", []))

    @jsii.member(jsii_name="resetMaxColors")
    def reset_max_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxColors", []))

    @jsii.member(jsii_name="resetMirror")
    def reset_mirror(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMirror", []))

    @jsii.member(jsii_name="resetMonoHue")
    def reset_mono_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonoHue", []))

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetRemoveColor")
    def reset_remove_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRemoveColor", []))

    @jsii.member(jsii_name="resetUnsharpMask")
    def reset_unsharp_mask(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUnsharpMask", []))

    @builtins.property
    @jsii.member(jsii_name="backgroundColor")
    def background_color(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsBackgroundColorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsBackgroundColorList, jsii.get(self, "backgroundColor"))

    @builtins.property
    @jsii.member(jsii_name="blur")
    def blur(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsBlurList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsBlurList, jsii.get(self, "blur"))

    @builtins.property
    @jsii.member(jsii_name="chromaKey")
    def chroma_key(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsChromaKeyList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsChromaKeyList, jsii.get(self, "chromaKey"))

    @builtins.property
    @jsii.member(jsii_name="composite")
    def composite(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeList, jsii.get(self, "composite"))

    @builtins.property
    @jsii.member(jsii_name="compound")
    def compound(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundList, jsii.get(self, "compound"))

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsContrastList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsContrastList, jsii.get(self, "contrast"))

    @builtins.property
    @jsii.member(jsii_name="goop")
    def goop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsGoopList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsGoopList, jsii.get(self, "goop"))

    @builtins.property
    @jsii.member(jsii_name="grayscale")
    def grayscale(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsGrayscaleList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsGrayscaleList, jsii.get(self, "grayscale"))

    @builtins.property
    @jsii.member(jsii_name="hsl")
    def hsl(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsHslList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsHslList, jsii.get(self, "hsl"))

    @builtins.property
    @jsii.member(jsii_name="hsv")
    def hsv(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsHsvList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsHsvList, jsii.get(self, "hsv"))

    @builtins.property
    @jsii.member(jsii_name="ifDimension")
    def if_dimension(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionList, jsii.get(self, "ifDimension"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientation")
    def if_orientation(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationList, jsii.get(self, "ifOrientation"))

    @builtins.property
    @jsii.member(jsii_name="maxColors")
    def max_colors(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsMaxColorsList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsMaxColorsList, jsii.get(self, "maxColors"))

    @builtins.property
    @jsii.member(jsii_name="mirror")
    def mirror(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsMirrorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsMirrorList, jsii.get(self, "mirror"))

    @builtins.property
    @jsii.member(jsii_name="monoHue")
    def mono_hue(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsMonoHueList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsMonoHueList, jsii.get(self, "monoHue"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsOpacityList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsOpacityList, jsii.get(self, "opacity"))

    @builtins.property
    @jsii.member(jsii_name="removeColor")
    def remove_color(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsRemoveColorList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsRemoveColorList", jsii.get(self, "removeColor"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMask")
    def unsharp_mask(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsUnsharpMaskList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsUnsharpMaskList", jsii.get(self, "unsharpMask"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColorInput")
    def background_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsBackgroundColor]]], jsii.get(self, "backgroundColorInput"))

    @builtins.property
    @jsii.member(jsii_name="blurInput")
    def blur_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsBlur]]], jsii.get(self, "blurInput"))

    @builtins.property
    @jsii.member(jsii_name="chromaKeyInput")
    def chroma_key_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsChromaKey]]], jsii.get(self, "chromaKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="compositeInput")
    def composite_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsComposite]]], jsii.get(self, "compositeInput"))

    @builtins.property
    @jsii.member(jsii_name="compoundInput")
    def compound_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompound]]], jsii.get(self, "compoundInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsContrast]]], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="goopInput")
    def goop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsGoop]]], jsii.get(self, "goopInput"))

    @builtins.property
    @jsii.member(jsii_name="grayscaleInput")
    def grayscale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsGrayscale]]], jsii.get(self, "grayscaleInput"))

    @builtins.property
    @jsii.member(jsii_name="hslInput")
    def hsl_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsHsl]]], jsii.get(self, "hslInput"))

    @builtins.property
    @jsii.member(jsii_name="hsvInput")
    def hsv_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsHsv]]], jsii.get(self, "hsvInput"))

    @builtins.property
    @jsii.member(jsii_name="ifDimensionInput")
    def if_dimension_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimension]]], jsii.get(self, "ifDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientationInput")
    def if_orientation_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientation]]], jsii.get(self, "ifOrientationInput"))

    @builtins.property
    @jsii.member(jsii_name="maxColorsInput")
    def max_colors_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsMaxColors]]], jsii.get(self, "maxColorsInput"))

    @builtins.property
    @jsii.member(jsii_name="mirrorInput")
    def mirror_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsMirror]]], jsii.get(self, "mirrorInput"))

    @builtins.property
    @jsii.member(jsii_name="monoHueInput")
    def mono_hue_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsMonoHue]]], jsii.get(self, "monoHueInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsOpacity]]], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="removeColorInput")
    def remove_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsRemoveColor"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsRemoveColor"]]], jsii.get(self, "removeColorInput"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMaskInput")
    def unsharp_mask_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsUnsharpMask"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsUnsharpMask"]]], jsii.get(self, "unsharpMaskInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformations]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformations]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformations]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea7063b35859821531c6b1b3165f095f353c1164676d761a4b877e160b2d5cad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsRemoveColor",
    jsii_struct_bases=[],
    name_mapping={
        "color": "color",
        "color_var": "colorVar",
        "feather": "feather",
        "feather_var": "featherVar",
        "tolerance": "tolerance",
        "tolerance_var": "toleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsRemoveColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
        feather: typing.Optional[builtins.str] = None,
        feather_var: typing.Optional[builtins.str] = None,
        tolerance: typing.Optional[builtins.str] = None,
        tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        :param feather: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        :param feather_var: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        :param tolerance: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        :param tolerance_var: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1aa14b8fee3b034c28f88a3d2f5850bf9c830063e1031bb38c310c5b670d9106)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
            check_type(argname="argument feather", value=feather, expected_type=type_hints["feather"])
            check_type(argname="argument feather_var", value=feather_var, expected_type=type_hints["feather_var"])
            check_type(argname="argument tolerance", value=tolerance, expected_type=type_hints["tolerance"])
            check_type(argname="argument tolerance_var", value=tolerance_var, expected_type=type_hints["tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var
        if feather is not None:
            self._values["feather"] = feather
        if feather_var is not None:
            self._values["feather_var"] = feather_var
        if tolerance is not None:
            self._values["tolerance"] = tolerance
        if tolerance_var is not None:
            self._values["tolerance_var"] = tolerance_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        '''
        result = self._values.get("feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather_var(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        '''
        result = self._values.get("feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        '''
        result = self._values.get("tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance_var(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        result = self._values.get("tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsRemoveColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsRemoveColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsRemoveColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1998cdfe2af8d9ecfc9974eb34bef5fca09b89dc2d483d1bad455beccd629750)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsRemoveColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f5ee1ed27df1f87cac080561f9dbd51aef9c3553ecaf86819a763bfb8eeec53a)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsRemoveColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6427993323812e77e579b40dc5d843755d25d5cff739e05c6931c712eca345fb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__810b3b6fac5fb03470c033c4ac8fb3aa852990936aee0783545e3a5533c4b94e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e7e68c581ab688e93bb10fb75e8c17cbbfac24356f07bced4ddf2796fe739e6e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsRemoveColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsRemoveColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsRemoveColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3cf5ac0b804f6f9ab43e955e8eda1e0a5f4f71f5a9908ee9c67fa7b5f1181c37)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsRemoveColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsRemoveColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__568266c4602aa81d082da0e32b92c4793b3bb54ac6b285959ba0d392ffe98edd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @jsii.member(jsii_name="resetFeather")
    def reset_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeather", []))

    @jsii.member(jsii_name="resetFeatherVar")
    def reset_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatherVar", []))

    @jsii.member(jsii_name="resetTolerance")
    def reset_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTolerance", []))

    @jsii.member(jsii_name="resetToleranceVar")
    def reset_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featherInput")
    def feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherInput"))

    @builtins.property
    @jsii.member(jsii_name="featherVarInput")
    def feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceInput")
    def tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceVarInput")
    def tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c0413348a599d368888c8b4b212bde0e7ca51c0d3bbbb7b866765d44a56b13ca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__033631f5aea458eb808eb5a1261b8f3487534342d27669c27b93d5f767ddcdb3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="feather")
    def feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "feather"))

    @feather.setter
    def feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__05f898e26e67cf985ce4b1079e0649e766c221785f11d46006ce96f3f60a9643)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "feather", value)

    @builtins.property
    @jsii.member(jsii_name="featherVar")
    def feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featherVar"))

    @feather_var.setter
    def feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__017ac9047808167dba07f449db115e411ff797e60e3dd0cfd4a9578548081ccf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featherVar", value)

    @builtins.property
    @jsii.member(jsii_name="tolerance")
    def tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tolerance"))

    @tolerance.setter
    def tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a069bca87f0d7a09e41e2893514f6bd4e8be402521b7afd094fd33e40298a82)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tolerance", value)

    @builtins.property
    @jsii.member(jsii_name="toleranceVar")
    def tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "toleranceVar"))

    @tolerance_var.setter
    def tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e970530e2b31e430fe9e8806b3a8f12ca005770a3b73e27593e7670e6aa81070)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "toleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsRemoveColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsRemoveColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsRemoveColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__62ad5dad0bf2ee556f0726dd87af52cdf745c545be669b276b2eebf369514e55)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsUnsharpMask",
    jsii_struct_bases=[],
    name_mapping={
        "gain": "gain",
        "gain_var": "gainVar",
        "sigma": "sigma",
        "sigma_var": "sigmaVar",
        "threshold": "threshold",
        "threshold_var": "thresholdVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsUnsharpMask:
    def __init__(
        self,
        *,
        gain: typing.Optional[builtins.str] = None,
        gain_var: typing.Optional[builtins.str] = None,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
        threshold: typing.Optional[builtins.str] = None,
        threshold_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param gain: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        :param gain_var: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        :param sigma: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        :param threshold: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        :param threshold_var: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e3d9bb46c4c3a6263c7de79f4d7ae39a33155289ed8b44554508fdb2361ee8c4)
            check_type(argname="argument gain", value=gain, expected_type=type_hints["gain"])
            check_type(argname="argument gain_var", value=gain_var, expected_type=type_hints["gain_var"])
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
            check_type(argname="argument threshold", value=threshold, expected_type=type_hints["threshold"])
            check_type(argname="argument threshold_var", value=threshold_var, expected_type=type_hints["threshold_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if gain is not None:
            self._values["gain"] = gain
        if gain_var is not None:
            self._values["gain_var"] = gain_var
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var
        if threshold is not None:
            self._values["threshold"] = threshold
        if threshold_var is not None:
            self._values["threshold_var"] = threshold_var

    @builtins.property
    def gain(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        '''
        result = self._values.get("gain")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gain_var(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        '''
        result = self._values.get("gain_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        '''
        result = self._values.get("threshold")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold_var(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        result = self._values.get("threshold_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsUnsharpMask(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsUnsharpMaskList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsUnsharpMaskList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__75dcd50dec69cb2ecfc9f45be5c80c143064446ec463f2bb11149f6ac2f7926f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsUnsharpMaskOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a2ea21d53152805d8f2f8fb727c58f9bc0e4888cfd428715b118f9afe93fcc13)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsUnsharpMaskOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f2429b3efa16e0eb06ef3d2cb17aff972a9dfa7863a13db3810b358d9f34ec38)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6539f8ea991c2e6526f44ca3a41d7ed08ef7df4ee426241c41cdbedbf676c77a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa8fd4c2b10f5882df2df04014495fb697760f32d6bc56a3edc6780c1ebb0b39)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsUnsharpMask]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsUnsharpMask]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsUnsharpMask]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4b1335881d9068befd07c6248ddc68145ff1f233c8047b27d143df2fd2b84ffa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsUnsharpMaskOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsUnsharpMaskOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__098d511ffccf34b1715f46709d9af1109cf0e66f19bb9ae4ea299f3356368d98)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetGain")
    def reset_gain(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGain", []))

    @jsii.member(jsii_name="resetGainVar")
    def reset_gain_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGainVar", []))

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @jsii.member(jsii_name="resetThreshold")
    def reset_threshold(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThreshold", []))

    @jsii.member(jsii_name="resetThresholdVar")
    def reset_threshold_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThresholdVar", []))

    @builtins.property
    @jsii.member(jsii_name="gainInput")
    def gain_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainInput"))

    @builtins.property
    @jsii.member(jsii_name="gainVarInput")
    def gain_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdInput")
    def threshold_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdVarInput")
    def threshold_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gain")
    def gain(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gain"))

    @gain.setter
    def gain(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7c95c2dce82c89721271829c8020cf2a4f3422d33f4298fa35295341e19d2f72)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gain", value)

    @builtins.property
    @jsii.member(jsii_name="gainVar")
    def gain_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gainVar"))

    @gain_var.setter
    def gain_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4f9ddb8ecafd6309a7d2de7b2cd6cd881586dd6ba448bd256a86c7bbeacb29d8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gainVar", value)

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__baac5607531b1489879aa0754e502824a35a8b721b2b68e89d348cc319e193f6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__118463a1bdf7e9a5a660fc3665c7058b551930a8e7366cce1485b692fef7fd46)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="threshold")
    def threshold(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "threshold"))

    @threshold.setter
    def threshold(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e27a2503ee98c0c58618f74924de3c7fb3a9704245605697d1510e2c782662e7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "threshold", value)

    @builtins.property
    @jsii.member(jsii_name="thresholdVar")
    def threshold_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "thresholdVar"))

    @threshold_var.setter
    def threshold_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d5693ead62cfe295f5a316b7a2f9ad05adffffd25c289895bd918a0125c51caa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "thresholdVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsUnsharpMask]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsUnsharpMask]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsUnsharpMask]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d1298a3e25b48ff01c135e405c9a09c5ce383bd52e8b6603c847d007664eed59)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsContrast",
    jsii_struct_bases=[],
    name_mapping={
        "brightness": "brightness",
        "brightness_var": "brightnessVar",
        "contrast": "contrast",
        "contrast_var": "contrastVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsContrast:
    def __init__(
        self,
        *,
        brightness: typing.Optional[builtins.str] = None,
        brightness_var: typing.Optional[builtins.str] = None,
        contrast: typing.Optional[builtins.str] = None,
        contrast_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param brightness: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        :param brightness_var: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        :param contrast: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param contrast_var: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4dbcbe4b2ea80c2f2100647e4df7566619a43d2fbdae57cebdf5a36944ea58a2)
            check_type(argname="argument brightness", value=brightness, expected_type=type_hints["brightness"])
            check_type(argname="argument brightness_var", value=brightness_var, expected_type=type_hints["brightness_var"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument contrast_var", value=contrast_var, expected_type=type_hints["contrast_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if brightness is not None:
            self._values["brightness"] = brightness
        if brightness_var is not None:
            self._values["brightness_var"] = brightness_var
        if contrast is not None:
            self._values["contrast"] = contrast
        if contrast_var is not None:
            self._values["contrast_var"] = contrast_var

    @builtins.property
    def brightness(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        '''
        result = self._values.get("brightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def brightness_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        '''
        result = self._values.get("brightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        result = self._values.get("contrast_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsContrast(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsContrastList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsContrastList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__49b9d07ef96423b127ebd2e6769c71ba015c61b25d220cb3947d8d929c5532aa)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsContrastOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c2d912392b0cc2f4d46fd238faeb1ed5b330a12c12ee37ff0a8c9f1494a488cb)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsContrastOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b4a613ac529cbc7e0944bf02d9e824872b176aab78262ba304d41c5be7106310)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ca5a3b58fa75318ff1cd9ae40e71d30254b38ca32f1aa2ea5eba96c1d648d62a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fd45c4055b6dcf01fcd22cc60f93b63c2c083eed64f305a4485d48e9054dbe08)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsContrast]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsContrast]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cae002dd272a8318df9b33f30ede80b9a43072087424abd3901ac3f6ae4f1519)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsContrastOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsContrastOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dbc690446d91f6644c7fe043b99e94bfd73a16eeb528abd6de272d7829d68452)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetBrightness")
    def reset_brightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightness", []))

    @jsii.member(jsii_name="resetBrightnessVar")
    def reset_brightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightnessVar", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetContrastVar")
    def reset_contrast_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrastVar", []))

    @builtins.property
    @jsii.member(jsii_name="brightnessInput")
    def brightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="brightnessVarInput")
    def brightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastVarInput")
    def contrast_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="brightness")
    def brightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightness"))

    @brightness.setter
    def brightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5e7fb214dd0acd15646d522ed73a8c6c909790797376dec4efb219466c576571)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightness", value)

    @builtins.property
    @jsii.member(jsii_name="brightnessVar")
    def brightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightnessVar"))

    @brightness_var.setter
    def brightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0df71545d304a6c30d7584bb56e587d0c947c5b773f1b7965b70cbf345dbde76)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrast"))

    @contrast.setter
    def contrast(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e7b27a95ad8923a1c6c508a2c63db17235486f375964cef5303686f36e17e41e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrast", value)

    @builtins.property
    @jsii.member(jsii_name="contrastVar")
    def contrast_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrastVar"))

    @contrast_var.setter
    def contrast_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__008384b551ebbd0fca76896b1b42e6d5d4312a03c55f40468690c16ed4c3499c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrastVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsContrast]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsContrast]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsContrast]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e16552e0317e1b34b0076aa93420fc0d8241c4e304e13af4a42625cece2e431d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsGoop",
    jsii_struct_bases=[],
    name_mapping={
        "chaos": "chaos",
        "chaos_var": "chaosVar",
        "density": "density",
        "density_var": "densityVar",
        "power": "power",
        "power_var": "powerVar",
        "seed": "seed",
        "seed_var": "seedVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsGoop:
    def __init__(
        self,
        *,
        chaos: typing.Optional[builtins.str] = None,
        chaos_var: typing.Optional[builtins.str] = None,
        density: typing.Optional[builtins.str] = None,
        density_var: typing.Optional[builtins.str] = None,
        power: typing.Optional[builtins.str] = None,
        power_var: typing.Optional[builtins.str] = None,
        seed: typing.Optional[builtins.str] = None,
        seed_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param chaos: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        :param chaos_var: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        :param density: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        :param density_var: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        :param power: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        :param power_var: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        :param seed: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        :param seed_var: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__92f4350b78ffacd7b128edc2b15d77a935634edf5b4f1eb20ea4ad759bb26d8b)
            check_type(argname="argument chaos", value=chaos, expected_type=type_hints["chaos"])
            check_type(argname="argument chaos_var", value=chaos_var, expected_type=type_hints["chaos_var"])
            check_type(argname="argument density", value=density, expected_type=type_hints["density"])
            check_type(argname="argument density_var", value=density_var, expected_type=type_hints["density_var"])
            check_type(argname="argument power", value=power, expected_type=type_hints["power"])
            check_type(argname="argument power_var", value=power_var, expected_type=type_hints["power_var"])
            check_type(argname="argument seed", value=seed, expected_type=type_hints["seed"])
            check_type(argname="argument seed_var", value=seed_var, expected_type=type_hints["seed_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if chaos is not None:
            self._values["chaos"] = chaos
        if chaos_var is not None:
            self._values["chaos_var"] = chaos_var
        if density is not None:
            self._values["density"] = density
        if density_var is not None:
            self._values["density_var"] = density_var
        if power is not None:
            self._values["power"] = power
        if power_var is not None:
            self._values["power_var"] = power_var
        if seed is not None:
            self._values["seed"] = seed
        if seed_var is not None:
            self._values["seed_var"] = seed_var

    @builtins.property
    def chaos(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        '''
        result = self._values.get("chaos")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def chaos_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        '''
        result = self._values.get("chaos_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        '''
        result = self._values.get("density")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density_var(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        '''
        result = self._values.get("density_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        '''
        result = self._values.get("power")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power_var(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        '''
        result = self._values.get("power_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        '''
        result = self._values.get("seed")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed_var(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        result = self._values.get("seed_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsGoop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsGoopList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsGoopList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__53f65d65d657f7220d44154a829da2505f8d71c00fa062ea417bea996fe951e5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsGoopOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__522fee3d9c806ff93fd81d0bc260d917c63921b960659eb38fc008f45f4871e7)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsGoopOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dcf17855966510d3bf309de297f802ff996a0afc916b1d812516bc876a6d3cad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b9c942abdfafe5a1414a495744f8be132c880fb7a829b5bc8dfaa626753e9272)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__919a5b03d5c2fbb31f10e690d7fc9d942fcabcf5ee94068565e979c368193d5e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsGoop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsGoop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__76f121771a975abff4faf6944b58b7b9cd6a47b63d4430f0f9549e3c79b01439)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsGoopOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsGoopOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__47b44f54dc1bfba09382f7d0e5c4cc4c944fcafcaef3903c95beaeda35eba22d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetChaos")
    def reset_chaos(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaos", []))

    @jsii.member(jsii_name="resetChaosVar")
    def reset_chaos_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaosVar", []))

    @jsii.member(jsii_name="resetDensity")
    def reset_density(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensity", []))

    @jsii.member(jsii_name="resetDensityVar")
    def reset_density_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensityVar", []))

    @jsii.member(jsii_name="resetPower")
    def reset_power(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPower", []))

    @jsii.member(jsii_name="resetPowerVar")
    def reset_power_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPowerVar", []))

    @jsii.member(jsii_name="resetSeed")
    def reset_seed(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeed", []))

    @jsii.member(jsii_name="resetSeedVar")
    def reset_seed_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeedVar", []))

    @builtins.property
    @jsii.member(jsii_name="chaosInput")
    def chaos_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosInput"))

    @builtins.property
    @jsii.member(jsii_name="chaosVarInput")
    def chaos_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosVarInput"))

    @builtins.property
    @jsii.member(jsii_name="densityInput")
    def density_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityInput"))

    @builtins.property
    @jsii.member(jsii_name="densityVarInput")
    def density_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="powerInput")
    def power_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerInput"))

    @builtins.property
    @jsii.member(jsii_name="powerVarInput")
    def power_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerVarInput"))

    @builtins.property
    @jsii.member(jsii_name="seedInput")
    def seed_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedInput"))

    @builtins.property
    @jsii.member(jsii_name="seedVarInput")
    def seed_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedVarInput"))

    @builtins.property
    @jsii.member(jsii_name="chaos")
    def chaos(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaos"))

    @chaos.setter
    def chaos(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__74ef0c08ce4c296245371fb36cb9c6444ef6f68647bae251179534342a1dd3c3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaos", value)

    @builtins.property
    @jsii.member(jsii_name="chaosVar")
    def chaos_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaosVar"))

    @chaos_var.setter
    def chaos_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e4af1f8105ca4b5e7f3a30a398c4f1282c6914d92047d1bff8933d18d803df67)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaosVar", value)

    @builtins.property
    @jsii.member(jsii_name="density")
    def density(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "density"))

    @density.setter
    def density(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ad767a52321bca3b7239b6c4458a8d8f3ad719ead2d491ae19da18e4eff701d6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "density", value)

    @builtins.property
    @jsii.member(jsii_name="densityVar")
    def density_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "densityVar"))

    @density_var.setter
    def density_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d8bbef3255308fae852d75277a8206639e2fac696702afae37cdcd83c3e6c60c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "densityVar", value)

    @builtins.property
    @jsii.member(jsii_name="power")
    def power(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "power"))

    @power.setter
    def power(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3649f95c306cc229c60841f870226f541bcae63c90edaf3e344f788299377e0f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "power", value)

    @builtins.property
    @jsii.member(jsii_name="powerVar")
    def power_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "powerVar"))

    @power_var.setter
    def power_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c8780599cb55805b1ec51ca2bab511d940773a341fe4e328db0a6a213a72dc24)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "powerVar", value)

    @builtins.property
    @jsii.member(jsii_name="seed")
    def seed(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seed"))

    @seed.setter
    def seed(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0748d478b41281404cf4f478cf72c3434aa82ab557ba82a5fe6db5e93ab12994)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seed", value)

    @builtins.property
    @jsii.member(jsii_name="seedVar")
    def seed_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seedVar"))

    @seed_var.setter
    def seed_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2fde80d0bd0fe51306a0e7e97c75900799b18e32442f6f9c0a93b6b3f81bd9f1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seedVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsGoop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsGoop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsGoop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d1c4d2a1c08a1737a405beedd54b719b73a201656e53dfe2319be8abee02e01a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsGrayscale",
    jsii_struct_bases=[],
    name_mapping={"type": "type", "type_var": "typeVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsGrayscale:
    def __init__(
        self,
        *,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param type: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8f7d274963ae381f0152df080e513713fec93da83b16b2c6d5497bf2264b091e)
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsGrayscale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsGrayscaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsGrayscaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e37f556b23f7b53f735e58ca27e0d299bdcb136ebb667b81c3f02ab516bb7284)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsGrayscaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__21360cbf085c461377cd147cb578982ae4149013319c8c027b428267437ed42d)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsGrayscaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__85e0faa61f482f3b9c6157412e3d8a0106514117254ea31858e9a7c23ee5828a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5974c367227e6c5806c35ff8cd81de559fd63c2e8a9178be5c1a480fd9544422)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bddf9fd3ee41d3c2a18e98f988a00c2ff330eaac0abdc6cfc756f500b9694819)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsGrayscale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsGrayscale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1157402b1f72a560404e82b2727ccc60c2461b871e44dc4eb111eb9ab9c0d986)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsGrayscaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsGrayscaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9df65ce7ff0ef6d1de4797b9030af9c805e0ee4b7c5259be0ea8f3869a7c0ae5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__89c6e2d93605565ffa58c4dbccfc59b8ae8e4a88d4b8ed0c7c187d2a04dc35b3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__58ad0d781f45848e862d32e3feb65182d95edb03d6e536d9f4fc307c8e2d0be8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsGrayscale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsGrayscale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsGrayscale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b23e25f4bf379383d4ed088635ef24382a04f418befee37ddb59aabe0ddd5cd5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsHsl",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "lightness": "lightness",
        "lightness_var": "lightnessVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsHsl:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness: typing.Optional[builtins.str] = None,
        lightness_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        :param lightness_var: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8e93f4a4c028f226092a258fa7181bd2e96ea0df5a8e73b8b7f67005d5bad443)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness", value=lightness, expected_type=type_hints["lightness"])
            check_type(argname="argument lightness_var", value=lightness_var, expected_type=type_hints["lightness_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness is not None:
            self._values["lightness"] = lightness
        if lightness_var is not None:
            self._values["lightness_var"] = lightness_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        '''
        result = self._values.get("lightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        '''
        result = self._values.get("lightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsHsl(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsHslList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsHslList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f950e3b1b46fccd11e25dadece636683baedff189e87f9abf635634b1655421b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsHslOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c5180f44fb0fd381658a56d4037c758bba8e0e3dc6d12c61bd12eab4e6e74507)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsHslOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c0d461b316ed0fd16a56b1ed5a048d3d02e1045a93fe5e143a03d8693a2c521f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e05c6d2086812de987e640c6b2d40badc258e1438059e24e68988a2b23a47ef4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__30b07c77b2faa5253284d1d57e322ef17145b2024c68d58bb7359ef9ddb4bdc2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsHsl]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsHsl]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__936c0484382f0d157d2aeafa081c432db103b2b91269f870c5933c99fd5bd219)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsHslOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsHslOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d2f54b7006106d43c12c090ce4f480ccbcbb77148072ed69dba39cc2c17a271)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightness")
    def reset_lightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightness", []))

    @jsii.member(jsii_name="resetLightnessVar")
    def reset_lightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessInput")
    def lightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessVarInput")
    def lightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ce9fc479628e097a66d987946461d3c244bfe2d7c9198dd7a051595f193c019)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a5b739c81817c10e23f43292d010a5c11f57efc4c879565404bd17e186daf70)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightness")
    def lightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightness"))

    @lightness.setter
    def lightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2c2a8c41f7de154f9e1c622aa377711a0c963e290b639e7085501e3e1b6c7eac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightness", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessVar")
    def lightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessVar"))

    @lightness_var.setter
    def lightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e01534452cdd422f31b31fe9469c26b45c8b94a6b1829bdaa3edb9d3fe7fe9fe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ec70a4c4b4c99f89c453d2642f58286214901cc8ff7725e2c8e9302ef20676c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df18f596564d7dc5c74d6ab7c733e5ee05d1271ce4cf171d09e8ccf27389aee7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsHsl]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsHsl]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsHsl]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b8550e08623a3c2f3fc2bf8a12af0cf5ae7848053658d212e9ef6480e032f404)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsHsv",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsHsv:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        :param value: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0f02a6deb6e5165ae25c58de2f2f330ebef3eb78da83f843ed3c0aa5c3865b8d)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsHsv(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsHsvList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsHsvList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9144894e54efbd9a1d79bcd11b1abd5bde3bd95088f495146fe74bc897fe6763)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsHsvOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__76f5cb4cb4ec1067fc1bd27a248fd491303c1036fa636944aa2dc16e51ce33c0)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsHsvOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__44ea386e59d3c1dff11d7b6a11b45a78736d0b83dd1f590f9e4a2ee1bc8a136b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a10e7287015e56e4414d8e366f53d663f768d5941ecdf48b26bfc5738c51693)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1694f789ed6bcb77e2a66f83bedc4a01f6c9edd7d25125218494ed86b7bb779f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsHsv]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsHsv]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b2131555a67d38ca6ebd70b6376254c32f996d69bdf4a46e001d275af1729b02)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsHsvOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsHsvOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c08ccf20cdca72f24b831a808cab75b07e8bf854a6837fc560d5a912901af774)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f7381a01a4e1f5a2fb777f01564bfe70888eb3e8e652d2587cb994d009a885a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a11352d6a301c571d2c4e038e8e9263d731deb128f61899d2bdfaa878b1c797e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ae57fc2e18ff1fa6a0f00c622763e5a71a3f39561b0a876cc5000c026dacfcf3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b7bf2b69a6c1e2557a43ec4801b07f8466b57a0ba64cd206248594a731d55cda)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df9c41aff2734b2aa798a37201f4de9a0753f0c7fb8335234633b099e9a53c9f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b1df125c6f6b6c02996795c533c2a26ce2e45b2507dcfc93da5952b5c3f7a2ef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsHsv]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsHsv]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsHsv]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b2a7a778fd86f77da04905a8cfb6496197f3127c4460bbc63bd86f111654e668)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimension",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "dimension": "dimension",
        "dimension_var": "dimensionVar",
        "equal": "equal",
        "greater_than": "greaterThan",
        "less_than": "lessThan",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimension:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        dimension: typing.Optional[builtins.str] = None,
        dimension_var: typing.Optional[builtins.str] = None,
        equal: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqual", typing.Dict[builtins.str, typing.Any]]] = None,
        greater_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThan", typing.Dict[builtins.str, typing.Any]]] = None,
        less_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThan", typing.Dict[builtins.str, typing.Any]]] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param dimension: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        :param dimension_var: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        :param equal: equal block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        :param greater_than: greater_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        :param less_than: less_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        :param value: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefault(**default)
        if isinstance(equal, dict):
            equal = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqual(**equal)
        if isinstance(greater_than, dict):
            greater_than = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThan(**greater_than)
        if isinstance(less_than, dict):
            less_than = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThan(**less_than)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e7175d0feca651b70c4a91c71c0fe4c1a848e281f1d7fc912301052c06fa9872)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument dimension", value=dimension, expected_type=type_hints["dimension"])
            check_type(argname="argument dimension_var", value=dimension_var, expected_type=type_hints["dimension_var"])
            check_type(argname="argument equal", value=equal, expected_type=type_hints["equal"])
            check_type(argname="argument greater_than", value=greater_than, expected_type=type_hints["greater_than"])
            check_type(argname="argument less_than", value=less_than, expected_type=type_hints["less_than"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if dimension is not None:
            self._values["dimension"] = dimension
        if dimension_var is not None:
            self._values["dimension_var"] = dimension_var
        if equal is not None:
            self._values["equal"] = equal
        if greater_than is not None:
            self._values["greater_than"] = greater_than
        if less_than is not None:
            self._values["less_than"] = less_than
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefault"], result)

    @builtins.property
    def dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        '''
        result = self._values.get("dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        '''
        result = self._values.get("dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def equal(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqual"]:
        '''equal block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        '''
        result = self._values.get("equal")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqual"], result)

    @builtins.property
    def greater_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThan"]:
        '''greater_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        '''
        result = self._values.get("greater_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThan"], result)

    @builtins.property
    def less_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThan"]:
        '''less_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        '''
        result = self._values.get("less_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThan"], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimension(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefault",
    jsii_struct_bases=[],
    name_mapping={
        "background_color": "backgroundColor",
        "blur": "blur",
        "chroma_key": "chromaKey",
        "composite": "composite",
        "compound": "compound",
        "contrast": "contrast",
        "goop": "goop",
        "grayscale": "grayscale",
        "hsl": "hsl",
        "hsv": "hsv",
        "if_dimension": "ifDimension",
        "if_orientation": "ifOrientation",
        "max_colors": "maxColors",
        "mirror": "mirror",
        "mono_hue": "monoHue",
        "opacity": "opacity",
        "remove_color": "removeColor",
        "unsharp_mask": "unsharpMask",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefault:
    def __init__(
        self,
        *,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultBackgroundColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultBlur", typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultChromaKey", typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultComposite", typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompound", typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultContrast", typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultGoop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultGrayscale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultHsl", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultHsv", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientation", typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultMaxColors", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultMirror", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultMonoHue", typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultOpacity", typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultRemoveColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultUnsharpMask", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8b4f22ea254a147b29603e5eaca532972da96a16041f6c453012abf3a3e5a60f)
            check_type(argname="argument background_color", value=background_color, expected_type=type_hints["background_color"])
            check_type(argname="argument blur", value=blur, expected_type=type_hints["blur"])
            check_type(argname="argument chroma_key", value=chroma_key, expected_type=type_hints["chroma_key"])
            check_type(argname="argument composite", value=composite, expected_type=type_hints["composite"])
            check_type(argname="argument compound", value=compound, expected_type=type_hints["compound"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument goop", value=goop, expected_type=type_hints["goop"])
            check_type(argname="argument grayscale", value=grayscale, expected_type=type_hints["grayscale"])
            check_type(argname="argument hsl", value=hsl, expected_type=type_hints["hsl"])
            check_type(argname="argument hsv", value=hsv, expected_type=type_hints["hsv"])
            check_type(argname="argument if_dimension", value=if_dimension, expected_type=type_hints["if_dimension"])
            check_type(argname="argument if_orientation", value=if_orientation, expected_type=type_hints["if_orientation"])
            check_type(argname="argument max_colors", value=max_colors, expected_type=type_hints["max_colors"])
            check_type(argname="argument mirror", value=mirror, expected_type=type_hints["mirror"])
            check_type(argname="argument mono_hue", value=mono_hue, expected_type=type_hints["mono_hue"])
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument remove_color", value=remove_color, expected_type=type_hints["remove_color"])
            check_type(argname="argument unsharp_mask", value=unsharp_mask, expected_type=type_hints["unsharp_mask"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if background_color is not None:
            self._values["background_color"] = background_color
        if blur is not None:
            self._values["blur"] = blur
        if chroma_key is not None:
            self._values["chroma_key"] = chroma_key
        if composite is not None:
            self._values["composite"] = composite
        if compound is not None:
            self._values["compound"] = compound
        if contrast is not None:
            self._values["contrast"] = contrast
        if goop is not None:
            self._values["goop"] = goop
        if grayscale is not None:
            self._values["grayscale"] = grayscale
        if hsl is not None:
            self._values["hsl"] = hsl
        if hsv is not None:
            self._values["hsv"] = hsv
        if if_dimension is not None:
            self._values["if_dimension"] = if_dimension
        if if_orientation is not None:
            self._values["if_orientation"] = if_orientation
        if max_colors is not None:
            self._values["max_colors"] = max_colors
        if mirror is not None:
            self._values["mirror"] = mirror
        if mono_hue is not None:
            self._values["mono_hue"] = mono_hue
        if opacity is not None:
            self._values["opacity"] = opacity
        if remove_color is not None:
            self._values["remove_color"] = remove_color
        if unsharp_mask is not None:
            self._values["unsharp_mask"] = unsharp_mask

    @builtins.property
    def background_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultBackgroundColor"]]]:
        '''background_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        '''
        result = self._values.get("background_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultBackgroundColor"]]], result)

    @builtins.property
    def blur(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultBlur"]]]:
        '''blur block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        '''
        result = self._values.get("blur")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultBlur"]]], result)

    @builtins.property
    def chroma_key(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultChromaKey"]]]:
        '''chroma_key block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        '''
        result = self._values.get("chroma_key")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultChromaKey"]]], result)

    @builtins.property
    def composite(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultComposite"]]]:
        '''composite block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        '''
        result = self._values.get("composite")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultComposite"]]], result)

    @builtins.property
    def compound(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompound"]]]:
        '''compound block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        '''
        result = self._values.get("compound")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompound"]]], result)

    @builtins.property
    def contrast(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultContrast"]]]:
        '''contrast block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultContrast"]]], result)

    @builtins.property
    def goop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultGoop"]]]:
        '''goop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        '''
        result = self._values.get("goop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultGoop"]]], result)

    @builtins.property
    def grayscale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultGrayscale"]]]:
        '''grayscale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        '''
        result = self._values.get("grayscale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultGrayscale"]]], result)

    @builtins.property
    def hsl(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultHsl"]]]:
        '''hsl block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        '''
        result = self._values.get("hsl")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultHsl"]]], result)

    @builtins.property
    def hsv(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultHsv"]]]:
        '''hsv block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        '''
        result = self._values.get("hsv")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultHsv"]]], result)

    @builtins.property
    def if_dimension(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimension]]]:
        '''if_dimension block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        '''
        result = self._values.get("if_dimension")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimension]]], result)

    @builtins.property
    def if_orientation(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientation"]]]:
        '''if_orientation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        '''
        result = self._values.get("if_orientation")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientation"]]], result)

    @builtins.property
    def max_colors(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultMaxColors"]]]:
        '''max_colors block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        '''
        result = self._values.get("max_colors")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultMaxColors"]]], result)

    @builtins.property
    def mirror(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultMirror"]]]:
        '''mirror block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        '''
        result = self._values.get("mirror")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultMirror"]]], result)

    @builtins.property
    def mono_hue(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultMonoHue"]]]:
        '''mono_hue block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        '''
        result = self._values.get("mono_hue")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultMonoHue"]]], result)

    @builtins.property
    def opacity(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultOpacity"]]]:
        '''opacity block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultOpacity"]]], result)

    @builtins.property
    def remove_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultRemoveColor"]]]:
        '''remove_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        '''
        result = self._values.get("remove_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultRemoveColor"]]], result)

    @builtins.property
    def unsharp_mask(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultUnsharpMask"]]]:
        '''unsharp_mask block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        result = self._values.get("unsharp_mask")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultUnsharpMask"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultBackgroundColor",
    jsii_struct_bases=[],
    name_mapping={"color": "color", "color_var": "colorVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultBackgroundColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__071c1a92628c02cbe32bfd275a71980529a8d4affbcc68d0b10531e86211fabe)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultBackgroundColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultBackgroundColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultBackgroundColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__efb70c631368b061c8df8656a0b27ecd23aa9522e7a6fc1948d27d36ed06618f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultBackgroundColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__393109a4357c79c769f48c1356d0193c8ecf52f7c82ecda99d6ed5ae99e34b93)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultBackgroundColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3406b0c7a317949c9148a2e2203982adc7211d0446043440037164906e2465c3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__75d7f5eac874067db4333fc7b22ff27d27a6e9a1822acd9483694bdb70f1a787)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aebdc5b3c2d2d47470b675b4a8a1b21b3a6545f1f29211e4de048a8401ca2baf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultBackgroundColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultBackgroundColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0f9f1518e189fb87e4c1546fbf6b1a7f11d8e20c11cced6702cc2b3e9633b5aa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultBackgroundColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultBackgroundColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__77f2e5ae324a3bec545dbd15d5493e94e8d324c09e752da90399bf0e3ef268ae)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9f6d3d4d5d73534ecc56247c66e271a1439529ddbc46569fbc2952108a0d72eb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__49b12a224ca575a0315e9f754eec2b0988e06ae34eba88ecd0d77453a2de4cfd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultBackgroundColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultBackgroundColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultBackgroundColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bdd495153f020c8358889c04078538c2f84544218d5d2d08655c825ee3d82516)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultBlur",
    jsii_struct_bases=[],
    name_mapping={"sigma": "sigma", "sigma_var": "sigmaVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultBlur:
    def __init__(
        self,
        *,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param sigma: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e33e40f3450de3aa0db965d9b2e510b8976f215c2a94c1bace6a84b148b50897)
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultBlur(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultBlurList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultBlurList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__89efe30467fb79b994fa93c859e4a9d60bfd5c55eab2a7d271995661ce25bd67)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultBlurOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c95c11468ba66b16b9117ad70db4663b018ae273588a8f8d0960289cc3104efb)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultBlurOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af926387c9d199d39be3fe67dd2ebb97a76ef124e0fd265ee2696bf52bdea474)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ae6fa810a363d5b97a2d40a49fc9fcdaff35ac045257a15aaaf59bd8542cdfbd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__36be0a4e4b3a0bdbb7879aac77c902b74285c82833df50a4f650be927da442e3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultBlur]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultBlur]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7235eb76a76557e1fec17639f83f15096fac279b2ef0f8da0dc71931779a618e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultBlurOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultBlurOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f83050f277464df81bd0373f098bdb2b5e1fdf7fce18fec9e7b779833d2f63d3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ea3f9ed913e1148b96085800223e820b5b36f307972a8dc5a2f4bdcd15588b7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3b3ea013d2d2057edd5c09e0948b2c4f5649b10373607414afc91e4e7bf0dbfc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultBlur]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultBlur]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultBlur]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ce1caec344b4d716ce23eea02bb2b26df1ccf638c19ce669db5c461554079db)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultChromaKey",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_feather": "hueFeather",
        "hue_feather_var": "hueFeatherVar",
        "hue_tolerance": "hueTolerance",
        "hue_tolerance_var": "hueToleranceVar",
        "hue_var": "hueVar",
        "lightness_feather": "lightnessFeather",
        "lightness_feather_var": "lightnessFeatherVar",
        "lightness_tolerance": "lightnessTolerance",
        "lightness_tolerance_var": "lightnessToleranceVar",
        "saturation_feather": "saturationFeather",
        "saturation_feather_var": "saturationFeatherVar",
        "saturation_tolerance": "saturationTolerance",
        "saturation_tolerance_var": "saturationToleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultChromaKey:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_feather: typing.Optional[builtins.str] = None,
        hue_feather_var: typing.Optional[builtins.str] = None,
        hue_tolerance: typing.Optional[builtins.str] = None,
        hue_tolerance_var: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness_feather: typing.Optional[builtins.str] = None,
        lightness_feather_var: typing.Optional[builtins.str] = None,
        lightness_tolerance: typing.Optional[builtins.str] = None,
        lightness_tolerance_var: typing.Optional[builtins.str] = None,
        saturation_feather: typing.Optional[builtins.str] = None,
        saturation_feather_var: typing.Optional[builtins.str] = None,
        saturation_tolerance: typing.Optional[builtins.str] = None,
        saturation_tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_feather: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        :param hue_feather_var: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        :param hue_tolerance: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        :param hue_tolerance_var: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        :param hue_var: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness_feather: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        :param lightness_feather_var: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        :param lightness_tolerance: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        :param lightness_tolerance_var: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        :param saturation_feather: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        :param saturation_feather_var: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        :param saturation_tolerance: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        :param saturation_tolerance_var: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__12ba1c5cd5614b5698b83ff4adad22aebd12a1301f9be12884efb50e12ac66a8)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_feather", value=hue_feather, expected_type=type_hints["hue_feather"])
            check_type(argname="argument hue_feather_var", value=hue_feather_var, expected_type=type_hints["hue_feather_var"])
            check_type(argname="argument hue_tolerance", value=hue_tolerance, expected_type=type_hints["hue_tolerance"])
            check_type(argname="argument hue_tolerance_var", value=hue_tolerance_var, expected_type=type_hints["hue_tolerance_var"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness_feather", value=lightness_feather, expected_type=type_hints["lightness_feather"])
            check_type(argname="argument lightness_feather_var", value=lightness_feather_var, expected_type=type_hints["lightness_feather_var"])
            check_type(argname="argument lightness_tolerance", value=lightness_tolerance, expected_type=type_hints["lightness_tolerance"])
            check_type(argname="argument lightness_tolerance_var", value=lightness_tolerance_var, expected_type=type_hints["lightness_tolerance_var"])
            check_type(argname="argument saturation_feather", value=saturation_feather, expected_type=type_hints["saturation_feather"])
            check_type(argname="argument saturation_feather_var", value=saturation_feather_var, expected_type=type_hints["saturation_feather_var"])
            check_type(argname="argument saturation_tolerance", value=saturation_tolerance, expected_type=type_hints["saturation_tolerance"])
            check_type(argname="argument saturation_tolerance_var", value=saturation_tolerance_var, expected_type=type_hints["saturation_tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_feather is not None:
            self._values["hue_feather"] = hue_feather
        if hue_feather_var is not None:
            self._values["hue_feather_var"] = hue_feather_var
        if hue_tolerance is not None:
            self._values["hue_tolerance"] = hue_tolerance
        if hue_tolerance_var is not None:
            self._values["hue_tolerance_var"] = hue_tolerance_var
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness_feather is not None:
            self._values["lightness_feather"] = lightness_feather
        if lightness_feather_var is not None:
            self._values["lightness_feather_var"] = lightness_feather_var
        if lightness_tolerance is not None:
            self._values["lightness_tolerance"] = lightness_tolerance
        if lightness_tolerance_var is not None:
            self._values["lightness_tolerance_var"] = lightness_tolerance_var
        if saturation_feather is not None:
            self._values["saturation_feather"] = saturation_feather
        if saturation_feather_var is not None:
            self._values["saturation_feather_var"] = saturation_feather_var
        if saturation_tolerance is not None:
            self._values["saturation_tolerance"] = saturation_tolerance
        if saturation_tolerance_var is not None:
            self._values["saturation_tolerance_var"] = saturation_tolerance_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        '''
        result = self._values.get("hue_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        '''
        result = self._values.get("hue_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        '''
        result = self._values.get("hue_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        '''
        result = self._values.get("hue_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        '''
        result = self._values.get("lightness_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        '''
        result = self._values.get("lightness_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        '''
        result = self._values.get("lightness_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        '''
        result = self._values.get("lightness_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        '''
        result = self._values.get("saturation_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        '''
        result = self._values.get("saturation_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        '''
        result = self._values.get("saturation_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        result = self._values.get("saturation_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultChromaKey(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultChromaKeyList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultChromaKeyList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8fbbda4d925037cc6eeb05fcddc88be9fe2828a18fa13e438adde39a34c9f5e7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultChromaKeyOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eae27dcb5f7b035b4358452b1a44f3a822c3cb5779d96ed7b9a3f8cbfd0ac644)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultChromaKeyOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__74c21bad9ba92506a4ec945f588813f35866307fccb19a81fa5f25848f9a7284)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cf874d286d6b385f53eafc07f7c419bd3e4743e478269f9fe47a3e596cc8963c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c7a7e4d31e88b61527d27baeca70d01f5953d9c20588178d7a956706b3aa46d0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultChromaKey]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultChromaKey]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c9a950706ed62fbea2b99529252a0ede8ccca9d09c0165a21ee3ca6608871f4c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultChromaKeyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultChromaKeyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d9c5fc69c79dac93a610de0d5858ed7a79d4353b5dbe4322a85061e1789fe027)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueFeather")
    def reset_hue_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeather", []))

    @jsii.member(jsii_name="resetHueFeatherVar")
    def reset_hue_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeatherVar", []))

    @jsii.member(jsii_name="resetHueTolerance")
    def reset_hue_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueTolerance", []))

    @jsii.member(jsii_name="resetHueToleranceVar")
    def reset_hue_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueToleranceVar", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightnessFeather")
    def reset_lightness_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeather", []))

    @jsii.member(jsii_name="resetLightnessFeatherVar")
    def reset_lightness_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeatherVar", []))

    @jsii.member(jsii_name="resetLightnessTolerance")
    def reset_lightness_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessTolerance", []))

    @jsii.member(jsii_name="resetLightnessToleranceVar")
    def reset_lightness_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessToleranceVar", []))

    @jsii.member(jsii_name="resetSaturationFeather")
    def reset_saturation_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeather", []))

    @jsii.member(jsii_name="resetSaturationFeatherVar")
    def reset_saturation_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeatherVar", []))

    @jsii.member(jsii_name="resetSaturationTolerance")
    def reset_saturation_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationTolerance", []))

    @jsii.member(jsii_name="resetSaturationToleranceVar")
    def reset_saturation_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherInput")
    def hue_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVarInput")
    def hue_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceInput")
    def hue_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVarInput")
    def hue_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherInput")
    def lightness_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVarInput")
    def lightness_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceInput")
    def lightness_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVarInput")
    def lightness_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherInput")
    def saturation_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVarInput")
    def saturation_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceInput")
    def saturation_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVarInput")
    def saturation_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__caaa1248fadfacb9d6677ac89a840d2ba281df93c81671a828d1899b120d5c34)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeather")
    def hue_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeather"))

    @hue_feather.setter
    def hue_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3b2c32c39218e094c9372766ce080a94ea1afe5a9203912f07a58affbd135fdc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeather", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVar")
    def hue_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeatherVar"))

    @hue_feather_var.setter
    def hue_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__10ec8674c10e7aff6e39863fc4a6b0c5710aeb502839ce91981422ca4844e8da)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueTolerance")
    def hue_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueTolerance"))

    @hue_tolerance.setter
    def hue_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7189739bbd09d58b59406f323884fc316f7a6691f4b061040360e815abc024fe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVar")
    def hue_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueToleranceVar"))

    @hue_tolerance_var.setter
    def hue_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__36a1d686b0d907bb53f42a53caac419515bf2e4b1ea3b5ed272053a4b22a96ed)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__50ec50b760e8a5649012b20b8c17aa0660deffa3c6c6a557e36d62ab0df12212)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeather")
    def lightness_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeather"))

    @lightness_feather.setter
    def lightness_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__92914d538db9238fc86d26afd5c14478a8b1f02dbe8d4787adee3a475b86cf7a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeather", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVar")
    def lightness_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeatherVar"))

    @lightness_feather_var.setter
    def lightness_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6cd63d8164828f870d5ee166ad0b72392fd97d9bb25057f7263098e21b236bfb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessTolerance")
    def lightness_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessTolerance"))

    @lightness_tolerance.setter
    def lightness_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a8c9d0758e96f35856ffd3b6b4ab10f0361ba6c3f07dec6adfb6c90d965003e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVar")
    def lightness_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessToleranceVar"))

    @lightness_tolerance_var.setter
    def lightness_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__881c9424a92623fa51c621ae5ad4516c946978b47f0cc36c52055dc2e509fccf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeather")
    def saturation_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeather"))

    @saturation_feather.setter
    def saturation_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c630654f3cc1164fc49e26552292b30108ed642b1a12637e001aa7f69cb88880)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeather", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVar")
    def saturation_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeatherVar"))

    @saturation_feather_var.setter
    def saturation_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__61fd1604cc04c0df63e0c07ed390811bca9bc3b768e850c8f175cf5521925102)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationTolerance")
    def saturation_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationTolerance"))

    @saturation_tolerance.setter
    def saturation_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3f3f36a8673a97d8817dcdf58ddc0261a43ab2a959b2f6f89f55640c6a0fa337)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVar")
    def saturation_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationToleranceVar"))

    @saturation_tolerance_var.setter
    def saturation_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a1c8525027709933ee81e3fd57536a6f1affeef92df30af30b13544e4aa0e3e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultChromaKey]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultChromaKey]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultChromaKey]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f22c3f45a369bdefc1a32850014c54bd7b5f2098ffdb702361412a0414006dbb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultComposite",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "placement": "placement",
        "placement_var": "placementVar",
        "scale": "scale",
        "scale_dimension": "scaleDimension",
        "scale_dimension_var": "scaleDimensionVar",
        "scale_var": "scaleVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultComposite:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        placement: typing.Optional[builtins.str] = None,
        placement_var: typing.Optional[builtins.str] = None,
        scale: typing.Optional[builtins.str] = None,
        scale_dimension: typing.Optional[builtins.str] = None,
        scale_dimension_var: typing.Optional[builtins.str] = None,
        scale_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param placement: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        :param placement_var: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        :param scale: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param scale_dimension: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        :param scale_dimension_var: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        :param scale_var: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        :param x_position: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__22daa4f161b1997d58053941036af05c1ca465476b3e18a0ed617f29a72307c3)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument placement", value=placement, expected_type=type_hints["placement"])
            check_type(argname="argument placement_var", value=placement_var, expected_type=type_hints["placement_var"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument scale_dimension", value=scale_dimension, expected_type=type_hints["scale_dimension"])
            check_type(argname="argument scale_dimension_var", value=scale_dimension_var, expected_type=type_hints["scale_dimension_var"])
            check_type(argname="argument scale_var", value=scale_var, expected_type=type_hints["scale_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if placement is not None:
            self._values["placement"] = placement
        if placement_var is not None:
            self._values["placement_var"] = placement_var
        if scale is not None:
            self._values["scale"] = scale
        if scale_dimension is not None:
            self._values["scale_dimension"] = scale_dimension
        if scale_dimension_var is not None:
            self._values["scale_dimension_var"] = scale_dimension_var
        if scale_var is not None:
            self._values["scale_var"] = scale_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        '''
        result = self._values.get("placement")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement_var(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        '''
        result = self._values.get("placement_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        '''
        result = self._values.get("scale_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        '''
        result = self._values.get("scale_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        '''
        result = self._values.get("scale_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultComposite(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImage",
    jsii_struct_bases=[],
    name_mapping={
        "box_image": "boxImage",
        "circle_image": "circleImage",
        "text_image": "textImage",
        "url_image": "urlImage",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImage:
    def __init__(
        self,
        *,
        box_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageBoxImage", typing.Dict[builtins.str, typing.Any]]]]] = None,
        circle_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageCircleImage", typing.Dict[builtins.str, typing.Any]]]]] = None,
        text_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageTextImage", typing.Dict[builtins.str, typing.Any]]]]] = None,
        url_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageUrlImage", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param box_image: box_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#box_image DataAkamaiImagingPolicyImage#box_image}
        :param circle_image: circle_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#circle_image DataAkamaiImagingPolicyImage#circle_image}
        :param text_image: text_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text_image DataAkamaiImagingPolicyImage#text_image}
        :param url_image: url_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url_image DataAkamaiImagingPolicyImage#url_image}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ada14cddd9ef347ca322b2c9d920f18aa3a298b2b2608246aef25a46dfcf889f)
            check_type(argname="argument box_image", value=box_image, expected_type=type_hints["box_image"])
            check_type(argname="argument circle_image", value=circle_image, expected_type=type_hints["circle_image"])
            check_type(argname="argument text_image", value=text_image, expected_type=type_hints["text_image"])
            check_type(argname="argument url_image", value=url_image, expected_type=type_hints["url_image"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if box_image is not None:
            self._values["box_image"] = box_image
        if circle_image is not None:
            self._values["circle_image"] = circle_image
        if text_image is not None:
            self._values["text_image"] = text_image
        if url_image is not None:
            self._values["url_image"] = url_image

    @builtins.property
    def box_image(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageBoxImage"]]]:
        '''box_image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#box_image DataAkamaiImagingPolicyImage#box_image}
        '''
        result = self._values.get("box_image")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageBoxImage"]]], result)

    @builtins.property
    def circle_image(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageCircleImage"]]]:
        '''circle_image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#circle_image DataAkamaiImagingPolicyImage#circle_image}
        '''
        result = self._values.get("circle_image")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageCircleImage"]]], result)

    @builtins.property
    def text_image(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageTextImage"]]]:
        '''text_image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text_image DataAkamaiImagingPolicyImage#text_image}
        '''
        result = self._values.get("text_image")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageTextImage"]]], result)

    @builtins.property
    def url_image(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageUrlImage"]]]:
        '''url_image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url_image DataAkamaiImagingPolicyImage#url_image}
        '''
        result = self._values.get("url_image")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageUrlImage"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageBoxImage",
    jsii_struct_bases=[],
    name_mapping={
        "color": "color",
        "color_var": "colorVar",
        "height": "height",
        "height_var": "heightVar",
        "transformation": "transformation",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageBoxImage:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        transformation: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageBoxImageTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The fill color of the box, not the edge of the box. The API supports hexadecimal representation and CSS hexadecimal color values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The fill color of the box, not the edge of the box. The API supports hexadecimal representation and CSS hexadecimal color values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        :param height: The height of the box in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height of the box in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param transformation: transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        :param width: The width of the box in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width of the box in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(transformation, dict):
            transformation = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageBoxImageTransformation(**transformation)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dbd5c52efccb8dd5db24564d521390396e3687e340d00a307e5aaf31f0d959f6)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument transformation", value=transformation, expected_type=type_hints["transformation"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if transformation is not None:
            self._values["transformation"] = transformation
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The fill color of the box, not the edge of the box.

        The API supports hexadecimal representation and CSS hexadecimal color values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The fill color of the box, not the edge of the box.

        The API supports hexadecimal representation and CSS hexadecimal color values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height of the box in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height of the box in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def transformation(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageBoxImageTransformation"]:
        '''transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        '''
        result = self._values.get("transformation")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageBoxImageTransformation"], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width of the box in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width of the box in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageBoxImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageBoxImageList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageBoxImageList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c1ce6e02094864043467d91c26f30609a2e3be241f237d9f173772c581079c99)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageBoxImageOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4af34b7c42d75c4b72bcbbc97e6785f1ab6b7caea76cd68fa9ddcf52a8298c8b)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageBoxImageOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__28c8a5a136577f7a85a3de52bbd11c2db34394e449f2abbff2e15f880abed269)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af9aaac1af9b6feb830097fa0b57a22585cd974863792e15c8acab9c0a95b4bc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4d2b05b3caffc291e019b7b551758123abf18dc37e8876c4edecfbb5b9abd319)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageBoxImage]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageBoxImage]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageBoxImage]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f284a3cac10df82357a8c1a813eef145632ea13c4b8058a07a275b993a893528)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageBoxImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageBoxImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9f4b40890d19edc5238fb93ec14faf21f64636b1f97d356c205b85b58faaab44)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformation")
    def put_transformation(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageBoxImageTransformation()

        return typing.cast(None, jsii.invoke(self, "putTransformation", [value]))

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetTransformation")
    def reset_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformation", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="transformation")
    def transformation(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageBoxImageTransformationOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageBoxImageTransformationOutputReference", jsii.get(self, "transformation"))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="transformationInput")
    def transformation_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageBoxImageTransformation"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageBoxImageTransformation"], jsii.get(self, "transformationInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e1c6b75e4644fd23193d6d9f004de3d87f46c31d3c636d4586aeb7b082a1ce51)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5c01c784edcc46818a164cd5f4b7fcc45ef1a53980e12ca246a37792bd9f677a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a16c65274a2eb7ee2cf5967b9cce0b1370996ed98c864485a385470edda0bdd0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dae410f3db77f9ed366019c884808e6b80b1028d3a433afbda8023749c3c0c1f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__80750b7e56716410597836efcaa426cf7775822650e1be6bff7f482f1b65c9fe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a2c449ca3479f842055a72b460615ea4ced4dc980ca668d218b6654ea0d0fdf7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageBoxImage]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageBoxImage]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageBoxImage]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c60bbd79af289871e4099104eab874b8b84b8050604582911eae9921407e449e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageBoxImageTransformation",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageBoxImageTransformation:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageBoxImageTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageBoxImageTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageBoxImageTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8c6a69c4effe86d16d5573cbce498b0b35eb703aff73071ed44c6a2beddb68df)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageBoxImageTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageBoxImageTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageBoxImageTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__39b60ae24b56a0c231d4be7f32f55d052a3fc7f2589f9e8bd2c8466b71acdb76)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageCircleImage",
    jsii_struct_bases=[],
    name_mapping={
        "color": "color",
        "color_var": "colorVar",
        "diameter": "diameter",
        "diameter_var": "diameterVar",
        "transformation": "transformation",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageCircleImage:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
        diameter: typing.Optional[builtins.str] = None,
        diameter_var: typing.Optional[builtins.str] = None,
        transformation: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageCircleImageTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The fill color of the circle. The API supports hexadecimal representation and CSS hexadecimal color values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The fill color of the circle. The API supports hexadecimal representation and CSS hexadecimal color values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        :param diameter: The diameter of the circle. The diameter will be the width and the height of the image in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#diameter DataAkamaiImagingPolicyImage#diameter}
        :param diameter_var: The diameter of the circle. The diameter will be the width and the height of the image in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#diameter_var DataAkamaiImagingPolicyImage#diameter_var}
        :param transformation: transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        :param width: The width of the box in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width of the box in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(transformation, dict):
            transformation = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageCircleImageTransformation(**transformation)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a0c90491fdb25b1bee5465e38ff371ef75c4d36ec06253b1f188fbb017e0fe8)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
            check_type(argname="argument diameter", value=diameter, expected_type=type_hints["diameter"])
            check_type(argname="argument diameter_var", value=diameter_var, expected_type=type_hints["diameter_var"])
            check_type(argname="argument transformation", value=transformation, expected_type=type_hints["transformation"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var
        if diameter is not None:
            self._values["diameter"] = diameter
        if diameter_var is not None:
            self._values["diameter_var"] = diameter_var
        if transformation is not None:
            self._values["transformation"] = transformation
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The fill color of the circle. The API supports hexadecimal representation and CSS hexadecimal color values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The fill color of the circle. The API supports hexadecimal representation and CSS hexadecimal color values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def diameter(self) -> typing.Optional[builtins.str]:
        '''The diameter of the circle. The diameter will be the width and the height of the image in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#diameter DataAkamaiImagingPolicyImage#diameter}
        '''
        result = self._values.get("diameter")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def diameter_var(self) -> typing.Optional[builtins.str]:
        '''The diameter of the circle. The diameter will be the width and the height of the image in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#diameter_var DataAkamaiImagingPolicyImage#diameter_var}
        '''
        result = self._values.get("diameter_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def transformation(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageCircleImageTransformation"]:
        '''transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        '''
        result = self._values.get("transformation")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageCircleImageTransformation"], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width of the box in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width of the box in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageCircleImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageCircleImageList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageCircleImageList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__20368ec3e976fd3e87e90475e89503c886373135fdbea10cd98e15c13260e9c8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageCircleImageOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__054c7d40c49e88a0ccaaedd7ba6b06dc3cee57a671f0f005a9df6c0110ec2e7b)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageCircleImageOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__add5b2630dd83b317aca64b21da434750b8c5e525917f3b3f8c39489173b6c8b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__062080c1d8f0f70f02d64a419014b14cb2a54db0a2cf4f09307fcaa2dc75885e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f20e95f03b760f53527fe66367e713313c1161ec37a1f409f3694d83d0d9854)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageCircleImage]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageCircleImage]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageCircleImage]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__27d1f205595a4e5f46265f59bb2a9623f02352e34bbf45ebbbdd86b2bf481321)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageCircleImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageCircleImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__96895d3a60fc451d8074fbccc006e47088b94338ef19416f5e70e500f649ae76)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformation")
    def put_transformation(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageCircleImageTransformation()

        return typing.cast(None, jsii.invoke(self, "putTransformation", [value]))

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @jsii.member(jsii_name="resetDiameter")
    def reset_diameter(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDiameter", []))

    @jsii.member(jsii_name="resetDiameterVar")
    def reset_diameter_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDiameterVar", []))

    @jsii.member(jsii_name="resetTransformation")
    def reset_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformation", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="transformation")
    def transformation(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageCircleImageTransformationOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageCircleImageTransformationOutputReference", jsii.get(self, "transformation"))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="diameterInput")
    def diameter_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "diameterInput"))

    @builtins.property
    @jsii.member(jsii_name="diameterVarInput")
    def diameter_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "diameterVarInput"))

    @builtins.property
    @jsii.member(jsii_name="transformationInput")
    def transformation_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageCircleImageTransformation"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageCircleImageTransformation"], jsii.get(self, "transformationInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2930d4831afabd5cb204a5f3432a76b1e0026390e7a5f86b87820ba4f16e9c33)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fb46a46c8cfc4b0c62eda0ff86bf6fc7c22ea9c00ae4f03f26a31fd4df4f1b08)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="diameter")
    def diameter(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "diameter"))

    @diameter.setter
    def diameter(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0f6d42c53f8c8635de654f005fb2537d63b53fdbc627578d1477b4e2bce35727)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "diameter", value)

    @builtins.property
    @jsii.member(jsii_name="diameterVar")
    def diameter_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "diameterVar"))

    @diameter_var.setter
    def diameter_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__65489d6224389080fe7ca127d9818bc239cf1886d78d165aff0882fc5a72a6ce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "diameterVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a1052afabed53620f6ebff66dac552ab42dad4b68ba4e411a83a6c927ce4bd6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a2b77ff25190f4ddc7bb233d7eb252c1b366c0e916c596316f7cc250c113dd04)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageCircleImage]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageCircleImage]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageCircleImage]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7441f23fc5f3b72aaab6e0aa06820b28d558281b6442173369500a54994f436a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageCircleImageTransformation",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageCircleImageTransformation:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageCircleImageTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageCircleImageTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageCircleImageTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb91058191f4eebdb6ef83d1af0c8475ee11ceab846ba85641badddacd9f4cf9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageCircleImageTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageCircleImageTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageCircleImageTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dab20ccc202e4fb949296e672b3616233d469bbb0348f21a4244807882159952)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2c4f8578dff3d9ac0b773f01d8b0a609da3f9439423f16cc37f9688854c6e340)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putBoxImage")
    def put_box_image(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageBoxImage, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a8351dd379c6bfda987b69f21648bad1161e528955574a9315f946870768316c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBoxImage", [value]))

    @jsii.member(jsii_name="putCircleImage")
    def put_circle_image(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageCircleImage, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__068f4ff6bed4455e112860cf01b175f8ba37109a38ad368a5d94247debc0b842)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCircleImage", [value]))

    @jsii.member(jsii_name="putTextImage")
    def put_text_image(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageTextImage", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f62159a2362ba2894fb76c7854144a29205d55ccd0b94c25c1565209cbca594a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTextImage", [value]))

    @jsii.member(jsii_name="putUrlImage")
    def put_url_image(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageUrlImage", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6ed2c356a4d5a87032e222c9d1cb256521fcc9d0e8d48efad0a477ee787c44f5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putUrlImage", [value]))

    @jsii.member(jsii_name="resetBoxImage")
    def reset_box_image(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBoxImage", []))

    @jsii.member(jsii_name="resetCircleImage")
    def reset_circle_image(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCircleImage", []))

    @jsii.member(jsii_name="resetTextImage")
    def reset_text_image(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTextImage", []))

    @jsii.member(jsii_name="resetUrlImage")
    def reset_url_image(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUrlImage", []))

    @builtins.property
    @jsii.member(jsii_name="boxImage")
    def box_image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageBoxImageList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageBoxImageList, jsii.get(self, "boxImage"))

    @builtins.property
    @jsii.member(jsii_name="circleImage")
    def circle_image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageCircleImageList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageCircleImageList, jsii.get(self, "circleImage"))

    @builtins.property
    @jsii.member(jsii_name="textImage")
    def text_image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageTextImageList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageTextImageList", jsii.get(self, "textImage"))

    @builtins.property
    @jsii.member(jsii_name="urlImage")
    def url_image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageUrlImageList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageUrlImageList", jsii.get(self, "urlImage"))

    @builtins.property
    @jsii.member(jsii_name="boxImageInput")
    def box_image_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageBoxImage]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageBoxImage]]], jsii.get(self, "boxImageInput"))

    @builtins.property
    @jsii.member(jsii_name="circleImageInput")
    def circle_image_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageCircleImage]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageCircleImage]]], jsii.get(self, "circleImageInput"))

    @builtins.property
    @jsii.member(jsii_name="textImageInput")
    def text_image_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageTextImage"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageTextImage"]]], jsii.get(self, "textImageInput"))

    @builtins.property
    @jsii.member(jsii_name="urlImageInput")
    def url_image_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageUrlImage"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageUrlImage"]]], jsii.get(self, "urlImageInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__63814743f0565c27355820c5e7ca77dce25afa12726d228aedf051637bee2511)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageTextImage",
    jsii_struct_bases=[],
    name_mapping={
        "fill": "fill",
        "fill_var": "fillVar",
        "size": "size",
        "size_var": "sizeVar",
        "stroke": "stroke",
        "stroke_size": "strokeSize",
        "stroke_size_var": "strokeSizeVar",
        "stroke_var": "strokeVar",
        "text": "text",
        "text_var": "textVar",
        "transformation": "transformation",
        "typeface": "typeface",
        "typeface_var": "typefaceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageTextImage:
    def __init__(
        self,
        *,
        fill: typing.Optional[builtins.str] = None,
        fill_var: typing.Optional[builtins.str] = None,
        size: typing.Optional[builtins.str] = None,
        size_var: typing.Optional[builtins.str] = None,
        stroke: typing.Optional[builtins.str] = None,
        stroke_size: typing.Optional[builtins.str] = None,
        stroke_size_var: typing.Optional[builtins.str] = None,
        stroke_var: typing.Optional[builtins.str] = None,
        text: typing.Optional[builtins.str] = None,
        text_var: typing.Optional[builtins.str] = None,
        transformation: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageTextImageTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        typeface: typing.Optional[builtins.str] = None,
        typeface_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fill: The main fill color of the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill DataAkamaiImagingPolicyImage#fill}
        :param fill_var: The main fill color of the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_var DataAkamaiImagingPolicyImage#fill_var}
        :param size: The size in pixels to render the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#size DataAkamaiImagingPolicyImage#size}
        :param size_var: The size in pixels to render the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#size_var DataAkamaiImagingPolicyImage#size_var}
        :param stroke: The color for the outline of the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke DataAkamaiImagingPolicyImage#stroke}
        :param stroke_size: The thickness in points for the outline of the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_size DataAkamaiImagingPolicyImage#stroke_size}
        :param stroke_size_var: The thickness in points for the outline of the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_size_var DataAkamaiImagingPolicyImage#stroke_size_var}
        :param stroke_var: The color for the outline of the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_var DataAkamaiImagingPolicyImage#stroke_var}
        :param text: The line of text to render. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text DataAkamaiImagingPolicyImage#text}
        :param text_var: The line of text to render. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text_var DataAkamaiImagingPolicyImage#text_var}
        :param transformation: transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        :param typeface: The font family to apply to the text image. This may be a URL to a TrueType or WOFF (v1) typeface, or a string that refers to one of the standard built-in browser fonts. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#typeface DataAkamaiImagingPolicyImage#typeface}
        :param typeface_var: The font family to apply to the text image. This may be a URL to a TrueType or WOFF (v1) typeface, or a string that refers to one of the standard built-in browser fonts. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#typeface_var DataAkamaiImagingPolicyImage#typeface_var}
        '''
        if isinstance(transformation, dict):
            transformation = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageTextImageTransformation(**transformation)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0c735a5abbe880cd582e7a9a77dc327710beeee7dce1f354aa62c9f53f6f0e04)
            check_type(argname="argument fill", value=fill, expected_type=type_hints["fill"])
            check_type(argname="argument fill_var", value=fill_var, expected_type=type_hints["fill_var"])
            check_type(argname="argument size", value=size, expected_type=type_hints["size"])
            check_type(argname="argument size_var", value=size_var, expected_type=type_hints["size_var"])
            check_type(argname="argument stroke", value=stroke, expected_type=type_hints["stroke"])
            check_type(argname="argument stroke_size", value=stroke_size, expected_type=type_hints["stroke_size"])
            check_type(argname="argument stroke_size_var", value=stroke_size_var, expected_type=type_hints["stroke_size_var"])
            check_type(argname="argument stroke_var", value=stroke_var, expected_type=type_hints["stroke_var"])
            check_type(argname="argument text", value=text, expected_type=type_hints["text"])
            check_type(argname="argument text_var", value=text_var, expected_type=type_hints["text_var"])
            check_type(argname="argument transformation", value=transformation, expected_type=type_hints["transformation"])
            check_type(argname="argument typeface", value=typeface, expected_type=type_hints["typeface"])
            check_type(argname="argument typeface_var", value=typeface_var, expected_type=type_hints["typeface_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fill is not None:
            self._values["fill"] = fill
        if fill_var is not None:
            self._values["fill_var"] = fill_var
        if size is not None:
            self._values["size"] = size
        if size_var is not None:
            self._values["size_var"] = size_var
        if stroke is not None:
            self._values["stroke"] = stroke
        if stroke_size is not None:
            self._values["stroke_size"] = stroke_size
        if stroke_size_var is not None:
            self._values["stroke_size_var"] = stroke_size_var
        if stroke_var is not None:
            self._values["stroke_var"] = stroke_var
        if text is not None:
            self._values["text"] = text
        if text_var is not None:
            self._values["text_var"] = text_var
        if transformation is not None:
            self._values["transformation"] = transformation
        if typeface is not None:
            self._values["typeface"] = typeface
        if typeface_var is not None:
            self._values["typeface_var"] = typeface_var

    @builtins.property
    def fill(self) -> typing.Optional[builtins.str]:
        '''The main fill color of the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill DataAkamaiImagingPolicyImage#fill}
        '''
        result = self._values.get("fill")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fill_var(self) -> typing.Optional[builtins.str]:
        '''The main fill color of the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_var DataAkamaiImagingPolicyImage#fill_var}
        '''
        result = self._values.get("fill_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def size(self) -> typing.Optional[builtins.str]:
        '''The size in pixels to render the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#size DataAkamaiImagingPolicyImage#size}
        '''
        result = self._values.get("size")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def size_var(self) -> typing.Optional[builtins.str]:
        '''The size in pixels to render the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#size_var DataAkamaiImagingPolicyImage#size_var}
        '''
        result = self._values.get("size_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def stroke(self) -> typing.Optional[builtins.str]:
        '''The color for the outline of the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke DataAkamaiImagingPolicyImage#stroke}
        '''
        result = self._values.get("stroke")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def stroke_size(self) -> typing.Optional[builtins.str]:
        '''The thickness in points for the outline of the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_size DataAkamaiImagingPolicyImage#stroke_size}
        '''
        result = self._values.get("stroke_size")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def stroke_size_var(self) -> typing.Optional[builtins.str]:
        '''The thickness in points for the outline of the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_size_var DataAkamaiImagingPolicyImage#stroke_size_var}
        '''
        result = self._values.get("stroke_size_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def stroke_var(self) -> typing.Optional[builtins.str]:
        '''The color for the outline of the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_var DataAkamaiImagingPolicyImage#stroke_var}
        '''
        result = self._values.get("stroke_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def text(self) -> typing.Optional[builtins.str]:
        '''The line of text to render.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text DataAkamaiImagingPolicyImage#text}
        '''
        result = self._values.get("text")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def text_var(self) -> typing.Optional[builtins.str]:
        '''The line of text to render.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text_var DataAkamaiImagingPolicyImage#text_var}
        '''
        result = self._values.get("text_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def transformation(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageTextImageTransformation"]:
        '''transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        '''
        result = self._values.get("transformation")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageTextImageTransformation"], result)

    @builtins.property
    def typeface(self) -> typing.Optional[builtins.str]:
        '''The font family to apply to the text image.

        This may be a URL to a TrueType or WOFF (v1) typeface, or a string that refers to one of the standard built-in browser fonts.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#typeface DataAkamaiImagingPolicyImage#typeface}
        '''
        result = self._values.get("typeface")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def typeface_var(self) -> typing.Optional[builtins.str]:
        '''The font family to apply to the text image.

        This may be a URL to a TrueType or WOFF (v1) typeface, or a string that refers to one of the standard built-in browser fonts.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#typeface_var DataAkamaiImagingPolicyImage#typeface_var}
        '''
        result = self._values.get("typeface_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageTextImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageTextImageList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageTextImageList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4d6b35789753b4ab2d324b3c0ead2fe7222dc8101e16724b3a258cc6a04a48df)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageTextImageOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__04c646411dc28747fed1b98aee48e701c58cbe1526f69d0f8b06196f80b54f40)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageTextImageOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__144d54f575bdf3d750b8989e0f1e2c0c94a559c9ddd6c68c94ccf135b60ce939)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__90d60cddca9cdf91d941a463fa0033ec5df14979ace780b2bb2d305301af292b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__61293f9ac0fee2e7f4024eafc99516a488b59f15d99850ae3e5962d95acee165)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageTextImage]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageTextImage]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageTextImage]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9915209bd865ddf971fe280df816243deb21a40c2f538026f2f1e75f2479644e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageTextImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageTextImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4be52081d993d45022f33c97cf23be00b40070b6d290eebd6d815f46d5b11065)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformation")
    def put_transformation(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageTextImageTransformation()

        return typing.cast(None, jsii.invoke(self, "putTransformation", [value]))

    @jsii.member(jsii_name="resetFill")
    def reset_fill(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFill", []))

    @jsii.member(jsii_name="resetFillVar")
    def reset_fill_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFillVar", []))

    @jsii.member(jsii_name="resetSize")
    def reset_size(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSize", []))

    @jsii.member(jsii_name="resetSizeVar")
    def reset_size_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSizeVar", []))

    @jsii.member(jsii_name="resetStroke")
    def reset_stroke(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStroke", []))

    @jsii.member(jsii_name="resetStrokeSize")
    def reset_stroke_size(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStrokeSize", []))

    @jsii.member(jsii_name="resetStrokeSizeVar")
    def reset_stroke_size_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStrokeSizeVar", []))

    @jsii.member(jsii_name="resetStrokeVar")
    def reset_stroke_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStrokeVar", []))

    @jsii.member(jsii_name="resetText")
    def reset_text(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetText", []))

    @jsii.member(jsii_name="resetTextVar")
    def reset_text_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTextVar", []))

    @jsii.member(jsii_name="resetTransformation")
    def reset_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformation", []))

    @jsii.member(jsii_name="resetTypeface")
    def reset_typeface(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeface", []))

    @jsii.member(jsii_name="resetTypefaceVar")
    def reset_typeface_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypefaceVar", []))

    @builtins.property
    @jsii.member(jsii_name="transformation")
    def transformation(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageTextImageTransformationOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageTextImageTransformationOutputReference", jsii.get(self, "transformation"))

    @builtins.property
    @jsii.member(jsii_name="fillInput")
    def fill_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fillInput"))

    @builtins.property
    @jsii.member(jsii_name="fillVarInput")
    def fill_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fillVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sizeInput")
    def size_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sizeInput"))

    @builtins.property
    @jsii.member(jsii_name="sizeVarInput")
    def size_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sizeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="strokeInput")
    def stroke_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "strokeInput"))

    @builtins.property
    @jsii.member(jsii_name="strokeSizeInput")
    def stroke_size_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "strokeSizeInput"))

    @builtins.property
    @jsii.member(jsii_name="strokeSizeVarInput")
    def stroke_size_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "strokeSizeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="strokeVarInput")
    def stroke_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "strokeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="textInput")
    def text_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "textInput"))

    @builtins.property
    @jsii.member(jsii_name="textVarInput")
    def text_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "textVarInput"))

    @builtins.property
    @jsii.member(jsii_name="transformationInput")
    def transformation_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageTextImageTransformation"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageTextImageTransformation"], jsii.get(self, "transformationInput"))

    @builtins.property
    @jsii.member(jsii_name="typefaceInput")
    def typeface_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typefaceInput"))

    @builtins.property
    @jsii.member(jsii_name="typefaceVarInput")
    def typeface_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typefaceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="fill")
    def fill(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fill"))

    @fill.setter
    def fill(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__46d858df28fd2615fd771fdc4bdc53f8bb61d6f5f8095d128b5450e45e99c0ef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fill", value)

    @builtins.property
    @jsii.member(jsii_name="fillVar")
    def fill_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fillVar"))

    @fill_var.setter
    def fill_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cb94893e4504436d31ee2082a703e21e9bfe392fcbc19956d2e0ab0b1e8b8af7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fillVar", value)

    @builtins.property
    @jsii.member(jsii_name="size")
    def size(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "size"))

    @size.setter
    def size(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eeefc9324d11116575c6e30bdd5db824dcd3d5babedd7645f5cc4c3da256cff2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "size", value)

    @builtins.property
    @jsii.member(jsii_name="sizeVar")
    def size_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sizeVar"))

    @size_var.setter
    def size_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__57ab86f1284dcf684886ef6e3ded5045e37c66469bdfdd99a466cee3b7cbfaea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sizeVar", value)

    @builtins.property
    @jsii.member(jsii_name="stroke")
    def stroke(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "stroke"))

    @stroke.setter
    def stroke(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a0a189d49532b80e681379fb666ba5c602fa6ccb7e8b6852fda2072e900ea85)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "stroke", value)

    @builtins.property
    @jsii.member(jsii_name="strokeSize")
    def stroke_size(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "strokeSize"))

    @stroke_size.setter
    def stroke_size(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__537821f9a4f092f086d80c0479a609a7a1fcd20f1f83244b2c17679c14a001c3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "strokeSize", value)

    @builtins.property
    @jsii.member(jsii_name="strokeSizeVar")
    def stroke_size_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "strokeSizeVar"))

    @stroke_size_var.setter
    def stroke_size_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f17e727acf8c3cfb76920fdc015385655baf00f72ce1b4a3b996af43519d0190)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "strokeSizeVar", value)

    @builtins.property
    @jsii.member(jsii_name="strokeVar")
    def stroke_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "strokeVar"))

    @stroke_var.setter
    def stroke_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0302d1a6e456fd7778cfb083b2b915931e50e3666eabe92a74a0d70146105266)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "strokeVar", value)

    @builtins.property
    @jsii.member(jsii_name="text")
    def text(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "text"))

    @text.setter
    def text(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4471088775534125e5f14daf557c374328d03e5529be7ec6d133febd832e596a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "text", value)

    @builtins.property
    @jsii.member(jsii_name="textVar")
    def text_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "textVar"))

    @text_var.setter
    def text_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__817fcdade0572c946d1786601c4c3f1b4c96f76b07c4b4ee629ecce636053509)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "textVar", value)

    @builtins.property
    @jsii.member(jsii_name="typeface")
    def typeface(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeface"))

    @typeface.setter
    def typeface(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f786005a31d1839e10a624d605b64e9d9d4e9321a7caab359ca9c6065096ed05)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeface", value)

    @builtins.property
    @jsii.member(jsii_name="typefaceVar")
    def typeface_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typefaceVar"))

    @typeface_var.setter
    def typeface_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ff070350b2aa615c0d1c13de71dd123e612f257fe32dfa85fa3dccc2f56829a0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typefaceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageTextImage]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageTextImage]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageTextImage]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fc014142cc72db9cb43b059087e4aecb85a888aca786332b3b97da6286d95a0e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageTextImageTransformation",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageTextImageTransformation:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageTextImageTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageTextImageTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageTextImageTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b3bd8ce8e402dcccd87838b60112c25bba782273ba89203aa0ceddc178fb2a27)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageTextImageTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageTextImageTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageTextImageTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__39c66fad9796b2b7957c8c8746cdb3e28688abb061b0b54241de7ef66407872e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageUrlImage",
    jsii_struct_bases=[],
    name_mapping={
        "transformation": "transformation",
        "url": "url",
        "url_var": "urlVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageUrlImage:
    def __init__(
        self,
        *,
        transformation: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageUrlImageTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        url: typing.Optional[builtins.str] = None,
        url_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param transformation: transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        :param url: The URL of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url DataAkamaiImagingPolicyImage#url}
        :param url_var: The URL of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url_var DataAkamaiImagingPolicyImage#url_var}
        '''
        if isinstance(transformation, dict):
            transformation = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageUrlImageTransformation(**transformation)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c7a12e961a61959fd061507343a597411c9ab4dae4a9df6d6bf7bd9b6bd8ae6a)
            check_type(argname="argument transformation", value=transformation, expected_type=type_hints["transformation"])
            check_type(argname="argument url", value=url, expected_type=type_hints["url"])
            check_type(argname="argument url_var", value=url_var, expected_type=type_hints["url_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if transformation is not None:
            self._values["transformation"] = transformation
        if url is not None:
            self._values["url"] = url
        if url_var is not None:
            self._values["url_var"] = url_var

    @builtins.property
    def transformation(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageUrlImageTransformation"]:
        '''transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        '''
        result = self._values.get("transformation")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageUrlImageTransformation"], result)

    @builtins.property
    def url(self) -> typing.Optional[builtins.str]:
        '''The URL of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url DataAkamaiImagingPolicyImage#url}
        '''
        result = self._values.get("url")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def url_var(self) -> typing.Optional[builtins.str]:
        '''The URL of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url_var DataAkamaiImagingPolicyImage#url_var}
        '''
        result = self._values.get("url_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageUrlImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageUrlImageList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageUrlImageList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3d179d960ad66e7739bb84bdc91053a1c079e764791eab64e8fd3f187f721e50)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageUrlImageOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b7ced8f2d0a07509d32b08d193544682e221998492161aaa3bd07c4c0fe497d3)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageUrlImageOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c66408bd26b06e29e834b706e14456768dc781c988fb183d5caf30b9f26f4948)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b2e1cf29c338b82575b8af7c10c6a1c25e2930e35de8807a68e0ecf0af3ddd4f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d112b14f63ac3a5c44c1bb167461efba06c0777c4c7b9e96a7e63b2611b91cb0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageUrlImage]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageUrlImage]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageUrlImage]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c1d7702d1c2776f6660e701dca1df97b914eb704c9f18ca22b10e732f934aafc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageUrlImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageUrlImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be33cdc62a00e572f4e754f1093665a8d7353a83675fb81fb3ab45e895595e62)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformation")
    def put_transformation(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageUrlImageTransformation()

        return typing.cast(None, jsii.invoke(self, "putTransformation", [value]))

    @jsii.member(jsii_name="resetTransformation")
    def reset_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformation", []))

    @jsii.member(jsii_name="resetUrl")
    def reset_url(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUrl", []))

    @jsii.member(jsii_name="resetUrlVar")
    def reset_url_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUrlVar", []))

    @builtins.property
    @jsii.member(jsii_name="transformation")
    def transformation(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageUrlImageTransformationOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageUrlImageTransformationOutputReference", jsii.get(self, "transformation"))

    @builtins.property
    @jsii.member(jsii_name="transformationInput")
    def transformation_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageUrlImageTransformation"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageUrlImageTransformation"], jsii.get(self, "transformationInput"))

    @builtins.property
    @jsii.member(jsii_name="urlInput")
    def url_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "urlInput"))

    @builtins.property
    @jsii.member(jsii_name="urlVarInput")
    def url_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "urlVarInput"))

    @builtins.property
    @jsii.member(jsii_name="url")
    def url(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "url"))

    @url.setter
    def url(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e6fc1dc9424b9389f17cea96d7d06f554346450396b7657599b3cfa65db11446)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "url", value)

    @builtins.property
    @jsii.member(jsii_name="urlVar")
    def url_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "urlVar"))

    @url_var.setter
    def url_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__da138c2eb7c8b412fe97350629e50325a5c89dd52add65eae2ffb434d4eacddd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "urlVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageUrlImage]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageUrlImage]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageUrlImage]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__163b65733b3ff88fd72d9994af375d278675a0351471146aeeefd174ad4c814a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageUrlImageTransformation",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageUrlImageTransformation:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageUrlImageTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageUrlImageTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageUrlImageTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__555b03f12cb932831a72d36dc2779cf75d39efca569cd71e7f0489f82e26b06b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageUrlImageTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageUrlImageTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageUrlImageTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3b202d4e92a6fdf72346c9d6ba799e467573e5702e4f6d50bcd0ecd3b1390b96)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ec169258f75dcee4a88b36e024800afb633b5d184a271edaaf95921bb9247c4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d8414f23da0b546ad808e65ef1723d532883d38dd1d490bbd3ea2bfd1276e015)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dcb5305cb0ffda2bd3dddf8a38a16a2f46dad33ef0c0255d8edc44e81e5f979f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e483fccb677053c9e2ef81fd447402b90f4a18d3ad1340eded22b444477c1e0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df6136a886e5f8952d9036d03b0777902bcffb0d259b3fa5019f8ff18673ce96)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultComposite]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultComposite]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d256871da703b83a97d5c4615a06df1d46547d805996ec6babf6e7e0addc30a8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9031b1bcd8b4444e321219771b171d5b31922c924f1b41c72bc6de00b0444b38)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(
        self,
        *,
        box_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageBoxImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
        circle_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageCircleImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
        text_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageTextImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
        url_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageUrlImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param box_image: box_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#box_image DataAkamaiImagingPolicyImage#box_image}
        :param circle_image: circle_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#circle_image DataAkamaiImagingPolicyImage#circle_image}
        :param text_image: text_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text_image DataAkamaiImagingPolicyImage#text_image}
        :param url_image: url_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url_image DataAkamaiImagingPolicyImage#url_image}
        '''
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImage(
            box_image=box_image,
            circle_image=circle_image,
            text_image=text_image,
            url_image=url_image,
        )

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPlacement")
    def reset_placement(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacement", []))

    @jsii.member(jsii_name="resetPlacementVar")
    def reset_placement_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacementVar", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetScaleDimension")
    def reset_scale_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimension", []))

    @jsii.member(jsii_name="resetScaleDimensionVar")
    def reset_scale_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimensionVar", []))

    @jsii.member(jsii_name="resetScaleVar")
    def reset_scale_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="placementInput")
    def placement_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementInput"))

    @builtins.property
    @jsii.member(jsii_name="placementVarInput")
    def placement_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionInput")
    def scale_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVarInput")
    def scale_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleVarInput")
    def scale_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__51a3321fbef6920103e820e5bbbf999282569350a0fd6ab6d6d8e551cf7fcb63)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f95bd7c99f652f99519c9b995e397f6e9a7f79739b17314639f55ffe4c19ab51)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="placement")
    def placement(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placement"))

    @placement.setter
    def placement(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b006ab50245449ebab7be5621e1afc0041619f9ddebd1bb9cace89bc2efc833e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placement", value)

    @builtins.property
    @jsii.member(jsii_name="placementVar")
    def placement_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placementVar"))

    @placement_var.setter
    def placement_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__561d51b51ba8070f6c8a0cfb58402717757c75b105db1ad00b67d1c430fac985)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placementVar", value)

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scale"))

    @scale.setter
    def scale(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d04ef6b2fb698d4caff1c5554292dda738828b016e4058b3eaecc2f02167b1d8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scale", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimension")
    def scale_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimension"))

    @scale_dimension.setter
    def scale_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__313d492e13b36c08b8bab6882e43386be77d8fd62df64114dc7905867f2bcffa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimension", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVar")
    def scale_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimensionVar"))

    @scale_dimension_var.setter
    def scale_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1330d3ab871acd64c067925a25a7fef5f52b9f1276026a7d8ce388ecde27ede7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="scaleVar")
    def scale_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleVar"))

    @scale_var.setter
    def scale_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__817bcc4a91234f6fea5a3b173ec8d66439cecfa55826ebbc1f08e8c714aed22d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b3188c58ff7201424933c87d25dee5e7e8e645830545e71db6da97c42e4e7c42)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__147b722020e37b9044a6bbd360381e8a8415212e2e116912a966737d709d8608)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6a2c592625e8e0fb7c1d8b9984cdd26033c66d9999973cb28903530bb794aa85)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8f030607d3015886b6377933ffa2448f160ccf364bd350b76a47c123765ee44a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultComposite]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultComposite]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultComposite]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a9a1829005ce680664f94172c12efe0e8bbcccf4197c29507c04e8861b5bd8e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompound",
    jsii_struct_bases=[],
    name_mapping={"transformations": "transformations"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompound:
    def __init__(
        self,
        *,
        transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param transformations: transformations block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e4e1d7f577344231f00f270c105e18353f57ce3ab2c4f25424024e956480a4c6)
            check_type(argname="argument transformations", value=transformations, expected_type=type_hints["transformations"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if transformations is not None:
            self._values["transformations"] = transformations

    @builtins.property
    def transformations(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformations"]]]:
        '''transformations block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        result = self._values.get("transformations")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformations"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompound(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__96512c0cc78401b035059026963a7b7c5b76ffea1a544f35e8118a596805bf53)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af0fecc6e3ff6c73926054a8f754d0798497b809481fde8748ee654f0f57759f)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__518f72b68e38c72f67cd55ead297791fdab1a6e26f933081d6c97c0be1dd7a54)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bdcdf31795364747db12719377ebe3e6129630a612758bdf61e19e8b6781654c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__15940e2e551716bc24725cdb254c09960a603fcc453b06a00b2954e8c25b0aa2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompound]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompound]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a516f1403d283ed294c2a6c296322f6eb2736299f6522a068b4a7e46a2da567)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ed5955bfd6db85179b0d747bc37897c36c12ab86c151bbfab41ef8fbe1dbebf9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformations")
    def put_transformations(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a96ed93adb4eb813c156d8d2cb0a4a459096e21bf4906d2be508d0287505667e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTransformations", [value]))

    @jsii.member(jsii_name="resetTransformations")
    def reset_transformations(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformations", []))

    @builtins.property
    @jsii.member(jsii_name="transformations")
    def transformations(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsList", jsii.get(self, "transformations"))

    @builtins.property
    @jsii.member(jsii_name="transformationsInput")
    def transformations_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformations"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformations"]]], jsii.get(self, "transformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompound]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompound]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompound]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2775af5d6d22d6bb4093e79b802dfe4d7760ef9c36a37a87f8330a09f9eda131)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformations",
    jsii_struct_bases=[],
    name_mapping={
        "background_color": "backgroundColor",
        "blur": "blur",
        "chroma_key": "chromaKey",
        "composite": "composite",
        "compound": "compound",
        "contrast": "contrast",
        "goop": "goop",
        "grayscale": "grayscale",
        "hsl": "hsl",
        "hsv": "hsv",
        "if_dimension": "ifDimension",
        "if_orientation": "ifOrientation",
        "max_colors": "maxColors",
        "mirror": "mirror",
        "mono_hue": "monoHue",
        "opacity": "opacity",
        "remove_color": "removeColor",
        "unsharp_mask": "unsharpMask",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformations:
    def __init__(
        self,
        *,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsBackgroundColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsBlur", typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsChromaKey", typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsComposite", typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsCompound", typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsContrast", typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsGoop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsGrayscale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsHsl", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsHsv", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfDimension", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfOrientation", typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsMaxColors", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsMirror", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsMonoHue", typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsOpacity", typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsRemoveColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsUnsharpMask", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5dfd30e8ecbbbfb8e9e0450c1c3429a163270814743bbd99c0514845dd1fa37d)
            check_type(argname="argument background_color", value=background_color, expected_type=type_hints["background_color"])
            check_type(argname="argument blur", value=blur, expected_type=type_hints["blur"])
            check_type(argname="argument chroma_key", value=chroma_key, expected_type=type_hints["chroma_key"])
            check_type(argname="argument composite", value=composite, expected_type=type_hints["composite"])
            check_type(argname="argument compound", value=compound, expected_type=type_hints["compound"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument goop", value=goop, expected_type=type_hints["goop"])
            check_type(argname="argument grayscale", value=grayscale, expected_type=type_hints["grayscale"])
            check_type(argname="argument hsl", value=hsl, expected_type=type_hints["hsl"])
            check_type(argname="argument hsv", value=hsv, expected_type=type_hints["hsv"])
            check_type(argname="argument if_dimension", value=if_dimension, expected_type=type_hints["if_dimension"])
            check_type(argname="argument if_orientation", value=if_orientation, expected_type=type_hints["if_orientation"])
            check_type(argname="argument max_colors", value=max_colors, expected_type=type_hints["max_colors"])
            check_type(argname="argument mirror", value=mirror, expected_type=type_hints["mirror"])
            check_type(argname="argument mono_hue", value=mono_hue, expected_type=type_hints["mono_hue"])
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument remove_color", value=remove_color, expected_type=type_hints["remove_color"])
            check_type(argname="argument unsharp_mask", value=unsharp_mask, expected_type=type_hints["unsharp_mask"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if background_color is not None:
            self._values["background_color"] = background_color
        if blur is not None:
            self._values["blur"] = blur
        if chroma_key is not None:
            self._values["chroma_key"] = chroma_key
        if composite is not None:
            self._values["composite"] = composite
        if compound is not None:
            self._values["compound"] = compound
        if contrast is not None:
            self._values["contrast"] = contrast
        if goop is not None:
            self._values["goop"] = goop
        if grayscale is not None:
            self._values["grayscale"] = grayscale
        if hsl is not None:
            self._values["hsl"] = hsl
        if hsv is not None:
            self._values["hsv"] = hsv
        if if_dimension is not None:
            self._values["if_dimension"] = if_dimension
        if if_orientation is not None:
            self._values["if_orientation"] = if_orientation
        if max_colors is not None:
            self._values["max_colors"] = max_colors
        if mirror is not None:
            self._values["mirror"] = mirror
        if mono_hue is not None:
            self._values["mono_hue"] = mono_hue
        if opacity is not None:
            self._values["opacity"] = opacity
        if remove_color is not None:
            self._values["remove_color"] = remove_color
        if unsharp_mask is not None:
            self._values["unsharp_mask"] = unsharp_mask

    @builtins.property
    def background_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsBackgroundColor"]]]:
        '''background_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        '''
        result = self._values.get("background_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsBackgroundColor"]]], result)

    @builtins.property
    def blur(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsBlur"]]]:
        '''blur block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        '''
        result = self._values.get("blur")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsBlur"]]], result)

    @builtins.property
    def chroma_key(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsChromaKey"]]]:
        '''chroma_key block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        '''
        result = self._values.get("chroma_key")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsChromaKey"]]], result)

    @builtins.property
    def composite(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsComposite"]]]:
        '''composite block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        '''
        result = self._values.get("composite")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsComposite"]]], result)

    @builtins.property
    def compound(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsCompound"]]]:
        '''compound block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        '''
        result = self._values.get("compound")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsCompound"]]], result)

    @builtins.property
    def contrast(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsContrast"]]]:
        '''contrast block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsContrast"]]], result)

    @builtins.property
    def goop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsGoop"]]]:
        '''goop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        '''
        result = self._values.get("goop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsGoop"]]], result)

    @builtins.property
    def grayscale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsGrayscale"]]]:
        '''grayscale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        '''
        result = self._values.get("grayscale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsGrayscale"]]], result)

    @builtins.property
    def hsl(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsHsl"]]]:
        '''hsl block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        '''
        result = self._values.get("hsl")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsHsl"]]], result)

    @builtins.property
    def hsv(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsHsv"]]]:
        '''hsv block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        '''
        result = self._values.get("hsv")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsHsv"]]], result)

    @builtins.property
    def if_dimension(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfDimension"]]]:
        '''if_dimension block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        '''
        result = self._values.get("if_dimension")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfDimension"]]], result)

    @builtins.property
    def if_orientation(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfOrientation"]]]:
        '''if_orientation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        '''
        result = self._values.get("if_orientation")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfOrientation"]]], result)

    @builtins.property
    def max_colors(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsMaxColors"]]]:
        '''max_colors block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        '''
        result = self._values.get("max_colors")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsMaxColors"]]], result)

    @builtins.property
    def mirror(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsMirror"]]]:
        '''mirror block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        '''
        result = self._values.get("mirror")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsMirror"]]], result)

    @builtins.property
    def mono_hue(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsMonoHue"]]]:
        '''mono_hue block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        '''
        result = self._values.get("mono_hue")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsMonoHue"]]], result)

    @builtins.property
    def opacity(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsOpacity"]]]:
        '''opacity block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsOpacity"]]], result)

    @builtins.property
    def remove_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsRemoveColor"]]]:
        '''remove_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        '''
        result = self._values.get("remove_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsRemoveColor"]]], result)

    @builtins.property
    def unsharp_mask(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsUnsharpMask"]]]:
        '''unsharp_mask block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        result = self._values.get("unsharp_mask")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsUnsharpMask"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformations(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsBackgroundColor",
    jsii_struct_bases=[],
    name_mapping={"color": "color", "color_var": "colorVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsBackgroundColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__01c4505f1210cde8eef3fac30cc527a704d48f5002787aba0d07ddf35f16b6d6)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsBackgroundColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsBackgroundColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsBackgroundColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1998916a03dbe9336ea1ecbfbea141b9cdcdbee8ca86aa966dc229b4320ebe2f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsBackgroundColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea25a6fa4f8a6a60763d5b0ea535b88a0b12d762c2b16cc96bf19bf0b61bca3d)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsBackgroundColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__24cf35ff8fe45a1833ab0faf907fa75ce83af3b15220c8500aeaf6bbd190af7f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ba0285bb093cdccc5576e8d3d9ccab8e989e2cd47c17beaa49225c3ab11e60a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1738cff9fa486724c610ae50440d16612fd76c6649dff8ed5960ce78fe5621bc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsBackgroundColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsBackgroundColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f835c007b99066207f73572bc9d0ef6b166f367a1addd91d0c9090bdc7e08e4f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsBackgroundColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsBackgroundColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a0505642686e589e0e6b5e3d248fbaf0e299b95bb54adea20903186ac42e17f5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5fee8b0058722838caa17a75ba4c8a620d8e4880d4eea191f80014c3adcfa965)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2e0d4dc96b5afb0c3c64f1beeb9a84530d3cca55d2c594d2f64272cc300ecd9b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsBackgroundColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsBackgroundColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsBackgroundColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aef3fff79245a77926a284358350ab5aa86653dc3c7395c9a71d52a126aeb221)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsBlur",
    jsii_struct_bases=[],
    name_mapping={"sigma": "sigma", "sigma_var": "sigmaVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsBlur:
    def __init__(
        self,
        *,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param sigma: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__abaabe3ef75960800b3866478a41db822eeb14dca606102e193d49aa433eb334)
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsBlur(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsBlurList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsBlurList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1896721f7dd4fb0e8d6f1e144c4be35dca0d0567045f165be95bd4662d72d5ed)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsBlurOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1cc72e53f68b86291d44b0ae7b4c12fb4f21311e34bc0053c25cdf25f61fa46a)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsBlurOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5dfacf642dad2db4b21d2c5688735ca98fd56a7b3912908bffd3af26f6c482c1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bf47d9927e93e58006cb261e3f112e6b38ebe42e7ddfa1c5e6d5d3424b81a24b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__856b22da318a4db941aec4bc15b44ed187a9dd92a6fafc85eb6234dd50cffe90)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsBlur]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsBlur]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a7a6c52f0d62f76a3a764e7c6c9c345af4b931fedf8f4b1e84e44b52e35f7770)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsBlurOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsBlurOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__330fb36f58cb72347d17fa0a5c39c611659922a214802b174b2e5448f5d82a5f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a12d8375a6e782603530978d4a794bd5b32d5c39004f57fd190662fa14f259e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c6199457d01503f26f971d4d9c33a69b96de7ca7acd665196556464a5615ee29)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsBlur]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsBlur]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsBlur]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a1eb9f248fc7032069f579b15da2840b450b671d3743854422c9cf3536b9472d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsChromaKey",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_feather": "hueFeather",
        "hue_feather_var": "hueFeatherVar",
        "hue_tolerance": "hueTolerance",
        "hue_tolerance_var": "hueToleranceVar",
        "hue_var": "hueVar",
        "lightness_feather": "lightnessFeather",
        "lightness_feather_var": "lightnessFeatherVar",
        "lightness_tolerance": "lightnessTolerance",
        "lightness_tolerance_var": "lightnessToleranceVar",
        "saturation_feather": "saturationFeather",
        "saturation_feather_var": "saturationFeatherVar",
        "saturation_tolerance": "saturationTolerance",
        "saturation_tolerance_var": "saturationToleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsChromaKey:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_feather: typing.Optional[builtins.str] = None,
        hue_feather_var: typing.Optional[builtins.str] = None,
        hue_tolerance: typing.Optional[builtins.str] = None,
        hue_tolerance_var: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness_feather: typing.Optional[builtins.str] = None,
        lightness_feather_var: typing.Optional[builtins.str] = None,
        lightness_tolerance: typing.Optional[builtins.str] = None,
        lightness_tolerance_var: typing.Optional[builtins.str] = None,
        saturation_feather: typing.Optional[builtins.str] = None,
        saturation_feather_var: typing.Optional[builtins.str] = None,
        saturation_tolerance: typing.Optional[builtins.str] = None,
        saturation_tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_feather: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        :param hue_feather_var: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        :param hue_tolerance: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        :param hue_tolerance_var: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        :param hue_var: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness_feather: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        :param lightness_feather_var: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        :param lightness_tolerance: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        :param lightness_tolerance_var: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        :param saturation_feather: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        :param saturation_feather_var: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        :param saturation_tolerance: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        :param saturation_tolerance_var: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__65b065ab1ea37763c98ef61e05fe8ed38466350e64795b335c237a55b5fb5946)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_feather", value=hue_feather, expected_type=type_hints["hue_feather"])
            check_type(argname="argument hue_feather_var", value=hue_feather_var, expected_type=type_hints["hue_feather_var"])
            check_type(argname="argument hue_tolerance", value=hue_tolerance, expected_type=type_hints["hue_tolerance"])
            check_type(argname="argument hue_tolerance_var", value=hue_tolerance_var, expected_type=type_hints["hue_tolerance_var"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness_feather", value=lightness_feather, expected_type=type_hints["lightness_feather"])
            check_type(argname="argument lightness_feather_var", value=lightness_feather_var, expected_type=type_hints["lightness_feather_var"])
            check_type(argname="argument lightness_tolerance", value=lightness_tolerance, expected_type=type_hints["lightness_tolerance"])
            check_type(argname="argument lightness_tolerance_var", value=lightness_tolerance_var, expected_type=type_hints["lightness_tolerance_var"])
            check_type(argname="argument saturation_feather", value=saturation_feather, expected_type=type_hints["saturation_feather"])
            check_type(argname="argument saturation_feather_var", value=saturation_feather_var, expected_type=type_hints["saturation_feather_var"])
            check_type(argname="argument saturation_tolerance", value=saturation_tolerance, expected_type=type_hints["saturation_tolerance"])
            check_type(argname="argument saturation_tolerance_var", value=saturation_tolerance_var, expected_type=type_hints["saturation_tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_feather is not None:
            self._values["hue_feather"] = hue_feather
        if hue_feather_var is not None:
            self._values["hue_feather_var"] = hue_feather_var
        if hue_tolerance is not None:
            self._values["hue_tolerance"] = hue_tolerance
        if hue_tolerance_var is not None:
            self._values["hue_tolerance_var"] = hue_tolerance_var
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness_feather is not None:
            self._values["lightness_feather"] = lightness_feather
        if lightness_feather_var is not None:
            self._values["lightness_feather_var"] = lightness_feather_var
        if lightness_tolerance is not None:
            self._values["lightness_tolerance"] = lightness_tolerance
        if lightness_tolerance_var is not None:
            self._values["lightness_tolerance_var"] = lightness_tolerance_var
        if saturation_feather is not None:
            self._values["saturation_feather"] = saturation_feather
        if saturation_feather_var is not None:
            self._values["saturation_feather_var"] = saturation_feather_var
        if saturation_tolerance is not None:
            self._values["saturation_tolerance"] = saturation_tolerance
        if saturation_tolerance_var is not None:
            self._values["saturation_tolerance_var"] = saturation_tolerance_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        '''
        result = self._values.get("hue_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        '''
        result = self._values.get("hue_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        '''
        result = self._values.get("hue_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        '''
        result = self._values.get("hue_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        '''
        result = self._values.get("lightness_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        '''
        result = self._values.get("lightness_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        '''
        result = self._values.get("lightness_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        '''
        result = self._values.get("lightness_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        '''
        result = self._values.get("saturation_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        '''
        result = self._values.get("saturation_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        '''
        result = self._values.get("saturation_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        result = self._values.get("saturation_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsChromaKey(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsChromaKeyList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsChromaKeyList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2241e5bffb1bc31c8aac763f02b28daaf4a5370586272ea8bf3061172b8324a4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsChromaKeyOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8db7fa9a8fbc29d3ed347682479cc6004f87cab8d552a75c4ce75c7d433dd314)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsChromaKeyOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5aaffa54b9c62107f083162c9e26b1c42a3926ca81290fed549847d530f51d3b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__086b53297754355e2e578d3fcc1887d8186901b26aa46f775d216ddb4c4b96b5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__233c6fec7d4199a73c8f41ec0825b01ba36c42709e13122a0a69a5eb4fc33752)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsChromaKey]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsChromaKey]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__364f754c0644e596d888962e59c08235b9806c3565d258be226196a58e8f625d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsChromaKeyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsChromaKeyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b266b242db3dad67a6e6cbd45da946c0ec5a887679cfc8274c1971f1af8f910f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueFeather")
    def reset_hue_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeather", []))

    @jsii.member(jsii_name="resetHueFeatherVar")
    def reset_hue_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeatherVar", []))

    @jsii.member(jsii_name="resetHueTolerance")
    def reset_hue_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueTolerance", []))

    @jsii.member(jsii_name="resetHueToleranceVar")
    def reset_hue_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueToleranceVar", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightnessFeather")
    def reset_lightness_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeather", []))

    @jsii.member(jsii_name="resetLightnessFeatherVar")
    def reset_lightness_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeatherVar", []))

    @jsii.member(jsii_name="resetLightnessTolerance")
    def reset_lightness_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessTolerance", []))

    @jsii.member(jsii_name="resetLightnessToleranceVar")
    def reset_lightness_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessToleranceVar", []))

    @jsii.member(jsii_name="resetSaturationFeather")
    def reset_saturation_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeather", []))

    @jsii.member(jsii_name="resetSaturationFeatherVar")
    def reset_saturation_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeatherVar", []))

    @jsii.member(jsii_name="resetSaturationTolerance")
    def reset_saturation_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationTolerance", []))

    @jsii.member(jsii_name="resetSaturationToleranceVar")
    def reset_saturation_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherInput")
    def hue_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVarInput")
    def hue_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceInput")
    def hue_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVarInput")
    def hue_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherInput")
    def lightness_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVarInput")
    def lightness_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceInput")
    def lightness_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVarInput")
    def lightness_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherInput")
    def saturation_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVarInput")
    def saturation_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceInput")
    def saturation_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVarInput")
    def saturation_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ce5a7eb966e54ced874248f1f16c71f2c62acf3a678bf76fc83febf513e28c6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeather")
    def hue_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeather"))

    @hue_feather.setter
    def hue_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__22ca2e43a671c152f10e6da75d33911a028e4342faf04aa4d27671592c2f2f47)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeather", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVar")
    def hue_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeatherVar"))

    @hue_feather_var.setter
    def hue_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f717637644dc0a8b353a8d3c1812389d774c69aec15217d9bb7d5c8130d7faa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueTolerance")
    def hue_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueTolerance"))

    @hue_tolerance.setter
    def hue_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__080d15c29015cead41c48651b08effde9d44e855c2fd9450eb389f1fec778cf6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVar")
    def hue_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueToleranceVar"))

    @hue_tolerance_var.setter
    def hue_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d277ce609ac17e542265c8682a338205e12dabec675037831b83d804fddbfa82)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aa18879dd8a4152ef3dff9013b64573ad2c15dba051f40f98dcd30db16fce211)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeather")
    def lightness_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeather"))

    @lightness_feather.setter
    def lightness_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__04107daf41c079d6dcf644a79461c865be1692123d8c7784a938be0265b65b37)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeather", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVar")
    def lightness_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeatherVar"))

    @lightness_feather_var.setter
    def lightness_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9be3569b2a00110da370042a59123de9fc68f940cd5762ce512387251e1dc97b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessTolerance")
    def lightness_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessTolerance"))

    @lightness_tolerance.setter
    def lightness_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7a477e972eb61815dffdec9ba434f404e97b9eedc21a1abc94a53d32720efcb2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVar")
    def lightness_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessToleranceVar"))

    @lightness_tolerance_var.setter
    def lightness_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__78088dcc702e0b293aaf4566458f0d369f0b2c2a390aefa3e09138bb92df25a9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeather")
    def saturation_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeather"))

    @saturation_feather.setter
    def saturation_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2248b936d3af023225b4dff058fc90755e607bc52e63abc00b182b5155987fba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeather", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVar")
    def saturation_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeatherVar"))

    @saturation_feather_var.setter
    def saturation_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3b557b0c13040a73ca4b30aa28d6d58fc2fe17e21a2cad218454b4ae2f8a1fbc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationTolerance")
    def saturation_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationTolerance"))

    @saturation_tolerance.setter
    def saturation_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2bf1a8035ddd308311e157661e7f80e51e4335a5fe7a73a8a05a41e56d2c31e0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVar")
    def saturation_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationToleranceVar"))

    @saturation_tolerance_var.setter
    def saturation_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__58b613582937e2348f59eb1ba68ae0e8253193c2c716d3bfe884fcb0abb7afd3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsChromaKey]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsChromaKey]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsChromaKey]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__64253901f3c18355c31d6f7d923587d82ff79dc9e6222bef6c9ccdcc352f62a1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsComposite",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "placement": "placement",
        "placement_var": "placementVar",
        "scale": "scale",
        "scale_dimension": "scaleDimension",
        "scale_dimension_var": "scaleDimensionVar",
        "scale_var": "scaleVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsComposite:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsCompositeImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        placement: typing.Optional[builtins.str] = None,
        placement_var: typing.Optional[builtins.str] = None,
        scale: typing.Optional[builtins.str] = None,
        scale_dimension: typing.Optional[builtins.str] = None,
        scale_dimension_var: typing.Optional[builtins.str] = None,
        scale_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param placement: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        :param placement_var: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        :param scale: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param scale_dimension: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        :param scale_dimension_var: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        :param scale_var: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        :param x_position: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsCompositeImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6772874f57188882a03e7ba4b34d614f8a7e65a25495ec609d7837abb704c5df)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument placement", value=placement, expected_type=type_hints["placement"])
            check_type(argname="argument placement_var", value=placement_var, expected_type=type_hints["placement_var"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument scale_dimension", value=scale_dimension, expected_type=type_hints["scale_dimension"])
            check_type(argname="argument scale_dimension_var", value=scale_dimension_var, expected_type=type_hints["scale_dimension_var"])
            check_type(argname="argument scale_var", value=scale_var, expected_type=type_hints["scale_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if placement is not None:
            self._values["placement"] = placement
        if placement_var is not None:
            self._values["placement_var"] = placement_var
        if scale is not None:
            self._values["scale"] = scale
        if scale_dimension is not None:
            self._values["scale_dimension"] = scale_dimension
        if scale_dimension_var is not None:
            self._values["scale_dimension_var"] = scale_dimension_var
        if scale_var is not None:
            self._values["scale_var"] = scale_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsCompositeImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsCompositeImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        '''
        result = self._values.get("placement")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement_var(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        '''
        result = self._values.get("placement_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        '''
        result = self._values.get("scale_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        '''
        result = self._values.get("scale_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        '''
        result = self._values.get("scale_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsComposite(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsCompositeImage",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsCompositeImage:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsCompositeImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsCompositeImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsCompositeImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0d867c433b85de39f9dd949da0e3c4c44764311f72ecadaabd51f19dd7e607c7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsCompositeImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsCompositeImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1b3bc3837b94700fa287b7a01582fd7295f81e27354c3d7723313c84f2a9bca2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsCompositeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsCompositeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f32e8d7a2b605a1a33c51950df9b8b1ae8a480bde5e352e5e93e690167ab7c5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsCompositeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3363d17ff8019b9378aee62f19aa3840e228186606037b92970fa14dc2aa5607)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsCompositeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__50fa5027d3e9565bd73bdc1d51670db2ec6dfefff3d48ac74442b25d47a66a6a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ca1aa4b0986c24f5ef3327560ae9f435e96df019b699ef9fd612d87f52477ee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c0282dd2525f39c48bce5d80b17ca371f23f3feeca0056efd3f59973d795afa5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsComposite]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsComposite]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8600d38c4a8eadece0d66f6f8207676e71b85f53f2f6802f490bf369886d7ab2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsCompositeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsCompositeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__83f1360e708e3273abcc887cb81f2da4e8416611dad675f52328b4cb35422dda)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsCompositeImage()

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPlacement")
    def reset_placement(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacement", []))

    @jsii.member(jsii_name="resetPlacementVar")
    def reset_placement_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacementVar", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetScaleDimension")
    def reset_scale_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimension", []))

    @jsii.member(jsii_name="resetScaleDimensionVar")
    def reset_scale_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimensionVar", []))

    @jsii.member(jsii_name="resetScaleVar")
    def reset_scale_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsCompositeImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsCompositeImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsCompositeImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="placementInput")
    def placement_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementInput"))

    @builtins.property
    @jsii.member(jsii_name="placementVarInput")
    def placement_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionInput")
    def scale_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVarInput")
    def scale_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleVarInput")
    def scale_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__64e8af78191088bcf84755c19762f72b94e2f7944fea2bd970f89e78e1a5cd0a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3f30a3444b6cd38ddd2c6a60d0c5b304c6681ebadc4a9203764fd04b794fb841)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="placement")
    def placement(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placement"))

    @placement.setter
    def placement(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ba080d99002554fbd643d70d4ae3c584f0e2c4b3a08a8d4b889970983a17d929)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placement", value)

    @builtins.property
    @jsii.member(jsii_name="placementVar")
    def placement_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placementVar"))

    @placement_var.setter
    def placement_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bd20cda1539d0a77eaad0b841e332031d451d1d7602dfe34d248506a14a361c9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placementVar", value)

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scale"))

    @scale.setter
    def scale(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7b20cbabb1647af66045f057c3c9d839abdabe254a498c5fed2f1b663786c2b4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scale", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimension")
    def scale_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimension"))

    @scale_dimension.setter
    def scale_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2b767024f2379d547606d1a2030891b1f76514f4239b5f2459961b69d7ec5d86)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimension", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVar")
    def scale_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimensionVar"))

    @scale_dimension_var.setter
    def scale_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__97ae4f13b6462f07d67766b65ecfa2bdd48fede3789742e8420c8ed28004f857)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="scaleVar")
    def scale_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleVar"))

    @scale_var.setter
    def scale_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2f8e69e45edd5ab7838e5510bb0345850a5f041abc4a32a1f2ef3f4ecb1cf928)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6b80f2d93af775d7cbe048d8fa4c9807850500703e5868c0e053ff3e58de5bf9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__29d5ff421bc8eeb2c2a20dfd06e531b72559ee02fd366e343957571683ffe9ba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__974fca1b15af52b94d9d75d0cd365d32a1f99f44f716088ad7d14f9a1f24084d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e73f7f2fa7de0119ff675ee1769f2447631c428ea7f441d6a362e8bb7233ffb3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsComposite]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsComposite]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsComposite]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0c0ada2d8d06b7eb3e42c885bdb0c0e0bcce71db1fe1223a12c52502803dc26f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsCompound",
    jsii_struct_bases=[],
    name_mapping={"transformations": "transformations"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsCompound:
    def __init__(
        self,
        *,
        transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param transformations: transformations block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0942b9081389fc93a095f6681323f8df91961b1ac4a560d8a1f1f471ab8d1835)
            check_type(argname="argument transformations", value=transformations, expected_type=type_hints["transformations"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if transformations is not None:
            self._values["transformations"] = transformations

    @builtins.property
    def transformations(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsCompoundTransformations"]]]:
        '''transformations block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        result = self._values.get("transformations")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsCompoundTransformations"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsCompound(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsCompoundList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsCompoundList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eb9ccb14837922c6e0418ccc9fc5776adc144ec1f0ca041b6493ba975c548388)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsCompoundOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__92314bd057ec87a33dffd1d38a82be4d6dc110afb9b8a67c300078d1d4728323)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsCompoundOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3066ae21edb042bb8e73ff82b35ba7d25b8f35feec90dfbcb636cb854fe78681)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__01fe061ec3ceeaab1213433c7b3e53db775d608a125ae5dd33652fff987db684)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0f47469f5688a6038df4a3e1c075d9fc53a40929ca1ca5e265402933b2373ef5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsCompound]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsCompound]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__16900e65960541e7e0911b7425c41e923fea4ebc9ab96ccc79cb55d5b6fc7394)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsCompoundOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsCompoundOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8320a203543fe4aed8f4368c2b35813b2cd7a8a439d80093274a9719bd69f879)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformations")
    def put_transformations(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__254e87d66f112e56c42655c080de2ae93f047a337ba96262ba3c42eec5dd3798)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTransformations", [value]))

    @jsii.member(jsii_name="resetTransformations")
    def reset_transformations(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformations", []))

    @builtins.property
    @jsii.member(jsii_name="transformations")
    def transformations(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsCompoundTransformationsList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsCompoundTransformationsList", jsii.get(self, "transformations"))

    @builtins.property
    @jsii.member(jsii_name="transformationsInput")
    def transformations_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsCompoundTransformations"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsCompoundTransformations"]]], jsii.get(self, "transformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsCompound]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsCompound]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsCompound]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aa831089e4142f05261cd51b7c9ca13c2979e5859f7c535726dbdddce5fc7b1e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsCompoundTransformations",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsCompoundTransformations:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsCompoundTransformations(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsCompoundTransformationsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsCompoundTransformationsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7340502b2b9cb53d198c10ea79698db3a2585532dc41728e4df2de954b6a35dc)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsCompoundTransformationsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fe1128b451bb7951ae8c9adeda0a9e8784815f635531c9bd8a0cdfb95ba3a7ce)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsCompoundTransformationsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__26134ab46bcf860c4749022479bc3eefdebd9aa10a4cef14092fac6dc7bea74b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b28fd4f1dc77db9381a7f393970da73c026b35b02b3e3e652e0445c60c2fe344)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ad8b25f41ede31838725774d8e32f75caa35095fdadc0a5f388a6dd3a18c9253)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsCompoundTransformations]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsCompoundTransformations]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsCompoundTransformations]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f7f9e6efeaf78071be26c0c3028905c30cbbd4f38d652da95567403d4bf679cc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsCompoundTransformationsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsCompoundTransformationsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__44f26d50affb9095a9efc9fe1d952912f6acc74fb7cb319c32bb2645fdd8301c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsCompoundTransformations]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsCompoundTransformations]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsCompoundTransformations]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b6f06bd80003d8cd7fd7520d534e6aaee3ad9f2df649ca629fc363e73b57e338)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsContrast",
    jsii_struct_bases=[],
    name_mapping={
        "brightness": "brightness",
        "brightness_var": "brightnessVar",
        "contrast": "contrast",
        "contrast_var": "contrastVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsContrast:
    def __init__(
        self,
        *,
        brightness: typing.Optional[builtins.str] = None,
        brightness_var: typing.Optional[builtins.str] = None,
        contrast: typing.Optional[builtins.str] = None,
        contrast_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param brightness: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        :param brightness_var: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        :param contrast: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param contrast_var: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d49a21121fc1de95cc608762813bdc3741df6473364f52e4890db34edf6890c2)
            check_type(argname="argument brightness", value=brightness, expected_type=type_hints["brightness"])
            check_type(argname="argument brightness_var", value=brightness_var, expected_type=type_hints["brightness_var"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument contrast_var", value=contrast_var, expected_type=type_hints["contrast_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if brightness is not None:
            self._values["brightness"] = brightness
        if brightness_var is not None:
            self._values["brightness_var"] = brightness_var
        if contrast is not None:
            self._values["contrast"] = contrast
        if contrast_var is not None:
            self._values["contrast_var"] = contrast_var

    @builtins.property
    def brightness(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        '''
        result = self._values.get("brightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def brightness_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        '''
        result = self._values.get("brightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        result = self._values.get("contrast_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsContrast(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsContrastList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsContrastList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b8d9ce48732b913c566f19da5c38a1ab604e9fe333022eaea4d94e3150756a30)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsContrastOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ecb3e0142341cea47fe5193208358c58a8f710f3de0b0b6960916ead5a1a23be)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsContrastOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f426b3caef4e56a4781bdddcc1dfb955dce7ce9339055bc20b1b8977eba539f1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c910a6ef1d6a6cbb4affed0ce8dee7f755ded385157e764a9d2b0e14c2ff4570)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b04739ac896f986b71cc85cf9d066ce5411e8f300c3d81908923f97d0628d171)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsContrast]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsContrast]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f993d6ccdeb50be5ab78221e8a1628bde015c43eb9a25b35fadd9ac7c329137b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsContrastOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsContrastOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a178c8bc9f0e4113eb94bce99b51ef0856284ef354fe28ce6f61b79f8d67c02)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetBrightness")
    def reset_brightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightness", []))

    @jsii.member(jsii_name="resetBrightnessVar")
    def reset_brightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightnessVar", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetContrastVar")
    def reset_contrast_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrastVar", []))

    @builtins.property
    @jsii.member(jsii_name="brightnessInput")
    def brightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="brightnessVarInput")
    def brightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastVarInput")
    def contrast_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="brightness")
    def brightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightness"))

    @brightness.setter
    def brightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fe4b29e834d9f4ca64ddda5954f3d8c73e765eecbedc329f8e713d7990d58831)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightness", value)

    @builtins.property
    @jsii.member(jsii_name="brightnessVar")
    def brightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightnessVar"))

    @brightness_var.setter
    def brightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__da647c7b78c9eb4827390e7fa054e487b4ee6c3ca8bfcff4bdd4263364bba384)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrast"))

    @contrast.setter
    def contrast(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ffa1769c03a11055b9b20a4e2a57584727224f51e25f959f6e914b608b019bbf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrast", value)

    @builtins.property
    @jsii.member(jsii_name="contrastVar")
    def contrast_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrastVar"))

    @contrast_var.setter
    def contrast_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d347608d5672b1275026350e262ba718b131e29eb891e0def058fb297ff6fee3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrastVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsContrast]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsContrast]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsContrast]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__218691df426682f22460459d4c1db6524c63c4568002ce373ea51b3273320e01)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsGoop",
    jsii_struct_bases=[],
    name_mapping={
        "chaos": "chaos",
        "chaos_var": "chaosVar",
        "density": "density",
        "density_var": "densityVar",
        "power": "power",
        "power_var": "powerVar",
        "seed": "seed",
        "seed_var": "seedVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsGoop:
    def __init__(
        self,
        *,
        chaos: typing.Optional[builtins.str] = None,
        chaos_var: typing.Optional[builtins.str] = None,
        density: typing.Optional[builtins.str] = None,
        density_var: typing.Optional[builtins.str] = None,
        power: typing.Optional[builtins.str] = None,
        power_var: typing.Optional[builtins.str] = None,
        seed: typing.Optional[builtins.str] = None,
        seed_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param chaos: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        :param chaos_var: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        :param density: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        :param density_var: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        :param power: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        :param power_var: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        :param seed: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        :param seed_var: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eda0b499850203091ae2e095c435279ff95901730af7c4593202028edb10318a)
            check_type(argname="argument chaos", value=chaos, expected_type=type_hints["chaos"])
            check_type(argname="argument chaos_var", value=chaos_var, expected_type=type_hints["chaos_var"])
            check_type(argname="argument density", value=density, expected_type=type_hints["density"])
            check_type(argname="argument density_var", value=density_var, expected_type=type_hints["density_var"])
            check_type(argname="argument power", value=power, expected_type=type_hints["power"])
            check_type(argname="argument power_var", value=power_var, expected_type=type_hints["power_var"])
            check_type(argname="argument seed", value=seed, expected_type=type_hints["seed"])
            check_type(argname="argument seed_var", value=seed_var, expected_type=type_hints["seed_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if chaos is not None:
            self._values["chaos"] = chaos
        if chaos_var is not None:
            self._values["chaos_var"] = chaos_var
        if density is not None:
            self._values["density"] = density
        if density_var is not None:
            self._values["density_var"] = density_var
        if power is not None:
            self._values["power"] = power
        if power_var is not None:
            self._values["power_var"] = power_var
        if seed is not None:
            self._values["seed"] = seed
        if seed_var is not None:
            self._values["seed_var"] = seed_var

    @builtins.property
    def chaos(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        '''
        result = self._values.get("chaos")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def chaos_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        '''
        result = self._values.get("chaos_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        '''
        result = self._values.get("density")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density_var(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        '''
        result = self._values.get("density_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        '''
        result = self._values.get("power")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power_var(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        '''
        result = self._values.get("power_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        '''
        result = self._values.get("seed")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed_var(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        result = self._values.get("seed_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsGoop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsGoopList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsGoopList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6c010672d93cc8942a5ef787d2000dd5798d4b7dec251b59ea72cd24edef07ae)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsGoopOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9cbdfcc81055b01e5ecddb57bed7ce6107b5af535d662ddc05d8c72122fdacab)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsGoopOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1c8cc5d29e89f298ae8989bdb1ee143b9c4382da4db3c17aefc89c8ff5d5c244)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6b80274a8b555c0480e3dc728f8034fbb8a52b44670a8868f4248c42680259d2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d670b142bc151978d2e563552d6fea8f0b5e8e34d97c363f7d42120bde573710)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsGoop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsGoop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__029415265b5f6073fe2248b29ce27f640483001a9eb8ef6ad1a813885d26fb25)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsGoopOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsGoopOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b6a460ea3a392516133b7d6a9577fdd73dc825aab67f31b3c8d94fb5c61465e2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetChaos")
    def reset_chaos(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaos", []))

    @jsii.member(jsii_name="resetChaosVar")
    def reset_chaos_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaosVar", []))

    @jsii.member(jsii_name="resetDensity")
    def reset_density(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensity", []))

    @jsii.member(jsii_name="resetDensityVar")
    def reset_density_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensityVar", []))

    @jsii.member(jsii_name="resetPower")
    def reset_power(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPower", []))

    @jsii.member(jsii_name="resetPowerVar")
    def reset_power_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPowerVar", []))

    @jsii.member(jsii_name="resetSeed")
    def reset_seed(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeed", []))

    @jsii.member(jsii_name="resetSeedVar")
    def reset_seed_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeedVar", []))

    @builtins.property
    @jsii.member(jsii_name="chaosInput")
    def chaos_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosInput"))

    @builtins.property
    @jsii.member(jsii_name="chaosVarInput")
    def chaos_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosVarInput"))

    @builtins.property
    @jsii.member(jsii_name="densityInput")
    def density_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityInput"))

    @builtins.property
    @jsii.member(jsii_name="densityVarInput")
    def density_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="powerInput")
    def power_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerInput"))

    @builtins.property
    @jsii.member(jsii_name="powerVarInput")
    def power_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerVarInput"))

    @builtins.property
    @jsii.member(jsii_name="seedInput")
    def seed_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedInput"))

    @builtins.property
    @jsii.member(jsii_name="seedVarInput")
    def seed_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedVarInput"))

    @builtins.property
    @jsii.member(jsii_name="chaos")
    def chaos(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaos"))

    @chaos.setter
    def chaos(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__038a8aec2b2190b3b5e89db270e838675b8ccce92aaa066d2429d8998766c72c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaos", value)

    @builtins.property
    @jsii.member(jsii_name="chaosVar")
    def chaos_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaosVar"))

    @chaos_var.setter
    def chaos_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e7b927829d6b9d98d5717cfbf4651cf52b4ee8ce0e7b28666f273509c26b53a7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaosVar", value)

    @builtins.property
    @jsii.member(jsii_name="density")
    def density(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "density"))

    @density.setter
    def density(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e9c296323e60c1076bcc796bf86483d11cc97d629dc1b3183929cd061a4b5b0f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "density", value)

    @builtins.property
    @jsii.member(jsii_name="densityVar")
    def density_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "densityVar"))

    @density_var.setter
    def density_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__efdb969f3a064f5ca61832cab4f2820f8614247a16d7d69e1e0ba4cd008307b9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "densityVar", value)

    @builtins.property
    @jsii.member(jsii_name="power")
    def power(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "power"))

    @power.setter
    def power(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f391f5e99f6cd0bbdb83ed8170e12f3c76460858af09139eca2c18d49268ae6f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "power", value)

    @builtins.property
    @jsii.member(jsii_name="powerVar")
    def power_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "powerVar"))

    @power_var.setter
    def power_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7bc23839f0c832e8edb3dd0b66e8c857bba110e26fef8f8b550940899147e604)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "powerVar", value)

    @builtins.property
    @jsii.member(jsii_name="seed")
    def seed(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seed"))

    @seed.setter
    def seed(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__264519fe682ee0601f5161ffe4163266d3d6663da3803d0529dc6e3cd0713b54)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seed", value)

    @builtins.property
    @jsii.member(jsii_name="seedVar")
    def seed_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seedVar"))

    @seed_var.setter
    def seed_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0098f4808d703d1d3941e6f97b2de20047e6cdc617a9b93613ab9ffacfd77420)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seedVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsGoop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsGoop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsGoop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__33a632d5c1eb1fc3c88f1ebf4240c6ba95294d5cc00c566eaad4fab3a1c6c0cc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsGrayscale",
    jsii_struct_bases=[],
    name_mapping={"type": "type", "type_var": "typeVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsGrayscale:
    def __init__(
        self,
        *,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param type: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7eb76d725b27c27e0d9cd6ffc4a0e38443929db19eecee5123f8f25a75f2f8d0)
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsGrayscale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsGrayscaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsGrayscaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c6e98b0af06c92ae40db830b176a24e16189c966b28fafa5168944e478e321e3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsGrayscaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f72664b3438b9e34cb9e4343d8a60c3ce587374126eb264ba179d6c833adda54)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsGrayscaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0b2024dcd848bce6b634388966f839e9320570dc99f9452e886f9ba099cb0431)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6dbb2423c61af8d3a5a20a843cf064f574e5dbc9757ee240669338ba2fe5412f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cff66b5ff2f9d0eb4ccbe5650a5a57481307dca65671a46e58691e42a259544a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsGrayscale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsGrayscale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5d5e6eb23efae455a444f45c7c2dbf09dc30c799b1fa9d8eff98343c92b5cbeb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsGrayscaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsGrayscaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dc6d67e4edbf4a5313987b570e80fb46f65a36d74daff0cd0ee052918887629b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__949c526305e7caef431ccb2d55ab303128234456e64c6b48a2387fd85defb6af)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__de0243fa34db75ef83caaba98cb0a6e620dfc57bc389f36225eea8b848f1a16a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsGrayscale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsGrayscale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsGrayscale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7753172391788bb3c3646dcc995e9f1c2bedfadbde49706c06de0bce0e31c67e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsHsl",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "lightness": "lightness",
        "lightness_var": "lightnessVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsHsl:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness: typing.Optional[builtins.str] = None,
        lightness_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        :param lightness_var: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ddc99e2e0fb034cdb419cf0c954c59e0bbcfcbd4a19df22a179c90a1c947c9ca)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness", value=lightness, expected_type=type_hints["lightness"])
            check_type(argname="argument lightness_var", value=lightness_var, expected_type=type_hints["lightness_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness is not None:
            self._values["lightness"] = lightness
        if lightness_var is not None:
            self._values["lightness_var"] = lightness_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        '''
        result = self._values.get("lightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        '''
        result = self._values.get("lightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsHsl(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsHslList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsHslList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dc38bb205e2e9632a55ac98c485c434bfc62324298d64cc124e6712a7d2be1e5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsHslOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__118e7e5e136127a17fc6e07cfdf47586206608db96be5f27ff344b524366a900)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsHslOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__00ccfec7a8412f6ed61c75493a82014a2b40490a88d1a7a908498e6d0461fa6d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f68b502595836edc40c7cbe99f836670b27782bd5d935086e4097a810a044856)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__516c7e7dba4a7e54d69b52cc7f78d788d0471fd9eb3a7c26221b01dca0586461)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsHsl]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsHsl]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__004e316f7b6d05666bbed13d66aa073fb8d67efc2c71db691538d403353c9759)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsHslOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsHslOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e8a6ed06e5a0b6e958d9bf8f0015d9128b1c9c0b83e5e7f13a591ff115a4bdca)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightness")
    def reset_lightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightness", []))

    @jsii.member(jsii_name="resetLightnessVar")
    def reset_lightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessInput")
    def lightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessVarInput")
    def lightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__48f44048aa2e152da112a0a2ab079aef8a627f536c36fc7f5e1a84b61de8148b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__92f2f8436a35aecde9c326abd2c7d6ab9921c9320ace13f91185cd24296acdee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightness")
    def lightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightness"))

    @lightness.setter
    def lightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3e05ac99c75c989b8cb889a0bea474274d00e2639fc9f2d1b1f6086b3b54ddbe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightness", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessVar")
    def lightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessVar"))

    @lightness_var.setter
    def lightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b386171ba4b1a4e52a9ad30bc01d938aa1929a6c6fbc9911ec1f676e2565c9fa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__247d84ae1c31c3442be633070d674161715b407abf1a510201293e9001f7b6b8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__61f1aaf57d58ced282d7fd42909aed05ac2be899f2a2c91659dcfefc81ba2ae5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsHsl]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsHsl]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsHsl]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e7355185359d31fd9623898a26848a8c84669382d68bb06c3eaf98370d4df3c2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsHsv",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsHsv:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        :param value: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__43e3e11c2251965f87faaecbf354007def6f5dfe3424eb25e6e78c8f8e26b77d)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsHsv(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsHsvList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsHsvList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e8c36518133cc7dfd501728af614168836942922eed9c46ae1adf71966538d27)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsHsvOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__25ddf04078055e9d1c23a43146ba518fb21c6af6347283b22e36f1982dabb611)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsHsvOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b0c878e48c7887a03b8fd7ab9779b0184b77c0ba1cb8a14c4301c873f35cc5a0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8742ba557d12f410c19cadbc6e6474629e8caac15c637aec6bad43704cb3a3ad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4e91e417c4cbc985ced6584ab9d0ec4c8607b701d6abd88b5757b06be28e0776)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsHsv]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsHsv]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8cb4602a5942d1380b2880062cc24139ba2b1db68a5a176e37cba3e7f89bdd09)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsHsvOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsHsvOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4686f477000d7774eb86fca2eed08dfaa1354060811a6533710e3d0dc7e27e10)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__97274cd743653315030497d105934a28610869ba1304a5e6b717528920b321a8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cc2840e1a3e3a267febec959b74981ff46c1dce621e4cbb41f5fccc0eae93bb3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2f03a2dda4930dadce76064c6bd3f4adc033e65b7fca20c76307966cefc61bc9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a22a1ccd2b8de72f42186731c4808bfcd421c945e058320ccf96adb44cf2c249)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be91d7ce43dc8baa4820deab87afb914fcc21ee16c59b8dcb8aa6c911d9d5b9e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c03a7247e0018e8a94e6cc18195181d8658942e495bbbbb4aebd6301da01b087)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsHsv]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsHsv]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsHsv]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1d6de822fa4ee28209754bd953954d5dde8cb29f4835e6ac3150b025d9279ab8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfDimension",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "dimension": "dimension",
        "dimension_var": "dimensionVar",
        "equal": "equal",
        "greater_than": "greaterThan",
        "less_than": "lessThan",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfDimension:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfDimensionDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        dimension: typing.Optional[builtins.str] = None,
        dimension_var: typing.Optional[builtins.str] = None,
        equal: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfDimensionEqual", typing.Dict[builtins.str, typing.Any]]] = None,
        greater_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfDimensionGreaterThan", typing.Dict[builtins.str, typing.Any]]] = None,
        less_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfDimensionLessThan", typing.Dict[builtins.str, typing.Any]]] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param dimension: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        :param dimension_var: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        :param equal: equal block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        :param greater_than: greater_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        :param less_than: less_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        :param value: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfDimensionDefault(**default)
        if isinstance(equal, dict):
            equal = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfDimensionEqual(**equal)
        if isinstance(greater_than, dict):
            greater_than = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfDimensionGreaterThan(**greater_than)
        if isinstance(less_than, dict):
            less_than = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfDimensionLessThan(**less_than)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb98cb41776f7ce39c481f1475c70620249b9f55fb97933fa1bbf94abb522c1e)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument dimension", value=dimension, expected_type=type_hints["dimension"])
            check_type(argname="argument dimension_var", value=dimension_var, expected_type=type_hints["dimension_var"])
            check_type(argname="argument equal", value=equal, expected_type=type_hints["equal"])
            check_type(argname="argument greater_than", value=greater_than, expected_type=type_hints["greater_than"])
            check_type(argname="argument less_than", value=less_than, expected_type=type_hints["less_than"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if dimension is not None:
            self._values["dimension"] = dimension
        if dimension_var is not None:
            self._values["dimension_var"] = dimension_var
        if equal is not None:
            self._values["equal"] = equal
        if greater_than is not None:
            self._values["greater_than"] = greater_than
        if less_than is not None:
            self._values["less_than"] = less_than
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfDimensionDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfDimensionDefault"], result)

    @builtins.property
    def dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        '''
        result = self._values.get("dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        '''
        result = self._values.get("dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def equal(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfDimensionEqual"]:
        '''equal block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        '''
        result = self._values.get("equal")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfDimensionEqual"], result)

    @builtins.property
    def greater_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfDimensionGreaterThan"]:
        '''greater_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        '''
        result = self._values.get("greater_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfDimensionGreaterThan"], result)

    @builtins.property
    def less_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfDimensionLessThan"]:
        '''less_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        '''
        result = self._values.get("less_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfDimensionLessThan"], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfDimension(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfDimensionDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfDimensionDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfDimensionDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfDimensionDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfDimensionDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__29d2b4fc380f78c5304d715f191a1ab415106822400b114a67ac67913f57471c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfDimensionDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfDimensionDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f1459eadb04d01f6ba49d73fb04d9f95cb22f1f9caa56227b6fba8464df02b7e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfDimensionEqual",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfDimensionEqual:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfDimensionEqual(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfDimensionEqualOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfDimensionEqualOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7bf32b5823512f3b5bf92f2ea85b5400ebf696e81790f2f5d978a98b92bb9520)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfDimensionEqual], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfDimensionEqual],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3db35074266a8b9c4b65f7865bd9d72804ebd3242ac6e20c909edaaccc55d203)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfDimensionGreaterThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfDimensionGreaterThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfDimensionGreaterThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfDimensionGreaterThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfDimensionGreaterThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f94c80f2a51116ccfc988d5dc878a3f6db4b3148cb198792092855513873a8cc)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfDimensionGreaterThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfDimensionGreaterThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5606d2f2c24a43f341a2dd07fdb5c530b8fa21ff6428495fec56e8b461496db8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfDimensionLessThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfDimensionLessThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfDimensionLessThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfDimensionLessThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfDimensionLessThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__db26d0908c57917965bf9a7476a76f58569df1cc88eae0c9a203842bbb2c7bff)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfDimensionLessThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfDimensionLessThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__56cb7e649c736163dc9a47b3ae5f2044489e74247ff2b419b55422463a6707e0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfDimensionList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfDimensionList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__253f22f52d6eb290c0bc9f075aa9d41161d16be1483b15ba8961fd2af649077b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfDimensionOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2af4a6812bd401c2608240df6ac200c67fb2e2b91298e419e6e0a745562e8ba6)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfDimensionOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__beea246f05891b7bf56e489e967240d0af1c86c85bac425a8c1e5b8b735bda0b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0012cf730bc575608bccb6baaf93ec6450b416433aefbe3152d6fddb46688a6d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9973066af600d51f33aa987ce16186f31d52001f15d9153a8db5a1627f522778)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfDimension]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfDimension]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7471d4af81eba61d7cb90e9816c87082c08f87fb56262a45cde04963fcedb4f0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfDimensionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfDimensionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9f5d237808b9f6343f224978fa700cfc14f5f684bfd0fff1316ce8b42773ad99)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfDimensionDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putEqual")
    def put_equal(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfDimensionEqual()

        return typing.cast(None, jsii.invoke(self, "putEqual", [value]))

    @jsii.member(jsii_name="putGreaterThan")
    def put_greater_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfDimensionGreaterThan()

        return typing.cast(None, jsii.invoke(self, "putGreaterThan", [value]))

    @jsii.member(jsii_name="putLessThan")
    def put_less_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfDimensionLessThan()

        return typing.cast(None, jsii.invoke(self, "putLessThan", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetDimension")
    def reset_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimension", []))

    @jsii.member(jsii_name="resetDimensionVar")
    def reset_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimensionVar", []))

    @jsii.member(jsii_name="resetEqual")
    def reset_equal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEqual", []))

    @jsii.member(jsii_name="resetGreaterThan")
    def reset_greater_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGreaterThan", []))

    @jsii.member(jsii_name="resetLessThan")
    def reset_less_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLessThan", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfDimensionDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfDimensionDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="equal")
    def equal(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfDimensionEqualOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfDimensionEqualOutputReference, jsii.get(self, "equal"))

    @builtins.property
    @jsii.member(jsii_name="greaterThan")
    def greater_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfDimensionGreaterThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfDimensionGreaterThanOutputReference, jsii.get(self, "greaterThan"))

    @builtins.property
    @jsii.member(jsii_name="lessThan")
    def less_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfDimensionLessThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfDimensionLessThanOutputReference, jsii.get(self, "lessThan"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfDimensionDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionInput")
    def dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionVarInput")
    def dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="equalInput")
    def equal_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfDimensionEqual], jsii.get(self, "equalInput"))

    @builtins.property
    @jsii.member(jsii_name="greaterThanInput")
    def greater_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfDimensionGreaterThan], jsii.get(self, "greaterThanInput"))

    @builtins.property
    @jsii.member(jsii_name="lessThanInput")
    def less_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfDimensionLessThan], jsii.get(self, "lessThanInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="dimension")
    def dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimension"))

    @dimension.setter
    def dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__123ff2de1149d8ff2c792cab8d81109539250c09a75513ec8fc038cd96af88cb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimension", value)

    @builtins.property
    @jsii.member(jsii_name="dimensionVar")
    def dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimensionVar"))

    @dimension_var.setter
    def dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__93f6fe5d0eef0a2fb99018253280ff36dae2f4c3c09da166955b0fa161a5646c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2942655e3492b4531385b53b2de984942cb12cbaa3b39524d17caa8142303142)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b64925560e969cd2d26a0b75ee33f480c3eafde0543d1a7443d60958ba5fb569)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfDimension]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfDimension]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfDimension]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dc6e89e6d7becb6e4c69fe9f3bb14678795f9d23cbd4d1eb0158e1531212a02e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfOrientation",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "landscape": "landscape",
        "portrait": "portrait",
        "square": "square",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfOrientation:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfOrientationDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        landscape: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfOrientationLandscape", typing.Dict[builtins.str, typing.Any]]] = None,
        portrait: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfOrientationPortrait", typing.Dict[builtins.str, typing.Any]]] = None,
        square: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfOrientationSquare", typing.Dict[builtins.str, typing.Any]]] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param landscape: landscape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        :param portrait: portrait block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        :param square: square block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfOrientationDefault(**default)
        if isinstance(landscape, dict):
            landscape = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfOrientationLandscape(**landscape)
        if isinstance(portrait, dict):
            portrait = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfOrientationPortrait(**portrait)
        if isinstance(square, dict):
            square = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfOrientationSquare(**square)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f903388838897121d9da692688de7ad1eb4e1bdbe23c11dcba09f778237b46ab)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument landscape", value=landscape, expected_type=type_hints["landscape"])
            check_type(argname="argument portrait", value=portrait, expected_type=type_hints["portrait"])
            check_type(argname="argument square", value=square, expected_type=type_hints["square"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if landscape is not None:
            self._values["landscape"] = landscape
        if portrait is not None:
            self._values["portrait"] = portrait
        if square is not None:
            self._values["square"] = square

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfOrientationDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfOrientationDefault"], result)

    @builtins.property
    def landscape(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfOrientationLandscape"]:
        '''landscape block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        '''
        result = self._values.get("landscape")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfOrientationLandscape"], result)

    @builtins.property
    def portrait(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfOrientationPortrait"]:
        '''portrait block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        '''
        result = self._values.get("portrait")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfOrientationPortrait"], result)

    @builtins.property
    def square(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfOrientationSquare"]:
        '''square block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        result = self._values.get("square")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfOrientationSquare"], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfOrientation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfOrientationDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfOrientationDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfOrientationDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfOrientationDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfOrientationDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fe793a690597de4e19b3773ca4e72351bf30a10c31470c683d33b972f1fe6446)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfOrientationDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfOrientationDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e6014a7ca2a535a08d4f2daf0b494f52e954d7657d55217f92024d27bf93821)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfOrientationLandscape",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfOrientationLandscape:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfOrientationLandscape(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfOrientationLandscapeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfOrientationLandscapeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0a6eadb79b33771a85ea4a38c4faa16134f39e65b1cde4a960806914e4518f20)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfOrientationLandscape], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfOrientationLandscape],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__899b47f6de2dda9ce5eaab334d4ab27799c35c911fadc3a53a4cece4cd49502c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfOrientationList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfOrientationList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__33b58ee4388a7f5e17472bf826c187d64f06d132e71b9f6dc4bce3fdb0803f5d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfOrientationOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c4559e9040f8685aaf838afb11089ed468fa92c18196f2fa3325b32a5d6d7e5c)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfOrientationOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e96df03cd40c84c4bfc3dbd75b954b498f663bf81a4f1da1aee84862253c708d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__18a165355527c4e001e2fae71f5895026a71ab629c26b127998bc763fe23b92f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9730705a4911eeefbe9b6242981908df857237bb8bea68cf2e80703af441f6f6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfOrientation]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfOrientation]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bfdcf94a4e8986b2dc1e2cd088ffd1419e24790a4b14669c5c66cbd0ecbedd7a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfOrientationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfOrientationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1819c6d08a2a92eddc3d26c5ad7667a70afbe8c684a8c3802f79dd668ca28ebb)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfOrientationDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putLandscape")
    def put_landscape(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfOrientationLandscape()

        return typing.cast(None, jsii.invoke(self, "putLandscape", [value]))

    @jsii.member(jsii_name="putPortrait")
    def put_portrait(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfOrientationPortrait()

        return typing.cast(None, jsii.invoke(self, "putPortrait", [value]))

    @jsii.member(jsii_name="putSquare")
    def put_square(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfOrientationSquare()

        return typing.cast(None, jsii.invoke(self, "putSquare", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetLandscape")
    def reset_landscape(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLandscape", []))

    @jsii.member(jsii_name="resetPortrait")
    def reset_portrait(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPortrait", []))

    @jsii.member(jsii_name="resetSquare")
    def reset_square(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSquare", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfOrientationDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfOrientationDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="landscape")
    def landscape(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfOrientationLandscapeOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfOrientationLandscapeOutputReference, jsii.get(self, "landscape"))

    @builtins.property
    @jsii.member(jsii_name="portrait")
    def portrait(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfOrientationPortraitOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfOrientationPortraitOutputReference", jsii.get(self, "portrait"))

    @builtins.property
    @jsii.member(jsii_name="square")
    def square(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfOrientationSquareOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfOrientationSquareOutputReference", jsii.get(self, "square"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfOrientationDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="landscapeInput")
    def landscape_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfOrientationLandscape], jsii.get(self, "landscapeInput"))

    @builtins.property
    @jsii.member(jsii_name="portraitInput")
    def portrait_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfOrientationPortrait"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfOrientationPortrait"], jsii.get(self, "portraitInput"))

    @builtins.property
    @jsii.member(jsii_name="squareInput")
    def square_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfOrientationSquare"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfOrientationSquare"], jsii.get(self, "squareInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfOrientation]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfOrientation]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfOrientation]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__79db2491ebfa0d4526c4ed3a6fae99c7c8742c7de859de89fbdb002ee5477426)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfOrientationPortrait",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfOrientationPortrait:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfOrientationPortrait(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfOrientationPortraitOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfOrientationPortraitOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b71df14f04cb71b3954cf0eeb50da6a6f50bce4b40311155bdf2e6fcbca4884b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfOrientationPortrait]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfOrientationPortrait], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfOrientationPortrait],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c6f2745eed02cbfca8d2973a8ce08071870c64157c8fccb56579b80be4e75de4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfOrientationSquare",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfOrientationSquare:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfOrientationSquare(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfOrientationSquareOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfOrientationSquareOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d1738d05acff7f2db60132da05574924fcc0ec6b479eb4b21e72a41c4baff68c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfOrientationSquare]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfOrientationSquare], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfOrientationSquare],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d833aae967c721e37fa8b69b7e4c9a0c2b3be9b698158527a56bf2ff60cd69e7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__86e6aa89bc1309c7a47033532b14c5ac4a2a0e428614aa310b935c8b6140a29d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__826ac304c671a076472f050a3590e64f49cc1fd6608297811d2fdc7a51316287)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a23cf6910e0cecacc96b7818e2140c7ffbcfc83b5250123f980091a904e3691)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a63633aaa9c27a053a0f79f4c306504522a4eedc2dedc8961527926b7ccabe81)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f8e34d35d64142b5af98d5f45e5a8465d9df638d92f7d6e2587b2fad75646514)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformations]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformations]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformations]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__96c9c56a0b4b527142485f2660f1bfc90fb764827822bf5b4f06ecbc1f6e2ca0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsMaxColors",
    jsii_struct_bases=[],
    name_mapping={"colors": "colors", "colors_var": "colorsVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsMaxColors:
    def __init__(
        self,
        *,
        colors: typing.Optional[builtins.str] = None,
        colors_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param colors: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        :param colors_var: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3dc7c8d20bc8efe02d46a30e36650e921c2ceb4386e38fc1f1d0d21f4db4a4b9)
            check_type(argname="argument colors", value=colors, expected_type=type_hints["colors"])
            check_type(argname="argument colors_var", value=colors_var, expected_type=type_hints["colors_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if colors is not None:
            self._values["colors"] = colors
        if colors_var is not None:
            self._values["colors_var"] = colors_var

    @builtins.property
    def colors(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        '''
        result = self._values.get("colors")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def colors_var(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        result = self._values.get("colors_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsMaxColors(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsMaxColorsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsMaxColorsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__40bc94c26c01b3147b143dccdb4148e8c7cf6b2dddb89116687207c0302f5443)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsMaxColorsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__63f800a9bb821f104edb1410447d1120ba8d339ee42b844007aa4ebb9361c830)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsMaxColorsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cee2a629c139e61495c591d8f8de84d6b356de5aa447079fcc65aa7b8df8ebea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a3991cefb8b14ca593698e3966182ebfb85efc1a65387dd31424b6284e7111b9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fbf804c60e2a0169c62b9cb91e1ecd2f17f92a9777652aec947991c9f16661ac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsMaxColors]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsMaxColors]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ed48ba1042807d924af9168e26d6605ece4ef7e40d06ccd6825ea86cdf54ae0c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsMaxColorsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsMaxColorsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fe2adc7b9889b03f5b52d06dd41a0abcbb926d02722d8b65c2cb4fdf79a00fdf)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColors")
    def reset_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColors", []))

    @jsii.member(jsii_name="resetColorsVar")
    def reset_colors_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorsVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorsInput")
    def colors_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsInput"))

    @builtins.property
    @jsii.member(jsii_name="colorsVarInput")
    def colors_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsVarInput"))

    @builtins.property
    @jsii.member(jsii_name="colors")
    def colors(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colors"))

    @colors.setter
    def colors(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bccc45b7bd3f7ac02f61cf884aa451e5780600fdbd238e5266d4ab431cb492ba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colors", value)

    @builtins.property
    @jsii.member(jsii_name="colorsVar")
    def colors_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorsVar"))

    @colors_var.setter
    def colors_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ff600c53610e02e2d1892b0d3fd241b0fd359f281b1c459fcbc1d582d733111d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorsVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsMaxColors]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsMaxColors]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsMaxColors]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__52745cd0b7b09263f82d2bfe66daf06419763da7670c02b3bfdb52d2d74d5243)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsMirror",
    jsii_struct_bases=[],
    name_mapping={
        "horizontal": "horizontal",
        "horizontal_var": "horizontalVar",
        "vertical": "vertical",
        "vertical_var": "verticalVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsMirror:
    def __init__(
        self,
        *,
        horizontal: typing.Optional[builtins.str] = None,
        horizontal_var: typing.Optional[builtins.str] = None,
        vertical: typing.Optional[builtins.str] = None,
        vertical_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param horizontal: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        :param horizontal_var: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        :param vertical: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        :param vertical_var: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9810e755482aafd716c47279fff734732f298976d5abefbd6ae98d53c64b49e1)
            check_type(argname="argument horizontal", value=horizontal, expected_type=type_hints["horizontal"])
            check_type(argname="argument horizontal_var", value=horizontal_var, expected_type=type_hints["horizontal_var"])
            check_type(argname="argument vertical", value=vertical, expected_type=type_hints["vertical"])
            check_type(argname="argument vertical_var", value=vertical_var, expected_type=type_hints["vertical_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if horizontal is not None:
            self._values["horizontal"] = horizontal
        if horizontal_var is not None:
            self._values["horizontal_var"] = horizontal_var
        if vertical is not None:
            self._values["vertical"] = vertical
        if vertical_var is not None:
            self._values["vertical_var"] = vertical_var

    @builtins.property
    def horizontal(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        '''
        result = self._values.get("horizontal")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def horizontal_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        '''
        result = self._values.get("horizontal_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        '''
        result = self._values.get("vertical")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        result = self._values.get("vertical_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsMirror(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsMirrorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsMirrorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__82f8298676c67ebee788833e62f59702290e45f785d2b2d5306d1e60d3fb5452)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsMirrorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e10bd8d39fd579f4174f782c6c7cf45fac5e10d633dbda9c9faf533b40ce0fb1)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsMirrorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b9bb1fdb4234303bcd3ba9abeb7d424ef73f99f3c9331668ab602049d853854b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__59f00bdd331df4d064e549623dbfa5cfe5751dcf4de8a6e4c3658b93e90253d7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cabc0fce8aed933da057bdac7ea17fc38c1156591445d9971c813dbf159a0588)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsMirror]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsMirror]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5437e114ff9eb8da959a3f4819061c55c5ac6a0f9540ab23ebb6cf956e26e4e9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsMirrorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsMirrorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4f29f0311a6b56c846eb14d8e2aba5b0503af50915a526ba71280195d171246e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHorizontal")
    def reset_horizontal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontal", []))

    @jsii.member(jsii_name="resetHorizontalVar")
    def reset_horizontal_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontalVar", []))

    @jsii.member(jsii_name="resetVertical")
    def reset_vertical(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVertical", []))

    @jsii.member(jsii_name="resetVerticalVar")
    def reset_vertical_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVerticalVar", []))

    @builtins.property
    @jsii.member(jsii_name="horizontalInput")
    def horizontal_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontalVarInput")
    def horizontal_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalInput")
    def vertical_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalVarInput")
    def vertical_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontal")
    def horizontal(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontal"))

    @horizontal.setter
    def horizontal(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ef704f30196f51789d096993e57098281fccf45336fec772c7bf6f5b5f8e1faa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontal", value)

    @builtins.property
    @jsii.member(jsii_name="horizontalVar")
    def horizontal_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontalVar"))

    @horizontal_var.setter
    def horizontal_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0c65ccdc3f0d28249c2d043b2344e26ca7024b2ee99281bf1a319fb3596b5545)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontalVar", value)

    @builtins.property
    @jsii.member(jsii_name="vertical")
    def vertical(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "vertical"))

    @vertical.setter
    def vertical(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f6feb6194a5f08410200d8441e783854dd1071da7e8189edb7fc6230d896814c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "vertical", value)

    @builtins.property
    @jsii.member(jsii_name="verticalVar")
    def vertical_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "verticalVar"))

    @vertical_var.setter
    def vertical_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__58f185365b2c522601bd161c278b3508631a7d8a84abd664c1d6a75962d68efa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "verticalVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsMirror]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsMirror]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsMirror]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9dd01ea697dd929f03b6b11238f1199d83d298a7a3d8791816c937e6330b96a0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsMonoHue",
    jsii_struct_bases=[],
    name_mapping={"hue": "hue", "hue_var": "hueVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsMonoHue:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__277a85916b54a5fa633bf341531fd23d02c12f35e78a506483921fb23207328f)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsMonoHue(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsMonoHueList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsMonoHueList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__95e2d3cac5faa3e609146dd5eb1f2abc6fa4a860808235de0c216641ec7ad517)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsMonoHueOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0b9b2b78ec9c679c60385d3cbfdc93afbcc08f78c61a7098489e6c2924800b2a)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsMonoHueOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__989769a0b7c27f2288d575cc6aa6851bf69e30b0330a5b812a35441649baf18a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__89ed37942e3b6a67d278c04f03fb231d19b09db066a435010f217fe011941fc7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3062d34f53876af2081c8509490c00fa95e6733ffbdee1b3ed25559ed1afc38b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsMonoHue]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsMonoHue]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__68419eb3005f79df9b94497a1a69fa2bba16b1c16ff504f8cf23c9bac3667fa1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsMonoHueOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsMonoHueOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4375919c16dd3c720a0e3b718e74438476b9a1b929782de8b0a6df01b603ca70)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__83e313297e7172e6cec3d45b2227f3cf5a5adaab9ba4b4b80202972246e88260)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aca8df470ed131049c9cb1c6629dc5e8fd399dfb9927991763710bce813ca25a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsMonoHue]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsMonoHue]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsMonoHue]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8bb8236ac5684ca35342b6d732b8680a175d6d8c2370ffbe51096a1a0b6457b2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsOpacity",
    jsii_struct_bases=[],
    name_mapping={"opacity": "opacity", "opacity_var": "opacityVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsOpacity:
    def __init__(
        self,
        *,
        opacity: typing.Optional[builtins.str] = None,
        opacity_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param opacity: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param opacity_var: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__88d50a288a433c69e32a9f049073b95b3889fa2d8ec5c150fc150d610f3120d9)
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument opacity_var", value=opacity_var, expected_type=type_hints["opacity_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if opacity is not None:
            self._values["opacity"] = opacity
        if opacity_var is not None:
            self._values["opacity_var"] = opacity_var

    @builtins.property
    def opacity(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def opacity_var(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        result = self._values.get("opacity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsOpacity(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsOpacityList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsOpacityList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__40beda27f8b64a99eaa9ff9874402a12214d6d830f145df6f560c8d1dc14d1ee)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsOpacityOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b000f3891949ffe4a9009c7c060fb1725d55233ea5d24c0fcd61bd1dab631971)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsOpacityOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a7f24187c9a0eb9885294fba6909cf76d065c74bbdba305b2f66cde02603247)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3c339423301a9d67385e6505128f34a7b3c249f086ae6686194f47d75a4af3be)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab5483e94822fe49804913bd535f279c6c6747dc26e1664ddabe5e51a11edded)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsOpacity]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsOpacity]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af0929e53e1f31a0c73f4c6c8729e7eee2f5c940243d2fe524bd5bce68295d31)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsOpacityOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsOpacityOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__15d54aebd8976bb14371fed9721db5f4f7de44abe0da803698d3e1011963af0c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetOpacityVar")
    def reset_opacity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacityVar", []))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityVarInput")
    def opacity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacity"))

    @opacity.setter
    def opacity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d92a6217253a28953701af2a193cc042d3914c28bc24838a934d43631afeaff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacity", value)

    @builtins.property
    @jsii.member(jsii_name="opacityVar")
    def opacity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacityVar"))

    @opacity_var.setter
    def opacity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4e52e9bfd1311b8f5a28aba906f792e4c6b7ebb73494783618ddde059101a9b1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacityVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsOpacity]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsOpacity]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsOpacity]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__79e9af3194f96364804308054c6c6c659c57be4e928224a64be44821a8ca2a05)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0b609e64cfed14c2142ab39346db960f36555fe6c514db74145ebc1d532401aa)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putBackgroundColor")
    def put_background_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d9405ef5f733a7db8e75cbc31168088a72b8f569307050ff50d18b90d3d1abe6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBackgroundColor", [value]))

    @jsii.member(jsii_name="putBlur")
    def put_blur(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsBlur, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fe1905f999e3e21249d7fda7a548dbbf591b7d65bb738f96ff597bc420d73b1a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBlur", [value]))

    @jsii.member(jsii_name="putChromaKey")
    def put_chroma_key(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsChromaKey, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3894926aed5d85403df60b7f7f52de8a223658093e24de70d24c5da933d07789)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putChromaKey", [value]))

    @jsii.member(jsii_name="putComposite")
    def put_composite(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsComposite, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__76b0cb6762f79a84beb800765a49104e571766f7e6ca97725b8f7296a8a71aad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putComposite", [value]))

    @jsii.member(jsii_name="putCompound")
    def put_compound(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsCompound, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0b4fb38fafdff4487d15df47191704a05aa884e2b80b4856ceabcbceefeff1d7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCompound", [value]))

    @jsii.member(jsii_name="putContrast")
    def put_contrast(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsContrast, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__39ef68115fc8df7bf86eaf8db7b11e195144e473c9bb90367a1809f84832166c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putContrast", [value]))

    @jsii.member(jsii_name="putGoop")
    def put_goop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsGoop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b87891cb553706e0509629831575797c64e97c85267b37a60d0998e30c3abb7e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGoop", [value]))

    @jsii.member(jsii_name="putGrayscale")
    def put_grayscale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsGrayscale, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9351a5199c7dda6dcc2b9aaf1b085c86b6050e28a16512e640d14239f345d5de)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGrayscale", [value]))

    @jsii.member(jsii_name="putHsl")
    def put_hsl(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsHsl, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eaa7fafe68f973ac4c66d2ae135e9775dbef6b6cb29540b2857efbc8c3c23647)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsl", [value]))

    @jsii.member(jsii_name="putHsv")
    def put_hsv(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsHsv, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__88cfeab27a0e070f08e129774c2ca27a0c198778b6977751eba9497228532f99)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsv", [value]))

    @jsii.member(jsii_name="putIfDimension")
    def put_if_dimension(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfDimension, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3f266fc2a2ca5e67dc620fa3fec9e2d176921f047d5e7009915d8e20580d602d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfDimension", [value]))

    @jsii.member(jsii_name="putIfOrientation")
    def put_if_orientation(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea489e0970c4f9368df59b1a736389de717c76c9a48f3079f4da21a30403b3a1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfOrientation", [value]))

    @jsii.member(jsii_name="putMaxColors")
    def put_max_colors(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsMaxColors, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bed02a182882c4daae7e724a518399f8af5b78d6b27fef57601aa4d30af9aaf9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMaxColors", [value]))

    @jsii.member(jsii_name="putMirror")
    def put_mirror(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsMirror, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e7ed98d12dbfe1b395e46a3f7829fa1eb86b1040849c1c13c775b174d7fb58c4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMirror", [value]))

    @jsii.member(jsii_name="putMonoHue")
    def put_mono_hue(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsMonoHue, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ce6347b87c7100b2f71669cf39aba080ce02c5783c2507580cd534a8f88e07b3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMonoHue", [value]))

    @jsii.member(jsii_name="putOpacity")
    def put_opacity(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsOpacity, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b036ab27c7be38c4fd4e7979addeafb930b882a1179106a69b194c545f765696)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putOpacity", [value]))

    @jsii.member(jsii_name="putRemoveColor")
    def put_remove_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsRemoveColor", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__411ee9277e1adb8c33cd62f61a16a89857f86e01b026efa301e4c7f7b511d2d5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRemoveColor", [value]))

    @jsii.member(jsii_name="putUnsharpMask")
    def put_unsharp_mask(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsUnsharpMask", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0237e739968646b86076dc1b1291d889aee23edfaf6780cb35cd54b1693d05da)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putUnsharpMask", [value]))

    @jsii.member(jsii_name="resetBackgroundColor")
    def reset_background_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBackgroundColor", []))

    @jsii.member(jsii_name="resetBlur")
    def reset_blur(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBlur", []))

    @jsii.member(jsii_name="resetChromaKey")
    def reset_chroma_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChromaKey", []))

    @jsii.member(jsii_name="resetComposite")
    def reset_composite(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetComposite", []))

    @jsii.member(jsii_name="resetCompound")
    def reset_compound(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCompound", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetGoop")
    def reset_goop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGoop", []))

    @jsii.member(jsii_name="resetGrayscale")
    def reset_grayscale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGrayscale", []))

    @jsii.member(jsii_name="resetHsl")
    def reset_hsl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsl", []))

    @jsii.member(jsii_name="resetHsv")
    def reset_hsv(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsv", []))

    @jsii.member(jsii_name="resetIfDimension")
    def reset_if_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfDimension", []))

    @jsii.member(jsii_name="resetIfOrientation")
    def reset_if_orientation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfOrientation", []))

    @jsii.member(jsii_name="resetMaxColors")
    def reset_max_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxColors", []))

    @jsii.member(jsii_name="resetMirror")
    def reset_mirror(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMirror", []))

    @jsii.member(jsii_name="resetMonoHue")
    def reset_mono_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonoHue", []))

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetRemoveColor")
    def reset_remove_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRemoveColor", []))

    @jsii.member(jsii_name="resetUnsharpMask")
    def reset_unsharp_mask(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUnsharpMask", []))

    @builtins.property
    @jsii.member(jsii_name="backgroundColor")
    def background_color(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsBackgroundColorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsBackgroundColorList, jsii.get(self, "backgroundColor"))

    @builtins.property
    @jsii.member(jsii_name="blur")
    def blur(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsBlurList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsBlurList, jsii.get(self, "blur"))

    @builtins.property
    @jsii.member(jsii_name="chromaKey")
    def chroma_key(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsChromaKeyList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsChromaKeyList, jsii.get(self, "chromaKey"))

    @builtins.property
    @jsii.member(jsii_name="composite")
    def composite(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsCompositeList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsCompositeList, jsii.get(self, "composite"))

    @builtins.property
    @jsii.member(jsii_name="compound")
    def compound(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsCompoundList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsCompoundList, jsii.get(self, "compound"))

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsContrastList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsContrastList, jsii.get(self, "contrast"))

    @builtins.property
    @jsii.member(jsii_name="goop")
    def goop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsGoopList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsGoopList, jsii.get(self, "goop"))

    @builtins.property
    @jsii.member(jsii_name="grayscale")
    def grayscale(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsGrayscaleList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsGrayscaleList, jsii.get(self, "grayscale"))

    @builtins.property
    @jsii.member(jsii_name="hsl")
    def hsl(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsHslList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsHslList, jsii.get(self, "hsl"))

    @builtins.property
    @jsii.member(jsii_name="hsv")
    def hsv(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsHsvList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsHsvList, jsii.get(self, "hsv"))

    @builtins.property
    @jsii.member(jsii_name="ifDimension")
    def if_dimension(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfDimensionList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfDimensionList, jsii.get(self, "ifDimension"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientation")
    def if_orientation(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfOrientationList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfOrientationList, jsii.get(self, "ifOrientation"))

    @builtins.property
    @jsii.member(jsii_name="maxColors")
    def max_colors(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsMaxColorsList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsMaxColorsList, jsii.get(self, "maxColors"))

    @builtins.property
    @jsii.member(jsii_name="mirror")
    def mirror(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsMirrorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsMirrorList, jsii.get(self, "mirror"))

    @builtins.property
    @jsii.member(jsii_name="monoHue")
    def mono_hue(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsMonoHueList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsMonoHueList, jsii.get(self, "monoHue"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsOpacityList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsOpacityList, jsii.get(self, "opacity"))

    @builtins.property
    @jsii.member(jsii_name="removeColor")
    def remove_color(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsRemoveColorList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsRemoveColorList", jsii.get(self, "removeColor"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMask")
    def unsharp_mask(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsUnsharpMaskList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsUnsharpMaskList", jsii.get(self, "unsharpMask"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColorInput")
    def background_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsBackgroundColor]]], jsii.get(self, "backgroundColorInput"))

    @builtins.property
    @jsii.member(jsii_name="blurInput")
    def blur_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsBlur]]], jsii.get(self, "blurInput"))

    @builtins.property
    @jsii.member(jsii_name="chromaKeyInput")
    def chroma_key_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsChromaKey]]], jsii.get(self, "chromaKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="compositeInput")
    def composite_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsComposite]]], jsii.get(self, "compositeInput"))

    @builtins.property
    @jsii.member(jsii_name="compoundInput")
    def compound_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsCompound]]], jsii.get(self, "compoundInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsContrast]]], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="goopInput")
    def goop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsGoop]]], jsii.get(self, "goopInput"))

    @builtins.property
    @jsii.member(jsii_name="grayscaleInput")
    def grayscale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsGrayscale]]], jsii.get(self, "grayscaleInput"))

    @builtins.property
    @jsii.member(jsii_name="hslInput")
    def hsl_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsHsl]]], jsii.get(self, "hslInput"))

    @builtins.property
    @jsii.member(jsii_name="hsvInput")
    def hsv_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsHsv]]], jsii.get(self, "hsvInput"))

    @builtins.property
    @jsii.member(jsii_name="ifDimensionInput")
    def if_dimension_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfDimension]]], jsii.get(self, "ifDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientationInput")
    def if_orientation_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfOrientation]]], jsii.get(self, "ifOrientationInput"))

    @builtins.property
    @jsii.member(jsii_name="maxColorsInput")
    def max_colors_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsMaxColors]]], jsii.get(self, "maxColorsInput"))

    @builtins.property
    @jsii.member(jsii_name="mirrorInput")
    def mirror_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsMirror]]], jsii.get(self, "mirrorInput"))

    @builtins.property
    @jsii.member(jsii_name="monoHueInput")
    def mono_hue_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsMonoHue]]], jsii.get(self, "monoHueInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsOpacity]]], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="removeColorInput")
    def remove_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsRemoveColor"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsRemoveColor"]]], jsii.get(self, "removeColorInput"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMaskInput")
    def unsharp_mask_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsUnsharpMask"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsUnsharpMask"]]], jsii.get(self, "unsharpMaskInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformations]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformations]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformations]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3c41d1a6f5908ba4284f5ba58518703e86c98c75447c2f14b45c6ca32ebbbaae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsRemoveColor",
    jsii_struct_bases=[],
    name_mapping={
        "color": "color",
        "color_var": "colorVar",
        "feather": "feather",
        "feather_var": "featherVar",
        "tolerance": "tolerance",
        "tolerance_var": "toleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsRemoveColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
        feather: typing.Optional[builtins.str] = None,
        feather_var: typing.Optional[builtins.str] = None,
        tolerance: typing.Optional[builtins.str] = None,
        tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        :param feather: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        :param feather_var: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        :param tolerance: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        :param tolerance_var: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7740692fffc42b25fc095bf7c94cb83379a2e6e3d9b3ea65797ba2e9f202c8fe)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
            check_type(argname="argument feather", value=feather, expected_type=type_hints["feather"])
            check_type(argname="argument feather_var", value=feather_var, expected_type=type_hints["feather_var"])
            check_type(argname="argument tolerance", value=tolerance, expected_type=type_hints["tolerance"])
            check_type(argname="argument tolerance_var", value=tolerance_var, expected_type=type_hints["tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var
        if feather is not None:
            self._values["feather"] = feather
        if feather_var is not None:
            self._values["feather_var"] = feather_var
        if tolerance is not None:
            self._values["tolerance"] = tolerance
        if tolerance_var is not None:
            self._values["tolerance_var"] = tolerance_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        '''
        result = self._values.get("feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather_var(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        '''
        result = self._values.get("feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        '''
        result = self._values.get("tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance_var(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        result = self._values.get("tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsRemoveColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsRemoveColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsRemoveColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a8f4b363277b5548c130ce3cf64e5b2c6d5d385f0a56c81573c43379276fb91f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsRemoveColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1b9615a6de521b7466fd23bf5c36738e488fce5ea897db1a4ee2232b23ad4860)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsRemoveColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__017f7fa8f24c5ce6994e74fd8f300d4cfc4639a94ab2af018e3b2bbb90553803)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d7719d0beea533fdd2d9294b62167ff8149a41bffb1c014794e6e76178b2f0c2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eead6a746277417a1d391d779f53ace1aeb1dd378aab5ee8a02902cf1fb409f8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsRemoveColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsRemoveColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsRemoveColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5b8e4a06bbe1f53812cc9e34dcb8862c0d3c32a12895dbf321ee95bde6e59a77)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsRemoveColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsRemoveColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__342701d2aad51a7d097b99c97a59031d85dca72f5fd09c526e535ff9f51f6923)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @jsii.member(jsii_name="resetFeather")
    def reset_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeather", []))

    @jsii.member(jsii_name="resetFeatherVar")
    def reset_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatherVar", []))

    @jsii.member(jsii_name="resetTolerance")
    def reset_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTolerance", []))

    @jsii.member(jsii_name="resetToleranceVar")
    def reset_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featherInput")
    def feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherInput"))

    @builtins.property
    @jsii.member(jsii_name="featherVarInput")
    def feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceInput")
    def tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceVarInput")
    def tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__99449c0d13d48a512af375b4e47f1d01a535e5066ab68cd464e50860446fa521)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__151a4dd6e1024c331c8c7f7e6d6289aeb60b889d06eab9af645c81100ca9c926)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="feather")
    def feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "feather"))

    @feather.setter
    def feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__04c8cbc044dad57dd56b213c60baa2a88e2ff6d4953e3d6ad880f2619f12a080)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "feather", value)

    @builtins.property
    @jsii.member(jsii_name="featherVar")
    def feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featherVar"))

    @feather_var.setter
    def feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e47f2cd60ffeee9a9b341cc25fe20d68c9fd228155dd805def47c261d21b349f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featherVar", value)

    @builtins.property
    @jsii.member(jsii_name="tolerance")
    def tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tolerance"))

    @tolerance.setter
    def tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__20dd619595d3986dea3c54aeefb43629c3cf502bb1b4b0252fe61b3f7f5d640a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tolerance", value)

    @builtins.property
    @jsii.member(jsii_name="toleranceVar")
    def tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "toleranceVar"))

    @tolerance_var.setter
    def tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5b34b3d48a46d4fbb597ad0dced565a5e0f59f05d10cf60f65a1ced7b1b4a983)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "toleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsRemoveColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsRemoveColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsRemoveColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__26a348117abd9fb8c6210c8176e824cbc0dbc491e1c302bdc62684b206bd952a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsUnsharpMask",
    jsii_struct_bases=[],
    name_mapping={
        "gain": "gain",
        "gain_var": "gainVar",
        "sigma": "sigma",
        "sigma_var": "sigmaVar",
        "threshold": "threshold",
        "threshold_var": "thresholdVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsUnsharpMask:
    def __init__(
        self,
        *,
        gain: typing.Optional[builtins.str] = None,
        gain_var: typing.Optional[builtins.str] = None,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
        threshold: typing.Optional[builtins.str] = None,
        threshold_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param gain: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        :param gain_var: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        :param sigma: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        :param threshold: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        :param threshold_var: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9067fa58958fb92ebc354ffe554dfce8131d5832e2808488d9959ccacf68a6c3)
            check_type(argname="argument gain", value=gain, expected_type=type_hints["gain"])
            check_type(argname="argument gain_var", value=gain_var, expected_type=type_hints["gain_var"])
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
            check_type(argname="argument threshold", value=threshold, expected_type=type_hints["threshold"])
            check_type(argname="argument threshold_var", value=threshold_var, expected_type=type_hints["threshold_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if gain is not None:
            self._values["gain"] = gain
        if gain_var is not None:
            self._values["gain_var"] = gain_var
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var
        if threshold is not None:
            self._values["threshold"] = threshold
        if threshold_var is not None:
            self._values["threshold_var"] = threshold_var

    @builtins.property
    def gain(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        '''
        result = self._values.get("gain")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gain_var(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        '''
        result = self._values.get("gain_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        '''
        result = self._values.get("threshold")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold_var(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        result = self._values.get("threshold_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsUnsharpMask(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsUnsharpMaskList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsUnsharpMaskList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d68d69d8567f8220c00c4dfabb64854b2b00b727c60cdaed5e5757032bef795f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsUnsharpMaskOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ce2557540954ff65518cc0590d847bcf63d373edd891f33c6c5ade2c0a13e1dc)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsUnsharpMaskOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ce5ba0abac5651389c330a9a004b60e0f9984118b4283a70fadb9dc739031d57)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f374474668bfa303d30f033550f40c954dcca10a40c7f10478f2dda9bc477f58)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__96ec2a57730b10b04794391336a3a9b090f42421d6673b9d7b18f6158272bb13)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsUnsharpMask]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsUnsharpMask]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsUnsharpMask]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a3c7e970eef8a5d9c00df0288af7fb9ffd65158d28dfdbd4abf82c37c7a4ef56)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsUnsharpMaskOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsUnsharpMaskOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c3c0a934f65cb222c6e90a4a1fd049f929501bb78d9108bf52e583fc336633fc)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetGain")
    def reset_gain(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGain", []))

    @jsii.member(jsii_name="resetGainVar")
    def reset_gain_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGainVar", []))

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @jsii.member(jsii_name="resetThreshold")
    def reset_threshold(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThreshold", []))

    @jsii.member(jsii_name="resetThresholdVar")
    def reset_threshold_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThresholdVar", []))

    @builtins.property
    @jsii.member(jsii_name="gainInput")
    def gain_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainInput"))

    @builtins.property
    @jsii.member(jsii_name="gainVarInput")
    def gain_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdInput")
    def threshold_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdVarInput")
    def threshold_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gain")
    def gain(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gain"))

    @gain.setter
    def gain(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__98b7e75482bfba4ec53766b5f619cc9fda2f37b4234f6c1c1c5b8e8b20985930)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gain", value)

    @builtins.property
    @jsii.member(jsii_name="gainVar")
    def gain_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gainVar"))

    @gain_var.setter
    def gain_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__24f0d81929f7ba904790b07a96caa8d9eec79f229f80ec3ca37e7a53c2688053)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gainVar", value)

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f86744c157af76f3a732da32ff88998ccfb7fad66571f6a1750f898019a0a1d1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f4375c19689c5edacdc4deeebf3f4e1c240873c1c99a83f8ed5065f6489be342)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="threshold")
    def threshold(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "threshold"))

    @threshold.setter
    def threshold(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a40f814d42f7b3272267b98aec171feed3b5287f49916e61e81558b5a1902de8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "threshold", value)

    @builtins.property
    @jsii.member(jsii_name="thresholdVar")
    def threshold_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "thresholdVar"))

    @threshold_var.setter
    def threshold_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b8d288248f46d4e598125582d3de77879677cef9a4ec815a52d055cd4f2e496a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "thresholdVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsUnsharpMask]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsUnsharpMask]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsUnsharpMask]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__925b4f5592bc384a173f29bec9d46e389c8b9b2a87f5bc07b950cb4fdde297da)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultContrast",
    jsii_struct_bases=[],
    name_mapping={
        "brightness": "brightness",
        "brightness_var": "brightnessVar",
        "contrast": "contrast",
        "contrast_var": "contrastVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultContrast:
    def __init__(
        self,
        *,
        brightness: typing.Optional[builtins.str] = None,
        brightness_var: typing.Optional[builtins.str] = None,
        contrast: typing.Optional[builtins.str] = None,
        contrast_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param brightness: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        :param brightness_var: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        :param contrast: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param contrast_var: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f9f4efbe78255415329a56709877f62489a84e446b625ac52be4933ced1b6ead)
            check_type(argname="argument brightness", value=brightness, expected_type=type_hints["brightness"])
            check_type(argname="argument brightness_var", value=brightness_var, expected_type=type_hints["brightness_var"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument contrast_var", value=contrast_var, expected_type=type_hints["contrast_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if brightness is not None:
            self._values["brightness"] = brightness
        if brightness_var is not None:
            self._values["brightness_var"] = brightness_var
        if contrast is not None:
            self._values["contrast"] = contrast
        if contrast_var is not None:
            self._values["contrast_var"] = contrast_var

    @builtins.property
    def brightness(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        '''
        result = self._values.get("brightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def brightness_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        '''
        result = self._values.get("brightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        result = self._values.get("contrast_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultContrast(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultContrastList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultContrastList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e2421ad8aab8ff1ff4cdc0e084964387d2d8413b80256ccc776f02a7848bdb68)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultContrastOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1a4683f454393b923cdcaab162d0a89ef95b0201e374c6d9edf99160ef10dabd)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultContrastOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__25c8ebe9cdb88c09808edc3b7c6a34fd11f9af1a216776d7cdf014ef13eb0621)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7cf62edabfd09db950af747dfaa3de7136b9439f4df01de746169cba84c45e91)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3cfa83c9107b81506e9b1392307e1af978f456c51cf218b7b294abb99435c490)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultContrast]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultContrast]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__36b81dd7b8df5d67c100845586e477666f9c85129fdd378688a22acfa83659a4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultContrastOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultContrastOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__36565cdfae450ea474759008f57ddb8ab4e28d8f7e673bfd5242c7efd0897927)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetBrightness")
    def reset_brightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightness", []))

    @jsii.member(jsii_name="resetBrightnessVar")
    def reset_brightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightnessVar", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetContrastVar")
    def reset_contrast_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrastVar", []))

    @builtins.property
    @jsii.member(jsii_name="brightnessInput")
    def brightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="brightnessVarInput")
    def brightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastVarInput")
    def contrast_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="brightness")
    def brightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightness"))

    @brightness.setter
    def brightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab79043e8f799ec75a43c57d92b769846694b60e6b4fc9dc341803b4baaa4ee4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightness", value)

    @builtins.property
    @jsii.member(jsii_name="brightnessVar")
    def brightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightnessVar"))

    @brightness_var.setter
    def brightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d343740ae4b6b59943dbdb5c9574424c17155e67d80ee1ed9958568b1c85db0e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrast"))

    @contrast.setter
    def contrast(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c318c1ea690ffdc63a1d7950588ac7f4edd75fc299718ebe785579a555ba2948)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrast", value)

    @builtins.property
    @jsii.member(jsii_name="contrastVar")
    def contrast_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrastVar"))

    @contrast_var.setter
    def contrast_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5a8eb2a4016e8965489ca65e6b6bcc0dcd7dc7a324541edfd8adb08de7f983d7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrastVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultContrast]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultContrast]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultContrast]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__613bd51e25de49a96467e966f056e6fff86170f4cb786c16da5875cb7fe1fbbc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultGoop",
    jsii_struct_bases=[],
    name_mapping={
        "chaos": "chaos",
        "chaos_var": "chaosVar",
        "density": "density",
        "density_var": "densityVar",
        "power": "power",
        "power_var": "powerVar",
        "seed": "seed",
        "seed_var": "seedVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultGoop:
    def __init__(
        self,
        *,
        chaos: typing.Optional[builtins.str] = None,
        chaos_var: typing.Optional[builtins.str] = None,
        density: typing.Optional[builtins.str] = None,
        density_var: typing.Optional[builtins.str] = None,
        power: typing.Optional[builtins.str] = None,
        power_var: typing.Optional[builtins.str] = None,
        seed: typing.Optional[builtins.str] = None,
        seed_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param chaos: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        :param chaos_var: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        :param density: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        :param density_var: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        :param power: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        :param power_var: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        :param seed: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        :param seed_var: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2e59b8eb29f4d72c76202b0985c6d4eedd59c2457e695806e2940ca75207ae9b)
            check_type(argname="argument chaos", value=chaos, expected_type=type_hints["chaos"])
            check_type(argname="argument chaos_var", value=chaos_var, expected_type=type_hints["chaos_var"])
            check_type(argname="argument density", value=density, expected_type=type_hints["density"])
            check_type(argname="argument density_var", value=density_var, expected_type=type_hints["density_var"])
            check_type(argname="argument power", value=power, expected_type=type_hints["power"])
            check_type(argname="argument power_var", value=power_var, expected_type=type_hints["power_var"])
            check_type(argname="argument seed", value=seed, expected_type=type_hints["seed"])
            check_type(argname="argument seed_var", value=seed_var, expected_type=type_hints["seed_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if chaos is not None:
            self._values["chaos"] = chaos
        if chaos_var is not None:
            self._values["chaos_var"] = chaos_var
        if density is not None:
            self._values["density"] = density
        if density_var is not None:
            self._values["density_var"] = density_var
        if power is not None:
            self._values["power"] = power
        if power_var is not None:
            self._values["power_var"] = power_var
        if seed is not None:
            self._values["seed"] = seed
        if seed_var is not None:
            self._values["seed_var"] = seed_var

    @builtins.property
    def chaos(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        '''
        result = self._values.get("chaos")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def chaos_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        '''
        result = self._values.get("chaos_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        '''
        result = self._values.get("density")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density_var(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        '''
        result = self._values.get("density_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        '''
        result = self._values.get("power")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power_var(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        '''
        result = self._values.get("power_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        '''
        result = self._values.get("seed")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed_var(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        result = self._values.get("seed_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultGoop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultGoopList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultGoopList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a8a63a2eb2a9235d19583420776eeccf9f2da53ea7552f4d3e13b0d4af69a16a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultGoopOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f7044ccaf3d3d661d6ec92b4c5911f9227325cc056d3474a6d4ac9b8e24d18e)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultGoopOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__576fedf9ac1337f3c75d655ddd09fe3a41e85d0a070fadf96e52c5092d385023)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__66b0b54010dcfa9dee227cca318374e059f7becbcb44b5194633a0660d1777fa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ee1d37e51629bf4d444dcc847c753b6f08c20cddcc614de47ac77b96d33ea53b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultGoop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultGoop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__94b2f9241b460c7164201329ffc5dcb87b264cbe1f45bded9a7a7cc190991bd4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultGoopOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultGoopOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cb5b0c960172b66f5985a4595fb35810d432c9905b40258f2ee84f027aa7cc83)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetChaos")
    def reset_chaos(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaos", []))

    @jsii.member(jsii_name="resetChaosVar")
    def reset_chaos_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaosVar", []))

    @jsii.member(jsii_name="resetDensity")
    def reset_density(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensity", []))

    @jsii.member(jsii_name="resetDensityVar")
    def reset_density_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensityVar", []))

    @jsii.member(jsii_name="resetPower")
    def reset_power(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPower", []))

    @jsii.member(jsii_name="resetPowerVar")
    def reset_power_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPowerVar", []))

    @jsii.member(jsii_name="resetSeed")
    def reset_seed(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeed", []))

    @jsii.member(jsii_name="resetSeedVar")
    def reset_seed_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeedVar", []))

    @builtins.property
    @jsii.member(jsii_name="chaosInput")
    def chaos_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosInput"))

    @builtins.property
    @jsii.member(jsii_name="chaosVarInput")
    def chaos_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosVarInput"))

    @builtins.property
    @jsii.member(jsii_name="densityInput")
    def density_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityInput"))

    @builtins.property
    @jsii.member(jsii_name="densityVarInput")
    def density_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="powerInput")
    def power_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerInput"))

    @builtins.property
    @jsii.member(jsii_name="powerVarInput")
    def power_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerVarInput"))

    @builtins.property
    @jsii.member(jsii_name="seedInput")
    def seed_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedInput"))

    @builtins.property
    @jsii.member(jsii_name="seedVarInput")
    def seed_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedVarInput"))

    @builtins.property
    @jsii.member(jsii_name="chaos")
    def chaos(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaos"))

    @chaos.setter
    def chaos(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9177da75c9f609e8ad1601274b2e61dadf79cbd516484d17cf81bf8570e34495)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaos", value)

    @builtins.property
    @jsii.member(jsii_name="chaosVar")
    def chaos_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaosVar"))

    @chaos_var.setter
    def chaos_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__330716827835d5a02223bb089eb0b19aa6c1a6998a3df67ec544b7cd8fa25b42)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaosVar", value)

    @builtins.property
    @jsii.member(jsii_name="density")
    def density(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "density"))

    @density.setter
    def density(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3829f8720a94981c7d56e6a80e11a3353d280af2f34888d8e35584b6fca7b44f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "density", value)

    @builtins.property
    @jsii.member(jsii_name="densityVar")
    def density_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "densityVar"))

    @density_var.setter
    def density_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3b6690193bde51759065a2476684c04390c832c0fc0c7442d09cb7060072e496)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "densityVar", value)

    @builtins.property
    @jsii.member(jsii_name="power")
    def power(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "power"))

    @power.setter
    def power(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a3ff3e2243b43e1c1ea6896322d952c0b450cda11298f345ecfafd3808dbb1cb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "power", value)

    @builtins.property
    @jsii.member(jsii_name="powerVar")
    def power_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "powerVar"))

    @power_var.setter
    def power_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d0e7032e16e318b15d60b8124f6da22e9e09579e02538e016d4f229aeefbbfa4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "powerVar", value)

    @builtins.property
    @jsii.member(jsii_name="seed")
    def seed(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seed"))

    @seed.setter
    def seed(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7256924670f95531eeae434547906d7ffcc75edabea77e7200e750b160bb1b0c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seed", value)

    @builtins.property
    @jsii.member(jsii_name="seedVar")
    def seed_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seedVar"))

    @seed_var.setter
    def seed_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eed9e201a386714ba9001d0e971fd49400e857d96160865f0618c2a261a17e23)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seedVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultGoop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultGoop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultGoop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__921f4b863d34dd3fc64744366deadf42625aa9a27f3b2ded43a370454852f975)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultGrayscale",
    jsii_struct_bases=[],
    name_mapping={"type": "type", "type_var": "typeVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultGrayscale:
    def __init__(
        self,
        *,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param type: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4b6e1ae850e42489255bc8ce83c787e0211d10473574cc038d2dda13d2e3e4fa)
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultGrayscale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultGrayscaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultGrayscaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__47e74b7a0dc8c6f0fbdc8e1d209acea3ccee97be29bb2ed50fd8cdb975bd2283)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultGrayscaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d4d8249599df754e3c46806cf0d79711415602792e3756c3f5106a50f11f9ccc)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultGrayscaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c20c5820ba37fdfc12621795418f0cd1059ef4a84398f62d09a14b7681bb488c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eaf6f21615e1801a427bbc5ae2914a077e5a5b63838edc206b59c6664c1978d1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f5dd54cbaf9d0fe6e3e10d166732e7b7cfd3b7680f8854db01a2f9f0633aac7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultGrayscale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultGrayscale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7f39d8151cda9ca591340cce2f54f616509c6b4ed903e4b2d346e7be93dc27ab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultGrayscaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultGrayscaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f05718ddf06ae7a60110fc010b74a77585217b0aaa7a2eee0261a36e8a382e7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5170f64961855e6dbdaab761bf3896403a7e51597354fd228e95e45769704aa4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__075cd318eb5991593d955231ff8d3cf3064296cfd38caaeeb121bc75724799f9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultGrayscale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultGrayscale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultGrayscale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5073e7c8c213b20d70ecb32828d99433132346fd566ad58ef35cf508bf326d9c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultHsl",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "lightness": "lightness",
        "lightness_var": "lightnessVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultHsl:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness: typing.Optional[builtins.str] = None,
        lightness_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        :param lightness_var: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__923fb34e052961bca4bd3dbd8137b3e3f70b671bd98966aacf27c18c57d8d4ce)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness", value=lightness, expected_type=type_hints["lightness"])
            check_type(argname="argument lightness_var", value=lightness_var, expected_type=type_hints["lightness_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness is not None:
            self._values["lightness"] = lightness
        if lightness_var is not None:
            self._values["lightness_var"] = lightness_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        '''
        result = self._values.get("lightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        '''
        result = self._values.get("lightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultHsl(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultHslList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultHslList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eed080926b23f09fb4e63223702d4c9f2f64e8532c16a5ed437aa285ca63dcd4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultHslOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4cb4b2c9be0c43a2b758cb68f2e60541dd6f018a1862d71389a47883b0cabc2f)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultHslOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5adc70491229404c1f46a58e2d8f90bb92d0b7b9b7d85d3e5a3c248dbf3be354)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2fe377216872b0be3255825cded4e6dbb59fccef35dcde252a6f271269a9511f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cf53c8b76aa9c3dadd17730f67b54c3d171c4b2238cb8dafc06090a271c0f2c2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultHsl]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultHsl]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__76c549a98b749e6a0e9da906eb6cc0aa831113492f2405d31586f04aa04dca61)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultHslOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultHslOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__50caa1b72bec72e2bd92f8570e193b8fc3347bdbbbfa32a09a65cc72541bbadf)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightness")
    def reset_lightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightness", []))

    @jsii.member(jsii_name="resetLightnessVar")
    def reset_lightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessInput")
    def lightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessVarInput")
    def lightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__74a54dfd25ea5edd59841894912c7e4fe92fb15fed3417f85b57990f9bcfdef4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__68f9ebb5713754bc81c4942dde17d6674cb4d3d4a499c86d28c951546106554e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightness")
    def lightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightness"))

    @lightness.setter
    def lightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__40e4f5ad2f65585a55da30a775403b24516bef891b56f5f790c36cd249e98f05)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightness", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessVar")
    def lightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessVar"))

    @lightness_var.setter
    def lightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d900e10015f3f2722811c69fec863374395e5a64683246ebe0ac8c74a34903e4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__85a996b4b29fd3abda2781effa564c348e4dc956e4622e1ee945d1938efdb7e7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__743073e311d64103e0d1d040d892845c56d495dac4065af00a9025a0b2c01cef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultHsl]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultHsl]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultHsl]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__68c368e436496f628e41a8a0a8a4ebf3d18bd91823443423722c5bc75b420621)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultHsv",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultHsv:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        :param value: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ae10609d49c0fad545d9a94162fe6fb61eae53b31313bbee2288efa09d703f7a)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultHsv(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultHsvList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultHsvList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d22064df43c7f68fadd1c40d56d25fe11b78bf003b98839bf6f3c05ff97d494)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultHsvOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__475371814fa18f102449521d009b5769cc1c3c141799f375dbead5936176eb29)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultHsvOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3d2fe18d86e01bdc5b490598120dd419666237cd2b8b22187e353482cc8db674)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d9baae7e7b40cf0d61f8e164d00663e1fb6d75127fdd8a3309cd54097739281)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4db66030e92dd075c162407f5a1f063658d9f9c7be31c7d914a6501b83b36f3d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultHsv]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultHsv]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__255a0c976f55171a16ea2b21cf0adb4d5326c5541a2560914ac18631e6408643)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultHsvOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultHsvOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc6534a3d5898f38855c9ed2e058a4f90f5d6185368ebb3eea449999f861c0da)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6004d4e729d0ca5e36a4d44200019c3fd0e9c8ab68c383fce2376ac092e8203f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0dfd2bd7dba2d9876a38dc0276235b3f44e453da18d7da9275ed39a80a2929ff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c1fae1d93bff4510d8612e13638b8d17675c1d45d928744740d9f8c1e714c988)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1ba2e52d137b40cb285c51a76e2c9a36ef1ae181596f71f998b3555e4beb022a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0fa8fcd7be8a55533c5fbf6b9d427a43479535d9134bd356cf3ec66e9195e322)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7b1f3dc72680fcc3a09ec55ad7061f4db356af3561fdffc7eb3bbf6b4f233b2e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultHsv]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultHsv]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultHsv]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__daeaff27f67974771cf284dbf8663c193c96d14e01d73d1e4611c725310ef536)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientation",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "landscape": "landscape",
        "portrait": "portrait",
        "square": "square",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientation:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefault, typing.Dict[builtins.str, typing.Any]]] = None,
        landscape: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscape", typing.Dict[builtins.str, typing.Any]]] = None,
        portrait: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortrait", typing.Dict[builtins.str, typing.Any]]] = None,
        square: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquare", typing.Dict[builtins.str, typing.Any]]] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param landscape: landscape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        :param portrait: portrait block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        :param square: square block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefault(**default)
        if isinstance(landscape, dict):
            landscape = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscape(**landscape)
        if isinstance(portrait, dict):
            portrait = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortrait(**portrait)
        if isinstance(square, dict):
            square = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquare(**square)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__812d7cf7ce50ed0e78f9752ca79d8e99302cbf8706ad1f809669d520a8094997)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument landscape", value=landscape, expected_type=type_hints["landscape"])
            check_type(argname="argument portrait", value=portrait, expected_type=type_hints["portrait"])
            check_type(argname="argument square", value=square, expected_type=type_hints["square"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if landscape is not None:
            self._values["landscape"] = landscape
        if portrait is not None:
            self._values["portrait"] = portrait
        if square is not None:
            self._values["square"] = square

    @builtins.property
    def default(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefault]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefault], result)

    @builtins.property
    def landscape(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscape"]:
        '''landscape block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        '''
        result = self._values.get("landscape")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscape"], result)

    @builtins.property
    def portrait(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortrait"]:
        '''portrait block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        '''
        result = self._values.get("portrait")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortrait"], result)

    @builtins.property
    def square(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquare"]:
        '''square block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        result = self._values.get("square")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquare"], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscape",
    jsii_struct_bases=[],
    name_mapping={
        "background_color": "backgroundColor",
        "blur": "blur",
        "chroma_key": "chromaKey",
        "composite": "composite",
        "compound": "compound",
        "contrast": "contrast",
        "goop": "goop",
        "grayscale": "grayscale",
        "hsl": "hsl",
        "hsv": "hsv",
        "if_dimension": "ifDimension",
        "if_orientation": "ifOrientation",
        "max_colors": "maxColors",
        "mirror": "mirror",
        "mono_hue": "monoHue",
        "opacity": "opacity",
        "remove_color": "removeColor",
        "unsharp_mask": "unsharpMask",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscape:
    def __init__(
        self,
        *,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeBackgroundColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeBlur", typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeChromaKey", typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeComposite", typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeCompound", typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeContrast", typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeGoop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeGrayscale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeHsl", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeHsv", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimension", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientation", typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeMaxColors", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeMirror", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeMonoHue", typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeOpacity", typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeRemoveColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeUnsharpMask", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ed81d2fc6e4e5c26d483e6e97a8c32e38b822035e67016aee36c72e3d63ff1f6)
            check_type(argname="argument background_color", value=background_color, expected_type=type_hints["background_color"])
            check_type(argname="argument blur", value=blur, expected_type=type_hints["blur"])
            check_type(argname="argument chroma_key", value=chroma_key, expected_type=type_hints["chroma_key"])
            check_type(argname="argument composite", value=composite, expected_type=type_hints["composite"])
            check_type(argname="argument compound", value=compound, expected_type=type_hints["compound"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument goop", value=goop, expected_type=type_hints["goop"])
            check_type(argname="argument grayscale", value=grayscale, expected_type=type_hints["grayscale"])
            check_type(argname="argument hsl", value=hsl, expected_type=type_hints["hsl"])
            check_type(argname="argument hsv", value=hsv, expected_type=type_hints["hsv"])
            check_type(argname="argument if_dimension", value=if_dimension, expected_type=type_hints["if_dimension"])
            check_type(argname="argument if_orientation", value=if_orientation, expected_type=type_hints["if_orientation"])
            check_type(argname="argument max_colors", value=max_colors, expected_type=type_hints["max_colors"])
            check_type(argname="argument mirror", value=mirror, expected_type=type_hints["mirror"])
            check_type(argname="argument mono_hue", value=mono_hue, expected_type=type_hints["mono_hue"])
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument remove_color", value=remove_color, expected_type=type_hints["remove_color"])
            check_type(argname="argument unsharp_mask", value=unsharp_mask, expected_type=type_hints["unsharp_mask"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if background_color is not None:
            self._values["background_color"] = background_color
        if blur is not None:
            self._values["blur"] = blur
        if chroma_key is not None:
            self._values["chroma_key"] = chroma_key
        if composite is not None:
            self._values["composite"] = composite
        if compound is not None:
            self._values["compound"] = compound
        if contrast is not None:
            self._values["contrast"] = contrast
        if goop is not None:
            self._values["goop"] = goop
        if grayscale is not None:
            self._values["grayscale"] = grayscale
        if hsl is not None:
            self._values["hsl"] = hsl
        if hsv is not None:
            self._values["hsv"] = hsv
        if if_dimension is not None:
            self._values["if_dimension"] = if_dimension
        if if_orientation is not None:
            self._values["if_orientation"] = if_orientation
        if max_colors is not None:
            self._values["max_colors"] = max_colors
        if mirror is not None:
            self._values["mirror"] = mirror
        if mono_hue is not None:
            self._values["mono_hue"] = mono_hue
        if opacity is not None:
            self._values["opacity"] = opacity
        if remove_color is not None:
            self._values["remove_color"] = remove_color
        if unsharp_mask is not None:
            self._values["unsharp_mask"] = unsharp_mask

    @builtins.property
    def background_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeBackgroundColor"]]]:
        '''background_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        '''
        result = self._values.get("background_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeBackgroundColor"]]], result)

    @builtins.property
    def blur(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeBlur"]]]:
        '''blur block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        '''
        result = self._values.get("blur")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeBlur"]]], result)

    @builtins.property
    def chroma_key(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeChromaKey"]]]:
        '''chroma_key block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        '''
        result = self._values.get("chroma_key")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeChromaKey"]]], result)

    @builtins.property
    def composite(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeComposite"]]]:
        '''composite block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        '''
        result = self._values.get("composite")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeComposite"]]], result)

    @builtins.property
    def compound(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeCompound"]]]:
        '''compound block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        '''
        result = self._values.get("compound")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeCompound"]]], result)

    @builtins.property
    def contrast(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeContrast"]]]:
        '''contrast block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeContrast"]]], result)

    @builtins.property
    def goop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeGoop"]]]:
        '''goop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        '''
        result = self._values.get("goop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeGoop"]]], result)

    @builtins.property
    def grayscale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeGrayscale"]]]:
        '''grayscale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        '''
        result = self._values.get("grayscale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeGrayscale"]]], result)

    @builtins.property
    def hsl(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeHsl"]]]:
        '''hsl block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        '''
        result = self._values.get("hsl")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeHsl"]]], result)

    @builtins.property
    def hsv(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeHsv"]]]:
        '''hsv block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        '''
        result = self._values.get("hsv")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeHsv"]]], result)

    @builtins.property
    def if_dimension(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimension"]]]:
        '''if_dimension block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        '''
        result = self._values.get("if_dimension")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimension"]]], result)

    @builtins.property
    def if_orientation(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientation"]]]:
        '''if_orientation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        '''
        result = self._values.get("if_orientation")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientation"]]], result)

    @builtins.property
    def max_colors(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeMaxColors"]]]:
        '''max_colors block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        '''
        result = self._values.get("max_colors")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeMaxColors"]]], result)

    @builtins.property
    def mirror(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeMirror"]]]:
        '''mirror block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        '''
        result = self._values.get("mirror")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeMirror"]]], result)

    @builtins.property
    def mono_hue(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeMonoHue"]]]:
        '''mono_hue block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        '''
        result = self._values.get("mono_hue")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeMonoHue"]]], result)

    @builtins.property
    def opacity(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeOpacity"]]]:
        '''opacity block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeOpacity"]]], result)

    @builtins.property
    def remove_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeRemoveColor"]]]:
        '''remove_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        '''
        result = self._values.get("remove_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeRemoveColor"]]], result)

    @builtins.property
    def unsharp_mask(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeUnsharpMask"]]]:
        '''unsharp_mask block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        result = self._values.get("unsharp_mask")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeUnsharpMask"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscape(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeBackgroundColor",
    jsii_struct_bases=[],
    name_mapping={"color": "color", "color_var": "colorVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeBackgroundColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1b090d1146c2c645364910b4106a99b7d93c4ad4d296af66b23e962512b974c9)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeBackgroundColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeBackgroundColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeBackgroundColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__efc47ce87bc556a757e043f818031d999c4a06e9ec37fa66ef5a7e5180b11bee)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeBackgroundColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5c142242380de4741f9d231e2423837bc6496a84725bcfce11c4e3bba9c38da3)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeBackgroundColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__22115958e150db0e27d220204e3346f127dee61e2b5d2bc2ba8e5c0621e4a7b8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__75c9fefb6365738dc292409d872aa8170a2f463c272c604dae7227ee5deed073)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6dbf10c4624b2e9d44efa1de93d080317cadd53a377726da201f93fe315f6d16)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeBackgroundColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeBackgroundColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__09bec76f4a48e157bfeaf85cb798583c9918caf703ac0888e7e786922c50a526)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeBackgroundColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeBackgroundColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8fbab8d5bbbc28fb7ae00e3eca0abc126ffbde833ebaff2dbfe0fa8a569147d0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a258c1270a4f13a8dd71c0cba59b99b744588cdfc8c8ed6f1e180e4461725f98)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8d488487bab768f9c68e9bc7f612342af47638978e481c9d4c7af6a51a20196b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeBackgroundColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeBackgroundColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeBackgroundColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__58015caee0d22044f1efadeaa3c6eafac04acc6b1b16f5795165e2e6d5aac8be)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeBlur",
    jsii_struct_bases=[],
    name_mapping={"sigma": "sigma", "sigma_var": "sigmaVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeBlur:
    def __init__(
        self,
        *,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param sigma: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a05d71eebb26c845b7326a953bfc14f54f2768322ef3ff578c4576789061bfed)
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeBlur(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeBlurList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeBlurList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dbe7cee049dd63e61be74000671487fca3313e7ac62c0beb6f2ef728a42f61de)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeBlurOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__38de88781203b7fb3ea9b3eba1bbe8ad18ed9d7e75cf7b28d3b87c4f33f67a61)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeBlurOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac2cfc9ced984ec55aa0049dae4b2e4a0efcf80e2c8e62e134619a7be5164a46)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__06116676222b520df49ca2ae7cc437df9c9b44ae8bb41861c75bb199536b2da2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0bd7009fc94f979c559cbafd29d0f7fdc11babcdb3a85314bfbe474c05fd4c87)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeBlur]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeBlur]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__73f0c85318335fd9b41e1ac50eac60bdc55e6c63b4e70cdef6f7dbafa28a39fd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeBlurOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeBlurOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__84efb35a76027edcdc7c0d0b6558c72b58dc22d27cb84d434ef29c05dd5fe538)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b708ac95175d29e6a25c7882145a55cb1fb6d087be45d642a276e41d064565ee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e499d1e54f25aa87a6826fddcba99261ff8a3a208ec80d26d9beae318cf7fb9f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeBlur]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeBlur]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeBlur]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__415b0430ccf05dd959710b264a7787be1051b8aa5cd6857dd2107b941a1768b0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeChromaKey",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_feather": "hueFeather",
        "hue_feather_var": "hueFeatherVar",
        "hue_tolerance": "hueTolerance",
        "hue_tolerance_var": "hueToleranceVar",
        "hue_var": "hueVar",
        "lightness_feather": "lightnessFeather",
        "lightness_feather_var": "lightnessFeatherVar",
        "lightness_tolerance": "lightnessTolerance",
        "lightness_tolerance_var": "lightnessToleranceVar",
        "saturation_feather": "saturationFeather",
        "saturation_feather_var": "saturationFeatherVar",
        "saturation_tolerance": "saturationTolerance",
        "saturation_tolerance_var": "saturationToleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeChromaKey:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_feather: typing.Optional[builtins.str] = None,
        hue_feather_var: typing.Optional[builtins.str] = None,
        hue_tolerance: typing.Optional[builtins.str] = None,
        hue_tolerance_var: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness_feather: typing.Optional[builtins.str] = None,
        lightness_feather_var: typing.Optional[builtins.str] = None,
        lightness_tolerance: typing.Optional[builtins.str] = None,
        lightness_tolerance_var: typing.Optional[builtins.str] = None,
        saturation_feather: typing.Optional[builtins.str] = None,
        saturation_feather_var: typing.Optional[builtins.str] = None,
        saturation_tolerance: typing.Optional[builtins.str] = None,
        saturation_tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_feather: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        :param hue_feather_var: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        :param hue_tolerance: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        :param hue_tolerance_var: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        :param hue_var: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness_feather: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        :param lightness_feather_var: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        :param lightness_tolerance: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        :param lightness_tolerance_var: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        :param saturation_feather: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        :param saturation_feather_var: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        :param saturation_tolerance: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        :param saturation_tolerance_var: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__929bda55353cb4927bd5fa8553f1934794379d954056dda97d31dba105e7fc88)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_feather", value=hue_feather, expected_type=type_hints["hue_feather"])
            check_type(argname="argument hue_feather_var", value=hue_feather_var, expected_type=type_hints["hue_feather_var"])
            check_type(argname="argument hue_tolerance", value=hue_tolerance, expected_type=type_hints["hue_tolerance"])
            check_type(argname="argument hue_tolerance_var", value=hue_tolerance_var, expected_type=type_hints["hue_tolerance_var"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness_feather", value=lightness_feather, expected_type=type_hints["lightness_feather"])
            check_type(argname="argument lightness_feather_var", value=lightness_feather_var, expected_type=type_hints["lightness_feather_var"])
            check_type(argname="argument lightness_tolerance", value=lightness_tolerance, expected_type=type_hints["lightness_tolerance"])
            check_type(argname="argument lightness_tolerance_var", value=lightness_tolerance_var, expected_type=type_hints["lightness_tolerance_var"])
            check_type(argname="argument saturation_feather", value=saturation_feather, expected_type=type_hints["saturation_feather"])
            check_type(argname="argument saturation_feather_var", value=saturation_feather_var, expected_type=type_hints["saturation_feather_var"])
            check_type(argname="argument saturation_tolerance", value=saturation_tolerance, expected_type=type_hints["saturation_tolerance"])
            check_type(argname="argument saturation_tolerance_var", value=saturation_tolerance_var, expected_type=type_hints["saturation_tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_feather is not None:
            self._values["hue_feather"] = hue_feather
        if hue_feather_var is not None:
            self._values["hue_feather_var"] = hue_feather_var
        if hue_tolerance is not None:
            self._values["hue_tolerance"] = hue_tolerance
        if hue_tolerance_var is not None:
            self._values["hue_tolerance_var"] = hue_tolerance_var
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness_feather is not None:
            self._values["lightness_feather"] = lightness_feather
        if lightness_feather_var is not None:
            self._values["lightness_feather_var"] = lightness_feather_var
        if lightness_tolerance is not None:
            self._values["lightness_tolerance"] = lightness_tolerance
        if lightness_tolerance_var is not None:
            self._values["lightness_tolerance_var"] = lightness_tolerance_var
        if saturation_feather is not None:
            self._values["saturation_feather"] = saturation_feather
        if saturation_feather_var is not None:
            self._values["saturation_feather_var"] = saturation_feather_var
        if saturation_tolerance is not None:
            self._values["saturation_tolerance"] = saturation_tolerance
        if saturation_tolerance_var is not None:
            self._values["saturation_tolerance_var"] = saturation_tolerance_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        '''
        result = self._values.get("hue_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        '''
        result = self._values.get("hue_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        '''
        result = self._values.get("hue_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        '''
        result = self._values.get("hue_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        '''
        result = self._values.get("lightness_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        '''
        result = self._values.get("lightness_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        '''
        result = self._values.get("lightness_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        '''
        result = self._values.get("lightness_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        '''
        result = self._values.get("saturation_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        '''
        result = self._values.get("saturation_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        '''
        result = self._values.get("saturation_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        result = self._values.get("saturation_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeChromaKey(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeChromaKeyList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeChromaKeyList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__87319404290f2f8f27ce7d9b8130af4db44b5614df8a874ca5f4ab813aaf9570)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeChromaKeyOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f776d9eb73da89618992e7cbea2d8a895a20430d5208e66a4db39869a1d5930c)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeChromaKeyOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__35a54ca56549bf118268e631a9dffe661125a08e436370d5ced7fd66a128b42f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c3667d12089c94339ba045859ede6858531d6adb9033597919131be42a4fe0c7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e3cb2bd827d9f17e6aedf45c02edc3ba1e8b6ac25931ee8498cb59ce877689fa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeChromaKey]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeChromaKey]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b2d90bbf9b5a9b0950195eafe3e5581f72c0a784c7b3eae582c0edfc4ac1d90a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeChromaKeyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeChromaKeyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1702198a1f7edd23ad7824b4719e440f0b4dc137dcfa4d90a0fd2d128e32b913)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueFeather")
    def reset_hue_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeather", []))

    @jsii.member(jsii_name="resetHueFeatherVar")
    def reset_hue_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeatherVar", []))

    @jsii.member(jsii_name="resetHueTolerance")
    def reset_hue_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueTolerance", []))

    @jsii.member(jsii_name="resetHueToleranceVar")
    def reset_hue_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueToleranceVar", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightnessFeather")
    def reset_lightness_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeather", []))

    @jsii.member(jsii_name="resetLightnessFeatherVar")
    def reset_lightness_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeatherVar", []))

    @jsii.member(jsii_name="resetLightnessTolerance")
    def reset_lightness_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessTolerance", []))

    @jsii.member(jsii_name="resetLightnessToleranceVar")
    def reset_lightness_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessToleranceVar", []))

    @jsii.member(jsii_name="resetSaturationFeather")
    def reset_saturation_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeather", []))

    @jsii.member(jsii_name="resetSaturationFeatherVar")
    def reset_saturation_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeatherVar", []))

    @jsii.member(jsii_name="resetSaturationTolerance")
    def reset_saturation_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationTolerance", []))

    @jsii.member(jsii_name="resetSaturationToleranceVar")
    def reset_saturation_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherInput")
    def hue_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVarInput")
    def hue_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceInput")
    def hue_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVarInput")
    def hue_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherInput")
    def lightness_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVarInput")
    def lightness_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceInput")
    def lightness_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVarInput")
    def lightness_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherInput")
    def saturation_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVarInput")
    def saturation_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceInput")
    def saturation_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVarInput")
    def saturation_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a2a1753a601d75bdb57a234a8ec469bef321721d8d6fa6b33f338004f81c941b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeather")
    def hue_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeather"))

    @hue_feather.setter
    def hue_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__629e04fa4e9c2c590291febe09c2032645b12582a39772cd9f6fd289ea58abf7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeather", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVar")
    def hue_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeatherVar"))

    @hue_feather_var.setter
    def hue_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__05e5b91ad76fa3c241cde46af9f458c64dfa916b1629838ea998cfe6a6de9848)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueTolerance")
    def hue_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueTolerance"))

    @hue_tolerance.setter
    def hue_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dce6a6a2ad56d9a6890696bd5db567d7229cd8f74eb3d79e5dada744c5b48beb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVar")
    def hue_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueToleranceVar"))

    @hue_tolerance_var.setter
    def hue_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eee74779bff442eefbaa1652bdfea1fcd711d116a570dd2b8107715d4f614620)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9af2deefaa22c033dd1dac9afad8f572527469bf31c007162d66611940a6fddb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeather")
    def lightness_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeather"))

    @lightness_feather.setter
    def lightness_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f259332138a1a13b390d5beb83a17c7fba27c98613afea3b4943abaf7c6b4b90)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeather", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVar")
    def lightness_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeatherVar"))

    @lightness_feather_var.setter
    def lightness_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a30270195ad9986012c9055f4034e72d2a594830333acd08398c708193d719c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessTolerance")
    def lightness_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessTolerance"))

    @lightness_tolerance.setter
    def lightness_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__58438b0f24d98d19a80bb4ce30de7bea397663741b8c9f711e131a04ad8f312f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVar")
    def lightness_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessToleranceVar"))

    @lightness_tolerance_var.setter
    def lightness_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2563140b4e8316ecbc5ca82a4ca68f823ec7e6715bc822a341d12eae438ccc11)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeather")
    def saturation_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeather"))

    @saturation_feather.setter
    def saturation_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3287e8562de7e6ca423dbdd8e58e4f323a5282e9d1a339968f8052cd97353832)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeather", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVar")
    def saturation_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeatherVar"))

    @saturation_feather_var.setter
    def saturation_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e5e242b07c9d97b0062c8ef0dc467838b2fae7b4db04e66b6b61d979194f9e5d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationTolerance")
    def saturation_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationTolerance"))

    @saturation_tolerance.setter
    def saturation_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc1b2ba52b695f78cf520429bcf4b9aeafa71eeaac3065af2fe58bffd537db35)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVar")
    def saturation_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationToleranceVar"))

    @saturation_tolerance_var.setter
    def saturation_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7c4051427abc6f78168981749ad3efad5a438df2267c31757f226088e24394cb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeChromaKey]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeChromaKey]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeChromaKey]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5a582a5fc1742300f7ce0a342f66bd61af1019b41aed5c43ec01c3145bd998eb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeComposite",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "placement": "placement",
        "placement_var": "placementVar",
        "scale": "scale",
        "scale_dimension": "scaleDimension",
        "scale_dimension_var": "scaleDimensionVar",
        "scale_var": "scaleVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeComposite:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeCompositeImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        placement: typing.Optional[builtins.str] = None,
        placement_var: typing.Optional[builtins.str] = None,
        scale: typing.Optional[builtins.str] = None,
        scale_dimension: typing.Optional[builtins.str] = None,
        scale_dimension_var: typing.Optional[builtins.str] = None,
        scale_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param placement: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        :param placement_var: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        :param scale: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param scale_dimension: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        :param scale_dimension_var: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        :param scale_var: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        :param x_position: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeCompositeImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8f9eede03ae29aadd217957d316f15483dd45ea2e7749e3f247ba96ebc5869aa)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument placement", value=placement, expected_type=type_hints["placement"])
            check_type(argname="argument placement_var", value=placement_var, expected_type=type_hints["placement_var"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument scale_dimension", value=scale_dimension, expected_type=type_hints["scale_dimension"])
            check_type(argname="argument scale_dimension_var", value=scale_dimension_var, expected_type=type_hints["scale_dimension_var"])
            check_type(argname="argument scale_var", value=scale_var, expected_type=type_hints["scale_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if placement is not None:
            self._values["placement"] = placement
        if placement_var is not None:
            self._values["placement_var"] = placement_var
        if scale is not None:
            self._values["scale"] = scale
        if scale_dimension is not None:
            self._values["scale_dimension"] = scale_dimension
        if scale_dimension_var is not None:
            self._values["scale_dimension_var"] = scale_dimension_var
        if scale_var is not None:
            self._values["scale_var"] = scale_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeCompositeImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeCompositeImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        '''
        result = self._values.get("placement")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement_var(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        '''
        result = self._values.get("placement_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        '''
        result = self._values.get("scale_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        '''
        result = self._values.get("scale_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        '''
        result = self._values.get("scale_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeComposite(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeCompositeImage",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeCompositeImage:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeCompositeImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeCompositeImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeCompositeImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cef3db949d8115d6d7ed989d5f655283b3cf99ba1f4268fd9f615411139d7df3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeCompositeImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeCompositeImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b4b1c1da6d9267083f2aad2d8f4e9b56647933bb179eb54d5561bf5ea9fc67f7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeCompositeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeCompositeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4dac368a46f62d9db932da92555eb4608f13f51a07a4de82e96aa605a8069553)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeCompositeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__81f44bfab97335dfec39764c86e7610c8504091868c29aa5f0077a947c8f7ca4)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeCompositeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c38a7c7f1b71fc8f170b2b8cb6f675159f9b88848abac6d542a2ea67aea8d22f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4802e540025200b23a9a4b8377496b4a254c4444404ff083cfb04efe96eef1b4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8e6e27e84e9fbfd9de5d67ae7f983f08a44ede1c04a1679c9ae0f257aa10e630)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeComposite]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeComposite]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3c71ff431b117436a3bb91dc3d20c06b6f57bcc9e48a8caec84a4e269f74bdd5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeCompositeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeCompositeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ddca71e2683cf76e924abf4381666c5d5cf87fd2e4a4d5dd03d45f8b8d4d642)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeCompositeImage()

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPlacement")
    def reset_placement(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacement", []))

    @jsii.member(jsii_name="resetPlacementVar")
    def reset_placement_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacementVar", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetScaleDimension")
    def reset_scale_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimension", []))

    @jsii.member(jsii_name="resetScaleDimensionVar")
    def reset_scale_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimensionVar", []))

    @jsii.member(jsii_name="resetScaleVar")
    def reset_scale_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeCompositeImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeCompositeImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeCompositeImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="placementInput")
    def placement_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementInput"))

    @builtins.property
    @jsii.member(jsii_name="placementVarInput")
    def placement_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionInput")
    def scale_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVarInput")
    def scale_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleVarInput")
    def scale_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2bf912ca5b8382389100c0f064ff2fa405de32230f854ddf3fb6d2133d69c173)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__80daf3b5454993b3a0314ddd95a9b3034b1ded1b21291850f43bff6412d1aefb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="placement")
    def placement(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placement"))

    @placement.setter
    def placement(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9e380833c864d53b4cd73d8de6fbf2cfb58556d6e8b46bedfa2c91ce2a18002e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placement", value)

    @builtins.property
    @jsii.member(jsii_name="placementVar")
    def placement_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placementVar"))

    @placement_var.setter
    def placement_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3aa67c6173aa38c76d9f081821d835321a9c3ae9429c98d72f07dd3556a1fe44)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placementVar", value)

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scale"))

    @scale.setter
    def scale(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f360135413c3c5a513720c14215ffa26793650850aca194ee0816eaf6288bd5b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scale", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimension")
    def scale_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimension"))

    @scale_dimension.setter
    def scale_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ef433752b679d38ded73953ce72a09422493d6d0777cadc685c74117d2010eff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimension", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVar")
    def scale_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimensionVar"))

    @scale_dimension_var.setter
    def scale_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d627a2cd4524fd726ee85e08e383f8b086e25364241d87ac0ba9ce244e4bc65)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="scaleVar")
    def scale_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleVar"))

    @scale_var.setter
    def scale_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2c2b6ab51efda6646e59dc52cd52e8071ca6bc7937b451f47cd46562c0c726fb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0a40cbf771861a9b170891289384b23d79684270e4b6f69e8fa8f0ed8caaf915)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c1f3f0c89475a842fd2efcc093703b62ecaff7483b6c836102d05a03389da2e3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__876e5bee04e2981b72f2e0e765b6b56888282a6a275b4a0c76684c14b477165e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__74bfd3249a94f0fd549b7604b095b7c789a5f80ed3d0f54e0cf9ee0f6479b6fc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeComposite]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeComposite]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeComposite]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__24664a8c0d66b275a91e77e7b04060631e746e32fe99dc7f430b27cb0146288f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeCompound",
    jsii_struct_bases=[],
    name_mapping={"transformations": "transformations"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeCompound:
    def __init__(
        self,
        *,
        transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param transformations: transformations block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__59c91ea6b9d7a9c998a2c08051a83e46eb49e459e039afde1bb876405dd76300)
            check_type(argname="argument transformations", value=transformations, expected_type=type_hints["transformations"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if transformations is not None:
            self._values["transformations"] = transformations

    @builtins.property
    def transformations(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeCompoundTransformations"]]]:
        '''transformations block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        result = self._values.get("transformations")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeCompoundTransformations"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeCompound(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeCompoundList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeCompoundList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9cde330dc43a3b61c8e9d7628118ba8503d970e43e319d9e2e1ae2b08c49e16d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeCompoundOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8b6d76d9b05607f2ab1c5134af959802e06207a6138753b80b603d6420562526)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeCompoundOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__578360b196c926e5071061d16ac2414e02750204c5c090634b213f3d6093892b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bdd431a5dbbf43287168347e778af64678af3e452435a7344ba826804faab285)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1da6d6767d185c537db058ca85b9785db00b0225dfb09cfb8c7976944bb6a606)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeCompound]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeCompound]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b01750280ee8743d5a33febbceb8d3b8e4d98c19abd55fb9082f9160cc13c109)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeCompoundOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeCompoundOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1d9c2dc86a235932cbcaf05d736880c60b5c3385aebbdcb9cf71c088efd35890)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformations")
    def put_transformations(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__43beb4800a0ecce3cf9b4e2a9c3ff1376facdc54db7d4292e0c4764354e38f5f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTransformations", [value]))

    @jsii.member(jsii_name="resetTransformations")
    def reset_transformations(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformations", []))

    @builtins.property
    @jsii.member(jsii_name="transformations")
    def transformations(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeCompoundTransformationsList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeCompoundTransformationsList", jsii.get(self, "transformations"))

    @builtins.property
    @jsii.member(jsii_name="transformationsInput")
    def transformations_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeCompoundTransformations"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeCompoundTransformations"]]], jsii.get(self, "transformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeCompound]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeCompound]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeCompound]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__86da60218575e5e6b1475e5f1509ebdd303f1f96f0c44ab0b0bc6cc99d472401)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeCompoundTransformations",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeCompoundTransformations:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeCompoundTransformations(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeCompoundTransformationsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeCompoundTransformationsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c5b07904c0d5efc0c3b2e8d47d08308fef6abb4deee18e6fc8a0321e3ce11d45)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeCompoundTransformationsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0e4ec7359fabdc7c807bb6c2234017a28d96fea7022f2a771383fb78179ac83c)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeCompoundTransformationsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__48dd39be084bf2757078ef8ced7ad762af01164655cb774a2fada7fbe19c54a9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4b8d6ae9f5a1fb9781b0fd15a8cad4c32ae86cc882ba25731319b42cba9904a0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__77a6ed6683f59d64af004c785272f7f4ce24bb01d348695b6da0f16f834b5c1f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeCompoundTransformations]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeCompoundTransformations]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeCompoundTransformations]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e10457ca7c7d89a3ac523e504b24e3896a203db2979c800a7e7732de357cca87)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeCompoundTransformationsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeCompoundTransformationsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a2eeb3ade21cb2320077f8a2d47dc4a717fa5d1db419992f47698e5601e99521)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeCompoundTransformations]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeCompoundTransformations]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeCompoundTransformations]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ba975180e352c3e590b0079719de68d924198196b1dd109c31c9d169b26fc232)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeContrast",
    jsii_struct_bases=[],
    name_mapping={
        "brightness": "brightness",
        "brightness_var": "brightnessVar",
        "contrast": "contrast",
        "contrast_var": "contrastVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeContrast:
    def __init__(
        self,
        *,
        brightness: typing.Optional[builtins.str] = None,
        brightness_var: typing.Optional[builtins.str] = None,
        contrast: typing.Optional[builtins.str] = None,
        contrast_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param brightness: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        :param brightness_var: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        :param contrast: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param contrast_var: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2eb25217fbb2163ff377278d36bd482109c76547a35037613b905dbf080565d7)
            check_type(argname="argument brightness", value=brightness, expected_type=type_hints["brightness"])
            check_type(argname="argument brightness_var", value=brightness_var, expected_type=type_hints["brightness_var"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument contrast_var", value=contrast_var, expected_type=type_hints["contrast_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if brightness is not None:
            self._values["brightness"] = brightness
        if brightness_var is not None:
            self._values["brightness_var"] = brightness_var
        if contrast is not None:
            self._values["contrast"] = contrast
        if contrast_var is not None:
            self._values["contrast_var"] = contrast_var

    @builtins.property
    def brightness(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        '''
        result = self._values.get("brightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def brightness_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        '''
        result = self._values.get("brightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        result = self._values.get("contrast_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeContrast(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeContrastList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeContrastList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1dbb6b45021f9234df99be4f625bc3cd2d0ff38f1c0ab6952bef185384512568)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeContrastOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0a3b4ce9f3bb3dec435a1113bbddf130796e7c5c7442187ce4784b1b7c5cbec0)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeContrastOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__47e871c577eb351aa62d17ad1a3413dbf72a976fa4e7e9c59005069dc2741538)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c9e4e91db44ad432996df32f9879256aaf66b1ba42122bd89430873b84f4e6fc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ddc5fb67ec5b346bae661d03b659faa71ef3e7753e61649a56bdca72f6886a9b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeContrast]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeContrast]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ffa3829488629ed1060420552db0c84654dbbc0c1f3300dc072709e59d85f28)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeContrastOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeContrastOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7105914af60684f40598b8d585c4d304ed69a050decda14eeace4cf755e3520f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetBrightness")
    def reset_brightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightness", []))

    @jsii.member(jsii_name="resetBrightnessVar")
    def reset_brightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightnessVar", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetContrastVar")
    def reset_contrast_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrastVar", []))

    @builtins.property
    @jsii.member(jsii_name="brightnessInput")
    def brightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="brightnessVarInput")
    def brightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastVarInput")
    def contrast_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="brightness")
    def brightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightness"))

    @brightness.setter
    def brightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6330188da0ab1b55d5d507acb473f5b20d26807d7b16274057231cfeb8899932)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightness", value)

    @builtins.property
    @jsii.member(jsii_name="brightnessVar")
    def brightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightnessVar"))

    @brightness_var.setter
    def brightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__16c84810855abf70e5719fff2b8df1f1406a4ba391ae9828b34249a867136fb4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrast"))

    @contrast.setter
    def contrast(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ff2507f3e9ee1984ef3ff954f4fcb2078b7ad2ab5cf51ef0cea4b32733288e0a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrast", value)

    @builtins.property
    @jsii.member(jsii_name="contrastVar")
    def contrast_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrastVar"))

    @contrast_var.setter
    def contrast_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__55a2b2bea308b44ff56b7a099795638fdeb4e140cc715461be91aec0eeb2b8c0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrastVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeContrast]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeContrast]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeContrast]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5480f9e44787e3cf185d5db215b7cf823d20913b4bce8bd87ed2e88d311c262e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeGoop",
    jsii_struct_bases=[],
    name_mapping={
        "chaos": "chaos",
        "chaos_var": "chaosVar",
        "density": "density",
        "density_var": "densityVar",
        "power": "power",
        "power_var": "powerVar",
        "seed": "seed",
        "seed_var": "seedVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeGoop:
    def __init__(
        self,
        *,
        chaos: typing.Optional[builtins.str] = None,
        chaos_var: typing.Optional[builtins.str] = None,
        density: typing.Optional[builtins.str] = None,
        density_var: typing.Optional[builtins.str] = None,
        power: typing.Optional[builtins.str] = None,
        power_var: typing.Optional[builtins.str] = None,
        seed: typing.Optional[builtins.str] = None,
        seed_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param chaos: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        :param chaos_var: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        :param density: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        :param density_var: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        :param power: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        :param power_var: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        :param seed: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        :param seed_var: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f772a9a2a6ac66bc883a7fbced035e758f339860b1ab2188bc1d1502f476007a)
            check_type(argname="argument chaos", value=chaos, expected_type=type_hints["chaos"])
            check_type(argname="argument chaos_var", value=chaos_var, expected_type=type_hints["chaos_var"])
            check_type(argname="argument density", value=density, expected_type=type_hints["density"])
            check_type(argname="argument density_var", value=density_var, expected_type=type_hints["density_var"])
            check_type(argname="argument power", value=power, expected_type=type_hints["power"])
            check_type(argname="argument power_var", value=power_var, expected_type=type_hints["power_var"])
            check_type(argname="argument seed", value=seed, expected_type=type_hints["seed"])
            check_type(argname="argument seed_var", value=seed_var, expected_type=type_hints["seed_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if chaos is not None:
            self._values["chaos"] = chaos
        if chaos_var is not None:
            self._values["chaos_var"] = chaos_var
        if density is not None:
            self._values["density"] = density
        if density_var is not None:
            self._values["density_var"] = density_var
        if power is not None:
            self._values["power"] = power
        if power_var is not None:
            self._values["power_var"] = power_var
        if seed is not None:
            self._values["seed"] = seed
        if seed_var is not None:
            self._values["seed_var"] = seed_var

    @builtins.property
    def chaos(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        '''
        result = self._values.get("chaos")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def chaos_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        '''
        result = self._values.get("chaos_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        '''
        result = self._values.get("density")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density_var(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        '''
        result = self._values.get("density_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        '''
        result = self._values.get("power")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power_var(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        '''
        result = self._values.get("power_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        '''
        result = self._values.get("seed")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed_var(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        result = self._values.get("seed_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeGoop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeGoopList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeGoopList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__34d816a2e056abdc493e4415950780b294f3a0cd2672f97ddcd1fd6f0576b7c2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeGoopOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a0f3612b34ab10bee6031d865c379d1471981fa731e5694dd05962daeedf0335)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeGoopOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8438d17a6d29d39c79c528698a0e9959e4d2191feab24f58ce5c4b04833a51f8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__adac29b241ca20aed9f5f8058b5661f0a147e23a4b3f9f16139dc6142fe578e1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d75266128b35094caf3f1161b6e0d3258a158661e093b6f112ae4b29333dd70b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeGoop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeGoop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a65690cdbd2375961061bb3f2ecff8c2b9f979a1e08f96e2e8e0cba8097191af)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeGoopOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeGoopOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__74baacf6d20a7a33b1409be57e2dcc5bb41b2c8c712e302ad1e6aed52464e382)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetChaos")
    def reset_chaos(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaos", []))

    @jsii.member(jsii_name="resetChaosVar")
    def reset_chaos_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaosVar", []))

    @jsii.member(jsii_name="resetDensity")
    def reset_density(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensity", []))

    @jsii.member(jsii_name="resetDensityVar")
    def reset_density_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensityVar", []))

    @jsii.member(jsii_name="resetPower")
    def reset_power(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPower", []))

    @jsii.member(jsii_name="resetPowerVar")
    def reset_power_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPowerVar", []))

    @jsii.member(jsii_name="resetSeed")
    def reset_seed(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeed", []))

    @jsii.member(jsii_name="resetSeedVar")
    def reset_seed_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeedVar", []))

    @builtins.property
    @jsii.member(jsii_name="chaosInput")
    def chaos_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosInput"))

    @builtins.property
    @jsii.member(jsii_name="chaosVarInput")
    def chaos_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosVarInput"))

    @builtins.property
    @jsii.member(jsii_name="densityInput")
    def density_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityInput"))

    @builtins.property
    @jsii.member(jsii_name="densityVarInput")
    def density_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="powerInput")
    def power_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerInput"))

    @builtins.property
    @jsii.member(jsii_name="powerVarInput")
    def power_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerVarInput"))

    @builtins.property
    @jsii.member(jsii_name="seedInput")
    def seed_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedInput"))

    @builtins.property
    @jsii.member(jsii_name="seedVarInput")
    def seed_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedVarInput"))

    @builtins.property
    @jsii.member(jsii_name="chaos")
    def chaos(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaos"))

    @chaos.setter
    def chaos(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e609b55df030072648e5a3f20d70d514ec1b8a70c3a279d7e7eee9d10fe552ce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaos", value)

    @builtins.property
    @jsii.member(jsii_name="chaosVar")
    def chaos_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaosVar"))

    @chaos_var.setter
    def chaos_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ba7880f0baf753417643327f6c0967dc22ee3408f945617f237589edd225c5b1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaosVar", value)

    @builtins.property
    @jsii.member(jsii_name="density")
    def density(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "density"))

    @density.setter
    def density(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b4d95cec5a278662d4b67741a84c08b02443f8a82a22958ce9c6f8dd9bc6ab9e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "density", value)

    @builtins.property
    @jsii.member(jsii_name="densityVar")
    def density_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "densityVar"))

    @density_var.setter
    def density_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__122f34c65db0277479cbe851a6219aa130af8a5e7dd4d99e0f2b7e6e4736ac84)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "densityVar", value)

    @builtins.property
    @jsii.member(jsii_name="power")
    def power(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "power"))

    @power.setter
    def power(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8aba880851448b37d0df96a8ead06426596e83ce40d819ce981fa9a10e00d04c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "power", value)

    @builtins.property
    @jsii.member(jsii_name="powerVar")
    def power_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "powerVar"))

    @power_var.setter
    def power_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa85ae1a05a0c6115d79c985df47670747feb8936fac83c089773b4c71db9eec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "powerVar", value)

    @builtins.property
    @jsii.member(jsii_name="seed")
    def seed(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seed"))

    @seed.setter
    def seed(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__377c47fb561b2f714fb4178643cf0aa706b8ead25750f467f335372c8008b19c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seed", value)

    @builtins.property
    @jsii.member(jsii_name="seedVar")
    def seed_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seedVar"))

    @seed_var.setter
    def seed_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bf2ae86c5808107dc8d7cd1aa3581255fb11091d26565751c90a1a09de320789)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seedVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeGoop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeGoop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeGoop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fba4be195f712e408ef66afcda89059ae635f0123ddfa81afc11fab89a22ad17)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeGrayscale",
    jsii_struct_bases=[],
    name_mapping={"type": "type", "type_var": "typeVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeGrayscale:
    def __init__(
        self,
        *,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param type: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a81dab819882d5cc0ae1165b9f6aea16521dbe8b9dcdeec9916524edbd9b7855)
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeGrayscale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeGrayscaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeGrayscaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4c1572c77df9ff62999538613c95487739f17896763d6984b1c86397aca64733)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeGrayscaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__07b2b4424ce130fdf55e56736b7b6188386d26779514595e7fd834e9870072a2)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeGrayscaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d09a1567e4096c09ebeae3d37cdc409854b0726c94cefb75861297bad46962b9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__352fbcd243e951064696595aebc52f4b4881ec649d36f7ff926db4f808934d5e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b226aca70e73a1efc477984313ca9724a61bf9836148af9fcaf2d87bacf8957e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeGrayscale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeGrayscale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__36a046a3f76f89ec7c210ab734eac5f4d46f562ada2187d6d2b99934fccc25b4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeGrayscaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeGrayscaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__de85439d03ea5d110efdd4e23db2e1aa2f778b6229660d49db5082d3c5040cb6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d8bcc659acc8bcdbc70619ec965b700a34d5b250a1feec7148bc92e206f68f2a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__95515dcc3296c4b9ef4f59f1ff86afdfb1d5c95725ce507b2048971ebf4b9a2a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeGrayscale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeGrayscale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeGrayscale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ffdd7659da4c346c00150a2a2487adbb6222cf08cd4077239ed7b37f8dbb8d19)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeHsl",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "lightness": "lightness",
        "lightness_var": "lightnessVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeHsl:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness: typing.Optional[builtins.str] = None,
        lightness_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        :param lightness_var: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d2732497060b1e0a66e191e57a4169bb480ba8b3274f8a7926ebfa32b67171b1)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness", value=lightness, expected_type=type_hints["lightness"])
            check_type(argname="argument lightness_var", value=lightness_var, expected_type=type_hints["lightness_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness is not None:
            self._values["lightness"] = lightness
        if lightness_var is not None:
            self._values["lightness_var"] = lightness_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        '''
        result = self._values.get("lightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        '''
        result = self._values.get("lightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeHsl(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeHslList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeHslList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f409e58c82c35c238331aa302cc9c6b63fa2da6f2b87a94222d9adace6083a52)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeHslOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d55e0b4c8bcd4f7700dc22311c672b9bdc75e8d7828927f59537210784e5b61a)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeHslOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__69fb084836ad57f7811ed31fb621a69ccd5800f4a991bf0638542b1d70604723)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7dcc70b22ebdaf602ea958be242a55546b6271e2024129eb5f5ca4630cc89275)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4f8262592e2dbb34c3ff3462a4615887708a7209d070e7fd8919f0740ae90a88)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeHsl]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeHsl]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ec8a7911c04b9d38dff31171a095b6f5d2024a3bc0cf613acbade5574974ba66)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeHslOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeHslOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3f73fa4b923320577e1506529348cee71da28f9021f192c4b607d62e17649b93)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightness")
    def reset_lightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightness", []))

    @jsii.member(jsii_name="resetLightnessVar")
    def reset_lightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessInput")
    def lightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessVarInput")
    def lightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__85109562959df3ae1c3a311d86a54c82fae5c8b9b7e0b6611553bad65968b1f5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb15316cbd0649327a19b0a61e6fd8c940bffbfc31be8eba1d5c92e2220a26ae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightness")
    def lightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightness"))

    @lightness.setter
    def lightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b0f4c5e17d17079913d42f4d195c4f03745b001dd851a060f0a8e40a5cfbaed0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightness", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessVar")
    def lightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessVar"))

    @lightness_var.setter
    def lightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__38621ab0987cb26589b825f279ab94e510da14cfacd163dac4f355cc3cad1d17)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__76008e3514fd33cb6802c18af268f123b710cadf6fdbf52c7028ff0fe9119815)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e523a53999e7ebd58b2488f21d35aad0651683cfac1d036a270394fd13c8521f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeHsl]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeHsl]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeHsl]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1cd51c55c729d4ab3bf36aabdb57911cdeb1bde47fe9a4736311bc041d635e75)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeHsv",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeHsv:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        :param value: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b8b7d5ae5f755c2f9518d0c63bc19bc10a6c0db79e2b2ad27aeb289649107466)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeHsv(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeHsvList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeHsvList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__92b90a6420f3cdc04d2f2ef975b353771d0bc7fb9375159477a1360a85391bc9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeHsvOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d7ccccc07c71504418f887abc6373e4fed2dd5207317afc9b24b2d34a7e9bea2)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeHsvOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fae8d9270c03e2726bfb91b02940c2567adf0a34e1a69a1a16b3ce9031a91ac6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c8aeb722cbf54dcfa9a63218f9bbbd733d1b74f9d61917327bd26d7695dee146)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8074847cb2448ab549c85121db16995581840411c4d82f6fca53ffe6d6e29bbf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeHsv]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeHsv]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cc6ad1a15507bd54c1bea22d6dbab13bf444f2c0833b3ad539968d9f3fd54486)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeHsvOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeHsvOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__272561f8896224bdf18c1363d4e289987a70c3925efbd34e6093a404dacc4c9f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__de2ca3f6d227ee5272c9151bc3b852f1e96f5bc0788e7257aba11eacb5b8d66c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e83d1522492cc40bf4322a50e9ecfac9a7005370af5d1a651a34fbce0bbbe317)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea6b8e9fb423e70264abe42f0b3d56340eb98b430aed2f5fecbdb10bd2c4728b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__04a6079030a20cc5f18706ff1f52e4819a02e2e85f27bb2ea827092ea932f696)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__688de2aea3608e673ba1fe249923531ddaa953e4dfa18e3cca967be2e956717c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3f3ea0960e5cad53b308c3bed254627df26eb202392f4bb70bec4478657db8f9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeHsv]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeHsv]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeHsv]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0773c36ec1053c9d06e649bafc48d8cf1e407227d76384ac2786a98767bc913b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimension",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "dimension": "dimension",
        "dimension_var": "dimensionVar",
        "equal": "equal",
        "greater_than": "greaterThan",
        "less_than": "lessThan",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimension:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        dimension: typing.Optional[builtins.str] = None,
        dimension_var: typing.Optional[builtins.str] = None,
        equal: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionEqual", typing.Dict[builtins.str, typing.Any]]] = None,
        greater_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionGreaterThan", typing.Dict[builtins.str, typing.Any]]] = None,
        less_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionLessThan", typing.Dict[builtins.str, typing.Any]]] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param dimension: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        :param dimension_var: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        :param equal: equal block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        :param greater_than: greater_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        :param less_than: less_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        :param value: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionDefault(**default)
        if isinstance(equal, dict):
            equal = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionEqual(**equal)
        if isinstance(greater_than, dict):
            greater_than = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionGreaterThan(**greater_than)
        if isinstance(less_than, dict):
            less_than = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionLessThan(**less_than)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bbfe6059b84bc150e5c2212eae31cd0120a2220b638bc418a6974f36e24afb9b)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument dimension", value=dimension, expected_type=type_hints["dimension"])
            check_type(argname="argument dimension_var", value=dimension_var, expected_type=type_hints["dimension_var"])
            check_type(argname="argument equal", value=equal, expected_type=type_hints["equal"])
            check_type(argname="argument greater_than", value=greater_than, expected_type=type_hints["greater_than"])
            check_type(argname="argument less_than", value=less_than, expected_type=type_hints["less_than"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if dimension is not None:
            self._values["dimension"] = dimension
        if dimension_var is not None:
            self._values["dimension_var"] = dimension_var
        if equal is not None:
            self._values["equal"] = equal
        if greater_than is not None:
            self._values["greater_than"] = greater_than
        if less_than is not None:
            self._values["less_than"] = less_than
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionDefault"], result)

    @builtins.property
    def dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        '''
        result = self._values.get("dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        '''
        result = self._values.get("dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def equal(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionEqual"]:
        '''equal block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        '''
        result = self._values.get("equal")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionEqual"], result)

    @builtins.property
    def greater_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionGreaterThan"]:
        '''greater_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        '''
        result = self._values.get("greater_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionGreaterThan"], result)

    @builtins.property
    def less_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionLessThan"]:
        '''less_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        '''
        result = self._values.get("less_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionLessThan"], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimension(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__21b93cb020f4488085c2e3e4907cd7601e1c753cce54f191017e7b2e38339355)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7204641bd9c4fcf1dce4284d93b6407a2453d1f2705dd0c3bae92d762b3345c7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionEqual",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionEqual:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionEqual(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionEqualOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionEqualOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9475fc4072f10d12c0678b5c3029e1865052b9e99af0755381c3ed3cfc21298a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionEqual], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionEqual],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d879bf1f2ec80ed3fee81af5852568f36466f3006f510d4b3a7426c206f4caae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionGreaterThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionGreaterThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionGreaterThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionGreaterThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionGreaterThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a0108f4427b1e7eb12f759aceff679f68e3acb30446b659eb6dab1552c308a8f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionGreaterThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionGreaterThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f331bc8a8e2befd216ef0ac473ef0fce0f99cf50f5eb578dbf7f97ed502220f0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionLessThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionLessThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionLessThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionLessThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionLessThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d833ac858f6e6b82a5c53d6f4eea702e4bace54e211f817d8bc2532e38983ede)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionLessThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionLessThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__20b55bbbb1b28579510f55659e587e118b797d4f06c8643714c48855def0226a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__69eede250cb2a64f2f1c835913c5e2ba5089d67fde509ae1dd2fa88f9d619eaa)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aee02f8e4721f01503ccfb20821ee369d592ef585b2a98d4f4af68c053f5831a)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__56f6218eb91baef25e023236d883f9467affe9036d63a1ff83537774459b18d3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__96c4d5818913f3f8002aaf8486cdbe82b4d73853a2decf57e9c0a60ea36c3993)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ec01aca5e8cc9ac733d758a56f7e8ff59b0ba95f71f65d8a2f604d77d6672e5a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimension]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimension]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__655c0fc09f3c3fc44ebbaf059fee2bd673707d2d20793c33d11edc5698b6af88)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6aa67970903068326c974573314201ada3cbf5db0c85549828fc3130acebe067)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putEqual")
    def put_equal(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionEqual()

        return typing.cast(None, jsii.invoke(self, "putEqual", [value]))

    @jsii.member(jsii_name="putGreaterThan")
    def put_greater_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionGreaterThan()

        return typing.cast(None, jsii.invoke(self, "putGreaterThan", [value]))

    @jsii.member(jsii_name="putLessThan")
    def put_less_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionLessThan()

        return typing.cast(None, jsii.invoke(self, "putLessThan", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetDimension")
    def reset_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimension", []))

    @jsii.member(jsii_name="resetDimensionVar")
    def reset_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimensionVar", []))

    @jsii.member(jsii_name="resetEqual")
    def reset_equal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEqual", []))

    @jsii.member(jsii_name="resetGreaterThan")
    def reset_greater_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGreaterThan", []))

    @jsii.member(jsii_name="resetLessThan")
    def reset_less_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLessThan", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="equal")
    def equal(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionEqualOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionEqualOutputReference, jsii.get(self, "equal"))

    @builtins.property
    @jsii.member(jsii_name="greaterThan")
    def greater_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionGreaterThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionGreaterThanOutputReference, jsii.get(self, "greaterThan"))

    @builtins.property
    @jsii.member(jsii_name="lessThan")
    def less_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionLessThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionLessThanOutputReference, jsii.get(self, "lessThan"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionInput")
    def dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionVarInput")
    def dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="equalInput")
    def equal_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionEqual], jsii.get(self, "equalInput"))

    @builtins.property
    @jsii.member(jsii_name="greaterThanInput")
    def greater_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionGreaterThan], jsii.get(self, "greaterThanInput"))

    @builtins.property
    @jsii.member(jsii_name="lessThanInput")
    def less_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionLessThan], jsii.get(self, "lessThanInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="dimension")
    def dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimension"))

    @dimension.setter
    def dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c22d30c2cf9713aa557a5120b5afa52bb4de274052af2edcc7a1867313ed7259)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimension", value)

    @builtins.property
    @jsii.member(jsii_name="dimensionVar")
    def dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimensionVar"))

    @dimension_var.setter
    def dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__63bf625fad0a592f70513b17aa94c906f9db41c87f5b44ce6865211e7b8fa5b7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ff790ea7c80609f0757eb30d5188dd276f02e4c32bff85f415fe4bcdea8a61b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__634a1c6cea9ac6de2eb0095e050403e7ce4fc19a2df2d2864ff56c0efbe4b961)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimension]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimension]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimension]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__302c1be6718c1dbf838390a088094821fc6ca40875d22ebb4d36a4bfc15e33ab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientation",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "landscape": "landscape",
        "portrait": "portrait",
        "square": "square",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientation:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        landscape: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationLandscape", typing.Dict[builtins.str, typing.Any]]] = None,
        portrait: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationPortrait", typing.Dict[builtins.str, typing.Any]]] = None,
        square: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationSquare", typing.Dict[builtins.str, typing.Any]]] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param landscape: landscape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        :param portrait: portrait block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        :param square: square block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationDefault(**default)
        if isinstance(landscape, dict):
            landscape = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationLandscape(**landscape)
        if isinstance(portrait, dict):
            portrait = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationPortrait(**portrait)
        if isinstance(square, dict):
            square = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationSquare(**square)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__561ef493047e29cc7f7515518af2a1f04505eb94bdd682cd29d3be4f161052ce)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument landscape", value=landscape, expected_type=type_hints["landscape"])
            check_type(argname="argument portrait", value=portrait, expected_type=type_hints["portrait"])
            check_type(argname="argument square", value=square, expected_type=type_hints["square"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if landscape is not None:
            self._values["landscape"] = landscape
        if portrait is not None:
            self._values["portrait"] = portrait
        if square is not None:
            self._values["square"] = square

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationDefault"], result)

    @builtins.property
    def landscape(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationLandscape"]:
        '''landscape block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        '''
        result = self._values.get("landscape")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationLandscape"], result)

    @builtins.property
    def portrait(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationPortrait"]:
        '''portrait block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        '''
        result = self._values.get("portrait")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationPortrait"], result)

    @builtins.property
    def square(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationSquare"]:
        '''square block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        result = self._values.get("square")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationSquare"], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dcf9aeb00ed676a132ac5c2e512eebb479c9ea58a05a567b72e2282df10a22c1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__28a597a3940624875b3a5f76c3b5656def226292e91af133e8ad3b00cdf234e2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationLandscape",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationLandscape:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationLandscape(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationLandscapeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationLandscapeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1250ee374df0879806fe99103e2058c78588cebccbf4e4bb51a4efa70cff7d80)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationLandscape], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationLandscape],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7a708fee843503f418c20f2a23fd4c469632cb4e6b7ff79495e75d8e3976aedf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ab5e0e66d35f670add51f4e5211048c0fbaa117c3a91687a15251476c873162)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1e1501b9f341e38629d597845035093e513d0d33b0e1b99350fbdef0afc7c519)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__79473a7d976f114fd22f55a8f65b43e44cd090e17e506f002d231852c36a5037)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5c4db52846664ffb46b90c5b498cd034f2896c8aab40358e78dabd9e73ddcaa6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__04ff05fa6826ed9eedeffad771126f866c2ab682fb6af6d1d5a22c5c6731197e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientation]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientation]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ab1a9fc1d58f3ea00b328af1ef7c9dd73bf8ea0bfd05864983ac0d973203b3b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__726171a809d2b3a6776aace04849fcf2a5d5105217e4acaf97ea4d45b8e83cb3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putLandscape")
    def put_landscape(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationLandscape()

        return typing.cast(None, jsii.invoke(self, "putLandscape", [value]))

    @jsii.member(jsii_name="putPortrait")
    def put_portrait(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationPortrait()

        return typing.cast(None, jsii.invoke(self, "putPortrait", [value]))

    @jsii.member(jsii_name="putSquare")
    def put_square(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationSquare()

        return typing.cast(None, jsii.invoke(self, "putSquare", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetLandscape")
    def reset_landscape(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLandscape", []))

    @jsii.member(jsii_name="resetPortrait")
    def reset_portrait(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPortrait", []))

    @jsii.member(jsii_name="resetSquare")
    def reset_square(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSquare", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="landscape")
    def landscape(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationLandscapeOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationLandscapeOutputReference, jsii.get(self, "landscape"))

    @builtins.property
    @jsii.member(jsii_name="portrait")
    def portrait(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationPortraitOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationPortraitOutputReference", jsii.get(self, "portrait"))

    @builtins.property
    @jsii.member(jsii_name="square")
    def square(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationSquareOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationSquareOutputReference", jsii.get(self, "square"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="landscapeInput")
    def landscape_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationLandscape], jsii.get(self, "landscapeInput"))

    @builtins.property
    @jsii.member(jsii_name="portraitInput")
    def portrait_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationPortrait"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationPortrait"], jsii.get(self, "portraitInput"))

    @builtins.property
    @jsii.member(jsii_name="squareInput")
    def square_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationSquare"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationSquare"], jsii.get(self, "squareInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientation]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientation]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientation]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f3b9744af2facb0aa08e6f6133bec8b16050b9a9196fa9b75fb0673ea44b4779)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationPortrait",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationPortrait:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationPortrait(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationPortraitOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationPortraitOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d9ba3393b80b5e8dee0dafe509c662048d42b1533f9cd8cba7490bc3d50b007)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationPortrait]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationPortrait], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationPortrait],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__11a075667836eb93878b501f54487e2b5df8015e24a4f14b4b3f94897e2d9ffa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationSquare",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationSquare:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationSquare(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationSquareOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationSquareOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1e6433efe9bd06d2bd4eaefa25e7363878b69ebd93fceb754ecbfd4438aa8dd2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationSquare]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationSquare], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationSquare],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__88f3a112cdbd01d1fd6c616ae256863e5c4b4bd4fc96a8dfbb478968033bc9f3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeMaxColors",
    jsii_struct_bases=[],
    name_mapping={"colors": "colors", "colors_var": "colorsVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeMaxColors:
    def __init__(
        self,
        *,
        colors: typing.Optional[builtins.str] = None,
        colors_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param colors: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        :param colors_var: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__09470c5e5680028ca88615fc87b4739022f6603e75372e37e9897611ed96bc48)
            check_type(argname="argument colors", value=colors, expected_type=type_hints["colors"])
            check_type(argname="argument colors_var", value=colors_var, expected_type=type_hints["colors_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if colors is not None:
            self._values["colors"] = colors
        if colors_var is not None:
            self._values["colors_var"] = colors_var

    @builtins.property
    def colors(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        '''
        result = self._values.get("colors")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def colors_var(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        result = self._values.get("colors_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeMaxColors(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeMaxColorsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeMaxColorsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__32952473ebf8e2a072eabe0a2c9f72ece6276d6ed75e062ec75b2f15c7b741fc)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeMaxColorsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d1c77ed9c422a143913b1aa3fa4da08a96d386776443c20ec7ef3a3f9f81c2f6)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeMaxColorsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e74fa66f706dead82e618ae6b81f5dfb385f3b9aac657b3354b4a573dd14e9ed)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6996b33b922a3ea60f677266295e8b3499db986df1f891062c3e9a093d653c44)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f2017cc26c697ab6eefa5bb748689d09607392c502f9f7359b930a3fad82ead)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeMaxColors]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeMaxColors]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__58513a844b8a323004300176dce7df27a58a70876cd545a677489e93865b3288)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeMaxColorsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeMaxColorsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__18a0d8d33652bd578c550c8e9890f0049aa510a64a8d84e0e950ae198bd9ef82)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColors")
    def reset_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColors", []))

    @jsii.member(jsii_name="resetColorsVar")
    def reset_colors_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorsVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorsInput")
    def colors_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsInput"))

    @builtins.property
    @jsii.member(jsii_name="colorsVarInput")
    def colors_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsVarInput"))

    @builtins.property
    @jsii.member(jsii_name="colors")
    def colors(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colors"))

    @colors.setter
    def colors(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb6cbcc76bfae0467ec10fdb2fc21bd50e6266cae7259e1f2dd1b0199859b697)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colors", value)

    @builtins.property
    @jsii.member(jsii_name="colorsVar")
    def colors_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorsVar"))

    @colors_var.setter
    def colors_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e62882ecdc6dc7e6bf76046add6472796be07493c6df2d97dfb3a115403974fc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorsVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeMaxColors]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeMaxColors]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeMaxColors]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f213bb6bd94f5e3099239b3cb46061f75bf877d6863d40c119a5671d1b2f2c71)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeMirror",
    jsii_struct_bases=[],
    name_mapping={
        "horizontal": "horizontal",
        "horizontal_var": "horizontalVar",
        "vertical": "vertical",
        "vertical_var": "verticalVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeMirror:
    def __init__(
        self,
        *,
        horizontal: typing.Optional[builtins.str] = None,
        horizontal_var: typing.Optional[builtins.str] = None,
        vertical: typing.Optional[builtins.str] = None,
        vertical_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param horizontal: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        :param horizontal_var: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        :param vertical: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        :param vertical_var: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cdb10acadc9d472d9b576eedae6cc46ba2f1e26970e9b7e8447ceea94b61453f)
            check_type(argname="argument horizontal", value=horizontal, expected_type=type_hints["horizontal"])
            check_type(argname="argument horizontal_var", value=horizontal_var, expected_type=type_hints["horizontal_var"])
            check_type(argname="argument vertical", value=vertical, expected_type=type_hints["vertical"])
            check_type(argname="argument vertical_var", value=vertical_var, expected_type=type_hints["vertical_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if horizontal is not None:
            self._values["horizontal"] = horizontal
        if horizontal_var is not None:
            self._values["horizontal_var"] = horizontal_var
        if vertical is not None:
            self._values["vertical"] = vertical
        if vertical_var is not None:
            self._values["vertical_var"] = vertical_var

    @builtins.property
    def horizontal(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        '''
        result = self._values.get("horizontal")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def horizontal_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        '''
        result = self._values.get("horizontal_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        '''
        result = self._values.get("vertical")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        result = self._values.get("vertical_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeMirror(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeMirrorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeMirrorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__50f1825c84a28d6985352e167e89b4d13df0294a1887c161259197744a043214)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeMirrorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b538387abf65c56fe440d591bebed657a4c73fe7c578edcdbeca4489331f9c19)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeMirrorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a15dde6d5184187250380dd1adaa3f5b5dfb483806e674e0d0ee9e8f0f2248c3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__63000d881450089a459d57711a57a4f79dd171267ca14167ce0c3544cb481658)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__49b1fba0beb16800498fc598af1cd5659410b6abd07d4e283c201d0c8452e553)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeMirror]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeMirror]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__12bbb0eeb76f53beff40dd9488412ea0f221e1ee514aa157929e6f5ae2fa72a8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeMirrorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeMirrorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1440960f832165649dcbe0e5c29dda520d9f21cd1db8491bc55d83b96b60dad5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHorizontal")
    def reset_horizontal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontal", []))

    @jsii.member(jsii_name="resetHorizontalVar")
    def reset_horizontal_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontalVar", []))

    @jsii.member(jsii_name="resetVertical")
    def reset_vertical(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVertical", []))

    @jsii.member(jsii_name="resetVerticalVar")
    def reset_vertical_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVerticalVar", []))

    @builtins.property
    @jsii.member(jsii_name="horizontalInput")
    def horizontal_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontalVarInput")
    def horizontal_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalInput")
    def vertical_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalVarInput")
    def vertical_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontal")
    def horizontal(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontal"))

    @horizontal.setter
    def horizontal(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f86dc23cf197e641039d783374165fbb27505854a2fc6539de3f4b9f28f6db8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontal", value)

    @builtins.property
    @jsii.member(jsii_name="horizontalVar")
    def horizontal_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontalVar"))

    @horizontal_var.setter
    def horizontal_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__287a1819bcc5dd9e7cc45f6413d6673c2380470c997fb8b5f627b27810e1352d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontalVar", value)

    @builtins.property
    @jsii.member(jsii_name="vertical")
    def vertical(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "vertical"))

    @vertical.setter
    def vertical(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__94d74dfb28f45785761cd7dec81ae43cabb30a8394c8f8480c024f9234bfe98f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "vertical", value)

    @builtins.property
    @jsii.member(jsii_name="verticalVar")
    def vertical_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "verticalVar"))

    @vertical_var.setter
    def vertical_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4d00543572ea9130a5bee6fd1bb344e7bfc6555d1d14590955c08feb4e9584ae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "verticalVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeMirror]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeMirror]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeMirror]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1973779a5af723e21a5cc4cce700bc3d7b7c43ffb8f1d833d7d8065612817847)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeMonoHue",
    jsii_struct_bases=[],
    name_mapping={"hue": "hue", "hue_var": "hueVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeMonoHue:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e5e744f5ee69170c076947ac4bf77933da096e2a471758043e1f18d4ae78043f)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeMonoHue(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeMonoHueList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeMonoHueList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b68ec60956d8f9fb130872745deffbd1264f4c0dbe5438c5c433889c6c5b6763)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeMonoHueOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__17fa721b9e7cb55a3c18bd21f8928ce167321683c834b819efb09ae4c3baf1c2)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeMonoHueOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cfd02c6bcfb8e256a26e4bc3a82da4dd749f45937b9e69ecc36ea4ede9d201cf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f6d5cd73f5cab12ec4c1cf3186706b353d0c21142474055ee1aa474fadf07a19)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ded0c965668bd9b22c0e76af4ee58732fe7990be8cd33451f293b741816f007)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeMonoHue]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeMonoHue]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e9a781ce6268fdd3801b0ccde7a6de6faf6015cefabdffc93d891e1e31a5901b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeMonoHueOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeMonoHueOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8f2d2f01e056aad84d0c6b1a3b51b8e572ae34826a8549e9eb42eebe0dc74b64)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b97b1e36b799f69af662326e783b387027102c734e4137d82242855764946e51)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cfdbc8d5ab69363c4e7ef4699afa79fde67547907295397c3dd75ec3ef360ebc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeMonoHue]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeMonoHue]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeMonoHue]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5395a38db0eca569b079f0175bd3d00d490b2f6795c79aaf55963d46e0b0a951)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeOpacity",
    jsii_struct_bases=[],
    name_mapping={"opacity": "opacity", "opacity_var": "opacityVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeOpacity:
    def __init__(
        self,
        *,
        opacity: typing.Optional[builtins.str] = None,
        opacity_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param opacity: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param opacity_var: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0db21bcc249fb966c4d44d2b7ba241614eb1dd70d22cc0c4aa8d7c097dde356d)
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument opacity_var", value=opacity_var, expected_type=type_hints["opacity_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if opacity is not None:
            self._values["opacity"] = opacity
        if opacity_var is not None:
            self._values["opacity_var"] = opacity_var

    @builtins.property
    def opacity(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def opacity_var(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        result = self._values.get("opacity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeOpacity(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeOpacityList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeOpacityList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3c37b9ed17945446ef0f982a2c48f9de53f1f124e3dcd9fe9f37bfd5e7db0eaa)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeOpacityOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df87905d076e96aecd49d906182ac3e142dcb58faa5828b3026534961f62e32e)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeOpacityOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e8f5bdefa9414c326f61e6a6bca093916bc2cd5749325abce1af68aaa696a2bd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8419913764615c4325ed67eeaefee7a3fa2cc39a203c07d498e086c1dabe3204)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3d2adf09e99aef75806f66339a6a9be5bcdf03ed688a1208e5b883a00bea656e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeOpacity]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeOpacity]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e0755af0ad16ba117194666fe49cfb36a16d0aae581aa9bc1ddf4c0353b1c3de)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeOpacityOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeOpacityOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e0a577d94efe87d5a8f0a5e19a46969a57e4777f53105df5469b5eb12531af1e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetOpacityVar")
    def reset_opacity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacityVar", []))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityVarInput")
    def opacity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacity"))

    @opacity.setter
    def opacity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b55495e3c3fa85488e224678b845cf0136bd24df6e85e8159215dab7202665f8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacity", value)

    @builtins.property
    @jsii.member(jsii_name="opacityVar")
    def opacity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacityVar"))

    @opacity_var.setter
    def opacity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3daa50cfd6425959cf0fb10f9f82ed02e2ddeb45f0e28a21d7ba5a19f89979f6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacityVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeOpacity]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeOpacity]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeOpacity]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f1da4904232ca580cafa00a493063c5acd4cf8678531e8302ca666315718f095)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__264b3de9706f13ac5582a34a11479b5d76850c19231163896ce7ccc0dfa883b5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putBackgroundColor")
    def put_background_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__269877fdc4b1037ad6f023d15459bb731a83c14d8af12d1c24881ff63f209faa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBackgroundColor", [value]))

    @jsii.member(jsii_name="putBlur")
    def put_blur(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeBlur, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4466a241bda24c9a8ddd8ccbb21a88e0714f2bc446b1ff9b58cc5d89424ed592)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBlur", [value]))

    @jsii.member(jsii_name="putChromaKey")
    def put_chroma_key(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeChromaKey, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eb1ed825a057184223f7d02247260fbed4b0c3f96ae0a2e526b3f5cc8faa81be)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putChromaKey", [value]))

    @jsii.member(jsii_name="putComposite")
    def put_composite(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeComposite, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__db17d11808df2c682e18c3b9b6753cd753a200b088120e014c4dc4a3fb1d8fcb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putComposite", [value]))

    @jsii.member(jsii_name="putCompound")
    def put_compound(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeCompound, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1a4425548286ba2c9ad0646b4af56eae644ddbb669ef050596c64599c4b27b24)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCompound", [value]))

    @jsii.member(jsii_name="putContrast")
    def put_contrast(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeContrast, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__98eb26b7ef57eb478a0ca3c7e94e51e6ca65ef3daed5063815a748dafe2ca561)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putContrast", [value]))

    @jsii.member(jsii_name="putGoop")
    def put_goop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeGoop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0f35d1430aa196644e5c68d7ed2a254a4d34edf398e45f9968692c4c22d01477)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGoop", [value]))

    @jsii.member(jsii_name="putGrayscale")
    def put_grayscale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeGrayscale, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a353c1d3ee17ab87cef139e3614e59fa41cd6d88045ed67d235e48f5db4ee45)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGrayscale", [value]))

    @jsii.member(jsii_name="putHsl")
    def put_hsl(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeHsl, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7c751b41e06f604bf4b72d13ce8f75a6ef2a5508c60fab4b9e0ed2043c4d4fc2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsl", [value]))

    @jsii.member(jsii_name="putHsv")
    def put_hsv(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeHsv, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d6ca6f8f2d73e7f117f39c3264098f3ad72bca7a0e0ae2c7b239b069a2b8862)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsv", [value]))

    @jsii.member(jsii_name="putIfDimension")
    def put_if_dimension(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimension, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f53c66889c867622f94662e82676f0865f791e5a5d90ca165bae6b6577e85a6b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfDimension", [value]))

    @jsii.member(jsii_name="putIfOrientation")
    def put_if_orientation(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8f4d685b05d8342ff7ee6f420c52513c89f0cb061594533a92632e709fb0adb7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfOrientation", [value]))

    @jsii.member(jsii_name="putMaxColors")
    def put_max_colors(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeMaxColors, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f8c8146c67cbdbfa127d762718024dbef0c9da634ebd4d1119438d12ce69657c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMaxColors", [value]))

    @jsii.member(jsii_name="putMirror")
    def put_mirror(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeMirror, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5da9079f554efd1b266864796ad9cc8b5d74c7c428620fd6243af2b88d81b18f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMirror", [value]))

    @jsii.member(jsii_name="putMonoHue")
    def put_mono_hue(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeMonoHue, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6697519e22bec5321fe4a665bd388888a735b095eef3e18a7da432905f955f4f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMonoHue", [value]))

    @jsii.member(jsii_name="putOpacity")
    def put_opacity(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeOpacity, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a232b7e8f991fc652c32f0dd3fb28de3334e17e9bbaea29e49c7cf5a70ce50d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putOpacity", [value]))

    @jsii.member(jsii_name="putRemoveColor")
    def put_remove_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeRemoveColor", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dcd3823104eee329d4a3116fa9e4082f829735d2d402906842d67af382978f6a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRemoveColor", [value]))

    @jsii.member(jsii_name="putUnsharpMask")
    def put_unsharp_mask(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeUnsharpMask", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ae2978eb59d7828fd8e48b00cd8e7242d1c0a82d561a29a4783e4e597c044656)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putUnsharpMask", [value]))

    @jsii.member(jsii_name="resetBackgroundColor")
    def reset_background_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBackgroundColor", []))

    @jsii.member(jsii_name="resetBlur")
    def reset_blur(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBlur", []))

    @jsii.member(jsii_name="resetChromaKey")
    def reset_chroma_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChromaKey", []))

    @jsii.member(jsii_name="resetComposite")
    def reset_composite(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetComposite", []))

    @jsii.member(jsii_name="resetCompound")
    def reset_compound(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCompound", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetGoop")
    def reset_goop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGoop", []))

    @jsii.member(jsii_name="resetGrayscale")
    def reset_grayscale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGrayscale", []))

    @jsii.member(jsii_name="resetHsl")
    def reset_hsl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsl", []))

    @jsii.member(jsii_name="resetHsv")
    def reset_hsv(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsv", []))

    @jsii.member(jsii_name="resetIfDimension")
    def reset_if_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfDimension", []))

    @jsii.member(jsii_name="resetIfOrientation")
    def reset_if_orientation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfOrientation", []))

    @jsii.member(jsii_name="resetMaxColors")
    def reset_max_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxColors", []))

    @jsii.member(jsii_name="resetMirror")
    def reset_mirror(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMirror", []))

    @jsii.member(jsii_name="resetMonoHue")
    def reset_mono_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonoHue", []))

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetRemoveColor")
    def reset_remove_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRemoveColor", []))

    @jsii.member(jsii_name="resetUnsharpMask")
    def reset_unsharp_mask(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUnsharpMask", []))

    @builtins.property
    @jsii.member(jsii_name="backgroundColor")
    def background_color(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeBackgroundColorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeBackgroundColorList, jsii.get(self, "backgroundColor"))

    @builtins.property
    @jsii.member(jsii_name="blur")
    def blur(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeBlurList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeBlurList, jsii.get(self, "blur"))

    @builtins.property
    @jsii.member(jsii_name="chromaKey")
    def chroma_key(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeChromaKeyList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeChromaKeyList, jsii.get(self, "chromaKey"))

    @builtins.property
    @jsii.member(jsii_name="composite")
    def composite(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeCompositeList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeCompositeList, jsii.get(self, "composite"))

    @builtins.property
    @jsii.member(jsii_name="compound")
    def compound(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeCompoundList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeCompoundList, jsii.get(self, "compound"))

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeContrastList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeContrastList, jsii.get(self, "contrast"))

    @builtins.property
    @jsii.member(jsii_name="goop")
    def goop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeGoopList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeGoopList, jsii.get(self, "goop"))

    @builtins.property
    @jsii.member(jsii_name="grayscale")
    def grayscale(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeGrayscaleList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeGrayscaleList, jsii.get(self, "grayscale"))

    @builtins.property
    @jsii.member(jsii_name="hsl")
    def hsl(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeHslList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeHslList, jsii.get(self, "hsl"))

    @builtins.property
    @jsii.member(jsii_name="hsv")
    def hsv(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeHsvList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeHsvList, jsii.get(self, "hsv"))

    @builtins.property
    @jsii.member(jsii_name="ifDimension")
    def if_dimension(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionList, jsii.get(self, "ifDimension"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientation")
    def if_orientation(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationList, jsii.get(self, "ifOrientation"))

    @builtins.property
    @jsii.member(jsii_name="maxColors")
    def max_colors(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeMaxColorsList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeMaxColorsList, jsii.get(self, "maxColors"))

    @builtins.property
    @jsii.member(jsii_name="mirror")
    def mirror(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeMirrorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeMirrorList, jsii.get(self, "mirror"))

    @builtins.property
    @jsii.member(jsii_name="monoHue")
    def mono_hue(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeMonoHueList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeMonoHueList, jsii.get(self, "monoHue"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeOpacityList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeOpacityList, jsii.get(self, "opacity"))

    @builtins.property
    @jsii.member(jsii_name="removeColor")
    def remove_color(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeRemoveColorList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeRemoveColorList", jsii.get(self, "removeColor"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMask")
    def unsharp_mask(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeUnsharpMaskList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeUnsharpMaskList", jsii.get(self, "unsharpMask"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColorInput")
    def background_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeBackgroundColor]]], jsii.get(self, "backgroundColorInput"))

    @builtins.property
    @jsii.member(jsii_name="blurInput")
    def blur_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeBlur]]], jsii.get(self, "blurInput"))

    @builtins.property
    @jsii.member(jsii_name="chromaKeyInput")
    def chroma_key_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeChromaKey]]], jsii.get(self, "chromaKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="compositeInput")
    def composite_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeComposite]]], jsii.get(self, "compositeInput"))

    @builtins.property
    @jsii.member(jsii_name="compoundInput")
    def compound_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeCompound]]], jsii.get(self, "compoundInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeContrast]]], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="goopInput")
    def goop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeGoop]]], jsii.get(self, "goopInput"))

    @builtins.property
    @jsii.member(jsii_name="grayscaleInput")
    def grayscale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeGrayscale]]], jsii.get(self, "grayscaleInput"))

    @builtins.property
    @jsii.member(jsii_name="hslInput")
    def hsl_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeHsl]]], jsii.get(self, "hslInput"))

    @builtins.property
    @jsii.member(jsii_name="hsvInput")
    def hsv_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeHsv]]], jsii.get(self, "hsvInput"))

    @builtins.property
    @jsii.member(jsii_name="ifDimensionInput")
    def if_dimension_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimension]]], jsii.get(self, "ifDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientationInput")
    def if_orientation_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientation]]], jsii.get(self, "ifOrientationInput"))

    @builtins.property
    @jsii.member(jsii_name="maxColorsInput")
    def max_colors_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeMaxColors]]], jsii.get(self, "maxColorsInput"))

    @builtins.property
    @jsii.member(jsii_name="mirrorInput")
    def mirror_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeMirror]]], jsii.get(self, "mirrorInput"))

    @builtins.property
    @jsii.member(jsii_name="monoHueInput")
    def mono_hue_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeMonoHue]]], jsii.get(self, "monoHueInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeOpacity]]], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="removeColorInput")
    def remove_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeRemoveColor"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeRemoveColor"]]], jsii.get(self, "removeColorInput"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMaskInput")
    def unsharp_mask_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeUnsharpMask"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeUnsharpMask"]]], jsii.get(self, "unsharpMaskInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscape], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscape],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f424b2d6362a48c32cef94479efc0f4c9c228e04315e89086d2f3646d8e9128e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeRemoveColor",
    jsii_struct_bases=[],
    name_mapping={
        "color": "color",
        "color_var": "colorVar",
        "feather": "feather",
        "feather_var": "featherVar",
        "tolerance": "tolerance",
        "tolerance_var": "toleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeRemoveColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
        feather: typing.Optional[builtins.str] = None,
        feather_var: typing.Optional[builtins.str] = None,
        tolerance: typing.Optional[builtins.str] = None,
        tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        :param feather: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        :param feather_var: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        :param tolerance: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        :param tolerance_var: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3e41562b91f1664b2b1b501b36c98bfe125df3e6f1b7f736a34f1424d1775ac7)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
            check_type(argname="argument feather", value=feather, expected_type=type_hints["feather"])
            check_type(argname="argument feather_var", value=feather_var, expected_type=type_hints["feather_var"])
            check_type(argname="argument tolerance", value=tolerance, expected_type=type_hints["tolerance"])
            check_type(argname="argument tolerance_var", value=tolerance_var, expected_type=type_hints["tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var
        if feather is not None:
            self._values["feather"] = feather
        if feather_var is not None:
            self._values["feather_var"] = feather_var
        if tolerance is not None:
            self._values["tolerance"] = tolerance
        if tolerance_var is not None:
            self._values["tolerance_var"] = tolerance_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        '''
        result = self._values.get("feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather_var(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        '''
        result = self._values.get("feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        '''
        result = self._values.get("tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance_var(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        result = self._values.get("tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeRemoveColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeRemoveColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeRemoveColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__81d314e46b53fe84a70175dbc450eb40bc25765ed6d895929115e8c8f10744fa)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeRemoveColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3bbfe8e9c14fa10f2abc2c8f92da2e5984565b154bba2e69ceb361cb3f06e52f)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeRemoveColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0a98e284707ab169f0d3ac8c522764feef0f2e895bbb18c2bb2c7cceb4672b33)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b8f56ef19993c96bd578b26d2f423b6ddbb14b19cc4ed44aff1fb053772730c9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3b272bf4da097ed4470bd9cc18964294b11340fec8e450bee50fddf32d89014b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeRemoveColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeRemoveColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeRemoveColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__044323236ddacc6cddb8daf8091a930e246a82dc2a1e78f0e17b32b2a259e6d0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeRemoveColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeRemoveColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__855950f89c60b5515bfe60be3eafca838b130a7c8bcfae5b434f286d52db1248)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @jsii.member(jsii_name="resetFeather")
    def reset_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeather", []))

    @jsii.member(jsii_name="resetFeatherVar")
    def reset_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatherVar", []))

    @jsii.member(jsii_name="resetTolerance")
    def reset_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTolerance", []))

    @jsii.member(jsii_name="resetToleranceVar")
    def reset_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featherInput")
    def feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherInput"))

    @builtins.property
    @jsii.member(jsii_name="featherVarInput")
    def feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceInput")
    def tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceVarInput")
    def tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__26866ef6e50a9b80324ca998147acfac5124039473a1274d548bcf2a861e9664)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b3119883e59de86658294613c31393beea294c94bfcd8b4a796d84d8ecf1e01b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="feather")
    def feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "feather"))

    @feather.setter
    def feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__95bab1a391503f2e5559dc61149612a3250f206c1dff87548edd0003f836c5f7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "feather", value)

    @builtins.property
    @jsii.member(jsii_name="featherVar")
    def feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featherVar"))

    @feather_var.setter
    def feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e652dad9a27655849e9608b1cb786d72dc5a288f0f7801d0fe8170f9418e2626)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featherVar", value)

    @builtins.property
    @jsii.member(jsii_name="tolerance")
    def tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tolerance"))

    @tolerance.setter
    def tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__11bedfb3550f0bddc5094ba4cf28944c003e0d73445cead2a5d8d1cca0b3f066)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tolerance", value)

    @builtins.property
    @jsii.member(jsii_name="toleranceVar")
    def tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "toleranceVar"))

    @tolerance_var.setter
    def tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5b61baec40fb66163f0a0c3b18b68abf46a41c83ba954e2a57baf9872fc8bbf2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "toleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeRemoveColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeRemoveColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeRemoveColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__554a9d01c0b6de5996b8a7a4358b13a7ab554cca85e1a63d6033d58970ba1b6f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeUnsharpMask",
    jsii_struct_bases=[],
    name_mapping={
        "gain": "gain",
        "gain_var": "gainVar",
        "sigma": "sigma",
        "sigma_var": "sigmaVar",
        "threshold": "threshold",
        "threshold_var": "thresholdVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeUnsharpMask:
    def __init__(
        self,
        *,
        gain: typing.Optional[builtins.str] = None,
        gain_var: typing.Optional[builtins.str] = None,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
        threshold: typing.Optional[builtins.str] = None,
        threshold_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param gain: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        :param gain_var: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        :param sigma: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        :param threshold: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        :param threshold_var: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac0db8c1a2f9fd30f342b0cf310c634b9828bef620ef5b94152c564de4d8724a)
            check_type(argname="argument gain", value=gain, expected_type=type_hints["gain"])
            check_type(argname="argument gain_var", value=gain_var, expected_type=type_hints["gain_var"])
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
            check_type(argname="argument threshold", value=threshold, expected_type=type_hints["threshold"])
            check_type(argname="argument threshold_var", value=threshold_var, expected_type=type_hints["threshold_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if gain is not None:
            self._values["gain"] = gain
        if gain_var is not None:
            self._values["gain_var"] = gain_var
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var
        if threshold is not None:
            self._values["threshold"] = threshold
        if threshold_var is not None:
            self._values["threshold_var"] = threshold_var

    @builtins.property
    def gain(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        '''
        result = self._values.get("gain")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gain_var(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        '''
        result = self._values.get("gain_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        '''
        result = self._values.get("threshold")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold_var(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        result = self._values.get("threshold_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeUnsharpMask(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeUnsharpMaskList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeUnsharpMaskList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ed95ef7f3749f1323cd86723b00f72661998fd13e06238d32e1f34362cb9e521)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeUnsharpMaskOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__230f946e7e667e1366245f88175cea1b6434f1b93c69c141cc7a693e7027245b)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeUnsharpMaskOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e94d602c6fbfce1821997dc0e26eff0b25cf2b4e449c72152bd6e55860a943d4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5e32435433a9397eb94a648eb4118c4a93db7a36f99ef5becd9d49853a2b4eab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7a4363844765b5631a9de37614f479e945b38ee0a1b1b0ed50f9c81ca04deff0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeUnsharpMask]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeUnsharpMask]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeUnsharpMask]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__42c75f9fc09264795447a7e1f4be3932b247187d37ca7117132890ac2594cb21)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeUnsharpMaskOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeUnsharpMaskOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fdea6e2870070c5a7d16209bd8ce47fb62d5fce9bc7c6428d489f88b85198981)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetGain")
    def reset_gain(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGain", []))

    @jsii.member(jsii_name="resetGainVar")
    def reset_gain_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGainVar", []))

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @jsii.member(jsii_name="resetThreshold")
    def reset_threshold(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThreshold", []))

    @jsii.member(jsii_name="resetThresholdVar")
    def reset_threshold_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThresholdVar", []))

    @builtins.property
    @jsii.member(jsii_name="gainInput")
    def gain_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainInput"))

    @builtins.property
    @jsii.member(jsii_name="gainVarInput")
    def gain_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdInput")
    def threshold_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdVarInput")
    def threshold_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gain")
    def gain(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gain"))

    @gain.setter
    def gain(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__387c81a564dae871ed15e41f2239d13c4f0af67d3687c96e3ccf7056251f3263)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gain", value)

    @builtins.property
    @jsii.member(jsii_name="gainVar")
    def gain_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gainVar"))

    @gain_var.setter
    def gain_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4d076eaf26f381da2b7d26af549ebd920bf049b3b7d45b722f30bc9b799fb2a1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gainVar", value)

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e10ba5de6bdd4a044f8466fc2e88a35a9588139b961019b5c5973193ad91cba9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dbef65f3bd3a19bd17382a9f2d05c20db9bedce22d91577b056cea7570ed84fa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="threshold")
    def threshold(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "threshold"))

    @threshold.setter
    def threshold(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__33a0ae21d9e9ba730421d48a40dfa83de006e103891f8a8d77b38c39aadf6924)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "threshold", value)

    @builtins.property
    @jsii.member(jsii_name="thresholdVar")
    def threshold_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "thresholdVar"))

    @threshold_var.setter
    def threshold_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ed2d5e9870bfe6f5fbf3b536e26904fe8626da7573303caa0362391d032a9dc7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "thresholdVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeUnsharpMask]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeUnsharpMask]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeUnsharpMask]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7152cb3d4ae3c96c24105b692eddf67a4461e3b8e65b32d497b61816494cac71)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ad7a24bb881b867e6a32bf62a9d9f4b65bb6419c2d3a3ac3fec285ad5326baa)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f5e28a8c1d4f29488479fda57f2e87448e13ad9dc01677f9f332726a22a1616f)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__68baf241d3a3c4cc5248214c287ad4a98b52a300400c22cae2410b76265644eb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b860cc0fa681f2020deba3b6328befbc005b9a4898aa5ce6e74afcd7591b1257)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c614771071431caca995a4c5bcd405b9b8771e4347cbd4ee14ce28c96ee3bb4c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientation]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientation]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4e286e9d4a55b137c60353deed284acb9a1feb55857bcf4a77c07051cced67ce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9b8c546ca62404b75ab58493a3f052cf95487d6038311ea5364404ce02d9e9b8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(
        self,
        *,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultMaxColors", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultMirror", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultMonoHue", typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultOpacity", typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultRemoveColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultUnsharpMask", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefault(
            background_color=background_color,
            blur=blur,
            chroma_key=chroma_key,
            composite=composite,
            compound=compound,
            contrast=contrast,
            goop=goop,
            grayscale=grayscale,
            hsl=hsl,
            hsv=hsv,
            if_dimension=if_dimension,
            if_orientation=if_orientation,
            max_colors=max_colors,
            mirror=mirror,
            mono_hue=mono_hue,
            opacity=opacity,
            remove_color=remove_color,
            unsharp_mask=unsharp_mask,
        )

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putLandscape")
    def put_landscape(
        self,
        *,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscape(
            background_color=background_color,
            blur=blur,
            chroma_key=chroma_key,
            composite=composite,
            compound=compound,
            contrast=contrast,
            goop=goop,
            grayscale=grayscale,
            hsl=hsl,
            hsv=hsv,
            if_dimension=if_dimension,
            if_orientation=if_orientation,
            max_colors=max_colors,
            mirror=mirror,
            mono_hue=mono_hue,
            opacity=opacity,
            remove_color=remove_color,
            unsharp_mask=unsharp_mask,
        )

        return typing.cast(None, jsii.invoke(self, "putLandscape", [value]))

    @jsii.member(jsii_name="putPortrait")
    def put_portrait(
        self,
        *,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitBackgroundColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitBlur", typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitChromaKey", typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitComposite", typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitCompound", typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitContrast", typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitGoop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitGrayscale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitHsl", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitHsv", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfDimension", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientation", typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitMaxColors", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitMirror", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitMonoHue", typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitOpacity", typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitRemoveColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitUnsharpMask", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortrait(
            background_color=background_color,
            blur=blur,
            chroma_key=chroma_key,
            composite=composite,
            compound=compound,
            contrast=contrast,
            goop=goop,
            grayscale=grayscale,
            hsl=hsl,
            hsv=hsv,
            if_dimension=if_dimension,
            if_orientation=if_orientation,
            max_colors=max_colors,
            mirror=mirror,
            mono_hue=mono_hue,
            opacity=opacity,
            remove_color=remove_color,
            unsharp_mask=unsharp_mask,
        )

        return typing.cast(None, jsii.invoke(self, "putPortrait", [value]))

    @jsii.member(jsii_name="putSquare")
    def put_square(
        self,
        *,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareBackgroundColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareBlur", typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareChromaKey", typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareComposite", typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareCompound", typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareContrast", typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareGoop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareGrayscale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareHsl", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareHsv", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfDimension", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfOrientation", typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareMaxColors", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareMirror", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareMonoHue", typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareOpacity", typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareRemoveColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareUnsharpMask", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquare(
            background_color=background_color,
            blur=blur,
            chroma_key=chroma_key,
            composite=composite,
            compound=compound,
            contrast=contrast,
            goop=goop,
            grayscale=grayscale,
            hsl=hsl,
            hsv=hsv,
            if_dimension=if_dimension,
            if_orientation=if_orientation,
            max_colors=max_colors,
            mirror=mirror,
            mono_hue=mono_hue,
            opacity=opacity,
            remove_color=remove_color,
            unsharp_mask=unsharp_mask,
        )

        return typing.cast(None, jsii.invoke(self, "putSquare", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetLandscape")
    def reset_landscape(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLandscape", []))

    @jsii.member(jsii_name="resetPortrait")
    def reset_portrait(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPortrait", []))

    @jsii.member(jsii_name="resetSquare")
    def reset_square(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSquare", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultOutputReference", jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="landscape")
    def landscape(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeOutputReference, jsii.get(self, "landscape"))

    @builtins.property
    @jsii.member(jsii_name="portrait")
    def portrait(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitOutputReference", jsii.get(self, "portrait"))

    @builtins.property
    @jsii.member(jsii_name="square")
    def square(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareOutputReference", jsii.get(self, "square"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="landscapeInput")
    def landscape_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscape], jsii.get(self, "landscapeInput"))

    @builtins.property
    @jsii.member(jsii_name="portraitInput")
    def portrait_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortrait"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortrait"], jsii.get(self, "portraitInput"))

    @builtins.property
    @jsii.member(jsii_name="squareInput")
    def square_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquare"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquare"], jsii.get(self, "squareInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientation]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientation]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientation]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1c273f1a08708c8b3d59caa76f1448b0c01aebd06c8f4884ce23c9a487aca855)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortrait",
    jsii_struct_bases=[],
    name_mapping={
        "background_color": "backgroundColor",
        "blur": "blur",
        "chroma_key": "chromaKey",
        "composite": "composite",
        "compound": "compound",
        "contrast": "contrast",
        "goop": "goop",
        "grayscale": "grayscale",
        "hsl": "hsl",
        "hsv": "hsv",
        "if_dimension": "ifDimension",
        "if_orientation": "ifOrientation",
        "max_colors": "maxColors",
        "mirror": "mirror",
        "mono_hue": "monoHue",
        "opacity": "opacity",
        "remove_color": "removeColor",
        "unsharp_mask": "unsharpMask",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortrait:
    def __init__(
        self,
        *,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitBackgroundColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitBlur", typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitChromaKey", typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitComposite", typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitCompound", typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitContrast", typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitGoop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitGrayscale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitHsl", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitHsv", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfDimension", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientation", typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitMaxColors", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitMirror", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitMonoHue", typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitOpacity", typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitRemoveColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitUnsharpMask", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c86b46852e40e9e2c2b66b84f0625a5fa053ca37165533e286abbb0ad8820cca)
            check_type(argname="argument background_color", value=background_color, expected_type=type_hints["background_color"])
            check_type(argname="argument blur", value=blur, expected_type=type_hints["blur"])
            check_type(argname="argument chroma_key", value=chroma_key, expected_type=type_hints["chroma_key"])
            check_type(argname="argument composite", value=composite, expected_type=type_hints["composite"])
            check_type(argname="argument compound", value=compound, expected_type=type_hints["compound"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument goop", value=goop, expected_type=type_hints["goop"])
            check_type(argname="argument grayscale", value=grayscale, expected_type=type_hints["grayscale"])
            check_type(argname="argument hsl", value=hsl, expected_type=type_hints["hsl"])
            check_type(argname="argument hsv", value=hsv, expected_type=type_hints["hsv"])
            check_type(argname="argument if_dimension", value=if_dimension, expected_type=type_hints["if_dimension"])
            check_type(argname="argument if_orientation", value=if_orientation, expected_type=type_hints["if_orientation"])
            check_type(argname="argument max_colors", value=max_colors, expected_type=type_hints["max_colors"])
            check_type(argname="argument mirror", value=mirror, expected_type=type_hints["mirror"])
            check_type(argname="argument mono_hue", value=mono_hue, expected_type=type_hints["mono_hue"])
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument remove_color", value=remove_color, expected_type=type_hints["remove_color"])
            check_type(argname="argument unsharp_mask", value=unsharp_mask, expected_type=type_hints["unsharp_mask"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if background_color is not None:
            self._values["background_color"] = background_color
        if blur is not None:
            self._values["blur"] = blur
        if chroma_key is not None:
            self._values["chroma_key"] = chroma_key
        if composite is not None:
            self._values["composite"] = composite
        if compound is not None:
            self._values["compound"] = compound
        if contrast is not None:
            self._values["contrast"] = contrast
        if goop is not None:
            self._values["goop"] = goop
        if grayscale is not None:
            self._values["grayscale"] = grayscale
        if hsl is not None:
            self._values["hsl"] = hsl
        if hsv is not None:
            self._values["hsv"] = hsv
        if if_dimension is not None:
            self._values["if_dimension"] = if_dimension
        if if_orientation is not None:
            self._values["if_orientation"] = if_orientation
        if max_colors is not None:
            self._values["max_colors"] = max_colors
        if mirror is not None:
            self._values["mirror"] = mirror
        if mono_hue is not None:
            self._values["mono_hue"] = mono_hue
        if opacity is not None:
            self._values["opacity"] = opacity
        if remove_color is not None:
            self._values["remove_color"] = remove_color
        if unsharp_mask is not None:
            self._values["unsharp_mask"] = unsharp_mask

    @builtins.property
    def background_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitBackgroundColor"]]]:
        '''background_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        '''
        result = self._values.get("background_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitBackgroundColor"]]], result)

    @builtins.property
    def blur(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitBlur"]]]:
        '''blur block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        '''
        result = self._values.get("blur")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitBlur"]]], result)

    @builtins.property
    def chroma_key(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitChromaKey"]]]:
        '''chroma_key block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        '''
        result = self._values.get("chroma_key")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitChromaKey"]]], result)

    @builtins.property
    def composite(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitComposite"]]]:
        '''composite block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        '''
        result = self._values.get("composite")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitComposite"]]], result)

    @builtins.property
    def compound(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitCompound"]]]:
        '''compound block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        '''
        result = self._values.get("compound")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitCompound"]]], result)

    @builtins.property
    def contrast(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitContrast"]]]:
        '''contrast block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitContrast"]]], result)

    @builtins.property
    def goop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitGoop"]]]:
        '''goop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        '''
        result = self._values.get("goop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitGoop"]]], result)

    @builtins.property
    def grayscale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitGrayscale"]]]:
        '''grayscale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        '''
        result = self._values.get("grayscale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitGrayscale"]]], result)

    @builtins.property
    def hsl(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitHsl"]]]:
        '''hsl block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        '''
        result = self._values.get("hsl")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitHsl"]]], result)

    @builtins.property
    def hsv(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitHsv"]]]:
        '''hsv block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        '''
        result = self._values.get("hsv")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitHsv"]]], result)

    @builtins.property
    def if_dimension(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfDimension"]]]:
        '''if_dimension block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        '''
        result = self._values.get("if_dimension")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfDimension"]]], result)

    @builtins.property
    def if_orientation(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientation"]]]:
        '''if_orientation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        '''
        result = self._values.get("if_orientation")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientation"]]], result)

    @builtins.property
    def max_colors(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitMaxColors"]]]:
        '''max_colors block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        '''
        result = self._values.get("max_colors")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitMaxColors"]]], result)

    @builtins.property
    def mirror(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitMirror"]]]:
        '''mirror block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        '''
        result = self._values.get("mirror")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitMirror"]]], result)

    @builtins.property
    def mono_hue(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitMonoHue"]]]:
        '''mono_hue block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        '''
        result = self._values.get("mono_hue")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitMonoHue"]]], result)

    @builtins.property
    def opacity(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitOpacity"]]]:
        '''opacity block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitOpacity"]]], result)

    @builtins.property
    def remove_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitRemoveColor"]]]:
        '''remove_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        '''
        result = self._values.get("remove_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitRemoveColor"]]], result)

    @builtins.property
    def unsharp_mask(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitUnsharpMask"]]]:
        '''unsharp_mask block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        result = self._values.get("unsharp_mask")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitUnsharpMask"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortrait(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitBackgroundColor",
    jsii_struct_bases=[],
    name_mapping={"color": "color", "color_var": "colorVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitBackgroundColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2de4a9695f327a0f74b76e882ebf7f39661d127a6076ecad01459d5467dc4df7)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitBackgroundColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitBackgroundColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitBackgroundColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__98f00d4b804e6660f540ed0fc2b58fb3a00069be2d3e393187b4ff1aaf8ff64f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitBackgroundColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dad3ba961e4a73d7586ee4b6b956ffd3f270245fad4cb0978212ed79bb0888ae)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitBackgroundColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__225d29760034e8f64d735170d046de516e4282365bc9bc78019d74d60b3bc043)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__27f3162017c13f246c7d12c0ac83e03e21e473f9eb78f63981e34f1f636cb532)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ed4340404fbfb1ab2fa0b379f9734d3d148edef4b1557dfb7e76b2886f2ec2dd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitBackgroundColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitBackgroundColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e19b5be773e6eb456bf07eb080e4bd73f0136752e803e8e4f9c1d3c82a1d5e66)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitBackgroundColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitBackgroundColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5d558fba3a5aea3e8dcda8b41bce3d2aaa1126d23b56f7e1e2c4a911466f3d1e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd8d0ead7eae46c99f6b5c82a050b4846dd08bd7658945881aef41edd2ebd1d6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea78a3b6438eb44d3c3a8e406568d2377a479beca7f6cc63c84b9d96f3e6d8d0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitBackgroundColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitBackgroundColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitBackgroundColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__02cdd2931a59413a901d82db8db1c58e0d5140a21797d9d1c335ed1205d0b676)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitBlur",
    jsii_struct_bases=[],
    name_mapping={"sigma": "sigma", "sigma_var": "sigmaVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitBlur:
    def __init__(
        self,
        *,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param sigma: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__370308d45c7e51440ce56301e67862a287230fe15e7d7e349c73cb2a76e42dab)
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitBlur(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitBlurList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitBlurList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f4f590d2e2afa6080fbc2500e53dde6eecfc59af67296085e9f40698daacecb5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitBlurOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__07124ecfc7510046ae2ea87bf4e857032e21bba691de037f88d4ef7050ae1ba3)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitBlurOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6972b3931def2fb2407cc5b43a2e0415a23452a421fbb09bfeede2e3f062e18c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b3c2dac90c88da65075f40863982ef366186577f5148c6c2bd489654a96aea4f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1c78f4eeec043a2a7e7407567fc61dc7342895a86469d0f5cfc1b233588c8e0f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitBlur]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitBlur]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1ea6ed72af030d4047d744eb10ddd44c9c4b7eb9fc9879028ee072b6eed01f7f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitBlurOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitBlurOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__94e1afcd5d7d506b0ee331057eeca97c5a10f13e42bb1e8f0b0c7ebebb97a661)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cf68383084b4d63e9527321b42a99ef53dd6d9f4f7a5448708172f24d0ffded1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c11a99c637631e62099093ff57f797aa65c84091452811eb0231dc8b379071b8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitBlur]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitBlur]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitBlur]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__31e6d3ab6c1bcf953db3acd6b382f9ed47e3982ef895a187750aa471ca22515b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitChromaKey",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_feather": "hueFeather",
        "hue_feather_var": "hueFeatherVar",
        "hue_tolerance": "hueTolerance",
        "hue_tolerance_var": "hueToleranceVar",
        "hue_var": "hueVar",
        "lightness_feather": "lightnessFeather",
        "lightness_feather_var": "lightnessFeatherVar",
        "lightness_tolerance": "lightnessTolerance",
        "lightness_tolerance_var": "lightnessToleranceVar",
        "saturation_feather": "saturationFeather",
        "saturation_feather_var": "saturationFeatherVar",
        "saturation_tolerance": "saturationTolerance",
        "saturation_tolerance_var": "saturationToleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitChromaKey:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_feather: typing.Optional[builtins.str] = None,
        hue_feather_var: typing.Optional[builtins.str] = None,
        hue_tolerance: typing.Optional[builtins.str] = None,
        hue_tolerance_var: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness_feather: typing.Optional[builtins.str] = None,
        lightness_feather_var: typing.Optional[builtins.str] = None,
        lightness_tolerance: typing.Optional[builtins.str] = None,
        lightness_tolerance_var: typing.Optional[builtins.str] = None,
        saturation_feather: typing.Optional[builtins.str] = None,
        saturation_feather_var: typing.Optional[builtins.str] = None,
        saturation_tolerance: typing.Optional[builtins.str] = None,
        saturation_tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_feather: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        :param hue_feather_var: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        :param hue_tolerance: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        :param hue_tolerance_var: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        :param hue_var: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness_feather: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        :param lightness_feather_var: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        :param lightness_tolerance: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        :param lightness_tolerance_var: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        :param saturation_feather: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        :param saturation_feather_var: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        :param saturation_tolerance: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        :param saturation_tolerance_var: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d1c92a2467ea640314ce2c9a6d8a7180ffc1fa373b1caac2ed66324c7c149dcf)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_feather", value=hue_feather, expected_type=type_hints["hue_feather"])
            check_type(argname="argument hue_feather_var", value=hue_feather_var, expected_type=type_hints["hue_feather_var"])
            check_type(argname="argument hue_tolerance", value=hue_tolerance, expected_type=type_hints["hue_tolerance"])
            check_type(argname="argument hue_tolerance_var", value=hue_tolerance_var, expected_type=type_hints["hue_tolerance_var"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness_feather", value=lightness_feather, expected_type=type_hints["lightness_feather"])
            check_type(argname="argument lightness_feather_var", value=lightness_feather_var, expected_type=type_hints["lightness_feather_var"])
            check_type(argname="argument lightness_tolerance", value=lightness_tolerance, expected_type=type_hints["lightness_tolerance"])
            check_type(argname="argument lightness_tolerance_var", value=lightness_tolerance_var, expected_type=type_hints["lightness_tolerance_var"])
            check_type(argname="argument saturation_feather", value=saturation_feather, expected_type=type_hints["saturation_feather"])
            check_type(argname="argument saturation_feather_var", value=saturation_feather_var, expected_type=type_hints["saturation_feather_var"])
            check_type(argname="argument saturation_tolerance", value=saturation_tolerance, expected_type=type_hints["saturation_tolerance"])
            check_type(argname="argument saturation_tolerance_var", value=saturation_tolerance_var, expected_type=type_hints["saturation_tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_feather is not None:
            self._values["hue_feather"] = hue_feather
        if hue_feather_var is not None:
            self._values["hue_feather_var"] = hue_feather_var
        if hue_tolerance is not None:
            self._values["hue_tolerance"] = hue_tolerance
        if hue_tolerance_var is not None:
            self._values["hue_tolerance_var"] = hue_tolerance_var
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness_feather is not None:
            self._values["lightness_feather"] = lightness_feather
        if lightness_feather_var is not None:
            self._values["lightness_feather_var"] = lightness_feather_var
        if lightness_tolerance is not None:
            self._values["lightness_tolerance"] = lightness_tolerance
        if lightness_tolerance_var is not None:
            self._values["lightness_tolerance_var"] = lightness_tolerance_var
        if saturation_feather is not None:
            self._values["saturation_feather"] = saturation_feather
        if saturation_feather_var is not None:
            self._values["saturation_feather_var"] = saturation_feather_var
        if saturation_tolerance is not None:
            self._values["saturation_tolerance"] = saturation_tolerance
        if saturation_tolerance_var is not None:
            self._values["saturation_tolerance_var"] = saturation_tolerance_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        '''
        result = self._values.get("hue_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        '''
        result = self._values.get("hue_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        '''
        result = self._values.get("hue_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        '''
        result = self._values.get("hue_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        '''
        result = self._values.get("lightness_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        '''
        result = self._values.get("lightness_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        '''
        result = self._values.get("lightness_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        '''
        result = self._values.get("lightness_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        '''
        result = self._values.get("saturation_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        '''
        result = self._values.get("saturation_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        '''
        result = self._values.get("saturation_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        result = self._values.get("saturation_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitChromaKey(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitChromaKeyList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitChromaKeyList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9071278d9565e3f2466515b3fcb24985d1e0fa3e7ee33d9b2f6456cd939cb3d1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitChromaKeyOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d153355f9b841def3c3300fbb07a3bc206cc4205bc4c063c52cbc427d19a81ea)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitChromaKeyOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6775e79dd3f94de01cc6ab9637b4b9f37c54c554687bbd500fe8798d65867653)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2cf3a73d4b1d516d64b5aa43b9f814e8d5d4e8eaa1469fd6c47796838210872b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__49a9df210c3abdb7ef2f460d1014d6dfe11f50200444eb8fd04a999852b16fa8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitChromaKey]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitChromaKey]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__95227f2beb9f3660b78ef4a5be28e023fd747d946a40f33c93ddce81c908d1d0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitChromaKeyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitChromaKeyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ece9b9e393f3d645dfa90901541b4a71e4db6d4584c3c2d79728c2e01046019e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueFeather")
    def reset_hue_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeather", []))

    @jsii.member(jsii_name="resetHueFeatherVar")
    def reset_hue_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeatherVar", []))

    @jsii.member(jsii_name="resetHueTolerance")
    def reset_hue_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueTolerance", []))

    @jsii.member(jsii_name="resetHueToleranceVar")
    def reset_hue_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueToleranceVar", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightnessFeather")
    def reset_lightness_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeather", []))

    @jsii.member(jsii_name="resetLightnessFeatherVar")
    def reset_lightness_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeatherVar", []))

    @jsii.member(jsii_name="resetLightnessTolerance")
    def reset_lightness_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessTolerance", []))

    @jsii.member(jsii_name="resetLightnessToleranceVar")
    def reset_lightness_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessToleranceVar", []))

    @jsii.member(jsii_name="resetSaturationFeather")
    def reset_saturation_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeather", []))

    @jsii.member(jsii_name="resetSaturationFeatherVar")
    def reset_saturation_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeatherVar", []))

    @jsii.member(jsii_name="resetSaturationTolerance")
    def reset_saturation_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationTolerance", []))

    @jsii.member(jsii_name="resetSaturationToleranceVar")
    def reset_saturation_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherInput")
    def hue_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVarInput")
    def hue_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceInput")
    def hue_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVarInput")
    def hue_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherInput")
    def lightness_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVarInput")
    def lightness_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceInput")
    def lightness_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVarInput")
    def lightness_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherInput")
    def saturation_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVarInput")
    def saturation_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceInput")
    def saturation_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVarInput")
    def saturation_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ec23585c76c1fbc7e958163a172e845831aa7baac8c327e2528e6fdda9a2fc7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeather")
    def hue_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeather"))

    @hue_feather.setter
    def hue_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bbd7d0b334cf00b15f77378b1c0e09eff8b9b808585c325f701d249e07254d51)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeather", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVar")
    def hue_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeatherVar"))

    @hue_feather_var.setter
    def hue_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7489de44a5d9a8fd8f6398342711c57fac7651488c134dad57e9f20d3784b165)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueTolerance")
    def hue_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueTolerance"))

    @hue_tolerance.setter
    def hue_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__acbe82d6a5ee5c110cf6e64c3c913744b51d1e179a74fbd8d230fff41127a36c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVar")
    def hue_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueToleranceVar"))

    @hue_tolerance_var.setter
    def hue_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d3d261816abc7cabe61c446f06ade58c999360601e25c927230500331313ac52)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__36f657882ac28a5c6744c8261f6862fd3bc8cbc7f3a2f969707050fb8f4176eb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeather")
    def lightness_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeather"))

    @lightness_feather.setter
    def lightness_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__99c3a7cb90fd5d653825b6e905c6c6f7b41046af8f04c60983e7723691fbf9d6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeather", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVar")
    def lightness_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeatherVar"))

    @lightness_feather_var.setter
    def lightness_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5c1161735b01b386954b8a9ffbd20f7416ec6bac7a4806e454ca3c1341c97521)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessTolerance")
    def lightness_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessTolerance"))

    @lightness_tolerance.setter
    def lightness_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e72058084d1fd729d32afb03e7f50427fe3cfd193e13f956c262ffae2a28bf3f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVar")
    def lightness_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessToleranceVar"))

    @lightness_tolerance_var.setter
    def lightness_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3558e9dbf2e2d405e2ceabe4964cc8b9c3cc476a035ae85b1638aaa52d25318a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeather")
    def saturation_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeather"))

    @saturation_feather.setter
    def saturation_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__938855d35ed79f9ac565d56d359a48b7bb3dcaba0b518846866b4ee9059f6fee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeather", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVar")
    def saturation_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeatherVar"))

    @saturation_feather_var.setter
    def saturation_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__484207747473927f2b0e6b356297a6c203307a2d6421eb892fc522ebbc5ad1ac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationTolerance")
    def saturation_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationTolerance"))

    @saturation_tolerance.setter
    def saturation_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d1c7daecc68a12d4f4e0303ca6a2b32f62aafe248ddb9099d41ca93a5d67fc22)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVar")
    def saturation_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationToleranceVar"))

    @saturation_tolerance_var.setter
    def saturation_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1548875d347ad55cacdc7bd00267c7655712476fe49ab25562d97f6b431c0e91)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitChromaKey]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitChromaKey]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitChromaKey]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9275c834f68544088fbd5f7b66d6102c9e003af92d2f0f79e09c53dc8b827e2f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitComposite",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "placement": "placement",
        "placement_var": "placementVar",
        "scale": "scale",
        "scale_dimension": "scaleDimension",
        "scale_dimension_var": "scaleDimensionVar",
        "scale_var": "scaleVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitComposite:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitCompositeImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        placement: typing.Optional[builtins.str] = None,
        placement_var: typing.Optional[builtins.str] = None,
        scale: typing.Optional[builtins.str] = None,
        scale_dimension: typing.Optional[builtins.str] = None,
        scale_dimension_var: typing.Optional[builtins.str] = None,
        scale_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param placement: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        :param placement_var: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        :param scale: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param scale_dimension: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        :param scale_dimension_var: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        :param scale_var: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        :param x_position: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitCompositeImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f0c5728dd93b2396fc132449c6519660e35e1bc41b25e7317274c240ca4cc202)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument placement", value=placement, expected_type=type_hints["placement"])
            check_type(argname="argument placement_var", value=placement_var, expected_type=type_hints["placement_var"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument scale_dimension", value=scale_dimension, expected_type=type_hints["scale_dimension"])
            check_type(argname="argument scale_dimension_var", value=scale_dimension_var, expected_type=type_hints["scale_dimension_var"])
            check_type(argname="argument scale_var", value=scale_var, expected_type=type_hints["scale_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if placement is not None:
            self._values["placement"] = placement
        if placement_var is not None:
            self._values["placement_var"] = placement_var
        if scale is not None:
            self._values["scale"] = scale
        if scale_dimension is not None:
            self._values["scale_dimension"] = scale_dimension
        if scale_dimension_var is not None:
            self._values["scale_dimension_var"] = scale_dimension_var
        if scale_var is not None:
            self._values["scale_var"] = scale_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitCompositeImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitCompositeImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        '''
        result = self._values.get("placement")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement_var(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        '''
        result = self._values.get("placement_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        '''
        result = self._values.get("scale_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        '''
        result = self._values.get("scale_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        '''
        result = self._values.get("scale_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitComposite(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitCompositeImage",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitCompositeImage:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitCompositeImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitCompositeImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitCompositeImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e241be495f0162726b5e8434e17f907a9c9ab233b34bce6f47f3a865bf9a8cfa)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitCompositeImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitCompositeImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__60e597d99e016ea136333ab2ecdcf94671e6575f07ab5cfb115f327d3649dcef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitCompositeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitCompositeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7f182fafc5f050f33ada2be0ca23952c4b18e249ec30a677be29b1a038a8b5d2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitCompositeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a248c07487b04b512a5f443dcc662d2c4c89e8d0b0581c8af8d050a8284c05d5)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitCompositeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c4797ffe453d9200b05130d4fe1c9cd6faf20390efb4c4e9636475a9aaeb9a6b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__341121bcfa50ccc8d89abb8856f3de440f00cd42bc9add10040fe7a02c04362a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__80696a03801afc747e786cf8d49e75755176efbff1724c26fa387bbe6ebc8bc3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitComposite]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitComposite]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a28e54df4c4cd8faf93f45d199c07c75d3bd547ff28e2a72b604a216e15bdb6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitCompositeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitCompositeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ef54bd5e43c7a5b24a66154fccd8c66fa066d594e370a5f1bac745069eaf7731)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitCompositeImage()

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPlacement")
    def reset_placement(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacement", []))

    @jsii.member(jsii_name="resetPlacementVar")
    def reset_placement_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacementVar", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetScaleDimension")
    def reset_scale_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimension", []))

    @jsii.member(jsii_name="resetScaleDimensionVar")
    def reset_scale_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimensionVar", []))

    @jsii.member(jsii_name="resetScaleVar")
    def reset_scale_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitCompositeImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitCompositeImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitCompositeImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="placementInput")
    def placement_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementInput"))

    @builtins.property
    @jsii.member(jsii_name="placementVarInput")
    def placement_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionInput")
    def scale_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVarInput")
    def scale_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleVarInput")
    def scale_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ef274a7efd15ce5ff759c942c483f0cbafd28dd81e3b553f50abb47cc1c37ea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4080786bf68cea4e744d56ef710873509e50a1ac981815c25bc9871dc8d8feb8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="placement")
    def placement(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placement"))

    @placement.setter
    def placement(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__72b713cfe4ba96cf565787077b7c587af45faf4c4dfe253a12beb88fe8985d90)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placement", value)

    @builtins.property
    @jsii.member(jsii_name="placementVar")
    def placement_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placementVar"))

    @placement_var.setter
    def placement_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f0bf6510f5eed7a483d34323e075806d1fd2349155f164a276960dd82f89ea6c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placementVar", value)

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scale"))

    @scale.setter
    def scale(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a089ff088aa610bb8bb2bd3e132047b01b449cad79c3e7bee7e854034677c776)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scale", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimension")
    def scale_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimension"))

    @scale_dimension.setter
    def scale_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fdebd42632c52faa5db0135de3e45d17169f54a007c763ea36af895f3e60a3d6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimension", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVar")
    def scale_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimensionVar"))

    @scale_dimension_var.setter
    def scale_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__31cf7933300abd9fa09d4287972f81d49215e02df55ca70072f9370775bdb3c0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="scaleVar")
    def scale_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleVar"))

    @scale_var.setter
    def scale_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c7033f8a5673bb6714217f0ae60e1d28ffe627286776f9f0139777f7b29ab674)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__985fa5b9625feed49dcb9e0890ac5649c9ca4038b1ccfb9cf071a017b4c5e8b0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ec1429c73e208e052965299126efd69397d57f0ee89fcf5d3341074c9c37a1c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1d07bde125bad66168e73257254b62d13fc95756886f089470791dfb172f16af)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0d5d3b9c153c395cd5eae128bba91d9a30f9346e90479ec1bedb4e6156414f89)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitComposite]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitComposite]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitComposite]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f8eb15809eefe8c219ea1ad7a416689bdbea563b89d047a1f51729be50e7c8fd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitCompound",
    jsii_struct_bases=[],
    name_mapping={"transformations": "transformations"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitCompound:
    def __init__(
        self,
        *,
        transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param transformations: transformations block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e4a57b0345bf9ea9a7f00fdfe7e5e7ecc8587695a42177adc3a0a3e26efcfc9)
            check_type(argname="argument transformations", value=transformations, expected_type=type_hints["transformations"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if transformations is not None:
            self._values["transformations"] = transformations

    @builtins.property
    def transformations(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitCompoundTransformations"]]]:
        '''transformations block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        result = self._values.get("transformations")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitCompoundTransformations"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitCompound(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitCompoundList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitCompoundList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7506906cc4ef438c40fc0cc2f98b275710b0af9d574e345ad40bf2bb4c49d090)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitCompoundOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a910384430535ac98a9ad5dc90315a311c01606542b9aaad8fb0483f77acc45b)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitCompoundOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b351c6cfaa808b273b833cea0cd4dc0d10b78dcca322a446ad49692697fbc030)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__59100a681e7a2cf865930d9d4212403e0e71dbb3c2d3f0e8af708a119bd91e73)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__24ad37a717ae9935b8caaabafe2660a5cea6898bfbca46faf2895ece738e1705)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitCompound]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitCompound]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__40afdc7b2f12433034a6bd1195b4a186b29ec76a73179654d0a2680c3b259fec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitCompoundOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitCompoundOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ef2dd3cdd20e039bc000617d04cffb9f823bda3eed914d31a24342a1a1a43dd8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformations")
    def put_transformations(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__88b15a1be91cbb6925b7cbfef49e6dcde4deab1775172af0e8dd4b4c2314eeec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTransformations", [value]))

    @jsii.member(jsii_name="resetTransformations")
    def reset_transformations(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformations", []))

    @builtins.property
    @jsii.member(jsii_name="transformations")
    def transformations(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitCompoundTransformationsList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitCompoundTransformationsList", jsii.get(self, "transformations"))

    @builtins.property
    @jsii.member(jsii_name="transformationsInput")
    def transformations_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitCompoundTransformations"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitCompoundTransformations"]]], jsii.get(self, "transformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitCompound]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitCompound]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitCompound]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1d8c2065fc4ba700b49ec8a44493b38bd50598b1cf32f47bf37a04e52868e15b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitCompoundTransformations",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitCompoundTransformations:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitCompoundTransformations(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitCompoundTransformationsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitCompoundTransformationsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df723edd959a5a48df7d7fc3296e710fb82242ce35d7170d3ad791be344e3583)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitCompoundTransformationsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e76bc0239f9233eb3156e8d84d08802ef07c56476a70dd254516f6c3b31ca36a)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitCompoundTransformationsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bd97e51efb88070ffd5037e2a1e5ddde211e1e5ea00b0f39ea24828a29d3de78)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e29e51aa91428354f2d661218e2c74cbb7dcd68018dd22f6b80008b1e9b6c28c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1a3ddfe2fc90aa24b22a6dbf8a165187202bf9020c1fc9993f564f1c3bd80476)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitCompoundTransformations]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitCompoundTransformations]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitCompoundTransformations]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__06016216fa68bae1635c01220d159beefe3b8c65ba624fdcca92cd2bb2097955)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitCompoundTransformationsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitCompoundTransformationsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__662689fc52e75e8505df687cef17ef41776b5e633045c10a5f7e97f80ab7f249)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitCompoundTransformations]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitCompoundTransformations]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitCompoundTransformations]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c80e2c85e5509691f8d0a1a8ab2288cca30b380dbd13c3a5031f9c68a9849a92)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitContrast",
    jsii_struct_bases=[],
    name_mapping={
        "brightness": "brightness",
        "brightness_var": "brightnessVar",
        "contrast": "contrast",
        "contrast_var": "contrastVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitContrast:
    def __init__(
        self,
        *,
        brightness: typing.Optional[builtins.str] = None,
        brightness_var: typing.Optional[builtins.str] = None,
        contrast: typing.Optional[builtins.str] = None,
        contrast_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param brightness: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        :param brightness_var: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        :param contrast: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param contrast_var: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e3d45a79f36f11237d94c33e05f5d0430691b7e4f351d4b06e7a4692bfac79d5)
            check_type(argname="argument brightness", value=brightness, expected_type=type_hints["brightness"])
            check_type(argname="argument brightness_var", value=brightness_var, expected_type=type_hints["brightness_var"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument contrast_var", value=contrast_var, expected_type=type_hints["contrast_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if brightness is not None:
            self._values["brightness"] = brightness
        if brightness_var is not None:
            self._values["brightness_var"] = brightness_var
        if contrast is not None:
            self._values["contrast"] = contrast
        if contrast_var is not None:
            self._values["contrast_var"] = contrast_var

    @builtins.property
    def brightness(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        '''
        result = self._values.get("brightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def brightness_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        '''
        result = self._values.get("brightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        result = self._values.get("contrast_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitContrast(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitContrastList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitContrastList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__709368a74224401a8d5492e8f4fcd24bd5d17e13bfdb930ff8e318124a5a014b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitContrastOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f4c2c46368e546f8f3d9728dc21b2db373745b9546a263e473e16d007686e77d)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitContrastOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3cf82f47132a0cce75b38001d124f4c290a98d635b7a5ba22e95557649749f67)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ff962d857bf35ef099ffe9d08ce4453cd47c970438d2a310c64895d9749cd607)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e672739e3cf7c4fd1a8996974000b4ce49f6ccac3b020e36c36e45f40b9e61ac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitContrast]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitContrast]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__949f1764d7b8cf8d28b822a359400f8202dbeebf71d05e6cb4ccfb9c684e929a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitContrastOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitContrastOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__10719fc5305df503ea0b4c4be918dd64b051a54d7629fe4c2e03252c32d41be3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetBrightness")
    def reset_brightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightness", []))

    @jsii.member(jsii_name="resetBrightnessVar")
    def reset_brightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightnessVar", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetContrastVar")
    def reset_contrast_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrastVar", []))

    @builtins.property
    @jsii.member(jsii_name="brightnessInput")
    def brightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="brightnessVarInput")
    def brightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastVarInput")
    def contrast_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="brightness")
    def brightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightness"))

    @brightness.setter
    def brightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6c71073e0fa1cc72b2f94d5657c148c0d343a2b7da813891dc6905e96fd44db4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightness", value)

    @builtins.property
    @jsii.member(jsii_name="brightnessVar")
    def brightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightnessVar"))

    @brightness_var.setter
    def brightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__54682bebd380dbc15e2fac027f3e1a0d7879ded9542b3b79039804c2360e28f9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrast"))

    @contrast.setter
    def contrast(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd72cad74ec1d4118046d0b5321c813fa7ca64a2c7704828a418a838651d08eb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrast", value)

    @builtins.property
    @jsii.member(jsii_name="contrastVar")
    def contrast_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrastVar"))

    @contrast_var.setter
    def contrast_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5c7ac77be3bb79c211d7dee10ce9ab82630d7029f78d2b419b85097f9ec4a554)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrastVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitContrast]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitContrast]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitContrast]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__326f9e1e44da9d82b6e4b5505945bb91f47c64f0983fddc4b7ff07c1da59d60f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitGoop",
    jsii_struct_bases=[],
    name_mapping={
        "chaos": "chaos",
        "chaos_var": "chaosVar",
        "density": "density",
        "density_var": "densityVar",
        "power": "power",
        "power_var": "powerVar",
        "seed": "seed",
        "seed_var": "seedVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitGoop:
    def __init__(
        self,
        *,
        chaos: typing.Optional[builtins.str] = None,
        chaos_var: typing.Optional[builtins.str] = None,
        density: typing.Optional[builtins.str] = None,
        density_var: typing.Optional[builtins.str] = None,
        power: typing.Optional[builtins.str] = None,
        power_var: typing.Optional[builtins.str] = None,
        seed: typing.Optional[builtins.str] = None,
        seed_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param chaos: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        :param chaos_var: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        :param density: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        :param density_var: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        :param power: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        :param power_var: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        :param seed: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        :param seed_var: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ee5c7c95ac238a19af7ab8839fdcfcb6f0394673a3e33de91e882f216ec02570)
            check_type(argname="argument chaos", value=chaos, expected_type=type_hints["chaos"])
            check_type(argname="argument chaos_var", value=chaos_var, expected_type=type_hints["chaos_var"])
            check_type(argname="argument density", value=density, expected_type=type_hints["density"])
            check_type(argname="argument density_var", value=density_var, expected_type=type_hints["density_var"])
            check_type(argname="argument power", value=power, expected_type=type_hints["power"])
            check_type(argname="argument power_var", value=power_var, expected_type=type_hints["power_var"])
            check_type(argname="argument seed", value=seed, expected_type=type_hints["seed"])
            check_type(argname="argument seed_var", value=seed_var, expected_type=type_hints["seed_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if chaos is not None:
            self._values["chaos"] = chaos
        if chaos_var is not None:
            self._values["chaos_var"] = chaos_var
        if density is not None:
            self._values["density"] = density
        if density_var is not None:
            self._values["density_var"] = density_var
        if power is not None:
            self._values["power"] = power
        if power_var is not None:
            self._values["power_var"] = power_var
        if seed is not None:
            self._values["seed"] = seed
        if seed_var is not None:
            self._values["seed_var"] = seed_var

    @builtins.property
    def chaos(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        '''
        result = self._values.get("chaos")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def chaos_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        '''
        result = self._values.get("chaos_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        '''
        result = self._values.get("density")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density_var(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        '''
        result = self._values.get("density_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        '''
        result = self._values.get("power")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power_var(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        '''
        result = self._values.get("power_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        '''
        result = self._values.get("seed")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed_var(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        result = self._values.get("seed_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitGoop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitGoopList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitGoopList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab35ff9ef43eaae9700cc582239485fd907b86d79d3888f8c36234ac0acab56e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitGoopOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__602d2f8cea5af1bb56a42068ee57b431147ae9e3d2693f280169feb0c3a024f8)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitGoopOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b5c70f7fcb98d058292ccd5f0ef58b7c4f035a8a0650d63f36dec0f530aa4bbd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eab1739abaee8ab197d46eca35f799161ca92929ba8bf5708c73ceeab7106356)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__580ad21b16a1fcdca295d8ef79adcf76e6de2c22fcbbfa587d4ca4791dcfef09)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitGoop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitGoop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8db036d14b11f1a1b0b7525cd963f28b2fc627c694085cbdecf0a2f80693ce43)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitGoopOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitGoopOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ad918eac7452155c6261aa9780732f749adcca11117f0f10574f76fc07a09442)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetChaos")
    def reset_chaos(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaos", []))

    @jsii.member(jsii_name="resetChaosVar")
    def reset_chaos_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaosVar", []))

    @jsii.member(jsii_name="resetDensity")
    def reset_density(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensity", []))

    @jsii.member(jsii_name="resetDensityVar")
    def reset_density_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensityVar", []))

    @jsii.member(jsii_name="resetPower")
    def reset_power(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPower", []))

    @jsii.member(jsii_name="resetPowerVar")
    def reset_power_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPowerVar", []))

    @jsii.member(jsii_name="resetSeed")
    def reset_seed(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeed", []))

    @jsii.member(jsii_name="resetSeedVar")
    def reset_seed_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeedVar", []))

    @builtins.property
    @jsii.member(jsii_name="chaosInput")
    def chaos_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosInput"))

    @builtins.property
    @jsii.member(jsii_name="chaosVarInput")
    def chaos_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosVarInput"))

    @builtins.property
    @jsii.member(jsii_name="densityInput")
    def density_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityInput"))

    @builtins.property
    @jsii.member(jsii_name="densityVarInput")
    def density_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="powerInput")
    def power_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerInput"))

    @builtins.property
    @jsii.member(jsii_name="powerVarInput")
    def power_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerVarInput"))

    @builtins.property
    @jsii.member(jsii_name="seedInput")
    def seed_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedInput"))

    @builtins.property
    @jsii.member(jsii_name="seedVarInput")
    def seed_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedVarInput"))

    @builtins.property
    @jsii.member(jsii_name="chaos")
    def chaos(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaos"))

    @chaos.setter
    def chaos(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e33cf5377b91fb69fe8e882f9b685833fb728392bab345f2f20bdade8987558f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaos", value)

    @builtins.property
    @jsii.member(jsii_name="chaosVar")
    def chaos_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaosVar"))

    @chaos_var.setter
    def chaos_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6c37ed9fe9bbff45670229ab9a6250881f7afbf4d9722cb941d02591ca6b405e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaosVar", value)

    @builtins.property
    @jsii.member(jsii_name="density")
    def density(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "density"))

    @density.setter
    def density(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__999efe4c14acfbf95d94e4318027abe9b1c7761379081d69ea698b83f4742ddb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "density", value)

    @builtins.property
    @jsii.member(jsii_name="densityVar")
    def density_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "densityVar"))

    @density_var.setter
    def density_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d0159ba4afc7910fce62a5972fe97fac1d02772d78e269ef5c1e3dfd4445fecf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "densityVar", value)

    @builtins.property
    @jsii.member(jsii_name="power")
    def power(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "power"))

    @power.setter
    def power(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a57a31a04cdee8ce8775906071459d502a14282d095800b3494f9e7c1f4a317)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "power", value)

    @builtins.property
    @jsii.member(jsii_name="powerVar")
    def power_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "powerVar"))

    @power_var.setter
    def power_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__78e877d6de9525a9c867e5529841bda1fe90691df0576a8de85a3ed67bb2373a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "powerVar", value)

    @builtins.property
    @jsii.member(jsii_name="seed")
    def seed(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seed"))

    @seed.setter
    def seed(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d64e26005c08d172577388349b905e7225272aa437f574a1192dc0d4945cd5de)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seed", value)

    @builtins.property
    @jsii.member(jsii_name="seedVar")
    def seed_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seedVar"))

    @seed_var.setter
    def seed_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bd199e4ff6e7aa156232b5b791da06e892aab33531ad6d1237c8189e0ae65aee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seedVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitGoop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitGoop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitGoop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8770e34d1b3c5887fa4373ffc76b88cb990699f39adea427ba10704976a84c12)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitGrayscale",
    jsii_struct_bases=[],
    name_mapping={"type": "type", "type_var": "typeVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitGrayscale:
    def __init__(
        self,
        *,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param type: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f9f861cd2e122ccf552b5c69ac8885dc4519a8f8acdd42bb9125ba6680e3d9d9)
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitGrayscale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitGrayscaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitGrayscaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ec1ca280a039bc6157d3df57b6d780b84b7328f91d8f40413cdc7023163b0bd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitGrayscaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__78f5ef46c3e2a7108e581aa62c78284d7f9dd7ed333787cf7de8e7645883b912)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitGrayscaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4d33fd804e1a0d35f65381b35c59896d9f0980a3cd1a9b80c9b5cb722318fa37)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2e8e3de1bbb146160070a2893f5a7d7af3ab49b969e402aa120f320d5b954ba7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__98f05186f7e5f8c807ceaf5645f4f103360aabf71b4dbd63021acef8d8d8e819)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitGrayscale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitGrayscale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6ab3a83d892049e554edc0d224757be1de2af975d42cc0d20c664e47e056c363)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitGrayscaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitGrayscaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__beb16c3db888ac0c321fd16ab89db82a84ea6070ce33239c53e5289b0f2b4295)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__77cfd4aa51540df9db84a55b531b3d5c26f4e011befd9b882b7f20e31ba37c7f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d31c514d3251f8ebcbc6eb72293dc984104449af8877f62ee072485a9987cbe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitGrayscale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitGrayscale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitGrayscale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fc6267d00acc6e2aa23b593f413bb75a1de138e0042b80d31cbdb8acc654cb99)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitHsl",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "lightness": "lightness",
        "lightness_var": "lightnessVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitHsl:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness: typing.Optional[builtins.str] = None,
        lightness_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        :param lightness_var: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__436fb0ec5eae9a16e03f3ff0eccc019c775475b1712e1a6f951f2db30d849815)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness", value=lightness, expected_type=type_hints["lightness"])
            check_type(argname="argument lightness_var", value=lightness_var, expected_type=type_hints["lightness_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness is not None:
            self._values["lightness"] = lightness
        if lightness_var is not None:
            self._values["lightness_var"] = lightness_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        '''
        result = self._values.get("lightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        '''
        result = self._values.get("lightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitHsl(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitHslList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitHslList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__05e568a35ee803eb8f779fcb31b2b084d4b5ab75955c238b2e83c34fb4e338c1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitHslOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__659b6247711e162143a4b2d8ba2f3766816b5664f8b20cca1ed43487308754a0)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitHslOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7a4f8435dbb43780136e8bebc79c0efac93d570a3c932527f0025b639d987554)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d03a867d9064e463b693a91819ec55135e08d32e71bd8b43ff295fa7d7cbe846)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3481a6c6ebae651736882419b0aa02a0116ecd5ac3e97d4000a9d66c7aae57b3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitHsl]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitHsl]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f168c2d24ee8902374a6c5c583712c07fdecae9fcc2b9f0684651cc70be9c71e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitHslOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitHslOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__20a095a9a78a2db112371eb3e2e091da5ad4ff59201f179cc32971136efd646d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightness")
    def reset_lightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightness", []))

    @jsii.member(jsii_name="resetLightnessVar")
    def reset_lightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessInput")
    def lightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessVarInput")
    def lightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ae8382a3f1ba0aa68ea2abb243b6d446f68c5276aac30cff564cc0ea939b6511)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7b9040c93bee510c9176e95ea5e654052c443d53327aef1aba5285893ae86ca3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightness")
    def lightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightness"))

    @lightness.setter
    def lightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f8ee5896fef44e2d0a113870603637a54823f6f1b3ab7315688103a0a7a63a4e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightness", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessVar")
    def lightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessVar"))

    @lightness_var.setter
    def lightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__87f579f7d6ae704a0c3e245b80f44a414d4a08202491154154b6903fb1f70cc7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f4cafaa024e914eaebcffd4d51f5704ab1ce78a652b628cd95c0640bffd35a56)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__179e6c67f536d4205c21c6aadc7d20f05d1ae69dabae652867ea53fa7d00bdf1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitHsl]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitHsl]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitHsl]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5e5635414b3758413263dc480d54ab492e1cbdb80ea659af027ede86f9214325)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitHsv",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitHsv:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        :param value: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1a1c0df46189f6a1899750a5045e2f34e2d62a4e12dedb4b37e2b38948836750)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitHsv(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitHsvList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitHsvList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b9137e5be18565bdf8dd54dba447bd0f737dc8dc320b397cbb88f35f30f6ba0f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitHsvOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7001ba82ffa9c408f24524c043bc634a8bdf230eb80d20983dca9fec5255be3f)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitHsvOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__acc33184147732b75e6171db74b6a1583226070b8f21f9556e0f1b5d3652f7bf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3de8b8d03aee64cbdeef8f44680a0106311f46d3ff52bad4cffde6bdf5a95e2c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__488052b48457185695eb02a5fb675d28cb5082e3b4299bee7a53869778ab213b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitHsv]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitHsv]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f0a09c8232771646b4891b3a9f5cca5f91678d8f2c4ed25c74e6e4c834349c4f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitHsvOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitHsvOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b1c72fd785286ef298334011f7103145226b2ceadd2287de7831d7e5919ccfe9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e9de69d0bcd157234b4d4c4ae2e0fd65cccaabca9908b6aa1aabb46edc5c7d9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4aef9aa0816ff8d88a283f4704108e1a7888e3ec6e7c0c38e605cbe1b7a89823)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ebc7e4915578cd5fd3c7398faf634353d65cfbdba2e6f39599879d8aa1dfdbf7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3b4405d3c9dbf6bbb3dd86f84b2003727248440bbf9c2dbf41d98a34af48db89)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__621f725869e638421814e5d218a5fb1e21c7bd2cd6f681b490fabfd288049861)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4e6df4ee1478b6a8f52829a1dbd95b007dfad8e847e41f675fc423e9508cf626)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitHsv]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitHsv]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitHsv]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b5bf37e0e8ccebbeb6ba42f7ea33dedf910a9e96a893ddf6ba93020d542590e4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfDimension",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "dimension": "dimension",
        "dimension_var": "dimensionVar",
        "equal": "equal",
        "greater_than": "greaterThan",
        "less_than": "lessThan",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfDimension:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        dimension: typing.Optional[builtins.str] = None,
        dimension_var: typing.Optional[builtins.str] = None,
        equal: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionEqual", typing.Dict[builtins.str, typing.Any]]] = None,
        greater_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionGreaterThan", typing.Dict[builtins.str, typing.Any]]] = None,
        less_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionLessThan", typing.Dict[builtins.str, typing.Any]]] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param dimension: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        :param dimension_var: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        :param equal: equal block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        :param greater_than: greater_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        :param less_than: less_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        :param value: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionDefault(**default)
        if isinstance(equal, dict):
            equal = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionEqual(**equal)
        if isinstance(greater_than, dict):
            greater_than = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionGreaterThan(**greater_than)
        if isinstance(less_than, dict):
            less_than = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionLessThan(**less_than)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__26d5b84126e861755af87a1c9712db4e6a6db317270eacb57b4b863cd96df4a7)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument dimension", value=dimension, expected_type=type_hints["dimension"])
            check_type(argname="argument dimension_var", value=dimension_var, expected_type=type_hints["dimension_var"])
            check_type(argname="argument equal", value=equal, expected_type=type_hints["equal"])
            check_type(argname="argument greater_than", value=greater_than, expected_type=type_hints["greater_than"])
            check_type(argname="argument less_than", value=less_than, expected_type=type_hints["less_than"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if dimension is not None:
            self._values["dimension"] = dimension
        if dimension_var is not None:
            self._values["dimension_var"] = dimension_var
        if equal is not None:
            self._values["equal"] = equal
        if greater_than is not None:
            self._values["greater_than"] = greater_than
        if less_than is not None:
            self._values["less_than"] = less_than
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionDefault"], result)

    @builtins.property
    def dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        '''
        result = self._values.get("dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        '''
        result = self._values.get("dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def equal(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionEqual"]:
        '''equal block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        '''
        result = self._values.get("equal")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionEqual"], result)

    @builtins.property
    def greater_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionGreaterThan"]:
        '''greater_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        '''
        result = self._values.get("greater_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionGreaterThan"], result)

    @builtins.property
    def less_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionLessThan"]:
        '''less_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        '''
        result = self._values.get("less_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionLessThan"], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfDimension(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aa75721ebbdd570043c16ce74e2e48ceddb848e748aaa5ca04230dde4e6fffaa)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d2a656eb4474ac4ddda9aae9fe774031d590a0b7fe646408c6b2da1511371534)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionEqual",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionEqual:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionEqual(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionEqualOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionEqualOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__28fa37833592076fca9af82112bf5b405a24830d83cea8793f5aed77b82c4cb3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionEqual], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionEqual],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f848647d40c1f863293b2f6be5c036763a4f9967055ea1c3982064f1b9f68126)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionGreaterThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionGreaterThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionGreaterThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionGreaterThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionGreaterThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f043566b67eb003ea921bb06ecff2d2abd70d99c87fed3f90dcbbee54928ec28)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionGreaterThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionGreaterThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa3ea7bed3b36070c452a5f71c92b0b03c06b4ab499688d38da5db055283ad32)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionLessThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionLessThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionLessThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionLessThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionLessThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aae67e9a0cd15a95eb08ee362b627a0c13243bfa2ef4198f2016d4fa7ad96556)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionLessThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionLessThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aeb8e77d4964e578816715bbb71183bc1d6432bd87dd5327afeb43d9d21f96a2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__02176d16fa298a5507d4cfe05fc6cf32bcb703d96b1e5706d983e9a71c874376)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f68dd4e091d7449f94edc97ce07f820337a959524434aa6c46d9a10e428ec45b)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fb7b09718e2ff022ecd2a90e226514582977324a473540b067b30cb5a8354a50)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb6e4b2196403f69507b4721c0a9bf57b39981164e8b088cf2a25d104d4ab526)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__101cc5395ef606f8c8565c9610004768bab765f9b9525a33d29966250c175234)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfDimension]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfDimension]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8cc0aeb1c3e4532caf9933e6558b8c64c74548f2ac7fc71d99f418ab2fd6655c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e9b99e76c6aa32f14c56d0d7ee280a0a9c84d197926ece012ba97bf9880eeb50)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putEqual")
    def put_equal(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionEqual()

        return typing.cast(None, jsii.invoke(self, "putEqual", [value]))

    @jsii.member(jsii_name="putGreaterThan")
    def put_greater_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionGreaterThan()

        return typing.cast(None, jsii.invoke(self, "putGreaterThan", [value]))

    @jsii.member(jsii_name="putLessThan")
    def put_less_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionLessThan()

        return typing.cast(None, jsii.invoke(self, "putLessThan", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetDimension")
    def reset_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimension", []))

    @jsii.member(jsii_name="resetDimensionVar")
    def reset_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimensionVar", []))

    @jsii.member(jsii_name="resetEqual")
    def reset_equal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEqual", []))

    @jsii.member(jsii_name="resetGreaterThan")
    def reset_greater_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGreaterThan", []))

    @jsii.member(jsii_name="resetLessThan")
    def reset_less_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLessThan", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="equal")
    def equal(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionEqualOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionEqualOutputReference, jsii.get(self, "equal"))

    @builtins.property
    @jsii.member(jsii_name="greaterThan")
    def greater_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionGreaterThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionGreaterThanOutputReference, jsii.get(self, "greaterThan"))

    @builtins.property
    @jsii.member(jsii_name="lessThan")
    def less_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionLessThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionLessThanOutputReference, jsii.get(self, "lessThan"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionInput")
    def dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionVarInput")
    def dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="equalInput")
    def equal_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionEqual], jsii.get(self, "equalInput"))

    @builtins.property
    @jsii.member(jsii_name="greaterThanInput")
    def greater_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionGreaterThan], jsii.get(self, "greaterThanInput"))

    @builtins.property
    @jsii.member(jsii_name="lessThanInput")
    def less_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionLessThan], jsii.get(self, "lessThanInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="dimension")
    def dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimension"))

    @dimension.setter
    def dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__217eec65594b26b3427f3b2a52dc9485f31ebdf6559a714d03f3d6c9c747334b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimension", value)

    @builtins.property
    @jsii.member(jsii_name="dimensionVar")
    def dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimensionVar"))

    @dimension_var.setter
    def dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4527fe63d79c354cb344378488c8904f4490b7458275ff95521596c0ca2bd8ff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb96b2772435f5d64052ac76d22aed4cd434f3d3ef73621d1d934af3cdf7bce4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b6b74f73a811149ca12c252dbafb4aaf84842cc43d24f6846c93f8b72e4a9529)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfDimension]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfDimension]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfDimension]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__527fd57d8ca053f058ea2abb20b26cddc85ba5358a37bbde26efe651fdc42980)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientation",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "landscape": "landscape",
        "portrait": "portrait",
        "square": "square",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientation:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        landscape: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationLandscape", typing.Dict[builtins.str, typing.Any]]] = None,
        portrait: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationPortrait", typing.Dict[builtins.str, typing.Any]]] = None,
        square: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationSquare", typing.Dict[builtins.str, typing.Any]]] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param landscape: landscape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        :param portrait: portrait block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        :param square: square block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationDefault(**default)
        if isinstance(landscape, dict):
            landscape = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationLandscape(**landscape)
        if isinstance(portrait, dict):
            portrait = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationPortrait(**portrait)
        if isinstance(square, dict):
            square = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationSquare(**square)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e5602d88a81d30098b46e92c3ae3ef9637bd12844e52d753566317ef35b1e382)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument landscape", value=landscape, expected_type=type_hints["landscape"])
            check_type(argname="argument portrait", value=portrait, expected_type=type_hints["portrait"])
            check_type(argname="argument square", value=square, expected_type=type_hints["square"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if landscape is not None:
            self._values["landscape"] = landscape
        if portrait is not None:
            self._values["portrait"] = portrait
        if square is not None:
            self._values["square"] = square

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationDefault"], result)

    @builtins.property
    def landscape(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationLandscape"]:
        '''landscape block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        '''
        result = self._values.get("landscape")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationLandscape"], result)

    @builtins.property
    def portrait(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationPortrait"]:
        '''portrait block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        '''
        result = self._values.get("portrait")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationPortrait"], result)

    @builtins.property
    def square(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationSquare"]:
        '''square block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        result = self._values.get("square")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationSquare"], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fc111cd5be80c452462c54ad7098b659f487c4a66fcc0fdae338800edd449b0b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d60d37a6fd54a47e120f44432e4be684786c1a4dbaff2525ca72b779f5dd6841)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationLandscape",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationLandscape:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationLandscape(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationLandscapeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationLandscapeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5b057b267292950a968ab81d8cd775da6357d67d8b14a5fe915ee839885e2198)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationLandscape], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationLandscape],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a072f88381d9ef20bb67c7118a179e95956c5ec6b6cbf8a5869fb7e5dbf0780)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d645aafa0817c70e5eec510e997e3f5103ec30556a993c261eefed717037efc8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d05d7dfd792032636532949b2a038fcdabd03708f9914226fc2e2e78f8b0d83)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7cf22a1100ec0b3f2e30dfb2c3b09cb254eab3b77cc412aba8cb4a13c9ee2f23)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__672a98258de9131fb40b6bde7209bb3e6a0046087bef612e72571b055f056c72)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__57a3cef648c071d4365fa1cdc5513ff7d2f22ab300179c0b137d799aeed4ab21)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientation]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientation]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab9de4cd540ce960d6623bc4b97ffce5b810f95ed7efd3b2f00f739c4fd70ca6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fc1acf5df3e827660af169c0dd7165c2e85834a013ffc65425fc6086f203673a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putLandscape")
    def put_landscape(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationLandscape()

        return typing.cast(None, jsii.invoke(self, "putLandscape", [value]))

    @jsii.member(jsii_name="putPortrait")
    def put_portrait(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationPortrait()

        return typing.cast(None, jsii.invoke(self, "putPortrait", [value]))

    @jsii.member(jsii_name="putSquare")
    def put_square(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationSquare()

        return typing.cast(None, jsii.invoke(self, "putSquare", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetLandscape")
    def reset_landscape(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLandscape", []))

    @jsii.member(jsii_name="resetPortrait")
    def reset_portrait(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPortrait", []))

    @jsii.member(jsii_name="resetSquare")
    def reset_square(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSquare", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="landscape")
    def landscape(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationLandscapeOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationLandscapeOutputReference, jsii.get(self, "landscape"))

    @builtins.property
    @jsii.member(jsii_name="portrait")
    def portrait(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationPortraitOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationPortraitOutputReference", jsii.get(self, "portrait"))

    @builtins.property
    @jsii.member(jsii_name="square")
    def square(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationSquareOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationSquareOutputReference", jsii.get(self, "square"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="landscapeInput")
    def landscape_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationLandscape], jsii.get(self, "landscapeInput"))

    @builtins.property
    @jsii.member(jsii_name="portraitInput")
    def portrait_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationPortrait"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationPortrait"], jsii.get(self, "portraitInput"))

    @builtins.property
    @jsii.member(jsii_name="squareInput")
    def square_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationSquare"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationSquare"], jsii.get(self, "squareInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientation]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientation]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientation]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9f07f9d3fb99b1a72a88f8ec53fea575af8c420c63a868edfd0aeb0507b5d7c1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationPortrait",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationPortrait:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationPortrait(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationPortraitOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationPortraitOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7a5f0b59c2d9b1ba3e17bbf11b894d7248bc0b88a657e10541980009c6b491f5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationPortrait]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationPortrait], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationPortrait],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ec1240600e41fe46253b9677836b16e710b5a97b7cdd4a29066de71cb3da5a0f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationSquare",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationSquare:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationSquare(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationSquareOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationSquareOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__32f604af6c9f88f4c7d6f9d0984f6bb8669a064dc353359aa96bb45d830b62d7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationSquare]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationSquare], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationSquare],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5b1b1a20bc9800a961c55cf92b90db192862ae06beb9634574d14ca4155eb9e3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitMaxColors",
    jsii_struct_bases=[],
    name_mapping={"colors": "colors", "colors_var": "colorsVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitMaxColors:
    def __init__(
        self,
        *,
        colors: typing.Optional[builtins.str] = None,
        colors_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param colors: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        :param colors_var: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__08ac2487006c87ad398f1c746a001d75ae17faf8a41f384e81a2d4c5dd7216c8)
            check_type(argname="argument colors", value=colors, expected_type=type_hints["colors"])
            check_type(argname="argument colors_var", value=colors_var, expected_type=type_hints["colors_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if colors is not None:
            self._values["colors"] = colors
        if colors_var is not None:
            self._values["colors_var"] = colors_var

    @builtins.property
    def colors(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        '''
        result = self._values.get("colors")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def colors_var(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        result = self._values.get("colors_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitMaxColors(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitMaxColorsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitMaxColorsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__99db7d16bce350721cd1b4d9f500826efffaa754679c12d7e7e20114920b8563)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitMaxColorsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__377cf9621ed6963df8fb0f3a649df09ec26b122cde2fa00c0fdcba55b2163e5b)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitMaxColorsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2c2e8545f760e37205d5258c6fd8b566ede12ec02767517d057323478f8843cb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__deafa2e00e11c7f63ca6f549dc93c3766e478b6e8b121d154c8e201eda3fb642)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__074e958441ada59b2c3cf39a2b90e5fdcb3d09bc37939f1700833c19843aca62)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitMaxColors]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitMaxColors]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bca54f4a3a51d5f0b155e5651feeeafb02a50c573d02a0dd6ba644a5aa4d9d77)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitMaxColorsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitMaxColorsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ac50396fb9e02f3f508c5d2ed1f9d4186116410715894b2131ebbe4279e6c73)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColors")
    def reset_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColors", []))

    @jsii.member(jsii_name="resetColorsVar")
    def reset_colors_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorsVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorsInput")
    def colors_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsInput"))

    @builtins.property
    @jsii.member(jsii_name="colorsVarInput")
    def colors_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsVarInput"))

    @builtins.property
    @jsii.member(jsii_name="colors")
    def colors(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colors"))

    @colors.setter
    def colors(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9803b009b1cf1414b62c1f79b99697b739c06a7bccd75e302cb1a67480c02f8e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colors", value)

    @builtins.property
    @jsii.member(jsii_name="colorsVar")
    def colors_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorsVar"))

    @colors_var.setter
    def colors_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__13ed5d208e68d4023e68807fe62c22e10820b9fee92fbbf355984aae25ac7be4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorsVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitMaxColors]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitMaxColors]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitMaxColors]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1ae2b245b7baf641f4624d265a28c04ab925337ffc2232b0319ed0341bb572a0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitMirror",
    jsii_struct_bases=[],
    name_mapping={
        "horizontal": "horizontal",
        "horizontal_var": "horizontalVar",
        "vertical": "vertical",
        "vertical_var": "verticalVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitMirror:
    def __init__(
        self,
        *,
        horizontal: typing.Optional[builtins.str] = None,
        horizontal_var: typing.Optional[builtins.str] = None,
        vertical: typing.Optional[builtins.str] = None,
        vertical_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param horizontal: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        :param horizontal_var: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        :param vertical: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        :param vertical_var: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__777c060780fd74b3a46f72c0c09fe8224fdb9d4edc813d988f64cf669c894498)
            check_type(argname="argument horizontal", value=horizontal, expected_type=type_hints["horizontal"])
            check_type(argname="argument horizontal_var", value=horizontal_var, expected_type=type_hints["horizontal_var"])
            check_type(argname="argument vertical", value=vertical, expected_type=type_hints["vertical"])
            check_type(argname="argument vertical_var", value=vertical_var, expected_type=type_hints["vertical_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if horizontal is not None:
            self._values["horizontal"] = horizontal
        if horizontal_var is not None:
            self._values["horizontal_var"] = horizontal_var
        if vertical is not None:
            self._values["vertical"] = vertical
        if vertical_var is not None:
            self._values["vertical_var"] = vertical_var

    @builtins.property
    def horizontal(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        '''
        result = self._values.get("horizontal")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def horizontal_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        '''
        result = self._values.get("horizontal_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        '''
        result = self._values.get("vertical")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        result = self._values.get("vertical_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitMirror(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitMirrorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitMirrorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cb684e5e2a6782ff9299421b98b0dbf4298bc19ccf83910becb86d01b944dcfd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitMirrorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e8d8ab8b81a731438d5f45896cedcc17fc36c7599e8f03f63b25d5e6864d1b46)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitMirrorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__02db076d11fd1990811ce6eaf13984ea3e2e3165c1383cbef6fb5fdfca4c993e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fd9f60b81d4d78d84d0f0e747366e497fb351356b930ac50d00338ba21366f40)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__97323754a12f372b128958b7d99ab3fe90fba2979eedff1556adc92448cb8e82)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitMirror]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitMirror]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7094cb5d8ea87e7859a10ea79324296234665670a9fe84c2065598cb2283d73f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitMirrorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitMirrorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a261560832b398d40b2c67aa0296ec248478e88063fb68c5bca945ed6384bb72)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHorizontal")
    def reset_horizontal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontal", []))

    @jsii.member(jsii_name="resetHorizontalVar")
    def reset_horizontal_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontalVar", []))

    @jsii.member(jsii_name="resetVertical")
    def reset_vertical(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVertical", []))

    @jsii.member(jsii_name="resetVerticalVar")
    def reset_vertical_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVerticalVar", []))

    @builtins.property
    @jsii.member(jsii_name="horizontalInput")
    def horizontal_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontalVarInput")
    def horizontal_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalInput")
    def vertical_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalVarInput")
    def vertical_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontal")
    def horizontal(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontal"))

    @horizontal.setter
    def horizontal(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__23f8cc3254a75702d1a070c5d46dfcc97b4a17d3b35a01db682f4bc1ac811d19)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontal", value)

    @builtins.property
    @jsii.member(jsii_name="horizontalVar")
    def horizontal_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontalVar"))

    @horizontal_var.setter
    def horizontal_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3cb083271f8f397b5b095b90ee99026d869be9273c834b0340be47c5bd8f329e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontalVar", value)

    @builtins.property
    @jsii.member(jsii_name="vertical")
    def vertical(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "vertical"))

    @vertical.setter
    def vertical(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__300fe45309f74c91fafe4dd8bb67be6a4fef10f25d5db6cf7e3118bcacfbcbc6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "vertical", value)

    @builtins.property
    @jsii.member(jsii_name="verticalVar")
    def vertical_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "verticalVar"))

    @vertical_var.setter
    def vertical_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5105359cb22b3dc6cbde504ad4e62a20164da207e5cd0845f55564dbab23f21b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "verticalVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitMirror]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitMirror]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitMirror]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0914b09e1a50663dafadab4f5eba388c852c80af0363f113efdbd5b08e1184ac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitMonoHue",
    jsii_struct_bases=[],
    name_mapping={"hue": "hue", "hue_var": "hueVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitMonoHue:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__59bc4947f6292c907f63533714ba88776c51c89b82388b2acaf58694ea127bd4)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitMonoHue(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitMonoHueList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitMonoHueList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a7801cdcec283b82bea499d026650c2ce380d122766ea6bee45dbfb4e486e4f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitMonoHueOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d15ec16270dba7601fb5805c0586b073666d07294b7311b58145e096ba8f7a3b)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitMonoHueOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ec018edb043049c89cfbf069ffcdb896587720853a66356ece11e439884b9467)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d877e2c3646c736cf65293c908c7afb6a0605c9ca2a9b8bd6254890750e8b06a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__955877542fa5f7ec65fbbebaea4d132e452cb7da0d8df5d60365b4643841895f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitMonoHue]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitMonoHue]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6dfdd741cfde544b89a0b42154e9c9772f497910059fe4327c326afba9f230bb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitMonoHueOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitMonoHueOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ffe8a4914c9ae44f007e26d30af9727e49eb4f804f4ff1c170183e2bbb5a74f9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fcec5f1c56bdfce4a43be56538ebd5c6fd0765253467ec7469b064ac25a462bd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d36001782420285751187608147cb4a0fe770a584535cfbd1cd49581f274501e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitMonoHue]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitMonoHue]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitMonoHue]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__509bb280f287cf4d1e0777171c04bb36ee09c22abce1696f67553f6ca14f4c6f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitOpacity",
    jsii_struct_bases=[],
    name_mapping={"opacity": "opacity", "opacity_var": "opacityVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitOpacity:
    def __init__(
        self,
        *,
        opacity: typing.Optional[builtins.str] = None,
        opacity_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param opacity: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param opacity_var: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__acedb58049aa8533ecd8ac9eae95edef741bdf0b4240a2b958cede24d0ab3c1b)
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument opacity_var", value=opacity_var, expected_type=type_hints["opacity_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if opacity is not None:
            self._values["opacity"] = opacity
        if opacity_var is not None:
            self._values["opacity_var"] = opacity_var

    @builtins.property
    def opacity(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def opacity_var(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        result = self._values.get("opacity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitOpacity(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitOpacityList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitOpacityList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cf212a823a0f4d74ae1ce333335f73f7c24b8be553c0a69ddbe5ca8b344b738f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitOpacityOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d2fde803ea88061285c6183234bf89d67fdc1a1eb27863f7ff5cc05c7cb1500e)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitOpacityOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5db541ebab2ff37df2c087d233c64f63fda397b5af6fbabf37f3a290b8678eba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__52bc7508f1a5d7ced34800a7d62cc625354303e6c1f8d0109a1c3a180235a45c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc3c740f698cc19ed80ffdb92d52ef276a63dbad7cc178331c5c31bf726537fe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitOpacity]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitOpacity]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cb70c6fc8929494a69a4f9ef9d66bce38b59437770c8295ae7bbeb98a7e6a063)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitOpacityOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitOpacityOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ce462b47f2b0f55bcaa64d8ca385f291f1c511e86c8e4b71227ccde87ce396a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetOpacityVar")
    def reset_opacity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacityVar", []))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityVarInput")
    def opacity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacity"))

    @opacity.setter
    def opacity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d9f51b2a443fd251c02c731f59f4e79ef10021f5d059de1d0b9c06fa230406e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacity", value)

    @builtins.property
    @jsii.member(jsii_name="opacityVar")
    def opacity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacityVar"))

    @opacity_var.setter
    def opacity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__624ce1955c14cdfac403649b421958f9d2fd55736a8f97795978f50b879477df)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacityVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitOpacity]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitOpacity]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitOpacity]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1cf788b434eaae630e8c30b62e7c32efbc59e9ba9265d7a101765b660f1824b8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea876497d75593c986320862424c4853a509742abbc8ef56f047d2e781c6444e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putBackgroundColor")
    def put_background_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa3d6faa8ee595a0ccdec723da535a4c535d305c0862e3040b3ca2ce7513ff49)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBackgroundColor", [value]))

    @jsii.member(jsii_name="putBlur")
    def put_blur(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitBlur, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8e8446d4cb2f880e5d7ba6e8618a6d8ce9184942d798bb2c82d1016a82b368fd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBlur", [value]))

    @jsii.member(jsii_name="putChromaKey")
    def put_chroma_key(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitChromaKey, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__36481dea4e79c59df438c4418fcb8313d541bd775e7fbc7f86b038ec3c4fc698)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putChromaKey", [value]))

    @jsii.member(jsii_name="putComposite")
    def put_composite(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitComposite, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8e0e13aeac7afa6e3344631ff2f9211f402e5ce49d6c0140b729b1017d8a45f2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putComposite", [value]))

    @jsii.member(jsii_name="putCompound")
    def put_compound(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitCompound, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f9da7c76b2f7884f1cdd28439a863185183827f071780fec400f4dfa98efd3d4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCompound", [value]))

    @jsii.member(jsii_name="putContrast")
    def put_contrast(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitContrast, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__832c568b501bff3216f4ef80440498f0041cb8d7a855a1f9652eca527c4254bc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putContrast", [value]))

    @jsii.member(jsii_name="putGoop")
    def put_goop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitGoop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c85abcd2c1126588011b740de2adfa9f030b2707e24efddea23f6e1783242062)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGoop", [value]))

    @jsii.member(jsii_name="putGrayscale")
    def put_grayscale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitGrayscale, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3f592dd8d047ab5e68c6473eeae27ccd5dea3ef8623a8d42ab6c256fd605282c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGrayscale", [value]))

    @jsii.member(jsii_name="putHsl")
    def put_hsl(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitHsl, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__44da562189feddec9cdd76177f253442ba0e5fabd8a776304a3dc9dd4bae4c9a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsl", [value]))

    @jsii.member(jsii_name="putHsv")
    def put_hsv(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitHsv, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e528419bd5be571995539f6b646fdbc837af966a9fc8d2c67324542b55c27632)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsv", [value]))

    @jsii.member(jsii_name="putIfDimension")
    def put_if_dimension(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfDimension, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f1deac63b6c91697e93dc73e585d79c870a5dce93b8298b14d86b2b66690294a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfDimension", [value]))

    @jsii.member(jsii_name="putIfOrientation")
    def put_if_orientation(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df1898844ec30ba8a2e90f59052250c484d0acb08807e7be68926b082985376e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfOrientation", [value]))

    @jsii.member(jsii_name="putMaxColors")
    def put_max_colors(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitMaxColors, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7c0645d4a72605984e1b3d4fa8c19d73263c7ddc81ddeb749dc7b4b485ed6944)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMaxColors", [value]))

    @jsii.member(jsii_name="putMirror")
    def put_mirror(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitMirror, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a30b8e79f4b106fb798e968f2debd5424864959e0a70e584ce18e86e14eb7bd2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMirror", [value]))

    @jsii.member(jsii_name="putMonoHue")
    def put_mono_hue(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitMonoHue, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7047f65b5f8b2b2eb9341e71edc88ac329187b12b44f5ce80794e007b2a85ad8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMonoHue", [value]))

    @jsii.member(jsii_name="putOpacity")
    def put_opacity(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitOpacity, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__51f5520dc1fcf62da02766a656d9561b66d10d97a725d339ea1e0ac09356925a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putOpacity", [value]))

    @jsii.member(jsii_name="putRemoveColor")
    def put_remove_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitRemoveColor", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f844c55f51e2db344f31e8dbb66113fb092aa78bc8cf9a26de33ee11efd06cee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRemoveColor", [value]))

    @jsii.member(jsii_name="putUnsharpMask")
    def put_unsharp_mask(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitUnsharpMask", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__42b52f879327910dec16b345452437d17bcab440e0118c0a3a7e7e0b59118552)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putUnsharpMask", [value]))

    @jsii.member(jsii_name="resetBackgroundColor")
    def reset_background_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBackgroundColor", []))

    @jsii.member(jsii_name="resetBlur")
    def reset_blur(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBlur", []))

    @jsii.member(jsii_name="resetChromaKey")
    def reset_chroma_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChromaKey", []))

    @jsii.member(jsii_name="resetComposite")
    def reset_composite(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetComposite", []))

    @jsii.member(jsii_name="resetCompound")
    def reset_compound(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCompound", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetGoop")
    def reset_goop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGoop", []))

    @jsii.member(jsii_name="resetGrayscale")
    def reset_grayscale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGrayscale", []))

    @jsii.member(jsii_name="resetHsl")
    def reset_hsl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsl", []))

    @jsii.member(jsii_name="resetHsv")
    def reset_hsv(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsv", []))

    @jsii.member(jsii_name="resetIfDimension")
    def reset_if_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfDimension", []))

    @jsii.member(jsii_name="resetIfOrientation")
    def reset_if_orientation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfOrientation", []))

    @jsii.member(jsii_name="resetMaxColors")
    def reset_max_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxColors", []))

    @jsii.member(jsii_name="resetMirror")
    def reset_mirror(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMirror", []))

    @jsii.member(jsii_name="resetMonoHue")
    def reset_mono_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonoHue", []))

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetRemoveColor")
    def reset_remove_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRemoveColor", []))

    @jsii.member(jsii_name="resetUnsharpMask")
    def reset_unsharp_mask(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUnsharpMask", []))

    @builtins.property
    @jsii.member(jsii_name="backgroundColor")
    def background_color(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitBackgroundColorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitBackgroundColorList, jsii.get(self, "backgroundColor"))

    @builtins.property
    @jsii.member(jsii_name="blur")
    def blur(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitBlurList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitBlurList, jsii.get(self, "blur"))

    @builtins.property
    @jsii.member(jsii_name="chromaKey")
    def chroma_key(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitChromaKeyList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitChromaKeyList, jsii.get(self, "chromaKey"))

    @builtins.property
    @jsii.member(jsii_name="composite")
    def composite(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitCompositeList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitCompositeList, jsii.get(self, "composite"))

    @builtins.property
    @jsii.member(jsii_name="compound")
    def compound(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitCompoundList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitCompoundList, jsii.get(self, "compound"))

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitContrastList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitContrastList, jsii.get(self, "contrast"))

    @builtins.property
    @jsii.member(jsii_name="goop")
    def goop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitGoopList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitGoopList, jsii.get(self, "goop"))

    @builtins.property
    @jsii.member(jsii_name="grayscale")
    def grayscale(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitGrayscaleList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitGrayscaleList, jsii.get(self, "grayscale"))

    @builtins.property
    @jsii.member(jsii_name="hsl")
    def hsl(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitHslList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitHslList, jsii.get(self, "hsl"))

    @builtins.property
    @jsii.member(jsii_name="hsv")
    def hsv(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitHsvList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitHsvList, jsii.get(self, "hsv"))

    @builtins.property
    @jsii.member(jsii_name="ifDimension")
    def if_dimension(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionList, jsii.get(self, "ifDimension"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientation")
    def if_orientation(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationList, jsii.get(self, "ifOrientation"))

    @builtins.property
    @jsii.member(jsii_name="maxColors")
    def max_colors(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitMaxColorsList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitMaxColorsList, jsii.get(self, "maxColors"))

    @builtins.property
    @jsii.member(jsii_name="mirror")
    def mirror(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitMirrorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitMirrorList, jsii.get(self, "mirror"))

    @builtins.property
    @jsii.member(jsii_name="monoHue")
    def mono_hue(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitMonoHueList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitMonoHueList, jsii.get(self, "monoHue"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitOpacityList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitOpacityList, jsii.get(self, "opacity"))

    @builtins.property
    @jsii.member(jsii_name="removeColor")
    def remove_color(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitRemoveColorList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitRemoveColorList", jsii.get(self, "removeColor"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMask")
    def unsharp_mask(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitUnsharpMaskList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitUnsharpMaskList", jsii.get(self, "unsharpMask"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColorInput")
    def background_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitBackgroundColor]]], jsii.get(self, "backgroundColorInput"))

    @builtins.property
    @jsii.member(jsii_name="blurInput")
    def blur_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitBlur]]], jsii.get(self, "blurInput"))

    @builtins.property
    @jsii.member(jsii_name="chromaKeyInput")
    def chroma_key_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitChromaKey]]], jsii.get(self, "chromaKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="compositeInput")
    def composite_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitComposite]]], jsii.get(self, "compositeInput"))

    @builtins.property
    @jsii.member(jsii_name="compoundInput")
    def compound_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitCompound]]], jsii.get(self, "compoundInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitContrast]]], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="goopInput")
    def goop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitGoop]]], jsii.get(self, "goopInput"))

    @builtins.property
    @jsii.member(jsii_name="grayscaleInput")
    def grayscale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitGrayscale]]], jsii.get(self, "grayscaleInput"))

    @builtins.property
    @jsii.member(jsii_name="hslInput")
    def hsl_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitHsl]]], jsii.get(self, "hslInput"))

    @builtins.property
    @jsii.member(jsii_name="hsvInput")
    def hsv_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitHsv]]], jsii.get(self, "hsvInput"))

    @builtins.property
    @jsii.member(jsii_name="ifDimensionInput")
    def if_dimension_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfDimension]]], jsii.get(self, "ifDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientationInput")
    def if_orientation_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientation]]], jsii.get(self, "ifOrientationInput"))

    @builtins.property
    @jsii.member(jsii_name="maxColorsInput")
    def max_colors_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitMaxColors]]], jsii.get(self, "maxColorsInput"))

    @builtins.property
    @jsii.member(jsii_name="mirrorInput")
    def mirror_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitMirror]]], jsii.get(self, "mirrorInput"))

    @builtins.property
    @jsii.member(jsii_name="monoHueInput")
    def mono_hue_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitMonoHue]]], jsii.get(self, "monoHueInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitOpacity]]], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="removeColorInput")
    def remove_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitRemoveColor"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitRemoveColor"]]], jsii.get(self, "removeColorInput"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMaskInput")
    def unsharp_mask_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitUnsharpMask"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitUnsharpMask"]]], jsii.get(self, "unsharpMaskInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortrait]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortrait], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortrait],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__11b5f142e9ff1121640350748c37342aabef1c183377c0010849efbde9c1b313)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitRemoveColor",
    jsii_struct_bases=[],
    name_mapping={
        "color": "color",
        "color_var": "colorVar",
        "feather": "feather",
        "feather_var": "featherVar",
        "tolerance": "tolerance",
        "tolerance_var": "toleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitRemoveColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
        feather: typing.Optional[builtins.str] = None,
        feather_var: typing.Optional[builtins.str] = None,
        tolerance: typing.Optional[builtins.str] = None,
        tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        :param feather: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        :param feather_var: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        :param tolerance: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        :param tolerance_var: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b6b9f2cc05908f5a1f89ffeb1561be1e14478e81bce809b789bbd939cb40b99e)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
            check_type(argname="argument feather", value=feather, expected_type=type_hints["feather"])
            check_type(argname="argument feather_var", value=feather_var, expected_type=type_hints["feather_var"])
            check_type(argname="argument tolerance", value=tolerance, expected_type=type_hints["tolerance"])
            check_type(argname="argument tolerance_var", value=tolerance_var, expected_type=type_hints["tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var
        if feather is not None:
            self._values["feather"] = feather
        if feather_var is not None:
            self._values["feather_var"] = feather_var
        if tolerance is not None:
            self._values["tolerance"] = tolerance
        if tolerance_var is not None:
            self._values["tolerance_var"] = tolerance_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        '''
        result = self._values.get("feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather_var(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        '''
        result = self._values.get("feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        '''
        result = self._values.get("tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance_var(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        result = self._values.get("tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitRemoveColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitRemoveColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitRemoveColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a814553271b450ac9a9b62ff52a2200d3c53387c5ebc42ed46ee9137042db7e2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitRemoveColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ad81c51d6e8f8b607a2a83ab5cea0cffd10236005d621cd98a493a721d7b4cd)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitRemoveColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7c463059626d32dc5ab5a6b77aa26fc8b98c5174686328d6f4e5341577b3db9b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__387c1017d8779a9f80cb6daaa59031933a6c5b1d885ee63c29524db75747f653)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c2f75193ae49e2cc229bef746f96fcb36b4cd3a2269c90c28d688f6ba8b68d25)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitRemoveColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitRemoveColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitRemoveColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__44b621af7900f6afe3ff721c86024c8ef11372521b1cff148d61ee3c31f492cc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitRemoveColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitRemoveColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9e90806fa1f49af7cc687fb69323ca6cbbb3960c6dd954c2d98d043dbb9b33dd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @jsii.member(jsii_name="resetFeather")
    def reset_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeather", []))

    @jsii.member(jsii_name="resetFeatherVar")
    def reset_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatherVar", []))

    @jsii.member(jsii_name="resetTolerance")
    def reset_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTolerance", []))

    @jsii.member(jsii_name="resetToleranceVar")
    def reset_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featherInput")
    def feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherInput"))

    @builtins.property
    @jsii.member(jsii_name="featherVarInput")
    def feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceInput")
    def tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceVarInput")
    def tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7041f51b5e571afe30ca1e0cdbd96f0637e394d98c953258abb27726248abc10)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3d0fcf49d9c3ecf364dc07af681c32489f839bc1c8facccb5cd40e1771d44f38)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="feather")
    def feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "feather"))

    @feather.setter
    def feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6a25588bc81181616283aaf8399d7fb4d5b053699fdb8fe5b01ddf5a1788b4a8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "feather", value)

    @builtins.property
    @jsii.member(jsii_name="featherVar")
    def feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featherVar"))

    @feather_var.setter
    def feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f4d563cec01e376ce886afc7b1d4ee39313f3fb6b242b139e2d345dde849a00a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featherVar", value)

    @builtins.property
    @jsii.member(jsii_name="tolerance")
    def tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tolerance"))

    @tolerance.setter
    def tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d6f3b7474ddfb77b96ab9f104627ee2bb8bf995ef2623c85dca044b5300b6bde)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tolerance", value)

    @builtins.property
    @jsii.member(jsii_name="toleranceVar")
    def tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "toleranceVar"))

    @tolerance_var.setter
    def tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__05da70983c0ce8cc9492efa8bf44d1d5528b24bd6ba8a3bf516e5495fe1c4c9d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "toleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitRemoveColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitRemoveColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitRemoveColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__46fdd44352866de6434a25bbb1bf397343d33fa71b9c0519d1ae56b3605b4aa7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitUnsharpMask",
    jsii_struct_bases=[],
    name_mapping={
        "gain": "gain",
        "gain_var": "gainVar",
        "sigma": "sigma",
        "sigma_var": "sigmaVar",
        "threshold": "threshold",
        "threshold_var": "thresholdVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitUnsharpMask:
    def __init__(
        self,
        *,
        gain: typing.Optional[builtins.str] = None,
        gain_var: typing.Optional[builtins.str] = None,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
        threshold: typing.Optional[builtins.str] = None,
        threshold_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param gain: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        :param gain_var: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        :param sigma: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        :param threshold: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        :param threshold_var: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f1a7539160676ae202d4b85288a9740ee68a549c5675b7d7261d4b03b36a735d)
            check_type(argname="argument gain", value=gain, expected_type=type_hints["gain"])
            check_type(argname="argument gain_var", value=gain_var, expected_type=type_hints["gain_var"])
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
            check_type(argname="argument threshold", value=threshold, expected_type=type_hints["threshold"])
            check_type(argname="argument threshold_var", value=threshold_var, expected_type=type_hints["threshold_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if gain is not None:
            self._values["gain"] = gain
        if gain_var is not None:
            self._values["gain_var"] = gain_var
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var
        if threshold is not None:
            self._values["threshold"] = threshold
        if threshold_var is not None:
            self._values["threshold_var"] = threshold_var

    @builtins.property
    def gain(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        '''
        result = self._values.get("gain")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gain_var(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        '''
        result = self._values.get("gain_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        '''
        result = self._values.get("threshold")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold_var(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        result = self._values.get("threshold_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitUnsharpMask(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitUnsharpMaskList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitUnsharpMaskList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a77f4afbfadab5ee0327959d1d21519b4abe194557e2e53c382227923b528d7d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitUnsharpMaskOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa705589e3239d0986ee4f351582aed076a969d77eb05a98cf22b4f654689244)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitUnsharpMaskOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8e547b03ae0955ac62ce589e923349718ee705056c692e545894a37b54aa9a5a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__92ac980cfa9b1fe1373b3d48064c7d49f568de016c2a4ec13161d95e455c8c15)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ff7db05ec07cc27fb456efd3e56abb41ad94cda7c95ea4493a9aa0969256b49c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitUnsharpMask]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitUnsharpMask]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitUnsharpMask]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d4e2965b320b340cebdb18c66e2204b8742f17cabcd847c31b15278e83ee95d5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitUnsharpMaskOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitUnsharpMaskOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c1b6ad74dadab67a52b8b61657e56e659730cdebdf2c2873a757857e8ddfe40a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetGain")
    def reset_gain(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGain", []))

    @jsii.member(jsii_name="resetGainVar")
    def reset_gain_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGainVar", []))

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @jsii.member(jsii_name="resetThreshold")
    def reset_threshold(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThreshold", []))

    @jsii.member(jsii_name="resetThresholdVar")
    def reset_threshold_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThresholdVar", []))

    @builtins.property
    @jsii.member(jsii_name="gainInput")
    def gain_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainInput"))

    @builtins.property
    @jsii.member(jsii_name="gainVarInput")
    def gain_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdInput")
    def threshold_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdVarInput")
    def threshold_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gain")
    def gain(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gain"))

    @gain.setter
    def gain(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__05972392be930e58cbc2635a69f585e5695a78593d8643ad2c8f61c7ca8ff64f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gain", value)

    @builtins.property
    @jsii.member(jsii_name="gainVar")
    def gain_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gainVar"))

    @gain_var.setter
    def gain_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__43c45642227a1e69c47d52f5d1abe9ccfc1a454f895f4328fc533e475d9529d1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gainVar", value)

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4534a7cedac18fd076dac3861a1af8a5e2ceae038e4b0d1ac47c1294265adba6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__13b121fffa6b143cf015541f82329d2d44e5814f3a4206bca7dd9769ef04e537)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="threshold")
    def threshold(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "threshold"))

    @threshold.setter
    def threshold(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8dc9da09a4a7c0b2c8af1b2c07e56ee1422bc05a974d51d4e0e490a0f82cf3f8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "threshold", value)

    @builtins.property
    @jsii.member(jsii_name="thresholdVar")
    def threshold_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "thresholdVar"))

    @threshold_var.setter
    def threshold_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__33bbda3a44362fd66a00025cb8d0a185184ab866a9a00d80798e39f5c7e1052a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "thresholdVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitUnsharpMask]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitUnsharpMask]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitUnsharpMask]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__196db9ecea09ae78c3043fa2e2275c5f45fbb2bfba7ec22f1263c4c78b89e4ff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquare",
    jsii_struct_bases=[],
    name_mapping={
        "background_color": "backgroundColor",
        "blur": "blur",
        "chroma_key": "chromaKey",
        "composite": "composite",
        "compound": "compound",
        "contrast": "contrast",
        "goop": "goop",
        "grayscale": "grayscale",
        "hsl": "hsl",
        "hsv": "hsv",
        "if_dimension": "ifDimension",
        "if_orientation": "ifOrientation",
        "max_colors": "maxColors",
        "mirror": "mirror",
        "mono_hue": "monoHue",
        "opacity": "opacity",
        "remove_color": "removeColor",
        "unsharp_mask": "unsharpMask",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquare:
    def __init__(
        self,
        *,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareBackgroundColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareBlur", typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareChromaKey", typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareComposite", typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareCompound", typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareContrast", typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareGoop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareGrayscale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareHsl", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareHsv", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfDimension", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfOrientation", typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareMaxColors", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareMirror", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareMonoHue", typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareOpacity", typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareRemoveColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareUnsharpMask", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__80a92e11321337992be9f77355cb8125888ec9a896f63500abd3129b82ea173f)
            check_type(argname="argument background_color", value=background_color, expected_type=type_hints["background_color"])
            check_type(argname="argument blur", value=blur, expected_type=type_hints["blur"])
            check_type(argname="argument chroma_key", value=chroma_key, expected_type=type_hints["chroma_key"])
            check_type(argname="argument composite", value=composite, expected_type=type_hints["composite"])
            check_type(argname="argument compound", value=compound, expected_type=type_hints["compound"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument goop", value=goop, expected_type=type_hints["goop"])
            check_type(argname="argument grayscale", value=grayscale, expected_type=type_hints["grayscale"])
            check_type(argname="argument hsl", value=hsl, expected_type=type_hints["hsl"])
            check_type(argname="argument hsv", value=hsv, expected_type=type_hints["hsv"])
            check_type(argname="argument if_dimension", value=if_dimension, expected_type=type_hints["if_dimension"])
            check_type(argname="argument if_orientation", value=if_orientation, expected_type=type_hints["if_orientation"])
            check_type(argname="argument max_colors", value=max_colors, expected_type=type_hints["max_colors"])
            check_type(argname="argument mirror", value=mirror, expected_type=type_hints["mirror"])
            check_type(argname="argument mono_hue", value=mono_hue, expected_type=type_hints["mono_hue"])
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument remove_color", value=remove_color, expected_type=type_hints["remove_color"])
            check_type(argname="argument unsharp_mask", value=unsharp_mask, expected_type=type_hints["unsharp_mask"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if background_color is not None:
            self._values["background_color"] = background_color
        if blur is not None:
            self._values["blur"] = blur
        if chroma_key is not None:
            self._values["chroma_key"] = chroma_key
        if composite is not None:
            self._values["composite"] = composite
        if compound is not None:
            self._values["compound"] = compound
        if contrast is not None:
            self._values["contrast"] = contrast
        if goop is not None:
            self._values["goop"] = goop
        if grayscale is not None:
            self._values["grayscale"] = grayscale
        if hsl is not None:
            self._values["hsl"] = hsl
        if hsv is not None:
            self._values["hsv"] = hsv
        if if_dimension is not None:
            self._values["if_dimension"] = if_dimension
        if if_orientation is not None:
            self._values["if_orientation"] = if_orientation
        if max_colors is not None:
            self._values["max_colors"] = max_colors
        if mirror is not None:
            self._values["mirror"] = mirror
        if mono_hue is not None:
            self._values["mono_hue"] = mono_hue
        if opacity is not None:
            self._values["opacity"] = opacity
        if remove_color is not None:
            self._values["remove_color"] = remove_color
        if unsharp_mask is not None:
            self._values["unsharp_mask"] = unsharp_mask

    @builtins.property
    def background_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareBackgroundColor"]]]:
        '''background_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        '''
        result = self._values.get("background_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareBackgroundColor"]]], result)

    @builtins.property
    def blur(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareBlur"]]]:
        '''blur block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        '''
        result = self._values.get("blur")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareBlur"]]], result)

    @builtins.property
    def chroma_key(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareChromaKey"]]]:
        '''chroma_key block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        '''
        result = self._values.get("chroma_key")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareChromaKey"]]], result)

    @builtins.property
    def composite(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareComposite"]]]:
        '''composite block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        '''
        result = self._values.get("composite")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareComposite"]]], result)

    @builtins.property
    def compound(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareCompound"]]]:
        '''compound block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        '''
        result = self._values.get("compound")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareCompound"]]], result)

    @builtins.property
    def contrast(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareContrast"]]]:
        '''contrast block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareContrast"]]], result)

    @builtins.property
    def goop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareGoop"]]]:
        '''goop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        '''
        result = self._values.get("goop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareGoop"]]], result)

    @builtins.property
    def grayscale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareGrayscale"]]]:
        '''grayscale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        '''
        result = self._values.get("grayscale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareGrayscale"]]], result)

    @builtins.property
    def hsl(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareHsl"]]]:
        '''hsl block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        '''
        result = self._values.get("hsl")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareHsl"]]], result)

    @builtins.property
    def hsv(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareHsv"]]]:
        '''hsv block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        '''
        result = self._values.get("hsv")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareHsv"]]], result)

    @builtins.property
    def if_dimension(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfDimension"]]]:
        '''if_dimension block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        '''
        result = self._values.get("if_dimension")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfDimension"]]], result)

    @builtins.property
    def if_orientation(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfOrientation"]]]:
        '''if_orientation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        '''
        result = self._values.get("if_orientation")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfOrientation"]]], result)

    @builtins.property
    def max_colors(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareMaxColors"]]]:
        '''max_colors block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        '''
        result = self._values.get("max_colors")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareMaxColors"]]], result)

    @builtins.property
    def mirror(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareMirror"]]]:
        '''mirror block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        '''
        result = self._values.get("mirror")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareMirror"]]], result)

    @builtins.property
    def mono_hue(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareMonoHue"]]]:
        '''mono_hue block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        '''
        result = self._values.get("mono_hue")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareMonoHue"]]], result)

    @builtins.property
    def opacity(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareOpacity"]]]:
        '''opacity block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareOpacity"]]], result)

    @builtins.property
    def remove_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareRemoveColor"]]]:
        '''remove_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        '''
        result = self._values.get("remove_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareRemoveColor"]]], result)

    @builtins.property
    def unsharp_mask(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareUnsharpMask"]]]:
        '''unsharp_mask block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        result = self._values.get("unsharp_mask")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareUnsharpMask"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquare(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareBackgroundColor",
    jsii_struct_bases=[],
    name_mapping={"color": "color", "color_var": "colorVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareBackgroundColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fbb9df42344c268bd458811d37d22c0c303cfedd29b479bd8607c3791016c8bf)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareBackgroundColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareBackgroundColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareBackgroundColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9f7600702a1bea1e8340ffa8595d6aec15db9a5494d61012ba1f2cd3cb64913f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareBackgroundColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__60c42777d0422d62d8f7f8280150f5921bdbd177e180a9406e71b87c15fe7fdb)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareBackgroundColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e57bcde178460f1e2af348b7778c7a4e99dda3e4765577d483358fbacb5bf56)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__803398f9426c8d9d316a374418256716c4c3b1296fd273eca4fe170460399fb3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5a7ecba10bfacab61dc0da77dab48a9da4670b15e95f2ce172b83486a932c309)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareBackgroundColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareBackgroundColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4d11bd7dd60d2781c0304927cdf00e9dae24d7909fe540c6a743b97de5d62c65)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareBackgroundColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareBackgroundColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__086ace57e74a7d905d5d22acdece666f1daa03709427d5aae5b790098781c5d5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e7bbb80aee4671b1210ffb92f4c1ddb7dcffb79d9764058566e55b2085e75cc1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6b23944571ee8b64fd15097034612fe72834cbf41670f94674bfd59f3cfc742a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareBackgroundColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareBackgroundColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareBackgroundColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a1fb82327f05f98d37204c4dbaa324a4c220a6d04a8d6994e8c63ae63d23094e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareBlur",
    jsii_struct_bases=[],
    name_mapping={"sigma": "sigma", "sigma_var": "sigmaVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareBlur:
    def __init__(
        self,
        *,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param sigma: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8f249e1cb18241a9df11a08731ae68fa4d1cc8b94f269a6ac240f637d6810eb8)
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareBlur(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareBlurList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareBlurList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__210e3b62786eaac956d81f4cd838d049efcaf1c9b7f2880d2da94f78f4dcf003)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareBlurOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a6a1b3bebef6af9e9a47cd07b2b3c6f634d8c977cda01e8c55d2ed45a15d45d5)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareBlurOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__913b5eda3aef1e1137fe7167d7c15b772b1be092bb2baff5b6d469adec64c2f0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5e87066983189651ac7d64dd6697cb87731c2a9edb1cc5fbc5b5579d903bff82)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4854c6fe86ae16a1ca50991b65ee6951428b7ee1c128914d659c96a66dfc1b99)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareBlur]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareBlur]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a2b4f80aa219c2ff1bc4956bdb4e252d40676bb49709951fcc766e25cff9e75d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareBlurOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareBlurOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__388a10889b7c8a5fe0dc952dcca2433846d2be8f9909ac834685d48add7a3313)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9efc7717d37316ad261c35ac0f7def34c38461758f6b555127dde9fa1c624a57)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e2d0977644cce961e4b921490dd1021fb59a895447d7116e69805b972d459c2c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareBlur]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareBlur]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareBlur]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a606533ea8482a717b5cc9cf665ae1addb93e1c75ea86938d762e683dfc14ca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareChromaKey",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_feather": "hueFeather",
        "hue_feather_var": "hueFeatherVar",
        "hue_tolerance": "hueTolerance",
        "hue_tolerance_var": "hueToleranceVar",
        "hue_var": "hueVar",
        "lightness_feather": "lightnessFeather",
        "lightness_feather_var": "lightnessFeatherVar",
        "lightness_tolerance": "lightnessTolerance",
        "lightness_tolerance_var": "lightnessToleranceVar",
        "saturation_feather": "saturationFeather",
        "saturation_feather_var": "saturationFeatherVar",
        "saturation_tolerance": "saturationTolerance",
        "saturation_tolerance_var": "saturationToleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareChromaKey:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_feather: typing.Optional[builtins.str] = None,
        hue_feather_var: typing.Optional[builtins.str] = None,
        hue_tolerance: typing.Optional[builtins.str] = None,
        hue_tolerance_var: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness_feather: typing.Optional[builtins.str] = None,
        lightness_feather_var: typing.Optional[builtins.str] = None,
        lightness_tolerance: typing.Optional[builtins.str] = None,
        lightness_tolerance_var: typing.Optional[builtins.str] = None,
        saturation_feather: typing.Optional[builtins.str] = None,
        saturation_feather_var: typing.Optional[builtins.str] = None,
        saturation_tolerance: typing.Optional[builtins.str] = None,
        saturation_tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_feather: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        :param hue_feather_var: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        :param hue_tolerance: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        :param hue_tolerance_var: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        :param hue_var: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness_feather: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        :param lightness_feather_var: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        :param lightness_tolerance: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        :param lightness_tolerance_var: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        :param saturation_feather: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        :param saturation_feather_var: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        :param saturation_tolerance: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        :param saturation_tolerance_var: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d49ce00689dbb286ef40753754dce3acfd7031a7da3198a33f618a9bff07f0cd)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_feather", value=hue_feather, expected_type=type_hints["hue_feather"])
            check_type(argname="argument hue_feather_var", value=hue_feather_var, expected_type=type_hints["hue_feather_var"])
            check_type(argname="argument hue_tolerance", value=hue_tolerance, expected_type=type_hints["hue_tolerance"])
            check_type(argname="argument hue_tolerance_var", value=hue_tolerance_var, expected_type=type_hints["hue_tolerance_var"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness_feather", value=lightness_feather, expected_type=type_hints["lightness_feather"])
            check_type(argname="argument lightness_feather_var", value=lightness_feather_var, expected_type=type_hints["lightness_feather_var"])
            check_type(argname="argument lightness_tolerance", value=lightness_tolerance, expected_type=type_hints["lightness_tolerance"])
            check_type(argname="argument lightness_tolerance_var", value=lightness_tolerance_var, expected_type=type_hints["lightness_tolerance_var"])
            check_type(argname="argument saturation_feather", value=saturation_feather, expected_type=type_hints["saturation_feather"])
            check_type(argname="argument saturation_feather_var", value=saturation_feather_var, expected_type=type_hints["saturation_feather_var"])
            check_type(argname="argument saturation_tolerance", value=saturation_tolerance, expected_type=type_hints["saturation_tolerance"])
            check_type(argname="argument saturation_tolerance_var", value=saturation_tolerance_var, expected_type=type_hints["saturation_tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_feather is not None:
            self._values["hue_feather"] = hue_feather
        if hue_feather_var is not None:
            self._values["hue_feather_var"] = hue_feather_var
        if hue_tolerance is not None:
            self._values["hue_tolerance"] = hue_tolerance
        if hue_tolerance_var is not None:
            self._values["hue_tolerance_var"] = hue_tolerance_var
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness_feather is not None:
            self._values["lightness_feather"] = lightness_feather
        if lightness_feather_var is not None:
            self._values["lightness_feather_var"] = lightness_feather_var
        if lightness_tolerance is not None:
            self._values["lightness_tolerance"] = lightness_tolerance
        if lightness_tolerance_var is not None:
            self._values["lightness_tolerance_var"] = lightness_tolerance_var
        if saturation_feather is not None:
            self._values["saturation_feather"] = saturation_feather
        if saturation_feather_var is not None:
            self._values["saturation_feather_var"] = saturation_feather_var
        if saturation_tolerance is not None:
            self._values["saturation_tolerance"] = saturation_tolerance
        if saturation_tolerance_var is not None:
            self._values["saturation_tolerance_var"] = saturation_tolerance_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        '''
        result = self._values.get("hue_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        '''
        result = self._values.get("hue_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        '''
        result = self._values.get("hue_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        '''
        result = self._values.get("hue_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        '''
        result = self._values.get("lightness_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        '''
        result = self._values.get("lightness_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        '''
        result = self._values.get("lightness_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        '''
        result = self._values.get("lightness_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        '''
        result = self._values.get("saturation_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        '''
        result = self._values.get("saturation_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        '''
        result = self._values.get("saturation_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        result = self._values.get("saturation_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareChromaKey(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareChromaKeyList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareChromaKeyList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e90254bb0e6e23ffa4757c9b1b908c2dc33b5fa12ce0481ca3e5e2ee6d37fe99)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareChromaKeyOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2698d89669cb235c77d4eed9dbeaf9a1aef748b8a86af8c5f32b593a1b3eec86)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareChromaKeyOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a172bddb3bdb58f6032eb9dba20263b1acf6984ba4d8f8e9e48027543701d783)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e10c63e1662787d0347b125da54bd5d01fe79b05a061d0e20c24e929204b66f2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__de880ebf09588c2467c55e0c4930a88a136658ff3c1367a0b11912ae04cfc456)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareChromaKey]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareChromaKey]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cf71544a22e4443b87a105344e3797653392bd673fd34a3d6ee06d0d8493268f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareChromaKeyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareChromaKeyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5b00f9cc6a36eaa910562365814ae7d26ac8d09bb6efda208cd5d3b34a234709)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueFeather")
    def reset_hue_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeather", []))

    @jsii.member(jsii_name="resetHueFeatherVar")
    def reset_hue_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeatherVar", []))

    @jsii.member(jsii_name="resetHueTolerance")
    def reset_hue_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueTolerance", []))

    @jsii.member(jsii_name="resetHueToleranceVar")
    def reset_hue_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueToleranceVar", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightnessFeather")
    def reset_lightness_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeather", []))

    @jsii.member(jsii_name="resetLightnessFeatherVar")
    def reset_lightness_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeatherVar", []))

    @jsii.member(jsii_name="resetLightnessTolerance")
    def reset_lightness_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessTolerance", []))

    @jsii.member(jsii_name="resetLightnessToleranceVar")
    def reset_lightness_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessToleranceVar", []))

    @jsii.member(jsii_name="resetSaturationFeather")
    def reset_saturation_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeather", []))

    @jsii.member(jsii_name="resetSaturationFeatherVar")
    def reset_saturation_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeatherVar", []))

    @jsii.member(jsii_name="resetSaturationTolerance")
    def reset_saturation_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationTolerance", []))

    @jsii.member(jsii_name="resetSaturationToleranceVar")
    def reset_saturation_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherInput")
    def hue_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVarInput")
    def hue_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceInput")
    def hue_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVarInput")
    def hue_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherInput")
    def lightness_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVarInput")
    def lightness_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceInput")
    def lightness_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVarInput")
    def lightness_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherInput")
    def saturation_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVarInput")
    def saturation_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceInput")
    def saturation_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVarInput")
    def saturation_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__45277f3010244dc073824feb0e65ba6dcaa003f47fde78d3379d961cc1d261db)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeather")
    def hue_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeather"))

    @hue_feather.setter
    def hue_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__62a5dc8715758ca47bedde539fb97dfa74595627980809ad708f2fa4e6e414c1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeather", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVar")
    def hue_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeatherVar"))

    @hue_feather_var.setter
    def hue_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4cf083a2338c05dd33048f564325f68a02b637ca6dfa52bebfe22df38cf689a7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueTolerance")
    def hue_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueTolerance"))

    @hue_tolerance.setter
    def hue_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1de571a4501155d203186a4c1f3435ba8da3d5f4387a4c5e37656ea8cafe103c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVar")
    def hue_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueToleranceVar"))

    @hue_tolerance_var.setter
    def hue_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5dd242642dafb92e040d67b5ec27e776a7d790c865670816926cc0b63b1b397a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3840128de3a0bc7f1514e2dadb14e0c40ff9eda45949606f0e494b9e352e1b9c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeather")
    def lightness_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeather"))

    @lightness_feather.setter
    def lightness_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__544c7c18d43120e0d6e8d8a7fa7858a8a1c23182deaece98f8394a4341f9ac9b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeather", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVar")
    def lightness_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeatherVar"))

    @lightness_feather_var.setter
    def lightness_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9adf59e91499906487518610291e8c710bbdfe43be39cbbd69a14cc31658efda)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessTolerance")
    def lightness_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessTolerance"))

    @lightness_tolerance.setter
    def lightness_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__41b962083344ad280b2e4784802dd078d1e888f9ad0a59d8a3c4c8890ab16fab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVar")
    def lightness_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessToleranceVar"))

    @lightness_tolerance_var.setter
    def lightness_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6ecc45889624b00464a092075c83d13b7cff6ba8deff824b6f957a5572db60b5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeather")
    def saturation_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeather"))

    @saturation_feather.setter
    def saturation_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ca7e6441fe671cf68f0f0f1f376f80ad0a1bee8669ab4382aa7fc1a1f344aeed)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeather", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVar")
    def saturation_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeatherVar"))

    @saturation_feather_var.setter
    def saturation_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2b3edd420bef599de4027037eb51f3ad3729c3121434bd82a3e2b6d5230abf3d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationTolerance")
    def saturation_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationTolerance"))

    @saturation_tolerance.setter
    def saturation_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8e095d564066d7973308a67cc063633d5ad82424607f04855ccb19d1c5187259)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVar")
    def saturation_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationToleranceVar"))

    @saturation_tolerance_var.setter
    def saturation_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fae1098da9bdd7e2dc310698a29ef30bcc68c75273c4f38f8ed396054a0d864b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareChromaKey]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareChromaKey]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareChromaKey]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d6513217b90f0ba68b2a8187e834f492b54fe8e282afce8d644fbeb99344a055)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareComposite",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "placement": "placement",
        "placement_var": "placementVar",
        "scale": "scale",
        "scale_dimension": "scaleDimension",
        "scale_dimension_var": "scaleDimensionVar",
        "scale_var": "scaleVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareComposite:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareCompositeImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        placement: typing.Optional[builtins.str] = None,
        placement_var: typing.Optional[builtins.str] = None,
        scale: typing.Optional[builtins.str] = None,
        scale_dimension: typing.Optional[builtins.str] = None,
        scale_dimension_var: typing.Optional[builtins.str] = None,
        scale_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param placement: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        :param placement_var: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        :param scale: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param scale_dimension: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        :param scale_dimension_var: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        :param scale_var: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        :param x_position: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareCompositeImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa59eaba9cb97fd529e00da522cc2ecf8c01413625133db20e578cbe42f69127)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument placement", value=placement, expected_type=type_hints["placement"])
            check_type(argname="argument placement_var", value=placement_var, expected_type=type_hints["placement_var"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument scale_dimension", value=scale_dimension, expected_type=type_hints["scale_dimension"])
            check_type(argname="argument scale_dimension_var", value=scale_dimension_var, expected_type=type_hints["scale_dimension_var"])
            check_type(argname="argument scale_var", value=scale_var, expected_type=type_hints["scale_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if placement is not None:
            self._values["placement"] = placement
        if placement_var is not None:
            self._values["placement_var"] = placement_var
        if scale is not None:
            self._values["scale"] = scale
        if scale_dimension is not None:
            self._values["scale_dimension"] = scale_dimension
        if scale_dimension_var is not None:
            self._values["scale_dimension_var"] = scale_dimension_var
        if scale_var is not None:
            self._values["scale_var"] = scale_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareCompositeImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareCompositeImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        '''
        result = self._values.get("placement")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement_var(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        '''
        result = self._values.get("placement_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        '''
        result = self._values.get("scale_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        '''
        result = self._values.get("scale_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        '''
        result = self._values.get("scale_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareComposite(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareCompositeImage",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareCompositeImage:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareCompositeImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareCompositeImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareCompositeImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d0e32dce4838bf34501b97aa6cde8aa0edf11659535586c827162d700505278a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareCompositeImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareCompositeImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a4291f2f0bfb7733b3f4af63255c4fcdb43a4f19abdb2ff56be25546020b6316)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareCompositeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareCompositeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5d7269b8d89d5c7380a40dc549be08e47b6ac3dd97378109306b7d2633850d98)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareCompositeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0c979f22c775ff94e54bf2abb34c5fa1a8a019de55f25953f9f58ea6297cf438)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareCompositeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fecc06869e62fcb4b6d8a6f2fb52ee81e5110afdea25a99096e71ab1ef68522c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e3a71d89511077c27600ffcbf36e15b98a5476fb1e7e7e1baf245238b2651a64)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__870932c990c2fd6ddfedd0f234e9f910fceeebba6cdf3aa19fb6201b1de327b0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareComposite]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareComposite]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f4e45c0e8efff5a5095d0d10345fba469846867c269be37d1764f8aac5daf109)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareCompositeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareCompositeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__747be4bbc3106c5ba4a57be97b40efd90e14f56beae72eb2ccd613bbd4514e51)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareCompositeImage()

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPlacement")
    def reset_placement(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacement", []))

    @jsii.member(jsii_name="resetPlacementVar")
    def reset_placement_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacementVar", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetScaleDimension")
    def reset_scale_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimension", []))

    @jsii.member(jsii_name="resetScaleDimensionVar")
    def reset_scale_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimensionVar", []))

    @jsii.member(jsii_name="resetScaleVar")
    def reset_scale_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareCompositeImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareCompositeImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareCompositeImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="placementInput")
    def placement_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementInput"))

    @builtins.property
    @jsii.member(jsii_name="placementVarInput")
    def placement_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionInput")
    def scale_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVarInput")
    def scale_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleVarInput")
    def scale_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d9a0a3c49f33d2c4d5f8b17ac4f12a16f45648caedaf86f143e10880b8a58ed0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__afcfe1624cb0a37b553cce9e274d48bf2dd6d7813212055e4e25e5e1eab3ab3b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="placement")
    def placement(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placement"))

    @placement.setter
    def placement(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__942bd46b9650a459abe1137fee6d75be629b02fcb02ff7e9cf8314988ab99316)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placement", value)

    @builtins.property
    @jsii.member(jsii_name="placementVar")
    def placement_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placementVar"))

    @placement_var.setter
    def placement_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__278468fb67a9516ac9aa930eb62a9a463d2814c4b139ad5d342eb780d17e3307)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placementVar", value)

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scale"))

    @scale.setter
    def scale(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__93af1b77f9ae3af8aa55378a42f22ace6caa84c9f2e11b63ac01a9cd8ffe1219)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scale", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimension")
    def scale_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimension"))

    @scale_dimension.setter
    def scale_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ec5c3edd0ef256adc302c4eeb6b83c6fe5e3668de8bb46b89cc2a43efeb3205e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimension", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVar")
    def scale_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimensionVar"))

    @scale_dimension_var.setter
    def scale_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ce2d7e54d66aa063c3b05743285e69a22208e5c63c8edb013afcfc4f4f697417)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="scaleVar")
    def scale_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleVar"))

    @scale_var.setter
    def scale_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2b05f233c3b633aa314fc4123e8a550f80dc66901450895e638303b7d5702758)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__47bf629fc70ced474162d995544b3b7a7b927fc49f9da592831dc6ca308be81b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8172e0fb8de78f2d2a70cfbc4c4deac9fffc279819ac36b473c60be2b7cd54c6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__44ad9e9b13a1d1bafe5f816ef4741e6cab1f47113a34f3af92a3fd47eb8dc4b3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9c80903915471d2e5887d24a5ccc7d84b3baa9a927a8b0c3d242b7fb7707d9a5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareComposite]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareComposite]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareComposite]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__08aab64b671dc2882fbf38455cfece390804ed69914656d9a22020a2d4fa7c85)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareCompound",
    jsii_struct_bases=[],
    name_mapping={"transformations": "transformations"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareCompound:
    def __init__(
        self,
        *,
        transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param transformations: transformations block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dc7e952ef6395f415760cfb31ce8b2938256a6c9d844af9f40b710f5cf4879e4)
            check_type(argname="argument transformations", value=transformations, expected_type=type_hints["transformations"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if transformations is not None:
            self._values["transformations"] = transformations

    @builtins.property
    def transformations(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareCompoundTransformations"]]]:
        '''transformations block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        result = self._values.get("transformations")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareCompoundTransformations"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareCompound(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareCompoundList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareCompoundList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4f016c9706a0ab5414dee39fb0eaa6d409b657bb112254ebbf4d9cb277b84792)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareCompoundOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aac139efc4bf27bb9e01567d5b588e8aef302e55b9ed37b10659d55da8509f27)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareCompoundOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4b7589132fc7aa8d21b080b28250f58201bd0b118dfcb1b4f316e67556c1d20b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__05d9ace34929cadcd62d29c801d3f062bef44645d21e2b3fb71e7aade6d69318)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bdb82f78c9cb8ccb9b9e43fe198bd77b2df7afad91603b673dfd2613396b05bc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareCompound]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareCompound]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f1767293eb518942fff2f53972628a08afe654ab44f41212bee112a0004fba33)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareCompoundOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareCompoundOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0bcaa9eacd080d9ac4f8b78c54090e741e690e3adb96f2a22d9f63ab27cf843e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformations")
    def put_transformations(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f85993b867585e46dca43208fbdfdacdc81e946d29b89c1e294ebf404da69e20)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTransformations", [value]))

    @jsii.member(jsii_name="resetTransformations")
    def reset_transformations(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformations", []))

    @builtins.property
    @jsii.member(jsii_name="transformations")
    def transformations(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareCompoundTransformationsList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareCompoundTransformationsList", jsii.get(self, "transformations"))

    @builtins.property
    @jsii.member(jsii_name="transformationsInput")
    def transformations_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareCompoundTransformations"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareCompoundTransformations"]]], jsii.get(self, "transformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareCompound]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareCompound]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareCompound]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4653772b756c6972d7c50f4c5674e561623908f1d2ba08f1a3125e6dbe0b09cd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareCompoundTransformations",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareCompoundTransformations:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareCompoundTransformations(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareCompoundTransformationsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareCompoundTransformationsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__24f10db8c8d827471735d10f8ff5d5870f486e712615f539a07df61585282152)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareCompoundTransformationsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d7be54c5f2e14b317bf6fd837e8c2474df830d94894cf8d182624e02216f491b)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareCompoundTransformationsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e36bf32f154601200bf7ae96d5616d496f052d2340c475d391c888b2a1d32913)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1ad062c54ba5d7c86577225826a517d1cedc559c2d9ca1e725dc056f9f4e3935)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a545035886e52f0fe160395bcb031468f0002a9da9ddfd41b588b61728cba3e5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareCompoundTransformations]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareCompoundTransformations]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareCompoundTransformations]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bdd1494d05d4e39129ca1997cbcd7e9de5c6d3735c969b1ac8fe849751be93bc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareCompoundTransformationsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareCompoundTransformationsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8911bce0990dac3c7372adc6cb2b82110255b40522755f79969bed7b12e6d211)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareCompoundTransformations]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareCompoundTransformations]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareCompoundTransformations]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f7957adf223446e4c94ca1e962a8c818f30955a4e9bf8711d663c8deaaec91b4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareContrast",
    jsii_struct_bases=[],
    name_mapping={
        "brightness": "brightness",
        "brightness_var": "brightnessVar",
        "contrast": "contrast",
        "contrast_var": "contrastVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareContrast:
    def __init__(
        self,
        *,
        brightness: typing.Optional[builtins.str] = None,
        brightness_var: typing.Optional[builtins.str] = None,
        contrast: typing.Optional[builtins.str] = None,
        contrast_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param brightness: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        :param brightness_var: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        :param contrast: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param contrast_var: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a82fed95225c2747e4f734550530620339a8962b19ac4e152915681b3c4278de)
            check_type(argname="argument brightness", value=brightness, expected_type=type_hints["brightness"])
            check_type(argname="argument brightness_var", value=brightness_var, expected_type=type_hints["brightness_var"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument contrast_var", value=contrast_var, expected_type=type_hints["contrast_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if brightness is not None:
            self._values["brightness"] = brightness
        if brightness_var is not None:
            self._values["brightness_var"] = brightness_var
        if contrast is not None:
            self._values["contrast"] = contrast
        if contrast_var is not None:
            self._values["contrast_var"] = contrast_var

    @builtins.property
    def brightness(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        '''
        result = self._values.get("brightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def brightness_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        '''
        result = self._values.get("brightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        result = self._values.get("contrast_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareContrast(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareContrastList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareContrastList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a0a70b5953c5dbae25976b360e06b1960013f18630c3be2b9a779676c8704307)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareContrastOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ffbcd14c4fe9de71de616c555367e59b1a3b8c60aa98e3d6ad653ab60c381f9a)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareContrastOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3abd23be4b723ef3e669a2f8548b7657d8acbbc3b800b1ac6517a193be8f97e7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d362ed9e83ee5390d15321e811ada84778ac921f8a24e901cfebe53e0350440c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a900917e8edd17cd75bb655a481d70adde573a364b4eef30662c2d8d948cb26)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareContrast]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareContrast]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__125b71156ca6a0804129a1497e18cd7b4f7999ddfbd9908d3c152bbd7fd2ca25)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareContrastOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareContrastOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__190d07dae4f862a8d3b62e0a25160cd55af6ad46e19ff406fd656385f77d94cd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetBrightness")
    def reset_brightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightness", []))

    @jsii.member(jsii_name="resetBrightnessVar")
    def reset_brightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightnessVar", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetContrastVar")
    def reset_contrast_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrastVar", []))

    @builtins.property
    @jsii.member(jsii_name="brightnessInput")
    def brightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="brightnessVarInput")
    def brightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastVarInput")
    def contrast_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="brightness")
    def brightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightness"))

    @brightness.setter
    def brightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e5385b95d8d14c84afc7b2ea6049f8c433e87342455a770ce352a99908c9af67)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightness", value)

    @builtins.property
    @jsii.member(jsii_name="brightnessVar")
    def brightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightnessVar"))

    @brightness_var.setter
    def brightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d80166b001800565f0a5637241ecb089d30ab57ed58bac381b7336f03b7d5815)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrast"))

    @contrast.setter
    def contrast(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__40589a01387332a9c74e43d3c3eef3dea512f238a596f4d3217dc8b5cb3d5a78)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrast", value)

    @builtins.property
    @jsii.member(jsii_name="contrastVar")
    def contrast_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrastVar"))

    @contrast_var.setter
    def contrast_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0a820dc34210662736f643dd45c8fa041ad79136b29d630a0513da1f4ac2460e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrastVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareContrast]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareContrast]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareContrast]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__54c6ce27ce20c36e8bca9e7c42e01ec423a25887d001026043993814413e5716)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareGoop",
    jsii_struct_bases=[],
    name_mapping={
        "chaos": "chaos",
        "chaos_var": "chaosVar",
        "density": "density",
        "density_var": "densityVar",
        "power": "power",
        "power_var": "powerVar",
        "seed": "seed",
        "seed_var": "seedVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareGoop:
    def __init__(
        self,
        *,
        chaos: typing.Optional[builtins.str] = None,
        chaos_var: typing.Optional[builtins.str] = None,
        density: typing.Optional[builtins.str] = None,
        density_var: typing.Optional[builtins.str] = None,
        power: typing.Optional[builtins.str] = None,
        power_var: typing.Optional[builtins.str] = None,
        seed: typing.Optional[builtins.str] = None,
        seed_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param chaos: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        :param chaos_var: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        :param density: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        :param density_var: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        :param power: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        :param power_var: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        :param seed: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        :param seed_var: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9e7363566c0069f76bd391dfeaa7b37013dc1f62cfd3a8b6feea04972d788e95)
            check_type(argname="argument chaos", value=chaos, expected_type=type_hints["chaos"])
            check_type(argname="argument chaos_var", value=chaos_var, expected_type=type_hints["chaos_var"])
            check_type(argname="argument density", value=density, expected_type=type_hints["density"])
            check_type(argname="argument density_var", value=density_var, expected_type=type_hints["density_var"])
            check_type(argname="argument power", value=power, expected_type=type_hints["power"])
            check_type(argname="argument power_var", value=power_var, expected_type=type_hints["power_var"])
            check_type(argname="argument seed", value=seed, expected_type=type_hints["seed"])
            check_type(argname="argument seed_var", value=seed_var, expected_type=type_hints["seed_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if chaos is not None:
            self._values["chaos"] = chaos
        if chaos_var is not None:
            self._values["chaos_var"] = chaos_var
        if density is not None:
            self._values["density"] = density
        if density_var is not None:
            self._values["density_var"] = density_var
        if power is not None:
            self._values["power"] = power
        if power_var is not None:
            self._values["power_var"] = power_var
        if seed is not None:
            self._values["seed"] = seed
        if seed_var is not None:
            self._values["seed_var"] = seed_var

    @builtins.property
    def chaos(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        '''
        result = self._values.get("chaos")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def chaos_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        '''
        result = self._values.get("chaos_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        '''
        result = self._values.get("density")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density_var(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        '''
        result = self._values.get("density_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        '''
        result = self._values.get("power")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power_var(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        '''
        result = self._values.get("power_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        '''
        result = self._values.get("seed")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed_var(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        result = self._values.get("seed_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareGoop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareGoopList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareGoopList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a61ebfa3f52307da2823383d2ed51255176c94057b44b5ec452dd750d224491)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareGoopOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c296e170bbc7b1dd71b0165b382ac5723439d0a357efd861831493883a847cb3)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareGoopOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3279a0ace45433adcf0ba461ef52885abd4079846724aeff78d9dfbcf9084c81)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__88be958b69153061ad57dfdc7419a9637d8526378f6c5db0b27b35438ba23bb4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9064acc1390b64ba7ffb85a36aa4082995d2261668391574d9891c174b505b5a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareGoop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareGoop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__19bb3fe270128bf5daad6fa73034330f607cb3fd47760e12bda574b6323d79cc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareGoopOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareGoopOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ea78f13fb375cdfd146c65748fcee2ae9a5c0bbe95a3490c336f9c2216902a4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetChaos")
    def reset_chaos(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaos", []))

    @jsii.member(jsii_name="resetChaosVar")
    def reset_chaos_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaosVar", []))

    @jsii.member(jsii_name="resetDensity")
    def reset_density(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensity", []))

    @jsii.member(jsii_name="resetDensityVar")
    def reset_density_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensityVar", []))

    @jsii.member(jsii_name="resetPower")
    def reset_power(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPower", []))

    @jsii.member(jsii_name="resetPowerVar")
    def reset_power_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPowerVar", []))

    @jsii.member(jsii_name="resetSeed")
    def reset_seed(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeed", []))

    @jsii.member(jsii_name="resetSeedVar")
    def reset_seed_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeedVar", []))

    @builtins.property
    @jsii.member(jsii_name="chaosInput")
    def chaos_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosInput"))

    @builtins.property
    @jsii.member(jsii_name="chaosVarInput")
    def chaos_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosVarInput"))

    @builtins.property
    @jsii.member(jsii_name="densityInput")
    def density_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityInput"))

    @builtins.property
    @jsii.member(jsii_name="densityVarInput")
    def density_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="powerInput")
    def power_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerInput"))

    @builtins.property
    @jsii.member(jsii_name="powerVarInput")
    def power_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerVarInput"))

    @builtins.property
    @jsii.member(jsii_name="seedInput")
    def seed_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedInput"))

    @builtins.property
    @jsii.member(jsii_name="seedVarInput")
    def seed_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedVarInput"))

    @builtins.property
    @jsii.member(jsii_name="chaos")
    def chaos(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaos"))

    @chaos.setter
    def chaos(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__91d29ed9a7bf4b1c5cdf6dd5dc614d3bbdcbced5de667c7306874f2d23f04dc6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaos", value)

    @builtins.property
    @jsii.member(jsii_name="chaosVar")
    def chaos_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaosVar"))

    @chaos_var.setter
    def chaos_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e3f92b1840cb3abe766a580ba4f8db16d5ee473b2ff8fa9f253e35cdcabcb5d3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaosVar", value)

    @builtins.property
    @jsii.member(jsii_name="density")
    def density(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "density"))

    @density.setter
    def density(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ff07360c7ea0cc677435fdf725c45497f53ae79ce3ccd5d1d66341bcb1a937eb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "density", value)

    @builtins.property
    @jsii.member(jsii_name="densityVar")
    def density_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "densityVar"))

    @density_var.setter
    def density_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3f61128b22e98b6f32f8c1a18cc243aacfc68c27ae3a482ff6d3254c019f54e1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "densityVar", value)

    @builtins.property
    @jsii.member(jsii_name="power")
    def power(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "power"))

    @power.setter
    def power(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e282ce2cac2dcec605a20f7457158b7b4f029c3c3106120e0f40442ab3f49ea3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "power", value)

    @builtins.property
    @jsii.member(jsii_name="powerVar")
    def power_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "powerVar"))

    @power_var.setter
    def power_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dc80aa9803571faad0e66924b8fb191110052c74a44aedd2a75e3d0f616988aa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "powerVar", value)

    @builtins.property
    @jsii.member(jsii_name="seed")
    def seed(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seed"))

    @seed.setter
    def seed(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c71784df8adf48d7c375c58a8df471cfe9ea0b2ff8d5cab2f3cf43e0ad8a1b6c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seed", value)

    @builtins.property
    @jsii.member(jsii_name="seedVar")
    def seed_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seedVar"))

    @seed_var.setter
    def seed_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6de43f660da241c21b985145b7ba53809fc1af197f05fd5fb39fd9b355143626)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seedVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareGoop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareGoop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareGoop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ae0b30e712571ee55d239136e01eb4136a360415aec466d3a64c6b08c918aa1c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareGrayscale",
    jsii_struct_bases=[],
    name_mapping={"type": "type", "type_var": "typeVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareGrayscale:
    def __init__(
        self,
        *,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param type: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6a027af00660d28d1eb306f88af8c1b9703435fd5f08156e248f9c935527a1bf)
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareGrayscale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareGrayscaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareGrayscaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__26d38a4f3cf4379cb69ec55ec6fc97484d04d254cd56ae89fa02336f1dabe1fe)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareGrayscaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b14d46785db3019973db0d602c12c4874b996e29dcdfb731c3f9e50c6b49f44f)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareGrayscaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b8b732b94a2d2a936cf20f43b042e88b6fb8ccaf43f42dbc7a6964b964331ac5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aede3d77aa182ab7fb7836d36f77feecfe46af43247fe159c79cedfcc3447b61)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa33e4099f9b534cc7a209035c6598705a6244e85570986d10a154c96fffb90d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareGrayscale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareGrayscale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b1793038863a4d6e70325d35e1ca5b590348b7957431cb290d9412a843b3845e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareGrayscaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareGrayscaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__16047cc769c641858c4519b50a310a4975bca099a24884e4ec41c3cf01ea7abc)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b80622f835d70af549f4a3a94aff45a20f4372ac3ba050d9e576210fc162df87)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ed320682898898b1f4f79ee27194c397e8bba89a34b2ed3f8fece01b36b56a9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareGrayscale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareGrayscale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareGrayscale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1ad70ab1bd48090b83b2854e8083c09c62d0b26dc3f845a9fd71f962b800eda1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareHsl",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "lightness": "lightness",
        "lightness_var": "lightnessVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareHsl:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness: typing.Optional[builtins.str] = None,
        lightness_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        :param lightness_var: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ecca1af7aee48d6b892f098d43eecb9decc0c64e20bb5897e601e0a47af6207b)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness", value=lightness, expected_type=type_hints["lightness"])
            check_type(argname="argument lightness_var", value=lightness_var, expected_type=type_hints["lightness_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness is not None:
            self._values["lightness"] = lightness
        if lightness_var is not None:
            self._values["lightness_var"] = lightness_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        '''
        result = self._values.get("lightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        '''
        result = self._values.get("lightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareHsl(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareHslList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareHslList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1c883790ce29bc118a318ad1c17b4117143dc0f2b8cfa7a6d4b36a3a5dd2d1b1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareHslOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7b896d488846f5c6a5fca4d9093718791c0edfb52e3561caf82467995f352686)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareHslOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab241ab20c6e1a893285760ffbb01b7253e2c47e35ba6ade09728d11da8a46d6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eafb8660f0da520faa0b64070253a695ef50398cfc7202ed12f86295d8c24493)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4eef250eb385010c7b8312c63839f6daaca19955a9d7eaef8af8e30342a7157f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareHsl]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareHsl]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d6a9e315655defcf6238eba9961f5c35df7d697eea15850e29297b239a1b9714)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareHslOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareHslOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7e4e3b35e4a0f35f950e0452566a8ab7ad7dd16c563ad3e39742b6f421b4b15f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightness")
    def reset_lightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightness", []))

    @jsii.member(jsii_name="resetLightnessVar")
    def reset_lightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessInput")
    def lightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessVarInput")
    def lightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4f65002c374f279639a1db1a2ae39157bba2d50399ace9cc45a6e00311c259e9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__718b3752f672c2fcbd48864d5ba22da7087e38410911692a708cfa535a08c45b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightness")
    def lightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightness"))

    @lightness.setter
    def lightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e03df3ce9972298ac1134ccc0cf0182a20258a3d71b6751cb8b773aa132dd221)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightness", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessVar")
    def lightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessVar"))

    @lightness_var.setter
    def lightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__00b1c709076f0d3ab27ddfa5cc8bb3880bd22ee0c7568b57b2d2bea70bc8f594)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__431ea25587cab6f0bb328693296f1d3e5ba26c41b50b1a5c8b01f46d43ba6a4f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9527267476f42cc6f24d95e7fb4d95b121779d818cfcfaa9e61af2332d21bf44)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareHsl]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareHsl]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareHsl]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__43606e32264e411a86275f711e1586684737bdebc32b19bda0fa8a2a7980336e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareHsv",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareHsv:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        :param value: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ec18688ba63f0bc46690a8fab6763cd50124a7fcbfdcf3b7a76b7f1ec800af3d)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareHsv(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareHsvList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareHsvList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dddd846527cda253d16ac4176b7f561cd556b7fed2d01819029e6b325dd99d60)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareHsvOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__284b960160edd29e7e2b9ec44ba83aa97b61137945342dd3b06ae6a0d0f2a8fd)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareHsvOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f1625a49afc7910e34e30c1a87b538b4fd510678fa084f0870da8f70d4b38dc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__94c9ac831347481245198bf0b945f112db588c05d5ea2aa12aa5e6b7d75e5dc6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3f0a24830fbe95201162a9303fe1307079f59226db9f81870175fea748a57d3e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareHsv]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareHsv]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b97748febcb6f847e31073f45fc9eca6109ee6b71a95caa48bb6bf05afe3a0e0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareHsvOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareHsvOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d062895c47e35cf343e63c40bd3585cda4a67b8861110c511b5f6d757ce4850d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__da132f69644552456bb4a355972ecc17c5bef561df7a9dad9382ba620ae3cfe7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ad50a32b427d4f13540d7e149afec7c3037f5ec76f4705126330bb24ac4b1cbc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d1e2243e03b7b4a860772e58f0f323bd76de9e3a794d4049e2c90a65b3208b8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6df36239b1cc1b45105c5ad815d7c4c001591e6a9dc89393e03eb025db3c14e8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2593894372ed56211fd637800212950034b15411e363f1881f114c994b8fb6f2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3aa033cd795f80061125b27d7c6ea9121fbbd813ab08307a7f30528e4dc65201)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareHsv]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareHsv]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareHsv]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__91c8d912d2dc13cb2f0cf5b622a04b59da45dd0b59cf6e9a6fe883dda6d4bd08)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfDimension",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "dimension": "dimension",
        "dimension_var": "dimensionVar",
        "equal": "equal",
        "greater_than": "greaterThan",
        "less_than": "lessThan",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfDimension:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        dimension: typing.Optional[builtins.str] = None,
        dimension_var: typing.Optional[builtins.str] = None,
        equal: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionEqual", typing.Dict[builtins.str, typing.Any]]] = None,
        greater_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionGreaterThan", typing.Dict[builtins.str, typing.Any]]] = None,
        less_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionLessThan", typing.Dict[builtins.str, typing.Any]]] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param dimension: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        :param dimension_var: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        :param equal: equal block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        :param greater_than: greater_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        :param less_than: less_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        :param value: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionDefault(**default)
        if isinstance(equal, dict):
            equal = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionEqual(**equal)
        if isinstance(greater_than, dict):
            greater_than = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionGreaterThan(**greater_than)
        if isinstance(less_than, dict):
            less_than = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionLessThan(**less_than)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5730163954aa6839b2cb4a08af89132258d173522d6cdb8e4f7b8f7d49a8fd43)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument dimension", value=dimension, expected_type=type_hints["dimension"])
            check_type(argname="argument dimension_var", value=dimension_var, expected_type=type_hints["dimension_var"])
            check_type(argname="argument equal", value=equal, expected_type=type_hints["equal"])
            check_type(argname="argument greater_than", value=greater_than, expected_type=type_hints["greater_than"])
            check_type(argname="argument less_than", value=less_than, expected_type=type_hints["less_than"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if dimension is not None:
            self._values["dimension"] = dimension
        if dimension_var is not None:
            self._values["dimension_var"] = dimension_var
        if equal is not None:
            self._values["equal"] = equal
        if greater_than is not None:
            self._values["greater_than"] = greater_than
        if less_than is not None:
            self._values["less_than"] = less_than
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionDefault"], result)

    @builtins.property
    def dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        '''
        result = self._values.get("dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        '''
        result = self._values.get("dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def equal(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionEqual"]:
        '''equal block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        '''
        result = self._values.get("equal")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionEqual"], result)

    @builtins.property
    def greater_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionGreaterThan"]:
        '''greater_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        '''
        result = self._values.get("greater_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionGreaterThan"], result)

    @builtins.property
    def less_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionLessThan"]:
        '''less_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        '''
        result = self._values.get("less_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionLessThan"], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfDimension(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df5670f4e5ea53e75510ba28a8ede500736ecbac2cedcfae0e14ea901bb91bce)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3b43355d1d85e1f5af3da4279655c25e52855848ffb5c9988417c0e4c16a38a5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionEqual",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionEqual:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionEqual(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionEqualOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionEqualOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d0db53b95b248a5c2c5e21fc4fd64a4ad19e3168d386e92f6243e2fc5a3e65d3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionEqual], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionEqual],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f9d6eb6739769f45dd1c79d1d84a208117d3ec2a8e10ec5200250a9902d86550)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionGreaterThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionGreaterThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionGreaterThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionGreaterThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionGreaterThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__75230855da63b3699cd0cf3eb62ba6fa38576853e3962c63c0c9b5d5446ba805)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionGreaterThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionGreaterThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd9f3d0fd536180c7b15d215b378a41d2fa640f70f0055df71bf91aa486745a7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionLessThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionLessThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionLessThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionLessThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionLessThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3827fab5c7806e91631bb1a57210cbf8cda2cd9c306eaa7be7fd8242caa6dd7d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionLessThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionLessThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__475ae51100cd1035ecd7a80eaf55342b7c69556a4b49569c87d6ae3279fe0149)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__09e4543bd635fc1bc485c253d1e0513b27370407c2749b946bdb58ce0b4ecb55)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ed3cabb419a85b77c9f9718c0c8c477f905edd9e8b49ca22aa03aa906e08efa)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c71a0c58255e96796dc3bae9f4ba4f3a6b41ace303ea875e37891faa41bb7a62)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__97f06d6f42571e66bbe23e9a1e93b87b191e270e4592644080551c70209fbdf6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__14908e8ee6a51c8703b3e5cd4b3a2222fc2ef4b76a0a30eee0d81a1540168ecd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfDimension]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfDimension]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e61c49d89a1080e800f6eea6a85ad8e71cd6f3dfa4e2190b82aa9e43c8491bf6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__45d581b50fcc6acd9a2e5f3f5fe335c59103a60fcc2c7f96352d175ff574b6ba)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putEqual")
    def put_equal(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionEqual()

        return typing.cast(None, jsii.invoke(self, "putEqual", [value]))

    @jsii.member(jsii_name="putGreaterThan")
    def put_greater_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionGreaterThan()

        return typing.cast(None, jsii.invoke(self, "putGreaterThan", [value]))

    @jsii.member(jsii_name="putLessThan")
    def put_less_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionLessThan()

        return typing.cast(None, jsii.invoke(self, "putLessThan", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetDimension")
    def reset_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimension", []))

    @jsii.member(jsii_name="resetDimensionVar")
    def reset_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimensionVar", []))

    @jsii.member(jsii_name="resetEqual")
    def reset_equal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEqual", []))

    @jsii.member(jsii_name="resetGreaterThan")
    def reset_greater_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGreaterThan", []))

    @jsii.member(jsii_name="resetLessThan")
    def reset_less_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLessThan", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="equal")
    def equal(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionEqualOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionEqualOutputReference, jsii.get(self, "equal"))

    @builtins.property
    @jsii.member(jsii_name="greaterThan")
    def greater_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionGreaterThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionGreaterThanOutputReference, jsii.get(self, "greaterThan"))

    @builtins.property
    @jsii.member(jsii_name="lessThan")
    def less_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionLessThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionLessThanOutputReference, jsii.get(self, "lessThan"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionInput")
    def dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionVarInput")
    def dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="equalInput")
    def equal_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionEqual], jsii.get(self, "equalInput"))

    @builtins.property
    @jsii.member(jsii_name="greaterThanInput")
    def greater_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionGreaterThan], jsii.get(self, "greaterThanInput"))

    @builtins.property
    @jsii.member(jsii_name="lessThanInput")
    def less_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionLessThan], jsii.get(self, "lessThanInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="dimension")
    def dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimension"))

    @dimension.setter
    def dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fd3b939a3f0c089f15f484051a021f99b2d5f364671fc1dd060bbd2d78bcb580)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimension", value)

    @builtins.property
    @jsii.member(jsii_name="dimensionVar")
    def dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimensionVar"))

    @dimension_var.setter
    def dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a46df0698383ac60f9ef85a7c9e200df6ab9faeacb648da802c81fba9054eb0d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2fbbccecaee009b949e422853c0efa02d6795028cfed257c422328a613ee2a49)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3b6a1a814d3d26b518ff214e6d7a6aa4d6acfa0de9b3d103ebc23dd01a3fd995)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfDimension]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfDimension]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfDimension]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c1c1d56f0e734d0e06db6d59df6c7a9659dab2b650966dda35e72d76fc175185)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfOrientation",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "landscape": "landscape",
        "portrait": "portrait",
        "square": "square",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfOrientation:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        landscape: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationLandscape", typing.Dict[builtins.str, typing.Any]]] = None,
        portrait: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationPortrait", typing.Dict[builtins.str, typing.Any]]] = None,
        square: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationSquare", typing.Dict[builtins.str, typing.Any]]] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param landscape: landscape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        :param portrait: portrait block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        :param square: square block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationDefault(**default)
        if isinstance(landscape, dict):
            landscape = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationLandscape(**landscape)
        if isinstance(portrait, dict):
            portrait = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationPortrait(**portrait)
        if isinstance(square, dict):
            square = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationSquare(**square)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7187b17f0e225ba7a0198d0beaad7bbb2d0092a0c6144a9603f6f063e760afa3)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument landscape", value=landscape, expected_type=type_hints["landscape"])
            check_type(argname="argument portrait", value=portrait, expected_type=type_hints["portrait"])
            check_type(argname="argument square", value=square, expected_type=type_hints["square"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if landscape is not None:
            self._values["landscape"] = landscape
        if portrait is not None:
            self._values["portrait"] = portrait
        if square is not None:
            self._values["square"] = square

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationDefault"], result)

    @builtins.property
    def landscape(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationLandscape"]:
        '''landscape block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        '''
        result = self._values.get("landscape")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationLandscape"], result)

    @builtins.property
    def portrait(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationPortrait"]:
        '''portrait block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        '''
        result = self._values.get("portrait")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationPortrait"], result)

    @builtins.property
    def square(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationSquare"]:
        '''square block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        result = self._values.get("square")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationSquare"], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfOrientation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7f0dddb2817d42261e2486d84b4934887bd0751f98e74ed767c8646e752602f2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__497e2d9711f9ddd7321ee01a9a4825169d2736f91d01c265baae04481b107cde)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationLandscape",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationLandscape:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationLandscape(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationLandscapeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationLandscapeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4cb9f9bfe426cca3c5bdce6222b0d0630b1af18f9f1f2412f6aa5a22a96f3f21)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationLandscape], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationLandscape],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ba85a7eb9b329879a96bf4d1ed3b58d64d6eb1ab68611fc458a376788815523)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__63e0758a8cdf03b9a09ce3efec5f0c1f3b06c1db66c13c5a8b8c7c382fb1af6d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__71bea8f600c6fe7a586058da632f4ec3d369f52b0baa3155316e4fd9a8460fa6)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d097b9c8450ec08a2959154c3ddc83afe9abd02cb127d249f99ddfdd18e2a3ce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__978c4eb994aec2056eef8e3eecf55372313ffe5d370536d319ad2f815aef7153)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__037b3f46595f6e0164413902a44352c3715534896f9e6471f6d74428ca4183f6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfOrientation]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfOrientation]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f6b1e42183b0a021ed547dd9dab47d6b1a4784e60cde1b8844c74b2c59ce0b5e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4e4bee4a4635b1dd842a22b5e4f1e2c27e19415223e34d6be3443e36def3c212)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putLandscape")
    def put_landscape(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationLandscape()

        return typing.cast(None, jsii.invoke(self, "putLandscape", [value]))

    @jsii.member(jsii_name="putPortrait")
    def put_portrait(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationPortrait()

        return typing.cast(None, jsii.invoke(self, "putPortrait", [value]))

    @jsii.member(jsii_name="putSquare")
    def put_square(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationSquare()

        return typing.cast(None, jsii.invoke(self, "putSquare", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetLandscape")
    def reset_landscape(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLandscape", []))

    @jsii.member(jsii_name="resetPortrait")
    def reset_portrait(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPortrait", []))

    @jsii.member(jsii_name="resetSquare")
    def reset_square(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSquare", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="landscape")
    def landscape(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationLandscapeOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationLandscapeOutputReference, jsii.get(self, "landscape"))

    @builtins.property
    @jsii.member(jsii_name="portrait")
    def portrait(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationPortraitOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationPortraitOutputReference", jsii.get(self, "portrait"))

    @builtins.property
    @jsii.member(jsii_name="square")
    def square(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationSquareOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationSquareOutputReference", jsii.get(self, "square"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="landscapeInput")
    def landscape_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationLandscape], jsii.get(self, "landscapeInput"))

    @builtins.property
    @jsii.member(jsii_name="portraitInput")
    def portrait_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationPortrait"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationPortrait"], jsii.get(self, "portraitInput"))

    @builtins.property
    @jsii.member(jsii_name="squareInput")
    def square_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationSquare"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationSquare"], jsii.get(self, "squareInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfOrientation]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfOrientation]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfOrientation]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8c29c1c7bc30562dbef8994e7a27ae13a545b6cd539bc0508400c50000b43ea3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationPortrait",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationPortrait:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationPortrait(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationPortraitOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationPortraitOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__171a277a3c4fa938c99627e3eb85a9d35b24e723072ec36c154b2aea50dceb7d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationPortrait]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationPortrait], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationPortrait],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ca339176450a21e6bd0560c2a01c8c1698c6fb5e6a8b67efc6a7037029716b3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationSquare",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationSquare:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationSquare(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationSquareOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationSquareOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f778112b1b39a3ae7f1cba923a2863840ca308e1ae2fd0e648964073c9817f17)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationSquare]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationSquare], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationSquare],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ce38d3fd51e25f977d6328a38c5a207c4c4df0298d5c5684262f153fc2997502)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareMaxColors",
    jsii_struct_bases=[],
    name_mapping={"colors": "colors", "colors_var": "colorsVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareMaxColors:
    def __init__(
        self,
        *,
        colors: typing.Optional[builtins.str] = None,
        colors_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param colors: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        :param colors_var: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__94b0fdc429453e7a1bdc39767d9f4cabc528277c44658dd873f5c238a37d111b)
            check_type(argname="argument colors", value=colors, expected_type=type_hints["colors"])
            check_type(argname="argument colors_var", value=colors_var, expected_type=type_hints["colors_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if colors is not None:
            self._values["colors"] = colors
        if colors_var is not None:
            self._values["colors_var"] = colors_var

    @builtins.property
    def colors(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        '''
        result = self._values.get("colors")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def colors_var(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        result = self._values.get("colors_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareMaxColors(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareMaxColorsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareMaxColorsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e50230bee952aea37539737bce8e6b1b1cedca43057850e378b14f7b67fff363)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareMaxColorsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3fe37e3053706855a1ed2351e9c2faf68f7d5036df5ac7d3177af8ce275e0981)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareMaxColorsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4f8db479ea053322a6d0e462d72ec0ca13b51851b3096ab69c042dd49212ddcf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2175690dd8f297f5ce03d98f71f514b1de08d1aec8e28d01c0664cd44e0ea1dd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1e924dde3535b5f71064e8b8d49ba5e9744f24e53fbe0105b3908216409d24e0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareMaxColors]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareMaxColors]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c0f519f2d2299009dac5b363d066351df6e3a7eda7a133592897f4da6c9be832)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareMaxColorsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareMaxColorsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7f2b7d253df37b40056fe555f832b629d74457507bb48e9a1f542b5c6ecfd2d7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColors")
    def reset_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColors", []))

    @jsii.member(jsii_name="resetColorsVar")
    def reset_colors_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorsVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorsInput")
    def colors_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsInput"))

    @builtins.property
    @jsii.member(jsii_name="colorsVarInput")
    def colors_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsVarInput"))

    @builtins.property
    @jsii.member(jsii_name="colors")
    def colors(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colors"))

    @colors.setter
    def colors(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__07fd119f9e3b84b2483b4da591d3e2839390406b59300a85b99dfba2533c20fc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colors", value)

    @builtins.property
    @jsii.member(jsii_name="colorsVar")
    def colors_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorsVar"))

    @colors_var.setter
    def colors_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__417638b289d0def5cdb527cde929c742bf3cbb78d41ac82790613b99249822aa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorsVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareMaxColors]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareMaxColors]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareMaxColors]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f367bf6b44dbefe9ec47cdf69ea41fd6a63c860f24535efa24f9ba04de0185c2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareMirror",
    jsii_struct_bases=[],
    name_mapping={
        "horizontal": "horizontal",
        "horizontal_var": "horizontalVar",
        "vertical": "vertical",
        "vertical_var": "verticalVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareMirror:
    def __init__(
        self,
        *,
        horizontal: typing.Optional[builtins.str] = None,
        horizontal_var: typing.Optional[builtins.str] = None,
        vertical: typing.Optional[builtins.str] = None,
        vertical_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param horizontal: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        :param horizontal_var: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        :param vertical: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        :param vertical_var: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e60bbac72407291d9ea9aa52d4b14ad2f7db7d11f68562c4026b2147f96931e9)
            check_type(argname="argument horizontal", value=horizontal, expected_type=type_hints["horizontal"])
            check_type(argname="argument horizontal_var", value=horizontal_var, expected_type=type_hints["horizontal_var"])
            check_type(argname="argument vertical", value=vertical, expected_type=type_hints["vertical"])
            check_type(argname="argument vertical_var", value=vertical_var, expected_type=type_hints["vertical_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if horizontal is not None:
            self._values["horizontal"] = horizontal
        if horizontal_var is not None:
            self._values["horizontal_var"] = horizontal_var
        if vertical is not None:
            self._values["vertical"] = vertical
        if vertical_var is not None:
            self._values["vertical_var"] = vertical_var

    @builtins.property
    def horizontal(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        '''
        result = self._values.get("horizontal")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def horizontal_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        '''
        result = self._values.get("horizontal_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        '''
        result = self._values.get("vertical")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        result = self._values.get("vertical_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareMirror(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareMirrorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareMirrorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3e6b28e0209eccad94b9be61fe4f516b2ae1d344fd86a24547ff8d4654c00b11)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareMirrorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c5addb972d866a701110d3473d538ec01724e1843b8108cb0e65a78befa41431)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareMirrorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5223f90ca0dd658de2731abc6c1f3b53a3e64915289b73ef028da1e569eee03d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__629c2a0bd87e92a08803b8f82759c4f61b06921981852c80f43362913cd93ccd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f060e1b8af7ad0dc2322c7e2756eb940ed944bca194cd28e10f9f867dec141f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareMirror]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareMirror]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a4e03f1c88ba9d982b02e16996a5904c543c422ee3a07f3c7f54319c3076c75)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareMirrorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareMirrorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b98ee625d3634eb07c231cc1316d5c79d257ea5389ed9e25faa4d027735d2d9d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHorizontal")
    def reset_horizontal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontal", []))

    @jsii.member(jsii_name="resetHorizontalVar")
    def reset_horizontal_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontalVar", []))

    @jsii.member(jsii_name="resetVertical")
    def reset_vertical(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVertical", []))

    @jsii.member(jsii_name="resetVerticalVar")
    def reset_vertical_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVerticalVar", []))

    @builtins.property
    @jsii.member(jsii_name="horizontalInput")
    def horizontal_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontalVarInput")
    def horizontal_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalInput")
    def vertical_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalVarInput")
    def vertical_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontal")
    def horizontal(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontal"))

    @horizontal.setter
    def horizontal(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__46add8539138393eb1dfe9ecb89a31dcc27a9c6c44f28cdc91f7f707d561e843)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontal", value)

    @builtins.property
    @jsii.member(jsii_name="horizontalVar")
    def horizontal_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontalVar"))

    @horizontal_var.setter
    def horizontal_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__424bb8f256e1ae8a43c9b4f4ee25f4d3570db2fe0d7c06a4cfbd48432156fcfc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontalVar", value)

    @builtins.property
    @jsii.member(jsii_name="vertical")
    def vertical(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "vertical"))

    @vertical.setter
    def vertical(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ba5b3a5f1388c844b6c988cea6e7d2e1255c7eb264e1d7bc18c5d1fc0babb09f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "vertical", value)

    @builtins.property
    @jsii.member(jsii_name="verticalVar")
    def vertical_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "verticalVar"))

    @vertical_var.setter
    def vertical_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dbb6b6ea54935f4429d29928bbdbca05758804d76985f77278873223d0fd1768)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "verticalVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareMirror]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareMirror]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareMirror]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2c06bc6dab4bc6740173439b2dfa20499946c731e1b64ab7983687e0d402d6f1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareMonoHue",
    jsii_struct_bases=[],
    name_mapping={"hue": "hue", "hue_var": "hueVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareMonoHue:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__72f9fbd2f0dbbb345fceed052015f97011ea9d143ac998d561ac4f927421bbc4)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareMonoHue(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareMonoHueList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareMonoHueList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a5837d987145dc25b3e098cce730952e3e6bb42186e33a73122ae446378b8380)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareMonoHueOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e5b87acbd5e0171298e1f2c5e2a7a1e31652194ffc2dae4a53e160655b742d01)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareMonoHueOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d80037b7be37f5ce8c952f152282db81587577765249da89b65b7aad324c2a4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__adef71922d6b5e7f48271ae09910baa30a1e8f95e954f1c34ca467a0ae8bb4cc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__db21fb1352981e35d690827833417bb8170b730b9db9f50912dc9d4e345978c1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareMonoHue]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareMonoHue]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a7b904a8e6fb90d916c7eb0ae35ad2f7463b8a81037c5e6145b4c85bb27d4f73)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareMonoHueOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareMonoHueOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__74b956d070e3a0f0c48835b917028a6f6f645e5a26a9283d526f3157ad3cb7c8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6a1b274a91bc7449e7ade528f26609168996ea81a7067b6b80081204942f7dc9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fbe4938be42812a1bb0465ea73a1a41f652fca2506ea67e3a225a2007857d3d7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareMonoHue]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareMonoHue]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareMonoHue]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4921dd5632d52493c47518b5c83b6ba8cdd2a09e1d501fbb7d732803d5726b26)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareOpacity",
    jsii_struct_bases=[],
    name_mapping={"opacity": "opacity", "opacity_var": "opacityVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareOpacity:
    def __init__(
        self,
        *,
        opacity: typing.Optional[builtins.str] = None,
        opacity_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param opacity: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param opacity_var: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab0001175da794fb7a74727158a2586c0578d997639a54f37c9096388151936f)
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument opacity_var", value=opacity_var, expected_type=type_hints["opacity_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if opacity is not None:
            self._values["opacity"] = opacity
        if opacity_var is not None:
            self._values["opacity_var"] = opacity_var

    @builtins.property
    def opacity(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def opacity_var(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        result = self._values.get("opacity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareOpacity(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareOpacityList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareOpacityList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0d08fb91ea7721de077c743bab7948481ff8c4ccc0a832db39cd7edb60ba19b8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareOpacityOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ccd239b60165d4cdf66b47b22b0edbed66189804d195dc95fd3175332624020c)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareOpacityOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__53d29c929cea51065cd68f64e15be9377046a8adca9d9f2f92b57a38a3fa6480)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__45fdb02a5c20a20c3134490379d5425fdfba5c7c6559a3a5903e84dc44a577e8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f17a1e7551d07f1b3a97512f676905b62f8224b0efc208ad35767f4eba3930b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareOpacity]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareOpacity]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b3f9d1a97733ac41503bf6727ab71d205b80e655d18bf0c46b6633133503f6b0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareOpacityOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareOpacityOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b13e9966a2042165d4b01d3360dbddba7e9196d9e8710dbe6e8a89a1b7b0ffae)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetOpacityVar")
    def reset_opacity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacityVar", []))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityVarInput")
    def opacity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacity"))

    @opacity.setter
    def opacity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b147309f96194e3a25a2eb56ac95c5d48aed76a67e9d498ab8802ff1c0ac6367)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacity", value)

    @builtins.property
    @jsii.member(jsii_name="opacityVar")
    def opacity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacityVar"))

    @opacity_var.setter
    def opacity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__91ebb0b67bb238f0ffb8865bd4bdb40128c77b8189bda64cdcbb0c4055455bd8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacityVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareOpacity]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareOpacity]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareOpacity]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a8da61907846045802f434fd7845fa2b28f325f8f82a9795a75b79134ad2991)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b66a9e865ef44ad18c7bff5d3a9a390b0693ba2bdd8cc259e6c5296b33034505)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putBackgroundColor")
    def put_background_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3c02c05fa5cad5d2df4203046557306912096b37adf1b9cd6a59df97103b62e1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBackgroundColor", [value]))

    @jsii.member(jsii_name="putBlur")
    def put_blur(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareBlur, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b0d32ae843247c1103409a59b57dbbcb6f473d82c0a09d797b64442a79ad219e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBlur", [value]))

    @jsii.member(jsii_name="putChromaKey")
    def put_chroma_key(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareChromaKey, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9da8bfa4b946ffc5a62b8c3bcc898cae0ef792cdd989acf8f46f2ddb743f50a3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putChromaKey", [value]))

    @jsii.member(jsii_name="putComposite")
    def put_composite(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareComposite, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d612e75cb84b7bdee26f6790b5dcd4832d2de058a45abfa4793060b44419f37a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putComposite", [value]))

    @jsii.member(jsii_name="putCompound")
    def put_compound(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareCompound, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fe7e56c024c07f286664a9ae260cb855b67b68290fd2fd39c4d913a8924f8026)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCompound", [value]))

    @jsii.member(jsii_name="putContrast")
    def put_contrast(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareContrast, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6cb81b5bf3445a9340e4cdc8aeb9001009e73450894b470ca1183bd700113306)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putContrast", [value]))

    @jsii.member(jsii_name="putGoop")
    def put_goop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareGoop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6d6b56cf2465ca7f2eda17c4cfc8c990b40e4ddf226f6fad84b7d19fa46b6ff3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGoop", [value]))

    @jsii.member(jsii_name="putGrayscale")
    def put_grayscale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareGrayscale, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fb1ec26adf6cfd76d732e312f71a9da80fb2c2c29cb951ce16a2188823349008)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGrayscale", [value]))

    @jsii.member(jsii_name="putHsl")
    def put_hsl(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareHsl, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4696d94631406a40acfab81c36aee5e6e5801b16accdf0e4ce388321867b4a55)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsl", [value]))

    @jsii.member(jsii_name="putHsv")
    def put_hsv(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareHsv, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__37b49ad3aed81aa6c3c5498c0c9c663304438cae1393099f9a3c6be6946e1103)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsv", [value]))

    @jsii.member(jsii_name="putIfDimension")
    def put_if_dimension(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfDimension, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5439fa2ad75e245a924c646d8cd44f1f3bd3f7ac582a93adad44c4cfa84e7be1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfDimension", [value]))

    @jsii.member(jsii_name="putIfOrientation")
    def put_if_orientation(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5b12862b48858a6e4ec659ca3b3947cadbed5c759f0eea8aa315152d2cd143ff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfOrientation", [value]))

    @jsii.member(jsii_name="putMaxColors")
    def put_max_colors(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareMaxColors, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0e3c240ca910c7a61febe6845c460fc883deb348eabb3f1632df0853fb4f1b3a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMaxColors", [value]))

    @jsii.member(jsii_name="putMirror")
    def put_mirror(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareMirror, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__47ab7e49177b2e0bc66e6233a4a03284093e51bf6520e1eed30a457dd56c3f6c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMirror", [value]))

    @jsii.member(jsii_name="putMonoHue")
    def put_mono_hue(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareMonoHue, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fb4d1ad8cc6c8e2b318113a29a713044a7e8481805e0dd31f031c5f41a89900c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMonoHue", [value]))

    @jsii.member(jsii_name="putOpacity")
    def put_opacity(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareOpacity, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__756938609eca7655f23cb55a142290a5453edaf93c36155b3091ff8f639248cb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putOpacity", [value]))

    @jsii.member(jsii_name="putRemoveColor")
    def put_remove_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareRemoveColor", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a3b7d3b9f02da8876c440589fcc94004dbc58e1adb9b7d391825b7c0706da8d1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRemoveColor", [value]))

    @jsii.member(jsii_name="putUnsharpMask")
    def put_unsharp_mask(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareUnsharpMask", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__edddfa846d641cde0c384f9573145421eeba69c4477949144581d914f3737d82)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putUnsharpMask", [value]))

    @jsii.member(jsii_name="resetBackgroundColor")
    def reset_background_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBackgroundColor", []))

    @jsii.member(jsii_name="resetBlur")
    def reset_blur(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBlur", []))

    @jsii.member(jsii_name="resetChromaKey")
    def reset_chroma_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChromaKey", []))

    @jsii.member(jsii_name="resetComposite")
    def reset_composite(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetComposite", []))

    @jsii.member(jsii_name="resetCompound")
    def reset_compound(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCompound", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetGoop")
    def reset_goop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGoop", []))

    @jsii.member(jsii_name="resetGrayscale")
    def reset_grayscale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGrayscale", []))

    @jsii.member(jsii_name="resetHsl")
    def reset_hsl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsl", []))

    @jsii.member(jsii_name="resetHsv")
    def reset_hsv(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsv", []))

    @jsii.member(jsii_name="resetIfDimension")
    def reset_if_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfDimension", []))

    @jsii.member(jsii_name="resetIfOrientation")
    def reset_if_orientation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfOrientation", []))

    @jsii.member(jsii_name="resetMaxColors")
    def reset_max_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxColors", []))

    @jsii.member(jsii_name="resetMirror")
    def reset_mirror(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMirror", []))

    @jsii.member(jsii_name="resetMonoHue")
    def reset_mono_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonoHue", []))

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetRemoveColor")
    def reset_remove_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRemoveColor", []))

    @jsii.member(jsii_name="resetUnsharpMask")
    def reset_unsharp_mask(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUnsharpMask", []))

    @builtins.property
    @jsii.member(jsii_name="backgroundColor")
    def background_color(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareBackgroundColorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareBackgroundColorList, jsii.get(self, "backgroundColor"))

    @builtins.property
    @jsii.member(jsii_name="blur")
    def blur(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareBlurList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareBlurList, jsii.get(self, "blur"))

    @builtins.property
    @jsii.member(jsii_name="chromaKey")
    def chroma_key(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareChromaKeyList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareChromaKeyList, jsii.get(self, "chromaKey"))

    @builtins.property
    @jsii.member(jsii_name="composite")
    def composite(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareCompositeList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareCompositeList, jsii.get(self, "composite"))

    @builtins.property
    @jsii.member(jsii_name="compound")
    def compound(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareCompoundList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareCompoundList, jsii.get(self, "compound"))

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareContrastList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareContrastList, jsii.get(self, "contrast"))

    @builtins.property
    @jsii.member(jsii_name="goop")
    def goop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareGoopList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareGoopList, jsii.get(self, "goop"))

    @builtins.property
    @jsii.member(jsii_name="grayscale")
    def grayscale(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareGrayscaleList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareGrayscaleList, jsii.get(self, "grayscale"))

    @builtins.property
    @jsii.member(jsii_name="hsl")
    def hsl(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareHslList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareHslList, jsii.get(self, "hsl"))

    @builtins.property
    @jsii.member(jsii_name="hsv")
    def hsv(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareHsvList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareHsvList, jsii.get(self, "hsv"))

    @builtins.property
    @jsii.member(jsii_name="ifDimension")
    def if_dimension(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionList, jsii.get(self, "ifDimension"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientation")
    def if_orientation(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationList, jsii.get(self, "ifOrientation"))

    @builtins.property
    @jsii.member(jsii_name="maxColors")
    def max_colors(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareMaxColorsList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareMaxColorsList, jsii.get(self, "maxColors"))

    @builtins.property
    @jsii.member(jsii_name="mirror")
    def mirror(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareMirrorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareMirrorList, jsii.get(self, "mirror"))

    @builtins.property
    @jsii.member(jsii_name="monoHue")
    def mono_hue(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareMonoHueList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareMonoHueList, jsii.get(self, "monoHue"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareOpacityList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareOpacityList, jsii.get(self, "opacity"))

    @builtins.property
    @jsii.member(jsii_name="removeColor")
    def remove_color(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareRemoveColorList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareRemoveColorList", jsii.get(self, "removeColor"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMask")
    def unsharp_mask(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareUnsharpMaskList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareUnsharpMaskList", jsii.get(self, "unsharpMask"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColorInput")
    def background_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareBackgroundColor]]], jsii.get(self, "backgroundColorInput"))

    @builtins.property
    @jsii.member(jsii_name="blurInput")
    def blur_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareBlur]]], jsii.get(self, "blurInput"))

    @builtins.property
    @jsii.member(jsii_name="chromaKeyInput")
    def chroma_key_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareChromaKey]]], jsii.get(self, "chromaKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="compositeInput")
    def composite_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareComposite]]], jsii.get(self, "compositeInput"))

    @builtins.property
    @jsii.member(jsii_name="compoundInput")
    def compound_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareCompound]]], jsii.get(self, "compoundInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareContrast]]], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="goopInput")
    def goop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareGoop]]], jsii.get(self, "goopInput"))

    @builtins.property
    @jsii.member(jsii_name="grayscaleInput")
    def grayscale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareGrayscale]]], jsii.get(self, "grayscaleInput"))

    @builtins.property
    @jsii.member(jsii_name="hslInput")
    def hsl_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareHsl]]], jsii.get(self, "hslInput"))

    @builtins.property
    @jsii.member(jsii_name="hsvInput")
    def hsv_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareHsv]]], jsii.get(self, "hsvInput"))

    @builtins.property
    @jsii.member(jsii_name="ifDimensionInput")
    def if_dimension_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfDimension]]], jsii.get(self, "ifDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientationInput")
    def if_orientation_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfOrientation]]], jsii.get(self, "ifOrientationInput"))

    @builtins.property
    @jsii.member(jsii_name="maxColorsInput")
    def max_colors_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareMaxColors]]], jsii.get(self, "maxColorsInput"))

    @builtins.property
    @jsii.member(jsii_name="mirrorInput")
    def mirror_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareMirror]]], jsii.get(self, "mirrorInput"))

    @builtins.property
    @jsii.member(jsii_name="monoHueInput")
    def mono_hue_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareMonoHue]]], jsii.get(self, "monoHueInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareOpacity]]], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="removeColorInput")
    def remove_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareRemoveColor"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareRemoveColor"]]], jsii.get(self, "removeColorInput"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMaskInput")
    def unsharp_mask_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareUnsharpMask"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareUnsharpMask"]]], jsii.get(self, "unsharpMaskInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquare]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquare], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquare],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__48bbd2cd5949d6252967f40a8843d4f9db01b42e6493d01282d1e018166db3b9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareRemoveColor",
    jsii_struct_bases=[],
    name_mapping={
        "color": "color",
        "color_var": "colorVar",
        "feather": "feather",
        "feather_var": "featherVar",
        "tolerance": "tolerance",
        "tolerance_var": "toleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareRemoveColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
        feather: typing.Optional[builtins.str] = None,
        feather_var: typing.Optional[builtins.str] = None,
        tolerance: typing.Optional[builtins.str] = None,
        tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        :param feather: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        :param feather_var: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        :param tolerance: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        :param tolerance_var: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eff945ce062a897cdd61659747ae4a9915fbaf2dcb777a79627d1ca83411e19b)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
            check_type(argname="argument feather", value=feather, expected_type=type_hints["feather"])
            check_type(argname="argument feather_var", value=feather_var, expected_type=type_hints["feather_var"])
            check_type(argname="argument tolerance", value=tolerance, expected_type=type_hints["tolerance"])
            check_type(argname="argument tolerance_var", value=tolerance_var, expected_type=type_hints["tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var
        if feather is not None:
            self._values["feather"] = feather
        if feather_var is not None:
            self._values["feather_var"] = feather_var
        if tolerance is not None:
            self._values["tolerance"] = tolerance
        if tolerance_var is not None:
            self._values["tolerance_var"] = tolerance_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        '''
        result = self._values.get("feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather_var(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        '''
        result = self._values.get("feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        '''
        result = self._values.get("tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance_var(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        result = self._values.get("tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareRemoveColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareRemoveColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareRemoveColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d7737e0b73aa49facfbcc9e402fb6ddcff516b6b220894927f2eb67da9dda0c4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareRemoveColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__22e99c337c174a59137ae1471aa7ccebe2c396dee22c2d198a949d7524aaa936)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareRemoveColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dd35a1fa90289fa3c7b52fc7d06ec3efbeca4a5dda88099a3389432382a2aba3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f0b11ed356256dd8b326a201827afe2d858f15e9146950fac28785ef7370a5c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4d1267cc18fea63e9de195c7c998bcdbbc50674022e58957e2951d7735484e73)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareRemoveColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareRemoveColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareRemoveColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4d15f0639e538a8187437cb36b84e048df02e9e2473d4445bf84164992f2108e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareRemoveColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareRemoveColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__70bf8a030d69b0ebe163fd875476d5fc4afc118d746f2a068696c35f5cf3b86c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @jsii.member(jsii_name="resetFeather")
    def reset_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeather", []))

    @jsii.member(jsii_name="resetFeatherVar")
    def reset_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatherVar", []))

    @jsii.member(jsii_name="resetTolerance")
    def reset_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTolerance", []))

    @jsii.member(jsii_name="resetToleranceVar")
    def reset_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featherInput")
    def feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherInput"))

    @builtins.property
    @jsii.member(jsii_name="featherVarInput")
    def feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceInput")
    def tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceVarInput")
    def tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__34fcf6950fd5cea87e6685ca7c513c193166012bdbe4d9c327ca865342337c89)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1fc7be2cae5d995e903c164fa67fa611a7fd3f1eacfedf36db1e87b69661a61b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="feather")
    def feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "feather"))

    @feather.setter
    def feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__69b2dc5b2c194bb98416375045472eee7703706a00e54dc882fc3840466b69c2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "feather", value)

    @builtins.property
    @jsii.member(jsii_name="featherVar")
    def feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featherVar"))

    @feather_var.setter
    def feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4e862ccc2dd035d081871cffd232a758b30d59b5def49f7f36024c0a8ffacbc8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featherVar", value)

    @builtins.property
    @jsii.member(jsii_name="tolerance")
    def tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tolerance"))

    @tolerance.setter
    def tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fe7b6645c7e2654585076449116979955b71f65b26a5a0942a277baacf5a5fcf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tolerance", value)

    @builtins.property
    @jsii.member(jsii_name="toleranceVar")
    def tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "toleranceVar"))

    @tolerance_var.setter
    def tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b4ec1dfdf2f4da7d85175d3d3580113a1f7891dbdc9eab1f83c85bc8e9ac151d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "toleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareRemoveColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareRemoveColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareRemoveColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cc2efe3e5cf2c785b3e46eee397a3342401652e49dcf0e8640b653aba9514535)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareUnsharpMask",
    jsii_struct_bases=[],
    name_mapping={
        "gain": "gain",
        "gain_var": "gainVar",
        "sigma": "sigma",
        "sigma_var": "sigmaVar",
        "threshold": "threshold",
        "threshold_var": "thresholdVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareUnsharpMask:
    def __init__(
        self,
        *,
        gain: typing.Optional[builtins.str] = None,
        gain_var: typing.Optional[builtins.str] = None,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
        threshold: typing.Optional[builtins.str] = None,
        threshold_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param gain: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        :param gain_var: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        :param sigma: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        :param threshold: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        :param threshold_var: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c4c3587847a4870b7846081c0349e66c64d67141cbf86d44c495e4074e17e634)
            check_type(argname="argument gain", value=gain, expected_type=type_hints["gain"])
            check_type(argname="argument gain_var", value=gain_var, expected_type=type_hints["gain_var"])
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
            check_type(argname="argument threshold", value=threshold, expected_type=type_hints["threshold"])
            check_type(argname="argument threshold_var", value=threshold_var, expected_type=type_hints["threshold_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if gain is not None:
            self._values["gain"] = gain
        if gain_var is not None:
            self._values["gain_var"] = gain_var
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var
        if threshold is not None:
            self._values["threshold"] = threshold
        if threshold_var is not None:
            self._values["threshold_var"] = threshold_var

    @builtins.property
    def gain(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        '''
        result = self._values.get("gain")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gain_var(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        '''
        result = self._values.get("gain_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        '''
        result = self._values.get("threshold")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold_var(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        result = self._values.get("threshold_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareUnsharpMask(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareUnsharpMaskList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareUnsharpMaskList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5e511b6e90bb70095a588be1302c4bed8452d958aa4ad223d876f3014a08095f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareUnsharpMaskOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b18987b9a59e5de26840ff7afa92f942867962fa0bc44e9f4c902bb5807c3a75)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareUnsharpMaskOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f5b49aed546fd3b11bd84fe7530a911aa103286f724d17004b35bc41a8c7d64d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a55eac6db8d4d5d709677c25883cc6632f89459a9541348428fab0e9b27b774e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a1399453338adc7ae2d2c5cb2f9e58f49bcd3e533a0d3319fe470322c7bf9efb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareUnsharpMask]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareUnsharpMask]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareUnsharpMask]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__17cdd6e9ae623f5d3ab5047374bbb38ee5546d00d306d1c0d65bea1b98014b30)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareUnsharpMaskOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareUnsharpMaskOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__355768cb1e1da4955fff79807aed8737d0bc078107aa74091f75f3b3545b5018)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetGain")
    def reset_gain(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGain", []))

    @jsii.member(jsii_name="resetGainVar")
    def reset_gain_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGainVar", []))

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @jsii.member(jsii_name="resetThreshold")
    def reset_threshold(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThreshold", []))

    @jsii.member(jsii_name="resetThresholdVar")
    def reset_threshold_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThresholdVar", []))

    @builtins.property
    @jsii.member(jsii_name="gainInput")
    def gain_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainInput"))

    @builtins.property
    @jsii.member(jsii_name="gainVarInput")
    def gain_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdInput")
    def threshold_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdVarInput")
    def threshold_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gain")
    def gain(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gain"))

    @gain.setter
    def gain(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__83dac015064f4319f178438b23f3c97360084adef230eefa8ab07e3d7c51dd9e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gain", value)

    @builtins.property
    @jsii.member(jsii_name="gainVar")
    def gain_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gainVar"))

    @gain_var.setter
    def gain_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c3816457ce43311ce97bb4c143ae57258327b6e68422c2d863dc6e63dad9d1d5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gainVar", value)

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2570fc41319dd18a780a3c2be57887d1c110ce76c7cd32d07641696967e78b14)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ee05f810b7e25f87606191771956dfa148520859381e81b6cbd88a14f193131)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="threshold")
    def threshold(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "threshold"))

    @threshold.setter
    def threshold(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b68266c61e20056c4d6eb4bac1fadec1aa6c6acefe601eb8b173815044f49599)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "threshold", value)

    @builtins.property
    @jsii.member(jsii_name="thresholdVar")
    def threshold_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "thresholdVar"))

    @threshold_var.setter
    def threshold_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__13cb8458fa73bb4e825a7a84d4033ab73a6e3b112bce4078e27694e2f6351f81)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "thresholdVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareUnsharpMask]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareUnsharpMask]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareUnsharpMask]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df7199fdc86dc82e42fd1c152d9dbd3f5e0e02b4d16ec78dcfa8f850da5783e1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultMaxColors",
    jsii_struct_bases=[],
    name_mapping={"colors": "colors", "colors_var": "colorsVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultMaxColors:
    def __init__(
        self,
        *,
        colors: typing.Optional[builtins.str] = None,
        colors_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param colors: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        :param colors_var: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dde1b85731750c31f4e9e8ae0890343171ac8ccb0d4a002f0302cb462bbdec28)
            check_type(argname="argument colors", value=colors, expected_type=type_hints["colors"])
            check_type(argname="argument colors_var", value=colors_var, expected_type=type_hints["colors_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if colors is not None:
            self._values["colors"] = colors
        if colors_var is not None:
            self._values["colors_var"] = colors_var

    @builtins.property
    def colors(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        '''
        result = self._values.get("colors")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def colors_var(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        result = self._values.get("colors_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultMaxColors(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultMaxColorsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultMaxColorsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b30d99b022f55082d559e9d07e073b58d1fa18b34dbddd79a7d1bce49670174e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultMaxColorsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__34fa87bae198866ff1b5594601fc7dce8819e9c4bc1e1095fd8818e21ed03f75)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultMaxColorsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e6cb73606631e207efaba4ffb51ae5b311bb45ce9d23c1b725983aea2c4345de)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fd315125324de66b24f6f493293d52cf94d28a41fe449e30686c0f4d06b5030b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__097b7575c03d380cde09e79dd968c02b8b1f949999b8ce26b35039758d1c4fda)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultMaxColors]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultMaxColors]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d800b5986616d3188a74301a9bf7dbb1249bd2203ffa30259f0ac5e775aa6e99)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultMaxColorsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultMaxColorsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__307393d2947a226f6555e231703ebe1f4731e1968e3d79c1b2afd05a22a947c2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColors")
    def reset_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColors", []))

    @jsii.member(jsii_name="resetColorsVar")
    def reset_colors_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorsVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorsInput")
    def colors_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsInput"))

    @builtins.property
    @jsii.member(jsii_name="colorsVarInput")
    def colors_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsVarInput"))

    @builtins.property
    @jsii.member(jsii_name="colors")
    def colors(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colors"))

    @colors.setter
    def colors(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e80646d96eb292bfc34dd763ac59ef69e1ce22f47e922992bcad058c38af5c02)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colors", value)

    @builtins.property
    @jsii.member(jsii_name="colorsVar")
    def colors_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorsVar"))

    @colors_var.setter
    def colors_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__52a3705b7669b5b58057740ee4ee7d3e9d7c8824c9e81df697750bb896a3c0ad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorsVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultMaxColors]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultMaxColors]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultMaxColors]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f818806f3a101e18ed6580d0c1e0ad50c19f27d8c89c62c47c93b5e764712a1d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultMirror",
    jsii_struct_bases=[],
    name_mapping={
        "horizontal": "horizontal",
        "horizontal_var": "horizontalVar",
        "vertical": "vertical",
        "vertical_var": "verticalVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultMirror:
    def __init__(
        self,
        *,
        horizontal: typing.Optional[builtins.str] = None,
        horizontal_var: typing.Optional[builtins.str] = None,
        vertical: typing.Optional[builtins.str] = None,
        vertical_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param horizontal: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        :param horizontal_var: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        :param vertical: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        :param vertical_var: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__46abeb0709519e9643d1bc55d057daa8e36cc34f9f91a3846fcd46c7f4e8d1da)
            check_type(argname="argument horizontal", value=horizontal, expected_type=type_hints["horizontal"])
            check_type(argname="argument horizontal_var", value=horizontal_var, expected_type=type_hints["horizontal_var"])
            check_type(argname="argument vertical", value=vertical, expected_type=type_hints["vertical"])
            check_type(argname="argument vertical_var", value=vertical_var, expected_type=type_hints["vertical_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if horizontal is not None:
            self._values["horizontal"] = horizontal
        if horizontal_var is not None:
            self._values["horizontal_var"] = horizontal_var
        if vertical is not None:
            self._values["vertical"] = vertical
        if vertical_var is not None:
            self._values["vertical_var"] = vertical_var

    @builtins.property
    def horizontal(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        '''
        result = self._values.get("horizontal")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def horizontal_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        '''
        result = self._values.get("horizontal_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        '''
        result = self._values.get("vertical")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        result = self._values.get("vertical_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultMirror(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultMirrorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultMirrorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb45369942267749cd24bd74fb637b2b2ea5d96d9df9352a23408f9a4e61a9f9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultMirrorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__86d4ebdd589278fad665badc1a9089720f414358a446548c1de0d11b422fde29)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultMirrorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ee0e301a163dee66bb472771d3c01a6ea57e384870025008f320d6814dff954a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e6c5697d0e5c34748a038cbc354a7bcb4f1fcdee42df41c40794c410743e48f1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__86873f5561c60630d6279558f9e71a4ae0557856933cd37b642359a0ff3dc435)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultMirror]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultMirror]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c45015927b13149d7c8a2d954fe6c4a75e32ed012dfde966f4746854a353d82f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultMirrorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultMirrorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__872355dc62ded1f56882983d12c3a4b94e91493eac2d1cf1040cec14350497c5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHorizontal")
    def reset_horizontal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontal", []))

    @jsii.member(jsii_name="resetHorizontalVar")
    def reset_horizontal_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontalVar", []))

    @jsii.member(jsii_name="resetVertical")
    def reset_vertical(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVertical", []))

    @jsii.member(jsii_name="resetVerticalVar")
    def reset_vertical_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVerticalVar", []))

    @builtins.property
    @jsii.member(jsii_name="horizontalInput")
    def horizontal_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontalVarInput")
    def horizontal_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalInput")
    def vertical_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalVarInput")
    def vertical_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontal")
    def horizontal(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontal"))

    @horizontal.setter
    def horizontal(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__24acb7995ba77eef7494b66c77e4f07ee34a4ec7f410936d6fa25b847f43282a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontal", value)

    @builtins.property
    @jsii.member(jsii_name="horizontalVar")
    def horizontal_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontalVar"))

    @horizontal_var.setter
    def horizontal_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5a38b748436673446d26fc94af3d83f2915192b7833b9e1045b56fd8c8e8b2bf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontalVar", value)

    @builtins.property
    @jsii.member(jsii_name="vertical")
    def vertical(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "vertical"))

    @vertical.setter
    def vertical(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__15c2906a745a727ba0300d24bc2f0cfa6259a4f06c43490ddfa12e3aec927675)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "vertical", value)

    @builtins.property
    @jsii.member(jsii_name="verticalVar")
    def vertical_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "verticalVar"))

    @vertical_var.setter
    def vertical_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f65c6f8878288c6964f5f06dcc4cb6347af2ec09197251d81f0b0dd9313eba11)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "verticalVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultMirror]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultMirror]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultMirror]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1737bcfa0ca55ec70d8936ad44088f7fc76b6f83ce237f0021b48c8484236cc1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultMonoHue",
    jsii_struct_bases=[],
    name_mapping={"hue": "hue", "hue_var": "hueVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultMonoHue:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__564d68ccdf4bfcce6dfce31a39ee8c0008f12deae28402a75014e9efd4c9a737)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultMonoHue(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultMonoHueList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultMonoHueList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0aacc19709f080302eaabc742c0555d7b7d73189ff316e1c246c2c78f459a88d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultMonoHueOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aaef1aeb51012997ffc5a0c6699f61f163998c7287b7f7ebe82f3a54500aa616)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultMonoHueOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa1d6483834dbc698224e7e6b30f3287984bca8a85d1f88f99be447d5c098ad1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__498bdfea4eec4faa2b2d57f82adf370e848f4984350e2915c9a81c3c91671bc7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__29beb5cbd17923041ffdc94544f4f3c5f95e6608a96327ec967253d0c4486aa8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultMonoHue]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultMonoHue]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9c729d83b5fd80123f92b1b7ba34c1f05d4d355ce5ef7b14e24e45b63b2aa77d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultMonoHueOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultMonoHueOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__050b568025528041f6a25fae9ed6d06f8a4fe4669f154a1bb4b017f7457d4fb0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cc4ff00c115682e9211695c84ea6af7305ee0c49717e010af019287e37c71a6a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a8dad2b05f8f13ca1184699cf63009879cb5f760157263c822f23a1a4106c0bd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultMonoHue]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultMonoHue]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultMonoHue]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__105257bb8e3fb464d4397259d1105e8403eb97c697bef354fb420b8214c7dc44)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultOpacity",
    jsii_struct_bases=[],
    name_mapping={"opacity": "opacity", "opacity_var": "opacityVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultOpacity:
    def __init__(
        self,
        *,
        opacity: typing.Optional[builtins.str] = None,
        opacity_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param opacity: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param opacity_var: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__52dc232a6ba4184692a173f8736b4679afe04f249048303d4744e2028d2631a9)
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument opacity_var", value=opacity_var, expected_type=type_hints["opacity_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if opacity is not None:
            self._values["opacity"] = opacity
        if opacity_var is not None:
            self._values["opacity_var"] = opacity_var

    @builtins.property
    def opacity(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def opacity_var(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        result = self._values.get("opacity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultOpacity(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultOpacityList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultOpacityList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1fa7bb0c49abe715d905187fce1f10a2a25763874c385317c8f69dd71939200e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultOpacityOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__67a7afc8c65a9172718793c6469c70159e13f0ead10162e4dc75bd07ffd63b20)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultOpacityOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2902f6d04e5c21e1f00d2b120e1297743b54c0763418729c7a427dc701f67452)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cddb846028233002c6a955128387f5ace29253d25e705ac349dadae4334855f5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4986b3be08dbedde82f0aac12b99bb12981ebeeae86d950f27d6b4ba0c0bd53b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultOpacity]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultOpacity]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__10a9b37a75146937e819778b26a5fc5772ddc72df5290d0630f26d7a47490e14)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultOpacityOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultOpacityOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5783703d5bcd2946ae9d0d1a71d358cc4df457fd0cdd5e7a026c4fd593b06fdb)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetOpacityVar")
    def reset_opacity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacityVar", []))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityVarInput")
    def opacity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacity"))

    @opacity.setter
    def opacity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ba01d6c6cf82ce4c1309c22dbda470b2e7a89bd37935be3becad0315522cd191)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacity", value)

    @builtins.property
    @jsii.member(jsii_name="opacityVar")
    def opacity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacityVar"))

    @opacity_var.setter
    def opacity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd271581e7c416b033b178d2b05885da9f004d97f91f79115595b32c9400a201)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacityVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultOpacity]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultOpacity]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultOpacity]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f596c1d55222716580079149f20e806acdd2e35f17a599ead8611a470e210fdb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5dee1e440418166c2e74781579a77b15310c513a25e0066d0907915e5b514a78)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putBackgroundColor")
    def put_background_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e9e81794fd9cec050ecdf431fa01f8b9b3aa3db2b8857d1e992db3dbcbb0a982)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBackgroundColor", [value]))

    @jsii.member(jsii_name="putBlur")
    def put_blur(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultBlur, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__306cc155b3bb8ada8d5f3efa44a3a0d5a8f80909702c6fcdc41de87168e337d3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBlur", [value]))

    @jsii.member(jsii_name="putChromaKey")
    def put_chroma_key(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultChromaKey, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__65fcc06d542a52c29572d7edd3fc4755728ae20f5ed3cde8c0bb1957de7e4099)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putChromaKey", [value]))

    @jsii.member(jsii_name="putComposite")
    def put_composite(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultComposite, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f28b4d78ad9016c598e72d9a3b6d7783be7f3c60d2e45b81c4d2b30d84cf2b31)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putComposite", [value]))

    @jsii.member(jsii_name="putCompound")
    def put_compound(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompound, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8b38c223d3d5c645fae6c371a42750e8e26732083c3e163a145a4f2f6e99c8b7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCompound", [value]))

    @jsii.member(jsii_name="putContrast")
    def put_contrast(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultContrast, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6ead590d6a37127ef4abb5b1fff06108e5894bff7102615dc5b41ff8030fb2ed)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putContrast", [value]))

    @jsii.member(jsii_name="putGoop")
    def put_goop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultGoop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cdc9e5727426f580ac02535b168b2e65ff901caeedee13296c5b8a4688729439)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGoop", [value]))

    @jsii.member(jsii_name="putGrayscale")
    def put_grayscale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultGrayscale, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7e6da450daf60cd0233ae3a8f014ce09138ddb4349f8eeb59b6a1827663645d4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGrayscale", [value]))

    @jsii.member(jsii_name="putHsl")
    def put_hsl(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultHsl, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d545abf97b4b70751c90fcc6e08f2e1098f82b02dc2598c892740071540fb05f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsl", [value]))

    @jsii.member(jsii_name="putHsv")
    def put_hsv(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultHsv, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a308329c4876c03157e78773cb46acda0dc7ffef18688e4d94c67b69cdbd508a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsv", [value]))

    @jsii.member(jsii_name="putIfDimension")
    def put_if_dimension(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimension, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__470849b8ab0db031f5a02909b50f81a82ec99bbe8cc9407c9fb1a50f50209920)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfDimension", [value]))

    @jsii.member(jsii_name="putIfOrientation")
    def put_if_orientation(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__135cb9e6dbe477e771f65c1e529b83051838958ae1dedefbfea427636738f4f7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfOrientation", [value]))

    @jsii.member(jsii_name="putMaxColors")
    def put_max_colors(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultMaxColors, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8b8441ab2bb383d02d8f5c58bc456b632cc9ce789c10b3c62cdd3db813d4f462)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMaxColors", [value]))

    @jsii.member(jsii_name="putMirror")
    def put_mirror(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultMirror, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1dfdf2d755df75087ac8659929536cae3fa1d2ab83dfe8208deefce32087bfb7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMirror", [value]))

    @jsii.member(jsii_name="putMonoHue")
    def put_mono_hue(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultMonoHue, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__20094dda3ef8da450bff3679c5e6482dd5d5aba2209618fec7947e1acc8a4605)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMonoHue", [value]))

    @jsii.member(jsii_name="putOpacity")
    def put_opacity(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultOpacity, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__54c9c202a280e1040177a9de7fe1b10f285d0a2ae543edb6ba98ce25d6e76c79)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putOpacity", [value]))

    @jsii.member(jsii_name="putRemoveColor")
    def put_remove_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultRemoveColor", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e568c2d70f4ebb8a3ba5eff685cb5e6793eed48e286853a0c0763d62229a920d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRemoveColor", [value]))

    @jsii.member(jsii_name="putUnsharpMask")
    def put_unsharp_mask(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultUnsharpMask", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b515d77f5fe98a6890fb182dd90fd1a0ad744763aead456bb42ec44f4e0ee82d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putUnsharpMask", [value]))

    @jsii.member(jsii_name="resetBackgroundColor")
    def reset_background_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBackgroundColor", []))

    @jsii.member(jsii_name="resetBlur")
    def reset_blur(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBlur", []))

    @jsii.member(jsii_name="resetChromaKey")
    def reset_chroma_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChromaKey", []))

    @jsii.member(jsii_name="resetComposite")
    def reset_composite(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetComposite", []))

    @jsii.member(jsii_name="resetCompound")
    def reset_compound(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCompound", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetGoop")
    def reset_goop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGoop", []))

    @jsii.member(jsii_name="resetGrayscale")
    def reset_grayscale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGrayscale", []))

    @jsii.member(jsii_name="resetHsl")
    def reset_hsl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsl", []))

    @jsii.member(jsii_name="resetHsv")
    def reset_hsv(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsv", []))

    @jsii.member(jsii_name="resetIfDimension")
    def reset_if_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfDimension", []))

    @jsii.member(jsii_name="resetIfOrientation")
    def reset_if_orientation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfOrientation", []))

    @jsii.member(jsii_name="resetMaxColors")
    def reset_max_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxColors", []))

    @jsii.member(jsii_name="resetMirror")
    def reset_mirror(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMirror", []))

    @jsii.member(jsii_name="resetMonoHue")
    def reset_mono_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonoHue", []))

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetRemoveColor")
    def reset_remove_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRemoveColor", []))

    @jsii.member(jsii_name="resetUnsharpMask")
    def reset_unsharp_mask(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUnsharpMask", []))

    @builtins.property
    @jsii.member(jsii_name="backgroundColor")
    def background_color(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultBackgroundColorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultBackgroundColorList, jsii.get(self, "backgroundColor"))

    @builtins.property
    @jsii.member(jsii_name="blur")
    def blur(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultBlurList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultBlurList, jsii.get(self, "blur"))

    @builtins.property
    @jsii.member(jsii_name="chromaKey")
    def chroma_key(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultChromaKeyList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultChromaKeyList, jsii.get(self, "chromaKey"))

    @builtins.property
    @jsii.member(jsii_name="composite")
    def composite(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeList, jsii.get(self, "composite"))

    @builtins.property
    @jsii.member(jsii_name="compound")
    def compound(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundList, jsii.get(self, "compound"))

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultContrastList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultContrastList, jsii.get(self, "contrast"))

    @builtins.property
    @jsii.member(jsii_name="goop")
    def goop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultGoopList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultGoopList, jsii.get(self, "goop"))

    @builtins.property
    @jsii.member(jsii_name="grayscale")
    def grayscale(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultGrayscaleList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultGrayscaleList, jsii.get(self, "grayscale"))

    @builtins.property
    @jsii.member(jsii_name="hsl")
    def hsl(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultHslList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultHslList, jsii.get(self, "hsl"))

    @builtins.property
    @jsii.member(jsii_name="hsv")
    def hsv(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultHsvList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultHsvList, jsii.get(self, "hsv"))

    @builtins.property
    @jsii.member(jsii_name="ifDimension")
    def if_dimension(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionList", jsii.get(self, "ifDimension"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientation")
    def if_orientation(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationList, jsii.get(self, "ifOrientation"))

    @builtins.property
    @jsii.member(jsii_name="maxColors")
    def max_colors(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultMaxColorsList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultMaxColorsList, jsii.get(self, "maxColors"))

    @builtins.property
    @jsii.member(jsii_name="mirror")
    def mirror(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultMirrorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultMirrorList, jsii.get(self, "mirror"))

    @builtins.property
    @jsii.member(jsii_name="monoHue")
    def mono_hue(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultMonoHueList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultMonoHueList, jsii.get(self, "monoHue"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultOpacityList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultOpacityList, jsii.get(self, "opacity"))

    @builtins.property
    @jsii.member(jsii_name="removeColor")
    def remove_color(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultRemoveColorList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultRemoveColorList", jsii.get(self, "removeColor"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMask")
    def unsharp_mask(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultUnsharpMaskList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultUnsharpMaskList", jsii.get(self, "unsharpMask"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColorInput")
    def background_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultBackgroundColor]]], jsii.get(self, "backgroundColorInput"))

    @builtins.property
    @jsii.member(jsii_name="blurInput")
    def blur_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultBlur]]], jsii.get(self, "blurInput"))

    @builtins.property
    @jsii.member(jsii_name="chromaKeyInput")
    def chroma_key_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultChromaKey]]], jsii.get(self, "chromaKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="compositeInput")
    def composite_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultComposite]]], jsii.get(self, "compositeInput"))

    @builtins.property
    @jsii.member(jsii_name="compoundInput")
    def compound_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompound]]], jsii.get(self, "compoundInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultContrast]]], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="goopInput")
    def goop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultGoop]]], jsii.get(self, "goopInput"))

    @builtins.property
    @jsii.member(jsii_name="grayscaleInput")
    def grayscale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultGrayscale]]], jsii.get(self, "grayscaleInput"))

    @builtins.property
    @jsii.member(jsii_name="hslInput")
    def hsl_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultHsl]]], jsii.get(self, "hslInput"))

    @builtins.property
    @jsii.member(jsii_name="hsvInput")
    def hsv_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultHsv]]], jsii.get(self, "hsvInput"))

    @builtins.property
    @jsii.member(jsii_name="ifDimensionInput")
    def if_dimension_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimension]]], jsii.get(self, "ifDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientationInput")
    def if_orientation_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientation]]], jsii.get(self, "ifOrientationInput"))

    @builtins.property
    @jsii.member(jsii_name="maxColorsInput")
    def max_colors_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultMaxColors]]], jsii.get(self, "maxColorsInput"))

    @builtins.property
    @jsii.member(jsii_name="mirrorInput")
    def mirror_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultMirror]]], jsii.get(self, "mirrorInput"))

    @builtins.property
    @jsii.member(jsii_name="monoHueInput")
    def mono_hue_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultMonoHue]]], jsii.get(self, "monoHueInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultOpacity]]], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="removeColorInput")
    def remove_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultRemoveColor"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultRemoveColor"]]], jsii.get(self, "removeColorInput"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMaskInput")
    def unsharp_mask_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultUnsharpMask"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultUnsharpMask"]]], jsii.get(self, "unsharpMaskInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f84c49f881b7ad733b6ec34e9e6ee943c9f7b6122c56d361983f5c8a4bd5b500)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultRemoveColor",
    jsii_struct_bases=[],
    name_mapping={
        "color": "color",
        "color_var": "colorVar",
        "feather": "feather",
        "feather_var": "featherVar",
        "tolerance": "tolerance",
        "tolerance_var": "toleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultRemoveColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
        feather: typing.Optional[builtins.str] = None,
        feather_var: typing.Optional[builtins.str] = None,
        tolerance: typing.Optional[builtins.str] = None,
        tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        :param feather: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        :param feather_var: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        :param tolerance: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        :param tolerance_var: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__db0d9618b4e5a4524b4d4d074705d12e57c1caa19560a404ddd28e9d43a2b2a0)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
            check_type(argname="argument feather", value=feather, expected_type=type_hints["feather"])
            check_type(argname="argument feather_var", value=feather_var, expected_type=type_hints["feather_var"])
            check_type(argname="argument tolerance", value=tolerance, expected_type=type_hints["tolerance"])
            check_type(argname="argument tolerance_var", value=tolerance_var, expected_type=type_hints["tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var
        if feather is not None:
            self._values["feather"] = feather
        if feather_var is not None:
            self._values["feather_var"] = feather_var
        if tolerance is not None:
            self._values["tolerance"] = tolerance
        if tolerance_var is not None:
            self._values["tolerance_var"] = tolerance_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        '''
        result = self._values.get("feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather_var(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        '''
        result = self._values.get("feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        '''
        result = self._values.get("tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance_var(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        result = self._values.get("tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultRemoveColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultRemoveColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultRemoveColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5a10d30e3ed448eb3ac71f7686689eb10b48202ecc9027dffdc4a02256b7a01e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultRemoveColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e0621176bc8ff8347c26c72480290b54fcc725b8ffa9efc14c8f93c03a60b51b)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultRemoveColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__40c2b5d46cec8ea41755ce7510afbaa5873190200f0ceead2b98e8a6254f59ab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__29f54723362fd389d9aab4c4340c96b62d1cebcf68efdfae98a7db9973c83b22)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4bc8c9883a02d9d9f74cfe4a4a0c553afe5d347649a8b40c0b87c62b19a96dba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultRemoveColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultRemoveColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultRemoveColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__97d7614ea854c413fc80459914198accddcaa99d49de55d7b3f29f0c179bf211)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultRemoveColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultRemoveColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d9d773d6995da8ecd43973fc9bcdf88c4f3815bd6c17dacb635f1b626cdc3e27)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @jsii.member(jsii_name="resetFeather")
    def reset_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeather", []))

    @jsii.member(jsii_name="resetFeatherVar")
    def reset_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatherVar", []))

    @jsii.member(jsii_name="resetTolerance")
    def reset_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTolerance", []))

    @jsii.member(jsii_name="resetToleranceVar")
    def reset_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featherInput")
    def feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherInput"))

    @builtins.property
    @jsii.member(jsii_name="featherVarInput")
    def feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceInput")
    def tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceVarInput")
    def tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d8abaf0f8b66d1c3907399e023ba1b7772db4d2f5fc55438ef9e3e4bf47b4490)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b84350667535bdb78c713cd729b81ca24b9f775bd0beec72944813cb6e05b29b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="feather")
    def feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "feather"))

    @feather.setter
    def feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__69f0f18d7aff85d4d1789305f53ed5ff5285409937aa4aad01c196f48c59a2a6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "feather", value)

    @builtins.property
    @jsii.member(jsii_name="featherVar")
    def feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featherVar"))

    @feather_var.setter
    def feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1c653786d2d26b2ced5305b431392d0d73a23200254ed59ffa39a1e94adfaa43)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featherVar", value)

    @builtins.property
    @jsii.member(jsii_name="tolerance")
    def tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tolerance"))

    @tolerance.setter
    def tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e184f64978695d3defd087c36d110f109094e56b55f8283129314e6dd22bb554)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tolerance", value)

    @builtins.property
    @jsii.member(jsii_name="toleranceVar")
    def tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "toleranceVar"))

    @tolerance_var.setter
    def tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7b2c627228fe26686e2e00d9ca6aaeb6550b788a30d0242fd11c8ec2f674e326)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "toleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultRemoveColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultRemoveColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultRemoveColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6166ec397c291be374b352682079569dbfb06b07bd62a67df19f4c26afaaf1f0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultUnsharpMask",
    jsii_struct_bases=[],
    name_mapping={
        "gain": "gain",
        "gain_var": "gainVar",
        "sigma": "sigma",
        "sigma_var": "sigmaVar",
        "threshold": "threshold",
        "threshold_var": "thresholdVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultUnsharpMask:
    def __init__(
        self,
        *,
        gain: typing.Optional[builtins.str] = None,
        gain_var: typing.Optional[builtins.str] = None,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
        threshold: typing.Optional[builtins.str] = None,
        threshold_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param gain: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        :param gain_var: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        :param sigma: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        :param threshold: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        :param threshold_var: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3c413e98f45836a8ae3e7a14a53f9b360c10cf258828040c767426be770aa646)
            check_type(argname="argument gain", value=gain, expected_type=type_hints["gain"])
            check_type(argname="argument gain_var", value=gain_var, expected_type=type_hints["gain_var"])
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
            check_type(argname="argument threshold", value=threshold, expected_type=type_hints["threshold"])
            check_type(argname="argument threshold_var", value=threshold_var, expected_type=type_hints["threshold_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if gain is not None:
            self._values["gain"] = gain
        if gain_var is not None:
            self._values["gain_var"] = gain_var
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var
        if threshold is not None:
            self._values["threshold"] = threshold
        if threshold_var is not None:
            self._values["threshold_var"] = threshold_var

    @builtins.property
    def gain(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        '''
        result = self._values.get("gain")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gain_var(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        '''
        result = self._values.get("gain_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        '''
        result = self._values.get("threshold")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold_var(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        result = self._values.get("threshold_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultUnsharpMask(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultUnsharpMaskList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultUnsharpMaskList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4921fbe4d1f81f95f731747dc54ae382d39897fbdf13d09ac7c2c5fd53af54f1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultUnsharpMaskOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4122ed0f00f4a89bf9e2f67a269eeec1f8e6114e3089b26401641c5b832a20aa)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultUnsharpMaskOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f34e122767164122173e3d30757d206269c1a98bdc5b39e2f317cf23e65e63c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4db22232857ab8532e7d98d9dd485adcf71e59d55b35677748a7b616275be63f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ca20a36258b87d66c296061cb8ca625bce0ecd70ccc80a3ee27e5321b4a5f9e8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultUnsharpMask]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultUnsharpMask]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultUnsharpMask]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__11bf1d5a833d159391629086e7ba72dd581dd3fabdf067830450ecc357963ed9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultUnsharpMaskOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultUnsharpMaskOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e31c511a96d1c1451f4da5029c03bbd28694fa7406b7d168acaeb4fdad63e59)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetGain")
    def reset_gain(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGain", []))

    @jsii.member(jsii_name="resetGainVar")
    def reset_gain_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGainVar", []))

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @jsii.member(jsii_name="resetThreshold")
    def reset_threshold(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThreshold", []))

    @jsii.member(jsii_name="resetThresholdVar")
    def reset_threshold_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThresholdVar", []))

    @builtins.property
    @jsii.member(jsii_name="gainInput")
    def gain_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainInput"))

    @builtins.property
    @jsii.member(jsii_name="gainVarInput")
    def gain_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdInput")
    def threshold_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdVarInput")
    def threshold_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gain")
    def gain(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gain"))

    @gain.setter
    def gain(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bae727892d690f2653a1a25b4ca6dbeec9080c62cf070822480a91c5e6f49a79)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gain", value)

    @builtins.property
    @jsii.member(jsii_name="gainVar")
    def gain_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gainVar"))

    @gain_var.setter
    def gain_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f54b8f0285cd9f71c937f3f62d09e34332f2f5f4ec94a71fcec92b94e35719e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gainVar", value)

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__75e06a763cdde3f699219490c862f54518f2974cc3e6678415f8c20d5f1f9b2e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__21a05813c90d0443278dda1e94d73217af707576fa903de36b926b257d79b512)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="threshold")
    def threshold(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "threshold"))

    @threshold.setter
    def threshold(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__693fd14853bf26ee6658e7bbd03fa53ec9338e85063ecef3ad0a55a2a83c4a4e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "threshold", value)

    @builtins.property
    @jsii.member(jsii_name="thresholdVar")
    def threshold_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "thresholdVar"))

    @threshold_var.setter
    def threshold_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__982ffb50d62e0a764f8255f21f27701d707e1beb43508eeb219fa6c93fb6d463)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "thresholdVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultUnsharpMask]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultUnsharpMask]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultUnsharpMask]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c220e101ce7da19151b35003f7b18d4c2b12ff6074135d99ed2e9778601d5568)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqual",
    jsii_struct_bases=[],
    name_mapping={
        "background_color": "backgroundColor",
        "blur": "blur",
        "chroma_key": "chromaKey",
        "composite": "composite",
        "compound": "compound",
        "contrast": "contrast",
        "goop": "goop",
        "grayscale": "grayscale",
        "hsl": "hsl",
        "hsv": "hsv",
        "if_dimension": "ifDimension",
        "if_orientation": "ifOrientation",
        "max_colors": "maxColors",
        "mirror": "mirror",
        "mono_hue": "monoHue",
        "opacity": "opacity",
        "remove_color": "removeColor",
        "unsharp_mask": "unsharpMask",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqual:
    def __init__(
        self,
        *,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualBackgroundColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualBlur", typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualChromaKey", typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualComposite", typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompound", typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualContrast", typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualGoop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualGrayscale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualHsl", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualHsv", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientation", typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualMaxColors", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualMirror", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualMonoHue", typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualOpacity", typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualRemoveColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualUnsharpMask", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__145697a9a907979a87dd81bc6b9cc2fb29887664bf9153641de47d845933103a)
            check_type(argname="argument background_color", value=background_color, expected_type=type_hints["background_color"])
            check_type(argname="argument blur", value=blur, expected_type=type_hints["blur"])
            check_type(argname="argument chroma_key", value=chroma_key, expected_type=type_hints["chroma_key"])
            check_type(argname="argument composite", value=composite, expected_type=type_hints["composite"])
            check_type(argname="argument compound", value=compound, expected_type=type_hints["compound"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument goop", value=goop, expected_type=type_hints["goop"])
            check_type(argname="argument grayscale", value=grayscale, expected_type=type_hints["grayscale"])
            check_type(argname="argument hsl", value=hsl, expected_type=type_hints["hsl"])
            check_type(argname="argument hsv", value=hsv, expected_type=type_hints["hsv"])
            check_type(argname="argument if_dimension", value=if_dimension, expected_type=type_hints["if_dimension"])
            check_type(argname="argument if_orientation", value=if_orientation, expected_type=type_hints["if_orientation"])
            check_type(argname="argument max_colors", value=max_colors, expected_type=type_hints["max_colors"])
            check_type(argname="argument mirror", value=mirror, expected_type=type_hints["mirror"])
            check_type(argname="argument mono_hue", value=mono_hue, expected_type=type_hints["mono_hue"])
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument remove_color", value=remove_color, expected_type=type_hints["remove_color"])
            check_type(argname="argument unsharp_mask", value=unsharp_mask, expected_type=type_hints["unsharp_mask"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if background_color is not None:
            self._values["background_color"] = background_color
        if blur is not None:
            self._values["blur"] = blur
        if chroma_key is not None:
            self._values["chroma_key"] = chroma_key
        if composite is not None:
            self._values["composite"] = composite
        if compound is not None:
            self._values["compound"] = compound
        if contrast is not None:
            self._values["contrast"] = contrast
        if goop is not None:
            self._values["goop"] = goop
        if grayscale is not None:
            self._values["grayscale"] = grayscale
        if hsl is not None:
            self._values["hsl"] = hsl
        if hsv is not None:
            self._values["hsv"] = hsv
        if if_dimension is not None:
            self._values["if_dimension"] = if_dimension
        if if_orientation is not None:
            self._values["if_orientation"] = if_orientation
        if max_colors is not None:
            self._values["max_colors"] = max_colors
        if mirror is not None:
            self._values["mirror"] = mirror
        if mono_hue is not None:
            self._values["mono_hue"] = mono_hue
        if opacity is not None:
            self._values["opacity"] = opacity
        if remove_color is not None:
            self._values["remove_color"] = remove_color
        if unsharp_mask is not None:
            self._values["unsharp_mask"] = unsharp_mask

    @builtins.property
    def background_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualBackgroundColor"]]]:
        '''background_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        '''
        result = self._values.get("background_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualBackgroundColor"]]], result)

    @builtins.property
    def blur(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualBlur"]]]:
        '''blur block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        '''
        result = self._values.get("blur")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualBlur"]]], result)

    @builtins.property
    def chroma_key(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualChromaKey"]]]:
        '''chroma_key block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        '''
        result = self._values.get("chroma_key")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualChromaKey"]]], result)

    @builtins.property
    def composite(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualComposite"]]]:
        '''composite block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        '''
        result = self._values.get("composite")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualComposite"]]], result)

    @builtins.property
    def compound(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompound"]]]:
        '''compound block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        '''
        result = self._values.get("compound")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompound"]]], result)

    @builtins.property
    def contrast(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualContrast"]]]:
        '''contrast block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualContrast"]]], result)

    @builtins.property
    def goop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualGoop"]]]:
        '''goop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        '''
        result = self._values.get("goop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualGoop"]]], result)

    @builtins.property
    def grayscale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualGrayscale"]]]:
        '''grayscale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        '''
        result = self._values.get("grayscale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualGrayscale"]]], result)

    @builtins.property
    def hsl(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualHsl"]]]:
        '''hsl block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        '''
        result = self._values.get("hsl")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualHsl"]]], result)

    @builtins.property
    def hsv(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualHsv"]]]:
        '''hsv block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        '''
        result = self._values.get("hsv")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualHsv"]]], result)

    @builtins.property
    def if_dimension(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimension]]]:
        '''if_dimension block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        '''
        result = self._values.get("if_dimension")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimension]]], result)

    @builtins.property
    def if_orientation(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientation"]]]:
        '''if_orientation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        '''
        result = self._values.get("if_orientation")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientation"]]], result)

    @builtins.property
    def max_colors(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualMaxColors"]]]:
        '''max_colors block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        '''
        result = self._values.get("max_colors")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualMaxColors"]]], result)

    @builtins.property
    def mirror(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualMirror"]]]:
        '''mirror block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        '''
        result = self._values.get("mirror")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualMirror"]]], result)

    @builtins.property
    def mono_hue(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualMonoHue"]]]:
        '''mono_hue block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        '''
        result = self._values.get("mono_hue")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualMonoHue"]]], result)

    @builtins.property
    def opacity(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualOpacity"]]]:
        '''opacity block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualOpacity"]]], result)

    @builtins.property
    def remove_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualRemoveColor"]]]:
        '''remove_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        '''
        result = self._values.get("remove_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualRemoveColor"]]], result)

    @builtins.property
    def unsharp_mask(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualUnsharpMask"]]]:
        '''unsharp_mask block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        result = self._values.get("unsharp_mask")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualUnsharpMask"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqual(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualBackgroundColor",
    jsii_struct_bases=[],
    name_mapping={"color": "color", "color_var": "colorVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualBackgroundColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cba85f5eea881057cd452435c8e246739639edd734f8be355cb1eff76ad3fb41)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualBackgroundColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualBackgroundColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualBackgroundColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e3d7f15824de2063e224f16a760cdd6e749bf03e6cce561bdc25734733228d6a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualBackgroundColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7898124b2e7404512a4b11b90890b6d48925cf7e5cb65f3182123ff1a178567b)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualBackgroundColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__75bd644a21051347a0b36894da0c481f5d6adeb7e274655c18c51d56639269e9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5eb6d30fdf423fa23abe008e91260538e73d77c2ede16ebbc12bc8d7e4cf7e37)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea6a2dc11387006b94995e47c92a8c3c81870afeca0ac04cfb54277f9c17b771)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualBackgroundColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualBackgroundColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc5d223e6cf9bffc52675d5ab7a80c7a6b71388a25e0794ea6839c265d9c6874)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualBackgroundColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualBackgroundColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ceee0c6f531d12fde5962896bf6825d215e863ddc59975960cc08978a0d701e2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2dc9861c86b2a4711df2f44d420b48175f8e12092571582521059fdc4b42a5dd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d52d5845f6cfd90274435c5069f38e17d60e92953a9605ccc59b5d91db005a95)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualBackgroundColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualBackgroundColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualBackgroundColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4f77dc682c9b721887a6597f2906ebe51b5f7c25fbb6334ee3ea435c43c578bf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualBlur",
    jsii_struct_bases=[],
    name_mapping={"sigma": "sigma", "sigma_var": "sigmaVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualBlur:
    def __init__(
        self,
        *,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param sigma: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__49fcce9b764083daaee613c0c3ad9cbdd3f383b0e2b40db775c1224a655f6451)
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualBlur(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualBlurList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualBlurList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f8b44566a85ad34635e52606014872cb170fff0851f13c11b7500e32e6212877)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualBlurOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e28332a2cf2eb9074299e254db5bbfce4d99f9980f0e12eaa22100899357fde5)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualBlurOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f380f792cd3b148353cfd6f4a38e664ce2e854f61df0402a58de99d1f4b5cdf5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1a7679f12e2f7c49ee5ed9e70cc260eb206607f5898b6285dc0d4fbf90a9bfda)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cb681984de922bf7b0e14ecbe038ecef54c3134352fe7eea1c6c46e1b7251004)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualBlur]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualBlur]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d09a6544d3edd60fef4ba029cf8a5d8613cca9d6d0ee185051f69d3e81dfd4a0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualBlurOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualBlurOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a9edce24e48779d4f211b195fa92afd8164bd18e1ca0090846f5898ec8ec71d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cba8a6afbb90df92858ca61b861b4d44951af1f9b8ab9e9eaf44033ff07cc0dc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0bed96d3786d292d4f48b000df92fe2b8f18503f64c8832be10f91b372002d52)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualBlur]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualBlur]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualBlur]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0a23de960902a88c909ea2a3df31e9adb987efa9ae1a7134dc77b0a51886402f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualChromaKey",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_feather": "hueFeather",
        "hue_feather_var": "hueFeatherVar",
        "hue_tolerance": "hueTolerance",
        "hue_tolerance_var": "hueToleranceVar",
        "hue_var": "hueVar",
        "lightness_feather": "lightnessFeather",
        "lightness_feather_var": "lightnessFeatherVar",
        "lightness_tolerance": "lightnessTolerance",
        "lightness_tolerance_var": "lightnessToleranceVar",
        "saturation_feather": "saturationFeather",
        "saturation_feather_var": "saturationFeatherVar",
        "saturation_tolerance": "saturationTolerance",
        "saturation_tolerance_var": "saturationToleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualChromaKey:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_feather: typing.Optional[builtins.str] = None,
        hue_feather_var: typing.Optional[builtins.str] = None,
        hue_tolerance: typing.Optional[builtins.str] = None,
        hue_tolerance_var: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness_feather: typing.Optional[builtins.str] = None,
        lightness_feather_var: typing.Optional[builtins.str] = None,
        lightness_tolerance: typing.Optional[builtins.str] = None,
        lightness_tolerance_var: typing.Optional[builtins.str] = None,
        saturation_feather: typing.Optional[builtins.str] = None,
        saturation_feather_var: typing.Optional[builtins.str] = None,
        saturation_tolerance: typing.Optional[builtins.str] = None,
        saturation_tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_feather: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        :param hue_feather_var: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        :param hue_tolerance: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        :param hue_tolerance_var: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        :param hue_var: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness_feather: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        :param lightness_feather_var: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        :param lightness_tolerance: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        :param lightness_tolerance_var: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        :param saturation_feather: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        :param saturation_feather_var: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        :param saturation_tolerance: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        :param saturation_tolerance_var: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__10ccb3adf9f2bc583ba26b91f589283ee453e57d63c7bbe6e52636e690e9afec)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_feather", value=hue_feather, expected_type=type_hints["hue_feather"])
            check_type(argname="argument hue_feather_var", value=hue_feather_var, expected_type=type_hints["hue_feather_var"])
            check_type(argname="argument hue_tolerance", value=hue_tolerance, expected_type=type_hints["hue_tolerance"])
            check_type(argname="argument hue_tolerance_var", value=hue_tolerance_var, expected_type=type_hints["hue_tolerance_var"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness_feather", value=lightness_feather, expected_type=type_hints["lightness_feather"])
            check_type(argname="argument lightness_feather_var", value=lightness_feather_var, expected_type=type_hints["lightness_feather_var"])
            check_type(argname="argument lightness_tolerance", value=lightness_tolerance, expected_type=type_hints["lightness_tolerance"])
            check_type(argname="argument lightness_tolerance_var", value=lightness_tolerance_var, expected_type=type_hints["lightness_tolerance_var"])
            check_type(argname="argument saturation_feather", value=saturation_feather, expected_type=type_hints["saturation_feather"])
            check_type(argname="argument saturation_feather_var", value=saturation_feather_var, expected_type=type_hints["saturation_feather_var"])
            check_type(argname="argument saturation_tolerance", value=saturation_tolerance, expected_type=type_hints["saturation_tolerance"])
            check_type(argname="argument saturation_tolerance_var", value=saturation_tolerance_var, expected_type=type_hints["saturation_tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_feather is not None:
            self._values["hue_feather"] = hue_feather
        if hue_feather_var is not None:
            self._values["hue_feather_var"] = hue_feather_var
        if hue_tolerance is not None:
            self._values["hue_tolerance"] = hue_tolerance
        if hue_tolerance_var is not None:
            self._values["hue_tolerance_var"] = hue_tolerance_var
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness_feather is not None:
            self._values["lightness_feather"] = lightness_feather
        if lightness_feather_var is not None:
            self._values["lightness_feather_var"] = lightness_feather_var
        if lightness_tolerance is not None:
            self._values["lightness_tolerance"] = lightness_tolerance
        if lightness_tolerance_var is not None:
            self._values["lightness_tolerance_var"] = lightness_tolerance_var
        if saturation_feather is not None:
            self._values["saturation_feather"] = saturation_feather
        if saturation_feather_var is not None:
            self._values["saturation_feather_var"] = saturation_feather_var
        if saturation_tolerance is not None:
            self._values["saturation_tolerance"] = saturation_tolerance
        if saturation_tolerance_var is not None:
            self._values["saturation_tolerance_var"] = saturation_tolerance_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        '''
        result = self._values.get("hue_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        '''
        result = self._values.get("hue_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        '''
        result = self._values.get("hue_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        '''
        result = self._values.get("hue_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        '''
        result = self._values.get("lightness_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        '''
        result = self._values.get("lightness_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        '''
        result = self._values.get("lightness_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        '''
        result = self._values.get("lightness_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        '''
        result = self._values.get("saturation_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        '''
        result = self._values.get("saturation_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        '''
        result = self._values.get("saturation_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        result = self._values.get("saturation_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualChromaKey(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualChromaKeyList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualChromaKeyList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5287aa82438baed16552bbb1f7feab7697881979df1eed7ac2444a9efa91385b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualChromaKeyOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7cb7e33eb202aba42b6892ab70bfc8a1c7612c0efbb68802e78c4183e6c14fab)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualChromaKeyOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__63b6672fb35ba7f9ee587f91665da3ba6c678639b702b8a261899e08eafb5901)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__605df6aee3e22a38c2283120a7ce08fbb8fa7a3249ae7ab2d213924bc23b2f2e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f4fd24030441d684fe67a179d04594acfe11fa3108a7dcc5bfefc1229c5bb4f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualChromaKey]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualChromaKey]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f8b081df84e7ccf9e9c3eb2abd6992691a03101c5b7a4f39c7b61931fdc744a4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualChromaKeyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualChromaKeyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5372f2c0f8a11bc9ba533ca323923a07341f1d7ec6d3e1da441194c48f76b562)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueFeather")
    def reset_hue_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeather", []))

    @jsii.member(jsii_name="resetHueFeatherVar")
    def reset_hue_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeatherVar", []))

    @jsii.member(jsii_name="resetHueTolerance")
    def reset_hue_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueTolerance", []))

    @jsii.member(jsii_name="resetHueToleranceVar")
    def reset_hue_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueToleranceVar", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightnessFeather")
    def reset_lightness_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeather", []))

    @jsii.member(jsii_name="resetLightnessFeatherVar")
    def reset_lightness_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeatherVar", []))

    @jsii.member(jsii_name="resetLightnessTolerance")
    def reset_lightness_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessTolerance", []))

    @jsii.member(jsii_name="resetLightnessToleranceVar")
    def reset_lightness_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessToleranceVar", []))

    @jsii.member(jsii_name="resetSaturationFeather")
    def reset_saturation_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeather", []))

    @jsii.member(jsii_name="resetSaturationFeatherVar")
    def reset_saturation_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeatherVar", []))

    @jsii.member(jsii_name="resetSaturationTolerance")
    def reset_saturation_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationTolerance", []))

    @jsii.member(jsii_name="resetSaturationToleranceVar")
    def reset_saturation_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherInput")
    def hue_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVarInput")
    def hue_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceInput")
    def hue_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVarInput")
    def hue_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherInput")
    def lightness_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVarInput")
    def lightness_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceInput")
    def lightness_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVarInput")
    def lightness_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherInput")
    def saturation_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVarInput")
    def saturation_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceInput")
    def saturation_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVarInput")
    def saturation_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6d7205fbc4ff0a847575cdfbe50d374275a1603921b68a400baf643e92115e1b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeather")
    def hue_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeather"))

    @hue_feather.setter
    def hue_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3915dd96303ad469db7b0d1485d1e0634b1df322650bd4ba66721a1d1a6baf31)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeather", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVar")
    def hue_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeatherVar"))

    @hue_feather_var.setter
    def hue_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cf3b8ccb415d6de2384e7764026b565e03a5eb11866d86b68bbad25fff27bf16)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueTolerance")
    def hue_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueTolerance"))

    @hue_tolerance.setter
    def hue_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f1a0caa1fc236d44165069f98511952e0bcf1a6a5b660b9cbfd3ee090a85a909)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVar")
    def hue_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueToleranceVar"))

    @hue_tolerance_var.setter
    def hue_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a5cc0196da21dd8e17b17a9f91cb1d9089dba2e797a6d3f2f406f64e5b098e7b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c449a5b11e23b5027cd7fdfa23ec19ae9cf12f48a39c3c0e6a4686827628bd11)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeather")
    def lightness_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeather"))

    @lightness_feather.setter
    def lightness_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d371c5ea66465821f2531afb9d7577c1a4dfba7f3ca7308415b94df268717115)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeather", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVar")
    def lightness_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeatherVar"))

    @lightness_feather_var.setter
    def lightness_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__68fe010982faaef262cd07a11f2591a3e2c0ecf780949a1f1969ef923e4954e8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessTolerance")
    def lightness_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessTolerance"))

    @lightness_tolerance.setter
    def lightness_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__86d5845b7a5670a98ee869ff40d665966b27be581bc0a7e004bd0cb492ec65c7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVar")
    def lightness_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessToleranceVar"))

    @lightness_tolerance_var.setter
    def lightness_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6494935cb5c457857f933142a3d9de7dfb8a2a34fc5025ca20713ec0d6861e8a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeather")
    def saturation_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeather"))

    @saturation_feather.setter
    def saturation_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__73a8d9476412b46a11ee67a6de126e9ad63188c4939ae0fd7d7a5cdf53a1abf9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeather", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVar")
    def saturation_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeatherVar"))

    @saturation_feather_var.setter
    def saturation_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__37035941145893b2c7edd8fcc817e6d0023ff64dd254ad9740e013a632766a61)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationTolerance")
    def saturation_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationTolerance"))

    @saturation_tolerance.setter
    def saturation_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a537c99bbf2a9f874757d677a8ab644aeb06a4396672a42b48b1a3d7942ebbea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVar")
    def saturation_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationToleranceVar"))

    @saturation_tolerance_var.setter
    def saturation_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ba7b3aae3d2bcc31054ffb87b33aa0bfa73fb5cbb6c7284e8562acd2b509963)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualChromaKey]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualChromaKey]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualChromaKey]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__15a0c129d6449567f8ad7f7d68522fce0a758f467fa9b897ef7305fad629f849)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualComposite",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "placement": "placement",
        "placement_var": "placementVar",
        "scale": "scale",
        "scale_dimension": "scaleDimension",
        "scale_dimension_var": "scaleDimensionVar",
        "scale_var": "scaleVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualComposite:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        placement: typing.Optional[builtins.str] = None,
        placement_var: typing.Optional[builtins.str] = None,
        scale: typing.Optional[builtins.str] = None,
        scale_dimension: typing.Optional[builtins.str] = None,
        scale_dimension_var: typing.Optional[builtins.str] = None,
        scale_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param placement: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        :param placement_var: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        :param scale: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param scale_dimension: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        :param scale_dimension_var: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        :param scale_var: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        :param x_position: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b7a575d215ff786660e29797da21daa822482a3bece7cb293db0d04568402ccf)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument placement", value=placement, expected_type=type_hints["placement"])
            check_type(argname="argument placement_var", value=placement_var, expected_type=type_hints["placement_var"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument scale_dimension", value=scale_dimension, expected_type=type_hints["scale_dimension"])
            check_type(argname="argument scale_dimension_var", value=scale_dimension_var, expected_type=type_hints["scale_dimension_var"])
            check_type(argname="argument scale_var", value=scale_var, expected_type=type_hints["scale_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if placement is not None:
            self._values["placement"] = placement
        if placement_var is not None:
            self._values["placement_var"] = placement_var
        if scale is not None:
            self._values["scale"] = scale
        if scale_dimension is not None:
            self._values["scale_dimension"] = scale_dimension
        if scale_dimension_var is not None:
            self._values["scale_dimension_var"] = scale_dimension_var
        if scale_var is not None:
            self._values["scale_var"] = scale_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        '''
        result = self._values.get("placement")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement_var(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        '''
        result = self._values.get("placement_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        '''
        result = self._values.get("scale_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        '''
        result = self._values.get("scale_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        '''
        result = self._values.get("scale_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualComposite(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImage",
    jsii_struct_bases=[],
    name_mapping={
        "box_image": "boxImage",
        "circle_image": "circleImage",
        "text_image": "textImage",
        "url_image": "urlImage",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImage:
    def __init__(
        self,
        *,
        box_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageBoxImage", typing.Dict[builtins.str, typing.Any]]]]] = None,
        circle_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageCircleImage", typing.Dict[builtins.str, typing.Any]]]]] = None,
        text_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageTextImage", typing.Dict[builtins.str, typing.Any]]]]] = None,
        url_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageUrlImage", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param box_image: box_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#box_image DataAkamaiImagingPolicyImage#box_image}
        :param circle_image: circle_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#circle_image DataAkamaiImagingPolicyImage#circle_image}
        :param text_image: text_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text_image DataAkamaiImagingPolicyImage#text_image}
        :param url_image: url_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url_image DataAkamaiImagingPolicyImage#url_image}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e1806bb724f34c89d45e0387ba2f0536a9efdceac7a6eed9eddd927041177115)
            check_type(argname="argument box_image", value=box_image, expected_type=type_hints["box_image"])
            check_type(argname="argument circle_image", value=circle_image, expected_type=type_hints["circle_image"])
            check_type(argname="argument text_image", value=text_image, expected_type=type_hints["text_image"])
            check_type(argname="argument url_image", value=url_image, expected_type=type_hints["url_image"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if box_image is not None:
            self._values["box_image"] = box_image
        if circle_image is not None:
            self._values["circle_image"] = circle_image
        if text_image is not None:
            self._values["text_image"] = text_image
        if url_image is not None:
            self._values["url_image"] = url_image

    @builtins.property
    def box_image(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageBoxImage"]]]:
        '''box_image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#box_image DataAkamaiImagingPolicyImage#box_image}
        '''
        result = self._values.get("box_image")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageBoxImage"]]], result)

    @builtins.property
    def circle_image(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageCircleImage"]]]:
        '''circle_image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#circle_image DataAkamaiImagingPolicyImage#circle_image}
        '''
        result = self._values.get("circle_image")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageCircleImage"]]], result)

    @builtins.property
    def text_image(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageTextImage"]]]:
        '''text_image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text_image DataAkamaiImagingPolicyImage#text_image}
        '''
        result = self._values.get("text_image")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageTextImage"]]], result)

    @builtins.property
    def url_image(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageUrlImage"]]]:
        '''url_image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url_image DataAkamaiImagingPolicyImage#url_image}
        '''
        result = self._values.get("url_image")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageUrlImage"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageBoxImage",
    jsii_struct_bases=[],
    name_mapping={
        "color": "color",
        "color_var": "colorVar",
        "height": "height",
        "height_var": "heightVar",
        "transformation": "transformation",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageBoxImage:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        transformation: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageBoxImageTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The fill color of the box, not the edge of the box. The API supports hexadecimal representation and CSS hexadecimal color values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The fill color of the box, not the edge of the box. The API supports hexadecimal representation and CSS hexadecimal color values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        :param height: The height of the box in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height of the box in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param transformation: transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        :param width: The width of the box in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width of the box in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(transformation, dict):
            transformation = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageBoxImageTransformation(**transformation)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3798c662d36da4700077173efcec1380264cb54fd89bf789abe01f1499b4be48)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument transformation", value=transformation, expected_type=type_hints["transformation"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if transformation is not None:
            self._values["transformation"] = transformation
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The fill color of the box, not the edge of the box.

        The API supports hexadecimal representation and CSS hexadecimal color values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The fill color of the box, not the edge of the box.

        The API supports hexadecimal representation and CSS hexadecimal color values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height of the box in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height of the box in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def transformation(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageBoxImageTransformation"]:
        '''transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        '''
        result = self._values.get("transformation")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageBoxImageTransformation"], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width of the box in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width of the box in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageBoxImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageBoxImageList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageBoxImageList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__06cc2846c606705e98f3d3674ce2213994025152d82c1549a555002fcd0075a4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageBoxImageOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__250ad6ddc199a915576a6796cc4b51c32277cf81ba2918a811f83926fe13e9b8)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageBoxImageOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__02602b5f157cdf2e69ea58edf4f450fbd709f514b8fefcb68d9fc16a1fef843f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7426835ccb8c6dbe2de55fb79fa9b27ae80c99ba583955f3f1dfcac7fe03fd65)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f10c0effda2794469fe01a93e1884c1c9eb54bd8a82dbb75644a3a912444654b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageBoxImage]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageBoxImage]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageBoxImage]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8445178aa920acd9373cf3c59a04995b3844f881ba674fdce2479aa403dad1c2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageBoxImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageBoxImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ed09c7fbbc63eaa7168ac9b1777ac3db62e338fc4ba7086c12762d0fb32bf21c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformation")
    def put_transformation(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageBoxImageTransformation()

        return typing.cast(None, jsii.invoke(self, "putTransformation", [value]))

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetTransformation")
    def reset_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformation", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="transformation")
    def transformation(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageBoxImageTransformationOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageBoxImageTransformationOutputReference", jsii.get(self, "transformation"))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="transformationInput")
    def transformation_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageBoxImageTransformation"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageBoxImageTransformation"], jsii.get(self, "transformationInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__26b62edc1706831d4970f3dc5f8c81468b59211e463d729ee5f4a663c217bfb5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a60e0d5bcd03e8a81ec7f78fa4bbb13b98e126e944bf5133220ef6465b8df24d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0de76100def62f83ab53a517a90c18772df280ff3f8c0b8e394f6675e64fc2cd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__566d5237b7e5e88c478fd424cb8a8c4b00cdc78afa3898d4dd90a20fd7bc5f5d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b25fc3f54a5a592b178f8ec2ecddfd6c739cc9a9b6ffff4e80e627aa75d3625a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__28cb5c0f064f873f9266e1d9e4d4671200eb2e11cda442eac32b39d2b4f50f97)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageBoxImage]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageBoxImage]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageBoxImage]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6d5e6d1f101f680c651f9bec3b42fc7fbdffd7e5f270cba8382bd414d3342da8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageBoxImageTransformation",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageBoxImageTransformation:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageBoxImageTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageBoxImageTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageBoxImageTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__50d63a22ce81d2110288c245ced74af574f6b638b5f574a0c2a4ae64495eaed8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageBoxImageTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageBoxImageTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageBoxImageTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f7c7a5304689b70ad32797f1bc5bcd108505fb66b955f23a7d8564c3177496c7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageCircleImage",
    jsii_struct_bases=[],
    name_mapping={
        "color": "color",
        "color_var": "colorVar",
        "diameter": "diameter",
        "diameter_var": "diameterVar",
        "transformation": "transformation",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageCircleImage:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
        diameter: typing.Optional[builtins.str] = None,
        diameter_var: typing.Optional[builtins.str] = None,
        transformation: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageCircleImageTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The fill color of the circle. The API supports hexadecimal representation and CSS hexadecimal color values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The fill color of the circle. The API supports hexadecimal representation and CSS hexadecimal color values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        :param diameter: The diameter of the circle. The diameter will be the width and the height of the image in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#diameter DataAkamaiImagingPolicyImage#diameter}
        :param diameter_var: The diameter of the circle. The diameter will be the width and the height of the image in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#diameter_var DataAkamaiImagingPolicyImage#diameter_var}
        :param transformation: transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        :param width: The width of the box in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width of the box in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(transformation, dict):
            transformation = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageCircleImageTransformation(**transformation)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3be9ea4904ab4572243dcf0ad99a9719a29fcbe7fdb7717a113df097bb886df7)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
            check_type(argname="argument diameter", value=diameter, expected_type=type_hints["diameter"])
            check_type(argname="argument diameter_var", value=diameter_var, expected_type=type_hints["diameter_var"])
            check_type(argname="argument transformation", value=transformation, expected_type=type_hints["transformation"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var
        if diameter is not None:
            self._values["diameter"] = diameter
        if diameter_var is not None:
            self._values["diameter_var"] = diameter_var
        if transformation is not None:
            self._values["transformation"] = transformation
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The fill color of the circle. The API supports hexadecimal representation and CSS hexadecimal color values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The fill color of the circle. The API supports hexadecimal representation and CSS hexadecimal color values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def diameter(self) -> typing.Optional[builtins.str]:
        '''The diameter of the circle. The diameter will be the width and the height of the image in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#diameter DataAkamaiImagingPolicyImage#diameter}
        '''
        result = self._values.get("diameter")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def diameter_var(self) -> typing.Optional[builtins.str]:
        '''The diameter of the circle. The diameter will be the width and the height of the image in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#diameter_var DataAkamaiImagingPolicyImage#diameter_var}
        '''
        result = self._values.get("diameter_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def transformation(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageCircleImageTransformation"]:
        '''transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        '''
        result = self._values.get("transformation")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageCircleImageTransformation"], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width of the box in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width of the box in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageCircleImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageCircleImageList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageCircleImageList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa6ec643bd93f4d3859871f06482ab27fe9da3051c719d27f52df5de8d65c829)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageCircleImageOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__24bf8138dc04a9a38c0fa9703c836d56b98a29434fea814bc3ceff07a7be3d79)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageCircleImageOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0b8a6ec8fe5ec1babcb2aaf64818464fea383206db2ec7e057bd4c79ba45a37c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f9f3318a4662e9f3d4efc817c3c727b3e0354c3c916e3ab3b6561f521cee431c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8325d7bc6f7663fe8c4d12dd12197f4c5d83796cac869cc0f8b3cdbb09d7e1b5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageCircleImage]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageCircleImage]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageCircleImage]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__48d3416c76b4ef40a78675e0b76b369cb34af79bdc2fe4bea2b4eef2f2076c5a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageCircleImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageCircleImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ae513458a0682ccfb019b70d675c31bba1fc9c7bfd3e54bc0b7bc9c5758dd0f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformation")
    def put_transformation(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageCircleImageTransformation()

        return typing.cast(None, jsii.invoke(self, "putTransformation", [value]))

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @jsii.member(jsii_name="resetDiameter")
    def reset_diameter(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDiameter", []))

    @jsii.member(jsii_name="resetDiameterVar")
    def reset_diameter_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDiameterVar", []))

    @jsii.member(jsii_name="resetTransformation")
    def reset_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformation", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="transformation")
    def transformation(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageCircleImageTransformationOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageCircleImageTransformationOutputReference", jsii.get(self, "transformation"))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="diameterInput")
    def diameter_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "diameterInput"))

    @builtins.property
    @jsii.member(jsii_name="diameterVarInput")
    def diameter_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "diameterVarInput"))

    @builtins.property
    @jsii.member(jsii_name="transformationInput")
    def transformation_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageCircleImageTransformation"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageCircleImageTransformation"], jsii.get(self, "transformationInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a5251efbfcb6508deccef34fce113817f2bae2344c99260f3fc47a8b92ff417)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__24c683f4f4d34a86d1031e112f179ae507e720a4f09df965ee927405c86fc5ee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="diameter")
    def diameter(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "diameter"))

    @diameter.setter
    def diameter(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__80544c56365d79d569de507c89240f105c5bbb73a43db47eca11fc6812c39d4f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "diameter", value)

    @builtins.property
    @jsii.member(jsii_name="diameterVar")
    def diameter_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "diameterVar"))

    @diameter_var.setter
    def diameter_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dea13930ed06db0f39fcf8be14d7301046b46909a84e14ddb8a54286d8790d2a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "diameterVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f30f6d62b5ea42c46835a9a2b89aeb2ae05bc52d4f24d50756c9c9976ffd1f3d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e6012e33c73ed05057d15a9326c941bfe335d936c086ecf493bf25f636789ff4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageCircleImage]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageCircleImage]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageCircleImage]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9875670729ad10e24810413e4b424bc6852b140c35bb456e8f61bf7c48c62ee3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageCircleImageTransformation",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageCircleImageTransformation:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageCircleImageTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageCircleImageTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageCircleImageTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a46cf4da1742afc0221384de7e630e30e4dabbb69642a0ac0c0e08a1f705064c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageCircleImageTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageCircleImageTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageCircleImageTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b2f80cd433d428d4fb9e921bd171b248533ca09e1512f94beb367780a841bf9b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__60d45d89df12c43617e058e450e840f77e0e5f12907ab3930f131cfe9af33717)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putBoxImage")
    def put_box_image(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageBoxImage, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__071fa9c15524b31b056e199bd8a5fb8c2ac949ef0777de3b264066c0d5bf102a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBoxImage", [value]))

    @jsii.member(jsii_name="putCircleImage")
    def put_circle_image(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageCircleImage, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__36db84b6dd6cb09b38b87a178b601a53589a59da9934fb40ab5c16e01ebc632b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCircleImage", [value]))

    @jsii.member(jsii_name="putTextImage")
    def put_text_image(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageTextImage", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b7c8b16540f04a02a0137d6a37d385ccd12fbad7fb6084b23036c44826da0f63)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTextImage", [value]))

    @jsii.member(jsii_name="putUrlImage")
    def put_url_image(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageUrlImage", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c1bbacb71ee20dae1ed0b8b4f3fb401631ac67ad43e96d351345c6d28c1986d7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putUrlImage", [value]))

    @jsii.member(jsii_name="resetBoxImage")
    def reset_box_image(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBoxImage", []))

    @jsii.member(jsii_name="resetCircleImage")
    def reset_circle_image(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCircleImage", []))

    @jsii.member(jsii_name="resetTextImage")
    def reset_text_image(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTextImage", []))

    @jsii.member(jsii_name="resetUrlImage")
    def reset_url_image(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUrlImage", []))

    @builtins.property
    @jsii.member(jsii_name="boxImage")
    def box_image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageBoxImageList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageBoxImageList, jsii.get(self, "boxImage"))

    @builtins.property
    @jsii.member(jsii_name="circleImage")
    def circle_image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageCircleImageList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageCircleImageList, jsii.get(self, "circleImage"))

    @builtins.property
    @jsii.member(jsii_name="textImage")
    def text_image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageTextImageList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageTextImageList", jsii.get(self, "textImage"))

    @builtins.property
    @jsii.member(jsii_name="urlImage")
    def url_image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageUrlImageList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageUrlImageList", jsii.get(self, "urlImage"))

    @builtins.property
    @jsii.member(jsii_name="boxImageInput")
    def box_image_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageBoxImage]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageBoxImage]]], jsii.get(self, "boxImageInput"))

    @builtins.property
    @jsii.member(jsii_name="circleImageInput")
    def circle_image_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageCircleImage]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageCircleImage]]], jsii.get(self, "circleImageInput"))

    @builtins.property
    @jsii.member(jsii_name="textImageInput")
    def text_image_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageTextImage"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageTextImage"]]], jsii.get(self, "textImageInput"))

    @builtins.property
    @jsii.member(jsii_name="urlImageInput")
    def url_image_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageUrlImage"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageUrlImage"]]], jsii.get(self, "urlImageInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f2f62d78529b22fb5d413722f94c909b8d9480535088f6ca4738dd5e4ec9d91e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageTextImage",
    jsii_struct_bases=[],
    name_mapping={
        "fill": "fill",
        "fill_var": "fillVar",
        "size": "size",
        "size_var": "sizeVar",
        "stroke": "stroke",
        "stroke_size": "strokeSize",
        "stroke_size_var": "strokeSizeVar",
        "stroke_var": "strokeVar",
        "text": "text",
        "text_var": "textVar",
        "transformation": "transformation",
        "typeface": "typeface",
        "typeface_var": "typefaceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageTextImage:
    def __init__(
        self,
        *,
        fill: typing.Optional[builtins.str] = None,
        fill_var: typing.Optional[builtins.str] = None,
        size: typing.Optional[builtins.str] = None,
        size_var: typing.Optional[builtins.str] = None,
        stroke: typing.Optional[builtins.str] = None,
        stroke_size: typing.Optional[builtins.str] = None,
        stroke_size_var: typing.Optional[builtins.str] = None,
        stroke_var: typing.Optional[builtins.str] = None,
        text: typing.Optional[builtins.str] = None,
        text_var: typing.Optional[builtins.str] = None,
        transformation: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageTextImageTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        typeface: typing.Optional[builtins.str] = None,
        typeface_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fill: The main fill color of the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill DataAkamaiImagingPolicyImage#fill}
        :param fill_var: The main fill color of the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_var DataAkamaiImagingPolicyImage#fill_var}
        :param size: The size in pixels to render the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#size DataAkamaiImagingPolicyImage#size}
        :param size_var: The size in pixels to render the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#size_var DataAkamaiImagingPolicyImage#size_var}
        :param stroke: The color for the outline of the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke DataAkamaiImagingPolicyImage#stroke}
        :param stroke_size: The thickness in points for the outline of the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_size DataAkamaiImagingPolicyImage#stroke_size}
        :param stroke_size_var: The thickness in points for the outline of the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_size_var DataAkamaiImagingPolicyImage#stroke_size_var}
        :param stroke_var: The color for the outline of the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_var DataAkamaiImagingPolicyImage#stroke_var}
        :param text: The line of text to render. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text DataAkamaiImagingPolicyImage#text}
        :param text_var: The line of text to render. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text_var DataAkamaiImagingPolicyImage#text_var}
        :param transformation: transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        :param typeface: The font family to apply to the text image. This may be a URL to a TrueType or WOFF (v1) typeface, or a string that refers to one of the standard built-in browser fonts. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#typeface DataAkamaiImagingPolicyImage#typeface}
        :param typeface_var: The font family to apply to the text image. This may be a URL to a TrueType or WOFF (v1) typeface, or a string that refers to one of the standard built-in browser fonts. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#typeface_var DataAkamaiImagingPolicyImage#typeface_var}
        '''
        if isinstance(transformation, dict):
            transformation = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageTextImageTransformation(**transformation)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f01ca37a5a22041b8ef2d791503498d1245c903f9d315892af719c662e9c3463)
            check_type(argname="argument fill", value=fill, expected_type=type_hints["fill"])
            check_type(argname="argument fill_var", value=fill_var, expected_type=type_hints["fill_var"])
            check_type(argname="argument size", value=size, expected_type=type_hints["size"])
            check_type(argname="argument size_var", value=size_var, expected_type=type_hints["size_var"])
            check_type(argname="argument stroke", value=stroke, expected_type=type_hints["stroke"])
            check_type(argname="argument stroke_size", value=stroke_size, expected_type=type_hints["stroke_size"])
            check_type(argname="argument stroke_size_var", value=stroke_size_var, expected_type=type_hints["stroke_size_var"])
            check_type(argname="argument stroke_var", value=stroke_var, expected_type=type_hints["stroke_var"])
            check_type(argname="argument text", value=text, expected_type=type_hints["text"])
            check_type(argname="argument text_var", value=text_var, expected_type=type_hints["text_var"])
            check_type(argname="argument transformation", value=transformation, expected_type=type_hints["transformation"])
            check_type(argname="argument typeface", value=typeface, expected_type=type_hints["typeface"])
            check_type(argname="argument typeface_var", value=typeface_var, expected_type=type_hints["typeface_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fill is not None:
            self._values["fill"] = fill
        if fill_var is not None:
            self._values["fill_var"] = fill_var
        if size is not None:
            self._values["size"] = size
        if size_var is not None:
            self._values["size_var"] = size_var
        if stroke is not None:
            self._values["stroke"] = stroke
        if stroke_size is not None:
            self._values["stroke_size"] = stroke_size
        if stroke_size_var is not None:
            self._values["stroke_size_var"] = stroke_size_var
        if stroke_var is not None:
            self._values["stroke_var"] = stroke_var
        if text is not None:
            self._values["text"] = text
        if text_var is not None:
            self._values["text_var"] = text_var
        if transformation is not None:
            self._values["transformation"] = transformation
        if typeface is not None:
            self._values["typeface"] = typeface
        if typeface_var is not None:
            self._values["typeface_var"] = typeface_var

    @builtins.property
    def fill(self) -> typing.Optional[builtins.str]:
        '''The main fill color of the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill DataAkamaiImagingPolicyImage#fill}
        '''
        result = self._values.get("fill")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fill_var(self) -> typing.Optional[builtins.str]:
        '''The main fill color of the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_var DataAkamaiImagingPolicyImage#fill_var}
        '''
        result = self._values.get("fill_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def size(self) -> typing.Optional[builtins.str]:
        '''The size in pixels to render the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#size DataAkamaiImagingPolicyImage#size}
        '''
        result = self._values.get("size")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def size_var(self) -> typing.Optional[builtins.str]:
        '''The size in pixels to render the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#size_var DataAkamaiImagingPolicyImage#size_var}
        '''
        result = self._values.get("size_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def stroke(self) -> typing.Optional[builtins.str]:
        '''The color for the outline of the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke DataAkamaiImagingPolicyImage#stroke}
        '''
        result = self._values.get("stroke")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def stroke_size(self) -> typing.Optional[builtins.str]:
        '''The thickness in points for the outline of the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_size DataAkamaiImagingPolicyImage#stroke_size}
        '''
        result = self._values.get("stroke_size")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def stroke_size_var(self) -> typing.Optional[builtins.str]:
        '''The thickness in points for the outline of the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_size_var DataAkamaiImagingPolicyImage#stroke_size_var}
        '''
        result = self._values.get("stroke_size_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def stroke_var(self) -> typing.Optional[builtins.str]:
        '''The color for the outline of the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_var DataAkamaiImagingPolicyImage#stroke_var}
        '''
        result = self._values.get("stroke_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def text(self) -> typing.Optional[builtins.str]:
        '''The line of text to render.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text DataAkamaiImagingPolicyImage#text}
        '''
        result = self._values.get("text")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def text_var(self) -> typing.Optional[builtins.str]:
        '''The line of text to render.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text_var DataAkamaiImagingPolicyImage#text_var}
        '''
        result = self._values.get("text_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def transformation(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageTextImageTransformation"]:
        '''transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        '''
        result = self._values.get("transformation")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageTextImageTransformation"], result)

    @builtins.property
    def typeface(self) -> typing.Optional[builtins.str]:
        '''The font family to apply to the text image.

        This may be a URL to a TrueType or WOFF (v1) typeface, or a string that refers to one of the standard built-in browser fonts.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#typeface DataAkamaiImagingPolicyImage#typeface}
        '''
        result = self._values.get("typeface")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def typeface_var(self) -> typing.Optional[builtins.str]:
        '''The font family to apply to the text image.

        This may be a URL to a TrueType or WOFF (v1) typeface, or a string that refers to one of the standard built-in browser fonts.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#typeface_var DataAkamaiImagingPolicyImage#typeface_var}
        '''
        result = self._values.get("typeface_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageTextImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageTextImageList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageTextImageList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c80fdd72f8bf664c41f55ad90a6112b044245485bd7567b151ae414892336d23)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageTextImageOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9f672ded4bae51ac6b867159bd4431e4e10beae770bcceb7a397105c6712bd4c)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageTextImageOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a66a69c553e09e00422cbe9ddb6556936afa811b408cd2f6edce504ef8880ba7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__504a87915aaff0744ad614425ed3b34e6c27b01cb2e52229a480b0ea6a60b7dd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8b4ec16d71fab8dd7c22ca7417d5336bbab6748f5795de6614a1aac38469afe0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageTextImage]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageTextImage]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageTextImage]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__15cf6e7ad33d6f8a9838cfca2344215a70e1a713b5526fc991fbd90ec117c8cc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageTextImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageTextImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab5af7f9771d14517a878feb6675b8678f4b944f14f112c92d0a15fc08fa0659)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformation")
    def put_transformation(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageTextImageTransformation()

        return typing.cast(None, jsii.invoke(self, "putTransformation", [value]))

    @jsii.member(jsii_name="resetFill")
    def reset_fill(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFill", []))

    @jsii.member(jsii_name="resetFillVar")
    def reset_fill_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFillVar", []))

    @jsii.member(jsii_name="resetSize")
    def reset_size(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSize", []))

    @jsii.member(jsii_name="resetSizeVar")
    def reset_size_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSizeVar", []))

    @jsii.member(jsii_name="resetStroke")
    def reset_stroke(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStroke", []))

    @jsii.member(jsii_name="resetStrokeSize")
    def reset_stroke_size(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStrokeSize", []))

    @jsii.member(jsii_name="resetStrokeSizeVar")
    def reset_stroke_size_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStrokeSizeVar", []))

    @jsii.member(jsii_name="resetStrokeVar")
    def reset_stroke_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStrokeVar", []))

    @jsii.member(jsii_name="resetText")
    def reset_text(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetText", []))

    @jsii.member(jsii_name="resetTextVar")
    def reset_text_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTextVar", []))

    @jsii.member(jsii_name="resetTransformation")
    def reset_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformation", []))

    @jsii.member(jsii_name="resetTypeface")
    def reset_typeface(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeface", []))

    @jsii.member(jsii_name="resetTypefaceVar")
    def reset_typeface_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypefaceVar", []))

    @builtins.property
    @jsii.member(jsii_name="transformation")
    def transformation(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageTextImageTransformationOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageTextImageTransformationOutputReference", jsii.get(self, "transformation"))

    @builtins.property
    @jsii.member(jsii_name="fillInput")
    def fill_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fillInput"))

    @builtins.property
    @jsii.member(jsii_name="fillVarInput")
    def fill_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fillVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sizeInput")
    def size_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sizeInput"))

    @builtins.property
    @jsii.member(jsii_name="sizeVarInput")
    def size_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sizeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="strokeInput")
    def stroke_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "strokeInput"))

    @builtins.property
    @jsii.member(jsii_name="strokeSizeInput")
    def stroke_size_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "strokeSizeInput"))

    @builtins.property
    @jsii.member(jsii_name="strokeSizeVarInput")
    def stroke_size_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "strokeSizeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="strokeVarInput")
    def stroke_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "strokeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="textInput")
    def text_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "textInput"))

    @builtins.property
    @jsii.member(jsii_name="textVarInput")
    def text_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "textVarInput"))

    @builtins.property
    @jsii.member(jsii_name="transformationInput")
    def transformation_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageTextImageTransformation"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageTextImageTransformation"], jsii.get(self, "transformationInput"))

    @builtins.property
    @jsii.member(jsii_name="typefaceInput")
    def typeface_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typefaceInput"))

    @builtins.property
    @jsii.member(jsii_name="typefaceVarInput")
    def typeface_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typefaceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="fill")
    def fill(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fill"))

    @fill.setter
    def fill(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b46d57fcf0c9a7c134d93e4790d0b9bf60216f8ab349baeedc18737e0137c439)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fill", value)

    @builtins.property
    @jsii.member(jsii_name="fillVar")
    def fill_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fillVar"))

    @fill_var.setter
    def fill_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__029c9c899b939b6ecb4bc316aea316500a8c4f150fd0161e91f62136fe8acabe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fillVar", value)

    @builtins.property
    @jsii.member(jsii_name="size")
    def size(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "size"))

    @size.setter
    def size(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2af57b0141d0731bc08ea7614492c8e9b125fb6310f36253c5e34239f0fafc8d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "size", value)

    @builtins.property
    @jsii.member(jsii_name="sizeVar")
    def size_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sizeVar"))

    @size_var.setter
    def size_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4e1cd4e31590ca827ef88199f15cba2599a84972070f575d245686b4717ca9dc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sizeVar", value)

    @builtins.property
    @jsii.member(jsii_name="stroke")
    def stroke(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "stroke"))

    @stroke.setter
    def stroke(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cad3803673576b79f3fc95d15641674108d61149a17d184010f7ea3fcf406bf8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "stroke", value)

    @builtins.property
    @jsii.member(jsii_name="strokeSize")
    def stroke_size(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "strokeSize"))

    @stroke_size.setter
    def stroke_size(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c54759dd52c756727b28e0595a440311bfe74a97e880b566de977683981ddc88)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "strokeSize", value)

    @builtins.property
    @jsii.member(jsii_name="strokeSizeVar")
    def stroke_size_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "strokeSizeVar"))

    @stroke_size_var.setter
    def stroke_size_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2266dd90a062c4af44075cd6786b57d0a4b7df98b6593c3023f7a3f680b631f5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "strokeSizeVar", value)

    @builtins.property
    @jsii.member(jsii_name="strokeVar")
    def stroke_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "strokeVar"))

    @stroke_var.setter
    def stroke_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4e578148830fed57ceaff61b45bd3f1ba30eff64ad8e332f0e4dc64b724ca726)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "strokeVar", value)

    @builtins.property
    @jsii.member(jsii_name="text")
    def text(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "text"))

    @text.setter
    def text(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4c9be7e91098e603584aa7600d79a35554c4ba28ee72656034fcda42927a998c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "text", value)

    @builtins.property
    @jsii.member(jsii_name="textVar")
    def text_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "textVar"))

    @text_var.setter
    def text_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__557b289359aa84b1323f0a8ee729ac852d13c45980433c743a0cfc2ccdeb7a6a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "textVar", value)

    @builtins.property
    @jsii.member(jsii_name="typeface")
    def typeface(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeface"))

    @typeface.setter
    def typeface(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__62d016b40bde964bd96bc77ed5c8959d010fd2792afea54892eaab6ca3370074)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeface", value)

    @builtins.property
    @jsii.member(jsii_name="typefaceVar")
    def typeface_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typefaceVar"))

    @typeface_var.setter
    def typeface_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__12afa1583d103f2b1a4316000a63614ed57ca76c0b41b50442e016099601f5fa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typefaceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageTextImage]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageTextImage]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageTextImage]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ebcbde6640fe56324538fa99d3f8b0ac2f7c8856fbfdee1f08e95986c28e4220)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageTextImageTransformation",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageTextImageTransformation:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageTextImageTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageTextImageTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageTextImageTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__235c527739b21efd868714130809e8ff2baf557a085daad38e398860f8c2ac45)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageTextImageTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageTextImageTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageTextImageTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4f27e71f87826cc923ea18e81aa47b3b1fb96be112f0657651712cbf77a8abbd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageUrlImage",
    jsii_struct_bases=[],
    name_mapping={
        "transformation": "transformation",
        "url": "url",
        "url_var": "urlVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageUrlImage:
    def __init__(
        self,
        *,
        transformation: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageUrlImageTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        url: typing.Optional[builtins.str] = None,
        url_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param transformation: transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        :param url: The URL of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url DataAkamaiImagingPolicyImage#url}
        :param url_var: The URL of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url_var DataAkamaiImagingPolicyImage#url_var}
        '''
        if isinstance(transformation, dict):
            transformation = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageUrlImageTransformation(**transformation)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a9769978930beeedbf67007aef43aa4153ca3e8b04abd518c594ce61a5183756)
            check_type(argname="argument transformation", value=transformation, expected_type=type_hints["transformation"])
            check_type(argname="argument url", value=url, expected_type=type_hints["url"])
            check_type(argname="argument url_var", value=url_var, expected_type=type_hints["url_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if transformation is not None:
            self._values["transformation"] = transformation
        if url is not None:
            self._values["url"] = url
        if url_var is not None:
            self._values["url_var"] = url_var

    @builtins.property
    def transformation(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageUrlImageTransformation"]:
        '''transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        '''
        result = self._values.get("transformation")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageUrlImageTransformation"], result)

    @builtins.property
    def url(self) -> typing.Optional[builtins.str]:
        '''The URL of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url DataAkamaiImagingPolicyImage#url}
        '''
        result = self._values.get("url")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def url_var(self) -> typing.Optional[builtins.str]:
        '''The URL of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url_var DataAkamaiImagingPolicyImage#url_var}
        '''
        result = self._values.get("url_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageUrlImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageUrlImageList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageUrlImageList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f83307111528300b987e6ebd8ca3a0f2c53c030564816fc8385d544a07449534)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageUrlImageOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9b8fcf0cb50ca2bffdec6676f5d84e22e7e7791ee440ffe496dd27f1380035d1)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageUrlImageOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1b76004b5d88c26b87c9eb0144f12f0e1cc4bf29240eeef3b598923e5dce0040)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aa2c18f7248fce7d2eaa8213abfb629b3087ecb40fad5df824d126c6c8e0e104)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__170066cf96d1d67b37adb80bd2740781c3028d7285e6be3f2529ac045b8dde49)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageUrlImage]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageUrlImage]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageUrlImage]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b262765be3a213b0d57da83d3ba2b9af5351bf2c151b74a6181eb4660c94ac08)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageUrlImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageUrlImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__75efe32452bdb651d15a6f2c9554f6991ec67425475ce1cdc94a153f6ff77054)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformation")
    def put_transformation(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageUrlImageTransformation()

        return typing.cast(None, jsii.invoke(self, "putTransformation", [value]))

    @jsii.member(jsii_name="resetTransformation")
    def reset_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformation", []))

    @jsii.member(jsii_name="resetUrl")
    def reset_url(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUrl", []))

    @jsii.member(jsii_name="resetUrlVar")
    def reset_url_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUrlVar", []))

    @builtins.property
    @jsii.member(jsii_name="transformation")
    def transformation(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageUrlImageTransformationOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageUrlImageTransformationOutputReference", jsii.get(self, "transformation"))

    @builtins.property
    @jsii.member(jsii_name="transformationInput")
    def transformation_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageUrlImageTransformation"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageUrlImageTransformation"], jsii.get(self, "transformationInput"))

    @builtins.property
    @jsii.member(jsii_name="urlInput")
    def url_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "urlInput"))

    @builtins.property
    @jsii.member(jsii_name="urlVarInput")
    def url_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "urlVarInput"))

    @builtins.property
    @jsii.member(jsii_name="url")
    def url(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "url"))

    @url.setter
    def url(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8bc6a558dda757a7b63c296c0813befa7c1394c37d65fbd09e37380fb0d03bf7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "url", value)

    @builtins.property
    @jsii.member(jsii_name="urlVar")
    def url_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "urlVar"))

    @url_var.setter
    def url_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__06de89ebc466e6b83cdd3662822973b33e563424f875ecabc47df97cd478a71f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "urlVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageUrlImage]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageUrlImage]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageUrlImage]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7098ba7f09e5ecdb04ceba449eb4bad75cc3391e10c1817c0b89ae13af97eeca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageUrlImageTransformation",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageUrlImageTransformation:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageUrlImageTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageUrlImageTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageUrlImageTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0e53dcca1e71e0c6c4ef6af10c375ccc88e7fd60d919e1860174e68bd05109ee)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageUrlImageTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageUrlImageTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageUrlImageTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b4bd9a5b83d738868f4aa259c3e1483fa4fb180b02c1c55da05b6a14cf2989dd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__109e3bf4530653fd3675aa3e3084f6921d47cc3cdf7deb7a1f2008234f9a4023)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9791fb08416c8a4921ba652a3a248e7b48d85f7151e0033d40b0d83497c80163)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f9bccea7418d5c8ef34e7ca79cf52b755abc0702eea42dfdc6f144134dd24ead)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__093fdb26ca553279f2eec5f9cf5f1a04fdbee473f49508e6622f6d8686539c95)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b592bb600adb77293687a628c8e41e2b365e4bee62bb1c30428e575395312fcf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualComposite]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualComposite]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f34cd5eda130ca33a7bc2ef9ca656895fe41693bc7595f26898eb2f47452df60)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__79cc26cd94e73ba508fdd507a060413bde73f6adcfd5607ea4b3e6f5b410e9ea)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(
        self,
        *,
        box_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageBoxImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
        circle_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageCircleImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
        text_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageTextImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
        url_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageUrlImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param box_image: box_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#box_image DataAkamaiImagingPolicyImage#box_image}
        :param circle_image: circle_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#circle_image DataAkamaiImagingPolicyImage#circle_image}
        :param text_image: text_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text_image DataAkamaiImagingPolicyImage#text_image}
        :param url_image: url_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url_image DataAkamaiImagingPolicyImage#url_image}
        '''
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImage(
            box_image=box_image,
            circle_image=circle_image,
            text_image=text_image,
            url_image=url_image,
        )

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPlacement")
    def reset_placement(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacement", []))

    @jsii.member(jsii_name="resetPlacementVar")
    def reset_placement_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacementVar", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetScaleDimension")
    def reset_scale_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimension", []))

    @jsii.member(jsii_name="resetScaleDimensionVar")
    def reset_scale_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimensionVar", []))

    @jsii.member(jsii_name="resetScaleVar")
    def reset_scale_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="placementInput")
    def placement_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementInput"))

    @builtins.property
    @jsii.member(jsii_name="placementVarInput")
    def placement_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionInput")
    def scale_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVarInput")
    def scale_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleVarInput")
    def scale_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0533521b6ea2491b48731fd2ab693431e6389d13222f3a35c32c4c6ba49fa993)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5a72c4669c3e78e58bb96eb84043b678d88f8c3832cd427c6e276dc52357818e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="placement")
    def placement(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placement"))

    @placement.setter
    def placement(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__96bb21a5fc1ed065faf545f02b7146d084d3478e59e812674713ab886f90db56)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placement", value)

    @builtins.property
    @jsii.member(jsii_name="placementVar")
    def placement_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placementVar"))

    @placement_var.setter
    def placement_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__575a0558dfc64b29f1a3ad33fea5816db25536e2ddd75e348f8b6fffcc155aff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placementVar", value)

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scale"))

    @scale.setter
    def scale(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d1b18e868bb5279b4c6d26f0a0e0f6ccaf91ccc7238848f91af4fe9c3b063dd7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scale", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimension")
    def scale_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimension"))

    @scale_dimension.setter
    def scale_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ef8c6419d89cbbb6fab9de1c4fa7a55a897c08969ecc70b08e635049613398e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimension", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVar")
    def scale_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimensionVar"))

    @scale_dimension_var.setter
    def scale_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c1f4488fb6e59e780c380dd3931e9ca0c631075584b894c86780125ec7676dbc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="scaleVar")
    def scale_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleVar"))

    @scale_var.setter
    def scale_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__675248d285b1343160ea2a0284fc087bbb7fe04f446fa639e5ca44a6ba2b8a37)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9cd8ee64008794fb08b4e0ed0b3658da40ce81f2df335f2dc1b58000dd08f57e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a2cd8477daff79a5f0b9e10a4b24093b622bbdecaad62b5435ef26a7614b4f8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3580a92b8f13296a7e42e5c1587cc192a7ace6e85bd79f48503d217de72cd5ac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b842a4d06369076c7534cb176e3418f5c6ba48d38732f80c614de7e6591f1dd5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualComposite]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualComposite]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualComposite]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__71610df9ac3231e589bf4f091818f0bf2b97091377ed301462f2cf07cf752926)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompound",
    jsii_struct_bases=[],
    name_mapping={"transformations": "transformations"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompound:
    def __init__(
        self,
        *,
        transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param transformations: transformations block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__97e3d72057bf96f867443755a3b5f1a634d12c49cfe7ebf8754f8aafcab48300)
            check_type(argname="argument transformations", value=transformations, expected_type=type_hints["transformations"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if transformations is not None:
            self._values["transformations"] = transformations

    @builtins.property
    def transformations(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformations"]]]:
        '''transformations block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        result = self._values.get("transformations")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformations"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompound(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eea81651fa064dfac8ccc5934e94004024cfa2439201ceed716bbdbd583c9585)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__13f6614657777a504141414a3182735a9529bfd135c3900a9a714628b7eeb0d2)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7fb792a8f0e7dcb52c02284ace9d9237a3dd15cfab6e0b813736e4d6de92a0f3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__83dd7a1b89e7c527ca6e6ea71ebf42ffba3f019da92c03943ffe3e5a4b6c8a75)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__abaebba85a46033a3271fc3c18647434c734c71274af3ab636c7186b3f809921)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompound]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompound]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a0edcc450d4710f7f0ee6a11cb57f3297489910c5c07d8abd299bd855e452ea6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d096b5b224ea4f4d98a3c619ad53c099c9f97f74854aaba57922e0acacaccebd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformations")
    def put_transformations(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__70a901ec73eac029a61142575b1f9ee54d1dfbcc74885fc282f204c7a7100ff7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTransformations", [value]))

    @jsii.member(jsii_name="resetTransformations")
    def reset_transformations(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformations", []))

    @builtins.property
    @jsii.member(jsii_name="transformations")
    def transformations(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsList", jsii.get(self, "transformations"))

    @builtins.property
    @jsii.member(jsii_name="transformationsInput")
    def transformations_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformations"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformations"]]], jsii.get(self, "transformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompound]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompound]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompound]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e4e757b8698d7d170f8d9d0dd366e6987159a175170153e50b285aee27ec53e7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformations",
    jsii_struct_bases=[],
    name_mapping={
        "background_color": "backgroundColor",
        "blur": "blur",
        "chroma_key": "chromaKey",
        "composite": "composite",
        "compound": "compound",
        "contrast": "contrast",
        "goop": "goop",
        "grayscale": "grayscale",
        "hsl": "hsl",
        "hsv": "hsv",
        "if_dimension": "ifDimension",
        "if_orientation": "ifOrientation",
        "max_colors": "maxColors",
        "mirror": "mirror",
        "mono_hue": "monoHue",
        "opacity": "opacity",
        "remove_color": "removeColor",
        "unsharp_mask": "unsharpMask",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformations:
    def __init__(
        self,
        *,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsBackgroundColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsBlur", typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsChromaKey", typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsComposite", typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsCompound", typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsContrast", typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsGoop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsGrayscale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsHsl", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsHsv", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfDimension", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfOrientation", typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsMaxColors", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsMirror", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsMonoHue", typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsOpacity", typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsRemoveColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsUnsharpMask", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__987bc2f3c291e2c482fcfd26aae1b5b9a4ea246e8e5afcf400aa10689d06ac93)
            check_type(argname="argument background_color", value=background_color, expected_type=type_hints["background_color"])
            check_type(argname="argument blur", value=blur, expected_type=type_hints["blur"])
            check_type(argname="argument chroma_key", value=chroma_key, expected_type=type_hints["chroma_key"])
            check_type(argname="argument composite", value=composite, expected_type=type_hints["composite"])
            check_type(argname="argument compound", value=compound, expected_type=type_hints["compound"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument goop", value=goop, expected_type=type_hints["goop"])
            check_type(argname="argument grayscale", value=grayscale, expected_type=type_hints["grayscale"])
            check_type(argname="argument hsl", value=hsl, expected_type=type_hints["hsl"])
            check_type(argname="argument hsv", value=hsv, expected_type=type_hints["hsv"])
            check_type(argname="argument if_dimension", value=if_dimension, expected_type=type_hints["if_dimension"])
            check_type(argname="argument if_orientation", value=if_orientation, expected_type=type_hints["if_orientation"])
            check_type(argname="argument max_colors", value=max_colors, expected_type=type_hints["max_colors"])
            check_type(argname="argument mirror", value=mirror, expected_type=type_hints["mirror"])
            check_type(argname="argument mono_hue", value=mono_hue, expected_type=type_hints["mono_hue"])
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument remove_color", value=remove_color, expected_type=type_hints["remove_color"])
            check_type(argname="argument unsharp_mask", value=unsharp_mask, expected_type=type_hints["unsharp_mask"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if background_color is not None:
            self._values["background_color"] = background_color
        if blur is not None:
            self._values["blur"] = blur
        if chroma_key is not None:
            self._values["chroma_key"] = chroma_key
        if composite is not None:
            self._values["composite"] = composite
        if compound is not None:
            self._values["compound"] = compound
        if contrast is not None:
            self._values["contrast"] = contrast
        if goop is not None:
            self._values["goop"] = goop
        if grayscale is not None:
            self._values["grayscale"] = grayscale
        if hsl is not None:
            self._values["hsl"] = hsl
        if hsv is not None:
            self._values["hsv"] = hsv
        if if_dimension is not None:
            self._values["if_dimension"] = if_dimension
        if if_orientation is not None:
            self._values["if_orientation"] = if_orientation
        if max_colors is not None:
            self._values["max_colors"] = max_colors
        if mirror is not None:
            self._values["mirror"] = mirror
        if mono_hue is not None:
            self._values["mono_hue"] = mono_hue
        if opacity is not None:
            self._values["opacity"] = opacity
        if remove_color is not None:
            self._values["remove_color"] = remove_color
        if unsharp_mask is not None:
            self._values["unsharp_mask"] = unsharp_mask

    @builtins.property
    def background_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsBackgroundColor"]]]:
        '''background_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        '''
        result = self._values.get("background_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsBackgroundColor"]]], result)

    @builtins.property
    def blur(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsBlur"]]]:
        '''blur block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        '''
        result = self._values.get("blur")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsBlur"]]], result)

    @builtins.property
    def chroma_key(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsChromaKey"]]]:
        '''chroma_key block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        '''
        result = self._values.get("chroma_key")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsChromaKey"]]], result)

    @builtins.property
    def composite(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsComposite"]]]:
        '''composite block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        '''
        result = self._values.get("composite")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsComposite"]]], result)

    @builtins.property
    def compound(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsCompound"]]]:
        '''compound block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        '''
        result = self._values.get("compound")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsCompound"]]], result)

    @builtins.property
    def contrast(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsContrast"]]]:
        '''contrast block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsContrast"]]], result)

    @builtins.property
    def goop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsGoop"]]]:
        '''goop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        '''
        result = self._values.get("goop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsGoop"]]], result)

    @builtins.property
    def grayscale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsGrayscale"]]]:
        '''grayscale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        '''
        result = self._values.get("grayscale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsGrayscale"]]], result)

    @builtins.property
    def hsl(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsHsl"]]]:
        '''hsl block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        '''
        result = self._values.get("hsl")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsHsl"]]], result)

    @builtins.property
    def hsv(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsHsv"]]]:
        '''hsv block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        '''
        result = self._values.get("hsv")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsHsv"]]], result)

    @builtins.property
    def if_dimension(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfDimension"]]]:
        '''if_dimension block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        '''
        result = self._values.get("if_dimension")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfDimension"]]], result)

    @builtins.property
    def if_orientation(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfOrientation"]]]:
        '''if_orientation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        '''
        result = self._values.get("if_orientation")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfOrientation"]]], result)

    @builtins.property
    def max_colors(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsMaxColors"]]]:
        '''max_colors block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        '''
        result = self._values.get("max_colors")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsMaxColors"]]], result)

    @builtins.property
    def mirror(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsMirror"]]]:
        '''mirror block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        '''
        result = self._values.get("mirror")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsMirror"]]], result)

    @builtins.property
    def mono_hue(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsMonoHue"]]]:
        '''mono_hue block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        '''
        result = self._values.get("mono_hue")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsMonoHue"]]], result)

    @builtins.property
    def opacity(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsOpacity"]]]:
        '''opacity block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsOpacity"]]], result)

    @builtins.property
    def remove_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsRemoveColor"]]]:
        '''remove_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        '''
        result = self._values.get("remove_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsRemoveColor"]]], result)

    @builtins.property
    def unsharp_mask(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsUnsharpMask"]]]:
        '''unsharp_mask block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        result = self._values.get("unsharp_mask")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsUnsharpMask"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformations(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsBackgroundColor",
    jsii_struct_bases=[],
    name_mapping={"color": "color", "color_var": "colorVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsBackgroundColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7db6881eb8ac64d546893dd5be1d55d156d86566ee61da05533637f3820d8f04)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsBackgroundColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsBackgroundColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsBackgroundColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__82fbd4dabc8cdbc4e499d3a37f3783a0b267578863c3f2597ab2f83b6b84cd9c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsBackgroundColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__35202eccbb4e37440f9aa39d5b52a407a44ec5eddf9336ac7a82440e8439148c)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsBackgroundColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a2e847657c14088359e0e06d595d724f931e9dd007f522fc745e33dcb5805bdc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f2463dac6fb005c2c3d68543c99b5a3b5a943951a288ffc2f28ec55fb8ef82c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aa30bd0fc189145a9fb96f610f8c3d559a342c61455dc21dd7cb2ba189c9825a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsBackgroundColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsBackgroundColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c279636d28ad10e819a90049dd07dc00cb8adbb5e11105c38170c00828c9d738)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsBackgroundColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsBackgroundColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ce08513d8abfe9ab39c6570f19d6a1319be35ab9dcd812aed706c1cf317b1cd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__87fc77b87350b5467ff59699e3b7d9c100210577fb3b1254f753440be81336c4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a09ed28e4a5075a707e19a9a3fa1f04a35a8de04d76de9fff5a16c9cee1075c5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsBackgroundColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsBackgroundColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsBackgroundColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f722ebef4abe012d5803ef52cdd1e4614ce38f18fc5ea01276ae415caa2aee3a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsBlur",
    jsii_struct_bases=[],
    name_mapping={"sigma": "sigma", "sigma_var": "sigmaVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsBlur:
    def __init__(
        self,
        *,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param sigma: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fe9e7b2f63a4083022859db76a4440a631d12fef85bc2bd9ac69bc20eebd5f15)
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsBlur(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsBlurList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsBlurList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__170701698556e4fa78a6f8d72f95ed0d9489205a092c1e6ba2c557f8f2689c62)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsBlurOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7ee0026b02f911f65d72a0eb88119021bc40eb30203ff77e3becfe8ed87d6611)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsBlurOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f166b9dfdc6f420b13445d9b1912d63bb5bdf8717cb53fdc505bd95889cc32b7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__42e0044c191ab493a9a1800df8fc0816221c56e683395d20befab595472736c0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0220d0cbb2a7ddcfd6380d12bbefcb70031f52f7d6c41b2e6191a33947400a87)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsBlur]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsBlur]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e93f2486e14cf32f259c5d9884ffc0471d8475b81101e48e4b3eebfd76b9f4f8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsBlurOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsBlurOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a4e6d5085a0eaafd6dd88f1deedb465add08fdd2cefec351a3836b9c31351297)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__46ce96ab527826a871b9d4d099fcd2ada72a967c4b03ee9f181bd07310bc04dc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__40c5337f9a212b352d852bfc70af77e153934a6197c232f75b07481fb5eef60c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsBlur]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsBlur]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsBlur]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__94edba580e78403ec384f3c9d0f0a766dcf2704bc1c8f1470249b601b88ac537)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsChromaKey",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_feather": "hueFeather",
        "hue_feather_var": "hueFeatherVar",
        "hue_tolerance": "hueTolerance",
        "hue_tolerance_var": "hueToleranceVar",
        "hue_var": "hueVar",
        "lightness_feather": "lightnessFeather",
        "lightness_feather_var": "lightnessFeatherVar",
        "lightness_tolerance": "lightnessTolerance",
        "lightness_tolerance_var": "lightnessToleranceVar",
        "saturation_feather": "saturationFeather",
        "saturation_feather_var": "saturationFeatherVar",
        "saturation_tolerance": "saturationTolerance",
        "saturation_tolerance_var": "saturationToleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsChromaKey:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_feather: typing.Optional[builtins.str] = None,
        hue_feather_var: typing.Optional[builtins.str] = None,
        hue_tolerance: typing.Optional[builtins.str] = None,
        hue_tolerance_var: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness_feather: typing.Optional[builtins.str] = None,
        lightness_feather_var: typing.Optional[builtins.str] = None,
        lightness_tolerance: typing.Optional[builtins.str] = None,
        lightness_tolerance_var: typing.Optional[builtins.str] = None,
        saturation_feather: typing.Optional[builtins.str] = None,
        saturation_feather_var: typing.Optional[builtins.str] = None,
        saturation_tolerance: typing.Optional[builtins.str] = None,
        saturation_tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_feather: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        :param hue_feather_var: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        :param hue_tolerance: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        :param hue_tolerance_var: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        :param hue_var: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness_feather: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        :param lightness_feather_var: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        :param lightness_tolerance: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        :param lightness_tolerance_var: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        :param saturation_feather: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        :param saturation_feather_var: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        :param saturation_tolerance: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        :param saturation_tolerance_var: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7ca72e6398d4738980bb9d49b1dda2b3b78d5b5eb3f3e9431d2e11cd6c2dcf12)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_feather", value=hue_feather, expected_type=type_hints["hue_feather"])
            check_type(argname="argument hue_feather_var", value=hue_feather_var, expected_type=type_hints["hue_feather_var"])
            check_type(argname="argument hue_tolerance", value=hue_tolerance, expected_type=type_hints["hue_tolerance"])
            check_type(argname="argument hue_tolerance_var", value=hue_tolerance_var, expected_type=type_hints["hue_tolerance_var"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness_feather", value=lightness_feather, expected_type=type_hints["lightness_feather"])
            check_type(argname="argument lightness_feather_var", value=lightness_feather_var, expected_type=type_hints["lightness_feather_var"])
            check_type(argname="argument lightness_tolerance", value=lightness_tolerance, expected_type=type_hints["lightness_tolerance"])
            check_type(argname="argument lightness_tolerance_var", value=lightness_tolerance_var, expected_type=type_hints["lightness_tolerance_var"])
            check_type(argname="argument saturation_feather", value=saturation_feather, expected_type=type_hints["saturation_feather"])
            check_type(argname="argument saturation_feather_var", value=saturation_feather_var, expected_type=type_hints["saturation_feather_var"])
            check_type(argname="argument saturation_tolerance", value=saturation_tolerance, expected_type=type_hints["saturation_tolerance"])
            check_type(argname="argument saturation_tolerance_var", value=saturation_tolerance_var, expected_type=type_hints["saturation_tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_feather is not None:
            self._values["hue_feather"] = hue_feather
        if hue_feather_var is not None:
            self._values["hue_feather_var"] = hue_feather_var
        if hue_tolerance is not None:
            self._values["hue_tolerance"] = hue_tolerance
        if hue_tolerance_var is not None:
            self._values["hue_tolerance_var"] = hue_tolerance_var
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness_feather is not None:
            self._values["lightness_feather"] = lightness_feather
        if lightness_feather_var is not None:
            self._values["lightness_feather_var"] = lightness_feather_var
        if lightness_tolerance is not None:
            self._values["lightness_tolerance"] = lightness_tolerance
        if lightness_tolerance_var is not None:
            self._values["lightness_tolerance_var"] = lightness_tolerance_var
        if saturation_feather is not None:
            self._values["saturation_feather"] = saturation_feather
        if saturation_feather_var is not None:
            self._values["saturation_feather_var"] = saturation_feather_var
        if saturation_tolerance is not None:
            self._values["saturation_tolerance"] = saturation_tolerance
        if saturation_tolerance_var is not None:
            self._values["saturation_tolerance_var"] = saturation_tolerance_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        '''
        result = self._values.get("hue_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        '''
        result = self._values.get("hue_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        '''
        result = self._values.get("hue_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        '''
        result = self._values.get("hue_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        '''
        result = self._values.get("lightness_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        '''
        result = self._values.get("lightness_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        '''
        result = self._values.get("lightness_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        '''
        result = self._values.get("lightness_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        '''
        result = self._values.get("saturation_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        '''
        result = self._values.get("saturation_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        '''
        result = self._values.get("saturation_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        result = self._values.get("saturation_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsChromaKey(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsChromaKeyList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsChromaKeyList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0a05659f2a662b1e748a3b850953d5bfeafe087431908c10a436825b68036246)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsChromaKeyOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__94d27ea3ef776f1e1584059ec4fbc116dac2e0fef382f80d24f115f599e9638c)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsChromaKeyOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dda9cae3ce41c0eeec9e7a9861bd76c5be37220a1c9c8432ab3b5f8c794b4abb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4954b94a79cc2770cb094d7fc79002f9a730714ca983cb3d772e81dc01bb5033)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__560b05ea60b7b1bcdcb8ce918b683807103775349b75510568ee9cb258855730)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsChromaKey]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsChromaKey]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c921bbafc301f72cd0ccfb3e38dc5df2a2958bf99fe10a4d6131647e3c3fce2a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsChromaKeyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsChromaKeyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3f876735323836b1f7e0fde3216d421326606a32581f579d9d00511b1b8ed2b2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueFeather")
    def reset_hue_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeather", []))

    @jsii.member(jsii_name="resetHueFeatherVar")
    def reset_hue_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeatherVar", []))

    @jsii.member(jsii_name="resetHueTolerance")
    def reset_hue_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueTolerance", []))

    @jsii.member(jsii_name="resetHueToleranceVar")
    def reset_hue_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueToleranceVar", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightnessFeather")
    def reset_lightness_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeather", []))

    @jsii.member(jsii_name="resetLightnessFeatherVar")
    def reset_lightness_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeatherVar", []))

    @jsii.member(jsii_name="resetLightnessTolerance")
    def reset_lightness_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessTolerance", []))

    @jsii.member(jsii_name="resetLightnessToleranceVar")
    def reset_lightness_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessToleranceVar", []))

    @jsii.member(jsii_name="resetSaturationFeather")
    def reset_saturation_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeather", []))

    @jsii.member(jsii_name="resetSaturationFeatherVar")
    def reset_saturation_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeatherVar", []))

    @jsii.member(jsii_name="resetSaturationTolerance")
    def reset_saturation_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationTolerance", []))

    @jsii.member(jsii_name="resetSaturationToleranceVar")
    def reset_saturation_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherInput")
    def hue_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVarInput")
    def hue_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceInput")
    def hue_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVarInput")
    def hue_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherInput")
    def lightness_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVarInput")
    def lightness_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceInput")
    def lightness_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVarInput")
    def lightness_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherInput")
    def saturation_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVarInput")
    def saturation_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceInput")
    def saturation_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVarInput")
    def saturation_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1db156c86efc623b43c433801b81f2f4bf98d954282aba905d62326c11ae5468)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeather")
    def hue_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeather"))

    @hue_feather.setter
    def hue_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bce585c7ebd70299be32ac432437618af49165ad5e0066f611f040257af2d71d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeather", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVar")
    def hue_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeatherVar"))

    @hue_feather_var.setter
    def hue_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c21cce08af13b77c2665f927139fb009fadeb81bb6cf24f031546d9e3a62d9c3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueTolerance")
    def hue_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueTolerance"))

    @hue_tolerance.setter
    def hue_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e9f2d21837cb583bb48716fdb76db845d14f1ea2353cabb37bad40a6e32c6524)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVar")
    def hue_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueToleranceVar"))

    @hue_tolerance_var.setter
    def hue_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__72816ef992e7970f1431fd495811137b4c0a361bd4ea4a7141694420c63d6c94)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__29aa222924ce9c09add4330a72000c47c8c78729998979195ce4b576c93e5f53)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeather")
    def lightness_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeather"))

    @lightness_feather.setter
    def lightness_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a22ec423faef02e0c60c77d50bc4179fed910fb409b743b59fba895cfbd8ebe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeather", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVar")
    def lightness_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeatherVar"))

    @lightness_feather_var.setter
    def lightness_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3659efee2ff924d66955125a9c7d65c12f329034a1b594139c51c972a64ea47e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessTolerance")
    def lightness_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessTolerance"))

    @lightness_tolerance.setter
    def lightness_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__95a286a0c6458ff3a5edac0df8141951b6fbb2ed619a917fc8f6e63164139039)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVar")
    def lightness_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessToleranceVar"))

    @lightness_tolerance_var.setter
    def lightness_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9c7ece7a60ffc29061f55a2486ff9e04b786dba496ca843e348b1dffff49a5ff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeather")
    def saturation_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeather"))

    @saturation_feather.setter
    def saturation_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9bfca96d17cf51587be418ad583612a6fe6711aa406f2bdf2d6d10026898f1f5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeather", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVar")
    def saturation_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeatherVar"))

    @saturation_feather_var.setter
    def saturation_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3d7b2012fd09a88a2fb44c1642ac0b03d9dbed4e5600afcbc1214a4228806c47)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationTolerance")
    def saturation_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationTolerance"))

    @saturation_tolerance.setter
    def saturation_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7e5c579faf36190adc14acace3f74cd2b64bce3501ba3d980ecac1152331dff4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVar")
    def saturation_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationToleranceVar"))

    @saturation_tolerance_var.setter
    def saturation_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__93e61c6c0aa3f5dd0613739cc9785b6ef88afb39c611256208b5d08d7ccb86c5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsChromaKey]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsChromaKey]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsChromaKey]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6c85e4d8b02747eaa281949a32c92280b0b5b96f864872d5279396b568034a79)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsComposite",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "placement": "placement",
        "placement_var": "placementVar",
        "scale": "scale",
        "scale_dimension": "scaleDimension",
        "scale_dimension_var": "scaleDimensionVar",
        "scale_var": "scaleVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsComposite:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsCompositeImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        placement: typing.Optional[builtins.str] = None,
        placement_var: typing.Optional[builtins.str] = None,
        scale: typing.Optional[builtins.str] = None,
        scale_dimension: typing.Optional[builtins.str] = None,
        scale_dimension_var: typing.Optional[builtins.str] = None,
        scale_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param placement: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        :param placement_var: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        :param scale: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param scale_dimension: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        :param scale_dimension_var: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        :param scale_var: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        :param x_position: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsCompositeImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7821aedfcdcd5d05f2f36562114cdc8476bd8fdff72598501c1833334c3fef66)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument placement", value=placement, expected_type=type_hints["placement"])
            check_type(argname="argument placement_var", value=placement_var, expected_type=type_hints["placement_var"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument scale_dimension", value=scale_dimension, expected_type=type_hints["scale_dimension"])
            check_type(argname="argument scale_dimension_var", value=scale_dimension_var, expected_type=type_hints["scale_dimension_var"])
            check_type(argname="argument scale_var", value=scale_var, expected_type=type_hints["scale_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if placement is not None:
            self._values["placement"] = placement
        if placement_var is not None:
            self._values["placement_var"] = placement_var
        if scale is not None:
            self._values["scale"] = scale
        if scale_dimension is not None:
            self._values["scale_dimension"] = scale_dimension
        if scale_dimension_var is not None:
            self._values["scale_dimension_var"] = scale_dimension_var
        if scale_var is not None:
            self._values["scale_var"] = scale_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsCompositeImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsCompositeImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        '''
        result = self._values.get("placement")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement_var(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        '''
        result = self._values.get("placement_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        '''
        result = self._values.get("scale_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        '''
        result = self._values.get("scale_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        '''
        result = self._values.get("scale_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsComposite(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsCompositeImage",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsCompositeImage:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsCompositeImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsCompositeImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsCompositeImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f448b81332cafe84a673a69bcd344fcbf445ea8311ac48fbfb9a7f1af3d7d9f7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsCompositeImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsCompositeImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8ed71adb5907093cac10ffbbd85bc58d12a8b1c4a25ee9c81580f881a2573879)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsCompositeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsCompositeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__118459bacbc9170c3dc598ef76d26ce4cf51c5cd403b58ed564c178a12f66e71)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsCompositeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1044f95798dd1872ad6fcd4e335c060d5a86fbdcd26d1eb09fb117d1049c84e9)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsCompositeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e6376af7b71c1342194e675ec9dcc47f4a6c5640b472d8dd8039ff84d215c960)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__31becc3628583eafd9ddc7fbe05b8417d5ac0d68351106e77a9dab6dab5823d6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b3af7aa1441a86d8d3754dede090184ebda3b31e39f4e09d51d06e90086a3cf4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsComposite]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsComposite]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9aabb1e4ddedf966c35e5ee1346fb2c1a6c598d508cb973e979ac84a5c7b8efc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsCompositeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsCompositeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__54a1ee5ff1a67b6395936f567a8d45e641b51e086df2fb34de9e8ebb8ba78f37)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsCompositeImage()

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPlacement")
    def reset_placement(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacement", []))

    @jsii.member(jsii_name="resetPlacementVar")
    def reset_placement_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacementVar", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetScaleDimension")
    def reset_scale_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimension", []))

    @jsii.member(jsii_name="resetScaleDimensionVar")
    def reset_scale_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimensionVar", []))

    @jsii.member(jsii_name="resetScaleVar")
    def reset_scale_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsCompositeImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsCompositeImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsCompositeImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="placementInput")
    def placement_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementInput"))

    @builtins.property
    @jsii.member(jsii_name="placementVarInput")
    def placement_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionInput")
    def scale_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVarInput")
    def scale_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleVarInput")
    def scale_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__781ee2af07805ed7c00523f4c58d90dc3f9591f27725b9ec1978c0dcf1fd9181)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__deb82e2191c5e51f01f50866dc39b141bd4a36652f7bcd034f627fe52362d975)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="placement")
    def placement(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placement"))

    @placement.setter
    def placement(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a5190cd23d46d3253245edada9faebbcba3ead0375c3dc2868f3cedfa9ddfbe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placement", value)

    @builtins.property
    @jsii.member(jsii_name="placementVar")
    def placement_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placementVar"))

    @placement_var.setter
    def placement_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f0eba1d4bdb8b09c2037260377409c735d556bcb4f53a1e0e65adff736f5ed36)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placementVar", value)

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scale"))

    @scale.setter
    def scale(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__22ea793cc4f625e7c68eb811d99a18c15f8838f1735386e66f39283bf91a741f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scale", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimension")
    def scale_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimension"))

    @scale_dimension.setter
    def scale_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0d614f8cbb060bdbee781349c190145fccef71ad8efd56ec579107d3d567eef0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimension", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVar")
    def scale_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimensionVar"))

    @scale_dimension_var.setter
    def scale_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f86c7647a23fbd47a7d1dcf1d133465706b632ecd1e8d78671f9138387391490)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="scaleVar")
    def scale_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleVar"))

    @scale_var.setter
    def scale_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a0a3bad8933aeb789fb7e6333064a65e9cd3f30c1765a6d79eb865782dabefec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8bd2f10c4e4fce65fe8ad9ca04c4509e87ce054a108b56b48fec21aaebca1ad1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be00f2447558ffb0c4144a1eb90db588f47b8c33ae80f262516cb9e10c0107c2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__297ad56194b90330159650983eca922f2bb234795b273d5580a82797bb02fd67)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1eadd4dae33ab409ce8fda76d46dd90d5e17e5802dd0f5659348810069fa247f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsComposite]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsComposite]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsComposite]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bfe666e1d86c64ea0fe70798f00a34fdab1cdd325aa0ec8aeb3c8c1e92c48e6e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsCompound",
    jsii_struct_bases=[],
    name_mapping={"transformations": "transformations"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsCompound:
    def __init__(
        self,
        *,
        transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param transformations: transformations block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1019dc156db9c994fb5dd2d7b8da0e1620b4ea85f8ed7aefea3334864cde1be0)
            check_type(argname="argument transformations", value=transformations, expected_type=type_hints["transformations"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if transformations is not None:
            self._values["transformations"] = transformations

    @builtins.property
    def transformations(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsCompoundTransformations"]]]:
        '''transformations block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        result = self._values.get("transformations")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsCompoundTransformations"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsCompound(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsCompoundList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsCompoundList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__63992b1e98726499030f39c8d28b256bfb87835760d7b2ddd153a829ee9f293d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsCompoundOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa138de3c52a16653dbaa76659a038c74a5ec67adaf7acdb0a5980129f114371)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsCompoundOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__333e12e84b2eab2a463bca3fd13e3cf2ccb981b9f7d5a31f454bd35965b0e660)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__87333d370a9362e0dc6381099940f0cc5918e7adb32ab90e2ac7c89df73e66bd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6511e308af7b1a0c548294d98d17dff245513084b399f3d3a24c57e4c047cf98)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsCompound]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsCompound]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d9d2fc9f294ccb1afcb24d61f69b0b28a599378cc35a78bf38d57a8d5b118f60)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsCompoundOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsCompoundOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c3e58b4e1beeb8888aba67e2d450c7a92d5c0467befc942a5a7fad9580ab0189)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformations")
    def put_transformations(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__460e1de22b7cc8c5b20aead0696fc54a8df0f7f09bba2daf936a061741811520)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTransformations", [value]))

    @jsii.member(jsii_name="resetTransformations")
    def reset_transformations(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformations", []))

    @builtins.property
    @jsii.member(jsii_name="transformations")
    def transformations(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsCompoundTransformationsList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsCompoundTransformationsList", jsii.get(self, "transformations"))

    @builtins.property
    @jsii.member(jsii_name="transformationsInput")
    def transformations_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsCompoundTransformations"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsCompoundTransformations"]]], jsii.get(self, "transformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsCompound]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsCompound]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsCompound]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f866e9a9df9d0fc317032fe9515e41ab7a52baa7b8b78699d2a9e8f92509eec0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsCompoundTransformations",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsCompoundTransformations:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsCompoundTransformations(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsCompoundTransformationsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsCompoundTransformationsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__52e0ecb2609a6508f8013af659dba887a7b34ed641e134b5e689599b91bba6d1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsCompoundTransformationsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cb2caaecd5a4545b4fe40e647dc7ad285a16d01aa174e1308ee1b0c9dc3df4cb)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsCompoundTransformationsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__680657bfe23f6ef904155c49c468bb3fd88ec493c644ee48e22be5e6395cc6b7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a6ae1933c643f161edf86ce8357bbeac20936c2c9fdf7678fd2d4420c709f30)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d8b2e0f5883fd5c56cc4de53455181ec4be4cb8ea32d37489ec1eed05a0e6b13)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsCompoundTransformations]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsCompoundTransformations]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsCompoundTransformations]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__56c719ee90b196901f380b100fd09ccf2ce31e2c68d448a03759c3d38148e02c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsCompoundTransformationsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsCompoundTransformationsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9bd1a7a42ee865bd8c94ead23281a4f6f1a77dde8786a728073d3edf67ebd6c0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsCompoundTransformations]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsCompoundTransformations]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsCompoundTransformations]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bfa0203dd8a801d2415f99d752f02447e9419056982e6f4169cbc65c379a3407)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsContrast",
    jsii_struct_bases=[],
    name_mapping={
        "brightness": "brightness",
        "brightness_var": "brightnessVar",
        "contrast": "contrast",
        "contrast_var": "contrastVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsContrast:
    def __init__(
        self,
        *,
        brightness: typing.Optional[builtins.str] = None,
        brightness_var: typing.Optional[builtins.str] = None,
        contrast: typing.Optional[builtins.str] = None,
        contrast_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param brightness: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        :param brightness_var: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        :param contrast: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param contrast_var: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e8db0c15407d35973b3bb3c19525b4ac87ad519fbcb6605bec6e68b82f88d7ea)
            check_type(argname="argument brightness", value=brightness, expected_type=type_hints["brightness"])
            check_type(argname="argument brightness_var", value=brightness_var, expected_type=type_hints["brightness_var"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument contrast_var", value=contrast_var, expected_type=type_hints["contrast_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if brightness is not None:
            self._values["brightness"] = brightness
        if brightness_var is not None:
            self._values["brightness_var"] = brightness_var
        if contrast is not None:
            self._values["contrast"] = contrast
        if contrast_var is not None:
            self._values["contrast_var"] = contrast_var

    @builtins.property
    def brightness(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        '''
        result = self._values.get("brightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def brightness_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        '''
        result = self._values.get("brightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        result = self._values.get("contrast_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsContrast(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsContrastList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsContrastList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d5f1f7a2eccf77b91350e7a9569125cf2db9c85a6bcc8adfc5669a35d48a348c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsContrastOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4f0179facbf93f1ef61e80af3cd96f7fdb6eb9dd6dd596f7b7e849c2b1a64e0f)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsContrastOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a0a42286642181b5cd983fdd019a77bc7030280551fc834bb2a40ebe97df243d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ee5233552fa2d9ad26486e0c9371b3ca9e4cf6d67872a67ad5882cc20da17519)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b69129db200550bc8b5a6bc0a0159f9730b5d45cc97adefb534571f0b5b40f1d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsContrast]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsContrast]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0be3b4d8dfd3f8dc45e31ce67df204fb8f32d8de9e6664d20d529c8a05e15be4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsContrastOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsContrastOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e00ba0312570f1a2e67ade6b5084e54abbf16a2a7c82b03c207707084bb6805)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetBrightness")
    def reset_brightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightness", []))

    @jsii.member(jsii_name="resetBrightnessVar")
    def reset_brightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightnessVar", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetContrastVar")
    def reset_contrast_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrastVar", []))

    @builtins.property
    @jsii.member(jsii_name="brightnessInput")
    def brightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="brightnessVarInput")
    def brightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastVarInput")
    def contrast_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="brightness")
    def brightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightness"))

    @brightness.setter
    def brightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__252776b33f8e0eeb1468d0eef00a9bf9aa04366d038bc1a8bca39ac599f17acb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightness", value)

    @builtins.property
    @jsii.member(jsii_name="brightnessVar")
    def brightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightnessVar"))

    @brightness_var.setter
    def brightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__19a8e0926dcc36213bff35060ae761b51be6b3ee1c6653e52d996d5ed78d2cf5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrast"))

    @contrast.setter
    def contrast(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__10d03686a77a9e3e14ed6600d03b9ef1cad85862abcbabeb2b128e6b947f46e9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrast", value)

    @builtins.property
    @jsii.member(jsii_name="contrastVar")
    def contrast_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrastVar"))

    @contrast_var.setter
    def contrast_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ef1f25d69cb64e38a0dad90b14e2f46f47507df958a99886124acada01cc18ba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrastVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsContrast]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsContrast]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsContrast]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0825be49c1660c9b9bc779345835727bc0828ad001716aab4339f11d1c4a50e7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsGoop",
    jsii_struct_bases=[],
    name_mapping={
        "chaos": "chaos",
        "chaos_var": "chaosVar",
        "density": "density",
        "density_var": "densityVar",
        "power": "power",
        "power_var": "powerVar",
        "seed": "seed",
        "seed_var": "seedVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsGoop:
    def __init__(
        self,
        *,
        chaos: typing.Optional[builtins.str] = None,
        chaos_var: typing.Optional[builtins.str] = None,
        density: typing.Optional[builtins.str] = None,
        density_var: typing.Optional[builtins.str] = None,
        power: typing.Optional[builtins.str] = None,
        power_var: typing.Optional[builtins.str] = None,
        seed: typing.Optional[builtins.str] = None,
        seed_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param chaos: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        :param chaos_var: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        :param density: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        :param density_var: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        :param power: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        :param power_var: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        :param seed: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        :param seed_var: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__00131cf986edb69eb79ab853989f1dc2a7adbd896c99f76ada569f6e03dc0e29)
            check_type(argname="argument chaos", value=chaos, expected_type=type_hints["chaos"])
            check_type(argname="argument chaos_var", value=chaos_var, expected_type=type_hints["chaos_var"])
            check_type(argname="argument density", value=density, expected_type=type_hints["density"])
            check_type(argname="argument density_var", value=density_var, expected_type=type_hints["density_var"])
            check_type(argname="argument power", value=power, expected_type=type_hints["power"])
            check_type(argname="argument power_var", value=power_var, expected_type=type_hints["power_var"])
            check_type(argname="argument seed", value=seed, expected_type=type_hints["seed"])
            check_type(argname="argument seed_var", value=seed_var, expected_type=type_hints["seed_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if chaos is not None:
            self._values["chaos"] = chaos
        if chaos_var is not None:
            self._values["chaos_var"] = chaos_var
        if density is not None:
            self._values["density"] = density
        if density_var is not None:
            self._values["density_var"] = density_var
        if power is not None:
            self._values["power"] = power
        if power_var is not None:
            self._values["power_var"] = power_var
        if seed is not None:
            self._values["seed"] = seed
        if seed_var is not None:
            self._values["seed_var"] = seed_var

    @builtins.property
    def chaos(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        '''
        result = self._values.get("chaos")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def chaos_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        '''
        result = self._values.get("chaos_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        '''
        result = self._values.get("density")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density_var(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        '''
        result = self._values.get("density_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        '''
        result = self._values.get("power")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power_var(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        '''
        result = self._values.get("power_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        '''
        result = self._values.get("seed")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed_var(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        result = self._values.get("seed_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsGoop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsGoopList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsGoopList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7e5114e4c59eb4ab2cacd67e9180b09b6220fd0be75135be8726e4c81963a412)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsGoopOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aa0fad276415f1f9ccb754a73f4f01cda4eb642c12d34f65291f51d6ede66ab2)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsGoopOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b527d381ff82c3eb5735427f591907fac0478db6f39fa2481056511af2751dd7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__06bf2fd43ae8cdd782549f31180b9039156f648dc67c59df3b5966c705d196c3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5b3615b761db49264e1a339579c8e6417c470397432da376c4a270a005952e7c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsGoop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsGoop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f1bc261803f674d835e5185cbfcff85d0c3248182a5bfc2b0e0236bf0e7ef48d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsGoopOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsGoopOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ff3b194e85144fd7dbde7ca8a374a81427ad914dff846faf0c0b4afd5264cda9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetChaos")
    def reset_chaos(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaos", []))

    @jsii.member(jsii_name="resetChaosVar")
    def reset_chaos_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaosVar", []))

    @jsii.member(jsii_name="resetDensity")
    def reset_density(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensity", []))

    @jsii.member(jsii_name="resetDensityVar")
    def reset_density_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensityVar", []))

    @jsii.member(jsii_name="resetPower")
    def reset_power(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPower", []))

    @jsii.member(jsii_name="resetPowerVar")
    def reset_power_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPowerVar", []))

    @jsii.member(jsii_name="resetSeed")
    def reset_seed(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeed", []))

    @jsii.member(jsii_name="resetSeedVar")
    def reset_seed_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeedVar", []))

    @builtins.property
    @jsii.member(jsii_name="chaosInput")
    def chaos_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosInput"))

    @builtins.property
    @jsii.member(jsii_name="chaosVarInput")
    def chaos_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosVarInput"))

    @builtins.property
    @jsii.member(jsii_name="densityInput")
    def density_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityInput"))

    @builtins.property
    @jsii.member(jsii_name="densityVarInput")
    def density_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="powerInput")
    def power_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerInput"))

    @builtins.property
    @jsii.member(jsii_name="powerVarInput")
    def power_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerVarInput"))

    @builtins.property
    @jsii.member(jsii_name="seedInput")
    def seed_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedInput"))

    @builtins.property
    @jsii.member(jsii_name="seedVarInput")
    def seed_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedVarInput"))

    @builtins.property
    @jsii.member(jsii_name="chaos")
    def chaos(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaos"))

    @chaos.setter
    def chaos(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d04c75b1b48e40042ffe2bd793c96ca25ef5b1e996213ed30ad4467763c146ac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaos", value)

    @builtins.property
    @jsii.member(jsii_name="chaosVar")
    def chaos_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaosVar"))

    @chaos_var.setter
    def chaos_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0dd67e2c0f4c1472929b1db2e6a33aaae274499a39992bcccd17a497bfd00071)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaosVar", value)

    @builtins.property
    @jsii.member(jsii_name="density")
    def density(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "density"))

    @density.setter
    def density(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__60655bc00e27e16fc1fc000a6ab7662f0b518cfaef12c6b4a4e903a6c0447aaf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "density", value)

    @builtins.property
    @jsii.member(jsii_name="densityVar")
    def density_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "densityVar"))

    @density_var.setter
    def density_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c6af758815a8283463126b5c51652fd53131ec7fc9eeaccde37b42798b5f18ad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "densityVar", value)

    @builtins.property
    @jsii.member(jsii_name="power")
    def power(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "power"))

    @power.setter
    def power(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd76aa411b44a406675963e624cd4ffd15aa7b4bec3627e1341f6ed9a4544248)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "power", value)

    @builtins.property
    @jsii.member(jsii_name="powerVar")
    def power_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "powerVar"))

    @power_var.setter
    def power_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__14db1f25dd4c9f52954845eea1a7b0e6ee9796305e3e3a4b10510b53c1b128ab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "powerVar", value)

    @builtins.property
    @jsii.member(jsii_name="seed")
    def seed(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seed"))

    @seed.setter
    def seed(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4cb8cd608a6e227301e4fbdbd2eb96cee92b970c7e15f639333c946203f9650e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seed", value)

    @builtins.property
    @jsii.member(jsii_name="seedVar")
    def seed_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seedVar"))

    @seed_var.setter
    def seed_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ed69aa0d38761ac3e19881e0eaef1c2307941984e6d846737a4a565bcf029091)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seedVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsGoop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsGoop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsGoop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bd8d0310acb25ac6f3eee1fb31f6c76b49b1d71e3d1fb8782682796d87dbe584)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsGrayscale",
    jsii_struct_bases=[],
    name_mapping={"type": "type", "type_var": "typeVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsGrayscale:
    def __init__(
        self,
        *,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param type: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5d81e5b1c72b1a27c27572ede58de1d881883d653a457034b383a7987704a98b)
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsGrayscale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsGrayscaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsGrayscaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__62524147c3e881408f5e76a99b3daa0684e268efb1a0d9085d199db55d87f873)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsGrayscaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5949ba650cda4de42cc398df881e00d05ea8f3c4d63bcf5d726b03862ff9f2f5)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsGrayscaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3e1a846fd1823a81c8d2ec9ffa5a6ce40db115cbb596510785b7474ae73d5034)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2f18ad1385abc6f8aca6150473ff9cc287cfcd6cd2bcd9a6d708799a13162101)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__39e523af21eda7060804c1a8de5651ec0e7898fcc9f6870d0126a80380c15bf3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsGrayscale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsGrayscale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ecd692923d674167c1b646b8f356472494ebb192fafd620dd3005888c64e6b07)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsGrayscaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsGrayscaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__da2d8772b3d3b94cd39dd24cf10cb56a53afec24c99009a903612d3c983cff8e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b4dd3a8afcaf674c96463c61565f0fad2d95a760c6f744c99690e1169ccbb2c2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4f48e5b2bdb80d101677daa1e32eba20c09cc6036c4526748a1ef395a408771b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsGrayscale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsGrayscale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsGrayscale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__afb8d21c92eca08a50cac92dda70aaca9378e08ae4941f8cad318efafd91f3d3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsHsl",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "lightness": "lightness",
        "lightness_var": "lightnessVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsHsl:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness: typing.Optional[builtins.str] = None,
        lightness_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        :param lightness_var: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__425f7f06d84ea759ec272f74a599f7dbbbb120dc387e8a13d235ca9170f8df25)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness", value=lightness, expected_type=type_hints["lightness"])
            check_type(argname="argument lightness_var", value=lightness_var, expected_type=type_hints["lightness_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness is not None:
            self._values["lightness"] = lightness
        if lightness_var is not None:
            self._values["lightness_var"] = lightness_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        '''
        result = self._values.get("lightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        '''
        result = self._values.get("lightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsHsl(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsHslList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsHslList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__38756c72f0a6bc9495e78dd42903ae148d843dcd05ba49e5208ce872c7ed0d45)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsHslOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b840413ef568f9789f45990315584c90ec0de6cf2182b50ab8ee73864a8cb8e1)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsHslOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6cb1de8f0dfaa62fdeabc4b17ca16c94daa3cc94aec7d8292d5a90e990a114b1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a6e112878fd6b17dd17b4dfc317b3c34dc27df49ed02659a91a6d3348c58a06e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f1b63bab0fded52419d05e30817257badf71ecaaaa88de24bd14aae6fdf11ac7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsHsl]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsHsl]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df8590d5615a085ddeadb2bb5bacc1b547352ab2b3665a3993f5cf475f874fc1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsHslOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsHslOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__096fe857dbc914a82f69358564a15323fa0858e2bce8571e33650003902e06ea)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightness")
    def reset_lightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightness", []))

    @jsii.member(jsii_name="resetLightnessVar")
    def reset_lightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessInput")
    def lightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessVarInput")
    def lightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__190fb87a7e372ffcfc01b0621b2f8d1595614c46b86f3107a5f3dffac6e65391)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c57a4c2f7bff5cbd83cbce80a908b86f00e74c9b41016fc75f02e9add81b4d37)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightness")
    def lightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightness"))

    @lightness.setter
    def lightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e3914719aa9b23d37450cb2f90dd3e24f562adeb7009d21df2c08cab9ca942aa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightness", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessVar")
    def lightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessVar"))

    @lightness_var.setter
    def lightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c5b8e5a4bbfaaf356475b92f42cee25fe28e26a5421170b4d4ea39a0f1f08ae8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__40e4b36d9b06ed9d184ba233ffeffd070b3c953676330b555ee0646e167dd788)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9c1eeaab358d7e12dcec8d00fc0ad3836836432794bed4abc6cbaaf72ab473c7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsHsl]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsHsl]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsHsl]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ba55d76dbeb59f4e89aaa87c50153ccc2593bef746e834be9cc88848db0f4c0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsHsv",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsHsv:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        :param value: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cac30ecbe015a8e99dd07791cf55e219144f1ac6fad73795ad452be88d0beeb0)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsHsv(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsHsvList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsHsvList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d72c4c235e11482f9d7409b17c48985c3547dd4bc5cac50a51025bed21189e10)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsHsvOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__acb22d39880b883d3676a96d325b34691a0773857ef2b74df2bd0bb9e45ec6dc)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsHsvOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a21e38d7954c69bd610b55c965ca4a402812a946e7ca2a7cd42d3976acd764d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b749674bcf04dd5c531020c9c0ac0f77ed6ad86c2f83160210dba9165e838442)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b5d4b6be6f983497d59860088e1e7bafeac4d577c0713bd670db4bc9229f50fd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsHsv]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsHsv]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e1d86bcee19bfaa3e7278bd401a37f9364301c10769596abef2c1b588f3e3d5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsHsvOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsHsvOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__03071586d65e37b50a56b92bef81e08ee8b1adb59530bd04037ee19b15474a12)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eca3654aef330db71296a223387c487d6af1e3fc90b5988426845a9598c72697)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ad74173ac37f3a56bcedb255b5ff6a372a5ad0c60af92385144bee845b0cce4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__02210eafd504e2c8fa57017c169bce7d8f568ccf1e406b4dbefd84bcc3c5e6f9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f6b80f4093ad4c7863bc7f85824600846c8528d955441a9ae9db05939f3e3ec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a1d8b71224daf1309489a58a6af288061dd1781f9fe328b55eabc3b4b932a4d2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3771c6b32c9374e6b7e224af617ab105d9f826d8a4100f2c7b04cff98ad31fbe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsHsv]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsHsv]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsHsv]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2e4aadd64e7b38e4ef10903156300a85895559079a695bbf0886b60521a87b44)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfDimension",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "dimension": "dimension",
        "dimension_var": "dimensionVar",
        "equal": "equal",
        "greater_than": "greaterThan",
        "less_than": "lessThan",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfDimension:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfDimensionDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        dimension: typing.Optional[builtins.str] = None,
        dimension_var: typing.Optional[builtins.str] = None,
        equal: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfDimensionEqual", typing.Dict[builtins.str, typing.Any]]] = None,
        greater_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfDimensionGreaterThan", typing.Dict[builtins.str, typing.Any]]] = None,
        less_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfDimensionLessThan", typing.Dict[builtins.str, typing.Any]]] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param dimension: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        :param dimension_var: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        :param equal: equal block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        :param greater_than: greater_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        :param less_than: less_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        :param value: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfDimensionDefault(**default)
        if isinstance(equal, dict):
            equal = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfDimensionEqual(**equal)
        if isinstance(greater_than, dict):
            greater_than = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfDimensionGreaterThan(**greater_than)
        if isinstance(less_than, dict):
            less_than = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfDimensionLessThan(**less_than)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d7821f88c7aca982fef40fa747abc60bcb7e44ec00ed9fe03583914842df25b2)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument dimension", value=dimension, expected_type=type_hints["dimension"])
            check_type(argname="argument dimension_var", value=dimension_var, expected_type=type_hints["dimension_var"])
            check_type(argname="argument equal", value=equal, expected_type=type_hints["equal"])
            check_type(argname="argument greater_than", value=greater_than, expected_type=type_hints["greater_than"])
            check_type(argname="argument less_than", value=less_than, expected_type=type_hints["less_than"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if dimension is not None:
            self._values["dimension"] = dimension
        if dimension_var is not None:
            self._values["dimension_var"] = dimension_var
        if equal is not None:
            self._values["equal"] = equal
        if greater_than is not None:
            self._values["greater_than"] = greater_than
        if less_than is not None:
            self._values["less_than"] = less_than
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfDimensionDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfDimensionDefault"], result)

    @builtins.property
    def dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        '''
        result = self._values.get("dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        '''
        result = self._values.get("dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def equal(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfDimensionEqual"]:
        '''equal block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        '''
        result = self._values.get("equal")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfDimensionEqual"], result)

    @builtins.property
    def greater_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfDimensionGreaterThan"]:
        '''greater_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        '''
        result = self._values.get("greater_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfDimensionGreaterThan"], result)

    @builtins.property
    def less_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfDimensionLessThan"]:
        '''less_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        '''
        result = self._values.get("less_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfDimensionLessThan"], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfDimension(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfDimensionDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfDimensionDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfDimensionDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfDimensionDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfDimensionDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__acf52728ba9aad36d2d29e7959c0fbd9b1bbd8ae1712d39f9b618a25cea249e4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfDimensionDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfDimensionDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__835cec57e34266b21c69dcc07ed136b316a0603d3fe9d32dccfb922f18ff23fb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfDimensionEqual",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfDimensionEqual:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfDimensionEqual(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfDimensionEqualOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfDimensionEqualOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a0cd495800635ef525e4ee4ccd92c78345dd38e2a87c2a0c740d88960591e1f5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfDimensionEqual], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfDimensionEqual],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c3726f2128072b1cc9eddd4c3c742f0c0d851d490ef616fc06f8ce809b6bfba3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfDimensionGreaterThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfDimensionGreaterThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfDimensionGreaterThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfDimensionGreaterThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfDimensionGreaterThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aec5fbee0311985689097c7b5d485a935845df6c2c986a3ab2d9bcb0f343b0c1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfDimensionGreaterThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfDimensionGreaterThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__33359a352134e9d46f12ae71b671f9cf69ef7c0364a02945decb0c1a57bf2d5e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfDimensionLessThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfDimensionLessThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfDimensionLessThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfDimensionLessThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfDimensionLessThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1593f854b0b0360d927aa54ea478e5785e6c36c8c862b2b03265b9c640ba5c78)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfDimensionLessThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfDimensionLessThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ede0de36e51e0806fb2f0fa18731080251210a1be85a796f035a6324f1cb7371)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfDimensionList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfDimensionList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9e746e47a10405faed15664bf0f5cf5ec3027129cbb5b3a7bb39162e33e7ffd6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfDimensionOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3c38bc52ce9483835402adc740d164022672c26174af9ae615d94fad193beb09)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfDimensionOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b1cb05ba534c0b82e23a81b4b67407e979487c0356e7d092279dbf9274eceb81)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0107c95e29a872bb97421b64aa349ccc273a118d915519d0e121166dae1e777c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2fe16c0acc288c4e013ac7d70a603f381e384fda9357512c32518016d3873d3c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfDimension]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfDimension]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bee2d362c3dbb6f55e602e9f528a8cee70c3ec62ce3450c1d45a23ce20686431)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfDimensionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfDimensionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1d5b9a42dcee67e596e5b0a7343ac6e497be7b979c691e61a19f55905ead516e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfDimensionDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putEqual")
    def put_equal(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfDimensionEqual()

        return typing.cast(None, jsii.invoke(self, "putEqual", [value]))

    @jsii.member(jsii_name="putGreaterThan")
    def put_greater_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfDimensionGreaterThan()

        return typing.cast(None, jsii.invoke(self, "putGreaterThan", [value]))

    @jsii.member(jsii_name="putLessThan")
    def put_less_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfDimensionLessThan()

        return typing.cast(None, jsii.invoke(self, "putLessThan", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetDimension")
    def reset_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimension", []))

    @jsii.member(jsii_name="resetDimensionVar")
    def reset_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimensionVar", []))

    @jsii.member(jsii_name="resetEqual")
    def reset_equal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEqual", []))

    @jsii.member(jsii_name="resetGreaterThan")
    def reset_greater_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGreaterThan", []))

    @jsii.member(jsii_name="resetLessThan")
    def reset_less_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLessThan", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfDimensionDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfDimensionDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="equal")
    def equal(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfDimensionEqualOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfDimensionEqualOutputReference, jsii.get(self, "equal"))

    @builtins.property
    @jsii.member(jsii_name="greaterThan")
    def greater_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfDimensionGreaterThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfDimensionGreaterThanOutputReference, jsii.get(self, "greaterThan"))

    @builtins.property
    @jsii.member(jsii_name="lessThan")
    def less_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfDimensionLessThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfDimensionLessThanOutputReference, jsii.get(self, "lessThan"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfDimensionDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionInput")
    def dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionVarInput")
    def dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="equalInput")
    def equal_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfDimensionEqual], jsii.get(self, "equalInput"))

    @builtins.property
    @jsii.member(jsii_name="greaterThanInput")
    def greater_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfDimensionGreaterThan], jsii.get(self, "greaterThanInput"))

    @builtins.property
    @jsii.member(jsii_name="lessThanInput")
    def less_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfDimensionLessThan], jsii.get(self, "lessThanInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="dimension")
    def dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimension"))

    @dimension.setter
    def dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df7ddca21cc9f059cc665834a6c2984de601470485ad04aa0c51a8fb57d18a4b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimension", value)

    @builtins.property
    @jsii.member(jsii_name="dimensionVar")
    def dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimensionVar"))

    @dimension_var.setter
    def dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a8a8b4c6b7eaa3fe687ad7246ea77f8f7ef50de95973cd028ebebb0203f770e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f31f5634040dd5d0305f36622a328a2e80c938681068ddf04e9596e5defb5a6f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__52247c72731c3ad6787acc9b11cb32ce3d70dc1ede0462b69f3e860065946569)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfDimension]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfDimension]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfDimension]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8c806544888a2b44ca6a8d7a13fa55acd7ed4bf368b132267588333fbbdc9d2f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfOrientation",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "landscape": "landscape",
        "portrait": "portrait",
        "square": "square",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfOrientation:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfOrientationDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        landscape: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfOrientationLandscape", typing.Dict[builtins.str, typing.Any]]] = None,
        portrait: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfOrientationPortrait", typing.Dict[builtins.str, typing.Any]]] = None,
        square: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfOrientationSquare", typing.Dict[builtins.str, typing.Any]]] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param landscape: landscape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        :param portrait: portrait block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        :param square: square block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfOrientationDefault(**default)
        if isinstance(landscape, dict):
            landscape = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfOrientationLandscape(**landscape)
        if isinstance(portrait, dict):
            portrait = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfOrientationPortrait(**portrait)
        if isinstance(square, dict):
            square = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfOrientationSquare(**square)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__20fcd4b99c2676e6c728aa70951c36d6caea076e0c3e3c3912826ca71b04b96c)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument landscape", value=landscape, expected_type=type_hints["landscape"])
            check_type(argname="argument portrait", value=portrait, expected_type=type_hints["portrait"])
            check_type(argname="argument square", value=square, expected_type=type_hints["square"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if landscape is not None:
            self._values["landscape"] = landscape
        if portrait is not None:
            self._values["portrait"] = portrait
        if square is not None:
            self._values["square"] = square

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfOrientationDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfOrientationDefault"], result)

    @builtins.property
    def landscape(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfOrientationLandscape"]:
        '''landscape block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        '''
        result = self._values.get("landscape")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfOrientationLandscape"], result)

    @builtins.property
    def portrait(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfOrientationPortrait"]:
        '''portrait block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        '''
        result = self._values.get("portrait")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfOrientationPortrait"], result)

    @builtins.property
    def square(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfOrientationSquare"]:
        '''square block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        result = self._values.get("square")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfOrientationSquare"], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfOrientation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfOrientationDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfOrientationDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfOrientationDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfOrientationDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfOrientationDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ce7a4cbebf60432a3bbc0fe66db5ec8638d6d797c785be956c9af6b67debb65f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfOrientationDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfOrientationDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dabb8071e42f4189e5d3ad32ebbe94ec6b77ffd6b314d2b27580c23203025d3e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfOrientationLandscape",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfOrientationLandscape:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfOrientationLandscape(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfOrientationLandscapeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfOrientationLandscapeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a32464eb1deee501b3255375faf99f53902f6c90e23ce5f43a7c747afdd0e09a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfOrientationLandscape], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfOrientationLandscape],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a01b143c82a53925f19c1ecbed27614ecd954d177f8008c384704f479d6155ef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfOrientationList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfOrientationList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c700eb56989d5cb3d3369219c1324cb0e5c0aac6f9836a9e2e74bf9e7c61d23d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfOrientationOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6ede2a436e33501d1da1db638e7eb19bbdb4e86c0367752886e1d08dae81d00e)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfOrientationOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a87da312e5ea701f4eff866f427c02bec6ebf1338f4fedc465db42373f8f28dc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__001ebc6841167a3ee6fd9b55c8c47d691304ca8a07368d95ffed87e3bf2dd470)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a8c91c69361b04c4520d223c87351c8da3f249c4c577e63ce413d41db0d5460)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfOrientation]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfOrientation]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ec2cbe37989bb40ac5cabea838e7b63eccbe23fea116a98d52024949d4b9812f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfOrientationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfOrientationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2982498db41c51d6eb7162135e63e000c179b4895bb451fcef12c535e7fda776)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfOrientationDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putLandscape")
    def put_landscape(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfOrientationLandscape()

        return typing.cast(None, jsii.invoke(self, "putLandscape", [value]))

    @jsii.member(jsii_name="putPortrait")
    def put_portrait(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfOrientationPortrait()

        return typing.cast(None, jsii.invoke(self, "putPortrait", [value]))

    @jsii.member(jsii_name="putSquare")
    def put_square(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfOrientationSquare()

        return typing.cast(None, jsii.invoke(self, "putSquare", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetLandscape")
    def reset_landscape(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLandscape", []))

    @jsii.member(jsii_name="resetPortrait")
    def reset_portrait(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPortrait", []))

    @jsii.member(jsii_name="resetSquare")
    def reset_square(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSquare", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfOrientationDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfOrientationDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="landscape")
    def landscape(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfOrientationLandscapeOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfOrientationLandscapeOutputReference, jsii.get(self, "landscape"))

    @builtins.property
    @jsii.member(jsii_name="portrait")
    def portrait(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfOrientationPortraitOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfOrientationPortraitOutputReference", jsii.get(self, "portrait"))

    @builtins.property
    @jsii.member(jsii_name="square")
    def square(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfOrientationSquareOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfOrientationSquareOutputReference", jsii.get(self, "square"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfOrientationDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="landscapeInput")
    def landscape_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfOrientationLandscape], jsii.get(self, "landscapeInput"))

    @builtins.property
    @jsii.member(jsii_name="portraitInput")
    def portrait_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfOrientationPortrait"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfOrientationPortrait"], jsii.get(self, "portraitInput"))

    @builtins.property
    @jsii.member(jsii_name="squareInput")
    def square_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfOrientationSquare"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfOrientationSquare"], jsii.get(self, "squareInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfOrientation]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfOrientation]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfOrientation]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7a01064e1e803dfcfbc5985269096fc07b3ca310ecf871a82e79295ebc6df834)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfOrientationPortrait",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfOrientationPortrait:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfOrientationPortrait(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfOrientationPortraitOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfOrientationPortraitOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9f10cb2240cf0f69f1254565adca822abbf73d2637c479974ae0a3f211f1f666)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfOrientationPortrait]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfOrientationPortrait], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfOrientationPortrait],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f54943f8b3a9bd680f7a61ebd85d6ba03f5c7235ce39ef011edfd8c589a12531)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfOrientationSquare",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfOrientationSquare:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfOrientationSquare(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfOrientationSquareOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfOrientationSquareOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a93b9c9a37d02799c1821e133bd76876bd18a68fd2e1ba0485f9e0b3ede1361d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfOrientationSquare]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfOrientationSquare], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfOrientationSquare],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f46d3c28bda6af98d8e5bea1a82f538144394a37610124224eccb15b87645c6d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__01d7572e16a33fbf5bd799c57639d91ca03bf3305406d5dcf260620adb163435)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ccee27e20adcb37217152d1fa893e785de39257e262e3e3d1208675a07b6c5b0)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bfb7fef8a61ae8705f9376c2c8fd45c11841ae9540c809c5931d8f56123db12a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4e97ae02aeb774958995aa63d74813ed6f0e7d66ffaf7a6a4ffdfb13adea5a40)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__475ae1fd3aa5d71887e51acdfbf3810a79b2249732cafacd2f2c3070b0f76675)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformations]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformations]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformations]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__25395ac92aa6af62fefb79c083d1fa4fdfd6b44280d0581f38a08bc4dd48db58)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsMaxColors",
    jsii_struct_bases=[],
    name_mapping={"colors": "colors", "colors_var": "colorsVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsMaxColors:
    def __init__(
        self,
        *,
        colors: typing.Optional[builtins.str] = None,
        colors_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param colors: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        :param colors_var: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__493b7cae163745dc202812e9f63db4b24d816f276e4746918f07c6995fb919d3)
            check_type(argname="argument colors", value=colors, expected_type=type_hints["colors"])
            check_type(argname="argument colors_var", value=colors_var, expected_type=type_hints["colors_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if colors is not None:
            self._values["colors"] = colors
        if colors_var is not None:
            self._values["colors_var"] = colors_var

    @builtins.property
    def colors(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        '''
        result = self._values.get("colors")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def colors_var(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        result = self._values.get("colors_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsMaxColors(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsMaxColorsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsMaxColorsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f7a52892899f0886733cd89a36df0394fba8f57ddcf38414b3aeb37339a05618)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsMaxColorsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a4012bcbef918b73f99672028055687280f57f85375befc23833eeb866db2f2e)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsMaxColorsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4d0df8c26dd2571ea1ea445ba058a27e8c4383e3db2e11c75ca42c3f21b17039)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1633b054046ca77c0d32cb50f7744b2356d88386da4a39eb1304b78f29fdf6fe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2512184edb7eb3b965c49c3d3b07071ca38ef3fd27b0e47b282109020b61656e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsMaxColors]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsMaxColors]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f681687d269907c7b616865053eeea0e7510be317b10f9b085e6d1546dafb38)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsMaxColorsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsMaxColorsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__14b58e1faf78143759abe56c08eef0a5cdc3964aaf231b138f56e6dde85fe3a1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColors")
    def reset_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColors", []))

    @jsii.member(jsii_name="resetColorsVar")
    def reset_colors_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorsVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorsInput")
    def colors_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsInput"))

    @builtins.property
    @jsii.member(jsii_name="colorsVarInput")
    def colors_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsVarInput"))

    @builtins.property
    @jsii.member(jsii_name="colors")
    def colors(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colors"))

    @colors.setter
    def colors(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e28c2be1eb428bcb84c20824591f0f0b9186beb58a8f3052fcbbd967eac69ae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colors", value)

    @builtins.property
    @jsii.member(jsii_name="colorsVar")
    def colors_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorsVar"))

    @colors_var.setter
    def colors_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f79d75dfc32c327fb0453d105536052d88efdfad02896ef6b57dd41f90922e7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorsVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsMaxColors]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsMaxColors]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsMaxColors]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9177aca7c759d4d144c42d793f595db3b060c2f560a3dac0f5ca8ac25f894d4b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsMirror",
    jsii_struct_bases=[],
    name_mapping={
        "horizontal": "horizontal",
        "horizontal_var": "horizontalVar",
        "vertical": "vertical",
        "vertical_var": "verticalVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsMirror:
    def __init__(
        self,
        *,
        horizontal: typing.Optional[builtins.str] = None,
        horizontal_var: typing.Optional[builtins.str] = None,
        vertical: typing.Optional[builtins.str] = None,
        vertical_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param horizontal: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        :param horizontal_var: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        :param vertical: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        :param vertical_var: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b12f5dade0ebbfba059d0f1779593ad8a3da90aa8e8d9a5cd4d78d9375b4fde0)
            check_type(argname="argument horizontal", value=horizontal, expected_type=type_hints["horizontal"])
            check_type(argname="argument horizontal_var", value=horizontal_var, expected_type=type_hints["horizontal_var"])
            check_type(argname="argument vertical", value=vertical, expected_type=type_hints["vertical"])
            check_type(argname="argument vertical_var", value=vertical_var, expected_type=type_hints["vertical_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if horizontal is not None:
            self._values["horizontal"] = horizontal
        if horizontal_var is not None:
            self._values["horizontal_var"] = horizontal_var
        if vertical is not None:
            self._values["vertical"] = vertical
        if vertical_var is not None:
            self._values["vertical_var"] = vertical_var

    @builtins.property
    def horizontal(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        '''
        result = self._values.get("horizontal")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def horizontal_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        '''
        result = self._values.get("horizontal_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        '''
        result = self._values.get("vertical")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        result = self._values.get("vertical_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsMirror(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsMirrorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsMirrorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a5de552f608deb1bce4902fdb3a6f4e34b94a17c7f412e278d791791548002ac)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsMirrorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2c706579156ad1ba8a984e756a22e1cad3729ec264eff1fc116ca48ace78cb0b)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsMirrorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__53f425bc541053e6d02a7ccbbb257505658072e39ad2664df06842b6746f9456)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d9105ec5484043d63f802f0b05c099a0eb27b83c85d20e15af2caebf36048b62)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__27a927d3821ea71ddf5f12b629288530768d4142b28c8ab79601db3eeca30ea2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsMirror]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsMirror]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4092e8bceecbcd14aab9df22d03a1fc2eb8b061dddd5bb1d8a6c0e5bbc1b1925)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsMirrorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsMirrorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1d493bf49b2ed2fbbbac9462e534e4aa53cadeac9a909ef5ebf2029d32e3430a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHorizontal")
    def reset_horizontal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontal", []))

    @jsii.member(jsii_name="resetHorizontalVar")
    def reset_horizontal_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontalVar", []))

    @jsii.member(jsii_name="resetVertical")
    def reset_vertical(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVertical", []))

    @jsii.member(jsii_name="resetVerticalVar")
    def reset_vertical_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVerticalVar", []))

    @builtins.property
    @jsii.member(jsii_name="horizontalInput")
    def horizontal_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontalVarInput")
    def horizontal_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalInput")
    def vertical_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalVarInput")
    def vertical_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontal")
    def horizontal(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontal"))

    @horizontal.setter
    def horizontal(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6c1bcbde8bc0fb49f7d222d5add9d5314fb0da52d5880391f7977597655252a1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontal", value)

    @builtins.property
    @jsii.member(jsii_name="horizontalVar")
    def horizontal_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontalVar"))

    @horizontal_var.setter
    def horizontal_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__99980a4a905554c9a3d053046505ace32f09592256dd6a509febd1b860239099)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontalVar", value)

    @builtins.property
    @jsii.member(jsii_name="vertical")
    def vertical(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "vertical"))

    @vertical.setter
    def vertical(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a810940a7bf9feb0768ee6efde1de8d01adccb467be8632f9e1359e8d9bd537)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "vertical", value)

    @builtins.property
    @jsii.member(jsii_name="verticalVar")
    def vertical_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "verticalVar"))

    @vertical_var.setter
    def vertical_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3c07a648774c1301a8937974570f0c3112b4ae0d75154eee42b742d710cf2f56)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "verticalVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsMirror]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsMirror]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsMirror]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6cdcf6a214354b00b2f27fb02636a38d97a76c9b9f389744aad04cb164da18e8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsMonoHue",
    jsii_struct_bases=[],
    name_mapping={"hue": "hue", "hue_var": "hueVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsMonoHue:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a275c7c8b986ea65694b1f320869cef476a9a0f9bf01484ac494a021d0c497b8)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsMonoHue(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsMonoHueList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsMonoHueList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fe7ac6795d6215075a2bb19c3624d97ed4aabf8a8b58a3e09f48296f5676a95c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsMonoHueOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__64f9960a1a55c4aa04d7482a04bf901513d444a5ad6858306c9baaa6b8c65f7c)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsMonoHueOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bfbdfbaebc195cc3c07e820f8dd434b5cea671213133687d94fe09b403478cbd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6496c3d07dea3a11bedcd478e52ca9b90dbcf92144a9d9e761debe0bf0c3a828)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__68c74bdbfdda1d7df8dbe9cd24709bac1b2de9ce3eed1bd771b585c89762c203)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsMonoHue]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsMonoHue]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6d61aa4d46cba1737b70d9cdb352a157e5f03def6968c1dc4754b411093173cc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsMonoHueOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsMonoHueOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2567a0b4e1470ae02945ea17940c044a762274315d7f030e574a779ddd01d874)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fab0ce9560db5a29d992e3b695cf9218b25095c6af7644824e5d339f310b57d6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__840745aa60605c924e22535812266db1c5ec5b7c06c242a90894c7ed50e96660)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsMonoHue]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsMonoHue]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsMonoHue]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7ebe911627fdc6775c2ded7141763214be6f9dad3d8f84350197219ca0df9887)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsOpacity",
    jsii_struct_bases=[],
    name_mapping={"opacity": "opacity", "opacity_var": "opacityVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsOpacity:
    def __init__(
        self,
        *,
        opacity: typing.Optional[builtins.str] = None,
        opacity_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param opacity: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param opacity_var: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__42d1debdfba935f945ac3a9e7ec4afbb3a20ba9dc800b02f6d22ffefbd8a5436)
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument opacity_var", value=opacity_var, expected_type=type_hints["opacity_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if opacity is not None:
            self._values["opacity"] = opacity
        if opacity_var is not None:
            self._values["opacity_var"] = opacity_var

    @builtins.property
    def opacity(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def opacity_var(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        result = self._values.get("opacity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsOpacity(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsOpacityList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsOpacityList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f544b86bb3e93fa81371cdee6b8747a90c4e67381446bef049bf54d6497ea361)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsOpacityOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d5cfe60c362c0a2940e9f1f913fe53e87e0cd959089155a9e996d9b3127ca12c)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsOpacityOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1dc9c502ca2e87caffca3c045bb7a604557337eea5edc205ddda6996d8f7e74a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9506d714a1e029966ef8624cce90fb1c98e2fbd81bfd98b3ecbe02ca17a72321)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e9088c32a3b3982e98248e1010839a2149ba6dba9783b09266ac2252ef84b888)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsOpacity]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsOpacity]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ecb3ae6c30fd3530da4b4dd84d23819b83bfd199b23e76b3f74c4590616e0f3b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsOpacityOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsOpacityOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a5536736445962b82ccea06a7ab4b00d459dcf00fca852aaa7248684d2ca964)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetOpacityVar")
    def reset_opacity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacityVar", []))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityVarInput")
    def opacity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacity"))

    @opacity.setter
    def opacity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2698076bc326f4636b5c63b984735e3323e04bfd44a39ad6e6cfbbe58f348325)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacity", value)

    @builtins.property
    @jsii.member(jsii_name="opacityVar")
    def opacity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacityVar"))

    @opacity_var.setter
    def opacity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__063fe61e07c33375c39ed3c860df56c0bd237b918dfc3b54882da28b67cd0275)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacityVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsOpacity]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsOpacity]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsOpacity]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bf49e1d57bd2d7c58308e2b9d613be649a9430fb5dcc18954ab4169e396f34ea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__afc18cdfacf98b0ab7f9089367283b41445eecbe2a966c5dc901ac4fddeabe12)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putBackgroundColor")
    def put_background_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__08f91d7caa68f354ee7db8adf736e403b1eff0eef5e1c81d867843defb34b520)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBackgroundColor", [value]))

    @jsii.member(jsii_name="putBlur")
    def put_blur(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsBlur, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f4a1c1bfc148c91512e1bd4bbd2e83b47b93b668b124d79ba627385c090f6ec3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBlur", [value]))

    @jsii.member(jsii_name="putChromaKey")
    def put_chroma_key(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsChromaKey, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__70d3216b184beeaa05009fe5466428565862c62a809ee287c7dc66f1bbbf68f2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putChromaKey", [value]))

    @jsii.member(jsii_name="putComposite")
    def put_composite(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsComposite, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a504f09f39733ecaaf7738260b3d0c45a0fbe9b532249b23798167b5ed88d30)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putComposite", [value]))

    @jsii.member(jsii_name="putCompound")
    def put_compound(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsCompound, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ef4917d2900b86f97af64a60e8241f992c826628ea031540a082224d06329cc5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCompound", [value]))

    @jsii.member(jsii_name="putContrast")
    def put_contrast(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsContrast, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7fc7233a7aee27d29e263483af4d2d9b9b00863e276c699994386f32785a3fa0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putContrast", [value]))

    @jsii.member(jsii_name="putGoop")
    def put_goop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsGoop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ded9febab81a3916605a1c97bca194d429c9d609a6907e6c8748750c2864d71e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGoop", [value]))

    @jsii.member(jsii_name="putGrayscale")
    def put_grayscale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsGrayscale, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__379d38f2660ce07674b36b27b25acc1dad867c63f0698748480aa8f12c66b809)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGrayscale", [value]))

    @jsii.member(jsii_name="putHsl")
    def put_hsl(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsHsl, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9df5897dd2cbab571af503d2e1c57c3bc29f2d62cfceb4e2849c92dcaf626ed7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsl", [value]))

    @jsii.member(jsii_name="putHsv")
    def put_hsv(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsHsv, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__095e12341dfb96ec1f2ffd331e4ab10541de66995f07113b557a6d8e87cef2f5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsv", [value]))

    @jsii.member(jsii_name="putIfDimension")
    def put_if_dimension(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfDimension, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__420483932cbb10a0108e6047b73b8530da3a46c143c81e948b52acb723dee850)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfDimension", [value]))

    @jsii.member(jsii_name="putIfOrientation")
    def put_if_orientation(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__31858cd5e3e1baf7f6d38465636bd8381d30e3b9e1a306e85a87c79e751621c7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfOrientation", [value]))

    @jsii.member(jsii_name="putMaxColors")
    def put_max_colors(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsMaxColors, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7f67221950b8ca3b2d175bbb8ec5a050e6da006e2a5b1be5996f73b90e298a41)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMaxColors", [value]))

    @jsii.member(jsii_name="putMirror")
    def put_mirror(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsMirror, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c818323d123fcc9eb3990c64057f97cf021b7932e168282696309364a9241304)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMirror", [value]))

    @jsii.member(jsii_name="putMonoHue")
    def put_mono_hue(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsMonoHue, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__313f50ae5ddccef436f08afc02d47dca9dd5489bf81e476be2dd776eda1da928)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMonoHue", [value]))

    @jsii.member(jsii_name="putOpacity")
    def put_opacity(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsOpacity, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__10954fd30e6af61c5b613c93ae48f36a66cb4845b0153d171138d8fc79d0f1e4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putOpacity", [value]))

    @jsii.member(jsii_name="putRemoveColor")
    def put_remove_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsRemoveColor", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__56068eb12a135afe7252d47b5a4da50d78d1a95a7b90b0c7719dc030f63d73f6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRemoveColor", [value]))

    @jsii.member(jsii_name="putUnsharpMask")
    def put_unsharp_mask(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsUnsharpMask", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__58b5d548021c65a719ed3493053ee103e9f4c861386beb6ab58ad17372498657)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putUnsharpMask", [value]))

    @jsii.member(jsii_name="resetBackgroundColor")
    def reset_background_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBackgroundColor", []))

    @jsii.member(jsii_name="resetBlur")
    def reset_blur(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBlur", []))

    @jsii.member(jsii_name="resetChromaKey")
    def reset_chroma_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChromaKey", []))

    @jsii.member(jsii_name="resetComposite")
    def reset_composite(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetComposite", []))

    @jsii.member(jsii_name="resetCompound")
    def reset_compound(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCompound", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetGoop")
    def reset_goop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGoop", []))

    @jsii.member(jsii_name="resetGrayscale")
    def reset_grayscale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGrayscale", []))

    @jsii.member(jsii_name="resetHsl")
    def reset_hsl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsl", []))

    @jsii.member(jsii_name="resetHsv")
    def reset_hsv(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsv", []))

    @jsii.member(jsii_name="resetIfDimension")
    def reset_if_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfDimension", []))

    @jsii.member(jsii_name="resetIfOrientation")
    def reset_if_orientation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfOrientation", []))

    @jsii.member(jsii_name="resetMaxColors")
    def reset_max_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxColors", []))

    @jsii.member(jsii_name="resetMirror")
    def reset_mirror(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMirror", []))

    @jsii.member(jsii_name="resetMonoHue")
    def reset_mono_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonoHue", []))

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetRemoveColor")
    def reset_remove_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRemoveColor", []))

    @jsii.member(jsii_name="resetUnsharpMask")
    def reset_unsharp_mask(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUnsharpMask", []))

    @builtins.property
    @jsii.member(jsii_name="backgroundColor")
    def background_color(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsBackgroundColorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsBackgroundColorList, jsii.get(self, "backgroundColor"))

    @builtins.property
    @jsii.member(jsii_name="blur")
    def blur(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsBlurList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsBlurList, jsii.get(self, "blur"))

    @builtins.property
    @jsii.member(jsii_name="chromaKey")
    def chroma_key(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsChromaKeyList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsChromaKeyList, jsii.get(self, "chromaKey"))

    @builtins.property
    @jsii.member(jsii_name="composite")
    def composite(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsCompositeList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsCompositeList, jsii.get(self, "composite"))

    @builtins.property
    @jsii.member(jsii_name="compound")
    def compound(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsCompoundList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsCompoundList, jsii.get(self, "compound"))

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsContrastList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsContrastList, jsii.get(self, "contrast"))

    @builtins.property
    @jsii.member(jsii_name="goop")
    def goop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsGoopList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsGoopList, jsii.get(self, "goop"))

    @builtins.property
    @jsii.member(jsii_name="grayscale")
    def grayscale(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsGrayscaleList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsGrayscaleList, jsii.get(self, "grayscale"))

    @builtins.property
    @jsii.member(jsii_name="hsl")
    def hsl(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsHslList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsHslList, jsii.get(self, "hsl"))

    @builtins.property
    @jsii.member(jsii_name="hsv")
    def hsv(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsHsvList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsHsvList, jsii.get(self, "hsv"))

    @builtins.property
    @jsii.member(jsii_name="ifDimension")
    def if_dimension(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfDimensionList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfDimensionList, jsii.get(self, "ifDimension"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientation")
    def if_orientation(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfOrientationList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfOrientationList, jsii.get(self, "ifOrientation"))

    @builtins.property
    @jsii.member(jsii_name="maxColors")
    def max_colors(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsMaxColorsList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsMaxColorsList, jsii.get(self, "maxColors"))

    @builtins.property
    @jsii.member(jsii_name="mirror")
    def mirror(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsMirrorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsMirrorList, jsii.get(self, "mirror"))

    @builtins.property
    @jsii.member(jsii_name="monoHue")
    def mono_hue(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsMonoHueList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsMonoHueList, jsii.get(self, "monoHue"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsOpacityList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsOpacityList, jsii.get(self, "opacity"))

    @builtins.property
    @jsii.member(jsii_name="removeColor")
    def remove_color(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsRemoveColorList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsRemoveColorList", jsii.get(self, "removeColor"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMask")
    def unsharp_mask(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsUnsharpMaskList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsUnsharpMaskList", jsii.get(self, "unsharpMask"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColorInput")
    def background_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsBackgroundColor]]], jsii.get(self, "backgroundColorInput"))

    @builtins.property
    @jsii.member(jsii_name="blurInput")
    def blur_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsBlur]]], jsii.get(self, "blurInput"))

    @builtins.property
    @jsii.member(jsii_name="chromaKeyInput")
    def chroma_key_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsChromaKey]]], jsii.get(self, "chromaKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="compositeInput")
    def composite_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsComposite]]], jsii.get(self, "compositeInput"))

    @builtins.property
    @jsii.member(jsii_name="compoundInput")
    def compound_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsCompound]]], jsii.get(self, "compoundInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsContrast]]], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="goopInput")
    def goop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsGoop]]], jsii.get(self, "goopInput"))

    @builtins.property
    @jsii.member(jsii_name="grayscaleInput")
    def grayscale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsGrayscale]]], jsii.get(self, "grayscaleInput"))

    @builtins.property
    @jsii.member(jsii_name="hslInput")
    def hsl_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsHsl]]], jsii.get(self, "hslInput"))

    @builtins.property
    @jsii.member(jsii_name="hsvInput")
    def hsv_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsHsv]]], jsii.get(self, "hsvInput"))

    @builtins.property
    @jsii.member(jsii_name="ifDimensionInput")
    def if_dimension_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfDimension]]], jsii.get(self, "ifDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientationInput")
    def if_orientation_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfOrientation]]], jsii.get(self, "ifOrientationInput"))

    @builtins.property
    @jsii.member(jsii_name="maxColorsInput")
    def max_colors_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsMaxColors]]], jsii.get(self, "maxColorsInput"))

    @builtins.property
    @jsii.member(jsii_name="mirrorInput")
    def mirror_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsMirror]]], jsii.get(self, "mirrorInput"))

    @builtins.property
    @jsii.member(jsii_name="monoHueInput")
    def mono_hue_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsMonoHue]]], jsii.get(self, "monoHueInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsOpacity]]], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="removeColorInput")
    def remove_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsRemoveColor"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsRemoveColor"]]], jsii.get(self, "removeColorInput"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMaskInput")
    def unsharp_mask_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsUnsharpMask"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsUnsharpMask"]]], jsii.get(self, "unsharpMaskInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformations]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformations]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformations]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__378a1556098a3064cca954a0dfd37bae63954315a2527b8311ee319959b72fe1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsRemoveColor",
    jsii_struct_bases=[],
    name_mapping={
        "color": "color",
        "color_var": "colorVar",
        "feather": "feather",
        "feather_var": "featherVar",
        "tolerance": "tolerance",
        "tolerance_var": "toleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsRemoveColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
        feather: typing.Optional[builtins.str] = None,
        feather_var: typing.Optional[builtins.str] = None,
        tolerance: typing.Optional[builtins.str] = None,
        tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        :param feather: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        :param feather_var: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        :param tolerance: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        :param tolerance_var: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bf89b0a8e674253ac3ea2056953c55430fd01edc72167b23835553a63c678784)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
            check_type(argname="argument feather", value=feather, expected_type=type_hints["feather"])
            check_type(argname="argument feather_var", value=feather_var, expected_type=type_hints["feather_var"])
            check_type(argname="argument tolerance", value=tolerance, expected_type=type_hints["tolerance"])
            check_type(argname="argument tolerance_var", value=tolerance_var, expected_type=type_hints["tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var
        if feather is not None:
            self._values["feather"] = feather
        if feather_var is not None:
            self._values["feather_var"] = feather_var
        if tolerance is not None:
            self._values["tolerance"] = tolerance
        if tolerance_var is not None:
            self._values["tolerance_var"] = tolerance_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        '''
        result = self._values.get("feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather_var(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        '''
        result = self._values.get("feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        '''
        result = self._values.get("tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance_var(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        result = self._values.get("tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsRemoveColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsRemoveColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsRemoveColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9f1382ff1e7abf124461a7291140255618badef7276ed8ba4958bc742abe80bd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsRemoveColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3b60827175b0ef8381dd4bf992355e39b239441bc77bb4425ab515b6c2cf7c13)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsRemoveColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6ebacb6a8682105bbb499a7ef0635e4bd4f012a39ace267796b1a1cfc3f9ac2a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__43f48311e64ba7f9fa16cf810c579e164d2d3c3abccec29bf12355cb70971517)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f9286921f9020d3c41a4c3f2927263cbb35ee25b37797c98e11fd0d7af53172)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsRemoveColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsRemoveColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsRemoveColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__02890a6205df5521ceb7306516c1ded801d21c50338cfe8b2d27a1aaebf13667)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsRemoveColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsRemoveColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__74df4ed6d57976dbaf65f4b07e71c2afd25d65a5605961e13ddfea8c4089925c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @jsii.member(jsii_name="resetFeather")
    def reset_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeather", []))

    @jsii.member(jsii_name="resetFeatherVar")
    def reset_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatherVar", []))

    @jsii.member(jsii_name="resetTolerance")
    def reset_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTolerance", []))

    @jsii.member(jsii_name="resetToleranceVar")
    def reset_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featherInput")
    def feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherInput"))

    @builtins.property
    @jsii.member(jsii_name="featherVarInput")
    def feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceInput")
    def tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceVarInput")
    def tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f66cdc1acc2d812dea8610c000d07791ba6f0869e5d8966536d4fa825a523041)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e1c423a799b48ff93e365ec5ff4644cfee196d25dbaab8fe4826ca35cfe643f9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="feather")
    def feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "feather"))

    @feather.setter
    def feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f8bdd93270a99e763b4e81b12322bcc2f640cd0e16fdc873f4c7b3e153726809)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "feather", value)

    @builtins.property
    @jsii.member(jsii_name="featherVar")
    def feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featherVar"))

    @feather_var.setter
    def feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9aec51dc52a61aedeff6e24044d33df40fa4eb47d65cacbd18366809674b0f16)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featherVar", value)

    @builtins.property
    @jsii.member(jsii_name="tolerance")
    def tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tolerance"))

    @tolerance.setter
    def tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dc52961c1fdf95234368ef2b0cf1c6db0ef5ebd679001b2a86bf270a1b981244)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tolerance", value)

    @builtins.property
    @jsii.member(jsii_name="toleranceVar")
    def tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "toleranceVar"))

    @tolerance_var.setter
    def tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7b20a323e1138b9c19b4f9bb0a2207e68baf28988e207eaf44f56809e6770ef2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "toleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsRemoveColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsRemoveColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsRemoveColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__32b1c7a72aa066e1db097ca20a1e2f290837c111a5c91275457f7dc46533cdf5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsUnsharpMask",
    jsii_struct_bases=[],
    name_mapping={
        "gain": "gain",
        "gain_var": "gainVar",
        "sigma": "sigma",
        "sigma_var": "sigmaVar",
        "threshold": "threshold",
        "threshold_var": "thresholdVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsUnsharpMask:
    def __init__(
        self,
        *,
        gain: typing.Optional[builtins.str] = None,
        gain_var: typing.Optional[builtins.str] = None,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
        threshold: typing.Optional[builtins.str] = None,
        threshold_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param gain: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        :param gain_var: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        :param sigma: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        :param threshold: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        :param threshold_var: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b2ad61e9bd9023dc4d81c57fad707c75c082a93350c9bd84ea40808572b125f5)
            check_type(argname="argument gain", value=gain, expected_type=type_hints["gain"])
            check_type(argname="argument gain_var", value=gain_var, expected_type=type_hints["gain_var"])
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
            check_type(argname="argument threshold", value=threshold, expected_type=type_hints["threshold"])
            check_type(argname="argument threshold_var", value=threshold_var, expected_type=type_hints["threshold_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if gain is not None:
            self._values["gain"] = gain
        if gain_var is not None:
            self._values["gain_var"] = gain_var
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var
        if threshold is not None:
            self._values["threshold"] = threshold
        if threshold_var is not None:
            self._values["threshold_var"] = threshold_var

    @builtins.property
    def gain(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        '''
        result = self._values.get("gain")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gain_var(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        '''
        result = self._values.get("gain_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        '''
        result = self._values.get("threshold")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold_var(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        result = self._values.get("threshold_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsUnsharpMask(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsUnsharpMaskList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsUnsharpMaskList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3e4a204843d5d55e4cc53693f5eb17968819bd48aa78d490e00387eb8354d24f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsUnsharpMaskOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__72dab8cbd38282cfe7379a565f51640c58449762908be8472d6990a4a8e591e9)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsUnsharpMaskOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea4660ec8e7705cc375370fcbcf19b8d64481049ea1e39d976010de7707eb069)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7182be4aa918ff85688116d3043298b994cf04ab544a4b731cea0e31fc710f67)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3903d634418129a22c8d39b3ed54bf91d222928461eb644785a4087f1d9463a1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsUnsharpMask]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsUnsharpMask]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsUnsharpMask]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ed68cc54a76dd8ca67d0b8ae6516c39750f2ad8176f540501f26182d5fc44c15)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsUnsharpMaskOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsUnsharpMaskOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df3e9616826229c00535effdad59fd2e95e0cda1440ef7ed1d504e393a7ed43a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetGain")
    def reset_gain(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGain", []))

    @jsii.member(jsii_name="resetGainVar")
    def reset_gain_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGainVar", []))

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @jsii.member(jsii_name="resetThreshold")
    def reset_threshold(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThreshold", []))

    @jsii.member(jsii_name="resetThresholdVar")
    def reset_threshold_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThresholdVar", []))

    @builtins.property
    @jsii.member(jsii_name="gainInput")
    def gain_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainInput"))

    @builtins.property
    @jsii.member(jsii_name="gainVarInput")
    def gain_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdInput")
    def threshold_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdVarInput")
    def threshold_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gain")
    def gain(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gain"))

    @gain.setter
    def gain(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fae9dc50d6d3b7528f3848703e8f5850612d2013acf0368928f806f82b18326a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gain", value)

    @builtins.property
    @jsii.member(jsii_name="gainVar")
    def gain_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gainVar"))

    @gain_var.setter
    def gain_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c9736d78596b36108a52f332d5f8fd313b7eefca144efb5b7f06fccd2ba5b0dd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gainVar", value)

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d48f8d85ee0b1ac7d67f8a6b4c74f4e970c27ae13af238599646637705c0344e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__251583761778c79f225b59d9b9ae324a76cb3f0aad4d139ab4528970030a6524)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="threshold")
    def threshold(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "threshold"))

    @threshold.setter
    def threshold(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__64ed6d584e499f7ef3cfa202c493ee8eb03215f2515cab967192ef6ac9063f70)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "threshold", value)

    @builtins.property
    @jsii.member(jsii_name="thresholdVar")
    def threshold_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "thresholdVar"))

    @threshold_var.setter
    def threshold_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f0870783f4f7be530c1ebf76365d6ef8db1b040ed4516aa4ad51bf93f76b06ae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "thresholdVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsUnsharpMask]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsUnsharpMask]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsUnsharpMask]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ef256f672e85edbdedc1a06485168b2e23c378d66df841ddf032bc348fcda73)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualContrast",
    jsii_struct_bases=[],
    name_mapping={
        "brightness": "brightness",
        "brightness_var": "brightnessVar",
        "contrast": "contrast",
        "contrast_var": "contrastVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualContrast:
    def __init__(
        self,
        *,
        brightness: typing.Optional[builtins.str] = None,
        brightness_var: typing.Optional[builtins.str] = None,
        contrast: typing.Optional[builtins.str] = None,
        contrast_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param brightness: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        :param brightness_var: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        :param contrast: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param contrast_var: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6cd5c580f7a7caf4633a35dd6291c175730260333831c601178a2cc71ba0789d)
            check_type(argname="argument brightness", value=brightness, expected_type=type_hints["brightness"])
            check_type(argname="argument brightness_var", value=brightness_var, expected_type=type_hints["brightness_var"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument contrast_var", value=contrast_var, expected_type=type_hints["contrast_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if brightness is not None:
            self._values["brightness"] = brightness
        if brightness_var is not None:
            self._values["brightness_var"] = brightness_var
        if contrast is not None:
            self._values["contrast"] = contrast
        if contrast_var is not None:
            self._values["contrast_var"] = contrast_var

    @builtins.property
    def brightness(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        '''
        result = self._values.get("brightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def brightness_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        '''
        result = self._values.get("brightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        result = self._values.get("contrast_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualContrast(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualContrastList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualContrastList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b035ab80d700868b711e20d700abf69bc6ad5b679496523d8c856e19ce82cbf4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualContrastOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__582f4c90e1a2e7bcef7c67aedd076287ee999ab0bb2a5dede2506666c1f0644e)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualContrastOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1e13969439eabdccb5a5a6bae6caced4d2f72243f3b95174eab87db8cd3dca01)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc9cbf32c86546ab89b746603d6c6ad6f96ccf44824202a141028f70e33c943c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__80a8d08271dba7a1cb6995d9c5f63db18bc98ae469ee6a64642437a167e94d33)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualContrast]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualContrast]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e313f71aea2858d9544852d61b79c872fe2ee30e6194f9843df253caa5b6f435)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualContrastOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualContrastOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7c26428b60888ffd356c588ccae33cc4352a752d2865645fbf7b054d29e3afba)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetBrightness")
    def reset_brightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightness", []))

    @jsii.member(jsii_name="resetBrightnessVar")
    def reset_brightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightnessVar", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetContrastVar")
    def reset_contrast_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrastVar", []))

    @builtins.property
    @jsii.member(jsii_name="brightnessInput")
    def brightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="brightnessVarInput")
    def brightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastVarInput")
    def contrast_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="brightness")
    def brightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightness"))

    @brightness.setter
    def brightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9912efae50ed2767c67ec22311b2b30f522db74cf16cf85280590402e63fb311)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightness", value)

    @builtins.property
    @jsii.member(jsii_name="brightnessVar")
    def brightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightnessVar"))

    @brightness_var.setter
    def brightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4716d9b6e112c3e014aa5da90c9d8208f48b3086e0c938cc58975ac8e3e4105d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrast"))

    @contrast.setter
    def contrast(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cb75f345ba4c65ae9e5a7d1dd9d71c4a4148af175cb7bebf0416531d6b15ef68)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrast", value)

    @builtins.property
    @jsii.member(jsii_name="contrastVar")
    def contrast_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrastVar"))

    @contrast_var.setter
    def contrast_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__195ba1db7f27ba0c3ea8c14d01a103ad984e27d7af1a6d25a57b074f8fd70167)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrastVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualContrast]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualContrast]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualContrast]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__45cb52f784d1eb83d24299930cac5f8e8567c94f10de51126f409b1527a40292)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualGoop",
    jsii_struct_bases=[],
    name_mapping={
        "chaos": "chaos",
        "chaos_var": "chaosVar",
        "density": "density",
        "density_var": "densityVar",
        "power": "power",
        "power_var": "powerVar",
        "seed": "seed",
        "seed_var": "seedVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualGoop:
    def __init__(
        self,
        *,
        chaos: typing.Optional[builtins.str] = None,
        chaos_var: typing.Optional[builtins.str] = None,
        density: typing.Optional[builtins.str] = None,
        density_var: typing.Optional[builtins.str] = None,
        power: typing.Optional[builtins.str] = None,
        power_var: typing.Optional[builtins.str] = None,
        seed: typing.Optional[builtins.str] = None,
        seed_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param chaos: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        :param chaos_var: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        :param density: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        :param density_var: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        :param power: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        :param power_var: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        :param seed: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        :param seed_var: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__439c4f4b1231e38450b885b358e21db30f15dad31c60a2993ab03c16f5edab95)
            check_type(argname="argument chaos", value=chaos, expected_type=type_hints["chaos"])
            check_type(argname="argument chaos_var", value=chaos_var, expected_type=type_hints["chaos_var"])
            check_type(argname="argument density", value=density, expected_type=type_hints["density"])
            check_type(argname="argument density_var", value=density_var, expected_type=type_hints["density_var"])
            check_type(argname="argument power", value=power, expected_type=type_hints["power"])
            check_type(argname="argument power_var", value=power_var, expected_type=type_hints["power_var"])
            check_type(argname="argument seed", value=seed, expected_type=type_hints["seed"])
            check_type(argname="argument seed_var", value=seed_var, expected_type=type_hints["seed_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if chaos is not None:
            self._values["chaos"] = chaos
        if chaos_var is not None:
            self._values["chaos_var"] = chaos_var
        if density is not None:
            self._values["density"] = density
        if density_var is not None:
            self._values["density_var"] = density_var
        if power is not None:
            self._values["power"] = power
        if power_var is not None:
            self._values["power_var"] = power_var
        if seed is not None:
            self._values["seed"] = seed
        if seed_var is not None:
            self._values["seed_var"] = seed_var

    @builtins.property
    def chaos(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        '''
        result = self._values.get("chaos")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def chaos_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        '''
        result = self._values.get("chaos_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        '''
        result = self._values.get("density")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density_var(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        '''
        result = self._values.get("density_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        '''
        result = self._values.get("power")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power_var(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        '''
        result = self._values.get("power_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        '''
        result = self._values.get("seed")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed_var(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        result = self._values.get("seed_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualGoop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualGoopList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualGoopList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__99583062faa7e020ea3f278812d8ee2909cce99394202ea5dfbd04c6308c3854)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualGoopOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6db1104e09877dc127891928b206c53456bac7e5c2bd9e0342e3e596e66f5eea)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualGoopOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1935af1e2049941d61c750a51e86d4e99980c93accc5feb2335515d86dd089d0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ce2d569ffb6aaef62087c9f43fbfe87d76e8f3ccba22e9fa50c5d48a98cbae6b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8db6872132c2357861449795b63d16e00a0b92049d254cbc8a44a2b5b52bc243)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualGoop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualGoop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__60942224887e643291e4666ca6634eaae0479876d0e12a8daadf2eace4dc1bcf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualGoopOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualGoopOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__95ad32367d7ecc67858b6fd4b0208a57ec972e87c4eb9a50e5a4fa11329a74af)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetChaos")
    def reset_chaos(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaos", []))

    @jsii.member(jsii_name="resetChaosVar")
    def reset_chaos_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaosVar", []))

    @jsii.member(jsii_name="resetDensity")
    def reset_density(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensity", []))

    @jsii.member(jsii_name="resetDensityVar")
    def reset_density_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensityVar", []))

    @jsii.member(jsii_name="resetPower")
    def reset_power(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPower", []))

    @jsii.member(jsii_name="resetPowerVar")
    def reset_power_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPowerVar", []))

    @jsii.member(jsii_name="resetSeed")
    def reset_seed(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeed", []))

    @jsii.member(jsii_name="resetSeedVar")
    def reset_seed_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeedVar", []))

    @builtins.property
    @jsii.member(jsii_name="chaosInput")
    def chaos_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosInput"))

    @builtins.property
    @jsii.member(jsii_name="chaosVarInput")
    def chaos_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosVarInput"))

    @builtins.property
    @jsii.member(jsii_name="densityInput")
    def density_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityInput"))

    @builtins.property
    @jsii.member(jsii_name="densityVarInput")
    def density_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="powerInput")
    def power_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerInput"))

    @builtins.property
    @jsii.member(jsii_name="powerVarInput")
    def power_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerVarInput"))

    @builtins.property
    @jsii.member(jsii_name="seedInput")
    def seed_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedInput"))

    @builtins.property
    @jsii.member(jsii_name="seedVarInput")
    def seed_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedVarInput"))

    @builtins.property
    @jsii.member(jsii_name="chaos")
    def chaos(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaos"))

    @chaos.setter
    def chaos(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1ce5a9be24f004a7b9b7d1c1499c01a09b949a80d6f5ca9377fa1f9fbab97ef0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaos", value)

    @builtins.property
    @jsii.member(jsii_name="chaosVar")
    def chaos_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaosVar"))

    @chaos_var.setter
    def chaos_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9780ce8b9dea09ecb629b704ebd458abdcd886d48065f99ae8b4a8be087be39f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaosVar", value)

    @builtins.property
    @jsii.member(jsii_name="density")
    def density(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "density"))

    @density.setter
    def density(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a659142be5a7070eb83943caf98d736d7340b3ef67928c2eea61dc02b3d44dff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "density", value)

    @builtins.property
    @jsii.member(jsii_name="densityVar")
    def density_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "densityVar"))

    @density_var.setter
    def density_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__38c5533a562ed5689b4347daf7dc832df3f5ef06ee40cf122093052188b3caa0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "densityVar", value)

    @builtins.property
    @jsii.member(jsii_name="power")
    def power(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "power"))

    @power.setter
    def power(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e718cbd30a28496c45b4fc8fe3237d0c9247fbdf105346002f9e3ffd7a0264a5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "power", value)

    @builtins.property
    @jsii.member(jsii_name="powerVar")
    def power_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "powerVar"))

    @power_var.setter
    def power_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c64433594c959b7a44fa8f337c3f0a37cf68d084346ae694df6005f046c0ef33)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "powerVar", value)

    @builtins.property
    @jsii.member(jsii_name="seed")
    def seed(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seed"))

    @seed.setter
    def seed(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7ebe3e9d7d81c1c2359cd8fa15507936af8a71fcaf1a11d65ab573a5dc4305e8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seed", value)

    @builtins.property
    @jsii.member(jsii_name="seedVar")
    def seed_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seedVar"))

    @seed_var.setter
    def seed_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__03beb5034a38468367c3959d0f9668ca000f36ea2a159d1cab9b4708718849e6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seedVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualGoop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualGoop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualGoop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cb5a96a37033fd01ab10755717fc7c038f4c97592b75f5e52a6f1a5fe7e8bb59)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualGrayscale",
    jsii_struct_bases=[],
    name_mapping={"type": "type", "type_var": "typeVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualGrayscale:
    def __init__(
        self,
        *,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param type: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__324262d7021c5123d38f1725c0fdfdea4f2228f7929a819b63934f1168c848ad)
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualGrayscale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualGrayscaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualGrayscaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6d9a44697c05bad1835000f6133b3ebfc07d4fec98139d0745850c81bbcaa1ff)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualGrayscaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__60a7661277d5aedd8ecc00ea8ee3d1977afd347982d7959d88281c9a1fbeef22)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualGrayscaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1b51538d08ee06aa4c46912759695d5e7d6e990080e8ebf46297ca94144e697e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab38946d145fe36f31809dcec3fbb254b2c26f9e8a4513442049111f43a41044)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__10edea145bac6599b90b50d3b86be2128d47113fc37ab0c3d14eb8c28dcf411d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualGrayscale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualGrayscale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__30cfc50ad0eaf07f21047258ee6e459b84797e0ba8e2ebe572255eb8f88c84ff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualGrayscaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualGrayscaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__923fcc0c586138a9b3bd6800922380fb09955c93644246e8c2ab4ff38419e04d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ffa553feb75f232251765be8e38e9fb248402b949d83420155869bc87fdb922d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__36e6a7cc462b40f82eb5db51e9bba346febfc4d6673f38afd78357f5ab0c2044)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualGrayscale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualGrayscale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualGrayscale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7c915ec43c867442d1288228b1444bb1fdd0a121659b821d74e8a68b7007a544)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualHsl",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "lightness": "lightness",
        "lightness_var": "lightnessVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualHsl:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness: typing.Optional[builtins.str] = None,
        lightness_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        :param lightness_var: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__823468e353429a3697ea3f972625df4fc021580f57ee9f84e8d761e0bf077909)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness", value=lightness, expected_type=type_hints["lightness"])
            check_type(argname="argument lightness_var", value=lightness_var, expected_type=type_hints["lightness_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness is not None:
            self._values["lightness"] = lightness
        if lightness_var is not None:
            self._values["lightness_var"] = lightness_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        '''
        result = self._values.get("lightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        '''
        result = self._values.get("lightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualHsl(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualHslList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualHslList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d20d79fa2f27f0c21f31ef78dec6085e308ff52c2f6035046cd6a2c77db06de0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualHslOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__89722187701ec858146dbb0ce75cfcf8e860ad900c00dec533707d10f3d06f1e)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualHslOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__55208d261f42a95fc6d84f2b3194f453efe50251fb9fa9879041ee8a8ed46f5a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c08d40194be40ea04fe7a8759b0aa79fc018fe8c9e1e6c0f7d2af76011e62d48)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__064724c2064bacd462ff4b6b956927f1c62f30c21a011d2a3e44bf3be9d525b6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualHsl]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualHsl]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f697761a4fae315b69385a64021b312f233986b43d717b0a04ae6d0d86bf9f4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualHslOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualHslOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__deb29819dc7055d5fcaba3a3966886551e87ec2a92a437b75020d66986132376)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightness")
    def reset_lightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightness", []))

    @jsii.member(jsii_name="resetLightnessVar")
    def reset_lightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessInput")
    def lightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessVarInput")
    def lightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4926e206a92c564977f0e312eb08fa2ca9ce1cb2b3fc832e621dfb2bc155b59d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__53f89f27f608a19946a2eb072734d3de19fe27f4916f6f4cfa3ecd12253fcc81)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightness")
    def lightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightness"))

    @lightness.setter
    def lightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__375d2ee90cf051337276ef98bcb45df5c1440e1666d8d7e26a56f38c047f1609)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightness", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessVar")
    def lightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessVar"))

    @lightness_var.setter
    def lightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5e5b65cf3dcf545d453b333146647b18f40c5cd89ab7fe87fa55a5cb99865843)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__20523ce08f80ffff9c7c59d2008844eed719f372e1b06658897f59058a650ba8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aab9247fe90d8b08104df62a9d4509c004f628df4967ed1a370c5774248e0ed8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualHsl]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualHsl]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualHsl]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2e46e2c1418634d3a5267bd1552a0196411d453926f177a9e5854c48e1b1e984)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualHsv",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualHsv:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        :param value: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f86a7011036e5a698eaf31611cd8d65a91f6cfee79056d6607b1ebc1305ed46)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualHsv(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualHsvList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualHsvList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f0b4e27657eac63f75f3363201ce8c09f8fa26a37dd8b9b9f39541f26f14470c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualHsvOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__296c626aee867079429c211cc51c407c3914b59d7b4bb70e1a5d4d1861a9f40a)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualHsvOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc7856371d07fe24b479e9f21efa7d608c724b1bf86c10a4cb4e709703e57803)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__689ada7c54e5e6f1d145bb37aef83bbb2cfe55095be1b0ad5cf20958f3d4d846)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__23467b8b39166d1cbe4ffb822f9a95cdb437bd9f9809c6ff5a5d37056660b989)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualHsv]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualHsv]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dcb89eb28532642ef4c91508599a28bbc7380253cd01968422f17f0e2c052db9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualHsvOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualHsvOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5b45813c59a295d78747021f59ae0566b110e2449af1ed66a168b969ed7a0da5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8fd93112764375b84e6105f57ffa67c3e1f3ef620fd49fb062883f4041545bc1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__faabdacb971f382f032809e40da0f65e20a82690075836e9dff723b6f76b7a0d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__99193a0af7dad8de31e4421655e7ed3127a394c1c2e7aa86aba082de64f44eb4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a21cbd4499462a4294f3d458bf5a413b7fd35dded9626632f497b983a71e9e81)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__52431585d2faba9fa0e3fb7c3afb63e7b81ffc550f8766440a5514e18d00c81c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__da8c6249367290e35e4fd31da35a5798947715949f42ddc5008aea0d1fb84314)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualHsv]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualHsv]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualHsv]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__981f45275a7f75d3226e8f71dfff11f1b4c42cb419381ae67a63b5ffcb2a41df)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientation",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "landscape": "landscape",
        "portrait": "portrait",
        "square": "square",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientation:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        landscape: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscape", typing.Dict[builtins.str, typing.Any]]] = None,
        portrait: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortrait", typing.Dict[builtins.str, typing.Any]]] = None,
        square: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquare", typing.Dict[builtins.str, typing.Any]]] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param landscape: landscape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        :param portrait: portrait block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        :param square: square block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefault(**default)
        if isinstance(landscape, dict):
            landscape = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscape(**landscape)
        if isinstance(portrait, dict):
            portrait = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortrait(**portrait)
        if isinstance(square, dict):
            square = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquare(**square)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4c74e94849e459e53b622ab27c9e115f04c03f84f649fbe2a7ba8ec750059da1)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument landscape", value=landscape, expected_type=type_hints["landscape"])
            check_type(argname="argument portrait", value=portrait, expected_type=type_hints["portrait"])
            check_type(argname="argument square", value=square, expected_type=type_hints["square"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if landscape is not None:
            self._values["landscape"] = landscape
        if portrait is not None:
            self._values["portrait"] = portrait
        if square is not None:
            self._values["square"] = square

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefault"], result)

    @builtins.property
    def landscape(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscape"]:
        '''landscape block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        '''
        result = self._values.get("landscape")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscape"], result)

    @builtins.property
    def portrait(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortrait"]:
        '''portrait block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        '''
        result = self._values.get("portrait")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortrait"], result)

    @builtins.property
    def square(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquare"]:
        '''square block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        result = self._values.get("square")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquare"], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefault",
    jsii_struct_bases=[],
    name_mapping={
        "background_color": "backgroundColor",
        "blur": "blur",
        "chroma_key": "chromaKey",
        "composite": "composite",
        "compound": "compound",
        "contrast": "contrast",
        "goop": "goop",
        "grayscale": "grayscale",
        "hsl": "hsl",
        "hsv": "hsv",
        "if_dimension": "ifDimension",
        "if_orientation": "ifOrientation",
        "max_colors": "maxColors",
        "mirror": "mirror",
        "mono_hue": "monoHue",
        "opacity": "opacity",
        "remove_color": "removeColor",
        "unsharp_mask": "unsharpMask",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefault:
    def __init__(
        self,
        *,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultBackgroundColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultBlur", typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultChromaKey", typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultComposite", typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultCompound", typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultContrast", typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultGoop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultGrayscale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultHsl", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultHsv", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfDimension", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfOrientation", typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultMaxColors", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultMirror", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultMonoHue", typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultOpacity", typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultRemoveColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultUnsharpMask", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8c6dfb1abcebd993f0d48a9d60154456708478d1790798ccce26a64035c6daeb)
            check_type(argname="argument background_color", value=background_color, expected_type=type_hints["background_color"])
            check_type(argname="argument blur", value=blur, expected_type=type_hints["blur"])
            check_type(argname="argument chroma_key", value=chroma_key, expected_type=type_hints["chroma_key"])
            check_type(argname="argument composite", value=composite, expected_type=type_hints["composite"])
            check_type(argname="argument compound", value=compound, expected_type=type_hints["compound"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument goop", value=goop, expected_type=type_hints["goop"])
            check_type(argname="argument grayscale", value=grayscale, expected_type=type_hints["grayscale"])
            check_type(argname="argument hsl", value=hsl, expected_type=type_hints["hsl"])
            check_type(argname="argument hsv", value=hsv, expected_type=type_hints["hsv"])
            check_type(argname="argument if_dimension", value=if_dimension, expected_type=type_hints["if_dimension"])
            check_type(argname="argument if_orientation", value=if_orientation, expected_type=type_hints["if_orientation"])
            check_type(argname="argument max_colors", value=max_colors, expected_type=type_hints["max_colors"])
            check_type(argname="argument mirror", value=mirror, expected_type=type_hints["mirror"])
            check_type(argname="argument mono_hue", value=mono_hue, expected_type=type_hints["mono_hue"])
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument remove_color", value=remove_color, expected_type=type_hints["remove_color"])
            check_type(argname="argument unsharp_mask", value=unsharp_mask, expected_type=type_hints["unsharp_mask"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if background_color is not None:
            self._values["background_color"] = background_color
        if blur is not None:
            self._values["blur"] = blur
        if chroma_key is not None:
            self._values["chroma_key"] = chroma_key
        if composite is not None:
            self._values["composite"] = composite
        if compound is not None:
            self._values["compound"] = compound
        if contrast is not None:
            self._values["contrast"] = contrast
        if goop is not None:
            self._values["goop"] = goop
        if grayscale is not None:
            self._values["grayscale"] = grayscale
        if hsl is not None:
            self._values["hsl"] = hsl
        if hsv is not None:
            self._values["hsv"] = hsv
        if if_dimension is not None:
            self._values["if_dimension"] = if_dimension
        if if_orientation is not None:
            self._values["if_orientation"] = if_orientation
        if max_colors is not None:
            self._values["max_colors"] = max_colors
        if mirror is not None:
            self._values["mirror"] = mirror
        if mono_hue is not None:
            self._values["mono_hue"] = mono_hue
        if opacity is not None:
            self._values["opacity"] = opacity
        if remove_color is not None:
            self._values["remove_color"] = remove_color
        if unsharp_mask is not None:
            self._values["unsharp_mask"] = unsharp_mask

    @builtins.property
    def background_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultBackgroundColor"]]]:
        '''background_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        '''
        result = self._values.get("background_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultBackgroundColor"]]], result)

    @builtins.property
    def blur(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultBlur"]]]:
        '''blur block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        '''
        result = self._values.get("blur")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultBlur"]]], result)

    @builtins.property
    def chroma_key(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultChromaKey"]]]:
        '''chroma_key block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        '''
        result = self._values.get("chroma_key")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultChromaKey"]]], result)

    @builtins.property
    def composite(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultComposite"]]]:
        '''composite block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        '''
        result = self._values.get("composite")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultComposite"]]], result)

    @builtins.property
    def compound(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultCompound"]]]:
        '''compound block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        '''
        result = self._values.get("compound")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultCompound"]]], result)

    @builtins.property
    def contrast(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultContrast"]]]:
        '''contrast block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultContrast"]]], result)

    @builtins.property
    def goop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultGoop"]]]:
        '''goop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        '''
        result = self._values.get("goop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultGoop"]]], result)

    @builtins.property
    def grayscale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultGrayscale"]]]:
        '''grayscale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        '''
        result = self._values.get("grayscale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultGrayscale"]]], result)

    @builtins.property
    def hsl(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultHsl"]]]:
        '''hsl block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        '''
        result = self._values.get("hsl")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultHsl"]]], result)

    @builtins.property
    def hsv(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultHsv"]]]:
        '''hsv block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        '''
        result = self._values.get("hsv")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultHsv"]]], result)

    @builtins.property
    def if_dimension(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfDimension"]]]:
        '''if_dimension block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        '''
        result = self._values.get("if_dimension")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfDimension"]]], result)

    @builtins.property
    def if_orientation(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfOrientation"]]]:
        '''if_orientation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        '''
        result = self._values.get("if_orientation")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfOrientation"]]], result)

    @builtins.property
    def max_colors(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultMaxColors"]]]:
        '''max_colors block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        '''
        result = self._values.get("max_colors")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultMaxColors"]]], result)

    @builtins.property
    def mirror(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultMirror"]]]:
        '''mirror block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        '''
        result = self._values.get("mirror")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultMirror"]]], result)

    @builtins.property
    def mono_hue(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultMonoHue"]]]:
        '''mono_hue block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        '''
        result = self._values.get("mono_hue")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultMonoHue"]]], result)

    @builtins.property
    def opacity(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultOpacity"]]]:
        '''opacity block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultOpacity"]]], result)

    @builtins.property
    def remove_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultRemoveColor"]]]:
        '''remove_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        '''
        result = self._values.get("remove_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultRemoveColor"]]], result)

    @builtins.property
    def unsharp_mask(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultUnsharpMask"]]]:
        '''unsharp_mask block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        result = self._values.get("unsharp_mask")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultUnsharpMask"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultBackgroundColor",
    jsii_struct_bases=[],
    name_mapping={"color": "color", "color_var": "colorVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultBackgroundColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__067f6a99ae290b9bd98e2de5d854bf3fb2830a2bb886b22f288227a3cd46de63)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultBackgroundColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultBackgroundColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultBackgroundColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8b3222356974978e92621f1d7f380f42d08235e4d3f99f493343af50dd170fb1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultBackgroundColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e33b1962a2038be89cc700ffdfe31ad8e68288a551e27a0a57d5f838d299314f)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultBackgroundColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d0ed72a85a10743f742634c58b251203afeeeab1f755c4a30cc4c7ba7eef1783)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__39c3f2285ddca0110dcee620f5bef5df94ede32d6f3e0fed39915446f792684a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1616d73b163b2f2c8452027db57ab82b755005494a15caf8b510613d0624ca58)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultBackgroundColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultBackgroundColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c48718a96b5cef37781504f6c99e8c78d2a4eff92b88778f35077006a3f44670)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultBackgroundColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultBackgroundColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f17b66da60775690eb3e826caeac2aa3900f6b112d239c611eb0afd8ad9dc76)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a6b619f3350df9196fc0afadc483cdefce609ecfe72054acc09710a249e489a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ea19df2504d9c9819935e84dc87b8e6d406821e77c79a62c6e601c663b02b4b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultBackgroundColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultBackgroundColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultBackgroundColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__59d072cfefc8f4bda90b74bba6a7ec4720ef3f7ba2a4e111486717a6101d63d6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultBlur",
    jsii_struct_bases=[],
    name_mapping={"sigma": "sigma", "sigma_var": "sigmaVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultBlur:
    def __init__(
        self,
        *,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param sigma: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c25717671425690a3ddfe51267b59b2ca43ab9c83a704b6657cd84645778ff17)
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultBlur(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultBlurList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultBlurList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d3982894fde2e42825cd613b120e00121459b1b0edcd0060c48d26188740305)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultBlurOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b139132c5b483498bc48ff2ce292479224645bd082c799e6efc8cb36f7f62043)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultBlurOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ad81e874c250ab4e5d4da560b0e756f65332d9b0a069df2a30f6073c61c7dcf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__515d62a7ed7a46b2da971386f7c36b598c2383f9d730bcb13e83b65e325b7374)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__606f6cbed84a16f319af4b98bb1e0663c22472a12cd5c90b603c6a6afb9a383b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultBlur]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultBlur]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fecb358a529e6df84faddc5602932a47de603a60bf7060ea6469622b5051bec3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultBlurOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultBlurOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a4aa7b31f0c662710b7184b1b1971c12dcf2bb22b0f5bdcfbdd6f25ff6e2313)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__572403b25e8dcebdd4347a014ffc7838be7bf63c2cbcdb7c9d21456e4c4e6283)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__22fc821ad9fb4a9a5f418326af2cf24d9728d4814c4248a54852275c5fa22762)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultBlur]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultBlur]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultBlur]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3fc1ddad860eb21861a7548bf270e8b7bfb8dbeb65d3323ef38581e3650e113f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultChromaKey",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_feather": "hueFeather",
        "hue_feather_var": "hueFeatherVar",
        "hue_tolerance": "hueTolerance",
        "hue_tolerance_var": "hueToleranceVar",
        "hue_var": "hueVar",
        "lightness_feather": "lightnessFeather",
        "lightness_feather_var": "lightnessFeatherVar",
        "lightness_tolerance": "lightnessTolerance",
        "lightness_tolerance_var": "lightnessToleranceVar",
        "saturation_feather": "saturationFeather",
        "saturation_feather_var": "saturationFeatherVar",
        "saturation_tolerance": "saturationTolerance",
        "saturation_tolerance_var": "saturationToleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultChromaKey:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_feather: typing.Optional[builtins.str] = None,
        hue_feather_var: typing.Optional[builtins.str] = None,
        hue_tolerance: typing.Optional[builtins.str] = None,
        hue_tolerance_var: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness_feather: typing.Optional[builtins.str] = None,
        lightness_feather_var: typing.Optional[builtins.str] = None,
        lightness_tolerance: typing.Optional[builtins.str] = None,
        lightness_tolerance_var: typing.Optional[builtins.str] = None,
        saturation_feather: typing.Optional[builtins.str] = None,
        saturation_feather_var: typing.Optional[builtins.str] = None,
        saturation_tolerance: typing.Optional[builtins.str] = None,
        saturation_tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_feather: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        :param hue_feather_var: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        :param hue_tolerance: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        :param hue_tolerance_var: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        :param hue_var: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness_feather: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        :param lightness_feather_var: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        :param lightness_tolerance: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        :param lightness_tolerance_var: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        :param saturation_feather: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        :param saturation_feather_var: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        :param saturation_tolerance: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        :param saturation_tolerance_var: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__94db0a910454ff8a6c228ead1c6ddd54ba5432472412e5490f8348c22ca1d4a5)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_feather", value=hue_feather, expected_type=type_hints["hue_feather"])
            check_type(argname="argument hue_feather_var", value=hue_feather_var, expected_type=type_hints["hue_feather_var"])
            check_type(argname="argument hue_tolerance", value=hue_tolerance, expected_type=type_hints["hue_tolerance"])
            check_type(argname="argument hue_tolerance_var", value=hue_tolerance_var, expected_type=type_hints["hue_tolerance_var"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness_feather", value=lightness_feather, expected_type=type_hints["lightness_feather"])
            check_type(argname="argument lightness_feather_var", value=lightness_feather_var, expected_type=type_hints["lightness_feather_var"])
            check_type(argname="argument lightness_tolerance", value=lightness_tolerance, expected_type=type_hints["lightness_tolerance"])
            check_type(argname="argument lightness_tolerance_var", value=lightness_tolerance_var, expected_type=type_hints["lightness_tolerance_var"])
            check_type(argname="argument saturation_feather", value=saturation_feather, expected_type=type_hints["saturation_feather"])
            check_type(argname="argument saturation_feather_var", value=saturation_feather_var, expected_type=type_hints["saturation_feather_var"])
            check_type(argname="argument saturation_tolerance", value=saturation_tolerance, expected_type=type_hints["saturation_tolerance"])
            check_type(argname="argument saturation_tolerance_var", value=saturation_tolerance_var, expected_type=type_hints["saturation_tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_feather is not None:
            self._values["hue_feather"] = hue_feather
        if hue_feather_var is not None:
            self._values["hue_feather_var"] = hue_feather_var
        if hue_tolerance is not None:
            self._values["hue_tolerance"] = hue_tolerance
        if hue_tolerance_var is not None:
            self._values["hue_tolerance_var"] = hue_tolerance_var
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness_feather is not None:
            self._values["lightness_feather"] = lightness_feather
        if lightness_feather_var is not None:
            self._values["lightness_feather_var"] = lightness_feather_var
        if lightness_tolerance is not None:
            self._values["lightness_tolerance"] = lightness_tolerance
        if lightness_tolerance_var is not None:
            self._values["lightness_tolerance_var"] = lightness_tolerance_var
        if saturation_feather is not None:
            self._values["saturation_feather"] = saturation_feather
        if saturation_feather_var is not None:
            self._values["saturation_feather_var"] = saturation_feather_var
        if saturation_tolerance is not None:
            self._values["saturation_tolerance"] = saturation_tolerance
        if saturation_tolerance_var is not None:
            self._values["saturation_tolerance_var"] = saturation_tolerance_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        '''
        result = self._values.get("hue_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        '''
        result = self._values.get("hue_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        '''
        result = self._values.get("hue_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        '''
        result = self._values.get("hue_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        '''
        result = self._values.get("lightness_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        '''
        result = self._values.get("lightness_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        '''
        result = self._values.get("lightness_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        '''
        result = self._values.get("lightness_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        '''
        result = self._values.get("saturation_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        '''
        result = self._values.get("saturation_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        '''
        result = self._values.get("saturation_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        result = self._values.get("saturation_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultChromaKey(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultChromaKeyList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultChromaKeyList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__58a51f8e1abb76b0308b62f742cf60fe1f485ec1e29088007546bda4f0244357)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultChromaKeyOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__30047b086e28798b1b0acddaff1c77bd0929a1f3eca561c2bfc768dd0e7927dd)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultChromaKeyOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7333a6a0cdd8ddd8a4c33e4e964c03876c337d70837c8e2c27f609415b72d5a9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7e75404f28ac1ae8bf40e9182109fc5ddd9ae72aa9560219829bc95b2c961d8c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__458ef7afabad7b5fa4349ca8f7fa385a967fda7cf52bbe859fd302c0457b2572)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultChromaKey]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultChromaKey]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1116e1b8e753b6091b5361f6393526bf2e33740b47d11e6e95be069dd7508c02)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultChromaKeyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultChromaKeyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c5b9aff35f3e1ad8e0bfba93e2e279f5a5a564eb312dc461076bf5425c12459a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueFeather")
    def reset_hue_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeather", []))

    @jsii.member(jsii_name="resetHueFeatherVar")
    def reset_hue_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeatherVar", []))

    @jsii.member(jsii_name="resetHueTolerance")
    def reset_hue_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueTolerance", []))

    @jsii.member(jsii_name="resetHueToleranceVar")
    def reset_hue_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueToleranceVar", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightnessFeather")
    def reset_lightness_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeather", []))

    @jsii.member(jsii_name="resetLightnessFeatherVar")
    def reset_lightness_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeatherVar", []))

    @jsii.member(jsii_name="resetLightnessTolerance")
    def reset_lightness_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessTolerance", []))

    @jsii.member(jsii_name="resetLightnessToleranceVar")
    def reset_lightness_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessToleranceVar", []))

    @jsii.member(jsii_name="resetSaturationFeather")
    def reset_saturation_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeather", []))

    @jsii.member(jsii_name="resetSaturationFeatherVar")
    def reset_saturation_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeatherVar", []))

    @jsii.member(jsii_name="resetSaturationTolerance")
    def reset_saturation_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationTolerance", []))

    @jsii.member(jsii_name="resetSaturationToleranceVar")
    def reset_saturation_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherInput")
    def hue_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVarInput")
    def hue_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceInput")
    def hue_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVarInput")
    def hue_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherInput")
    def lightness_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVarInput")
    def lightness_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceInput")
    def lightness_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVarInput")
    def lightness_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherInput")
    def saturation_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVarInput")
    def saturation_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceInput")
    def saturation_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVarInput")
    def saturation_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__47a1e8d6386b61fe5cb788938c670f724984fd3c580c9277580d74b693048593)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeather")
    def hue_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeather"))

    @hue_feather.setter
    def hue_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6c1d7cfefb5e112a8db2d23ca794d65ddd0c9df789225255690d06ec5cdb0ba6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeather", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVar")
    def hue_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeatherVar"))

    @hue_feather_var.setter
    def hue_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f0e60e8ce1d7b6b485005eedc07fdd96b76e280167b457d1a9dcc7a75aff474e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueTolerance")
    def hue_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueTolerance"))

    @hue_tolerance.setter
    def hue_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__677a2578732db5ff66b8d67d4f7bd90443d6d2c21fb2ce06fe2aa0d9cce2f710)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVar")
    def hue_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueToleranceVar"))

    @hue_tolerance_var.setter
    def hue_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c0a2e8fddf8cc48fbaf8a7322707e6ab3715f92ec6bb0d47bc9206e49262ac20)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6a47e75ec800c39adcb49749737800e2eb013f4695a19d3a678b60d9f661ba6d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeather")
    def lightness_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeather"))

    @lightness_feather.setter
    def lightness_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f50b2bea79e81f379e7327037d7a260b907fe456e00a1d9a2f41bf14a5d5b607)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeather", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVar")
    def lightness_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeatherVar"))

    @lightness_feather_var.setter
    def lightness_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__86b2867ded3713fb102fc61d092365977cadee395f489181b5d2460bc1114613)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessTolerance")
    def lightness_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessTolerance"))

    @lightness_tolerance.setter
    def lightness_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ffe836f445b8b59c3de5021eef7fcfb040733a38cfad4cd3a8c07c074b2eded8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVar")
    def lightness_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessToleranceVar"))

    @lightness_tolerance_var.setter
    def lightness_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2215ae078092c23911dd349d1ac64a5ee9851279639a16737bab5d43d73de096)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeather")
    def saturation_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeather"))

    @saturation_feather.setter
    def saturation_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5abf2569a435e801aa96d7ceacd18e3322979f92a6c3e9ca3d865632bc1183b5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeather", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVar")
    def saturation_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeatherVar"))

    @saturation_feather_var.setter
    def saturation_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__964e2038cb9adaa426874e507cbc5e94625f3a2bf2342860a43596f17fbee0ff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationTolerance")
    def saturation_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationTolerance"))

    @saturation_tolerance.setter
    def saturation_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dcccfdea5d0c38294fb2f6f60f0a9fca8f9ab8f13beeedb7812b6e391ad404d3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVar")
    def saturation_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationToleranceVar"))

    @saturation_tolerance_var.setter
    def saturation_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d7970ca02190b473685f2d157ba7596c0cb3175ba3df3745bf92900bfd66dbc4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultChromaKey]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultChromaKey]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultChromaKey]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e4309b41b8575dc3c7ff6df679792a6d243ca82d8c90694c8f7fd3c89a41cc76)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultComposite",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "placement": "placement",
        "placement_var": "placementVar",
        "scale": "scale",
        "scale_dimension": "scaleDimension",
        "scale_dimension_var": "scaleDimensionVar",
        "scale_var": "scaleVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultComposite:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultCompositeImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        placement: typing.Optional[builtins.str] = None,
        placement_var: typing.Optional[builtins.str] = None,
        scale: typing.Optional[builtins.str] = None,
        scale_dimension: typing.Optional[builtins.str] = None,
        scale_dimension_var: typing.Optional[builtins.str] = None,
        scale_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param placement: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        :param placement_var: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        :param scale: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param scale_dimension: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        :param scale_dimension_var: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        :param scale_var: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        :param x_position: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultCompositeImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ef21d05d601c7691e151195d47ade6828dfe334911b96f1004e4fb1ba2ab020)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument placement", value=placement, expected_type=type_hints["placement"])
            check_type(argname="argument placement_var", value=placement_var, expected_type=type_hints["placement_var"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument scale_dimension", value=scale_dimension, expected_type=type_hints["scale_dimension"])
            check_type(argname="argument scale_dimension_var", value=scale_dimension_var, expected_type=type_hints["scale_dimension_var"])
            check_type(argname="argument scale_var", value=scale_var, expected_type=type_hints["scale_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if placement is not None:
            self._values["placement"] = placement
        if placement_var is not None:
            self._values["placement_var"] = placement_var
        if scale is not None:
            self._values["scale"] = scale
        if scale_dimension is not None:
            self._values["scale_dimension"] = scale_dimension
        if scale_dimension_var is not None:
            self._values["scale_dimension_var"] = scale_dimension_var
        if scale_var is not None:
            self._values["scale_var"] = scale_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultCompositeImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultCompositeImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        '''
        result = self._values.get("placement")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement_var(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        '''
        result = self._values.get("placement_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        '''
        result = self._values.get("scale_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        '''
        result = self._values.get("scale_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        '''
        result = self._values.get("scale_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultComposite(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultCompositeImage",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultCompositeImage:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultCompositeImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultCompositeImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultCompositeImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd90f6505c0f50c4dcfa7a6daa2719b507cd4d578ac6bbacc6c825c5c406b964)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultCompositeImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultCompositeImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c2f60ab26965f9911725e9718e05f1119dd458681efdc867aacf048824805717)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultCompositeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultCompositeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea9d318e80fda64515f3505a3cb6a6c9659bb31282c266c27565b49d19ff88b9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultCompositeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__de88cc74788eb906b606b55ef3809a9a17e9bafd76c22fe0a2d445768d5f2442)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultCompositeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9cc14dfbfd07d30a6b04ad0b5e7284bccc03a663a8b1398aaae9a6e1db23f6d8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__42cb11bafebed3778ea48cdcf1347aff664841f4884fb84db94581088d2f0607)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4248bdeb18ba23860163defd41d2bebc81d324a471d1111f4f79601934b0195f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultComposite]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultComposite]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f93533a9ae44d006b0fbe66102d96e079a426fbb05db7737e350478919861d5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultCompositeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultCompositeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ef1c1ca14b3009d82beca119f6922fb2f6864f6eaa4563be4c087d59eba0900)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultCompositeImage()

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPlacement")
    def reset_placement(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacement", []))

    @jsii.member(jsii_name="resetPlacementVar")
    def reset_placement_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacementVar", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetScaleDimension")
    def reset_scale_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimension", []))

    @jsii.member(jsii_name="resetScaleDimensionVar")
    def reset_scale_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimensionVar", []))

    @jsii.member(jsii_name="resetScaleVar")
    def reset_scale_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultCompositeImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultCompositeImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultCompositeImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="placementInput")
    def placement_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementInput"))

    @builtins.property
    @jsii.member(jsii_name="placementVarInput")
    def placement_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionInput")
    def scale_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVarInput")
    def scale_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleVarInput")
    def scale_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8e7f62924203367bc7af56bc596382b5966dba8eedd738ccf04c60e35b62a308)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7254d49d915d46c0c0cdd1e4bb34962e0153ce237fdb489a95c7785a1437264f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="placement")
    def placement(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placement"))

    @placement.setter
    def placement(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3cdb5f797dced3c7f8d7ac04e01c855852d0607094862eba8d316724b83ccf14)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placement", value)

    @builtins.property
    @jsii.member(jsii_name="placementVar")
    def placement_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placementVar"))

    @placement_var.setter
    def placement_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9cc4e328ed16c2c7e2737db1ee03c87ab7129b218524677a437dadbc54b1b62d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placementVar", value)

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scale"))

    @scale.setter
    def scale(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c7e4ebd74d664ffd9d4f7ed948e0b39283c4f53a9e13e8454d495ed42c76a61f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scale", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimension")
    def scale_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimension"))

    @scale_dimension.setter
    def scale_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__37df2c585e4d3a901858332dc0fa19788852615006787adb9bf608b95d590563)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimension", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVar")
    def scale_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimensionVar"))

    @scale_dimension_var.setter
    def scale_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b1a7cca5cece6d84e41fbad0cc89a2fdca54ab21a1f87d02e61542a26daaca1f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="scaleVar")
    def scale_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleVar"))

    @scale_var.setter
    def scale_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7634999438960831396bce62f05fc9ab4beb34a9d5b82c342947efb5c18e840d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__61664f664585120d1d361b2720e8325ee5268868e998a339ea740e5a628358b2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__48553d2d3877c79c48b0e324aab7640c2680ac634c68783e51e485bfcda7cbf5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ede291dd793924103d61b2bf87ef2cb5f5a7280a67558e1e7db1cafa92074d96)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4172f17b1ab70ffe9b74e7e75571b3ad25f031c84c6a7fc22222e31992dd0313)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultComposite]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultComposite]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultComposite]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fbda4f23e7ae450762e343389a192ef7320a9f8408ba12b48578cf1f8018c72a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultCompound",
    jsii_struct_bases=[],
    name_mapping={"transformations": "transformations"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultCompound:
    def __init__(
        self,
        *,
        transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param transformations: transformations block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6d3c19cc0ff03a72e8f4f521c5bacb136a2de2fc7aafc97cf862b75ff561c4de)
            check_type(argname="argument transformations", value=transformations, expected_type=type_hints["transformations"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if transformations is not None:
            self._values["transformations"] = transformations

    @builtins.property
    def transformations(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultCompoundTransformations"]]]:
        '''transformations block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        result = self._values.get("transformations")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultCompoundTransformations"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultCompound(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultCompoundList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultCompoundList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b6085e9dcee0700cd2c06cf5994e1279f7634ca1f4c327acba4337ac0b7bceed)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultCompoundOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__01506f7f6eeea41a6f5c4df1fc77a37837d123784acbde53d182562343d82fa3)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultCompoundOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2b6a946ee545d66d505813b83122617a9c17858742e388e62bce053308b3b912)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f182d55883d72b361bd9faf5726d968205257c369520ea25fc217887df1b4a13)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cf0e50b777c091574a3916610e32b11283004a2acd6208ee517bd685d92de514)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultCompound]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultCompound]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7121273c3058d197ac1f68e03d4095b20630b84810c89cac4a4269db1cccb29d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultCompoundOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultCompoundOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__65aa3e8a52f75707a9a71816d238491a36af3ba301845c1f787d50fab8c175d7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformations")
    def put_transformations(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dfc2f2efd5515e6656fe0b7a107639489779fc3be2377798da6d634692745f0f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTransformations", [value]))

    @jsii.member(jsii_name="resetTransformations")
    def reset_transformations(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformations", []))

    @builtins.property
    @jsii.member(jsii_name="transformations")
    def transformations(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultCompoundTransformationsList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultCompoundTransformationsList", jsii.get(self, "transformations"))

    @builtins.property
    @jsii.member(jsii_name="transformationsInput")
    def transformations_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultCompoundTransformations"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultCompoundTransformations"]]], jsii.get(self, "transformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultCompound]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultCompound]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultCompound]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7fef81ec9f3b1f9fbc18212f96087bd769b3f588b50df1666a44e185f1042d53)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultCompoundTransformations",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultCompoundTransformations:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultCompoundTransformations(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultCompoundTransformationsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultCompoundTransformationsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0a906c3279968cc5b1860e0936a3d9d61b31293fac4b1aee985c463b94363dea)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultCompoundTransformationsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__79c5fa12206353c124909bd41b4de25547a44837cfc9aba1689fc15c68a71e72)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultCompoundTransformationsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8af7a251024ffce61061c3437200c3c65d742ed544842ebb24bf1a39af1825a2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e174290e3a123c59e95c3a05af58d88ce2744724975c136acbfc4fc8e15e9433)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bf98a0d0dedf106015fe6688d63738784587c2f92d0888bde9b0f65ac4dc492c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultCompoundTransformations]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultCompoundTransformations]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultCompoundTransformations]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab9ce0fdaa65180401ac391f9c3bb46a67dec3ca2255663c7e8eebecd8daf020)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultCompoundTransformationsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultCompoundTransformationsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__83c935448de249c92d188830ccceb17e66661639512e5e56728c0a610189fe70)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultCompoundTransformations]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultCompoundTransformations]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultCompoundTransformations]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__28958f408b8f2648bad550ffeef816b95bb506b73f51999bf0a2db087630d1b6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultContrast",
    jsii_struct_bases=[],
    name_mapping={
        "brightness": "brightness",
        "brightness_var": "brightnessVar",
        "contrast": "contrast",
        "contrast_var": "contrastVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultContrast:
    def __init__(
        self,
        *,
        brightness: typing.Optional[builtins.str] = None,
        brightness_var: typing.Optional[builtins.str] = None,
        contrast: typing.Optional[builtins.str] = None,
        contrast_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param brightness: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        :param brightness_var: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        :param contrast: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param contrast_var: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b12a91d9656da2d2c3558f5465b8b191854437821d808e779376d4703ae204bb)
            check_type(argname="argument brightness", value=brightness, expected_type=type_hints["brightness"])
            check_type(argname="argument brightness_var", value=brightness_var, expected_type=type_hints["brightness_var"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument contrast_var", value=contrast_var, expected_type=type_hints["contrast_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if brightness is not None:
            self._values["brightness"] = brightness
        if brightness_var is not None:
            self._values["brightness_var"] = brightness_var
        if contrast is not None:
            self._values["contrast"] = contrast
        if contrast_var is not None:
            self._values["contrast_var"] = contrast_var

    @builtins.property
    def brightness(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        '''
        result = self._values.get("brightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def brightness_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        '''
        result = self._values.get("brightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        result = self._values.get("contrast_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultContrast(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultContrastList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultContrastList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dc2a8fb1ceb6dac7c96991535e6d27cfa375fa785c589481970a6ba54a176a58)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultContrastOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d08fda94ae6358c8becc62e258e175d7a300ef6edca97a0da46388f78f3c808a)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultContrastOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eb278ae995bd9d30edc4125cd57fb0e9c199b53c6acf89de59294a499c9fdb69)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1d7f78e54beb8e5a489144bc6ee0daffade35e96ed4b06c9b5eb8daffea9cd16)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__86e6ccff1ef1b51411d2ade4680ac15a859c4903ba10a37a1fcc208bd28da334)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultContrast]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultContrast]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aaf76bbc1555545098b20e944d14450a771d2e92f8341ce364451160311f3ac8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultContrastOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultContrastOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d3b2d6c87cbaec0db3446a06e3f315151e77d6e890861119b88a2a32ccc24023)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetBrightness")
    def reset_brightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightness", []))

    @jsii.member(jsii_name="resetBrightnessVar")
    def reset_brightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightnessVar", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetContrastVar")
    def reset_contrast_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrastVar", []))

    @builtins.property
    @jsii.member(jsii_name="brightnessInput")
    def brightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="brightnessVarInput")
    def brightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastVarInput")
    def contrast_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="brightness")
    def brightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightness"))

    @brightness.setter
    def brightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__41f94570dfc0fee23b52dd8295fc5b6c96e991a68d2a200d38422a7b8940f304)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightness", value)

    @builtins.property
    @jsii.member(jsii_name="brightnessVar")
    def brightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightnessVar"))

    @brightness_var.setter
    def brightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0351ca28cd20fa1e4f2151d394f911ffe6d5ff14f5bc255819f5ef3102465de9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrast"))

    @contrast.setter
    def contrast(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__327f9caba851de1492abaa5796111a20d083cedae4afa8cf81fb9b9bdb7d3812)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrast", value)

    @builtins.property
    @jsii.member(jsii_name="contrastVar")
    def contrast_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrastVar"))

    @contrast_var.setter
    def contrast_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b35d60b6f62113e6d15278c2f5ef3d8a61e4b59c13bfdf200060e3cb700423d2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrastVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultContrast]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultContrast]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultContrast]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e8ca18c5ac92c6ed5a68e21795652ae07614b5d10eeef8d951759e6053cb07e7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultGoop",
    jsii_struct_bases=[],
    name_mapping={
        "chaos": "chaos",
        "chaos_var": "chaosVar",
        "density": "density",
        "density_var": "densityVar",
        "power": "power",
        "power_var": "powerVar",
        "seed": "seed",
        "seed_var": "seedVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultGoop:
    def __init__(
        self,
        *,
        chaos: typing.Optional[builtins.str] = None,
        chaos_var: typing.Optional[builtins.str] = None,
        density: typing.Optional[builtins.str] = None,
        density_var: typing.Optional[builtins.str] = None,
        power: typing.Optional[builtins.str] = None,
        power_var: typing.Optional[builtins.str] = None,
        seed: typing.Optional[builtins.str] = None,
        seed_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param chaos: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        :param chaos_var: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        :param density: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        :param density_var: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        :param power: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        :param power_var: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        :param seed: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        :param seed_var: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f998af54c3fbba3acd3291b084dcf93078c62a0b58d4e3c260cb4765bb7a073)
            check_type(argname="argument chaos", value=chaos, expected_type=type_hints["chaos"])
            check_type(argname="argument chaos_var", value=chaos_var, expected_type=type_hints["chaos_var"])
            check_type(argname="argument density", value=density, expected_type=type_hints["density"])
            check_type(argname="argument density_var", value=density_var, expected_type=type_hints["density_var"])
            check_type(argname="argument power", value=power, expected_type=type_hints["power"])
            check_type(argname="argument power_var", value=power_var, expected_type=type_hints["power_var"])
            check_type(argname="argument seed", value=seed, expected_type=type_hints["seed"])
            check_type(argname="argument seed_var", value=seed_var, expected_type=type_hints["seed_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if chaos is not None:
            self._values["chaos"] = chaos
        if chaos_var is not None:
            self._values["chaos_var"] = chaos_var
        if density is not None:
            self._values["density"] = density
        if density_var is not None:
            self._values["density_var"] = density_var
        if power is not None:
            self._values["power"] = power
        if power_var is not None:
            self._values["power_var"] = power_var
        if seed is not None:
            self._values["seed"] = seed
        if seed_var is not None:
            self._values["seed_var"] = seed_var

    @builtins.property
    def chaos(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        '''
        result = self._values.get("chaos")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def chaos_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        '''
        result = self._values.get("chaos_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        '''
        result = self._values.get("density")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density_var(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        '''
        result = self._values.get("density_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        '''
        result = self._values.get("power")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power_var(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        '''
        result = self._values.get("power_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        '''
        result = self._values.get("seed")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed_var(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        result = self._values.get("seed_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultGoop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultGoopList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultGoopList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e22ddcaa364d33a20bde4dad85a42a74d106cf4b56420be749c7e439649dde18)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultGoopOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f7f40ea12d3fd80c21ff8c4d659b475858c064229ef1dec1045584279d8fbd08)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultGoopOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dd42b22ff0251b9c6474712c3d95a63f9012bec98d93d6aa9078510844f5a7b1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fafea5ee632c99568b566e3c40ef815338391d7cce69231b1f0e36853f7a67cf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__17ca32b2f1dd816302f06baa675644f3f9396b3ac1c66137e64be4d109404c15)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultGoop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultGoop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1c5161573a0f4bced5f2f8a46ea37af2319674ad345f416fac224dfdff382cb7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultGoopOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultGoopOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9c6c11e5a15eabb080c5579902b2eea56ec1932a5115f0691b22755f4bb4731f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetChaos")
    def reset_chaos(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaos", []))

    @jsii.member(jsii_name="resetChaosVar")
    def reset_chaos_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaosVar", []))

    @jsii.member(jsii_name="resetDensity")
    def reset_density(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensity", []))

    @jsii.member(jsii_name="resetDensityVar")
    def reset_density_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensityVar", []))

    @jsii.member(jsii_name="resetPower")
    def reset_power(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPower", []))

    @jsii.member(jsii_name="resetPowerVar")
    def reset_power_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPowerVar", []))

    @jsii.member(jsii_name="resetSeed")
    def reset_seed(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeed", []))

    @jsii.member(jsii_name="resetSeedVar")
    def reset_seed_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeedVar", []))

    @builtins.property
    @jsii.member(jsii_name="chaosInput")
    def chaos_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosInput"))

    @builtins.property
    @jsii.member(jsii_name="chaosVarInput")
    def chaos_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosVarInput"))

    @builtins.property
    @jsii.member(jsii_name="densityInput")
    def density_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityInput"))

    @builtins.property
    @jsii.member(jsii_name="densityVarInput")
    def density_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="powerInput")
    def power_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerInput"))

    @builtins.property
    @jsii.member(jsii_name="powerVarInput")
    def power_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerVarInput"))

    @builtins.property
    @jsii.member(jsii_name="seedInput")
    def seed_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedInput"))

    @builtins.property
    @jsii.member(jsii_name="seedVarInput")
    def seed_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedVarInput"))

    @builtins.property
    @jsii.member(jsii_name="chaos")
    def chaos(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaos"))

    @chaos.setter
    def chaos(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb72665f6d6f551a42a3bf66f0a00d975ce2f728c0a5281678ff4125e9d9eb02)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaos", value)

    @builtins.property
    @jsii.member(jsii_name="chaosVar")
    def chaos_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaosVar"))

    @chaos_var.setter
    def chaos_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__68da4bbdcd33a6830688867ee0484f6df90425c464dc37575b186e1eec3a609c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaosVar", value)

    @builtins.property
    @jsii.member(jsii_name="density")
    def density(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "density"))

    @density.setter
    def density(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__17dc943dfcec12caebdf680df0ffaf331d2f9d986ac0876c28ba2d97765d455a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "density", value)

    @builtins.property
    @jsii.member(jsii_name="densityVar")
    def density_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "densityVar"))

    @density_var.setter
    def density_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__787cf84367387881dc7d581087c162a32dbb5988bad408fdc43ec8bbe0433c5f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "densityVar", value)

    @builtins.property
    @jsii.member(jsii_name="power")
    def power(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "power"))

    @power.setter
    def power(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__45425557a750d74fc0489064f52a7cec0ab6ba2a554bfa5d57ecfcc17dad0a82)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "power", value)

    @builtins.property
    @jsii.member(jsii_name="powerVar")
    def power_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "powerVar"))

    @power_var.setter
    def power_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__22cdf3155e1d56a8c039d873b95c821a266daefc99530e06f4f1ad7db7cfd3ac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "powerVar", value)

    @builtins.property
    @jsii.member(jsii_name="seed")
    def seed(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seed"))

    @seed.setter
    def seed(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ebb63cff01acac8408ececd92d39706b300b26b244f355d7f984772db65db1c2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seed", value)

    @builtins.property
    @jsii.member(jsii_name="seedVar")
    def seed_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seedVar"))

    @seed_var.setter
    def seed_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__935b23cef881f2a8cee67419048fe71fbc99247af17217bed7583b14efd65c04)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seedVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultGoop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultGoop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultGoop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__55327bf0d470fc963c2c7ddd9b09907f06dc3b35ce5eb0506ce13c27e9dddb56)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultGrayscale",
    jsii_struct_bases=[],
    name_mapping={"type": "type", "type_var": "typeVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultGrayscale:
    def __init__(
        self,
        *,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param type: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a7b148d3d64c32b9d63edcefd8d35679d21bc528d218eee3fcfffa70164da6c9)
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultGrayscale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultGrayscaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultGrayscaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0f0bd1d026a21f45e300a7e0c2bdb4d2a937fcc8951cf8423f72b86c3f82c71e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultGrayscaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__420327f4e8d3960d3f1a72d7c8cd43908fd7c831d86d880d985dd38fb7b5ee1b)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultGrayscaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1e4f634002a245982f70134181971633c67db8eca57e4485da08ca3b64b67d8b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__faf9673239ed4d074e3463cc11fc22c3f84dd28853e27c5d340695edf5ee7dbe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__26c1c8b487a7d5067ee2d5895d6e994922a71dbb1bb58bb59fb512953c79d49e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultGrayscale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultGrayscale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a721ffbed67ef0ba1935c52d1c287498f23e653f7b8076f970398d82aa6cee4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultGrayscaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultGrayscaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1676f39ac9904e63e2186cd7b3641556c1a80d57f9b20d50cca05570cf63191a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3093845289dcc28f1e7a6ba397c110e97cc5266c4a39d01ffba266d623384060)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9227ea63e7e0f6eca085dd542018a4719cef4502924b87dae2a56883cd7960d1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultGrayscale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultGrayscale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultGrayscale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ec6b35b24742e40117fb7f168ee38fb5005fcbb6dcfe6758327397185e426f4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultHsl",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "lightness": "lightness",
        "lightness_var": "lightnessVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultHsl:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness: typing.Optional[builtins.str] = None,
        lightness_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        :param lightness_var: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b086002bb34e09b5f6d583ad4e8435cb78fdf6306ae764f5830df658a9a0dd07)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness", value=lightness, expected_type=type_hints["lightness"])
            check_type(argname="argument lightness_var", value=lightness_var, expected_type=type_hints["lightness_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness is not None:
            self._values["lightness"] = lightness
        if lightness_var is not None:
            self._values["lightness_var"] = lightness_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        '''
        result = self._values.get("lightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        '''
        result = self._values.get("lightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultHsl(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultHslList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultHslList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cabfbdb978e6d47bbb4e9a8437058be4239dbf9dd0c3b88c5287ec9e2dca443d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultHslOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__400a6129ab75b3ae296bf1fc7aa2bb64212f138000b83cdc36a995175a8d43b9)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultHslOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc390b66b0be53fda0bafe6917f73aa84da396879a2fc9456a86a872a63dbee3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5001016e28e5feaad9bc492a80812e58a6c6eed38251e71e2b147bdd36d11ee8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__406b8f7e73c26d99addcefc3b1635eca77efea95e0aeabb296fb0d3dadb883ef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultHsl]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultHsl]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fc8d9baae208578d1a4da81945d1fb9abfadce6d7bf33531a9bf368703c98f7b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultHslOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultHslOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d3391b8dc3ff0c16eb5da6bec4c4cffca47dd69827acbc98add95003df963a20)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightness")
    def reset_lightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightness", []))

    @jsii.member(jsii_name="resetLightnessVar")
    def reset_lightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessInput")
    def lightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessVarInput")
    def lightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d98c473b7b88dea6f3fd5b990ceeb39baf25c07eca84a18e69c44712619d38a4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__667343203ab05ecd8ace0f1129e76ee34dde0210ae4169de42705087e6805400)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightness")
    def lightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightness"))

    @lightness.setter
    def lightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c679638f4dbe6732f122bfa18bebcd09a726b49083aba0dcc363de49086fc7c4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightness", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessVar")
    def lightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessVar"))

    @lightness_var.setter
    def lightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b6cffab524ff258ac9b9d32938e928b1f2e05485df425eecdbefd5dc719846d2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6b744798b738454339be7c7fadb199892181d152d2ce2b4ea56be790c01c62a2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d6d6af37fb32858259e673e165fc6ecb70a8613f7d2292787699ce69bd880594)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultHsl]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultHsl]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultHsl]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f157c354ccf08442e89ac6329a87bc8baf5fde18cd4281257fe1d1027551bae7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultHsv",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultHsv:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        :param value: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__76d094be0cc95395c503c5ee57350ddb732419b42bfdbd013d9291a9710143a5)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultHsv(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultHsvList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultHsvList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__52ce92e2ab8cf6a249a0bee39a464931a82c51a81b5697819b6477ac5528efd1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultHsvOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6d2458e4e91bff139088a4f67a4d4b3c5cc64ae68687a95df6b266b35460c94c)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultHsvOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__917db58c455b876b0a204a10355a1f2bcc245eaf7e9ecb175995f70d4c289137)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b084abd4985d192d1b3860ac12c04b7ac9dba7bbb8139271cf7a6d7b6b8ce618)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7006f209ecb88e95a230b5b5ed3edcb3bf48572863343ccb48ede5fbc5fcfd22)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultHsv]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultHsv]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a08706d749518bfa711dfa69ec493165afd1a893837ddfacc7afa2674a3e71e1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultHsvOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultHsvOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__996808552206bc466a3a00b30716ef7de2ba2ccc450c3387055015320795c040)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8fef9774386fbf2ceda9a0257017c205902629178cf63e57d5d46e27c39c86d8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__99c15e4be2fa5cf68c302ca1fde37ad6e66c7f8d34fb287d8e7305e5b0adc7a0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__131b31869a23916f6f0f57277135e04f32e033651b21fb9b9a1b76e6fa8160fe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__525d2453558efe2006ab7f2b4927a563ce7651e4534ac9c83b2c07d2547e26cc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e21ac28c559be627ea7491539cc9a2d4b58c92a4da59eb66bfd7c4e8c43beda2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ebee772125397b79beeff500755a80316410568faa57f389b0e967afd08e3772)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultHsv]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultHsv]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultHsv]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9b5f91ee5c97cb835fa35e9296b8ceb0ffcc891385bad3265bdc1de097ee5d6f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfDimension",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "dimension": "dimension",
        "dimension_var": "dimensionVar",
        "equal": "equal",
        "greater_than": "greaterThan",
        "less_than": "lessThan",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfDimension:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        dimension: typing.Optional[builtins.str] = None,
        dimension_var: typing.Optional[builtins.str] = None,
        equal: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionEqual", typing.Dict[builtins.str, typing.Any]]] = None,
        greater_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionGreaterThan", typing.Dict[builtins.str, typing.Any]]] = None,
        less_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionLessThan", typing.Dict[builtins.str, typing.Any]]] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param dimension: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        :param dimension_var: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        :param equal: equal block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        :param greater_than: greater_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        :param less_than: less_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        :param value: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionDefault(**default)
        if isinstance(equal, dict):
            equal = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionEqual(**equal)
        if isinstance(greater_than, dict):
            greater_than = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionGreaterThan(**greater_than)
        if isinstance(less_than, dict):
            less_than = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionLessThan(**less_than)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d0a4779af13904ff73ae1db5a1228b2092e42a8f9407025469c2761ed75a98cd)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument dimension", value=dimension, expected_type=type_hints["dimension"])
            check_type(argname="argument dimension_var", value=dimension_var, expected_type=type_hints["dimension_var"])
            check_type(argname="argument equal", value=equal, expected_type=type_hints["equal"])
            check_type(argname="argument greater_than", value=greater_than, expected_type=type_hints["greater_than"])
            check_type(argname="argument less_than", value=less_than, expected_type=type_hints["less_than"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if dimension is not None:
            self._values["dimension"] = dimension
        if dimension_var is not None:
            self._values["dimension_var"] = dimension_var
        if equal is not None:
            self._values["equal"] = equal
        if greater_than is not None:
            self._values["greater_than"] = greater_than
        if less_than is not None:
            self._values["less_than"] = less_than
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionDefault"], result)

    @builtins.property
    def dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        '''
        result = self._values.get("dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        '''
        result = self._values.get("dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def equal(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionEqual"]:
        '''equal block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        '''
        result = self._values.get("equal")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionEqual"], result)

    @builtins.property
    def greater_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionGreaterThan"]:
        '''greater_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        '''
        result = self._values.get("greater_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionGreaterThan"], result)

    @builtins.property
    def less_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionLessThan"]:
        '''less_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        '''
        result = self._values.get("less_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionLessThan"], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfDimension(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4cca6bb147820645d4f0b522dd7f8a4dadf4bfdf9162f71fcc0c71108aedd536)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__84a4ef73c872c5f140879f76ed7f7d28225cc43a2fd2aef9fb62fb9ed7beff0d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionEqual",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionEqual:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionEqual(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionEqualOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionEqualOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c8249202d90bd1cdafc643baffdf18bd983ded06de08efba4205b9606db02e2b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionEqual], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionEqual],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7122c26922c044f141e01c70175ff3de4d7a29427a30eed7bebef154de5b88a2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionGreaterThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionGreaterThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionGreaterThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionGreaterThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionGreaterThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__548350a63f73489cecdf485c3c804d553d19c5c030b4f74baf7bbf160f675a25)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionGreaterThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionGreaterThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__786a673fc7a1a93adf16c0cf6c2bd61b5f0c3f167f265aad14414085a743c652)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionLessThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionLessThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionLessThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionLessThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionLessThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8df1cd1942d4d2f0864ffd342cb7ac5ecd76ab2e22465d8647a92312af86ba44)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionLessThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionLessThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__30c09a5cb305c04270248c89ca2652efe79a1d6861b128c2a2f0d2f709d54eaa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0daf3790a37fdc9be4005c8bf8a76e72b094924a12955dd319b5a119d8e4b139)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__97509f93d6ca66ea1897ce7c58b2d832a80fd7e98a6e19f1d97b9c1ec327d03e)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__420b23a7b65c934e945b4b5c283c6212bc50b290328cbcc71faadc9859c77691)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3c4897b127bf59f0258bb5520241f54b44331fff05e7422375ecceb8861f1224)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b7318ca32f805950f3da0acb9a6a8b824267addca5471eb364ee6aa15ec76125)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfDimension]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfDimension]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f45e5007915309af7b371d85bfb30877a5fcc6e0555db923c57d9027bc3dfc6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__14cbffc7eac86bde2bb49f424933426368c9d6dc48797935643877778710ea81)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putEqual")
    def put_equal(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionEqual()

        return typing.cast(None, jsii.invoke(self, "putEqual", [value]))

    @jsii.member(jsii_name="putGreaterThan")
    def put_greater_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionGreaterThan()

        return typing.cast(None, jsii.invoke(self, "putGreaterThan", [value]))

    @jsii.member(jsii_name="putLessThan")
    def put_less_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionLessThan()

        return typing.cast(None, jsii.invoke(self, "putLessThan", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetDimension")
    def reset_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimension", []))

    @jsii.member(jsii_name="resetDimensionVar")
    def reset_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimensionVar", []))

    @jsii.member(jsii_name="resetEqual")
    def reset_equal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEqual", []))

    @jsii.member(jsii_name="resetGreaterThan")
    def reset_greater_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGreaterThan", []))

    @jsii.member(jsii_name="resetLessThan")
    def reset_less_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLessThan", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="equal")
    def equal(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionEqualOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionEqualOutputReference, jsii.get(self, "equal"))

    @builtins.property
    @jsii.member(jsii_name="greaterThan")
    def greater_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionGreaterThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionGreaterThanOutputReference, jsii.get(self, "greaterThan"))

    @builtins.property
    @jsii.member(jsii_name="lessThan")
    def less_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionLessThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionLessThanOutputReference, jsii.get(self, "lessThan"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionInput")
    def dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionVarInput")
    def dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="equalInput")
    def equal_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionEqual], jsii.get(self, "equalInput"))

    @builtins.property
    @jsii.member(jsii_name="greaterThanInput")
    def greater_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionGreaterThan], jsii.get(self, "greaterThanInput"))

    @builtins.property
    @jsii.member(jsii_name="lessThanInput")
    def less_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionLessThan], jsii.get(self, "lessThanInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="dimension")
    def dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimension"))

    @dimension.setter
    def dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7dee7674674abae1f9cd5b1ff1e55a1f8524b4d4e5d8e6b0f8a96d257821412b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimension", value)

    @builtins.property
    @jsii.member(jsii_name="dimensionVar")
    def dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimensionVar"))

    @dimension_var.setter
    def dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__75109bfed03a430e7ac86d27913f40f4b5c1b5ebe352abd18042a645a86d14f1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__213c0b7bc2e461bf9d159ff04d80989cd52e2285b4756337b94a3cd5d21623ee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__61761755235376813a096e3c9da14b9cfeeda1aada213ba4ef84a4ed0581a16c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfDimension]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfDimension]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfDimension]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a0a46f185a323bff19e088fa69486e8d979c98ddec82f143cbd682bfca9c0b0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfOrientation",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "landscape": "landscape",
        "portrait": "portrait",
        "square": "square",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfOrientation:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        landscape: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationLandscape", typing.Dict[builtins.str, typing.Any]]] = None,
        portrait: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationPortrait", typing.Dict[builtins.str, typing.Any]]] = None,
        square: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationSquare", typing.Dict[builtins.str, typing.Any]]] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param landscape: landscape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        :param portrait: portrait block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        :param square: square block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationDefault(**default)
        if isinstance(landscape, dict):
            landscape = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationLandscape(**landscape)
        if isinstance(portrait, dict):
            portrait = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationPortrait(**portrait)
        if isinstance(square, dict):
            square = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationSquare(**square)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__27d3c4b5e9dacf66f110ed65c50e41f5b1c7d87e908f2a553924201abc67e94e)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument landscape", value=landscape, expected_type=type_hints["landscape"])
            check_type(argname="argument portrait", value=portrait, expected_type=type_hints["portrait"])
            check_type(argname="argument square", value=square, expected_type=type_hints["square"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if landscape is not None:
            self._values["landscape"] = landscape
        if portrait is not None:
            self._values["portrait"] = portrait
        if square is not None:
            self._values["square"] = square

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationDefault"], result)

    @builtins.property
    def landscape(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationLandscape"]:
        '''landscape block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        '''
        result = self._values.get("landscape")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationLandscape"], result)

    @builtins.property
    def portrait(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationPortrait"]:
        '''portrait block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        '''
        result = self._values.get("portrait")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationPortrait"], result)

    @builtins.property
    def square(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationSquare"]:
        '''square block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        result = self._values.get("square")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationSquare"], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfOrientation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__71cc6a43ede8b0f2be90bb3a577d3c75f177441f01cc26680c4bf10f9563b42d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b6c0087a5540f5a669ad2f01b140b2ec6fe6a5397405c2e3df6cb3cbdb4062c0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationLandscape",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationLandscape:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationLandscape(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationLandscapeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationLandscapeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4974f2b133ab6314f5de4efd64ce3773dd9ad6a8d64f6005810854aaf1ce3247)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationLandscape], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationLandscape],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fd9111c9eb7c313b167efb0379eda2413d97843ff765dd24b86f42570f0543eb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e74c4a8ae03cab8fb7344d31c8546dec08459ee7a230b0fc5a5a71a3bee4653f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__da8f7e3d7afb8f1e07d50ba3638d68fa73c6d002cabd3cfb2d047053f8f97629)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__200d734737b0d19cbd2cdccacb2cee9fc2dca7816d7fc0057fee032496059b23)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__91a35de5598d77bdcc4f354e043b1481b1928a10195155cc6e7472c4eddf3f10)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f0460b8e5be5e2f23675065d564ce3aada9a65b3d2b97b29e306d2d98f6afe3f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfOrientation]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfOrientation]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e7b473384611cd67a5dae9615e5320d077e4a0949cb774a7629a3a4a40f7074d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a09fd9835c4f8334c2e7d6bcb19f4b3be960b5175d12e9c8203b9d0c21588a5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putLandscape")
    def put_landscape(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationLandscape()

        return typing.cast(None, jsii.invoke(self, "putLandscape", [value]))

    @jsii.member(jsii_name="putPortrait")
    def put_portrait(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationPortrait()

        return typing.cast(None, jsii.invoke(self, "putPortrait", [value]))

    @jsii.member(jsii_name="putSquare")
    def put_square(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationSquare()

        return typing.cast(None, jsii.invoke(self, "putSquare", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetLandscape")
    def reset_landscape(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLandscape", []))

    @jsii.member(jsii_name="resetPortrait")
    def reset_portrait(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPortrait", []))

    @jsii.member(jsii_name="resetSquare")
    def reset_square(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSquare", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="landscape")
    def landscape(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationLandscapeOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationLandscapeOutputReference, jsii.get(self, "landscape"))

    @builtins.property
    @jsii.member(jsii_name="portrait")
    def portrait(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationPortraitOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationPortraitOutputReference", jsii.get(self, "portrait"))

    @builtins.property
    @jsii.member(jsii_name="square")
    def square(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationSquareOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationSquareOutputReference", jsii.get(self, "square"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="landscapeInput")
    def landscape_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationLandscape], jsii.get(self, "landscapeInput"))

    @builtins.property
    @jsii.member(jsii_name="portraitInput")
    def portrait_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationPortrait"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationPortrait"], jsii.get(self, "portraitInput"))

    @builtins.property
    @jsii.member(jsii_name="squareInput")
    def square_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationSquare"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationSquare"], jsii.get(self, "squareInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfOrientation]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfOrientation]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfOrientation]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__20a52ed96740aa0b77fa109928ec1419fcd5f9ebcee9c1625b569c69fe33eef0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationPortrait",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationPortrait:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationPortrait(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationPortraitOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationPortraitOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7f2eba1d54286224ea7cd894edeec7c535bb681d4385439c35b397505e5766aa)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationPortrait]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationPortrait], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationPortrait],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__40e39ef75254f1225dd317e88a4d379edc3ab9ecbcb107fa2ae2b4a4136261f6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationSquare",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationSquare:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationSquare(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationSquareOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationSquareOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dcd9e2cb6009716f6907dce2ab77ce21886a1c32fde42354df59ce9e8644ff04)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationSquare]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationSquare], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationSquare],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__60a8a1b15817be5982861afee3431dd492b6c6b6226d6afdae2a9bff68df68f8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultMaxColors",
    jsii_struct_bases=[],
    name_mapping={"colors": "colors", "colors_var": "colorsVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultMaxColors:
    def __init__(
        self,
        *,
        colors: typing.Optional[builtins.str] = None,
        colors_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param colors: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        :param colors_var: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9536bea18e2b4f6ff01825fda89b17dccbcfe6e8132936400665f367af7048cd)
            check_type(argname="argument colors", value=colors, expected_type=type_hints["colors"])
            check_type(argname="argument colors_var", value=colors_var, expected_type=type_hints["colors_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if colors is not None:
            self._values["colors"] = colors
        if colors_var is not None:
            self._values["colors_var"] = colors_var

    @builtins.property
    def colors(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        '''
        result = self._values.get("colors")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def colors_var(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        result = self._values.get("colors_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultMaxColors(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultMaxColorsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultMaxColorsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__800ad1ad2d6690998d42c8c27a27c1fde8bd666ce91f62139ea422b517d1f48f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultMaxColorsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__da2c4f1bb568deda3147be0d37ad23611255b32ccba7fdc1fe0b35742295f81c)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultMaxColorsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f3c06190cd04eddeaa3d7760c4bc3cd16ba7c790959f87a4a777dec57c0144ff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8486dd7cfa5084e8cbc2697c59441359c2977bd315ca7e87bf6d89dcf0d531c6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__36e67ebdf71901cf1662414ae0d42008a00a291e29ad331ff51c2953c2d1f6a7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultMaxColors]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultMaxColors]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c84f07b9c32862cddb8889525e2442905d2fcfd1b0eaac055c4ff95142c8a413)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultMaxColorsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultMaxColorsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__75b67bbf77c826ed72d62c23b05389ee420d6609ed20ff571affe5c068fd928e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColors")
    def reset_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColors", []))

    @jsii.member(jsii_name="resetColorsVar")
    def reset_colors_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorsVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorsInput")
    def colors_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsInput"))

    @builtins.property
    @jsii.member(jsii_name="colorsVarInput")
    def colors_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsVarInput"))

    @builtins.property
    @jsii.member(jsii_name="colors")
    def colors(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colors"))

    @colors.setter
    def colors(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a1afcc4f48c9c95a65660dac665cdb5d5b36330059e777ce158cfdb66aa1491e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colors", value)

    @builtins.property
    @jsii.member(jsii_name="colorsVar")
    def colors_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorsVar"))

    @colors_var.setter
    def colors_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__305043bcbb7ffbdaa28059a82bdffd2b28b9ed142971da4977b40c4fe6579915)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorsVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultMaxColors]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultMaxColors]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultMaxColors]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__196232ef1b1eb031b8442ef2eb454963712feb87685d8b67d30301bcbaf3e145)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultMirror",
    jsii_struct_bases=[],
    name_mapping={
        "horizontal": "horizontal",
        "horizontal_var": "horizontalVar",
        "vertical": "vertical",
        "vertical_var": "verticalVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultMirror:
    def __init__(
        self,
        *,
        horizontal: typing.Optional[builtins.str] = None,
        horizontal_var: typing.Optional[builtins.str] = None,
        vertical: typing.Optional[builtins.str] = None,
        vertical_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param horizontal: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        :param horizontal_var: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        :param vertical: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        :param vertical_var: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__75116d6d301afd7ddd99e3af0e9bc3a7d1e5302624ff600648bafb4aef796e3e)
            check_type(argname="argument horizontal", value=horizontal, expected_type=type_hints["horizontal"])
            check_type(argname="argument horizontal_var", value=horizontal_var, expected_type=type_hints["horizontal_var"])
            check_type(argname="argument vertical", value=vertical, expected_type=type_hints["vertical"])
            check_type(argname="argument vertical_var", value=vertical_var, expected_type=type_hints["vertical_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if horizontal is not None:
            self._values["horizontal"] = horizontal
        if horizontal_var is not None:
            self._values["horizontal_var"] = horizontal_var
        if vertical is not None:
            self._values["vertical"] = vertical
        if vertical_var is not None:
            self._values["vertical_var"] = vertical_var

    @builtins.property
    def horizontal(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        '''
        result = self._values.get("horizontal")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def horizontal_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        '''
        result = self._values.get("horizontal_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        '''
        result = self._values.get("vertical")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        result = self._values.get("vertical_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultMirror(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultMirrorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultMirrorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3e66b9e3ef4ac01288bce7cf42e7c75738aa3e694ac527745fb7b6224c5c03bc)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultMirrorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3d5d1e4084b2dfe84415d7adaf609fc5c016392d951193bde895fc91b23095e2)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultMirrorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0fb1c693ff6e9c6b51c44e61c61fbc036a66573891f7e24aaa02bd20e80f8673)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2e5e45552c5323aea9ba72cf2fc71c52f8405880f8b8a0026b00432f7415e29c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6798a5b0d7f99d82955ec219a48c107dba693968c558ae6c940f997937dc58e5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultMirror]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultMirror]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e5536615beb377c990c4dafccda6967ee6fe35fd9ab926f406d5aa3206e63d93)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultMirrorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultMirrorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__63d9670550030544bf289052b93a3a457508eb46e21732311393680dbed02eb0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHorizontal")
    def reset_horizontal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontal", []))

    @jsii.member(jsii_name="resetHorizontalVar")
    def reset_horizontal_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontalVar", []))

    @jsii.member(jsii_name="resetVertical")
    def reset_vertical(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVertical", []))

    @jsii.member(jsii_name="resetVerticalVar")
    def reset_vertical_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVerticalVar", []))

    @builtins.property
    @jsii.member(jsii_name="horizontalInput")
    def horizontal_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontalVarInput")
    def horizontal_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalInput")
    def vertical_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalVarInput")
    def vertical_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontal")
    def horizontal(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontal"))

    @horizontal.setter
    def horizontal(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__34f42c84fe5e9f75f4efb8d24fd8d35429ced5895d3cd9bb092b70f9dae9e8b6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontal", value)

    @builtins.property
    @jsii.member(jsii_name="horizontalVar")
    def horizontal_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontalVar"))

    @horizontal_var.setter
    def horizontal_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dcb71e62b71b55fe91fe0c124fcbfd14f78cf8fd52e22a38980ca43d6cccc230)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontalVar", value)

    @builtins.property
    @jsii.member(jsii_name="vertical")
    def vertical(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "vertical"))

    @vertical.setter
    def vertical(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__07c435ff554bcf6ddf7613241f02356764bb0feeb7e121526d8802faaea9923c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "vertical", value)

    @builtins.property
    @jsii.member(jsii_name="verticalVar")
    def vertical_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "verticalVar"))

    @vertical_var.setter
    def vertical_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__07743a0c5d7d18cf96f957caa876109b3449365f3011fe8724c0a768f75e0028)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "verticalVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultMirror]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultMirror]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultMirror]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__328ef7123de3c325dd71b86ca387924b47d2198994e41d7890e0a08bffb365d5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultMonoHue",
    jsii_struct_bases=[],
    name_mapping={"hue": "hue", "hue_var": "hueVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultMonoHue:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__039c00127d0f683046c26a192ffef1d16605f817dcdad3c2f7b5b36bb0b3362e)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultMonoHue(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultMonoHueList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultMonoHueList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aefe183ade04fabd58dee11a6d907bbfed8799bf48b5452b5d48cf4f3a2dcf5c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultMonoHueOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__32fbf0718e0be23d38b8102ec5a5b1df577aa822056f68ae40645f0661d14442)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultMonoHueOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__653d88ea07809f03f1d1bb1de667936328481331c28d67c41ff4e1b018572e10)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__17f08207c7253f67ce3dec0e5ef78bb490c65e5b8a1a240314f8f61f8cd02837)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1e95ac5ce5a56d9cdf4121e8e2ba746c5470bb234bade8dd74a66b3dd0735325)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultMonoHue]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultMonoHue]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__907178ac1de75060076f62b6a661a9d00adf0121a05334cd4dbf9d6a19251a27)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultMonoHueOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultMonoHueOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1369521879bab9970ae988b490cea9a463bbab6c051d3dd17bf8ac6917d406ae)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab28b25d83070fe76175eefd00217bec0cbf01757bd3089e0cd3f7efc55b1d18)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dd8fb9f726ead3b0b8383ffdc12531c67aecdc16535f73b4ca204ddbbc7c7a83)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultMonoHue]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultMonoHue]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultMonoHue]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2628ec49e13e8c53770f16973cb6a816800987ea168b1a94d6256b3e4be4ac6f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultOpacity",
    jsii_struct_bases=[],
    name_mapping={"opacity": "opacity", "opacity_var": "opacityVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultOpacity:
    def __init__(
        self,
        *,
        opacity: typing.Optional[builtins.str] = None,
        opacity_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param opacity: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param opacity_var: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__50a439631a2b40d6e1ff74db594540d98592d81f8bff241691ac99047f7f8622)
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument opacity_var", value=opacity_var, expected_type=type_hints["opacity_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if opacity is not None:
            self._values["opacity"] = opacity
        if opacity_var is not None:
            self._values["opacity_var"] = opacity_var

    @builtins.property
    def opacity(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def opacity_var(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        result = self._values.get("opacity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultOpacity(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultOpacityList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultOpacityList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ca8aa0d2f21874612f128c79146d3b10b74a31625d7e86857536792d091974b1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultOpacityOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__57a613bafd38719e6bcd1dbff4b575d2a9989c2ea30dddd1bda2a6d815e2f4e3)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultOpacityOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__69f8a69c6ba1bd829bb99d4a8b6a4032edf3112a273f6785248d42ae4d2df488)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a738bc976ec27ff4d01a31c800260a62bdc5fe171e808018d4d193a9d63affd7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0b5477ff00d072927aecb4c6d860aa40ebc3d93af0e437ae918d9c6d2f13cb0c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultOpacity]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultOpacity]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cca502364d0b15fdf623993b20860bac56757e2fac4dd1269162322e670673d9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultOpacityOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultOpacityOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f4f387aaeb17a9b6626dde4892d0a2a2f8e787ff691ac095950abe75a7c52e7b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetOpacityVar")
    def reset_opacity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacityVar", []))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityVarInput")
    def opacity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacity"))

    @opacity.setter
    def opacity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5af88eef4dc6e34cb1fe673792906df49e88ea0eb03ae1bafa5db8bf746ec782)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacity", value)

    @builtins.property
    @jsii.member(jsii_name="opacityVar")
    def opacity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacityVar"))

    @opacity_var.setter
    def opacity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b8a5132bc9ab3c099f44c794afa45363e2d312ecefb0473b24b5bfdfef51ac89)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacityVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultOpacity]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultOpacity]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultOpacity]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e48f0dce20cae68e2329179ff6ebf58a4f4a5be7c5c67636525ce68784f72824)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f2c09f0233f6fc59132c6455bdebc5d3b5060fe193dba6d019ab5c4b3a7aa4b8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putBackgroundColor")
    def put_background_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eb8e4e25a4785252e8d9c0aae9600fff8b6b834688ba750a687a675d6ab585e0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBackgroundColor", [value]))

    @jsii.member(jsii_name="putBlur")
    def put_blur(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultBlur, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4865604a324e23852173c5390bd1650fb4ffdbf23b56efc8d3d08e86bfc43cfb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBlur", [value]))

    @jsii.member(jsii_name="putChromaKey")
    def put_chroma_key(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultChromaKey, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3295473571dbe2a4b3390cd934e7aaab089a0568b3a788fc5ed35582b54971ea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putChromaKey", [value]))

    @jsii.member(jsii_name="putComposite")
    def put_composite(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultComposite, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d2bc9264382937249b530931c3bec5463b65f2194f6782a5f28de20b0a1d9bf0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putComposite", [value]))

    @jsii.member(jsii_name="putCompound")
    def put_compound(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultCompound, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e33aafeee63a848356161c806e4d68a93a28b85318c2db672a650578eef62f0a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCompound", [value]))

    @jsii.member(jsii_name="putContrast")
    def put_contrast(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultContrast, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__22dc9076e542ded790afa2c234540616253d23531e5bbb63beabd0d2438ad58f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putContrast", [value]))

    @jsii.member(jsii_name="putGoop")
    def put_goop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultGoop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a2eb70c2b3ad8b80e82ab2a15950e9b91ea94509d1b8d11aeb7b217f610fe89)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGoop", [value]))

    @jsii.member(jsii_name="putGrayscale")
    def put_grayscale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultGrayscale, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__585131bdb6f3b64132715162ae25fe5671e290c7f597c62a970209774236cdf4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGrayscale", [value]))

    @jsii.member(jsii_name="putHsl")
    def put_hsl(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultHsl, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3e690dc7f1daf743ac07cd23d3213a2ea74d12fff15281bac14f2983046cfe22)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsl", [value]))

    @jsii.member(jsii_name="putHsv")
    def put_hsv(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultHsv, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7e5a39503e06cc0beaee62fe2258aec507f4939038e3d0d076512d3c572b2c06)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsv", [value]))

    @jsii.member(jsii_name="putIfDimension")
    def put_if_dimension(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfDimension, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__41bf0e19497d2a131f97f905d2b748739274224fa46e3ad7fd1d94badbdce879)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfDimension", [value]))

    @jsii.member(jsii_name="putIfOrientation")
    def put_if_orientation(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1883ef2df24396e02172838582558c665b24e0360f578895f0a6baa7ea86606b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfOrientation", [value]))

    @jsii.member(jsii_name="putMaxColors")
    def put_max_colors(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultMaxColors, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0b09cd609677bada9dda946dba9fcecf2ddef4f31e9ac0a57772c317620c9267)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMaxColors", [value]))

    @jsii.member(jsii_name="putMirror")
    def put_mirror(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultMirror, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eb2d184c2dd4e7543ed76f3f34a07be2a6759f1cc3f047f0ffa5ca8d380ac271)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMirror", [value]))

    @jsii.member(jsii_name="putMonoHue")
    def put_mono_hue(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultMonoHue, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d179c195c2efc9b115eed9f7d082f3a82cf0726556070cc2d949085078ab0e1d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMonoHue", [value]))

    @jsii.member(jsii_name="putOpacity")
    def put_opacity(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultOpacity, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a5260c90227368caba51b6394077d6bcd9c548c8374488e1d10762adbb571b6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putOpacity", [value]))

    @jsii.member(jsii_name="putRemoveColor")
    def put_remove_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultRemoveColor", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6ca89776094ac7a4a5272ac26586475c1708e3e04e11b205a4e149976163030a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRemoveColor", [value]))

    @jsii.member(jsii_name="putUnsharpMask")
    def put_unsharp_mask(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultUnsharpMask", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__97d9bcd26e2e67c26b238ae5388d7214894b296046804613050bef07478c1ea9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putUnsharpMask", [value]))

    @jsii.member(jsii_name="resetBackgroundColor")
    def reset_background_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBackgroundColor", []))

    @jsii.member(jsii_name="resetBlur")
    def reset_blur(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBlur", []))

    @jsii.member(jsii_name="resetChromaKey")
    def reset_chroma_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChromaKey", []))

    @jsii.member(jsii_name="resetComposite")
    def reset_composite(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetComposite", []))

    @jsii.member(jsii_name="resetCompound")
    def reset_compound(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCompound", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetGoop")
    def reset_goop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGoop", []))

    @jsii.member(jsii_name="resetGrayscale")
    def reset_grayscale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGrayscale", []))

    @jsii.member(jsii_name="resetHsl")
    def reset_hsl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsl", []))

    @jsii.member(jsii_name="resetHsv")
    def reset_hsv(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsv", []))

    @jsii.member(jsii_name="resetIfDimension")
    def reset_if_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfDimension", []))

    @jsii.member(jsii_name="resetIfOrientation")
    def reset_if_orientation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfOrientation", []))

    @jsii.member(jsii_name="resetMaxColors")
    def reset_max_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxColors", []))

    @jsii.member(jsii_name="resetMirror")
    def reset_mirror(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMirror", []))

    @jsii.member(jsii_name="resetMonoHue")
    def reset_mono_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonoHue", []))

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetRemoveColor")
    def reset_remove_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRemoveColor", []))

    @jsii.member(jsii_name="resetUnsharpMask")
    def reset_unsharp_mask(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUnsharpMask", []))

    @builtins.property
    @jsii.member(jsii_name="backgroundColor")
    def background_color(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultBackgroundColorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultBackgroundColorList, jsii.get(self, "backgroundColor"))

    @builtins.property
    @jsii.member(jsii_name="blur")
    def blur(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultBlurList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultBlurList, jsii.get(self, "blur"))

    @builtins.property
    @jsii.member(jsii_name="chromaKey")
    def chroma_key(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultChromaKeyList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultChromaKeyList, jsii.get(self, "chromaKey"))

    @builtins.property
    @jsii.member(jsii_name="composite")
    def composite(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultCompositeList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultCompositeList, jsii.get(self, "composite"))

    @builtins.property
    @jsii.member(jsii_name="compound")
    def compound(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultCompoundList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultCompoundList, jsii.get(self, "compound"))

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultContrastList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultContrastList, jsii.get(self, "contrast"))

    @builtins.property
    @jsii.member(jsii_name="goop")
    def goop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultGoopList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultGoopList, jsii.get(self, "goop"))

    @builtins.property
    @jsii.member(jsii_name="grayscale")
    def grayscale(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultGrayscaleList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultGrayscaleList, jsii.get(self, "grayscale"))

    @builtins.property
    @jsii.member(jsii_name="hsl")
    def hsl(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultHslList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultHslList, jsii.get(self, "hsl"))

    @builtins.property
    @jsii.member(jsii_name="hsv")
    def hsv(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultHsvList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultHsvList, jsii.get(self, "hsv"))

    @builtins.property
    @jsii.member(jsii_name="ifDimension")
    def if_dimension(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionList, jsii.get(self, "ifDimension"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientation")
    def if_orientation(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationList, jsii.get(self, "ifOrientation"))

    @builtins.property
    @jsii.member(jsii_name="maxColors")
    def max_colors(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultMaxColorsList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultMaxColorsList, jsii.get(self, "maxColors"))

    @builtins.property
    @jsii.member(jsii_name="mirror")
    def mirror(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultMirrorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultMirrorList, jsii.get(self, "mirror"))

    @builtins.property
    @jsii.member(jsii_name="monoHue")
    def mono_hue(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultMonoHueList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultMonoHueList, jsii.get(self, "monoHue"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultOpacityList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultOpacityList, jsii.get(self, "opacity"))

    @builtins.property
    @jsii.member(jsii_name="removeColor")
    def remove_color(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultRemoveColorList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultRemoveColorList", jsii.get(self, "removeColor"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMask")
    def unsharp_mask(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultUnsharpMaskList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultUnsharpMaskList", jsii.get(self, "unsharpMask"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColorInput")
    def background_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultBackgroundColor]]], jsii.get(self, "backgroundColorInput"))

    @builtins.property
    @jsii.member(jsii_name="blurInput")
    def blur_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultBlur]]], jsii.get(self, "blurInput"))

    @builtins.property
    @jsii.member(jsii_name="chromaKeyInput")
    def chroma_key_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultChromaKey]]], jsii.get(self, "chromaKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="compositeInput")
    def composite_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultComposite]]], jsii.get(self, "compositeInput"))

    @builtins.property
    @jsii.member(jsii_name="compoundInput")
    def compound_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultCompound]]], jsii.get(self, "compoundInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultContrast]]], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="goopInput")
    def goop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultGoop]]], jsii.get(self, "goopInput"))

    @builtins.property
    @jsii.member(jsii_name="grayscaleInput")
    def grayscale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultGrayscale]]], jsii.get(self, "grayscaleInput"))

    @builtins.property
    @jsii.member(jsii_name="hslInput")
    def hsl_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultHsl]]], jsii.get(self, "hslInput"))

    @builtins.property
    @jsii.member(jsii_name="hsvInput")
    def hsv_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultHsv]]], jsii.get(self, "hsvInput"))

    @builtins.property
    @jsii.member(jsii_name="ifDimensionInput")
    def if_dimension_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfDimension]]], jsii.get(self, "ifDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientationInput")
    def if_orientation_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfOrientation]]], jsii.get(self, "ifOrientationInput"))

    @builtins.property
    @jsii.member(jsii_name="maxColorsInput")
    def max_colors_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultMaxColors]]], jsii.get(self, "maxColorsInput"))

    @builtins.property
    @jsii.member(jsii_name="mirrorInput")
    def mirror_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultMirror]]], jsii.get(self, "mirrorInput"))

    @builtins.property
    @jsii.member(jsii_name="monoHueInput")
    def mono_hue_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultMonoHue]]], jsii.get(self, "monoHueInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultOpacity]]], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="removeColorInput")
    def remove_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultRemoveColor"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultRemoveColor"]]], jsii.get(self, "removeColorInput"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMaskInput")
    def unsharp_mask_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultUnsharpMask"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultUnsharpMask"]]], jsii.get(self, "unsharpMaskInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f420f12e655519df989be93c613517eaa79c7673fe433bd01e488dcc85f83f1b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultRemoveColor",
    jsii_struct_bases=[],
    name_mapping={
        "color": "color",
        "color_var": "colorVar",
        "feather": "feather",
        "feather_var": "featherVar",
        "tolerance": "tolerance",
        "tolerance_var": "toleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultRemoveColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
        feather: typing.Optional[builtins.str] = None,
        feather_var: typing.Optional[builtins.str] = None,
        tolerance: typing.Optional[builtins.str] = None,
        tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        :param feather: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        :param feather_var: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        :param tolerance: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        :param tolerance_var: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__21776875919ccdee7b050012cba5aadb09d790746d5928f19eaacaac01586754)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
            check_type(argname="argument feather", value=feather, expected_type=type_hints["feather"])
            check_type(argname="argument feather_var", value=feather_var, expected_type=type_hints["feather_var"])
            check_type(argname="argument tolerance", value=tolerance, expected_type=type_hints["tolerance"])
            check_type(argname="argument tolerance_var", value=tolerance_var, expected_type=type_hints["tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var
        if feather is not None:
            self._values["feather"] = feather
        if feather_var is not None:
            self._values["feather_var"] = feather_var
        if tolerance is not None:
            self._values["tolerance"] = tolerance
        if tolerance_var is not None:
            self._values["tolerance_var"] = tolerance_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        '''
        result = self._values.get("feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather_var(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        '''
        result = self._values.get("feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        '''
        result = self._values.get("tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance_var(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        result = self._values.get("tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultRemoveColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultRemoveColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultRemoveColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b3869ea777484730c11e7f8bfdb12dc2a695dbe60fcd6381cb3101b3bf6ad6a2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultRemoveColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c6f49d6029ed18b688178be5baddd60791d365ca55d0ca288486bf99d22be7b6)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultRemoveColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__362d349f28ba913b168b5cea39880f97d07b1b47e631a2c135fb08b0959f404a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a8f58855468d5cda71e2169b27c89ca06d31a296cacdad588de00febbfe67bff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__13c3b0497a6b0e6b1296ff8ffe65b54db9d69d5985c7f54c8ab57f7cf358e318)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultRemoveColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultRemoveColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultRemoveColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__46125aa7924d84e456301a5d31ed702b5d3d12abaa92dd8e731419da66053c54)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultRemoveColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultRemoveColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8225e465f6131834bfbefa626c3351ae5702b78c987fdb480e146f32afa05b6e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @jsii.member(jsii_name="resetFeather")
    def reset_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeather", []))

    @jsii.member(jsii_name="resetFeatherVar")
    def reset_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatherVar", []))

    @jsii.member(jsii_name="resetTolerance")
    def reset_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTolerance", []))

    @jsii.member(jsii_name="resetToleranceVar")
    def reset_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featherInput")
    def feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherInput"))

    @builtins.property
    @jsii.member(jsii_name="featherVarInput")
    def feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceInput")
    def tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceVarInput")
    def tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bffbb1d126490e32da51c191e7b92eecac530a33ba802e77f8bb5636c05d4257)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a99a2a042c7b0b13e70531f891c101661265bae63c3c5fe2cb547ac774865a98)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="feather")
    def feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "feather"))

    @feather.setter
    def feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__029d04d8ed6e95010529832ea9b9824d1d2064a194139243ea4ec6b872db20bb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "feather", value)

    @builtins.property
    @jsii.member(jsii_name="featherVar")
    def feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featherVar"))

    @feather_var.setter
    def feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__973372b4f2b394fae285240c238eac65caed92b451d5042dc08434e2f5079f37)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featherVar", value)

    @builtins.property
    @jsii.member(jsii_name="tolerance")
    def tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tolerance"))

    @tolerance.setter
    def tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__51510fc625847a0a713b5a052aae8f11e649a55d66ddc65b42c81e4a76e9991a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tolerance", value)

    @builtins.property
    @jsii.member(jsii_name="toleranceVar")
    def tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "toleranceVar"))

    @tolerance_var.setter
    def tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a84708c06eff4b9f59f57c58f9bfbaec837b4aae9872c03375003c0ae67cffa8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "toleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultRemoveColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultRemoveColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultRemoveColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a8a2c090bc203179d7a574930c49fb994cd83513cb3ea7ba3094a3449ee77ea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultUnsharpMask",
    jsii_struct_bases=[],
    name_mapping={
        "gain": "gain",
        "gain_var": "gainVar",
        "sigma": "sigma",
        "sigma_var": "sigmaVar",
        "threshold": "threshold",
        "threshold_var": "thresholdVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultUnsharpMask:
    def __init__(
        self,
        *,
        gain: typing.Optional[builtins.str] = None,
        gain_var: typing.Optional[builtins.str] = None,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
        threshold: typing.Optional[builtins.str] = None,
        threshold_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param gain: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        :param gain_var: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        :param sigma: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        :param threshold: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        :param threshold_var: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f711a4a1455059964f6aebe1a738c48fb7354579c63dac7d186ae5250fc8a4b6)
            check_type(argname="argument gain", value=gain, expected_type=type_hints["gain"])
            check_type(argname="argument gain_var", value=gain_var, expected_type=type_hints["gain_var"])
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
            check_type(argname="argument threshold", value=threshold, expected_type=type_hints["threshold"])
            check_type(argname="argument threshold_var", value=threshold_var, expected_type=type_hints["threshold_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if gain is not None:
            self._values["gain"] = gain
        if gain_var is not None:
            self._values["gain_var"] = gain_var
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var
        if threshold is not None:
            self._values["threshold"] = threshold
        if threshold_var is not None:
            self._values["threshold_var"] = threshold_var

    @builtins.property
    def gain(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        '''
        result = self._values.get("gain")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gain_var(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        '''
        result = self._values.get("gain_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        '''
        result = self._values.get("threshold")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold_var(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        result = self._values.get("threshold_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultUnsharpMask(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultUnsharpMaskList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultUnsharpMaskList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d4aad8c340251f6cd3c9c070a1b448f1afc978130d001752ad5eb6527830b69a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultUnsharpMaskOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e4bac021aeffc90a015f8327dce35a006be6ed31566405f5bb199720b410e5ad)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultUnsharpMaskOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5956f3793ace44533e078e805d6191a6ca85ec6b2f1bc9db9a86aacd7d2a86d8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3f6e95d28fedd595fe7a1a59a7fe9c2801debd9f2ef055722cf1c1b9798ec356)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b4a3edec0d341d59ff478674a9689cc54e21977a8fa3f9395b37083c04a47d2d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultUnsharpMask]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultUnsharpMask]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultUnsharpMask]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__07eae9c352762e5d447c8eb76d2b3ff6b9bd6c673a2e0604bd4139f519649342)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultUnsharpMaskOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultUnsharpMaskOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c1bd56ece0a74e6b5d1fcc4671d8ef232816b6cc77cec479854cd51a77a67789)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetGain")
    def reset_gain(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGain", []))

    @jsii.member(jsii_name="resetGainVar")
    def reset_gain_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGainVar", []))

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @jsii.member(jsii_name="resetThreshold")
    def reset_threshold(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThreshold", []))

    @jsii.member(jsii_name="resetThresholdVar")
    def reset_threshold_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThresholdVar", []))

    @builtins.property
    @jsii.member(jsii_name="gainInput")
    def gain_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainInput"))

    @builtins.property
    @jsii.member(jsii_name="gainVarInput")
    def gain_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdInput")
    def threshold_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdVarInput")
    def threshold_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gain")
    def gain(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gain"))

    @gain.setter
    def gain(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__faf19e41c436a370d8be76b00638d2b9f471c759b85b61976b3fb77096010305)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gain", value)

    @builtins.property
    @jsii.member(jsii_name="gainVar")
    def gain_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gainVar"))

    @gain_var.setter
    def gain_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c67557bbdae152523ee474a0b73635e4c1b61744aa4d7893be1d547f722ef947)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gainVar", value)

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__88d23b3e253c7078979843b25844a093d2b1afcc94cbcd827d57491930a0c0c2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5c00e71600bc231371b9ff0b19094113161776caf3904cf2baa749ac716695a7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="threshold")
    def threshold(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "threshold"))

    @threshold.setter
    def threshold(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f74014ddfe9045079c28b23a58e5cd72dae08619f6054430514c1ae2029b8a3c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "threshold", value)

    @builtins.property
    @jsii.member(jsii_name="thresholdVar")
    def threshold_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "thresholdVar"))

    @threshold_var.setter
    def threshold_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fd106b37702151e3288ff2c65ddc168dd36e9caf1e4ec59688149ccf3195b1e6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "thresholdVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultUnsharpMask]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultUnsharpMask]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultUnsharpMask]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__81cb84d4cd2ece2239f3cfc579bc2e06633cc5940d165964539bf5af3722f689)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscape",
    jsii_struct_bases=[],
    name_mapping={
        "background_color": "backgroundColor",
        "blur": "blur",
        "chroma_key": "chromaKey",
        "composite": "composite",
        "compound": "compound",
        "contrast": "contrast",
        "goop": "goop",
        "grayscale": "grayscale",
        "hsl": "hsl",
        "hsv": "hsv",
        "if_dimension": "ifDimension",
        "if_orientation": "ifOrientation",
        "max_colors": "maxColors",
        "mirror": "mirror",
        "mono_hue": "monoHue",
        "opacity": "opacity",
        "remove_color": "removeColor",
        "unsharp_mask": "unsharpMask",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscape:
    def __init__(
        self,
        *,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeBackgroundColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeBlur", typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeChromaKey", typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeComposite", typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeCompound", typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeContrast", typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeGoop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeGrayscale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeHsl", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeHsv", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfDimension", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientation", typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeMaxColors", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeMirror", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeMonoHue", typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeOpacity", typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeRemoveColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeUnsharpMask", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__72c249f41687406e5efdcfc822fe4071db10580ba9e95a4d206b192f78579061)
            check_type(argname="argument background_color", value=background_color, expected_type=type_hints["background_color"])
            check_type(argname="argument blur", value=blur, expected_type=type_hints["blur"])
            check_type(argname="argument chroma_key", value=chroma_key, expected_type=type_hints["chroma_key"])
            check_type(argname="argument composite", value=composite, expected_type=type_hints["composite"])
            check_type(argname="argument compound", value=compound, expected_type=type_hints["compound"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument goop", value=goop, expected_type=type_hints["goop"])
            check_type(argname="argument grayscale", value=grayscale, expected_type=type_hints["grayscale"])
            check_type(argname="argument hsl", value=hsl, expected_type=type_hints["hsl"])
            check_type(argname="argument hsv", value=hsv, expected_type=type_hints["hsv"])
            check_type(argname="argument if_dimension", value=if_dimension, expected_type=type_hints["if_dimension"])
            check_type(argname="argument if_orientation", value=if_orientation, expected_type=type_hints["if_orientation"])
            check_type(argname="argument max_colors", value=max_colors, expected_type=type_hints["max_colors"])
            check_type(argname="argument mirror", value=mirror, expected_type=type_hints["mirror"])
            check_type(argname="argument mono_hue", value=mono_hue, expected_type=type_hints["mono_hue"])
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument remove_color", value=remove_color, expected_type=type_hints["remove_color"])
            check_type(argname="argument unsharp_mask", value=unsharp_mask, expected_type=type_hints["unsharp_mask"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if background_color is not None:
            self._values["background_color"] = background_color
        if blur is not None:
            self._values["blur"] = blur
        if chroma_key is not None:
            self._values["chroma_key"] = chroma_key
        if composite is not None:
            self._values["composite"] = composite
        if compound is not None:
            self._values["compound"] = compound
        if contrast is not None:
            self._values["contrast"] = contrast
        if goop is not None:
            self._values["goop"] = goop
        if grayscale is not None:
            self._values["grayscale"] = grayscale
        if hsl is not None:
            self._values["hsl"] = hsl
        if hsv is not None:
            self._values["hsv"] = hsv
        if if_dimension is not None:
            self._values["if_dimension"] = if_dimension
        if if_orientation is not None:
            self._values["if_orientation"] = if_orientation
        if max_colors is not None:
            self._values["max_colors"] = max_colors
        if mirror is not None:
            self._values["mirror"] = mirror
        if mono_hue is not None:
            self._values["mono_hue"] = mono_hue
        if opacity is not None:
            self._values["opacity"] = opacity
        if remove_color is not None:
            self._values["remove_color"] = remove_color
        if unsharp_mask is not None:
            self._values["unsharp_mask"] = unsharp_mask

    @builtins.property
    def background_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeBackgroundColor"]]]:
        '''background_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        '''
        result = self._values.get("background_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeBackgroundColor"]]], result)

    @builtins.property
    def blur(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeBlur"]]]:
        '''blur block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        '''
        result = self._values.get("blur")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeBlur"]]], result)

    @builtins.property
    def chroma_key(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeChromaKey"]]]:
        '''chroma_key block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        '''
        result = self._values.get("chroma_key")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeChromaKey"]]], result)

    @builtins.property
    def composite(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeComposite"]]]:
        '''composite block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        '''
        result = self._values.get("composite")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeComposite"]]], result)

    @builtins.property
    def compound(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeCompound"]]]:
        '''compound block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        '''
        result = self._values.get("compound")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeCompound"]]], result)

    @builtins.property
    def contrast(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeContrast"]]]:
        '''contrast block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeContrast"]]], result)

    @builtins.property
    def goop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeGoop"]]]:
        '''goop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        '''
        result = self._values.get("goop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeGoop"]]], result)

    @builtins.property
    def grayscale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeGrayscale"]]]:
        '''grayscale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        '''
        result = self._values.get("grayscale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeGrayscale"]]], result)

    @builtins.property
    def hsl(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeHsl"]]]:
        '''hsl block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        '''
        result = self._values.get("hsl")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeHsl"]]], result)

    @builtins.property
    def hsv(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeHsv"]]]:
        '''hsv block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        '''
        result = self._values.get("hsv")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeHsv"]]], result)

    @builtins.property
    def if_dimension(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfDimension"]]]:
        '''if_dimension block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        '''
        result = self._values.get("if_dimension")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfDimension"]]], result)

    @builtins.property
    def if_orientation(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientation"]]]:
        '''if_orientation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        '''
        result = self._values.get("if_orientation")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientation"]]], result)

    @builtins.property
    def max_colors(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeMaxColors"]]]:
        '''max_colors block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        '''
        result = self._values.get("max_colors")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeMaxColors"]]], result)

    @builtins.property
    def mirror(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeMirror"]]]:
        '''mirror block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        '''
        result = self._values.get("mirror")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeMirror"]]], result)

    @builtins.property
    def mono_hue(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeMonoHue"]]]:
        '''mono_hue block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        '''
        result = self._values.get("mono_hue")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeMonoHue"]]], result)

    @builtins.property
    def opacity(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeOpacity"]]]:
        '''opacity block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeOpacity"]]], result)

    @builtins.property
    def remove_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeRemoveColor"]]]:
        '''remove_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        '''
        result = self._values.get("remove_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeRemoveColor"]]], result)

    @builtins.property
    def unsharp_mask(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeUnsharpMask"]]]:
        '''unsharp_mask block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        result = self._values.get("unsharp_mask")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeUnsharpMask"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscape(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeBackgroundColor",
    jsii_struct_bases=[],
    name_mapping={"color": "color", "color_var": "colorVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeBackgroundColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__261c8359ecb3e8a83afb54077cb2b957517e0ade4e588549fcf1d8c5337ded48)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeBackgroundColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeBackgroundColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeBackgroundColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__05528d4585fec2883c35385b4525fad5cce19f55276edcfcaeb4a44ba2066a5b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeBackgroundColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7b7b5decfb10dfcc040984ccb28ef5fd8f22fbd372e0aa4378bdd09d6bbdf28e)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeBackgroundColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3e1a760145d7fd3e10f363b8fb5fcd4cff0247342b8c1b836c55b8e37239c148)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__abf5d815e7f0eb619d071e82063e62586f03540d172c051868a53085068efc59)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cf073719a8ad08a8c5d35a8a02a9b2baa138db18f007167b2b63d21b46206776)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeBackgroundColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeBackgroundColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__323e1355f62384b9d548363d96f6bf6c29835a5f55d7fb7822e8770cb0bbe80b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeBackgroundColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeBackgroundColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4aab99bdd08cc7985954a75d335e87407c1b53addf0c4d78792ee96b4e3c69c8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa46012804b340194c4a0a977ee0aa8e480a1f80fe608f537a2dc7254bcf141d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e5bd8404279ef9e773edb924e2dd88ab15cc12f53bf9aba159f09d6476b28ac0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeBackgroundColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeBackgroundColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeBackgroundColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__17ff8e88f05885cf98af430de3e6fd38ecc3a27c12803565ea156dc42fe4dea6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeBlur",
    jsii_struct_bases=[],
    name_mapping={"sigma": "sigma", "sigma_var": "sigmaVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeBlur:
    def __init__(
        self,
        *,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param sigma: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f73f8dc9f2778d61eba4d36867acf5dfff929061908f7d933f9acadf74298348)
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeBlur(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeBlurList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeBlurList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3986a51ef9141c191b02460100c3e553fed6f67c3b458eeac986f591260c96ad)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeBlurOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__552aa6e087f95d1201009c533c5f0ccdf2f627eb7240c1b11cee54535bdaf2f0)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeBlurOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bdd5c8648b34b1c887ca7e7c11bebf0da31779a7657ab6722d481b3fe71e16d9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6498675d42a13fa06711cb34cfe73a4337f52e24a7f7ac7b401cf20d81c39ba9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__29d7ade66538965716b2f7f6493b0bafcbbfdb1834fc28896350a596d56d4f02)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeBlur]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeBlur]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ec65b03c3aab61e04b71afa866997460fdb25bc4883b06d26b92c11c0a1d1b4b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeBlurOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeBlurOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d578e34b60b644f5e44d289e9883304ef8e1ca27c6af2060a7128a584636dd29)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c528ce70e2ddba8fa9c912982d89d2d84220d705a9aa3927bd1ba01dde406b42)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f2ba3e4e6e0150135382c1d4976dd7df554eddf1b3d800bccc0ff8a2f3023037)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeBlur]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeBlur]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeBlur]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6c3f09830fc612637d2e6a7b566f80d11780aa28a4f4a1680cc0115ec411b2af)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeChromaKey",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_feather": "hueFeather",
        "hue_feather_var": "hueFeatherVar",
        "hue_tolerance": "hueTolerance",
        "hue_tolerance_var": "hueToleranceVar",
        "hue_var": "hueVar",
        "lightness_feather": "lightnessFeather",
        "lightness_feather_var": "lightnessFeatherVar",
        "lightness_tolerance": "lightnessTolerance",
        "lightness_tolerance_var": "lightnessToleranceVar",
        "saturation_feather": "saturationFeather",
        "saturation_feather_var": "saturationFeatherVar",
        "saturation_tolerance": "saturationTolerance",
        "saturation_tolerance_var": "saturationToleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeChromaKey:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_feather: typing.Optional[builtins.str] = None,
        hue_feather_var: typing.Optional[builtins.str] = None,
        hue_tolerance: typing.Optional[builtins.str] = None,
        hue_tolerance_var: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness_feather: typing.Optional[builtins.str] = None,
        lightness_feather_var: typing.Optional[builtins.str] = None,
        lightness_tolerance: typing.Optional[builtins.str] = None,
        lightness_tolerance_var: typing.Optional[builtins.str] = None,
        saturation_feather: typing.Optional[builtins.str] = None,
        saturation_feather_var: typing.Optional[builtins.str] = None,
        saturation_tolerance: typing.Optional[builtins.str] = None,
        saturation_tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_feather: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        :param hue_feather_var: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        :param hue_tolerance: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        :param hue_tolerance_var: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        :param hue_var: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness_feather: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        :param lightness_feather_var: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        :param lightness_tolerance: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        :param lightness_tolerance_var: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        :param saturation_feather: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        :param saturation_feather_var: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        :param saturation_tolerance: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        :param saturation_tolerance_var: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d93036c2014be6d0e952eca6752ff64274022e3f989ef346b746be6e03ba493a)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_feather", value=hue_feather, expected_type=type_hints["hue_feather"])
            check_type(argname="argument hue_feather_var", value=hue_feather_var, expected_type=type_hints["hue_feather_var"])
            check_type(argname="argument hue_tolerance", value=hue_tolerance, expected_type=type_hints["hue_tolerance"])
            check_type(argname="argument hue_tolerance_var", value=hue_tolerance_var, expected_type=type_hints["hue_tolerance_var"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness_feather", value=lightness_feather, expected_type=type_hints["lightness_feather"])
            check_type(argname="argument lightness_feather_var", value=lightness_feather_var, expected_type=type_hints["lightness_feather_var"])
            check_type(argname="argument lightness_tolerance", value=lightness_tolerance, expected_type=type_hints["lightness_tolerance"])
            check_type(argname="argument lightness_tolerance_var", value=lightness_tolerance_var, expected_type=type_hints["lightness_tolerance_var"])
            check_type(argname="argument saturation_feather", value=saturation_feather, expected_type=type_hints["saturation_feather"])
            check_type(argname="argument saturation_feather_var", value=saturation_feather_var, expected_type=type_hints["saturation_feather_var"])
            check_type(argname="argument saturation_tolerance", value=saturation_tolerance, expected_type=type_hints["saturation_tolerance"])
            check_type(argname="argument saturation_tolerance_var", value=saturation_tolerance_var, expected_type=type_hints["saturation_tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_feather is not None:
            self._values["hue_feather"] = hue_feather
        if hue_feather_var is not None:
            self._values["hue_feather_var"] = hue_feather_var
        if hue_tolerance is not None:
            self._values["hue_tolerance"] = hue_tolerance
        if hue_tolerance_var is not None:
            self._values["hue_tolerance_var"] = hue_tolerance_var
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness_feather is not None:
            self._values["lightness_feather"] = lightness_feather
        if lightness_feather_var is not None:
            self._values["lightness_feather_var"] = lightness_feather_var
        if lightness_tolerance is not None:
            self._values["lightness_tolerance"] = lightness_tolerance
        if lightness_tolerance_var is not None:
            self._values["lightness_tolerance_var"] = lightness_tolerance_var
        if saturation_feather is not None:
            self._values["saturation_feather"] = saturation_feather
        if saturation_feather_var is not None:
            self._values["saturation_feather_var"] = saturation_feather_var
        if saturation_tolerance is not None:
            self._values["saturation_tolerance"] = saturation_tolerance
        if saturation_tolerance_var is not None:
            self._values["saturation_tolerance_var"] = saturation_tolerance_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        '''
        result = self._values.get("hue_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        '''
        result = self._values.get("hue_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        '''
        result = self._values.get("hue_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        '''
        result = self._values.get("hue_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        '''
        result = self._values.get("lightness_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        '''
        result = self._values.get("lightness_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        '''
        result = self._values.get("lightness_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        '''
        result = self._values.get("lightness_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        '''
        result = self._values.get("saturation_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        '''
        result = self._values.get("saturation_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        '''
        result = self._values.get("saturation_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        result = self._values.get("saturation_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeChromaKey(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeChromaKeyList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeChromaKeyList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0f6a332f2ca169e02ab0aea68556f35f52e25a02caa720b9d2c08d6b38b3351f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeChromaKeyOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fd390d7c076c766d680219b4276207efe66c06c1e959f92dd601cd0c823f68df)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeChromaKeyOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f6347eca960571120423660dd617b328c3b668e77493a28cb61333c025a30297)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e7f7a55801eb041e838e52fa3cfd97e3f128ffa099e54a7acc4240444618350e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__869aced8a098dfbc814afc8a7a3ba900d6c46e4d65c19dcf494bc262f9ce5428)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeChromaKey]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeChromaKey]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c6e4b0c472c2e2ccba4a3620e78856a4256516a6ff76840624c587afc20313b1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeChromaKeyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeChromaKeyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7b9a69d200692d8249a1bdfc390978164ef3b8f589c4c802746cddc9c27062f6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueFeather")
    def reset_hue_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeather", []))

    @jsii.member(jsii_name="resetHueFeatherVar")
    def reset_hue_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeatherVar", []))

    @jsii.member(jsii_name="resetHueTolerance")
    def reset_hue_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueTolerance", []))

    @jsii.member(jsii_name="resetHueToleranceVar")
    def reset_hue_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueToleranceVar", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightnessFeather")
    def reset_lightness_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeather", []))

    @jsii.member(jsii_name="resetLightnessFeatherVar")
    def reset_lightness_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeatherVar", []))

    @jsii.member(jsii_name="resetLightnessTolerance")
    def reset_lightness_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessTolerance", []))

    @jsii.member(jsii_name="resetLightnessToleranceVar")
    def reset_lightness_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessToleranceVar", []))

    @jsii.member(jsii_name="resetSaturationFeather")
    def reset_saturation_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeather", []))

    @jsii.member(jsii_name="resetSaturationFeatherVar")
    def reset_saturation_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeatherVar", []))

    @jsii.member(jsii_name="resetSaturationTolerance")
    def reset_saturation_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationTolerance", []))

    @jsii.member(jsii_name="resetSaturationToleranceVar")
    def reset_saturation_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherInput")
    def hue_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVarInput")
    def hue_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceInput")
    def hue_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVarInput")
    def hue_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherInput")
    def lightness_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVarInput")
    def lightness_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceInput")
    def lightness_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVarInput")
    def lightness_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherInput")
    def saturation_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVarInput")
    def saturation_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceInput")
    def saturation_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVarInput")
    def saturation_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__861375a66d011209f60fb279df3d8c7fc73367d83182e9471dc629492c5b5315)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeather")
    def hue_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeather"))

    @hue_feather.setter
    def hue_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2369193494a7794101b74297de372d7825ca1a31b5e8eb9dfb16d7d470559b39)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeather", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVar")
    def hue_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeatherVar"))

    @hue_feather_var.setter
    def hue_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__376c82d35c1ed2614b94cbba3bf644ab5bdf4896c91f4a96560f77cb8df2a89f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueTolerance")
    def hue_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueTolerance"))

    @hue_tolerance.setter
    def hue_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__03529fb28961b4338807bf7c964def272fc0c43b10061a0a66ce930d574ca69b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVar")
    def hue_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueToleranceVar"))

    @hue_tolerance_var.setter
    def hue_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__48221721720aefa4a7578eddacfa142c59161f344dd02556a1037d91efbe3a81)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3e7c822683d7d80bea2a763313c9534ce1e5ecb403ec85bfef7f461f8ac272fa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeather")
    def lightness_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeather"))

    @lightness_feather.setter
    def lightness_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__221ffa40a47d13e928134322f26b45e670f03c24d54e45aa4a71ebb4e9b9f3ff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeather", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVar")
    def lightness_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeatherVar"))

    @lightness_feather_var.setter
    def lightness_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dac716361f3581ab23561bdd8b53f0cc15dcdb50909cebac9a48b0ea3fec0e61)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessTolerance")
    def lightness_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessTolerance"))

    @lightness_tolerance.setter
    def lightness_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c2992bf2f3a8703efa682e97179f243c381456a83614eb7ac5c749c23f027959)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVar")
    def lightness_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessToleranceVar"))

    @lightness_tolerance_var.setter
    def lightness_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__02f5bbb174267a44dd9d63c02bc96d8f921027850d74a37920975ba5fbce1196)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeather")
    def saturation_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeather"))

    @saturation_feather.setter
    def saturation_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__723a0e0b6ca990533fdbfd9c850506563355404d53cd34e45e27e52435bbf063)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeather", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVar")
    def saturation_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeatherVar"))

    @saturation_feather_var.setter
    def saturation_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fad148cc2f585143132c34e6248c74686fc88a4bdf4d9a6aa84e8fafb0d02cfd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationTolerance")
    def saturation_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationTolerance"))

    @saturation_tolerance.setter
    def saturation_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f5daa161b03d1b2bb1ebbf40c27389fcde17444251dd5725a68d385d8c3142b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVar")
    def saturation_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationToleranceVar"))

    @saturation_tolerance_var.setter
    def saturation_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__40e8b417dae01ad6c8ecbcbffc96d0f698ac593cb0fa540c238f9cac53638a44)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeChromaKey]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeChromaKey]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeChromaKey]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__980fe031d33e5d42bcf873157ec310285bb619e5c0d173cc07a4a58af225f24d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeComposite",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "placement": "placement",
        "placement_var": "placementVar",
        "scale": "scale",
        "scale_dimension": "scaleDimension",
        "scale_dimension_var": "scaleDimensionVar",
        "scale_var": "scaleVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeComposite:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeCompositeImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        placement: typing.Optional[builtins.str] = None,
        placement_var: typing.Optional[builtins.str] = None,
        scale: typing.Optional[builtins.str] = None,
        scale_dimension: typing.Optional[builtins.str] = None,
        scale_dimension_var: typing.Optional[builtins.str] = None,
        scale_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param placement: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        :param placement_var: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        :param scale: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param scale_dimension: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        :param scale_dimension_var: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        :param scale_var: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        :param x_position: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeCompositeImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cb3ad5b5a74e67a11318fc4b1e82b653acb37d6a6c18badbef9a9f73962b6f4a)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument placement", value=placement, expected_type=type_hints["placement"])
            check_type(argname="argument placement_var", value=placement_var, expected_type=type_hints["placement_var"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument scale_dimension", value=scale_dimension, expected_type=type_hints["scale_dimension"])
            check_type(argname="argument scale_dimension_var", value=scale_dimension_var, expected_type=type_hints["scale_dimension_var"])
            check_type(argname="argument scale_var", value=scale_var, expected_type=type_hints["scale_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if placement is not None:
            self._values["placement"] = placement
        if placement_var is not None:
            self._values["placement_var"] = placement_var
        if scale is not None:
            self._values["scale"] = scale
        if scale_dimension is not None:
            self._values["scale_dimension"] = scale_dimension
        if scale_dimension_var is not None:
            self._values["scale_dimension_var"] = scale_dimension_var
        if scale_var is not None:
            self._values["scale_var"] = scale_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeCompositeImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeCompositeImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        '''
        result = self._values.get("placement")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement_var(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        '''
        result = self._values.get("placement_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        '''
        result = self._values.get("scale_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        '''
        result = self._values.get("scale_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        '''
        result = self._values.get("scale_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeComposite(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeCompositeImage",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeCompositeImage:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeCompositeImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeCompositeImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeCompositeImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e286447ef32d0552602390f2ff1c2f123bf0afc1edd3fa445246a0312137b5a1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeCompositeImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeCompositeImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f98cfe4feb9678c85536f829281a6c40fd965f6326c97da150d96aadbe2d93ff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeCompositeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeCompositeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c1dcda11976dd4e8c8d17fc160452f52fadb654e60a062e14e93b641a8f5cb10)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeCompositeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a837547db0a6674606620a4db9c471330cabf07c63bf31e9f49155b9d7b25c4)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeCompositeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eab8834142552a988d85fee5a32f2d3cd067a11dc9d35d90107f04903be5d17c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__010776ca75840321c6e3398dd83e6b48e4ca5ded202fc788e187df2729b2878c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d9f4e40f1f8a5b504c504c1206288f64878fd7d0dc576c6af16b89b3a142402a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeComposite]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeComposite]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__272ba852269898ee05cf19cb3c6d8ea582b8a954a3dbb5e3d8938be4b55a2f63)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeCompositeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeCompositeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bd3890dbe291f8633bdc11c5c0eee07026161b1bf2c2de9ac00929313e6a67fd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeCompositeImage()

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPlacement")
    def reset_placement(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacement", []))

    @jsii.member(jsii_name="resetPlacementVar")
    def reset_placement_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacementVar", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetScaleDimension")
    def reset_scale_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimension", []))

    @jsii.member(jsii_name="resetScaleDimensionVar")
    def reset_scale_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimensionVar", []))

    @jsii.member(jsii_name="resetScaleVar")
    def reset_scale_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeCompositeImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeCompositeImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeCompositeImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="placementInput")
    def placement_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementInput"))

    @builtins.property
    @jsii.member(jsii_name="placementVarInput")
    def placement_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionInput")
    def scale_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVarInput")
    def scale_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleVarInput")
    def scale_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d4a2049bef9eb707a6f901c00840e9bacb229887d3d246fbd8ee497ebf79f972)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e08cc0385b797a6f3c445236494471123b1767540e50e0144deb91c1d0d52188)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="placement")
    def placement(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placement"))

    @placement.setter
    def placement(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__428c4d9341921f89c33db0be009770cddbb9d9b4d8e6ccc1569d70dbc0417944)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placement", value)

    @builtins.property
    @jsii.member(jsii_name="placementVar")
    def placement_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placementVar"))

    @placement_var.setter
    def placement_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a6ca0577122385f95a9ab9923aee090145ee2f6d10a356ebc10e60f577650140)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placementVar", value)

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scale"))

    @scale.setter
    def scale(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__63de7a64760b59849f1e59d1677747ed36ef77d50ca96e8c687c54dce2224b30)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scale", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimension")
    def scale_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimension"))

    @scale_dimension.setter
    def scale_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5a9fcaedf6402176ceaa84f98aa287bf3d54b8469792e86d0f62195922dc0ac2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimension", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVar")
    def scale_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimensionVar"))

    @scale_dimension_var.setter
    def scale_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ec2fdc9ca37def3219817e8c48a4336f4a49965152cea3778c3cd03a1ca6acf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="scaleVar")
    def scale_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleVar"))

    @scale_var.setter
    def scale_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ab1faa8cfbedef13269db6ff08403070609cd3ee0447483c9dcba9254c2558c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a59d23275e2af124695f29e6b23b2735198a50cde567d54d7e599f9e21965aa1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3c4763773b800fe4bbad01f932125ea831977661b6ec09a08d1e87e05e861dfc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__465a5a8e7733265421f32304577832136e8de028dee2bdfc4352b5dff68d926d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__55c3980ed1df494f6f7bfa2e11e241d6c674b7612d5c9fb2a5a3b2d39a5f02e6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeComposite]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeComposite]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeComposite]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__92d0075686c03e0b9235d38c438102cb8ee098ed613da7d1aa9b4df413d2c69c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeCompound",
    jsii_struct_bases=[],
    name_mapping={"transformations": "transformations"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeCompound:
    def __init__(
        self,
        *,
        transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param transformations: transformations block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5bcac5fc1e63f8c38b3afae72f5776e611e84214b689273da517012967028044)
            check_type(argname="argument transformations", value=transformations, expected_type=type_hints["transformations"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if transformations is not None:
            self._values["transformations"] = transformations

    @builtins.property
    def transformations(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeCompoundTransformations"]]]:
        '''transformations block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        result = self._values.get("transformations")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeCompoundTransformations"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeCompound(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeCompoundList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeCompoundList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__95511528dca0ded388fe5f404e1c8434106d991bf8181e14da5f8036807e8e3a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeCompoundOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__204ed1403c3371a33bc52b47e2d9b0d4e1efd342778e2bc7b68ec1237d40bd6e)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeCompoundOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0b4e5e8a1881e93de9547d668c9294b4bbb7d6be2aa108d27c6773ecfd066b43)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__85eba9358df58dfe1834d03676590f8d4aa4143073db69e1b239028f8f401dd5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d5554e4e7970894c7f59ddf7238ed4a422c05802cd8c9f21a7a26f093a82c765)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeCompound]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeCompound]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0a186e426f6f1d0d18ba4938274a785c28ba646ce296f36bc59d0bca092c09fb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeCompoundOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeCompoundOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ddbc9d3faefe90d5d83f9a7fc94a1a9d937821f418a5a650ce03068b0ea1208d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformations")
    def put_transformations(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d1778eb16187c682f0ede46439508dc05eecd1295eac78a2a86cdc0ee8c1a87c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTransformations", [value]))

    @jsii.member(jsii_name="resetTransformations")
    def reset_transformations(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformations", []))

    @builtins.property
    @jsii.member(jsii_name="transformations")
    def transformations(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeCompoundTransformationsList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeCompoundTransformationsList", jsii.get(self, "transformations"))

    @builtins.property
    @jsii.member(jsii_name="transformationsInput")
    def transformations_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeCompoundTransformations"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeCompoundTransformations"]]], jsii.get(self, "transformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeCompound]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeCompound]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeCompound]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4377a703a6e494bf4055203ffb770d95def445515491a5733f87173b2923048a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeCompoundTransformations",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeCompoundTransformations:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeCompoundTransformations(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeCompoundTransformationsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeCompoundTransformationsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c747740a13e9a61434de2d323a0f1b33cb025caec9a21b9ccbb535a012578990)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeCompoundTransformationsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3548819900991619589b6a839408a085e703229a2a9f61ead8822dcbf8ae268a)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeCompoundTransformationsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__11f76fbfb34290a01d2250411082d902d5988e2b6c1b1aed3805c475dcc9d9c6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bce884813842af16bd9b638b700c55f31319815f26777c8ace27459a785d8d5b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__69c71403dd4c2b59e3fd878478452e077f889431256c874c9df5206e1f89066c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeCompoundTransformations]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeCompoundTransformations]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeCompoundTransformations]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__51b70824c4f00bab7c96fc35d99670f851521b68b49467d1a465db0432cf5476)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeCompoundTransformationsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeCompoundTransformationsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a5d385905257838f3d579080b544477d497b974ab6bcb50db7d3da1f3a8c1354)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeCompoundTransformations]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeCompoundTransformations]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeCompoundTransformations]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__06a5d1f4ffdc5da4c618120fa87c8a06f6724086badfc72543f4671a3eec0dd4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeContrast",
    jsii_struct_bases=[],
    name_mapping={
        "brightness": "brightness",
        "brightness_var": "brightnessVar",
        "contrast": "contrast",
        "contrast_var": "contrastVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeContrast:
    def __init__(
        self,
        *,
        brightness: typing.Optional[builtins.str] = None,
        brightness_var: typing.Optional[builtins.str] = None,
        contrast: typing.Optional[builtins.str] = None,
        contrast_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param brightness: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        :param brightness_var: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        :param contrast: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param contrast_var: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f2310efe9af6265633bc79fcb5fb1498b8abf07d2fdfea0cdb04425dc90d3d10)
            check_type(argname="argument brightness", value=brightness, expected_type=type_hints["brightness"])
            check_type(argname="argument brightness_var", value=brightness_var, expected_type=type_hints["brightness_var"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument contrast_var", value=contrast_var, expected_type=type_hints["contrast_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if brightness is not None:
            self._values["brightness"] = brightness
        if brightness_var is not None:
            self._values["brightness_var"] = brightness_var
        if contrast is not None:
            self._values["contrast"] = contrast
        if contrast_var is not None:
            self._values["contrast_var"] = contrast_var

    @builtins.property
    def brightness(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        '''
        result = self._values.get("brightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def brightness_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        '''
        result = self._values.get("brightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        result = self._values.get("contrast_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeContrast(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeContrastList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeContrastList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__67bfdd91d48edf84ead342ea2625ed857dbeb24f55438b1f96a595abf97d0d3f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeContrastOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__25c24772df037c6c93ebf2bf38c7c29e5a1de9abd04ebf2698d73d7e571ad5f5)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeContrastOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2e1104b090835896de6cd85d6358ff0c590e15dd20b21b93fc531e701e25a7eb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__98ade1af2ba89c0fb768acb99522bb09643f069a28824e2ad86ba0074e345f8a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__238bd101b5a5465e86c2ed34f5f39ab39e0671d780644a135b8ebe437c9fa47e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeContrast]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeContrast]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__40b310bfdc468c5241d644d232a4b00f88fd7f0b5d1195e93d59669ace3eda2b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeContrastOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeContrastOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__562146b8b66df224f77e9aec5890772d78d5f121d05102809609fd114103d764)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetBrightness")
    def reset_brightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightness", []))

    @jsii.member(jsii_name="resetBrightnessVar")
    def reset_brightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightnessVar", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetContrastVar")
    def reset_contrast_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrastVar", []))

    @builtins.property
    @jsii.member(jsii_name="brightnessInput")
    def brightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="brightnessVarInput")
    def brightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastVarInput")
    def contrast_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="brightness")
    def brightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightness"))

    @brightness.setter
    def brightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9c585e78c0753a1af5fb33911475c9d284edd25917a48e72a4f726648fb7596f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightness", value)

    @builtins.property
    @jsii.member(jsii_name="brightnessVar")
    def brightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightnessVar"))

    @brightness_var.setter
    def brightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a0cef544db2a9bf8b0411dc19ea049d55b67b3255b523d0c1b744eaa4fe55cd0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrast"))

    @contrast.setter
    def contrast(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3e2d7e8d695efb34b6a90113f7fe8130300cff9f75f8e300207af6c49cae11c8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrast", value)

    @builtins.property
    @jsii.member(jsii_name="contrastVar")
    def contrast_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrastVar"))

    @contrast_var.setter
    def contrast_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__762c0afbe7ef4d8bd566164c5948915be08430535b1dae3a33569b78526dd951)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrastVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeContrast]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeContrast]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeContrast]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f2b76fd12545d33a5476bc020864204b8f385fc9b0c00ae984d076a268357a29)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeGoop",
    jsii_struct_bases=[],
    name_mapping={
        "chaos": "chaos",
        "chaos_var": "chaosVar",
        "density": "density",
        "density_var": "densityVar",
        "power": "power",
        "power_var": "powerVar",
        "seed": "seed",
        "seed_var": "seedVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeGoop:
    def __init__(
        self,
        *,
        chaos: typing.Optional[builtins.str] = None,
        chaos_var: typing.Optional[builtins.str] = None,
        density: typing.Optional[builtins.str] = None,
        density_var: typing.Optional[builtins.str] = None,
        power: typing.Optional[builtins.str] = None,
        power_var: typing.Optional[builtins.str] = None,
        seed: typing.Optional[builtins.str] = None,
        seed_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param chaos: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        :param chaos_var: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        :param density: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        :param density_var: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        :param power: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        :param power_var: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        :param seed: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        :param seed_var: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6a0515800f48f0bace5cf3d25ff449bbc8623dba936881178c71ac1a860360a7)
            check_type(argname="argument chaos", value=chaos, expected_type=type_hints["chaos"])
            check_type(argname="argument chaos_var", value=chaos_var, expected_type=type_hints["chaos_var"])
            check_type(argname="argument density", value=density, expected_type=type_hints["density"])
            check_type(argname="argument density_var", value=density_var, expected_type=type_hints["density_var"])
            check_type(argname="argument power", value=power, expected_type=type_hints["power"])
            check_type(argname="argument power_var", value=power_var, expected_type=type_hints["power_var"])
            check_type(argname="argument seed", value=seed, expected_type=type_hints["seed"])
            check_type(argname="argument seed_var", value=seed_var, expected_type=type_hints["seed_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if chaos is not None:
            self._values["chaos"] = chaos
        if chaos_var is not None:
            self._values["chaos_var"] = chaos_var
        if density is not None:
            self._values["density"] = density
        if density_var is not None:
            self._values["density_var"] = density_var
        if power is not None:
            self._values["power"] = power
        if power_var is not None:
            self._values["power_var"] = power_var
        if seed is not None:
            self._values["seed"] = seed
        if seed_var is not None:
            self._values["seed_var"] = seed_var

    @builtins.property
    def chaos(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        '''
        result = self._values.get("chaos")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def chaos_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        '''
        result = self._values.get("chaos_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        '''
        result = self._values.get("density")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density_var(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        '''
        result = self._values.get("density_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        '''
        result = self._values.get("power")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power_var(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        '''
        result = self._values.get("power_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        '''
        result = self._values.get("seed")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed_var(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        result = self._values.get("seed_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeGoop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeGoopList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeGoopList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eb6c4c239759648fc2b3896f28acf413a2f01c37a56508b57f49265af9b0f51a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeGoopOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__59ca8bd85477a805f2d9a7f9e086cf1b477074fa11c6a957bc0f56fd24a9c438)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeGoopOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d1233fc287f35e74c4ae4f2dbe0e9ea46ae4e6d5f827c09c80e649bec32ca422)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__18978ad22147480dfb3c265a284affe10199143f50c32190fd567692ef2fd13b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__66b6b6b32990354613b8e1145cdc2842ba416f2b7b642cc76645c0100780b0f3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeGoop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeGoop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0de9cfc3cdb71bbec7e3ac528b9bf0d771c56e77d1d0857175ae0e418a39aa80)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeGoopOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeGoopOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__46ed9ec006f04bfc99eafc4cd6ac74cb6ce55b4c19d10316d5521721db1178c6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetChaos")
    def reset_chaos(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaos", []))

    @jsii.member(jsii_name="resetChaosVar")
    def reset_chaos_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaosVar", []))

    @jsii.member(jsii_name="resetDensity")
    def reset_density(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensity", []))

    @jsii.member(jsii_name="resetDensityVar")
    def reset_density_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensityVar", []))

    @jsii.member(jsii_name="resetPower")
    def reset_power(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPower", []))

    @jsii.member(jsii_name="resetPowerVar")
    def reset_power_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPowerVar", []))

    @jsii.member(jsii_name="resetSeed")
    def reset_seed(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeed", []))

    @jsii.member(jsii_name="resetSeedVar")
    def reset_seed_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeedVar", []))

    @builtins.property
    @jsii.member(jsii_name="chaosInput")
    def chaos_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosInput"))

    @builtins.property
    @jsii.member(jsii_name="chaosVarInput")
    def chaos_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosVarInput"))

    @builtins.property
    @jsii.member(jsii_name="densityInput")
    def density_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityInput"))

    @builtins.property
    @jsii.member(jsii_name="densityVarInput")
    def density_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="powerInput")
    def power_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerInput"))

    @builtins.property
    @jsii.member(jsii_name="powerVarInput")
    def power_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerVarInput"))

    @builtins.property
    @jsii.member(jsii_name="seedInput")
    def seed_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedInput"))

    @builtins.property
    @jsii.member(jsii_name="seedVarInput")
    def seed_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedVarInput"))

    @builtins.property
    @jsii.member(jsii_name="chaos")
    def chaos(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaos"))

    @chaos.setter
    def chaos(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f777396e16d7bd2f023ddd4c843a21f1cfab15be89991d1c73e8dd0cfdd887e6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaos", value)

    @builtins.property
    @jsii.member(jsii_name="chaosVar")
    def chaos_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaosVar"))

    @chaos_var.setter
    def chaos_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea2c63c2b8a54fe917a4c9a621b063f38497cb5032333a67cc8f5524e5fdf356)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaosVar", value)

    @builtins.property
    @jsii.member(jsii_name="density")
    def density(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "density"))

    @density.setter
    def density(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0b666aa0e84c7055bda39666f165b42000fa21c480fea4abf4a9ba295348a95a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "density", value)

    @builtins.property
    @jsii.member(jsii_name="densityVar")
    def density_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "densityVar"))

    @density_var.setter
    def density_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0b7408776eb49c22e1e5c511f602697ec96936a8ead90559cbab38a0b6ee24a4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "densityVar", value)

    @builtins.property
    @jsii.member(jsii_name="power")
    def power(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "power"))

    @power.setter
    def power(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__166b40b527cf7dbd9ddcb8943e3905cb8294c08fae2354aa64a9794bc3cf1237)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "power", value)

    @builtins.property
    @jsii.member(jsii_name="powerVar")
    def power_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "powerVar"))

    @power_var.setter
    def power_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1fcd2191788c4514967bb5d34a7fdf763c5c16a81fd7448f93539f76f8d5280a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "powerVar", value)

    @builtins.property
    @jsii.member(jsii_name="seed")
    def seed(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seed"))

    @seed.setter
    def seed(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__efee4dfa18949d33fdfd1a77ae5bb2fb6deefb4e2490957899f19b2b2be760e5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seed", value)

    @builtins.property
    @jsii.member(jsii_name="seedVar")
    def seed_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seedVar"))

    @seed_var.setter
    def seed_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__515d71ec7f0cb202ba031f31a4a85e14ead1643f29ffee2a710977b937e90454)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seedVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeGoop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeGoop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeGoop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3c797628ee0a8fc1d4fea12731c334fa1f9a474df4fe51f6e2423b7a9d3f3775)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeGrayscale",
    jsii_struct_bases=[],
    name_mapping={"type": "type", "type_var": "typeVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeGrayscale:
    def __init__(
        self,
        *,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param type: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c20091bc57ec0554b0ffd4134d7f0c1882cba4032ab35c44f30d43093350fbdd)
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeGrayscale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeGrayscaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeGrayscaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__623f2100f7ffed09bad87f29fab7cf0dc7c6e6bfa37f76652801ea4dc2ac13bf)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeGrayscaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ba523b8285c2200d38fe74e0d595ce65aeb8ba76611156f841342bf1301478b6)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeGrayscaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a5e5dfcc8a8ace3672f8dccf9bb1bfb7bb4b6b8cdd4e51d244d902272d1986a7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3db9a3b22bed0ac9556d5ec77d7f012194731e88a6a16211c1cf829b53936587)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__22e06014e43e8ae4489e2ff2fa4c308a23708eeeee79274f35df86edacabffca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeGrayscale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeGrayscale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__17a367406cde642052ebee2fa43cab624c5957b71118d07ea625ebc8baf3bf13)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeGrayscaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeGrayscaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__02126000fd0299153ca11a0dd99a99f5fbe40f52aacf7e4e9c683c237fadf9c3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4de1a69915d385d672fe884ef1f8e918f90a5e2cde70b3c1e36522cf8d584bd7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__de58ced230f184865a8acc9f63d881befceb7158cf9bedba6abad39aca32219d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeGrayscale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeGrayscale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeGrayscale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3c34b10ff9c29a24b8b520529c137221f780fbc26b51f4fcbe9223762b71ffec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeHsl",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "lightness": "lightness",
        "lightness_var": "lightnessVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeHsl:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness: typing.Optional[builtins.str] = None,
        lightness_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        :param lightness_var: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6cd9fb3ecf5059bac134c26c381f10d0dfc8a981bd03d76eb7ff8657ffe7a55d)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness", value=lightness, expected_type=type_hints["lightness"])
            check_type(argname="argument lightness_var", value=lightness_var, expected_type=type_hints["lightness_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness is not None:
            self._values["lightness"] = lightness
        if lightness_var is not None:
            self._values["lightness_var"] = lightness_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        '''
        result = self._values.get("lightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        '''
        result = self._values.get("lightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeHsl(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeHslList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeHslList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__446b0d104f548fed95ca4b8d01ce513cbba25590ba210da3706414e62afc729b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeHslOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cee9556155865cec7d55cba4b8df6fd9b691e8c2fd1ec4e61f9ca2f625657e05)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeHslOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__29de40a7c532373566b34eb88905fca7973ab43e3e469e4410a8132e938e789c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ee8e41bdab999b579b33c2721f080d71f5d3ebbc94948a0761bece197112ed6a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2844ca33a0656fd90badf9cf2b3eb7a70fa3d514b43bb69b82e52a16e686350b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeHsl]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeHsl]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__04e4ab2e3766ede347236a36f8d6a90762378d90414781717066d48245934dd3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeHslOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeHslOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eb2ec2f59ea2625ac08c517dee5049d5927b5d6a566cc81f96e6385586c86708)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightness")
    def reset_lightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightness", []))

    @jsii.member(jsii_name="resetLightnessVar")
    def reset_lightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessInput")
    def lightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessVarInput")
    def lightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e9783d00bdceb9e5bd2623e1921480a050c8e7742559ed179ec264b6f5f5cab6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e9d0fcb2c1bef8618eaa886476f18c69b8223c3ff1fb0a0d3986df926851535b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightness")
    def lightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightness"))

    @lightness.setter
    def lightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5c181cd3f9a05821fbf9cb29c1e61e9d728b567483bf8f4de9210c8a61f812a0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightness", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessVar")
    def lightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessVar"))

    @lightness_var.setter
    def lightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__157380475dcca79fb39b6a1c9b2eced72d20d213d6166468af55d279ce7f855a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1930165c2d7fff938d2ceb1a66899e141c6cd919db0fa0438304425474313427)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f07e9303893d8af1eb4239cb860422ac1424908c2f4caf798c62d44aa1756328)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeHsl]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeHsl]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeHsl]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1ae6bcc7edf25ca385094c3a97d11fce5ee649da81f38e5832b0ba979ea88353)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeHsv",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeHsv:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        :param value: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eb7eb761ae13115b0e7c051fb0cce4b1493cf3911d3da5d282c3683dd224f989)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeHsv(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeHsvList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeHsvList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e4165ee6960f6e21a4f8fd4f8c1c7f574b83198d5eada64810c8efef7a94ea18)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeHsvOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0c43154c1ac1a2647cd00514247ab3869b814d2c9f48a4a70e8a7aeebb9165d7)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeHsvOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2f1c4790a7a279439794c42d623816e66daaecc232e5786d084400adce91f933)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0b2feee3b646161256dc4d50a4706bd962a8ba64aaf9343d02ff76ffd8b5c693)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bdce612c8e299eec7fb435c0074fb62b5a0e25efc2f2f38867053a610bc010d9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeHsv]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeHsv]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b8aba88f77c8453db76151db485bb3c9528cf61132585396bc59e8fbfd252f80)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeHsvOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeHsvOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8f556ce2a4b356da3d53efa31eba2beced6fc3e035c99eaac0c7f855ee3b7468)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__79fd5ca50ed6c42bc4279937068b13ed11aba8e232ff6c897dfe5635bff403df)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1202e3fd21cfa1d236fa2b76cd28968ef0a6275b12fd08ec2be0e49b689afc8b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__37bf6b09c55e6d7846d3f48a381ecda51c3b764b2b3f1e3fda551c68f8a3d83f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__36ca551b60e74275e492d049dcdc5e54d2a62ebfdfd44fec6e51c63405dc5814)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a1aba3c5efa1a8cf550e4aae9db4f5dbe9a9c98ea16d066eddc985db6cff5bc5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e64330a6d880017ed4014aefecb81b7311cd74d149cc88e57171c228140f6cad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeHsv]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeHsv]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeHsv]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f8a3e205cd7608c8648a0ca36c83e27bbc2957b1dc163f69dbfc4d4c96c950d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfDimension",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "dimension": "dimension",
        "dimension_var": "dimensionVar",
        "equal": "equal",
        "greater_than": "greaterThan",
        "less_than": "lessThan",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfDimension:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        dimension: typing.Optional[builtins.str] = None,
        dimension_var: typing.Optional[builtins.str] = None,
        equal: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionEqual", typing.Dict[builtins.str, typing.Any]]] = None,
        greater_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionGreaterThan", typing.Dict[builtins.str, typing.Any]]] = None,
        less_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionLessThan", typing.Dict[builtins.str, typing.Any]]] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param dimension: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        :param dimension_var: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        :param equal: equal block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        :param greater_than: greater_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        :param less_than: less_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        :param value: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionDefault(**default)
        if isinstance(equal, dict):
            equal = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionEqual(**equal)
        if isinstance(greater_than, dict):
            greater_than = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionGreaterThan(**greater_than)
        if isinstance(less_than, dict):
            less_than = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionLessThan(**less_than)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ddb91b76696b1d5e46e81e071027fe6fc0a5cb7c384c125896328f8e89f3661)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument dimension", value=dimension, expected_type=type_hints["dimension"])
            check_type(argname="argument dimension_var", value=dimension_var, expected_type=type_hints["dimension_var"])
            check_type(argname="argument equal", value=equal, expected_type=type_hints["equal"])
            check_type(argname="argument greater_than", value=greater_than, expected_type=type_hints["greater_than"])
            check_type(argname="argument less_than", value=less_than, expected_type=type_hints["less_than"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if dimension is not None:
            self._values["dimension"] = dimension
        if dimension_var is not None:
            self._values["dimension_var"] = dimension_var
        if equal is not None:
            self._values["equal"] = equal
        if greater_than is not None:
            self._values["greater_than"] = greater_than
        if less_than is not None:
            self._values["less_than"] = less_than
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionDefault"], result)

    @builtins.property
    def dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        '''
        result = self._values.get("dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        '''
        result = self._values.get("dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def equal(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionEqual"]:
        '''equal block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        '''
        result = self._values.get("equal")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionEqual"], result)

    @builtins.property
    def greater_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionGreaterThan"]:
        '''greater_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        '''
        result = self._values.get("greater_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionGreaterThan"], result)

    @builtins.property
    def less_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionLessThan"]:
        '''less_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        '''
        result = self._values.get("less_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionLessThan"], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfDimension(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4fde8c547ea14a1df22c32f5e556fb987551b991f0e772d2744bb37e45d20f3d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f68ed68f3ce10fedc684b4d305a77399f1f40964be3be80cb2c5b0e78debdcc8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionEqual",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionEqual:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionEqual(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionEqualOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionEqualOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1b3860335fbe9662c679a962e3e68a10d75958ddaa41a6d6d22b52369e607de1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionEqual], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionEqual],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c08caa9f8643025fb57a1087127db77832d72b96649f8a365defe4763bcf5ca7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionGreaterThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionGreaterThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionGreaterThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionGreaterThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionGreaterThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a11ebad0c22cbe2a9ad60376dde814c77d805faec51bd60fbec115a212eb7a8b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionGreaterThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionGreaterThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a238046f73be62c82a11e347d5377255c4dd60f9e24118934ebefebb2d6c12d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionLessThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionLessThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionLessThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionLessThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionLessThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0c2e838b1bbb59b7d93c75bef65b7bb2a82430ee228186e26aa5c0bb96c9639c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionLessThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionLessThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__00537ab34b2e6071adfd224e3f0b628eb3dd09563398aac337fd6d88b18777b1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__199ff0e3b43160ce3c08b07f9bddb45469bd47de4442ab2a8fa362b711a704ae)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__76fd314cc11a425840034c5005811782b9c28e67bf73754759d02260724f669b)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__584ad30295d854736b2113334767d1eff0e76fc002d99c0b8022d65cb75b6bbe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__847834bec73ee7f07b1be75c61fef8f9c8a7e3e344188cdce879263d66035576)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4e5872b179119ddb226b9b73e17fb21e7ac740eb75ccfa9265093fdd45958d6d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfDimension]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfDimension]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7c2bee37accf2495f1c48e3e92341597ccee92f5defd59fbdd6ff44fb0339082)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dbe22dfd4df0b3bcce738d77c8925d18dfab3c21534e1effba1f73ab00bd5054)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putEqual")
    def put_equal(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionEqual()

        return typing.cast(None, jsii.invoke(self, "putEqual", [value]))

    @jsii.member(jsii_name="putGreaterThan")
    def put_greater_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionGreaterThan()

        return typing.cast(None, jsii.invoke(self, "putGreaterThan", [value]))

    @jsii.member(jsii_name="putLessThan")
    def put_less_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionLessThan()

        return typing.cast(None, jsii.invoke(self, "putLessThan", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetDimension")
    def reset_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimension", []))

    @jsii.member(jsii_name="resetDimensionVar")
    def reset_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimensionVar", []))

    @jsii.member(jsii_name="resetEqual")
    def reset_equal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEqual", []))

    @jsii.member(jsii_name="resetGreaterThan")
    def reset_greater_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGreaterThan", []))

    @jsii.member(jsii_name="resetLessThan")
    def reset_less_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLessThan", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="equal")
    def equal(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionEqualOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionEqualOutputReference, jsii.get(self, "equal"))

    @builtins.property
    @jsii.member(jsii_name="greaterThan")
    def greater_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionGreaterThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionGreaterThanOutputReference, jsii.get(self, "greaterThan"))

    @builtins.property
    @jsii.member(jsii_name="lessThan")
    def less_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionLessThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionLessThanOutputReference, jsii.get(self, "lessThan"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionInput")
    def dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionVarInput")
    def dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="equalInput")
    def equal_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionEqual], jsii.get(self, "equalInput"))

    @builtins.property
    @jsii.member(jsii_name="greaterThanInput")
    def greater_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionGreaterThan], jsii.get(self, "greaterThanInput"))

    @builtins.property
    @jsii.member(jsii_name="lessThanInput")
    def less_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionLessThan], jsii.get(self, "lessThanInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="dimension")
    def dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimension"))

    @dimension.setter
    def dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8cda70d3efa1914626c6cb4408ec06a649772d5f3cad4466aef7e28457456097)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimension", value)

    @builtins.property
    @jsii.member(jsii_name="dimensionVar")
    def dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimensionVar"))

    @dimension_var.setter
    def dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6bc814b9e0de99e1751a23292bd47a5aba142d5973cc0c82b5d6ea4018b38de5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e21aaa12eb143ca557793b2415abdf1313a0917bf84210d544b53435963a8a04)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bcb8b1b0519ce19ccaddc3c3babfc722ae17ac4fbd99ceb2e1fde1d67e4be7ee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfDimension]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfDimension]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfDimension]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5a5ada8f5a948b1e1aabc63940fb538886354e1868a66c8d17c3d5647b4eba48)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientation",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "landscape": "landscape",
        "portrait": "portrait",
        "square": "square",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientation:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        landscape: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationLandscape", typing.Dict[builtins.str, typing.Any]]] = None,
        portrait: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationPortrait", typing.Dict[builtins.str, typing.Any]]] = None,
        square: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationSquare", typing.Dict[builtins.str, typing.Any]]] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param landscape: landscape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        :param portrait: portrait block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        :param square: square block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationDefault(**default)
        if isinstance(landscape, dict):
            landscape = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationLandscape(**landscape)
        if isinstance(portrait, dict):
            portrait = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationPortrait(**portrait)
        if isinstance(square, dict):
            square = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationSquare(**square)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c3690ba46634684f8b1367feacfbf0f09e07afaf25d2e03810d8663f6a126c03)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument landscape", value=landscape, expected_type=type_hints["landscape"])
            check_type(argname="argument portrait", value=portrait, expected_type=type_hints["portrait"])
            check_type(argname="argument square", value=square, expected_type=type_hints["square"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if landscape is not None:
            self._values["landscape"] = landscape
        if portrait is not None:
            self._values["portrait"] = portrait
        if square is not None:
            self._values["square"] = square

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationDefault"], result)

    @builtins.property
    def landscape(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationLandscape"]:
        '''landscape block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        '''
        result = self._values.get("landscape")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationLandscape"], result)

    @builtins.property
    def portrait(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationPortrait"]:
        '''portrait block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        '''
        result = self._values.get("portrait")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationPortrait"], result)

    @builtins.property
    def square(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationSquare"]:
        '''square block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        result = self._values.get("square")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationSquare"], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__24598978bf639970e433485c0ea7a0212656cca93d107ea286dc902ff11be401)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b08f8f4e465a57e92f3b9013c49d306b25ab06b77097443afc9ad5e6fcef12ac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationLandscape",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationLandscape:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationLandscape(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationLandscapeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationLandscapeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4b729efe34954cee48e9e9f064735a6a54492c97167f777f4b4d9d9ce962c473)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationLandscape], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationLandscape],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c10a1897639d32535672625b340cb0b3c6d3a10ad1ae82ae2bb2a76104d3db39)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__989f5a4e0b1e7aa98288add0048d7025f429051832577d965252165e7022dc94)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5d60825f171bcf161f5bf6473eb026cff26524f321460bbd23f90ebd19adb9c1)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6c37ac526721d5fa1d4752cb99a2a2c740b9ae95362fb40d7443045ddf8b122f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__52e73f0b2e1f7480b980b0b7ebc4d324e81c38863d44affeb2bf883014ee0d87)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e07182835c87635d7c8b2808d94dcf459f0e248f72b8f246be86e7f7007f8af6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientation]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientation]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__700d0420cbe60060d8ecdea00895ecff6efd381447c1508d6bad202ef67ef9fb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a84bdbb27326cc8371b4087d0875ea2473ef1306b1893fa471a18e9a3ce923e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putLandscape")
    def put_landscape(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationLandscape()

        return typing.cast(None, jsii.invoke(self, "putLandscape", [value]))

    @jsii.member(jsii_name="putPortrait")
    def put_portrait(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationPortrait()

        return typing.cast(None, jsii.invoke(self, "putPortrait", [value]))

    @jsii.member(jsii_name="putSquare")
    def put_square(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationSquare()

        return typing.cast(None, jsii.invoke(self, "putSquare", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetLandscape")
    def reset_landscape(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLandscape", []))

    @jsii.member(jsii_name="resetPortrait")
    def reset_portrait(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPortrait", []))

    @jsii.member(jsii_name="resetSquare")
    def reset_square(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSquare", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="landscape")
    def landscape(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationLandscapeOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationLandscapeOutputReference, jsii.get(self, "landscape"))

    @builtins.property
    @jsii.member(jsii_name="portrait")
    def portrait(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationPortraitOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationPortraitOutputReference", jsii.get(self, "portrait"))

    @builtins.property
    @jsii.member(jsii_name="square")
    def square(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationSquareOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationSquareOutputReference", jsii.get(self, "square"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="landscapeInput")
    def landscape_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationLandscape], jsii.get(self, "landscapeInput"))

    @builtins.property
    @jsii.member(jsii_name="portraitInput")
    def portrait_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationPortrait"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationPortrait"], jsii.get(self, "portraitInput"))

    @builtins.property
    @jsii.member(jsii_name="squareInput")
    def square_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationSquare"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationSquare"], jsii.get(self, "squareInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientation]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientation]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientation]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1396e540b829791186a4131369fd5cdd9bf6257919644dc688d6d5d51d0c9968)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationPortrait",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationPortrait:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationPortrait(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationPortraitOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationPortraitOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9529783b53bc37a0fe01e2648ca1d9ee040373eab41a773ee084a5c49c7b6dcc)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationPortrait]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationPortrait], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationPortrait],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__320842865cf6a4f79205e8f6bda6b5286a4f4f94780a2d8f6e637384b4c9543f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationSquare",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationSquare:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationSquare(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationSquareOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationSquareOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4eb2a02ee2afe5694010216f9a039fdd965597029c58151fbff0acb66e5045b1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationSquare]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationSquare], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationSquare],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c98e7f858f5fa9e88d8395acce291b1102611a2a09e500145eb7e9d127645347)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeMaxColors",
    jsii_struct_bases=[],
    name_mapping={"colors": "colors", "colors_var": "colorsVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeMaxColors:
    def __init__(
        self,
        *,
        colors: typing.Optional[builtins.str] = None,
        colors_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param colors: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        :param colors_var: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7cdab73f76e602ec2d84fc0648558f66f83ed646927e5235151e9ef07e6796f0)
            check_type(argname="argument colors", value=colors, expected_type=type_hints["colors"])
            check_type(argname="argument colors_var", value=colors_var, expected_type=type_hints["colors_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if colors is not None:
            self._values["colors"] = colors
        if colors_var is not None:
            self._values["colors_var"] = colors_var

    @builtins.property
    def colors(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        '''
        result = self._values.get("colors")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def colors_var(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        result = self._values.get("colors_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeMaxColors(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeMaxColorsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeMaxColorsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__791accb2f2b83969239fe180f802117fc70794e806ff1933744d956c30baf744)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeMaxColorsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ffce9468286ff9e8c0a43cdab61e866574748879c6187825762667fe14f3604)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeMaxColorsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__53cbebe224f83bdea25d0e2118a6f73a074868985c200cebc2572bfa41d5e94f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__21bbc71478dee7af212ecbeb6a4131d94d14633f1151c97238fede842acd95d0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c858ebe6e1ac776711149daf37e860a12e16969dc7c66a8899186d510ab46221)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeMaxColors]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeMaxColors]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f6d884433ad6878fc8349ac60ee3c91fa5384e767d8e2d3413e583431075c2d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeMaxColorsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeMaxColorsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__33250c72580ecc926793ac01bd3ca13979abf621f502892b144eca4ea02e860c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColors")
    def reset_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColors", []))

    @jsii.member(jsii_name="resetColorsVar")
    def reset_colors_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorsVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorsInput")
    def colors_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsInput"))

    @builtins.property
    @jsii.member(jsii_name="colorsVarInput")
    def colors_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsVarInput"))

    @builtins.property
    @jsii.member(jsii_name="colors")
    def colors(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colors"))

    @colors.setter
    def colors(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__90dd7f6e986f0fd61fe2e46946a6e84ad9fce9806f4cf38531366992ccb24f3a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colors", value)

    @builtins.property
    @jsii.member(jsii_name="colorsVar")
    def colors_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorsVar"))

    @colors_var.setter
    def colors_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__342201168220fc7f6fcef25f125be038ff04da1c22e55891f9d6489481794541)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorsVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeMaxColors]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeMaxColors]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeMaxColors]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d3a8533d5ff87d3293038198054bd813a5bbb22427a4456aecc770e832374702)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeMirror",
    jsii_struct_bases=[],
    name_mapping={
        "horizontal": "horizontal",
        "horizontal_var": "horizontalVar",
        "vertical": "vertical",
        "vertical_var": "verticalVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeMirror:
    def __init__(
        self,
        *,
        horizontal: typing.Optional[builtins.str] = None,
        horizontal_var: typing.Optional[builtins.str] = None,
        vertical: typing.Optional[builtins.str] = None,
        vertical_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param horizontal: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        :param horizontal_var: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        :param vertical: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        :param vertical_var: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__290d4676db48c583447275074363015874920dcd3e13067abb332be7683f14f1)
            check_type(argname="argument horizontal", value=horizontal, expected_type=type_hints["horizontal"])
            check_type(argname="argument horizontal_var", value=horizontal_var, expected_type=type_hints["horizontal_var"])
            check_type(argname="argument vertical", value=vertical, expected_type=type_hints["vertical"])
            check_type(argname="argument vertical_var", value=vertical_var, expected_type=type_hints["vertical_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if horizontal is not None:
            self._values["horizontal"] = horizontal
        if horizontal_var is not None:
            self._values["horizontal_var"] = horizontal_var
        if vertical is not None:
            self._values["vertical"] = vertical
        if vertical_var is not None:
            self._values["vertical_var"] = vertical_var

    @builtins.property
    def horizontal(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        '''
        result = self._values.get("horizontal")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def horizontal_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        '''
        result = self._values.get("horizontal_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        '''
        result = self._values.get("vertical")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        result = self._values.get("vertical_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeMirror(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeMirrorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeMirrorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__19ed4b5bb8c1ff7aea2059efcb20d2c533573d6bae28e4319cd83b46681bd7bb)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeMirrorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b5b2cdc8a251bcc0134194fd5179f3887f29ef0eed9e4c7773bf1bc419544de1)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeMirrorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3e153125658fd0a6b8c7ddf21e788318b0fb66deb0e11fb72bb915982e9ab43e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__239a508394761ba769231f8105735ed245839c71384df1d4a373313f5a7bf122)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5dc63dcbd8180b371c29afc0bc9cda1af49561408061444be177fcdd67e1dcd6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeMirror]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeMirror]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__983b48182b202f93637495e0e0754a76364a46bbbccd7536bcad461507cc3302)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeMirrorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeMirrorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__78e896a9a888a9dce0b070194f3e0e8f64e97926b943877b234d0bdef793d8e8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHorizontal")
    def reset_horizontal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontal", []))

    @jsii.member(jsii_name="resetHorizontalVar")
    def reset_horizontal_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontalVar", []))

    @jsii.member(jsii_name="resetVertical")
    def reset_vertical(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVertical", []))

    @jsii.member(jsii_name="resetVerticalVar")
    def reset_vertical_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVerticalVar", []))

    @builtins.property
    @jsii.member(jsii_name="horizontalInput")
    def horizontal_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontalVarInput")
    def horizontal_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalInput")
    def vertical_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalVarInput")
    def vertical_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontal")
    def horizontal(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontal"))

    @horizontal.setter
    def horizontal(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bcc709f96eb89831b2c35141194e19f31c7ba1504cd5f7041e1787077df4e885)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontal", value)

    @builtins.property
    @jsii.member(jsii_name="horizontalVar")
    def horizontal_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontalVar"))

    @horizontal_var.setter
    def horizontal_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d5d71650e85d62deb3c8856dfb29a19bd242b9eb608b7afd1fcb9c25a47c7b24)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontalVar", value)

    @builtins.property
    @jsii.member(jsii_name="vertical")
    def vertical(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "vertical"))

    @vertical.setter
    def vertical(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7366a958deea516028f6bf36e9111ea2f2b161d59e015180c04388057e0a0974)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "vertical", value)

    @builtins.property
    @jsii.member(jsii_name="verticalVar")
    def vertical_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "verticalVar"))

    @vertical_var.setter
    def vertical_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__14781c1b8149bfc2df084366acb6b379210933ab017c71d63d23b7840630f8a5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "verticalVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeMirror]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeMirror]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeMirror]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3b7d6dd819b3e1db4866359c2b96c15e92cfe6e6c77befd2bf4877ea7a41f769)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeMonoHue",
    jsii_struct_bases=[],
    name_mapping={"hue": "hue", "hue_var": "hueVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeMonoHue:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a31e4217c4bd1a7efe7b83f739e4f95c848685dc3098094d1c1063563af65bcc)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeMonoHue(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeMonoHueList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeMonoHueList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2c259e37f9479cb9fc812ef89c9f8023c007b57e5a3bf634f5c80026edb97cd2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeMonoHueOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2e1bf61ea68b855ea4170054c5264ae135c3e623d6d7dd3fb6cb1d9cb72b050d)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeMonoHueOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df6b8d954d434bf7008dd7f69dfea534997eece3467ef4052970408b19bc47d2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6cd5e4b71931ead0e179b54bcfec00229077bf5db4c4c9eaaf30414024442de4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__21244e27821d1a11f01eaa002d74292c7b33f48f13c7fa99712dc6bda909d3d1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeMonoHue]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeMonoHue]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__81fae01dbd969c8e0708f36477fbb8eb6c8520833ef23913bb18b4cfa2aa92d7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeMonoHueOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeMonoHueOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a8bf77c3b840498f9ee1c9ae60fea4c8d7726dab73cb3c6dbbdd398730655df4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fc29959d134c49f871eeb8a3e0ad85ad6d52ae1a4c3780bb96af5810734cce7e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7f3c1778c51835d47f2717114ce8a9a1656c58ce933e02c076a76237532a3522)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeMonoHue]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeMonoHue]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeMonoHue]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4172aa4662f6eb5773772bb4688f410f06dc65c3e64319ea765ab2bf57390058)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeOpacity",
    jsii_struct_bases=[],
    name_mapping={"opacity": "opacity", "opacity_var": "opacityVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeOpacity:
    def __init__(
        self,
        *,
        opacity: typing.Optional[builtins.str] = None,
        opacity_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param opacity: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param opacity_var: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__50b5fdbc77598d9d0f7fb8379cdad619196e8e58818309df37221296883299b6)
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument opacity_var", value=opacity_var, expected_type=type_hints["opacity_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if opacity is not None:
            self._values["opacity"] = opacity
        if opacity_var is not None:
            self._values["opacity_var"] = opacity_var

    @builtins.property
    def opacity(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def opacity_var(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        result = self._values.get("opacity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeOpacity(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeOpacityList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeOpacityList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc64e87686a306b07525a10a26f00efb73433a0bce705c7744550eac97056d2a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeOpacityOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__996f3ce719ae4bacf94a6c874d346410c5af67dbfac8dcaef0603fc7c2417d3b)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeOpacityOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e8566ca62c45b8327b2fdbb75b6274205867e5f750a3502ec6f1aa4aacb943ec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4f1da102073b2106a02763c9928c0902548145a394b643103d0aac7cce6324d0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a295bad4a960bac9f7791ceb765ad884c4ca4934776877e15b2705619b9d886c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeOpacity]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeOpacity]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__248e3d8879189762911ed9f55fadb653baaa494a6e990b85fdf5e09cceb814f4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeOpacityOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeOpacityOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__76c4cd924ab661126d47f302d15b65e33dd338e5361b2507153aa23e5869138d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetOpacityVar")
    def reset_opacity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacityVar", []))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityVarInput")
    def opacity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacity"))

    @opacity.setter
    def opacity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__848ca4212dd06845c0681189a1afc4b02e5992e6fc283ec64e72ad04920d73a6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacity", value)

    @builtins.property
    @jsii.member(jsii_name="opacityVar")
    def opacity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacityVar"))

    @opacity_var.setter
    def opacity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a4539df99c2fc43ddc2c9e016b4d6872be18b4a4b1a90a4c13d094e76214d443)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacityVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeOpacity]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeOpacity]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeOpacity]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__622b53ddbec5acb0c6e20562293bf23a9ffcd091896cfbe1fcd5201990928e8d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__73927c6f7414511b1ea0e917d147c6af9ff87a3da469dbfbca296db890f2a6c1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putBackgroundColor")
    def put_background_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9f3f77339b59cd4cecc9986b958cd394112ea4fe23924861383a0ff91aa4eb64)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBackgroundColor", [value]))

    @jsii.member(jsii_name="putBlur")
    def put_blur(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeBlur, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__197f9767ee26770b78b4e6dfc884f3e9bfe161bfc0393e653c930d46dc215273)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBlur", [value]))

    @jsii.member(jsii_name="putChromaKey")
    def put_chroma_key(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeChromaKey, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__62299027a598b5180bc1f6802ea2970d42cd54717000ec76cde07dea1f5af8b5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putChromaKey", [value]))

    @jsii.member(jsii_name="putComposite")
    def put_composite(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeComposite, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2cd49588d764237fae4c6c89d7d63d1b2fe6966a9f68e38a78ddb48414ded339)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putComposite", [value]))

    @jsii.member(jsii_name="putCompound")
    def put_compound(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeCompound, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__077ac0e2afad344917ba2f981ee3010f486a660b98b7133f568506ae0889180e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCompound", [value]))

    @jsii.member(jsii_name="putContrast")
    def put_contrast(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeContrast, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3e51433de9795104d1e008851b2969ceda71f37da5e9811aa8143432ac61eed8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putContrast", [value]))

    @jsii.member(jsii_name="putGoop")
    def put_goop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeGoop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__385eba9afc0f93941a08c837e12e7e4d2e3d595f918e1b8eb3c99a5f64a362b5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGoop", [value]))

    @jsii.member(jsii_name="putGrayscale")
    def put_grayscale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeGrayscale, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e607f84aca765fcf28b8c808e2e774db1f605901a97477947ea347de9bf1826b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGrayscale", [value]))

    @jsii.member(jsii_name="putHsl")
    def put_hsl(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeHsl, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5c6392782512097ffbbee6eefcff20c89e371c633920d9a4f308713885e87014)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsl", [value]))

    @jsii.member(jsii_name="putHsv")
    def put_hsv(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeHsv, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b8a7586e612db211d413e95095d5f6e585827101509a2982462785f07fd4f7a4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsv", [value]))

    @jsii.member(jsii_name="putIfDimension")
    def put_if_dimension(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfDimension, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b25b5dc866e254bb92b2767d64f140ea5226f16fdee0e86d68972dfeb794d570)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfDimension", [value]))

    @jsii.member(jsii_name="putIfOrientation")
    def put_if_orientation(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ad5f69c5b8884f9e6242537bc731358f9add8040b6aca23722213e7d21c7b52c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfOrientation", [value]))

    @jsii.member(jsii_name="putMaxColors")
    def put_max_colors(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeMaxColors, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bf4b82728609d499ed38d1d3ed8bd84c38b4a8d44b81dde46e8b3e63501d377c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMaxColors", [value]))

    @jsii.member(jsii_name="putMirror")
    def put_mirror(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeMirror, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af960875a411318416189a65864ef688a7bab9bcf83ccc24a8887712d175a468)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMirror", [value]))

    @jsii.member(jsii_name="putMonoHue")
    def put_mono_hue(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeMonoHue, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__285677527ec60e85ac325230b544e4e4376bfac98acb0ad28478586e23420952)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMonoHue", [value]))

    @jsii.member(jsii_name="putOpacity")
    def put_opacity(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeOpacity, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d0bdd4361b2e5a4d14f7acfe32c1e926d1724023014b3d60d9231252dd29bb7f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putOpacity", [value]))

    @jsii.member(jsii_name="putRemoveColor")
    def put_remove_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeRemoveColor", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b9b48393a016acaf2ac1f1a6ba8333108d7d3b5fd61bd35813e844097ff9eccb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRemoveColor", [value]))

    @jsii.member(jsii_name="putUnsharpMask")
    def put_unsharp_mask(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeUnsharpMask", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f778fe74eb25e68379fd237665960e3d5f724baab9187225273293d65ca10bae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putUnsharpMask", [value]))

    @jsii.member(jsii_name="resetBackgroundColor")
    def reset_background_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBackgroundColor", []))

    @jsii.member(jsii_name="resetBlur")
    def reset_blur(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBlur", []))

    @jsii.member(jsii_name="resetChromaKey")
    def reset_chroma_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChromaKey", []))

    @jsii.member(jsii_name="resetComposite")
    def reset_composite(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetComposite", []))

    @jsii.member(jsii_name="resetCompound")
    def reset_compound(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCompound", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetGoop")
    def reset_goop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGoop", []))

    @jsii.member(jsii_name="resetGrayscale")
    def reset_grayscale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGrayscale", []))

    @jsii.member(jsii_name="resetHsl")
    def reset_hsl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsl", []))

    @jsii.member(jsii_name="resetHsv")
    def reset_hsv(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsv", []))

    @jsii.member(jsii_name="resetIfDimension")
    def reset_if_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfDimension", []))

    @jsii.member(jsii_name="resetIfOrientation")
    def reset_if_orientation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfOrientation", []))

    @jsii.member(jsii_name="resetMaxColors")
    def reset_max_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxColors", []))

    @jsii.member(jsii_name="resetMirror")
    def reset_mirror(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMirror", []))

    @jsii.member(jsii_name="resetMonoHue")
    def reset_mono_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonoHue", []))

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetRemoveColor")
    def reset_remove_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRemoveColor", []))

    @jsii.member(jsii_name="resetUnsharpMask")
    def reset_unsharp_mask(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUnsharpMask", []))

    @builtins.property
    @jsii.member(jsii_name="backgroundColor")
    def background_color(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeBackgroundColorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeBackgroundColorList, jsii.get(self, "backgroundColor"))

    @builtins.property
    @jsii.member(jsii_name="blur")
    def blur(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeBlurList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeBlurList, jsii.get(self, "blur"))

    @builtins.property
    @jsii.member(jsii_name="chromaKey")
    def chroma_key(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeChromaKeyList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeChromaKeyList, jsii.get(self, "chromaKey"))

    @builtins.property
    @jsii.member(jsii_name="composite")
    def composite(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeCompositeList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeCompositeList, jsii.get(self, "composite"))

    @builtins.property
    @jsii.member(jsii_name="compound")
    def compound(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeCompoundList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeCompoundList, jsii.get(self, "compound"))

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeContrastList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeContrastList, jsii.get(self, "contrast"))

    @builtins.property
    @jsii.member(jsii_name="goop")
    def goop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeGoopList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeGoopList, jsii.get(self, "goop"))

    @builtins.property
    @jsii.member(jsii_name="grayscale")
    def grayscale(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeGrayscaleList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeGrayscaleList, jsii.get(self, "grayscale"))

    @builtins.property
    @jsii.member(jsii_name="hsl")
    def hsl(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeHslList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeHslList, jsii.get(self, "hsl"))

    @builtins.property
    @jsii.member(jsii_name="hsv")
    def hsv(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeHsvList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeHsvList, jsii.get(self, "hsv"))

    @builtins.property
    @jsii.member(jsii_name="ifDimension")
    def if_dimension(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionList, jsii.get(self, "ifDimension"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientation")
    def if_orientation(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationList, jsii.get(self, "ifOrientation"))

    @builtins.property
    @jsii.member(jsii_name="maxColors")
    def max_colors(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeMaxColorsList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeMaxColorsList, jsii.get(self, "maxColors"))

    @builtins.property
    @jsii.member(jsii_name="mirror")
    def mirror(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeMirrorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeMirrorList, jsii.get(self, "mirror"))

    @builtins.property
    @jsii.member(jsii_name="monoHue")
    def mono_hue(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeMonoHueList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeMonoHueList, jsii.get(self, "monoHue"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeOpacityList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeOpacityList, jsii.get(self, "opacity"))

    @builtins.property
    @jsii.member(jsii_name="removeColor")
    def remove_color(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeRemoveColorList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeRemoveColorList", jsii.get(self, "removeColor"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMask")
    def unsharp_mask(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeUnsharpMaskList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeUnsharpMaskList", jsii.get(self, "unsharpMask"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColorInput")
    def background_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeBackgroundColor]]], jsii.get(self, "backgroundColorInput"))

    @builtins.property
    @jsii.member(jsii_name="blurInput")
    def blur_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeBlur]]], jsii.get(self, "blurInput"))

    @builtins.property
    @jsii.member(jsii_name="chromaKeyInput")
    def chroma_key_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeChromaKey]]], jsii.get(self, "chromaKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="compositeInput")
    def composite_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeComposite]]], jsii.get(self, "compositeInput"))

    @builtins.property
    @jsii.member(jsii_name="compoundInput")
    def compound_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeCompound]]], jsii.get(self, "compoundInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeContrast]]], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="goopInput")
    def goop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeGoop]]], jsii.get(self, "goopInput"))

    @builtins.property
    @jsii.member(jsii_name="grayscaleInput")
    def grayscale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeGrayscale]]], jsii.get(self, "grayscaleInput"))

    @builtins.property
    @jsii.member(jsii_name="hslInput")
    def hsl_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeHsl]]], jsii.get(self, "hslInput"))

    @builtins.property
    @jsii.member(jsii_name="hsvInput")
    def hsv_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeHsv]]], jsii.get(self, "hsvInput"))

    @builtins.property
    @jsii.member(jsii_name="ifDimensionInput")
    def if_dimension_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfDimension]]], jsii.get(self, "ifDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientationInput")
    def if_orientation_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientation]]], jsii.get(self, "ifOrientationInput"))

    @builtins.property
    @jsii.member(jsii_name="maxColorsInput")
    def max_colors_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeMaxColors]]], jsii.get(self, "maxColorsInput"))

    @builtins.property
    @jsii.member(jsii_name="mirrorInput")
    def mirror_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeMirror]]], jsii.get(self, "mirrorInput"))

    @builtins.property
    @jsii.member(jsii_name="monoHueInput")
    def mono_hue_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeMonoHue]]], jsii.get(self, "monoHueInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeOpacity]]], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="removeColorInput")
    def remove_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeRemoveColor"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeRemoveColor"]]], jsii.get(self, "removeColorInput"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMaskInput")
    def unsharp_mask_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeUnsharpMask"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeUnsharpMask"]]], jsii.get(self, "unsharpMaskInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscape], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscape],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d4f746dd4508ce99e0946623c07b304049681d1710f84bba2df29319d53e56ca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeRemoveColor",
    jsii_struct_bases=[],
    name_mapping={
        "color": "color",
        "color_var": "colorVar",
        "feather": "feather",
        "feather_var": "featherVar",
        "tolerance": "tolerance",
        "tolerance_var": "toleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeRemoveColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
        feather: typing.Optional[builtins.str] = None,
        feather_var: typing.Optional[builtins.str] = None,
        tolerance: typing.Optional[builtins.str] = None,
        tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        :param feather: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        :param feather_var: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        :param tolerance: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        :param tolerance_var: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ec4410d792bac2b68a438f9fc77263b1a2a6b18e986ea09a8b4650b33b9681cf)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
            check_type(argname="argument feather", value=feather, expected_type=type_hints["feather"])
            check_type(argname="argument feather_var", value=feather_var, expected_type=type_hints["feather_var"])
            check_type(argname="argument tolerance", value=tolerance, expected_type=type_hints["tolerance"])
            check_type(argname="argument tolerance_var", value=tolerance_var, expected_type=type_hints["tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var
        if feather is not None:
            self._values["feather"] = feather
        if feather_var is not None:
            self._values["feather_var"] = feather_var
        if tolerance is not None:
            self._values["tolerance"] = tolerance
        if tolerance_var is not None:
            self._values["tolerance_var"] = tolerance_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        '''
        result = self._values.get("feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather_var(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        '''
        result = self._values.get("feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        '''
        result = self._values.get("tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance_var(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        result = self._values.get("tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeRemoveColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeRemoveColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeRemoveColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__27f37a6ddf9213f3d90e8b01cc750527a9c78498efafb90db8b6b8ccd7366860)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeRemoveColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a4e2c33087a71a2ee0f772cdf907d307331722058fd1baf055fe12551f5a17c)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeRemoveColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__61145387b279cb288b18d3990e25cbdefa337e9adda4472f9fb5c6734299d78e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__edc0d4dd388c30cc6289c66bca0c530297f595ec42d73661d81e9b0dcfc55aff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__27e22b69faf320302fe49579a427ac3f1baeea29d1d1fede4b93227c4d579c5c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeRemoveColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeRemoveColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeRemoveColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__985bf68085a3b6f3a7723aca09a6972b2c10a4cb37bfbb44c9d3a54a52fc4bdb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeRemoveColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeRemoveColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e659f2b1df43ca65fdceff374aca6dc85fa814cbb0280f2391dcc47633ae8167)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @jsii.member(jsii_name="resetFeather")
    def reset_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeather", []))

    @jsii.member(jsii_name="resetFeatherVar")
    def reset_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatherVar", []))

    @jsii.member(jsii_name="resetTolerance")
    def reset_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTolerance", []))

    @jsii.member(jsii_name="resetToleranceVar")
    def reset_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featherInput")
    def feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherInput"))

    @builtins.property
    @jsii.member(jsii_name="featherVarInput")
    def feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceInput")
    def tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceVarInput")
    def tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d661b2df8e1aa57b9fcb4907f68524d65dc8bbab03306813902e80e527f4db03)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__225359840b48e64db097e4f4d4fbcc611ac8aa8198f2caf2db6ec68716cac932)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="feather")
    def feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "feather"))

    @feather.setter
    def feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__594ca233893f65c4e421b3d55c2566ef95f3f49492b55a00ac10a9c93c421dc4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "feather", value)

    @builtins.property
    @jsii.member(jsii_name="featherVar")
    def feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featherVar"))

    @feather_var.setter
    def feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3bdf2806af739532fc7cbb111a76f71bf1f498eb70a5a591443276c1f3da7250)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featherVar", value)

    @builtins.property
    @jsii.member(jsii_name="tolerance")
    def tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tolerance"))

    @tolerance.setter
    def tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d26e8d252cacd13d5b9766d2b411b410ec4582ce73a3a16b0aa57070ca4ac208)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tolerance", value)

    @builtins.property
    @jsii.member(jsii_name="toleranceVar")
    def tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "toleranceVar"))

    @tolerance_var.setter
    def tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eecc81d5df4e3f4e9b4de13c1c05042a2e054680921b451fd8d5266998d4cb38)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "toleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeRemoveColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeRemoveColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeRemoveColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__86a46e51e56f3eac6c3444f157b71f718e515caf54d251049b28bb5b3849d8b9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeUnsharpMask",
    jsii_struct_bases=[],
    name_mapping={
        "gain": "gain",
        "gain_var": "gainVar",
        "sigma": "sigma",
        "sigma_var": "sigmaVar",
        "threshold": "threshold",
        "threshold_var": "thresholdVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeUnsharpMask:
    def __init__(
        self,
        *,
        gain: typing.Optional[builtins.str] = None,
        gain_var: typing.Optional[builtins.str] = None,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
        threshold: typing.Optional[builtins.str] = None,
        threshold_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param gain: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        :param gain_var: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        :param sigma: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        :param threshold: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        :param threshold_var: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__64e69820bddbf061db769c3b54db34ed030e194702721baa3d334e6cb5989145)
            check_type(argname="argument gain", value=gain, expected_type=type_hints["gain"])
            check_type(argname="argument gain_var", value=gain_var, expected_type=type_hints["gain_var"])
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
            check_type(argname="argument threshold", value=threshold, expected_type=type_hints["threshold"])
            check_type(argname="argument threshold_var", value=threshold_var, expected_type=type_hints["threshold_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if gain is not None:
            self._values["gain"] = gain
        if gain_var is not None:
            self._values["gain_var"] = gain_var
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var
        if threshold is not None:
            self._values["threshold"] = threshold
        if threshold_var is not None:
            self._values["threshold_var"] = threshold_var

    @builtins.property
    def gain(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        '''
        result = self._values.get("gain")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gain_var(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        '''
        result = self._values.get("gain_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        '''
        result = self._values.get("threshold")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold_var(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        result = self._values.get("threshold_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeUnsharpMask(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeUnsharpMaskList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeUnsharpMaskList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dc98f75e956cad08aed1528c43dbe17b3b0b461a95583f9bb10a9348786cdad0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeUnsharpMaskOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__58617eaf0a12adabf85532abaa1dc192cbcf21b5e039d7a9ad0d06bf7cf19521)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeUnsharpMaskOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__17deb46b224367eb4ffda6ba771a0e7b72adaefe65151aad17f99619267aeb7d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__39f5eab435701eaf312377f8ba33e23febb4ff3454a89d483ef6986e0322cfb5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0850764cbcbe3a1f0005e8cad02e1f384a2a5ec3b65d55918df0718ef166a0d9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeUnsharpMask]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeUnsharpMask]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeUnsharpMask]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b35621889e24a9bf05831acdeba4107081163a32fa9cea92a80668b2a7497212)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeUnsharpMaskOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeUnsharpMaskOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bd0dcf5485f0d60e250d95b9381bbf0c8f9f67b0ab02c1ea9befde6ff93cfdd8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetGain")
    def reset_gain(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGain", []))

    @jsii.member(jsii_name="resetGainVar")
    def reset_gain_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGainVar", []))

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @jsii.member(jsii_name="resetThreshold")
    def reset_threshold(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThreshold", []))

    @jsii.member(jsii_name="resetThresholdVar")
    def reset_threshold_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThresholdVar", []))

    @builtins.property
    @jsii.member(jsii_name="gainInput")
    def gain_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainInput"))

    @builtins.property
    @jsii.member(jsii_name="gainVarInput")
    def gain_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdInput")
    def threshold_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdVarInput")
    def threshold_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gain")
    def gain(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gain"))

    @gain.setter
    def gain(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d38c6039ba354f6ef800aee5831b4561c5773e5be755d70547e7fc23000224e0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gain", value)

    @builtins.property
    @jsii.member(jsii_name="gainVar")
    def gain_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gainVar"))

    @gain_var.setter
    def gain_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__05d6e7795225d434acb0d43579157d0330fe6cc4bb900ec5263ef21d4537fa8e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gainVar", value)

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__93140e14a30e43ebb3fe3f4e720279a3479bc9a3c9a40734099fc613b19a4b40)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__238f27117c927859808800b61a8fe8d52a226203cc7249bc651db15938421157)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="threshold")
    def threshold(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "threshold"))

    @threshold.setter
    def threshold(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__667839165b8e128a863f6b67acff214cd0643b85326255cf8f74280e86f16a8f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "threshold", value)

    @builtins.property
    @jsii.member(jsii_name="thresholdVar")
    def threshold_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "thresholdVar"))

    @threshold_var.setter
    def threshold_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0b470c27dfb34a04dee63942b93ec236d53673de1059cdd2debc09ecd2ca178f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "thresholdVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeUnsharpMask]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeUnsharpMask]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeUnsharpMask]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f8f1b4806f14a06120edb412d255ce92d146d8a7130eb69a0c4dd82589fcaea5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c8a988d923e3f7479e3aa1975482b13672eb1939fbb531cb18b7e65d29f963a0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4795e5fa9739ef7777ff38790f44c58b32cfbcfc9c0c0fb6b70099da76557222)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__70f76dea056c7558ee878907af24e241f320e4780539308136f6beda41996a2a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__518937602253b8bf1bacc270edf367c0f7ef6b54f91712d294a414e9028cb8ee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f598e503dd5b3f1c589b5752d310b7115fd84d1dfe337c8cdc6787ee70bc032e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientation]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientation]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f64114c77d22e86703c3b85620e69a810d56fc6346302b2e3c7d0a25cad8ebbe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7afd206b56af1ae18234b5e70ecead3ab32ca771194c129d0317e2c2200c8450)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(
        self,
        *,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefault(
            background_color=background_color,
            blur=blur,
            chroma_key=chroma_key,
            composite=composite,
            compound=compound,
            contrast=contrast,
            goop=goop,
            grayscale=grayscale,
            hsl=hsl,
            hsv=hsv,
            if_dimension=if_dimension,
            if_orientation=if_orientation,
            max_colors=max_colors,
            mirror=mirror,
            mono_hue=mono_hue,
            opacity=opacity,
            remove_color=remove_color,
            unsharp_mask=unsharp_mask,
        )

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putLandscape")
    def put_landscape(
        self,
        *,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscape(
            background_color=background_color,
            blur=blur,
            chroma_key=chroma_key,
            composite=composite,
            compound=compound,
            contrast=contrast,
            goop=goop,
            grayscale=grayscale,
            hsl=hsl,
            hsv=hsv,
            if_dimension=if_dimension,
            if_orientation=if_orientation,
            max_colors=max_colors,
            mirror=mirror,
            mono_hue=mono_hue,
            opacity=opacity,
            remove_color=remove_color,
            unsharp_mask=unsharp_mask,
        )

        return typing.cast(None, jsii.invoke(self, "putLandscape", [value]))

    @jsii.member(jsii_name="putPortrait")
    def put_portrait(
        self,
        *,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitBackgroundColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitBlur", typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitChromaKey", typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitComposite", typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitCompound", typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitContrast", typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitGoop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitGrayscale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitHsl", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitHsv", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfDimension", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfOrientation", typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitMaxColors", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitMirror", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitMonoHue", typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitOpacity", typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitRemoveColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitUnsharpMask", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortrait(
            background_color=background_color,
            blur=blur,
            chroma_key=chroma_key,
            composite=composite,
            compound=compound,
            contrast=contrast,
            goop=goop,
            grayscale=grayscale,
            hsl=hsl,
            hsv=hsv,
            if_dimension=if_dimension,
            if_orientation=if_orientation,
            max_colors=max_colors,
            mirror=mirror,
            mono_hue=mono_hue,
            opacity=opacity,
            remove_color=remove_color,
            unsharp_mask=unsharp_mask,
        )

        return typing.cast(None, jsii.invoke(self, "putPortrait", [value]))

    @jsii.member(jsii_name="putSquare")
    def put_square(
        self,
        *,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareBackgroundColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareBlur", typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareChromaKey", typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareComposite", typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareCompound", typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareContrast", typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareGoop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareGrayscale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareHsl", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareHsv", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfDimension", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfOrientation", typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareMaxColors", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareMirror", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareMonoHue", typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareOpacity", typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareRemoveColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareUnsharpMask", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquare(
            background_color=background_color,
            blur=blur,
            chroma_key=chroma_key,
            composite=composite,
            compound=compound,
            contrast=contrast,
            goop=goop,
            grayscale=grayscale,
            hsl=hsl,
            hsv=hsv,
            if_dimension=if_dimension,
            if_orientation=if_orientation,
            max_colors=max_colors,
            mirror=mirror,
            mono_hue=mono_hue,
            opacity=opacity,
            remove_color=remove_color,
            unsharp_mask=unsharp_mask,
        )

        return typing.cast(None, jsii.invoke(self, "putSquare", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetLandscape")
    def reset_landscape(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLandscape", []))

    @jsii.member(jsii_name="resetPortrait")
    def reset_portrait(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPortrait", []))

    @jsii.member(jsii_name="resetSquare")
    def reset_square(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSquare", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="landscape")
    def landscape(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeOutputReference, jsii.get(self, "landscape"))

    @builtins.property
    @jsii.member(jsii_name="portrait")
    def portrait(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitOutputReference", jsii.get(self, "portrait"))

    @builtins.property
    @jsii.member(jsii_name="square")
    def square(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareOutputReference", jsii.get(self, "square"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="landscapeInput")
    def landscape_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscape], jsii.get(self, "landscapeInput"))

    @builtins.property
    @jsii.member(jsii_name="portraitInput")
    def portrait_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortrait"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortrait"], jsii.get(self, "portraitInput"))

    @builtins.property
    @jsii.member(jsii_name="squareInput")
    def square_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquare"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquare"], jsii.get(self, "squareInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientation]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientation]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientation]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2588fda5fdf40fb0d93d4eec0829195ec9214c6cbff0b5064e994a93f34deb13)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortrait",
    jsii_struct_bases=[],
    name_mapping={
        "background_color": "backgroundColor",
        "blur": "blur",
        "chroma_key": "chromaKey",
        "composite": "composite",
        "compound": "compound",
        "contrast": "contrast",
        "goop": "goop",
        "grayscale": "grayscale",
        "hsl": "hsl",
        "hsv": "hsv",
        "if_dimension": "ifDimension",
        "if_orientation": "ifOrientation",
        "max_colors": "maxColors",
        "mirror": "mirror",
        "mono_hue": "monoHue",
        "opacity": "opacity",
        "remove_color": "removeColor",
        "unsharp_mask": "unsharpMask",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortrait:
    def __init__(
        self,
        *,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitBackgroundColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitBlur", typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitChromaKey", typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitComposite", typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitCompound", typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitContrast", typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitGoop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitGrayscale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitHsl", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitHsv", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfDimension", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfOrientation", typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitMaxColors", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitMirror", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitMonoHue", typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitOpacity", typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitRemoveColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitUnsharpMask", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__129d83de3c91312d2266a343e0303a4e5b1b76fb4bad3222938f815d696db518)
            check_type(argname="argument background_color", value=background_color, expected_type=type_hints["background_color"])
            check_type(argname="argument blur", value=blur, expected_type=type_hints["blur"])
            check_type(argname="argument chroma_key", value=chroma_key, expected_type=type_hints["chroma_key"])
            check_type(argname="argument composite", value=composite, expected_type=type_hints["composite"])
            check_type(argname="argument compound", value=compound, expected_type=type_hints["compound"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument goop", value=goop, expected_type=type_hints["goop"])
            check_type(argname="argument grayscale", value=grayscale, expected_type=type_hints["grayscale"])
            check_type(argname="argument hsl", value=hsl, expected_type=type_hints["hsl"])
            check_type(argname="argument hsv", value=hsv, expected_type=type_hints["hsv"])
            check_type(argname="argument if_dimension", value=if_dimension, expected_type=type_hints["if_dimension"])
            check_type(argname="argument if_orientation", value=if_orientation, expected_type=type_hints["if_orientation"])
            check_type(argname="argument max_colors", value=max_colors, expected_type=type_hints["max_colors"])
            check_type(argname="argument mirror", value=mirror, expected_type=type_hints["mirror"])
            check_type(argname="argument mono_hue", value=mono_hue, expected_type=type_hints["mono_hue"])
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument remove_color", value=remove_color, expected_type=type_hints["remove_color"])
            check_type(argname="argument unsharp_mask", value=unsharp_mask, expected_type=type_hints["unsharp_mask"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if background_color is not None:
            self._values["background_color"] = background_color
        if blur is not None:
            self._values["blur"] = blur
        if chroma_key is not None:
            self._values["chroma_key"] = chroma_key
        if composite is not None:
            self._values["composite"] = composite
        if compound is not None:
            self._values["compound"] = compound
        if contrast is not None:
            self._values["contrast"] = contrast
        if goop is not None:
            self._values["goop"] = goop
        if grayscale is not None:
            self._values["grayscale"] = grayscale
        if hsl is not None:
            self._values["hsl"] = hsl
        if hsv is not None:
            self._values["hsv"] = hsv
        if if_dimension is not None:
            self._values["if_dimension"] = if_dimension
        if if_orientation is not None:
            self._values["if_orientation"] = if_orientation
        if max_colors is not None:
            self._values["max_colors"] = max_colors
        if mirror is not None:
            self._values["mirror"] = mirror
        if mono_hue is not None:
            self._values["mono_hue"] = mono_hue
        if opacity is not None:
            self._values["opacity"] = opacity
        if remove_color is not None:
            self._values["remove_color"] = remove_color
        if unsharp_mask is not None:
            self._values["unsharp_mask"] = unsharp_mask

    @builtins.property
    def background_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitBackgroundColor"]]]:
        '''background_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        '''
        result = self._values.get("background_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitBackgroundColor"]]], result)

    @builtins.property
    def blur(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitBlur"]]]:
        '''blur block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        '''
        result = self._values.get("blur")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitBlur"]]], result)

    @builtins.property
    def chroma_key(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitChromaKey"]]]:
        '''chroma_key block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        '''
        result = self._values.get("chroma_key")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitChromaKey"]]], result)

    @builtins.property
    def composite(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitComposite"]]]:
        '''composite block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        '''
        result = self._values.get("composite")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitComposite"]]], result)

    @builtins.property
    def compound(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitCompound"]]]:
        '''compound block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        '''
        result = self._values.get("compound")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitCompound"]]], result)

    @builtins.property
    def contrast(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitContrast"]]]:
        '''contrast block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitContrast"]]], result)

    @builtins.property
    def goop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitGoop"]]]:
        '''goop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        '''
        result = self._values.get("goop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitGoop"]]], result)

    @builtins.property
    def grayscale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitGrayscale"]]]:
        '''grayscale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        '''
        result = self._values.get("grayscale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitGrayscale"]]], result)

    @builtins.property
    def hsl(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitHsl"]]]:
        '''hsl block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        '''
        result = self._values.get("hsl")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitHsl"]]], result)

    @builtins.property
    def hsv(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitHsv"]]]:
        '''hsv block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        '''
        result = self._values.get("hsv")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitHsv"]]], result)

    @builtins.property
    def if_dimension(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfDimension"]]]:
        '''if_dimension block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        '''
        result = self._values.get("if_dimension")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfDimension"]]], result)

    @builtins.property
    def if_orientation(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfOrientation"]]]:
        '''if_orientation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        '''
        result = self._values.get("if_orientation")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfOrientation"]]], result)

    @builtins.property
    def max_colors(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitMaxColors"]]]:
        '''max_colors block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        '''
        result = self._values.get("max_colors")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitMaxColors"]]], result)

    @builtins.property
    def mirror(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitMirror"]]]:
        '''mirror block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        '''
        result = self._values.get("mirror")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitMirror"]]], result)

    @builtins.property
    def mono_hue(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitMonoHue"]]]:
        '''mono_hue block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        '''
        result = self._values.get("mono_hue")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitMonoHue"]]], result)

    @builtins.property
    def opacity(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitOpacity"]]]:
        '''opacity block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitOpacity"]]], result)

    @builtins.property
    def remove_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitRemoveColor"]]]:
        '''remove_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        '''
        result = self._values.get("remove_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitRemoveColor"]]], result)

    @builtins.property
    def unsharp_mask(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitUnsharpMask"]]]:
        '''unsharp_mask block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        result = self._values.get("unsharp_mask")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitUnsharpMask"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortrait(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitBackgroundColor",
    jsii_struct_bases=[],
    name_mapping={"color": "color", "color_var": "colorVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitBackgroundColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0b922de4cf8100e5144f994c3f62de1f057c36b04be8b9f6391e5d0b5feda417)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitBackgroundColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitBackgroundColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitBackgroundColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3fbad16c3cac65e6f2b2d08676aa2c843e6074e57bb51331fc5c78084384e35f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitBackgroundColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dccc0132ca9068d4eb4c0cdc88f1e6bccecb17dbac1b802095906c36e3b4b049)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitBackgroundColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1aa26e372a49025e7fcfa2f45d8e8b128dfe3b4ac715679b81a127a6436a8957)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a37504d5a70578d00939de340d33b27707b43382d9fa5f2777719ffe3b1a2aab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2f0a08a2908f3342ccf771eb8c6c5f06cffb9770325422fef376d52d0a9f283b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitBackgroundColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitBackgroundColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__389e7692e32fb1f8c5d0b34589d468799458df281abd6ed2b2872d04eebe45e7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitBackgroundColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitBackgroundColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e7f095946f9ef27cf50bbe78d612ec87d46bc87cca0cc297bfe69c1c02915a8d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__056e405b25fba6741b05f272c1693d14e897c03f98f2e7e50804bdcba7fb028a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5bab6318004e30115aa4203690e84d3590024eefb6b77e531219db1b07e60528)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitBackgroundColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitBackgroundColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitBackgroundColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__00f8b51cce579e3c72903856afee18f11c894997fb0b2557fa24fc7a480c123d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitBlur",
    jsii_struct_bases=[],
    name_mapping={"sigma": "sigma", "sigma_var": "sigmaVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitBlur:
    def __init__(
        self,
        *,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param sigma: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__092e983e7d603b840eb7478ee2f69bc098711e152eec2dbd5eb5fcc04dbed7ad)
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitBlur(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitBlurList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitBlurList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a86f8e8b7c651d9469a30de5600f8aefe81efa8867a0e37c0f9fb1a8788d13a5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitBlurOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2841f8741d0f637f2ec42dfd2887c43eeec60537bc4a81497e0da7080460f487)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitBlurOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7581c4cd1d4589f5f211ee71fda73313adae47afb57240824ad5e085efc6b24a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__83b6aba6c1d881a30d8622e4c2e49ade9c515ba3051c280e1b52a4273dacfe79)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__23f9b26b3b0e641cb7cdc481e6e9490f3c0426bc1462b5ac14c65e62b26a258f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitBlur]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitBlur]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fd94d857c7aa92daa604f6a230484c1b4db8ec022462b8652ff5bd5bfd95c6b2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitBlurOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitBlurOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7f881acb2728f79999d08577d1341b16c618e98f077c34125ea8d95ad6914252)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__36c195c422429e6a1d137ce8c2bae4dc7c477a65ceb49965540969a11cc33fa1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__959e0bdac9c5794792f7250fe7a034f65ce322fa219e1da01232b2b7c0dad1c9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitBlur]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitBlur]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitBlur]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7e41bc15f6efcb2c4ee687526e46e1b460be313eeaa1305cbad5ec9de8f532a4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitChromaKey",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_feather": "hueFeather",
        "hue_feather_var": "hueFeatherVar",
        "hue_tolerance": "hueTolerance",
        "hue_tolerance_var": "hueToleranceVar",
        "hue_var": "hueVar",
        "lightness_feather": "lightnessFeather",
        "lightness_feather_var": "lightnessFeatherVar",
        "lightness_tolerance": "lightnessTolerance",
        "lightness_tolerance_var": "lightnessToleranceVar",
        "saturation_feather": "saturationFeather",
        "saturation_feather_var": "saturationFeatherVar",
        "saturation_tolerance": "saturationTolerance",
        "saturation_tolerance_var": "saturationToleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitChromaKey:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_feather: typing.Optional[builtins.str] = None,
        hue_feather_var: typing.Optional[builtins.str] = None,
        hue_tolerance: typing.Optional[builtins.str] = None,
        hue_tolerance_var: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness_feather: typing.Optional[builtins.str] = None,
        lightness_feather_var: typing.Optional[builtins.str] = None,
        lightness_tolerance: typing.Optional[builtins.str] = None,
        lightness_tolerance_var: typing.Optional[builtins.str] = None,
        saturation_feather: typing.Optional[builtins.str] = None,
        saturation_feather_var: typing.Optional[builtins.str] = None,
        saturation_tolerance: typing.Optional[builtins.str] = None,
        saturation_tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_feather: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        :param hue_feather_var: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        :param hue_tolerance: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        :param hue_tolerance_var: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        :param hue_var: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness_feather: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        :param lightness_feather_var: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        :param lightness_tolerance: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        :param lightness_tolerance_var: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        :param saturation_feather: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        :param saturation_feather_var: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        :param saturation_tolerance: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        :param saturation_tolerance_var: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__56b52e3ec699d6b33d7ec89d7a6a9455caec565d635cd33827a059c17cc28016)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_feather", value=hue_feather, expected_type=type_hints["hue_feather"])
            check_type(argname="argument hue_feather_var", value=hue_feather_var, expected_type=type_hints["hue_feather_var"])
            check_type(argname="argument hue_tolerance", value=hue_tolerance, expected_type=type_hints["hue_tolerance"])
            check_type(argname="argument hue_tolerance_var", value=hue_tolerance_var, expected_type=type_hints["hue_tolerance_var"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness_feather", value=lightness_feather, expected_type=type_hints["lightness_feather"])
            check_type(argname="argument lightness_feather_var", value=lightness_feather_var, expected_type=type_hints["lightness_feather_var"])
            check_type(argname="argument lightness_tolerance", value=lightness_tolerance, expected_type=type_hints["lightness_tolerance"])
            check_type(argname="argument lightness_tolerance_var", value=lightness_tolerance_var, expected_type=type_hints["lightness_tolerance_var"])
            check_type(argname="argument saturation_feather", value=saturation_feather, expected_type=type_hints["saturation_feather"])
            check_type(argname="argument saturation_feather_var", value=saturation_feather_var, expected_type=type_hints["saturation_feather_var"])
            check_type(argname="argument saturation_tolerance", value=saturation_tolerance, expected_type=type_hints["saturation_tolerance"])
            check_type(argname="argument saturation_tolerance_var", value=saturation_tolerance_var, expected_type=type_hints["saturation_tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_feather is not None:
            self._values["hue_feather"] = hue_feather
        if hue_feather_var is not None:
            self._values["hue_feather_var"] = hue_feather_var
        if hue_tolerance is not None:
            self._values["hue_tolerance"] = hue_tolerance
        if hue_tolerance_var is not None:
            self._values["hue_tolerance_var"] = hue_tolerance_var
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness_feather is not None:
            self._values["lightness_feather"] = lightness_feather
        if lightness_feather_var is not None:
            self._values["lightness_feather_var"] = lightness_feather_var
        if lightness_tolerance is not None:
            self._values["lightness_tolerance"] = lightness_tolerance
        if lightness_tolerance_var is not None:
            self._values["lightness_tolerance_var"] = lightness_tolerance_var
        if saturation_feather is not None:
            self._values["saturation_feather"] = saturation_feather
        if saturation_feather_var is not None:
            self._values["saturation_feather_var"] = saturation_feather_var
        if saturation_tolerance is not None:
            self._values["saturation_tolerance"] = saturation_tolerance
        if saturation_tolerance_var is not None:
            self._values["saturation_tolerance_var"] = saturation_tolerance_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        '''
        result = self._values.get("hue_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        '''
        result = self._values.get("hue_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        '''
        result = self._values.get("hue_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        '''
        result = self._values.get("hue_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        '''
        result = self._values.get("lightness_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        '''
        result = self._values.get("lightness_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        '''
        result = self._values.get("lightness_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        '''
        result = self._values.get("lightness_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        '''
        result = self._values.get("saturation_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        '''
        result = self._values.get("saturation_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        '''
        result = self._values.get("saturation_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        result = self._values.get("saturation_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitChromaKey(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitChromaKeyList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitChromaKeyList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3bb82022ad410fa7409376f87fe29cbc6332d642643670222777e3a84a4bb7f3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitChromaKeyOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ac16e37132330b089af3f915b0d4bd13f76188b112eaa3eca03fcebd689691d)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitChromaKeyOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc1dbf5b0795dfc68d343a517027d771eba5ab9a4ec9d7f778c5d8438428f48f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__11509e8ad3d01a7ac5e8317c969db41f0e540b64fb50eff1dcc4a72b3b846996)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7c79c844e0131dd82ec1034ca76502ddadebd675502f5d1dc518b0d518c01555)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitChromaKey]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitChromaKey]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e3a36cc6f396fad49996e0a7dee83968a9e43650e7a144cbaf79f5cb989bf4f9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitChromaKeyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitChromaKeyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a1ae7c30afd1a0b0a9655bff4dc9999717a09bbb86bd97ddcb394559cd4e505a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueFeather")
    def reset_hue_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeather", []))

    @jsii.member(jsii_name="resetHueFeatherVar")
    def reset_hue_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeatherVar", []))

    @jsii.member(jsii_name="resetHueTolerance")
    def reset_hue_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueTolerance", []))

    @jsii.member(jsii_name="resetHueToleranceVar")
    def reset_hue_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueToleranceVar", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightnessFeather")
    def reset_lightness_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeather", []))

    @jsii.member(jsii_name="resetLightnessFeatherVar")
    def reset_lightness_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeatherVar", []))

    @jsii.member(jsii_name="resetLightnessTolerance")
    def reset_lightness_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessTolerance", []))

    @jsii.member(jsii_name="resetLightnessToleranceVar")
    def reset_lightness_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessToleranceVar", []))

    @jsii.member(jsii_name="resetSaturationFeather")
    def reset_saturation_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeather", []))

    @jsii.member(jsii_name="resetSaturationFeatherVar")
    def reset_saturation_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeatherVar", []))

    @jsii.member(jsii_name="resetSaturationTolerance")
    def reset_saturation_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationTolerance", []))

    @jsii.member(jsii_name="resetSaturationToleranceVar")
    def reset_saturation_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherInput")
    def hue_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVarInput")
    def hue_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceInput")
    def hue_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVarInput")
    def hue_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherInput")
    def lightness_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVarInput")
    def lightness_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceInput")
    def lightness_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVarInput")
    def lightness_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherInput")
    def saturation_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVarInput")
    def saturation_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceInput")
    def saturation_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVarInput")
    def saturation_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d27cd764ec8b89ce57c72f86165f60492506368ca22b7ca9b8e1256cab33a965)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeather")
    def hue_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeather"))

    @hue_feather.setter
    def hue_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__67a834d8825ac4fb741d84a254f15ae618705c4a25d7fdae2489f8821a68dec6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeather", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVar")
    def hue_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeatherVar"))

    @hue_feather_var.setter
    def hue_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__80049f49b1786d2230ae3b6bc91d232c95436b28a74e2f67038466826c154223)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueTolerance")
    def hue_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueTolerance"))

    @hue_tolerance.setter
    def hue_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__75abc6b609c423aa91dbe19ab6ad506b351f8519a495a2dd05621d58a196ced0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVar")
    def hue_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueToleranceVar"))

    @hue_tolerance_var.setter
    def hue_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0edc7c3d170b37e314300927064c009b9f90ca91a1513be1c92d2cbfa979a712)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d6af28e55064f0b065c759381ab76124b9701de78549b8995dc12ed13c51c63b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeather")
    def lightness_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeather"))

    @lightness_feather.setter
    def lightness_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__da6a4b83e997d3ecbcfc03ef57c88f3af7833126ca1ea331f3d022677bb15244)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeather", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVar")
    def lightness_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeatherVar"))

    @lightness_feather_var.setter
    def lightness_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__19a504f22a58e4e4661c745d64250fb75595bf92b291dd57a3366eefd417c5dd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessTolerance")
    def lightness_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessTolerance"))

    @lightness_tolerance.setter
    def lightness_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a504f75ab344f95ccfa48ccfe95a25d4a3cbda96740c3baf6f20102408a7ab1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVar")
    def lightness_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessToleranceVar"))

    @lightness_tolerance_var.setter
    def lightness_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2185f349aa6e6dbc7335f6ed1dbda4398b7c9b697fb573d62d2e3e6ef256d816)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeather")
    def saturation_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeather"))

    @saturation_feather.setter
    def saturation_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__996ef16768c0d0ed60aab0c8f452e0d2137ff7f24162902d6510b4ad63adc785)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeather", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVar")
    def saturation_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeatherVar"))

    @saturation_feather_var.setter
    def saturation_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__95186010c94f038e9e6bc55cb112da1622b026125a29d344d860e0a42e8c9c22)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationTolerance")
    def saturation_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationTolerance"))

    @saturation_tolerance.setter
    def saturation_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__92742209cbed61b99a5b017faba7618e67c229ec67990e1c1f494aff764434a6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVar")
    def saturation_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationToleranceVar"))

    @saturation_tolerance_var.setter
    def saturation_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4d5af003ae8412c4dab85d96b1db046ba07dc6602da3690151b647d40e1d861a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitChromaKey]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitChromaKey]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitChromaKey]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e5f7773521a963ed0b0b3a321152a4d9e21cca8d8783ec21e3c2ef81c20abb5a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitComposite",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "placement": "placement",
        "placement_var": "placementVar",
        "scale": "scale",
        "scale_dimension": "scaleDimension",
        "scale_dimension_var": "scaleDimensionVar",
        "scale_var": "scaleVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitComposite:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitCompositeImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        placement: typing.Optional[builtins.str] = None,
        placement_var: typing.Optional[builtins.str] = None,
        scale: typing.Optional[builtins.str] = None,
        scale_dimension: typing.Optional[builtins.str] = None,
        scale_dimension_var: typing.Optional[builtins.str] = None,
        scale_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param placement: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        :param placement_var: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        :param scale: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param scale_dimension: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        :param scale_dimension_var: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        :param scale_var: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        :param x_position: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitCompositeImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ee899f073d750dbc49153fd192c110b78c60d930fc16ae237ac4c59971da75f)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument placement", value=placement, expected_type=type_hints["placement"])
            check_type(argname="argument placement_var", value=placement_var, expected_type=type_hints["placement_var"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument scale_dimension", value=scale_dimension, expected_type=type_hints["scale_dimension"])
            check_type(argname="argument scale_dimension_var", value=scale_dimension_var, expected_type=type_hints["scale_dimension_var"])
            check_type(argname="argument scale_var", value=scale_var, expected_type=type_hints["scale_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if placement is not None:
            self._values["placement"] = placement
        if placement_var is not None:
            self._values["placement_var"] = placement_var
        if scale is not None:
            self._values["scale"] = scale
        if scale_dimension is not None:
            self._values["scale_dimension"] = scale_dimension
        if scale_dimension_var is not None:
            self._values["scale_dimension_var"] = scale_dimension_var
        if scale_var is not None:
            self._values["scale_var"] = scale_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitCompositeImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitCompositeImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        '''
        result = self._values.get("placement")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement_var(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        '''
        result = self._values.get("placement_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        '''
        result = self._values.get("scale_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        '''
        result = self._values.get("scale_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        '''
        result = self._values.get("scale_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitComposite(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitCompositeImage",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitCompositeImage:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitCompositeImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitCompositeImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitCompositeImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__78d0db1b2b1bd050248c22b6cea8d965ce8f792d047a98bd9b9ad33be46f543a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitCompositeImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitCompositeImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5c33819dcf1715bc470fada990ef3710459b0b3b35a6275fac8c2d9cc3b45c7f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitCompositeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitCompositeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b49b44df1991c62162788985e5c904aba2fb888d000b8088d8ae5b1dd8584e31)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitCompositeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__573583115a10003de260e65d4910d96dbbe0f172b7a9c54c546c484ffd784a38)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitCompositeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5d915273b8ab92b8c2ccd761d69a84ed1d584c07117ee48de3ae3e44e92bf70a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__15efc3e4f9939c186e7f8e2f95c907e53ff97f40bc3ae386867dba0fa4831f4c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__891f0c14cf6ac3121287007b577663a422a682762831e85ce1ad8fab5b1f9edf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitComposite]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitComposite]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c63455d8637d30657214fe96647ec017fbc434b6dae09cbb578f31f3000c6de4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitCompositeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitCompositeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6fab967669bb3a5608cee397cc116b89f553da6ada184d3dc8dfeeb394f2cc57)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitCompositeImage()

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPlacement")
    def reset_placement(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacement", []))

    @jsii.member(jsii_name="resetPlacementVar")
    def reset_placement_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacementVar", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetScaleDimension")
    def reset_scale_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimension", []))

    @jsii.member(jsii_name="resetScaleDimensionVar")
    def reset_scale_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimensionVar", []))

    @jsii.member(jsii_name="resetScaleVar")
    def reset_scale_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitCompositeImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitCompositeImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitCompositeImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="placementInput")
    def placement_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementInput"))

    @builtins.property
    @jsii.member(jsii_name="placementVarInput")
    def placement_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionInput")
    def scale_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVarInput")
    def scale_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleVarInput")
    def scale_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__58598ae3b97f76383a00d149d07427c7f0a7b6a23fdbb8e3a29577284f39f89a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cdd1e0148f0ac05b030a34c2206ec0f70625ea4ff802681e69785e0a186c3413)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="placement")
    def placement(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placement"))

    @placement.setter
    def placement(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__79e15cb1e241c21cff4776697aa1300040a40fc95f1b7c0e4aec6f56d6e860b3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placement", value)

    @builtins.property
    @jsii.member(jsii_name="placementVar")
    def placement_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placementVar"))

    @placement_var.setter
    def placement_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f5d6083cbd9cfcae82158d2a41ac6f4e50cfad8b51196a6ee1f4f20958c1b879)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placementVar", value)

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scale"))

    @scale.setter
    def scale(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8478911fae1b288fb348f1f77ca2fc5b99d66efb92f736372ac9a8913c9df886)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scale", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimension")
    def scale_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimension"))

    @scale_dimension.setter
    def scale_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5e5d30c1e38c0182cc3a4f15d18318eed2192325ae64434e1ac4dbfa669809d0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimension", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVar")
    def scale_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimensionVar"))

    @scale_dimension_var.setter
    def scale_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__692992e1e3b0e62a4b5e18a9a2e23d7b2ab011bb5ddfe3ff0e3b15f07da4212a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="scaleVar")
    def scale_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleVar"))

    @scale_var.setter
    def scale_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aaa33f6aab2c4ac8dab03857d92191e4384709fd2dc621c7f5f4ab783ad9deea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac24bfdbf83140c862824f76ccc396fa7ecebc3f20be75887153e0c50dd936af)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__557cd5e4887c0c64bf136c536be84b6222712eaf92c50c2c616e0ce775c4854c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e45a7ae70d3b9233b69f78d5203f15c3f82303fc8971a1ec0a245ca03d8ca9fa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fbcef9387d619ef41931b07cb28c2b4aebe7c9d4399eec7d1d48b1b70394476f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitComposite]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitComposite]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitComposite]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e73441df6a5dce04cd13c951d88e13fc8a226c8026ab0600517f0376c93e9a74)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitCompound",
    jsii_struct_bases=[],
    name_mapping={"transformations": "transformations"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitCompound:
    def __init__(
        self,
        *,
        transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param transformations: transformations block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__94d684facc77d0d4eac5ea73e58106b29e6af3e38874d4219151af563d1b52c0)
            check_type(argname="argument transformations", value=transformations, expected_type=type_hints["transformations"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if transformations is not None:
            self._values["transformations"] = transformations

    @builtins.property
    def transformations(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitCompoundTransformations"]]]:
        '''transformations block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        result = self._values.get("transformations")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitCompoundTransformations"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitCompound(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitCompoundList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitCompoundList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fe49769948aee69d1266acf49e7166398936e22e2a133ec5820969a3847be13c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitCompoundOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ce8b2caab2fdfdf844220b5c5be0fa1ccae90908957dd3f9a1efa46a29d3a159)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitCompoundOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7c41602209e12bc760831f869e25a1d6c6670bab1a4e9748ed0553f3eeeba3fd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c27cdfbf3faf7026d7f5eff9644a5e9d680c5b2df5560be7cc4c0b8330d82c2f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__24cb90e66de564af238d3f07392686354387c366be17d3c6bb134215483e1339)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitCompound]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitCompound]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7dbfeca2d6a2e1f51527c750c49362445e8142b1df5e859b7a426fa2b109065b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitCompoundOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitCompoundOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e1e2dd9b972ae933b5d17519c8135b9fabb304955a2baed78f3f33726fd744ba)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformations")
    def put_transformations(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a939fd3de5a0b397806af104659abe04b4a8558225c97484e6c2644d1999913)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTransformations", [value]))

    @jsii.member(jsii_name="resetTransformations")
    def reset_transformations(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformations", []))

    @builtins.property
    @jsii.member(jsii_name="transformations")
    def transformations(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitCompoundTransformationsList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitCompoundTransformationsList", jsii.get(self, "transformations"))

    @builtins.property
    @jsii.member(jsii_name="transformationsInput")
    def transformations_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitCompoundTransformations"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitCompoundTransformations"]]], jsii.get(self, "transformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitCompound]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitCompound]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitCompound]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__93305cc8430001cad06c2fc0faab11eb0d2c3b2be85b58ef1d97e395cc33ab06)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitCompoundTransformations",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitCompoundTransformations:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitCompoundTransformations(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitCompoundTransformationsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitCompoundTransformationsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3f597c1ebb949377af61427f3068a2b0e8d10ccbda207cbf99437433d538ec15)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitCompoundTransformationsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ff9f1b8dd5772a7bf71eb77c2b6611a8c825988d4b9a4699fca59c7b48c604b7)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitCompoundTransformationsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aed2c0f91ced8b5b55f15f535fc0a846be377f983ac3ae1b5ce30802d182790a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cabb75d90c4d54e1199fc14d9fa33a8ed18766818cf56ca8ed854bef4d21c1b6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5e4147288469e064e775f207b6873aa26f861307317491fd920d00df87ac45f1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitCompoundTransformations]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitCompoundTransformations]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitCompoundTransformations]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__55c50b042efdd6177c68d7f0b908ee166b2fc3b76250d9723c14edc8ad74c43a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitCompoundTransformationsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitCompoundTransformationsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__963108a4a60a1747f012bcc12ab9b93a47f0fc20f5541d0db47501c69ce15bd6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitCompoundTransformations]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitCompoundTransformations]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitCompoundTransformations]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__949da8a69cb71e748dd4eeafe5cf747c90609b3ff44191c0b42241a2ac533715)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitContrast",
    jsii_struct_bases=[],
    name_mapping={
        "brightness": "brightness",
        "brightness_var": "brightnessVar",
        "contrast": "contrast",
        "contrast_var": "contrastVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitContrast:
    def __init__(
        self,
        *,
        brightness: typing.Optional[builtins.str] = None,
        brightness_var: typing.Optional[builtins.str] = None,
        contrast: typing.Optional[builtins.str] = None,
        contrast_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param brightness: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        :param brightness_var: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        :param contrast: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param contrast_var: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c911bcec5662e3800a8689d9f57f6978a086a7064bd9edccf5c088c26d7775b3)
            check_type(argname="argument brightness", value=brightness, expected_type=type_hints["brightness"])
            check_type(argname="argument brightness_var", value=brightness_var, expected_type=type_hints["brightness_var"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument contrast_var", value=contrast_var, expected_type=type_hints["contrast_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if brightness is not None:
            self._values["brightness"] = brightness
        if brightness_var is not None:
            self._values["brightness_var"] = brightness_var
        if contrast is not None:
            self._values["contrast"] = contrast
        if contrast_var is not None:
            self._values["contrast_var"] = contrast_var

    @builtins.property
    def brightness(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        '''
        result = self._values.get("brightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def brightness_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        '''
        result = self._values.get("brightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        result = self._values.get("contrast_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitContrast(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitContrastList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitContrastList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__38fc3004090a16b92c5d8ab5fc42a9c834de139470bca76598532e103575ef59)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitContrastOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__30855af6299253832652a25bdff35ba05ee78d3e0341f22672aa9dcff75872af)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitContrastOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aa785e1be8c9c9d0e54574b77566d1eb2df32b0dd352a9b9525b046dcaf986a5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__229e72b6053d783640e97ed3d8da6e14459ea0e4a99b174ea8ae4e558e62999e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a85cd0deabbc17e0a2a1c0daf97bfc722aafe3ab602c0b740f69c682af545213)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitContrast]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitContrast]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__51933e38cbbefa9e16c45b4dc77d7cb89c6e4976a339bc14f16c9e424f0c8595)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitContrastOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitContrastOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__361ec59884815b53f1fd64eff0c942e160327e8cafb3c2969283bffe36508daf)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetBrightness")
    def reset_brightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightness", []))

    @jsii.member(jsii_name="resetBrightnessVar")
    def reset_brightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightnessVar", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetContrastVar")
    def reset_contrast_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrastVar", []))

    @builtins.property
    @jsii.member(jsii_name="brightnessInput")
    def brightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="brightnessVarInput")
    def brightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastVarInput")
    def contrast_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="brightness")
    def brightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightness"))

    @brightness.setter
    def brightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5d3f99cab24600a58b00faa64ffb0b5ff352737fd9c127ce7212f2cf46616cb2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightness", value)

    @builtins.property
    @jsii.member(jsii_name="brightnessVar")
    def brightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightnessVar"))

    @brightness_var.setter
    def brightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__465d6c6d254626f856176dc976ef3d75c6ac765b4c041ee435d9271bd861b5fc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrast"))

    @contrast.setter
    def contrast(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a857edaa13ab50fd301969cc473f08a6b0f545bae6a84e5d98c95802669fa1a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrast", value)

    @builtins.property
    @jsii.member(jsii_name="contrastVar")
    def contrast_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrastVar"))

    @contrast_var.setter
    def contrast_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e15760789d6cf44735a6e38d1d51346a39bee9d279407b2a0f31d19aec3bfc47)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrastVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitContrast]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitContrast]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitContrast]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5e1a21f7c006f70f8639c04930b180e1e79736d9851334f02fdf41707195f0ff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitGoop",
    jsii_struct_bases=[],
    name_mapping={
        "chaos": "chaos",
        "chaos_var": "chaosVar",
        "density": "density",
        "density_var": "densityVar",
        "power": "power",
        "power_var": "powerVar",
        "seed": "seed",
        "seed_var": "seedVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitGoop:
    def __init__(
        self,
        *,
        chaos: typing.Optional[builtins.str] = None,
        chaos_var: typing.Optional[builtins.str] = None,
        density: typing.Optional[builtins.str] = None,
        density_var: typing.Optional[builtins.str] = None,
        power: typing.Optional[builtins.str] = None,
        power_var: typing.Optional[builtins.str] = None,
        seed: typing.Optional[builtins.str] = None,
        seed_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param chaos: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        :param chaos_var: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        :param density: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        :param density_var: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        :param power: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        :param power_var: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        :param seed: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        :param seed_var: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__04c7aeb1cdf6636173338024add50d0110b24d972bf858f1b0854e37e211ba83)
            check_type(argname="argument chaos", value=chaos, expected_type=type_hints["chaos"])
            check_type(argname="argument chaos_var", value=chaos_var, expected_type=type_hints["chaos_var"])
            check_type(argname="argument density", value=density, expected_type=type_hints["density"])
            check_type(argname="argument density_var", value=density_var, expected_type=type_hints["density_var"])
            check_type(argname="argument power", value=power, expected_type=type_hints["power"])
            check_type(argname="argument power_var", value=power_var, expected_type=type_hints["power_var"])
            check_type(argname="argument seed", value=seed, expected_type=type_hints["seed"])
            check_type(argname="argument seed_var", value=seed_var, expected_type=type_hints["seed_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if chaos is not None:
            self._values["chaos"] = chaos
        if chaos_var is not None:
            self._values["chaos_var"] = chaos_var
        if density is not None:
            self._values["density"] = density
        if density_var is not None:
            self._values["density_var"] = density_var
        if power is not None:
            self._values["power"] = power
        if power_var is not None:
            self._values["power_var"] = power_var
        if seed is not None:
            self._values["seed"] = seed
        if seed_var is not None:
            self._values["seed_var"] = seed_var

    @builtins.property
    def chaos(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        '''
        result = self._values.get("chaos")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def chaos_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        '''
        result = self._values.get("chaos_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        '''
        result = self._values.get("density")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density_var(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        '''
        result = self._values.get("density_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        '''
        result = self._values.get("power")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power_var(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        '''
        result = self._values.get("power_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        '''
        result = self._values.get("seed")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed_var(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        result = self._values.get("seed_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitGoop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitGoopList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitGoopList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__74542729bbf8fc59f17e8a1d2a916fac72e2ac588dab1e90509e57966c0a4714)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitGoopOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b8d7b22cbac1b39cf23ce2ebc217a95decfaea39d76521719d8ba3b0f658df6c)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitGoopOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c291748d485dd97c7bb07fbfc2ffd76702f35231842a1669900c371a9adf60b5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7ece4b930792b70b00fab512a93772bd5c52730f689ca30d47865eca3886b5a8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f4c182fc4c15e90c790314256a0efa1c0fd40ce0abd9b20f778af015cab36336)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitGoop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitGoop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a12f2e7b2561e008277c23f16ac57721bc541b87825c65bcc321eac34fad2afe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitGoopOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitGoopOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a75fccaf0b64bf517471f5d500192c58bb2554458ae5e3f5cb90a70d3fe593d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetChaos")
    def reset_chaos(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaos", []))

    @jsii.member(jsii_name="resetChaosVar")
    def reset_chaos_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaosVar", []))

    @jsii.member(jsii_name="resetDensity")
    def reset_density(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensity", []))

    @jsii.member(jsii_name="resetDensityVar")
    def reset_density_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensityVar", []))

    @jsii.member(jsii_name="resetPower")
    def reset_power(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPower", []))

    @jsii.member(jsii_name="resetPowerVar")
    def reset_power_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPowerVar", []))

    @jsii.member(jsii_name="resetSeed")
    def reset_seed(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeed", []))

    @jsii.member(jsii_name="resetSeedVar")
    def reset_seed_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeedVar", []))

    @builtins.property
    @jsii.member(jsii_name="chaosInput")
    def chaos_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosInput"))

    @builtins.property
    @jsii.member(jsii_name="chaosVarInput")
    def chaos_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosVarInput"))

    @builtins.property
    @jsii.member(jsii_name="densityInput")
    def density_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityInput"))

    @builtins.property
    @jsii.member(jsii_name="densityVarInput")
    def density_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="powerInput")
    def power_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerInput"))

    @builtins.property
    @jsii.member(jsii_name="powerVarInput")
    def power_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerVarInput"))

    @builtins.property
    @jsii.member(jsii_name="seedInput")
    def seed_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedInput"))

    @builtins.property
    @jsii.member(jsii_name="seedVarInput")
    def seed_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedVarInput"))

    @builtins.property
    @jsii.member(jsii_name="chaos")
    def chaos(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaos"))

    @chaos.setter
    def chaos(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__06af2f89306268b8067c6269786993720efb833daa338860dd8b10a67f96e9b7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaos", value)

    @builtins.property
    @jsii.member(jsii_name="chaosVar")
    def chaos_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaosVar"))

    @chaos_var.setter
    def chaos_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b0b369f0a0796a4ebadf797242df4b72c777bcc526f573cf2175a246a1b31f33)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaosVar", value)

    @builtins.property
    @jsii.member(jsii_name="density")
    def density(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "density"))

    @density.setter
    def density(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f1c9eec40018fd992e7c914f1b3f511841fdc21d00bf73560c62e464a83d9d47)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "density", value)

    @builtins.property
    @jsii.member(jsii_name="densityVar")
    def density_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "densityVar"))

    @density_var.setter
    def density_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__134dfb2bd3368b623c093f28e1dbc1f6eca1a4a2eb20f5ad2fa4842e29b05bcc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "densityVar", value)

    @builtins.property
    @jsii.member(jsii_name="power")
    def power(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "power"))

    @power.setter
    def power(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d202159a274d2b4f9971af43dc8c4d607f00c48bc4252e4d31558cf32ca7b09a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "power", value)

    @builtins.property
    @jsii.member(jsii_name="powerVar")
    def power_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "powerVar"))

    @power_var.setter
    def power_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__30ac672141fe410f28599011753b28ee8beee85208d5fda66a9ff13080e1b4f8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "powerVar", value)

    @builtins.property
    @jsii.member(jsii_name="seed")
    def seed(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seed"))

    @seed.setter
    def seed(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dd16fb28b161ca3d250653fc9f932843f64d8cd078adbfadb2618acbb556293f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seed", value)

    @builtins.property
    @jsii.member(jsii_name="seedVar")
    def seed_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seedVar"))

    @seed_var.setter
    def seed_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e08a2a6e817012e323b5e3d11c376d0b2da095b9de8b7e299820ea097eb0ff6a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seedVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitGoop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitGoop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitGoop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__01dd51e69e0e7efcb653b1bc4f852359df8395f6075a1152f399bc27de0309b4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitGrayscale",
    jsii_struct_bases=[],
    name_mapping={"type": "type", "type_var": "typeVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitGrayscale:
    def __init__(
        self,
        *,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param type: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e5d31c3fded234f8299a0ee7d011021907e26a61082733069297f88348473b4)
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitGrayscale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitGrayscaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitGrayscaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8f096d73edafee693c017387d6f6572988915e266cd518b96f7cba5dfdf34050)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitGrayscaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7b330c810729aab244fae9665198870942afb51c3865397fe2d70248ee1721d2)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitGrayscaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cb1897520305b90e20ce15cbb92422870f407fbf1ce57dfdb9824d727b175ca8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__66b49d117111d11dc325fd23015821a0606e2fede12d9095213261e940dc1cc4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fdb8551b3a377de7f1968b4dd1262d93183f28cf7cb35ea7d6a258f0388cdd38)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitGrayscale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitGrayscale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2f5efda5e521cb717b9849b84266294add236966dc9c7a99060d5ba57f981d6c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitGrayscaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitGrayscaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ec958715809bf471349467900a7b30d841a0bb4a3ef10772a853cfa5b8d5fe43)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1fd94155967cd90c16a39b98d48f63a54e0dc4bd872c4affe61f164c6f9ceee8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ca908e12237fb6f559c0d73f1cba887a772223f5cb8e13350091b5c3dc603d5b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitGrayscale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitGrayscale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitGrayscale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3afe479cb86823376d7de274ccdb45b753c01fcaeec8902fff0314da7c716548)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitHsl",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "lightness": "lightness",
        "lightness_var": "lightnessVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitHsl:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness: typing.Optional[builtins.str] = None,
        lightness_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        :param lightness_var: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4c5ba99d84b99b2ca2ca2e4dcebdb13614e77bacd45885ee44c2ec5e321a0dc0)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness", value=lightness, expected_type=type_hints["lightness"])
            check_type(argname="argument lightness_var", value=lightness_var, expected_type=type_hints["lightness_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness is not None:
            self._values["lightness"] = lightness
        if lightness_var is not None:
            self._values["lightness_var"] = lightness_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        '''
        result = self._values.get("lightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        '''
        result = self._values.get("lightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitHsl(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitHslList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitHslList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__84a5b7f48effd83c9ce9af3ea5dd8b277bc27a4b157f476a02ed352c5619d44a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitHslOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__233bd46a2ed2daedf1a921f7fd226f1cabc8dc3ddeca81f2c2d0989eb199a5c0)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitHslOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a73368d4697963c5b0cbb022d7354ef18918c5c94b8f9097613a49aa8815bc1d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3e931128d6c01e6f9d700875b4d3c079359ccf48cd9021695bccd568281025ec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be0c19e4b5701755505c0a7116764de2e8148e94a0e826309e9033882db269c0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitHsl]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitHsl]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2c272d580aa5e8c8490093600b9da50bc66e271e65137d6ca01b0963547442cb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitHslOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitHslOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2cedd436997a0ae2fe5142a763e012c2c6547f821f8e103cbde4ee84ec3e0f1a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightness")
    def reset_lightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightness", []))

    @jsii.member(jsii_name="resetLightnessVar")
    def reset_lightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessInput")
    def lightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessVarInput")
    def lightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5d174fa8bf4db5133f64d66c0da895120d64bfb32f02edbe65be0e9933942f30)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0edea85fedcb90fdc870128e5b2a331028699ae87af71f654f66ad6d30df845d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightness")
    def lightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightness"))

    @lightness.setter
    def lightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f1dd2a5cf0644ee31245303c9dda5c9e75843cd97b1e32eec983495eacda71c9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightness", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessVar")
    def lightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessVar"))

    @lightness_var.setter
    def lightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aebf12a38b0f80c3a7779e6f99c3537b23fe3c4547250e408311fee82639fa53)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7b3787e86db0b02ee11f8b69e9ece76eb4daec338e00366c41d4dcf81dfa0fc2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__178df3ec57fa1ba6a2a36dc53e0b906202388c95e2d75a38bbf60f7a05924d03)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitHsl]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitHsl]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitHsl]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6c50bdcded98803d8db22e1de16a10a29d89458b7c0ef60043b1a5b5c11366b8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitHsv",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitHsv:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        :param value: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c0e1528dde240b2149856751d735f87c4b28e33823ba8bc1d14a515fb0fbff55)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitHsv(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitHsvList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitHsvList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__22da26befe9c062c1e97453126f917792b9ec4141a77eb5a6e7a1f16d9aac5c5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitHsvOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b7191921d666a8d12d3036da2e7d91ed4b7c1773f227539b232826c1c5bb1d5f)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitHsvOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cc976dad16260174b4b30cd143a8322116917b2b70d8a57eb9c794f058e6a993)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__57006ef7c9ae7ced947d8bbca87b25a4a7eefc46017553bb6eff0e92df238d12)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9f96a885d545f1c55a600f09a1cafa21f2e6ccd3dbc1777c95c95afdd6d07f5d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitHsv]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitHsv]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__00475a4fef0692b0d2aec5c3d7bd7180750e5c5acc861ab38d67d08647e07e5e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitHsvOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitHsvOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__87f73c1cea137b027d81dd5514269d9494ac6f8bf5af7b90c942d9c5d8f3062c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5399c38604e6b0d08aa4c613ad7bcd6b49a629dfffa313723a1da189b72bb3c6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__925752f10808e232599cc501fed8d8abdcb6c5b0a03e500199bb1c06e5f8a97d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fccfa0ceb7a2d50de018cf89ce296a7c41ba8775053aefc281a2b0ec3bb2cf27)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__41b57b1039e198f2e2fae09574c0e2e2797569b929d767a72b55f9fa03cbcccc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c5ba7514ab2a7f5ac35f9a1e7663c1d22d0f39a9d3ee87bb6b99ae6a1712e831)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7cd6800287dd95f259603f21fb44264ffb31e6b5c1cb56481b6e08a621f41afc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitHsv]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitHsv]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitHsv]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__72044e1a615d46b8a4e2faf9b459e573f4abd0851060f7a8ebe4b90e9a642eaf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfDimension",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "dimension": "dimension",
        "dimension_var": "dimensionVar",
        "equal": "equal",
        "greater_than": "greaterThan",
        "less_than": "lessThan",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfDimension:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        dimension: typing.Optional[builtins.str] = None,
        dimension_var: typing.Optional[builtins.str] = None,
        equal: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionEqual", typing.Dict[builtins.str, typing.Any]]] = None,
        greater_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionGreaterThan", typing.Dict[builtins.str, typing.Any]]] = None,
        less_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionLessThan", typing.Dict[builtins.str, typing.Any]]] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param dimension: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        :param dimension_var: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        :param equal: equal block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        :param greater_than: greater_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        :param less_than: less_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        :param value: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionDefault(**default)
        if isinstance(equal, dict):
            equal = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionEqual(**equal)
        if isinstance(greater_than, dict):
            greater_than = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionGreaterThan(**greater_than)
        if isinstance(less_than, dict):
            less_than = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionLessThan(**less_than)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__764e34ec24d9b860ea2257b433b9383615917741e8ff0765695c46fbc30e1d4c)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument dimension", value=dimension, expected_type=type_hints["dimension"])
            check_type(argname="argument dimension_var", value=dimension_var, expected_type=type_hints["dimension_var"])
            check_type(argname="argument equal", value=equal, expected_type=type_hints["equal"])
            check_type(argname="argument greater_than", value=greater_than, expected_type=type_hints["greater_than"])
            check_type(argname="argument less_than", value=less_than, expected_type=type_hints["less_than"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if dimension is not None:
            self._values["dimension"] = dimension
        if dimension_var is not None:
            self._values["dimension_var"] = dimension_var
        if equal is not None:
            self._values["equal"] = equal
        if greater_than is not None:
            self._values["greater_than"] = greater_than
        if less_than is not None:
            self._values["less_than"] = less_than
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionDefault"], result)

    @builtins.property
    def dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        '''
        result = self._values.get("dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        '''
        result = self._values.get("dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def equal(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionEqual"]:
        '''equal block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        '''
        result = self._values.get("equal")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionEqual"], result)

    @builtins.property
    def greater_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionGreaterThan"]:
        '''greater_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        '''
        result = self._values.get("greater_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionGreaterThan"], result)

    @builtins.property
    def less_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionLessThan"]:
        '''less_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        '''
        result = self._values.get("less_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionLessThan"], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfDimension(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__236823344a27d34bbe90a734a347c24a653f738b396acd4b867e9b3e2612164b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2af101d84759683f56a7fe5ef3f18ffec2caeea2a5adaf0e28a369fef1cf3c19)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionEqual",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionEqual:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionEqual(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionEqualOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionEqualOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d16f0bb845f038ff42ef997075117e07b6477f6cfbff0e8384cb6f41c4897d0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionEqual], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionEqual],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d9ed05866a1cddb3789d9777d3f21e9672a9432b7ab35b0f48a44d21d5b34a3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionGreaterThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionGreaterThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionGreaterThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionGreaterThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionGreaterThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f11f2fb2671c754fbf346a86e2ca6e105e6fd5f02643a09e1c9d6e5b0a08ce2c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionGreaterThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionGreaterThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__22b3dac1e1741e4e988a42523ea9d423d4b5e7686f2ac8c110b28c3b817184f7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionLessThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionLessThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionLessThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionLessThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionLessThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__45ac8354616532d6b8be167a6ac8b337a8a4f09cf4ad3d842e21a5219663e219)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionLessThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionLessThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1cf7e68e23e27859b153dc49222ccbbc7328818c9f5a03ab7bed61454f615c33)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__17525b945c50dfa363dbcfd8cf2e101171badfc3d605186f5ccdd627c8e07ebf)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__105c7eb9a4ecad0d7980d7200ae9d5b65796f91321b0301a87edf9d7b783951c)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__274a9226cfbef431bd8826d8d52ac72dab886a5012e25a2d27d0b5b522fcd289)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a3ae77a8a3c8f7fb2d9f54a487ec2888d16e433c10298b8d29251929ab8c5171)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__31ad5e4b08ee602f544710ab760f4873d078398827ae541a89d3fb49c832116d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfDimension]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfDimension]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__549bfa0df3b78744c6b40c4e899eeef74a4c4fd194269a9a622399621b59e979)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__51e4d1ee6b625c72c071410c5d8fc69549997ab73dc7a8970b06aac4b124cb9a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putEqual")
    def put_equal(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionEqual()

        return typing.cast(None, jsii.invoke(self, "putEqual", [value]))

    @jsii.member(jsii_name="putGreaterThan")
    def put_greater_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionGreaterThan()

        return typing.cast(None, jsii.invoke(self, "putGreaterThan", [value]))

    @jsii.member(jsii_name="putLessThan")
    def put_less_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionLessThan()

        return typing.cast(None, jsii.invoke(self, "putLessThan", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetDimension")
    def reset_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimension", []))

    @jsii.member(jsii_name="resetDimensionVar")
    def reset_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimensionVar", []))

    @jsii.member(jsii_name="resetEqual")
    def reset_equal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEqual", []))

    @jsii.member(jsii_name="resetGreaterThan")
    def reset_greater_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGreaterThan", []))

    @jsii.member(jsii_name="resetLessThan")
    def reset_less_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLessThan", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="equal")
    def equal(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionEqualOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionEqualOutputReference, jsii.get(self, "equal"))

    @builtins.property
    @jsii.member(jsii_name="greaterThan")
    def greater_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionGreaterThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionGreaterThanOutputReference, jsii.get(self, "greaterThan"))

    @builtins.property
    @jsii.member(jsii_name="lessThan")
    def less_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionLessThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionLessThanOutputReference, jsii.get(self, "lessThan"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionInput")
    def dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionVarInput")
    def dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="equalInput")
    def equal_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionEqual], jsii.get(self, "equalInput"))

    @builtins.property
    @jsii.member(jsii_name="greaterThanInput")
    def greater_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionGreaterThan], jsii.get(self, "greaterThanInput"))

    @builtins.property
    @jsii.member(jsii_name="lessThanInput")
    def less_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionLessThan], jsii.get(self, "lessThanInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="dimension")
    def dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimension"))

    @dimension.setter
    def dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d2e413e043656358bf728d428fee05db3dcd6429a3ef71e42c3ae76425fcda52)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimension", value)

    @builtins.property
    @jsii.member(jsii_name="dimensionVar")
    def dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimensionVar"))

    @dimension_var.setter
    def dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e43a11db5e680127972572deea5a0afc142160620a7809688091d5fe649d5be1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__24e99f4b4ebf51e9f0250885791514d960aa17bfe576f37c3761b3532f08c152)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1cb35927d7b6fb73798f32c708c554c4337f5728fbbf5d7e1d6c08994e5a656d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfDimension]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfDimension]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfDimension]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d072beb138510ec606f152e1dd2fcb1acdc859fca6429f8e154856b32ce5c51)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfOrientation",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "landscape": "landscape",
        "portrait": "portrait",
        "square": "square",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfOrientation:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        landscape: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationLandscape", typing.Dict[builtins.str, typing.Any]]] = None,
        portrait: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationPortrait", typing.Dict[builtins.str, typing.Any]]] = None,
        square: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationSquare", typing.Dict[builtins.str, typing.Any]]] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param landscape: landscape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        :param portrait: portrait block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        :param square: square block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationDefault(**default)
        if isinstance(landscape, dict):
            landscape = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationLandscape(**landscape)
        if isinstance(portrait, dict):
            portrait = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationPortrait(**portrait)
        if isinstance(square, dict):
            square = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationSquare(**square)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d581a95f782e09a857b1e4cdcf16ba6e8a7b1eaa40b4aea7f5290f2121b5b6fd)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument landscape", value=landscape, expected_type=type_hints["landscape"])
            check_type(argname="argument portrait", value=portrait, expected_type=type_hints["portrait"])
            check_type(argname="argument square", value=square, expected_type=type_hints["square"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if landscape is not None:
            self._values["landscape"] = landscape
        if portrait is not None:
            self._values["portrait"] = portrait
        if square is not None:
            self._values["square"] = square

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationDefault"], result)

    @builtins.property
    def landscape(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationLandscape"]:
        '''landscape block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        '''
        result = self._values.get("landscape")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationLandscape"], result)

    @builtins.property
    def portrait(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationPortrait"]:
        '''portrait block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        '''
        result = self._values.get("portrait")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationPortrait"], result)

    @builtins.property
    def square(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationSquare"]:
        '''square block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        result = self._values.get("square")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationSquare"], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfOrientation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8fedad078882f47bf04de4339ccade5bf4290df1a613fae3d58968043177c4bb)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0c6920ba22aca01038c02243e29de411be3625ccf4866712432c7e7c31722cd2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationLandscape",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationLandscape:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationLandscape(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationLandscapeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationLandscapeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a93a74f595321f63ff3190885c677a57acc8a889c792d25d7ac66258da8d4afc)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationLandscape], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationLandscape],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__91b32ca1698de4b58d08a4c54b21158e53ffb306b36ac72a2640c8f1dea8455d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c211d3cd83b329cf0756aa2959b8e76ccae92946f9874f52309d49cfed8fc61a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__319698281836804f2daeaca0642b0f9a35de0eb914c4f02d471e70e88b4209b8)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__89401592f45efee79aaf66fb6b0dc59ab53ed262b796c42b1bdbd5935ac7166e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__010d2e7af342a9f41c95a2befd1c3878e058883fe251e2f0e27af754b8c41f24)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fed24424cc9afe38e877f7ef502a7c8e1414ce07a69ee0319157ee5305e15824)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfOrientation]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfOrientation]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a71b0fbf97e0f1de58fdc65acbbc4d91473ff884930a4d338105282c1b1a1fbc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__84fdfcca26a8c04950f800272fdf64ba0f5a7c7e655c302a1e2a926e6235e4b0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putLandscape")
    def put_landscape(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationLandscape()

        return typing.cast(None, jsii.invoke(self, "putLandscape", [value]))

    @jsii.member(jsii_name="putPortrait")
    def put_portrait(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationPortrait()

        return typing.cast(None, jsii.invoke(self, "putPortrait", [value]))

    @jsii.member(jsii_name="putSquare")
    def put_square(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationSquare()

        return typing.cast(None, jsii.invoke(self, "putSquare", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetLandscape")
    def reset_landscape(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLandscape", []))

    @jsii.member(jsii_name="resetPortrait")
    def reset_portrait(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPortrait", []))

    @jsii.member(jsii_name="resetSquare")
    def reset_square(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSquare", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="landscape")
    def landscape(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationLandscapeOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationLandscapeOutputReference, jsii.get(self, "landscape"))

    @builtins.property
    @jsii.member(jsii_name="portrait")
    def portrait(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationPortraitOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationPortraitOutputReference", jsii.get(self, "portrait"))

    @builtins.property
    @jsii.member(jsii_name="square")
    def square(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationSquareOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationSquareOutputReference", jsii.get(self, "square"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="landscapeInput")
    def landscape_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationLandscape], jsii.get(self, "landscapeInput"))

    @builtins.property
    @jsii.member(jsii_name="portraitInput")
    def portrait_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationPortrait"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationPortrait"], jsii.get(self, "portraitInput"))

    @builtins.property
    @jsii.member(jsii_name="squareInput")
    def square_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationSquare"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationSquare"], jsii.get(self, "squareInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfOrientation]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfOrientation]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfOrientation]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__370c21772b1cc381bd3f6484e527a1d59099b196bc8caa4b182ed28bdb0c7e16)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationPortrait",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationPortrait:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationPortrait(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationPortraitOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationPortraitOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dbed07300c6ce67343aab2f98ffc0eb293edb56f31f63a18bb65155d0101f297)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationPortrait]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationPortrait], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationPortrait],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__85f77992d756579babfff7b518e735684ea70c2ccbaff8381139d7c4e34252d4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationSquare",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationSquare:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationSquare(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationSquareOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationSquareOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c899b42fb0d53f3156cd870bdc556e525e0778ded4e53c6b2b474c440d314499)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationSquare]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationSquare], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationSquare],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__15e96ee2d75fe627167bd5f2a9e926f42fa7deaebdc1071cdf6b51f6e7e3fc53)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitMaxColors",
    jsii_struct_bases=[],
    name_mapping={"colors": "colors", "colors_var": "colorsVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitMaxColors:
    def __init__(
        self,
        *,
        colors: typing.Optional[builtins.str] = None,
        colors_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param colors: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        :param colors_var: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__65f40e771755941849b68b9f8be1b513002ce0fdc4529b794e650baeed9fd6e7)
            check_type(argname="argument colors", value=colors, expected_type=type_hints["colors"])
            check_type(argname="argument colors_var", value=colors_var, expected_type=type_hints["colors_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if colors is not None:
            self._values["colors"] = colors
        if colors_var is not None:
            self._values["colors_var"] = colors_var

    @builtins.property
    def colors(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        '''
        result = self._values.get("colors")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def colors_var(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        result = self._values.get("colors_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitMaxColors(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitMaxColorsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitMaxColorsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ed54fd9d8fe50212e443f96c36028ad931898700a19748fa2db6f19243829402)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitMaxColorsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1b40fc0b1853b27d4162907da4e8a4704b08c86762826d1b9d6ddd2eddbebc42)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitMaxColorsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f16edf3377d78dbb8cc309a5127165a7d4a8688e23ac1b4e2772781b18775db)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__60918f238cbeed52733c579f1ed0a663c7c06e9a5ae6d5ecb33d5a6156c038cd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b945f09482f16b3bc0ce5744e345f68f9ba998c51455becaa6fdd7ca020dec86)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitMaxColors]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitMaxColors]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a0e177f81c456ecfce0f4547254c936984a2a60b6c48be99fd3d3e9ad81c637e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitMaxColorsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitMaxColorsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1003e78fd079b9e656ab935a0bae96791defc04444f7d0a32eb3161db6f04f52)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColors")
    def reset_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColors", []))

    @jsii.member(jsii_name="resetColorsVar")
    def reset_colors_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorsVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorsInput")
    def colors_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsInput"))

    @builtins.property
    @jsii.member(jsii_name="colorsVarInput")
    def colors_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsVarInput"))

    @builtins.property
    @jsii.member(jsii_name="colors")
    def colors(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colors"))

    @colors.setter
    def colors(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac20101aec26c7128d22538ca07a80b6f9e16480eac67278056d0ef65cd01c9f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colors", value)

    @builtins.property
    @jsii.member(jsii_name="colorsVar")
    def colors_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorsVar"))

    @colors_var.setter
    def colors_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2bc4f2208e77799c33e6962b44845b81eae39ad1b5eab8a8815dbf808adbdaa3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorsVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitMaxColors]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitMaxColors]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitMaxColors]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__021b7da76cd7c9a8cc6212565849c1b1e694a6f8ec6e3f190fa59ec279ef3d25)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitMirror",
    jsii_struct_bases=[],
    name_mapping={
        "horizontal": "horizontal",
        "horizontal_var": "horizontalVar",
        "vertical": "vertical",
        "vertical_var": "verticalVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitMirror:
    def __init__(
        self,
        *,
        horizontal: typing.Optional[builtins.str] = None,
        horizontal_var: typing.Optional[builtins.str] = None,
        vertical: typing.Optional[builtins.str] = None,
        vertical_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param horizontal: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        :param horizontal_var: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        :param vertical: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        :param vertical_var: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7e33665eb408b367833134696df8905cf2275fa6046c81c46d8a5e8bd38ed41d)
            check_type(argname="argument horizontal", value=horizontal, expected_type=type_hints["horizontal"])
            check_type(argname="argument horizontal_var", value=horizontal_var, expected_type=type_hints["horizontal_var"])
            check_type(argname="argument vertical", value=vertical, expected_type=type_hints["vertical"])
            check_type(argname="argument vertical_var", value=vertical_var, expected_type=type_hints["vertical_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if horizontal is not None:
            self._values["horizontal"] = horizontal
        if horizontal_var is not None:
            self._values["horizontal_var"] = horizontal_var
        if vertical is not None:
            self._values["vertical"] = vertical
        if vertical_var is not None:
            self._values["vertical_var"] = vertical_var

    @builtins.property
    def horizontal(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        '''
        result = self._values.get("horizontal")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def horizontal_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        '''
        result = self._values.get("horizontal_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        '''
        result = self._values.get("vertical")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        result = self._values.get("vertical_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitMirror(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitMirrorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitMirrorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2b8550f823010873a736fade5dfcf94889c700f80a0307a542df624fb060d3ff)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitMirrorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ddb20967fbffc46fdcfd64a3f451c6bfaa9ce681f52183c835baf5a3fb324071)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitMirrorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f4434f7dd2c41e4161cf3f804cc4afa72c7105ed2792d92c48992b97233d0693)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e1e184c8060ec2f9fa41fd8f46ada127edf67e34cc7d5e6211c59e48f25f6526)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__31d9717275ee2d2f1afa6d31b26d3d6a90dd0184eb0b0413a2c4329f5e020bda)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitMirror]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitMirror]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5296771291a5babcb95ddae07b8a66f6b28a367d3fbb1a64813217b0110c5e3d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitMirrorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitMirrorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1d510a613551a66ec566f8061ce820df5e4eb08f403bdb8e2742254c06303357)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHorizontal")
    def reset_horizontal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontal", []))

    @jsii.member(jsii_name="resetHorizontalVar")
    def reset_horizontal_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontalVar", []))

    @jsii.member(jsii_name="resetVertical")
    def reset_vertical(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVertical", []))

    @jsii.member(jsii_name="resetVerticalVar")
    def reset_vertical_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVerticalVar", []))

    @builtins.property
    @jsii.member(jsii_name="horizontalInput")
    def horizontal_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontalVarInput")
    def horizontal_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalInput")
    def vertical_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalVarInput")
    def vertical_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontal")
    def horizontal(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontal"))

    @horizontal.setter
    def horizontal(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c8e9aff00cf29c8fe920676b4a542c1a6034206ab79f051bd31f35f6dcd782a9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontal", value)

    @builtins.property
    @jsii.member(jsii_name="horizontalVar")
    def horizontal_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontalVar"))

    @horizontal_var.setter
    def horizontal_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__89f0457880b51601cf5fc7dd2ef4d00b316c44025a9d9c25fe85b0c97c0c93e3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontalVar", value)

    @builtins.property
    @jsii.member(jsii_name="vertical")
    def vertical(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "vertical"))

    @vertical.setter
    def vertical(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dc5ec611504bfc222a741410bb908178ec4d90d714382405795132ae3332d3c6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "vertical", value)

    @builtins.property
    @jsii.member(jsii_name="verticalVar")
    def vertical_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "verticalVar"))

    @vertical_var.setter
    def vertical_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f579013792f9164cc3fc293d5a559f34e4533862bef07da1a3098bbe61d0784b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "verticalVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitMirror]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitMirror]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitMirror]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b949e77b94d30096c5ded10c35298be60d9a3d6a9e7de53d9405910fa772d785)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitMonoHue",
    jsii_struct_bases=[],
    name_mapping={"hue": "hue", "hue_var": "hueVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitMonoHue:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8d90be897fa313456eb99d32a55d5331cb3b464cdbba0c8e94f28e37ceda52e0)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitMonoHue(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitMonoHueList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitMonoHueList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5c30a0bb3c82b8110d1d63a41930e044b5a16d572af5e7040554d33cc1147dea)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitMonoHueOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__345562be573d1b710a5fd83e4c1c9fbf05b10602d9ff97fc4eb65f1762335b22)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitMonoHueOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cff4b869feae8ea8fb4e809d10d09d22c3498a9acae509a82fc99c5da8091e15)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__903f0ce7099673e263d437fcc0c98548b58ad825f2c76562493269f2fe73e26d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__20adefd512fe8733124096f269bddfe2b660bdd79a4da762803c229c7182b53b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitMonoHue]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitMonoHue]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1d1cca5b9ca359760a035ea562a5d3c62e74b5525c6a72a7150e199acff63df8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitMonoHueOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitMonoHueOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__866449c141bb4242f2f33e488086018f0429d69a8b571073972469459de8156a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__54daf97d89242c1eb35f73096c2c765c0504ecf425e9159a0207c644af70452d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb7a696f11331569bcd6dd0e60797994309db882cdbf92bd6020b8a465cb35e7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitMonoHue]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitMonoHue]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitMonoHue]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e4457e649d14afa4152496389b79c566c734cad3934e3154f66c4cc28934ef78)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitOpacity",
    jsii_struct_bases=[],
    name_mapping={"opacity": "opacity", "opacity_var": "opacityVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitOpacity:
    def __init__(
        self,
        *,
        opacity: typing.Optional[builtins.str] = None,
        opacity_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param opacity: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param opacity_var: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c9f40ee3743d5cce86b853e006f64516c13be5bccd46c1a08f051d24c8d1b9cc)
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument opacity_var", value=opacity_var, expected_type=type_hints["opacity_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if opacity is not None:
            self._values["opacity"] = opacity
        if opacity_var is not None:
            self._values["opacity_var"] = opacity_var

    @builtins.property
    def opacity(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def opacity_var(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        result = self._values.get("opacity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitOpacity(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitOpacityList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitOpacityList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7bbc0b2181db813f1d14b58ae7116dbdab150dc6733e153afafec19a5047443b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitOpacityOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8dbfaa4ea063d25a5eeafc1cf02ab0634fc8bb8aff8928c4f5c1de5fae5b5128)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitOpacityOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__91fd96fa398209965c324bd995726b9cc781d89fa228d905bf0ac080ee50fb4b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__139e0f58a9777ce02dba6de536a8165b02b5d3d2a26ff0e737addff98e2b1484)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__65f869348166c11e993a6b5906a9a612b77668f2b9b2e8bd9337b3c21eaf9256)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitOpacity]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitOpacity]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8080b02af5026b3b7f7f2e2d9bb2eb884432c0731eb235e78d66d5541ec55f4a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitOpacityOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitOpacityOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4d34eedaac131a887ba977b7121da97e8eb7a43a64736f9d26c9434330089c3c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetOpacityVar")
    def reset_opacity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacityVar", []))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityVarInput")
    def opacity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacity"))

    @opacity.setter
    def opacity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ba526b33702923a1df3513c0f6fb172fc3176f9a4154405611747f2354e0707d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacity", value)

    @builtins.property
    @jsii.member(jsii_name="opacityVar")
    def opacity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacityVar"))

    @opacity_var.setter
    def opacity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__263813861c549e401458622fb665561389a96ce984f84dbf44bc8462a8d2a511)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacityVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitOpacity]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitOpacity]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitOpacity]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c8f502bfa3b8cea24cfac7e97c756c78e9d3e8ad3be60d7a5c4fa0b823ec8af7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac81e2ce1662445f7339100db3b3efc1bf4dd59621548f23ad49715ac463277d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putBackgroundColor")
    def put_background_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ebf072652af976139490f50a50c96971493f9647b58933a6831f626ac91b7ef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBackgroundColor", [value]))

    @jsii.member(jsii_name="putBlur")
    def put_blur(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitBlur, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4308fec4696862fc8f1776f9d94f069a35323fae462a4ff0af37d06f7bd1196c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBlur", [value]))

    @jsii.member(jsii_name="putChromaKey")
    def put_chroma_key(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitChromaKey, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a21d2324a9e07369c0804ae6751547a2cd216143582ab6521bcb5c864f9dbb7e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putChromaKey", [value]))

    @jsii.member(jsii_name="putComposite")
    def put_composite(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitComposite, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dcd9287c3cac5042eb25343233a194f41cefd93bda0ee8bc3881db143b4e67c2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putComposite", [value]))

    @jsii.member(jsii_name="putCompound")
    def put_compound(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitCompound, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0a02b3718994a2b9f2db54aebdbb247f07341fea1d5073e2e2e4370e9b0dcdc8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCompound", [value]))

    @jsii.member(jsii_name="putContrast")
    def put_contrast(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitContrast, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__625e053c25318d2454e51635304539435d0752997a761f42a38abc7ffb731f27)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putContrast", [value]))

    @jsii.member(jsii_name="putGoop")
    def put_goop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitGoop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cc5e7dd52f16fea769fad69190d01939ec74d8602fbd2fa2fd8740063cfb9d51)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGoop", [value]))

    @jsii.member(jsii_name="putGrayscale")
    def put_grayscale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitGrayscale, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0118a8a119aa3cc8bee4db1a2e4c6bfb5d6777093d2dd29cb59c594997ece49f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGrayscale", [value]))

    @jsii.member(jsii_name="putHsl")
    def put_hsl(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitHsl, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5e43b3d3b7d8c25ef69e039512f22253b81b0251e5971ab701d235c4c18367ca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsl", [value]))

    @jsii.member(jsii_name="putHsv")
    def put_hsv(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitHsv, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__03c90a8f1b43ec6eecb541ed7313005ec348643d81610707338ce3237bb74f8c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsv", [value]))

    @jsii.member(jsii_name="putIfDimension")
    def put_if_dimension(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfDimension, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d6e06e2b15adf5a07d708adffb52b6f2584dbf10091818ad4baf2b5c3456120e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfDimension", [value]))

    @jsii.member(jsii_name="putIfOrientation")
    def put_if_orientation(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__219c9fa8e31f82c710c874a81539d1dbbedcfd7512ac86cbef0276f2b28f1859)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfOrientation", [value]))

    @jsii.member(jsii_name="putMaxColors")
    def put_max_colors(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitMaxColors, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b3c0c7eec5acc1eff4d26e9f4f400c5da22a9da0aae2dffad2d6f50e78cb26f6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMaxColors", [value]))

    @jsii.member(jsii_name="putMirror")
    def put_mirror(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitMirror, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__19b4fa90defc7d19fb3061fa7f432f4cdab2024285b05b7e1babf86cab0f6af1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMirror", [value]))

    @jsii.member(jsii_name="putMonoHue")
    def put_mono_hue(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitMonoHue, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a8293a85ec17f02af87d6d6854441d0aac3d93115ee44de6c0c4957a93bfd862)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMonoHue", [value]))

    @jsii.member(jsii_name="putOpacity")
    def put_opacity(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitOpacity, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d56ecd9aa7559d9b1ea5af4c21e8d10e5385680135cbe2e232157e7b578d05a0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putOpacity", [value]))

    @jsii.member(jsii_name="putRemoveColor")
    def put_remove_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitRemoveColor", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bd278cc0b6e1ad2511957dc2260545001295db1cb3c848a583b1aecc02084382)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRemoveColor", [value]))

    @jsii.member(jsii_name="putUnsharpMask")
    def put_unsharp_mask(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitUnsharpMask", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bdec854dad8f071218312c2aa126489d69d9cc5c8706fe379504dda3b15d926a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putUnsharpMask", [value]))

    @jsii.member(jsii_name="resetBackgroundColor")
    def reset_background_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBackgroundColor", []))

    @jsii.member(jsii_name="resetBlur")
    def reset_blur(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBlur", []))

    @jsii.member(jsii_name="resetChromaKey")
    def reset_chroma_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChromaKey", []))

    @jsii.member(jsii_name="resetComposite")
    def reset_composite(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetComposite", []))

    @jsii.member(jsii_name="resetCompound")
    def reset_compound(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCompound", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetGoop")
    def reset_goop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGoop", []))

    @jsii.member(jsii_name="resetGrayscale")
    def reset_grayscale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGrayscale", []))

    @jsii.member(jsii_name="resetHsl")
    def reset_hsl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsl", []))

    @jsii.member(jsii_name="resetHsv")
    def reset_hsv(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsv", []))

    @jsii.member(jsii_name="resetIfDimension")
    def reset_if_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfDimension", []))

    @jsii.member(jsii_name="resetIfOrientation")
    def reset_if_orientation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfOrientation", []))

    @jsii.member(jsii_name="resetMaxColors")
    def reset_max_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxColors", []))

    @jsii.member(jsii_name="resetMirror")
    def reset_mirror(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMirror", []))

    @jsii.member(jsii_name="resetMonoHue")
    def reset_mono_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonoHue", []))

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetRemoveColor")
    def reset_remove_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRemoveColor", []))

    @jsii.member(jsii_name="resetUnsharpMask")
    def reset_unsharp_mask(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUnsharpMask", []))

    @builtins.property
    @jsii.member(jsii_name="backgroundColor")
    def background_color(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitBackgroundColorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitBackgroundColorList, jsii.get(self, "backgroundColor"))

    @builtins.property
    @jsii.member(jsii_name="blur")
    def blur(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitBlurList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitBlurList, jsii.get(self, "blur"))

    @builtins.property
    @jsii.member(jsii_name="chromaKey")
    def chroma_key(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitChromaKeyList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitChromaKeyList, jsii.get(self, "chromaKey"))

    @builtins.property
    @jsii.member(jsii_name="composite")
    def composite(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitCompositeList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitCompositeList, jsii.get(self, "composite"))

    @builtins.property
    @jsii.member(jsii_name="compound")
    def compound(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitCompoundList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitCompoundList, jsii.get(self, "compound"))

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitContrastList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitContrastList, jsii.get(self, "contrast"))

    @builtins.property
    @jsii.member(jsii_name="goop")
    def goop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitGoopList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitGoopList, jsii.get(self, "goop"))

    @builtins.property
    @jsii.member(jsii_name="grayscale")
    def grayscale(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitGrayscaleList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitGrayscaleList, jsii.get(self, "grayscale"))

    @builtins.property
    @jsii.member(jsii_name="hsl")
    def hsl(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitHslList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitHslList, jsii.get(self, "hsl"))

    @builtins.property
    @jsii.member(jsii_name="hsv")
    def hsv(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitHsvList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitHsvList, jsii.get(self, "hsv"))

    @builtins.property
    @jsii.member(jsii_name="ifDimension")
    def if_dimension(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionList, jsii.get(self, "ifDimension"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientation")
    def if_orientation(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationList, jsii.get(self, "ifOrientation"))

    @builtins.property
    @jsii.member(jsii_name="maxColors")
    def max_colors(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitMaxColorsList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitMaxColorsList, jsii.get(self, "maxColors"))

    @builtins.property
    @jsii.member(jsii_name="mirror")
    def mirror(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitMirrorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitMirrorList, jsii.get(self, "mirror"))

    @builtins.property
    @jsii.member(jsii_name="monoHue")
    def mono_hue(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitMonoHueList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitMonoHueList, jsii.get(self, "monoHue"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitOpacityList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitOpacityList, jsii.get(self, "opacity"))

    @builtins.property
    @jsii.member(jsii_name="removeColor")
    def remove_color(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitRemoveColorList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitRemoveColorList", jsii.get(self, "removeColor"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMask")
    def unsharp_mask(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitUnsharpMaskList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitUnsharpMaskList", jsii.get(self, "unsharpMask"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColorInput")
    def background_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitBackgroundColor]]], jsii.get(self, "backgroundColorInput"))

    @builtins.property
    @jsii.member(jsii_name="blurInput")
    def blur_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitBlur]]], jsii.get(self, "blurInput"))

    @builtins.property
    @jsii.member(jsii_name="chromaKeyInput")
    def chroma_key_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitChromaKey]]], jsii.get(self, "chromaKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="compositeInput")
    def composite_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitComposite]]], jsii.get(self, "compositeInput"))

    @builtins.property
    @jsii.member(jsii_name="compoundInput")
    def compound_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitCompound]]], jsii.get(self, "compoundInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitContrast]]], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="goopInput")
    def goop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitGoop]]], jsii.get(self, "goopInput"))

    @builtins.property
    @jsii.member(jsii_name="grayscaleInput")
    def grayscale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitGrayscale]]], jsii.get(self, "grayscaleInput"))

    @builtins.property
    @jsii.member(jsii_name="hslInput")
    def hsl_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitHsl]]], jsii.get(self, "hslInput"))

    @builtins.property
    @jsii.member(jsii_name="hsvInput")
    def hsv_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitHsv]]], jsii.get(self, "hsvInput"))

    @builtins.property
    @jsii.member(jsii_name="ifDimensionInput")
    def if_dimension_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfDimension]]], jsii.get(self, "ifDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientationInput")
    def if_orientation_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfOrientation]]], jsii.get(self, "ifOrientationInput"))

    @builtins.property
    @jsii.member(jsii_name="maxColorsInput")
    def max_colors_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitMaxColors]]], jsii.get(self, "maxColorsInput"))

    @builtins.property
    @jsii.member(jsii_name="mirrorInput")
    def mirror_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitMirror]]], jsii.get(self, "mirrorInput"))

    @builtins.property
    @jsii.member(jsii_name="monoHueInput")
    def mono_hue_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitMonoHue]]], jsii.get(self, "monoHueInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitOpacity]]], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="removeColorInput")
    def remove_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitRemoveColor"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitRemoveColor"]]], jsii.get(self, "removeColorInput"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMaskInput")
    def unsharp_mask_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitUnsharpMask"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitUnsharpMask"]]], jsii.get(self, "unsharpMaskInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortrait]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortrait], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortrait],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a5d42ed786f4319af034380adf16aaade5abb478b7d673de628c397263f5bae4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitRemoveColor",
    jsii_struct_bases=[],
    name_mapping={
        "color": "color",
        "color_var": "colorVar",
        "feather": "feather",
        "feather_var": "featherVar",
        "tolerance": "tolerance",
        "tolerance_var": "toleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitRemoveColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
        feather: typing.Optional[builtins.str] = None,
        feather_var: typing.Optional[builtins.str] = None,
        tolerance: typing.Optional[builtins.str] = None,
        tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        :param feather: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        :param feather_var: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        :param tolerance: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        :param tolerance_var: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f48391653144686d381c44d2fd934274a51993f661c1db0eac1f13cfebd3c289)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
            check_type(argname="argument feather", value=feather, expected_type=type_hints["feather"])
            check_type(argname="argument feather_var", value=feather_var, expected_type=type_hints["feather_var"])
            check_type(argname="argument tolerance", value=tolerance, expected_type=type_hints["tolerance"])
            check_type(argname="argument tolerance_var", value=tolerance_var, expected_type=type_hints["tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var
        if feather is not None:
            self._values["feather"] = feather
        if feather_var is not None:
            self._values["feather_var"] = feather_var
        if tolerance is not None:
            self._values["tolerance"] = tolerance
        if tolerance_var is not None:
            self._values["tolerance_var"] = tolerance_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        '''
        result = self._values.get("feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather_var(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        '''
        result = self._values.get("feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        '''
        result = self._values.get("tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance_var(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        result = self._values.get("tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitRemoveColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitRemoveColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitRemoveColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__27c2cfe6feec7bdb4d6d25c691d3d860adce80398b27e7e2a3365cfe59b96478)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitRemoveColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__afb5266fc67fb680222cd0caaf67e861f78bf7e0aa7ebea64b6891b9b4a30872)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitRemoveColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c9c9d2e579b759aa70646b800db160135075526f113b4b84c97f812f46e025f3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c87c65a14b8e754a2d36a9e9ac9cdf9c53978ee4941a87f13e1a65304163e9ab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e14c5d6f1471b1dd7b338162bd93910131b9a06eecd8e05941283a95f877ec4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitRemoveColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitRemoveColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitRemoveColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e045e6f67e0980d8d30af32ddbda7cda113ecc962c90564958d1c57ddc2eb3a5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitRemoveColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitRemoveColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__736b9240a1906993527839944c4fc477a197aff17ed1443224f4062bbb7df7ed)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @jsii.member(jsii_name="resetFeather")
    def reset_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeather", []))

    @jsii.member(jsii_name="resetFeatherVar")
    def reset_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatherVar", []))

    @jsii.member(jsii_name="resetTolerance")
    def reset_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTolerance", []))

    @jsii.member(jsii_name="resetToleranceVar")
    def reset_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featherInput")
    def feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherInput"))

    @builtins.property
    @jsii.member(jsii_name="featherVarInput")
    def feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceInput")
    def tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceVarInput")
    def tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c01473cfe6e3f680a3686e9eede7a96514e319c56d9c468c35eeace62ec488a1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1bd9ea4065ea24c67416cd762d72f3cfaaf7852b8559d841f6bff8b11b50c322)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="feather")
    def feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "feather"))

    @feather.setter
    def feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ca61f2438f04ad55247525b313b360d6633f52e8550c2b038c7765232eecce08)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "feather", value)

    @builtins.property
    @jsii.member(jsii_name="featherVar")
    def feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featherVar"))

    @feather_var.setter
    def feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fb0299a562a6d597ed2a93a4f19bc83e87dac4122a0b96ae79af07780f0b8d94)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featherVar", value)

    @builtins.property
    @jsii.member(jsii_name="tolerance")
    def tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tolerance"))

    @tolerance.setter
    def tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d1778da4e1684eab68a5b87e8c5e85c0c2aabc7472fd7a8150dea426a46d674c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tolerance", value)

    @builtins.property
    @jsii.member(jsii_name="toleranceVar")
    def tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "toleranceVar"))

    @tolerance_var.setter
    def tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3e93aba2ddf8cf77163b20658a5f66f810831ab1947e1ff545c5cc93f375a65e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "toleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitRemoveColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitRemoveColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitRemoveColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__36e6aff33ceee99182bd07571f772d97f77323c6c03b9230eff17ec554389f19)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitUnsharpMask",
    jsii_struct_bases=[],
    name_mapping={
        "gain": "gain",
        "gain_var": "gainVar",
        "sigma": "sigma",
        "sigma_var": "sigmaVar",
        "threshold": "threshold",
        "threshold_var": "thresholdVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitUnsharpMask:
    def __init__(
        self,
        *,
        gain: typing.Optional[builtins.str] = None,
        gain_var: typing.Optional[builtins.str] = None,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
        threshold: typing.Optional[builtins.str] = None,
        threshold_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param gain: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        :param gain_var: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        :param sigma: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        :param threshold: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        :param threshold_var: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0787c82b222509db206e4ba1d9acbb3cf11ef2c6fbd9898448a42c9fccf603e9)
            check_type(argname="argument gain", value=gain, expected_type=type_hints["gain"])
            check_type(argname="argument gain_var", value=gain_var, expected_type=type_hints["gain_var"])
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
            check_type(argname="argument threshold", value=threshold, expected_type=type_hints["threshold"])
            check_type(argname="argument threshold_var", value=threshold_var, expected_type=type_hints["threshold_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if gain is not None:
            self._values["gain"] = gain
        if gain_var is not None:
            self._values["gain_var"] = gain_var
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var
        if threshold is not None:
            self._values["threshold"] = threshold
        if threshold_var is not None:
            self._values["threshold_var"] = threshold_var

    @builtins.property
    def gain(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        '''
        result = self._values.get("gain")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gain_var(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        '''
        result = self._values.get("gain_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        '''
        result = self._values.get("threshold")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold_var(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        result = self._values.get("threshold_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitUnsharpMask(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitUnsharpMaskList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitUnsharpMaskList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__75aa43466b38e1768f7999f84b30bc10780ae5ce65d0b5fead80e2d25990fac2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitUnsharpMaskOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__19563a57661471ca91d5e0875dfbf82d3dc7cbc456e425211c13f63366092656)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitUnsharpMaskOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__88181e259885a6a34d570c861ca43b33f79065fb54ea76289102adc7143a36b1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e7045fd2a57d0f9508e019994f1239e1079778d35e3a622bb1822999ecdac65e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d65ab33ba2189195f69620bf4bd2ef22f8347d07efef1f46457a767781d474f7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitUnsharpMask]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitUnsharpMask]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitUnsharpMask]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aad23e7d5797a5913641433149a6796bba16571d3b4b31ef978ab959fac74072)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitUnsharpMaskOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitUnsharpMaskOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2256bfaa41bc261e639495ebbc30c38102df53a7e6eae1a8e6255757232a8a91)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetGain")
    def reset_gain(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGain", []))

    @jsii.member(jsii_name="resetGainVar")
    def reset_gain_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGainVar", []))

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @jsii.member(jsii_name="resetThreshold")
    def reset_threshold(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThreshold", []))

    @jsii.member(jsii_name="resetThresholdVar")
    def reset_threshold_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThresholdVar", []))

    @builtins.property
    @jsii.member(jsii_name="gainInput")
    def gain_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainInput"))

    @builtins.property
    @jsii.member(jsii_name="gainVarInput")
    def gain_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdInput")
    def threshold_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdVarInput")
    def threshold_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gain")
    def gain(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gain"))

    @gain.setter
    def gain(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a42e9f49f9c4fa32681184c463f1fef79f0343eb1a249b64a7d2dbecbc8cac8a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gain", value)

    @builtins.property
    @jsii.member(jsii_name="gainVar")
    def gain_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gainVar"))

    @gain_var.setter
    def gain_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b772f57300dea56df4adfc17628a91d30f4c0b5b18fcff429a80c516a4fdef59)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gainVar", value)

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__79e4a7318863f5c9f9da040a052eca3c4f34f637cc2c38374aa8788547023a36)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a166086bc764be62550d9e3649e31b29bb530e25f47438725f80c62b50efdda2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="threshold")
    def threshold(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "threshold"))

    @threshold.setter
    def threshold(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__605eb32d01e15dc39584d55c6822ef822c0cd264cf4458bc28a3cda141e924f0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "threshold", value)

    @builtins.property
    @jsii.member(jsii_name="thresholdVar")
    def threshold_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "thresholdVar"))

    @threshold_var.setter
    def threshold_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__230763a0a29454a71bd4b7cef2a57d2024f3beef1c0b439acd880058554176a9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "thresholdVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitUnsharpMask]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitUnsharpMask]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitUnsharpMask]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b9ae3a76843c34f5325c40ba10f7f97fdfe04d010ac479bc664ad219a5103f29)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquare",
    jsii_struct_bases=[],
    name_mapping={
        "background_color": "backgroundColor",
        "blur": "blur",
        "chroma_key": "chromaKey",
        "composite": "composite",
        "compound": "compound",
        "contrast": "contrast",
        "goop": "goop",
        "grayscale": "grayscale",
        "hsl": "hsl",
        "hsv": "hsv",
        "if_dimension": "ifDimension",
        "if_orientation": "ifOrientation",
        "max_colors": "maxColors",
        "mirror": "mirror",
        "mono_hue": "monoHue",
        "opacity": "opacity",
        "remove_color": "removeColor",
        "unsharp_mask": "unsharpMask",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquare:
    def __init__(
        self,
        *,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareBackgroundColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareBlur", typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareChromaKey", typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareComposite", typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareCompound", typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareContrast", typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareGoop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareGrayscale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareHsl", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareHsv", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfDimension", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfOrientation", typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareMaxColors", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareMirror", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareMonoHue", typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareOpacity", typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareRemoveColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareUnsharpMask", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__226ce60a972e6769c8637b3fbd4a629634e8c7117b29da69a75ab16dd6a21638)
            check_type(argname="argument background_color", value=background_color, expected_type=type_hints["background_color"])
            check_type(argname="argument blur", value=blur, expected_type=type_hints["blur"])
            check_type(argname="argument chroma_key", value=chroma_key, expected_type=type_hints["chroma_key"])
            check_type(argname="argument composite", value=composite, expected_type=type_hints["composite"])
            check_type(argname="argument compound", value=compound, expected_type=type_hints["compound"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument goop", value=goop, expected_type=type_hints["goop"])
            check_type(argname="argument grayscale", value=grayscale, expected_type=type_hints["grayscale"])
            check_type(argname="argument hsl", value=hsl, expected_type=type_hints["hsl"])
            check_type(argname="argument hsv", value=hsv, expected_type=type_hints["hsv"])
            check_type(argname="argument if_dimension", value=if_dimension, expected_type=type_hints["if_dimension"])
            check_type(argname="argument if_orientation", value=if_orientation, expected_type=type_hints["if_orientation"])
            check_type(argname="argument max_colors", value=max_colors, expected_type=type_hints["max_colors"])
            check_type(argname="argument mirror", value=mirror, expected_type=type_hints["mirror"])
            check_type(argname="argument mono_hue", value=mono_hue, expected_type=type_hints["mono_hue"])
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument remove_color", value=remove_color, expected_type=type_hints["remove_color"])
            check_type(argname="argument unsharp_mask", value=unsharp_mask, expected_type=type_hints["unsharp_mask"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if background_color is not None:
            self._values["background_color"] = background_color
        if blur is not None:
            self._values["blur"] = blur
        if chroma_key is not None:
            self._values["chroma_key"] = chroma_key
        if composite is not None:
            self._values["composite"] = composite
        if compound is not None:
            self._values["compound"] = compound
        if contrast is not None:
            self._values["contrast"] = contrast
        if goop is not None:
            self._values["goop"] = goop
        if grayscale is not None:
            self._values["grayscale"] = grayscale
        if hsl is not None:
            self._values["hsl"] = hsl
        if hsv is not None:
            self._values["hsv"] = hsv
        if if_dimension is not None:
            self._values["if_dimension"] = if_dimension
        if if_orientation is not None:
            self._values["if_orientation"] = if_orientation
        if max_colors is not None:
            self._values["max_colors"] = max_colors
        if mirror is not None:
            self._values["mirror"] = mirror
        if mono_hue is not None:
            self._values["mono_hue"] = mono_hue
        if opacity is not None:
            self._values["opacity"] = opacity
        if remove_color is not None:
            self._values["remove_color"] = remove_color
        if unsharp_mask is not None:
            self._values["unsharp_mask"] = unsharp_mask

    @builtins.property
    def background_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareBackgroundColor"]]]:
        '''background_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        '''
        result = self._values.get("background_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareBackgroundColor"]]], result)

    @builtins.property
    def blur(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareBlur"]]]:
        '''blur block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        '''
        result = self._values.get("blur")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareBlur"]]], result)

    @builtins.property
    def chroma_key(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareChromaKey"]]]:
        '''chroma_key block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        '''
        result = self._values.get("chroma_key")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareChromaKey"]]], result)

    @builtins.property
    def composite(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareComposite"]]]:
        '''composite block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        '''
        result = self._values.get("composite")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareComposite"]]], result)

    @builtins.property
    def compound(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareCompound"]]]:
        '''compound block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        '''
        result = self._values.get("compound")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareCompound"]]], result)

    @builtins.property
    def contrast(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareContrast"]]]:
        '''contrast block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareContrast"]]], result)

    @builtins.property
    def goop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareGoop"]]]:
        '''goop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        '''
        result = self._values.get("goop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareGoop"]]], result)

    @builtins.property
    def grayscale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareGrayscale"]]]:
        '''grayscale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        '''
        result = self._values.get("grayscale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareGrayscale"]]], result)

    @builtins.property
    def hsl(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareHsl"]]]:
        '''hsl block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        '''
        result = self._values.get("hsl")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareHsl"]]], result)

    @builtins.property
    def hsv(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareHsv"]]]:
        '''hsv block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        '''
        result = self._values.get("hsv")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareHsv"]]], result)

    @builtins.property
    def if_dimension(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfDimension"]]]:
        '''if_dimension block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        '''
        result = self._values.get("if_dimension")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfDimension"]]], result)

    @builtins.property
    def if_orientation(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfOrientation"]]]:
        '''if_orientation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        '''
        result = self._values.get("if_orientation")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfOrientation"]]], result)

    @builtins.property
    def max_colors(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareMaxColors"]]]:
        '''max_colors block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        '''
        result = self._values.get("max_colors")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareMaxColors"]]], result)

    @builtins.property
    def mirror(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareMirror"]]]:
        '''mirror block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        '''
        result = self._values.get("mirror")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareMirror"]]], result)

    @builtins.property
    def mono_hue(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareMonoHue"]]]:
        '''mono_hue block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        '''
        result = self._values.get("mono_hue")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareMonoHue"]]], result)

    @builtins.property
    def opacity(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareOpacity"]]]:
        '''opacity block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareOpacity"]]], result)

    @builtins.property
    def remove_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareRemoveColor"]]]:
        '''remove_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        '''
        result = self._values.get("remove_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareRemoveColor"]]], result)

    @builtins.property
    def unsharp_mask(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareUnsharpMask"]]]:
        '''unsharp_mask block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        result = self._values.get("unsharp_mask")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareUnsharpMask"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquare(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareBackgroundColor",
    jsii_struct_bases=[],
    name_mapping={"color": "color", "color_var": "colorVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareBackgroundColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c366f5d75e1791ebbe3596e8baa51dcf41668d8291fe6006009574e70b0658dc)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareBackgroundColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareBackgroundColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareBackgroundColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__207c01ceec300b2f37fb3b7cfee9f155201fc30da343291d522d285eb29732c1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareBackgroundColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__084c59bcfd83f0ecd3615f490a843c71cb9e0ff18e25438457a3a7095a2f2b79)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareBackgroundColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8b1fc770a04f6e07aadae8de8af899b47184581028dd52e6eac53ba5fa01db0e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b60a2573086bd8eabeb65271181e5d9f62557c4b4989a2d7b42700a5cda5008a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0cfdd08d218eed23329093bb634ecf2ad0c5fc70e7e9b644635b625fa9be3309)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareBackgroundColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareBackgroundColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dcf574fbc296fa0c984fbcb6ac74ef0ba034689da02b39393ad334afbf11067b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareBackgroundColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareBackgroundColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__91329f4f27984f5c03054d576a2f35caa344f11f6ddd9fc48cbe55664b85b80a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cdd57947255cec1bf124ff48f387b17a47d284a215367521c3f79f4810d86cc2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4c2d699cec3cf8809ad94a4849013ede2cfca9ca103565fc97da95f061163701)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareBackgroundColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareBackgroundColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareBackgroundColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__79b69067a56b9202b8bcfe61dc376aa5687cf5549ebcb04a4dd27a90c79d9263)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareBlur",
    jsii_struct_bases=[],
    name_mapping={"sigma": "sigma", "sigma_var": "sigmaVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareBlur:
    def __init__(
        self,
        *,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param sigma: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d79b33576d5fc872b5e264710d35252d51a4a5aabb056b7919e2ddeb90955e18)
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareBlur(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareBlurList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareBlurList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__baabf7a56feb0a0027143e37518ab3b4c236e76618be3713ec93f1299991cd5f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareBlurOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__499a9f210f055cb9012f559abc49333c0a08c68131d371289c37a79d41e439b0)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareBlurOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__48028e579a8e6decf396f7043441ce2e293c33b916ec1e205e4e92daf7c8ab7f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3585da1e696eb1b699a6e0e398b4e863465b4e79b525d8fd28ab1576642f96a7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9f0274163abba783bb21e829d89e654549321bf2bf6e74ce7754c6d4dcbd6e50)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareBlur]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareBlur]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f9d9f245fdb6da3b1caa499a20cb597dc64c90837c3979de99bac7ea0aa663b7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareBlurOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareBlurOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eda929bd2798e0fc564ca3f01242cb677ec45a4892cc5d0b201410fed765e4eb)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__44ae64c4c73916c7e17e3156c664367afabdce0e3d98840a2b7af16dd9d19964)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a107075a2b407690498548db98e4823d42295ea149c681691252505cc419e9f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareBlur]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareBlur]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareBlur]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cc0fb63ba6b865e8eeb4bcb4a1a2c099c8ee54fbb6b906e3f9c13cceb21b90f5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareChromaKey",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_feather": "hueFeather",
        "hue_feather_var": "hueFeatherVar",
        "hue_tolerance": "hueTolerance",
        "hue_tolerance_var": "hueToleranceVar",
        "hue_var": "hueVar",
        "lightness_feather": "lightnessFeather",
        "lightness_feather_var": "lightnessFeatherVar",
        "lightness_tolerance": "lightnessTolerance",
        "lightness_tolerance_var": "lightnessToleranceVar",
        "saturation_feather": "saturationFeather",
        "saturation_feather_var": "saturationFeatherVar",
        "saturation_tolerance": "saturationTolerance",
        "saturation_tolerance_var": "saturationToleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareChromaKey:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_feather: typing.Optional[builtins.str] = None,
        hue_feather_var: typing.Optional[builtins.str] = None,
        hue_tolerance: typing.Optional[builtins.str] = None,
        hue_tolerance_var: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness_feather: typing.Optional[builtins.str] = None,
        lightness_feather_var: typing.Optional[builtins.str] = None,
        lightness_tolerance: typing.Optional[builtins.str] = None,
        lightness_tolerance_var: typing.Optional[builtins.str] = None,
        saturation_feather: typing.Optional[builtins.str] = None,
        saturation_feather_var: typing.Optional[builtins.str] = None,
        saturation_tolerance: typing.Optional[builtins.str] = None,
        saturation_tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_feather: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        :param hue_feather_var: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        :param hue_tolerance: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        :param hue_tolerance_var: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        :param hue_var: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness_feather: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        :param lightness_feather_var: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        :param lightness_tolerance: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        :param lightness_tolerance_var: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        :param saturation_feather: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        :param saturation_feather_var: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        :param saturation_tolerance: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        :param saturation_tolerance_var: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__97eab9858a55bbe0ec6f41231ab1e1035f582f2065f424c2ee4dd633cd0db9dd)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_feather", value=hue_feather, expected_type=type_hints["hue_feather"])
            check_type(argname="argument hue_feather_var", value=hue_feather_var, expected_type=type_hints["hue_feather_var"])
            check_type(argname="argument hue_tolerance", value=hue_tolerance, expected_type=type_hints["hue_tolerance"])
            check_type(argname="argument hue_tolerance_var", value=hue_tolerance_var, expected_type=type_hints["hue_tolerance_var"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness_feather", value=lightness_feather, expected_type=type_hints["lightness_feather"])
            check_type(argname="argument lightness_feather_var", value=lightness_feather_var, expected_type=type_hints["lightness_feather_var"])
            check_type(argname="argument lightness_tolerance", value=lightness_tolerance, expected_type=type_hints["lightness_tolerance"])
            check_type(argname="argument lightness_tolerance_var", value=lightness_tolerance_var, expected_type=type_hints["lightness_tolerance_var"])
            check_type(argname="argument saturation_feather", value=saturation_feather, expected_type=type_hints["saturation_feather"])
            check_type(argname="argument saturation_feather_var", value=saturation_feather_var, expected_type=type_hints["saturation_feather_var"])
            check_type(argname="argument saturation_tolerance", value=saturation_tolerance, expected_type=type_hints["saturation_tolerance"])
            check_type(argname="argument saturation_tolerance_var", value=saturation_tolerance_var, expected_type=type_hints["saturation_tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_feather is not None:
            self._values["hue_feather"] = hue_feather
        if hue_feather_var is not None:
            self._values["hue_feather_var"] = hue_feather_var
        if hue_tolerance is not None:
            self._values["hue_tolerance"] = hue_tolerance
        if hue_tolerance_var is not None:
            self._values["hue_tolerance_var"] = hue_tolerance_var
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness_feather is not None:
            self._values["lightness_feather"] = lightness_feather
        if lightness_feather_var is not None:
            self._values["lightness_feather_var"] = lightness_feather_var
        if lightness_tolerance is not None:
            self._values["lightness_tolerance"] = lightness_tolerance
        if lightness_tolerance_var is not None:
            self._values["lightness_tolerance_var"] = lightness_tolerance_var
        if saturation_feather is not None:
            self._values["saturation_feather"] = saturation_feather
        if saturation_feather_var is not None:
            self._values["saturation_feather_var"] = saturation_feather_var
        if saturation_tolerance is not None:
            self._values["saturation_tolerance"] = saturation_tolerance
        if saturation_tolerance_var is not None:
            self._values["saturation_tolerance_var"] = saturation_tolerance_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        '''
        result = self._values.get("hue_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        '''
        result = self._values.get("hue_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        '''
        result = self._values.get("hue_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        '''
        result = self._values.get("hue_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        '''
        result = self._values.get("lightness_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        '''
        result = self._values.get("lightness_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        '''
        result = self._values.get("lightness_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        '''
        result = self._values.get("lightness_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        '''
        result = self._values.get("saturation_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        '''
        result = self._values.get("saturation_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        '''
        result = self._values.get("saturation_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        result = self._values.get("saturation_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareChromaKey(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareChromaKeyList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareChromaKeyList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aa0633fc5bd69e32d19527ac87434f606ed45d6b456ebb109b207f24567281ce)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareChromaKeyOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__781250bedf2cd548f12106c1eee99e3de7177813622401222f6260c59c419ea0)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareChromaKeyOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e320e7a1ab49aa2594f50405f557a5a949555aab586fd7c96d077d60d3a340c8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b13c848bb6206216e3dcf3abc2bc1ca3373bb71bf28310581368b45cd1bd9e54)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ef6fd87b8152fdce627684f1b35af6a8c8d7c63df94a88ac0ee60b956a9853c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareChromaKey]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareChromaKey]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7ba0704a2bc8d3c8ac9f7479264a673bcae092280a5b86e6b8d7c5dfeab13a02)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareChromaKeyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareChromaKeyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__07ab97c83b3212d62418c8130b5269f4e37704cfeabf2ec5f68739afd8b2512b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueFeather")
    def reset_hue_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeather", []))

    @jsii.member(jsii_name="resetHueFeatherVar")
    def reset_hue_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeatherVar", []))

    @jsii.member(jsii_name="resetHueTolerance")
    def reset_hue_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueTolerance", []))

    @jsii.member(jsii_name="resetHueToleranceVar")
    def reset_hue_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueToleranceVar", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightnessFeather")
    def reset_lightness_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeather", []))

    @jsii.member(jsii_name="resetLightnessFeatherVar")
    def reset_lightness_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeatherVar", []))

    @jsii.member(jsii_name="resetLightnessTolerance")
    def reset_lightness_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessTolerance", []))

    @jsii.member(jsii_name="resetLightnessToleranceVar")
    def reset_lightness_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessToleranceVar", []))

    @jsii.member(jsii_name="resetSaturationFeather")
    def reset_saturation_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeather", []))

    @jsii.member(jsii_name="resetSaturationFeatherVar")
    def reset_saturation_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeatherVar", []))

    @jsii.member(jsii_name="resetSaturationTolerance")
    def reset_saturation_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationTolerance", []))

    @jsii.member(jsii_name="resetSaturationToleranceVar")
    def reset_saturation_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherInput")
    def hue_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVarInput")
    def hue_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceInput")
    def hue_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVarInput")
    def hue_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherInput")
    def lightness_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVarInput")
    def lightness_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceInput")
    def lightness_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVarInput")
    def lightness_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherInput")
    def saturation_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVarInput")
    def saturation_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceInput")
    def saturation_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVarInput")
    def saturation_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__85bf0a77649726877b9b67a054e77bc5b2dd3fbfbb70d98c6361f7cceda80d56)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeather")
    def hue_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeather"))

    @hue_feather.setter
    def hue_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4b4b97b52f02a61dcd0ee7364a8c513518dd2420a78934ee86b8e4b267369579)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeather", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVar")
    def hue_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeatherVar"))

    @hue_feather_var.setter
    def hue_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7bc170d184bf8df1921fecbaa98c593129bc47e5fbdd27f4c94d303aca0c0506)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueTolerance")
    def hue_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueTolerance"))

    @hue_tolerance.setter
    def hue_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bbb55a94c4483d580a963d85ebd6ec06481f8dfc2ebd98d4985ff390e674fa12)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVar")
    def hue_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueToleranceVar"))

    @hue_tolerance_var.setter
    def hue_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__62c37f78f6966f819cf16f65a533d188aa2c94b1f1f298d46ec8311a8ca361d5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__75c13355040158ebdd43b7d4fe3be0b02aaef59b7064ccb82e1f0596401f19f7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeather")
    def lightness_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeather"))

    @lightness_feather.setter
    def lightness_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f05a19487a4cc31a104812ec5bf9b11999dc6fa921e11e6ef5dbd735eeaae899)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeather", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVar")
    def lightness_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeatherVar"))

    @lightness_feather_var.setter
    def lightness_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cacb86994c903647f9e97b9058630c67bb1751e78e8ce0d5a3e892841b616d67)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessTolerance")
    def lightness_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessTolerance"))

    @lightness_tolerance.setter
    def lightness_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__27ed869679d0eeeaa775cd9b2c5e639ef5aadae479ab0c5ba728e690e031f6ef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVar")
    def lightness_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessToleranceVar"))

    @lightness_tolerance_var.setter
    def lightness_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bd02daadd2d6c021ef1876a0e7327f4d6fd4efd565f9408aee1ed5b7e86fbcd6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeather")
    def saturation_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeather"))

    @saturation_feather.setter
    def saturation_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5bdf97e44c7c1853a23d383bc3a173733d6068d74643378f2abdc84418a8247e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeather", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVar")
    def saturation_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeatherVar"))

    @saturation_feather_var.setter
    def saturation_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a4ac5091dc4ea01010527185055d365ad15000fd0bc28ba9bcc2d1450089ad92)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationTolerance")
    def saturation_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationTolerance"))

    @saturation_tolerance.setter
    def saturation_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3e267ce26374b4d5830c0ded66b9ef08975ed086e8000c064ab219e4c79ef4ad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVar")
    def saturation_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationToleranceVar"))

    @saturation_tolerance_var.setter
    def saturation_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2b797cf9b0ec47991a317c8ba3bf161cc5e3dbffe9d9f3621e14bf44d365f2d4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareChromaKey]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareChromaKey]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareChromaKey]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__de1bfa1daef8d43ee10468acd83d376667af43f9e858264f24eafe96b7a9788e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareComposite",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "placement": "placement",
        "placement_var": "placementVar",
        "scale": "scale",
        "scale_dimension": "scaleDimension",
        "scale_dimension_var": "scaleDimensionVar",
        "scale_var": "scaleVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareComposite:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareCompositeImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        placement: typing.Optional[builtins.str] = None,
        placement_var: typing.Optional[builtins.str] = None,
        scale: typing.Optional[builtins.str] = None,
        scale_dimension: typing.Optional[builtins.str] = None,
        scale_dimension_var: typing.Optional[builtins.str] = None,
        scale_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param placement: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        :param placement_var: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        :param scale: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param scale_dimension: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        :param scale_dimension_var: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        :param scale_var: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        :param x_position: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareCompositeImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ce71f5124368f6309aef81fdc2ff7a6b12c6fb496a6b184e42ba3a2190632b0)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument placement", value=placement, expected_type=type_hints["placement"])
            check_type(argname="argument placement_var", value=placement_var, expected_type=type_hints["placement_var"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument scale_dimension", value=scale_dimension, expected_type=type_hints["scale_dimension"])
            check_type(argname="argument scale_dimension_var", value=scale_dimension_var, expected_type=type_hints["scale_dimension_var"])
            check_type(argname="argument scale_var", value=scale_var, expected_type=type_hints["scale_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if placement is not None:
            self._values["placement"] = placement
        if placement_var is not None:
            self._values["placement_var"] = placement_var
        if scale is not None:
            self._values["scale"] = scale
        if scale_dimension is not None:
            self._values["scale_dimension"] = scale_dimension
        if scale_dimension_var is not None:
            self._values["scale_dimension_var"] = scale_dimension_var
        if scale_var is not None:
            self._values["scale_var"] = scale_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareCompositeImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareCompositeImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        '''
        result = self._values.get("placement")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement_var(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        '''
        result = self._values.get("placement_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        '''
        result = self._values.get("scale_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        '''
        result = self._values.get("scale_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        '''
        result = self._values.get("scale_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareComposite(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareCompositeImage",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareCompositeImage:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareCompositeImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareCompositeImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareCompositeImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0083594a12887ae723888a10449818ec28148516c384813b374acf177c415442)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareCompositeImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareCompositeImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__50be7d83a7328abf7a524db125c67a7e7e8a66cdac3c789015b9b5aa07e7c45c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareCompositeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareCompositeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4098fcbd313b75706e944e17b451be3c4b387139be3b5381467ba8e7dfb0130a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareCompositeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b33203a61d6bcb54abeffcbf9805b4a83a8e5b8bdf51bf65df10ba2ff68d953b)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareCompositeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a0347bfa188c4f1456afa85d3b8acc8c76a2ec943748bc01ba1fd9fcb5098a10)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5dfd10ad529e14285acce0fac00db6d800063295b7ee9101d12317d5deda79b9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__867b237e903f1e81175dbdff2a56f727365786311760878d1d07697bda215a50)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareComposite]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareComposite]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fcc5e171bc199aed6f9d6b3188439d4319a4e418a6adc14f1b768622f9519de6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareCompositeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareCompositeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__305749af8a417270931d0adcb46ac510bddb0cfb82545b3b485633eab9209390)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareCompositeImage()

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPlacement")
    def reset_placement(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacement", []))

    @jsii.member(jsii_name="resetPlacementVar")
    def reset_placement_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacementVar", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetScaleDimension")
    def reset_scale_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimension", []))

    @jsii.member(jsii_name="resetScaleDimensionVar")
    def reset_scale_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimensionVar", []))

    @jsii.member(jsii_name="resetScaleVar")
    def reset_scale_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareCompositeImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareCompositeImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareCompositeImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="placementInput")
    def placement_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementInput"))

    @builtins.property
    @jsii.member(jsii_name="placementVarInput")
    def placement_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionInput")
    def scale_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVarInput")
    def scale_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleVarInput")
    def scale_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1eecf1683a1c2e36d7ad818acdeac168378e6c93e5b15bf424570437feb56a2e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__351c8f358730c03159a3620b384dd9f702fdf1017a61616509dd9c409f54bb29)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="placement")
    def placement(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placement"))

    @placement.setter
    def placement(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e00d4199f8e7d2200b9e9af5ac1af58e8a811fc52820cd9079a03d823c87faf6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placement", value)

    @builtins.property
    @jsii.member(jsii_name="placementVar")
    def placement_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placementVar"))

    @placement_var.setter
    def placement_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__860cc9a570048bb412b16b3c7693357805a11a36b2165358e09427faa0f04f42)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placementVar", value)

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scale"))

    @scale.setter
    def scale(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1b7cf4df9b31f7ca1b9a4ac061b4c2196a359e6b10e3e549fc655d00f6f6b02f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scale", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimension")
    def scale_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimension"))

    @scale_dimension.setter
    def scale_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7b0e9d64b45f9fe49192ad4f89b60b59e8becfb3a1b2619e08e23be8fc0e9211)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimension", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVar")
    def scale_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimensionVar"))

    @scale_dimension_var.setter
    def scale_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a4615c9663529dab313ef774ed82a400cf3b9fcdd2b58952d7907187d5a6f322)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="scaleVar")
    def scale_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleVar"))

    @scale_var.setter
    def scale_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aef9ecedc3f368465c2e8e90a71a9629787590c1abd7d5a79478877edc066ba1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e6cec46eddd470f4f3840b17774238a53a639404764fe1d4854bbcc18d24cd2e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a3758060f8893defe9fa21f148cb40db889fe287bac3ca5678a4ac26ed53c30c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4b493af0b32dc0d50fab26351642864c67c1ec79ed8c7e267ebdc481674ecec0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4c01fb74070028e198479ce1c575921c1bbf074db216a123ae6c95e11dce06e3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareComposite]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareComposite]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareComposite]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b6dbf61559b10578c236aa629a0de60bf88a1d173f9bdf006f9cbe3c26e97a05)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareCompound",
    jsii_struct_bases=[],
    name_mapping={"transformations": "transformations"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareCompound:
    def __init__(
        self,
        *,
        transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param transformations: transformations block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2e03e17228c67b0e4ea28c18c57d4a15bda0bb753369162a7739500888814642)
            check_type(argname="argument transformations", value=transformations, expected_type=type_hints["transformations"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if transformations is not None:
            self._values["transformations"] = transformations

    @builtins.property
    def transformations(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareCompoundTransformations"]]]:
        '''transformations block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        result = self._values.get("transformations")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareCompoundTransformations"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareCompound(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareCompoundList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareCompoundList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dbac02ddc8d5b89250f35da12d4af7dac33ff8898006b9889fe7787f388f2c1d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareCompoundOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b3f014c48267397f12e135adbb02da7bb2e1ca0dc5fc40451ff26c5039c64116)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareCompoundOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__820469cca6670b6b199e37e71ff5ff78a1f8e6ed1cd9927096068fccd5f27198)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a7ccb21e7a9c0342e25086d5ddd1f453520317a88831b2673f105e2ef42b37c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__06332e25905b5196bd17f362917e0106b94bd5e2abd86cfc36cb74b4dd6a9bec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareCompound]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareCompound]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ef789d54efa53d5506a0da66e0915cf159bc3e1ce574dd3054c209a20f03a938)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareCompoundOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareCompoundOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__848fe6a15dde124cc94dbb5137a1e7b116b9703402e47ae608de74ce82190b9c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformations")
    def put_transformations(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__23632f1990e7bf896fa7cfe03a0dde54ca124edf856347295da414a7fa6da02a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTransformations", [value]))

    @jsii.member(jsii_name="resetTransformations")
    def reset_transformations(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformations", []))

    @builtins.property
    @jsii.member(jsii_name="transformations")
    def transformations(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareCompoundTransformationsList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareCompoundTransformationsList", jsii.get(self, "transformations"))

    @builtins.property
    @jsii.member(jsii_name="transformationsInput")
    def transformations_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareCompoundTransformations"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareCompoundTransformations"]]], jsii.get(self, "transformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareCompound]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareCompound]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareCompound]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__576fe2d53dd6f7f18322dbad559a8325911930e52d2474dd8f1cd1c43628bfa3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareCompoundTransformations",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareCompoundTransformations:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareCompoundTransformations(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareCompoundTransformationsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareCompoundTransformationsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c740d5675432884c6d8451ff820f0bb7bc0e3ed0a545198257bcd472708cbac1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareCompoundTransformationsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e93673e3c613de49f64705b29f0b998b009d3f0a0efb9d8a774b858592c5e37)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareCompoundTransformationsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__596315e170eaf6066b451dffe7875235a365ac7616b0819ffb78beb6d59c8a69)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a2f66908a9698434dc302751dc3896c9d801cad635c880a531b20a940314c0d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__16084f5a4f8970db2276fab96e7f8b20ade20b655b6ec1663f656159f394d506)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareCompoundTransformations]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareCompoundTransformations]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareCompoundTransformations]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__33297919123790b726c07c8fd5135f5bd240c58929ad89949c87abaa5f96be1f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareCompoundTransformationsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareCompoundTransformationsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b8cc750d224943679c5e333cede0c353fddbc988c92d61c5992a0f9155764be3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareCompoundTransformations]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareCompoundTransformations]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareCompoundTransformations]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__49c3b2f5fc9cc46806900b53de0a588edeac757cb88376b48d45ce4eff98eafb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareContrast",
    jsii_struct_bases=[],
    name_mapping={
        "brightness": "brightness",
        "brightness_var": "brightnessVar",
        "contrast": "contrast",
        "contrast_var": "contrastVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareContrast:
    def __init__(
        self,
        *,
        brightness: typing.Optional[builtins.str] = None,
        brightness_var: typing.Optional[builtins.str] = None,
        contrast: typing.Optional[builtins.str] = None,
        contrast_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param brightness: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        :param brightness_var: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        :param contrast: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param contrast_var: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__28d18d3a201d2e72a6a94cd5869580c1d12f46e33ffeb6aa0d5420e2e52df272)
            check_type(argname="argument brightness", value=brightness, expected_type=type_hints["brightness"])
            check_type(argname="argument brightness_var", value=brightness_var, expected_type=type_hints["brightness_var"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument contrast_var", value=contrast_var, expected_type=type_hints["contrast_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if brightness is not None:
            self._values["brightness"] = brightness
        if brightness_var is not None:
            self._values["brightness_var"] = brightness_var
        if contrast is not None:
            self._values["contrast"] = contrast
        if contrast_var is not None:
            self._values["contrast_var"] = contrast_var

    @builtins.property
    def brightness(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        '''
        result = self._values.get("brightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def brightness_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        '''
        result = self._values.get("brightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        result = self._values.get("contrast_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareContrast(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareContrastList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareContrastList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eeb4e29b3a975b2c26cbc99805b008f15c840e769cdedb35f60c003d5eb02ed6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareContrastOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__74ba5fc6455b03011b9a79d714694503dad6aef9f760159544c5c47170485b1b)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareContrastOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6ad6e7d3cca5400b2f7a8bb71f19f85003b4fb4cfdc519f8936d909f98c43564)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0921fae3aa25e6b0784f06fb3cd1b5e5e102baffd24480a0ea5388e7edea12fc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__72683ec77a603dc16a59709ab5dec793e615dc9724e813ab3ef764ccc97d5153)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareContrast]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareContrast]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f530a1ee82b5be71f85e118bad524894fe79c6ad6d2009f37436b89555819bb9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareContrastOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareContrastOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4602f0c5946273d3d3791d886d957d46fc0829ec0ebf0aa63aa0987e1ae21ca0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetBrightness")
    def reset_brightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightness", []))

    @jsii.member(jsii_name="resetBrightnessVar")
    def reset_brightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightnessVar", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetContrastVar")
    def reset_contrast_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrastVar", []))

    @builtins.property
    @jsii.member(jsii_name="brightnessInput")
    def brightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="brightnessVarInput")
    def brightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastVarInput")
    def contrast_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="brightness")
    def brightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightness"))

    @brightness.setter
    def brightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ea0924ceece89132662ac2dc480ec96d8befb7f5ac06966ab6e9abfe06ff515)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightness", value)

    @builtins.property
    @jsii.member(jsii_name="brightnessVar")
    def brightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightnessVar"))

    @brightness_var.setter
    def brightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8b3ffb23d1ebade863de75d671389d30dddb020efb7bc41006b560ca57c99273)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrast"))

    @contrast.setter
    def contrast(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__58f7ef86ea5df9fa818157ea73adc7a45a02a06ac0b11b037cbf7a937dece2bc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrast", value)

    @builtins.property
    @jsii.member(jsii_name="contrastVar")
    def contrast_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrastVar"))

    @contrast_var.setter
    def contrast_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__00231e6cc70bc6f2aff2be6cb42cf0c59381becaba64a12c3591e743800eeb03)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrastVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareContrast]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareContrast]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareContrast]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7a60ca389cf42e4262ee3c42750603bde56d37f66d23eebdbd2bd52ff8460f08)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareGoop",
    jsii_struct_bases=[],
    name_mapping={
        "chaos": "chaos",
        "chaos_var": "chaosVar",
        "density": "density",
        "density_var": "densityVar",
        "power": "power",
        "power_var": "powerVar",
        "seed": "seed",
        "seed_var": "seedVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareGoop:
    def __init__(
        self,
        *,
        chaos: typing.Optional[builtins.str] = None,
        chaos_var: typing.Optional[builtins.str] = None,
        density: typing.Optional[builtins.str] = None,
        density_var: typing.Optional[builtins.str] = None,
        power: typing.Optional[builtins.str] = None,
        power_var: typing.Optional[builtins.str] = None,
        seed: typing.Optional[builtins.str] = None,
        seed_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param chaos: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        :param chaos_var: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        :param density: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        :param density_var: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        :param power: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        :param power_var: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        :param seed: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        :param seed_var: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e98ff83f836727abc9cb54c2e24b2db522ef05e349ba10257b6b8ed95743580)
            check_type(argname="argument chaos", value=chaos, expected_type=type_hints["chaos"])
            check_type(argname="argument chaos_var", value=chaos_var, expected_type=type_hints["chaos_var"])
            check_type(argname="argument density", value=density, expected_type=type_hints["density"])
            check_type(argname="argument density_var", value=density_var, expected_type=type_hints["density_var"])
            check_type(argname="argument power", value=power, expected_type=type_hints["power"])
            check_type(argname="argument power_var", value=power_var, expected_type=type_hints["power_var"])
            check_type(argname="argument seed", value=seed, expected_type=type_hints["seed"])
            check_type(argname="argument seed_var", value=seed_var, expected_type=type_hints["seed_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if chaos is not None:
            self._values["chaos"] = chaos
        if chaos_var is not None:
            self._values["chaos_var"] = chaos_var
        if density is not None:
            self._values["density"] = density
        if density_var is not None:
            self._values["density_var"] = density_var
        if power is not None:
            self._values["power"] = power
        if power_var is not None:
            self._values["power_var"] = power_var
        if seed is not None:
            self._values["seed"] = seed
        if seed_var is not None:
            self._values["seed_var"] = seed_var

    @builtins.property
    def chaos(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        '''
        result = self._values.get("chaos")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def chaos_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        '''
        result = self._values.get("chaos_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        '''
        result = self._values.get("density")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density_var(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        '''
        result = self._values.get("density_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        '''
        result = self._values.get("power")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power_var(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        '''
        result = self._values.get("power_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        '''
        result = self._values.get("seed")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed_var(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        result = self._values.get("seed_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareGoop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareGoopList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareGoopList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e4e88d98d7c89d150895a74bd22b68fb5a11cff3795cb2cd23607957cae9b62c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareGoopOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__729a710443d0353bf4a852a08e904f587f652b4d194c650b9b1c40bed0883c1a)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareGoopOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab461dc6adcf9684fa72a6cda7635f1f3cf367a5891258dcb704c6d02d18d818)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f76b6f634c94c3b8329f36a0d617aa16d7a37a6b5aad9c1567513d7d00bddee4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8b210a0195c2f2692b3c2c0f3e0c84710a0bc0ddc4d34fd3a15232629aba2f3e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareGoop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareGoop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dd83d4f02f96bff76d98d69eb4274d15a62e7cda6fb3b5285a493cabb79ec586)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareGoopOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareGoopOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ab22e1cda5a57fdae2a086d738f1d201755a4e94d0ba782d49a89bae1ccd00f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetChaos")
    def reset_chaos(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaos", []))

    @jsii.member(jsii_name="resetChaosVar")
    def reset_chaos_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaosVar", []))

    @jsii.member(jsii_name="resetDensity")
    def reset_density(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensity", []))

    @jsii.member(jsii_name="resetDensityVar")
    def reset_density_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensityVar", []))

    @jsii.member(jsii_name="resetPower")
    def reset_power(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPower", []))

    @jsii.member(jsii_name="resetPowerVar")
    def reset_power_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPowerVar", []))

    @jsii.member(jsii_name="resetSeed")
    def reset_seed(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeed", []))

    @jsii.member(jsii_name="resetSeedVar")
    def reset_seed_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeedVar", []))

    @builtins.property
    @jsii.member(jsii_name="chaosInput")
    def chaos_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosInput"))

    @builtins.property
    @jsii.member(jsii_name="chaosVarInput")
    def chaos_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosVarInput"))

    @builtins.property
    @jsii.member(jsii_name="densityInput")
    def density_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityInput"))

    @builtins.property
    @jsii.member(jsii_name="densityVarInput")
    def density_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="powerInput")
    def power_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerInput"))

    @builtins.property
    @jsii.member(jsii_name="powerVarInput")
    def power_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerVarInput"))

    @builtins.property
    @jsii.member(jsii_name="seedInput")
    def seed_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedInput"))

    @builtins.property
    @jsii.member(jsii_name="seedVarInput")
    def seed_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedVarInput"))

    @builtins.property
    @jsii.member(jsii_name="chaos")
    def chaos(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaos"))

    @chaos.setter
    def chaos(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__08f957b2464d0b83be7627d4624feaa8d4735f4603ebaae5c9c46f9fd7944cd8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaos", value)

    @builtins.property
    @jsii.member(jsii_name="chaosVar")
    def chaos_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaosVar"))

    @chaos_var.setter
    def chaos_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b2372c687c51c4a49cd94d4150323e8cbe043aa5bfef6a392318c2372ca3ddf8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaosVar", value)

    @builtins.property
    @jsii.member(jsii_name="density")
    def density(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "density"))

    @density.setter
    def density(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c0ac9727ffd503c67211293ea589db2afd4cbb236a7e6ce73fe2354da45c514c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "density", value)

    @builtins.property
    @jsii.member(jsii_name="densityVar")
    def density_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "densityVar"))

    @density_var.setter
    def density_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8eb32374b9f897fbbd96fea204c8ebc313d16b32a8f8b16ac2dc134bbf3c56d5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "densityVar", value)

    @builtins.property
    @jsii.member(jsii_name="power")
    def power(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "power"))

    @power.setter
    def power(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__48a6187808ebb2fb308e1c503ed6b6b0c290b58fda8e8835db2e3410059e07f8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "power", value)

    @builtins.property
    @jsii.member(jsii_name="powerVar")
    def power_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "powerVar"))

    @power_var.setter
    def power_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b2ae2cfd35f9633cc19ec4f20c542c83ec204f132e752b03395101f7bebb6d2d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "powerVar", value)

    @builtins.property
    @jsii.member(jsii_name="seed")
    def seed(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seed"))

    @seed.setter
    def seed(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__07b2480dbbc530eddb1cea49671c02ea93255e6aba0c4cd1f3a07d097f23f6c7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seed", value)

    @builtins.property
    @jsii.member(jsii_name="seedVar")
    def seed_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seedVar"))

    @seed_var.setter
    def seed_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__13b8426fb0200754498e41c15f336b5d9dea6e0c35b4bcd4d05f70558ec30bd1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seedVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareGoop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareGoop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareGoop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a515e00b040589dfb898937def17f1f894d8a2400a4274babe845b2d8f16d510)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareGrayscale",
    jsii_struct_bases=[],
    name_mapping={"type": "type", "type_var": "typeVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareGrayscale:
    def __init__(
        self,
        *,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param type: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__47d3d87a113e465c7e23c397bf9f171133a77f4c3c3883f57e8f5364fbc84834)
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareGrayscale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareGrayscaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareGrayscaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0bd89d8e70e31499f848ca3c5b49b7d43c38ded2387125a914513ec78403fb1c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareGrayscaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fc19e9a827f0e281b8e17b7f9a309db99f86441e753d8d96c4cc99a3826cbe5b)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareGrayscaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6d6d41fa378e792073546a35fbbc6ad9abf2ee0b8cd67aa155120533f3ef93ff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ec409b5b2bb5c46425f45bda9a14c2e3e7e970716c1bd8130a92156536aa39f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__546c160af719cf84303fd59f4600a7147fa80bb985b3443f460f47e99837cb57)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareGrayscale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareGrayscale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b23f16f411c7625a2554a08e41031d122f7426cdd8539c782c939d3e46c0b847)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareGrayscaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareGrayscaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c599ec0c069cf194c1fdb45539476c15d7cf171a48fcd92b7245e69e7f215337)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cb2ed0469389d221c9e07d4f23c810e1fbd8de1dbf1bbdd12f41288c3082d7f2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__20b28d26b35bee852f9f5b0f1827d8cfe611b3d0f9ed0d663ea6808856cc1e54)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareGrayscale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareGrayscale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareGrayscale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7c4428e174b24ac5559d8de53551592fe6bf1c6065acf920895b76eb091b4650)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareHsl",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "lightness": "lightness",
        "lightness_var": "lightnessVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareHsl:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness: typing.Optional[builtins.str] = None,
        lightness_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        :param lightness_var: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3b51a1182792df7e707898dc76e4e752746311a2d8cbcabfff76757417deaf5d)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness", value=lightness, expected_type=type_hints["lightness"])
            check_type(argname="argument lightness_var", value=lightness_var, expected_type=type_hints["lightness_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness is not None:
            self._values["lightness"] = lightness
        if lightness_var is not None:
            self._values["lightness_var"] = lightness_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        '''
        result = self._values.get("lightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        '''
        result = self._values.get("lightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareHsl(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareHslList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareHslList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__21c747bdadd8134e6607223c2333593698b46e23a2bbd0e14f80834e2d5bbe4d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareHslOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d5a3c89b8e8353ef6776d5c7532f137acf828935e7256c072e95dc8a59417c34)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareHslOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d0431d7ffd188d34ce0aa16e0a9a08b230707b77dbf2f4e9e238e496bdef1b38)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__66306b74a2437fe45e0fcb6f33fe58dd0da043d19726d720390a287cba0e4ad3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f60f6535546953ef6370b19accae3cfebc4388370c3b657da17a4b496015d49)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareHsl]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareHsl]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0cf8df18d218fd0cee7aea8de8e6fae0ac87dfa647a33c9136df900444f4e700)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareHslOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareHslOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__32693c2c48db2d1904c9416f5708ca4e4d5fe66ec27d9a3e6c783b14c0dd8c8c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightness")
    def reset_lightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightness", []))

    @jsii.member(jsii_name="resetLightnessVar")
    def reset_lightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessInput")
    def lightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessVarInput")
    def lightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f3bfb3c08154a05ae2e7c0b948a855acd09b71687421b60e054f6cb868cec703)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__11577aaf756d377d9c33af99beb4d99664fb91ed1e84176fcc573754bfc80643)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightness")
    def lightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightness"))

    @lightness.setter
    def lightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d64aaafd62a653473ef39dab6a16314876b460b7cfb356a0efc62cab0bf8d250)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightness", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessVar")
    def lightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessVar"))

    @lightness_var.setter
    def lightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__44005185589abb418fba2a77e89963947006c215a24a1c47cdfefd272028ead8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b479813d04a9139adac3f2bb954bf0bf95c156f0d1e5711c887c0e1e205a7f46)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__db71d95a3730626820dce700056fdb7e4e46c73846b4ff75d4527e13f4cd6e76)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareHsl]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareHsl]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareHsl]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__105f224538eefdb6512714ea07a9c22aa511ddd780325460c2703005c6140bd1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareHsv",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareHsv:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        :param value: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4e164396beeee0ab079fae0276f5de2c7ac6d21bc9e6063877cbd1744ed05a71)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareHsv(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareHsvList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareHsvList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__708a1e80baf70d5c864aebd7252702c9758ee674fffe0ec03ac96f74e5e8a59c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareHsvOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d0266c7c63a98300bad1864cf2f0cfd7d18f64a8403f9266e5b94aebde3b29c3)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareHsvOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8dbd34acf1cb9023d266a4b2fee81ea9f520529f34a1be10b9ee2591e6897cc6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__86f846c1074f97bb73b691600b81790f9adf915cdc61270a37f5cdf815fed6b7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f82f607acc2bb58c310f4081db151664b1fe37080f64a0d4390be0f48913c43c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareHsv]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareHsv]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c96efe4061dde856ff6c718a65ea721875d2a0dc2c15f8a57dac17cdfe36e66a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareHsvOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareHsvOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e3b4d6abf7c558614f7ca59a8d1c60bba475f031d53a66e998a9f3eb6ca667b1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ce17338493bc6cb3cba2785c62abbedba9be4319dfaadbb0d4a836542cff2d93)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac2393b9b89805dc072f31cecf9bf4c233ba6d75614a075d6a0359abf3dfe150)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d1c0cdab35e733658f1eb47558815e714ed6f4be634ef89d59ae08755f8e21b8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__60b389aa94c701c7e10f8fa6395b2b0cd8676b8fcb87fd938a738b3060c787ad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__62559e283b5284530de50a98f21ce1c5bfd43f7ed139c3075aac83d0233dbb0e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e683752555dcaaf6c461d5a8cbdbfdad1b9d556ae0d4b632772027cf8f452e60)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareHsv]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareHsv]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareHsv]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9c39668f035c4a50443a81bfd40870ee54a24a3e5c3df448e4a9be3e08b232b8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfDimension",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "dimension": "dimension",
        "dimension_var": "dimensionVar",
        "equal": "equal",
        "greater_than": "greaterThan",
        "less_than": "lessThan",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfDimension:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfDimensionDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        dimension: typing.Optional[builtins.str] = None,
        dimension_var: typing.Optional[builtins.str] = None,
        equal: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfDimensionEqual", typing.Dict[builtins.str, typing.Any]]] = None,
        greater_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfDimensionGreaterThan", typing.Dict[builtins.str, typing.Any]]] = None,
        less_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfDimensionLessThan", typing.Dict[builtins.str, typing.Any]]] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param dimension: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        :param dimension_var: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        :param equal: equal block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        :param greater_than: greater_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        :param less_than: less_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        :param value: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfDimensionDefault(**default)
        if isinstance(equal, dict):
            equal = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfDimensionEqual(**equal)
        if isinstance(greater_than, dict):
            greater_than = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfDimensionGreaterThan(**greater_than)
        if isinstance(less_than, dict):
            less_than = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfDimensionLessThan(**less_than)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__09806cca6d1a19083f0e52deef1f57ce82ea89cfc3786016e0623762fe6cd6a4)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument dimension", value=dimension, expected_type=type_hints["dimension"])
            check_type(argname="argument dimension_var", value=dimension_var, expected_type=type_hints["dimension_var"])
            check_type(argname="argument equal", value=equal, expected_type=type_hints["equal"])
            check_type(argname="argument greater_than", value=greater_than, expected_type=type_hints["greater_than"])
            check_type(argname="argument less_than", value=less_than, expected_type=type_hints["less_than"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if dimension is not None:
            self._values["dimension"] = dimension
        if dimension_var is not None:
            self._values["dimension_var"] = dimension_var
        if equal is not None:
            self._values["equal"] = equal
        if greater_than is not None:
            self._values["greater_than"] = greater_than
        if less_than is not None:
            self._values["less_than"] = less_than
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfDimensionDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfDimensionDefault"], result)

    @builtins.property
    def dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        '''
        result = self._values.get("dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        '''
        result = self._values.get("dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def equal(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfDimensionEqual"]:
        '''equal block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        '''
        result = self._values.get("equal")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfDimensionEqual"], result)

    @builtins.property
    def greater_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfDimensionGreaterThan"]:
        '''greater_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        '''
        result = self._values.get("greater_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfDimensionGreaterThan"], result)

    @builtins.property
    def less_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfDimensionLessThan"]:
        '''less_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        '''
        result = self._values.get("less_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfDimensionLessThan"], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfDimension(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfDimensionDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfDimensionDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfDimensionDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfDimensionDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfDimensionDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0edf51b54ade4aea480fc5a7a75f6acf9e3c5b1b996025bbc796fcb1ba87a1c0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfDimensionDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfDimensionDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e455866740db8130daecb626b45737680bb0b6a14ccadc3d7adc74788ba6a421)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfDimensionEqual",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfDimensionEqual:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfDimensionEqual(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfDimensionEqualOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfDimensionEqualOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__60c48cd25369a33c3df3f90c30d27244d95b55952d7d73698638b536f9497b77)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfDimensionEqual], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfDimensionEqual],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d28ae69cd1a38c391bd533ff73298a13e7c6abfab266e6b2472252dbc2e78cc4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfDimensionGreaterThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfDimensionGreaterThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfDimensionGreaterThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfDimensionGreaterThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfDimensionGreaterThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7ff4d7cd200b0733a1f99f6c5045eab6e4f8a5d46e780a21390b3f514c4e6323)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfDimensionGreaterThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfDimensionGreaterThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fc1e926ccd12746e8326ec267eaa5f29336147b4647d538fae581b3057326822)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfDimensionLessThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfDimensionLessThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfDimensionLessThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfDimensionLessThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfDimensionLessThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8d5efd8c2a27077583f44fd48ad45e8c64c887da725af1e84bbd7e86bb0409fe)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfDimensionLessThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfDimensionLessThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a17a6c2a62577e38421590ae9a62455b06a43fbc8fc68d2638bf812b389f4cfe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfDimensionList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfDimensionList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__31ac39fbbcccb56411cca297301057f2cbee32c5110e62e69d9be52ade5ca705)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfDimensionOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__56f4cb34fb04432be002e18b5a8618602bc48ff4f1cf0d54d4ddb101d22c18eb)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfDimensionOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__88708c5e6859749061cf29be2c7ed1165b79931a1cdfcd251419701929782c1c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__acc3ba84297e0611d8645d6f792ae0a46320bd804cb406b90c8396867806fbec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dddfa4c58d14815afe8884d08eb439f426ebdb879b662a8f982eee4302f50eb4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfDimension]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfDimension]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__79b58da3c97498ad9c2917efffb2b3a8135f60669fac71c6d57471738de51ff5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfDimensionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfDimensionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b120ce023389ba98797343c0a90d1afcd5f642d659d8827b0051c4ffdb2b10f9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfDimensionDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putEqual")
    def put_equal(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfDimensionEqual()

        return typing.cast(None, jsii.invoke(self, "putEqual", [value]))

    @jsii.member(jsii_name="putGreaterThan")
    def put_greater_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfDimensionGreaterThan()

        return typing.cast(None, jsii.invoke(self, "putGreaterThan", [value]))

    @jsii.member(jsii_name="putLessThan")
    def put_less_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfDimensionLessThan()

        return typing.cast(None, jsii.invoke(self, "putLessThan", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetDimension")
    def reset_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimension", []))

    @jsii.member(jsii_name="resetDimensionVar")
    def reset_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimensionVar", []))

    @jsii.member(jsii_name="resetEqual")
    def reset_equal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEqual", []))

    @jsii.member(jsii_name="resetGreaterThan")
    def reset_greater_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGreaterThan", []))

    @jsii.member(jsii_name="resetLessThan")
    def reset_less_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLessThan", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfDimensionDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfDimensionDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="equal")
    def equal(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfDimensionEqualOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfDimensionEqualOutputReference, jsii.get(self, "equal"))

    @builtins.property
    @jsii.member(jsii_name="greaterThan")
    def greater_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfDimensionGreaterThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfDimensionGreaterThanOutputReference, jsii.get(self, "greaterThan"))

    @builtins.property
    @jsii.member(jsii_name="lessThan")
    def less_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfDimensionLessThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfDimensionLessThanOutputReference, jsii.get(self, "lessThan"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfDimensionDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionInput")
    def dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionVarInput")
    def dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="equalInput")
    def equal_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfDimensionEqual], jsii.get(self, "equalInput"))

    @builtins.property
    @jsii.member(jsii_name="greaterThanInput")
    def greater_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfDimensionGreaterThan], jsii.get(self, "greaterThanInput"))

    @builtins.property
    @jsii.member(jsii_name="lessThanInput")
    def less_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfDimensionLessThan], jsii.get(self, "lessThanInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="dimension")
    def dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimension"))

    @dimension.setter
    def dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__96f9d8f56dc76cb1e4a1f8c41a406711b024fcceb29bb55048a5307247db90c1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimension", value)

    @builtins.property
    @jsii.member(jsii_name="dimensionVar")
    def dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimensionVar"))

    @dimension_var.setter
    def dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0667620eebd14ec7d1596e502f81bf2af08b2733cbcafb304bc24a3cdfadcffa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0e0fac2619ed147af7b4ddd00e70075fe8f253388b7c386cea8d1a9efc6809e5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b7c4b5b287c2ce917602fff546d335194a80590442bccc67fd671affa5926261)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfDimension]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfDimension]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfDimension]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d5723ee5050b0d745e22a0599da4b7ec4acbda44a5d01bbf72a79131576ff01)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfOrientation",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "landscape": "landscape",
        "portrait": "portrait",
        "square": "square",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfOrientation:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfOrientationDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        landscape: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfOrientationLandscape", typing.Dict[builtins.str, typing.Any]]] = None,
        portrait: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfOrientationPortrait", typing.Dict[builtins.str, typing.Any]]] = None,
        square: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfOrientationSquare", typing.Dict[builtins.str, typing.Any]]] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param landscape: landscape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        :param portrait: portrait block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        :param square: square block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfOrientationDefault(**default)
        if isinstance(landscape, dict):
            landscape = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfOrientationLandscape(**landscape)
        if isinstance(portrait, dict):
            portrait = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfOrientationPortrait(**portrait)
        if isinstance(square, dict):
            square = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfOrientationSquare(**square)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__effbca679f9da7a22a7a5cfe69deb0ae88c4a5c4211dc4723db37a95177c568b)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument landscape", value=landscape, expected_type=type_hints["landscape"])
            check_type(argname="argument portrait", value=portrait, expected_type=type_hints["portrait"])
            check_type(argname="argument square", value=square, expected_type=type_hints["square"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if landscape is not None:
            self._values["landscape"] = landscape
        if portrait is not None:
            self._values["portrait"] = portrait
        if square is not None:
            self._values["square"] = square

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfOrientationDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfOrientationDefault"], result)

    @builtins.property
    def landscape(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfOrientationLandscape"]:
        '''landscape block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        '''
        result = self._values.get("landscape")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfOrientationLandscape"], result)

    @builtins.property
    def portrait(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfOrientationPortrait"]:
        '''portrait block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        '''
        result = self._values.get("portrait")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfOrientationPortrait"], result)

    @builtins.property
    def square(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfOrientationSquare"]:
        '''square block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        result = self._values.get("square")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfOrientationSquare"], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfOrientation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfOrientationDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfOrientationDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfOrientationDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfOrientationDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfOrientationDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3e2eb7dce4c4bd6adb029cd4ced8e9123d4b64fc3e7bc4512ec9a12043ade205)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfOrientationDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfOrientationDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cc8858233513016ca2df4c1391d315906744f336b77130e16dabad4bffc45070)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfOrientationLandscape",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfOrientationLandscape:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfOrientationLandscape(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfOrientationLandscapeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfOrientationLandscapeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ee65f7431fd9d92d6d0b38e292966e864b4d9244b8fd5ff039654f4590cda086)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfOrientationLandscape], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfOrientationLandscape],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8716aae59ac7e68cdb9da085d6b1b7e1a46a744d35c6c961a71f83a69564deb3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfOrientationList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfOrientationList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cafdde48bd7b6c146837b7be317a47174a9d2e864b4bf74ecc80918d7f790030)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfOrientationOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8c22cc1c733cb4f8ef549c0f95dfd8c128f27922ffa492b0221afdd864b2a355)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfOrientationOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c928d6fd5048c1bdcd185de94a3843cd1f78aa9e5ae1248443cb4359f9c2828d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7e3a645be474c3a8268b3642eaed52e3ac18598be2e09affd268dc4a08e297f9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd5e7905f47696467b1a27142c7243b05ea43dd0445b9fabba20d73f6a2a8fd0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfOrientation]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfOrientation]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9216cf0c15e6d0608e33205275817904d61a62c19bb695905d3a9078589c57ec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfOrientationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfOrientationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e8bc4378dc54e0a8109b7aafbe03d82b2fbb3d21b20bd28dc93b6faa507c5af9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfOrientationDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putLandscape")
    def put_landscape(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfOrientationLandscape()

        return typing.cast(None, jsii.invoke(self, "putLandscape", [value]))

    @jsii.member(jsii_name="putPortrait")
    def put_portrait(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfOrientationPortrait()

        return typing.cast(None, jsii.invoke(self, "putPortrait", [value]))

    @jsii.member(jsii_name="putSquare")
    def put_square(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfOrientationSquare()

        return typing.cast(None, jsii.invoke(self, "putSquare", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetLandscape")
    def reset_landscape(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLandscape", []))

    @jsii.member(jsii_name="resetPortrait")
    def reset_portrait(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPortrait", []))

    @jsii.member(jsii_name="resetSquare")
    def reset_square(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSquare", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfOrientationDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfOrientationDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="landscape")
    def landscape(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfOrientationLandscapeOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfOrientationLandscapeOutputReference, jsii.get(self, "landscape"))

    @builtins.property
    @jsii.member(jsii_name="portrait")
    def portrait(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfOrientationPortraitOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfOrientationPortraitOutputReference", jsii.get(self, "portrait"))

    @builtins.property
    @jsii.member(jsii_name="square")
    def square(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfOrientationSquareOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfOrientationSquareOutputReference", jsii.get(self, "square"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfOrientationDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="landscapeInput")
    def landscape_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfOrientationLandscape], jsii.get(self, "landscapeInput"))

    @builtins.property
    @jsii.member(jsii_name="portraitInput")
    def portrait_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfOrientationPortrait"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfOrientationPortrait"], jsii.get(self, "portraitInput"))

    @builtins.property
    @jsii.member(jsii_name="squareInput")
    def square_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfOrientationSquare"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfOrientationSquare"], jsii.get(self, "squareInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfOrientation]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfOrientation]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfOrientation]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__67e53a55a539f3fa10faebfcb6336e1eb329a44d0c39c2386b3164c6583c66e5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfOrientationPortrait",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfOrientationPortrait:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfOrientationPortrait(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfOrientationPortraitOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfOrientationPortraitOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f28c6a9e41e3c72c8cca1b5093d550af5841f8e59531bef963ed297622dc222b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfOrientationPortrait]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfOrientationPortrait], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfOrientationPortrait],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__14577c40be73ec1997c673d018ac135505abd56ef68cd808ad5d3b42b1b08d54)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfOrientationSquare",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfOrientationSquare:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfOrientationSquare(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfOrientationSquareOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfOrientationSquareOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__19b1ad273ab7f105a447167148c1fec5c9ddd2ae8029eea3e1e7bbb2df37eb12)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfOrientationSquare]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfOrientationSquare], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfOrientationSquare],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ced34867e517b5c199a5a979f248a024ddd9cf716f8a974ac9b9ffa0cd1f5556)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareMaxColors",
    jsii_struct_bases=[],
    name_mapping={"colors": "colors", "colors_var": "colorsVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareMaxColors:
    def __init__(
        self,
        *,
        colors: typing.Optional[builtins.str] = None,
        colors_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param colors: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        :param colors_var: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ae58b5d4cf0ee55eb49fa27c282b651651b9b56cae16322a217da34d6345ab75)
            check_type(argname="argument colors", value=colors, expected_type=type_hints["colors"])
            check_type(argname="argument colors_var", value=colors_var, expected_type=type_hints["colors_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if colors is not None:
            self._values["colors"] = colors
        if colors_var is not None:
            self._values["colors_var"] = colors_var

    @builtins.property
    def colors(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        '''
        result = self._values.get("colors")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def colors_var(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        result = self._values.get("colors_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareMaxColors(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareMaxColorsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareMaxColorsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f50688bf5a8fa1aff386019b51f0a1c0480356c1db753f709f35f8c28587198e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareMaxColorsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aa34083ceaf908e3faae3038696d5bb8739c0b40d8da4b9ea50e91056de0c865)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareMaxColorsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d3f8e97e98b3fb5dd969b4319ed23c4822dc1851bf363fe3618dd7fbd20b923c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__32e904db0be33bf94ce45b92627dd92efae48ec58ef6e00d91cad4ef85a2f95b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c7a7d33d6fd60d4a588982d9afbb1b2bf0c631a90bac5b840a3b47bbce7921d0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareMaxColors]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareMaxColors]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6723be53dd7577cb6f3bddf4d36e880a89771a5fbc88d49c42a986586a56c642)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareMaxColorsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareMaxColorsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb17fb9bcfab5ca2bebaf87aacebc02e894ea5b84c2e9cb9b685299b1f56f3cf)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColors")
    def reset_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColors", []))

    @jsii.member(jsii_name="resetColorsVar")
    def reset_colors_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorsVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorsInput")
    def colors_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsInput"))

    @builtins.property
    @jsii.member(jsii_name="colorsVarInput")
    def colors_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsVarInput"))

    @builtins.property
    @jsii.member(jsii_name="colors")
    def colors(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colors"))

    @colors.setter
    def colors(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c25bf118f59fbd810fb9f4c7623724a401fb3fe43049b617b3dcedc0ae32eb74)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colors", value)

    @builtins.property
    @jsii.member(jsii_name="colorsVar")
    def colors_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorsVar"))

    @colors_var.setter
    def colors_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e0752db714ca9992a290262386a155921b013ece247fcbcdf257eb8466732f41)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorsVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareMaxColors]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareMaxColors]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareMaxColors]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ca9856d0e0e048110e0f4b52d859487448bc6fc16360e5de3afc1488e5b3c87)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareMirror",
    jsii_struct_bases=[],
    name_mapping={
        "horizontal": "horizontal",
        "horizontal_var": "horizontalVar",
        "vertical": "vertical",
        "vertical_var": "verticalVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareMirror:
    def __init__(
        self,
        *,
        horizontal: typing.Optional[builtins.str] = None,
        horizontal_var: typing.Optional[builtins.str] = None,
        vertical: typing.Optional[builtins.str] = None,
        vertical_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param horizontal: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        :param horizontal_var: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        :param vertical: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        :param vertical_var: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__98aab48e15095395ac3e0b73fc044369eca7d63218380a438e832c6f95c7f9c8)
            check_type(argname="argument horizontal", value=horizontal, expected_type=type_hints["horizontal"])
            check_type(argname="argument horizontal_var", value=horizontal_var, expected_type=type_hints["horizontal_var"])
            check_type(argname="argument vertical", value=vertical, expected_type=type_hints["vertical"])
            check_type(argname="argument vertical_var", value=vertical_var, expected_type=type_hints["vertical_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if horizontal is not None:
            self._values["horizontal"] = horizontal
        if horizontal_var is not None:
            self._values["horizontal_var"] = horizontal_var
        if vertical is not None:
            self._values["vertical"] = vertical
        if vertical_var is not None:
            self._values["vertical_var"] = vertical_var

    @builtins.property
    def horizontal(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        '''
        result = self._values.get("horizontal")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def horizontal_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        '''
        result = self._values.get("horizontal_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        '''
        result = self._values.get("vertical")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        result = self._values.get("vertical_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareMirror(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareMirrorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareMirrorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f6d21ccfc869ce9b664b883c95d5b6cea0b3233fbb509785647e42dcb9667f19)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareMirrorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0d9564355a0d8b0903979b5a36b8b072fa8d286e4fda2a4badda7e6c6496e312)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareMirrorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__26aff56f2389e138edf5dbaaef071cbb4afef6269087f49d0230783356e4003c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0519272e6ae6542d87b47854fb11c328ff7f733a6e15f2e1e06196e1faa684b5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ec4e82cab0e5c94103a35a8640c9901bbda62e7f99fe90595e418649fb0c1484)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareMirror]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareMirror]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ff453d4a73421d510af1ce2d5e459d338fd83480f5221bbb1210beb5b7e92d7c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareMirrorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareMirrorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d488cdafe728f6dca8af50dbe645c9075232ff87dae23288c4260ad4fbcd6f4e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHorizontal")
    def reset_horizontal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontal", []))

    @jsii.member(jsii_name="resetHorizontalVar")
    def reset_horizontal_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontalVar", []))

    @jsii.member(jsii_name="resetVertical")
    def reset_vertical(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVertical", []))

    @jsii.member(jsii_name="resetVerticalVar")
    def reset_vertical_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVerticalVar", []))

    @builtins.property
    @jsii.member(jsii_name="horizontalInput")
    def horizontal_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontalVarInput")
    def horizontal_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalInput")
    def vertical_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalVarInput")
    def vertical_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontal")
    def horizontal(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontal"))

    @horizontal.setter
    def horizontal(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__33913f806c8bfa43d1346b26265aa8062eb3fafe922e2d5c522c71bae9852179)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontal", value)

    @builtins.property
    @jsii.member(jsii_name="horizontalVar")
    def horizontal_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontalVar"))

    @horizontal_var.setter
    def horizontal_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__86ff371439f98b5a930ce38dbfe04bb56a649d51497626082d026172d2d9499a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontalVar", value)

    @builtins.property
    @jsii.member(jsii_name="vertical")
    def vertical(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "vertical"))

    @vertical.setter
    def vertical(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__555597099b9af65b2f0b0c04eb98aec61b9c7720ca0738e007148b1bbea780d9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "vertical", value)

    @builtins.property
    @jsii.member(jsii_name="verticalVar")
    def vertical_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "verticalVar"))

    @vertical_var.setter
    def vertical_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c46e2ce48f453d84253dcb251a6fd85159e4fdd6eba77cf6202f18a2f2473406)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "verticalVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareMirror]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareMirror]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareMirror]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f8a11c52c02cfbcbae6aa266c59068ec51e1c7540698636f50ef0ef9f363aa64)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareMonoHue",
    jsii_struct_bases=[],
    name_mapping={"hue": "hue", "hue_var": "hueVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareMonoHue:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d2f78dbf033bdcbeaafe6f75992ba7aa96f9d9b049c84ac883128bec7a0cd97)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareMonoHue(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareMonoHueList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareMonoHueList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__548cdeae67744902087643fb33ceb090cf1b456a71ca7c9f5da123d6fde124c1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareMonoHueOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7f804c085acae7526aa564a0524d709418995714e98d8911fbd2675eda227676)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareMonoHueOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7a8f9bf0b13917bbf3f126aaaa343ca48e30f05ae0af3ddc9324b843c43a624a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__83e9c1074de44289928c377a0e2772060c56d7c40b06a050ff16aa9268b8e084)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a1b1d3fc387a74b9a9bf6e33163c5f71bcb50d8c1cd038166a0ab4eb25d4475)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareMonoHue]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareMonoHue]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8c20a721e70261ad81670f4ee9f2b6e5ae66cf6f4436601abaeb49d351953d01)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareMonoHueOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareMonoHueOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__84a485182afbbae68301a9b8b738783339229a433b8e5845844666df9843b64c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7fa9a09ebd577de99003aabf91d96d28308d12c95966c8cacc8e543876d399d3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c279957169b1045b10ca7fa743d49f1d88ec326d93fcc2d32f020183135a1dc4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareMonoHue]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareMonoHue]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareMonoHue]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b096e37130db38607bcb67a21722b1c6fc273d819bda5c9b219bb5323fce6382)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareOpacity",
    jsii_struct_bases=[],
    name_mapping={"opacity": "opacity", "opacity_var": "opacityVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareOpacity:
    def __init__(
        self,
        *,
        opacity: typing.Optional[builtins.str] = None,
        opacity_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param opacity: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param opacity_var: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc8b7c2f36e904a689c9a7d68901219796bce56632be345bdf051a48d9f087a7)
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument opacity_var", value=opacity_var, expected_type=type_hints["opacity_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if opacity is not None:
            self._values["opacity"] = opacity
        if opacity_var is not None:
            self._values["opacity_var"] = opacity_var

    @builtins.property
    def opacity(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def opacity_var(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        result = self._values.get("opacity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareOpacity(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareOpacityList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareOpacityList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c42bd1bf2fef96895b0ba2cda10d47e253a15bee3c33104ea7d2b345b58b88da)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareOpacityOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__92bf4fc2d49abb9ac98addb7a3692b6c1b92aa45796002db081b03facb451c1b)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareOpacityOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1004a93de6bbe54c887d852f955964e363d7cfd8881293f4ccccaab0476e9699)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eda81221e19dfb7740c6577deb5b5c44a03ab92f04d331a5a1e491cd8e52ffe8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a943f7f27e983a649814d2af497dfdd670f4864691b0c6dec5cd2eb6c6e16aa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareOpacity]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareOpacity]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aea5534d7aed0f5c9d2647ec445e74c95ec77bbfd1c18b533e29b9537cd3d489)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareOpacityOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareOpacityOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a19b5014380c2edf862875ad2f10c99bbe5b2c79330e89bcd8c02f8a801c9e2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetOpacityVar")
    def reset_opacity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacityVar", []))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityVarInput")
    def opacity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacity"))

    @opacity.setter
    def opacity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b8bb5310c90f3c7d63b221414ab2417f61c6611746fd53c033351ec65e1823d8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacity", value)

    @builtins.property
    @jsii.member(jsii_name="opacityVar")
    def opacity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacityVar"))

    @opacity_var.setter
    def opacity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__beb362023a4f0ddd48eeecd7945414076e2af867d57c7055007039ebd5214740)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacityVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareOpacity]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareOpacity]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareOpacity]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e0d3f772c4d369e849892e00e861cc57dffcb1e96b01f98c6bc33f21ea2b15e2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ac31201b48c3006fe12999293ed8b1e3795ba5877c331ee32673c61051a9f1d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putBackgroundColor")
    def put_background_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__58f25540e0a47b0e9db08577cc821462eea67eba912441d3c063270b1ac124e1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBackgroundColor", [value]))

    @jsii.member(jsii_name="putBlur")
    def put_blur(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareBlur, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b225fd875a521aae1eeb31fc8881f3aefa8df298389d2069fba4333ffbdd4093)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBlur", [value]))

    @jsii.member(jsii_name="putChromaKey")
    def put_chroma_key(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareChromaKey, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__701f84f2c986233b0fce5648e01e17aead8631b95ffac326f1f8b996b29f470a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putChromaKey", [value]))

    @jsii.member(jsii_name="putComposite")
    def put_composite(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareComposite, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e5f91bd2b08912eb5fd8330f6d1b1d2d1ba70bef664233f49c3b3e431fb66a00)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putComposite", [value]))

    @jsii.member(jsii_name="putCompound")
    def put_compound(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareCompound, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__36e11ef2cf995141b07710af22439c3091cfac2b117526c7423fc54c26a3bd63)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCompound", [value]))

    @jsii.member(jsii_name="putContrast")
    def put_contrast(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareContrast, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5136f823ab02993945e930c401c8ce2422537e170034bf6653b5a0b447ddec7b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putContrast", [value]))

    @jsii.member(jsii_name="putGoop")
    def put_goop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareGoop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__46e8067a7ddae647577c9f52ad6e001e00e26fd402a9122000096410167e571e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGoop", [value]))

    @jsii.member(jsii_name="putGrayscale")
    def put_grayscale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareGrayscale, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb5666f0a4dd827a5ebdb66eb55774c0de7e64658608a79349335079847f6e45)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGrayscale", [value]))

    @jsii.member(jsii_name="putHsl")
    def put_hsl(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareHsl, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__76ec4656b8ef08cd98e6cae03e7fea088f0c550c23f787358bd174e8d61cb893)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsl", [value]))

    @jsii.member(jsii_name="putHsv")
    def put_hsv(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareHsv, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb4876c3719d9d88d2667381eea1f57ca8dad417e5f9cb22556deb2325b38fe3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsv", [value]))

    @jsii.member(jsii_name="putIfDimension")
    def put_if_dimension(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfDimension, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f8b5cea832c35a9d3227b3e5aa599f06f6e19ec0a8c7fd5b436577b57bd1e9f3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfDimension", [value]))

    @jsii.member(jsii_name="putIfOrientation")
    def put_if_orientation(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e5519b99d0b0acec3bb52b8714e7177714ac4b79927473238121cf128a40fb42)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfOrientation", [value]))

    @jsii.member(jsii_name="putMaxColors")
    def put_max_colors(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareMaxColors, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__143f3eb00c8c2d6a63f0504a7bf48c06b7b6de1e7d2ed75b7b3d69b273cbe6a0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMaxColors", [value]))

    @jsii.member(jsii_name="putMirror")
    def put_mirror(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareMirror, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__30a98d5b160333ad69675a3eda0161a653f792bdfaa9bbeb99df31dac5dcb119)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMirror", [value]))

    @jsii.member(jsii_name="putMonoHue")
    def put_mono_hue(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareMonoHue, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8f7f188dc8545e6eed201f3ae9ad55040a420170ff401cf5241165ba7b020286)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMonoHue", [value]))

    @jsii.member(jsii_name="putOpacity")
    def put_opacity(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareOpacity, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__36193df4db95ef0d08ec8db671089d6e37d44846d4c4c0146818c2535c82e7fd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putOpacity", [value]))

    @jsii.member(jsii_name="putRemoveColor")
    def put_remove_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareRemoveColor", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0318e65a9e4ebdaaeb8e18f93a42117ff2ad5ad950a8ac1233000aded0e3277c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRemoveColor", [value]))

    @jsii.member(jsii_name="putUnsharpMask")
    def put_unsharp_mask(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareUnsharpMask", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e773eb3f2b53fa4f3f64dedb4d02e0c992ef9a2732945bb8c7bd43d2ddf9b9ea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putUnsharpMask", [value]))

    @jsii.member(jsii_name="resetBackgroundColor")
    def reset_background_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBackgroundColor", []))

    @jsii.member(jsii_name="resetBlur")
    def reset_blur(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBlur", []))

    @jsii.member(jsii_name="resetChromaKey")
    def reset_chroma_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChromaKey", []))

    @jsii.member(jsii_name="resetComposite")
    def reset_composite(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetComposite", []))

    @jsii.member(jsii_name="resetCompound")
    def reset_compound(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCompound", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetGoop")
    def reset_goop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGoop", []))

    @jsii.member(jsii_name="resetGrayscale")
    def reset_grayscale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGrayscale", []))

    @jsii.member(jsii_name="resetHsl")
    def reset_hsl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsl", []))

    @jsii.member(jsii_name="resetHsv")
    def reset_hsv(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsv", []))

    @jsii.member(jsii_name="resetIfDimension")
    def reset_if_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfDimension", []))

    @jsii.member(jsii_name="resetIfOrientation")
    def reset_if_orientation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfOrientation", []))

    @jsii.member(jsii_name="resetMaxColors")
    def reset_max_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxColors", []))

    @jsii.member(jsii_name="resetMirror")
    def reset_mirror(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMirror", []))

    @jsii.member(jsii_name="resetMonoHue")
    def reset_mono_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonoHue", []))

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetRemoveColor")
    def reset_remove_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRemoveColor", []))

    @jsii.member(jsii_name="resetUnsharpMask")
    def reset_unsharp_mask(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUnsharpMask", []))

    @builtins.property
    @jsii.member(jsii_name="backgroundColor")
    def background_color(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareBackgroundColorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareBackgroundColorList, jsii.get(self, "backgroundColor"))

    @builtins.property
    @jsii.member(jsii_name="blur")
    def blur(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareBlurList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareBlurList, jsii.get(self, "blur"))

    @builtins.property
    @jsii.member(jsii_name="chromaKey")
    def chroma_key(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareChromaKeyList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareChromaKeyList, jsii.get(self, "chromaKey"))

    @builtins.property
    @jsii.member(jsii_name="composite")
    def composite(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareCompositeList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareCompositeList, jsii.get(self, "composite"))

    @builtins.property
    @jsii.member(jsii_name="compound")
    def compound(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareCompoundList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareCompoundList, jsii.get(self, "compound"))

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareContrastList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareContrastList, jsii.get(self, "contrast"))

    @builtins.property
    @jsii.member(jsii_name="goop")
    def goop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareGoopList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareGoopList, jsii.get(self, "goop"))

    @builtins.property
    @jsii.member(jsii_name="grayscale")
    def grayscale(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareGrayscaleList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareGrayscaleList, jsii.get(self, "grayscale"))

    @builtins.property
    @jsii.member(jsii_name="hsl")
    def hsl(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareHslList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareHslList, jsii.get(self, "hsl"))

    @builtins.property
    @jsii.member(jsii_name="hsv")
    def hsv(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareHsvList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareHsvList, jsii.get(self, "hsv"))

    @builtins.property
    @jsii.member(jsii_name="ifDimension")
    def if_dimension(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfDimensionList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfDimensionList, jsii.get(self, "ifDimension"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientation")
    def if_orientation(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfOrientationList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfOrientationList, jsii.get(self, "ifOrientation"))

    @builtins.property
    @jsii.member(jsii_name="maxColors")
    def max_colors(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareMaxColorsList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareMaxColorsList, jsii.get(self, "maxColors"))

    @builtins.property
    @jsii.member(jsii_name="mirror")
    def mirror(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareMirrorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareMirrorList, jsii.get(self, "mirror"))

    @builtins.property
    @jsii.member(jsii_name="monoHue")
    def mono_hue(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareMonoHueList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareMonoHueList, jsii.get(self, "monoHue"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareOpacityList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareOpacityList, jsii.get(self, "opacity"))

    @builtins.property
    @jsii.member(jsii_name="removeColor")
    def remove_color(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareRemoveColorList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareRemoveColorList", jsii.get(self, "removeColor"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMask")
    def unsharp_mask(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareUnsharpMaskList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareUnsharpMaskList", jsii.get(self, "unsharpMask"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColorInput")
    def background_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareBackgroundColor]]], jsii.get(self, "backgroundColorInput"))

    @builtins.property
    @jsii.member(jsii_name="blurInput")
    def blur_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareBlur]]], jsii.get(self, "blurInput"))

    @builtins.property
    @jsii.member(jsii_name="chromaKeyInput")
    def chroma_key_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareChromaKey]]], jsii.get(self, "chromaKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="compositeInput")
    def composite_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareComposite]]], jsii.get(self, "compositeInput"))

    @builtins.property
    @jsii.member(jsii_name="compoundInput")
    def compound_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareCompound]]], jsii.get(self, "compoundInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareContrast]]], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="goopInput")
    def goop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareGoop]]], jsii.get(self, "goopInput"))

    @builtins.property
    @jsii.member(jsii_name="grayscaleInput")
    def grayscale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareGrayscale]]], jsii.get(self, "grayscaleInput"))

    @builtins.property
    @jsii.member(jsii_name="hslInput")
    def hsl_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareHsl]]], jsii.get(self, "hslInput"))

    @builtins.property
    @jsii.member(jsii_name="hsvInput")
    def hsv_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareHsv]]], jsii.get(self, "hsvInput"))

    @builtins.property
    @jsii.member(jsii_name="ifDimensionInput")
    def if_dimension_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfDimension]]], jsii.get(self, "ifDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientationInput")
    def if_orientation_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfOrientation]]], jsii.get(self, "ifOrientationInput"))

    @builtins.property
    @jsii.member(jsii_name="maxColorsInput")
    def max_colors_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareMaxColors]]], jsii.get(self, "maxColorsInput"))

    @builtins.property
    @jsii.member(jsii_name="mirrorInput")
    def mirror_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareMirror]]], jsii.get(self, "mirrorInput"))

    @builtins.property
    @jsii.member(jsii_name="monoHueInput")
    def mono_hue_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareMonoHue]]], jsii.get(self, "monoHueInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareOpacity]]], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="removeColorInput")
    def remove_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareRemoveColor"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareRemoveColor"]]], jsii.get(self, "removeColorInput"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMaskInput")
    def unsharp_mask_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareUnsharpMask"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareUnsharpMask"]]], jsii.get(self, "unsharpMaskInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquare]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquare], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquare],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f7124dbb9e48ea6417ee29648c1a7b3c20e42ea9e39642f822f7a6eb3f5fab53)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareRemoveColor",
    jsii_struct_bases=[],
    name_mapping={
        "color": "color",
        "color_var": "colorVar",
        "feather": "feather",
        "feather_var": "featherVar",
        "tolerance": "tolerance",
        "tolerance_var": "toleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareRemoveColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
        feather: typing.Optional[builtins.str] = None,
        feather_var: typing.Optional[builtins.str] = None,
        tolerance: typing.Optional[builtins.str] = None,
        tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        :param feather: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        :param feather_var: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        :param tolerance: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        :param tolerance_var: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af6853f18daeea9d763b6e4298bbdf100311f9f734f0510f3477be9fa29793fa)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
            check_type(argname="argument feather", value=feather, expected_type=type_hints["feather"])
            check_type(argname="argument feather_var", value=feather_var, expected_type=type_hints["feather_var"])
            check_type(argname="argument tolerance", value=tolerance, expected_type=type_hints["tolerance"])
            check_type(argname="argument tolerance_var", value=tolerance_var, expected_type=type_hints["tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var
        if feather is not None:
            self._values["feather"] = feather
        if feather_var is not None:
            self._values["feather_var"] = feather_var
        if tolerance is not None:
            self._values["tolerance"] = tolerance
        if tolerance_var is not None:
            self._values["tolerance_var"] = tolerance_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        '''
        result = self._values.get("feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather_var(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        '''
        result = self._values.get("feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        '''
        result = self._values.get("tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance_var(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        result = self._values.get("tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareRemoveColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareRemoveColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareRemoveColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa64ee69d196e532bb7bc2b0b2f9737e93514f6592d9c8c413cc44c0cb060742)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareRemoveColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__151b304edd5f3b5a65d5459dfb70220103324ffa43c970be304f0a2a6482b86e)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareRemoveColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d7ee235a6cc001f94bc27f7ee26d7d592d51dc9442c7128fe1e68f17fc6dda0b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bcce1409df21fb725d6e1a47634d0bbe3d906ec4693374b7773ff35ea60e6f4c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6a6771857bd1fd825c9dd1edbb7c16d1dd7beb687033cfe881f995dc1f14aa66)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareRemoveColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareRemoveColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareRemoveColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__31b1274dd963f80bf0d375c56058263df54d286c6c79e41b77d440e45041ed66)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareRemoveColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareRemoveColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4d5ef04c0829fe36ce4605d62c033693655d400feac59a8abbf96b21af8c7ba8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @jsii.member(jsii_name="resetFeather")
    def reset_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeather", []))

    @jsii.member(jsii_name="resetFeatherVar")
    def reset_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatherVar", []))

    @jsii.member(jsii_name="resetTolerance")
    def reset_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTolerance", []))

    @jsii.member(jsii_name="resetToleranceVar")
    def reset_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featherInput")
    def feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherInput"))

    @builtins.property
    @jsii.member(jsii_name="featherVarInput")
    def feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceInput")
    def tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceVarInput")
    def tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__32ea3c7db6d7a7b167a5666119127c7e0936f1c076518df8578676571a810a9f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4e6a810c0c76eedafedd776bccfbffdf6b9b56d6d7acdf37e6f34ad9ed1d1b78)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="feather")
    def feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "feather"))

    @feather.setter
    def feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__67897a234ed2044a4484a2d328139799fbaba70aafdfbed67a853507473979e0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "feather", value)

    @builtins.property
    @jsii.member(jsii_name="featherVar")
    def feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featherVar"))

    @feather_var.setter
    def feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__50b7bb2553ad92cb91132f63d01912e6ef98734a194d1c0ed622185905c36d01)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featherVar", value)

    @builtins.property
    @jsii.member(jsii_name="tolerance")
    def tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tolerance"))

    @tolerance.setter
    def tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d9fab79b79ff31f76a3dfa826bc0f87941a13666febbc5e42f3b060d213698fa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tolerance", value)

    @builtins.property
    @jsii.member(jsii_name="toleranceVar")
    def tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "toleranceVar"))

    @tolerance_var.setter
    def tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__131bfa80808d394f4b0341fa63c526d715dc301c4bf1c8ef94c882d8364fb9d3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "toleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareRemoveColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareRemoveColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareRemoveColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f4fb666027393997c9e9feabd7553145c67b11a3b86ce9e9538a5183e1bc6824)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareUnsharpMask",
    jsii_struct_bases=[],
    name_mapping={
        "gain": "gain",
        "gain_var": "gainVar",
        "sigma": "sigma",
        "sigma_var": "sigmaVar",
        "threshold": "threshold",
        "threshold_var": "thresholdVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareUnsharpMask:
    def __init__(
        self,
        *,
        gain: typing.Optional[builtins.str] = None,
        gain_var: typing.Optional[builtins.str] = None,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
        threshold: typing.Optional[builtins.str] = None,
        threshold_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param gain: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        :param gain_var: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        :param sigma: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        :param threshold: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        :param threshold_var: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6307199ee18ab6f3ede2571fa1475a8de95901c6539c6c812700952feabbcbea)
            check_type(argname="argument gain", value=gain, expected_type=type_hints["gain"])
            check_type(argname="argument gain_var", value=gain_var, expected_type=type_hints["gain_var"])
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
            check_type(argname="argument threshold", value=threshold, expected_type=type_hints["threshold"])
            check_type(argname="argument threshold_var", value=threshold_var, expected_type=type_hints["threshold_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if gain is not None:
            self._values["gain"] = gain
        if gain_var is not None:
            self._values["gain_var"] = gain_var
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var
        if threshold is not None:
            self._values["threshold"] = threshold
        if threshold_var is not None:
            self._values["threshold_var"] = threshold_var

    @builtins.property
    def gain(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        '''
        result = self._values.get("gain")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gain_var(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        '''
        result = self._values.get("gain_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        '''
        result = self._values.get("threshold")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold_var(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        result = self._values.get("threshold_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareUnsharpMask(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareUnsharpMaskList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareUnsharpMaskList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c4881a77ef03bdbe0f57c2fe1980adf84d54c2fe87176d36d5e17c32f1d9219c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareUnsharpMaskOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__65c817d7dc1630e3091fcfe40a15aea570a881a113b06c1cad7dbb4db52cb6d3)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareUnsharpMaskOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__44f1f584a37eb9dc3516eedb1fc2c2c84cc69192fb1621297d801bd7b8a3a3d0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__edfb17fa83060ea20aad11d7f64fdef73921afe1098136fa7f45f8c5759b689c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8696136fd1aab0923596f1e7bc25b65ce8c384f9bb522ac9f9d63f11338f6a64)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareUnsharpMask]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareUnsharpMask]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareUnsharpMask]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8c57d089580bda34f194da1ce4a79434c0e029c4036c4b6fe736cccfc86a6609)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareUnsharpMaskOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareUnsharpMaskOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__871e86bc0ba29fbdc24b8af0eb908974cd0a933c76f0a6ba9af2e98bb90c4243)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetGain")
    def reset_gain(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGain", []))

    @jsii.member(jsii_name="resetGainVar")
    def reset_gain_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGainVar", []))

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @jsii.member(jsii_name="resetThreshold")
    def reset_threshold(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThreshold", []))

    @jsii.member(jsii_name="resetThresholdVar")
    def reset_threshold_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThresholdVar", []))

    @builtins.property
    @jsii.member(jsii_name="gainInput")
    def gain_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainInput"))

    @builtins.property
    @jsii.member(jsii_name="gainVarInput")
    def gain_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdInput")
    def threshold_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdVarInput")
    def threshold_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gain")
    def gain(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gain"))

    @gain.setter
    def gain(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__42644ca73e20189c41f1bcdc65cc5229fc7da72b9d4201d13b7a3e1f76f36f9b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gain", value)

    @builtins.property
    @jsii.member(jsii_name="gainVar")
    def gain_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gainVar"))

    @gain_var.setter
    def gain_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a28ba2be01310bc2eefd28e2265cf018adaffa38a7eb14a8a8324781cd1f947e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gainVar", value)

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4110ce59dcd826793dd5f14d9b13482552f5c0805d59309ffeedbeeb146b03c6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c782b0fb75681b851c53eb4a82248eb9b4c771d77844077a45cbb49c8f3187c7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="threshold")
    def threshold(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "threshold"))

    @threshold.setter
    def threshold(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f972d0640c65c726d40a868719b2bc8788b505bf35f53851d64337a630690e81)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "threshold", value)

    @builtins.property
    @jsii.member(jsii_name="thresholdVar")
    def threshold_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "thresholdVar"))

    @threshold_var.setter
    def threshold_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b7c06285ec8abde997810ae95fe1693bfc5fff490b5b69be18ce6fa24ffc87f6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "thresholdVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareUnsharpMask]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareUnsharpMask]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareUnsharpMask]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bf476ce36467623032f272dee4962ad55ff4f07ac8dc4e5b374afe63f9d710d8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualMaxColors",
    jsii_struct_bases=[],
    name_mapping={"colors": "colors", "colors_var": "colorsVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualMaxColors:
    def __init__(
        self,
        *,
        colors: typing.Optional[builtins.str] = None,
        colors_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param colors: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        :param colors_var: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__31bdc5851bda2fe8ce01d06ef528920c0f173b3e44a6712023f67122a324d3e0)
            check_type(argname="argument colors", value=colors, expected_type=type_hints["colors"])
            check_type(argname="argument colors_var", value=colors_var, expected_type=type_hints["colors_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if colors is not None:
            self._values["colors"] = colors
        if colors_var is not None:
            self._values["colors_var"] = colors_var

    @builtins.property
    def colors(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        '''
        result = self._values.get("colors")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def colors_var(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        result = self._values.get("colors_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualMaxColors(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualMaxColorsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualMaxColorsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__adb6a4128f5227bc0639c0150ab9bb1aeab8b74a3aeca327f94bce1ae4405198)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualMaxColorsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__25076ab5accb37aee93fe88de0e4e0b77479fee485895629a383cf7d35d3df82)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualMaxColorsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d201edbbe363d50d2913a8aefa832d1d24ba75cfdac3e46068a1aa69b1770a71)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f57da7365dbbc9749eadf3bb77bec88d8ec92731ecf1292e6db5ee5b00b4d900)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7323d420d5b04bba3baa9b5ace2f86c1f366f8174d9562a4c52e5a9169047b40)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualMaxColors]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualMaxColors]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__949266e09500de1b2ee1ab1ca15efadf9a4fa6dd8e6bb2cc426f3a88e67ede04)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualMaxColorsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualMaxColorsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__963ab82e1f87a0df4e7c20be76b8f0e90846327e6d0084082278c0963b9abecf)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColors")
    def reset_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColors", []))

    @jsii.member(jsii_name="resetColorsVar")
    def reset_colors_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorsVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorsInput")
    def colors_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsInput"))

    @builtins.property
    @jsii.member(jsii_name="colorsVarInput")
    def colors_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsVarInput"))

    @builtins.property
    @jsii.member(jsii_name="colors")
    def colors(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colors"))

    @colors.setter
    def colors(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d7c2022dd137512e3dfbe46ead9cca3cf679d26dfef49df8c1f3c4233b62c2cb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colors", value)

    @builtins.property
    @jsii.member(jsii_name="colorsVar")
    def colors_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorsVar"))

    @colors_var.setter
    def colors_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dd372968ec3a2298668282b3f8892b6658d0ee622e7011feb90cd5ca5d373940)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorsVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualMaxColors]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualMaxColors]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualMaxColors]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__42c178824330143ad5befe94a170a24c8a67c41ff2474c121fd884ef1967b700)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualMirror",
    jsii_struct_bases=[],
    name_mapping={
        "horizontal": "horizontal",
        "horizontal_var": "horizontalVar",
        "vertical": "vertical",
        "vertical_var": "verticalVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualMirror:
    def __init__(
        self,
        *,
        horizontal: typing.Optional[builtins.str] = None,
        horizontal_var: typing.Optional[builtins.str] = None,
        vertical: typing.Optional[builtins.str] = None,
        vertical_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param horizontal: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        :param horizontal_var: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        :param vertical: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        :param vertical_var: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a86bba8757e1fd7cb25cca0aa611cd1b86dc7dbe91a14eb70255f5f65a84e1d2)
            check_type(argname="argument horizontal", value=horizontal, expected_type=type_hints["horizontal"])
            check_type(argname="argument horizontal_var", value=horizontal_var, expected_type=type_hints["horizontal_var"])
            check_type(argname="argument vertical", value=vertical, expected_type=type_hints["vertical"])
            check_type(argname="argument vertical_var", value=vertical_var, expected_type=type_hints["vertical_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if horizontal is not None:
            self._values["horizontal"] = horizontal
        if horizontal_var is not None:
            self._values["horizontal_var"] = horizontal_var
        if vertical is not None:
            self._values["vertical"] = vertical
        if vertical_var is not None:
            self._values["vertical_var"] = vertical_var

    @builtins.property
    def horizontal(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        '''
        result = self._values.get("horizontal")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def horizontal_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        '''
        result = self._values.get("horizontal_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        '''
        result = self._values.get("vertical")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        result = self._values.get("vertical_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualMirror(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualMirrorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualMirrorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0d379f70a630f748ab39447c29b7291225ab61bb53a8d1e142c7d9dd72f69fb7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualMirrorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__136221ccdf836e3c0f63bbe9e49457541d964f5e348fa23592240d011d65cd28)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualMirrorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__05323dcc6d6b3b43615bb2bed15f971dae7cd2c01d0fbe0f05df4b90890afead)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__93f7f94c6f949de68f105faaa086467c067e341d1bbb6890346265e8f89db9bb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__975f8815d9b605c1eee4e259d12302fb998d7a66ff1ad0ea4506a3a2a9d2dfae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualMirror]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualMirror]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e42bf29731f13ddafec3a792a9a39bed4b4c687d668b7cb980b023da9b6afe98)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualMirrorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualMirrorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ca5b0bdc98f61126e8058546cb1bf74954f123e8bff82cc463bc67416e26f5e6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHorizontal")
    def reset_horizontal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontal", []))

    @jsii.member(jsii_name="resetHorizontalVar")
    def reset_horizontal_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontalVar", []))

    @jsii.member(jsii_name="resetVertical")
    def reset_vertical(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVertical", []))

    @jsii.member(jsii_name="resetVerticalVar")
    def reset_vertical_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVerticalVar", []))

    @builtins.property
    @jsii.member(jsii_name="horizontalInput")
    def horizontal_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontalVarInput")
    def horizontal_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalInput")
    def vertical_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalVarInput")
    def vertical_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontal")
    def horizontal(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontal"))

    @horizontal.setter
    def horizontal(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__10c14d879476333f375221393ae9f1d3f65f3a62f112d958e386150c29dd681b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontal", value)

    @builtins.property
    @jsii.member(jsii_name="horizontalVar")
    def horizontal_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontalVar"))

    @horizontal_var.setter
    def horizontal_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__12d46d29bd85148f3267df0914d74e958bad256da2c11be786a94c1fdced1b7f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontalVar", value)

    @builtins.property
    @jsii.member(jsii_name="vertical")
    def vertical(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "vertical"))

    @vertical.setter
    def vertical(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__07d40fd5dbfe65b2ea693394b7579105fa4ebfd845aaa947b9427a81f057eb65)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "vertical", value)

    @builtins.property
    @jsii.member(jsii_name="verticalVar")
    def vertical_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "verticalVar"))

    @vertical_var.setter
    def vertical_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__05f8a7fc30155f416b6cf12881d67b3b2b842bf0fc700bd81de8516bd3d64b73)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "verticalVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualMirror]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualMirror]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualMirror]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__59c48e86270556c2ab7952ed57dd862319251ba84f019218ae3c671a80ce5e4d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualMonoHue",
    jsii_struct_bases=[],
    name_mapping={"hue": "hue", "hue_var": "hueVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualMonoHue:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2cceae01d61bafc2d48870ebe753773f4b8ecd47ea0c6f0649a87fb17c93b1eb)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualMonoHue(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualMonoHueList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualMonoHueList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__64838bb323eb924a40f7fd2fb211017937a7438140ca409c2b9728b8e40e235d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualMonoHueOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a1aec2be37009568722a8b2cc5568e7a7e405e7f27a9e55d160e91a973e79c5a)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualMonoHueOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__acc5595241b8eccfd4b6151245f6fc8b8f4522c9f554638ad8c852a2422f8cc5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f4ab8c9174651ce20bf3ac1e00e23d5fb8deac508d9fa0be34d8f08331b7b8b1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5167a71aed0675a6d02be5e4d0849d8d582112c6e0c27309e370f02d2639a0d5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualMonoHue]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualMonoHue]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d36ca48dd0764e280cd9d2cb1d680b9f26e34986caff89bab942789b2e0c37f3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualMonoHueOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualMonoHueOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6db6e1a211b7c54000d4e6724a17e457378fff578bcee8fe2378581db0483414)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__531fb297b6b174390d9d61a171cb34f054a7c8f76cc98d46dc20e110744d05c8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5aeda7b5ab14caee4bd9fb05abf72c81081fb2f5815c745e060283a95f7ef47d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualMonoHue]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualMonoHue]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualMonoHue]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e89a6e02d935613d3bff7ba2c8616757d627b4e3a44c490c60adbb9830243779)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualOpacity",
    jsii_struct_bases=[],
    name_mapping={"opacity": "opacity", "opacity_var": "opacityVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualOpacity:
    def __init__(
        self,
        *,
        opacity: typing.Optional[builtins.str] = None,
        opacity_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param opacity: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param opacity_var: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d0a4fb91459175996970e3c5af1621bbfb72c1902a633327c0182b3c5872efa3)
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument opacity_var", value=opacity_var, expected_type=type_hints["opacity_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if opacity is not None:
            self._values["opacity"] = opacity
        if opacity_var is not None:
            self._values["opacity_var"] = opacity_var

    @builtins.property
    def opacity(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def opacity_var(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        result = self._values.get("opacity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualOpacity(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualOpacityList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualOpacityList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ef426b0dd6269b75afd3f6aefd7e4a464d226673d1ab78694de6d75c92a67cc7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualOpacityOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ec1b50be28b3057086e2e3f0d94a158f105160c84b6ef4249cfc20ab6cc931f)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualOpacityOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__53bd240a28b7a4bb0d9c502a58c88ee616d75546caa6afc68aabafc2b62bd5e0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7858a7208daa179ab84c5d710e3ea5c25c5b81dc1eaec975f791f28e828fc1b9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e07f9d41233d55eb5b233b2247ce78b316a246abc264341f5e73aafbbec948e3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualOpacity]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualOpacity]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__774c2b3ee070b0040d8fcfe461c1efe9a4acad9e017e5351b5b0896e9f245e73)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualOpacityOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualOpacityOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__38d696779f7f165d1d5d2a48cad3470b84fffff274e772f5d12650d6f86eb762)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetOpacityVar")
    def reset_opacity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacityVar", []))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityVarInput")
    def opacity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacity"))

    @opacity.setter
    def opacity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2e3422a981eda5b7ce7a60137c1194fd01a8e26807c91ad73191c0f8e093a119)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacity", value)

    @builtins.property
    @jsii.member(jsii_name="opacityVar")
    def opacity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacityVar"))

    @opacity_var.setter
    def opacity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e0014cd495d0f079da9f2e669290a985b2e8e39995ff578fddba0524ba78e07a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacityVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualOpacity]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualOpacity]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualOpacity]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9683c68cf047903c63b93967d37135eb0a112970e2eefb1cef397dabb165ed4e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__055e1f2a00c150c3be72ecb688826ec664e78b9366ab1d0fc5396b12db1f20b4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putBackgroundColor")
    def put_background_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cc7058e4c60c0ea143af9d287e648016690ba99c96d5e98012a60c7568bb699b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBackgroundColor", [value]))

    @jsii.member(jsii_name="putBlur")
    def put_blur(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualBlur, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__435b383d8639bbc118b38898d3f48c3b78c5167ecc49abad2c3b16af1b6d319b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBlur", [value]))

    @jsii.member(jsii_name="putChromaKey")
    def put_chroma_key(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualChromaKey, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7f6cb848eb45ebb9a0238a35ea621993caade3445d3114e16f61b8999dfccfb2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putChromaKey", [value]))

    @jsii.member(jsii_name="putComposite")
    def put_composite(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualComposite, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c5b50fc9c6b98b55df202007b2c214b7ddf9a6e72f02caa6e4437e644160aada)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putComposite", [value]))

    @jsii.member(jsii_name="putCompound")
    def put_compound(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompound, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b5e8e17feebcc90883814f91f35b1dfde007964d5d053d83d1396cc473f1234c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCompound", [value]))

    @jsii.member(jsii_name="putContrast")
    def put_contrast(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualContrast, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__50a07fb3f31fd0938c56fa8bc9af58c9e0d6a4be0e3b6c8fde960b012cb336ae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putContrast", [value]))

    @jsii.member(jsii_name="putGoop")
    def put_goop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualGoop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e4982941fbfc7ef4320513946715233c1040f3bb2179dc5138862f01e4c995a0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGoop", [value]))

    @jsii.member(jsii_name="putGrayscale")
    def put_grayscale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualGrayscale, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5e579acf15f2c0af002471a7a64db25e6a94a5b9996f83b349d45e17e2c5099c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGrayscale", [value]))

    @jsii.member(jsii_name="putHsl")
    def put_hsl(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualHsl, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__62a826e6179ba48dbc6110c1a29a70980f6840a600d0d8faaa120bbb43bf88e9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsl", [value]))

    @jsii.member(jsii_name="putHsv")
    def put_hsv(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualHsv, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__33c225b39e0b4af8a58fd49cedf81192957f389ed7a17df1ead891862adcc371)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsv", [value]))

    @jsii.member(jsii_name="putIfDimension")
    def put_if_dimension(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimension, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e6b50b577fd03559e45bd599c81011ad2a0eff5408917418ee327f4e831fb7bc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfDimension", [value]))

    @jsii.member(jsii_name="putIfOrientation")
    def put_if_orientation(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__403d3df348c39a2bdeaa8532cc0dfc209202f1799a9b81154c33a1c16fbc012b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfOrientation", [value]))

    @jsii.member(jsii_name="putMaxColors")
    def put_max_colors(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualMaxColors, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c4c4dffd069f8d8bdfc1e9d7f5fd9f64b097f24617d23e4db778011caa102b06)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMaxColors", [value]))

    @jsii.member(jsii_name="putMirror")
    def put_mirror(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualMirror, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b93f0f7fd91b16a00cf0b73e0b25827ec9eeb6201730ede293740ca6afdd6ccc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMirror", [value]))

    @jsii.member(jsii_name="putMonoHue")
    def put_mono_hue(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualMonoHue, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__893095dde3d8466834bd637e76a6a9dfd0f5f17737a954bb8b177cca384fb450)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMonoHue", [value]))

    @jsii.member(jsii_name="putOpacity")
    def put_opacity(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualOpacity, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ad6e85ed189bb728c6de03baeaab2afd638620c7f5cecaa0cb35c41abc7deb9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putOpacity", [value]))

    @jsii.member(jsii_name="putRemoveColor")
    def put_remove_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualRemoveColor", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ab93f6b505e28dd9baa6b9270c6d60a692d9842227248902b0e2e2c20fa536f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRemoveColor", [value]))

    @jsii.member(jsii_name="putUnsharpMask")
    def put_unsharp_mask(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualUnsharpMask", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__db7949c61d2f0447337c67c4f2dbdf1899a55462e7405fe27738d47df4b8fb9c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putUnsharpMask", [value]))

    @jsii.member(jsii_name="resetBackgroundColor")
    def reset_background_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBackgroundColor", []))

    @jsii.member(jsii_name="resetBlur")
    def reset_blur(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBlur", []))

    @jsii.member(jsii_name="resetChromaKey")
    def reset_chroma_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChromaKey", []))

    @jsii.member(jsii_name="resetComposite")
    def reset_composite(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetComposite", []))

    @jsii.member(jsii_name="resetCompound")
    def reset_compound(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCompound", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetGoop")
    def reset_goop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGoop", []))

    @jsii.member(jsii_name="resetGrayscale")
    def reset_grayscale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGrayscale", []))

    @jsii.member(jsii_name="resetHsl")
    def reset_hsl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsl", []))

    @jsii.member(jsii_name="resetHsv")
    def reset_hsv(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsv", []))

    @jsii.member(jsii_name="resetIfDimension")
    def reset_if_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfDimension", []))

    @jsii.member(jsii_name="resetIfOrientation")
    def reset_if_orientation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfOrientation", []))

    @jsii.member(jsii_name="resetMaxColors")
    def reset_max_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxColors", []))

    @jsii.member(jsii_name="resetMirror")
    def reset_mirror(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMirror", []))

    @jsii.member(jsii_name="resetMonoHue")
    def reset_mono_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonoHue", []))

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetRemoveColor")
    def reset_remove_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRemoveColor", []))

    @jsii.member(jsii_name="resetUnsharpMask")
    def reset_unsharp_mask(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUnsharpMask", []))

    @builtins.property
    @jsii.member(jsii_name="backgroundColor")
    def background_color(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualBackgroundColorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualBackgroundColorList, jsii.get(self, "backgroundColor"))

    @builtins.property
    @jsii.member(jsii_name="blur")
    def blur(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualBlurList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualBlurList, jsii.get(self, "blur"))

    @builtins.property
    @jsii.member(jsii_name="chromaKey")
    def chroma_key(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualChromaKeyList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualChromaKeyList, jsii.get(self, "chromaKey"))

    @builtins.property
    @jsii.member(jsii_name="composite")
    def composite(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeList, jsii.get(self, "composite"))

    @builtins.property
    @jsii.member(jsii_name="compound")
    def compound(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundList, jsii.get(self, "compound"))

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualContrastList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualContrastList, jsii.get(self, "contrast"))

    @builtins.property
    @jsii.member(jsii_name="goop")
    def goop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualGoopList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualGoopList, jsii.get(self, "goop"))

    @builtins.property
    @jsii.member(jsii_name="grayscale")
    def grayscale(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualGrayscaleList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualGrayscaleList, jsii.get(self, "grayscale"))

    @builtins.property
    @jsii.member(jsii_name="hsl")
    def hsl(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualHslList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualHslList, jsii.get(self, "hsl"))

    @builtins.property
    @jsii.member(jsii_name="hsv")
    def hsv(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualHsvList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualHsvList, jsii.get(self, "hsv"))

    @builtins.property
    @jsii.member(jsii_name="ifDimension")
    def if_dimension(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionList", jsii.get(self, "ifDimension"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientation")
    def if_orientation(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationList, jsii.get(self, "ifOrientation"))

    @builtins.property
    @jsii.member(jsii_name="maxColors")
    def max_colors(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualMaxColorsList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualMaxColorsList, jsii.get(self, "maxColors"))

    @builtins.property
    @jsii.member(jsii_name="mirror")
    def mirror(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualMirrorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualMirrorList, jsii.get(self, "mirror"))

    @builtins.property
    @jsii.member(jsii_name="monoHue")
    def mono_hue(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualMonoHueList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualMonoHueList, jsii.get(self, "monoHue"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualOpacityList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualOpacityList, jsii.get(self, "opacity"))

    @builtins.property
    @jsii.member(jsii_name="removeColor")
    def remove_color(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualRemoveColorList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualRemoveColorList", jsii.get(self, "removeColor"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMask")
    def unsharp_mask(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualUnsharpMaskList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualUnsharpMaskList", jsii.get(self, "unsharpMask"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColorInput")
    def background_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualBackgroundColor]]], jsii.get(self, "backgroundColorInput"))

    @builtins.property
    @jsii.member(jsii_name="blurInput")
    def blur_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualBlur]]], jsii.get(self, "blurInput"))

    @builtins.property
    @jsii.member(jsii_name="chromaKeyInput")
    def chroma_key_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualChromaKey]]], jsii.get(self, "chromaKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="compositeInput")
    def composite_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualComposite]]], jsii.get(self, "compositeInput"))

    @builtins.property
    @jsii.member(jsii_name="compoundInput")
    def compound_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompound]]], jsii.get(self, "compoundInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualContrast]]], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="goopInput")
    def goop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualGoop]]], jsii.get(self, "goopInput"))

    @builtins.property
    @jsii.member(jsii_name="grayscaleInput")
    def grayscale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualGrayscale]]], jsii.get(self, "grayscaleInput"))

    @builtins.property
    @jsii.member(jsii_name="hslInput")
    def hsl_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualHsl]]], jsii.get(self, "hslInput"))

    @builtins.property
    @jsii.member(jsii_name="hsvInput")
    def hsv_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualHsv]]], jsii.get(self, "hsvInput"))

    @builtins.property
    @jsii.member(jsii_name="ifDimensionInput")
    def if_dimension_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimension]]], jsii.get(self, "ifDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientationInput")
    def if_orientation_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientation]]], jsii.get(self, "ifOrientationInput"))

    @builtins.property
    @jsii.member(jsii_name="maxColorsInput")
    def max_colors_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualMaxColors]]], jsii.get(self, "maxColorsInput"))

    @builtins.property
    @jsii.member(jsii_name="mirrorInput")
    def mirror_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualMirror]]], jsii.get(self, "mirrorInput"))

    @builtins.property
    @jsii.member(jsii_name="monoHueInput")
    def mono_hue_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualMonoHue]]], jsii.get(self, "monoHueInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualOpacity]]], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="removeColorInput")
    def remove_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualRemoveColor"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualRemoveColor"]]], jsii.get(self, "removeColorInput"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMaskInput")
    def unsharp_mask_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualUnsharpMask"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualUnsharpMask"]]], jsii.get(self, "unsharpMaskInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqual], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqual],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__768d99a09ef08cd9241fea3b90b6e95fd649b895e7a55354cae3d9777e8b5448)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualRemoveColor",
    jsii_struct_bases=[],
    name_mapping={
        "color": "color",
        "color_var": "colorVar",
        "feather": "feather",
        "feather_var": "featherVar",
        "tolerance": "tolerance",
        "tolerance_var": "toleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualRemoveColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
        feather: typing.Optional[builtins.str] = None,
        feather_var: typing.Optional[builtins.str] = None,
        tolerance: typing.Optional[builtins.str] = None,
        tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        :param feather: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        :param feather_var: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        :param tolerance: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        :param tolerance_var: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7353a628d685b1aa4afc81bb26030fd231ec041cb5b124e2fc548b8b0e83059c)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
            check_type(argname="argument feather", value=feather, expected_type=type_hints["feather"])
            check_type(argname="argument feather_var", value=feather_var, expected_type=type_hints["feather_var"])
            check_type(argname="argument tolerance", value=tolerance, expected_type=type_hints["tolerance"])
            check_type(argname="argument tolerance_var", value=tolerance_var, expected_type=type_hints["tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var
        if feather is not None:
            self._values["feather"] = feather
        if feather_var is not None:
            self._values["feather_var"] = feather_var
        if tolerance is not None:
            self._values["tolerance"] = tolerance
        if tolerance_var is not None:
            self._values["tolerance_var"] = tolerance_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        '''
        result = self._values.get("feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather_var(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        '''
        result = self._values.get("feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        '''
        result = self._values.get("tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance_var(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        result = self._values.get("tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualRemoveColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualRemoveColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualRemoveColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__00c9811adb4810885f11d7794534cd15bfdace349a581842df473b11c79e7a35)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualRemoveColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d9bef3564d89f7ec593739c379c4cca3873f55d9666fc19f49f8cf1537731e69)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualRemoveColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e8e4f5c3268c4fb96de57816b6b93a91b69cfe79cf21f940d81dd580e5629a31)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9b94b7dab8a93fb6fef38de06aa96641aac264a9e4e93ee74c429f6de643d8c0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e2624b7186cbfe2ff15b8af405a6801d2a46f580f51c510bc9479a2724094656)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualRemoveColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualRemoveColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualRemoveColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5bedfa7a4719f9aa7c4a6e296c4bddb427d5f9ae11b4dfdcb5e3139b8e50078a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualRemoveColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualRemoveColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9552639bbe4d1f9497b9947bbbe808220a558a741c2e3738392adbc275f4030f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @jsii.member(jsii_name="resetFeather")
    def reset_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeather", []))

    @jsii.member(jsii_name="resetFeatherVar")
    def reset_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatherVar", []))

    @jsii.member(jsii_name="resetTolerance")
    def reset_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTolerance", []))

    @jsii.member(jsii_name="resetToleranceVar")
    def reset_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featherInput")
    def feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherInput"))

    @builtins.property
    @jsii.member(jsii_name="featherVarInput")
    def feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceInput")
    def tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceVarInput")
    def tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dce9bf77584d427b2bfde2b0a81683908290557dc04cdd6ee15c84485e26f89f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6956e2e3fa2215284c461f6a2bcaeae4e9d8859b43358788218e2306046a0e7a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="feather")
    def feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "feather"))

    @feather.setter
    def feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5aa4cec0bb4b7582ef6d6c11f310eb15077fe83c7a482307f8cb57c91710eb52)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "feather", value)

    @builtins.property
    @jsii.member(jsii_name="featherVar")
    def feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featherVar"))

    @feather_var.setter
    def feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e1080429e8e5f5bc647b874179cb9eed9962a8ca35e9bdc3a3b980d6423f901e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featherVar", value)

    @builtins.property
    @jsii.member(jsii_name="tolerance")
    def tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tolerance"))

    @tolerance.setter
    def tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__00c7f2aeb3492b34b55bcd987cddb23a4e68182009fade30abb40b19441ec4ec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tolerance", value)

    @builtins.property
    @jsii.member(jsii_name="toleranceVar")
    def tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "toleranceVar"))

    @tolerance_var.setter
    def tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__13245bd3c5abc0562273d2833b36916e24c669c2cb23571a57c862d9c654d941)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "toleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualRemoveColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualRemoveColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualRemoveColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__da2463fde96e9603eb048d6be853be9bc32c496642ecf3b8b18874f826538fe2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualUnsharpMask",
    jsii_struct_bases=[],
    name_mapping={
        "gain": "gain",
        "gain_var": "gainVar",
        "sigma": "sigma",
        "sigma_var": "sigmaVar",
        "threshold": "threshold",
        "threshold_var": "thresholdVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualUnsharpMask:
    def __init__(
        self,
        *,
        gain: typing.Optional[builtins.str] = None,
        gain_var: typing.Optional[builtins.str] = None,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
        threshold: typing.Optional[builtins.str] = None,
        threshold_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param gain: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        :param gain_var: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        :param sigma: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        :param threshold: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        :param threshold_var: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__36dcf03fff65449c1abfe6d71d8aecaaab480668f6abe55bc9e71ac77e8ea8a2)
            check_type(argname="argument gain", value=gain, expected_type=type_hints["gain"])
            check_type(argname="argument gain_var", value=gain_var, expected_type=type_hints["gain_var"])
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
            check_type(argname="argument threshold", value=threshold, expected_type=type_hints["threshold"])
            check_type(argname="argument threshold_var", value=threshold_var, expected_type=type_hints["threshold_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if gain is not None:
            self._values["gain"] = gain
        if gain_var is not None:
            self._values["gain_var"] = gain_var
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var
        if threshold is not None:
            self._values["threshold"] = threshold
        if threshold_var is not None:
            self._values["threshold_var"] = threshold_var

    @builtins.property
    def gain(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        '''
        result = self._values.get("gain")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gain_var(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        '''
        result = self._values.get("gain_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        '''
        result = self._values.get("threshold")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold_var(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        result = self._values.get("threshold_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualUnsharpMask(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualUnsharpMaskList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualUnsharpMaskList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9eb29a289acb87d012689abbf5be51571920f5f53b35156250a2506bd9af1656)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualUnsharpMaskOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__290f07fdebd10c63550aa0ff79ecb7da0d9f67e24c8a6430304b2159cfd0ae68)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualUnsharpMaskOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__255194de63620dc13182c50685fd59b785c5ac2801dd6bb26b22322d2a9b4f97)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__97df1eb5a813003a533e2287ebacab7a3bca219a67e294853badebf1b98ac59b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__29c38e438437ef347ffac6be2bf5dce603fce320a537e2049ec938a399d9bc1f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualUnsharpMask]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualUnsharpMask]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualUnsharpMask]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e8f31a9b161fa3ab9c12eb581dfdcbc9565ef88184c6eb20e696d983cd311fcd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualUnsharpMaskOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualUnsharpMaskOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__06548171515acb868b12a87f6ab6b5699914af2343dbca4bcdeff5dd8cefde85)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetGain")
    def reset_gain(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGain", []))

    @jsii.member(jsii_name="resetGainVar")
    def reset_gain_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGainVar", []))

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @jsii.member(jsii_name="resetThreshold")
    def reset_threshold(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThreshold", []))

    @jsii.member(jsii_name="resetThresholdVar")
    def reset_threshold_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThresholdVar", []))

    @builtins.property
    @jsii.member(jsii_name="gainInput")
    def gain_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainInput"))

    @builtins.property
    @jsii.member(jsii_name="gainVarInput")
    def gain_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdInput")
    def threshold_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdVarInput")
    def threshold_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gain")
    def gain(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gain"))

    @gain.setter
    def gain(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ead07dc035a91174e5dfd1ecbf38c0b753a0e6e3da4074401e82f8fbe7b6129)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gain", value)

    @builtins.property
    @jsii.member(jsii_name="gainVar")
    def gain_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gainVar"))

    @gain_var.setter
    def gain_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__67a280bdfb3ec60822250143fb51606454b9308e8bd7f0fb547eef83b1352cdc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gainVar", value)

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f39abbe28d5ab8e32ab666509db4e6b85554bb6d8bab5aa1eb7a4137b67530a2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4508074abd876c806da7a677df6ce45c2baabba268fd944a9c83ee818f4a441f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="threshold")
    def threshold(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "threshold"))

    @threshold.setter
    def threshold(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0c7a52622c3020862e96884f5acf8a024a5a8417f2babe9f34ae74974bfcf8e0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "threshold", value)

    @builtins.property
    @jsii.member(jsii_name="thresholdVar")
    def threshold_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "thresholdVar"))

    @threshold_var.setter
    def threshold_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5fa8b1ea76e2bf0deac7f376c1a1c62837ed22a7bf8de8f9896ec1421133169d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "thresholdVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualUnsharpMask]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualUnsharpMask]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualUnsharpMask]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__84a7a885cea9b010ce1f9c16ed8713bcf56161f85bb104b66833a4dc24adabb9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThan",
    jsii_struct_bases=[],
    name_mapping={
        "background_color": "backgroundColor",
        "blur": "blur",
        "chroma_key": "chromaKey",
        "composite": "composite",
        "compound": "compound",
        "contrast": "contrast",
        "goop": "goop",
        "grayscale": "grayscale",
        "hsl": "hsl",
        "hsv": "hsv",
        "if_dimension": "ifDimension",
        "if_orientation": "ifOrientation",
        "max_colors": "maxColors",
        "mirror": "mirror",
        "mono_hue": "monoHue",
        "opacity": "opacity",
        "remove_color": "removeColor",
        "unsharp_mask": "unsharpMask",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThan:
    def __init__(
        self,
        *,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanBackgroundColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanBlur", typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanChromaKey", typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanComposite", typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompound", typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanContrast", typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanGoop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanGrayscale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanHsl", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanHsv", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientation", typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanMaxColors", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanMirror", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanMonoHue", typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanOpacity", typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanRemoveColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanUnsharpMask", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__669732a7f9e7879671afbf9a4402e3d496ce82b4fda02befa6b337167fb22538)
            check_type(argname="argument background_color", value=background_color, expected_type=type_hints["background_color"])
            check_type(argname="argument blur", value=blur, expected_type=type_hints["blur"])
            check_type(argname="argument chroma_key", value=chroma_key, expected_type=type_hints["chroma_key"])
            check_type(argname="argument composite", value=composite, expected_type=type_hints["composite"])
            check_type(argname="argument compound", value=compound, expected_type=type_hints["compound"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument goop", value=goop, expected_type=type_hints["goop"])
            check_type(argname="argument grayscale", value=grayscale, expected_type=type_hints["grayscale"])
            check_type(argname="argument hsl", value=hsl, expected_type=type_hints["hsl"])
            check_type(argname="argument hsv", value=hsv, expected_type=type_hints["hsv"])
            check_type(argname="argument if_dimension", value=if_dimension, expected_type=type_hints["if_dimension"])
            check_type(argname="argument if_orientation", value=if_orientation, expected_type=type_hints["if_orientation"])
            check_type(argname="argument max_colors", value=max_colors, expected_type=type_hints["max_colors"])
            check_type(argname="argument mirror", value=mirror, expected_type=type_hints["mirror"])
            check_type(argname="argument mono_hue", value=mono_hue, expected_type=type_hints["mono_hue"])
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument remove_color", value=remove_color, expected_type=type_hints["remove_color"])
            check_type(argname="argument unsharp_mask", value=unsharp_mask, expected_type=type_hints["unsharp_mask"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if background_color is not None:
            self._values["background_color"] = background_color
        if blur is not None:
            self._values["blur"] = blur
        if chroma_key is not None:
            self._values["chroma_key"] = chroma_key
        if composite is not None:
            self._values["composite"] = composite
        if compound is not None:
            self._values["compound"] = compound
        if contrast is not None:
            self._values["contrast"] = contrast
        if goop is not None:
            self._values["goop"] = goop
        if grayscale is not None:
            self._values["grayscale"] = grayscale
        if hsl is not None:
            self._values["hsl"] = hsl
        if hsv is not None:
            self._values["hsv"] = hsv
        if if_dimension is not None:
            self._values["if_dimension"] = if_dimension
        if if_orientation is not None:
            self._values["if_orientation"] = if_orientation
        if max_colors is not None:
            self._values["max_colors"] = max_colors
        if mirror is not None:
            self._values["mirror"] = mirror
        if mono_hue is not None:
            self._values["mono_hue"] = mono_hue
        if opacity is not None:
            self._values["opacity"] = opacity
        if remove_color is not None:
            self._values["remove_color"] = remove_color
        if unsharp_mask is not None:
            self._values["unsharp_mask"] = unsharp_mask

    @builtins.property
    def background_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanBackgroundColor"]]]:
        '''background_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        '''
        result = self._values.get("background_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanBackgroundColor"]]], result)

    @builtins.property
    def blur(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanBlur"]]]:
        '''blur block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        '''
        result = self._values.get("blur")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanBlur"]]], result)

    @builtins.property
    def chroma_key(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanChromaKey"]]]:
        '''chroma_key block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        '''
        result = self._values.get("chroma_key")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanChromaKey"]]], result)

    @builtins.property
    def composite(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanComposite"]]]:
        '''composite block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        '''
        result = self._values.get("composite")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanComposite"]]], result)

    @builtins.property
    def compound(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompound"]]]:
        '''compound block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        '''
        result = self._values.get("compound")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompound"]]], result)

    @builtins.property
    def contrast(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanContrast"]]]:
        '''contrast block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanContrast"]]], result)

    @builtins.property
    def goop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanGoop"]]]:
        '''goop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        '''
        result = self._values.get("goop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanGoop"]]], result)

    @builtins.property
    def grayscale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanGrayscale"]]]:
        '''grayscale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        '''
        result = self._values.get("grayscale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanGrayscale"]]], result)

    @builtins.property
    def hsl(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanHsl"]]]:
        '''hsl block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        '''
        result = self._values.get("hsl")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanHsl"]]], result)

    @builtins.property
    def hsv(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanHsv"]]]:
        '''hsv block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        '''
        result = self._values.get("hsv")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanHsv"]]], result)

    @builtins.property
    def if_dimension(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimension]]]:
        '''if_dimension block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        '''
        result = self._values.get("if_dimension")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimension]]], result)

    @builtins.property
    def if_orientation(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientation"]]]:
        '''if_orientation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        '''
        result = self._values.get("if_orientation")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientation"]]], result)

    @builtins.property
    def max_colors(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanMaxColors"]]]:
        '''max_colors block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        '''
        result = self._values.get("max_colors")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanMaxColors"]]], result)

    @builtins.property
    def mirror(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanMirror"]]]:
        '''mirror block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        '''
        result = self._values.get("mirror")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanMirror"]]], result)

    @builtins.property
    def mono_hue(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanMonoHue"]]]:
        '''mono_hue block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        '''
        result = self._values.get("mono_hue")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanMonoHue"]]], result)

    @builtins.property
    def opacity(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanOpacity"]]]:
        '''opacity block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanOpacity"]]], result)

    @builtins.property
    def remove_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanRemoveColor"]]]:
        '''remove_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        '''
        result = self._values.get("remove_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanRemoveColor"]]], result)

    @builtins.property
    def unsharp_mask(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanUnsharpMask"]]]:
        '''unsharp_mask block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        result = self._values.get("unsharp_mask")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanUnsharpMask"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanBackgroundColor",
    jsii_struct_bases=[],
    name_mapping={"color": "color", "color_var": "colorVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanBackgroundColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__61446f0736f7a286fda268f7b8a31a433ce8edbb52e3db6e9621a65f5c7d0814)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanBackgroundColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanBackgroundColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanBackgroundColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a1a762f22100e583752c132b847595b3a897c6f697a26d9b107be0929e7b61cd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanBackgroundColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8fbd0474a9813a4ec7950e572e901aa37a854bcaa9e9c280fee257b5f344c666)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanBackgroundColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e4ed613c1fef10de17a979984a730dcaeac36b2951189b2d9cfe4779a0262c45)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f11d3a18cdef6989b2f7d4b9ee1a1bd87459dba24782df89cb6e7b5bb9bd74ca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a953215e2b66709693de1d0e8a9f35080c26c5aed75aa7db1adf51f12a181df)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanBackgroundColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanBackgroundColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa94abe6914e79615b799391ab1cea6c6ce0b79c37646cf75c386443b9ce5ca1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanBackgroundColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanBackgroundColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7af37f43ac643c041eab9c61b4372af41a78bb3dc53b913cf4efe1f16c8a45de)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ffd75bda0769335260136b972ff89d0bc712736a2f4b842ce83814f3c43c717)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__47235a4b28d206a3f10cccd17284ea448e6a6767eb25cc6e2e62c4b02c19e0d7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanBackgroundColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanBackgroundColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanBackgroundColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__75b9b3d17bd276d93619f0585b4ecbd19ea5592fb9adc0119fcb02da1bd94256)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanBlur",
    jsii_struct_bases=[],
    name_mapping={"sigma": "sigma", "sigma_var": "sigmaVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanBlur:
    def __init__(
        self,
        *,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param sigma: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a75405b9c9eab93c18e774ad7495d9f440868dec1f311ff685f596d0d074e168)
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanBlur(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanBlurList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanBlurList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cb8df54fd118eb2031a5e44311758e23446c2e7aabeb43512ee410d377c6bd56)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanBlurOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__043016bf242698dbd54735377f1e45ab7854c0a58a6dbe3313b606910fc2b2d4)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanBlurOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa288dca59f9e30c2db8d35c41b349f2832a8f444688a94049751913d2f2a586)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6bb99e6fc613127717fdd480c88055ec06d22915c9ac9c13f49debf6f4c9da88)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__89550a80fea88689f2ca9f35c3706bdccba2154b11f86a977bf893597e2d1410)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanBlur]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanBlur]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d2d743a65ceb0732c1474afdd004e9281d7e2ef7776f1f0640f423df4a5e7f05)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanBlurOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanBlurOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b52c39488398abe3171ad18dff8b4b333e0e49c565f9ac6e0446fb0961855243)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d9fecaf5a8a8077a2a752af474f2ad19d674072bd103878b1a38248dc118e701)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__45537f33e3b5fe785740ba6285577d0b2bf0af12af179a359da4ee599e0e7ef4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanBlur]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanBlur]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanBlur]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__13063aa5c94a1e7fc6f02f853d91fc44f9f133028044d6b4e6863a761de53abc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanChromaKey",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_feather": "hueFeather",
        "hue_feather_var": "hueFeatherVar",
        "hue_tolerance": "hueTolerance",
        "hue_tolerance_var": "hueToleranceVar",
        "hue_var": "hueVar",
        "lightness_feather": "lightnessFeather",
        "lightness_feather_var": "lightnessFeatherVar",
        "lightness_tolerance": "lightnessTolerance",
        "lightness_tolerance_var": "lightnessToleranceVar",
        "saturation_feather": "saturationFeather",
        "saturation_feather_var": "saturationFeatherVar",
        "saturation_tolerance": "saturationTolerance",
        "saturation_tolerance_var": "saturationToleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanChromaKey:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_feather: typing.Optional[builtins.str] = None,
        hue_feather_var: typing.Optional[builtins.str] = None,
        hue_tolerance: typing.Optional[builtins.str] = None,
        hue_tolerance_var: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness_feather: typing.Optional[builtins.str] = None,
        lightness_feather_var: typing.Optional[builtins.str] = None,
        lightness_tolerance: typing.Optional[builtins.str] = None,
        lightness_tolerance_var: typing.Optional[builtins.str] = None,
        saturation_feather: typing.Optional[builtins.str] = None,
        saturation_feather_var: typing.Optional[builtins.str] = None,
        saturation_tolerance: typing.Optional[builtins.str] = None,
        saturation_tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_feather: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        :param hue_feather_var: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        :param hue_tolerance: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        :param hue_tolerance_var: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        :param hue_var: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness_feather: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        :param lightness_feather_var: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        :param lightness_tolerance: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        :param lightness_tolerance_var: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        :param saturation_feather: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        :param saturation_feather_var: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        :param saturation_tolerance: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        :param saturation_tolerance_var: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d50ea82d53c1624068c954c2649b9d20df0b4811c03c7dc4d9f67baeb73a36e1)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_feather", value=hue_feather, expected_type=type_hints["hue_feather"])
            check_type(argname="argument hue_feather_var", value=hue_feather_var, expected_type=type_hints["hue_feather_var"])
            check_type(argname="argument hue_tolerance", value=hue_tolerance, expected_type=type_hints["hue_tolerance"])
            check_type(argname="argument hue_tolerance_var", value=hue_tolerance_var, expected_type=type_hints["hue_tolerance_var"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness_feather", value=lightness_feather, expected_type=type_hints["lightness_feather"])
            check_type(argname="argument lightness_feather_var", value=lightness_feather_var, expected_type=type_hints["lightness_feather_var"])
            check_type(argname="argument lightness_tolerance", value=lightness_tolerance, expected_type=type_hints["lightness_tolerance"])
            check_type(argname="argument lightness_tolerance_var", value=lightness_tolerance_var, expected_type=type_hints["lightness_tolerance_var"])
            check_type(argname="argument saturation_feather", value=saturation_feather, expected_type=type_hints["saturation_feather"])
            check_type(argname="argument saturation_feather_var", value=saturation_feather_var, expected_type=type_hints["saturation_feather_var"])
            check_type(argname="argument saturation_tolerance", value=saturation_tolerance, expected_type=type_hints["saturation_tolerance"])
            check_type(argname="argument saturation_tolerance_var", value=saturation_tolerance_var, expected_type=type_hints["saturation_tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_feather is not None:
            self._values["hue_feather"] = hue_feather
        if hue_feather_var is not None:
            self._values["hue_feather_var"] = hue_feather_var
        if hue_tolerance is not None:
            self._values["hue_tolerance"] = hue_tolerance
        if hue_tolerance_var is not None:
            self._values["hue_tolerance_var"] = hue_tolerance_var
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness_feather is not None:
            self._values["lightness_feather"] = lightness_feather
        if lightness_feather_var is not None:
            self._values["lightness_feather_var"] = lightness_feather_var
        if lightness_tolerance is not None:
            self._values["lightness_tolerance"] = lightness_tolerance
        if lightness_tolerance_var is not None:
            self._values["lightness_tolerance_var"] = lightness_tolerance_var
        if saturation_feather is not None:
            self._values["saturation_feather"] = saturation_feather
        if saturation_feather_var is not None:
            self._values["saturation_feather_var"] = saturation_feather_var
        if saturation_tolerance is not None:
            self._values["saturation_tolerance"] = saturation_tolerance
        if saturation_tolerance_var is not None:
            self._values["saturation_tolerance_var"] = saturation_tolerance_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        '''
        result = self._values.get("hue_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        '''
        result = self._values.get("hue_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        '''
        result = self._values.get("hue_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        '''
        result = self._values.get("hue_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        '''
        result = self._values.get("lightness_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        '''
        result = self._values.get("lightness_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        '''
        result = self._values.get("lightness_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        '''
        result = self._values.get("lightness_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        '''
        result = self._values.get("saturation_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        '''
        result = self._values.get("saturation_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        '''
        result = self._values.get("saturation_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        result = self._values.get("saturation_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanChromaKey(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanChromaKeyList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanChromaKeyList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5a57b1a61f2590fbfce26629f52c87018f43abeb8a78d3e203db53f7e795ab25)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanChromaKeyOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__96d514efa8b89c1e949b322cb3e8f080387bfb909a8ede662b619a035189197f)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanChromaKeyOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9c813d88538dff5de5b3205127c4bf469a3b4e1b11227c73e1e44ed814de4c9d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7b3039beb24629910649f47c87d12c53c7d99e031e2ea7a60810ff19b69c8077)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0e56b80b60b6b1c9b1b70255dfc17a66b14381307dd9eb439b9962f3d85ea533)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanChromaKey]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanChromaKey]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__098d73e39a5d76128d56a591170b72cb184fe93f64e8f59ccdc7cfe7e5da019f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanChromaKeyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanChromaKeyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a8c3e27b97b9f9dc1d70b1f85de374f54325e2eda7be8e28741d4d1c73907ab)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueFeather")
    def reset_hue_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeather", []))

    @jsii.member(jsii_name="resetHueFeatherVar")
    def reset_hue_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeatherVar", []))

    @jsii.member(jsii_name="resetHueTolerance")
    def reset_hue_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueTolerance", []))

    @jsii.member(jsii_name="resetHueToleranceVar")
    def reset_hue_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueToleranceVar", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightnessFeather")
    def reset_lightness_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeather", []))

    @jsii.member(jsii_name="resetLightnessFeatherVar")
    def reset_lightness_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeatherVar", []))

    @jsii.member(jsii_name="resetLightnessTolerance")
    def reset_lightness_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessTolerance", []))

    @jsii.member(jsii_name="resetLightnessToleranceVar")
    def reset_lightness_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessToleranceVar", []))

    @jsii.member(jsii_name="resetSaturationFeather")
    def reset_saturation_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeather", []))

    @jsii.member(jsii_name="resetSaturationFeatherVar")
    def reset_saturation_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeatherVar", []))

    @jsii.member(jsii_name="resetSaturationTolerance")
    def reset_saturation_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationTolerance", []))

    @jsii.member(jsii_name="resetSaturationToleranceVar")
    def reset_saturation_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherInput")
    def hue_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVarInput")
    def hue_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceInput")
    def hue_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVarInput")
    def hue_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherInput")
    def lightness_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVarInput")
    def lightness_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceInput")
    def lightness_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVarInput")
    def lightness_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherInput")
    def saturation_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVarInput")
    def saturation_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceInput")
    def saturation_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVarInput")
    def saturation_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__22979850efa4c136c9154d26d95e83d828bb3b5b70b13445dddeb39e32dd7eaa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeather")
    def hue_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeather"))

    @hue_feather.setter
    def hue_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dc9995378454f605a1430da62eb95aded265a11407fc809afea51dec2c16e0c2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeather", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVar")
    def hue_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeatherVar"))

    @hue_feather_var.setter
    def hue_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a6cf425594f7fa22f02501cdee291802d4025cc4c58245c172a8749f027097c4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueTolerance")
    def hue_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueTolerance"))

    @hue_tolerance.setter
    def hue_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__23988f3fefba02e9fe8ea2757d6d5747bcebf76aa18a74909bdc358864f3d3cb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVar")
    def hue_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueToleranceVar"))

    @hue_tolerance_var.setter
    def hue_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3e660c5f75931b9ebc934e83355aa0143cafd41001cc538238a9bd34682753e2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2c1bde6981ee07e8889e2e597b37370639bdb4ab16d97157553202b92b252202)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeather")
    def lightness_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeather"))

    @lightness_feather.setter
    def lightness_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__31b0426b6fc16ec7b6d099db146fc1a920df06aa7e50370fc6d017edc6ecf372)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeather", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVar")
    def lightness_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeatherVar"))

    @lightness_feather_var.setter
    def lightness_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d3e7c05d6d4b64386f28c809d3d26034bfe11c31dca18e2bb9ecc221d0a9b32c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessTolerance")
    def lightness_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessTolerance"))

    @lightness_tolerance.setter
    def lightness_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__849ca8db1b92a4b886996f68f3303fd1aa460ffdfc23e62bdd138b9c54be9c79)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVar")
    def lightness_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessToleranceVar"))

    @lightness_tolerance_var.setter
    def lightness_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d51252d02eb7635f303fa9a5113b41375cd7a5dd8b7d9a0aca6c2be8a1a0a71f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeather")
    def saturation_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeather"))

    @saturation_feather.setter
    def saturation_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4796a572be02d14143a2f2dfdc9113e0d5bd8b16849f4e1454bddf30fc6f9e1d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeather", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVar")
    def saturation_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeatherVar"))

    @saturation_feather_var.setter
    def saturation_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4612c5545923f0c062c461425324503cb367ba24f1983a0befdccb8afcfbbee2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationTolerance")
    def saturation_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationTolerance"))

    @saturation_tolerance.setter
    def saturation_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__84b1dce74e6b14e307683653d908f0f84637db22e09aed49dc846b0d4313fdff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVar")
    def saturation_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationToleranceVar"))

    @saturation_tolerance_var.setter
    def saturation_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__20a9c7965910e7fd2455b58444656d82c492de8ffd3fbf9c04327470d06ecf3a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanChromaKey]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanChromaKey]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanChromaKey]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f577a178f77ea044c24dc7f3280845648fd23049ae48e337d6eb1c655cba6965)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanComposite",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "placement": "placement",
        "placement_var": "placementVar",
        "scale": "scale",
        "scale_dimension": "scaleDimension",
        "scale_dimension_var": "scaleDimensionVar",
        "scale_var": "scaleVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanComposite:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        placement: typing.Optional[builtins.str] = None,
        placement_var: typing.Optional[builtins.str] = None,
        scale: typing.Optional[builtins.str] = None,
        scale_dimension: typing.Optional[builtins.str] = None,
        scale_dimension_var: typing.Optional[builtins.str] = None,
        scale_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param placement: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        :param placement_var: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        :param scale: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param scale_dimension: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        :param scale_dimension_var: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        :param scale_var: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        :param x_position: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7ff450bc758df184cd2d887e9e307feb0f148a12d9b1fa6e77ddbd57960b13f1)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument placement", value=placement, expected_type=type_hints["placement"])
            check_type(argname="argument placement_var", value=placement_var, expected_type=type_hints["placement_var"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument scale_dimension", value=scale_dimension, expected_type=type_hints["scale_dimension"])
            check_type(argname="argument scale_dimension_var", value=scale_dimension_var, expected_type=type_hints["scale_dimension_var"])
            check_type(argname="argument scale_var", value=scale_var, expected_type=type_hints["scale_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if placement is not None:
            self._values["placement"] = placement
        if placement_var is not None:
            self._values["placement_var"] = placement_var
        if scale is not None:
            self._values["scale"] = scale
        if scale_dimension is not None:
            self._values["scale_dimension"] = scale_dimension
        if scale_dimension_var is not None:
            self._values["scale_dimension_var"] = scale_dimension_var
        if scale_var is not None:
            self._values["scale_var"] = scale_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        '''
        result = self._values.get("placement")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement_var(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        '''
        result = self._values.get("placement_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        '''
        result = self._values.get("scale_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        '''
        result = self._values.get("scale_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        '''
        result = self._values.get("scale_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanComposite(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImage",
    jsii_struct_bases=[],
    name_mapping={
        "box_image": "boxImage",
        "circle_image": "circleImage",
        "text_image": "textImage",
        "url_image": "urlImage",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImage:
    def __init__(
        self,
        *,
        box_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageBoxImage", typing.Dict[builtins.str, typing.Any]]]]] = None,
        circle_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageCircleImage", typing.Dict[builtins.str, typing.Any]]]]] = None,
        text_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageTextImage", typing.Dict[builtins.str, typing.Any]]]]] = None,
        url_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageUrlImage", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param box_image: box_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#box_image DataAkamaiImagingPolicyImage#box_image}
        :param circle_image: circle_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#circle_image DataAkamaiImagingPolicyImage#circle_image}
        :param text_image: text_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text_image DataAkamaiImagingPolicyImage#text_image}
        :param url_image: url_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url_image DataAkamaiImagingPolicyImage#url_image}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f277d78f058e2b94256c71388c83de6d4dc4e7e068656cb2f561a79c10af0c9e)
            check_type(argname="argument box_image", value=box_image, expected_type=type_hints["box_image"])
            check_type(argname="argument circle_image", value=circle_image, expected_type=type_hints["circle_image"])
            check_type(argname="argument text_image", value=text_image, expected_type=type_hints["text_image"])
            check_type(argname="argument url_image", value=url_image, expected_type=type_hints["url_image"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if box_image is not None:
            self._values["box_image"] = box_image
        if circle_image is not None:
            self._values["circle_image"] = circle_image
        if text_image is not None:
            self._values["text_image"] = text_image
        if url_image is not None:
            self._values["url_image"] = url_image

    @builtins.property
    def box_image(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageBoxImage"]]]:
        '''box_image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#box_image DataAkamaiImagingPolicyImage#box_image}
        '''
        result = self._values.get("box_image")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageBoxImage"]]], result)

    @builtins.property
    def circle_image(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageCircleImage"]]]:
        '''circle_image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#circle_image DataAkamaiImagingPolicyImage#circle_image}
        '''
        result = self._values.get("circle_image")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageCircleImage"]]], result)

    @builtins.property
    def text_image(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageTextImage"]]]:
        '''text_image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text_image DataAkamaiImagingPolicyImage#text_image}
        '''
        result = self._values.get("text_image")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageTextImage"]]], result)

    @builtins.property
    def url_image(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageUrlImage"]]]:
        '''url_image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url_image DataAkamaiImagingPolicyImage#url_image}
        '''
        result = self._values.get("url_image")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageUrlImage"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageBoxImage",
    jsii_struct_bases=[],
    name_mapping={
        "color": "color",
        "color_var": "colorVar",
        "height": "height",
        "height_var": "heightVar",
        "transformation": "transformation",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageBoxImage:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        transformation: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageBoxImageTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The fill color of the box, not the edge of the box. The API supports hexadecimal representation and CSS hexadecimal color values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The fill color of the box, not the edge of the box. The API supports hexadecimal representation and CSS hexadecimal color values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        :param height: The height of the box in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height of the box in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param transformation: transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        :param width: The width of the box in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width of the box in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(transformation, dict):
            transformation = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageBoxImageTransformation(**transformation)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__95c5363055e3d335ce5d3ce2300ba54e0a8101da9be0151ef45d0853954cb999)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument transformation", value=transformation, expected_type=type_hints["transformation"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if transformation is not None:
            self._values["transformation"] = transformation
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The fill color of the box, not the edge of the box.

        The API supports hexadecimal representation and CSS hexadecimal color values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The fill color of the box, not the edge of the box.

        The API supports hexadecimal representation and CSS hexadecimal color values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height of the box in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height of the box in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def transformation(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageBoxImageTransformation"]:
        '''transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        '''
        result = self._values.get("transformation")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageBoxImageTransformation"], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width of the box in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width of the box in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageBoxImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageBoxImageList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageBoxImageList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1968207cb88a202a2ef63a1a72f02655728a21e006f5214dcc102520869365ee)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageBoxImageOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1a12b1050e357cec75dc376bdcc6fa76b3bb819555b51326dc27bfd8f42d32da)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageBoxImageOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1da5aac1dee0537e4c0cf706a7b1966a65737b2a210f84fe8f34acfcbd0d934f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__de54e576f4f46a68d4d321f3c92a1800b390586ce40b7eaf2accb45969fe31d3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8cc043cac27f744e0582027f47efa087eb844157a277c3c3af21c672e9c9fc47)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageBoxImage]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageBoxImage]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageBoxImage]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3db3e53ee07954f4e8c58c1396e7e4112e04eda0e9005d5d540d9efd87e418b4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageBoxImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageBoxImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a2c9ee18f6d43e43552a4b7b472705239a3c51af9eae95a01476e4f4725fd772)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformation")
    def put_transformation(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageBoxImageTransformation()

        return typing.cast(None, jsii.invoke(self, "putTransformation", [value]))

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetTransformation")
    def reset_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformation", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="transformation")
    def transformation(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageBoxImageTransformationOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageBoxImageTransformationOutputReference", jsii.get(self, "transformation"))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="transformationInput")
    def transformation_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageBoxImageTransformation"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageBoxImageTransformation"], jsii.get(self, "transformationInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f227c65343f6ea43a9ad77f6b5690831a86b5b823ac8f25dc5539f0b672bfe27)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a50f6b03871a76e972a76dd7188d111674c2c43c61b9b9723facb5338391096d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bfa25f326b0ae16a163eb6e47b4a095bd80d5f4982dd400ed34a64e07b3d1464)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__47e7d774cca53142964467506389123bc1366fddb447bf810fea1019fda30e20)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1eec6ae46ab2c0cab295e628abe383727f71721aa37438c496d34fc07166721f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__248bbda0d7cc147a9921565ae80d75d1b78fbb7052f96dd5bdc8fdbdb7880772)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageBoxImage]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageBoxImage]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageBoxImage]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d97221fcb53148adead3d85e5f48f02aa47dcde6b1a6839ab09ca8a275193b41)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageBoxImageTransformation",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageBoxImageTransformation:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageBoxImageTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageBoxImageTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageBoxImageTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__240e0e8b79c4f278e36ec3a8ba35c5c4ee9214697dd2c7a2fd44deeca365707c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageBoxImageTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageBoxImageTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageBoxImageTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__41bd98439facf5a111deb0d2da052b8c400bf1bc4a51eaefdbb77035a058223c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageCircleImage",
    jsii_struct_bases=[],
    name_mapping={
        "color": "color",
        "color_var": "colorVar",
        "diameter": "diameter",
        "diameter_var": "diameterVar",
        "transformation": "transformation",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageCircleImage:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
        diameter: typing.Optional[builtins.str] = None,
        diameter_var: typing.Optional[builtins.str] = None,
        transformation: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageCircleImageTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The fill color of the circle. The API supports hexadecimal representation and CSS hexadecimal color values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The fill color of the circle. The API supports hexadecimal representation and CSS hexadecimal color values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        :param diameter: The diameter of the circle. The diameter will be the width and the height of the image in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#diameter DataAkamaiImagingPolicyImage#diameter}
        :param diameter_var: The diameter of the circle. The diameter will be the width and the height of the image in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#diameter_var DataAkamaiImagingPolicyImage#diameter_var}
        :param transformation: transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        :param width: The width of the box in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width of the box in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(transformation, dict):
            transformation = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageCircleImageTransformation(**transformation)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f996c92d4bd2644e99c64326190282ac287edf5b16796754b71b639662f5fcfa)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
            check_type(argname="argument diameter", value=diameter, expected_type=type_hints["diameter"])
            check_type(argname="argument diameter_var", value=diameter_var, expected_type=type_hints["diameter_var"])
            check_type(argname="argument transformation", value=transformation, expected_type=type_hints["transformation"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var
        if diameter is not None:
            self._values["diameter"] = diameter
        if diameter_var is not None:
            self._values["diameter_var"] = diameter_var
        if transformation is not None:
            self._values["transformation"] = transformation
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The fill color of the circle. The API supports hexadecimal representation and CSS hexadecimal color values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The fill color of the circle. The API supports hexadecimal representation and CSS hexadecimal color values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def diameter(self) -> typing.Optional[builtins.str]:
        '''The diameter of the circle. The diameter will be the width and the height of the image in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#diameter DataAkamaiImagingPolicyImage#diameter}
        '''
        result = self._values.get("diameter")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def diameter_var(self) -> typing.Optional[builtins.str]:
        '''The diameter of the circle. The diameter will be the width and the height of the image in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#diameter_var DataAkamaiImagingPolicyImage#diameter_var}
        '''
        result = self._values.get("diameter_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def transformation(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageCircleImageTransformation"]:
        '''transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        '''
        result = self._values.get("transformation")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageCircleImageTransformation"], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width of the box in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width of the box in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageCircleImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageCircleImageList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageCircleImageList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__34827c599c9b8f60a472a453f8137c353e79f0bbf4922906849c33cb7f29e8d7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageCircleImageOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7a3f5ea94ee616b157b25605e0ff243935295ddaaaa4155550f5c04387ea4087)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageCircleImageOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f92a9b51a715d5bcef4cf7854fb6554cfeaad0cd9d33bae65ff874aaddc73a8f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__38ac9af30f2fd755e48519f95d6990b472544782744b030639d283ebcf7ac745)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e11ab83ee27bd9cef4e8d5bddac686b4c23aa3db76f0be9844fd09f319012752)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageCircleImage]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageCircleImage]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageCircleImage]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__68a537568bcd11ffd5e4ca561b7644ff020b940ed37017e6da82ac36a62083a6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageCircleImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageCircleImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e508ffac0681a85b5e503207783847d73bd5dc3d7d6ebb8f78f6f7988bfc0a12)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformation")
    def put_transformation(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageCircleImageTransformation()

        return typing.cast(None, jsii.invoke(self, "putTransformation", [value]))

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @jsii.member(jsii_name="resetDiameter")
    def reset_diameter(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDiameter", []))

    @jsii.member(jsii_name="resetDiameterVar")
    def reset_diameter_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDiameterVar", []))

    @jsii.member(jsii_name="resetTransformation")
    def reset_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformation", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="transformation")
    def transformation(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageCircleImageTransformationOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageCircleImageTransformationOutputReference", jsii.get(self, "transformation"))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="diameterInput")
    def diameter_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "diameterInput"))

    @builtins.property
    @jsii.member(jsii_name="diameterVarInput")
    def diameter_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "diameterVarInput"))

    @builtins.property
    @jsii.member(jsii_name="transformationInput")
    def transformation_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageCircleImageTransformation"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageCircleImageTransformation"], jsii.get(self, "transformationInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1a2de7b4237f65696e69516ef1839733389211b625220ae1dba1dc02a86e84cd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c0cba032beda8fb0ddc4b93ac97c9083716d77acc984848ac033f7f7d7478e70)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="diameter")
    def diameter(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "diameter"))

    @diameter.setter
    def diameter(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__09e4a027ee65624d3823dcface02765256bb9783baa43d959562f7320d9947aa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "diameter", value)

    @builtins.property
    @jsii.member(jsii_name="diameterVar")
    def diameter_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "diameterVar"))

    @diameter_var.setter
    def diameter_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ce60f72125d29b9a42e9f1b4bc0159398dd03d9dabad41bf9628a897a2b3db2b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "diameterVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9588890a7b25272ece7d1c05f556c871bc966c95bf6c9b20465e01c5cc3ac6f1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b486d9ffcdbfb16241cd590507c8432a07227e4860784e3395db51234ca040af)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageCircleImage]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageCircleImage]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageCircleImage]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fd1b0e3b4ad5d5446da5ebfe5692acdea2faed29ea42f4fa156ce2d089b88ffb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageCircleImageTransformation",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageCircleImageTransformation:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageCircleImageTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageCircleImageTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageCircleImageTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__97031dbcd4be79d8e06b92327f18558fc9e5e2e20b337dcbe5281e0a947bb81a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageCircleImageTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageCircleImageTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageCircleImageTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f7ec34fa559f0a41d858b4444e859cc48aee360aface4b54d21d840aa465eb52)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5d437810c14ba2fba0f07d41bfb00c9208c03958b32a82df2a2d6f27127210d8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putBoxImage")
    def put_box_image(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageBoxImage, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6252bc7bf2f935d211ea4c238c7ad1811c05fc07e2fc100ce8c0bad5316feb83)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBoxImage", [value]))

    @jsii.member(jsii_name="putCircleImage")
    def put_circle_image(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageCircleImage, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0d4012297f660b5c9299c6a9aa0694b3f9b8e1c916ac029cd6b373caa589fc77)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCircleImage", [value]))

    @jsii.member(jsii_name="putTextImage")
    def put_text_image(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageTextImage", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6004c13aa706f5be9b5bad5c8bf72d3aa715e7241b496df8d2f2e28f4706a301)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTextImage", [value]))

    @jsii.member(jsii_name="putUrlImage")
    def put_url_image(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageUrlImage", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0f3a9b3aa0b829b699bfc2bfc44cdf0a286f0ce0312311e9aa4a975f3cce310e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putUrlImage", [value]))

    @jsii.member(jsii_name="resetBoxImage")
    def reset_box_image(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBoxImage", []))

    @jsii.member(jsii_name="resetCircleImage")
    def reset_circle_image(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCircleImage", []))

    @jsii.member(jsii_name="resetTextImage")
    def reset_text_image(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTextImage", []))

    @jsii.member(jsii_name="resetUrlImage")
    def reset_url_image(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUrlImage", []))

    @builtins.property
    @jsii.member(jsii_name="boxImage")
    def box_image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageBoxImageList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageBoxImageList, jsii.get(self, "boxImage"))

    @builtins.property
    @jsii.member(jsii_name="circleImage")
    def circle_image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageCircleImageList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageCircleImageList, jsii.get(self, "circleImage"))

    @builtins.property
    @jsii.member(jsii_name="textImage")
    def text_image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageTextImageList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageTextImageList", jsii.get(self, "textImage"))

    @builtins.property
    @jsii.member(jsii_name="urlImage")
    def url_image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageUrlImageList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageUrlImageList", jsii.get(self, "urlImage"))

    @builtins.property
    @jsii.member(jsii_name="boxImageInput")
    def box_image_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageBoxImage]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageBoxImage]]], jsii.get(self, "boxImageInput"))

    @builtins.property
    @jsii.member(jsii_name="circleImageInput")
    def circle_image_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageCircleImage]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageCircleImage]]], jsii.get(self, "circleImageInput"))

    @builtins.property
    @jsii.member(jsii_name="textImageInput")
    def text_image_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageTextImage"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageTextImage"]]], jsii.get(self, "textImageInput"))

    @builtins.property
    @jsii.member(jsii_name="urlImageInput")
    def url_image_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageUrlImage"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageUrlImage"]]], jsii.get(self, "urlImageInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a1cb3f2a6d0ca8933d9ff80509151e736750107e80fb7ac6e9ddd1ec5a69fbc1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageTextImage",
    jsii_struct_bases=[],
    name_mapping={
        "fill": "fill",
        "fill_var": "fillVar",
        "size": "size",
        "size_var": "sizeVar",
        "stroke": "stroke",
        "stroke_size": "strokeSize",
        "stroke_size_var": "strokeSizeVar",
        "stroke_var": "strokeVar",
        "text": "text",
        "text_var": "textVar",
        "transformation": "transformation",
        "typeface": "typeface",
        "typeface_var": "typefaceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageTextImage:
    def __init__(
        self,
        *,
        fill: typing.Optional[builtins.str] = None,
        fill_var: typing.Optional[builtins.str] = None,
        size: typing.Optional[builtins.str] = None,
        size_var: typing.Optional[builtins.str] = None,
        stroke: typing.Optional[builtins.str] = None,
        stroke_size: typing.Optional[builtins.str] = None,
        stroke_size_var: typing.Optional[builtins.str] = None,
        stroke_var: typing.Optional[builtins.str] = None,
        text: typing.Optional[builtins.str] = None,
        text_var: typing.Optional[builtins.str] = None,
        transformation: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageTextImageTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        typeface: typing.Optional[builtins.str] = None,
        typeface_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fill: The main fill color of the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill DataAkamaiImagingPolicyImage#fill}
        :param fill_var: The main fill color of the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_var DataAkamaiImagingPolicyImage#fill_var}
        :param size: The size in pixels to render the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#size DataAkamaiImagingPolicyImage#size}
        :param size_var: The size in pixels to render the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#size_var DataAkamaiImagingPolicyImage#size_var}
        :param stroke: The color for the outline of the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke DataAkamaiImagingPolicyImage#stroke}
        :param stroke_size: The thickness in points for the outline of the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_size DataAkamaiImagingPolicyImage#stroke_size}
        :param stroke_size_var: The thickness in points for the outline of the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_size_var DataAkamaiImagingPolicyImage#stroke_size_var}
        :param stroke_var: The color for the outline of the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_var DataAkamaiImagingPolicyImage#stroke_var}
        :param text: The line of text to render. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text DataAkamaiImagingPolicyImage#text}
        :param text_var: The line of text to render. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text_var DataAkamaiImagingPolicyImage#text_var}
        :param transformation: transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        :param typeface: The font family to apply to the text image. This may be a URL to a TrueType or WOFF (v1) typeface, or a string that refers to one of the standard built-in browser fonts. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#typeface DataAkamaiImagingPolicyImage#typeface}
        :param typeface_var: The font family to apply to the text image. This may be a URL to a TrueType or WOFF (v1) typeface, or a string that refers to one of the standard built-in browser fonts. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#typeface_var DataAkamaiImagingPolicyImage#typeface_var}
        '''
        if isinstance(transformation, dict):
            transformation = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageTextImageTransformation(**transformation)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d5db8dccbb7f9236a3d4241b938280dda4e11284bfd04d4a3f0487dc3a9e2053)
            check_type(argname="argument fill", value=fill, expected_type=type_hints["fill"])
            check_type(argname="argument fill_var", value=fill_var, expected_type=type_hints["fill_var"])
            check_type(argname="argument size", value=size, expected_type=type_hints["size"])
            check_type(argname="argument size_var", value=size_var, expected_type=type_hints["size_var"])
            check_type(argname="argument stroke", value=stroke, expected_type=type_hints["stroke"])
            check_type(argname="argument stroke_size", value=stroke_size, expected_type=type_hints["stroke_size"])
            check_type(argname="argument stroke_size_var", value=stroke_size_var, expected_type=type_hints["stroke_size_var"])
            check_type(argname="argument stroke_var", value=stroke_var, expected_type=type_hints["stroke_var"])
            check_type(argname="argument text", value=text, expected_type=type_hints["text"])
            check_type(argname="argument text_var", value=text_var, expected_type=type_hints["text_var"])
            check_type(argname="argument transformation", value=transformation, expected_type=type_hints["transformation"])
            check_type(argname="argument typeface", value=typeface, expected_type=type_hints["typeface"])
            check_type(argname="argument typeface_var", value=typeface_var, expected_type=type_hints["typeface_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fill is not None:
            self._values["fill"] = fill
        if fill_var is not None:
            self._values["fill_var"] = fill_var
        if size is not None:
            self._values["size"] = size
        if size_var is not None:
            self._values["size_var"] = size_var
        if stroke is not None:
            self._values["stroke"] = stroke
        if stroke_size is not None:
            self._values["stroke_size"] = stroke_size
        if stroke_size_var is not None:
            self._values["stroke_size_var"] = stroke_size_var
        if stroke_var is not None:
            self._values["stroke_var"] = stroke_var
        if text is not None:
            self._values["text"] = text
        if text_var is not None:
            self._values["text_var"] = text_var
        if transformation is not None:
            self._values["transformation"] = transformation
        if typeface is not None:
            self._values["typeface"] = typeface
        if typeface_var is not None:
            self._values["typeface_var"] = typeface_var

    @builtins.property
    def fill(self) -> typing.Optional[builtins.str]:
        '''The main fill color of the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill DataAkamaiImagingPolicyImage#fill}
        '''
        result = self._values.get("fill")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fill_var(self) -> typing.Optional[builtins.str]:
        '''The main fill color of the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_var DataAkamaiImagingPolicyImage#fill_var}
        '''
        result = self._values.get("fill_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def size(self) -> typing.Optional[builtins.str]:
        '''The size in pixels to render the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#size DataAkamaiImagingPolicyImage#size}
        '''
        result = self._values.get("size")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def size_var(self) -> typing.Optional[builtins.str]:
        '''The size in pixels to render the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#size_var DataAkamaiImagingPolicyImage#size_var}
        '''
        result = self._values.get("size_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def stroke(self) -> typing.Optional[builtins.str]:
        '''The color for the outline of the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke DataAkamaiImagingPolicyImage#stroke}
        '''
        result = self._values.get("stroke")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def stroke_size(self) -> typing.Optional[builtins.str]:
        '''The thickness in points for the outline of the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_size DataAkamaiImagingPolicyImage#stroke_size}
        '''
        result = self._values.get("stroke_size")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def stroke_size_var(self) -> typing.Optional[builtins.str]:
        '''The thickness in points for the outline of the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_size_var DataAkamaiImagingPolicyImage#stroke_size_var}
        '''
        result = self._values.get("stroke_size_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def stroke_var(self) -> typing.Optional[builtins.str]:
        '''The color for the outline of the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_var DataAkamaiImagingPolicyImage#stroke_var}
        '''
        result = self._values.get("stroke_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def text(self) -> typing.Optional[builtins.str]:
        '''The line of text to render.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text DataAkamaiImagingPolicyImage#text}
        '''
        result = self._values.get("text")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def text_var(self) -> typing.Optional[builtins.str]:
        '''The line of text to render.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text_var DataAkamaiImagingPolicyImage#text_var}
        '''
        result = self._values.get("text_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def transformation(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageTextImageTransformation"]:
        '''transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        '''
        result = self._values.get("transformation")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageTextImageTransformation"], result)

    @builtins.property
    def typeface(self) -> typing.Optional[builtins.str]:
        '''The font family to apply to the text image.

        This may be a URL to a TrueType or WOFF (v1) typeface, or a string that refers to one of the standard built-in browser fonts.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#typeface DataAkamaiImagingPolicyImage#typeface}
        '''
        result = self._values.get("typeface")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def typeface_var(self) -> typing.Optional[builtins.str]:
        '''The font family to apply to the text image.

        This may be a URL to a TrueType or WOFF (v1) typeface, or a string that refers to one of the standard built-in browser fonts.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#typeface_var DataAkamaiImagingPolicyImage#typeface_var}
        '''
        result = self._values.get("typeface_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageTextImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageTextImageList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageTextImageList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2e80de910790f4ff188f95f651f89e707f7de756cd833b9002a7321db706400f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageTextImageOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5387ea3c9c945b287c97c891a2d7671a61d36b2e5e0203fafe588d5e8a0d0d88)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageTextImageOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f3b480282bf7b18c94cc6eb760e89f3f2a51840f36f8963c94ba8577acd9e000)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a347aad655426e4707c3d3da14cb91f6fc232d50045748e2745119093db92bb2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__505fd578a87e9e1c621931b1671b1cfe014339a86c3bc59e0ed234d863eb94ed)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageTextImage]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageTextImage]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageTextImage]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d715a1932618a3ac533615b3c890dc3905bea93b9371e9f233cae2ab1054e81b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageTextImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageTextImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__031f17b4bea8c15d9b5845e06c83c86bfb0a62ad90c395460ea8b96b529a20a8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformation")
    def put_transformation(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageTextImageTransformation()

        return typing.cast(None, jsii.invoke(self, "putTransformation", [value]))

    @jsii.member(jsii_name="resetFill")
    def reset_fill(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFill", []))

    @jsii.member(jsii_name="resetFillVar")
    def reset_fill_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFillVar", []))

    @jsii.member(jsii_name="resetSize")
    def reset_size(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSize", []))

    @jsii.member(jsii_name="resetSizeVar")
    def reset_size_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSizeVar", []))

    @jsii.member(jsii_name="resetStroke")
    def reset_stroke(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStroke", []))

    @jsii.member(jsii_name="resetStrokeSize")
    def reset_stroke_size(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStrokeSize", []))

    @jsii.member(jsii_name="resetStrokeSizeVar")
    def reset_stroke_size_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStrokeSizeVar", []))

    @jsii.member(jsii_name="resetStrokeVar")
    def reset_stroke_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStrokeVar", []))

    @jsii.member(jsii_name="resetText")
    def reset_text(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetText", []))

    @jsii.member(jsii_name="resetTextVar")
    def reset_text_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTextVar", []))

    @jsii.member(jsii_name="resetTransformation")
    def reset_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformation", []))

    @jsii.member(jsii_name="resetTypeface")
    def reset_typeface(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeface", []))

    @jsii.member(jsii_name="resetTypefaceVar")
    def reset_typeface_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypefaceVar", []))

    @builtins.property
    @jsii.member(jsii_name="transformation")
    def transformation(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageTextImageTransformationOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageTextImageTransformationOutputReference", jsii.get(self, "transformation"))

    @builtins.property
    @jsii.member(jsii_name="fillInput")
    def fill_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fillInput"))

    @builtins.property
    @jsii.member(jsii_name="fillVarInput")
    def fill_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fillVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sizeInput")
    def size_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sizeInput"))

    @builtins.property
    @jsii.member(jsii_name="sizeVarInput")
    def size_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sizeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="strokeInput")
    def stroke_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "strokeInput"))

    @builtins.property
    @jsii.member(jsii_name="strokeSizeInput")
    def stroke_size_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "strokeSizeInput"))

    @builtins.property
    @jsii.member(jsii_name="strokeSizeVarInput")
    def stroke_size_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "strokeSizeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="strokeVarInput")
    def stroke_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "strokeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="textInput")
    def text_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "textInput"))

    @builtins.property
    @jsii.member(jsii_name="textVarInput")
    def text_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "textVarInput"))

    @builtins.property
    @jsii.member(jsii_name="transformationInput")
    def transformation_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageTextImageTransformation"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageTextImageTransformation"], jsii.get(self, "transformationInput"))

    @builtins.property
    @jsii.member(jsii_name="typefaceInput")
    def typeface_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typefaceInput"))

    @builtins.property
    @jsii.member(jsii_name="typefaceVarInput")
    def typeface_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typefaceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="fill")
    def fill(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fill"))

    @fill.setter
    def fill(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__168a6cbbd655755c40d333db7120592fd5f33957af08a66a134a4c8322385d64)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fill", value)

    @builtins.property
    @jsii.member(jsii_name="fillVar")
    def fill_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fillVar"))

    @fill_var.setter
    def fill_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dc0c81553246957756dbd757da473afca64ad05cc1d6848d6237adc5c002b90d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fillVar", value)

    @builtins.property
    @jsii.member(jsii_name="size")
    def size(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "size"))

    @size.setter
    def size(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c1e6b4366f489c1172e053ca662e57083e495bc353d85ad1aedc2e9763eb57a9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "size", value)

    @builtins.property
    @jsii.member(jsii_name="sizeVar")
    def size_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sizeVar"))

    @size_var.setter
    def size_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea7b3082a1ab2d7c67dd7e794074d65d6a6ad4e10bab97e98bdcf7a6c457d4d4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sizeVar", value)

    @builtins.property
    @jsii.member(jsii_name="stroke")
    def stroke(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "stroke"))

    @stroke.setter
    def stroke(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bf06df5a6616fc95e7c12c13f5356040e4c94a8c5740fbe41fc702971486247d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "stroke", value)

    @builtins.property
    @jsii.member(jsii_name="strokeSize")
    def stroke_size(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "strokeSize"))

    @stroke_size.setter
    def stroke_size(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3193c28b3d51088dd21a30cda59c60c91ff203d4b864ac454ccd5d36f433e0a0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "strokeSize", value)

    @builtins.property
    @jsii.member(jsii_name="strokeSizeVar")
    def stroke_size_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "strokeSizeVar"))

    @stroke_size_var.setter
    def stroke_size_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bd222ee28591c585a6c459f873057bb0e20d50b143f1d28e48d9552808e37fb3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "strokeSizeVar", value)

    @builtins.property
    @jsii.member(jsii_name="strokeVar")
    def stroke_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "strokeVar"))

    @stroke_var.setter
    def stroke_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a9f0e61d866d9f1ee35f17320d2d5c2a030ae7a303ddc2aca581898f4ab3c356)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "strokeVar", value)

    @builtins.property
    @jsii.member(jsii_name="text")
    def text(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "text"))

    @text.setter
    def text(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a7707db50c5dc2cb9128ca37a0ae901b1643e4c39f72f089877c4ee7f5f2787a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "text", value)

    @builtins.property
    @jsii.member(jsii_name="textVar")
    def text_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "textVar"))

    @text_var.setter
    def text_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__22a16a537625b478b9498111643ae0362452388db3c79409b53e79d588d0d9cf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "textVar", value)

    @builtins.property
    @jsii.member(jsii_name="typeface")
    def typeface(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeface"))

    @typeface.setter
    def typeface(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f8e5ae5ca0d6964eac01c5ef40863a559c86b9da563ca7a4e04fc7cf155db7f5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeface", value)

    @builtins.property
    @jsii.member(jsii_name="typefaceVar")
    def typeface_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typefaceVar"))

    @typeface_var.setter
    def typeface_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6de358f15e502156d8ac2a7257a28ec4f74d09e2d0b493fa1fad2c3bdaea4f5d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typefaceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageTextImage]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageTextImage]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageTextImage]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__05005e08269a172f657703d870a95b5f74ffb35f5c9622475cdbe975c8abfcde)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageTextImageTransformation",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageTextImageTransformation:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageTextImageTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageTextImageTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageTextImageTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a375a7ed58226df6dada366f167491d263005a815b09ed518ca8cb25d6fbe8ff)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageTextImageTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageTextImageTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageTextImageTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__291408be1c14ee2d9e09821996bfb474ff981a0630357e6203c32fc73f7eb7c0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageUrlImage",
    jsii_struct_bases=[],
    name_mapping={
        "transformation": "transformation",
        "url": "url",
        "url_var": "urlVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageUrlImage:
    def __init__(
        self,
        *,
        transformation: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageUrlImageTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        url: typing.Optional[builtins.str] = None,
        url_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param transformation: transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        :param url: The URL of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url DataAkamaiImagingPolicyImage#url}
        :param url_var: The URL of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url_var DataAkamaiImagingPolicyImage#url_var}
        '''
        if isinstance(transformation, dict):
            transformation = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageUrlImageTransformation(**transformation)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__71135d32c1a2e0318ab8971b3ec7dcdc08eb4d1ee18a6e742bc7a8bc30fe185f)
            check_type(argname="argument transformation", value=transformation, expected_type=type_hints["transformation"])
            check_type(argname="argument url", value=url, expected_type=type_hints["url"])
            check_type(argname="argument url_var", value=url_var, expected_type=type_hints["url_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if transformation is not None:
            self._values["transformation"] = transformation
        if url is not None:
            self._values["url"] = url
        if url_var is not None:
            self._values["url_var"] = url_var

    @builtins.property
    def transformation(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageUrlImageTransformation"]:
        '''transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        '''
        result = self._values.get("transformation")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageUrlImageTransformation"], result)

    @builtins.property
    def url(self) -> typing.Optional[builtins.str]:
        '''The URL of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url DataAkamaiImagingPolicyImage#url}
        '''
        result = self._values.get("url")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def url_var(self) -> typing.Optional[builtins.str]:
        '''The URL of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url_var DataAkamaiImagingPolicyImage#url_var}
        '''
        result = self._values.get("url_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageUrlImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageUrlImageList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageUrlImageList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7337c8281142a9df6c152d36bc5df3832629d2bb0cb526cc9863534948e4bea3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageUrlImageOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2c23694122984d819bdec7708dc88aa9e1fd58b1dfabaa5f1c7e9229fa810b71)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageUrlImageOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a47d5fcef359ecf4c689e9ac2f9223ce80834082178b22b9129ce643a0b59c3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__68419269681c70dba168eba7ca5c8bada595b460a3d81de82df54de752c5a248)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f4ce8d45e4ff5c067a6b83261f68857a640544e6512752f37dd235ec3f0e0f3c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageUrlImage]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageUrlImage]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageUrlImage]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c1effb57536d0d05102f8d2ce104c834f5c3eba9c4e5481e8d97c8e958d3a3e3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageUrlImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageUrlImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a7a74696ffbb1e7236d8bc9e7f1b5f7dd5d1bd2326fe9d0ea0ab17c43e1ba65)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformation")
    def put_transformation(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageUrlImageTransformation()

        return typing.cast(None, jsii.invoke(self, "putTransformation", [value]))

    @jsii.member(jsii_name="resetTransformation")
    def reset_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformation", []))

    @jsii.member(jsii_name="resetUrl")
    def reset_url(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUrl", []))

    @jsii.member(jsii_name="resetUrlVar")
    def reset_url_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUrlVar", []))

    @builtins.property
    @jsii.member(jsii_name="transformation")
    def transformation(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageUrlImageTransformationOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageUrlImageTransformationOutputReference", jsii.get(self, "transformation"))

    @builtins.property
    @jsii.member(jsii_name="transformationInput")
    def transformation_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageUrlImageTransformation"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageUrlImageTransformation"], jsii.get(self, "transformationInput"))

    @builtins.property
    @jsii.member(jsii_name="urlInput")
    def url_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "urlInput"))

    @builtins.property
    @jsii.member(jsii_name="urlVarInput")
    def url_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "urlVarInput"))

    @builtins.property
    @jsii.member(jsii_name="url")
    def url(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "url"))

    @url.setter
    def url(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d1041b6c1fdbf755af7a7e84a9b38c17938943954554e0a76de3ab922c44ec3a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "url", value)

    @builtins.property
    @jsii.member(jsii_name="urlVar")
    def url_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "urlVar"))

    @url_var.setter
    def url_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__095ecb2174de2ca0fb99ec9162d88d4241db793727403683ca13be2439558ff8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "urlVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageUrlImage]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageUrlImage]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageUrlImage]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__991e7eaf287d899411df466feac5bf358bacada72d5fbff2ef042866ed95c00c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageUrlImageTransformation",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageUrlImageTransformation:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageUrlImageTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageUrlImageTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageUrlImageTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__91f5e07b22d7b0bedaaae3b1e40175a7c24a6f8d20ffb3844fdf56bb815925e6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageUrlImageTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageUrlImageTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageUrlImageTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__18e54b672ea7878b5ad868262e839b3bc903b0f6534284ff3da0234721f47481)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af7d64013d54ae0b7b642615ff1319e676eb7aa283d163add96d998553c014da)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__463e8bbc876c1407ccab6b98f475d8eb32382e9c3b10ada45fdea33efc8e7278)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6b2ca8ac8e000efe6fe51ba4fb2a42ceadeab466348bf7cd68c30b9ef259bd89)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab57c4a235a0aeeae9f162da9d5f5293c6ae6cdaa2f6e5e47e53d538cd526b76)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9fb2ad741d09e537e33c60ce2c7da064897173a72027e17de9b7eb7e163bd0c0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanComposite]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanComposite]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__977ebe586da37709c3b38eb7684b27d3236d07f9d45ae130840e3f2d0bbab5e7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d75e65acaabb9c0920f3d24f1fe94f28d6347230b9f9515e0d9ec9ece528113a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(
        self,
        *,
        box_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageBoxImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
        circle_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageCircleImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
        text_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageTextImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
        url_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageUrlImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param box_image: box_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#box_image DataAkamaiImagingPolicyImage#box_image}
        :param circle_image: circle_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#circle_image DataAkamaiImagingPolicyImage#circle_image}
        :param text_image: text_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text_image DataAkamaiImagingPolicyImage#text_image}
        :param url_image: url_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url_image DataAkamaiImagingPolicyImage#url_image}
        '''
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImage(
            box_image=box_image,
            circle_image=circle_image,
            text_image=text_image,
            url_image=url_image,
        )

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPlacement")
    def reset_placement(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacement", []))

    @jsii.member(jsii_name="resetPlacementVar")
    def reset_placement_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacementVar", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetScaleDimension")
    def reset_scale_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimension", []))

    @jsii.member(jsii_name="resetScaleDimensionVar")
    def reset_scale_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimensionVar", []))

    @jsii.member(jsii_name="resetScaleVar")
    def reset_scale_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="placementInput")
    def placement_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementInput"))

    @builtins.property
    @jsii.member(jsii_name="placementVarInput")
    def placement_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionInput")
    def scale_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVarInput")
    def scale_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleVarInput")
    def scale_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__10347314080e15c22c3b58f2ff71518e62ca3254099792fb24b9ce8b5b883c3e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b590957d2fdbaf9aee6802ead52955e594e6cbbe16e650ad2b92c0cac030eade)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="placement")
    def placement(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placement"))

    @placement.setter
    def placement(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c30b8d9d77222b7e36035772bf9996e067f98bf64b92b640352abdc5b7cc105c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placement", value)

    @builtins.property
    @jsii.member(jsii_name="placementVar")
    def placement_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placementVar"))

    @placement_var.setter
    def placement_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af52d2c6597a026ff50875ae15278429151c4e3c2f18e78be752117dc27b08b0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placementVar", value)

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scale"))

    @scale.setter
    def scale(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3022adedeb3ec2f0feede20f0060251ef3d49df1544ea822474a0c318415d95c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scale", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimension")
    def scale_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimension"))

    @scale_dimension.setter
    def scale_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e00d264338b1c517d23e96b91524c086e4370b8a56816b96ef77dafc2814f799)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimension", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVar")
    def scale_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimensionVar"))

    @scale_dimension_var.setter
    def scale_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__283b60b69a64bde4e0502047cf7909798dc33c10ef1faf863c0f73a742fa680a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="scaleVar")
    def scale_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleVar"))

    @scale_var.setter
    def scale_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dd55c98d9084aad638083c0fca60933a81fac9fcb1d949e79b44f375b49f0909)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4f236d1483e3a7a2eacf0d21aa2bf6b9f19def964bfdbdcc80c22936aa9c5dc1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e1c1772558324a1896b8bdbea7fcf65fd78aed9f8e3351d7c2fc3edcae4a240a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2e6e63bfd0d0769003ec25b2910806525ce7652c46e47a32b1767082dffecdc4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e6a2b460bbbe790641e62b3037efaf441f64cefc917e5ab117270973a9215e1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanComposite]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanComposite]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanComposite]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__26b875f69f5fe79e7b47279ce53917ade376d1a9d813bbe941348864b99f6243)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompound",
    jsii_struct_bases=[],
    name_mapping={"transformations": "transformations"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompound:
    def __init__(
        self,
        *,
        transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param transformations: transformations block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__969d02847912390fbf47e043c5c2b09bcc4f17286895ba1301797f680814a179)
            check_type(argname="argument transformations", value=transformations, expected_type=type_hints["transformations"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if transformations is not None:
            self._values["transformations"] = transformations

    @builtins.property
    def transformations(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformations"]]]:
        '''transformations block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        result = self._values.get("transformations")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformations"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompound(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7468ef4b850c55f592090113cbc3bdad78991d45ad04ba884471d57d0864b57c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c20469d6cd5c710b316331c4a576235870175447ffcadac4a3df05e77b7afba1)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c5d510afe5128173fbf30a91f0c24ce8bb5acd9e9b2c20fbd8ce817564a560a4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__42ab5abeb7031c9503fc75c9de11f349a80c6de68bf1408f47ffb51175b720ae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__54b84a89d4cd1f702997ca1f806ae43d649bf1d1f54f68e846a8cf982e4f5544)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompound]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompound]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ce7ec6049db836012d53de6eef7b22a30afd737316eeba6e8fbc232700bd17ab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9dfcc161fdbb7c439e7c9d3555035214b03f76e7317bbbcf20fd8eb41a5141f6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformations")
    def put_transformations(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c19ea0e68cddbf18059827b1a0401c803b9857fdba8b25f9813f19e13a960328)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTransformations", [value]))

    @jsii.member(jsii_name="resetTransformations")
    def reset_transformations(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformations", []))

    @builtins.property
    @jsii.member(jsii_name="transformations")
    def transformations(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsList", jsii.get(self, "transformations"))

    @builtins.property
    @jsii.member(jsii_name="transformationsInput")
    def transformations_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformations"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformations"]]], jsii.get(self, "transformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompound]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompound]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompound]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__37f38dd0f3a64f9f56116ac31a3fda94ed6d6bcd52f61f3002fa41ce8ad1db08)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformations",
    jsii_struct_bases=[],
    name_mapping={
        "background_color": "backgroundColor",
        "blur": "blur",
        "chroma_key": "chromaKey",
        "composite": "composite",
        "compound": "compound",
        "contrast": "contrast",
        "goop": "goop",
        "grayscale": "grayscale",
        "hsl": "hsl",
        "hsv": "hsv",
        "if_dimension": "ifDimension",
        "if_orientation": "ifOrientation",
        "max_colors": "maxColors",
        "mirror": "mirror",
        "mono_hue": "monoHue",
        "opacity": "opacity",
        "remove_color": "removeColor",
        "unsharp_mask": "unsharpMask",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformations:
    def __init__(
        self,
        *,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsBackgroundColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsBlur", typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsChromaKey", typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsComposite", typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsCompound", typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsContrast", typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsGoop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsGrayscale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsHsl", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsHsv", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfDimension", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfOrientation", typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsMaxColors", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsMirror", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsMonoHue", typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsOpacity", typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsRemoveColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsUnsharpMask", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1522fa390c723db386a68c77d3985b6b4ac6273a0732ae341fc0944f6c0a6be9)
            check_type(argname="argument background_color", value=background_color, expected_type=type_hints["background_color"])
            check_type(argname="argument blur", value=blur, expected_type=type_hints["blur"])
            check_type(argname="argument chroma_key", value=chroma_key, expected_type=type_hints["chroma_key"])
            check_type(argname="argument composite", value=composite, expected_type=type_hints["composite"])
            check_type(argname="argument compound", value=compound, expected_type=type_hints["compound"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument goop", value=goop, expected_type=type_hints["goop"])
            check_type(argname="argument grayscale", value=grayscale, expected_type=type_hints["grayscale"])
            check_type(argname="argument hsl", value=hsl, expected_type=type_hints["hsl"])
            check_type(argname="argument hsv", value=hsv, expected_type=type_hints["hsv"])
            check_type(argname="argument if_dimension", value=if_dimension, expected_type=type_hints["if_dimension"])
            check_type(argname="argument if_orientation", value=if_orientation, expected_type=type_hints["if_orientation"])
            check_type(argname="argument max_colors", value=max_colors, expected_type=type_hints["max_colors"])
            check_type(argname="argument mirror", value=mirror, expected_type=type_hints["mirror"])
            check_type(argname="argument mono_hue", value=mono_hue, expected_type=type_hints["mono_hue"])
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument remove_color", value=remove_color, expected_type=type_hints["remove_color"])
            check_type(argname="argument unsharp_mask", value=unsharp_mask, expected_type=type_hints["unsharp_mask"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if background_color is not None:
            self._values["background_color"] = background_color
        if blur is not None:
            self._values["blur"] = blur
        if chroma_key is not None:
            self._values["chroma_key"] = chroma_key
        if composite is not None:
            self._values["composite"] = composite
        if compound is not None:
            self._values["compound"] = compound
        if contrast is not None:
            self._values["contrast"] = contrast
        if goop is not None:
            self._values["goop"] = goop
        if grayscale is not None:
            self._values["grayscale"] = grayscale
        if hsl is not None:
            self._values["hsl"] = hsl
        if hsv is not None:
            self._values["hsv"] = hsv
        if if_dimension is not None:
            self._values["if_dimension"] = if_dimension
        if if_orientation is not None:
            self._values["if_orientation"] = if_orientation
        if max_colors is not None:
            self._values["max_colors"] = max_colors
        if mirror is not None:
            self._values["mirror"] = mirror
        if mono_hue is not None:
            self._values["mono_hue"] = mono_hue
        if opacity is not None:
            self._values["opacity"] = opacity
        if remove_color is not None:
            self._values["remove_color"] = remove_color
        if unsharp_mask is not None:
            self._values["unsharp_mask"] = unsharp_mask

    @builtins.property
    def background_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsBackgroundColor"]]]:
        '''background_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        '''
        result = self._values.get("background_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsBackgroundColor"]]], result)

    @builtins.property
    def blur(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsBlur"]]]:
        '''blur block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        '''
        result = self._values.get("blur")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsBlur"]]], result)

    @builtins.property
    def chroma_key(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsChromaKey"]]]:
        '''chroma_key block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        '''
        result = self._values.get("chroma_key")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsChromaKey"]]], result)

    @builtins.property
    def composite(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsComposite"]]]:
        '''composite block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        '''
        result = self._values.get("composite")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsComposite"]]], result)

    @builtins.property
    def compound(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsCompound"]]]:
        '''compound block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        '''
        result = self._values.get("compound")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsCompound"]]], result)

    @builtins.property
    def contrast(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsContrast"]]]:
        '''contrast block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsContrast"]]], result)

    @builtins.property
    def goop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsGoop"]]]:
        '''goop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        '''
        result = self._values.get("goop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsGoop"]]], result)

    @builtins.property
    def grayscale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsGrayscale"]]]:
        '''grayscale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        '''
        result = self._values.get("grayscale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsGrayscale"]]], result)

    @builtins.property
    def hsl(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsHsl"]]]:
        '''hsl block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        '''
        result = self._values.get("hsl")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsHsl"]]], result)

    @builtins.property
    def hsv(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsHsv"]]]:
        '''hsv block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        '''
        result = self._values.get("hsv")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsHsv"]]], result)

    @builtins.property
    def if_dimension(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfDimension"]]]:
        '''if_dimension block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        '''
        result = self._values.get("if_dimension")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfDimension"]]], result)

    @builtins.property
    def if_orientation(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfOrientation"]]]:
        '''if_orientation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        '''
        result = self._values.get("if_orientation")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfOrientation"]]], result)

    @builtins.property
    def max_colors(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsMaxColors"]]]:
        '''max_colors block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        '''
        result = self._values.get("max_colors")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsMaxColors"]]], result)

    @builtins.property
    def mirror(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsMirror"]]]:
        '''mirror block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        '''
        result = self._values.get("mirror")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsMirror"]]], result)

    @builtins.property
    def mono_hue(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsMonoHue"]]]:
        '''mono_hue block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        '''
        result = self._values.get("mono_hue")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsMonoHue"]]], result)

    @builtins.property
    def opacity(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsOpacity"]]]:
        '''opacity block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsOpacity"]]], result)

    @builtins.property
    def remove_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsRemoveColor"]]]:
        '''remove_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        '''
        result = self._values.get("remove_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsRemoveColor"]]], result)

    @builtins.property
    def unsharp_mask(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsUnsharpMask"]]]:
        '''unsharp_mask block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        result = self._values.get("unsharp_mask")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsUnsharpMask"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformations(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsBackgroundColor",
    jsii_struct_bases=[],
    name_mapping={"color": "color", "color_var": "colorVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsBackgroundColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__36b9302cdbaa92a854cfa654421b0f9c682c5c6491f87cdafd44d6080e8933f3)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsBackgroundColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsBackgroundColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsBackgroundColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0513aba8406e7c573d5fb826829fb0e0cdc757168440da36bff4cadd09bc6072)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsBackgroundColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__062750f1c2aed235365ad8bb6ef325ff7be42fafa395a3617f62c5a1ce013e52)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsBackgroundColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__45763f13a175b1ec62b6a4baf2331b00a4020dd2628682af08acfda42a221bbb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__09f711d2459fa1ac09bea1139af763ecbb4d325a9d157a523563975e6fe52610)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2f33f41410f43a468fc103f48a38f704c1efc0299bfb224e65c10fe809777394)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsBackgroundColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsBackgroundColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e63897b6626957f8c54331665c04e49e62cb0c08e0e19d454d353dcbd8522eb2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsBackgroundColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsBackgroundColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bf54574087a69217aa155449b28765e138fc7eae226404e4c2cf7d4f3aec1a4b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eb0c194d297daea12aeabb3d853a93d219b309c109df2806484d0c1c680cb369)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aaeb147e58556dc77b23acce9c92f65b5f130c090361d7bbbaa56d1418c46295)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsBackgroundColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsBackgroundColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsBackgroundColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1032c5f1d166b2e48093e0aa748f02acd624eeefa938c7a0c8c56737b3b6e370)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsBlur",
    jsii_struct_bases=[],
    name_mapping={"sigma": "sigma", "sigma_var": "sigmaVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsBlur:
    def __init__(
        self,
        *,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param sigma: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__74c527fef282044da8dac317a9982ac8b64b6e3e2fb944352313a5e8c2dda53b)
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsBlur(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsBlurList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsBlurList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f84bd17642d9923d6d39ed7acd17b63c4d6f15c4fb30bee03ff2df93b78729b8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsBlurOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__792853911b2a4318623487b720e421d2838b244504902e73f3ca48e624cf5747)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsBlurOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e2c0e4873f69868d9b6398575fb9614e075aa4e30d6e38823abb297c4a290a5a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0205d6e71b11d6bb342d30e1d08227c066be87644b69f2816d054d03b4935d45)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9530bdaf1356fbc5d359447b5cf3ab775345c0c581a3e0aef449b0e795565401)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsBlur]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsBlur]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3b3a3869acf9e3d30e354b4cb6b44233c6c7c6af2612b2143f8efa2e3dc801a2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsBlurOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsBlurOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa88785f97211e27ec9b5d046d09a65a4313c79e5e0e139e50a4dfcd233eb91a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4563d309b56cedd9f1bfa8601687eba09db939f45e0feb1bfbc1f03d2e8970a8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e15b1427ed13f531ab8778a6432bfc18b939203641d56efd5cdab0d1f266d58a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsBlur]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsBlur]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsBlur]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1c0391bb7ffb4b86d56cb74d140e952c84c9abe02d784fda5d3cdf8c93dd2b01)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsChromaKey",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_feather": "hueFeather",
        "hue_feather_var": "hueFeatherVar",
        "hue_tolerance": "hueTolerance",
        "hue_tolerance_var": "hueToleranceVar",
        "hue_var": "hueVar",
        "lightness_feather": "lightnessFeather",
        "lightness_feather_var": "lightnessFeatherVar",
        "lightness_tolerance": "lightnessTolerance",
        "lightness_tolerance_var": "lightnessToleranceVar",
        "saturation_feather": "saturationFeather",
        "saturation_feather_var": "saturationFeatherVar",
        "saturation_tolerance": "saturationTolerance",
        "saturation_tolerance_var": "saturationToleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsChromaKey:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_feather: typing.Optional[builtins.str] = None,
        hue_feather_var: typing.Optional[builtins.str] = None,
        hue_tolerance: typing.Optional[builtins.str] = None,
        hue_tolerance_var: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness_feather: typing.Optional[builtins.str] = None,
        lightness_feather_var: typing.Optional[builtins.str] = None,
        lightness_tolerance: typing.Optional[builtins.str] = None,
        lightness_tolerance_var: typing.Optional[builtins.str] = None,
        saturation_feather: typing.Optional[builtins.str] = None,
        saturation_feather_var: typing.Optional[builtins.str] = None,
        saturation_tolerance: typing.Optional[builtins.str] = None,
        saturation_tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_feather: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        :param hue_feather_var: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        :param hue_tolerance: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        :param hue_tolerance_var: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        :param hue_var: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness_feather: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        :param lightness_feather_var: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        :param lightness_tolerance: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        :param lightness_tolerance_var: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        :param saturation_feather: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        :param saturation_feather_var: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        :param saturation_tolerance: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        :param saturation_tolerance_var: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d8f933e4a1a834c92477544e2c17bc9c948903f36c6b69aaa7bbecd9eaf072da)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_feather", value=hue_feather, expected_type=type_hints["hue_feather"])
            check_type(argname="argument hue_feather_var", value=hue_feather_var, expected_type=type_hints["hue_feather_var"])
            check_type(argname="argument hue_tolerance", value=hue_tolerance, expected_type=type_hints["hue_tolerance"])
            check_type(argname="argument hue_tolerance_var", value=hue_tolerance_var, expected_type=type_hints["hue_tolerance_var"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness_feather", value=lightness_feather, expected_type=type_hints["lightness_feather"])
            check_type(argname="argument lightness_feather_var", value=lightness_feather_var, expected_type=type_hints["lightness_feather_var"])
            check_type(argname="argument lightness_tolerance", value=lightness_tolerance, expected_type=type_hints["lightness_tolerance"])
            check_type(argname="argument lightness_tolerance_var", value=lightness_tolerance_var, expected_type=type_hints["lightness_tolerance_var"])
            check_type(argname="argument saturation_feather", value=saturation_feather, expected_type=type_hints["saturation_feather"])
            check_type(argname="argument saturation_feather_var", value=saturation_feather_var, expected_type=type_hints["saturation_feather_var"])
            check_type(argname="argument saturation_tolerance", value=saturation_tolerance, expected_type=type_hints["saturation_tolerance"])
            check_type(argname="argument saturation_tolerance_var", value=saturation_tolerance_var, expected_type=type_hints["saturation_tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_feather is not None:
            self._values["hue_feather"] = hue_feather
        if hue_feather_var is not None:
            self._values["hue_feather_var"] = hue_feather_var
        if hue_tolerance is not None:
            self._values["hue_tolerance"] = hue_tolerance
        if hue_tolerance_var is not None:
            self._values["hue_tolerance_var"] = hue_tolerance_var
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness_feather is not None:
            self._values["lightness_feather"] = lightness_feather
        if lightness_feather_var is not None:
            self._values["lightness_feather_var"] = lightness_feather_var
        if lightness_tolerance is not None:
            self._values["lightness_tolerance"] = lightness_tolerance
        if lightness_tolerance_var is not None:
            self._values["lightness_tolerance_var"] = lightness_tolerance_var
        if saturation_feather is not None:
            self._values["saturation_feather"] = saturation_feather
        if saturation_feather_var is not None:
            self._values["saturation_feather_var"] = saturation_feather_var
        if saturation_tolerance is not None:
            self._values["saturation_tolerance"] = saturation_tolerance
        if saturation_tolerance_var is not None:
            self._values["saturation_tolerance_var"] = saturation_tolerance_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        '''
        result = self._values.get("hue_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        '''
        result = self._values.get("hue_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        '''
        result = self._values.get("hue_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        '''
        result = self._values.get("hue_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        '''
        result = self._values.get("lightness_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        '''
        result = self._values.get("lightness_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        '''
        result = self._values.get("lightness_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        '''
        result = self._values.get("lightness_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        '''
        result = self._values.get("saturation_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        '''
        result = self._values.get("saturation_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        '''
        result = self._values.get("saturation_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        result = self._values.get("saturation_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsChromaKey(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsChromaKeyList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsChromaKeyList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c34234ae9adddc4ebbabc3936d396673f744b1885d5a3c533da9867053e4df55)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsChromaKeyOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9532ec0bf2fcca43aabfdcfd2b9d8d76f021755a5af5f9c8d8fa009eef38a811)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsChromaKeyOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b879a801ef9e56b6d8d382a4204e35b55e71e72e59e55a6e9ade52acb367ec36)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__00e769673122a35fab868d9f336402baf49a21865ae50be032cf54ee9795e349)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7596e208d5c56e29249e857b6581f4d691cb5ecf3800738bc5ab73fcbef47fa0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsChromaKey]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsChromaKey]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eb138b770ccfcd10e2e6f54fca62c7fd4d58ff3083a777e0f885f0d61140db37)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsChromaKeyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsChromaKeyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab16df7d87cfd63aed24e6cde5ce99f2f91224ecb2999c89020b53433ac6c3ec)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueFeather")
    def reset_hue_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeather", []))

    @jsii.member(jsii_name="resetHueFeatherVar")
    def reset_hue_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeatherVar", []))

    @jsii.member(jsii_name="resetHueTolerance")
    def reset_hue_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueTolerance", []))

    @jsii.member(jsii_name="resetHueToleranceVar")
    def reset_hue_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueToleranceVar", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightnessFeather")
    def reset_lightness_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeather", []))

    @jsii.member(jsii_name="resetLightnessFeatherVar")
    def reset_lightness_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeatherVar", []))

    @jsii.member(jsii_name="resetLightnessTolerance")
    def reset_lightness_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessTolerance", []))

    @jsii.member(jsii_name="resetLightnessToleranceVar")
    def reset_lightness_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessToleranceVar", []))

    @jsii.member(jsii_name="resetSaturationFeather")
    def reset_saturation_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeather", []))

    @jsii.member(jsii_name="resetSaturationFeatherVar")
    def reset_saturation_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeatherVar", []))

    @jsii.member(jsii_name="resetSaturationTolerance")
    def reset_saturation_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationTolerance", []))

    @jsii.member(jsii_name="resetSaturationToleranceVar")
    def reset_saturation_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherInput")
    def hue_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVarInput")
    def hue_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceInput")
    def hue_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVarInput")
    def hue_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherInput")
    def lightness_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVarInput")
    def lightness_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceInput")
    def lightness_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVarInput")
    def lightness_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherInput")
    def saturation_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVarInput")
    def saturation_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceInput")
    def saturation_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVarInput")
    def saturation_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__443b884922784c2c1ed90effb54ade8c7e7f664bd0a986fe0e8296577e17eba0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeather")
    def hue_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeather"))

    @hue_feather.setter
    def hue_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4692a00de3d8b0c535386765b352a3823ee3ba03911e11e6974edb7386e36517)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeather", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVar")
    def hue_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeatherVar"))

    @hue_feather_var.setter
    def hue_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__554662c7cc0363f0a2816babfcc6cfc7907bf3a9619ff7a1ec52fa035c9f1a50)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueTolerance")
    def hue_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueTolerance"))

    @hue_tolerance.setter
    def hue_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc48b7833f9d0ad13ead1123847edd3755199bcddd1d40f5e13540f0efb86ce1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVar")
    def hue_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueToleranceVar"))

    @hue_tolerance_var.setter
    def hue_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c2a7d8aaa12a08e0e18a7aa3b8a777b30350456a537b09a816b709b0d9b4e271)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__24f519676868aa55d144e0abf3cb0c338dca0fef1d5d4eb53d1e73af265dc02e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeather")
    def lightness_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeather"))

    @lightness_feather.setter
    def lightness_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9508a307ed5b9a02159d66a754a673832e22661871f05f4d843b22357e46e86d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeather", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVar")
    def lightness_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeatherVar"))

    @lightness_feather_var.setter
    def lightness_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f697ebd008411fd187b3d591ca1ef46393e8f2e5c7e85023555f3fe6881edf5d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessTolerance")
    def lightness_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessTolerance"))

    @lightness_tolerance.setter
    def lightness_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fc8f06fb272d5f3cdc0aa8a5fd7d1a861845b3289bc4d410eff2afef0919c3c2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVar")
    def lightness_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessToleranceVar"))

    @lightness_tolerance_var.setter
    def lightness_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3034a763010d1390baa89d338b98935ac7f505af23dc7b1c492ba13ebbf1b2fe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeather")
    def saturation_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeather"))

    @saturation_feather.setter
    def saturation_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e530764b0f211c23e85ef6daa6a56023024335a7cb4ce2e1e984545f9b8abe0e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeather", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVar")
    def saturation_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeatherVar"))

    @saturation_feather_var.setter
    def saturation_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__80506f584b79d1d68f46d7d707b7ce3c4f00839129c3d2c145b6d0c1ec93f458)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationTolerance")
    def saturation_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationTolerance"))

    @saturation_tolerance.setter
    def saturation_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__69466cde5f6ead49a0c70a678577c31396b675a906648e092cc323fc1fd7c0a1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVar")
    def saturation_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationToleranceVar"))

    @saturation_tolerance_var.setter
    def saturation_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b6a8fb3febe475ee463d88af1667a988507715f6ebf3431b74fc1b643194ba2a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsChromaKey]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsChromaKey]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsChromaKey]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c7e835a1edb3bbb6fff7c0ece7aca72528eb43f79d14ac798ea665df2e6ca613)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsComposite",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "placement": "placement",
        "placement_var": "placementVar",
        "scale": "scale",
        "scale_dimension": "scaleDimension",
        "scale_dimension_var": "scaleDimensionVar",
        "scale_var": "scaleVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsComposite:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsCompositeImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        placement: typing.Optional[builtins.str] = None,
        placement_var: typing.Optional[builtins.str] = None,
        scale: typing.Optional[builtins.str] = None,
        scale_dimension: typing.Optional[builtins.str] = None,
        scale_dimension_var: typing.Optional[builtins.str] = None,
        scale_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param placement: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        :param placement_var: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        :param scale: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param scale_dimension: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        :param scale_dimension_var: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        :param scale_var: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        :param x_position: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsCompositeImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b7f708c401c9238148c597d34851999319854941ce241d4a2611be05db9fa266)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument placement", value=placement, expected_type=type_hints["placement"])
            check_type(argname="argument placement_var", value=placement_var, expected_type=type_hints["placement_var"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument scale_dimension", value=scale_dimension, expected_type=type_hints["scale_dimension"])
            check_type(argname="argument scale_dimension_var", value=scale_dimension_var, expected_type=type_hints["scale_dimension_var"])
            check_type(argname="argument scale_var", value=scale_var, expected_type=type_hints["scale_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if placement is not None:
            self._values["placement"] = placement
        if placement_var is not None:
            self._values["placement_var"] = placement_var
        if scale is not None:
            self._values["scale"] = scale
        if scale_dimension is not None:
            self._values["scale_dimension"] = scale_dimension
        if scale_dimension_var is not None:
            self._values["scale_dimension_var"] = scale_dimension_var
        if scale_var is not None:
            self._values["scale_var"] = scale_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsCompositeImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsCompositeImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        '''
        result = self._values.get("placement")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement_var(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        '''
        result = self._values.get("placement_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        '''
        result = self._values.get("scale_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        '''
        result = self._values.get("scale_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        '''
        result = self._values.get("scale_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsComposite(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsCompositeImage",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsCompositeImage:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsCompositeImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsCompositeImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsCompositeImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d6e694d11f13c6288e864f50d8b25508412d2d63e04110939f61a94fa8385b46)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsCompositeImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsCompositeImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cb36ba3c145fdc473bcf2b620f7ae15fe8718f257292488f5e79b78876831356)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsCompositeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsCompositeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__83e4003fd80b0bc69280365fd222e4cbf1dc4de0aadd436e5c7af5d3b25ba544)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsCompositeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6d242b77c18ec4e0e8f2670632a297808e1cd93a67260ed58b6d071088b18470)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsCompositeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e17edebdb6fb86851550efff5650f3f9654df77b991661d3a278aaf67b872c93)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fc49a87030b047f06478497eb104921daee87f10a57adf4fcb026ceb9e0ae82d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f6b4a0eba7b4fd93958745c20d88b38919409dcd5edc84b05ed82cc5e6f2a6e1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsComposite]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsComposite]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f2a9bddd4c85d4fbf1682120ffa27212bbb05ea14f3ffce54b602235825accea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsCompositeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsCompositeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__220d308c7e157b418d8ba309ba610296fb8fcd54312993ddd6d1f085b963d336)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsCompositeImage()

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPlacement")
    def reset_placement(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacement", []))

    @jsii.member(jsii_name="resetPlacementVar")
    def reset_placement_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacementVar", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetScaleDimension")
    def reset_scale_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimension", []))

    @jsii.member(jsii_name="resetScaleDimensionVar")
    def reset_scale_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimensionVar", []))

    @jsii.member(jsii_name="resetScaleVar")
    def reset_scale_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsCompositeImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsCompositeImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsCompositeImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="placementInput")
    def placement_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementInput"))

    @builtins.property
    @jsii.member(jsii_name="placementVarInput")
    def placement_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionInput")
    def scale_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVarInput")
    def scale_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleVarInput")
    def scale_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c6140533c5b272fd2f91a2b581d6c4ad1308004d327cc698f67926a186cbb2a0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ca5c981e8a9e83b6fef5480f5d6679750a07ee9b6a454f484eb47d63d4266c93)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="placement")
    def placement(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placement"))

    @placement.setter
    def placement(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8b9a01fe2663df103c64126e99193a8a7bb44984c5313969dffe8f1a2c8a03c4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placement", value)

    @builtins.property
    @jsii.member(jsii_name="placementVar")
    def placement_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placementVar"))

    @placement_var.setter
    def placement_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a1b4941084da5af28fa770e9ba7a028522a982d631c391d8f751d5f4ada2f8ea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placementVar", value)

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scale"))

    @scale.setter
    def scale(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c4723e6d6561f87ae5a07d2f17de40de227d826cdbdc123e75ec7851b7eef416)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scale", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimension")
    def scale_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimension"))

    @scale_dimension.setter
    def scale_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__61e068320588efc7ca47cbdab4c88bfaf98d5d4d6426d2af845c6d23153f2788)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimension", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVar")
    def scale_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimensionVar"))

    @scale_dimension_var.setter
    def scale_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__708488a54a7ca1659732b319e80ad4a24bbda7b47913311de5f38fc3692e5d90)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="scaleVar")
    def scale_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleVar"))

    @scale_var.setter
    def scale_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8917ec567956744ed1c58e27a64dfc54c3a0cb246861f711f618ac4586d03995)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a0339a6d59921f8550de88c8d3c29b229e608b2b6ad826fa355ba57bd82a659)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8daa781334516887127055699908d1d3c79d4e1a4a2b0d91cd9c9415ab877cdf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__731fc9de1ac86cd7c63cca5d5cd2edacfe5a34af6d11b55ddd28792b1b827f34)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__24d8d7e1037d64c2440d69a6c8e4a5e58b03ef3d373ac054f5ee5f571feb71ba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsComposite]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsComposite]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsComposite]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__213b4e00ac99bc4663dd923428c9f3deaf0ce621fd2f53776066f8df665eba85)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsCompound",
    jsii_struct_bases=[],
    name_mapping={"transformations": "transformations"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsCompound:
    def __init__(
        self,
        *,
        transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param transformations: transformations block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f32a1eff674ebe1471579e67b27e4ab51f617a98a423da48c1d84ce376d070b2)
            check_type(argname="argument transformations", value=transformations, expected_type=type_hints["transformations"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if transformations is not None:
            self._values["transformations"] = transformations

    @builtins.property
    def transformations(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsCompoundTransformations"]]]:
        '''transformations block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        result = self._values.get("transformations")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsCompoundTransformations"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsCompound(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsCompoundList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsCompoundList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__555d54729aa40b570df118bbc201eeb10ebf4475155b5314c99675d0b82f8acf)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsCompoundOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c62afded5eabaa0a8363e2743a3a416a0e64646d658a04e4277671d66f3b0c69)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsCompoundOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3f9e8fd8357012d4568abf808bf9674caf1ac87bfa00937e82c8526fb7144e72)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2040c10919313aa9f8c4d3992752c9dab651e8e6930b064a1a28ca250b8f7fe9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__93087613f14498693fa995b42ee774c81975a07e214a8a129f9d1d46efb73669)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsCompound]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsCompound]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dc3160f05cd2d7bc2169768da84c232273810bf37bc04287655787113f430a98)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsCompoundOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsCompoundOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5acef1ccea9482764d48836e551cc12fcf6b50f8a5c72390881cb32bda33dc3d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformations")
    def put_transformations(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__487f146e5163a82684d7f6db097d4523423d808609cc3d29833a3927d258bad9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTransformations", [value]))

    @jsii.member(jsii_name="resetTransformations")
    def reset_transformations(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformations", []))

    @builtins.property
    @jsii.member(jsii_name="transformations")
    def transformations(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsCompoundTransformationsList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsCompoundTransformationsList", jsii.get(self, "transformations"))

    @builtins.property
    @jsii.member(jsii_name="transformationsInput")
    def transformations_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsCompoundTransformations"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsCompoundTransformations"]]], jsii.get(self, "transformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsCompound]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsCompound]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsCompound]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e27d6bc19db96b7e1bfde917533e85f6da0398b9774ea685071a4690b06367f8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsCompoundTransformations",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsCompoundTransformations:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsCompoundTransformations(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsCompoundTransformationsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsCompoundTransformationsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3fee5bbe2b294b46162b17051cbf34ced961583e88b9d8dc1f5f1ce9ab4beae9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsCompoundTransformationsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af9949edf4bc3616a8410f99e75d822537fe6c5e104f7d627fe0e649517c9435)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsCompoundTransformationsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__baca81cc418d743e332891dc0d7989f629111a995aa26cdad9e3881924a8392e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__74ed722a622ca0f8cda1778911aaa2893a59f7588543d6427655d0048a2e3c54)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c13d22aa34e0aae86950bb935371332f438ed3d6d022cdeb6ed2a60e23dc8ba5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsCompoundTransformations]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsCompoundTransformations]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsCompoundTransformations]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__521df1b5c3e0b267f16caa459b996c0e7ba94433d49fc1aa0cb4acf2eedeb5d6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsCompoundTransformationsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsCompoundTransformationsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__77380891af49f6757bccbf81ba4cead1b723bfa5b0a253c136b2f03d2f8db212)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsCompoundTransformations]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsCompoundTransformations]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsCompoundTransformations]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__578f3c570845c36c096a18e48d65ec0d394905cbfd7fcde9e00cc222da9f28ee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsContrast",
    jsii_struct_bases=[],
    name_mapping={
        "brightness": "brightness",
        "brightness_var": "brightnessVar",
        "contrast": "contrast",
        "contrast_var": "contrastVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsContrast:
    def __init__(
        self,
        *,
        brightness: typing.Optional[builtins.str] = None,
        brightness_var: typing.Optional[builtins.str] = None,
        contrast: typing.Optional[builtins.str] = None,
        contrast_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param brightness: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        :param brightness_var: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        :param contrast: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param contrast_var: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1e344ca0f20c99a8b3c3b8aeeacbee6bf4094fa8c409c8463244fbc2ae5c489e)
            check_type(argname="argument brightness", value=brightness, expected_type=type_hints["brightness"])
            check_type(argname="argument brightness_var", value=brightness_var, expected_type=type_hints["brightness_var"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument contrast_var", value=contrast_var, expected_type=type_hints["contrast_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if brightness is not None:
            self._values["brightness"] = brightness
        if brightness_var is not None:
            self._values["brightness_var"] = brightness_var
        if contrast is not None:
            self._values["contrast"] = contrast
        if contrast_var is not None:
            self._values["contrast_var"] = contrast_var

    @builtins.property
    def brightness(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        '''
        result = self._values.get("brightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def brightness_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        '''
        result = self._values.get("brightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        result = self._values.get("contrast_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsContrast(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsContrastList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsContrastList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa2c9aed6fe007e42aa243f98d0260e18167ec52713a2f01db3dc3af8d667a4a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsContrastOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__57a7c3a4f3f2e87b89b0e3ea710402117aa9f2178946280aa265d8c8125476fc)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsContrastOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__695ba37c29771799e97623468aea80b21492df87beb03423ba8535ef54a3dc22)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__532ee297d77aee8f1b82575b31f94607f7449988b0a204877b9e81df0b8331c6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e3fb07d037d77a0d5ac413f57b3779f8712e5ca0447d047343e5b33da2bafeb6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsContrast]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsContrast]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b6038fed4184e786f4da119474a8f7da69d603529fc2cf1a046369715d7209a8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsContrastOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsContrastOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a5f8857d042bfc1298c4e6f521f9cbbb6109831b506acc32bfc0a0acfe3f5fe4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetBrightness")
    def reset_brightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightness", []))

    @jsii.member(jsii_name="resetBrightnessVar")
    def reset_brightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightnessVar", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetContrastVar")
    def reset_contrast_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrastVar", []))

    @builtins.property
    @jsii.member(jsii_name="brightnessInput")
    def brightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="brightnessVarInput")
    def brightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastVarInput")
    def contrast_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="brightness")
    def brightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightness"))

    @brightness.setter
    def brightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f20f1ff0a6a6efe55f6adf26c50b4c4e5f83117aacc46e2d65c2330832d97773)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightness", value)

    @builtins.property
    @jsii.member(jsii_name="brightnessVar")
    def brightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightnessVar"))

    @brightness_var.setter
    def brightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__427b914e2368fd2e6ddd75d49ab2750016f098774e136ce875616e2436fcc1be)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrast"))

    @contrast.setter
    def contrast(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8d722889d0c9ff906cc7dc2dbdbf5d1128720ec8eaedd64b38201d650832064f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrast", value)

    @builtins.property
    @jsii.member(jsii_name="contrastVar")
    def contrast_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrastVar"))

    @contrast_var.setter
    def contrast_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c16e4c18f0e6b7cc5095aa209903b0588c8e9ddbcc2fd133e394a1ee09069593)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrastVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsContrast]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsContrast]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsContrast]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__82f5856468ac40e5601a42398e903add7eb902cb8c9f737cd4f08dbbf2d57730)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsGoop",
    jsii_struct_bases=[],
    name_mapping={
        "chaos": "chaos",
        "chaos_var": "chaosVar",
        "density": "density",
        "density_var": "densityVar",
        "power": "power",
        "power_var": "powerVar",
        "seed": "seed",
        "seed_var": "seedVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsGoop:
    def __init__(
        self,
        *,
        chaos: typing.Optional[builtins.str] = None,
        chaos_var: typing.Optional[builtins.str] = None,
        density: typing.Optional[builtins.str] = None,
        density_var: typing.Optional[builtins.str] = None,
        power: typing.Optional[builtins.str] = None,
        power_var: typing.Optional[builtins.str] = None,
        seed: typing.Optional[builtins.str] = None,
        seed_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param chaos: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        :param chaos_var: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        :param density: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        :param density_var: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        :param power: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        :param power_var: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        :param seed: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        :param seed_var: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__837c893b24fa5893b9ceb53504df9bc6cb3f62ea852524750e9045e227fa6a75)
            check_type(argname="argument chaos", value=chaos, expected_type=type_hints["chaos"])
            check_type(argname="argument chaos_var", value=chaos_var, expected_type=type_hints["chaos_var"])
            check_type(argname="argument density", value=density, expected_type=type_hints["density"])
            check_type(argname="argument density_var", value=density_var, expected_type=type_hints["density_var"])
            check_type(argname="argument power", value=power, expected_type=type_hints["power"])
            check_type(argname="argument power_var", value=power_var, expected_type=type_hints["power_var"])
            check_type(argname="argument seed", value=seed, expected_type=type_hints["seed"])
            check_type(argname="argument seed_var", value=seed_var, expected_type=type_hints["seed_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if chaos is not None:
            self._values["chaos"] = chaos
        if chaos_var is not None:
            self._values["chaos_var"] = chaos_var
        if density is not None:
            self._values["density"] = density
        if density_var is not None:
            self._values["density_var"] = density_var
        if power is not None:
            self._values["power"] = power
        if power_var is not None:
            self._values["power_var"] = power_var
        if seed is not None:
            self._values["seed"] = seed
        if seed_var is not None:
            self._values["seed_var"] = seed_var

    @builtins.property
    def chaos(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        '''
        result = self._values.get("chaos")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def chaos_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        '''
        result = self._values.get("chaos_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        '''
        result = self._values.get("density")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density_var(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        '''
        result = self._values.get("density_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        '''
        result = self._values.get("power")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power_var(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        '''
        result = self._values.get("power_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        '''
        result = self._values.get("seed")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed_var(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        result = self._values.get("seed_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsGoop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsGoopList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsGoopList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__92bd98c8482952862b8fbef0243fdc14ac77a628446105496be1bf2d31f761ef)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsGoopOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a291d70783bffcc974aa2f5bfc758dda46b4b3422b592ae44b3acafc62acb4da)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsGoopOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ba09e2c9f11045375e9ca9ce1b4ef2df3d420b99a075c619dc75f7869c2449b1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7dc226e7ef27f01a47546c5c1e51c2fad873f6ec68d8cc83561cd3ae1339fdef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a5225641cf82918ea79e355effd202e271c927e0c930fcfc3efa08429b61526)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsGoop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsGoop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__488a3a2a3c9548ac2f48a15e61dd0c03be6b880ebac7fd3d2f7ae4d63bcb1dbe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsGoopOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsGoopOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ee6cb31b41d2454d49eb4adad41bb37c706ac1868e0e05ba6132583d2353165)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetChaos")
    def reset_chaos(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaos", []))

    @jsii.member(jsii_name="resetChaosVar")
    def reset_chaos_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaosVar", []))

    @jsii.member(jsii_name="resetDensity")
    def reset_density(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensity", []))

    @jsii.member(jsii_name="resetDensityVar")
    def reset_density_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensityVar", []))

    @jsii.member(jsii_name="resetPower")
    def reset_power(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPower", []))

    @jsii.member(jsii_name="resetPowerVar")
    def reset_power_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPowerVar", []))

    @jsii.member(jsii_name="resetSeed")
    def reset_seed(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeed", []))

    @jsii.member(jsii_name="resetSeedVar")
    def reset_seed_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeedVar", []))

    @builtins.property
    @jsii.member(jsii_name="chaosInput")
    def chaos_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosInput"))

    @builtins.property
    @jsii.member(jsii_name="chaosVarInput")
    def chaos_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosVarInput"))

    @builtins.property
    @jsii.member(jsii_name="densityInput")
    def density_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityInput"))

    @builtins.property
    @jsii.member(jsii_name="densityVarInput")
    def density_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="powerInput")
    def power_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerInput"))

    @builtins.property
    @jsii.member(jsii_name="powerVarInput")
    def power_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerVarInput"))

    @builtins.property
    @jsii.member(jsii_name="seedInput")
    def seed_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedInput"))

    @builtins.property
    @jsii.member(jsii_name="seedVarInput")
    def seed_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedVarInput"))

    @builtins.property
    @jsii.member(jsii_name="chaos")
    def chaos(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaos"))

    @chaos.setter
    def chaos(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__03c2efc12159dc6ab1f1d565a36c69eab2c8467f8f01a2a4597cf48b64f75ced)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaos", value)

    @builtins.property
    @jsii.member(jsii_name="chaosVar")
    def chaos_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaosVar"))

    @chaos_var.setter
    def chaos_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__deacad16ebe5e6f237f3440fad3547a4efa712f46b7c37a5624be6204af50b2b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaosVar", value)

    @builtins.property
    @jsii.member(jsii_name="density")
    def density(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "density"))

    @density.setter
    def density(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eee51749e62cc3c4b757cc3c0346ed8a27e5445b12a30c68cbf6bbd087c6b953)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "density", value)

    @builtins.property
    @jsii.member(jsii_name="densityVar")
    def density_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "densityVar"))

    @density_var.setter
    def density_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__47d0594dde4d619eaa740240e5bdde29b707edbd8f44d10087d2ddaa6dccef30)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "densityVar", value)

    @builtins.property
    @jsii.member(jsii_name="power")
    def power(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "power"))

    @power.setter
    def power(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a8ce3e35c2ebaea6faec31ae77ea266c34d16e3531c01dfbc84f5e06b9b42d32)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "power", value)

    @builtins.property
    @jsii.member(jsii_name="powerVar")
    def power_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "powerVar"))

    @power_var.setter
    def power_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ecc064ac57bed9bf80424cbfce61c8021fcf2b754bc61a0d6b8140f1ac8b5e25)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "powerVar", value)

    @builtins.property
    @jsii.member(jsii_name="seed")
    def seed(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seed"))

    @seed.setter
    def seed(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__692bddcdfaff39f910df81447dd0955d0d5f3e68ed8b486bb135d73a0258b79b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seed", value)

    @builtins.property
    @jsii.member(jsii_name="seedVar")
    def seed_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seedVar"))

    @seed_var.setter
    def seed_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__24a4153d255ea4c73c9a315b409b708ca54ceeffeec1ba7a71c2d9a990ef79b1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seedVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsGoop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsGoop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsGoop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__84614352922b2e1007036ddbe82ed135b22afd322aeb6a6909184e6adb6199dc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsGrayscale",
    jsii_struct_bases=[],
    name_mapping={"type": "type", "type_var": "typeVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsGrayscale:
    def __init__(
        self,
        *,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param type: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__33cd0d5321771948a1ea3e370459713d2dc7a4ae6e18bd76679c3e96b9b30d74)
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsGrayscale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsGrayscaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsGrayscaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2f933ce3149ad758e1038d26a397079eace329d0de66ed2aaa3ea7ec5b29a5a4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsGrayscaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7e16f7528bfb92fc3a214357b0b9a518d872aedeb8fa52db5d61810122ec8c94)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsGrayscaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5852862dce7e0e480e3451baa5a19d56cc13ab04e23fe608a65f4ab711a174c0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f1ba6253e050b3c034b5199df1f0612ee52ae6b3c11cfbbdac30831e117c271)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b8c01355f3ed65b1090b9e633a4310bce03ef9ce6f89060ea7422971ff93fd9b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsGrayscale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsGrayscale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c189da86c7ae9d9d824778db22bafb89184dd279998730c42cd3307dc0d426f2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsGrayscaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsGrayscaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6dd362f36ea13690f42093fa44729128b5e0399d71d9c0593d19d67965aa5a3c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f82e777ffbb50a48411f606ce37ca9c9c95a3ee6291a648122ce0f4c28e9f301)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__45c83e3e0716d2b54bf2da1f3878625d987abc654cd2160918c9825ad1dc5726)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsGrayscale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsGrayscale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsGrayscale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8fca06c251aae466f0faeb615af73f3819bf41d8da5b3e1753fbf6b2478b662e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsHsl",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "lightness": "lightness",
        "lightness_var": "lightnessVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsHsl:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness: typing.Optional[builtins.str] = None,
        lightness_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        :param lightness_var: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d2a63c07b532d502f1b6442882be6bb3d10d72643b327e1df2d5e145528b38f6)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness", value=lightness, expected_type=type_hints["lightness"])
            check_type(argname="argument lightness_var", value=lightness_var, expected_type=type_hints["lightness_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness is not None:
            self._values["lightness"] = lightness
        if lightness_var is not None:
            self._values["lightness_var"] = lightness_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        '''
        result = self._values.get("lightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        '''
        result = self._values.get("lightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsHsl(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsHslList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsHslList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2dde498de802f81a84d85a20aedafe027b77a59b6381a195985dc1da9834a7d7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsHslOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1a06055f1224fc93c08ff5796f6e83cf690b0110f1ad710feb9eb9363cbe234d)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsHslOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2bdbf1d60fbd14d57bd7c7bd469de38c77da1182f578a26c314ea8cafdf4b1c7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6d32af8d2766198a260fa05d7dc33eff1dd4cfb886a98f1694764e38d98b8d5f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f65445b5f3021bcbca2d02df82e862fc4dcb733b923851aaf50fd1e986f7585)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsHsl]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsHsl]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fe7f6fb996e80c08546903be9ab947acef0f5f71979283648c7a09ed8b4750ba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsHslOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsHslOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b89433fa53e1a441f1889bfce8e645cfc8161cd286aba597111055518ea86045)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightness")
    def reset_lightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightness", []))

    @jsii.member(jsii_name="resetLightnessVar")
    def reset_lightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessInput")
    def lightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessVarInput")
    def lightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f9097193359d97b13683d4206fbbf8ad48a6eed21ded64222aaef6d15412eb6c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4cd2f06cc24de5ec11feb695caced89ba71d65fdd779809f159c455cc1440c4f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightness")
    def lightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightness"))

    @lightness.setter
    def lightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a7fa6bed1ff71ce7a5641109df1dca56e93571f7e1a0bd00d3bfd4091ac78947)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightness", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessVar")
    def lightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessVar"))

    @lightness_var.setter
    def lightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dc58374895756f47a7c20d9995578a36511412a57feb175a044b0f3a0ab67b34)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__502346a937f770265a2dae513749bbb1e1fe39b0e8b3412267d9241d693bbc06)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__334e9a58d994ef450706e668beca617b5a907fd3881e8df1cdac18b11c50e6a6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsHsl]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsHsl]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsHsl]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__27139d53f40f73adfa23d853db6122c848aede0f6627a9bdf4dae9c024364018)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsHsv",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsHsv:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        :param value: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__845c48a1221b4c2ecd2edd68936b2326dbef29255af9cc050b0dc0ad22dbe32d)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsHsv(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsHsvList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsHsvList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ad8a6fe6ff3d77c9545a32e1741039c963acacf698bf0e9410999d9c142f2761)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsHsvOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e4f02f0520d9efe416a7e36533fd84496ef2aabcac291b49e1f436f6dd4fb02a)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsHsvOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5631e7f1466875d24f4278a467cf24070b5ec61ffdf96cfcbd45fc313b5549ec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c91e9ebfd5dda465e5ecb17ca31b32ab8d8967428e48bf2351ffc93b595b4c31)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f95410446f142e8d5ad3177c674d62a29718c2a3a43b766a67c7e4db07e8c269)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsHsv]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsHsv]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b847ffde135b01796cecd94dfaea26447064ed87ad11a26bf59b252f884bbd57)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsHsvOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsHsvOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__33067d16c44236d58d22eb232bdeeefd8118380267b2702ff7d9c653b6d088c2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3d072ddb4ab58d7daa37c2ba3843bbf2c5152ea89ff8626bdf84b77d901e0565)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a45e83d905539ebb5fab3383a7222273a77447d9a4615fa2059c35a5c0486c77)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df066d7b0db7ed5c4b08dc654a4540be1f8fd6eaa1580c9ff1e18e665b626ea0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8314232ec1a54288a5583d3ea09c9131a0c392f6bc088a01c1cd83f6ef2146c6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fdc9d0b9815b9887fcdf2d39f4ead91cafdca0742158d93afb8c85f2029de408)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a21a1b312c83c23c8b2acb83d61f4904df1754adcf864c5196f51eed5a73a1fa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsHsv]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsHsv]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsHsv]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e2affe4b3204be90b4d35712ae48a2d16119c7086fd19ddeffbe864859665849)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfDimension",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "dimension": "dimension",
        "dimension_var": "dimensionVar",
        "equal": "equal",
        "greater_than": "greaterThan",
        "less_than": "lessThan",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfDimension:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfDimensionDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        dimension: typing.Optional[builtins.str] = None,
        dimension_var: typing.Optional[builtins.str] = None,
        equal: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfDimensionEqual", typing.Dict[builtins.str, typing.Any]]] = None,
        greater_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfDimensionGreaterThan", typing.Dict[builtins.str, typing.Any]]] = None,
        less_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfDimensionLessThan", typing.Dict[builtins.str, typing.Any]]] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param dimension: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        :param dimension_var: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        :param equal: equal block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        :param greater_than: greater_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        :param less_than: less_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        :param value: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfDimensionDefault(**default)
        if isinstance(equal, dict):
            equal = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfDimensionEqual(**equal)
        if isinstance(greater_than, dict):
            greater_than = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfDimensionGreaterThan(**greater_than)
        if isinstance(less_than, dict):
            less_than = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfDimensionLessThan(**less_than)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a8faf5acd5c266f445c86f45b9ba90ed09a5f78d3af19da453b18cbc2d61f809)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument dimension", value=dimension, expected_type=type_hints["dimension"])
            check_type(argname="argument dimension_var", value=dimension_var, expected_type=type_hints["dimension_var"])
            check_type(argname="argument equal", value=equal, expected_type=type_hints["equal"])
            check_type(argname="argument greater_than", value=greater_than, expected_type=type_hints["greater_than"])
            check_type(argname="argument less_than", value=less_than, expected_type=type_hints["less_than"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if dimension is not None:
            self._values["dimension"] = dimension
        if dimension_var is not None:
            self._values["dimension_var"] = dimension_var
        if equal is not None:
            self._values["equal"] = equal
        if greater_than is not None:
            self._values["greater_than"] = greater_than
        if less_than is not None:
            self._values["less_than"] = less_than
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfDimensionDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfDimensionDefault"], result)

    @builtins.property
    def dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        '''
        result = self._values.get("dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        '''
        result = self._values.get("dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def equal(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfDimensionEqual"]:
        '''equal block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        '''
        result = self._values.get("equal")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfDimensionEqual"], result)

    @builtins.property
    def greater_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfDimensionGreaterThan"]:
        '''greater_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        '''
        result = self._values.get("greater_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfDimensionGreaterThan"], result)

    @builtins.property
    def less_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfDimensionLessThan"]:
        '''less_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        '''
        result = self._values.get("less_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfDimensionLessThan"], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfDimension(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfDimensionDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfDimensionDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfDimensionDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfDimensionDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfDimensionDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__94ffe5a593ecf6d3d1ccd644bcac2bee3eccdbdfee2447bff9b930cc5f41473a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfDimensionDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfDimensionDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a7b46e263b2b70ba40d1a443b5336c8c110d243a88dd31946f36c8730321952)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfDimensionEqual",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfDimensionEqual:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfDimensionEqual(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfDimensionEqualOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfDimensionEqualOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__683db23bd6ccf1645442f608a227b84d742120d493696d029585028abdd01c09)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfDimensionEqual], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfDimensionEqual],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6065fc3dc84a094dd37236b76047c807fdb256943f873978f9d920466ada9c0a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfDimensionGreaterThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfDimensionGreaterThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfDimensionGreaterThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfDimensionGreaterThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfDimensionGreaterThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eef1b7f5fa423bb0011af31e4e1af1f483106e64ced2a3e96a2a52f2b4e6772a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfDimensionGreaterThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfDimensionGreaterThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__111d3ae73eb295d0b2ed2c5c3760577456f0537a65655c74f5832b6e3c7d12f5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfDimensionLessThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfDimensionLessThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfDimensionLessThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfDimensionLessThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfDimensionLessThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__298881d9f5fba807bff3d22ea5a8f3b95604842fbd13d5e6ee15936e3022c43b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfDimensionLessThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfDimensionLessThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d1d8675c7cf75c0abc5d2fba3a0c6204eac2ef07b759151140df15c6345a80a0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfDimensionList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfDimensionList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ce1c7f991e00b12b0f52a2b0a05b295723790b8841e2e9ce2d3547de3694b910)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfDimensionOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d1d85370712bb03156aca3339325a778d22c81f58159379e09e3734f861e815)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfDimensionOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0bb1bacf1c38c8011152ea26c834b7ea9149f9fb11823a3d25b880182eb67d57)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6860c0d30c0d044fbeb22583cd23ec8dc8ef68b46a6c70152b6cf54153e4df92)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__99fc7c7de8dc0bce540314618f065c142719a878c79266135e8024e2fc21bfa2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfDimension]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfDimension]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a4753d87cb5fd4128abc17645e470f01a761b3e29d9eada13229f481d6954e1e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfDimensionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfDimensionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__acf8e989fd1ac1b2b822c5997444b9847743d8c5a3c38319d093a9e2c7c4d1e6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfDimensionDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putEqual")
    def put_equal(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfDimensionEqual()

        return typing.cast(None, jsii.invoke(self, "putEqual", [value]))

    @jsii.member(jsii_name="putGreaterThan")
    def put_greater_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfDimensionGreaterThan()

        return typing.cast(None, jsii.invoke(self, "putGreaterThan", [value]))

    @jsii.member(jsii_name="putLessThan")
    def put_less_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfDimensionLessThan()

        return typing.cast(None, jsii.invoke(self, "putLessThan", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetDimension")
    def reset_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimension", []))

    @jsii.member(jsii_name="resetDimensionVar")
    def reset_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimensionVar", []))

    @jsii.member(jsii_name="resetEqual")
    def reset_equal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEqual", []))

    @jsii.member(jsii_name="resetGreaterThan")
    def reset_greater_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGreaterThan", []))

    @jsii.member(jsii_name="resetLessThan")
    def reset_less_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLessThan", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfDimensionDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfDimensionDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="equal")
    def equal(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfDimensionEqualOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfDimensionEqualOutputReference, jsii.get(self, "equal"))

    @builtins.property
    @jsii.member(jsii_name="greaterThan")
    def greater_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfDimensionGreaterThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfDimensionGreaterThanOutputReference, jsii.get(self, "greaterThan"))

    @builtins.property
    @jsii.member(jsii_name="lessThan")
    def less_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfDimensionLessThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfDimensionLessThanOutputReference, jsii.get(self, "lessThan"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfDimensionDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionInput")
    def dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionVarInput")
    def dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="equalInput")
    def equal_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfDimensionEqual], jsii.get(self, "equalInput"))

    @builtins.property
    @jsii.member(jsii_name="greaterThanInput")
    def greater_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfDimensionGreaterThan], jsii.get(self, "greaterThanInput"))

    @builtins.property
    @jsii.member(jsii_name="lessThanInput")
    def less_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfDimensionLessThan], jsii.get(self, "lessThanInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="dimension")
    def dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimension"))

    @dimension.setter
    def dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a03f51295c832517e0b9e7aaf23fb06803315db01ad703ac4696f5f5fd441c63)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimension", value)

    @builtins.property
    @jsii.member(jsii_name="dimensionVar")
    def dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimensionVar"))

    @dimension_var.setter
    def dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cb2e5b67c9c56ddf735fe09025863bd56d365b05fe5482db5dde817859ff2e9a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1b8c5496668dca36776b7a2f83a841b3ec21fff2002d246c4f87a18ae5f03873)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ae3d2fd7b51a6950bd3f86b1d82e1b0ff08f985cf6a8bdada6854846c0e4955f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfDimension]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfDimension]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfDimension]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4fe2a474f909b7692d91c541aa5f8cf026e5b42b1bd948b16fdbad9e599bd480)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfOrientation",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "landscape": "landscape",
        "portrait": "portrait",
        "square": "square",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfOrientation:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfOrientationDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        landscape: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfOrientationLandscape", typing.Dict[builtins.str, typing.Any]]] = None,
        portrait: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfOrientationPortrait", typing.Dict[builtins.str, typing.Any]]] = None,
        square: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfOrientationSquare", typing.Dict[builtins.str, typing.Any]]] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param landscape: landscape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        :param portrait: portrait block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        :param square: square block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfOrientationDefault(**default)
        if isinstance(landscape, dict):
            landscape = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfOrientationLandscape(**landscape)
        if isinstance(portrait, dict):
            portrait = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfOrientationPortrait(**portrait)
        if isinstance(square, dict):
            square = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfOrientationSquare(**square)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a7d26466f323221e8d8e557e75293c8f05bd7f1bc8147436a170c57d8f50f148)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument landscape", value=landscape, expected_type=type_hints["landscape"])
            check_type(argname="argument portrait", value=portrait, expected_type=type_hints["portrait"])
            check_type(argname="argument square", value=square, expected_type=type_hints["square"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if landscape is not None:
            self._values["landscape"] = landscape
        if portrait is not None:
            self._values["portrait"] = portrait
        if square is not None:
            self._values["square"] = square

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfOrientationDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfOrientationDefault"], result)

    @builtins.property
    def landscape(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfOrientationLandscape"]:
        '''landscape block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        '''
        result = self._values.get("landscape")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfOrientationLandscape"], result)

    @builtins.property
    def portrait(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfOrientationPortrait"]:
        '''portrait block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        '''
        result = self._values.get("portrait")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfOrientationPortrait"], result)

    @builtins.property
    def square(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfOrientationSquare"]:
        '''square block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        result = self._values.get("square")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfOrientationSquare"], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfOrientation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfOrientationDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfOrientationDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfOrientationDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfOrientationDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfOrientationDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__686e22ccc7f609cc6c3bcccdfbeffe1f018d85b74559212c83dde490846dc2d1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfOrientationDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfOrientationDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df2af4eb017fa15d0dcb060925718c2812b9f4738c0c69f386393d03a8cc6874)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfOrientationLandscape",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfOrientationLandscape:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfOrientationLandscape(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfOrientationLandscapeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfOrientationLandscapeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc74dffc9757d2e2b2bd3b21af6d4c1621a85e2c0ea1f046afee5fce01e760e0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfOrientationLandscape], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfOrientationLandscape],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7eefbca0da177401aff14ea82d4d8b03d933e35d2adad73a44c34660015292a8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfOrientationList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfOrientationList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d52409374b171fc3dc6f34a4e0c84d1be3f7742f513e2a60aaa0ece96009da07)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfOrientationOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0a9acd91169eb290a3e601ba152f7011075720b62e2fc0e7c3dffbbf95e45d5d)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfOrientationOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__154a355ada5c32de5d7ef8d5b3413ddc78401ff4353fc296a87fe99c67e001a7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__23a9563f4e73b15cf07b1a813ca982c70bec347e0749875578d22e8f78abdb15)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cb931d36c23b9259bce5c30db7b590436ceb66243d513f30fb35dc307620f6fe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfOrientation]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfOrientation]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c1a32f00af1f10d41c134a7e27e2ebf4eaa420f663d6a844d6f08120241c6a45)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfOrientationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfOrientationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f015b37524fd1b0601d280b98f7fed74f832ae2366892fce56485c2ea17dd55)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfOrientationDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putLandscape")
    def put_landscape(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfOrientationLandscape()

        return typing.cast(None, jsii.invoke(self, "putLandscape", [value]))

    @jsii.member(jsii_name="putPortrait")
    def put_portrait(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfOrientationPortrait()

        return typing.cast(None, jsii.invoke(self, "putPortrait", [value]))

    @jsii.member(jsii_name="putSquare")
    def put_square(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfOrientationSquare()

        return typing.cast(None, jsii.invoke(self, "putSquare", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetLandscape")
    def reset_landscape(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLandscape", []))

    @jsii.member(jsii_name="resetPortrait")
    def reset_portrait(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPortrait", []))

    @jsii.member(jsii_name="resetSquare")
    def reset_square(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSquare", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfOrientationDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfOrientationDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="landscape")
    def landscape(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfOrientationLandscapeOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfOrientationLandscapeOutputReference, jsii.get(self, "landscape"))

    @builtins.property
    @jsii.member(jsii_name="portrait")
    def portrait(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfOrientationPortraitOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfOrientationPortraitOutputReference", jsii.get(self, "portrait"))

    @builtins.property
    @jsii.member(jsii_name="square")
    def square(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfOrientationSquareOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfOrientationSquareOutputReference", jsii.get(self, "square"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfOrientationDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="landscapeInput")
    def landscape_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfOrientationLandscape], jsii.get(self, "landscapeInput"))

    @builtins.property
    @jsii.member(jsii_name="portraitInput")
    def portrait_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfOrientationPortrait"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfOrientationPortrait"], jsii.get(self, "portraitInput"))

    @builtins.property
    @jsii.member(jsii_name="squareInput")
    def square_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfOrientationSquare"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfOrientationSquare"], jsii.get(self, "squareInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfOrientation]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfOrientation]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfOrientation]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__efbad3bdc722af82261cd80bd6bea852f1836860e63cad8936d738fcc828342f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfOrientationPortrait",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfOrientationPortrait:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfOrientationPortrait(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfOrientationPortraitOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfOrientationPortraitOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a246283e99c772356c14b192f0aa61dd3a12f8fb3d536e07d89d86387b7ce686)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfOrientationPortrait]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfOrientationPortrait], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfOrientationPortrait],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a29b86f73558e47c0138c372296cefbf925b58b6078363ea76f8534a4fe9438)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfOrientationSquare",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfOrientationSquare:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfOrientationSquare(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfOrientationSquareOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfOrientationSquareOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__482ed60a77db2c345910faebdc7534e3e7c1a782cd6f3ea9ce0ebb4b574f0c6a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfOrientationSquare]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfOrientationSquare], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfOrientationSquare],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4f9b4eaa38db01bbe14a3d68b53a19db3b4add30dfda7f81f1a69f4e32977c3b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__521ed6e99694f478f51ec44af4e3caf4039d0a5e175c18bc3c6a9d076641a51a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b4c8b74f9df560129ecd77401a9c4a5c4dbfaf4ab9e62fed461dde0f9e636564)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1b94c16563f7d353bbabebbeed3ef87acfef9b9fb2582bb54f540bf736a04984)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e79ee11dc3922a977525f5e71f8e467dc54aa22b2571c135af518968d1a43d3c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__80c9806fb114b074bb62bf8d5c8b3c7aa13acd905a1644597154fd9c1a65cae0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformations]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformations]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformations]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__133e5e59e92bacfc94db7ed7988882783a2ff5bd80610f7d6a566695d6474693)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsMaxColors",
    jsii_struct_bases=[],
    name_mapping={"colors": "colors", "colors_var": "colorsVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsMaxColors:
    def __init__(
        self,
        *,
        colors: typing.Optional[builtins.str] = None,
        colors_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param colors: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        :param colors_var: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__adb9e2bc35aeb80d68e3d9e0e7d1603e6b8cffdaf1446672190ff9fe2060a6a1)
            check_type(argname="argument colors", value=colors, expected_type=type_hints["colors"])
            check_type(argname="argument colors_var", value=colors_var, expected_type=type_hints["colors_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if colors is not None:
            self._values["colors"] = colors
        if colors_var is not None:
            self._values["colors_var"] = colors_var

    @builtins.property
    def colors(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        '''
        result = self._values.get("colors")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def colors_var(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        result = self._values.get("colors_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsMaxColors(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsMaxColorsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsMaxColorsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a025a175a323f4cffbfee6847667ca741299daddf4ed54716a09ae0fa34b5e63)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsMaxColorsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7e1b8cee1af4db9f1ab4eb57aca8e5419ef75fae7429af81412a115964f7ec9e)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsMaxColorsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__43789855ee69dcc26ba06aa5511d8d93cd8e461135e7b372862c8ace568fb241)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__05df3334a4773ef6068473477c403aaf1285fe6e4a4a160f495af1caf9091c93)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__527e0c5caa861a2bfc1b87dab046bdeaae20859738313f08e2d7757d549e7ca5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsMaxColors]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsMaxColors]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__faf459ce02eba9a72d8f0514a279f41f94d6d30727b27b50288d036a87908a3e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsMaxColorsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsMaxColorsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__02343f901bf4585d8c68b6885b50c6438da95319e87dcbb421ca2c1accacaaeb)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColors")
    def reset_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColors", []))

    @jsii.member(jsii_name="resetColorsVar")
    def reset_colors_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorsVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorsInput")
    def colors_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsInput"))

    @builtins.property
    @jsii.member(jsii_name="colorsVarInput")
    def colors_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsVarInput"))

    @builtins.property
    @jsii.member(jsii_name="colors")
    def colors(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colors"))

    @colors.setter
    def colors(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b974a16aee06ca3f2ef742a53c5a35e9d20716692ddd195778f36fca2c90ddf0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colors", value)

    @builtins.property
    @jsii.member(jsii_name="colorsVar")
    def colors_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorsVar"))

    @colors_var.setter
    def colors_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__03c64f87468e7a588f97facb9249d307da0ff58a1bd3b7164c8e380f258874ef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorsVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsMaxColors]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsMaxColors]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsMaxColors]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__748ab5330abd85d0b9ca7fb6397d864bb168ddf88850203b5ff16b93c9091ae5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsMirror",
    jsii_struct_bases=[],
    name_mapping={
        "horizontal": "horizontal",
        "horizontal_var": "horizontalVar",
        "vertical": "vertical",
        "vertical_var": "verticalVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsMirror:
    def __init__(
        self,
        *,
        horizontal: typing.Optional[builtins.str] = None,
        horizontal_var: typing.Optional[builtins.str] = None,
        vertical: typing.Optional[builtins.str] = None,
        vertical_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param horizontal: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        :param horizontal_var: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        :param vertical: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        :param vertical_var: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bee64f8218d4cba23a139105377df618dec07daf59011976054bd9c88de0adc2)
            check_type(argname="argument horizontal", value=horizontal, expected_type=type_hints["horizontal"])
            check_type(argname="argument horizontal_var", value=horizontal_var, expected_type=type_hints["horizontal_var"])
            check_type(argname="argument vertical", value=vertical, expected_type=type_hints["vertical"])
            check_type(argname="argument vertical_var", value=vertical_var, expected_type=type_hints["vertical_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if horizontal is not None:
            self._values["horizontal"] = horizontal
        if horizontal_var is not None:
            self._values["horizontal_var"] = horizontal_var
        if vertical is not None:
            self._values["vertical"] = vertical
        if vertical_var is not None:
            self._values["vertical_var"] = vertical_var

    @builtins.property
    def horizontal(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        '''
        result = self._values.get("horizontal")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def horizontal_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        '''
        result = self._values.get("horizontal_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        '''
        result = self._values.get("vertical")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        result = self._values.get("vertical_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsMirror(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsMirrorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsMirrorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__32d6ac89ce5bf9a7fe907e57a15daf77333f7a5fe24fe798da5867db47140597)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsMirrorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a6240fc42d13b0be06852e23a5f22a5eb14a7097fd0eb23c40f8df10981bb337)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsMirrorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__79ab19af80b96ba0d80b1de8c446c06cd9cc45422391f5e9a0e9535c0bc41d84)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f0256876960bfb150be96503e35dbf116a7426ffd64bd384b5ebe6fb95d09011)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac0255b652b79e2c3ba3d25a6590e42d94a5be632759a3d8db4259092b84df26)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsMirror]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsMirror]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a4f4c1539b6ee585aa34a7d313011a50588fe87b740ccad594b22fae1acb69eb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsMirrorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsMirrorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__679036a766d7211727e5608cab45fafb33ef61399ba8dbb7ecae93dc0db4d17c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHorizontal")
    def reset_horizontal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontal", []))

    @jsii.member(jsii_name="resetHorizontalVar")
    def reset_horizontal_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontalVar", []))

    @jsii.member(jsii_name="resetVertical")
    def reset_vertical(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVertical", []))

    @jsii.member(jsii_name="resetVerticalVar")
    def reset_vertical_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVerticalVar", []))

    @builtins.property
    @jsii.member(jsii_name="horizontalInput")
    def horizontal_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontalVarInput")
    def horizontal_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalInput")
    def vertical_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalVarInput")
    def vertical_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontal")
    def horizontal(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontal"))

    @horizontal.setter
    def horizontal(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1bea1d7dabc98c9b08eeea8e6b1cd5a0496843ce2bfe81a38af7e1dfe91e5986)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontal", value)

    @builtins.property
    @jsii.member(jsii_name="horizontalVar")
    def horizontal_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontalVar"))

    @horizontal_var.setter
    def horizontal_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__24d3f6b1aada8f721b7a117ffbb83e54b16d878056029800acd5350bda30f7df)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontalVar", value)

    @builtins.property
    @jsii.member(jsii_name="vertical")
    def vertical(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "vertical"))

    @vertical.setter
    def vertical(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__63000b4acc643dc294b35a362cb50cf1bfd169204b5bfbf85eb8485a2bcf4ed8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "vertical", value)

    @builtins.property
    @jsii.member(jsii_name="verticalVar")
    def vertical_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "verticalVar"))

    @vertical_var.setter
    def vertical_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5bd5f524800c3dfd3e6d710f49b76ec968389eef359feab015c909d4c1a24493)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "verticalVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsMirror]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsMirror]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsMirror]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__72419afda8348f2ca45cc1ecb08ce5ec916d2189b80bf22e6499cfa7214292d8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsMonoHue",
    jsii_struct_bases=[],
    name_mapping={"hue": "hue", "hue_var": "hueVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsMonoHue:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__628aafa195504b0075c5402079b0e137f326e21b8daa8f1ef07db6d59fac27fd)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsMonoHue(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsMonoHueList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsMonoHueList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__933ba4ae81e35ed4bf4258fc7613546e2366ad7706fc41366a6d67c86f8c0c21)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsMonoHueOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__649ddeaa8ac8aaceddedcf0c0b812dd56a9db7d801fc9b9ba000ee4c8c9a1d04)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsMonoHueOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7a9b1e3c79ca52e44b803066eb81e0fed1bb3a710fc0a34706fcd41c3e00188a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ba2d607e989ebf4258c85298adf76f9bc9614bbea8d9b5feadc93035db99c08)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__98e82205e67feff4d3dca721e6074ec4c208a4dfdd16d7ba6d2228aed04b030e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsMonoHue]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsMonoHue]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__184c7054f70f1b2183338f528b8d7cca0d66b5e3917ef8223d725d513399491a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsMonoHueOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsMonoHueOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3e1e8ee4f7e074659e1c23c607c538fd0f13fe09a6e633389b3ee68bc336c880)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e49ad97a84f4bfeb4f0a1dd15cdab9155c943e79d242010089bcaf5276cf333f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4c1b0cb138fe23f600fdc71c910457d133050452d7edd1ecb0d9c15e90547d8a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsMonoHue]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsMonoHue]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsMonoHue]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0bba1a0b78ab31cf268fd1256a162157c2e63941a16441bccec9da96147f4593)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsOpacity",
    jsii_struct_bases=[],
    name_mapping={"opacity": "opacity", "opacity_var": "opacityVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsOpacity:
    def __init__(
        self,
        *,
        opacity: typing.Optional[builtins.str] = None,
        opacity_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param opacity: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param opacity_var: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1224b3f912adaa3256f391fb784f4d2f5ee8bf72fbc4ff69d741ab9b7f131877)
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument opacity_var", value=opacity_var, expected_type=type_hints["opacity_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if opacity is not None:
            self._values["opacity"] = opacity
        if opacity_var is not None:
            self._values["opacity_var"] = opacity_var

    @builtins.property
    def opacity(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def opacity_var(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        result = self._values.get("opacity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsOpacity(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsOpacityList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsOpacityList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__28b30a4c4438e94ed4b372bb0d2461178913b21460296eed6b26404315327414)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsOpacityOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4e15ee191ef78d98e65d2b9b68f3994e9b9e7f93358faaf251c537257b09c4ae)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsOpacityOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d5efc5748ed7d725d839e5aa75dd1872d5f25c33141b157f9ff0054176676d56)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__05b065e6794d982eb6071a1edda903f2fca5b1643edca9c494bdf39522bbd2f1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3f1ddd626013d3d113f79dcf428822f52c05c9bd2b2e9872e70bfc8abf3aa70c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsOpacity]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsOpacity]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c5e9c43398889930b2beb2ca78dccf974ac14209c16ad451253e91eb5bc090a1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsOpacityOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsOpacityOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5fa65f3b0fb769e21022216e2a7dc3cfa12a58cfbf97ecd115691a105737681c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetOpacityVar")
    def reset_opacity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacityVar", []))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityVarInput")
    def opacity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacity"))

    @opacity.setter
    def opacity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__06a2e9bd4ae8ffeec3c8b5d9049189d3f09ef77f9672e0e4295efc4ff3e041d0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacity", value)

    @builtins.property
    @jsii.member(jsii_name="opacityVar")
    def opacity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacityVar"))

    @opacity_var.setter
    def opacity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab36381bef263ed4ed81381e9690a6d3f2e545c003764ba221f5d1343879fdb9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacityVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsOpacity]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsOpacity]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsOpacity]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e7dcf847613805e15f6052c288cc0603f1eee3d40ad99ecfda429d8a36b245e0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1e1f0e9dcc4c47f3e858935aa103ade4e8ab6db32dfde4442b06aea8059422ce)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putBackgroundColor")
    def put_background_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7edf63bca3e0476344699d288d0546cad15dd4b594606542a0a449c6f49cc5c2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBackgroundColor", [value]))

    @jsii.member(jsii_name="putBlur")
    def put_blur(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsBlur, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__59bcf412ac44cf15f470b1af630fd89db27eec99f2b33f4b88da81d6768d09b7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBlur", [value]))

    @jsii.member(jsii_name="putChromaKey")
    def put_chroma_key(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsChromaKey, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dfbcfc4ad6716b40d78041a4d44c0802c21d7c0db764a1e340710ee674c9e108)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putChromaKey", [value]))

    @jsii.member(jsii_name="putComposite")
    def put_composite(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsComposite, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bfc3c7a5d081d6a530d6d44f2db2bc1f60a201a34ceb08310a5e7f5611d30dba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putComposite", [value]))

    @jsii.member(jsii_name="putCompound")
    def put_compound(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsCompound, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c91fa0bbda942264abf9644f13f3e98c584100a1b62bdbc10675ee362949f058)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCompound", [value]))

    @jsii.member(jsii_name="putContrast")
    def put_contrast(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsContrast, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__68ba6a1cd351caf6c6b66b7104dd3de80a319bfdac58992da3c57342035f52b3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putContrast", [value]))

    @jsii.member(jsii_name="putGoop")
    def put_goop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsGoop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f95ae4630f75635650f37be934d4f2249e74fea859aef99bcaf6c3045734d44c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGoop", [value]))

    @jsii.member(jsii_name="putGrayscale")
    def put_grayscale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsGrayscale, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7dd3af9038a64a27d4d48765b02bd6c39ff3608f8bd129c2de08263f2c279b7c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGrayscale", [value]))

    @jsii.member(jsii_name="putHsl")
    def put_hsl(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsHsl, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0a5e358ea4c27ae8a8771510f328d2966f159b8cb44bc0247f16f0eff9e87971)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsl", [value]))

    @jsii.member(jsii_name="putHsv")
    def put_hsv(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsHsv, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9c076a9e029749285c72d8f3b9d33e2ffcc8364ea9f7711759919293ff5f24c2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsv", [value]))

    @jsii.member(jsii_name="putIfDimension")
    def put_if_dimension(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfDimension, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__22d52df2c8756b67c039b86b3a8b2e5d5ccf27867a0fb73ad35b74c03012cd68)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfDimension", [value]))

    @jsii.member(jsii_name="putIfOrientation")
    def put_if_orientation(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__51db7890b2f05a3e43e30b1561ee765e641c80274503a08844618069d4b04427)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfOrientation", [value]))

    @jsii.member(jsii_name="putMaxColors")
    def put_max_colors(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsMaxColors, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1b4b88f29676145cc31426b284d58107074cb28d6aa9671343477e96b22f5f81)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMaxColors", [value]))

    @jsii.member(jsii_name="putMirror")
    def put_mirror(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsMirror, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d396d4ef85bc9fb572c1c459412a9b59d2a458307df600b9d4a76c6626cfbea6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMirror", [value]))

    @jsii.member(jsii_name="putMonoHue")
    def put_mono_hue(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsMonoHue, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__164d2a4cebf3ed0110d2220f98859d9796712c4fb14c852ab33269458a24b188)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMonoHue", [value]))

    @jsii.member(jsii_name="putOpacity")
    def put_opacity(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsOpacity, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f0daa28bdaa48ddc58872671b47f60e1133e9abc61f088299c03d89a0138de3e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putOpacity", [value]))

    @jsii.member(jsii_name="putRemoveColor")
    def put_remove_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsRemoveColor", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__01ef8aef6667a1e25f530665f3a1d8368310e4d6ebe4c1bca8bc975118572b9f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRemoveColor", [value]))

    @jsii.member(jsii_name="putUnsharpMask")
    def put_unsharp_mask(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsUnsharpMask", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__95ef975b8929b2db583c227d00e276e2923a044158cd8b6416e5c5b508666466)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putUnsharpMask", [value]))

    @jsii.member(jsii_name="resetBackgroundColor")
    def reset_background_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBackgroundColor", []))

    @jsii.member(jsii_name="resetBlur")
    def reset_blur(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBlur", []))

    @jsii.member(jsii_name="resetChromaKey")
    def reset_chroma_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChromaKey", []))

    @jsii.member(jsii_name="resetComposite")
    def reset_composite(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetComposite", []))

    @jsii.member(jsii_name="resetCompound")
    def reset_compound(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCompound", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetGoop")
    def reset_goop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGoop", []))

    @jsii.member(jsii_name="resetGrayscale")
    def reset_grayscale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGrayscale", []))

    @jsii.member(jsii_name="resetHsl")
    def reset_hsl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsl", []))

    @jsii.member(jsii_name="resetHsv")
    def reset_hsv(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsv", []))

    @jsii.member(jsii_name="resetIfDimension")
    def reset_if_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfDimension", []))

    @jsii.member(jsii_name="resetIfOrientation")
    def reset_if_orientation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfOrientation", []))

    @jsii.member(jsii_name="resetMaxColors")
    def reset_max_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxColors", []))

    @jsii.member(jsii_name="resetMirror")
    def reset_mirror(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMirror", []))

    @jsii.member(jsii_name="resetMonoHue")
    def reset_mono_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonoHue", []))

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetRemoveColor")
    def reset_remove_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRemoveColor", []))

    @jsii.member(jsii_name="resetUnsharpMask")
    def reset_unsharp_mask(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUnsharpMask", []))

    @builtins.property
    @jsii.member(jsii_name="backgroundColor")
    def background_color(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsBackgroundColorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsBackgroundColorList, jsii.get(self, "backgroundColor"))

    @builtins.property
    @jsii.member(jsii_name="blur")
    def blur(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsBlurList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsBlurList, jsii.get(self, "blur"))

    @builtins.property
    @jsii.member(jsii_name="chromaKey")
    def chroma_key(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsChromaKeyList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsChromaKeyList, jsii.get(self, "chromaKey"))

    @builtins.property
    @jsii.member(jsii_name="composite")
    def composite(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsCompositeList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsCompositeList, jsii.get(self, "composite"))

    @builtins.property
    @jsii.member(jsii_name="compound")
    def compound(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsCompoundList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsCompoundList, jsii.get(self, "compound"))

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsContrastList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsContrastList, jsii.get(self, "contrast"))

    @builtins.property
    @jsii.member(jsii_name="goop")
    def goop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsGoopList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsGoopList, jsii.get(self, "goop"))

    @builtins.property
    @jsii.member(jsii_name="grayscale")
    def grayscale(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsGrayscaleList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsGrayscaleList, jsii.get(self, "grayscale"))

    @builtins.property
    @jsii.member(jsii_name="hsl")
    def hsl(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsHslList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsHslList, jsii.get(self, "hsl"))

    @builtins.property
    @jsii.member(jsii_name="hsv")
    def hsv(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsHsvList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsHsvList, jsii.get(self, "hsv"))

    @builtins.property
    @jsii.member(jsii_name="ifDimension")
    def if_dimension(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfDimensionList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfDimensionList, jsii.get(self, "ifDimension"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientation")
    def if_orientation(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfOrientationList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfOrientationList, jsii.get(self, "ifOrientation"))

    @builtins.property
    @jsii.member(jsii_name="maxColors")
    def max_colors(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsMaxColorsList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsMaxColorsList, jsii.get(self, "maxColors"))

    @builtins.property
    @jsii.member(jsii_name="mirror")
    def mirror(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsMirrorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsMirrorList, jsii.get(self, "mirror"))

    @builtins.property
    @jsii.member(jsii_name="monoHue")
    def mono_hue(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsMonoHueList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsMonoHueList, jsii.get(self, "monoHue"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsOpacityList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsOpacityList, jsii.get(self, "opacity"))

    @builtins.property
    @jsii.member(jsii_name="removeColor")
    def remove_color(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsRemoveColorList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsRemoveColorList", jsii.get(self, "removeColor"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMask")
    def unsharp_mask(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsUnsharpMaskList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsUnsharpMaskList", jsii.get(self, "unsharpMask"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColorInput")
    def background_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsBackgroundColor]]], jsii.get(self, "backgroundColorInput"))

    @builtins.property
    @jsii.member(jsii_name="blurInput")
    def blur_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsBlur]]], jsii.get(self, "blurInput"))

    @builtins.property
    @jsii.member(jsii_name="chromaKeyInput")
    def chroma_key_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsChromaKey]]], jsii.get(self, "chromaKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="compositeInput")
    def composite_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsComposite]]], jsii.get(self, "compositeInput"))

    @builtins.property
    @jsii.member(jsii_name="compoundInput")
    def compound_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsCompound]]], jsii.get(self, "compoundInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsContrast]]], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="goopInput")
    def goop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsGoop]]], jsii.get(self, "goopInput"))

    @builtins.property
    @jsii.member(jsii_name="grayscaleInput")
    def grayscale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsGrayscale]]], jsii.get(self, "grayscaleInput"))

    @builtins.property
    @jsii.member(jsii_name="hslInput")
    def hsl_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsHsl]]], jsii.get(self, "hslInput"))

    @builtins.property
    @jsii.member(jsii_name="hsvInput")
    def hsv_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsHsv]]], jsii.get(self, "hsvInput"))

    @builtins.property
    @jsii.member(jsii_name="ifDimensionInput")
    def if_dimension_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfDimension]]], jsii.get(self, "ifDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientationInput")
    def if_orientation_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfOrientation]]], jsii.get(self, "ifOrientationInput"))

    @builtins.property
    @jsii.member(jsii_name="maxColorsInput")
    def max_colors_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsMaxColors]]], jsii.get(self, "maxColorsInput"))

    @builtins.property
    @jsii.member(jsii_name="mirrorInput")
    def mirror_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsMirror]]], jsii.get(self, "mirrorInput"))

    @builtins.property
    @jsii.member(jsii_name="monoHueInput")
    def mono_hue_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsMonoHue]]], jsii.get(self, "monoHueInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsOpacity]]], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="removeColorInput")
    def remove_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsRemoveColor"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsRemoveColor"]]], jsii.get(self, "removeColorInput"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMaskInput")
    def unsharp_mask_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsUnsharpMask"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsUnsharpMask"]]], jsii.get(self, "unsharpMaskInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformations]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformations]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformations]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__76bfcf03a45e606a343db4321434ad4dec6606c2f65ba407a7dfb4fa0b312499)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsRemoveColor",
    jsii_struct_bases=[],
    name_mapping={
        "color": "color",
        "color_var": "colorVar",
        "feather": "feather",
        "feather_var": "featherVar",
        "tolerance": "tolerance",
        "tolerance_var": "toleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsRemoveColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
        feather: typing.Optional[builtins.str] = None,
        feather_var: typing.Optional[builtins.str] = None,
        tolerance: typing.Optional[builtins.str] = None,
        tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        :param feather: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        :param feather_var: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        :param tolerance: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        :param tolerance_var: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__15945c450a86c62cc15d66d963c97540317eb86d71065dd158a0238fff0dc5e8)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
            check_type(argname="argument feather", value=feather, expected_type=type_hints["feather"])
            check_type(argname="argument feather_var", value=feather_var, expected_type=type_hints["feather_var"])
            check_type(argname="argument tolerance", value=tolerance, expected_type=type_hints["tolerance"])
            check_type(argname="argument tolerance_var", value=tolerance_var, expected_type=type_hints["tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var
        if feather is not None:
            self._values["feather"] = feather
        if feather_var is not None:
            self._values["feather_var"] = feather_var
        if tolerance is not None:
            self._values["tolerance"] = tolerance
        if tolerance_var is not None:
            self._values["tolerance_var"] = tolerance_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        '''
        result = self._values.get("feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather_var(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        '''
        result = self._values.get("feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        '''
        result = self._values.get("tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance_var(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        result = self._values.get("tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsRemoveColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsRemoveColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsRemoveColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8b09f19175da03814d5faf9533da780ef5900396ba3912cb2690be1fcdd27209)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsRemoveColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e04affc4d9db8fec44948cab63af99c8b7853e878d654cc1bd25a2fdc6d37667)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsRemoveColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9fc5723ea6e7d1cc2a6765b57a837ed6bb3ace8d20a44a46a600d84d6054846a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa1f6e1212e7a76a8031c545438d57edaa65f1c63eb070c031b592dabd7831aa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa5c7ad8f68d6c998a9d6d151de1d55cd0ad95202210c5e947059135f06046c5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsRemoveColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsRemoveColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsRemoveColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8b24865e0f1dff25533dc835850562f983b821b3d7beead0b92f1cf931bf745b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsRemoveColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsRemoveColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__13372854a08e4208eeddb221e7067d1b1c86c38b0f1473950ff289513fab47da)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @jsii.member(jsii_name="resetFeather")
    def reset_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeather", []))

    @jsii.member(jsii_name="resetFeatherVar")
    def reset_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatherVar", []))

    @jsii.member(jsii_name="resetTolerance")
    def reset_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTolerance", []))

    @jsii.member(jsii_name="resetToleranceVar")
    def reset_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featherInput")
    def feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherInput"))

    @builtins.property
    @jsii.member(jsii_name="featherVarInput")
    def feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceInput")
    def tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceVarInput")
    def tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__52abcfa2c6f6d90a5f2dd8a04e9c15b1c0dd1c9fefdaca41e9022aca22903e1e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6623bfc653ce464d9b27e4b0b0297691dc8736a3b7079483836ff6c24c48af1e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="feather")
    def feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "feather"))

    @feather.setter
    def feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7e3589196e63a8e9458cb5a7095cfa6fef23fa70957a0ba3e793897dfa26e7c7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "feather", value)

    @builtins.property
    @jsii.member(jsii_name="featherVar")
    def feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featherVar"))

    @feather_var.setter
    def feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__42ad2287a9c12336f1282a2026ff4ef73c8d768f5a0ad484902d97df81d03b50)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featherVar", value)

    @builtins.property
    @jsii.member(jsii_name="tolerance")
    def tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tolerance"))

    @tolerance.setter
    def tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__acf8214d23a2a1c17cbc1bf0619b727b7d2bfa3ef4bc55a56ed0a4e5f53e5d09)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tolerance", value)

    @builtins.property
    @jsii.member(jsii_name="toleranceVar")
    def tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "toleranceVar"))

    @tolerance_var.setter
    def tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b245c056187fad9c9c9199207010f583b226897a88470dbd20c5da17b70c8467)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "toleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsRemoveColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsRemoveColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsRemoveColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3cfa7bd4e023547ba057466c50e6b10d81eee389d8c429b0a74ddc135dd68aa1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsUnsharpMask",
    jsii_struct_bases=[],
    name_mapping={
        "gain": "gain",
        "gain_var": "gainVar",
        "sigma": "sigma",
        "sigma_var": "sigmaVar",
        "threshold": "threshold",
        "threshold_var": "thresholdVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsUnsharpMask:
    def __init__(
        self,
        *,
        gain: typing.Optional[builtins.str] = None,
        gain_var: typing.Optional[builtins.str] = None,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
        threshold: typing.Optional[builtins.str] = None,
        threshold_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param gain: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        :param gain_var: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        :param sigma: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        :param threshold: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        :param threshold_var: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__41b15911c0be63bfe7788a9a8cb0e96bd9132202f4abe6439c3f175d2d0ccad7)
            check_type(argname="argument gain", value=gain, expected_type=type_hints["gain"])
            check_type(argname="argument gain_var", value=gain_var, expected_type=type_hints["gain_var"])
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
            check_type(argname="argument threshold", value=threshold, expected_type=type_hints["threshold"])
            check_type(argname="argument threshold_var", value=threshold_var, expected_type=type_hints["threshold_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if gain is not None:
            self._values["gain"] = gain
        if gain_var is not None:
            self._values["gain_var"] = gain_var
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var
        if threshold is not None:
            self._values["threshold"] = threshold
        if threshold_var is not None:
            self._values["threshold_var"] = threshold_var

    @builtins.property
    def gain(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        '''
        result = self._values.get("gain")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gain_var(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        '''
        result = self._values.get("gain_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        '''
        result = self._values.get("threshold")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold_var(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        result = self._values.get("threshold_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsUnsharpMask(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsUnsharpMaskList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsUnsharpMaskList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__058d2f9f8fdd984cfefa0ba0570548ef30c7e2a51d3c55c2bee8f181f2c52fbd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsUnsharpMaskOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__84304c892fe71908e634dbe009be8ba70754201624bdc0490ebb92f718121c61)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsUnsharpMaskOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__503e81c52e9f715c53f90c731a4c88823dbcb647c95a5c903995a126d11cd80c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ba146b8bcbd9f83b8f3b0a314d45ac5790d8821577790511bc20e0f5d0ebdfe2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2e0d97d5b09a09df539760303bec76623aaf18aa9be6e4ce746d8c8931001b6a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsUnsharpMask]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsUnsharpMask]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsUnsharpMask]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__428682c4d6dc5ed3904872f053fbc4d63c5ffb929f44125e740bf3e3a07e8316)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsUnsharpMaskOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsUnsharpMaskOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d97a0fdf4d29428662cd2f27808e22020b78d67b12b91f6f41a490df1de43348)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetGain")
    def reset_gain(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGain", []))

    @jsii.member(jsii_name="resetGainVar")
    def reset_gain_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGainVar", []))

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @jsii.member(jsii_name="resetThreshold")
    def reset_threshold(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThreshold", []))

    @jsii.member(jsii_name="resetThresholdVar")
    def reset_threshold_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThresholdVar", []))

    @builtins.property
    @jsii.member(jsii_name="gainInput")
    def gain_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainInput"))

    @builtins.property
    @jsii.member(jsii_name="gainVarInput")
    def gain_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdInput")
    def threshold_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdVarInput")
    def threshold_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gain")
    def gain(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gain"))

    @gain.setter
    def gain(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9049d397b6f37b19ce2aab33a439d06705489ff2d7a99700a5ff6743f1553324)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gain", value)

    @builtins.property
    @jsii.member(jsii_name="gainVar")
    def gain_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gainVar"))

    @gain_var.setter
    def gain_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4e1253a7bb1c11fe2255088935a0a97935dab759f944e07279e00a629b417be8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gainVar", value)

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__36e663d99857e082eb016d5b559303d9f48983ce06cdd2437d37060fb0460f51)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d60406b786f03007f29fc364e5eb8919a686c7044ca79dbfbaa7d7c07a0688bd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="threshold")
    def threshold(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "threshold"))

    @threshold.setter
    def threshold(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a780051506f6389100f1173913a0efec351785db3c3b3f1a192aaf66adf381f0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "threshold", value)

    @builtins.property
    @jsii.member(jsii_name="thresholdVar")
    def threshold_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "thresholdVar"))

    @threshold_var.setter
    def threshold_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a9a883b5094b401f9d4588b275a429dace4e13ad630bffb979f5a43fbae0ed61)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "thresholdVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsUnsharpMask]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsUnsharpMask]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsUnsharpMask]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d8fa19ba58eabc8983e709f1ad6a092f467259120b011fe417b9919230e41eab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanContrast",
    jsii_struct_bases=[],
    name_mapping={
        "brightness": "brightness",
        "brightness_var": "brightnessVar",
        "contrast": "contrast",
        "contrast_var": "contrastVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanContrast:
    def __init__(
        self,
        *,
        brightness: typing.Optional[builtins.str] = None,
        brightness_var: typing.Optional[builtins.str] = None,
        contrast: typing.Optional[builtins.str] = None,
        contrast_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param brightness: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        :param brightness_var: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        :param contrast: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param contrast_var: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__80060aba6a94218456b24f009c6cc760e0fae9fbe794ec599155cfd1c8042bb1)
            check_type(argname="argument brightness", value=brightness, expected_type=type_hints["brightness"])
            check_type(argname="argument brightness_var", value=brightness_var, expected_type=type_hints["brightness_var"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument contrast_var", value=contrast_var, expected_type=type_hints["contrast_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if brightness is not None:
            self._values["brightness"] = brightness
        if brightness_var is not None:
            self._values["brightness_var"] = brightness_var
        if contrast is not None:
            self._values["contrast"] = contrast
        if contrast_var is not None:
            self._values["contrast_var"] = contrast_var

    @builtins.property
    def brightness(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        '''
        result = self._values.get("brightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def brightness_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        '''
        result = self._values.get("brightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        result = self._values.get("contrast_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanContrast(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanContrastList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanContrastList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ff7bbf0fc87456bbffd2f855eec522563a60e65ad71eac4df02ca19943045826)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanContrastOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bca2193da9b46ef416a2591000db048bb5d9269aa444fd0ff41a9cabbfdfdeea)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanContrastOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd712dc610d2ac2e98cf28f4d4ababccb2e8b2c71e729549ec6a746f56778641)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a1f9fb3797745d10712d6bd6da78444c03d849e81edc01d0cf62c5942a2caab8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8749ff8cd2ac13806cdb2266a7f1f062b257d8af3b54f241a5044cab78a36136)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanContrast]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanContrast]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ff9ed6de229f98e75c3c8fda3fb310ccda088c83ec806273b72fe5f72cd9b1ea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanContrastOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanContrastOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__22147dd71ffb61bc060f7afda90c77007cfe274a9f4694d8c5ff57441118918c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetBrightness")
    def reset_brightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightness", []))

    @jsii.member(jsii_name="resetBrightnessVar")
    def reset_brightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightnessVar", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetContrastVar")
    def reset_contrast_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrastVar", []))

    @builtins.property
    @jsii.member(jsii_name="brightnessInput")
    def brightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="brightnessVarInput")
    def brightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastVarInput")
    def contrast_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="brightness")
    def brightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightness"))

    @brightness.setter
    def brightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4b46e4bf4b53ce133fae978bb901d53d32d24900250ae2027adcfc14bd1eafac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightness", value)

    @builtins.property
    @jsii.member(jsii_name="brightnessVar")
    def brightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightnessVar"))

    @brightness_var.setter
    def brightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ad291dd032173f3edb8d07de30078b284a1337910293bc1172d128d782aeab6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrast"))

    @contrast.setter
    def contrast(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a0bc40edbe65ca2e53656dd1166042b4ce725d0868a1111155f9ba8e4e464bda)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrast", value)

    @builtins.property
    @jsii.member(jsii_name="contrastVar")
    def contrast_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrastVar"))

    @contrast_var.setter
    def contrast_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ac0dada099a1d36c8a4d8db4e71271c3de3d20a91a360365b071c17b20cff03)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrastVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanContrast]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanContrast]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanContrast]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0dfb54032ed980ae13b26795a56a1913c80b6a1fc154ea864ef46338de658288)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanGoop",
    jsii_struct_bases=[],
    name_mapping={
        "chaos": "chaos",
        "chaos_var": "chaosVar",
        "density": "density",
        "density_var": "densityVar",
        "power": "power",
        "power_var": "powerVar",
        "seed": "seed",
        "seed_var": "seedVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanGoop:
    def __init__(
        self,
        *,
        chaos: typing.Optional[builtins.str] = None,
        chaos_var: typing.Optional[builtins.str] = None,
        density: typing.Optional[builtins.str] = None,
        density_var: typing.Optional[builtins.str] = None,
        power: typing.Optional[builtins.str] = None,
        power_var: typing.Optional[builtins.str] = None,
        seed: typing.Optional[builtins.str] = None,
        seed_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param chaos: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        :param chaos_var: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        :param density: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        :param density_var: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        :param power: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        :param power_var: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        :param seed: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        :param seed_var: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ec09e03b7ab9edfdd88368ab4fc76fee173315ea462533c30735ccd0b4f43bcb)
            check_type(argname="argument chaos", value=chaos, expected_type=type_hints["chaos"])
            check_type(argname="argument chaos_var", value=chaos_var, expected_type=type_hints["chaos_var"])
            check_type(argname="argument density", value=density, expected_type=type_hints["density"])
            check_type(argname="argument density_var", value=density_var, expected_type=type_hints["density_var"])
            check_type(argname="argument power", value=power, expected_type=type_hints["power"])
            check_type(argname="argument power_var", value=power_var, expected_type=type_hints["power_var"])
            check_type(argname="argument seed", value=seed, expected_type=type_hints["seed"])
            check_type(argname="argument seed_var", value=seed_var, expected_type=type_hints["seed_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if chaos is not None:
            self._values["chaos"] = chaos
        if chaos_var is not None:
            self._values["chaos_var"] = chaos_var
        if density is not None:
            self._values["density"] = density
        if density_var is not None:
            self._values["density_var"] = density_var
        if power is not None:
            self._values["power"] = power
        if power_var is not None:
            self._values["power_var"] = power_var
        if seed is not None:
            self._values["seed"] = seed
        if seed_var is not None:
            self._values["seed_var"] = seed_var

    @builtins.property
    def chaos(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        '''
        result = self._values.get("chaos")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def chaos_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        '''
        result = self._values.get("chaos_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        '''
        result = self._values.get("density")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density_var(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        '''
        result = self._values.get("density_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        '''
        result = self._values.get("power")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power_var(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        '''
        result = self._values.get("power_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        '''
        result = self._values.get("seed")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed_var(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        result = self._values.get("seed_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanGoop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanGoopList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanGoopList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a0da73facbe34cead9c91fa6ff388b87f3c2d7634e8904a6bc291b800a62e28d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanGoopOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a3453736b36583b49ef7b0bd3e83c55e5fb12f346aff4a092edb8cadb152158f)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanGoopOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__31225f6ffc0feb9f11198a411b8d8f02cf2bfa067ced453f09a3e0c4f34e2f86)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a8d83d8321e0310c8818c6f04bb7472ae55943c41c7502957fad331f4ab0c95)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c63837dc8668ec2041bb67573e6809d97f0c99bfef598db09583de9959851905)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanGoop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanGoop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__150ed55b1397d979450c5c62c6b907ee5c07f33588e38d942a41e398c7d36548)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanGoopOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanGoopOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1255061de50856116a65eb69abc95c93b7d84e22773049e8d3ea82ad84a9f0dc)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetChaos")
    def reset_chaos(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaos", []))

    @jsii.member(jsii_name="resetChaosVar")
    def reset_chaos_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaosVar", []))

    @jsii.member(jsii_name="resetDensity")
    def reset_density(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensity", []))

    @jsii.member(jsii_name="resetDensityVar")
    def reset_density_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensityVar", []))

    @jsii.member(jsii_name="resetPower")
    def reset_power(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPower", []))

    @jsii.member(jsii_name="resetPowerVar")
    def reset_power_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPowerVar", []))

    @jsii.member(jsii_name="resetSeed")
    def reset_seed(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeed", []))

    @jsii.member(jsii_name="resetSeedVar")
    def reset_seed_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeedVar", []))

    @builtins.property
    @jsii.member(jsii_name="chaosInput")
    def chaos_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosInput"))

    @builtins.property
    @jsii.member(jsii_name="chaosVarInput")
    def chaos_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosVarInput"))

    @builtins.property
    @jsii.member(jsii_name="densityInput")
    def density_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityInput"))

    @builtins.property
    @jsii.member(jsii_name="densityVarInput")
    def density_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="powerInput")
    def power_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerInput"))

    @builtins.property
    @jsii.member(jsii_name="powerVarInput")
    def power_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerVarInput"))

    @builtins.property
    @jsii.member(jsii_name="seedInput")
    def seed_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedInput"))

    @builtins.property
    @jsii.member(jsii_name="seedVarInput")
    def seed_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedVarInput"))

    @builtins.property
    @jsii.member(jsii_name="chaos")
    def chaos(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaos"))

    @chaos.setter
    def chaos(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4d24f611b606bcbbb4064cce95f47dd1f28133eb2fc02d3b5084b4563ad5e045)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaos", value)

    @builtins.property
    @jsii.member(jsii_name="chaosVar")
    def chaos_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaosVar"))

    @chaos_var.setter
    def chaos_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f2920851ff4a23898b0e84db087c90066232b3d81282d0afbcddd14f76ca227a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaosVar", value)

    @builtins.property
    @jsii.member(jsii_name="density")
    def density(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "density"))

    @density.setter
    def density(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b22f9f89f0f88123c9c4db7c4bb7fe5c790d9322edaa16df53727700fa89e861)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "density", value)

    @builtins.property
    @jsii.member(jsii_name="densityVar")
    def density_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "densityVar"))

    @density_var.setter
    def density_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__64edbbd7979d74e5b56cbfa09f28fe9b602e7bde219359b88d81747fba56ef75)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "densityVar", value)

    @builtins.property
    @jsii.member(jsii_name="power")
    def power(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "power"))

    @power.setter
    def power(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__db152472fc054d43f46536d90cb8810eee6c6119de8bde50f038be2edf427e84)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "power", value)

    @builtins.property
    @jsii.member(jsii_name="powerVar")
    def power_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "powerVar"))

    @power_var.setter
    def power_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a2b792fd91dfaad942d495bd98e9a05d3afd1a27068a26eab489abc500e4cba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "powerVar", value)

    @builtins.property
    @jsii.member(jsii_name="seed")
    def seed(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seed"))

    @seed.setter
    def seed(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f73114743672dba566887e4b082325bc05c1c527870440a4cecb1008a5f48bc9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seed", value)

    @builtins.property
    @jsii.member(jsii_name="seedVar")
    def seed_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seedVar"))

    @seed_var.setter
    def seed_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__597845b9d7e055bb56af8c590e7a0afea15cbedbb5f45e511321feefa38d2056)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seedVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanGoop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanGoop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanGoop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e9dd3c2f13413ed1430462b34a36579fab0596cd446cb8d0fb83911d812872cd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanGrayscale",
    jsii_struct_bases=[],
    name_mapping={"type": "type", "type_var": "typeVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanGrayscale:
    def __init__(
        self,
        *,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param type: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a510d23acbd12c7ac832cd025c2a0c0d94bebb8a155e2178236e0ac821d8061)
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanGrayscale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanGrayscaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanGrayscaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f2e251c92762a32ed83b7f65c035325ce9504b709ebe6ede3de8bdf16de480e2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanGrayscaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__caa8d11d083d3b10e702f2c3e93800b4ed194bd5b8dd925fb5003be1eebf2f00)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanGrayscaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9f297e1a46a1337d9b3cc319a0be8e42ed46c0bad28bbb8997888a7bc0ed3a19)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ce8143d8e569f00ef80621550bab22e2cbceb38bef0d1fc775744aa7e2c2e6e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d28e067c05f2fdb038b8f2f12c235d0c99515c60e682242c8d0e12f9d1bfc95a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanGrayscale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanGrayscale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d8351805ce7e7ed981212da9364b8b788f50249ff1831e1e82902a5010b2598c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanGrayscaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanGrayscaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f01ea475561d4d243d6b0556e70e138dd5834346bb4c37c2732889d55866971)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7062892090bbdf9f4dff65a3ead80908f3c4c35205b3a8338ca738832e05fff4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ca43e55a941b556f1b1889f28f99732aa90b732b7230e176f3a9b624e39f16a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanGrayscale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanGrayscale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanGrayscale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b96251985652d16bc0085237d88cff62638b1b5f49a72ce7bfabadf952c51fd8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanHsl",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "lightness": "lightness",
        "lightness_var": "lightnessVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanHsl:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness: typing.Optional[builtins.str] = None,
        lightness_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        :param lightness_var: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c3c0baa169c160420f7ced3496386130e61488e4266f7e513e077378f67a4619)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness", value=lightness, expected_type=type_hints["lightness"])
            check_type(argname="argument lightness_var", value=lightness_var, expected_type=type_hints["lightness_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness is not None:
            self._values["lightness"] = lightness
        if lightness_var is not None:
            self._values["lightness_var"] = lightness_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        '''
        result = self._values.get("lightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        '''
        result = self._values.get("lightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanHsl(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanHslList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanHslList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab9f01b2eba3d80fa3413fce119b2b3122b6c3d0c957e0fa80b98e85c250ac31)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanHslOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d06d3272fd7e9c52edade408ec64fac8596514a6f5de81be948ecc0ffcd15856)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanHslOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1fd18af39ad59a548e07820862b3acfda2cf8d79600907d5812b509b8b855a65)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9faab00f6b25b4814bfed7b7436d0fca4d7c1302da54c72ce99a8c2c7f9641c5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__24b2338972344e1cc565de1ac22209c987fa6903e817c9a598c784d3793f5d0f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanHsl]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanHsl]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__53b5f23ab63f5a30cc010aeb1cdd221047b09ec6bda4fc524cec6acad49cd855)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanHslOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanHslOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d59a53bd803c52df3079f1b908addb038064fa35ff261c5b2824f6e040de4fca)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightness")
    def reset_lightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightness", []))

    @jsii.member(jsii_name="resetLightnessVar")
    def reset_lightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessInput")
    def lightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessVarInput")
    def lightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__45759adaa196e9ade56dd9c0bb89a19dac82c5d8b5085daf978d9a132ef70a8e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__07727281ff64ec860d9576ee6d1289094cc9bce216750502190ddf312bf5fdb0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightness")
    def lightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightness"))

    @lightness.setter
    def lightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e2485b93c1ca7ad59c6e435754d88da3a52a52f6dab2ff41ef1bf31d1b76ffdb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightness", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessVar")
    def lightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessVar"))

    @lightness_var.setter
    def lightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f9c0572663c6d9f5bf1e867eddfcf33dd6a7f7d48883b9b6f6becfdb1fe1bff1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b4e55f0cde2b3a8e859accdcd75d6486f109e0723e6030c2dacdbc3e66ca9535)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9f50dfcf5d6713476c5be055fffa382ec5cdf3c05b51a856d9384f651fcf3ffb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanHsl]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanHsl]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanHsl]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__15849350d03c092b583675a0d3d4538900054b26692ae1316df05c58e8c36fe0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanHsv",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanHsv:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        :param value: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d633b9485f6373a87920a4c897fae42bdd83cf9e953e1eacaf2b9a9823cac797)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanHsv(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanHsvList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanHsvList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cf2a6b13ae143b16dc18a116619f776ac2b2d99708fefe761110e2489a5b8890)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanHsvOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d43f24998355450ca023b5005d82cc5893cde18a72208c6f8c27788781a32049)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanHsvOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a3dc3c252ceb07f70647ebf66d2cdac2d0be4bed16cac00dd5967ab7a0f1800a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__16b969999afbbe6340e991c689aee0db072c6428d8b2650a9d3f5028335895a1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__31b1ebe0a56034d1d724f9a3228198600ec0a99f9091c3e59813f44d82b7e79e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanHsv]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanHsv]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ef332e0e0b09e0b45e238998ac581f270352093ae11f731407e7e985a7d8aff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanHsvOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanHsvOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ecde75ae45a0019e45f7975f4082abc0f4377ee97c0e4ca284c436aba0148149)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__20223ae72449cf258c5cd0eb44696fc6c352c1ed55fd566820f3bb4503934cc3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ce323c0a3cf42b0ab64e3cf08b9dbccc350e8beb3296276e6f7a188b28be67cd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8e351350161e401b38e5773666d4e2c25a846b3045fd7072b4dc67c5ae658c3b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c0b73a8e9b279d51474b56f9c4d751482fca91c5493e254213a47a3eb35c2317)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__040e3cc14b03bf978e74699b98f9a3d7049967239612210de4c7333e7009a3b5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ef974fa9d1f9eda0776115f40443a4dc864648e3611f0f381989396168079e6d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanHsv]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanHsv]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanHsv]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a0a2a5cf45b9b5f3c3d264f4bdb367ef19a320828b5cf09bfe5b69ea0dadd209)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientation",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "landscape": "landscape",
        "portrait": "portrait",
        "square": "square",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientation:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        landscape: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscape", typing.Dict[builtins.str, typing.Any]]] = None,
        portrait: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortrait", typing.Dict[builtins.str, typing.Any]]] = None,
        square: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquare", typing.Dict[builtins.str, typing.Any]]] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param landscape: landscape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        :param portrait: portrait block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        :param square: square block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefault(**default)
        if isinstance(landscape, dict):
            landscape = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscape(**landscape)
        if isinstance(portrait, dict):
            portrait = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortrait(**portrait)
        if isinstance(square, dict):
            square = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquare(**square)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__16c6923cba9585a93a71e3800cf6bad8aefa944711459321d8816dfd1817bcde)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument landscape", value=landscape, expected_type=type_hints["landscape"])
            check_type(argname="argument portrait", value=portrait, expected_type=type_hints["portrait"])
            check_type(argname="argument square", value=square, expected_type=type_hints["square"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if landscape is not None:
            self._values["landscape"] = landscape
        if portrait is not None:
            self._values["portrait"] = portrait
        if square is not None:
            self._values["square"] = square

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefault"], result)

    @builtins.property
    def landscape(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscape"]:
        '''landscape block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        '''
        result = self._values.get("landscape")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscape"], result)

    @builtins.property
    def portrait(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortrait"]:
        '''portrait block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        '''
        result = self._values.get("portrait")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortrait"], result)

    @builtins.property
    def square(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquare"]:
        '''square block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        result = self._values.get("square")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquare"], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefault",
    jsii_struct_bases=[],
    name_mapping={
        "background_color": "backgroundColor",
        "blur": "blur",
        "chroma_key": "chromaKey",
        "composite": "composite",
        "compound": "compound",
        "contrast": "contrast",
        "goop": "goop",
        "grayscale": "grayscale",
        "hsl": "hsl",
        "hsv": "hsv",
        "if_dimension": "ifDimension",
        "if_orientation": "ifOrientation",
        "max_colors": "maxColors",
        "mirror": "mirror",
        "mono_hue": "monoHue",
        "opacity": "opacity",
        "remove_color": "removeColor",
        "unsharp_mask": "unsharpMask",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefault:
    def __init__(
        self,
        *,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultBackgroundColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultBlur", typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultChromaKey", typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultComposite", typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultCompound", typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultContrast", typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultGoop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultGrayscale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultHsl", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultHsv", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimension", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientation", typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultMaxColors", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultMirror", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultMonoHue", typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultOpacity", typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultRemoveColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultUnsharpMask", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bdcb8fe7a36daa363eaacf739c1bafa16f84b366268b14cd7c80a15799d40a12)
            check_type(argname="argument background_color", value=background_color, expected_type=type_hints["background_color"])
            check_type(argname="argument blur", value=blur, expected_type=type_hints["blur"])
            check_type(argname="argument chroma_key", value=chroma_key, expected_type=type_hints["chroma_key"])
            check_type(argname="argument composite", value=composite, expected_type=type_hints["composite"])
            check_type(argname="argument compound", value=compound, expected_type=type_hints["compound"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument goop", value=goop, expected_type=type_hints["goop"])
            check_type(argname="argument grayscale", value=grayscale, expected_type=type_hints["grayscale"])
            check_type(argname="argument hsl", value=hsl, expected_type=type_hints["hsl"])
            check_type(argname="argument hsv", value=hsv, expected_type=type_hints["hsv"])
            check_type(argname="argument if_dimension", value=if_dimension, expected_type=type_hints["if_dimension"])
            check_type(argname="argument if_orientation", value=if_orientation, expected_type=type_hints["if_orientation"])
            check_type(argname="argument max_colors", value=max_colors, expected_type=type_hints["max_colors"])
            check_type(argname="argument mirror", value=mirror, expected_type=type_hints["mirror"])
            check_type(argname="argument mono_hue", value=mono_hue, expected_type=type_hints["mono_hue"])
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument remove_color", value=remove_color, expected_type=type_hints["remove_color"])
            check_type(argname="argument unsharp_mask", value=unsharp_mask, expected_type=type_hints["unsharp_mask"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if background_color is not None:
            self._values["background_color"] = background_color
        if blur is not None:
            self._values["blur"] = blur
        if chroma_key is not None:
            self._values["chroma_key"] = chroma_key
        if composite is not None:
            self._values["composite"] = composite
        if compound is not None:
            self._values["compound"] = compound
        if contrast is not None:
            self._values["contrast"] = contrast
        if goop is not None:
            self._values["goop"] = goop
        if grayscale is not None:
            self._values["grayscale"] = grayscale
        if hsl is not None:
            self._values["hsl"] = hsl
        if hsv is not None:
            self._values["hsv"] = hsv
        if if_dimension is not None:
            self._values["if_dimension"] = if_dimension
        if if_orientation is not None:
            self._values["if_orientation"] = if_orientation
        if max_colors is not None:
            self._values["max_colors"] = max_colors
        if mirror is not None:
            self._values["mirror"] = mirror
        if mono_hue is not None:
            self._values["mono_hue"] = mono_hue
        if opacity is not None:
            self._values["opacity"] = opacity
        if remove_color is not None:
            self._values["remove_color"] = remove_color
        if unsharp_mask is not None:
            self._values["unsharp_mask"] = unsharp_mask

    @builtins.property
    def background_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultBackgroundColor"]]]:
        '''background_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        '''
        result = self._values.get("background_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultBackgroundColor"]]], result)

    @builtins.property
    def blur(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultBlur"]]]:
        '''blur block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        '''
        result = self._values.get("blur")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultBlur"]]], result)

    @builtins.property
    def chroma_key(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultChromaKey"]]]:
        '''chroma_key block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        '''
        result = self._values.get("chroma_key")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultChromaKey"]]], result)

    @builtins.property
    def composite(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultComposite"]]]:
        '''composite block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        '''
        result = self._values.get("composite")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultComposite"]]], result)

    @builtins.property
    def compound(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultCompound"]]]:
        '''compound block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        '''
        result = self._values.get("compound")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultCompound"]]], result)

    @builtins.property
    def contrast(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultContrast"]]]:
        '''contrast block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultContrast"]]], result)

    @builtins.property
    def goop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultGoop"]]]:
        '''goop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        '''
        result = self._values.get("goop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultGoop"]]], result)

    @builtins.property
    def grayscale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultGrayscale"]]]:
        '''grayscale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        '''
        result = self._values.get("grayscale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultGrayscale"]]], result)

    @builtins.property
    def hsl(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultHsl"]]]:
        '''hsl block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        '''
        result = self._values.get("hsl")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultHsl"]]], result)

    @builtins.property
    def hsv(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultHsv"]]]:
        '''hsv block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        '''
        result = self._values.get("hsv")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultHsv"]]], result)

    @builtins.property
    def if_dimension(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimension"]]]:
        '''if_dimension block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        '''
        result = self._values.get("if_dimension")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimension"]]], result)

    @builtins.property
    def if_orientation(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientation"]]]:
        '''if_orientation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        '''
        result = self._values.get("if_orientation")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientation"]]], result)

    @builtins.property
    def max_colors(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultMaxColors"]]]:
        '''max_colors block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        '''
        result = self._values.get("max_colors")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultMaxColors"]]], result)

    @builtins.property
    def mirror(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultMirror"]]]:
        '''mirror block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        '''
        result = self._values.get("mirror")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultMirror"]]], result)

    @builtins.property
    def mono_hue(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultMonoHue"]]]:
        '''mono_hue block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        '''
        result = self._values.get("mono_hue")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultMonoHue"]]], result)

    @builtins.property
    def opacity(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultOpacity"]]]:
        '''opacity block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultOpacity"]]], result)

    @builtins.property
    def remove_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultRemoveColor"]]]:
        '''remove_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        '''
        result = self._values.get("remove_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultRemoveColor"]]], result)

    @builtins.property
    def unsharp_mask(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultUnsharpMask"]]]:
        '''unsharp_mask block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        result = self._values.get("unsharp_mask")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultUnsharpMask"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultBackgroundColor",
    jsii_struct_bases=[],
    name_mapping={"color": "color", "color_var": "colorVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultBackgroundColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__460d3c39c9d80640ac1d685bc65e24981deac0956ea61c331a85cf79c723075d)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultBackgroundColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultBackgroundColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultBackgroundColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__da9a795a283a5ad540216da2339197133f275cabfe022ac4df68e30f13e8464e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultBackgroundColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b5c6a03fc2bba72c2d707dca98f7b3bb45e3ddcc01acbc66902a58df10e5c27a)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultBackgroundColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__47456f01780e6e081e9ad1d0cde5e9b7c03f963d0499dbec170221ebb967b71f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1da4cd9d706e2dde5ea6e5f5c0fc73171e0c71f9a05fe4ca5451fd08208ac9f7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0268c0a1a5c32bd831c5125039ae6f5a49674ec35411462cdd77fc9c487be02e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultBackgroundColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultBackgroundColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6ec3b3fb16e8d568051618b565c904828356b2296ddefcd5fa807798268bbaeb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultBackgroundColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultBackgroundColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c6feaffcb265eb8645be350f5e811d165429cc2c619d0d729dc3e909f30feb80)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0bce02603e03b5bac79fb697cb91e6a4a59bd3c88853db07b017f470167eb1cc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eee47357cd8917ccdba2982b5186fee6e79236a975e15bcc6e9ba5e5806b4472)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultBackgroundColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultBackgroundColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultBackgroundColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab8d112f238e48a9de59628af98985932cb543613e897121204404917e2298bd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultBlur",
    jsii_struct_bases=[],
    name_mapping={"sigma": "sigma", "sigma_var": "sigmaVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultBlur:
    def __init__(
        self,
        *,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param sigma: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a0d3e393de9435c04a764c2f5753fbfd27fbc321a5e6538c4b6c361c19998d9e)
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultBlur(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultBlurList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultBlurList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cf12d073fd94701eefeb0754266235946a6f9605a7330e186bff9e8fd0f66603)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultBlurOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cca2f7019fd21493c33b110aaec1bf95e3c3e8ab50722959f8958208e92b96e4)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultBlurOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__73d8876fce23fba375f932bbb5088eb06de31d3ff131d513c502e050e23603bd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__43cff4a31588d1281f8c229f2d6d3c40b27435097eef512555ec1d9d4d5cdb9c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d62d8935891712a5d272c3905e80ac7d0defa20c0a63e92559c386b50a0550a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultBlur]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultBlur]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8c00c40de8cca1eb61ee9a43f68df2d99cc3b830d78f9a5709502de86948d6f1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultBlurOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultBlurOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__97192be23655ff075eb030b29a8ebf1ac5a77b841e04c117a677dc238914ea10)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1042434a885161113b2bcf774d3b747421f0e9bdf4de9280fe06868f206b8f10)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b8d5d0ca88a7a0f59f9464018ff64452cb42bb129685327a866bbb422963807f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultBlur]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultBlur]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultBlur]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8369a5e24d3b8060cfe3c5cdf0fb14785ab4c2d7cc3d315d22acfe3ae79e9544)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultChromaKey",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_feather": "hueFeather",
        "hue_feather_var": "hueFeatherVar",
        "hue_tolerance": "hueTolerance",
        "hue_tolerance_var": "hueToleranceVar",
        "hue_var": "hueVar",
        "lightness_feather": "lightnessFeather",
        "lightness_feather_var": "lightnessFeatherVar",
        "lightness_tolerance": "lightnessTolerance",
        "lightness_tolerance_var": "lightnessToleranceVar",
        "saturation_feather": "saturationFeather",
        "saturation_feather_var": "saturationFeatherVar",
        "saturation_tolerance": "saturationTolerance",
        "saturation_tolerance_var": "saturationToleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultChromaKey:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_feather: typing.Optional[builtins.str] = None,
        hue_feather_var: typing.Optional[builtins.str] = None,
        hue_tolerance: typing.Optional[builtins.str] = None,
        hue_tolerance_var: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness_feather: typing.Optional[builtins.str] = None,
        lightness_feather_var: typing.Optional[builtins.str] = None,
        lightness_tolerance: typing.Optional[builtins.str] = None,
        lightness_tolerance_var: typing.Optional[builtins.str] = None,
        saturation_feather: typing.Optional[builtins.str] = None,
        saturation_feather_var: typing.Optional[builtins.str] = None,
        saturation_tolerance: typing.Optional[builtins.str] = None,
        saturation_tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_feather: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        :param hue_feather_var: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        :param hue_tolerance: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        :param hue_tolerance_var: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        :param hue_var: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness_feather: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        :param lightness_feather_var: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        :param lightness_tolerance: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        :param lightness_tolerance_var: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        :param saturation_feather: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        :param saturation_feather_var: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        :param saturation_tolerance: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        :param saturation_tolerance_var: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7a9b6344c52b3a2af1ddd20291fcc0437feacc6a34b6b942697ffc3a202e2af2)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_feather", value=hue_feather, expected_type=type_hints["hue_feather"])
            check_type(argname="argument hue_feather_var", value=hue_feather_var, expected_type=type_hints["hue_feather_var"])
            check_type(argname="argument hue_tolerance", value=hue_tolerance, expected_type=type_hints["hue_tolerance"])
            check_type(argname="argument hue_tolerance_var", value=hue_tolerance_var, expected_type=type_hints["hue_tolerance_var"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness_feather", value=lightness_feather, expected_type=type_hints["lightness_feather"])
            check_type(argname="argument lightness_feather_var", value=lightness_feather_var, expected_type=type_hints["lightness_feather_var"])
            check_type(argname="argument lightness_tolerance", value=lightness_tolerance, expected_type=type_hints["lightness_tolerance"])
            check_type(argname="argument lightness_tolerance_var", value=lightness_tolerance_var, expected_type=type_hints["lightness_tolerance_var"])
            check_type(argname="argument saturation_feather", value=saturation_feather, expected_type=type_hints["saturation_feather"])
            check_type(argname="argument saturation_feather_var", value=saturation_feather_var, expected_type=type_hints["saturation_feather_var"])
            check_type(argname="argument saturation_tolerance", value=saturation_tolerance, expected_type=type_hints["saturation_tolerance"])
            check_type(argname="argument saturation_tolerance_var", value=saturation_tolerance_var, expected_type=type_hints["saturation_tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_feather is not None:
            self._values["hue_feather"] = hue_feather
        if hue_feather_var is not None:
            self._values["hue_feather_var"] = hue_feather_var
        if hue_tolerance is not None:
            self._values["hue_tolerance"] = hue_tolerance
        if hue_tolerance_var is not None:
            self._values["hue_tolerance_var"] = hue_tolerance_var
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness_feather is not None:
            self._values["lightness_feather"] = lightness_feather
        if lightness_feather_var is not None:
            self._values["lightness_feather_var"] = lightness_feather_var
        if lightness_tolerance is not None:
            self._values["lightness_tolerance"] = lightness_tolerance
        if lightness_tolerance_var is not None:
            self._values["lightness_tolerance_var"] = lightness_tolerance_var
        if saturation_feather is not None:
            self._values["saturation_feather"] = saturation_feather
        if saturation_feather_var is not None:
            self._values["saturation_feather_var"] = saturation_feather_var
        if saturation_tolerance is not None:
            self._values["saturation_tolerance"] = saturation_tolerance
        if saturation_tolerance_var is not None:
            self._values["saturation_tolerance_var"] = saturation_tolerance_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        '''
        result = self._values.get("hue_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        '''
        result = self._values.get("hue_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        '''
        result = self._values.get("hue_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        '''
        result = self._values.get("hue_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        '''
        result = self._values.get("lightness_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        '''
        result = self._values.get("lightness_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        '''
        result = self._values.get("lightness_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        '''
        result = self._values.get("lightness_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        '''
        result = self._values.get("saturation_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        '''
        result = self._values.get("saturation_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        '''
        result = self._values.get("saturation_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        result = self._values.get("saturation_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultChromaKey(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultChromaKeyList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultChromaKeyList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eef8a2a874cb210d0b8ea75b8b26b366ba8c86a48dd516500ac2ce862a07dc25)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultChromaKeyOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__36cf65809ca3eecb0878490bc2e4aa110bd29bb91cabdd936e432ea7137a7c2b)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultChromaKeyOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ad385fa192e6202453120354de39e3ea0d922b8539a2507827ce6018860ce33)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5827bc7f850bd9cfef2db9ccfaacd5dbebfe1e55fa412d6936587dcc7c23d0d4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7e3a3476dcd871443f65306fcf6fa3d6febc909fe248601f0ddb476884bc97bd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultChromaKey]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultChromaKey]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b0d6c501e2d37cbb747c27c794827491f6508931595441f71ca83e99b03a352c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultChromaKeyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultChromaKeyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4480114e4294773fcb8ca65d87dd66b77d57424b5974ccc4e65c2ef58e1816a3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueFeather")
    def reset_hue_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeather", []))

    @jsii.member(jsii_name="resetHueFeatherVar")
    def reset_hue_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeatherVar", []))

    @jsii.member(jsii_name="resetHueTolerance")
    def reset_hue_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueTolerance", []))

    @jsii.member(jsii_name="resetHueToleranceVar")
    def reset_hue_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueToleranceVar", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightnessFeather")
    def reset_lightness_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeather", []))

    @jsii.member(jsii_name="resetLightnessFeatherVar")
    def reset_lightness_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeatherVar", []))

    @jsii.member(jsii_name="resetLightnessTolerance")
    def reset_lightness_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessTolerance", []))

    @jsii.member(jsii_name="resetLightnessToleranceVar")
    def reset_lightness_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessToleranceVar", []))

    @jsii.member(jsii_name="resetSaturationFeather")
    def reset_saturation_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeather", []))

    @jsii.member(jsii_name="resetSaturationFeatherVar")
    def reset_saturation_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeatherVar", []))

    @jsii.member(jsii_name="resetSaturationTolerance")
    def reset_saturation_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationTolerance", []))

    @jsii.member(jsii_name="resetSaturationToleranceVar")
    def reset_saturation_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherInput")
    def hue_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVarInput")
    def hue_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceInput")
    def hue_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVarInput")
    def hue_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherInput")
    def lightness_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVarInput")
    def lightness_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceInput")
    def lightness_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVarInput")
    def lightness_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherInput")
    def saturation_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVarInput")
    def saturation_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceInput")
    def saturation_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVarInput")
    def saturation_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3e9cfd46cbeaafad55068124a9f6f767c97f5b91916dd98b3853ddf1e49af086)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeather")
    def hue_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeather"))

    @hue_feather.setter
    def hue_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0d7e3b17484c9fe9b42864b1fce792e1fdfc0ddf84efcaece8f954c5b046fd3b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeather", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVar")
    def hue_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeatherVar"))

    @hue_feather_var.setter
    def hue_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__13eb642ffde37c23487dd0e5f56e3a7bccde6d7865d8a6a6633001a6a45f4c40)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueTolerance")
    def hue_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueTolerance"))

    @hue_tolerance.setter
    def hue_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__95eb1f571a4cca856cf59510618a1187aa341140cad443fe7d93a79081394d1a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVar")
    def hue_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueToleranceVar"))

    @hue_tolerance_var.setter
    def hue_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__75cd14296213759f2477422e1d8e90b92c9518efbbb7d03278be81c20143a123)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b09677dd8c7940b8897805f75b82f3afcb89f679eec2e69cb1b69c1e6eb2e5f0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeather")
    def lightness_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeather"))

    @lightness_feather.setter
    def lightness_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ca9bc83f2369a72af9e99c34443ebd2a1ed4f7483fe9d075d885c9259df0a4c4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeather", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVar")
    def lightness_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeatherVar"))

    @lightness_feather_var.setter
    def lightness_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d7f6d2697eca4cfce5a983a6e4e1744493883b9b65cbd0fee22c9c3c145bc39c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessTolerance")
    def lightness_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessTolerance"))

    @lightness_tolerance.setter
    def lightness_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ea50321a981ea9e9981d998f679a2bcb2e4f7fda2dc1b2fedd284a1edfa22f7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVar")
    def lightness_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessToleranceVar"))

    @lightness_tolerance_var.setter
    def lightness_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c2260cff0f5b522a467d55b7702ec4e54b55dd168bf4e029f21af82935a981f8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeather")
    def saturation_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeather"))

    @saturation_feather.setter
    def saturation_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ce8e02afd4ec96c16cc7032d28384975ff1b0ae1e8d05de92992750195154c8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeather", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVar")
    def saturation_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeatherVar"))

    @saturation_feather_var.setter
    def saturation_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__05251b4c75277caba16e735fe80b9346d520403ab931bfe0ef51f1de642dca19)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationTolerance")
    def saturation_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationTolerance"))

    @saturation_tolerance.setter
    def saturation_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__da0b982efb158f307668d88b16d389b61ecddf0fa60faff2cec042e72daafc43)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVar")
    def saturation_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationToleranceVar"))

    @saturation_tolerance_var.setter
    def saturation_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e457f6a507899c1b8a237971c1e218a08efa7814a12127e6334b8d2ab5dd1643)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultChromaKey]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultChromaKey]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultChromaKey]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__28fd7c75c05b1e6fdf1ed3de214de19b0b5fe4510d36a912644ae30a1cc0979e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultComposite",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "placement": "placement",
        "placement_var": "placementVar",
        "scale": "scale",
        "scale_dimension": "scaleDimension",
        "scale_dimension_var": "scaleDimensionVar",
        "scale_var": "scaleVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultComposite:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultCompositeImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        placement: typing.Optional[builtins.str] = None,
        placement_var: typing.Optional[builtins.str] = None,
        scale: typing.Optional[builtins.str] = None,
        scale_dimension: typing.Optional[builtins.str] = None,
        scale_dimension_var: typing.Optional[builtins.str] = None,
        scale_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param placement: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        :param placement_var: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        :param scale: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param scale_dimension: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        :param scale_dimension_var: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        :param scale_var: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        :param x_position: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultCompositeImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__06ee8b84340171e8220f71f34a6d81677eef77fbbf311f9af309548b5c104338)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument placement", value=placement, expected_type=type_hints["placement"])
            check_type(argname="argument placement_var", value=placement_var, expected_type=type_hints["placement_var"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument scale_dimension", value=scale_dimension, expected_type=type_hints["scale_dimension"])
            check_type(argname="argument scale_dimension_var", value=scale_dimension_var, expected_type=type_hints["scale_dimension_var"])
            check_type(argname="argument scale_var", value=scale_var, expected_type=type_hints["scale_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if placement is not None:
            self._values["placement"] = placement
        if placement_var is not None:
            self._values["placement_var"] = placement_var
        if scale is not None:
            self._values["scale"] = scale
        if scale_dimension is not None:
            self._values["scale_dimension"] = scale_dimension
        if scale_dimension_var is not None:
            self._values["scale_dimension_var"] = scale_dimension_var
        if scale_var is not None:
            self._values["scale_var"] = scale_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultCompositeImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultCompositeImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        '''
        result = self._values.get("placement")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement_var(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        '''
        result = self._values.get("placement_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        '''
        result = self._values.get("scale_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        '''
        result = self._values.get("scale_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        '''
        result = self._values.get("scale_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultComposite(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultCompositeImage",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultCompositeImage:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultCompositeImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultCompositeImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultCompositeImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab28e04346f25fd92703841806d8339a1aabb8e24dbae7bcba555d3068a68238)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultCompositeImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultCompositeImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0963561a70af347b581037e987d98ce177d2707c92da1f05b54097470d721f68)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultCompositeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultCompositeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6510e8ecc00fe6778928ed1bf04a7b787aac982206b1b3d5339357e1fba330c3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultCompositeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__29af3296a0de51f28bac257ddf11129a9573ea377440e95130c75b1b70bcbb0a)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultCompositeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab7b362aa71d82ff958295c9de52cc70329221f50012ce46aff9a455e17492d8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6675e148573bc85bb25796ae182027967fad3fef0404bd245e43638ced6960e3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__24dcb0ea06cba69560c2eba81c9600ff1f3c03cec2be5832018edbabff3a574c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultComposite]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultComposite]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__40f55d412d5b04331f2025f06afea214c58def7acb949b420425ebad10e8432e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultCompositeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultCompositeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e2225c7368d54c89eb95f87cb97e2e50b2140133131b91da59d2cad4fe22a865)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultCompositeImage()

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPlacement")
    def reset_placement(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacement", []))

    @jsii.member(jsii_name="resetPlacementVar")
    def reset_placement_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacementVar", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetScaleDimension")
    def reset_scale_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimension", []))

    @jsii.member(jsii_name="resetScaleDimensionVar")
    def reset_scale_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimensionVar", []))

    @jsii.member(jsii_name="resetScaleVar")
    def reset_scale_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultCompositeImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultCompositeImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultCompositeImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="placementInput")
    def placement_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementInput"))

    @builtins.property
    @jsii.member(jsii_name="placementVarInput")
    def placement_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionInput")
    def scale_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVarInput")
    def scale_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleVarInput")
    def scale_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d79f0c6ac3049038364d0c90d8ed78b80617ab4ed66d3beb0b2dae9e7a727a05)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__76d85691026a9d3989675e7185215dcf12418bb0050947746508c785b23645b0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="placement")
    def placement(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placement"))

    @placement.setter
    def placement(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e4933bba095418adf32fe00de76662be34922daa1d74e3151d4ca0b89dbc8ed)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placement", value)

    @builtins.property
    @jsii.member(jsii_name="placementVar")
    def placement_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placementVar"))

    @placement_var.setter
    def placement_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__481d2fda23f15712c44852d73e7f1daff55d457c7fd77077d071f27ad87fab4d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placementVar", value)

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scale"))

    @scale.setter
    def scale(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__420c3c5e634e3072149a1aa58be97eb2f347614c92f685bcf67e4f3a65eda1d9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scale", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimension")
    def scale_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimension"))

    @scale_dimension.setter
    def scale_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__998a07026afcdf40ab5394f6ee2406d50ccd02e0f49ec1297f35814de3f50c20)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimension", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVar")
    def scale_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimensionVar"))

    @scale_dimension_var.setter
    def scale_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5a529d808095c2b6f42014b6f0227e27c8f3d9b4249524ba4a4f3e374cdf0ce2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="scaleVar")
    def scale_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleVar"))

    @scale_var.setter
    def scale_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e7d9289c511710c759a9a38f0c87aa869fddc6a42f089b5edf9f0808a5befd82)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e442885ac4daae0ad67c0ce27ef55911ab1d7fcc7542ea5496f43ae8cf0f5a69)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e2aab934528430793680c258cab0844e360f070aa9dcf89aebfc7150cb29805f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a194bbaa1c3bae0f07c8a1e080e53051415cd5471ad4ca1839d066d2c7fdb1d4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__170a160663289289f6cafa98df02f6acfabb7420f722201f9fe8630d57578c1c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultComposite]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultComposite]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultComposite]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__87113d633212ef5afc5238ddf559ae17aaac9cae0073e7a0a1e022d64cdfd33b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultCompound",
    jsii_struct_bases=[],
    name_mapping={"transformations": "transformations"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultCompound:
    def __init__(
        self,
        *,
        transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param transformations: transformations block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__78a475e7708e2e7bb4bde5fd922651ba5768c121110ffce0883b63c3b7fc0a3a)
            check_type(argname="argument transformations", value=transformations, expected_type=type_hints["transformations"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if transformations is not None:
            self._values["transformations"] = transformations

    @builtins.property
    def transformations(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultCompoundTransformations"]]]:
        '''transformations block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        result = self._values.get("transformations")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultCompoundTransformations"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultCompound(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultCompoundList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultCompoundList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6af222c2baccb064da95bd1ff0a20729c61c200afe36620195e25618859d7ded)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultCompoundOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c0fffd5feaaf15f5b471f946a1836de3028f1d5c87ea241a7783a33a468aff9e)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultCompoundOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__06c943657229bf5c562e67eb4fce4c365357daf1f24466a163406c3646580b9e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d56ce3f267ce38be5667f064db9243b58903388b64f55446a26e4de1245023f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__82462dbe19c11ce424b6f5fc76978a1edf3750bf558ee112e2b0365ac09d673f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultCompound]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultCompound]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f075a7c452ad93ab32e6630687e080fd519f961e95a951a0625795bafc80e19e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultCompoundOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultCompoundOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__893c3bfae0da71fa9a9b10afb4d309d161a3afa1351c303f631713bd11644b34)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformations")
    def put_transformations(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d4a766c788e1672250da26b550c991db7fbb8f26693840c2705065af6dae8d35)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTransformations", [value]))

    @jsii.member(jsii_name="resetTransformations")
    def reset_transformations(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformations", []))

    @builtins.property
    @jsii.member(jsii_name="transformations")
    def transformations(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultCompoundTransformationsList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultCompoundTransformationsList", jsii.get(self, "transformations"))

    @builtins.property
    @jsii.member(jsii_name="transformationsInput")
    def transformations_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultCompoundTransformations"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultCompoundTransformations"]]], jsii.get(self, "transformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultCompound]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultCompound]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultCompound]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__66d22412e913dc36d4397f9014f3b5f17a83dfb3526b2a875ae268d7fe332788)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultCompoundTransformations",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultCompoundTransformations:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultCompoundTransformations(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultCompoundTransformationsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultCompoundTransformationsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b2669fd0531e7874d3d8073061aa315006341e8be5249ba3c329aa13211c5da4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultCompoundTransformationsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c10f2f9d086297d9b035cd34e4043f925f128a91139566b0f1fd34ee8765a6d5)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultCompoundTransformationsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4c649a6d545cccdc85969fe7e99441e992b1c0c46aa9079f1fc346cb354bb850)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__55a8380f83f7106b6c2e30904f7b08b9e56e2049ce410628d23e023c6393352b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__73925af45eb03545353320768cddc2adbb764039e47fd13c8dd22aefe0660e31)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultCompoundTransformations]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultCompoundTransformations]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultCompoundTransformations]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0efa7a5707ddebb2ffb67d6373ccd719c090467fbd10060eca7847b2f627caf3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultCompoundTransformationsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultCompoundTransformationsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__93fcf67811f3c158442b09645882ed59580b086276ddab799a10d34e6eb6d688)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultCompoundTransformations]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultCompoundTransformations]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultCompoundTransformations]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__53d19bc0d5c9d0abb1efeec946bb8073b7fcbde57799b3dc2d659bfb90ff729a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultContrast",
    jsii_struct_bases=[],
    name_mapping={
        "brightness": "brightness",
        "brightness_var": "brightnessVar",
        "contrast": "contrast",
        "contrast_var": "contrastVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultContrast:
    def __init__(
        self,
        *,
        brightness: typing.Optional[builtins.str] = None,
        brightness_var: typing.Optional[builtins.str] = None,
        contrast: typing.Optional[builtins.str] = None,
        contrast_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param brightness: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        :param brightness_var: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        :param contrast: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param contrast_var: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__43f5a721575389f96d6ce47efca1b404d4818adb3fcb0d9474f2329a5b379ab3)
            check_type(argname="argument brightness", value=brightness, expected_type=type_hints["brightness"])
            check_type(argname="argument brightness_var", value=brightness_var, expected_type=type_hints["brightness_var"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument contrast_var", value=contrast_var, expected_type=type_hints["contrast_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if brightness is not None:
            self._values["brightness"] = brightness
        if brightness_var is not None:
            self._values["brightness_var"] = brightness_var
        if contrast is not None:
            self._values["contrast"] = contrast
        if contrast_var is not None:
            self._values["contrast_var"] = contrast_var

    @builtins.property
    def brightness(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        '''
        result = self._values.get("brightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def brightness_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        '''
        result = self._values.get("brightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        result = self._values.get("contrast_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultContrast(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultContrastList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultContrastList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc662201f23dc146f6ab954b95448128f551befe96ed778aa24c586b9cc1ba4b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultContrastOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__56164205f333865c4540550f9d0b55d11b828abff71a096d87081c2d62e29ebb)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultContrastOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__69accd37b68f51181e1733a8e61767c6185ed981dd3c5e2c62c3d3630dabaa1e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ceae83332705eb50703a6f23f0e440722755c57641205eb79473c4750a7d425)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__56ca3a675c985802b63b2875179795120c373a6602805affba8a05f10d7e49ca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultContrast]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultContrast]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__272b4384323eb58f9d531e27c42ea593859d0f33d9eb0e99bb73a6fb9ac6fcb3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultContrastOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultContrastOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6a7718756592dc423384d335fa3ea97bcb81b05c54a7318da3fe061bb30ced1e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetBrightness")
    def reset_brightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightness", []))

    @jsii.member(jsii_name="resetBrightnessVar")
    def reset_brightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightnessVar", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetContrastVar")
    def reset_contrast_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrastVar", []))

    @builtins.property
    @jsii.member(jsii_name="brightnessInput")
    def brightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="brightnessVarInput")
    def brightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastVarInput")
    def contrast_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="brightness")
    def brightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightness"))

    @brightness.setter
    def brightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__28254a0d3807bef79a4bd6ab946a571299b39d1b51c609d6f8f94ba658eef50a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightness", value)

    @builtins.property
    @jsii.member(jsii_name="brightnessVar")
    def brightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightnessVar"))

    @brightness_var.setter
    def brightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d65d051e262c08219325e4071cef1cfa37048f8bc9955d4fede4fe22f99a2c24)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrast"))

    @contrast.setter
    def contrast(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__662d15e0d0a76f6573f93e9385ba6f79ff6fa13efafa2742bb891d341be50732)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrast", value)

    @builtins.property
    @jsii.member(jsii_name="contrastVar")
    def contrast_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrastVar"))

    @contrast_var.setter
    def contrast_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__18903c32c80a24637c18976268e8aaca76afbd59da36125fa39ef8af879868fd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrastVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultContrast]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultContrast]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultContrast]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a70b0c258327cb657b9176caa470c7ce2e77d2d3183baa5519bf4c69361ef216)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultGoop",
    jsii_struct_bases=[],
    name_mapping={
        "chaos": "chaos",
        "chaos_var": "chaosVar",
        "density": "density",
        "density_var": "densityVar",
        "power": "power",
        "power_var": "powerVar",
        "seed": "seed",
        "seed_var": "seedVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultGoop:
    def __init__(
        self,
        *,
        chaos: typing.Optional[builtins.str] = None,
        chaos_var: typing.Optional[builtins.str] = None,
        density: typing.Optional[builtins.str] = None,
        density_var: typing.Optional[builtins.str] = None,
        power: typing.Optional[builtins.str] = None,
        power_var: typing.Optional[builtins.str] = None,
        seed: typing.Optional[builtins.str] = None,
        seed_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param chaos: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        :param chaos_var: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        :param density: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        :param density_var: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        :param power: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        :param power_var: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        :param seed: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        :param seed_var: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1727715b548740add1d49b7eafe052270b9c4a415d76d440c8543c8ff790d3b9)
            check_type(argname="argument chaos", value=chaos, expected_type=type_hints["chaos"])
            check_type(argname="argument chaos_var", value=chaos_var, expected_type=type_hints["chaos_var"])
            check_type(argname="argument density", value=density, expected_type=type_hints["density"])
            check_type(argname="argument density_var", value=density_var, expected_type=type_hints["density_var"])
            check_type(argname="argument power", value=power, expected_type=type_hints["power"])
            check_type(argname="argument power_var", value=power_var, expected_type=type_hints["power_var"])
            check_type(argname="argument seed", value=seed, expected_type=type_hints["seed"])
            check_type(argname="argument seed_var", value=seed_var, expected_type=type_hints["seed_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if chaos is not None:
            self._values["chaos"] = chaos
        if chaos_var is not None:
            self._values["chaos_var"] = chaos_var
        if density is not None:
            self._values["density"] = density
        if density_var is not None:
            self._values["density_var"] = density_var
        if power is not None:
            self._values["power"] = power
        if power_var is not None:
            self._values["power_var"] = power_var
        if seed is not None:
            self._values["seed"] = seed
        if seed_var is not None:
            self._values["seed_var"] = seed_var

    @builtins.property
    def chaos(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        '''
        result = self._values.get("chaos")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def chaos_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        '''
        result = self._values.get("chaos_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        '''
        result = self._values.get("density")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density_var(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        '''
        result = self._values.get("density_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        '''
        result = self._values.get("power")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power_var(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        '''
        result = self._values.get("power_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        '''
        result = self._values.get("seed")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed_var(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        result = self._values.get("seed_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultGoop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultGoopList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultGoopList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__94a30451cbb1553b1db0c3e194087775098652c28e84146bce7e4e5f01d2c402)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultGoopOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__865f6a71995559f83823f2873ad0595b32a06fd54be5b333828aa8a9a759558b)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultGoopOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9232e3ca35be25fb19b9aff0c0ca89ae4b1d65c54024856bc50c9e938856ca26)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ae2db63400a76f8b682db995bd4b34e63d9080bd60b126007af1eaec6248790a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d07289769ab833959f26bd8e70c9eccd3d4e1471b5524a54abe8f175d4fa63a8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultGoop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultGoop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__256bee94e8d46e3c7f391bf99a278cbfc1dd3d9bf4f51ec43b3a45c8ac607e81)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultGoopOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultGoopOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c4475ddc9bac9ef20ccfd36ab108de3a0dae0e0ef4aa11b093d9cee1d9ff1987)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetChaos")
    def reset_chaos(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaos", []))

    @jsii.member(jsii_name="resetChaosVar")
    def reset_chaos_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaosVar", []))

    @jsii.member(jsii_name="resetDensity")
    def reset_density(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensity", []))

    @jsii.member(jsii_name="resetDensityVar")
    def reset_density_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensityVar", []))

    @jsii.member(jsii_name="resetPower")
    def reset_power(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPower", []))

    @jsii.member(jsii_name="resetPowerVar")
    def reset_power_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPowerVar", []))

    @jsii.member(jsii_name="resetSeed")
    def reset_seed(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeed", []))

    @jsii.member(jsii_name="resetSeedVar")
    def reset_seed_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeedVar", []))

    @builtins.property
    @jsii.member(jsii_name="chaosInput")
    def chaos_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosInput"))

    @builtins.property
    @jsii.member(jsii_name="chaosVarInput")
    def chaos_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosVarInput"))

    @builtins.property
    @jsii.member(jsii_name="densityInput")
    def density_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityInput"))

    @builtins.property
    @jsii.member(jsii_name="densityVarInput")
    def density_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="powerInput")
    def power_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerInput"))

    @builtins.property
    @jsii.member(jsii_name="powerVarInput")
    def power_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerVarInput"))

    @builtins.property
    @jsii.member(jsii_name="seedInput")
    def seed_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedInput"))

    @builtins.property
    @jsii.member(jsii_name="seedVarInput")
    def seed_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedVarInput"))

    @builtins.property
    @jsii.member(jsii_name="chaos")
    def chaos(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaos"))

    @chaos.setter
    def chaos(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6a35e6b07d0887dae8a88bab9439a0e2099c288343f5f44b22e759c477e87fca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaos", value)

    @builtins.property
    @jsii.member(jsii_name="chaosVar")
    def chaos_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaosVar"))

    @chaos_var.setter
    def chaos_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__907f5b588c13263397cbdf4bc681aa16aca50966d84ce8ad3d39d0e0ac2e7a49)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaosVar", value)

    @builtins.property
    @jsii.member(jsii_name="density")
    def density(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "density"))

    @density.setter
    def density(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0bd736c373d6933b42cf872aad7b5a0f38d6d5c7f12b78ae912b3e1e458f069b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "density", value)

    @builtins.property
    @jsii.member(jsii_name="densityVar")
    def density_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "densityVar"))

    @density_var.setter
    def density_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7f9ff0632da6521dd9d23c2ba096220b53f0ecbe821b87bd4b646e90a8ca761a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "densityVar", value)

    @builtins.property
    @jsii.member(jsii_name="power")
    def power(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "power"))

    @power.setter
    def power(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d91ce3b04db0deed910f1c096c2c58221595a30ba4751957fa7da0ef757cf137)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "power", value)

    @builtins.property
    @jsii.member(jsii_name="powerVar")
    def power_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "powerVar"))

    @power_var.setter
    def power_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e0669117ad910b6c333150d16cf5ec970c856333f950ea2b6ffc265bbf52ea37)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "powerVar", value)

    @builtins.property
    @jsii.member(jsii_name="seed")
    def seed(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seed"))

    @seed.setter
    def seed(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__50d579922eef3c1b47b815e34059fbc4e4343787668b37b8fd3a8acbf2c6baad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seed", value)

    @builtins.property
    @jsii.member(jsii_name="seedVar")
    def seed_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seedVar"))

    @seed_var.setter
    def seed_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a768fa15938aa6575413ff2c95fd19f9f91761add18fc49f22772bc922c6a90)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seedVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultGoop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultGoop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultGoop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a44f4047fe43fa1df29a6c3501dfd8548f41803d6dd6c13844cfd34d9e63aaa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultGrayscale",
    jsii_struct_bases=[],
    name_mapping={"type": "type", "type_var": "typeVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultGrayscale:
    def __init__(
        self,
        *,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param type: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__77ae4264d9e36f2bb79def5d16129e27300cdc6744834bbdb62ad9ffbae1d7b1)
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultGrayscale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultGrayscaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultGrayscaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3317cae27c947a344c7a7e55639fd2c158bf21590207ec6504ee205807af40e2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultGrayscaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6874e155b67f7c8a88dfeb87e7e97afb1c100fa6917e2b0730b3ba3200691286)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultGrayscaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c62c0b77e94f71aa37782f149ca613e216b69d72719e9925959e441938f95003)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7e245b85c5e1f63826566e538566622e880c74b2a28e67fa5bfce9b6d6185266)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2e78693ab6fc36ad99e7669d70befa1f4853c62cc0aa9d82a8eb97e2c9ce0403)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultGrayscale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultGrayscale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a1aca137164626a5b346d572fe26a5c786192445a63ce01f578299c7d26b302)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultGrayscaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultGrayscaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fdf1e3ec901813f3ececa3132e2e03842658a498723c92d120640855775dbb88)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__29a42d9ceb03e1ee42ce8276db33a552adbede58a702fe29f164627ebdc63f2c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ba207ca304303232e2f1f6e0214d3729e2a25adfa4fe1297eec124c6c3b50130)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultGrayscale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultGrayscale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultGrayscale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__911af5536451f892bf5932cd1c6999b4b93feb81e7be0832af98393864f6cef7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultHsl",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "lightness": "lightness",
        "lightness_var": "lightnessVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultHsl:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness: typing.Optional[builtins.str] = None,
        lightness_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        :param lightness_var: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2e0565c0bf8cc3ab424845b9d0d00a01226bc83932febf01404c4a4304fa6644)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness", value=lightness, expected_type=type_hints["lightness"])
            check_type(argname="argument lightness_var", value=lightness_var, expected_type=type_hints["lightness_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness is not None:
            self._values["lightness"] = lightness
        if lightness_var is not None:
            self._values["lightness_var"] = lightness_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        '''
        result = self._values.get("lightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        '''
        result = self._values.get("lightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultHsl(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultHslList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultHslList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__29f423b9ad48a96d5259d4d1407d33dc1717b3336b3d4290d323366fee4b8006)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultHslOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__86b528572af8de1736330ca01e0494e0b74b6d71b5c19d21a14f1e4188591211)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultHslOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1291e7871a3d123222b216acc54a2dd0b3f29089f54429654585e83912ed1762)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6a88b296a3319fa9ab3f1990af31e72651dc2c5b95d2920e207a4950e47e3eda)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__db61eebada994c4ef6f557425c8f689ce8636be36741ab976c1998dd85ee9835)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultHsl]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultHsl]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9b40e2f7d4bd7d809c9eda10d589294519160df1c3c519c6826f57ec658b5502)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultHslOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultHslOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c6ba1c8e00ce0b79c795b0219e9fd82dcd3f0249d28e20b94f2f2d523b40d6a6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightness")
    def reset_lightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightness", []))

    @jsii.member(jsii_name="resetLightnessVar")
    def reset_lightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessInput")
    def lightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessVarInput")
    def lightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__068854419254c124abd064e5a8305fd5b88aeedd60615fb7cf11aa992951b9c7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f30f2d94298a70f72a92e58197ea59c16cd80e6570daae531dad5e1af96f394)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightness")
    def lightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightness"))

    @lightness.setter
    def lightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__178772569aee27c2e3955280bf1fe237b4d7a8701b680fd3cf74897934eb8c7f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightness", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessVar")
    def lightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessVar"))

    @lightness_var.setter
    def lightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a2d0740feccc0a4d152c64187fb7ea39bee805981519d300f5257573232149a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__97fb250524ec7510d8d1fede5ff2fafc2270588f7dd9efcf421802ceb033d348)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8b0a55be7393e23089436623fa01ea38fab8e1555cdb384044783d3de12b840e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultHsl]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultHsl]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultHsl]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__40da64448f81f18c57a610160fd3a347ca1a3787b8e45ab8b93d9a7306b29717)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultHsv",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultHsv:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        :param value: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d74324633366cfb7f43c4b99ca6eeda27ac71826908f71fdd0bc23ac593977e)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultHsv(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultHsvList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultHsvList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c71c3e9119b3b084076679f94db47149932d835d25b76163a05a495d86fd481a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultHsvOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d05bbfd2ac3736d3e078e23cdbe9eada50f12e4d13bf24a6e0b4bfcd6baec275)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultHsvOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b0aaaabecea965c3e55035b305aa79f840d6c52a370af3ca12a4db4b5f5e39c9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__22ed97cd78fafd8ca407b2b14a475ee7191d60fb76995527660a214b1372d6f6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f22309eba46479db00744602d179e99032008d16fe9339a1eae1dce4d0ac858)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultHsv]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultHsv]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d31bec0d71d51ee13a7919a15a8fd4da5e0afecf2a18e71ff1207dc6d82eb880)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultHsvOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultHsvOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__62d9d289bf2d55fb168904045b1b50d9ca46383981193567f0227b8de7c32fc3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5641170fd27c3f308edfb52c01ea7de81f8e788932252deb1079663bd9231931)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b4e995ee23351bfa033490461dbd6c24886a70b8d85b0fd37a7a91e7fd9f4d9b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__15efc89ed8bce6d38abf92ebdbfde0b986ddcbc100752d26e34bfdbae857d9b9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e22c2721ef43d5609c22e53fc8f4d420348165ebcff13caa3f733b21c3ffce09)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1fea7e0f08529923e08f818cbdc91cbdb81857cb692a2fe2752b15a4f9d05c22)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ede2a445f16d7627264acedfc0c4e8ef864d394306cbb4659715f0050b48069d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultHsv]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultHsv]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultHsv]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d70e983faa31716a4cdb352c4383f0771dda499155ae6806f0896116b9efafaf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimension",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "dimension": "dimension",
        "dimension_var": "dimensionVar",
        "equal": "equal",
        "greater_than": "greaterThan",
        "less_than": "lessThan",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimension:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        dimension: typing.Optional[builtins.str] = None,
        dimension_var: typing.Optional[builtins.str] = None,
        equal: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionEqual", typing.Dict[builtins.str, typing.Any]]] = None,
        greater_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionGreaterThan", typing.Dict[builtins.str, typing.Any]]] = None,
        less_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionLessThan", typing.Dict[builtins.str, typing.Any]]] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param dimension: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        :param dimension_var: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        :param equal: equal block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        :param greater_than: greater_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        :param less_than: less_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        :param value: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionDefault(**default)
        if isinstance(equal, dict):
            equal = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionEqual(**equal)
        if isinstance(greater_than, dict):
            greater_than = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionGreaterThan(**greater_than)
        if isinstance(less_than, dict):
            less_than = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionLessThan(**less_than)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1266761775bd8d78ae958cb869e9ae2dfc46f42c9c2471f34e08fbf321a46f96)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument dimension", value=dimension, expected_type=type_hints["dimension"])
            check_type(argname="argument dimension_var", value=dimension_var, expected_type=type_hints["dimension_var"])
            check_type(argname="argument equal", value=equal, expected_type=type_hints["equal"])
            check_type(argname="argument greater_than", value=greater_than, expected_type=type_hints["greater_than"])
            check_type(argname="argument less_than", value=less_than, expected_type=type_hints["less_than"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if dimension is not None:
            self._values["dimension"] = dimension
        if dimension_var is not None:
            self._values["dimension_var"] = dimension_var
        if equal is not None:
            self._values["equal"] = equal
        if greater_than is not None:
            self._values["greater_than"] = greater_than
        if less_than is not None:
            self._values["less_than"] = less_than
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionDefault"], result)

    @builtins.property
    def dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        '''
        result = self._values.get("dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        '''
        result = self._values.get("dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def equal(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionEqual"]:
        '''equal block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        '''
        result = self._values.get("equal")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionEqual"], result)

    @builtins.property
    def greater_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionGreaterThan"]:
        '''greater_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        '''
        result = self._values.get("greater_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionGreaterThan"], result)

    @builtins.property
    def less_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionLessThan"]:
        '''less_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        '''
        result = self._values.get("less_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionLessThan"], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimension(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6958bfdf69c75943dcd93bb4d4d7a9a8bdd04d09ac2c101ee22ee62de7c1dc80)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7f0adc98772a1648e63ce567637b9c7def7327ea51c3624eec55d73fbcffb0b3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionEqual",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionEqual:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionEqual(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionEqualOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionEqualOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8282de526445c9f575b000df6ea257a4aff68acfbadbbb8ec0fe20295a39885c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionEqual], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionEqual],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f282f136b0c4af5e1e89d73eb971feefc5cc63608cac776f5498c53dfe77eb3e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionGreaterThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionGreaterThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionGreaterThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionGreaterThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionGreaterThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__36082c0a298b415da1b1ddf6d94b64c171f2c6e6723c680dc6e5b9b78eb808db)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionGreaterThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionGreaterThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d618400d048b9630a96c8c4c11514185a5b229f271eb46bfcea02a8d02c9dafc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionLessThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionLessThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionLessThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionLessThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionLessThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6cfd5d3be6471c60c5dbb53cfeedee6911370b5e79fad5f7ecb4743b0485ac8b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionLessThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionLessThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__697b1c4ab6f96240fee0dd03c2bbcaeca151fca59d389f2dcb39a0873b90cd01)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e591e39ac742ef374a2df71887fbfc35d31df08a3fb8b1d7f6f7c0454c0c27d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__838f20302e9379e743b7b2f142bc45e845c50c6fc3b1c9b9deebc1c705e56f91)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fe426a27c835eec685ec76ba117117d83876929be46ac2297db66d6bc73238a8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f7de2d35219f2aa67490f8560ec07f1933e59fed78530c1333e3d2053c4ad0f4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9671f3231a74b9c4b370feb9f39c75bf6ecd21ae0d370ce9798533a5732a3a78)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimension]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimension]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__99663152586cd6778f71a01de8bdaaa2933a79abed4ae123cb4a132b2497578b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ad3933a2737858f9eb39af987ceb2511c39954afdf95d343fa9d4462e23cafc6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putEqual")
    def put_equal(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionEqual()

        return typing.cast(None, jsii.invoke(self, "putEqual", [value]))

    @jsii.member(jsii_name="putGreaterThan")
    def put_greater_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionGreaterThan()

        return typing.cast(None, jsii.invoke(self, "putGreaterThan", [value]))

    @jsii.member(jsii_name="putLessThan")
    def put_less_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionLessThan()

        return typing.cast(None, jsii.invoke(self, "putLessThan", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetDimension")
    def reset_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimension", []))

    @jsii.member(jsii_name="resetDimensionVar")
    def reset_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimensionVar", []))

    @jsii.member(jsii_name="resetEqual")
    def reset_equal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEqual", []))

    @jsii.member(jsii_name="resetGreaterThan")
    def reset_greater_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGreaterThan", []))

    @jsii.member(jsii_name="resetLessThan")
    def reset_less_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLessThan", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="equal")
    def equal(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionEqualOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionEqualOutputReference, jsii.get(self, "equal"))

    @builtins.property
    @jsii.member(jsii_name="greaterThan")
    def greater_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionGreaterThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionGreaterThanOutputReference, jsii.get(self, "greaterThan"))

    @builtins.property
    @jsii.member(jsii_name="lessThan")
    def less_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionLessThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionLessThanOutputReference, jsii.get(self, "lessThan"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionInput")
    def dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionVarInput")
    def dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="equalInput")
    def equal_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionEqual], jsii.get(self, "equalInput"))

    @builtins.property
    @jsii.member(jsii_name="greaterThanInput")
    def greater_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionGreaterThan], jsii.get(self, "greaterThanInput"))

    @builtins.property
    @jsii.member(jsii_name="lessThanInput")
    def less_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionLessThan], jsii.get(self, "lessThanInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="dimension")
    def dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimension"))

    @dimension.setter
    def dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__403db2903a5d7f5681393080e16f6a34df001a3f27583a59c100309e9b0f71af)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimension", value)

    @builtins.property
    @jsii.member(jsii_name="dimensionVar")
    def dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimensionVar"))

    @dimension_var.setter
    def dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f094f0f0eccf8bc2ae68c4c732b0642e5713d59eb9072ac53f86e89a973b4bfb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fba59a0c41aac3e30bbd0d65d6e650e9c0e913b56ee7ab271af043277631a0d8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__348af317caa5bf2cf5be306b1589852a51ef8c4c4dbc7681152594eeb924d467)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimension]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimension]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimension]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5a4e646e4f8c527ba895bb42a8bfea63ac45d13d0649ee15f71b8d3b470000e1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientation",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "landscape": "landscape",
        "portrait": "portrait",
        "square": "square",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientation:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        landscape: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationLandscape", typing.Dict[builtins.str, typing.Any]]] = None,
        portrait: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationPortrait", typing.Dict[builtins.str, typing.Any]]] = None,
        square: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationSquare", typing.Dict[builtins.str, typing.Any]]] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param landscape: landscape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        :param portrait: portrait block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        :param square: square block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationDefault(**default)
        if isinstance(landscape, dict):
            landscape = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationLandscape(**landscape)
        if isinstance(portrait, dict):
            portrait = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationPortrait(**portrait)
        if isinstance(square, dict):
            square = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationSquare(**square)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7733262eebf23d441123486a1c9c6971c144c5c0c250c9c70cb745b7db72b48f)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument landscape", value=landscape, expected_type=type_hints["landscape"])
            check_type(argname="argument portrait", value=portrait, expected_type=type_hints["portrait"])
            check_type(argname="argument square", value=square, expected_type=type_hints["square"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if landscape is not None:
            self._values["landscape"] = landscape
        if portrait is not None:
            self._values["portrait"] = portrait
        if square is not None:
            self._values["square"] = square

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationDefault"], result)

    @builtins.property
    def landscape(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationLandscape"]:
        '''landscape block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        '''
        result = self._values.get("landscape")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationLandscape"], result)

    @builtins.property
    def portrait(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationPortrait"]:
        '''portrait block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        '''
        result = self._values.get("portrait")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationPortrait"], result)

    @builtins.property
    def square(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationSquare"]:
        '''square block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        result = self._values.get("square")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationSquare"], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4e61f33ac8a1f663b0a3f0b152c30778cafd6d30f00edc6bcccc20e3293157dd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__910a2547b7218d024eebf1c9383443b49c755b1888a48969c8fc60bdee157804)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationLandscape",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationLandscape:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationLandscape(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationLandscapeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationLandscapeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__738366e36470630b99bee0a1d84511a997fc26ee036d4770acd22ab0ff6eabb9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationLandscape], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationLandscape],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9f42af440dc2c19179d31e7af5d9b4def1f0a43ae61c2a58c147786c704975d7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__13edb5c108ba5b980413f867f3fef0022b9f158a9a9bac2602fb3ec832ada746)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__857b448f90b3a4479b50761bea0f67e362fc3472ecdf187ccfeac149ff96d7c1)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8176ad5422155502d6a57f29769d25977b2e2c960eaa099f2eff944ad9a18476)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6905c047af4c44199306dee9d837b01dfd6b5255f57ca864943ea5ec97310019)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b1f16ad537591c380cbe19f40021ccf7e4230f5a819a4fc827095ff12bb03ea1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientation]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientation]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5aae8c842690a23f252ec7ff796777b96954cf83ac586b5bf9e7c925ccfae97a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__037a0454550a62b78aef2760a3e0236bcf2ea0a8570f4073015c1c60849697c6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putLandscape")
    def put_landscape(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationLandscape()

        return typing.cast(None, jsii.invoke(self, "putLandscape", [value]))

    @jsii.member(jsii_name="putPortrait")
    def put_portrait(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationPortrait()

        return typing.cast(None, jsii.invoke(self, "putPortrait", [value]))

    @jsii.member(jsii_name="putSquare")
    def put_square(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationSquare()

        return typing.cast(None, jsii.invoke(self, "putSquare", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetLandscape")
    def reset_landscape(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLandscape", []))

    @jsii.member(jsii_name="resetPortrait")
    def reset_portrait(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPortrait", []))

    @jsii.member(jsii_name="resetSquare")
    def reset_square(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSquare", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="landscape")
    def landscape(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationLandscapeOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationLandscapeOutputReference, jsii.get(self, "landscape"))

    @builtins.property
    @jsii.member(jsii_name="portrait")
    def portrait(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationPortraitOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationPortraitOutputReference", jsii.get(self, "portrait"))

    @builtins.property
    @jsii.member(jsii_name="square")
    def square(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationSquareOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationSquareOutputReference", jsii.get(self, "square"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="landscapeInput")
    def landscape_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationLandscape], jsii.get(self, "landscapeInput"))

    @builtins.property
    @jsii.member(jsii_name="portraitInput")
    def portrait_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationPortrait"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationPortrait"], jsii.get(self, "portraitInput"))

    @builtins.property
    @jsii.member(jsii_name="squareInput")
    def square_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationSquare"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationSquare"], jsii.get(self, "squareInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientation]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientation]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientation]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__92c5952b047d1b5d797bd5e67f358da11eda080903a46c1c6cb420dbe5f9e936)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationPortrait",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationPortrait:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationPortrait(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationPortraitOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationPortraitOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a90064a5da66c621366890532b2e4ff5260399aec782ad040f3b7d4c21308ee1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationPortrait]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationPortrait], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationPortrait],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fe58a88d2a9abe5a8336fe0268e044a317f1871c8ed3a0bee1441dafb7bbf003)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationSquare",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationSquare:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationSquare(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationSquareOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationSquareOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__295898f745e61fbfae89039643707a99c5263c61cb7f7ec8f78d709c9559a1b0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationSquare]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationSquare], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationSquare],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2063980bfad37cab178d635a8ba9540517ec97ce8d166ac94d65a2ecc5d710f6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultMaxColors",
    jsii_struct_bases=[],
    name_mapping={"colors": "colors", "colors_var": "colorsVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultMaxColors:
    def __init__(
        self,
        *,
        colors: typing.Optional[builtins.str] = None,
        colors_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param colors: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        :param colors_var: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f315a36475a82c0f0b0ce4df28953a41bbb39d36f80325ec44871d63f9a1b977)
            check_type(argname="argument colors", value=colors, expected_type=type_hints["colors"])
            check_type(argname="argument colors_var", value=colors_var, expected_type=type_hints["colors_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if colors is not None:
            self._values["colors"] = colors
        if colors_var is not None:
            self._values["colors_var"] = colors_var

    @builtins.property
    def colors(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        '''
        result = self._values.get("colors")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def colors_var(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        result = self._values.get("colors_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultMaxColors(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultMaxColorsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultMaxColorsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__596f12d6b55c12b0b06a342c54fd2dbdd87b90c4675182c4b45d63db242289a1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultMaxColorsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f00bc5489561ad4c753dec4ccfdce12428437b2d3a824a4145249b0a87901a99)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultMaxColorsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3d9fa42d27994ff8188d3156a5d0955469af62092db4dd7854da105df9e886e0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__edc97837e8072323c7efaee80136af9e5585ee2a3817b9b531821d6dad5a7ae3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__88f4853b8813d8664763308e6133af2476e0aef87b088756058e9fe943e6e94c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultMaxColors]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultMaxColors]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5459fba41372ecb421f15a7a19586d75ac94576628b22265e0e5c5fff8c9cfe7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultMaxColorsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultMaxColorsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__97c815dcc102b410464fc7e9b0f165bd6c8a6d76f2b2a18383c216a4649979d3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColors")
    def reset_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColors", []))

    @jsii.member(jsii_name="resetColorsVar")
    def reset_colors_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorsVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorsInput")
    def colors_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsInput"))

    @builtins.property
    @jsii.member(jsii_name="colorsVarInput")
    def colors_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsVarInput"))

    @builtins.property
    @jsii.member(jsii_name="colors")
    def colors(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colors"))

    @colors.setter
    def colors(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d76a334096cbb641ebf625cade63e1eb9f30785eee185f8b606fa2c6d9f2d9d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colors", value)

    @builtins.property
    @jsii.member(jsii_name="colorsVar")
    def colors_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorsVar"))

    @colors_var.setter
    def colors_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8b6100025295fe1b1fc874f33cee5c738fbc5193dcb90b0f8fbaf9e22ff0a3b8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorsVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultMaxColors]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultMaxColors]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultMaxColors]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ce698e08bca1d6f9d66b6c1230ef26647e2c8839ea0d8c9ac58ee3754e19a950)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultMirror",
    jsii_struct_bases=[],
    name_mapping={
        "horizontal": "horizontal",
        "horizontal_var": "horizontalVar",
        "vertical": "vertical",
        "vertical_var": "verticalVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultMirror:
    def __init__(
        self,
        *,
        horizontal: typing.Optional[builtins.str] = None,
        horizontal_var: typing.Optional[builtins.str] = None,
        vertical: typing.Optional[builtins.str] = None,
        vertical_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param horizontal: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        :param horizontal_var: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        :param vertical: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        :param vertical_var: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a684a956e8f3251729da00a6d56af350f672d134ebd2f5909c6436c30d066449)
            check_type(argname="argument horizontal", value=horizontal, expected_type=type_hints["horizontal"])
            check_type(argname="argument horizontal_var", value=horizontal_var, expected_type=type_hints["horizontal_var"])
            check_type(argname="argument vertical", value=vertical, expected_type=type_hints["vertical"])
            check_type(argname="argument vertical_var", value=vertical_var, expected_type=type_hints["vertical_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if horizontal is not None:
            self._values["horizontal"] = horizontal
        if horizontal_var is not None:
            self._values["horizontal_var"] = horizontal_var
        if vertical is not None:
            self._values["vertical"] = vertical
        if vertical_var is not None:
            self._values["vertical_var"] = vertical_var

    @builtins.property
    def horizontal(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        '''
        result = self._values.get("horizontal")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def horizontal_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        '''
        result = self._values.get("horizontal_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        '''
        result = self._values.get("vertical")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        result = self._values.get("vertical_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultMirror(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultMirrorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultMirrorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9bd98add09ecd9c2f50a3a49987d767359a71b52aa8ade06c66c1db06a475e52)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultMirrorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4dcaca31017c0be7676463f5d1792cc4621684cbe7ae7588164a53257b97f786)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultMirrorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__675c8ddc8fbc624afbc441e9bab362e5f5ce2ce2d3bc7cd6a5dafcced28fe64a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1587abf9e66d631659a8bbfa5133ce4252beebc352aec18907342a0200e5f10a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a0bab03d4c2af627ab7be22826b500de8e6b6ff335bd36426cf55a5222d8ad6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultMirror]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultMirror]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ae4c28b9f366e94496dbe03003aa92821fafceb8c5ed46264fca621c2d05c8d1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultMirrorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultMirrorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f4d4d432f5a5f12d426bb79cc98012ee25ac3fee93616d402a732825ea1b34fc)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHorizontal")
    def reset_horizontal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontal", []))

    @jsii.member(jsii_name="resetHorizontalVar")
    def reset_horizontal_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontalVar", []))

    @jsii.member(jsii_name="resetVertical")
    def reset_vertical(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVertical", []))

    @jsii.member(jsii_name="resetVerticalVar")
    def reset_vertical_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVerticalVar", []))

    @builtins.property
    @jsii.member(jsii_name="horizontalInput")
    def horizontal_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontalVarInput")
    def horizontal_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalInput")
    def vertical_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalVarInput")
    def vertical_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontal")
    def horizontal(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontal"))

    @horizontal.setter
    def horizontal(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__76bd4aa83a76e50769a401b768f03d1b016b788dc6eedf305b6fea049dcacf6b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontal", value)

    @builtins.property
    @jsii.member(jsii_name="horizontalVar")
    def horizontal_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontalVar"))

    @horizontal_var.setter
    def horizontal_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f67165bccec71072abb0294904ffb6b1e3e8e1f8366de1c46102ca84f7af8d0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontalVar", value)

    @builtins.property
    @jsii.member(jsii_name="vertical")
    def vertical(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "vertical"))

    @vertical.setter
    def vertical(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ff02694fab1c90f88926b666d5d3c2f40fda74bb96970de25965011121512b6b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "vertical", value)

    @builtins.property
    @jsii.member(jsii_name="verticalVar")
    def vertical_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "verticalVar"))

    @vertical_var.setter
    def vertical_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__59282cbe474826793ec1062c72b609b1e78ecf61eb08c6167623c9523c8ba4f6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "verticalVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultMirror]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultMirror]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultMirror]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7efc6466639b42c7222a6ecc966a2a20777f8b54ba4a56496ea68bb74cb16a5b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultMonoHue",
    jsii_struct_bases=[],
    name_mapping={"hue": "hue", "hue_var": "hueVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultMonoHue:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8ad5e84e328df404f184fb40cd1b89fb9d0c83b0fd676373bd231e4ab4ed740f)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultMonoHue(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultMonoHueList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultMonoHueList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__71066d9d297dd1b98402dd6c276d459ac4c0153e60d03e3b988d6a23fe304ea5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultMonoHueOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__90b65a4a955604bf354012dac5a61b0f80073af9ea9aba22c197ecf4488fe7c7)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultMonoHueOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e682e8e5f04dbbc0be1341e8190c33ec1ec43714b8b5a1c58d08edf17a24a803)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9e55b4db01d0346a54bd1ad721da34f927fec700cf9a6383116f853e07163c8c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c420d04e6bb812e4f73446b7e6e591853009d740fae49731713c8010a1ec3247)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultMonoHue]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultMonoHue]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa37b225a0f64b3d53475e24883bdefbaeef59f72c0ac64cc7c16be91f7a11e5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultMonoHueOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultMonoHueOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__86e14cb2a8db0fc4f053517b5c44c3fecc514988efa4af3c6db7785587bd480a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fb879716802204c905fba0f90967e904ebf0251cebc8f38780e52b2a7c9cc6d6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__40e3b2acd4ebc4222024c25a412a40a485aa9649a83996ea5e4a9bc5c9f7ea2d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultMonoHue]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultMonoHue]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultMonoHue]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__24221fe7defcf945a5f5e9f22525e94f23b9d0976683ec3f0c89154f1df1e22b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultOpacity",
    jsii_struct_bases=[],
    name_mapping={"opacity": "opacity", "opacity_var": "opacityVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultOpacity:
    def __init__(
        self,
        *,
        opacity: typing.Optional[builtins.str] = None,
        opacity_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param opacity: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param opacity_var: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f83de1106c50fb2add4da048ffe702f3472d2a15771b9540b14249fcc5ad0895)
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument opacity_var", value=opacity_var, expected_type=type_hints["opacity_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if opacity is not None:
            self._values["opacity"] = opacity
        if opacity_var is not None:
            self._values["opacity_var"] = opacity_var

    @builtins.property
    def opacity(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def opacity_var(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        result = self._values.get("opacity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultOpacity(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultOpacityList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultOpacityList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a619ed9bfdf7716af2736c389c96045c458b5fd5009640183390c1b3b2d73fc)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultOpacityOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d4bba8329dcb50bb1d0d844a6303eaf40a1fff95f4af3b3220a00b77ee9be7d9)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultOpacityOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e2a9564ad060017af6c93b6b170268965b6a02273563ebc7c4451f5b79ca48e3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eb97f1dc441b14db68babf27375ea9962e0a7e5295aa4b46582cc4de71584cb6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c87a2e86e355efd812d8264a6e658522347bf79e6ff94215b25ed868b02ebbf9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultOpacity]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultOpacity]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__115bd3f4d8810f0696d6ba51f8b36742fd83ab133c531d847d2f451a60913324)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultOpacityOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultOpacityOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fb22bdbf6491a8cd577d612a340ce4af5dc5fcdec4a160ff5bdd61e1d121f691)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetOpacityVar")
    def reset_opacity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacityVar", []))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityVarInput")
    def opacity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacity"))

    @opacity.setter
    def opacity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__16ad5922792f6e539457c92acfc9a5501d5bf9509eba214505bd4df582d83a83)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacity", value)

    @builtins.property
    @jsii.member(jsii_name="opacityVar")
    def opacity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacityVar"))

    @opacity_var.setter
    def opacity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7430e11e732da14d53ce971b9b0920437a65d66154fbf026f2da3a0564c25913)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacityVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultOpacity]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultOpacity]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultOpacity]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5a02a8b0318f0405de2149e4d01f6d51e0e15b5da58c06147b62d5a82566525a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4c9e05c89929ebf3e1a886ab0524a2af1d5185e1b1124c598224a52110309932)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putBackgroundColor")
    def put_background_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__50613441aefc1d5eb7e06e03983976f3d8c81cad39231f266b05eb1b11a3c83b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBackgroundColor", [value]))

    @jsii.member(jsii_name="putBlur")
    def put_blur(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultBlur, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__256e0e6feb9602a619e3f075379845a6bff18d423b93eb87dd2d7bc1a122b4ef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBlur", [value]))

    @jsii.member(jsii_name="putChromaKey")
    def put_chroma_key(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultChromaKey, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ec015d8cbc42fa0ca912b212d20c49f480b5e7ae89ebc341a147ff9f563349a9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putChromaKey", [value]))

    @jsii.member(jsii_name="putComposite")
    def put_composite(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultComposite, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__53507b894adc74a59972c6854fc07547be0e247b2c64f1f28013793547ce5060)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putComposite", [value]))

    @jsii.member(jsii_name="putCompound")
    def put_compound(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultCompound, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__25dcddf2da45fad5cb6d9cd1f0d7b5c91a5d46f580e60c5b473ca11b54baa43b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCompound", [value]))

    @jsii.member(jsii_name="putContrast")
    def put_contrast(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultContrast, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__25345fec16c9184f1d3e51e212512fa30628c204d8edbcef9db4d705d690b122)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putContrast", [value]))

    @jsii.member(jsii_name="putGoop")
    def put_goop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultGoop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__75de6f008df6895bd16afb729dfb55edd536e0dfde654926a354d5c2e6847b34)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGoop", [value]))

    @jsii.member(jsii_name="putGrayscale")
    def put_grayscale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultGrayscale, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a3e604905e791d6294e1443d85ea1c17a21202d83a9df40b5f29fb104e825930)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGrayscale", [value]))

    @jsii.member(jsii_name="putHsl")
    def put_hsl(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultHsl, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6d4894f68bd2a4a03cdaa614ce41bddf5f2c6af7e0a441d808ababd31936deea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsl", [value]))

    @jsii.member(jsii_name="putHsv")
    def put_hsv(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultHsv, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cbd225cf298d0f745aede1b774c742ed007d197bb05cf2b5b4bdfa7210a7fbd5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsv", [value]))

    @jsii.member(jsii_name="putIfDimension")
    def put_if_dimension(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimension, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac6db9e3c76851f3080075a27dd6f394467a43fff3417c6c935a395713d25be8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfDimension", [value]))

    @jsii.member(jsii_name="putIfOrientation")
    def put_if_orientation(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c653cca852db456caac7fb3c61c17bf3ceee796ff2181fa45053188c1656db8c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfOrientation", [value]))

    @jsii.member(jsii_name="putMaxColors")
    def put_max_colors(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultMaxColors, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4b4525cb8e584da3a907f621e94d66f8c8849bb879f0ab9d8249b25f363eb8bf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMaxColors", [value]))

    @jsii.member(jsii_name="putMirror")
    def put_mirror(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultMirror, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dc98d060a7f3548ad1e2d3f332dd71f6e7b14dcda5a1477d0ed23e6af9bdb2b1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMirror", [value]))

    @jsii.member(jsii_name="putMonoHue")
    def put_mono_hue(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultMonoHue, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0b68ce6d722132fd651510849edf9b836874f12677c1c0b3f291cc73bc606a77)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMonoHue", [value]))

    @jsii.member(jsii_name="putOpacity")
    def put_opacity(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultOpacity, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e9449a0cba6793d971bff310d295e46ba48f9e77db47828f7110975e387eba3f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putOpacity", [value]))

    @jsii.member(jsii_name="putRemoveColor")
    def put_remove_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultRemoveColor", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__55449b5b7a9a9806b08eaefe402b6079d880fab8a6be1f4660b20ddf8d4dee4c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRemoveColor", [value]))

    @jsii.member(jsii_name="putUnsharpMask")
    def put_unsharp_mask(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultUnsharpMask", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7ce66e630bc863ee553ae86cea9291836ba4b62fd6d674fda771bec1814b912b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putUnsharpMask", [value]))

    @jsii.member(jsii_name="resetBackgroundColor")
    def reset_background_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBackgroundColor", []))

    @jsii.member(jsii_name="resetBlur")
    def reset_blur(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBlur", []))

    @jsii.member(jsii_name="resetChromaKey")
    def reset_chroma_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChromaKey", []))

    @jsii.member(jsii_name="resetComposite")
    def reset_composite(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetComposite", []))

    @jsii.member(jsii_name="resetCompound")
    def reset_compound(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCompound", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetGoop")
    def reset_goop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGoop", []))

    @jsii.member(jsii_name="resetGrayscale")
    def reset_grayscale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGrayscale", []))

    @jsii.member(jsii_name="resetHsl")
    def reset_hsl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsl", []))

    @jsii.member(jsii_name="resetHsv")
    def reset_hsv(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsv", []))

    @jsii.member(jsii_name="resetIfDimension")
    def reset_if_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfDimension", []))

    @jsii.member(jsii_name="resetIfOrientation")
    def reset_if_orientation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfOrientation", []))

    @jsii.member(jsii_name="resetMaxColors")
    def reset_max_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxColors", []))

    @jsii.member(jsii_name="resetMirror")
    def reset_mirror(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMirror", []))

    @jsii.member(jsii_name="resetMonoHue")
    def reset_mono_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonoHue", []))

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetRemoveColor")
    def reset_remove_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRemoveColor", []))

    @jsii.member(jsii_name="resetUnsharpMask")
    def reset_unsharp_mask(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUnsharpMask", []))

    @builtins.property
    @jsii.member(jsii_name="backgroundColor")
    def background_color(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultBackgroundColorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultBackgroundColorList, jsii.get(self, "backgroundColor"))

    @builtins.property
    @jsii.member(jsii_name="blur")
    def blur(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultBlurList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultBlurList, jsii.get(self, "blur"))

    @builtins.property
    @jsii.member(jsii_name="chromaKey")
    def chroma_key(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultChromaKeyList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultChromaKeyList, jsii.get(self, "chromaKey"))

    @builtins.property
    @jsii.member(jsii_name="composite")
    def composite(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultCompositeList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultCompositeList, jsii.get(self, "composite"))

    @builtins.property
    @jsii.member(jsii_name="compound")
    def compound(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultCompoundList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultCompoundList, jsii.get(self, "compound"))

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultContrastList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultContrastList, jsii.get(self, "contrast"))

    @builtins.property
    @jsii.member(jsii_name="goop")
    def goop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultGoopList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultGoopList, jsii.get(self, "goop"))

    @builtins.property
    @jsii.member(jsii_name="grayscale")
    def grayscale(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultGrayscaleList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultGrayscaleList, jsii.get(self, "grayscale"))

    @builtins.property
    @jsii.member(jsii_name="hsl")
    def hsl(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultHslList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultHslList, jsii.get(self, "hsl"))

    @builtins.property
    @jsii.member(jsii_name="hsv")
    def hsv(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultHsvList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultHsvList, jsii.get(self, "hsv"))

    @builtins.property
    @jsii.member(jsii_name="ifDimension")
    def if_dimension(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionList, jsii.get(self, "ifDimension"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientation")
    def if_orientation(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationList, jsii.get(self, "ifOrientation"))

    @builtins.property
    @jsii.member(jsii_name="maxColors")
    def max_colors(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultMaxColorsList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultMaxColorsList, jsii.get(self, "maxColors"))

    @builtins.property
    @jsii.member(jsii_name="mirror")
    def mirror(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultMirrorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultMirrorList, jsii.get(self, "mirror"))

    @builtins.property
    @jsii.member(jsii_name="monoHue")
    def mono_hue(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultMonoHueList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultMonoHueList, jsii.get(self, "monoHue"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultOpacityList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultOpacityList, jsii.get(self, "opacity"))

    @builtins.property
    @jsii.member(jsii_name="removeColor")
    def remove_color(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultRemoveColorList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultRemoveColorList", jsii.get(self, "removeColor"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMask")
    def unsharp_mask(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultUnsharpMaskList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultUnsharpMaskList", jsii.get(self, "unsharpMask"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColorInput")
    def background_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultBackgroundColor]]], jsii.get(self, "backgroundColorInput"))

    @builtins.property
    @jsii.member(jsii_name="blurInput")
    def blur_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultBlur]]], jsii.get(self, "blurInput"))

    @builtins.property
    @jsii.member(jsii_name="chromaKeyInput")
    def chroma_key_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultChromaKey]]], jsii.get(self, "chromaKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="compositeInput")
    def composite_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultComposite]]], jsii.get(self, "compositeInput"))

    @builtins.property
    @jsii.member(jsii_name="compoundInput")
    def compound_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultCompound]]], jsii.get(self, "compoundInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultContrast]]], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="goopInput")
    def goop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultGoop]]], jsii.get(self, "goopInput"))

    @builtins.property
    @jsii.member(jsii_name="grayscaleInput")
    def grayscale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultGrayscale]]], jsii.get(self, "grayscaleInput"))

    @builtins.property
    @jsii.member(jsii_name="hslInput")
    def hsl_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultHsl]]], jsii.get(self, "hslInput"))

    @builtins.property
    @jsii.member(jsii_name="hsvInput")
    def hsv_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultHsv]]], jsii.get(self, "hsvInput"))

    @builtins.property
    @jsii.member(jsii_name="ifDimensionInput")
    def if_dimension_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimension]]], jsii.get(self, "ifDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientationInput")
    def if_orientation_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientation]]], jsii.get(self, "ifOrientationInput"))

    @builtins.property
    @jsii.member(jsii_name="maxColorsInput")
    def max_colors_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultMaxColors]]], jsii.get(self, "maxColorsInput"))

    @builtins.property
    @jsii.member(jsii_name="mirrorInput")
    def mirror_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultMirror]]], jsii.get(self, "mirrorInput"))

    @builtins.property
    @jsii.member(jsii_name="monoHueInput")
    def mono_hue_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultMonoHue]]], jsii.get(self, "monoHueInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultOpacity]]], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="removeColorInput")
    def remove_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultRemoveColor"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultRemoveColor"]]], jsii.get(self, "removeColorInput"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMaskInput")
    def unsharp_mask_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultUnsharpMask"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultUnsharpMask"]]], jsii.get(self, "unsharpMaskInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__99c5eb9eeffcac7e28be237a1cacb763ad5bfd58ddabca84a34dd9cd6d58e1d6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultRemoveColor",
    jsii_struct_bases=[],
    name_mapping={
        "color": "color",
        "color_var": "colorVar",
        "feather": "feather",
        "feather_var": "featherVar",
        "tolerance": "tolerance",
        "tolerance_var": "toleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultRemoveColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
        feather: typing.Optional[builtins.str] = None,
        feather_var: typing.Optional[builtins.str] = None,
        tolerance: typing.Optional[builtins.str] = None,
        tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        :param feather: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        :param feather_var: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        :param tolerance: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        :param tolerance_var: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e66c47e564094d4d913b45794c1c1297d7f5b59117d8128c005aa2ca546882d0)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
            check_type(argname="argument feather", value=feather, expected_type=type_hints["feather"])
            check_type(argname="argument feather_var", value=feather_var, expected_type=type_hints["feather_var"])
            check_type(argname="argument tolerance", value=tolerance, expected_type=type_hints["tolerance"])
            check_type(argname="argument tolerance_var", value=tolerance_var, expected_type=type_hints["tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var
        if feather is not None:
            self._values["feather"] = feather
        if feather_var is not None:
            self._values["feather_var"] = feather_var
        if tolerance is not None:
            self._values["tolerance"] = tolerance
        if tolerance_var is not None:
            self._values["tolerance_var"] = tolerance_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        '''
        result = self._values.get("feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather_var(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        '''
        result = self._values.get("feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        '''
        result = self._values.get("tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance_var(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        result = self._values.get("tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultRemoveColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultRemoveColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultRemoveColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__376ebdf6474497f820aee2d830f35fea39392eb93cf4889025529b66e61e8876)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultRemoveColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7267070f78b4fe7112c6cd32b23c4c450376d30dcabae0e595142b350f827d44)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultRemoveColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d3fd639dac02388fa14009934a677904c47dfd64a9c037943e6d289deb331b9d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a58836901ee46de7307ffe42ff623f29fe2a23d4705d9ba57c11792dd2e00fee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ddf359e587cc77f665924f3aea8984b02b9d2b2f7b004ffd0f0675b24555298)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultRemoveColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultRemoveColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultRemoveColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cf90153293d4f01210f5b78c1b4ac64b0db56b3c583b4234bc677483e515e19c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultRemoveColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultRemoveColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__148cf20414e3ce67651242e887bc32b54eafacda0b96f1bc732d8140327c7b05)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @jsii.member(jsii_name="resetFeather")
    def reset_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeather", []))

    @jsii.member(jsii_name="resetFeatherVar")
    def reset_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatherVar", []))

    @jsii.member(jsii_name="resetTolerance")
    def reset_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTolerance", []))

    @jsii.member(jsii_name="resetToleranceVar")
    def reset_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featherInput")
    def feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherInput"))

    @builtins.property
    @jsii.member(jsii_name="featherVarInput")
    def feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceInput")
    def tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceVarInput")
    def tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__012e8a5f3ba880fd034aa80d34da9e6844ec7c8f0cb3aed42f53e1602cfe258f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4c5f8e20f7ec397db924abc36b9f066b9c0903c7e0d44afb408d21803647fbac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="feather")
    def feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "feather"))

    @feather.setter
    def feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2cc47a1667ca8248293f359b66fce1aefe7b9902b34f7ed16c167a663891ceff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "feather", value)

    @builtins.property
    @jsii.member(jsii_name="featherVar")
    def feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featherVar"))

    @feather_var.setter
    def feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__842e6fc2ca67c64e39a45a9d560bafcfe30e7a6451f673f9c6712724f827467f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featherVar", value)

    @builtins.property
    @jsii.member(jsii_name="tolerance")
    def tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tolerance"))

    @tolerance.setter
    def tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__20e72c0d273960fd677b88b06dd29512bb251aac1efc2b3a4785bad3e6f0838c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tolerance", value)

    @builtins.property
    @jsii.member(jsii_name="toleranceVar")
    def tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "toleranceVar"))

    @tolerance_var.setter
    def tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__17cdc164e19a3bd834d9445a6f4fd1bec7bcc940f330310fbcfae22b01670ccf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "toleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultRemoveColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultRemoveColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultRemoveColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4d18b959367fbbdcab81cf2c89251e7d691c17159ba5834956cafa1ca186ca2b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultUnsharpMask",
    jsii_struct_bases=[],
    name_mapping={
        "gain": "gain",
        "gain_var": "gainVar",
        "sigma": "sigma",
        "sigma_var": "sigmaVar",
        "threshold": "threshold",
        "threshold_var": "thresholdVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultUnsharpMask:
    def __init__(
        self,
        *,
        gain: typing.Optional[builtins.str] = None,
        gain_var: typing.Optional[builtins.str] = None,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
        threshold: typing.Optional[builtins.str] = None,
        threshold_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param gain: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        :param gain_var: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        :param sigma: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        :param threshold: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        :param threshold_var: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fcdbe91eccf6411872bba7ab5370088635afc20fefc1b17daea346de43e6379a)
            check_type(argname="argument gain", value=gain, expected_type=type_hints["gain"])
            check_type(argname="argument gain_var", value=gain_var, expected_type=type_hints["gain_var"])
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
            check_type(argname="argument threshold", value=threshold, expected_type=type_hints["threshold"])
            check_type(argname="argument threshold_var", value=threshold_var, expected_type=type_hints["threshold_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if gain is not None:
            self._values["gain"] = gain
        if gain_var is not None:
            self._values["gain_var"] = gain_var
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var
        if threshold is not None:
            self._values["threshold"] = threshold
        if threshold_var is not None:
            self._values["threshold_var"] = threshold_var

    @builtins.property
    def gain(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        '''
        result = self._values.get("gain")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gain_var(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        '''
        result = self._values.get("gain_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        '''
        result = self._values.get("threshold")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold_var(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        result = self._values.get("threshold_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultUnsharpMask(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultUnsharpMaskList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultUnsharpMaskList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3250d6de33576b0762dfbc1337a603ae5e53842ef480edeed72eb06461c76615)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultUnsharpMaskOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__71df996f1853b0f557318441a05c31ee79859000e75aecd1dcaf2022e01da60c)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultUnsharpMaskOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__99ad67af368e4d73248ff81dfbe04f784cf02b145ac636d9562fb25e46e6ac7e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__582c2a3f7849d0f393b3a5481c890c6ba9443877f94fceaac1ef4eccb123789f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__70ead67de830506b0f783d9d268c5cce8c04bd0d99d489e1d0d0a20527554b72)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultUnsharpMask]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultUnsharpMask]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultUnsharpMask]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ef24f75783ff52f47b15ed4686d5746dbee79a5a51792f49d2a02924679f9151)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultUnsharpMaskOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultUnsharpMaskOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2c31cd869879e7680696537010e02a7982976400e871e3a4d79f2628f8768d03)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetGain")
    def reset_gain(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGain", []))

    @jsii.member(jsii_name="resetGainVar")
    def reset_gain_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGainVar", []))

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @jsii.member(jsii_name="resetThreshold")
    def reset_threshold(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThreshold", []))

    @jsii.member(jsii_name="resetThresholdVar")
    def reset_threshold_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThresholdVar", []))

    @builtins.property
    @jsii.member(jsii_name="gainInput")
    def gain_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainInput"))

    @builtins.property
    @jsii.member(jsii_name="gainVarInput")
    def gain_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdInput")
    def threshold_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdVarInput")
    def threshold_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gain")
    def gain(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gain"))

    @gain.setter
    def gain(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7140e12a477a73aa791a82dffdf0ebac67d71b09f3a434e6601201a15aef3ef0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gain", value)

    @builtins.property
    @jsii.member(jsii_name="gainVar")
    def gain_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gainVar"))

    @gain_var.setter
    def gain_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__09849357a25c4ec25d67cc9b963f4f20f23f4d74b257c0ccd9ce2a29bb450ce3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gainVar", value)

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__69e9d32887ca0daf86fdad6fe4f4fc79e9bb758b99b1418c787895df74508fab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__15e7b66108b5ea2ca5e87266966abb6b1c9470446516afdba71003e71fc8eef1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="threshold")
    def threshold(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "threshold"))

    @threshold.setter
    def threshold(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d5f8cf552f61b7ee581be8026cf7b8ade9b1f3dd9cb369f69691bd91f34e22fb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "threshold", value)

    @builtins.property
    @jsii.member(jsii_name="thresholdVar")
    def threshold_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "thresholdVar"))

    @threshold_var.setter
    def threshold_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bcf335debc2dc939a08e7b9f8105d7b6b0d7636cd6327435cfc2be5c8ea158e9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "thresholdVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultUnsharpMask]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultUnsharpMask]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultUnsharpMask]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8ec9128630685c7321849b0fad113ca5f0d822efb2cea8aff0a19ec3a6803183)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscape",
    jsii_struct_bases=[],
    name_mapping={
        "background_color": "backgroundColor",
        "blur": "blur",
        "chroma_key": "chromaKey",
        "composite": "composite",
        "compound": "compound",
        "contrast": "contrast",
        "goop": "goop",
        "grayscale": "grayscale",
        "hsl": "hsl",
        "hsv": "hsv",
        "if_dimension": "ifDimension",
        "if_orientation": "ifOrientation",
        "max_colors": "maxColors",
        "mirror": "mirror",
        "mono_hue": "monoHue",
        "opacity": "opacity",
        "remove_color": "removeColor",
        "unsharp_mask": "unsharpMask",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscape:
    def __init__(
        self,
        *,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeBackgroundColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeBlur", typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeChromaKey", typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeComposite", typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompound", typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeContrast", typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeGoop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeGrayscale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeHsl", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeHsv", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimension", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientation", typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeMaxColors", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeMirror", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeMonoHue", typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeOpacity", typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeRemoveColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeUnsharpMask", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__74057807417b9e37bde4b9b7519e04a729225dcb2ff7fa1ad55afc14b07d26f1)
            check_type(argname="argument background_color", value=background_color, expected_type=type_hints["background_color"])
            check_type(argname="argument blur", value=blur, expected_type=type_hints["blur"])
            check_type(argname="argument chroma_key", value=chroma_key, expected_type=type_hints["chroma_key"])
            check_type(argname="argument composite", value=composite, expected_type=type_hints["composite"])
            check_type(argname="argument compound", value=compound, expected_type=type_hints["compound"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument goop", value=goop, expected_type=type_hints["goop"])
            check_type(argname="argument grayscale", value=grayscale, expected_type=type_hints["grayscale"])
            check_type(argname="argument hsl", value=hsl, expected_type=type_hints["hsl"])
            check_type(argname="argument hsv", value=hsv, expected_type=type_hints["hsv"])
            check_type(argname="argument if_dimension", value=if_dimension, expected_type=type_hints["if_dimension"])
            check_type(argname="argument if_orientation", value=if_orientation, expected_type=type_hints["if_orientation"])
            check_type(argname="argument max_colors", value=max_colors, expected_type=type_hints["max_colors"])
            check_type(argname="argument mirror", value=mirror, expected_type=type_hints["mirror"])
            check_type(argname="argument mono_hue", value=mono_hue, expected_type=type_hints["mono_hue"])
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument remove_color", value=remove_color, expected_type=type_hints["remove_color"])
            check_type(argname="argument unsharp_mask", value=unsharp_mask, expected_type=type_hints["unsharp_mask"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if background_color is not None:
            self._values["background_color"] = background_color
        if blur is not None:
            self._values["blur"] = blur
        if chroma_key is not None:
            self._values["chroma_key"] = chroma_key
        if composite is not None:
            self._values["composite"] = composite
        if compound is not None:
            self._values["compound"] = compound
        if contrast is not None:
            self._values["contrast"] = contrast
        if goop is not None:
            self._values["goop"] = goop
        if grayscale is not None:
            self._values["grayscale"] = grayscale
        if hsl is not None:
            self._values["hsl"] = hsl
        if hsv is not None:
            self._values["hsv"] = hsv
        if if_dimension is not None:
            self._values["if_dimension"] = if_dimension
        if if_orientation is not None:
            self._values["if_orientation"] = if_orientation
        if max_colors is not None:
            self._values["max_colors"] = max_colors
        if mirror is not None:
            self._values["mirror"] = mirror
        if mono_hue is not None:
            self._values["mono_hue"] = mono_hue
        if opacity is not None:
            self._values["opacity"] = opacity
        if remove_color is not None:
            self._values["remove_color"] = remove_color
        if unsharp_mask is not None:
            self._values["unsharp_mask"] = unsharp_mask

    @builtins.property
    def background_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeBackgroundColor"]]]:
        '''background_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        '''
        result = self._values.get("background_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeBackgroundColor"]]], result)

    @builtins.property
    def blur(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeBlur"]]]:
        '''blur block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        '''
        result = self._values.get("blur")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeBlur"]]], result)

    @builtins.property
    def chroma_key(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeChromaKey"]]]:
        '''chroma_key block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        '''
        result = self._values.get("chroma_key")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeChromaKey"]]], result)

    @builtins.property
    def composite(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeComposite"]]]:
        '''composite block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        '''
        result = self._values.get("composite")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeComposite"]]], result)

    @builtins.property
    def compound(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompound"]]]:
        '''compound block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        '''
        result = self._values.get("compound")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompound"]]], result)

    @builtins.property
    def contrast(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeContrast"]]]:
        '''contrast block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeContrast"]]], result)

    @builtins.property
    def goop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeGoop"]]]:
        '''goop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        '''
        result = self._values.get("goop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeGoop"]]], result)

    @builtins.property
    def grayscale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeGrayscale"]]]:
        '''grayscale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        '''
        result = self._values.get("grayscale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeGrayscale"]]], result)

    @builtins.property
    def hsl(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeHsl"]]]:
        '''hsl block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        '''
        result = self._values.get("hsl")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeHsl"]]], result)

    @builtins.property
    def hsv(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeHsv"]]]:
        '''hsv block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        '''
        result = self._values.get("hsv")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeHsv"]]], result)

    @builtins.property
    def if_dimension(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimension"]]]:
        '''if_dimension block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        '''
        result = self._values.get("if_dimension")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimension"]]], result)

    @builtins.property
    def if_orientation(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientation"]]]:
        '''if_orientation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        '''
        result = self._values.get("if_orientation")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientation"]]], result)

    @builtins.property
    def max_colors(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeMaxColors"]]]:
        '''max_colors block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        '''
        result = self._values.get("max_colors")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeMaxColors"]]], result)

    @builtins.property
    def mirror(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeMirror"]]]:
        '''mirror block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        '''
        result = self._values.get("mirror")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeMirror"]]], result)

    @builtins.property
    def mono_hue(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeMonoHue"]]]:
        '''mono_hue block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        '''
        result = self._values.get("mono_hue")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeMonoHue"]]], result)

    @builtins.property
    def opacity(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeOpacity"]]]:
        '''opacity block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeOpacity"]]], result)

    @builtins.property
    def remove_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeRemoveColor"]]]:
        '''remove_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        '''
        result = self._values.get("remove_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeRemoveColor"]]], result)

    @builtins.property
    def unsharp_mask(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeUnsharpMask"]]]:
        '''unsharp_mask block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        result = self._values.get("unsharp_mask")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeUnsharpMask"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscape(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeBackgroundColor",
    jsii_struct_bases=[],
    name_mapping={"color": "color", "color_var": "colorVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeBackgroundColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3c708d0e3e4c91c3d8208b04080a32dfc5a4ef0a45599da40a144ed11f645713)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeBackgroundColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeBackgroundColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeBackgroundColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c38169ae339e81df352bdd1e2b9f432a3b184c1bc0eafbc0f1712815c42e5a48)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeBackgroundColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__61cd84f0a176e5c50b6b854a77b080ea4f6aa455d7c6c36240075c1d9ac25af8)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeBackgroundColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__182da7457c6d367b41a7f5afb17ab2450db3b9fc0771d87ed0607cbd947a8c2b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b9f0c8aa846014e8a1ce457d1f7328114655b28cf3e5f23f6adb6dfd00d808e6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__99e7691bd98a749b5b4344260fa408b00a74389042e6edba3e433a099a752ebc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeBackgroundColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeBackgroundColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__026ef2371c2dd9507e5e2f6f0db3fa1a09e0e367b98b13f654c8e74227e2bf86)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeBackgroundColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeBackgroundColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b7593df349f0a7b2a49bfbe4608ce123763ee66262264d7ddee5a38ea2a7f35a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e5fc0784198b0726293f64c2d260a9a8120ceca9df8126fa3832a5d6ae353e39)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e6b318c2b6608af1ce31b175951d4ded2186b1bd7f763071c964189c5e069d57)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeBackgroundColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeBackgroundColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeBackgroundColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b5cbd9bbf3928e8032678a6940889224080be51dc3f04e45e7801c5501f0ff9c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeBlur",
    jsii_struct_bases=[],
    name_mapping={"sigma": "sigma", "sigma_var": "sigmaVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeBlur:
    def __init__(
        self,
        *,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param sigma: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b03ca5486b8818c28c0ee1b418bb1451671500cd477d5ee3757530221db2c3c6)
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeBlur(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeBlurList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeBlurList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e5511bfa70132da7648a5eee19d721b4856141b88ac4204fbda47f07d1a4f207)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeBlurOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e50f0fcef6c785dcec135c6802301aacc08775f721b7ebd7453ac0eb2d81d8d1)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeBlurOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d68a285ada4ebb2d392c95d16bb14f53edac13d84d77cdb142e14b9c905c9a82)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__844398bee0f847b494f818d68f99ad2e4092e71660d41cc9a5fe8317fba56ca2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__da321842808b941e35a5ab03f835abdfb5e188a73e17b86cf1210b08e2381a51)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeBlur]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeBlur]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b0923c5778d89b1d7635bec760a96b9c3b99407b290be3e20a53372750abe9be)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeBlurOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeBlurOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b1ad82050f9c3c4d3f534899935de9372790e55f2009bb4a7b4e6654f5eb86b3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5b77cdf277b938ae86a0582e0e512f8e4cdab367e81d618572b18c4251cf2707)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ad21e2787ed91d13999a0c3061ef9dae2c6bcf19f052e28ae77ee0faeff189be)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeBlur]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeBlur]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeBlur]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0384f312a8a53cafac163ed592950d549cf014d20763de94d6ef6f2080f058e8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeChromaKey",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_feather": "hueFeather",
        "hue_feather_var": "hueFeatherVar",
        "hue_tolerance": "hueTolerance",
        "hue_tolerance_var": "hueToleranceVar",
        "hue_var": "hueVar",
        "lightness_feather": "lightnessFeather",
        "lightness_feather_var": "lightnessFeatherVar",
        "lightness_tolerance": "lightnessTolerance",
        "lightness_tolerance_var": "lightnessToleranceVar",
        "saturation_feather": "saturationFeather",
        "saturation_feather_var": "saturationFeatherVar",
        "saturation_tolerance": "saturationTolerance",
        "saturation_tolerance_var": "saturationToleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeChromaKey:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_feather: typing.Optional[builtins.str] = None,
        hue_feather_var: typing.Optional[builtins.str] = None,
        hue_tolerance: typing.Optional[builtins.str] = None,
        hue_tolerance_var: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness_feather: typing.Optional[builtins.str] = None,
        lightness_feather_var: typing.Optional[builtins.str] = None,
        lightness_tolerance: typing.Optional[builtins.str] = None,
        lightness_tolerance_var: typing.Optional[builtins.str] = None,
        saturation_feather: typing.Optional[builtins.str] = None,
        saturation_feather_var: typing.Optional[builtins.str] = None,
        saturation_tolerance: typing.Optional[builtins.str] = None,
        saturation_tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_feather: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        :param hue_feather_var: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        :param hue_tolerance: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        :param hue_tolerance_var: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        :param hue_var: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness_feather: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        :param lightness_feather_var: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        :param lightness_tolerance: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        :param lightness_tolerance_var: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        :param saturation_feather: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        :param saturation_feather_var: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        :param saturation_tolerance: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        :param saturation_tolerance_var: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8d000a3bbd75917ea036e6de30f033b96bf2837ad58f75074500a1a46fc697fd)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_feather", value=hue_feather, expected_type=type_hints["hue_feather"])
            check_type(argname="argument hue_feather_var", value=hue_feather_var, expected_type=type_hints["hue_feather_var"])
            check_type(argname="argument hue_tolerance", value=hue_tolerance, expected_type=type_hints["hue_tolerance"])
            check_type(argname="argument hue_tolerance_var", value=hue_tolerance_var, expected_type=type_hints["hue_tolerance_var"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness_feather", value=lightness_feather, expected_type=type_hints["lightness_feather"])
            check_type(argname="argument lightness_feather_var", value=lightness_feather_var, expected_type=type_hints["lightness_feather_var"])
            check_type(argname="argument lightness_tolerance", value=lightness_tolerance, expected_type=type_hints["lightness_tolerance"])
            check_type(argname="argument lightness_tolerance_var", value=lightness_tolerance_var, expected_type=type_hints["lightness_tolerance_var"])
            check_type(argname="argument saturation_feather", value=saturation_feather, expected_type=type_hints["saturation_feather"])
            check_type(argname="argument saturation_feather_var", value=saturation_feather_var, expected_type=type_hints["saturation_feather_var"])
            check_type(argname="argument saturation_tolerance", value=saturation_tolerance, expected_type=type_hints["saturation_tolerance"])
            check_type(argname="argument saturation_tolerance_var", value=saturation_tolerance_var, expected_type=type_hints["saturation_tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_feather is not None:
            self._values["hue_feather"] = hue_feather
        if hue_feather_var is not None:
            self._values["hue_feather_var"] = hue_feather_var
        if hue_tolerance is not None:
            self._values["hue_tolerance"] = hue_tolerance
        if hue_tolerance_var is not None:
            self._values["hue_tolerance_var"] = hue_tolerance_var
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness_feather is not None:
            self._values["lightness_feather"] = lightness_feather
        if lightness_feather_var is not None:
            self._values["lightness_feather_var"] = lightness_feather_var
        if lightness_tolerance is not None:
            self._values["lightness_tolerance"] = lightness_tolerance
        if lightness_tolerance_var is not None:
            self._values["lightness_tolerance_var"] = lightness_tolerance_var
        if saturation_feather is not None:
            self._values["saturation_feather"] = saturation_feather
        if saturation_feather_var is not None:
            self._values["saturation_feather_var"] = saturation_feather_var
        if saturation_tolerance is not None:
            self._values["saturation_tolerance"] = saturation_tolerance
        if saturation_tolerance_var is not None:
            self._values["saturation_tolerance_var"] = saturation_tolerance_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        '''
        result = self._values.get("hue_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        '''
        result = self._values.get("hue_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        '''
        result = self._values.get("hue_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        '''
        result = self._values.get("hue_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        '''
        result = self._values.get("lightness_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        '''
        result = self._values.get("lightness_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        '''
        result = self._values.get("lightness_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        '''
        result = self._values.get("lightness_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        '''
        result = self._values.get("saturation_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        '''
        result = self._values.get("saturation_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        '''
        result = self._values.get("saturation_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        result = self._values.get("saturation_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeChromaKey(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeChromaKeyList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeChromaKeyList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2407d4efc6e835722dabbbe825139de0874aae232a37b4b64e09c51950bfe660)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeChromaKeyOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8b48c4a90c4357465c45b91328c70ce921219969334b351831930ed6837eda7f)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeChromaKeyOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ff3e1a3e30661eb88282b5bb13cd2b465169eab480decea58a0a84a7aa0ff3b5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f7ae1a5736e98b1897cc23bf71e7309284443d6a17f5b0806b24b34006701cfd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5a09395547a5136b47c588f4ca5c2144abf6492d8d1ad0e9a5e543d37aaeea43)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeChromaKey]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeChromaKey]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__799b7267f46b80ec069ba28e003c711d5b31656a2dd1fa7cd8472cc84ff6ca07)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeChromaKeyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeChromaKeyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e3a8454aa54dcba44163d49b29b8beb9478866dde59c8f191dd6d5806b5aacbe)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueFeather")
    def reset_hue_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeather", []))

    @jsii.member(jsii_name="resetHueFeatherVar")
    def reset_hue_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeatherVar", []))

    @jsii.member(jsii_name="resetHueTolerance")
    def reset_hue_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueTolerance", []))

    @jsii.member(jsii_name="resetHueToleranceVar")
    def reset_hue_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueToleranceVar", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightnessFeather")
    def reset_lightness_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeather", []))

    @jsii.member(jsii_name="resetLightnessFeatherVar")
    def reset_lightness_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeatherVar", []))

    @jsii.member(jsii_name="resetLightnessTolerance")
    def reset_lightness_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessTolerance", []))

    @jsii.member(jsii_name="resetLightnessToleranceVar")
    def reset_lightness_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessToleranceVar", []))

    @jsii.member(jsii_name="resetSaturationFeather")
    def reset_saturation_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeather", []))

    @jsii.member(jsii_name="resetSaturationFeatherVar")
    def reset_saturation_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeatherVar", []))

    @jsii.member(jsii_name="resetSaturationTolerance")
    def reset_saturation_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationTolerance", []))

    @jsii.member(jsii_name="resetSaturationToleranceVar")
    def reset_saturation_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherInput")
    def hue_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVarInput")
    def hue_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceInput")
    def hue_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVarInput")
    def hue_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherInput")
    def lightness_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVarInput")
    def lightness_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceInput")
    def lightness_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVarInput")
    def lightness_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherInput")
    def saturation_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVarInput")
    def saturation_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceInput")
    def saturation_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVarInput")
    def saturation_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6afba74c5819d20fd3e221283d21835cb57a29dc3dce3b7c7922b98c379e4752)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeather")
    def hue_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeather"))

    @hue_feather.setter
    def hue_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__95d54ce8b4cfdc1967066d87cb9205468041a59eb4fd348235ac347ee791b090)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeather", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVar")
    def hue_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeatherVar"))

    @hue_feather_var.setter
    def hue_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ce16928faef4bf5b224617c80305810f3bc7da2510d73762aaf1aba7291d9348)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueTolerance")
    def hue_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueTolerance"))

    @hue_tolerance.setter
    def hue_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e673ebe0d3684b1a3ae19f7464c719099a0e9af1e63610ea0ad7ce775b64f404)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVar")
    def hue_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueToleranceVar"))

    @hue_tolerance_var.setter
    def hue_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5569b3026b47390cef09a3b6b3163e7ddccd44634e2eb2f702d70fd988fb1970)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d2552ec3f421431d5e798be157b99c48d592b442beb2a4c2bb8c854327dd3bd8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeather")
    def lightness_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeather"))

    @lightness_feather.setter
    def lightness_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea6a14ba94c522cc4d4e96d1ea68891523e21b0998eb2e2293c8f36af250e478)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeather", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVar")
    def lightness_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeatherVar"))

    @lightness_feather_var.setter
    def lightness_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c225afc35d36cdda3219625b553d42b4483d324bc554b0e0a33934c54ad70a4c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessTolerance")
    def lightness_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessTolerance"))

    @lightness_tolerance.setter
    def lightness_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c59dc0ac6a29e53965e50db041813f58c8d6f1b035d17887ccd60884e2086718)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVar")
    def lightness_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessToleranceVar"))

    @lightness_tolerance_var.setter
    def lightness_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5c5b8e7eff8257ce477b06b0bd1bb27d6b76c2efc14c0e4359ca99e302b965e0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeather")
    def saturation_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeather"))

    @saturation_feather.setter
    def saturation_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f4087f8aeb86d404c6532a328e83fd1f20fef56d02a8d8e0adf78b0ff529b112)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeather", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVar")
    def saturation_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeatherVar"))

    @saturation_feather_var.setter
    def saturation_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__914d8de66572d6cf3db690e46f65a09fa0b8151057f040190e4464db0bbbcfae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationTolerance")
    def saturation_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationTolerance"))

    @saturation_tolerance.setter
    def saturation_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ba6c46f06d7220aab105261770782b68dc6ed59ee94eb6922e729c3cc63d255)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVar")
    def saturation_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationToleranceVar"))

    @saturation_tolerance_var.setter
    def saturation_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ecfd789215da6bdf9a68fe0433902921e953b222a05fadacb53ff0ca6c2527e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeChromaKey]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeChromaKey]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeChromaKey]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2870bfb70d9a79c8f4f93f0b765184fabb338fd0205b4caee04f28236c7e2a82)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeComposite",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "placement": "placement",
        "placement_var": "placementVar",
        "scale": "scale",
        "scale_dimension": "scaleDimension",
        "scale_dimension_var": "scaleDimensionVar",
        "scale_var": "scaleVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeComposite:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompositeImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        placement: typing.Optional[builtins.str] = None,
        placement_var: typing.Optional[builtins.str] = None,
        scale: typing.Optional[builtins.str] = None,
        scale_dimension: typing.Optional[builtins.str] = None,
        scale_dimension_var: typing.Optional[builtins.str] = None,
        scale_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param placement: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        :param placement_var: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        :param scale: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param scale_dimension: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        :param scale_dimension_var: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        :param scale_var: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        :param x_position: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompositeImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__879b8c37d0b62bf7c750b26e1dd5e0a865f6847964ae055be403817c275c1fae)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument placement", value=placement, expected_type=type_hints["placement"])
            check_type(argname="argument placement_var", value=placement_var, expected_type=type_hints["placement_var"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument scale_dimension", value=scale_dimension, expected_type=type_hints["scale_dimension"])
            check_type(argname="argument scale_dimension_var", value=scale_dimension_var, expected_type=type_hints["scale_dimension_var"])
            check_type(argname="argument scale_var", value=scale_var, expected_type=type_hints["scale_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if placement is not None:
            self._values["placement"] = placement
        if placement_var is not None:
            self._values["placement_var"] = placement_var
        if scale is not None:
            self._values["scale"] = scale
        if scale_dimension is not None:
            self._values["scale_dimension"] = scale_dimension
        if scale_dimension_var is not None:
            self._values["scale_dimension_var"] = scale_dimension_var
        if scale_var is not None:
            self._values["scale_var"] = scale_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompositeImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompositeImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        '''
        result = self._values.get("placement")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement_var(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        '''
        result = self._values.get("placement_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        '''
        result = self._values.get("scale_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        '''
        result = self._values.get("scale_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        '''
        result = self._values.get("scale_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeComposite(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompositeImage",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompositeImage:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompositeImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompositeImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompositeImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__46ad95b127da9f57440f1a143122eb6e9c1c78bbefbe87f599655aec71c5f82a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompositeImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompositeImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4e2eb7294ec9c00635158d2ec97941c174db93c5c291fff848740b28eaf4d076)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompositeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompositeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ed73d51c4f0f39b4c78a8648c718db28bfc0f559c19dbac6625fdf691fdff667)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompositeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a7e7d302d3d8f1b20d9e48badb595149f25679cbbb10953103e5c671d9ebfa38)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompositeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1ee00e023348a92221939172cf9445a76f02f7a4445e6fab4fa366e77a167177)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__46e90353369f46f1324253e39b638ba1a8d29e248d46142c1cd4050fc1e9a837)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8da4cd2738c15e01dbcea7d7f58b3a6f5d676e3c5a82a4a2b06beb0cd541de2f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeComposite]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeComposite]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7984c1aefa978849fd640dc20e8cca5e0c369f2ec0961b2bee195eca22414137)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompositeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompositeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e6c8343ecf2fbb41bc92aa228978fcd46521c717f02016fa95164fc33d23a37c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompositeImage()

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPlacement")
    def reset_placement(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacement", []))

    @jsii.member(jsii_name="resetPlacementVar")
    def reset_placement_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacementVar", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetScaleDimension")
    def reset_scale_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimension", []))

    @jsii.member(jsii_name="resetScaleDimensionVar")
    def reset_scale_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimensionVar", []))

    @jsii.member(jsii_name="resetScaleVar")
    def reset_scale_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompositeImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompositeImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompositeImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="placementInput")
    def placement_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementInput"))

    @builtins.property
    @jsii.member(jsii_name="placementVarInput")
    def placement_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionInput")
    def scale_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVarInput")
    def scale_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleVarInput")
    def scale_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__103d016042fddf1bb517b1f15712dbdadc08614cefedfbe672a8efed32e8ceda)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__809bbd672dbd16d8ae55c00723b01bbd2535bfdefe64cd61c822fd11502676d0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="placement")
    def placement(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placement"))

    @placement.setter
    def placement(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e2646ba09e440c71181ab3fb557d4defb470c3d1cbecc9c63a5b5bfbbcbeb88a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placement", value)

    @builtins.property
    @jsii.member(jsii_name="placementVar")
    def placement_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placementVar"))

    @placement_var.setter
    def placement_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__19b79b7deafcbfbea753e8142da3075a54588d269bdf9068e918539deda6d3de)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placementVar", value)

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scale"))

    @scale.setter
    def scale(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a367fc1a9b1063c584efb3358b8d0400a6b50250ecd9a858ce6d2b2fae8b9d7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scale", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimension")
    def scale_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimension"))

    @scale_dimension.setter
    def scale_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ac69cdd504c81416b899286de130b9feab7568fdc6c2c07817e9079a631cac4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimension", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVar")
    def scale_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimensionVar"))

    @scale_dimension_var.setter
    def scale_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b3bffb2134a44658eced10c8c29aa6821c293890f56200d1cb4634842c2bce8f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="scaleVar")
    def scale_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleVar"))

    @scale_var.setter
    def scale_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9458cf6d159638c99b8a478cb0b27be0a3fa6e13c0c2ccac1e20a6224ba16b7e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__03868d038c128acadf998742d837ac8e40ffafaa3c5604e25fe3f69fa59e64a7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__614a8393d9ca7b8e0fc2e0304fcee83a3d444396f8665bcdc0f8012c4fc37439)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__04126803c197c8b719707be1733fb8655b3eb67370d528ef1d8e68cc3d394e28)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__27c146e5674494c526f9fbf0c5f7dea014efe97d870c30859a4733beb97e8ae3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeComposite]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeComposite]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeComposite]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__552842d191a3df32a3821fec6c478edf845900194d9103f6c32e3e5cf98aa416)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompound",
    jsii_struct_bases=[],
    name_mapping={"transformations": "transformations"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompound:
    def __init__(
        self,
        *,
        transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param transformations: transformations block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c94819f8835248d09e4861024b7a87adf1343759bd153c24769aa0868df93be6)
            check_type(argname="argument transformations", value=transformations, expected_type=type_hints["transformations"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if transformations is not None:
            self._values["transformations"] = transformations

    @builtins.property
    def transformations(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompoundTransformations"]]]:
        '''transformations block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        result = self._values.get("transformations")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompoundTransformations"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompound(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompoundList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompoundList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6937c70b33f3b361e2758fcb899b3bd36b9b910388afc54c6c3b4f3e8ae75512)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompoundOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cebf023cd6c122fc9de11d138c27ace7d03aa551a797ddcde458996f04e785be)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompoundOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f20b5d25999f694ff44e51d9e9925449bf1d9605b5383827bfd466d448854bf4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb6f2b54a9d0c77e879ef323ce7c219ea6e635647da4ca0d617668bf39dccd95)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ce0d854f944417a9b6a47d48c3d3c6f30d8e74417e5e7c31de6eb42857d77ce6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompound]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompound]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__61f26be91d78e492471c1e0a0023e28cb1ec86f03e55b04e14553be6018f5e18)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompoundOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompoundOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c62d80e1f75ef5690f378875c068b89fca0031d1235db20adf5c23b454517bd5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformations")
    def put_transformations(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a039c72aa282442abaa3d7cbda1d893a382d55731f39e17dafa6326df3e33213)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTransformations", [value]))

    @jsii.member(jsii_name="resetTransformations")
    def reset_transformations(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformations", []))

    @builtins.property
    @jsii.member(jsii_name="transformations")
    def transformations(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompoundTransformationsList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompoundTransformationsList", jsii.get(self, "transformations"))

    @builtins.property
    @jsii.member(jsii_name="transformationsInput")
    def transformations_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompoundTransformations"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompoundTransformations"]]], jsii.get(self, "transformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompound]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompound]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompound]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ec759e3ba5fd2f7bd6e5c2e21e2a7b81092cb9d790590d97cb3b474f67d8049)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompoundTransformations",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompoundTransformations:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompoundTransformations(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompoundTransformationsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompoundTransformationsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__01efb5470bc6e96f0354dd00f78a9bd9326616bfec4c3b3432d96d11fcbc291d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompoundTransformationsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__443f22c765dcab8b1ae921e1adb14f941b311ee369f899df338ceaceb0470a05)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompoundTransformationsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fe9ef370be3a3cac9089632ac2642f6dba8921e4d290906a3be56bcf468a2024)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7f22cb8f2ef3ca555d4c5985728448a191b2136a22ad2c4f9fb515deb5f68ba7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__41e46abdc35c276f66326f8e9b6d622c90c49356074277570c9a7e247d10fbf4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompoundTransformations]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompoundTransformations]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompoundTransformations]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e1af6ea85e8243ff2b7d50102a62f05393a7d5de6d11db8612aabb4b9da97182)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompoundTransformationsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompoundTransformationsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bccd37ab90079887d4a54a8b69fb05ff6e39d7f787c9084283834ce5b6327e16)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompoundTransformations]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompoundTransformations]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompoundTransformations]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9fd8bf8023f8ffefaeae29eb820b578a1e071e9d6578d16022caa87d8c2bccf3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeContrast",
    jsii_struct_bases=[],
    name_mapping={
        "brightness": "brightness",
        "brightness_var": "brightnessVar",
        "contrast": "contrast",
        "contrast_var": "contrastVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeContrast:
    def __init__(
        self,
        *,
        brightness: typing.Optional[builtins.str] = None,
        brightness_var: typing.Optional[builtins.str] = None,
        contrast: typing.Optional[builtins.str] = None,
        contrast_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param brightness: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        :param brightness_var: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        :param contrast: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param contrast_var: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4bc16ac194cfe128f68c03ba0e67a6c3746d76fbb50876fef5f915877599cbd2)
            check_type(argname="argument brightness", value=brightness, expected_type=type_hints["brightness"])
            check_type(argname="argument brightness_var", value=brightness_var, expected_type=type_hints["brightness_var"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument contrast_var", value=contrast_var, expected_type=type_hints["contrast_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if brightness is not None:
            self._values["brightness"] = brightness
        if brightness_var is not None:
            self._values["brightness_var"] = brightness_var
        if contrast is not None:
            self._values["contrast"] = contrast
        if contrast_var is not None:
            self._values["contrast_var"] = contrast_var

    @builtins.property
    def brightness(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        '''
        result = self._values.get("brightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def brightness_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        '''
        result = self._values.get("brightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        result = self._values.get("contrast_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeContrast(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeContrastList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeContrastList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__26efa185a5e8c714a82130b9a29654369bd98719dcf9929281c9393034114689)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeContrastOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7c948c67299eed5a7cc86c511eb9e771985fed02af6879fda82709a0200c2d50)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeContrastOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5b40936843057d3c17cad54b9676fbc2b66f85789b1c0610f3c5e324c6f100bd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c5090c27fa9143e97bfefd1c16f28ccbfa19dcc873b041624c1f2a770b987ada)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2116fc16096fcd61c7472b14007eb3d2cb31dab682a1171014e2545d562f2e23)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeContrast]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeContrast]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0dffe42fa7720d4103ceec1a2601fe34be69bd3d1667fb194188b334f55be56f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeContrastOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeContrastOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3e8340bd875de79a3253d35e108117907c8f693634906eb142d6c20a931740e7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetBrightness")
    def reset_brightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightness", []))

    @jsii.member(jsii_name="resetBrightnessVar")
    def reset_brightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightnessVar", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetContrastVar")
    def reset_contrast_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrastVar", []))

    @builtins.property
    @jsii.member(jsii_name="brightnessInput")
    def brightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="brightnessVarInput")
    def brightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastVarInput")
    def contrast_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="brightness")
    def brightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightness"))

    @brightness.setter
    def brightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9388c09d4119deb40d214450e17613dcb37018dca4e2d10709bf754210f1099e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightness", value)

    @builtins.property
    @jsii.member(jsii_name="brightnessVar")
    def brightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightnessVar"))

    @brightness_var.setter
    def brightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7c2ccb6b51caaf9064bd8b4b44b188117df0bc34807c149265848cee0b00536b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrast"))

    @contrast.setter
    def contrast(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9fdb5a333cd457984a6dd0200e904e53cc96e6e5e84579681a651cdd31e3df8c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrast", value)

    @builtins.property
    @jsii.member(jsii_name="contrastVar")
    def contrast_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrastVar"))

    @contrast_var.setter
    def contrast_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9b71ada2431a9bb619213b05582ed68d84dfa4ebbd246e3e5bdaa8df911123dc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrastVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeContrast]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeContrast]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeContrast]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1bcb8ba37fc8e4415ce89ce7b4e997d46255c2b1a1d64609c56a779aa721cd8a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeGoop",
    jsii_struct_bases=[],
    name_mapping={
        "chaos": "chaos",
        "chaos_var": "chaosVar",
        "density": "density",
        "density_var": "densityVar",
        "power": "power",
        "power_var": "powerVar",
        "seed": "seed",
        "seed_var": "seedVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeGoop:
    def __init__(
        self,
        *,
        chaos: typing.Optional[builtins.str] = None,
        chaos_var: typing.Optional[builtins.str] = None,
        density: typing.Optional[builtins.str] = None,
        density_var: typing.Optional[builtins.str] = None,
        power: typing.Optional[builtins.str] = None,
        power_var: typing.Optional[builtins.str] = None,
        seed: typing.Optional[builtins.str] = None,
        seed_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param chaos: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        :param chaos_var: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        :param density: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        :param density_var: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        :param power: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        :param power_var: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        :param seed: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        :param seed_var: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b62d66619014add41a601bdcccd1b7a380c099c496c69aae7e34359d3cc1d86e)
            check_type(argname="argument chaos", value=chaos, expected_type=type_hints["chaos"])
            check_type(argname="argument chaos_var", value=chaos_var, expected_type=type_hints["chaos_var"])
            check_type(argname="argument density", value=density, expected_type=type_hints["density"])
            check_type(argname="argument density_var", value=density_var, expected_type=type_hints["density_var"])
            check_type(argname="argument power", value=power, expected_type=type_hints["power"])
            check_type(argname="argument power_var", value=power_var, expected_type=type_hints["power_var"])
            check_type(argname="argument seed", value=seed, expected_type=type_hints["seed"])
            check_type(argname="argument seed_var", value=seed_var, expected_type=type_hints["seed_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if chaos is not None:
            self._values["chaos"] = chaos
        if chaos_var is not None:
            self._values["chaos_var"] = chaos_var
        if density is not None:
            self._values["density"] = density
        if density_var is not None:
            self._values["density_var"] = density_var
        if power is not None:
            self._values["power"] = power
        if power_var is not None:
            self._values["power_var"] = power_var
        if seed is not None:
            self._values["seed"] = seed
        if seed_var is not None:
            self._values["seed_var"] = seed_var

    @builtins.property
    def chaos(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        '''
        result = self._values.get("chaos")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def chaos_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        '''
        result = self._values.get("chaos_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        '''
        result = self._values.get("density")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density_var(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        '''
        result = self._values.get("density_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        '''
        result = self._values.get("power")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power_var(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        '''
        result = self._values.get("power_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        '''
        result = self._values.get("seed")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed_var(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        result = self._values.get("seed_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeGoop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeGoopList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeGoopList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__706cbc7c6335496de747f2263d1f514cfae2ce101cf0adec240a55d1d31a964f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeGoopOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5a9b14a899b660a74221354c4bfad8c5ed0b81e170475a36d986491e5cb54cda)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeGoopOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4959fda8cc68921a8f8b844966a023b05564512a093dcace3ebcde77afa854d6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__965fd1eaed4363698f8c2707c49cd6b729b9847cf74f5a01d6fdef41744c8d8a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__abfa5c579e4e4c981160d4cafcbff8e6937b55134532239be61586f939e9062e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeGoop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeGoop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c7c5cc5e67e447e17952d7a37f74b8e5b085723a2d31b926d001996e82c30a86)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeGoopOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeGoopOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fde31437f5c3d4e2f9fdb8b2203f15f2884b3fd103dc5f3b11c536fdc9fcf592)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetChaos")
    def reset_chaos(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaos", []))

    @jsii.member(jsii_name="resetChaosVar")
    def reset_chaos_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaosVar", []))

    @jsii.member(jsii_name="resetDensity")
    def reset_density(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensity", []))

    @jsii.member(jsii_name="resetDensityVar")
    def reset_density_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensityVar", []))

    @jsii.member(jsii_name="resetPower")
    def reset_power(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPower", []))

    @jsii.member(jsii_name="resetPowerVar")
    def reset_power_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPowerVar", []))

    @jsii.member(jsii_name="resetSeed")
    def reset_seed(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeed", []))

    @jsii.member(jsii_name="resetSeedVar")
    def reset_seed_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeedVar", []))

    @builtins.property
    @jsii.member(jsii_name="chaosInput")
    def chaos_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosInput"))

    @builtins.property
    @jsii.member(jsii_name="chaosVarInput")
    def chaos_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosVarInput"))

    @builtins.property
    @jsii.member(jsii_name="densityInput")
    def density_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityInput"))

    @builtins.property
    @jsii.member(jsii_name="densityVarInput")
    def density_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="powerInput")
    def power_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerInput"))

    @builtins.property
    @jsii.member(jsii_name="powerVarInput")
    def power_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerVarInput"))

    @builtins.property
    @jsii.member(jsii_name="seedInput")
    def seed_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedInput"))

    @builtins.property
    @jsii.member(jsii_name="seedVarInput")
    def seed_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedVarInput"))

    @builtins.property
    @jsii.member(jsii_name="chaos")
    def chaos(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaos"))

    @chaos.setter
    def chaos(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4c258e6ea94ae38a4e134304f940e82c35b4641644637c033da886054f69a4d5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaos", value)

    @builtins.property
    @jsii.member(jsii_name="chaosVar")
    def chaos_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaosVar"))

    @chaos_var.setter
    def chaos_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f3102755b926b9e9e71b0a2688e2054a688f6acffdd1eaa3e2316097351c0682)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaosVar", value)

    @builtins.property
    @jsii.member(jsii_name="density")
    def density(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "density"))

    @density.setter
    def density(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6d7f2a057122665905f898af8f7ae42752e843f95de351ae0fad683a05e6af58)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "density", value)

    @builtins.property
    @jsii.member(jsii_name="densityVar")
    def density_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "densityVar"))

    @density_var.setter
    def density_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e06a6ac9609c9623a4800744eceb6d4e853930850394e5737769e8ae384812a6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "densityVar", value)

    @builtins.property
    @jsii.member(jsii_name="power")
    def power(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "power"))

    @power.setter
    def power(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ef46c65277625e7fe62fc84fbadec55ff0a70c8787ebad8006bbd58dc8d4948)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "power", value)

    @builtins.property
    @jsii.member(jsii_name="powerVar")
    def power_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "powerVar"))

    @power_var.setter
    def power_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1b7f7f8f086fee4f56db57ec129f51b648ea2f7367e97f801da687d0dbc3a948)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "powerVar", value)

    @builtins.property
    @jsii.member(jsii_name="seed")
    def seed(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seed"))

    @seed.setter
    def seed(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5c9eaf2e6a2c7da53a0b9eb2b6546f0745f8a0d0c605aadc27af3ce8000716cb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seed", value)

    @builtins.property
    @jsii.member(jsii_name="seedVar")
    def seed_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seedVar"))

    @seed_var.setter
    def seed_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__73b0987f6bccbf013586bb6b0aaf9b2ce4c17c8c90ea0b05d0a667bef9e83c87)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seedVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeGoop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeGoop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeGoop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8de39caa5ce01080dd70a5a329ac9996b533a225be0318eced8c710d556d10e0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeGrayscale",
    jsii_struct_bases=[],
    name_mapping={"type": "type", "type_var": "typeVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeGrayscale:
    def __init__(
        self,
        *,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param type: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__36094c180dd8aa09882d2abb80cd464b2a1ef7ad3053825f52427e1f6df6a1bd)
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeGrayscale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeGrayscaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeGrayscaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__59ba88ed05c7f501e85a400cc62b626d78826c64ab85842d5f939403589c7f88)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeGrayscaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4229a385ddef89871f01f4e401d6316508c5542193e3af340841481c812322c5)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeGrayscaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f3b5a018e3766c0b585764e0a96679bab19f86d66604494ed0e44663db68344b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__57c44e24e15a4600c9a7e21c782f3791927d9e2103ac1415923bd1ae0cd0200b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__57a1a7d12f9d7c045770a7c19fe0135f42053f8e98e219cf7853f1b458b7e638)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeGrayscale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeGrayscale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__24de2f4f56eb4431a5d4af11c2d9a100298095b7ca4c715537540b314721a458)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeGrayscaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeGrayscaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b99148f426a85e15a1271ce4728a57f8e9b36cf982b7425b12e8ddf9711ad2f9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bfcd76c30dc62a95b9426d4f8c89e7fffd78978223c0acbc0e04bcb05ae78a35)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d891bbb70af76ea8155d5ac7b6b6a271919f8575e8e812a957925fe8817a1fa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeGrayscale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeGrayscale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeGrayscale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b0bd6102182971e7ad3c4ae4415e1d6433dbb4cb6b25d7b831085e32dd78acae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeHsl",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "lightness": "lightness",
        "lightness_var": "lightnessVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeHsl:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness: typing.Optional[builtins.str] = None,
        lightness_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        :param lightness_var: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__87b4d5542663b02068a7617e1dca5994aa05e3905be31faa306087400fb21784)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness", value=lightness, expected_type=type_hints["lightness"])
            check_type(argname="argument lightness_var", value=lightness_var, expected_type=type_hints["lightness_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness is not None:
            self._values["lightness"] = lightness
        if lightness_var is not None:
            self._values["lightness_var"] = lightness_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        '''
        result = self._values.get("lightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        '''
        result = self._values.get("lightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeHsl(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeHslList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeHslList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3e008e0c2f05aca2a62330c77b0409233d59990a4d09d8ec287beca0ecc86fa9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeHslOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c164f7f536a2b9c24af9a83b26ba53441a5a3b9a672bc20476b97a113866431c)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeHslOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b99724fb9eda6104664e90ef9eb1de72bf01bbbf5392eac5a735a3ee836a1195)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8eaccfcbf7191a6a883e12fe7f6d2ec38df5982fc1a30f793288ea6c23e480f2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b4cb61e2b2f823f60b9fdc24f7512ba3dcae0bed5e69826588f90e48481f86b9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeHsl]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeHsl]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2c2753a18580c26314ae9b1cc328f75a1bc96ee735eac1049d672a437669d176)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeHslOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeHslOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8b8f7bad0acd39d05ea81d8e49c3d13cbf1bf7896befdd985884cf85462dae04)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightness")
    def reset_lightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightness", []))

    @jsii.member(jsii_name="resetLightnessVar")
    def reset_lightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessInput")
    def lightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessVarInput")
    def lightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__427354693ac73071b1ba3c80b3bbbe2d4ff6455c44fe06eeb11c9ec389da4e57)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e9ae407764607d9f5c745f2b5be48dea095d54b47743a39d3ba6ecf417084862)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightness")
    def lightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightness"))

    @lightness.setter
    def lightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__41ed0eccbe6eab9e2ebdb3d93d9e8ca704a1a402846d847fdbbaf9650c85a435)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightness", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessVar")
    def lightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessVar"))

    @lightness_var.setter
    def lightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__161bff45edf0445093aed4816a541d1eb83bab96ae5666eca443ac001daf2b67)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c423ab39727a406e1746df99938cb5569c194c8c9596ad16118e53125d9d7e4c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a688b26a4dd084af53c57bffa1529d669b1ea4887461b6dc4300eb10d99a397)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeHsl]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeHsl]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeHsl]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a5f243a1158c35d3ae46da137d038cf347b6d233cf5024523d1ff00033dfefd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeHsv",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeHsv:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        :param value: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__13dcc9d9cf6b4a43e5aef4f47a123e8fd6a71879015669b7e75d8f8964e36d52)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeHsv(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeHsvList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeHsvList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6c72c614cd46efa3ef35a539e9ee13f61b75134dc4b4fccac467bee929b3418f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeHsvOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__853c1abd2161cf813d3f3043ae06dedad3026830a80bc5d06b51f518eb03bbaf)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeHsvOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0f6adea6fb21cb0fa4496531a3ee360794945db903161016a6c2c6bb310376ef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d96e0f2787675be22fcdfb6ae70dc0d036b1fa0fff61409f6e542c9dd99fcb12)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__718bdf3651b9651d96a9ef24879fedcfd5e33278d4adcb86a56be05c92ab4a24)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeHsv]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeHsv]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c37e571a017f1e36d3c98fca64b3975d297a32797969b8bc6ef4885cddac372f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeHsvOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeHsvOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b796880831a4a793da5adabb7757c21755014c659fd867450671330a929da22c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f9fa31c348ed3d4e03ad7920af105870fd8b59eef34fcdcd4eb0f39e4dc806b6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__33f7cbdafd12360068bc97ada011b798db26c1b4cf8c76f8b408e1d1ab704978)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a43d8509b660eb21b7e2860c216b51bdaedaf448756fd1c24eeb60386e0d5fb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__20a4b492f59c4bf408df7344d68f3ad0bf4d320d673f51313fdbc3496ffa89bb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f4c59c083218906f616862d3f63ffbd0589657a624c2d74abd2a641cbb493622)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e479073a996386b58d90c230d1d4b7a99f7f314e5cae4f5dedadfb81af328735)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeHsv]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeHsv]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeHsv]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a9d1cf5dc3d02f58998703ca2ef7d9098c0dd41263390a92fb2017295654970)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimension",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "dimension": "dimension",
        "dimension_var": "dimensionVar",
        "equal": "equal",
        "greater_than": "greaterThan",
        "less_than": "lessThan",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimension:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        dimension: typing.Optional[builtins.str] = None,
        dimension_var: typing.Optional[builtins.str] = None,
        equal: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionEqual", typing.Dict[builtins.str, typing.Any]]] = None,
        greater_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionGreaterThan", typing.Dict[builtins.str, typing.Any]]] = None,
        less_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionLessThan", typing.Dict[builtins.str, typing.Any]]] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param dimension: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        :param dimension_var: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        :param equal: equal block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        :param greater_than: greater_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        :param less_than: less_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        :param value: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionDefault(**default)
        if isinstance(equal, dict):
            equal = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionEqual(**equal)
        if isinstance(greater_than, dict):
            greater_than = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionGreaterThan(**greater_than)
        if isinstance(less_than, dict):
            less_than = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionLessThan(**less_than)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__426ca2a445d68471a19fb663e6d666943f0f2ce356b6578f8995b20ca098b318)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument dimension", value=dimension, expected_type=type_hints["dimension"])
            check_type(argname="argument dimension_var", value=dimension_var, expected_type=type_hints["dimension_var"])
            check_type(argname="argument equal", value=equal, expected_type=type_hints["equal"])
            check_type(argname="argument greater_than", value=greater_than, expected_type=type_hints["greater_than"])
            check_type(argname="argument less_than", value=less_than, expected_type=type_hints["less_than"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if dimension is not None:
            self._values["dimension"] = dimension
        if dimension_var is not None:
            self._values["dimension_var"] = dimension_var
        if equal is not None:
            self._values["equal"] = equal
        if greater_than is not None:
            self._values["greater_than"] = greater_than
        if less_than is not None:
            self._values["less_than"] = less_than
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionDefault"], result)

    @builtins.property
    def dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        '''
        result = self._values.get("dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        '''
        result = self._values.get("dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def equal(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionEqual"]:
        '''equal block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        '''
        result = self._values.get("equal")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionEqual"], result)

    @builtins.property
    def greater_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionGreaterThan"]:
        '''greater_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        '''
        result = self._values.get("greater_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionGreaterThan"], result)

    @builtins.property
    def less_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionLessThan"]:
        '''less_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        '''
        result = self._values.get("less_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionLessThan"], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimension(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2bdc2298ca45070e16b70b4ed6ecbedfd79c05fcb596b117b3458a5d347814f6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__289593fbf599f7bf0ddace3e67e05e215bb41f5940ae4ff33f113fb1b518e0e3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionEqual",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionEqual:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionEqual(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionEqualOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionEqualOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c3e1bd8b962ec78c6678a86a9351b4dff7f763ee87576d9c8c1c6eee407e3bf8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionEqual], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionEqual],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__618ea5ca2ea0d5722c3fbe4a3f2e2a31a94bd4688e7067c4720a45212988ac0d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionGreaterThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionGreaterThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionGreaterThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionGreaterThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionGreaterThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e4acf1936c106369c68456f249f031f42efba8c5127667d03fbc8a329204d343)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionGreaterThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionGreaterThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d438c15e750069c91fa101e9dd1363380685a0b80da79e6242d59ac839b6813d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionLessThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionLessThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionLessThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionLessThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionLessThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3719cdbf34d11cd777b814e9399d47b40c565d86846ced3350cbf357726ce864)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionLessThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionLessThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9321724972ea3926b236961ca0834093679365c644695f925aab1599b9ab7821)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ca06fb374082cfe325b0a8fe31fb656d9f7644d6f90941e0efb58f29d28013a2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d89390544297c0ec6e90a7782a49bbf15de763b45f4811d7137ae038e7961382)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__836da1d5bb5e6404d263a94e33404f14a8b93c9ae58b38425a4ee6b649b34107)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cbbbfc38fbda4a6e9944973b4e97945765c6f729011871a409dba996e9623b93)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d5d059bd31e1af107cae6216519bdac043ad0aed99b49d7c0f99e26b08ce3052)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimension]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimension]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1b34f995c1f6960136df89751ace0725387f9956d4b9610f1cc6187f2215c863)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f55e0160ab5a83b35d695b6619c98eb99a263ba6be96ec980bafdd9343d5f545)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putEqual")
    def put_equal(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionEqual()

        return typing.cast(None, jsii.invoke(self, "putEqual", [value]))

    @jsii.member(jsii_name="putGreaterThan")
    def put_greater_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionGreaterThan()

        return typing.cast(None, jsii.invoke(self, "putGreaterThan", [value]))

    @jsii.member(jsii_name="putLessThan")
    def put_less_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionLessThan()

        return typing.cast(None, jsii.invoke(self, "putLessThan", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetDimension")
    def reset_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimension", []))

    @jsii.member(jsii_name="resetDimensionVar")
    def reset_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimensionVar", []))

    @jsii.member(jsii_name="resetEqual")
    def reset_equal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEqual", []))

    @jsii.member(jsii_name="resetGreaterThan")
    def reset_greater_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGreaterThan", []))

    @jsii.member(jsii_name="resetLessThan")
    def reset_less_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLessThan", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="equal")
    def equal(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionEqualOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionEqualOutputReference, jsii.get(self, "equal"))

    @builtins.property
    @jsii.member(jsii_name="greaterThan")
    def greater_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionGreaterThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionGreaterThanOutputReference, jsii.get(self, "greaterThan"))

    @builtins.property
    @jsii.member(jsii_name="lessThan")
    def less_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionLessThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionLessThanOutputReference, jsii.get(self, "lessThan"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionInput")
    def dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionVarInput")
    def dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="equalInput")
    def equal_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionEqual], jsii.get(self, "equalInput"))

    @builtins.property
    @jsii.member(jsii_name="greaterThanInput")
    def greater_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionGreaterThan], jsii.get(self, "greaterThanInput"))

    @builtins.property
    @jsii.member(jsii_name="lessThanInput")
    def less_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionLessThan], jsii.get(self, "lessThanInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="dimension")
    def dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimension"))

    @dimension.setter
    def dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__85553cde1aab107ba5b5d8f0667d447d00e15aa82cbe522b6e194e0cd969f6c3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimension", value)

    @builtins.property
    @jsii.member(jsii_name="dimensionVar")
    def dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimensionVar"))

    @dimension_var.setter
    def dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__41fb95576f2176f8f17d8a0546f468d082e8c07051766f1cba40fa27a7f7d3ef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c1f1330f128d74180fef728fa91c80df048d12dcd3d84124ced965b38f8273b6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1cba1aa54bc1054bd7a743fc2960bd462a259d6a36c3502af81cd27e55055ad7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimension]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimension]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimension]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4c1e9725faa83503d1992dcfc2fba6b58c1b2a686cdec1e44d8b81c05de2da2d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientation",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "landscape": "landscape",
        "portrait": "portrait",
        "square": "square",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientation:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        landscape: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationLandscape", typing.Dict[builtins.str, typing.Any]]] = None,
        portrait: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationPortrait", typing.Dict[builtins.str, typing.Any]]] = None,
        square: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationSquare", typing.Dict[builtins.str, typing.Any]]] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param landscape: landscape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        :param portrait: portrait block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        :param square: square block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationDefault(**default)
        if isinstance(landscape, dict):
            landscape = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationLandscape(**landscape)
        if isinstance(portrait, dict):
            portrait = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationPortrait(**portrait)
        if isinstance(square, dict):
            square = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationSquare(**square)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__105a3e0b8b20259fadba0472364270e778743f023d54fa7dfb3527e6d69fe463)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument landscape", value=landscape, expected_type=type_hints["landscape"])
            check_type(argname="argument portrait", value=portrait, expected_type=type_hints["portrait"])
            check_type(argname="argument square", value=square, expected_type=type_hints["square"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if landscape is not None:
            self._values["landscape"] = landscape
        if portrait is not None:
            self._values["portrait"] = portrait
        if square is not None:
            self._values["square"] = square

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationDefault"], result)

    @builtins.property
    def landscape(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationLandscape"]:
        '''landscape block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        '''
        result = self._values.get("landscape")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationLandscape"], result)

    @builtins.property
    def portrait(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationPortrait"]:
        '''portrait block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        '''
        result = self._values.get("portrait")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationPortrait"], result)

    @builtins.property
    def square(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationSquare"]:
        '''square block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        result = self._values.get("square")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationSquare"], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8b8d4f461d5b0e45d272963deaa0cb3cc8d49108269ec2e68eeeaa4e4688b432)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c803b508dc20ecc764e9dc2e235ca36f18ab2e00bfb515bad90dd6b14a303433)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationLandscape",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationLandscape:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationLandscape(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationLandscapeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationLandscapeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dc4ae8d15e9c38837c356059f8a7e24f38390be6c7916102011bc03f686e9417)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationLandscape], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationLandscape],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4fedd7445b06b457cefd9f2fff22c25f6c05e86518fc61eab7e1c9f55531454d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ca7edd5d73c7c9ef017bc55eb2262faf4bf0196e6fc97ab3cb9fada4f8c7862)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ca8fc88f6e5fb1ce4aeeaefc4b41fb332b91a8b43c4fdbd1e331243e14d65c2c)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f8b3796b131c335d77090513f1749d6efa21adef2092ad1fe9ebcc76a08ceda)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ef2d2479bb83192a7b27a42a52339ee8aa9bc247123f4ea69ce52d44f2231ddb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3768a575aff176f7da5cb9d465e891c69a502f97cdd51ef43d411ab1561b461d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientation]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientation]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__86c6cf0ab3c1c9b2e1b51e4e3333c54824773523ac04de7721ab991b4a87ebfc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__34b63b81d471acd1d5686ad330ae5ea4009ffe9fc86a00d4ce7ca21d7343cf66)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putLandscape")
    def put_landscape(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationLandscape()

        return typing.cast(None, jsii.invoke(self, "putLandscape", [value]))

    @jsii.member(jsii_name="putPortrait")
    def put_portrait(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationPortrait()

        return typing.cast(None, jsii.invoke(self, "putPortrait", [value]))

    @jsii.member(jsii_name="putSquare")
    def put_square(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationSquare()

        return typing.cast(None, jsii.invoke(self, "putSquare", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetLandscape")
    def reset_landscape(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLandscape", []))

    @jsii.member(jsii_name="resetPortrait")
    def reset_portrait(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPortrait", []))

    @jsii.member(jsii_name="resetSquare")
    def reset_square(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSquare", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="landscape")
    def landscape(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationLandscapeOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationLandscapeOutputReference, jsii.get(self, "landscape"))

    @builtins.property
    @jsii.member(jsii_name="portrait")
    def portrait(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationPortraitOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationPortraitOutputReference", jsii.get(self, "portrait"))

    @builtins.property
    @jsii.member(jsii_name="square")
    def square(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationSquareOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationSquareOutputReference", jsii.get(self, "square"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="landscapeInput")
    def landscape_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationLandscape], jsii.get(self, "landscapeInput"))

    @builtins.property
    @jsii.member(jsii_name="portraitInput")
    def portrait_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationPortrait"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationPortrait"], jsii.get(self, "portraitInput"))

    @builtins.property
    @jsii.member(jsii_name="squareInput")
    def square_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationSquare"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationSquare"], jsii.get(self, "squareInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientation]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientation]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientation]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__39a55eb2005a760ddd4a22574bf1eb8b45d3c07269e132e01ea4f4d6cca6da41)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationPortrait",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationPortrait:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationPortrait(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationPortraitOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationPortraitOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__13464edab2a2d64b48fa819dedfca326442aae212da53c7bc18b6656f820c47b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationPortrait]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationPortrait], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationPortrait],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__15820a1d66d8cc263a17519ba849805139032964dc6a15bc7871d03f8319929f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationSquare",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationSquare:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationSquare(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationSquareOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationSquareOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9e7feaf31805f7732e85a3dbd9fa1ddd80879cf92b22cd54bcbdb0d7a63e4fff)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationSquare]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationSquare], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationSquare],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9987db841561e03edd65f0554712475241ed0702778a58d640b216298689c3b4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeMaxColors",
    jsii_struct_bases=[],
    name_mapping={"colors": "colors", "colors_var": "colorsVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeMaxColors:
    def __init__(
        self,
        *,
        colors: typing.Optional[builtins.str] = None,
        colors_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param colors: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        :param colors_var: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__118a874dc2fa541829c346ebe2b7469d36745ed3e6cdb102d7119405cb65c810)
            check_type(argname="argument colors", value=colors, expected_type=type_hints["colors"])
            check_type(argname="argument colors_var", value=colors_var, expected_type=type_hints["colors_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if colors is not None:
            self._values["colors"] = colors
        if colors_var is not None:
            self._values["colors_var"] = colors_var

    @builtins.property
    def colors(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        '''
        result = self._values.get("colors")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def colors_var(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        result = self._values.get("colors_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeMaxColors(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeMaxColorsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeMaxColorsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1fdb84276e2d50d714ebb9294f906a87cd99e0a329a735d616081469246b7dee)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeMaxColorsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f853d387bd130bfc846cc3ec7e3f7fcf0fa9bcaedb7bd3dbdb5810ac37fab7a4)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeMaxColorsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0f2ba9bcee9c5bc58ea8ab3a8e28956ed45a63e2a81bd324b7333490ec064041)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4e686742a05a55df22f1ca839eee266d701913d50507423ba54735b126c76bd7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0d48d4a3c348f4f6c60dd2151a8d673aaceff8f2f445411794ca413ea373a855)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeMaxColors]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeMaxColors]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1a5d289a1f7c625c9670f73290eaa1f68cfc143b385468b53042d6d8addfaf7a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeMaxColorsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeMaxColorsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__461234c6289c29d4f8bc349114d7d534a21d1dcd1c3b599fefdb4eec8547412f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColors")
    def reset_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColors", []))

    @jsii.member(jsii_name="resetColorsVar")
    def reset_colors_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorsVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorsInput")
    def colors_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsInput"))

    @builtins.property
    @jsii.member(jsii_name="colorsVarInput")
    def colors_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsVarInput"))

    @builtins.property
    @jsii.member(jsii_name="colors")
    def colors(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colors"))

    @colors.setter
    def colors(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__695bd0b1e89e4e69a9e49650f170d96a36c9307759bc3d8affe9cec06e65d821)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colors", value)

    @builtins.property
    @jsii.member(jsii_name="colorsVar")
    def colors_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorsVar"))

    @colors_var.setter
    def colors_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2e7f9d4dc696fc2b269eb105595fa824572a30585d458b5ccc35a06ebf0e6a13)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorsVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeMaxColors]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeMaxColors]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeMaxColors]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d16d9a9d6252680af2e874a1b76e4bd3ce1ae9d70a06bafbb0657f0f667f24ac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeMirror",
    jsii_struct_bases=[],
    name_mapping={
        "horizontal": "horizontal",
        "horizontal_var": "horizontalVar",
        "vertical": "vertical",
        "vertical_var": "verticalVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeMirror:
    def __init__(
        self,
        *,
        horizontal: typing.Optional[builtins.str] = None,
        horizontal_var: typing.Optional[builtins.str] = None,
        vertical: typing.Optional[builtins.str] = None,
        vertical_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param horizontal: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        :param horizontal_var: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        :param vertical: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        :param vertical_var: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__718984a5b57df32c22c8085af770320c1e786f95445b94b76ce59960e892f63a)
            check_type(argname="argument horizontal", value=horizontal, expected_type=type_hints["horizontal"])
            check_type(argname="argument horizontal_var", value=horizontal_var, expected_type=type_hints["horizontal_var"])
            check_type(argname="argument vertical", value=vertical, expected_type=type_hints["vertical"])
            check_type(argname="argument vertical_var", value=vertical_var, expected_type=type_hints["vertical_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if horizontal is not None:
            self._values["horizontal"] = horizontal
        if horizontal_var is not None:
            self._values["horizontal_var"] = horizontal_var
        if vertical is not None:
            self._values["vertical"] = vertical
        if vertical_var is not None:
            self._values["vertical_var"] = vertical_var

    @builtins.property
    def horizontal(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        '''
        result = self._values.get("horizontal")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def horizontal_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        '''
        result = self._values.get("horizontal_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        '''
        result = self._values.get("vertical")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        result = self._values.get("vertical_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeMirror(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeMirrorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeMirrorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6c330d1ac52e52741bc70c4d8acfdf0501600d3b33109e04b6bd545484eb5047)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeMirrorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3206d9b5ab8732fc29a8e53717d41bd68d1240535b3a524da3a350ff1e5cc0d7)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeMirrorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__00d33e9277cf2ab13b48662441c7018eb491770ee937d593cc9c68c6068990da)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fb29a757a2cdc5149d16768cbf5a93e9c8780e698ab8a3ffce78e3485e57442e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ae7b997ad6dc8298403be1e7f415de33010c98a7463504cb7c07d7f47c459bac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeMirror]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeMirror]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ab6c09669761264e6d1e0af79df3c045f8fa5f9a41bc64def90b8f66b71a6df)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeMirrorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeMirrorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c1d891b2ed2a627d872dc3994b7a297e197e155eaa406937b3eb4796b7254e51)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHorizontal")
    def reset_horizontal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontal", []))

    @jsii.member(jsii_name="resetHorizontalVar")
    def reset_horizontal_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontalVar", []))

    @jsii.member(jsii_name="resetVertical")
    def reset_vertical(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVertical", []))

    @jsii.member(jsii_name="resetVerticalVar")
    def reset_vertical_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVerticalVar", []))

    @builtins.property
    @jsii.member(jsii_name="horizontalInput")
    def horizontal_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontalVarInput")
    def horizontal_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalInput")
    def vertical_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalVarInput")
    def vertical_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontal")
    def horizontal(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontal"))

    @horizontal.setter
    def horizontal(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4608e5759a70ffe8e78081e3513235f18086c643e4f722ba965ec5d77b5e1cb1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontal", value)

    @builtins.property
    @jsii.member(jsii_name="horizontalVar")
    def horizontal_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontalVar"))

    @horizontal_var.setter
    def horizontal_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6afc2500477037d902e8ccd99c8ff355709877db00d85ab7cf3b65fb7619542f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontalVar", value)

    @builtins.property
    @jsii.member(jsii_name="vertical")
    def vertical(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "vertical"))

    @vertical.setter
    def vertical(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__976c083d021f4b83a5c2940b88f5933c78ece2ca4251d9fa3c96227230b695ba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "vertical", value)

    @builtins.property
    @jsii.member(jsii_name="verticalVar")
    def vertical_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "verticalVar"))

    @vertical_var.setter
    def vertical_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8d41556d6fd8f97dd4e074808c63fd07e4913f3576586f9a84ce8723dc10dda3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "verticalVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeMirror]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeMirror]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeMirror]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af1fd5b7e59978efe72b748440d82f97cb3ae76468046367d4513fed562df6f0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeMonoHue",
    jsii_struct_bases=[],
    name_mapping={"hue": "hue", "hue_var": "hueVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeMonoHue:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__17742550556bbbeecac5727a442c8f17966f54f015a531b66b854290b6f7bf7f)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeMonoHue(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeMonoHueList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeMonoHueList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__41656097bc8a0027db5f213f7099b30213eb3fc99da21d33886d7bd1b91f8aee)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeMonoHueOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__78ab41610a445e9664364295c79c2e61b9f92311b10ec34235f09b0bf0769ada)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeMonoHueOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e246816c07da7a106cfb688c582af1fb204be569ff4a93a273841a25865330a1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4b17efc7fd6baacc7ec57a09f7c0532ce561f905e89c9bcda34b23a6e87532cf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__47d6f658204b00470c0e9b88d203e6ffd9dd093ee3d29a9926190cd6fe6c95e8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeMonoHue]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeMonoHue]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f8f8e8e29c7b218126f9c9a13b462abadf26f36447730f4f6719a15c3a6b62bf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeMonoHueOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeMonoHueOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__213f6d87be950b39c51358d8f26ce492cb83af006d0314bbcf9cf7aed340ddca)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f9039e2cd7a6be27db0182816896d470c9e7bc6e919b27d3508a4ec20916a5e7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a5f68bbfc4d5425cad60b86b0b5fceae30251a5fd8e7c2e900fb96586537267a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeMonoHue]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeMonoHue]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeMonoHue]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__95735fb43793f01ca1bc2e1fd37e83bcd74517f5b21e4f2a0de34ac76addccdc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeOpacity",
    jsii_struct_bases=[],
    name_mapping={"opacity": "opacity", "opacity_var": "opacityVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeOpacity:
    def __init__(
        self,
        *,
        opacity: typing.Optional[builtins.str] = None,
        opacity_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param opacity: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param opacity_var: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__15a1190b215d152a5be36497209df63a06d782b9d5f1b5454c9d7a1b8d9f2dc1)
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument opacity_var", value=opacity_var, expected_type=type_hints["opacity_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if opacity is not None:
            self._values["opacity"] = opacity
        if opacity_var is not None:
            self._values["opacity_var"] = opacity_var

    @builtins.property
    def opacity(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def opacity_var(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        result = self._values.get("opacity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeOpacity(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeOpacityList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeOpacityList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fcf1dd1a79f8648a72802fccad8ebae30f8d3f996a69cfd50fafd914871bbd07)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeOpacityOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2b5d24f21d022453fb8c0b64873e681f668c9959e1ca1d411c68dede900da649)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeOpacityOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0de9e75e30afb8d00763760032f80ac9927381631c0ebe88df277beae4f05732)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7c6886817725b2ee4893096d9039b73469f45f14af6488ebe06d66ea95759eae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d002ed4f813ce4f518a778b7b23ce9cc4ab3f580047ad9ff4d4e8fe823a15e2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeOpacity]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeOpacity]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__40bccfdae03ec2b3fa4a3f50fe158816618a0f5c77a17cbc18119c13b4162b58)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeOpacityOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeOpacityOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__800ed189f0c060e9627fe8974546bbaa06ff25797e1a0fb441758a853cf7162e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetOpacityVar")
    def reset_opacity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacityVar", []))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityVarInput")
    def opacity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacity"))

    @opacity.setter
    def opacity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3e744f1cf72f857a5ac6cddf371b446ac1def80b9d78b4ef366b2ced7468cbc0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacity", value)

    @builtins.property
    @jsii.member(jsii_name="opacityVar")
    def opacity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacityVar"))

    @opacity_var.setter
    def opacity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f54ffa05f31947043e83e1d3e59be4241dc2e8329b6ce26062f38f4d6ecb9f85)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacityVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeOpacity]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeOpacity]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeOpacity]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7efba14c40c5af552cb19f69c1fe2f064c9bac36ed03878e131fd8708b36e406)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8851b38e2126502f6cbe702ddab720ae0e79afbefcfdca9c9750166dffd293eb)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putBackgroundColor")
    def put_background_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c862680f3c1beed3d292156b0659d37885d825532b947b044eec4ec4821ab691)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBackgroundColor", [value]))

    @jsii.member(jsii_name="putBlur")
    def put_blur(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeBlur, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f76096c4aacc9477c84d35ba67bb8a8e288ca1e4a0cebc7207263eba415df5e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBlur", [value]))

    @jsii.member(jsii_name="putChromaKey")
    def put_chroma_key(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeChromaKey, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__110aed8c3137d217f69f0daaf508241437d3ca6a0cfcb5b4ddf52cff06d960af)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putChromaKey", [value]))

    @jsii.member(jsii_name="putComposite")
    def put_composite(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeComposite, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df6071bd559616aee19a63ed08deef47c064b8af74ea59c37290dce25a67b557)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putComposite", [value]))

    @jsii.member(jsii_name="putCompound")
    def put_compound(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompound, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d321556a703ab01b326dd3adc06cfa0076397fa2c142e3960244897ffb800825)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCompound", [value]))

    @jsii.member(jsii_name="putContrast")
    def put_contrast(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeContrast, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f06236ea113d90eb1bb90e8284f856393c5f1a7583b0412e9b7b53aa9a5e544d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putContrast", [value]))

    @jsii.member(jsii_name="putGoop")
    def put_goop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeGoop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2f37e5fa100731542831f4138552fce136f2531f24c79cb5f56e5da79a868abf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGoop", [value]))

    @jsii.member(jsii_name="putGrayscale")
    def put_grayscale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeGrayscale, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1a67a2cfa8e08b1128cc4881619113f25a1a2d1bf39eb1e3c35f422f95841cb4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGrayscale", [value]))

    @jsii.member(jsii_name="putHsl")
    def put_hsl(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeHsl, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8c902cb63c9da3d5af3deb50b45883e6858f21d36581e806a2928b6953949bc1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsl", [value]))

    @jsii.member(jsii_name="putHsv")
    def put_hsv(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeHsv, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea8f658b20d8dc480e9928ac29b2c8bd98dbd5e5c0a09c20268e212c3a5686ca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsv", [value]))

    @jsii.member(jsii_name="putIfDimension")
    def put_if_dimension(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimension, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__20d6a5116d458aa9a3d67232d4b19a85a4d52906b752e4496771c020f1a49c05)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfDimension", [value]))

    @jsii.member(jsii_name="putIfOrientation")
    def put_if_orientation(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c2dbbaf2364ace4f457b7b7377286d235bec6cb94ebe4e9f6d155c1a866378e9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfOrientation", [value]))

    @jsii.member(jsii_name="putMaxColors")
    def put_max_colors(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeMaxColors, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__34b160e76fa228047ad9c153040e14c54927e02588d723d6cac22e7fcfa510a1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMaxColors", [value]))

    @jsii.member(jsii_name="putMirror")
    def put_mirror(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeMirror, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b8c6c85e633f530424374cf378548c67808294d8c0e93fcab661f5c3b85e9668)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMirror", [value]))

    @jsii.member(jsii_name="putMonoHue")
    def put_mono_hue(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeMonoHue, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e00d349dc156138ed5d82560eea475c1cf86c48ae07b02686143579c5128c467)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMonoHue", [value]))

    @jsii.member(jsii_name="putOpacity")
    def put_opacity(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeOpacity, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e076c8054f3323937f15baa5314d81cdf53a7389a06cdf9b3ac42ebb8aa3db8c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putOpacity", [value]))

    @jsii.member(jsii_name="putRemoveColor")
    def put_remove_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeRemoveColor", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c065597856c69f36a592d99b2d6c033e4f027c215ba8110338ee49867b520af5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRemoveColor", [value]))

    @jsii.member(jsii_name="putUnsharpMask")
    def put_unsharp_mask(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeUnsharpMask", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__48a405cfad59341365cc81e207c98fc5fd16c5c2681b00438cedc3e58012846f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putUnsharpMask", [value]))

    @jsii.member(jsii_name="resetBackgroundColor")
    def reset_background_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBackgroundColor", []))

    @jsii.member(jsii_name="resetBlur")
    def reset_blur(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBlur", []))

    @jsii.member(jsii_name="resetChromaKey")
    def reset_chroma_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChromaKey", []))

    @jsii.member(jsii_name="resetComposite")
    def reset_composite(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetComposite", []))

    @jsii.member(jsii_name="resetCompound")
    def reset_compound(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCompound", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetGoop")
    def reset_goop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGoop", []))

    @jsii.member(jsii_name="resetGrayscale")
    def reset_grayscale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGrayscale", []))

    @jsii.member(jsii_name="resetHsl")
    def reset_hsl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsl", []))

    @jsii.member(jsii_name="resetHsv")
    def reset_hsv(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsv", []))

    @jsii.member(jsii_name="resetIfDimension")
    def reset_if_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfDimension", []))

    @jsii.member(jsii_name="resetIfOrientation")
    def reset_if_orientation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfOrientation", []))

    @jsii.member(jsii_name="resetMaxColors")
    def reset_max_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxColors", []))

    @jsii.member(jsii_name="resetMirror")
    def reset_mirror(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMirror", []))

    @jsii.member(jsii_name="resetMonoHue")
    def reset_mono_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonoHue", []))

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetRemoveColor")
    def reset_remove_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRemoveColor", []))

    @jsii.member(jsii_name="resetUnsharpMask")
    def reset_unsharp_mask(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUnsharpMask", []))

    @builtins.property
    @jsii.member(jsii_name="backgroundColor")
    def background_color(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeBackgroundColorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeBackgroundColorList, jsii.get(self, "backgroundColor"))

    @builtins.property
    @jsii.member(jsii_name="blur")
    def blur(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeBlurList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeBlurList, jsii.get(self, "blur"))

    @builtins.property
    @jsii.member(jsii_name="chromaKey")
    def chroma_key(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeChromaKeyList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeChromaKeyList, jsii.get(self, "chromaKey"))

    @builtins.property
    @jsii.member(jsii_name="composite")
    def composite(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompositeList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompositeList, jsii.get(self, "composite"))

    @builtins.property
    @jsii.member(jsii_name="compound")
    def compound(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompoundList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompoundList, jsii.get(self, "compound"))

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeContrastList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeContrastList, jsii.get(self, "contrast"))

    @builtins.property
    @jsii.member(jsii_name="goop")
    def goop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeGoopList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeGoopList, jsii.get(self, "goop"))

    @builtins.property
    @jsii.member(jsii_name="grayscale")
    def grayscale(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeGrayscaleList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeGrayscaleList, jsii.get(self, "grayscale"))

    @builtins.property
    @jsii.member(jsii_name="hsl")
    def hsl(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeHslList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeHslList, jsii.get(self, "hsl"))

    @builtins.property
    @jsii.member(jsii_name="hsv")
    def hsv(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeHsvList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeHsvList, jsii.get(self, "hsv"))

    @builtins.property
    @jsii.member(jsii_name="ifDimension")
    def if_dimension(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionList, jsii.get(self, "ifDimension"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientation")
    def if_orientation(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationList, jsii.get(self, "ifOrientation"))

    @builtins.property
    @jsii.member(jsii_name="maxColors")
    def max_colors(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeMaxColorsList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeMaxColorsList, jsii.get(self, "maxColors"))

    @builtins.property
    @jsii.member(jsii_name="mirror")
    def mirror(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeMirrorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeMirrorList, jsii.get(self, "mirror"))

    @builtins.property
    @jsii.member(jsii_name="monoHue")
    def mono_hue(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeMonoHueList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeMonoHueList, jsii.get(self, "monoHue"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeOpacityList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeOpacityList, jsii.get(self, "opacity"))

    @builtins.property
    @jsii.member(jsii_name="removeColor")
    def remove_color(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeRemoveColorList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeRemoveColorList", jsii.get(self, "removeColor"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMask")
    def unsharp_mask(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeUnsharpMaskList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeUnsharpMaskList", jsii.get(self, "unsharpMask"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColorInput")
    def background_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeBackgroundColor]]], jsii.get(self, "backgroundColorInput"))

    @builtins.property
    @jsii.member(jsii_name="blurInput")
    def blur_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeBlur]]], jsii.get(self, "blurInput"))

    @builtins.property
    @jsii.member(jsii_name="chromaKeyInput")
    def chroma_key_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeChromaKey]]], jsii.get(self, "chromaKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="compositeInput")
    def composite_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeComposite]]], jsii.get(self, "compositeInput"))

    @builtins.property
    @jsii.member(jsii_name="compoundInput")
    def compound_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompound]]], jsii.get(self, "compoundInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeContrast]]], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="goopInput")
    def goop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeGoop]]], jsii.get(self, "goopInput"))

    @builtins.property
    @jsii.member(jsii_name="grayscaleInput")
    def grayscale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeGrayscale]]], jsii.get(self, "grayscaleInput"))

    @builtins.property
    @jsii.member(jsii_name="hslInput")
    def hsl_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeHsl]]], jsii.get(self, "hslInput"))

    @builtins.property
    @jsii.member(jsii_name="hsvInput")
    def hsv_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeHsv]]], jsii.get(self, "hsvInput"))

    @builtins.property
    @jsii.member(jsii_name="ifDimensionInput")
    def if_dimension_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimension]]], jsii.get(self, "ifDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientationInput")
    def if_orientation_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientation]]], jsii.get(self, "ifOrientationInput"))

    @builtins.property
    @jsii.member(jsii_name="maxColorsInput")
    def max_colors_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeMaxColors]]], jsii.get(self, "maxColorsInput"))

    @builtins.property
    @jsii.member(jsii_name="mirrorInput")
    def mirror_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeMirror]]], jsii.get(self, "mirrorInput"))

    @builtins.property
    @jsii.member(jsii_name="monoHueInput")
    def mono_hue_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeMonoHue]]], jsii.get(self, "monoHueInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeOpacity]]], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="removeColorInput")
    def remove_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeRemoveColor"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeRemoveColor"]]], jsii.get(self, "removeColorInput"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMaskInput")
    def unsharp_mask_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeUnsharpMask"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeUnsharpMask"]]], jsii.get(self, "unsharpMaskInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscape], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscape],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a90e038d4bbf9277a9e0bebe56cea82f8cdf478b67607e54cb62c12fa1802935)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeRemoveColor",
    jsii_struct_bases=[],
    name_mapping={
        "color": "color",
        "color_var": "colorVar",
        "feather": "feather",
        "feather_var": "featherVar",
        "tolerance": "tolerance",
        "tolerance_var": "toleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeRemoveColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
        feather: typing.Optional[builtins.str] = None,
        feather_var: typing.Optional[builtins.str] = None,
        tolerance: typing.Optional[builtins.str] = None,
        tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        :param feather: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        :param feather_var: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        :param tolerance: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        :param tolerance_var: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__184f0df824e18ae06076e2dd7538b5b72a054aa6bbc2569d9da658c79c5aa22c)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
            check_type(argname="argument feather", value=feather, expected_type=type_hints["feather"])
            check_type(argname="argument feather_var", value=feather_var, expected_type=type_hints["feather_var"])
            check_type(argname="argument tolerance", value=tolerance, expected_type=type_hints["tolerance"])
            check_type(argname="argument tolerance_var", value=tolerance_var, expected_type=type_hints["tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var
        if feather is not None:
            self._values["feather"] = feather
        if feather_var is not None:
            self._values["feather_var"] = feather_var
        if tolerance is not None:
            self._values["tolerance"] = tolerance
        if tolerance_var is not None:
            self._values["tolerance_var"] = tolerance_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        '''
        result = self._values.get("feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather_var(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        '''
        result = self._values.get("feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        '''
        result = self._values.get("tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance_var(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        result = self._values.get("tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeRemoveColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeRemoveColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeRemoveColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8f54856dc5d78b0f4f8272bbfc748db595d6e2a05303c578a491bd2ba86617f7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeRemoveColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b7d51a2faa64ac59069eadaf4630594687b9a9004f69aed0b79fe3153b9e4cda)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeRemoveColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__349a434df5e0c1f8dfc80a37c277047d0bd7d1dcdb50668ca9166fb4f414f92e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a5cc93edcf12a93df74846ce630199c4d16c466b0a60b55d380562017f2aa943)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__67302de9222f083fb813dc64afb448284fa62d1f3073f673bb7be5d57cdf6d49)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeRemoveColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeRemoveColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeRemoveColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a612e133f0f9148febcd3b212e1abe331a8a35a13d82efb4e0fd7b54995d23a1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeRemoveColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeRemoveColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d9c3ce3c159e7ae5451b7f8875478faf722e575de04a880b52abb0b5afb44cb6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @jsii.member(jsii_name="resetFeather")
    def reset_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeather", []))

    @jsii.member(jsii_name="resetFeatherVar")
    def reset_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatherVar", []))

    @jsii.member(jsii_name="resetTolerance")
    def reset_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTolerance", []))

    @jsii.member(jsii_name="resetToleranceVar")
    def reset_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featherInput")
    def feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherInput"))

    @builtins.property
    @jsii.member(jsii_name="featherVarInput")
    def feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceInput")
    def tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceVarInput")
    def tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e37cb745652aa33ffc3ef86cf91f35f116d02904384b7565b4e45f015b93906c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a99becca4ab18a22c86c8dd8640fe3e8fd2165ec2e58e2c19a6a93d6ac570ff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="feather")
    def feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "feather"))

    @feather.setter
    def feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__52eec929a5fcc7154fa7abc7e9af8630b036ce91bf964d8a255ce69a34869deb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "feather", value)

    @builtins.property
    @jsii.member(jsii_name="featherVar")
    def feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featherVar"))

    @feather_var.setter
    def feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__67c5a009d2eb8461de449efb404e193521d1920a0cb49411a473af32f1119ffd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featherVar", value)

    @builtins.property
    @jsii.member(jsii_name="tolerance")
    def tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tolerance"))

    @tolerance.setter
    def tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c9f6719553a4d2d670fb2dcd803b415b1776cdef6aebf92c0b2085ce64d08214)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tolerance", value)

    @builtins.property
    @jsii.member(jsii_name="toleranceVar")
    def tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "toleranceVar"))

    @tolerance_var.setter
    def tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8efa74c15f805293c751929272a2daef4e8c6cbce0b76245d82778304542c3b7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "toleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeRemoveColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeRemoveColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeRemoveColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0fab5fff98a27fa209d3ab8d721fd0e26d4fdeea3c23308c471f0e959efbf339)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeUnsharpMask",
    jsii_struct_bases=[],
    name_mapping={
        "gain": "gain",
        "gain_var": "gainVar",
        "sigma": "sigma",
        "sigma_var": "sigmaVar",
        "threshold": "threshold",
        "threshold_var": "thresholdVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeUnsharpMask:
    def __init__(
        self,
        *,
        gain: typing.Optional[builtins.str] = None,
        gain_var: typing.Optional[builtins.str] = None,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
        threshold: typing.Optional[builtins.str] = None,
        threshold_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param gain: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        :param gain_var: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        :param sigma: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        :param threshold: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        :param threshold_var: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__18b20d39ab241ba27cea92ee3212b4e4bbca595fc97fcac9e493460da946576e)
            check_type(argname="argument gain", value=gain, expected_type=type_hints["gain"])
            check_type(argname="argument gain_var", value=gain_var, expected_type=type_hints["gain_var"])
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
            check_type(argname="argument threshold", value=threshold, expected_type=type_hints["threshold"])
            check_type(argname="argument threshold_var", value=threshold_var, expected_type=type_hints["threshold_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if gain is not None:
            self._values["gain"] = gain
        if gain_var is not None:
            self._values["gain_var"] = gain_var
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var
        if threshold is not None:
            self._values["threshold"] = threshold
        if threshold_var is not None:
            self._values["threshold_var"] = threshold_var

    @builtins.property
    def gain(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        '''
        result = self._values.get("gain")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gain_var(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        '''
        result = self._values.get("gain_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        '''
        result = self._values.get("threshold")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold_var(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        result = self._values.get("threshold_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeUnsharpMask(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeUnsharpMaskList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeUnsharpMaskList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3e77bfc8638a84dfebe6dcd4ff481b592bb958264809f376f2f7fae3dee37d63)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeUnsharpMaskOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__15367f7e56382559b6772c107bfa3afb88fd660fc77deca3c9aa9047b975e4a4)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeUnsharpMaskOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3f436ca3926d69dde670ff29e395fb476f9b09f8f366d0e3f40352b6e3968179)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3f9dd706ce6e029bd482fc19c498f2d92010fd88e98caa9546c0e4937b8afcbd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e816379f7b4931ebef75db34209a8cd1f0f52e6466f8b55bfdfd0382eefc4068)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeUnsharpMask]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeUnsharpMask]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeUnsharpMask]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8d7b0d0edabddad47ea25589a94d00c18b4f6dd0014c2c4361c8b409e5dee13e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeUnsharpMaskOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeUnsharpMaskOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c6ae23a2f8cb6139b3d51784e4eab3bc6f846c2e345470dc9cf8a389f1259a94)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetGain")
    def reset_gain(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGain", []))

    @jsii.member(jsii_name="resetGainVar")
    def reset_gain_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGainVar", []))

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @jsii.member(jsii_name="resetThreshold")
    def reset_threshold(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThreshold", []))

    @jsii.member(jsii_name="resetThresholdVar")
    def reset_threshold_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThresholdVar", []))

    @builtins.property
    @jsii.member(jsii_name="gainInput")
    def gain_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainInput"))

    @builtins.property
    @jsii.member(jsii_name="gainVarInput")
    def gain_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdInput")
    def threshold_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdVarInput")
    def threshold_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gain")
    def gain(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gain"))

    @gain.setter
    def gain(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__358d17410c8231796005d7a0612df1daac5a841267db5bafc166e65bb5af9319)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gain", value)

    @builtins.property
    @jsii.member(jsii_name="gainVar")
    def gain_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gainVar"))

    @gain_var.setter
    def gain_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ada2dc28d8fc9918a2805e03f4403936902126e4ebc60fe3373ca35302ad02e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gainVar", value)

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__36da1f04ba97cc3f9f4158179aebbc6611ae5178e1ad747a23aa276c1d5630b2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9b659564a77482d0c8e580ec97faccd9f8bb599d81a6a4a5e1324e8439ab1c3e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="threshold")
    def threshold(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "threshold"))

    @threshold.setter
    def threshold(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b2856fce806708e3979b1532012db44e5480db69e9688426fc8bb6cac8fdd697)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "threshold", value)

    @builtins.property
    @jsii.member(jsii_name="thresholdVar")
    def threshold_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "thresholdVar"))

    @threshold_var.setter
    def threshold_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e58d8b51325c12885b6f66fdbfae3ca773a7e4842a6633e0b12aa941903266d6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "thresholdVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeUnsharpMask]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeUnsharpMask]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeUnsharpMask]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cc41299995a88dd33c82b470d1c4c7270464b333f5b6af891f8a9de54c1b6325)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__64c48cd5dee49c23f452144b9437d8c202f6326fd60cb4b7c864eda0404a89c1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__706b95f8d14862040edab2d57fcd259c53358c9546a57ce889f61113160cbe80)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a8298f4f0f7c915d244bd22c5ee28c415d34a98cb5feeebfbf838a7950980b77)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__abc7fdc9e01d5f44c5977875a4e3f601ba957d8e688838e5f3282b27a0d311b7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e8ba8e4272edcd528a066fcaa0fb5890d340e3b1dd8ec056254b427274cd0ca7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientation]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientation]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__552609309c74c4ca0aa9c8e0ba31260e4f354c4bb35eca6ac7fd8e259af21d7b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e75794b671f88e6c7abb9c642c8dfcd0ac3866e92c9d2d141f54328fddeb5844)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(
        self,
        *,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefault(
            background_color=background_color,
            blur=blur,
            chroma_key=chroma_key,
            composite=composite,
            compound=compound,
            contrast=contrast,
            goop=goop,
            grayscale=grayscale,
            hsl=hsl,
            hsv=hsv,
            if_dimension=if_dimension,
            if_orientation=if_orientation,
            max_colors=max_colors,
            mirror=mirror,
            mono_hue=mono_hue,
            opacity=opacity,
            remove_color=remove_color,
            unsharp_mask=unsharp_mask,
        )

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putLandscape")
    def put_landscape(
        self,
        *,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscape(
            background_color=background_color,
            blur=blur,
            chroma_key=chroma_key,
            composite=composite,
            compound=compound,
            contrast=contrast,
            goop=goop,
            grayscale=grayscale,
            hsl=hsl,
            hsv=hsv,
            if_dimension=if_dimension,
            if_orientation=if_orientation,
            max_colors=max_colors,
            mirror=mirror,
            mono_hue=mono_hue,
            opacity=opacity,
            remove_color=remove_color,
            unsharp_mask=unsharp_mask,
        )

        return typing.cast(None, jsii.invoke(self, "putLandscape", [value]))

    @jsii.member(jsii_name="putPortrait")
    def put_portrait(
        self,
        *,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitBackgroundColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitBlur", typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitChromaKey", typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitComposite", typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitCompound", typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitContrast", typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitGoop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitGrayscale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitHsl", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitHsv", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimension", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientation", typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitMaxColors", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitMirror", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitMonoHue", typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitOpacity", typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitRemoveColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitUnsharpMask", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortrait(
            background_color=background_color,
            blur=blur,
            chroma_key=chroma_key,
            composite=composite,
            compound=compound,
            contrast=contrast,
            goop=goop,
            grayscale=grayscale,
            hsl=hsl,
            hsv=hsv,
            if_dimension=if_dimension,
            if_orientation=if_orientation,
            max_colors=max_colors,
            mirror=mirror,
            mono_hue=mono_hue,
            opacity=opacity,
            remove_color=remove_color,
            unsharp_mask=unsharp_mask,
        )

        return typing.cast(None, jsii.invoke(self, "putPortrait", [value]))

    @jsii.member(jsii_name="putSquare")
    def put_square(
        self,
        *,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareBackgroundColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareBlur", typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareChromaKey", typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareComposite", typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareCompound", typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareContrast", typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareGoop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareGrayscale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareHsl", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareHsv", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimension", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientation", typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareMaxColors", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareMirror", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareMonoHue", typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareOpacity", typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareRemoveColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareUnsharpMask", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquare(
            background_color=background_color,
            blur=blur,
            chroma_key=chroma_key,
            composite=composite,
            compound=compound,
            contrast=contrast,
            goop=goop,
            grayscale=grayscale,
            hsl=hsl,
            hsv=hsv,
            if_dimension=if_dimension,
            if_orientation=if_orientation,
            max_colors=max_colors,
            mirror=mirror,
            mono_hue=mono_hue,
            opacity=opacity,
            remove_color=remove_color,
            unsharp_mask=unsharp_mask,
        )

        return typing.cast(None, jsii.invoke(self, "putSquare", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetLandscape")
    def reset_landscape(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLandscape", []))

    @jsii.member(jsii_name="resetPortrait")
    def reset_portrait(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPortrait", []))

    @jsii.member(jsii_name="resetSquare")
    def reset_square(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSquare", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="landscape")
    def landscape(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeOutputReference, jsii.get(self, "landscape"))

    @builtins.property
    @jsii.member(jsii_name="portrait")
    def portrait(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitOutputReference", jsii.get(self, "portrait"))

    @builtins.property
    @jsii.member(jsii_name="square")
    def square(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareOutputReference", jsii.get(self, "square"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="landscapeInput")
    def landscape_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscape], jsii.get(self, "landscapeInput"))

    @builtins.property
    @jsii.member(jsii_name="portraitInput")
    def portrait_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortrait"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortrait"], jsii.get(self, "portraitInput"))

    @builtins.property
    @jsii.member(jsii_name="squareInput")
    def square_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquare"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquare"], jsii.get(self, "squareInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientation]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientation]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientation]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__08974fcd16cd862c3f63f6913686d8c2d9c994d5bd20557145f7078843404757)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortrait",
    jsii_struct_bases=[],
    name_mapping={
        "background_color": "backgroundColor",
        "blur": "blur",
        "chroma_key": "chromaKey",
        "composite": "composite",
        "compound": "compound",
        "contrast": "contrast",
        "goop": "goop",
        "grayscale": "grayscale",
        "hsl": "hsl",
        "hsv": "hsv",
        "if_dimension": "ifDimension",
        "if_orientation": "ifOrientation",
        "max_colors": "maxColors",
        "mirror": "mirror",
        "mono_hue": "monoHue",
        "opacity": "opacity",
        "remove_color": "removeColor",
        "unsharp_mask": "unsharpMask",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortrait:
    def __init__(
        self,
        *,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitBackgroundColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitBlur", typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitChromaKey", typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitComposite", typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitCompound", typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitContrast", typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitGoop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitGrayscale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitHsl", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitHsv", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimension", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientation", typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitMaxColors", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitMirror", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitMonoHue", typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitOpacity", typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitRemoveColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitUnsharpMask", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ccf085e80bb12790582e24f05966973788da19c13960cf911cf8b00b02ab40ab)
            check_type(argname="argument background_color", value=background_color, expected_type=type_hints["background_color"])
            check_type(argname="argument blur", value=blur, expected_type=type_hints["blur"])
            check_type(argname="argument chroma_key", value=chroma_key, expected_type=type_hints["chroma_key"])
            check_type(argname="argument composite", value=composite, expected_type=type_hints["composite"])
            check_type(argname="argument compound", value=compound, expected_type=type_hints["compound"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument goop", value=goop, expected_type=type_hints["goop"])
            check_type(argname="argument grayscale", value=grayscale, expected_type=type_hints["grayscale"])
            check_type(argname="argument hsl", value=hsl, expected_type=type_hints["hsl"])
            check_type(argname="argument hsv", value=hsv, expected_type=type_hints["hsv"])
            check_type(argname="argument if_dimension", value=if_dimension, expected_type=type_hints["if_dimension"])
            check_type(argname="argument if_orientation", value=if_orientation, expected_type=type_hints["if_orientation"])
            check_type(argname="argument max_colors", value=max_colors, expected_type=type_hints["max_colors"])
            check_type(argname="argument mirror", value=mirror, expected_type=type_hints["mirror"])
            check_type(argname="argument mono_hue", value=mono_hue, expected_type=type_hints["mono_hue"])
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument remove_color", value=remove_color, expected_type=type_hints["remove_color"])
            check_type(argname="argument unsharp_mask", value=unsharp_mask, expected_type=type_hints["unsharp_mask"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if background_color is not None:
            self._values["background_color"] = background_color
        if blur is not None:
            self._values["blur"] = blur
        if chroma_key is not None:
            self._values["chroma_key"] = chroma_key
        if composite is not None:
            self._values["composite"] = composite
        if compound is not None:
            self._values["compound"] = compound
        if contrast is not None:
            self._values["contrast"] = contrast
        if goop is not None:
            self._values["goop"] = goop
        if grayscale is not None:
            self._values["grayscale"] = grayscale
        if hsl is not None:
            self._values["hsl"] = hsl
        if hsv is not None:
            self._values["hsv"] = hsv
        if if_dimension is not None:
            self._values["if_dimension"] = if_dimension
        if if_orientation is not None:
            self._values["if_orientation"] = if_orientation
        if max_colors is not None:
            self._values["max_colors"] = max_colors
        if mirror is not None:
            self._values["mirror"] = mirror
        if mono_hue is not None:
            self._values["mono_hue"] = mono_hue
        if opacity is not None:
            self._values["opacity"] = opacity
        if remove_color is not None:
            self._values["remove_color"] = remove_color
        if unsharp_mask is not None:
            self._values["unsharp_mask"] = unsharp_mask

    @builtins.property
    def background_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitBackgroundColor"]]]:
        '''background_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        '''
        result = self._values.get("background_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitBackgroundColor"]]], result)

    @builtins.property
    def blur(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitBlur"]]]:
        '''blur block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        '''
        result = self._values.get("blur")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitBlur"]]], result)

    @builtins.property
    def chroma_key(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitChromaKey"]]]:
        '''chroma_key block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        '''
        result = self._values.get("chroma_key")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitChromaKey"]]], result)

    @builtins.property
    def composite(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitComposite"]]]:
        '''composite block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        '''
        result = self._values.get("composite")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitComposite"]]], result)

    @builtins.property
    def compound(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitCompound"]]]:
        '''compound block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        '''
        result = self._values.get("compound")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitCompound"]]], result)

    @builtins.property
    def contrast(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitContrast"]]]:
        '''contrast block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitContrast"]]], result)

    @builtins.property
    def goop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitGoop"]]]:
        '''goop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        '''
        result = self._values.get("goop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitGoop"]]], result)

    @builtins.property
    def grayscale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitGrayscale"]]]:
        '''grayscale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        '''
        result = self._values.get("grayscale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitGrayscale"]]], result)

    @builtins.property
    def hsl(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitHsl"]]]:
        '''hsl block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        '''
        result = self._values.get("hsl")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitHsl"]]], result)

    @builtins.property
    def hsv(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitHsv"]]]:
        '''hsv block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        '''
        result = self._values.get("hsv")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitHsv"]]], result)

    @builtins.property
    def if_dimension(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimension"]]]:
        '''if_dimension block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        '''
        result = self._values.get("if_dimension")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimension"]]], result)

    @builtins.property
    def if_orientation(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientation"]]]:
        '''if_orientation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        '''
        result = self._values.get("if_orientation")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientation"]]], result)

    @builtins.property
    def max_colors(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitMaxColors"]]]:
        '''max_colors block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        '''
        result = self._values.get("max_colors")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitMaxColors"]]], result)

    @builtins.property
    def mirror(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitMirror"]]]:
        '''mirror block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        '''
        result = self._values.get("mirror")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitMirror"]]], result)

    @builtins.property
    def mono_hue(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitMonoHue"]]]:
        '''mono_hue block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        '''
        result = self._values.get("mono_hue")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitMonoHue"]]], result)

    @builtins.property
    def opacity(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitOpacity"]]]:
        '''opacity block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitOpacity"]]], result)

    @builtins.property
    def remove_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitRemoveColor"]]]:
        '''remove_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        '''
        result = self._values.get("remove_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitRemoveColor"]]], result)

    @builtins.property
    def unsharp_mask(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitUnsharpMask"]]]:
        '''unsharp_mask block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        result = self._values.get("unsharp_mask")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitUnsharpMask"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortrait(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitBackgroundColor",
    jsii_struct_bases=[],
    name_mapping={"color": "color", "color_var": "colorVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitBackgroundColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__520b45ef87c5d231cc937354bccaf7c5a19abf70ebda24c0eef120b4818bedef)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitBackgroundColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitBackgroundColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitBackgroundColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__94a2274b40d3b422043de3d626d45e518aaa04a3b080ccd99484f26b600d530f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitBackgroundColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__253a7110c8b12329008100ff982dc3afadabd394bbc295328b344d2bcbffebf2)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitBackgroundColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__53132e1387ee5c65540d73a1ca7399de8b60e1d824460976be09a166df0243b3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7ac8c32a3dbe9235883ad07b9e98e93ad02fbdccc2d7d4ab79303ec78b4ca638)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f7281912379c30a2a03af52483e9f58106822219eeb9c8461c937cebd8c3e63f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitBackgroundColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitBackgroundColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2b68d1e64eec0538f982e45ffffd53d833c9ca9446ae33b7a76c21670963286b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitBackgroundColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitBackgroundColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__60defc60f965812c7284ce3c259a765ddb6e592259bf3fa1a93d3dbcbeeb1c7e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b97359bcf475fd3e67338d848a613df9e5c834751e376ee27fb8acdbaef092f6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__73170b7b40dc47c6cb4b5128a50bc95df9f203a1224e5b570f1293d8e2ebf3a1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitBackgroundColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitBackgroundColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitBackgroundColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c3168d76a31da5dfd9c5ff9778a2404f3046dcd44b3233ac56cbc3e1b0f8fe9e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitBlur",
    jsii_struct_bases=[],
    name_mapping={"sigma": "sigma", "sigma_var": "sigmaVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitBlur:
    def __init__(
        self,
        *,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param sigma: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bbf38b78492db117bbd9174312094e10fc10a1e0ed4aae13c7cad2cd3f233090)
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitBlur(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitBlurList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitBlurList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b28ab2decbcd867cbe4f7d207dbc1b4cf7706e2f613a73085258765dab8c6585)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitBlurOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__76f24e4c6e61ccdde1810093d41d334d792965aa14503ce2895c65efa4c9455a)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitBlurOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__85f509a9c03b72196d8b93db8c39111cd8f046d194cc9aa92a8d119c4e930a54)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c49534dc5eb9d8a96db81e7525f168c0cb7702cb1a1e89ffb045f5612d2adfc8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a3102f79586f8c9c4dcb71d4a04f2780d7f40f224c19eda8f7a9965a5b69d42f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitBlur]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitBlur]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dd9a70cf946e7bca853faa02a542b0e8ec7136753f41fea374c8491e0a06d38d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitBlurOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitBlurOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__24be42c915311bada4af6fc241f6555d96b0d662c1bca95e290949b319462612)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f7abca6522cc5a62c4d96ec068ca6e00d96ee80c2d99c60b8a6e93ac0426ab0a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__158032c89ddee59c312e1a842d68bcc18175573ede26e2c8f599fc4c1d1b3328)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitBlur]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitBlur]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitBlur]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__21fe60439152ce5ff269cbf013de79404f63e92f5522bdf78a8ea4dd5e056af8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitChromaKey",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_feather": "hueFeather",
        "hue_feather_var": "hueFeatherVar",
        "hue_tolerance": "hueTolerance",
        "hue_tolerance_var": "hueToleranceVar",
        "hue_var": "hueVar",
        "lightness_feather": "lightnessFeather",
        "lightness_feather_var": "lightnessFeatherVar",
        "lightness_tolerance": "lightnessTolerance",
        "lightness_tolerance_var": "lightnessToleranceVar",
        "saturation_feather": "saturationFeather",
        "saturation_feather_var": "saturationFeatherVar",
        "saturation_tolerance": "saturationTolerance",
        "saturation_tolerance_var": "saturationToleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitChromaKey:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_feather: typing.Optional[builtins.str] = None,
        hue_feather_var: typing.Optional[builtins.str] = None,
        hue_tolerance: typing.Optional[builtins.str] = None,
        hue_tolerance_var: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness_feather: typing.Optional[builtins.str] = None,
        lightness_feather_var: typing.Optional[builtins.str] = None,
        lightness_tolerance: typing.Optional[builtins.str] = None,
        lightness_tolerance_var: typing.Optional[builtins.str] = None,
        saturation_feather: typing.Optional[builtins.str] = None,
        saturation_feather_var: typing.Optional[builtins.str] = None,
        saturation_tolerance: typing.Optional[builtins.str] = None,
        saturation_tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_feather: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        :param hue_feather_var: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        :param hue_tolerance: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        :param hue_tolerance_var: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        :param hue_var: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness_feather: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        :param lightness_feather_var: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        :param lightness_tolerance: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        :param lightness_tolerance_var: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        :param saturation_feather: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        :param saturation_feather_var: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        :param saturation_tolerance: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        :param saturation_tolerance_var: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__084289d3b0d478e74016b5d4a60519e690963fbff0a1ce314ed076086a3638c6)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_feather", value=hue_feather, expected_type=type_hints["hue_feather"])
            check_type(argname="argument hue_feather_var", value=hue_feather_var, expected_type=type_hints["hue_feather_var"])
            check_type(argname="argument hue_tolerance", value=hue_tolerance, expected_type=type_hints["hue_tolerance"])
            check_type(argname="argument hue_tolerance_var", value=hue_tolerance_var, expected_type=type_hints["hue_tolerance_var"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness_feather", value=lightness_feather, expected_type=type_hints["lightness_feather"])
            check_type(argname="argument lightness_feather_var", value=lightness_feather_var, expected_type=type_hints["lightness_feather_var"])
            check_type(argname="argument lightness_tolerance", value=lightness_tolerance, expected_type=type_hints["lightness_tolerance"])
            check_type(argname="argument lightness_tolerance_var", value=lightness_tolerance_var, expected_type=type_hints["lightness_tolerance_var"])
            check_type(argname="argument saturation_feather", value=saturation_feather, expected_type=type_hints["saturation_feather"])
            check_type(argname="argument saturation_feather_var", value=saturation_feather_var, expected_type=type_hints["saturation_feather_var"])
            check_type(argname="argument saturation_tolerance", value=saturation_tolerance, expected_type=type_hints["saturation_tolerance"])
            check_type(argname="argument saturation_tolerance_var", value=saturation_tolerance_var, expected_type=type_hints["saturation_tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_feather is not None:
            self._values["hue_feather"] = hue_feather
        if hue_feather_var is not None:
            self._values["hue_feather_var"] = hue_feather_var
        if hue_tolerance is not None:
            self._values["hue_tolerance"] = hue_tolerance
        if hue_tolerance_var is not None:
            self._values["hue_tolerance_var"] = hue_tolerance_var
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness_feather is not None:
            self._values["lightness_feather"] = lightness_feather
        if lightness_feather_var is not None:
            self._values["lightness_feather_var"] = lightness_feather_var
        if lightness_tolerance is not None:
            self._values["lightness_tolerance"] = lightness_tolerance
        if lightness_tolerance_var is not None:
            self._values["lightness_tolerance_var"] = lightness_tolerance_var
        if saturation_feather is not None:
            self._values["saturation_feather"] = saturation_feather
        if saturation_feather_var is not None:
            self._values["saturation_feather_var"] = saturation_feather_var
        if saturation_tolerance is not None:
            self._values["saturation_tolerance"] = saturation_tolerance
        if saturation_tolerance_var is not None:
            self._values["saturation_tolerance_var"] = saturation_tolerance_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        '''
        result = self._values.get("hue_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        '''
        result = self._values.get("hue_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        '''
        result = self._values.get("hue_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        '''
        result = self._values.get("hue_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        '''
        result = self._values.get("lightness_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        '''
        result = self._values.get("lightness_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        '''
        result = self._values.get("lightness_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        '''
        result = self._values.get("lightness_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        '''
        result = self._values.get("saturation_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        '''
        result = self._values.get("saturation_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        '''
        result = self._values.get("saturation_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        result = self._values.get("saturation_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitChromaKey(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitChromaKeyList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitChromaKeyList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__232feea8d258980349739b6a5fd87243022e68b6a3772bdc14cbddeb244acecd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitChromaKeyOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f5fb906605df697d151af659c99179a6ec8df3c4ff2d01b55d6e77759a0f206d)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitChromaKeyOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4d20b95711bd66197a5d7544c93798884848b86ae5813dd2ab82c32516efc281)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0848bc9d92b147e26defa2ff74de89706a0229cba75777aa432737f94553b221)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__30b4b215a0465fe3ee441e9737476b38e3307709354a6b636325545ade4044be)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitChromaKey]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitChromaKey]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__da21e610152be4415e4254582422d89547b3c7c661334aa42a6e0a9126a9d20f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitChromaKeyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitChromaKeyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fc7f10a2a3d327c20f94d8eec85ee520d55211a29e7e18ed3c20f134d89fbf85)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueFeather")
    def reset_hue_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeather", []))

    @jsii.member(jsii_name="resetHueFeatherVar")
    def reset_hue_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeatherVar", []))

    @jsii.member(jsii_name="resetHueTolerance")
    def reset_hue_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueTolerance", []))

    @jsii.member(jsii_name="resetHueToleranceVar")
    def reset_hue_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueToleranceVar", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightnessFeather")
    def reset_lightness_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeather", []))

    @jsii.member(jsii_name="resetLightnessFeatherVar")
    def reset_lightness_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeatherVar", []))

    @jsii.member(jsii_name="resetLightnessTolerance")
    def reset_lightness_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessTolerance", []))

    @jsii.member(jsii_name="resetLightnessToleranceVar")
    def reset_lightness_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessToleranceVar", []))

    @jsii.member(jsii_name="resetSaturationFeather")
    def reset_saturation_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeather", []))

    @jsii.member(jsii_name="resetSaturationFeatherVar")
    def reset_saturation_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeatherVar", []))

    @jsii.member(jsii_name="resetSaturationTolerance")
    def reset_saturation_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationTolerance", []))

    @jsii.member(jsii_name="resetSaturationToleranceVar")
    def reset_saturation_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherInput")
    def hue_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVarInput")
    def hue_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceInput")
    def hue_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVarInput")
    def hue_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherInput")
    def lightness_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVarInput")
    def lightness_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceInput")
    def lightness_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVarInput")
    def lightness_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherInput")
    def saturation_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVarInput")
    def saturation_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceInput")
    def saturation_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVarInput")
    def saturation_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa4b38da7f8ce4bfe33fba9316f14b58375fb831d7cdba63c8e10c9c9cadcac6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeather")
    def hue_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeather"))

    @hue_feather.setter
    def hue_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__04b4330d2b238d49d1f217ca413d82ddd5e5c9facba3c0c26ecb4a00512a0720)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeather", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVar")
    def hue_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeatherVar"))

    @hue_feather_var.setter
    def hue_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cfb6a75ca44f45ca0d3243b89514f57c03e6c1f6ce1ebae0735ad5b554042b31)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueTolerance")
    def hue_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueTolerance"))

    @hue_tolerance.setter
    def hue_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__54c72b0900dfccedf56ff072e32d5f2df88c8d9f18916a056e73ca058cb21c85)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVar")
    def hue_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueToleranceVar"))

    @hue_tolerance_var.setter
    def hue_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__35ed6258811df8d9053d4fcaad1da83799826b927bc1ec234ccd95c761402d8b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ae245ba64cd3fe17c134607853b4994b8fd72303be1903b8617e18e74d2e58e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeather")
    def lightness_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeather"))

    @lightness_feather.setter
    def lightness_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e775599854856e2946d2c0202a87c5aa77ae2447aef511c232b091bdd9eb373)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeather", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVar")
    def lightness_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeatherVar"))

    @lightness_feather_var.setter
    def lightness_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3682b24edf87e54b882efa4018fe5cb422b2fc6766acfe946c7717976f8dde28)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessTolerance")
    def lightness_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessTolerance"))

    @lightness_tolerance.setter
    def lightness_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__229ad021729661311647b74d96280910448e524af93a2738914653f1cddc80a6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVar")
    def lightness_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessToleranceVar"))

    @lightness_tolerance_var.setter
    def lightness_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__42f36c60cb158689dc5d03903486870e462ab2479bca16bb06de578bf9991121)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeather")
    def saturation_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeather"))

    @saturation_feather.setter
    def saturation_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__64ce21226c87ee2cd1a1f7194ced9bf6a4f76d6b84b7cd054e244d0b346c7a67)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeather", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVar")
    def saturation_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeatherVar"))

    @saturation_feather_var.setter
    def saturation_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f69eda4dcb72f4e5e1975a39cbaa3578c539f3b169e3568788a5aa3a0c60f512)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationTolerance")
    def saturation_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationTolerance"))

    @saturation_tolerance.setter
    def saturation_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a622c6be95481b8633e33f631b509d7142996ff8052661ce24efd97f479507c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVar")
    def saturation_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationToleranceVar"))

    @saturation_tolerance_var.setter
    def saturation_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dd87cebc6eeb3b34334421b15d90cb36c06cb2914d9d2f498b0c573604b7d99d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitChromaKey]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitChromaKey]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitChromaKey]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f642030b48180faf4948a3923feccfcb630ffe9dc8bbc40de6e6dbb12052e8ab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitComposite",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "placement": "placement",
        "placement_var": "placementVar",
        "scale": "scale",
        "scale_dimension": "scaleDimension",
        "scale_dimension_var": "scaleDimensionVar",
        "scale_var": "scaleVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitComposite:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitCompositeImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        placement: typing.Optional[builtins.str] = None,
        placement_var: typing.Optional[builtins.str] = None,
        scale: typing.Optional[builtins.str] = None,
        scale_dimension: typing.Optional[builtins.str] = None,
        scale_dimension_var: typing.Optional[builtins.str] = None,
        scale_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param placement: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        :param placement_var: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        :param scale: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param scale_dimension: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        :param scale_dimension_var: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        :param scale_var: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        :param x_position: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitCompositeImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__baae49c3320dfc833b958f06b01161fa146eed79d5d2067bfc519689d6abcafd)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument placement", value=placement, expected_type=type_hints["placement"])
            check_type(argname="argument placement_var", value=placement_var, expected_type=type_hints["placement_var"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument scale_dimension", value=scale_dimension, expected_type=type_hints["scale_dimension"])
            check_type(argname="argument scale_dimension_var", value=scale_dimension_var, expected_type=type_hints["scale_dimension_var"])
            check_type(argname="argument scale_var", value=scale_var, expected_type=type_hints["scale_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if placement is not None:
            self._values["placement"] = placement
        if placement_var is not None:
            self._values["placement_var"] = placement_var
        if scale is not None:
            self._values["scale"] = scale
        if scale_dimension is not None:
            self._values["scale_dimension"] = scale_dimension
        if scale_dimension_var is not None:
            self._values["scale_dimension_var"] = scale_dimension_var
        if scale_var is not None:
            self._values["scale_var"] = scale_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitCompositeImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitCompositeImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        '''
        result = self._values.get("placement")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement_var(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        '''
        result = self._values.get("placement_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        '''
        result = self._values.get("scale_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        '''
        result = self._values.get("scale_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        '''
        result = self._values.get("scale_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitComposite(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitCompositeImage",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitCompositeImage:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitCompositeImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitCompositeImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitCompositeImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4535aa483f08fc02954bea5269de3055bbbe7a442c82b62659e923e130899cda)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitCompositeImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitCompositeImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a2d45d9be23b79ebced5a5553b4df58b113e5368902137ce018ba68e780f520f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitCompositeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitCompositeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d925f441f98d3bb2edf50817eac88bb8cca2b4a43bbb52a8e3f56be6b8449d94)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitCompositeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__38f579ec3ca7cd26a1623b956f08514aea19640f68ded1d439906b5c26923cf9)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitCompositeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4fa658ba1099c80e51123b4ce4a2d6f09e14e218ff990cb60af6023af1e63138)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bf0601084a7292c6552201bc241cf9908f798227d44a18d90c9641405b563db0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af053ddd7c7056537146e8c87346f406534cc3eefdd52f22fc1d1f682a7e8bfc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitComposite]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitComposite]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__50ecb5c2108956b67337893b85ac65bcaac1ae1aeef1a60ee78aae502ed47266)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitCompositeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitCompositeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d510e6cfe31eb315c3eeb6ddf2d64522fc9f53cc4d14ab18ddf738cc8bcf275)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitCompositeImage()

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPlacement")
    def reset_placement(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacement", []))

    @jsii.member(jsii_name="resetPlacementVar")
    def reset_placement_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacementVar", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetScaleDimension")
    def reset_scale_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimension", []))

    @jsii.member(jsii_name="resetScaleDimensionVar")
    def reset_scale_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimensionVar", []))

    @jsii.member(jsii_name="resetScaleVar")
    def reset_scale_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitCompositeImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitCompositeImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitCompositeImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="placementInput")
    def placement_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementInput"))

    @builtins.property
    @jsii.member(jsii_name="placementVarInput")
    def placement_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionInput")
    def scale_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVarInput")
    def scale_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleVarInput")
    def scale_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1cab0744b7df9ed7cba8ed647672d61d3347f2b59622efef2e19dae58f1b5a5c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__172f40a926cdac90430e65b4ecaf21448ffc02ca343f21a6b2ba75b7a3c7a7ff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="placement")
    def placement(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placement"))

    @placement.setter
    def placement(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8d74ab847d25495ebe5798a531d7ffb2af3d415cd0a7ea7a34121b79f24732e7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placement", value)

    @builtins.property
    @jsii.member(jsii_name="placementVar")
    def placement_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placementVar"))

    @placement_var.setter
    def placement_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ff8bead652c29dde5110e1a5fe132357ce3694b78efd23136cdd4dbed6a39d93)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placementVar", value)

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scale"))

    @scale.setter
    def scale(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4aaf0fa9d3b503899b4a66813fea109749afec146d348504d6812747a87b0dd5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scale", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimension")
    def scale_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimension"))

    @scale_dimension.setter
    def scale_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3839e607b807660f57a58ff18ba28899514c470a6b4b98d2f2c89c66952657bf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimension", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVar")
    def scale_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimensionVar"))

    @scale_dimension_var.setter
    def scale_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ca69f656391f0b6a0395682f90bcc5dcb1d6c99916e202a38457f634e5538339)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="scaleVar")
    def scale_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleVar"))

    @scale_var.setter
    def scale_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d5b1c622c0431fcc7a190b823316bc5395ae1c88a981a73deb38e73ccc54021)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9664a914e3a813adb24f8d8a62cd20ef267c4cd9599cea9808ca5d312f6ea808)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__916d35ee149ef349568d29ac1d2296f8cc2ba2ff581a01629eb1cc4018f30be8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2b2ecebfdf42b93e436796aec3d6f7590132461dd2e68bcf497c1930341d2b5a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1531169be34a719ae8bfe6793a75c3d76cfa01f4556e5af6f2b506738a86d3f0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitComposite]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitComposite]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitComposite]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a63ac52b3f1cf3417b364cb90285343be72f2f1cd95d800ee2803449fe520c2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitCompound",
    jsii_struct_bases=[],
    name_mapping={"transformations": "transformations"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitCompound:
    def __init__(
        self,
        *,
        transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param transformations: transformations block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7ea9f2af98b7b05899934f30e0f5ec33efb9a2dd5e3424993eb490a003cdd028)
            check_type(argname="argument transformations", value=transformations, expected_type=type_hints["transformations"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if transformations is not None:
            self._values["transformations"] = transformations

    @builtins.property
    def transformations(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitCompoundTransformations"]]]:
        '''transformations block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        result = self._values.get("transformations")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitCompoundTransformations"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitCompound(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitCompoundList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitCompoundList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fe8c7e05773d44ac2501c210901fb45e162cccfbad6ea3550442c912fe3c8bf3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitCompoundOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__316c944451d42177c6feb6978b8ae6ac636db930237aab4e286b58704fa30b1f)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitCompoundOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__da6171e1c93e86e3d626a12d2923348b16f7c034ec4a4a87c4ae7201b3cfb843)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d5a1ef3d90ceedb85feb15da6079805bdb07041ae8c4714a66d302acad8d53c1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e2611e914cea7b567576bee012d6e79828eff7cc71c68d6df181a9107626dd60)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitCompound]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitCompound]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e0472df97b866ea06ec413c5d87cfbbc95c1004e20d964e3d571428067283846)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitCompoundOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitCompoundOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a26e12ac65827d9626864d5feb6f9b3016b357004fed89f95d7b7b641f8c3c82)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformations")
    def put_transformations(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0e8d4afe2bb53653ef4b9d41d78e4ced11930324608f10e1c9adbb44d098d9dd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTransformations", [value]))

    @jsii.member(jsii_name="resetTransformations")
    def reset_transformations(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformations", []))

    @builtins.property
    @jsii.member(jsii_name="transformations")
    def transformations(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitCompoundTransformationsList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitCompoundTransformationsList", jsii.get(self, "transformations"))

    @builtins.property
    @jsii.member(jsii_name="transformationsInput")
    def transformations_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitCompoundTransformations"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitCompoundTransformations"]]], jsii.get(self, "transformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitCompound]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitCompound]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitCompound]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c094b84fa32977723811112d0b18d7b23edccf3fd8f3a129997372b1e22b049e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitCompoundTransformations",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitCompoundTransformations:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitCompoundTransformations(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitCompoundTransformationsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitCompoundTransformationsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9b3dbb6fbf06f5983bb902e90d6d478fd44695ce2e48d14f98fb4bb5115150d3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitCompoundTransformationsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f655688589222abf28479ccb543fbe23e600a0282b5ce8da289b51897cd4ff30)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitCompoundTransformationsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__92e9952f70d0e978f22191b73940f50af01b2c04462172c6c255c6bef9128532)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__91fb70543457c26ce097731d54e5fa58d1ce2f3a183ccb5cf2abb37a668a9d9b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9e57db023e5f885a71fe4b870670045bb2ed30dcca80430705b23187db3873ea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitCompoundTransformations]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitCompoundTransformations]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitCompoundTransformations]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__076e258d88c8d7169670b5154add4841176d3e95c7b0c8a122be77587acf7afb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitCompoundTransformationsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitCompoundTransformationsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bdcd712bb513c974d0ba9a7ccbf6b698794d5834a2213d4c70a6fa52ec43c9b7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitCompoundTransformations]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitCompoundTransformations]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitCompoundTransformations]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1c3f8a5cfbad72cf27919f9356ffda4cffddd7cb030b529a647c1801bca42fe3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitContrast",
    jsii_struct_bases=[],
    name_mapping={
        "brightness": "brightness",
        "brightness_var": "brightnessVar",
        "contrast": "contrast",
        "contrast_var": "contrastVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitContrast:
    def __init__(
        self,
        *,
        brightness: typing.Optional[builtins.str] = None,
        brightness_var: typing.Optional[builtins.str] = None,
        contrast: typing.Optional[builtins.str] = None,
        contrast_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param brightness: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        :param brightness_var: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        :param contrast: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param contrast_var: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fe315307f25b5b62714994c64501e5a5daf7312a41ff1c635fb70b7f78f1e428)
            check_type(argname="argument brightness", value=brightness, expected_type=type_hints["brightness"])
            check_type(argname="argument brightness_var", value=brightness_var, expected_type=type_hints["brightness_var"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument contrast_var", value=contrast_var, expected_type=type_hints["contrast_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if brightness is not None:
            self._values["brightness"] = brightness
        if brightness_var is not None:
            self._values["brightness_var"] = brightness_var
        if contrast is not None:
            self._values["contrast"] = contrast
        if contrast_var is not None:
            self._values["contrast_var"] = contrast_var

    @builtins.property
    def brightness(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        '''
        result = self._values.get("brightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def brightness_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        '''
        result = self._values.get("brightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        result = self._values.get("contrast_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitContrast(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitContrastList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitContrastList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__41c2036ef657f29bfa27d1ae728127113e9c95373f8e1b70cdbe2b5e46e55d1f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitContrastOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d8150506f1a943d2038f7e5d031df39fe63b51322da8f50f9d19eb701c0f33c7)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitContrastOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__541a79b268ba4feb2bdb8adb6f4ea8f400fe5ba4a1ccc332b9659c7cdd1d88cf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b54448dbeb76402f3e4d9927d06fc82cc8daac5adc9ab43cb8fc88272be20982)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a31fafce11b38e27dc945f2a025dc98dd622fdbde12785d444dbe95e658ba009)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitContrast]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitContrast]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e42a8f625fde4ce5237747efe8923d4fbb4c578d74547c1206edd86d36dd0c3a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitContrastOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitContrastOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dd8c4d68bb3848ad159c99299bfe8cffcc0c96d3c624efcd6f3e7a6012603fe2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetBrightness")
    def reset_brightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightness", []))

    @jsii.member(jsii_name="resetBrightnessVar")
    def reset_brightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightnessVar", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetContrastVar")
    def reset_contrast_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrastVar", []))

    @builtins.property
    @jsii.member(jsii_name="brightnessInput")
    def brightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="brightnessVarInput")
    def brightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastVarInput")
    def contrast_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="brightness")
    def brightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightness"))

    @brightness.setter
    def brightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1e4667309f7b64063abd5dec809125edfe02fa52c63128c3269d77e31974e578)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightness", value)

    @builtins.property
    @jsii.member(jsii_name="brightnessVar")
    def brightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightnessVar"))

    @brightness_var.setter
    def brightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6aa300549f538f6c048278ab724e16315fa25779f4bc1993b27c2f1f6168da3b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrast"))

    @contrast.setter
    def contrast(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__62bf018b181638778bfee495cfc6111ee9d38c9c74dfd6abab2c8a9aa68ac4aa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrast", value)

    @builtins.property
    @jsii.member(jsii_name="contrastVar")
    def contrast_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrastVar"))

    @contrast_var.setter
    def contrast_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7631e701302aaa41271196b87b39faf08af5bf1b9f380f87df98fc4f76c1ece3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrastVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitContrast]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitContrast]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitContrast]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a2eaa46b6bd902568378c88d82efde2e712bc0ddb1b0131f5b3d10702c4d7e54)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitGoop",
    jsii_struct_bases=[],
    name_mapping={
        "chaos": "chaos",
        "chaos_var": "chaosVar",
        "density": "density",
        "density_var": "densityVar",
        "power": "power",
        "power_var": "powerVar",
        "seed": "seed",
        "seed_var": "seedVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitGoop:
    def __init__(
        self,
        *,
        chaos: typing.Optional[builtins.str] = None,
        chaos_var: typing.Optional[builtins.str] = None,
        density: typing.Optional[builtins.str] = None,
        density_var: typing.Optional[builtins.str] = None,
        power: typing.Optional[builtins.str] = None,
        power_var: typing.Optional[builtins.str] = None,
        seed: typing.Optional[builtins.str] = None,
        seed_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param chaos: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        :param chaos_var: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        :param density: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        :param density_var: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        :param power: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        :param power_var: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        :param seed: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        :param seed_var: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__914ba5c990f456d5f9a188430bfaae866ab814b64da781c1c612fc6d1bcfa464)
            check_type(argname="argument chaos", value=chaos, expected_type=type_hints["chaos"])
            check_type(argname="argument chaos_var", value=chaos_var, expected_type=type_hints["chaos_var"])
            check_type(argname="argument density", value=density, expected_type=type_hints["density"])
            check_type(argname="argument density_var", value=density_var, expected_type=type_hints["density_var"])
            check_type(argname="argument power", value=power, expected_type=type_hints["power"])
            check_type(argname="argument power_var", value=power_var, expected_type=type_hints["power_var"])
            check_type(argname="argument seed", value=seed, expected_type=type_hints["seed"])
            check_type(argname="argument seed_var", value=seed_var, expected_type=type_hints["seed_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if chaos is not None:
            self._values["chaos"] = chaos
        if chaos_var is not None:
            self._values["chaos_var"] = chaos_var
        if density is not None:
            self._values["density"] = density
        if density_var is not None:
            self._values["density_var"] = density_var
        if power is not None:
            self._values["power"] = power
        if power_var is not None:
            self._values["power_var"] = power_var
        if seed is not None:
            self._values["seed"] = seed
        if seed_var is not None:
            self._values["seed_var"] = seed_var

    @builtins.property
    def chaos(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        '''
        result = self._values.get("chaos")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def chaos_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        '''
        result = self._values.get("chaos_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        '''
        result = self._values.get("density")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density_var(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        '''
        result = self._values.get("density_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        '''
        result = self._values.get("power")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power_var(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        '''
        result = self._values.get("power_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        '''
        result = self._values.get("seed")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed_var(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        result = self._values.get("seed_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitGoop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitGoopList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitGoopList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ed4f6d182b0766b737dfe3c058ac952169c4bb0d882e6755f2618632b513bf64)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitGoopOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9e5398f2dfe963b283bcd3147c3b5c539779136abc0bfed50972ecc8ef143fc4)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitGoopOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4e7027e78bc38245a1107ab5a83cb8788f83af1842eed69b850def828da29919)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d9027042e613e6cb98a028a1e889052a86c9f69ba07b5daaca1a3f538e90afaf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__88f2fa31788b5a96380ecf113ec71c1f7243e0b2a0f411f699b20c5bba014060)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitGoop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitGoop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3513808f3568ba850b3fc499fd638794dceba9fbceb4c644988b70c03c9fab79)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitGoopOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitGoopOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4979b9a08fd918215c73b17d9a7e0ccba9e3a6afabcffb834033eb6a52997c8c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetChaos")
    def reset_chaos(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaos", []))

    @jsii.member(jsii_name="resetChaosVar")
    def reset_chaos_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaosVar", []))

    @jsii.member(jsii_name="resetDensity")
    def reset_density(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensity", []))

    @jsii.member(jsii_name="resetDensityVar")
    def reset_density_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensityVar", []))

    @jsii.member(jsii_name="resetPower")
    def reset_power(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPower", []))

    @jsii.member(jsii_name="resetPowerVar")
    def reset_power_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPowerVar", []))

    @jsii.member(jsii_name="resetSeed")
    def reset_seed(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeed", []))

    @jsii.member(jsii_name="resetSeedVar")
    def reset_seed_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeedVar", []))

    @builtins.property
    @jsii.member(jsii_name="chaosInput")
    def chaos_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosInput"))

    @builtins.property
    @jsii.member(jsii_name="chaosVarInput")
    def chaos_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosVarInput"))

    @builtins.property
    @jsii.member(jsii_name="densityInput")
    def density_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityInput"))

    @builtins.property
    @jsii.member(jsii_name="densityVarInput")
    def density_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="powerInput")
    def power_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerInput"))

    @builtins.property
    @jsii.member(jsii_name="powerVarInput")
    def power_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerVarInput"))

    @builtins.property
    @jsii.member(jsii_name="seedInput")
    def seed_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedInput"))

    @builtins.property
    @jsii.member(jsii_name="seedVarInput")
    def seed_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedVarInput"))

    @builtins.property
    @jsii.member(jsii_name="chaos")
    def chaos(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaos"))

    @chaos.setter
    def chaos(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__995a7cdcd27c1523bf812b113861bf829227939a6029548a4fbc47498edab99a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaos", value)

    @builtins.property
    @jsii.member(jsii_name="chaosVar")
    def chaos_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaosVar"))

    @chaos_var.setter
    def chaos_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dbf4a7927057e3985e0ca45c825c252e4bba25d6d0a4255fadbafc4a1320fa24)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaosVar", value)

    @builtins.property
    @jsii.member(jsii_name="density")
    def density(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "density"))

    @density.setter
    def density(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__216b46fedf2782487743316487b152c9da80cc33f3b0e7a68de6e65575dfca9a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "density", value)

    @builtins.property
    @jsii.member(jsii_name="densityVar")
    def density_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "densityVar"))

    @density_var.setter
    def density_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c01ac625157f850e92fceb087ae8e1f5cdea0f769a960cfd525121ed7ef0afa3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "densityVar", value)

    @builtins.property
    @jsii.member(jsii_name="power")
    def power(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "power"))

    @power.setter
    def power(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9e485bf652c1aaf368a09e87f4a7d6084b0326f8fca97907281ac007fda648c5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "power", value)

    @builtins.property
    @jsii.member(jsii_name="powerVar")
    def power_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "powerVar"))

    @power_var.setter
    def power_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fd8456f8f14026941fdfb9c26fba3d99d81034ae0bea59ed2ba34f8f2a17daa2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "powerVar", value)

    @builtins.property
    @jsii.member(jsii_name="seed")
    def seed(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seed"))

    @seed.setter
    def seed(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__021a04ae8927475a869e5b9af82db60be620bcb20d5217517b6bb85d045d6447)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seed", value)

    @builtins.property
    @jsii.member(jsii_name="seedVar")
    def seed_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seedVar"))

    @seed_var.setter
    def seed_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__28058984f5abf9b0047d58537c33defbc3b11c1780cc2c23fa758e79de215f1c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seedVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitGoop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitGoop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitGoop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b4030777381d1735998cf1cca93e71b63db2281ea77feb83cbd46eeb5551dca7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitGrayscale",
    jsii_struct_bases=[],
    name_mapping={"type": "type", "type_var": "typeVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitGrayscale:
    def __init__(
        self,
        *,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param type: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__57f22576dcce92604154bbfcfb2e8bc528a1772f470a7c17ec5afce2b54b6d51)
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitGrayscale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitGrayscaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitGrayscaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__059cc072ad217baff365536ee6a50c3345466b89bef9a3746f1c0ca9bd1c5080)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitGrayscaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__476953079f98e9cae84f753b40f1ba20f9c7e855c719b86439abfbea129c4223)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitGrayscaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d5d1896618fceedd2dc531d781bc7c557c34b3a1e8a4ec887f491bc127b1d08a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a24c11e50b33391e2db643044f9725f9730ae9bbb3877b7e546cbadd22c12b1c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__35df3ec70b0c1668bd097bad12a464b102e101c6e66ced3cc3bdeaf8a94940a4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitGrayscale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitGrayscale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0244c092e3db48c61a03f5eb195464be2431cd5013d02cdc7f97bf99dde87e97)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitGrayscaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitGrayscaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1d8add85b393417f739aa5c952f1d4a192d929703f3310010406f5335c5b0313)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c0758817c15b6a9970279ee44e51fbda8cfbbb07612e06c34239c39966965e84)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__53ed35f34420d2ec128787100f7697e9a91ae92de576708e745666e97c9d8c08)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitGrayscale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitGrayscale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitGrayscale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cff7e7a2039d25de4eb398a0384e9c413b3c37ce534adbf5c433aba5df2ea8f9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitHsl",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "lightness": "lightness",
        "lightness_var": "lightnessVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitHsl:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness: typing.Optional[builtins.str] = None,
        lightness_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        :param lightness_var: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__147d0b454bda6804de033685e7258ce3f715bba45bb6ee755c68ff7b0c3687c7)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness", value=lightness, expected_type=type_hints["lightness"])
            check_type(argname="argument lightness_var", value=lightness_var, expected_type=type_hints["lightness_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness is not None:
            self._values["lightness"] = lightness
        if lightness_var is not None:
            self._values["lightness_var"] = lightness_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        '''
        result = self._values.get("lightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        '''
        result = self._values.get("lightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitHsl(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitHslList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitHslList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__08852092f6c78c616f01221b53b58bc13b4ff92543d5c1c661f24389a6bcebb2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitHslOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ca5909d9f1ed2b3dcc883749d45be73dfd0ae761f1ae7b68ed06a679a3c172a1)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitHslOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__14f58d06dbb4a98c4aefc3f6a5dcff3db83e5e3a00900341219c1cbb3708b066)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__842ba712d8f18e18bb70bf46f26f86a0c30ef94be9906869a11804bb57df9614)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e210185d1dc454287231465425a118ab7c4f2820e80556e5f00c83d2978068d2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitHsl]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitHsl]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3114f2f536d18acf2a13b8dd60cac621d746a127061084fe361c69d319ed796a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitHslOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitHslOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__37ed707843e1b674e93e5a505dfe2a333b629e536690de992505ea9684975907)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightness")
    def reset_lightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightness", []))

    @jsii.member(jsii_name="resetLightnessVar")
    def reset_lightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessInput")
    def lightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessVarInput")
    def lightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d463f0f46f9c1df1fd97524aa7f575626c11d798754251a06d158f80ff21b8d9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0564bcee5997590823a69eefd43de93f9beeac90cd0df5c24260c5e38f1911e4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightness")
    def lightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightness"))

    @lightness.setter
    def lightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8e607403bb7d2142f2341af35eb9e43e48901adfa82b7fdf59e3c6cbf5a76b7b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightness", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessVar")
    def lightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessVar"))

    @lightness_var.setter
    def lightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f7c3cb901e79f01601fb1c755b4bad51e5b1aa3d3d1595210f1e48122794e837)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__65eaf05646df5aede9a08cd91de577b4e7d1e806a24862e460b147ea9283aad4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dbc608e7622fcedb1a4adf4f97c56b016119f71c27a54c8fd04a138148e02b81)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitHsl]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitHsl]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitHsl]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__884b622f9c7c3c71056e304388358a631f78f90d2a119b9a48bb1aa76f5bac14)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitHsv",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitHsv:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        :param value: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ebb4d236938361dc161d987b01d73c975aa962542da5571fa40e0c8d8dbe8d93)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitHsv(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitHsvList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitHsvList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d8dfd0d6ba8cd7dc537fc281d94f7c684372a234fde1b4219b5269dada6c9f3d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitHsvOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3b48bceea1af563e494ab8386c4e0e2ce88ea6a73d0d05869db1a786653ba6e3)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitHsvOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__03c97daec16fd5fb263e11c418be14336461de42ce6b3312f85ea1849bfd82ea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7730e24ae717b451466b859674289f8121d49806b2080d221a1abc84cb883aac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__edb585fb713408cc67be10c75e126cb481beb4e0caaa4310456d73995413990f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitHsv]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitHsv]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b17f0e0448c9b122324d29dbdfafdbc36709fcce2ecccc792c6d2af41c121cc8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitHsvOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitHsvOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb28424a2ca9fa984f48217097f8f570cb4e73572ed6254414e9675a7134d278)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5b05f7e7d9284ed8f8dcc9077f07ed3add6952aa2176dfb2d80963e1fa9ed84e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7eaa454f59ce26646f49a0ac450f22806ef3e05768cd95947a5df1b756cae7d3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__098cecd033aa28c42711cbb405b0d0cb6d5472016c3e019daca1701c5a39be64)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__779e83db07d5c5e68ca8e18f4af0cc319e54a6a02b10828b8cde0ae886c52022)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6218ea7dd628fe49dfc3f1bfdcd182f2e1b4e77c97e4f0808651d5c6d528da1c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0e99d09d3ecc1af2eb3e564143951b962e8bd9a2b290f64dd100cc955799afbd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitHsv]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitHsv]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitHsv]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af369136d5327c3c12e04e86a68b37e7be827e714e1dd1a70aa9efd28f844749)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimension",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "dimension": "dimension",
        "dimension_var": "dimensionVar",
        "equal": "equal",
        "greater_than": "greaterThan",
        "less_than": "lessThan",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimension:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        dimension: typing.Optional[builtins.str] = None,
        dimension_var: typing.Optional[builtins.str] = None,
        equal: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionEqual", typing.Dict[builtins.str, typing.Any]]] = None,
        greater_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionGreaterThan", typing.Dict[builtins.str, typing.Any]]] = None,
        less_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionLessThan", typing.Dict[builtins.str, typing.Any]]] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param dimension: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        :param dimension_var: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        :param equal: equal block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        :param greater_than: greater_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        :param less_than: less_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        :param value: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionDefault(**default)
        if isinstance(equal, dict):
            equal = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionEqual(**equal)
        if isinstance(greater_than, dict):
            greater_than = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionGreaterThan(**greater_than)
        if isinstance(less_than, dict):
            less_than = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionLessThan(**less_than)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d5ae19a2cdc33eed4eb58ca1231533644a1877f0878884655d17f1e9bd380cbb)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument dimension", value=dimension, expected_type=type_hints["dimension"])
            check_type(argname="argument dimension_var", value=dimension_var, expected_type=type_hints["dimension_var"])
            check_type(argname="argument equal", value=equal, expected_type=type_hints["equal"])
            check_type(argname="argument greater_than", value=greater_than, expected_type=type_hints["greater_than"])
            check_type(argname="argument less_than", value=less_than, expected_type=type_hints["less_than"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if dimension is not None:
            self._values["dimension"] = dimension
        if dimension_var is not None:
            self._values["dimension_var"] = dimension_var
        if equal is not None:
            self._values["equal"] = equal
        if greater_than is not None:
            self._values["greater_than"] = greater_than
        if less_than is not None:
            self._values["less_than"] = less_than
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionDefault"], result)

    @builtins.property
    def dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        '''
        result = self._values.get("dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        '''
        result = self._values.get("dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def equal(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionEqual"]:
        '''equal block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        '''
        result = self._values.get("equal")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionEqual"], result)

    @builtins.property
    def greater_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionGreaterThan"]:
        '''greater_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        '''
        result = self._values.get("greater_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionGreaterThan"], result)

    @builtins.property
    def less_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionLessThan"]:
        '''less_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        '''
        result = self._values.get("less_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionLessThan"], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimension(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6b4177daf79d8db3cf292aef84cbcb37b3f64ffe0a6ec72ffd871154957783c6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__162e54a77d58a0318b8b8efe9c2a84385c8efd31df1142502c459da3c6387822)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionEqual",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionEqual:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionEqual(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionEqualOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionEqualOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__37acbe20ab8c77b6d5fe3bd8b2e7038b245c48ad6afbc5d6dafac98f3075d75d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionEqual], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionEqual],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__66b1d32c43d9291e9805cff1d7510967537f8a45ac4c52cf7ec66a84b6eabe83)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionGreaterThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionGreaterThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionGreaterThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionGreaterThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionGreaterThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3010ccec2bddc3aa900dd8f4035241052bf4966f3196fbf764d29812a612c3e4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionGreaterThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionGreaterThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__56dd19fa6e4eeaa392bb4da594bfaf02e04f16d2caeb0a509a275797458889e4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionLessThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionLessThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionLessThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionLessThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionLessThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f5fada983a36087d540c64cecff1e974ba23a2dd1d293f16cf707f24d5619c7c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionLessThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionLessThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__690022e7868ea40ac9875640bfa49c8be1bba5f1610c023f26aa81cf75794cfc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__73f9360fcf196eb817f4a9d946f0c36b8fdd6e81fc0d3115fd8c43d899adf968)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__46ed390f4105ff90c2ab57667f8be55676022d1bc9ecc09f71131afacf2d7567)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__edbd4a5db618e0f933eb8c8fb2534bac3b3869c89794e135ffd3c91d6be9e06b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__678d90dea4a501a457a370487762466b8ea7d840492759b5049bd34003956f49)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3baf832feb3b88ee7bc9611859b5b40a6e5ad1d685537d2b88c84e9e078714fa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimension]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimension]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9dbfce985d4e15f6988f47e01dfa0032c122dde2d1358b51e203b642fb37cbbe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8fedf0edc9920a3975356bd53d9a82ad67be4c8fb98c205b66c7960fd2cf61ff)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putEqual")
    def put_equal(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionEqual()

        return typing.cast(None, jsii.invoke(self, "putEqual", [value]))

    @jsii.member(jsii_name="putGreaterThan")
    def put_greater_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionGreaterThan()

        return typing.cast(None, jsii.invoke(self, "putGreaterThan", [value]))

    @jsii.member(jsii_name="putLessThan")
    def put_less_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionLessThan()

        return typing.cast(None, jsii.invoke(self, "putLessThan", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetDimension")
    def reset_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimension", []))

    @jsii.member(jsii_name="resetDimensionVar")
    def reset_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimensionVar", []))

    @jsii.member(jsii_name="resetEqual")
    def reset_equal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEqual", []))

    @jsii.member(jsii_name="resetGreaterThan")
    def reset_greater_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGreaterThan", []))

    @jsii.member(jsii_name="resetLessThan")
    def reset_less_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLessThan", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="equal")
    def equal(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionEqualOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionEqualOutputReference, jsii.get(self, "equal"))

    @builtins.property
    @jsii.member(jsii_name="greaterThan")
    def greater_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionGreaterThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionGreaterThanOutputReference, jsii.get(self, "greaterThan"))

    @builtins.property
    @jsii.member(jsii_name="lessThan")
    def less_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionLessThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionLessThanOutputReference, jsii.get(self, "lessThan"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionInput")
    def dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionVarInput")
    def dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="equalInput")
    def equal_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionEqual], jsii.get(self, "equalInput"))

    @builtins.property
    @jsii.member(jsii_name="greaterThanInput")
    def greater_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionGreaterThan], jsii.get(self, "greaterThanInput"))

    @builtins.property
    @jsii.member(jsii_name="lessThanInput")
    def less_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionLessThan], jsii.get(self, "lessThanInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="dimension")
    def dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimension"))

    @dimension.setter
    def dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9c022a084272c98cd526c9fc0014ac6628a6d64fe99776dc2a3873f24001227c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimension", value)

    @builtins.property
    @jsii.member(jsii_name="dimensionVar")
    def dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimensionVar"))

    @dimension_var.setter
    def dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__529be2d6f210c5876659439e375bd8f5203b5888a7360c0b83e4ff9ed2858ae7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c63630a5e64642f9940d587a73c20d9268712b27cd57f747a67bc444ed67115f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6adf0f03568286368aa70246ee7e69c8144132d97dc4d0946099bd2d6e4608a4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimension]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimension]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimension]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__61d54acd941db4a99668619892ed9e3894c0c31d9b4c72e5d044cc9ab0520b2d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientation",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "landscape": "landscape",
        "portrait": "portrait",
        "square": "square",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientation:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        landscape: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationLandscape", typing.Dict[builtins.str, typing.Any]]] = None,
        portrait: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationPortrait", typing.Dict[builtins.str, typing.Any]]] = None,
        square: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationSquare", typing.Dict[builtins.str, typing.Any]]] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param landscape: landscape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        :param portrait: portrait block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        :param square: square block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationDefault(**default)
        if isinstance(landscape, dict):
            landscape = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationLandscape(**landscape)
        if isinstance(portrait, dict):
            portrait = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationPortrait(**portrait)
        if isinstance(square, dict):
            square = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationSquare(**square)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e64a4f09610a40446c4edee302433d4b5a734eadf0942d0f3ee2a0017332bf85)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument landscape", value=landscape, expected_type=type_hints["landscape"])
            check_type(argname="argument portrait", value=portrait, expected_type=type_hints["portrait"])
            check_type(argname="argument square", value=square, expected_type=type_hints["square"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if landscape is not None:
            self._values["landscape"] = landscape
        if portrait is not None:
            self._values["portrait"] = portrait
        if square is not None:
            self._values["square"] = square

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationDefault"], result)

    @builtins.property
    def landscape(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationLandscape"]:
        '''landscape block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        '''
        result = self._values.get("landscape")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationLandscape"], result)

    @builtins.property
    def portrait(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationPortrait"]:
        '''portrait block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        '''
        result = self._values.get("portrait")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationPortrait"], result)

    @builtins.property
    def square(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationSquare"]:
        '''square block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        result = self._values.get("square")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationSquare"], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b5ba81b65550ceb811ecda27b4389966394a7fb613d67c1f7d02825a0c34ee4a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d81a8f91132f16d99c0cf75cb9c2dfaca11779892137b606ddb793e6f0e69e5e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationLandscape",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationLandscape:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationLandscape(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationLandscapeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationLandscapeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e2060797f5818ee0aa0d63c195b6910f5e578255e2afdf4f1cfbe2dc889261a9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationLandscape], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationLandscape],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__31e2d90d3891f7d06c78581cd3eddfb049fb56169f6b49332d2d3c93ecf4c470)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__368afbc815bde1176678630805917c8a1006930fda2e4660843d5fb8d4129c24)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__77c4d4894a48f3b553e644c92a3064d9b0fe6003a185f7f02fc881cdd910bfe8)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c34b1fdb9ffa32f752f36f96e8fa9b85236a7473dc1dd709b20216590e1c551d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__487cddf98296cb855e41b3f05f6c85c8af7f3f347f8e7413cc4367f50f355da9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b95c47b0c05c4344e15c5a1082fda020aab389e1937f9554cd4243d56a896d1b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientation]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientation]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__53afecf1d6929a05cef79f0aee432e520d3456da52a8ba13b871415b216d046b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__438f10e8d5d93da97d2b1f5f30c21523e508909b75268a9109b6229b36eb6b1f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putLandscape")
    def put_landscape(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationLandscape()

        return typing.cast(None, jsii.invoke(self, "putLandscape", [value]))

    @jsii.member(jsii_name="putPortrait")
    def put_portrait(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationPortrait()

        return typing.cast(None, jsii.invoke(self, "putPortrait", [value]))

    @jsii.member(jsii_name="putSquare")
    def put_square(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationSquare()

        return typing.cast(None, jsii.invoke(self, "putSquare", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetLandscape")
    def reset_landscape(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLandscape", []))

    @jsii.member(jsii_name="resetPortrait")
    def reset_portrait(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPortrait", []))

    @jsii.member(jsii_name="resetSquare")
    def reset_square(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSquare", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="landscape")
    def landscape(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationLandscapeOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationLandscapeOutputReference, jsii.get(self, "landscape"))

    @builtins.property
    @jsii.member(jsii_name="portrait")
    def portrait(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationPortraitOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationPortraitOutputReference", jsii.get(self, "portrait"))

    @builtins.property
    @jsii.member(jsii_name="square")
    def square(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationSquareOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationSquareOutputReference", jsii.get(self, "square"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="landscapeInput")
    def landscape_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationLandscape], jsii.get(self, "landscapeInput"))

    @builtins.property
    @jsii.member(jsii_name="portraitInput")
    def portrait_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationPortrait"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationPortrait"], jsii.get(self, "portraitInput"))

    @builtins.property
    @jsii.member(jsii_name="squareInput")
    def square_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationSquare"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationSquare"], jsii.get(self, "squareInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientation]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientation]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientation]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b025c8fd091406cb2a73d28a9654f599ffb59882353173fa145d32f88b1d4fe4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationPortrait",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationPortrait:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationPortrait(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationPortraitOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationPortraitOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__68ff9637b55346d9bef82e65b2b3b840771daf61a85d7fd79bdcc10d522f89a0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationPortrait]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationPortrait], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationPortrait],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__da211956d50b852794be3d3c03b1027b88bdf13c1672e42a3749d1f3063f8105)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationSquare",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationSquare:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationSquare(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationSquareOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationSquareOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__518175753908f31843ebc41618d1901da6cf7a3e50eb5870f93f711f6be3d566)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationSquare]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationSquare], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationSquare],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b078d1e2b5a0689afab70930efd78a6995edb76974826a207536df681a19e38a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitMaxColors",
    jsii_struct_bases=[],
    name_mapping={"colors": "colors", "colors_var": "colorsVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitMaxColors:
    def __init__(
        self,
        *,
        colors: typing.Optional[builtins.str] = None,
        colors_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param colors: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        :param colors_var: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__79c9053142e278030eec6402a51c4e4a576570974fa32c7718c873f04f8fe310)
            check_type(argname="argument colors", value=colors, expected_type=type_hints["colors"])
            check_type(argname="argument colors_var", value=colors_var, expected_type=type_hints["colors_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if colors is not None:
            self._values["colors"] = colors
        if colors_var is not None:
            self._values["colors_var"] = colors_var

    @builtins.property
    def colors(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        '''
        result = self._values.get("colors")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def colors_var(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        result = self._values.get("colors_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitMaxColors(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitMaxColorsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitMaxColorsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__936c8b9a7e70cc7122e167b2c10c2294f45e7988dcb885fc862486a2129a38ce)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitMaxColorsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b375a4c7e691a6e0b6288b7f46e9a1d8cf84b0ccbda826106af8c31f83770fbb)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitMaxColorsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__932df9cf3e6dacc2a70d3589fe6b2823c1bb8701c9bcb94055eafa089f46e896)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__077da1488f3528397687767ffb192e4d15907da81f60d0b3affc561040686617)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fb5b61a0090fbb7e06b2dfd3e5ed9924f9a5b2967b670d1f84cfe575f29caf0f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitMaxColors]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitMaxColors]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3290a6ac147ec982e80f6b0321e0c89832f372ef264e673b8d5a1e7356ed2ef9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitMaxColorsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitMaxColorsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5031874097c3d7475f8d4a27c085d26516bbe54c7ef08df9578b01be1d1e2f76)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColors")
    def reset_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColors", []))

    @jsii.member(jsii_name="resetColorsVar")
    def reset_colors_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorsVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorsInput")
    def colors_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsInput"))

    @builtins.property
    @jsii.member(jsii_name="colorsVarInput")
    def colors_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsVarInput"))

    @builtins.property
    @jsii.member(jsii_name="colors")
    def colors(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colors"))

    @colors.setter
    def colors(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9dfa93f9e0c21e3100a152b512849603dce03314c66a25ee7e70c8e12aa1158e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colors", value)

    @builtins.property
    @jsii.member(jsii_name="colorsVar")
    def colors_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorsVar"))

    @colors_var.setter
    def colors_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a4b59add09a9589748bf149f6fd542002117aeedf2e71521e38e5c726ee63b40)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorsVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitMaxColors]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitMaxColors]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitMaxColors]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e0f32fe916c70991e43cf610759a214c6e5de6f639d7807110829d4cb34cf72c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitMirror",
    jsii_struct_bases=[],
    name_mapping={
        "horizontal": "horizontal",
        "horizontal_var": "horizontalVar",
        "vertical": "vertical",
        "vertical_var": "verticalVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitMirror:
    def __init__(
        self,
        *,
        horizontal: typing.Optional[builtins.str] = None,
        horizontal_var: typing.Optional[builtins.str] = None,
        vertical: typing.Optional[builtins.str] = None,
        vertical_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param horizontal: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        :param horizontal_var: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        :param vertical: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        :param vertical_var: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__30cb37476b929bef65376c86cff69f65c6b9e253a07a108144d8f35fb116b226)
            check_type(argname="argument horizontal", value=horizontal, expected_type=type_hints["horizontal"])
            check_type(argname="argument horizontal_var", value=horizontal_var, expected_type=type_hints["horizontal_var"])
            check_type(argname="argument vertical", value=vertical, expected_type=type_hints["vertical"])
            check_type(argname="argument vertical_var", value=vertical_var, expected_type=type_hints["vertical_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if horizontal is not None:
            self._values["horizontal"] = horizontal
        if horizontal_var is not None:
            self._values["horizontal_var"] = horizontal_var
        if vertical is not None:
            self._values["vertical"] = vertical
        if vertical_var is not None:
            self._values["vertical_var"] = vertical_var

    @builtins.property
    def horizontal(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        '''
        result = self._values.get("horizontal")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def horizontal_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        '''
        result = self._values.get("horizontal_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        '''
        result = self._values.get("vertical")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        result = self._values.get("vertical_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitMirror(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitMirrorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitMirrorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b3b8c5aed2cbe7d4dd2aa86a879d1c870ace45293b6492b42d0c01769a4e2054)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitMirrorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__67b6b5ac36e78de3a25660adc3569bea82e222e4147322cd7ead5db2bc97498c)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitMirrorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e74b4a7e6993201c4c8754e6fa5923701975cb767279f148e16ab0a40d76e944)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__15c97681d524282e863299c667c06a4527a968e330855074473fc763195dfc72)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3b54359c572a5f46e0522563baab23516e5fb3640a40f8cdc74a2ff9cf1ef965)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitMirror]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitMirror]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ce356ce811127b7165ce10bfd5f3ff5ce88e9b274ba1b508bd1d9c443af9f129)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitMirrorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitMirrorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eecb82953104ad50496b0869461b3b6b1c01bc30d60ee7c921df5344c0d48ac5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHorizontal")
    def reset_horizontal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontal", []))

    @jsii.member(jsii_name="resetHorizontalVar")
    def reset_horizontal_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontalVar", []))

    @jsii.member(jsii_name="resetVertical")
    def reset_vertical(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVertical", []))

    @jsii.member(jsii_name="resetVerticalVar")
    def reset_vertical_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVerticalVar", []))

    @builtins.property
    @jsii.member(jsii_name="horizontalInput")
    def horizontal_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontalVarInput")
    def horizontal_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalInput")
    def vertical_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalVarInput")
    def vertical_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontal")
    def horizontal(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontal"))

    @horizontal.setter
    def horizontal(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ede4ff0a8f072ee95fea49c2f921c380370ceb89a884f08d46234f5f17075b8e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontal", value)

    @builtins.property
    @jsii.member(jsii_name="horizontalVar")
    def horizontal_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontalVar"))

    @horizontal_var.setter
    def horizontal_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__33b4747fdd741145e79bcf9b9a4e317e72c022056c069123c898f868c76a681a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontalVar", value)

    @builtins.property
    @jsii.member(jsii_name="vertical")
    def vertical(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "vertical"))

    @vertical.setter
    def vertical(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dc5db4dd2f4d6422718a7516a0d1e8a14abcdd7f87b37e2fc56da2a809c746e0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "vertical", value)

    @builtins.property
    @jsii.member(jsii_name="verticalVar")
    def vertical_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "verticalVar"))

    @vertical_var.setter
    def vertical_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f55e6b5c23b6ea88554a4ab33852dccb1f04f8e4db3d399f3305c5b68b0f8bc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "verticalVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitMirror]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitMirror]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitMirror]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a4c63924e04e4138f938ae89111e201e439f0a6af0f023fc014d3e4384aef665)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitMonoHue",
    jsii_struct_bases=[],
    name_mapping={"hue": "hue", "hue_var": "hueVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitMonoHue:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fdbde2d664cd8ab291a749037ab2103ed50880a043f625b37532a5b6e39133c5)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitMonoHue(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitMonoHueList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitMonoHueList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f3da579b1aeb7a9c661131f2127f453cc492c2a88dd599a098c076713c7b7763)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitMonoHueOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6ca149f6b2ad1ccb5d44034b489f5dc02f26935e18945c63fc09bf90cb3705b3)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitMonoHueOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__21a3940e35d5fd756ffb49fb06a47268d6fb79b1da148997326c9f9c950159e9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8de1681e34569f20a5629924d84520de4a663fccf5297f82f038e2b538825e98)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9bc012a98ba2a271e3e75349aca99417435c673eb95d0e72a22075cbd520b958)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitMonoHue]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitMonoHue]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b192d43deb08f55cec8968a58ce2ef4a0f3f4afdbd243317d51af738e28eb6e9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitMonoHueOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitMonoHueOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a0c42d992cdfd6385c516e6b5f8b6c0d322d546abb5c8e10e093f38d3e8f5c8b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__860b34c1ec7b622839ddb4290d355bd0d545bd271a6866a929ee81ba8de8e64b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f3d662c308ff934fc5c7ae3ab7bca6eb303af845e391ce7d7f65a647e05d482)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitMonoHue]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitMonoHue]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitMonoHue]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__31f6db3c51386ceebfa987755a711ab1f1bbbc80e1c96199cb89503412805fe3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitOpacity",
    jsii_struct_bases=[],
    name_mapping={"opacity": "opacity", "opacity_var": "opacityVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitOpacity:
    def __init__(
        self,
        *,
        opacity: typing.Optional[builtins.str] = None,
        opacity_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param opacity: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param opacity_var: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b666ede5d8b62d1a91f7143986757ee248eee8c4d98c5601139e9b21bf2183b7)
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument opacity_var", value=opacity_var, expected_type=type_hints["opacity_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if opacity is not None:
            self._values["opacity"] = opacity
        if opacity_var is not None:
            self._values["opacity_var"] = opacity_var

    @builtins.property
    def opacity(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def opacity_var(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        result = self._values.get("opacity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitOpacity(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitOpacityList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitOpacityList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d88e01056a8a0dded3c39482caea4a291d282c3324d26e4fa36c542a5b6958d9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitOpacityOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4fa9f13bcdb83634190b1e5e7843ffb3eba8688967e2000973982753a8333f69)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitOpacityOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c49294ea5a7fb9ab93ff54fcc5f6effb965321ada7f3d1230c392dafb336c8ed)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__52d04e83a42f20a4f23c85992b4c7e3610a9c45664270d335396f1835f4c3d2d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3063f4bd40f039a949285ee2ad6cdeb01f3bc4be09234c41ec6b2981c6e2d239)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitOpacity]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitOpacity]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2fe7e9601b9d75e6fe97d9d509b3864b74848aa25cd2cc6ba5f5baa4bf36abbe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitOpacityOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitOpacityOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__138ce017a82cb3e80b1f44e4bb59f6a2daa9984848f655f496aefa38af6ad99d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetOpacityVar")
    def reset_opacity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacityVar", []))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityVarInput")
    def opacity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacity"))

    @opacity.setter
    def opacity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__85bc94894320c14627fc49778c9cef025fb4bf89bb646f2f17b914b554be54c3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacity", value)

    @builtins.property
    @jsii.member(jsii_name="opacityVar")
    def opacity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacityVar"))

    @opacity_var.setter
    def opacity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1cfe99147e64114e131308038cd642a3810f7cf8e2613b90a02ba6bda79cbccf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacityVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitOpacity]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitOpacity]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitOpacity]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1a54af3916b8ca0c5630796737877beb01cce3201dad9c01eecdbdde3a77ee67)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eb74982dc289137f17d8f8bcf38f92a4c1a8177c5ff6204d9de3f4b12a0f1f29)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putBackgroundColor")
    def put_background_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0c123bb82b7f31dbae755e7d2b23629dc46179194311a5ba4551efd10d08072a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBackgroundColor", [value]))

    @jsii.member(jsii_name="putBlur")
    def put_blur(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitBlur, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bad32d5ac244addbfc7c030d66b194d36fe983411abd90b6a428906171b546d6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBlur", [value]))

    @jsii.member(jsii_name="putChromaKey")
    def put_chroma_key(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitChromaKey, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df34f1266b7bfcb731d07826afe46f898060cdb7d63926c0c5fe8c717b11a3f3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putChromaKey", [value]))

    @jsii.member(jsii_name="putComposite")
    def put_composite(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitComposite, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0589385ba8fe80edd8e191fdfc3fdbd5a0172c56c5105c52673e5949958454e5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putComposite", [value]))

    @jsii.member(jsii_name="putCompound")
    def put_compound(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitCompound, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__56c6c393c374cf74e156066f105a2aa003352611adbe85415daa04069afb2ced)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCompound", [value]))

    @jsii.member(jsii_name="putContrast")
    def put_contrast(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitContrast, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5fd2fd329d134708238b50238f9b7f0d7ad264ce8459c7cd308e185f7ae8e465)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putContrast", [value]))

    @jsii.member(jsii_name="putGoop")
    def put_goop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitGoop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ae21a641302da74ade7b252ccdebb7d7c1f5ee702ce3469daa9c5d1d482512a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGoop", [value]))

    @jsii.member(jsii_name="putGrayscale")
    def put_grayscale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitGrayscale, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e8631dbf41596af73dc32fcf89fac583813bc76043082a1f58493f32dc0895f8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGrayscale", [value]))

    @jsii.member(jsii_name="putHsl")
    def put_hsl(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitHsl, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c28116f2d7295d29781b012fc9f79b614ddc68e63303795b1a53a885c67648c7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsl", [value]))

    @jsii.member(jsii_name="putHsv")
    def put_hsv(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitHsv, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__34ad26273b0a573ecf7c719c5925e93ef8615efbede22ebc38db42cb70865c74)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsv", [value]))

    @jsii.member(jsii_name="putIfDimension")
    def put_if_dimension(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimension, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a6a5dfa0479066519094de29d1965b61ab0a77a16cbd50faed4ae9941e8ae09c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfDimension", [value]))

    @jsii.member(jsii_name="putIfOrientation")
    def put_if_orientation(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__60b5598438ed419b4e67219881376039c314fb89d0f1c894343d729f0da0abc0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfOrientation", [value]))

    @jsii.member(jsii_name="putMaxColors")
    def put_max_colors(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitMaxColors, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8e70651d87512fb565a9c10b0e7e4a15f391fadf6b1e5fc38f2da4472150a74d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMaxColors", [value]))

    @jsii.member(jsii_name="putMirror")
    def put_mirror(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitMirror, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__55f32ef8defb87c2eb79fc9e5c27947dd0d8b5e3b338ceb6ece97422e3799886)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMirror", [value]))

    @jsii.member(jsii_name="putMonoHue")
    def put_mono_hue(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitMonoHue, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d5958cace0fac0828b46a99243945cb1a4eb765778f0b5550c916d9da93dd795)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMonoHue", [value]))

    @jsii.member(jsii_name="putOpacity")
    def put_opacity(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitOpacity, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__93d5be0b75387a565dbcb8481bd8b36f012783eb32467addbc7f431f9961eea0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putOpacity", [value]))

    @jsii.member(jsii_name="putRemoveColor")
    def put_remove_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitRemoveColor", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac3a6b12bd6e094fb5dcfb2b2a3aee05f9375613ab0ab169770850cc6ba24a44)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRemoveColor", [value]))

    @jsii.member(jsii_name="putUnsharpMask")
    def put_unsharp_mask(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitUnsharpMask", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4201b189c828da246e527d238fbd1631dd250c30e82b0f69435d1b284fc4e078)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putUnsharpMask", [value]))

    @jsii.member(jsii_name="resetBackgroundColor")
    def reset_background_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBackgroundColor", []))

    @jsii.member(jsii_name="resetBlur")
    def reset_blur(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBlur", []))

    @jsii.member(jsii_name="resetChromaKey")
    def reset_chroma_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChromaKey", []))

    @jsii.member(jsii_name="resetComposite")
    def reset_composite(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetComposite", []))

    @jsii.member(jsii_name="resetCompound")
    def reset_compound(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCompound", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetGoop")
    def reset_goop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGoop", []))

    @jsii.member(jsii_name="resetGrayscale")
    def reset_grayscale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGrayscale", []))

    @jsii.member(jsii_name="resetHsl")
    def reset_hsl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsl", []))

    @jsii.member(jsii_name="resetHsv")
    def reset_hsv(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsv", []))

    @jsii.member(jsii_name="resetIfDimension")
    def reset_if_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfDimension", []))

    @jsii.member(jsii_name="resetIfOrientation")
    def reset_if_orientation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfOrientation", []))

    @jsii.member(jsii_name="resetMaxColors")
    def reset_max_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxColors", []))

    @jsii.member(jsii_name="resetMirror")
    def reset_mirror(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMirror", []))

    @jsii.member(jsii_name="resetMonoHue")
    def reset_mono_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonoHue", []))

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetRemoveColor")
    def reset_remove_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRemoveColor", []))

    @jsii.member(jsii_name="resetUnsharpMask")
    def reset_unsharp_mask(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUnsharpMask", []))

    @builtins.property
    @jsii.member(jsii_name="backgroundColor")
    def background_color(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitBackgroundColorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitBackgroundColorList, jsii.get(self, "backgroundColor"))

    @builtins.property
    @jsii.member(jsii_name="blur")
    def blur(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitBlurList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitBlurList, jsii.get(self, "blur"))

    @builtins.property
    @jsii.member(jsii_name="chromaKey")
    def chroma_key(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitChromaKeyList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitChromaKeyList, jsii.get(self, "chromaKey"))

    @builtins.property
    @jsii.member(jsii_name="composite")
    def composite(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitCompositeList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitCompositeList, jsii.get(self, "composite"))

    @builtins.property
    @jsii.member(jsii_name="compound")
    def compound(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitCompoundList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitCompoundList, jsii.get(self, "compound"))

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitContrastList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitContrastList, jsii.get(self, "contrast"))

    @builtins.property
    @jsii.member(jsii_name="goop")
    def goop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitGoopList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitGoopList, jsii.get(self, "goop"))

    @builtins.property
    @jsii.member(jsii_name="grayscale")
    def grayscale(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitGrayscaleList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitGrayscaleList, jsii.get(self, "grayscale"))

    @builtins.property
    @jsii.member(jsii_name="hsl")
    def hsl(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitHslList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitHslList, jsii.get(self, "hsl"))

    @builtins.property
    @jsii.member(jsii_name="hsv")
    def hsv(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitHsvList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitHsvList, jsii.get(self, "hsv"))

    @builtins.property
    @jsii.member(jsii_name="ifDimension")
    def if_dimension(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionList, jsii.get(self, "ifDimension"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientation")
    def if_orientation(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationList, jsii.get(self, "ifOrientation"))

    @builtins.property
    @jsii.member(jsii_name="maxColors")
    def max_colors(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitMaxColorsList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitMaxColorsList, jsii.get(self, "maxColors"))

    @builtins.property
    @jsii.member(jsii_name="mirror")
    def mirror(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitMirrorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitMirrorList, jsii.get(self, "mirror"))

    @builtins.property
    @jsii.member(jsii_name="monoHue")
    def mono_hue(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitMonoHueList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitMonoHueList, jsii.get(self, "monoHue"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitOpacityList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitOpacityList, jsii.get(self, "opacity"))

    @builtins.property
    @jsii.member(jsii_name="removeColor")
    def remove_color(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitRemoveColorList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitRemoveColorList", jsii.get(self, "removeColor"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMask")
    def unsharp_mask(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitUnsharpMaskList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitUnsharpMaskList", jsii.get(self, "unsharpMask"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColorInput")
    def background_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitBackgroundColor]]], jsii.get(self, "backgroundColorInput"))

    @builtins.property
    @jsii.member(jsii_name="blurInput")
    def blur_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitBlur]]], jsii.get(self, "blurInput"))

    @builtins.property
    @jsii.member(jsii_name="chromaKeyInput")
    def chroma_key_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitChromaKey]]], jsii.get(self, "chromaKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="compositeInput")
    def composite_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitComposite]]], jsii.get(self, "compositeInput"))

    @builtins.property
    @jsii.member(jsii_name="compoundInput")
    def compound_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitCompound]]], jsii.get(self, "compoundInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitContrast]]], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="goopInput")
    def goop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitGoop]]], jsii.get(self, "goopInput"))

    @builtins.property
    @jsii.member(jsii_name="grayscaleInput")
    def grayscale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitGrayscale]]], jsii.get(self, "grayscaleInput"))

    @builtins.property
    @jsii.member(jsii_name="hslInput")
    def hsl_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitHsl]]], jsii.get(self, "hslInput"))

    @builtins.property
    @jsii.member(jsii_name="hsvInput")
    def hsv_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitHsv]]], jsii.get(self, "hsvInput"))

    @builtins.property
    @jsii.member(jsii_name="ifDimensionInput")
    def if_dimension_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimension]]], jsii.get(self, "ifDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientationInput")
    def if_orientation_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientation]]], jsii.get(self, "ifOrientationInput"))

    @builtins.property
    @jsii.member(jsii_name="maxColorsInput")
    def max_colors_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitMaxColors]]], jsii.get(self, "maxColorsInput"))

    @builtins.property
    @jsii.member(jsii_name="mirrorInput")
    def mirror_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitMirror]]], jsii.get(self, "mirrorInput"))

    @builtins.property
    @jsii.member(jsii_name="monoHueInput")
    def mono_hue_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitMonoHue]]], jsii.get(self, "monoHueInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitOpacity]]], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="removeColorInput")
    def remove_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitRemoveColor"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitRemoveColor"]]], jsii.get(self, "removeColorInput"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMaskInput")
    def unsharp_mask_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitUnsharpMask"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitUnsharpMask"]]], jsii.get(self, "unsharpMaskInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortrait]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortrait], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortrait],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0d75914fd007cda3d5db2171ece79080a2eb4e86541b486844a89f9cb1080de5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitRemoveColor",
    jsii_struct_bases=[],
    name_mapping={
        "color": "color",
        "color_var": "colorVar",
        "feather": "feather",
        "feather_var": "featherVar",
        "tolerance": "tolerance",
        "tolerance_var": "toleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitRemoveColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
        feather: typing.Optional[builtins.str] = None,
        feather_var: typing.Optional[builtins.str] = None,
        tolerance: typing.Optional[builtins.str] = None,
        tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        :param feather: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        :param feather_var: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        :param tolerance: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        :param tolerance_var: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb01700e27483f300a3192226e7fd06a04e0e1fd65692d9ff2eceaba6d0d7463)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
            check_type(argname="argument feather", value=feather, expected_type=type_hints["feather"])
            check_type(argname="argument feather_var", value=feather_var, expected_type=type_hints["feather_var"])
            check_type(argname="argument tolerance", value=tolerance, expected_type=type_hints["tolerance"])
            check_type(argname="argument tolerance_var", value=tolerance_var, expected_type=type_hints["tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var
        if feather is not None:
            self._values["feather"] = feather
        if feather_var is not None:
            self._values["feather_var"] = feather_var
        if tolerance is not None:
            self._values["tolerance"] = tolerance
        if tolerance_var is not None:
            self._values["tolerance_var"] = tolerance_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        '''
        result = self._values.get("feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather_var(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        '''
        result = self._values.get("feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        '''
        result = self._values.get("tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance_var(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        result = self._values.get("tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitRemoveColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitRemoveColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitRemoveColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d619308cfc2624068ede9110c4a52b3285c5f7126d674ceb834c170aeb4c35c9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitRemoveColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2963eb4bdd0773cc1f2d7cf5d80b22b671e2140bffc3a5512da0d139aaeb2b2f)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitRemoveColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be4a4feccfa15d9fae603ba0a3657192f4b584e8c2792e5bb80292a9e2643fd3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d271ddc5de5d1e3b96057cd6f26d2273d09f85dbe8f243b3ded64a19d667125a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a0e690b8a3eb4b9965333ceb35549f88ca57731173e7d7f47c3cdc43cea89128)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitRemoveColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitRemoveColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitRemoveColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4b616463642beec5e6428cc6229b0f647d8a7a27a386bba724901344e06d1a65)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitRemoveColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitRemoveColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e8d0a82d5864753e0d732b2de7a638063e479f220dbdd5748f87b037960d2e16)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @jsii.member(jsii_name="resetFeather")
    def reset_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeather", []))

    @jsii.member(jsii_name="resetFeatherVar")
    def reset_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatherVar", []))

    @jsii.member(jsii_name="resetTolerance")
    def reset_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTolerance", []))

    @jsii.member(jsii_name="resetToleranceVar")
    def reset_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featherInput")
    def feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherInput"))

    @builtins.property
    @jsii.member(jsii_name="featherVarInput")
    def feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceInput")
    def tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceVarInput")
    def tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bfc0112307a7f95924723ce27b32d0e21e1993940f0d375ea88337f63282ce6b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__54db0bd6debac82c6e5c3d3698b98c924d02b05136a1a0ed152c4cc642673b3c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="feather")
    def feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "feather"))

    @feather.setter
    def feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5d9b0db050c1052a9538c5502efb6ea0c78b8ed13e0e2a332250a641b83af3cf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "feather", value)

    @builtins.property
    @jsii.member(jsii_name="featherVar")
    def feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featherVar"))

    @feather_var.setter
    def feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0df384cad53ac55182791ea60560406cbfd16c0555ecc5cea24a41b5588ba4ea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featherVar", value)

    @builtins.property
    @jsii.member(jsii_name="tolerance")
    def tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tolerance"))

    @tolerance.setter
    def tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__91bcc91022c14965f379918fb8172ea05fdf25d079c77354940aec6409ddaa44)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tolerance", value)

    @builtins.property
    @jsii.member(jsii_name="toleranceVar")
    def tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "toleranceVar"))

    @tolerance_var.setter
    def tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eb7381abf417dbf3ec0be8a61919faf669f0e571d7b318487a83e31c7ded2c7c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "toleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitRemoveColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitRemoveColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitRemoveColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f7155faf3d2a7cde968479f675d1e90e99f70f9cc41c13d9caab51bf2ee89557)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitUnsharpMask",
    jsii_struct_bases=[],
    name_mapping={
        "gain": "gain",
        "gain_var": "gainVar",
        "sigma": "sigma",
        "sigma_var": "sigmaVar",
        "threshold": "threshold",
        "threshold_var": "thresholdVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitUnsharpMask:
    def __init__(
        self,
        *,
        gain: typing.Optional[builtins.str] = None,
        gain_var: typing.Optional[builtins.str] = None,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
        threshold: typing.Optional[builtins.str] = None,
        threshold_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param gain: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        :param gain_var: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        :param sigma: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        :param threshold: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        :param threshold_var: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4074f6152797e635bbd895dde37b4fbc26d13145033f2f877dc7fe2dae95b897)
            check_type(argname="argument gain", value=gain, expected_type=type_hints["gain"])
            check_type(argname="argument gain_var", value=gain_var, expected_type=type_hints["gain_var"])
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
            check_type(argname="argument threshold", value=threshold, expected_type=type_hints["threshold"])
            check_type(argname="argument threshold_var", value=threshold_var, expected_type=type_hints["threshold_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if gain is not None:
            self._values["gain"] = gain
        if gain_var is not None:
            self._values["gain_var"] = gain_var
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var
        if threshold is not None:
            self._values["threshold"] = threshold
        if threshold_var is not None:
            self._values["threshold_var"] = threshold_var

    @builtins.property
    def gain(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        '''
        result = self._values.get("gain")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gain_var(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        '''
        result = self._values.get("gain_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        '''
        result = self._values.get("threshold")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold_var(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        result = self._values.get("threshold_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitUnsharpMask(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitUnsharpMaskList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitUnsharpMaskList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8086b9a20c8c09d69264f66915241f48b9797d7e2279ed9da4a70047fc592363)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitUnsharpMaskOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__84419063026d21d083cdf9ff1321c1bec063bd4cd64a1f4e141c18d86eb11bde)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitUnsharpMaskOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4e29661d78f81c5f74a6856324fe56fe0f5434dddfd00a919921d2430f54c0fc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2c5b831630a90b4b46d102b4860f7c164589c8c47477c04aa715ea1c52f11ae0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__28307762e6d6f3717012b5df7fd5ced9a9ae96c096a13ae72dfd216501da144c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitUnsharpMask]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitUnsharpMask]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitUnsharpMask]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0a5f3aa5fb427ba2e30aa9e43740529efc539584f87b9a57cd3285c376754639)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitUnsharpMaskOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitUnsharpMaskOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4faf549f88941d8dcbc009ae5cc5ea66aac16bf0c9ce6eb9ff12745f4e10d729)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetGain")
    def reset_gain(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGain", []))

    @jsii.member(jsii_name="resetGainVar")
    def reset_gain_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGainVar", []))

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @jsii.member(jsii_name="resetThreshold")
    def reset_threshold(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThreshold", []))

    @jsii.member(jsii_name="resetThresholdVar")
    def reset_threshold_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThresholdVar", []))

    @builtins.property
    @jsii.member(jsii_name="gainInput")
    def gain_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainInput"))

    @builtins.property
    @jsii.member(jsii_name="gainVarInput")
    def gain_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdInput")
    def threshold_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdVarInput")
    def threshold_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gain")
    def gain(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gain"))

    @gain.setter
    def gain(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5c59964a782d60cfe3fbcf1e61cdf762086fa0269b3d1d063e19f9a78dfc6506)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gain", value)

    @builtins.property
    @jsii.member(jsii_name="gainVar")
    def gain_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gainVar"))

    @gain_var.setter
    def gain_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__110a113c499f162497003436e0116ae6c8ec2ac44b65bc4b2040754733badc8f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gainVar", value)

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__057719649868f5fabe7b4359d864f7bdcec2a980e964e08f83c11ade9d83408f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1fec857123b2e2a06923cf50a5607e67abd6c38263afb957e566f554b1efb39a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="threshold")
    def threshold(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "threshold"))

    @threshold.setter
    def threshold(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4cab64bc5f0f8bd4170100326cd7962a2dd28e009842bd8479476da9a5dbedba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "threshold", value)

    @builtins.property
    @jsii.member(jsii_name="thresholdVar")
    def threshold_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "thresholdVar"))

    @threshold_var.setter
    def threshold_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__efe56419fd64a91bd61bdb190c434a425a09d842bf9816c87651a984f62bd343)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "thresholdVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitUnsharpMask]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitUnsharpMask]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitUnsharpMask]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__578a583dd15e5fbb211bcabda087c8feb989b3fc3320952097c4be4469d02921)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquare",
    jsii_struct_bases=[],
    name_mapping={
        "background_color": "backgroundColor",
        "blur": "blur",
        "chroma_key": "chromaKey",
        "composite": "composite",
        "compound": "compound",
        "contrast": "contrast",
        "goop": "goop",
        "grayscale": "grayscale",
        "hsl": "hsl",
        "hsv": "hsv",
        "if_dimension": "ifDimension",
        "if_orientation": "ifOrientation",
        "max_colors": "maxColors",
        "mirror": "mirror",
        "mono_hue": "monoHue",
        "opacity": "opacity",
        "remove_color": "removeColor",
        "unsharp_mask": "unsharpMask",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquare:
    def __init__(
        self,
        *,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareBackgroundColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareBlur", typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareChromaKey", typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareComposite", typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareCompound", typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareContrast", typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareGoop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareGrayscale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareHsl", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareHsv", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimension", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientation", typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareMaxColors", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareMirror", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareMonoHue", typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareOpacity", typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareRemoveColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareUnsharpMask", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__da3d0862030208a388598740349747fe0c8d42dbfe9a9d70ff89077540eac6ce)
            check_type(argname="argument background_color", value=background_color, expected_type=type_hints["background_color"])
            check_type(argname="argument blur", value=blur, expected_type=type_hints["blur"])
            check_type(argname="argument chroma_key", value=chroma_key, expected_type=type_hints["chroma_key"])
            check_type(argname="argument composite", value=composite, expected_type=type_hints["composite"])
            check_type(argname="argument compound", value=compound, expected_type=type_hints["compound"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument goop", value=goop, expected_type=type_hints["goop"])
            check_type(argname="argument grayscale", value=grayscale, expected_type=type_hints["grayscale"])
            check_type(argname="argument hsl", value=hsl, expected_type=type_hints["hsl"])
            check_type(argname="argument hsv", value=hsv, expected_type=type_hints["hsv"])
            check_type(argname="argument if_dimension", value=if_dimension, expected_type=type_hints["if_dimension"])
            check_type(argname="argument if_orientation", value=if_orientation, expected_type=type_hints["if_orientation"])
            check_type(argname="argument max_colors", value=max_colors, expected_type=type_hints["max_colors"])
            check_type(argname="argument mirror", value=mirror, expected_type=type_hints["mirror"])
            check_type(argname="argument mono_hue", value=mono_hue, expected_type=type_hints["mono_hue"])
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument remove_color", value=remove_color, expected_type=type_hints["remove_color"])
            check_type(argname="argument unsharp_mask", value=unsharp_mask, expected_type=type_hints["unsharp_mask"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if background_color is not None:
            self._values["background_color"] = background_color
        if blur is not None:
            self._values["blur"] = blur
        if chroma_key is not None:
            self._values["chroma_key"] = chroma_key
        if composite is not None:
            self._values["composite"] = composite
        if compound is not None:
            self._values["compound"] = compound
        if contrast is not None:
            self._values["contrast"] = contrast
        if goop is not None:
            self._values["goop"] = goop
        if grayscale is not None:
            self._values["grayscale"] = grayscale
        if hsl is not None:
            self._values["hsl"] = hsl
        if hsv is not None:
            self._values["hsv"] = hsv
        if if_dimension is not None:
            self._values["if_dimension"] = if_dimension
        if if_orientation is not None:
            self._values["if_orientation"] = if_orientation
        if max_colors is not None:
            self._values["max_colors"] = max_colors
        if mirror is not None:
            self._values["mirror"] = mirror
        if mono_hue is not None:
            self._values["mono_hue"] = mono_hue
        if opacity is not None:
            self._values["opacity"] = opacity
        if remove_color is not None:
            self._values["remove_color"] = remove_color
        if unsharp_mask is not None:
            self._values["unsharp_mask"] = unsharp_mask

    @builtins.property
    def background_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareBackgroundColor"]]]:
        '''background_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        '''
        result = self._values.get("background_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareBackgroundColor"]]], result)

    @builtins.property
    def blur(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareBlur"]]]:
        '''blur block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        '''
        result = self._values.get("blur")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareBlur"]]], result)

    @builtins.property
    def chroma_key(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareChromaKey"]]]:
        '''chroma_key block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        '''
        result = self._values.get("chroma_key")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareChromaKey"]]], result)

    @builtins.property
    def composite(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareComposite"]]]:
        '''composite block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        '''
        result = self._values.get("composite")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareComposite"]]], result)

    @builtins.property
    def compound(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareCompound"]]]:
        '''compound block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        '''
        result = self._values.get("compound")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareCompound"]]], result)

    @builtins.property
    def contrast(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareContrast"]]]:
        '''contrast block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareContrast"]]], result)

    @builtins.property
    def goop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareGoop"]]]:
        '''goop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        '''
        result = self._values.get("goop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareGoop"]]], result)

    @builtins.property
    def grayscale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareGrayscale"]]]:
        '''grayscale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        '''
        result = self._values.get("grayscale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareGrayscale"]]], result)

    @builtins.property
    def hsl(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareHsl"]]]:
        '''hsl block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        '''
        result = self._values.get("hsl")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareHsl"]]], result)

    @builtins.property
    def hsv(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareHsv"]]]:
        '''hsv block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        '''
        result = self._values.get("hsv")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareHsv"]]], result)

    @builtins.property
    def if_dimension(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimension"]]]:
        '''if_dimension block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        '''
        result = self._values.get("if_dimension")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimension"]]], result)

    @builtins.property
    def if_orientation(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientation"]]]:
        '''if_orientation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        '''
        result = self._values.get("if_orientation")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientation"]]], result)

    @builtins.property
    def max_colors(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareMaxColors"]]]:
        '''max_colors block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        '''
        result = self._values.get("max_colors")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareMaxColors"]]], result)

    @builtins.property
    def mirror(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareMirror"]]]:
        '''mirror block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        '''
        result = self._values.get("mirror")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareMirror"]]], result)

    @builtins.property
    def mono_hue(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareMonoHue"]]]:
        '''mono_hue block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        '''
        result = self._values.get("mono_hue")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareMonoHue"]]], result)

    @builtins.property
    def opacity(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareOpacity"]]]:
        '''opacity block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareOpacity"]]], result)

    @builtins.property
    def remove_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareRemoveColor"]]]:
        '''remove_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        '''
        result = self._values.get("remove_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareRemoveColor"]]], result)

    @builtins.property
    def unsharp_mask(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareUnsharpMask"]]]:
        '''unsharp_mask block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        result = self._values.get("unsharp_mask")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareUnsharpMask"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquare(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareBackgroundColor",
    jsii_struct_bases=[],
    name_mapping={"color": "color", "color_var": "colorVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareBackgroundColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e2dd351c3425a8b78dce695b282e135aa40089c6cb4f993f5fee38987d4e84bb)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareBackgroundColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareBackgroundColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareBackgroundColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5bc606a66aeb8845e5109d0cabe7a905852ded1b085706e8a02b4079142a04d9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareBackgroundColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a8dd8a7fba8d30b8e68fb9eb6baf1a709bb2c0c6149129cb257427085fb4df7e)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareBackgroundColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6bed7e57c16d617a0955468ce7ebf019ee11ba7858a5d63d75be9d80e60613e4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__518135ca78f6e9a98e3eaa575fe4ff3f11b0a5131157d9d86f89d550829be5bc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ec57364e16c562a970eabec74e312ec9b5e80af06bf9bd7cfd0cbc73bc0cd606)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareBackgroundColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareBackgroundColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__29ea11015b4e8b575412ae36c5477776d6a7ffe6dcbe7974223b6d81500d2e4c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareBackgroundColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareBackgroundColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a60552a18a6bf56418eb1fe7a6b56c1f9fcb8736cbd99cd621792bd179f10b6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__488c5ac7345b9c0a44427f5e266a8dc0e0bd96e73a0daacee7580ef57627109f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__944a1ec986ff003eee0c011e2acfb81d2b99f714802710756b67bf71184291af)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareBackgroundColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareBackgroundColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareBackgroundColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd489baefb789ce6d841e82752baaf590e92ff1190a4484bb7cbb15b9617cae5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareBlur",
    jsii_struct_bases=[],
    name_mapping={"sigma": "sigma", "sigma_var": "sigmaVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareBlur:
    def __init__(
        self,
        *,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param sigma: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0bd454164e3c08098072fdb488e34835e2873cb27e8d1b836e0569bf1bdf230c)
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareBlur(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareBlurList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareBlurList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__33ec05bcd5c7cf248c14f4ad7be7811b015e797f4f6b905654cb47e1db95f0d7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareBlurOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b117890a4ab0fcf8dece5da15b2d02d9f6c972b1bc721231bef421527f8108d0)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareBlurOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__320a61d4d1b954210e7a3071eae601a1e96d7409c8f985d8d5f9d4d274686d4a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b083b246751dde71bcfa6ef1ee6c2b02e9bd20ad46f6dfd1090c622a6eb64aca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__889da0551b733a10693e153719308a38144b42b20cf7878f8e3e6ab19fabb733)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareBlur]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareBlur]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__03f048084557374bb6d1e83bdd4430ced86abd59753b215ca1effa8560190f0f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareBlurOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareBlurOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6ece48690d63d25df2bed77b82cdde3c51225e1b7f6fec3007860024afbf1c1b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c3991210386f00d565054697f93751070c8ff2a46f2aca18c6cec73f6e2dc394)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4e8b3afab7b77d2b64426160392dd2d1aab70d03ab00c4dfbdab0b5c36ceeb62)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareBlur]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareBlur]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareBlur]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__03a0856de4f4b186d65717333d9083c2172fbcba426b5cb001d172f29b36be3e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareChromaKey",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_feather": "hueFeather",
        "hue_feather_var": "hueFeatherVar",
        "hue_tolerance": "hueTolerance",
        "hue_tolerance_var": "hueToleranceVar",
        "hue_var": "hueVar",
        "lightness_feather": "lightnessFeather",
        "lightness_feather_var": "lightnessFeatherVar",
        "lightness_tolerance": "lightnessTolerance",
        "lightness_tolerance_var": "lightnessToleranceVar",
        "saturation_feather": "saturationFeather",
        "saturation_feather_var": "saturationFeatherVar",
        "saturation_tolerance": "saturationTolerance",
        "saturation_tolerance_var": "saturationToleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareChromaKey:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_feather: typing.Optional[builtins.str] = None,
        hue_feather_var: typing.Optional[builtins.str] = None,
        hue_tolerance: typing.Optional[builtins.str] = None,
        hue_tolerance_var: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness_feather: typing.Optional[builtins.str] = None,
        lightness_feather_var: typing.Optional[builtins.str] = None,
        lightness_tolerance: typing.Optional[builtins.str] = None,
        lightness_tolerance_var: typing.Optional[builtins.str] = None,
        saturation_feather: typing.Optional[builtins.str] = None,
        saturation_feather_var: typing.Optional[builtins.str] = None,
        saturation_tolerance: typing.Optional[builtins.str] = None,
        saturation_tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_feather: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        :param hue_feather_var: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        :param hue_tolerance: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        :param hue_tolerance_var: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        :param hue_var: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness_feather: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        :param lightness_feather_var: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        :param lightness_tolerance: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        :param lightness_tolerance_var: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        :param saturation_feather: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        :param saturation_feather_var: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        :param saturation_tolerance: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        :param saturation_tolerance_var: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6acfc7e4fefbc4ed87f384733a5e9374c1fc286328fd46f0a1cab7c7924ea3d1)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_feather", value=hue_feather, expected_type=type_hints["hue_feather"])
            check_type(argname="argument hue_feather_var", value=hue_feather_var, expected_type=type_hints["hue_feather_var"])
            check_type(argname="argument hue_tolerance", value=hue_tolerance, expected_type=type_hints["hue_tolerance"])
            check_type(argname="argument hue_tolerance_var", value=hue_tolerance_var, expected_type=type_hints["hue_tolerance_var"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness_feather", value=lightness_feather, expected_type=type_hints["lightness_feather"])
            check_type(argname="argument lightness_feather_var", value=lightness_feather_var, expected_type=type_hints["lightness_feather_var"])
            check_type(argname="argument lightness_tolerance", value=lightness_tolerance, expected_type=type_hints["lightness_tolerance"])
            check_type(argname="argument lightness_tolerance_var", value=lightness_tolerance_var, expected_type=type_hints["lightness_tolerance_var"])
            check_type(argname="argument saturation_feather", value=saturation_feather, expected_type=type_hints["saturation_feather"])
            check_type(argname="argument saturation_feather_var", value=saturation_feather_var, expected_type=type_hints["saturation_feather_var"])
            check_type(argname="argument saturation_tolerance", value=saturation_tolerance, expected_type=type_hints["saturation_tolerance"])
            check_type(argname="argument saturation_tolerance_var", value=saturation_tolerance_var, expected_type=type_hints["saturation_tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_feather is not None:
            self._values["hue_feather"] = hue_feather
        if hue_feather_var is not None:
            self._values["hue_feather_var"] = hue_feather_var
        if hue_tolerance is not None:
            self._values["hue_tolerance"] = hue_tolerance
        if hue_tolerance_var is not None:
            self._values["hue_tolerance_var"] = hue_tolerance_var
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness_feather is not None:
            self._values["lightness_feather"] = lightness_feather
        if lightness_feather_var is not None:
            self._values["lightness_feather_var"] = lightness_feather_var
        if lightness_tolerance is not None:
            self._values["lightness_tolerance"] = lightness_tolerance
        if lightness_tolerance_var is not None:
            self._values["lightness_tolerance_var"] = lightness_tolerance_var
        if saturation_feather is not None:
            self._values["saturation_feather"] = saturation_feather
        if saturation_feather_var is not None:
            self._values["saturation_feather_var"] = saturation_feather_var
        if saturation_tolerance is not None:
            self._values["saturation_tolerance"] = saturation_tolerance
        if saturation_tolerance_var is not None:
            self._values["saturation_tolerance_var"] = saturation_tolerance_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        '''
        result = self._values.get("hue_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        '''
        result = self._values.get("hue_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        '''
        result = self._values.get("hue_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        '''
        result = self._values.get("hue_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        '''
        result = self._values.get("lightness_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        '''
        result = self._values.get("lightness_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        '''
        result = self._values.get("lightness_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        '''
        result = self._values.get("lightness_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        '''
        result = self._values.get("saturation_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        '''
        result = self._values.get("saturation_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        '''
        result = self._values.get("saturation_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        result = self._values.get("saturation_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareChromaKey(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareChromaKeyList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareChromaKeyList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__db5be663c9c5ed29926e949185fa29cac679a9dcee25bb58b38d3dbdcd5bf570)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareChromaKeyOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9625878ae6ac588cee9d9742d9d81db03b5f9ea01cf3dc73378a97e7735d5b81)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareChromaKeyOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__93238d6a0e91171f4911d1fee3843af12b9ff90221ec7c514dd6110952c3f0ff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__00b703ba08c0c499a7e5dd3439ac981783b3b481ae053fbd687c2fad395585a3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0551d0af47c5e2f8072f924f145c265a09d4762702f35c1c3030ddd14cf31b73)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareChromaKey]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareChromaKey]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a1c58d5a457bf99ab37f738942ef70b598c4128fb10448e192250f19bc4dbcc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareChromaKeyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareChromaKeyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7442fd9bde55caba1adbf03a1a5876c4998061a42f482ddea307e69cf68c4de7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueFeather")
    def reset_hue_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeather", []))

    @jsii.member(jsii_name="resetHueFeatherVar")
    def reset_hue_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeatherVar", []))

    @jsii.member(jsii_name="resetHueTolerance")
    def reset_hue_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueTolerance", []))

    @jsii.member(jsii_name="resetHueToleranceVar")
    def reset_hue_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueToleranceVar", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightnessFeather")
    def reset_lightness_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeather", []))

    @jsii.member(jsii_name="resetLightnessFeatherVar")
    def reset_lightness_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeatherVar", []))

    @jsii.member(jsii_name="resetLightnessTolerance")
    def reset_lightness_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessTolerance", []))

    @jsii.member(jsii_name="resetLightnessToleranceVar")
    def reset_lightness_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessToleranceVar", []))

    @jsii.member(jsii_name="resetSaturationFeather")
    def reset_saturation_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeather", []))

    @jsii.member(jsii_name="resetSaturationFeatherVar")
    def reset_saturation_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeatherVar", []))

    @jsii.member(jsii_name="resetSaturationTolerance")
    def reset_saturation_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationTolerance", []))

    @jsii.member(jsii_name="resetSaturationToleranceVar")
    def reset_saturation_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherInput")
    def hue_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVarInput")
    def hue_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceInput")
    def hue_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVarInput")
    def hue_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherInput")
    def lightness_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVarInput")
    def lightness_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceInput")
    def lightness_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVarInput")
    def lightness_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherInput")
    def saturation_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVarInput")
    def saturation_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceInput")
    def saturation_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVarInput")
    def saturation_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1ec60240f978e23c9d778c483a179888eb5bd07d9b6a72e30fd18ab60acc1495)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeather")
    def hue_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeather"))

    @hue_feather.setter
    def hue_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__01e85c93ebf6d523a1a1e711b005eeaec8b504708cd9f17db7eade8d77b5e245)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeather", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVar")
    def hue_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeatherVar"))

    @hue_feather_var.setter
    def hue_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__01a04865287fda1bfa5af6a278291496615ead95a76dfef27175b400e4ee23a0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueTolerance")
    def hue_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueTolerance"))

    @hue_tolerance.setter
    def hue_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1830866252ddb1bbf089f344788b9d9353c03a9b94c7f4db282c189510dfeb8f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVar")
    def hue_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueToleranceVar"))

    @hue_tolerance_var.setter
    def hue_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__49f3c4568d57f039b0dd26641e4b207e95272e0d55f20178c0884d48727258e5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1cb262354551c7aa691260638386a574a35fe59c8915ccb68e27c7f1acdfe54d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeather")
    def lightness_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeather"))

    @lightness_feather.setter
    def lightness_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__84076807f1a23d8762400dbcf3ae63f4adfa39a3b55d4702fb43c484f7ccdcb8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeather", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVar")
    def lightness_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeatherVar"))

    @lightness_feather_var.setter
    def lightness_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c0811163904482ea5c61b7ced4802ae1fffb36e2c95701cf7eace51680ff0d2e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessTolerance")
    def lightness_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessTolerance"))

    @lightness_tolerance.setter
    def lightness_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f33e24831737aae1227b1cfeb98a5052263c02372df5628364da133271642ba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVar")
    def lightness_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessToleranceVar"))

    @lightness_tolerance_var.setter
    def lightness_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5c797513a4e813a776f32cbd855a10376b79fa90bd0d3b0a1d7421397e392b79)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeather")
    def saturation_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeather"))

    @saturation_feather.setter
    def saturation_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__49b7f4c8a4e99b303636b9385c5562dff4a26dbace86c8547f4d02ce4231ec39)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeather", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVar")
    def saturation_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeatherVar"))

    @saturation_feather_var.setter
    def saturation_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af4595883718ca1b3085ad0d0654ac9a49ed4a5ab9bf3fd4833ff67b3a485f18)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationTolerance")
    def saturation_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationTolerance"))

    @saturation_tolerance.setter
    def saturation_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__10f620edb5d70fd21b17adb002db88e135a3acf8060fc2f3029a4b342f19b871)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVar")
    def saturation_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationToleranceVar"))

    @saturation_tolerance_var.setter
    def saturation_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__67170188432b30439f4a256a56241ceb81cd5f53d09c91b3eb9079f2493b77a8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareChromaKey]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareChromaKey]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareChromaKey]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__37e647c6939b0051dc668b2f06de144508b9462220a7fb844c3fa5788b2dcb45)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareComposite",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "placement": "placement",
        "placement_var": "placementVar",
        "scale": "scale",
        "scale_dimension": "scaleDimension",
        "scale_dimension_var": "scaleDimensionVar",
        "scale_var": "scaleVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareComposite:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareCompositeImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        placement: typing.Optional[builtins.str] = None,
        placement_var: typing.Optional[builtins.str] = None,
        scale: typing.Optional[builtins.str] = None,
        scale_dimension: typing.Optional[builtins.str] = None,
        scale_dimension_var: typing.Optional[builtins.str] = None,
        scale_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param placement: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        :param placement_var: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        :param scale: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param scale_dimension: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        :param scale_dimension_var: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        :param scale_var: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        :param x_position: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareCompositeImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__284251344fbf173c8869e392150554bd081700c469f3ca89d8e95939cf3b9f03)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument placement", value=placement, expected_type=type_hints["placement"])
            check_type(argname="argument placement_var", value=placement_var, expected_type=type_hints["placement_var"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument scale_dimension", value=scale_dimension, expected_type=type_hints["scale_dimension"])
            check_type(argname="argument scale_dimension_var", value=scale_dimension_var, expected_type=type_hints["scale_dimension_var"])
            check_type(argname="argument scale_var", value=scale_var, expected_type=type_hints["scale_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if placement is not None:
            self._values["placement"] = placement
        if placement_var is not None:
            self._values["placement_var"] = placement_var
        if scale is not None:
            self._values["scale"] = scale
        if scale_dimension is not None:
            self._values["scale_dimension"] = scale_dimension
        if scale_dimension_var is not None:
            self._values["scale_dimension_var"] = scale_dimension_var
        if scale_var is not None:
            self._values["scale_var"] = scale_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareCompositeImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareCompositeImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        '''
        result = self._values.get("placement")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement_var(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        '''
        result = self._values.get("placement_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        '''
        result = self._values.get("scale_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        '''
        result = self._values.get("scale_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        '''
        result = self._values.get("scale_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareComposite(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareCompositeImage",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareCompositeImage:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareCompositeImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareCompositeImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareCompositeImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__28a36beaef7595b198ef31da3120872a3140e94b1ef135d620e54f3cfe684184)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareCompositeImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareCompositeImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d045662fb2865b6f306066ace4bbf85e422f062e41fc6fe09a613c2040318047)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareCompositeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareCompositeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c67c6ba956c3c2214a3307f9243431c6bbbaebd9bb8df397bdc3a13488b28e9e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareCompositeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__99d6a34e8ae637daba86bb1bdb9e48447e256d6bd5f53a22d3fab3aed3566608)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareCompositeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3d6b5cf461d1941bf866f3f8401d423d272fd6440a8e6dfc24cb50f93161fcbd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__379a5849ec9c44295549a5638add73abab4a870a07437fe2008d6e2e0f2f2b10)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d7b23b6ece8f0ea131d3fbf8de75f96004acba89b65ea06a41f501f5b132bf3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareComposite]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareComposite]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2119cda1781c2b58fecc3cdb3fcaea7236dbc9be1c610d7ed260326a690d0004)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareCompositeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareCompositeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c21331aec94d94739f0fa97aaa02985b6b8b13929880455c2b3ecc790c84e4ce)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareCompositeImage()

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPlacement")
    def reset_placement(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacement", []))

    @jsii.member(jsii_name="resetPlacementVar")
    def reset_placement_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacementVar", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetScaleDimension")
    def reset_scale_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimension", []))

    @jsii.member(jsii_name="resetScaleDimensionVar")
    def reset_scale_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimensionVar", []))

    @jsii.member(jsii_name="resetScaleVar")
    def reset_scale_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareCompositeImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareCompositeImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareCompositeImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="placementInput")
    def placement_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementInput"))

    @builtins.property
    @jsii.member(jsii_name="placementVarInput")
    def placement_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionInput")
    def scale_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVarInput")
    def scale_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleVarInput")
    def scale_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__68ae2eed8fbc0c268b8e3aa96599adf554ca0b6f4a028abbc77487d01509952f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3fa4017dad689d8d02472ed397ae7ebf10111bee4eb6f594eb362dec240bb561)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="placement")
    def placement(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placement"))

    @placement.setter
    def placement(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d0f32a642ab5ed126374939d6bb07a9ef835e3fd4302a655df65f3a0fdeef886)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placement", value)

    @builtins.property
    @jsii.member(jsii_name="placementVar")
    def placement_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placementVar"))

    @placement_var.setter
    def placement_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4d93c5cd11da509cfc63d2d4e904d4ff00b27126b990a59644c98bcff1b24674)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placementVar", value)

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scale"))

    @scale.setter
    def scale(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__47efcd874362edecb0ef4303d048ebc477404dcd333d5dcab56c42aae5306133)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scale", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimension")
    def scale_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimension"))

    @scale_dimension.setter
    def scale_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__46f8c237bc68663b609cbea6b46b639f8a8a04b9868c22b9cca398f47b31b506)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimension", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVar")
    def scale_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimensionVar"))

    @scale_dimension_var.setter
    def scale_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__42bb38686dce40a410a7732d37382e7ae5697d8f67bb98737974ca76a50ca6f5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="scaleVar")
    def scale_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleVar"))

    @scale_var.setter
    def scale_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__89e0c2feb62c1fac6a6dfb8b43c79e5be7ebfc3c874f0807097d8b6cf6ffa802)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d60fef5d064a019b3531da29561a9183cee56d1c5c68e5bb6934cb0383b34f41)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__463537524534d2e3a7b2186b1a1a02e23c34a411c8df8ef3dc37ba7fce37cd40)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dd6776646be0af4b90b9870b5e635ba0a43eda0970c565d7e782941bd03f49ab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0b7186ad00fc735964f351b8cff63a574f93dc08653231245e954ac4bf33781c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareComposite]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareComposite]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareComposite]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__53197ad0d1c9462c98649ced6b0fa898199fa6958782379598d23ce82b6c30b9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareCompound",
    jsii_struct_bases=[],
    name_mapping={"transformations": "transformations"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareCompound:
    def __init__(
        self,
        *,
        transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param transformations: transformations block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__409f532f7ed10561c9905858f13ce26b7ca6de7b94138fea6c5d007377b97f6d)
            check_type(argname="argument transformations", value=transformations, expected_type=type_hints["transformations"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if transformations is not None:
            self._values["transformations"] = transformations

    @builtins.property
    def transformations(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareCompoundTransformations"]]]:
        '''transformations block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        result = self._values.get("transformations")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareCompoundTransformations"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareCompound(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareCompoundList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareCompoundList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a6ca4d660b4f3e2a21e6b11ade847928722c5d70a1b3ab0728ec1d24790c4670)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareCompoundOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__22b4052e233cc0c90a56c90880281bbe6176ef917f11e3e36189b56d91d349ea)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareCompoundOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f906791e97d90aedadc7d2f524723ccf5e8d7fe7b9b4ecd934410ad32dd0bf5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4b921c2205301005cf8217204d964eff5f687c4e89a7d7b245932547ff82c5cd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e0251cecd10e6090162c5b513cebc78077693466d65239ffea2678f3cf173303)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareCompound]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareCompound]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8795ce930a6d589acc5281678bcde54e7367ccd977c38cf4ab492b8266a25cac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareCompoundOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareCompoundOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d63ee38f27f5f6f043cbf070a4a0302f194bac9058ae5a08627fd39ca84e1139)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformations")
    def put_transformations(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a0967eaf4915f1de024ea7540cc750228dfbba5de8edff1fbad7234e5b369671)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTransformations", [value]))

    @jsii.member(jsii_name="resetTransformations")
    def reset_transformations(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformations", []))

    @builtins.property
    @jsii.member(jsii_name="transformations")
    def transformations(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareCompoundTransformationsList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareCompoundTransformationsList", jsii.get(self, "transformations"))

    @builtins.property
    @jsii.member(jsii_name="transformationsInput")
    def transformations_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareCompoundTransformations"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareCompoundTransformations"]]], jsii.get(self, "transformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareCompound]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareCompound]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareCompound]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__471485b13fa35bb990dd0d5cba25f36c7eff3c41530d3d31145d2cbe4577444d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareCompoundTransformations",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareCompoundTransformations:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareCompoundTransformations(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareCompoundTransformationsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareCompoundTransformationsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b7f24cef8f234a86957a290e412969fd01c22106eb61f46630d7d85cad4b843b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareCompoundTransformationsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ba8a95ca6f23754648d8379c5878df4f7b3f590a2f1676a7885e67d56fca4aeb)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareCompoundTransformationsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab504f55db1ea59521a401d01a529afacb21c1adbbaeabdc604cb3050c87323f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f24135376179b235b4acf14d1e8a68265e946b0a7c28c6dbf0ea66a7e41ab5a7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e0b469e59423a6b06e94ac4c844cc998d9e8a6b14e111dada06e384e27117c19)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareCompoundTransformations]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareCompoundTransformations]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareCompoundTransformations]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2f7efbe0d252d11d955618ac8475b6b020f5e52944e8bec33f7ba44f450b4b49)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareCompoundTransformationsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareCompoundTransformationsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e8c855f9d4a5bfce1dfaf041a53476687f042f969b16a07a69c4f0f5fe270abe)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareCompoundTransformations]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareCompoundTransformations]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareCompoundTransformations]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e79260610c67b8a65b4769cfac79ff03f4469466f8d19e169f23d78b4476017b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareContrast",
    jsii_struct_bases=[],
    name_mapping={
        "brightness": "brightness",
        "brightness_var": "brightnessVar",
        "contrast": "contrast",
        "contrast_var": "contrastVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareContrast:
    def __init__(
        self,
        *,
        brightness: typing.Optional[builtins.str] = None,
        brightness_var: typing.Optional[builtins.str] = None,
        contrast: typing.Optional[builtins.str] = None,
        contrast_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param brightness: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        :param brightness_var: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        :param contrast: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param contrast_var: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b594d5b78a0847bf84a6c384802e3c9254bd4204b631fc59125feb0ffc690a0b)
            check_type(argname="argument brightness", value=brightness, expected_type=type_hints["brightness"])
            check_type(argname="argument brightness_var", value=brightness_var, expected_type=type_hints["brightness_var"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument contrast_var", value=contrast_var, expected_type=type_hints["contrast_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if brightness is not None:
            self._values["brightness"] = brightness
        if brightness_var is not None:
            self._values["brightness_var"] = brightness_var
        if contrast is not None:
            self._values["contrast"] = contrast
        if contrast_var is not None:
            self._values["contrast_var"] = contrast_var

    @builtins.property
    def brightness(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        '''
        result = self._values.get("brightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def brightness_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        '''
        result = self._values.get("brightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        result = self._values.get("contrast_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareContrast(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareContrastList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareContrastList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f4db26e0568d5724ec625a2621c912083b595da95b9efa9947f339cb34d63916)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareContrastOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f03f8ff99463cead32bac78629a3ac8d803cd75fabff0e8cc0f9fa9f8055e52)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareContrastOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__94f105d50e73c39730a062fae0aa12e43d2b736ea58d71b05491ba2989a5de63)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1acbcf876c3b71712dc2d14dba52660ae16e05d53cf174377e666de86844fd5b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8d36722ef21fc5ee5ed64b201d6d206a85f1dcdd88ecaab1a778502b6b4364a0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareContrast]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareContrast]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4546fd33a7cfb12354248925e68cb8f8f50bd65569e6531ed5ac7fce66bf4d59)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareContrastOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareContrastOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5418de26c277206fd2dae33ac9b639440c93b6c96f771cb3369b46822d366df2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetBrightness")
    def reset_brightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightness", []))

    @jsii.member(jsii_name="resetBrightnessVar")
    def reset_brightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightnessVar", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetContrastVar")
    def reset_contrast_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrastVar", []))

    @builtins.property
    @jsii.member(jsii_name="brightnessInput")
    def brightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="brightnessVarInput")
    def brightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastVarInput")
    def contrast_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="brightness")
    def brightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightness"))

    @brightness.setter
    def brightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0463983e7394f4375172415ec0ec1b5c4dc4e87d71429cdf5b52e25cd02bbd23)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightness", value)

    @builtins.property
    @jsii.member(jsii_name="brightnessVar")
    def brightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightnessVar"))

    @brightness_var.setter
    def brightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bcf8d68fd66c54be8bc95d911cc7d3d1f0d674a6b38d37a1de667927b8824d41)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrast"))

    @contrast.setter
    def contrast(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f143527c656f63a3a9c699aad2af61b99cc0e7454f0046a4c2f19b59ea94c98a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrast", value)

    @builtins.property
    @jsii.member(jsii_name="contrastVar")
    def contrast_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrastVar"))

    @contrast_var.setter
    def contrast_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f45017f590c0e377873f30786b216ca1461c252c773a8add66fe01cee835bbc1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrastVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareContrast]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareContrast]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareContrast]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aaa6d71936e26ab851a2c9f8569843c6640da912aeff1ee46b7ef67249fa1849)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareGoop",
    jsii_struct_bases=[],
    name_mapping={
        "chaos": "chaos",
        "chaos_var": "chaosVar",
        "density": "density",
        "density_var": "densityVar",
        "power": "power",
        "power_var": "powerVar",
        "seed": "seed",
        "seed_var": "seedVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareGoop:
    def __init__(
        self,
        *,
        chaos: typing.Optional[builtins.str] = None,
        chaos_var: typing.Optional[builtins.str] = None,
        density: typing.Optional[builtins.str] = None,
        density_var: typing.Optional[builtins.str] = None,
        power: typing.Optional[builtins.str] = None,
        power_var: typing.Optional[builtins.str] = None,
        seed: typing.Optional[builtins.str] = None,
        seed_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param chaos: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        :param chaos_var: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        :param density: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        :param density_var: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        :param power: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        :param power_var: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        :param seed: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        :param seed_var: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__97de330d44411a7b9953fd1a34bdb5dd871efba51f73fcb1b2f1dc002bb95eb1)
            check_type(argname="argument chaos", value=chaos, expected_type=type_hints["chaos"])
            check_type(argname="argument chaos_var", value=chaos_var, expected_type=type_hints["chaos_var"])
            check_type(argname="argument density", value=density, expected_type=type_hints["density"])
            check_type(argname="argument density_var", value=density_var, expected_type=type_hints["density_var"])
            check_type(argname="argument power", value=power, expected_type=type_hints["power"])
            check_type(argname="argument power_var", value=power_var, expected_type=type_hints["power_var"])
            check_type(argname="argument seed", value=seed, expected_type=type_hints["seed"])
            check_type(argname="argument seed_var", value=seed_var, expected_type=type_hints["seed_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if chaos is not None:
            self._values["chaos"] = chaos
        if chaos_var is not None:
            self._values["chaos_var"] = chaos_var
        if density is not None:
            self._values["density"] = density
        if density_var is not None:
            self._values["density_var"] = density_var
        if power is not None:
            self._values["power"] = power
        if power_var is not None:
            self._values["power_var"] = power_var
        if seed is not None:
            self._values["seed"] = seed
        if seed_var is not None:
            self._values["seed_var"] = seed_var

    @builtins.property
    def chaos(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        '''
        result = self._values.get("chaos")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def chaos_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        '''
        result = self._values.get("chaos_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        '''
        result = self._values.get("density")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density_var(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        '''
        result = self._values.get("density_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        '''
        result = self._values.get("power")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power_var(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        '''
        result = self._values.get("power_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        '''
        result = self._values.get("seed")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed_var(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        result = self._values.get("seed_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareGoop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareGoopList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareGoopList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7af6a8c3308f83c5909fb99b97b5f5008a594a66c8c65c7223536a9913cc9eb4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareGoopOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2b38e531f5cf8e7e9de69b6ff7efcc39ef8db398224067416936d7ee78aa6a57)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareGoopOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__27472b9eb34470f16ca2b800d7ab556eff2dc23ffb3b5dffe516cea7205b41e2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__39716902f6138be201cc57355bb08e905fcca1dc549c02d43d57bb733d4801a1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__57c91723c91a40612aeb789b704ff2d68c03837e2703f2d84186e247d765263f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareGoop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareGoop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__471112fea2e8fd8089ab4d4daed85177c372ac33761ab0c1c871ae01c2054ee8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareGoopOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareGoopOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fc93caf5e73cab480492943b049a5b091e0b8bb0efe2c319930af06594f83c3c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetChaos")
    def reset_chaos(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaos", []))

    @jsii.member(jsii_name="resetChaosVar")
    def reset_chaos_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaosVar", []))

    @jsii.member(jsii_name="resetDensity")
    def reset_density(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensity", []))

    @jsii.member(jsii_name="resetDensityVar")
    def reset_density_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensityVar", []))

    @jsii.member(jsii_name="resetPower")
    def reset_power(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPower", []))

    @jsii.member(jsii_name="resetPowerVar")
    def reset_power_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPowerVar", []))

    @jsii.member(jsii_name="resetSeed")
    def reset_seed(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeed", []))

    @jsii.member(jsii_name="resetSeedVar")
    def reset_seed_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeedVar", []))

    @builtins.property
    @jsii.member(jsii_name="chaosInput")
    def chaos_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosInput"))

    @builtins.property
    @jsii.member(jsii_name="chaosVarInput")
    def chaos_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosVarInput"))

    @builtins.property
    @jsii.member(jsii_name="densityInput")
    def density_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityInput"))

    @builtins.property
    @jsii.member(jsii_name="densityVarInput")
    def density_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="powerInput")
    def power_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerInput"))

    @builtins.property
    @jsii.member(jsii_name="powerVarInput")
    def power_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerVarInput"))

    @builtins.property
    @jsii.member(jsii_name="seedInput")
    def seed_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedInput"))

    @builtins.property
    @jsii.member(jsii_name="seedVarInput")
    def seed_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedVarInput"))

    @builtins.property
    @jsii.member(jsii_name="chaos")
    def chaos(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaos"))

    @chaos.setter
    def chaos(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dddb5a589bb603dc7d4f53aa2b43c698a075c7beb8b08f6ef87553759df9a1d3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaos", value)

    @builtins.property
    @jsii.member(jsii_name="chaosVar")
    def chaos_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaosVar"))

    @chaos_var.setter
    def chaos_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__203ddb20fb5ed98da28cce17d57092b4170aa15a4205b8d909ae755def59b5cb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaosVar", value)

    @builtins.property
    @jsii.member(jsii_name="density")
    def density(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "density"))

    @density.setter
    def density(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__732011ea5e34cbdd45aaf47328b1426f834bd9e567eef3820671dfe9363d64a9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "density", value)

    @builtins.property
    @jsii.member(jsii_name="densityVar")
    def density_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "densityVar"))

    @density_var.setter
    def density_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3d1901666fdb42ee249041ae926ed3d439647c566acd52d08de7ae0baf1414fd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "densityVar", value)

    @builtins.property
    @jsii.member(jsii_name="power")
    def power(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "power"))

    @power.setter
    def power(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1922f3f6fc30fb78588a0d2049e796d99b7d072c99f3167c3db2d16067bff23e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "power", value)

    @builtins.property
    @jsii.member(jsii_name="powerVar")
    def power_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "powerVar"))

    @power_var.setter
    def power_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__91d9b96399a05ac63d8c6f7b0bb8a54aac1b8c7c98e359f6e98c351bf85f1c57)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "powerVar", value)

    @builtins.property
    @jsii.member(jsii_name="seed")
    def seed(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seed"))

    @seed.setter
    def seed(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3fc7ec431dd502786d482afce27ceed0ee63d1c45abd2e8067bf74ecc05c1e9b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seed", value)

    @builtins.property
    @jsii.member(jsii_name="seedVar")
    def seed_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seedVar"))

    @seed_var.setter
    def seed_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e482d2cf6264fe8b8efdf967e1d36e099514b4f1d33c76830bd0b38bd2a17078)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seedVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareGoop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareGoop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareGoop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cff1fc8fcf3597f0cc6172f0abb0cd73777198ab493d205744f7dbef4a610f1b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareGrayscale",
    jsii_struct_bases=[],
    name_mapping={"type": "type", "type_var": "typeVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareGrayscale:
    def __init__(
        self,
        *,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param type: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9db159671120825cd8835c569237e15db215e3de2dba6fb5b8204ebad6ceabda)
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareGrayscale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareGrayscaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareGrayscaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0d15ea0b28868912343c57c9ece71946d651c9bef185b6979d963b1e093a667b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareGrayscaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f55e6e70ad7f9f52d63a718282cb84e609b8a33d375b793dc0eabc1f8d54cad8)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareGrayscaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__258238bf018d94ba5b243893a29142dfd1ac2f48e08ef5e86cec361f2c07b788)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5c4e2214f4f78b59f5618acf353b9d95bd4b0c0b23f7152dfa9d373338d7d9bb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd1db428f5df3e97c2234d6f851ceca2c528880db53bfdbe0a40e0a2d0eec5e3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareGrayscale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareGrayscale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__31db496a065f0d63746dd40dfcc378340a79308e46e4086078edebd8e8a6a20a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareGrayscaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareGrayscaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d0c081850b2deadbcba950ca3c65f481f1440c475fdf9a821f4992f8b765b2b2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6649de040bfcdb20d5f9882446cb8289db27c0e3928c798469c61d7af7841dd0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5efdd3fda789da1ecfb5f528241a3fb688a2f9115bb1f9ea9d64fc20fd9e3d12)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareGrayscale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareGrayscale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareGrayscale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f96d0621dad307464af8a6451dbf13aca4c90093ad5532cc8338946e89f4c197)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareHsl",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "lightness": "lightness",
        "lightness_var": "lightnessVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareHsl:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness: typing.Optional[builtins.str] = None,
        lightness_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        :param lightness_var: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4abb1884d9ba1acf04daa7acf3d802443687f17ff6c4c559b1860b7f9de6a454)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness", value=lightness, expected_type=type_hints["lightness"])
            check_type(argname="argument lightness_var", value=lightness_var, expected_type=type_hints["lightness_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness is not None:
            self._values["lightness"] = lightness
        if lightness_var is not None:
            self._values["lightness_var"] = lightness_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        '''
        result = self._values.get("lightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        '''
        result = self._values.get("lightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareHsl(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareHslList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareHslList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d5c4b297e1424ac887fc77908bc6344529c06577e0f04c16435ae3825406863f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareHslOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a6399704bfa3ce4c7a316c1f1433602eefe280e798b26bf9d70c554f9cb65f0)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareHslOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__952af77999d325fc73358c853eb46ee35a4747679a22646db882e72a9ebf586b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b0685b56186f6e105b05591d6f0d5b5f63c6806e21db2701aa660516fc595e05)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f624446e3101e5eebcebf8c2003b7f56b95e6b6107baeaef483e3661b7c2b76)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareHsl]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareHsl]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__07b758fe8fb1d3f6ff1db7cba287d8debcc1fece35e64815da5161d1c4d24919)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareHslOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareHslOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8190f08cbcb8db399317806fe7f4e5748c763d7e8b6b73c34558e423f158e2c1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightness")
    def reset_lightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightness", []))

    @jsii.member(jsii_name="resetLightnessVar")
    def reset_lightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessInput")
    def lightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessVarInput")
    def lightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3e95c7d178fd685e952319d0bed57905762beb2429ea1b064570177e9f784eb0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__28f25967562fd5a15c94ff1b1d7dd4b675580afbf214419dea04edfbb6158c42)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightness")
    def lightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightness"))

    @lightness.setter
    def lightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2686a216ff390c8e842862aaf662ad920b4d1cc3d807713978db1942ab855761)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightness", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessVar")
    def lightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessVar"))

    @lightness_var.setter
    def lightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__84217a7eb1470f920cfc995f835487166e00ba6ffaeb7a596a7858ff4114736d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__210a5269d4e0d7d0818b81378e473a4151a009c16a2e05faa024032ec80eca68)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__28e71db58eae8fa2566f4d031adf822d62d4626f247cd6a72fdc40588146fb34)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareHsl]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareHsl]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareHsl]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0a4c14ce2c1cbe7aa96637dcf16f88bd8cf982cc8c0298045c188e31d4c6821e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareHsv",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareHsv:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        :param value: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__66f84e9a7fdd60f83962fa9faffc35100f02c69c15d7eaeae9afcc2056f03bf5)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareHsv(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareHsvList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareHsvList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b4341a634d9a6878026b640191fa6f1382fe3ef2caf797fac5d5f1c8f4d13b80)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareHsvOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6c183c64d8ce11495b5c2fd36261307766c4aabdd821dd314c1e026bac6d85cb)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareHsvOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e8f22a249355737210fbac87a9556eb83e35b149ba3eef25037acb0c013ca8c6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f2fc21f0e1647e0f45348626a21b1d78cf619ac39a5833894462ea243fac2b7a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1d8fa3bae57f76e9b5c2ed89fffa735873682e908912369001b7c6f3f6ac9db4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareHsv]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareHsv]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__52b7a5cad29dce33f1c6b3760e4b86b2c4668cfddd41cd1b0711c5aa6c7e99ff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareHsvOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareHsvOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a38b60e920c1d041273cb95283d473c72e56109188d4ca800d862b2e539fc14)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f9ffbf97204fd063c49205ba734e89edec75069bdc3f9e39352df3d8b8150da)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9b72dc7ea1bf5284483fd25bd67c3478569046abdfae03c14062f11eb037d33b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0e4ecdf202a2882c9238ae3287a159545a387d7cf686a5b4ebb7669ad6a8b839)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d413954f6fcd0b1e47705a3ae30abd927198db0fb01b27f18822b43a1faba4b6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3faf3d8504f72c9783f9a5ca601323976f670fc4745b58c016383b9fd17dbb05)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0cab4f9a99c914ac6a9fc4cc30a57b5d943d9c35c83d5b8a78168cf6a331ed35)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareHsv]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareHsv]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareHsv]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__81a8c92ad1d47d80d777ddd07b788ca9e1745797e1aa271519723b64db8dde81)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimension",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "dimension": "dimension",
        "dimension_var": "dimensionVar",
        "equal": "equal",
        "greater_than": "greaterThan",
        "less_than": "lessThan",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimension:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        dimension: typing.Optional[builtins.str] = None,
        dimension_var: typing.Optional[builtins.str] = None,
        equal: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionEqual", typing.Dict[builtins.str, typing.Any]]] = None,
        greater_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionGreaterThan", typing.Dict[builtins.str, typing.Any]]] = None,
        less_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionLessThan", typing.Dict[builtins.str, typing.Any]]] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param dimension: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        :param dimension_var: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        :param equal: equal block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        :param greater_than: greater_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        :param less_than: less_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        :param value: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionDefault(**default)
        if isinstance(equal, dict):
            equal = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionEqual(**equal)
        if isinstance(greater_than, dict):
            greater_than = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionGreaterThan(**greater_than)
        if isinstance(less_than, dict):
            less_than = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionLessThan(**less_than)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fc03a3fcfcd891c12167e5984939f546e95ada9a75d5e0adf8f468f298e5f1c0)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument dimension", value=dimension, expected_type=type_hints["dimension"])
            check_type(argname="argument dimension_var", value=dimension_var, expected_type=type_hints["dimension_var"])
            check_type(argname="argument equal", value=equal, expected_type=type_hints["equal"])
            check_type(argname="argument greater_than", value=greater_than, expected_type=type_hints["greater_than"])
            check_type(argname="argument less_than", value=less_than, expected_type=type_hints["less_than"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if dimension is not None:
            self._values["dimension"] = dimension
        if dimension_var is not None:
            self._values["dimension_var"] = dimension_var
        if equal is not None:
            self._values["equal"] = equal
        if greater_than is not None:
            self._values["greater_than"] = greater_than
        if less_than is not None:
            self._values["less_than"] = less_than
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionDefault"], result)

    @builtins.property
    def dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        '''
        result = self._values.get("dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        '''
        result = self._values.get("dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def equal(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionEqual"]:
        '''equal block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        '''
        result = self._values.get("equal")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionEqual"], result)

    @builtins.property
    def greater_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionGreaterThan"]:
        '''greater_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        '''
        result = self._values.get("greater_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionGreaterThan"], result)

    @builtins.property
    def less_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionLessThan"]:
        '''less_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        '''
        result = self._values.get("less_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionLessThan"], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimension(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c2af1e765a0775fa662d7012ca93a27d14b823f141813aa9e84baa857e275fd1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__090aaaf50671ef5407f504d7c5b8b31d0a485e77a5eba4b790b4003f7f312623)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionEqual",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionEqual:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionEqual(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionEqualOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionEqualOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac2261d6e3e51090cdc59e941f80d8e39a0b2441e99327f12084a082b1c187c1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionEqual], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionEqual],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__249fd8bed6cd76383bb151fbf50160ba588e082a58437e55a14656dd8e7bafd2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionGreaterThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionGreaterThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionGreaterThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionGreaterThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionGreaterThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e30b9515c67e8708d9d94be3616792f6f1dbb39fa50e0f5b7b5415b1b2a27786)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionGreaterThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionGreaterThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5fed07e46885bd37f5c4d89f403b6eb189c265abbb70be5e8bb50023fa253e90)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionLessThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionLessThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionLessThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionLessThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionLessThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__560f1ee9d322a1d26f898d3443f09e13d5ec70cdf6e5549fef7ecb04fd0f0903)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionLessThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionLessThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__58ad6d38c1183a11c3a040663bd81ebdb7afbd657c5bd190bbaf7fdda0f7dda5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8af8a62862326115568c54567ccbe5dc388e4075b5fbcd9ca3d178fbedf073be)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6438d3a2f5ed04364d832a26ce3ab4128090f4e0b8384adc8d62bbca0a1c1b43)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8e92f01d16c0846bbb6d416634580fa72f8ecd6c4a36666390b966be67455eb0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7ea972c19e0c7296215ffb1743adc5da16d4edd30cb7e180a5da1b24c43e0609)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ed6af028963bef429b0677be5d221bbd4d6dc7f007e87507a159718c662a6496)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimension]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimension]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d7aa453e5d3407441337fd976587df9963546d65f69537d63c677e322e93896c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f6fd532257d0ddadc8696a11add1d96c799f74fbe52dc2101ac7ef3eb9ba274c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putEqual")
    def put_equal(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionEqual()

        return typing.cast(None, jsii.invoke(self, "putEqual", [value]))

    @jsii.member(jsii_name="putGreaterThan")
    def put_greater_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionGreaterThan()

        return typing.cast(None, jsii.invoke(self, "putGreaterThan", [value]))

    @jsii.member(jsii_name="putLessThan")
    def put_less_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionLessThan()

        return typing.cast(None, jsii.invoke(self, "putLessThan", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetDimension")
    def reset_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimension", []))

    @jsii.member(jsii_name="resetDimensionVar")
    def reset_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimensionVar", []))

    @jsii.member(jsii_name="resetEqual")
    def reset_equal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEqual", []))

    @jsii.member(jsii_name="resetGreaterThan")
    def reset_greater_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGreaterThan", []))

    @jsii.member(jsii_name="resetLessThan")
    def reset_less_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLessThan", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="equal")
    def equal(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionEqualOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionEqualOutputReference, jsii.get(self, "equal"))

    @builtins.property
    @jsii.member(jsii_name="greaterThan")
    def greater_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionGreaterThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionGreaterThanOutputReference, jsii.get(self, "greaterThan"))

    @builtins.property
    @jsii.member(jsii_name="lessThan")
    def less_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionLessThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionLessThanOutputReference, jsii.get(self, "lessThan"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionInput")
    def dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionVarInput")
    def dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="equalInput")
    def equal_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionEqual], jsii.get(self, "equalInput"))

    @builtins.property
    @jsii.member(jsii_name="greaterThanInput")
    def greater_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionGreaterThan], jsii.get(self, "greaterThanInput"))

    @builtins.property
    @jsii.member(jsii_name="lessThanInput")
    def less_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionLessThan], jsii.get(self, "lessThanInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="dimension")
    def dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimension"))

    @dimension.setter
    def dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6cf3ba2b532d20183699759d646f857c73a69412f46d14a6f893a3f2a4e75766)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimension", value)

    @builtins.property
    @jsii.member(jsii_name="dimensionVar")
    def dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimensionVar"))

    @dimension_var.setter
    def dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e1b461d951cc799b24f48ade69e4b39332a3b0412f04789a771500e6c1a768b9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__546518542f3608cbd88915d680e075181cc7184c66108d3e07fe37b6853061d5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__041f0495feaace07f39845c55c6f54870c74cb70c131cb7e244c2ad4727847e5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimension]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimension]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimension]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__87884da90a57c6892515bfeeeb56ba7d66a4e97febc3df70bec42c100d594f4b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientation",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "landscape": "landscape",
        "portrait": "portrait",
        "square": "square",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientation:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        landscape: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationLandscape", typing.Dict[builtins.str, typing.Any]]] = None,
        portrait: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationPortrait", typing.Dict[builtins.str, typing.Any]]] = None,
        square: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationSquare", typing.Dict[builtins.str, typing.Any]]] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param landscape: landscape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        :param portrait: portrait block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        :param square: square block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationDefault(**default)
        if isinstance(landscape, dict):
            landscape = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationLandscape(**landscape)
        if isinstance(portrait, dict):
            portrait = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationPortrait(**portrait)
        if isinstance(square, dict):
            square = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationSquare(**square)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3b72dfd9467e1e8c67ecdbeb3923f8a8108f341d357d09ed869b68bff009a2ca)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument landscape", value=landscape, expected_type=type_hints["landscape"])
            check_type(argname="argument portrait", value=portrait, expected_type=type_hints["portrait"])
            check_type(argname="argument square", value=square, expected_type=type_hints["square"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if landscape is not None:
            self._values["landscape"] = landscape
        if portrait is not None:
            self._values["portrait"] = portrait
        if square is not None:
            self._values["square"] = square

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationDefault"], result)

    @builtins.property
    def landscape(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationLandscape"]:
        '''landscape block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        '''
        result = self._values.get("landscape")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationLandscape"], result)

    @builtins.property
    def portrait(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationPortrait"]:
        '''portrait block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        '''
        result = self._values.get("portrait")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationPortrait"], result)

    @builtins.property
    def square(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationSquare"]:
        '''square block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        result = self._values.get("square")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationSquare"], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a8572f245e924c086d93ff23b5514658606b2ef15bf9195442dc8be223c1b6bf)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ab00241015dfbc1fff47a32c9d02f55a729ae0e764023cda8e6ed889ebfa4c0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationLandscape",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationLandscape:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationLandscape(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationLandscapeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationLandscapeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__43fa8eab2a043ab4a2fea88d4c87e5fb6581ca44da18bb28e88b4f3df3ee2c40)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationLandscape], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationLandscape],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9fb107a20b737d1dea9ecfd509c429b8c23962991cd2d68339b8701487969ecc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8e395c2288d175026ac8c5322c9a553fadefaca21c5dbc6609f30add3e591d8c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__465e6e49e65a898fa1ab7d7110cd8160b2dd4a90894dcc6e10db887cdc86ba11)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__06c65b272295ea93ef923fe15d4e1347727a2badf2b2de5557021d945330d545)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__23652a7dc6bb234167c969208a04f0f192c9807740c01895c2cf3bfa51a8581c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b22153e6eaad69725aff52b96c77bdc82cceeec1d1864864a9b49b50e27439c3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientation]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientation]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1b08185e329ada21621ff1e08ff920c2785f45525bf556020edb885065becd4e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ef046de13fece00de4ed87ea1785cd3a1fc0b37d14e70fc275ede5ed0f3ae10)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putLandscape")
    def put_landscape(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationLandscape()

        return typing.cast(None, jsii.invoke(self, "putLandscape", [value]))

    @jsii.member(jsii_name="putPortrait")
    def put_portrait(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationPortrait()

        return typing.cast(None, jsii.invoke(self, "putPortrait", [value]))

    @jsii.member(jsii_name="putSquare")
    def put_square(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationSquare()

        return typing.cast(None, jsii.invoke(self, "putSquare", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetLandscape")
    def reset_landscape(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLandscape", []))

    @jsii.member(jsii_name="resetPortrait")
    def reset_portrait(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPortrait", []))

    @jsii.member(jsii_name="resetSquare")
    def reset_square(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSquare", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="landscape")
    def landscape(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationLandscapeOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationLandscapeOutputReference, jsii.get(self, "landscape"))

    @builtins.property
    @jsii.member(jsii_name="portrait")
    def portrait(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationPortraitOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationPortraitOutputReference", jsii.get(self, "portrait"))

    @builtins.property
    @jsii.member(jsii_name="square")
    def square(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationSquareOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationSquareOutputReference", jsii.get(self, "square"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="landscapeInput")
    def landscape_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationLandscape], jsii.get(self, "landscapeInput"))

    @builtins.property
    @jsii.member(jsii_name="portraitInput")
    def portrait_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationPortrait"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationPortrait"], jsii.get(self, "portraitInput"))

    @builtins.property
    @jsii.member(jsii_name="squareInput")
    def square_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationSquare"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationSquare"], jsii.get(self, "squareInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientation]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientation]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientation]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__83884782ecc15a014d907a93eb792e240c17055dc668eda94d4dc9454e21e306)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationPortrait",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationPortrait:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationPortrait(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationPortraitOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationPortraitOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d4476d6e0f76fe91719dc09795614ba150f43ccffd64521ac481dfaeb9c44673)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationPortrait]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationPortrait], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationPortrait],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__80ce901933e883da00f87acbe75bfeb7f9a84ddafe6ca91bb1c6ef2c4955a653)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationSquare",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationSquare:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationSquare(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationSquareOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationSquareOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c90d00b2157f5a869e484743d3aba545650801f222722a4ba4250e762b4523e6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationSquare]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationSquare], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationSquare],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__07e31f0357967779e451c9867e25a424467c93cacf8d1b04a77bc4f9fc68913e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareMaxColors",
    jsii_struct_bases=[],
    name_mapping={"colors": "colors", "colors_var": "colorsVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareMaxColors:
    def __init__(
        self,
        *,
        colors: typing.Optional[builtins.str] = None,
        colors_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param colors: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        :param colors_var: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__76a5edce4388697dbcba16ff1d9490cb8e0729ab8ae0a7cbb3e6e5c9fa9fbecd)
            check_type(argname="argument colors", value=colors, expected_type=type_hints["colors"])
            check_type(argname="argument colors_var", value=colors_var, expected_type=type_hints["colors_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if colors is not None:
            self._values["colors"] = colors
        if colors_var is not None:
            self._values["colors_var"] = colors_var

    @builtins.property
    def colors(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        '''
        result = self._values.get("colors")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def colors_var(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        result = self._values.get("colors_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareMaxColors(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareMaxColorsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareMaxColorsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__86c7321e8d7b066a897c9fbb8ed35b775b5e7440f025190579d3a6e5aef36f88)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareMaxColorsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b724ac88806e3fb25660de7cfbb43877c6aa33038b9927867bf0240cd5111142)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareMaxColorsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a212cd532de63b0d1ea4424fbd5be46e00b317cdd878faa1e9caa14a208cbb14)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4702ebac34783bd3e6c148389bce35cfdfdd0e32d7b5b223251b8c67bb79758e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ce5ef6ff1e5e14218d2fd7bd0049e518ea50f54690c6f0e1ea4e7523f5a33f0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareMaxColors]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareMaxColors]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a58860cc7ad1d62deeb04a50af708aec212c3cddd3301195fa8ec326b37fe0b1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareMaxColorsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareMaxColorsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2be1a773b766444cbb38f646ae3b219575e94c5f69f270d338aacb8efd2f5ff5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColors")
    def reset_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColors", []))

    @jsii.member(jsii_name="resetColorsVar")
    def reset_colors_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorsVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorsInput")
    def colors_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsInput"))

    @builtins.property
    @jsii.member(jsii_name="colorsVarInput")
    def colors_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsVarInput"))

    @builtins.property
    @jsii.member(jsii_name="colors")
    def colors(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colors"))

    @colors.setter
    def colors(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__884299e837fd023f0a5dcb9c056c6a66eb0647e4bf42863bcffa519efd06617f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colors", value)

    @builtins.property
    @jsii.member(jsii_name="colorsVar")
    def colors_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorsVar"))

    @colors_var.setter
    def colors_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2f62fdee8f909eb0b180bb9796133d162728d3c4d43c7f63c20ac3d4da7521e3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorsVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareMaxColors]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareMaxColors]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareMaxColors]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eb3ca1a5c227da001cca083fc4036f4d0aaa688a28dddaf1e220033bbbb20027)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareMirror",
    jsii_struct_bases=[],
    name_mapping={
        "horizontal": "horizontal",
        "horizontal_var": "horizontalVar",
        "vertical": "vertical",
        "vertical_var": "verticalVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareMirror:
    def __init__(
        self,
        *,
        horizontal: typing.Optional[builtins.str] = None,
        horizontal_var: typing.Optional[builtins.str] = None,
        vertical: typing.Optional[builtins.str] = None,
        vertical_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param horizontal: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        :param horizontal_var: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        :param vertical: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        :param vertical_var: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__96aaf2aa22b68d2030c0443eddabb9b5ae43c4dddaa42d2a91bc657f7a482b70)
            check_type(argname="argument horizontal", value=horizontal, expected_type=type_hints["horizontal"])
            check_type(argname="argument horizontal_var", value=horizontal_var, expected_type=type_hints["horizontal_var"])
            check_type(argname="argument vertical", value=vertical, expected_type=type_hints["vertical"])
            check_type(argname="argument vertical_var", value=vertical_var, expected_type=type_hints["vertical_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if horizontal is not None:
            self._values["horizontal"] = horizontal
        if horizontal_var is not None:
            self._values["horizontal_var"] = horizontal_var
        if vertical is not None:
            self._values["vertical"] = vertical
        if vertical_var is not None:
            self._values["vertical_var"] = vertical_var

    @builtins.property
    def horizontal(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        '''
        result = self._values.get("horizontal")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def horizontal_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        '''
        result = self._values.get("horizontal_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        '''
        result = self._values.get("vertical")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        result = self._values.get("vertical_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareMirror(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareMirrorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareMirrorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2be8685bab3f0b8d1df387f70cb37b23316983429d8bec3ad61e96a18c6a3cf3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareMirrorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6caf82b5ae802a59e43317a8eb41e8d1be15e620dfaa095cb8f8c871f3aba2f2)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareMirrorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c694148711da528ff050974437acdab3ab14fc154f9cabc2189b5a576cb78dcb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__348318c3f8fc4781b70a3ed41ef15a3382352b627cf8ccbe1653486d00a816da)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab1f975b1f18e20f9c734f9be00cc61ea5c7204a94004d0577d3e928141a7eae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareMirror]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareMirror]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8eed1ff13708ca82f9b27760209d76aaa38ee9e7b72adb27c5fd5885ede4cabd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareMirrorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareMirrorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__61536256546464341096ed8a7d8df95d252a81c6ef1a990fe5745cf96d16d82a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHorizontal")
    def reset_horizontal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontal", []))

    @jsii.member(jsii_name="resetHorizontalVar")
    def reset_horizontal_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontalVar", []))

    @jsii.member(jsii_name="resetVertical")
    def reset_vertical(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVertical", []))

    @jsii.member(jsii_name="resetVerticalVar")
    def reset_vertical_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVerticalVar", []))

    @builtins.property
    @jsii.member(jsii_name="horizontalInput")
    def horizontal_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontalVarInput")
    def horizontal_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalInput")
    def vertical_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalVarInput")
    def vertical_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontal")
    def horizontal(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontal"))

    @horizontal.setter
    def horizontal(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ef926cecd5db69c42e4586ebea65796de303ac8a16fb37655b11e8c56e1f4394)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontal", value)

    @builtins.property
    @jsii.member(jsii_name="horizontalVar")
    def horizontal_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontalVar"))

    @horizontal_var.setter
    def horizontal_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ddacf2a4fff62e22114f4d0b5d578edd2968ffb48ee5998dfbf2760a33841345)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontalVar", value)

    @builtins.property
    @jsii.member(jsii_name="vertical")
    def vertical(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "vertical"))

    @vertical.setter
    def vertical(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__69b164b82462d3923de3c761881966e758763f3f3333189caafd789792b4d2ca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "vertical", value)

    @builtins.property
    @jsii.member(jsii_name="verticalVar")
    def vertical_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "verticalVar"))

    @vertical_var.setter
    def vertical_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e21cbab26b05405193561b2dfcae28f5b416395d1949e6393cb8b8dd5e77b493)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "verticalVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareMirror]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareMirror]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareMirror]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b62c95db8016636b6ead248bdd91e73fa84431f79bad08a1385f5e83df24530a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareMonoHue",
    jsii_struct_bases=[],
    name_mapping={"hue": "hue", "hue_var": "hueVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareMonoHue:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__54df5758b6ee7e5720f0bc1e213f7624d1f7d8a9bc460815dec16a58eab34996)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareMonoHue(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareMonoHueList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareMonoHueList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fab20cc6a5cd76f90461a9360c9034d97d28d034d18c62c3ed5e5afd283ad3f4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareMonoHueOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__abc2e10dc7431ba5f757902a1522b96db0755d81d5ed153b8e49b30d9fd02918)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareMonoHueOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__37ecb02b5c4af69e2388093ad8c9c84a2caa186629e2277725e237e48f00aa9f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c9aca6deff7c48cd852b32516197a6a36e9733b6778cc48e4bdcabd4a2dd1714)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7e8fd9a2db8a88f0681ce1975dc00548b62e0df0a501b1f21be7aed7de63bb6b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareMonoHue]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareMonoHue]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2c3357495646537825d40f782534d48e98df4feebd38eace511edac42d340e81)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareMonoHueOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareMonoHueOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__268f52aac196d9aa97f07ea52241f0495579dfcb40c06125c216b6c40dfd319f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fdec3505dfac07069a5a3e9edee18386433f423d0c8876ac54ede07b1f54a0f7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0f68ec3348aa4ac0fd3328c14644ac4e52f6d64c435e912d47b7a1464a358ac3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareMonoHue]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareMonoHue]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareMonoHue]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c6cc8f40888a145c5164384077632788149729a4c20038f31437d34e06888946)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareOpacity",
    jsii_struct_bases=[],
    name_mapping={"opacity": "opacity", "opacity_var": "opacityVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareOpacity:
    def __init__(
        self,
        *,
        opacity: typing.Optional[builtins.str] = None,
        opacity_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param opacity: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param opacity_var: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__32011f9428034b519da7c3487a184ec7100eeb51c61ce1ee68e53dade7a4afb4)
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument opacity_var", value=opacity_var, expected_type=type_hints["opacity_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if opacity is not None:
            self._values["opacity"] = opacity
        if opacity_var is not None:
            self._values["opacity_var"] = opacity_var

    @builtins.property
    def opacity(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def opacity_var(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        result = self._values.get("opacity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareOpacity(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareOpacityList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareOpacityList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2edcb5193eaa9c44a0e05ade2ef43f10b65c479916fca0d900e564714bc830be)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareOpacityOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__08ce1e30b4d6ef06c3409c1d8c6fb0b235ad90854014b06c48fa2c603b8f0e0d)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareOpacityOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d3ed40742ee4216e94b5b0befe9188645fa695b3420f666657ebcb59e215a102)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e2a5c38f1196e90a1d3b7618ea6924aa2badadc14ef122b5370c64b772dde08a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7f64a9073c5d6d24f7bc36a5934352176f8975f13f5d8f93d05120eeabc4e134)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareOpacity]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareOpacity]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aceeace7fe809f6649988b7d0273a854d28f74bfedeb61a6ff956eea7a26c854)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareOpacityOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareOpacityOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6499750e40add33266f21b185d678e3c26e1ccbab07690b09b33d5dbe207ae2a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetOpacityVar")
    def reset_opacity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacityVar", []))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityVarInput")
    def opacity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacity"))

    @opacity.setter
    def opacity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__52dd0935f18d0f51252d1096e253a7bda1e322a358e398b059564c6e488ee82f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacity", value)

    @builtins.property
    @jsii.member(jsii_name="opacityVar")
    def opacity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacityVar"))

    @opacity_var.setter
    def opacity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5fcd13cf84e244fb8a177109e624d8f2b438db709f174fcc5d99f32386a0a762)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacityVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareOpacity]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareOpacity]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareOpacity]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f0691bed645baadaaa50bdf976447fa1dd0ea10e6743fa7a9b54ea5d67310af1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6d2923b73e77e3d5d6df74b8d39d5f927d696fc638ed50b60e3319c6f30923de)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putBackgroundColor")
    def put_background_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b10ddc741a2e826f98d1fe4a7d8abf0f27d7a0c19dd7cc4125ba257d4e55ba8a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBackgroundColor", [value]))

    @jsii.member(jsii_name="putBlur")
    def put_blur(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareBlur, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d09c4c0cec6c6a576df472bd30640af85910f4f0aa3bf561b9f16b609aaaf572)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBlur", [value]))

    @jsii.member(jsii_name="putChromaKey")
    def put_chroma_key(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareChromaKey, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f0be2d96260f8beb5590380823d9860b61acf3127b05cca4803100df353e9a10)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putChromaKey", [value]))

    @jsii.member(jsii_name="putComposite")
    def put_composite(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareComposite, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__082d697b7e037311b36869be7dcc9f3fdd629eaa08bf9f82112d10bb77e04949)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putComposite", [value]))

    @jsii.member(jsii_name="putCompound")
    def put_compound(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareCompound, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ead02bec4131042fdf560280b73fd87647af85a1db653a4e9ad1c99dcc809e7b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCompound", [value]))

    @jsii.member(jsii_name="putContrast")
    def put_contrast(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareContrast, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__03bec5e91ff63900eed74a406f0521ef7a380c729bb2236f59260fac26d10672)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putContrast", [value]))

    @jsii.member(jsii_name="putGoop")
    def put_goop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareGoop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a9d1bb5ff7ae596c4686b9fd01e2ea48cc9487c45db6e0fa24b14d72a65ac78d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGoop", [value]))

    @jsii.member(jsii_name="putGrayscale")
    def put_grayscale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareGrayscale, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__515af96ca581b88d7c8c3ca301ad9369909b8ec23c30ff8610ecbde62e130faa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGrayscale", [value]))

    @jsii.member(jsii_name="putHsl")
    def put_hsl(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareHsl, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a01a163b7c7a586617883d91cf979f3f6084ab5b72198bb223be63d03c486ad3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsl", [value]))

    @jsii.member(jsii_name="putHsv")
    def put_hsv(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareHsv, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a533d231a46d11c600de0c5c9b39364782a08e89b917da74db5d39e9c2db5146)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsv", [value]))

    @jsii.member(jsii_name="putIfDimension")
    def put_if_dimension(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimension, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d82745d0e5b3252c2107231059e93e6fcafe9fc3341507582dc3ea63e9787e0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfDimension", [value]))

    @jsii.member(jsii_name="putIfOrientation")
    def put_if_orientation(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__51e8d31371234efae1138b9b00178f5a5d23521f743316fc364b8d6f65a2d1a1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfOrientation", [value]))

    @jsii.member(jsii_name="putMaxColors")
    def put_max_colors(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareMaxColors, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ce61bd978ea90ec30048ac62f62b156d2cebe373bf6faabcbe13247135d17843)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMaxColors", [value]))

    @jsii.member(jsii_name="putMirror")
    def put_mirror(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareMirror, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__28e834776b95bbd5862579e780ba1553a8337be7391a4e2955dbbb5e654c6ea4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMirror", [value]))

    @jsii.member(jsii_name="putMonoHue")
    def put_mono_hue(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareMonoHue, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b041738cb122371b7b96164f3f54fbaa8207f793bd3c9531daa25190e6bdbca9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMonoHue", [value]))

    @jsii.member(jsii_name="putOpacity")
    def put_opacity(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareOpacity, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8d92c35e7c6b050d6a92348bdb048cd978cad3d7ef70c600d252b8913439c6a4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putOpacity", [value]))

    @jsii.member(jsii_name="putRemoveColor")
    def put_remove_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareRemoveColor", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df435ba9ae75abef1940ec84388c77ab0b8e7dbf22a347bfa9b9ac72d5fb3d5a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRemoveColor", [value]))

    @jsii.member(jsii_name="putUnsharpMask")
    def put_unsharp_mask(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareUnsharpMask", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5432dbe4029d74c8e2fb7e4134ead3023d19380b7ff81390999253d8a0a7f4f8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putUnsharpMask", [value]))

    @jsii.member(jsii_name="resetBackgroundColor")
    def reset_background_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBackgroundColor", []))

    @jsii.member(jsii_name="resetBlur")
    def reset_blur(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBlur", []))

    @jsii.member(jsii_name="resetChromaKey")
    def reset_chroma_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChromaKey", []))

    @jsii.member(jsii_name="resetComposite")
    def reset_composite(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetComposite", []))

    @jsii.member(jsii_name="resetCompound")
    def reset_compound(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCompound", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetGoop")
    def reset_goop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGoop", []))

    @jsii.member(jsii_name="resetGrayscale")
    def reset_grayscale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGrayscale", []))

    @jsii.member(jsii_name="resetHsl")
    def reset_hsl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsl", []))

    @jsii.member(jsii_name="resetHsv")
    def reset_hsv(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsv", []))

    @jsii.member(jsii_name="resetIfDimension")
    def reset_if_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfDimension", []))

    @jsii.member(jsii_name="resetIfOrientation")
    def reset_if_orientation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfOrientation", []))

    @jsii.member(jsii_name="resetMaxColors")
    def reset_max_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxColors", []))

    @jsii.member(jsii_name="resetMirror")
    def reset_mirror(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMirror", []))

    @jsii.member(jsii_name="resetMonoHue")
    def reset_mono_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonoHue", []))

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetRemoveColor")
    def reset_remove_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRemoveColor", []))

    @jsii.member(jsii_name="resetUnsharpMask")
    def reset_unsharp_mask(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUnsharpMask", []))

    @builtins.property
    @jsii.member(jsii_name="backgroundColor")
    def background_color(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareBackgroundColorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareBackgroundColorList, jsii.get(self, "backgroundColor"))

    @builtins.property
    @jsii.member(jsii_name="blur")
    def blur(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareBlurList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareBlurList, jsii.get(self, "blur"))

    @builtins.property
    @jsii.member(jsii_name="chromaKey")
    def chroma_key(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareChromaKeyList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareChromaKeyList, jsii.get(self, "chromaKey"))

    @builtins.property
    @jsii.member(jsii_name="composite")
    def composite(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareCompositeList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareCompositeList, jsii.get(self, "composite"))

    @builtins.property
    @jsii.member(jsii_name="compound")
    def compound(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareCompoundList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareCompoundList, jsii.get(self, "compound"))

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareContrastList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareContrastList, jsii.get(self, "contrast"))

    @builtins.property
    @jsii.member(jsii_name="goop")
    def goop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareGoopList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareGoopList, jsii.get(self, "goop"))

    @builtins.property
    @jsii.member(jsii_name="grayscale")
    def grayscale(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareGrayscaleList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareGrayscaleList, jsii.get(self, "grayscale"))

    @builtins.property
    @jsii.member(jsii_name="hsl")
    def hsl(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareHslList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareHslList, jsii.get(self, "hsl"))

    @builtins.property
    @jsii.member(jsii_name="hsv")
    def hsv(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareHsvList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareHsvList, jsii.get(self, "hsv"))

    @builtins.property
    @jsii.member(jsii_name="ifDimension")
    def if_dimension(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionList, jsii.get(self, "ifDimension"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientation")
    def if_orientation(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationList, jsii.get(self, "ifOrientation"))

    @builtins.property
    @jsii.member(jsii_name="maxColors")
    def max_colors(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareMaxColorsList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareMaxColorsList, jsii.get(self, "maxColors"))

    @builtins.property
    @jsii.member(jsii_name="mirror")
    def mirror(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareMirrorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareMirrorList, jsii.get(self, "mirror"))

    @builtins.property
    @jsii.member(jsii_name="monoHue")
    def mono_hue(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareMonoHueList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareMonoHueList, jsii.get(self, "monoHue"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareOpacityList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareOpacityList, jsii.get(self, "opacity"))

    @builtins.property
    @jsii.member(jsii_name="removeColor")
    def remove_color(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareRemoveColorList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareRemoveColorList", jsii.get(self, "removeColor"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMask")
    def unsharp_mask(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareUnsharpMaskList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareUnsharpMaskList", jsii.get(self, "unsharpMask"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColorInput")
    def background_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareBackgroundColor]]], jsii.get(self, "backgroundColorInput"))

    @builtins.property
    @jsii.member(jsii_name="blurInput")
    def blur_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareBlur]]], jsii.get(self, "blurInput"))

    @builtins.property
    @jsii.member(jsii_name="chromaKeyInput")
    def chroma_key_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareChromaKey]]], jsii.get(self, "chromaKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="compositeInput")
    def composite_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareComposite]]], jsii.get(self, "compositeInput"))

    @builtins.property
    @jsii.member(jsii_name="compoundInput")
    def compound_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareCompound]]], jsii.get(self, "compoundInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareContrast]]], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="goopInput")
    def goop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareGoop]]], jsii.get(self, "goopInput"))

    @builtins.property
    @jsii.member(jsii_name="grayscaleInput")
    def grayscale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareGrayscale]]], jsii.get(self, "grayscaleInput"))

    @builtins.property
    @jsii.member(jsii_name="hslInput")
    def hsl_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareHsl]]], jsii.get(self, "hslInput"))

    @builtins.property
    @jsii.member(jsii_name="hsvInput")
    def hsv_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareHsv]]], jsii.get(self, "hsvInput"))

    @builtins.property
    @jsii.member(jsii_name="ifDimensionInput")
    def if_dimension_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimension]]], jsii.get(self, "ifDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientationInput")
    def if_orientation_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientation]]], jsii.get(self, "ifOrientationInput"))

    @builtins.property
    @jsii.member(jsii_name="maxColorsInput")
    def max_colors_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareMaxColors]]], jsii.get(self, "maxColorsInput"))

    @builtins.property
    @jsii.member(jsii_name="mirrorInput")
    def mirror_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareMirror]]], jsii.get(self, "mirrorInput"))

    @builtins.property
    @jsii.member(jsii_name="monoHueInput")
    def mono_hue_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareMonoHue]]], jsii.get(self, "monoHueInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareOpacity]]], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="removeColorInput")
    def remove_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareRemoveColor"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareRemoveColor"]]], jsii.get(self, "removeColorInput"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMaskInput")
    def unsharp_mask_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareUnsharpMask"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareUnsharpMask"]]], jsii.get(self, "unsharpMaskInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquare]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquare], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquare],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8fd4964efdc669b6cf49edd889cf28f9cd393800d362a4ceebe8a0724af31d3b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareRemoveColor",
    jsii_struct_bases=[],
    name_mapping={
        "color": "color",
        "color_var": "colorVar",
        "feather": "feather",
        "feather_var": "featherVar",
        "tolerance": "tolerance",
        "tolerance_var": "toleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareRemoveColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
        feather: typing.Optional[builtins.str] = None,
        feather_var: typing.Optional[builtins.str] = None,
        tolerance: typing.Optional[builtins.str] = None,
        tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        :param feather: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        :param feather_var: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        :param tolerance: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        :param tolerance_var: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a0e0c8f49fc8c35700a7af27f9c68d15d6c3c166089367e53a1f15fd066e489)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
            check_type(argname="argument feather", value=feather, expected_type=type_hints["feather"])
            check_type(argname="argument feather_var", value=feather_var, expected_type=type_hints["feather_var"])
            check_type(argname="argument tolerance", value=tolerance, expected_type=type_hints["tolerance"])
            check_type(argname="argument tolerance_var", value=tolerance_var, expected_type=type_hints["tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var
        if feather is not None:
            self._values["feather"] = feather
        if feather_var is not None:
            self._values["feather_var"] = feather_var
        if tolerance is not None:
            self._values["tolerance"] = tolerance
        if tolerance_var is not None:
            self._values["tolerance_var"] = tolerance_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        '''
        result = self._values.get("feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather_var(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        '''
        result = self._values.get("feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        '''
        result = self._values.get("tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance_var(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        result = self._values.get("tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareRemoveColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareRemoveColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareRemoveColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__39e38f7dd7cef6a229f1da9417c9e5c529e82f785c6860abfe399e3771824bab)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareRemoveColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5eb70082e31a20bfc67761cca685b65c2bc95d7780df6a0b4d1807ea79765e55)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareRemoveColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__935fec050b41cb526d8a5b5c232b6267fe24dd5754437cbce6dc85cea8a07efc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__da199fec837623738fc07b2fbe31a955d36000939a52823727966f8f881de44b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__15e2c1b09bd764224b56067d07861efcea8f850ba06516fcd808f16970006d46)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareRemoveColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareRemoveColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareRemoveColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__078949d539bea3b4b2d1b75ea1a4fb5a0ab2668a89602dae83c698d362d1eb45)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareRemoveColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareRemoveColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ea3284c38e1f9c6aa94a4c3823e7ed514b586f1cc27b56e384ba56ac969a8b9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @jsii.member(jsii_name="resetFeather")
    def reset_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeather", []))

    @jsii.member(jsii_name="resetFeatherVar")
    def reset_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatherVar", []))

    @jsii.member(jsii_name="resetTolerance")
    def reset_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTolerance", []))

    @jsii.member(jsii_name="resetToleranceVar")
    def reset_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featherInput")
    def feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherInput"))

    @builtins.property
    @jsii.member(jsii_name="featherVarInput")
    def feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceInput")
    def tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceVarInput")
    def tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7bb513a78089c6a23e8def59db9e5bc533ab37847a4bc1aff59700ae8e9afd43)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e2e9af0610997e08864b15500ed4fc6f1e0ff93abaa32f70486286070822d3b7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="feather")
    def feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "feather"))

    @feather.setter
    def feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f3b4df7e144e4fe1266c8307daf0ef74370db0d9e9c2a02ac0db21a42bee26b1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "feather", value)

    @builtins.property
    @jsii.member(jsii_name="featherVar")
    def feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featherVar"))

    @feather_var.setter
    def feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3b029141a7c4400a84592760ff0f6641a7c74adcc4eb33a23e03059cbb6d0043)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featherVar", value)

    @builtins.property
    @jsii.member(jsii_name="tolerance")
    def tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tolerance"))

    @tolerance.setter
    def tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a9b002122f40d72675913e44a68f34665fb61b4bf8629c5351e3e72c7bcef239)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tolerance", value)

    @builtins.property
    @jsii.member(jsii_name="toleranceVar")
    def tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "toleranceVar"))

    @tolerance_var.setter
    def tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b8357a7fdfbe5d8cbc9ae634e181f6b3ba3cc99e8283eaabbfe3c96fda683c07)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "toleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareRemoveColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareRemoveColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareRemoveColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9c65c8afa53e3fe8cb92269a9ffc386d90ed971fac554b7c2afa7bcbd37b13bb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareUnsharpMask",
    jsii_struct_bases=[],
    name_mapping={
        "gain": "gain",
        "gain_var": "gainVar",
        "sigma": "sigma",
        "sigma_var": "sigmaVar",
        "threshold": "threshold",
        "threshold_var": "thresholdVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareUnsharpMask:
    def __init__(
        self,
        *,
        gain: typing.Optional[builtins.str] = None,
        gain_var: typing.Optional[builtins.str] = None,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
        threshold: typing.Optional[builtins.str] = None,
        threshold_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param gain: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        :param gain_var: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        :param sigma: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        :param threshold: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        :param threshold_var: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a9d3b5067da0fec9c172cc6320932794125614472748396a2463bb6c1a89c7db)
            check_type(argname="argument gain", value=gain, expected_type=type_hints["gain"])
            check_type(argname="argument gain_var", value=gain_var, expected_type=type_hints["gain_var"])
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
            check_type(argname="argument threshold", value=threshold, expected_type=type_hints["threshold"])
            check_type(argname="argument threshold_var", value=threshold_var, expected_type=type_hints["threshold_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if gain is not None:
            self._values["gain"] = gain
        if gain_var is not None:
            self._values["gain_var"] = gain_var
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var
        if threshold is not None:
            self._values["threshold"] = threshold
        if threshold_var is not None:
            self._values["threshold_var"] = threshold_var

    @builtins.property
    def gain(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        '''
        result = self._values.get("gain")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gain_var(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        '''
        result = self._values.get("gain_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        '''
        result = self._values.get("threshold")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold_var(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        result = self._values.get("threshold_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareUnsharpMask(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareUnsharpMaskList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareUnsharpMaskList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5c44908927f0979b80846a0523c6b40091a4b27a5dded22fdd69ee64ae1e6eb8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareUnsharpMaskOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a0bfbc8d46914f9fe8b88a92c257badef5baea93d0c42c4853053cb3d1788e36)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareUnsharpMaskOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__04abc07d975dfcd22b9325f923477fdb4967d4361988fea06267cad50490bbcc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__55f202c30634a9189dfde2df911bea5365585229adacb6c290ad88b443f50142)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__30cb6f2d34459572e52989c32b3fb9d6f1311e82d6efb232dd71ccf409430068)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareUnsharpMask]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareUnsharpMask]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareUnsharpMask]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3c5a0a8f14edf2ff10152e94257fa1cc212eb422029c737f038b8415e6290cd1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareUnsharpMaskOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareUnsharpMaskOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e56305800a8a951a46b66997d7ce70fb776347401df5e164ff9b89ca11fc14a2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetGain")
    def reset_gain(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGain", []))

    @jsii.member(jsii_name="resetGainVar")
    def reset_gain_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGainVar", []))

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @jsii.member(jsii_name="resetThreshold")
    def reset_threshold(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThreshold", []))

    @jsii.member(jsii_name="resetThresholdVar")
    def reset_threshold_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThresholdVar", []))

    @builtins.property
    @jsii.member(jsii_name="gainInput")
    def gain_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainInput"))

    @builtins.property
    @jsii.member(jsii_name="gainVarInput")
    def gain_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdInput")
    def threshold_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdVarInput")
    def threshold_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gain")
    def gain(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gain"))

    @gain.setter
    def gain(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__59fce487eca048e489020b5e9955c1100b3344991e55b1dd5a1976dbce0902af)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gain", value)

    @builtins.property
    @jsii.member(jsii_name="gainVar")
    def gain_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gainVar"))

    @gain_var.setter
    def gain_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__60c8b9aba47a8e1bc4c27c9ebbe5e7ef0e2b3f9eda5bca700a2a2f24f3e6d3bd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gainVar", value)

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__592a7f42c51e390a8dfaa592580dc16381f672ef5e0ca165b2ac5748d6d29bd7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8af11772817c2831e43b1c6d1538937b9e441590937f99c3670af11af530893a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="threshold")
    def threshold(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "threshold"))

    @threshold.setter
    def threshold(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a525674d9f4b2bd20a47231bfd03066680bd3a9c2f41c007514f684e0710bff4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "threshold", value)

    @builtins.property
    @jsii.member(jsii_name="thresholdVar")
    def threshold_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "thresholdVar"))

    @threshold_var.setter
    def threshold_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e27c128409f179049d9fcb608c6c4a70b9880e2ea6be8b9b180b4df4f2434904)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "thresholdVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareUnsharpMask]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareUnsharpMask]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareUnsharpMask]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bdc3430a1a29237ff3df05f042038144495703e3be9a947474afe8c0beb31c0a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanMaxColors",
    jsii_struct_bases=[],
    name_mapping={"colors": "colors", "colors_var": "colorsVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanMaxColors:
    def __init__(
        self,
        *,
        colors: typing.Optional[builtins.str] = None,
        colors_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param colors: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        :param colors_var: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__61cf20a2c71bdae5993d1ca40138d220fcf4e0818bbb45e41b261ccfc53896ef)
            check_type(argname="argument colors", value=colors, expected_type=type_hints["colors"])
            check_type(argname="argument colors_var", value=colors_var, expected_type=type_hints["colors_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if colors is not None:
            self._values["colors"] = colors
        if colors_var is not None:
            self._values["colors_var"] = colors_var

    @builtins.property
    def colors(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        '''
        result = self._values.get("colors")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def colors_var(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        result = self._values.get("colors_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanMaxColors(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanMaxColorsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanMaxColorsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c25de982ade43fbab7aaacd1f731c1656ddac04ed1ea3e5c9e7456d0a7da5a6f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanMaxColorsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ca20d848cd0c8458df2e429dfec5896384767b764a5b7d00d011ff5c5f98d58a)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanMaxColorsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8ac926375cb54f3c06001f452274fffaabbfc9f96c471e85541ea0b8e57ac49d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__221262b421ded9eef86bc518f994759f38a85f01a666ba0b81b47699c5850179)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc6c373363ec40b71f1090d1d55c4a213583acfe1bff0fad0b76fff4a6636859)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanMaxColors]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanMaxColors]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f81235ead2dad15c72b95ad368f3e308e182ab9ee7e9a6b23980299bd3dc5876)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanMaxColorsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanMaxColorsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__38f5b11d7ca1be7080ee19061c896706b619ba2aa4b9fbf23788a9846efbf3ef)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColors")
    def reset_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColors", []))

    @jsii.member(jsii_name="resetColorsVar")
    def reset_colors_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorsVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorsInput")
    def colors_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsInput"))

    @builtins.property
    @jsii.member(jsii_name="colorsVarInput")
    def colors_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsVarInput"))

    @builtins.property
    @jsii.member(jsii_name="colors")
    def colors(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colors"))

    @colors.setter
    def colors(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3640886f33d4c0b10b326f89eed8553cff14f109303b18331222cdfed28f12e0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colors", value)

    @builtins.property
    @jsii.member(jsii_name="colorsVar")
    def colors_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorsVar"))

    @colors_var.setter
    def colors_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f4c2b90c19c74bc8f3deef0ed9250e5bdd30760c2b393f27fa494d8b9affa613)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorsVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanMaxColors]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanMaxColors]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanMaxColors]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ee08502425fb7547a08e045ff3a2dcbb58cd472f57cd1fc96670cd557ad0e33)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanMirror",
    jsii_struct_bases=[],
    name_mapping={
        "horizontal": "horizontal",
        "horizontal_var": "horizontalVar",
        "vertical": "vertical",
        "vertical_var": "verticalVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanMirror:
    def __init__(
        self,
        *,
        horizontal: typing.Optional[builtins.str] = None,
        horizontal_var: typing.Optional[builtins.str] = None,
        vertical: typing.Optional[builtins.str] = None,
        vertical_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param horizontal: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        :param horizontal_var: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        :param vertical: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        :param vertical_var: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e6cef02a42ff134d891676c0cc9d05849d6dbac679f8aab0c17f3ea5a9e5bcf6)
            check_type(argname="argument horizontal", value=horizontal, expected_type=type_hints["horizontal"])
            check_type(argname="argument horizontal_var", value=horizontal_var, expected_type=type_hints["horizontal_var"])
            check_type(argname="argument vertical", value=vertical, expected_type=type_hints["vertical"])
            check_type(argname="argument vertical_var", value=vertical_var, expected_type=type_hints["vertical_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if horizontal is not None:
            self._values["horizontal"] = horizontal
        if horizontal_var is not None:
            self._values["horizontal_var"] = horizontal_var
        if vertical is not None:
            self._values["vertical"] = vertical
        if vertical_var is not None:
            self._values["vertical_var"] = vertical_var

    @builtins.property
    def horizontal(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        '''
        result = self._values.get("horizontal")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def horizontal_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        '''
        result = self._values.get("horizontal_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        '''
        result = self._values.get("vertical")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        result = self._values.get("vertical_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanMirror(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanMirrorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanMirrorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__856065d547fdb649574ce9de81c2775629e65692ced2a70d517347346ed6e91a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanMirrorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0953698e5f67705e5adf076baec8d51416d9b46958b58abfe7bbfafc3c5b8403)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanMirrorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7a269f6cc9ed1d0e15ce834ea936bb7b025ecfec9413831c6ffa094633ecac59)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c69b247255200e2e25dcc129ade09a89de3344e0a71b5308901d18d982026242)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e2f843309d2d93b4280081fd416c6c4fbd243745cc3455041ef134a08858b1c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanMirror]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanMirror]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__91bec000a04669f6168c4ee95e06b7922ea500aeda7471930b9b5306e56b0cb3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanMirrorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanMirrorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3bea206fa63dc6ae445bcafc2c40ad14f5e5eaa9941d40e6134df9a6dfe12737)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHorizontal")
    def reset_horizontal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontal", []))

    @jsii.member(jsii_name="resetHorizontalVar")
    def reset_horizontal_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontalVar", []))

    @jsii.member(jsii_name="resetVertical")
    def reset_vertical(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVertical", []))

    @jsii.member(jsii_name="resetVerticalVar")
    def reset_vertical_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVerticalVar", []))

    @builtins.property
    @jsii.member(jsii_name="horizontalInput")
    def horizontal_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontalVarInput")
    def horizontal_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalInput")
    def vertical_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalVarInput")
    def vertical_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontal")
    def horizontal(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontal"))

    @horizontal.setter
    def horizontal(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d9b19d89efbc34fb7dae4020a7c8d094c0ce23e1374ed3e772ae636cfbaff93)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontal", value)

    @builtins.property
    @jsii.member(jsii_name="horizontalVar")
    def horizontal_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontalVar"))

    @horizontal_var.setter
    def horizontal_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3467979f3c31dd6b17ae58aafdb63b9ef68c17225159e4f8f155db016a2ef979)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontalVar", value)

    @builtins.property
    @jsii.member(jsii_name="vertical")
    def vertical(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "vertical"))

    @vertical.setter
    def vertical(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__27b2ae0ff72bc36f81c564a3ae8a0fcf39a3a8e1e52557229a22e6b3dd85bda0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "vertical", value)

    @builtins.property
    @jsii.member(jsii_name="verticalVar")
    def vertical_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "verticalVar"))

    @vertical_var.setter
    def vertical_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8dcc1fcd599eacfab10a2ee6e9aaeac88c145a9ac7e7ab338cf883fea8a70626)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "verticalVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanMirror]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanMirror]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanMirror]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0917b793b205b87ebd8909e4be792f81c70ef77b5ce82df75ed29bb492e9d1ab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanMonoHue",
    jsii_struct_bases=[],
    name_mapping={"hue": "hue", "hue_var": "hueVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanMonoHue:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__468750b6e01a8e9db098471db585e35cdf532b53ee4c86bdeeef74252c4f1ec0)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanMonoHue(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanMonoHueList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanMonoHueList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__98e1d63282ecc6280915d306e6fcebaf0512f2105935d5813fe42f897e38cb95)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanMonoHueOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0061f18e603607ddd02107c84f61fac742921e929fd697980a4db53c15831c08)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanMonoHueOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__baad64cf033992c3a51ca3d5d6a8134ca4ef273227a1fe1d41909513aee45de6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2b1e4482db16137125f86226cb70260c93e3244877a06dd512233a7fe06d2aad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__273bb156ac51491894d02722c0da718d1cc2853427974fc053e633f9b5f3cddc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanMonoHue]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanMonoHue]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__29e676d940ade88858e700b71482599fcd841f2540335060b356619777fbde6e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanMonoHueOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanMonoHueOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__12cf55e8a31f3789e235e4a7ee791404ec2afc809d0121cd7d15e502ff189095)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__753644c4a17abb1e26ff7712601064ad0c4728b1afad339bb63a93c51a1f8b8b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7dab871d2f6242339cb0fb7b0a8280f94c680b01dff7cc4c97f7d6be026f3609)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanMonoHue]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanMonoHue]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanMonoHue]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f412a22ea4d9f98567a2f9d76ad96e3caa75ac4e2f51e09bae6d426c8959beb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanOpacity",
    jsii_struct_bases=[],
    name_mapping={"opacity": "opacity", "opacity_var": "opacityVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanOpacity:
    def __init__(
        self,
        *,
        opacity: typing.Optional[builtins.str] = None,
        opacity_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param opacity: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param opacity_var: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e520d46d084b793a149b85e03c8e7c9893b39ee6404d8f52a8f22d9d72ecf08)
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument opacity_var", value=opacity_var, expected_type=type_hints["opacity_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if opacity is not None:
            self._values["opacity"] = opacity
        if opacity_var is not None:
            self._values["opacity_var"] = opacity_var

    @builtins.property
    def opacity(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def opacity_var(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        result = self._values.get("opacity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanOpacity(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanOpacityList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanOpacityList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9cbcec5ea2a0d6bda2b67c5c5451c8a993e639d6ac34e182786c83ab03d6b18c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanOpacityOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c727eb2fd7a9c46bce1b9cc17a7952d9544feea978991aae8cafce9e9ee2eabb)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanOpacityOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ae4842ed8ae6ca606a4482aafb4c1142a7e9f49cde68909c6bd9d534d7efdd1a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__88ae434db19cc87bd6148ffbfe0433ad1861820ae5284a07f068fd8fb58093fd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af37cb4dbc5c5dda3969418bfd1ea34d046946844645aca27c6594076637d985)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanOpacity]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanOpacity]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4b868be0be52ab51f99d98e9a5208d432fc211e02ae269247bfce3c7063de7b3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanOpacityOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanOpacityOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__25054fe820948ef6e6d678c965e79dbfd17d4892af6e8073a182f617bcd1d815)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetOpacityVar")
    def reset_opacity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacityVar", []))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityVarInput")
    def opacity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacity"))

    @opacity.setter
    def opacity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__89a8abebe9762fa108e165242e72659cec87a41ca23c6b52c99eb248da5a7303)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacity", value)

    @builtins.property
    @jsii.member(jsii_name="opacityVar")
    def opacity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacityVar"))

    @opacity_var.setter
    def opacity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__206e5a02cc4359451591cfa2cce7b0879e3191093995eba77660695ed3b41f94)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacityVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanOpacity]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanOpacity]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanOpacity]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__744ab2919ad39af44862b56b302b44c27547cd8b3341e73a43b3011eb5a13bc0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__509e3f9bba4f5db7e9809d5dd3e46d4023e344b95793aceb7eba26cf0b6f1187)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putBackgroundColor")
    def put_background_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e9d1ba2d0c726bbf6275a2cb5fb72318caf50d21aea303e0097e0d86807ba6af)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBackgroundColor", [value]))

    @jsii.member(jsii_name="putBlur")
    def put_blur(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanBlur, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4d980ba9b88185a816c8bf45014d2c345247ffe5752707fab6e26b35a95ab75d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBlur", [value]))

    @jsii.member(jsii_name="putChromaKey")
    def put_chroma_key(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanChromaKey, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__37550e96ddf59bb3d55a28d36592fcf0cc6fe1d070f3bb07a2ec6e277204348e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putChromaKey", [value]))

    @jsii.member(jsii_name="putComposite")
    def put_composite(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanComposite, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6343da286d225b391558f6cd14c65654a8b6035ae77ccb1b9c3a658993548611)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putComposite", [value]))

    @jsii.member(jsii_name="putCompound")
    def put_compound(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompound, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__33313b477157304f7f72b8808a271af6c8e1177144d177907ae20bd352410e0a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCompound", [value]))

    @jsii.member(jsii_name="putContrast")
    def put_contrast(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanContrast, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6529c866be0ec61ebc394e5f4c4c22f290b26a3f2ec98e30668da0b480903940)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putContrast", [value]))

    @jsii.member(jsii_name="putGoop")
    def put_goop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanGoop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__05774a4695e8aca3e4f0e63669f04ee2c3dd7490ffc10ebfc96cd344fe01d24f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGoop", [value]))

    @jsii.member(jsii_name="putGrayscale")
    def put_grayscale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanGrayscale, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__61d1e34f541ba5cc0a1aebbade335a7e002f495fb39e50c1406f5c6bc5e008a9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGrayscale", [value]))

    @jsii.member(jsii_name="putHsl")
    def put_hsl(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanHsl, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ee726fc9e3ecc36a769995d4578bc602d815a51bbd57ba8c4f7264db498a4b6c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsl", [value]))

    @jsii.member(jsii_name="putHsv")
    def put_hsv(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanHsv, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__652a4c85081f4811d396e7eaad40bb9a2b50a1b4d82080e70639c471efb57651)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsv", [value]))

    @jsii.member(jsii_name="putIfDimension")
    def put_if_dimension(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimension, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bf46c2a3944b54856f4ab3c5120d5c64b4b6325748955e0da1c11f1c49a7a1d7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfDimension", [value]))

    @jsii.member(jsii_name="putIfOrientation")
    def put_if_orientation(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c137293f44a30e3993dbdd2c0cb214ee1b83feae7c9ac300c2f0625ac7645ed0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfOrientation", [value]))

    @jsii.member(jsii_name="putMaxColors")
    def put_max_colors(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanMaxColors, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__427789b710642174aaa6573c0a882d8746baf67538bfc8790c40f38dfca37288)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMaxColors", [value]))

    @jsii.member(jsii_name="putMirror")
    def put_mirror(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanMirror, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__404223ebc96784ed460601a1cb98ca1ee59cbdd757bc2ac5df78c8751c4f2a24)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMirror", [value]))

    @jsii.member(jsii_name="putMonoHue")
    def put_mono_hue(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanMonoHue, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__56b9adb51dbd2cfd01b4c88790fe4381e131ada8ac52f615c9cd3198a93a925d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMonoHue", [value]))

    @jsii.member(jsii_name="putOpacity")
    def put_opacity(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanOpacity, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ee242069629a7dd7b929e74ae86cb077d6ccc02fbe6d5d68eb2fb7be0e0d12a1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putOpacity", [value]))

    @jsii.member(jsii_name="putRemoveColor")
    def put_remove_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanRemoveColor", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__674c866ad45f566e508f1928bda5cb6fd05e12e85f3a450f100ae49d2e74919d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRemoveColor", [value]))

    @jsii.member(jsii_name="putUnsharpMask")
    def put_unsharp_mask(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanUnsharpMask", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9cc4810170d090ab3b4e552aacd612823fece7602028cd9841c5f88b214a73c3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putUnsharpMask", [value]))

    @jsii.member(jsii_name="resetBackgroundColor")
    def reset_background_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBackgroundColor", []))

    @jsii.member(jsii_name="resetBlur")
    def reset_blur(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBlur", []))

    @jsii.member(jsii_name="resetChromaKey")
    def reset_chroma_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChromaKey", []))

    @jsii.member(jsii_name="resetComposite")
    def reset_composite(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetComposite", []))

    @jsii.member(jsii_name="resetCompound")
    def reset_compound(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCompound", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetGoop")
    def reset_goop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGoop", []))

    @jsii.member(jsii_name="resetGrayscale")
    def reset_grayscale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGrayscale", []))

    @jsii.member(jsii_name="resetHsl")
    def reset_hsl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsl", []))

    @jsii.member(jsii_name="resetHsv")
    def reset_hsv(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsv", []))

    @jsii.member(jsii_name="resetIfDimension")
    def reset_if_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfDimension", []))

    @jsii.member(jsii_name="resetIfOrientation")
    def reset_if_orientation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfOrientation", []))

    @jsii.member(jsii_name="resetMaxColors")
    def reset_max_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxColors", []))

    @jsii.member(jsii_name="resetMirror")
    def reset_mirror(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMirror", []))

    @jsii.member(jsii_name="resetMonoHue")
    def reset_mono_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonoHue", []))

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetRemoveColor")
    def reset_remove_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRemoveColor", []))

    @jsii.member(jsii_name="resetUnsharpMask")
    def reset_unsharp_mask(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUnsharpMask", []))

    @builtins.property
    @jsii.member(jsii_name="backgroundColor")
    def background_color(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanBackgroundColorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanBackgroundColorList, jsii.get(self, "backgroundColor"))

    @builtins.property
    @jsii.member(jsii_name="blur")
    def blur(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanBlurList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanBlurList, jsii.get(self, "blur"))

    @builtins.property
    @jsii.member(jsii_name="chromaKey")
    def chroma_key(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanChromaKeyList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanChromaKeyList, jsii.get(self, "chromaKey"))

    @builtins.property
    @jsii.member(jsii_name="composite")
    def composite(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeList, jsii.get(self, "composite"))

    @builtins.property
    @jsii.member(jsii_name="compound")
    def compound(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundList, jsii.get(self, "compound"))

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanContrastList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanContrastList, jsii.get(self, "contrast"))

    @builtins.property
    @jsii.member(jsii_name="goop")
    def goop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanGoopList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanGoopList, jsii.get(self, "goop"))

    @builtins.property
    @jsii.member(jsii_name="grayscale")
    def grayscale(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanGrayscaleList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanGrayscaleList, jsii.get(self, "grayscale"))

    @builtins.property
    @jsii.member(jsii_name="hsl")
    def hsl(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanHslList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanHslList, jsii.get(self, "hsl"))

    @builtins.property
    @jsii.member(jsii_name="hsv")
    def hsv(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanHsvList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanHsvList, jsii.get(self, "hsv"))

    @builtins.property
    @jsii.member(jsii_name="ifDimension")
    def if_dimension(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionList", jsii.get(self, "ifDimension"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientation")
    def if_orientation(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationList, jsii.get(self, "ifOrientation"))

    @builtins.property
    @jsii.member(jsii_name="maxColors")
    def max_colors(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanMaxColorsList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanMaxColorsList, jsii.get(self, "maxColors"))

    @builtins.property
    @jsii.member(jsii_name="mirror")
    def mirror(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanMirrorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanMirrorList, jsii.get(self, "mirror"))

    @builtins.property
    @jsii.member(jsii_name="monoHue")
    def mono_hue(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanMonoHueList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanMonoHueList, jsii.get(self, "monoHue"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanOpacityList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanOpacityList, jsii.get(self, "opacity"))

    @builtins.property
    @jsii.member(jsii_name="removeColor")
    def remove_color(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanRemoveColorList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanRemoveColorList", jsii.get(self, "removeColor"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMask")
    def unsharp_mask(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanUnsharpMaskList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanUnsharpMaskList", jsii.get(self, "unsharpMask"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColorInput")
    def background_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanBackgroundColor]]], jsii.get(self, "backgroundColorInput"))

    @builtins.property
    @jsii.member(jsii_name="blurInput")
    def blur_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanBlur]]], jsii.get(self, "blurInput"))

    @builtins.property
    @jsii.member(jsii_name="chromaKeyInput")
    def chroma_key_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanChromaKey]]], jsii.get(self, "chromaKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="compositeInput")
    def composite_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanComposite]]], jsii.get(self, "compositeInput"))

    @builtins.property
    @jsii.member(jsii_name="compoundInput")
    def compound_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompound]]], jsii.get(self, "compoundInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanContrast]]], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="goopInput")
    def goop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanGoop]]], jsii.get(self, "goopInput"))

    @builtins.property
    @jsii.member(jsii_name="grayscaleInput")
    def grayscale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanGrayscale]]], jsii.get(self, "grayscaleInput"))

    @builtins.property
    @jsii.member(jsii_name="hslInput")
    def hsl_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanHsl]]], jsii.get(self, "hslInput"))

    @builtins.property
    @jsii.member(jsii_name="hsvInput")
    def hsv_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanHsv]]], jsii.get(self, "hsvInput"))

    @builtins.property
    @jsii.member(jsii_name="ifDimensionInput")
    def if_dimension_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimension]]], jsii.get(self, "ifDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientationInput")
    def if_orientation_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientation]]], jsii.get(self, "ifOrientationInput"))

    @builtins.property
    @jsii.member(jsii_name="maxColorsInput")
    def max_colors_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanMaxColors]]], jsii.get(self, "maxColorsInput"))

    @builtins.property
    @jsii.member(jsii_name="mirrorInput")
    def mirror_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanMirror]]], jsii.get(self, "mirrorInput"))

    @builtins.property
    @jsii.member(jsii_name="monoHueInput")
    def mono_hue_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanMonoHue]]], jsii.get(self, "monoHueInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanOpacity]]], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="removeColorInput")
    def remove_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanRemoveColor"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanRemoveColor"]]], jsii.get(self, "removeColorInput"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMaskInput")
    def unsharp_mask_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanUnsharpMask"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanUnsharpMask"]]], jsii.get(self, "unsharpMaskInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4470a72455fe13426fdb0024e691457b541898fe038b17b9d463dfd6aa145841)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanRemoveColor",
    jsii_struct_bases=[],
    name_mapping={
        "color": "color",
        "color_var": "colorVar",
        "feather": "feather",
        "feather_var": "featherVar",
        "tolerance": "tolerance",
        "tolerance_var": "toleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanRemoveColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
        feather: typing.Optional[builtins.str] = None,
        feather_var: typing.Optional[builtins.str] = None,
        tolerance: typing.Optional[builtins.str] = None,
        tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        :param feather: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        :param feather_var: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        :param tolerance: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        :param tolerance_var: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ce8d436c41a58fb9f41634e508a68e181bf39a84f89ba2a16b2c1aab0a505b4d)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
            check_type(argname="argument feather", value=feather, expected_type=type_hints["feather"])
            check_type(argname="argument feather_var", value=feather_var, expected_type=type_hints["feather_var"])
            check_type(argname="argument tolerance", value=tolerance, expected_type=type_hints["tolerance"])
            check_type(argname="argument tolerance_var", value=tolerance_var, expected_type=type_hints["tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var
        if feather is not None:
            self._values["feather"] = feather
        if feather_var is not None:
            self._values["feather_var"] = feather_var
        if tolerance is not None:
            self._values["tolerance"] = tolerance
        if tolerance_var is not None:
            self._values["tolerance_var"] = tolerance_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        '''
        result = self._values.get("feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather_var(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        '''
        result = self._values.get("feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        '''
        result = self._values.get("tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance_var(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        result = self._values.get("tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanRemoveColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanRemoveColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanRemoveColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e85c38086d9e4705b979c7af27a02cc36e38809ac577861c872dc558c5a1120d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanRemoveColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c1b1ee2283478607748e125a302add56449c2e5c7a46b52d00b3966ea0ed9beb)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanRemoveColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5db562518885292448b5d8154661e2b115d4edaa55cb5829ac155a69fcc1b825)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__335eebe3e0e2f99a18a6427251444002a2caa04038e33cc0c6e379811bc65174)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dc505ce2d5399c9a200cf61356e0a08d56c14abdbdf518c05d2d014df5bf1417)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanRemoveColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanRemoveColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanRemoveColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f43faa86420afb6b30573d32e9b515f1d505a1164de8fc67c4738ee0dba6e9f8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanRemoveColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanRemoveColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__94baeb056eff31030d08b7e67f15a7216d6180cb6a631c9c92a36d84ca3958c7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @jsii.member(jsii_name="resetFeather")
    def reset_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeather", []))

    @jsii.member(jsii_name="resetFeatherVar")
    def reset_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatherVar", []))

    @jsii.member(jsii_name="resetTolerance")
    def reset_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTolerance", []))

    @jsii.member(jsii_name="resetToleranceVar")
    def reset_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featherInput")
    def feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherInput"))

    @builtins.property
    @jsii.member(jsii_name="featherVarInput")
    def feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceInput")
    def tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceVarInput")
    def tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__79265c62a51aa89776ff3e1d381ac16ff988fedfd3c3d44f52869259ac9109a0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9c287c86f4cd7dad0aeca716f4cfbe224d70b7f39b6454183d3085cf4cf19bc9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="feather")
    def feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "feather"))

    @feather.setter
    def feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__80abed16ef5b4ada7d622e0d3de99fbffb6eeb128005d56f858f600019f22294)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "feather", value)

    @builtins.property
    @jsii.member(jsii_name="featherVar")
    def feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featherVar"))

    @feather_var.setter
    def feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__96b0bcbfaac6a5c73251271da2776971c45b2d9e37a3571085842bfd1963f6e4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featherVar", value)

    @builtins.property
    @jsii.member(jsii_name="tolerance")
    def tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tolerance"))

    @tolerance.setter
    def tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b1db3a8faf0e49f94ef1dae1d0c621f6c8e0c80f8e23cc17b0976275e1e0125d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tolerance", value)

    @builtins.property
    @jsii.member(jsii_name="toleranceVar")
    def tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "toleranceVar"))

    @tolerance_var.setter
    def tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__41c974832272076ea5a16d4dc1a98729eba9682c0d8544997334f25e6bf18a44)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "toleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanRemoveColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanRemoveColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanRemoveColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fba592c11c148bb78c3d750077669b8335e34aab3f636841b8b33c2838ba1f4c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanUnsharpMask",
    jsii_struct_bases=[],
    name_mapping={
        "gain": "gain",
        "gain_var": "gainVar",
        "sigma": "sigma",
        "sigma_var": "sigmaVar",
        "threshold": "threshold",
        "threshold_var": "thresholdVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanUnsharpMask:
    def __init__(
        self,
        *,
        gain: typing.Optional[builtins.str] = None,
        gain_var: typing.Optional[builtins.str] = None,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
        threshold: typing.Optional[builtins.str] = None,
        threshold_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param gain: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        :param gain_var: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        :param sigma: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        :param threshold: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        :param threshold_var: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__763e5cea3ef57eed1f3dd18ebc6ab5fd4ea2af3fec246cb252f246f5b5824b27)
            check_type(argname="argument gain", value=gain, expected_type=type_hints["gain"])
            check_type(argname="argument gain_var", value=gain_var, expected_type=type_hints["gain_var"])
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
            check_type(argname="argument threshold", value=threshold, expected_type=type_hints["threshold"])
            check_type(argname="argument threshold_var", value=threshold_var, expected_type=type_hints["threshold_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if gain is not None:
            self._values["gain"] = gain
        if gain_var is not None:
            self._values["gain_var"] = gain_var
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var
        if threshold is not None:
            self._values["threshold"] = threshold
        if threshold_var is not None:
            self._values["threshold_var"] = threshold_var

    @builtins.property
    def gain(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        '''
        result = self._values.get("gain")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gain_var(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        '''
        result = self._values.get("gain_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        '''
        result = self._values.get("threshold")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold_var(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        result = self._values.get("threshold_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanUnsharpMask(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanUnsharpMaskList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanUnsharpMaskList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ec512caaca3086eb86ca5dd0ad8d23151e7ead7244ac2b01fef1285d144f7b1f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanUnsharpMaskOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__47380474b13d3542d13ebf47df5d628bf8d73ae37d5a621d103d2123b70aba3f)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanUnsharpMaskOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f0e5a7a42b8fae83d09ad55737153fa74fa6079ac29ff9070b5b0d67b1264007)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__afb7c8bf6e0f2c1870c17cddb969394b39b57b775779e3ab344a1f42ef90e0e1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__93a9245069a7c4fa382cea6030227fc82224fd01199e6dd2dbe3cf24a7a045a0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanUnsharpMask]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanUnsharpMask]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanUnsharpMask]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7bd01e6d1fb1863c11685b2ff7f9a7197867f1afcb0b6db33cd6907f692f5356)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanUnsharpMaskOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanUnsharpMaskOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c9a492ca2db85deed09cf0415a3045b914280319bf046839ff3ebe4015025361)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetGain")
    def reset_gain(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGain", []))

    @jsii.member(jsii_name="resetGainVar")
    def reset_gain_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGainVar", []))

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @jsii.member(jsii_name="resetThreshold")
    def reset_threshold(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThreshold", []))

    @jsii.member(jsii_name="resetThresholdVar")
    def reset_threshold_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThresholdVar", []))

    @builtins.property
    @jsii.member(jsii_name="gainInput")
    def gain_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainInput"))

    @builtins.property
    @jsii.member(jsii_name="gainVarInput")
    def gain_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdInput")
    def threshold_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdVarInput")
    def threshold_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gain")
    def gain(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gain"))

    @gain.setter
    def gain(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__afdc82f409d41bf265b152acc446fda43280a7980e8a980b30a6ec9394eb56af)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gain", value)

    @builtins.property
    @jsii.member(jsii_name="gainVar")
    def gain_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gainVar"))

    @gain_var.setter
    def gain_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be490ed96c45901d846770f69eb632865b603c84bb7a113e1516f830a277f9df)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gainVar", value)

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0233a3595d55adda7a5160bdff2d68780de6b3f4be74b4fec335dc9e8fc0b19e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__76a44d262abe94058b91bd2d675148b4f2f06179486551c635044ada6cbef30a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="threshold")
    def threshold(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "threshold"))

    @threshold.setter
    def threshold(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__781f8df057db2ceeb0f1e9732aad60bd23d2c90c91ab314eb0c177ab062e463e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "threshold", value)

    @builtins.property
    @jsii.member(jsii_name="thresholdVar")
    def threshold_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "thresholdVar"))

    @threshold_var.setter
    def threshold_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4132d7486589b4a1380f7e9d889379e2aac9943d7501eab534cb45f35070d598)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "thresholdVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanUnsharpMask]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanUnsharpMask]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanUnsharpMask]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2fdf39f750c45910691ce554ee9babcfa75d1e5f737260f6160fadc10aa4cf8c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThan",
    jsii_struct_bases=[],
    name_mapping={
        "background_color": "backgroundColor",
        "blur": "blur",
        "chroma_key": "chromaKey",
        "composite": "composite",
        "compound": "compound",
        "contrast": "contrast",
        "goop": "goop",
        "grayscale": "grayscale",
        "hsl": "hsl",
        "hsv": "hsv",
        "if_dimension": "ifDimension",
        "if_orientation": "ifOrientation",
        "max_colors": "maxColors",
        "mirror": "mirror",
        "mono_hue": "monoHue",
        "opacity": "opacity",
        "remove_color": "removeColor",
        "unsharp_mask": "unsharpMask",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThan:
    def __init__(
        self,
        *,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanBackgroundColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanBlur", typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanChromaKey", typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanComposite", typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompound", typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanContrast", typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanGoop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanGrayscale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanHsl", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanHsv", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientation", typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanMaxColors", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanMirror", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanMonoHue", typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanOpacity", typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanRemoveColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanUnsharpMask", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__40ec9e772ed9b7d1787156d1caf52f4df25fd1651961f01b2f20b9d0bdfeb982)
            check_type(argname="argument background_color", value=background_color, expected_type=type_hints["background_color"])
            check_type(argname="argument blur", value=blur, expected_type=type_hints["blur"])
            check_type(argname="argument chroma_key", value=chroma_key, expected_type=type_hints["chroma_key"])
            check_type(argname="argument composite", value=composite, expected_type=type_hints["composite"])
            check_type(argname="argument compound", value=compound, expected_type=type_hints["compound"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument goop", value=goop, expected_type=type_hints["goop"])
            check_type(argname="argument grayscale", value=grayscale, expected_type=type_hints["grayscale"])
            check_type(argname="argument hsl", value=hsl, expected_type=type_hints["hsl"])
            check_type(argname="argument hsv", value=hsv, expected_type=type_hints["hsv"])
            check_type(argname="argument if_dimension", value=if_dimension, expected_type=type_hints["if_dimension"])
            check_type(argname="argument if_orientation", value=if_orientation, expected_type=type_hints["if_orientation"])
            check_type(argname="argument max_colors", value=max_colors, expected_type=type_hints["max_colors"])
            check_type(argname="argument mirror", value=mirror, expected_type=type_hints["mirror"])
            check_type(argname="argument mono_hue", value=mono_hue, expected_type=type_hints["mono_hue"])
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument remove_color", value=remove_color, expected_type=type_hints["remove_color"])
            check_type(argname="argument unsharp_mask", value=unsharp_mask, expected_type=type_hints["unsharp_mask"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if background_color is not None:
            self._values["background_color"] = background_color
        if blur is not None:
            self._values["blur"] = blur
        if chroma_key is not None:
            self._values["chroma_key"] = chroma_key
        if composite is not None:
            self._values["composite"] = composite
        if compound is not None:
            self._values["compound"] = compound
        if contrast is not None:
            self._values["contrast"] = contrast
        if goop is not None:
            self._values["goop"] = goop
        if grayscale is not None:
            self._values["grayscale"] = grayscale
        if hsl is not None:
            self._values["hsl"] = hsl
        if hsv is not None:
            self._values["hsv"] = hsv
        if if_dimension is not None:
            self._values["if_dimension"] = if_dimension
        if if_orientation is not None:
            self._values["if_orientation"] = if_orientation
        if max_colors is not None:
            self._values["max_colors"] = max_colors
        if mirror is not None:
            self._values["mirror"] = mirror
        if mono_hue is not None:
            self._values["mono_hue"] = mono_hue
        if opacity is not None:
            self._values["opacity"] = opacity
        if remove_color is not None:
            self._values["remove_color"] = remove_color
        if unsharp_mask is not None:
            self._values["unsharp_mask"] = unsharp_mask

    @builtins.property
    def background_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanBackgroundColor"]]]:
        '''background_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        '''
        result = self._values.get("background_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanBackgroundColor"]]], result)

    @builtins.property
    def blur(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanBlur"]]]:
        '''blur block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        '''
        result = self._values.get("blur")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanBlur"]]], result)

    @builtins.property
    def chroma_key(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanChromaKey"]]]:
        '''chroma_key block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        '''
        result = self._values.get("chroma_key")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanChromaKey"]]], result)

    @builtins.property
    def composite(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanComposite"]]]:
        '''composite block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        '''
        result = self._values.get("composite")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanComposite"]]], result)

    @builtins.property
    def compound(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompound"]]]:
        '''compound block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        '''
        result = self._values.get("compound")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompound"]]], result)

    @builtins.property
    def contrast(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanContrast"]]]:
        '''contrast block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanContrast"]]], result)

    @builtins.property
    def goop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanGoop"]]]:
        '''goop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        '''
        result = self._values.get("goop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanGoop"]]], result)

    @builtins.property
    def grayscale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanGrayscale"]]]:
        '''grayscale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        '''
        result = self._values.get("grayscale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanGrayscale"]]], result)

    @builtins.property
    def hsl(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanHsl"]]]:
        '''hsl block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        '''
        result = self._values.get("hsl")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanHsl"]]], result)

    @builtins.property
    def hsv(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanHsv"]]]:
        '''hsv block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        '''
        result = self._values.get("hsv")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanHsv"]]], result)

    @builtins.property
    def if_dimension(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimension]]]:
        '''if_dimension block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        '''
        result = self._values.get("if_dimension")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimension]]], result)

    @builtins.property
    def if_orientation(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientation"]]]:
        '''if_orientation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        '''
        result = self._values.get("if_orientation")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientation"]]], result)

    @builtins.property
    def max_colors(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanMaxColors"]]]:
        '''max_colors block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        '''
        result = self._values.get("max_colors")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanMaxColors"]]], result)

    @builtins.property
    def mirror(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanMirror"]]]:
        '''mirror block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        '''
        result = self._values.get("mirror")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanMirror"]]], result)

    @builtins.property
    def mono_hue(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanMonoHue"]]]:
        '''mono_hue block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        '''
        result = self._values.get("mono_hue")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanMonoHue"]]], result)

    @builtins.property
    def opacity(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanOpacity"]]]:
        '''opacity block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanOpacity"]]], result)

    @builtins.property
    def remove_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanRemoveColor"]]]:
        '''remove_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        '''
        result = self._values.get("remove_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanRemoveColor"]]], result)

    @builtins.property
    def unsharp_mask(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanUnsharpMask"]]]:
        '''unsharp_mask block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        result = self._values.get("unsharp_mask")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanUnsharpMask"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanBackgroundColor",
    jsii_struct_bases=[],
    name_mapping={"color": "color", "color_var": "colorVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanBackgroundColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa526e58a7302d16244342d170ba215f39b137dee74c88b58c0daa599f359d1c)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanBackgroundColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanBackgroundColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanBackgroundColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fd52c9218a2bd9e89b69c0e32e12f02bc5c1cfec59778eda4c8a250408e4e2d7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanBackgroundColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2f2cc8c84a1e834caeb253021195974a989d7d0570232d47d24de05684720426)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanBackgroundColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2e75dd835de0e064a5e7d069491af7b79dd7e240261d8fc3828bdfc4d54b3ece)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aec1aaa6c4c03a0861e91420714b25767867ac6d39a1d4c5016419b0ed889efa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d20f94c3f8ae024efb125a54d74388ac41d16b90035c63cda1a272e2a23e18c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanBackgroundColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanBackgroundColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ad13196927d5cc463affb412c4be3c9db38027c81a6956952cf0b898bc81c9c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanBackgroundColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanBackgroundColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a8a0d7465a0893c70cb472bc1379d7a259cf2ccf06927eb0684b4e539002c5e8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5d658bd13b15b12d97107cbba958907702887a3f83cd03ec64469ff060ab4973)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c9027a8d92c867f1ad83ba0e4ac979c9ab61251aaf243c672c7b5c1bf9193f0b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanBackgroundColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanBackgroundColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanBackgroundColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6575880f5f7986e28fabc4c22382af41b1e634ff825cef82d7d1039e53438adf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanBlur",
    jsii_struct_bases=[],
    name_mapping={"sigma": "sigma", "sigma_var": "sigmaVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanBlur:
    def __init__(
        self,
        *,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param sigma: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__52565f56b7c453b2e0ef07d01337a760b45e482940d5e24c58694ddbf9895bff)
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanBlur(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanBlurList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanBlurList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__92bfcac9486c925bc08d5b3067334c26537cefc597cd3f3a433b6b01837cefda)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanBlurOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__05a8cb1d1ff89ac571c7e819b1fee15ce8904f6fee0afcfc12f291adc53cca2d)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanBlurOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__131c69c9f26040c65a88450c677c6f2a49fe3984f40bb10305b6dd7e58fe1d0d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__212c5116cbf093d4222575a4617d94df27cf36c1b4e580e523255d8ecc393a40)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__88ee990cf4f8bfdd3ebc40b0ab74815935593f800fe55ff85a2bdd58f8452d24)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanBlur]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanBlur]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1ef33d2b3311894dbad1937976f3249f5658274a8e6824442cfa7b42978d89f3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanBlurOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanBlurOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d0f3d0fba1f1efd544579103e9f2b1386eea8351e50c5946c3cf7a8e8ddd4ce2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__28a4ff473810073f2e441bd6b819723dafb3537af5f50f682f3166a34ec8954d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1e43a47c569255ade82996fb5a9839e9bb39112d9b4e8700ea949d0fd925cd0c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanBlur]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanBlur]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanBlur]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4742a28c408b344d0f0a6fe859b94fc8b7140286efd7d74e0d4c359848af2a87)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanChromaKey",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_feather": "hueFeather",
        "hue_feather_var": "hueFeatherVar",
        "hue_tolerance": "hueTolerance",
        "hue_tolerance_var": "hueToleranceVar",
        "hue_var": "hueVar",
        "lightness_feather": "lightnessFeather",
        "lightness_feather_var": "lightnessFeatherVar",
        "lightness_tolerance": "lightnessTolerance",
        "lightness_tolerance_var": "lightnessToleranceVar",
        "saturation_feather": "saturationFeather",
        "saturation_feather_var": "saturationFeatherVar",
        "saturation_tolerance": "saturationTolerance",
        "saturation_tolerance_var": "saturationToleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanChromaKey:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_feather: typing.Optional[builtins.str] = None,
        hue_feather_var: typing.Optional[builtins.str] = None,
        hue_tolerance: typing.Optional[builtins.str] = None,
        hue_tolerance_var: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness_feather: typing.Optional[builtins.str] = None,
        lightness_feather_var: typing.Optional[builtins.str] = None,
        lightness_tolerance: typing.Optional[builtins.str] = None,
        lightness_tolerance_var: typing.Optional[builtins.str] = None,
        saturation_feather: typing.Optional[builtins.str] = None,
        saturation_feather_var: typing.Optional[builtins.str] = None,
        saturation_tolerance: typing.Optional[builtins.str] = None,
        saturation_tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_feather: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        :param hue_feather_var: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        :param hue_tolerance: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        :param hue_tolerance_var: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        :param hue_var: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness_feather: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        :param lightness_feather_var: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        :param lightness_tolerance: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        :param lightness_tolerance_var: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        :param saturation_feather: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        :param saturation_feather_var: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        :param saturation_tolerance: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        :param saturation_tolerance_var: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5b1dbeb80c56d3ebf441c9cbb4d3444bc30bf1a897a439d4651a1d752dbc9cba)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_feather", value=hue_feather, expected_type=type_hints["hue_feather"])
            check_type(argname="argument hue_feather_var", value=hue_feather_var, expected_type=type_hints["hue_feather_var"])
            check_type(argname="argument hue_tolerance", value=hue_tolerance, expected_type=type_hints["hue_tolerance"])
            check_type(argname="argument hue_tolerance_var", value=hue_tolerance_var, expected_type=type_hints["hue_tolerance_var"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness_feather", value=lightness_feather, expected_type=type_hints["lightness_feather"])
            check_type(argname="argument lightness_feather_var", value=lightness_feather_var, expected_type=type_hints["lightness_feather_var"])
            check_type(argname="argument lightness_tolerance", value=lightness_tolerance, expected_type=type_hints["lightness_tolerance"])
            check_type(argname="argument lightness_tolerance_var", value=lightness_tolerance_var, expected_type=type_hints["lightness_tolerance_var"])
            check_type(argname="argument saturation_feather", value=saturation_feather, expected_type=type_hints["saturation_feather"])
            check_type(argname="argument saturation_feather_var", value=saturation_feather_var, expected_type=type_hints["saturation_feather_var"])
            check_type(argname="argument saturation_tolerance", value=saturation_tolerance, expected_type=type_hints["saturation_tolerance"])
            check_type(argname="argument saturation_tolerance_var", value=saturation_tolerance_var, expected_type=type_hints["saturation_tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_feather is not None:
            self._values["hue_feather"] = hue_feather
        if hue_feather_var is not None:
            self._values["hue_feather_var"] = hue_feather_var
        if hue_tolerance is not None:
            self._values["hue_tolerance"] = hue_tolerance
        if hue_tolerance_var is not None:
            self._values["hue_tolerance_var"] = hue_tolerance_var
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness_feather is not None:
            self._values["lightness_feather"] = lightness_feather
        if lightness_feather_var is not None:
            self._values["lightness_feather_var"] = lightness_feather_var
        if lightness_tolerance is not None:
            self._values["lightness_tolerance"] = lightness_tolerance
        if lightness_tolerance_var is not None:
            self._values["lightness_tolerance_var"] = lightness_tolerance_var
        if saturation_feather is not None:
            self._values["saturation_feather"] = saturation_feather
        if saturation_feather_var is not None:
            self._values["saturation_feather_var"] = saturation_feather_var
        if saturation_tolerance is not None:
            self._values["saturation_tolerance"] = saturation_tolerance
        if saturation_tolerance_var is not None:
            self._values["saturation_tolerance_var"] = saturation_tolerance_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        '''
        result = self._values.get("hue_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        '''
        result = self._values.get("hue_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        '''
        result = self._values.get("hue_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        '''
        result = self._values.get("hue_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        '''
        result = self._values.get("lightness_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        '''
        result = self._values.get("lightness_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        '''
        result = self._values.get("lightness_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        '''
        result = self._values.get("lightness_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        '''
        result = self._values.get("saturation_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        '''
        result = self._values.get("saturation_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        '''
        result = self._values.get("saturation_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        result = self._values.get("saturation_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanChromaKey(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanChromaKeyList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanChromaKeyList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c57cca5830533e9b3a085812304bb8e26b6358ccf95fdae18f85fe2bb004df8c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanChromaKeyOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7861ce20e7062f88eaa25d1d84c0a4f0aedc9e7592f6a0b9ef1f3e8c99e1e74a)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanChromaKeyOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bab2717fd351b4e0ba28b0ff84e54f7bfb18fc574ba78af1a15853575f7e8514)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df1f1a52eb85866767e2bc08670c5e6e4fa263e05a036745e0b4db3f2f322947)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b57d12dc0269222947fc164a1ded9769863ae7ef89b5714742faac078be0ef73)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanChromaKey]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanChromaKey]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__826d8037e0976a8c1fd612523dd3ce52cbf1413492170e5862d6487167746330)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanChromaKeyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanChromaKeyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d3f8b04ec0a18cbe05c7073d41c9ae4e2cd536eb037c4929caf9f2ad09924548)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueFeather")
    def reset_hue_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeather", []))

    @jsii.member(jsii_name="resetHueFeatherVar")
    def reset_hue_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeatherVar", []))

    @jsii.member(jsii_name="resetHueTolerance")
    def reset_hue_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueTolerance", []))

    @jsii.member(jsii_name="resetHueToleranceVar")
    def reset_hue_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueToleranceVar", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightnessFeather")
    def reset_lightness_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeather", []))

    @jsii.member(jsii_name="resetLightnessFeatherVar")
    def reset_lightness_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeatherVar", []))

    @jsii.member(jsii_name="resetLightnessTolerance")
    def reset_lightness_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessTolerance", []))

    @jsii.member(jsii_name="resetLightnessToleranceVar")
    def reset_lightness_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessToleranceVar", []))

    @jsii.member(jsii_name="resetSaturationFeather")
    def reset_saturation_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeather", []))

    @jsii.member(jsii_name="resetSaturationFeatherVar")
    def reset_saturation_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeatherVar", []))

    @jsii.member(jsii_name="resetSaturationTolerance")
    def reset_saturation_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationTolerance", []))

    @jsii.member(jsii_name="resetSaturationToleranceVar")
    def reset_saturation_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherInput")
    def hue_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVarInput")
    def hue_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceInput")
    def hue_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVarInput")
    def hue_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherInput")
    def lightness_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVarInput")
    def lightness_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceInput")
    def lightness_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVarInput")
    def lightness_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherInput")
    def saturation_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVarInput")
    def saturation_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceInput")
    def saturation_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVarInput")
    def saturation_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__17611f7e994471ead912cb7f717f3486e6b080e88c1b839265d41535ecc973df)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeather")
    def hue_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeather"))

    @hue_feather.setter
    def hue_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc8670fa8136208871dac6c7b324e6e951df7ca8758dfbe6343e4187f23b63c4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeather", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVar")
    def hue_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeatherVar"))

    @hue_feather_var.setter
    def hue_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7768602a2b9b20b295cb1023eec47f193d7df26f1e4320d2a3ae0e8750256f24)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueTolerance")
    def hue_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueTolerance"))

    @hue_tolerance.setter
    def hue_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a2c94e1a7fbb7ee797fa64a2830dca097bfae787a8c315e1fe70a05fbed8c3fb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVar")
    def hue_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueToleranceVar"))

    @hue_tolerance_var.setter
    def hue_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c9d1a0cca213b2fe40068f512e6f16a9a94b4affd43c69bb00045dbc3f7c4967)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4319aedaa94f3fcdc3b47ad3a1517811db9c5350f9f65fd9c2c9a3c349e6c21b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeather")
    def lightness_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeather"))

    @lightness_feather.setter
    def lightness_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5c7d7d4641aca056cfa91a6fe1ee181c081bc73482104ab79275f728e43fd9fc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeather", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVar")
    def lightness_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeatherVar"))

    @lightness_feather_var.setter
    def lightness_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bd5f265222424d1e68400fa50d11c355177332da98c985fdb8768064036d907a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessTolerance")
    def lightness_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessTolerance"))

    @lightness_tolerance.setter
    def lightness_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6be2897dce65232a07901f3d6d50d990c3cecb0c5073cb56395987e4c50cfb43)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVar")
    def lightness_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessToleranceVar"))

    @lightness_tolerance_var.setter
    def lightness_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ee83719e3b4ae17dd105587bab56c8b967e6c1010cf0e6c6869f367cbc184057)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeather")
    def saturation_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeather"))

    @saturation_feather.setter
    def saturation_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f1b106c4f37b642fcc10f5e8791a1f1b7b36401762e1c98e894ef5edbae543c0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeather", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVar")
    def saturation_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeatherVar"))

    @saturation_feather_var.setter
    def saturation_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__75d8cc34b1da8db0237394698d2c077bc1eac324caeaf1cdaad2f25168656d0b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationTolerance")
    def saturation_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationTolerance"))

    @saturation_tolerance.setter
    def saturation_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__87531740f6c410eea755b5d696491c6260830667e544863e2d34c190bcf9d30b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVar")
    def saturation_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationToleranceVar"))

    @saturation_tolerance_var.setter
    def saturation_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__21c7f95961122ff0567794f718c72ca8dd569d1666dd00d1516a1f6e0e71160e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanChromaKey]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanChromaKey]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanChromaKey]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6ba0724e2e96e2a71818a58cd40d38671f3e7c187c046a1c80c841c47b9b42bd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanComposite",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "placement": "placement",
        "placement_var": "placementVar",
        "scale": "scale",
        "scale_dimension": "scaleDimension",
        "scale_dimension_var": "scaleDimensionVar",
        "scale_var": "scaleVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanComposite:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        placement: typing.Optional[builtins.str] = None,
        placement_var: typing.Optional[builtins.str] = None,
        scale: typing.Optional[builtins.str] = None,
        scale_dimension: typing.Optional[builtins.str] = None,
        scale_dimension_var: typing.Optional[builtins.str] = None,
        scale_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param placement: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        :param placement_var: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        :param scale: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param scale_dimension: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        :param scale_dimension_var: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        :param scale_var: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        :param x_position: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f103c1e670b6f0e89cc9a970b441ab29f042aea32d08495ddc99103582558b39)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument placement", value=placement, expected_type=type_hints["placement"])
            check_type(argname="argument placement_var", value=placement_var, expected_type=type_hints["placement_var"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument scale_dimension", value=scale_dimension, expected_type=type_hints["scale_dimension"])
            check_type(argname="argument scale_dimension_var", value=scale_dimension_var, expected_type=type_hints["scale_dimension_var"])
            check_type(argname="argument scale_var", value=scale_var, expected_type=type_hints["scale_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if placement is not None:
            self._values["placement"] = placement
        if placement_var is not None:
            self._values["placement_var"] = placement_var
        if scale is not None:
            self._values["scale"] = scale
        if scale_dimension is not None:
            self._values["scale_dimension"] = scale_dimension
        if scale_dimension_var is not None:
            self._values["scale_dimension_var"] = scale_dimension_var
        if scale_var is not None:
            self._values["scale_var"] = scale_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        '''
        result = self._values.get("placement")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement_var(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        '''
        result = self._values.get("placement_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        '''
        result = self._values.get("scale_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        '''
        result = self._values.get("scale_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        '''
        result = self._values.get("scale_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanComposite(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImage",
    jsii_struct_bases=[],
    name_mapping={
        "box_image": "boxImage",
        "circle_image": "circleImage",
        "text_image": "textImage",
        "url_image": "urlImage",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImage:
    def __init__(
        self,
        *,
        box_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageBoxImage", typing.Dict[builtins.str, typing.Any]]]]] = None,
        circle_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageCircleImage", typing.Dict[builtins.str, typing.Any]]]]] = None,
        text_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageTextImage", typing.Dict[builtins.str, typing.Any]]]]] = None,
        url_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageUrlImage", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param box_image: box_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#box_image DataAkamaiImagingPolicyImage#box_image}
        :param circle_image: circle_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#circle_image DataAkamaiImagingPolicyImage#circle_image}
        :param text_image: text_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text_image DataAkamaiImagingPolicyImage#text_image}
        :param url_image: url_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url_image DataAkamaiImagingPolicyImage#url_image}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a12dd12d17da03cc270bce2ae03c6571d86d8912308ea270b436ea4fa9c946e4)
            check_type(argname="argument box_image", value=box_image, expected_type=type_hints["box_image"])
            check_type(argname="argument circle_image", value=circle_image, expected_type=type_hints["circle_image"])
            check_type(argname="argument text_image", value=text_image, expected_type=type_hints["text_image"])
            check_type(argname="argument url_image", value=url_image, expected_type=type_hints["url_image"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if box_image is not None:
            self._values["box_image"] = box_image
        if circle_image is not None:
            self._values["circle_image"] = circle_image
        if text_image is not None:
            self._values["text_image"] = text_image
        if url_image is not None:
            self._values["url_image"] = url_image

    @builtins.property
    def box_image(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageBoxImage"]]]:
        '''box_image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#box_image DataAkamaiImagingPolicyImage#box_image}
        '''
        result = self._values.get("box_image")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageBoxImage"]]], result)

    @builtins.property
    def circle_image(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageCircleImage"]]]:
        '''circle_image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#circle_image DataAkamaiImagingPolicyImage#circle_image}
        '''
        result = self._values.get("circle_image")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageCircleImage"]]], result)

    @builtins.property
    def text_image(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageTextImage"]]]:
        '''text_image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text_image DataAkamaiImagingPolicyImage#text_image}
        '''
        result = self._values.get("text_image")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageTextImage"]]], result)

    @builtins.property
    def url_image(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageUrlImage"]]]:
        '''url_image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url_image DataAkamaiImagingPolicyImage#url_image}
        '''
        result = self._values.get("url_image")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageUrlImage"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageBoxImage",
    jsii_struct_bases=[],
    name_mapping={
        "color": "color",
        "color_var": "colorVar",
        "height": "height",
        "height_var": "heightVar",
        "transformation": "transformation",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageBoxImage:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        transformation: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageBoxImageTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The fill color of the box, not the edge of the box. The API supports hexadecimal representation and CSS hexadecimal color values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The fill color of the box, not the edge of the box. The API supports hexadecimal representation and CSS hexadecimal color values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        :param height: The height of the box in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height of the box in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param transformation: transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        :param width: The width of the box in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width of the box in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(transformation, dict):
            transformation = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageBoxImageTransformation(**transformation)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0c3c37a469bfd6c6b61a74e31ad79d658852a0b2c2c7e98fc54579981585d0d0)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument transformation", value=transformation, expected_type=type_hints["transformation"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if transformation is not None:
            self._values["transformation"] = transformation
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The fill color of the box, not the edge of the box.

        The API supports hexadecimal representation and CSS hexadecimal color values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The fill color of the box, not the edge of the box.

        The API supports hexadecimal representation and CSS hexadecimal color values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height of the box in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height of the box in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def transformation(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageBoxImageTransformation"]:
        '''transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        '''
        result = self._values.get("transformation")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageBoxImageTransformation"], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width of the box in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width of the box in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageBoxImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageBoxImageList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageBoxImageList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__efd283372aec20f62603beade79905292b237907a235d6e08235920b471c49b5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageBoxImageOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6ace8077e09e94becfd4a30049c1d55e9d2624e7d6a0e7f2083d4264e006ea78)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageBoxImageOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be6fa563db4e6da7ccd3897811f0d5a30e1bfddad486870ff313f9bffb329106)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__60b6fa300d5ea7ffd5f9a4ad127ddfee91e3569c67d5342afa14c87d53413e5a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c63e56902e94efb592de22e1f196248f9b01038b3430f2bba32ffb75dc7b06e1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageBoxImage]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageBoxImage]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageBoxImage]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7766186e31da3ce4cd6d3b4f0241d6ce11a3b771012e0be7df02ae98a642633e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageBoxImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageBoxImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8ef19cde9cec152dbe4319183866fd1603aeabd53306f988edb142038ae028d8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformation")
    def put_transformation(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageBoxImageTransformation()

        return typing.cast(None, jsii.invoke(self, "putTransformation", [value]))

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetTransformation")
    def reset_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformation", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="transformation")
    def transformation(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageBoxImageTransformationOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageBoxImageTransformationOutputReference", jsii.get(self, "transformation"))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="transformationInput")
    def transformation_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageBoxImageTransformation"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageBoxImageTransformation"], jsii.get(self, "transformationInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__61ec055726f8fe3e8b8aa8b386340514045d94c2beb43510a9ff87d2a326a25b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__37bc3c09f8fc285667937e733f2433f175aefd2d75098d8f6d0a2e5fb8ef6bd7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d0e3f6b9019d6665d3a6c78e45fa5a3d1c01045ca84b7cc03e7d01783570dc7e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__83736ecd6a883156fa2e4cacb26598b11c74c86beb4d664f012d0a4204347dc0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a576ba748e1972de83d8504c621747fe6fda33b8bae3958c4ca0620fc0b9488)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d8b9b01e7d21c79f1ad15795d1647ad7e688ca14aab37208c1050d0fc2900490)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageBoxImage]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageBoxImage]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageBoxImage]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7c72fa111dda724ac31c006d3e30c7dcfcde0bc5336b3d0278883ff297c6b8e7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageBoxImageTransformation",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageBoxImageTransformation:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageBoxImageTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageBoxImageTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageBoxImageTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ec364077c885ec36957f37757ad500cddd19b22ee0e4f63903a883c51a5d18ea)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageBoxImageTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageBoxImageTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageBoxImageTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8c888e99d74ad378164d906fe24116c51eb3bdf408066ebbb80b39b07e5d753d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageCircleImage",
    jsii_struct_bases=[],
    name_mapping={
        "color": "color",
        "color_var": "colorVar",
        "diameter": "diameter",
        "diameter_var": "diameterVar",
        "transformation": "transformation",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageCircleImage:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
        diameter: typing.Optional[builtins.str] = None,
        diameter_var: typing.Optional[builtins.str] = None,
        transformation: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageCircleImageTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The fill color of the circle. The API supports hexadecimal representation and CSS hexadecimal color values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The fill color of the circle. The API supports hexadecimal representation and CSS hexadecimal color values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        :param diameter: The diameter of the circle. The diameter will be the width and the height of the image in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#diameter DataAkamaiImagingPolicyImage#diameter}
        :param diameter_var: The diameter of the circle. The diameter will be the width and the height of the image in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#diameter_var DataAkamaiImagingPolicyImage#diameter_var}
        :param transformation: transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        :param width: The width of the box in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width of the box in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(transformation, dict):
            transformation = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageCircleImageTransformation(**transformation)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bfd20c02c16b1bda0d02e68a4297cb4d99a308e54004ecbbde509fb31fd8ab11)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
            check_type(argname="argument diameter", value=diameter, expected_type=type_hints["diameter"])
            check_type(argname="argument diameter_var", value=diameter_var, expected_type=type_hints["diameter_var"])
            check_type(argname="argument transformation", value=transformation, expected_type=type_hints["transformation"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var
        if diameter is not None:
            self._values["diameter"] = diameter
        if diameter_var is not None:
            self._values["diameter_var"] = diameter_var
        if transformation is not None:
            self._values["transformation"] = transformation
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The fill color of the circle. The API supports hexadecimal representation and CSS hexadecimal color values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The fill color of the circle. The API supports hexadecimal representation and CSS hexadecimal color values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def diameter(self) -> typing.Optional[builtins.str]:
        '''The diameter of the circle. The diameter will be the width and the height of the image in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#diameter DataAkamaiImagingPolicyImage#diameter}
        '''
        result = self._values.get("diameter")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def diameter_var(self) -> typing.Optional[builtins.str]:
        '''The diameter of the circle. The diameter will be the width and the height of the image in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#diameter_var DataAkamaiImagingPolicyImage#diameter_var}
        '''
        result = self._values.get("diameter_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def transformation(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageCircleImageTransformation"]:
        '''transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        '''
        result = self._values.get("transformation")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageCircleImageTransformation"], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width of the box in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width of the box in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageCircleImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageCircleImageList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageCircleImageList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d0358b54d7c5f735114eea5a942038ec1581a6eb110a1b770e0b1747823a8bc2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageCircleImageOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5a0e26580475db513f280e128edc33284e6b641f283bc97adfe78e9faa7858fe)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageCircleImageOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2611fd0a58f8d18af217e2299a2351eb9e6ccf76fa38843dfca6d80305eda2f2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bf6893b1d670be52a93c226f6bf9770db3949a697c9befd2923af67e98e77072)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f6d86f6ceb3473de4f29091ef940aef17e3dc9c1b07cf2c4227a37ac12022945)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageCircleImage]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageCircleImage]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageCircleImage]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6529276c624816010c9edecb0644c7902943ec576a3e4aa716ef94d8a0b52dde)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageCircleImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageCircleImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d1ee99e153a87aa63ddc59eb748f65ed3dcccbb80cfda6577951a9af9f4adbb9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformation")
    def put_transformation(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageCircleImageTransformation()

        return typing.cast(None, jsii.invoke(self, "putTransformation", [value]))

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @jsii.member(jsii_name="resetDiameter")
    def reset_diameter(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDiameter", []))

    @jsii.member(jsii_name="resetDiameterVar")
    def reset_diameter_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDiameterVar", []))

    @jsii.member(jsii_name="resetTransformation")
    def reset_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformation", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="transformation")
    def transformation(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageCircleImageTransformationOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageCircleImageTransformationOutputReference", jsii.get(self, "transformation"))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="diameterInput")
    def diameter_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "diameterInput"))

    @builtins.property
    @jsii.member(jsii_name="diameterVarInput")
    def diameter_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "diameterVarInput"))

    @builtins.property
    @jsii.member(jsii_name="transformationInput")
    def transformation_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageCircleImageTransformation"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageCircleImageTransformation"], jsii.get(self, "transformationInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0cc13d8d76c5b317971b436aa52401c8a7aee4312c01236c9ac392c66d3090ab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__085c826da8f1646414fcc1fa0fafbf6ae5e6fcf8f1b5a7488d0ad47766e510ba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="diameter")
    def diameter(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "diameter"))

    @diameter.setter
    def diameter(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a3f3b4d7a4758d3bb5f6dc2f8a4dea537a537f21d87ed0ad45d0f31cf1e4ca64)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "diameter", value)

    @builtins.property
    @jsii.member(jsii_name="diameterVar")
    def diameter_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "diameterVar"))

    @diameter_var.setter
    def diameter_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__95e55653c200c52dc0e174027c12fc5147887aa2372f5c406eb846f850b0f91e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "diameterVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__55ecfe00ef2eb623a364f585da24afe06ae75cf0dba64fa088463774031a399a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1c1445d2535fa78b815188204e40f1ba079d38b6cd6de25e9b679e38978c5404)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageCircleImage]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageCircleImage]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageCircleImage]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__00f18da29aec5e2601b33abe37f0aae91394daa8b0500649757630552ca7ebba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageCircleImageTransformation",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageCircleImageTransformation:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageCircleImageTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageCircleImageTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageCircleImageTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__189541316a72168f2defabdabb8eaa2d111caadf698c538f690afd4e85617084)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageCircleImageTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageCircleImageTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageCircleImageTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1e97394c373275872f009f5b08fc9a6551ce932e622afc019b25e468296d2ed0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__86bf1a90c44864c947cdd2702ce3e265818bd250f3556fb384f6fde483280f7a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putBoxImage")
    def put_box_image(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageBoxImage, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e4d833d0183c9b1953d61847d929a53a1be11629e51906d4da559ed1b3e5df2e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBoxImage", [value]))

    @jsii.member(jsii_name="putCircleImage")
    def put_circle_image(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageCircleImage, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__603fae559399ad2dc41d9b81751cec3457a79ea0aebb659934df682dd2af3d71)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCircleImage", [value]))

    @jsii.member(jsii_name="putTextImage")
    def put_text_image(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageTextImage", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0179a8ee7a1b743490a6f2b2dc9f72cd6cf4e87dc7674ffb9c309549b21e9d26)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTextImage", [value]))

    @jsii.member(jsii_name="putUrlImage")
    def put_url_image(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageUrlImage", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__435bcd305651103ba05f69469907932152fb80b5ffc64205d4e16b7f746f8ae3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putUrlImage", [value]))

    @jsii.member(jsii_name="resetBoxImage")
    def reset_box_image(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBoxImage", []))

    @jsii.member(jsii_name="resetCircleImage")
    def reset_circle_image(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCircleImage", []))

    @jsii.member(jsii_name="resetTextImage")
    def reset_text_image(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTextImage", []))

    @jsii.member(jsii_name="resetUrlImage")
    def reset_url_image(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUrlImage", []))

    @builtins.property
    @jsii.member(jsii_name="boxImage")
    def box_image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageBoxImageList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageBoxImageList, jsii.get(self, "boxImage"))

    @builtins.property
    @jsii.member(jsii_name="circleImage")
    def circle_image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageCircleImageList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageCircleImageList, jsii.get(self, "circleImage"))

    @builtins.property
    @jsii.member(jsii_name="textImage")
    def text_image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageTextImageList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageTextImageList", jsii.get(self, "textImage"))

    @builtins.property
    @jsii.member(jsii_name="urlImage")
    def url_image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageUrlImageList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageUrlImageList", jsii.get(self, "urlImage"))

    @builtins.property
    @jsii.member(jsii_name="boxImageInput")
    def box_image_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageBoxImage]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageBoxImage]]], jsii.get(self, "boxImageInput"))

    @builtins.property
    @jsii.member(jsii_name="circleImageInput")
    def circle_image_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageCircleImage]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageCircleImage]]], jsii.get(self, "circleImageInput"))

    @builtins.property
    @jsii.member(jsii_name="textImageInput")
    def text_image_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageTextImage"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageTextImage"]]], jsii.get(self, "textImageInput"))

    @builtins.property
    @jsii.member(jsii_name="urlImageInput")
    def url_image_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageUrlImage"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageUrlImage"]]], jsii.get(self, "urlImageInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0cc49941debb0757f468f84993142f8f2efda79a580d93957d4753b6d247e27b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageTextImage",
    jsii_struct_bases=[],
    name_mapping={
        "fill": "fill",
        "fill_var": "fillVar",
        "size": "size",
        "size_var": "sizeVar",
        "stroke": "stroke",
        "stroke_size": "strokeSize",
        "stroke_size_var": "strokeSizeVar",
        "stroke_var": "strokeVar",
        "text": "text",
        "text_var": "textVar",
        "transformation": "transformation",
        "typeface": "typeface",
        "typeface_var": "typefaceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageTextImage:
    def __init__(
        self,
        *,
        fill: typing.Optional[builtins.str] = None,
        fill_var: typing.Optional[builtins.str] = None,
        size: typing.Optional[builtins.str] = None,
        size_var: typing.Optional[builtins.str] = None,
        stroke: typing.Optional[builtins.str] = None,
        stroke_size: typing.Optional[builtins.str] = None,
        stroke_size_var: typing.Optional[builtins.str] = None,
        stroke_var: typing.Optional[builtins.str] = None,
        text: typing.Optional[builtins.str] = None,
        text_var: typing.Optional[builtins.str] = None,
        transformation: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageTextImageTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        typeface: typing.Optional[builtins.str] = None,
        typeface_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fill: The main fill color of the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill DataAkamaiImagingPolicyImage#fill}
        :param fill_var: The main fill color of the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_var DataAkamaiImagingPolicyImage#fill_var}
        :param size: The size in pixels to render the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#size DataAkamaiImagingPolicyImage#size}
        :param size_var: The size in pixels to render the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#size_var DataAkamaiImagingPolicyImage#size_var}
        :param stroke: The color for the outline of the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke DataAkamaiImagingPolicyImage#stroke}
        :param stroke_size: The thickness in points for the outline of the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_size DataAkamaiImagingPolicyImage#stroke_size}
        :param stroke_size_var: The thickness in points for the outline of the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_size_var DataAkamaiImagingPolicyImage#stroke_size_var}
        :param stroke_var: The color for the outline of the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_var DataAkamaiImagingPolicyImage#stroke_var}
        :param text: The line of text to render. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text DataAkamaiImagingPolicyImage#text}
        :param text_var: The line of text to render. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text_var DataAkamaiImagingPolicyImage#text_var}
        :param transformation: transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        :param typeface: The font family to apply to the text image. This may be a URL to a TrueType or WOFF (v1) typeface, or a string that refers to one of the standard built-in browser fonts. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#typeface DataAkamaiImagingPolicyImage#typeface}
        :param typeface_var: The font family to apply to the text image. This may be a URL to a TrueType or WOFF (v1) typeface, or a string that refers to one of the standard built-in browser fonts. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#typeface_var DataAkamaiImagingPolicyImage#typeface_var}
        '''
        if isinstance(transformation, dict):
            transformation = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageTextImageTransformation(**transformation)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__276f62deae4b9f65aac8ff90825ca25b1e30fcb6ff69e1faf890f4ec14517a66)
            check_type(argname="argument fill", value=fill, expected_type=type_hints["fill"])
            check_type(argname="argument fill_var", value=fill_var, expected_type=type_hints["fill_var"])
            check_type(argname="argument size", value=size, expected_type=type_hints["size"])
            check_type(argname="argument size_var", value=size_var, expected_type=type_hints["size_var"])
            check_type(argname="argument stroke", value=stroke, expected_type=type_hints["stroke"])
            check_type(argname="argument stroke_size", value=stroke_size, expected_type=type_hints["stroke_size"])
            check_type(argname="argument stroke_size_var", value=stroke_size_var, expected_type=type_hints["stroke_size_var"])
            check_type(argname="argument stroke_var", value=stroke_var, expected_type=type_hints["stroke_var"])
            check_type(argname="argument text", value=text, expected_type=type_hints["text"])
            check_type(argname="argument text_var", value=text_var, expected_type=type_hints["text_var"])
            check_type(argname="argument transformation", value=transformation, expected_type=type_hints["transformation"])
            check_type(argname="argument typeface", value=typeface, expected_type=type_hints["typeface"])
            check_type(argname="argument typeface_var", value=typeface_var, expected_type=type_hints["typeface_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fill is not None:
            self._values["fill"] = fill
        if fill_var is not None:
            self._values["fill_var"] = fill_var
        if size is not None:
            self._values["size"] = size
        if size_var is not None:
            self._values["size_var"] = size_var
        if stroke is not None:
            self._values["stroke"] = stroke
        if stroke_size is not None:
            self._values["stroke_size"] = stroke_size
        if stroke_size_var is not None:
            self._values["stroke_size_var"] = stroke_size_var
        if stroke_var is not None:
            self._values["stroke_var"] = stroke_var
        if text is not None:
            self._values["text"] = text
        if text_var is not None:
            self._values["text_var"] = text_var
        if transformation is not None:
            self._values["transformation"] = transformation
        if typeface is not None:
            self._values["typeface"] = typeface
        if typeface_var is not None:
            self._values["typeface_var"] = typeface_var

    @builtins.property
    def fill(self) -> typing.Optional[builtins.str]:
        '''The main fill color of the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill DataAkamaiImagingPolicyImage#fill}
        '''
        result = self._values.get("fill")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fill_var(self) -> typing.Optional[builtins.str]:
        '''The main fill color of the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_var DataAkamaiImagingPolicyImage#fill_var}
        '''
        result = self._values.get("fill_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def size(self) -> typing.Optional[builtins.str]:
        '''The size in pixels to render the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#size DataAkamaiImagingPolicyImage#size}
        '''
        result = self._values.get("size")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def size_var(self) -> typing.Optional[builtins.str]:
        '''The size in pixels to render the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#size_var DataAkamaiImagingPolicyImage#size_var}
        '''
        result = self._values.get("size_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def stroke(self) -> typing.Optional[builtins.str]:
        '''The color for the outline of the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke DataAkamaiImagingPolicyImage#stroke}
        '''
        result = self._values.get("stroke")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def stroke_size(self) -> typing.Optional[builtins.str]:
        '''The thickness in points for the outline of the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_size DataAkamaiImagingPolicyImage#stroke_size}
        '''
        result = self._values.get("stroke_size")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def stroke_size_var(self) -> typing.Optional[builtins.str]:
        '''The thickness in points for the outline of the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_size_var DataAkamaiImagingPolicyImage#stroke_size_var}
        '''
        result = self._values.get("stroke_size_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def stroke_var(self) -> typing.Optional[builtins.str]:
        '''The color for the outline of the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_var DataAkamaiImagingPolicyImage#stroke_var}
        '''
        result = self._values.get("stroke_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def text(self) -> typing.Optional[builtins.str]:
        '''The line of text to render.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text DataAkamaiImagingPolicyImage#text}
        '''
        result = self._values.get("text")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def text_var(self) -> typing.Optional[builtins.str]:
        '''The line of text to render.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text_var DataAkamaiImagingPolicyImage#text_var}
        '''
        result = self._values.get("text_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def transformation(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageTextImageTransformation"]:
        '''transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        '''
        result = self._values.get("transformation")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageTextImageTransformation"], result)

    @builtins.property
    def typeface(self) -> typing.Optional[builtins.str]:
        '''The font family to apply to the text image.

        This may be a URL to a TrueType or WOFF (v1) typeface, or a string that refers to one of the standard built-in browser fonts.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#typeface DataAkamaiImagingPolicyImage#typeface}
        '''
        result = self._values.get("typeface")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def typeface_var(self) -> typing.Optional[builtins.str]:
        '''The font family to apply to the text image.

        This may be a URL to a TrueType or WOFF (v1) typeface, or a string that refers to one of the standard built-in browser fonts.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#typeface_var DataAkamaiImagingPolicyImage#typeface_var}
        '''
        result = self._values.get("typeface_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageTextImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageTextImageList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageTextImageList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4dc1b7cacb5455ea95f156e3a58ab8efbddca7e54ec27a5ebad1300b4e0df7a9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageTextImageOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c2bd3162a1dec4100eac25f2745add015cefd7086cbcfc17e27f51fe397c6e99)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageTextImageOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__03f4d03d570e9656eba893426fecc843d17a46965112c0110fced29dd4acee40)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2eb23bf646070c6c3dfbbbd2b022c7e37430b5a4472f45a1a2484dc57857d06b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f5b15a240a01bafe5b9d6a3208a534c585c028ac5db6fb03a7a989387ba2ce13)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageTextImage]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageTextImage]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageTextImage]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__246b51021472978aaf7ba1308c3b9539d1c5c6590023815dc457bea4985f36c6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageTextImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageTextImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__17fd340af4b50ad26c0d0728c172f4b9a0a70ac547f7c2b37bbc76aad707f564)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformation")
    def put_transformation(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageTextImageTransformation()

        return typing.cast(None, jsii.invoke(self, "putTransformation", [value]))

    @jsii.member(jsii_name="resetFill")
    def reset_fill(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFill", []))

    @jsii.member(jsii_name="resetFillVar")
    def reset_fill_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFillVar", []))

    @jsii.member(jsii_name="resetSize")
    def reset_size(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSize", []))

    @jsii.member(jsii_name="resetSizeVar")
    def reset_size_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSizeVar", []))

    @jsii.member(jsii_name="resetStroke")
    def reset_stroke(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStroke", []))

    @jsii.member(jsii_name="resetStrokeSize")
    def reset_stroke_size(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStrokeSize", []))

    @jsii.member(jsii_name="resetStrokeSizeVar")
    def reset_stroke_size_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStrokeSizeVar", []))

    @jsii.member(jsii_name="resetStrokeVar")
    def reset_stroke_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStrokeVar", []))

    @jsii.member(jsii_name="resetText")
    def reset_text(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetText", []))

    @jsii.member(jsii_name="resetTextVar")
    def reset_text_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTextVar", []))

    @jsii.member(jsii_name="resetTransformation")
    def reset_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformation", []))

    @jsii.member(jsii_name="resetTypeface")
    def reset_typeface(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeface", []))

    @jsii.member(jsii_name="resetTypefaceVar")
    def reset_typeface_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypefaceVar", []))

    @builtins.property
    @jsii.member(jsii_name="transformation")
    def transformation(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageTextImageTransformationOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageTextImageTransformationOutputReference", jsii.get(self, "transformation"))

    @builtins.property
    @jsii.member(jsii_name="fillInput")
    def fill_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fillInput"))

    @builtins.property
    @jsii.member(jsii_name="fillVarInput")
    def fill_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fillVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sizeInput")
    def size_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sizeInput"))

    @builtins.property
    @jsii.member(jsii_name="sizeVarInput")
    def size_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sizeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="strokeInput")
    def stroke_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "strokeInput"))

    @builtins.property
    @jsii.member(jsii_name="strokeSizeInput")
    def stroke_size_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "strokeSizeInput"))

    @builtins.property
    @jsii.member(jsii_name="strokeSizeVarInput")
    def stroke_size_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "strokeSizeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="strokeVarInput")
    def stroke_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "strokeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="textInput")
    def text_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "textInput"))

    @builtins.property
    @jsii.member(jsii_name="textVarInput")
    def text_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "textVarInput"))

    @builtins.property
    @jsii.member(jsii_name="transformationInput")
    def transformation_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageTextImageTransformation"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageTextImageTransformation"], jsii.get(self, "transformationInput"))

    @builtins.property
    @jsii.member(jsii_name="typefaceInput")
    def typeface_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typefaceInput"))

    @builtins.property
    @jsii.member(jsii_name="typefaceVarInput")
    def typeface_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typefaceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="fill")
    def fill(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fill"))

    @fill.setter
    def fill(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c51400f0d2f76ce6f1aa1e21c293486a9ecb6b82a969f58e7274b6ff2b710872)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fill", value)

    @builtins.property
    @jsii.member(jsii_name="fillVar")
    def fill_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fillVar"))

    @fill_var.setter
    def fill_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b90c600365b2c8f1a51df1df435f6591c547c8ce694d3387ac868f679240f395)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fillVar", value)

    @builtins.property
    @jsii.member(jsii_name="size")
    def size(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "size"))

    @size.setter
    def size(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c01ddfabe02d17059449b37cead98cd14eabea2aca7b738255d7c725dfce5518)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "size", value)

    @builtins.property
    @jsii.member(jsii_name="sizeVar")
    def size_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sizeVar"))

    @size_var.setter
    def size_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__36f2aeca76bd8104b4a3703721b1ccaf258fa9b5e8b5ca41d79d8220c589bddc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sizeVar", value)

    @builtins.property
    @jsii.member(jsii_name="stroke")
    def stroke(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "stroke"))

    @stroke.setter
    def stroke(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e79bef0180f367f5fc5fff8977a383a501efe01010c82919883a558b8d869ef9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "stroke", value)

    @builtins.property
    @jsii.member(jsii_name="strokeSize")
    def stroke_size(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "strokeSize"))

    @stroke_size.setter
    def stroke_size(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c5f1434c25891ba6ee83b429130639fe069e26f5e44d043dce3fd75d72357e6c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "strokeSize", value)

    @builtins.property
    @jsii.member(jsii_name="strokeSizeVar")
    def stroke_size_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "strokeSizeVar"))

    @stroke_size_var.setter
    def stroke_size_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3cc75db2295372dc8551e47b1b0c63000a19cdb57135280cd77058ffa729876a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "strokeSizeVar", value)

    @builtins.property
    @jsii.member(jsii_name="strokeVar")
    def stroke_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "strokeVar"))

    @stroke_var.setter
    def stroke_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__513564ce8900df846a99ae786f67ad095338ebdd74f2d847fd506e0a9110973f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "strokeVar", value)

    @builtins.property
    @jsii.member(jsii_name="text")
    def text(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "text"))

    @text.setter
    def text(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__67eb09c003af137e09bfee0cacbec022ccee4ee3b77c7ea889bd27359550fe9a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "text", value)

    @builtins.property
    @jsii.member(jsii_name="textVar")
    def text_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "textVar"))

    @text_var.setter
    def text_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__90caf5493db1bfbff0cfcb5ddf86ff6059056c3d2fe75ec8556f6692fbd77d09)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "textVar", value)

    @builtins.property
    @jsii.member(jsii_name="typeface")
    def typeface(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeface"))

    @typeface.setter
    def typeface(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5501f56521a1f0fd2d01a000efc1ca7c461e7b8189efe6243304b97bc2a4d8f9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeface", value)

    @builtins.property
    @jsii.member(jsii_name="typefaceVar")
    def typeface_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typefaceVar"))

    @typeface_var.setter
    def typeface_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7ad3185ce324f49ab2bbeae3a8f270c707ed6b10bec0157ba46057bcd1804ed5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typefaceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageTextImage]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageTextImage]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageTextImage]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__288e061072517338af7e11acff7260b977ec44b121ceb575f068984f893f3500)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageTextImageTransformation",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageTextImageTransformation:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageTextImageTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageTextImageTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageTextImageTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b915898a6175996f2dfcb7e8dac6376b0f6e4c563ed02309253252b5e04a088b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageTextImageTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageTextImageTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageTextImageTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__03991712c733206919c9bca16c28de2e0ede01e6f7a350efa2acc66267eacdf0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageUrlImage",
    jsii_struct_bases=[],
    name_mapping={
        "transformation": "transformation",
        "url": "url",
        "url_var": "urlVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageUrlImage:
    def __init__(
        self,
        *,
        transformation: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageUrlImageTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        url: typing.Optional[builtins.str] = None,
        url_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param transformation: transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        :param url: The URL of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url DataAkamaiImagingPolicyImage#url}
        :param url_var: The URL of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url_var DataAkamaiImagingPolicyImage#url_var}
        '''
        if isinstance(transformation, dict):
            transformation = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageUrlImageTransformation(**transformation)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__56b32649cc6ca7a6403c9c3d79b37452c659872a71daec960b3d7eb49bf4dd22)
            check_type(argname="argument transformation", value=transformation, expected_type=type_hints["transformation"])
            check_type(argname="argument url", value=url, expected_type=type_hints["url"])
            check_type(argname="argument url_var", value=url_var, expected_type=type_hints["url_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if transformation is not None:
            self._values["transformation"] = transformation
        if url is not None:
            self._values["url"] = url
        if url_var is not None:
            self._values["url_var"] = url_var

    @builtins.property
    def transformation(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageUrlImageTransformation"]:
        '''transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        '''
        result = self._values.get("transformation")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageUrlImageTransformation"], result)

    @builtins.property
    def url(self) -> typing.Optional[builtins.str]:
        '''The URL of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url DataAkamaiImagingPolicyImage#url}
        '''
        result = self._values.get("url")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def url_var(self) -> typing.Optional[builtins.str]:
        '''The URL of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url_var DataAkamaiImagingPolicyImage#url_var}
        '''
        result = self._values.get("url_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageUrlImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageUrlImageList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageUrlImageList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7284957023ce88f4f356dd67304434c2d02abd688606b84640f13f46d6ae71b2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageUrlImageOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__062eee1cd0d5d4b7434ce45ae12445b0c347325487edf6e5dae3adc711201ce3)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageUrlImageOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a1cedfa7af3e856cda4d404de80be763bac95fad724776d01284d7d0262923a6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__39952b8963e5f15053456b6736638cb0315ec7bff0fcfcd0b03ac207efc8dc0d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e6e6b7f7ce7e345cb4d919f31776676dfa52f58e017d275866286f408e269b7d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageUrlImage]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageUrlImage]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageUrlImage]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a4fd6a269b49eaff178c85e1e87c3aba3da41234bc087d96a02793d4ead07c33)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageUrlImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageUrlImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b97066d1d1e4d8f8199c443900e23e8707ee03b32b79e68a1d706708523fb72a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformation")
    def put_transformation(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageUrlImageTransformation()

        return typing.cast(None, jsii.invoke(self, "putTransformation", [value]))

    @jsii.member(jsii_name="resetTransformation")
    def reset_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformation", []))

    @jsii.member(jsii_name="resetUrl")
    def reset_url(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUrl", []))

    @jsii.member(jsii_name="resetUrlVar")
    def reset_url_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUrlVar", []))

    @builtins.property
    @jsii.member(jsii_name="transformation")
    def transformation(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageUrlImageTransformationOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageUrlImageTransformationOutputReference", jsii.get(self, "transformation"))

    @builtins.property
    @jsii.member(jsii_name="transformationInput")
    def transformation_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageUrlImageTransformation"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageUrlImageTransformation"], jsii.get(self, "transformationInput"))

    @builtins.property
    @jsii.member(jsii_name="urlInput")
    def url_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "urlInput"))

    @builtins.property
    @jsii.member(jsii_name="urlVarInput")
    def url_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "urlVarInput"))

    @builtins.property
    @jsii.member(jsii_name="url")
    def url(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "url"))

    @url.setter
    def url(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9845a649cc3a667efebe5d77edd6cbdb34337e36f2b2ece10677330680feba0e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "url", value)

    @builtins.property
    @jsii.member(jsii_name="urlVar")
    def url_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "urlVar"))

    @url_var.setter
    def url_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b3d5e0fb7cf4bbc62d7a329bcac4c0f934dfccf1f4ade39d1d8c5eefb0cbbebb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "urlVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageUrlImage]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageUrlImage]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageUrlImage]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d493a83f8768236b9c1468b87a64a8a698781f36034ab28e6a04223cbe0c8a2f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageUrlImageTransformation",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageUrlImageTransformation:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageUrlImageTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageUrlImageTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageUrlImageTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f06eb3e876749ae7de724fc660ec6a2ce56d899e453a8853031c9f0b5a20da4d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageUrlImageTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageUrlImageTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageUrlImageTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ae5077488c1592755ba536120a6c35ff409d341bb3651c5c5c886d4befacfb89)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3377cce592e6fd37f7c92d3ffefd9fc515c848de841cac7b1ed180df93de5350)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b25d7ea49a7e5d327928df480f146a7b1132387be629b2e2d0cd96dc4a86d2b0)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cca2b6554265ba5b6ff09bd0b796e4abce45d566b5adb6a781284a01de81bf5f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e81eae6c74a168880e4d3b5a4f3d3026e72ae8559ff7c43caf2b307442c0ff18)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__85806b2f61bce829249ac1c571cd5e38061de2d0c355c1901d39247cca97e9c8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanComposite]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanComposite]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2f10ab71a14870bf8fd1d062420d11a154ea10edeeac5c3c9e544539c36f53ec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5a91ab5b175805259651325b9e7d8ae4c2e3af6318558f63d62f4abd829038b5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(
        self,
        *,
        box_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageBoxImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
        circle_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageCircleImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
        text_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageTextImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
        url_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageUrlImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param box_image: box_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#box_image DataAkamaiImagingPolicyImage#box_image}
        :param circle_image: circle_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#circle_image DataAkamaiImagingPolicyImage#circle_image}
        :param text_image: text_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text_image DataAkamaiImagingPolicyImage#text_image}
        :param url_image: url_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url_image DataAkamaiImagingPolicyImage#url_image}
        '''
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImage(
            box_image=box_image,
            circle_image=circle_image,
            text_image=text_image,
            url_image=url_image,
        )

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPlacement")
    def reset_placement(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacement", []))

    @jsii.member(jsii_name="resetPlacementVar")
    def reset_placement_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacementVar", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetScaleDimension")
    def reset_scale_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimension", []))

    @jsii.member(jsii_name="resetScaleDimensionVar")
    def reset_scale_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimensionVar", []))

    @jsii.member(jsii_name="resetScaleVar")
    def reset_scale_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="placementInput")
    def placement_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementInput"))

    @builtins.property
    @jsii.member(jsii_name="placementVarInput")
    def placement_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionInput")
    def scale_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVarInput")
    def scale_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleVarInput")
    def scale_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6853c8310a58a645978784c5833ab1a1f8942fc13f03cc1a64feeec937560cf9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__075b4af6887b77646de3e1b491c5c076046d83dd710f8c79b08b41802d2568b5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="placement")
    def placement(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placement"))

    @placement.setter
    def placement(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__52280f5ebb44c8b29e7ceee7635aacb430a1aa8ad2c78cff0159f9e8eea9cbe0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placement", value)

    @builtins.property
    @jsii.member(jsii_name="placementVar")
    def placement_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placementVar"))

    @placement_var.setter
    def placement_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__660036ba379a41b928ef06a37c783fe173b223641233f783f3dde710e734d3f8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placementVar", value)

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scale"))

    @scale.setter
    def scale(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1e00952cb5bfef1cf572b1df0e730bf105b8344fcc205aeda8ed8b6a202e5350)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scale", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimension")
    def scale_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimension"))

    @scale_dimension.setter
    def scale_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ebfc229bee6263e622262e131be5c64338cdcacecd3a173d0a9fe3c5a8836bb0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimension", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVar")
    def scale_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimensionVar"))

    @scale_dimension_var.setter
    def scale_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aadd9772d1deceeb6d976577632cb89f0aa87b26827e5c817e98bbe94800c751)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="scaleVar")
    def scale_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleVar"))

    @scale_var.setter
    def scale_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e904b51ad4f1acad1ee5bd0ca99a2232ce96fd233a49b35fb43fb753ddf9ff2d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f97aac57287883df6b4c56c6ff6fe58028a3bf388ce52c4078a443c9e8cae2fe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ece7509187d12babf44fec87b33efba88fda960685d4477563dba2eaaaa82ba7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__589a051bdbb0f0652236ccef76a37cfc16073eeb33758d58a49c080554fa8df1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f21aa68ecbb69b58a49bbd44f0fa038226203d887207bdd0e859634763aeb2b8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanComposite]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanComposite]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanComposite]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1e399880ffd05d44ba0a458697cff5d4bb06ab8ab49b877859e85ae48f5a58d0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompound",
    jsii_struct_bases=[],
    name_mapping={"transformations": "transformations"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompound:
    def __init__(
        self,
        *,
        transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param transformations: transformations block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6de384b7bd66d975f097726fdae7d9b0aa6944c264ba7da5f407ff06ab057969)
            check_type(argname="argument transformations", value=transformations, expected_type=type_hints["transformations"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if transformations is not None:
            self._values["transformations"] = transformations

    @builtins.property
    def transformations(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformations"]]]:
        '''transformations block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        result = self._values.get("transformations")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformations"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompound(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f684fc154479ebaddb8dd052042784f6240da5c85526800c8fa34b272f7486c8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__246047c1a16029b01ec5ac13a1679cc1e105da623f9e7a02d94b43afa466451e)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eedecf239f34652dc71a3d0a11f2a174384224ba0828b99075a8318c41b66721)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bfc44a9fde59fb2f1224b4fd044268101314086a9b98c5414d753f608c0e9347)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cbe97e488c58fece48759a03308fd8a8f6eeac2d2b3f37d188f4dbe1e6dbbfe9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompound]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompound]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__62907ba7d004ebf7ac64807bf808a6d6718e4bf43c23b61786ce7f15802c6b1a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2e4360d45eaf2d6e5dcbf88fb4b78a215eedd78106b283fba537fad2aa2deae9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformations")
    def put_transformations(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__18297cafde5f43b6e2b42d343991fda9cd44f0cc1a1071f00845bda64e90b777)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTransformations", [value]))

    @jsii.member(jsii_name="resetTransformations")
    def reset_transformations(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformations", []))

    @builtins.property
    @jsii.member(jsii_name="transformations")
    def transformations(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsList", jsii.get(self, "transformations"))

    @builtins.property
    @jsii.member(jsii_name="transformationsInput")
    def transformations_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformations"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformations"]]], jsii.get(self, "transformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompound]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompound]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompound]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd4cb090ebc584c5ddd907d1dcc542c023d7bdd206164fc6d6caafae757484e0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformations",
    jsii_struct_bases=[],
    name_mapping={
        "background_color": "backgroundColor",
        "blur": "blur",
        "chroma_key": "chromaKey",
        "composite": "composite",
        "compound": "compound",
        "contrast": "contrast",
        "goop": "goop",
        "grayscale": "grayscale",
        "hsl": "hsl",
        "hsv": "hsv",
        "if_dimension": "ifDimension",
        "if_orientation": "ifOrientation",
        "max_colors": "maxColors",
        "mirror": "mirror",
        "mono_hue": "monoHue",
        "opacity": "opacity",
        "remove_color": "removeColor",
        "unsharp_mask": "unsharpMask",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformations:
    def __init__(
        self,
        *,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsBackgroundColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsBlur", typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsChromaKey", typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsComposite", typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsCompound", typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsContrast", typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsGoop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsGrayscale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsHsl", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsHsv", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfDimension", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfOrientation", typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsMaxColors", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsMirror", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsMonoHue", typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsOpacity", typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsRemoveColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsUnsharpMask", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__62661424489361ffc02169a08c2cb22fefc8f51e8aff9d8b15512fad31e096ff)
            check_type(argname="argument background_color", value=background_color, expected_type=type_hints["background_color"])
            check_type(argname="argument blur", value=blur, expected_type=type_hints["blur"])
            check_type(argname="argument chroma_key", value=chroma_key, expected_type=type_hints["chroma_key"])
            check_type(argname="argument composite", value=composite, expected_type=type_hints["composite"])
            check_type(argname="argument compound", value=compound, expected_type=type_hints["compound"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument goop", value=goop, expected_type=type_hints["goop"])
            check_type(argname="argument grayscale", value=grayscale, expected_type=type_hints["grayscale"])
            check_type(argname="argument hsl", value=hsl, expected_type=type_hints["hsl"])
            check_type(argname="argument hsv", value=hsv, expected_type=type_hints["hsv"])
            check_type(argname="argument if_dimension", value=if_dimension, expected_type=type_hints["if_dimension"])
            check_type(argname="argument if_orientation", value=if_orientation, expected_type=type_hints["if_orientation"])
            check_type(argname="argument max_colors", value=max_colors, expected_type=type_hints["max_colors"])
            check_type(argname="argument mirror", value=mirror, expected_type=type_hints["mirror"])
            check_type(argname="argument mono_hue", value=mono_hue, expected_type=type_hints["mono_hue"])
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument remove_color", value=remove_color, expected_type=type_hints["remove_color"])
            check_type(argname="argument unsharp_mask", value=unsharp_mask, expected_type=type_hints["unsharp_mask"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if background_color is not None:
            self._values["background_color"] = background_color
        if blur is not None:
            self._values["blur"] = blur
        if chroma_key is not None:
            self._values["chroma_key"] = chroma_key
        if composite is not None:
            self._values["composite"] = composite
        if compound is not None:
            self._values["compound"] = compound
        if contrast is not None:
            self._values["contrast"] = contrast
        if goop is not None:
            self._values["goop"] = goop
        if grayscale is not None:
            self._values["grayscale"] = grayscale
        if hsl is not None:
            self._values["hsl"] = hsl
        if hsv is not None:
            self._values["hsv"] = hsv
        if if_dimension is not None:
            self._values["if_dimension"] = if_dimension
        if if_orientation is not None:
            self._values["if_orientation"] = if_orientation
        if max_colors is not None:
            self._values["max_colors"] = max_colors
        if mirror is not None:
            self._values["mirror"] = mirror
        if mono_hue is not None:
            self._values["mono_hue"] = mono_hue
        if opacity is not None:
            self._values["opacity"] = opacity
        if remove_color is not None:
            self._values["remove_color"] = remove_color
        if unsharp_mask is not None:
            self._values["unsharp_mask"] = unsharp_mask

    @builtins.property
    def background_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsBackgroundColor"]]]:
        '''background_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        '''
        result = self._values.get("background_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsBackgroundColor"]]], result)

    @builtins.property
    def blur(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsBlur"]]]:
        '''blur block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        '''
        result = self._values.get("blur")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsBlur"]]], result)

    @builtins.property
    def chroma_key(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsChromaKey"]]]:
        '''chroma_key block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        '''
        result = self._values.get("chroma_key")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsChromaKey"]]], result)

    @builtins.property
    def composite(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsComposite"]]]:
        '''composite block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        '''
        result = self._values.get("composite")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsComposite"]]], result)

    @builtins.property
    def compound(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsCompound"]]]:
        '''compound block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        '''
        result = self._values.get("compound")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsCompound"]]], result)

    @builtins.property
    def contrast(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsContrast"]]]:
        '''contrast block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsContrast"]]], result)

    @builtins.property
    def goop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsGoop"]]]:
        '''goop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        '''
        result = self._values.get("goop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsGoop"]]], result)

    @builtins.property
    def grayscale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsGrayscale"]]]:
        '''grayscale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        '''
        result = self._values.get("grayscale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsGrayscale"]]], result)

    @builtins.property
    def hsl(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsHsl"]]]:
        '''hsl block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        '''
        result = self._values.get("hsl")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsHsl"]]], result)

    @builtins.property
    def hsv(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsHsv"]]]:
        '''hsv block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        '''
        result = self._values.get("hsv")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsHsv"]]], result)

    @builtins.property
    def if_dimension(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfDimension"]]]:
        '''if_dimension block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        '''
        result = self._values.get("if_dimension")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfDimension"]]], result)

    @builtins.property
    def if_orientation(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfOrientation"]]]:
        '''if_orientation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        '''
        result = self._values.get("if_orientation")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfOrientation"]]], result)

    @builtins.property
    def max_colors(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsMaxColors"]]]:
        '''max_colors block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        '''
        result = self._values.get("max_colors")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsMaxColors"]]], result)

    @builtins.property
    def mirror(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsMirror"]]]:
        '''mirror block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        '''
        result = self._values.get("mirror")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsMirror"]]], result)

    @builtins.property
    def mono_hue(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsMonoHue"]]]:
        '''mono_hue block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        '''
        result = self._values.get("mono_hue")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsMonoHue"]]], result)

    @builtins.property
    def opacity(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsOpacity"]]]:
        '''opacity block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsOpacity"]]], result)

    @builtins.property
    def remove_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsRemoveColor"]]]:
        '''remove_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        '''
        result = self._values.get("remove_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsRemoveColor"]]], result)

    @builtins.property
    def unsharp_mask(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsUnsharpMask"]]]:
        '''unsharp_mask block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        result = self._values.get("unsharp_mask")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsUnsharpMask"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformations(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsBackgroundColor",
    jsii_struct_bases=[],
    name_mapping={"color": "color", "color_var": "colorVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsBackgroundColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__31987f3bf6c17e9640ccde3294310d8ff0c22e2fc819226e2cd6837fb9107515)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsBackgroundColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsBackgroundColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsBackgroundColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a209ef4f1629897e7f2c9ee2840c19a6ca50abc39acd3ea35f501bedf2a06ab2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsBackgroundColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__14f9956444e56566352c7e225e34c9dfe41961795f0573d0b44fc2b6460dddc3)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsBackgroundColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__72a554d97dd806d85d9592b187a46d232d313011e041a22dec361c74ae2f5586)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d029e5a24982bab22d6d57ed57b771505b430d98335e01a4b71dcf9c762b5b58)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c1baaac30e004b437191f5d7f0e015980d9300fc97d426afc25ae43677a9013c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsBackgroundColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsBackgroundColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f7586e757c97ec4c4d1a7cc3c38f3ac47f3346ea198875f1605b62c0770e229)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsBackgroundColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsBackgroundColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8035764b9361ac6e2360cb974b70afedc937c02d1270514937ae94f1693b9482)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__870ba1c6a11a21be1c7208cb9e6b78ccda78cd3d354f021af44a1526fac3f4c3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__da460d0ee70b7a972a79684919bf02a3b3fcbb7dba40ef70acba7258d601433b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsBackgroundColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsBackgroundColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsBackgroundColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d64a353e00907d53a2555d1b7d69b9cc0c79d00411f5a1c34549f345ca9c8465)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsBlur",
    jsii_struct_bases=[],
    name_mapping={"sigma": "sigma", "sigma_var": "sigmaVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsBlur:
    def __init__(
        self,
        *,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param sigma: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__477e6af053bb5f2e37d40e8362be48324133fa3b245ccdb7df9dd7910e0e3dcc)
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsBlur(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsBlurList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsBlurList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3aeaf83e9f682bc537b016f17561ebf3db48d4d3bf2f0626484ccf0bb3fb9ed6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsBlurOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c7f096af91bda9151a15985551ff7907fa35ad956e1c4bb91ff1a2be89bd1108)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsBlurOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dfb93f951411d2115f3c062553e43e76294d85886d8682b5d9a780f2671bd526)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8ddbd81f56aa40846a25fbd640f231868d45166f3939eca02d231e4b92fe65c6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ce29a3f7d98e102aa01e096c0135d2c26ecd67c3eb4faa37fb2d06ce0f933381)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsBlur]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsBlur]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__223efc09fcaa28a1239bfa91f515276204802e209b7a168360bfa98b3277bc31)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsBlurOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsBlurOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a0a3c3b6c4d3c3916c4d9386574241353cc51c48baf54abe748bc1c623e6a420)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5db25d3069ea3ffeb0a76318975915f7d9b16dd2fb34a410f64e81c21cebfee6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__afec1b146530b89951c95db28b4168728f5168a1f94d21d1404d0ed3a1fcd616)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsBlur]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsBlur]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsBlur]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__01bb286233018d05bd1383b30379ab6e9790b5c1673adc9cf58fec0fb478a239)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsChromaKey",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_feather": "hueFeather",
        "hue_feather_var": "hueFeatherVar",
        "hue_tolerance": "hueTolerance",
        "hue_tolerance_var": "hueToleranceVar",
        "hue_var": "hueVar",
        "lightness_feather": "lightnessFeather",
        "lightness_feather_var": "lightnessFeatherVar",
        "lightness_tolerance": "lightnessTolerance",
        "lightness_tolerance_var": "lightnessToleranceVar",
        "saturation_feather": "saturationFeather",
        "saturation_feather_var": "saturationFeatherVar",
        "saturation_tolerance": "saturationTolerance",
        "saturation_tolerance_var": "saturationToleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsChromaKey:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_feather: typing.Optional[builtins.str] = None,
        hue_feather_var: typing.Optional[builtins.str] = None,
        hue_tolerance: typing.Optional[builtins.str] = None,
        hue_tolerance_var: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness_feather: typing.Optional[builtins.str] = None,
        lightness_feather_var: typing.Optional[builtins.str] = None,
        lightness_tolerance: typing.Optional[builtins.str] = None,
        lightness_tolerance_var: typing.Optional[builtins.str] = None,
        saturation_feather: typing.Optional[builtins.str] = None,
        saturation_feather_var: typing.Optional[builtins.str] = None,
        saturation_tolerance: typing.Optional[builtins.str] = None,
        saturation_tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_feather: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        :param hue_feather_var: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        :param hue_tolerance: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        :param hue_tolerance_var: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        :param hue_var: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness_feather: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        :param lightness_feather_var: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        :param lightness_tolerance: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        :param lightness_tolerance_var: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        :param saturation_feather: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        :param saturation_feather_var: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        :param saturation_tolerance: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        :param saturation_tolerance_var: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__715cd1b313c2c65c85c0d211839ec1dde4470a779f506d57e0e687fb8fc7b95d)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_feather", value=hue_feather, expected_type=type_hints["hue_feather"])
            check_type(argname="argument hue_feather_var", value=hue_feather_var, expected_type=type_hints["hue_feather_var"])
            check_type(argname="argument hue_tolerance", value=hue_tolerance, expected_type=type_hints["hue_tolerance"])
            check_type(argname="argument hue_tolerance_var", value=hue_tolerance_var, expected_type=type_hints["hue_tolerance_var"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness_feather", value=lightness_feather, expected_type=type_hints["lightness_feather"])
            check_type(argname="argument lightness_feather_var", value=lightness_feather_var, expected_type=type_hints["lightness_feather_var"])
            check_type(argname="argument lightness_tolerance", value=lightness_tolerance, expected_type=type_hints["lightness_tolerance"])
            check_type(argname="argument lightness_tolerance_var", value=lightness_tolerance_var, expected_type=type_hints["lightness_tolerance_var"])
            check_type(argname="argument saturation_feather", value=saturation_feather, expected_type=type_hints["saturation_feather"])
            check_type(argname="argument saturation_feather_var", value=saturation_feather_var, expected_type=type_hints["saturation_feather_var"])
            check_type(argname="argument saturation_tolerance", value=saturation_tolerance, expected_type=type_hints["saturation_tolerance"])
            check_type(argname="argument saturation_tolerance_var", value=saturation_tolerance_var, expected_type=type_hints["saturation_tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_feather is not None:
            self._values["hue_feather"] = hue_feather
        if hue_feather_var is not None:
            self._values["hue_feather_var"] = hue_feather_var
        if hue_tolerance is not None:
            self._values["hue_tolerance"] = hue_tolerance
        if hue_tolerance_var is not None:
            self._values["hue_tolerance_var"] = hue_tolerance_var
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness_feather is not None:
            self._values["lightness_feather"] = lightness_feather
        if lightness_feather_var is not None:
            self._values["lightness_feather_var"] = lightness_feather_var
        if lightness_tolerance is not None:
            self._values["lightness_tolerance"] = lightness_tolerance
        if lightness_tolerance_var is not None:
            self._values["lightness_tolerance_var"] = lightness_tolerance_var
        if saturation_feather is not None:
            self._values["saturation_feather"] = saturation_feather
        if saturation_feather_var is not None:
            self._values["saturation_feather_var"] = saturation_feather_var
        if saturation_tolerance is not None:
            self._values["saturation_tolerance"] = saturation_tolerance
        if saturation_tolerance_var is not None:
            self._values["saturation_tolerance_var"] = saturation_tolerance_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        '''
        result = self._values.get("hue_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        '''
        result = self._values.get("hue_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        '''
        result = self._values.get("hue_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        '''
        result = self._values.get("hue_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        '''
        result = self._values.get("lightness_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        '''
        result = self._values.get("lightness_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        '''
        result = self._values.get("lightness_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        '''
        result = self._values.get("lightness_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        '''
        result = self._values.get("saturation_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        '''
        result = self._values.get("saturation_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        '''
        result = self._values.get("saturation_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        result = self._values.get("saturation_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsChromaKey(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsChromaKeyList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsChromaKeyList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ddd493130a35b2ff23bbd1588c3eabc7c77b8918219f2aa56cad58f2e774984d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsChromaKeyOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__38c43b489d3fbe1dbc287ef9a07dc2fd92f4ee5bd9bc6afb5b95d0b3c7ed54d6)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsChromaKeyOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c44d772002b7e5dd87605e36b0be7be2313dd63e6742c1a5788159293217d8dd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__15a839e318d0a824d4c43f41ccfcc76c4d9136680dc5b07c86df06ea6d6d892d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__caab870f71b0915e301828c38d6c5afe75a290144eda4d30408bc9b4e7e04b55)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsChromaKey]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsChromaKey]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac2a0f680abb6625fee678ac1332a48e30beebcdd066f3697771ad074038a846)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsChromaKeyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsChromaKeyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__383b8d32a281121b14657eaa775abe97940e28890c4a906f1fa99bcd32179117)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueFeather")
    def reset_hue_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeather", []))

    @jsii.member(jsii_name="resetHueFeatherVar")
    def reset_hue_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeatherVar", []))

    @jsii.member(jsii_name="resetHueTolerance")
    def reset_hue_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueTolerance", []))

    @jsii.member(jsii_name="resetHueToleranceVar")
    def reset_hue_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueToleranceVar", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightnessFeather")
    def reset_lightness_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeather", []))

    @jsii.member(jsii_name="resetLightnessFeatherVar")
    def reset_lightness_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeatherVar", []))

    @jsii.member(jsii_name="resetLightnessTolerance")
    def reset_lightness_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessTolerance", []))

    @jsii.member(jsii_name="resetLightnessToleranceVar")
    def reset_lightness_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessToleranceVar", []))

    @jsii.member(jsii_name="resetSaturationFeather")
    def reset_saturation_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeather", []))

    @jsii.member(jsii_name="resetSaturationFeatherVar")
    def reset_saturation_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeatherVar", []))

    @jsii.member(jsii_name="resetSaturationTolerance")
    def reset_saturation_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationTolerance", []))

    @jsii.member(jsii_name="resetSaturationToleranceVar")
    def reset_saturation_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherInput")
    def hue_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVarInput")
    def hue_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceInput")
    def hue_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVarInput")
    def hue_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherInput")
    def lightness_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVarInput")
    def lightness_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceInput")
    def lightness_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVarInput")
    def lightness_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherInput")
    def saturation_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVarInput")
    def saturation_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceInput")
    def saturation_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVarInput")
    def saturation_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1713d974b8a0ba60d304ae1b0dba09335899e1316e9b349cf4937814c4335008)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeather")
    def hue_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeather"))

    @hue_feather.setter
    def hue_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f74ed63d69cc7a520e426a3b512f7e20b2a2993ea6d2d918601182a7efccb736)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeather", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVar")
    def hue_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeatherVar"))

    @hue_feather_var.setter
    def hue_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__39e68d4057bdfd0007d69f472c96a2ed76525555c60613f2b0f7578d51620ab6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueTolerance")
    def hue_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueTolerance"))

    @hue_tolerance.setter
    def hue_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f730e95de4b58a3d49aaa443fe77432516db66c99cdca7d74531b73d175634a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVar")
    def hue_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueToleranceVar"))

    @hue_tolerance_var.setter
    def hue_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__89913dea8c458d835717717b08429c71ba5d1b3b998bbf1e96123ae4fabe38bf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__140cc815e2add982372ed2260442c1bbcca6c46fc67663e078ea0d5b7a9a7b52)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeather")
    def lightness_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeather"))

    @lightness_feather.setter
    def lightness_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__db9d98d31cab43a863af9a73a6bd07bb9445a68e5cc5efb823d05598ee5ea5b6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeather", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVar")
    def lightness_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeatherVar"))

    @lightness_feather_var.setter
    def lightness_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8839e4c09a6ad0ffcf9ca9bb222572a20aea26ceadfc57d29827daa0389f3546)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessTolerance")
    def lightness_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessTolerance"))

    @lightness_tolerance.setter
    def lightness_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__57865ed4a74fd49262dba45a3f56557d737f852056d5655a792b62c7e4d8e34a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVar")
    def lightness_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessToleranceVar"))

    @lightness_tolerance_var.setter
    def lightness_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__07d816c6dc2f5fd0f7c4a7bfb12db973db4800157a0bbee37290ad59db8671e0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeather")
    def saturation_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeather"))

    @saturation_feather.setter
    def saturation_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__34511a9060597f0e438fe1c2f68abff40b383925922d3bbeff846a8daf73f4dd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeather", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVar")
    def saturation_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeatherVar"))

    @saturation_feather_var.setter
    def saturation_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8fe868bb672ec9721043ba669f19155d2116cca7efd7f63bf3ed0f7ad8e682f7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationTolerance")
    def saturation_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationTolerance"))

    @saturation_tolerance.setter
    def saturation_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__db558d55013091423d27fbada7027b340ef5180d6e145ba8e48e04e048513ba7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVar")
    def saturation_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationToleranceVar"))

    @saturation_tolerance_var.setter
    def saturation_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__90024e725acee2feb76ac320dcc73d21fa62d8cc8b71d5b872a53f743fb68afc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsChromaKey]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsChromaKey]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsChromaKey]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eaad4480221c61a37ed15b7eee2fba5c552fb1e23efe86738ee73159a7cbb4b9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsComposite",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "placement": "placement",
        "placement_var": "placementVar",
        "scale": "scale",
        "scale_dimension": "scaleDimension",
        "scale_dimension_var": "scaleDimensionVar",
        "scale_var": "scaleVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsComposite:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsCompositeImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        placement: typing.Optional[builtins.str] = None,
        placement_var: typing.Optional[builtins.str] = None,
        scale: typing.Optional[builtins.str] = None,
        scale_dimension: typing.Optional[builtins.str] = None,
        scale_dimension_var: typing.Optional[builtins.str] = None,
        scale_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param placement: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        :param placement_var: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        :param scale: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param scale_dimension: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        :param scale_dimension_var: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        :param scale_var: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        :param x_position: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsCompositeImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc451c094d545c1166ec9544ac27a2f736fe67b5f271bd2c0b2e7b610f78fa17)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument placement", value=placement, expected_type=type_hints["placement"])
            check_type(argname="argument placement_var", value=placement_var, expected_type=type_hints["placement_var"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument scale_dimension", value=scale_dimension, expected_type=type_hints["scale_dimension"])
            check_type(argname="argument scale_dimension_var", value=scale_dimension_var, expected_type=type_hints["scale_dimension_var"])
            check_type(argname="argument scale_var", value=scale_var, expected_type=type_hints["scale_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if placement is not None:
            self._values["placement"] = placement
        if placement_var is not None:
            self._values["placement_var"] = placement_var
        if scale is not None:
            self._values["scale"] = scale
        if scale_dimension is not None:
            self._values["scale_dimension"] = scale_dimension
        if scale_dimension_var is not None:
            self._values["scale_dimension_var"] = scale_dimension_var
        if scale_var is not None:
            self._values["scale_var"] = scale_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsCompositeImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsCompositeImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        '''
        result = self._values.get("placement")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement_var(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        '''
        result = self._values.get("placement_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        '''
        result = self._values.get("scale_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        '''
        result = self._values.get("scale_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        '''
        result = self._values.get("scale_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsComposite(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsCompositeImage",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsCompositeImage:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsCompositeImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsCompositeImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsCompositeImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ae878dd29cc4573119a269a97daa6a29f933816aabfb7f577df07eaad4ca6d01)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsCompositeImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsCompositeImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bfc1b20ce3f03c8cb3005a1f3b5f91ad619bb66d9ecaffa0867cb3057ea8ed61)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsCompositeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsCompositeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b5d8f6b46acb5c87a5e3722b2d41fa7c951e12ca7429d25ff406f4780bafc623)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsCompositeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af0e7e17f34a46a132c3263e6c4ee4fa435937adfb59f2c8199fb2c911d72b8c)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsCompositeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4cb3290a8794bec60b83109caa07efb4680d128c4fc36739d848a2fd8d734459)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9e3aedb37d36cefc0bb4d59ff87e93f517424ec05e1dd41cf63ab1a66515d3e8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f2f85ebe089f762a340d9baefb4a2e279bdf2f4e731d0f26f16a618c4526b5b6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsComposite]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsComposite]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f5558ef8339b963ac6b5ffa9225c729e2dbac251c1664ff20c8b7d21632187f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsCompositeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsCompositeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fec31dfb9e0901deeb6447a13e87c821e2f8ff2e0d67866a4429d703277a804f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsCompositeImage()

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPlacement")
    def reset_placement(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacement", []))

    @jsii.member(jsii_name="resetPlacementVar")
    def reset_placement_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacementVar", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetScaleDimension")
    def reset_scale_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimension", []))

    @jsii.member(jsii_name="resetScaleDimensionVar")
    def reset_scale_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimensionVar", []))

    @jsii.member(jsii_name="resetScaleVar")
    def reset_scale_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsCompositeImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsCompositeImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsCompositeImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="placementInput")
    def placement_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementInput"))

    @builtins.property
    @jsii.member(jsii_name="placementVarInput")
    def placement_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionInput")
    def scale_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVarInput")
    def scale_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleVarInput")
    def scale_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8450f11c43755b5a42d9d1273d87e579000d61f74f041346350ab76535e2550b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af3f582c0bed6175eff706c3018d9e557bb18205514b6769046f79d8ece4ba1f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="placement")
    def placement(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placement"))

    @placement.setter
    def placement(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1ec14811813f4aeeb385d5940e0e1f335925837d8a9a6d67fbd04630814c9f23)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placement", value)

    @builtins.property
    @jsii.member(jsii_name="placementVar")
    def placement_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placementVar"))

    @placement_var.setter
    def placement_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__16d8b5dc6caa5e2610c8c498e7c8b84a7326687303a76554210d19f80e75cedf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placementVar", value)

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scale"))

    @scale.setter
    def scale(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cc271afd11a22dfc52d3a85ba58d0bf7e6b3e0823a77cd75c120ec7a319fe1fd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scale", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimension")
    def scale_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimension"))

    @scale_dimension.setter
    def scale_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c59c1697c815c4a535c03d22bc91bf77cbac9150fd48d0c5d97305e19b94413f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimension", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVar")
    def scale_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimensionVar"))

    @scale_dimension_var.setter
    def scale_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e25815249e303d89f6a576e6dff80d6a896b08e478abb9f7cfdcc6e5cc2e1625)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="scaleVar")
    def scale_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleVar"))

    @scale_var.setter
    def scale_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f19b2875d82544999513d6b3215eed50741aa70edd5dc96b3623be3d07b8582c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__99d1235f8b45ae01a8d3e7e161654d1bb3864f6d605a96cfe18aa3f086d0c051)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__263ff155a3b0aed634a9f69be607dbcfc2e38b703ded4058284d9bbaf1e5daa1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bbcd431a2e0f48cd076b0e5c4b31a1669da7d0e780eb99f1a1a2ecbc9cf4e35c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bf7310b44efb92c8a3f8dbc3fc1b8111d587eefeaa6e23f51f4456ee47df4543)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsComposite]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsComposite]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsComposite]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f573502fcec785e23f64a1a217b6955d75aea9f280e606705e554c15273b20e6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsCompound",
    jsii_struct_bases=[],
    name_mapping={"transformations": "transformations"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsCompound:
    def __init__(
        self,
        *,
        transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param transformations: transformations block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dc3399442fdd5992f78719bdf73ec587c85e82d443f38db1c63d2740599bdad8)
            check_type(argname="argument transformations", value=transformations, expected_type=type_hints["transformations"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if transformations is not None:
            self._values["transformations"] = transformations

    @builtins.property
    def transformations(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsCompoundTransformations"]]]:
        '''transformations block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        result = self._values.get("transformations")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsCompoundTransformations"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsCompound(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsCompoundList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsCompoundList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__953d087bdd5cfe6829238dfa43ef735d4eef73c9bb16f9ac7c4badefe8024413)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsCompoundOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f5f52dac835370ad307e0006a40e4d08420be2e57a2e736af98493f1006e45c0)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsCompoundOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__37896c1318f38a99b41c595dc624e8159810780e7e84cc8291cc6c70e1ce6769)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__492ca459aefa28444eb3aac20bf1f588f3ccdad3aa49cbf222b72b65f4b6a7d3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3727e2a133e14be613058029c864660cc6ebfefcd26e428ec8a61c3386c0e101)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsCompound]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsCompound]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fe8392635fd66ba8a153f95ba68d145fa70a36f8a50cdbe7dd7683f4bb7265ba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsCompoundOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsCompoundOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__688d8daa6795abcdf3c77b7f26239d6d3b429cc8da46e1f78fc44743542caddc)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformations")
    def put_transformations(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a18a7e88532c8080c9a3c683d3b4c69bd59a8f6cfb43434fa63a49f40c395718)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTransformations", [value]))

    @jsii.member(jsii_name="resetTransformations")
    def reset_transformations(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformations", []))

    @builtins.property
    @jsii.member(jsii_name="transformations")
    def transformations(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsCompoundTransformationsList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsCompoundTransformationsList", jsii.get(self, "transformations"))

    @builtins.property
    @jsii.member(jsii_name="transformationsInput")
    def transformations_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsCompoundTransformations"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsCompoundTransformations"]]], jsii.get(self, "transformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsCompound]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsCompound]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsCompound]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__196ca71ffa1e7b36e8d9b571206757196eebec513cb2f712ce4ef6933f715ea0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsCompoundTransformations",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsCompoundTransformations:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsCompoundTransformations(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsCompoundTransformationsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsCompoundTransformationsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ca0f8c1db7260d1ff4807da8f18f0344d9d8201bd623efa6ae7679a92fb4a438)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsCompoundTransformationsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__620ae1dce5af61e4a8717a84da02f5bf9eb62803945438cb41634b9cade8a9b1)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsCompoundTransformationsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5aee3154becd5b32eb7e321818abb9acfe715b12f786a719ba64925c10b4cb37)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__093a3c002f4f97c3b1a920ed66b92b0ff02d126412ef3e27952e7717c5a9d2e9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fd27dfa3a40e5f4c862a30b3ec5c53814dbe481949425c46b056e1671b153f82)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsCompoundTransformations]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsCompoundTransformations]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsCompoundTransformations]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8c4ee1093500e61ea2d4807f6e10b8515a889bf02120395d4f6cbff655a76cb9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsCompoundTransformationsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsCompoundTransformationsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7c1e05489dd5aba938540e144d5dc37e9862d931f82b23874b31aaef94d0a013)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsCompoundTransformations]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsCompoundTransformations]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsCompoundTransformations]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f135d0921d0fd28e52892f07866d3f38047b8928dd8a474cbd579464eb23637f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsContrast",
    jsii_struct_bases=[],
    name_mapping={
        "brightness": "brightness",
        "brightness_var": "brightnessVar",
        "contrast": "contrast",
        "contrast_var": "contrastVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsContrast:
    def __init__(
        self,
        *,
        brightness: typing.Optional[builtins.str] = None,
        brightness_var: typing.Optional[builtins.str] = None,
        contrast: typing.Optional[builtins.str] = None,
        contrast_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param brightness: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        :param brightness_var: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        :param contrast: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param contrast_var: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__860d8cf8725891afc6ffdf566e634e1f3f51443a10cf3d99acbf5c4f576c8c86)
            check_type(argname="argument brightness", value=brightness, expected_type=type_hints["brightness"])
            check_type(argname="argument brightness_var", value=brightness_var, expected_type=type_hints["brightness_var"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument contrast_var", value=contrast_var, expected_type=type_hints["contrast_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if brightness is not None:
            self._values["brightness"] = brightness
        if brightness_var is not None:
            self._values["brightness_var"] = brightness_var
        if contrast is not None:
            self._values["contrast"] = contrast
        if contrast_var is not None:
            self._values["contrast_var"] = contrast_var

    @builtins.property
    def brightness(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        '''
        result = self._values.get("brightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def brightness_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        '''
        result = self._values.get("brightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        result = self._values.get("contrast_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsContrast(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsContrastList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsContrastList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2f3a306a18831ae503e37e247fc54d52fbe89cde6b288378015c3d9997996749)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsContrastOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3328483c39074f5f263f4729dac81e0640e14e67761629decc724d25f88652d3)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsContrastOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__daa603a6b91fdd820e09a405cf5c492099ac992f0488fdb7f64e46889e23a430)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2858bbcdea39e4b223bf717f659fea7043d52ccc928a815daa25fffeebfa476c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e1df083fd2d567c5de8c13dd05953616213c02d4f7ebb80f76a3a4eabe62dd1a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsContrast]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsContrast]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f69f00454b2a935c2e2130e5a9f1ebc2c4b441f0660ddb327a7e8ccfbdc852ce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsContrastOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsContrastOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c419531470236af5a8606668cd9369816c9978f8d39e55138d5db287b36e6de9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetBrightness")
    def reset_brightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightness", []))

    @jsii.member(jsii_name="resetBrightnessVar")
    def reset_brightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightnessVar", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetContrastVar")
    def reset_contrast_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrastVar", []))

    @builtins.property
    @jsii.member(jsii_name="brightnessInput")
    def brightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="brightnessVarInput")
    def brightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastVarInput")
    def contrast_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="brightness")
    def brightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightness"))

    @brightness.setter
    def brightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__23bebaf1627c62f7f4f68424892f92f418199452df44b358af5b6bbad21a4910)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightness", value)

    @builtins.property
    @jsii.member(jsii_name="brightnessVar")
    def brightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightnessVar"))

    @brightness_var.setter
    def brightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__30e6c1602bba5eab4ebe327f252538378c61681c2c3aa734bfcb3641f52dd42e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrast"))

    @contrast.setter
    def contrast(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ddd7f7846dd8f4a07885ca86f1cab46e8125141a093749c5d9b47e197fd5e0e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrast", value)

    @builtins.property
    @jsii.member(jsii_name="contrastVar")
    def contrast_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrastVar"))

    @contrast_var.setter
    def contrast_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0342e330c254e9b66d103198f7ec4e80e89d7b2251cd3891a44158ded76b7ecc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrastVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsContrast]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsContrast]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsContrast]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c20ba7c33cb75419f0d2e1ecc3e30d25d0dd99629cafcb9f2fbc439684a22683)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsGoop",
    jsii_struct_bases=[],
    name_mapping={
        "chaos": "chaos",
        "chaos_var": "chaosVar",
        "density": "density",
        "density_var": "densityVar",
        "power": "power",
        "power_var": "powerVar",
        "seed": "seed",
        "seed_var": "seedVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsGoop:
    def __init__(
        self,
        *,
        chaos: typing.Optional[builtins.str] = None,
        chaos_var: typing.Optional[builtins.str] = None,
        density: typing.Optional[builtins.str] = None,
        density_var: typing.Optional[builtins.str] = None,
        power: typing.Optional[builtins.str] = None,
        power_var: typing.Optional[builtins.str] = None,
        seed: typing.Optional[builtins.str] = None,
        seed_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param chaos: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        :param chaos_var: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        :param density: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        :param density_var: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        :param power: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        :param power_var: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        :param seed: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        :param seed_var: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f8afae5a76a24c88e8a25b19ef10205444b46144b432a0a3a66c30e941c10821)
            check_type(argname="argument chaos", value=chaos, expected_type=type_hints["chaos"])
            check_type(argname="argument chaos_var", value=chaos_var, expected_type=type_hints["chaos_var"])
            check_type(argname="argument density", value=density, expected_type=type_hints["density"])
            check_type(argname="argument density_var", value=density_var, expected_type=type_hints["density_var"])
            check_type(argname="argument power", value=power, expected_type=type_hints["power"])
            check_type(argname="argument power_var", value=power_var, expected_type=type_hints["power_var"])
            check_type(argname="argument seed", value=seed, expected_type=type_hints["seed"])
            check_type(argname="argument seed_var", value=seed_var, expected_type=type_hints["seed_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if chaos is not None:
            self._values["chaos"] = chaos
        if chaos_var is not None:
            self._values["chaos_var"] = chaos_var
        if density is not None:
            self._values["density"] = density
        if density_var is not None:
            self._values["density_var"] = density_var
        if power is not None:
            self._values["power"] = power
        if power_var is not None:
            self._values["power_var"] = power_var
        if seed is not None:
            self._values["seed"] = seed
        if seed_var is not None:
            self._values["seed_var"] = seed_var

    @builtins.property
    def chaos(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        '''
        result = self._values.get("chaos")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def chaos_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        '''
        result = self._values.get("chaos_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        '''
        result = self._values.get("density")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density_var(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        '''
        result = self._values.get("density_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        '''
        result = self._values.get("power")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power_var(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        '''
        result = self._values.get("power_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        '''
        result = self._values.get("seed")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed_var(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        result = self._values.get("seed_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsGoop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsGoopList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsGoopList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__30cf2752a9b323dec8d69b43bd50bfcb8dc8e41119af1182ef100360be973440)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsGoopOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b8073e2fdc7c4716bdec3bf4520e84ce809390b9fefa6e744cfee5a2b88d87b0)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsGoopOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f7809751a0d4f0fb12c7b4db439461f2183a887d8f7faf715e132bf13e99a60b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1fafadccb404a3e22d91040dc7fe7f7f08dd08c10a9689c6a84c634c9f884cee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4382eafdc2d10be90c2e827f85002700501358d263b2b1f77b174473e92e94ee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsGoop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsGoop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3613c28ae7bdb886ae34cb4b720b462ceb9315cc3086411fde2700ec761aa729)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsGoopOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsGoopOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f9c462b253da39f745f32949f6767473a49e57f4b4a6361939154a3c9a129e10)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetChaos")
    def reset_chaos(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaos", []))

    @jsii.member(jsii_name="resetChaosVar")
    def reset_chaos_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaosVar", []))

    @jsii.member(jsii_name="resetDensity")
    def reset_density(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensity", []))

    @jsii.member(jsii_name="resetDensityVar")
    def reset_density_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensityVar", []))

    @jsii.member(jsii_name="resetPower")
    def reset_power(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPower", []))

    @jsii.member(jsii_name="resetPowerVar")
    def reset_power_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPowerVar", []))

    @jsii.member(jsii_name="resetSeed")
    def reset_seed(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeed", []))

    @jsii.member(jsii_name="resetSeedVar")
    def reset_seed_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeedVar", []))

    @builtins.property
    @jsii.member(jsii_name="chaosInput")
    def chaos_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosInput"))

    @builtins.property
    @jsii.member(jsii_name="chaosVarInput")
    def chaos_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosVarInput"))

    @builtins.property
    @jsii.member(jsii_name="densityInput")
    def density_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityInput"))

    @builtins.property
    @jsii.member(jsii_name="densityVarInput")
    def density_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="powerInput")
    def power_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerInput"))

    @builtins.property
    @jsii.member(jsii_name="powerVarInput")
    def power_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerVarInput"))

    @builtins.property
    @jsii.member(jsii_name="seedInput")
    def seed_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedInput"))

    @builtins.property
    @jsii.member(jsii_name="seedVarInput")
    def seed_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedVarInput"))

    @builtins.property
    @jsii.member(jsii_name="chaos")
    def chaos(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaos"))

    @chaos.setter
    def chaos(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1820a139e69151bdd80273d6525b4ae4d85ea6b1b763774121298db42f21e87e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaos", value)

    @builtins.property
    @jsii.member(jsii_name="chaosVar")
    def chaos_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaosVar"))

    @chaos_var.setter
    def chaos_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d80ef1e2a438eeb73b063a8e02459f03f256e435e42e89b0e1efd6ead7e8660)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaosVar", value)

    @builtins.property
    @jsii.member(jsii_name="density")
    def density(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "density"))

    @density.setter
    def density(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__22d6ce0053492950af853bac016649bc5f8a141961fedf329427f87bc94a176c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "density", value)

    @builtins.property
    @jsii.member(jsii_name="densityVar")
    def density_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "densityVar"))

    @density_var.setter
    def density_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e09cbedb289ec5171e0b4b76d9346fc04625ec2ae5ae2b1bacbfdd6e5a4080b5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "densityVar", value)

    @builtins.property
    @jsii.member(jsii_name="power")
    def power(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "power"))

    @power.setter
    def power(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b31d7dbea01bfa815e95be0354115369de43ad4880315eeceba8eab0e3d2bc12)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "power", value)

    @builtins.property
    @jsii.member(jsii_name="powerVar")
    def power_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "powerVar"))

    @power_var.setter
    def power_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__77e8d3991363abd50392b6d4665d0f6f7b7d113fbcf877f71ef2b40e7a9a8ef0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "powerVar", value)

    @builtins.property
    @jsii.member(jsii_name="seed")
    def seed(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seed"))

    @seed.setter
    def seed(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0964be94d4d6f5591bbd5b84a5bd42cb3ef93f8022ad31a79291ca842fe2d016)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seed", value)

    @builtins.property
    @jsii.member(jsii_name="seedVar")
    def seed_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seedVar"))

    @seed_var.setter
    def seed_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a101a89c85af3dd509b6fd3be30e18414e8b97ad7b1658a1525bef1f1ddc1db2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seedVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsGoop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsGoop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsGoop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d833e986efde4ca217234e2d4eca5ba88cdccbef96e54ee4708d0fec8def5ea7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsGrayscale",
    jsii_struct_bases=[],
    name_mapping={"type": "type", "type_var": "typeVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsGrayscale:
    def __init__(
        self,
        *,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param type: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4d63a668abdcef8a0afb3bebaece9094d6b70cbd047580c105525d5cd202e8cd)
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsGrayscale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsGrayscaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsGrayscaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1bedd7dbb335791e420bde01f778ced80a7ec545eca962495d4d02049c5bb331)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsGrayscaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7424c22f9ae2ca17c3b02df47032970375d358ee0a550073a23b237efec378f6)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsGrayscaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__302ccfdfa981815ad11ee00c37967acb06feb94edc31f74808d7f3c270e2235a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__30bd26cbc722ba9b6dcb8185da95edf9a8d18f29f720e20ef347470704cb3a77)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab781fb5b9e3ae268d90f04f3022c56fd6c8abd71bdb35ce641d9aba6ab4a52e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsGrayscale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsGrayscale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2e3245460d832f5dea76d0a76b64a7e4ae10540abff5fdfed6a8990b35417582)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsGrayscaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsGrayscaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ad0f3e006a722e479591a00bcdd28e7c3242c3b5a30a2ad704923aeac889a94a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__65b22c19c17a04818d6fedd2083bde59c33cebae012c9b779cd594a92f8cdf79)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c3d0065bd45a4f9951f79c6d1b1bfd2bf819f21c2184554b9a5c1d10a98b8d17)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsGrayscale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsGrayscale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsGrayscale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__67060c4bd70ddc0f7b884faa26efc04a23928fb98ea371de0dc6b2d857d7ca78)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsHsl",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "lightness": "lightness",
        "lightness_var": "lightnessVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsHsl:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness: typing.Optional[builtins.str] = None,
        lightness_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        :param lightness_var: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a34afb7ea5c16ae90d89a689cb818a982619af816765ddb5ec23bb1e5a199b6)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness", value=lightness, expected_type=type_hints["lightness"])
            check_type(argname="argument lightness_var", value=lightness_var, expected_type=type_hints["lightness_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness is not None:
            self._values["lightness"] = lightness
        if lightness_var is not None:
            self._values["lightness_var"] = lightness_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        '''
        result = self._values.get("lightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        '''
        result = self._values.get("lightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsHsl(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsHslList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsHslList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1b5196a4352eae4a7e51f9ecc18be3c8b4f28df9f544cde239e5a7e03e01f69b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsHslOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__906b5bebb91dd2e68d31db832948adeaf386d73b8ab0a93924fda9d0e8a9a23d)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsHslOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__73fcf281c9e253bca6eab9b9af14c362797e3e17359b7df24c3167ec99aedaaf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__336d12bfc3f5adb1ebf3d6c974896acb8273be1590d92911229824f5d99e4b85)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6250ecda5532aff9c8b10ee6e85d172f9db8baac355e69fd4a01a65ec2d37ac8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsHsl]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsHsl]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d1f93ac9092157330a7fc05086674aca3df51388146f1681442d09852204681d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsHslOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsHslOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b5c7407efcd0ffb2ed546efae543d6f4a438b76b333231d30b10f98fa82efb67)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightness")
    def reset_lightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightness", []))

    @jsii.member(jsii_name="resetLightnessVar")
    def reset_lightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessInput")
    def lightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessVarInput")
    def lightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__53018a8284e2e9d615e93e6c6cea5e585487445d102789f3db74cdac7e1aca0d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__492377ebcf055f25fef45b06cb57cd0fb3fc584fbc7db10d7c327f163241e3e6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightness")
    def lightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightness"))

    @lightness.setter
    def lightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__97afd368461d3112a5ff42b702c2175e4c4fc32939cf901039babf21849342e9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightness", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessVar")
    def lightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessVar"))

    @lightness_var.setter
    def lightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__24334ce739559d70dff655ce5160cbfccc5ad065905b28b1c2e5f08f391732b7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a4043dc798a1d43655620ba6a650a26c592e85337a8d546710be4ef20aac3846)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5262d9ce80aaf8c55d4951f6b5999fa15bf66b712b8b2d032c22a6817a2db50c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsHsl]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsHsl]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsHsl]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__79ad6540190841a9dcae9a75233fa69f28ece659140a7667a8e36d6ef8e49791)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsHsv",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsHsv:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        :param value: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d94e62ca1104addca2bc7267d5a9fcda35ee4c84286138553ec2d4e6adce61ac)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsHsv(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsHsvList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsHsvList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0d92d2a46a71004c6e606a95339074fd9be2b9cd4da64c08015e3e41f941a49b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsHsvOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__010b3c2e16c618a6bddf022781bfce622a3c2e2723eaddf5e4c232bb40c1f39c)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsHsvOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__113f2797a9632887e7492c1f36daa05b1a0a08bdfa66abfea67822ad8338913f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__514ac514c279b31acfa4de50819e8a7f59b5f2c4be2aa8b7cd31d72db568cf5e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4332c8f750b6a21696b3db06c82d30ea9275aadf32795f518a7e24286500d2d3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsHsv]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsHsv]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__84de561cb01ccc5e693d1da7443ca1bc5ec26e81c551b64a5e7927540ab7ccce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsHsvOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsHsvOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__040b01e8afc0763ef48b9928ea5d48cce099afbb5e6e94022924218bd0753c04)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9b3ffac72eb81c64a700d5f7864fc2e3b7cb72171b6a65a219f09431aa2e7512)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c0dde8b53b32e7a644d0b85404b6bb0672bcecb2f776abc37470b5b4c4e97d4e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b1aa022805c9cbdb06e94ec671f166ee08c5e8fbedb9d1ea310a46b5e337f18c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cc474a31d508fa309d6f498b24cb1af9e32268de45d81434c88fd79fe59c8753)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c09911cb608f235272e68898c7f578c36dcb94a1d102549f96fe914197793bd2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7a806b4132ffa1cededc56dd091a1986748276fb8cc11e310996051494a2b6f1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsHsv]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsHsv]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsHsv]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4d5897924f8ef4749a5570131e5d5b6543c4af6ee23b506dda3f4b4b7f598f44)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfDimension",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "dimension": "dimension",
        "dimension_var": "dimensionVar",
        "equal": "equal",
        "greater_than": "greaterThan",
        "less_than": "lessThan",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfDimension:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfDimensionDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        dimension: typing.Optional[builtins.str] = None,
        dimension_var: typing.Optional[builtins.str] = None,
        equal: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfDimensionEqual", typing.Dict[builtins.str, typing.Any]]] = None,
        greater_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfDimensionGreaterThan", typing.Dict[builtins.str, typing.Any]]] = None,
        less_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfDimensionLessThan", typing.Dict[builtins.str, typing.Any]]] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param dimension: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        :param dimension_var: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        :param equal: equal block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        :param greater_than: greater_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        :param less_than: less_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        :param value: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfDimensionDefault(**default)
        if isinstance(equal, dict):
            equal = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfDimensionEqual(**equal)
        if isinstance(greater_than, dict):
            greater_than = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfDimensionGreaterThan(**greater_than)
        if isinstance(less_than, dict):
            less_than = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfDimensionLessThan(**less_than)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ada8040878344cd533e3780315ebbda1f2ae708391ae4852282fcb9a5be73715)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument dimension", value=dimension, expected_type=type_hints["dimension"])
            check_type(argname="argument dimension_var", value=dimension_var, expected_type=type_hints["dimension_var"])
            check_type(argname="argument equal", value=equal, expected_type=type_hints["equal"])
            check_type(argname="argument greater_than", value=greater_than, expected_type=type_hints["greater_than"])
            check_type(argname="argument less_than", value=less_than, expected_type=type_hints["less_than"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if dimension is not None:
            self._values["dimension"] = dimension
        if dimension_var is not None:
            self._values["dimension_var"] = dimension_var
        if equal is not None:
            self._values["equal"] = equal
        if greater_than is not None:
            self._values["greater_than"] = greater_than
        if less_than is not None:
            self._values["less_than"] = less_than
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfDimensionDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfDimensionDefault"], result)

    @builtins.property
    def dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        '''
        result = self._values.get("dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        '''
        result = self._values.get("dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def equal(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfDimensionEqual"]:
        '''equal block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        '''
        result = self._values.get("equal")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfDimensionEqual"], result)

    @builtins.property
    def greater_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfDimensionGreaterThan"]:
        '''greater_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        '''
        result = self._values.get("greater_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfDimensionGreaterThan"], result)

    @builtins.property
    def less_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfDimensionLessThan"]:
        '''less_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        '''
        result = self._values.get("less_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfDimensionLessThan"], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfDimension(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfDimensionDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfDimensionDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfDimensionDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfDimensionDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfDimensionDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__77470b772e740ea2ac126a166641a8193dba165b25624c29a8c8254e445f7579)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfDimensionDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfDimensionDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dde802d0a2c12dab277d11855bd2e30b9281e952e851fd79f091ac5193f0fa4c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfDimensionEqual",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfDimensionEqual:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfDimensionEqual(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfDimensionEqualOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfDimensionEqualOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a5fbdc81716e91fc0c6ee01b6a30280bdbe9e7442ca8b63e71693781cffe5145)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfDimensionEqual], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfDimensionEqual],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__706142ba01a16c28622db175553311e720a3c733b7abb7155a4a0c309ec704f9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfDimensionGreaterThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfDimensionGreaterThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfDimensionGreaterThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfDimensionGreaterThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfDimensionGreaterThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8926ab76d51b3ce4d15303197066de10f777f383c020e4b0dcac9b9c51ab00e3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfDimensionGreaterThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfDimensionGreaterThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f62c19e9831e632d78aa095e4033b256bd54469b9b39e87f3218863d1eb78aaf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfDimensionLessThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfDimensionLessThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfDimensionLessThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfDimensionLessThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfDimensionLessThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__771704959c74f3e19278355206520d663dc1045a1a9339c6ec49efe935e34103)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfDimensionLessThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfDimensionLessThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4d4eccfb1ccdb611c3841958c6ac27f2b35b87c724a6d129518d52c80090c41d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfDimensionList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfDimensionList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__514f5866e8369b6ef13ae55625e801aa97f38595bc92d8e90c7becb646bd1227)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfDimensionOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3f4e445c10bd9f81ad35181b35740c068d4a498f016e5d7ccb4d25422c4ea5f5)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfDimensionOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__658f01989702a682b6b15bd346405bc56eb11c572b9d304c9a89d817877688ac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__51113a72a9b83df744469ca4a0223e2f25b221f33b8d898789d01b434025627e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a20cbcbad88c74f923b4296e207684ded2a3ca17211d0eeee21bc5ba825d322)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfDimension]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfDimension]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f24ced4ba6eef72fce4295025e5c03951ccb2ba08b5a3630a7074d82ced3dfca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfDimensionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfDimensionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7c57ed715ec489e2a229a33eb25f6083e376dc6ad163d2eabb9dd60c9cba64ee)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfDimensionDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putEqual")
    def put_equal(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfDimensionEqual()

        return typing.cast(None, jsii.invoke(self, "putEqual", [value]))

    @jsii.member(jsii_name="putGreaterThan")
    def put_greater_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfDimensionGreaterThan()

        return typing.cast(None, jsii.invoke(self, "putGreaterThan", [value]))

    @jsii.member(jsii_name="putLessThan")
    def put_less_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfDimensionLessThan()

        return typing.cast(None, jsii.invoke(self, "putLessThan", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetDimension")
    def reset_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimension", []))

    @jsii.member(jsii_name="resetDimensionVar")
    def reset_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimensionVar", []))

    @jsii.member(jsii_name="resetEqual")
    def reset_equal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEqual", []))

    @jsii.member(jsii_name="resetGreaterThan")
    def reset_greater_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGreaterThan", []))

    @jsii.member(jsii_name="resetLessThan")
    def reset_less_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLessThan", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfDimensionDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfDimensionDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="equal")
    def equal(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfDimensionEqualOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfDimensionEqualOutputReference, jsii.get(self, "equal"))

    @builtins.property
    @jsii.member(jsii_name="greaterThan")
    def greater_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfDimensionGreaterThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfDimensionGreaterThanOutputReference, jsii.get(self, "greaterThan"))

    @builtins.property
    @jsii.member(jsii_name="lessThan")
    def less_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfDimensionLessThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfDimensionLessThanOutputReference, jsii.get(self, "lessThan"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfDimensionDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionInput")
    def dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionVarInput")
    def dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="equalInput")
    def equal_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfDimensionEqual], jsii.get(self, "equalInput"))

    @builtins.property
    @jsii.member(jsii_name="greaterThanInput")
    def greater_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfDimensionGreaterThan], jsii.get(self, "greaterThanInput"))

    @builtins.property
    @jsii.member(jsii_name="lessThanInput")
    def less_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfDimensionLessThan], jsii.get(self, "lessThanInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="dimension")
    def dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimension"))

    @dimension.setter
    def dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__12e664c81971c6d2aa1715ac69ad3973cae9ae6c16b1c28646604af66d09bec4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimension", value)

    @builtins.property
    @jsii.member(jsii_name="dimensionVar")
    def dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimensionVar"))

    @dimension_var.setter
    def dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1523f7b26898d5e6a755fd3a6e3c6d59fea06d820dca7c3e71a9e456ad4ef40e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d4948a141f057a6a7f9825cc90b5456b77d35aa1ef82e0a9b7bea0e0d039eb40)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__17ead594755c77ada38897d7ed060d1b555aa350974e09cdf9184d1da72b0cb2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfDimension]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfDimension]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfDimension]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__68e471b80844cc41ae0c69c9f6772f9e2c53985225814b3131abf9d300e8665a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfOrientation",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "landscape": "landscape",
        "portrait": "portrait",
        "square": "square",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfOrientation:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfOrientationDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        landscape: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfOrientationLandscape", typing.Dict[builtins.str, typing.Any]]] = None,
        portrait: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfOrientationPortrait", typing.Dict[builtins.str, typing.Any]]] = None,
        square: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfOrientationSquare", typing.Dict[builtins.str, typing.Any]]] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param landscape: landscape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        :param portrait: portrait block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        :param square: square block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfOrientationDefault(**default)
        if isinstance(landscape, dict):
            landscape = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfOrientationLandscape(**landscape)
        if isinstance(portrait, dict):
            portrait = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfOrientationPortrait(**portrait)
        if isinstance(square, dict):
            square = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfOrientationSquare(**square)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__00b78d3853d34132095d80913f775e5448bf15b4674e9d9dce119c772f640f06)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument landscape", value=landscape, expected_type=type_hints["landscape"])
            check_type(argname="argument portrait", value=portrait, expected_type=type_hints["portrait"])
            check_type(argname="argument square", value=square, expected_type=type_hints["square"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if landscape is not None:
            self._values["landscape"] = landscape
        if portrait is not None:
            self._values["portrait"] = portrait
        if square is not None:
            self._values["square"] = square

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfOrientationDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfOrientationDefault"], result)

    @builtins.property
    def landscape(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfOrientationLandscape"]:
        '''landscape block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        '''
        result = self._values.get("landscape")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfOrientationLandscape"], result)

    @builtins.property
    def portrait(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfOrientationPortrait"]:
        '''portrait block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        '''
        result = self._values.get("portrait")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfOrientationPortrait"], result)

    @builtins.property
    def square(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfOrientationSquare"]:
        '''square block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        result = self._values.get("square")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfOrientationSquare"], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfOrientation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfOrientationDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfOrientationDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfOrientationDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfOrientationDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfOrientationDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ad7808e899da88956eefcf14b0e53c091181730deb661e5c2e7cac43ba221c3b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfOrientationDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfOrientationDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__10d2100969f9e7623435eb8c57633e455768b7837df599190dfc9207eafd0028)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfOrientationLandscape",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfOrientationLandscape:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfOrientationLandscape(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfOrientationLandscapeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfOrientationLandscapeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d7b45f29b648e817f2284e05b543dcfb7d757358f499f70e06889fb5a35994b7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfOrientationLandscape], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfOrientationLandscape],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__344be53f6a7a9b9e66b953a4405887972d321f605ab1d6a05127ac306a3f9987)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfOrientationList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfOrientationList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__16a01f4e3c9c8dd5def7daf387c331ae7e8d19eb374dfff227a9bbc4fdb089cc)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfOrientationOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__134a28e77a49e1230e28528a6b198a92f674b399ecce54d35f8f2fb05373946e)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfOrientationOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b04d7c7d9b8c3021ef533772e9c766b040010efa4518ca7ea90cc018d8815b18)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__71d303aea03c2a9ef2a5210385c366817f9a7454ff139e86a7fb62cf2cc53198)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__255711831b3379f64162ee40acb9936bcbe3536f4788b88e38b22a8f86c11f08)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfOrientation]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfOrientation]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f1622246f28ae51e0e278ec4f74ede7d25262872e8d573fdcf365597a5a60730)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfOrientationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfOrientationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__775bbb3cb35530fec68f36a283688dea3732b87be48767a0801f77941c687fc2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfOrientationDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putLandscape")
    def put_landscape(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfOrientationLandscape()

        return typing.cast(None, jsii.invoke(self, "putLandscape", [value]))

    @jsii.member(jsii_name="putPortrait")
    def put_portrait(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfOrientationPortrait()

        return typing.cast(None, jsii.invoke(self, "putPortrait", [value]))

    @jsii.member(jsii_name="putSquare")
    def put_square(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfOrientationSquare()

        return typing.cast(None, jsii.invoke(self, "putSquare", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetLandscape")
    def reset_landscape(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLandscape", []))

    @jsii.member(jsii_name="resetPortrait")
    def reset_portrait(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPortrait", []))

    @jsii.member(jsii_name="resetSquare")
    def reset_square(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSquare", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfOrientationDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfOrientationDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="landscape")
    def landscape(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfOrientationLandscapeOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfOrientationLandscapeOutputReference, jsii.get(self, "landscape"))

    @builtins.property
    @jsii.member(jsii_name="portrait")
    def portrait(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfOrientationPortraitOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfOrientationPortraitOutputReference", jsii.get(self, "portrait"))

    @builtins.property
    @jsii.member(jsii_name="square")
    def square(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfOrientationSquareOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfOrientationSquareOutputReference", jsii.get(self, "square"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfOrientationDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="landscapeInput")
    def landscape_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfOrientationLandscape], jsii.get(self, "landscapeInput"))

    @builtins.property
    @jsii.member(jsii_name="portraitInput")
    def portrait_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfOrientationPortrait"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfOrientationPortrait"], jsii.get(self, "portraitInput"))

    @builtins.property
    @jsii.member(jsii_name="squareInput")
    def square_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfOrientationSquare"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfOrientationSquare"], jsii.get(self, "squareInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfOrientation]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfOrientation]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfOrientation]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b0af1827743db2f25aa573ef5fb08c862437865061f7602ab68e818645997993)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfOrientationPortrait",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfOrientationPortrait:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfOrientationPortrait(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfOrientationPortraitOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfOrientationPortraitOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__22f4982a50537088ed1e3ac9277b0217ba9326bcfea1c97d50b0c7ae0a9aa808)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfOrientationPortrait]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfOrientationPortrait], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfOrientationPortrait],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6fd4f2fcc118aaba6d0735c60c024bcddf2a65ba0ef26c712bf47fe3e2000c16)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfOrientationSquare",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfOrientationSquare:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfOrientationSquare(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfOrientationSquareOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfOrientationSquareOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a45d5071c8fa19e4d96104092e424e35fa601e9ea4e65b90a3ba85a2957ee686)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfOrientationSquare]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfOrientationSquare], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfOrientationSquare],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__098b0a86bc781c34fc14015d1948899ed8f6fe77f8d4db80826c0b0c87d4d4a0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7cacd69cd44f2515b732e595dfcf999232f1461767ed863e8cffa61026781d94)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1b79215dabcee10b44b4817ed91ff94bf91d3952d485e0856154a054b6f6a0b6)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4219a811027bb227bd3713a187bc499a5adb079abb8653161462859d02d52788)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__08c058a95f075c2220b1976e0d5fc4af8f490d74615b4e5d093f93d43c8a35fc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__17e12915fd4236c65e801af60e9da16bec3683fe93073132121dcfeae89dd218)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformations]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformations]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformations]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd33e3ffcee3c981551691ee2179541513beaee751a9d47969b26848c18bbcbd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsMaxColors",
    jsii_struct_bases=[],
    name_mapping={"colors": "colors", "colors_var": "colorsVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsMaxColors:
    def __init__(
        self,
        *,
        colors: typing.Optional[builtins.str] = None,
        colors_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param colors: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        :param colors_var: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8ab5cc8cdb903579a774cb7a9d558f4d73d630e8f3730d8225c919a71d94447d)
            check_type(argname="argument colors", value=colors, expected_type=type_hints["colors"])
            check_type(argname="argument colors_var", value=colors_var, expected_type=type_hints["colors_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if colors is not None:
            self._values["colors"] = colors
        if colors_var is not None:
            self._values["colors_var"] = colors_var

    @builtins.property
    def colors(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        '''
        result = self._values.get("colors")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def colors_var(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        result = self._values.get("colors_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsMaxColors(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsMaxColorsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsMaxColorsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c823f8d2d69dbb6e9e33e45533e71c154c88172f3112fa2e87a1268a238ce2d2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsMaxColorsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dc10cc47de635ca37a24b0dec487a0b4ec1e01d2b767c75261f485ac72497b62)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsMaxColorsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__12d304b7a8c196da305ec293bf8c944d986612519b8dee2e9d0666549042382c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__352923f6cc38bab86823b7860f522959ee2158625d0a61ec5869679f64d064ef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1e69947114843e4f41524c4f017ebfc9522345ebe6e3018b290a320fd16c20fe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsMaxColors]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsMaxColors]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8e6e40c52a1e136a041ab1a3f816017e4a7a2c7aa59d29872aeceaf5afdebaa8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsMaxColorsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsMaxColorsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af5426604cb7f5ca4bfb409b5e810cffb9a46f8006585e3291e371f3f5484fcb)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColors")
    def reset_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColors", []))

    @jsii.member(jsii_name="resetColorsVar")
    def reset_colors_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorsVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorsInput")
    def colors_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsInput"))

    @builtins.property
    @jsii.member(jsii_name="colorsVarInput")
    def colors_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsVarInput"))

    @builtins.property
    @jsii.member(jsii_name="colors")
    def colors(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colors"))

    @colors.setter
    def colors(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ce94735ffa643f0b27390d86e37a59670f1026d8f1c0e77a2b478c8b87a7a092)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colors", value)

    @builtins.property
    @jsii.member(jsii_name="colorsVar")
    def colors_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorsVar"))

    @colors_var.setter
    def colors_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0566e087d42faa24c8bb83294db2a947ea4f5e41277670c558d01ff9e55e93d9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorsVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsMaxColors]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsMaxColors]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsMaxColors]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c1661c9ea0d98b084c30105f7d6208893c9ba121f7db604b557af9eb84be99eb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsMirror",
    jsii_struct_bases=[],
    name_mapping={
        "horizontal": "horizontal",
        "horizontal_var": "horizontalVar",
        "vertical": "vertical",
        "vertical_var": "verticalVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsMirror:
    def __init__(
        self,
        *,
        horizontal: typing.Optional[builtins.str] = None,
        horizontal_var: typing.Optional[builtins.str] = None,
        vertical: typing.Optional[builtins.str] = None,
        vertical_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param horizontal: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        :param horizontal_var: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        :param vertical: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        :param vertical_var: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9f9e8a3761f44ce05dcfa82588f137b3288bca8d01deb0971eec8aeeb04558d0)
            check_type(argname="argument horizontal", value=horizontal, expected_type=type_hints["horizontal"])
            check_type(argname="argument horizontal_var", value=horizontal_var, expected_type=type_hints["horizontal_var"])
            check_type(argname="argument vertical", value=vertical, expected_type=type_hints["vertical"])
            check_type(argname="argument vertical_var", value=vertical_var, expected_type=type_hints["vertical_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if horizontal is not None:
            self._values["horizontal"] = horizontal
        if horizontal_var is not None:
            self._values["horizontal_var"] = horizontal_var
        if vertical is not None:
            self._values["vertical"] = vertical
        if vertical_var is not None:
            self._values["vertical_var"] = vertical_var

    @builtins.property
    def horizontal(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        '''
        result = self._values.get("horizontal")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def horizontal_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        '''
        result = self._values.get("horizontal_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        '''
        result = self._values.get("vertical")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        result = self._values.get("vertical_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsMirror(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsMirrorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsMirrorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__337f71f8b68438c0ff84d35d47319792153ab6e5befec627fa18380719cdd39d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsMirrorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dee123e139cb4d35c2d508902aee5b9a57faab26e97405b834d2e2ec936b83a6)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsMirrorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c6adb400f1918a97d1999aae94a82d6faf26119012beea07105ee8b5cd2a734a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a4e7e6b764240f24304ddc83c7af540822b20b586fda4fe9093ea262f0ed1355)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3b1c559667ee4da668c5de8c8114921bf103421413f321d36ede3a4f246024fb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsMirror]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsMirror]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9c05fb235f80d4654e1ad2f7bd570ad339704a43e419d361440c91c0319200a6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsMirrorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsMirrorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9f810a09dfa46d5a35c1874122beea98099ad6779fe3260f8afa7605f8fca12d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHorizontal")
    def reset_horizontal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontal", []))

    @jsii.member(jsii_name="resetHorizontalVar")
    def reset_horizontal_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontalVar", []))

    @jsii.member(jsii_name="resetVertical")
    def reset_vertical(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVertical", []))

    @jsii.member(jsii_name="resetVerticalVar")
    def reset_vertical_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVerticalVar", []))

    @builtins.property
    @jsii.member(jsii_name="horizontalInput")
    def horizontal_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontalVarInput")
    def horizontal_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalInput")
    def vertical_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalVarInput")
    def vertical_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontal")
    def horizontal(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontal"))

    @horizontal.setter
    def horizontal(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4fd939eac5f9708c6bf3b49a1f4cface0b62dcbd69d2a31859cf8f98b3874365)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontal", value)

    @builtins.property
    @jsii.member(jsii_name="horizontalVar")
    def horizontal_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontalVar"))

    @horizontal_var.setter
    def horizontal_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0b81adda1c0e072766381b86ed64de00805d5d4c499f65edc755ba252fc29200)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontalVar", value)

    @builtins.property
    @jsii.member(jsii_name="vertical")
    def vertical(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "vertical"))

    @vertical.setter
    def vertical(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__71ca9dba4243338aad446420f6ceec2872db84f9b06fbbe892cc0fdda1118793)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "vertical", value)

    @builtins.property
    @jsii.member(jsii_name="verticalVar")
    def vertical_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "verticalVar"))

    @vertical_var.setter
    def vertical_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__699918ab8a90b10ca9e81ca5e2a75c0b194d256ab087abfb5c04ab0d53730b28)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "verticalVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsMirror]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsMirror]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsMirror]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ccd0634c4900262ab0c92d179b4cd0dbfb87bfefbce48f1c99dcdfc1fced926b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsMonoHue",
    jsii_struct_bases=[],
    name_mapping={"hue": "hue", "hue_var": "hueVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsMonoHue:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2b3168a2b08d4925dfedc2e6ebed44d3d66fb71613a611553ac3e0a40ea255a0)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsMonoHue(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsMonoHueList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsMonoHueList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4110be9847a35077219e2373f3d4e34911c60053a33b4586260fb7806eb37d30)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsMonoHueOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2535c100c0de4960876ac48f3eed56d18ba6668ada6312806a49726f51db9bde)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsMonoHueOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1fa1272adac9b2d094e8eff612175c7d739a45ac8a1951e41c8eced476d9f434)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c181dbacf684b0ef54d6a4be582cda520b1c9a71b206996f070663f50958ec9c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fe324661368c52cb3f87297c3db303bc6e6194e97fefb4b78a7810d2d4e6fcdb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsMonoHue]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsMonoHue]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df4faf6b09d5463d32e7de9095f2436942320be91f2fc91f2d61c043be596c30)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsMonoHueOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsMonoHueOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6a0bf2e7e4337cf1eea8a8318efa27a115e982ff2818692535366625e88c4f86)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__97ca1446614d7eef7b24a30fb135ff7e27cbf31ceb5b8b79c5581a7215c7f5d6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__400a0d05eaa4cbdf55f0b3fd4347c2aced0b6b7e4f9f33b82074d3e9313ec6a8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsMonoHue]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsMonoHue]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsMonoHue]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fb9985c0648deef725c45a967a0f76b8b714e2c3649ed71cd98d5c9a6ac5de9b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsOpacity",
    jsii_struct_bases=[],
    name_mapping={"opacity": "opacity", "opacity_var": "opacityVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsOpacity:
    def __init__(
        self,
        *,
        opacity: typing.Optional[builtins.str] = None,
        opacity_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param opacity: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param opacity_var: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e3a16c665772a7ce8eafa0c68201b15cc6bac9622c9e9e38c3e4a7a763ce6a49)
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument opacity_var", value=opacity_var, expected_type=type_hints["opacity_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if opacity is not None:
            self._values["opacity"] = opacity
        if opacity_var is not None:
            self._values["opacity_var"] = opacity_var

    @builtins.property
    def opacity(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def opacity_var(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        result = self._values.get("opacity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsOpacity(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsOpacityList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsOpacityList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f0c83128963cd1dce3ac3a7b57dcf33bce037d3c6718e1ed66ea241e25a5bc6e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsOpacityOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b9e4b7b0677ea33907e8b3bb971a9054b5665d21c4ce19d1122bb3b0ddbddf4c)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsOpacityOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3544fd7b10f5d085a8e0825b1bc67c5222430730b70f97aa6fa079abc916faa8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3412b05eec12f14118865cc520c79b87dcd70db829d6cfb02eaf11cd2a77e2b9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8c3afc3f9a2f6dada3027391aeac8c9e87324e2b8153ad31a6ff4e28b0987a2b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsOpacity]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsOpacity]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ae779a604e2d9ca358cb323732bc1cecc393fff26ea71731bec38a43105b81e6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsOpacityOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsOpacityOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c9badb1e3156be519e49725e187e412a7211fd78d8c960636c556935f3af6a7a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetOpacityVar")
    def reset_opacity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacityVar", []))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityVarInput")
    def opacity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacity"))

    @opacity.setter
    def opacity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d2824e149c1dce4462395b4a3765d0f5b4c4e5a93b2a6da9129b57250f32f69b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacity", value)

    @builtins.property
    @jsii.member(jsii_name="opacityVar")
    def opacity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacityVar"))

    @opacity_var.setter
    def opacity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6cc374c643ea8fae189ed52b6b4ad9e47bcd14d4f2009e9801ec34e7c457c9b6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacityVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsOpacity]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsOpacity]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsOpacity]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0eddebf54dbb1638c7cbf9b29f0669642075448028876d8a5bb31b90aa0ce7a4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__157bbbec67f1872f32908292d79212d7733044123c86447af1da26a49fbb6c95)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putBackgroundColor")
    def put_background_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c63d826e9994c26f81a5c6590adbe44931f0aa4586d05ce0ed3a054c72575fdd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBackgroundColor", [value]))

    @jsii.member(jsii_name="putBlur")
    def put_blur(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsBlur, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f206441757246fcf392c7744066135abedc223f72ee7f637543d205409331bd3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBlur", [value]))

    @jsii.member(jsii_name="putChromaKey")
    def put_chroma_key(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsChromaKey, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f31eb066bd617ee91d3d4db79fc287f6d1f69b128073022a8fee1ededad410e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putChromaKey", [value]))

    @jsii.member(jsii_name="putComposite")
    def put_composite(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsComposite, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1afba2190741a6b8d0becb3eca19cda115e6fac6e73b89a23730013234471f20)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putComposite", [value]))

    @jsii.member(jsii_name="putCompound")
    def put_compound(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsCompound, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2cd43b48003b440b566de02d858bf0cc8ee3145138c8abdd942400c94ea628d3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCompound", [value]))

    @jsii.member(jsii_name="putContrast")
    def put_contrast(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsContrast, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__31df2df163d561ce7eb4b6e021698a003f1a1753b11145e50f97e13e563e1ceb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putContrast", [value]))

    @jsii.member(jsii_name="putGoop")
    def put_goop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsGoop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__068f0c3cfdb66081ba23c42e908ec7d13496b0d1bb517544984cc27227b85702)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGoop", [value]))

    @jsii.member(jsii_name="putGrayscale")
    def put_grayscale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsGrayscale, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1c082688f47440201abb16dc1d7d33e7e89098bc29e4956f3bed71935e6a186c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGrayscale", [value]))

    @jsii.member(jsii_name="putHsl")
    def put_hsl(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsHsl, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3819c19beacc03601e0f69b245fd0760d217a7f1bbedecdf73363e743f7316c6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsl", [value]))

    @jsii.member(jsii_name="putHsv")
    def put_hsv(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsHsv, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b99b3328ba1d5171a670105ae389bd78cd3647d5fa5ec15c5387456d2546ad31)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsv", [value]))

    @jsii.member(jsii_name="putIfDimension")
    def put_if_dimension(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfDimension, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3dfdd06894efce9b6c8c3b7089bae822741e631420fff08fc89669d36a027ccf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfDimension", [value]))

    @jsii.member(jsii_name="putIfOrientation")
    def put_if_orientation(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__705165d83e835f9287e20a9bc4cc5fd498aae66ded65aaaa055c87fda419d0ae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfOrientation", [value]))

    @jsii.member(jsii_name="putMaxColors")
    def put_max_colors(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsMaxColors, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__20bcb011e26df3da89171bd59c20b2301d142849fe500095bb2387d0707b5f81)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMaxColors", [value]))

    @jsii.member(jsii_name="putMirror")
    def put_mirror(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsMirror, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__de70fd5b3c84cfeca0fdc8f0843a4af0bda7ba73bf8fc643a9bd9d4dd08a46c0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMirror", [value]))

    @jsii.member(jsii_name="putMonoHue")
    def put_mono_hue(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsMonoHue, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__afe9c500ef77647531684a49ec30fb25f88a55ecfc824460e0979562499e6435)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMonoHue", [value]))

    @jsii.member(jsii_name="putOpacity")
    def put_opacity(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsOpacity, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d5867c842fdfb9907cb392a5c167787f11bcd813dfddd84b2ffabfd08acd9340)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putOpacity", [value]))

    @jsii.member(jsii_name="putRemoveColor")
    def put_remove_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsRemoveColor", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__25efaff4c252825c4a4d21569de2843332c6170dca39fd821450f5f8a04fd301)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRemoveColor", [value]))

    @jsii.member(jsii_name="putUnsharpMask")
    def put_unsharp_mask(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsUnsharpMask", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__311a7a6b0d259789a322f39ec6eb9132cb01842808bb8a26b32c50c40f885a96)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putUnsharpMask", [value]))

    @jsii.member(jsii_name="resetBackgroundColor")
    def reset_background_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBackgroundColor", []))

    @jsii.member(jsii_name="resetBlur")
    def reset_blur(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBlur", []))

    @jsii.member(jsii_name="resetChromaKey")
    def reset_chroma_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChromaKey", []))

    @jsii.member(jsii_name="resetComposite")
    def reset_composite(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetComposite", []))

    @jsii.member(jsii_name="resetCompound")
    def reset_compound(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCompound", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetGoop")
    def reset_goop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGoop", []))

    @jsii.member(jsii_name="resetGrayscale")
    def reset_grayscale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGrayscale", []))

    @jsii.member(jsii_name="resetHsl")
    def reset_hsl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsl", []))

    @jsii.member(jsii_name="resetHsv")
    def reset_hsv(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsv", []))

    @jsii.member(jsii_name="resetIfDimension")
    def reset_if_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfDimension", []))

    @jsii.member(jsii_name="resetIfOrientation")
    def reset_if_orientation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfOrientation", []))

    @jsii.member(jsii_name="resetMaxColors")
    def reset_max_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxColors", []))

    @jsii.member(jsii_name="resetMirror")
    def reset_mirror(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMirror", []))

    @jsii.member(jsii_name="resetMonoHue")
    def reset_mono_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonoHue", []))

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetRemoveColor")
    def reset_remove_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRemoveColor", []))

    @jsii.member(jsii_name="resetUnsharpMask")
    def reset_unsharp_mask(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUnsharpMask", []))

    @builtins.property
    @jsii.member(jsii_name="backgroundColor")
    def background_color(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsBackgroundColorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsBackgroundColorList, jsii.get(self, "backgroundColor"))

    @builtins.property
    @jsii.member(jsii_name="blur")
    def blur(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsBlurList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsBlurList, jsii.get(self, "blur"))

    @builtins.property
    @jsii.member(jsii_name="chromaKey")
    def chroma_key(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsChromaKeyList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsChromaKeyList, jsii.get(self, "chromaKey"))

    @builtins.property
    @jsii.member(jsii_name="composite")
    def composite(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsCompositeList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsCompositeList, jsii.get(self, "composite"))

    @builtins.property
    @jsii.member(jsii_name="compound")
    def compound(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsCompoundList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsCompoundList, jsii.get(self, "compound"))

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsContrastList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsContrastList, jsii.get(self, "contrast"))

    @builtins.property
    @jsii.member(jsii_name="goop")
    def goop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsGoopList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsGoopList, jsii.get(self, "goop"))

    @builtins.property
    @jsii.member(jsii_name="grayscale")
    def grayscale(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsGrayscaleList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsGrayscaleList, jsii.get(self, "grayscale"))

    @builtins.property
    @jsii.member(jsii_name="hsl")
    def hsl(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsHslList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsHslList, jsii.get(self, "hsl"))

    @builtins.property
    @jsii.member(jsii_name="hsv")
    def hsv(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsHsvList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsHsvList, jsii.get(self, "hsv"))

    @builtins.property
    @jsii.member(jsii_name="ifDimension")
    def if_dimension(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfDimensionList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfDimensionList, jsii.get(self, "ifDimension"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientation")
    def if_orientation(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfOrientationList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfOrientationList, jsii.get(self, "ifOrientation"))

    @builtins.property
    @jsii.member(jsii_name="maxColors")
    def max_colors(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsMaxColorsList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsMaxColorsList, jsii.get(self, "maxColors"))

    @builtins.property
    @jsii.member(jsii_name="mirror")
    def mirror(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsMirrorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsMirrorList, jsii.get(self, "mirror"))

    @builtins.property
    @jsii.member(jsii_name="monoHue")
    def mono_hue(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsMonoHueList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsMonoHueList, jsii.get(self, "monoHue"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsOpacityList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsOpacityList, jsii.get(self, "opacity"))

    @builtins.property
    @jsii.member(jsii_name="removeColor")
    def remove_color(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsRemoveColorList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsRemoveColorList", jsii.get(self, "removeColor"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMask")
    def unsharp_mask(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsUnsharpMaskList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsUnsharpMaskList", jsii.get(self, "unsharpMask"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColorInput")
    def background_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsBackgroundColor]]], jsii.get(self, "backgroundColorInput"))

    @builtins.property
    @jsii.member(jsii_name="blurInput")
    def blur_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsBlur]]], jsii.get(self, "blurInput"))

    @builtins.property
    @jsii.member(jsii_name="chromaKeyInput")
    def chroma_key_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsChromaKey]]], jsii.get(self, "chromaKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="compositeInput")
    def composite_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsComposite]]], jsii.get(self, "compositeInput"))

    @builtins.property
    @jsii.member(jsii_name="compoundInput")
    def compound_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsCompound]]], jsii.get(self, "compoundInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsContrast]]], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="goopInput")
    def goop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsGoop]]], jsii.get(self, "goopInput"))

    @builtins.property
    @jsii.member(jsii_name="grayscaleInput")
    def grayscale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsGrayscale]]], jsii.get(self, "grayscaleInput"))

    @builtins.property
    @jsii.member(jsii_name="hslInput")
    def hsl_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsHsl]]], jsii.get(self, "hslInput"))

    @builtins.property
    @jsii.member(jsii_name="hsvInput")
    def hsv_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsHsv]]], jsii.get(self, "hsvInput"))

    @builtins.property
    @jsii.member(jsii_name="ifDimensionInput")
    def if_dimension_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfDimension]]], jsii.get(self, "ifDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientationInput")
    def if_orientation_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfOrientation]]], jsii.get(self, "ifOrientationInput"))

    @builtins.property
    @jsii.member(jsii_name="maxColorsInput")
    def max_colors_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsMaxColors]]], jsii.get(self, "maxColorsInput"))

    @builtins.property
    @jsii.member(jsii_name="mirrorInput")
    def mirror_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsMirror]]], jsii.get(self, "mirrorInput"))

    @builtins.property
    @jsii.member(jsii_name="monoHueInput")
    def mono_hue_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsMonoHue]]], jsii.get(self, "monoHueInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsOpacity]]], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="removeColorInput")
    def remove_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsRemoveColor"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsRemoveColor"]]], jsii.get(self, "removeColorInput"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMaskInput")
    def unsharp_mask_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsUnsharpMask"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsUnsharpMask"]]], jsii.get(self, "unsharpMaskInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformations]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformations]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformations]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__da28297c19c52def805e45faf5589bf8a6b54482e6815a2d57bb507f8c1b0e3d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsRemoveColor",
    jsii_struct_bases=[],
    name_mapping={
        "color": "color",
        "color_var": "colorVar",
        "feather": "feather",
        "feather_var": "featherVar",
        "tolerance": "tolerance",
        "tolerance_var": "toleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsRemoveColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
        feather: typing.Optional[builtins.str] = None,
        feather_var: typing.Optional[builtins.str] = None,
        tolerance: typing.Optional[builtins.str] = None,
        tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        :param feather: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        :param feather_var: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        :param tolerance: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        :param tolerance_var: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e355adde72354ced96c8e4eef4e433da9941170c5f28744bfbd0d90808c11bab)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
            check_type(argname="argument feather", value=feather, expected_type=type_hints["feather"])
            check_type(argname="argument feather_var", value=feather_var, expected_type=type_hints["feather_var"])
            check_type(argname="argument tolerance", value=tolerance, expected_type=type_hints["tolerance"])
            check_type(argname="argument tolerance_var", value=tolerance_var, expected_type=type_hints["tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var
        if feather is not None:
            self._values["feather"] = feather
        if feather_var is not None:
            self._values["feather_var"] = feather_var
        if tolerance is not None:
            self._values["tolerance"] = tolerance
        if tolerance_var is not None:
            self._values["tolerance_var"] = tolerance_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        '''
        result = self._values.get("feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather_var(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        '''
        result = self._values.get("feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        '''
        result = self._values.get("tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance_var(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        result = self._values.get("tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsRemoveColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsRemoveColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsRemoveColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1fbd9ef17a337b8deeac589d079ea11e37f974867e1dea0d14c7f92b0ea9230d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsRemoveColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4c94788286d79ab4b7d45b3ae9a0a703fe33d1c8dcd79605f05cd1b2a7d81118)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsRemoveColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__16fbce41aeb272a475c217e573e94f7a9f78c36053cc2d5856462b7d75ac6c7c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9297e18fb4788be3a362c77c6bb1c6de94b05f5471c746656b2e9c027747cf55)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b63f16ff179ddc08268fed965551343df87bc5d68a2a8817d902c90f1acf71ab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsRemoveColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsRemoveColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsRemoveColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d3b0149901520a5be87cdd091050096b83fa1351216a65b0b5f6b1a1c49d8a9d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsRemoveColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsRemoveColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d0dcb8894e351b86313a474d0b83db94b410246649aae3a24b5bb003557523c8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @jsii.member(jsii_name="resetFeather")
    def reset_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeather", []))

    @jsii.member(jsii_name="resetFeatherVar")
    def reset_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatherVar", []))

    @jsii.member(jsii_name="resetTolerance")
    def reset_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTolerance", []))

    @jsii.member(jsii_name="resetToleranceVar")
    def reset_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featherInput")
    def feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherInput"))

    @builtins.property
    @jsii.member(jsii_name="featherVarInput")
    def feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceInput")
    def tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceVarInput")
    def tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c0ae46f010988f3800a7870aab2bb101fab5edf1323d193c390aaa64ec3af92e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__64eb4378b1bd873227693ddc97aa0797521524ee562ccb2ca4d33db20c16db4b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="feather")
    def feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "feather"))

    @feather.setter
    def feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df26d019708ed372d89bd0f9d60a9c34f629d6d91afd50df70a17ccbab9273b9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "feather", value)

    @builtins.property
    @jsii.member(jsii_name="featherVar")
    def feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featherVar"))

    @feather_var.setter
    def feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9f7fa7c09a92f2ebac1cde32a5f402aeaf82ba7860f915bc841cd2ef491a4fac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featherVar", value)

    @builtins.property
    @jsii.member(jsii_name="tolerance")
    def tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tolerance"))

    @tolerance.setter
    def tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d5adae39945e7b89f5d038f4d3fc861b30568c05c84cce64c77d75c4620ae3ad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tolerance", value)

    @builtins.property
    @jsii.member(jsii_name="toleranceVar")
    def tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "toleranceVar"))

    @tolerance_var.setter
    def tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__79ac2000f0c11ee6dd8e8648a4991403fe7436b9bcf99356db2bf3083727c763)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "toleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsRemoveColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsRemoveColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsRemoveColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f1c424183b889b1bd707d7783511e0e75d5633341609d1d3fd9ce9499a3f8dd5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsUnsharpMask",
    jsii_struct_bases=[],
    name_mapping={
        "gain": "gain",
        "gain_var": "gainVar",
        "sigma": "sigma",
        "sigma_var": "sigmaVar",
        "threshold": "threshold",
        "threshold_var": "thresholdVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsUnsharpMask:
    def __init__(
        self,
        *,
        gain: typing.Optional[builtins.str] = None,
        gain_var: typing.Optional[builtins.str] = None,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
        threshold: typing.Optional[builtins.str] = None,
        threshold_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param gain: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        :param gain_var: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        :param sigma: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        :param threshold: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        :param threshold_var: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3b1e88a49d587fe02423390dd23db37eed391beab61ae4a928b81be895de7b2a)
            check_type(argname="argument gain", value=gain, expected_type=type_hints["gain"])
            check_type(argname="argument gain_var", value=gain_var, expected_type=type_hints["gain_var"])
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
            check_type(argname="argument threshold", value=threshold, expected_type=type_hints["threshold"])
            check_type(argname="argument threshold_var", value=threshold_var, expected_type=type_hints["threshold_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if gain is not None:
            self._values["gain"] = gain
        if gain_var is not None:
            self._values["gain_var"] = gain_var
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var
        if threshold is not None:
            self._values["threshold"] = threshold
        if threshold_var is not None:
            self._values["threshold_var"] = threshold_var

    @builtins.property
    def gain(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        '''
        result = self._values.get("gain")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gain_var(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        '''
        result = self._values.get("gain_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        '''
        result = self._values.get("threshold")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold_var(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        result = self._values.get("threshold_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsUnsharpMask(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsUnsharpMaskList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsUnsharpMaskList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b43975d428ad83376a71125bcc3466de0e1fb5462ff6315c0b6a7e379a6f407c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsUnsharpMaskOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9beb6750fc6001c15c8e0d88567104ac4ed84b7bff442af90279eb7cef6dc54b)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsUnsharpMaskOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9991f9bb5401f6fca52264c7a17f9fe26712515e7b4dca714c4765388036e729)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3918404092597ffddcb8f84acd1e8c44af8635aa3e66bca06e62ac11d90d46dc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6874e5a825b510ab72eb3d711f36b4046665816f2b36583584de230eb9b49d52)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsUnsharpMask]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsUnsharpMask]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsUnsharpMask]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__559cdb2166b1cd4afbe88fdd2ab05ac44d2516d7770be8e1ac2369a79469d631)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsUnsharpMaskOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsUnsharpMaskOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b8c6c0f23dd9319b6c41bd06d80184b920207c37e8984e71b55149c7ed1f38ff)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetGain")
    def reset_gain(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGain", []))

    @jsii.member(jsii_name="resetGainVar")
    def reset_gain_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGainVar", []))

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @jsii.member(jsii_name="resetThreshold")
    def reset_threshold(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThreshold", []))

    @jsii.member(jsii_name="resetThresholdVar")
    def reset_threshold_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThresholdVar", []))

    @builtins.property
    @jsii.member(jsii_name="gainInput")
    def gain_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainInput"))

    @builtins.property
    @jsii.member(jsii_name="gainVarInput")
    def gain_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdInput")
    def threshold_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdVarInput")
    def threshold_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gain")
    def gain(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gain"))

    @gain.setter
    def gain(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1ec2082cf98f258588549099fe839006f7dca019ebcb9a68848c60487c0ac85a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gain", value)

    @builtins.property
    @jsii.member(jsii_name="gainVar")
    def gain_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gainVar"))

    @gain_var.setter
    def gain_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ebebf5e847961e61eeb9188d1a6d4bc725b67e5051ad3de7c6d11b152de74a0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gainVar", value)

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1d57b85328065c8479dd8ed1447eefbc237a28ab793d69ae8b3ace728f41a168)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__933300f92b0a90f37b32bfe7f575b83f3067af839ef77b2dbc44cf1ecb7ef3e6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="threshold")
    def threshold(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "threshold"))

    @threshold.setter
    def threshold(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8f673caada516810f734b8baee0573df5451d44e90e4f1700762f284d6223605)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "threshold", value)

    @builtins.property
    @jsii.member(jsii_name="thresholdVar")
    def threshold_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "thresholdVar"))

    @threshold_var.setter
    def threshold_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dcc7acb30b711ce0b393bb865959a8724020d8f03cb74d561eb1555869d110dc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "thresholdVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsUnsharpMask]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsUnsharpMask]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsUnsharpMask]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4d0c5a9516e336dd2b57f5ac24610f889d1a53bf4ad380d0a8ef07a9d239c47a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanContrast",
    jsii_struct_bases=[],
    name_mapping={
        "brightness": "brightness",
        "brightness_var": "brightnessVar",
        "contrast": "contrast",
        "contrast_var": "contrastVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanContrast:
    def __init__(
        self,
        *,
        brightness: typing.Optional[builtins.str] = None,
        brightness_var: typing.Optional[builtins.str] = None,
        contrast: typing.Optional[builtins.str] = None,
        contrast_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param brightness: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        :param brightness_var: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        :param contrast: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param contrast_var: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__30931dd833684e601cd97f26e17a0ac0b13308b8d3f193643eedff15253422fb)
            check_type(argname="argument brightness", value=brightness, expected_type=type_hints["brightness"])
            check_type(argname="argument brightness_var", value=brightness_var, expected_type=type_hints["brightness_var"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument contrast_var", value=contrast_var, expected_type=type_hints["contrast_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if brightness is not None:
            self._values["brightness"] = brightness
        if brightness_var is not None:
            self._values["brightness_var"] = brightness_var
        if contrast is not None:
            self._values["contrast"] = contrast
        if contrast_var is not None:
            self._values["contrast_var"] = contrast_var

    @builtins.property
    def brightness(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        '''
        result = self._values.get("brightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def brightness_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        '''
        result = self._values.get("brightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        result = self._values.get("contrast_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanContrast(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanContrastList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanContrastList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__766f1d278c2485bd1dbc2b93ffb51c1ae3925ba40eca2e9e4011dd8f3589fd5c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanContrastOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea3230294e44f5c49ca7482ac9766cc1bdcae0c5d662a1d37954c2c3469b6427)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanContrastOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__80d54f887cfcf9079d4d61f98575414d9b8f8718c568b4fff6f15b2818ef7bbc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__98e2c73cac282eab4a708ef36fa363eaf46c643bd9b842db63f6cd80592a7b2c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2864ebe5c66e403107e1b0663ecc7e891793983ea444688a50dcc78f14032309)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanContrast]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanContrast]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__45c2aaf6aceb62ff4a6fa08c0b7416ef20956038a77352ad768493a9ed7dcf60)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanContrastOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanContrastOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e115bfed70aad6586e415d9833dae9d7d9899b27db635e7283c52fa97ba9b79d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetBrightness")
    def reset_brightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightness", []))

    @jsii.member(jsii_name="resetBrightnessVar")
    def reset_brightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightnessVar", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetContrastVar")
    def reset_contrast_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrastVar", []))

    @builtins.property
    @jsii.member(jsii_name="brightnessInput")
    def brightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="brightnessVarInput")
    def brightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastVarInput")
    def contrast_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="brightness")
    def brightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightness"))

    @brightness.setter
    def brightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__707c18ddaac8e9a7b2a0d73f76518dd682f9fa9ddb48f973cb52c78986670048)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightness", value)

    @builtins.property
    @jsii.member(jsii_name="brightnessVar")
    def brightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightnessVar"))

    @brightness_var.setter
    def brightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__db525e2e94489dd15e1012003d22b7870f6d8e1593a6a0d7ff9895a184affc5e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrast"))

    @contrast.setter
    def contrast(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e698565b0c541b11c89375f2e49c9537f63c142c12ed7b775de650873b6b1c37)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrast", value)

    @builtins.property
    @jsii.member(jsii_name="contrastVar")
    def contrast_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrastVar"))

    @contrast_var.setter
    def contrast_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__377a625bdde4d4a996872788175cbef0958df9f51449134d4c374ef6f3f87565)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrastVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanContrast]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanContrast]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanContrast]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__167ec7e011418bf2ac95a476e71c41b2446c60471bf1307a69af4ce8bece8bcd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanGoop",
    jsii_struct_bases=[],
    name_mapping={
        "chaos": "chaos",
        "chaos_var": "chaosVar",
        "density": "density",
        "density_var": "densityVar",
        "power": "power",
        "power_var": "powerVar",
        "seed": "seed",
        "seed_var": "seedVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanGoop:
    def __init__(
        self,
        *,
        chaos: typing.Optional[builtins.str] = None,
        chaos_var: typing.Optional[builtins.str] = None,
        density: typing.Optional[builtins.str] = None,
        density_var: typing.Optional[builtins.str] = None,
        power: typing.Optional[builtins.str] = None,
        power_var: typing.Optional[builtins.str] = None,
        seed: typing.Optional[builtins.str] = None,
        seed_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param chaos: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        :param chaos_var: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        :param density: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        :param density_var: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        :param power: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        :param power_var: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        :param seed: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        :param seed_var: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bfca03cb0caabe7815c6cb1b56ae9b57274aba9c6be7495321f9591fb3d72270)
            check_type(argname="argument chaos", value=chaos, expected_type=type_hints["chaos"])
            check_type(argname="argument chaos_var", value=chaos_var, expected_type=type_hints["chaos_var"])
            check_type(argname="argument density", value=density, expected_type=type_hints["density"])
            check_type(argname="argument density_var", value=density_var, expected_type=type_hints["density_var"])
            check_type(argname="argument power", value=power, expected_type=type_hints["power"])
            check_type(argname="argument power_var", value=power_var, expected_type=type_hints["power_var"])
            check_type(argname="argument seed", value=seed, expected_type=type_hints["seed"])
            check_type(argname="argument seed_var", value=seed_var, expected_type=type_hints["seed_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if chaos is not None:
            self._values["chaos"] = chaos
        if chaos_var is not None:
            self._values["chaos_var"] = chaos_var
        if density is not None:
            self._values["density"] = density
        if density_var is not None:
            self._values["density_var"] = density_var
        if power is not None:
            self._values["power"] = power
        if power_var is not None:
            self._values["power_var"] = power_var
        if seed is not None:
            self._values["seed"] = seed
        if seed_var is not None:
            self._values["seed_var"] = seed_var

    @builtins.property
    def chaos(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        '''
        result = self._values.get("chaos")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def chaos_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        '''
        result = self._values.get("chaos_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        '''
        result = self._values.get("density")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density_var(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        '''
        result = self._values.get("density_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        '''
        result = self._values.get("power")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power_var(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        '''
        result = self._values.get("power_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        '''
        result = self._values.get("seed")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed_var(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        result = self._values.get("seed_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanGoop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanGoopList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanGoopList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6d4c4f60c47075e82039ab39476438a9defbfe3f458390189b7b0795cc7b8338)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanGoopOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__00f8e0deb7345c4a98b072f0fd8f53eeb5fcf3bc8402dabfd29104d640145ae0)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanGoopOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8ba519447b9f6cec95ab2cf99ab2c9b9c54e7fc864f541b83fe3c7e84996b10c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__baac1b39f39cd4a2cf037ad52d24d5d97a30d89195fd307a2d4a0a28a4f08683)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3451f6fa1d56195c0d94b66ec2f59ca19968135498f354f5300c80cf633aef53)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanGoop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanGoop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bf4d049c29e56410215f8751c5b60257304c8c6f4dae06f28cf266577732af28)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanGoopOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanGoopOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3b5b804a26df33da0b68f65b4d21c08518c247933e9597742c90c869c94d77f2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetChaos")
    def reset_chaos(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaos", []))

    @jsii.member(jsii_name="resetChaosVar")
    def reset_chaos_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaosVar", []))

    @jsii.member(jsii_name="resetDensity")
    def reset_density(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensity", []))

    @jsii.member(jsii_name="resetDensityVar")
    def reset_density_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensityVar", []))

    @jsii.member(jsii_name="resetPower")
    def reset_power(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPower", []))

    @jsii.member(jsii_name="resetPowerVar")
    def reset_power_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPowerVar", []))

    @jsii.member(jsii_name="resetSeed")
    def reset_seed(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeed", []))

    @jsii.member(jsii_name="resetSeedVar")
    def reset_seed_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeedVar", []))

    @builtins.property
    @jsii.member(jsii_name="chaosInput")
    def chaos_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosInput"))

    @builtins.property
    @jsii.member(jsii_name="chaosVarInput")
    def chaos_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosVarInput"))

    @builtins.property
    @jsii.member(jsii_name="densityInput")
    def density_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityInput"))

    @builtins.property
    @jsii.member(jsii_name="densityVarInput")
    def density_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="powerInput")
    def power_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerInput"))

    @builtins.property
    @jsii.member(jsii_name="powerVarInput")
    def power_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerVarInput"))

    @builtins.property
    @jsii.member(jsii_name="seedInput")
    def seed_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedInput"))

    @builtins.property
    @jsii.member(jsii_name="seedVarInput")
    def seed_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedVarInput"))

    @builtins.property
    @jsii.member(jsii_name="chaos")
    def chaos(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaos"))

    @chaos.setter
    def chaos(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a316afbdde0e257b2a6cb6f4999ac71520e8f98ff3e6a669dc04ee31e046ceb6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaos", value)

    @builtins.property
    @jsii.member(jsii_name="chaosVar")
    def chaos_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaosVar"))

    @chaos_var.setter
    def chaos_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d5d9fa21f327d2200eea55ea2be964cdf443cc32055f3c8b72db594040c1817)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaosVar", value)

    @builtins.property
    @jsii.member(jsii_name="density")
    def density(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "density"))

    @density.setter
    def density(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e6b7244d49ac183a66abeb963fa8a813b68ece97bc1355176a292d06fcb837ff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "density", value)

    @builtins.property
    @jsii.member(jsii_name="densityVar")
    def density_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "densityVar"))

    @density_var.setter
    def density_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__904c375fb825914dfc28afe846cf12f2db4225d02bede42bfffe2d95d335e652)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "densityVar", value)

    @builtins.property
    @jsii.member(jsii_name="power")
    def power(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "power"))

    @power.setter
    def power(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a5cdece2d50d186454eebebab526980e509a32935c654bab606b875474037c82)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "power", value)

    @builtins.property
    @jsii.member(jsii_name="powerVar")
    def power_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "powerVar"))

    @power_var.setter
    def power_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f23ef609e76cb87275a5e30e965e39fdd0e039fd37aaea4608dd1e9df7e90d31)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "powerVar", value)

    @builtins.property
    @jsii.member(jsii_name="seed")
    def seed(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seed"))

    @seed.setter
    def seed(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7334b89fa8693e7f8c78c63dd5e1f67b6e2a9f7826eb3717f170e3314f292e88)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seed", value)

    @builtins.property
    @jsii.member(jsii_name="seedVar")
    def seed_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seedVar"))

    @seed_var.setter
    def seed_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cf80af28dc9ca69c84e5a5c30a49e4c179e09a3aa4639060b70ed0eb9f4c4222)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seedVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanGoop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanGoop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanGoop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__899e8c6964b779b6323fa848cd3ae75867914c5374e7d07ec831be5160747abc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanGrayscale",
    jsii_struct_bases=[],
    name_mapping={"type": "type", "type_var": "typeVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanGrayscale:
    def __init__(
        self,
        *,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param type: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b9de35cfe9cdf70ab31ff6225b4f8c551c3969a39087029d8150820305680af9)
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanGrayscale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanGrayscaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanGrayscaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b64851f56d6b691ce3c67d0e65f2b68f532a8ad43cc5f8406b7b608156773be6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanGrayscaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__984be948fe608d34164a13fc80413fde0d2e8728ab423450ddb4491dc3ff44a0)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanGrayscaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f9a5e31ef09a8f542c32a38f33b014c2aabff9d0411c8d5e5379639f4a755c85)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__59c2b3b14764ce1c470831fc82011db92f95552c1bfbae2fd65004cc3bea30a0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a00ca8d6cd66080f52983ff80d78a46fbe76e03f57bae8f53c60632ca8be738e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanGrayscale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanGrayscale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9919c09e00526613bcd2779d301d360ae35e11fce8d0a4cb488a69ac68748005)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanGrayscaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanGrayscaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__efccec90aa93d8cee4dc857930ddcecd39bbd1cd03ed806e0c4db452e53a7148)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__46ca9c628eda4b257735d0f034c56b987753254c89c86fa5560d40c4c56140ef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7c3ef0f1f015808aa1598c10884f8d27e8802d0f437f13d48e925b2412ba43ca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanGrayscale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanGrayscale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanGrayscale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8d48440bbfa761f47660772d73635ab0d620e7856dba402a60738852dd117874)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanHsl",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "lightness": "lightness",
        "lightness_var": "lightnessVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanHsl:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness: typing.Optional[builtins.str] = None,
        lightness_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        :param lightness_var: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__de8311e947f25b7a41451f558514e61b83a02c02538058fe174b3c97c3f151f3)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness", value=lightness, expected_type=type_hints["lightness"])
            check_type(argname="argument lightness_var", value=lightness_var, expected_type=type_hints["lightness_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness is not None:
            self._values["lightness"] = lightness
        if lightness_var is not None:
            self._values["lightness_var"] = lightness_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        '''
        result = self._values.get("lightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        '''
        result = self._values.get("lightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanHsl(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanHslList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanHslList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c4ed1ed88b3cfb2d84e725ec759de9d172930001c3683010524463e024702390)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanHslOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dd9e5a6b8b05349c950b920612eeb5a90db012da642ac1f95477c5671c8cef75)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanHslOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fd71332e2ec35a77a48e0c60740b51a8eb697727dfb63fa6ad96642d8db26f18)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c2c6825a48c11d60c4424d4cd070197bbe98048a25d6d6269a762df9efe4aaae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b0368887b3f9ad2346b88e160e1c76a2afe188ec826c3cef0bdd628d2d645006)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanHsl]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanHsl]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5c4f85c4101c44242125da829e013019d42df37473fd944a5ee3564e78c12ea2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanHslOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanHslOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__92c3d2b1c95fbc7e7882918918c3a20bc3f22c3c8c451a09777770fe76413765)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightness")
    def reset_lightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightness", []))

    @jsii.member(jsii_name="resetLightnessVar")
    def reset_lightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessInput")
    def lightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessVarInput")
    def lightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b2730ef494b12bdbd6d915099f6db57de3a3ef32bb871bb14ceabcf1005b1895)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__48d07a315c89066cd9cdc2ba26fed4cc179fca1ea7c0a3d9b197f9b53ca73b97)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightness")
    def lightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightness"))

    @lightness.setter
    def lightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a1a06b2db999a2c3f36a631a198ceec4ede45e4f9aa015303c229257cfe570f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightness", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessVar")
    def lightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessVar"))

    @lightness_var.setter
    def lightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__87e38ba3cb759a0d8ea8f2b5c4a04ffe938dd7ada45eac0dbd63ac8d3d35e8b0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc27664be7b3921c962f2e8297df1de6da485a096c91ac8e78e84207b01f0926)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b0d83c1410e514771a35812859d5ff1c0d69e7f61af3380bc9c4b66b811a7141)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanHsl]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanHsl]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanHsl]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b1e06c50d2ae3a87cb0f09d2eadc7a5d35c1fbd243fa1006f86dd781531d106d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanHsv",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanHsv:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        :param value: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__68d8a68a5aafafe447a6f405c4c6a07ea175b247d515577e7ac1fd39f9bf744b)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanHsv(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanHsvList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanHsvList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1d87ce5f22c5e8b1524137707d28a74304a95e728527bce6f6cefb2bf3e58ff7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanHsvOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__425411e644d3c2af6b555e5efd5b871dfef0657af31bcfd4a983b5e0511a6307)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanHsvOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2b73e4a1b36e44b76c8dce2441b323439965a861bddd525e6e2e21aef5012ae5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__51d74f2103183eedb0f3d1d75d1b5b4684859517c0f758a4bb65654f201f3054)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4c4f7ccf59c93d8e57c3d664979d4baea61d1c82b58d088564ecce67c836be20)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanHsv]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanHsv]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b575833aae3dc595253c6de90cd59ca3817d5a5dff3ea60a2112199c6dff75da)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanHsvOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanHsvOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__749ea702cf2c426aadc3c60b5b4f35a4ca572e7d7c1ce20c6bc9dc3f9948337b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2e17ecd442139f02cc09b315399cda37c77a97d0753c82145d3c72858c6a670f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__07fcb370996ed2443da88e708437196e9889b4860e0066447e461ca01877a788)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ab6794cfc5cc43d6662c08680e8a478467e38b9aa593ab801a3d929db710bab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c548219ba8a75dfc77c80e2c01edef7f026425943371ba9f7455c8bce140b2b2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__12069e2d74c85d626ab95f848205abdae9ec2a9882694df739fb6d6ff414e09a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c2c8d7383ffc19a578130c23f4af92fb022f5f653bfcbcff3dafe2d063bc026b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanHsv]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanHsv]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanHsv]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7a4fb2d6e676e8d6d24aa26c85c6751d1043cd98a7f13253de2079d43fe13c74)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientation",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "landscape": "landscape",
        "portrait": "portrait",
        "square": "square",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientation:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        landscape: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscape", typing.Dict[builtins.str, typing.Any]]] = None,
        portrait: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortrait", typing.Dict[builtins.str, typing.Any]]] = None,
        square: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquare", typing.Dict[builtins.str, typing.Any]]] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param landscape: landscape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        :param portrait: portrait block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        :param square: square block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefault(**default)
        if isinstance(landscape, dict):
            landscape = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscape(**landscape)
        if isinstance(portrait, dict):
            portrait = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortrait(**portrait)
        if isinstance(square, dict):
            square = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquare(**square)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8963f8998c49528bf2cf7e82af9106552af01957bfa0be7408335d00ae1d1df5)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument landscape", value=landscape, expected_type=type_hints["landscape"])
            check_type(argname="argument portrait", value=portrait, expected_type=type_hints["portrait"])
            check_type(argname="argument square", value=square, expected_type=type_hints["square"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if landscape is not None:
            self._values["landscape"] = landscape
        if portrait is not None:
            self._values["portrait"] = portrait
        if square is not None:
            self._values["square"] = square

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefault"], result)

    @builtins.property
    def landscape(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscape"]:
        '''landscape block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        '''
        result = self._values.get("landscape")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscape"], result)

    @builtins.property
    def portrait(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortrait"]:
        '''portrait block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        '''
        result = self._values.get("portrait")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortrait"], result)

    @builtins.property
    def square(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquare"]:
        '''square block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        result = self._values.get("square")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquare"], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefault",
    jsii_struct_bases=[],
    name_mapping={
        "background_color": "backgroundColor",
        "blur": "blur",
        "chroma_key": "chromaKey",
        "composite": "composite",
        "compound": "compound",
        "contrast": "contrast",
        "goop": "goop",
        "grayscale": "grayscale",
        "hsl": "hsl",
        "hsv": "hsv",
        "if_dimension": "ifDimension",
        "if_orientation": "ifOrientation",
        "max_colors": "maxColors",
        "mirror": "mirror",
        "mono_hue": "monoHue",
        "opacity": "opacity",
        "remove_color": "removeColor",
        "unsharp_mask": "unsharpMask",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefault:
    def __init__(
        self,
        *,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultBackgroundColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultBlur", typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultChromaKey", typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultComposite", typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultCompound", typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultContrast", typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultGoop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultGrayscale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultHsl", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultHsv", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfDimension", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientation", typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultMaxColors", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultMirror", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultMonoHue", typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultOpacity", typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultRemoveColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultUnsharpMask", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__513df90afd964673c0e5e99d79ab4190ad6b697c6d85a9bb699dc8a69d079bfa)
            check_type(argname="argument background_color", value=background_color, expected_type=type_hints["background_color"])
            check_type(argname="argument blur", value=blur, expected_type=type_hints["blur"])
            check_type(argname="argument chroma_key", value=chroma_key, expected_type=type_hints["chroma_key"])
            check_type(argname="argument composite", value=composite, expected_type=type_hints["composite"])
            check_type(argname="argument compound", value=compound, expected_type=type_hints["compound"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument goop", value=goop, expected_type=type_hints["goop"])
            check_type(argname="argument grayscale", value=grayscale, expected_type=type_hints["grayscale"])
            check_type(argname="argument hsl", value=hsl, expected_type=type_hints["hsl"])
            check_type(argname="argument hsv", value=hsv, expected_type=type_hints["hsv"])
            check_type(argname="argument if_dimension", value=if_dimension, expected_type=type_hints["if_dimension"])
            check_type(argname="argument if_orientation", value=if_orientation, expected_type=type_hints["if_orientation"])
            check_type(argname="argument max_colors", value=max_colors, expected_type=type_hints["max_colors"])
            check_type(argname="argument mirror", value=mirror, expected_type=type_hints["mirror"])
            check_type(argname="argument mono_hue", value=mono_hue, expected_type=type_hints["mono_hue"])
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument remove_color", value=remove_color, expected_type=type_hints["remove_color"])
            check_type(argname="argument unsharp_mask", value=unsharp_mask, expected_type=type_hints["unsharp_mask"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if background_color is not None:
            self._values["background_color"] = background_color
        if blur is not None:
            self._values["blur"] = blur
        if chroma_key is not None:
            self._values["chroma_key"] = chroma_key
        if composite is not None:
            self._values["composite"] = composite
        if compound is not None:
            self._values["compound"] = compound
        if contrast is not None:
            self._values["contrast"] = contrast
        if goop is not None:
            self._values["goop"] = goop
        if grayscale is not None:
            self._values["grayscale"] = grayscale
        if hsl is not None:
            self._values["hsl"] = hsl
        if hsv is not None:
            self._values["hsv"] = hsv
        if if_dimension is not None:
            self._values["if_dimension"] = if_dimension
        if if_orientation is not None:
            self._values["if_orientation"] = if_orientation
        if max_colors is not None:
            self._values["max_colors"] = max_colors
        if mirror is not None:
            self._values["mirror"] = mirror
        if mono_hue is not None:
            self._values["mono_hue"] = mono_hue
        if opacity is not None:
            self._values["opacity"] = opacity
        if remove_color is not None:
            self._values["remove_color"] = remove_color
        if unsharp_mask is not None:
            self._values["unsharp_mask"] = unsharp_mask

    @builtins.property
    def background_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultBackgroundColor"]]]:
        '''background_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        '''
        result = self._values.get("background_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultBackgroundColor"]]], result)

    @builtins.property
    def blur(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultBlur"]]]:
        '''blur block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        '''
        result = self._values.get("blur")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultBlur"]]], result)

    @builtins.property
    def chroma_key(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultChromaKey"]]]:
        '''chroma_key block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        '''
        result = self._values.get("chroma_key")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultChromaKey"]]], result)

    @builtins.property
    def composite(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultComposite"]]]:
        '''composite block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        '''
        result = self._values.get("composite")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultComposite"]]], result)

    @builtins.property
    def compound(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultCompound"]]]:
        '''compound block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        '''
        result = self._values.get("compound")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultCompound"]]], result)

    @builtins.property
    def contrast(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultContrast"]]]:
        '''contrast block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultContrast"]]], result)

    @builtins.property
    def goop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultGoop"]]]:
        '''goop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        '''
        result = self._values.get("goop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultGoop"]]], result)

    @builtins.property
    def grayscale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultGrayscale"]]]:
        '''grayscale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        '''
        result = self._values.get("grayscale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultGrayscale"]]], result)

    @builtins.property
    def hsl(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultHsl"]]]:
        '''hsl block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        '''
        result = self._values.get("hsl")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultHsl"]]], result)

    @builtins.property
    def hsv(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultHsv"]]]:
        '''hsv block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        '''
        result = self._values.get("hsv")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultHsv"]]], result)

    @builtins.property
    def if_dimension(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfDimension"]]]:
        '''if_dimension block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        '''
        result = self._values.get("if_dimension")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfDimension"]]], result)

    @builtins.property
    def if_orientation(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientation"]]]:
        '''if_orientation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        '''
        result = self._values.get("if_orientation")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientation"]]], result)

    @builtins.property
    def max_colors(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultMaxColors"]]]:
        '''max_colors block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        '''
        result = self._values.get("max_colors")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultMaxColors"]]], result)

    @builtins.property
    def mirror(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultMirror"]]]:
        '''mirror block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        '''
        result = self._values.get("mirror")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultMirror"]]], result)

    @builtins.property
    def mono_hue(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultMonoHue"]]]:
        '''mono_hue block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        '''
        result = self._values.get("mono_hue")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultMonoHue"]]], result)

    @builtins.property
    def opacity(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultOpacity"]]]:
        '''opacity block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultOpacity"]]], result)

    @builtins.property
    def remove_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultRemoveColor"]]]:
        '''remove_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        '''
        result = self._values.get("remove_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultRemoveColor"]]], result)

    @builtins.property
    def unsharp_mask(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultUnsharpMask"]]]:
        '''unsharp_mask block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        result = self._values.get("unsharp_mask")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultUnsharpMask"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultBackgroundColor",
    jsii_struct_bases=[],
    name_mapping={"color": "color", "color_var": "colorVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultBackgroundColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__08696d04d22eca33355e217e31a972aa31388b0377ac133fed3f3e47ec672e40)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultBackgroundColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultBackgroundColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultBackgroundColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__398053a14efc86d48d1129c41ec008503bb3f05132f89ea4eecdaef92e16f3fa)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultBackgroundColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d0b4caa1f8a47b33d16d03b280bc1e2537ae050c9c94f4d2a6171fe5761fcde8)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultBackgroundColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a11ac3e6137f059e33078ef6bd717dbcb9f7c571a840b91aea46f1bd85932611)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__36c2091e7e0b0c85bb7580950b209afc45c0e4438223b933adacb752355ad05a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__74c07ae5413a425f2d04ff689f87af4b6cd9e1007b0ca0712f53053a7193551b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultBackgroundColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultBackgroundColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__59a170ffc70234b88cd679d4ce01c3905abfa0f0c204011039bbd591cb971f67)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultBackgroundColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultBackgroundColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__010a6d198409cbbae615b0bdb983b2ccbe181d76b4aed75a1b3287b6ba778bf7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__81b99bb774dc40e88cd64a64a20d5ded192aa8de5df6159ddc21ff4cc4416fd2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d96aad21dc9fee0b3ea08c63318491ad27bbee07bc1fe4b0e7dd5e344d61f655)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultBackgroundColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultBackgroundColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultBackgroundColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__85b3b7b0117fbfa31c9acac059cfcc9881f9e64e6e78fc1c8962c87f538667f1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultBlur",
    jsii_struct_bases=[],
    name_mapping={"sigma": "sigma", "sigma_var": "sigmaVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultBlur:
    def __init__(
        self,
        *,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param sigma: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1b41ddb0c68299935bc57058608cbe3c9216cdce34f2df78a944e2f420664a01)
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultBlur(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultBlurList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultBlurList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f63c558dafb50421debfc756e945cfeb1163320698966854a04c5a77bfcafe40)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultBlurOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__52b73d771e79b923f84984fd8579b295293c8970151769ad52a3dcaaab33c16d)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultBlurOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__079fa73a5be2498bf7d7c7693d49227d3cb99cabba9d64590506185db6175300)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b12e6c11313da3674b1e0e6cb3d6c653d55be71ca1ef10693b74dd45bd10c5ed)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a56642202ce4204c15e92ecdb94bb603a223e93366b8a524a1a1f2cb05710232)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultBlur]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultBlur]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__823117d6162bd53503ff434723e2b1b3fc0e79fc2f5e10614d06998f62b1f36a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultBlurOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultBlurOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4c60548c06d2e33ab7e570f6fcd0974d471bbd751a458a8b4c58d909bf1e5511)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__558252b4307da4b5338cb375f561e560a6ca830291442d82e1c5bcb964c7bca9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5812cd03d94cc562bc568b93a058319ff31c18a00b3f22596b0fab4a82e14cad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultBlur]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultBlur]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultBlur]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa7fb55decee0a04bd9e66a44240665da9aa5706e40fc24872c57409ad94d9bd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultChromaKey",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_feather": "hueFeather",
        "hue_feather_var": "hueFeatherVar",
        "hue_tolerance": "hueTolerance",
        "hue_tolerance_var": "hueToleranceVar",
        "hue_var": "hueVar",
        "lightness_feather": "lightnessFeather",
        "lightness_feather_var": "lightnessFeatherVar",
        "lightness_tolerance": "lightnessTolerance",
        "lightness_tolerance_var": "lightnessToleranceVar",
        "saturation_feather": "saturationFeather",
        "saturation_feather_var": "saturationFeatherVar",
        "saturation_tolerance": "saturationTolerance",
        "saturation_tolerance_var": "saturationToleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultChromaKey:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_feather: typing.Optional[builtins.str] = None,
        hue_feather_var: typing.Optional[builtins.str] = None,
        hue_tolerance: typing.Optional[builtins.str] = None,
        hue_tolerance_var: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness_feather: typing.Optional[builtins.str] = None,
        lightness_feather_var: typing.Optional[builtins.str] = None,
        lightness_tolerance: typing.Optional[builtins.str] = None,
        lightness_tolerance_var: typing.Optional[builtins.str] = None,
        saturation_feather: typing.Optional[builtins.str] = None,
        saturation_feather_var: typing.Optional[builtins.str] = None,
        saturation_tolerance: typing.Optional[builtins.str] = None,
        saturation_tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_feather: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        :param hue_feather_var: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        :param hue_tolerance: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        :param hue_tolerance_var: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        :param hue_var: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness_feather: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        :param lightness_feather_var: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        :param lightness_tolerance: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        :param lightness_tolerance_var: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        :param saturation_feather: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        :param saturation_feather_var: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        :param saturation_tolerance: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        :param saturation_tolerance_var: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__de257ffeeaf57606f3f21491e10be526628720e36f5bfcd41c843ec785e95bcb)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_feather", value=hue_feather, expected_type=type_hints["hue_feather"])
            check_type(argname="argument hue_feather_var", value=hue_feather_var, expected_type=type_hints["hue_feather_var"])
            check_type(argname="argument hue_tolerance", value=hue_tolerance, expected_type=type_hints["hue_tolerance"])
            check_type(argname="argument hue_tolerance_var", value=hue_tolerance_var, expected_type=type_hints["hue_tolerance_var"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness_feather", value=lightness_feather, expected_type=type_hints["lightness_feather"])
            check_type(argname="argument lightness_feather_var", value=lightness_feather_var, expected_type=type_hints["lightness_feather_var"])
            check_type(argname="argument lightness_tolerance", value=lightness_tolerance, expected_type=type_hints["lightness_tolerance"])
            check_type(argname="argument lightness_tolerance_var", value=lightness_tolerance_var, expected_type=type_hints["lightness_tolerance_var"])
            check_type(argname="argument saturation_feather", value=saturation_feather, expected_type=type_hints["saturation_feather"])
            check_type(argname="argument saturation_feather_var", value=saturation_feather_var, expected_type=type_hints["saturation_feather_var"])
            check_type(argname="argument saturation_tolerance", value=saturation_tolerance, expected_type=type_hints["saturation_tolerance"])
            check_type(argname="argument saturation_tolerance_var", value=saturation_tolerance_var, expected_type=type_hints["saturation_tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_feather is not None:
            self._values["hue_feather"] = hue_feather
        if hue_feather_var is not None:
            self._values["hue_feather_var"] = hue_feather_var
        if hue_tolerance is not None:
            self._values["hue_tolerance"] = hue_tolerance
        if hue_tolerance_var is not None:
            self._values["hue_tolerance_var"] = hue_tolerance_var
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness_feather is not None:
            self._values["lightness_feather"] = lightness_feather
        if lightness_feather_var is not None:
            self._values["lightness_feather_var"] = lightness_feather_var
        if lightness_tolerance is not None:
            self._values["lightness_tolerance"] = lightness_tolerance
        if lightness_tolerance_var is not None:
            self._values["lightness_tolerance_var"] = lightness_tolerance_var
        if saturation_feather is not None:
            self._values["saturation_feather"] = saturation_feather
        if saturation_feather_var is not None:
            self._values["saturation_feather_var"] = saturation_feather_var
        if saturation_tolerance is not None:
            self._values["saturation_tolerance"] = saturation_tolerance
        if saturation_tolerance_var is not None:
            self._values["saturation_tolerance_var"] = saturation_tolerance_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        '''
        result = self._values.get("hue_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        '''
        result = self._values.get("hue_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        '''
        result = self._values.get("hue_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        '''
        result = self._values.get("hue_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        '''
        result = self._values.get("lightness_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        '''
        result = self._values.get("lightness_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        '''
        result = self._values.get("lightness_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        '''
        result = self._values.get("lightness_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        '''
        result = self._values.get("saturation_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        '''
        result = self._values.get("saturation_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        '''
        result = self._values.get("saturation_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        result = self._values.get("saturation_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultChromaKey(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultChromaKeyList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultChromaKeyList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b44bfaeef4344175392d28f94a5daa28ae1c75cde57939a5d2c4fa883f6e746e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultChromaKeyOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__768c303a4c680ab4247a0118f318e37e0196f1d13c1fc9295526d70f923f5034)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultChromaKeyOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af91394ff8d8dcf7b8ec9edee978a55889c149d51c759aa969a056a02df5056b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8f42b0aeb3944883d4109ea2cff58bc5d94826b96e38d0cd4c1bf1d90f175896)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__42cea5e7394e26e0409cd3d8de6e9f6e2c3aa1927b90bf6a197ee444ea255d17)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultChromaKey]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultChromaKey]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4304d091ea826cddf33ec6840f206a073991a827ebee72117e5cb98c97ef0ed5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultChromaKeyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultChromaKeyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__54713e73398d59cef1e9fc07ce97e43ce7ba0b614bbe023fd5b9f6de27587770)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueFeather")
    def reset_hue_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeather", []))

    @jsii.member(jsii_name="resetHueFeatherVar")
    def reset_hue_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeatherVar", []))

    @jsii.member(jsii_name="resetHueTolerance")
    def reset_hue_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueTolerance", []))

    @jsii.member(jsii_name="resetHueToleranceVar")
    def reset_hue_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueToleranceVar", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightnessFeather")
    def reset_lightness_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeather", []))

    @jsii.member(jsii_name="resetLightnessFeatherVar")
    def reset_lightness_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeatherVar", []))

    @jsii.member(jsii_name="resetLightnessTolerance")
    def reset_lightness_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessTolerance", []))

    @jsii.member(jsii_name="resetLightnessToleranceVar")
    def reset_lightness_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessToleranceVar", []))

    @jsii.member(jsii_name="resetSaturationFeather")
    def reset_saturation_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeather", []))

    @jsii.member(jsii_name="resetSaturationFeatherVar")
    def reset_saturation_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeatherVar", []))

    @jsii.member(jsii_name="resetSaturationTolerance")
    def reset_saturation_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationTolerance", []))

    @jsii.member(jsii_name="resetSaturationToleranceVar")
    def reset_saturation_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherInput")
    def hue_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVarInput")
    def hue_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceInput")
    def hue_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVarInput")
    def hue_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherInput")
    def lightness_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVarInput")
    def lightness_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceInput")
    def lightness_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVarInput")
    def lightness_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherInput")
    def saturation_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVarInput")
    def saturation_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceInput")
    def saturation_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVarInput")
    def saturation_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__826636004f8147459975ea48498e7d3cb926e23c88b5e20d27779bd442ce590e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeather")
    def hue_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeather"))

    @hue_feather.setter
    def hue_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df68cb8c557a09a7d7401e7e997f5c81f9f0bb9ecaa36a9830968edc9273238c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeather", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVar")
    def hue_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeatherVar"))

    @hue_feather_var.setter
    def hue_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__676a5d1c6163bb63dc44ac8713ca6db6736800de5e3e2f2cdb8cf5b948a4d84c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueTolerance")
    def hue_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueTolerance"))

    @hue_tolerance.setter
    def hue_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5d756123206f5bae3bb87838d29d9f9d47593e233066f9af24acfecbdf9ab179)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVar")
    def hue_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueToleranceVar"))

    @hue_tolerance_var.setter
    def hue_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a783afc8eba85516d4b702ef817196723bef157436dab2d9bc9891df4e0940ea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6207016802647f0390ccfbf3cf9c0be52caa335225d73df71490819bd41cf022)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeather")
    def lightness_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeather"))

    @lightness_feather.setter
    def lightness_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__da5bc1888b60cbb738906d0f86e22c874ec60a44a1a6f00efd0b882737c5864d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeather", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVar")
    def lightness_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeatherVar"))

    @lightness_feather_var.setter
    def lightness_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f7e4f272de110e92cbd26dccfc508b980f4da4e3f0ceb6e3b742daacd0ea7b50)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessTolerance")
    def lightness_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessTolerance"))

    @lightness_tolerance.setter
    def lightness_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d2b8eb04574aa8ac4896eb9b261d3f66bb1e0ed34adaa1d232c9cd61e6f58a65)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVar")
    def lightness_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessToleranceVar"))

    @lightness_tolerance_var.setter
    def lightness_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb3854155ca44b292e8e7ce155459b459bd964e64aa43595b7bfbb52990c83c8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeather")
    def saturation_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeather"))

    @saturation_feather.setter
    def saturation_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__247663dd4ba5b0b3c5a9b2e768e6923d5210a631037a5a0237e1a2dd9783ba05)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeather", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVar")
    def saturation_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeatherVar"))

    @saturation_feather_var.setter
    def saturation_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__674c25244fafd3b2c9216183c03c76d8bc3fd065f8214a4c5613e228e5e6442b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationTolerance")
    def saturation_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationTolerance"))

    @saturation_tolerance.setter
    def saturation_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5d269251018815e838a88cc6b15d272e41e964899ef855964739d7fcf36c9e2a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVar")
    def saturation_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationToleranceVar"))

    @saturation_tolerance_var.setter
    def saturation_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0cc5d747e03b80e18945de44558f33c3d228f7ea78e9e613521b5e1d4759edba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultChromaKey]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultChromaKey]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultChromaKey]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8e68afca742002fc8f39dd660577729547310dfcf1b2bd8c683cd51f38e4f963)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultComposite",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "placement": "placement",
        "placement_var": "placementVar",
        "scale": "scale",
        "scale_dimension": "scaleDimension",
        "scale_dimension_var": "scaleDimensionVar",
        "scale_var": "scaleVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultComposite:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultCompositeImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        placement: typing.Optional[builtins.str] = None,
        placement_var: typing.Optional[builtins.str] = None,
        scale: typing.Optional[builtins.str] = None,
        scale_dimension: typing.Optional[builtins.str] = None,
        scale_dimension_var: typing.Optional[builtins.str] = None,
        scale_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param placement: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        :param placement_var: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        :param scale: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param scale_dimension: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        :param scale_dimension_var: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        :param scale_var: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        :param x_position: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultCompositeImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a2d44d30733de02308f449300e1077b1da45411b268d7ea4489bf09c5bd05119)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument placement", value=placement, expected_type=type_hints["placement"])
            check_type(argname="argument placement_var", value=placement_var, expected_type=type_hints["placement_var"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument scale_dimension", value=scale_dimension, expected_type=type_hints["scale_dimension"])
            check_type(argname="argument scale_dimension_var", value=scale_dimension_var, expected_type=type_hints["scale_dimension_var"])
            check_type(argname="argument scale_var", value=scale_var, expected_type=type_hints["scale_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if placement is not None:
            self._values["placement"] = placement
        if placement_var is not None:
            self._values["placement_var"] = placement_var
        if scale is not None:
            self._values["scale"] = scale
        if scale_dimension is not None:
            self._values["scale_dimension"] = scale_dimension
        if scale_dimension_var is not None:
            self._values["scale_dimension_var"] = scale_dimension_var
        if scale_var is not None:
            self._values["scale_var"] = scale_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultCompositeImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultCompositeImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        '''
        result = self._values.get("placement")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement_var(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        '''
        result = self._values.get("placement_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        '''
        result = self._values.get("scale_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        '''
        result = self._values.get("scale_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        '''
        result = self._values.get("scale_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultComposite(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultCompositeImage",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultCompositeImage:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultCompositeImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultCompositeImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultCompositeImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e21302339ec6dc78ce92a4128d4e93f69879a7aeae3e9dbf6ff71237de98dade)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultCompositeImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultCompositeImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8d9e532d145122e63aa6a8ba24d288cc821fd1201290a578d7f33421ce3aab44)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultCompositeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultCompositeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9bff6c5ba6fa9a829432f0baabecfe0d1c7e20c2c92f18bb2107544c2e526d52)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultCompositeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1292afee15406323f8287bd696ed6c6b8a262c111fac39062ce74216ccbda5f0)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultCompositeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2efb7966f36f7b83220521194a874c0943b8ff17584530fc3c030f924814be30)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__64086d76ea24272ae765bc121779fd817633922ba9e6ba7b18eb52b164bb3ea1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c9d3c3c453bdb88b5d790cb70def8ae37b4313f6377d1c17b0ce49c33ea93e6c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultComposite]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultComposite]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e202a46bcf786abfb495a8c8a1a56a8e894bd11af1e33fd9d1b326d3c10ff387)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultCompositeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultCompositeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ce298239cf02e69d37da9895af5761219c7d2448bb13c88edbc0af7c84450c25)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultCompositeImage()

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPlacement")
    def reset_placement(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacement", []))

    @jsii.member(jsii_name="resetPlacementVar")
    def reset_placement_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacementVar", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetScaleDimension")
    def reset_scale_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimension", []))

    @jsii.member(jsii_name="resetScaleDimensionVar")
    def reset_scale_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimensionVar", []))

    @jsii.member(jsii_name="resetScaleVar")
    def reset_scale_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultCompositeImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultCompositeImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultCompositeImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="placementInput")
    def placement_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementInput"))

    @builtins.property
    @jsii.member(jsii_name="placementVarInput")
    def placement_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionInput")
    def scale_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVarInput")
    def scale_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleVarInput")
    def scale_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__300bf0054ea9b8b2d6bb6a2b99377216e7fff7638983265d246dedcd85507fe1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7edf577bcd67f710d1c93822902a34a6f4df9d6e9ddbc8729c4ce9a523c0a7d9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="placement")
    def placement(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placement"))

    @placement.setter
    def placement(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2cc1e0a2e9f5c49d3024be1a3080ff7df2c64651ec137d5dabcbe3240d7990d4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placement", value)

    @builtins.property
    @jsii.member(jsii_name="placementVar")
    def placement_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placementVar"))

    @placement_var.setter
    def placement_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__21e3d09013448b80b450c24e190869b353c88469613b24c13de54c8da38d0b04)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placementVar", value)

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scale"))

    @scale.setter
    def scale(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7e1ccf272828ba3c02695e976962155b839295946f3604033818ef09ed6555c7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scale", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimension")
    def scale_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimension"))

    @scale_dimension.setter
    def scale_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__449b849e1f0cfe36ddd55bd63630dfe953beef2fa134368d4b5b675b6b7bb9bb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimension", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVar")
    def scale_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimensionVar"))

    @scale_dimension_var.setter
    def scale_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__13774bb7a5887b5794d06255c8251029dc9e851e1513ac0954322d593897bcc1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="scaleVar")
    def scale_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleVar"))

    @scale_var.setter
    def scale_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1c7b5e07e1ea9eaa2368478a87c0638a5e28bfb5839b11e07199ae9c82acc0ef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__51053d73993be4ed0e06fd8e6b3e0d770b0d9cb14a93824c9172feb7ef0184e1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5eb99eca80d528772e91dfaf02aa0fbf41c5a07c80fac0b3b39f4e757acdbf01)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__153fc93a1fc1932c7b43993457cccbfe65247cd6ef129b9fbcb07dae7e0980d5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8e204be6f8db35ca2bdf98e9ace95bbd0e8ee58e500fbb85365a40a6e2a05b4e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultComposite]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultComposite]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultComposite]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__87a4d20eaac0e480aedeb17200afbdfeb72b94aa351cf2f711f6ecb3f1b4567e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultCompound",
    jsii_struct_bases=[],
    name_mapping={"transformations": "transformations"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultCompound:
    def __init__(
        self,
        *,
        transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param transformations: transformations block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__da2fbf7eb3c5968692c70bf0b627a8fb49f8ddbe88d9082b1c3ddf7730ad1732)
            check_type(argname="argument transformations", value=transformations, expected_type=type_hints["transformations"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if transformations is not None:
            self._values["transformations"] = transformations

    @builtins.property
    def transformations(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultCompoundTransformations"]]]:
        '''transformations block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        result = self._values.get("transformations")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultCompoundTransformations"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultCompound(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultCompoundList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultCompoundList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e5d9343c76ec076bc92a6ce7006a67136331a73d56e4e7be909f43545b4a93e9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultCompoundOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__83a015e5bb083387e798313d117b9aa0376aeb3dffa5ade2a53d6c25f38a444b)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultCompoundOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__10175bf3a1e509ef637efa7c3ed8dc6452f3289b2db4a2b783ce97ad4f529a99)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3957f464cda06b843d1bfbfd317b3734f8ae31c10d3b3220d5b10e089d08bb83)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__73fe40e9a1229563c1364c67b4428b396fc04183ccc9f8655ee0e9737e594388)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultCompound]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultCompound]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e2a606ff06e63732eab7464a07e300e5fac11f7cfcac8472955791c8d613eaed)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultCompoundOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultCompoundOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__98534b10e3ee958360edf03361f378bd43cf330a92e632fd0aa1a0850af3a74a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformations")
    def put_transformations(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2c577c00e77159e5255bf258fa12239c960127d25d229678773f818c506b3563)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTransformations", [value]))

    @jsii.member(jsii_name="resetTransformations")
    def reset_transformations(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformations", []))

    @builtins.property
    @jsii.member(jsii_name="transformations")
    def transformations(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultCompoundTransformationsList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultCompoundTransformationsList", jsii.get(self, "transformations"))

    @builtins.property
    @jsii.member(jsii_name="transformationsInput")
    def transformations_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultCompoundTransformations"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultCompoundTransformations"]]], jsii.get(self, "transformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultCompound]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultCompound]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultCompound]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cf94d7d799539671cda4003f36cce55e4e1ec9e73e4583f6e7952435ccb526bd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultCompoundTransformations",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultCompoundTransformations:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultCompoundTransformations(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultCompoundTransformationsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultCompoundTransformationsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1c9aa5bd4a0f0a1c896e2f14a4d6b6e3635eb9e8e1122ea3ed7d8abf23ec325d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultCompoundTransformationsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ffa2bc4fdeba0ee7bfa9b9c6de29a7b90eb91b2cc5a330995cb300befb778b47)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultCompoundTransformationsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7b9f54c8daa0c9bfe920d4b8f83e702429f9a28aee752ae7b0461dafbd774c5b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ce4f19929c08f3b161065436a7a76d7d780303ac337bca2997a0d0e2561f184a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5682b5f9a502c4e7f30f5cee6adddd42fbdaf4eea8ffa48bd46262e24d467cb1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultCompoundTransformations]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultCompoundTransformations]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultCompoundTransformations]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dbcfda22062aa36ecebf80ed13e9feb1a671144962ba94896c4427d789b96896)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultCompoundTransformationsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultCompoundTransformationsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dced925a747ac4bfc8649279a503688ecb8d670de2d1e59785b71c74c9ac6e16)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultCompoundTransformations]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultCompoundTransformations]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultCompoundTransformations]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5440df1655af7ae9b8277c0ea341d42894b75a04464579d8c96a670d2c88e867)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultContrast",
    jsii_struct_bases=[],
    name_mapping={
        "brightness": "brightness",
        "brightness_var": "brightnessVar",
        "contrast": "contrast",
        "contrast_var": "contrastVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultContrast:
    def __init__(
        self,
        *,
        brightness: typing.Optional[builtins.str] = None,
        brightness_var: typing.Optional[builtins.str] = None,
        contrast: typing.Optional[builtins.str] = None,
        contrast_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param brightness: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        :param brightness_var: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        :param contrast: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param contrast_var: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b7c81a5aca30a54b0bf4e2de5a60dce10240d97ac74dfaa2184f896bf6fab3ea)
            check_type(argname="argument brightness", value=brightness, expected_type=type_hints["brightness"])
            check_type(argname="argument brightness_var", value=brightness_var, expected_type=type_hints["brightness_var"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument contrast_var", value=contrast_var, expected_type=type_hints["contrast_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if brightness is not None:
            self._values["brightness"] = brightness
        if brightness_var is not None:
            self._values["brightness_var"] = brightness_var
        if contrast is not None:
            self._values["contrast"] = contrast
        if contrast_var is not None:
            self._values["contrast_var"] = contrast_var

    @builtins.property
    def brightness(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        '''
        result = self._values.get("brightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def brightness_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        '''
        result = self._values.get("brightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        result = self._values.get("contrast_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultContrast(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultContrastList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultContrastList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__76779bec9900b334ec741f3fb75a5df5213f057f09eee27c22393ee1f616031b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultContrastOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ac79c571a2f0b27b69e2c318729a8b1ea3fbd93a1c9d66811372f43bfa851c7)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultContrastOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5900fe8ae90ac204cc7b18663f5217ed25b4d950a3394cc4966b76820dfc11bd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8053ffaf821a204ba2c0f07fdb690f3a5fb5258d430611d07ac5bc653771b6db)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__08bd35ea12c0fa6be4c6963c17d7d7c77ccc015e498b6a54a474b5e7ddfe0f12)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultContrast]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultContrast]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__524815e37dd0489dc419c3ebdb95238917a34872cd407cf10c014b16350d5a17)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultContrastOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultContrastOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c59130fe6f6fe7e781e2a1b35863cac3666946d09d63144a7b72e47145366209)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetBrightness")
    def reset_brightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightness", []))

    @jsii.member(jsii_name="resetBrightnessVar")
    def reset_brightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightnessVar", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetContrastVar")
    def reset_contrast_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrastVar", []))

    @builtins.property
    @jsii.member(jsii_name="brightnessInput")
    def brightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="brightnessVarInput")
    def brightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastVarInput")
    def contrast_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="brightness")
    def brightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightness"))

    @brightness.setter
    def brightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f8817d70d61a069d11721e1c9efa03360d64bf311211bd7ad4e1d9e4074df96b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightness", value)

    @builtins.property
    @jsii.member(jsii_name="brightnessVar")
    def brightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightnessVar"))

    @brightness_var.setter
    def brightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be0af9225b474c86cd6843f9f5552d6d39f2136c2042fa8fde872c3f450525bf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrast"))

    @contrast.setter
    def contrast(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__54b80349925ab0539ef4e9b9d2e3d89f5d2967c2b590dfde5cd2d2c94847b32c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrast", value)

    @builtins.property
    @jsii.member(jsii_name="contrastVar")
    def contrast_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrastVar"))

    @contrast_var.setter
    def contrast_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5bc7aea0fe079a22075fd301640349f83f54f55097b7cfe5f78a4d30ba9651f4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrastVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultContrast]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultContrast]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultContrast]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fc626f3ada530a63068e7cc2c63e8f7e2e556ff3eefd4f41f6cf1d3a2765a611)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultGoop",
    jsii_struct_bases=[],
    name_mapping={
        "chaos": "chaos",
        "chaos_var": "chaosVar",
        "density": "density",
        "density_var": "densityVar",
        "power": "power",
        "power_var": "powerVar",
        "seed": "seed",
        "seed_var": "seedVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultGoop:
    def __init__(
        self,
        *,
        chaos: typing.Optional[builtins.str] = None,
        chaos_var: typing.Optional[builtins.str] = None,
        density: typing.Optional[builtins.str] = None,
        density_var: typing.Optional[builtins.str] = None,
        power: typing.Optional[builtins.str] = None,
        power_var: typing.Optional[builtins.str] = None,
        seed: typing.Optional[builtins.str] = None,
        seed_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param chaos: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        :param chaos_var: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        :param density: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        :param density_var: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        :param power: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        :param power_var: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        :param seed: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        :param seed_var: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__076ca5b2c84c75451151c6b9f4ff791ef87e09342a45bd19393d5bd19258363f)
            check_type(argname="argument chaos", value=chaos, expected_type=type_hints["chaos"])
            check_type(argname="argument chaos_var", value=chaos_var, expected_type=type_hints["chaos_var"])
            check_type(argname="argument density", value=density, expected_type=type_hints["density"])
            check_type(argname="argument density_var", value=density_var, expected_type=type_hints["density_var"])
            check_type(argname="argument power", value=power, expected_type=type_hints["power"])
            check_type(argname="argument power_var", value=power_var, expected_type=type_hints["power_var"])
            check_type(argname="argument seed", value=seed, expected_type=type_hints["seed"])
            check_type(argname="argument seed_var", value=seed_var, expected_type=type_hints["seed_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if chaos is not None:
            self._values["chaos"] = chaos
        if chaos_var is not None:
            self._values["chaos_var"] = chaos_var
        if density is not None:
            self._values["density"] = density
        if density_var is not None:
            self._values["density_var"] = density_var
        if power is not None:
            self._values["power"] = power
        if power_var is not None:
            self._values["power_var"] = power_var
        if seed is not None:
            self._values["seed"] = seed
        if seed_var is not None:
            self._values["seed_var"] = seed_var

    @builtins.property
    def chaos(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        '''
        result = self._values.get("chaos")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def chaos_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        '''
        result = self._values.get("chaos_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        '''
        result = self._values.get("density")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density_var(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        '''
        result = self._values.get("density_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        '''
        result = self._values.get("power")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power_var(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        '''
        result = self._values.get("power_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        '''
        result = self._values.get("seed")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed_var(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        result = self._values.get("seed_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultGoop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultGoopList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultGoopList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2b480be0ca0ab954d0a08cf3a34ec45126f5b48dd58d1375b8e44206ea63b7bf)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultGoopOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b7c93e464bc0bba6c9ef69ac4e7e291451bff25288c1135a619a8cbedafe4481)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultGoopOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e8f7453d0138e995be258277365cdf3adad059dd81e6cfa64e00e82a8d0cdecc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3993c6d93170da25a1fca1ae4ec478b0f5a2933f083239bc47cdf06c03972c14)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__50a78a8da71109e7c621f25f3945d248b0817df4ec53f0e7890484e663946d82)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultGoop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultGoop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__35bc067fe1efab55dc75a0e8ee2cfd4d2a26ef879b39e13b0c7bfd9e6ced1e9f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultGoopOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultGoopOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f17f934095593c9cbfc8651bf480d6e3c049880cdf5373e514101db89120834a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetChaos")
    def reset_chaos(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaos", []))

    @jsii.member(jsii_name="resetChaosVar")
    def reset_chaos_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaosVar", []))

    @jsii.member(jsii_name="resetDensity")
    def reset_density(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensity", []))

    @jsii.member(jsii_name="resetDensityVar")
    def reset_density_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensityVar", []))

    @jsii.member(jsii_name="resetPower")
    def reset_power(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPower", []))

    @jsii.member(jsii_name="resetPowerVar")
    def reset_power_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPowerVar", []))

    @jsii.member(jsii_name="resetSeed")
    def reset_seed(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeed", []))

    @jsii.member(jsii_name="resetSeedVar")
    def reset_seed_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeedVar", []))

    @builtins.property
    @jsii.member(jsii_name="chaosInput")
    def chaos_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosInput"))

    @builtins.property
    @jsii.member(jsii_name="chaosVarInput")
    def chaos_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosVarInput"))

    @builtins.property
    @jsii.member(jsii_name="densityInput")
    def density_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityInput"))

    @builtins.property
    @jsii.member(jsii_name="densityVarInput")
    def density_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="powerInput")
    def power_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerInput"))

    @builtins.property
    @jsii.member(jsii_name="powerVarInput")
    def power_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerVarInput"))

    @builtins.property
    @jsii.member(jsii_name="seedInput")
    def seed_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedInput"))

    @builtins.property
    @jsii.member(jsii_name="seedVarInput")
    def seed_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedVarInput"))

    @builtins.property
    @jsii.member(jsii_name="chaos")
    def chaos(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaos"))

    @chaos.setter
    def chaos(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__286d31a59770b800a76d08128473f5c6f2a01943e1b5ef324c419a170496f63d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaos", value)

    @builtins.property
    @jsii.member(jsii_name="chaosVar")
    def chaos_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaosVar"))

    @chaos_var.setter
    def chaos_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__392ad648f8082f4b769ecf541d33ebfae7c2f3255af6f80ab14af1dc54947c2d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaosVar", value)

    @builtins.property
    @jsii.member(jsii_name="density")
    def density(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "density"))

    @density.setter
    def density(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__99a8d50e1068806576d1c6e55e5a9b6a179624442b7532a3ff22b55814f8cc9e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "density", value)

    @builtins.property
    @jsii.member(jsii_name="densityVar")
    def density_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "densityVar"))

    @density_var.setter
    def density_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d65cfa0583a4578cea8dfbe625c256759f504c9c19f5279be593a5023849c6a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "densityVar", value)

    @builtins.property
    @jsii.member(jsii_name="power")
    def power(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "power"))

    @power.setter
    def power(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__17b3851bdc8e0d0283c0a6d1971d1098a0a5050cb93fb6f35b6476e5400672d6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "power", value)

    @builtins.property
    @jsii.member(jsii_name="powerVar")
    def power_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "powerVar"))

    @power_var.setter
    def power_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3bf2ef55584c217f0d1c8626e3258279f96ef35aef445c5ffab556a935af5692)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "powerVar", value)

    @builtins.property
    @jsii.member(jsii_name="seed")
    def seed(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seed"))

    @seed.setter
    def seed(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8789e93ca0358592eddeebb3868d76da255967d32bd98b95d6cc8be13a3c4067)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seed", value)

    @builtins.property
    @jsii.member(jsii_name="seedVar")
    def seed_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seedVar"))

    @seed_var.setter
    def seed_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__135d7b71da627a4718d947894adb688b902f183f93e492ce46b36528eee7c6a6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seedVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultGoop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultGoop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultGoop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fc2db1d239ac8ce1aeaa19fdd78a8467ad0354d83f11232876bb2c18ae59611e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultGrayscale",
    jsii_struct_bases=[],
    name_mapping={"type": "type", "type_var": "typeVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultGrayscale:
    def __init__(
        self,
        *,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param type: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c99aade156790f51984356cc9ab20b2cf99a7b6ab025ddc8b3deaa91f7c8bdea)
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultGrayscale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultGrayscaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultGrayscaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5a51fc497534f3f464f009acd52fd5523245682c9a6182f3239b156c2265b566)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultGrayscaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d744021c8d9b000b5209784163b3c0de29d4e900ccd4a53e5ba05e5041df8316)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultGrayscaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__21f207e5eb2fe39d07a373ff2d86e28a0fddd5dd416b556dabd4425e223fca9b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__84a78c3cbe736fb4ee530f84edcf8d60c1a4b580b12ee663db164d1a099a82c9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9793f20b22e2c72d89a30ce70a5e0957fc21773b11a2746e9a3a8de8543f1abb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultGrayscale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultGrayscale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__73df18598643c41075f15c3625c6d9ce6702c3bee0257fc0666ede49e28d9339)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultGrayscaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultGrayscaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3d8ff9250ceaab2e18685713ca164ac67468aebd7994b4c11c5e5d933fc25035)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b9eedded43536917cec732fe082d5112deb80f8854c5bb28f6764c4390dd36cc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc5e3716fd39f9cb4e9ee44c4b1c762379b0c022354cde1a98c7ce41a273ace7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultGrayscale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultGrayscale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultGrayscale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__190ef417e3e7b5cc69b5a35737ad708c0b0430b3409b9f760078590bf7794d02)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultHsl",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "lightness": "lightness",
        "lightness_var": "lightnessVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultHsl:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness: typing.Optional[builtins.str] = None,
        lightness_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        :param lightness_var: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3723eb95d67cd3312207c84fb72e9769aa1d01fa4b116a5c6facdb1d2ae8e77a)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness", value=lightness, expected_type=type_hints["lightness"])
            check_type(argname="argument lightness_var", value=lightness_var, expected_type=type_hints["lightness_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness is not None:
            self._values["lightness"] = lightness
        if lightness_var is not None:
            self._values["lightness_var"] = lightness_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        '''
        result = self._values.get("lightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        '''
        result = self._values.get("lightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultHsl(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultHslList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultHslList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ed05823619fcfe3cc7c6ccd187eb0b32308368f935a11c88ede7018381eec7f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultHslOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa6527dbfec96a0ea19ef34472e474dceade54eba2ce2d33c6371a75b39c6c92)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultHslOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e9dcd72e994d712c4f74012484c5837f3da32f32ea95d87b22563145ba55ccc3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c1a3a518de9ea94fb694e10b106c5bc22b05de30364df9ab9e0efc449a43b4c9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9536dabe29639e9eadfcf30ede53b028e4926cb49321976647d9f2d7db45f0dc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultHsl]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultHsl]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ca2abf120b546e615f6c5df70bb3d9cfdb23b93ee83c272287c3fc76e25686e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultHslOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultHslOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__35bd1ecbd59097b5af9e9192db4f7fda21fec0b437b07231efa1d51fd5298c3b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightness")
    def reset_lightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightness", []))

    @jsii.member(jsii_name="resetLightnessVar")
    def reset_lightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessInput")
    def lightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessVarInput")
    def lightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5b47ac5c8427a327e2b716cd510b9a2eba96f137f38205a3ca9e427c2fd2bf16)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__382a0a64e65f6e895b2d2bf18821a6253158d48657085bb19ee6540f7f7bc64b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightness")
    def lightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightness"))

    @lightness.setter
    def lightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1c297d9072211f761a338bf2cff2da4757e041fb0f782abc6244d7602bed54b4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightness", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessVar")
    def lightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessVar"))

    @lightness_var.setter
    def lightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__91e19a6472bb377f9899c6e8ec488fe1d9d954ae297452902bf53f28f401d763)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b2a34fbeb5dcdf732ad0006e8c0a6b2e7b581b9c076b7df5a2f571ad35b145eb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__27ea5abfa2b32b29993e5fc343e6dedcfbd04c3e097beb17e5feaab50da801f1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultHsl]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultHsl]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultHsl]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b2998f7e46b6a8d5d6791c96c4485e960be91651f0e72ce150d943fcb8534bb1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultHsv",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultHsv:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        :param value: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__08a8000ff8b5bd5f719191aca34eb28b8c472bb5707bad2dbbe524fed07639da)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultHsv(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultHsvList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultHsvList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8d37f1b2a1b7fa8636c4dcc91b8ba739461de7ce0a86b97b5556867e3ffbbc8c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultHsvOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__40c9946b23ff6be8ff52177c4c80bc9159af785370dff959d9e35265a64aea6d)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultHsvOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__99ab3f04206eb38573b80e4d54069e6fc2a6a7fc6d0590732205a3a7ec31cda9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ac4f78d3951c32d4da38110fc7e06f91b3ffbaea3f4da1749af27fd55199bc9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6a03af1b6bc1100f0e772bfa3dcedd1c18e5d8043283eefeadc9911887d9bc2e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultHsv]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultHsv]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eb735c20a39d6b0f30ad5b567c21e3dc6e196e83900e5728ae17f40501bfdd2e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultHsvOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultHsvOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5128200ea14a60d5dff80886503e8ce3f6c16a7daeacad02a537a2a3147dccc6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d090ae7e2b4d9561d69d0306b0b9971b62b373e882a46cf3a9190e85a102ca79)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f1dcdd2bdd26abdc6a79bdfbc03694d5fd5345115693a9af84313e7c90ad7a53)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d819b0201207ec67712ce41d9ed28442fcc93df57350e9701416408cd51f6875)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ce3f46eb8dee7c506f7686d3b763a3556d613bcd34b32f6466a24667cf5b268b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__83b36c5c975f9ec29b2786dd14d42cdc8340e399cfc54dd4e29828a0621dff31)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__603471142ab8de3fecb11c2c2ff827170c622408554863454c3f52e9b1f2aad7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultHsv]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultHsv]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultHsv]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0c5f65fa97617b3082a0471ede35497d60e042fb681b12635cfd1efb0c1e24d4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfDimension",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "dimension": "dimension",
        "dimension_var": "dimensionVar",
        "equal": "equal",
        "greater_than": "greaterThan",
        "less_than": "lessThan",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfDimension:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        dimension: typing.Optional[builtins.str] = None,
        dimension_var: typing.Optional[builtins.str] = None,
        equal: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionEqual", typing.Dict[builtins.str, typing.Any]]] = None,
        greater_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionGreaterThan", typing.Dict[builtins.str, typing.Any]]] = None,
        less_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionLessThan", typing.Dict[builtins.str, typing.Any]]] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param dimension: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        :param dimension_var: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        :param equal: equal block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        :param greater_than: greater_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        :param less_than: less_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        :param value: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionDefault(**default)
        if isinstance(equal, dict):
            equal = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionEqual(**equal)
        if isinstance(greater_than, dict):
            greater_than = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionGreaterThan(**greater_than)
        if isinstance(less_than, dict):
            less_than = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionLessThan(**less_than)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__94be4d4e5777b120407d7542d6b6747751d0069aa4c5785a0393798d971e4ad9)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument dimension", value=dimension, expected_type=type_hints["dimension"])
            check_type(argname="argument dimension_var", value=dimension_var, expected_type=type_hints["dimension_var"])
            check_type(argname="argument equal", value=equal, expected_type=type_hints["equal"])
            check_type(argname="argument greater_than", value=greater_than, expected_type=type_hints["greater_than"])
            check_type(argname="argument less_than", value=less_than, expected_type=type_hints["less_than"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if dimension is not None:
            self._values["dimension"] = dimension
        if dimension_var is not None:
            self._values["dimension_var"] = dimension_var
        if equal is not None:
            self._values["equal"] = equal
        if greater_than is not None:
            self._values["greater_than"] = greater_than
        if less_than is not None:
            self._values["less_than"] = less_than
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionDefault"], result)

    @builtins.property
    def dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        '''
        result = self._values.get("dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        '''
        result = self._values.get("dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def equal(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionEqual"]:
        '''equal block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        '''
        result = self._values.get("equal")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionEqual"], result)

    @builtins.property
    def greater_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionGreaterThan"]:
        '''greater_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        '''
        result = self._values.get("greater_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionGreaterThan"], result)

    @builtins.property
    def less_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionLessThan"]:
        '''less_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        '''
        result = self._values.get("less_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionLessThan"], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfDimension(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c81cbedc14a4d7c81b70ec6501c779c8ba0ee523c708644599e4f9c318b42c52)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6a12859cc648c3ec30bc4f5cf33368305b6ad1a410125cae275640fe5bbcfc9c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionEqual",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionEqual:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionEqual(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionEqualOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionEqualOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6ac786e32176294f76025aacc323b8ab503984e99cc4f22865e13766ec1b8f79)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionEqual], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionEqual],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__909efadb0b4981cc44f08630a0b9c8b9fb187abc478291ff0d312e2cbd30765a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionGreaterThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionGreaterThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionGreaterThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionGreaterThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionGreaterThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__26209a520bf32c83d1950e2b19abc34658dd7d5e1d4c1f0791bc604f62b9b4c2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionGreaterThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionGreaterThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2732878563f31f2d7a9d844183d36c3708f2f0def6c6c7f02d18d6c687bc527f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionLessThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionLessThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionLessThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionLessThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionLessThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e1e0a59454f09b3dc5433f2841512d3f1e4738361b3aacb8be89f33859c519f1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionLessThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionLessThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__58425695af7c55162152dde4628697c9b1ade1b4e0a87587b8205343b667a6b8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e2bb78d6246bbd5ec7e7d5e6b3c0491c41b61e62cedae0f7d6afb6d7b3196747)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2e20ef1d84b3b0b76d9102b259ee50c55dcef48b292f4d10300b3cd482ea2339)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c109eba8dc2175dbf96f28ec1926721420a64af6b60721000ecd3ac65ea94e2c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1211df9e6c5fb509bddf0baedfa5de38f186b8fb6f2f0bcbcf7d66a6296003e2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9fe176aab47d605d74ca9b5829b6d09e323b5b3fee771e4a3c06f3c24fe626cf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfDimension]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfDimension]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__248f4a332772eccc8b4e8945897b3248027f1344ddb944119ba98ad6eb284185)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3c0950c08391b708886edccee4d0b11bcd7ecd8d293ab4c3040599d46968c216)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putEqual")
    def put_equal(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionEqual()

        return typing.cast(None, jsii.invoke(self, "putEqual", [value]))

    @jsii.member(jsii_name="putGreaterThan")
    def put_greater_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionGreaterThan()

        return typing.cast(None, jsii.invoke(self, "putGreaterThan", [value]))

    @jsii.member(jsii_name="putLessThan")
    def put_less_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionLessThan()

        return typing.cast(None, jsii.invoke(self, "putLessThan", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetDimension")
    def reset_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimension", []))

    @jsii.member(jsii_name="resetDimensionVar")
    def reset_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimensionVar", []))

    @jsii.member(jsii_name="resetEqual")
    def reset_equal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEqual", []))

    @jsii.member(jsii_name="resetGreaterThan")
    def reset_greater_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGreaterThan", []))

    @jsii.member(jsii_name="resetLessThan")
    def reset_less_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLessThan", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="equal")
    def equal(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionEqualOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionEqualOutputReference, jsii.get(self, "equal"))

    @builtins.property
    @jsii.member(jsii_name="greaterThan")
    def greater_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionGreaterThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionGreaterThanOutputReference, jsii.get(self, "greaterThan"))

    @builtins.property
    @jsii.member(jsii_name="lessThan")
    def less_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionLessThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionLessThanOutputReference, jsii.get(self, "lessThan"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionInput")
    def dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionVarInput")
    def dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="equalInput")
    def equal_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionEqual], jsii.get(self, "equalInput"))

    @builtins.property
    @jsii.member(jsii_name="greaterThanInput")
    def greater_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionGreaterThan], jsii.get(self, "greaterThanInput"))

    @builtins.property
    @jsii.member(jsii_name="lessThanInput")
    def less_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionLessThan], jsii.get(self, "lessThanInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="dimension")
    def dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimension"))

    @dimension.setter
    def dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4cae3272f50c8c88327a0061c122dd17caf9fce742c31b5da53f7c7b0f4efe90)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimension", value)

    @builtins.property
    @jsii.member(jsii_name="dimensionVar")
    def dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimensionVar"))

    @dimension_var.setter
    def dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b66229f9016b799a61d5f5eabcece6565ecc1ba62020aaac4ae8da41aa4cfd40)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5a2762a93da3ee2f140bfe760c412c20237133c5711e0f6ec00fec236957ffff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__56a2a7e273902a779f02eb1b65c0e0f8b7c3446f5110a07facef20b33061fe22)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfDimension]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfDimension]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfDimension]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__148e1144794aad53d2cd8e68eb36a32b2b2e4b49fcc13107d3c4400054904cd1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientation",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "landscape": "landscape",
        "portrait": "portrait",
        "square": "square",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientation:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        landscape: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationLandscape", typing.Dict[builtins.str, typing.Any]]] = None,
        portrait: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationPortrait", typing.Dict[builtins.str, typing.Any]]] = None,
        square: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationSquare", typing.Dict[builtins.str, typing.Any]]] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param landscape: landscape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        :param portrait: portrait block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        :param square: square block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationDefault(**default)
        if isinstance(landscape, dict):
            landscape = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationLandscape(**landscape)
        if isinstance(portrait, dict):
            portrait = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationPortrait(**portrait)
        if isinstance(square, dict):
            square = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationSquare(**square)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__afd58adc8abe56f96c635f7d46cce4a15cae6091e8b51ec480f6cd00f8efec57)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument landscape", value=landscape, expected_type=type_hints["landscape"])
            check_type(argname="argument portrait", value=portrait, expected_type=type_hints["portrait"])
            check_type(argname="argument square", value=square, expected_type=type_hints["square"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if landscape is not None:
            self._values["landscape"] = landscape
        if portrait is not None:
            self._values["portrait"] = portrait
        if square is not None:
            self._values["square"] = square

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationDefault"], result)

    @builtins.property
    def landscape(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationLandscape"]:
        '''landscape block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        '''
        result = self._values.get("landscape")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationLandscape"], result)

    @builtins.property
    def portrait(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationPortrait"]:
        '''portrait block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        '''
        result = self._values.get("portrait")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationPortrait"], result)

    @builtins.property
    def square(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationSquare"]:
        '''square block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        result = self._values.get("square")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationSquare"], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c3795d0370d3aa288752f3c9949d6d423c17631a5b74dcc1ad37027e0d42cc03)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__728560b521be2d9852e346afd8836c0a4980e76675491a55690c443fb28eb597)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationLandscape",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationLandscape:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationLandscape(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationLandscapeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationLandscapeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0602ead788b427acc46bce11a9c7bbb5bb6e9e3f17591a0d46369f2c5e9ea5f7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationLandscape], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationLandscape],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6bea138ac4aa1893ca2298e699841affd90905446746b4a501a721e9d0945a1e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d2e657eed4ba354d9e663b6237015b933c500818b88297364a08a62bb91f87e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df5fbb6cce09305fda28a984597819ef9121b21620123af57db45f35f26368f9)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d400968ac6c6e47bcbe4f01419cf6a064c8f56061a962d57fd49fb148d0adc3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0837775156f5cb793dd8a4b741f9f30f1d626f31adb3c6d6193440e39191f63a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5856e0be5b96c362fc89257c707e9e60705b1056dff5f8fc923c46297047879a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientation]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientation]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1204cb35aa73172bef6b62a6d556d5be764263e72ff4ed2226e835ceecb24e37)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__614abb051daa80f823a6bff9854ae53292628f2750d127d45bd63b204a687dca)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putLandscape")
    def put_landscape(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationLandscape()

        return typing.cast(None, jsii.invoke(self, "putLandscape", [value]))

    @jsii.member(jsii_name="putPortrait")
    def put_portrait(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationPortrait()

        return typing.cast(None, jsii.invoke(self, "putPortrait", [value]))

    @jsii.member(jsii_name="putSquare")
    def put_square(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationSquare()

        return typing.cast(None, jsii.invoke(self, "putSquare", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetLandscape")
    def reset_landscape(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLandscape", []))

    @jsii.member(jsii_name="resetPortrait")
    def reset_portrait(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPortrait", []))

    @jsii.member(jsii_name="resetSquare")
    def reset_square(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSquare", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="landscape")
    def landscape(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationLandscapeOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationLandscapeOutputReference, jsii.get(self, "landscape"))

    @builtins.property
    @jsii.member(jsii_name="portrait")
    def portrait(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationPortraitOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationPortraitOutputReference", jsii.get(self, "portrait"))

    @builtins.property
    @jsii.member(jsii_name="square")
    def square(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationSquareOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationSquareOutputReference", jsii.get(self, "square"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="landscapeInput")
    def landscape_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationLandscape], jsii.get(self, "landscapeInput"))

    @builtins.property
    @jsii.member(jsii_name="portraitInput")
    def portrait_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationPortrait"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationPortrait"], jsii.get(self, "portraitInput"))

    @builtins.property
    @jsii.member(jsii_name="squareInput")
    def square_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationSquare"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationSquare"], jsii.get(self, "squareInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientation]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientation]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientation]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__65f0e52fb4340326d1b0e93ddbdc192da9ed92005e05b77813a7bc7f9b038425)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationPortrait",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationPortrait:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationPortrait(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationPortraitOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationPortraitOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7c80265500eefbb49b6bb4b6b8891ab53a6eb77a6394af4325e1fc1f696b8e21)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationPortrait]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationPortrait], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationPortrait],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__68da77710d8ed42d49745d0b038e821cd4eb1ab591ce0155f6325d16fc3c85bf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationSquare",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationSquare:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationSquare(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationSquareOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationSquareOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5d65da2d577d1318c66d9433cad26e32b1f8593529147f5428e0480a304f3404)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationSquare]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationSquare], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationSquare],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__08b58389847ead8797b8a508380e806d24f264861a1cdca00c37ce250b9c2c43)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultMaxColors",
    jsii_struct_bases=[],
    name_mapping={"colors": "colors", "colors_var": "colorsVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultMaxColors:
    def __init__(
        self,
        *,
        colors: typing.Optional[builtins.str] = None,
        colors_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param colors: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        :param colors_var: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__08e05b029912fd04ad6632414d7c345019e6024353f5ec8e6309c5b6087adb57)
            check_type(argname="argument colors", value=colors, expected_type=type_hints["colors"])
            check_type(argname="argument colors_var", value=colors_var, expected_type=type_hints["colors_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if colors is not None:
            self._values["colors"] = colors
        if colors_var is not None:
            self._values["colors_var"] = colors_var

    @builtins.property
    def colors(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        '''
        result = self._values.get("colors")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def colors_var(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        result = self._values.get("colors_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultMaxColors(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultMaxColorsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultMaxColorsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__52a263934cb21dd88c95dece61b07fab6b231170efa6b786d8b6d6d19deaf699)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultMaxColorsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__333efac1966adcb163d180443a1f9e28f1a0c67415c44c6d50e265a1f2cd3096)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultMaxColorsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a75cebc557c5f73aec91d4b5eced89e428966bfbe4db494767b8b7e16e5a591)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__322d54e2718ff3ddb676f424c2a5997438b202a800121ba4203767b2920e6599)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d19d7aadb638e9af1386e18051b0f1d6034b7989c51b5a5b7555432546d21c5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultMaxColors]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultMaxColors]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d7a34f7f31afa8fab611a2e4481fad502e136e5765074f1dc9710e36ec935e85)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultMaxColorsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultMaxColorsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__37a18a39d0248c41aeee6744efd3bebd0c423979589316780cf2e612c048d872)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColors")
    def reset_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColors", []))

    @jsii.member(jsii_name="resetColorsVar")
    def reset_colors_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorsVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorsInput")
    def colors_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsInput"))

    @builtins.property
    @jsii.member(jsii_name="colorsVarInput")
    def colors_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsVarInput"))

    @builtins.property
    @jsii.member(jsii_name="colors")
    def colors(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colors"))

    @colors.setter
    def colors(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5c898cb3aaa51d507ad1a1716b5764a44d7ab1d890cc03cbfd58f249e9cee1a6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colors", value)

    @builtins.property
    @jsii.member(jsii_name="colorsVar")
    def colors_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorsVar"))

    @colors_var.setter
    def colors_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8067912ce4876871c2dbd0a4bec74d74818a9760ec7ab5dedb2d0ae683960b81)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorsVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultMaxColors]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultMaxColors]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultMaxColors]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f6d75600d3d154c3edad766b2027b26cf25b2161306c1b25c4872984a8732c3e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultMirror",
    jsii_struct_bases=[],
    name_mapping={
        "horizontal": "horizontal",
        "horizontal_var": "horizontalVar",
        "vertical": "vertical",
        "vertical_var": "verticalVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultMirror:
    def __init__(
        self,
        *,
        horizontal: typing.Optional[builtins.str] = None,
        horizontal_var: typing.Optional[builtins.str] = None,
        vertical: typing.Optional[builtins.str] = None,
        vertical_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param horizontal: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        :param horizontal_var: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        :param vertical: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        :param vertical_var: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f53ff2c6535031a9d6c6a94417dd56ebffba2c72d18cc560d1b4f098f6342773)
            check_type(argname="argument horizontal", value=horizontal, expected_type=type_hints["horizontal"])
            check_type(argname="argument horizontal_var", value=horizontal_var, expected_type=type_hints["horizontal_var"])
            check_type(argname="argument vertical", value=vertical, expected_type=type_hints["vertical"])
            check_type(argname="argument vertical_var", value=vertical_var, expected_type=type_hints["vertical_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if horizontal is not None:
            self._values["horizontal"] = horizontal
        if horizontal_var is not None:
            self._values["horizontal_var"] = horizontal_var
        if vertical is not None:
            self._values["vertical"] = vertical
        if vertical_var is not None:
            self._values["vertical_var"] = vertical_var

    @builtins.property
    def horizontal(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        '''
        result = self._values.get("horizontal")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def horizontal_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        '''
        result = self._values.get("horizontal_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        '''
        result = self._values.get("vertical")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        result = self._values.get("vertical_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultMirror(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultMirrorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultMirrorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8d21f241853886efb8f90d3b4cb483865a4519cff9a0d6a599fd012e9346bfcd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultMirrorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3748e95733ed5390fc8a22ace12ed003ad0e521ab506b0c318998b3b5a574597)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultMirrorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dd2be6d116c3b185407b459492c1ca44cee7433a093347a9592692a305cf1540)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f8a8dc975c72a0bfed235d1c91bdbbac9c943fb0b5b5fe2eb5f31734f8789084)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1c190424909f8018242dc49265b0e839ce827308775feca20e6080fce67149a8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultMirror]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultMirror]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__92e949b2ebcb590289494d655f1a32eca9a5082b75cd105b5a6b9ae6e95be2a3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultMirrorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultMirrorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ab7b4b7e8425cdeb6c98e03ca3ebc8ce429f40da6846fb04a153018f28d43ab)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHorizontal")
    def reset_horizontal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontal", []))

    @jsii.member(jsii_name="resetHorizontalVar")
    def reset_horizontal_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontalVar", []))

    @jsii.member(jsii_name="resetVertical")
    def reset_vertical(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVertical", []))

    @jsii.member(jsii_name="resetVerticalVar")
    def reset_vertical_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVerticalVar", []))

    @builtins.property
    @jsii.member(jsii_name="horizontalInput")
    def horizontal_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontalVarInput")
    def horizontal_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalInput")
    def vertical_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalVarInput")
    def vertical_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontal")
    def horizontal(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontal"))

    @horizontal.setter
    def horizontal(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__212302996f5473a3ce2debbe54bdf3b2d23fa18920b049b6d5ca63a2ea21796b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontal", value)

    @builtins.property
    @jsii.member(jsii_name="horizontalVar")
    def horizontal_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontalVar"))

    @horizontal_var.setter
    def horizontal_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__79c6d9e0c01869cc6b829165a1b2a0c92ec8b817e92242fd775f7e05263b5553)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontalVar", value)

    @builtins.property
    @jsii.member(jsii_name="vertical")
    def vertical(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "vertical"))

    @vertical.setter
    def vertical(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a2939c0c20c74392062bf0237d6619b4211db2b35c0320fd0c6cb883bf0ea79d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "vertical", value)

    @builtins.property
    @jsii.member(jsii_name="verticalVar")
    def vertical_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "verticalVar"))

    @vertical_var.setter
    def vertical_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d060ddc9d772c384d19302756c6eec23c179c31a57ee52ea94a9f3c0b01368cd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "verticalVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultMirror]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultMirror]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultMirror]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__764a9a3b59ee58e95e187c784863b2266110958466643e31b406c47b93b083c6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultMonoHue",
    jsii_struct_bases=[],
    name_mapping={"hue": "hue", "hue_var": "hueVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultMonoHue:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a375e0891a4f11fe8b6d4ae3fabbd426379a65de75652e8477205a59f23319c9)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultMonoHue(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultMonoHueList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultMonoHueList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__db33209be32853119649324d2178b0e1f47d5b7c1ac6d263f045c7d47d48795a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultMonoHueOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__46ea524e0e530bf4c09d10af6e20779c2c77f8cf5656f2bc372ae5cdb8745371)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultMonoHueOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9cc6682dc01ec3bc2a35a28a1f77d18931f9a7025bc01bc96e61658162b24b80)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2b962395c0e86c77231a6c4e5b4d8ae7ee42bd35fb8fa059f1d3cb80648b4838)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4f90b3de158520fb0bb3b10198e719bf4ac6b955a7abde84401bae343946cae6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultMonoHue]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultMonoHue]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b54262d32ed38e60e543b9f81a87b051b08df98cc37e3c36dd09e81b7bde254b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultMonoHueOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultMonoHueOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8361b3a9926022ea61a6542ca6040f7145c26c0dce463adfdc3f7eeea40e92a9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e4ad5d0297eb9a3758c127c920a8f52cc58e71b70cbf1d42288eade4ec129afe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__acc0c3188595dddb7a485a3097081b45f6fd41f6229ef97b22770d60c3e0eb4e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultMonoHue]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultMonoHue]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultMonoHue]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__36421c9b782118bed662d35a2174b19711e538beb638efffc0e45e85c5214c8d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultOpacity",
    jsii_struct_bases=[],
    name_mapping={"opacity": "opacity", "opacity_var": "opacityVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultOpacity:
    def __init__(
        self,
        *,
        opacity: typing.Optional[builtins.str] = None,
        opacity_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param opacity: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param opacity_var: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__721621daf82aa85a16b0c446e3c36fb7e35e71dd43c5b822751a0311c341996f)
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument opacity_var", value=opacity_var, expected_type=type_hints["opacity_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if opacity is not None:
            self._values["opacity"] = opacity
        if opacity_var is not None:
            self._values["opacity_var"] = opacity_var

    @builtins.property
    def opacity(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def opacity_var(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        result = self._values.get("opacity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultOpacity(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultOpacityList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultOpacityList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5bac8ef58a1ae6173ff525b59d80170dac94ab1e68863946f42cd70649a4949a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultOpacityOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6563c784b6a957174a39ddf5fa68ec9a2755eadbef514d64059b30839c9d1d5f)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultOpacityOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bde67026db07dd67d293fdb022bfac1a12d1c3ac7e2346fc9d2add1fa2aba5f7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b488d9b752755d9b3093f8025cd92bd198d50532555f637da615f668b780c888)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b35aea769ac4ace61368152a5227e20e37cfcf6ee547b910cce0bd4a327fdb51)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultOpacity]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultOpacity]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1984dd027b0a3f7047e8f21a0f02d7596bf054fc6bc036b9a89fc23d45ef7c14)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultOpacityOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultOpacityOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a39eaf33556cb80f1c3993452109412c21bb2f7a84b4cb5958142165388d537)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetOpacityVar")
    def reset_opacity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacityVar", []))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityVarInput")
    def opacity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacity"))

    @opacity.setter
    def opacity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7aaa2461c978e3f08c7ed5ac1826820272bac4eedf1e39057334bc14403f7d78)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacity", value)

    @builtins.property
    @jsii.member(jsii_name="opacityVar")
    def opacity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacityVar"))

    @opacity_var.setter
    def opacity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__188f30e9f5eb309b8c1f680f4caec6fa37b098832d97998075a7f60783c1ef52)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacityVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultOpacity]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultOpacity]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultOpacity]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__533835c72eedab8b6e737b1e927f90174ea193c6cbb2a96afc73b3d4099409ad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1df8af2410df2342f7c612a9a225f9f9fbe9910ff5513422c3f3839d803207c0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putBackgroundColor")
    def put_background_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d4b2cf7742a461d967e737fc5b31db081025e3d964bbf656a13b50eed6c22dc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBackgroundColor", [value]))

    @jsii.member(jsii_name="putBlur")
    def put_blur(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultBlur, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ec049956326c782755fa71eb925e8882d79d3b7e8e67d792ce0884ee9435de6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBlur", [value]))

    @jsii.member(jsii_name="putChromaKey")
    def put_chroma_key(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultChromaKey, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__078faec4f2497df97882db93e0df93697c91f123ce16c2255fc58e692a0b81e8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putChromaKey", [value]))

    @jsii.member(jsii_name="putComposite")
    def put_composite(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultComposite, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7704dd9e6e34eac9fbe70087ccb9e541358aeca82d872b15399246c5bd0c2155)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putComposite", [value]))

    @jsii.member(jsii_name="putCompound")
    def put_compound(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultCompound, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__85716738cb9c6c3e42878f294d2080df01bed6cddd564cbdb37935dacce0b033)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCompound", [value]))

    @jsii.member(jsii_name="putContrast")
    def put_contrast(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultContrast, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__91a896ef2ce553d3fd77f01afc98d32f55e3f38a9613e693d44eff1cee7aa3f3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putContrast", [value]))

    @jsii.member(jsii_name="putGoop")
    def put_goop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultGoop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__22c8a315eaebe8fc65cf6252f64d2574ce78fd1b36c5571a68b5c85218a398e0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGoop", [value]))

    @jsii.member(jsii_name="putGrayscale")
    def put_grayscale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultGrayscale, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__52bcd759c53231f052e9bad744cf7f9ef1cec4481830459d0bf2573417ee090b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGrayscale", [value]))

    @jsii.member(jsii_name="putHsl")
    def put_hsl(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultHsl, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ee2b4a3586a95f45528dbb1a457e3790292dad05b65e022a1718e6c55af1a142)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsl", [value]))

    @jsii.member(jsii_name="putHsv")
    def put_hsv(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultHsv, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ecda2a47e6b5d3099b4acdf402e9475d9c3acc0c5c0cea491ef76fe58137594)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsv", [value]))

    @jsii.member(jsii_name="putIfDimension")
    def put_if_dimension(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfDimension, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5fff0d8c556fff0cab6d566d2867e0978ff38da46a3bb71a81af3969e17593f7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfDimension", [value]))

    @jsii.member(jsii_name="putIfOrientation")
    def put_if_orientation(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0215f16f7b27f354f72d292a0e1c03326e0067dd2fa7555ab81fca3086e24dcb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfOrientation", [value]))

    @jsii.member(jsii_name="putMaxColors")
    def put_max_colors(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultMaxColors, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__727f2d805d5dd69ef15f029c117327f6c26b2d72b47a0e3110518c9b405d7cf3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMaxColors", [value]))

    @jsii.member(jsii_name="putMirror")
    def put_mirror(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultMirror, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fbd7e4b9672b2afc816f9143c5a8138dc83edc9303c3daeaa64471bdc602af6a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMirror", [value]))

    @jsii.member(jsii_name="putMonoHue")
    def put_mono_hue(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultMonoHue, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__042e74babba702954cebd87c36e46bb33a00f3a5b3d451db8288c46fdc137bc5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMonoHue", [value]))

    @jsii.member(jsii_name="putOpacity")
    def put_opacity(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultOpacity, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4fec228ee515f6910161031132e29e9dc0e05743809453ec34629c189ff81eb4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putOpacity", [value]))

    @jsii.member(jsii_name="putRemoveColor")
    def put_remove_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultRemoveColor", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8f80eed090b631b065050082c780e38bf8faf383f6e544a63060057e4a9db604)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRemoveColor", [value]))

    @jsii.member(jsii_name="putUnsharpMask")
    def put_unsharp_mask(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultUnsharpMask", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__73f5335d3f55dcc24e7e469e417e7157623d7a3951c3b8a9f228467c14e2e252)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putUnsharpMask", [value]))

    @jsii.member(jsii_name="resetBackgroundColor")
    def reset_background_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBackgroundColor", []))

    @jsii.member(jsii_name="resetBlur")
    def reset_blur(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBlur", []))

    @jsii.member(jsii_name="resetChromaKey")
    def reset_chroma_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChromaKey", []))

    @jsii.member(jsii_name="resetComposite")
    def reset_composite(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetComposite", []))

    @jsii.member(jsii_name="resetCompound")
    def reset_compound(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCompound", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetGoop")
    def reset_goop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGoop", []))

    @jsii.member(jsii_name="resetGrayscale")
    def reset_grayscale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGrayscale", []))

    @jsii.member(jsii_name="resetHsl")
    def reset_hsl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsl", []))

    @jsii.member(jsii_name="resetHsv")
    def reset_hsv(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsv", []))

    @jsii.member(jsii_name="resetIfDimension")
    def reset_if_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfDimension", []))

    @jsii.member(jsii_name="resetIfOrientation")
    def reset_if_orientation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfOrientation", []))

    @jsii.member(jsii_name="resetMaxColors")
    def reset_max_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxColors", []))

    @jsii.member(jsii_name="resetMirror")
    def reset_mirror(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMirror", []))

    @jsii.member(jsii_name="resetMonoHue")
    def reset_mono_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonoHue", []))

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetRemoveColor")
    def reset_remove_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRemoveColor", []))

    @jsii.member(jsii_name="resetUnsharpMask")
    def reset_unsharp_mask(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUnsharpMask", []))

    @builtins.property
    @jsii.member(jsii_name="backgroundColor")
    def background_color(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultBackgroundColorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultBackgroundColorList, jsii.get(self, "backgroundColor"))

    @builtins.property
    @jsii.member(jsii_name="blur")
    def blur(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultBlurList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultBlurList, jsii.get(self, "blur"))

    @builtins.property
    @jsii.member(jsii_name="chromaKey")
    def chroma_key(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultChromaKeyList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultChromaKeyList, jsii.get(self, "chromaKey"))

    @builtins.property
    @jsii.member(jsii_name="composite")
    def composite(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultCompositeList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultCompositeList, jsii.get(self, "composite"))

    @builtins.property
    @jsii.member(jsii_name="compound")
    def compound(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultCompoundList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultCompoundList, jsii.get(self, "compound"))

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultContrastList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultContrastList, jsii.get(self, "contrast"))

    @builtins.property
    @jsii.member(jsii_name="goop")
    def goop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultGoopList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultGoopList, jsii.get(self, "goop"))

    @builtins.property
    @jsii.member(jsii_name="grayscale")
    def grayscale(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultGrayscaleList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultGrayscaleList, jsii.get(self, "grayscale"))

    @builtins.property
    @jsii.member(jsii_name="hsl")
    def hsl(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultHslList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultHslList, jsii.get(self, "hsl"))

    @builtins.property
    @jsii.member(jsii_name="hsv")
    def hsv(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultHsvList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultHsvList, jsii.get(self, "hsv"))

    @builtins.property
    @jsii.member(jsii_name="ifDimension")
    def if_dimension(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionList, jsii.get(self, "ifDimension"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientation")
    def if_orientation(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationList, jsii.get(self, "ifOrientation"))

    @builtins.property
    @jsii.member(jsii_name="maxColors")
    def max_colors(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultMaxColorsList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultMaxColorsList, jsii.get(self, "maxColors"))

    @builtins.property
    @jsii.member(jsii_name="mirror")
    def mirror(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultMirrorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultMirrorList, jsii.get(self, "mirror"))

    @builtins.property
    @jsii.member(jsii_name="monoHue")
    def mono_hue(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultMonoHueList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultMonoHueList, jsii.get(self, "monoHue"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultOpacityList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultOpacityList, jsii.get(self, "opacity"))

    @builtins.property
    @jsii.member(jsii_name="removeColor")
    def remove_color(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultRemoveColorList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultRemoveColorList", jsii.get(self, "removeColor"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMask")
    def unsharp_mask(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultUnsharpMaskList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultUnsharpMaskList", jsii.get(self, "unsharpMask"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColorInput")
    def background_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultBackgroundColor]]], jsii.get(self, "backgroundColorInput"))

    @builtins.property
    @jsii.member(jsii_name="blurInput")
    def blur_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultBlur]]], jsii.get(self, "blurInput"))

    @builtins.property
    @jsii.member(jsii_name="chromaKeyInput")
    def chroma_key_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultChromaKey]]], jsii.get(self, "chromaKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="compositeInput")
    def composite_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultComposite]]], jsii.get(self, "compositeInput"))

    @builtins.property
    @jsii.member(jsii_name="compoundInput")
    def compound_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultCompound]]], jsii.get(self, "compoundInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultContrast]]], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="goopInput")
    def goop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultGoop]]], jsii.get(self, "goopInput"))

    @builtins.property
    @jsii.member(jsii_name="grayscaleInput")
    def grayscale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultGrayscale]]], jsii.get(self, "grayscaleInput"))

    @builtins.property
    @jsii.member(jsii_name="hslInput")
    def hsl_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultHsl]]], jsii.get(self, "hslInput"))

    @builtins.property
    @jsii.member(jsii_name="hsvInput")
    def hsv_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultHsv]]], jsii.get(self, "hsvInput"))

    @builtins.property
    @jsii.member(jsii_name="ifDimensionInput")
    def if_dimension_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfDimension]]], jsii.get(self, "ifDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientationInput")
    def if_orientation_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientation]]], jsii.get(self, "ifOrientationInput"))

    @builtins.property
    @jsii.member(jsii_name="maxColorsInput")
    def max_colors_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultMaxColors]]], jsii.get(self, "maxColorsInput"))

    @builtins.property
    @jsii.member(jsii_name="mirrorInput")
    def mirror_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultMirror]]], jsii.get(self, "mirrorInput"))

    @builtins.property
    @jsii.member(jsii_name="monoHueInput")
    def mono_hue_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultMonoHue]]], jsii.get(self, "monoHueInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultOpacity]]], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="removeColorInput")
    def remove_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultRemoveColor"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultRemoveColor"]]], jsii.get(self, "removeColorInput"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMaskInput")
    def unsharp_mask_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultUnsharpMask"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultUnsharpMask"]]], jsii.get(self, "unsharpMaskInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3b8f6d3a5fbed86c19bab37e6257e327db0ac60e26fb4d89bb0e0c2e993a2041)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultRemoveColor",
    jsii_struct_bases=[],
    name_mapping={
        "color": "color",
        "color_var": "colorVar",
        "feather": "feather",
        "feather_var": "featherVar",
        "tolerance": "tolerance",
        "tolerance_var": "toleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultRemoveColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
        feather: typing.Optional[builtins.str] = None,
        feather_var: typing.Optional[builtins.str] = None,
        tolerance: typing.Optional[builtins.str] = None,
        tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        :param feather: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        :param feather_var: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        :param tolerance: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        :param tolerance_var: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6c07c80649b575ebe6fe4e67cfbff1911177e821d094fba855d0cab23ce49e43)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
            check_type(argname="argument feather", value=feather, expected_type=type_hints["feather"])
            check_type(argname="argument feather_var", value=feather_var, expected_type=type_hints["feather_var"])
            check_type(argname="argument tolerance", value=tolerance, expected_type=type_hints["tolerance"])
            check_type(argname="argument tolerance_var", value=tolerance_var, expected_type=type_hints["tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var
        if feather is not None:
            self._values["feather"] = feather
        if feather_var is not None:
            self._values["feather_var"] = feather_var
        if tolerance is not None:
            self._values["tolerance"] = tolerance
        if tolerance_var is not None:
            self._values["tolerance_var"] = tolerance_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        '''
        result = self._values.get("feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather_var(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        '''
        result = self._values.get("feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        '''
        result = self._values.get("tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance_var(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        result = self._values.get("tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultRemoveColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultRemoveColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultRemoveColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3eb4111a2664832339e0cbbcb8f6114d420ff01d5ab4aab3679f5dbd510085dc)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultRemoveColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ce7b3c14fb86af0df1932c31ade78f3ea3eb56174865ab959850cbb48f8f0dfb)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultRemoveColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9cfad2f7ad680189604ba73c6680227e5ddb823714c7230bf41a2f8f47b4eb7e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__13361778cc008e5e146b351eea9160084c0f93dea204ff83bcd7e3d2676796a3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__983399bfa3cf0d9cc4e05d253f0155f175a490d5d99a734edf5f8c84cacd61af)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultRemoveColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultRemoveColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultRemoveColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b24ce0c89735f9b70f6f882ea828e405a99a31dd1e0e91e16299225909968cdc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultRemoveColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultRemoveColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4f1cce89c66a15694a78b4e0ea53ed968e3e463b0bcfc75f837c71027f8362dd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @jsii.member(jsii_name="resetFeather")
    def reset_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeather", []))

    @jsii.member(jsii_name="resetFeatherVar")
    def reset_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatherVar", []))

    @jsii.member(jsii_name="resetTolerance")
    def reset_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTolerance", []))

    @jsii.member(jsii_name="resetToleranceVar")
    def reset_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featherInput")
    def feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherInput"))

    @builtins.property
    @jsii.member(jsii_name="featherVarInput")
    def feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceInput")
    def tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceVarInput")
    def tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7938009e1718a773f0a70f2690ba231c591704e744be9e61c2a175eea8ef0ec4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dea15b702d6c57c39ddedd82780eecf2058328bf38f7ef2642f9a615392535f6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="feather")
    def feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "feather"))

    @feather.setter
    def feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd55796150165be45a12cf12a98ac5d9441331fbde3fbd624be4fed2a0cca800)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "feather", value)

    @builtins.property
    @jsii.member(jsii_name="featherVar")
    def feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featherVar"))

    @feather_var.setter
    def feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e55efa1e027415899e431cafe8177ec37fb2727f7a28aad31ba8593afcb040c2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featherVar", value)

    @builtins.property
    @jsii.member(jsii_name="tolerance")
    def tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tolerance"))

    @tolerance.setter
    def tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0090b743772124af542b055c7b1bc8a892fc3d2bff3eb8dec495150430ad43b5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tolerance", value)

    @builtins.property
    @jsii.member(jsii_name="toleranceVar")
    def tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "toleranceVar"))

    @tolerance_var.setter
    def tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c5018bc55b0042aad56bf76d1bad3e084cf20a07aee5f3916ccc84f62ccb7a29)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "toleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultRemoveColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultRemoveColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultRemoveColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e1fba184103e2a8650a6a7bb28fa2a7d3d01bc135a5b0fa1a6c11c79d1f07a4e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultUnsharpMask",
    jsii_struct_bases=[],
    name_mapping={
        "gain": "gain",
        "gain_var": "gainVar",
        "sigma": "sigma",
        "sigma_var": "sigmaVar",
        "threshold": "threshold",
        "threshold_var": "thresholdVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultUnsharpMask:
    def __init__(
        self,
        *,
        gain: typing.Optional[builtins.str] = None,
        gain_var: typing.Optional[builtins.str] = None,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
        threshold: typing.Optional[builtins.str] = None,
        threshold_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param gain: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        :param gain_var: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        :param sigma: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        :param threshold: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        :param threshold_var: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2770e147166beac14ff3a6127ce0b7b76fa96b1960fa5fd21880c9c904d294f9)
            check_type(argname="argument gain", value=gain, expected_type=type_hints["gain"])
            check_type(argname="argument gain_var", value=gain_var, expected_type=type_hints["gain_var"])
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
            check_type(argname="argument threshold", value=threshold, expected_type=type_hints["threshold"])
            check_type(argname="argument threshold_var", value=threshold_var, expected_type=type_hints["threshold_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if gain is not None:
            self._values["gain"] = gain
        if gain_var is not None:
            self._values["gain_var"] = gain_var
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var
        if threshold is not None:
            self._values["threshold"] = threshold
        if threshold_var is not None:
            self._values["threshold_var"] = threshold_var

    @builtins.property
    def gain(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        '''
        result = self._values.get("gain")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gain_var(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        '''
        result = self._values.get("gain_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        '''
        result = self._values.get("threshold")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold_var(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        result = self._values.get("threshold_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultUnsharpMask(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultUnsharpMaskList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultUnsharpMaskList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a6422a749648a3ae48cfef622d0c51043559f869be23fb5aeaf076df670fdda)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultUnsharpMaskOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__144af244c79a9b971087c99913bf396199b92679ea02b2e1609bec3b556efe9c)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultUnsharpMaskOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4e97bf37e6aea2769f5dfbad529afceafa2edc6cb338df8c1320d2d172d43e7d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__99f1c93c3649ac29787580609c8881c04a6b9e5aff5a406b1e9c0722d08bb36c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a11abd60313796d11a2d1f9f23d6298ab6491fbb73ee3ca5d0ba4e960de3da38)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultUnsharpMask]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultUnsharpMask]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultUnsharpMask]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8faa1c5f558e87d041204e1ba755f12b9c4eb83b1b5a76849e845ac4a5ec7897)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultUnsharpMaskOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultUnsharpMaskOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eafba247f52d335f3a299ec442f7f88a292202c9baa17f45cbded669fe8a73dc)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetGain")
    def reset_gain(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGain", []))

    @jsii.member(jsii_name="resetGainVar")
    def reset_gain_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGainVar", []))

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @jsii.member(jsii_name="resetThreshold")
    def reset_threshold(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThreshold", []))

    @jsii.member(jsii_name="resetThresholdVar")
    def reset_threshold_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThresholdVar", []))

    @builtins.property
    @jsii.member(jsii_name="gainInput")
    def gain_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainInput"))

    @builtins.property
    @jsii.member(jsii_name="gainVarInput")
    def gain_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdInput")
    def threshold_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdVarInput")
    def threshold_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gain")
    def gain(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gain"))

    @gain.setter
    def gain(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__38ce62d47a649003467851b65a37881815cdae795ac414afcf366fda2ef2050c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gain", value)

    @builtins.property
    @jsii.member(jsii_name="gainVar")
    def gain_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gainVar"))

    @gain_var.setter
    def gain_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__98d45085bf42ee4684ff43f23b58b359383363fa41cc6f22a07b84ca9e2a4cc5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gainVar", value)

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2c611d84eb28d8e4fd356274e1896fb1384edad88b4bf2c1ae3c4d81f344ac77)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__909e35c4c7cee1365885e4e9d44f46351b222e444d5ab417f5881d02ed6d13b2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="threshold")
    def threshold(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "threshold"))

    @threshold.setter
    def threshold(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__db9610bed175704c710e1b30a9e0543178a0a9763d7fbb8786cc34b372c6bfb2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "threshold", value)

    @builtins.property
    @jsii.member(jsii_name="thresholdVar")
    def threshold_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "thresholdVar"))

    @threshold_var.setter
    def threshold_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c74c17548378ab8bbd2cbbb74a165e421c2800f63787291a83c90344bacbd34f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "thresholdVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultUnsharpMask]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultUnsharpMask]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultUnsharpMask]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb5e19cf14946d7fd567641333f23a4d13e1f23611520cac1cda9d8cd3d88f5a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscape",
    jsii_struct_bases=[],
    name_mapping={
        "background_color": "backgroundColor",
        "blur": "blur",
        "chroma_key": "chromaKey",
        "composite": "composite",
        "compound": "compound",
        "contrast": "contrast",
        "goop": "goop",
        "grayscale": "grayscale",
        "hsl": "hsl",
        "hsv": "hsv",
        "if_dimension": "ifDimension",
        "if_orientation": "ifOrientation",
        "max_colors": "maxColors",
        "mirror": "mirror",
        "mono_hue": "monoHue",
        "opacity": "opacity",
        "remove_color": "removeColor",
        "unsharp_mask": "unsharpMask",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscape:
    def __init__(
        self,
        *,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeBackgroundColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeBlur", typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeChromaKey", typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeComposite", typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeCompound", typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeContrast", typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeGoop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeGrayscale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeHsl", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeHsv", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimension", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientation", typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeMaxColors", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeMirror", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeMonoHue", typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeOpacity", typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeRemoveColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeUnsharpMask", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a570637f2a5df459da07ca81fd52159f264825c6dc3604c05d87dc8e63b57826)
            check_type(argname="argument background_color", value=background_color, expected_type=type_hints["background_color"])
            check_type(argname="argument blur", value=blur, expected_type=type_hints["blur"])
            check_type(argname="argument chroma_key", value=chroma_key, expected_type=type_hints["chroma_key"])
            check_type(argname="argument composite", value=composite, expected_type=type_hints["composite"])
            check_type(argname="argument compound", value=compound, expected_type=type_hints["compound"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument goop", value=goop, expected_type=type_hints["goop"])
            check_type(argname="argument grayscale", value=grayscale, expected_type=type_hints["grayscale"])
            check_type(argname="argument hsl", value=hsl, expected_type=type_hints["hsl"])
            check_type(argname="argument hsv", value=hsv, expected_type=type_hints["hsv"])
            check_type(argname="argument if_dimension", value=if_dimension, expected_type=type_hints["if_dimension"])
            check_type(argname="argument if_orientation", value=if_orientation, expected_type=type_hints["if_orientation"])
            check_type(argname="argument max_colors", value=max_colors, expected_type=type_hints["max_colors"])
            check_type(argname="argument mirror", value=mirror, expected_type=type_hints["mirror"])
            check_type(argname="argument mono_hue", value=mono_hue, expected_type=type_hints["mono_hue"])
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument remove_color", value=remove_color, expected_type=type_hints["remove_color"])
            check_type(argname="argument unsharp_mask", value=unsharp_mask, expected_type=type_hints["unsharp_mask"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if background_color is not None:
            self._values["background_color"] = background_color
        if blur is not None:
            self._values["blur"] = blur
        if chroma_key is not None:
            self._values["chroma_key"] = chroma_key
        if composite is not None:
            self._values["composite"] = composite
        if compound is not None:
            self._values["compound"] = compound
        if contrast is not None:
            self._values["contrast"] = contrast
        if goop is not None:
            self._values["goop"] = goop
        if grayscale is not None:
            self._values["grayscale"] = grayscale
        if hsl is not None:
            self._values["hsl"] = hsl
        if hsv is not None:
            self._values["hsv"] = hsv
        if if_dimension is not None:
            self._values["if_dimension"] = if_dimension
        if if_orientation is not None:
            self._values["if_orientation"] = if_orientation
        if max_colors is not None:
            self._values["max_colors"] = max_colors
        if mirror is not None:
            self._values["mirror"] = mirror
        if mono_hue is not None:
            self._values["mono_hue"] = mono_hue
        if opacity is not None:
            self._values["opacity"] = opacity
        if remove_color is not None:
            self._values["remove_color"] = remove_color
        if unsharp_mask is not None:
            self._values["unsharp_mask"] = unsharp_mask

    @builtins.property
    def background_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeBackgroundColor"]]]:
        '''background_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        '''
        result = self._values.get("background_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeBackgroundColor"]]], result)

    @builtins.property
    def blur(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeBlur"]]]:
        '''blur block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        '''
        result = self._values.get("blur")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeBlur"]]], result)

    @builtins.property
    def chroma_key(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeChromaKey"]]]:
        '''chroma_key block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        '''
        result = self._values.get("chroma_key")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeChromaKey"]]], result)

    @builtins.property
    def composite(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeComposite"]]]:
        '''composite block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        '''
        result = self._values.get("composite")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeComposite"]]], result)

    @builtins.property
    def compound(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeCompound"]]]:
        '''compound block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        '''
        result = self._values.get("compound")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeCompound"]]], result)

    @builtins.property
    def contrast(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeContrast"]]]:
        '''contrast block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeContrast"]]], result)

    @builtins.property
    def goop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeGoop"]]]:
        '''goop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        '''
        result = self._values.get("goop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeGoop"]]], result)

    @builtins.property
    def grayscale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeGrayscale"]]]:
        '''grayscale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        '''
        result = self._values.get("grayscale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeGrayscale"]]], result)

    @builtins.property
    def hsl(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeHsl"]]]:
        '''hsl block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        '''
        result = self._values.get("hsl")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeHsl"]]], result)

    @builtins.property
    def hsv(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeHsv"]]]:
        '''hsv block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        '''
        result = self._values.get("hsv")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeHsv"]]], result)

    @builtins.property
    def if_dimension(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimension"]]]:
        '''if_dimension block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        '''
        result = self._values.get("if_dimension")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimension"]]], result)

    @builtins.property
    def if_orientation(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientation"]]]:
        '''if_orientation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        '''
        result = self._values.get("if_orientation")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientation"]]], result)

    @builtins.property
    def max_colors(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeMaxColors"]]]:
        '''max_colors block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        '''
        result = self._values.get("max_colors")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeMaxColors"]]], result)

    @builtins.property
    def mirror(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeMirror"]]]:
        '''mirror block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        '''
        result = self._values.get("mirror")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeMirror"]]], result)

    @builtins.property
    def mono_hue(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeMonoHue"]]]:
        '''mono_hue block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        '''
        result = self._values.get("mono_hue")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeMonoHue"]]], result)

    @builtins.property
    def opacity(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeOpacity"]]]:
        '''opacity block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeOpacity"]]], result)

    @builtins.property
    def remove_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeRemoveColor"]]]:
        '''remove_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        '''
        result = self._values.get("remove_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeRemoveColor"]]], result)

    @builtins.property
    def unsharp_mask(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeUnsharpMask"]]]:
        '''unsharp_mask block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        result = self._values.get("unsharp_mask")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeUnsharpMask"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscape(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeBackgroundColor",
    jsii_struct_bases=[],
    name_mapping={"color": "color", "color_var": "colorVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeBackgroundColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df56829bdf492134dc0d9cc433a50327e9285346625508d034e705ff1e31adad)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeBackgroundColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeBackgroundColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeBackgroundColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0847bde104f8bf2c37e4c92073eee2c87bf32835470396ff9793ebc80b869201)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeBackgroundColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8edabf645bf4b461d5d3763f5fd080bc75281295ce2e58c69eb8af157b31725d)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeBackgroundColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f66a30ace6c8b2c3c8fe53c1e30e4d65cdf744a8b5dc50e40f6b6fdb074174d0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c9547d1bb23bdd592af95125d35c32766e22655eb735c75f9892f1f8ec891408)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__607c91100c8bdbb2ddc771223236662113ebf8e282461d930484b4dd8ace4ac7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeBackgroundColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeBackgroundColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a64488e79130a7e41a92b9fcbae4a7bc3062d4283ac9bec111cc53a282598382)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeBackgroundColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeBackgroundColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__54d6ebcc1677d787fd3b23e6b832ebc824afc5c6256a56dca4848f93f79a3c97)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dedf0a0a0279bec0c631cfe30f12c9369e953708d9af3c781324440e49e14758)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a9fdc248ad421e2d6d00e3216c1524a9fba9b2c7d502e1fc720c6fa194b87872)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeBackgroundColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeBackgroundColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeBackgroundColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d89d030a1c698894a10d52f8feff5ec56bbb229b4a1dd77076dc3169e0d93dac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeBlur",
    jsii_struct_bases=[],
    name_mapping={"sigma": "sigma", "sigma_var": "sigmaVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeBlur:
    def __init__(
        self,
        *,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param sigma: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1b8c83b84fda76ad55a911420f6b299e69961d2bc7229e841b9d90635dadac16)
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeBlur(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeBlurList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeBlurList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6378a463d4411cdd90417b4fc0bf29cd13f50d748e3830b4ebda7a46813881d0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeBlurOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0350d3e6c4cb62496b64c8faa0b467c89de8beb191e92c1e9e2150e2fd9ad6e3)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeBlurOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c41b1a304343f6934af452b20ec6278a30c09e54d3d10ce2118db8b1b408395e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__54519598591cb83db3db9b1c6581e164c64061aacad2922caae5c5b5ecad43e1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8c24024699cf986c3d7e02d04e65b7e81a41bb4374e0d51632e49aa5e8367f8f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeBlur]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeBlur]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__12ae99904c6d4851012b848d67628ef73cd18ac87bc91c9d7894e8fe93431f5c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeBlurOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeBlurOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c083758e0e730a1159949d951acc8c6c54a8dfd80e4870ca9c6894a40c1237cd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d5de1ca5f8fed110dc83069d96a2631410b640f23c8a94b21ad4a5067779780b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__baafca79a3233646ce33c5b6c817e7352158420506a077eb773c1b203516146e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeBlur]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeBlur]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeBlur]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7e9ed37132773ae3048b537c595786c5c620048fb56b704f7976450c775ea231)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeChromaKey",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_feather": "hueFeather",
        "hue_feather_var": "hueFeatherVar",
        "hue_tolerance": "hueTolerance",
        "hue_tolerance_var": "hueToleranceVar",
        "hue_var": "hueVar",
        "lightness_feather": "lightnessFeather",
        "lightness_feather_var": "lightnessFeatherVar",
        "lightness_tolerance": "lightnessTolerance",
        "lightness_tolerance_var": "lightnessToleranceVar",
        "saturation_feather": "saturationFeather",
        "saturation_feather_var": "saturationFeatherVar",
        "saturation_tolerance": "saturationTolerance",
        "saturation_tolerance_var": "saturationToleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeChromaKey:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_feather: typing.Optional[builtins.str] = None,
        hue_feather_var: typing.Optional[builtins.str] = None,
        hue_tolerance: typing.Optional[builtins.str] = None,
        hue_tolerance_var: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness_feather: typing.Optional[builtins.str] = None,
        lightness_feather_var: typing.Optional[builtins.str] = None,
        lightness_tolerance: typing.Optional[builtins.str] = None,
        lightness_tolerance_var: typing.Optional[builtins.str] = None,
        saturation_feather: typing.Optional[builtins.str] = None,
        saturation_feather_var: typing.Optional[builtins.str] = None,
        saturation_tolerance: typing.Optional[builtins.str] = None,
        saturation_tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_feather: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        :param hue_feather_var: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        :param hue_tolerance: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        :param hue_tolerance_var: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        :param hue_var: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness_feather: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        :param lightness_feather_var: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        :param lightness_tolerance: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        :param lightness_tolerance_var: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        :param saturation_feather: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        :param saturation_feather_var: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        :param saturation_tolerance: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        :param saturation_tolerance_var: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__46569a0aed820ddb6e2d4cfbeb8fef426b5a7e9836763ec47816f130a9398007)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_feather", value=hue_feather, expected_type=type_hints["hue_feather"])
            check_type(argname="argument hue_feather_var", value=hue_feather_var, expected_type=type_hints["hue_feather_var"])
            check_type(argname="argument hue_tolerance", value=hue_tolerance, expected_type=type_hints["hue_tolerance"])
            check_type(argname="argument hue_tolerance_var", value=hue_tolerance_var, expected_type=type_hints["hue_tolerance_var"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness_feather", value=lightness_feather, expected_type=type_hints["lightness_feather"])
            check_type(argname="argument lightness_feather_var", value=lightness_feather_var, expected_type=type_hints["lightness_feather_var"])
            check_type(argname="argument lightness_tolerance", value=lightness_tolerance, expected_type=type_hints["lightness_tolerance"])
            check_type(argname="argument lightness_tolerance_var", value=lightness_tolerance_var, expected_type=type_hints["lightness_tolerance_var"])
            check_type(argname="argument saturation_feather", value=saturation_feather, expected_type=type_hints["saturation_feather"])
            check_type(argname="argument saturation_feather_var", value=saturation_feather_var, expected_type=type_hints["saturation_feather_var"])
            check_type(argname="argument saturation_tolerance", value=saturation_tolerance, expected_type=type_hints["saturation_tolerance"])
            check_type(argname="argument saturation_tolerance_var", value=saturation_tolerance_var, expected_type=type_hints["saturation_tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_feather is not None:
            self._values["hue_feather"] = hue_feather
        if hue_feather_var is not None:
            self._values["hue_feather_var"] = hue_feather_var
        if hue_tolerance is not None:
            self._values["hue_tolerance"] = hue_tolerance
        if hue_tolerance_var is not None:
            self._values["hue_tolerance_var"] = hue_tolerance_var
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness_feather is not None:
            self._values["lightness_feather"] = lightness_feather
        if lightness_feather_var is not None:
            self._values["lightness_feather_var"] = lightness_feather_var
        if lightness_tolerance is not None:
            self._values["lightness_tolerance"] = lightness_tolerance
        if lightness_tolerance_var is not None:
            self._values["lightness_tolerance_var"] = lightness_tolerance_var
        if saturation_feather is not None:
            self._values["saturation_feather"] = saturation_feather
        if saturation_feather_var is not None:
            self._values["saturation_feather_var"] = saturation_feather_var
        if saturation_tolerance is not None:
            self._values["saturation_tolerance"] = saturation_tolerance
        if saturation_tolerance_var is not None:
            self._values["saturation_tolerance_var"] = saturation_tolerance_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        '''
        result = self._values.get("hue_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        '''
        result = self._values.get("hue_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        '''
        result = self._values.get("hue_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        '''
        result = self._values.get("hue_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        '''
        result = self._values.get("lightness_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        '''
        result = self._values.get("lightness_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        '''
        result = self._values.get("lightness_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        '''
        result = self._values.get("lightness_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        '''
        result = self._values.get("saturation_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        '''
        result = self._values.get("saturation_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        '''
        result = self._values.get("saturation_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        result = self._values.get("saturation_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeChromaKey(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeChromaKeyList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeChromaKeyList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1a226e32e0b86c94412ecfce06c2e793720d2fba0f408915efe5ef72929a311f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeChromaKeyOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__76470d44296b5e82f3a1382d3985c4c297a0266ade9c8f8cded0766039318b4f)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeChromaKeyOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1e1cfe4d3ce7ade1909899e7b5416ad87b4e582d6a025a9514dd1e0dc759724d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0e7cff84e3b916510a4a603cd05c4a78d98f6422f05fd710d44d5f648502020a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e6780fd6708bddda00ee549362adee3e133f828ece32826c8cac10029272cf65)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeChromaKey]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeChromaKey]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__24b05b9e84d602709e19e9f7ebc4abfa4c8d884e8c186233907a966d6a6397c6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeChromaKeyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeChromaKeyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bae8f224b29de65eeee5666a0f102fe97a8bd1181ba491ee469fe15fca69e66a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueFeather")
    def reset_hue_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeather", []))

    @jsii.member(jsii_name="resetHueFeatherVar")
    def reset_hue_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeatherVar", []))

    @jsii.member(jsii_name="resetHueTolerance")
    def reset_hue_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueTolerance", []))

    @jsii.member(jsii_name="resetHueToleranceVar")
    def reset_hue_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueToleranceVar", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightnessFeather")
    def reset_lightness_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeather", []))

    @jsii.member(jsii_name="resetLightnessFeatherVar")
    def reset_lightness_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeatherVar", []))

    @jsii.member(jsii_name="resetLightnessTolerance")
    def reset_lightness_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessTolerance", []))

    @jsii.member(jsii_name="resetLightnessToleranceVar")
    def reset_lightness_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessToleranceVar", []))

    @jsii.member(jsii_name="resetSaturationFeather")
    def reset_saturation_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeather", []))

    @jsii.member(jsii_name="resetSaturationFeatherVar")
    def reset_saturation_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeatherVar", []))

    @jsii.member(jsii_name="resetSaturationTolerance")
    def reset_saturation_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationTolerance", []))

    @jsii.member(jsii_name="resetSaturationToleranceVar")
    def reset_saturation_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherInput")
    def hue_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVarInput")
    def hue_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceInput")
    def hue_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVarInput")
    def hue_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherInput")
    def lightness_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVarInput")
    def lightness_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceInput")
    def lightness_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVarInput")
    def lightness_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherInput")
    def saturation_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVarInput")
    def saturation_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceInput")
    def saturation_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVarInput")
    def saturation_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__66b33f3951a813e6b3a1cf1dc2f84b14093381bd6e89baf2e38b01f90d4007cc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeather")
    def hue_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeather"))

    @hue_feather.setter
    def hue_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dffba70ec564b70c3965a650e4965f815eda7a9eb7592be939e5be49812a830e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeather", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVar")
    def hue_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeatherVar"))

    @hue_feather_var.setter
    def hue_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a55275dd391dd7d1b2edb1024a1c0bc6ffd6d912e4b4f3024b46e2a835fb3f50)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueTolerance")
    def hue_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueTolerance"))

    @hue_tolerance.setter
    def hue_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__59a3f12eaa9478b7fa7c46c7990b0da96f6ff6f6e97c2f572e90decd7d5c5794)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVar")
    def hue_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueToleranceVar"))

    @hue_tolerance_var.setter
    def hue_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f7b3e829129bd323904d1e27260f6153d87b3819dabdaf2fddcbb95ea04122be)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__00d47ec49665ff01c75b80ab6c218abdf9fea1e11b39491e44c5c0178552c6fb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeather")
    def lightness_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeather"))

    @lightness_feather.setter
    def lightness_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6b8fa62bac9bc551ad08761f903d7e9dbde44758dd885a767786f1f64335937b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeather", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVar")
    def lightness_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeatherVar"))

    @lightness_feather_var.setter
    def lightness_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__75a4172bc41a2e94478ed93f056d2b6005e03c0a6791d1b23aa5e9a34d655b92)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessTolerance")
    def lightness_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessTolerance"))

    @lightness_tolerance.setter
    def lightness_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__03f8e19b563f3ac7fec96b566e7acce03bd1490c5fe8686b839d932c8c5b759d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVar")
    def lightness_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessToleranceVar"))

    @lightness_tolerance_var.setter
    def lightness_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1837d6349cf51dc59795ca7d2d85da5409467ad2594abaa78ecf372afd6ab7ef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeather")
    def saturation_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeather"))

    @saturation_feather.setter
    def saturation_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1bfd15781cba3f8869c5209535588c22d15d29602fad70bcffd7099720e11ff3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeather", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVar")
    def saturation_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeatherVar"))

    @saturation_feather_var.setter
    def saturation_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2083f389deb973a9651642ca9071f2c71ef7f1aba58ca501bff50fb01f270f51)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationTolerance")
    def saturation_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationTolerance"))

    @saturation_tolerance.setter
    def saturation_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6157abb4e7574946439067d545f04bae242ee77169b523ae28dcc46889e4f83c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVar")
    def saturation_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationToleranceVar"))

    @saturation_tolerance_var.setter
    def saturation_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ce6217558b961b3e7cb3ad5ee8b60c5337bc39a8b7c1d3d3d1ae1bbb11368b9e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeChromaKey]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeChromaKey]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeChromaKey]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d9dee5c70dca35db9a941cb3e48e58e174761bc039267e56314c86e048c782a4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeComposite",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "placement": "placement",
        "placement_var": "placementVar",
        "scale": "scale",
        "scale_dimension": "scaleDimension",
        "scale_dimension_var": "scaleDimensionVar",
        "scale_var": "scaleVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeComposite:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeCompositeImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        placement: typing.Optional[builtins.str] = None,
        placement_var: typing.Optional[builtins.str] = None,
        scale: typing.Optional[builtins.str] = None,
        scale_dimension: typing.Optional[builtins.str] = None,
        scale_dimension_var: typing.Optional[builtins.str] = None,
        scale_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param placement: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        :param placement_var: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        :param scale: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param scale_dimension: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        :param scale_dimension_var: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        :param scale_var: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        :param x_position: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeCompositeImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f9d62bb0375640936416b6ba8fe6a59869b982f6b933d5ab28d28eec3b55d2c)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument placement", value=placement, expected_type=type_hints["placement"])
            check_type(argname="argument placement_var", value=placement_var, expected_type=type_hints["placement_var"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument scale_dimension", value=scale_dimension, expected_type=type_hints["scale_dimension"])
            check_type(argname="argument scale_dimension_var", value=scale_dimension_var, expected_type=type_hints["scale_dimension_var"])
            check_type(argname="argument scale_var", value=scale_var, expected_type=type_hints["scale_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if placement is not None:
            self._values["placement"] = placement
        if placement_var is not None:
            self._values["placement_var"] = placement_var
        if scale is not None:
            self._values["scale"] = scale
        if scale_dimension is not None:
            self._values["scale_dimension"] = scale_dimension
        if scale_dimension_var is not None:
            self._values["scale_dimension_var"] = scale_dimension_var
        if scale_var is not None:
            self._values["scale_var"] = scale_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeCompositeImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeCompositeImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        '''
        result = self._values.get("placement")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement_var(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        '''
        result = self._values.get("placement_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        '''
        result = self._values.get("scale_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        '''
        result = self._values.get("scale_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        '''
        result = self._values.get("scale_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeComposite(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeCompositeImage",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeCompositeImage:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeCompositeImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeCompositeImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeCompositeImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__04b39c1d56853096df9a46df0632416c0655ad5ecb43357d7a9d29a04c9c0a7a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeCompositeImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeCompositeImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b45bdff48589ab0d0a8d06f3a74a55fb639079f27071b95b6f25ecae0b8cc1fa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeCompositeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeCompositeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__201b8e306e692c8425fd543150cde92377f26dc5e4fe353617fedc6243b9a5ec)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeCompositeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af7417ea4d65f45cb6ae5b8b787eebcea03931c0f305eeaaf03add5d8b48af7a)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeCompositeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4f3f31b3ffcc96bbed61b17d07a7cbdbb17d6a194412bd86c5e62e8616e72384)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd5339d8ab19a613055ad06b37b5f15ac1e26e6fb20d2c81adadea242597da97)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f5e592582fb4c1408cbbc02e7ce2fb50385dcb4b4c0ef357b387558226f52313)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeComposite]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeComposite]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__001c238c418d7fa96bfe35ebe3d5d507e931bea410b16dcf4a9db9a183a31ef6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeCompositeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeCompositeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ebe22f6dc9195d1c692558f6a2983db1a33feeecaea6f780c73c31997aa3cdc1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeCompositeImage()

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPlacement")
    def reset_placement(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacement", []))

    @jsii.member(jsii_name="resetPlacementVar")
    def reset_placement_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacementVar", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetScaleDimension")
    def reset_scale_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimension", []))

    @jsii.member(jsii_name="resetScaleDimensionVar")
    def reset_scale_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimensionVar", []))

    @jsii.member(jsii_name="resetScaleVar")
    def reset_scale_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeCompositeImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeCompositeImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeCompositeImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="placementInput")
    def placement_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementInput"))

    @builtins.property
    @jsii.member(jsii_name="placementVarInput")
    def placement_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionInput")
    def scale_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVarInput")
    def scale_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleVarInput")
    def scale_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b2c0a12e0b655100ec2f6e11115cc0fddbbee3f494df774c742d0a34e2a6d19a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__722f1f4bf1ac417bc690de7daea4c04a424d58b607b852ab028ca03873f1003d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="placement")
    def placement(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placement"))

    @placement.setter
    def placement(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5c10b80abb1857c44634adf960eb7da97237dbcf8600aaeca5c403cedec25c15)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placement", value)

    @builtins.property
    @jsii.member(jsii_name="placementVar")
    def placement_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placementVar"))

    @placement_var.setter
    def placement_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a8578a0f4233f7e2c7b4828c1018f12c4da82dfc41615cdca774e25b6a0149af)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placementVar", value)

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scale"))

    @scale.setter
    def scale(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d412f6586ac2920fc0c1acc47865498fce28064745d05ce4a4642667fdd9b02d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scale", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimension")
    def scale_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimension"))

    @scale_dimension.setter
    def scale_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__02e9abcd903520212c2c8d8a932ecd844c938eeebc4f0b27798b60e2d263e35f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimension", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVar")
    def scale_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimensionVar"))

    @scale_dimension_var.setter
    def scale_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d4c2d5a3bfe6c40826856e627bab2709d64de669b0bd45416e1d9934be09606c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="scaleVar")
    def scale_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleVar"))

    @scale_var.setter
    def scale_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__70d222bd6828416e5bba8e5843902c3b6ab7f50973ffe44f44efc64f0f144d3a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d8d5e7da1e1415d9d797d595fe07db6099d42fa7c73fa97061ae73c9e80e8c44)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ef64cc8f51beaf96def619669efccec17545e7d774cfc5c058a55255906eaac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__570f7d446b3ea3463ef26d4ddd934c28feb138468ef5ea4f8c76c82431f4cf38)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6cb094589df628ffbf100d81f18987bd42b3c5b590f398055e2242ebcdc18fac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeComposite]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeComposite]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeComposite]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d74acb86709fb353a9f993bd9d8b8dbc0e71cb8f1be889730a0728e18eda270)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeCompound",
    jsii_struct_bases=[],
    name_mapping={"transformations": "transformations"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeCompound:
    def __init__(
        self,
        *,
        transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param transformations: transformations block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__147cb92de3ea63dca754bde10ac6336c58a6f2a0b984aeffa09b9531953c7746)
            check_type(argname="argument transformations", value=transformations, expected_type=type_hints["transformations"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if transformations is not None:
            self._values["transformations"] = transformations

    @builtins.property
    def transformations(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeCompoundTransformations"]]]:
        '''transformations block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        result = self._values.get("transformations")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeCompoundTransformations"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeCompound(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeCompoundList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeCompoundList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cf2b4702d21844322ac42bedcd2f52d879137f9c7cbc8f37fa7a7381c25a06c8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeCompoundOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6a10c756df03de587a75e7f3983e3f972c67a1fce8260174c9acbae9a8abea44)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeCompoundOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f7039e521d7fbb0e20de7a4c3dd6e2e276fa772189c2ed6e1ae20f4ae42031f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__999441166c6e4fd1d8406dddecf6df5e77110a893fae0d238bcc99ec78625bfc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cb8fe9571fdebc7cdbab4aa98e3af2f19a561ae1c7850ca702f66bd3eaf2072d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeCompound]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeCompound]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__66ae16576ff009f46e0952175657d6c6073df75b3a7ab4f97d4786afcf588142)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeCompoundOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeCompoundOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__556de510affe892fa3577d9b5d225cad6cfb08354dbe2cbf7a72b053b2debaf5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformations")
    def put_transformations(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c81e4456a71da4b1669bde776b4552acdcb0a9a3a8234e6ce318e59a4a3a9234)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTransformations", [value]))

    @jsii.member(jsii_name="resetTransformations")
    def reset_transformations(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformations", []))

    @builtins.property
    @jsii.member(jsii_name="transformations")
    def transformations(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeCompoundTransformationsList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeCompoundTransformationsList", jsii.get(self, "transformations"))

    @builtins.property
    @jsii.member(jsii_name="transformationsInput")
    def transformations_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeCompoundTransformations"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeCompoundTransformations"]]], jsii.get(self, "transformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeCompound]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeCompound]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeCompound]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9264edc653cbbe8ef08721624014fd106a888c3dd6ece5db089e579ee674ae79)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeCompoundTransformations",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeCompoundTransformations:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeCompoundTransformations(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeCompoundTransformationsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeCompoundTransformationsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be8da6ad747adc549cc06378ba3c2ee873ebffe570d7f8fe1234770a03425b8c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeCompoundTransformationsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ff8aec2ef0c17cb2fcf6ad717a6f737e7d18fe42227fe8b248d84beaa15e357)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeCompoundTransformationsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__40c9aadcdf26fe2bbe5b755d520339b081e9ae7c8d579e390182b244392d6dfc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f848ccffe29787959bfd3cdef0be27b9b6c5effe38dff163a0bc5c7b632f5be6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fbf1a49c6d59d46d1066f170f48676bf675dda0f2b9b02d7ae3f150aa651458d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeCompoundTransformations]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeCompoundTransformations]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeCompoundTransformations]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__39559e61851579790eb067da16135c1d1927db8fc0b23d21c2527280da2a7180)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeCompoundTransformationsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeCompoundTransformationsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__855aaa308a8044e9c52a563278bd1f49171957ea8bb82f81895fbfe6e7f5f1ba)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeCompoundTransformations]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeCompoundTransformations]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeCompoundTransformations]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__27ca06ff19dda7153fa478e9772e7052fc55b7ca414e92265363560141df8ab5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeContrast",
    jsii_struct_bases=[],
    name_mapping={
        "brightness": "brightness",
        "brightness_var": "brightnessVar",
        "contrast": "contrast",
        "contrast_var": "contrastVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeContrast:
    def __init__(
        self,
        *,
        brightness: typing.Optional[builtins.str] = None,
        brightness_var: typing.Optional[builtins.str] = None,
        contrast: typing.Optional[builtins.str] = None,
        contrast_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param brightness: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        :param brightness_var: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        :param contrast: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param contrast_var: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1b608d57a9cd8b305518b58b048c4ab3327026906d3074bf1cac57df1977d08a)
            check_type(argname="argument brightness", value=brightness, expected_type=type_hints["brightness"])
            check_type(argname="argument brightness_var", value=brightness_var, expected_type=type_hints["brightness_var"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument contrast_var", value=contrast_var, expected_type=type_hints["contrast_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if brightness is not None:
            self._values["brightness"] = brightness
        if brightness_var is not None:
            self._values["brightness_var"] = brightness_var
        if contrast is not None:
            self._values["contrast"] = contrast
        if contrast_var is not None:
            self._values["contrast_var"] = contrast_var

    @builtins.property
    def brightness(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        '''
        result = self._values.get("brightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def brightness_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        '''
        result = self._values.get("brightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        result = self._values.get("contrast_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeContrast(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeContrastList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeContrastList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fc6d767529cc1d1197d5fab8e3ed8c7f5d20647f11c690bc8c33845f9b2a3d58)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeContrastOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1355f657716f8dfc0565b6d991ed3392bad9a6796e55d37cf66e9ab61a03d024)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeContrastOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fb175b279ac135aa2ad41161e8d35d85b5c41002ddfc61e4d973995009836eb8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cb44bc9692d6700d68b0efe255202949a3e0b32e5eb72087f1577044f4b15686)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f9341aebba22405c8d6306df28a98cb833f4e876f410d11a91602062dcc29b3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeContrast]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeContrast]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ce410c3f69c12051bcdca4bfc7517eec49783052ca56a5a4b4c79edee9f723e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeContrastOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeContrastOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__09eb692298dd4cff8b20e74b359d887bd00ab41a9788cefae43f0f65fae78678)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetBrightness")
    def reset_brightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightness", []))

    @jsii.member(jsii_name="resetBrightnessVar")
    def reset_brightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightnessVar", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetContrastVar")
    def reset_contrast_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrastVar", []))

    @builtins.property
    @jsii.member(jsii_name="brightnessInput")
    def brightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="brightnessVarInput")
    def brightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastVarInput")
    def contrast_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="brightness")
    def brightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightness"))

    @brightness.setter
    def brightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__548c0a53ffda8c6c03828a4aacd7a0df0178e3882c053c6b74f2fb46a0daa3f7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightness", value)

    @builtins.property
    @jsii.member(jsii_name="brightnessVar")
    def brightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightnessVar"))

    @brightness_var.setter
    def brightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d82eca81331d5c161fcd3d14e1c4e62fceefd42777ad6e1206394536dd70224)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrast"))

    @contrast.setter
    def contrast(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d2b21cdc39d45c7935a10595e26866a53a0f98179c4a3b5e4e4f0c0355a4e14)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrast", value)

    @builtins.property
    @jsii.member(jsii_name="contrastVar")
    def contrast_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrastVar"))

    @contrast_var.setter
    def contrast_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0eef0acf52168596955c0c72ea65a19256c1aa1509c329320c07ef37fe2200a5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrastVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeContrast]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeContrast]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeContrast]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ddb02eb79591e39bbae96d30f7a73777b6f625696ede8589b3d5acad73f94115)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeGoop",
    jsii_struct_bases=[],
    name_mapping={
        "chaos": "chaos",
        "chaos_var": "chaosVar",
        "density": "density",
        "density_var": "densityVar",
        "power": "power",
        "power_var": "powerVar",
        "seed": "seed",
        "seed_var": "seedVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeGoop:
    def __init__(
        self,
        *,
        chaos: typing.Optional[builtins.str] = None,
        chaos_var: typing.Optional[builtins.str] = None,
        density: typing.Optional[builtins.str] = None,
        density_var: typing.Optional[builtins.str] = None,
        power: typing.Optional[builtins.str] = None,
        power_var: typing.Optional[builtins.str] = None,
        seed: typing.Optional[builtins.str] = None,
        seed_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param chaos: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        :param chaos_var: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        :param density: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        :param density_var: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        :param power: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        :param power_var: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        :param seed: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        :param seed_var: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__73241696744707bedd6b86549b574ed5105b2062e65dd16482c09c8f1c015975)
            check_type(argname="argument chaos", value=chaos, expected_type=type_hints["chaos"])
            check_type(argname="argument chaos_var", value=chaos_var, expected_type=type_hints["chaos_var"])
            check_type(argname="argument density", value=density, expected_type=type_hints["density"])
            check_type(argname="argument density_var", value=density_var, expected_type=type_hints["density_var"])
            check_type(argname="argument power", value=power, expected_type=type_hints["power"])
            check_type(argname="argument power_var", value=power_var, expected_type=type_hints["power_var"])
            check_type(argname="argument seed", value=seed, expected_type=type_hints["seed"])
            check_type(argname="argument seed_var", value=seed_var, expected_type=type_hints["seed_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if chaos is not None:
            self._values["chaos"] = chaos
        if chaos_var is not None:
            self._values["chaos_var"] = chaos_var
        if density is not None:
            self._values["density"] = density
        if density_var is not None:
            self._values["density_var"] = density_var
        if power is not None:
            self._values["power"] = power
        if power_var is not None:
            self._values["power_var"] = power_var
        if seed is not None:
            self._values["seed"] = seed
        if seed_var is not None:
            self._values["seed_var"] = seed_var

    @builtins.property
    def chaos(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        '''
        result = self._values.get("chaos")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def chaos_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        '''
        result = self._values.get("chaos_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        '''
        result = self._values.get("density")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density_var(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        '''
        result = self._values.get("density_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        '''
        result = self._values.get("power")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power_var(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        '''
        result = self._values.get("power_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        '''
        result = self._values.get("seed")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed_var(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        result = self._values.get("seed_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeGoop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeGoopList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeGoopList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__14cca1d59b0ea9ecf474cfcc7442ef0e760682c172a7799f35526055dddb5f85)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeGoopOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d7af76d8d0b8e71b861023a9298b7f2e1ef381e2b2550c4e9cbadbca17cfeb60)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeGoopOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ac51ad6a589595c3b8a441624231edf9e528b7924b58b8abd9a1d417e1bc403)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3304b92a1248f52e1e04e4638b85b805ce2e14875d5e0b989d12553b4da85e1f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d00d3c2e1c2e78fc9d36e8d0354f22fb5785b4788e8405a3010edf372868f6e8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeGoop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeGoop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc0e61e2b3e4f8631809e8b187251b9a35ac9aed8fab6f3a9e35c1564bf3e328)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeGoopOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeGoopOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd546f095e75ec354e3ef37d94ae3f6d3c3071e2dfce6d38df273439116d4464)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetChaos")
    def reset_chaos(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaos", []))

    @jsii.member(jsii_name="resetChaosVar")
    def reset_chaos_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaosVar", []))

    @jsii.member(jsii_name="resetDensity")
    def reset_density(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensity", []))

    @jsii.member(jsii_name="resetDensityVar")
    def reset_density_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensityVar", []))

    @jsii.member(jsii_name="resetPower")
    def reset_power(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPower", []))

    @jsii.member(jsii_name="resetPowerVar")
    def reset_power_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPowerVar", []))

    @jsii.member(jsii_name="resetSeed")
    def reset_seed(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeed", []))

    @jsii.member(jsii_name="resetSeedVar")
    def reset_seed_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeedVar", []))

    @builtins.property
    @jsii.member(jsii_name="chaosInput")
    def chaos_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosInput"))

    @builtins.property
    @jsii.member(jsii_name="chaosVarInput")
    def chaos_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosVarInput"))

    @builtins.property
    @jsii.member(jsii_name="densityInput")
    def density_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityInput"))

    @builtins.property
    @jsii.member(jsii_name="densityVarInput")
    def density_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="powerInput")
    def power_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerInput"))

    @builtins.property
    @jsii.member(jsii_name="powerVarInput")
    def power_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerVarInput"))

    @builtins.property
    @jsii.member(jsii_name="seedInput")
    def seed_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedInput"))

    @builtins.property
    @jsii.member(jsii_name="seedVarInput")
    def seed_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedVarInput"))

    @builtins.property
    @jsii.member(jsii_name="chaos")
    def chaos(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaos"))

    @chaos.setter
    def chaos(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__99731487c23e6782860d78e4652249788e964fe2bb709ca6d89d7ccd7962e39b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaos", value)

    @builtins.property
    @jsii.member(jsii_name="chaosVar")
    def chaos_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaosVar"))

    @chaos_var.setter
    def chaos_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5da64d9d5723d57f42cd93c27191d52b66b562198630d53304c5b4c97a18ae38)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaosVar", value)

    @builtins.property
    @jsii.member(jsii_name="density")
    def density(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "density"))

    @density.setter
    def density(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1041ad48de9b04595477cb3043c480b6e12a9b4192ee85c4cdb0c9f6b4cea74a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "density", value)

    @builtins.property
    @jsii.member(jsii_name="densityVar")
    def density_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "densityVar"))

    @density_var.setter
    def density_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2305ce9489cadd3a8eee0f42629477cd831f582a4ec1fc24c2d20cd694f73d0a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "densityVar", value)

    @builtins.property
    @jsii.member(jsii_name="power")
    def power(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "power"))

    @power.setter
    def power(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e34182cf049843a6d135b269ee3d638bedd1cb2eb18c25b48ba44102cab013a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "power", value)

    @builtins.property
    @jsii.member(jsii_name="powerVar")
    def power_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "powerVar"))

    @power_var.setter
    def power_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__026ffa44045475c6fb079437c922e2cdd3dda8bc1cd901166853b1a534beb0c2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "powerVar", value)

    @builtins.property
    @jsii.member(jsii_name="seed")
    def seed(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seed"))

    @seed.setter
    def seed(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7f235d5a72b1260f534f26afa617219ccf9c93fa40e354d988ee2b6e48ee94ad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seed", value)

    @builtins.property
    @jsii.member(jsii_name="seedVar")
    def seed_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seedVar"))

    @seed_var.setter
    def seed_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6c89f5d3781e27b11eefa271451fc72537f86c888ed410ed286269f838330dc6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seedVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeGoop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeGoop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeGoop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1289c860234a7a041d9475b44bcdaa14dc382db34f570aa77ff7056a31d5acd5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeGrayscale",
    jsii_struct_bases=[],
    name_mapping={"type": "type", "type_var": "typeVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeGrayscale:
    def __init__(
        self,
        *,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param type: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__96a97217be0abe142dc5939da63bbfcca0363b1b138b493259a43665524394d9)
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeGrayscale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeGrayscaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeGrayscaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2481ab766ae1b89b52acca0d0d21c61fc007846038a4cd176ddaab1ef03cac3c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeGrayscaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b69b09bc223593c8d73bf9b29f4309efa06fa9e1cc9eac394d3e46f1bbc4448a)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeGrayscaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f8c380ed17bf04dbec1b1791e5d4c5ca1d97cd963842ad511423f3a966fadd0f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c50b531a187897f40d6b979319aeb319919d864a4e9e8d1ceeb563a9911b5835)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5d0c074bfb0b291dbf97cf3a838761afb943748e2bb03f14a5384b3409e85753)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeGrayscale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeGrayscale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f1c125aaa64e6a7eaa5d9db1585c60e09df4d4e3552696e1bcd3cdceb1892cb0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeGrayscaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeGrayscaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6bcf0b627e33323f50299abd158d5aed96fa7d3ad5fd4968eff62c779b6c7f1c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__819e8b63dbd385d083ea9dab3f7cc7c7e9726b93b7d8076cc704ac99edfac448)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d44cfc712b88ebd5ab0811ca7d2c3522a1f3091dbcfd64e29abab317ad879378)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeGrayscale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeGrayscale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeGrayscale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f63428f6f1ef6b4582de6deab75d750fd11b8d686b8918e602412621b6e9dec9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeHsl",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "lightness": "lightness",
        "lightness_var": "lightnessVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeHsl:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness: typing.Optional[builtins.str] = None,
        lightness_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        :param lightness_var: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a84119a0e3c295535c0cc21cc3291f4aa7fe13386633cf38e322224dd23118f4)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness", value=lightness, expected_type=type_hints["lightness"])
            check_type(argname="argument lightness_var", value=lightness_var, expected_type=type_hints["lightness_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness is not None:
            self._values["lightness"] = lightness
        if lightness_var is not None:
            self._values["lightness_var"] = lightness_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        '''
        result = self._values.get("lightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        '''
        result = self._values.get("lightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeHsl(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeHslList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeHslList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a10c74d5391a17437db815b13f998890a915bb682a805bba58f67c72559e3634)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeHslOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5cb881f8ebedab9f7ccdb1140e0a66269f2a3732de1f723c714069f47315097c)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeHslOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f0fd67e8c4fd47de94ec14c3535cf6c7265ed4d35205b8256faa51169b6798a4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aae2cbd93ce3ea237b5fbcd7a6da9db78e83df0d30a28e5a6edca44c7a8b5f1d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__000525fb416a4febc890526a04cae4f8fb85fba827fd5b81d2999fee71fc07fd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeHsl]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeHsl]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__22b61bc8b4af2ebb25b11d058397123e083709331d14613b8758132574ed87b2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeHslOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeHslOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a81769d18d3b85f47b5e99ac423b79867e2503cfcc2f60c82efa095b90b138a5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightness")
    def reset_lightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightness", []))

    @jsii.member(jsii_name="resetLightnessVar")
    def reset_lightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessInput")
    def lightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessVarInput")
    def lightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e92c4bd85b16dd2e251f1f18c2e05e32fd6c8978a1beb31ef3a25b4d15bef5d8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__388b3fceca8e6a4b0dce93da7ab98f2c0b8fc85ba341bde045495ac5b4f37cf0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightness")
    def lightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightness"))

    @lightness.setter
    def lightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__82ce1783e6b9b396b6281377711c348b5d4313747bbd57a098e7a556bfe2d885)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightness", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessVar")
    def lightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessVar"))

    @lightness_var.setter
    def lightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0789da31a049456cf14006d0479173c1747790ae8f78f90bb17ab81b479f5b61)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ae4a6c1f470994c23fd5431a72f03d2f33bb4378dd1710e99f2f617a60f5c15)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b4f33e2f8c7335e1db2d0b948a0f5cf7f6eb626cf3f6f33ad5b49383dc2fb40b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeHsl]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeHsl]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeHsl]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4bc0a524060c16d09cc1a2367935dde627c3365ccf2a439dd4a353ab1777aa2a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeHsv",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeHsv:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        :param value: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8b512854e4e497f7a4466a61a6738e6cadcb660b204f4ff5f7b4b2c98f442710)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeHsv(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeHsvList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeHsvList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bbd436b6315817bee9759627112b7c881d772ed3618b12d609a06eb0d4013b0f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeHsvOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__79c05174d09f1a47912aeccc6cd9e665ea39e4cc54bc4c050a1bc1296329266e)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeHsvOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0d325d83f093035a4dd431af30ec02aed90233518c0fb2df81c97410f563be0f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b60ff1f28d325b22852311fb0bed9b5580292b84600137d66d148363308e2dd1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__44e91013745cfc26951122ecb423b6a6d48c730b79510152cca1daaf68369e63)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeHsv]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeHsv]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__35399f0cbd79d1d5f659a1c3873e9cd9aa840466fbbe39f857c6900cbba90aac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeHsvOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeHsvOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__550709f8d1ac75839c3c3ec10f77edde8edb7bcba2a9d7daafe9fa8e59fb55a5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b39676c323b115a03e58d16bebe43644834d2e819863b511e15a1b530d3442d7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7b016ced2af960699a3f11075f74a68bb679f351e043c237789fdb6f0b7d196a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ef5c8eea160f366b85f049578c40f9f77e4fcc4322d58de219f8a49687e098f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ce75fd6d084b29aeb8831612fefac4ffb19fc329159948c0a08598203ccaa846)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eaa20aaca15eda8fb84cfea7252dc99e49afbfc2a6b85ef7e8c1c55773eb8829)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be20827b873bfcd2ac7ef4672899fc5c3018f2984ecc7b4e2fabd847b98bf4a2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeHsv]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeHsv]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeHsv]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7a290dc3d5343d6ea1de1fecd50ee26a651df4fa7a17816a118dab4ed2e2fe9b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimension",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "dimension": "dimension",
        "dimension_var": "dimensionVar",
        "equal": "equal",
        "greater_than": "greaterThan",
        "less_than": "lessThan",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimension:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        dimension: typing.Optional[builtins.str] = None,
        dimension_var: typing.Optional[builtins.str] = None,
        equal: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionEqual", typing.Dict[builtins.str, typing.Any]]] = None,
        greater_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionGreaterThan", typing.Dict[builtins.str, typing.Any]]] = None,
        less_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionLessThan", typing.Dict[builtins.str, typing.Any]]] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param dimension: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        :param dimension_var: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        :param equal: equal block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        :param greater_than: greater_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        :param less_than: less_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        :param value: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionDefault(**default)
        if isinstance(equal, dict):
            equal = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionEqual(**equal)
        if isinstance(greater_than, dict):
            greater_than = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionGreaterThan(**greater_than)
        if isinstance(less_than, dict):
            less_than = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionLessThan(**less_than)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7eac17c62ff0c531e766df9a84b0f8e107c776be7bb8b12ea8abf6ffba4e8166)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument dimension", value=dimension, expected_type=type_hints["dimension"])
            check_type(argname="argument dimension_var", value=dimension_var, expected_type=type_hints["dimension_var"])
            check_type(argname="argument equal", value=equal, expected_type=type_hints["equal"])
            check_type(argname="argument greater_than", value=greater_than, expected_type=type_hints["greater_than"])
            check_type(argname="argument less_than", value=less_than, expected_type=type_hints["less_than"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if dimension is not None:
            self._values["dimension"] = dimension
        if dimension_var is not None:
            self._values["dimension_var"] = dimension_var
        if equal is not None:
            self._values["equal"] = equal
        if greater_than is not None:
            self._values["greater_than"] = greater_than
        if less_than is not None:
            self._values["less_than"] = less_than
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionDefault"], result)

    @builtins.property
    def dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        '''
        result = self._values.get("dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        '''
        result = self._values.get("dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def equal(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionEqual"]:
        '''equal block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        '''
        result = self._values.get("equal")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionEqual"], result)

    @builtins.property
    def greater_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionGreaterThan"]:
        '''greater_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        '''
        result = self._values.get("greater_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionGreaterThan"], result)

    @builtins.property
    def less_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionLessThan"]:
        '''less_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        '''
        result = self._values.get("less_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionLessThan"], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimension(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7cb38b1cd5e363c9e03dac52a0fd5bc95aa0dfaf0001334e756510ad97e12097)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__236a635f662c35e67633ae9f9bf0ec810684ac6cde3ece4e15716f35a06a3eb5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionEqual",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionEqual:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionEqual(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionEqualOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionEqualOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a20ce681c64df6bee425521b11a72ae813872687dc0f958325927269f753de8c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionEqual], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionEqual],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e3a504cc45c127195453d34ac8da3a45cba9440e7779c5ae756c63b9fad7db66)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionGreaterThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionGreaterThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionGreaterThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionGreaterThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionGreaterThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5939f89e9afa131030ae561dec519c1ed6a4a628e28e34cd8e3050999c056bd4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionGreaterThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionGreaterThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cb8c03062999040648e3cdb1d63d24c21c0760bfcbfba357d55337436105e56a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionLessThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionLessThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionLessThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionLessThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionLessThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0aa2d80af39a57a126d65712b7764e79328b4ddc3202a73fe0b0f753125bd0d6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionLessThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionLessThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c70b9c9557e22482bdcb17865c10a229b492901195efef7bb213ec38b7d2cdbc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__52722f743aa41c1842c473b076850ad2facdff94be38eaecd8cca02409241e42)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5bc0cf97534996ea75a7748066d7c33bf242d644dce5275390ecd3a05c179cd1)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__362a90da41225d6d3528636712cb4fe38af0ace44daf1cb46bf2feb8a94deeeb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a2fa85450acade0e2d00e4c4b3f1ca15829d81899f278be17e6d84ad1d74eebc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__535545b713a55bbfd15429685d43ac699a9cf70d4621c82c20fbe47d1d93fca6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimension]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimension]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8d46230e9550898df41cf085176d784fd37c71ff6292231f2c92e89755d79b7d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f22d6d9cf158a668bda620636167644bad42ba233e336f5f85d91d5be9e5ac7d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putEqual")
    def put_equal(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionEqual()

        return typing.cast(None, jsii.invoke(self, "putEqual", [value]))

    @jsii.member(jsii_name="putGreaterThan")
    def put_greater_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionGreaterThan()

        return typing.cast(None, jsii.invoke(self, "putGreaterThan", [value]))

    @jsii.member(jsii_name="putLessThan")
    def put_less_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionLessThan()

        return typing.cast(None, jsii.invoke(self, "putLessThan", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetDimension")
    def reset_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimension", []))

    @jsii.member(jsii_name="resetDimensionVar")
    def reset_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimensionVar", []))

    @jsii.member(jsii_name="resetEqual")
    def reset_equal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEqual", []))

    @jsii.member(jsii_name="resetGreaterThan")
    def reset_greater_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGreaterThan", []))

    @jsii.member(jsii_name="resetLessThan")
    def reset_less_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLessThan", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="equal")
    def equal(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionEqualOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionEqualOutputReference, jsii.get(self, "equal"))

    @builtins.property
    @jsii.member(jsii_name="greaterThan")
    def greater_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionGreaterThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionGreaterThanOutputReference, jsii.get(self, "greaterThan"))

    @builtins.property
    @jsii.member(jsii_name="lessThan")
    def less_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionLessThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionLessThanOutputReference, jsii.get(self, "lessThan"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionInput")
    def dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionVarInput")
    def dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="equalInput")
    def equal_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionEqual], jsii.get(self, "equalInput"))

    @builtins.property
    @jsii.member(jsii_name="greaterThanInput")
    def greater_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionGreaterThan], jsii.get(self, "greaterThanInput"))

    @builtins.property
    @jsii.member(jsii_name="lessThanInput")
    def less_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionLessThan], jsii.get(self, "lessThanInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="dimension")
    def dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimension"))

    @dimension.setter
    def dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ad02f2058321594d46ab2dd327a86ea110e867f813cbcf226ee0e28462ac1282)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimension", value)

    @builtins.property
    @jsii.member(jsii_name="dimensionVar")
    def dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimensionVar"))

    @dimension_var.setter
    def dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__30093dd6f3ca3cf228723090ee87ae6a8e7f1661847a304378f3bf7a3f00ed92)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__80d5a3bed71f55feade1fa1c08b9e817e334a462ade6c5429abc62eef949dafd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__09ddc0fee2481d1cc2920c303cb43b8e37e90a8afddc6354043e1c8ea7ac06e8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimension]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimension]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimension]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__adc014294237e7627dbb254f3407c6be7b826bd63616f15fb690c13a4a61847a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientation",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "landscape": "landscape",
        "portrait": "portrait",
        "square": "square",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientation:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        landscape: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationLandscape", typing.Dict[builtins.str, typing.Any]]] = None,
        portrait: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationPortrait", typing.Dict[builtins.str, typing.Any]]] = None,
        square: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationSquare", typing.Dict[builtins.str, typing.Any]]] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param landscape: landscape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        :param portrait: portrait block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        :param square: square block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationDefault(**default)
        if isinstance(landscape, dict):
            landscape = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationLandscape(**landscape)
        if isinstance(portrait, dict):
            portrait = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationPortrait(**portrait)
        if isinstance(square, dict):
            square = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationSquare(**square)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c33a299a7b5d602f48c510cf7f4c423faa3962fbf813f3bf9ff2e09bdedc1311)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument landscape", value=landscape, expected_type=type_hints["landscape"])
            check_type(argname="argument portrait", value=portrait, expected_type=type_hints["portrait"])
            check_type(argname="argument square", value=square, expected_type=type_hints["square"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if landscape is not None:
            self._values["landscape"] = landscape
        if portrait is not None:
            self._values["portrait"] = portrait
        if square is not None:
            self._values["square"] = square

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationDefault"], result)

    @builtins.property
    def landscape(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationLandscape"]:
        '''landscape block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        '''
        result = self._values.get("landscape")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationLandscape"], result)

    @builtins.property
    def portrait(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationPortrait"]:
        '''portrait block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        '''
        result = self._values.get("portrait")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationPortrait"], result)

    @builtins.property
    def square(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationSquare"]:
        '''square block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        result = self._values.get("square")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationSquare"], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8f1f14e3086335f377eccc7f2b938cdbba6ac90d80d15bba74fd6782751935b8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b26bb208fb3b3b6698a691f11a45cb301139e9950916b2dff228ea3541f60d84)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationLandscape",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationLandscape:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationLandscape(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationLandscapeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationLandscapeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f1559038320b0a8154446f3ff540dfe235a86541fab5309d5cec0e72931b8d24)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationLandscape], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationLandscape],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1d677621409f2d628ab4affdb095c58b99119870bcdef7fbcbb4480f93695a34)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dfc3028ac1ea7b7b4f725e50dedfa833768b9e8b500e1aca34244fc6c387caf9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1538bc38af6d35c94e93501d6d3ac2896ba44c91b8a3b0cc28ad030d748c5fb5)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be8fb21f5b90994e85356036447dccd764432f4d90cbba89efdef40443744a19)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c201ada4099b318a16b45452344254b6d39a45d5ba28b6306ea610461e91f726)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d057303da46f2c27017acf37caff124cc4dcdaeec4fa3427defc2f5100178e33)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientation]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientation]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb9c42b6fc429e7095b740a0cf5a12c4765c0d1cc7054f3366e5309fb243a2ad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c94b4a8c65ed5328d7ff6bcd37e9bec06143547cc2afb3e8d9873c22ff1581e8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putLandscape")
    def put_landscape(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationLandscape()

        return typing.cast(None, jsii.invoke(self, "putLandscape", [value]))

    @jsii.member(jsii_name="putPortrait")
    def put_portrait(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationPortrait()

        return typing.cast(None, jsii.invoke(self, "putPortrait", [value]))

    @jsii.member(jsii_name="putSquare")
    def put_square(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationSquare()

        return typing.cast(None, jsii.invoke(self, "putSquare", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetLandscape")
    def reset_landscape(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLandscape", []))

    @jsii.member(jsii_name="resetPortrait")
    def reset_portrait(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPortrait", []))

    @jsii.member(jsii_name="resetSquare")
    def reset_square(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSquare", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="landscape")
    def landscape(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationLandscapeOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationLandscapeOutputReference, jsii.get(self, "landscape"))

    @builtins.property
    @jsii.member(jsii_name="portrait")
    def portrait(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationPortraitOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationPortraitOutputReference", jsii.get(self, "portrait"))

    @builtins.property
    @jsii.member(jsii_name="square")
    def square(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationSquareOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationSquareOutputReference", jsii.get(self, "square"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="landscapeInput")
    def landscape_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationLandscape], jsii.get(self, "landscapeInput"))

    @builtins.property
    @jsii.member(jsii_name="portraitInput")
    def portrait_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationPortrait"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationPortrait"], jsii.get(self, "portraitInput"))

    @builtins.property
    @jsii.member(jsii_name="squareInput")
    def square_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationSquare"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationSquare"], jsii.get(self, "squareInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientation]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientation]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientation]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fc2524f932284fef6c7838f618e4c0e0d719265c43c5b1e9a30c5dd728857f3c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationPortrait",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationPortrait:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationPortrait(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationPortraitOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationPortraitOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__089ecb4b169e82ac097c347a23b9017584926bc827d35f7729ce47775d70eac2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationPortrait]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationPortrait], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationPortrait],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c049c5e3e6e3d2bb4a873856f6694e3db94fab3f0aa6e2c2b0372502401d2193)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationSquare",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationSquare:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationSquare(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationSquareOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationSquareOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__96ec7481ae4fc3475927b1c2fa53ccce6279dfd59dbed18be198f19a50b80519)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationSquare]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationSquare], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationSquare],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__672db176c2a94d780de80c6e8d6c5fbb9276276a57721ecdab0da05d0a57f3b1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeMaxColors",
    jsii_struct_bases=[],
    name_mapping={"colors": "colors", "colors_var": "colorsVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeMaxColors:
    def __init__(
        self,
        *,
        colors: typing.Optional[builtins.str] = None,
        colors_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param colors: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        :param colors_var: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ca3831d0b041c6522c2b186e2986fe129199da4e582938267fc08bbaa68ba7a)
            check_type(argname="argument colors", value=colors, expected_type=type_hints["colors"])
            check_type(argname="argument colors_var", value=colors_var, expected_type=type_hints["colors_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if colors is not None:
            self._values["colors"] = colors
        if colors_var is not None:
            self._values["colors_var"] = colors_var

    @builtins.property
    def colors(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        '''
        result = self._values.get("colors")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def colors_var(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        result = self._values.get("colors_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeMaxColors(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeMaxColorsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeMaxColorsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9303ece5ad27896493ef0ef6b28985531b82daa049556ea4c5c851dc32f30ed2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeMaxColorsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a8aab7629ce92433f6ed3f21d0f5116124e2bcf8bd9d5a2463014b0c6d8f6a01)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeMaxColorsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7fad49420ef49fd5c3179335cc328e90dbb2398bb4a31630942ffa7ea05929ad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__638f48ff648b0b351b3ac8cc37b313a18013ad1be7754c89ec0e9053b09bc5bd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__532c8d22ffe1bbbab2bd8cbf041fc79edacde068df532b8762fda667f6c835dc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeMaxColors]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeMaxColors]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e9c313facf048a1de0b2b66722aeb3571ec68eaa347496ef0b8d36d707aca354)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeMaxColorsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeMaxColorsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0bc7fcc6fe0a1bee223672d8fa168e7c7b728418049782bad81eb83e48c34c69)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColors")
    def reset_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColors", []))

    @jsii.member(jsii_name="resetColorsVar")
    def reset_colors_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorsVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorsInput")
    def colors_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsInput"))

    @builtins.property
    @jsii.member(jsii_name="colorsVarInput")
    def colors_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsVarInput"))

    @builtins.property
    @jsii.member(jsii_name="colors")
    def colors(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colors"))

    @colors.setter
    def colors(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__01559e54df58b0d58624de427f599d60d8acc8619374e25d767cdc080aa249e0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colors", value)

    @builtins.property
    @jsii.member(jsii_name="colorsVar")
    def colors_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorsVar"))

    @colors_var.setter
    def colors_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f4d6aa62b82d1fef60688d2e75d7bbf37511e7efd41ffd2d8def17a709f54f47)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorsVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeMaxColors]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeMaxColors]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeMaxColors]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c669ec149ac11f5f086c79758f957c4ae89bd7876e036c39060dc934392a580c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeMirror",
    jsii_struct_bases=[],
    name_mapping={
        "horizontal": "horizontal",
        "horizontal_var": "horizontalVar",
        "vertical": "vertical",
        "vertical_var": "verticalVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeMirror:
    def __init__(
        self,
        *,
        horizontal: typing.Optional[builtins.str] = None,
        horizontal_var: typing.Optional[builtins.str] = None,
        vertical: typing.Optional[builtins.str] = None,
        vertical_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param horizontal: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        :param horizontal_var: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        :param vertical: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        :param vertical_var: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__770eedd9321b192322257ea1cb1d57dd514e50239119df1a6827dd5226ea6279)
            check_type(argname="argument horizontal", value=horizontal, expected_type=type_hints["horizontal"])
            check_type(argname="argument horizontal_var", value=horizontal_var, expected_type=type_hints["horizontal_var"])
            check_type(argname="argument vertical", value=vertical, expected_type=type_hints["vertical"])
            check_type(argname="argument vertical_var", value=vertical_var, expected_type=type_hints["vertical_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if horizontal is not None:
            self._values["horizontal"] = horizontal
        if horizontal_var is not None:
            self._values["horizontal_var"] = horizontal_var
        if vertical is not None:
            self._values["vertical"] = vertical
        if vertical_var is not None:
            self._values["vertical_var"] = vertical_var

    @builtins.property
    def horizontal(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        '''
        result = self._values.get("horizontal")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def horizontal_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        '''
        result = self._values.get("horizontal_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        '''
        result = self._values.get("vertical")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        result = self._values.get("vertical_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeMirror(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeMirrorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeMirrorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3517fd63ba865e697e761e5656422708cd9460bba1af833bef25620438066a90)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeMirrorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__033b6884a44bc68a196943477cec8145b174fec8e96fc1f5f4bf0c76b69893e7)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeMirrorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f73482f12e4f0dfcc4504964d76cb19ca348854a80e676e12811e0e1ca80922e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ef7f45a3d7481705250f45fe50ed51ac44a6f1424c80530672c0394bf87a3f51)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd825eeeb26309c348aeacdc247d13c786eee74aacac6d94a3443ea887baeba4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeMirror]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeMirror]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a86429fb2203636d0c917df4d7e67d54d937fd4b0b2cf6da9757d6253a5e66ff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeMirrorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeMirrorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b13bf1f354f6ae31ce833693ca0a3fbf0edb610046ded141cdf009071573a710)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHorizontal")
    def reset_horizontal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontal", []))

    @jsii.member(jsii_name="resetHorizontalVar")
    def reset_horizontal_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontalVar", []))

    @jsii.member(jsii_name="resetVertical")
    def reset_vertical(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVertical", []))

    @jsii.member(jsii_name="resetVerticalVar")
    def reset_vertical_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVerticalVar", []))

    @builtins.property
    @jsii.member(jsii_name="horizontalInput")
    def horizontal_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontalVarInput")
    def horizontal_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalInput")
    def vertical_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalVarInput")
    def vertical_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontal")
    def horizontal(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontal"))

    @horizontal.setter
    def horizontal(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8051be3db28cd176716f8dc76b80a32b746a7d835dc349ff7c90bfad243be456)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontal", value)

    @builtins.property
    @jsii.member(jsii_name="horizontalVar")
    def horizontal_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontalVar"))

    @horizontal_var.setter
    def horizontal_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__540c5ac5ee62d729fc42b56ab167454843ba6172721de44ce5869bea7af2ac6a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontalVar", value)

    @builtins.property
    @jsii.member(jsii_name="vertical")
    def vertical(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "vertical"))

    @vertical.setter
    def vertical(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__254558dea48a7006a3034f20ea227f426dae6448a74f32d09e2f16bb9ff64e93)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "vertical", value)

    @builtins.property
    @jsii.member(jsii_name="verticalVar")
    def vertical_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "verticalVar"))

    @vertical_var.setter
    def vertical_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d6ee9d6a2ce60491d264310e58d32ce4908063d2e642a91ca9f9290f9bbde16c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "verticalVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeMirror]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeMirror]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeMirror]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d2940dddcf2f08e1ef2854ebb51c39c4ec3396672fb19e38dc47103b70034e6a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeMonoHue",
    jsii_struct_bases=[],
    name_mapping={"hue": "hue", "hue_var": "hueVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeMonoHue:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2c58672ad636ec89269c297fa50e0c9bdefdb4b74d12bb001942f85a6583620c)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeMonoHue(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeMonoHueList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeMonoHueList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__441fc98d17d2573ab7663914bd079e0a9cb8d6525067ace40437ae3690a05f7c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeMonoHueOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e79f409ab1cd82cd56b41e4f1d9b7228f8b3ead2a3685e76c8a0f2d9418b82aa)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeMonoHueOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__973692339be75ade37c462c318a6aa326c072cfda85ab1b90916d8f799766404)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b8862ae0129477d3d52081fdcec2e647ec4523dd567868bc06b1fd89233780db)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a888305e04e6d213bb52cf6da8a6a7f01926684e537775cc51bb08f819e54e9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeMonoHue]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeMonoHue]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4dc8fe0d48605f70dfede4f01dc1beed86c603aa2bbec0d948f244b1685640e3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeMonoHueOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeMonoHueOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a47189224cb811b214f3ffe4af113d2e733dd056ec1b489b7968e4fa00c348bf)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c7a851a2ee3a8c7bcea632fdeb6c9677d7bf456df2ff579c0e0bce82e6e3bc2a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9abafbc7cee6bcefea0dffc96467867f870f93f68d0d0df312ec9e1b27b81766)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeMonoHue]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeMonoHue]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeMonoHue]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__62e7f98b5850442bd2871451bdfd7e39c233f3004a64a23e6b2cc09684888849)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeOpacity",
    jsii_struct_bases=[],
    name_mapping={"opacity": "opacity", "opacity_var": "opacityVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeOpacity:
    def __init__(
        self,
        *,
        opacity: typing.Optional[builtins.str] = None,
        opacity_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param opacity: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param opacity_var: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8e1d6cc7056cb735d731ee3cc3114c51f1ce4aba9f355c41af49f55b9a384283)
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument opacity_var", value=opacity_var, expected_type=type_hints["opacity_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if opacity is not None:
            self._values["opacity"] = opacity
        if opacity_var is not None:
            self._values["opacity_var"] = opacity_var

    @builtins.property
    def opacity(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def opacity_var(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        result = self._values.get("opacity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeOpacity(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeOpacityList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeOpacityList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e07e93c77c6570042d12f8262696a845185c93c2bd3dee6746fb6b0b3ae1f662)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeOpacityOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6c4119bf6d52dc5bf1f60e12fea50cc8d937e9f305aa66494879fd79c35a9c4f)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeOpacityOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__54828574b00474e0c0b3547505930cb8b60846c5b36a72fe8ee491ddd8afd2fe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f701a35668e6669ebb2717897b62a9c3591ff4df6f82e14b662de972807295f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7f763978f3f239056e10d3920517b6ce6af2a1687c9c995c73d3f86629c1d274)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeOpacity]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeOpacity]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__daa29a8c430d9a60168968acedcd384ea0a9e4ce6ab0487a54c9fd742acc4814)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeOpacityOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeOpacityOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5b000443e20b3fd79cb1c20610ef3e594ad0d2bfcdee8d47d7ad6733400a6c17)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetOpacityVar")
    def reset_opacity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacityVar", []))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityVarInput")
    def opacity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacity"))

    @opacity.setter
    def opacity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d096fe04e4af290d0fad007d85fe622391574dc0fdcfb33074d9984203d1cc7e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacity", value)

    @builtins.property
    @jsii.member(jsii_name="opacityVar")
    def opacity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacityVar"))

    @opacity_var.setter
    def opacity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f302189e53eb73cee1517f931b8161497e925d547cac948ebf7c8c8a8f56b652)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacityVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeOpacity]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeOpacity]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeOpacity]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f9434761eb9d9ba702faf48ae4efecc552a9deca43a69baa16898235a8cc187d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9978d9afcc61f5e934163a149b86b93e6dc62e7dda6d76e4ad18cc8c9502f455)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putBackgroundColor")
    def put_background_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4bb8f5646990c08b1c9637beca341e370e8d40d8dcfad365b4e389884d1be677)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBackgroundColor", [value]))

    @jsii.member(jsii_name="putBlur")
    def put_blur(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeBlur, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__379470ab22f0011dd1c7f748aea702112720d77b38dab3de6d4c5f1d7c3e6e2d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBlur", [value]))

    @jsii.member(jsii_name="putChromaKey")
    def put_chroma_key(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeChromaKey, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dc6d2907707803d6344924d49b9318b8942b8a7a83a2c5b1bc2530caa89ce948)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putChromaKey", [value]))

    @jsii.member(jsii_name="putComposite")
    def put_composite(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeComposite, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__62affe9b8a4990b7b7347f9d46d760ad391449217baf979f7dfb010e9b79ebce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putComposite", [value]))

    @jsii.member(jsii_name="putCompound")
    def put_compound(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeCompound, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ef8f941e8e8e734766f5b29d5e32141765706ff7811196dac865a543cf363fa0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCompound", [value]))

    @jsii.member(jsii_name="putContrast")
    def put_contrast(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeContrast, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9de54d79220a2a088955e080739add7367e425dc51ca1d0d22bd73fdd562bf3b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putContrast", [value]))

    @jsii.member(jsii_name="putGoop")
    def put_goop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeGoop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__46624c6134c345bcbc7e4954059c6cdf3c22383bada6d542e92fba61c9f6e1d1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGoop", [value]))

    @jsii.member(jsii_name="putGrayscale")
    def put_grayscale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeGrayscale, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7824954c8d04a9c52db5e4f93d3867b764c54b33f0cb0c002bbb803efcd8512f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGrayscale", [value]))

    @jsii.member(jsii_name="putHsl")
    def put_hsl(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeHsl, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3c57dd0fd22b763262d36b96a4ca7480b195e782727a1c6afdfdff6708b15e75)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsl", [value]))

    @jsii.member(jsii_name="putHsv")
    def put_hsv(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeHsv, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b3d59b0b711488eb166d676e065061e0384a293ff5df93d5ba8dbe2d0ffb72d8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsv", [value]))

    @jsii.member(jsii_name="putIfDimension")
    def put_if_dimension(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimension, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1cb468ef8ffdf72dda72feb1574cdfe655e8e46b6fe10ace1632e455ac40d147)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfDimension", [value]))

    @jsii.member(jsii_name="putIfOrientation")
    def put_if_orientation(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8bcabed9fc8a5c4e97fa75f54dbc6ff5d66eccf419a14a35458883c7e100ed67)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfOrientation", [value]))

    @jsii.member(jsii_name="putMaxColors")
    def put_max_colors(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeMaxColors, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__97b52bcc99135e97df45e961b131f08dbe66678600d97819d05725c02d61bce0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMaxColors", [value]))

    @jsii.member(jsii_name="putMirror")
    def put_mirror(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeMirror, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9075af5d5db0ab9947bb02f88551995d8c7a3e1cb84c24d7233c74c43d6ba74a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMirror", [value]))

    @jsii.member(jsii_name="putMonoHue")
    def put_mono_hue(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeMonoHue, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__45b7c440acbe78121174a8669da5ac988695d009677e886f4973ae9f00afde6e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMonoHue", [value]))

    @jsii.member(jsii_name="putOpacity")
    def put_opacity(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeOpacity, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5483aa3f420565908bfe0308b231b6bdffea558f3be1b38f499e0986ccefc52b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putOpacity", [value]))

    @jsii.member(jsii_name="putRemoveColor")
    def put_remove_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeRemoveColor", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__58a98d8e403eaba48e1a6cee71651f27a26787e53f02a27b280cb896b0757c25)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRemoveColor", [value]))

    @jsii.member(jsii_name="putUnsharpMask")
    def put_unsharp_mask(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeUnsharpMask", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__15e15905b29321cde49c287841442ba1cf23f2d2c7c3072daa88ffca18bd1a4e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putUnsharpMask", [value]))

    @jsii.member(jsii_name="resetBackgroundColor")
    def reset_background_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBackgroundColor", []))

    @jsii.member(jsii_name="resetBlur")
    def reset_blur(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBlur", []))

    @jsii.member(jsii_name="resetChromaKey")
    def reset_chroma_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChromaKey", []))

    @jsii.member(jsii_name="resetComposite")
    def reset_composite(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetComposite", []))

    @jsii.member(jsii_name="resetCompound")
    def reset_compound(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCompound", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetGoop")
    def reset_goop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGoop", []))

    @jsii.member(jsii_name="resetGrayscale")
    def reset_grayscale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGrayscale", []))

    @jsii.member(jsii_name="resetHsl")
    def reset_hsl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsl", []))

    @jsii.member(jsii_name="resetHsv")
    def reset_hsv(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsv", []))

    @jsii.member(jsii_name="resetIfDimension")
    def reset_if_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfDimension", []))

    @jsii.member(jsii_name="resetIfOrientation")
    def reset_if_orientation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfOrientation", []))

    @jsii.member(jsii_name="resetMaxColors")
    def reset_max_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxColors", []))

    @jsii.member(jsii_name="resetMirror")
    def reset_mirror(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMirror", []))

    @jsii.member(jsii_name="resetMonoHue")
    def reset_mono_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonoHue", []))

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetRemoveColor")
    def reset_remove_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRemoveColor", []))

    @jsii.member(jsii_name="resetUnsharpMask")
    def reset_unsharp_mask(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUnsharpMask", []))

    @builtins.property
    @jsii.member(jsii_name="backgroundColor")
    def background_color(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeBackgroundColorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeBackgroundColorList, jsii.get(self, "backgroundColor"))

    @builtins.property
    @jsii.member(jsii_name="blur")
    def blur(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeBlurList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeBlurList, jsii.get(self, "blur"))

    @builtins.property
    @jsii.member(jsii_name="chromaKey")
    def chroma_key(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeChromaKeyList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeChromaKeyList, jsii.get(self, "chromaKey"))

    @builtins.property
    @jsii.member(jsii_name="composite")
    def composite(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeCompositeList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeCompositeList, jsii.get(self, "composite"))

    @builtins.property
    @jsii.member(jsii_name="compound")
    def compound(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeCompoundList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeCompoundList, jsii.get(self, "compound"))

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeContrastList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeContrastList, jsii.get(self, "contrast"))

    @builtins.property
    @jsii.member(jsii_name="goop")
    def goop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeGoopList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeGoopList, jsii.get(self, "goop"))

    @builtins.property
    @jsii.member(jsii_name="grayscale")
    def grayscale(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeGrayscaleList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeGrayscaleList, jsii.get(self, "grayscale"))

    @builtins.property
    @jsii.member(jsii_name="hsl")
    def hsl(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeHslList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeHslList, jsii.get(self, "hsl"))

    @builtins.property
    @jsii.member(jsii_name="hsv")
    def hsv(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeHsvList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeHsvList, jsii.get(self, "hsv"))

    @builtins.property
    @jsii.member(jsii_name="ifDimension")
    def if_dimension(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionList, jsii.get(self, "ifDimension"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientation")
    def if_orientation(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationList, jsii.get(self, "ifOrientation"))

    @builtins.property
    @jsii.member(jsii_name="maxColors")
    def max_colors(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeMaxColorsList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeMaxColorsList, jsii.get(self, "maxColors"))

    @builtins.property
    @jsii.member(jsii_name="mirror")
    def mirror(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeMirrorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeMirrorList, jsii.get(self, "mirror"))

    @builtins.property
    @jsii.member(jsii_name="monoHue")
    def mono_hue(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeMonoHueList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeMonoHueList, jsii.get(self, "monoHue"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeOpacityList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeOpacityList, jsii.get(self, "opacity"))

    @builtins.property
    @jsii.member(jsii_name="removeColor")
    def remove_color(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeRemoveColorList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeRemoveColorList", jsii.get(self, "removeColor"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMask")
    def unsharp_mask(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeUnsharpMaskList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeUnsharpMaskList", jsii.get(self, "unsharpMask"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColorInput")
    def background_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeBackgroundColor]]], jsii.get(self, "backgroundColorInput"))

    @builtins.property
    @jsii.member(jsii_name="blurInput")
    def blur_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeBlur]]], jsii.get(self, "blurInput"))

    @builtins.property
    @jsii.member(jsii_name="chromaKeyInput")
    def chroma_key_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeChromaKey]]], jsii.get(self, "chromaKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="compositeInput")
    def composite_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeComposite]]], jsii.get(self, "compositeInput"))

    @builtins.property
    @jsii.member(jsii_name="compoundInput")
    def compound_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeCompound]]], jsii.get(self, "compoundInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeContrast]]], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="goopInput")
    def goop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeGoop]]], jsii.get(self, "goopInput"))

    @builtins.property
    @jsii.member(jsii_name="grayscaleInput")
    def grayscale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeGrayscale]]], jsii.get(self, "grayscaleInput"))

    @builtins.property
    @jsii.member(jsii_name="hslInput")
    def hsl_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeHsl]]], jsii.get(self, "hslInput"))

    @builtins.property
    @jsii.member(jsii_name="hsvInput")
    def hsv_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeHsv]]], jsii.get(self, "hsvInput"))

    @builtins.property
    @jsii.member(jsii_name="ifDimensionInput")
    def if_dimension_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimension]]], jsii.get(self, "ifDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientationInput")
    def if_orientation_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientation]]], jsii.get(self, "ifOrientationInput"))

    @builtins.property
    @jsii.member(jsii_name="maxColorsInput")
    def max_colors_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeMaxColors]]], jsii.get(self, "maxColorsInput"))

    @builtins.property
    @jsii.member(jsii_name="mirrorInput")
    def mirror_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeMirror]]], jsii.get(self, "mirrorInput"))

    @builtins.property
    @jsii.member(jsii_name="monoHueInput")
    def mono_hue_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeMonoHue]]], jsii.get(self, "monoHueInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeOpacity]]], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="removeColorInput")
    def remove_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeRemoveColor"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeRemoveColor"]]], jsii.get(self, "removeColorInput"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMaskInput")
    def unsharp_mask_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeUnsharpMask"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeUnsharpMask"]]], jsii.get(self, "unsharpMaskInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscape], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscape],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f59329af735a2acbf2de884757f6179b632c393c9318dce452dac9b678c9b247)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeRemoveColor",
    jsii_struct_bases=[],
    name_mapping={
        "color": "color",
        "color_var": "colorVar",
        "feather": "feather",
        "feather_var": "featherVar",
        "tolerance": "tolerance",
        "tolerance_var": "toleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeRemoveColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
        feather: typing.Optional[builtins.str] = None,
        feather_var: typing.Optional[builtins.str] = None,
        tolerance: typing.Optional[builtins.str] = None,
        tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        :param feather: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        :param feather_var: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        :param tolerance: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        :param tolerance_var: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2e9b4e6e79f83328ca9c2aedcc47958e68431d76d816024e2b1f19f3021b4090)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
            check_type(argname="argument feather", value=feather, expected_type=type_hints["feather"])
            check_type(argname="argument feather_var", value=feather_var, expected_type=type_hints["feather_var"])
            check_type(argname="argument tolerance", value=tolerance, expected_type=type_hints["tolerance"])
            check_type(argname="argument tolerance_var", value=tolerance_var, expected_type=type_hints["tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var
        if feather is not None:
            self._values["feather"] = feather
        if feather_var is not None:
            self._values["feather_var"] = feather_var
        if tolerance is not None:
            self._values["tolerance"] = tolerance
        if tolerance_var is not None:
            self._values["tolerance_var"] = tolerance_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        '''
        result = self._values.get("feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather_var(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        '''
        result = self._values.get("feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        '''
        result = self._values.get("tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance_var(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        result = self._values.get("tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeRemoveColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeRemoveColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeRemoveColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1964ca8b108068eba8e754a2643decdcd9216014ec44fa813603846621dae06a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeRemoveColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__07ddabe7b818d44aeb85a97ba3437b4b090071f1e8bcfca32329dfd5fb42bfe0)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeRemoveColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0440463f0bcc1d893381d241ce646d1c77851b5dab1ae93879b78962da529ca6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__28e7abd9f637232f0b584594710df52f94931071bdf166c218133d3b19bf2dba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c494da6a5d1c5126fa09b7f19e5e2964e6ff78b697f28f4f192c88ce26c0c1a3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeRemoveColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeRemoveColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeRemoveColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__347a5aaa936d61b7af0e4452526772444a5dabb8756e3695d4cf55a594902eb3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeRemoveColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeRemoveColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aa584ee703b8a8b6d21fbea6f1699e02c4b4eb0f4521a9b835dbce07caf24ddd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @jsii.member(jsii_name="resetFeather")
    def reset_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeather", []))

    @jsii.member(jsii_name="resetFeatherVar")
    def reset_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatherVar", []))

    @jsii.member(jsii_name="resetTolerance")
    def reset_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTolerance", []))

    @jsii.member(jsii_name="resetToleranceVar")
    def reset_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featherInput")
    def feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherInput"))

    @builtins.property
    @jsii.member(jsii_name="featherVarInput")
    def feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceInput")
    def tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceVarInput")
    def tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__31c003b4fe9f45695979a771cdedc7f7235db2e25e99fd9ad81a89486ae8481e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f60e300519d9a66b7f3a6abf055586232e20621f5133eea03e457b7895ddd9ae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="feather")
    def feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "feather"))

    @feather.setter
    def feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e7d04ea34e9c4f0488133cab2626daae83e5496523a3f3edd2ae9019c319f66)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "feather", value)

    @builtins.property
    @jsii.member(jsii_name="featherVar")
    def feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featherVar"))

    @feather_var.setter
    def feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__058e1a61c34898137f81fa148c2f0fdf70e9a7ecbb60e6b093b768459e59d422)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featherVar", value)

    @builtins.property
    @jsii.member(jsii_name="tolerance")
    def tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tolerance"))

    @tolerance.setter
    def tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0e9b65537c5a09f07c8c65c8800c869da634a21852b9ca1971d027e6f0ba7755)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tolerance", value)

    @builtins.property
    @jsii.member(jsii_name="toleranceVar")
    def tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "toleranceVar"))

    @tolerance_var.setter
    def tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__663fc9b72f13972e413cd5a10f04c33584aab207816ba6807c2cd0df21832dbb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "toleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeRemoveColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeRemoveColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeRemoveColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dede1a9729e58d8f5e62a5449547f5183a5422a13139aed0999f03f4418baf92)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeUnsharpMask",
    jsii_struct_bases=[],
    name_mapping={
        "gain": "gain",
        "gain_var": "gainVar",
        "sigma": "sigma",
        "sigma_var": "sigmaVar",
        "threshold": "threshold",
        "threshold_var": "thresholdVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeUnsharpMask:
    def __init__(
        self,
        *,
        gain: typing.Optional[builtins.str] = None,
        gain_var: typing.Optional[builtins.str] = None,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
        threshold: typing.Optional[builtins.str] = None,
        threshold_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param gain: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        :param gain_var: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        :param sigma: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        :param threshold: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        :param threshold_var: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f7d68a4cf982e1b1ce00bf4326402eb49416e2aa0dbbb18c648447b4bfb58155)
            check_type(argname="argument gain", value=gain, expected_type=type_hints["gain"])
            check_type(argname="argument gain_var", value=gain_var, expected_type=type_hints["gain_var"])
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
            check_type(argname="argument threshold", value=threshold, expected_type=type_hints["threshold"])
            check_type(argname="argument threshold_var", value=threshold_var, expected_type=type_hints["threshold_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if gain is not None:
            self._values["gain"] = gain
        if gain_var is not None:
            self._values["gain_var"] = gain_var
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var
        if threshold is not None:
            self._values["threshold"] = threshold
        if threshold_var is not None:
            self._values["threshold_var"] = threshold_var

    @builtins.property
    def gain(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        '''
        result = self._values.get("gain")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gain_var(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        '''
        result = self._values.get("gain_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        '''
        result = self._values.get("threshold")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold_var(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        result = self._values.get("threshold_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeUnsharpMask(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeUnsharpMaskList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeUnsharpMaskList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d2c0097bc0fae1128f8db79cb66cd6211fd548bfce846fc907d2c5b0cb7a9656)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeUnsharpMaskOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd8eb716c42d903d1697f460d8d14bc0c5a606dd7267de1b511ee94168998c71)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeUnsharpMaskOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5d47f89e7f2b0676349c3a2f6fc2ca7c00c5124c7d56681c4bd8e38d7d781111)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1ca7188b41e4c70ca35e1dc26d3a67495c451d41fb1f771d7b5af5a49e6fe42d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__50341ca3b57fed6e97408a1a7b65b79e9f1f212fe8fb62e499cf54a9414514ce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeUnsharpMask]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeUnsharpMask]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeUnsharpMask]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7dc8be37891e70f04e6b63b84d9073aa0d02dbf1bbccd5862bd885d4b15ebf48)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeUnsharpMaskOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeUnsharpMaskOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__098f9db49edbc875988a971c339ccec9b60c4b8194b02742c42b658a28ad64eb)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetGain")
    def reset_gain(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGain", []))

    @jsii.member(jsii_name="resetGainVar")
    def reset_gain_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGainVar", []))

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @jsii.member(jsii_name="resetThreshold")
    def reset_threshold(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThreshold", []))

    @jsii.member(jsii_name="resetThresholdVar")
    def reset_threshold_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThresholdVar", []))

    @builtins.property
    @jsii.member(jsii_name="gainInput")
    def gain_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainInput"))

    @builtins.property
    @jsii.member(jsii_name="gainVarInput")
    def gain_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdInput")
    def threshold_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdVarInput")
    def threshold_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gain")
    def gain(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gain"))

    @gain.setter
    def gain(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d90013f3ad6c554032f11c1e217f4737a44bd0f5b00faada14a3745ef5ece203)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gain", value)

    @builtins.property
    @jsii.member(jsii_name="gainVar")
    def gain_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gainVar"))

    @gain_var.setter
    def gain_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3cd07404537a26ff591b7f447c9484cc44964ec1b14ca3e09ecd7b834bf8f5e7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gainVar", value)

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__779772fde14add819d5a1e111e37834f898da5c2c2c8236b3dfd338a82f3d2b2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aa625fdfbf861722b3f06c37037315178504d652eebd0817cb64008e117f30b1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="threshold")
    def threshold(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "threshold"))

    @threshold.setter
    def threshold(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b471117a02891e09c257307881d7f4655ff9a1c6ae54c0ea3375bf00ee6cd9f0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "threshold", value)

    @builtins.property
    @jsii.member(jsii_name="thresholdVar")
    def threshold_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "thresholdVar"))

    @threshold_var.setter
    def threshold_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e9bce521530c259cc54da4d8ef8400541e5bebbbdc1be86406423a008cb3dda)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "thresholdVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeUnsharpMask]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeUnsharpMask]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeUnsharpMask]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ef6226f985b7e218d6d97c8f720c46de21a1e52ee438f5f64892c6be679292b5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1b91f2fad7bf43d477cb711fbf22dadbcc2f63162f80272ee2c145f1e20972f3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__10c3a4932be2c66929a9a7e9580ee2523ddb0df6fa6fdefbc952b74f94583edd)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8886b765e984fadf2cb5e4ba35717a2e8bb5c386d9e95510a642ad050047cc16)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__11b6ac987c49200575115a053978d8b6b3063218612889ac3bb8cabf072de5e7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0643ce6149123cd5854e09a6e7a934a95ce0a2e18dc7f45f72fcb66e13554dd1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientation]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientation]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ba6caf173f4802e0f5c2b73c2b8eb27bb85342fd36b5d9ac9512bc3756df661)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4af877e7b18547bc02e99b813cb481d230ee9e8f7c1e14c23cff0fda231541b2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(
        self,
        *,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefault(
            background_color=background_color,
            blur=blur,
            chroma_key=chroma_key,
            composite=composite,
            compound=compound,
            contrast=contrast,
            goop=goop,
            grayscale=grayscale,
            hsl=hsl,
            hsv=hsv,
            if_dimension=if_dimension,
            if_orientation=if_orientation,
            max_colors=max_colors,
            mirror=mirror,
            mono_hue=mono_hue,
            opacity=opacity,
            remove_color=remove_color,
            unsharp_mask=unsharp_mask,
        )

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putLandscape")
    def put_landscape(
        self,
        *,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscape(
            background_color=background_color,
            blur=blur,
            chroma_key=chroma_key,
            composite=composite,
            compound=compound,
            contrast=contrast,
            goop=goop,
            grayscale=grayscale,
            hsl=hsl,
            hsv=hsv,
            if_dimension=if_dimension,
            if_orientation=if_orientation,
            max_colors=max_colors,
            mirror=mirror,
            mono_hue=mono_hue,
            opacity=opacity,
            remove_color=remove_color,
            unsharp_mask=unsharp_mask,
        )

        return typing.cast(None, jsii.invoke(self, "putLandscape", [value]))

    @jsii.member(jsii_name="putPortrait")
    def put_portrait(
        self,
        *,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitBackgroundColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitBlur", typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitChromaKey", typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitComposite", typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitCompound", typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitContrast", typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitGoop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitGrayscale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitHsl", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitHsv", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfDimension", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientation", typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitMaxColors", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitMirror", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitMonoHue", typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitOpacity", typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitRemoveColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitUnsharpMask", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortrait(
            background_color=background_color,
            blur=blur,
            chroma_key=chroma_key,
            composite=composite,
            compound=compound,
            contrast=contrast,
            goop=goop,
            grayscale=grayscale,
            hsl=hsl,
            hsv=hsv,
            if_dimension=if_dimension,
            if_orientation=if_orientation,
            max_colors=max_colors,
            mirror=mirror,
            mono_hue=mono_hue,
            opacity=opacity,
            remove_color=remove_color,
            unsharp_mask=unsharp_mask,
        )

        return typing.cast(None, jsii.invoke(self, "putPortrait", [value]))

    @jsii.member(jsii_name="putSquare")
    def put_square(
        self,
        *,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareBackgroundColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareBlur", typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareChromaKey", typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareComposite", typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareCompound", typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareContrast", typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareGoop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareGrayscale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareHsl", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareHsv", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfDimension", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfOrientation", typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareMaxColors", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareMirror", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareMonoHue", typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareOpacity", typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareRemoveColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareUnsharpMask", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquare(
            background_color=background_color,
            blur=blur,
            chroma_key=chroma_key,
            composite=composite,
            compound=compound,
            contrast=contrast,
            goop=goop,
            grayscale=grayscale,
            hsl=hsl,
            hsv=hsv,
            if_dimension=if_dimension,
            if_orientation=if_orientation,
            max_colors=max_colors,
            mirror=mirror,
            mono_hue=mono_hue,
            opacity=opacity,
            remove_color=remove_color,
            unsharp_mask=unsharp_mask,
        )

        return typing.cast(None, jsii.invoke(self, "putSquare", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetLandscape")
    def reset_landscape(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLandscape", []))

    @jsii.member(jsii_name="resetPortrait")
    def reset_portrait(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPortrait", []))

    @jsii.member(jsii_name="resetSquare")
    def reset_square(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSquare", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="landscape")
    def landscape(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeOutputReference, jsii.get(self, "landscape"))

    @builtins.property
    @jsii.member(jsii_name="portrait")
    def portrait(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitOutputReference", jsii.get(self, "portrait"))

    @builtins.property
    @jsii.member(jsii_name="square")
    def square(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareOutputReference", jsii.get(self, "square"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="landscapeInput")
    def landscape_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscape], jsii.get(self, "landscapeInput"))

    @builtins.property
    @jsii.member(jsii_name="portraitInput")
    def portrait_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortrait"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortrait"], jsii.get(self, "portraitInput"))

    @builtins.property
    @jsii.member(jsii_name="squareInput")
    def square_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquare"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquare"], jsii.get(self, "squareInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientation]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientation]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientation]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fac4ac28147e10b94025b9ac8574660cf2b15cfdfa148ae80df5ae5ea6275096)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortrait",
    jsii_struct_bases=[],
    name_mapping={
        "background_color": "backgroundColor",
        "blur": "blur",
        "chroma_key": "chromaKey",
        "composite": "composite",
        "compound": "compound",
        "contrast": "contrast",
        "goop": "goop",
        "grayscale": "grayscale",
        "hsl": "hsl",
        "hsv": "hsv",
        "if_dimension": "ifDimension",
        "if_orientation": "ifOrientation",
        "max_colors": "maxColors",
        "mirror": "mirror",
        "mono_hue": "monoHue",
        "opacity": "opacity",
        "remove_color": "removeColor",
        "unsharp_mask": "unsharpMask",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortrait:
    def __init__(
        self,
        *,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitBackgroundColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitBlur", typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitChromaKey", typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitComposite", typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitCompound", typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitContrast", typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitGoop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitGrayscale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitHsl", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitHsv", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfDimension", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientation", typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitMaxColors", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitMirror", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitMonoHue", typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitOpacity", typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitRemoveColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitUnsharpMask", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5bdd5c2de27555b9761f8ec6cb9d32b12544994eedd5bd6ef7e0ed8e3e82444b)
            check_type(argname="argument background_color", value=background_color, expected_type=type_hints["background_color"])
            check_type(argname="argument blur", value=blur, expected_type=type_hints["blur"])
            check_type(argname="argument chroma_key", value=chroma_key, expected_type=type_hints["chroma_key"])
            check_type(argname="argument composite", value=composite, expected_type=type_hints["composite"])
            check_type(argname="argument compound", value=compound, expected_type=type_hints["compound"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument goop", value=goop, expected_type=type_hints["goop"])
            check_type(argname="argument grayscale", value=grayscale, expected_type=type_hints["grayscale"])
            check_type(argname="argument hsl", value=hsl, expected_type=type_hints["hsl"])
            check_type(argname="argument hsv", value=hsv, expected_type=type_hints["hsv"])
            check_type(argname="argument if_dimension", value=if_dimension, expected_type=type_hints["if_dimension"])
            check_type(argname="argument if_orientation", value=if_orientation, expected_type=type_hints["if_orientation"])
            check_type(argname="argument max_colors", value=max_colors, expected_type=type_hints["max_colors"])
            check_type(argname="argument mirror", value=mirror, expected_type=type_hints["mirror"])
            check_type(argname="argument mono_hue", value=mono_hue, expected_type=type_hints["mono_hue"])
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument remove_color", value=remove_color, expected_type=type_hints["remove_color"])
            check_type(argname="argument unsharp_mask", value=unsharp_mask, expected_type=type_hints["unsharp_mask"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if background_color is not None:
            self._values["background_color"] = background_color
        if blur is not None:
            self._values["blur"] = blur
        if chroma_key is not None:
            self._values["chroma_key"] = chroma_key
        if composite is not None:
            self._values["composite"] = composite
        if compound is not None:
            self._values["compound"] = compound
        if contrast is not None:
            self._values["contrast"] = contrast
        if goop is not None:
            self._values["goop"] = goop
        if grayscale is not None:
            self._values["grayscale"] = grayscale
        if hsl is not None:
            self._values["hsl"] = hsl
        if hsv is not None:
            self._values["hsv"] = hsv
        if if_dimension is not None:
            self._values["if_dimension"] = if_dimension
        if if_orientation is not None:
            self._values["if_orientation"] = if_orientation
        if max_colors is not None:
            self._values["max_colors"] = max_colors
        if mirror is not None:
            self._values["mirror"] = mirror
        if mono_hue is not None:
            self._values["mono_hue"] = mono_hue
        if opacity is not None:
            self._values["opacity"] = opacity
        if remove_color is not None:
            self._values["remove_color"] = remove_color
        if unsharp_mask is not None:
            self._values["unsharp_mask"] = unsharp_mask

    @builtins.property
    def background_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitBackgroundColor"]]]:
        '''background_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        '''
        result = self._values.get("background_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitBackgroundColor"]]], result)

    @builtins.property
    def blur(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitBlur"]]]:
        '''blur block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        '''
        result = self._values.get("blur")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitBlur"]]], result)

    @builtins.property
    def chroma_key(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitChromaKey"]]]:
        '''chroma_key block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        '''
        result = self._values.get("chroma_key")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitChromaKey"]]], result)

    @builtins.property
    def composite(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitComposite"]]]:
        '''composite block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        '''
        result = self._values.get("composite")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitComposite"]]], result)

    @builtins.property
    def compound(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitCompound"]]]:
        '''compound block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        '''
        result = self._values.get("compound")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitCompound"]]], result)

    @builtins.property
    def contrast(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitContrast"]]]:
        '''contrast block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitContrast"]]], result)

    @builtins.property
    def goop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitGoop"]]]:
        '''goop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        '''
        result = self._values.get("goop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitGoop"]]], result)

    @builtins.property
    def grayscale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitGrayscale"]]]:
        '''grayscale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        '''
        result = self._values.get("grayscale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitGrayscale"]]], result)

    @builtins.property
    def hsl(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitHsl"]]]:
        '''hsl block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        '''
        result = self._values.get("hsl")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitHsl"]]], result)

    @builtins.property
    def hsv(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitHsv"]]]:
        '''hsv block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        '''
        result = self._values.get("hsv")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitHsv"]]], result)

    @builtins.property
    def if_dimension(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfDimension"]]]:
        '''if_dimension block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        '''
        result = self._values.get("if_dimension")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfDimension"]]], result)

    @builtins.property
    def if_orientation(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientation"]]]:
        '''if_orientation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        '''
        result = self._values.get("if_orientation")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientation"]]], result)

    @builtins.property
    def max_colors(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitMaxColors"]]]:
        '''max_colors block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        '''
        result = self._values.get("max_colors")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitMaxColors"]]], result)

    @builtins.property
    def mirror(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitMirror"]]]:
        '''mirror block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        '''
        result = self._values.get("mirror")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitMirror"]]], result)

    @builtins.property
    def mono_hue(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitMonoHue"]]]:
        '''mono_hue block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        '''
        result = self._values.get("mono_hue")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitMonoHue"]]], result)

    @builtins.property
    def opacity(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitOpacity"]]]:
        '''opacity block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitOpacity"]]], result)

    @builtins.property
    def remove_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitRemoveColor"]]]:
        '''remove_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        '''
        result = self._values.get("remove_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitRemoveColor"]]], result)

    @builtins.property
    def unsharp_mask(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitUnsharpMask"]]]:
        '''unsharp_mask block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        result = self._values.get("unsharp_mask")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitUnsharpMask"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortrait(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitBackgroundColor",
    jsii_struct_bases=[],
    name_mapping={"color": "color", "color_var": "colorVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitBackgroundColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7f82b8f25160812a6f108b0992ab058646fa56ff14d41a2eed0eb51795007560)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitBackgroundColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitBackgroundColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitBackgroundColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c7af6b32ffd338eee7ca54b610ad7379ae673e37126367f64cfbc50088760e43)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitBackgroundColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ebfab112093473de83f3730c4a46005d8c31462916eb2c264e18be0a9b0e731)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitBackgroundColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6d8b00fd55b93d770b5ac5ade57c23bc85ff944e3ebcb012cdbb4e512b828d6b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__14e401151d126ed86840de50b39b590b9834041ee8c749347129c103dcbee4c0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d7d6e7249ef26b63b85b65f75612beb8746f7ddfa046731551fdd4997f2eef2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitBackgroundColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitBackgroundColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a0d5074fcccff4901df6040e34efcbc82234cc9e11ec2ed52e5da9674f6486fe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitBackgroundColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitBackgroundColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__79c4ec37d2a230f808dedc3472a072f5a649f3531e087becd16064b00634e7e0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2add9f01cb363eab6dfe5a784866242ed97e76a4b690e185ee29a3225c138906)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__23f8af219f6f33e36d1c1e0de62fd86fdc1ab4cfd6ffb3fe93114c486c70973c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitBackgroundColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitBackgroundColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitBackgroundColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7ebed7cb54102917eedb36760534b0e5e4f5f3978a543a8a98fdd92e31f25c73)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitBlur",
    jsii_struct_bases=[],
    name_mapping={"sigma": "sigma", "sigma_var": "sigmaVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitBlur:
    def __init__(
        self,
        *,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param sigma: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5eaa5dc78c730b850ded876b7cf14d53bb3334a3a8afbbd434099d4bd8f0b78e)
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitBlur(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitBlurList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitBlurList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3d07ffb69f6466a46ca021dcd7e12f81dbeb9464f56668cf973654307237d772)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitBlurOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__99474b1f20e0c61bfe25d13bbc89236ce90a04954472f4112c7af4f6ce925bce)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitBlurOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__18088e98e1577d24f806c3e4590366a9a18c060fc13bb49a25033ba4bf163846)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f7526538840759dd177b02da01f3e9433a22ecb2fc7f634e9d6da41ebd81080c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8547b1348f94421a704032aeb1ded094c0365dcf120410c8b2a12e4d048e1955)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitBlur]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitBlur]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b54866d36a656e3c43640999afbff34ada322a10056c60edee9ee8f8728d5532)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitBlurOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitBlurOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__061c95401259330a0af333713332b0e64d617e22ed0543ff6ca2d7d21473093d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__17909ec96b411c89beba31d462a7e4e47ce6a61aa8a961a3d4ee9d276465a238)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7172e0117b226b821622aef067146c475bf3963644c83563112cd6997c284cbe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitBlur]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitBlur]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitBlur]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e79dccd773a0ef7f85a0dd440aaa530b8c9432966d857117d768e1c07f79e4bc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitChromaKey",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_feather": "hueFeather",
        "hue_feather_var": "hueFeatherVar",
        "hue_tolerance": "hueTolerance",
        "hue_tolerance_var": "hueToleranceVar",
        "hue_var": "hueVar",
        "lightness_feather": "lightnessFeather",
        "lightness_feather_var": "lightnessFeatherVar",
        "lightness_tolerance": "lightnessTolerance",
        "lightness_tolerance_var": "lightnessToleranceVar",
        "saturation_feather": "saturationFeather",
        "saturation_feather_var": "saturationFeatherVar",
        "saturation_tolerance": "saturationTolerance",
        "saturation_tolerance_var": "saturationToleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitChromaKey:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_feather: typing.Optional[builtins.str] = None,
        hue_feather_var: typing.Optional[builtins.str] = None,
        hue_tolerance: typing.Optional[builtins.str] = None,
        hue_tolerance_var: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness_feather: typing.Optional[builtins.str] = None,
        lightness_feather_var: typing.Optional[builtins.str] = None,
        lightness_tolerance: typing.Optional[builtins.str] = None,
        lightness_tolerance_var: typing.Optional[builtins.str] = None,
        saturation_feather: typing.Optional[builtins.str] = None,
        saturation_feather_var: typing.Optional[builtins.str] = None,
        saturation_tolerance: typing.Optional[builtins.str] = None,
        saturation_tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_feather: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        :param hue_feather_var: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        :param hue_tolerance: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        :param hue_tolerance_var: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        :param hue_var: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness_feather: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        :param lightness_feather_var: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        :param lightness_tolerance: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        :param lightness_tolerance_var: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        :param saturation_feather: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        :param saturation_feather_var: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        :param saturation_tolerance: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        :param saturation_tolerance_var: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e7dc3256b3f94f40f0f447de02fc55d142924381cc778325684a3c14d16ff7b3)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_feather", value=hue_feather, expected_type=type_hints["hue_feather"])
            check_type(argname="argument hue_feather_var", value=hue_feather_var, expected_type=type_hints["hue_feather_var"])
            check_type(argname="argument hue_tolerance", value=hue_tolerance, expected_type=type_hints["hue_tolerance"])
            check_type(argname="argument hue_tolerance_var", value=hue_tolerance_var, expected_type=type_hints["hue_tolerance_var"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness_feather", value=lightness_feather, expected_type=type_hints["lightness_feather"])
            check_type(argname="argument lightness_feather_var", value=lightness_feather_var, expected_type=type_hints["lightness_feather_var"])
            check_type(argname="argument lightness_tolerance", value=lightness_tolerance, expected_type=type_hints["lightness_tolerance"])
            check_type(argname="argument lightness_tolerance_var", value=lightness_tolerance_var, expected_type=type_hints["lightness_tolerance_var"])
            check_type(argname="argument saturation_feather", value=saturation_feather, expected_type=type_hints["saturation_feather"])
            check_type(argname="argument saturation_feather_var", value=saturation_feather_var, expected_type=type_hints["saturation_feather_var"])
            check_type(argname="argument saturation_tolerance", value=saturation_tolerance, expected_type=type_hints["saturation_tolerance"])
            check_type(argname="argument saturation_tolerance_var", value=saturation_tolerance_var, expected_type=type_hints["saturation_tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_feather is not None:
            self._values["hue_feather"] = hue_feather
        if hue_feather_var is not None:
            self._values["hue_feather_var"] = hue_feather_var
        if hue_tolerance is not None:
            self._values["hue_tolerance"] = hue_tolerance
        if hue_tolerance_var is not None:
            self._values["hue_tolerance_var"] = hue_tolerance_var
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness_feather is not None:
            self._values["lightness_feather"] = lightness_feather
        if lightness_feather_var is not None:
            self._values["lightness_feather_var"] = lightness_feather_var
        if lightness_tolerance is not None:
            self._values["lightness_tolerance"] = lightness_tolerance
        if lightness_tolerance_var is not None:
            self._values["lightness_tolerance_var"] = lightness_tolerance_var
        if saturation_feather is not None:
            self._values["saturation_feather"] = saturation_feather
        if saturation_feather_var is not None:
            self._values["saturation_feather_var"] = saturation_feather_var
        if saturation_tolerance is not None:
            self._values["saturation_tolerance"] = saturation_tolerance
        if saturation_tolerance_var is not None:
            self._values["saturation_tolerance_var"] = saturation_tolerance_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        '''
        result = self._values.get("hue_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        '''
        result = self._values.get("hue_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        '''
        result = self._values.get("hue_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        '''
        result = self._values.get("hue_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        '''
        result = self._values.get("lightness_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        '''
        result = self._values.get("lightness_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        '''
        result = self._values.get("lightness_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        '''
        result = self._values.get("lightness_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        '''
        result = self._values.get("saturation_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        '''
        result = self._values.get("saturation_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        '''
        result = self._values.get("saturation_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        result = self._values.get("saturation_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitChromaKey(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitChromaKeyList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitChromaKeyList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3abc861450bc72476182f3a7405e058eb58f4c80fee80db04a4761f707f3e0f6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitChromaKeyOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2882f6142eaf1a5de2e6c178369f371ba4a53178036be45dd2553b2c3e4518e3)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitChromaKeyOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__46e8e89fa75eff521754c9d2c4b1df498b63eaae7774171d7304a3ccea09dc96)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4274eb3a03b0635b2e78f03005807b16d3c2e322b21e354a2d43deb1fc0925ab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bd5598085770826fab362d97571aecf254131a175b9b0c2d3a8380d5f969737c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitChromaKey]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitChromaKey]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__72f675079249c7d47a603b67fe01ef589b3ce68f6563ce02b2ebfc2d27685696)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitChromaKeyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitChromaKeyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__82ebdeac94fc3c00a2c39bca7c74f83ac04cdcae951861d7a1039be149c8c8c5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueFeather")
    def reset_hue_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeather", []))

    @jsii.member(jsii_name="resetHueFeatherVar")
    def reset_hue_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeatherVar", []))

    @jsii.member(jsii_name="resetHueTolerance")
    def reset_hue_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueTolerance", []))

    @jsii.member(jsii_name="resetHueToleranceVar")
    def reset_hue_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueToleranceVar", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightnessFeather")
    def reset_lightness_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeather", []))

    @jsii.member(jsii_name="resetLightnessFeatherVar")
    def reset_lightness_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeatherVar", []))

    @jsii.member(jsii_name="resetLightnessTolerance")
    def reset_lightness_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessTolerance", []))

    @jsii.member(jsii_name="resetLightnessToleranceVar")
    def reset_lightness_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessToleranceVar", []))

    @jsii.member(jsii_name="resetSaturationFeather")
    def reset_saturation_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeather", []))

    @jsii.member(jsii_name="resetSaturationFeatherVar")
    def reset_saturation_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeatherVar", []))

    @jsii.member(jsii_name="resetSaturationTolerance")
    def reset_saturation_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationTolerance", []))

    @jsii.member(jsii_name="resetSaturationToleranceVar")
    def reset_saturation_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherInput")
    def hue_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVarInput")
    def hue_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceInput")
    def hue_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVarInput")
    def hue_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherInput")
    def lightness_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVarInput")
    def lightness_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceInput")
    def lightness_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVarInput")
    def lightness_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherInput")
    def saturation_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVarInput")
    def saturation_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceInput")
    def saturation_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVarInput")
    def saturation_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e91d41db94e9647a758128ff29f4dcbdbd74d7854eb7e962a6f803cd24551139)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeather")
    def hue_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeather"))

    @hue_feather.setter
    def hue_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bf5596730a23bcad09b214d66c8a7edb181fc15b49d469d4a317fc77d3daf333)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeather", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVar")
    def hue_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeatherVar"))

    @hue_feather_var.setter
    def hue_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__78d14df19400f7179da01cbdf7dee6bcf5ceb70b26abde8058d7e5adeb155ec7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueTolerance")
    def hue_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueTolerance"))

    @hue_tolerance.setter
    def hue_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0493e0d634eee36a6ddf60cb315f3651d727a8fd293ea65e22e5a87ce3b6f773)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVar")
    def hue_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueToleranceVar"))

    @hue_tolerance_var.setter
    def hue_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f9bc7eb1348c4c34e7d971e469f9ea8e2d254d5ec98afe1c17e4c871f5dc692a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bebdc066dd453c3bf0d4b1b32618ca1358b7f77418a5fe19f2b8d792b7e1c516)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeather")
    def lightness_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeather"))

    @lightness_feather.setter
    def lightness_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5270c7a80f6e61dc5b475e8d0f868a894b2e32abaf2eb4011be7deeb0f8fd3c0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeather", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVar")
    def lightness_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeatherVar"))

    @lightness_feather_var.setter
    def lightness_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1507b58167689d8b73296a57052d5006cc3e0714c93d0503049abf9a01fd54bc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessTolerance")
    def lightness_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessTolerance"))

    @lightness_tolerance.setter
    def lightness_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__28d4d9ed9926d3847a65ebdab516100987baa29eabb94a761b8f9f2897e7ce33)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVar")
    def lightness_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessToleranceVar"))

    @lightness_tolerance_var.setter
    def lightness_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__49829d1db2981e787dfcb25ff1b3b48e28d846d21d0743a8da9cf512faa33ac2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeather")
    def saturation_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeather"))

    @saturation_feather.setter
    def saturation_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__83127577da1db211c98a6d3333818a2a903cbae758caea14794228e8ed65c381)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeather", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVar")
    def saturation_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeatherVar"))

    @saturation_feather_var.setter
    def saturation_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__926b2199e2e7f47ef2c4a809e1a731a1505f83ad1869ae20f22ca585ef4e7b77)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationTolerance")
    def saturation_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationTolerance"))

    @saturation_tolerance.setter
    def saturation_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ed4d72762e57bf88ad185db017644d9b931ce3f8db5f29137fc26e6aa273c08e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVar")
    def saturation_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationToleranceVar"))

    @saturation_tolerance_var.setter
    def saturation_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7914396a59108aadac396af6caa23ba7480084065062bf1b52a3dbbeef6a65a4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitChromaKey]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitChromaKey]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitChromaKey]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e6cc6ef1d1d05982bd0409c440ae881113f598f04328a6bc5f29bf253ac2a31d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitComposite",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "placement": "placement",
        "placement_var": "placementVar",
        "scale": "scale",
        "scale_dimension": "scaleDimension",
        "scale_dimension_var": "scaleDimensionVar",
        "scale_var": "scaleVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitComposite:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitCompositeImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        placement: typing.Optional[builtins.str] = None,
        placement_var: typing.Optional[builtins.str] = None,
        scale: typing.Optional[builtins.str] = None,
        scale_dimension: typing.Optional[builtins.str] = None,
        scale_dimension_var: typing.Optional[builtins.str] = None,
        scale_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param placement: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        :param placement_var: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        :param scale: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param scale_dimension: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        :param scale_dimension_var: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        :param scale_var: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        :param x_position: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitCompositeImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d33766d0a43744f01e52a18550777960017f4606714d5d258fbc4dd0b4f4145)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument placement", value=placement, expected_type=type_hints["placement"])
            check_type(argname="argument placement_var", value=placement_var, expected_type=type_hints["placement_var"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument scale_dimension", value=scale_dimension, expected_type=type_hints["scale_dimension"])
            check_type(argname="argument scale_dimension_var", value=scale_dimension_var, expected_type=type_hints["scale_dimension_var"])
            check_type(argname="argument scale_var", value=scale_var, expected_type=type_hints["scale_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if placement is not None:
            self._values["placement"] = placement
        if placement_var is not None:
            self._values["placement_var"] = placement_var
        if scale is not None:
            self._values["scale"] = scale
        if scale_dimension is not None:
            self._values["scale_dimension"] = scale_dimension
        if scale_dimension_var is not None:
            self._values["scale_dimension_var"] = scale_dimension_var
        if scale_var is not None:
            self._values["scale_var"] = scale_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitCompositeImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitCompositeImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        '''
        result = self._values.get("placement")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement_var(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        '''
        result = self._values.get("placement_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        '''
        result = self._values.get("scale_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        '''
        result = self._values.get("scale_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        '''
        result = self._values.get("scale_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitComposite(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitCompositeImage",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitCompositeImage:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitCompositeImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitCompositeImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitCompositeImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a66c4d4f98fc4cd074aee4ba542c203160f695da19e20284fee3c9533357d295)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitCompositeImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitCompositeImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8067377fce2a4dd6d9d125c765aec0fa4b3fb06639504c724468edbee3be70ba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitCompositeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitCompositeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__47e249a54f31047adc45f4809905821a0c4fab490c4d0db62794ebcadc43a08e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitCompositeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a8ef5ba183cee88a477529b5083c10a9640234debe660dbaa8d22fc65d708361)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitCompositeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7147d6b156dd4f64b99b8a97cc9799ba878d1e58c2024e1f7df4456dc690e0e3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__44974cf4d3cdd5a89701b17a89107eaae8c00883df71217a89a9b16dd4cfe1d2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__63ccf403100877c58506e544aac216208aac4756eefbcb4d5093587c1924d732)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitComposite]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitComposite]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__675f937ac0af45a3875a85d14eff4ac9fceaed90fd0f3f4aeb1e9c3a379b6ff6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitCompositeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitCompositeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c0fae84899de3ccdcbee8eebd1455fbbb960fca019f7730d0d3b3d39562e7365)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitCompositeImage()

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPlacement")
    def reset_placement(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacement", []))

    @jsii.member(jsii_name="resetPlacementVar")
    def reset_placement_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacementVar", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetScaleDimension")
    def reset_scale_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimension", []))

    @jsii.member(jsii_name="resetScaleDimensionVar")
    def reset_scale_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimensionVar", []))

    @jsii.member(jsii_name="resetScaleVar")
    def reset_scale_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitCompositeImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitCompositeImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitCompositeImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="placementInput")
    def placement_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementInput"))

    @builtins.property
    @jsii.member(jsii_name="placementVarInput")
    def placement_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionInput")
    def scale_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVarInput")
    def scale_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleVarInput")
    def scale_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__512a7c3f0cf14002357dfdb3f98fa391e855d7436ca6f4492f2281a4032bb6cf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0f97ca8a036609fc2292a8fadce6da43eafa6693b966b5d4c9dded89d0e9bf06)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="placement")
    def placement(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placement"))

    @placement.setter
    def placement(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__298f8aa79bee7f6ecad668723d6bf7b108d3c91a3a2ce9cfc55f321f9cb0d51f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placement", value)

    @builtins.property
    @jsii.member(jsii_name="placementVar")
    def placement_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placementVar"))

    @placement_var.setter
    def placement_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a335030f57844542a848f18508a1abce3695c5ff2da9c2b83854da34b468c70b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placementVar", value)

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scale"))

    @scale.setter
    def scale(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b34cfcc89951e3c1b25f00c806e570ef98b8a332478e08a882a9fb9312b6b21a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scale", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimension")
    def scale_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimension"))

    @scale_dimension.setter
    def scale_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__34f6f2d2154dc844ea4330f3dc58566b468cbe618dbf62c3b75e5772de32140e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimension", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVar")
    def scale_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimensionVar"))

    @scale_dimension_var.setter
    def scale_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5dbb30bd66a4a53aab7c8c520f4dbcd140151cae3603fc0935ca92e882299c8e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="scaleVar")
    def scale_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleVar"))

    @scale_var.setter
    def scale_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ac2bb4a250fca289274f2fda86770647baed38bafa796057aaabeca7c8f6378)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa7f263d71813dfdd6e329d261e0cd0ef901f451f82e93082179e5123fcd9539)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__69c6960f8bfb7c6386ab67fe3788c7e1435b9f63dc841a68c9e7761147bd0dd4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8e5b91c1e40ea1282d4a636e94289797e4060ff4af76c658a2521665185b691c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d55f1f24c61ff22a58eb383121e355ebbc4f007f671af746e0bebcd4a05147ec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitComposite]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitComposite]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitComposite]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__779c7e608450a83192a237c88d34098f1843ae67e483fc2a936bb46101622dd4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitCompound",
    jsii_struct_bases=[],
    name_mapping={"transformations": "transformations"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitCompound:
    def __init__(
        self,
        *,
        transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param transformations: transformations block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fc1815f341403b32a87475d8c35827b6e910c3085341c08a4b7f1154ed61a48f)
            check_type(argname="argument transformations", value=transformations, expected_type=type_hints["transformations"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if transformations is not None:
            self._values["transformations"] = transformations

    @builtins.property
    def transformations(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitCompoundTransformations"]]]:
        '''transformations block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        result = self._values.get("transformations")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitCompoundTransformations"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitCompound(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitCompoundList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitCompoundList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f6e6530f69bb109568d5223518dc154177236411f4bead3525ca4eacfa28f0ce)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitCompoundOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b56c2e274a7f3ae2a4905315a8268b51ce85875dba2dcb4570d36dc02b91fac9)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitCompoundOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__95fb48c03c2e8a442ae52eb3ec4523ca37426f28613883b58e164db7241b41a3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__415215a92dc86670487d741b8594c01f42c07cf44aeae911cacad4a41d68bef8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ad080c839a1b01677a64e92c8924206a523504f4dcb9bb15b005fb7147d54c19)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitCompound]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitCompound]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bcbaec178b54cd054a298427b064029023f5890aa85d828fb53bc3259e030a83)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitCompoundOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitCompoundOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0c65ce276aac3031b65844a5aaecf010b5df5809b46b835a240b40b3e37e3ded)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformations")
    def put_transformations(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ebf6aa802b0817bef80b9b6187a3af710a8647ae1d66f9cfe75ff7af544f2ff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTransformations", [value]))

    @jsii.member(jsii_name="resetTransformations")
    def reset_transformations(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformations", []))

    @builtins.property
    @jsii.member(jsii_name="transformations")
    def transformations(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitCompoundTransformationsList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitCompoundTransformationsList", jsii.get(self, "transformations"))

    @builtins.property
    @jsii.member(jsii_name="transformationsInput")
    def transformations_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitCompoundTransformations"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitCompoundTransformations"]]], jsii.get(self, "transformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitCompound]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitCompound]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitCompound]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__756adace0e3aa1f070ec3ce76854aa828c3565a6cda944917f4dad58f0b95b2c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitCompoundTransformations",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitCompoundTransformations:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitCompoundTransformations(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitCompoundTransformationsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitCompoundTransformationsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4c624d1a0767b266f83578600b319402c2217b95c2f8db5660998a27da410eb5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitCompoundTransformationsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a44523e5f251a858039c353b382b951113740c50af5253b83a0c5f05e6a40593)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitCompoundTransformationsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c60b9030be21ba5aa7ef004dc16d695f42fd228a46ceffa665cd13899b686fd0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5d5ad5ae554804c6ffd8186bd18ab5223a70a80673df327d26f1c7eae2541b3e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f1bdd2c8faf97d6f275b25e6a66689c334ed7146e6743d0e343e8953bb601782)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitCompoundTransformations]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitCompoundTransformations]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitCompoundTransformations]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0daa22820906fe342b46e59880aac38e89cafd80d8c1f3f4e1feb7c0df5d0c3a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitCompoundTransformationsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitCompoundTransformationsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d86842511d905bdd6ed31241368cb5602aa127c49e37326304bdc113b5f7c58e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitCompoundTransformations]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitCompoundTransformations]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitCompoundTransformations]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__386bda9948d1c082400eb1fe534ee3e54c176ae92a2f9ff971b01cb4941d82af)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitContrast",
    jsii_struct_bases=[],
    name_mapping={
        "brightness": "brightness",
        "brightness_var": "brightnessVar",
        "contrast": "contrast",
        "contrast_var": "contrastVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitContrast:
    def __init__(
        self,
        *,
        brightness: typing.Optional[builtins.str] = None,
        brightness_var: typing.Optional[builtins.str] = None,
        contrast: typing.Optional[builtins.str] = None,
        contrast_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param brightness: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        :param brightness_var: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        :param contrast: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param contrast_var: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fc8c86755ba5341dcd0a8867797407d62c7b995dd0b2cc8f82e9b94e02119514)
            check_type(argname="argument brightness", value=brightness, expected_type=type_hints["brightness"])
            check_type(argname="argument brightness_var", value=brightness_var, expected_type=type_hints["brightness_var"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument contrast_var", value=contrast_var, expected_type=type_hints["contrast_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if brightness is not None:
            self._values["brightness"] = brightness
        if brightness_var is not None:
            self._values["brightness_var"] = brightness_var
        if contrast is not None:
            self._values["contrast"] = contrast
        if contrast_var is not None:
            self._values["contrast_var"] = contrast_var

    @builtins.property
    def brightness(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        '''
        result = self._values.get("brightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def brightness_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        '''
        result = self._values.get("brightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        result = self._values.get("contrast_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitContrast(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitContrastList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitContrastList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__18d933f557d0a3d0053370853999405412be5401625a435df4bcbabd3a32c352)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitContrastOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3403e23315bddc4862605a54cf90628dc7b74febf1a13ea46005c3ac84db3ec1)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitContrastOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c1efe7a5636913acfb938bcb4ea7e622020c58eac5bff7f7d4835b0e3ca05e06)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__273322fe25b4f080a241be09217137cdb6c3f529fb4d9eaeaf54ec2657235de5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__08e7b3bb34102398a0f4191e3c6f93cc0ef9b80851dd495470504f7ad1668307)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitContrast]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitContrast]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b661e549829b8140bd8a260a568b2b78369e58dc90d83464bd0457c12213aa38)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitContrastOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitContrastOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1a64f43ee2ed3e0e09ba2da6e83df6292d5e17be99d9afcff7f9e26e6339b97a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetBrightness")
    def reset_brightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightness", []))

    @jsii.member(jsii_name="resetBrightnessVar")
    def reset_brightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightnessVar", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetContrastVar")
    def reset_contrast_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrastVar", []))

    @builtins.property
    @jsii.member(jsii_name="brightnessInput")
    def brightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="brightnessVarInput")
    def brightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastVarInput")
    def contrast_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="brightness")
    def brightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightness"))

    @brightness.setter
    def brightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__367dad26fc5a4101c10ff04fdad64d8305bf02d35b64a650bff15b3bf5c7c239)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightness", value)

    @builtins.property
    @jsii.member(jsii_name="brightnessVar")
    def brightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightnessVar"))

    @brightness_var.setter
    def brightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3316a8445347625ca7784ecf3f39e61de3d0fb9a3b9eaf47eb06254a3645a947)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrast"))

    @contrast.setter
    def contrast(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea12fa71a6cd2b095c0c2edcd8b918b1958cdcf2fe7f195e0bdcc4aa8662bcd7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrast", value)

    @builtins.property
    @jsii.member(jsii_name="contrastVar")
    def contrast_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrastVar"))

    @contrast_var.setter
    def contrast_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__90dc468e76d8dd6b49541ddfb86698d2a33ff390cd6bc6c6f6a2a8e0bc0c01b0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrastVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitContrast]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitContrast]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitContrast]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b59d7e3a10cc5cdaf1f337b3be041e8137c0924e8591a8645dd98e56719289a6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitGoop",
    jsii_struct_bases=[],
    name_mapping={
        "chaos": "chaos",
        "chaos_var": "chaosVar",
        "density": "density",
        "density_var": "densityVar",
        "power": "power",
        "power_var": "powerVar",
        "seed": "seed",
        "seed_var": "seedVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitGoop:
    def __init__(
        self,
        *,
        chaos: typing.Optional[builtins.str] = None,
        chaos_var: typing.Optional[builtins.str] = None,
        density: typing.Optional[builtins.str] = None,
        density_var: typing.Optional[builtins.str] = None,
        power: typing.Optional[builtins.str] = None,
        power_var: typing.Optional[builtins.str] = None,
        seed: typing.Optional[builtins.str] = None,
        seed_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param chaos: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        :param chaos_var: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        :param density: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        :param density_var: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        :param power: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        :param power_var: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        :param seed: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        :param seed_var: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b1202a075bb1d7b795715215bc90d744817cb268bd4259683da8f8d4d02dc297)
            check_type(argname="argument chaos", value=chaos, expected_type=type_hints["chaos"])
            check_type(argname="argument chaos_var", value=chaos_var, expected_type=type_hints["chaos_var"])
            check_type(argname="argument density", value=density, expected_type=type_hints["density"])
            check_type(argname="argument density_var", value=density_var, expected_type=type_hints["density_var"])
            check_type(argname="argument power", value=power, expected_type=type_hints["power"])
            check_type(argname="argument power_var", value=power_var, expected_type=type_hints["power_var"])
            check_type(argname="argument seed", value=seed, expected_type=type_hints["seed"])
            check_type(argname="argument seed_var", value=seed_var, expected_type=type_hints["seed_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if chaos is not None:
            self._values["chaos"] = chaos
        if chaos_var is not None:
            self._values["chaos_var"] = chaos_var
        if density is not None:
            self._values["density"] = density
        if density_var is not None:
            self._values["density_var"] = density_var
        if power is not None:
            self._values["power"] = power
        if power_var is not None:
            self._values["power_var"] = power_var
        if seed is not None:
            self._values["seed"] = seed
        if seed_var is not None:
            self._values["seed_var"] = seed_var

    @builtins.property
    def chaos(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        '''
        result = self._values.get("chaos")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def chaos_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        '''
        result = self._values.get("chaos_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        '''
        result = self._values.get("density")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density_var(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        '''
        result = self._values.get("density_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        '''
        result = self._values.get("power")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power_var(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        '''
        result = self._values.get("power_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        '''
        result = self._values.get("seed")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed_var(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        result = self._values.get("seed_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitGoop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitGoopList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitGoopList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__41d79a29bca1e62c0c2e81e3a20c81d0b52d9c3f5f0c7bd0a180ae9e56011a84)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitGoopOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6c69a51312e6b600b714184fbfe787270d84ed76fa1ee771d08b4318ce318c18)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitGoopOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4d55fe3cb06fae33d7281a8f3d35daa0030afa09f4e27d5e15bd5a9ec65a4df6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__548b020397453e71459d7ef022dcf1cc25981a50e20075d26c63b3d86558ddb6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3814ed358d1b5a4eab08e8ae0908e518373731e9ddea41413b9dcd6435435239)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitGoop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitGoop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb6b661670f9faafe61404c57189dfb6d2123edb37c45e01d79ed693e1925503)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitGoopOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitGoopOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bdabe8790e620ab04759e1f9bc4834f2ba42cab6b54be877455a457978e2607b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetChaos")
    def reset_chaos(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaos", []))

    @jsii.member(jsii_name="resetChaosVar")
    def reset_chaos_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaosVar", []))

    @jsii.member(jsii_name="resetDensity")
    def reset_density(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensity", []))

    @jsii.member(jsii_name="resetDensityVar")
    def reset_density_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensityVar", []))

    @jsii.member(jsii_name="resetPower")
    def reset_power(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPower", []))

    @jsii.member(jsii_name="resetPowerVar")
    def reset_power_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPowerVar", []))

    @jsii.member(jsii_name="resetSeed")
    def reset_seed(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeed", []))

    @jsii.member(jsii_name="resetSeedVar")
    def reset_seed_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeedVar", []))

    @builtins.property
    @jsii.member(jsii_name="chaosInput")
    def chaos_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosInput"))

    @builtins.property
    @jsii.member(jsii_name="chaosVarInput")
    def chaos_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosVarInput"))

    @builtins.property
    @jsii.member(jsii_name="densityInput")
    def density_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityInput"))

    @builtins.property
    @jsii.member(jsii_name="densityVarInput")
    def density_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="powerInput")
    def power_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerInput"))

    @builtins.property
    @jsii.member(jsii_name="powerVarInput")
    def power_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerVarInput"))

    @builtins.property
    @jsii.member(jsii_name="seedInput")
    def seed_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedInput"))

    @builtins.property
    @jsii.member(jsii_name="seedVarInput")
    def seed_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedVarInput"))

    @builtins.property
    @jsii.member(jsii_name="chaos")
    def chaos(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaos"))

    @chaos.setter
    def chaos(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a2a022a38c963310a478ae123b7a56c725cfe1098e9ffb0577708592d14fa7d7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaos", value)

    @builtins.property
    @jsii.member(jsii_name="chaosVar")
    def chaos_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaosVar"))

    @chaos_var.setter
    def chaos_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__98dcba39f0a26d14ac71de2b9a6f004b3ccb3b7d08e5736658bdcaf47248e76d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaosVar", value)

    @builtins.property
    @jsii.member(jsii_name="density")
    def density(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "density"))

    @density.setter
    def density(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5e98335d03c459f7d4fe90b24f07927802f17122c2c956dbb345209b394fde3b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "density", value)

    @builtins.property
    @jsii.member(jsii_name="densityVar")
    def density_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "densityVar"))

    @density_var.setter
    def density_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4f81565997a95d81d2510a37a1d1a9090ff9b4972050e54fdff48663d5fdb267)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "densityVar", value)

    @builtins.property
    @jsii.member(jsii_name="power")
    def power(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "power"))

    @power.setter
    def power(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__25a62414ab4a3509472a8ffce589cfe9f51131b45423dd01f4d55587d958803f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "power", value)

    @builtins.property
    @jsii.member(jsii_name="powerVar")
    def power_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "powerVar"))

    @power_var.setter
    def power_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c14e3c230aca05dd3d2b9583df9c34467f1665829de03d096357c77f125317f8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "powerVar", value)

    @builtins.property
    @jsii.member(jsii_name="seed")
    def seed(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seed"))

    @seed.setter
    def seed(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__33ad8706ce906f4ae28da2f3bebb22e9e0e667e354b2a00e0428dc12c106389d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seed", value)

    @builtins.property
    @jsii.member(jsii_name="seedVar")
    def seed_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seedVar"))

    @seed_var.setter
    def seed_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f0291ca5b083a554de392ae34b2d812d2f2c9d60cd296abe58263fa3ccb43426)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seedVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitGoop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitGoop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitGoop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__00a561ef12d6511ecec849b546001624a4f4e029efdd51b94ec77fa555fdecb5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitGrayscale",
    jsii_struct_bases=[],
    name_mapping={"type": "type", "type_var": "typeVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitGrayscale:
    def __init__(
        self,
        *,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param type: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0810abc6cd278c3902466c13d175bb783dfb61155faef224fac22f69d8a97792)
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitGrayscale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitGrayscaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitGrayscaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2e94151cf9e814267e8fa9d62d23f4190609d3c2365432ab74d09b833268306e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitGrayscaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0c4f2319e77dbee72cdc6bbd8538578f1e521895020c4f2b19a7d26c6a8c0096)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitGrayscaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a9895799f7db7e41f4a7650a9834269fdbd7d88fd1bd3db3913b40889f68224f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aa8208f10659e00820de8e80f3a2dded37b455c2e141828a1e675a24cf6713e3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a405583db8b6d3f6a7c3b509519a760ab245e76a803ea5ff3bdb113b6d09484c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitGrayscale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitGrayscale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__00a8a45b0f12ed6b7588edaec07a4167d018d965e830198b0e0688d3076b2de2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitGrayscaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitGrayscaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa2e5bd68b1c1de437377271cb217194e96e8a59e9fd9c1ec77b23c11c562e76)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d9856151a6965309f4c00ba017472bf2f76f8546903fdcc6481f84017135495e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f994e05bd002f8305b1f4baa84c6b78ea58cb7feb4e65410fc602f4715f9e58c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitGrayscale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitGrayscale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitGrayscale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fb3d9d69a3f539434eaf48a5b8fe2425125e98ee9e50f2c974b2488c23ffe5db)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitHsl",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "lightness": "lightness",
        "lightness_var": "lightnessVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitHsl:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness: typing.Optional[builtins.str] = None,
        lightness_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        :param lightness_var: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ce2dfc7a1660108c82bb517c5b1a8178ccb31d2075eb75a0632165ea3d524e6b)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness", value=lightness, expected_type=type_hints["lightness"])
            check_type(argname="argument lightness_var", value=lightness_var, expected_type=type_hints["lightness_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness is not None:
            self._values["lightness"] = lightness
        if lightness_var is not None:
            self._values["lightness_var"] = lightness_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        '''
        result = self._values.get("lightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        '''
        result = self._values.get("lightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitHsl(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitHslList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitHslList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__743a9eee62e322b015a8c1dc01c477637df1e2adbd5cfbfe370589df04bd6ac6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitHslOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e880e964dd4a558cc775203625c623c274ba6c061abb841d596c84ea8350f9e)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitHslOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__55a6e87862a52f735653e7440be0834ea84b539cc6f18b19e784556a2d5d8e00)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9dd585e61fd9e73a9c5c45169a0de22918814fa32c0a7875e7b3527089dd9ac3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e255942a7f1814875ceb78effe9ad2976da37d8d6506cf3f33bee8b0f707e251)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitHsl]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitHsl]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a297d8a2b10b894d96506c75967ef6b33b5be4d9a2ceb95b357fd6ac5aafd5a8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitHslOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitHslOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7a80952cceca87d54d335764e213f28c0639b6ebd6654f29b290445af713c0cf)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightness")
    def reset_lightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightness", []))

    @jsii.member(jsii_name="resetLightnessVar")
    def reset_lightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessInput")
    def lightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessVarInput")
    def lightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__336f9894c459123607792ef0c7b19ca3dbe896f09b8d7ef13e4eb57d9955da88)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ab6e25ecaed7e501a56a01a14c5c0f1fd22bc3e2c706fbc1d2231cf8f624146)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightness")
    def lightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightness"))

    @lightness.setter
    def lightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__631845ecefbf15ca62a6c3b97f1836c21efb4cabca5be12e240d74aeb6cb2227)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightness", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessVar")
    def lightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessVar"))

    @lightness_var.setter
    def lightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__89280b28c2b0f3557bad97102b0e21176621b61fb9ecc19462594f4d8f4acdfd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3c64eafa22de8435e8802b254b99fdf5e2c7ecfff8c32fe0bb90399d679e5642)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bd30096880fe653320bbdb092278b0636162bde2ae29f2fbceac862ead6fb60b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitHsl]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitHsl]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitHsl]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__68fe37939617a5dcb1b31817f3fe494544a3a19ca43444c5d9640197f7f2ec2f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitHsv",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitHsv:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        :param value: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f74866b1badf42514148e2d7bb3a5767351b72d66552b9264041c28737a08ae6)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitHsv(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitHsvList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitHsvList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__90ad0a33c07a8a4c6f1eb7a8e0451c86c26194f229c18c27052d21eed2078d29)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitHsvOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__85c188b86d745ef51872506bac34b9ea1211a714e017a2ea0c78005208daf873)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitHsvOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5158e83d34afd1466393b6d61b6317a6dee9ad4a352e116cbfe7b63d1a121934)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0e17b1bf97fa8ba2600c9dc4fde6a028b7406cc3d75b47339dcebc881aa68d94)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__94176f92c47f1f2757564883be518905178003b7da066b611ace945eb2d11f4b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitHsv]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitHsv]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b4b25b45207552add41a0c743199a78d8f9f9d2da110fd114b9374484a018032)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitHsvOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitHsvOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9264345bb8c347c15428129565524d9a5a4ca0058d87dd3696258752f17779c6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__84bad497f18edfa82067976339e136c9df613ed0dc9ebd190f44d4a6dc742324)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cdc8d7b14a8c43d8163ea885d6f25d4504046128d21397fcb53158fe966e32cf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1e4bff9a5b62be4d3ac213518f5e0a041a3934639091fcd4e2832285d4188a35)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fd489c67401c4c0864631b92f5cf296a2a3289620084809fc8c2428c89451e79)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b570cbd82cdf8e605979d2d0264bac45ade07eaf276ce30713281bc8de3e7430)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7b4597929e8d1533569aabebb0b3681b7e723455abe7ff85ae3d5c273677f4ab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitHsv]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitHsv]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitHsv]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b211b3746da5117b01af55d38920388378958faff6f74f7eaee24ce13c714c18)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfDimension",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "dimension": "dimension",
        "dimension_var": "dimensionVar",
        "equal": "equal",
        "greater_than": "greaterThan",
        "less_than": "lessThan",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfDimension:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        dimension: typing.Optional[builtins.str] = None,
        dimension_var: typing.Optional[builtins.str] = None,
        equal: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionEqual", typing.Dict[builtins.str, typing.Any]]] = None,
        greater_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionGreaterThan", typing.Dict[builtins.str, typing.Any]]] = None,
        less_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionLessThan", typing.Dict[builtins.str, typing.Any]]] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param dimension: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        :param dimension_var: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        :param equal: equal block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        :param greater_than: greater_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        :param less_than: less_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        :param value: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionDefault(**default)
        if isinstance(equal, dict):
            equal = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionEqual(**equal)
        if isinstance(greater_than, dict):
            greater_than = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionGreaterThan(**greater_than)
        if isinstance(less_than, dict):
            less_than = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionLessThan(**less_than)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e26e01889f5fae1aa4639193d2fada7ebf406b4ad317e756a12eeaf3484739e)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument dimension", value=dimension, expected_type=type_hints["dimension"])
            check_type(argname="argument dimension_var", value=dimension_var, expected_type=type_hints["dimension_var"])
            check_type(argname="argument equal", value=equal, expected_type=type_hints["equal"])
            check_type(argname="argument greater_than", value=greater_than, expected_type=type_hints["greater_than"])
            check_type(argname="argument less_than", value=less_than, expected_type=type_hints["less_than"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if dimension is not None:
            self._values["dimension"] = dimension
        if dimension_var is not None:
            self._values["dimension_var"] = dimension_var
        if equal is not None:
            self._values["equal"] = equal
        if greater_than is not None:
            self._values["greater_than"] = greater_than
        if less_than is not None:
            self._values["less_than"] = less_than
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionDefault"], result)

    @builtins.property
    def dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        '''
        result = self._values.get("dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        '''
        result = self._values.get("dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def equal(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionEqual"]:
        '''equal block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        '''
        result = self._values.get("equal")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionEqual"], result)

    @builtins.property
    def greater_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionGreaterThan"]:
        '''greater_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        '''
        result = self._values.get("greater_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionGreaterThan"], result)

    @builtins.property
    def less_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionLessThan"]:
        '''less_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        '''
        result = self._values.get("less_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionLessThan"], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfDimension(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0f75dab71e61c2ca764539168f02a452081bfee6dc266c0af57c670d7d4484ec)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b897d13591c1604e80947f3a71c163babf71bf3ccecb2140a877a8f9580795b2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionEqual",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionEqual:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionEqual(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionEqualOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionEqualOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a7f989afe4f1d7c22303c16c555343a22b1ccce662fdcae3adcc74e68965bf21)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionEqual], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionEqual],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0cb8ff3a708fcd6166b4ceb0681631875e704d1253a9e084ace6a3f986d04a52)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionGreaterThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionGreaterThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionGreaterThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionGreaterThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionGreaterThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__657c59faffcc9637d0919c52b9667dd0de4e90ef57372bf078102015b2861006)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionGreaterThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionGreaterThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0a0dd6bcd87fcc25e2da86bca444f3c3bbfdae4e98426348e0390dfae1ce9e64)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionLessThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionLessThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionLessThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionLessThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionLessThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1a3ba4d3c600ec3c1e74579a61680c4ed1eb98ef45ff96b6136b50755af038e5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionLessThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionLessThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5eb9cd3b7a4108fbe95455acef960e3d5fa6986b7ae38e49f0a98b718682408e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__612df7fdd8cc22b33f99f23a5934843021a402b3e5074f6997347a8ee10c3031)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__268a4e0bcc3484d8e4cba2340b5b91f65e4ce1b51431f989d139d72b95ee2315)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ac00592382049b0b7a8085d3de332e75beb0d5f9bbcfe88dc4d3502cd96e2d2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dd62c173d6dab1a803a863d4db2ac5c91d10ad35da061142aacb9652633397f0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c8570af5f1321e5305109707dfac38104aae97abe560bd660dcb2da8e5e39610)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfDimension]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfDimension]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__53d811d597519e0eee76986f05e54f9811e6a99bfc1b6249ec9c6a8fcac71dd9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fab08d736c2c1b9762015bd4f0740e40186af32bb56e0f4b5e5ab91fd681840b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putEqual")
    def put_equal(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionEqual()

        return typing.cast(None, jsii.invoke(self, "putEqual", [value]))

    @jsii.member(jsii_name="putGreaterThan")
    def put_greater_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionGreaterThan()

        return typing.cast(None, jsii.invoke(self, "putGreaterThan", [value]))

    @jsii.member(jsii_name="putLessThan")
    def put_less_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionLessThan()

        return typing.cast(None, jsii.invoke(self, "putLessThan", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetDimension")
    def reset_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimension", []))

    @jsii.member(jsii_name="resetDimensionVar")
    def reset_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimensionVar", []))

    @jsii.member(jsii_name="resetEqual")
    def reset_equal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEqual", []))

    @jsii.member(jsii_name="resetGreaterThan")
    def reset_greater_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGreaterThan", []))

    @jsii.member(jsii_name="resetLessThan")
    def reset_less_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLessThan", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="equal")
    def equal(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionEqualOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionEqualOutputReference, jsii.get(self, "equal"))

    @builtins.property
    @jsii.member(jsii_name="greaterThan")
    def greater_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionGreaterThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionGreaterThanOutputReference, jsii.get(self, "greaterThan"))

    @builtins.property
    @jsii.member(jsii_name="lessThan")
    def less_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionLessThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionLessThanOutputReference, jsii.get(self, "lessThan"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionInput")
    def dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionVarInput")
    def dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="equalInput")
    def equal_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionEqual], jsii.get(self, "equalInput"))

    @builtins.property
    @jsii.member(jsii_name="greaterThanInput")
    def greater_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionGreaterThan], jsii.get(self, "greaterThanInput"))

    @builtins.property
    @jsii.member(jsii_name="lessThanInput")
    def less_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionLessThan], jsii.get(self, "lessThanInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="dimension")
    def dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimension"))

    @dimension.setter
    def dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7b3d3ff2781e9e87e0c2ccbb2de733be9bafa66f73ad413895bf00eb72b6e188)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimension", value)

    @builtins.property
    @jsii.member(jsii_name="dimensionVar")
    def dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimensionVar"))

    @dimension_var.setter
    def dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__898f991390f48ce8bcaa80e5307d3407988a82edeab493a91c3ac96b25d1cbb8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__918706e09652d2f50344028c44ef7e30db0d6a94e4a5d9c4e91ddc0fd45794c8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__53587761d61aca8e300704c831316db6c86dc93342d4fd96b03a642c3ccbe5ad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfDimension]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfDimension]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfDimension]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__734ee7424222c187e6fd24f7b7c4693206a9cc60104417dbb0d35a6612ddcb8c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientation",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "landscape": "landscape",
        "portrait": "portrait",
        "square": "square",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientation:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        landscape: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationLandscape", typing.Dict[builtins.str, typing.Any]]] = None,
        portrait: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationPortrait", typing.Dict[builtins.str, typing.Any]]] = None,
        square: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationSquare", typing.Dict[builtins.str, typing.Any]]] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param landscape: landscape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        :param portrait: portrait block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        :param square: square block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationDefault(**default)
        if isinstance(landscape, dict):
            landscape = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationLandscape(**landscape)
        if isinstance(portrait, dict):
            portrait = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationPortrait(**portrait)
        if isinstance(square, dict):
            square = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationSquare(**square)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fff88cfa2136f181d12c7d20a65097bb3d51a7b48ce904169aa0baa4fe404f00)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument landscape", value=landscape, expected_type=type_hints["landscape"])
            check_type(argname="argument portrait", value=portrait, expected_type=type_hints["portrait"])
            check_type(argname="argument square", value=square, expected_type=type_hints["square"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if landscape is not None:
            self._values["landscape"] = landscape
        if portrait is not None:
            self._values["portrait"] = portrait
        if square is not None:
            self._values["square"] = square

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationDefault"], result)

    @builtins.property
    def landscape(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationLandscape"]:
        '''landscape block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        '''
        result = self._values.get("landscape")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationLandscape"], result)

    @builtins.property
    def portrait(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationPortrait"]:
        '''portrait block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        '''
        result = self._values.get("portrait")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationPortrait"], result)

    @builtins.property
    def square(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationSquare"]:
        '''square block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        result = self._values.get("square")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationSquare"], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ddf0d3091de51ee392cc8856cbf8a2efcd51c75735991fca07e124abc9621548)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ad63fea47633578dc738f0030caf9e55b5db1e3a50ab79b67657dde8338b9ab2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationLandscape",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationLandscape:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationLandscape(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationLandscapeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationLandscapeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__17054f97f588c47192c6edd94378fde41b1179cf4501bf28d9d98628a056704e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationLandscape], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationLandscape],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e30fde230db0ea7ff0e385d0ce7c557c8849d3de6f27fd1dbcaad6878e148f23)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5d943729d8d325f2af505899157bdce220c5b1e73efe949fbef45e355b57480e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5e031af6b5ef2b9dd4f9db6f054853c905d5f8e8e6d5cdbccd22067963cefad6)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__238dff9656251ee346f525b0a03dcbef566f7a7c69175f40b0a059d892009ea7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__254fb17ec71ef453f284cc23519fc4ff53a7ccbf74091502b7448d8cffb3d371)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__567229cd86beff8cdfc12efaf0ef0a4251517eb444d5a7f3124a1a77b145a01d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientation]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientation]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b9d0b5b9c74449cb59c25fcdf88a3c073bcb1f668a0213e6cd56ba143aefcc0e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dea474fab2fab211a6cf8c12cfe8852a310f42c54ed03e874749b9cd7e8f93a1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putLandscape")
    def put_landscape(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationLandscape()

        return typing.cast(None, jsii.invoke(self, "putLandscape", [value]))

    @jsii.member(jsii_name="putPortrait")
    def put_portrait(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationPortrait()

        return typing.cast(None, jsii.invoke(self, "putPortrait", [value]))

    @jsii.member(jsii_name="putSquare")
    def put_square(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationSquare()

        return typing.cast(None, jsii.invoke(self, "putSquare", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetLandscape")
    def reset_landscape(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLandscape", []))

    @jsii.member(jsii_name="resetPortrait")
    def reset_portrait(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPortrait", []))

    @jsii.member(jsii_name="resetSquare")
    def reset_square(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSquare", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="landscape")
    def landscape(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationLandscapeOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationLandscapeOutputReference, jsii.get(self, "landscape"))

    @builtins.property
    @jsii.member(jsii_name="portrait")
    def portrait(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationPortraitOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationPortraitOutputReference", jsii.get(self, "portrait"))

    @builtins.property
    @jsii.member(jsii_name="square")
    def square(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationSquareOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationSquareOutputReference", jsii.get(self, "square"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="landscapeInput")
    def landscape_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationLandscape], jsii.get(self, "landscapeInput"))

    @builtins.property
    @jsii.member(jsii_name="portraitInput")
    def portrait_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationPortrait"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationPortrait"], jsii.get(self, "portraitInput"))

    @builtins.property
    @jsii.member(jsii_name="squareInput")
    def square_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationSquare"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationSquare"], jsii.get(self, "squareInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientation]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientation]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientation]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__59e309e08f8a4fafbf6ef38c39ca6592c1e89ddb637e63e46de9452ad3bc2955)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationPortrait",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationPortrait:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationPortrait(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationPortraitOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationPortraitOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ae71ffe781d672349fc086eced6a428f86a53431f3767b325a6d3431010f05a2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationPortrait]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationPortrait], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationPortrait],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f0bab730b7f61918026d8a46dbf9371fa434f9d19594f33412759c366c75eefc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationSquare",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationSquare:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationSquare(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationSquareOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationSquareOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fe6e71586b55588186e177626b15274c36c8fa5bd5444ddd4b9b2eb137e2a3b0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationSquare]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationSquare], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationSquare],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__04a3ab523336906b45fc184ff2fa139160eccc0720cb9c983a4a56f3d3f4f12d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitMaxColors",
    jsii_struct_bases=[],
    name_mapping={"colors": "colors", "colors_var": "colorsVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitMaxColors:
    def __init__(
        self,
        *,
        colors: typing.Optional[builtins.str] = None,
        colors_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param colors: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        :param colors_var: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__30d2d17f7f6def19b4525622e6d95c758cefd5d670866aaedc2b5e263d017830)
            check_type(argname="argument colors", value=colors, expected_type=type_hints["colors"])
            check_type(argname="argument colors_var", value=colors_var, expected_type=type_hints["colors_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if colors is not None:
            self._values["colors"] = colors
        if colors_var is not None:
            self._values["colors_var"] = colors_var

    @builtins.property
    def colors(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        '''
        result = self._values.get("colors")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def colors_var(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        result = self._values.get("colors_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitMaxColors(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitMaxColorsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitMaxColorsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fff4dc27342f4a5132d1c5cea1496d6ecc26b86ac3400a8778158d4b39c13da7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitMaxColorsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cb9ce707a90c7598ef5dd285e48492e5e55695096d3da1df2ebda759aa28e7ab)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitMaxColorsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a64fcf5cd51c7db926ae040fed8a47ce1ab259bfe938a8c8c25a0c47a33c0a57)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__621ae2ae134372c17a520af81429170616c61812ee368a5e2d4cb30543f47c5f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6ea2f0fdca40a065ce819f0269188593d674b4512b9022cf412ae9e5a8c63ad1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitMaxColors]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitMaxColors]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d85291f923eb5f736557d9668b9d8d3c15f643233adb4355812afc28d6f1a349)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitMaxColorsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitMaxColorsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ffdafb925a118335dca8a111b1d83d3c216477c730df5a18369392cac93a1fd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColors")
    def reset_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColors", []))

    @jsii.member(jsii_name="resetColorsVar")
    def reset_colors_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorsVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorsInput")
    def colors_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsInput"))

    @builtins.property
    @jsii.member(jsii_name="colorsVarInput")
    def colors_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsVarInput"))

    @builtins.property
    @jsii.member(jsii_name="colors")
    def colors(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colors"))

    @colors.setter
    def colors(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f9d94418713db31927400e05e2b6b7f63aaea1fbdb13fceda1ae2ba3a9a36560)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colors", value)

    @builtins.property
    @jsii.member(jsii_name="colorsVar")
    def colors_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorsVar"))

    @colors_var.setter
    def colors_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__201eb2fa03d5d41d89da6ec3382c23f433b4b8deda8d5c0e739261a12026d362)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorsVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitMaxColors]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitMaxColors]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitMaxColors]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__24711ef2b4b11f31ede0aeee4ebdc598f8cfe082093c218eaebeef0a2f103094)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitMirror",
    jsii_struct_bases=[],
    name_mapping={
        "horizontal": "horizontal",
        "horizontal_var": "horizontalVar",
        "vertical": "vertical",
        "vertical_var": "verticalVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitMirror:
    def __init__(
        self,
        *,
        horizontal: typing.Optional[builtins.str] = None,
        horizontal_var: typing.Optional[builtins.str] = None,
        vertical: typing.Optional[builtins.str] = None,
        vertical_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param horizontal: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        :param horizontal_var: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        :param vertical: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        :param vertical_var: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f034281e0000cb7a1e5bd20fed59f49d15ef87782de356418085ca59b7e02928)
            check_type(argname="argument horizontal", value=horizontal, expected_type=type_hints["horizontal"])
            check_type(argname="argument horizontal_var", value=horizontal_var, expected_type=type_hints["horizontal_var"])
            check_type(argname="argument vertical", value=vertical, expected_type=type_hints["vertical"])
            check_type(argname="argument vertical_var", value=vertical_var, expected_type=type_hints["vertical_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if horizontal is not None:
            self._values["horizontal"] = horizontal
        if horizontal_var is not None:
            self._values["horizontal_var"] = horizontal_var
        if vertical is not None:
            self._values["vertical"] = vertical
        if vertical_var is not None:
            self._values["vertical_var"] = vertical_var

    @builtins.property
    def horizontal(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        '''
        result = self._values.get("horizontal")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def horizontal_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        '''
        result = self._values.get("horizontal_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        '''
        result = self._values.get("vertical")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        result = self._values.get("vertical_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitMirror(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitMirrorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitMirrorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cf9101bb70294e196dfae95d4fe59dfefc61d73beb05975791f025bc61ebf378)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitMirrorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__38b85a00570e43a0b5a45da39110d2c3f348404844d5ebdbd2557b8ccbc3d9ce)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitMirrorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7c5773a18375af22c4ae814e79ee029c73d783764bd178099d961cf9ae3483d3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__71aee85f67735d4afc327d5d5a704164a807f0f985eaa8fc521fb0cf6e55b83e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e4fb0585c6bef31c10008ac691f574c1fd2e4f8745f211544dcff34f2fac846e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitMirror]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitMirror]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac334391288c95cab1c8fda995eef2490a937a9a904f36b3e45b8881e09607b9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitMirrorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitMirrorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d95867388ee81fbedd4c0f214c3a2058f45612f6c90506076f8b61037be0bdc7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHorizontal")
    def reset_horizontal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontal", []))

    @jsii.member(jsii_name="resetHorizontalVar")
    def reset_horizontal_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontalVar", []))

    @jsii.member(jsii_name="resetVertical")
    def reset_vertical(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVertical", []))

    @jsii.member(jsii_name="resetVerticalVar")
    def reset_vertical_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVerticalVar", []))

    @builtins.property
    @jsii.member(jsii_name="horizontalInput")
    def horizontal_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontalVarInput")
    def horizontal_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalInput")
    def vertical_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalVarInput")
    def vertical_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontal")
    def horizontal(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontal"))

    @horizontal.setter
    def horizontal(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__66829e1390bdadad8e6ce8f5fe79901a35c8e4b838968c3de5b4263422244482)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontal", value)

    @builtins.property
    @jsii.member(jsii_name="horizontalVar")
    def horizontal_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontalVar"))

    @horizontal_var.setter
    def horizontal_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2c4f10b1fc41f8ceb4216ab2d8207585491a4448e537d165338e638eea65519a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontalVar", value)

    @builtins.property
    @jsii.member(jsii_name="vertical")
    def vertical(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "vertical"))

    @vertical.setter
    def vertical(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4b21c97bb0b496ca132b2f5e22937e09bfe7d0b4719ca7b5062de6f8d92549b7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "vertical", value)

    @builtins.property
    @jsii.member(jsii_name="verticalVar")
    def vertical_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "verticalVar"))

    @vertical_var.setter
    def vertical_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__60971e0c8a354fec595c1a29653bf0ad18c7210ea19066164d015932f5d1ef46)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "verticalVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitMirror]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitMirror]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitMirror]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__59b238247c97648f00b364b3ebf13475225a1ff5660430952283340070b725fc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitMonoHue",
    jsii_struct_bases=[],
    name_mapping={"hue": "hue", "hue_var": "hueVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitMonoHue:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9b603c5b98d9ababcf981391d0ecb236db98a9d2ed0a5157a204cbc3f8186b7d)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitMonoHue(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitMonoHueList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitMonoHueList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0595c823e91e156559a85354c119520daade14d4d69a90e48f9ebed45060078c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitMonoHueOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd3d067bea40590e920ebb25ea634fea609dd0882a5506332a6e3bb64dd5e714)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitMonoHueOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__07b238f3149be311dd4ee5dee382ce35cd50c5ac6da195c6b95b6f286d1e0d99)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__33edc83247d9a324d1c90e23837f765af4e184230470a50c6be6d2a8f74c35f4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f53e07b6a2fb409f34dc033b7b59e0e723640a84c2341da1874a3f78d0672038)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitMonoHue]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitMonoHue]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__45734b9917091bae20271f6cf77f27bf2b974bcb227230d50a46f02b8cc483be)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitMonoHueOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitMonoHueOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__01d8fc3cdc44517823a23f2f0715ae2a9d03f2e0fe6a7d154677444da9ba5b5f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d41bcf50e896f6babe51049bc58480570a37aefcbb279ffcec470ebf99b80be)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c06c1d2b2485795992e2a4fac80bf676dfbcc67ef2361ebec24e317d860f4f59)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitMonoHue]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitMonoHue]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitMonoHue]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__05238f8bd8b2ef3ce1e57cd4d9313ce67e1ff3e8b1eeee0c35b186bc7c806c98)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitOpacity",
    jsii_struct_bases=[],
    name_mapping={"opacity": "opacity", "opacity_var": "opacityVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitOpacity:
    def __init__(
        self,
        *,
        opacity: typing.Optional[builtins.str] = None,
        opacity_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param opacity: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param opacity_var: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c9cb29260705f21d033e5bd7fb15cf4d1f3fe134c55e040d7b097aec3cbf3dca)
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument opacity_var", value=opacity_var, expected_type=type_hints["opacity_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if opacity is not None:
            self._values["opacity"] = opacity
        if opacity_var is not None:
            self._values["opacity_var"] = opacity_var

    @builtins.property
    def opacity(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def opacity_var(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        result = self._values.get("opacity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitOpacity(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitOpacityList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitOpacityList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0268f63b5eb245ff6df4ca413e95bf8f040de28420c95e67a3730a4c2124bd90)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitOpacityOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7e587c349b0f4050572bdcfc1cff1ca6fc92871152f6f5517b387deab679b4d7)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitOpacityOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e431c033ecbb8ebc848dd353d78f587d36d8f23818b4661c06bd682121ae2409)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__067ef0ae3f61462510e8ea4ff5ef87ba09035e341d9240ece0c139abda95a727)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__619a41e8a0416766ab5df929fcc5c13c6ce495352b939cd8673edf1b3f39f33f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitOpacity]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitOpacity]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d0dce92c5bf89b48422e49f732f8f6c3bcc99f92c7c47572eb9fcc38d02c8aa3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitOpacityOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitOpacityOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8fa99d8768b49a989f3847026adc6376129bb3c28119bc4e8ece1fcee7ad3ef9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetOpacityVar")
    def reset_opacity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacityVar", []))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityVarInput")
    def opacity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacity"))

    @opacity.setter
    def opacity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4bfc5be45eedca626512fe5d4b7c1cd6d28f6a7abbb1323ff94f99876cdc4368)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacity", value)

    @builtins.property
    @jsii.member(jsii_name="opacityVar")
    def opacity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacityVar"))

    @opacity_var.setter
    def opacity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__365c41c6ff67fbbd025be8b08ebbcd8f1677eef432de2348d87e06f26637cb9d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacityVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitOpacity]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitOpacity]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitOpacity]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6730dc587873643fcf3b5922bcd181f1b23fa24942514a1d388c4733b9bc71c3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5db6f46a1592444fdde033331f98edf420bac3407eef1ce6c2e3089a6735b31d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putBackgroundColor")
    def put_background_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0c53ebe126da53fc7f2946d4676b10c148c7bd7c66efe7285cf98aad46e31255)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBackgroundColor", [value]))

    @jsii.member(jsii_name="putBlur")
    def put_blur(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitBlur, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f57a565c506e472db2a8c307b9f5286fe84f3db4260ef44a8c1004241811958a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBlur", [value]))

    @jsii.member(jsii_name="putChromaKey")
    def put_chroma_key(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitChromaKey, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d98c53c4b41bccb325a93e23600519b70cb5c359c9dfdffde4dd326837484f87)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putChromaKey", [value]))

    @jsii.member(jsii_name="putComposite")
    def put_composite(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitComposite, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5c0816240dd36b959fc268dfbd163874b4005c60e3fcd924abb7663b2a6e725c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putComposite", [value]))

    @jsii.member(jsii_name="putCompound")
    def put_compound(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitCompound, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6550e61c9eadd25c8ca1729be82806a108053ed77ab44800bc4f76e3deeba579)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCompound", [value]))

    @jsii.member(jsii_name="putContrast")
    def put_contrast(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitContrast, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__580ce156465a9d698e57a26a89012130347683022a9c270aebae1483a83688d1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putContrast", [value]))

    @jsii.member(jsii_name="putGoop")
    def put_goop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitGoop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9690de5c964e2c4762abbdd656191483f69a4d5ca902e2388e0eabc130198cf3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGoop", [value]))

    @jsii.member(jsii_name="putGrayscale")
    def put_grayscale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitGrayscale, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e12af74dc8c46b2efe94fc5f71706d1483d16e7f86763b25e0f4750e0050e19d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGrayscale", [value]))

    @jsii.member(jsii_name="putHsl")
    def put_hsl(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitHsl, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a796a4ac9892b3fe9da8c9a6df16a75db7b771c67ebdb99cab836cf133c28754)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsl", [value]))

    @jsii.member(jsii_name="putHsv")
    def put_hsv(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitHsv, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e8bc488c248964bc9f68a1e5143e0e6e094d2593d03b111f6164ca7876808f7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsv", [value]))

    @jsii.member(jsii_name="putIfDimension")
    def put_if_dimension(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfDimension, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__06f80daa88a802cb2e259d944febc030414fdf7ff706964805fb5b0a7855c191)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfDimension", [value]))

    @jsii.member(jsii_name="putIfOrientation")
    def put_if_orientation(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b6f9ead83d538d7e0e6a1851ef3b578f6718b738022ba9bc4aea6859d7d6f953)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfOrientation", [value]))

    @jsii.member(jsii_name="putMaxColors")
    def put_max_colors(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitMaxColors, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c787d7f79f308b2d04923a8b06df4dcfebfa1a9f61cd0b8ff14787ededc4fd89)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMaxColors", [value]))

    @jsii.member(jsii_name="putMirror")
    def put_mirror(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitMirror, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f7024d368bf80fbfabd5a9aa2fb3e1e5218d2e1faa530c92b07a90f5f44b23cd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMirror", [value]))

    @jsii.member(jsii_name="putMonoHue")
    def put_mono_hue(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitMonoHue, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__60257a6881984d60115e4be29b0caec39fbcec631b1cb6f52f26dfae320a91a8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMonoHue", [value]))

    @jsii.member(jsii_name="putOpacity")
    def put_opacity(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitOpacity, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4d61692e7096982cff60016e29685408bc09ded732fb5af88659219c6fe8aa4d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putOpacity", [value]))

    @jsii.member(jsii_name="putRemoveColor")
    def put_remove_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitRemoveColor", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e11d332d6a52bb1d6c758219c0f7f7b4af6b022751dafda461ff36770bcf6b5b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRemoveColor", [value]))

    @jsii.member(jsii_name="putUnsharpMask")
    def put_unsharp_mask(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitUnsharpMask", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1faab68dc48a0909617aa3b19487e82c101572aebcca0fdb55b8a1686da178c7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putUnsharpMask", [value]))

    @jsii.member(jsii_name="resetBackgroundColor")
    def reset_background_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBackgroundColor", []))

    @jsii.member(jsii_name="resetBlur")
    def reset_blur(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBlur", []))

    @jsii.member(jsii_name="resetChromaKey")
    def reset_chroma_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChromaKey", []))

    @jsii.member(jsii_name="resetComposite")
    def reset_composite(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetComposite", []))

    @jsii.member(jsii_name="resetCompound")
    def reset_compound(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCompound", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetGoop")
    def reset_goop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGoop", []))

    @jsii.member(jsii_name="resetGrayscale")
    def reset_grayscale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGrayscale", []))

    @jsii.member(jsii_name="resetHsl")
    def reset_hsl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsl", []))

    @jsii.member(jsii_name="resetHsv")
    def reset_hsv(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsv", []))

    @jsii.member(jsii_name="resetIfDimension")
    def reset_if_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfDimension", []))

    @jsii.member(jsii_name="resetIfOrientation")
    def reset_if_orientation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfOrientation", []))

    @jsii.member(jsii_name="resetMaxColors")
    def reset_max_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxColors", []))

    @jsii.member(jsii_name="resetMirror")
    def reset_mirror(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMirror", []))

    @jsii.member(jsii_name="resetMonoHue")
    def reset_mono_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonoHue", []))

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetRemoveColor")
    def reset_remove_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRemoveColor", []))

    @jsii.member(jsii_name="resetUnsharpMask")
    def reset_unsharp_mask(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUnsharpMask", []))

    @builtins.property
    @jsii.member(jsii_name="backgroundColor")
    def background_color(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitBackgroundColorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitBackgroundColorList, jsii.get(self, "backgroundColor"))

    @builtins.property
    @jsii.member(jsii_name="blur")
    def blur(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitBlurList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitBlurList, jsii.get(self, "blur"))

    @builtins.property
    @jsii.member(jsii_name="chromaKey")
    def chroma_key(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitChromaKeyList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitChromaKeyList, jsii.get(self, "chromaKey"))

    @builtins.property
    @jsii.member(jsii_name="composite")
    def composite(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitCompositeList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitCompositeList, jsii.get(self, "composite"))

    @builtins.property
    @jsii.member(jsii_name="compound")
    def compound(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitCompoundList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitCompoundList, jsii.get(self, "compound"))

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitContrastList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitContrastList, jsii.get(self, "contrast"))

    @builtins.property
    @jsii.member(jsii_name="goop")
    def goop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitGoopList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitGoopList, jsii.get(self, "goop"))

    @builtins.property
    @jsii.member(jsii_name="grayscale")
    def grayscale(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitGrayscaleList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitGrayscaleList, jsii.get(self, "grayscale"))

    @builtins.property
    @jsii.member(jsii_name="hsl")
    def hsl(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitHslList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitHslList, jsii.get(self, "hsl"))

    @builtins.property
    @jsii.member(jsii_name="hsv")
    def hsv(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitHsvList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitHsvList, jsii.get(self, "hsv"))

    @builtins.property
    @jsii.member(jsii_name="ifDimension")
    def if_dimension(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionList, jsii.get(self, "ifDimension"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientation")
    def if_orientation(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationList, jsii.get(self, "ifOrientation"))

    @builtins.property
    @jsii.member(jsii_name="maxColors")
    def max_colors(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitMaxColorsList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitMaxColorsList, jsii.get(self, "maxColors"))

    @builtins.property
    @jsii.member(jsii_name="mirror")
    def mirror(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitMirrorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitMirrorList, jsii.get(self, "mirror"))

    @builtins.property
    @jsii.member(jsii_name="monoHue")
    def mono_hue(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitMonoHueList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitMonoHueList, jsii.get(self, "monoHue"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitOpacityList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitOpacityList, jsii.get(self, "opacity"))

    @builtins.property
    @jsii.member(jsii_name="removeColor")
    def remove_color(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitRemoveColorList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitRemoveColorList", jsii.get(self, "removeColor"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMask")
    def unsharp_mask(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitUnsharpMaskList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitUnsharpMaskList", jsii.get(self, "unsharpMask"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColorInput")
    def background_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitBackgroundColor]]], jsii.get(self, "backgroundColorInput"))

    @builtins.property
    @jsii.member(jsii_name="blurInput")
    def blur_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitBlur]]], jsii.get(self, "blurInput"))

    @builtins.property
    @jsii.member(jsii_name="chromaKeyInput")
    def chroma_key_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitChromaKey]]], jsii.get(self, "chromaKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="compositeInput")
    def composite_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitComposite]]], jsii.get(self, "compositeInput"))

    @builtins.property
    @jsii.member(jsii_name="compoundInput")
    def compound_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitCompound]]], jsii.get(self, "compoundInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitContrast]]], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="goopInput")
    def goop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitGoop]]], jsii.get(self, "goopInput"))

    @builtins.property
    @jsii.member(jsii_name="grayscaleInput")
    def grayscale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitGrayscale]]], jsii.get(self, "grayscaleInput"))

    @builtins.property
    @jsii.member(jsii_name="hslInput")
    def hsl_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitHsl]]], jsii.get(self, "hslInput"))

    @builtins.property
    @jsii.member(jsii_name="hsvInput")
    def hsv_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitHsv]]], jsii.get(self, "hsvInput"))

    @builtins.property
    @jsii.member(jsii_name="ifDimensionInput")
    def if_dimension_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfDimension]]], jsii.get(self, "ifDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientationInput")
    def if_orientation_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientation]]], jsii.get(self, "ifOrientationInput"))

    @builtins.property
    @jsii.member(jsii_name="maxColorsInput")
    def max_colors_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitMaxColors]]], jsii.get(self, "maxColorsInput"))

    @builtins.property
    @jsii.member(jsii_name="mirrorInput")
    def mirror_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitMirror]]], jsii.get(self, "mirrorInput"))

    @builtins.property
    @jsii.member(jsii_name="monoHueInput")
    def mono_hue_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitMonoHue]]], jsii.get(self, "monoHueInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitOpacity]]], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="removeColorInput")
    def remove_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitRemoveColor"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitRemoveColor"]]], jsii.get(self, "removeColorInput"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMaskInput")
    def unsharp_mask_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitUnsharpMask"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitUnsharpMask"]]], jsii.get(self, "unsharpMaskInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortrait]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortrait], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortrait],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f544876e194b61820f3688a03410acf5d217dc81170325d84283bea45868ca2a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitRemoveColor",
    jsii_struct_bases=[],
    name_mapping={
        "color": "color",
        "color_var": "colorVar",
        "feather": "feather",
        "feather_var": "featherVar",
        "tolerance": "tolerance",
        "tolerance_var": "toleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitRemoveColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
        feather: typing.Optional[builtins.str] = None,
        feather_var: typing.Optional[builtins.str] = None,
        tolerance: typing.Optional[builtins.str] = None,
        tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        :param feather: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        :param feather_var: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        :param tolerance: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        :param tolerance_var: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__64e86d93f990a69986a7c091e6d67ea10326541514fcab77d6cec25db7998acb)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
            check_type(argname="argument feather", value=feather, expected_type=type_hints["feather"])
            check_type(argname="argument feather_var", value=feather_var, expected_type=type_hints["feather_var"])
            check_type(argname="argument tolerance", value=tolerance, expected_type=type_hints["tolerance"])
            check_type(argname="argument tolerance_var", value=tolerance_var, expected_type=type_hints["tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var
        if feather is not None:
            self._values["feather"] = feather
        if feather_var is not None:
            self._values["feather_var"] = feather_var
        if tolerance is not None:
            self._values["tolerance"] = tolerance
        if tolerance_var is not None:
            self._values["tolerance_var"] = tolerance_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        '''
        result = self._values.get("feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather_var(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        '''
        result = self._values.get("feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        '''
        result = self._values.get("tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance_var(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        result = self._values.get("tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitRemoveColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitRemoveColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitRemoveColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6773a9afe0291121f50821848ed2cf568be62ba58e6d52844bd523b6ce68feeb)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitRemoveColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d2edb9ba48fa624d56f9ecd7c7833da20349a36ce80338fa7f6ba4ced4083c81)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitRemoveColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c6b95e4f5080e8894079c8fcad03f99c44a90275a9d31d163fab3ab73227f6d0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a2efd7e338dbcb61310f80a9476a2159c887ce5e40f658ef7c8450ea1dcbd7b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cf64444719efc8e4f2b3e7fa75a2f2f060571e2fba61330bd513247f05bfd0fb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitRemoveColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitRemoveColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitRemoveColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__434346d51fa7875e5ea99052b022e8e1377d4fda40091cf9556b04685ce72609)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitRemoveColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitRemoveColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a95454ccc5732fd2c80b92b5f684127d697185e4840f0c974a23f20d4841259b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @jsii.member(jsii_name="resetFeather")
    def reset_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeather", []))

    @jsii.member(jsii_name="resetFeatherVar")
    def reset_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatherVar", []))

    @jsii.member(jsii_name="resetTolerance")
    def reset_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTolerance", []))

    @jsii.member(jsii_name="resetToleranceVar")
    def reset_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featherInput")
    def feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherInput"))

    @builtins.property
    @jsii.member(jsii_name="featherVarInput")
    def feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceInput")
    def tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceVarInput")
    def tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8feca5784f4376e268ba30cce228632f2b18825c0850267a594bdb79651286ac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__002c0b8156b0d639d2d814e732b30824cc27f41a2a8a759bbfa30dfc15c7577f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="feather")
    def feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "feather"))

    @feather.setter
    def feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8e9dbbdececae0cbde65af12f738a1e211f04f66b2b090efe60d176c93051e96)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "feather", value)

    @builtins.property
    @jsii.member(jsii_name="featherVar")
    def feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featherVar"))

    @feather_var.setter
    def feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__de6668c745d585463397133473174367ef180f459090ced8398bf8ebe8529add)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featherVar", value)

    @builtins.property
    @jsii.member(jsii_name="tolerance")
    def tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tolerance"))

    @tolerance.setter
    def tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a67d73cf74c2d2c366764f4a204ea9e6fafe019f932b1bb0af542609ac147ce7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tolerance", value)

    @builtins.property
    @jsii.member(jsii_name="toleranceVar")
    def tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "toleranceVar"))

    @tolerance_var.setter
    def tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ba84969e036629d9854fb35bd627930f774a823f3e22221ebe582921444124b0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "toleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitRemoveColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitRemoveColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitRemoveColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__090cfaea2f5166fcbeb8710c2d305f1c434f9afcc658488d71118197b0f1a542)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitUnsharpMask",
    jsii_struct_bases=[],
    name_mapping={
        "gain": "gain",
        "gain_var": "gainVar",
        "sigma": "sigma",
        "sigma_var": "sigmaVar",
        "threshold": "threshold",
        "threshold_var": "thresholdVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitUnsharpMask:
    def __init__(
        self,
        *,
        gain: typing.Optional[builtins.str] = None,
        gain_var: typing.Optional[builtins.str] = None,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
        threshold: typing.Optional[builtins.str] = None,
        threshold_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param gain: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        :param gain_var: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        :param sigma: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        :param threshold: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        :param threshold_var: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__716738f6b201c8870463fb24aae1c00561750a590a7a93ade226a28ea11bc442)
            check_type(argname="argument gain", value=gain, expected_type=type_hints["gain"])
            check_type(argname="argument gain_var", value=gain_var, expected_type=type_hints["gain_var"])
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
            check_type(argname="argument threshold", value=threshold, expected_type=type_hints["threshold"])
            check_type(argname="argument threshold_var", value=threshold_var, expected_type=type_hints["threshold_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if gain is not None:
            self._values["gain"] = gain
        if gain_var is not None:
            self._values["gain_var"] = gain_var
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var
        if threshold is not None:
            self._values["threshold"] = threshold
        if threshold_var is not None:
            self._values["threshold_var"] = threshold_var

    @builtins.property
    def gain(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        '''
        result = self._values.get("gain")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gain_var(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        '''
        result = self._values.get("gain_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        '''
        result = self._values.get("threshold")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold_var(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        result = self._values.get("threshold_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitUnsharpMask(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitUnsharpMaskList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitUnsharpMaskList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e9dcb6c19a6bbd4708520beed68be1f6c5d1a6c274ca935de5cf55caecdd122a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitUnsharpMaskOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a1c2436e0933d14d67e2ab6b2a7d17619540941b897f2cdf216623152ca0f8f5)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitUnsharpMaskOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d8d99bca686a638a8ecfaddfd67d9b53e24f1cfd6030303906b7c76ace16f52a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eb6844b423b2b72015d0b7ab607baab40be375ce58dc3997adcdb69a5ff6c32f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b14aa9f3b4b00c06202851769dfdd874bf77886e4b5e51fa6df8c1127de88f66)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitUnsharpMask]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitUnsharpMask]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitUnsharpMask]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e3ea30b6afd6d54a32526af734eadc54c2e93fe468445dba240f36748cf5a717)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitUnsharpMaskOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitUnsharpMaskOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6af0da5826c3ad5f13013d302bfa9a360c4fcef022447875478fa2778e21ca49)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetGain")
    def reset_gain(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGain", []))

    @jsii.member(jsii_name="resetGainVar")
    def reset_gain_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGainVar", []))

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @jsii.member(jsii_name="resetThreshold")
    def reset_threshold(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThreshold", []))

    @jsii.member(jsii_name="resetThresholdVar")
    def reset_threshold_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThresholdVar", []))

    @builtins.property
    @jsii.member(jsii_name="gainInput")
    def gain_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainInput"))

    @builtins.property
    @jsii.member(jsii_name="gainVarInput")
    def gain_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdInput")
    def threshold_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdVarInput")
    def threshold_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gain")
    def gain(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gain"))

    @gain.setter
    def gain(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ed45a62beb1baebebcae058a4a0b920604416ac5f66dbae48b3f25a2e7e191aa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gain", value)

    @builtins.property
    @jsii.member(jsii_name="gainVar")
    def gain_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gainVar"))

    @gain_var.setter
    def gain_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__24c439a461bef68b415cf20cf492c5f6642aa61e913a95bad1dcdba86d215a63)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gainVar", value)

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ced94df4fda9099b128b0e6ca4880c5aebb22d791a45906999a457678cda975e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb5d390ef7f0d4096a33ba4e23ffecf5b1b0b45e6872c16336570443f4aded3c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="threshold")
    def threshold(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "threshold"))

    @threshold.setter
    def threshold(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a3725547e04a6092e2df70a2a0affe18481c078af074321ca1b3e97bad56997)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "threshold", value)

    @builtins.property
    @jsii.member(jsii_name="thresholdVar")
    def threshold_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "thresholdVar"))

    @threshold_var.setter
    def threshold_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0eb7d8fc80cd74efc499cc06f2c4c04bae68dc5e54bf22f504021f8ca749bff1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "thresholdVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitUnsharpMask]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitUnsharpMask]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitUnsharpMask]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__13c5b8cd1975489464d6883f44c55b877fd755686a9048897799a093f6e77ee1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquare",
    jsii_struct_bases=[],
    name_mapping={
        "background_color": "backgroundColor",
        "blur": "blur",
        "chroma_key": "chromaKey",
        "composite": "composite",
        "compound": "compound",
        "contrast": "contrast",
        "goop": "goop",
        "grayscale": "grayscale",
        "hsl": "hsl",
        "hsv": "hsv",
        "if_dimension": "ifDimension",
        "if_orientation": "ifOrientation",
        "max_colors": "maxColors",
        "mirror": "mirror",
        "mono_hue": "monoHue",
        "opacity": "opacity",
        "remove_color": "removeColor",
        "unsharp_mask": "unsharpMask",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquare:
    def __init__(
        self,
        *,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareBackgroundColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareBlur", typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareChromaKey", typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareComposite", typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareCompound", typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareContrast", typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareGoop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareGrayscale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareHsl", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareHsv", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfDimension", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfOrientation", typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareMaxColors", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareMirror", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareMonoHue", typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareOpacity", typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareRemoveColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareUnsharpMask", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a4bf2fbe085084b498aeb1fba2a2bdc56ebb66ead418da87b8474ced78e5047f)
            check_type(argname="argument background_color", value=background_color, expected_type=type_hints["background_color"])
            check_type(argname="argument blur", value=blur, expected_type=type_hints["blur"])
            check_type(argname="argument chroma_key", value=chroma_key, expected_type=type_hints["chroma_key"])
            check_type(argname="argument composite", value=composite, expected_type=type_hints["composite"])
            check_type(argname="argument compound", value=compound, expected_type=type_hints["compound"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument goop", value=goop, expected_type=type_hints["goop"])
            check_type(argname="argument grayscale", value=grayscale, expected_type=type_hints["grayscale"])
            check_type(argname="argument hsl", value=hsl, expected_type=type_hints["hsl"])
            check_type(argname="argument hsv", value=hsv, expected_type=type_hints["hsv"])
            check_type(argname="argument if_dimension", value=if_dimension, expected_type=type_hints["if_dimension"])
            check_type(argname="argument if_orientation", value=if_orientation, expected_type=type_hints["if_orientation"])
            check_type(argname="argument max_colors", value=max_colors, expected_type=type_hints["max_colors"])
            check_type(argname="argument mirror", value=mirror, expected_type=type_hints["mirror"])
            check_type(argname="argument mono_hue", value=mono_hue, expected_type=type_hints["mono_hue"])
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument remove_color", value=remove_color, expected_type=type_hints["remove_color"])
            check_type(argname="argument unsharp_mask", value=unsharp_mask, expected_type=type_hints["unsharp_mask"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if background_color is not None:
            self._values["background_color"] = background_color
        if blur is not None:
            self._values["blur"] = blur
        if chroma_key is not None:
            self._values["chroma_key"] = chroma_key
        if composite is not None:
            self._values["composite"] = composite
        if compound is not None:
            self._values["compound"] = compound
        if contrast is not None:
            self._values["contrast"] = contrast
        if goop is not None:
            self._values["goop"] = goop
        if grayscale is not None:
            self._values["grayscale"] = grayscale
        if hsl is not None:
            self._values["hsl"] = hsl
        if hsv is not None:
            self._values["hsv"] = hsv
        if if_dimension is not None:
            self._values["if_dimension"] = if_dimension
        if if_orientation is not None:
            self._values["if_orientation"] = if_orientation
        if max_colors is not None:
            self._values["max_colors"] = max_colors
        if mirror is not None:
            self._values["mirror"] = mirror
        if mono_hue is not None:
            self._values["mono_hue"] = mono_hue
        if opacity is not None:
            self._values["opacity"] = opacity
        if remove_color is not None:
            self._values["remove_color"] = remove_color
        if unsharp_mask is not None:
            self._values["unsharp_mask"] = unsharp_mask

    @builtins.property
    def background_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareBackgroundColor"]]]:
        '''background_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        '''
        result = self._values.get("background_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareBackgroundColor"]]], result)

    @builtins.property
    def blur(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareBlur"]]]:
        '''blur block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        '''
        result = self._values.get("blur")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareBlur"]]], result)

    @builtins.property
    def chroma_key(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareChromaKey"]]]:
        '''chroma_key block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        '''
        result = self._values.get("chroma_key")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareChromaKey"]]], result)

    @builtins.property
    def composite(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareComposite"]]]:
        '''composite block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        '''
        result = self._values.get("composite")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareComposite"]]], result)

    @builtins.property
    def compound(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareCompound"]]]:
        '''compound block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        '''
        result = self._values.get("compound")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareCompound"]]], result)

    @builtins.property
    def contrast(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareContrast"]]]:
        '''contrast block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareContrast"]]], result)

    @builtins.property
    def goop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareGoop"]]]:
        '''goop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        '''
        result = self._values.get("goop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareGoop"]]], result)

    @builtins.property
    def grayscale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareGrayscale"]]]:
        '''grayscale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        '''
        result = self._values.get("grayscale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareGrayscale"]]], result)

    @builtins.property
    def hsl(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareHsl"]]]:
        '''hsl block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        '''
        result = self._values.get("hsl")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareHsl"]]], result)

    @builtins.property
    def hsv(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareHsv"]]]:
        '''hsv block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        '''
        result = self._values.get("hsv")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareHsv"]]], result)

    @builtins.property
    def if_dimension(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfDimension"]]]:
        '''if_dimension block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        '''
        result = self._values.get("if_dimension")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfDimension"]]], result)

    @builtins.property
    def if_orientation(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfOrientation"]]]:
        '''if_orientation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        '''
        result = self._values.get("if_orientation")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfOrientation"]]], result)

    @builtins.property
    def max_colors(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareMaxColors"]]]:
        '''max_colors block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        '''
        result = self._values.get("max_colors")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareMaxColors"]]], result)

    @builtins.property
    def mirror(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareMirror"]]]:
        '''mirror block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        '''
        result = self._values.get("mirror")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareMirror"]]], result)

    @builtins.property
    def mono_hue(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareMonoHue"]]]:
        '''mono_hue block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        '''
        result = self._values.get("mono_hue")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareMonoHue"]]], result)

    @builtins.property
    def opacity(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareOpacity"]]]:
        '''opacity block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareOpacity"]]], result)

    @builtins.property
    def remove_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareRemoveColor"]]]:
        '''remove_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        '''
        result = self._values.get("remove_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareRemoveColor"]]], result)

    @builtins.property
    def unsharp_mask(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareUnsharpMask"]]]:
        '''unsharp_mask block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        result = self._values.get("unsharp_mask")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareUnsharpMask"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquare(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareBackgroundColor",
    jsii_struct_bases=[],
    name_mapping={"color": "color", "color_var": "colorVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareBackgroundColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c7532e1e1d3cd5d2a4a6f84c5a95d066608fc490007ceacd79178c26b8e846fa)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareBackgroundColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareBackgroundColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareBackgroundColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ad9ff46cdb532f5c74cb142c70914886ce139ffac780d3dc6f7757ef309e8226)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareBackgroundColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__01cc90286a241b2f94cf7b14d74dc97e236761c68dedd2c7c3d9d76ffb670ae8)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareBackgroundColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__491a774a4fe91e5f11baa7d033cd71c9c4d9051ac8003561012368fd0e80ceb2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d07ccddcca82b9b41a59dce17320fa6798927093b4bd932a4496bdafc82106be)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ce5f863ff6bae93fd4c089e34f992f6733a4c233da32d7a2d61d2faf529bfef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareBackgroundColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareBackgroundColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__19296697db44d34a7cc1a0b1dbb625d5dd50abb9fd50b9cf0ff96177890b980c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareBackgroundColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareBackgroundColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e31ac4cf588945e9a8389702579a556547c0ed7d7947b8424d5c120e6510a429)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fec28fb096a89e081513ce90091cd3b29065ab44ff3dec0a30c4e818cb2f840d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4703a129c6f8a04762b809a352f200e6aec0320f80aaa6b46f612ce9f58c37da)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareBackgroundColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareBackgroundColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareBackgroundColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__14720fd43303115921f193de05ef8041c2dd0480749dde2349a28af3dccfbf79)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareBlur",
    jsii_struct_bases=[],
    name_mapping={"sigma": "sigma", "sigma_var": "sigmaVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareBlur:
    def __init__(
        self,
        *,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param sigma: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ae835f28c30d838f77ecea63d0b850276988807ba890581a97cd7b66fd03fafa)
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareBlur(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareBlurList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareBlurList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__489cc80855ba3dfdac2beb27b01dddf2b8921614b8e9a1abb6af84317c094484)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareBlurOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0fb3a463f62666d58511382a4f0aa61cb89210cfc80179ba33093a33ed4fcd9a)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareBlurOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__86f616d773fe91222b8870a50557c8a6ba7e25819d0ada8d2ffbe2d33653ed80)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__74070f0c5a1ab2b2dc12d6ba4a0158a6c772ddf35e458328fd51879e309efab5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b7c85110b246faad8e28d7faf10972ef33b5ef84a52592df5808cbc3d61e5696)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareBlur]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareBlur]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a9eb5870e0607f1b08acc04eb9214f2937d9c22ca14094db0befa4e07e08db59)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareBlurOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareBlurOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__584dabdf3c4ab166f5ef06d08f0dc160e62eb646f9648d601327a134290a5ca1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__756e358232b3cd1eb8f55397d7087119ab73cacb8f8a3582d0e94bab791b876d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b9812c4aa3855f0013dc7721f89b9246164edd742f786fc879e02d284ffce206)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareBlur]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareBlur]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareBlur]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__041d43302eb0597cda1ed1a053aca73111cb24b20c89881dd9203f6ff33b0fe0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareChromaKey",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_feather": "hueFeather",
        "hue_feather_var": "hueFeatherVar",
        "hue_tolerance": "hueTolerance",
        "hue_tolerance_var": "hueToleranceVar",
        "hue_var": "hueVar",
        "lightness_feather": "lightnessFeather",
        "lightness_feather_var": "lightnessFeatherVar",
        "lightness_tolerance": "lightnessTolerance",
        "lightness_tolerance_var": "lightnessToleranceVar",
        "saturation_feather": "saturationFeather",
        "saturation_feather_var": "saturationFeatherVar",
        "saturation_tolerance": "saturationTolerance",
        "saturation_tolerance_var": "saturationToleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareChromaKey:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_feather: typing.Optional[builtins.str] = None,
        hue_feather_var: typing.Optional[builtins.str] = None,
        hue_tolerance: typing.Optional[builtins.str] = None,
        hue_tolerance_var: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness_feather: typing.Optional[builtins.str] = None,
        lightness_feather_var: typing.Optional[builtins.str] = None,
        lightness_tolerance: typing.Optional[builtins.str] = None,
        lightness_tolerance_var: typing.Optional[builtins.str] = None,
        saturation_feather: typing.Optional[builtins.str] = None,
        saturation_feather_var: typing.Optional[builtins.str] = None,
        saturation_tolerance: typing.Optional[builtins.str] = None,
        saturation_tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_feather: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        :param hue_feather_var: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        :param hue_tolerance: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        :param hue_tolerance_var: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        :param hue_var: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness_feather: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        :param lightness_feather_var: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        :param lightness_tolerance: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        :param lightness_tolerance_var: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        :param saturation_feather: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        :param saturation_feather_var: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        :param saturation_tolerance: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        :param saturation_tolerance_var: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5de568ea5c9430289cfc8834503287c162189907a6e6e116d410328762b2b049)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_feather", value=hue_feather, expected_type=type_hints["hue_feather"])
            check_type(argname="argument hue_feather_var", value=hue_feather_var, expected_type=type_hints["hue_feather_var"])
            check_type(argname="argument hue_tolerance", value=hue_tolerance, expected_type=type_hints["hue_tolerance"])
            check_type(argname="argument hue_tolerance_var", value=hue_tolerance_var, expected_type=type_hints["hue_tolerance_var"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness_feather", value=lightness_feather, expected_type=type_hints["lightness_feather"])
            check_type(argname="argument lightness_feather_var", value=lightness_feather_var, expected_type=type_hints["lightness_feather_var"])
            check_type(argname="argument lightness_tolerance", value=lightness_tolerance, expected_type=type_hints["lightness_tolerance"])
            check_type(argname="argument lightness_tolerance_var", value=lightness_tolerance_var, expected_type=type_hints["lightness_tolerance_var"])
            check_type(argname="argument saturation_feather", value=saturation_feather, expected_type=type_hints["saturation_feather"])
            check_type(argname="argument saturation_feather_var", value=saturation_feather_var, expected_type=type_hints["saturation_feather_var"])
            check_type(argname="argument saturation_tolerance", value=saturation_tolerance, expected_type=type_hints["saturation_tolerance"])
            check_type(argname="argument saturation_tolerance_var", value=saturation_tolerance_var, expected_type=type_hints["saturation_tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_feather is not None:
            self._values["hue_feather"] = hue_feather
        if hue_feather_var is not None:
            self._values["hue_feather_var"] = hue_feather_var
        if hue_tolerance is not None:
            self._values["hue_tolerance"] = hue_tolerance
        if hue_tolerance_var is not None:
            self._values["hue_tolerance_var"] = hue_tolerance_var
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness_feather is not None:
            self._values["lightness_feather"] = lightness_feather
        if lightness_feather_var is not None:
            self._values["lightness_feather_var"] = lightness_feather_var
        if lightness_tolerance is not None:
            self._values["lightness_tolerance"] = lightness_tolerance
        if lightness_tolerance_var is not None:
            self._values["lightness_tolerance_var"] = lightness_tolerance_var
        if saturation_feather is not None:
            self._values["saturation_feather"] = saturation_feather
        if saturation_feather_var is not None:
            self._values["saturation_feather_var"] = saturation_feather_var
        if saturation_tolerance is not None:
            self._values["saturation_tolerance"] = saturation_tolerance
        if saturation_tolerance_var is not None:
            self._values["saturation_tolerance_var"] = saturation_tolerance_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        '''
        result = self._values.get("hue_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        '''
        result = self._values.get("hue_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        '''
        result = self._values.get("hue_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        '''
        result = self._values.get("hue_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        '''
        result = self._values.get("lightness_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        '''
        result = self._values.get("lightness_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        '''
        result = self._values.get("lightness_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        '''
        result = self._values.get("lightness_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        '''
        result = self._values.get("saturation_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        '''
        result = self._values.get("saturation_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        '''
        result = self._values.get("saturation_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        result = self._values.get("saturation_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareChromaKey(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareChromaKeyList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareChromaKeyList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a1505d2cc5f071409ee7b818ca4e2fcd288047555b9d4a302954ec8a96e9631)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareChromaKeyOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab5c2e38afbda9a27e8c3ebf7d3c20207fb37802e2ed2a9380defaeda18c9aff)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareChromaKeyOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b9f75170e0acbf22a554250adddd143d310d55c7e8e5fa475857e0413e4652a5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1e4c678a878278bce2dddb5c5a6184137cb81014e94873f730638f788f33c552)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3e2d7f8afbcd49e15392b68f21fd99d171d0670725a19e07b47afcd2572b4da3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareChromaKey]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareChromaKey]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5581626b39de584f5ee117944144bed9f00d625e0ae278321588fc02f5d54108)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareChromaKeyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareChromaKeyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2c5b32918f59afe8efc6d0b6695d25cd4d0ddbb4f689ee83f07dd8f00da84941)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueFeather")
    def reset_hue_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeather", []))

    @jsii.member(jsii_name="resetHueFeatherVar")
    def reset_hue_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeatherVar", []))

    @jsii.member(jsii_name="resetHueTolerance")
    def reset_hue_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueTolerance", []))

    @jsii.member(jsii_name="resetHueToleranceVar")
    def reset_hue_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueToleranceVar", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightnessFeather")
    def reset_lightness_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeather", []))

    @jsii.member(jsii_name="resetLightnessFeatherVar")
    def reset_lightness_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeatherVar", []))

    @jsii.member(jsii_name="resetLightnessTolerance")
    def reset_lightness_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessTolerance", []))

    @jsii.member(jsii_name="resetLightnessToleranceVar")
    def reset_lightness_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessToleranceVar", []))

    @jsii.member(jsii_name="resetSaturationFeather")
    def reset_saturation_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeather", []))

    @jsii.member(jsii_name="resetSaturationFeatherVar")
    def reset_saturation_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeatherVar", []))

    @jsii.member(jsii_name="resetSaturationTolerance")
    def reset_saturation_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationTolerance", []))

    @jsii.member(jsii_name="resetSaturationToleranceVar")
    def reset_saturation_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherInput")
    def hue_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVarInput")
    def hue_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceInput")
    def hue_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVarInput")
    def hue_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherInput")
    def lightness_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVarInput")
    def lightness_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceInput")
    def lightness_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVarInput")
    def lightness_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherInput")
    def saturation_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVarInput")
    def saturation_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceInput")
    def saturation_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVarInput")
    def saturation_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ec4e8423f8432cccb19c0028b022dddacb06a04bc35285fd5c4cf4d16ce1601f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeather")
    def hue_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeather"))

    @hue_feather.setter
    def hue_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__52f141d42c77f75c4d9746f9fc029639507d7279c37464dc4261432c60bbc329)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeather", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVar")
    def hue_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeatherVar"))

    @hue_feather_var.setter
    def hue_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b6c2b25bacf3ba0877d8eb0ffad1c0cc20b2ce8003ff9db3c130ccb74c772d11)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueTolerance")
    def hue_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueTolerance"))

    @hue_tolerance.setter
    def hue_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c5f72530cc0009b57b400d20f2060190b198739785d86c924cc2a9a2cc4bfc3c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVar")
    def hue_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueToleranceVar"))

    @hue_tolerance_var.setter
    def hue_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b2e9ea51398f267f4a6d2f081151c36c86085ca66d061aea48ac490c1a748c2d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a212c30e6f3968f16fdce86edacd4b56f119395d65465abbf9e6888485d0acc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeather")
    def lightness_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeather"))

    @lightness_feather.setter
    def lightness_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__197793f36e98ccea9634b56fd2dfe591ac677878f8fee4a5fee826333b82f9b7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeather", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVar")
    def lightness_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeatherVar"))

    @lightness_feather_var.setter
    def lightness_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__72a4a671cf423ab7481f39c26dea165be9be7e5e80a29db2353f496bb732bb40)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessTolerance")
    def lightness_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessTolerance"))

    @lightness_tolerance.setter
    def lightness_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__017e351d3b16f7fb610654ffe238ed942437273a5c7afd7e050565f9867287d4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVar")
    def lightness_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessToleranceVar"))

    @lightness_tolerance_var.setter
    def lightness_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__18a645e46a0274f953587de7530ecc2cea64b20c05880ac53c0451ee987b20b9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeather")
    def saturation_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeather"))

    @saturation_feather.setter
    def saturation_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__53340bb345c0d872408971a94aa34a82ec29e15152d0eb6c5c84c27970b5ae6b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeather", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVar")
    def saturation_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeatherVar"))

    @saturation_feather_var.setter
    def saturation_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b66251e8706e27fbb27120bef7f9cd78c49787cb492d74f8920832a75304500c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationTolerance")
    def saturation_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationTolerance"))

    @saturation_tolerance.setter
    def saturation_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7c5a48b07121acc4fc1da54cabea7f7d86578206b856082a9b852c3ba4dd137a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVar")
    def saturation_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationToleranceVar"))

    @saturation_tolerance_var.setter
    def saturation_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__55e5238d6759828ee0aa5fe7d281ad68b91f04588234dc525073853f68fbdf67)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareChromaKey]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareChromaKey]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareChromaKey]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c8b20cd31feac89b4be705319baad54837e493ed2daa439e53b1aa6625f53127)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareComposite",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "placement": "placement",
        "placement_var": "placementVar",
        "scale": "scale",
        "scale_dimension": "scaleDimension",
        "scale_dimension_var": "scaleDimensionVar",
        "scale_var": "scaleVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareComposite:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareCompositeImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        placement: typing.Optional[builtins.str] = None,
        placement_var: typing.Optional[builtins.str] = None,
        scale: typing.Optional[builtins.str] = None,
        scale_dimension: typing.Optional[builtins.str] = None,
        scale_dimension_var: typing.Optional[builtins.str] = None,
        scale_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param placement: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        :param placement_var: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        :param scale: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param scale_dimension: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        :param scale_dimension_var: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        :param scale_var: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        :param x_position: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareCompositeImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5c768a0b8178cdbbad6eb03e5ff4cb7778fb6dab9246927465707cade774e859)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument placement", value=placement, expected_type=type_hints["placement"])
            check_type(argname="argument placement_var", value=placement_var, expected_type=type_hints["placement_var"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument scale_dimension", value=scale_dimension, expected_type=type_hints["scale_dimension"])
            check_type(argname="argument scale_dimension_var", value=scale_dimension_var, expected_type=type_hints["scale_dimension_var"])
            check_type(argname="argument scale_var", value=scale_var, expected_type=type_hints["scale_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if placement is not None:
            self._values["placement"] = placement
        if placement_var is not None:
            self._values["placement_var"] = placement_var
        if scale is not None:
            self._values["scale"] = scale
        if scale_dimension is not None:
            self._values["scale_dimension"] = scale_dimension
        if scale_dimension_var is not None:
            self._values["scale_dimension_var"] = scale_dimension_var
        if scale_var is not None:
            self._values["scale_var"] = scale_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareCompositeImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareCompositeImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        '''
        result = self._values.get("placement")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement_var(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        '''
        result = self._values.get("placement_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        '''
        result = self._values.get("scale_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        '''
        result = self._values.get("scale_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        '''
        result = self._values.get("scale_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareComposite(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareCompositeImage",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareCompositeImage:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareCompositeImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareCompositeImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareCompositeImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__496e8fb75583ccc2ed8c658219156ac1500c6783492544dde3fff9a10a14d8d1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareCompositeImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareCompositeImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f477996636e8e62cde5e28162d7c51b52fa4747a746445850c8eede1fac3ce1a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareCompositeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareCompositeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ad57a3b9ed42afe648d9e282c99f4696f3c074e526cd7b7bed869d97a188eba4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareCompositeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1e5f37e27c58087ef865e442af9520efc672706fefc0fff5735e649ff1274728)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareCompositeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c1a37dbc0f1579ee00c102eac5ec2f5490b0173e630390e473d8613c656abe63)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9e52641930d6cdd86b1c14165eb17025d6f0e65a9e8e05cd3e03857c03ab933a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f425641cf1d1461606fbf795b832b97dd0af405baacbae626b6ebc91d1df1c9e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareComposite]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareComposite]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__05c640bc2864cded330d71737d0a70812b0e3a9811721f4d73ab035847010d5a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareCompositeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareCompositeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0001d5fffc66853396c52778950d3d6b2eb255f1ba7d1288db1ce53870063bd4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareCompositeImage()

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPlacement")
    def reset_placement(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacement", []))

    @jsii.member(jsii_name="resetPlacementVar")
    def reset_placement_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacementVar", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetScaleDimension")
    def reset_scale_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimension", []))

    @jsii.member(jsii_name="resetScaleDimensionVar")
    def reset_scale_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimensionVar", []))

    @jsii.member(jsii_name="resetScaleVar")
    def reset_scale_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareCompositeImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareCompositeImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareCompositeImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="placementInput")
    def placement_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementInput"))

    @builtins.property
    @jsii.member(jsii_name="placementVarInput")
    def placement_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionInput")
    def scale_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVarInput")
    def scale_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleVarInput")
    def scale_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c7ea3510c9003c70fbcfe947b08427a5bd4d0d4619aa8f6fa1580fad65d8bdd3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0225118ac4fcd38c09a1f9fc34894c44b269eb812819fb5bbcd54a91952a103b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="placement")
    def placement(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placement"))

    @placement.setter
    def placement(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d5c821f157e38cb8345c087d371e1828d9502997455a31aea3632ec3468d4037)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placement", value)

    @builtins.property
    @jsii.member(jsii_name="placementVar")
    def placement_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placementVar"))

    @placement_var.setter
    def placement_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e9b8bf6da3f177fa20b9a40f6e43af81e2654c17701386c5965bf6d8f1f88762)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placementVar", value)

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scale"))

    @scale.setter
    def scale(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c8076e3d29dd6d42b448797ae52c14dbbcac56408224be1350743e580138b548)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scale", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimension")
    def scale_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimension"))

    @scale_dimension.setter
    def scale_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fb3eef524a9c2c1ccf860f9f898702f9a60ca140fa472e9ce001b765f513ac7f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimension", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVar")
    def scale_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimensionVar"))

    @scale_dimension_var.setter
    def scale_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__74d0d2d38f9c5d236ae3212ae79b4f466dd547ca0434425234dee8d5e25854a5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="scaleVar")
    def scale_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleVar"))

    @scale_var.setter
    def scale_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0c91dfda5ea55815838bfe40755ea177f8009c52a1fb20d9f80019c423d60d5e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__58cea4fb10afe7cb25b43715e00b059deb03d93bc2c873b1b8b2b380035e5fc7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4849cd1207fe59a320bb081a2e8ea1f91d7d04ab3d8d205a5d7f77829cf190ae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9b7a8b85ae550e9792a614e0765c72004e553cda4d1e386fa6fc4ccadf500b8c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df05e3b7b8ea61adb1ef6db1804c825d7a62458d327a3d51c87637b0de1d1968)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareComposite]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareComposite]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareComposite]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f1d0695682ffe8e2e2a1a983628443fc0daaab28bec961e4fb230417d4b41aa2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareCompound",
    jsii_struct_bases=[],
    name_mapping={"transformations": "transformations"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareCompound:
    def __init__(
        self,
        *,
        transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param transformations: transformations block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__34976b813eaa2268cb13e45ba43421c8a06ca137baf3c60bfc416fb80180b680)
            check_type(argname="argument transformations", value=transformations, expected_type=type_hints["transformations"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if transformations is not None:
            self._values["transformations"] = transformations

    @builtins.property
    def transformations(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareCompoundTransformations"]]]:
        '''transformations block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        result = self._values.get("transformations")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareCompoundTransformations"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareCompound(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareCompoundList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareCompoundList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ff5f003b88aa895c9517518e525c158e19d5fecc3a22c5fd3778f979d576d6b8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareCompoundOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__11fbca7e8f7287f80f183d993ec2f9232df70606ae69e78d2094a43546bcba3f)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareCompoundOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b0a5209eb3c06c0b23fa33f4ad24094ba0f3694f669aacf22387bf9e87e37229)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__74cd8eba5d7c0cd76d0a614075c56fd4477ac9a0436d2fce896fff541a3e2344)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__76ba30af4ebeed8cc508fee88023065a5de3a306bc3486d34522406b66a82113)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareCompound]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareCompound]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8d9a9d741de24b8e082ef071b535d778cb8424dbf246deefc2cfb501776c6d94)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareCompoundOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareCompoundOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c196ed2db478cf0799420fde97ad3119f4c02cc5e7f52a6c9280795ea5ff6d86)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformations")
    def put_transformations(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__601edd37ba8eee4ba033297f671d4dc00bb4c6812c67925c6407156468168c1e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTransformations", [value]))

    @jsii.member(jsii_name="resetTransformations")
    def reset_transformations(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformations", []))

    @builtins.property
    @jsii.member(jsii_name="transformations")
    def transformations(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareCompoundTransformationsList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareCompoundTransformationsList", jsii.get(self, "transformations"))

    @builtins.property
    @jsii.member(jsii_name="transformationsInput")
    def transformations_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareCompoundTransformations"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareCompoundTransformations"]]], jsii.get(self, "transformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareCompound]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareCompound]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareCompound]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1ad28f22ffff42f6a3b8cc510bb33fe7da38d4d429c799836c73220253f64015)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareCompoundTransformations",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareCompoundTransformations:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareCompoundTransformations(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareCompoundTransformationsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareCompoundTransformationsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6ff877ec19177a06238391c83636f029eba6cc63e1ed3b994873e4273064a465)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareCompoundTransformationsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be5fbd33d1ec5f3f1141c684a7d5051fd803503d8ccc4b358a091a11e94acef4)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareCompoundTransformationsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c8909379438c9f203eadfb7795428cfca24be15950179814b30878ae1a28ade6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f8306d1eabdbf0d88d09cee6c8ada481201fb686627d486e3a93812eec8fb202)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__026ffc93ce6d39e68173d3e05e030dd6d851a269933f7e16e98a6e9daf92da17)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareCompoundTransformations]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareCompoundTransformations]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareCompoundTransformations]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__39d5a549d0b2c90cb4dc6777d913e70cb648bb538913f270901ae15b8f9ada3e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareCompoundTransformationsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareCompoundTransformationsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bd66b7b7c05b072a9a3c523517d03cc9a2c684e80f067aa18ef400a4add44fae)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareCompoundTransformations]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareCompoundTransformations]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareCompoundTransformations]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__59a2c3cf1060896b38f9385bb5ab6c46ea098982d0270d6725e9255ecec3150f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareContrast",
    jsii_struct_bases=[],
    name_mapping={
        "brightness": "brightness",
        "brightness_var": "brightnessVar",
        "contrast": "contrast",
        "contrast_var": "contrastVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareContrast:
    def __init__(
        self,
        *,
        brightness: typing.Optional[builtins.str] = None,
        brightness_var: typing.Optional[builtins.str] = None,
        contrast: typing.Optional[builtins.str] = None,
        contrast_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param brightness: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        :param brightness_var: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        :param contrast: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param contrast_var: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b873a1a9619fad9dc67b5891b7eec49e2088cdcf515b5c12a1a8e11c01de0179)
            check_type(argname="argument brightness", value=brightness, expected_type=type_hints["brightness"])
            check_type(argname="argument brightness_var", value=brightness_var, expected_type=type_hints["brightness_var"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument contrast_var", value=contrast_var, expected_type=type_hints["contrast_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if brightness is not None:
            self._values["brightness"] = brightness
        if brightness_var is not None:
            self._values["brightness_var"] = brightness_var
        if contrast is not None:
            self._values["contrast"] = contrast
        if contrast_var is not None:
            self._values["contrast_var"] = contrast_var

    @builtins.property
    def brightness(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        '''
        result = self._values.get("brightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def brightness_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        '''
        result = self._values.get("brightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        result = self._values.get("contrast_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareContrast(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareContrastList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareContrastList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0d49a0ea7248625e2408a585a15b57cc7552770149115c69e2d5f0e721732d89)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareContrastOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a9312d4af0cd03a6d62be63948d29eecc650dac0315c922bf65c04fc8d004c20)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareContrastOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eede703525582d3d414bf563a6c5af0cc3bf992e9be5126695e56b027222f93a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__98f6a6cb45dc3c97c1093e5bcd14db5ef009ea0e68728ab28e2e1bf6d5fb8e46)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__91c12f18f4622f03d40e61dc7168081177c259646bdc9e28bf66c6051e5831e4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareContrast]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareContrast]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__360c50ba262e77a7bb070d509190c5f4a2785d6c94917aa7b2281dc938aab143)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareContrastOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareContrastOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4507b45bfa5408e6fe9e7d983836bf00edfd74574e0b45e5c269d4baa8794fca)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetBrightness")
    def reset_brightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightness", []))

    @jsii.member(jsii_name="resetBrightnessVar")
    def reset_brightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightnessVar", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetContrastVar")
    def reset_contrast_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrastVar", []))

    @builtins.property
    @jsii.member(jsii_name="brightnessInput")
    def brightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="brightnessVarInput")
    def brightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastVarInput")
    def contrast_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="brightness")
    def brightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightness"))

    @brightness.setter
    def brightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__62f0abc232a31d94246d08043f9701ddf95f47db93c53c8c31d8405f91da03a5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightness", value)

    @builtins.property
    @jsii.member(jsii_name="brightnessVar")
    def brightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightnessVar"))

    @brightness_var.setter
    def brightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a8c555270b9db6ded63f0011545a709081ad3a366a87c497da0458cf2e5e1c77)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrast"))

    @contrast.setter
    def contrast(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ef3d62d3a9011a1927f3875c264260b6e52f4726f5733aa3964f725ff7812891)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrast", value)

    @builtins.property
    @jsii.member(jsii_name="contrastVar")
    def contrast_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrastVar"))

    @contrast_var.setter
    def contrast_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__00cf2a6b072f89c9cd4363e71861e39068cd8ff193487643351fe087ea70fbb1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrastVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareContrast]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareContrast]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareContrast]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8c068d22026af9d48b54d8440bc9a2c40f9b18c1d1b9b88b4ad4706275902992)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareGoop",
    jsii_struct_bases=[],
    name_mapping={
        "chaos": "chaos",
        "chaos_var": "chaosVar",
        "density": "density",
        "density_var": "densityVar",
        "power": "power",
        "power_var": "powerVar",
        "seed": "seed",
        "seed_var": "seedVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareGoop:
    def __init__(
        self,
        *,
        chaos: typing.Optional[builtins.str] = None,
        chaos_var: typing.Optional[builtins.str] = None,
        density: typing.Optional[builtins.str] = None,
        density_var: typing.Optional[builtins.str] = None,
        power: typing.Optional[builtins.str] = None,
        power_var: typing.Optional[builtins.str] = None,
        seed: typing.Optional[builtins.str] = None,
        seed_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param chaos: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        :param chaos_var: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        :param density: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        :param density_var: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        :param power: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        :param power_var: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        :param seed: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        :param seed_var: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4bf14a601d8e66e239c407d1300881218a5757475d8124458467177fec013b39)
            check_type(argname="argument chaos", value=chaos, expected_type=type_hints["chaos"])
            check_type(argname="argument chaos_var", value=chaos_var, expected_type=type_hints["chaos_var"])
            check_type(argname="argument density", value=density, expected_type=type_hints["density"])
            check_type(argname="argument density_var", value=density_var, expected_type=type_hints["density_var"])
            check_type(argname="argument power", value=power, expected_type=type_hints["power"])
            check_type(argname="argument power_var", value=power_var, expected_type=type_hints["power_var"])
            check_type(argname="argument seed", value=seed, expected_type=type_hints["seed"])
            check_type(argname="argument seed_var", value=seed_var, expected_type=type_hints["seed_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if chaos is not None:
            self._values["chaos"] = chaos
        if chaos_var is not None:
            self._values["chaos_var"] = chaos_var
        if density is not None:
            self._values["density"] = density
        if density_var is not None:
            self._values["density_var"] = density_var
        if power is not None:
            self._values["power"] = power
        if power_var is not None:
            self._values["power_var"] = power_var
        if seed is not None:
            self._values["seed"] = seed
        if seed_var is not None:
            self._values["seed_var"] = seed_var

    @builtins.property
    def chaos(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        '''
        result = self._values.get("chaos")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def chaos_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        '''
        result = self._values.get("chaos_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        '''
        result = self._values.get("density")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density_var(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        '''
        result = self._values.get("density_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        '''
        result = self._values.get("power")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power_var(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        '''
        result = self._values.get("power_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        '''
        result = self._values.get("seed")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed_var(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        result = self._values.get("seed_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareGoop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareGoopList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareGoopList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d55325d148a1da8a2d33fd5dba6c79417fa0a07af6205da14f0c531a4d89b0b7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareGoopOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__79996e81ecd8bfe87f0d37eab5a288b72c8922f454f8fca1e179cc6024159cbf)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareGoopOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0c54015b52c7ceb51c721f9cdc033c4284d27d14e8e5ef9b632f329aad3e6a16)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a6291d9b0fc75edac63066a706be0e1f2795850838d2b06a636cd41e1a8f69f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fe8c3d5d71f02cfd44f5ad1b085c324aa23aefec561ac2af6c0fcbad6d60efe6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareGoop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareGoop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c0b7d0747e9d550e7b24426c3c1096c712d6f20881e2ccf362c5ba703112d461)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareGoopOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareGoopOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__18d752bf4894c821caeb4f7e15eb02398a2331cc13312b20cd38d836f5d80907)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetChaos")
    def reset_chaos(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaos", []))

    @jsii.member(jsii_name="resetChaosVar")
    def reset_chaos_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaosVar", []))

    @jsii.member(jsii_name="resetDensity")
    def reset_density(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensity", []))

    @jsii.member(jsii_name="resetDensityVar")
    def reset_density_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensityVar", []))

    @jsii.member(jsii_name="resetPower")
    def reset_power(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPower", []))

    @jsii.member(jsii_name="resetPowerVar")
    def reset_power_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPowerVar", []))

    @jsii.member(jsii_name="resetSeed")
    def reset_seed(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeed", []))

    @jsii.member(jsii_name="resetSeedVar")
    def reset_seed_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeedVar", []))

    @builtins.property
    @jsii.member(jsii_name="chaosInput")
    def chaos_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosInput"))

    @builtins.property
    @jsii.member(jsii_name="chaosVarInput")
    def chaos_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosVarInput"))

    @builtins.property
    @jsii.member(jsii_name="densityInput")
    def density_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityInput"))

    @builtins.property
    @jsii.member(jsii_name="densityVarInput")
    def density_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="powerInput")
    def power_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerInput"))

    @builtins.property
    @jsii.member(jsii_name="powerVarInput")
    def power_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerVarInput"))

    @builtins.property
    @jsii.member(jsii_name="seedInput")
    def seed_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedInput"))

    @builtins.property
    @jsii.member(jsii_name="seedVarInput")
    def seed_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedVarInput"))

    @builtins.property
    @jsii.member(jsii_name="chaos")
    def chaos(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaos"))

    @chaos.setter
    def chaos(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c80d18e18c044ef435ee1e75778232fb720db3929531f13ab9db8283b17d0d6d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaos", value)

    @builtins.property
    @jsii.member(jsii_name="chaosVar")
    def chaos_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaosVar"))

    @chaos_var.setter
    def chaos_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__32ae99ecbc0645b3ebc6bd77162da677481caad31186cd812f69a8a393c90377)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaosVar", value)

    @builtins.property
    @jsii.member(jsii_name="density")
    def density(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "density"))

    @density.setter
    def density(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a1b7b879c78f177e0d710325ee5b3666d8b6fb1cc6b3c99ece787d53ad59e4e8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "density", value)

    @builtins.property
    @jsii.member(jsii_name="densityVar")
    def density_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "densityVar"))

    @density_var.setter
    def density_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b627b10ba6f2e3787c1d90ce312dd91530df8fd6898a6f27fe9ad87a4287ed43)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "densityVar", value)

    @builtins.property
    @jsii.member(jsii_name="power")
    def power(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "power"))

    @power.setter
    def power(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__71130159417795bc3615c8a48f0011b1f2e098557c2cdd8e31b553834376acd8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "power", value)

    @builtins.property
    @jsii.member(jsii_name="powerVar")
    def power_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "powerVar"))

    @power_var.setter
    def power_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e98635c0c17f4474587aadb1803347252d40ce041d42bfd903303b272a6a7e03)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "powerVar", value)

    @builtins.property
    @jsii.member(jsii_name="seed")
    def seed(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seed"))

    @seed.setter
    def seed(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c8cf88fc5ba8f6f886e0e98edd557c89f71c903c815c925192bceb336dde58a0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seed", value)

    @builtins.property
    @jsii.member(jsii_name="seedVar")
    def seed_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seedVar"))

    @seed_var.setter
    def seed_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1487d576a5acc086254c9df0246bf80db712630553a8aede57f204dc4370731e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seedVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareGoop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareGoop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareGoop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__20eb7369450bced20fb082095f8dffe15f4d364f8b9a26f36a5a271d51fdae7c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareGrayscale",
    jsii_struct_bases=[],
    name_mapping={"type": "type", "type_var": "typeVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareGrayscale:
    def __init__(
        self,
        *,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param type: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__003d4fd04faf555669a6736927b55370c6174ab5b6b6f3b4f6888372d6e1e2a6)
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareGrayscale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareGrayscaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareGrayscaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__916d3c4b1db01f5d83a8e23f564482411ff6c1f650f769320865284b8fb499ba)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareGrayscaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__07896e602a80bbfbb627f3a13c653af1d535792c7c4462aface135e12b95e942)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareGrayscaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a80c9a0b8a42c67fb71d45e61d6dd0a278ac214e9312d80e7d42377daf8f54f8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ae7dc6be09ef9b7060d488bef1c9f334c946f50988f8e1b15c959dac8780d0ed)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__386131954b68aeff16c341341c34cbd9f569750badc8d8f8517e35337ff74bc5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareGrayscale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareGrayscale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0a7efdf7938ab71538c92bfcf281db05529de5f6abdec128e72bd666a3f2c3bf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareGrayscaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareGrayscaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d2a528b93a574249e7515039597cf3a25012ee226753959a5ffdfd4f506b67bf)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f73e672a3b2a09df137e0980888f3c94aa704a7b1ad69a5e640b98e1978ad49a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4c3dce7f4ae00a2cfc5c194579e3be228417aa18713ace791151d2877252f893)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareGrayscale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareGrayscale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareGrayscale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__81e5758ba49117bf8efffa4172081d71bdedb409149bf277858b94f8bd9cc19c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareHsl",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "lightness": "lightness",
        "lightness_var": "lightnessVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareHsl:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness: typing.Optional[builtins.str] = None,
        lightness_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        :param lightness_var: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ffb56915e47de493aea92a593d1eb0a180f284062cdd4475dc6490f3d026cc88)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness", value=lightness, expected_type=type_hints["lightness"])
            check_type(argname="argument lightness_var", value=lightness_var, expected_type=type_hints["lightness_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness is not None:
            self._values["lightness"] = lightness
        if lightness_var is not None:
            self._values["lightness_var"] = lightness_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        '''
        result = self._values.get("lightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        '''
        result = self._values.get("lightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareHsl(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareHslList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareHslList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__043352af7133f047ea4721d18be51f65737e37a29f7ef739f0a3f0b7802d006e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareHslOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f039e59de686aa50f5674b6b3f9e8089ca4cb04dd312f2d37e2d4cffeda60491)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareHslOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a2143bd217a3d92fd7c693c05ba734d6378f54ffd532089527def1d73ddae544)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6391373a658deb06963ef9f04c31a9592cd03e96613a8b37fc7ad9ea955c2edf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__648f0819ad7588c08fac6672125adf244b43dbed9e97f2bb4c48bd318459c20b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareHsl]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareHsl]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__416a882201e27ba4a37dcbca90b64b66362339cf6fa8dfee7a48217ab495c4d5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareHslOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareHslOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eb790fe14d7e4bca4f7a11cd8a7b5152a449730202c32ad3c76217e009a56154)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightness")
    def reset_lightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightness", []))

    @jsii.member(jsii_name="resetLightnessVar")
    def reset_lightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessInput")
    def lightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessVarInput")
    def lightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__72098c445e283880b678a3e0245b58a7f35150042627025d8e356be678e4eb44)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8e43c359dcf0f38cf4d1c4620a11751114f3b1b5935844f04c6fab7ba235326e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightness")
    def lightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightness"))

    @lightness.setter
    def lightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7f024ebca18375e4f6615a93ab4da58f2f3005a34df4b7d95e7a7b1fe8c6517e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightness", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessVar")
    def lightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessVar"))

    @lightness_var.setter
    def lightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f61184f5e10e5aa6bb21bd8fd88d80326aaf8c9fdf77e429cd919aec569e134b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5492b316c61cd95528cffc39359fbeb6f2fa958f16fd27b06211603143550e08)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__944d22d1b3d1ec28a24b2ba5b8d5fb9bb4f59f238841bbf8ed6c2cf526df7931)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareHsl]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareHsl]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareHsl]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ffc47abd5f3754e8d6690d64d2e35e9164571e738bf7d386d3662c584702c72)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareHsv",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareHsv:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        :param value: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df04ce0801d90b3c75ac726cbd79262a186efc10e0d4a03f225efe47d124d5e9)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareHsv(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareHsvList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareHsvList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cc2b0591626d73c326d4a31b8b04deaab071d3a938ffbb65539238f83054b507)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareHsvOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__95f62a431a0846b1bf2c0097beace99db5d91e6b8762d46913006b687f388dfa)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareHsvOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b5d172180956b2139991660f85f74a4069a7752dcb606dd27d2735960d9b3727)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e82b079044c486f24cce43f1ab2dd910b4b0713dfe827867d5d06b1d5978ce2d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5286b2dc052ff5bf1cf4d3ae0078ff73c78b6471b3379ff56994d039bdf5e222)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareHsv]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareHsv]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e6ab6a5c9224f615eb3c29ae0a42f70d5697dadade878e0a2116a751db409177)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareHsvOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareHsvOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fd6204394cc3e418b0c82c171cb7c9aa1bdcb2b03df3f4a277ab074dd319603b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0a3c1ddb094ccb09eb3c85c4a311e792e23cbcb9506fa08df80bd74a5787dd4b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__493cb16d08371566a8710b6f7fb7bbdf8630e119b7b13c54c92d74c1e5b32d79)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fbe57dd930ea1d396a8f47c1ab1ef35cb7a6497a5122532744706acfdcd012c4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__21226770d890686a378ef6082dbf5885fbe1342d93280e3ec645ed8c6b7b36f5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c191fb7179181d6357ebe161e170813fd1fc39beb0dab386c91e6b4e7fdac206)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__799ac486e896df2b0894a9df6a243dc846023846bd9bc4154445e14de1ce8e52)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareHsv]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareHsv]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareHsv]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b0aa5d8294962ab59ac29ff7d5dfec98de871a33aebe7bea482741f4d077936e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfDimension",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "dimension": "dimension",
        "dimension_var": "dimensionVar",
        "equal": "equal",
        "greater_than": "greaterThan",
        "less_than": "lessThan",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfDimension:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        dimension: typing.Optional[builtins.str] = None,
        dimension_var: typing.Optional[builtins.str] = None,
        equal: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionEqual", typing.Dict[builtins.str, typing.Any]]] = None,
        greater_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionGreaterThan", typing.Dict[builtins.str, typing.Any]]] = None,
        less_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionLessThan", typing.Dict[builtins.str, typing.Any]]] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param dimension: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        :param dimension_var: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        :param equal: equal block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        :param greater_than: greater_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        :param less_than: less_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        :param value: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionDefault(**default)
        if isinstance(equal, dict):
            equal = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionEqual(**equal)
        if isinstance(greater_than, dict):
            greater_than = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionGreaterThan(**greater_than)
        if isinstance(less_than, dict):
            less_than = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionLessThan(**less_than)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc1bfc4c1225f41f14fc155420bb49a71268a54cbadefcb78bc28fd88a198b95)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument dimension", value=dimension, expected_type=type_hints["dimension"])
            check_type(argname="argument dimension_var", value=dimension_var, expected_type=type_hints["dimension_var"])
            check_type(argname="argument equal", value=equal, expected_type=type_hints["equal"])
            check_type(argname="argument greater_than", value=greater_than, expected_type=type_hints["greater_than"])
            check_type(argname="argument less_than", value=less_than, expected_type=type_hints["less_than"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if dimension is not None:
            self._values["dimension"] = dimension
        if dimension_var is not None:
            self._values["dimension_var"] = dimension_var
        if equal is not None:
            self._values["equal"] = equal
        if greater_than is not None:
            self._values["greater_than"] = greater_than
        if less_than is not None:
            self._values["less_than"] = less_than
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionDefault"], result)

    @builtins.property
    def dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        '''
        result = self._values.get("dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        '''
        result = self._values.get("dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def equal(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionEqual"]:
        '''equal block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        '''
        result = self._values.get("equal")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionEqual"], result)

    @builtins.property
    def greater_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionGreaterThan"]:
        '''greater_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        '''
        result = self._values.get("greater_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionGreaterThan"], result)

    @builtins.property
    def less_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionLessThan"]:
        '''less_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        '''
        result = self._values.get("less_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionLessThan"], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfDimension(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__763650e7cf930c55a3c49b766ed6c448f288bf6596fe7f1a1e102d6c5aa19794)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__09a11497345dfb157dfd384836e3aefd71f3c4b8cc2062f482ac9e34b6fa3778)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionEqual",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionEqual:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionEqual(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionEqualOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionEqualOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f3b51448d58b95812e43fe616b22ddc16e0f64c2d8d535050bbd9f895ba40c1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionEqual], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionEqual],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a876dfa89db48501e71703af1861987620afa08cc39b37697ea36f2d1dd60ddc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionGreaterThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionGreaterThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionGreaterThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionGreaterThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionGreaterThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3b0db3b0285dc67f3b5e9ac6e7fe51e0af975a5af176cb2f027b7d0ed1324d03)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionGreaterThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionGreaterThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0d82a7fbc9b4d1c4a18ff377fedfd3eeb0a908a4109db4e9093fa6d21c50209b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionLessThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionLessThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionLessThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionLessThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionLessThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4521a1f169d6ea1dbce3315aac6317012f1764128d4387aa3dc78c5b95140023)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionLessThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionLessThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__33580ee3967b36e2e23e2c8a3869c98ce78d0464f67728a672002e5675e54291)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c4de812e21e3e8c22c7072a0db796b68891778dc63ca3ff6bceb9f2dc2ecab90)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7b3c2456f58302929cc52ee3b2f2ca86ed41c8fafd35028a72640b911861f912)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__282f2d0ca8b9d98e7f02f731497578e4fce115df56601e2671af3d12ea6d8f36)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__596bb6b8224ee3f56a500fa7e4d7bb45ada1227c4f276b30f19f86c2c3f79b91)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c8b3327c44289d3c50768b491b883a25e0932d5139c1f427b9e760d30b22ea1a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfDimension]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfDimension]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fe50b00dc778007522e682d5ea7d7a9c2ab9c6e2938fde14dcb37baa8f677b67)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d958e6e8c8de213bc3c3eb47da7377b86fce8a0c85de134226fd2c18fba379f6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putEqual")
    def put_equal(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionEqual()

        return typing.cast(None, jsii.invoke(self, "putEqual", [value]))

    @jsii.member(jsii_name="putGreaterThan")
    def put_greater_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionGreaterThan()

        return typing.cast(None, jsii.invoke(self, "putGreaterThan", [value]))

    @jsii.member(jsii_name="putLessThan")
    def put_less_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionLessThan()

        return typing.cast(None, jsii.invoke(self, "putLessThan", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetDimension")
    def reset_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimension", []))

    @jsii.member(jsii_name="resetDimensionVar")
    def reset_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimensionVar", []))

    @jsii.member(jsii_name="resetEqual")
    def reset_equal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEqual", []))

    @jsii.member(jsii_name="resetGreaterThan")
    def reset_greater_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGreaterThan", []))

    @jsii.member(jsii_name="resetLessThan")
    def reset_less_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLessThan", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="equal")
    def equal(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionEqualOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionEqualOutputReference, jsii.get(self, "equal"))

    @builtins.property
    @jsii.member(jsii_name="greaterThan")
    def greater_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionGreaterThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionGreaterThanOutputReference, jsii.get(self, "greaterThan"))

    @builtins.property
    @jsii.member(jsii_name="lessThan")
    def less_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionLessThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionLessThanOutputReference, jsii.get(self, "lessThan"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionInput")
    def dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionVarInput")
    def dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="equalInput")
    def equal_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionEqual], jsii.get(self, "equalInput"))

    @builtins.property
    @jsii.member(jsii_name="greaterThanInput")
    def greater_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionGreaterThan], jsii.get(self, "greaterThanInput"))

    @builtins.property
    @jsii.member(jsii_name="lessThanInput")
    def less_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionLessThan], jsii.get(self, "lessThanInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="dimension")
    def dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimension"))

    @dimension.setter
    def dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7b3a5928f7c92d4af742e967c4840a881b3bbfb21ffae50cd8cf7a94537be536)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimension", value)

    @builtins.property
    @jsii.member(jsii_name="dimensionVar")
    def dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimensionVar"))

    @dimension_var.setter
    def dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c808b0d589dcf8f63be064aa17582b403a067729b968b0128aa4ceaa0619ec3c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__47f2a53ad42a61d71d7de8007b549b1c63805cc356d31a368fede3f775adaf82)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b53f2dcd46ead972e8cb0d52bfcb1aa5076cc55301eae290e9375f2cd9395481)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfDimension]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfDimension]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfDimension]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__39cd3ac73c4b2d2ce2cd63576a23960e3fb2193f9cacb016a1e660fdd7459486)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfOrientation",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "landscape": "landscape",
        "portrait": "portrait",
        "square": "square",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfOrientation:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        landscape: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationLandscape", typing.Dict[builtins.str, typing.Any]]] = None,
        portrait: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationPortrait", typing.Dict[builtins.str, typing.Any]]] = None,
        square: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationSquare", typing.Dict[builtins.str, typing.Any]]] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param landscape: landscape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        :param portrait: portrait block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        :param square: square block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationDefault(**default)
        if isinstance(landscape, dict):
            landscape = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationLandscape(**landscape)
        if isinstance(portrait, dict):
            portrait = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationPortrait(**portrait)
        if isinstance(square, dict):
            square = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationSquare(**square)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ff8e08bd244357291662518da6f04344cc02cd481c29d4c32deff736b106680)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument landscape", value=landscape, expected_type=type_hints["landscape"])
            check_type(argname="argument portrait", value=portrait, expected_type=type_hints["portrait"])
            check_type(argname="argument square", value=square, expected_type=type_hints["square"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if landscape is not None:
            self._values["landscape"] = landscape
        if portrait is not None:
            self._values["portrait"] = portrait
        if square is not None:
            self._values["square"] = square

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationDefault"], result)

    @builtins.property
    def landscape(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationLandscape"]:
        '''landscape block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        '''
        result = self._values.get("landscape")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationLandscape"], result)

    @builtins.property
    def portrait(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationPortrait"]:
        '''portrait block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        '''
        result = self._values.get("portrait")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationPortrait"], result)

    @builtins.property
    def square(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationSquare"]:
        '''square block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        result = self._values.get("square")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationSquare"], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfOrientation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__996fa3c8c221fb2c78e53fe7a59813f696aa5258660b6d23db655879580bfe24)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__868d58b2bb69a8aae2a5fde713ccd06544e8b09329d8b9e892e333fd12cd2574)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationLandscape",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationLandscape:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationLandscape(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationLandscapeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationLandscapeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1b04400caaebfa5e86f334a88f5cd35296772a11cf45acb6e2f6684748745f84)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationLandscape], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationLandscape],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f94b6bbd0487dbb071fe55e77a59989738250810cbe8e02fda660b7a76ccacce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f6543043a1c023049df69c53829a994a59f8ea5632de9d56cc564a32ce042f74)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__03ded372fd244df705aed20c58eb3e22132a01bdcd7fbd6e3a38dd9f98352e36)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__afb2eeeb727d52b1531df11a075675e4be78d4926257f203a49eea409657a9f1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c6e1f03eeea36b128fff80fa6c95f3a2961cd05d6ac007035d10186e011f154d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__030c4da8b9a8e6406f9718f1e99822bfd0aa91a1634cd84bf702f6b238235701)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfOrientation]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfOrientation]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fb35b9116c5fca811f5af860c15b2ad4294ef66156c9b0ed231fd4d3c16a7733)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__615c655888981574ee05e8d1872fafc3ac030595bc8aed217f10646b580f6118)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putLandscape")
    def put_landscape(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationLandscape()

        return typing.cast(None, jsii.invoke(self, "putLandscape", [value]))

    @jsii.member(jsii_name="putPortrait")
    def put_portrait(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationPortrait()

        return typing.cast(None, jsii.invoke(self, "putPortrait", [value]))

    @jsii.member(jsii_name="putSquare")
    def put_square(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationSquare()

        return typing.cast(None, jsii.invoke(self, "putSquare", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetLandscape")
    def reset_landscape(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLandscape", []))

    @jsii.member(jsii_name="resetPortrait")
    def reset_portrait(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPortrait", []))

    @jsii.member(jsii_name="resetSquare")
    def reset_square(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSquare", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="landscape")
    def landscape(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationLandscapeOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationLandscapeOutputReference, jsii.get(self, "landscape"))

    @builtins.property
    @jsii.member(jsii_name="portrait")
    def portrait(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationPortraitOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationPortraitOutputReference", jsii.get(self, "portrait"))

    @builtins.property
    @jsii.member(jsii_name="square")
    def square(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationSquareOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationSquareOutputReference", jsii.get(self, "square"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="landscapeInput")
    def landscape_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationLandscape], jsii.get(self, "landscapeInput"))

    @builtins.property
    @jsii.member(jsii_name="portraitInput")
    def portrait_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationPortrait"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationPortrait"], jsii.get(self, "portraitInput"))

    @builtins.property
    @jsii.member(jsii_name="squareInput")
    def square_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationSquare"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationSquare"], jsii.get(self, "squareInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfOrientation]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfOrientation]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfOrientation]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b6367061065cca6763e9d3f54b489195e50e20b61ed6ee1f8a268530674d27a5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationPortrait",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationPortrait:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationPortrait(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationPortraitOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationPortraitOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__31623efc3bcd3c7260c1e249d488c5c35fb477dd453b752b1aaa0e9c156fa173)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationPortrait]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationPortrait], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationPortrait],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5103e014609480813e361f0ff279bab57bfc444bbb506233fcdbc83e36cff9b2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationSquare",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationSquare:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationSquare(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationSquareOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationSquareOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c8ec9b1c865a1f29c38bb75a8d8efb9a9bb6aacb7af6a839cad75e067b146a63)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationSquare]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationSquare], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationSquare],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a99afed6e85c00ec108b1144cc3740fb995437b661b1c5d9a6da0df3d434d820)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareMaxColors",
    jsii_struct_bases=[],
    name_mapping={"colors": "colors", "colors_var": "colorsVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareMaxColors:
    def __init__(
        self,
        *,
        colors: typing.Optional[builtins.str] = None,
        colors_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param colors: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        :param colors_var: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bf2e878b804d926a8648278ecb6fa40d6e0b329ca018dda33d83723cea7c4dce)
            check_type(argname="argument colors", value=colors, expected_type=type_hints["colors"])
            check_type(argname="argument colors_var", value=colors_var, expected_type=type_hints["colors_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if colors is not None:
            self._values["colors"] = colors
        if colors_var is not None:
            self._values["colors_var"] = colors_var

    @builtins.property
    def colors(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        '''
        result = self._values.get("colors")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def colors_var(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        result = self._values.get("colors_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareMaxColors(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareMaxColorsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareMaxColorsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__29c058cbaf0991b706b84b049f3a79619276f7d6499c033032dafe8e881911ac)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareMaxColorsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7a638213ab66d5a59366dd32982ab51344f0d26532974b254eb05d286e100399)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareMaxColorsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8c10bb9e1db22b143906b5944c23e6b89c10297085158fc0849db6d4eee12289)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__99775a34e0106caa849214c96a58dc14aefc54aa9da1d4d138b65dc602cc7f9d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__011edb2bbcdc8bae35b844512d3e10179f53769b960d5b4e078690b69b318868)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareMaxColors]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareMaxColors]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8ce8b8804459e5e4ffd7700536fa1a1cd777854717cbf2b5b2fa539b35e67270)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareMaxColorsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareMaxColorsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eef9f15b582837ca22abde3c3a6be8d162d5f1b0e3a744704a87e9c9e9392877)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColors")
    def reset_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColors", []))

    @jsii.member(jsii_name="resetColorsVar")
    def reset_colors_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorsVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorsInput")
    def colors_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsInput"))

    @builtins.property
    @jsii.member(jsii_name="colorsVarInput")
    def colors_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsVarInput"))

    @builtins.property
    @jsii.member(jsii_name="colors")
    def colors(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colors"))

    @colors.setter
    def colors(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6c472cc621d5406e5a525e9fa3887f07ed2db05f5d74cd4c3ee4aecc46479565)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colors", value)

    @builtins.property
    @jsii.member(jsii_name="colorsVar")
    def colors_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorsVar"))

    @colors_var.setter
    def colors_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b9d4f7a365d6877f17cd2b7cdc4ed4b5de9caee8c6998656cd371bdbe98f4319)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorsVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareMaxColors]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareMaxColors]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareMaxColors]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3673a8fae182999bff86e95700a205d9a50e7ab32944aab90fb7fd6ae0493b3b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareMirror",
    jsii_struct_bases=[],
    name_mapping={
        "horizontal": "horizontal",
        "horizontal_var": "horizontalVar",
        "vertical": "vertical",
        "vertical_var": "verticalVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareMirror:
    def __init__(
        self,
        *,
        horizontal: typing.Optional[builtins.str] = None,
        horizontal_var: typing.Optional[builtins.str] = None,
        vertical: typing.Optional[builtins.str] = None,
        vertical_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param horizontal: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        :param horizontal_var: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        :param vertical: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        :param vertical_var: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6cd7e877a303ac75ece7d8f15e3d362cd1e63d95ee2000114fb30112e22d6520)
            check_type(argname="argument horizontal", value=horizontal, expected_type=type_hints["horizontal"])
            check_type(argname="argument horizontal_var", value=horizontal_var, expected_type=type_hints["horizontal_var"])
            check_type(argname="argument vertical", value=vertical, expected_type=type_hints["vertical"])
            check_type(argname="argument vertical_var", value=vertical_var, expected_type=type_hints["vertical_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if horizontal is not None:
            self._values["horizontal"] = horizontal
        if horizontal_var is not None:
            self._values["horizontal_var"] = horizontal_var
        if vertical is not None:
            self._values["vertical"] = vertical
        if vertical_var is not None:
            self._values["vertical_var"] = vertical_var

    @builtins.property
    def horizontal(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        '''
        result = self._values.get("horizontal")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def horizontal_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        '''
        result = self._values.get("horizontal_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        '''
        result = self._values.get("vertical")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        result = self._values.get("vertical_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareMirror(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareMirrorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareMirrorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f705ea4a787f2880b71f0434274eb9465b4053c6e3dba089d7528b021a67008)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareMirrorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa06ab2e732e425bf683a7f88243677bc750d236b4f5b628c26b93985d6240de)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareMirrorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e3d6912336a00e0f7e58f25be35c1a8c492c2aaf267c90256d78c5cc423d49df)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ca60459d411618cf51e0a80975abf38ef1ea7fb7f708a6ca64a373fdd9fd7bf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6c0773f44ff93e57399d16d3cc4dc56c6e7548ecff8624ba37d843879e847732)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareMirror]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareMirror]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8ab5c7323ff499a7b25c00b14fa6052d6aa2ca7ddd4118f87680022a2c15babc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareMirrorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareMirrorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__14bd3e562eb8640ecf987517d5c84a91883ad00a3244949f4ab0887bd1009c82)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHorizontal")
    def reset_horizontal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontal", []))

    @jsii.member(jsii_name="resetHorizontalVar")
    def reset_horizontal_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontalVar", []))

    @jsii.member(jsii_name="resetVertical")
    def reset_vertical(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVertical", []))

    @jsii.member(jsii_name="resetVerticalVar")
    def reset_vertical_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVerticalVar", []))

    @builtins.property
    @jsii.member(jsii_name="horizontalInput")
    def horizontal_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontalVarInput")
    def horizontal_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalInput")
    def vertical_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalVarInput")
    def vertical_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontal")
    def horizontal(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontal"))

    @horizontal.setter
    def horizontal(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c689b4c439612fa6e155d0f3e67069b2719acc5740ef35f60e8ab9d628d907e5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontal", value)

    @builtins.property
    @jsii.member(jsii_name="horizontalVar")
    def horizontal_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontalVar"))

    @horizontal_var.setter
    def horizontal_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cc0e6d5e7de692126a5fab0475357363fbe7013a7b6744d2b3553a6eee2a82d4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontalVar", value)

    @builtins.property
    @jsii.member(jsii_name="vertical")
    def vertical(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "vertical"))

    @vertical.setter
    def vertical(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e0c5333095e23cbbd95897a3fc7da20b21cc75bc948353a33c93d95a390ce29)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "vertical", value)

    @builtins.property
    @jsii.member(jsii_name="verticalVar")
    def vertical_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "verticalVar"))

    @vertical_var.setter
    def vertical_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9c74bc0c8835d1b419a3e2f0df6b3c1a337c8939b225fe9102737b8353d5e6cf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "verticalVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareMirror]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareMirror]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareMirror]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8bb7913f2c8c290dd033dbe3f4fbcf1af5a0e2016c54b02b2f9e6dbf87e0de0b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareMonoHue",
    jsii_struct_bases=[],
    name_mapping={"hue": "hue", "hue_var": "hueVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareMonoHue:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__59dee7bc0da7c8dca9cd61161b1f03eae3df3713606d70e84d81be366d61cad1)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareMonoHue(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareMonoHueList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareMonoHueList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8ced702f26e50134ec03c730d98ab70e65d673789cafe5316b7edf74809ec543)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareMonoHueOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__514517fec3e733f3aec2be223b5aa581aa4f1a15c941a980a184eee7b1237d78)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareMonoHueOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__101b3c696cc239e402d9215c6ee45444c7d4f9bb4cbd7ca08d0384a02b987263)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f565b24da56b6b0dbf7f40ee26e42e690b5611ceb23b70bfad7c0e3b48eb2ca1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c2cf219e27483f90341d424118b2fcc99c028f01806cceac48265cc8b13c29a4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareMonoHue]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareMonoHue]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ec558e06879f6212d3a556999b58c300b169658c7e8ca7c7c4b5e3b1f89a042)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareMonoHueOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareMonoHueOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__43c3b184446a569c162b95fbd6ca282d432b880a4a91bac318f4384f17f05629)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3e1e8cf7ca254dae743adfa03e385a81ba98d0b87c9164c45c660afa39ba5319)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1617fdccf7a8cc4ac6f39cdd8fe1927a06efa61f99f7d40794075d77283a7d9c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareMonoHue]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareMonoHue]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareMonoHue]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f39ad0b2285552dd68993fd569c240c0fcb29f50f03360f3471122462c3cc14a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareOpacity",
    jsii_struct_bases=[],
    name_mapping={"opacity": "opacity", "opacity_var": "opacityVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareOpacity:
    def __init__(
        self,
        *,
        opacity: typing.Optional[builtins.str] = None,
        opacity_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param opacity: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param opacity_var: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bd5a5b44b472ec2ad3e914f46d9aed09c3feeaf33130702b252da06e92c6e801)
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument opacity_var", value=opacity_var, expected_type=type_hints["opacity_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if opacity is not None:
            self._values["opacity"] = opacity
        if opacity_var is not None:
            self._values["opacity_var"] = opacity_var

    @builtins.property
    def opacity(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def opacity_var(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        result = self._values.get("opacity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareOpacity(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareOpacityList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareOpacityList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a8341613c12963088679f2747d7eef197c05d1a1273801905d0d62c6738908ff)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareOpacityOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__57a40ee354c9e760131583f0b46cd52dc5f213346d303c9846ece52d03224a38)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareOpacityOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8b2c7956bec237b51fd2e717de1426963381f2d3d871939047b5e7ec0d338309)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a81933d46bb7ef08fc2b634ab3d50551f7293d73519d15c2b485b4e998f84b2a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__630523157d9cd99e40e9368089b27436cd78d29354aacf9688280152bedd5869)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareOpacity]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareOpacity]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__68914f24f5f6521d13693c5e127364023b5d0226228a605eb6166ad580aa23d8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareOpacityOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareOpacityOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cbf726f21e3011b98cd0634532b9f6ae3e21e2f0d30faa81a3a2d670a33ecf83)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetOpacityVar")
    def reset_opacity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacityVar", []))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityVarInput")
    def opacity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacity"))

    @opacity.setter
    def opacity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3c8e63835e87075041e0f47a20867b211cb14ff43adc3f624a195e39ced36ff0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacity", value)

    @builtins.property
    @jsii.member(jsii_name="opacityVar")
    def opacity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacityVar"))

    @opacity_var.setter
    def opacity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e05f5a5f608f44b936888ce0d3fc78d5066e4d0a6a2f9b5ed2ba7316fa0d54c2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacityVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareOpacity]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareOpacity]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareOpacity]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__42a8e792ac4321a0c6991ee26c7295650ebdf92e0e5e0102c51865afff408845)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__396908d9c0ec5bcfd8d6a8c0b93da9bfed73af37242596435fa9412f132e65f3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putBackgroundColor")
    def put_background_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__53a9e4d08614fc7d99f2c6aff9f5c616b1c37c6dadb425758f344c51d10b9a75)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBackgroundColor", [value]))

    @jsii.member(jsii_name="putBlur")
    def put_blur(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareBlur, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__297270deeda4c14f02295a582c4ec5a03f6f662e54d8157ad68724ea56893e7d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBlur", [value]))

    @jsii.member(jsii_name="putChromaKey")
    def put_chroma_key(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareChromaKey, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8cd7d2f4728a11d88e0e9ab4d0e27e52a88f818b242e057038984b3004fab1fa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putChromaKey", [value]))

    @jsii.member(jsii_name="putComposite")
    def put_composite(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareComposite, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5bfe828b8b812a53d6aa69eecbba235514e0df172ea57aa3df37293933808b67)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putComposite", [value]))

    @jsii.member(jsii_name="putCompound")
    def put_compound(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareCompound, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__82fae2e92e21b4cd2324b3fb7a388381472af28b483410195a78b233e9dfd3b4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCompound", [value]))

    @jsii.member(jsii_name="putContrast")
    def put_contrast(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareContrast, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__da8da1986a00e45e58fbbccc34587963f6a735c83b324020b15fcb42cf09c80f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putContrast", [value]))

    @jsii.member(jsii_name="putGoop")
    def put_goop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareGoop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__acfe5ff72bf3365139d39422e78cdc43c3e5126ff35979875f9c565535938e90)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGoop", [value]))

    @jsii.member(jsii_name="putGrayscale")
    def put_grayscale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareGrayscale, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__43876e47369cc8be3870e08a60587d85fdbfb5727c7e08cd7071419a52c02142)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGrayscale", [value]))

    @jsii.member(jsii_name="putHsl")
    def put_hsl(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareHsl, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__12a84beea7df92faa0b2e57c567d13cdefbd47aa238553e244d54059dab206a8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsl", [value]))

    @jsii.member(jsii_name="putHsv")
    def put_hsv(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareHsv, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__720c63fcde5955e6049e29e3c8c80b7d27d7e3c3fc21ec4b246e756d8efded8e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsv", [value]))

    @jsii.member(jsii_name="putIfDimension")
    def put_if_dimension(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfDimension, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__129caa3b7257035a6ea0f934606d345966bba64fe64920e2a963fda618ee9e52)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfDimension", [value]))

    @jsii.member(jsii_name="putIfOrientation")
    def put_if_orientation(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cdcbcaa00c2c70e68d9abf56cb3f9b4daec898286899caf70591097b8cd19924)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfOrientation", [value]))

    @jsii.member(jsii_name="putMaxColors")
    def put_max_colors(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareMaxColors, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fde18d1c36dbe7ad33c5278872ad40b7a3ea068f4b47601634d39b3d6177f351)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMaxColors", [value]))

    @jsii.member(jsii_name="putMirror")
    def put_mirror(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareMirror, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6620789a8ed35544375cc7946045f8016d02d7c7846ffcf0c49f5c6dde8f28c6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMirror", [value]))

    @jsii.member(jsii_name="putMonoHue")
    def put_mono_hue(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareMonoHue, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2152fde975b3609e152c09fb5751040d99492b187c91979b29a8a781376ee747)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMonoHue", [value]))

    @jsii.member(jsii_name="putOpacity")
    def put_opacity(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareOpacity, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fd6210896ea2df193b612571f411dfb1b9bc9f121d012b5a33cfad349b50c56c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putOpacity", [value]))

    @jsii.member(jsii_name="putRemoveColor")
    def put_remove_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareRemoveColor", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ae404b081bd76742830efc037236289c485858d95b1f88de17ed7e5bdea04072)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRemoveColor", [value]))

    @jsii.member(jsii_name="putUnsharpMask")
    def put_unsharp_mask(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareUnsharpMask", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e233531c69c30f8527aac443b6156a3bafdec0690dc0c51bc83f6e00523c1ea2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putUnsharpMask", [value]))

    @jsii.member(jsii_name="resetBackgroundColor")
    def reset_background_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBackgroundColor", []))

    @jsii.member(jsii_name="resetBlur")
    def reset_blur(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBlur", []))

    @jsii.member(jsii_name="resetChromaKey")
    def reset_chroma_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChromaKey", []))

    @jsii.member(jsii_name="resetComposite")
    def reset_composite(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetComposite", []))

    @jsii.member(jsii_name="resetCompound")
    def reset_compound(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCompound", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetGoop")
    def reset_goop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGoop", []))

    @jsii.member(jsii_name="resetGrayscale")
    def reset_grayscale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGrayscale", []))

    @jsii.member(jsii_name="resetHsl")
    def reset_hsl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsl", []))

    @jsii.member(jsii_name="resetHsv")
    def reset_hsv(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsv", []))

    @jsii.member(jsii_name="resetIfDimension")
    def reset_if_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfDimension", []))

    @jsii.member(jsii_name="resetIfOrientation")
    def reset_if_orientation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfOrientation", []))

    @jsii.member(jsii_name="resetMaxColors")
    def reset_max_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxColors", []))

    @jsii.member(jsii_name="resetMirror")
    def reset_mirror(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMirror", []))

    @jsii.member(jsii_name="resetMonoHue")
    def reset_mono_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonoHue", []))

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetRemoveColor")
    def reset_remove_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRemoveColor", []))

    @jsii.member(jsii_name="resetUnsharpMask")
    def reset_unsharp_mask(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUnsharpMask", []))

    @builtins.property
    @jsii.member(jsii_name="backgroundColor")
    def background_color(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareBackgroundColorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareBackgroundColorList, jsii.get(self, "backgroundColor"))

    @builtins.property
    @jsii.member(jsii_name="blur")
    def blur(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareBlurList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareBlurList, jsii.get(self, "blur"))

    @builtins.property
    @jsii.member(jsii_name="chromaKey")
    def chroma_key(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareChromaKeyList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareChromaKeyList, jsii.get(self, "chromaKey"))

    @builtins.property
    @jsii.member(jsii_name="composite")
    def composite(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareCompositeList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareCompositeList, jsii.get(self, "composite"))

    @builtins.property
    @jsii.member(jsii_name="compound")
    def compound(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareCompoundList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareCompoundList, jsii.get(self, "compound"))

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareContrastList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareContrastList, jsii.get(self, "contrast"))

    @builtins.property
    @jsii.member(jsii_name="goop")
    def goop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareGoopList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareGoopList, jsii.get(self, "goop"))

    @builtins.property
    @jsii.member(jsii_name="grayscale")
    def grayscale(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareGrayscaleList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareGrayscaleList, jsii.get(self, "grayscale"))

    @builtins.property
    @jsii.member(jsii_name="hsl")
    def hsl(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareHslList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareHslList, jsii.get(self, "hsl"))

    @builtins.property
    @jsii.member(jsii_name="hsv")
    def hsv(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareHsvList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareHsvList, jsii.get(self, "hsv"))

    @builtins.property
    @jsii.member(jsii_name="ifDimension")
    def if_dimension(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionList, jsii.get(self, "ifDimension"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientation")
    def if_orientation(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationList, jsii.get(self, "ifOrientation"))

    @builtins.property
    @jsii.member(jsii_name="maxColors")
    def max_colors(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareMaxColorsList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareMaxColorsList, jsii.get(self, "maxColors"))

    @builtins.property
    @jsii.member(jsii_name="mirror")
    def mirror(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareMirrorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareMirrorList, jsii.get(self, "mirror"))

    @builtins.property
    @jsii.member(jsii_name="monoHue")
    def mono_hue(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareMonoHueList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareMonoHueList, jsii.get(self, "monoHue"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareOpacityList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareOpacityList, jsii.get(self, "opacity"))

    @builtins.property
    @jsii.member(jsii_name="removeColor")
    def remove_color(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareRemoveColorList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareRemoveColorList", jsii.get(self, "removeColor"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMask")
    def unsharp_mask(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareUnsharpMaskList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareUnsharpMaskList", jsii.get(self, "unsharpMask"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColorInput")
    def background_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareBackgroundColor]]], jsii.get(self, "backgroundColorInput"))

    @builtins.property
    @jsii.member(jsii_name="blurInput")
    def blur_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareBlur]]], jsii.get(self, "blurInput"))

    @builtins.property
    @jsii.member(jsii_name="chromaKeyInput")
    def chroma_key_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareChromaKey]]], jsii.get(self, "chromaKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="compositeInput")
    def composite_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareComposite]]], jsii.get(self, "compositeInput"))

    @builtins.property
    @jsii.member(jsii_name="compoundInput")
    def compound_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareCompound]]], jsii.get(self, "compoundInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareContrast]]], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="goopInput")
    def goop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareGoop]]], jsii.get(self, "goopInput"))

    @builtins.property
    @jsii.member(jsii_name="grayscaleInput")
    def grayscale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareGrayscale]]], jsii.get(self, "grayscaleInput"))

    @builtins.property
    @jsii.member(jsii_name="hslInput")
    def hsl_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareHsl]]], jsii.get(self, "hslInput"))

    @builtins.property
    @jsii.member(jsii_name="hsvInput")
    def hsv_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareHsv]]], jsii.get(self, "hsvInput"))

    @builtins.property
    @jsii.member(jsii_name="ifDimensionInput")
    def if_dimension_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfDimension]]], jsii.get(self, "ifDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientationInput")
    def if_orientation_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfOrientation]]], jsii.get(self, "ifOrientationInput"))

    @builtins.property
    @jsii.member(jsii_name="maxColorsInput")
    def max_colors_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareMaxColors]]], jsii.get(self, "maxColorsInput"))

    @builtins.property
    @jsii.member(jsii_name="mirrorInput")
    def mirror_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareMirror]]], jsii.get(self, "mirrorInput"))

    @builtins.property
    @jsii.member(jsii_name="monoHueInput")
    def mono_hue_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareMonoHue]]], jsii.get(self, "monoHueInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareOpacity]]], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="removeColorInput")
    def remove_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareRemoveColor"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareRemoveColor"]]], jsii.get(self, "removeColorInput"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMaskInput")
    def unsharp_mask_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareUnsharpMask"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareUnsharpMask"]]], jsii.get(self, "unsharpMaskInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquare]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquare], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquare],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4645eac2256e126aa755c1853dada88b4154b8748b10ffa5c3baf889bc80aefb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareRemoveColor",
    jsii_struct_bases=[],
    name_mapping={
        "color": "color",
        "color_var": "colorVar",
        "feather": "feather",
        "feather_var": "featherVar",
        "tolerance": "tolerance",
        "tolerance_var": "toleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareRemoveColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
        feather: typing.Optional[builtins.str] = None,
        feather_var: typing.Optional[builtins.str] = None,
        tolerance: typing.Optional[builtins.str] = None,
        tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        :param feather: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        :param feather_var: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        :param tolerance: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        :param tolerance_var: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a4159987b4ece1e25a2b644b2a6462b63bba51457356224621d558bb2e5cb1e)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
            check_type(argname="argument feather", value=feather, expected_type=type_hints["feather"])
            check_type(argname="argument feather_var", value=feather_var, expected_type=type_hints["feather_var"])
            check_type(argname="argument tolerance", value=tolerance, expected_type=type_hints["tolerance"])
            check_type(argname="argument tolerance_var", value=tolerance_var, expected_type=type_hints["tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var
        if feather is not None:
            self._values["feather"] = feather
        if feather_var is not None:
            self._values["feather_var"] = feather_var
        if tolerance is not None:
            self._values["tolerance"] = tolerance
        if tolerance_var is not None:
            self._values["tolerance_var"] = tolerance_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        '''
        result = self._values.get("feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather_var(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        '''
        result = self._values.get("feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        '''
        result = self._values.get("tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance_var(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        result = self._values.get("tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareRemoveColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareRemoveColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareRemoveColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__881ea29020003e5b50ed805b7c44e0297750eb5701ad75c152174009a3dbbc64)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareRemoveColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b47a9fc16870f92978c928645aa77af874392009644b1af59e1019f30b84a401)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareRemoveColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2bdaddd9174bfa406969ef49ba78034eb62ca66ece329f03cb403c843d675243)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b2c2dca082dcee8032bd49b9b58739210e7f4bc957f62a5162c9a5050d4168ea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__342d256d01fc6f5831f36abdb44765e84b123c0148d5493ee3a3375836e1f79f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareRemoveColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareRemoveColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareRemoveColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a2537b18372ab46f2efc58c93c1a2f9ae60221f60b4e67d75181dede045d28fd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareRemoveColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareRemoveColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b9684f05a485775e5d2cc88fd354e115942edbfdf5e602e97d26524fbb9166bd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @jsii.member(jsii_name="resetFeather")
    def reset_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeather", []))

    @jsii.member(jsii_name="resetFeatherVar")
    def reset_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatherVar", []))

    @jsii.member(jsii_name="resetTolerance")
    def reset_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTolerance", []))

    @jsii.member(jsii_name="resetToleranceVar")
    def reset_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featherInput")
    def feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherInput"))

    @builtins.property
    @jsii.member(jsii_name="featherVarInput")
    def feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceInput")
    def tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceVarInput")
    def tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cff0e56222bbc5f360a86e0447cb886db661aed132cd9801fd5b3d5284f5a219)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9930da6e7481cbe22f606dd796b088f4082beeb5492f9c35a518bbb6d4f58db1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="feather")
    def feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "feather"))

    @feather.setter
    def feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__418a1a91eac7838eb52fcc87dd64533d14d37d53c4ee4183dc9d9d7acaffd520)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "feather", value)

    @builtins.property
    @jsii.member(jsii_name="featherVar")
    def feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featherVar"))

    @feather_var.setter
    def feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c2f401b4fb3a0faa624ffddf0b70cb4dad1488ad66fd69872b9087f1de799798)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featherVar", value)

    @builtins.property
    @jsii.member(jsii_name="tolerance")
    def tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tolerance"))

    @tolerance.setter
    def tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dd88dc4663be2a254112a3dfb6ca9036e9fe82ae706b6212f55df52673d39748)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tolerance", value)

    @builtins.property
    @jsii.member(jsii_name="toleranceVar")
    def tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "toleranceVar"))

    @tolerance_var.setter
    def tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5989923cf84c9a8cf3e232e8baba57d6cd1fef6d95f3804bbb660e001116d25a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "toleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareRemoveColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareRemoveColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareRemoveColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5644ed5eed034c24c8263ece3a25933a1491e60a791860fe912a75d98d343ce1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareUnsharpMask",
    jsii_struct_bases=[],
    name_mapping={
        "gain": "gain",
        "gain_var": "gainVar",
        "sigma": "sigma",
        "sigma_var": "sigmaVar",
        "threshold": "threshold",
        "threshold_var": "thresholdVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareUnsharpMask:
    def __init__(
        self,
        *,
        gain: typing.Optional[builtins.str] = None,
        gain_var: typing.Optional[builtins.str] = None,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
        threshold: typing.Optional[builtins.str] = None,
        threshold_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param gain: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        :param gain_var: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        :param sigma: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        :param threshold: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        :param threshold_var: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c609ee229d4a67489de8a0b1b3ad7554b65c3985d94dbb6d4cc7af0cb868329b)
            check_type(argname="argument gain", value=gain, expected_type=type_hints["gain"])
            check_type(argname="argument gain_var", value=gain_var, expected_type=type_hints["gain_var"])
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
            check_type(argname="argument threshold", value=threshold, expected_type=type_hints["threshold"])
            check_type(argname="argument threshold_var", value=threshold_var, expected_type=type_hints["threshold_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if gain is not None:
            self._values["gain"] = gain
        if gain_var is not None:
            self._values["gain_var"] = gain_var
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var
        if threshold is not None:
            self._values["threshold"] = threshold
        if threshold_var is not None:
            self._values["threshold_var"] = threshold_var

    @builtins.property
    def gain(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        '''
        result = self._values.get("gain")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gain_var(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        '''
        result = self._values.get("gain_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        '''
        result = self._values.get("threshold")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold_var(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        result = self._values.get("threshold_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareUnsharpMask(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareUnsharpMaskList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareUnsharpMaskList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d5a3bb86258e283e401f8a2816d24e984106cb8a5864684b34b55a89fdbff1dc)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareUnsharpMaskOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d4dba86f4fd725b396b68cbad05d4a0d087332ba5d2a70d3f16bbb1c5f6184b)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareUnsharpMaskOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__22b0a973d63bf7b0aea51f6f0dc321918379aa4f2c93e0d58d5d520d34c9f837)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f9e58334317fe4e04e2b340fc9b326467cb71ffee100aad219ea45da366cf418)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ed40a635d130eef09db82480d7a0769166a0c114061ca638fd7220c21037fe3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareUnsharpMask]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareUnsharpMask]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareUnsharpMask]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b2b29bc1c039aefcdce15a97877b561159c7265cd4b739f48acc4cb4cd1b80f6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareUnsharpMaskOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareUnsharpMaskOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__437ad02d02861e782991ae8fadf931be50167d5dc1f47753f7e9eb5f6885bbcc)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetGain")
    def reset_gain(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGain", []))

    @jsii.member(jsii_name="resetGainVar")
    def reset_gain_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGainVar", []))

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @jsii.member(jsii_name="resetThreshold")
    def reset_threshold(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThreshold", []))

    @jsii.member(jsii_name="resetThresholdVar")
    def reset_threshold_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThresholdVar", []))

    @builtins.property
    @jsii.member(jsii_name="gainInput")
    def gain_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainInput"))

    @builtins.property
    @jsii.member(jsii_name="gainVarInput")
    def gain_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdInput")
    def threshold_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdVarInput")
    def threshold_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gain")
    def gain(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gain"))

    @gain.setter
    def gain(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ac3249a84440c71450313b25e4b3c4a40ce3dacbdc8e87ea43b0ce599034806)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gain", value)

    @builtins.property
    @jsii.member(jsii_name="gainVar")
    def gain_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gainVar"))

    @gain_var.setter
    def gain_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__57dd3fbd33d971e3d0965ca21b208a041445bdf8e3a9c45cf75bb1141b984240)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gainVar", value)

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a56c5fa5524647b76acc4e7a0f397902735a44026441ac9f789a5d759bdcc66c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__09bb0bda45c990ca2798a021b323916964adcf91b5d3ac271c0bab97f9b16bf6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="threshold")
    def threshold(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "threshold"))

    @threshold.setter
    def threshold(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d1c336f7bef381d2235d54d193b3f5db4b1c09652c16e7fef71c8cf260e78ef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "threshold", value)

    @builtins.property
    @jsii.member(jsii_name="thresholdVar")
    def threshold_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "thresholdVar"))

    @threshold_var.setter
    def threshold_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ee64eca6223836a3d60f7686204552e6b0890b204d6316341417abdacd81045)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "thresholdVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareUnsharpMask]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareUnsharpMask]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareUnsharpMask]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9b6fe030009c657badbbbef94d6adfe2561ba8702dd98c6ec8200d65a7cd02e4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanMaxColors",
    jsii_struct_bases=[],
    name_mapping={"colors": "colors", "colors_var": "colorsVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanMaxColors:
    def __init__(
        self,
        *,
        colors: typing.Optional[builtins.str] = None,
        colors_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param colors: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        :param colors_var: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ba680ed70f1976004a620d30a825b47e80fbbb670d89e3bbc29e77166ce99e9)
            check_type(argname="argument colors", value=colors, expected_type=type_hints["colors"])
            check_type(argname="argument colors_var", value=colors_var, expected_type=type_hints["colors_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if colors is not None:
            self._values["colors"] = colors
        if colors_var is not None:
            self._values["colors_var"] = colors_var

    @builtins.property
    def colors(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        '''
        result = self._values.get("colors")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def colors_var(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        result = self._values.get("colors_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanMaxColors(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanMaxColorsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanMaxColorsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__319e9947c6149471c2e15231b48d35bc0344dc8d6c5c7627b4fcffd4ec63be48)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanMaxColorsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6fc251597547fcb0d6572b04cb6121b35fc3139ebff81d3208d6510ddfeb262d)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanMaxColorsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aa92fa33d7e18368ae8b4359d65c18b776ec7e3bf4583688ffad5e265d3acddb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__66f44a9d0ee447ebe360be34a69bc200ae2cc5e3fa1fd615c1fa1429362898d7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__11f864e2a8f914e2d3a3278bf1fc92ca810ffd9bb9e12f3a040345c7656b707c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanMaxColors]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanMaxColors]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b8f35b45dfc2678a7a8cefaa1ce7330f44038214aac16d0ce9b90d99328fe3ee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanMaxColorsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanMaxColorsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa33a96ee9e4a24fce9efffb1eb16524c616045cfb2e9ffc2d8a556a3a52d575)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColors")
    def reset_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColors", []))

    @jsii.member(jsii_name="resetColorsVar")
    def reset_colors_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorsVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorsInput")
    def colors_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsInput"))

    @builtins.property
    @jsii.member(jsii_name="colorsVarInput")
    def colors_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsVarInput"))

    @builtins.property
    @jsii.member(jsii_name="colors")
    def colors(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colors"))

    @colors.setter
    def colors(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__00546e6819401cc7fce46f780e0425e0bd0512622ba76244e86cf26b8371cfbc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colors", value)

    @builtins.property
    @jsii.member(jsii_name="colorsVar")
    def colors_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorsVar"))

    @colors_var.setter
    def colors_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c688913160d53b14e9f10cc303856fe69903bdf3a2eaab005f9255be96aceb3d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorsVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanMaxColors]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanMaxColors]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanMaxColors]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cafb0afb54702725d39c0a2d8e7124775e5d7fda9aea8c39b424557f77992d35)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanMirror",
    jsii_struct_bases=[],
    name_mapping={
        "horizontal": "horizontal",
        "horizontal_var": "horizontalVar",
        "vertical": "vertical",
        "vertical_var": "verticalVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanMirror:
    def __init__(
        self,
        *,
        horizontal: typing.Optional[builtins.str] = None,
        horizontal_var: typing.Optional[builtins.str] = None,
        vertical: typing.Optional[builtins.str] = None,
        vertical_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param horizontal: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        :param horizontal_var: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        :param vertical: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        :param vertical_var: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab25245ea38e9863eedd1b0ce6602b595ac9ae60bf50d6cf5b01c484a03dbc25)
            check_type(argname="argument horizontal", value=horizontal, expected_type=type_hints["horizontal"])
            check_type(argname="argument horizontal_var", value=horizontal_var, expected_type=type_hints["horizontal_var"])
            check_type(argname="argument vertical", value=vertical, expected_type=type_hints["vertical"])
            check_type(argname="argument vertical_var", value=vertical_var, expected_type=type_hints["vertical_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if horizontal is not None:
            self._values["horizontal"] = horizontal
        if horizontal_var is not None:
            self._values["horizontal_var"] = horizontal_var
        if vertical is not None:
            self._values["vertical"] = vertical
        if vertical_var is not None:
            self._values["vertical_var"] = vertical_var

    @builtins.property
    def horizontal(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        '''
        result = self._values.get("horizontal")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def horizontal_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        '''
        result = self._values.get("horizontal_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        '''
        result = self._values.get("vertical")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        result = self._values.get("vertical_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanMirror(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanMirrorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanMirrorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__92596bdb0c53bbd12071861e700ef27c8b014ac1ec51dc5b52d600a96de6112f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanMirrorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__85ef42d184b63cd7d34b875f6e90b602c4300927347debbb30165d94e6f6188a)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanMirrorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cdc9287b5569e982a665004fad14a9faf164912d26805f874fc90799978f0f48)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a0c78628e0d1229fee3a16e5b5d58395dd8141bf2b74013b2745f88b99c94a5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__11246b2b369088f47aa6e02e5119e7da99d96ff84ae4e1368b8b49a6ec003631)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanMirror]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanMirror]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__065280d63329875ab4c6cd3536e21344fdd171d744bf77428e5ef23151761cd7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanMirrorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanMirrorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__843d0ded2edfd87d700ed0e0e523e3d3df6593e75fbdd74ed787de9ee195313a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHorizontal")
    def reset_horizontal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontal", []))

    @jsii.member(jsii_name="resetHorizontalVar")
    def reset_horizontal_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontalVar", []))

    @jsii.member(jsii_name="resetVertical")
    def reset_vertical(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVertical", []))

    @jsii.member(jsii_name="resetVerticalVar")
    def reset_vertical_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVerticalVar", []))

    @builtins.property
    @jsii.member(jsii_name="horizontalInput")
    def horizontal_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontalVarInput")
    def horizontal_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalInput")
    def vertical_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalVarInput")
    def vertical_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontal")
    def horizontal(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontal"))

    @horizontal.setter
    def horizontal(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__45e25327f045b60026f9ea6b5d2dd3dee389c6361860a3f9eb79681ca986efd6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontal", value)

    @builtins.property
    @jsii.member(jsii_name="horizontalVar")
    def horizontal_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontalVar"))

    @horizontal_var.setter
    def horizontal_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab56d26c417bce1f9a49cd727ef7fe046293db15b6b1c9fda34439545c6479b7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontalVar", value)

    @builtins.property
    @jsii.member(jsii_name="vertical")
    def vertical(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "vertical"))

    @vertical.setter
    def vertical(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__80fa4393c9dd6ca0b341e950c4c3ef7452988594d2cf7671eeff3b7e1bc89d9e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "vertical", value)

    @builtins.property
    @jsii.member(jsii_name="verticalVar")
    def vertical_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "verticalVar"))

    @vertical_var.setter
    def vertical_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__809f0af56547d421992e21c6fa3eda5d14fd9a11c7ca9f539c95ca53f6ed1968)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "verticalVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanMirror]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanMirror]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanMirror]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7e958cca876936aac18257659f33daffb2253e2def19c9474b68b71480395bc9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanMonoHue",
    jsii_struct_bases=[],
    name_mapping={"hue": "hue", "hue_var": "hueVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanMonoHue:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd073209e92e1ad8cab13e9a4613243903c77df96e7d7f1877621fffe8510816)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanMonoHue(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanMonoHueList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanMonoHueList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9e2f6a034d2ae292e332685fd80e2d738a7be219a16e027f57818d96e379334a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanMonoHueOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a8a18809ca358313216ea1cd7e7e7680b2555e76047723e6bd75174df4852c79)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanMonoHueOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__179724959dac509986f5d8051805f03a8e3d67c8d04f83f05ee5a8ddb944c5f2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__16d4010e18e767922f26168006ca9d7f78e599f89018832bb47fda41b742a3ee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__385f8910cf1ee67fc534aa19a5d7afadc1a0a39558907cb834f8a57c48cc420b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanMonoHue]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanMonoHue]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__285f8c4b987988f6be2eabbf33e2d806a21d2e00c41b9431ad3fc0640bcf55ed)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanMonoHueOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanMonoHueOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__15d9e857495b0b1e6ab3ee1be817661e3a0e92b87d6248efc446d8db5855aaf1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__443d04b8477d4ba10983990a2012947d4e47f70f85a9d92f8f014bca8f00a793)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__503fd1df4d771bc91b8aff9acec3c6570a7c90105807489f25fa6171dae13e81)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanMonoHue]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanMonoHue]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanMonoHue]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__42971ee35a5bcb62e895bdc9510aa6d2a46738ada0d52a863a29509336978aac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanOpacity",
    jsii_struct_bases=[],
    name_mapping={"opacity": "opacity", "opacity_var": "opacityVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanOpacity:
    def __init__(
        self,
        *,
        opacity: typing.Optional[builtins.str] = None,
        opacity_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param opacity: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param opacity_var: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5988d9fe80ef763059f6c1542e651dac53a5ecef8138a6d18f56ebff832cb279)
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument opacity_var", value=opacity_var, expected_type=type_hints["opacity_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if opacity is not None:
            self._values["opacity"] = opacity
        if opacity_var is not None:
            self._values["opacity_var"] = opacity_var

    @builtins.property
    def opacity(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def opacity_var(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        result = self._values.get("opacity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanOpacity(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanOpacityList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanOpacityList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__78f604d60de301b6619a9c3fa81e79bbf4fb7036e72e43fdd156a6286f3334f3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanOpacityOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8b5ee93811e8997d0a5fb7c98ce59406340e2c17f74f763e1414b7111db9c354)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanOpacityOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a19b51f844b4602f17eb9fda2483311c48033703ec0a2f68fe21fb629f5411dc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__669775e69f2403bd0ac7a43838552e3ca2b8a839efae879f4e0f0c44744d1b68)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8d6c311b27f8dc5c67b2f03a373e9ffd92ffb285d4a7568f077b893f0190aed8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanOpacity]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanOpacity]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f9582d6ad67b6a9aa7a1e07c435b8aaa7dc262715bd9aead8dd397fac1011788)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanOpacityOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanOpacityOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b65d0146b4e2a410080c64442bdd29b61d5ee9d9e36f39baadcec4f343db2869)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetOpacityVar")
    def reset_opacity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacityVar", []))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityVarInput")
    def opacity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacity"))

    @opacity.setter
    def opacity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__92467b8209ef7227f71e289118aa3b15f0492430a38c91d3ce579d9712e4d994)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacity", value)

    @builtins.property
    @jsii.member(jsii_name="opacityVar")
    def opacity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacityVar"))

    @opacity_var.setter
    def opacity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__72c31efa2b21d661421f7512a4b057c0f749440294140dd8871fb9379157b9ce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacityVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanOpacity]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanOpacity]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanOpacity]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4de756ad4b2e1d29488eafa7924f08bcb6af67f0bd2d74047eff320aa6622c86)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__47070e26c8a479c8200ab5020d20d03eca694b4e376d9932595d91a39bcd9680)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putBackgroundColor")
    def put_background_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__780f7f60001e0c3c659103182edbbf5cd8e5eecb540ece98a5739db050207cab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBackgroundColor", [value]))

    @jsii.member(jsii_name="putBlur")
    def put_blur(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanBlur, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b20b85b51255190dce0bd2658eeede482eff54ab2597859fe211fa4199aaa24e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBlur", [value]))

    @jsii.member(jsii_name="putChromaKey")
    def put_chroma_key(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanChromaKey, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac0071d04071cc96af510ac65fb58308b30f4c1701e51eb5bd1abf147badaa8e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putChromaKey", [value]))

    @jsii.member(jsii_name="putComposite")
    def put_composite(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanComposite, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d3afe97f84b61c81264f9461e5784dbbfd699727d1f8cedeff5f90a950cf876)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putComposite", [value]))

    @jsii.member(jsii_name="putCompound")
    def put_compound(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompound, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b6e51e1c8185ec3731f7d4cdf178807aa42314705a6ae20fac6f5e32daaad6ae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCompound", [value]))

    @jsii.member(jsii_name="putContrast")
    def put_contrast(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanContrast, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__522eb574dbd7484b67d55c563d63b467ae2299d3e247078b20c2ba853b0e7d69)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putContrast", [value]))

    @jsii.member(jsii_name="putGoop")
    def put_goop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanGoop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d3eac5c762e1493f3e204df2c2304fe3d6ce1af444ed94f2883cc439cbca418)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGoop", [value]))

    @jsii.member(jsii_name="putGrayscale")
    def put_grayscale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanGrayscale, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__24a6e998d5d9d8a92bd5509127c7b4cf0fd381a1d236e6874ba42a21fbc599f3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGrayscale", [value]))

    @jsii.member(jsii_name="putHsl")
    def put_hsl(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanHsl, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6772150da709b30dc3fab66d250435439e1ecff26f7e9e38a5ed549c24b9a055)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsl", [value]))

    @jsii.member(jsii_name="putHsv")
    def put_hsv(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanHsv, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e82648770fdff250dd51d621b953db8db5c2e90de08ec53795f7d588c4cec996)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsv", [value]))

    @jsii.member(jsii_name="putIfDimension")
    def put_if_dimension(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimension, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__65619f902136953bcbb6217fc965624f1e279ee72c8eeeee397c821089c0daa0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfDimension", [value]))

    @jsii.member(jsii_name="putIfOrientation")
    def put_if_orientation(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a9db21286bf87b7ab0aa83eb96e40d2c25544889ad63a916f5ab1054822c1697)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfOrientation", [value]))

    @jsii.member(jsii_name="putMaxColors")
    def put_max_colors(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanMaxColors, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4f02eb8da2f072fa9cfa3e8af4053dd9897cfa13e45a2bed106a15522e2289c1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMaxColors", [value]))

    @jsii.member(jsii_name="putMirror")
    def put_mirror(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanMirror, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7f54e302fa7daee6e139249ee84568be5121719417d5b59b79e1335b776a5d00)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMirror", [value]))

    @jsii.member(jsii_name="putMonoHue")
    def put_mono_hue(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanMonoHue, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__46e0506bbee5df991722f7c46052cc4f5a9d2bdcade4e710ce0be82c55f2b016)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMonoHue", [value]))

    @jsii.member(jsii_name="putOpacity")
    def put_opacity(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanOpacity, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__051d494a8636e609ac9e71cf50c0556ccd8cefd3a88ef6630d654299312004e7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putOpacity", [value]))

    @jsii.member(jsii_name="putRemoveColor")
    def put_remove_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanRemoveColor", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__37456b4078c4a3b34c267cc0d1caf5bc87e17aae72639105b5aa9f7fec7a5105)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRemoveColor", [value]))

    @jsii.member(jsii_name="putUnsharpMask")
    def put_unsharp_mask(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanUnsharpMask", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7afc26e7864c99c1d7d274ed13c718a65dbbc9808453c0376402480a22f05760)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putUnsharpMask", [value]))

    @jsii.member(jsii_name="resetBackgroundColor")
    def reset_background_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBackgroundColor", []))

    @jsii.member(jsii_name="resetBlur")
    def reset_blur(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBlur", []))

    @jsii.member(jsii_name="resetChromaKey")
    def reset_chroma_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChromaKey", []))

    @jsii.member(jsii_name="resetComposite")
    def reset_composite(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetComposite", []))

    @jsii.member(jsii_name="resetCompound")
    def reset_compound(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCompound", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetGoop")
    def reset_goop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGoop", []))

    @jsii.member(jsii_name="resetGrayscale")
    def reset_grayscale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGrayscale", []))

    @jsii.member(jsii_name="resetHsl")
    def reset_hsl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsl", []))

    @jsii.member(jsii_name="resetHsv")
    def reset_hsv(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsv", []))

    @jsii.member(jsii_name="resetIfDimension")
    def reset_if_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfDimension", []))

    @jsii.member(jsii_name="resetIfOrientation")
    def reset_if_orientation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfOrientation", []))

    @jsii.member(jsii_name="resetMaxColors")
    def reset_max_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxColors", []))

    @jsii.member(jsii_name="resetMirror")
    def reset_mirror(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMirror", []))

    @jsii.member(jsii_name="resetMonoHue")
    def reset_mono_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonoHue", []))

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetRemoveColor")
    def reset_remove_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRemoveColor", []))

    @jsii.member(jsii_name="resetUnsharpMask")
    def reset_unsharp_mask(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUnsharpMask", []))

    @builtins.property
    @jsii.member(jsii_name="backgroundColor")
    def background_color(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanBackgroundColorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanBackgroundColorList, jsii.get(self, "backgroundColor"))

    @builtins.property
    @jsii.member(jsii_name="blur")
    def blur(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanBlurList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanBlurList, jsii.get(self, "blur"))

    @builtins.property
    @jsii.member(jsii_name="chromaKey")
    def chroma_key(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanChromaKeyList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanChromaKeyList, jsii.get(self, "chromaKey"))

    @builtins.property
    @jsii.member(jsii_name="composite")
    def composite(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeList, jsii.get(self, "composite"))

    @builtins.property
    @jsii.member(jsii_name="compound")
    def compound(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundList, jsii.get(self, "compound"))

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanContrastList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanContrastList, jsii.get(self, "contrast"))

    @builtins.property
    @jsii.member(jsii_name="goop")
    def goop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanGoopList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanGoopList, jsii.get(self, "goop"))

    @builtins.property
    @jsii.member(jsii_name="grayscale")
    def grayscale(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanGrayscaleList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanGrayscaleList, jsii.get(self, "grayscale"))

    @builtins.property
    @jsii.member(jsii_name="hsl")
    def hsl(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanHslList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanHslList, jsii.get(self, "hsl"))

    @builtins.property
    @jsii.member(jsii_name="hsv")
    def hsv(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanHsvList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanHsvList, jsii.get(self, "hsv"))

    @builtins.property
    @jsii.member(jsii_name="ifDimension")
    def if_dimension(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionList", jsii.get(self, "ifDimension"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientation")
    def if_orientation(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationList, jsii.get(self, "ifOrientation"))

    @builtins.property
    @jsii.member(jsii_name="maxColors")
    def max_colors(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanMaxColorsList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanMaxColorsList, jsii.get(self, "maxColors"))

    @builtins.property
    @jsii.member(jsii_name="mirror")
    def mirror(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanMirrorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanMirrorList, jsii.get(self, "mirror"))

    @builtins.property
    @jsii.member(jsii_name="monoHue")
    def mono_hue(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanMonoHueList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanMonoHueList, jsii.get(self, "monoHue"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanOpacityList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanOpacityList, jsii.get(self, "opacity"))

    @builtins.property
    @jsii.member(jsii_name="removeColor")
    def remove_color(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanRemoveColorList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanRemoveColorList", jsii.get(self, "removeColor"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMask")
    def unsharp_mask(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanUnsharpMaskList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanUnsharpMaskList", jsii.get(self, "unsharpMask"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColorInput")
    def background_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanBackgroundColor]]], jsii.get(self, "backgroundColorInput"))

    @builtins.property
    @jsii.member(jsii_name="blurInput")
    def blur_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanBlur]]], jsii.get(self, "blurInput"))

    @builtins.property
    @jsii.member(jsii_name="chromaKeyInput")
    def chroma_key_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanChromaKey]]], jsii.get(self, "chromaKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="compositeInput")
    def composite_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanComposite]]], jsii.get(self, "compositeInput"))

    @builtins.property
    @jsii.member(jsii_name="compoundInput")
    def compound_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompound]]], jsii.get(self, "compoundInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanContrast]]], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="goopInput")
    def goop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanGoop]]], jsii.get(self, "goopInput"))

    @builtins.property
    @jsii.member(jsii_name="grayscaleInput")
    def grayscale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanGrayscale]]], jsii.get(self, "grayscaleInput"))

    @builtins.property
    @jsii.member(jsii_name="hslInput")
    def hsl_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanHsl]]], jsii.get(self, "hslInput"))

    @builtins.property
    @jsii.member(jsii_name="hsvInput")
    def hsv_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanHsv]]], jsii.get(self, "hsvInput"))

    @builtins.property
    @jsii.member(jsii_name="ifDimensionInput")
    def if_dimension_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimension]]], jsii.get(self, "ifDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientationInput")
    def if_orientation_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientation]]], jsii.get(self, "ifOrientationInput"))

    @builtins.property
    @jsii.member(jsii_name="maxColorsInput")
    def max_colors_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanMaxColors]]], jsii.get(self, "maxColorsInput"))

    @builtins.property
    @jsii.member(jsii_name="mirrorInput")
    def mirror_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanMirror]]], jsii.get(self, "mirrorInput"))

    @builtins.property
    @jsii.member(jsii_name="monoHueInput")
    def mono_hue_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanMonoHue]]], jsii.get(self, "monoHueInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanOpacity]]], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="removeColorInput")
    def remove_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanRemoveColor"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanRemoveColor"]]], jsii.get(self, "removeColorInput"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMaskInput")
    def unsharp_mask_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanUnsharpMask"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanUnsharpMask"]]], jsii.get(self, "unsharpMaskInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__51969e678cf728723a5faa149dbc68d99fba8ab426a5326c84a4ba2e9d52164a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanRemoveColor",
    jsii_struct_bases=[],
    name_mapping={
        "color": "color",
        "color_var": "colorVar",
        "feather": "feather",
        "feather_var": "featherVar",
        "tolerance": "tolerance",
        "tolerance_var": "toleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanRemoveColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
        feather: typing.Optional[builtins.str] = None,
        feather_var: typing.Optional[builtins.str] = None,
        tolerance: typing.Optional[builtins.str] = None,
        tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        :param feather: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        :param feather_var: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        :param tolerance: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        :param tolerance_var: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bf50264e31b195d2892a770f941c81b01b8b99b382eceac8a3f055b00f3c2256)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
            check_type(argname="argument feather", value=feather, expected_type=type_hints["feather"])
            check_type(argname="argument feather_var", value=feather_var, expected_type=type_hints["feather_var"])
            check_type(argname="argument tolerance", value=tolerance, expected_type=type_hints["tolerance"])
            check_type(argname="argument tolerance_var", value=tolerance_var, expected_type=type_hints["tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var
        if feather is not None:
            self._values["feather"] = feather
        if feather_var is not None:
            self._values["feather_var"] = feather_var
        if tolerance is not None:
            self._values["tolerance"] = tolerance
        if tolerance_var is not None:
            self._values["tolerance_var"] = tolerance_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        '''
        result = self._values.get("feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather_var(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        '''
        result = self._values.get("feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        '''
        result = self._values.get("tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance_var(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        result = self._values.get("tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanRemoveColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanRemoveColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanRemoveColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f67be7bfd2043bc1cc8bbe82efb02a63d50245519865f2152b77de21f5a8243d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanRemoveColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__67549f6e009e059419e37696173fc1135f6b26210ef8d67405db0ae3cf180108)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanRemoveColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__801aa160eb1dada9cea8bcf46c633b016804fed360f3949389bdef017a7c120d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b811ab8d25e9d8761a442807916eddec71856047ef19c39ddad025decd53bb67)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e2746277d30f659ccd678f94a18daa63a3bac96bd685f675db98ece20c97d7f5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanRemoveColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanRemoveColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanRemoveColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__690b6fc91ca20d30abbcc8fe525786bfc7528c8ae8a926aad882288de4af9ac4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanRemoveColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanRemoveColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e534dcfcd16f8d08546f1f3c4c962e7527e88dd7b243128b55270abfe0393c39)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @jsii.member(jsii_name="resetFeather")
    def reset_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeather", []))

    @jsii.member(jsii_name="resetFeatherVar")
    def reset_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatherVar", []))

    @jsii.member(jsii_name="resetTolerance")
    def reset_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTolerance", []))

    @jsii.member(jsii_name="resetToleranceVar")
    def reset_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featherInput")
    def feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherInput"))

    @builtins.property
    @jsii.member(jsii_name="featherVarInput")
    def feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceInput")
    def tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceVarInput")
    def tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d5eec395c9aae2fb221f946e7d6473a7b2f6c8144fa2d6508e63c787c174c688)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fe19ded5a1ffbce67c68aa2524daf474cd0ef02b13d713c9e8a77f19bb64648a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="feather")
    def feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "feather"))

    @feather.setter
    def feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ca7e58557a81ea7de0731307351d47169c2f2341838b21cef0302c09bd9e8127)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "feather", value)

    @builtins.property
    @jsii.member(jsii_name="featherVar")
    def feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featherVar"))

    @feather_var.setter
    def feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__03a0a80c7ecfec7423b9e01a19b4af19f027c5da40dbfbc7653957f3859c7d65)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featherVar", value)

    @builtins.property
    @jsii.member(jsii_name="tolerance")
    def tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tolerance"))

    @tolerance.setter
    def tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__85608b27e1566d176476ed3ec14338c06f8b3e72226d25f4368bb9936444903a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tolerance", value)

    @builtins.property
    @jsii.member(jsii_name="toleranceVar")
    def tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "toleranceVar"))

    @tolerance_var.setter
    def tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fbb33a863e50b00000f77bd28c3f51c08fbb5049bfe904e9ad4e6afd2780359d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "toleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanRemoveColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanRemoveColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanRemoveColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2eb98fe490cd9fc05292fa606e0cc4b46d08f25066eeac58de31bfafd5f11400)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanUnsharpMask",
    jsii_struct_bases=[],
    name_mapping={
        "gain": "gain",
        "gain_var": "gainVar",
        "sigma": "sigma",
        "sigma_var": "sigmaVar",
        "threshold": "threshold",
        "threshold_var": "thresholdVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanUnsharpMask:
    def __init__(
        self,
        *,
        gain: typing.Optional[builtins.str] = None,
        gain_var: typing.Optional[builtins.str] = None,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
        threshold: typing.Optional[builtins.str] = None,
        threshold_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param gain: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        :param gain_var: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        :param sigma: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        :param threshold: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        :param threshold_var: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ed949424004820b5b8ff4af62bbea2e40548c53438d21a82444105afeeb0bda)
            check_type(argname="argument gain", value=gain, expected_type=type_hints["gain"])
            check_type(argname="argument gain_var", value=gain_var, expected_type=type_hints["gain_var"])
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
            check_type(argname="argument threshold", value=threshold, expected_type=type_hints["threshold"])
            check_type(argname="argument threshold_var", value=threshold_var, expected_type=type_hints["threshold_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if gain is not None:
            self._values["gain"] = gain
        if gain_var is not None:
            self._values["gain_var"] = gain_var
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var
        if threshold is not None:
            self._values["threshold"] = threshold
        if threshold_var is not None:
            self._values["threshold_var"] = threshold_var

    @builtins.property
    def gain(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        '''
        result = self._values.get("gain")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gain_var(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        '''
        result = self._values.get("gain_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        '''
        result = self._values.get("threshold")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold_var(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        result = self._values.get("threshold_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanUnsharpMask(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanUnsharpMaskList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanUnsharpMaskList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__64676bf7e763e9bced2b4b663d19cd8800dfd5de9f5f58490827084de3c2085e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanUnsharpMaskOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1d519807e262a2743dcf526439e2a860a1e20111b79e1bc38859ba3d74dd24e1)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanUnsharpMaskOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__19d0c3a484cbdbe4b8e47431734bf19bdbd3831f173a3c78e4ec7d0ad1e02fc8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b3ebea64d9d6aad342b9adec1bba360c7767a5c8c8903268e1374ade3b89044e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d75f157ed3f7807a249daf2dd50eb67910c7f9f92d2d10f77e0c2496666d65b4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanUnsharpMask]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanUnsharpMask]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanUnsharpMask]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ddef13fe2fee245722c1d25583b761b5cee2af9f8d036f1fa6dfd90410e02be0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanUnsharpMaskOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanUnsharpMaskOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8c10404cb2f8bffd77281429746b0525c7eef1604e16dee67997211cb290af9a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetGain")
    def reset_gain(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGain", []))

    @jsii.member(jsii_name="resetGainVar")
    def reset_gain_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGainVar", []))

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @jsii.member(jsii_name="resetThreshold")
    def reset_threshold(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThreshold", []))

    @jsii.member(jsii_name="resetThresholdVar")
    def reset_threshold_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThresholdVar", []))

    @builtins.property
    @jsii.member(jsii_name="gainInput")
    def gain_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainInput"))

    @builtins.property
    @jsii.member(jsii_name="gainVarInput")
    def gain_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdInput")
    def threshold_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdVarInput")
    def threshold_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gain")
    def gain(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gain"))

    @gain.setter
    def gain(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__34e8427facf21c9eb13b32be9c4cca4837d5e8551dc041386e89c8ec9bad495e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gain", value)

    @builtins.property
    @jsii.member(jsii_name="gainVar")
    def gain_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gainVar"))

    @gain_var.setter
    def gain_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__754e24107e27c30130ba4be6a31d8597bd4ac8f80717c7a44af17a6ebda6cc16)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gainVar", value)

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b09017d116f9132250a0de982a02b471bd0851bec2f66ad2f1f9437709426660)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__350a5941339166da28dc7b46551aaf6074dc97b2024beb9d6c3ba564f83f24b5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="threshold")
    def threshold(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "threshold"))

    @threshold.setter
    def threshold(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__437c9d098004cce44bacd0f938777851affe1f598e94128ea74720c381285bc7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "threshold", value)

    @builtins.property
    @jsii.member(jsii_name="thresholdVar")
    def threshold_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "thresholdVar"))

    @threshold_var.setter
    def threshold_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e8f0f52167faa5146fad1dd8aeaae5e3025c6ff7a18d13d3c916b07db9bd539d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "thresholdVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanUnsharpMask]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanUnsharpMask]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanUnsharpMask]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a12791b64b57e8f68a0ac05225e8965b1706a5f4c5b0afcf307952b8a109dee5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__77e688740101e8b497a65b97b890043a1a0906cdf59af1f34b2a22ab2d5ebbec)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__70897b7815ae46fd20f51b72d1d5dc328d51ccb837ef4b1ee453d9eaff63dfaf)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c920fcdb27924ce29fe7979fcce7c9130a072c636b64a204f36b4eab8a40f724)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__82fb1f20c8ce70c42aabefbf486032a166c827acbfa976a8dd3620a723e162c7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__792099dfec0c138bcbb13e30d0281c2d42f47bfec5a7204171f5db3c55369de8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimension]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimension]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2daf95c8ff3686cf0fc0db5d30addd04d3310ff9e96d9941372ba55729d9f3f2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__da85c7322c164b446f70fd271a9e254e741a48aa8a8ba7bc132c7070e6e5f8a3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(
        self,
        *,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefault(
            background_color=background_color,
            blur=blur,
            chroma_key=chroma_key,
            composite=composite,
            compound=compound,
            contrast=contrast,
            goop=goop,
            grayscale=grayscale,
            hsl=hsl,
            hsv=hsv,
            if_dimension=if_dimension,
            if_orientation=if_orientation,
            max_colors=max_colors,
            mirror=mirror,
            mono_hue=mono_hue,
            opacity=opacity,
            remove_color=remove_color,
            unsharp_mask=unsharp_mask,
        )

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putEqual")
    def put_equal(
        self,
        *,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqual(
            background_color=background_color,
            blur=blur,
            chroma_key=chroma_key,
            composite=composite,
            compound=compound,
            contrast=contrast,
            goop=goop,
            grayscale=grayscale,
            hsl=hsl,
            hsv=hsv,
            if_dimension=if_dimension,
            if_orientation=if_orientation,
            max_colors=max_colors,
            mirror=mirror,
            mono_hue=mono_hue,
            opacity=opacity,
            remove_color=remove_color,
            unsharp_mask=unsharp_mask,
        )

        return typing.cast(None, jsii.invoke(self, "putEqual", [value]))

    @jsii.member(jsii_name="putGreaterThan")
    def put_greater_than(
        self,
        *,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThan(
            background_color=background_color,
            blur=blur,
            chroma_key=chroma_key,
            composite=composite,
            compound=compound,
            contrast=contrast,
            goop=goop,
            grayscale=grayscale,
            hsl=hsl,
            hsv=hsv,
            if_dimension=if_dimension,
            if_orientation=if_orientation,
            max_colors=max_colors,
            mirror=mirror,
            mono_hue=mono_hue,
            opacity=opacity,
            remove_color=remove_color,
            unsharp_mask=unsharp_mask,
        )

        return typing.cast(None, jsii.invoke(self, "putGreaterThan", [value]))

    @jsii.member(jsii_name="putLessThan")
    def put_less_than(
        self,
        *,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThan(
            background_color=background_color,
            blur=blur,
            chroma_key=chroma_key,
            composite=composite,
            compound=compound,
            contrast=contrast,
            goop=goop,
            grayscale=grayscale,
            hsl=hsl,
            hsv=hsv,
            if_dimension=if_dimension,
            if_orientation=if_orientation,
            max_colors=max_colors,
            mirror=mirror,
            mono_hue=mono_hue,
            opacity=opacity,
            remove_color=remove_color,
            unsharp_mask=unsharp_mask,
        )

        return typing.cast(None, jsii.invoke(self, "putLessThan", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetDimension")
    def reset_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimension", []))

    @jsii.member(jsii_name="resetDimensionVar")
    def reset_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimensionVar", []))

    @jsii.member(jsii_name="resetEqual")
    def reset_equal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEqual", []))

    @jsii.member(jsii_name="resetGreaterThan")
    def reset_greater_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGreaterThan", []))

    @jsii.member(jsii_name="resetLessThan")
    def reset_less_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLessThan", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="equal")
    def equal(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualOutputReference, jsii.get(self, "equal"))

    @builtins.property
    @jsii.member(jsii_name="greaterThan")
    def greater_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanOutputReference, jsii.get(self, "greaterThan"))

    @builtins.property
    @jsii.member(jsii_name="lessThan")
    def less_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanOutputReference, jsii.get(self, "lessThan"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionInput")
    def dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionVarInput")
    def dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="equalInput")
    def equal_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqual], jsii.get(self, "equalInput"))

    @builtins.property
    @jsii.member(jsii_name="greaterThanInput")
    def greater_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThan], jsii.get(self, "greaterThanInput"))

    @builtins.property
    @jsii.member(jsii_name="lessThanInput")
    def less_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThan], jsii.get(self, "lessThanInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="dimension")
    def dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimension"))

    @dimension.setter
    def dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__256e6f4ef18ae281afa8271586385f801ab41723ef05a45e82f54a2590ed1b2f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimension", value)

    @builtins.property
    @jsii.member(jsii_name="dimensionVar")
    def dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimensionVar"))

    @dimension_var.setter
    def dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__977e122794246b545340c2513be8c6ad2e195ae483c7d371a24c16bd8d40f5ac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__00979a96753594873d7d3552666643901e97cac79ff4b1cf08cf6c18e1d4181a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e78e9204c9c0cad04ef57715b5a9e4a0cda8175a48966b7ba4a8ca0ba4a8998f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimension]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimension]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimension]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__61d34507ed71dc6c4c7086933b96ca443f9058dc853eba870a026c197e959521)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientation",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "landscape": "landscape",
        "portrait": "portrait",
        "square": "square",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientation:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        landscape: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscape", typing.Dict[builtins.str, typing.Any]]] = None,
        portrait: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortrait", typing.Dict[builtins.str, typing.Any]]] = None,
        square: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquare", typing.Dict[builtins.str, typing.Any]]] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param landscape: landscape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        :param portrait: portrait block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        :param square: square block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefault(**default)
        if isinstance(landscape, dict):
            landscape = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscape(**landscape)
        if isinstance(portrait, dict):
            portrait = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortrait(**portrait)
        if isinstance(square, dict):
            square = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquare(**square)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c55d4243473d7b6e14936270f1bd0ef14d5afb8d3950d1051a02deb6bd02b2bc)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument landscape", value=landscape, expected_type=type_hints["landscape"])
            check_type(argname="argument portrait", value=portrait, expected_type=type_hints["portrait"])
            check_type(argname="argument square", value=square, expected_type=type_hints["square"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if landscape is not None:
            self._values["landscape"] = landscape
        if portrait is not None:
            self._values["portrait"] = portrait
        if square is not None:
            self._values["square"] = square

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefault"], result)

    @builtins.property
    def landscape(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscape"]:
        '''landscape block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        '''
        result = self._values.get("landscape")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscape"], result)

    @builtins.property
    def portrait(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortrait"]:
        '''portrait block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        '''
        result = self._values.get("portrait")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortrait"], result)

    @builtins.property
    def square(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquare"]:
        '''square block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        result = self._values.get("square")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquare"], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefault",
    jsii_struct_bases=[],
    name_mapping={
        "background_color": "backgroundColor",
        "blur": "blur",
        "chroma_key": "chromaKey",
        "composite": "composite",
        "compound": "compound",
        "contrast": "contrast",
        "goop": "goop",
        "grayscale": "grayscale",
        "hsl": "hsl",
        "hsv": "hsv",
        "if_dimension": "ifDimension",
        "if_orientation": "ifOrientation",
        "max_colors": "maxColors",
        "mirror": "mirror",
        "mono_hue": "monoHue",
        "opacity": "opacity",
        "remove_color": "removeColor",
        "unsharp_mask": "unsharpMask",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefault:
    def __init__(
        self,
        *,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultBackgroundColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultBlur", typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultChromaKey", typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultComposite", typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompound", typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultContrast", typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultGoop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultGrayscale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultHsl", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultHsv", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimension", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultMaxColors", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultMirror", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultMonoHue", typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultOpacity", typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultRemoveColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultUnsharpMask", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6d4371616902b5878646e0034d02d45f0c1f0fafc4b85cac0479a05149bbdb03)
            check_type(argname="argument background_color", value=background_color, expected_type=type_hints["background_color"])
            check_type(argname="argument blur", value=blur, expected_type=type_hints["blur"])
            check_type(argname="argument chroma_key", value=chroma_key, expected_type=type_hints["chroma_key"])
            check_type(argname="argument composite", value=composite, expected_type=type_hints["composite"])
            check_type(argname="argument compound", value=compound, expected_type=type_hints["compound"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument goop", value=goop, expected_type=type_hints["goop"])
            check_type(argname="argument grayscale", value=grayscale, expected_type=type_hints["grayscale"])
            check_type(argname="argument hsl", value=hsl, expected_type=type_hints["hsl"])
            check_type(argname="argument hsv", value=hsv, expected_type=type_hints["hsv"])
            check_type(argname="argument if_dimension", value=if_dimension, expected_type=type_hints["if_dimension"])
            check_type(argname="argument if_orientation", value=if_orientation, expected_type=type_hints["if_orientation"])
            check_type(argname="argument max_colors", value=max_colors, expected_type=type_hints["max_colors"])
            check_type(argname="argument mirror", value=mirror, expected_type=type_hints["mirror"])
            check_type(argname="argument mono_hue", value=mono_hue, expected_type=type_hints["mono_hue"])
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument remove_color", value=remove_color, expected_type=type_hints["remove_color"])
            check_type(argname="argument unsharp_mask", value=unsharp_mask, expected_type=type_hints["unsharp_mask"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if background_color is not None:
            self._values["background_color"] = background_color
        if blur is not None:
            self._values["blur"] = blur
        if chroma_key is not None:
            self._values["chroma_key"] = chroma_key
        if composite is not None:
            self._values["composite"] = composite
        if compound is not None:
            self._values["compound"] = compound
        if contrast is not None:
            self._values["contrast"] = contrast
        if goop is not None:
            self._values["goop"] = goop
        if grayscale is not None:
            self._values["grayscale"] = grayscale
        if hsl is not None:
            self._values["hsl"] = hsl
        if hsv is not None:
            self._values["hsv"] = hsv
        if if_dimension is not None:
            self._values["if_dimension"] = if_dimension
        if if_orientation is not None:
            self._values["if_orientation"] = if_orientation
        if max_colors is not None:
            self._values["max_colors"] = max_colors
        if mirror is not None:
            self._values["mirror"] = mirror
        if mono_hue is not None:
            self._values["mono_hue"] = mono_hue
        if opacity is not None:
            self._values["opacity"] = opacity
        if remove_color is not None:
            self._values["remove_color"] = remove_color
        if unsharp_mask is not None:
            self._values["unsharp_mask"] = unsharp_mask

    @builtins.property
    def background_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultBackgroundColor"]]]:
        '''background_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        '''
        result = self._values.get("background_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultBackgroundColor"]]], result)

    @builtins.property
    def blur(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultBlur"]]]:
        '''blur block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        '''
        result = self._values.get("blur")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultBlur"]]], result)

    @builtins.property
    def chroma_key(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultChromaKey"]]]:
        '''chroma_key block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        '''
        result = self._values.get("chroma_key")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultChromaKey"]]], result)

    @builtins.property
    def composite(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultComposite"]]]:
        '''composite block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        '''
        result = self._values.get("composite")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultComposite"]]], result)

    @builtins.property
    def compound(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompound"]]]:
        '''compound block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        '''
        result = self._values.get("compound")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompound"]]], result)

    @builtins.property
    def contrast(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultContrast"]]]:
        '''contrast block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultContrast"]]], result)

    @builtins.property
    def goop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultGoop"]]]:
        '''goop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        '''
        result = self._values.get("goop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultGoop"]]], result)

    @builtins.property
    def grayscale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultGrayscale"]]]:
        '''grayscale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        '''
        result = self._values.get("grayscale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultGrayscale"]]], result)

    @builtins.property
    def hsl(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultHsl"]]]:
        '''hsl block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        '''
        result = self._values.get("hsl")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultHsl"]]], result)

    @builtins.property
    def hsv(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultHsv"]]]:
        '''hsv block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        '''
        result = self._values.get("hsv")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultHsv"]]], result)

    @builtins.property
    def if_dimension(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimension"]]]:
        '''if_dimension block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        '''
        result = self._values.get("if_dimension")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimension"]]], result)

    @builtins.property
    def if_orientation(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientation]]]:
        '''if_orientation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        '''
        result = self._values.get("if_orientation")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientation]]], result)

    @builtins.property
    def max_colors(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultMaxColors"]]]:
        '''max_colors block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        '''
        result = self._values.get("max_colors")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultMaxColors"]]], result)

    @builtins.property
    def mirror(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultMirror"]]]:
        '''mirror block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        '''
        result = self._values.get("mirror")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultMirror"]]], result)

    @builtins.property
    def mono_hue(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultMonoHue"]]]:
        '''mono_hue block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        '''
        result = self._values.get("mono_hue")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultMonoHue"]]], result)

    @builtins.property
    def opacity(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultOpacity"]]]:
        '''opacity block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultOpacity"]]], result)

    @builtins.property
    def remove_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultRemoveColor"]]]:
        '''remove_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        '''
        result = self._values.get("remove_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultRemoveColor"]]], result)

    @builtins.property
    def unsharp_mask(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultUnsharpMask"]]]:
        '''unsharp_mask block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        result = self._values.get("unsharp_mask")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultUnsharpMask"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultBackgroundColor",
    jsii_struct_bases=[],
    name_mapping={"color": "color", "color_var": "colorVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultBackgroundColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cc40abaee755003e6b46372c626ebe4958f7da070acb6e91e495174620b962e6)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultBackgroundColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultBackgroundColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultBackgroundColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e6c51309ae3ca7ef7e0af9540c8105d6afb0a8e09fabac194d6fd7f34c304030)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultBackgroundColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bbc1f72b33a0ed47ba9baa9a8757f5c3450afe16effec8e18fd19ecc7523884e)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultBackgroundColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__69e27cd9f01e26ffec38294c82e232fb11193ac0ed3e0714486757b3d10d40a8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__29b9d7dae9abef2142c084e7ad95df0effe33e1e4ef1b8f6e90f673a5ca584b5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__345d02884cf0203dfc8815afffdd39b10d7c687f8db54f176a98fdded2897209)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultBackgroundColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultBackgroundColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1b3ae51233f01d7be10d5bd13b01699a10b591467edc07632ad1a45844491a9a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultBackgroundColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultBackgroundColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8c392b7772259535f53b47d5f5e31cb113a37214be46fcbb1d3f490c84dd4f59)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b654fe5e71b4929b13471c12b4c05771d16f80ece32f28e778dd280333a8ad07)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d1ab853c7538dcedd00cfef0e14930bdf7a812b6ac90e5de1880622fda85874c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultBackgroundColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultBackgroundColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultBackgroundColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a92ddeb0f79beb683980bdd8b1ee5fbfc2333fdaa2c8eb0f1fbcbddf73b8c84)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultBlur",
    jsii_struct_bases=[],
    name_mapping={"sigma": "sigma", "sigma_var": "sigmaVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultBlur:
    def __init__(
        self,
        *,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param sigma: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d9ca2b12b90b8bac33be94e993e1c540c3756f14f998548b2a9a4fd056e8783e)
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultBlur(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultBlurList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultBlurList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__57623b8c7325f68b25c7f4c7c08deaa9053076b4e66d42dc47e7b7a521d2b7b5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultBlurOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a742d7cdcfd18799f8e87f7695fe70ebcfcf2eb18ac9b8de4fe66980a880f5af)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultBlurOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__53489502ad6ba07cb9adfc59ec3941976d3ee56d1c14988e86c36aaccf0fb64f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d52ab900a0c592530146c0dd5d7b0b8cc0ac8758585ca1ad32a10accd8c209b8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4c53de0d7b520f0d8f8a582e66b6063eb4724358062dcd48f315e4a39a585c87)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultBlur]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultBlur]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__73fdd4c55c8288af7e14949216123a890e209a265c3edae7344514f1821ffaa3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultBlurOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultBlurOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__329d09676dc13fd3fbc0ab843f76c366be59e457363cbf8dd013b684ddac8eee)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__39568a4cf96acf8a112aa9669d6830fb5a89c27a0da9224be0628e0091e6433c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a072854469e408e06663c4041740450b250dd65abe73ea73af7fadc10faa5542)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultBlur]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultBlur]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultBlur]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e3190ae543360fcb8630e0041f38a4207caf51b092bc7f9260304c78dbc971f7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultChromaKey",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_feather": "hueFeather",
        "hue_feather_var": "hueFeatherVar",
        "hue_tolerance": "hueTolerance",
        "hue_tolerance_var": "hueToleranceVar",
        "hue_var": "hueVar",
        "lightness_feather": "lightnessFeather",
        "lightness_feather_var": "lightnessFeatherVar",
        "lightness_tolerance": "lightnessTolerance",
        "lightness_tolerance_var": "lightnessToleranceVar",
        "saturation_feather": "saturationFeather",
        "saturation_feather_var": "saturationFeatherVar",
        "saturation_tolerance": "saturationTolerance",
        "saturation_tolerance_var": "saturationToleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultChromaKey:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_feather: typing.Optional[builtins.str] = None,
        hue_feather_var: typing.Optional[builtins.str] = None,
        hue_tolerance: typing.Optional[builtins.str] = None,
        hue_tolerance_var: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness_feather: typing.Optional[builtins.str] = None,
        lightness_feather_var: typing.Optional[builtins.str] = None,
        lightness_tolerance: typing.Optional[builtins.str] = None,
        lightness_tolerance_var: typing.Optional[builtins.str] = None,
        saturation_feather: typing.Optional[builtins.str] = None,
        saturation_feather_var: typing.Optional[builtins.str] = None,
        saturation_tolerance: typing.Optional[builtins.str] = None,
        saturation_tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_feather: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        :param hue_feather_var: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        :param hue_tolerance: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        :param hue_tolerance_var: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        :param hue_var: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness_feather: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        :param lightness_feather_var: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        :param lightness_tolerance: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        :param lightness_tolerance_var: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        :param saturation_feather: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        :param saturation_feather_var: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        :param saturation_tolerance: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        :param saturation_tolerance_var: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a4ad1aa04c68b82620d7264a59c1f87f75ecfe46e78ebb6a2027713191bbf31c)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_feather", value=hue_feather, expected_type=type_hints["hue_feather"])
            check_type(argname="argument hue_feather_var", value=hue_feather_var, expected_type=type_hints["hue_feather_var"])
            check_type(argname="argument hue_tolerance", value=hue_tolerance, expected_type=type_hints["hue_tolerance"])
            check_type(argname="argument hue_tolerance_var", value=hue_tolerance_var, expected_type=type_hints["hue_tolerance_var"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness_feather", value=lightness_feather, expected_type=type_hints["lightness_feather"])
            check_type(argname="argument lightness_feather_var", value=lightness_feather_var, expected_type=type_hints["lightness_feather_var"])
            check_type(argname="argument lightness_tolerance", value=lightness_tolerance, expected_type=type_hints["lightness_tolerance"])
            check_type(argname="argument lightness_tolerance_var", value=lightness_tolerance_var, expected_type=type_hints["lightness_tolerance_var"])
            check_type(argname="argument saturation_feather", value=saturation_feather, expected_type=type_hints["saturation_feather"])
            check_type(argname="argument saturation_feather_var", value=saturation_feather_var, expected_type=type_hints["saturation_feather_var"])
            check_type(argname="argument saturation_tolerance", value=saturation_tolerance, expected_type=type_hints["saturation_tolerance"])
            check_type(argname="argument saturation_tolerance_var", value=saturation_tolerance_var, expected_type=type_hints["saturation_tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_feather is not None:
            self._values["hue_feather"] = hue_feather
        if hue_feather_var is not None:
            self._values["hue_feather_var"] = hue_feather_var
        if hue_tolerance is not None:
            self._values["hue_tolerance"] = hue_tolerance
        if hue_tolerance_var is not None:
            self._values["hue_tolerance_var"] = hue_tolerance_var
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness_feather is not None:
            self._values["lightness_feather"] = lightness_feather
        if lightness_feather_var is not None:
            self._values["lightness_feather_var"] = lightness_feather_var
        if lightness_tolerance is not None:
            self._values["lightness_tolerance"] = lightness_tolerance
        if lightness_tolerance_var is not None:
            self._values["lightness_tolerance_var"] = lightness_tolerance_var
        if saturation_feather is not None:
            self._values["saturation_feather"] = saturation_feather
        if saturation_feather_var is not None:
            self._values["saturation_feather_var"] = saturation_feather_var
        if saturation_tolerance is not None:
            self._values["saturation_tolerance"] = saturation_tolerance
        if saturation_tolerance_var is not None:
            self._values["saturation_tolerance_var"] = saturation_tolerance_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        '''
        result = self._values.get("hue_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        '''
        result = self._values.get("hue_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        '''
        result = self._values.get("hue_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        '''
        result = self._values.get("hue_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        '''
        result = self._values.get("lightness_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        '''
        result = self._values.get("lightness_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        '''
        result = self._values.get("lightness_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        '''
        result = self._values.get("lightness_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        '''
        result = self._values.get("saturation_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        '''
        result = self._values.get("saturation_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        '''
        result = self._values.get("saturation_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        result = self._values.get("saturation_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultChromaKey(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultChromaKeyList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultChromaKeyList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__87189a4561d57c700d802e54864a56b3d23d575b9da72a8ecaaf974d8383dac4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultChromaKeyOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ca56da53f2bfec65c16c5d42443c66c4dbe0d542d26ffc2b3c304fe4e213983f)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultChromaKeyOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__265d4e36207394fcb332fb34ee68fff7557595c3208afdd6aa023ab29bcb3b7a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a0d6046e6e216ad98a71c5f2575298aa579c04ec8dd939cc4b1eb7cff957a04a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a4d10155733ecb75abbe253b37ccc64fb281f7f8ba2ea2a10c714ecf6d2784d4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultChromaKey]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultChromaKey]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be4a7e4a6a0e1260c2ace7fb1c65b6f98bf7df2683c6ef1f3da1581f693e22cf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultChromaKeyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultChromaKeyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__33240ecbcebb3ecf7989ef2969c25017238a9532bd7a3599383b7d54233f52aa)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueFeather")
    def reset_hue_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeather", []))

    @jsii.member(jsii_name="resetHueFeatherVar")
    def reset_hue_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeatherVar", []))

    @jsii.member(jsii_name="resetHueTolerance")
    def reset_hue_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueTolerance", []))

    @jsii.member(jsii_name="resetHueToleranceVar")
    def reset_hue_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueToleranceVar", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightnessFeather")
    def reset_lightness_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeather", []))

    @jsii.member(jsii_name="resetLightnessFeatherVar")
    def reset_lightness_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeatherVar", []))

    @jsii.member(jsii_name="resetLightnessTolerance")
    def reset_lightness_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessTolerance", []))

    @jsii.member(jsii_name="resetLightnessToleranceVar")
    def reset_lightness_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessToleranceVar", []))

    @jsii.member(jsii_name="resetSaturationFeather")
    def reset_saturation_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeather", []))

    @jsii.member(jsii_name="resetSaturationFeatherVar")
    def reset_saturation_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeatherVar", []))

    @jsii.member(jsii_name="resetSaturationTolerance")
    def reset_saturation_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationTolerance", []))

    @jsii.member(jsii_name="resetSaturationToleranceVar")
    def reset_saturation_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherInput")
    def hue_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVarInput")
    def hue_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceInput")
    def hue_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVarInput")
    def hue_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherInput")
    def lightness_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVarInput")
    def lightness_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceInput")
    def lightness_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVarInput")
    def lightness_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherInput")
    def saturation_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVarInput")
    def saturation_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceInput")
    def saturation_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVarInput")
    def saturation_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7b63462a574af8823be3502d48e0abb60a4f2f9dc035f9085d8096816c1fda77)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeather")
    def hue_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeather"))

    @hue_feather.setter
    def hue_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9752acc8c74ae631127d2b202ce0962fd96715a4d8d8653d374072fdec42be86)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeather", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVar")
    def hue_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeatherVar"))

    @hue_feather_var.setter
    def hue_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6ee257940e90b3d7b9f57007c2957f4070e3ee98980e181999c3f5989939d61c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueTolerance")
    def hue_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueTolerance"))

    @hue_tolerance.setter
    def hue_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4dfd5f4825eec36d24516ca9fced60e5ce14128088705ef0d0feff64f41fc861)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVar")
    def hue_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueToleranceVar"))

    @hue_tolerance_var.setter
    def hue_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6afa3408d899ecd43abc0ec4877707e7b2a4bbee84b98a3c904ec131499bc12a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__900b3589d4d22d197e357322af5d4dd2dab68895dacbaa3f75e8088375546af1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeather")
    def lightness_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeather"))

    @lightness_feather.setter
    def lightness_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__87662f52441c795724eb418a658137ba5c5d96227ec3566a2870e0393eb26a8d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeather", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVar")
    def lightness_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeatherVar"))

    @lightness_feather_var.setter
    def lightness_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f49f448bfb15017421d389caea4cfabef11e0fe9eabd1aa123b2a8d620292e88)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessTolerance")
    def lightness_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessTolerance"))

    @lightness_tolerance.setter
    def lightness_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__19a4ee5e6bcdc6789163b77387257ae13d1a7c4dd1db48c4007ffdace942dab3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVar")
    def lightness_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessToleranceVar"))

    @lightness_tolerance_var.setter
    def lightness_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__417812d784fbc9766defe5178630fcce3b8b099b08ba8c6dea851ac5573dc6a4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeather")
    def saturation_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeather"))

    @saturation_feather.setter
    def saturation_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fbc63188c889d55e3b449ff24122915bbdbe4be1ed0202c6f43ebba08554059f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeather", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVar")
    def saturation_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeatherVar"))

    @saturation_feather_var.setter
    def saturation_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a44e7f25d11b8b01129933d12c861cf2d7b312475c14298ffa0afd5a2156e6d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationTolerance")
    def saturation_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationTolerance"))

    @saturation_tolerance.setter
    def saturation_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__919ded2eef2d0799eed878616899fa8a68105eea45b79265c4e90e0c1dedf704)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVar")
    def saturation_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationToleranceVar"))

    @saturation_tolerance_var.setter
    def saturation_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e31b2cc180ba14fa9523038f4c3b5e285c20bacca35e9125deca64e054a64bd0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultChromaKey]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultChromaKey]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultChromaKey]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2f313e010790cfefabf31a331ff33178adc461499e4bb851d09600d87190ad00)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultComposite",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "placement": "placement",
        "placement_var": "placementVar",
        "scale": "scale",
        "scale_dimension": "scaleDimension",
        "scale_dimension_var": "scaleDimensionVar",
        "scale_var": "scaleVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultComposite:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        placement: typing.Optional[builtins.str] = None,
        placement_var: typing.Optional[builtins.str] = None,
        scale: typing.Optional[builtins.str] = None,
        scale_dimension: typing.Optional[builtins.str] = None,
        scale_dimension_var: typing.Optional[builtins.str] = None,
        scale_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param placement: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        :param placement_var: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        :param scale: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param scale_dimension: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        :param scale_dimension_var: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        :param scale_var: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        :param x_position: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4262f574ed02609d3db1674b06cbe734bcd2afe6ef20301cf65554057e7bfd83)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument placement", value=placement, expected_type=type_hints["placement"])
            check_type(argname="argument placement_var", value=placement_var, expected_type=type_hints["placement_var"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument scale_dimension", value=scale_dimension, expected_type=type_hints["scale_dimension"])
            check_type(argname="argument scale_dimension_var", value=scale_dimension_var, expected_type=type_hints["scale_dimension_var"])
            check_type(argname="argument scale_var", value=scale_var, expected_type=type_hints["scale_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if placement is not None:
            self._values["placement"] = placement
        if placement_var is not None:
            self._values["placement_var"] = placement_var
        if scale is not None:
            self._values["scale"] = scale
        if scale_dimension is not None:
            self._values["scale_dimension"] = scale_dimension
        if scale_dimension_var is not None:
            self._values["scale_dimension_var"] = scale_dimension_var
        if scale_var is not None:
            self._values["scale_var"] = scale_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        '''
        result = self._values.get("placement")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement_var(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        '''
        result = self._values.get("placement_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        '''
        result = self._values.get("scale_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        '''
        result = self._values.get("scale_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        '''
        result = self._values.get("scale_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultComposite(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImage",
    jsii_struct_bases=[],
    name_mapping={
        "box_image": "boxImage",
        "circle_image": "circleImage",
        "text_image": "textImage",
        "url_image": "urlImage",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImage:
    def __init__(
        self,
        *,
        box_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageBoxImage", typing.Dict[builtins.str, typing.Any]]]]] = None,
        circle_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageCircleImage", typing.Dict[builtins.str, typing.Any]]]]] = None,
        text_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageTextImage", typing.Dict[builtins.str, typing.Any]]]]] = None,
        url_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageUrlImage", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param box_image: box_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#box_image DataAkamaiImagingPolicyImage#box_image}
        :param circle_image: circle_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#circle_image DataAkamaiImagingPolicyImage#circle_image}
        :param text_image: text_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text_image DataAkamaiImagingPolicyImage#text_image}
        :param url_image: url_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url_image DataAkamaiImagingPolicyImage#url_image}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9c415cfbf4cc45013500ce77fca698c724ac2e8699bba424379afb79f7bbabc9)
            check_type(argname="argument box_image", value=box_image, expected_type=type_hints["box_image"])
            check_type(argname="argument circle_image", value=circle_image, expected_type=type_hints["circle_image"])
            check_type(argname="argument text_image", value=text_image, expected_type=type_hints["text_image"])
            check_type(argname="argument url_image", value=url_image, expected_type=type_hints["url_image"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if box_image is not None:
            self._values["box_image"] = box_image
        if circle_image is not None:
            self._values["circle_image"] = circle_image
        if text_image is not None:
            self._values["text_image"] = text_image
        if url_image is not None:
            self._values["url_image"] = url_image

    @builtins.property
    def box_image(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageBoxImage"]]]:
        '''box_image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#box_image DataAkamaiImagingPolicyImage#box_image}
        '''
        result = self._values.get("box_image")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageBoxImage"]]], result)

    @builtins.property
    def circle_image(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageCircleImage"]]]:
        '''circle_image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#circle_image DataAkamaiImagingPolicyImage#circle_image}
        '''
        result = self._values.get("circle_image")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageCircleImage"]]], result)

    @builtins.property
    def text_image(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageTextImage"]]]:
        '''text_image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text_image DataAkamaiImagingPolicyImage#text_image}
        '''
        result = self._values.get("text_image")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageTextImage"]]], result)

    @builtins.property
    def url_image(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageUrlImage"]]]:
        '''url_image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url_image DataAkamaiImagingPolicyImage#url_image}
        '''
        result = self._values.get("url_image")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageUrlImage"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageBoxImage",
    jsii_struct_bases=[],
    name_mapping={
        "color": "color",
        "color_var": "colorVar",
        "height": "height",
        "height_var": "heightVar",
        "transformation": "transformation",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageBoxImage:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        transformation: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageBoxImageTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The fill color of the box, not the edge of the box. The API supports hexadecimal representation and CSS hexadecimal color values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The fill color of the box, not the edge of the box. The API supports hexadecimal representation and CSS hexadecimal color values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        :param height: The height of the box in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height of the box in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param transformation: transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        :param width: The width of the box in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width of the box in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(transformation, dict):
            transformation = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageBoxImageTransformation(**transformation)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__906eb84757ca4e1997aac4b05d5f7194ae4e5b8621b17178786dd17dadc65534)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument transformation", value=transformation, expected_type=type_hints["transformation"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if transformation is not None:
            self._values["transformation"] = transformation
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The fill color of the box, not the edge of the box.

        The API supports hexadecimal representation and CSS hexadecimal color values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The fill color of the box, not the edge of the box.

        The API supports hexadecimal representation and CSS hexadecimal color values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height of the box in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height of the box in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def transformation(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageBoxImageTransformation"]:
        '''transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        '''
        result = self._values.get("transformation")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageBoxImageTransformation"], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width of the box in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width of the box in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageBoxImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageBoxImageList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageBoxImageList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0bcbfaa7e05cb39c26ff49d6513c31c0d3a6a17529b040898e688e03c43c9777)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageBoxImageOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__96860b23a6b04031e0a57d5a0f60b12ce8fc501c9cbbb3f5d8c5a0f83cb7c39d)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageBoxImageOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__52e49955e696fab1d027cf7bfe4e4e26add8fab732cc8ce057a633fdb8c5bbb6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1d78520e9d283ef812ef97021282c81a8978ce068484b1045f64e811122349b5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0318cc5df3ac94bb6f87df3ec6302c01cbe3d5445cfdbf07c8de2e9b2f3075b9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageBoxImage]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageBoxImage]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageBoxImage]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__074ca92c91e002beb665e83822acd7364c0321cdecaad29a4697e6a66ca8bdba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageBoxImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageBoxImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7a619925923741e2557b32082012939427233a6b11861f360dae305c298f999a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformation")
    def put_transformation(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageBoxImageTransformation()

        return typing.cast(None, jsii.invoke(self, "putTransformation", [value]))

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetTransformation")
    def reset_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformation", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="transformation")
    def transformation(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageBoxImageTransformationOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageBoxImageTransformationOutputReference", jsii.get(self, "transformation"))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="transformationInput")
    def transformation_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageBoxImageTransformation"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageBoxImageTransformation"], jsii.get(self, "transformationInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4fdaa0ba6e1cfa0016c7c9a10e4a2639f3ddf5bd5b21f29efdbbf16aaad3cb6c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4536a388269d06e15ccb19799e350d8230d89f07921b307cabfe6f5e31d1f6df)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__81ca5971f5cf0518c7b3e78ba29849cbd909711cc3bd248b54ef51b6a5db4ed0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a4f5e0378c42091bc6aaed7d970135581ab7cf42f5ab1a0ed9838532262c6de)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7fa116c4145cdbde254591156ee8f243c18cf9141cae424e1c7fb0d3a8ac0883)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a077d1ca7d01fc8ae638de7b664155090ceced33365f01f781ca5f6ce90879c4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageBoxImage]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageBoxImage]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageBoxImage]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3c413b710a9d06568f6afdd7d725bf0446ba1ab3dd32b8dd913ed04a765a8e9a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageBoxImageTransformation",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageBoxImageTransformation:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageBoxImageTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageBoxImageTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageBoxImageTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__48ffe9d5b6adfb7f511e0d1a0e363ee0838e1018696742348902ddee9df1af71)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageBoxImageTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageBoxImageTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageBoxImageTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac11fcdbdfa2d174f993387d8d32381c3ab0d8d15d0204c47513a47d9f0972d5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageCircleImage",
    jsii_struct_bases=[],
    name_mapping={
        "color": "color",
        "color_var": "colorVar",
        "diameter": "diameter",
        "diameter_var": "diameterVar",
        "transformation": "transformation",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageCircleImage:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
        diameter: typing.Optional[builtins.str] = None,
        diameter_var: typing.Optional[builtins.str] = None,
        transformation: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageCircleImageTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The fill color of the circle. The API supports hexadecimal representation and CSS hexadecimal color values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The fill color of the circle. The API supports hexadecimal representation and CSS hexadecimal color values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        :param diameter: The diameter of the circle. The diameter will be the width and the height of the image in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#diameter DataAkamaiImagingPolicyImage#diameter}
        :param diameter_var: The diameter of the circle. The diameter will be the width and the height of the image in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#diameter_var DataAkamaiImagingPolicyImage#diameter_var}
        :param transformation: transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        :param width: The width of the box in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width of the box in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(transformation, dict):
            transformation = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageCircleImageTransformation(**transformation)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e7c022b0c79003203344e239e44276ae2365416ed9e9fc19090b3e41374e29fd)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
            check_type(argname="argument diameter", value=diameter, expected_type=type_hints["diameter"])
            check_type(argname="argument diameter_var", value=diameter_var, expected_type=type_hints["diameter_var"])
            check_type(argname="argument transformation", value=transformation, expected_type=type_hints["transformation"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var
        if diameter is not None:
            self._values["diameter"] = diameter
        if diameter_var is not None:
            self._values["diameter_var"] = diameter_var
        if transformation is not None:
            self._values["transformation"] = transformation
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The fill color of the circle. The API supports hexadecimal representation and CSS hexadecimal color values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The fill color of the circle. The API supports hexadecimal representation and CSS hexadecimal color values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def diameter(self) -> typing.Optional[builtins.str]:
        '''The diameter of the circle. The diameter will be the width and the height of the image in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#diameter DataAkamaiImagingPolicyImage#diameter}
        '''
        result = self._values.get("diameter")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def diameter_var(self) -> typing.Optional[builtins.str]:
        '''The diameter of the circle. The diameter will be the width and the height of the image in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#diameter_var DataAkamaiImagingPolicyImage#diameter_var}
        '''
        result = self._values.get("diameter_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def transformation(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageCircleImageTransformation"]:
        '''transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        '''
        result = self._values.get("transformation")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageCircleImageTransformation"], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width of the box in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width of the box in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageCircleImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageCircleImageList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageCircleImageList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e4e825450a12f02a5852f22377e2095fb41a2f051d2d1253c7bab8d1ac98a586)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageCircleImageOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f350125b9fbbd86c303670d0c73f7b74e7d502239012610beadf5769184855d2)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageCircleImageOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6636b5c18b13709411d541a148239976c07ac72081df4a15f1b05f4376a55447)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__24d5d1f0f7eee26bc16dd381ac5041b21ab10633eb9f42fceb9b4ff35e2f7828)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4805413f045b73aac01c4bbdbe7d1ff7fac126408cb0613eaff5aedea4dfca56)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageCircleImage]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageCircleImage]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageCircleImage]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e7f79d1bfa93bb7a697ed338e97b297de412ea283a26d05b2f388c2a0dd96112)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageCircleImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageCircleImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__55a54e9e624bedd97411e67933f3bd70c81d09b41257c959a83aa5ac8b73a3b5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformation")
    def put_transformation(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageCircleImageTransformation()

        return typing.cast(None, jsii.invoke(self, "putTransformation", [value]))

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @jsii.member(jsii_name="resetDiameter")
    def reset_diameter(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDiameter", []))

    @jsii.member(jsii_name="resetDiameterVar")
    def reset_diameter_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDiameterVar", []))

    @jsii.member(jsii_name="resetTransformation")
    def reset_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformation", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="transformation")
    def transformation(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageCircleImageTransformationOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageCircleImageTransformationOutputReference", jsii.get(self, "transformation"))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="diameterInput")
    def diameter_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "diameterInput"))

    @builtins.property
    @jsii.member(jsii_name="diameterVarInput")
    def diameter_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "diameterVarInput"))

    @builtins.property
    @jsii.member(jsii_name="transformationInput")
    def transformation_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageCircleImageTransformation"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageCircleImageTransformation"], jsii.get(self, "transformationInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__980d621a095f800e9645179b5649c18d6b652f7ab2a22831c4f6978fc5bf6cb5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7ea561616802daef773071490dae5606c4c2ff97302494c2b94b6e034770c018)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="diameter")
    def diameter(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "diameter"))

    @diameter.setter
    def diameter(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__635354f0b1dfb1830bf8871714629bb85770395818540944fe73672f22fa32a4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "diameter", value)

    @builtins.property
    @jsii.member(jsii_name="diameterVar")
    def diameter_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "diameterVar"))

    @diameter_var.setter
    def diameter_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9e98b094e9d579d0feeb342a68abd6e20324b9eaaf0f5394f7f97100ab9aecf0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "diameterVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__93f8485fa4ae00137f6a713241e662c9ec2539b3da7266949a7baf4d3992e588)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a64db7235b76f024e4f9acdc9d19d64005d7d6297621c53f7356de8a111ec077)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageCircleImage]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageCircleImage]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageCircleImage]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0efeecca5fe21894767aeb9bfe668f939391e15b84728fc1c167711be229a03b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageCircleImageTransformation",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageCircleImageTransformation:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageCircleImageTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageCircleImageTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageCircleImageTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__965118815c045f0469eb8786b4fc169c1027ebc162f1149518815197c4efcad4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageCircleImageTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageCircleImageTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageCircleImageTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f41d151e5054f99b478aff9db8134f7f49e17a1607d8bfe7e70f9dbe399e720)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9fd41c16ba0c6549435c3c8a323b2358b067910358e1d48f28793537ac63fef6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putBoxImage")
    def put_box_image(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageBoxImage, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9e6ca0e2faa41c47c0c42d1ff942f13f77acbca02ca572d080ca43de80840c9f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBoxImage", [value]))

    @jsii.member(jsii_name="putCircleImage")
    def put_circle_image(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageCircleImage, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a885edeb3ba669e61b2a48a7fd4b16ba6d6bf33d882169ca3341b865d2169f4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCircleImage", [value]))

    @jsii.member(jsii_name="putTextImage")
    def put_text_image(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageTextImage", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6ad18fa29c0f2e5ad02ce65988a33588b7abb7e53e099e86ab741ad52ce6cf15)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTextImage", [value]))

    @jsii.member(jsii_name="putUrlImage")
    def put_url_image(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageUrlImage", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__378bdd96805ef3039776634616672a9aa5f2a338a36aa39f151e4411a72602f7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putUrlImage", [value]))

    @jsii.member(jsii_name="resetBoxImage")
    def reset_box_image(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBoxImage", []))

    @jsii.member(jsii_name="resetCircleImage")
    def reset_circle_image(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCircleImage", []))

    @jsii.member(jsii_name="resetTextImage")
    def reset_text_image(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTextImage", []))

    @jsii.member(jsii_name="resetUrlImage")
    def reset_url_image(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUrlImage", []))

    @builtins.property
    @jsii.member(jsii_name="boxImage")
    def box_image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageBoxImageList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageBoxImageList, jsii.get(self, "boxImage"))

    @builtins.property
    @jsii.member(jsii_name="circleImage")
    def circle_image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageCircleImageList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageCircleImageList, jsii.get(self, "circleImage"))

    @builtins.property
    @jsii.member(jsii_name="textImage")
    def text_image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageTextImageList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageTextImageList", jsii.get(self, "textImage"))

    @builtins.property
    @jsii.member(jsii_name="urlImage")
    def url_image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageUrlImageList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageUrlImageList", jsii.get(self, "urlImage"))

    @builtins.property
    @jsii.member(jsii_name="boxImageInput")
    def box_image_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageBoxImage]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageBoxImage]]], jsii.get(self, "boxImageInput"))

    @builtins.property
    @jsii.member(jsii_name="circleImageInput")
    def circle_image_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageCircleImage]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageCircleImage]]], jsii.get(self, "circleImageInput"))

    @builtins.property
    @jsii.member(jsii_name="textImageInput")
    def text_image_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageTextImage"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageTextImage"]]], jsii.get(self, "textImageInput"))

    @builtins.property
    @jsii.member(jsii_name="urlImageInput")
    def url_image_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageUrlImage"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageUrlImage"]]], jsii.get(self, "urlImageInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1e4c2d07bb739697bd2adc750d0e577bf14ff5b40faff2d053ad7707558a1b27)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageTextImage",
    jsii_struct_bases=[],
    name_mapping={
        "fill": "fill",
        "fill_var": "fillVar",
        "size": "size",
        "size_var": "sizeVar",
        "stroke": "stroke",
        "stroke_size": "strokeSize",
        "stroke_size_var": "strokeSizeVar",
        "stroke_var": "strokeVar",
        "text": "text",
        "text_var": "textVar",
        "transformation": "transformation",
        "typeface": "typeface",
        "typeface_var": "typefaceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageTextImage:
    def __init__(
        self,
        *,
        fill: typing.Optional[builtins.str] = None,
        fill_var: typing.Optional[builtins.str] = None,
        size: typing.Optional[builtins.str] = None,
        size_var: typing.Optional[builtins.str] = None,
        stroke: typing.Optional[builtins.str] = None,
        stroke_size: typing.Optional[builtins.str] = None,
        stroke_size_var: typing.Optional[builtins.str] = None,
        stroke_var: typing.Optional[builtins.str] = None,
        text: typing.Optional[builtins.str] = None,
        text_var: typing.Optional[builtins.str] = None,
        transformation: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageTextImageTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        typeface: typing.Optional[builtins.str] = None,
        typeface_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fill: The main fill color of the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill DataAkamaiImagingPolicyImage#fill}
        :param fill_var: The main fill color of the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_var DataAkamaiImagingPolicyImage#fill_var}
        :param size: The size in pixels to render the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#size DataAkamaiImagingPolicyImage#size}
        :param size_var: The size in pixels to render the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#size_var DataAkamaiImagingPolicyImage#size_var}
        :param stroke: The color for the outline of the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke DataAkamaiImagingPolicyImage#stroke}
        :param stroke_size: The thickness in points for the outline of the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_size DataAkamaiImagingPolicyImage#stroke_size}
        :param stroke_size_var: The thickness in points for the outline of the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_size_var DataAkamaiImagingPolicyImage#stroke_size_var}
        :param stroke_var: The color for the outline of the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_var DataAkamaiImagingPolicyImage#stroke_var}
        :param text: The line of text to render. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text DataAkamaiImagingPolicyImage#text}
        :param text_var: The line of text to render. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text_var DataAkamaiImagingPolicyImage#text_var}
        :param transformation: transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        :param typeface: The font family to apply to the text image. This may be a URL to a TrueType or WOFF (v1) typeface, or a string that refers to one of the standard built-in browser fonts. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#typeface DataAkamaiImagingPolicyImage#typeface}
        :param typeface_var: The font family to apply to the text image. This may be a URL to a TrueType or WOFF (v1) typeface, or a string that refers to one of the standard built-in browser fonts. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#typeface_var DataAkamaiImagingPolicyImage#typeface_var}
        '''
        if isinstance(transformation, dict):
            transformation = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageTextImageTransformation(**transformation)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5d6e1d3a8319b2e908ab6e87898817de8de9707b1bc6815f620698fbc69868ee)
            check_type(argname="argument fill", value=fill, expected_type=type_hints["fill"])
            check_type(argname="argument fill_var", value=fill_var, expected_type=type_hints["fill_var"])
            check_type(argname="argument size", value=size, expected_type=type_hints["size"])
            check_type(argname="argument size_var", value=size_var, expected_type=type_hints["size_var"])
            check_type(argname="argument stroke", value=stroke, expected_type=type_hints["stroke"])
            check_type(argname="argument stroke_size", value=stroke_size, expected_type=type_hints["stroke_size"])
            check_type(argname="argument stroke_size_var", value=stroke_size_var, expected_type=type_hints["stroke_size_var"])
            check_type(argname="argument stroke_var", value=stroke_var, expected_type=type_hints["stroke_var"])
            check_type(argname="argument text", value=text, expected_type=type_hints["text"])
            check_type(argname="argument text_var", value=text_var, expected_type=type_hints["text_var"])
            check_type(argname="argument transformation", value=transformation, expected_type=type_hints["transformation"])
            check_type(argname="argument typeface", value=typeface, expected_type=type_hints["typeface"])
            check_type(argname="argument typeface_var", value=typeface_var, expected_type=type_hints["typeface_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fill is not None:
            self._values["fill"] = fill
        if fill_var is not None:
            self._values["fill_var"] = fill_var
        if size is not None:
            self._values["size"] = size
        if size_var is not None:
            self._values["size_var"] = size_var
        if stroke is not None:
            self._values["stroke"] = stroke
        if stroke_size is not None:
            self._values["stroke_size"] = stroke_size
        if stroke_size_var is not None:
            self._values["stroke_size_var"] = stroke_size_var
        if stroke_var is not None:
            self._values["stroke_var"] = stroke_var
        if text is not None:
            self._values["text"] = text
        if text_var is not None:
            self._values["text_var"] = text_var
        if transformation is not None:
            self._values["transformation"] = transformation
        if typeface is not None:
            self._values["typeface"] = typeface
        if typeface_var is not None:
            self._values["typeface_var"] = typeface_var

    @builtins.property
    def fill(self) -> typing.Optional[builtins.str]:
        '''The main fill color of the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill DataAkamaiImagingPolicyImage#fill}
        '''
        result = self._values.get("fill")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fill_var(self) -> typing.Optional[builtins.str]:
        '''The main fill color of the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_var DataAkamaiImagingPolicyImage#fill_var}
        '''
        result = self._values.get("fill_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def size(self) -> typing.Optional[builtins.str]:
        '''The size in pixels to render the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#size DataAkamaiImagingPolicyImage#size}
        '''
        result = self._values.get("size")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def size_var(self) -> typing.Optional[builtins.str]:
        '''The size in pixels to render the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#size_var DataAkamaiImagingPolicyImage#size_var}
        '''
        result = self._values.get("size_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def stroke(self) -> typing.Optional[builtins.str]:
        '''The color for the outline of the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke DataAkamaiImagingPolicyImage#stroke}
        '''
        result = self._values.get("stroke")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def stroke_size(self) -> typing.Optional[builtins.str]:
        '''The thickness in points for the outline of the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_size DataAkamaiImagingPolicyImage#stroke_size}
        '''
        result = self._values.get("stroke_size")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def stroke_size_var(self) -> typing.Optional[builtins.str]:
        '''The thickness in points for the outline of the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_size_var DataAkamaiImagingPolicyImage#stroke_size_var}
        '''
        result = self._values.get("stroke_size_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def stroke_var(self) -> typing.Optional[builtins.str]:
        '''The color for the outline of the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_var DataAkamaiImagingPolicyImage#stroke_var}
        '''
        result = self._values.get("stroke_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def text(self) -> typing.Optional[builtins.str]:
        '''The line of text to render.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text DataAkamaiImagingPolicyImage#text}
        '''
        result = self._values.get("text")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def text_var(self) -> typing.Optional[builtins.str]:
        '''The line of text to render.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text_var DataAkamaiImagingPolicyImage#text_var}
        '''
        result = self._values.get("text_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def transformation(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageTextImageTransformation"]:
        '''transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        '''
        result = self._values.get("transformation")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageTextImageTransformation"], result)

    @builtins.property
    def typeface(self) -> typing.Optional[builtins.str]:
        '''The font family to apply to the text image.

        This may be a URL to a TrueType or WOFF (v1) typeface, or a string that refers to one of the standard built-in browser fonts.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#typeface DataAkamaiImagingPolicyImage#typeface}
        '''
        result = self._values.get("typeface")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def typeface_var(self) -> typing.Optional[builtins.str]:
        '''The font family to apply to the text image.

        This may be a URL to a TrueType or WOFF (v1) typeface, or a string that refers to one of the standard built-in browser fonts.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#typeface_var DataAkamaiImagingPolicyImage#typeface_var}
        '''
        result = self._values.get("typeface_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageTextImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageTextImageList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageTextImageList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__93ffb91089fd06eb09b748cabef8c86b47b7b007d55e27da323086e3857671d2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageTextImageOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c30c027ad02ce630362b25e66d56fc812fcaaab87d102fb531be289e6da309d2)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageTextImageOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8058256b1ba4bcf0f8c40e4d5c4da988a2b3236fc1e99a6b957740780c1cc0f8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a9ea813fa8f1cb740e18994c36aed2791bd2f17c394684e7e48651aae01157c0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__edb4a761542350995ba948a13c1b5a080a104a5583187d479e8d317aa6f3a08f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageTextImage]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageTextImage]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageTextImage]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0faad5ce95a85e82c497591ae93e40a6fb99c2139485d9bdaa3255a5f20da242)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageTextImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageTextImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3577dd0ad07737f6766b1fbb5c4df1178dbc5d42272a4ce21c8cbcb3f8b25fb0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformation")
    def put_transformation(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageTextImageTransformation()

        return typing.cast(None, jsii.invoke(self, "putTransformation", [value]))

    @jsii.member(jsii_name="resetFill")
    def reset_fill(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFill", []))

    @jsii.member(jsii_name="resetFillVar")
    def reset_fill_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFillVar", []))

    @jsii.member(jsii_name="resetSize")
    def reset_size(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSize", []))

    @jsii.member(jsii_name="resetSizeVar")
    def reset_size_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSizeVar", []))

    @jsii.member(jsii_name="resetStroke")
    def reset_stroke(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStroke", []))

    @jsii.member(jsii_name="resetStrokeSize")
    def reset_stroke_size(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStrokeSize", []))

    @jsii.member(jsii_name="resetStrokeSizeVar")
    def reset_stroke_size_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStrokeSizeVar", []))

    @jsii.member(jsii_name="resetStrokeVar")
    def reset_stroke_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStrokeVar", []))

    @jsii.member(jsii_name="resetText")
    def reset_text(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetText", []))

    @jsii.member(jsii_name="resetTextVar")
    def reset_text_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTextVar", []))

    @jsii.member(jsii_name="resetTransformation")
    def reset_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformation", []))

    @jsii.member(jsii_name="resetTypeface")
    def reset_typeface(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeface", []))

    @jsii.member(jsii_name="resetTypefaceVar")
    def reset_typeface_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypefaceVar", []))

    @builtins.property
    @jsii.member(jsii_name="transformation")
    def transformation(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageTextImageTransformationOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageTextImageTransformationOutputReference", jsii.get(self, "transformation"))

    @builtins.property
    @jsii.member(jsii_name="fillInput")
    def fill_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fillInput"))

    @builtins.property
    @jsii.member(jsii_name="fillVarInput")
    def fill_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fillVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sizeInput")
    def size_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sizeInput"))

    @builtins.property
    @jsii.member(jsii_name="sizeVarInput")
    def size_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sizeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="strokeInput")
    def stroke_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "strokeInput"))

    @builtins.property
    @jsii.member(jsii_name="strokeSizeInput")
    def stroke_size_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "strokeSizeInput"))

    @builtins.property
    @jsii.member(jsii_name="strokeSizeVarInput")
    def stroke_size_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "strokeSizeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="strokeVarInput")
    def stroke_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "strokeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="textInput")
    def text_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "textInput"))

    @builtins.property
    @jsii.member(jsii_name="textVarInput")
    def text_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "textVarInput"))

    @builtins.property
    @jsii.member(jsii_name="transformationInput")
    def transformation_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageTextImageTransformation"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageTextImageTransformation"], jsii.get(self, "transformationInput"))

    @builtins.property
    @jsii.member(jsii_name="typefaceInput")
    def typeface_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typefaceInput"))

    @builtins.property
    @jsii.member(jsii_name="typefaceVarInput")
    def typeface_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typefaceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="fill")
    def fill(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fill"))

    @fill.setter
    def fill(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3b3024746d2a4af17369815a422ead6657693cbb4ed86dd1f7290537f706dd24)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fill", value)

    @builtins.property
    @jsii.member(jsii_name="fillVar")
    def fill_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fillVar"))

    @fill_var.setter
    def fill_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a8731ff6a391f785b55c6153a8f77d3bc253e602bcbdcd0a18bb7e5fc6eea3bd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fillVar", value)

    @builtins.property
    @jsii.member(jsii_name="size")
    def size(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "size"))

    @size.setter
    def size(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7ad07b76e8a84f2afc6019bcadda585804f1c2efab7845a982cd5da08bd041e0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "size", value)

    @builtins.property
    @jsii.member(jsii_name="sizeVar")
    def size_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sizeVar"))

    @size_var.setter
    def size_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eb3a603c486f7161674da255e1458002d197967323651f1f29c8d83fbef3c737)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sizeVar", value)

    @builtins.property
    @jsii.member(jsii_name="stroke")
    def stroke(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "stroke"))

    @stroke.setter
    def stroke(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__95d27781aa7ece5e0b12e7042c98fd013cad444de28a614854a0b3a8f2a1e70c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "stroke", value)

    @builtins.property
    @jsii.member(jsii_name="strokeSize")
    def stroke_size(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "strokeSize"))

    @stroke_size.setter
    def stroke_size(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__694a2e900b47c096a8b718577bf9ce6a4f8f2375f4adf1da96560d034071addf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "strokeSize", value)

    @builtins.property
    @jsii.member(jsii_name="strokeSizeVar")
    def stroke_size_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "strokeSizeVar"))

    @stroke_size_var.setter
    def stroke_size_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__de6f2950891f66dcda8751ccd9fb141a44995e77b9be3c0a219557adcbd4a1ec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "strokeSizeVar", value)

    @builtins.property
    @jsii.member(jsii_name="strokeVar")
    def stroke_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "strokeVar"))

    @stroke_var.setter
    def stroke_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a00cccbdbbb06a183491435a43f3bc9a86f2aa0b9d8038cb9117a6f741d3199e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "strokeVar", value)

    @builtins.property
    @jsii.member(jsii_name="text")
    def text(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "text"))

    @text.setter
    def text(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f25b4d8814ec5688fabd713163cf8c66fc500b1bc66d8779bef0c566e6ce536d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "text", value)

    @builtins.property
    @jsii.member(jsii_name="textVar")
    def text_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "textVar"))

    @text_var.setter
    def text_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d7069a55a723a4f01cc2af1c2be2e11f4e23af01cc998362b50ba5fdd5a2e65e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "textVar", value)

    @builtins.property
    @jsii.member(jsii_name="typeface")
    def typeface(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeface"))

    @typeface.setter
    def typeface(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a31e650f834b20aec34abac38a18bd2d26d39ea4f768777675468a05406f698b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeface", value)

    @builtins.property
    @jsii.member(jsii_name="typefaceVar")
    def typeface_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typefaceVar"))

    @typeface_var.setter
    def typeface_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f08f4e0e97cba76dcbb7782122428938fed184f9a089fc343b8c1df3ad0a040)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typefaceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageTextImage]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageTextImage]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageTextImage]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ee0d5e07118e45d3d4e73f8c1e13c53afaff93b118f9d12de0663ab1e2a34b66)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageTextImageTransformation",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageTextImageTransformation:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageTextImageTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageTextImageTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageTextImageTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c534fd7a5c1564294505b348fdfa2d323c721134a2fb4944bb1946629fce7dcd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageTextImageTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageTextImageTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageTextImageTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__429267e245a77e1e7b6c447c8a6c88b6a6b047f658d3b22d3ab7d32647601b76)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageUrlImage",
    jsii_struct_bases=[],
    name_mapping={
        "transformation": "transformation",
        "url": "url",
        "url_var": "urlVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageUrlImage:
    def __init__(
        self,
        *,
        transformation: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageUrlImageTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        url: typing.Optional[builtins.str] = None,
        url_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param transformation: transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        :param url: The URL of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url DataAkamaiImagingPolicyImage#url}
        :param url_var: The URL of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url_var DataAkamaiImagingPolicyImage#url_var}
        '''
        if isinstance(transformation, dict):
            transformation = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageUrlImageTransformation(**transformation)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7c8e1fea50445aed68b52eb0529c2d2cadba04d06be08b3072715308b2f146f9)
            check_type(argname="argument transformation", value=transformation, expected_type=type_hints["transformation"])
            check_type(argname="argument url", value=url, expected_type=type_hints["url"])
            check_type(argname="argument url_var", value=url_var, expected_type=type_hints["url_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if transformation is not None:
            self._values["transformation"] = transformation
        if url is not None:
            self._values["url"] = url
        if url_var is not None:
            self._values["url_var"] = url_var

    @builtins.property
    def transformation(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageUrlImageTransformation"]:
        '''transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        '''
        result = self._values.get("transformation")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageUrlImageTransformation"], result)

    @builtins.property
    def url(self) -> typing.Optional[builtins.str]:
        '''The URL of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url DataAkamaiImagingPolicyImage#url}
        '''
        result = self._values.get("url")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def url_var(self) -> typing.Optional[builtins.str]:
        '''The URL of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url_var DataAkamaiImagingPolicyImage#url_var}
        '''
        result = self._values.get("url_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageUrlImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageUrlImageList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageUrlImageList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4b33692a47b980f8ff8c9ffcd5e7a4a047f1c12e2ee4a7d888cb87358dbaef23)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageUrlImageOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ba470e100bb6eb59fac827e844c5a10a2a591c579c6a38b56bfec4dfbe79617f)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageUrlImageOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e2b3adf79077447acd93fda92cb2fd7a959f4f628a124b4927d0668eba23986f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b219a35e8b021d9f73dbbc74814cd5b5ec9b904ba73d733c66be7832cbfd7fe8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ec5d43d3c555eb38373a6e7f9ab6b742940fe60a9e116ad7ae9b88830883e04b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageUrlImage]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageUrlImage]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageUrlImage]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bdac2f01a114f50d4afbe6a9806985feafcd0875536fd085c4093130b9989b59)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageUrlImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageUrlImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fbe6ad6577a7f48f540b1c9c36801f7a8a6a2547140182d3518c91ea6c48a767)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformation")
    def put_transformation(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageUrlImageTransformation()

        return typing.cast(None, jsii.invoke(self, "putTransformation", [value]))

    @jsii.member(jsii_name="resetTransformation")
    def reset_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformation", []))

    @jsii.member(jsii_name="resetUrl")
    def reset_url(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUrl", []))

    @jsii.member(jsii_name="resetUrlVar")
    def reset_url_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUrlVar", []))

    @builtins.property
    @jsii.member(jsii_name="transformation")
    def transformation(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageUrlImageTransformationOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageUrlImageTransformationOutputReference", jsii.get(self, "transformation"))

    @builtins.property
    @jsii.member(jsii_name="transformationInput")
    def transformation_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageUrlImageTransformation"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageUrlImageTransformation"], jsii.get(self, "transformationInput"))

    @builtins.property
    @jsii.member(jsii_name="urlInput")
    def url_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "urlInput"))

    @builtins.property
    @jsii.member(jsii_name="urlVarInput")
    def url_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "urlVarInput"))

    @builtins.property
    @jsii.member(jsii_name="url")
    def url(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "url"))

    @url.setter
    def url(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e3098b931c29c88434aa2b55d76b9ffeac5ca1df14554e40160b4bed6aa5e109)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "url", value)

    @builtins.property
    @jsii.member(jsii_name="urlVar")
    def url_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "urlVar"))

    @url_var.setter
    def url_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__986dc32c2cca3010a3af4990ca7d322c745be77aa8f18cc50df3c84daa7500e5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "urlVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageUrlImage]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageUrlImage]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageUrlImage]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a4a72ab93897b1542715d35cfc277f394dc7e08638f940b61f20fa0c230ce83f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageUrlImageTransformation",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageUrlImageTransformation:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageUrlImageTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageUrlImageTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageUrlImageTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__19b502e915a2ba59615ede4177600e2529e267b0728464e41a603bf0d1995521)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageUrlImageTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageUrlImageTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageUrlImageTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__16eb18306a009e5c6f2bc49685632b354c3939f41debe084454f90efa61bbee6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dae26812399dc2bbee29266769f813c5de9aa299c1e3fe72af3289c0435182c0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cec58f45b1b1fc8f60f876fcfd417e1fff5cbdf83bbf994fa069aedb9b2fd3ee)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5503325a23985a13603b5bcdf2aad7de3f58cefaa451abb84cd85893cfdc68dd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__caffadbe94c544ad2cda0ad3fc6a1c54858350c953a0318c4f75fc24895ea058)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__87d0ab689a51eddde9c910a35dc74afcf91550694d7e4a4ab0b3e4500a080638)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultComposite]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultComposite]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ff42bc4ee3d6011d4d8f45ccea8a3c6555b4735695fd24f3abfa5276f2454088)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b871fd5e5ec977fac62ebd291346c1925839444cdf91373d3776ee32ab30a969)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(
        self,
        *,
        box_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageBoxImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
        circle_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageCircleImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
        text_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageTextImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
        url_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageUrlImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param box_image: box_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#box_image DataAkamaiImagingPolicyImage#box_image}
        :param circle_image: circle_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#circle_image DataAkamaiImagingPolicyImage#circle_image}
        :param text_image: text_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text_image DataAkamaiImagingPolicyImage#text_image}
        :param url_image: url_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url_image DataAkamaiImagingPolicyImage#url_image}
        '''
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImage(
            box_image=box_image,
            circle_image=circle_image,
            text_image=text_image,
            url_image=url_image,
        )

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPlacement")
    def reset_placement(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacement", []))

    @jsii.member(jsii_name="resetPlacementVar")
    def reset_placement_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacementVar", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetScaleDimension")
    def reset_scale_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimension", []))

    @jsii.member(jsii_name="resetScaleDimensionVar")
    def reset_scale_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimensionVar", []))

    @jsii.member(jsii_name="resetScaleVar")
    def reset_scale_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="placementInput")
    def placement_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementInput"))

    @builtins.property
    @jsii.member(jsii_name="placementVarInput")
    def placement_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionInput")
    def scale_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVarInput")
    def scale_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleVarInput")
    def scale_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1929db512f798802270a6ce18784833ac4b07b52c0003fa1a9cbd0190fc75e72)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4dbc7e419332af6f73f9b73dd59e982f86a561d218f058e37a90cf16afdc9241)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="placement")
    def placement(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placement"))

    @placement.setter
    def placement(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__15d12fe654470313af67bc362843f28c15d6769fb6c9c884e0095844c286ee74)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placement", value)

    @builtins.property
    @jsii.member(jsii_name="placementVar")
    def placement_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placementVar"))

    @placement_var.setter
    def placement_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__96ef6bcc0c98fac5645d5a92573b0be611c2dded44fe43954769df4e1419ebf9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placementVar", value)

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scale"))

    @scale.setter
    def scale(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f7c6a34f2ced6663ffe1fc12b0a488875c07ce382c2fb69da43d33dc560ba835)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scale", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimension")
    def scale_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimension"))

    @scale_dimension.setter
    def scale_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__90f783867ab27d6926f83dac00ae931189daf3589865dc07e513917124939a01)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimension", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVar")
    def scale_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimensionVar"))

    @scale_dimension_var.setter
    def scale_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8b66dc65c8068efec02702751702221927649e8a002e6abd7127cdc73d994da6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="scaleVar")
    def scale_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleVar"))

    @scale_var.setter
    def scale_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8e8cafaf9b16be663d63ad0ebed9172d210e759ce201c0153e6026b5b0d64114)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__49c057abe3713c82c70604d81344b7c8703b7488b6ea2908633fe6cf4c1b3275)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c7d53fb3174761067936df7886f6482b9008526671d6f77a7ff1a5a8bb377101)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__85b154c0929790fee35e7387f75c44129d73931cb31d22368ed023be743da942)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dc9ded17c800b217a4fc05ff260df0b5bdf358fe19ff704f3cd78856e15ac48d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultComposite]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultComposite]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultComposite]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__603d29b544801ecb70623949c21eb48869e784689d41977674755626db8170da)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompound",
    jsii_struct_bases=[],
    name_mapping={"transformations": "transformations"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompound:
    def __init__(
        self,
        *,
        transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param transformations: transformations block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__86e68a131ace62857a7338e13facbb2ad8503ee864138b78fcd6b041655c3287)
            check_type(argname="argument transformations", value=transformations, expected_type=type_hints["transformations"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if transformations is not None:
            self._values["transformations"] = transformations

    @builtins.property
    def transformations(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformations"]]]:
        '''transformations block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        result = self._values.get("transformations")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformations"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompound(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d85d3895c32ecb16721eb26fb85e21677299f483253a156b73cec34eb7c399cd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be692895610c3562ea762d8700859d4b115f42b008c113e17c8296b453d80bfe)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8cf81cdaff1a0233ac05ac586dac4d393954d61eeb3466aa79fff9d2d1725038)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6919ff98f1d66bd214ab9e548508ce54bd7e929f6342101f577b711d2bf40a77)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac0c7f5e6a93092ca1458c2d148d1e673f7a9cb4234c4c3b3a51818ee068b1fd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompound]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompound]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__819a7192262b8cb0cc70638e273c5c9f9e89d84ee232c892485a3625edf79ad3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__159007419ea9c3ea28d45f2696a10fb2c03091b9ab8a61c27dc51156d0dca4af)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformations")
    def put_transformations(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d66472afc2e817f694f816373bafef5aa0113c67b9d0633f5b17687cec6d795d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTransformations", [value]))

    @jsii.member(jsii_name="resetTransformations")
    def reset_transformations(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformations", []))

    @builtins.property
    @jsii.member(jsii_name="transformations")
    def transformations(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsList", jsii.get(self, "transformations"))

    @builtins.property
    @jsii.member(jsii_name="transformationsInput")
    def transformations_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformations"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformations"]]], jsii.get(self, "transformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompound]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompound]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompound]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0c5fbf2ebffa6511456847dedbcf3db3939092cc4a565d326b1b62e002552688)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformations",
    jsii_struct_bases=[],
    name_mapping={
        "background_color": "backgroundColor",
        "blur": "blur",
        "chroma_key": "chromaKey",
        "composite": "composite",
        "compound": "compound",
        "contrast": "contrast",
        "goop": "goop",
        "grayscale": "grayscale",
        "hsl": "hsl",
        "hsv": "hsv",
        "if_dimension": "ifDimension",
        "if_orientation": "ifOrientation",
        "max_colors": "maxColors",
        "mirror": "mirror",
        "mono_hue": "monoHue",
        "opacity": "opacity",
        "remove_color": "removeColor",
        "unsharp_mask": "unsharpMask",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformations:
    def __init__(
        self,
        *,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsBackgroundColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsBlur", typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsChromaKey", typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsComposite", typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsCompound", typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsContrast", typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsGoop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsGrayscale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsHsl", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsHsv", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfDimension", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfOrientation", typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsMaxColors", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsMirror", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsMonoHue", typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsOpacity", typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsRemoveColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsUnsharpMask", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bf6117440473832aa488024d7d88e2abb3ba9accd534e5eb226a62e5dd6eddd6)
            check_type(argname="argument background_color", value=background_color, expected_type=type_hints["background_color"])
            check_type(argname="argument blur", value=blur, expected_type=type_hints["blur"])
            check_type(argname="argument chroma_key", value=chroma_key, expected_type=type_hints["chroma_key"])
            check_type(argname="argument composite", value=composite, expected_type=type_hints["composite"])
            check_type(argname="argument compound", value=compound, expected_type=type_hints["compound"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument goop", value=goop, expected_type=type_hints["goop"])
            check_type(argname="argument grayscale", value=grayscale, expected_type=type_hints["grayscale"])
            check_type(argname="argument hsl", value=hsl, expected_type=type_hints["hsl"])
            check_type(argname="argument hsv", value=hsv, expected_type=type_hints["hsv"])
            check_type(argname="argument if_dimension", value=if_dimension, expected_type=type_hints["if_dimension"])
            check_type(argname="argument if_orientation", value=if_orientation, expected_type=type_hints["if_orientation"])
            check_type(argname="argument max_colors", value=max_colors, expected_type=type_hints["max_colors"])
            check_type(argname="argument mirror", value=mirror, expected_type=type_hints["mirror"])
            check_type(argname="argument mono_hue", value=mono_hue, expected_type=type_hints["mono_hue"])
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument remove_color", value=remove_color, expected_type=type_hints["remove_color"])
            check_type(argname="argument unsharp_mask", value=unsharp_mask, expected_type=type_hints["unsharp_mask"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if background_color is not None:
            self._values["background_color"] = background_color
        if blur is not None:
            self._values["blur"] = blur
        if chroma_key is not None:
            self._values["chroma_key"] = chroma_key
        if composite is not None:
            self._values["composite"] = composite
        if compound is not None:
            self._values["compound"] = compound
        if contrast is not None:
            self._values["contrast"] = contrast
        if goop is not None:
            self._values["goop"] = goop
        if grayscale is not None:
            self._values["grayscale"] = grayscale
        if hsl is not None:
            self._values["hsl"] = hsl
        if hsv is not None:
            self._values["hsv"] = hsv
        if if_dimension is not None:
            self._values["if_dimension"] = if_dimension
        if if_orientation is not None:
            self._values["if_orientation"] = if_orientation
        if max_colors is not None:
            self._values["max_colors"] = max_colors
        if mirror is not None:
            self._values["mirror"] = mirror
        if mono_hue is not None:
            self._values["mono_hue"] = mono_hue
        if opacity is not None:
            self._values["opacity"] = opacity
        if remove_color is not None:
            self._values["remove_color"] = remove_color
        if unsharp_mask is not None:
            self._values["unsharp_mask"] = unsharp_mask

    @builtins.property
    def background_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsBackgroundColor"]]]:
        '''background_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        '''
        result = self._values.get("background_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsBackgroundColor"]]], result)

    @builtins.property
    def blur(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsBlur"]]]:
        '''blur block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        '''
        result = self._values.get("blur")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsBlur"]]], result)

    @builtins.property
    def chroma_key(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsChromaKey"]]]:
        '''chroma_key block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        '''
        result = self._values.get("chroma_key")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsChromaKey"]]], result)

    @builtins.property
    def composite(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsComposite"]]]:
        '''composite block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        '''
        result = self._values.get("composite")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsComposite"]]], result)

    @builtins.property
    def compound(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsCompound"]]]:
        '''compound block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        '''
        result = self._values.get("compound")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsCompound"]]], result)

    @builtins.property
    def contrast(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsContrast"]]]:
        '''contrast block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsContrast"]]], result)

    @builtins.property
    def goop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsGoop"]]]:
        '''goop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        '''
        result = self._values.get("goop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsGoop"]]], result)

    @builtins.property
    def grayscale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsGrayscale"]]]:
        '''grayscale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        '''
        result = self._values.get("grayscale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsGrayscale"]]], result)

    @builtins.property
    def hsl(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsHsl"]]]:
        '''hsl block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        '''
        result = self._values.get("hsl")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsHsl"]]], result)

    @builtins.property
    def hsv(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsHsv"]]]:
        '''hsv block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        '''
        result = self._values.get("hsv")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsHsv"]]], result)

    @builtins.property
    def if_dimension(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfDimension"]]]:
        '''if_dimension block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        '''
        result = self._values.get("if_dimension")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfDimension"]]], result)

    @builtins.property
    def if_orientation(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfOrientation"]]]:
        '''if_orientation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        '''
        result = self._values.get("if_orientation")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfOrientation"]]], result)

    @builtins.property
    def max_colors(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsMaxColors"]]]:
        '''max_colors block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        '''
        result = self._values.get("max_colors")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsMaxColors"]]], result)

    @builtins.property
    def mirror(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsMirror"]]]:
        '''mirror block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        '''
        result = self._values.get("mirror")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsMirror"]]], result)

    @builtins.property
    def mono_hue(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsMonoHue"]]]:
        '''mono_hue block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        '''
        result = self._values.get("mono_hue")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsMonoHue"]]], result)

    @builtins.property
    def opacity(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsOpacity"]]]:
        '''opacity block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsOpacity"]]], result)

    @builtins.property
    def remove_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsRemoveColor"]]]:
        '''remove_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        '''
        result = self._values.get("remove_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsRemoveColor"]]], result)

    @builtins.property
    def unsharp_mask(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsUnsharpMask"]]]:
        '''unsharp_mask block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        result = self._values.get("unsharp_mask")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsUnsharpMask"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformations(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsBackgroundColor",
    jsii_struct_bases=[],
    name_mapping={"color": "color", "color_var": "colorVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsBackgroundColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__765364e1408361523eb14b936e6ead8b36df2fb08e04ce5171b2320ee7091b1c)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsBackgroundColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsBackgroundColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsBackgroundColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ad3992163115257c404ea76129e7d4b604efd12450f78a267b278fa3bdf6fabd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsBackgroundColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b643a5e08c58e8f2d6e7a2c7b8ce12cfc1c4acb53da58526f99991e2f946c226)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsBackgroundColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__914143d6e53370b1690c11365bae4a3c423cf13c2f510ce5727492b62f44c667)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c835ba8f788f6271b0f98a04a83ad14fd039fada3e26b487b2ffbaf93520b270)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b769785b0131f28272ba925d58c6809e38d809d5c17bead3bfc44c30c0c25046)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsBackgroundColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsBackgroundColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4931c13099bae700e5580cbb194774cc6e809acd866daed0f1202185211a11d3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsBackgroundColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsBackgroundColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e2d2e3bde71e1d9bc200cde3fb9a59983ecb18f2c7726f484d0bb410a626325d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4d1058605e5511f9f8ffec6eae9a5c7fce16c2316b8a95768bb60c9570919fd6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb2e692330400279d6904540092c95e2d07fdb779a1bd7eea30feced852ffdee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsBackgroundColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsBackgroundColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsBackgroundColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__987db98ffb68a568e509a2f5225ddccf8f281bbbe04dea9df4833eec9b32c31d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsBlur",
    jsii_struct_bases=[],
    name_mapping={"sigma": "sigma", "sigma_var": "sigmaVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsBlur:
    def __init__(
        self,
        *,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param sigma: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d123b62c3a973f01f047c6f02232190dcd60960bba0e2346586afc1a4360099a)
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsBlur(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsBlurList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsBlurList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c290522ac4ec88ae7d3f91095920fc6338c1ea6089e303fb0c9e7ee9ddc17ae8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsBlurOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__94744a516495453870064002de0a2e1627f941eb60ef0cfca6ca0f164d8fa3d8)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsBlurOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0969ac921101cf849be51c69ebf3a22ea7c69a40bcb56a5da23cb21b9f4f2a79)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__36d89e344b1fcbd87697e1874937ce85ec49b0c087ea2e274040b059092325fc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__92df1696247d068bf365660610ed50c465d7349543cab637370422a69e1d8d95)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsBlur]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsBlur]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9f7653dbe3fd3ceb5a2c180cb09cd8d010288735b4c817a10f513318b68fcd68)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsBlurOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsBlurOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be434e367c2bc139c45644dc26c81f07787ad221bc7dd56eebfe09c10c985086)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a7084a81302432089a71dc62020a7a613d23c8ed87ea585ce1c8041148c04730)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1890e9ab315b83a5aec2b62887cc3aeb9cddc7c8930eb48e4eb1259598cdc325)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsBlur]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsBlur]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsBlur]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__303a1c8ec93f9011262bc0415ff7da2c6320f227e19d7bd96c68355a430e4013)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsChromaKey",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_feather": "hueFeather",
        "hue_feather_var": "hueFeatherVar",
        "hue_tolerance": "hueTolerance",
        "hue_tolerance_var": "hueToleranceVar",
        "hue_var": "hueVar",
        "lightness_feather": "lightnessFeather",
        "lightness_feather_var": "lightnessFeatherVar",
        "lightness_tolerance": "lightnessTolerance",
        "lightness_tolerance_var": "lightnessToleranceVar",
        "saturation_feather": "saturationFeather",
        "saturation_feather_var": "saturationFeatherVar",
        "saturation_tolerance": "saturationTolerance",
        "saturation_tolerance_var": "saturationToleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsChromaKey:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_feather: typing.Optional[builtins.str] = None,
        hue_feather_var: typing.Optional[builtins.str] = None,
        hue_tolerance: typing.Optional[builtins.str] = None,
        hue_tolerance_var: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness_feather: typing.Optional[builtins.str] = None,
        lightness_feather_var: typing.Optional[builtins.str] = None,
        lightness_tolerance: typing.Optional[builtins.str] = None,
        lightness_tolerance_var: typing.Optional[builtins.str] = None,
        saturation_feather: typing.Optional[builtins.str] = None,
        saturation_feather_var: typing.Optional[builtins.str] = None,
        saturation_tolerance: typing.Optional[builtins.str] = None,
        saturation_tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_feather: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        :param hue_feather_var: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        :param hue_tolerance: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        :param hue_tolerance_var: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        :param hue_var: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness_feather: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        :param lightness_feather_var: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        :param lightness_tolerance: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        :param lightness_tolerance_var: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        :param saturation_feather: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        :param saturation_feather_var: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        :param saturation_tolerance: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        :param saturation_tolerance_var: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__78d3efe84e7ee0f53f8425473021d3b609931bff98afe6020489216ca46875c0)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_feather", value=hue_feather, expected_type=type_hints["hue_feather"])
            check_type(argname="argument hue_feather_var", value=hue_feather_var, expected_type=type_hints["hue_feather_var"])
            check_type(argname="argument hue_tolerance", value=hue_tolerance, expected_type=type_hints["hue_tolerance"])
            check_type(argname="argument hue_tolerance_var", value=hue_tolerance_var, expected_type=type_hints["hue_tolerance_var"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness_feather", value=lightness_feather, expected_type=type_hints["lightness_feather"])
            check_type(argname="argument lightness_feather_var", value=lightness_feather_var, expected_type=type_hints["lightness_feather_var"])
            check_type(argname="argument lightness_tolerance", value=lightness_tolerance, expected_type=type_hints["lightness_tolerance"])
            check_type(argname="argument lightness_tolerance_var", value=lightness_tolerance_var, expected_type=type_hints["lightness_tolerance_var"])
            check_type(argname="argument saturation_feather", value=saturation_feather, expected_type=type_hints["saturation_feather"])
            check_type(argname="argument saturation_feather_var", value=saturation_feather_var, expected_type=type_hints["saturation_feather_var"])
            check_type(argname="argument saturation_tolerance", value=saturation_tolerance, expected_type=type_hints["saturation_tolerance"])
            check_type(argname="argument saturation_tolerance_var", value=saturation_tolerance_var, expected_type=type_hints["saturation_tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_feather is not None:
            self._values["hue_feather"] = hue_feather
        if hue_feather_var is not None:
            self._values["hue_feather_var"] = hue_feather_var
        if hue_tolerance is not None:
            self._values["hue_tolerance"] = hue_tolerance
        if hue_tolerance_var is not None:
            self._values["hue_tolerance_var"] = hue_tolerance_var
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness_feather is not None:
            self._values["lightness_feather"] = lightness_feather
        if lightness_feather_var is not None:
            self._values["lightness_feather_var"] = lightness_feather_var
        if lightness_tolerance is not None:
            self._values["lightness_tolerance"] = lightness_tolerance
        if lightness_tolerance_var is not None:
            self._values["lightness_tolerance_var"] = lightness_tolerance_var
        if saturation_feather is not None:
            self._values["saturation_feather"] = saturation_feather
        if saturation_feather_var is not None:
            self._values["saturation_feather_var"] = saturation_feather_var
        if saturation_tolerance is not None:
            self._values["saturation_tolerance"] = saturation_tolerance
        if saturation_tolerance_var is not None:
            self._values["saturation_tolerance_var"] = saturation_tolerance_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        '''
        result = self._values.get("hue_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        '''
        result = self._values.get("hue_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        '''
        result = self._values.get("hue_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        '''
        result = self._values.get("hue_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        '''
        result = self._values.get("lightness_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        '''
        result = self._values.get("lightness_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        '''
        result = self._values.get("lightness_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        '''
        result = self._values.get("lightness_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        '''
        result = self._values.get("saturation_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        '''
        result = self._values.get("saturation_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        '''
        result = self._values.get("saturation_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        result = self._values.get("saturation_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsChromaKey(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsChromaKeyList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsChromaKeyList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9c6eaf6b102ffe8329866ebc1b3ccece7474eb756274ea6507ee7b08409a1174)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsChromaKeyOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ec9ac985d852b332104910218b29e1333290322feec9db5507044fe76a00d238)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsChromaKeyOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ae3489d1c4443d9d3c45bea594c4a7af73eb9143bfa3602826142f6088d812c8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d64acb0d05b53648f210ede91dcc6da62a937eb16f7de6c5869ae5e27336a9dc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3778e2a8804486c8b7e724ed128337d96ee93c957b07ff1e838919b5f4d28495)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsChromaKey]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsChromaKey]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__94749529254c87e06478bbf4fe46b68c85fb624acf74fd4a65b13e5157b27df6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsChromaKeyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsChromaKeyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__90ae8396eb62dc5ed4c02bd7d8b261d245628a2729c9f2d3e5ab040ae2cdeb96)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueFeather")
    def reset_hue_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeather", []))

    @jsii.member(jsii_name="resetHueFeatherVar")
    def reset_hue_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeatherVar", []))

    @jsii.member(jsii_name="resetHueTolerance")
    def reset_hue_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueTolerance", []))

    @jsii.member(jsii_name="resetHueToleranceVar")
    def reset_hue_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueToleranceVar", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightnessFeather")
    def reset_lightness_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeather", []))

    @jsii.member(jsii_name="resetLightnessFeatherVar")
    def reset_lightness_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeatherVar", []))

    @jsii.member(jsii_name="resetLightnessTolerance")
    def reset_lightness_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessTolerance", []))

    @jsii.member(jsii_name="resetLightnessToleranceVar")
    def reset_lightness_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessToleranceVar", []))

    @jsii.member(jsii_name="resetSaturationFeather")
    def reset_saturation_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeather", []))

    @jsii.member(jsii_name="resetSaturationFeatherVar")
    def reset_saturation_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeatherVar", []))

    @jsii.member(jsii_name="resetSaturationTolerance")
    def reset_saturation_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationTolerance", []))

    @jsii.member(jsii_name="resetSaturationToleranceVar")
    def reset_saturation_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherInput")
    def hue_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVarInput")
    def hue_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceInput")
    def hue_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVarInput")
    def hue_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherInput")
    def lightness_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVarInput")
    def lightness_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceInput")
    def lightness_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVarInput")
    def lightness_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherInput")
    def saturation_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVarInput")
    def saturation_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceInput")
    def saturation_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVarInput")
    def saturation_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f4547ac55808c984042ce86301d8095794779688a2f68baa85ad064117b0a478)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeather")
    def hue_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeather"))

    @hue_feather.setter
    def hue_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__011e0660325e1925455610a7e6fdf2b346f27d829b3cbc6e5c42e56c3630b102)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeather", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVar")
    def hue_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeatherVar"))

    @hue_feather_var.setter
    def hue_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c64b00d27babb5f510c930e85800b66f99960262d71518d81a8c37d996cea2f8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueTolerance")
    def hue_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueTolerance"))

    @hue_tolerance.setter
    def hue_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c98b23fa76e04ddc5bdb060a5b44905ccd50b514004ce4ef5eb53640b9c0b71f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVar")
    def hue_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueToleranceVar"))

    @hue_tolerance_var.setter
    def hue_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a072a3fc38267b68c2c44796a6dd98acf3adf114fc5fa08ffcbc84a10efb7528)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d0ad37b1fb1ccec42dca8afd9c7b969beb296c3dd9cabbd6738020e11955dd50)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeather")
    def lightness_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeather"))

    @lightness_feather.setter
    def lightness_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f5f4aa2f835b0dc9a87f12997664d3dc373d9e8aa264a6b837a3163b0df0b69d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeather", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVar")
    def lightness_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeatherVar"))

    @lightness_feather_var.setter
    def lightness_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bde445343944048b92e057fe416e626eef3c91bbc235db48c851496af7ef85ae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessTolerance")
    def lightness_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessTolerance"))

    @lightness_tolerance.setter
    def lightness_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__91e8776866e85d101eef29c10647c6317b76512a106108b3b51bd1b410538ee5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVar")
    def lightness_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessToleranceVar"))

    @lightness_tolerance_var.setter
    def lightness_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__84f09a03ad06c840af94aad697e37df24f7d620c5d0ba1b54dd123d9409e8658)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeather")
    def saturation_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeather"))

    @saturation_feather.setter
    def saturation_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b5ca95e195e626fc5a262dff39822079036ed250deb196c51556b9cbee8cb507)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeather", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVar")
    def saturation_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeatherVar"))

    @saturation_feather_var.setter
    def saturation_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__460beba263bab04adf218b6435010072d85eb8461cd6694205e1b3441baaa96b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationTolerance")
    def saturation_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationTolerance"))

    @saturation_tolerance.setter
    def saturation_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f8effb6a03b68a630a61eb5977e7f80395b9ccc822979b499c6c01bc0153ae38)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVar")
    def saturation_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationToleranceVar"))

    @saturation_tolerance_var.setter
    def saturation_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__97437583be7797371711c39d6160876cc8d85b9bf457c79f99bf13be264d3afc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsChromaKey]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsChromaKey]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsChromaKey]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__345fe5e6e27a5397df558a1e1f39ae3aa1f4215fe02990d91df60dae43569c2c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsComposite",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "placement": "placement",
        "placement_var": "placementVar",
        "scale": "scale",
        "scale_dimension": "scaleDimension",
        "scale_dimension_var": "scaleDimensionVar",
        "scale_var": "scaleVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsComposite:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsCompositeImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        placement: typing.Optional[builtins.str] = None,
        placement_var: typing.Optional[builtins.str] = None,
        scale: typing.Optional[builtins.str] = None,
        scale_dimension: typing.Optional[builtins.str] = None,
        scale_dimension_var: typing.Optional[builtins.str] = None,
        scale_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param placement: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        :param placement_var: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        :param scale: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param scale_dimension: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        :param scale_dimension_var: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        :param scale_var: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        :param x_position: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsCompositeImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__61737aa7d69ee182d368b58741baf74da7fdb5b72f96c9449307316eb88a82f4)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument placement", value=placement, expected_type=type_hints["placement"])
            check_type(argname="argument placement_var", value=placement_var, expected_type=type_hints["placement_var"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument scale_dimension", value=scale_dimension, expected_type=type_hints["scale_dimension"])
            check_type(argname="argument scale_dimension_var", value=scale_dimension_var, expected_type=type_hints["scale_dimension_var"])
            check_type(argname="argument scale_var", value=scale_var, expected_type=type_hints["scale_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if placement is not None:
            self._values["placement"] = placement
        if placement_var is not None:
            self._values["placement_var"] = placement_var
        if scale is not None:
            self._values["scale"] = scale
        if scale_dimension is not None:
            self._values["scale_dimension"] = scale_dimension
        if scale_dimension_var is not None:
            self._values["scale_dimension_var"] = scale_dimension_var
        if scale_var is not None:
            self._values["scale_var"] = scale_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsCompositeImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsCompositeImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        '''
        result = self._values.get("placement")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement_var(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        '''
        result = self._values.get("placement_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        '''
        result = self._values.get("scale_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        '''
        result = self._values.get("scale_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        '''
        result = self._values.get("scale_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsComposite(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsCompositeImage",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsCompositeImage:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsCompositeImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsCompositeImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsCompositeImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b15455e8da92b00791b0d669145608944f4b74dba69450eb82c483794d0477e0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsCompositeImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsCompositeImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9f75b774e362d9a0a0aaa68e3104c8738453331282b0ead13a0e1de97ade0aa4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsCompositeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsCompositeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5156bed4969371720a88bfc7e94ca18a038816cf9f0a23581e88231b0dfaa4d9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsCompositeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b5bc91f4a667341b9d2d71b2e5b676b0f5c8885b32b569472d7186b2f434c6b8)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsCompositeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b974539fb9c09fee9425aebc7f89a94a5e79b1e6e08ec70b8fa4b52359d283c9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5bb88751ab9d03b7b7a80abd17958726b599f1f0246f009f100f1100310766b1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__399782bab81b24aaad2d70bec0de964cfa0d0beba13d3596e312f87f8e376277)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsComposite]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsComposite]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__228dbcc714b4c29cce6d2ae4b6a7e8a48fca33c85757d0d6537550349fed705a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsCompositeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsCompositeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a7f5f6c498d517baaf18bf0c01eddc895bd3e9aae621055dee42fc357b453b7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsCompositeImage()

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPlacement")
    def reset_placement(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacement", []))

    @jsii.member(jsii_name="resetPlacementVar")
    def reset_placement_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacementVar", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetScaleDimension")
    def reset_scale_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimension", []))

    @jsii.member(jsii_name="resetScaleDimensionVar")
    def reset_scale_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimensionVar", []))

    @jsii.member(jsii_name="resetScaleVar")
    def reset_scale_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsCompositeImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsCompositeImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsCompositeImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="placementInput")
    def placement_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementInput"))

    @builtins.property
    @jsii.member(jsii_name="placementVarInput")
    def placement_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionInput")
    def scale_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVarInput")
    def scale_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleVarInput")
    def scale_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f90a23d216d583998782c241f4fd3e91afcb8ed6c420a3eade35610e8e21c76b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a8ae407a448d9d99427620580ddae815f9640c9ca11a2c8cfdb1a7b95dd25bd2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="placement")
    def placement(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placement"))

    @placement.setter
    def placement(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7e28cb599057a0780de0571b95b476fac24c8754c0c4a7526e9d49ca46b74852)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placement", value)

    @builtins.property
    @jsii.member(jsii_name="placementVar")
    def placement_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placementVar"))

    @placement_var.setter
    def placement_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4b230befefed3423c71453a54cf1571e0aadfb38d1f359064b9443ea9fea8757)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placementVar", value)

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scale"))

    @scale.setter
    def scale(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b649d9fa967ea651df5df680b5b42bb1d84fc07b1d868bdf80b45d2a7840e0f1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scale", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimension")
    def scale_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimension"))

    @scale_dimension.setter
    def scale_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__98d5266ac9024cc4f372f4cbcac73c218ce301ba50a552f527538214c5607fba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimension", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVar")
    def scale_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimensionVar"))

    @scale_dimension_var.setter
    def scale_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__662dd560e525d7b94d769e9c03cfe7b6613021b58059763bcf4563d1d90487de)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="scaleVar")
    def scale_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleVar"))

    @scale_var.setter
    def scale_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__014351366451abb878f070a314cc25609b3c61bb5a1f2f2177e0ea3302842206)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a18825f7067784ab3ccfc9808be13f9360ac103f4e3d04e61cbdf87aa2d05cd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__305715e1e88f0fe83ee945facd87a9499ae248a964431d4efc2c25c759d612a0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__02100b622e2073bc58d07611979183bda3026c711f8104aca985f61b0b8a5bf2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__950c3a0dacc3f638edfebe9d52cef0d6c0bef0adb675f7a8aafb8fce64e34301)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsComposite]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsComposite]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsComposite]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6b87b5b642d347cd295e941458b43b0379db64d212dbf0da9b6ccd0792560113)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsCompound",
    jsii_struct_bases=[],
    name_mapping={"transformations": "transformations"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsCompound:
    def __init__(
        self,
        *,
        transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param transformations: transformations block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2fb951fd716da617c93a70a944a2692a39131bfea6d0f05671a52876c17227d5)
            check_type(argname="argument transformations", value=transformations, expected_type=type_hints["transformations"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if transformations is not None:
            self._values["transformations"] = transformations

    @builtins.property
    def transformations(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsCompoundTransformations"]]]:
        '''transformations block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        result = self._values.get("transformations")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsCompoundTransformations"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsCompound(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsCompoundList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsCompoundList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__19ac4bebe249c892fe568b7f96c2719e1d524537a0a25c70ff72aac9e27c5a66)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsCompoundOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea0137cee092095ef7d7e414d57bec9ae4552ec873d7b01e9be1e1f53a1c9fa7)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsCompoundOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__28bc657d935b70b7ee910348aa053c1d536c085f75f577bee14582c726227e97)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d9fbbd6f41ebd25f092bce27bcf21d93e8e48151e50fd2a5f0ec8b64886e59d4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f5c8e4f24f8c6cad54ae16ce592a3aa1c74b54e76b65e142ed49d0e2df68be1b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsCompound]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsCompound]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__02335ef1b4da1ae760dc7597dcae3920f5dc645e7f037259eab1cbcc51646488)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsCompoundOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsCompoundOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__11f95ce012d7ae5b6ade8799dcb7eb83355ecb5cd22b6ec1fa2b35736d5af5fb)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformations")
    def put_transformations(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6ef7976dbba143fbebc6c0518be53cfa820a836dd60d15aaef5db530159a8da6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTransformations", [value]))

    @jsii.member(jsii_name="resetTransformations")
    def reset_transformations(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformations", []))

    @builtins.property
    @jsii.member(jsii_name="transformations")
    def transformations(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsCompoundTransformationsList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsCompoundTransformationsList", jsii.get(self, "transformations"))

    @builtins.property
    @jsii.member(jsii_name="transformationsInput")
    def transformations_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsCompoundTransformations"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsCompoundTransformations"]]], jsii.get(self, "transformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsCompound]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsCompound]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsCompound]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__486475fda19497ffe49507500340001ed105bf0b7b254dc661645bfb423ccf56)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsCompoundTransformations",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsCompoundTransformations:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsCompoundTransformations(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsCompoundTransformationsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsCompoundTransformationsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4718183a03cdd8f245e02d9ba0975eba719b34700a73ce10d8e853c2daec3c1d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsCompoundTransformationsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab5a947c32c23d1b738a2b04d4908ac379c0a234b3df7a3e3effc8603580e187)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsCompoundTransformationsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e54bb88f2a2339774b421127941e2bf94f49f7bedea0b9f5982de012a14079f6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d03429948704f7fe320062f8093f16d39066d0b2d4b5d363608a103a1ac8d9cd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ca8aeca93886320a0537d59afc3506c5df3886f55629e76d1a65e77d705639ac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsCompoundTransformations]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsCompoundTransformations]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsCompoundTransformations]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ffd80dda6e08d74a30f71ba9d953128cf89b3bae9f573f54a28144fb91dd183d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsCompoundTransformationsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsCompoundTransformationsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2f741d948165b8b3ec893eb9309668275d5ede30dec5ee3539d531a66502571b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsCompoundTransformations]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsCompoundTransformations]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsCompoundTransformations]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e390f854c4bcb343a9b91381e7eccd820d8475c943047fba2291851fd092a992)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsContrast",
    jsii_struct_bases=[],
    name_mapping={
        "brightness": "brightness",
        "brightness_var": "brightnessVar",
        "contrast": "contrast",
        "contrast_var": "contrastVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsContrast:
    def __init__(
        self,
        *,
        brightness: typing.Optional[builtins.str] = None,
        brightness_var: typing.Optional[builtins.str] = None,
        contrast: typing.Optional[builtins.str] = None,
        contrast_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param brightness: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        :param brightness_var: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        :param contrast: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param contrast_var: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d7366dbfe7ba0b5cb289e8c95bf19b31631e297e6c381a50357f8bdb52c323cd)
            check_type(argname="argument brightness", value=brightness, expected_type=type_hints["brightness"])
            check_type(argname="argument brightness_var", value=brightness_var, expected_type=type_hints["brightness_var"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument contrast_var", value=contrast_var, expected_type=type_hints["contrast_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if brightness is not None:
            self._values["brightness"] = brightness
        if brightness_var is not None:
            self._values["brightness_var"] = brightness_var
        if contrast is not None:
            self._values["contrast"] = contrast
        if contrast_var is not None:
            self._values["contrast_var"] = contrast_var

    @builtins.property
    def brightness(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        '''
        result = self._values.get("brightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def brightness_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        '''
        result = self._values.get("brightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        result = self._values.get("contrast_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsContrast(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsContrastList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsContrastList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__054a1f6400223600717b262d4bafc5fb0a70cff574c502ceef4a0ee6ba08af25)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsContrastOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f5cf0a0f7592edfda87c853d8251095add126f769343d8f1b99202660081fb5e)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsContrastOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6d6a4f14e152cc102db64f82a058f54ee1794fcd5c33b33a8c5242621d63f050)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e6a5ef44535eee674099d41157165f4feca3cbb369165eea0fac7896af02c952)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e66bee7e959a6d23bfecbf2681700ad859a51146a2df287bd4c1b05ff0dc554)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsContrast]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsContrast]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8b964fb6192d9bcd156f825fb421d59a52e7777a17efc8de55501f878097a631)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsContrastOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsContrastOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a6cf03fe3c772ec091a85593f6c40fffe319ec1f7fdf2ff86d466b8ffc42d54d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetBrightness")
    def reset_brightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightness", []))

    @jsii.member(jsii_name="resetBrightnessVar")
    def reset_brightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightnessVar", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetContrastVar")
    def reset_contrast_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrastVar", []))

    @builtins.property
    @jsii.member(jsii_name="brightnessInput")
    def brightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="brightnessVarInput")
    def brightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastVarInput")
    def contrast_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="brightness")
    def brightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightness"))

    @brightness.setter
    def brightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0e49a1a9eb7326b08f8d8359821d78ac94fa507a653147d2a387f26b820113a7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightness", value)

    @builtins.property
    @jsii.member(jsii_name="brightnessVar")
    def brightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightnessVar"))

    @brightness_var.setter
    def brightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac3011649a61aee9ea6d7b50231b498915001b91b727fe62da3897ee45d62a78)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrast"))

    @contrast.setter
    def contrast(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d37bf2cdfd68c692e2a465d513b0b82200257e9651138c2e9fc9b52f4aecf0f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrast", value)

    @builtins.property
    @jsii.member(jsii_name="contrastVar")
    def contrast_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrastVar"))

    @contrast_var.setter
    def contrast_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea3c3e3c7b68519d58a72614be9d555b59ffabe29f6b291089c27a25509927f2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrastVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsContrast]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsContrast]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsContrast]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__15cc139ec86a6aac1620031113669c35e5b21728ab4a20f9f6a6f16fcd0c6072)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsGoop",
    jsii_struct_bases=[],
    name_mapping={
        "chaos": "chaos",
        "chaos_var": "chaosVar",
        "density": "density",
        "density_var": "densityVar",
        "power": "power",
        "power_var": "powerVar",
        "seed": "seed",
        "seed_var": "seedVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsGoop:
    def __init__(
        self,
        *,
        chaos: typing.Optional[builtins.str] = None,
        chaos_var: typing.Optional[builtins.str] = None,
        density: typing.Optional[builtins.str] = None,
        density_var: typing.Optional[builtins.str] = None,
        power: typing.Optional[builtins.str] = None,
        power_var: typing.Optional[builtins.str] = None,
        seed: typing.Optional[builtins.str] = None,
        seed_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param chaos: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        :param chaos_var: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        :param density: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        :param density_var: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        :param power: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        :param power_var: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        :param seed: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        :param seed_var: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__99d777738d062c850cb9dc29e238b9d9849894b0d4d5c57ffdb10a28594da464)
            check_type(argname="argument chaos", value=chaos, expected_type=type_hints["chaos"])
            check_type(argname="argument chaos_var", value=chaos_var, expected_type=type_hints["chaos_var"])
            check_type(argname="argument density", value=density, expected_type=type_hints["density"])
            check_type(argname="argument density_var", value=density_var, expected_type=type_hints["density_var"])
            check_type(argname="argument power", value=power, expected_type=type_hints["power"])
            check_type(argname="argument power_var", value=power_var, expected_type=type_hints["power_var"])
            check_type(argname="argument seed", value=seed, expected_type=type_hints["seed"])
            check_type(argname="argument seed_var", value=seed_var, expected_type=type_hints["seed_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if chaos is not None:
            self._values["chaos"] = chaos
        if chaos_var is not None:
            self._values["chaos_var"] = chaos_var
        if density is not None:
            self._values["density"] = density
        if density_var is not None:
            self._values["density_var"] = density_var
        if power is not None:
            self._values["power"] = power
        if power_var is not None:
            self._values["power_var"] = power_var
        if seed is not None:
            self._values["seed"] = seed
        if seed_var is not None:
            self._values["seed_var"] = seed_var

    @builtins.property
    def chaos(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        '''
        result = self._values.get("chaos")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def chaos_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        '''
        result = self._values.get("chaos_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        '''
        result = self._values.get("density")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density_var(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        '''
        result = self._values.get("density_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        '''
        result = self._values.get("power")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power_var(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        '''
        result = self._values.get("power_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        '''
        result = self._values.get("seed")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed_var(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        result = self._values.get("seed_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsGoop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsGoopList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsGoopList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__02ef48f2e64d2edb74b0ace5ae680fcd8d5056978a1eb1a000dc85cdabb8016b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsGoopOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ddbbb28b451ea448e9fcd1f7a7212b9cd0576ddc04914baae8b3ccec13925d7)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsGoopOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a8a245018b9b2ca7ce1f5713d4cea09e8bb8aeea5fe2fc1f4868d4eab74a281e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__13485dd2bd416c40a3a563880e5bfdc4559815c4b3139f9caeb548118d627e21)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__38e27f24bc5b609636a85d9964dad8a3402648b36a8b73523c0725e916d9c644)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsGoop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsGoop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__683291736d9d52e7bbcf74b508825f56e9dcb3f150398bc1058ab6b9aea4df31)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsGoopOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsGoopOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c1a2224146764936406d5e64564edca1b8e89b8fd88c1a449edc8f988b2018fe)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetChaos")
    def reset_chaos(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaos", []))

    @jsii.member(jsii_name="resetChaosVar")
    def reset_chaos_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaosVar", []))

    @jsii.member(jsii_name="resetDensity")
    def reset_density(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensity", []))

    @jsii.member(jsii_name="resetDensityVar")
    def reset_density_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensityVar", []))

    @jsii.member(jsii_name="resetPower")
    def reset_power(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPower", []))

    @jsii.member(jsii_name="resetPowerVar")
    def reset_power_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPowerVar", []))

    @jsii.member(jsii_name="resetSeed")
    def reset_seed(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeed", []))

    @jsii.member(jsii_name="resetSeedVar")
    def reset_seed_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeedVar", []))

    @builtins.property
    @jsii.member(jsii_name="chaosInput")
    def chaos_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosInput"))

    @builtins.property
    @jsii.member(jsii_name="chaosVarInput")
    def chaos_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosVarInput"))

    @builtins.property
    @jsii.member(jsii_name="densityInput")
    def density_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityInput"))

    @builtins.property
    @jsii.member(jsii_name="densityVarInput")
    def density_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="powerInput")
    def power_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerInput"))

    @builtins.property
    @jsii.member(jsii_name="powerVarInput")
    def power_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerVarInput"))

    @builtins.property
    @jsii.member(jsii_name="seedInput")
    def seed_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedInput"))

    @builtins.property
    @jsii.member(jsii_name="seedVarInput")
    def seed_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedVarInput"))

    @builtins.property
    @jsii.member(jsii_name="chaos")
    def chaos(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaos"))

    @chaos.setter
    def chaos(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eaa678cee5cf8eccf1ae06efc75079c17c53794224fcc2994fa4a29706d6e982)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaos", value)

    @builtins.property
    @jsii.member(jsii_name="chaosVar")
    def chaos_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaosVar"))

    @chaos_var.setter
    def chaos_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__691cd2100ec4388cc09b6fe12d6d28d7961e0a83fb0937e4e4dbb847a42f61aa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaosVar", value)

    @builtins.property
    @jsii.member(jsii_name="density")
    def density(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "density"))

    @density.setter
    def density(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__159a318e5856845c42a4271d1621b332c0fab16c070f4310507ab48153d80702)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "density", value)

    @builtins.property
    @jsii.member(jsii_name="densityVar")
    def density_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "densityVar"))

    @density_var.setter
    def density_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__21b0e3b51b2893298e5964b428c1bf8c0d191fdcc06193db70d43c45c879ee54)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "densityVar", value)

    @builtins.property
    @jsii.member(jsii_name="power")
    def power(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "power"))

    @power.setter
    def power(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__db77ddce50b1a8e62b70df9986606f3692f4c676a4672bb2c7a121bdbe282242)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "power", value)

    @builtins.property
    @jsii.member(jsii_name="powerVar")
    def power_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "powerVar"))

    @power_var.setter
    def power_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac48d1f85d3f96d756b2e923596ccdc8f1cf479f691900969f1aaebffd15bc64)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "powerVar", value)

    @builtins.property
    @jsii.member(jsii_name="seed")
    def seed(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seed"))

    @seed.setter
    def seed(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8c458971b79dbf6dedae00d428eb826dd7d2f26a056de8524b07d15e0b024e6e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seed", value)

    @builtins.property
    @jsii.member(jsii_name="seedVar")
    def seed_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seedVar"))

    @seed_var.setter
    def seed_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__490c712b2bd2df7fc26d5480ac63153607a6dc279ad0341e4c034194219d2b42)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seedVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsGoop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsGoop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsGoop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9f2b18bc29ee2d9a96568eed537ae0a724279125f8647009f603b99cf9cce659)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsGrayscale",
    jsii_struct_bases=[],
    name_mapping={"type": "type", "type_var": "typeVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsGrayscale:
    def __init__(
        self,
        *,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param type: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b1460c9d8a103ca31cbf87002d4edad0ac795236df701536a71cb0117ebbe30a)
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsGrayscale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsGrayscaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsGrayscaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ff33ce8e93e2437c408ce54720425e99b45dc78075e8ef9a136535faa6f3b2ae)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsGrayscaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__28f063ea3d0998b8255e4372a2871037e663b617bc94dec23ca73fde0955c4fe)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsGrayscaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5e834c6649bad841734393e3b8f16393ac550c707dce9b6489c808d1db74f097)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a637e4d4bbfd1bd23e74d9101b8507cf2279518fe6e29946bd1b6e53befc35d7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__96e266e713143ffd473a755ed2566c12089d0f914d935276a3b74589d816ceb2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsGrayscale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsGrayscale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__97fa19af722f5fd2015eda9cfdb2a716d35b7c4bbddc4f4bbd732698863cdf87)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsGrayscaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsGrayscaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dcd77d028c1b09f10058d3122e2ca9fcacc7fda1a80c3fabedd0425261046cc0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c55068bef23d5e4ddbc06bfbf3249034e53d33d9de2c8a3a7389ee4997875c47)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__83313d57c2642d7c68c865cc3c4e4682f93b4efc0015505914fee84e858bd141)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsGrayscale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsGrayscale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsGrayscale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__330136e3bc0a38dbc1f7ebe759f0392aa7afa693d61d6c7897d1f96fd8e54f75)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsHsl",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "lightness": "lightness",
        "lightness_var": "lightnessVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsHsl:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness: typing.Optional[builtins.str] = None,
        lightness_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        :param lightness_var: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__408ada661eb5ab00e1a25119912afb0921550554725ecd5315b3b655eb6b1de9)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness", value=lightness, expected_type=type_hints["lightness"])
            check_type(argname="argument lightness_var", value=lightness_var, expected_type=type_hints["lightness_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness is not None:
            self._values["lightness"] = lightness
        if lightness_var is not None:
            self._values["lightness_var"] = lightness_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        '''
        result = self._values.get("lightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        '''
        result = self._values.get("lightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsHsl(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsHslList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsHslList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c1a4ca7fc6d16959c93d80d4e871ce28dfc0c5d6cf48c9cbbbf67a3b97251d52)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsHslOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__38bfeeca3269c44341742de98b889a4dcd28a32c5c9aed088d2fd37129b31d65)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsHslOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d17a0c281257fde555e967475064cea7e6c2f47879053d8c933e98f2a41364b7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__38854859639e9ce90624ab62846d46a259d87d329a0d38fa62052e2074d3107a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d845fa73760c9f9481e9f20ee5e90ced1679179de924de8d5f1e871ef57fbcf3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsHsl]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsHsl]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9c67097c576a2a4109271d446d50f630ba4a20167bd15631c1dd4e9966625f2c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsHslOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsHslOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5e68dcd33d756c8ea17981890fbcf46b96d9af7765f116a99fd05da4fd537e31)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightness")
    def reset_lightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightness", []))

    @jsii.member(jsii_name="resetLightnessVar")
    def reset_lightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessInput")
    def lightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessVarInput")
    def lightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e01656214543929a894bceae2ef6baed87f99aa34a4464ba400a3c55d5a983c0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a2649b21a80045d44050c427e664d0784f8e8ff9addfd64735a9615ee4ed6fc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightness")
    def lightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightness"))

    @lightness.setter
    def lightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a99607eba8c9f1573e853d4447e9c3c56837d207e110fa1919ea4681ea402eb3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightness", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessVar")
    def lightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessVar"))

    @lightness_var.setter
    def lightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f60760ce29d2d9d8dc1172e4ec4a7791be7dc56f44b68b80c706ae95bb3621a4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a6cd90f4404410841f9ecc0054ee842aa324c6e832b7ac7d3370f90471168c8e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3b5d4fe17292d5728d726dcdaae3f57cc237ff24973ebf5e926b9d9b86ef6ea0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsHsl]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsHsl]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsHsl]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__68ced46a27c307043009ca90f8e35da6f6ceda883dfbecb248813977d4785372)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsHsv",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsHsv:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        :param value: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bea5e7c3e0d16e62b73a6341419e24c1a77743903e2688237d913a235c1403fc)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsHsv(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsHsvList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsHsvList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b07801143b35a6389c2cdf96902b001509a1b517cc51362c747cc46967865c0f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsHsvOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__59d1889082daf64be06216be77b4fa30dc9f8798dfe03ea59c0475cf82247f9d)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsHsvOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb9fe110e9ba0139e5ff8bb2718f1f30784382b821c85199c744b0d940205b39)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f4d03dce06434f685fcdb8d4e4048679edf8d87612f08f70a137494fe66ab81e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2c6a067f8a91c71cb398a56432c217f238275ed3a92f66c6426a77d70435b299)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsHsv]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsHsv]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3d584ecee9db2eaaee5ef9ab41f6a4200e2d545161d0e254ea62dc45dd5ac6c5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsHsvOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsHsvOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__37ac2dccf3e92b4eabb85e723349627e0ec8d2146455cd3fa707a38bf8407119)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__65305436546640cdac331b03fd72ad0d7583c4868f480a3e31cafeb482a98f00)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d9a06c65a13e8e0f250103360bc82ce8f713a45a0faf164d85dc307b39407e0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__504076737db4ffeef0b9b152ce62e3ef46be0c75ee8aabbf6478e971927ef732)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a3bc7cc4f37f5efcbdfe6b85edd47e3a0c58dae66001fd7cee6fe1fbc0b150e9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__94cc9c6896398f98dc13984733b76c2f338077a9410125e612dea84377b32437)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0994c59fc682df61a8dbdf8b92362b80715b87ac5fdc5975baf07b803daac179)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsHsv]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsHsv]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsHsv]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__36d42ba3e1a36285b5d2050f79d548608578f0e81c0a7b436ad47d54ed4b9912)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfDimension",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "dimension": "dimension",
        "dimension_var": "dimensionVar",
        "equal": "equal",
        "greater_than": "greaterThan",
        "less_than": "lessThan",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfDimension:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfDimensionDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        dimension: typing.Optional[builtins.str] = None,
        dimension_var: typing.Optional[builtins.str] = None,
        equal: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfDimensionEqual", typing.Dict[builtins.str, typing.Any]]] = None,
        greater_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfDimensionGreaterThan", typing.Dict[builtins.str, typing.Any]]] = None,
        less_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfDimensionLessThan", typing.Dict[builtins.str, typing.Any]]] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param dimension: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        :param dimension_var: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        :param equal: equal block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        :param greater_than: greater_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        :param less_than: less_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        :param value: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfDimensionDefault(**default)
        if isinstance(equal, dict):
            equal = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfDimensionEqual(**equal)
        if isinstance(greater_than, dict):
            greater_than = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfDimensionGreaterThan(**greater_than)
        if isinstance(less_than, dict):
            less_than = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfDimensionLessThan(**less_than)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__75e252db49256de39d6cb827fc9a598af759f10f3b4f2f9f129f0781d4c7e994)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument dimension", value=dimension, expected_type=type_hints["dimension"])
            check_type(argname="argument dimension_var", value=dimension_var, expected_type=type_hints["dimension_var"])
            check_type(argname="argument equal", value=equal, expected_type=type_hints["equal"])
            check_type(argname="argument greater_than", value=greater_than, expected_type=type_hints["greater_than"])
            check_type(argname="argument less_than", value=less_than, expected_type=type_hints["less_than"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if dimension is not None:
            self._values["dimension"] = dimension
        if dimension_var is not None:
            self._values["dimension_var"] = dimension_var
        if equal is not None:
            self._values["equal"] = equal
        if greater_than is not None:
            self._values["greater_than"] = greater_than
        if less_than is not None:
            self._values["less_than"] = less_than
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfDimensionDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfDimensionDefault"], result)

    @builtins.property
    def dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        '''
        result = self._values.get("dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        '''
        result = self._values.get("dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def equal(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfDimensionEqual"]:
        '''equal block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        '''
        result = self._values.get("equal")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfDimensionEqual"], result)

    @builtins.property
    def greater_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfDimensionGreaterThan"]:
        '''greater_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        '''
        result = self._values.get("greater_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfDimensionGreaterThan"], result)

    @builtins.property
    def less_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfDimensionLessThan"]:
        '''less_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        '''
        result = self._values.get("less_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfDimensionLessThan"], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfDimension(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfDimensionDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfDimensionDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfDimensionDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfDimensionDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfDimensionDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7c50fe725481baf13e3e20ee59f3bba2c16afa38b86408dab4eef829612f20fb)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfDimensionDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfDimensionDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c011b975f3c83c59fc802e02678e9feaf953da66ca1e3029a2a9c2242ced500d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfDimensionEqual",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfDimensionEqual:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfDimensionEqual(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfDimensionEqualOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfDimensionEqualOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__87acb2cd0dc2f3b9a0e7e611c91be8e5c06758656fa6f2eac177d2cad280e174)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfDimensionEqual], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfDimensionEqual],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__488223990003cc027db03ed95be89f52c937235bd0daf5fc919cb453de7ceaea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfDimensionGreaterThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfDimensionGreaterThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfDimensionGreaterThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfDimensionGreaterThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfDimensionGreaterThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7e721d66994bfed8f1a39a29c18f120e50ef5dd9619be1bd640cedb15b1dd953)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfDimensionGreaterThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfDimensionGreaterThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a823872fdcf69b7e1e395d9ef26d4c36f0d8d17512e6a2a32dd495e79d24e3f9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfDimensionLessThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfDimensionLessThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfDimensionLessThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfDimensionLessThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfDimensionLessThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__063d560195024ba473f4608f0d8e597f20e6016ef4af74d52b9ba013492b14a8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfDimensionLessThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfDimensionLessThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a39d3dd999336637631c0fd50a167a1cd006f5085662565ff8b0178b4d118f3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfDimensionList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfDimensionList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aa951af7aea88c058594e37c25092c13a508be23b4c70a9e72b2edc87ad3d9af)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfDimensionOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5300f3fc348e1f24005f63f265495affa22205f9ecf19ac686f87dda56405597)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfDimensionOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c0ff720cdd7a972a8a9d5ca727158cf1cd6c9eb676bb38cf51238d3769cee333)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7b683caed4e50613a2e5b6f64d835be12f92c8171d89be031d5aa1fb4f7c5faf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ec5d5d0ea4a70bbfba41b8c06f66c90cecf763783d5135c611c0f75fd6f7e569)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfDimension]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfDimension]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ea0f1afd94f0fa839a75ccd3cd983d7d9b70b475de281df810115f19daf1e2d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfDimensionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfDimensionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b8560be268a5729e1e78f19001d567193ce2026628051582b581abdb4f7e14c0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfDimensionDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putEqual")
    def put_equal(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfDimensionEqual()

        return typing.cast(None, jsii.invoke(self, "putEqual", [value]))

    @jsii.member(jsii_name="putGreaterThan")
    def put_greater_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfDimensionGreaterThan()

        return typing.cast(None, jsii.invoke(self, "putGreaterThan", [value]))

    @jsii.member(jsii_name="putLessThan")
    def put_less_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfDimensionLessThan()

        return typing.cast(None, jsii.invoke(self, "putLessThan", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetDimension")
    def reset_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimension", []))

    @jsii.member(jsii_name="resetDimensionVar")
    def reset_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimensionVar", []))

    @jsii.member(jsii_name="resetEqual")
    def reset_equal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEqual", []))

    @jsii.member(jsii_name="resetGreaterThan")
    def reset_greater_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGreaterThan", []))

    @jsii.member(jsii_name="resetLessThan")
    def reset_less_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLessThan", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfDimensionDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfDimensionDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="equal")
    def equal(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfDimensionEqualOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfDimensionEqualOutputReference, jsii.get(self, "equal"))

    @builtins.property
    @jsii.member(jsii_name="greaterThan")
    def greater_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfDimensionGreaterThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfDimensionGreaterThanOutputReference, jsii.get(self, "greaterThan"))

    @builtins.property
    @jsii.member(jsii_name="lessThan")
    def less_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfDimensionLessThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfDimensionLessThanOutputReference, jsii.get(self, "lessThan"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfDimensionDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionInput")
    def dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionVarInput")
    def dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="equalInput")
    def equal_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfDimensionEqual], jsii.get(self, "equalInput"))

    @builtins.property
    @jsii.member(jsii_name="greaterThanInput")
    def greater_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfDimensionGreaterThan], jsii.get(self, "greaterThanInput"))

    @builtins.property
    @jsii.member(jsii_name="lessThanInput")
    def less_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfDimensionLessThan], jsii.get(self, "lessThanInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="dimension")
    def dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimension"))

    @dimension.setter
    def dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1699690af42802b0faafd85b1c3ad6a68df523442739110128ced9ddc0960c65)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimension", value)

    @builtins.property
    @jsii.member(jsii_name="dimensionVar")
    def dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimensionVar"))

    @dimension_var.setter
    def dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d568bc4a6ea625ed69b0080c48ebba0f5c7b0d14b5ec7a9735eb617c7f8e6d2f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f01dca14551b3c87486be9ada262e4e1f61bc05a2c0d5e29593047ba95286cc0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f696a132a9eddb1b27ff6e02fd3f4610ac08c4278279d7ad28dc53c7f4749f3c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfDimension]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfDimension]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfDimension]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e35eb33c048cc371be4ef44f04c9433e04351e1fb28f2a6c2f54723a1385b1a6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfOrientation",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "landscape": "landscape",
        "portrait": "portrait",
        "square": "square",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfOrientation:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfOrientationDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        landscape: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfOrientationLandscape", typing.Dict[builtins.str, typing.Any]]] = None,
        portrait: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfOrientationPortrait", typing.Dict[builtins.str, typing.Any]]] = None,
        square: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfOrientationSquare", typing.Dict[builtins.str, typing.Any]]] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param landscape: landscape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        :param portrait: portrait block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        :param square: square block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfOrientationDefault(**default)
        if isinstance(landscape, dict):
            landscape = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfOrientationLandscape(**landscape)
        if isinstance(portrait, dict):
            portrait = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfOrientationPortrait(**portrait)
        if isinstance(square, dict):
            square = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfOrientationSquare(**square)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5cbd5ec43fe04a9cc2b771cbdefef6658a6c02213201f7b46a95775ce4b2bdd9)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument landscape", value=landscape, expected_type=type_hints["landscape"])
            check_type(argname="argument portrait", value=portrait, expected_type=type_hints["portrait"])
            check_type(argname="argument square", value=square, expected_type=type_hints["square"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if landscape is not None:
            self._values["landscape"] = landscape
        if portrait is not None:
            self._values["portrait"] = portrait
        if square is not None:
            self._values["square"] = square

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfOrientationDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfOrientationDefault"], result)

    @builtins.property
    def landscape(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfOrientationLandscape"]:
        '''landscape block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        '''
        result = self._values.get("landscape")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfOrientationLandscape"], result)

    @builtins.property
    def portrait(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfOrientationPortrait"]:
        '''portrait block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        '''
        result = self._values.get("portrait")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfOrientationPortrait"], result)

    @builtins.property
    def square(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfOrientationSquare"]:
        '''square block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        result = self._values.get("square")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfOrientationSquare"], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfOrientation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfOrientationDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfOrientationDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfOrientationDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfOrientationDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfOrientationDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8b17d3f41f339caaffbe18e1ca717ce65945c093c282f4021bd2835d21f5f73c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfOrientationDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfOrientationDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__143cddf3ddee3be026f7f0a93973c7e44ac223db96633540d0ae9aa93f133f7e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfOrientationLandscape",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfOrientationLandscape:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfOrientationLandscape(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfOrientationLandscapeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfOrientationLandscapeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fba84228034284cdeb8a79c85d0e16b7f268e33e59af68d2dcac231eeecc4ecd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfOrientationLandscape], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfOrientationLandscape],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d9d737fd05c2460f69db94f239162185e65fb5e7513e5e5403d7afae637bf14e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfOrientationList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfOrientationList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7f6abd2343b81c8a7e9fc17af801bdac2b6849134274a27fff5472754719e80a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfOrientationOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0034c0cfc27bdef37093575c008554626c5271b30eb3d81d99d48a2efca4656b)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfOrientationOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__57549e66ba55a5ee970367a1890f0bb5ca2528b5bf47db49e45786e5a535bd35)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__04690822ccdaa89aaad9bb54bc9793908eb053837167e2d3b0221173259f1492)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc202c5e51e07ac6c2cae85bc29af7be7a7c399a76bae416140802901a78928a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfOrientation]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfOrientation]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7916556afa70e2c95bfcd559ba7127ff854ffc7d38d513919a20b2c0e4ac95f5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfOrientationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfOrientationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0bf166f5e0464e8d14b8fea9634e925bb7a4cd15fccf635b3ab32213dc8a91e1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfOrientationDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putLandscape")
    def put_landscape(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfOrientationLandscape()

        return typing.cast(None, jsii.invoke(self, "putLandscape", [value]))

    @jsii.member(jsii_name="putPortrait")
    def put_portrait(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfOrientationPortrait()

        return typing.cast(None, jsii.invoke(self, "putPortrait", [value]))

    @jsii.member(jsii_name="putSquare")
    def put_square(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfOrientationSquare()

        return typing.cast(None, jsii.invoke(self, "putSquare", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetLandscape")
    def reset_landscape(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLandscape", []))

    @jsii.member(jsii_name="resetPortrait")
    def reset_portrait(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPortrait", []))

    @jsii.member(jsii_name="resetSquare")
    def reset_square(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSquare", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfOrientationDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfOrientationDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="landscape")
    def landscape(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfOrientationLandscapeOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfOrientationLandscapeOutputReference, jsii.get(self, "landscape"))

    @builtins.property
    @jsii.member(jsii_name="portrait")
    def portrait(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfOrientationPortraitOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfOrientationPortraitOutputReference", jsii.get(self, "portrait"))

    @builtins.property
    @jsii.member(jsii_name="square")
    def square(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfOrientationSquareOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfOrientationSquareOutputReference", jsii.get(self, "square"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfOrientationDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="landscapeInput")
    def landscape_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfOrientationLandscape], jsii.get(self, "landscapeInput"))

    @builtins.property
    @jsii.member(jsii_name="portraitInput")
    def portrait_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfOrientationPortrait"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfOrientationPortrait"], jsii.get(self, "portraitInput"))

    @builtins.property
    @jsii.member(jsii_name="squareInput")
    def square_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfOrientationSquare"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfOrientationSquare"], jsii.get(self, "squareInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfOrientation]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfOrientation]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfOrientation]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e09de157a8c3d9d0817bb314fde33d5756bab587edc4a7edc5e18169c44bcab7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfOrientationPortrait",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfOrientationPortrait:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfOrientationPortrait(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfOrientationPortraitOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfOrientationPortraitOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__94362526fb1e1c69e8eb4cfa7550881d5391878246e573ccca9a7d577dbbea9e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfOrientationPortrait]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfOrientationPortrait], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfOrientationPortrait],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1e553d1cf3207e590ef8ad700e2799311e3086eeb65ae10e8ba8e35683dfddae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfOrientationSquare",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfOrientationSquare:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfOrientationSquare(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfOrientationSquareOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfOrientationSquareOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7be2176e69a9b588d24c5a20bb267aa7f8552f3cf08f1cf729a5fb201965d4d6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfOrientationSquare]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfOrientationSquare], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfOrientationSquare],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a31259649384757a6b25e23f860e4425f6d31383d490924da69d87e97cbdf99)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a31b900bd21a8b539b2f07abe1734e68f78d26d9e79f1daa27f070ea877722a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__21bcd4b8d697b319e9ce3e35186a43546f234c5e9c33affb8e1c670402bf2422)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__26abbcf2ecd8fd804325a93df746ec165ab993d41f3eda50cba969abfeab7cf2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fb18d13dd0afdb7445d20c1fd42c342e6f496f42f334228baffd9a257627a4cb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b0729087f5c71569b68d982f95733da745fc60d61fc94b18c3f75d3dc77e3abc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformations]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformations]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformations]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4d63e075bc507c2567151da7822e35f86d8ebb8641e581e2825893c8541c3e73)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsMaxColors",
    jsii_struct_bases=[],
    name_mapping={"colors": "colors", "colors_var": "colorsVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsMaxColors:
    def __init__(
        self,
        *,
        colors: typing.Optional[builtins.str] = None,
        colors_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param colors: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        :param colors_var: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4f94825f1c17cb1128087ae9e5ee5e0a9d57576700116d94ad8d17d63cf09617)
            check_type(argname="argument colors", value=colors, expected_type=type_hints["colors"])
            check_type(argname="argument colors_var", value=colors_var, expected_type=type_hints["colors_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if colors is not None:
            self._values["colors"] = colors
        if colors_var is not None:
            self._values["colors_var"] = colors_var

    @builtins.property
    def colors(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        '''
        result = self._values.get("colors")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def colors_var(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        result = self._values.get("colors_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsMaxColors(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsMaxColorsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsMaxColorsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a13ba9531a942b0585d662d996d78bd316c7bd360f99aaa25e86946b282a9f76)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsMaxColorsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ec780e46925f2676a9c1f1933fcfaf3ef06d0dac629e4ea8385bcdf557d6db3d)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsMaxColorsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__93af304150ce8756fbe860634e988bbbb360cb895c3b17ee7a0b9a83f1e7a239)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a57d0e60c4c5e7cb60c43a8e0598322178f8e33fb29709c35f81f54059502b34)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f97b2a7b4d50481285a996aeb920a93e85fa6c8ba711f9dd865d03cc933d053)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsMaxColors]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsMaxColors]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__04722e4ef37e5d1eafb4868dfd39d369b773a7c7aeb69bbde686090741828173)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsMaxColorsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsMaxColorsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd060a76e6a26abcad85d05154db8c823da16f358e0ddfdfa2acafd865410960)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColors")
    def reset_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColors", []))

    @jsii.member(jsii_name="resetColorsVar")
    def reset_colors_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorsVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorsInput")
    def colors_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsInput"))

    @builtins.property
    @jsii.member(jsii_name="colorsVarInput")
    def colors_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsVarInput"))

    @builtins.property
    @jsii.member(jsii_name="colors")
    def colors(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colors"))

    @colors.setter
    def colors(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f53dafb84f9022703b2126c643a15a270cdc34d5f2d350c9dd9902d60366d8b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colors", value)

    @builtins.property
    @jsii.member(jsii_name="colorsVar")
    def colors_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorsVar"))

    @colors_var.setter
    def colors_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d272592d9df199cdac6e3bfd3ab1d5762b49aba7314bf6dca710ca7baec5c42)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorsVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsMaxColors]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsMaxColors]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsMaxColors]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb32a2f6f0b83abd4ced147b69cf2828aceac11e925867c0be4a9d04163ef78a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsMirror",
    jsii_struct_bases=[],
    name_mapping={
        "horizontal": "horizontal",
        "horizontal_var": "horizontalVar",
        "vertical": "vertical",
        "vertical_var": "verticalVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsMirror:
    def __init__(
        self,
        *,
        horizontal: typing.Optional[builtins.str] = None,
        horizontal_var: typing.Optional[builtins.str] = None,
        vertical: typing.Optional[builtins.str] = None,
        vertical_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param horizontal: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        :param horizontal_var: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        :param vertical: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        :param vertical_var: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__74658fbdfcc1211255d8ee8e777c815cb49593822278092afeb585f18225aca6)
            check_type(argname="argument horizontal", value=horizontal, expected_type=type_hints["horizontal"])
            check_type(argname="argument horizontal_var", value=horizontal_var, expected_type=type_hints["horizontal_var"])
            check_type(argname="argument vertical", value=vertical, expected_type=type_hints["vertical"])
            check_type(argname="argument vertical_var", value=vertical_var, expected_type=type_hints["vertical_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if horizontal is not None:
            self._values["horizontal"] = horizontal
        if horizontal_var is not None:
            self._values["horizontal_var"] = horizontal_var
        if vertical is not None:
            self._values["vertical"] = vertical
        if vertical_var is not None:
            self._values["vertical_var"] = vertical_var

    @builtins.property
    def horizontal(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        '''
        result = self._values.get("horizontal")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def horizontal_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        '''
        result = self._values.get("horizontal_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        '''
        result = self._values.get("vertical")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        result = self._values.get("vertical_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsMirror(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsMirrorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsMirrorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5a8856284e29579a50c497f3696befca36212d5445aed7f0c364a8848e6b22b2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsMirrorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b2048151e0a1c80e5a576d36c5dd2e74a84c8d6081f354aaab0d316a73ed70df)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsMirrorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d2ecbd53edac983e6e3032d91acfdbf49e24a1ba8706ad1be9e0991e3e10ceb7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e5a912b9720841806d3e2745f4619a0a65f3fb86849b0edd1159644f028746ca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3c45458ab41d19b30c4a19621cbd9b7debac86d0bbdfc163f93edc1f21127182)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsMirror]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsMirror]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f0caeb03b1f843be8ab16d3f767023eef7cd9acc9e6df5f3cfeef5fb1e5c2de)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsMirrorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsMirrorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c51a5f6f697ae1828067fb8a5dee28482f5929622260c11701eb710349a821d0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHorizontal")
    def reset_horizontal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontal", []))

    @jsii.member(jsii_name="resetHorizontalVar")
    def reset_horizontal_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontalVar", []))

    @jsii.member(jsii_name="resetVertical")
    def reset_vertical(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVertical", []))

    @jsii.member(jsii_name="resetVerticalVar")
    def reset_vertical_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVerticalVar", []))

    @builtins.property
    @jsii.member(jsii_name="horizontalInput")
    def horizontal_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontalVarInput")
    def horizontal_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalInput")
    def vertical_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalVarInput")
    def vertical_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontal")
    def horizontal(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontal"))

    @horizontal.setter
    def horizontal(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d69f799a574bf6bbec8c347c1b869051a425354937a384c80b8e346175d29d64)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontal", value)

    @builtins.property
    @jsii.member(jsii_name="horizontalVar")
    def horizontal_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontalVar"))

    @horizontal_var.setter
    def horizontal_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__da32e9550e5d6e2a9f9464a67172f6cbccef33566b97e3f6c94b35a8c0f3e72b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontalVar", value)

    @builtins.property
    @jsii.member(jsii_name="vertical")
    def vertical(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "vertical"))

    @vertical.setter
    def vertical(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f6b506a68a7e2e56404e122cc6588a10c4811a9946ebd3168ee927a47b6582f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "vertical", value)

    @builtins.property
    @jsii.member(jsii_name="verticalVar")
    def vertical_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "verticalVar"))

    @vertical_var.setter
    def vertical_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__817d999b4c69755bed6e13c1bf666a1d3c505cfd067c3a86606cd0fb82fd2f2d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "verticalVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsMirror]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsMirror]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsMirror]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e2bab851896ebcf8c39f01943e9634274e872635c4747812482c35825bc4dd44)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsMonoHue",
    jsii_struct_bases=[],
    name_mapping={"hue": "hue", "hue_var": "hueVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsMonoHue:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b4994950e438079072c0f1058d324a6865edf4d4c07fab846baef55aa6bd0a7f)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsMonoHue(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsMonoHueList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsMonoHueList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__944baef387b432b79395ca13b4ae9b572211907969845fdf191abebad983c5c7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsMonoHueOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f5bb55291a6b64ee9c432d70e7730bc1fa6672c107c50bb3f6385d6f3597496d)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsMonoHueOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bf7f5ec1d75489708b3ef34f5447db0a04bb4dd361503433404274848a23e02b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__39bbb2bbcc9bcd8ca8447893428f2cc0c9191d9194c50ecf052405f7138cb1b6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cc2061b0e03333e2c81f1c51fd3a3e3a4643da8904dace3e83e0daadc3478e85)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsMonoHue]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsMonoHue]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__31fd34b490c41c4eb5f02b8ddebbebfe89f570f5d0d3811166e6ecf0feba4890)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsMonoHueOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsMonoHueOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f99cc3aef4104b796c50997c22f382da546b998e4566637327728eec945965a6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2c9753b0b9786f3bd118705dd2468bc700878b9b5c3a322d5c14c6eebc9b571e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__22183e9a623a8ae6256951a87ef80ed6e025e67ece7c601289d6339e800ca9bb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsMonoHue]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsMonoHue]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsMonoHue]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3664f80f00aeae027945fd6547aa6d1845789c98d4115179c6c1e63c5ab0dc61)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsOpacity",
    jsii_struct_bases=[],
    name_mapping={"opacity": "opacity", "opacity_var": "opacityVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsOpacity:
    def __init__(
        self,
        *,
        opacity: typing.Optional[builtins.str] = None,
        opacity_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param opacity: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param opacity_var: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__29328fdcdb06e246114936d80e9bda6c751b41560464d2b76d211ca28e81837a)
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument opacity_var", value=opacity_var, expected_type=type_hints["opacity_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if opacity is not None:
            self._values["opacity"] = opacity
        if opacity_var is not None:
            self._values["opacity_var"] = opacity_var

    @builtins.property
    def opacity(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def opacity_var(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        result = self._values.get("opacity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsOpacity(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsOpacityList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsOpacityList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bbebe71eacb52155a66f9d6641127debd1e35455664ea8f47d26db6be33520a8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsOpacityOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f78e739cc73749bd7c68fbf9cb637a5d0c4169cbcb9652a9d2e57fc23c7dc411)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsOpacityOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9c04546bb02bc772fd5417607422fb5c7b89b3b1df6c29f669a4cfb8d379968d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__763219467ecc927ea907fc2d517fe137c2c83e1872973d7a5abd84f9227a097d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__47a67933bc3a24077bf7c036cab9150c79333e1e9c50c5644d1c391a8064517c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsOpacity]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsOpacity]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d29feb99fa71be269c31279b9ace6a2d4edd6fd8d9a1010cecda12ff0a68ad0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsOpacityOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsOpacityOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9c013be158e3badfa2851717710a7a3d877d21bd335e3d60a3df83137801fde1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetOpacityVar")
    def reset_opacity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacityVar", []))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityVarInput")
    def opacity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacity"))

    @opacity.setter
    def opacity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eb6e2efa17d6d21e06c70e2c2b29af98c5752cf1efc329d825f623ea8cf4f74e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacity", value)

    @builtins.property
    @jsii.member(jsii_name="opacityVar")
    def opacity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacityVar"))

    @opacity_var.setter
    def opacity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__09f1bed5c423d58658004c62371bf6bef3ea0d722d1da942d02700a634788cdb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacityVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsOpacity]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsOpacity]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsOpacity]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bd34e709203920d539a5468393c68f30cf357ba642a63c2f0c9923c8ca1ea7d4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__30672b071a2621a9a0bc9f79aff3c3ecd889155da7840788518523c8297688e6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putBackgroundColor")
    def put_background_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a76264b092df1bb208f17950b62841b5e901fbbd0545d113b1a7bb5780f39f6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBackgroundColor", [value]))

    @jsii.member(jsii_name="putBlur")
    def put_blur(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsBlur, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__15c2861bc4d9a42d017096a93b526417ddb914bd7ccca4a0ef2471f11363fdf3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBlur", [value]))

    @jsii.member(jsii_name="putChromaKey")
    def put_chroma_key(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsChromaKey, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__42aac006b14c7ed8d9da3f433942f4051727ace81f7d3f8f3db3624b9f4b218f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putChromaKey", [value]))

    @jsii.member(jsii_name="putComposite")
    def put_composite(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsComposite, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a15e9740c390a75ff112d6fd2b76d9804804e6c270d10da1f8556f52003eec4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putComposite", [value]))

    @jsii.member(jsii_name="putCompound")
    def put_compound(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsCompound, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__861271f55baa1bffd43de7849248ca3a3164318fdd062b23b02a973ebd8a1d3c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCompound", [value]))

    @jsii.member(jsii_name="putContrast")
    def put_contrast(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsContrast, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e60821a2b5fdbc507bb5e83fcb8b0d40fd5dd8c15447df2836fa7ceb8519072)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putContrast", [value]))

    @jsii.member(jsii_name="putGoop")
    def put_goop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsGoop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b8e232a4c9e0d433167e26422421a657bc07d662fe45c59fd6ca61baf7e4ef51)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGoop", [value]))

    @jsii.member(jsii_name="putGrayscale")
    def put_grayscale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsGrayscale, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0e4aa83f2e85c6bce1ea9f10bad2f61097c8e44b25e2e88aa53048112118ba7d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGrayscale", [value]))

    @jsii.member(jsii_name="putHsl")
    def put_hsl(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsHsl, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b1032b58831577cafe3a299b2709043a821df91dedf92cbe5a86d3955ed4f8cd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsl", [value]))

    @jsii.member(jsii_name="putHsv")
    def put_hsv(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsHsv, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e2892acd47b62bc4b8b86e9adaa54b053cb7c047e457f6dce3358aa5f9463091)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsv", [value]))

    @jsii.member(jsii_name="putIfDimension")
    def put_if_dimension(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfDimension, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e2c7c9d55d740e20a77ecb7099fd295962d7960a4c9fa6926193173024def2b1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfDimension", [value]))

    @jsii.member(jsii_name="putIfOrientation")
    def put_if_orientation(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a6f717071501ac027615954fb2c8ab65bc2b3602bc3030d3dc6fddfbab5cb2a0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfOrientation", [value]))

    @jsii.member(jsii_name="putMaxColors")
    def put_max_colors(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsMaxColors, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ed9e9f4c5c53593ced3e36bbf31d4dc9d0c6cb06f935ad2d292b8989633f0e03)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMaxColors", [value]))

    @jsii.member(jsii_name="putMirror")
    def put_mirror(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsMirror, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__99298aa652d0fcbfb82c9448af45510a3d48a9b6f4951ac68b713acce1dcb163)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMirror", [value]))

    @jsii.member(jsii_name="putMonoHue")
    def put_mono_hue(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsMonoHue, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7bc0ddb1d0a7a3ac8adf62bfc4256b13b1f72180fc82338a11b44748aacf1f7a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMonoHue", [value]))

    @jsii.member(jsii_name="putOpacity")
    def put_opacity(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsOpacity, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a87b2dd44e7726cc2880c29a2201c05f3075346a96c0bda5a30045275d8e845e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putOpacity", [value]))

    @jsii.member(jsii_name="putRemoveColor")
    def put_remove_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsRemoveColor", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4739d31ecf6db6ecf4f24d6852d45882e0034ac680d943eb49db6ab5d4686b21)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRemoveColor", [value]))

    @jsii.member(jsii_name="putUnsharpMask")
    def put_unsharp_mask(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsUnsharpMask", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f410049aae7decd4210203ef101ebe54c49be900ae617a37cb1c94040defc9f1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putUnsharpMask", [value]))

    @jsii.member(jsii_name="resetBackgroundColor")
    def reset_background_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBackgroundColor", []))

    @jsii.member(jsii_name="resetBlur")
    def reset_blur(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBlur", []))

    @jsii.member(jsii_name="resetChromaKey")
    def reset_chroma_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChromaKey", []))

    @jsii.member(jsii_name="resetComposite")
    def reset_composite(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetComposite", []))

    @jsii.member(jsii_name="resetCompound")
    def reset_compound(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCompound", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetGoop")
    def reset_goop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGoop", []))

    @jsii.member(jsii_name="resetGrayscale")
    def reset_grayscale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGrayscale", []))

    @jsii.member(jsii_name="resetHsl")
    def reset_hsl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsl", []))

    @jsii.member(jsii_name="resetHsv")
    def reset_hsv(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsv", []))

    @jsii.member(jsii_name="resetIfDimension")
    def reset_if_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfDimension", []))

    @jsii.member(jsii_name="resetIfOrientation")
    def reset_if_orientation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfOrientation", []))

    @jsii.member(jsii_name="resetMaxColors")
    def reset_max_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxColors", []))

    @jsii.member(jsii_name="resetMirror")
    def reset_mirror(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMirror", []))

    @jsii.member(jsii_name="resetMonoHue")
    def reset_mono_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonoHue", []))

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetRemoveColor")
    def reset_remove_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRemoveColor", []))

    @jsii.member(jsii_name="resetUnsharpMask")
    def reset_unsharp_mask(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUnsharpMask", []))

    @builtins.property
    @jsii.member(jsii_name="backgroundColor")
    def background_color(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsBackgroundColorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsBackgroundColorList, jsii.get(self, "backgroundColor"))

    @builtins.property
    @jsii.member(jsii_name="blur")
    def blur(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsBlurList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsBlurList, jsii.get(self, "blur"))

    @builtins.property
    @jsii.member(jsii_name="chromaKey")
    def chroma_key(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsChromaKeyList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsChromaKeyList, jsii.get(self, "chromaKey"))

    @builtins.property
    @jsii.member(jsii_name="composite")
    def composite(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsCompositeList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsCompositeList, jsii.get(self, "composite"))

    @builtins.property
    @jsii.member(jsii_name="compound")
    def compound(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsCompoundList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsCompoundList, jsii.get(self, "compound"))

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsContrastList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsContrastList, jsii.get(self, "contrast"))

    @builtins.property
    @jsii.member(jsii_name="goop")
    def goop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsGoopList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsGoopList, jsii.get(self, "goop"))

    @builtins.property
    @jsii.member(jsii_name="grayscale")
    def grayscale(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsGrayscaleList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsGrayscaleList, jsii.get(self, "grayscale"))

    @builtins.property
    @jsii.member(jsii_name="hsl")
    def hsl(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsHslList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsHslList, jsii.get(self, "hsl"))

    @builtins.property
    @jsii.member(jsii_name="hsv")
    def hsv(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsHsvList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsHsvList, jsii.get(self, "hsv"))

    @builtins.property
    @jsii.member(jsii_name="ifDimension")
    def if_dimension(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfDimensionList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfDimensionList, jsii.get(self, "ifDimension"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientation")
    def if_orientation(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfOrientationList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfOrientationList, jsii.get(self, "ifOrientation"))

    @builtins.property
    @jsii.member(jsii_name="maxColors")
    def max_colors(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsMaxColorsList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsMaxColorsList, jsii.get(self, "maxColors"))

    @builtins.property
    @jsii.member(jsii_name="mirror")
    def mirror(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsMirrorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsMirrorList, jsii.get(self, "mirror"))

    @builtins.property
    @jsii.member(jsii_name="monoHue")
    def mono_hue(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsMonoHueList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsMonoHueList, jsii.get(self, "monoHue"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsOpacityList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsOpacityList, jsii.get(self, "opacity"))

    @builtins.property
    @jsii.member(jsii_name="removeColor")
    def remove_color(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsRemoveColorList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsRemoveColorList", jsii.get(self, "removeColor"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMask")
    def unsharp_mask(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsUnsharpMaskList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsUnsharpMaskList", jsii.get(self, "unsharpMask"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColorInput")
    def background_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsBackgroundColor]]], jsii.get(self, "backgroundColorInput"))

    @builtins.property
    @jsii.member(jsii_name="blurInput")
    def blur_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsBlur]]], jsii.get(self, "blurInput"))

    @builtins.property
    @jsii.member(jsii_name="chromaKeyInput")
    def chroma_key_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsChromaKey]]], jsii.get(self, "chromaKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="compositeInput")
    def composite_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsComposite]]], jsii.get(self, "compositeInput"))

    @builtins.property
    @jsii.member(jsii_name="compoundInput")
    def compound_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsCompound]]], jsii.get(self, "compoundInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsContrast]]], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="goopInput")
    def goop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsGoop]]], jsii.get(self, "goopInput"))

    @builtins.property
    @jsii.member(jsii_name="grayscaleInput")
    def grayscale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsGrayscale]]], jsii.get(self, "grayscaleInput"))

    @builtins.property
    @jsii.member(jsii_name="hslInput")
    def hsl_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsHsl]]], jsii.get(self, "hslInput"))

    @builtins.property
    @jsii.member(jsii_name="hsvInput")
    def hsv_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsHsv]]], jsii.get(self, "hsvInput"))

    @builtins.property
    @jsii.member(jsii_name="ifDimensionInput")
    def if_dimension_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfDimension]]], jsii.get(self, "ifDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientationInput")
    def if_orientation_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfOrientation]]], jsii.get(self, "ifOrientationInput"))

    @builtins.property
    @jsii.member(jsii_name="maxColorsInput")
    def max_colors_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsMaxColors]]], jsii.get(self, "maxColorsInput"))

    @builtins.property
    @jsii.member(jsii_name="mirrorInput")
    def mirror_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsMirror]]], jsii.get(self, "mirrorInput"))

    @builtins.property
    @jsii.member(jsii_name="monoHueInput")
    def mono_hue_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsMonoHue]]], jsii.get(self, "monoHueInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsOpacity]]], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="removeColorInput")
    def remove_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsRemoveColor"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsRemoveColor"]]], jsii.get(self, "removeColorInput"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMaskInput")
    def unsharp_mask_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsUnsharpMask"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsUnsharpMask"]]], jsii.get(self, "unsharpMaskInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformations]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformations]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformations]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1232d84e01c57ad90627756218763af9f80c2baf0265cd50994c0fca2c30a926)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsRemoveColor",
    jsii_struct_bases=[],
    name_mapping={
        "color": "color",
        "color_var": "colorVar",
        "feather": "feather",
        "feather_var": "featherVar",
        "tolerance": "tolerance",
        "tolerance_var": "toleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsRemoveColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
        feather: typing.Optional[builtins.str] = None,
        feather_var: typing.Optional[builtins.str] = None,
        tolerance: typing.Optional[builtins.str] = None,
        tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        :param feather: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        :param feather_var: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        :param tolerance: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        :param tolerance_var: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0d8b34a32adec3b7ad4d34ac696cba8d50fe45001ea0329f2d0f028201072311)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
            check_type(argname="argument feather", value=feather, expected_type=type_hints["feather"])
            check_type(argname="argument feather_var", value=feather_var, expected_type=type_hints["feather_var"])
            check_type(argname="argument tolerance", value=tolerance, expected_type=type_hints["tolerance"])
            check_type(argname="argument tolerance_var", value=tolerance_var, expected_type=type_hints["tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var
        if feather is not None:
            self._values["feather"] = feather
        if feather_var is not None:
            self._values["feather_var"] = feather_var
        if tolerance is not None:
            self._values["tolerance"] = tolerance
        if tolerance_var is not None:
            self._values["tolerance_var"] = tolerance_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        '''
        result = self._values.get("feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather_var(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        '''
        result = self._values.get("feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        '''
        result = self._values.get("tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance_var(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        result = self._values.get("tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsRemoveColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsRemoveColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsRemoveColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__30ed53995b2d62d126e199181201fd782b0e1ed6a88f6228bfc3f0d316e81b70)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsRemoveColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e9b8527090bbda6abdee7c95259b74b2a947ca25af474f1958b21d89a9ef60ef)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsRemoveColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__47a55b15a22ad662ba9f931a1b28b150bc95a6cc7084e445fefe9dc9ae449e67)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a1990d2bc12995de458f6e414698f307c69f8f636428bab569eacf1bed311268)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__54fc3fa71ef9b23292799a481e84656bf30b93da79ce265a113e6eed6e0182bd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsRemoveColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsRemoveColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsRemoveColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c492dd90e367523bda42aa739dbf577feef7bc3151f814f8f82b7d17d944de4c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsRemoveColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsRemoveColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a5a344db893747295eee7c85af3307b0a6aa30ff0790a4501868b191913194b1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @jsii.member(jsii_name="resetFeather")
    def reset_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeather", []))

    @jsii.member(jsii_name="resetFeatherVar")
    def reset_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatherVar", []))

    @jsii.member(jsii_name="resetTolerance")
    def reset_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTolerance", []))

    @jsii.member(jsii_name="resetToleranceVar")
    def reset_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featherInput")
    def feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherInput"))

    @builtins.property
    @jsii.member(jsii_name="featherVarInput")
    def feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceInput")
    def tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceVarInput")
    def tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aedec6a5c578b3dfaa3fbea8a5c216aefab15cd574c19b9a9346f5d54f587a7e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__737ff7d5bb04f0168695144f9e61bfb6053a005b3b977407739c570d35a2215f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="feather")
    def feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "feather"))

    @feather.setter
    def feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7078da25a39db724d3a7692adccc4a0fd94ef8a68aad8ef15a658880cf2afde2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "feather", value)

    @builtins.property
    @jsii.member(jsii_name="featherVar")
    def feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featherVar"))

    @feather_var.setter
    def feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__88d1475224b3fdb8229d333ecb5865596b99d20229528941bc9255d67d706813)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featherVar", value)

    @builtins.property
    @jsii.member(jsii_name="tolerance")
    def tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tolerance"))

    @tolerance.setter
    def tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6441affb399cdeb47c5edaceb2b512b25f53e5bd6780a675f96de4479b6cf7d0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tolerance", value)

    @builtins.property
    @jsii.member(jsii_name="toleranceVar")
    def tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "toleranceVar"))

    @tolerance_var.setter
    def tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__26bfd664b1cf08f99faddebe4475b7e84607682d07edd6df839649b93cad65e3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "toleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsRemoveColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsRemoveColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsRemoveColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc09e6e8a22f8a29eddac5c28336363aa41b18f6f8a6291657a6f38ab8300f2a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsUnsharpMask",
    jsii_struct_bases=[],
    name_mapping={
        "gain": "gain",
        "gain_var": "gainVar",
        "sigma": "sigma",
        "sigma_var": "sigmaVar",
        "threshold": "threshold",
        "threshold_var": "thresholdVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsUnsharpMask:
    def __init__(
        self,
        *,
        gain: typing.Optional[builtins.str] = None,
        gain_var: typing.Optional[builtins.str] = None,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
        threshold: typing.Optional[builtins.str] = None,
        threshold_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param gain: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        :param gain_var: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        :param sigma: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        :param threshold: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        :param threshold_var: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8dd8eb10f88a30494a8219b3368ec953f5016da0961c257c41ca08b08441bdef)
            check_type(argname="argument gain", value=gain, expected_type=type_hints["gain"])
            check_type(argname="argument gain_var", value=gain_var, expected_type=type_hints["gain_var"])
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
            check_type(argname="argument threshold", value=threshold, expected_type=type_hints["threshold"])
            check_type(argname="argument threshold_var", value=threshold_var, expected_type=type_hints["threshold_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if gain is not None:
            self._values["gain"] = gain
        if gain_var is not None:
            self._values["gain_var"] = gain_var
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var
        if threshold is not None:
            self._values["threshold"] = threshold
        if threshold_var is not None:
            self._values["threshold_var"] = threshold_var

    @builtins.property
    def gain(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        '''
        result = self._values.get("gain")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gain_var(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        '''
        result = self._values.get("gain_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        '''
        result = self._values.get("threshold")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold_var(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        result = self._values.get("threshold_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsUnsharpMask(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsUnsharpMaskList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsUnsharpMaskList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6cf95c0bb20993e31131c9ac64ce9fd83f46a916052274a93e187e4d97f75f7b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsUnsharpMaskOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__32cb4a53ddb95e3247807c6d9b29f6e9a330114f145edd809dc436f241f7089c)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsUnsharpMaskOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__47f09f95a28022df9178200df3c60e29a4cc77b8b4ce3ddc2e01a69f0136e770)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e1c6bc836176d92d70b3db3a42014742bec216ed2e5047985a67c58bad6feb6a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__929cab9149f84cd629f67a326cc54629467101ec2ef80144fa4d8bbcb7017c2f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsUnsharpMask]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsUnsharpMask]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsUnsharpMask]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8d18c5069c0d6e2dc5d9bebee4f9939ae1bba6dc6b501bcd9fdc1ce23e3032fe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsUnsharpMaskOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsUnsharpMaskOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0c24fc1ecf5e09f1a386ba44e129b306ea550699ad561cb3df870b9426c6b4db)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetGain")
    def reset_gain(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGain", []))

    @jsii.member(jsii_name="resetGainVar")
    def reset_gain_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGainVar", []))

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @jsii.member(jsii_name="resetThreshold")
    def reset_threshold(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThreshold", []))

    @jsii.member(jsii_name="resetThresholdVar")
    def reset_threshold_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThresholdVar", []))

    @builtins.property
    @jsii.member(jsii_name="gainInput")
    def gain_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainInput"))

    @builtins.property
    @jsii.member(jsii_name="gainVarInput")
    def gain_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdInput")
    def threshold_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdVarInput")
    def threshold_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gain")
    def gain(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gain"))

    @gain.setter
    def gain(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1ebbc401b401474c1dc32d9008b6a5bf55afdf2e4d6a8f1ce100ad43f188d76f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gain", value)

    @builtins.property
    @jsii.member(jsii_name="gainVar")
    def gain_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gainVar"))

    @gain_var.setter
    def gain_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f65ada1ae33fa7cef11b356f19e2931f9d877fd2ece8a13d72de82defb3e9c03)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gainVar", value)

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cc37f0433fac1e9227ab591471445d6b8083f23c4a4d5c712a446c0ee25f3da4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0d02fb5297a6df611becfce4a781e44350230505af98c9b2c1bd726eea3209eb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="threshold")
    def threshold(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "threshold"))

    @threshold.setter
    def threshold(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9fa392f64593bcb5ed54097e6fb4bcbabd8a7cc3212ef3307d61c39e2de142af)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "threshold", value)

    @builtins.property
    @jsii.member(jsii_name="thresholdVar")
    def threshold_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "thresholdVar"))

    @threshold_var.setter
    def threshold_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e747395014319fe956792cf130978f1b7fa2c1125636b2d164369e4febfa3ee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "thresholdVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsUnsharpMask]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsUnsharpMask]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsUnsharpMask]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__753fa13229812e2fc99fa11df9be6c75fa88975dcd39cad5699a7d148f1fd418)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultContrast",
    jsii_struct_bases=[],
    name_mapping={
        "brightness": "brightness",
        "brightness_var": "brightnessVar",
        "contrast": "contrast",
        "contrast_var": "contrastVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultContrast:
    def __init__(
        self,
        *,
        brightness: typing.Optional[builtins.str] = None,
        brightness_var: typing.Optional[builtins.str] = None,
        contrast: typing.Optional[builtins.str] = None,
        contrast_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param brightness: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        :param brightness_var: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        :param contrast: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param contrast_var: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6ebf001447292d1b81d155d2f3767af91122ede2d7fcd6a1323d4b88c970c9bb)
            check_type(argname="argument brightness", value=brightness, expected_type=type_hints["brightness"])
            check_type(argname="argument brightness_var", value=brightness_var, expected_type=type_hints["brightness_var"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument contrast_var", value=contrast_var, expected_type=type_hints["contrast_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if brightness is not None:
            self._values["brightness"] = brightness
        if brightness_var is not None:
            self._values["brightness_var"] = brightness_var
        if contrast is not None:
            self._values["contrast"] = contrast
        if contrast_var is not None:
            self._values["contrast_var"] = contrast_var

    @builtins.property
    def brightness(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        '''
        result = self._values.get("brightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def brightness_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        '''
        result = self._values.get("brightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        result = self._values.get("contrast_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultContrast(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultContrastList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultContrastList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9df785e9f33e2c2c41293d61657b442208aa1bc15dbbbe74aa5b77266611036d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultContrastOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d94793db22f1868227257786837a0e317910fe50f29170cfb8ef4d9cb73cb4bc)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultContrastOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e9fb52fd007dedd10fc4e77cb1eb52a3179f9341a478360ea91718c12f164be7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5c5eaf99e1f2a4ad307b89a2022dd6bf729822eebcdde3d35694131d4437a1a5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__57349d85da0fd3286f0b74e788bd62fba3a37c70e7aed6097ed15628f46e112e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultContrast]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultContrast]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c69ea5ae161127ec1fc4474bddd74c4dcf5b187c8bef5cbd1c622298571a7a26)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultContrastOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultContrastOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__58af10a90a1dab357b9ac4fe65607ec46d412a97556773bccdf639d5dba70c63)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetBrightness")
    def reset_brightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightness", []))

    @jsii.member(jsii_name="resetBrightnessVar")
    def reset_brightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightnessVar", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetContrastVar")
    def reset_contrast_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrastVar", []))

    @builtins.property
    @jsii.member(jsii_name="brightnessInput")
    def brightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="brightnessVarInput")
    def brightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastVarInput")
    def contrast_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="brightness")
    def brightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightness"))

    @brightness.setter
    def brightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__19f77ba0eb605fcaa645609788625f86889a85cb85c934b27910826060c8a7c0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightness", value)

    @builtins.property
    @jsii.member(jsii_name="brightnessVar")
    def brightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightnessVar"))

    @brightness_var.setter
    def brightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7164dab67045e19e4306c27ede7856c8e120baea494c85a5bb93c00298e06233)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrast"))

    @contrast.setter
    def contrast(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__42ce0640d5423940698adcbe1b36388dc57e8e8a50b1c5858dcb93b0a783373c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrast", value)

    @builtins.property
    @jsii.member(jsii_name="contrastVar")
    def contrast_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrastVar"))

    @contrast_var.setter
    def contrast_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d4ba5886e8c569d191a9af3fea0b0049b22b2d604400fdabf7b344013b165c2c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrastVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultContrast]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultContrast]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultContrast]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d684045c91bc92cba927417c12736b685695576b91ce7d28fa8d2ef37022b3d9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultGoop",
    jsii_struct_bases=[],
    name_mapping={
        "chaos": "chaos",
        "chaos_var": "chaosVar",
        "density": "density",
        "density_var": "densityVar",
        "power": "power",
        "power_var": "powerVar",
        "seed": "seed",
        "seed_var": "seedVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultGoop:
    def __init__(
        self,
        *,
        chaos: typing.Optional[builtins.str] = None,
        chaos_var: typing.Optional[builtins.str] = None,
        density: typing.Optional[builtins.str] = None,
        density_var: typing.Optional[builtins.str] = None,
        power: typing.Optional[builtins.str] = None,
        power_var: typing.Optional[builtins.str] = None,
        seed: typing.Optional[builtins.str] = None,
        seed_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param chaos: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        :param chaos_var: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        :param density: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        :param density_var: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        :param power: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        :param power_var: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        :param seed: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        :param seed_var: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__902f1ac016bc9e6c3b2bbc06c3793fc9d1e39391c6511a05f1d9fd1b99149e66)
            check_type(argname="argument chaos", value=chaos, expected_type=type_hints["chaos"])
            check_type(argname="argument chaos_var", value=chaos_var, expected_type=type_hints["chaos_var"])
            check_type(argname="argument density", value=density, expected_type=type_hints["density"])
            check_type(argname="argument density_var", value=density_var, expected_type=type_hints["density_var"])
            check_type(argname="argument power", value=power, expected_type=type_hints["power"])
            check_type(argname="argument power_var", value=power_var, expected_type=type_hints["power_var"])
            check_type(argname="argument seed", value=seed, expected_type=type_hints["seed"])
            check_type(argname="argument seed_var", value=seed_var, expected_type=type_hints["seed_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if chaos is not None:
            self._values["chaos"] = chaos
        if chaos_var is not None:
            self._values["chaos_var"] = chaos_var
        if density is not None:
            self._values["density"] = density
        if density_var is not None:
            self._values["density_var"] = density_var
        if power is not None:
            self._values["power"] = power
        if power_var is not None:
            self._values["power_var"] = power_var
        if seed is not None:
            self._values["seed"] = seed
        if seed_var is not None:
            self._values["seed_var"] = seed_var

    @builtins.property
    def chaos(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        '''
        result = self._values.get("chaos")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def chaos_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        '''
        result = self._values.get("chaos_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        '''
        result = self._values.get("density")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density_var(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        '''
        result = self._values.get("density_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        '''
        result = self._values.get("power")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power_var(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        '''
        result = self._values.get("power_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        '''
        result = self._values.get("seed")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed_var(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        result = self._values.get("seed_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultGoop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultGoopList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultGoopList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aa739973034ce8d0c6bf6a27b3c0a8cb0afea18170ab354426403b85303bea11)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultGoopOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__50d2470ca06b438d1e539f0ad586f4b33008cca682eb43256d0c3166f6e01914)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultGoopOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__525fb4f1a2b535586a48656903d2832f84ea81725c232e2ec3d2d2eee985decc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c13c3ed9f937f5a0c9835816dffad9db77895f288becb21c609639403cd0ee9e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9cc2a6c61bc32a58851154e52120c33442c836ea4eac6f2ab43fca6520180583)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultGoop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultGoop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d90044b13d6635615b40bac85cd98931753470f68e6032f52f4bd54ed3367951)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultGoopOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultGoopOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8c82ac8f8dd96ba361e4311948fb2e0ff0927b4d0f4de2602d7f2ccbb6892d32)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetChaos")
    def reset_chaos(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaos", []))

    @jsii.member(jsii_name="resetChaosVar")
    def reset_chaos_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaosVar", []))

    @jsii.member(jsii_name="resetDensity")
    def reset_density(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensity", []))

    @jsii.member(jsii_name="resetDensityVar")
    def reset_density_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensityVar", []))

    @jsii.member(jsii_name="resetPower")
    def reset_power(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPower", []))

    @jsii.member(jsii_name="resetPowerVar")
    def reset_power_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPowerVar", []))

    @jsii.member(jsii_name="resetSeed")
    def reset_seed(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeed", []))

    @jsii.member(jsii_name="resetSeedVar")
    def reset_seed_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeedVar", []))

    @builtins.property
    @jsii.member(jsii_name="chaosInput")
    def chaos_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosInput"))

    @builtins.property
    @jsii.member(jsii_name="chaosVarInput")
    def chaos_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosVarInput"))

    @builtins.property
    @jsii.member(jsii_name="densityInput")
    def density_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityInput"))

    @builtins.property
    @jsii.member(jsii_name="densityVarInput")
    def density_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="powerInput")
    def power_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerInput"))

    @builtins.property
    @jsii.member(jsii_name="powerVarInput")
    def power_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerVarInput"))

    @builtins.property
    @jsii.member(jsii_name="seedInput")
    def seed_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedInput"))

    @builtins.property
    @jsii.member(jsii_name="seedVarInput")
    def seed_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedVarInput"))

    @builtins.property
    @jsii.member(jsii_name="chaos")
    def chaos(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaos"))

    @chaos.setter
    def chaos(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3dc4562dd50136123f7704a11e8b3037412440fa900a03fefb7d3c3f68ab2f1e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaos", value)

    @builtins.property
    @jsii.member(jsii_name="chaosVar")
    def chaos_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaosVar"))

    @chaos_var.setter
    def chaos_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d6db40e84ae1fb9661be20130d4803c4a5c7a71c68b25a8a163dae839d38585f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaosVar", value)

    @builtins.property
    @jsii.member(jsii_name="density")
    def density(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "density"))

    @density.setter
    def density(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__095e65e7340e662aa79f5e955f3554f6d0dcbd797d1ba1ee160be254470c32b9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "density", value)

    @builtins.property
    @jsii.member(jsii_name="densityVar")
    def density_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "densityVar"))

    @density_var.setter
    def density_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e4c520a87a14d10bc59457f0194918de8929279c6ea21cf9f64374978ab91ba3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "densityVar", value)

    @builtins.property
    @jsii.member(jsii_name="power")
    def power(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "power"))

    @power.setter
    def power(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__87a14386ae639294f4d3e6d4deefb353546943aeae93df4a52322378b27350e7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "power", value)

    @builtins.property
    @jsii.member(jsii_name="powerVar")
    def power_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "powerVar"))

    @power_var.setter
    def power_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e65988987680213d3df4d80c14f289af07dbaeea7b26fa23c128aeee1cea6161)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "powerVar", value)

    @builtins.property
    @jsii.member(jsii_name="seed")
    def seed(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seed"))

    @seed.setter
    def seed(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d2eea36ff45ca3e501d616203bb0495daebd578caee403e69b156ae34f02b31b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seed", value)

    @builtins.property
    @jsii.member(jsii_name="seedVar")
    def seed_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seedVar"))

    @seed_var.setter
    def seed_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9b9bf91560293183cf5536b97ded85f863246ee29947f7de02d44e6ada961fe1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seedVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultGoop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultGoop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultGoop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f52cef2158127e47621e7543f46c2a0a39a34f274536752b94d1773b9fc6a28)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultGrayscale",
    jsii_struct_bases=[],
    name_mapping={"type": "type", "type_var": "typeVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultGrayscale:
    def __init__(
        self,
        *,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param type: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8d5e8bb70fdd88b7959b4e06668df9794f5cab664b4058736b19f94c1a945e2d)
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultGrayscale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultGrayscaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultGrayscaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ecd70a2855efa825c19c82f032920b7931c84ed2918bf9dde883a83fc7389711)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultGrayscaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__39a6c007207bf873debdbfb847bcf53571bc442153c783180996950a4760bcc4)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultGrayscaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bdd6952f4880fdf24a122ed53ace13974b82349d30c29943174f76ec6c56cdbd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ee7f22aabdf14d124c49c938b256e05fe9cbed838413d80b15c08f67a9a3cc34)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__88325cba9b9375ee9c5fc8412336ecaa34667934a15a7c8671d89bb8be46fd7a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultGrayscale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultGrayscale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1964d6504659e989d70e1f319a48754a2a1abbde9bb536c4632a8c51d4e1f2c7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultGrayscaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultGrayscaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7f937275b23abcc05d417483f20335bd8d7281407563a5a73e8241aac171fcd8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ffee2f640676706c25b16791e26399ddf59e9fbcaa75b6b1642be8e40c6a48d9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d2797a89cacdd34d518ced678f69a211e012a7a2baa38c0b34949a7b62421a5c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultGrayscale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultGrayscale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultGrayscale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ff3d3f85c9baaddbe4f5b8b309700c49a7bcd1e3809f20fad81083bc59f507b4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultHsl",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "lightness": "lightness",
        "lightness_var": "lightnessVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultHsl:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness: typing.Optional[builtins.str] = None,
        lightness_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        :param lightness_var: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ecd89b4c2845a99bb46384c6887c7fc9ec98d6f0e0b94112a29714fcc9292f79)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness", value=lightness, expected_type=type_hints["lightness"])
            check_type(argname="argument lightness_var", value=lightness_var, expected_type=type_hints["lightness_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness is not None:
            self._values["lightness"] = lightness
        if lightness_var is not None:
            self._values["lightness_var"] = lightness_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        '''
        result = self._values.get("lightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        '''
        result = self._values.get("lightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultHsl(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultHslList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultHslList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__174c0281840504184b49b9368339233909489d35cac72db431171c28edc9c9d0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultHslOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8b61065da847bd79d4a33f9157ceab924750a23290da076751bc6cedb7a89402)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultHslOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__934c7b3e9ae512c867e25601067a705e57f879d2d26127a5b365b35d7b8cd69a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a04d9b378464e4b8725cf2982bb1c510194f373a1e62ba582e9aca55969f270b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__58ff82dec824f4a6f0094e14a30991ad14e9445b568dceb40309778fafc4f7ff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultHsl]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultHsl]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__253da17d7c05d7436f96dfe26c004da1f8a755f9df6ee41a3361e5bbeaeec05d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultHslOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultHslOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af24be336e0ce17f62bdd0acf25d6eab97dd9dfef63de2d156c2a35f9ca709fc)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightness")
    def reset_lightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightness", []))

    @jsii.member(jsii_name="resetLightnessVar")
    def reset_lightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessInput")
    def lightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessVarInput")
    def lightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__291a381eeac233931839e7754bb914618129e83b98c1b66ddf00d6ec2c3c0cd9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fddabc47d211fd217f6faec639138a9b5bdade9be2934a310dbc8817a4d35a42)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightness")
    def lightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightness"))

    @lightness.setter
    def lightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d652937350e94f0bca9a283de938bfc309072c8c94c64018432377aa73bd23e4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightness", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessVar")
    def lightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessVar"))

    @lightness_var.setter
    def lightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b2e72e8e762cb231b8c0f807d2c9bbb2b3434059ebc3c8df946ab5c727bc7aab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4e7df423d0844168b6f49cf6b0277979fc555a89f00008adc37cbcd5329e80e1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__958401d0208baef7e3b70dc888121cd4e091f3a860f0f9e8ece91575f5e9ce39)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultHsl]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultHsl]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultHsl]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__021aabcbd1980d975f3369984ddce298319df9317f01ea52f6d42536989bb7ac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultHsv",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultHsv:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        :param value: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa8cccbce46461b8bb8ad733dc1457ba1741d5e555272fea8482e1f0170ce032)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultHsv(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultHsvList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultHsvList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3e982edd8f33a486fb64e6e3c9e2a71271d65c1b779733fd2fa619e4c61320bf)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultHsvOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__45143cfc70bacae879a93a2c8438fc2338183b925ed59041494f2c275563c255)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultHsvOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9eb6efddb453d5781489da3132973fa6d9529dba88fb0f7284b043db605b38c8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__efd0aaec0039ae29270637fb5a30481c46e6fbf7c71e501f20f7a855a5575c0a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1d8edd76c3b56414a9c13f510c87f8395e9cd23abea52ab561db468dace37fd9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultHsv]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultHsv]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f18ba03a0c499911e2736b2e2a41bf1ac18f9cbd8afb5d1ef433481886bc8ae5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultHsvOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultHsvOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6178a402a96cbbc61871807a9a6cc425279f586811c737e2ee44be90f0e4234f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bba59be36e15d15f4fc00ffac148b980b8613838c24e298f01b6c3dc90cc7f29)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5de41df5437f661f43f11840d56e119baeeab64c0385954a1bae44b038c652be)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f7e9e999053f57051639591281324c8bb6c21c93608f942734c8c577e8ecd765)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5a07b9b9c905f1cf4b617a5ad65604c5f15b72a8683cd9376236adb701583902)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__25e2abb58ff989cbacd866f87020d1525fca86244433489297840b56595a46fe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2aab664bd1ab21a93ebccd6ca24728eb6bb0a8b365447281ea60d533b670f4d4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultHsv]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultHsv]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultHsv]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__697960b8d1f3c159c056470de26709e73d2a7095f7739ae3879002f942dd3282)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimension",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "dimension": "dimension",
        "dimension_var": "dimensionVar",
        "equal": "equal",
        "greater_than": "greaterThan",
        "less_than": "lessThan",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimension:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefault, typing.Dict[builtins.str, typing.Any]]] = None,
        dimension: typing.Optional[builtins.str] = None,
        dimension_var: typing.Optional[builtins.str] = None,
        equal: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqual", typing.Dict[builtins.str, typing.Any]]] = None,
        greater_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThan", typing.Dict[builtins.str, typing.Any]]] = None,
        less_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThan", typing.Dict[builtins.str, typing.Any]]] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param dimension: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        :param dimension_var: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        :param equal: equal block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        :param greater_than: greater_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        :param less_than: less_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        :param value: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefault(**default)
        if isinstance(equal, dict):
            equal = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqual(**equal)
        if isinstance(greater_than, dict):
            greater_than = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThan(**greater_than)
        if isinstance(less_than, dict):
            less_than = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThan(**less_than)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__98fdee42a073c53351a2299c26209e0307dc14b69b7e60446d25e0e1c57b22d1)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument dimension", value=dimension, expected_type=type_hints["dimension"])
            check_type(argname="argument dimension_var", value=dimension_var, expected_type=type_hints["dimension_var"])
            check_type(argname="argument equal", value=equal, expected_type=type_hints["equal"])
            check_type(argname="argument greater_than", value=greater_than, expected_type=type_hints["greater_than"])
            check_type(argname="argument less_than", value=less_than, expected_type=type_hints["less_than"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if dimension is not None:
            self._values["dimension"] = dimension
        if dimension_var is not None:
            self._values["dimension_var"] = dimension_var
        if equal is not None:
            self._values["equal"] = equal
        if greater_than is not None:
            self._values["greater_than"] = greater_than
        if less_than is not None:
            self._values["less_than"] = less_than
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def default(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefault]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefault], result)

    @builtins.property
    def dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        '''
        result = self._values.get("dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        '''
        result = self._values.get("dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def equal(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqual"]:
        '''equal block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        '''
        result = self._values.get("equal")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqual"], result)

    @builtins.property
    def greater_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThan"]:
        '''greater_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        '''
        result = self._values.get("greater_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThan"], result)

    @builtins.property
    def less_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThan"]:
        '''less_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        '''
        result = self._values.get("less_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThan"], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimension(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqual",
    jsii_struct_bases=[],
    name_mapping={
        "background_color": "backgroundColor",
        "blur": "blur",
        "chroma_key": "chromaKey",
        "composite": "composite",
        "compound": "compound",
        "contrast": "contrast",
        "goop": "goop",
        "grayscale": "grayscale",
        "hsl": "hsl",
        "hsv": "hsv",
        "if_dimension": "ifDimension",
        "if_orientation": "ifOrientation",
        "max_colors": "maxColors",
        "mirror": "mirror",
        "mono_hue": "monoHue",
        "opacity": "opacity",
        "remove_color": "removeColor",
        "unsharp_mask": "unsharpMask",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqual:
    def __init__(
        self,
        *,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualBackgroundColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualBlur", typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualChromaKey", typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualComposite", typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualCompound", typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualContrast", typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualGoop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualGrayscale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualHsl", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualHsv", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfDimension", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfOrientation", typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualMaxColors", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualMirror", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualMonoHue", typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualOpacity", typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualRemoveColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualUnsharpMask", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b75c1f01c16f7ec6129802e6ef6b01d4d8789b276f07f83c90036229d961dbb7)
            check_type(argname="argument background_color", value=background_color, expected_type=type_hints["background_color"])
            check_type(argname="argument blur", value=blur, expected_type=type_hints["blur"])
            check_type(argname="argument chroma_key", value=chroma_key, expected_type=type_hints["chroma_key"])
            check_type(argname="argument composite", value=composite, expected_type=type_hints["composite"])
            check_type(argname="argument compound", value=compound, expected_type=type_hints["compound"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument goop", value=goop, expected_type=type_hints["goop"])
            check_type(argname="argument grayscale", value=grayscale, expected_type=type_hints["grayscale"])
            check_type(argname="argument hsl", value=hsl, expected_type=type_hints["hsl"])
            check_type(argname="argument hsv", value=hsv, expected_type=type_hints["hsv"])
            check_type(argname="argument if_dimension", value=if_dimension, expected_type=type_hints["if_dimension"])
            check_type(argname="argument if_orientation", value=if_orientation, expected_type=type_hints["if_orientation"])
            check_type(argname="argument max_colors", value=max_colors, expected_type=type_hints["max_colors"])
            check_type(argname="argument mirror", value=mirror, expected_type=type_hints["mirror"])
            check_type(argname="argument mono_hue", value=mono_hue, expected_type=type_hints["mono_hue"])
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument remove_color", value=remove_color, expected_type=type_hints["remove_color"])
            check_type(argname="argument unsharp_mask", value=unsharp_mask, expected_type=type_hints["unsharp_mask"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if background_color is not None:
            self._values["background_color"] = background_color
        if blur is not None:
            self._values["blur"] = blur
        if chroma_key is not None:
            self._values["chroma_key"] = chroma_key
        if composite is not None:
            self._values["composite"] = composite
        if compound is not None:
            self._values["compound"] = compound
        if contrast is not None:
            self._values["contrast"] = contrast
        if goop is not None:
            self._values["goop"] = goop
        if grayscale is not None:
            self._values["grayscale"] = grayscale
        if hsl is not None:
            self._values["hsl"] = hsl
        if hsv is not None:
            self._values["hsv"] = hsv
        if if_dimension is not None:
            self._values["if_dimension"] = if_dimension
        if if_orientation is not None:
            self._values["if_orientation"] = if_orientation
        if max_colors is not None:
            self._values["max_colors"] = max_colors
        if mirror is not None:
            self._values["mirror"] = mirror
        if mono_hue is not None:
            self._values["mono_hue"] = mono_hue
        if opacity is not None:
            self._values["opacity"] = opacity
        if remove_color is not None:
            self._values["remove_color"] = remove_color
        if unsharp_mask is not None:
            self._values["unsharp_mask"] = unsharp_mask

    @builtins.property
    def background_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualBackgroundColor"]]]:
        '''background_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        '''
        result = self._values.get("background_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualBackgroundColor"]]], result)

    @builtins.property
    def blur(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualBlur"]]]:
        '''blur block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        '''
        result = self._values.get("blur")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualBlur"]]], result)

    @builtins.property
    def chroma_key(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualChromaKey"]]]:
        '''chroma_key block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        '''
        result = self._values.get("chroma_key")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualChromaKey"]]], result)

    @builtins.property
    def composite(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualComposite"]]]:
        '''composite block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        '''
        result = self._values.get("composite")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualComposite"]]], result)

    @builtins.property
    def compound(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualCompound"]]]:
        '''compound block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        '''
        result = self._values.get("compound")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualCompound"]]], result)

    @builtins.property
    def contrast(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualContrast"]]]:
        '''contrast block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualContrast"]]], result)

    @builtins.property
    def goop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualGoop"]]]:
        '''goop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        '''
        result = self._values.get("goop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualGoop"]]], result)

    @builtins.property
    def grayscale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualGrayscale"]]]:
        '''grayscale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        '''
        result = self._values.get("grayscale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualGrayscale"]]], result)

    @builtins.property
    def hsl(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualHsl"]]]:
        '''hsl block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        '''
        result = self._values.get("hsl")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualHsl"]]], result)

    @builtins.property
    def hsv(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualHsv"]]]:
        '''hsv block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        '''
        result = self._values.get("hsv")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualHsv"]]], result)

    @builtins.property
    def if_dimension(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfDimension"]]]:
        '''if_dimension block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        '''
        result = self._values.get("if_dimension")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfDimension"]]], result)

    @builtins.property
    def if_orientation(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfOrientation"]]]:
        '''if_orientation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        '''
        result = self._values.get("if_orientation")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfOrientation"]]], result)

    @builtins.property
    def max_colors(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualMaxColors"]]]:
        '''max_colors block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        '''
        result = self._values.get("max_colors")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualMaxColors"]]], result)

    @builtins.property
    def mirror(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualMirror"]]]:
        '''mirror block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        '''
        result = self._values.get("mirror")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualMirror"]]], result)

    @builtins.property
    def mono_hue(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualMonoHue"]]]:
        '''mono_hue block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        '''
        result = self._values.get("mono_hue")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualMonoHue"]]], result)

    @builtins.property
    def opacity(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualOpacity"]]]:
        '''opacity block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualOpacity"]]], result)

    @builtins.property
    def remove_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualRemoveColor"]]]:
        '''remove_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        '''
        result = self._values.get("remove_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualRemoveColor"]]], result)

    @builtins.property
    def unsharp_mask(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualUnsharpMask"]]]:
        '''unsharp_mask block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        result = self._values.get("unsharp_mask")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualUnsharpMask"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqual(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualBackgroundColor",
    jsii_struct_bases=[],
    name_mapping={"color": "color", "color_var": "colorVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualBackgroundColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6401beb3dbce5014cd4ff0bad4b9b282f2961f9bb7d63d43f159c87e1a584320)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualBackgroundColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualBackgroundColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualBackgroundColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5b2f22cbf56dcf0cbf9062046af717de76fa1cc800a050fe8b8ef93332f6dedb)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualBackgroundColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dab92c8ea2890ad7bcff746d716b37b63ac638850ae7cbdaea7e76d19c2c26aa)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualBackgroundColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2be91dbbbc2b6733f2a23f093b29573d0255ae11184d5c0b7a3e1d9282d82b7b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6dcc6c0976d1efe67e57acd9806b9f01f7f71cd15619ef419d9f0dbc80557591)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb4704747319b43dc64689f5e9d0985e90618fcd35ee78e330f8e5bd64d10ced)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualBackgroundColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualBackgroundColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__564040eb99e9cd3fa2a36741f34e812ecfbe46bf80c15ebaad496de974be6279)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualBackgroundColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualBackgroundColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1d5df9d7ac073fd835477cd8d1de6aa96d005a89ea03c5ecb5b8c86030065308)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__935e66051e78d30fed5c5049d1acf0a5f97cd13163435aebcf435f031680f808)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d0f110394f6c8db6fc1d06b0eb4b3266eae703632842c1705c6a54f38b66a8cd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualBackgroundColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualBackgroundColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualBackgroundColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__58ab0a34af5a9803e26d041ad3b06b7269cbf5ff0abda7aa866ec002a04a0a93)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualBlur",
    jsii_struct_bases=[],
    name_mapping={"sigma": "sigma", "sigma_var": "sigmaVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualBlur:
    def __init__(
        self,
        *,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param sigma: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1a6c919d974cdd1f8122d965592d1e7690d5526771f52199cf8ad03e96b87fa7)
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualBlur(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualBlurList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualBlurList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7c0359a840f8d69101b535d1d77cfd37fd96c9c39ca46e0296f4e7023592e0ca)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualBlurOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d2023aec000b26ddacacd8d74960cb59656a3183c85b6264b76f42b1ea237183)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualBlurOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5a0131092d21808061fb87bdea5501b032b88910dc7f3e278f796efbf9794403)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4bb6acefb931209c2476ca822a29ffb35f8987367dc5b52282cab9fc03b71eb7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d86dd9ed3efae0796659cff9d03dbdb1e255d14677a6c50527d6f7863337860e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualBlur]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualBlur]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1de50dd19df60417676549793bac03c1271b26d4f3909213733655c114970454)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualBlurOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualBlurOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__912b56a01e82fddcd253442bf914a28a4a0b5b1260a2ed6237f02383d1e23306)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d7e8f8e0133946249cee93e80954945fd6d852813f34be53b963e6d8fd3a7a63)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__124e43a3219ae90664c3fdd2979c09e1335fbd7ac9675fd4da54a3a19b1c8596)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualBlur]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualBlur]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualBlur]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e7b57545583e11870c688ea9e64b3fa57ba5c11d7c0ea9d612b15338fd9495d4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualChromaKey",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_feather": "hueFeather",
        "hue_feather_var": "hueFeatherVar",
        "hue_tolerance": "hueTolerance",
        "hue_tolerance_var": "hueToleranceVar",
        "hue_var": "hueVar",
        "lightness_feather": "lightnessFeather",
        "lightness_feather_var": "lightnessFeatherVar",
        "lightness_tolerance": "lightnessTolerance",
        "lightness_tolerance_var": "lightnessToleranceVar",
        "saturation_feather": "saturationFeather",
        "saturation_feather_var": "saturationFeatherVar",
        "saturation_tolerance": "saturationTolerance",
        "saturation_tolerance_var": "saturationToleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualChromaKey:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_feather: typing.Optional[builtins.str] = None,
        hue_feather_var: typing.Optional[builtins.str] = None,
        hue_tolerance: typing.Optional[builtins.str] = None,
        hue_tolerance_var: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness_feather: typing.Optional[builtins.str] = None,
        lightness_feather_var: typing.Optional[builtins.str] = None,
        lightness_tolerance: typing.Optional[builtins.str] = None,
        lightness_tolerance_var: typing.Optional[builtins.str] = None,
        saturation_feather: typing.Optional[builtins.str] = None,
        saturation_feather_var: typing.Optional[builtins.str] = None,
        saturation_tolerance: typing.Optional[builtins.str] = None,
        saturation_tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_feather: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        :param hue_feather_var: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        :param hue_tolerance: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        :param hue_tolerance_var: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        :param hue_var: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness_feather: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        :param lightness_feather_var: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        :param lightness_tolerance: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        :param lightness_tolerance_var: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        :param saturation_feather: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        :param saturation_feather_var: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        :param saturation_tolerance: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        :param saturation_tolerance_var: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__007b1698748997797532dfec4ba2576eb085528eb9370dfd3b0b4488be6d8448)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_feather", value=hue_feather, expected_type=type_hints["hue_feather"])
            check_type(argname="argument hue_feather_var", value=hue_feather_var, expected_type=type_hints["hue_feather_var"])
            check_type(argname="argument hue_tolerance", value=hue_tolerance, expected_type=type_hints["hue_tolerance"])
            check_type(argname="argument hue_tolerance_var", value=hue_tolerance_var, expected_type=type_hints["hue_tolerance_var"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness_feather", value=lightness_feather, expected_type=type_hints["lightness_feather"])
            check_type(argname="argument lightness_feather_var", value=lightness_feather_var, expected_type=type_hints["lightness_feather_var"])
            check_type(argname="argument lightness_tolerance", value=lightness_tolerance, expected_type=type_hints["lightness_tolerance"])
            check_type(argname="argument lightness_tolerance_var", value=lightness_tolerance_var, expected_type=type_hints["lightness_tolerance_var"])
            check_type(argname="argument saturation_feather", value=saturation_feather, expected_type=type_hints["saturation_feather"])
            check_type(argname="argument saturation_feather_var", value=saturation_feather_var, expected_type=type_hints["saturation_feather_var"])
            check_type(argname="argument saturation_tolerance", value=saturation_tolerance, expected_type=type_hints["saturation_tolerance"])
            check_type(argname="argument saturation_tolerance_var", value=saturation_tolerance_var, expected_type=type_hints["saturation_tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_feather is not None:
            self._values["hue_feather"] = hue_feather
        if hue_feather_var is not None:
            self._values["hue_feather_var"] = hue_feather_var
        if hue_tolerance is not None:
            self._values["hue_tolerance"] = hue_tolerance
        if hue_tolerance_var is not None:
            self._values["hue_tolerance_var"] = hue_tolerance_var
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness_feather is not None:
            self._values["lightness_feather"] = lightness_feather
        if lightness_feather_var is not None:
            self._values["lightness_feather_var"] = lightness_feather_var
        if lightness_tolerance is not None:
            self._values["lightness_tolerance"] = lightness_tolerance
        if lightness_tolerance_var is not None:
            self._values["lightness_tolerance_var"] = lightness_tolerance_var
        if saturation_feather is not None:
            self._values["saturation_feather"] = saturation_feather
        if saturation_feather_var is not None:
            self._values["saturation_feather_var"] = saturation_feather_var
        if saturation_tolerance is not None:
            self._values["saturation_tolerance"] = saturation_tolerance
        if saturation_tolerance_var is not None:
            self._values["saturation_tolerance_var"] = saturation_tolerance_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        '''
        result = self._values.get("hue_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        '''
        result = self._values.get("hue_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        '''
        result = self._values.get("hue_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        '''
        result = self._values.get("hue_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        '''
        result = self._values.get("lightness_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        '''
        result = self._values.get("lightness_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        '''
        result = self._values.get("lightness_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        '''
        result = self._values.get("lightness_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        '''
        result = self._values.get("saturation_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        '''
        result = self._values.get("saturation_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        '''
        result = self._values.get("saturation_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        result = self._values.get("saturation_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualChromaKey(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualChromaKeyList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualChromaKeyList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__842ae8ed796a78dff3255730284b51a2f26b9cf978a43106b2094575e02c075d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualChromaKeyOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aea7b999329d967606f6110ad5955dab3ecf374b4a0b7d2e456064de21dbe5d8)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualChromaKeyOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ebfe20b58a66c6c6bed54be893bc2a1335343beae64b3702577cdfcf119f37dd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e4a0384a13980fe5a83feafa9a56b5f63af18ee3f81cc084a6095a7e312e659a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4be24422e357f89598fab0224239393ba9019e6b19b03e215be11790f1ad0fe1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualChromaKey]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualChromaKey]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fc3cf809d878a3abe015c868fe0c805f38c30e67761c079e71370bc4ca600737)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualChromaKeyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualChromaKeyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__da59a2f08d574da02942eee1971ea72c4bec57d5d182836c1a44ea5958223399)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueFeather")
    def reset_hue_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeather", []))

    @jsii.member(jsii_name="resetHueFeatherVar")
    def reset_hue_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeatherVar", []))

    @jsii.member(jsii_name="resetHueTolerance")
    def reset_hue_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueTolerance", []))

    @jsii.member(jsii_name="resetHueToleranceVar")
    def reset_hue_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueToleranceVar", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightnessFeather")
    def reset_lightness_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeather", []))

    @jsii.member(jsii_name="resetLightnessFeatherVar")
    def reset_lightness_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeatherVar", []))

    @jsii.member(jsii_name="resetLightnessTolerance")
    def reset_lightness_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessTolerance", []))

    @jsii.member(jsii_name="resetLightnessToleranceVar")
    def reset_lightness_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessToleranceVar", []))

    @jsii.member(jsii_name="resetSaturationFeather")
    def reset_saturation_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeather", []))

    @jsii.member(jsii_name="resetSaturationFeatherVar")
    def reset_saturation_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeatherVar", []))

    @jsii.member(jsii_name="resetSaturationTolerance")
    def reset_saturation_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationTolerance", []))

    @jsii.member(jsii_name="resetSaturationToleranceVar")
    def reset_saturation_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherInput")
    def hue_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVarInput")
    def hue_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceInput")
    def hue_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVarInput")
    def hue_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherInput")
    def lightness_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVarInput")
    def lightness_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceInput")
    def lightness_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVarInput")
    def lightness_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherInput")
    def saturation_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVarInput")
    def saturation_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceInput")
    def saturation_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVarInput")
    def saturation_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a12a4a0f6b2dcd29b0f3b7214e56f50a7c2be642f57687a9fa34f2409ba759dc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeather")
    def hue_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeather"))

    @hue_feather.setter
    def hue_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__80352d811510b2d12206e0a7107fa202bfd81546b2e568c7be58e9f4f3a6c1ad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeather", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVar")
    def hue_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeatherVar"))

    @hue_feather_var.setter
    def hue_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5401ebcbe1df2ccebbd5735ee9791c85966f2e6d923ccb1480c5fc3455031737)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueTolerance")
    def hue_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueTolerance"))

    @hue_tolerance.setter
    def hue_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ab25c03afc7e49b48578efdc2a9c3373d3f8ff119f99953c2e1418d93bb9c1f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVar")
    def hue_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueToleranceVar"))

    @hue_tolerance_var.setter
    def hue_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2e64a293b62b74506e637020aed914ea7106c4eac6a325aa994d9db8f3fba4e5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__257adb3ae416bd6dfff2c2919665d9d407eb285faa4e6cbeaee1a169eacea1e2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeather")
    def lightness_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeather"))

    @lightness_feather.setter
    def lightness_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__10de4408311ed121e754721165bcc9f58190c12abadc9f7650124f61b8dcee9d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeather", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVar")
    def lightness_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeatherVar"))

    @lightness_feather_var.setter
    def lightness_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eedf92140ff9421b0568e0c96c6bbe2c810c5a0c4321b16fbbb94a65908461d0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessTolerance")
    def lightness_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessTolerance"))

    @lightness_tolerance.setter
    def lightness_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f353e85067bfff0def48e89a7b5191f65d4e9841af57e1b22292cc2b7020fc5e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVar")
    def lightness_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessToleranceVar"))

    @lightness_tolerance_var.setter
    def lightness_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b5b4201581aaa81cd08cae9433efb36204a4a2650f38af0612402a63f417a195)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeather")
    def saturation_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeather"))

    @saturation_feather.setter
    def saturation_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8630840ac8916c783f283c03950247f54e517f12b4b896eeba55160d12b637a8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeather", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVar")
    def saturation_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeatherVar"))

    @saturation_feather_var.setter
    def saturation_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9cc99dc40f8a6d29e8276cd339fc4e689548886c0467bec263cd2a26d7c7c1c9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationTolerance")
    def saturation_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationTolerance"))

    @saturation_tolerance.setter
    def saturation_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__81cd01640ec14b0daa24513bf06fb374fce0bd4ef52339f3a5001f7a6623e5fc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVar")
    def saturation_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationToleranceVar"))

    @saturation_tolerance_var.setter
    def saturation_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1e95639c3c71c200dd868173dc34f7b2da43f27b456e5ea63477dc1d05e4aea9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualChromaKey]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualChromaKey]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualChromaKey]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4596029c75970dfac6e32c35db1d1e0112a68b65f415be65151303b1dda53ecb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualComposite",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "placement": "placement",
        "placement_var": "placementVar",
        "scale": "scale",
        "scale_dimension": "scaleDimension",
        "scale_dimension_var": "scaleDimensionVar",
        "scale_var": "scaleVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualComposite:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualCompositeImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        placement: typing.Optional[builtins.str] = None,
        placement_var: typing.Optional[builtins.str] = None,
        scale: typing.Optional[builtins.str] = None,
        scale_dimension: typing.Optional[builtins.str] = None,
        scale_dimension_var: typing.Optional[builtins.str] = None,
        scale_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param placement: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        :param placement_var: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        :param scale: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param scale_dimension: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        :param scale_dimension_var: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        :param scale_var: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        :param x_position: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualCompositeImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c21466378f6fc7db571c18023f229cd550625d7d5830e6c603a24de764a157bf)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument placement", value=placement, expected_type=type_hints["placement"])
            check_type(argname="argument placement_var", value=placement_var, expected_type=type_hints["placement_var"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument scale_dimension", value=scale_dimension, expected_type=type_hints["scale_dimension"])
            check_type(argname="argument scale_dimension_var", value=scale_dimension_var, expected_type=type_hints["scale_dimension_var"])
            check_type(argname="argument scale_var", value=scale_var, expected_type=type_hints["scale_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if placement is not None:
            self._values["placement"] = placement
        if placement_var is not None:
            self._values["placement_var"] = placement_var
        if scale is not None:
            self._values["scale"] = scale
        if scale_dimension is not None:
            self._values["scale_dimension"] = scale_dimension
        if scale_dimension_var is not None:
            self._values["scale_dimension_var"] = scale_dimension_var
        if scale_var is not None:
            self._values["scale_var"] = scale_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualCompositeImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualCompositeImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        '''
        result = self._values.get("placement")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement_var(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        '''
        result = self._values.get("placement_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        '''
        result = self._values.get("scale_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        '''
        result = self._values.get("scale_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        '''
        result = self._values.get("scale_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualComposite(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualCompositeImage",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualCompositeImage:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualCompositeImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualCompositeImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualCompositeImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a249830f295f3a8111c8e0bd20cb09b6886a2b97eed27633bb29c038e5b5831b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualCompositeImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualCompositeImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__90d12082c143cff5ebe9216b0854c146dec8331a731b66d2e5ee0f6f432dafa7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualCompositeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualCompositeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6cc133c90815baefea34217f3f44a2144ef535fa4b2039ea2535b90e8ee6f525)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualCompositeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dbc379ad690c74e491986db4efa909d472486f1d5af8d1afdadc2519fd972fdc)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualCompositeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1a9d388195778f6c7a2666dcb11d82b7bdaf4de0f1ac1a1b4e3c1383d5523473)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__626305ee259d1c86e2a256c86cb4aed34208bfa3002fba7754e07514cd184498)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3fd02651ca57adf1f674ae0f7a4f808a91ef0b3d850ad52031f9a14d2568ffb8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualComposite]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualComposite]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b65daafd78687d2e02bcec286da26096102cd4a4c295f44eb1b4714b1581c8e8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualCompositeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualCompositeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__de4f50d42d6a0737a0616e6f2835cf52b2b2386d62fa929bb9a0c760af34bef3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualCompositeImage()

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPlacement")
    def reset_placement(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacement", []))

    @jsii.member(jsii_name="resetPlacementVar")
    def reset_placement_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacementVar", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetScaleDimension")
    def reset_scale_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimension", []))

    @jsii.member(jsii_name="resetScaleDimensionVar")
    def reset_scale_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimensionVar", []))

    @jsii.member(jsii_name="resetScaleVar")
    def reset_scale_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualCompositeImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualCompositeImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualCompositeImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="placementInput")
    def placement_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementInput"))

    @builtins.property
    @jsii.member(jsii_name="placementVarInput")
    def placement_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionInput")
    def scale_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVarInput")
    def scale_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleVarInput")
    def scale_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e4b76c1d8d68d87f943ccbd1ba8c76e88411d95a75b223a66ab253859647e0c8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a4b336d99c961be69f8463c83f5ad3ca7f4c814f7ef91583d0a5780fa223b9f2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="placement")
    def placement(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placement"))

    @placement.setter
    def placement(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1cdeebc50ebef935528db3cf305d6aac985633f3c23154110d3ded1b4eda9652)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placement", value)

    @builtins.property
    @jsii.member(jsii_name="placementVar")
    def placement_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placementVar"))

    @placement_var.setter
    def placement_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b54fd50658258d847d6bfee7d89914ba625ea5d1ebf4f001d13e46d26d7b2f3e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placementVar", value)

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scale"))

    @scale.setter
    def scale(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7b53b2b361e0124647d606db405f2a23002820eefce33a12ccea4f63bd9fdd7a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scale", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimension")
    def scale_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimension"))

    @scale_dimension.setter
    def scale_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__89f30cdecb884910a508b6c6ac519cdb5ec7d473b2385fc7186dc6f79605fd8e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimension", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVar")
    def scale_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimensionVar"))

    @scale_dimension_var.setter
    def scale_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8446f492c4e64d19d4a20b137a6f6b16cf234f0ff9d2d3fe2705faafe3cf9107)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="scaleVar")
    def scale_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleVar"))

    @scale_var.setter
    def scale_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ed34c22d5879ae94c15db9800b8b3ebace6cda0a9bd5e25ae55ce92b0f171f1d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e4a40bd1ccab670cc11280863d243afc36233e449bf351346b022dcb4f12ef75)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__087697730d5ae7206a11f11675f9a59ac52131a93d50e9a5644cf4a7a757a1e5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__757d836e8fff0e0d100d653ec45893beb1a90dd593a5475b79d1351b425dcb02)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a19b54777683c463d9b4360b15f33bafda31230047eed0269f538f5ae31c5c2b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualComposite]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualComposite]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualComposite]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7ba5c4a414d5b6590550082346331023773d8b47167d17489883c97fe3f76376)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualCompound",
    jsii_struct_bases=[],
    name_mapping={"transformations": "transformations"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualCompound:
    def __init__(
        self,
        *,
        transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param transformations: transformations block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__430e6b57bd2de544bf59926c738a5d6e9cfd1cd936b6b49e04b919be8b827978)
            check_type(argname="argument transformations", value=transformations, expected_type=type_hints["transformations"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if transformations is not None:
            self._values["transformations"] = transformations

    @builtins.property
    def transformations(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualCompoundTransformations"]]]:
        '''transformations block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        result = self._values.get("transformations")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualCompoundTransformations"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualCompound(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualCompoundList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualCompoundList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__97ecf8e9223abb95e70e9aa2bf28928bd8771cbd430828cfa1a5bf5acc4a1811)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualCompoundOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bccc3bf8abbea4d6a0f598f712e2d5137605288630f9aecb58c1984518641c7c)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualCompoundOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a3609cb8ab15dbd1b4d8f02a1b35aaf8cf907a7489e79cc78564cb606180621e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2c6845ee7d463b556cd4d684cfb1ba8575282c70d765e98495243c4a730ca90a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__924602fcc8b5334ef22f7ee9548ede969bdfc1d86cff6801c2957b55f0713078)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualCompound]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualCompound]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2821d3b92f0d4b7092f06b07c93606ef3cbd0776c0b95aa35cc17c9a565698d2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualCompoundOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualCompoundOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a3215b9631fcda5bdc89c289479465f8371c6978f0ec3a592ff7b6e4fe4bcd57)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformations")
    def put_transformations(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eefb322489e4213258f319179d4d3f2749addf67c5bb302003f23e01ca9b1734)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTransformations", [value]))

    @jsii.member(jsii_name="resetTransformations")
    def reset_transformations(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformations", []))

    @builtins.property
    @jsii.member(jsii_name="transformations")
    def transformations(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualCompoundTransformationsList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualCompoundTransformationsList", jsii.get(self, "transformations"))

    @builtins.property
    @jsii.member(jsii_name="transformationsInput")
    def transformations_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualCompoundTransformations"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualCompoundTransformations"]]], jsii.get(self, "transformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualCompound]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualCompound]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualCompound]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df3fded13790b553bdc13c2f0cf7efb84ae453236d7f45d86d3927817bdcd0fb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualCompoundTransformations",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualCompoundTransformations:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualCompoundTransformations(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualCompoundTransformationsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualCompoundTransformationsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__628cba713061046a070ee5b0100a027115340b53c9e9ed6810eaa57572932700)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualCompoundTransformationsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5aba76384ac40b3496afd406e0037c34c0c4171aba59e77a353d06edb86c7293)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualCompoundTransformationsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__69bde56cd6ca0f288ffa9c955c4230b0b077ebc1d4e5ba91a4b58d17d23e1175)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e7bacf2f20fc29c6faaffac0c86ecb6941a104240b6ed1b519f8b9451e3a9c88)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__623c0f3548248af29d7204ff11822fab24c4543447abc55a6f02e247488b9847)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualCompoundTransformations]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualCompoundTransformations]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualCompoundTransformations]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0e533cf80b379bfca4a72031f378616ee30784a78e58973770fd94931c7d37fa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualCompoundTransformationsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualCompoundTransformationsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__64c48eab53d3b30ab46b499fad5f7e8be85f8060bedcdc257f28a4292075e22c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualCompoundTransformations]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualCompoundTransformations]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualCompoundTransformations]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e9b59c26a9e493a9429fb7625c80dda90d2b4c3ac7bd4abc8c973a294820af01)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualContrast",
    jsii_struct_bases=[],
    name_mapping={
        "brightness": "brightness",
        "brightness_var": "brightnessVar",
        "contrast": "contrast",
        "contrast_var": "contrastVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualContrast:
    def __init__(
        self,
        *,
        brightness: typing.Optional[builtins.str] = None,
        brightness_var: typing.Optional[builtins.str] = None,
        contrast: typing.Optional[builtins.str] = None,
        contrast_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param brightness: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        :param brightness_var: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        :param contrast: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param contrast_var: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f8bb3459fd138cc7e35a83e1bc627771e95e5355c82948f7fe35020ddceb327)
            check_type(argname="argument brightness", value=brightness, expected_type=type_hints["brightness"])
            check_type(argname="argument brightness_var", value=brightness_var, expected_type=type_hints["brightness_var"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument contrast_var", value=contrast_var, expected_type=type_hints["contrast_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if brightness is not None:
            self._values["brightness"] = brightness
        if brightness_var is not None:
            self._values["brightness_var"] = brightness_var
        if contrast is not None:
            self._values["contrast"] = contrast
        if contrast_var is not None:
            self._values["contrast_var"] = contrast_var

    @builtins.property
    def brightness(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        '''
        result = self._values.get("brightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def brightness_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        '''
        result = self._values.get("brightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        result = self._values.get("contrast_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualContrast(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualContrastList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualContrastList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0f86c837d3cba7eb98f3dcc551eadd9c78bb7c9bf08312f0dbe98a0faa26a72d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualContrastOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb73df64b4d8f122a5f53b9bad5777610eb40d520c29b0c8dee702cec6e355ab)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualContrastOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fce84a1b12e14f2cc6447177cdb4867ac641692e3dea0ace6b1ce84908295214)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1a5358f7838c05ece3b6470a8da846031eb2dfea85941dc844445637f35123cf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d9061f1399a89b4f3c61676c6bfc64f7a9e5d93ac24096e09928534555bd2815)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualContrast]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualContrast]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__db3b0c369b0bf5484ffc7e8bc8a61b94130e7be6a99185eb307287f445aacf56)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualContrastOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualContrastOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3249dc33349490329b7b39dcf23970acf424271f3b480cc36df42d963fc0e302)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetBrightness")
    def reset_brightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightness", []))

    @jsii.member(jsii_name="resetBrightnessVar")
    def reset_brightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightnessVar", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetContrastVar")
    def reset_contrast_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrastVar", []))

    @builtins.property
    @jsii.member(jsii_name="brightnessInput")
    def brightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="brightnessVarInput")
    def brightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastVarInput")
    def contrast_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="brightness")
    def brightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightness"))

    @brightness.setter
    def brightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dae7ec8dbb6b52f047fee46f05199dc33d4e0f2ebe573b5d0711644bef91aea3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightness", value)

    @builtins.property
    @jsii.member(jsii_name="brightnessVar")
    def brightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightnessVar"))

    @brightness_var.setter
    def brightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__36308cb5dca9001b9776d0bc1d0accb1b0dacbad25fe96a0d04a1f178eb35141)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrast"))

    @contrast.setter
    def contrast(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__382d26b750b281f716eb60056ff04d083d36a45ff0203fb7275502ef19bee84c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrast", value)

    @builtins.property
    @jsii.member(jsii_name="contrastVar")
    def contrast_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrastVar"))

    @contrast_var.setter
    def contrast_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3666ef8f1da2919c70eae2e5a39ab8e862ff5a5773ccd068b6d540aea6f61f7c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrastVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualContrast]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualContrast]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualContrast]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f55dc7630d4771bfe1e1981878cfc4ce881705b471b083d46cbc99831cb1228b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualGoop",
    jsii_struct_bases=[],
    name_mapping={
        "chaos": "chaos",
        "chaos_var": "chaosVar",
        "density": "density",
        "density_var": "densityVar",
        "power": "power",
        "power_var": "powerVar",
        "seed": "seed",
        "seed_var": "seedVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualGoop:
    def __init__(
        self,
        *,
        chaos: typing.Optional[builtins.str] = None,
        chaos_var: typing.Optional[builtins.str] = None,
        density: typing.Optional[builtins.str] = None,
        density_var: typing.Optional[builtins.str] = None,
        power: typing.Optional[builtins.str] = None,
        power_var: typing.Optional[builtins.str] = None,
        seed: typing.Optional[builtins.str] = None,
        seed_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param chaos: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        :param chaos_var: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        :param density: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        :param density_var: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        :param power: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        :param power_var: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        :param seed: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        :param seed_var: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__15e2687d1374dda0a2706f8f9f3b564ac6e72b949e980ccd61237d4cde0b23cb)
            check_type(argname="argument chaos", value=chaos, expected_type=type_hints["chaos"])
            check_type(argname="argument chaos_var", value=chaos_var, expected_type=type_hints["chaos_var"])
            check_type(argname="argument density", value=density, expected_type=type_hints["density"])
            check_type(argname="argument density_var", value=density_var, expected_type=type_hints["density_var"])
            check_type(argname="argument power", value=power, expected_type=type_hints["power"])
            check_type(argname="argument power_var", value=power_var, expected_type=type_hints["power_var"])
            check_type(argname="argument seed", value=seed, expected_type=type_hints["seed"])
            check_type(argname="argument seed_var", value=seed_var, expected_type=type_hints["seed_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if chaos is not None:
            self._values["chaos"] = chaos
        if chaos_var is not None:
            self._values["chaos_var"] = chaos_var
        if density is not None:
            self._values["density"] = density
        if density_var is not None:
            self._values["density_var"] = density_var
        if power is not None:
            self._values["power"] = power
        if power_var is not None:
            self._values["power_var"] = power_var
        if seed is not None:
            self._values["seed"] = seed
        if seed_var is not None:
            self._values["seed_var"] = seed_var

    @builtins.property
    def chaos(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        '''
        result = self._values.get("chaos")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def chaos_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        '''
        result = self._values.get("chaos_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        '''
        result = self._values.get("density")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density_var(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        '''
        result = self._values.get("density_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        '''
        result = self._values.get("power")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power_var(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        '''
        result = self._values.get("power_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        '''
        result = self._values.get("seed")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed_var(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        result = self._values.get("seed_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualGoop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualGoopList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualGoopList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c9ee979a9b038b7b9f7ebfd0756e9411d4a7352d23f9f6cb8341672b9b4b6068)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualGoopOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c98a6b91c45a69632a3bfc35a5cffb64770d98231c99e37a35ce7ec1fb4c77be)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualGoopOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eee5b520bbd35a22c27beb624ad08993ef31103e3f528c588a064f61ca0d14c7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4383ac2798c104c649582a2cd213c683cbc26217df29a2acc3eb93d77b95bb79)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__88949a685338262ae05b2afa937e09887f6daa650e208dd0840f8885f9823dd4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualGoop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualGoop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d23e6b83cbf22877634fb883a08e41d7c4ec1c78353e07a3940f8a371d2d9a4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualGoopOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualGoopOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8168e6194efdc2991b76c0d4d57207b08609508c3555c91975576d9e7c87763c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetChaos")
    def reset_chaos(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaos", []))

    @jsii.member(jsii_name="resetChaosVar")
    def reset_chaos_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaosVar", []))

    @jsii.member(jsii_name="resetDensity")
    def reset_density(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensity", []))

    @jsii.member(jsii_name="resetDensityVar")
    def reset_density_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensityVar", []))

    @jsii.member(jsii_name="resetPower")
    def reset_power(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPower", []))

    @jsii.member(jsii_name="resetPowerVar")
    def reset_power_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPowerVar", []))

    @jsii.member(jsii_name="resetSeed")
    def reset_seed(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeed", []))

    @jsii.member(jsii_name="resetSeedVar")
    def reset_seed_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeedVar", []))

    @builtins.property
    @jsii.member(jsii_name="chaosInput")
    def chaos_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosInput"))

    @builtins.property
    @jsii.member(jsii_name="chaosVarInput")
    def chaos_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosVarInput"))

    @builtins.property
    @jsii.member(jsii_name="densityInput")
    def density_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityInput"))

    @builtins.property
    @jsii.member(jsii_name="densityVarInput")
    def density_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="powerInput")
    def power_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerInput"))

    @builtins.property
    @jsii.member(jsii_name="powerVarInput")
    def power_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerVarInput"))

    @builtins.property
    @jsii.member(jsii_name="seedInput")
    def seed_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedInput"))

    @builtins.property
    @jsii.member(jsii_name="seedVarInput")
    def seed_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedVarInput"))

    @builtins.property
    @jsii.member(jsii_name="chaos")
    def chaos(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaos"))

    @chaos.setter
    def chaos(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__317a986d1ef4ecf33e78d5500f96d94b91bd81f3b6589adad7c5b8d90b8dea28)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaos", value)

    @builtins.property
    @jsii.member(jsii_name="chaosVar")
    def chaos_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaosVar"))

    @chaos_var.setter
    def chaos_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0389134764a3df29f71fe42cf0f2cf3841af41361dcd08482955e42f53672c15)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaosVar", value)

    @builtins.property
    @jsii.member(jsii_name="density")
    def density(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "density"))

    @density.setter
    def density(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f6ab8befd3690ec1e87eea0836781a44347eab73af9cd4e50c22ac3956d0c9f4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "density", value)

    @builtins.property
    @jsii.member(jsii_name="densityVar")
    def density_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "densityVar"))

    @density_var.setter
    def density_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cb38fb9ca76de69ef5e891b66f74f3519a502de86672e20fb198a59971896cdb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "densityVar", value)

    @builtins.property
    @jsii.member(jsii_name="power")
    def power(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "power"))

    @power.setter
    def power(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e893361f11f29a62f5c624150e1ea323440e9d96fcd5e58416a7b54d7f1281c0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "power", value)

    @builtins.property
    @jsii.member(jsii_name="powerVar")
    def power_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "powerVar"))

    @power_var.setter
    def power_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__58cf3809ebc72ae587efd7a9e44da6c33daa4c7059193dc85a8f15ae4a23d892)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "powerVar", value)

    @builtins.property
    @jsii.member(jsii_name="seed")
    def seed(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seed"))

    @seed.setter
    def seed(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7a8fdc3350dcbcae2207e5e2e201ce37bb39ebc00843d313920355bbe127aac5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seed", value)

    @builtins.property
    @jsii.member(jsii_name="seedVar")
    def seed_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seedVar"))

    @seed_var.setter
    def seed_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0557788163d114ed3587a7719744d6bd9df72d33bed69f4efc408ee56bdb40f5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seedVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualGoop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualGoop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualGoop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5dd5d428b701a9af6596b8fca4af51b895a74cc83b8bfbc55103991d8612429e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualGrayscale",
    jsii_struct_bases=[],
    name_mapping={"type": "type", "type_var": "typeVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualGrayscale:
    def __init__(
        self,
        *,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param type: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ad21d808ddf9ceefbfe67e471d379e011d70c830181e9db64101b83150ad4528)
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualGrayscale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualGrayscaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualGrayscaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c99bdf413704379ce5ebf6197d84d3e310c14f91686e19f96c8f77b68e1cba56)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualGrayscaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e4529ad54e218ce6a9ae76f9bfa5f557755bbaabb3c3d096e5b754fd7894be5b)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualGrayscaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a3e1e9f761ae29731eca76630dbd733c120cdb801de40d2a872a53da0ec8f5ad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f02738ea79b64878189d3862ec1beb93585d42b07d6877342c02fa04d5161986)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6661061cbfce6f22432a1773b81f1185a94b89d87538c6078016046ad4c58e62)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualGrayscale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualGrayscale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a39e120e19a9da4d1c6de358f870c1d0702eb08e5d0e083620e6f4d3438f13ef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualGrayscaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualGrayscaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3b989b14eafc8a2b4cd5bb66f992c6a086357b98980e3949c55b09f9f6630424)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c016b914f1f705282c4dec3c1c3ff79183d29fa3a212cfa8c065c76c2890f4c8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a0149eee7a2499994c69deb2db87bc0821116ae1c77ae99ab61b30d825c276e5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualGrayscale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualGrayscale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualGrayscale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__151e5b33d16caf1b26832e34d8d145979a62e140ce03ae0de1d98da83a7fa4e5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualHsl",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "lightness": "lightness",
        "lightness_var": "lightnessVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualHsl:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness: typing.Optional[builtins.str] = None,
        lightness_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        :param lightness_var: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__91ed6f35b548a2f3eb6c600e08b5d8b28398f710168bedaab9153c806dc79386)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness", value=lightness, expected_type=type_hints["lightness"])
            check_type(argname="argument lightness_var", value=lightness_var, expected_type=type_hints["lightness_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness is not None:
            self._values["lightness"] = lightness
        if lightness_var is not None:
            self._values["lightness_var"] = lightness_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        '''
        result = self._values.get("lightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        '''
        result = self._values.get("lightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualHsl(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualHslList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualHslList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7fe5623e0fa8c604e9d30d088205b9dcef5b32f65da0a160021ca5b51219f4b9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualHslOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a991866504b2fcc5799f626835131f4eb42b25731fec54885e2b9ae4afc8cc68)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualHslOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1feca9705bef2787853bd0e68763712a96b42e6499bea2111428c372858e4f84)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b07a21474009f1d4bb3d2fa726d6d711d982fc0efc7e584e6714a90aa66fb5c4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd938f1409b7b7d931e9d9e19b9754c55a500e7e2db2491c04654b002faed47d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualHsl]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualHsl]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__05262a78d36d7feae5d3756dcf98df2af5eabf574f06ec2d0179b38d43821f54)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualHslOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualHslOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__66abc18e5368f1b7200c7821a09aad1d80b307b24bc84cc45c40902c53bcd537)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightness")
    def reset_lightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightness", []))

    @jsii.member(jsii_name="resetLightnessVar")
    def reset_lightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessInput")
    def lightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessVarInput")
    def lightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a42d2a6ad1cad279afe97b5a20cc237ffde9a3fa4e960f5befab786ef8dad94)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__53a7e71370cbe9e21ef61175efda2033e65692ef47af99fc106be9cd99e02e01)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightness")
    def lightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightness"))

    @lightness.setter
    def lightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3f8b738089cca2b2c690b3a96b720c6fdbb47df1992e3c82d80cbe7da818c413)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightness", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessVar")
    def lightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessVar"))

    @lightness_var.setter
    def lightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__83aded0c17fbed414d83119ab636c85942217e1a69b1521790a6cbbd7f43cce8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f17707f67931d9c9540501c6dafdeb2ea6110d84dd39fb8daeddea031a7c33d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9f4166dd5e86ce5c38cfbab76efe1c0ef7f7b82ac9b235dd4b7fdeea3c599821)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualHsl]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualHsl]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualHsl]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__22fbeca720678a0c1ed0851ec29109a820f2eb8959626b5e607ffec6314d3473)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualHsv",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualHsv:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        :param value: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__58e81929fa1c0ede5469be85d30c8eb937bd59cd999700d58a963dd7f865762d)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualHsv(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualHsvList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualHsvList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8450bef7806c14fd704e5163dbb0af20d847a7152950cb11a1e79dae69c0ff78)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualHsvOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0bdc06319c0c65ae91a9da25f4e9e9111efb30cc8087d321e163a1cbe6f7a9c3)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualHsvOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3cb609b73e251620cc476b78ac4f8ce7c4fb32a1b8352cb5554c3dc25fdc0f28)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7e3750ec74fa1f542f0df13ea90070d69e311845a9c09139f168c8acd849fe14)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9cc421d8435ec13fcb580d5a2e74f68af8a4b64b25c934080836f14c7b7deae3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualHsv]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualHsv]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bfcbebe3593d8c40cf3cf13ed4165a255dbe4e6d638ea893fa6eac8afe28da81)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualHsvOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualHsvOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ae8f8e41f585a04c194de10d115f48def6beffddb1618e36049405d448a62614)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__47d26b4d5ba8bf9416978d25ce740b0d866d6ac1fde33c546b971d009a9758e2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1109270fc81df42daaeccc880bdfc444e324808078ad80b089f423e3ebda9994)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__327589ef50dc68461a75c1a308656d8b4492fa6febc7e57234ce3864e6d8d0ea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c48bce09ffd6a856faa94f1f6689e149b56bb7c36c2e937dfd81e508d20f67e8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6d14b17142ec677eeb1b1850b41d18aecc1baf7968d667e3698272253a3f3b3f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3953cbe553ba4500be1bce74c0b513b0485a662053280bbb2a0896ab3aaaef6f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualHsv]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualHsv]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualHsv]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e24f822cd899d4018b6651948daaaf1e9fea2ab94bebb6efe13b05b44df1f006)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfDimension",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "dimension": "dimension",
        "dimension_var": "dimensionVar",
        "equal": "equal",
        "greater_than": "greaterThan",
        "less_than": "lessThan",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfDimension:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        dimension: typing.Optional[builtins.str] = None,
        dimension_var: typing.Optional[builtins.str] = None,
        equal: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionEqual", typing.Dict[builtins.str, typing.Any]]] = None,
        greater_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionGreaterThan", typing.Dict[builtins.str, typing.Any]]] = None,
        less_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionLessThan", typing.Dict[builtins.str, typing.Any]]] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param dimension: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        :param dimension_var: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        :param equal: equal block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        :param greater_than: greater_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        :param less_than: less_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        :param value: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionDefault(**default)
        if isinstance(equal, dict):
            equal = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionEqual(**equal)
        if isinstance(greater_than, dict):
            greater_than = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionGreaterThan(**greater_than)
        if isinstance(less_than, dict):
            less_than = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionLessThan(**less_than)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3c4e5deb87b20737137e741dde6c20dbf63bdc151a08dbbcd3f33c9227282847)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument dimension", value=dimension, expected_type=type_hints["dimension"])
            check_type(argname="argument dimension_var", value=dimension_var, expected_type=type_hints["dimension_var"])
            check_type(argname="argument equal", value=equal, expected_type=type_hints["equal"])
            check_type(argname="argument greater_than", value=greater_than, expected_type=type_hints["greater_than"])
            check_type(argname="argument less_than", value=less_than, expected_type=type_hints["less_than"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if dimension is not None:
            self._values["dimension"] = dimension
        if dimension_var is not None:
            self._values["dimension_var"] = dimension_var
        if equal is not None:
            self._values["equal"] = equal
        if greater_than is not None:
            self._values["greater_than"] = greater_than
        if less_than is not None:
            self._values["less_than"] = less_than
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionDefault"], result)

    @builtins.property
    def dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        '''
        result = self._values.get("dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        '''
        result = self._values.get("dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def equal(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionEqual"]:
        '''equal block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        '''
        result = self._values.get("equal")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionEqual"], result)

    @builtins.property
    def greater_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionGreaterThan"]:
        '''greater_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        '''
        result = self._values.get("greater_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionGreaterThan"], result)

    @builtins.property
    def less_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionLessThan"]:
        '''less_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        '''
        result = self._values.get("less_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionLessThan"], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfDimension(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__56d842f8b0e787d1e7dde6fae6ea2a6cc832151fee1029ed68b62809491e2f94)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b94e5eee0964ddf089b7b3e824bbc919f5ca4fdb932bc8fab269de558a1ecec4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionEqual",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionEqual:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionEqual(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionEqualOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionEqualOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0493f8a54c96a776d5c47a014c94fc2a41f0e1b1435cdd4671ad7703dab3b8c2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionEqual], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionEqual],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8c3644b6ae54b5e9f5243987eacee5f8a229444aa39fdf9d1b213642aa0622bc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionGreaterThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionGreaterThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionGreaterThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionGreaterThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionGreaterThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c234a4ac08a26e70e5d0cee733fc3d10546686073b2ea6bfba621ad761a78adb)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionGreaterThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionGreaterThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__53079379c67c29b64f4ba9fd55b71d87902eaf84a2333a473d957e76dd488256)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionLessThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionLessThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionLessThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionLessThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionLessThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b9ae7720993f0b1825a7bb94db9dfea3575539e5324677f1e46831571abf09d3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionLessThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionLessThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__131db8f53fd0e931c2f0f04e5d9d3a29c58c8e9878766654d8c36ec8a0ab1eb1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3c9c95e2596cd619fe269949eb14a4299c68abac904c410b59fc643f85e3bdea)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__07ac4b2323bc513f42797183eaf5e112b8023e681c1741c0a3607d907872e5e4)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__930d47953f8c1822085529ddcbfffb399675f0a3c673c43334343098eab3a970)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c9dcde1bb32866047ac0be927a9d9df20e135dc93a79e17420a41ebe08ddf3df)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__efdc077bf94f8a7919679d410bf70a17d4678bae0e244dbcc06388c54b6b5df6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfDimension]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfDimension]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__020e12263875847cc9504e8c12bba6ccb60e2dbeb865f1778ee82ea9bd2568d1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5a192befac224d07a71114d5bd677d119e6a51baed7017ea3ebe622294859812)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putEqual")
    def put_equal(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionEqual()

        return typing.cast(None, jsii.invoke(self, "putEqual", [value]))

    @jsii.member(jsii_name="putGreaterThan")
    def put_greater_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionGreaterThan()

        return typing.cast(None, jsii.invoke(self, "putGreaterThan", [value]))

    @jsii.member(jsii_name="putLessThan")
    def put_less_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionLessThan()

        return typing.cast(None, jsii.invoke(self, "putLessThan", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetDimension")
    def reset_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimension", []))

    @jsii.member(jsii_name="resetDimensionVar")
    def reset_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimensionVar", []))

    @jsii.member(jsii_name="resetEqual")
    def reset_equal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEqual", []))

    @jsii.member(jsii_name="resetGreaterThan")
    def reset_greater_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGreaterThan", []))

    @jsii.member(jsii_name="resetLessThan")
    def reset_less_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLessThan", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="equal")
    def equal(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionEqualOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionEqualOutputReference, jsii.get(self, "equal"))

    @builtins.property
    @jsii.member(jsii_name="greaterThan")
    def greater_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionGreaterThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionGreaterThanOutputReference, jsii.get(self, "greaterThan"))

    @builtins.property
    @jsii.member(jsii_name="lessThan")
    def less_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionLessThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionLessThanOutputReference, jsii.get(self, "lessThan"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionInput")
    def dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionVarInput")
    def dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="equalInput")
    def equal_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionEqual], jsii.get(self, "equalInput"))

    @builtins.property
    @jsii.member(jsii_name="greaterThanInput")
    def greater_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionGreaterThan], jsii.get(self, "greaterThanInput"))

    @builtins.property
    @jsii.member(jsii_name="lessThanInput")
    def less_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionLessThan], jsii.get(self, "lessThanInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="dimension")
    def dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimension"))

    @dimension.setter
    def dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d69a95d73c373ece12b1ddf4d727d2f37f721b0b95ab243ee185917047a24b34)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimension", value)

    @builtins.property
    @jsii.member(jsii_name="dimensionVar")
    def dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimensionVar"))

    @dimension_var.setter
    def dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c27e26d8551067d9c1f7224f4ea45c5286cabd895d849227f10e149b8b2f0100)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d31356aa60bd7fe9c30f8e5baa21d5c35b781dd47c24ff6d42bc64aaaf0a820)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8ba06b8fe5b388a675561f259329105cf6ac72cecc61c277bbe1ab9e77551181)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfDimension]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfDimension]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfDimension]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__855137f1b57d756fcaca18c03ddf00b7219074a484c2697c5ee02fa17a9d77bf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfOrientation",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "landscape": "landscape",
        "portrait": "portrait",
        "square": "square",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfOrientation:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        landscape: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationLandscape", typing.Dict[builtins.str, typing.Any]]] = None,
        portrait: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationPortrait", typing.Dict[builtins.str, typing.Any]]] = None,
        square: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationSquare", typing.Dict[builtins.str, typing.Any]]] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param landscape: landscape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        :param portrait: portrait block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        :param square: square block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationDefault(**default)
        if isinstance(landscape, dict):
            landscape = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationLandscape(**landscape)
        if isinstance(portrait, dict):
            portrait = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationPortrait(**portrait)
        if isinstance(square, dict):
            square = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationSquare(**square)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cc7a2f46d35a81044394fd9e71e2b8c66ba052a2f7a040dd636c4a161b49edfc)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument landscape", value=landscape, expected_type=type_hints["landscape"])
            check_type(argname="argument portrait", value=portrait, expected_type=type_hints["portrait"])
            check_type(argname="argument square", value=square, expected_type=type_hints["square"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if landscape is not None:
            self._values["landscape"] = landscape
        if portrait is not None:
            self._values["portrait"] = portrait
        if square is not None:
            self._values["square"] = square

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationDefault"], result)

    @builtins.property
    def landscape(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationLandscape"]:
        '''landscape block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        '''
        result = self._values.get("landscape")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationLandscape"], result)

    @builtins.property
    def portrait(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationPortrait"]:
        '''portrait block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        '''
        result = self._values.get("portrait")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationPortrait"], result)

    @builtins.property
    def square(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationSquare"]:
        '''square block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        result = self._values.get("square")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationSquare"], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfOrientation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1ff4ebc4f1d8e401e11e18efc94ad26040e38f13614f6769dc591c48ee809d05)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b073391c4d0feedec5275faf10088f95ab8f6a715ccb87865d621eeb698e4df9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationLandscape",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationLandscape:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationLandscape(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationLandscapeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationLandscapeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ba186dedffb8004a694e23ec274d237d878e27d82bf3b6ada52343bd570b8e5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationLandscape], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationLandscape],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aa56192128c9f20190fa4fab9876e3ac6169323d15815f4551c8a4f3239a3cc8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c98617a685a74db418387a4fb006694ac2f0a7527c45529550d43ca8460b4125)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3991a67b90cff75681136e985bfe758482f6280ed64d5ddb18df611db59e0b25)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1d958a82ab966bf9d11bec766219b72f4dd15b6c90eaddf77e88c188b385bd5e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3378b51f4a877397753d422d778c6d0fdb8fdcb0210c0ba780e6f5417b20b9fa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e08275e4c03dce2369cd8ce0961bdabefc0be294cab6046c0027e0d8e236335b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfOrientation]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfOrientation]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__67a3568eb968b046729e0f65f68fdcec2ac66473ac4f3deeef59ba058d6f7814)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__77e3730c805a54279421422985bcdb29a5a67e0e1cf0cbaf959c98add9fd71fa)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putLandscape")
    def put_landscape(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationLandscape()

        return typing.cast(None, jsii.invoke(self, "putLandscape", [value]))

    @jsii.member(jsii_name="putPortrait")
    def put_portrait(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationPortrait()

        return typing.cast(None, jsii.invoke(self, "putPortrait", [value]))

    @jsii.member(jsii_name="putSquare")
    def put_square(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationSquare()

        return typing.cast(None, jsii.invoke(self, "putSquare", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetLandscape")
    def reset_landscape(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLandscape", []))

    @jsii.member(jsii_name="resetPortrait")
    def reset_portrait(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPortrait", []))

    @jsii.member(jsii_name="resetSquare")
    def reset_square(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSquare", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="landscape")
    def landscape(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationLandscapeOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationLandscapeOutputReference, jsii.get(self, "landscape"))

    @builtins.property
    @jsii.member(jsii_name="portrait")
    def portrait(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationPortraitOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationPortraitOutputReference", jsii.get(self, "portrait"))

    @builtins.property
    @jsii.member(jsii_name="square")
    def square(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationSquareOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationSquareOutputReference", jsii.get(self, "square"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="landscapeInput")
    def landscape_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationLandscape], jsii.get(self, "landscapeInput"))

    @builtins.property
    @jsii.member(jsii_name="portraitInput")
    def portrait_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationPortrait"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationPortrait"], jsii.get(self, "portraitInput"))

    @builtins.property
    @jsii.member(jsii_name="squareInput")
    def square_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationSquare"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationSquare"], jsii.get(self, "squareInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfOrientation]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfOrientation]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfOrientation]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__053ead163539b3a589f8227673008c743805844f9159ff953b9757a9b0bc42d3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationPortrait",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationPortrait:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationPortrait(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationPortraitOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationPortraitOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__da69abe91456c4d5f457e4b181d35d8bfdaf1056c482736c7dc626c091b090c7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationPortrait]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationPortrait], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationPortrait],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7ba0daf9daed4f5313b8e3702aa1e9a7064231c236608e3d965f2724aeb2e8b8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationSquare",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationSquare:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationSquare(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationSquareOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationSquareOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5187bf21389bfd5a5097125c09d6b8905e2963f3cd354d3d30231ef773c24e2b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationSquare]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationSquare], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationSquare],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__91f05a9bc52566d563cf5cf0558a75babe6efe6514363500e663050501f2df63)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualMaxColors",
    jsii_struct_bases=[],
    name_mapping={"colors": "colors", "colors_var": "colorsVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualMaxColors:
    def __init__(
        self,
        *,
        colors: typing.Optional[builtins.str] = None,
        colors_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param colors: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        :param colors_var: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4cbe310da7a74efcd97b4aac947b47e91c1d7b46060e425bf94cd3151c07f7b2)
            check_type(argname="argument colors", value=colors, expected_type=type_hints["colors"])
            check_type(argname="argument colors_var", value=colors_var, expected_type=type_hints["colors_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if colors is not None:
            self._values["colors"] = colors
        if colors_var is not None:
            self._values["colors_var"] = colors_var

    @builtins.property
    def colors(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        '''
        result = self._values.get("colors")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def colors_var(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        result = self._values.get("colors_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualMaxColors(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualMaxColorsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualMaxColorsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d19847ffbe21b47ce64bafa409571bd835da4a0bd2c39ca680333deefc70ce28)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualMaxColorsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc44791cdb1de977033c7e08f97a95d2c6aec066766bf7c6ecf28a6ec0298f1b)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualMaxColorsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__22528d2a6b16d23ebb9c694128683f5c93b7ffc3c7414ec45f7f96722e0de392)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1bc3992c5580b41de9302b686b0c7b1783415a4132f2eed048e0e32c67584119)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a8415b7d10be2721dbd4a04291b715395a408aeaae98fc02182d68402077e16)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualMaxColors]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualMaxColors]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6a60177f154a162cd48118a7e01742edd5813e9e736ffac12d94cc9bc314fed9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualMaxColorsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualMaxColorsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__647e2f4bdfeb361a52995d9c24cb8c0c8d34657b31dd8bee8c239babe0ccb8a4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColors")
    def reset_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColors", []))

    @jsii.member(jsii_name="resetColorsVar")
    def reset_colors_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorsVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorsInput")
    def colors_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsInput"))

    @builtins.property
    @jsii.member(jsii_name="colorsVarInput")
    def colors_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsVarInput"))

    @builtins.property
    @jsii.member(jsii_name="colors")
    def colors(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colors"))

    @colors.setter
    def colors(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__29a9338bbf6f6f6ed57e07fdd4ff3cd55dc02d537b950148570420b5e10ad0df)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colors", value)

    @builtins.property
    @jsii.member(jsii_name="colorsVar")
    def colors_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorsVar"))

    @colors_var.setter
    def colors_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__26428f03d7983939df73bb8b32edec3eb17c4a930126485baeaf323baf452ec4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorsVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualMaxColors]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualMaxColors]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualMaxColors]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__139050747a864382f27763f35f2394e5bf6302f3f37ae1ec51cc7a8a8e69f6ca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualMirror",
    jsii_struct_bases=[],
    name_mapping={
        "horizontal": "horizontal",
        "horizontal_var": "horizontalVar",
        "vertical": "vertical",
        "vertical_var": "verticalVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualMirror:
    def __init__(
        self,
        *,
        horizontal: typing.Optional[builtins.str] = None,
        horizontal_var: typing.Optional[builtins.str] = None,
        vertical: typing.Optional[builtins.str] = None,
        vertical_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param horizontal: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        :param horizontal_var: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        :param vertical: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        :param vertical_var: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6b2c117356d4259e1ad31ea0978af8444cecfeac47c1c870c7d5819e9afa5f92)
            check_type(argname="argument horizontal", value=horizontal, expected_type=type_hints["horizontal"])
            check_type(argname="argument horizontal_var", value=horizontal_var, expected_type=type_hints["horizontal_var"])
            check_type(argname="argument vertical", value=vertical, expected_type=type_hints["vertical"])
            check_type(argname="argument vertical_var", value=vertical_var, expected_type=type_hints["vertical_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if horizontal is not None:
            self._values["horizontal"] = horizontal
        if horizontal_var is not None:
            self._values["horizontal_var"] = horizontal_var
        if vertical is not None:
            self._values["vertical"] = vertical
        if vertical_var is not None:
            self._values["vertical_var"] = vertical_var

    @builtins.property
    def horizontal(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        '''
        result = self._values.get("horizontal")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def horizontal_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        '''
        result = self._values.get("horizontal_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        '''
        result = self._values.get("vertical")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        result = self._values.get("vertical_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualMirror(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualMirrorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualMirrorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ed3434c48bebef8f59e5aefb2c1e6b63c74f82eb0feb5d5d4e77c86c7d26a9f6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualMirrorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5d435f1edcb2f2e0ae687d80f3be217c82d143cde87c6ff3788020b398beaa85)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualMirrorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__970197595e5fc191297e455f07c46bfb1f4f66e20d0ff1cf925de45dd8e36dfc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aaaa36006c795e8d662eaeafa84521a8fe23e3b678f6f60c6ffb2365da8f2617)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b15caa34e22f83b80908d5129c47515fba491f32ab2ddab8af4556675c8aad2f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualMirror]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualMirror]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be6e3cb9161cf5e8927706486913a70b9a27c09ea5e468bbc10a03fc44ad5e5a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualMirrorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualMirrorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__def720cc8234b59c318bd215a85466b2ea9625116124852d4f6c7a0dcab21678)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHorizontal")
    def reset_horizontal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontal", []))

    @jsii.member(jsii_name="resetHorizontalVar")
    def reset_horizontal_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontalVar", []))

    @jsii.member(jsii_name="resetVertical")
    def reset_vertical(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVertical", []))

    @jsii.member(jsii_name="resetVerticalVar")
    def reset_vertical_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVerticalVar", []))

    @builtins.property
    @jsii.member(jsii_name="horizontalInput")
    def horizontal_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontalVarInput")
    def horizontal_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalInput")
    def vertical_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalVarInput")
    def vertical_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontal")
    def horizontal(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontal"))

    @horizontal.setter
    def horizontal(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a27a90bb21e510a6996e32062d18f5338dd730e56d4932b7fa37a55914e6d659)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontal", value)

    @builtins.property
    @jsii.member(jsii_name="horizontalVar")
    def horizontal_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontalVar"))

    @horizontal_var.setter
    def horizontal_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3b6ad1e16a6bd420cf3de9962bc7128ce7c2854b675e1409f81b24af8a619905)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontalVar", value)

    @builtins.property
    @jsii.member(jsii_name="vertical")
    def vertical(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "vertical"))

    @vertical.setter
    def vertical(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c7b97b009f77145fcf896c975e5524971e665ddc1f29ec38ae23aa81ea1ce61f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "vertical", value)

    @builtins.property
    @jsii.member(jsii_name="verticalVar")
    def vertical_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "verticalVar"))

    @vertical_var.setter
    def vertical_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b7bcfd64ec82f7c5a060e28f4bd49ebd1c0133082c7800696ae062a7ab377766)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "verticalVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualMirror]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualMirror]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualMirror]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4481b87079191f0954e9e62b1f51870b3b26dde695287aa54c59a066dd45b082)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualMonoHue",
    jsii_struct_bases=[],
    name_mapping={"hue": "hue", "hue_var": "hueVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualMonoHue:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__753089555b321906be44861fce62d7ad2a86ba0470e7717794814f647808c266)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualMonoHue(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualMonoHueList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualMonoHueList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__21680f6b1fd0e4ac06036dd2b2e92c1601302cdd211a1ba1a582d60df2526596)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualMonoHueOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6be1801399a8dba0321a08179186db9f323e45c5bfc37325566cf74d685b01ab)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualMonoHueOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fe64a3ed231ba8655c11a43c593b355008d69ba4449e84d5c6bbfa922630c2e0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__10e2fac16a89b75505b7c5e32ae365a940c7cd0e02c7e5c00fa418ce0cd1c678)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8aae8f7558887346f70afc7ab18df5c9f9374d39744e23ecd62c5ac2bdbc776c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualMonoHue]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualMonoHue]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cba062631ee3b0b5dea310241bf706b396447d4de7c7438e77c56e6b39d4bfaf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualMonoHueOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualMonoHueOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c2fc855c28ee4f9c6d70413f08118849c066ed1b5cdf0b2bc684dfaafcccf358)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f54f4decad4d2b01d4302bcaf38f1caebfe3257dbf6b83410c1da8e235369917)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bd8dcc9695634c056cb8a7ec1220fdd67db88b72a8f8ed628d4c3eb1014d7291)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualMonoHue]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualMonoHue]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualMonoHue]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__90a17f2cee0d389d3d66430e295a64cc2217970ff198f037969e57b9a89c38f4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualOpacity",
    jsii_struct_bases=[],
    name_mapping={"opacity": "opacity", "opacity_var": "opacityVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualOpacity:
    def __init__(
        self,
        *,
        opacity: typing.Optional[builtins.str] = None,
        opacity_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param opacity: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param opacity_var: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__18b38357dd5c088cac2522f009a1e110f1414a4775f40b84659e1e6b1f406b66)
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument opacity_var", value=opacity_var, expected_type=type_hints["opacity_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if opacity is not None:
            self._values["opacity"] = opacity
        if opacity_var is not None:
            self._values["opacity_var"] = opacity_var

    @builtins.property
    def opacity(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def opacity_var(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        result = self._values.get("opacity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualOpacity(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualOpacityList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualOpacityList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4d34ff3b3f70310b9d7da6f003f3bcf2d7087aea61de8f177d82fef282649d68)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualOpacityOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__34d823e6fdea65a2f19d99a08f494af9713d8c784eca285b9ec07febfb1aea55)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualOpacityOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8b35b7a4e27bf8c93f918dd9a2879c6907ea8aa1f3dc3603a01f6b2e114f9e6b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__47b20aca2d1d01aba7e1402cf463e659db28cb4b114b20d5b5a1fd2c0d5aa33d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__19574c54e57eacec681d8768d27844b7eaf4b875d945a620684a12b5ab443deb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualOpacity]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualOpacity]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e4cfb97e4fa2074ede2392b126636bd4444e153cd3f3c0835a579de15fb16bdc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualOpacityOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualOpacityOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__65e9c91ecdcbc9abcfe743775c2f69666e8bf404f548d6abf66ebb26ec7e0c59)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetOpacityVar")
    def reset_opacity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacityVar", []))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityVarInput")
    def opacity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacity"))

    @opacity.setter
    def opacity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fbcebd38afe129b747f960281caff03960e4f26afae5bf1c153ae594a0f34b8e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacity", value)

    @builtins.property
    @jsii.member(jsii_name="opacityVar")
    def opacity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacityVar"))

    @opacity_var.setter
    def opacity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__89b519be31fca106860a11f153d9175ec1e7e750eefa4956e8e96e412fab5b21)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacityVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualOpacity]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualOpacity]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualOpacity]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__85f9791335bb2c8f6a03de35a440c795960d7cca34ff83a02ad36905d695b61e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1b21eaf628b9da348ed63d4448dc8997d0065acde5faf0d7bcee597b1c2f5c1e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putBackgroundColor")
    def put_background_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4445a277b1968b2db0ef5ef2a1a6bba599852b127ac2ea7d0b69b6c58c23afa0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBackgroundColor", [value]))

    @jsii.member(jsii_name="putBlur")
    def put_blur(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualBlur, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c2671472d12d81cf5e8bd8fd4ee7a35e1fef8c93991771a01f6e9c23d4205c75)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBlur", [value]))

    @jsii.member(jsii_name="putChromaKey")
    def put_chroma_key(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualChromaKey, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c4e8de2c30d8eaef67d629ef2913145342dfe48527174ceb677a8af12ba40436)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putChromaKey", [value]))

    @jsii.member(jsii_name="putComposite")
    def put_composite(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualComposite, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f360d85fe35c46f70ff0c3b576a1214a27101ebfcdfe7ca49f3ac273ab901e05)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putComposite", [value]))

    @jsii.member(jsii_name="putCompound")
    def put_compound(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualCompound, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b203926f0997f2b80216dcaf68afc4773763abea7eb2ee010535916e3e93973f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCompound", [value]))

    @jsii.member(jsii_name="putContrast")
    def put_contrast(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualContrast, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3adbf92506f112f23e2f88aad766830dc4ff076a7e84ff6069580ce33b582a00)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putContrast", [value]))

    @jsii.member(jsii_name="putGoop")
    def put_goop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualGoop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fb84ffebfe5f2303bfb086e7a5516a5fab60e2645a4f5a99a8870e9c485aa3f1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGoop", [value]))

    @jsii.member(jsii_name="putGrayscale")
    def put_grayscale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualGrayscale, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__21eb42242780bf0c7f8221cd78340ab2ee0cdf3db42333da672459d2d5082a8d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGrayscale", [value]))

    @jsii.member(jsii_name="putHsl")
    def put_hsl(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualHsl, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b419e4f284580604180ff8e8c48e92ed3bb6c06abfe51edcb4352adbe9d0f1fd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsl", [value]))

    @jsii.member(jsii_name="putHsv")
    def put_hsv(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualHsv, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ffbf9b2d7bb58aedda6ff97238cdee17c8320bc82d7893582ef1b72678fccfa2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsv", [value]))

    @jsii.member(jsii_name="putIfDimension")
    def put_if_dimension(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfDimension, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d415dd5aec1c57d25a617d2ba9c52b388d830e7dff127a8472df1f4e69d4e0b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfDimension", [value]))

    @jsii.member(jsii_name="putIfOrientation")
    def put_if_orientation(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fd4ac9e2481afb56060aae6bfe4604976b689b4c9c3799c67b88b9cf71db4f82)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfOrientation", [value]))

    @jsii.member(jsii_name="putMaxColors")
    def put_max_colors(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualMaxColors, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a3d7bd3fbf32c3ce8bc23947401e2743c15b268d2bfa888df1f06af11e45e4c3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMaxColors", [value]))

    @jsii.member(jsii_name="putMirror")
    def put_mirror(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualMirror, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3c269a46a86da7fcd5524e0f27863a464e10923294a8d4a02e5271a5194a5f98)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMirror", [value]))

    @jsii.member(jsii_name="putMonoHue")
    def put_mono_hue(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualMonoHue, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a8675c32a60382f1c46259bd696feade96bb9434e3e12d984d912842e5682b88)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMonoHue", [value]))

    @jsii.member(jsii_name="putOpacity")
    def put_opacity(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualOpacity, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__79ae743b3ff8fc467b9b1db7f0004cb3d5ebbaa718a21dff8d670c7f7ed5ab59)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putOpacity", [value]))

    @jsii.member(jsii_name="putRemoveColor")
    def put_remove_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualRemoveColor", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__58a46f6618d07c0431dbf59447dad99b8c4068e3037cf9b57248bdb3bafb6887)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRemoveColor", [value]))

    @jsii.member(jsii_name="putUnsharpMask")
    def put_unsharp_mask(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualUnsharpMask", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__43af8d8ae943c86d8fcfb06402e74a32791a83c0d97ef1ba73c7ca5bdac202c1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putUnsharpMask", [value]))

    @jsii.member(jsii_name="resetBackgroundColor")
    def reset_background_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBackgroundColor", []))

    @jsii.member(jsii_name="resetBlur")
    def reset_blur(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBlur", []))

    @jsii.member(jsii_name="resetChromaKey")
    def reset_chroma_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChromaKey", []))

    @jsii.member(jsii_name="resetComposite")
    def reset_composite(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetComposite", []))

    @jsii.member(jsii_name="resetCompound")
    def reset_compound(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCompound", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetGoop")
    def reset_goop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGoop", []))

    @jsii.member(jsii_name="resetGrayscale")
    def reset_grayscale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGrayscale", []))

    @jsii.member(jsii_name="resetHsl")
    def reset_hsl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsl", []))

    @jsii.member(jsii_name="resetHsv")
    def reset_hsv(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsv", []))

    @jsii.member(jsii_name="resetIfDimension")
    def reset_if_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfDimension", []))

    @jsii.member(jsii_name="resetIfOrientation")
    def reset_if_orientation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfOrientation", []))

    @jsii.member(jsii_name="resetMaxColors")
    def reset_max_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxColors", []))

    @jsii.member(jsii_name="resetMirror")
    def reset_mirror(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMirror", []))

    @jsii.member(jsii_name="resetMonoHue")
    def reset_mono_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonoHue", []))

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetRemoveColor")
    def reset_remove_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRemoveColor", []))

    @jsii.member(jsii_name="resetUnsharpMask")
    def reset_unsharp_mask(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUnsharpMask", []))

    @builtins.property
    @jsii.member(jsii_name="backgroundColor")
    def background_color(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualBackgroundColorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualBackgroundColorList, jsii.get(self, "backgroundColor"))

    @builtins.property
    @jsii.member(jsii_name="blur")
    def blur(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualBlurList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualBlurList, jsii.get(self, "blur"))

    @builtins.property
    @jsii.member(jsii_name="chromaKey")
    def chroma_key(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualChromaKeyList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualChromaKeyList, jsii.get(self, "chromaKey"))

    @builtins.property
    @jsii.member(jsii_name="composite")
    def composite(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualCompositeList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualCompositeList, jsii.get(self, "composite"))

    @builtins.property
    @jsii.member(jsii_name="compound")
    def compound(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualCompoundList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualCompoundList, jsii.get(self, "compound"))

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualContrastList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualContrastList, jsii.get(self, "contrast"))

    @builtins.property
    @jsii.member(jsii_name="goop")
    def goop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualGoopList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualGoopList, jsii.get(self, "goop"))

    @builtins.property
    @jsii.member(jsii_name="grayscale")
    def grayscale(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualGrayscaleList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualGrayscaleList, jsii.get(self, "grayscale"))

    @builtins.property
    @jsii.member(jsii_name="hsl")
    def hsl(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualHslList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualHslList, jsii.get(self, "hsl"))

    @builtins.property
    @jsii.member(jsii_name="hsv")
    def hsv(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualHsvList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualHsvList, jsii.get(self, "hsv"))

    @builtins.property
    @jsii.member(jsii_name="ifDimension")
    def if_dimension(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionList, jsii.get(self, "ifDimension"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientation")
    def if_orientation(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationList, jsii.get(self, "ifOrientation"))

    @builtins.property
    @jsii.member(jsii_name="maxColors")
    def max_colors(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualMaxColorsList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualMaxColorsList, jsii.get(self, "maxColors"))

    @builtins.property
    @jsii.member(jsii_name="mirror")
    def mirror(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualMirrorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualMirrorList, jsii.get(self, "mirror"))

    @builtins.property
    @jsii.member(jsii_name="monoHue")
    def mono_hue(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualMonoHueList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualMonoHueList, jsii.get(self, "monoHue"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualOpacityList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualOpacityList, jsii.get(self, "opacity"))

    @builtins.property
    @jsii.member(jsii_name="removeColor")
    def remove_color(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualRemoveColorList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualRemoveColorList", jsii.get(self, "removeColor"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMask")
    def unsharp_mask(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualUnsharpMaskList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualUnsharpMaskList", jsii.get(self, "unsharpMask"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColorInput")
    def background_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualBackgroundColor]]], jsii.get(self, "backgroundColorInput"))

    @builtins.property
    @jsii.member(jsii_name="blurInput")
    def blur_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualBlur]]], jsii.get(self, "blurInput"))

    @builtins.property
    @jsii.member(jsii_name="chromaKeyInput")
    def chroma_key_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualChromaKey]]], jsii.get(self, "chromaKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="compositeInput")
    def composite_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualComposite]]], jsii.get(self, "compositeInput"))

    @builtins.property
    @jsii.member(jsii_name="compoundInput")
    def compound_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualCompound]]], jsii.get(self, "compoundInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualContrast]]], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="goopInput")
    def goop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualGoop]]], jsii.get(self, "goopInput"))

    @builtins.property
    @jsii.member(jsii_name="grayscaleInput")
    def grayscale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualGrayscale]]], jsii.get(self, "grayscaleInput"))

    @builtins.property
    @jsii.member(jsii_name="hslInput")
    def hsl_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualHsl]]], jsii.get(self, "hslInput"))

    @builtins.property
    @jsii.member(jsii_name="hsvInput")
    def hsv_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualHsv]]], jsii.get(self, "hsvInput"))

    @builtins.property
    @jsii.member(jsii_name="ifDimensionInput")
    def if_dimension_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfDimension]]], jsii.get(self, "ifDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientationInput")
    def if_orientation_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfOrientation]]], jsii.get(self, "ifOrientationInput"))

    @builtins.property
    @jsii.member(jsii_name="maxColorsInput")
    def max_colors_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualMaxColors]]], jsii.get(self, "maxColorsInput"))

    @builtins.property
    @jsii.member(jsii_name="mirrorInput")
    def mirror_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualMirror]]], jsii.get(self, "mirrorInput"))

    @builtins.property
    @jsii.member(jsii_name="monoHueInput")
    def mono_hue_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualMonoHue]]], jsii.get(self, "monoHueInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualOpacity]]], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="removeColorInput")
    def remove_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualRemoveColor"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualRemoveColor"]]], jsii.get(self, "removeColorInput"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMaskInput")
    def unsharp_mask_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualUnsharpMask"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualUnsharpMask"]]], jsii.get(self, "unsharpMaskInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqual], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqual],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1552c133d4fc62a52180303a87d4304906a3614b85db146466316d4db78451d5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualRemoveColor",
    jsii_struct_bases=[],
    name_mapping={
        "color": "color",
        "color_var": "colorVar",
        "feather": "feather",
        "feather_var": "featherVar",
        "tolerance": "tolerance",
        "tolerance_var": "toleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualRemoveColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
        feather: typing.Optional[builtins.str] = None,
        feather_var: typing.Optional[builtins.str] = None,
        tolerance: typing.Optional[builtins.str] = None,
        tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        :param feather: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        :param feather_var: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        :param tolerance: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        :param tolerance_var: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__463fdc0fcdd7a6486b7ecdeddfc8654627369b7b0ede753c6527be74e48cab3d)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
            check_type(argname="argument feather", value=feather, expected_type=type_hints["feather"])
            check_type(argname="argument feather_var", value=feather_var, expected_type=type_hints["feather_var"])
            check_type(argname="argument tolerance", value=tolerance, expected_type=type_hints["tolerance"])
            check_type(argname="argument tolerance_var", value=tolerance_var, expected_type=type_hints["tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var
        if feather is not None:
            self._values["feather"] = feather
        if feather_var is not None:
            self._values["feather_var"] = feather_var
        if tolerance is not None:
            self._values["tolerance"] = tolerance
        if tolerance_var is not None:
            self._values["tolerance_var"] = tolerance_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        '''
        result = self._values.get("feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather_var(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        '''
        result = self._values.get("feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        '''
        result = self._values.get("tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance_var(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        result = self._values.get("tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualRemoveColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualRemoveColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualRemoveColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__14f6e0c5ba0f84065b0c5fa0c10e46a38c7c9142fbce1cb126c96c491858a843)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualRemoveColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ec6e6a6e84c63d9977eea6ce3a654aacb03405d07a3f9b6bfbfb1fb0e8f5acb5)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualRemoveColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d7b17e4a14d2e3bb7288733ed90c9a77a0d1b7d9e359e2a966f448c3c23e20c8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d9b52a865d85e954421055747b337f6ee8d7373f9f8bddbf35784f5b6f0fe3ed)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__50a566ba135d3300bc893da0df40eba9dfe205885cfe9c263b1532387de579d0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualRemoveColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualRemoveColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualRemoveColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__34143cde20beba4ad8b5f57981aea76c90dcce4787a4803b3970a97c1d3159d2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualRemoveColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualRemoveColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f6e8a49d9513b1070beb87021c1087a27007bc6c10d209668949d9416e009ca)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @jsii.member(jsii_name="resetFeather")
    def reset_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeather", []))

    @jsii.member(jsii_name="resetFeatherVar")
    def reset_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatherVar", []))

    @jsii.member(jsii_name="resetTolerance")
    def reset_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTolerance", []))

    @jsii.member(jsii_name="resetToleranceVar")
    def reset_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featherInput")
    def feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherInput"))

    @builtins.property
    @jsii.member(jsii_name="featherVarInput")
    def feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceInput")
    def tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceVarInput")
    def tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__40a0d2810182d7493d15fd5ce9d0d2e03694566f9c26d5606cf8d244f40f2847)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2733d9cd4850d17bdd21a7c3b9f09c3d73eb547791c30cb678c92aab0892ad86)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="feather")
    def feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "feather"))

    @feather.setter
    def feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e6756651f7aefed76e1b76696b486d7d3bf50d9bc8bedae76c5d01b2a938e071)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "feather", value)

    @builtins.property
    @jsii.member(jsii_name="featherVar")
    def feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featherVar"))

    @feather_var.setter
    def feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__724c4fa3999251f726c15afbf88f2773163424f5372d2b07ffd98d3bf438a1c6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featherVar", value)

    @builtins.property
    @jsii.member(jsii_name="tolerance")
    def tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tolerance"))

    @tolerance.setter
    def tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6c000598880545deb2ef39e868dbe126f84650ce44496509a95dd0c883ca11d4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tolerance", value)

    @builtins.property
    @jsii.member(jsii_name="toleranceVar")
    def tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "toleranceVar"))

    @tolerance_var.setter
    def tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bdbeb66d98e10d45687bbffbc2fc1ab61bc6e985ab524dd39ab58498bb344a91)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "toleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualRemoveColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualRemoveColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualRemoveColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ad45a71af4a29c26d5265b69c70a061616ef938cc245e247f07930f3953f9820)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualUnsharpMask",
    jsii_struct_bases=[],
    name_mapping={
        "gain": "gain",
        "gain_var": "gainVar",
        "sigma": "sigma",
        "sigma_var": "sigmaVar",
        "threshold": "threshold",
        "threshold_var": "thresholdVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualUnsharpMask:
    def __init__(
        self,
        *,
        gain: typing.Optional[builtins.str] = None,
        gain_var: typing.Optional[builtins.str] = None,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
        threshold: typing.Optional[builtins.str] = None,
        threshold_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param gain: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        :param gain_var: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        :param sigma: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        :param threshold: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        :param threshold_var: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e0d691030dad1a6c28291b8b00c98d09e1293a84f0ff5c240400b95c7b85cf85)
            check_type(argname="argument gain", value=gain, expected_type=type_hints["gain"])
            check_type(argname="argument gain_var", value=gain_var, expected_type=type_hints["gain_var"])
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
            check_type(argname="argument threshold", value=threshold, expected_type=type_hints["threshold"])
            check_type(argname="argument threshold_var", value=threshold_var, expected_type=type_hints["threshold_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if gain is not None:
            self._values["gain"] = gain
        if gain_var is not None:
            self._values["gain_var"] = gain_var
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var
        if threshold is not None:
            self._values["threshold"] = threshold
        if threshold_var is not None:
            self._values["threshold_var"] = threshold_var

    @builtins.property
    def gain(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        '''
        result = self._values.get("gain")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gain_var(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        '''
        result = self._values.get("gain_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        '''
        result = self._values.get("threshold")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold_var(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        result = self._values.get("threshold_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualUnsharpMask(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualUnsharpMaskList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualUnsharpMaskList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c5f36fa617a4cd10a0b33c03403a4cd4b01facfeb6c790cff01b2eff8c644aa8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualUnsharpMaskOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb9e3899111418b86267b4a1f88693be73e08ff52a869bcddbd0ff46be2cd6f6)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualUnsharpMaskOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bdcc35e31255b54bd4ea8b7feaf1935064babb95853fd4c60cacd30f5470bc86)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__87aabca4dafd2ab2e1e53811edb4fc21eb53c7e5292b5bc9574e48985ef29942)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__696da4692992cd4704720738e189e37106f683e1d3e031516b92448115f19f19)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualUnsharpMask]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualUnsharpMask]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualUnsharpMask]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__04520a9bb3ccc49fb0cbb545f4d45c6e3ce23115f346e7e34e4def7f152a9f74)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualUnsharpMaskOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualUnsharpMaskOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__815967abe14de6084833dd4af90ed1c4b45883f01ef07e78bcaf7ac92ffcf600)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetGain")
    def reset_gain(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGain", []))

    @jsii.member(jsii_name="resetGainVar")
    def reset_gain_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGainVar", []))

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @jsii.member(jsii_name="resetThreshold")
    def reset_threshold(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThreshold", []))

    @jsii.member(jsii_name="resetThresholdVar")
    def reset_threshold_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThresholdVar", []))

    @builtins.property
    @jsii.member(jsii_name="gainInput")
    def gain_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainInput"))

    @builtins.property
    @jsii.member(jsii_name="gainVarInput")
    def gain_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdInput")
    def threshold_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdVarInput")
    def threshold_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gain")
    def gain(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gain"))

    @gain.setter
    def gain(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3e2d382462dd2371de75fd5ae51b1053690abe4679c919e1103b79f7ec74693b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gain", value)

    @builtins.property
    @jsii.member(jsii_name="gainVar")
    def gain_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gainVar"))

    @gain_var.setter
    def gain_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7799394329778fec44d6b0f7c6e7bfda28a635ac86183962bcdbd0a88b9e80f8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gainVar", value)

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__51e6b41909dc75b9dc888cd3a0872dc6abdc263c44804941f301f31114f31f07)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2bb68df6344563d93ca35ef34f05f82b51961602f8d552676dcb9736245ec002)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="threshold")
    def threshold(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "threshold"))

    @threshold.setter
    def threshold(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1e5cf13c9fe72618e824b5c012161b176e32a82136e5a961cf4bc706f7131e8a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "threshold", value)

    @builtins.property
    @jsii.member(jsii_name="thresholdVar")
    def threshold_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "thresholdVar"))

    @threshold_var.setter
    def threshold_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__19ad497b1523300bf0798816a8aac16f61fb7c2b6fcc7d4792e303a74b4309d0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "thresholdVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualUnsharpMask]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualUnsharpMask]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualUnsharpMask]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__deafeae9d715859c4f812fcfb11a07c19eb91d3454da6e3e3e080bf69d8e2245)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThan",
    jsii_struct_bases=[],
    name_mapping={
        "background_color": "backgroundColor",
        "blur": "blur",
        "chroma_key": "chromaKey",
        "composite": "composite",
        "compound": "compound",
        "contrast": "contrast",
        "goop": "goop",
        "grayscale": "grayscale",
        "hsl": "hsl",
        "hsv": "hsv",
        "if_dimension": "ifDimension",
        "if_orientation": "ifOrientation",
        "max_colors": "maxColors",
        "mirror": "mirror",
        "mono_hue": "monoHue",
        "opacity": "opacity",
        "remove_color": "removeColor",
        "unsharp_mask": "unsharpMask",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThan:
    def __init__(
        self,
        *,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanBackgroundColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanBlur", typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanChromaKey", typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanComposite", typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanCompound", typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanContrast", typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanGoop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanGrayscale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanHsl", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanHsv", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimension", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientation", typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanMaxColors", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanMirror", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanMonoHue", typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanOpacity", typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanRemoveColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanUnsharpMask", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d3dfaec7b23b8670b7817d763ec65b1d3472d39f610e9a22a7db96d95996348)
            check_type(argname="argument background_color", value=background_color, expected_type=type_hints["background_color"])
            check_type(argname="argument blur", value=blur, expected_type=type_hints["blur"])
            check_type(argname="argument chroma_key", value=chroma_key, expected_type=type_hints["chroma_key"])
            check_type(argname="argument composite", value=composite, expected_type=type_hints["composite"])
            check_type(argname="argument compound", value=compound, expected_type=type_hints["compound"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument goop", value=goop, expected_type=type_hints["goop"])
            check_type(argname="argument grayscale", value=grayscale, expected_type=type_hints["grayscale"])
            check_type(argname="argument hsl", value=hsl, expected_type=type_hints["hsl"])
            check_type(argname="argument hsv", value=hsv, expected_type=type_hints["hsv"])
            check_type(argname="argument if_dimension", value=if_dimension, expected_type=type_hints["if_dimension"])
            check_type(argname="argument if_orientation", value=if_orientation, expected_type=type_hints["if_orientation"])
            check_type(argname="argument max_colors", value=max_colors, expected_type=type_hints["max_colors"])
            check_type(argname="argument mirror", value=mirror, expected_type=type_hints["mirror"])
            check_type(argname="argument mono_hue", value=mono_hue, expected_type=type_hints["mono_hue"])
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument remove_color", value=remove_color, expected_type=type_hints["remove_color"])
            check_type(argname="argument unsharp_mask", value=unsharp_mask, expected_type=type_hints["unsharp_mask"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if background_color is not None:
            self._values["background_color"] = background_color
        if blur is not None:
            self._values["blur"] = blur
        if chroma_key is not None:
            self._values["chroma_key"] = chroma_key
        if composite is not None:
            self._values["composite"] = composite
        if compound is not None:
            self._values["compound"] = compound
        if contrast is not None:
            self._values["contrast"] = contrast
        if goop is not None:
            self._values["goop"] = goop
        if grayscale is not None:
            self._values["grayscale"] = grayscale
        if hsl is not None:
            self._values["hsl"] = hsl
        if hsv is not None:
            self._values["hsv"] = hsv
        if if_dimension is not None:
            self._values["if_dimension"] = if_dimension
        if if_orientation is not None:
            self._values["if_orientation"] = if_orientation
        if max_colors is not None:
            self._values["max_colors"] = max_colors
        if mirror is not None:
            self._values["mirror"] = mirror
        if mono_hue is not None:
            self._values["mono_hue"] = mono_hue
        if opacity is not None:
            self._values["opacity"] = opacity
        if remove_color is not None:
            self._values["remove_color"] = remove_color
        if unsharp_mask is not None:
            self._values["unsharp_mask"] = unsharp_mask

    @builtins.property
    def background_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanBackgroundColor"]]]:
        '''background_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        '''
        result = self._values.get("background_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanBackgroundColor"]]], result)

    @builtins.property
    def blur(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanBlur"]]]:
        '''blur block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        '''
        result = self._values.get("blur")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanBlur"]]], result)

    @builtins.property
    def chroma_key(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanChromaKey"]]]:
        '''chroma_key block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        '''
        result = self._values.get("chroma_key")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanChromaKey"]]], result)

    @builtins.property
    def composite(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanComposite"]]]:
        '''composite block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        '''
        result = self._values.get("composite")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanComposite"]]], result)

    @builtins.property
    def compound(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanCompound"]]]:
        '''compound block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        '''
        result = self._values.get("compound")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanCompound"]]], result)

    @builtins.property
    def contrast(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanContrast"]]]:
        '''contrast block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanContrast"]]], result)

    @builtins.property
    def goop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanGoop"]]]:
        '''goop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        '''
        result = self._values.get("goop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanGoop"]]], result)

    @builtins.property
    def grayscale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanGrayscale"]]]:
        '''grayscale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        '''
        result = self._values.get("grayscale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanGrayscale"]]], result)

    @builtins.property
    def hsl(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanHsl"]]]:
        '''hsl block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        '''
        result = self._values.get("hsl")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanHsl"]]], result)

    @builtins.property
    def hsv(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanHsv"]]]:
        '''hsv block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        '''
        result = self._values.get("hsv")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanHsv"]]], result)

    @builtins.property
    def if_dimension(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimension"]]]:
        '''if_dimension block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        '''
        result = self._values.get("if_dimension")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimension"]]], result)

    @builtins.property
    def if_orientation(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientation"]]]:
        '''if_orientation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        '''
        result = self._values.get("if_orientation")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientation"]]], result)

    @builtins.property
    def max_colors(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanMaxColors"]]]:
        '''max_colors block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        '''
        result = self._values.get("max_colors")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanMaxColors"]]], result)

    @builtins.property
    def mirror(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanMirror"]]]:
        '''mirror block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        '''
        result = self._values.get("mirror")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanMirror"]]], result)

    @builtins.property
    def mono_hue(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanMonoHue"]]]:
        '''mono_hue block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        '''
        result = self._values.get("mono_hue")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanMonoHue"]]], result)

    @builtins.property
    def opacity(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanOpacity"]]]:
        '''opacity block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanOpacity"]]], result)

    @builtins.property
    def remove_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanRemoveColor"]]]:
        '''remove_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        '''
        result = self._values.get("remove_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanRemoveColor"]]], result)

    @builtins.property
    def unsharp_mask(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanUnsharpMask"]]]:
        '''unsharp_mask block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        result = self._values.get("unsharp_mask")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanUnsharpMask"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanBackgroundColor",
    jsii_struct_bases=[],
    name_mapping={"color": "color", "color_var": "colorVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanBackgroundColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__33e836c6a4c1f12b0dd2e4d6fb66249fff1675c1744a83d91dc7c1678379635d)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanBackgroundColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanBackgroundColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanBackgroundColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5fb26c7fe500db57cd857cf4fdc0fe65282365291c9ee22e41c81f3970244825)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanBackgroundColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fce704a042b2f543c1485e507e1c97c862512d7f845e3cce814cb050c3eaac96)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanBackgroundColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bdfa969ef4f549714bb4e4954c9eff7ae13bc86c195aaa298770828ba25a2646)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1fc8e3273e820051dcdb5e77f9ebd57234dc2e1018ec3c704d92022a748bf0ba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__60294a110e366b04858d9026a8899c39c618af83b1566a2d159dedf92177df0d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanBackgroundColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanBackgroundColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9e15ed3099bd00378c2cf4d1b15a19dc891ea6f11a28656fc07117a12a3ba043)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanBackgroundColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanBackgroundColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4bb14c3fa70c6869f10f176e79cbc34aff7bca2b249af847b5310b78dbd19124)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7419674db1c84e446badfb6c66d2e2ea30cefdf0782107c7ff48954bf81cfa1e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b1460665b2a663a5d761d5be83f4dea39090d2e9e454fbcac4bc0b1925556f20)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanBackgroundColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanBackgroundColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanBackgroundColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__def6624ff799390c14002c0753493f5d99c6481e700a9b4dc52b62478b79d307)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanBlur",
    jsii_struct_bases=[],
    name_mapping={"sigma": "sigma", "sigma_var": "sigmaVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanBlur:
    def __init__(
        self,
        *,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param sigma: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__677d2bada7df06d31bc987c25382f2a5dc174d65f3451d2c74e960d4350d8549)
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanBlur(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanBlurList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanBlurList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__633499c77728ca4d16ee8b750e7b52f0b52e4ad6554f3c8f35c5ddf391ffa946)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanBlurOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f904c407068382d8ac09b4b89386d7fe0ccd3fdb6ec0ea855872f405f3c7f73)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanBlurOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eb7ea2eecc2c2256d70b3a35dfa6ac8ce211f2908127b92d44c702768da7a9d2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__db5d58a1382f9b50db1ba24f43b85386aa7e948f388112ac079fecedef954d5c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3b6f599c73e981de75d71dee76f0b6e18b724914bb18dedb83b3596c5e0908f4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanBlur]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanBlur]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b3d6803c76b55a3902e197a1e5a624c77835b5310192d57905faa8ec1cca11a9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanBlurOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanBlurOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__505f10ebba576e40385beb3c70edda98e03d8629b4fc3052204f44c7bf85afcc)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8113f86b81f101e0f13df5b010a9a3d38b271ae0c198f6f5d803943435e02352)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2c572eface558d4c695337de6b40f8e0674fb805512f0dfc87a8c3c98470bb82)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanBlur]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanBlur]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanBlur]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fea1ffd2f0b5e4d14386b3a500c2d8ac4ce63f80158f12a55b12ad5b0ac05667)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanChromaKey",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_feather": "hueFeather",
        "hue_feather_var": "hueFeatherVar",
        "hue_tolerance": "hueTolerance",
        "hue_tolerance_var": "hueToleranceVar",
        "hue_var": "hueVar",
        "lightness_feather": "lightnessFeather",
        "lightness_feather_var": "lightnessFeatherVar",
        "lightness_tolerance": "lightnessTolerance",
        "lightness_tolerance_var": "lightnessToleranceVar",
        "saturation_feather": "saturationFeather",
        "saturation_feather_var": "saturationFeatherVar",
        "saturation_tolerance": "saturationTolerance",
        "saturation_tolerance_var": "saturationToleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanChromaKey:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_feather: typing.Optional[builtins.str] = None,
        hue_feather_var: typing.Optional[builtins.str] = None,
        hue_tolerance: typing.Optional[builtins.str] = None,
        hue_tolerance_var: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness_feather: typing.Optional[builtins.str] = None,
        lightness_feather_var: typing.Optional[builtins.str] = None,
        lightness_tolerance: typing.Optional[builtins.str] = None,
        lightness_tolerance_var: typing.Optional[builtins.str] = None,
        saturation_feather: typing.Optional[builtins.str] = None,
        saturation_feather_var: typing.Optional[builtins.str] = None,
        saturation_tolerance: typing.Optional[builtins.str] = None,
        saturation_tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_feather: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        :param hue_feather_var: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        :param hue_tolerance: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        :param hue_tolerance_var: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        :param hue_var: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness_feather: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        :param lightness_feather_var: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        :param lightness_tolerance: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        :param lightness_tolerance_var: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        :param saturation_feather: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        :param saturation_feather_var: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        :param saturation_tolerance: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        :param saturation_tolerance_var: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0935d0506ed110d8f443caa10a55946621e4c9b61f775f06f67f3fc980255593)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_feather", value=hue_feather, expected_type=type_hints["hue_feather"])
            check_type(argname="argument hue_feather_var", value=hue_feather_var, expected_type=type_hints["hue_feather_var"])
            check_type(argname="argument hue_tolerance", value=hue_tolerance, expected_type=type_hints["hue_tolerance"])
            check_type(argname="argument hue_tolerance_var", value=hue_tolerance_var, expected_type=type_hints["hue_tolerance_var"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness_feather", value=lightness_feather, expected_type=type_hints["lightness_feather"])
            check_type(argname="argument lightness_feather_var", value=lightness_feather_var, expected_type=type_hints["lightness_feather_var"])
            check_type(argname="argument lightness_tolerance", value=lightness_tolerance, expected_type=type_hints["lightness_tolerance"])
            check_type(argname="argument lightness_tolerance_var", value=lightness_tolerance_var, expected_type=type_hints["lightness_tolerance_var"])
            check_type(argname="argument saturation_feather", value=saturation_feather, expected_type=type_hints["saturation_feather"])
            check_type(argname="argument saturation_feather_var", value=saturation_feather_var, expected_type=type_hints["saturation_feather_var"])
            check_type(argname="argument saturation_tolerance", value=saturation_tolerance, expected_type=type_hints["saturation_tolerance"])
            check_type(argname="argument saturation_tolerance_var", value=saturation_tolerance_var, expected_type=type_hints["saturation_tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_feather is not None:
            self._values["hue_feather"] = hue_feather
        if hue_feather_var is not None:
            self._values["hue_feather_var"] = hue_feather_var
        if hue_tolerance is not None:
            self._values["hue_tolerance"] = hue_tolerance
        if hue_tolerance_var is not None:
            self._values["hue_tolerance_var"] = hue_tolerance_var
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness_feather is not None:
            self._values["lightness_feather"] = lightness_feather
        if lightness_feather_var is not None:
            self._values["lightness_feather_var"] = lightness_feather_var
        if lightness_tolerance is not None:
            self._values["lightness_tolerance"] = lightness_tolerance
        if lightness_tolerance_var is not None:
            self._values["lightness_tolerance_var"] = lightness_tolerance_var
        if saturation_feather is not None:
            self._values["saturation_feather"] = saturation_feather
        if saturation_feather_var is not None:
            self._values["saturation_feather_var"] = saturation_feather_var
        if saturation_tolerance is not None:
            self._values["saturation_tolerance"] = saturation_tolerance
        if saturation_tolerance_var is not None:
            self._values["saturation_tolerance_var"] = saturation_tolerance_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        '''
        result = self._values.get("hue_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        '''
        result = self._values.get("hue_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        '''
        result = self._values.get("hue_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        '''
        result = self._values.get("hue_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        '''
        result = self._values.get("lightness_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        '''
        result = self._values.get("lightness_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        '''
        result = self._values.get("lightness_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        '''
        result = self._values.get("lightness_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        '''
        result = self._values.get("saturation_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        '''
        result = self._values.get("saturation_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        '''
        result = self._values.get("saturation_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        result = self._values.get("saturation_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanChromaKey(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanChromaKeyList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanChromaKeyList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b8bfe8448946b18bc64215dcae6cbebfd4b18aa203edbfe9475b875d05b3cfa8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanChromaKeyOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__13a473ce116d0c10d4d4f890edd577a5f9af8e1447ce2d12ca44626e458bd95f)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanChromaKeyOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ee393f9b9b7229c8acc48b027acc21946d7082d0a33005cc0f97ae5e6264720d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d0455bdae95a68577c0c9de7a97d6ebd024c05953e762d1f476b4b8d8440e6b6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a6f330ec57b320784f83ed1098b8937d9a317e16a891abd2909ac89c6faa8ae5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanChromaKey]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanChromaKey]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a6269f65b0aadda8f597ba15b418bfc2fea5368337f6705a84e426126150c78)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanChromaKeyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanChromaKeyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1225c5b34dd2b9d07ef287f2365b9fe5bd8a4ef53e6d980fe2f71e067e4b595c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueFeather")
    def reset_hue_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeather", []))

    @jsii.member(jsii_name="resetHueFeatherVar")
    def reset_hue_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeatherVar", []))

    @jsii.member(jsii_name="resetHueTolerance")
    def reset_hue_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueTolerance", []))

    @jsii.member(jsii_name="resetHueToleranceVar")
    def reset_hue_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueToleranceVar", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightnessFeather")
    def reset_lightness_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeather", []))

    @jsii.member(jsii_name="resetLightnessFeatherVar")
    def reset_lightness_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeatherVar", []))

    @jsii.member(jsii_name="resetLightnessTolerance")
    def reset_lightness_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessTolerance", []))

    @jsii.member(jsii_name="resetLightnessToleranceVar")
    def reset_lightness_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessToleranceVar", []))

    @jsii.member(jsii_name="resetSaturationFeather")
    def reset_saturation_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeather", []))

    @jsii.member(jsii_name="resetSaturationFeatherVar")
    def reset_saturation_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeatherVar", []))

    @jsii.member(jsii_name="resetSaturationTolerance")
    def reset_saturation_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationTolerance", []))

    @jsii.member(jsii_name="resetSaturationToleranceVar")
    def reset_saturation_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherInput")
    def hue_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVarInput")
    def hue_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceInput")
    def hue_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVarInput")
    def hue_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherInput")
    def lightness_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVarInput")
    def lightness_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceInput")
    def lightness_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVarInput")
    def lightness_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherInput")
    def saturation_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVarInput")
    def saturation_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceInput")
    def saturation_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVarInput")
    def saturation_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__536466bd85ff7d7bf6d3185f861f20c575584756d7749c8849e16c6ff6288b8c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeather")
    def hue_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeather"))

    @hue_feather.setter
    def hue_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1617bbe9da3393f959f3ef1df5d2b15dd59b8269b969027a3ee420530840305e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeather", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVar")
    def hue_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeatherVar"))

    @hue_feather_var.setter
    def hue_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7290baf0224e67198c84b52e7f172ecf484fa349f867034aa879a0c39c746395)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueTolerance")
    def hue_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueTolerance"))

    @hue_tolerance.setter
    def hue_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__21c095990e1b606d9927c81a950a9eb6b169a35e772674458e55c6fb44b0436e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVar")
    def hue_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueToleranceVar"))

    @hue_tolerance_var.setter
    def hue_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fe2d597d0f53a18bfd3596cad71037af722d85bfc96f6902a00ab173ea42b782)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e92c7f9d7456e48b035cee4ee2f55af1c4df053f363376d47689bdc581511acb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeather")
    def lightness_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeather"))

    @lightness_feather.setter
    def lightness_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__57ff688745cf7298840476eb8d16e4c41964236ff3511075801d8494dfc5d8b1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeather", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVar")
    def lightness_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeatherVar"))

    @lightness_feather_var.setter
    def lightness_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e94b16c319bac66bb72cf47602598487864c8c35cebeacf52636b2f23d90cd9a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessTolerance")
    def lightness_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessTolerance"))

    @lightness_tolerance.setter
    def lightness_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f146e5deec0b9fd072c95fd5666395f621592b2ee4dda903096ffe333dcd6d9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVar")
    def lightness_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessToleranceVar"))

    @lightness_tolerance_var.setter
    def lightness_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__788aad7c0b9094e97716a0e4191197077becff64fc41605f600e2f7bc04111af)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeather")
    def saturation_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeather"))

    @saturation_feather.setter
    def saturation_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d00776e5139cfb12d38bca5554c39bae3af3f56cea04757015c516e8c2eb410a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeather", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVar")
    def saturation_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeatherVar"))

    @saturation_feather_var.setter
    def saturation_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__52c6a1e8bb1cf159ed42cc288f3e505f866cf2a39433adf8d2c9eb4223305159)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationTolerance")
    def saturation_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationTolerance"))

    @saturation_tolerance.setter
    def saturation_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8e811fdb206778c633c536a7d37bf2299227850d1896818906e70af28fc30baf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVar")
    def saturation_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationToleranceVar"))

    @saturation_tolerance_var.setter
    def saturation_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__abcc3db3ad1c8307efa3458b05183af7d5963ac1db5643916d896530357b022d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanChromaKey]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanChromaKey]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanChromaKey]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__79d6984094b59d3eec4b352b1560ae473775e5b47ead098e406d20373d87dc94)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanComposite",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "placement": "placement",
        "placement_var": "placementVar",
        "scale": "scale",
        "scale_dimension": "scaleDimension",
        "scale_dimension_var": "scaleDimensionVar",
        "scale_var": "scaleVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanComposite:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanCompositeImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        placement: typing.Optional[builtins.str] = None,
        placement_var: typing.Optional[builtins.str] = None,
        scale: typing.Optional[builtins.str] = None,
        scale_dimension: typing.Optional[builtins.str] = None,
        scale_dimension_var: typing.Optional[builtins.str] = None,
        scale_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param placement: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        :param placement_var: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        :param scale: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param scale_dimension: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        :param scale_dimension_var: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        :param scale_var: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        :param x_position: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanCompositeImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7ce37b093bb97103ec3c8b832d709fe0e1b28ce566b41a62ed92f64e1bb23f95)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument placement", value=placement, expected_type=type_hints["placement"])
            check_type(argname="argument placement_var", value=placement_var, expected_type=type_hints["placement_var"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument scale_dimension", value=scale_dimension, expected_type=type_hints["scale_dimension"])
            check_type(argname="argument scale_dimension_var", value=scale_dimension_var, expected_type=type_hints["scale_dimension_var"])
            check_type(argname="argument scale_var", value=scale_var, expected_type=type_hints["scale_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if placement is not None:
            self._values["placement"] = placement
        if placement_var is not None:
            self._values["placement_var"] = placement_var
        if scale is not None:
            self._values["scale"] = scale
        if scale_dimension is not None:
            self._values["scale_dimension"] = scale_dimension
        if scale_dimension_var is not None:
            self._values["scale_dimension_var"] = scale_dimension_var
        if scale_var is not None:
            self._values["scale_var"] = scale_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanCompositeImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanCompositeImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        '''
        result = self._values.get("placement")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement_var(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        '''
        result = self._values.get("placement_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        '''
        result = self._values.get("scale_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        '''
        result = self._values.get("scale_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        '''
        result = self._values.get("scale_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanComposite(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanCompositeImage",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanCompositeImage:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanCompositeImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanCompositeImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanCompositeImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b5aec60548fdb39f8466aea53ab3d3d788560e70461f512de598aa9008d947ae)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanCompositeImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanCompositeImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a837649b6729335c0a0382d248fdd425d17824b724fa362b77e05a762473f22)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanCompositeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanCompositeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4833c9f4d6bfd3e5403bc4959bd29d5d0e262e6fcf63b43409a0682a73889e77)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanCompositeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2e9e022fb4cdbb39725c1589a448f4de77f98af98ae615583e359bbd00bfcad2)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanCompositeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd2df0ddf580cf7fd8d280974bc3f644ef907d9d587a579b399d94ce1f2a49f6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bfcc9c78bad9c4dad4499d557300aee315a66caf38aeb3ac0e61aab20282ee62)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d62ec0bf02341b9edd90ce050ca42648d93f06b6b8f4305291a7e7a817faf5f8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanComposite]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanComposite]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2c2e9fb7dafc7ed73d926bc63edb89b9030c6e8f1bb23f3e565cb4d8d38cf049)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanCompositeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanCompositeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a1ae2ef513703bf5127fbd0a4a4b8468b7d77902382ff0007e4ec183e491ba92)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanCompositeImage()

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPlacement")
    def reset_placement(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacement", []))

    @jsii.member(jsii_name="resetPlacementVar")
    def reset_placement_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacementVar", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetScaleDimension")
    def reset_scale_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimension", []))

    @jsii.member(jsii_name="resetScaleDimensionVar")
    def reset_scale_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimensionVar", []))

    @jsii.member(jsii_name="resetScaleVar")
    def reset_scale_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanCompositeImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanCompositeImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanCompositeImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="placementInput")
    def placement_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementInput"))

    @builtins.property
    @jsii.member(jsii_name="placementVarInput")
    def placement_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionInput")
    def scale_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVarInput")
    def scale_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleVarInput")
    def scale_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cc6be49ad7aedfda3edb441dd73136d6f0fc3f174e53456d08fa01b38bf0263d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ee2a57b11fb6a6fc2cb4eedafb25b140f1c1790416eb7486f2a56edb63dadb6a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="placement")
    def placement(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placement"))

    @placement.setter
    def placement(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0c66b95f91766dd24828c5cfeebf88280d16577809608ff51e991465977a248d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placement", value)

    @builtins.property
    @jsii.member(jsii_name="placementVar")
    def placement_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placementVar"))

    @placement_var.setter
    def placement_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d51b2054f38bbfd96b874ffc019fdc0bf5c0cbdf71cf69f6995cd0aee1b5f58b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placementVar", value)

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scale"))

    @scale.setter
    def scale(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__efba290fbc189613f44d62ae77675ec30ec59ea6687c76265d72aa172193cc44)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scale", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimension")
    def scale_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimension"))

    @scale_dimension.setter
    def scale_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__016af40f602b84e7bcaa282bbff938ac23adc53d11dc7b456bf6847fd1f98b82)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimension", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVar")
    def scale_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimensionVar"))

    @scale_dimension_var.setter
    def scale_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b304d19a300e7396249f82993f74b2d92c5b6fa9002b8f37c85a5f9f3cb37e4e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="scaleVar")
    def scale_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleVar"))

    @scale_var.setter
    def scale_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b5f67b6f5457437016f5ebeed9953b47f6cdb05501d100b291040d7caaeb60da)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__33533dc8d3235ccb19828e212404d539b4bcf69fa07cab021516f93b37374525)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d9ec00e800594afb8c4b28c07ab95ca559026a8370afbee3a84a4d2c58035410)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__34c4dbad37825b3f21db19715962e66f774b71b4350992074c0696467f1182ce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d8b578a525f66df6a4b6df177409718ee391810c92823de92b639044120ad513)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanComposite]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanComposite]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanComposite]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__06e7459a5fbfd8440a260dd738c40435a3e0a8f4f768a89ba62810fe990a1dec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanCompound",
    jsii_struct_bases=[],
    name_mapping={"transformations": "transformations"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanCompound:
    def __init__(
        self,
        *,
        transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param transformations: transformations block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__98b0678006ed4c771959b21d42477e1e768623734b876ebdcf4126fb5b63f204)
            check_type(argname="argument transformations", value=transformations, expected_type=type_hints["transformations"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if transformations is not None:
            self._values["transformations"] = transformations

    @builtins.property
    def transformations(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanCompoundTransformations"]]]:
        '''transformations block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        result = self._values.get("transformations")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanCompoundTransformations"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanCompound(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanCompoundList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanCompoundList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0c18ab1e782c2b4306b616953bb2ab26e339e17fa5ded7d6949a7eae0efc2ca1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanCompoundOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6a76f29a07cad40f52a2d04a89495e662bf7f57e9b7da498d6eb9182e24dd8b8)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanCompoundOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a30d412d85e14d3ce2763251361940939d2f3a0f687f06cdc7b8a2bd045873f3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1754817b28214dc0b84e286cb18a7506979a5a12cbd7cfa98f4fc0966aa6a19f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7791b35dcf620e549e0d4173a6e595720fbb074e2de34f07d1d844e4720bfc4a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanCompound]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanCompound]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__11999de5d6195b19b1caa8ff3e9d5331fc458f0cb8bf307c8bf072299ff25370)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanCompoundOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanCompoundOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7724fe6370716de9bc841c4f3ec8d9986e3677eb8b4d86843c983155fb29ab64)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformations")
    def put_transformations(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ed81f50c983434a00a07e3afd864fcde9bdd1aaf952d3c68c898b24cbf2b861)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTransformations", [value]))

    @jsii.member(jsii_name="resetTransformations")
    def reset_transformations(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformations", []))

    @builtins.property
    @jsii.member(jsii_name="transformations")
    def transformations(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanCompoundTransformationsList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanCompoundTransformationsList", jsii.get(self, "transformations"))

    @builtins.property
    @jsii.member(jsii_name="transformationsInput")
    def transformations_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanCompoundTransformations"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanCompoundTransformations"]]], jsii.get(self, "transformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanCompound]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanCompound]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanCompound]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c79d39e502615c76fe60232b823df4852430e2e5d9f5bec5d4846253222f5756)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanCompoundTransformations",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanCompoundTransformations:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanCompoundTransformations(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanCompoundTransformationsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanCompoundTransformationsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a2c18371788fa40c6d68b1b5e579102f3eba4a351a1f2666c8d7ce5cd018014)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanCompoundTransformationsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c78adb3427ea2d51352fd765c2c5d1b395b9fabd5f33a06654b600c3042c8c28)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanCompoundTransformationsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e213c42047886386761067619243afb1fe792da54e64f3c0a575061b45b4039a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5cd1a448fa76205677fe0803abd8689491a085c35900076a7d5aa8025370327e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5641e94b42cee1b093cdf51d6540810f3f9e14eb42328c99b2cc7052eff61411)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanCompoundTransformations]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanCompoundTransformations]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanCompoundTransformations]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f056073998d884ae7e9f96eead1503790082f3c6651bfb8abe214e40bc891223)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanCompoundTransformationsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanCompoundTransformationsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5d6b20f3416cb062b42218a0cf3d90460184c97199bf4100d505f42a684a8bb8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanCompoundTransformations]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanCompoundTransformations]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanCompoundTransformations]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5a634191278ba2ddbc952483e6a3776da294fd6d65e27dbe8c12c7dd28a45cb8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanContrast",
    jsii_struct_bases=[],
    name_mapping={
        "brightness": "brightness",
        "brightness_var": "brightnessVar",
        "contrast": "contrast",
        "contrast_var": "contrastVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanContrast:
    def __init__(
        self,
        *,
        brightness: typing.Optional[builtins.str] = None,
        brightness_var: typing.Optional[builtins.str] = None,
        contrast: typing.Optional[builtins.str] = None,
        contrast_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param brightness: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        :param brightness_var: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        :param contrast: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param contrast_var: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e685f891e716556ec22dfd9342c862d590d0f201a4d3e6218f252c309b221d7f)
            check_type(argname="argument brightness", value=brightness, expected_type=type_hints["brightness"])
            check_type(argname="argument brightness_var", value=brightness_var, expected_type=type_hints["brightness_var"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument contrast_var", value=contrast_var, expected_type=type_hints["contrast_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if brightness is not None:
            self._values["brightness"] = brightness
        if brightness_var is not None:
            self._values["brightness_var"] = brightness_var
        if contrast is not None:
            self._values["contrast"] = contrast
        if contrast_var is not None:
            self._values["contrast_var"] = contrast_var

    @builtins.property
    def brightness(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        '''
        result = self._values.get("brightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def brightness_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        '''
        result = self._values.get("brightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        result = self._values.get("contrast_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanContrast(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanContrastList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanContrastList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__96b05f90a42fe14e61c96a16ea5dd8594c9c8ea1f128b976531b2010c02a038b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanContrastOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f4d0a9e057676e493b9d93c8cb96b37fd6023ed40ab43bdd2a0159b96f01b02)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanContrastOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4e43e91e8901d2e0753878a0a173a05b10e69ca0f9dd421147733b4176c21dab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a029521b31294ecc6a052c07d7675891cec5be8dc8e9f467ab818f75a218d8d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bdca1231f3b0a4fe1aadd22c74dbbdfcc563054c4496bc4b29ee64d75803d44c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanContrast]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanContrast]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__57fb79aaef03469cecd5bcfd8a564c49834b1977b1be1e788e5514a5d9782a13)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanContrastOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanContrastOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9b06bd5d0210751a4f92850028a293c119aff46cc3c35d6a58e36b570e6e6950)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetBrightness")
    def reset_brightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightness", []))

    @jsii.member(jsii_name="resetBrightnessVar")
    def reset_brightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightnessVar", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetContrastVar")
    def reset_contrast_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrastVar", []))

    @builtins.property
    @jsii.member(jsii_name="brightnessInput")
    def brightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="brightnessVarInput")
    def brightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastVarInput")
    def contrast_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="brightness")
    def brightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightness"))

    @brightness.setter
    def brightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1e11c1bded5316ce54d5f7cf3f1407a000de35df6f83d1107268c005a60e51ce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightness", value)

    @builtins.property
    @jsii.member(jsii_name="brightnessVar")
    def brightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightnessVar"))

    @brightness_var.setter
    def brightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2962cd1f61dc0812cd384043e2860652899d53a7f75fc36e94103f3a0da00a2e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrast"))

    @contrast.setter
    def contrast(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bec1651f378e45c58e5b37596c81220c3dc3c2714fb08c6485e792c23684ad1b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrast", value)

    @builtins.property
    @jsii.member(jsii_name="contrastVar")
    def contrast_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrastVar"))

    @contrast_var.setter
    def contrast_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__73a21cd1b32a382e1135623fd6d5e5baa7c1dfc45cc32386cd2bd9d15ef345de)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrastVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanContrast]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanContrast]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanContrast]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__871865a9958eb638be9af6cb0bee8dc342f0de38b0cd16fd3ebed0a2dac170d1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanGoop",
    jsii_struct_bases=[],
    name_mapping={
        "chaos": "chaos",
        "chaos_var": "chaosVar",
        "density": "density",
        "density_var": "densityVar",
        "power": "power",
        "power_var": "powerVar",
        "seed": "seed",
        "seed_var": "seedVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanGoop:
    def __init__(
        self,
        *,
        chaos: typing.Optional[builtins.str] = None,
        chaos_var: typing.Optional[builtins.str] = None,
        density: typing.Optional[builtins.str] = None,
        density_var: typing.Optional[builtins.str] = None,
        power: typing.Optional[builtins.str] = None,
        power_var: typing.Optional[builtins.str] = None,
        seed: typing.Optional[builtins.str] = None,
        seed_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param chaos: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        :param chaos_var: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        :param density: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        :param density_var: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        :param power: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        :param power_var: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        :param seed: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        :param seed_var: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4bdfa31dd0490a64f23fca47659ed25ecd985fefeb0c301faf53b1995cbe062d)
            check_type(argname="argument chaos", value=chaos, expected_type=type_hints["chaos"])
            check_type(argname="argument chaos_var", value=chaos_var, expected_type=type_hints["chaos_var"])
            check_type(argname="argument density", value=density, expected_type=type_hints["density"])
            check_type(argname="argument density_var", value=density_var, expected_type=type_hints["density_var"])
            check_type(argname="argument power", value=power, expected_type=type_hints["power"])
            check_type(argname="argument power_var", value=power_var, expected_type=type_hints["power_var"])
            check_type(argname="argument seed", value=seed, expected_type=type_hints["seed"])
            check_type(argname="argument seed_var", value=seed_var, expected_type=type_hints["seed_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if chaos is not None:
            self._values["chaos"] = chaos
        if chaos_var is not None:
            self._values["chaos_var"] = chaos_var
        if density is not None:
            self._values["density"] = density
        if density_var is not None:
            self._values["density_var"] = density_var
        if power is not None:
            self._values["power"] = power
        if power_var is not None:
            self._values["power_var"] = power_var
        if seed is not None:
            self._values["seed"] = seed
        if seed_var is not None:
            self._values["seed_var"] = seed_var

    @builtins.property
    def chaos(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        '''
        result = self._values.get("chaos")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def chaos_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        '''
        result = self._values.get("chaos_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        '''
        result = self._values.get("density")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density_var(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        '''
        result = self._values.get("density_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        '''
        result = self._values.get("power")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power_var(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        '''
        result = self._values.get("power_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        '''
        result = self._values.get("seed")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed_var(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        result = self._values.get("seed_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanGoop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanGoopList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanGoopList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__45a31897ae50bef2c47c7093fdeb3f2999ac58273f75117ff396851f92084c97)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanGoopOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d8cf4aa1ec687fe10b40d3178d14fd48428bf14423dcdd4f4f41724e9b550913)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanGoopOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b1c2de053441a33f4eb88aaf32894007b08e227200407b1523c65232825a4c90)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__78e664d01f828bb99ea144b149903beedb93fe088f914e79d250b44542d70444)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a52ecac1aabafee2876b44d7a45993e72e4d569a3025cfbc9ff637fd5de0fe4c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanGoop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanGoop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__352b8396f2d1e5bb6b35b2e77d340f13700b5c4bdbc3e60862a5f77f921e7dfa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanGoopOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanGoopOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c7ac5ab6f4cece08536d6a170b0b1a772bd7813c601127c254aced4e10f97c08)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetChaos")
    def reset_chaos(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaos", []))

    @jsii.member(jsii_name="resetChaosVar")
    def reset_chaos_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaosVar", []))

    @jsii.member(jsii_name="resetDensity")
    def reset_density(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensity", []))

    @jsii.member(jsii_name="resetDensityVar")
    def reset_density_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensityVar", []))

    @jsii.member(jsii_name="resetPower")
    def reset_power(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPower", []))

    @jsii.member(jsii_name="resetPowerVar")
    def reset_power_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPowerVar", []))

    @jsii.member(jsii_name="resetSeed")
    def reset_seed(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeed", []))

    @jsii.member(jsii_name="resetSeedVar")
    def reset_seed_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeedVar", []))

    @builtins.property
    @jsii.member(jsii_name="chaosInput")
    def chaos_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosInput"))

    @builtins.property
    @jsii.member(jsii_name="chaosVarInput")
    def chaos_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosVarInput"))

    @builtins.property
    @jsii.member(jsii_name="densityInput")
    def density_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityInput"))

    @builtins.property
    @jsii.member(jsii_name="densityVarInput")
    def density_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="powerInput")
    def power_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerInput"))

    @builtins.property
    @jsii.member(jsii_name="powerVarInput")
    def power_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerVarInput"))

    @builtins.property
    @jsii.member(jsii_name="seedInput")
    def seed_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedInput"))

    @builtins.property
    @jsii.member(jsii_name="seedVarInput")
    def seed_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedVarInput"))

    @builtins.property
    @jsii.member(jsii_name="chaos")
    def chaos(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaos"))

    @chaos.setter
    def chaos(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6ce5e8a7eec4bd8dda1992dcccb4a5f1e9dd06ab5c43a672b532a39bdf696935)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaos", value)

    @builtins.property
    @jsii.member(jsii_name="chaosVar")
    def chaos_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaosVar"))

    @chaos_var.setter
    def chaos_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__888b858e83c4d7956ee8a3e435cb9dd0d1e1765b46e0cde125d7a6b1afdfd382)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaosVar", value)

    @builtins.property
    @jsii.member(jsii_name="density")
    def density(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "density"))

    @density.setter
    def density(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ae8ef92514071582da4a62c64a9ffbc7018e78a392eb9680ca2ec230382c66be)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "density", value)

    @builtins.property
    @jsii.member(jsii_name="densityVar")
    def density_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "densityVar"))

    @density_var.setter
    def density_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e3b8a9909d48ac7d76454491ba4adb0214ff10a7013071be986be779abef54dd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "densityVar", value)

    @builtins.property
    @jsii.member(jsii_name="power")
    def power(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "power"))

    @power.setter
    def power(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6aa849af9db5b11b108fc3c50b8628b1439ac15a63e4089f3fe97c2a044909d4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "power", value)

    @builtins.property
    @jsii.member(jsii_name="powerVar")
    def power_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "powerVar"))

    @power_var.setter
    def power_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__74e4e50adcde8ce3ce3f6b1b52fbdb97d7f82be32449a4490a490fe5e9d5c071)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "powerVar", value)

    @builtins.property
    @jsii.member(jsii_name="seed")
    def seed(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seed"))

    @seed.setter
    def seed(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ed86238d6890e6c8ccc64164bf190fd8a1cc2133456a825ed7983ec298af001)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seed", value)

    @builtins.property
    @jsii.member(jsii_name="seedVar")
    def seed_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seedVar"))

    @seed_var.setter
    def seed_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__06fc0418026e20a9238e9469a7a0d876cac3d4b21b6b6816ee81129ad99ed3bf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seedVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanGoop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanGoop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanGoop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__285cb4a1511be77a521bd98bbdcab60e93c4fe4391bd586e1ed33d2301d7972f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanGrayscale",
    jsii_struct_bases=[],
    name_mapping={"type": "type", "type_var": "typeVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanGrayscale:
    def __init__(
        self,
        *,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param type: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d7a30b702dbc58e12392722d8b15eaf2f148e259c9f6d672dfaf5e44c7371a17)
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanGrayscale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanGrayscaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanGrayscaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__252297b9c51e9376594c24f98d13ccdd604c12207f2e1fe9192a65f8e4364704)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanGrayscaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d598148bf2278fa92bae1a17ddd9ac929ff57b600fb8c2221cb41c4d79ed342c)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanGrayscaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__421799cd5d3ee0dde97d20d80876793a655d4519327655b3e2aa1eddf7032aa2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__625fc077e3e9cb566420bea62b8e53ff7d7c81d88f1a76b4c81db3e93bab0040)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1fc4c28405e85edf868adec42731191f9b5530cccf0027165227a3418a0b6c9e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanGrayscale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanGrayscale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__362791a9471131b3ab6119535fb01fcf53a24f72ef0862f0961714b96a7c58b9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanGrayscaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanGrayscaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7b4bae4d35e1df975816cacb2cdef556c28e91cac2c3b4bf2abca18654ebef34)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__db0ceca86355374a4a05147592f44aa3e2efeb60ee20b4f293ea8facdf262ae9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dd671e7e2041265487efbc16efec0c3ea2f43fa333f74f7cab7deb889485c387)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanGrayscale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanGrayscale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanGrayscale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7097f860aaa67cd9edc6f101061f5e405720e00492052e95b431556e1bc449d0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanHsl",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "lightness": "lightness",
        "lightness_var": "lightnessVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanHsl:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness: typing.Optional[builtins.str] = None,
        lightness_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        :param lightness_var: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__583898a80388c49ed3a74fed4d0821eb5d810f6aa8e689f728924a521f011ad1)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness", value=lightness, expected_type=type_hints["lightness"])
            check_type(argname="argument lightness_var", value=lightness_var, expected_type=type_hints["lightness_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness is not None:
            self._values["lightness"] = lightness
        if lightness_var is not None:
            self._values["lightness_var"] = lightness_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        '''
        result = self._values.get("lightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        '''
        result = self._values.get("lightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanHsl(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanHslList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanHslList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e7fd5044204d8091b8f5530c654af137e7a5f2afa6703c153649255acf68d31)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanHslOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__56fd6193f79fc8c1ff2fae70a779745734bf839d0dc8f296695eac7f83f1dd2d)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanHslOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__78ebc8aed2bd4d072a7c4e28c6434d80887bb664fad29479ab0b9ab757552713)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b612ecaa6731c940c5584101ac0629d7662179a0e5020f1c05ccdbc4410dcb35)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e371ecb145e43158c03a05c766ac0c4e9efd93a1a29ed3984279eb795c7a82f2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanHsl]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanHsl]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__30397ef062dacef48193629c716fdef0b11e9d1f781af9522e929dfe665cae98)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanHslOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanHslOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd9aa49f8931f23ce852e17a22f05af902d0a18fc32169275070e64afee2ebc7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightness")
    def reset_lightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightness", []))

    @jsii.member(jsii_name="resetLightnessVar")
    def reset_lightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessInput")
    def lightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessVarInput")
    def lightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fb2f95d41e72e8c1db978962664e05655af86aa054f1f1ae727e5896ad3eda3f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2e945da579b84a5ec85034fb00cdf4db6a4696287d234a1b2704be4a2bb27242)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightness")
    def lightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightness"))

    @lightness.setter
    def lightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__91166331054a984a3a012c409bc9015e6fdfb94e79b5f1904396d31d148959cf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightness", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessVar")
    def lightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessVar"))

    @lightness_var.setter
    def lightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__21f53fca7b2de6ea8ad50bb92afec0a2ce2865b0f92681c8156997b181a80033)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8d6c36ae4c6e52684b1e3c4988966ba0e9dcd24e53fe93b0a3a0a81abf4cc8a6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__00ed4a46e43150637da291a30f08efefe88e8ea0b3c2db26831f171c76c0eae4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanHsl]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanHsl]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanHsl]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__57c60ba7cd6c9dd77af7eea8b4bcc1acf3172433c7a4945e8fb7bb03b0dba568)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanHsv",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanHsv:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        :param value: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9beef736a01b45a4a56d3dec640791d2b148f0716aef72d7b17fcf9c800951bd)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanHsv(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanHsvList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanHsvList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__913a9599f85260524139c92fef1c29de5adf947b97313ca13f54f617a65ea7e0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanHsvOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__32889d542e69102e6d789fda152d572797c4eb6724f1d4a5574372e7209e3992)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanHsvOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f36d0873b909a6d70c7e94f7c8feb86e5cc12fd27dd9635b806e9269d3a07d06)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8661ade02f3747f2a3265978dbbfd9dbfb1eba6cdbf1c574884cf83a2c2d7b61)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c4a6ae84b494d03af195d8b932494a4b6664071b0a25669657ef6b4a7e6b2669)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanHsv]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanHsv]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__881d3d422f8da051b83dac61a4c36ca3c0d438552e66f28b62ad62bde4f8be86)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanHsvOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanHsvOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eb414a59a7cc95ddd9ac475c36f9790fcd57bc3d14c5e7cbb08d0692a3bd7080)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ffaa9ccbe3ad995c55d7ffe02ef484b35a4324ac98d1117ed294888b3653f641)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c8467287f76cfe3455f937f28ba60154062133a0be0e2253cb80fd8b59fc2bf2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__323c2c4535fed730b72d3e1698d1cc3a2ee3c4710cc5e2c6a205166e2f3ad849)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__076c986bc82d85ba2b2d60b4db56f1128e22f8ff86398bb9e8bbbce05382b8bb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__55a28ebcb9d53e045e3f9fc8357d4fd6d8f6ebc840e9105a141e8e25a0d11258)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3c8256ffee6bd865bc05e8afbf919ba08ffec92512f927b804bf18aee6e7e032)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanHsv]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanHsv]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanHsv]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__15b0d4d5b0d28a9f49d1e2ce79a861b340333ba63dcf20e92c9bb0d8fffb4e88)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimension",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "dimension": "dimension",
        "dimension_var": "dimensionVar",
        "equal": "equal",
        "greater_than": "greaterThan",
        "less_than": "lessThan",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimension:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        dimension: typing.Optional[builtins.str] = None,
        dimension_var: typing.Optional[builtins.str] = None,
        equal: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionEqual", typing.Dict[builtins.str, typing.Any]]] = None,
        greater_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionGreaterThan", typing.Dict[builtins.str, typing.Any]]] = None,
        less_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionLessThan", typing.Dict[builtins.str, typing.Any]]] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param dimension: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        :param dimension_var: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        :param equal: equal block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        :param greater_than: greater_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        :param less_than: less_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        :param value: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionDefault(**default)
        if isinstance(equal, dict):
            equal = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionEqual(**equal)
        if isinstance(greater_than, dict):
            greater_than = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionGreaterThan(**greater_than)
        if isinstance(less_than, dict):
            less_than = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionLessThan(**less_than)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__258cdeb5eb25cca0a3b7a683195dd6fbd4c50a68175c1e8253c8ad78e79b6d61)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument dimension", value=dimension, expected_type=type_hints["dimension"])
            check_type(argname="argument dimension_var", value=dimension_var, expected_type=type_hints["dimension_var"])
            check_type(argname="argument equal", value=equal, expected_type=type_hints["equal"])
            check_type(argname="argument greater_than", value=greater_than, expected_type=type_hints["greater_than"])
            check_type(argname="argument less_than", value=less_than, expected_type=type_hints["less_than"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if dimension is not None:
            self._values["dimension"] = dimension
        if dimension_var is not None:
            self._values["dimension_var"] = dimension_var
        if equal is not None:
            self._values["equal"] = equal
        if greater_than is not None:
            self._values["greater_than"] = greater_than
        if less_than is not None:
            self._values["less_than"] = less_than
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionDefault"], result)

    @builtins.property
    def dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        '''
        result = self._values.get("dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        '''
        result = self._values.get("dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def equal(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionEqual"]:
        '''equal block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        '''
        result = self._values.get("equal")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionEqual"], result)

    @builtins.property
    def greater_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionGreaterThan"]:
        '''greater_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        '''
        result = self._values.get("greater_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionGreaterThan"], result)

    @builtins.property
    def less_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionLessThan"]:
        '''less_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        '''
        result = self._values.get("less_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionLessThan"], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimension(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0dd241d81f071f80bbc08d22e8ce8cdfe44026b1cbc697010915ae63edeadfe0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__879b63a22bc25ad70976ab8dec3002923fe18ac427b30942b9410934516b5fd6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionEqual",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionEqual:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionEqual(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionEqualOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionEqualOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__605e312e8ca6224266eef0b4ef64f47ee2ef29f2bf23e081c2bc6a4fe2f03e71)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionEqual], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionEqual],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__547b96e19ac0b7c143809c6ac77cd5ec372e65baf73f50781a0caa0541ec0521)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionGreaterThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionGreaterThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionGreaterThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionGreaterThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionGreaterThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__067340a10d919ce50b78c401742a9af6d962ea62da88b1dfcde1e91ee590f1c6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionGreaterThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionGreaterThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9e17a9b7a66a6e6fb33a549de10c860ea3c487fbe6b4a6d2ae9ea8bd7948e01c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionLessThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionLessThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionLessThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionLessThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionLessThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__70b952f59d2741b744a2b3b154537550722f84307653be574a25e4635cb8769b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionLessThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionLessThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d1b2ae389753c64dc96993fece8c79e3345e4298e17c5d997d0c5dc0869c4c0a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__78cffd63519bb20d7bd8dcedd781f05115b5c1d796ec9f3356afffe1852b94be)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c6cb76b2fd3f801304e03962d73e6e6eff65d5c5e2209a6b952284599c7ded92)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ba2f371abaf4c7bd7dce7f903d8ba87c75ca5bfc7379a1b722a1666ddde1fe1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__810c675b2a62f89fcc2f602fec1b6bafb4a38a3b529448619659914f96970fe9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a135986640fffed3ef8e91aa41bb786ae69200b831422486216f6b1c51549f1d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimension]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimension]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__82be291ee3e9b384804a26e188d653c9d02ac03f375322956db86dce20897911)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__20f0b96c0b167bf185baa9bf7db7fce547672a1e4ebaa132d211e4240ad39fa6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putEqual")
    def put_equal(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionEqual()

        return typing.cast(None, jsii.invoke(self, "putEqual", [value]))

    @jsii.member(jsii_name="putGreaterThan")
    def put_greater_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionGreaterThan()

        return typing.cast(None, jsii.invoke(self, "putGreaterThan", [value]))

    @jsii.member(jsii_name="putLessThan")
    def put_less_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionLessThan()

        return typing.cast(None, jsii.invoke(self, "putLessThan", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetDimension")
    def reset_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimension", []))

    @jsii.member(jsii_name="resetDimensionVar")
    def reset_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimensionVar", []))

    @jsii.member(jsii_name="resetEqual")
    def reset_equal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEqual", []))

    @jsii.member(jsii_name="resetGreaterThan")
    def reset_greater_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGreaterThan", []))

    @jsii.member(jsii_name="resetLessThan")
    def reset_less_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLessThan", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="equal")
    def equal(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionEqualOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionEqualOutputReference, jsii.get(self, "equal"))

    @builtins.property
    @jsii.member(jsii_name="greaterThan")
    def greater_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionGreaterThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionGreaterThanOutputReference, jsii.get(self, "greaterThan"))

    @builtins.property
    @jsii.member(jsii_name="lessThan")
    def less_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionLessThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionLessThanOutputReference, jsii.get(self, "lessThan"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionInput")
    def dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionVarInput")
    def dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="equalInput")
    def equal_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionEqual], jsii.get(self, "equalInput"))

    @builtins.property
    @jsii.member(jsii_name="greaterThanInput")
    def greater_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionGreaterThan], jsii.get(self, "greaterThanInput"))

    @builtins.property
    @jsii.member(jsii_name="lessThanInput")
    def less_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionLessThan], jsii.get(self, "lessThanInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="dimension")
    def dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimension"))

    @dimension.setter
    def dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eefb8088d268aaceed1cf7bcf69eddcab61341900657ad66a0b94b53363546cd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimension", value)

    @builtins.property
    @jsii.member(jsii_name="dimensionVar")
    def dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimensionVar"))

    @dimension_var.setter
    def dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__700968cececdafcecac49bcf4347eaf31e62017676188a6e253d88ef6ac996fc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__44abc5f766ad652d546f04d622ba17ece8b802f9fb9eee7fa5ba312d1a2d609e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3df4e6782abf1b12d085dd338aebd2b60406204f16c7133ef52061f0b78ac00c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimension]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimension]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimension]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1489263812d7609dd226b03bb949d3b9b9739caa99f6d492b2ab58eb35cf0d41)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientation",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "landscape": "landscape",
        "portrait": "portrait",
        "square": "square",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientation:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        landscape: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationLandscape", typing.Dict[builtins.str, typing.Any]]] = None,
        portrait: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationPortrait", typing.Dict[builtins.str, typing.Any]]] = None,
        square: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationSquare", typing.Dict[builtins.str, typing.Any]]] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param landscape: landscape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        :param portrait: portrait block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        :param square: square block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationDefault(**default)
        if isinstance(landscape, dict):
            landscape = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationLandscape(**landscape)
        if isinstance(portrait, dict):
            portrait = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationPortrait(**portrait)
        if isinstance(square, dict):
            square = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationSquare(**square)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6acc4d0a06669d8fadf3bc4a509ee4f8dfa685a03aaa024011853f7372893b9d)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument landscape", value=landscape, expected_type=type_hints["landscape"])
            check_type(argname="argument portrait", value=portrait, expected_type=type_hints["portrait"])
            check_type(argname="argument square", value=square, expected_type=type_hints["square"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if landscape is not None:
            self._values["landscape"] = landscape
        if portrait is not None:
            self._values["portrait"] = portrait
        if square is not None:
            self._values["square"] = square

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationDefault"], result)

    @builtins.property
    def landscape(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationLandscape"]:
        '''landscape block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        '''
        result = self._values.get("landscape")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationLandscape"], result)

    @builtins.property
    def portrait(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationPortrait"]:
        '''portrait block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        '''
        result = self._values.get("portrait")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationPortrait"], result)

    @builtins.property
    def square(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationSquare"]:
        '''square block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        result = self._values.get("square")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationSquare"], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__380427f4ebf3e48ffd2897fa7cafeffc512d061c5c5d0a03269e1f1901d1f7ff)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6924aaed4deb9a7596aca5ce70fead8ba8f8d661cda0380efeec19cb4c16e0fb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationLandscape",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationLandscape:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationLandscape(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationLandscapeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationLandscapeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8e3abc20c976de6983549c256e3777afe919f94fb2aa807d45c29edbfaf77c19)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationLandscape], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationLandscape],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e772a70ecfd587a0a469f3514154eeb6b9d6aeec21b954f63cbf255f4f21bdeb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b10f5bd77d88686e80d53ba12eebfa44c87abaff8b87dc2fb2f82e6782b1044b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__80b29f71c3efb58a62e6857daa2647bd07556aeef99d8b15e5f3685935ee1b9d)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__03136e3af39c2cdfdb9bf70c69bacaa416c64149ce02595ba47801d0f7b172ae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fbb8fd811dedd382b1de0f9627b86c3f504688f1dedfc555c29384550546f511)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__096e8220f0592155a286f1c7155bf68927f7b8c4270f24a1cc67d1ece4288723)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientation]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientation]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ddda58eda0d3fd9ccc5490fe08510941d5c8273071a7192c4a7a6d648d90fdc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a36e9af03813b06c55e259e33a802da1c5fd19fde88d3258854f8af8dc17ab40)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putLandscape")
    def put_landscape(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationLandscape()

        return typing.cast(None, jsii.invoke(self, "putLandscape", [value]))

    @jsii.member(jsii_name="putPortrait")
    def put_portrait(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationPortrait()

        return typing.cast(None, jsii.invoke(self, "putPortrait", [value]))

    @jsii.member(jsii_name="putSquare")
    def put_square(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationSquare()

        return typing.cast(None, jsii.invoke(self, "putSquare", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetLandscape")
    def reset_landscape(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLandscape", []))

    @jsii.member(jsii_name="resetPortrait")
    def reset_portrait(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPortrait", []))

    @jsii.member(jsii_name="resetSquare")
    def reset_square(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSquare", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="landscape")
    def landscape(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationLandscapeOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationLandscapeOutputReference, jsii.get(self, "landscape"))

    @builtins.property
    @jsii.member(jsii_name="portrait")
    def portrait(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationPortraitOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationPortraitOutputReference", jsii.get(self, "portrait"))

    @builtins.property
    @jsii.member(jsii_name="square")
    def square(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationSquareOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationSquareOutputReference", jsii.get(self, "square"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="landscapeInput")
    def landscape_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationLandscape], jsii.get(self, "landscapeInput"))

    @builtins.property
    @jsii.member(jsii_name="portraitInput")
    def portrait_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationPortrait"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationPortrait"], jsii.get(self, "portraitInput"))

    @builtins.property
    @jsii.member(jsii_name="squareInput")
    def square_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationSquare"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationSquare"], jsii.get(self, "squareInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientation]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientation]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientation]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ead8b01ed18bf16d95e81a5c43e92e4024056b4cf36abc9046f0042183bc0cbd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationPortrait",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationPortrait:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationPortrait(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationPortraitOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationPortraitOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__07f7537fad246dc22c33f25164ffb31d9dedf152f34b1e7d6a0a85339408e58c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationPortrait]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationPortrait], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationPortrait],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__30d74effb15f20f8d278627a7e2539c3e22b6c4aa594d22b348355f5363efe5a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationSquare",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationSquare:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationSquare(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationSquareOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationSquareOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d87a52377926ab65d070a4171f88c926153e643297534dc228d19a7b745610f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationSquare]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationSquare], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationSquare],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a6ce4f5e6305512696e9f78883c37eb893fcbf47f878c6d70d6932a340ab58ac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanMaxColors",
    jsii_struct_bases=[],
    name_mapping={"colors": "colors", "colors_var": "colorsVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanMaxColors:
    def __init__(
        self,
        *,
        colors: typing.Optional[builtins.str] = None,
        colors_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param colors: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        :param colors_var: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__01c70657eb248a938f874085e561ed867f33cff51e4c8cde3ce8a97235ce8bc9)
            check_type(argname="argument colors", value=colors, expected_type=type_hints["colors"])
            check_type(argname="argument colors_var", value=colors_var, expected_type=type_hints["colors_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if colors is not None:
            self._values["colors"] = colors
        if colors_var is not None:
            self._values["colors_var"] = colors_var

    @builtins.property
    def colors(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        '''
        result = self._values.get("colors")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def colors_var(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        result = self._values.get("colors_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanMaxColors(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanMaxColorsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanMaxColorsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__36621c431e515747a0828afb89772e5ac8b0d7e6fce022bc358fe62312509152)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanMaxColorsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__10d576bf5c84d7ea8ddd1d1313c2128dbcce70b3eff4718d0de1689bae0b0f94)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanMaxColorsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e18515dd2fac349bf4ad71549352e8aa8ebb00d66db70ee768e94de1738b69a6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7c07564ec43f6c64b52902e2440be63ded320d7b218bcf3ce11daf15e6fd1938)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9c58289bcc76c2769c1bc5b23e9ee0435611075232dcc2e575bbb250fa35beee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanMaxColors]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanMaxColors]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3df344e341f899720fc2ce516e0144ac460b3cf403f836b8976957717c3ef453)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanMaxColorsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanMaxColorsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__77a5f6f7f54b2e8170a01e2d2c50f2e643a7068ff9ba7e068f7cb9bd3e68d062)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColors")
    def reset_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColors", []))

    @jsii.member(jsii_name="resetColorsVar")
    def reset_colors_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorsVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorsInput")
    def colors_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsInput"))

    @builtins.property
    @jsii.member(jsii_name="colorsVarInput")
    def colors_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsVarInput"))

    @builtins.property
    @jsii.member(jsii_name="colors")
    def colors(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colors"))

    @colors.setter
    def colors(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7c0fa9e9b1d628e8fbc913a3b1df1065ebcd5cd49dc753f06907498891515931)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colors", value)

    @builtins.property
    @jsii.member(jsii_name="colorsVar")
    def colors_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorsVar"))

    @colors_var.setter
    def colors_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7a7b10ce0598b4480793dbac4a0ba16821ad12e214c002d6959ee8e908c3771e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorsVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanMaxColors]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanMaxColors]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanMaxColors]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__76be198eb1f2b94f97ecb8ca6d7ea1e970d0495dab064e0c9e71bcebd863fb96)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanMirror",
    jsii_struct_bases=[],
    name_mapping={
        "horizontal": "horizontal",
        "horizontal_var": "horizontalVar",
        "vertical": "vertical",
        "vertical_var": "verticalVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanMirror:
    def __init__(
        self,
        *,
        horizontal: typing.Optional[builtins.str] = None,
        horizontal_var: typing.Optional[builtins.str] = None,
        vertical: typing.Optional[builtins.str] = None,
        vertical_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param horizontal: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        :param horizontal_var: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        :param vertical: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        :param vertical_var: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ee61cff270ad2bc00980c08ff3613235eea459df3ba9d1ea71ee5c2f9b59b5ca)
            check_type(argname="argument horizontal", value=horizontal, expected_type=type_hints["horizontal"])
            check_type(argname="argument horizontal_var", value=horizontal_var, expected_type=type_hints["horizontal_var"])
            check_type(argname="argument vertical", value=vertical, expected_type=type_hints["vertical"])
            check_type(argname="argument vertical_var", value=vertical_var, expected_type=type_hints["vertical_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if horizontal is not None:
            self._values["horizontal"] = horizontal
        if horizontal_var is not None:
            self._values["horizontal_var"] = horizontal_var
        if vertical is not None:
            self._values["vertical"] = vertical
        if vertical_var is not None:
            self._values["vertical_var"] = vertical_var

    @builtins.property
    def horizontal(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        '''
        result = self._values.get("horizontal")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def horizontal_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        '''
        result = self._values.get("horizontal_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        '''
        result = self._values.get("vertical")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        result = self._values.get("vertical_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanMirror(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanMirrorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanMirrorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1efb990a8509bf763de2b4a23f2b6d62d0206ad5bb72f9e37dbec7cf153c5fa1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanMirrorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1e3d0a36c2918ec95cc72340e368451fd17883090a3c4e1111cb86d6dc1c790b)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanMirrorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f766f13bc0eab19122e74784995a14942b73f33cdff492842a0f4576d440a4c2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a68d1d968083c082f2a27de9b732316568962f1e08b8a6deb91657705d282fc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b4d7daf1879f447c1163d7d034882a76f8c292dac194e6a030abfdbfbfe39501)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanMirror]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanMirror]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__794e4ac72a1ff65086b61afb8922f5df825321242e210aac0ec7b8eeca7671da)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanMirrorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanMirrorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7705ef99dd22cdc35df9d52b07d46ff7ba4d2b5d96406b20a8a60cac1d08a7b7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHorizontal")
    def reset_horizontal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontal", []))

    @jsii.member(jsii_name="resetHorizontalVar")
    def reset_horizontal_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontalVar", []))

    @jsii.member(jsii_name="resetVertical")
    def reset_vertical(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVertical", []))

    @jsii.member(jsii_name="resetVerticalVar")
    def reset_vertical_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVerticalVar", []))

    @builtins.property
    @jsii.member(jsii_name="horizontalInput")
    def horizontal_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontalVarInput")
    def horizontal_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalInput")
    def vertical_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalVarInput")
    def vertical_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontal")
    def horizontal(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontal"))

    @horizontal.setter
    def horizontal(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cc2f5f7ed4e3f9f009e962d7158244db4e27533f9b692cd324fd87b755256d05)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontal", value)

    @builtins.property
    @jsii.member(jsii_name="horizontalVar")
    def horizontal_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontalVar"))

    @horizontal_var.setter
    def horizontal_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e444f25ebd95e82ffb9f5673a76c8a2b07fcef959daaea376a7f4c746dbd95ff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontalVar", value)

    @builtins.property
    @jsii.member(jsii_name="vertical")
    def vertical(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "vertical"))

    @vertical.setter
    def vertical(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__daf04381380b598203479435f7acee761991c71b9262a928cf8475daac3f0b16)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "vertical", value)

    @builtins.property
    @jsii.member(jsii_name="verticalVar")
    def vertical_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "verticalVar"))

    @vertical_var.setter
    def vertical_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__476f2674fa94b496e29f57cdd5c13ab96ae956acf9e6b7abd7008d35504d0cf1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "verticalVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanMirror]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanMirror]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanMirror]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ddc923fc5e060644a60045e23b6da88eda98128cef676642dc710e461349d383)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanMonoHue",
    jsii_struct_bases=[],
    name_mapping={"hue": "hue", "hue_var": "hueVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanMonoHue:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__56c7e24f6b730eadae4577348cf5b0dbc701ad77c05f5b1615da4d86937bf648)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanMonoHue(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanMonoHueList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanMonoHueList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fdf968360c898ba94b63c53729d8e304dac2bfb7d60886afc2264fa76b1c4e49)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanMonoHueOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__25c40525882bd0bed3df716aee0ec6c5778df173dc5ced6e0f9406300fca4a05)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanMonoHueOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c55bfc0e48def447cadbd01181a08bd14824fe5545262bcbe0354035d3dcfb85)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b2252e71240169252695b621b656caea037e702f0bb4ec25d9f19d3a62d3209d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dcb5156d10d21d0030c889c5a52d1e1065bd718ef2ccd310444e495bbb52d246)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanMonoHue]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanMonoHue]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c2774ecbd60a6a5fa33d2591f00782578963f0bc78e52ba1960ac9d4b5b1eb8e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanMonoHueOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanMonoHueOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f96d0b0b5b8bb1f69fa6c10878c7177017fa8a100b071c4817fe64adde12d076)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b532b71bd81be8c3459c3e9a8d35215377dd5a8a7e22de35aa2a88f0cb6d6a49)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be98b7caccacc6a799f0d6da325793e91bb234d07136db64df585a41007fbca2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanMonoHue]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanMonoHue]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanMonoHue]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aefeddb6fa496bb884dc33ab835acca0635b24cbf4eb9da8573fa1f0b64aac78)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanOpacity",
    jsii_struct_bases=[],
    name_mapping={"opacity": "opacity", "opacity_var": "opacityVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanOpacity:
    def __init__(
        self,
        *,
        opacity: typing.Optional[builtins.str] = None,
        opacity_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param opacity: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param opacity_var: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bf351135fdd2c5cee839c0c1825904a261182ed18adb48f840891794b1d5104e)
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument opacity_var", value=opacity_var, expected_type=type_hints["opacity_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if opacity is not None:
            self._values["opacity"] = opacity
        if opacity_var is not None:
            self._values["opacity_var"] = opacity_var

    @builtins.property
    def opacity(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def opacity_var(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        result = self._values.get("opacity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanOpacity(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanOpacityList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanOpacityList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__26e056b1c9e2f41eee8d6461128f0262811316784a5dce0b70aba2f275250289)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanOpacityOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0a03d8f1b94029a55d45c935bbec0402f3deebb0886394b86c1471dee367dbad)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanOpacityOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fd8bc6480007e69d2092463dc512dcdd2bb8173163ab834ffd67655d2894dc03)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c1814a85970d4190821b2ee63549c996a845bb06417b86f3c0e25296da536e47)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ca5c0eed4720744d9bc7442a6cfa4ff8459500481fb6eb878db58376b081a42c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanOpacity]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanOpacity]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__98fe7fecc0ecee460785c6b9991a5a323255a222e84c54c75b8cd2a125740ec0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanOpacityOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanOpacityOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a79f371f6e661d2591a54d8ea670da82773847b0d5aaca3dd7e288b5de3c871)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetOpacityVar")
    def reset_opacity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacityVar", []))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityVarInput")
    def opacity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacity"))

    @opacity.setter
    def opacity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__676992d4063dbccbac0ebf4275d485eaa02124a0c69760686b44075197768f86)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacity", value)

    @builtins.property
    @jsii.member(jsii_name="opacityVar")
    def opacity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacityVar"))

    @opacity_var.setter
    def opacity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5c2c67d1fc9bf5bdac8aaeb51a54c9c39abcc77b923db4a9e7c3b97f5c02bd2c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacityVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanOpacity]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanOpacity]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanOpacity]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__76c4e9e99f912d40dd398122d84d876d15e2b80fe19788ab7daf72edfd85674c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2850442bf8888ba6fbb4dc352864ec4dfd8cc52a4a7bf124ffbc28ed2f200b5c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putBackgroundColor")
    def put_background_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0a48457d984c234144e6ce5a7486b82c7d8234ea13eb18927e495785885bf259)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBackgroundColor", [value]))

    @jsii.member(jsii_name="putBlur")
    def put_blur(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanBlur, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6051c03baa6feb1b94087e35c7c3655814f453b1762b6de27f2d4c50ae407ce4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBlur", [value]))

    @jsii.member(jsii_name="putChromaKey")
    def put_chroma_key(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanChromaKey, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__087e30148d482b0e36522b6dbcbe94fbe231cb67cb3564bc42688e939e4090fb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putChromaKey", [value]))

    @jsii.member(jsii_name="putComposite")
    def put_composite(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanComposite, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b03623ca61b1198f078407e0c12c168eac1f7cd8e936f1770f7e78d60e3be1d6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putComposite", [value]))

    @jsii.member(jsii_name="putCompound")
    def put_compound(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanCompound, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6fe84d013c511d3fcfdee4fd1839c7b8a2f86fcaf609df0efe5aa923d3992224)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCompound", [value]))

    @jsii.member(jsii_name="putContrast")
    def put_contrast(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanContrast, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6b999cb54c4a4d63c4e38baab91119497a158207e9499ab69f0d34fab7266a6b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putContrast", [value]))

    @jsii.member(jsii_name="putGoop")
    def put_goop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanGoop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f5322f87ce250c18b8b227361c4e74ce757faf1a1fd5fcbbae0f812402015fb7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGoop", [value]))

    @jsii.member(jsii_name="putGrayscale")
    def put_grayscale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanGrayscale, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a96bbf0ee6b3cbc464ec852408440e26b9965979e96da26aa09fe27c18a7955d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGrayscale", [value]))

    @jsii.member(jsii_name="putHsl")
    def put_hsl(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanHsl, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1b69e5017ab885f42d2eb3690fcf9dc59909adff56e14ca902edbe2b0878d565)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsl", [value]))

    @jsii.member(jsii_name="putHsv")
    def put_hsv(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanHsv, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c467e8e0d92e24555c94b9caa65fefff832667f7298923e091197ae358976b6f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsv", [value]))

    @jsii.member(jsii_name="putIfDimension")
    def put_if_dimension(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimension, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__acb69ff0138dbb001ddc9919d48881575b6e19f4fb41caefee89f0be6e6a6445)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfDimension", [value]))

    @jsii.member(jsii_name="putIfOrientation")
    def put_if_orientation(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fe0b41a868f8602d9e9f716b8a5ae9fb1e143059a42989840403b03f2a0d694b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfOrientation", [value]))

    @jsii.member(jsii_name="putMaxColors")
    def put_max_colors(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanMaxColors, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__63cceecd66ea649f3e8f9785d053211809226c9376eb1ef2c015067e4a05d4a5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMaxColors", [value]))

    @jsii.member(jsii_name="putMirror")
    def put_mirror(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanMirror, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__44fab764cf8bb78474f2ff5f293de6fceb40a757113e9882d9dc1948d168f560)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMirror", [value]))

    @jsii.member(jsii_name="putMonoHue")
    def put_mono_hue(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanMonoHue, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__17185ed58b44bca81ef4f454d77f9050915403e7e39139825a2c108cc7d7092a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMonoHue", [value]))

    @jsii.member(jsii_name="putOpacity")
    def put_opacity(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanOpacity, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3fc9fc2b16ce8f1543b0bda0eceb92037e4fb0bfeaeb1d56229fdc55f0c062a8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putOpacity", [value]))

    @jsii.member(jsii_name="putRemoveColor")
    def put_remove_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanRemoveColor", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5d865343a8a8ca3ac7b8bcda3ddc3e14b9efa14321a82e00b6f82e623f93a72c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRemoveColor", [value]))

    @jsii.member(jsii_name="putUnsharpMask")
    def put_unsharp_mask(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanUnsharpMask", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d4b3c4abae61870bd5adafe7e58a0bfe5a4fc9ea58e2e701b58bf84fb103b5ae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putUnsharpMask", [value]))

    @jsii.member(jsii_name="resetBackgroundColor")
    def reset_background_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBackgroundColor", []))

    @jsii.member(jsii_name="resetBlur")
    def reset_blur(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBlur", []))

    @jsii.member(jsii_name="resetChromaKey")
    def reset_chroma_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChromaKey", []))

    @jsii.member(jsii_name="resetComposite")
    def reset_composite(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetComposite", []))

    @jsii.member(jsii_name="resetCompound")
    def reset_compound(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCompound", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetGoop")
    def reset_goop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGoop", []))

    @jsii.member(jsii_name="resetGrayscale")
    def reset_grayscale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGrayscale", []))

    @jsii.member(jsii_name="resetHsl")
    def reset_hsl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsl", []))

    @jsii.member(jsii_name="resetHsv")
    def reset_hsv(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsv", []))

    @jsii.member(jsii_name="resetIfDimension")
    def reset_if_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfDimension", []))

    @jsii.member(jsii_name="resetIfOrientation")
    def reset_if_orientation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfOrientation", []))

    @jsii.member(jsii_name="resetMaxColors")
    def reset_max_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxColors", []))

    @jsii.member(jsii_name="resetMirror")
    def reset_mirror(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMirror", []))

    @jsii.member(jsii_name="resetMonoHue")
    def reset_mono_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonoHue", []))

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetRemoveColor")
    def reset_remove_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRemoveColor", []))

    @jsii.member(jsii_name="resetUnsharpMask")
    def reset_unsharp_mask(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUnsharpMask", []))

    @builtins.property
    @jsii.member(jsii_name="backgroundColor")
    def background_color(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanBackgroundColorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanBackgroundColorList, jsii.get(self, "backgroundColor"))

    @builtins.property
    @jsii.member(jsii_name="blur")
    def blur(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanBlurList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanBlurList, jsii.get(self, "blur"))

    @builtins.property
    @jsii.member(jsii_name="chromaKey")
    def chroma_key(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanChromaKeyList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanChromaKeyList, jsii.get(self, "chromaKey"))

    @builtins.property
    @jsii.member(jsii_name="composite")
    def composite(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanCompositeList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanCompositeList, jsii.get(self, "composite"))

    @builtins.property
    @jsii.member(jsii_name="compound")
    def compound(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanCompoundList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanCompoundList, jsii.get(self, "compound"))

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanContrastList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanContrastList, jsii.get(self, "contrast"))

    @builtins.property
    @jsii.member(jsii_name="goop")
    def goop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanGoopList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanGoopList, jsii.get(self, "goop"))

    @builtins.property
    @jsii.member(jsii_name="grayscale")
    def grayscale(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanGrayscaleList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanGrayscaleList, jsii.get(self, "grayscale"))

    @builtins.property
    @jsii.member(jsii_name="hsl")
    def hsl(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanHslList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanHslList, jsii.get(self, "hsl"))

    @builtins.property
    @jsii.member(jsii_name="hsv")
    def hsv(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanHsvList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanHsvList, jsii.get(self, "hsv"))

    @builtins.property
    @jsii.member(jsii_name="ifDimension")
    def if_dimension(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionList, jsii.get(self, "ifDimension"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientation")
    def if_orientation(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationList, jsii.get(self, "ifOrientation"))

    @builtins.property
    @jsii.member(jsii_name="maxColors")
    def max_colors(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanMaxColorsList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanMaxColorsList, jsii.get(self, "maxColors"))

    @builtins.property
    @jsii.member(jsii_name="mirror")
    def mirror(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanMirrorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanMirrorList, jsii.get(self, "mirror"))

    @builtins.property
    @jsii.member(jsii_name="monoHue")
    def mono_hue(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanMonoHueList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanMonoHueList, jsii.get(self, "monoHue"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanOpacityList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanOpacityList, jsii.get(self, "opacity"))

    @builtins.property
    @jsii.member(jsii_name="removeColor")
    def remove_color(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanRemoveColorList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanRemoveColorList", jsii.get(self, "removeColor"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMask")
    def unsharp_mask(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanUnsharpMaskList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanUnsharpMaskList", jsii.get(self, "unsharpMask"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColorInput")
    def background_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanBackgroundColor]]], jsii.get(self, "backgroundColorInput"))

    @builtins.property
    @jsii.member(jsii_name="blurInput")
    def blur_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanBlur]]], jsii.get(self, "blurInput"))

    @builtins.property
    @jsii.member(jsii_name="chromaKeyInput")
    def chroma_key_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanChromaKey]]], jsii.get(self, "chromaKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="compositeInput")
    def composite_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanComposite]]], jsii.get(self, "compositeInput"))

    @builtins.property
    @jsii.member(jsii_name="compoundInput")
    def compound_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanCompound]]], jsii.get(self, "compoundInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanContrast]]], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="goopInput")
    def goop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanGoop]]], jsii.get(self, "goopInput"))

    @builtins.property
    @jsii.member(jsii_name="grayscaleInput")
    def grayscale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanGrayscale]]], jsii.get(self, "grayscaleInput"))

    @builtins.property
    @jsii.member(jsii_name="hslInput")
    def hsl_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanHsl]]], jsii.get(self, "hslInput"))

    @builtins.property
    @jsii.member(jsii_name="hsvInput")
    def hsv_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanHsv]]], jsii.get(self, "hsvInput"))

    @builtins.property
    @jsii.member(jsii_name="ifDimensionInput")
    def if_dimension_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimension]]], jsii.get(self, "ifDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientationInput")
    def if_orientation_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientation]]], jsii.get(self, "ifOrientationInput"))

    @builtins.property
    @jsii.member(jsii_name="maxColorsInput")
    def max_colors_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanMaxColors]]], jsii.get(self, "maxColorsInput"))

    @builtins.property
    @jsii.member(jsii_name="mirrorInput")
    def mirror_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanMirror]]], jsii.get(self, "mirrorInput"))

    @builtins.property
    @jsii.member(jsii_name="monoHueInput")
    def mono_hue_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanMonoHue]]], jsii.get(self, "monoHueInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanOpacity]]], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="removeColorInput")
    def remove_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanRemoveColor"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanRemoveColor"]]], jsii.get(self, "removeColorInput"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMaskInput")
    def unsharp_mask_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanUnsharpMask"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanUnsharpMask"]]], jsii.get(self, "unsharpMaskInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__49526ed3fbc4f14e843af35c307c1c8f17e9f6ea1f8f652ba90f7f5a91bde017)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanRemoveColor",
    jsii_struct_bases=[],
    name_mapping={
        "color": "color",
        "color_var": "colorVar",
        "feather": "feather",
        "feather_var": "featherVar",
        "tolerance": "tolerance",
        "tolerance_var": "toleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanRemoveColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
        feather: typing.Optional[builtins.str] = None,
        feather_var: typing.Optional[builtins.str] = None,
        tolerance: typing.Optional[builtins.str] = None,
        tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        :param feather: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        :param feather_var: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        :param tolerance: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        :param tolerance_var: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a424de58106f2a14ac1f15b995552af8bc7baac0df359ec43ac9fa17c974dc91)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
            check_type(argname="argument feather", value=feather, expected_type=type_hints["feather"])
            check_type(argname="argument feather_var", value=feather_var, expected_type=type_hints["feather_var"])
            check_type(argname="argument tolerance", value=tolerance, expected_type=type_hints["tolerance"])
            check_type(argname="argument tolerance_var", value=tolerance_var, expected_type=type_hints["tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var
        if feather is not None:
            self._values["feather"] = feather
        if feather_var is not None:
            self._values["feather_var"] = feather_var
        if tolerance is not None:
            self._values["tolerance"] = tolerance
        if tolerance_var is not None:
            self._values["tolerance_var"] = tolerance_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        '''
        result = self._values.get("feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather_var(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        '''
        result = self._values.get("feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        '''
        result = self._values.get("tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance_var(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        result = self._values.get("tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanRemoveColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanRemoveColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanRemoveColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0280c2415de7d6ccc06b2bd6df65eec9a31d68007712916c1c2e114349eee028)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanRemoveColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__28b9262cd46b877a52de214e4abd4edbdf04e430f2ebd958bef0c6821e73e47b)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanRemoveColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f683c20cdea1b9364413493dfb255fd64719a596746e6f00a5cc8ea59d6b9843)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b93c0490c3a9e5eebfece3a2da421ac97d2f42a7bca653704dd94ce152b1ca8e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9580532077856d5fa7ff799291d010671aec7c4a1e3e50397c8b0ab275e40cb0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanRemoveColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanRemoveColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanRemoveColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__557bb731723ae9f09205c2ecd30ab9dc3e01f279ceb86907041fdf2f5f48a0d7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanRemoveColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanRemoveColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6c5a0035041b3062e8e55abb78fd040038472eed7d67f52d597f984ea7e27365)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @jsii.member(jsii_name="resetFeather")
    def reset_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeather", []))

    @jsii.member(jsii_name="resetFeatherVar")
    def reset_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatherVar", []))

    @jsii.member(jsii_name="resetTolerance")
    def reset_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTolerance", []))

    @jsii.member(jsii_name="resetToleranceVar")
    def reset_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featherInput")
    def feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherInput"))

    @builtins.property
    @jsii.member(jsii_name="featherVarInput")
    def feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceInput")
    def tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceVarInput")
    def tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dc7e14e8d421804b5e1579eac02576efbef6900bfd56be8e51cc704152df2519)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8f9a98eaef4e65e62fe498a85cae362878be8fe37d453fef38f59489ad9f80d5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="feather")
    def feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "feather"))

    @feather.setter
    def feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f56c6ca49e941edb325236c29d02666efc188d4c2f9ce4f54958268c8aa3989c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "feather", value)

    @builtins.property
    @jsii.member(jsii_name="featherVar")
    def feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featherVar"))

    @feather_var.setter
    def feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__78332b0276fc4c1851d6f2e2ad2226b50b33b79201c20dd035653e955064ff28)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featherVar", value)

    @builtins.property
    @jsii.member(jsii_name="tolerance")
    def tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tolerance"))

    @tolerance.setter
    def tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__98f8d63c2069c23f6f22b4c24bb1483bd00fb99c66c4561fb1275298e5a27024)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tolerance", value)

    @builtins.property
    @jsii.member(jsii_name="toleranceVar")
    def tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "toleranceVar"))

    @tolerance_var.setter
    def tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__628b4c7001dde9eaf27a84fe79608f4036b55ed89dbdb4e419539002b6bf2a64)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "toleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanRemoveColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanRemoveColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanRemoveColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab78ed3e91372d4eeaf501231f00d6c29b06f72ea744c7d446edb5613cbfe0f7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanUnsharpMask",
    jsii_struct_bases=[],
    name_mapping={
        "gain": "gain",
        "gain_var": "gainVar",
        "sigma": "sigma",
        "sigma_var": "sigmaVar",
        "threshold": "threshold",
        "threshold_var": "thresholdVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanUnsharpMask:
    def __init__(
        self,
        *,
        gain: typing.Optional[builtins.str] = None,
        gain_var: typing.Optional[builtins.str] = None,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
        threshold: typing.Optional[builtins.str] = None,
        threshold_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param gain: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        :param gain_var: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        :param sigma: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        :param threshold: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        :param threshold_var: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bee04a6ea920c1b6c33da632db07c21a076622e5c944766f5510788b22d1e17d)
            check_type(argname="argument gain", value=gain, expected_type=type_hints["gain"])
            check_type(argname="argument gain_var", value=gain_var, expected_type=type_hints["gain_var"])
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
            check_type(argname="argument threshold", value=threshold, expected_type=type_hints["threshold"])
            check_type(argname="argument threshold_var", value=threshold_var, expected_type=type_hints["threshold_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if gain is not None:
            self._values["gain"] = gain
        if gain_var is not None:
            self._values["gain_var"] = gain_var
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var
        if threshold is not None:
            self._values["threshold"] = threshold
        if threshold_var is not None:
            self._values["threshold_var"] = threshold_var

    @builtins.property
    def gain(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        '''
        result = self._values.get("gain")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gain_var(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        '''
        result = self._values.get("gain_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        '''
        result = self._values.get("threshold")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold_var(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        result = self._values.get("threshold_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanUnsharpMask(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanUnsharpMaskList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanUnsharpMaskList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__89c5f9d1122eaa1f0056a1f78e1b4d8a671314eb5e26f0b80f4232e617295a56)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanUnsharpMaskOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eb07b1837356e30833c2cd2e2c95c9d22410f6708e9316235e96e09a682a8f51)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanUnsharpMaskOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4753eda9c8ec6d6f1e6f536cb7ddc3cdeb0004a3f643c6f28fdd00e3c297d25a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6b15add6928ca8ca3d80b8574d692583224f555d6dd4351958fd9416d80f3f8c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aea393518d1749f26ed2086d042b414cfe22ccfa21b3de99936acd6daf5e9e80)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanUnsharpMask]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanUnsharpMask]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanUnsharpMask]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bf17f12b6fe72a042f298ffc0098e29158070fe8f40ff70db30264479b6e2d5d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanUnsharpMaskOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanUnsharpMaskOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__442926cc2eae50b9456bc40fc2cd98617ccb56caf30b56d76730d4e3e0427925)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetGain")
    def reset_gain(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGain", []))

    @jsii.member(jsii_name="resetGainVar")
    def reset_gain_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGainVar", []))

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @jsii.member(jsii_name="resetThreshold")
    def reset_threshold(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThreshold", []))

    @jsii.member(jsii_name="resetThresholdVar")
    def reset_threshold_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThresholdVar", []))

    @builtins.property
    @jsii.member(jsii_name="gainInput")
    def gain_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainInput"))

    @builtins.property
    @jsii.member(jsii_name="gainVarInput")
    def gain_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdInput")
    def threshold_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdVarInput")
    def threshold_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gain")
    def gain(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gain"))

    @gain.setter
    def gain(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__279a1e40f14f215d4c73472d769b79b0e48d4d914eaea72a0f0ba2c157bbdf76)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gain", value)

    @builtins.property
    @jsii.member(jsii_name="gainVar")
    def gain_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gainVar"))

    @gain_var.setter
    def gain_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b0d5431d5765b5ac5083dda554730fb4214a1754daade3aad4fbecb3a254babf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gainVar", value)

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ebbe59aec9291194e6b1dd5b54d89ac1ad700987d50e73a52e68ad5ce41645c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__096db9a486083f8f63a101e3534f709d7be203f063727e6e7aae48e7d0d50ffa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="threshold")
    def threshold(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "threshold"))

    @threshold.setter
    def threshold(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__292e28c0a660fa1501ff773bea878f26575ee47970d4fbb79796bbf5218676c4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "threshold", value)

    @builtins.property
    @jsii.member(jsii_name="thresholdVar")
    def threshold_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "thresholdVar"))

    @threshold_var.setter
    def threshold_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a33ec2449007f8d8af025f0e29b6250d35bcf02f65dc884961ba5d5c29f52c67)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "thresholdVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanUnsharpMask]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanUnsharpMask]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanUnsharpMask]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9959d55bb14301ac0e76ecc5733ed702df87d7d54e3cf074bf544e5f5e562c41)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThan",
    jsii_struct_bases=[],
    name_mapping={
        "background_color": "backgroundColor",
        "blur": "blur",
        "chroma_key": "chromaKey",
        "composite": "composite",
        "compound": "compound",
        "contrast": "contrast",
        "goop": "goop",
        "grayscale": "grayscale",
        "hsl": "hsl",
        "hsv": "hsv",
        "if_dimension": "ifDimension",
        "if_orientation": "ifOrientation",
        "max_colors": "maxColors",
        "mirror": "mirror",
        "mono_hue": "monoHue",
        "opacity": "opacity",
        "remove_color": "removeColor",
        "unsharp_mask": "unsharpMask",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThan:
    def __init__(
        self,
        *,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanBackgroundColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanBlur", typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanChromaKey", typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanComposite", typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanCompound", typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanContrast", typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanGoop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanGrayscale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanHsl", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanHsv", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfDimension", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientation", typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanMaxColors", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanMirror", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanMonoHue", typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanOpacity", typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanRemoveColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanUnsharpMask", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e11095c4fb4502f24d086a98d3aaeb575ebc8a898cb5b7e532de758e9a36d4a0)
            check_type(argname="argument background_color", value=background_color, expected_type=type_hints["background_color"])
            check_type(argname="argument blur", value=blur, expected_type=type_hints["blur"])
            check_type(argname="argument chroma_key", value=chroma_key, expected_type=type_hints["chroma_key"])
            check_type(argname="argument composite", value=composite, expected_type=type_hints["composite"])
            check_type(argname="argument compound", value=compound, expected_type=type_hints["compound"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument goop", value=goop, expected_type=type_hints["goop"])
            check_type(argname="argument grayscale", value=grayscale, expected_type=type_hints["grayscale"])
            check_type(argname="argument hsl", value=hsl, expected_type=type_hints["hsl"])
            check_type(argname="argument hsv", value=hsv, expected_type=type_hints["hsv"])
            check_type(argname="argument if_dimension", value=if_dimension, expected_type=type_hints["if_dimension"])
            check_type(argname="argument if_orientation", value=if_orientation, expected_type=type_hints["if_orientation"])
            check_type(argname="argument max_colors", value=max_colors, expected_type=type_hints["max_colors"])
            check_type(argname="argument mirror", value=mirror, expected_type=type_hints["mirror"])
            check_type(argname="argument mono_hue", value=mono_hue, expected_type=type_hints["mono_hue"])
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument remove_color", value=remove_color, expected_type=type_hints["remove_color"])
            check_type(argname="argument unsharp_mask", value=unsharp_mask, expected_type=type_hints["unsharp_mask"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if background_color is not None:
            self._values["background_color"] = background_color
        if blur is not None:
            self._values["blur"] = blur
        if chroma_key is not None:
            self._values["chroma_key"] = chroma_key
        if composite is not None:
            self._values["composite"] = composite
        if compound is not None:
            self._values["compound"] = compound
        if contrast is not None:
            self._values["contrast"] = contrast
        if goop is not None:
            self._values["goop"] = goop
        if grayscale is not None:
            self._values["grayscale"] = grayscale
        if hsl is not None:
            self._values["hsl"] = hsl
        if hsv is not None:
            self._values["hsv"] = hsv
        if if_dimension is not None:
            self._values["if_dimension"] = if_dimension
        if if_orientation is not None:
            self._values["if_orientation"] = if_orientation
        if max_colors is not None:
            self._values["max_colors"] = max_colors
        if mirror is not None:
            self._values["mirror"] = mirror
        if mono_hue is not None:
            self._values["mono_hue"] = mono_hue
        if opacity is not None:
            self._values["opacity"] = opacity
        if remove_color is not None:
            self._values["remove_color"] = remove_color
        if unsharp_mask is not None:
            self._values["unsharp_mask"] = unsharp_mask

    @builtins.property
    def background_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanBackgroundColor"]]]:
        '''background_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        '''
        result = self._values.get("background_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanBackgroundColor"]]], result)

    @builtins.property
    def blur(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanBlur"]]]:
        '''blur block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        '''
        result = self._values.get("blur")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanBlur"]]], result)

    @builtins.property
    def chroma_key(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanChromaKey"]]]:
        '''chroma_key block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        '''
        result = self._values.get("chroma_key")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanChromaKey"]]], result)

    @builtins.property
    def composite(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanComposite"]]]:
        '''composite block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        '''
        result = self._values.get("composite")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanComposite"]]], result)

    @builtins.property
    def compound(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanCompound"]]]:
        '''compound block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        '''
        result = self._values.get("compound")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanCompound"]]], result)

    @builtins.property
    def contrast(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanContrast"]]]:
        '''contrast block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanContrast"]]], result)

    @builtins.property
    def goop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanGoop"]]]:
        '''goop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        '''
        result = self._values.get("goop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanGoop"]]], result)

    @builtins.property
    def grayscale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanGrayscale"]]]:
        '''grayscale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        '''
        result = self._values.get("grayscale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanGrayscale"]]], result)

    @builtins.property
    def hsl(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanHsl"]]]:
        '''hsl block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        '''
        result = self._values.get("hsl")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanHsl"]]], result)

    @builtins.property
    def hsv(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanHsv"]]]:
        '''hsv block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        '''
        result = self._values.get("hsv")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanHsv"]]], result)

    @builtins.property
    def if_dimension(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfDimension"]]]:
        '''if_dimension block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        '''
        result = self._values.get("if_dimension")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfDimension"]]], result)

    @builtins.property
    def if_orientation(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientation"]]]:
        '''if_orientation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        '''
        result = self._values.get("if_orientation")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientation"]]], result)

    @builtins.property
    def max_colors(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanMaxColors"]]]:
        '''max_colors block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        '''
        result = self._values.get("max_colors")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanMaxColors"]]], result)

    @builtins.property
    def mirror(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanMirror"]]]:
        '''mirror block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        '''
        result = self._values.get("mirror")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanMirror"]]], result)

    @builtins.property
    def mono_hue(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanMonoHue"]]]:
        '''mono_hue block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        '''
        result = self._values.get("mono_hue")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanMonoHue"]]], result)

    @builtins.property
    def opacity(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanOpacity"]]]:
        '''opacity block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanOpacity"]]], result)

    @builtins.property
    def remove_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanRemoveColor"]]]:
        '''remove_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        '''
        result = self._values.get("remove_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanRemoveColor"]]], result)

    @builtins.property
    def unsharp_mask(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanUnsharpMask"]]]:
        '''unsharp_mask block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        result = self._values.get("unsharp_mask")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanUnsharpMask"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanBackgroundColor",
    jsii_struct_bases=[],
    name_mapping={"color": "color", "color_var": "colorVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanBackgroundColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__90a9001caa6bfc80c9e6dce5c9602463dca7e5bc73c74f191e9c618926c522c8)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanBackgroundColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanBackgroundColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanBackgroundColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a6fd43b69308c2da51318a6e9041ee4650a143c27fcad04460ad64f66904e5bb)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanBackgroundColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df8e489fd95fd6d9e2bf63b0113ac177f55b306ebd6b105821fbeeda20e59c85)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanBackgroundColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7eb23d6cd62d2166d1a9a8770375b7e14e9f68b4f3e391f468faf536301f45d6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__10500b39b3e608703613a45cb3b675ae2297ba2abe020190e229db94126f5224)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__78fb403401af28739759ff0f15074c1b46230d11e5e4500707f33e06f6d88d34)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanBackgroundColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanBackgroundColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__28a505403a6ad63eea79bb06a2506db148ea8a78dc87dc42d4c71375f2db06d1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanBackgroundColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanBackgroundColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6d9f6829fd94938a4b6c62e1ecbfd8feda1c155ed562b9ee98549ea8d2bf4f78)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__28efa6ac8a6ebdcd7cdda52989821cdc8cebc47ff072b9db8d8c9b8dc05a8218)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__29c19a0473e036aaef51d8e81724b80c73a5887ac300b536adad2741f394b7d4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanBackgroundColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanBackgroundColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanBackgroundColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__72361b9be4e359691261a07ba2d81e587d2c0117e3ec302571fc0c98ca2e521d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanBlur",
    jsii_struct_bases=[],
    name_mapping={"sigma": "sigma", "sigma_var": "sigmaVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanBlur:
    def __init__(
        self,
        *,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param sigma: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7e616da7c6129e77434e0610efe24e4948278b05a491d3317644d91abf39c547)
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanBlur(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanBlurList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanBlurList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7b0ab0b6ac2dd1ee25c87982040b6565cc5489e82e89cabedbf04c018f509d8a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanBlurOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8f5ff029af552dfb0e3ad64752151c803ade8d69bea20bce87c7d1660a177f67)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanBlurOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__732be4923f4be4e7db2a97a06e5e75968799d39c04d2def79de0ed3f9c39049a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e89b162d5693aa2e5aa29bc54d83990d671d0617d2207e7eecf7a80e1e61bb6a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4e6d705e7be7bb154745c59488098ca6548b0b5aab67e19b1238675531999cef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanBlur]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanBlur]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8007d500070826bb5159918a6aa8f58a0058ecd818b749c5866d6030432752e7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanBlurOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanBlurOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a30f75dd03838200755ac014af07c82253a5432c9280202c2cc435e8a1736057)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd1513262b47404156630d1ea547fd74409a6b72c2dce9090df005f2605d54f5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__596e84cf8086eb8db8d8c582c06551664f09cf09fd6f1671a6b963dd7d7084dd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanBlur]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanBlur]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanBlur]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__81a53ae15878f175081d2073128788e6328533033bc2bb4e470d6b7c7898933a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanChromaKey",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_feather": "hueFeather",
        "hue_feather_var": "hueFeatherVar",
        "hue_tolerance": "hueTolerance",
        "hue_tolerance_var": "hueToleranceVar",
        "hue_var": "hueVar",
        "lightness_feather": "lightnessFeather",
        "lightness_feather_var": "lightnessFeatherVar",
        "lightness_tolerance": "lightnessTolerance",
        "lightness_tolerance_var": "lightnessToleranceVar",
        "saturation_feather": "saturationFeather",
        "saturation_feather_var": "saturationFeatherVar",
        "saturation_tolerance": "saturationTolerance",
        "saturation_tolerance_var": "saturationToleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanChromaKey:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_feather: typing.Optional[builtins.str] = None,
        hue_feather_var: typing.Optional[builtins.str] = None,
        hue_tolerance: typing.Optional[builtins.str] = None,
        hue_tolerance_var: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness_feather: typing.Optional[builtins.str] = None,
        lightness_feather_var: typing.Optional[builtins.str] = None,
        lightness_tolerance: typing.Optional[builtins.str] = None,
        lightness_tolerance_var: typing.Optional[builtins.str] = None,
        saturation_feather: typing.Optional[builtins.str] = None,
        saturation_feather_var: typing.Optional[builtins.str] = None,
        saturation_tolerance: typing.Optional[builtins.str] = None,
        saturation_tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_feather: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        :param hue_feather_var: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        :param hue_tolerance: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        :param hue_tolerance_var: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        :param hue_var: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness_feather: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        :param lightness_feather_var: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        :param lightness_tolerance: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        :param lightness_tolerance_var: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        :param saturation_feather: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        :param saturation_feather_var: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        :param saturation_tolerance: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        :param saturation_tolerance_var: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0e8e217d40fbda959d25fa1bdd3636c89f8a03b486d65e6db3ffc03a78527c61)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_feather", value=hue_feather, expected_type=type_hints["hue_feather"])
            check_type(argname="argument hue_feather_var", value=hue_feather_var, expected_type=type_hints["hue_feather_var"])
            check_type(argname="argument hue_tolerance", value=hue_tolerance, expected_type=type_hints["hue_tolerance"])
            check_type(argname="argument hue_tolerance_var", value=hue_tolerance_var, expected_type=type_hints["hue_tolerance_var"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness_feather", value=lightness_feather, expected_type=type_hints["lightness_feather"])
            check_type(argname="argument lightness_feather_var", value=lightness_feather_var, expected_type=type_hints["lightness_feather_var"])
            check_type(argname="argument lightness_tolerance", value=lightness_tolerance, expected_type=type_hints["lightness_tolerance"])
            check_type(argname="argument lightness_tolerance_var", value=lightness_tolerance_var, expected_type=type_hints["lightness_tolerance_var"])
            check_type(argname="argument saturation_feather", value=saturation_feather, expected_type=type_hints["saturation_feather"])
            check_type(argname="argument saturation_feather_var", value=saturation_feather_var, expected_type=type_hints["saturation_feather_var"])
            check_type(argname="argument saturation_tolerance", value=saturation_tolerance, expected_type=type_hints["saturation_tolerance"])
            check_type(argname="argument saturation_tolerance_var", value=saturation_tolerance_var, expected_type=type_hints["saturation_tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_feather is not None:
            self._values["hue_feather"] = hue_feather
        if hue_feather_var is not None:
            self._values["hue_feather_var"] = hue_feather_var
        if hue_tolerance is not None:
            self._values["hue_tolerance"] = hue_tolerance
        if hue_tolerance_var is not None:
            self._values["hue_tolerance_var"] = hue_tolerance_var
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness_feather is not None:
            self._values["lightness_feather"] = lightness_feather
        if lightness_feather_var is not None:
            self._values["lightness_feather_var"] = lightness_feather_var
        if lightness_tolerance is not None:
            self._values["lightness_tolerance"] = lightness_tolerance
        if lightness_tolerance_var is not None:
            self._values["lightness_tolerance_var"] = lightness_tolerance_var
        if saturation_feather is not None:
            self._values["saturation_feather"] = saturation_feather
        if saturation_feather_var is not None:
            self._values["saturation_feather_var"] = saturation_feather_var
        if saturation_tolerance is not None:
            self._values["saturation_tolerance"] = saturation_tolerance
        if saturation_tolerance_var is not None:
            self._values["saturation_tolerance_var"] = saturation_tolerance_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        '''
        result = self._values.get("hue_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        '''
        result = self._values.get("hue_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        '''
        result = self._values.get("hue_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        '''
        result = self._values.get("hue_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        '''
        result = self._values.get("lightness_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        '''
        result = self._values.get("lightness_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        '''
        result = self._values.get("lightness_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        '''
        result = self._values.get("lightness_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        '''
        result = self._values.get("saturation_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        '''
        result = self._values.get("saturation_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        '''
        result = self._values.get("saturation_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        result = self._values.get("saturation_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanChromaKey(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanChromaKeyList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanChromaKeyList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7bd417c92bb04db6d3785f6c96c49817d1111c08f30710cee4fb489ecad06639)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanChromaKeyOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e8e78c4140f969085a6baac049c87e83b2321cf1a1865ba8ba2a7884cde05a18)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanChromaKeyOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__48c985b132f4a8dee06f8f05563fbe4a5b214e3a6eeef4365cb4c9ff98d2838e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd28046fbaa0a6c72bd5cf1ee2940597306cf6d749e9b393e785dc88a12f786f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a985109e91115722edd6454650c8bf0f5449ac468a43bb1ec4371115589fe26)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanChromaKey]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanChromaKey]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c204c510f45f8673e4b7745411b95f8e3330135c4e9dbd2dd3eb6aab275b1dcd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanChromaKeyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanChromaKeyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a342a2a94b2bb96c169e87b5ea8bfaeb8f42ed61def6b1a462648083e1591fb)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueFeather")
    def reset_hue_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeather", []))

    @jsii.member(jsii_name="resetHueFeatherVar")
    def reset_hue_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeatherVar", []))

    @jsii.member(jsii_name="resetHueTolerance")
    def reset_hue_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueTolerance", []))

    @jsii.member(jsii_name="resetHueToleranceVar")
    def reset_hue_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueToleranceVar", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightnessFeather")
    def reset_lightness_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeather", []))

    @jsii.member(jsii_name="resetLightnessFeatherVar")
    def reset_lightness_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeatherVar", []))

    @jsii.member(jsii_name="resetLightnessTolerance")
    def reset_lightness_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessTolerance", []))

    @jsii.member(jsii_name="resetLightnessToleranceVar")
    def reset_lightness_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessToleranceVar", []))

    @jsii.member(jsii_name="resetSaturationFeather")
    def reset_saturation_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeather", []))

    @jsii.member(jsii_name="resetSaturationFeatherVar")
    def reset_saturation_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeatherVar", []))

    @jsii.member(jsii_name="resetSaturationTolerance")
    def reset_saturation_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationTolerance", []))

    @jsii.member(jsii_name="resetSaturationToleranceVar")
    def reset_saturation_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherInput")
    def hue_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVarInput")
    def hue_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceInput")
    def hue_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVarInput")
    def hue_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherInput")
    def lightness_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVarInput")
    def lightness_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceInput")
    def lightness_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVarInput")
    def lightness_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherInput")
    def saturation_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVarInput")
    def saturation_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceInput")
    def saturation_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVarInput")
    def saturation_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__35a116c396cb8416e5813c7529b40149fd64ff8b07889e01a5a9da3012a360c3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeather")
    def hue_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeather"))

    @hue_feather.setter
    def hue_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__684b424471cb57c2545184d4bdc93636c22dac3a6cdffbf160bb7c4aeca8c55c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeather", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVar")
    def hue_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeatherVar"))

    @hue_feather_var.setter
    def hue_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f543016ec5015d07147deaba64d6cbcda68e9f39ac88f1dc8d733fedf645708b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueTolerance")
    def hue_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueTolerance"))

    @hue_tolerance.setter
    def hue_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__743998aef102e8e8dfe9d5d2b34641f455a71b01092299f8e41f6ca82bae6b85)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVar")
    def hue_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueToleranceVar"))

    @hue_tolerance_var.setter
    def hue_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f51db227f5c109c9b19a655a2b94444a3e16e23e8529e1e572a533ead1770e16)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d15e9499841bdd8f5f224062f1b20b2ab616bbfe4e571c33b7d203663e28352)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeather")
    def lightness_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeather"))

    @lightness_feather.setter
    def lightness_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__addd6f17eeaf531d939f1dbcae4fadba6ea2039f47330b27424ef3170837cf64)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeather", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVar")
    def lightness_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeatherVar"))

    @lightness_feather_var.setter
    def lightness_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ef7389d65d957721cb04682f7f8b8072df87da877bd7a59f6d2c337805effd8a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessTolerance")
    def lightness_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessTolerance"))

    @lightness_tolerance.setter
    def lightness_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d9a00fc7235001ba4262637fc721c39f9b888fbded0c064b0526ead487bb6860)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVar")
    def lightness_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessToleranceVar"))

    @lightness_tolerance_var.setter
    def lightness_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d8b76663a126189b75dd3d2f42b8207362fbb549ac9541162994e0e4f5785602)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeather")
    def saturation_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeather"))

    @saturation_feather.setter
    def saturation_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2bda7ee76ef5f5059fa264b02a0a576eff7a826b8eb23b3f50a7c5687f19fa2d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeather", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVar")
    def saturation_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeatherVar"))

    @saturation_feather_var.setter
    def saturation_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9543186fc3a980d28e89138a70eb6bc4b5b336b1c2735b79722bdf2b6747f302)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationTolerance")
    def saturation_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationTolerance"))

    @saturation_tolerance.setter
    def saturation_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__694a4edf48d72e6f479cf28b9632d3ba606e9fb4f9c667098346aac4065c6cb2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVar")
    def saturation_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationToleranceVar"))

    @saturation_tolerance_var.setter
    def saturation_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d4a40afddff171f1c29ae192bf16703643b05047b7704673af624e7e9d9b772)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanChromaKey]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanChromaKey]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanChromaKey]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__09aaac82e292b3c7a586dfc3c95ae261074f1dc029c8a4ddacb6e4dc113706ac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanComposite",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "placement": "placement",
        "placement_var": "placementVar",
        "scale": "scale",
        "scale_dimension": "scaleDimension",
        "scale_dimension_var": "scaleDimensionVar",
        "scale_var": "scaleVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanComposite:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanCompositeImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        placement: typing.Optional[builtins.str] = None,
        placement_var: typing.Optional[builtins.str] = None,
        scale: typing.Optional[builtins.str] = None,
        scale_dimension: typing.Optional[builtins.str] = None,
        scale_dimension_var: typing.Optional[builtins.str] = None,
        scale_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param placement: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        :param placement_var: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        :param scale: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param scale_dimension: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        :param scale_dimension_var: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        :param scale_var: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        :param x_position: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanCompositeImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__121ee21183b6bcebc62efe1a0ef4d0ff67663a7c03262b0077d4bb4133b173c7)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument placement", value=placement, expected_type=type_hints["placement"])
            check_type(argname="argument placement_var", value=placement_var, expected_type=type_hints["placement_var"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument scale_dimension", value=scale_dimension, expected_type=type_hints["scale_dimension"])
            check_type(argname="argument scale_dimension_var", value=scale_dimension_var, expected_type=type_hints["scale_dimension_var"])
            check_type(argname="argument scale_var", value=scale_var, expected_type=type_hints["scale_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if placement is not None:
            self._values["placement"] = placement
        if placement_var is not None:
            self._values["placement_var"] = placement_var
        if scale is not None:
            self._values["scale"] = scale
        if scale_dimension is not None:
            self._values["scale_dimension"] = scale_dimension
        if scale_dimension_var is not None:
            self._values["scale_dimension_var"] = scale_dimension_var
        if scale_var is not None:
            self._values["scale_var"] = scale_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanCompositeImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanCompositeImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        '''
        result = self._values.get("placement")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement_var(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        '''
        result = self._values.get("placement_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        '''
        result = self._values.get("scale_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        '''
        result = self._values.get("scale_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        '''
        result = self._values.get("scale_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanComposite(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanCompositeImage",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanCompositeImage:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanCompositeImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanCompositeImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanCompositeImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__51e647e09cb59cefa64e53c7e34d37b8163e6c65ffd8daeab7024671b6cdeac8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanCompositeImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanCompositeImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__75066189cf2d83926dfd730d986b845c131ecfe1bda83e60b0a8155507e25920)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanCompositeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanCompositeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dac50777053eba531364d0ec50408081cfd2b3e0373a6fd0477513695221e3e0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanCompositeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f616ba16233c7d1f675f40191e1f1450e0c3bdf39068766d47bee41c0507f663)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanCompositeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9fc9a6b80e1e08f63b25d26a35dc4960fa12cf485dbcd2dcd4d49e49632259ec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8bd8bc36d728cc539371c6f2097d6e19505f4ae60c06abecdd30c128ff2b71dc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f577f7b168f848c65941c7308278f4d25cdee7a5dbabebaab3181e23502e965f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanComposite]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanComposite]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f68b46625778d0d86021cdd49218cd4ff06fe834957501a99c6cf92db5424498)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanCompositeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanCompositeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7ca3c036df2c32d838e4bef1a12ad04c779feafd4d3f1f117293be740d1110a4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanCompositeImage()

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPlacement")
    def reset_placement(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacement", []))

    @jsii.member(jsii_name="resetPlacementVar")
    def reset_placement_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacementVar", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetScaleDimension")
    def reset_scale_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimension", []))

    @jsii.member(jsii_name="resetScaleDimensionVar")
    def reset_scale_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimensionVar", []))

    @jsii.member(jsii_name="resetScaleVar")
    def reset_scale_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanCompositeImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanCompositeImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanCompositeImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="placementInput")
    def placement_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementInput"))

    @builtins.property
    @jsii.member(jsii_name="placementVarInput")
    def placement_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionInput")
    def scale_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVarInput")
    def scale_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleVarInput")
    def scale_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__91ba19cc2a95e2419845c328064962a0fa2473481542ca7a995baac5c4d87109)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__80b085cc300019ca99323e6d816ad0bbef5d006a4a6664d6d384116513d87b06)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="placement")
    def placement(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placement"))

    @placement.setter
    def placement(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__12c4bf1ecd43e29befeade7b5b42bbb9d5887bf8283deec87d6121dfed8b2319)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placement", value)

    @builtins.property
    @jsii.member(jsii_name="placementVar")
    def placement_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placementVar"))

    @placement_var.setter
    def placement_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__71260db5338f341c9bb830268d28f083348b3324c5a22de17982fbf5208e6735)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placementVar", value)

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scale"))

    @scale.setter
    def scale(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__77d49811062a7d07a6aadd75f27be75fd95d0c19a7c20896bcc1bf87b352be7e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scale", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimension")
    def scale_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimension"))

    @scale_dimension.setter
    def scale_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7e2ab153ea360a8c5e744528556cd51f4b339b724ed6210f426e8c2bd7da894a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimension", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVar")
    def scale_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimensionVar"))

    @scale_dimension_var.setter
    def scale_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ae94cab445f9b5ddc2c01a16c8bc5c8f74ee78ec0d3da7033a7f5466cd85dea7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="scaleVar")
    def scale_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleVar"))

    @scale_var.setter
    def scale_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__27eaa3cf37da25f0962a40be7aca2da402054a67b1fe98cc64587bebf54093e8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1a0c5a180851521b7a1f3315fec9071310c963892a5064a8b1784528127bc6c6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d63d199cbbd85477d2f01bd1aba55533c31c20fb11dd2f2211151d8f905ab220)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ebca0195a7017fbce8baf35c8b56e345308818869d049c42c19aba4a3733e76d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e08a579005365ef7570faf61a72e720ca59492fd847f3fcb78198e6b471684e4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanComposite]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanComposite]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanComposite]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0b12647607760ff435082acbe51c0ad7337f4c92f9765ec98336f67a80353763)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanCompound",
    jsii_struct_bases=[],
    name_mapping={"transformations": "transformations"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanCompound:
    def __init__(
        self,
        *,
        transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param transformations: transformations block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b43a52c8ea20df47d5fb04c5230b90899c95f768f42936e6cd9fa62d011d0d7c)
            check_type(argname="argument transformations", value=transformations, expected_type=type_hints["transformations"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if transformations is not None:
            self._values["transformations"] = transformations

    @builtins.property
    def transformations(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanCompoundTransformations"]]]:
        '''transformations block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        result = self._values.get("transformations")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanCompoundTransformations"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanCompound(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanCompoundList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanCompoundList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__27f8e071f83de16052cac568189f00589892028d068c341833537483ebf5432d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanCompoundOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5b5e021cdbdc4613bc76e5531fc992131a37d151df3f72ca9a13090b066bcec3)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanCompoundOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__03c8c5d29bcc5b332cef4ac7229cf1bff6f520f0f6e8a81486ce0259ecc54b47)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d54ed00e21630853f576ec776fd00ca8c3e1cf44d73e7705b2556a28dc31ac0b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eb45797e7b9d076aefcef3390d5313b79baa50f61d41b8c1c7e5ab6725c27690)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanCompound]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanCompound]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9558f8e81370d10f630c9c900a8998e705aca49543f304364f3dcf6d9ddad803)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanCompoundOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanCompoundOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9b3e2b17373954ffd1eb4ed88cb6ff80a8461cbf04c979d14936cbef41353534)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformations")
    def put_transformations(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__722c2c74e4646ee6465163ff0357627cfa308cd2bda31569990c9dfc58f1f9cc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTransformations", [value]))

    @jsii.member(jsii_name="resetTransformations")
    def reset_transformations(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformations", []))

    @builtins.property
    @jsii.member(jsii_name="transformations")
    def transformations(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanCompoundTransformationsList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanCompoundTransformationsList", jsii.get(self, "transformations"))

    @builtins.property
    @jsii.member(jsii_name="transformationsInput")
    def transformations_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanCompoundTransformations"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanCompoundTransformations"]]], jsii.get(self, "transformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanCompound]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanCompound]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanCompound]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__76329a0cf700c969a02594330fd263b421e20d75158ccc7d5950bbf1954b62e0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanCompoundTransformations",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanCompoundTransformations:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanCompoundTransformations(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanCompoundTransformationsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanCompoundTransformationsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__247ac14831d9f1c5b0ba4003ff750b95eb156449edf61880eb71c5e4e5883299)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanCompoundTransformationsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7e077362e1f07bcbf13ef726348690c4deb37dd7561a59de3d1a06e56f08f3bc)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanCompoundTransformationsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0568a05c62276cc2af46e1b2382ca7eedaf12994a63edcd3a75361fc8e9cfb77)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aa990faf75bd1f696c3df66dbb0d693a814de5f07e501ea53de52fe70f6b48ce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0971ee0c9fa66650dbd289af1478dfa123a23156fab05d1b7560f8459a7a7521)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanCompoundTransformations]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanCompoundTransformations]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanCompoundTransformations]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3d1836662d819bb70bd1cf5f8194e8b7a7d6018d2aa80a6699b532d3a63247f6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanCompoundTransformationsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanCompoundTransformationsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bf776ce95f2056d3b1468a4e47d70fdf24ddc657641d42834c8a942c9c577b73)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanCompoundTransformations]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanCompoundTransformations]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanCompoundTransformations]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d593dc22eb34f2a3c6431798e57665439ac007c0a94fd9586509c21c230fda4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanContrast",
    jsii_struct_bases=[],
    name_mapping={
        "brightness": "brightness",
        "brightness_var": "brightnessVar",
        "contrast": "contrast",
        "contrast_var": "contrastVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanContrast:
    def __init__(
        self,
        *,
        brightness: typing.Optional[builtins.str] = None,
        brightness_var: typing.Optional[builtins.str] = None,
        contrast: typing.Optional[builtins.str] = None,
        contrast_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param brightness: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        :param brightness_var: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        :param contrast: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param contrast_var: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__64db47df6f35ee2b546bf0244d897bcbda3336743f14838b894370b5c8345e20)
            check_type(argname="argument brightness", value=brightness, expected_type=type_hints["brightness"])
            check_type(argname="argument brightness_var", value=brightness_var, expected_type=type_hints["brightness_var"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument contrast_var", value=contrast_var, expected_type=type_hints["contrast_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if brightness is not None:
            self._values["brightness"] = brightness
        if brightness_var is not None:
            self._values["brightness_var"] = brightness_var
        if contrast is not None:
            self._values["contrast"] = contrast
        if contrast_var is not None:
            self._values["contrast_var"] = contrast_var

    @builtins.property
    def brightness(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        '''
        result = self._values.get("brightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def brightness_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        '''
        result = self._values.get("brightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        result = self._values.get("contrast_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanContrast(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanContrastList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanContrastList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0d1d7df6b4c0ed294df593bb3cebe2d0b5c009de864fb43fdba7912e1edae4e5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanContrastOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a210783e0fb9589a08e519bfa62e168e111c3ad47e52cf1322c76deeb4612e0)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanContrastOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a60a6ebc12250a7957d8381d507b1293818f0bb5d3cc84c0416126e88e6c7119)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__818e939d6086e8e3054ded29ab80e21ab08114002497a6ccef07b1fb1e12b15f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cdf041da37533b75006a67702853e31edf0465977c66a7157d7df84c8769a72d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanContrast]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanContrast]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8b538890b27563feeb06960b632e6b501cd28bd40593d1ed70bb7d9392448398)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanContrastOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanContrastOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1a874a8cbf77bfa59b496c6d029dc443b5c33cb9d41f639af7a119bc809733d6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetBrightness")
    def reset_brightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightness", []))

    @jsii.member(jsii_name="resetBrightnessVar")
    def reset_brightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightnessVar", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetContrastVar")
    def reset_contrast_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrastVar", []))

    @builtins.property
    @jsii.member(jsii_name="brightnessInput")
    def brightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="brightnessVarInput")
    def brightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastVarInput")
    def contrast_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="brightness")
    def brightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightness"))

    @brightness.setter
    def brightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f08c426e9fdd5472aa4de82a84139f66646f10a2a39277f49925b78cdcf08ce0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightness", value)

    @builtins.property
    @jsii.member(jsii_name="brightnessVar")
    def brightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightnessVar"))

    @brightness_var.setter
    def brightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a98fa0b30ff295ce6ab49390d6f86477700231b45fed158575bb8016fb81df21)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrast"))

    @contrast.setter
    def contrast(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8e9f34809534cf0abe655aa42a8eea2a62ff80a3b45ed21d6d7a56874606fb29)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrast", value)

    @builtins.property
    @jsii.member(jsii_name="contrastVar")
    def contrast_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrastVar"))

    @contrast_var.setter
    def contrast_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a06eaadc570ea06e6f6f7d756be1769e14ebe4812cd59ebd89ec02d9345fb3dc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrastVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanContrast]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanContrast]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanContrast]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9631f12ef03c6b51cea7fa91e44c61017a2967b4ae571fa01167ff3cedcc0c2e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanGoop",
    jsii_struct_bases=[],
    name_mapping={
        "chaos": "chaos",
        "chaos_var": "chaosVar",
        "density": "density",
        "density_var": "densityVar",
        "power": "power",
        "power_var": "powerVar",
        "seed": "seed",
        "seed_var": "seedVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanGoop:
    def __init__(
        self,
        *,
        chaos: typing.Optional[builtins.str] = None,
        chaos_var: typing.Optional[builtins.str] = None,
        density: typing.Optional[builtins.str] = None,
        density_var: typing.Optional[builtins.str] = None,
        power: typing.Optional[builtins.str] = None,
        power_var: typing.Optional[builtins.str] = None,
        seed: typing.Optional[builtins.str] = None,
        seed_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param chaos: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        :param chaos_var: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        :param density: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        :param density_var: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        :param power: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        :param power_var: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        :param seed: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        :param seed_var: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a074f37b6ff6ea285080025250d148ec02bd79b13ef03827f0886b9975f82b6b)
            check_type(argname="argument chaos", value=chaos, expected_type=type_hints["chaos"])
            check_type(argname="argument chaos_var", value=chaos_var, expected_type=type_hints["chaos_var"])
            check_type(argname="argument density", value=density, expected_type=type_hints["density"])
            check_type(argname="argument density_var", value=density_var, expected_type=type_hints["density_var"])
            check_type(argname="argument power", value=power, expected_type=type_hints["power"])
            check_type(argname="argument power_var", value=power_var, expected_type=type_hints["power_var"])
            check_type(argname="argument seed", value=seed, expected_type=type_hints["seed"])
            check_type(argname="argument seed_var", value=seed_var, expected_type=type_hints["seed_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if chaos is not None:
            self._values["chaos"] = chaos
        if chaos_var is not None:
            self._values["chaos_var"] = chaos_var
        if density is not None:
            self._values["density"] = density
        if density_var is not None:
            self._values["density_var"] = density_var
        if power is not None:
            self._values["power"] = power
        if power_var is not None:
            self._values["power_var"] = power_var
        if seed is not None:
            self._values["seed"] = seed
        if seed_var is not None:
            self._values["seed_var"] = seed_var

    @builtins.property
    def chaos(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        '''
        result = self._values.get("chaos")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def chaos_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        '''
        result = self._values.get("chaos_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        '''
        result = self._values.get("density")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density_var(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        '''
        result = self._values.get("density_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        '''
        result = self._values.get("power")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power_var(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        '''
        result = self._values.get("power_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        '''
        result = self._values.get("seed")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed_var(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        result = self._values.get("seed_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanGoop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanGoopList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanGoopList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8700771149f18e00b01131e4d459bed826ab75423b19e7693f945f8c83a4200d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanGoopOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__50332aa48891b8e8cc3af5dd971c5eae2a1c9f0e452724a3a485c09390d81bb9)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanGoopOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__743977e96b8ce3737f56ed0c13f662b6daa4a2051c225b67b72f65f0e4d7ee64)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0d31da2d3dc2d118c9d919c0a51f1f7f547fcd47976f042fed033383aa0bfd4b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8cbf56eeee62ef0643e5c48122eec08f9e81568afc81a2ae3b8265355df49303)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanGoop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanGoop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e29ae08eac3795a9f95ccb674b591a6cd35241cb3e7a265f343b1da0db5de1d7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanGoopOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanGoopOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a268941f7db20602b0835b63c1bec5462b707976861d0bb7d9d96beaaa3b579a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetChaos")
    def reset_chaos(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaos", []))

    @jsii.member(jsii_name="resetChaosVar")
    def reset_chaos_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaosVar", []))

    @jsii.member(jsii_name="resetDensity")
    def reset_density(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensity", []))

    @jsii.member(jsii_name="resetDensityVar")
    def reset_density_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensityVar", []))

    @jsii.member(jsii_name="resetPower")
    def reset_power(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPower", []))

    @jsii.member(jsii_name="resetPowerVar")
    def reset_power_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPowerVar", []))

    @jsii.member(jsii_name="resetSeed")
    def reset_seed(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeed", []))

    @jsii.member(jsii_name="resetSeedVar")
    def reset_seed_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeedVar", []))

    @builtins.property
    @jsii.member(jsii_name="chaosInput")
    def chaos_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosInput"))

    @builtins.property
    @jsii.member(jsii_name="chaosVarInput")
    def chaos_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosVarInput"))

    @builtins.property
    @jsii.member(jsii_name="densityInput")
    def density_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityInput"))

    @builtins.property
    @jsii.member(jsii_name="densityVarInput")
    def density_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="powerInput")
    def power_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerInput"))

    @builtins.property
    @jsii.member(jsii_name="powerVarInput")
    def power_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerVarInput"))

    @builtins.property
    @jsii.member(jsii_name="seedInput")
    def seed_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedInput"))

    @builtins.property
    @jsii.member(jsii_name="seedVarInput")
    def seed_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedVarInput"))

    @builtins.property
    @jsii.member(jsii_name="chaos")
    def chaos(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaos"))

    @chaos.setter
    def chaos(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__517bc980b12f4aef024369435984ceae8ac7ff1791b745413d7e18ec9f3ed74b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaos", value)

    @builtins.property
    @jsii.member(jsii_name="chaosVar")
    def chaos_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaosVar"))

    @chaos_var.setter
    def chaos_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1bed3dbb40f06a212aa8f6f0b21abf5841820bacc6d8c73b971b8fe5857e77bf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaosVar", value)

    @builtins.property
    @jsii.member(jsii_name="density")
    def density(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "density"))

    @density.setter
    def density(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3e6a80a1ed0156d4b1a9ce0edd9ef739286401d2d958978c3ceb3d10cdfef7e0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "density", value)

    @builtins.property
    @jsii.member(jsii_name="densityVar")
    def density_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "densityVar"))

    @density_var.setter
    def density_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a01f87dfad8ea87920ddaa0bd60a8eae37f8f4dc3187a28a0435b0d885360662)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "densityVar", value)

    @builtins.property
    @jsii.member(jsii_name="power")
    def power(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "power"))

    @power.setter
    def power(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7987c50d6d7f3a18d15750aaaf5c1240a7d42543a3dde8b72dddf2a8d0a78f38)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "power", value)

    @builtins.property
    @jsii.member(jsii_name="powerVar")
    def power_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "powerVar"))

    @power_var.setter
    def power_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b4fa73ae5afde20a375eae4fc5e26f0fa79e3e8e4c497e4368e2db3926dc4087)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "powerVar", value)

    @builtins.property
    @jsii.member(jsii_name="seed")
    def seed(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seed"))

    @seed.setter
    def seed(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f0444914296c5def576d13eb97692e9bd482ce842d504215133eb3d31d961c18)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seed", value)

    @builtins.property
    @jsii.member(jsii_name="seedVar")
    def seed_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seedVar"))

    @seed_var.setter
    def seed_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d06060d2639aea560f6b83d90ba3adc1cf853db2a645ddd8056b95f8c948e4fd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seedVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanGoop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanGoop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanGoop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d1da431ed5796c3bebda09dab2996d87356a56184b3e7f39c3d6a9944b55209f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanGrayscale",
    jsii_struct_bases=[],
    name_mapping={"type": "type", "type_var": "typeVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanGrayscale:
    def __init__(
        self,
        *,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param type: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4f66bda0b155f4352bdc032af9f47070d8d5cada27ab4a78b856d0f49d5d84e8)
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanGrayscale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanGrayscaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanGrayscaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6c64c9394175ffc89f0d723bd2bad8de6f191a0e9e49828bd186f736b980277c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanGrayscaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ef54945ad9ee049de07ac842769dbdf8fe6c0eeae3603043d6064f7e9048cd7f)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanGrayscaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b7e600b589157c7370123b276a768f258711ffd136f733bb5d391aa3427e1d0e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f905320d120f8416764adf61b2ea964e9258e4a4caa63687fa557c2be906c74d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__89725d9848912be951d1a129eddc708e07b32e7265fb75b827f5709bb9d78591)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanGrayscale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanGrayscale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6ddb2d23b53e70f523414ccd980c0bd861cc86aadc45b6852d8797023fb6b5a8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanGrayscaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanGrayscaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d490ea665dd0c94e973777e990376d1b46cda466984458a7b40710a82da9d30e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9178f451125b4248a71693df2973a7cb234c5639950013c1089606b8e32f3e54)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__34ec2a1857280c635c58016ecd9fea0894438e802789b939c8dba20a016e8f3f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanGrayscale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanGrayscale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanGrayscale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a956460786d05318f239876d9e7d99e658d0d56169943c22823b110a56114177)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanHsl",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "lightness": "lightness",
        "lightness_var": "lightnessVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanHsl:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness: typing.Optional[builtins.str] = None,
        lightness_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        :param lightness_var: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__07bca4c7bdfd3990a23e34dacd9456478b50cd3fa0b9a288dcd3b5b62c5a5ca0)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness", value=lightness, expected_type=type_hints["lightness"])
            check_type(argname="argument lightness_var", value=lightness_var, expected_type=type_hints["lightness_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness is not None:
            self._values["lightness"] = lightness
        if lightness_var is not None:
            self._values["lightness_var"] = lightness_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        '''
        result = self._values.get("lightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        '''
        result = self._values.get("lightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanHsl(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanHslList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanHslList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__34e3e8f68247113ebf66d807f6fd9506dfbebcca7f953ffbe34dc4702b0d0867)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanHslOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d385e5244dfed25c3d66ab0d3992a2201615bb18b8287c0b787989bae67dc7a2)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanHslOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__251bff43df8a6a4b1098e228e8779b33c41800953457b2c8c44674c7ae47c2e7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eafafe9c186cc65fbe8748c417b26ccaa1c0c5b81a44f10dcde10cfb146f496b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0437bcf243af9db3a22e1179c725b7e34a313c935fd0c68228362191ba816ba7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanHsl]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanHsl]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__67489592dc355b07602feb4550d2f614ea11d8638d0d21944165dcc8a2460a88)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanHslOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanHslOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1544eff99b8fa0ba2db638342d8463aa5200079b2bd097a1a9722809071fc407)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightness")
    def reset_lightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightness", []))

    @jsii.member(jsii_name="resetLightnessVar")
    def reset_lightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessInput")
    def lightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessVarInput")
    def lightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0e8cae7f6fcfb4746cd2680c772a423696af354673aa68b1b1260dcfc782966b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d0bc6e04f59f0a5980c11c42409ef2a401d67265b663e2b1a1d40819da19e312)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightness")
    def lightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightness"))

    @lightness.setter
    def lightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b89e406f17fcbf164523a03b3fa71e10f00e8d2813c8abd4b71b3d727920c84e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightness", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessVar")
    def lightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessVar"))

    @lightness_var.setter
    def lightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1661f566ab2d481fb4ba38d8d3b6c008a96cb6a5f8898669c3eae6107458f57b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__31d2f254c059c23d7f6a281e56d616da9871e4c782c41d1b8f6945a76aff8dbd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__715f0a97fc15bdcc7d564a3f41e863aeb79712a8237fa925d8226b0a6e33848c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanHsl]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanHsl]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanHsl]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ee04d5631305c2b568aa6b8de945f2560fc3fc0894206cd21a4dd4b7a91bd541)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanHsv",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanHsv:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        :param value: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__181fabbd06c4ea02975ca2ddf099210560b14fcd26d8229f9db008e5ad67c2aa)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanHsv(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanHsvList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanHsvList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ccbcccaad7c9a1e21f008d2701797790292da880b588b92ac3cfb021bfc90735)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanHsvOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__60413b27536cb350f55fe0de144414c49cec098bc830ef75b31c8a0660ebefaa)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanHsvOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__29d61a0521fd8247905536de415b75c298c94d809f7376c8b1dea7eeaee634d3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__56edb99cc31a4538a3ed99ca245306f4feefc96d80aefada7c59b4ad37a3fdbe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__081c87064757fff4a6a594713d0cffec5597be5721da494f8a7d4c5b50a0047a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanHsv]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanHsv]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__80c5e8ffd729a5f2b891ec9d6756c2c801b75c8737ec4c863bb3a4138dbf8841)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanHsvOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanHsvOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e119d43a4a68b3ff570869e88de0c8a48c13f907e4896952f103f34dbdcf7479)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__68e0f5f60629ab72067095fc91b8358ec67ed07a52f5a7e96d322ff9cd356ba0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__337d10a6aa33f4ab67284c45582e97a26db85bcfc2d35a567a4c9320b04a865f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__833f92b760d966601dc53b34248a354e330006130f59280df85d611fca2ee240)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e034aedcea76f70ff8ceffe1fd7f1de3d258b6477777c885e724e8d371b23aa9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e1b5645266036e5c4b57f93b526b3d15107de980fbe4a17f1b9203bf2e73464d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d7806e9f92bec11315c8fbda59e78bf622eb807e4448453e6291c41c410db6b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanHsv]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanHsv]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanHsv]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__85ca3207014423554ce08c9ed5ad4beafb6b47f45f3bcb892f5941b9ebda9e4c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfDimension",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "dimension": "dimension",
        "dimension_var": "dimensionVar",
        "equal": "equal",
        "greater_than": "greaterThan",
        "less_than": "lessThan",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfDimension:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        dimension: typing.Optional[builtins.str] = None,
        dimension_var: typing.Optional[builtins.str] = None,
        equal: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionEqual", typing.Dict[builtins.str, typing.Any]]] = None,
        greater_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionGreaterThan", typing.Dict[builtins.str, typing.Any]]] = None,
        less_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionLessThan", typing.Dict[builtins.str, typing.Any]]] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param dimension: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        :param dimension_var: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        :param equal: equal block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        :param greater_than: greater_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        :param less_than: less_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        :param value: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionDefault(**default)
        if isinstance(equal, dict):
            equal = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionEqual(**equal)
        if isinstance(greater_than, dict):
            greater_than = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionGreaterThan(**greater_than)
        if isinstance(less_than, dict):
            less_than = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionLessThan(**less_than)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4c7f7d3519ef880ffdd61c29cfd16c50fa88898c98e4420de6821387fe0c11ce)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument dimension", value=dimension, expected_type=type_hints["dimension"])
            check_type(argname="argument dimension_var", value=dimension_var, expected_type=type_hints["dimension_var"])
            check_type(argname="argument equal", value=equal, expected_type=type_hints["equal"])
            check_type(argname="argument greater_than", value=greater_than, expected_type=type_hints["greater_than"])
            check_type(argname="argument less_than", value=less_than, expected_type=type_hints["less_than"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if dimension is not None:
            self._values["dimension"] = dimension
        if dimension_var is not None:
            self._values["dimension_var"] = dimension_var
        if equal is not None:
            self._values["equal"] = equal
        if greater_than is not None:
            self._values["greater_than"] = greater_than
        if less_than is not None:
            self._values["less_than"] = less_than
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionDefault"], result)

    @builtins.property
    def dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        '''
        result = self._values.get("dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        '''
        result = self._values.get("dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def equal(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionEqual"]:
        '''equal block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        '''
        result = self._values.get("equal")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionEqual"], result)

    @builtins.property
    def greater_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionGreaterThan"]:
        '''greater_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        '''
        result = self._values.get("greater_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionGreaterThan"], result)

    @builtins.property
    def less_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionLessThan"]:
        '''less_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        '''
        result = self._values.get("less_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionLessThan"], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfDimension(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2e642a604ef0324c47ce3ea529aa748e1fcca5321e91d04e686bf294c9fd5bfc)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__412f49d76020bfcb03c875dc60235ed0fa95c3f0e180ed8879c2bd790eddf6f8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionEqual",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionEqual:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionEqual(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionEqualOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionEqualOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__19610fd1b59ed16d7d474c97a7b287e80d0ae413f2e69131f904ede4ebc80fb0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionEqual], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionEqual],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__62b1e5160acc1233f22ed8ce278c208cb85819067f5393635944693ba130ad75)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionGreaterThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionGreaterThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionGreaterThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionGreaterThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionGreaterThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea3f2c47f6b512c15c4a0bf7d0c7c99a1079484a9e4759518b0ed7b668eb5cfa)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionGreaterThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionGreaterThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a0f5e7a1c46ffe07fe21fb5a1f91def9f6bc4335504396cb066e2ba0a7a2bfdb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionLessThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionLessThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionLessThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionLessThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionLessThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__deaf73a642ee8e74d9ee6c96b976d890acc58476928d0e065369aae4cf017b69)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionLessThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionLessThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bfcfb532ef5146bb88a8154e206bda9a28657a86cba5b3d624070bf072f3992f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eb26dc2d5ac9db7572fcb6df2469f2b80b2c9c68aefd966f84b3bdb7ceda89bf)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d3e809593cacb8191a66281f00236e8ed2a7f00baae0d9ef4a41cecde34c4496)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1aed8b68b5a0af810e7be84ff515b7fe63ea912ca8e9a632234a73f8f9a7ed4f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eed5b895e6ef5da5a3d992552dbb5cfe4cad87d32ef35e014a7b1aaea39a49e8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e602950ab357df7a264cf3e4611d3b764537aacb02ad2d0a964242b946604d6a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfDimension]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfDimension]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__87818d2fdd49a995aeddaa1264d27f9ea6881f44b4071ad1d660c46d4a219dc8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fc95157507eeefe5d2e3a2b4447119c1b17e7f86c23ba4eee2a4fe6439dc2938)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putEqual")
    def put_equal(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionEqual()

        return typing.cast(None, jsii.invoke(self, "putEqual", [value]))

    @jsii.member(jsii_name="putGreaterThan")
    def put_greater_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionGreaterThan()

        return typing.cast(None, jsii.invoke(self, "putGreaterThan", [value]))

    @jsii.member(jsii_name="putLessThan")
    def put_less_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionLessThan()

        return typing.cast(None, jsii.invoke(self, "putLessThan", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetDimension")
    def reset_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimension", []))

    @jsii.member(jsii_name="resetDimensionVar")
    def reset_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimensionVar", []))

    @jsii.member(jsii_name="resetEqual")
    def reset_equal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEqual", []))

    @jsii.member(jsii_name="resetGreaterThan")
    def reset_greater_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGreaterThan", []))

    @jsii.member(jsii_name="resetLessThan")
    def reset_less_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLessThan", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="equal")
    def equal(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionEqualOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionEqualOutputReference, jsii.get(self, "equal"))

    @builtins.property
    @jsii.member(jsii_name="greaterThan")
    def greater_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionGreaterThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionGreaterThanOutputReference, jsii.get(self, "greaterThan"))

    @builtins.property
    @jsii.member(jsii_name="lessThan")
    def less_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionLessThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionLessThanOutputReference, jsii.get(self, "lessThan"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionInput")
    def dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionVarInput")
    def dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="equalInput")
    def equal_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionEqual], jsii.get(self, "equalInput"))

    @builtins.property
    @jsii.member(jsii_name="greaterThanInput")
    def greater_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionGreaterThan], jsii.get(self, "greaterThanInput"))

    @builtins.property
    @jsii.member(jsii_name="lessThanInput")
    def less_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionLessThan], jsii.get(self, "lessThanInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="dimension")
    def dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimension"))

    @dimension.setter
    def dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__139d512ffef0c90c40770e6ee638146efcbee83a9cf45c1575da0c56158e63a4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimension", value)

    @builtins.property
    @jsii.member(jsii_name="dimensionVar")
    def dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimensionVar"))

    @dimension_var.setter
    def dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__10349961bfcf98c75f986069f179c3dfc7bfbe058ee72f4be0a943977470c19b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d6782499383c277d59e5a63d087132b2f92ee5c9d1d5f6852d236dc72ca6cb5f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__642a6c3bbaf78d5edffc5466ff298cfb6e78d864e647eeb7a1e0192f19e29bea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfDimension]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfDimension]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfDimension]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__448cebf59b768d997ae9ace6de0f174eb78952b65313b8d470d7b723d80fd273)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientation",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "landscape": "landscape",
        "portrait": "portrait",
        "square": "square",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientation:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        landscape: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationLandscape", typing.Dict[builtins.str, typing.Any]]] = None,
        portrait: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationPortrait", typing.Dict[builtins.str, typing.Any]]] = None,
        square: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationSquare", typing.Dict[builtins.str, typing.Any]]] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param landscape: landscape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        :param portrait: portrait block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        :param square: square block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationDefault(**default)
        if isinstance(landscape, dict):
            landscape = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationLandscape(**landscape)
        if isinstance(portrait, dict):
            portrait = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationPortrait(**portrait)
        if isinstance(square, dict):
            square = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationSquare(**square)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__51e029ab2be799c6a6ef35820b5e2aa630c4b57f60965154cde968ee27bedcc4)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument landscape", value=landscape, expected_type=type_hints["landscape"])
            check_type(argname="argument portrait", value=portrait, expected_type=type_hints["portrait"])
            check_type(argname="argument square", value=square, expected_type=type_hints["square"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if landscape is not None:
            self._values["landscape"] = landscape
        if portrait is not None:
            self._values["portrait"] = portrait
        if square is not None:
            self._values["square"] = square

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationDefault"], result)

    @builtins.property
    def landscape(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationLandscape"]:
        '''landscape block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        '''
        result = self._values.get("landscape")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationLandscape"], result)

    @builtins.property
    def portrait(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationPortrait"]:
        '''portrait block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        '''
        result = self._values.get("portrait")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationPortrait"], result)

    @builtins.property
    def square(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationSquare"]:
        '''square block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        result = self._values.get("square")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationSquare"], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__694a3047e7538424924972009a27c3aebd2cb9f88a86962541facaf3b095d3d9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9469eeb6eac943c0f63a9109c438f26244f13896da19af922da843131c5188fc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationLandscape",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationLandscape:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationLandscape(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationLandscapeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationLandscapeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d72d90df4bfb8ee92ad171f2265f4c6a45984a09a95797562f405aa32370046)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationLandscape], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationLandscape],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__49a2d65c92a26a3dc600cb1f2e2b95a3f009da1b5b6637b0e506ed44292ae6ad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f412cbd21994dc8d15802099cb7abe32f97a0cee2430271cd4d65018a18ae800)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__199ede77a41435614560ac40e39f18f57243d66b259ac375d233da726738e93d)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__62023cd137477baf6b82ac25bf358e3ecafd8fc52f6dc59d3dacffb61f3c58f8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df47b0d2ad2d6c8c38c7f9332362a1e41640eaa992e3b1831f109779e326cefa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fd9818181f9258b58f13a4d73afb232c1e9f1ed230ee134cc5d84b2b950e9920)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientation]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientation]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7a26324c8d39eb0151276a5b7716a6815a5e6ebf7271158592f23177ec9ac729)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__77714ffd8112921aa9194a22ee477e1cac5cc95c4194c8c1005968534710a093)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putLandscape")
    def put_landscape(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationLandscape()

        return typing.cast(None, jsii.invoke(self, "putLandscape", [value]))

    @jsii.member(jsii_name="putPortrait")
    def put_portrait(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationPortrait()

        return typing.cast(None, jsii.invoke(self, "putPortrait", [value]))

    @jsii.member(jsii_name="putSquare")
    def put_square(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationSquare()

        return typing.cast(None, jsii.invoke(self, "putSquare", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetLandscape")
    def reset_landscape(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLandscape", []))

    @jsii.member(jsii_name="resetPortrait")
    def reset_portrait(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPortrait", []))

    @jsii.member(jsii_name="resetSquare")
    def reset_square(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSquare", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="landscape")
    def landscape(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationLandscapeOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationLandscapeOutputReference, jsii.get(self, "landscape"))

    @builtins.property
    @jsii.member(jsii_name="portrait")
    def portrait(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationPortraitOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationPortraitOutputReference", jsii.get(self, "portrait"))

    @builtins.property
    @jsii.member(jsii_name="square")
    def square(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationSquareOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationSquareOutputReference", jsii.get(self, "square"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="landscapeInput")
    def landscape_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationLandscape], jsii.get(self, "landscapeInput"))

    @builtins.property
    @jsii.member(jsii_name="portraitInput")
    def portrait_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationPortrait"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationPortrait"], jsii.get(self, "portraitInput"))

    @builtins.property
    @jsii.member(jsii_name="squareInput")
    def square_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationSquare"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationSquare"], jsii.get(self, "squareInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientation]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientation]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientation]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__71311bcffc36c5e5a8f314a64165c1df2ec3a79a593671aa923ac95bebc55e5b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationPortrait",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationPortrait:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationPortrait(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationPortraitOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationPortraitOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e6fe8f790eb61a19d91bfc05edb1785f67b9549ca9f617ce24b6a69c98b8d8a9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationPortrait]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationPortrait], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationPortrait],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df9e49a2ed628f111c4a27f0b639a6c3583d2028c7f92a7d0dc122d8125e921e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationSquare",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationSquare:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationSquare(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationSquareOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationSquareOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8668c0039938ccaeae6b66c820487ea733ca1a57d17518ac05c7c2c4a585517a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationSquare]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationSquare], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationSquare],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b3311efc92ad5be7802a4838856d4cbc8eb62649ccae4cb5c1b5fe60f09abf99)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanMaxColors",
    jsii_struct_bases=[],
    name_mapping={"colors": "colors", "colors_var": "colorsVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanMaxColors:
    def __init__(
        self,
        *,
        colors: typing.Optional[builtins.str] = None,
        colors_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param colors: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        :param colors_var: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a8df196e33ff34bc53fd36dfbf06ba978a2c7a68584bd1baab36c6fd740452e8)
            check_type(argname="argument colors", value=colors, expected_type=type_hints["colors"])
            check_type(argname="argument colors_var", value=colors_var, expected_type=type_hints["colors_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if colors is not None:
            self._values["colors"] = colors
        if colors_var is not None:
            self._values["colors_var"] = colors_var

    @builtins.property
    def colors(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        '''
        result = self._values.get("colors")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def colors_var(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        result = self._values.get("colors_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanMaxColors(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanMaxColorsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanMaxColorsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__486ad48ac83a867e9e44d6b6c7a6276e75888b8605d179b39b74cfe16c81f34f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanMaxColorsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__acf805f2c9acc2b1aa02ef2f81892668ed67e0325c89bf49c0a37d0d561d32d0)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanMaxColorsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ebd1215e505d362758c8e44b0097b45b5734f64b7289e7521b077492647beba3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__047648730da2f3d2d1eb59c04699c1eb69d2670b0c63056d3a5c00ec3314dddc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1c2c295a482d79c455e2d9d34c4d517380c4348ade5daf72aacd61d125606ca7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanMaxColors]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanMaxColors]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f3a7afe7424bffe34c78864f00b71229a09764fbd3fdb2c8d144ce9d167cd1c1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanMaxColorsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanMaxColorsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dcc9e89759234c9b5f2b3e9b76bbb7480c85f325293d29dbd37ca956e0f73bbf)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColors")
    def reset_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColors", []))

    @jsii.member(jsii_name="resetColorsVar")
    def reset_colors_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorsVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorsInput")
    def colors_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsInput"))

    @builtins.property
    @jsii.member(jsii_name="colorsVarInput")
    def colors_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsVarInput"))

    @builtins.property
    @jsii.member(jsii_name="colors")
    def colors(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colors"))

    @colors.setter
    def colors(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b1d28c67b941654c3b1a4cf6621f61dd43fc824ca7327ec143ab89cc541e93bb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colors", value)

    @builtins.property
    @jsii.member(jsii_name="colorsVar")
    def colors_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorsVar"))

    @colors_var.setter
    def colors_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8092500e2da23b9ab21f4fc6a71ba03c63419dcb0d0f84d3043215ea37bf5fea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorsVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanMaxColors]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanMaxColors]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanMaxColors]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__07e1ef756e0b3e2ee3d4448efc66ad03ccefd8b0488e7bc35e37c695024013df)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanMirror",
    jsii_struct_bases=[],
    name_mapping={
        "horizontal": "horizontal",
        "horizontal_var": "horizontalVar",
        "vertical": "vertical",
        "vertical_var": "verticalVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanMirror:
    def __init__(
        self,
        *,
        horizontal: typing.Optional[builtins.str] = None,
        horizontal_var: typing.Optional[builtins.str] = None,
        vertical: typing.Optional[builtins.str] = None,
        vertical_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param horizontal: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        :param horizontal_var: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        :param vertical: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        :param vertical_var: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__731ce0fcbe24eac7680a003567d9b7faa4c605d403bc17b07c9e360e2343d261)
            check_type(argname="argument horizontal", value=horizontal, expected_type=type_hints["horizontal"])
            check_type(argname="argument horizontal_var", value=horizontal_var, expected_type=type_hints["horizontal_var"])
            check_type(argname="argument vertical", value=vertical, expected_type=type_hints["vertical"])
            check_type(argname="argument vertical_var", value=vertical_var, expected_type=type_hints["vertical_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if horizontal is not None:
            self._values["horizontal"] = horizontal
        if horizontal_var is not None:
            self._values["horizontal_var"] = horizontal_var
        if vertical is not None:
            self._values["vertical"] = vertical
        if vertical_var is not None:
            self._values["vertical_var"] = vertical_var

    @builtins.property
    def horizontal(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        '''
        result = self._values.get("horizontal")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def horizontal_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        '''
        result = self._values.get("horizontal_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        '''
        result = self._values.get("vertical")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        result = self._values.get("vertical_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanMirror(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanMirrorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanMirrorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__412d179234b40821af00dba79e23443bdf4489a3356eaf686b4e7bd8fc54305d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanMirrorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be9b21fb6faed4e96c66d5d8a45bcfe8eb7941efd016f9f28c609fc39dd69f56)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanMirrorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ec90c1095937bb692895d3c9aea6006a940afcdc5151658c80d1ad3f6a460b1b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ee49b6fd39a6477e88f8d409fcdf9677399895b0ff79cb8bee7138e07810f2d8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e15b01ba7860f68547e93ceb2fe0288bc252ce9be3d9c55493dc1d465076e13b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanMirror]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanMirror]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e1efdc33848f1c6dbbe8736e42665724a20472ffe5bb8a074ed46b8b9168f237)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanMirrorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanMirrorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa8ea270c3f672fc058319c82119a3eeb70ab2514abca0d6315242583e3afdd5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHorizontal")
    def reset_horizontal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontal", []))

    @jsii.member(jsii_name="resetHorizontalVar")
    def reset_horizontal_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontalVar", []))

    @jsii.member(jsii_name="resetVertical")
    def reset_vertical(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVertical", []))

    @jsii.member(jsii_name="resetVerticalVar")
    def reset_vertical_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVerticalVar", []))

    @builtins.property
    @jsii.member(jsii_name="horizontalInput")
    def horizontal_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontalVarInput")
    def horizontal_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalInput")
    def vertical_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalVarInput")
    def vertical_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontal")
    def horizontal(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontal"))

    @horizontal.setter
    def horizontal(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8357a8d2f8cee687f4a4e79332505ab13fa64ce8c5398f8d934dd55177c4a32a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontal", value)

    @builtins.property
    @jsii.member(jsii_name="horizontalVar")
    def horizontal_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontalVar"))

    @horizontal_var.setter
    def horizontal_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e4554e1626a29a947f9ee9c39283d4b9e2d3f9013964418870283af5ba6e078f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontalVar", value)

    @builtins.property
    @jsii.member(jsii_name="vertical")
    def vertical(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "vertical"))

    @vertical.setter
    def vertical(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6b95b85c21e9972b2d7ce9fc389d6049240c26ff3cd261a5f2b45d07147832c8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "vertical", value)

    @builtins.property
    @jsii.member(jsii_name="verticalVar")
    def vertical_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "verticalVar"))

    @vertical_var.setter
    def vertical_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d143380b2026411313c4647a01b8384567ba41d5c2f8bca271967030b805083b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "verticalVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanMirror]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanMirror]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanMirror]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__82c611089a1e75d015689affd7bb21007683f8681dda5f42ad57287d787b520f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanMonoHue",
    jsii_struct_bases=[],
    name_mapping={"hue": "hue", "hue_var": "hueVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanMonoHue:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__66d2458f4ee484c0db7cd69f6231949ef4dd57a201429492b997f6a29d921f80)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanMonoHue(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanMonoHueList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanMonoHueList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9c37f24a9f67376207f19ae0705af6100488d73cbb3dba06a6114720237c66fd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanMonoHueOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3d2c64e40c6dfb30420a3f406cb5b6785ba4501e1c53ffc4f50d59390e2899ef)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanMonoHueOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d5d5832e535319bdc275d9075d2997f63189da9ba85aaf450d4b163890b4ac7f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ce92fd106ac80a3c55fd119cf43930caf1f9bb545b2d76de9b4f3723d69fde47)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f5811b56202369ae7c973eb01619d639bc2ff3583a188da29adef3e2e55e48f2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanMonoHue]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanMonoHue]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__68a3801bc0859e670320ceac03c8aaf61aebd94a654d6bd3ffd18cc9816b3865)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanMonoHueOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanMonoHueOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3e4a9d16e9112ad8124a80725a4f1932c3365bd319bcb7a6c6cc0b520ffe73f0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac0a52c8348ae1efd92080e5ebb1b79df8089c6e897e7a945b68c57e3b99f267)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__75b3cd9cca3fcb9fd89216f4168fff5ba00d246ad68c7a4c65ea10c1d4dc7106)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanMonoHue]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanMonoHue]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanMonoHue]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__481332523bd34491dc2f6280453c25f769341a39ba5f069708ac0879eed3898a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanOpacity",
    jsii_struct_bases=[],
    name_mapping={"opacity": "opacity", "opacity_var": "opacityVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanOpacity:
    def __init__(
        self,
        *,
        opacity: typing.Optional[builtins.str] = None,
        opacity_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param opacity: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param opacity_var: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a533db0da8a88bf18758341fc7fc3d2c48fbf8b9cf0afbb6cb95323400f09c3b)
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument opacity_var", value=opacity_var, expected_type=type_hints["opacity_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if opacity is not None:
            self._values["opacity"] = opacity
        if opacity_var is not None:
            self._values["opacity_var"] = opacity_var

    @builtins.property
    def opacity(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def opacity_var(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        result = self._values.get("opacity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanOpacity(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanOpacityList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanOpacityList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b7493b486eeefe8d747db5d519836962f8277e7ed42db4821aee4b037cacc42f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanOpacityOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7437f95b4d7cf6860a92ed9d9478ba94c56b76456f8a358c5a1c5a6b3425e228)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanOpacityOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1c627822f4a4b23c6253e61fb11e08770f750fc976c6fb5dd2df322795e0daf9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d8d559aebf350595bb89d295d4c5d995884f8bdf7b837ffc8f8877857fb39efc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3037a23d42842db1d379b05d418031884cd6cc25831b26f51b6770fc55053925)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanOpacity]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanOpacity]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0a921e62b47fdd1d6f1b9c371eafdce70d65eef117763ed52427c46a921bfd5d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanOpacityOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanOpacityOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b8ef8eaaefd9099a96943c5b6e59eb66b3803e0c65da0371ef47e8dac9ce231b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetOpacityVar")
    def reset_opacity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacityVar", []))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityVarInput")
    def opacity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacity"))

    @opacity.setter
    def opacity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dd6512ea4970e40e1ea904cbf67f26fe93c36dbf7b70df02aedc86d439deead1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacity", value)

    @builtins.property
    @jsii.member(jsii_name="opacityVar")
    def opacity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacityVar"))

    @opacity_var.setter
    def opacity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df32bc4bc4ca02d1ed9faf90ef2dba24a9787290d711bac15958ff1e8e8541e5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacityVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanOpacity]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanOpacity]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanOpacity]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d423e1f911aff496447a82bc7d0c9b59e31f2413aa88fb6d40243e758fc76592)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e144c8cf3f0d89cb052d5f2a83f554f4fb96aa956254d8e53b2d57f69d0232c2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putBackgroundColor")
    def put_background_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__78a5fa93dccfaf1f69cf7f2a0fdb264272d554c0a6da34946822b71ae8776ec3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBackgroundColor", [value]))

    @jsii.member(jsii_name="putBlur")
    def put_blur(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanBlur, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__946531e9631417793d9c78c8cb31e1f6f7d57f77159627f14898da4f47d25cf4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBlur", [value]))

    @jsii.member(jsii_name="putChromaKey")
    def put_chroma_key(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanChromaKey, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be3e8a31c67af91d95a284e7f3d19736814c9895cdfef2c30bfe9caeb52030f6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putChromaKey", [value]))

    @jsii.member(jsii_name="putComposite")
    def put_composite(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanComposite, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d2b77fc304f10923c264ed17d613d43bf6e8234a737e9b79f59dd02f66383fd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putComposite", [value]))

    @jsii.member(jsii_name="putCompound")
    def put_compound(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanCompound, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__354160f38bec02568102665d25d2c600541178cc827577fc191a6809dfd77cc0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCompound", [value]))

    @jsii.member(jsii_name="putContrast")
    def put_contrast(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanContrast, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__76953b312899df5d28cc9fcccf4bcf134a68e92c89703ac95524463a6e8033e7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putContrast", [value]))

    @jsii.member(jsii_name="putGoop")
    def put_goop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanGoop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__849259cc9d0322bce65785c7800f4afed7dcdc808f80c77b7bb8be19da92fab0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGoop", [value]))

    @jsii.member(jsii_name="putGrayscale")
    def put_grayscale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanGrayscale, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b06dfb6399209411f351d5bf0fb04d2904ef35ad06b61907ed0b76c391f6abb3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGrayscale", [value]))

    @jsii.member(jsii_name="putHsl")
    def put_hsl(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanHsl, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d5e8cb40bbd5a0e2fa974b66fa1f0896be1f9bb481646425a2c7775cdc973a2b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsl", [value]))

    @jsii.member(jsii_name="putHsv")
    def put_hsv(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanHsv, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ebb5fe789ee705e4041e29c391c99f16685a8971110757769ac8719a0fc848af)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsv", [value]))

    @jsii.member(jsii_name="putIfDimension")
    def put_if_dimension(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfDimension, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__343e78f2dfff04fbdd1f1e79662d67875295922add781ea5ab71601997a77682)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfDimension", [value]))

    @jsii.member(jsii_name="putIfOrientation")
    def put_if_orientation(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aacf151175358adf93b8352bc2ba56c695b406f362e11607de1e09a6577f6d6a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfOrientation", [value]))

    @jsii.member(jsii_name="putMaxColors")
    def put_max_colors(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanMaxColors, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2970d906b8f449bca9fb8646e82f9ecf300a4e7893919c2de976504d5ae5ed41)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMaxColors", [value]))

    @jsii.member(jsii_name="putMirror")
    def put_mirror(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanMirror, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__28349d9cf34628db185311d3da49df45168c175eb05a113b10e955693167c6fc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMirror", [value]))

    @jsii.member(jsii_name="putMonoHue")
    def put_mono_hue(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanMonoHue, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1c7ea9132d77df8299b86796e68045fb1805491d97cc4b2f4b697a6095ce5f6b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMonoHue", [value]))

    @jsii.member(jsii_name="putOpacity")
    def put_opacity(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanOpacity, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__da4f5c7894acfae5ae277d12494fc329624562a56c65b29a8d755201a89af2c3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putOpacity", [value]))

    @jsii.member(jsii_name="putRemoveColor")
    def put_remove_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanRemoveColor", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__52a5114fb1d76a1304b7054c76ac8d34ecdea04baa5a7b658da5d26d038f40cd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRemoveColor", [value]))

    @jsii.member(jsii_name="putUnsharpMask")
    def put_unsharp_mask(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanUnsharpMask", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0bd7d7dde642e5f01ec363d624dd24aa251d5ec91ed04d63ee7346bab9264731)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putUnsharpMask", [value]))

    @jsii.member(jsii_name="resetBackgroundColor")
    def reset_background_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBackgroundColor", []))

    @jsii.member(jsii_name="resetBlur")
    def reset_blur(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBlur", []))

    @jsii.member(jsii_name="resetChromaKey")
    def reset_chroma_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChromaKey", []))

    @jsii.member(jsii_name="resetComposite")
    def reset_composite(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetComposite", []))

    @jsii.member(jsii_name="resetCompound")
    def reset_compound(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCompound", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetGoop")
    def reset_goop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGoop", []))

    @jsii.member(jsii_name="resetGrayscale")
    def reset_grayscale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGrayscale", []))

    @jsii.member(jsii_name="resetHsl")
    def reset_hsl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsl", []))

    @jsii.member(jsii_name="resetHsv")
    def reset_hsv(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsv", []))

    @jsii.member(jsii_name="resetIfDimension")
    def reset_if_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfDimension", []))

    @jsii.member(jsii_name="resetIfOrientation")
    def reset_if_orientation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfOrientation", []))

    @jsii.member(jsii_name="resetMaxColors")
    def reset_max_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxColors", []))

    @jsii.member(jsii_name="resetMirror")
    def reset_mirror(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMirror", []))

    @jsii.member(jsii_name="resetMonoHue")
    def reset_mono_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonoHue", []))

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetRemoveColor")
    def reset_remove_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRemoveColor", []))

    @jsii.member(jsii_name="resetUnsharpMask")
    def reset_unsharp_mask(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUnsharpMask", []))

    @builtins.property
    @jsii.member(jsii_name="backgroundColor")
    def background_color(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanBackgroundColorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanBackgroundColorList, jsii.get(self, "backgroundColor"))

    @builtins.property
    @jsii.member(jsii_name="blur")
    def blur(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanBlurList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanBlurList, jsii.get(self, "blur"))

    @builtins.property
    @jsii.member(jsii_name="chromaKey")
    def chroma_key(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanChromaKeyList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanChromaKeyList, jsii.get(self, "chromaKey"))

    @builtins.property
    @jsii.member(jsii_name="composite")
    def composite(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanCompositeList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanCompositeList, jsii.get(self, "composite"))

    @builtins.property
    @jsii.member(jsii_name="compound")
    def compound(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanCompoundList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanCompoundList, jsii.get(self, "compound"))

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanContrastList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanContrastList, jsii.get(self, "contrast"))

    @builtins.property
    @jsii.member(jsii_name="goop")
    def goop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanGoopList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanGoopList, jsii.get(self, "goop"))

    @builtins.property
    @jsii.member(jsii_name="grayscale")
    def grayscale(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanGrayscaleList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanGrayscaleList, jsii.get(self, "grayscale"))

    @builtins.property
    @jsii.member(jsii_name="hsl")
    def hsl(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanHslList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanHslList, jsii.get(self, "hsl"))

    @builtins.property
    @jsii.member(jsii_name="hsv")
    def hsv(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanHsvList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanHsvList, jsii.get(self, "hsv"))

    @builtins.property
    @jsii.member(jsii_name="ifDimension")
    def if_dimension(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionList, jsii.get(self, "ifDimension"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientation")
    def if_orientation(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationList, jsii.get(self, "ifOrientation"))

    @builtins.property
    @jsii.member(jsii_name="maxColors")
    def max_colors(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanMaxColorsList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanMaxColorsList, jsii.get(self, "maxColors"))

    @builtins.property
    @jsii.member(jsii_name="mirror")
    def mirror(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanMirrorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanMirrorList, jsii.get(self, "mirror"))

    @builtins.property
    @jsii.member(jsii_name="monoHue")
    def mono_hue(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanMonoHueList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanMonoHueList, jsii.get(self, "monoHue"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanOpacityList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanOpacityList, jsii.get(self, "opacity"))

    @builtins.property
    @jsii.member(jsii_name="removeColor")
    def remove_color(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanRemoveColorList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanRemoveColorList", jsii.get(self, "removeColor"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMask")
    def unsharp_mask(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanUnsharpMaskList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanUnsharpMaskList", jsii.get(self, "unsharpMask"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColorInput")
    def background_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanBackgroundColor]]], jsii.get(self, "backgroundColorInput"))

    @builtins.property
    @jsii.member(jsii_name="blurInput")
    def blur_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanBlur]]], jsii.get(self, "blurInput"))

    @builtins.property
    @jsii.member(jsii_name="chromaKeyInput")
    def chroma_key_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanChromaKey]]], jsii.get(self, "chromaKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="compositeInput")
    def composite_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanComposite]]], jsii.get(self, "compositeInput"))

    @builtins.property
    @jsii.member(jsii_name="compoundInput")
    def compound_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanCompound]]], jsii.get(self, "compoundInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanContrast]]], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="goopInput")
    def goop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanGoop]]], jsii.get(self, "goopInput"))

    @builtins.property
    @jsii.member(jsii_name="grayscaleInput")
    def grayscale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanGrayscale]]], jsii.get(self, "grayscaleInput"))

    @builtins.property
    @jsii.member(jsii_name="hslInput")
    def hsl_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanHsl]]], jsii.get(self, "hslInput"))

    @builtins.property
    @jsii.member(jsii_name="hsvInput")
    def hsv_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanHsv]]], jsii.get(self, "hsvInput"))

    @builtins.property
    @jsii.member(jsii_name="ifDimensionInput")
    def if_dimension_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfDimension]]], jsii.get(self, "ifDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientationInput")
    def if_orientation_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientation]]], jsii.get(self, "ifOrientationInput"))

    @builtins.property
    @jsii.member(jsii_name="maxColorsInput")
    def max_colors_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanMaxColors]]], jsii.get(self, "maxColorsInput"))

    @builtins.property
    @jsii.member(jsii_name="mirrorInput")
    def mirror_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanMirror]]], jsii.get(self, "mirrorInput"))

    @builtins.property
    @jsii.member(jsii_name="monoHueInput")
    def mono_hue_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanMonoHue]]], jsii.get(self, "monoHueInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanOpacity]]], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="removeColorInput")
    def remove_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanRemoveColor"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanRemoveColor"]]], jsii.get(self, "removeColorInput"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMaskInput")
    def unsharp_mask_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanUnsharpMask"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanUnsharpMask"]]], jsii.get(self, "unsharpMaskInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6a83987b0f3a57b4dfd824a127b9b539d93545341235e026dfc71d47931a4a1a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanRemoveColor",
    jsii_struct_bases=[],
    name_mapping={
        "color": "color",
        "color_var": "colorVar",
        "feather": "feather",
        "feather_var": "featherVar",
        "tolerance": "tolerance",
        "tolerance_var": "toleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanRemoveColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
        feather: typing.Optional[builtins.str] = None,
        feather_var: typing.Optional[builtins.str] = None,
        tolerance: typing.Optional[builtins.str] = None,
        tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        :param feather: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        :param feather_var: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        :param tolerance: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        :param tolerance_var: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4da76a265da996350af4dda12ea5d0a816c152b46ca013a43ec3de7470dfc317)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
            check_type(argname="argument feather", value=feather, expected_type=type_hints["feather"])
            check_type(argname="argument feather_var", value=feather_var, expected_type=type_hints["feather_var"])
            check_type(argname="argument tolerance", value=tolerance, expected_type=type_hints["tolerance"])
            check_type(argname="argument tolerance_var", value=tolerance_var, expected_type=type_hints["tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var
        if feather is not None:
            self._values["feather"] = feather
        if feather_var is not None:
            self._values["feather_var"] = feather_var
        if tolerance is not None:
            self._values["tolerance"] = tolerance
        if tolerance_var is not None:
            self._values["tolerance_var"] = tolerance_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        '''
        result = self._values.get("feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather_var(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        '''
        result = self._values.get("feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        '''
        result = self._values.get("tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance_var(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        result = self._values.get("tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanRemoveColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanRemoveColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanRemoveColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c98e6ae57ef43918bb4e3ce9b0747986d437ebd3b1a56d7f3a68157716d67819)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanRemoveColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f9594fa525b85fe10b5a977001a71a3bcefacd644ff559cd2b3cb6fcab0eae9c)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanRemoveColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__53cbd82f2b52408b3468f61e69de392fa4f863f3a73e75a47f66824c1d93810d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__adc18aa9b1c086c658fd0d22b9f3a8b6315ce28f37c5cb0a0accb9ad96cc2c01)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3886cbab4f04fef219c3adc7d65c30da517e87f409cdee702ff6a232ff73c4b1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanRemoveColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanRemoveColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanRemoveColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__11e3bdb047f22577a51b862bf1b39f70e84703452edb8c15e8f7f5440df6bc13)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanRemoveColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanRemoveColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__741a9de33871d333f8f7827b3465924012d2cc79e3d4fb7fff2cd380bfb077f6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @jsii.member(jsii_name="resetFeather")
    def reset_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeather", []))

    @jsii.member(jsii_name="resetFeatherVar")
    def reset_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatherVar", []))

    @jsii.member(jsii_name="resetTolerance")
    def reset_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTolerance", []))

    @jsii.member(jsii_name="resetToleranceVar")
    def reset_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featherInput")
    def feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherInput"))

    @builtins.property
    @jsii.member(jsii_name="featherVarInput")
    def feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceInput")
    def tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceVarInput")
    def tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb74c7e46eddb85f8b4950eb08f2dda3e7dd753af0a0aeb3b7a8d3676362c050)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d6854c67bcb2a4357e866a4dc08701f3f0c391bde86de2117a29c8185f5015e9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="feather")
    def feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "feather"))

    @feather.setter
    def feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__81afc20409f6bb4ad831ef27ca4ec2c850632f70f0f75d98888a1974d2cc9518)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "feather", value)

    @builtins.property
    @jsii.member(jsii_name="featherVar")
    def feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featherVar"))

    @feather_var.setter
    def feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a6a0cc892c1f9a5bd3ea01c943e4dd20bbf05a9d10ac7314af976d702e2f1057)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featherVar", value)

    @builtins.property
    @jsii.member(jsii_name="tolerance")
    def tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tolerance"))

    @tolerance.setter
    def tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5c5883a3f59578deb2ffe8d56cddcab685a2b90c4b1065047d95961e5f43afdd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tolerance", value)

    @builtins.property
    @jsii.member(jsii_name="toleranceVar")
    def tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "toleranceVar"))

    @tolerance_var.setter
    def tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a2f6b1adf92794e7c8616a7b27080bb0f8ec2dcfc536c85e245476071b9d5f15)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "toleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanRemoveColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanRemoveColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanRemoveColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4b57066594eaf52d93f4d662ae94e04141ffec89d61ffe25b631c4b2ba8d6def)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanUnsharpMask",
    jsii_struct_bases=[],
    name_mapping={
        "gain": "gain",
        "gain_var": "gainVar",
        "sigma": "sigma",
        "sigma_var": "sigmaVar",
        "threshold": "threshold",
        "threshold_var": "thresholdVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanUnsharpMask:
    def __init__(
        self,
        *,
        gain: typing.Optional[builtins.str] = None,
        gain_var: typing.Optional[builtins.str] = None,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
        threshold: typing.Optional[builtins.str] = None,
        threshold_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param gain: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        :param gain_var: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        :param sigma: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        :param threshold: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        :param threshold_var: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d231f7780c0ca263ba7f9524db6ee6fd6337af72762dca9b9901a137cd6ff7e2)
            check_type(argname="argument gain", value=gain, expected_type=type_hints["gain"])
            check_type(argname="argument gain_var", value=gain_var, expected_type=type_hints["gain_var"])
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
            check_type(argname="argument threshold", value=threshold, expected_type=type_hints["threshold"])
            check_type(argname="argument threshold_var", value=threshold_var, expected_type=type_hints["threshold_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if gain is not None:
            self._values["gain"] = gain
        if gain_var is not None:
            self._values["gain_var"] = gain_var
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var
        if threshold is not None:
            self._values["threshold"] = threshold
        if threshold_var is not None:
            self._values["threshold_var"] = threshold_var

    @builtins.property
    def gain(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        '''
        result = self._values.get("gain")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gain_var(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        '''
        result = self._values.get("gain_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        '''
        result = self._values.get("threshold")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold_var(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        result = self._values.get("threshold_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanUnsharpMask(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanUnsharpMaskList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanUnsharpMaskList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0911aafa65c320c1ff1d905239b795cad8f083c9dc015b9aa0ea977af35dbf71)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanUnsharpMaskOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9c8b6c44ed99d6d46a35f78b6e1bf64b002484090167c8edb7aabf89b49a80fb)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanUnsharpMaskOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b4f4254fb4234b6ac5a5d50bdfde09d90158df3b123d2fbbcfe9726ff2e8ac20)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c7e61a3a72bba5286f982bb7d835221fe59dc77d1ada61099ae5fa976ec98026)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2c710111e5366c590857c0d46f551f1e1bbabfb409062c067fac6e00054abd51)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanUnsharpMask]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanUnsharpMask]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanUnsharpMask]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__da6c71ab85f4ee7c7d47f53f7e6002f123f06d53b6826169b5fcee4d7692fdc2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanUnsharpMaskOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanUnsharpMaskOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0566f1ed4ec1a55c96a942be6bba32aba6eda3f9a160b5a841db03bef26d5efd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetGain")
    def reset_gain(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGain", []))

    @jsii.member(jsii_name="resetGainVar")
    def reset_gain_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGainVar", []))

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @jsii.member(jsii_name="resetThreshold")
    def reset_threshold(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThreshold", []))

    @jsii.member(jsii_name="resetThresholdVar")
    def reset_threshold_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThresholdVar", []))

    @builtins.property
    @jsii.member(jsii_name="gainInput")
    def gain_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainInput"))

    @builtins.property
    @jsii.member(jsii_name="gainVarInput")
    def gain_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdInput")
    def threshold_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdVarInput")
    def threshold_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gain")
    def gain(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gain"))

    @gain.setter
    def gain(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f3826b6c46ccc42716b4ce2c03b3936fc8e8a41de9dd094654d0900cbbbbc4f8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gain", value)

    @builtins.property
    @jsii.member(jsii_name="gainVar")
    def gain_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gainVar"))

    @gain_var.setter
    def gain_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__648956bf73aaa01b70984c42b4bc0de447fa81d75ebaafb39f1be5bd5ccc95e4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gainVar", value)

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fb420b03efeefbdc26441cdbaff02e78258474c2a065b0ecf1b1a190555a3bd5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b098d4b4e47ef2147ab29976650410690b64df57d859f2d5474cd7fec31604fa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="threshold")
    def threshold(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "threshold"))

    @threshold.setter
    def threshold(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__54253230a7def1efcd45b4c49d7ad1259d7b1a82055dd7bb0d6e66bcc7220171)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "threshold", value)

    @builtins.property
    @jsii.member(jsii_name="thresholdVar")
    def threshold_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "thresholdVar"))

    @threshold_var.setter
    def threshold_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__080f510120cdc08fcefdc9f4062ad71dbc23d46278b7da2e1b1a6b3e96dc39df)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "thresholdVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanUnsharpMask]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanUnsharpMask]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanUnsharpMask]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__086f0d766913bff74d86166dd933f1aa31eab4266104beaffac3d425a20ddb4f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b2728fb89ad7f816248816f561a65aa76751c69d602c11d27127528ba6e00f8b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a4866b187be7b66c870f318d93da42dfe4c739f3b0b1015c42c97db1400d96e)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__61c99a1f2c3687f730261b4da48a6b237d1d64a29bb2d1825b94533dfe17a8db)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8b2599de16acefbf0a66c56151cef1b0057c97487d7278556d4360736f3115ba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e6de2d166e1b3067ab7d31a03049b6230373a1bfc10623b487ef6594fe77de6c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimension]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimension]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f773c53de0cb57e12b499872ad64678d33d1b1db9628a33cc986efc664c5e91)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__73870f8f5714287317b3f66a09ed18f71bf8162e4f8d88871de3f3a148a5a6d2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(
        self,
        *,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultMaxColors", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultMirror", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultMonoHue", typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultOpacity", typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultRemoveColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultUnsharpMask", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefault(
            background_color=background_color,
            blur=blur,
            chroma_key=chroma_key,
            composite=composite,
            compound=compound,
            contrast=contrast,
            goop=goop,
            grayscale=grayscale,
            hsl=hsl,
            hsv=hsv,
            if_dimension=if_dimension,
            if_orientation=if_orientation,
            max_colors=max_colors,
            mirror=mirror,
            mono_hue=mono_hue,
            opacity=opacity,
            remove_color=remove_color,
            unsharp_mask=unsharp_mask,
        )

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putEqual")
    def put_equal(
        self,
        *,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqual(
            background_color=background_color,
            blur=blur,
            chroma_key=chroma_key,
            composite=composite,
            compound=compound,
            contrast=contrast,
            goop=goop,
            grayscale=grayscale,
            hsl=hsl,
            hsv=hsv,
            if_dimension=if_dimension,
            if_orientation=if_orientation,
            max_colors=max_colors,
            mirror=mirror,
            mono_hue=mono_hue,
            opacity=opacity,
            remove_color=remove_color,
            unsharp_mask=unsharp_mask,
        )

        return typing.cast(None, jsii.invoke(self, "putEqual", [value]))

    @jsii.member(jsii_name="putGreaterThan")
    def put_greater_than(
        self,
        *,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThan(
            background_color=background_color,
            blur=blur,
            chroma_key=chroma_key,
            composite=composite,
            compound=compound,
            contrast=contrast,
            goop=goop,
            grayscale=grayscale,
            hsl=hsl,
            hsv=hsv,
            if_dimension=if_dimension,
            if_orientation=if_orientation,
            max_colors=max_colors,
            mirror=mirror,
            mono_hue=mono_hue,
            opacity=opacity,
            remove_color=remove_color,
            unsharp_mask=unsharp_mask,
        )

        return typing.cast(None, jsii.invoke(self, "putGreaterThan", [value]))

    @jsii.member(jsii_name="putLessThan")
    def put_less_than(
        self,
        *,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThan(
            background_color=background_color,
            blur=blur,
            chroma_key=chroma_key,
            composite=composite,
            compound=compound,
            contrast=contrast,
            goop=goop,
            grayscale=grayscale,
            hsl=hsl,
            hsv=hsv,
            if_dimension=if_dimension,
            if_orientation=if_orientation,
            max_colors=max_colors,
            mirror=mirror,
            mono_hue=mono_hue,
            opacity=opacity,
            remove_color=remove_color,
            unsharp_mask=unsharp_mask,
        )

        return typing.cast(None, jsii.invoke(self, "putLessThan", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetDimension")
    def reset_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimension", []))

    @jsii.member(jsii_name="resetDimensionVar")
    def reset_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimensionVar", []))

    @jsii.member(jsii_name="resetEqual")
    def reset_equal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEqual", []))

    @jsii.member(jsii_name="resetGreaterThan")
    def reset_greater_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGreaterThan", []))

    @jsii.member(jsii_name="resetLessThan")
    def reset_less_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLessThan", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultOutputReference", jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="equal")
    def equal(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualOutputReference, jsii.get(self, "equal"))

    @builtins.property
    @jsii.member(jsii_name="greaterThan")
    def greater_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanOutputReference, jsii.get(self, "greaterThan"))

    @builtins.property
    @jsii.member(jsii_name="lessThan")
    def less_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanOutputReference, jsii.get(self, "lessThan"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionInput")
    def dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionVarInput")
    def dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="equalInput")
    def equal_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqual], jsii.get(self, "equalInput"))

    @builtins.property
    @jsii.member(jsii_name="greaterThanInput")
    def greater_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThan], jsii.get(self, "greaterThanInput"))

    @builtins.property
    @jsii.member(jsii_name="lessThanInput")
    def less_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThan], jsii.get(self, "lessThanInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="dimension")
    def dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimension"))

    @dimension.setter
    def dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__75e8a2da3959413720a1b251d238f80ef6e3ccf9c99e0a48b017f16a54cc67d0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimension", value)

    @builtins.property
    @jsii.member(jsii_name="dimensionVar")
    def dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimensionVar"))

    @dimension_var.setter
    def dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__077903efac80858924b1bd0aadda272d4b418cf9753964a7ea9cef40e06697aa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f0ed1a43708dfb8a3259a5fdab74f15146c3b5b03160817f554d0904394d3670)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ec003a0069f19a62f33662383a4204c5ecf2d34e8d019df937c56bf35ea55cd6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimension]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimension]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimension]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__596cda135d2c7bd47cc514e53fcc2d57907870b9880eb4db6a76d45feddd24ed)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultMaxColors",
    jsii_struct_bases=[],
    name_mapping={"colors": "colors", "colors_var": "colorsVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultMaxColors:
    def __init__(
        self,
        *,
        colors: typing.Optional[builtins.str] = None,
        colors_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param colors: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        :param colors_var: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2da7c5fb603889c5ec70ade1d0e4e1e210e2f28243f83ecd33b9e02d2c889b28)
            check_type(argname="argument colors", value=colors, expected_type=type_hints["colors"])
            check_type(argname="argument colors_var", value=colors_var, expected_type=type_hints["colors_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if colors is not None:
            self._values["colors"] = colors
        if colors_var is not None:
            self._values["colors_var"] = colors_var

    @builtins.property
    def colors(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        '''
        result = self._values.get("colors")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def colors_var(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        result = self._values.get("colors_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultMaxColors(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultMaxColorsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultMaxColorsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc643e2a78b66fe7762197b4567b6a25b5becdf4e241f0f4766b9c8168d9b9bd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultMaxColorsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3dec8787a4b2615125086b81c5eac14d4a912114e382d4531c634090082c849d)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultMaxColorsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab6fffcf6afe58d57467cf97cfbaee63def6b44ee733eb610a52c88634c14718)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__adf71f00f64d9f7d918b3362bf49607a95bc80a0dfcbac9d804d123781304cf4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ddc68ffe78eba1b0f4a66d8c4f2118973c9d565a451c110e7c9036af966b4c97)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultMaxColors]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultMaxColors]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__73f528f6a013d128c731b373b9d84c567d588900f09849acfd27836b488ba3f9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultMaxColorsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultMaxColorsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__89975c0089623d22cb3255f2ce085a66a6a5897f2370c883a645a00b52b6769c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColors")
    def reset_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColors", []))

    @jsii.member(jsii_name="resetColorsVar")
    def reset_colors_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorsVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorsInput")
    def colors_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsInput"))

    @builtins.property
    @jsii.member(jsii_name="colorsVarInput")
    def colors_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsVarInput"))

    @builtins.property
    @jsii.member(jsii_name="colors")
    def colors(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colors"))

    @colors.setter
    def colors(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__829f6e647c620719b038fbe4464b78774abf06bb1e129d2bedcf34448416d93a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colors", value)

    @builtins.property
    @jsii.member(jsii_name="colorsVar")
    def colors_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorsVar"))

    @colors_var.setter
    def colors_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1ca64ef6dee958dbebee05a5926a7b075fe6552fd8e15fa7aef42a45fa0ab5d7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorsVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultMaxColors]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultMaxColors]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultMaxColors]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__56a2f99943910766524cb1410598da3610cfcd2332801605bb27bc4917a73863)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultMirror",
    jsii_struct_bases=[],
    name_mapping={
        "horizontal": "horizontal",
        "horizontal_var": "horizontalVar",
        "vertical": "vertical",
        "vertical_var": "verticalVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultMirror:
    def __init__(
        self,
        *,
        horizontal: typing.Optional[builtins.str] = None,
        horizontal_var: typing.Optional[builtins.str] = None,
        vertical: typing.Optional[builtins.str] = None,
        vertical_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param horizontal: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        :param horizontal_var: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        :param vertical: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        :param vertical_var: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b55066b9c64cf6f3c6dad96ad0b64627f3173e7318050de5e189dd435d800135)
            check_type(argname="argument horizontal", value=horizontal, expected_type=type_hints["horizontal"])
            check_type(argname="argument horizontal_var", value=horizontal_var, expected_type=type_hints["horizontal_var"])
            check_type(argname="argument vertical", value=vertical, expected_type=type_hints["vertical"])
            check_type(argname="argument vertical_var", value=vertical_var, expected_type=type_hints["vertical_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if horizontal is not None:
            self._values["horizontal"] = horizontal
        if horizontal_var is not None:
            self._values["horizontal_var"] = horizontal_var
        if vertical is not None:
            self._values["vertical"] = vertical
        if vertical_var is not None:
            self._values["vertical_var"] = vertical_var

    @builtins.property
    def horizontal(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        '''
        result = self._values.get("horizontal")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def horizontal_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        '''
        result = self._values.get("horizontal_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        '''
        result = self._values.get("vertical")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        result = self._values.get("vertical_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultMirror(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultMirrorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultMirrorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c5d747b1f3dcbc80d003ccdb7557ac3d5ae0d8732fc6d6d230c65a503dc8c90f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultMirrorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c150c7d4c7a707b270ce70e6ab75e3c99daf2f933ad85deb02b2631fe6ba9009)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultMirrorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__64c13ec81e0677797272f41a31f87381fe11333b7ca4b3c3d0684b923d3e2a48)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__75d83e5e2a25b5607c2d90bae1e77d1656dd1b0099844e7220710a35ea0c110e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__796a1c951951683188cf83ebda9e3f4aaa7b63c811167f948d9d6b8387d40465)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultMirror]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultMirror]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7c94b07d6c0acda6974f68b11da9d62ad38b22633fa6b8d13b7b30491138f527)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultMirrorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultMirrorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__57405753809a3bc2e4843251f148ec0cddbaa373a8bbde96e7251ac28a472eb0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHorizontal")
    def reset_horizontal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontal", []))

    @jsii.member(jsii_name="resetHorizontalVar")
    def reset_horizontal_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontalVar", []))

    @jsii.member(jsii_name="resetVertical")
    def reset_vertical(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVertical", []))

    @jsii.member(jsii_name="resetVerticalVar")
    def reset_vertical_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVerticalVar", []))

    @builtins.property
    @jsii.member(jsii_name="horizontalInput")
    def horizontal_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontalVarInput")
    def horizontal_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalInput")
    def vertical_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalVarInput")
    def vertical_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontal")
    def horizontal(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontal"))

    @horizontal.setter
    def horizontal(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5598d5a659dbe3ccf7709cfa6c75448396b729dd80b6fb9b98edf70f8ea09b5a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontal", value)

    @builtins.property
    @jsii.member(jsii_name="horizontalVar")
    def horizontal_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontalVar"))

    @horizontal_var.setter
    def horizontal_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__88deea9d993618441a191f882d627d3876563234e98ef524022bd378204d8b4d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontalVar", value)

    @builtins.property
    @jsii.member(jsii_name="vertical")
    def vertical(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "vertical"))

    @vertical.setter
    def vertical(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be92e0199577de917c6c5cdb14859cd426bb0cf44eb8421ed654878fb2b87a3c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "vertical", value)

    @builtins.property
    @jsii.member(jsii_name="verticalVar")
    def vertical_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "verticalVar"))

    @vertical_var.setter
    def vertical_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__18cfb2832d8a5a7ded31b7f34f995fc072a12d1c6ced535aa0ebce19d72cb12e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "verticalVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultMirror]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultMirror]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultMirror]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7b637b9decdc2007a9e1f5e1fde3de2a084ed1d18aef886bd847a6d15d20b51c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultMonoHue",
    jsii_struct_bases=[],
    name_mapping={"hue": "hue", "hue_var": "hueVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultMonoHue:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eaf739f32bf7acc9a03bfac4de76a3b5e58a75d9c6bd4ddd9c68a60efb0d140b)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultMonoHue(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultMonoHueList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultMonoHueList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ffe4e72c7e7ce0eac017bfcd3415eea852eea6fadac51765cdb3f0838644642)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultMonoHueOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d753e8086a78dd82268a5917eb236ecb6ee7ea0003bd173234076b751f02c6a9)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultMonoHueOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8af7a6f5e002392fcb80944447ea01b9a9449dd5cda8e786555791c8a6dd47a9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__19b89c18160f6753e402e4c2ff837e5ad0de8d806a5bc91c475df592b761f8d1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ee4ee45d25d23708a4849aa6af950bbe16db1f50677da9573b48e3e717a1bb53)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultMonoHue]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultMonoHue]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3fb926d6778a6c0315175fac35b5a176ba19638dd619c8f8107f68a4dfb8690e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultMonoHueOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultMonoHueOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__77aa61786a8fa880f508fad3ffe8d1735dded75e1d34cea7752db467dd83e144)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a7345313dfbf82592091b68c2b08ead8c2c7e90b2f3ede7adb320e66d771cc72)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4d542db0bb673a4cf3089bbcd769fb00f4a51c983836e89c3e784346a42f35d1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultMonoHue]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultMonoHue]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultMonoHue]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2eb84c233576fefee277586399f1d40e7231512cbf803a51b72237cd62628c27)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultOpacity",
    jsii_struct_bases=[],
    name_mapping={"opacity": "opacity", "opacity_var": "opacityVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultOpacity:
    def __init__(
        self,
        *,
        opacity: typing.Optional[builtins.str] = None,
        opacity_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param opacity: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param opacity_var: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e4667a2df1c4db02602a93795e49c0e7b47bd397d7c6d20452dae2940548f38c)
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument opacity_var", value=opacity_var, expected_type=type_hints["opacity_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if opacity is not None:
            self._values["opacity"] = opacity
        if opacity_var is not None:
            self._values["opacity_var"] = opacity_var

    @builtins.property
    def opacity(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def opacity_var(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        result = self._values.get("opacity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultOpacity(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultOpacityList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultOpacityList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c7a717fe5e569232925ae6f208d4a4726ddac94015d1bc64962d1e6489609678)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultOpacityOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__584f1bb316a25bfa7f1ebaed6073facc0d2bb90ee917c94f5385a252cd07ee1c)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultOpacityOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c8b60159754ea5306070713d59b167cb03f805a09d5efa6e492a74f9104aa62f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f8e2ed36065adc84eb89c58514bf05618dc6daebfcf94c09961b0adea24ea50c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e51250e4d80afce26034112a6e3f5e8b9375b1d26d2ab8fcd63c5c7cf433bf36)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultOpacity]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultOpacity]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f9864de5f252b37caec3f86f55f978dc67155d06a749b61a1243c61bdda295d0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultOpacityOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultOpacityOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ad41b284036c0344e04f7b980655337c0a3b98dfcb31fe8353affc33988f82a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetOpacityVar")
    def reset_opacity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacityVar", []))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityVarInput")
    def opacity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacity"))

    @opacity.setter
    def opacity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__39a81bd254d28a24e7ef01e81cae4835ec0113bed44c01dfa86215bafc62b88d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacity", value)

    @builtins.property
    @jsii.member(jsii_name="opacityVar")
    def opacity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacityVar"))

    @opacity_var.setter
    def opacity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b92ed1c22588a50080de14529ae389a2b5d65f4b173fef3acc87085ce8a12c76)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacityVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultOpacity]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultOpacity]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultOpacity]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1e5440d2d75870b7fc1ecfa8b10d9f3d698bda8219e8584d7420cd9cc9503d05)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__77df161c4f3dd30a009dd53c8ba2b84d7824f9029ca8d28eca75e1fe1440c98a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putBackgroundColor")
    def put_background_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3fa55917de40a4cf4baac0451a912bdbcd4355d11f036c70d57092c18b9b4b68)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBackgroundColor", [value]))

    @jsii.member(jsii_name="putBlur")
    def put_blur(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultBlur, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__605708a33386546c857882a4a9b1ebb44cdbe0bc0e0e50a197c584296edbafed)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBlur", [value]))

    @jsii.member(jsii_name="putChromaKey")
    def put_chroma_key(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultChromaKey, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6c6536a60914889cab08382ee750a5d9d40c727e7e4826d6c72e739522cb00ea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putChromaKey", [value]))

    @jsii.member(jsii_name="putComposite")
    def put_composite(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultComposite, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__14d8065e92f57dea90721e5cdcb623f35b2ce82080ce24aa3bdb16790f9f308f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putComposite", [value]))

    @jsii.member(jsii_name="putCompound")
    def put_compound(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompound, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d311ae6e97cd6e5a097f5a3fdb47e893a72e0f42f6ce6db93859c3439ca046b1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCompound", [value]))

    @jsii.member(jsii_name="putContrast")
    def put_contrast(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultContrast, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__295171c128e96b9232c1a5204f843cbb52a92085ad8d86891bb9f2f92900e97d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putContrast", [value]))

    @jsii.member(jsii_name="putGoop")
    def put_goop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultGoop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__57d32c140e89c3e64bf48d43b46b26153254533321a41e70f47a6ebae781eb11)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGoop", [value]))

    @jsii.member(jsii_name="putGrayscale")
    def put_grayscale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultGrayscale, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__58a868b6fbcf8ecbc2186c44afcdb19a5e5d710e9bb71ab09313a21b62d8e19f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGrayscale", [value]))

    @jsii.member(jsii_name="putHsl")
    def put_hsl(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultHsl, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__451b661a1e3be1cbfdfb3f481ab1bc8651c054895f607132f64763d629eb032d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsl", [value]))

    @jsii.member(jsii_name="putHsv")
    def put_hsv(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultHsv, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0910c41db28a63cf0d33f9e2446f71ac76593bc7461d21d8b2b86ee7ca48c6fd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsv", [value]))

    @jsii.member(jsii_name="putIfDimension")
    def put_if_dimension(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimension, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cc7f6497fa5b5cf8795d9e20f5ea0438cfadf4ba09fcb28767900722b8ec38a0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfDimension", [value]))

    @jsii.member(jsii_name="putIfOrientation")
    def put_if_orientation(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b30241a4a34c7ba0e553efa461bdf4578664fe5e1934ac805bdc4b2c6c5251f7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfOrientation", [value]))

    @jsii.member(jsii_name="putMaxColors")
    def put_max_colors(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultMaxColors, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a86e38b079ba1f45bf8ae29d0dd9cfe576686537b3426a17029cab1b4e71710)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMaxColors", [value]))

    @jsii.member(jsii_name="putMirror")
    def put_mirror(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultMirror, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8862c3a15349295465f5ec2553cd7683daf0b3706355da3733d0c3ad7b0bc5bf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMirror", [value]))

    @jsii.member(jsii_name="putMonoHue")
    def put_mono_hue(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultMonoHue, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5bdd3fb0ccbfd46708d95112ee2a396bcc9c0591583a371ec48b7c741ad02d60)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMonoHue", [value]))

    @jsii.member(jsii_name="putOpacity")
    def put_opacity(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultOpacity, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd1bfc4bec678e8d75efe7a25a1e1276102f87a6365bcb985e38c14affb82ca5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putOpacity", [value]))

    @jsii.member(jsii_name="putRemoveColor")
    def put_remove_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultRemoveColor", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fbcbd9d36d211be494d14cb485835f8741a1f10d7986a30f937ef055cffed484)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRemoveColor", [value]))

    @jsii.member(jsii_name="putUnsharpMask")
    def put_unsharp_mask(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultUnsharpMask", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__945ede6ff5508d61b76ce2f44055977d2571d601e813a29f42d9c4d89c59f187)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putUnsharpMask", [value]))

    @jsii.member(jsii_name="resetBackgroundColor")
    def reset_background_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBackgroundColor", []))

    @jsii.member(jsii_name="resetBlur")
    def reset_blur(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBlur", []))

    @jsii.member(jsii_name="resetChromaKey")
    def reset_chroma_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChromaKey", []))

    @jsii.member(jsii_name="resetComposite")
    def reset_composite(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetComposite", []))

    @jsii.member(jsii_name="resetCompound")
    def reset_compound(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCompound", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetGoop")
    def reset_goop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGoop", []))

    @jsii.member(jsii_name="resetGrayscale")
    def reset_grayscale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGrayscale", []))

    @jsii.member(jsii_name="resetHsl")
    def reset_hsl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsl", []))

    @jsii.member(jsii_name="resetHsv")
    def reset_hsv(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsv", []))

    @jsii.member(jsii_name="resetIfDimension")
    def reset_if_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfDimension", []))

    @jsii.member(jsii_name="resetIfOrientation")
    def reset_if_orientation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfOrientation", []))

    @jsii.member(jsii_name="resetMaxColors")
    def reset_max_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxColors", []))

    @jsii.member(jsii_name="resetMirror")
    def reset_mirror(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMirror", []))

    @jsii.member(jsii_name="resetMonoHue")
    def reset_mono_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonoHue", []))

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetRemoveColor")
    def reset_remove_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRemoveColor", []))

    @jsii.member(jsii_name="resetUnsharpMask")
    def reset_unsharp_mask(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUnsharpMask", []))

    @builtins.property
    @jsii.member(jsii_name="backgroundColor")
    def background_color(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultBackgroundColorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultBackgroundColorList, jsii.get(self, "backgroundColor"))

    @builtins.property
    @jsii.member(jsii_name="blur")
    def blur(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultBlurList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultBlurList, jsii.get(self, "blur"))

    @builtins.property
    @jsii.member(jsii_name="chromaKey")
    def chroma_key(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultChromaKeyList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultChromaKeyList, jsii.get(self, "chromaKey"))

    @builtins.property
    @jsii.member(jsii_name="composite")
    def composite(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeList, jsii.get(self, "composite"))

    @builtins.property
    @jsii.member(jsii_name="compound")
    def compound(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundList, jsii.get(self, "compound"))

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultContrastList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultContrastList, jsii.get(self, "contrast"))

    @builtins.property
    @jsii.member(jsii_name="goop")
    def goop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultGoopList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultGoopList, jsii.get(self, "goop"))

    @builtins.property
    @jsii.member(jsii_name="grayscale")
    def grayscale(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultGrayscaleList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultGrayscaleList, jsii.get(self, "grayscale"))

    @builtins.property
    @jsii.member(jsii_name="hsl")
    def hsl(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultHslList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultHslList, jsii.get(self, "hsl"))

    @builtins.property
    @jsii.member(jsii_name="hsv")
    def hsv(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultHsvList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultHsvList, jsii.get(self, "hsv"))

    @builtins.property
    @jsii.member(jsii_name="ifDimension")
    def if_dimension(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionList, jsii.get(self, "ifDimension"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientation")
    def if_orientation(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationList", jsii.get(self, "ifOrientation"))

    @builtins.property
    @jsii.member(jsii_name="maxColors")
    def max_colors(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultMaxColorsList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultMaxColorsList, jsii.get(self, "maxColors"))

    @builtins.property
    @jsii.member(jsii_name="mirror")
    def mirror(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultMirrorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultMirrorList, jsii.get(self, "mirror"))

    @builtins.property
    @jsii.member(jsii_name="monoHue")
    def mono_hue(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultMonoHueList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultMonoHueList, jsii.get(self, "monoHue"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultOpacityList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultOpacityList, jsii.get(self, "opacity"))

    @builtins.property
    @jsii.member(jsii_name="removeColor")
    def remove_color(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultRemoveColorList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultRemoveColorList", jsii.get(self, "removeColor"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMask")
    def unsharp_mask(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultUnsharpMaskList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultUnsharpMaskList", jsii.get(self, "unsharpMask"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColorInput")
    def background_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultBackgroundColor]]], jsii.get(self, "backgroundColorInput"))

    @builtins.property
    @jsii.member(jsii_name="blurInput")
    def blur_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultBlur]]], jsii.get(self, "blurInput"))

    @builtins.property
    @jsii.member(jsii_name="chromaKeyInput")
    def chroma_key_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultChromaKey]]], jsii.get(self, "chromaKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="compositeInput")
    def composite_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultComposite]]], jsii.get(self, "compositeInput"))

    @builtins.property
    @jsii.member(jsii_name="compoundInput")
    def compound_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompound]]], jsii.get(self, "compoundInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultContrast]]], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="goopInput")
    def goop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultGoop]]], jsii.get(self, "goopInput"))

    @builtins.property
    @jsii.member(jsii_name="grayscaleInput")
    def grayscale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultGrayscale]]], jsii.get(self, "grayscaleInput"))

    @builtins.property
    @jsii.member(jsii_name="hslInput")
    def hsl_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultHsl]]], jsii.get(self, "hslInput"))

    @builtins.property
    @jsii.member(jsii_name="hsvInput")
    def hsv_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultHsv]]], jsii.get(self, "hsvInput"))

    @builtins.property
    @jsii.member(jsii_name="ifDimensionInput")
    def if_dimension_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimension]]], jsii.get(self, "ifDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientationInput")
    def if_orientation_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientation]]], jsii.get(self, "ifOrientationInput"))

    @builtins.property
    @jsii.member(jsii_name="maxColorsInput")
    def max_colors_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultMaxColors]]], jsii.get(self, "maxColorsInput"))

    @builtins.property
    @jsii.member(jsii_name="mirrorInput")
    def mirror_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultMirror]]], jsii.get(self, "mirrorInput"))

    @builtins.property
    @jsii.member(jsii_name="monoHueInput")
    def mono_hue_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultMonoHue]]], jsii.get(self, "monoHueInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultOpacity]]], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="removeColorInput")
    def remove_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultRemoveColor"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultRemoveColor"]]], jsii.get(self, "removeColorInput"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMaskInput")
    def unsharp_mask_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultUnsharpMask"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultUnsharpMask"]]], jsii.get(self, "unsharpMaskInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3cd8013286bd02cfd4122c4b9940f7d750bf9959810573baf6db25a416735645)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultRemoveColor",
    jsii_struct_bases=[],
    name_mapping={
        "color": "color",
        "color_var": "colorVar",
        "feather": "feather",
        "feather_var": "featherVar",
        "tolerance": "tolerance",
        "tolerance_var": "toleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultRemoveColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
        feather: typing.Optional[builtins.str] = None,
        feather_var: typing.Optional[builtins.str] = None,
        tolerance: typing.Optional[builtins.str] = None,
        tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        :param feather: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        :param feather_var: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        :param tolerance: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        :param tolerance_var: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ae298af48639c88bdca1f60a13edf87eca9e7cbbc7d5aea9d76d24d827774b5)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
            check_type(argname="argument feather", value=feather, expected_type=type_hints["feather"])
            check_type(argname="argument feather_var", value=feather_var, expected_type=type_hints["feather_var"])
            check_type(argname="argument tolerance", value=tolerance, expected_type=type_hints["tolerance"])
            check_type(argname="argument tolerance_var", value=tolerance_var, expected_type=type_hints["tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var
        if feather is not None:
            self._values["feather"] = feather
        if feather_var is not None:
            self._values["feather_var"] = feather_var
        if tolerance is not None:
            self._values["tolerance"] = tolerance
        if tolerance_var is not None:
            self._values["tolerance_var"] = tolerance_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        '''
        result = self._values.get("feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather_var(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        '''
        result = self._values.get("feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        '''
        result = self._values.get("tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance_var(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        result = self._values.get("tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultRemoveColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultRemoveColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultRemoveColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5249dac80e2e502a7aa62f89bd52db64dcb3cb9cbbec32aa517c1d4ce439abc6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultRemoveColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c11c980bd958fd90a37f179112dbb32922b35b1bdf3d6ed82e9135249b97ed56)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultRemoveColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cecf5a1a0e031f1a6fab40bf5be53d3c902bc5bb5c5632b9a732188e39bd9125)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__986df07e7d7a2902ec65e0a7909d9c11bff57c3bef74aa65c3fd9779f8a79e00)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c2043c0688ffd7b96acec4e5e55c62ba56ad6259b39c2dadbac9f146186ff0d1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultRemoveColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultRemoveColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultRemoveColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__791c74eb5213e84288a5381d059251e488f300330406e103dfb3f549dfb9ff99)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultRemoveColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultRemoveColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cc5f34afbdaf36bcba6ff60d254f0530b05b4be8c3e7292a47682a024650b5a2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @jsii.member(jsii_name="resetFeather")
    def reset_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeather", []))

    @jsii.member(jsii_name="resetFeatherVar")
    def reset_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatherVar", []))

    @jsii.member(jsii_name="resetTolerance")
    def reset_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTolerance", []))

    @jsii.member(jsii_name="resetToleranceVar")
    def reset_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featherInput")
    def feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherInput"))

    @builtins.property
    @jsii.member(jsii_name="featherVarInput")
    def feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceInput")
    def tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceVarInput")
    def tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__531b28d52a123f7e2158cc3287edfb25c0b121f35bd028a24ed18ed9c1ddc958)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__99d8219a69c9a46cb6f9edbf4574fd46fefadce01d6f6b99716b1c6607f34074)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="feather")
    def feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "feather"))

    @feather.setter
    def feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__56bd37a7a042aa07c94d16614e99d88722fe358006abc08ad25cb6e7669c757f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "feather", value)

    @builtins.property
    @jsii.member(jsii_name="featherVar")
    def feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featherVar"))

    @feather_var.setter
    def feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9003a8429b920bea6361b251a97704b2048c6b670a045c9f489d83346bf4aaee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featherVar", value)

    @builtins.property
    @jsii.member(jsii_name="tolerance")
    def tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tolerance"))

    @tolerance.setter
    def tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f2653ef99ffdbfe11ed4e2990b2812eb8d7124ab393bd3fe6453a93dce3b0ee4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tolerance", value)

    @builtins.property
    @jsii.member(jsii_name="toleranceVar")
    def tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "toleranceVar"))

    @tolerance_var.setter
    def tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8731ae7528e107074484e93c758430bc21fcfd74266cfa52ef983afe46d98d35)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "toleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultRemoveColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultRemoveColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultRemoveColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7c6fc6cd1d9c2d035b8115ca91dc1eab9ab269af59e7818356b55ec19c9d0480)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultUnsharpMask",
    jsii_struct_bases=[],
    name_mapping={
        "gain": "gain",
        "gain_var": "gainVar",
        "sigma": "sigma",
        "sigma_var": "sigmaVar",
        "threshold": "threshold",
        "threshold_var": "thresholdVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultUnsharpMask:
    def __init__(
        self,
        *,
        gain: typing.Optional[builtins.str] = None,
        gain_var: typing.Optional[builtins.str] = None,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
        threshold: typing.Optional[builtins.str] = None,
        threshold_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param gain: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        :param gain_var: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        :param sigma: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        :param threshold: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        :param threshold_var: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__91d0a738bba9de5e86aa043089efde443a20a4ab601c2dfaf1cf1c19d0c7d0c7)
            check_type(argname="argument gain", value=gain, expected_type=type_hints["gain"])
            check_type(argname="argument gain_var", value=gain_var, expected_type=type_hints["gain_var"])
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
            check_type(argname="argument threshold", value=threshold, expected_type=type_hints["threshold"])
            check_type(argname="argument threshold_var", value=threshold_var, expected_type=type_hints["threshold_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if gain is not None:
            self._values["gain"] = gain
        if gain_var is not None:
            self._values["gain_var"] = gain_var
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var
        if threshold is not None:
            self._values["threshold"] = threshold
        if threshold_var is not None:
            self._values["threshold_var"] = threshold_var

    @builtins.property
    def gain(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        '''
        result = self._values.get("gain")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gain_var(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        '''
        result = self._values.get("gain_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        '''
        result = self._values.get("threshold")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold_var(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        result = self._values.get("threshold_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultUnsharpMask(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultUnsharpMaskList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultUnsharpMaskList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9b4711f9dadabd0bf95c844ff90a6918f2fa5756512b213f793c6caa853de75e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultUnsharpMaskOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__73f52f25177d143b9d4d4aa03a9771488e0610947820dd2f9aff3fe86cdf1cd7)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultUnsharpMaskOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__64d5f279b1f2a2e385e150e03f179ad419302abaff1ec91977ea42b4b844d8dd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a22b2bd2bc4065b6666f1fc0c7e41c8bddbc5ff15197ffca75005bec5267f027)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8922dde66c47911dddbc399a023e534be6fd4d24b1b5873ecfe3cd25afec6643)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultUnsharpMask]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultUnsharpMask]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultUnsharpMask]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc0d6e3cf2caff86d32f8588d0f010dd3a6189714e0c4ecf864c6fb595871c43)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultUnsharpMaskOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultUnsharpMaskOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ca7e0cdb32859312280fa01c1fc170e59568aea4d5663ab3fa462cfb9b3113ef)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetGain")
    def reset_gain(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGain", []))

    @jsii.member(jsii_name="resetGainVar")
    def reset_gain_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGainVar", []))

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @jsii.member(jsii_name="resetThreshold")
    def reset_threshold(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThreshold", []))

    @jsii.member(jsii_name="resetThresholdVar")
    def reset_threshold_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThresholdVar", []))

    @builtins.property
    @jsii.member(jsii_name="gainInput")
    def gain_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainInput"))

    @builtins.property
    @jsii.member(jsii_name="gainVarInput")
    def gain_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdInput")
    def threshold_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdVarInput")
    def threshold_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gain")
    def gain(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gain"))

    @gain.setter
    def gain(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c03afa5f6565069bba512d31e1cb26c8d69d80ad0d39a8a18d298b4fb030dff7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gain", value)

    @builtins.property
    @jsii.member(jsii_name="gainVar")
    def gain_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gainVar"))

    @gain_var.setter
    def gain_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7a9d7a8a34a2767e45181f7329ea830de4922b969db4f6c830a6487ef599c731)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gainVar", value)

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eda6140076a9fe06063876ff228e288859e8f91493cb403e7f3a95ba6b69c34e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b82477412ffb71ebc9267117494136d7676263316737deb146623c89575b6b41)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="threshold")
    def threshold(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "threshold"))

    @threshold.setter
    def threshold(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f75b2dd94168cd3405a9f36b0a9f6893d0925e52288e4f6be763b1def71aecb2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "threshold", value)

    @builtins.property
    @jsii.member(jsii_name="thresholdVar")
    def threshold_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "thresholdVar"))

    @threshold_var.setter
    def threshold_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__14997fd54474cd2195a6a1fd3c6ac067a38cc358dd6c0967064d0bb022c29908)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "thresholdVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultUnsharpMask]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultUnsharpMask]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultUnsharpMask]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a152c29ebc72e0de105d752c0297bd4bc7b4fd535845ebd0b336e538e2de1008)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscape",
    jsii_struct_bases=[],
    name_mapping={
        "background_color": "backgroundColor",
        "blur": "blur",
        "chroma_key": "chromaKey",
        "composite": "composite",
        "compound": "compound",
        "contrast": "contrast",
        "goop": "goop",
        "grayscale": "grayscale",
        "hsl": "hsl",
        "hsv": "hsv",
        "if_dimension": "ifDimension",
        "if_orientation": "ifOrientation",
        "max_colors": "maxColors",
        "mirror": "mirror",
        "mono_hue": "monoHue",
        "opacity": "opacity",
        "remove_color": "removeColor",
        "unsharp_mask": "unsharpMask",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscape:
    def __init__(
        self,
        *,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeBackgroundColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeBlur", typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeChromaKey", typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeComposite", typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompound", typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeContrast", typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeGoop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeGrayscale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeHsl", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeHsv", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimension", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeMaxColors", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeMirror", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeMonoHue", typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeOpacity", typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeRemoveColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeUnsharpMask", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__07b1553c1981a3b4e639e7180e938cee0a90af5044c4bcb83c2772c330917fbf)
            check_type(argname="argument background_color", value=background_color, expected_type=type_hints["background_color"])
            check_type(argname="argument blur", value=blur, expected_type=type_hints["blur"])
            check_type(argname="argument chroma_key", value=chroma_key, expected_type=type_hints["chroma_key"])
            check_type(argname="argument composite", value=composite, expected_type=type_hints["composite"])
            check_type(argname="argument compound", value=compound, expected_type=type_hints["compound"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument goop", value=goop, expected_type=type_hints["goop"])
            check_type(argname="argument grayscale", value=grayscale, expected_type=type_hints["grayscale"])
            check_type(argname="argument hsl", value=hsl, expected_type=type_hints["hsl"])
            check_type(argname="argument hsv", value=hsv, expected_type=type_hints["hsv"])
            check_type(argname="argument if_dimension", value=if_dimension, expected_type=type_hints["if_dimension"])
            check_type(argname="argument if_orientation", value=if_orientation, expected_type=type_hints["if_orientation"])
            check_type(argname="argument max_colors", value=max_colors, expected_type=type_hints["max_colors"])
            check_type(argname="argument mirror", value=mirror, expected_type=type_hints["mirror"])
            check_type(argname="argument mono_hue", value=mono_hue, expected_type=type_hints["mono_hue"])
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument remove_color", value=remove_color, expected_type=type_hints["remove_color"])
            check_type(argname="argument unsharp_mask", value=unsharp_mask, expected_type=type_hints["unsharp_mask"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if background_color is not None:
            self._values["background_color"] = background_color
        if blur is not None:
            self._values["blur"] = blur
        if chroma_key is not None:
            self._values["chroma_key"] = chroma_key
        if composite is not None:
            self._values["composite"] = composite
        if compound is not None:
            self._values["compound"] = compound
        if contrast is not None:
            self._values["contrast"] = contrast
        if goop is not None:
            self._values["goop"] = goop
        if grayscale is not None:
            self._values["grayscale"] = grayscale
        if hsl is not None:
            self._values["hsl"] = hsl
        if hsv is not None:
            self._values["hsv"] = hsv
        if if_dimension is not None:
            self._values["if_dimension"] = if_dimension
        if if_orientation is not None:
            self._values["if_orientation"] = if_orientation
        if max_colors is not None:
            self._values["max_colors"] = max_colors
        if mirror is not None:
            self._values["mirror"] = mirror
        if mono_hue is not None:
            self._values["mono_hue"] = mono_hue
        if opacity is not None:
            self._values["opacity"] = opacity
        if remove_color is not None:
            self._values["remove_color"] = remove_color
        if unsharp_mask is not None:
            self._values["unsharp_mask"] = unsharp_mask

    @builtins.property
    def background_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeBackgroundColor"]]]:
        '''background_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        '''
        result = self._values.get("background_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeBackgroundColor"]]], result)

    @builtins.property
    def blur(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeBlur"]]]:
        '''blur block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        '''
        result = self._values.get("blur")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeBlur"]]], result)

    @builtins.property
    def chroma_key(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeChromaKey"]]]:
        '''chroma_key block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        '''
        result = self._values.get("chroma_key")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeChromaKey"]]], result)

    @builtins.property
    def composite(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeComposite"]]]:
        '''composite block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        '''
        result = self._values.get("composite")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeComposite"]]], result)

    @builtins.property
    def compound(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompound"]]]:
        '''compound block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        '''
        result = self._values.get("compound")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompound"]]], result)

    @builtins.property
    def contrast(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeContrast"]]]:
        '''contrast block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeContrast"]]], result)

    @builtins.property
    def goop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeGoop"]]]:
        '''goop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        '''
        result = self._values.get("goop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeGoop"]]], result)

    @builtins.property
    def grayscale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeGrayscale"]]]:
        '''grayscale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        '''
        result = self._values.get("grayscale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeGrayscale"]]], result)

    @builtins.property
    def hsl(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeHsl"]]]:
        '''hsl block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        '''
        result = self._values.get("hsl")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeHsl"]]], result)

    @builtins.property
    def hsv(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeHsv"]]]:
        '''hsv block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        '''
        result = self._values.get("hsv")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeHsv"]]], result)

    @builtins.property
    def if_dimension(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimension"]]]:
        '''if_dimension block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        '''
        result = self._values.get("if_dimension")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimension"]]], result)

    @builtins.property
    def if_orientation(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientation]]]:
        '''if_orientation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        '''
        result = self._values.get("if_orientation")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientation]]], result)

    @builtins.property
    def max_colors(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeMaxColors"]]]:
        '''max_colors block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        '''
        result = self._values.get("max_colors")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeMaxColors"]]], result)

    @builtins.property
    def mirror(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeMirror"]]]:
        '''mirror block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        '''
        result = self._values.get("mirror")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeMirror"]]], result)

    @builtins.property
    def mono_hue(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeMonoHue"]]]:
        '''mono_hue block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        '''
        result = self._values.get("mono_hue")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeMonoHue"]]], result)

    @builtins.property
    def opacity(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeOpacity"]]]:
        '''opacity block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeOpacity"]]], result)

    @builtins.property
    def remove_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeRemoveColor"]]]:
        '''remove_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        '''
        result = self._values.get("remove_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeRemoveColor"]]], result)

    @builtins.property
    def unsharp_mask(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeUnsharpMask"]]]:
        '''unsharp_mask block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        result = self._values.get("unsharp_mask")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeUnsharpMask"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscape(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeBackgroundColor",
    jsii_struct_bases=[],
    name_mapping={"color": "color", "color_var": "colorVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeBackgroundColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__63eb2738a8ac92690c6e41d300b17c13e2b5f3ccd24c92afa0ae386984a5cd14)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeBackgroundColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeBackgroundColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeBackgroundColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__82ea0fa3decad029c690aedf00739597a9cb09bd35171b8fc73f7938281c9d37)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeBackgroundColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__31a4eb9f7ba53f607d2e3bf38ba160ed5ed5eba0fb9460436bd6098f0c733cf5)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeBackgroundColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__51694c0d4d3193cdfc79f235a064b7db801d1af429ec58f00ac554d8f958343e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4809ac17b1a049a5f9389031fdf2b38a4b17a60345deaf5977f97d2be8c42c4c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a0ca516aef0edee212d4f365b15aaddb8c6ae2ebf55eff296d7d556b8cbc135)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeBackgroundColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeBackgroundColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9c200c31fce97cbcceef2050c86c10a8332602fffc3f39a7bd4cf4dc8eb2ae70)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeBackgroundColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeBackgroundColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__95b1293f5490a102aa21557fc699dede630e531cf93d33ba80d92e8d7a1ddc76)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d1fc83fbfb9811720f397ad3d174db45fba88a9cac10415244e9c8c63b3fd2f4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f06dfeb9f2786af47efd9bd6cc646ef77b4af74235a274280b85d96e048cff76)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeBackgroundColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeBackgroundColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeBackgroundColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d4d516f4ec1a19e453c61be4e95adcae37a8ddd177c77a9035ecf93bb9fe6651)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeBlur",
    jsii_struct_bases=[],
    name_mapping={"sigma": "sigma", "sigma_var": "sigmaVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeBlur:
    def __init__(
        self,
        *,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param sigma: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b22e9750327f6280e3d52e2bb0882accf7ce4b9afe7cbfdc9147ab75542210f4)
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeBlur(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeBlurList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeBlurList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b75c7ed3331986b6ccee4d2d56630b8ac9e7c54536004c8da06dfb7b04f385ec)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeBlurOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e8ad4cfd4ba8c2d8030ec8895a40f1d9f02cc63e804abc049a5e7ad4c075dfb2)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeBlurOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5332b91fac34a42e95ef69ecff186df675867294cf0b62d7c26e6cda2bb61511)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6acc0485209650757f87f25d87bf3d79ee75be6cd0d5f71dfc86dce8d5a95084)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ef20e066f2a9a56a4def6e6fe6a971fa96ba4248cd589ea012cf34c4f677ad45)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeBlur]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeBlur]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9072fad7a8e4d22ad5fcd47c6535258ef6d237d0bc502f8b358c5459db967f99)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeBlurOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeBlurOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0e6ab784a9a46830486152c634e76c3020336f086ce69860c7f42cf803d53b83)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c4c40c2e0291b539e9471eddb60e89f3014127d6db2bd6356e27199470f0e755)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__53491869de31627817a456ee0bd0fa20242f3bee66ee8febd83e1bb35ad84637)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeBlur]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeBlur]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeBlur]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__10e65177ae620182bd48a0983c931a0e2c3054ec8d72ece942d5a612dec08666)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeChromaKey",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_feather": "hueFeather",
        "hue_feather_var": "hueFeatherVar",
        "hue_tolerance": "hueTolerance",
        "hue_tolerance_var": "hueToleranceVar",
        "hue_var": "hueVar",
        "lightness_feather": "lightnessFeather",
        "lightness_feather_var": "lightnessFeatherVar",
        "lightness_tolerance": "lightnessTolerance",
        "lightness_tolerance_var": "lightnessToleranceVar",
        "saturation_feather": "saturationFeather",
        "saturation_feather_var": "saturationFeatherVar",
        "saturation_tolerance": "saturationTolerance",
        "saturation_tolerance_var": "saturationToleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeChromaKey:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_feather: typing.Optional[builtins.str] = None,
        hue_feather_var: typing.Optional[builtins.str] = None,
        hue_tolerance: typing.Optional[builtins.str] = None,
        hue_tolerance_var: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness_feather: typing.Optional[builtins.str] = None,
        lightness_feather_var: typing.Optional[builtins.str] = None,
        lightness_tolerance: typing.Optional[builtins.str] = None,
        lightness_tolerance_var: typing.Optional[builtins.str] = None,
        saturation_feather: typing.Optional[builtins.str] = None,
        saturation_feather_var: typing.Optional[builtins.str] = None,
        saturation_tolerance: typing.Optional[builtins.str] = None,
        saturation_tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_feather: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        :param hue_feather_var: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        :param hue_tolerance: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        :param hue_tolerance_var: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        :param hue_var: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness_feather: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        :param lightness_feather_var: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        :param lightness_tolerance: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        :param lightness_tolerance_var: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        :param saturation_feather: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        :param saturation_feather_var: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        :param saturation_tolerance: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        :param saturation_tolerance_var: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__28491b5f67ea0a2c2f019ff0da411fa18fd0df5bd750ff2846e089c11646aed1)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_feather", value=hue_feather, expected_type=type_hints["hue_feather"])
            check_type(argname="argument hue_feather_var", value=hue_feather_var, expected_type=type_hints["hue_feather_var"])
            check_type(argname="argument hue_tolerance", value=hue_tolerance, expected_type=type_hints["hue_tolerance"])
            check_type(argname="argument hue_tolerance_var", value=hue_tolerance_var, expected_type=type_hints["hue_tolerance_var"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness_feather", value=lightness_feather, expected_type=type_hints["lightness_feather"])
            check_type(argname="argument lightness_feather_var", value=lightness_feather_var, expected_type=type_hints["lightness_feather_var"])
            check_type(argname="argument lightness_tolerance", value=lightness_tolerance, expected_type=type_hints["lightness_tolerance"])
            check_type(argname="argument lightness_tolerance_var", value=lightness_tolerance_var, expected_type=type_hints["lightness_tolerance_var"])
            check_type(argname="argument saturation_feather", value=saturation_feather, expected_type=type_hints["saturation_feather"])
            check_type(argname="argument saturation_feather_var", value=saturation_feather_var, expected_type=type_hints["saturation_feather_var"])
            check_type(argname="argument saturation_tolerance", value=saturation_tolerance, expected_type=type_hints["saturation_tolerance"])
            check_type(argname="argument saturation_tolerance_var", value=saturation_tolerance_var, expected_type=type_hints["saturation_tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_feather is not None:
            self._values["hue_feather"] = hue_feather
        if hue_feather_var is not None:
            self._values["hue_feather_var"] = hue_feather_var
        if hue_tolerance is not None:
            self._values["hue_tolerance"] = hue_tolerance
        if hue_tolerance_var is not None:
            self._values["hue_tolerance_var"] = hue_tolerance_var
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness_feather is not None:
            self._values["lightness_feather"] = lightness_feather
        if lightness_feather_var is not None:
            self._values["lightness_feather_var"] = lightness_feather_var
        if lightness_tolerance is not None:
            self._values["lightness_tolerance"] = lightness_tolerance
        if lightness_tolerance_var is not None:
            self._values["lightness_tolerance_var"] = lightness_tolerance_var
        if saturation_feather is not None:
            self._values["saturation_feather"] = saturation_feather
        if saturation_feather_var is not None:
            self._values["saturation_feather_var"] = saturation_feather_var
        if saturation_tolerance is not None:
            self._values["saturation_tolerance"] = saturation_tolerance
        if saturation_tolerance_var is not None:
            self._values["saturation_tolerance_var"] = saturation_tolerance_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        '''
        result = self._values.get("hue_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        '''
        result = self._values.get("hue_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        '''
        result = self._values.get("hue_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        '''
        result = self._values.get("hue_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        '''
        result = self._values.get("lightness_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        '''
        result = self._values.get("lightness_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        '''
        result = self._values.get("lightness_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        '''
        result = self._values.get("lightness_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        '''
        result = self._values.get("saturation_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        '''
        result = self._values.get("saturation_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        '''
        result = self._values.get("saturation_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        result = self._values.get("saturation_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeChromaKey(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeChromaKeyList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeChromaKeyList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9fafd1f8321d6a6c831c9b34c0bda85f45d7dd5c7e6762ee2b36a31d6036ce11)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeChromaKeyOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0d417416a4b840ff0f9104d4e4a03353e01fe2fb732adc311d4127068039ce93)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeChromaKeyOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__639b8dfe3291d8e59a526cc2bd8e3660579fb86311577716089ab4f97891d61b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e7612eb1f86d0b98e8a90b86eca07897409ab09d05b809f4199cb68d7cb47f5a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d6f696faaebeef62a82ef51971633575afc039674eee3b5881c4c360021fc92)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeChromaKey]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeChromaKey]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e8820d208800114c8e471eeb98a4b6062dfc521cd202f1219ab7a5ce31edd484)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeChromaKeyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeChromaKeyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e444bef107a4e8792472baaa75adaad5de83f7212fec65f0092ec4be6e814bd6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueFeather")
    def reset_hue_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeather", []))

    @jsii.member(jsii_name="resetHueFeatherVar")
    def reset_hue_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeatherVar", []))

    @jsii.member(jsii_name="resetHueTolerance")
    def reset_hue_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueTolerance", []))

    @jsii.member(jsii_name="resetHueToleranceVar")
    def reset_hue_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueToleranceVar", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightnessFeather")
    def reset_lightness_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeather", []))

    @jsii.member(jsii_name="resetLightnessFeatherVar")
    def reset_lightness_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeatherVar", []))

    @jsii.member(jsii_name="resetLightnessTolerance")
    def reset_lightness_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessTolerance", []))

    @jsii.member(jsii_name="resetLightnessToleranceVar")
    def reset_lightness_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessToleranceVar", []))

    @jsii.member(jsii_name="resetSaturationFeather")
    def reset_saturation_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeather", []))

    @jsii.member(jsii_name="resetSaturationFeatherVar")
    def reset_saturation_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeatherVar", []))

    @jsii.member(jsii_name="resetSaturationTolerance")
    def reset_saturation_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationTolerance", []))

    @jsii.member(jsii_name="resetSaturationToleranceVar")
    def reset_saturation_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherInput")
    def hue_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVarInput")
    def hue_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceInput")
    def hue_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVarInput")
    def hue_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherInput")
    def lightness_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVarInput")
    def lightness_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceInput")
    def lightness_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVarInput")
    def lightness_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherInput")
    def saturation_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVarInput")
    def saturation_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceInput")
    def saturation_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVarInput")
    def saturation_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d3f781450be1e2f4567f956e2e0af31342c84e322850992633cf9f71443decfc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeather")
    def hue_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeather"))

    @hue_feather.setter
    def hue_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__002cbc086387b4e4c47f95a6a80cc2dd585d5f76316b6b8b6e87a1512d35dcba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeather", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVar")
    def hue_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeatherVar"))

    @hue_feather_var.setter
    def hue_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7dc1254493cead9803191b41be2abef0a257c590e82346aa6f518d68f94779c3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueTolerance")
    def hue_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueTolerance"))

    @hue_tolerance.setter
    def hue_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9792e6f0497b17b266d1fe85806021c263a99579be53524c847d547c16a51d58)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVar")
    def hue_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueToleranceVar"))

    @hue_tolerance_var.setter
    def hue_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af4c30957a29a03bf2a8b2d1edc2839788f41be06dfe17a4f5eaa2ff5c652390)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bae01e24a2cf2b0bdcc6276e477eb672e53ad94ecabec0fe332a2fd8efe1cf0d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeather")
    def lightness_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeather"))

    @lightness_feather.setter
    def lightness_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d05e83d4c68c641892e7d50380d8d35ca36e9b3eb243ad5cf35d606b06d3522f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeather", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVar")
    def lightness_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeatherVar"))

    @lightness_feather_var.setter
    def lightness_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d5c352775e744f58932b8151b79ffaa1823bcf0fbef7c10eb938dc088e307975)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessTolerance")
    def lightness_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessTolerance"))

    @lightness_tolerance.setter
    def lightness_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8bf12f936b3302908959fe0eb668ed5c65316223901c2f8ef38897403eb497b7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVar")
    def lightness_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessToleranceVar"))

    @lightness_tolerance_var.setter
    def lightness_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__976c770d7e6f451a0152ce316b9a03adacd51b2a8254f72bf055a26d8c512792)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeather")
    def saturation_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeather"))

    @saturation_feather.setter
    def saturation_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b0386d6e6182afdcf926f02fc2c6d2dddc15dfc91db8cc12e6f63163d99954e6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeather", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVar")
    def saturation_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeatherVar"))

    @saturation_feather_var.setter
    def saturation_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1b38452ee44afcc935e13fe562bdafd596c1234ce0885617288300e834b01eb2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationTolerance")
    def saturation_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationTolerance"))

    @saturation_tolerance.setter
    def saturation_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e30df59994725aa200aa2e1109fa84fdc707131df7ee48de22ac871d403c986c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVar")
    def saturation_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationToleranceVar"))

    @saturation_tolerance_var.setter
    def saturation_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5d0f5233c542baad23313d485a02343294adb99672bea5de933e78d266fc6c16)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeChromaKey]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeChromaKey]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeChromaKey]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e562e9273865e944e804114ec6d5a0d8732f97991f915f271dd6005e63faea11)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeComposite",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "placement": "placement",
        "placement_var": "placementVar",
        "scale": "scale",
        "scale_dimension": "scaleDimension",
        "scale_dimension_var": "scaleDimensionVar",
        "scale_var": "scaleVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeComposite:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        placement: typing.Optional[builtins.str] = None,
        placement_var: typing.Optional[builtins.str] = None,
        scale: typing.Optional[builtins.str] = None,
        scale_dimension: typing.Optional[builtins.str] = None,
        scale_dimension_var: typing.Optional[builtins.str] = None,
        scale_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param placement: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        :param placement_var: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        :param scale: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param scale_dimension: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        :param scale_dimension_var: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        :param scale_var: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        :param x_position: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e26bc6e7739df43bdec2a54b56c45265c921949c545bbe35f90871d4328d66d2)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument placement", value=placement, expected_type=type_hints["placement"])
            check_type(argname="argument placement_var", value=placement_var, expected_type=type_hints["placement_var"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument scale_dimension", value=scale_dimension, expected_type=type_hints["scale_dimension"])
            check_type(argname="argument scale_dimension_var", value=scale_dimension_var, expected_type=type_hints["scale_dimension_var"])
            check_type(argname="argument scale_var", value=scale_var, expected_type=type_hints["scale_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if placement is not None:
            self._values["placement"] = placement
        if placement_var is not None:
            self._values["placement_var"] = placement_var
        if scale is not None:
            self._values["scale"] = scale
        if scale_dimension is not None:
            self._values["scale_dimension"] = scale_dimension
        if scale_dimension_var is not None:
            self._values["scale_dimension_var"] = scale_dimension_var
        if scale_var is not None:
            self._values["scale_var"] = scale_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        '''
        result = self._values.get("placement")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement_var(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        '''
        result = self._values.get("placement_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        '''
        result = self._values.get("scale_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        '''
        result = self._values.get("scale_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        '''
        result = self._values.get("scale_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeComposite(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImage",
    jsii_struct_bases=[],
    name_mapping={
        "box_image": "boxImage",
        "circle_image": "circleImage",
        "text_image": "textImage",
        "url_image": "urlImage",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImage:
    def __init__(
        self,
        *,
        box_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageBoxImage", typing.Dict[builtins.str, typing.Any]]]]] = None,
        circle_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageCircleImage", typing.Dict[builtins.str, typing.Any]]]]] = None,
        text_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageTextImage", typing.Dict[builtins.str, typing.Any]]]]] = None,
        url_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageUrlImage", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param box_image: box_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#box_image DataAkamaiImagingPolicyImage#box_image}
        :param circle_image: circle_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#circle_image DataAkamaiImagingPolicyImage#circle_image}
        :param text_image: text_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text_image DataAkamaiImagingPolicyImage#text_image}
        :param url_image: url_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url_image DataAkamaiImagingPolicyImage#url_image}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f3524c0f6113bd2f2edb0bad0b8d6b227da6986d68e6d886e9bf829dd266ddad)
            check_type(argname="argument box_image", value=box_image, expected_type=type_hints["box_image"])
            check_type(argname="argument circle_image", value=circle_image, expected_type=type_hints["circle_image"])
            check_type(argname="argument text_image", value=text_image, expected_type=type_hints["text_image"])
            check_type(argname="argument url_image", value=url_image, expected_type=type_hints["url_image"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if box_image is not None:
            self._values["box_image"] = box_image
        if circle_image is not None:
            self._values["circle_image"] = circle_image
        if text_image is not None:
            self._values["text_image"] = text_image
        if url_image is not None:
            self._values["url_image"] = url_image

    @builtins.property
    def box_image(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageBoxImage"]]]:
        '''box_image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#box_image DataAkamaiImagingPolicyImage#box_image}
        '''
        result = self._values.get("box_image")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageBoxImage"]]], result)

    @builtins.property
    def circle_image(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageCircleImage"]]]:
        '''circle_image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#circle_image DataAkamaiImagingPolicyImage#circle_image}
        '''
        result = self._values.get("circle_image")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageCircleImage"]]], result)

    @builtins.property
    def text_image(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageTextImage"]]]:
        '''text_image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text_image DataAkamaiImagingPolicyImage#text_image}
        '''
        result = self._values.get("text_image")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageTextImage"]]], result)

    @builtins.property
    def url_image(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageUrlImage"]]]:
        '''url_image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url_image DataAkamaiImagingPolicyImage#url_image}
        '''
        result = self._values.get("url_image")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageUrlImage"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageBoxImage",
    jsii_struct_bases=[],
    name_mapping={
        "color": "color",
        "color_var": "colorVar",
        "height": "height",
        "height_var": "heightVar",
        "transformation": "transformation",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageBoxImage:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        transformation: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageBoxImageTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The fill color of the box, not the edge of the box. The API supports hexadecimal representation and CSS hexadecimal color values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The fill color of the box, not the edge of the box. The API supports hexadecimal representation and CSS hexadecimal color values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        :param height: The height of the box in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height of the box in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param transformation: transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        :param width: The width of the box in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width of the box in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(transformation, dict):
            transformation = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageBoxImageTransformation(**transformation)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ea5a4fb1044d9d24673e27cafde83c0b720cc010bd68529f10057001b61bb1a)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument transformation", value=transformation, expected_type=type_hints["transformation"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if transformation is not None:
            self._values["transformation"] = transformation
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The fill color of the box, not the edge of the box.

        The API supports hexadecimal representation and CSS hexadecimal color values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The fill color of the box, not the edge of the box.

        The API supports hexadecimal representation and CSS hexadecimal color values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height of the box in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height of the box in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def transformation(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageBoxImageTransformation"]:
        '''transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        '''
        result = self._values.get("transformation")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageBoxImageTransformation"], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width of the box in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width of the box in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageBoxImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageBoxImageList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageBoxImageList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e76c1af611cf6ee306f8342702a04ef98f9120dc109291e0ce3a939bff6f1411)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageBoxImageOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1abbbc082b58715eef11b22ca16de3f13aa99c3237c9fc1d656bd5dde9ccc547)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageBoxImageOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6d3f0e356999e2d8b38a97838b34ff8f962f3d91e0ba13ab85ebf9feb87a4cb8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aef52906e83c31f8a8398ad4ecef72966cdfe3b37ea15ae480924a8f88d339b8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__87072dcde45e56b247217ddfe6d1d59983519f40a1733d14a60ff6e741d6646a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageBoxImage]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageBoxImage]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageBoxImage]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__623660262c4635e8837a77849cb574983617c72fb503156761c21f503532cdd8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageBoxImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageBoxImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__84141c54db4458df8a62499c6d67c3480912809c1137b140210fabf51a476bfe)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformation")
    def put_transformation(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageBoxImageTransformation()

        return typing.cast(None, jsii.invoke(self, "putTransformation", [value]))

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetTransformation")
    def reset_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformation", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="transformation")
    def transformation(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageBoxImageTransformationOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageBoxImageTransformationOutputReference", jsii.get(self, "transformation"))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="transformationInput")
    def transformation_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageBoxImageTransformation"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageBoxImageTransformation"], jsii.get(self, "transformationInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__01e419a0c9e71d95572843959ba8a072a306bd230cdedfaeb498bf858d4c778e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9f6ba68f1409c6b86bc05ef8579ea7baf69792e73a491fa97f2a3d207e9a2a51)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8acf19c47a60130d7a0f08ad8b6b45df2d526568837819dcb20dea073f31f567)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8ca8dce8ef16b6d4c02d079f817a66357447757a3f40cedfd792645a61a3f8ef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__806b62225bf7df108e8f502f353eed381ef9582683df16ea4ced3d4aca3f306a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9765600dda64568c687cffead203c7d35655072b98cebefa53e7b8d05137e48c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageBoxImage]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageBoxImage]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageBoxImage]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__da80fa3498693d599d0edf4b24e74a40d8bf79f0834dc2318f71383f211e4245)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageBoxImageTransformation",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageBoxImageTransformation:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageBoxImageTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageBoxImageTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageBoxImageTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2cf95b2124df48e8e5f7d24ce1244b62b58fc3828e5f0e5fafa6451a62a4b45f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageBoxImageTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageBoxImageTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageBoxImageTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d251e40aac7664a4c24f5d6a6c63e6554ac549fa0cb9d586b2834cb66647e3c0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageCircleImage",
    jsii_struct_bases=[],
    name_mapping={
        "color": "color",
        "color_var": "colorVar",
        "diameter": "diameter",
        "diameter_var": "diameterVar",
        "transformation": "transformation",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageCircleImage:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
        diameter: typing.Optional[builtins.str] = None,
        diameter_var: typing.Optional[builtins.str] = None,
        transformation: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageCircleImageTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The fill color of the circle. The API supports hexadecimal representation and CSS hexadecimal color values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The fill color of the circle. The API supports hexadecimal representation and CSS hexadecimal color values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        :param diameter: The diameter of the circle. The diameter will be the width and the height of the image in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#diameter DataAkamaiImagingPolicyImage#diameter}
        :param diameter_var: The diameter of the circle. The diameter will be the width and the height of the image in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#diameter_var DataAkamaiImagingPolicyImage#diameter_var}
        :param transformation: transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        :param width: The width of the box in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width of the box in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(transformation, dict):
            transformation = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageCircleImageTransformation(**transformation)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ceb65534122f7f3ca16c264112495db663fe5e7dafa2167f10868a8383a14714)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
            check_type(argname="argument diameter", value=diameter, expected_type=type_hints["diameter"])
            check_type(argname="argument diameter_var", value=diameter_var, expected_type=type_hints["diameter_var"])
            check_type(argname="argument transformation", value=transformation, expected_type=type_hints["transformation"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var
        if diameter is not None:
            self._values["diameter"] = diameter
        if diameter_var is not None:
            self._values["diameter_var"] = diameter_var
        if transformation is not None:
            self._values["transformation"] = transformation
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The fill color of the circle. The API supports hexadecimal representation and CSS hexadecimal color values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The fill color of the circle. The API supports hexadecimal representation and CSS hexadecimal color values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def diameter(self) -> typing.Optional[builtins.str]:
        '''The diameter of the circle. The diameter will be the width and the height of the image in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#diameter DataAkamaiImagingPolicyImage#diameter}
        '''
        result = self._values.get("diameter")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def diameter_var(self) -> typing.Optional[builtins.str]:
        '''The diameter of the circle. The diameter will be the width and the height of the image in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#diameter_var DataAkamaiImagingPolicyImage#diameter_var}
        '''
        result = self._values.get("diameter_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def transformation(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageCircleImageTransformation"]:
        '''transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        '''
        result = self._values.get("transformation")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageCircleImageTransformation"], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width of the box in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width of the box in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageCircleImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageCircleImageList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageCircleImageList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__32ae8cd0c5d246a5fbccc03256244ffb97781815002631cb7af8b399fbee412d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageCircleImageOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2e45a23863ba3b78a48575b21c4f97af9e23f469dcc67bd02bdc5430b9c39bf2)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageCircleImageOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d3f0c6fdfe8b99e5ea83ca8998fa00782f8fa5fad9279e50ed5824cf26e369a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ac2c4b97e377404ad941220e4bc9b0e090fa28f8c12338724f72b1f79a12316)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e9d8058afc24a5fb0838409b973c9a8974c3936f80410a6b7ba01c7e6b914314)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageCircleImage]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageCircleImage]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageCircleImage]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2c724cd35ab0f41f675c3922360c2925929dff0003872e7d7f485eda1ce56908)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageCircleImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageCircleImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7f67a5fccd54bdcde6b0293ff5794ecd1d89e5e3e8ed7fab12bb0dc9bd1df213)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformation")
    def put_transformation(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageCircleImageTransformation()

        return typing.cast(None, jsii.invoke(self, "putTransformation", [value]))

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @jsii.member(jsii_name="resetDiameter")
    def reset_diameter(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDiameter", []))

    @jsii.member(jsii_name="resetDiameterVar")
    def reset_diameter_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDiameterVar", []))

    @jsii.member(jsii_name="resetTransformation")
    def reset_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformation", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="transformation")
    def transformation(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageCircleImageTransformationOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageCircleImageTransformationOutputReference", jsii.get(self, "transformation"))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="diameterInput")
    def diameter_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "diameterInput"))

    @builtins.property
    @jsii.member(jsii_name="diameterVarInput")
    def diameter_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "diameterVarInput"))

    @builtins.property
    @jsii.member(jsii_name="transformationInput")
    def transformation_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageCircleImageTransformation"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageCircleImageTransformation"], jsii.get(self, "transformationInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__58090bd1068c7f8309cd9401488ededc6aaf41d2049601f213041e6fd227e87b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__270e1c1f5d32a3fa5c38dcbc51db4ae5b93361869157a26676fef9445926b220)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="diameter")
    def diameter(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "diameter"))

    @diameter.setter
    def diameter(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__04ea756cda52152723da7dd1c3f32381a6c931824a2705c038e425f03560066d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "diameter", value)

    @builtins.property
    @jsii.member(jsii_name="diameterVar")
    def diameter_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "diameterVar"))

    @diameter_var.setter
    def diameter_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cab2d9f9b5864a7838c0b16524109da685e7580d7f8aad59ffea644fd7b9019d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "diameterVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2e0f163782293fce88bb4cabfd658d19c8d624257a0ac2c594b464696a3dbbb0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c38c4c5e82014750019cafc4fe111b6fc41985c5395a591e759fc0a9d200ff35)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageCircleImage]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageCircleImage]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageCircleImage]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dcc4f88173b2791466f38d5df1ea3da132d1c8c9b91e32217dd10b080ad7bb3d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageCircleImageTransformation",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageCircleImageTransformation:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageCircleImageTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageCircleImageTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageCircleImageTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5afebc95e62e74d3017d6304e638e1504d533bfa3b464e095ba8a94fb78c57ea)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageCircleImageTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageCircleImageTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageCircleImageTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__27e40e68fae9724a3c46f67485ec16ff6da2a296c14ce680ea900e054d925bf9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__354b1ec199909f10cefab51e41a7390e0ccee36cd72716030c2297e1ec2d9358)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putBoxImage")
    def put_box_image(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageBoxImage, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__15e4ba44590446ab15a79f4fd294862494b65d34bf120fd895a2bf871df4e6c1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBoxImage", [value]))

    @jsii.member(jsii_name="putCircleImage")
    def put_circle_image(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageCircleImage, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dc9074da98c93be23288bbbe33a67333f5dffc37b4e70fe580449be7e0e75f71)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCircleImage", [value]))

    @jsii.member(jsii_name="putTextImage")
    def put_text_image(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageTextImage", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a0cfe10673983aa1e6ba8863967eae845af64b8aea31cd065199b22a4b0614cc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTextImage", [value]))

    @jsii.member(jsii_name="putUrlImage")
    def put_url_image(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageUrlImage", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e6bfc04b07e8ac4c208415004bdd95bf61cd214f8c168162f98074d4f7d80935)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putUrlImage", [value]))

    @jsii.member(jsii_name="resetBoxImage")
    def reset_box_image(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBoxImage", []))

    @jsii.member(jsii_name="resetCircleImage")
    def reset_circle_image(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCircleImage", []))

    @jsii.member(jsii_name="resetTextImage")
    def reset_text_image(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTextImage", []))

    @jsii.member(jsii_name="resetUrlImage")
    def reset_url_image(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUrlImage", []))

    @builtins.property
    @jsii.member(jsii_name="boxImage")
    def box_image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageBoxImageList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageBoxImageList, jsii.get(self, "boxImage"))

    @builtins.property
    @jsii.member(jsii_name="circleImage")
    def circle_image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageCircleImageList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageCircleImageList, jsii.get(self, "circleImage"))

    @builtins.property
    @jsii.member(jsii_name="textImage")
    def text_image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageTextImageList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageTextImageList", jsii.get(self, "textImage"))

    @builtins.property
    @jsii.member(jsii_name="urlImage")
    def url_image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageUrlImageList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageUrlImageList", jsii.get(self, "urlImage"))

    @builtins.property
    @jsii.member(jsii_name="boxImageInput")
    def box_image_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageBoxImage]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageBoxImage]]], jsii.get(self, "boxImageInput"))

    @builtins.property
    @jsii.member(jsii_name="circleImageInput")
    def circle_image_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageCircleImage]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageCircleImage]]], jsii.get(self, "circleImageInput"))

    @builtins.property
    @jsii.member(jsii_name="textImageInput")
    def text_image_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageTextImage"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageTextImage"]]], jsii.get(self, "textImageInput"))

    @builtins.property
    @jsii.member(jsii_name="urlImageInput")
    def url_image_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageUrlImage"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageUrlImage"]]], jsii.get(self, "urlImageInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a9671962c727e76b0989a1b40e25564fdf00b64b6f09765753cea18a9d87af56)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageTextImage",
    jsii_struct_bases=[],
    name_mapping={
        "fill": "fill",
        "fill_var": "fillVar",
        "size": "size",
        "size_var": "sizeVar",
        "stroke": "stroke",
        "stroke_size": "strokeSize",
        "stroke_size_var": "strokeSizeVar",
        "stroke_var": "strokeVar",
        "text": "text",
        "text_var": "textVar",
        "transformation": "transformation",
        "typeface": "typeface",
        "typeface_var": "typefaceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageTextImage:
    def __init__(
        self,
        *,
        fill: typing.Optional[builtins.str] = None,
        fill_var: typing.Optional[builtins.str] = None,
        size: typing.Optional[builtins.str] = None,
        size_var: typing.Optional[builtins.str] = None,
        stroke: typing.Optional[builtins.str] = None,
        stroke_size: typing.Optional[builtins.str] = None,
        stroke_size_var: typing.Optional[builtins.str] = None,
        stroke_var: typing.Optional[builtins.str] = None,
        text: typing.Optional[builtins.str] = None,
        text_var: typing.Optional[builtins.str] = None,
        transformation: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageTextImageTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        typeface: typing.Optional[builtins.str] = None,
        typeface_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fill: The main fill color of the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill DataAkamaiImagingPolicyImage#fill}
        :param fill_var: The main fill color of the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_var DataAkamaiImagingPolicyImage#fill_var}
        :param size: The size in pixels to render the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#size DataAkamaiImagingPolicyImage#size}
        :param size_var: The size in pixels to render the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#size_var DataAkamaiImagingPolicyImage#size_var}
        :param stroke: The color for the outline of the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke DataAkamaiImagingPolicyImage#stroke}
        :param stroke_size: The thickness in points for the outline of the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_size DataAkamaiImagingPolicyImage#stroke_size}
        :param stroke_size_var: The thickness in points for the outline of the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_size_var DataAkamaiImagingPolicyImage#stroke_size_var}
        :param stroke_var: The color for the outline of the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_var DataAkamaiImagingPolicyImage#stroke_var}
        :param text: The line of text to render. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text DataAkamaiImagingPolicyImage#text}
        :param text_var: The line of text to render. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text_var DataAkamaiImagingPolicyImage#text_var}
        :param transformation: transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        :param typeface: The font family to apply to the text image. This may be a URL to a TrueType or WOFF (v1) typeface, or a string that refers to one of the standard built-in browser fonts. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#typeface DataAkamaiImagingPolicyImage#typeface}
        :param typeface_var: The font family to apply to the text image. This may be a URL to a TrueType or WOFF (v1) typeface, or a string that refers to one of the standard built-in browser fonts. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#typeface_var DataAkamaiImagingPolicyImage#typeface_var}
        '''
        if isinstance(transformation, dict):
            transformation = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageTextImageTransformation(**transformation)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6da12ea36e00ce71655a76db43983a3988a4db378de43269d5ecbe793c3b9f97)
            check_type(argname="argument fill", value=fill, expected_type=type_hints["fill"])
            check_type(argname="argument fill_var", value=fill_var, expected_type=type_hints["fill_var"])
            check_type(argname="argument size", value=size, expected_type=type_hints["size"])
            check_type(argname="argument size_var", value=size_var, expected_type=type_hints["size_var"])
            check_type(argname="argument stroke", value=stroke, expected_type=type_hints["stroke"])
            check_type(argname="argument stroke_size", value=stroke_size, expected_type=type_hints["stroke_size"])
            check_type(argname="argument stroke_size_var", value=stroke_size_var, expected_type=type_hints["stroke_size_var"])
            check_type(argname="argument stroke_var", value=stroke_var, expected_type=type_hints["stroke_var"])
            check_type(argname="argument text", value=text, expected_type=type_hints["text"])
            check_type(argname="argument text_var", value=text_var, expected_type=type_hints["text_var"])
            check_type(argname="argument transformation", value=transformation, expected_type=type_hints["transformation"])
            check_type(argname="argument typeface", value=typeface, expected_type=type_hints["typeface"])
            check_type(argname="argument typeface_var", value=typeface_var, expected_type=type_hints["typeface_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fill is not None:
            self._values["fill"] = fill
        if fill_var is not None:
            self._values["fill_var"] = fill_var
        if size is not None:
            self._values["size"] = size
        if size_var is not None:
            self._values["size_var"] = size_var
        if stroke is not None:
            self._values["stroke"] = stroke
        if stroke_size is not None:
            self._values["stroke_size"] = stroke_size
        if stroke_size_var is not None:
            self._values["stroke_size_var"] = stroke_size_var
        if stroke_var is not None:
            self._values["stroke_var"] = stroke_var
        if text is not None:
            self._values["text"] = text
        if text_var is not None:
            self._values["text_var"] = text_var
        if transformation is not None:
            self._values["transformation"] = transformation
        if typeface is not None:
            self._values["typeface"] = typeface
        if typeface_var is not None:
            self._values["typeface_var"] = typeface_var

    @builtins.property
    def fill(self) -> typing.Optional[builtins.str]:
        '''The main fill color of the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill DataAkamaiImagingPolicyImage#fill}
        '''
        result = self._values.get("fill")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fill_var(self) -> typing.Optional[builtins.str]:
        '''The main fill color of the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_var DataAkamaiImagingPolicyImage#fill_var}
        '''
        result = self._values.get("fill_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def size(self) -> typing.Optional[builtins.str]:
        '''The size in pixels to render the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#size DataAkamaiImagingPolicyImage#size}
        '''
        result = self._values.get("size")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def size_var(self) -> typing.Optional[builtins.str]:
        '''The size in pixels to render the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#size_var DataAkamaiImagingPolicyImage#size_var}
        '''
        result = self._values.get("size_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def stroke(self) -> typing.Optional[builtins.str]:
        '''The color for the outline of the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke DataAkamaiImagingPolicyImage#stroke}
        '''
        result = self._values.get("stroke")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def stroke_size(self) -> typing.Optional[builtins.str]:
        '''The thickness in points for the outline of the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_size DataAkamaiImagingPolicyImage#stroke_size}
        '''
        result = self._values.get("stroke_size")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def stroke_size_var(self) -> typing.Optional[builtins.str]:
        '''The thickness in points for the outline of the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_size_var DataAkamaiImagingPolicyImage#stroke_size_var}
        '''
        result = self._values.get("stroke_size_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def stroke_var(self) -> typing.Optional[builtins.str]:
        '''The color for the outline of the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_var DataAkamaiImagingPolicyImage#stroke_var}
        '''
        result = self._values.get("stroke_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def text(self) -> typing.Optional[builtins.str]:
        '''The line of text to render.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text DataAkamaiImagingPolicyImage#text}
        '''
        result = self._values.get("text")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def text_var(self) -> typing.Optional[builtins.str]:
        '''The line of text to render.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text_var DataAkamaiImagingPolicyImage#text_var}
        '''
        result = self._values.get("text_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def transformation(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageTextImageTransformation"]:
        '''transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        '''
        result = self._values.get("transformation")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageTextImageTransformation"], result)

    @builtins.property
    def typeface(self) -> typing.Optional[builtins.str]:
        '''The font family to apply to the text image.

        This may be a URL to a TrueType or WOFF (v1) typeface, or a string that refers to one of the standard built-in browser fonts.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#typeface DataAkamaiImagingPolicyImage#typeface}
        '''
        result = self._values.get("typeface")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def typeface_var(self) -> typing.Optional[builtins.str]:
        '''The font family to apply to the text image.

        This may be a URL to a TrueType or WOFF (v1) typeface, or a string that refers to one of the standard built-in browser fonts.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#typeface_var DataAkamaiImagingPolicyImage#typeface_var}
        '''
        result = self._values.get("typeface_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageTextImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageTextImageList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageTextImageList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a1f338c113b8048839df9154f564cc88a6362d0bff12e442d31e97ae14c9ff1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageTextImageOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cf1b21589c3e2804c0b8e3362f8a572cf6aab2fe0816746ccaa603c2ca6bf51f)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageTextImageOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ff0f52e9bcd6f316365cec4ee397ebecd04b7e1e3d3a884579ce4b99295c947e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e14c2befe426a02130983775624b3483a4714365a94592d7e3b23037ba6f2cfd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df82421c52cb4801722e63ec2dbcfad78074716e199eee2d12599281eb5cfcd4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageTextImage]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageTextImage]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageTextImage]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fd12343b60822497b05e8463a9cfaebe054967b315f007bd04953feab2b4b98e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageTextImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageTextImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__82b3e7b19b1b81ef1eb4617ab184ebe6ee2555a91f89b5a1a8833182b72a1487)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformation")
    def put_transformation(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageTextImageTransformation()

        return typing.cast(None, jsii.invoke(self, "putTransformation", [value]))

    @jsii.member(jsii_name="resetFill")
    def reset_fill(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFill", []))

    @jsii.member(jsii_name="resetFillVar")
    def reset_fill_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFillVar", []))

    @jsii.member(jsii_name="resetSize")
    def reset_size(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSize", []))

    @jsii.member(jsii_name="resetSizeVar")
    def reset_size_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSizeVar", []))

    @jsii.member(jsii_name="resetStroke")
    def reset_stroke(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStroke", []))

    @jsii.member(jsii_name="resetStrokeSize")
    def reset_stroke_size(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStrokeSize", []))

    @jsii.member(jsii_name="resetStrokeSizeVar")
    def reset_stroke_size_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStrokeSizeVar", []))

    @jsii.member(jsii_name="resetStrokeVar")
    def reset_stroke_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStrokeVar", []))

    @jsii.member(jsii_name="resetText")
    def reset_text(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetText", []))

    @jsii.member(jsii_name="resetTextVar")
    def reset_text_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTextVar", []))

    @jsii.member(jsii_name="resetTransformation")
    def reset_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformation", []))

    @jsii.member(jsii_name="resetTypeface")
    def reset_typeface(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeface", []))

    @jsii.member(jsii_name="resetTypefaceVar")
    def reset_typeface_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypefaceVar", []))

    @builtins.property
    @jsii.member(jsii_name="transformation")
    def transformation(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageTextImageTransformationOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageTextImageTransformationOutputReference", jsii.get(self, "transformation"))

    @builtins.property
    @jsii.member(jsii_name="fillInput")
    def fill_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fillInput"))

    @builtins.property
    @jsii.member(jsii_name="fillVarInput")
    def fill_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fillVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sizeInput")
    def size_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sizeInput"))

    @builtins.property
    @jsii.member(jsii_name="sizeVarInput")
    def size_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sizeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="strokeInput")
    def stroke_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "strokeInput"))

    @builtins.property
    @jsii.member(jsii_name="strokeSizeInput")
    def stroke_size_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "strokeSizeInput"))

    @builtins.property
    @jsii.member(jsii_name="strokeSizeVarInput")
    def stroke_size_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "strokeSizeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="strokeVarInput")
    def stroke_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "strokeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="textInput")
    def text_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "textInput"))

    @builtins.property
    @jsii.member(jsii_name="textVarInput")
    def text_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "textVarInput"))

    @builtins.property
    @jsii.member(jsii_name="transformationInput")
    def transformation_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageTextImageTransformation"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageTextImageTransformation"], jsii.get(self, "transformationInput"))

    @builtins.property
    @jsii.member(jsii_name="typefaceInput")
    def typeface_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typefaceInput"))

    @builtins.property
    @jsii.member(jsii_name="typefaceVarInput")
    def typeface_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typefaceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="fill")
    def fill(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fill"))

    @fill.setter
    def fill(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc06acd3a7a557c9b37cf3ce88360f58d242e63a93c9d66769aa11d85b991f9d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fill", value)

    @builtins.property
    @jsii.member(jsii_name="fillVar")
    def fill_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fillVar"))

    @fill_var.setter
    def fill_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__addb4920c1c17a6a36610cb14222e76fb6c970db6bb2d663adc194e2c766c9c7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fillVar", value)

    @builtins.property
    @jsii.member(jsii_name="size")
    def size(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "size"))

    @size.setter
    def size(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__37b623cf27aaa99745cb6efdebde3e2f73a48fa6c911827c9fd8b3baae8f5e4c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "size", value)

    @builtins.property
    @jsii.member(jsii_name="sizeVar")
    def size_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sizeVar"))

    @size_var.setter
    def size_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__831869ae22720a0cc3ae861709bd2474af6df80d4110bec3f883aaa3d63447f5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sizeVar", value)

    @builtins.property
    @jsii.member(jsii_name="stroke")
    def stroke(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "stroke"))

    @stroke.setter
    def stroke(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3dd93fb2048e93d6586a592a38c9c3a0a1e180df86693e02bb3608fe57e5863e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "stroke", value)

    @builtins.property
    @jsii.member(jsii_name="strokeSize")
    def stroke_size(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "strokeSize"))

    @stroke_size.setter
    def stroke_size(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__311ecdb8a28707c76397dba7fcf0d9cc83e25344b61bafd12b6f70e277258601)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "strokeSize", value)

    @builtins.property
    @jsii.member(jsii_name="strokeSizeVar")
    def stroke_size_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "strokeSizeVar"))

    @stroke_size_var.setter
    def stroke_size_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__de3b175d960504dfb229f2835e592a790ab7b7dab2314720b1f6782ca31fad75)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "strokeSizeVar", value)

    @builtins.property
    @jsii.member(jsii_name="strokeVar")
    def stroke_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "strokeVar"))

    @stroke_var.setter
    def stroke_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b0ab21f4b528794d0d269c5953aaaf3ef4701e856abd660af870dabc0d4bd339)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "strokeVar", value)

    @builtins.property
    @jsii.member(jsii_name="text")
    def text(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "text"))

    @text.setter
    def text(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__015b88c873c0b9e70cf4da06c3a4467549aab2b00868c38fdb9087a9b1059475)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "text", value)

    @builtins.property
    @jsii.member(jsii_name="textVar")
    def text_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "textVar"))

    @text_var.setter
    def text_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__91a7b5a88550955f83c25c9a08ceb8f53c1d036c72b801d30b6b79717d629d15)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "textVar", value)

    @builtins.property
    @jsii.member(jsii_name="typeface")
    def typeface(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeface"))

    @typeface.setter
    def typeface(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6ee8449b0569a2fd7a489df591c019e649e6edd7c933501834457e31eff9d775)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeface", value)

    @builtins.property
    @jsii.member(jsii_name="typefaceVar")
    def typeface_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typefaceVar"))

    @typeface_var.setter
    def typeface_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5223453a7a374748a65b26b365369093c5e11d3a70b77a932014c24a55336bf5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typefaceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageTextImage]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageTextImage]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageTextImage]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__745891320379e666a50c56927823e3c2f1369546154d9e1213bcc510bc1a6574)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageTextImageTransformation",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageTextImageTransformation:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageTextImageTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageTextImageTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageTextImageTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6702be1fdb350e5f9911d13e8592fa9482b1e2d861770e03d7c58f5028b5d18a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageTextImageTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageTextImageTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageTextImageTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d6eeef3a4a1559b07a4a291033feec2a8d97d1d72c25c8c82982691c00ebbde0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageUrlImage",
    jsii_struct_bases=[],
    name_mapping={
        "transformation": "transformation",
        "url": "url",
        "url_var": "urlVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageUrlImage:
    def __init__(
        self,
        *,
        transformation: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageUrlImageTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        url: typing.Optional[builtins.str] = None,
        url_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param transformation: transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        :param url: The URL of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url DataAkamaiImagingPolicyImage#url}
        :param url_var: The URL of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url_var DataAkamaiImagingPolicyImage#url_var}
        '''
        if isinstance(transformation, dict):
            transformation = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageUrlImageTransformation(**transformation)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__61c1d6a2223ceed24fcc2e0a690d9c6259aa6454cda4e92ee797beb3529bcff4)
            check_type(argname="argument transformation", value=transformation, expected_type=type_hints["transformation"])
            check_type(argname="argument url", value=url, expected_type=type_hints["url"])
            check_type(argname="argument url_var", value=url_var, expected_type=type_hints["url_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if transformation is not None:
            self._values["transformation"] = transformation
        if url is not None:
            self._values["url"] = url
        if url_var is not None:
            self._values["url_var"] = url_var

    @builtins.property
    def transformation(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageUrlImageTransformation"]:
        '''transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        '''
        result = self._values.get("transformation")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageUrlImageTransformation"], result)

    @builtins.property
    def url(self) -> typing.Optional[builtins.str]:
        '''The URL of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url DataAkamaiImagingPolicyImage#url}
        '''
        result = self._values.get("url")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def url_var(self) -> typing.Optional[builtins.str]:
        '''The URL of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url_var DataAkamaiImagingPolicyImage#url_var}
        '''
        result = self._values.get("url_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageUrlImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageUrlImageList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageUrlImageList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__53d6ad74c2222eb8a3e5b6f25f129d764ec2febba1a527cab2f756b5cca6d7ed)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageUrlImageOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a62e9201a8b309c2fe492d749c3a189522cd6a796131c0f0bb160e1e5558093)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageUrlImageOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f9b061ac43211a46f1f2caeda8fddad057b4e8d74dd7a03e7f05b2b26209ccc9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dc571a0a71ffa581898565507c2a20cba4edadc3ff4e788d10dc13244e73c8f4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__429bfe9a3c3f7a30dff8a2b76d4859a613d38aa4224da2d89bec52a8c0b47a08)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageUrlImage]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageUrlImage]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageUrlImage]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__548379eb88414874dbc994b8b20eaec90bdee7d5eba4af2faceb7226951a6d74)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageUrlImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageUrlImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d4b1dc94a61d06360bcae30b931bf1f8cb2dba91f8859aa0397fdd4d61d67446)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformation")
    def put_transformation(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageUrlImageTransformation()

        return typing.cast(None, jsii.invoke(self, "putTransformation", [value]))

    @jsii.member(jsii_name="resetTransformation")
    def reset_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformation", []))

    @jsii.member(jsii_name="resetUrl")
    def reset_url(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUrl", []))

    @jsii.member(jsii_name="resetUrlVar")
    def reset_url_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUrlVar", []))

    @builtins.property
    @jsii.member(jsii_name="transformation")
    def transformation(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageUrlImageTransformationOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageUrlImageTransformationOutputReference", jsii.get(self, "transformation"))

    @builtins.property
    @jsii.member(jsii_name="transformationInput")
    def transformation_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageUrlImageTransformation"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageUrlImageTransformation"], jsii.get(self, "transformationInput"))

    @builtins.property
    @jsii.member(jsii_name="urlInput")
    def url_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "urlInput"))

    @builtins.property
    @jsii.member(jsii_name="urlVarInput")
    def url_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "urlVarInput"))

    @builtins.property
    @jsii.member(jsii_name="url")
    def url(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "url"))

    @url.setter
    def url(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__29ea2b73f444c2c1d2faf036f4a86304ee1975bdc72af4826faaf3722d53bd7e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "url", value)

    @builtins.property
    @jsii.member(jsii_name="urlVar")
    def url_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "urlVar"))

    @url_var.setter
    def url_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c96c3ec95c8c81691bcc31831be99dadcddf64269aacbede17b3745e9fb67856)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "urlVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageUrlImage]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageUrlImage]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageUrlImage]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f675aa2b069c3305e84e906e3e5145ad039be040a99f591dc1f9589f139cbc9c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageUrlImageTransformation",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageUrlImageTransformation:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageUrlImageTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageUrlImageTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageUrlImageTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dc9b1a425223a41651db124169952cd4003fbf60a2543a660142dab35e4bffb0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageUrlImageTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageUrlImageTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageUrlImageTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__57d7f63afdf1ef8883f657f9c47a879ec6a992b59bbe1cbfe83de8d013e4dc73)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e6cfe1081e1f74577e8bbd117fb2ee9f35f9da54455bad78f2ae75032081e3ea)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__87581e4caaecc79098db4e59ff9df731efe891848069c1179616f10d1d7aabb9)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7987fa68e9049f5be1c4d86583de31e15a2e6b3a94cdf815db99eebcf6eaaf59)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__56cfa770adbfa33342e56ed87009b1474310aa16efa2de624389b06197bdd786)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6c32d359c2fabe0e33b945abf9c6d5b1b1fc4663ba3f20c0c7f1db864736e320)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeComposite]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeComposite]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f4ddc848468ab3ebd212d54b24fa824899efd8d24a3c055ef05b8e96fcfded79)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e4525cd2a3627cc3a983c529e88ae010811c0087c3a7b73736d7e3dbf7c7071)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(
        self,
        *,
        box_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageBoxImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
        circle_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageCircleImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
        text_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageTextImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
        url_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageUrlImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param box_image: box_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#box_image DataAkamaiImagingPolicyImage#box_image}
        :param circle_image: circle_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#circle_image DataAkamaiImagingPolicyImage#circle_image}
        :param text_image: text_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text_image DataAkamaiImagingPolicyImage#text_image}
        :param url_image: url_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url_image DataAkamaiImagingPolicyImage#url_image}
        '''
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImage(
            box_image=box_image,
            circle_image=circle_image,
            text_image=text_image,
            url_image=url_image,
        )

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPlacement")
    def reset_placement(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacement", []))

    @jsii.member(jsii_name="resetPlacementVar")
    def reset_placement_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacementVar", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetScaleDimension")
    def reset_scale_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimension", []))

    @jsii.member(jsii_name="resetScaleDimensionVar")
    def reset_scale_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimensionVar", []))

    @jsii.member(jsii_name="resetScaleVar")
    def reset_scale_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="placementInput")
    def placement_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementInput"))

    @builtins.property
    @jsii.member(jsii_name="placementVarInput")
    def placement_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionInput")
    def scale_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVarInput")
    def scale_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleVarInput")
    def scale_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9c38c9e6792902b04687fd18ee6ccb650fb631266905868170ca381e625053fc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c59ff4b9132209696d5f748ab82faee1dbc16203ea0325d1ffbcf1d8168e1b17)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="placement")
    def placement(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placement"))

    @placement.setter
    def placement(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea28fcedbb699a553e9921b19d3729e1028cafe37cd46db08c207bdfd923b7ee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placement", value)

    @builtins.property
    @jsii.member(jsii_name="placementVar")
    def placement_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placementVar"))

    @placement_var.setter
    def placement_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__068db589274ade3af3196b6c2d6df79652ac97dd4ee00f38adf2f5a55d7cd5a0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placementVar", value)

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scale"))

    @scale.setter
    def scale(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eb83b95fa3085b5b084ea5548edb6aeed0075f4738b717bc4ca4ce18007563f4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scale", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimension")
    def scale_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimension"))

    @scale_dimension.setter
    def scale_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be9f49f6dc58f8bc4dea405e74d8a210bcb59a9f62dbc61221119c0cdafb0999)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimension", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVar")
    def scale_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimensionVar"))

    @scale_dimension_var.setter
    def scale_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cf67d75e15b2a8519a98f489876b5e5d86b0ba83da6d529d86e7c14d129efb01)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="scaleVar")
    def scale_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleVar"))

    @scale_var.setter
    def scale_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab6701d4ec1517c04da18fa9c8a8ba340e4ee0763ec99c76946e55679bc3051d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__33b8ca26d8b956fcfe8157c1991a2ceca0394b117c1dbd608da95c68b33add4a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ff0bf1af47fc71f6d01f04130dab496335a8a401b92e6d765c68aedaa88dfb0b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d9c476df653e93649522a6619bdd41c49b5ef67f0d674bad0f587dc51027b7d3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__53d72ecb8b8faa41e54150399b960ef4e27fdf204bbb49f299f4b92e5a5d411a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeComposite]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeComposite]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeComposite]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0631bed4c3f3e65c399952ca48d7ba227dbc9405d6a6682e9fcdd5653d916f00)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompound",
    jsii_struct_bases=[],
    name_mapping={"transformations": "transformations"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompound:
    def __init__(
        self,
        *,
        transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param transformations: transformations block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4654c7cccd1a87b5e861d033d0abaf84176a2d6db0d60c6d22d322dd9fe63487)
            check_type(argname="argument transformations", value=transformations, expected_type=type_hints["transformations"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if transformations is not None:
            self._values["transformations"] = transformations

    @builtins.property
    def transformations(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformations"]]]:
        '''transformations block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        result = self._values.get("transformations")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformations"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompound(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__190e1be2f0c28857dbf66d687c2718d8075eb51b9a4ac34d874f8d09500d960c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__355a1ac2d382cfcde8f135ecb137fb01af5af02839332731fcab1c26708b910e)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__83bf954e483810c27ec64369f8245fc01c206daf591556668f41cf48b489728b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__28b8d732b85120eca628bcd49fb538292181dae8890af6933dddc4d97401e9e5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a40fd6ac539afdae3b4632747750efd1231c8d66683507f1404399fc020ece2f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompound]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompound]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__777623c939cadc4389f580b92158c878f3aecb6f1efd7fa47229a603f78f86b4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4e7ed524d0d8df7c300ba81bdc895231cd36f707cb6be841737f60e83275eeda)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformations")
    def put_transformations(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3b49000b50d0c9b4b1a1cb7c83d891925ad92cb18f7eaaf78a3bc7f96094bb43)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTransformations", [value]))

    @jsii.member(jsii_name="resetTransformations")
    def reset_transformations(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformations", []))

    @builtins.property
    @jsii.member(jsii_name="transformations")
    def transformations(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsList", jsii.get(self, "transformations"))

    @builtins.property
    @jsii.member(jsii_name="transformationsInput")
    def transformations_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformations"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformations"]]], jsii.get(self, "transformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompound]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompound]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompound]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3042a037ac84564626dacea2309be365aa06cd2208a2bfc86c3936f49f46e462)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformations",
    jsii_struct_bases=[],
    name_mapping={
        "background_color": "backgroundColor",
        "blur": "blur",
        "chroma_key": "chromaKey",
        "composite": "composite",
        "compound": "compound",
        "contrast": "contrast",
        "goop": "goop",
        "grayscale": "grayscale",
        "hsl": "hsl",
        "hsv": "hsv",
        "if_dimension": "ifDimension",
        "if_orientation": "ifOrientation",
        "max_colors": "maxColors",
        "mirror": "mirror",
        "mono_hue": "monoHue",
        "opacity": "opacity",
        "remove_color": "removeColor",
        "unsharp_mask": "unsharpMask",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformations:
    def __init__(
        self,
        *,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsBackgroundColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsBlur", typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsChromaKey", typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsComposite", typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsCompound", typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsContrast", typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsGoop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsGrayscale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsHsl", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsHsv", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfDimension", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfOrientation", typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsMaxColors", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsMirror", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsMonoHue", typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsOpacity", typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsRemoveColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsUnsharpMask", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c9594502f35ea6cf356caaaf1c5a9f71d8228170ec3fae7b2e25b0844514af9d)
            check_type(argname="argument background_color", value=background_color, expected_type=type_hints["background_color"])
            check_type(argname="argument blur", value=blur, expected_type=type_hints["blur"])
            check_type(argname="argument chroma_key", value=chroma_key, expected_type=type_hints["chroma_key"])
            check_type(argname="argument composite", value=composite, expected_type=type_hints["composite"])
            check_type(argname="argument compound", value=compound, expected_type=type_hints["compound"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument goop", value=goop, expected_type=type_hints["goop"])
            check_type(argname="argument grayscale", value=grayscale, expected_type=type_hints["grayscale"])
            check_type(argname="argument hsl", value=hsl, expected_type=type_hints["hsl"])
            check_type(argname="argument hsv", value=hsv, expected_type=type_hints["hsv"])
            check_type(argname="argument if_dimension", value=if_dimension, expected_type=type_hints["if_dimension"])
            check_type(argname="argument if_orientation", value=if_orientation, expected_type=type_hints["if_orientation"])
            check_type(argname="argument max_colors", value=max_colors, expected_type=type_hints["max_colors"])
            check_type(argname="argument mirror", value=mirror, expected_type=type_hints["mirror"])
            check_type(argname="argument mono_hue", value=mono_hue, expected_type=type_hints["mono_hue"])
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument remove_color", value=remove_color, expected_type=type_hints["remove_color"])
            check_type(argname="argument unsharp_mask", value=unsharp_mask, expected_type=type_hints["unsharp_mask"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if background_color is not None:
            self._values["background_color"] = background_color
        if blur is not None:
            self._values["blur"] = blur
        if chroma_key is not None:
            self._values["chroma_key"] = chroma_key
        if composite is not None:
            self._values["composite"] = composite
        if compound is not None:
            self._values["compound"] = compound
        if contrast is not None:
            self._values["contrast"] = contrast
        if goop is not None:
            self._values["goop"] = goop
        if grayscale is not None:
            self._values["grayscale"] = grayscale
        if hsl is not None:
            self._values["hsl"] = hsl
        if hsv is not None:
            self._values["hsv"] = hsv
        if if_dimension is not None:
            self._values["if_dimension"] = if_dimension
        if if_orientation is not None:
            self._values["if_orientation"] = if_orientation
        if max_colors is not None:
            self._values["max_colors"] = max_colors
        if mirror is not None:
            self._values["mirror"] = mirror
        if mono_hue is not None:
            self._values["mono_hue"] = mono_hue
        if opacity is not None:
            self._values["opacity"] = opacity
        if remove_color is not None:
            self._values["remove_color"] = remove_color
        if unsharp_mask is not None:
            self._values["unsharp_mask"] = unsharp_mask

    @builtins.property
    def background_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsBackgroundColor"]]]:
        '''background_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        '''
        result = self._values.get("background_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsBackgroundColor"]]], result)

    @builtins.property
    def blur(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsBlur"]]]:
        '''blur block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        '''
        result = self._values.get("blur")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsBlur"]]], result)

    @builtins.property
    def chroma_key(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsChromaKey"]]]:
        '''chroma_key block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        '''
        result = self._values.get("chroma_key")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsChromaKey"]]], result)

    @builtins.property
    def composite(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsComposite"]]]:
        '''composite block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        '''
        result = self._values.get("composite")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsComposite"]]], result)

    @builtins.property
    def compound(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsCompound"]]]:
        '''compound block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        '''
        result = self._values.get("compound")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsCompound"]]], result)

    @builtins.property
    def contrast(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsContrast"]]]:
        '''contrast block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsContrast"]]], result)

    @builtins.property
    def goop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsGoop"]]]:
        '''goop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        '''
        result = self._values.get("goop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsGoop"]]], result)

    @builtins.property
    def grayscale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsGrayscale"]]]:
        '''grayscale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        '''
        result = self._values.get("grayscale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsGrayscale"]]], result)

    @builtins.property
    def hsl(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsHsl"]]]:
        '''hsl block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        '''
        result = self._values.get("hsl")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsHsl"]]], result)

    @builtins.property
    def hsv(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsHsv"]]]:
        '''hsv block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        '''
        result = self._values.get("hsv")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsHsv"]]], result)

    @builtins.property
    def if_dimension(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfDimension"]]]:
        '''if_dimension block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        '''
        result = self._values.get("if_dimension")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfDimension"]]], result)

    @builtins.property
    def if_orientation(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfOrientation"]]]:
        '''if_orientation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        '''
        result = self._values.get("if_orientation")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfOrientation"]]], result)

    @builtins.property
    def max_colors(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsMaxColors"]]]:
        '''max_colors block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        '''
        result = self._values.get("max_colors")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsMaxColors"]]], result)

    @builtins.property
    def mirror(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsMirror"]]]:
        '''mirror block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        '''
        result = self._values.get("mirror")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsMirror"]]], result)

    @builtins.property
    def mono_hue(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsMonoHue"]]]:
        '''mono_hue block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        '''
        result = self._values.get("mono_hue")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsMonoHue"]]], result)

    @builtins.property
    def opacity(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsOpacity"]]]:
        '''opacity block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsOpacity"]]], result)

    @builtins.property
    def remove_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsRemoveColor"]]]:
        '''remove_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        '''
        result = self._values.get("remove_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsRemoveColor"]]], result)

    @builtins.property
    def unsharp_mask(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsUnsharpMask"]]]:
        '''unsharp_mask block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        result = self._values.get("unsharp_mask")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsUnsharpMask"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformations(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsBackgroundColor",
    jsii_struct_bases=[],
    name_mapping={"color": "color", "color_var": "colorVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsBackgroundColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ee5eb1c7a900e8578f4e7240c7c0cb6852294735fd160f85d53973db04d68d9)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsBackgroundColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsBackgroundColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsBackgroundColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af8c978d216b029ee828f442500f8dfb5358c5d67fd2ca01f04386bb13ed1649)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsBackgroundColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__34bcab6bf79e6a91b3917568fc1f16ed0843ec707a63237602ddf982c2f3f39b)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsBackgroundColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__12f10f3f64afd32716ccbb842706d23d20306f4ce9d89fdcece196745296e4f9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a739fa25eaccc3244024b1b6e514cae31ed5c05feb0a33782d21818add93b59e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8739ed703ffbd9a2552b110590aee3d9e14328372e2638372b70e5dc30adf1e1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsBackgroundColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsBackgroundColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7f4ce8bc79eb270e280d3a6470095f363f3d0cedecf1c5d848ff590dff9a2d9e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsBackgroundColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsBackgroundColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b996ced9e234d4d13cb01fb38e710539ea18fea50e7baa8de44615218f67b7e6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6d88d994255c115d152ac3352c10a3428762c40bb84c3aaa05c49505aa6bd773)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f9e890e5699d82c160f026e238fccd3c133665ae2a003c835faab6577740bd9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsBackgroundColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsBackgroundColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsBackgroundColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7271786d682b2411d58b4abcec7b52dbaee409ed4e248c8cc1362032340a25f4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsBlur",
    jsii_struct_bases=[],
    name_mapping={"sigma": "sigma", "sigma_var": "sigmaVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsBlur:
    def __init__(
        self,
        *,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param sigma: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__38067af2ceafc2b1bdaf7eec6ce67a4e84cd9fa01385a9876926c464202657ff)
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsBlur(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsBlurList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsBlurList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e4b0e8df4a70c45ba5e0c7895756dd274332a8db504ec2d36f85368a053a358b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsBlurOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a623bf4e0c3b90b0d4f10d5689e31d8c8044bf2750a6b1f9eb60b9032d42017)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsBlurOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__680926c6772d36af56de09c5147f0198ab9617b665f46278456ea0e5671f5bdf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__77eb45031c0f1c85b6164732ffb9f02ebfd9aa295b9a587b68277a188c9ad88d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__68f0ba2fb3876f9b5d306c7305c2bd3417cf1665e98bccff801f51e0c6a21485)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsBlur]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsBlur]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e432aae69d238fec19127eaf365352a853fd07a0ade664c034951acee708f2c3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsBlurOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsBlurOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__04a56e8c6c48c517ccabe9a426ac5558089a56008a645a25737ca1e687d4751d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__567db3639fece5e37b253d7278de6e1b112759d9863969cfaf3c004d3354559a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eb80c2155a5b853c461bb7360e7936e6695edc0501c5826648d8a3790392a166)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsBlur]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsBlur]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsBlur]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__034d330609692ffed5cd989e6e1fc7bba4853214e59c2e82805853c9363b80a3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsChromaKey",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_feather": "hueFeather",
        "hue_feather_var": "hueFeatherVar",
        "hue_tolerance": "hueTolerance",
        "hue_tolerance_var": "hueToleranceVar",
        "hue_var": "hueVar",
        "lightness_feather": "lightnessFeather",
        "lightness_feather_var": "lightnessFeatherVar",
        "lightness_tolerance": "lightnessTolerance",
        "lightness_tolerance_var": "lightnessToleranceVar",
        "saturation_feather": "saturationFeather",
        "saturation_feather_var": "saturationFeatherVar",
        "saturation_tolerance": "saturationTolerance",
        "saturation_tolerance_var": "saturationToleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsChromaKey:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_feather: typing.Optional[builtins.str] = None,
        hue_feather_var: typing.Optional[builtins.str] = None,
        hue_tolerance: typing.Optional[builtins.str] = None,
        hue_tolerance_var: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness_feather: typing.Optional[builtins.str] = None,
        lightness_feather_var: typing.Optional[builtins.str] = None,
        lightness_tolerance: typing.Optional[builtins.str] = None,
        lightness_tolerance_var: typing.Optional[builtins.str] = None,
        saturation_feather: typing.Optional[builtins.str] = None,
        saturation_feather_var: typing.Optional[builtins.str] = None,
        saturation_tolerance: typing.Optional[builtins.str] = None,
        saturation_tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_feather: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        :param hue_feather_var: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        :param hue_tolerance: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        :param hue_tolerance_var: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        :param hue_var: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness_feather: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        :param lightness_feather_var: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        :param lightness_tolerance: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        :param lightness_tolerance_var: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        :param saturation_feather: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        :param saturation_feather_var: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        :param saturation_tolerance: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        :param saturation_tolerance_var: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2be6cb54b9a3926e7b95b1a00811138e720527f9bd5efcac4b0ba370e8747510)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_feather", value=hue_feather, expected_type=type_hints["hue_feather"])
            check_type(argname="argument hue_feather_var", value=hue_feather_var, expected_type=type_hints["hue_feather_var"])
            check_type(argname="argument hue_tolerance", value=hue_tolerance, expected_type=type_hints["hue_tolerance"])
            check_type(argname="argument hue_tolerance_var", value=hue_tolerance_var, expected_type=type_hints["hue_tolerance_var"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness_feather", value=lightness_feather, expected_type=type_hints["lightness_feather"])
            check_type(argname="argument lightness_feather_var", value=lightness_feather_var, expected_type=type_hints["lightness_feather_var"])
            check_type(argname="argument lightness_tolerance", value=lightness_tolerance, expected_type=type_hints["lightness_tolerance"])
            check_type(argname="argument lightness_tolerance_var", value=lightness_tolerance_var, expected_type=type_hints["lightness_tolerance_var"])
            check_type(argname="argument saturation_feather", value=saturation_feather, expected_type=type_hints["saturation_feather"])
            check_type(argname="argument saturation_feather_var", value=saturation_feather_var, expected_type=type_hints["saturation_feather_var"])
            check_type(argname="argument saturation_tolerance", value=saturation_tolerance, expected_type=type_hints["saturation_tolerance"])
            check_type(argname="argument saturation_tolerance_var", value=saturation_tolerance_var, expected_type=type_hints["saturation_tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_feather is not None:
            self._values["hue_feather"] = hue_feather
        if hue_feather_var is not None:
            self._values["hue_feather_var"] = hue_feather_var
        if hue_tolerance is not None:
            self._values["hue_tolerance"] = hue_tolerance
        if hue_tolerance_var is not None:
            self._values["hue_tolerance_var"] = hue_tolerance_var
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness_feather is not None:
            self._values["lightness_feather"] = lightness_feather
        if lightness_feather_var is not None:
            self._values["lightness_feather_var"] = lightness_feather_var
        if lightness_tolerance is not None:
            self._values["lightness_tolerance"] = lightness_tolerance
        if lightness_tolerance_var is not None:
            self._values["lightness_tolerance_var"] = lightness_tolerance_var
        if saturation_feather is not None:
            self._values["saturation_feather"] = saturation_feather
        if saturation_feather_var is not None:
            self._values["saturation_feather_var"] = saturation_feather_var
        if saturation_tolerance is not None:
            self._values["saturation_tolerance"] = saturation_tolerance
        if saturation_tolerance_var is not None:
            self._values["saturation_tolerance_var"] = saturation_tolerance_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        '''
        result = self._values.get("hue_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        '''
        result = self._values.get("hue_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        '''
        result = self._values.get("hue_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        '''
        result = self._values.get("hue_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        '''
        result = self._values.get("lightness_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        '''
        result = self._values.get("lightness_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        '''
        result = self._values.get("lightness_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        '''
        result = self._values.get("lightness_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        '''
        result = self._values.get("saturation_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        '''
        result = self._values.get("saturation_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        '''
        result = self._values.get("saturation_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        result = self._values.get("saturation_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsChromaKey(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsChromaKeyList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsChromaKeyList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8988cb741f2f5341faebe8240fa9e3318f8cd352308dd4f103db338747f158ce)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsChromaKeyOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__486d7e585e145a9b4a047acb9e407f57894326147e1661d3337c089bb4063733)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsChromaKeyOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f2de56b448dad24aa38156abdaa5f063496f84f63d0504c7d7c93245130d8947)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bd77736df14e7180be10b951ec68a3c9ec6ab55bbf0189e7ee342c79cef321f5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c3717ce07e3c46b081dc0b52f3978c52c45c1a78b70f6fb570c43ffad76b4498)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsChromaKey]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsChromaKey]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f60554f7decdd9728508290b4313492ac8f852d0203edd6b70893f16ace872a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsChromaKeyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsChromaKeyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4117a9c5e036b633eefead571e84566607229facc3a4e58d87584538495547c0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueFeather")
    def reset_hue_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeather", []))

    @jsii.member(jsii_name="resetHueFeatherVar")
    def reset_hue_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeatherVar", []))

    @jsii.member(jsii_name="resetHueTolerance")
    def reset_hue_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueTolerance", []))

    @jsii.member(jsii_name="resetHueToleranceVar")
    def reset_hue_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueToleranceVar", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightnessFeather")
    def reset_lightness_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeather", []))

    @jsii.member(jsii_name="resetLightnessFeatherVar")
    def reset_lightness_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeatherVar", []))

    @jsii.member(jsii_name="resetLightnessTolerance")
    def reset_lightness_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessTolerance", []))

    @jsii.member(jsii_name="resetLightnessToleranceVar")
    def reset_lightness_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessToleranceVar", []))

    @jsii.member(jsii_name="resetSaturationFeather")
    def reset_saturation_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeather", []))

    @jsii.member(jsii_name="resetSaturationFeatherVar")
    def reset_saturation_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeatherVar", []))

    @jsii.member(jsii_name="resetSaturationTolerance")
    def reset_saturation_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationTolerance", []))

    @jsii.member(jsii_name="resetSaturationToleranceVar")
    def reset_saturation_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherInput")
    def hue_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVarInput")
    def hue_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceInput")
    def hue_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVarInput")
    def hue_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherInput")
    def lightness_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVarInput")
    def lightness_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceInput")
    def lightness_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVarInput")
    def lightness_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherInput")
    def saturation_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVarInput")
    def saturation_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceInput")
    def saturation_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVarInput")
    def saturation_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__822f5bbe60f63008d7f17846f26ae04e3d2f6fbe1e082f12c28d6bec70f5bd9f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeather")
    def hue_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeather"))

    @hue_feather.setter
    def hue_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__31fcbb8ab4d3a4d5a07239700c50befa7e6b6d7fe0a1e75e8e8c4b66b0197815)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeather", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVar")
    def hue_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeatherVar"))

    @hue_feather_var.setter
    def hue_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1673558f2999b1d34bc6fd15fe132c132efce2c2aa25034d4cac3d682a78a3ff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueTolerance")
    def hue_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueTolerance"))

    @hue_tolerance.setter
    def hue_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d932025cfa2073bd5d574d173fa4a3082990cd2e9e9c8808bdf2de462f700812)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVar")
    def hue_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueToleranceVar"))

    @hue_tolerance_var.setter
    def hue_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__86b6a0c31143b0526b018093b74476fec89c610dd2fb7079c8fdcefe9cba3ecf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__41f3653176aa9c5e11f3f655bd9c5e6eb31107710cc60f026cbf4fd3f46f795b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeather")
    def lightness_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeather"))

    @lightness_feather.setter
    def lightness_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc90f14fa4ee7c329697cd20dc9048f0e92144ce47eb0c59db099aff84a81e3a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeather", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVar")
    def lightness_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeatherVar"))

    @lightness_feather_var.setter
    def lightness_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fd723dcc98c693b326244cafb7474f6eb5b018ae5feb138cf8b76aa33208db79)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessTolerance")
    def lightness_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessTolerance"))

    @lightness_tolerance.setter
    def lightness_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__093c3cd8ad0bc5dbe7e6cc3d6f80de48f5fa038670dc0c34e26839c9e7f173c6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVar")
    def lightness_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessToleranceVar"))

    @lightness_tolerance_var.setter
    def lightness_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__12702199859b445a8c0d5d54fa14727ca4c8b0c038050853e80cef47ded9bcc8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeather")
    def saturation_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeather"))

    @saturation_feather.setter
    def saturation_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__08a822f3715c87d91d50eddc59039ad61ec0babef7dd0ed4ac4f6ee00d4ef626)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeather", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVar")
    def saturation_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeatherVar"))

    @saturation_feather_var.setter
    def saturation_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ac8a223f2e052e372e64d9412f360e057155490a1de79c90c68a8c15e99b073)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationTolerance")
    def saturation_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationTolerance"))

    @saturation_tolerance.setter
    def saturation_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4f29f3f12366b7cb9972c482db83d3e3af5b8ff613339ac04ef06cc30b373837)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVar")
    def saturation_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationToleranceVar"))

    @saturation_tolerance_var.setter
    def saturation_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aad4258a811de36aafe931986bbb126aeb60a02932a00ce10c364fa441fc5c6b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsChromaKey]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsChromaKey]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsChromaKey]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b9e89c1dff6294d52008ce099e21b8d381bf2150c4260b74f9090cd17ecd3da0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsComposite",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "placement": "placement",
        "placement_var": "placementVar",
        "scale": "scale",
        "scale_dimension": "scaleDimension",
        "scale_dimension_var": "scaleDimensionVar",
        "scale_var": "scaleVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsComposite:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsCompositeImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        placement: typing.Optional[builtins.str] = None,
        placement_var: typing.Optional[builtins.str] = None,
        scale: typing.Optional[builtins.str] = None,
        scale_dimension: typing.Optional[builtins.str] = None,
        scale_dimension_var: typing.Optional[builtins.str] = None,
        scale_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param placement: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        :param placement_var: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        :param scale: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param scale_dimension: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        :param scale_dimension_var: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        :param scale_var: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        :param x_position: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsCompositeImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2daa143f1af6168cd6918d28f81cd72812bed1cc82715de8d14842c6e0e334ff)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument placement", value=placement, expected_type=type_hints["placement"])
            check_type(argname="argument placement_var", value=placement_var, expected_type=type_hints["placement_var"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument scale_dimension", value=scale_dimension, expected_type=type_hints["scale_dimension"])
            check_type(argname="argument scale_dimension_var", value=scale_dimension_var, expected_type=type_hints["scale_dimension_var"])
            check_type(argname="argument scale_var", value=scale_var, expected_type=type_hints["scale_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if placement is not None:
            self._values["placement"] = placement
        if placement_var is not None:
            self._values["placement_var"] = placement_var
        if scale is not None:
            self._values["scale"] = scale
        if scale_dimension is not None:
            self._values["scale_dimension"] = scale_dimension
        if scale_dimension_var is not None:
            self._values["scale_dimension_var"] = scale_dimension_var
        if scale_var is not None:
            self._values["scale_var"] = scale_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsCompositeImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsCompositeImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        '''
        result = self._values.get("placement")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement_var(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        '''
        result = self._values.get("placement_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        '''
        result = self._values.get("scale_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        '''
        result = self._values.get("scale_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        '''
        result = self._values.get("scale_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsComposite(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsCompositeImage",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsCompositeImage:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsCompositeImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsCompositeImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsCompositeImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d350a2d8de709bd67a5563d6784a2716533f88d2aed8a446f8ce642f4b6d7697)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsCompositeImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsCompositeImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__80df09c2519b7c8d6c0a79200d04743205ecc8f5d901cfd07bd1e0e371a3d618)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsCompositeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsCompositeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ff6a6bbced4132a3390e7f4f2244e9bcd484debdc115b9226e2b15b71631b715)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsCompositeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__37c66a21777ae804b957c3faa3dc0b5e0291fecfd9152cbad398e4ab635d66ff)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsCompositeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0d191a0658cebfe34e4377582e80aa2474f8620db816fc705a781670b6debaac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e39f73030a644ca8745c833beb673a1b92662269ceac59c71b7f6ffb3c4303ab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__982838ec7851131079416607327c3193eb17f8a1a05d1ab253a30b3452d1a0d1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsComposite]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsComposite]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6afc921169583571d71b4a972c21da93c2e081628d0ebb3bcf9b0d604e6e4393)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsCompositeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsCompositeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f880e1ff99c4498492e444f1710ea3634c5ef8a856be5e551edddb429f5e915a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsCompositeImage()

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPlacement")
    def reset_placement(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacement", []))

    @jsii.member(jsii_name="resetPlacementVar")
    def reset_placement_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacementVar", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetScaleDimension")
    def reset_scale_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimension", []))

    @jsii.member(jsii_name="resetScaleDimensionVar")
    def reset_scale_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimensionVar", []))

    @jsii.member(jsii_name="resetScaleVar")
    def reset_scale_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsCompositeImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsCompositeImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsCompositeImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="placementInput")
    def placement_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementInput"))

    @builtins.property
    @jsii.member(jsii_name="placementVarInput")
    def placement_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionInput")
    def scale_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVarInput")
    def scale_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleVarInput")
    def scale_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__77094d6839187afb9ab4738b18103b0fd1ec44cb6e603d3f373b3df207875fdb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__52a25c289f0465bb6c5f1a99d968fef47422d285d5c64a06b179554d3357de83)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="placement")
    def placement(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placement"))

    @placement.setter
    def placement(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2e2db677accc6b067b6308cea698854bae305c36ec2569145344afbd88cd4ffd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placement", value)

    @builtins.property
    @jsii.member(jsii_name="placementVar")
    def placement_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placementVar"))

    @placement_var.setter
    def placement_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f73f7db7bb8ffad380c9e1590c5dd042c982d33d1986b2f81aa0d9ebfb5fec95)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placementVar", value)

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scale"))

    @scale.setter
    def scale(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9993f33423802179abcd1953bf47aa12bd59399a05229d6ffb1873fb3adabb36)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scale", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimension")
    def scale_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimension"))

    @scale_dimension.setter
    def scale_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a2a8dae1832ce31b9a59c7b1c83f4f8b3a420472f64005831ca8899198b09a17)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimension", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVar")
    def scale_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimensionVar"))

    @scale_dimension_var.setter
    def scale_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6932d1c9a81175cb7b1d4ce3c6c34d029ffbf64bcb4e55bcf13414d90a7d46ae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="scaleVar")
    def scale_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleVar"))

    @scale_var.setter
    def scale_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__444f133bef29e3c116ccb83cf7413f6415bcd89cbdcbb26400d3e696f5491384)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__397a4ba7297f075c0b0be208cb9ae7086b8a6c8e185c39697f22f6762586ae7d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5629ae6f49f4d3ba17aaa0e29ec27e3ff0579fd92b983bd3fa85386d9bfac800)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__59a5fb5e6e03137cfabc8eb4f3105fd87db360daadea71ffdabfa840585a6540)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0d286518775ebc705045e9f1919a2abd90bc0cf422b36b69c03e81ef1282633b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsComposite]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsComposite]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsComposite]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__82e833be7c4d728bc425978b49f6254d18c55c1e7782b9baec0163f21d6a1d02)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsCompound",
    jsii_struct_bases=[],
    name_mapping={"transformations": "transformations"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsCompound:
    def __init__(
        self,
        *,
        transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param transformations: transformations block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a5c20b94936874eed2191949a7ccdd469124f7face7dfa4c237eeac06ed4ccdc)
            check_type(argname="argument transformations", value=transformations, expected_type=type_hints["transformations"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if transformations is not None:
            self._values["transformations"] = transformations

    @builtins.property
    def transformations(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsCompoundTransformations"]]]:
        '''transformations block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        result = self._values.get("transformations")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsCompoundTransformations"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsCompound(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsCompoundList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsCompoundList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0482cdd193935d91dcda86045938b8c77507d415a729a67af79789ef7f20f9a4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsCompoundOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c758c4d99e83897da0e1e1c457811433c4f5bcab48e611487b74955be0f1dea1)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsCompoundOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac040c67f68c1b74e08ad1cceb5d8c59eb7a4772869ddb54eb77b9cca19ff6a2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7e11268a9b6d546409fed24a82dea7068bcf01c1e53ae48144d82498d1d878d1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f1198c2895f0f813ef4b7c28784726f562d2d8229b3e12ee1d6b44c95ebf5151)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsCompound]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsCompound]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__57badaada354cc769a9ac4b3ddb639d7b1a5321580ceae736cdccce88e954901)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsCompoundOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsCompoundOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a7374cc527923aa220813fd77b4e0e868869ac207ed532dd0855b826196de995)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformations")
    def put_transformations(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8275a057deec0c985edc9ace96377b5acd703970bb2d5a3cf1f968f170ec86ea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTransformations", [value]))

    @jsii.member(jsii_name="resetTransformations")
    def reset_transformations(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformations", []))

    @builtins.property
    @jsii.member(jsii_name="transformations")
    def transformations(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsCompoundTransformationsList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsCompoundTransformationsList", jsii.get(self, "transformations"))

    @builtins.property
    @jsii.member(jsii_name="transformationsInput")
    def transformations_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsCompoundTransformations"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsCompoundTransformations"]]], jsii.get(self, "transformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsCompound]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsCompound]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsCompound]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__84435b6491bd4da1770ef7ea8f7460307a63a85b95b1170bc0574de7fdad37c7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsCompoundTransformations",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsCompoundTransformations:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsCompoundTransformations(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsCompoundTransformationsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsCompoundTransformationsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c13d733a86d47aae2ea74e496edb08835c568a4c7769325651272fff4da5add1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsCompoundTransformationsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d94aaa00afb676dff2ba8c51e2060a09676261ba33ea594208a5dc6420bc5b7a)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsCompoundTransformationsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__71fcdb64947e39dd63fadf58ad437b54a12024af614d94464a04643f09988428)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__85633a36fd05d513664ecc5c1f712a33f90f92e5e45a5d156df23b8f5d557aaa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__83082d6867b713c3a3d799b0327d53df975656ce5e4f0697ae166ae3dcb7d607)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsCompoundTransformations]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsCompoundTransformations]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsCompoundTransformations]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c42e21d4ec37adace4f52d27072ab0b00449bacc0f13368e6fed72bee45b1293)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsCompoundTransformationsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsCompoundTransformationsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9927d120432087f0b4d0d918546a6cceb32edce46aaa8932dcebdee8254a5ebe)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsCompoundTransformations]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsCompoundTransformations]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsCompoundTransformations]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ff9de041cb1f3e893fcb83caa21ba1e97480ebe61c442de2514d5de53e94d6c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsContrast",
    jsii_struct_bases=[],
    name_mapping={
        "brightness": "brightness",
        "brightness_var": "brightnessVar",
        "contrast": "contrast",
        "contrast_var": "contrastVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsContrast:
    def __init__(
        self,
        *,
        brightness: typing.Optional[builtins.str] = None,
        brightness_var: typing.Optional[builtins.str] = None,
        contrast: typing.Optional[builtins.str] = None,
        contrast_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param brightness: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        :param brightness_var: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        :param contrast: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param contrast_var: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2b0c991786e4612204185a4940abe6b5edee7361a947ab369edbf65d4f9fa4ba)
            check_type(argname="argument brightness", value=brightness, expected_type=type_hints["brightness"])
            check_type(argname="argument brightness_var", value=brightness_var, expected_type=type_hints["brightness_var"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument contrast_var", value=contrast_var, expected_type=type_hints["contrast_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if brightness is not None:
            self._values["brightness"] = brightness
        if brightness_var is not None:
            self._values["brightness_var"] = brightness_var
        if contrast is not None:
            self._values["contrast"] = contrast
        if contrast_var is not None:
            self._values["contrast_var"] = contrast_var

    @builtins.property
    def brightness(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        '''
        result = self._values.get("brightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def brightness_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        '''
        result = self._values.get("brightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        result = self._values.get("contrast_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsContrast(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsContrastList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsContrastList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9017ee3178c0fe2b01e6e85515d3fd890040b6b6726c836d02e0cbadfd1724a4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsContrastOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__31bb8f45301f407c59d79d80ae82ad00cf490bf3d8ae02cca6388a09c250b16d)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsContrastOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0500db6a03da49af24b2dd5b6970d17381ecfe17f3a9563eb1827da9a6dab922)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__412ee82a6c16ba7a628e9e570f88f0b646341ea34089df7a46ecb05df7be5fef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea52f455fda6525c7a906107b4c20e9d6f980aad902314c0c3a089f970fb0fcb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsContrast]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsContrast]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5a40a819b555e749ba272dce8eed925796a1e80bd9ce6c89b2cbbd15c3553b6c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsContrastOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsContrastOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3e773d81b1a7d06a6064695d37ffea538f8f80fa3cb6e22844f19331fb01034f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetBrightness")
    def reset_brightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightness", []))

    @jsii.member(jsii_name="resetBrightnessVar")
    def reset_brightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightnessVar", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetContrastVar")
    def reset_contrast_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrastVar", []))

    @builtins.property
    @jsii.member(jsii_name="brightnessInput")
    def brightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="brightnessVarInput")
    def brightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastVarInput")
    def contrast_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="brightness")
    def brightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightness"))

    @brightness.setter
    def brightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__45b96baf3bd8c82a6a88d74c0b93ed5da8df3907e5288352c1906d908429b744)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightness", value)

    @builtins.property
    @jsii.member(jsii_name="brightnessVar")
    def brightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightnessVar"))

    @brightness_var.setter
    def brightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d22eced0647768b8f6e2d69947a8b81896927ec460c005dfcdc729faf24e0cc0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrast"))

    @contrast.setter
    def contrast(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e7501040662d74823719323ca7ce1d3262490d3fd53bcacd6ea9f4be9205ee47)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrast", value)

    @builtins.property
    @jsii.member(jsii_name="contrastVar")
    def contrast_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrastVar"))

    @contrast_var.setter
    def contrast_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3f4ec71dada6e600f167a266da47dc946f1cfd7cdcf1f7289b904a1fc8fae723)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrastVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsContrast]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsContrast]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsContrast]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b38f6a80afaa6b7124e9f1c2dc83557ac550ffac4c9702e4d5965fb5a8f483f5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsGoop",
    jsii_struct_bases=[],
    name_mapping={
        "chaos": "chaos",
        "chaos_var": "chaosVar",
        "density": "density",
        "density_var": "densityVar",
        "power": "power",
        "power_var": "powerVar",
        "seed": "seed",
        "seed_var": "seedVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsGoop:
    def __init__(
        self,
        *,
        chaos: typing.Optional[builtins.str] = None,
        chaos_var: typing.Optional[builtins.str] = None,
        density: typing.Optional[builtins.str] = None,
        density_var: typing.Optional[builtins.str] = None,
        power: typing.Optional[builtins.str] = None,
        power_var: typing.Optional[builtins.str] = None,
        seed: typing.Optional[builtins.str] = None,
        seed_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param chaos: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        :param chaos_var: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        :param density: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        :param density_var: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        :param power: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        :param power_var: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        :param seed: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        :param seed_var: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e6d48dd7d74048aace69a19016da5563c35508986b24d12f2cdc782663feb8e2)
            check_type(argname="argument chaos", value=chaos, expected_type=type_hints["chaos"])
            check_type(argname="argument chaos_var", value=chaos_var, expected_type=type_hints["chaos_var"])
            check_type(argname="argument density", value=density, expected_type=type_hints["density"])
            check_type(argname="argument density_var", value=density_var, expected_type=type_hints["density_var"])
            check_type(argname="argument power", value=power, expected_type=type_hints["power"])
            check_type(argname="argument power_var", value=power_var, expected_type=type_hints["power_var"])
            check_type(argname="argument seed", value=seed, expected_type=type_hints["seed"])
            check_type(argname="argument seed_var", value=seed_var, expected_type=type_hints["seed_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if chaos is not None:
            self._values["chaos"] = chaos
        if chaos_var is not None:
            self._values["chaos_var"] = chaos_var
        if density is not None:
            self._values["density"] = density
        if density_var is not None:
            self._values["density_var"] = density_var
        if power is not None:
            self._values["power"] = power
        if power_var is not None:
            self._values["power_var"] = power_var
        if seed is not None:
            self._values["seed"] = seed
        if seed_var is not None:
            self._values["seed_var"] = seed_var

    @builtins.property
    def chaos(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        '''
        result = self._values.get("chaos")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def chaos_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        '''
        result = self._values.get("chaos_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        '''
        result = self._values.get("density")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density_var(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        '''
        result = self._values.get("density_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        '''
        result = self._values.get("power")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power_var(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        '''
        result = self._values.get("power_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        '''
        result = self._values.get("seed")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed_var(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        result = self._values.get("seed_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsGoop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsGoopList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsGoopList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0655a16c8c5cddbb2a01e1ac0983048773bc68ba8b0f9822ffe178476d28a80f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsGoopOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2bb32355e9552009a153025ebae9deba54948377180173a09790203d210f2edd)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsGoopOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ecbf9d1f9ce9640e5fdb8f10af259728712e77bf3a3614130a661a86cbdce22)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9cc032cfeceab970de73809e527d9d9228d5ea406a9962496dfca255c8021799)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ecd07e447dcd36bed05a14607df15e64e13d3f34e3ec6e2de1f5582380862dd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsGoop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsGoop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__197cff57450ef08797fc5c7d8b70c1212197e58f4cb4f1e025c77b0bda54aee0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsGoopOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsGoopOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__36ea6d99aa01f29e51f52ed104a7c7c249a1290b329247a1f52a53e139370cea)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetChaos")
    def reset_chaos(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaos", []))

    @jsii.member(jsii_name="resetChaosVar")
    def reset_chaos_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaosVar", []))

    @jsii.member(jsii_name="resetDensity")
    def reset_density(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensity", []))

    @jsii.member(jsii_name="resetDensityVar")
    def reset_density_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensityVar", []))

    @jsii.member(jsii_name="resetPower")
    def reset_power(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPower", []))

    @jsii.member(jsii_name="resetPowerVar")
    def reset_power_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPowerVar", []))

    @jsii.member(jsii_name="resetSeed")
    def reset_seed(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeed", []))

    @jsii.member(jsii_name="resetSeedVar")
    def reset_seed_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeedVar", []))

    @builtins.property
    @jsii.member(jsii_name="chaosInput")
    def chaos_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosInput"))

    @builtins.property
    @jsii.member(jsii_name="chaosVarInput")
    def chaos_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosVarInput"))

    @builtins.property
    @jsii.member(jsii_name="densityInput")
    def density_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityInput"))

    @builtins.property
    @jsii.member(jsii_name="densityVarInput")
    def density_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="powerInput")
    def power_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerInput"))

    @builtins.property
    @jsii.member(jsii_name="powerVarInput")
    def power_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerVarInput"))

    @builtins.property
    @jsii.member(jsii_name="seedInput")
    def seed_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedInput"))

    @builtins.property
    @jsii.member(jsii_name="seedVarInput")
    def seed_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedVarInput"))

    @builtins.property
    @jsii.member(jsii_name="chaos")
    def chaos(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaos"))

    @chaos.setter
    def chaos(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e5a34e03532e936bb2f9ac8ba48e13015f97edad133e013fbcd81be62113995a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaos", value)

    @builtins.property
    @jsii.member(jsii_name="chaosVar")
    def chaos_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaosVar"))

    @chaos_var.setter
    def chaos_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__87ece1c7cf60d116300aab03a3da4fc6688acb2e78b461ccbec6d19cbfeb9cf7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaosVar", value)

    @builtins.property
    @jsii.member(jsii_name="density")
    def density(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "density"))

    @density.setter
    def density(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__87faf3c9d69e0ec18e1c6987822ef4b93e1c53ef525ba7e8d0fd98898a663a03)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "density", value)

    @builtins.property
    @jsii.member(jsii_name="densityVar")
    def density_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "densityVar"))

    @density_var.setter
    def density_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0b0be3717f02e2a2189ff8ce4c368ee35a5c9a0f84173420825e87e1741110e0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "densityVar", value)

    @builtins.property
    @jsii.member(jsii_name="power")
    def power(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "power"))

    @power.setter
    def power(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f7a4d84998590c40d5e6cb59eb7bb8405d84eea9025d8bdecd46b310a40fecf8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "power", value)

    @builtins.property
    @jsii.member(jsii_name="powerVar")
    def power_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "powerVar"))

    @power_var.setter
    def power_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4e087dd86c6e894f9ac7fd06e5954a8193f0b5476e6a37710496a4e6de5d79f8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "powerVar", value)

    @builtins.property
    @jsii.member(jsii_name="seed")
    def seed(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seed"))

    @seed.setter
    def seed(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1e2feb99bf76dfb0483b8f034cd4d9a5fb5179b6974b87fe25004098158b0d22)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seed", value)

    @builtins.property
    @jsii.member(jsii_name="seedVar")
    def seed_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seedVar"))

    @seed_var.setter
    def seed_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c50a91967b238c667c4215748aac1469116672fb2a141fbb3fe3398d7e392180)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seedVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsGoop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsGoop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsGoop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f54ab4b42225e87c2258ecd281f563ce3198dd5265929851dfe65fcf5e5f1c7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsGrayscale",
    jsii_struct_bases=[],
    name_mapping={"type": "type", "type_var": "typeVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsGrayscale:
    def __init__(
        self,
        *,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param type: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__beb6d65fbb072ce74017084d7e75ab1f5b665de0df96d4f78105197376c5dbb5)
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsGrayscale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsGrayscaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsGrayscaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__547280b5d4e490beab7e18f2e31c24824e26581a022761029ac58f13a6d13afd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsGrayscaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__27d88ec200bb7d926c8aa6734242146a9380f8e425de1a29265f79f9cdbe42fc)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsGrayscaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__219d22dd2d091565a21a06036f566e35a06f5b4f37df486be451cae3c3ad6280)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0c406892594ba2081cc4579383f6bdb268371281724d123beb387bfe682c9629)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__630ae294de533be1057966030a131036c56d9d6110f4e14fe72ee9506d3ae84f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsGrayscale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsGrayscale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__41262562a7c8db28c789d69aaf5ad6003be8ead712e8530a140c3e9ff87514b2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsGrayscaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsGrayscaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a6fb95ba1d7e1f20349bd3e46172bf21506b79d6d490c7d17d1f30d4b82d89f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cf40ce14bdba794ad403207410d0ec68f27fdf84463f444634a1da45609bc02a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e42f81dc8f87bbc55609d3fa9ac5d2fdfd44aa413172a6c97d1f52bbd8be35ba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsGrayscale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsGrayscale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsGrayscale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__09ce12e84d9e9f4e21e2dd4747d9dea0d180193c8de2a102c96497a19908e92c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsHsl",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "lightness": "lightness",
        "lightness_var": "lightnessVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsHsl:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness: typing.Optional[builtins.str] = None,
        lightness_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        :param lightness_var: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d11ddb8ddcb78d7cdc3c85d0d44d4ec005b8aa02f0f59a27fe6361bd61597861)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness", value=lightness, expected_type=type_hints["lightness"])
            check_type(argname="argument lightness_var", value=lightness_var, expected_type=type_hints["lightness_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness is not None:
            self._values["lightness"] = lightness
        if lightness_var is not None:
            self._values["lightness_var"] = lightness_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        '''
        result = self._values.get("lightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        '''
        result = self._values.get("lightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsHsl(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsHslList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsHslList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__889546d5b1a6a36bd4e9aa4964ca5e8a8332bf6444785e3e4f659183c7b8e398)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsHslOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__43a311d3792dd065757b27dae47267a237fc8e2e446acbaced30ddc495985627)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsHslOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0a410e39d22eb441766aa652bb06e06b26cecc334dc772e589c84dd68d053aa9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea26e523575c234419ab7785e5599f9d045fc7452ccc3f7d910562cf11a5d85b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ebb792675e17ab68fb1fa56365ed3fada9fb747db82ac06dae4fcab009339cb4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsHsl]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsHsl]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2952cdf50d86bb294508b94ba478690ef4945ef5c3e6dee0a47c932b33c9d0d9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsHslOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsHslOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f36086988f4a4eb99a38a29662a15ff8a88d030a048d7dc83588e36744002f0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightness")
    def reset_lightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightness", []))

    @jsii.member(jsii_name="resetLightnessVar")
    def reset_lightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessInput")
    def lightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessVarInput")
    def lightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e2c321d7f3235ef848b6b841f765790f064e63051a198277258fa4e7c61a9641)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eaed9bad8e92afef37b23588447785d5248b7066780d7a02669decc2bc94239c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightness")
    def lightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightness"))

    @lightness.setter
    def lightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b00917a0414c304277293d455d968f975dec380109990ba9ee8746c1a7ca7752)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightness", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessVar")
    def lightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessVar"))

    @lightness_var.setter
    def lightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d24905518c0f837418236590be6c36155774e5dd23c5004a1b5849f003f4d7f7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5896f086ee8661ae527858ce3938c0c0371ce73ff4ad93a7602f5a1ae032eec6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ce867d8a5918c871ebab631493041900c1a454c286e5f068b0683a72b3d2b02)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsHsl]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsHsl]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsHsl]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c8199960bfc8e4257e882ffdf223f0352aa691e641cba016afcc4f7d4e66a72a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsHsv",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsHsv:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        :param value: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__17e0b53a52003a13d150360392361b06be5f2eed437d6ab1ad0c95a056e2e521)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsHsv(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsHsvList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsHsvList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ce2f75ce5b2bec5247547a3d2f60de4c4221cb3a159fec40acb54ddf1d804fd2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsHsvOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8c852947d13501c1c6617332d67ee0d50d75b36502fd9e5ec4865b0dd1117c7b)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsHsvOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__13158b7ad50d2a304242d664c949b1e54f9c7c782ba0be4f1c650834e7d33c93)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e637b61a859f1c300481b8cd9d0008bbc5c71a399aa5fbe7e16e391e8dfeaea8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eeccd47a3a39124a9c4817473424a59f9050ae85b501f6219db1745766bf8348)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsHsv]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsHsv]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ced84947c6a670c86dc6bc011d7163091f89da2814d703d457b7936911323f40)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsHsvOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsHsvOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5186a78cecb75a0ca51bf0cc246e63f89c986036a44ce169f6e173273e7b5c99)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b6cbc1adfeb490ae387a6b11ad464d33876b3068720607f8e376bb6a4af0c113)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bdda8bf84cc4bedb7e36ac43d6ced11489d8e4c25667d240893fd084815d614c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d7f425aff942b6d7871b046ea873770369ab6d7a9fd0ca79387f012e9c6f050)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8eb1ca682ca474cc147aaac7e50199733072954a2942dee28799c8fa25b0f715)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f0b47b2cea2b57a871c587a1354f5d947ebc95fb09f3ea7d1695d6cfd0842aae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9f52da13ef8a5a3bf040db5f4da31236b019a9ec72dff84aff133d18cffeac06)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsHsv]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsHsv]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsHsv]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8ba535924f1fe107ee676591f32f44950286f62c1312cd5d6f225efc1f4065c4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfDimension",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "dimension": "dimension",
        "dimension_var": "dimensionVar",
        "equal": "equal",
        "greater_than": "greaterThan",
        "less_than": "lessThan",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfDimension:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfDimensionDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        dimension: typing.Optional[builtins.str] = None,
        dimension_var: typing.Optional[builtins.str] = None,
        equal: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfDimensionEqual", typing.Dict[builtins.str, typing.Any]]] = None,
        greater_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfDimensionGreaterThan", typing.Dict[builtins.str, typing.Any]]] = None,
        less_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfDimensionLessThan", typing.Dict[builtins.str, typing.Any]]] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param dimension: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        :param dimension_var: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        :param equal: equal block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        :param greater_than: greater_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        :param less_than: less_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        :param value: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfDimensionDefault(**default)
        if isinstance(equal, dict):
            equal = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfDimensionEqual(**equal)
        if isinstance(greater_than, dict):
            greater_than = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfDimensionGreaterThan(**greater_than)
        if isinstance(less_than, dict):
            less_than = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfDimensionLessThan(**less_than)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b5acd0d835cefcc7173804f68fe36369b98449022054770fdedb88e977e4b41a)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument dimension", value=dimension, expected_type=type_hints["dimension"])
            check_type(argname="argument dimension_var", value=dimension_var, expected_type=type_hints["dimension_var"])
            check_type(argname="argument equal", value=equal, expected_type=type_hints["equal"])
            check_type(argname="argument greater_than", value=greater_than, expected_type=type_hints["greater_than"])
            check_type(argname="argument less_than", value=less_than, expected_type=type_hints["less_than"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if dimension is not None:
            self._values["dimension"] = dimension
        if dimension_var is not None:
            self._values["dimension_var"] = dimension_var
        if equal is not None:
            self._values["equal"] = equal
        if greater_than is not None:
            self._values["greater_than"] = greater_than
        if less_than is not None:
            self._values["less_than"] = less_than
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfDimensionDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfDimensionDefault"], result)

    @builtins.property
    def dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        '''
        result = self._values.get("dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        '''
        result = self._values.get("dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def equal(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfDimensionEqual"]:
        '''equal block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        '''
        result = self._values.get("equal")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfDimensionEqual"], result)

    @builtins.property
    def greater_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfDimensionGreaterThan"]:
        '''greater_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        '''
        result = self._values.get("greater_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfDimensionGreaterThan"], result)

    @builtins.property
    def less_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfDimensionLessThan"]:
        '''less_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        '''
        result = self._values.get("less_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfDimensionLessThan"], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfDimension(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfDimensionDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfDimensionDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfDimensionDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfDimensionDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfDimensionDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b8a0102746bb85409102fc127f59d07a2ec1101960918d5ba7226974a5d8bb33)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfDimensionDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfDimensionDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e2e0ad45007b67e556d1128d65ac0c9cd8587c6bae957500fdc97508dc96ef75)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfDimensionEqual",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfDimensionEqual:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfDimensionEqual(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfDimensionEqualOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfDimensionEqualOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f511322252f12c66ee0bed045a3190da821af277573e6db20f15e41db4f34d61)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfDimensionEqual], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfDimensionEqual],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af400171143518c9be4a0ef67a30a75a716cc93e8da93dc166b5b6a4b57494af)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfDimensionGreaterThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfDimensionGreaterThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfDimensionGreaterThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfDimensionGreaterThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfDimensionGreaterThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__083644a0f33799df27ee770571d4426d55a7039fea4883220a65dc4d736aa80a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfDimensionGreaterThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfDimensionGreaterThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e7e1a7b392c1d985ddfcfdc78ea60ca9b69463b6a770ddced82e7619dfe03b1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfDimensionLessThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfDimensionLessThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfDimensionLessThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfDimensionLessThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfDimensionLessThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__da1f2d6e8881110cd83338f8581f4b101c6b83889323a562fcad39145d18cc7c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfDimensionLessThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfDimensionLessThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ba9cb5db6f1fffd08356395214decf79b665d45648033ffd3e654bc037f912bf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfDimensionList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfDimensionList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__690e186e04ecf978d1296f1fff0115b2f0a8c7983a5c2c7f2dd7bcd75db9d599)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfDimensionOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__249f3e43f83fa5a88f98f6371fa6d94b02d32f9964bfaa151d2f0393cd81519c)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfDimensionOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__356212c0753d4dfee3ab058eb409f4ce579ee01686672708c36213c4ba7df76f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cbfc9b699c92b7fe2ea869ee0d5daf91d85ee02bdc9509db0eada92c890d4ca9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__20f7e5cb529dbbaa1d8caf048a31d9695f60cff1ce0bfe97ec9987343f55c632)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfDimension]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfDimension]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5081879c2875229dca6471c936dd8eb68d260fb119ab15da86409826f4e321e4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfDimensionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfDimensionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b5ee46da82c7d92b5997fed1087b47f4304095761d91e6e9ba0284ba80facd3a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfDimensionDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putEqual")
    def put_equal(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfDimensionEqual()

        return typing.cast(None, jsii.invoke(self, "putEqual", [value]))

    @jsii.member(jsii_name="putGreaterThan")
    def put_greater_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfDimensionGreaterThan()

        return typing.cast(None, jsii.invoke(self, "putGreaterThan", [value]))

    @jsii.member(jsii_name="putLessThan")
    def put_less_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfDimensionLessThan()

        return typing.cast(None, jsii.invoke(self, "putLessThan", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetDimension")
    def reset_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimension", []))

    @jsii.member(jsii_name="resetDimensionVar")
    def reset_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimensionVar", []))

    @jsii.member(jsii_name="resetEqual")
    def reset_equal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEqual", []))

    @jsii.member(jsii_name="resetGreaterThan")
    def reset_greater_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGreaterThan", []))

    @jsii.member(jsii_name="resetLessThan")
    def reset_less_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLessThan", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfDimensionDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfDimensionDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="equal")
    def equal(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfDimensionEqualOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfDimensionEqualOutputReference, jsii.get(self, "equal"))

    @builtins.property
    @jsii.member(jsii_name="greaterThan")
    def greater_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfDimensionGreaterThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfDimensionGreaterThanOutputReference, jsii.get(self, "greaterThan"))

    @builtins.property
    @jsii.member(jsii_name="lessThan")
    def less_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfDimensionLessThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfDimensionLessThanOutputReference, jsii.get(self, "lessThan"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfDimensionDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionInput")
    def dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionVarInput")
    def dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="equalInput")
    def equal_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfDimensionEqual], jsii.get(self, "equalInput"))

    @builtins.property
    @jsii.member(jsii_name="greaterThanInput")
    def greater_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfDimensionGreaterThan], jsii.get(self, "greaterThanInput"))

    @builtins.property
    @jsii.member(jsii_name="lessThanInput")
    def less_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfDimensionLessThan], jsii.get(self, "lessThanInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="dimension")
    def dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimension"))

    @dimension.setter
    def dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ce9b0c0a269996564d5a64ea00792214bf1e626647243b341d2a3ddd988095cc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimension", value)

    @builtins.property
    @jsii.member(jsii_name="dimensionVar")
    def dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimensionVar"))

    @dimension_var.setter
    def dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__262131cb04117bc85a9a1e85fedb5c1ef947688fdb3237551b0793a1bad38d73)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ebf19715c2f88dfbedc974779cc45a0dcd7ef6f16e127f9076e0c190bb72b5ef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__038366eae7c285d48761a80883c48fc3b9a321cbaad49a2f8d5f38142244f77d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfDimension]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfDimension]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfDimension]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4e28e88625a3033e40a0f18cc4b05501a0f4f19cfe2d24bdd9e1c68422d5d716)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfOrientation",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "landscape": "landscape",
        "portrait": "portrait",
        "square": "square",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfOrientation:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfOrientationDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        landscape: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfOrientationLandscape", typing.Dict[builtins.str, typing.Any]]] = None,
        portrait: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfOrientationPortrait", typing.Dict[builtins.str, typing.Any]]] = None,
        square: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfOrientationSquare", typing.Dict[builtins.str, typing.Any]]] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param landscape: landscape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        :param portrait: portrait block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        :param square: square block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfOrientationDefault(**default)
        if isinstance(landscape, dict):
            landscape = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfOrientationLandscape(**landscape)
        if isinstance(portrait, dict):
            portrait = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfOrientationPortrait(**portrait)
        if isinstance(square, dict):
            square = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfOrientationSquare(**square)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__04fabac9608ed214e2789b12e4a6c62578ca715da505c4fe1882d0c8e8a19526)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument landscape", value=landscape, expected_type=type_hints["landscape"])
            check_type(argname="argument portrait", value=portrait, expected_type=type_hints["portrait"])
            check_type(argname="argument square", value=square, expected_type=type_hints["square"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if landscape is not None:
            self._values["landscape"] = landscape
        if portrait is not None:
            self._values["portrait"] = portrait
        if square is not None:
            self._values["square"] = square

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfOrientationDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfOrientationDefault"], result)

    @builtins.property
    def landscape(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfOrientationLandscape"]:
        '''landscape block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        '''
        result = self._values.get("landscape")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfOrientationLandscape"], result)

    @builtins.property
    def portrait(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfOrientationPortrait"]:
        '''portrait block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        '''
        result = self._values.get("portrait")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfOrientationPortrait"], result)

    @builtins.property
    def square(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfOrientationSquare"]:
        '''square block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        result = self._values.get("square")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfOrientationSquare"], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfOrientation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfOrientationDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfOrientationDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfOrientationDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfOrientationDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfOrientationDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f8db131e078703dfbba6d36f2b3fbde0f7e30911c7379079faab0ea13adb8cbb)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfOrientationDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfOrientationDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fb08a8497ae08bb417a361fdb6fc9d7cf7cab8743d669c40f74fbb4ceeea269d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfOrientationLandscape",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfOrientationLandscape:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfOrientationLandscape(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfOrientationLandscapeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfOrientationLandscapeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aae3096f4666267a4e0998af1a2d5bae73e7c5ee00d6d29f3289681144072653)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfOrientationLandscape], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfOrientationLandscape],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc5e123e3f71d6871057c1822ee9412e7e1090f29d4eabd95e9ae2bf34157a83)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfOrientationList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfOrientationList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__112fe984b88cd9f6795771b7cefc453d2c81b073fd3d510e7edb7eda99703f1e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfOrientationOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ed3ca9dc827ba6a5d3e09957f5e6bb7733e1df725e1a771c6d28110e337837c5)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfOrientationOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ba7391c9a722c3b42a80beea857ea207d6449eb3e0f68251a33a62b4957ab764)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b8c8bc3c265077bd21e1831ebd1f53c03bb14dc09ee257b2c6c3989c171a614a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__998456c47eaa6e93bfff9f31eb6f2283f68ec19deec4c21cbe1bb23820354fb9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfOrientation]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfOrientation]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6754feb47a0ad2c381e142c0bec517c61b627beecb11b8fed19a8ee6463e0209)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfOrientationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfOrientationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9e8eebaa63c4f059dc194d653946865c18ba39aeb51d18659d3b6d1dc648619b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfOrientationDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putLandscape")
    def put_landscape(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfOrientationLandscape()

        return typing.cast(None, jsii.invoke(self, "putLandscape", [value]))

    @jsii.member(jsii_name="putPortrait")
    def put_portrait(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfOrientationPortrait()

        return typing.cast(None, jsii.invoke(self, "putPortrait", [value]))

    @jsii.member(jsii_name="putSquare")
    def put_square(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfOrientationSquare()

        return typing.cast(None, jsii.invoke(self, "putSquare", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetLandscape")
    def reset_landscape(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLandscape", []))

    @jsii.member(jsii_name="resetPortrait")
    def reset_portrait(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPortrait", []))

    @jsii.member(jsii_name="resetSquare")
    def reset_square(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSquare", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfOrientationDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfOrientationDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="landscape")
    def landscape(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfOrientationLandscapeOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfOrientationLandscapeOutputReference, jsii.get(self, "landscape"))

    @builtins.property
    @jsii.member(jsii_name="portrait")
    def portrait(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfOrientationPortraitOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfOrientationPortraitOutputReference", jsii.get(self, "portrait"))

    @builtins.property
    @jsii.member(jsii_name="square")
    def square(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfOrientationSquareOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfOrientationSquareOutputReference", jsii.get(self, "square"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfOrientationDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="landscapeInput")
    def landscape_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfOrientationLandscape], jsii.get(self, "landscapeInput"))

    @builtins.property
    @jsii.member(jsii_name="portraitInput")
    def portrait_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfOrientationPortrait"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfOrientationPortrait"], jsii.get(self, "portraitInput"))

    @builtins.property
    @jsii.member(jsii_name="squareInput")
    def square_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfOrientationSquare"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfOrientationSquare"], jsii.get(self, "squareInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfOrientation]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfOrientation]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfOrientation]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__991ed18d01f1dce8bb40847626c69a5ff8a0919734e7f4120b823c8a0e0efc0c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfOrientationPortrait",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfOrientationPortrait:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfOrientationPortrait(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfOrientationPortraitOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfOrientationPortraitOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__91296a6b8969524d9a12d1dc512fbe67dab4c45790f31fa6b1db977de569d291)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfOrientationPortrait]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfOrientationPortrait], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfOrientationPortrait],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2f44c731271e547001f840052761593a33130c59e3c70b691363d81e9c153669)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfOrientationSquare",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfOrientationSquare:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfOrientationSquare(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfOrientationSquareOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfOrientationSquareOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a7bfa7defafc378d6c98f0bc5d4ca62950ecf431d74418eeaa65298b769121a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfOrientationSquare]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfOrientationSquare], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfOrientationSquare],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b78e750f5e06357757787d353979300ce3239cbac4223c023dbe4c9803648753)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cae3a31dff5106eddff018a0ec4868a0763f48a55c2031f2943108ead47ff67e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__afa603c99e07456b9c9edebbdb5a8643d28246e0e23ac5d95c31f990ddb93915)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__65544c7c4edc1291c9ce7d75586be8744f8c4889453befe7f0415840048566bb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__61e41564394e8b38b2924e3b19bd4f76094117a5601221c70c74c3858f3e57b5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c86e5470fe16e1b2eeebf0065992b541dd8f3100c1aca7094517d3d8c572e673)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformations]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformations]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformations]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1291e3abccb3655de8b75d08e82c0e6db987d3434f707c113f5c90f6378af855)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsMaxColors",
    jsii_struct_bases=[],
    name_mapping={"colors": "colors", "colors_var": "colorsVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsMaxColors:
    def __init__(
        self,
        *,
        colors: typing.Optional[builtins.str] = None,
        colors_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param colors: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        :param colors_var: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c2501368f44cd811987874645c24701f2223dcebfbe944ec44abf96287db92b2)
            check_type(argname="argument colors", value=colors, expected_type=type_hints["colors"])
            check_type(argname="argument colors_var", value=colors_var, expected_type=type_hints["colors_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if colors is not None:
            self._values["colors"] = colors
        if colors_var is not None:
            self._values["colors_var"] = colors_var

    @builtins.property
    def colors(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        '''
        result = self._values.get("colors")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def colors_var(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        result = self._values.get("colors_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsMaxColors(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsMaxColorsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsMaxColorsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ea1206e1088afb5c996788202658290eb6771e045c87d87fc8c62af23bbd3bc)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsMaxColorsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9fec7a07a514cf44a18d83f23be88cb3641d2f0fa25000a8d284b43626af6a06)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsMaxColorsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__53b98c8dcad8d98127f303f02f30d63976dd9423cf6b523d742976ca955c5328)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0b03134ed8ae783ff78dfcd8b114f9fb5e5e52a8d92fc8569541c47950be798d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2b3f6d6bc500e91d9a5ddd8af572792a50769097359c65006007756e47ee26bc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsMaxColors]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsMaxColors]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3633f23859e6a88e6135685e585961c5eecd73d44497d83a2f18be60ebf012b7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsMaxColorsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsMaxColorsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__955922de5096dcec7a32a661578410bc99f52353ea67485e408f308e546a4618)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColors")
    def reset_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColors", []))

    @jsii.member(jsii_name="resetColorsVar")
    def reset_colors_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorsVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorsInput")
    def colors_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsInput"))

    @builtins.property
    @jsii.member(jsii_name="colorsVarInput")
    def colors_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsVarInput"))

    @builtins.property
    @jsii.member(jsii_name="colors")
    def colors(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colors"))

    @colors.setter
    def colors(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c2938a4860d8826804af6026aa271b57345e5c23e4b7db7d832aa49f94256816)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colors", value)

    @builtins.property
    @jsii.member(jsii_name="colorsVar")
    def colors_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorsVar"))

    @colors_var.setter
    def colors_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f25c3cc2441a28eeae6da8f890f2e36a65a1f91ac04adbb3bfc9424860c697c1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorsVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsMaxColors]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsMaxColors]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsMaxColors]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea7d66761008668c26da02318847d2def589155c280ac5cec553c152795a2d35)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsMirror",
    jsii_struct_bases=[],
    name_mapping={
        "horizontal": "horizontal",
        "horizontal_var": "horizontalVar",
        "vertical": "vertical",
        "vertical_var": "verticalVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsMirror:
    def __init__(
        self,
        *,
        horizontal: typing.Optional[builtins.str] = None,
        horizontal_var: typing.Optional[builtins.str] = None,
        vertical: typing.Optional[builtins.str] = None,
        vertical_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param horizontal: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        :param horizontal_var: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        :param vertical: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        :param vertical_var: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a0d82dac5bb3e4d651aa9a28b25c93aacfe66b1f4647da73d53c7b0cadbe9079)
            check_type(argname="argument horizontal", value=horizontal, expected_type=type_hints["horizontal"])
            check_type(argname="argument horizontal_var", value=horizontal_var, expected_type=type_hints["horizontal_var"])
            check_type(argname="argument vertical", value=vertical, expected_type=type_hints["vertical"])
            check_type(argname="argument vertical_var", value=vertical_var, expected_type=type_hints["vertical_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if horizontal is not None:
            self._values["horizontal"] = horizontal
        if horizontal_var is not None:
            self._values["horizontal_var"] = horizontal_var
        if vertical is not None:
            self._values["vertical"] = vertical
        if vertical_var is not None:
            self._values["vertical_var"] = vertical_var

    @builtins.property
    def horizontal(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        '''
        result = self._values.get("horizontal")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def horizontal_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        '''
        result = self._values.get("horizontal_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        '''
        result = self._values.get("vertical")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        result = self._values.get("vertical_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsMirror(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsMirrorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsMirrorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7ec375bfc1ce0a0cfc825da079d9f67f5fe5ccf3a14258b971f6e58d25a5be29)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsMirrorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6b576922dc92ba323f87de42f5ca7b6c05be486f2bcba77bc8af0add7db3a48d)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsMirrorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3512cf7395e6e6f259b37b34bef2d06ef0770e4aa21ae52ec4719534d0b434a8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8bf3cf18c04d24dcf4e7dfd4baa2e35c2dfea44f4025475b20e59e33d40fcda9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__980ffe0dc54c1243f90340d8e4014bd905293c0dd4722b4fa978aa5670e20cb8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsMirror]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsMirror]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4b5187b18946e686d6b7507e1e765732c30db51c87ef3873bfb9e2072acf9f7d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsMirrorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsMirrorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__acf8d7d9d589d7b84a23877972495c9f29c1a0e59d8dc4364bae1015da3930f9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHorizontal")
    def reset_horizontal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontal", []))

    @jsii.member(jsii_name="resetHorizontalVar")
    def reset_horizontal_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontalVar", []))

    @jsii.member(jsii_name="resetVertical")
    def reset_vertical(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVertical", []))

    @jsii.member(jsii_name="resetVerticalVar")
    def reset_vertical_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVerticalVar", []))

    @builtins.property
    @jsii.member(jsii_name="horizontalInput")
    def horizontal_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontalVarInput")
    def horizontal_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalInput")
    def vertical_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalVarInput")
    def vertical_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontal")
    def horizontal(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontal"))

    @horizontal.setter
    def horizontal(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7302481a3e0fdc8387158a93fe62f1279e52bc7e5a9ee4cc377353cb61faef95)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontal", value)

    @builtins.property
    @jsii.member(jsii_name="horizontalVar")
    def horizontal_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontalVar"))

    @horizontal_var.setter
    def horizontal_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3087b42f491848eee16fdbb323a07acadad73c1c902c26f2c11c7d7913722bbc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontalVar", value)

    @builtins.property
    @jsii.member(jsii_name="vertical")
    def vertical(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "vertical"))

    @vertical.setter
    def vertical(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__34b98c94ef431e821c021dc1166af357263425ba772b744dd944edda82b5a843)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "vertical", value)

    @builtins.property
    @jsii.member(jsii_name="verticalVar")
    def vertical_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "verticalVar"))

    @vertical_var.setter
    def vertical_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__830497f72c654e8514ec5509bc9b127c5158f711ecd7ebe6ca5c01a7cd67f600)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "verticalVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsMirror]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsMirror]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsMirror]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7707428125608c1b148625d52019944f3a57d9ffb18c24cc5b13041eae1c5319)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsMonoHue",
    jsii_struct_bases=[],
    name_mapping={"hue": "hue", "hue_var": "hueVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsMonoHue:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dba95a5e5c00065479bbdcb1cc64503b062807292e83ad55eab80fd0a4b100b7)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsMonoHue(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsMonoHueList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsMonoHueList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d9901138111a931a6fc10c84dcbc98e661ceb16edf4bab5bb5ec4777eb7403b3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsMonoHueOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a9b2d0d85bc8ad01665fe6045102d0cac27ccd6a997e693dca3413f75b2e5d0)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsMonoHueOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d7cc4b8d382b9a0150739ae69e0ed90719c89a48c4a3ccabadbbb2ef754e3b8a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__07c5d77d9b6e646a1b141484773176cf999bc552f2d4d251bd8d3186d10ad201)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__382c504029d21befb85a00a07bcf4a503d2bd97997ec8df1261b343a5ddd74a1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsMonoHue]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsMonoHue]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e395e07cb0f20c86ccadc5aed6b163e9dcf2d268f9edda37e323183138a3e59)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsMonoHueOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsMonoHueOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bbdcbc2831f1b7b27f847d367954339ab6e7d958e6d4a4990db46810558c3316)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f8115be7723f474bbedcedc2711868b580b6e8ffc1222cc5e2a1b9b0b3268a9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__49614793dee196856722ef7949393e4ff2b9c8fbd76caaadbb408fd1e659b9f0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsMonoHue]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsMonoHue]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsMonoHue]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e250a2af46c1761e45e563d51f8b5726e85bce2743fc9ddb5bac0a190a2b8a20)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsOpacity",
    jsii_struct_bases=[],
    name_mapping={"opacity": "opacity", "opacity_var": "opacityVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsOpacity:
    def __init__(
        self,
        *,
        opacity: typing.Optional[builtins.str] = None,
        opacity_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param opacity: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param opacity_var: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d4a2e74c9cd1c38e6f60dc3bb3b7f9cd95f05eabb4396578ad31c2658fafa379)
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument opacity_var", value=opacity_var, expected_type=type_hints["opacity_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if opacity is not None:
            self._values["opacity"] = opacity
        if opacity_var is not None:
            self._values["opacity_var"] = opacity_var

    @builtins.property
    def opacity(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def opacity_var(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        result = self._values.get("opacity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsOpacity(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsOpacityList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsOpacityList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__80ccbc76422830ff68aae1a641684402f69f3bed1f9fab31c15a3f2c248b4950)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsOpacityOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__56ce714425d43b4324e6092ab39474f5d6eb032ebc05fa3627be0f6f20f67303)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsOpacityOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e61d467b89b6a5c71d6e79daf986d6c3117810e6ce0c4ed3136bd98021838d2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a4c6fee72bacbc74a8782c97cca4fcd3ab61bdafc87a92c000706824cfa73f50)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c274a9d084064abb7dd1df36169bae74df22d0511f1c04b4eabcf55bf67fa599)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsOpacity]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsOpacity]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__57f8339aed39f40c808d8c35b472e2e6ee3104170f080fd8630ce2ea4cfd22d1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsOpacityOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsOpacityOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ffa9763ccaebbf0787983fcd2ee1865894e608145bf67fded50441303bcd4bf5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetOpacityVar")
    def reset_opacity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacityVar", []))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityVarInput")
    def opacity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacity"))

    @opacity.setter
    def opacity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__604832317b023a77939c9209e6f0e12fc9b41e4d3067eace7690abd359a101b2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacity", value)

    @builtins.property
    @jsii.member(jsii_name="opacityVar")
    def opacity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacityVar"))

    @opacity_var.setter
    def opacity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__de3c1ebc6c5f604321551eeead53076ef7ff14bcbd49b13e50ccb5f1a0c32c09)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacityVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsOpacity]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsOpacity]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsOpacity]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e41fc2a411a8be797bcdfa6c5127479595b454d8136e636123ea84924b114624)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0f635b186503f56dd6446e332808f6b53d379fa92d55bb8a34df662c9bddd7b6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putBackgroundColor")
    def put_background_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__789940e54b4e9ce429d1b58dd6acacc0b78867bcd21aa716dbea4a7048558552)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBackgroundColor", [value]))

    @jsii.member(jsii_name="putBlur")
    def put_blur(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsBlur, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__db3b7146831f808929a18c661d6c6b9ec5cb3610945889e474dda6a2a8089c9a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBlur", [value]))

    @jsii.member(jsii_name="putChromaKey")
    def put_chroma_key(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsChromaKey, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__04adb027962ae81a119583e958a00fa6613cc14cf5e97812a1dae0de1f9ec778)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putChromaKey", [value]))

    @jsii.member(jsii_name="putComposite")
    def put_composite(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsComposite, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0135039cb2c191371fd5a93926ff30d2e3662c061b874c6e793a35cc1d5fa4b2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putComposite", [value]))

    @jsii.member(jsii_name="putCompound")
    def put_compound(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsCompound, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ee674afdf477fe1c4e679fb41a58fcd0894e9ecd3fbdd1d40458046a01bc77d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCompound", [value]))

    @jsii.member(jsii_name="putContrast")
    def put_contrast(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsContrast, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__208e9da68e0f376f94497175b5f038369510f6e7179adf5eadf20abac4df237d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putContrast", [value]))

    @jsii.member(jsii_name="putGoop")
    def put_goop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsGoop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__49af1b0761b19d838e1f42b4dcc5506e91472e6b509a8d954e1d4f862c2579c7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGoop", [value]))

    @jsii.member(jsii_name="putGrayscale")
    def put_grayscale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsGrayscale, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4bb1f716d738458274fce754eb1ba93131ed6ec91a5bc5879728fdd217f2d3fa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGrayscale", [value]))

    @jsii.member(jsii_name="putHsl")
    def put_hsl(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsHsl, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8384131d26d6e091368e6bea0a5b5bc442e62ea696454c3758005923d3c1bbec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsl", [value]))

    @jsii.member(jsii_name="putHsv")
    def put_hsv(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsHsv, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__19b18edbb5c5204b3a8b0e8cc8eab5d773bc4c071ca8ab7e133af96aa90e26f8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsv", [value]))

    @jsii.member(jsii_name="putIfDimension")
    def put_if_dimension(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfDimension, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1523fed1c9fb44e6b5cf03fcd7dd2bb18ba0a1fafbe14664ccaa779ee5133864)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfDimension", [value]))

    @jsii.member(jsii_name="putIfOrientation")
    def put_if_orientation(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f22577b7b9d36e8c6daf31c3d444d570af7a3b72ec6140a4efe4f33d26b07275)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfOrientation", [value]))

    @jsii.member(jsii_name="putMaxColors")
    def put_max_colors(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsMaxColors, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5c8ac3c2c4ddab9a7d4c4fcfeacfff77b8c86603ba557c7c982cdfab23732cb5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMaxColors", [value]))

    @jsii.member(jsii_name="putMirror")
    def put_mirror(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsMirror, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0c69bcae21dc150eb5453e97ec65eab1711d5ec94e3175c1acdacf2d1e582d6c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMirror", [value]))

    @jsii.member(jsii_name="putMonoHue")
    def put_mono_hue(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsMonoHue, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__31e977d8d38b5aef0e3aa0a2eab9fbd7e0020024aafd0ab603788e39aa49e44b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMonoHue", [value]))

    @jsii.member(jsii_name="putOpacity")
    def put_opacity(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsOpacity, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8f5f47085afa8d1828203739fc1e0df08111f4a2b4f6baec5fd2da9056371238)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putOpacity", [value]))

    @jsii.member(jsii_name="putRemoveColor")
    def put_remove_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsRemoveColor", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__75d775798204bea596ce8ed964763cf6c93fa489e649d593c42a243a5d55aae1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRemoveColor", [value]))

    @jsii.member(jsii_name="putUnsharpMask")
    def put_unsharp_mask(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsUnsharpMask", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__13c03eaf5570de2ad74a339ac8327d5fdd2aaa9f028dcc67718a5330eb9c106f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putUnsharpMask", [value]))

    @jsii.member(jsii_name="resetBackgroundColor")
    def reset_background_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBackgroundColor", []))

    @jsii.member(jsii_name="resetBlur")
    def reset_blur(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBlur", []))

    @jsii.member(jsii_name="resetChromaKey")
    def reset_chroma_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChromaKey", []))

    @jsii.member(jsii_name="resetComposite")
    def reset_composite(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetComposite", []))

    @jsii.member(jsii_name="resetCompound")
    def reset_compound(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCompound", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetGoop")
    def reset_goop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGoop", []))

    @jsii.member(jsii_name="resetGrayscale")
    def reset_grayscale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGrayscale", []))

    @jsii.member(jsii_name="resetHsl")
    def reset_hsl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsl", []))

    @jsii.member(jsii_name="resetHsv")
    def reset_hsv(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsv", []))

    @jsii.member(jsii_name="resetIfDimension")
    def reset_if_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfDimension", []))

    @jsii.member(jsii_name="resetIfOrientation")
    def reset_if_orientation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfOrientation", []))

    @jsii.member(jsii_name="resetMaxColors")
    def reset_max_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxColors", []))

    @jsii.member(jsii_name="resetMirror")
    def reset_mirror(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMirror", []))

    @jsii.member(jsii_name="resetMonoHue")
    def reset_mono_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonoHue", []))

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetRemoveColor")
    def reset_remove_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRemoveColor", []))

    @jsii.member(jsii_name="resetUnsharpMask")
    def reset_unsharp_mask(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUnsharpMask", []))

    @builtins.property
    @jsii.member(jsii_name="backgroundColor")
    def background_color(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsBackgroundColorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsBackgroundColorList, jsii.get(self, "backgroundColor"))

    @builtins.property
    @jsii.member(jsii_name="blur")
    def blur(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsBlurList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsBlurList, jsii.get(self, "blur"))

    @builtins.property
    @jsii.member(jsii_name="chromaKey")
    def chroma_key(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsChromaKeyList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsChromaKeyList, jsii.get(self, "chromaKey"))

    @builtins.property
    @jsii.member(jsii_name="composite")
    def composite(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsCompositeList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsCompositeList, jsii.get(self, "composite"))

    @builtins.property
    @jsii.member(jsii_name="compound")
    def compound(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsCompoundList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsCompoundList, jsii.get(self, "compound"))

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsContrastList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsContrastList, jsii.get(self, "contrast"))

    @builtins.property
    @jsii.member(jsii_name="goop")
    def goop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsGoopList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsGoopList, jsii.get(self, "goop"))

    @builtins.property
    @jsii.member(jsii_name="grayscale")
    def grayscale(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsGrayscaleList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsGrayscaleList, jsii.get(self, "grayscale"))

    @builtins.property
    @jsii.member(jsii_name="hsl")
    def hsl(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsHslList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsHslList, jsii.get(self, "hsl"))

    @builtins.property
    @jsii.member(jsii_name="hsv")
    def hsv(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsHsvList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsHsvList, jsii.get(self, "hsv"))

    @builtins.property
    @jsii.member(jsii_name="ifDimension")
    def if_dimension(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfDimensionList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfDimensionList, jsii.get(self, "ifDimension"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientation")
    def if_orientation(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfOrientationList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfOrientationList, jsii.get(self, "ifOrientation"))

    @builtins.property
    @jsii.member(jsii_name="maxColors")
    def max_colors(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsMaxColorsList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsMaxColorsList, jsii.get(self, "maxColors"))

    @builtins.property
    @jsii.member(jsii_name="mirror")
    def mirror(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsMirrorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsMirrorList, jsii.get(self, "mirror"))

    @builtins.property
    @jsii.member(jsii_name="monoHue")
    def mono_hue(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsMonoHueList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsMonoHueList, jsii.get(self, "monoHue"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsOpacityList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsOpacityList, jsii.get(self, "opacity"))

    @builtins.property
    @jsii.member(jsii_name="removeColor")
    def remove_color(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsRemoveColorList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsRemoveColorList", jsii.get(self, "removeColor"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMask")
    def unsharp_mask(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsUnsharpMaskList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsUnsharpMaskList", jsii.get(self, "unsharpMask"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColorInput")
    def background_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsBackgroundColor]]], jsii.get(self, "backgroundColorInput"))

    @builtins.property
    @jsii.member(jsii_name="blurInput")
    def blur_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsBlur]]], jsii.get(self, "blurInput"))

    @builtins.property
    @jsii.member(jsii_name="chromaKeyInput")
    def chroma_key_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsChromaKey]]], jsii.get(self, "chromaKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="compositeInput")
    def composite_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsComposite]]], jsii.get(self, "compositeInput"))

    @builtins.property
    @jsii.member(jsii_name="compoundInput")
    def compound_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsCompound]]], jsii.get(self, "compoundInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsContrast]]], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="goopInput")
    def goop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsGoop]]], jsii.get(self, "goopInput"))

    @builtins.property
    @jsii.member(jsii_name="grayscaleInput")
    def grayscale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsGrayscale]]], jsii.get(self, "grayscaleInput"))

    @builtins.property
    @jsii.member(jsii_name="hslInput")
    def hsl_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsHsl]]], jsii.get(self, "hslInput"))

    @builtins.property
    @jsii.member(jsii_name="hsvInput")
    def hsv_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsHsv]]], jsii.get(self, "hsvInput"))

    @builtins.property
    @jsii.member(jsii_name="ifDimensionInput")
    def if_dimension_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfDimension]]], jsii.get(self, "ifDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientationInput")
    def if_orientation_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfOrientation]]], jsii.get(self, "ifOrientationInput"))

    @builtins.property
    @jsii.member(jsii_name="maxColorsInput")
    def max_colors_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsMaxColors]]], jsii.get(self, "maxColorsInput"))

    @builtins.property
    @jsii.member(jsii_name="mirrorInput")
    def mirror_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsMirror]]], jsii.get(self, "mirrorInput"))

    @builtins.property
    @jsii.member(jsii_name="monoHueInput")
    def mono_hue_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsMonoHue]]], jsii.get(self, "monoHueInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsOpacity]]], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="removeColorInput")
    def remove_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsRemoveColor"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsRemoveColor"]]], jsii.get(self, "removeColorInput"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMaskInput")
    def unsharp_mask_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsUnsharpMask"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsUnsharpMask"]]], jsii.get(self, "unsharpMaskInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformations]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformations]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformations]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1c25b861af50a8025399916c06d96a8092dada31fa7fcdeb3cc761e6d2ce0a77)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsRemoveColor",
    jsii_struct_bases=[],
    name_mapping={
        "color": "color",
        "color_var": "colorVar",
        "feather": "feather",
        "feather_var": "featherVar",
        "tolerance": "tolerance",
        "tolerance_var": "toleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsRemoveColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
        feather: typing.Optional[builtins.str] = None,
        feather_var: typing.Optional[builtins.str] = None,
        tolerance: typing.Optional[builtins.str] = None,
        tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        :param feather: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        :param feather_var: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        :param tolerance: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        :param tolerance_var: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bf23b074f76bcde96d4f8ab54358e0aff6e52ee66e0cc42b9b5dfa179e35083c)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
            check_type(argname="argument feather", value=feather, expected_type=type_hints["feather"])
            check_type(argname="argument feather_var", value=feather_var, expected_type=type_hints["feather_var"])
            check_type(argname="argument tolerance", value=tolerance, expected_type=type_hints["tolerance"])
            check_type(argname="argument tolerance_var", value=tolerance_var, expected_type=type_hints["tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var
        if feather is not None:
            self._values["feather"] = feather
        if feather_var is not None:
            self._values["feather_var"] = feather_var
        if tolerance is not None:
            self._values["tolerance"] = tolerance
        if tolerance_var is not None:
            self._values["tolerance_var"] = tolerance_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        '''
        result = self._values.get("feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather_var(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        '''
        result = self._values.get("feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        '''
        result = self._values.get("tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance_var(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        result = self._values.get("tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsRemoveColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsRemoveColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsRemoveColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa66f72118aa5e6e2687d0a48512ea903abfc8c1d385e291d44418b978c47887)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsRemoveColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f30015fccd34ae832725224e39e117c819d31cfc23249ceedec43419bb3fb241)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsRemoveColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ef51affb621d17063187f817f7cf4b5726a08a8ca10a32569f6bf89434f3d5ee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5e4746286644803888ac9e0bc5e1d4b8089a12e1ea1c3e6d4526d242c6966499)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ab4e635c041ac7eff2515345b7bf7903550515c6914d19c1c5509daa27d6bda)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsRemoveColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsRemoveColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsRemoveColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__26cc47671699aca0ea05629afeb9ca61ba6476436e68e4a2e9502f90501a91eb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsRemoveColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsRemoveColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c4e976cd91d79f6656bec42ae4b44bf001f5a67bbcb18606cd97f3b29499157c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @jsii.member(jsii_name="resetFeather")
    def reset_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeather", []))

    @jsii.member(jsii_name="resetFeatherVar")
    def reset_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatherVar", []))

    @jsii.member(jsii_name="resetTolerance")
    def reset_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTolerance", []))

    @jsii.member(jsii_name="resetToleranceVar")
    def reset_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featherInput")
    def feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherInput"))

    @builtins.property
    @jsii.member(jsii_name="featherVarInput")
    def feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceInput")
    def tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceVarInput")
    def tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dd8401fb3affc93c7a6e73491ab030110e07916c876068721a57b389e5c897d2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1a12083989865313d44d20025ad014edf9033717203d28418eaf809411e36aa9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="feather")
    def feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "feather"))

    @feather.setter
    def feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f869b03ae18b9e8558ec5013d0fe5223fb370dd4b956004ecc8e13da8f7e75a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "feather", value)

    @builtins.property
    @jsii.member(jsii_name="featherVar")
    def feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featherVar"))

    @feather_var.setter
    def feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b3d0136f175e718a1fea7dac91a2803dfb4766095de40d1cd308a8b912f23da9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featherVar", value)

    @builtins.property
    @jsii.member(jsii_name="tolerance")
    def tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tolerance"))

    @tolerance.setter
    def tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dce993468733384c6b250f4c558b0205f3278b68201912f65cb6f92e661a3f66)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tolerance", value)

    @builtins.property
    @jsii.member(jsii_name="toleranceVar")
    def tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "toleranceVar"))

    @tolerance_var.setter
    def tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6c9004a06ecee745693a151bb4b54358fab9a39206265af7e13e922af2ce869e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "toleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsRemoveColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsRemoveColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsRemoveColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df6991fcfd2694b960e09f3258f61452360fd7421953a7e30b8c117deb6325d4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsUnsharpMask",
    jsii_struct_bases=[],
    name_mapping={
        "gain": "gain",
        "gain_var": "gainVar",
        "sigma": "sigma",
        "sigma_var": "sigmaVar",
        "threshold": "threshold",
        "threshold_var": "thresholdVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsUnsharpMask:
    def __init__(
        self,
        *,
        gain: typing.Optional[builtins.str] = None,
        gain_var: typing.Optional[builtins.str] = None,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
        threshold: typing.Optional[builtins.str] = None,
        threshold_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param gain: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        :param gain_var: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        :param sigma: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        :param threshold: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        :param threshold_var: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc5139576a80ab741c8fa53142ed1cc2f262ea42bab213f7dabfd32df83aed03)
            check_type(argname="argument gain", value=gain, expected_type=type_hints["gain"])
            check_type(argname="argument gain_var", value=gain_var, expected_type=type_hints["gain_var"])
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
            check_type(argname="argument threshold", value=threshold, expected_type=type_hints["threshold"])
            check_type(argname="argument threshold_var", value=threshold_var, expected_type=type_hints["threshold_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if gain is not None:
            self._values["gain"] = gain
        if gain_var is not None:
            self._values["gain_var"] = gain_var
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var
        if threshold is not None:
            self._values["threshold"] = threshold
        if threshold_var is not None:
            self._values["threshold_var"] = threshold_var

    @builtins.property
    def gain(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        '''
        result = self._values.get("gain")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gain_var(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        '''
        result = self._values.get("gain_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        '''
        result = self._values.get("threshold")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold_var(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        result = self._values.get("threshold_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsUnsharpMask(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsUnsharpMaskList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsUnsharpMaskList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__16a4c6361cc4a5cc2477b46fd48d95088ee559e13bd07e9bb1cd051e0e2f878e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsUnsharpMaskOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f80dbae9a184182a9f438740fa6012d844c74c3c0498b46f88e1c249d5088551)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsUnsharpMaskOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2db49dad55167a4af7ea3645695419758119c79a16e8f29bbc878b49d2a32a0d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a9c21231b41046aa7cbc3efaf17dba8621478e26e0555eec0bf1533c7ce58699)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__056ace49bd649626f63e3b95caa889ab294c597f4121e80187fadc229d057835)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsUnsharpMask]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsUnsharpMask]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsUnsharpMask]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__625c1675648343d77f0d83a8b3631bde3a91cbdf5bd54b66a8e20d3bea4f84ce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsUnsharpMaskOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsUnsharpMaskOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__86e538ba0b4a69ee019b32b4c30806715731b0e368502e0bac8ce53e7bb26597)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetGain")
    def reset_gain(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGain", []))

    @jsii.member(jsii_name="resetGainVar")
    def reset_gain_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGainVar", []))

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @jsii.member(jsii_name="resetThreshold")
    def reset_threshold(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThreshold", []))

    @jsii.member(jsii_name="resetThresholdVar")
    def reset_threshold_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThresholdVar", []))

    @builtins.property
    @jsii.member(jsii_name="gainInput")
    def gain_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainInput"))

    @builtins.property
    @jsii.member(jsii_name="gainVarInput")
    def gain_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdInput")
    def threshold_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdVarInput")
    def threshold_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gain")
    def gain(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gain"))

    @gain.setter
    def gain(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__efafea157b62a694987452df60c3431698a6840a1f1cb9aaf8d4ce1d9ef180e3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gain", value)

    @builtins.property
    @jsii.member(jsii_name="gainVar")
    def gain_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gainVar"))

    @gain_var.setter
    def gain_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__85cdd4f6ecb078e8d75c5b54c059f9a01e23832cdce6954d79fca12aa4f2cee7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gainVar", value)

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cffaf014149b4b389a807867680b16eb0427f7bbc4400ddb473062f8c9f3e196)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c4d7a897e7fe5ba91a06eac97778eff078492ba3238f80e5e5d42f6c29df0020)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="threshold")
    def threshold(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "threshold"))

    @threshold.setter
    def threshold(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9f32c790606d7690df7fdfc9a41e4c1cc202644e0e815ee47bab23d981373f26)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "threshold", value)

    @builtins.property
    @jsii.member(jsii_name="thresholdVar")
    def threshold_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "thresholdVar"))

    @threshold_var.setter
    def threshold_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5c2e9f7a007dec22e452700db3c406273a1dcee38567c889def9c0fd7a0195b2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "thresholdVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsUnsharpMask]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsUnsharpMask]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsUnsharpMask]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__670cf4ac1d83f51d12f6e49ce0293491fe17a7da0103d90e1658f4297063c282)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeContrast",
    jsii_struct_bases=[],
    name_mapping={
        "brightness": "brightness",
        "brightness_var": "brightnessVar",
        "contrast": "contrast",
        "contrast_var": "contrastVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeContrast:
    def __init__(
        self,
        *,
        brightness: typing.Optional[builtins.str] = None,
        brightness_var: typing.Optional[builtins.str] = None,
        contrast: typing.Optional[builtins.str] = None,
        contrast_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param brightness: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        :param brightness_var: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        :param contrast: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param contrast_var: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f87420c87f786a1056e68b0bb9be0d3418c147ef09e6acf0de2a8000e9fbef06)
            check_type(argname="argument brightness", value=brightness, expected_type=type_hints["brightness"])
            check_type(argname="argument brightness_var", value=brightness_var, expected_type=type_hints["brightness_var"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument contrast_var", value=contrast_var, expected_type=type_hints["contrast_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if brightness is not None:
            self._values["brightness"] = brightness
        if brightness_var is not None:
            self._values["brightness_var"] = brightness_var
        if contrast is not None:
            self._values["contrast"] = contrast
        if contrast_var is not None:
            self._values["contrast_var"] = contrast_var

    @builtins.property
    def brightness(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        '''
        result = self._values.get("brightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def brightness_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        '''
        result = self._values.get("brightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        result = self._values.get("contrast_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeContrast(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeContrastList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeContrastList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__75f3f4faf7d496702220bff46ca7f7cb9cb4c162d830e56794a52951ccc88423)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeContrastOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd995d50633276ef340c9573b5b064481df02cde4e66e8694e6c5806f6a24749)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeContrastOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4218530f4bc297b3f39f636cd22c8d1c0e5cd3fd0188cca4ccd826d244d8e567)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ec33e06d95a6bc7a12b0e0aa5558eacea5496254905062f28a225c509ade9481)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__afad2ffc2581a36b7ba4b71e36d0f640fadea8df518959432933ea73d930e339)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeContrast]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeContrast]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__34e3a4f7b97ca8f1f5df8b002a64fa3b733e2c79f8266c9054aa56eff4411d41)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeContrastOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeContrastOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5882bbab58a923a929bb7349ca04f49277a26e837e2f9d9b607b551fbea63306)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetBrightness")
    def reset_brightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightness", []))

    @jsii.member(jsii_name="resetBrightnessVar")
    def reset_brightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightnessVar", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetContrastVar")
    def reset_contrast_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrastVar", []))

    @builtins.property
    @jsii.member(jsii_name="brightnessInput")
    def brightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="brightnessVarInput")
    def brightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastVarInput")
    def contrast_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="brightness")
    def brightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightness"))

    @brightness.setter
    def brightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ee0efb6e4771bede075a4fa7bb0f1703cfe34b969201542a2a10503ac8b0b75f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightness", value)

    @builtins.property
    @jsii.member(jsii_name="brightnessVar")
    def brightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightnessVar"))

    @brightness_var.setter
    def brightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6a18dd61946d2afd5499780093fbebd3b0e40eb9697e6c220fa3b68f65b7d509)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrast"))

    @contrast.setter
    def contrast(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b965d4d940917a5afa8067ac65e251667336a2f77920702f0ff31ca248c2f8aa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrast", value)

    @builtins.property
    @jsii.member(jsii_name="contrastVar")
    def contrast_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrastVar"))

    @contrast_var.setter
    def contrast_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__33dc23a5dcf85667ebbb9cbde74efb569a0c290868d98973080844b47b5335aa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrastVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeContrast]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeContrast]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeContrast]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9755f6eaab856ed0b615e762d9af5bd73fe10c3054ea5d3e8c680ddc1595924f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeGoop",
    jsii_struct_bases=[],
    name_mapping={
        "chaos": "chaos",
        "chaos_var": "chaosVar",
        "density": "density",
        "density_var": "densityVar",
        "power": "power",
        "power_var": "powerVar",
        "seed": "seed",
        "seed_var": "seedVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeGoop:
    def __init__(
        self,
        *,
        chaos: typing.Optional[builtins.str] = None,
        chaos_var: typing.Optional[builtins.str] = None,
        density: typing.Optional[builtins.str] = None,
        density_var: typing.Optional[builtins.str] = None,
        power: typing.Optional[builtins.str] = None,
        power_var: typing.Optional[builtins.str] = None,
        seed: typing.Optional[builtins.str] = None,
        seed_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param chaos: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        :param chaos_var: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        :param density: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        :param density_var: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        :param power: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        :param power_var: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        :param seed: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        :param seed_var: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__19f9083761d13c93b34cb32bea8ba37beb9a4836d8eb053d22a61c32bc7a7e4c)
            check_type(argname="argument chaos", value=chaos, expected_type=type_hints["chaos"])
            check_type(argname="argument chaos_var", value=chaos_var, expected_type=type_hints["chaos_var"])
            check_type(argname="argument density", value=density, expected_type=type_hints["density"])
            check_type(argname="argument density_var", value=density_var, expected_type=type_hints["density_var"])
            check_type(argname="argument power", value=power, expected_type=type_hints["power"])
            check_type(argname="argument power_var", value=power_var, expected_type=type_hints["power_var"])
            check_type(argname="argument seed", value=seed, expected_type=type_hints["seed"])
            check_type(argname="argument seed_var", value=seed_var, expected_type=type_hints["seed_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if chaos is not None:
            self._values["chaos"] = chaos
        if chaos_var is not None:
            self._values["chaos_var"] = chaos_var
        if density is not None:
            self._values["density"] = density
        if density_var is not None:
            self._values["density_var"] = density_var
        if power is not None:
            self._values["power"] = power
        if power_var is not None:
            self._values["power_var"] = power_var
        if seed is not None:
            self._values["seed"] = seed
        if seed_var is not None:
            self._values["seed_var"] = seed_var

    @builtins.property
    def chaos(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        '''
        result = self._values.get("chaos")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def chaos_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        '''
        result = self._values.get("chaos_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        '''
        result = self._values.get("density")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density_var(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        '''
        result = self._values.get("density_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        '''
        result = self._values.get("power")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power_var(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        '''
        result = self._values.get("power_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        '''
        result = self._values.get("seed")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed_var(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        result = self._values.get("seed_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeGoop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeGoopList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeGoopList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b32a1667e5040ee92d322a88614f9b1f8af5501d18ea113cf2f49911dd061091)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeGoopOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__98a0dbb6784c44b4d7abb02d6bafdda77704858b82fc3dae620387f37632fdf5)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeGoopOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__788e1908a37c5c01176376545738c830cb975ef82618156ab64e33f7b8b6c926)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d52934a884701152d19a00628ceeef2c6fb668366a77bb1cefd96eb6b3f0454a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bd24f493ce2e0ec83b18b305d25b5891446593c5fd302155a63448abc653e5e2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeGoop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeGoop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1deb54984a0afc4cd9f3ad8778c419325648b7c61bc618667554840959daad4e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeGoopOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeGoopOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e7bf08531a8ef1a891b9ced54b3629dc551ce22ec741dfc9ef2f2d297e23b236)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetChaos")
    def reset_chaos(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaos", []))

    @jsii.member(jsii_name="resetChaosVar")
    def reset_chaos_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaosVar", []))

    @jsii.member(jsii_name="resetDensity")
    def reset_density(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensity", []))

    @jsii.member(jsii_name="resetDensityVar")
    def reset_density_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensityVar", []))

    @jsii.member(jsii_name="resetPower")
    def reset_power(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPower", []))

    @jsii.member(jsii_name="resetPowerVar")
    def reset_power_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPowerVar", []))

    @jsii.member(jsii_name="resetSeed")
    def reset_seed(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeed", []))

    @jsii.member(jsii_name="resetSeedVar")
    def reset_seed_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeedVar", []))

    @builtins.property
    @jsii.member(jsii_name="chaosInput")
    def chaos_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosInput"))

    @builtins.property
    @jsii.member(jsii_name="chaosVarInput")
    def chaos_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosVarInput"))

    @builtins.property
    @jsii.member(jsii_name="densityInput")
    def density_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityInput"))

    @builtins.property
    @jsii.member(jsii_name="densityVarInput")
    def density_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="powerInput")
    def power_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerInput"))

    @builtins.property
    @jsii.member(jsii_name="powerVarInput")
    def power_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerVarInput"))

    @builtins.property
    @jsii.member(jsii_name="seedInput")
    def seed_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedInput"))

    @builtins.property
    @jsii.member(jsii_name="seedVarInput")
    def seed_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedVarInput"))

    @builtins.property
    @jsii.member(jsii_name="chaos")
    def chaos(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaos"))

    @chaos.setter
    def chaos(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__58df99c592be7e85ce07808a098e653d403ff4102e4286523a3cd78d6b2e7bf3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaos", value)

    @builtins.property
    @jsii.member(jsii_name="chaosVar")
    def chaos_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaosVar"))

    @chaos_var.setter
    def chaos_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__456cf59b76ea08e7d594472d85a5f56d9548eadf439a120c2ef3fe3274eb23c7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaosVar", value)

    @builtins.property
    @jsii.member(jsii_name="density")
    def density(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "density"))

    @density.setter
    def density(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e95e5631bd255ed2c4610e4447b98c4407470e45b0b6865b9a5c7334be93c1d5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "density", value)

    @builtins.property
    @jsii.member(jsii_name="densityVar")
    def density_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "densityVar"))

    @density_var.setter
    def density_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d51c9113567a353b472b4792f8ba21ace952011e25900e8f25696a26cecc96a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "densityVar", value)

    @builtins.property
    @jsii.member(jsii_name="power")
    def power(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "power"))

    @power.setter
    def power(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9e984470d845dc9c7644781d600ce8579b9fa5b7f38e47dce34440d980aa2475)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "power", value)

    @builtins.property
    @jsii.member(jsii_name="powerVar")
    def power_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "powerVar"))

    @power_var.setter
    def power_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__55ee97fe4cf83fef4d9d7fcc8fceb3c8e06feb0e314a239279837fb502d51e91)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "powerVar", value)

    @builtins.property
    @jsii.member(jsii_name="seed")
    def seed(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seed"))

    @seed.setter
    def seed(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7eb4135c818664c258a17768786edca942d529351da4ef074f19071f6b5a7241)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seed", value)

    @builtins.property
    @jsii.member(jsii_name="seedVar")
    def seed_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seedVar"))

    @seed_var.setter
    def seed_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3e912aff6f5a20d337209d5ba401bee9825e8d082f6558784589947a2cb91dcf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seedVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeGoop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeGoop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeGoop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8fd4cca5c630cd297128aa0dff3b19cbbce68b43e2ea5dd31a8730b588a90a98)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeGrayscale",
    jsii_struct_bases=[],
    name_mapping={"type": "type", "type_var": "typeVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeGrayscale:
    def __init__(
        self,
        *,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param type: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__02b2a86c53927c70e8822d58acb540c335c204eb8bf826a6fdd1c93842d67d12)
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeGrayscale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeGrayscaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeGrayscaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__423b91b5840fa678a99c58a3193ce418fe26a3ab57084f91aab9663accd71e05)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeGrayscaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2aa69d4228ae6fd3cda2969e0bdefdc94cb97c584ad70d3ac54a90fb2586aa1b)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeGrayscaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ff284d40df193589da7bbd4562b8f712abbe99dbac071dde4c5916d102a3bb5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8e01d6fa1ad3197b97e7ee1abd74393babd3834e5b786f250b9e3a88ed55bdfb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a2ce5f66eceb7e7486f52f0da62175b687dfd508a3baa0127b181459eec109a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeGrayscale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeGrayscale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d4ce4b0a67b55a2b48e30ad9b2e103a8f9523be33ebde11ed09203810543d414)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeGrayscaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeGrayscaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c16807d4c65eb758cd0352ba0ffd8f499cb5f19cc358451d590bb1197ca3cce0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0454718bf7cf81f5999894ebfbf13ffa9bd286dadd7c1470200e6b971111c209)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0cc3a91110c02b4e1a9d7fcaf55f157f6b17f5998f113e605b2f069d6e86053f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeGrayscale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeGrayscale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeGrayscale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__adee473c9a0ebdf742e4566a83e253ccc42ac86ca5e3851d4deb9ec8ca40f670)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeHsl",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "lightness": "lightness",
        "lightness_var": "lightnessVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeHsl:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness: typing.Optional[builtins.str] = None,
        lightness_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        :param lightness_var: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dbe696a52c4aa1681af7a715dc84661acaad1e5b841724883c23af3fba77870f)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness", value=lightness, expected_type=type_hints["lightness"])
            check_type(argname="argument lightness_var", value=lightness_var, expected_type=type_hints["lightness_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness is not None:
            self._values["lightness"] = lightness
        if lightness_var is not None:
            self._values["lightness_var"] = lightness_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        '''
        result = self._values.get("lightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        '''
        result = self._values.get("lightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeHsl(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeHslList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeHslList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__879bf58dc43394493175f3153e0192e0f403da76b9de841bde7ec34e371760ef)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeHslOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__686c1a981f01632bd523199eff2897dcb91a71f7aa55989e5a439544ce67c3c0)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeHslOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e179ede5c659cd681d8710441723ee7bdf65d4ca4ce09cc660869baf9baa2cd0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b81bdef1e32d98750fecb618fc2f931bb3c0039eb95e3821a0431c0a40cb5727)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__07aba5aa9c7ab0f7495ab5a93d75630d642f47d51ba583b423e4fc0f569f2a9e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeHsl]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeHsl]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__986efc2a344d5e8f5800f3d4b225919209b5f3ad41da54e35934e0812162ed68)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeHslOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeHslOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7ad1042f1292e5bcad9f38cc1fc10d2639e1546db84ad8a875d27426a0046b16)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightness")
    def reset_lightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightness", []))

    @jsii.member(jsii_name="resetLightnessVar")
    def reset_lightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessInput")
    def lightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessVarInput")
    def lightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c523aaaa5a15ca761ec581db52075b0d526510ced699c8f1f19666d9f75c4312)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d16cb5edc0940e7bb7379373cf2a515985866c11aa33eccd81631b78ba0b5d10)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightness")
    def lightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightness"))

    @lightness.setter
    def lightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c53cfd896671300eeac6ffff547f8937dcc71777d3835f79b3f36db563abd681)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightness", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessVar")
    def lightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessVar"))

    @lightness_var.setter
    def lightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3b5cdbe3e9cb5be55dc46d98d0d9f4d204a1508ca8c9ca7a3f7e210799fc0804)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__077c9db8dae06d88fb98c66078580c6ac9bb6dd78f2e6a23144f49d9bc3ab118)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f137e6c9db5ace86bad2a95493347302f02bb6b486a94c19063334ffb6a41a00)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeHsl]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeHsl]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeHsl]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__05f7eac93296951ee817caaeca202c126bc5a26b186af240fd7e1074668556aa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeHsv",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeHsv:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        :param value: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__de1681e327803868a5198a84a8225f2aa3a4a9f1d0678b7b8087aa1a75396508)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeHsv(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeHsvList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeHsvList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e8ca66916ea1dd416c2560997f3936b672f54a0b9ff0a0ccf5b0fadac704fbe7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeHsvOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f481aca4c13a21e4db1213a122bc03fa30321b4aab56fd9d2179211d65a76fa)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeHsvOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4c976469667bc06b34fdbd94a22e697e593c97f8f68cb379b539fe12931b9ecd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ae085402ff84f9c15525c8d312b108e680fabdcaac2b8d6e8ade0d0deb26ff7a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fcdb3f9bc1cbb8576469c3137bf6330e3e3fb316fe428010ac5a775c6b37706e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeHsv]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeHsv]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__84ea30765ba4bbc04b4252f7d212467030e092b86be9de63346a3da059c66192)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeHsvOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeHsvOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__22ec4b528e0d19d43f60962c7fff0a19cc010f8910c7804fd2faed6ec655f407)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__516e537c42333011db0445f17d9ae68a879a76328595241268963ea0293878c3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b97dc75fdc4fef13b710ce024b672b71cc23ae3749c84f7e8c84a34488000cc9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__08e5505a9b018b41d1c1fc6beacbfc3fdf3c18bc28de0b849526d3c35f30a093)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__08e40d5b0058f880d1380f68b829bd3d77a26ee8e848e695a2c06daff3c7632d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d796d3035c1577cd3b4c0a48527425bf902514870dfbb71d88a333b6eac009a7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d09467d141ad7b49006c5f693734dc368c1a09ebb0fe333ffeff14689e1ca674)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeHsv]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeHsv]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeHsv]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4252c2c1c1d423808fe3dcac7126bc52b6a0497a421a3f8cee3c663da53760f5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimension",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "dimension": "dimension",
        "dimension_var": "dimensionVar",
        "equal": "equal",
        "greater_than": "greaterThan",
        "less_than": "lessThan",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimension:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        dimension: typing.Optional[builtins.str] = None,
        dimension_var: typing.Optional[builtins.str] = None,
        equal: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqual", typing.Dict[builtins.str, typing.Any]]] = None,
        greater_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThan", typing.Dict[builtins.str, typing.Any]]] = None,
        less_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThan", typing.Dict[builtins.str, typing.Any]]] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param dimension: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        :param dimension_var: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        :param equal: equal block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        :param greater_than: greater_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        :param less_than: less_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        :param value: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefault(**default)
        if isinstance(equal, dict):
            equal = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqual(**equal)
        if isinstance(greater_than, dict):
            greater_than = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThan(**greater_than)
        if isinstance(less_than, dict):
            less_than = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThan(**less_than)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6832c75900f4cc9ed1c179973bf1c1d4480590c53bc906a8cb06216437f05448)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument dimension", value=dimension, expected_type=type_hints["dimension"])
            check_type(argname="argument dimension_var", value=dimension_var, expected_type=type_hints["dimension_var"])
            check_type(argname="argument equal", value=equal, expected_type=type_hints["equal"])
            check_type(argname="argument greater_than", value=greater_than, expected_type=type_hints["greater_than"])
            check_type(argname="argument less_than", value=less_than, expected_type=type_hints["less_than"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if dimension is not None:
            self._values["dimension"] = dimension
        if dimension_var is not None:
            self._values["dimension_var"] = dimension_var
        if equal is not None:
            self._values["equal"] = equal
        if greater_than is not None:
            self._values["greater_than"] = greater_than
        if less_than is not None:
            self._values["less_than"] = less_than
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefault"], result)

    @builtins.property
    def dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        '''
        result = self._values.get("dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        '''
        result = self._values.get("dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def equal(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqual"]:
        '''equal block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        '''
        result = self._values.get("equal")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqual"], result)

    @builtins.property
    def greater_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThan"]:
        '''greater_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        '''
        result = self._values.get("greater_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThan"], result)

    @builtins.property
    def less_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThan"]:
        '''less_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        '''
        result = self._values.get("less_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThan"], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimension(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefault",
    jsii_struct_bases=[],
    name_mapping={
        "background_color": "backgroundColor",
        "blur": "blur",
        "chroma_key": "chromaKey",
        "composite": "composite",
        "compound": "compound",
        "contrast": "contrast",
        "goop": "goop",
        "grayscale": "grayscale",
        "hsl": "hsl",
        "hsv": "hsv",
        "if_dimension": "ifDimension",
        "if_orientation": "ifOrientation",
        "max_colors": "maxColors",
        "mirror": "mirror",
        "mono_hue": "monoHue",
        "opacity": "opacity",
        "remove_color": "removeColor",
        "unsharp_mask": "unsharpMask",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefault:
    def __init__(
        self,
        *,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultBackgroundColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultBlur", typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultChromaKey", typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultComposite", typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultCompound", typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultContrast", typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultGoop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultGrayscale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultHsl", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultHsv", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimension", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientation", typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultMaxColors", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultMirror", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultMonoHue", typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultOpacity", typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultRemoveColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultUnsharpMask", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d029a8a046995bd6b3b03aa33bb1f5c174e79b4620d3af8d8d41aa2324225a87)
            check_type(argname="argument background_color", value=background_color, expected_type=type_hints["background_color"])
            check_type(argname="argument blur", value=blur, expected_type=type_hints["blur"])
            check_type(argname="argument chroma_key", value=chroma_key, expected_type=type_hints["chroma_key"])
            check_type(argname="argument composite", value=composite, expected_type=type_hints["composite"])
            check_type(argname="argument compound", value=compound, expected_type=type_hints["compound"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument goop", value=goop, expected_type=type_hints["goop"])
            check_type(argname="argument grayscale", value=grayscale, expected_type=type_hints["grayscale"])
            check_type(argname="argument hsl", value=hsl, expected_type=type_hints["hsl"])
            check_type(argname="argument hsv", value=hsv, expected_type=type_hints["hsv"])
            check_type(argname="argument if_dimension", value=if_dimension, expected_type=type_hints["if_dimension"])
            check_type(argname="argument if_orientation", value=if_orientation, expected_type=type_hints["if_orientation"])
            check_type(argname="argument max_colors", value=max_colors, expected_type=type_hints["max_colors"])
            check_type(argname="argument mirror", value=mirror, expected_type=type_hints["mirror"])
            check_type(argname="argument mono_hue", value=mono_hue, expected_type=type_hints["mono_hue"])
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument remove_color", value=remove_color, expected_type=type_hints["remove_color"])
            check_type(argname="argument unsharp_mask", value=unsharp_mask, expected_type=type_hints["unsharp_mask"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if background_color is not None:
            self._values["background_color"] = background_color
        if blur is not None:
            self._values["blur"] = blur
        if chroma_key is not None:
            self._values["chroma_key"] = chroma_key
        if composite is not None:
            self._values["composite"] = composite
        if compound is not None:
            self._values["compound"] = compound
        if contrast is not None:
            self._values["contrast"] = contrast
        if goop is not None:
            self._values["goop"] = goop
        if grayscale is not None:
            self._values["grayscale"] = grayscale
        if hsl is not None:
            self._values["hsl"] = hsl
        if hsv is not None:
            self._values["hsv"] = hsv
        if if_dimension is not None:
            self._values["if_dimension"] = if_dimension
        if if_orientation is not None:
            self._values["if_orientation"] = if_orientation
        if max_colors is not None:
            self._values["max_colors"] = max_colors
        if mirror is not None:
            self._values["mirror"] = mirror
        if mono_hue is not None:
            self._values["mono_hue"] = mono_hue
        if opacity is not None:
            self._values["opacity"] = opacity
        if remove_color is not None:
            self._values["remove_color"] = remove_color
        if unsharp_mask is not None:
            self._values["unsharp_mask"] = unsharp_mask

    @builtins.property
    def background_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultBackgroundColor"]]]:
        '''background_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        '''
        result = self._values.get("background_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultBackgroundColor"]]], result)

    @builtins.property
    def blur(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultBlur"]]]:
        '''blur block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        '''
        result = self._values.get("blur")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultBlur"]]], result)

    @builtins.property
    def chroma_key(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultChromaKey"]]]:
        '''chroma_key block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        '''
        result = self._values.get("chroma_key")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultChromaKey"]]], result)

    @builtins.property
    def composite(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultComposite"]]]:
        '''composite block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        '''
        result = self._values.get("composite")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultComposite"]]], result)

    @builtins.property
    def compound(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultCompound"]]]:
        '''compound block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        '''
        result = self._values.get("compound")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultCompound"]]], result)

    @builtins.property
    def contrast(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultContrast"]]]:
        '''contrast block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultContrast"]]], result)

    @builtins.property
    def goop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultGoop"]]]:
        '''goop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        '''
        result = self._values.get("goop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultGoop"]]], result)

    @builtins.property
    def grayscale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultGrayscale"]]]:
        '''grayscale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        '''
        result = self._values.get("grayscale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultGrayscale"]]], result)

    @builtins.property
    def hsl(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultHsl"]]]:
        '''hsl block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        '''
        result = self._values.get("hsl")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultHsl"]]], result)

    @builtins.property
    def hsv(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultHsv"]]]:
        '''hsv block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        '''
        result = self._values.get("hsv")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultHsv"]]], result)

    @builtins.property
    def if_dimension(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimension"]]]:
        '''if_dimension block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        '''
        result = self._values.get("if_dimension")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimension"]]], result)

    @builtins.property
    def if_orientation(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientation"]]]:
        '''if_orientation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        '''
        result = self._values.get("if_orientation")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientation"]]], result)

    @builtins.property
    def max_colors(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultMaxColors"]]]:
        '''max_colors block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        '''
        result = self._values.get("max_colors")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultMaxColors"]]], result)

    @builtins.property
    def mirror(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultMirror"]]]:
        '''mirror block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        '''
        result = self._values.get("mirror")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultMirror"]]], result)

    @builtins.property
    def mono_hue(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultMonoHue"]]]:
        '''mono_hue block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        '''
        result = self._values.get("mono_hue")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultMonoHue"]]], result)

    @builtins.property
    def opacity(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultOpacity"]]]:
        '''opacity block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultOpacity"]]], result)

    @builtins.property
    def remove_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultRemoveColor"]]]:
        '''remove_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        '''
        result = self._values.get("remove_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultRemoveColor"]]], result)

    @builtins.property
    def unsharp_mask(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultUnsharpMask"]]]:
        '''unsharp_mask block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        result = self._values.get("unsharp_mask")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultUnsharpMask"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultBackgroundColor",
    jsii_struct_bases=[],
    name_mapping={"color": "color", "color_var": "colorVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultBackgroundColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c59f0f150a1fa275b069c4cb9772b8e8e38619c7418bcf5c3ffac894bb786139)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultBackgroundColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultBackgroundColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultBackgroundColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f66ea25f6b0bec88720cdbfc070dde9c36b91a6146e5321b9d17aeee920d514a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultBackgroundColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3afb2abf13f9ad2d5cecbc4c72d0e6e5965a5e0c4b450fc188ef52f37aa654c5)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultBackgroundColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__38be0da7ed1e3d853339ec8db9776084acdedf27b50621d6bef822b8157e0b58)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__707e8cf66cdd0920affd249f24dbe726dc7e283e88d054be836ef1791c116245)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__94a99106f237ae5fd243d5c439c4b2f90fa3d446ea0f9e540d1a945017e5331a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultBackgroundColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultBackgroundColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bf4daed02e35c1de8a100d211cc8c3b8f5e49318298ea62260c07d8042f60fb9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultBackgroundColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultBackgroundColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__424cfbd8fc475450975f9527c60906bd458ce1dc4fcfc781236680980fa1cda3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e7fa1077e778ca25ba68e47bed6aa785340d4d9e23e7855b768023587ee8eece)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a7cc26b22d94bdef26a3ead75a412986194c0f9fd26b6216d54eb4f7a0fbc2a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultBackgroundColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultBackgroundColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultBackgroundColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e7ffc75a4a4a1541af8d32aa19b15368e734e06ae259798c78c95bc819f4a55c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultBlur",
    jsii_struct_bases=[],
    name_mapping={"sigma": "sigma", "sigma_var": "sigmaVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultBlur:
    def __init__(
        self,
        *,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param sigma: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0aee361f48a04c744d29b57a4c468cb430f84254dbd4e63792a2326be276470f)
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultBlur(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultBlurList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultBlurList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ded2b458589586f615216e43ae2724e65d86e0de888318633f0407b280cbbb0f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultBlurOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3685d8c61d10595f9f9bba294a406d65c59cce6d8cd6ade36cee0e5fff4ef676)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultBlurOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a7e52135ed26570a98e98a3e937cf5e1b48163fcba5e8a589d0f863519c9fd1b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aa2a2c8b612b87712a2e851208d263b3224237e2115133a2346a2630a310cf84)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cb9d46694cc689fc910802931270c1ee174d77cad71c3e95d67f94d362c56a20)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultBlur]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultBlur]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f9eca757bca05c7cbb7b54781577a47ac862c28b45d070690b69712ced7d34f6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultBlurOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultBlurOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__473f2c5b1c7ac802d5a89d57131928d13eeaa4e2266dbcb7d1e2d8ca7b6c09af)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5989a2b04bb8a76fef062d57af96b51e6c11877c2b26dad76f33a3d72ca152e7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cef868def54519335d86475cf909548a36610f29f3658a97c5ace65942645eab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultBlur]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultBlur]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultBlur]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1e0aee7542b3233442dfe8b6d5f2c0248a3f4fd6cf29d07eb68f7299be2e48e6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultChromaKey",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_feather": "hueFeather",
        "hue_feather_var": "hueFeatherVar",
        "hue_tolerance": "hueTolerance",
        "hue_tolerance_var": "hueToleranceVar",
        "hue_var": "hueVar",
        "lightness_feather": "lightnessFeather",
        "lightness_feather_var": "lightnessFeatherVar",
        "lightness_tolerance": "lightnessTolerance",
        "lightness_tolerance_var": "lightnessToleranceVar",
        "saturation_feather": "saturationFeather",
        "saturation_feather_var": "saturationFeatherVar",
        "saturation_tolerance": "saturationTolerance",
        "saturation_tolerance_var": "saturationToleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultChromaKey:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_feather: typing.Optional[builtins.str] = None,
        hue_feather_var: typing.Optional[builtins.str] = None,
        hue_tolerance: typing.Optional[builtins.str] = None,
        hue_tolerance_var: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness_feather: typing.Optional[builtins.str] = None,
        lightness_feather_var: typing.Optional[builtins.str] = None,
        lightness_tolerance: typing.Optional[builtins.str] = None,
        lightness_tolerance_var: typing.Optional[builtins.str] = None,
        saturation_feather: typing.Optional[builtins.str] = None,
        saturation_feather_var: typing.Optional[builtins.str] = None,
        saturation_tolerance: typing.Optional[builtins.str] = None,
        saturation_tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_feather: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        :param hue_feather_var: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        :param hue_tolerance: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        :param hue_tolerance_var: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        :param hue_var: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness_feather: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        :param lightness_feather_var: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        :param lightness_tolerance: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        :param lightness_tolerance_var: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        :param saturation_feather: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        :param saturation_feather_var: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        :param saturation_tolerance: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        :param saturation_tolerance_var: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0324fe7ee0e6e1fc2f9a97fda25a84bc2e214c830efcdf650c4f93d80885a29c)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_feather", value=hue_feather, expected_type=type_hints["hue_feather"])
            check_type(argname="argument hue_feather_var", value=hue_feather_var, expected_type=type_hints["hue_feather_var"])
            check_type(argname="argument hue_tolerance", value=hue_tolerance, expected_type=type_hints["hue_tolerance"])
            check_type(argname="argument hue_tolerance_var", value=hue_tolerance_var, expected_type=type_hints["hue_tolerance_var"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness_feather", value=lightness_feather, expected_type=type_hints["lightness_feather"])
            check_type(argname="argument lightness_feather_var", value=lightness_feather_var, expected_type=type_hints["lightness_feather_var"])
            check_type(argname="argument lightness_tolerance", value=lightness_tolerance, expected_type=type_hints["lightness_tolerance"])
            check_type(argname="argument lightness_tolerance_var", value=lightness_tolerance_var, expected_type=type_hints["lightness_tolerance_var"])
            check_type(argname="argument saturation_feather", value=saturation_feather, expected_type=type_hints["saturation_feather"])
            check_type(argname="argument saturation_feather_var", value=saturation_feather_var, expected_type=type_hints["saturation_feather_var"])
            check_type(argname="argument saturation_tolerance", value=saturation_tolerance, expected_type=type_hints["saturation_tolerance"])
            check_type(argname="argument saturation_tolerance_var", value=saturation_tolerance_var, expected_type=type_hints["saturation_tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_feather is not None:
            self._values["hue_feather"] = hue_feather
        if hue_feather_var is not None:
            self._values["hue_feather_var"] = hue_feather_var
        if hue_tolerance is not None:
            self._values["hue_tolerance"] = hue_tolerance
        if hue_tolerance_var is not None:
            self._values["hue_tolerance_var"] = hue_tolerance_var
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness_feather is not None:
            self._values["lightness_feather"] = lightness_feather
        if lightness_feather_var is not None:
            self._values["lightness_feather_var"] = lightness_feather_var
        if lightness_tolerance is not None:
            self._values["lightness_tolerance"] = lightness_tolerance
        if lightness_tolerance_var is not None:
            self._values["lightness_tolerance_var"] = lightness_tolerance_var
        if saturation_feather is not None:
            self._values["saturation_feather"] = saturation_feather
        if saturation_feather_var is not None:
            self._values["saturation_feather_var"] = saturation_feather_var
        if saturation_tolerance is not None:
            self._values["saturation_tolerance"] = saturation_tolerance
        if saturation_tolerance_var is not None:
            self._values["saturation_tolerance_var"] = saturation_tolerance_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        '''
        result = self._values.get("hue_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        '''
        result = self._values.get("hue_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        '''
        result = self._values.get("hue_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        '''
        result = self._values.get("hue_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        '''
        result = self._values.get("lightness_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        '''
        result = self._values.get("lightness_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        '''
        result = self._values.get("lightness_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        '''
        result = self._values.get("lightness_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        '''
        result = self._values.get("saturation_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        '''
        result = self._values.get("saturation_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        '''
        result = self._values.get("saturation_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        result = self._values.get("saturation_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultChromaKey(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultChromaKeyList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultChromaKeyList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e971806507a5cf3efbc966e9bc4c8e5d7f409f5887c4386cc0d96948bf07daa6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultChromaKeyOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4fcab4d32c9cde3fda55e1852994ec5b819601dc58feeaa415db013521a44791)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultChromaKeyOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d2f4597c0f99744fb26470b681151cf9d5db048dc07a9129508b458142671554)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c7957f24cf48f3924953725dce18c23495360f97541a07bebc0696765705595b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6ea2b467ba07d7edb9da37f9e4af455fbbb9bbd1e2cba49bff39ed06e593c4d2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultChromaKey]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultChromaKey]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__451c6cb799fcbb0e37377b5e53d6cf32d82b8cd5224e5f1e7de971675ec585d0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultChromaKeyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultChromaKeyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5472b3e9482d456a2b26f6bb2a100bed5cedba5577e4baf656534d677ba7202d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueFeather")
    def reset_hue_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeather", []))

    @jsii.member(jsii_name="resetHueFeatherVar")
    def reset_hue_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeatherVar", []))

    @jsii.member(jsii_name="resetHueTolerance")
    def reset_hue_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueTolerance", []))

    @jsii.member(jsii_name="resetHueToleranceVar")
    def reset_hue_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueToleranceVar", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightnessFeather")
    def reset_lightness_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeather", []))

    @jsii.member(jsii_name="resetLightnessFeatherVar")
    def reset_lightness_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeatherVar", []))

    @jsii.member(jsii_name="resetLightnessTolerance")
    def reset_lightness_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessTolerance", []))

    @jsii.member(jsii_name="resetLightnessToleranceVar")
    def reset_lightness_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessToleranceVar", []))

    @jsii.member(jsii_name="resetSaturationFeather")
    def reset_saturation_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeather", []))

    @jsii.member(jsii_name="resetSaturationFeatherVar")
    def reset_saturation_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeatherVar", []))

    @jsii.member(jsii_name="resetSaturationTolerance")
    def reset_saturation_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationTolerance", []))

    @jsii.member(jsii_name="resetSaturationToleranceVar")
    def reset_saturation_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherInput")
    def hue_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVarInput")
    def hue_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceInput")
    def hue_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVarInput")
    def hue_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherInput")
    def lightness_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVarInput")
    def lightness_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceInput")
    def lightness_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVarInput")
    def lightness_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherInput")
    def saturation_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVarInput")
    def saturation_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceInput")
    def saturation_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVarInput")
    def saturation_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a93d49b832d6f07178e3e4964d8fdea593d79438aa5628343812f444d1fed28)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeather")
    def hue_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeather"))

    @hue_feather.setter
    def hue_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d15ce6ab8a4e9a60d7e184429c8a9a7650fa56d8bf3e2208aa5359fe3236333)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeather", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVar")
    def hue_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeatherVar"))

    @hue_feather_var.setter
    def hue_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a1a20482ad53d9b1cc70c01e49118dbc184d50d0fc9bc4dffb4039271484c68)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueTolerance")
    def hue_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueTolerance"))

    @hue_tolerance.setter
    def hue_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9b2c3b98242fd7c5c308b6a957d9c7602ac555aabf21a390256fb003817bccd1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVar")
    def hue_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueToleranceVar"))

    @hue_tolerance_var.setter
    def hue_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__60107f4bdaa59d5e03a3dca8683ce0630ed207f605defbe338f536a6233cec1a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7933d3b096630583a1fa07876804743345c2d0ed4bbea47a1f92e981c393e796)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeather")
    def lightness_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeather"))

    @lightness_feather.setter
    def lightness_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b598e520818c7274bf27f16fc208cefdc588d39d465b74d81d8f5b732f813409)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeather", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVar")
    def lightness_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeatherVar"))

    @lightness_feather_var.setter
    def lightness_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8145485ef8889411d7f74481ded917160eb58a8dc8d62caaa89fb652eda8efa0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessTolerance")
    def lightness_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessTolerance"))

    @lightness_tolerance.setter
    def lightness_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ec8198f02c19a0cceccf7a59123ed01546491052771b6afe9a4410d09c52ac90)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVar")
    def lightness_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessToleranceVar"))

    @lightness_tolerance_var.setter
    def lightness_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__51a0538c77c298490fdb73252e7d448d709ec69adee0a51b11cffc6b28587aa7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeather")
    def saturation_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeather"))

    @saturation_feather.setter
    def saturation_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a19a9ebd7f8ee5abd285dd3e9eec788fba160bf733d3a05dcd3dcfa5a82531d2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeather", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVar")
    def saturation_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeatherVar"))

    @saturation_feather_var.setter
    def saturation_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__321756cd7491be815811192f05fa30b46f860939aeacfd4bcf6786fe271799b5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationTolerance")
    def saturation_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationTolerance"))

    @saturation_tolerance.setter
    def saturation_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3bcdd7ff90fab0dbb5e4e11022d37743706d30d25c4b9e376c40d6808683546b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVar")
    def saturation_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationToleranceVar"))

    @saturation_tolerance_var.setter
    def saturation_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f93e1a25118630cb4aa29759ff709e65ee77ca1dba9ad2f5454eebf9d4787828)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultChromaKey]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultChromaKey]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultChromaKey]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc87cf4d577bf740864cc6a51cc84afee44b9dfd7fc62adbcf8f877ec78fdef6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultComposite",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "placement": "placement",
        "placement_var": "placementVar",
        "scale": "scale",
        "scale_dimension": "scaleDimension",
        "scale_dimension_var": "scaleDimensionVar",
        "scale_var": "scaleVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultComposite:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultCompositeImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        placement: typing.Optional[builtins.str] = None,
        placement_var: typing.Optional[builtins.str] = None,
        scale: typing.Optional[builtins.str] = None,
        scale_dimension: typing.Optional[builtins.str] = None,
        scale_dimension_var: typing.Optional[builtins.str] = None,
        scale_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param placement: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        :param placement_var: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        :param scale: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param scale_dimension: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        :param scale_dimension_var: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        :param scale_var: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        :param x_position: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultCompositeImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__27530e1a486ec4db4cdc4e0e68f7ea90edaa1cba097bc288a97ba3b232b3b1cb)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument placement", value=placement, expected_type=type_hints["placement"])
            check_type(argname="argument placement_var", value=placement_var, expected_type=type_hints["placement_var"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument scale_dimension", value=scale_dimension, expected_type=type_hints["scale_dimension"])
            check_type(argname="argument scale_dimension_var", value=scale_dimension_var, expected_type=type_hints["scale_dimension_var"])
            check_type(argname="argument scale_var", value=scale_var, expected_type=type_hints["scale_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if placement is not None:
            self._values["placement"] = placement
        if placement_var is not None:
            self._values["placement_var"] = placement_var
        if scale is not None:
            self._values["scale"] = scale
        if scale_dimension is not None:
            self._values["scale_dimension"] = scale_dimension
        if scale_dimension_var is not None:
            self._values["scale_dimension_var"] = scale_dimension_var
        if scale_var is not None:
            self._values["scale_var"] = scale_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultCompositeImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultCompositeImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        '''
        result = self._values.get("placement")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement_var(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        '''
        result = self._values.get("placement_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        '''
        result = self._values.get("scale_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        '''
        result = self._values.get("scale_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        '''
        result = self._values.get("scale_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultComposite(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultCompositeImage",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultCompositeImage:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultCompositeImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultCompositeImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultCompositeImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a566e8af0ded49fa3053995c4c60520fa987e97bb4ac8948e1b5c99f07f6231)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultCompositeImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultCompositeImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f8993a1c30d6e5d6ec19ee0a07a3c5459e4f9c9409ae7156325d7d2b5a43c7db)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultCompositeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultCompositeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__499ecd3a79a37a2975691ced034d915baaadca68d4ba6399c8ffe6b394ba2135)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultCompositeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2868cfe7af17a14359775b0b4c174b3216b45ff4e853ede92cc6699190149da4)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultCompositeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ac47b11a24b3b0a045ec4146cee51ece6e16bf17a8081946fdbe5ca9f37767a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b6b5cd2db437364d2d7d0e109ffb782abe4299280de4b51d6de7d09bf9d55eb5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ff3d0b41396536c1c48b13085a5ad9f37d4c8647d6824b8bb3e45c041dca3c43)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultComposite]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultComposite]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__90a0054a21f98ed78d7417900817cafcf7961c781934b4e9e14a4b2aa952891a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultCompositeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultCompositeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3439738d6b8251764a6a2c61770ced81eb1b02ce757fea27748f79967a41b9ee)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultCompositeImage()

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPlacement")
    def reset_placement(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacement", []))

    @jsii.member(jsii_name="resetPlacementVar")
    def reset_placement_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacementVar", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetScaleDimension")
    def reset_scale_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimension", []))

    @jsii.member(jsii_name="resetScaleDimensionVar")
    def reset_scale_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimensionVar", []))

    @jsii.member(jsii_name="resetScaleVar")
    def reset_scale_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultCompositeImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultCompositeImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultCompositeImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="placementInput")
    def placement_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementInput"))

    @builtins.property
    @jsii.member(jsii_name="placementVarInput")
    def placement_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionInput")
    def scale_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVarInput")
    def scale_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleVarInput")
    def scale_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aaf08d0f8ecb6ac39c68fb1996f4a9eddf14379f4fb60841a17307aca558f2ea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9eae45e287fda899faf7c86965ef133163b250ab8f98167037190908b518cef8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="placement")
    def placement(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placement"))

    @placement.setter
    def placement(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dd47fe3a550b2a85b66a49c2521c0d23ccc42242034c2f07511bee3dd18a816b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placement", value)

    @builtins.property
    @jsii.member(jsii_name="placementVar")
    def placement_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placementVar"))

    @placement_var.setter
    def placement_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fbbea83a94c94ac1940af4d88576e9bb031db470dedb669868eccfdf52e7dfa9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placementVar", value)

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scale"))

    @scale.setter
    def scale(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__890b8f797b3340d77161daa3f0bc1b4cc5f9f3661eeee78ac02cbd58cf80f50b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scale", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimension")
    def scale_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimension"))

    @scale_dimension.setter
    def scale_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d950d2d3057ee75df72b9d21468b5516a0013982adadaf4b182f988f51c4e059)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimension", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVar")
    def scale_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimensionVar"))

    @scale_dimension_var.setter
    def scale_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5a2473f624ada920d6ccedc86520f33d2ec242f66a77d96487e0fc717d1630fd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="scaleVar")
    def scale_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleVar"))

    @scale_var.setter
    def scale_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__33017926413f4fcb5b7db949d5bc5ae98bbb45cfb5916f0fc6b0117a72e41cd2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ebd6e3bc009cf1301de6bc826aa8efa5e1dcd57dbb6f1a8e5a4ae262454ac74)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__065ea6e5adcdb6bb17167c705d0d993121cf3f70053cfd7b47566ae6feb0a35f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__de84de63ed5a349905e345cc11b844f16be34a189684c596cba2669e9d71de66)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__66f13a4591b9f6fbd3b47f966d934314f2df54507650287bbabba107d734dba9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultComposite]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultComposite]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultComposite]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__49a3520e9cb3f5995befa256a5d4b4dcd38e81f6b7a1e1436898e587c496777e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultCompound",
    jsii_struct_bases=[],
    name_mapping={"transformations": "transformations"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultCompound:
    def __init__(
        self,
        *,
        transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param transformations: transformations block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__43725ab86e669cd2f694ecbe404468a0988ac2a24552ca132fe5b6def4d98efb)
            check_type(argname="argument transformations", value=transformations, expected_type=type_hints["transformations"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if transformations is not None:
            self._values["transformations"] = transformations

    @builtins.property
    def transformations(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultCompoundTransformations"]]]:
        '''transformations block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        result = self._values.get("transformations")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultCompoundTransformations"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultCompound(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultCompoundList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultCompoundList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4f7b723e6074fb8dc18874a6887d01a82c70cdf8e4bd74c23845cf5560e26690)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultCompoundOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__803dc42aff83a8f2c2b2627f82c749dc36282da53db81b3e17402d81a4338440)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultCompoundOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0d0ab4c83232c95623daa9f7d313f8ffbb75ac354c862a15a06a7c64e3e0cddc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b28b68968ca73f935a00692e92f94faef50c8de73e10edb0c28ec763151fc6d8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ba9255126d17274a3c205de0432a2d45004954f3ae5ee76751f595ad1d8b5b5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultCompound]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultCompound]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a424de0e03527865e10f707d72267895bbbd8fc08ea29b53d6d49fae6b7c76b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultCompoundOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultCompoundOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cdffa48f818600f30017dc7f3f9fadf00d0b3373e266a8594e8b858b8e70e6fd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformations")
    def put_transformations(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5d53f3f4aa231744a851d236b89c022a2a0f0f87a62383ae23c00905195ac827)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTransformations", [value]))

    @jsii.member(jsii_name="resetTransformations")
    def reset_transformations(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformations", []))

    @builtins.property
    @jsii.member(jsii_name="transformations")
    def transformations(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultCompoundTransformationsList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultCompoundTransformationsList", jsii.get(self, "transformations"))

    @builtins.property
    @jsii.member(jsii_name="transformationsInput")
    def transformations_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultCompoundTransformations"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultCompoundTransformations"]]], jsii.get(self, "transformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultCompound]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultCompound]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultCompound]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6c81728348ede11600b1e6290e86d0a94887909380c01afe9bd82ce5ef18ef46)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultCompoundTransformations",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultCompoundTransformations:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultCompoundTransformations(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultCompoundTransformationsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultCompoundTransformationsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5d0287ea13cdd74270523b021fda7edecc84b02d9290922cf24c3ea03c8c28b1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultCompoundTransformationsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aae804115595c3eda96fa20dabdfc666d6df11cef0d8be615365d2ecf6a61f37)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultCompoundTransformationsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d1306c4e2b57476a15e1a502e73ea85469bfe8d1ca015b5052b5cd40b9c558d8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__556dd3dd8c1c9ba5b5d62ba715378bf32e844e6766847c4f039fe20f8eb7ebff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__93eb157da36525674cad6173afaeb56b636f4e0e9a32c7b80889b9e767ff6557)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultCompoundTransformations]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultCompoundTransformations]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultCompoundTransformations]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__267b5c4e43b9bd6e42c08bf07028a2f3a9969f12e89391924ce4c18a12cffb90)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultCompoundTransformationsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultCompoundTransformationsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a1b83eff74e6181703563392327567dd4b3ea76c876be9ab3745f9785ddf7808)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultCompoundTransformations]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultCompoundTransformations]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultCompoundTransformations]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ee07c485f4226a5b393c2223ff91e1a81ee110830a65387c936cc5d155faa1db)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultContrast",
    jsii_struct_bases=[],
    name_mapping={
        "brightness": "brightness",
        "brightness_var": "brightnessVar",
        "contrast": "contrast",
        "contrast_var": "contrastVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultContrast:
    def __init__(
        self,
        *,
        brightness: typing.Optional[builtins.str] = None,
        brightness_var: typing.Optional[builtins.str] = None,
        contrast: typing.Optional[builtins.str] = None,
        contrast_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param brightness: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        :param brightness_var: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        :param contrast: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param contrast_var: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b404b09336ead1dd0f927532f5b57dda43b943dab626e899b0906d7ec3c17216)
            check_type(argname="argument brightness", value=brightness, expected_type=type_hints["brightness"])
            check_type(argname="argument brightness_var", value=brightness_var, expected_type=type_hints["brightness_var"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument contrast_var", value=contrast_var, expected_type=type_hints["contrast_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if brightness is not None:
            self._values["brightness"] = brightness
        if brightness_var is not None:
            self._values["brightness_var"] = brightness_var
        if contrast is not None:
            self._values["contrast"] = contrast
        if contrast_var is not None:
            self._values["contrast_var"] = contrast_var

    @builtins.property
    def brightness(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        '''
        result = self._values.get("brightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def brightness_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        '''
        result = self._values.get("brightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        result = self._values.get("contrast_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultContrast(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultContrastList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultContrastList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__24edde252f2fa5a7a137be7df608f285a89e90abbcc0085449c3fdf543c2c057)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultContrastOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3448ecfcf762c3d950abd2d3ffe44309081802ea0053dcde3f91750bd5b1e264)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultContrastOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9f62051eb71209d3ff13e438d8fba3bf3df34f703c208401a2234a0afcf0b45e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__044bb23ef8df60f0e895d547d24ed63ddc2606742a4d6a22e6b4c74384d6ccd4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__07b9b13b2440123c42b3d44e011e8540444256a7148e622c69eafe2623183f58)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultContrast]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultContrast]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__48544cac09db2f4347365023afefb83edd5acf324d0cb3f8a70f5d44cb72d2c3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultContrastOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultContrastOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0566ad76f376f5d54c311ff3d4de8afd1045ba5e73a7dd942da8d2967761aaec)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetBrightness")
    def reset_brightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightness", []))

    @jsii.member(jsii_name="resetBrightnessVar")
    def reset_brightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightnessVar", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetContrastVar")
    def reset_contrast_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrastVar", []))

    @builtins.property
    @jsii.member(jsii_name="brightnessInput")
    def brightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="brightnessVarInput")
    def brightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastVarInput")
    def contrast_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="brightness")
    def brightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightness"))

    @brightness.setter
    def brightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2e08b87a2624dc81e88b1cc91915c6b5b60fb3010fa771ff5b4ab91efe23aa8b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightness", value)

    @builtins.property
    @jsii.member(jsii_name="brightnessVar")
    def brightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightnessVar"))

    @brightness_var.setter
    def brightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bff5f5524981861a4c014960eab7b21c0748c21fcc0d129a1f14969dff3a91c2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrast"))

    @contrast.setter
    def contrast(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5b0670c0b3ad0d8b545c2ceaf8721dc7044d1206415efa1d7ee8f8057c3afb6d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrast", value)

    @builtins.property
    @jsii.member(jsii_name="contrastVar")
    def contrast_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrastVar"))

    @contrast_var.setter
    def contrast_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a48d14c7958cf754e583c82c9a974b8299caa8a8a94463ff7c7a204dc511207)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrastVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultContrast]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultContrast]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultContrast]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1ffefc4572aee782ad90e7268bb6534633f71c268d96abcff95ae8cf23aa7e15)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultGoop",
    jsii_struct_bases=[],
    name_mapping={
        "chaos": "chaos",
        "chaos_var": "chaosVar",
        "density": "density",
        "density_var": "densityVar",
        "power": "power",
        "power_var": "powerVar",
        "seed": "seed",
        "seed_var": "seedVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultGoop:
    def __init__(
        self,
        *,
        chaos: typing.Optional[builtins.str] = None,
        chaos_var: typing.Optional[builtins.str] = None,
        density: typing.Optional[builtins.str] = None,
        density_var: typing.Optional[builtins.str] = None,
        power: typing.Optional[builtins.str] = None,
        power_var: typing.Optional[builtins.str] = None,
        seed: typing.Optional[builtins.str] = None,
        seed_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param chaos: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        :param chaos_var: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        :param density: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        :param density_var: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        :param power: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        :param power_var: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        :param seed: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        :param seed_var: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c53d8da897a0b7909680381d7d45263cee074c3ad1cab860f91dde77ee134b68)
            check_type(argname="argument chaos", value=chaos, expected_type=type_hints["chaos"])
            check_type(argname="argument chaos_var", value=chaos_var, expected_type=type_hints["chaos_var"])
            check_type(argname="argument density", value=density, expected_type=type_hints["density"])
            check_type(argname="argument density_var", value=density_var, expected_type=type_hints["density_var"])
            check_type(argname="argument power", value=power, expected_type=type_hints["power"])
            check_type(argname="argument power_var", value=power_var, expected_type=type_hints["power_var"])
            check_type(argname="argument seed", value=seed, expected_type=type_hints["seed"])
            check_type(argname="argument seed_var", value=seed_var, expected_type=type_hints["seed_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if chaos is not None:
            self._values["chaos"] = chaos
        if chaos_var is not None:
            self._values["chaos_var"] = chaos_var
        if density is not None:
            self._values["density"] = density
        if density_var is not None:
            self._values["density_var"] = density_var
        if power is not None:
            self._values["power"] = power
        if power_var is not None:
            self._values["power_var"] = power_var
        if seed is not None:
            self._values["seed"] = seed
        if seed_var is not None:
            self._values["seed_var"] = seed_var

    @builtins.property
    def chaos(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        '''
        result = self._values.get("chaos")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def chaos_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        '''
        result = self._values.get("chaos_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        '''
        result = self._values.get("density")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density_var(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        '''
        result = self._values.get("density_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        '''
        result = self._values.get("power")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power_var(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        '''
        result = self._values.get("power_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        '''
        result = self._values.get("seed")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed_var(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        result = self._values.get("seed_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultGoop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultGoopList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultGoopList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ae53ef0d5824df487020bd18606779b5e11313a46340a3454fa90e74b72f3be)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultGoopOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ba5dafee3decdcce366627d6c7fa1ebcbfbaa1e00bf8842bc4cbfefc82e80ebf)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultGoopOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__37605ee63110ef61392e289ec90182f122462790020821fde317e79570f949b9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6a491871527e39967f22a502fa07a03d317cf788e4b8044505a99e06f081ddad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0453ce22029d3172676d5f6e3c1083a2b1897a3cd394e3ea07f0571fced448a9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultGoop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultGoop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cbbe788c3934acc8e192f211c8517e2825fe780ff9feee58468edd6db234dd87)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultGoopOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultGoopOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__580032493d61fb673291daf3e43f3e4996fd92450c63e6c71f7baa5efb2af726)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetChaos")
    def reset_chaos(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaos", []))

    @jsii.member(jsii_name="resetChaosVar")
    def reset_chaos_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaosVar", []))

    @jsii.member(jsii_name="resetDensity")
    def reset_density(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensity", []))

    @jsii.member(jsii_name="resetDensityVar")
    def reset_density_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensityVar", []))

    @jsii.member(jsii_name="resetPower")
    def reset_power(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPower", []))

    @jsii.member(jsii_name="resetPowerVar")
    def reset_power_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPowerVar", []))

    @jsii.member(jsii_name="resetSeed")
    def reset_seed(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeed", []))

    @jsii.member(jsii_name="resetSeedVar")
    def reset_seed_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeedVar", []))

    @builtins.property
    @jsii.member(jsii_name="chaosInput")
    def chaos_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosInput"))

    @builtins.property
    @jsii.member(jsii_name="chaosVarInput")
    def chaos_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosVarInput"))

    @builtins.property
    @jsii.member(jsii_name="densityInput")
    def density_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityInput"))

    @builtins.property
    @jsii.member(jsii_name="densityVarInput")
    def density_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="powerInput")
    def power_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerInput"))

    @builtins.property
    @jsii.member(jsii_name="powerVarInput")
    def power_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerVarInput"))

    @builtins.property
    @jsii.member(jsii_name="seedInput")
    def seed_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedInput"))

    @builtins.property
    @jsii.member(jsii_name="seedVarInput")
    def seed_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedVarInput"))

    @builtins.property
    @jsii.member(jsii_name="chaos")
    def chaos(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaos"))

    @chaos.setter
    def chaos(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__891f0af9d90b00140a6caff500896848604b3d60072c69d8da48cbd97f2e9e42)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaos", value)

    @builtins.property
    @jsii.member(jsii_name="chaosVar")
    def chaos_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaosVar"))

    @chaos_var.setter
    def chaos_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7f8ae04bbeed015d8027f539f20fd19cb3b7a5f9a2eb6f66dfaa79764b4581b4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaosVar", value)

    @builtins.property
    @jsii.member(jsii_name="density")
    def density(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "density"))

    @density.setter
    def density(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2b4ba90d863c8f3158b88008a68785aaa162ae58affc09d3554b69292bfd92cb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "density", value)

    @builtins.property
    @jsii.member(jsii_name="densityVar")
    def density_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "densityVar"))

    @density_var.setter
    def density_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b046f49db4c2bdae6ea27968631ebd6999d36dd71df78625eb1e673247c4b04a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "densityVar", value)

    @builtins.property
    @jsii.member(jsii_name="power")
    def power(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "power"))

    @power.setter
    def power(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__86797416519b8ad3e6f5b004ba511762059082df8b0b0350e8ac4084f4c99c24)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "power", value)

    @builtins.property
    @jsii.member(jsii_name="powerVar")
    def power_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "powerVar"))

    @power_var.setter
    def power_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c1fe0bb4b36ac4727f868d590fc4ea98b250012fa5c0c17e54a6bc7145d13edc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "powerVar", value)

    @builtins.property
    @jsii.member(jsii_name="seed")
    def seed(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seed"))

    @seed.setter
    def seed(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__630edbed808a10f83c736b4fc30638652ab9bbd4b86d1cd7d3bfd578cdf8645c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seed", value)

    @builtins.property
    @jsii.member(jsii_name="seedVar")
    def seed_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seedVar"))

    @seed_var.setter
    def seed_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2dd54f1f7596d526fcd92bea40c99e7095ff1818c4536ab7bc9c76bdc5cb2d9d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seedVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultGoop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultGoop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultGoop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d51eef1bc9424410bc620571a39bc2aefa38233253f816386912a33dd6b50271)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultGrayscale",
    jsii_struct_bases=[],
    name_mapping={"type": "type", "type_var": "typeVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultGrayscale:
    def __init__(
        self,
        *,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param type: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__292002317521d6fde579ac1b1557457dc40a67d38be26fd85e54c2089043a92e)
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultGrayscale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultGrayscaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultGrayscaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__65994f8169e342ea9aa2492018d0626bda063a22963e25d7e49d6b32c68baf51)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultGrayscaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ca62170873571daae8f00870e6082c9e56bb8b84bb2cb0792cf4f4d1482d14d2)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultGrayscaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1e268d946e49057b6d2796790501881a31c3b51f0f81d38923d01e53e0d450b2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a39ec7224a914a78f508ed6ef31fa78eab6651c1dbcc2fc6a8268c58b6cc6b44)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8c6e88e0ab500fe9aa6f31bce8c7fe496550d8df6bbc75838b722c60ec0e7859)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultGrayscale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultGrayscale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f52f8af8e0987b132091ac47100bf45b3f3ca762aaded868605ebc86f1197738)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultGrayscaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultGrayscaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__68bb4686b3111f56f2110695f2e5046f29a4ca3c50fc097af4737dd32111ea29)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a6b4fda82c397715f6776b5049466494cc06030fa1fa5365155379c47923cfd3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a672ca642afb4940ed31b8f7aafeb29323c87173d4889beafc5af0314c041a42)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultGrayscale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultGrayscale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultGrayscale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__05913e59e8de9d47ecbf7ffbeb3d3df2ca05d46e4748bd405756d6e4c569bdbc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultHsl",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "lightness": "lightness",
        "lightness_var": "lightnessVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultHsl:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness: typing.Optional[builtins.str] = None,
        lightness_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        :param lightness_var: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__98c1cf2f3ae665eee7ced7f068348d7651265cbbdf572aafef69e80175f7e0ae)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness", value=lightness, expected_type=type_hints["lightness"])
            check_type(argname="argument lightness_var", value=lightness_var, expected_type=type_hints["lightness_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness is not None:
            self._values["lightness"] = lightness
        if lightness_var is not None:
            self._values["lightness_var"] = lightness_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        '''
        result = self._values.get("lightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        '''
        result = self._values.get("lightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultHsl(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultHslList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultHslList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e6cc97b8c11d09ef18ea74cfd5e0132d0291bd7c7083555cf89e27bd9e442c0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultHslOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__baff14eb1123c76c4b452319c72ccab957c447d35d99fa4c9ca695a952d02edc)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultHslOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8eff524e9c096f038a45134464d9546552719775315af7490ec3432b3c750523)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__95663abcaef17b1f9d5dd86256efa9e003544d5c437d72d5f0fb219b09a7170f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__90f4321d99b258e11006224d14c533909a78309a498ed798590993dbba8b620c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultHsl]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultHsl]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb53757b38109014e1a1b7ba8c7da5fd046a00a2791bdb20122b3e6b4524840a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultHslOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultHslOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7966b370f351827f3295274a06faf71af9f7b6e169824d5465882e45a552f5a7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightness")
    def reset_lightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightness", []))

    @jsii.member(jsii_name="resetLightnessVar")
    def reset_lightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessInput")
    def lightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessVarInput")
    def lightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a188a94bd87f897f35168484f3448f30a6674252d8bccf957d4b8679b3ea3d7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f43b23bd84527d52448e30cf85c0dacba1af492631f8e8d3ce70149be8fb3d62)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightness")
    def lightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightness"))

    @lightness.setter
    def lightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__50d836f5c70de62a1654ecc1eb86cf3fc7413e8b702c2b035cf540fe63993b68)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightness", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessVar")
    def lightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessVar"))

    @lightness_var.setter
    def lightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c3643887ae72d41d7844434e96dae834f83244883cb30ab73529e5c77492d1c8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7ad43e5b1a31d4f4c5d16e892f3074b6393a58b8f2f646e640090159c218bad2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__04143f2e4a1a04a8c541ed69025d1b070f6313b8ef068d4f92a9c2bd27b33f94)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultHsl]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultHsl]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultHsl]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e182fd30709bd32f0dac46b310f965ddffe1f703d3b629a6b9a706d2ce8421a6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultHsv",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultHsv:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        :param value: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df0ed2a9df2c0fe32a007feddf6fbf812823a8e4490a92eb507ba2ec5556c28e)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultHsv(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultHsvList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultHsvList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6ab033ec5b21256b3690d5a154406cea2e28572558a489b4790dcf7ccc7e7f4d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultHsvOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8748cd5a9d74313c560bf98cfefea04ff1663e82002e4d87192049eccb81a1e8)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultHsvOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f9cf4b7b4aa86d570d3b043be1bcc9fe90f8de45c6faef12358815ddb6004060)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fdeaf0f827f0d2a7587a12c3d318db3bbd26c00117f573f46f889bcd832a0af8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ecf8fe7e3fb96c7ef84157679eb93e84fadf79b7e44677e44e7bb138951b5e51)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultHsv]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultHsv]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0d51b7f3f6106dbae9607b18742ff55cee99d3c33c49e1ec88c090ff777e55c0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultHsvOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultHsvOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d7b015302cb6a146b55d18ecb59a82bfd5aa335fb89c93e94a395be8a9a60e3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__98ffe0cbbda97182d8132fb3f135681f7f30f47f69a663560b7f6d785d381ba5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__faa17b3c2abf50febda8e272e579709369c0a9818624d2899189862bed6739af)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f6aa244e7ec22109b9f367910d1ea12ad103215e83afff466016f8b257a7852)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3d52a4f3cc930814325db57675f6980f154d63a199ad969e19e604604cd5e059)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d6f3b9996b36b189d716da33ee0622414df14a37975c9f22788a1b177413fee3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ae85ef0203d09030f9b9044a33c4dac03cf5cfc22e5c223aa0a61dedbef2e563)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultHsv]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultHsv]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultHsv]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__10e6f9fffada15a4e05f4e27c8c86c2e0e67ccf580c64721dda50f067ba4c1a3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimension",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "dimension": "dimension",
        "dimension_var": "dimensionVar",
        "equal": "equal",
        "greater_than": "greaterThan",
        "less_than": "lessThan",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimension:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        dimension: typing.Optional[builtins.str] = None,
        dimension_var: typing.Optional[builtins.str] = None,
        equal: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionEqual", typing.Dict[builtins.str, typing.Any]]] = None,
        greater_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionGreaterThan", typing.Dict[builtins.str, typing.Any]]] = None,
        less_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionLessThan", typing.Dict[builtins.str, typing.Any]]] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param dimension: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        :param dimension_var: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        :param equal: equal block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        :param greater_than: greater_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        :param less_than: less_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        :param value: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionDefault(**default)
        if isinstance(equal, dict):
            equal = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionEqual(**equal)
        if isinstance(greater_than, dict):
            greater_than = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionGreaterThan(**greater_than)
        if isinstance(less_than, dict):
            less_than = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionLessThan(**less_than)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9c48bedfb24068036801d63ddfa825feb449b8c80c08f744014ba7a8b2ae437f)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument dimension", value=dimension, expected_type=type_hints["dimension"])
            check_type(argname="argument dimension_var", value=dimension_var, expected_type=type_hints["dimension_var"])
            check_type(argname="argument equal", value=equal, expected_type=type_hints["equal"])
            check_type(argname="argument greater_than", value=greater_than, expected_type=type_hints["greater_than"])
            check_type(argname="argument less_than", value=less_than, expected_type=type_hints["less_than"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if dimension is not None:
            self._values["dimension"] = dimension
        if dimension_var is not None:
            self._values["dimension_var"] = dimension_var
        if equal is not None:
            self._values["equal"] = equal
        if greater_than is not None:
            self._values["greater_than"] = greater_than
        if less_than is not None:
            self._values["less_than"] = less_than
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionDefault"], result)

    @builtins.property
    def dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        '''
        result = self._values.get("dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        '''
        result = self._values.get("dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def equal(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionEqual"]:
        '''equal block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        '''
        result = self._values.get("equal")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionEqual"], result)

    @builtins.property
    def greater_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionGreaterThan"]:
        '''greater_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        '''
        result = self._values.get("greater_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionGreaterThan"], result)

    @builtins.property
    def less_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionLessThan"]:
        '''less_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        '''
        result = self._values.get("less_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionLessThan"], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimension(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4c97b213466c5b13b3977cc2398a5fbf579ad58e04fc3e16323ab4139d6713f6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0a9ff5c01f37611521631fc67360331268fb44a39cc105f13e855978b3d48ac5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionEqual",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionEqual:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionEqual(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionEqualOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionEqualOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4124f65cbcd01c91bb751eaaf5838f24e96872d5cdf820b1efa064180e54080d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionEqual], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionEqual],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7ceda55f0fb54998b698882e622140a98ac39796e1dcaf4529fafa5df4c59091)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionGreaterThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionGreaterThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionGreaterThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionGreaterThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionGreaterThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__38d6bf38caf3d41cb63a98f5eaddafdd6e2e3c0ce2f307da39df568cfa1986aa)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionGreaterThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionGreaterThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac7b8ccb8aba6b7e6493c33a080b2bd4237db8abc59696f47699e18b50b647c1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionLessThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionLessThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionLessThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionLessThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionLessThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__efb3465dbd4487d14139913aa1e211e26b489f8fdc8d118dea890a073e217cd9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionLessThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionLessThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__94e26a840da08484b195782f465bc1423ca913adcaf00762a6734726786e19e6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f2cc814d992e823eb6942b0a114bde199613115b406ddbd97d7e537678ff7280)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cc6414105ff38b65e6dd8c82633da68a3de5ccc5e95248022db4bf322b9dc6a3)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e052fde3b5055fef83602932fe64d1f815e7b7bf60720998f404c69164c77e4a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__25d912df0c50db97db7d2a1d01dc186cca05e24d0c171b9ad6336d5e1acb8e18)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__22e553bbcceaa75ddc6d9d994b2c1330e7ae39a5eec2d5bd8e0e06312291a293)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimension]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimension]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1b0b26bb4c73e9c1f811fb31623fdc3e67282030e17dbcfdfc45fa7db049289d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a7561891ce62dc79d73ce56194152c04698bbd3b9c444bc79906c1cd33162463)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putEqual")
    def put_equal(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionEqual()

        return typing.cast(None, jsii.invoke(self, "putEqual", [value]))

    @jsii.member(jsii_name="putGreaterThan")
    def put_greater_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionGreaterThan()

        return typing.cast(None, jsii.invoke(self, "putGreaterThan", [value]))

    @jsii.member(jsii_name="putLessThan")
    def put_less_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionLessThan()

        return typing.cast(None, jsii.invoke(self, "putLessThan", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetDimension")
    def reset_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimension", []))

    @jsii.member(jsii_name="resetDimensionVar")
    def reset_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimensionVar", []))

    @jsii.member(jsii_name="resetEqual")
    def reset_equal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEqual", []))

    @jsii.member(jsii_name="resetGreaterThan")
    def reset_greater_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGreaterThan", []))

    @jsii.member(jsii_name="resetLessThan")
    def reset_less_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLessThan", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="equal")
    def equal(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionEqualOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionEqualOutputReference, jsii.get(self, "equal"))

    @builtins.property
    @jsii.member(jsii_name="greaterThan")
    def greater_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionGreaterThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionGreaterThanOutputReference, jsii.get(self, "greaterThan"))

    @builtins.property
    @jsii.member(jsii_name="lessThan")
    def less_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionLessThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionLessThanOutputReference, jsii.get(self, "lessThan"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionInput")
    def dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionVarInput")
    def dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="equalInput")
    def equal_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionEqual], jsii.get(self, "equalInput"))

    @builtins.property
    @jsii.member(jsii_name="greaterThanInput")
    def greater_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionGreaterThan], jsii.get(self, "greaterThanInput"))

    @builtins.property
    @jsii.member(jsii_name="lessThanInput")
    def less_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionLessThan], jsii.get(self, "lessThanInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="dimension")
    def dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimension"))

    @dimension.setter
    def dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__849dea0ee18694d83a28a522d319d79d535854739751a64019e7efc970ce9cc3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimension", value)

    @builtins.property
    @jsii.member(jsii_name="dimensionVar")
    def dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimensionVar"))

    @dimension_var.setter
    def dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__041000f7f1af5368ca50b573e5907333fcf0a90340d1a687fd7fed779300adfc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5224a027ea9e47def1e9fab92ab4d6c33f53a3a117a1d68083321b916b722238)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b16b9ac1333720cec11cd34921599ccd057d9b74fea9ec35fdde5c743d19a446)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimension]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimension]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimension]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__60faef8f52f4a921b467df8d3686dc48d416d138dae68f2c3ced475b98921990)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientation",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "landscape": "landscape",
        "portrait": "portrait",
        "square": "square",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientation:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        landscape: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationLandscape", typing.Dict[builtins.str, typing.Any]]] = None,
        portrait: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationPortrait", typing.Dict[builtins.str, typing.Any]]] = None,
        square: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationSquare", typing.Dict[builtins.str, typing.Any]]] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param landscape: landscape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        :param portrait: portrait block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        :param square: square block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationDefault(**default)
        if isinstance(landscape, dict):
            landscape = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationLandscape(**landscape)
        if isinstance(portrait, dict):
            portrait = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationPortrait(**portrait)
        if isinstance(square, dict):
            square = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationSquare(**square)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f8c0df47cca575ed2c47bf92e85456799d9d2cf03df06f9cb4a0c3401363b4d7)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument landscape", value=landscape, expected_type=type_hints["landscape"])
            check_type(argname="argument portrait", value=portrait, expected_type=type_hints["portrait"])
            check_type(argname="argument square", value=square, expected_type=type_hints["square"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if landscape is not None:
            self._values["landscape"] = landscape
        if portrait is not None:
            self._values["portrait"] = portrait
        if square is not None:
            self._values["square"] = square

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationDefault"], result)

    @builtins.property
    def landscape(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationLandscape"]:
        '''landscape block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        '''
        result = self._values.get("landscape")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationLandscape"], result)

    @builtins.property
    def portrait(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationPortrait"]:
        '''portrait block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        '''
        result = self._values.get("portrait")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationPortrait"], result)

    @builtins.property
    def square(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationSquare"]:
        '''square block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        result = self._values.get("square")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationSquare"], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8810f1e70285198ff06d208e72469b542c7bdbe9e15d64573e1df858537b15d8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3c0dcf3de0e2d936598e1ebb284ba6a35d33a12cb929d2fe6a0590f0fc40e8ad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationLandscape",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationLandscape:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationLandscape(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationLandscapeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationLandscapeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__117fde96ab227d6ac5bc89fd9266780116d47175e1e196e6aea43ed52bffea3f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationLandscape], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationLandscape],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__978b20a3d7036587c45cb9456a0e3f0b77cde974631e5bfc70704a929442edba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__46d8e1ffdcb9834731313fe5101cad0a08459162fa1d13ea3e446e75d942a348)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__178009745a86b7fde1ef5fbe58070428102678ebf2e010d991474603591b0d22)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__49b515db779829c78107dbd2792004e357a937e136a01ba6d6aba19839cf8b1d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c95b590f210ce71da71169d667706b7fdfafde84b3c7a7f4f6200a3da209798b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bd8c2c669131039a3924eed4fbe2d3730f0ca6d592b100dbc0b755c58aa8e744)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientation]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientation]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fe63624f1b01b6dfb89052ff89844f1e9d82980377063163249633e86cd52c81)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__650f0cde4669e87c0f38712cd1f4b0220b7558beb203042c45d4068c2d3e1f02)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putLandscape")
    def put_landscape(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationLandscape()

        return typing.cast(None, jsii.invoke(self, "putLandscape", [value]))

    @jsii.member(jsii_name="putPortrait")
    def put_portrait(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationPortrait()

        return typing.cast(None, jsii.invoke(self, "putPortrait", [value]))

    @jsii.member(jsii_name="putSquare")
    def put_square(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationSquare()

        return typing.cast(None, jsii.invoke(self, "putSquare", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetLandscape")
    def reset_landscape(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLandscape", []))

    @jsii.member(jsii_name="resetPortrait")
    def reset_portrait(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPortrait", []))

    @jsii.member(jsii_name="resetSquare")
    def reset_square(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSquare", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="landscape")
    def landscape(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationLandscapeOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationLandscapeOutputReference, jsii.get(self, "landscape"))

    @builtins.property
    @jsii.member(jsii_name="portrait")
    def portrait(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationPortraitOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationPortraitOutputReference", jsii.get(self, "portrait"))

    @builtins.property
    @jsii.member(jsii_name="square")
    def square(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationSquareOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationSquareOutputReference", jsii.get(self, "square"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="landscapeInput")
    def landscape_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationLandscape], jsii.get(self, "landscapeInput"))

    @builtins.property
    @jsii.member(jsii_name="portraitInput")
    def portrait_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationPortrait"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationPortrait"], jsii.get(self, "portraitInput"))

    @builtins.property
    @jsii.member(jsii_name="squareInput")
    def square_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationSquare"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationSquare"], jsii.get(self, "squareInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientation]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientation]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientation]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0db0d7bdec595a4a190e37716da535f6dc5f542a631d7ad719b37d4360280eb5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationPortrait",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationPortrait:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationPortrait(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationPortraitOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationPortraitOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8622d515a4ced318f9dde18e6d761843c90a19048c9743f13e69299792365a89)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationPortrait]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationPortrait], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationPortrait],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__398e4e5a84fa30b221d0e3e9152a01df102d0a7323e37497f2a85babb51e9161)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationSquare",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationSquare:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationSquare(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationSquareOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationSquareOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7531658f6cae148deacc507f73548b7bac8af974f1d984f4bb0f41d26a295276)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationSquare]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationSquare], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationSquare],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__38be51255255532a366f6cb14213f10b7a79d5436a1b438dd2b81822c54c4d3a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultMaxColors",
    jsii_struct_bases=[],
    name_mapping={"colors": "colors", "colors_var": "colorsVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultMaxColors:
    def __init__(
        self,
        *,
        colors: typing.Optional[builtins.str] = None,
        colors_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param colors: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        :param colors_var: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8f1f5e6cf9e71dddf4fa8ad6f4f1a6df79ce1f9b1613826dab17895d9463db73)
            check_type(argname="argument colors", value=colors, expected_type=type_hints["colors"])
            check_type(argname="argument colors_var", value=colors_var, expected_type=type_hints["colors_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if colors is not None:
            self._values["colors"] = colors
        if colors_var is not None:
            self._values["colors_var"] = colors_var

    @builtins.property
    def colors(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        '''
        result = self._values.get("colors")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def colors_var(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        result = self._values.get("colors_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultMaxColors(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultMaxColorsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultMaxColorsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5fc48e40cb25a6e60077a2fd4a846beff8be182071b8c66e26ab5d9bb4fdfbfb)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultMaxColorsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0e3854f9f84ad59138ebb6444f2c8bcac7d34da1843a2071a40252b32e6e2ff5)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultMaxColorsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__db69e2186bea2c7bed241befb73e27663ae72e561c3e3f8bd81905ba27f9dc0f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__27a8363165d0675884488f17eefb0061ace75647adf029123239f6c5cacb56e4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fb3bcf66582626c9d1b3b306f3099e159f6045774818ada16ab29c7620e9e05c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultMaxColors]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultMaxColors]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__580bba499286c5c724f48430e8798ab81a9b7672ee821787c09af5d438cba658)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultMaxColorsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultMaxColorsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4d6177fe4f83965e90f4421f495957fe8722ca4bade14a4d6a2b64dc9911dc48)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColors")
    def reset_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColors", []))

    @jsii.member(jsii_name="resetColorsVar")
    def reset_colors_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorsVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorsInput")
    def colors_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsInput"))

    @builtins.property
    @jsii.member(jsii_name="colorsVarInput")
    def colors_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsVarInput"))

    @builtins.property
    @jsii.member(jsii_name="colors")
    def colors(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colors"))

    @colors.setter
    def colors(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__21909fe79b1bb605bb39c6ec780b454b3bf5d20da1b7698e7c72f021d03161f5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colors", value)

    @builtins.property
    @jsii.member(jsii_name="colorsVar")
    def colors_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorsVar"))

    @colors_var.setter
    def colors_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__269a93d3543c4009deae08f53c38c615e65ee96422e39864294111df0c676de4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorsVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultMaxColors]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultMaxColors]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultMaxColors]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac3e520084d9119cb9981c5fd6e9466639badbfa1b93c0cab0a4d818f791c3f5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultMirror",
    jsii_struct_bases=[],
    name_mapping={
        "horizontal": "horizontal",
        "horizontal_var": "horizontalVar",
        "vertical": "vertical",
        "vertical_var": "verticalVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultMirror:
    def __init__(
        self,
        *,
        horizontal: typing.Optional[builtins.str] = None,
        horizontal_var: typing.Optional[builtins.str] = None,
        vertical: typing.Optional[builtins.str] = None,
        vertical_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param horizontal: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        :param horizontal_var: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        :param vertical: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        :param vertical_var: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ccdf059fc4e13f3f26ae2908a33ff6b037690f438c0a92bed204c57fd850296)
            check_type(argname="argument horizontal", value=horizontal, expected_type=type_hints["horizontal"])
            check_type(argname="argument horizontal_var", value=horizontal_var, expected_type=type_hints["horizontal_var"])
            check_type(argname="argument vertical", value=vertical, expected_type=type_hints["vertical"])
            check_type(argname="argument vertical_var", value=vertical_var, expected_type=type_hints["vertical_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if horizontal is not None:
            self._values["horizontal"] = horizontal
        if horizontal_var is not None:
            self._values["horizontal_var"] = horizontal_var
        if vertical is not None:
            self._values["vertical"] = vertical
        if vertical_var is not None:
            self._values["vertical_var"] = vertical_var

    @builtins.property
    def horizontal(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        '''
        result = self._values.get("horizontal")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def horizontal_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        '''
        result = self._values.get("horizontal_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        '''
        result = self._values.get("vertical")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        result = self._values.get("vertical_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultMirror(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultMirrorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultMirrorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__238435485e5ab0d7316aa1222cb9d6f2ef94ec32fea8785ed06192a6c04fbf72)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultMirrorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__44028f7c6754f35ee5c71e36f11ba8f586da4863ca595a9d06b7f3425a301c12)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultMirrorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__06722712133ad378ce43b7470987b2d60271db14f0a3ebcf06392b89c819344f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1ff3362bfef32ff29f70384d1c91930b25e4543dfd8263f69bf0abaa60e1045e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1db80a9045e28c3a5b8036a2364984399ff04ca774706dd115ee59c5a4badd7d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultMirror]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultMirror]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b01154b1c5934710850c7940e91774596f7417196302ea702826d3f6b821c183)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultMirrorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultMirrorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__98b3b1018aa4a033c034c64a530b5323fabbec3bc6ee50cb3fc4e716d6272976)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHorizontal")
    def reset_horizontal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontal", []))

    @jsii.member(jsii_name="resetHorizontalVar")
    def reset_horizontal_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontalVar", []))

    @jsii.member(jsii_name="resetVertical")
    def reset_vertical(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVertical", []))

    @jsii.member(jsii_name="resetVerticalVar")
    def reset_vertical_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVerticalVar", []))

    @builtins.property
    @jsii.member(jsii_name="horizontalInput")
    def horizontal_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontalVarInput")
    def horizontal_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalInput")
    def vertical_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalVarInput")
    def vertical_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontal")
    def horizontal(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontal"))

    @horizontal.setter
    def horizontal(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c078d5846ecde6b498539f5e2d274386fa6a502b974e258cc5fda9869b005a9d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontal", value)

    @builtins.property
    @jsii.member(jsii_name="horizontalVar")
    def horizontal_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontalVar"))

    @horizontal_var.setter
    def horizontal_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f93cc146e4afa025da94aa0af8f0a094a7ba0ee60adaf82c71315278bcd0876)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontalVar", value)

    @builtins.property
    @jsii.member(jsii_name="vertical")
    def vertical(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "vertical"))

    @vertical.setter
    def vertical(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c614fb7a81a0e5efd8b230b4a0b840f2cfb2fb22ea73a7f1257cb67fe215bdad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "vertical", value)

    @builtins.property
    @jsii.member(jsii_name="verticalVar")
    def vertical_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "verticalVar"))

    @vertical_var.setter
    def vertical_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ffa8a286d7a1bd0e5686d59ab0572502ae292bf5fc80550ce53d0ca499c959e6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "verticalVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultMirror]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultMirror]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultMirror]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5bf3f9f38b1f75733dd404f0722f0aea05fdae02fdc10b6df19752bcceb1b4f5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultMonoHue",
    jsii_struct_bases=[],
    name_mapping={"hue": "hue", "hue_var": "hueVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultMonoHue:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ac79045f96ba7af1cae39ea87a3251390e539d517b5aad2eca0e74b9b2cbc2e)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultMonoHue(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultMonoHueList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultMonoHueList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__19e9a97c4ee23a0dacc6cb7f98e24de384bdb08d6ec514c0b4fc14dced66fe1e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultMonoHueOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1bb1c311e7759cd1e6f2325e3bbf488524862eb11e28bfe63c4c1005f6608ae0)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultMonoHueOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__364a2af369fd8c309423bbd40a9a1c17ff698e3207bdae571e7571b3a64d7f4d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b51a0458b0c82492b991dfdb9c58427a2e98ccb04c59ec7884f1be24969f6d4f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__da346ba5c30e982cbda05684e0d270e13d53c8bee0a90f3c3fd67d40a5824fc4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultMonoHue]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultMonoHue]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5a59928eb2fa58941c6dfc165b7c3e8725adc930b77b940e351fe43d8d7db183)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultMonoHueOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultMonoHueOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5e92b6fd99d974afe8bd0a718eabb1ea3295a0df4ac58f584b83e87a3be54ae9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5becb8676a80d499b050c75e5bf4060d2ce77a9c9228cc949439ec397112b632)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__823090e00a5d9cd4c47e0257ffc19888c3ddbe93844d4c03fe35ccae015730c7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultMonoHue]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultMonoHue]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultMonoHue]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c5eec716a51e6cd2f719f82672c7a4a4aaadaf907a3a5e6f7782f85f88985bfa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultOpacity",
    jsii_struct_bases=[],
    name_mapping={"opacity": "opacity", "opacity_var": "opacityVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultOpacity:
    def __init__(
        self,
        *,
        opacity: typing.Optional[builtins.str] = None,
        opacity_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param opacity: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param opacity_var: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1e6b220747e8912e3cdfe326bac4ac27196c4c07c715eb77b0ca601355158b41)
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument opacity_var", value=opacity_var, expected_type=type_hints["opacity_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if opacity is not None:
            self._values["opacity"] = opacity
        if opacity_var is not None:
            self._values["opacity_var"] = opacity_var

    @builtins.property
    def opacity(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def opacity_var(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        result = self._values.get("opacity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultOpacity(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultOpacityList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultOpacityList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a3527d4742319c0ddb709a7c4ad57578f6c019d0261d6726318602be0ec4b03f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultOpacityOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f10e7c33ad39fe09b1838761e14b83caac6dcabe3cf4ec218ff5b512ffe86fa1)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultOpacityOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e36b5ac3234d61ceccd0682fb6a18ec18e74b96272cbd7e85c36b67492deb837)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e71af81a45a8a507c21ad1a2f1551c373f459b4b16bade45722d57366cdaaa05)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d652b9c249e90e2fb5fe70107b40d58eb23290136fd412a26fd64d0478c2c8a9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultOpacity]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultOpacity]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7efeccb40c19389ab2ecbb5f7f3537021194cb521be96dfe6567d6ac5db1a3a2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultOpacityOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultOpacityOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9174df6a76b549653d69da7c68bae7a5925b68e6971a3f98499e7e0043b767d9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetOpacityVar")
    def reset_opacity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacityVar", []))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityVarInput")
    def opacity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacity"))

    @opacity.setter
    def opacity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__620b81816e9cbf38b0c31d8a6c243c675c42283e1842109681a71284fa8f3d4e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacity", value)

    @builtins.property
    @jsii.member(jsii_name="opacityVar")
    def opacity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacityVar"))

    @opacity_var.setter
    def opacity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c11fa631c94366328063292527c5e08c6b6c6af565878f166c26d0ceeb1a29d7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacityVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultOpacity]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultOpacity]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultOpacity]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3e4b895ec338fb6617f701038f5f00c3270bb9bc6bc54773279cde1198d99f01)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df264eb14fce29801d6990293ae8983b190a1cd8a94a3b9616f068f266a94969)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putBackgroundColor")
    def put_background_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c0aae0b01f6dc2f23c9bee04f478998096c9ceaa35ea95ea196e7d223cbb1ce0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBackgroundColor", [value]))

    @jsii.member(jsii_name="putBlur")
    def put_blur(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultBlur, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__496229b988de61ca59a1b3db84e9e26223f70c01f4760d78a98103c5942c0ea6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBlur", [value]))

    @jsii.member(jsii_name="putChromaKey")
    def put_chroma_key(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultChromaKey, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e4522276fc8fc55a6c3ea10ace36bf85c1390ad10a2254f39fbed979f9eb098a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putChromaKey", [value]))

    @jsii.member(jsii_name="putComposite")
    def put_composite(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultComposite, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__064e91e7ca35848d85dc8031972a7733d6abfb0575f77251033fd32f71410d3f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putComposite", [value]))

    @jsii.member(jsii_name="putCompound")
    def put_compound(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultCompound, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__26cc88770c44e4fd23d15cb783897c6f0b0849f612a4cbff1db3635431979218)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCompound", [value]))

    @jsii.member(jsii_name="putContrast")
    def put_contrast(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultContrast, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3fbab278effeb3768c8b7444cca61e92e2db4b20894d6b2ab92c8931b36f6dcb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putContrast", [value]))

    @jsii.member(jsii_name="putGoop")
    def put_goop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultGoop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4b3c28764ea0ef663815cc87eabe6ae77fe7154f8c985251608acb18b6764701)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGoop", [value]))

    @jsii.member(jsii_name="putGrayscale")
    def put_grayscale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultGrayscale, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__903476ff208d51be9fe6da2f3edc919e8ca7947a346d5cc6391a60296a18ce97)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGrayscale", [value]))

    @jsii.member(jsii_name="putHsl")
    def put_hsl(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultHsl, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__60a76c9def6dc70fd2676996d2472d60f71e9c46bfb7a495480cf352357ee711)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsl", [value]))

    @jsii.member(jsii_name="putHsv")
    def put_hsv(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultHsv, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6aedafd8d40e0efcf5032ba912701423a0089614f15e0a496e55da2c06767f71)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsv", [value]))

    @jsii.member(jsii_name="putIfDimension")
    def put_if_dimension(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimension, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2136264c07ff06a54990a4edb55ac256bbec63584e03f262ac717d29a2aeebda)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfDimension", [value]))

    @jsii.member(jsii_name="putIfOrientation")
    def put_if_orientation(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7e81c8e70e2966d7431d0c2c40408652008d347790825f74ec546e4891d6f31c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfOrientation", [value]))

    @jsii.member(jsii_name="putMaxColors")
    def put_max_colors(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultMaxColors, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__20a910076d51dabf131a0ed0a4cca81623264ea807f615925c12846efa4056bb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMaxColors", [value]))

    @jsii.member(jsii_name="putMirror")
    def put_mirror(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultMirror, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c3862393134d484ac28aff7bb3983e93939c91ea11100bab503c02af33db937d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMirror", [value]))

    @jsii.member(jsii_name="putMonoHue")
    def put_mono_hue(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultMonoHue, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__04f200091841adf6ad6f741b7b8957fd217e05fdfd0bd2b6ee5359387a3a22ec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMonoHue", [value]))

    @jsii.member(jsii_name="putOpacity")
    def put_opacity(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultOpacity, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3d9fa13b869c883d06981a90af82878319c77171fbc10428f469792fce23a2f9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putOpacity", [value]))

    @jsii.member(jsii_name="putRemoveColor")
    def put_remove_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultRemoveColor", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4bdcd9ee9cb00d1d9f886e1d5924a0553003527002c30f1f5d1dd4147274fe03)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRemoveColor", [value]))

    @jsii.member(jsii_name="putUnsharpMask")
    def put_unsharp_mask(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultUnsharpMask", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2248ed34aeee217fed8679963a5d8c7fe688c859ae83728ef29c1f44a313dff6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putUnsharpMask", [value]))

    @jsii.member(jsii_name="resetBackgroundColor")
    def reset_background_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBackgroundColor", []))

    @jsii.member(jsii_name="resetBlur")
    def reset_blur(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBlur", []))

    @jsii.member(jsii_name="resetChromaKey")
    def reset_chroma_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChromaKey", []))

    @jsii.member(jsii_name="resetComposite")
    def reset_composite(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetComposite", []))

    @jsii.member(jsii_name="resetCompound")
    def reset_compound(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCompound", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetGoop")
    def reset_goop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGoop", []))

    @jsii.member(jsii_name="resetGrayscale")
    def reset_grayscale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGrayscale", []))

    @jsii.member(jsii_name="resetHsl")
    def reset_hsl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsl", []))

    @jsii.member(jsii_name="resetHsv")
    def reset_hsv(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsv", []))

    @jsii.member(jsii_name="resetIfDimension")
    def reset_if_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfDimension", []))

    @jsii.member(jsii_name="resetIfOrientation")
    def reset_if_orientation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfOrientation", []))

    @jsii.member(jsii_name="resetMaxColors")
    def reset_max_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxColors", []))

    @jsii.member(jsii_name="resetMirror")
    def reset_mirror(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMirror", []))

    @jsii.member(jsii_name="resetMonoHue")
    def reset_mono_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonoHue", []))

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetRemoveColor")
    def reset_remove_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRemoveColor", []))

    @jsii.member(jsii_name="resetUnsharpMask")
    def reset_unsharp_mask(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUnsharpMask", []))

    @builtins.property
    @jsii.member(jsii_name="backgroundColor")
    def background_color(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultBackgroundColorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultBackgroundColorList, jsii.get(self, "backgroundColor"))

    @builtins.property
    @jsii.member(jsii_name="blur")
    def blur(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultBlurList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultBlurList, jsii.get(self, "blur"))

    @builtins.property
    @jsii.member(jsii_name="chromaKey")
    def chroma_key(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultChromaKeyList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultChromaKeyList, jsii.get(self, "chromaKey"))

    @builtins.property
    @jsii.member(jsii_name="composite")
    def composite(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultCompositeList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultCompositeList, jsii.get(self, "composite"))

    @builtins.property
    @jsii.member(jsii_name="compound")
    def compound(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultCompoundList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultCompoundList, jsii.get(self, "compound"))

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultContrastList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultContrastList, jsii.get(self, "contrast"))

    @builtins.property
    @jsii.member(jsii_name="goop")
    def goop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultGoopList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultGoopList, jsii.get(self, "goop"))

    @builtins.property
    @jsii.member(jsii_name="grayscale")
    def grayscale(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultGrayscaleList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultGrayscaleList, jsii.get(self, "grayscale"))

    @builtins.property
    @jsii.member(jsii_name="hsl")
    def hsl(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultHslList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultHslList, jsii.get(self, "hsl"))

    @builtins.property
    @jsii.member(jsii_name="hsv")
    def hsv(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultHsvList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultHsvList, jsii.get(self, "hsv"))

    @builtins.property
    @jsii.member(jsii_name="ifDimension")
    def if_dimension(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionList, jsii.get(self, "ifDimension"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientation")
    def if_orientation(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationList, jsii.get(self, "ifOrientation"))

    @builtins.property
    @jsii.member(jsii_name="maxColors")
    def max_colors(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultMaxColorsList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultMaxColorsList, jsii.get(self, "maxColors"))

    @builtins.property
    @jsii.member(jsii_name="mirror")
    def mirror(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultMirrorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultMirrorList, jsii.get(self, "mirror"))

    @builtins.property
    @jsii.member(jsii_name="monoHue")
    def mono_hue(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultMonoHueList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultMonoHueList, jsii.get(self, "monoHue"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultOpacityList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultOpacityList, jsii.get(self, "opacity"))

    @builtins.property
    @jsii.member(jsii_name="removeColor")
    def remove_color(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultRemoveColorList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultRemoveColorList", jsii.get(self, "removeColor"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMask")
    def unsharp_mask(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultUnsharpMaskList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultUnsharpMaskList", jsii.get(self, "unsharpMask"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColorInput")
    def background_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultBackgroundColor]]], jsii.get(self, "backgroundColorInput"))

    @builtins.property
    @jsii.member(jsii_name="blurInput")
    def blur_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultBlur]]], jsii.get(self, "blurInput"))

    @builtins.property
    @jsii.member(jsii_name="chromaKeyInput")
    def chroma_key_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultChromaKey]]], jsii.get(self, "chromaKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="compositeInput")
    def composite_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultComposite]]], jsii.get(self, "compositeInput"))

    @builtins.property
    @jsii.member(jsii_name="compoundInput")
    def compound_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultCompound]]], jsii.get(self, "compoundInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultContrast]]], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="goopInput")
    def goop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultGoop]]], jsii.get(self, "goopInput"))

    @builtins.property
    @jsii.member(jsii_name="grayscaleInput")
    def grayscale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultGrayscale]]], jsii.get(self, "grayscaleInput"))

    @builtins.property
    @jsii.member(jsii_name="hslInput")
    def hsl_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultHsl]]], jsii.get(self, "hslInput"))

    @builtins.property
    @jsii.member(jsii_name="hsvInput")
    def hsv_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultHsv]]], jsii.get(self, "hsvInput"))

    @builtins.property
    @jsii.member(jsii_name="ifDimensionInput")
    def if_dimension_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimension]]], jsii.get(self, "ifDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientationInput")
    def if_orientation_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientation]]], jsii.get(self, "ifOrientationInput"))

    @builtins.property
    @jsii.member(jsii_name="maxColorsInput")
    def max_colors_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultMaxColors]]], jsii.get(self, "maxColorsInput"))

    @builtins.property
    @jsii.member(jsii_name="mirrorInput")
    def mirror_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultMirror]]], jsii.get(self, "mirrorInput"))

    @builtins.property
    @jsii.member(jsii_name="monoHueInput")
    def mono_hue_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultMonoHue]]], jsii.get(self, "monoHueInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultOpacity]]], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="removeColorInput")
    def remove_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultRemoveColor"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultRemoveColor"]]], jsii.get(self, "removeColorInput"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMaskInput")
    def unsharp_mask_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultUnsharpMask"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultUnsharpMask"]]], jsii.get(self, "unsharpMaskInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c4382cd2bc0251efcc91399263ad91d3ec6027a24f0b5f664097b02e2fa29d98)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultRemoveColor",
    jsii_struct_bases=[],
    name_mapping={
        "color": "color",
        "color_var": "colorVar",
        "feather": "feather",
        "feather_var": "featherVar",
        "tolerance": "tolerance",
        "tolerance_var": "toleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultRemoveColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
        feather: typing.Optional[builtins.str] = None,
        feather_var: typing.Optional[builtins.str] = None,
        tolerance: typing.Optional[builtins.str] = None,
        tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        :param feather: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        :param feather_var: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        :param tolerance: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        :param tolerance_var: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__47f2febb20432a440688c7e7e9a2b476a8df4fb9d6c22d5912e600613d69f0bb)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
            check_type(argname="argument feather", value=feather, expected_type=type_hints["feather"])
            check_type(argname="argument feather_var", value=feather_var, expected_type=type_hints["feather_var"])
            check_type(argname="argument tolerance", value=tolerance, expected_type=type_hints["tolerance"])
            check_type(argname="argument tolerance_var", value=tolerance_var, expected_type=type_hints["tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var
        if feather is not None:
            self._values["feather"] = feather
        if feather_var is not None:
            self._values["feather_var"] = feather_var
        if tolerance is not None:
            self._values["tolerance"] = tolerance
        if tolerance_var is not None:
            self._values["tolerance_var"] = tolerance_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        '''
        result = self._values.get("feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather_var(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        '''
        result = self._values.get("feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        '''
        result = self._values.get("tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance_var(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        result = self._values.get("tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultRemoveColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultRemoveColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultRemoveColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__07868504443d38c5e33e7d0dd480113676879b9416bc3fe26c12f9636f90b515)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultRemoveColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0b91f8781b7252c35987b6ce2b14392b48e13479ee51549b5a44a692b6b89cae)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultRemoveColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df14781a894c022f5c8a5e5325cf266b9621cf9db781f69a703b5ab1235e5fae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9dee5af693ed964a85a371433fb14528efc0602ed430d85f4c4619a6a04d1b56)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0eea3ba058e59324f3c2909a904379bca9074e98d6dffb7d97cb249f43bfe335)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultRemoveColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultRemoveColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultRemoveColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ea34fe63e4f0751477c70103c8945a206d6171285f062dcb5a25d508c0e6ba6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultRemoveColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultRemoveColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6c821ef2537ad5b0d5f1564cbd92db81cb4daf1c18da098225906b575e4407d5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @jsii.member(jsii_name="resetFeather")
    def reset_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeather", []))

    @jsii.member(jsii_name="resetFeatherVar")
    def reset_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatherVar", []))

    @jsii.member(jsii_name="resetTolerance")
    def reset_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTolerance", []))

    @jsii.member(jsii_name="resetToleranceVar")
    def reset_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featherInput")
    def feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherInput"))

    @builtins.property
    @jsii.member(jsii_name="featherVarInput")
    def feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceInput")
    def tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceVarInput")
    def tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6a614fe2902f0aebbb148c2bf6ece439b2ffbaae50efacd847efb11ba627c2c5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__726b4c3f90d250091b54ac370747c2383d583bd9b9300b9b1e60ad847b11d887)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="feather")
    def feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "feather"))

    @feather.setter
    def feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7a78ac244f7879b03f10283f5fd6eaa53ea1523f14c4758f1a7fc44f775e32bb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "feather", value)

    @builtins.property
    @jsii.member(jsii_name="featherVar")
    def feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featherVar"))

    @feather_var.setter
    def feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d9fe9d8479c8885342555eea63d8c824fbc28c07fb53b02ebf0480c4888f3dd7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featherVar", value)

    @builtins.property
    @jsii.member(jsii_name="tolerance")
    def tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tolerance"))

    @tolerance.setter
    def tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fd70b4b6fed624849d3b2dfedd500b04405c88682963564d5944c4cf8d1be136)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tolerance", value)

    @builtins.property
    @jsii.member(jsii_name="toleranceVar")
    def tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "toleranceVar"))

    @tolerance_var.setter
    def tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d43ed58894c08e62c10f3d8630ca96c33d275528e22d866228a79070501f7f0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "toleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultRemoveColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultRemoveColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultRemoveColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be06dcf532a39a8e76485acb3d04bd3f78b62af2460847996920a8d53fe16857)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultUnsharpMask",
    jsii_struct_bases=[],
    name_mapping={
        "gain": "gain",
        "gain_var": "gainVar",
        "sigma": "sigma",
        "sigma_var": "sigmaVar",
        "threshold": "threshold",
        "threshold_var": "thresholdVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultUnsharpMask:
    def __init__(
        self,
        *,
        gain: typing.Optional[builtins.str] = None,
        gain_var: typing.Optional[builtins.str] = None,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
        threshold: typing.Optional[builtins.str] = None,
        threshold_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param gain: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        :param gain_var: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        :param sigma: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        :param threshold: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        :param threshold_var: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d2b3014c7384a6bd2b8003b3c5a28d194043d95c5945582de8ef1c083975263a)
            check_type(argname="argument gain", value=gain, expected_type=type_hints["gain"])
            check_type(argname="argument gain_var", value=gain_var, expected_type=type_hints["gain_var"])
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
            check_type(argname="argument threshold", value=threshold, expected_type=type_hints["threshold"])
            check_type(argname="argument threshold_var", value=threshold_var, expected_type=type_hints["threshold_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if gain is not None:
            self._values["gain"] = gain
        if gain_var is not None:
            self._values["gain_var"] = gain_var
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var
        if threshold is not None:
            self._values["threshold"] = threshold
        if threshold_var is not None:
            self._values["threshold_var"] = threshold_var

    @builtins.property
    def gain(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        '''
        result = self._values.get("gain")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gain_var(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        '''
        result = self._values.get("gain_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        '''
        result = self._values.get("threshold")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold_var(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        result = self._values.get("threshold_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultUnsharpMask(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultUnsharpMaskList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultUnsharpMaskList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a38ac3f2b4001ef35250385855bdcd5d7323c00b67f9fc170d48ecae14e37eac)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultUnsharpMaskOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__406b252182eec816642d4cad3f0773d65277b512a7c247e8f0574d188879d470)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultUnsharpMaskOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a3dd303e162be2de5925193418c3141674d713878f6d8fb26ea1fec43b4bf972)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0bc680dff695ea3a0d4aea69104fed5c6cbc159b01b7139ffd149d0bd190453f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cf55dbe1cd1cad9629000d8ab3d3a70fc2cbbca62195b4957eba3438cd8c2f5c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultUnsharpMask]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultUnsharpMask]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultUnsharpMask]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2e6e15a1365296ac415205e5fb366a4e769dae6c0f7462f430683bb2ddc78986)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultUnsharpMaskOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultUnsharpMaskOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d3e42a40024eba770375138b174deaaa1833cb2314181dae9bb6f97e8cb0c953)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetGain")
    def reset_gain(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGain", []))

    @jsii.member(jsii_name="resetGainVar")
    def reset_gain_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGainVar", []))

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @jsii.member(jsii_name="resetThreshold")
    def reset_threshold(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThreshold", []))

    @jsii.member(jsii_name="resetThresholdVar")
    def reset_threshold_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThresholdVar", []))

    @builtins.property
    @jsii.member(jsii_name="gainInput")
    def gain_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainInput"))

    @builtins.property
    @jsii.member(jsii_name="gainVarInput")
    def gain_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdInput")
    def threshold_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdVarInput")
    def threshold_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gain")
    def gain(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gain"))

    @gain.setter
    def gain(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__413b5255c9cfb688bb7dd843f608eb4b8fbe13784f5c8729b8314304a68dcc72)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gain", value)

    @builtins.property
    @jsii.member(jsii_name="gainVar")
    def gain_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gainVar"))

    @gain_var.setter
    def gain_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__08be03b86b137d86f66e771d7caef783905f17deb403a2ed17d8d2a760713b01)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gainVar", value)

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c12b28065135c7894399bb944b065684af05305c4d93d1d3a47d3e29b7a2b896)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d61d13564021dc654617c7f2f549e6b758b73c2e04c9a243840ca163c8c6276e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="threshold")
    def threshold(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "threshold"))

    @threshold.setter
    def threshold(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dbc4f64de33558eb4401d096bbf39a1fd2924a492bbe33c99fb9802d7697b926)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "threshold", value)

    @builtins.property
    @jsii.member(jsii_name="thresholdVar")
    def threshold_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "thresholdVar"))

    @threshold_var.setter
    def threshold_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__169175ed3c96fca2c095d5d8c574d07927d46f4b270409f5806ec497a935aead)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "thresholdVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultUnsharpMask]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultUnsharpMask]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultUnsharpMask]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__183a44e0a52189353ba3e9861e24820f9ce4dafcd710c710c5e7db81f56b29a4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqual",
    jsii_struct_bases=[],
    name_mapping={
        "background_color": "backgroundColor",
        "blur": "blur",
        "chroma_key": "chromaKey",
        "composite": "composite",
        "compound": "compound",
        "contrast": "contrast",
        "goop": "goop",
        "grayscale": "grayscale",
        "hsl": "hsl",
        "hsv": "hsv",
        "if_dimension": "ifDimension",
        "if_orientation": "ifOrientation",
        "max_colors": "maxColors",
        "mirror": "mirror",
        "mono_hue": "monoHue",
        "opacity": "opacity",
        "remove_color": "removeColor",
        "unsharp_mask": "unsharpMask",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqual:
    def __init__(
        self,
        *,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualBackgroundColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualBlur", typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualChromaKey", typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualComposite", typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualCompound", typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualContrast", typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualGoop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualGrayscale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualHsl", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualHsv", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfDimension", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientation", typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualMaxColors", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualMirror", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualMonoHue", typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualOpacity", typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualRemoveColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualUnsharpMask", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__714db6d92d62932d9650997a9e537180a27473a2832c35d16e4b431e774e040c)
            check_type(argname="argument background_color", value=background_color, expected_type=type_hints["background_color"])
            check_type(argname="argument blur", value=blur, expected_type=type_hints["blur"])
            check_type(argname="argument chroma_key", value=chroma_key, expected_type=type_hints["chroma_key"])
            check_type(argname="argument composite", value=composite, expected_type=type_hints["composite"])
            check_type(argname="argument compound", value=compound, expected_type=type_hints["compound"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument goop", value=goop, expected_type=type_hints["goop"])
            check_type(argname="argument grayscale", value=grayscale, expected_type=type_hints["grayscale"])
            check_type(argname="argument hsl", value=hsl, expected_type=type_hints["hsl"])
            check_type(argname="argument hsv", value=hsv, expected_type=type_hints["hsv"])
            check_type(argname="argument if_dimension", value=if_dimension, expected_type=type_hints["if_dimension"])
            check_type(argname="argument if_orientation", value=if_orientation, expected_type=type_hints["if_orientation"])
            check_type(argname="argument max_colors", value=max_colors, expected_type=type_hints["max_colors"])
            check_type(argname="argument mirror", value=mirror, expected_type=type_hints["mirror"])
            check_type(argname="argument mono_hue", value=mono_hue, expected_type=type_hints["mono_hue"])
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument remove_color", value=remove_color, expected_type=type_hints["remove_color"])
            check_type(argname="argument unsharp_mask", value=unsharp_mask, expected_type=type_hints["unsharp_mask"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if background_color is not None:
            self._values["background_color"] = background_color
        if blur is not None:
            self._values["blur"] = blur
        if chroma_key is not None:
            self._values["chroma_key"] = chroma_key
        if composite is not None:
            self._values["composite"] = composite
        if compound is not None:
            self._values["compound"] = compound
        if contrast is not None:
            self._values["contrast"] = contrast
        if goop is not None:
            self._values["goop"] = goop
        if grayscale is not None:
            self._values["grayscale"] = grayscale
        if hsl is not None:
            self._values["hsl"] = hsl
        if hsv is not None:
            self._values["hsv"] = hsv
        if if_dimension is not None:
            self._values["if_dimension"] = if_dimension
        if if_orientation is not None:
            self._values["if_orientation"] = if_orientation
        if max_colors is not None:
            self._values["max_colors"] = max_colors
        if mirror is not None:
            self._values["mirror"] = mirror
        if mono_hue is not None:
            self._values["mono_hue"] = mono_hue
        if opacity is not None:
            self._values["opacity"] = opacity
        if remove_color is not None:
            self._values["remove_color"] = remove_color
        if unsharp_mask is not None:
            self._values["unsharp_mask"] = unsharp_mask

    @builtins.property
    def background_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualBackgroundColor"]]]:
        '''background_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        '''
        result = self._values.get("background_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualBackgroundColor"]]], result)

    @builtins.property
    def blur(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualBlur"]]]:
        '''blur block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        '''
        result = self._values.get("blur")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualBlur"]]], result)

    @builtins.property
    def chroma_key(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualChromaKey"]]]:
        '''chroma_key block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        '''
        result = self._values.get("chroma_key")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualChromaKey"]]], result)

    @builtins.property
    def composite(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualComposite"]]]:
        '''composite block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        '''
        result = self._values.get("composite")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualComposite"]]], result)

    @builtins.property
    def compound(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualCompound"]]]:
        '''compound block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        '''
        result = self._values.get("compound")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualCompound"]]], result)

    @builtins.property
    def contrast(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualContrast"]]]:
        '''contrast block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualContrast"]]], result)

    @builtins.property
    def goop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualGoop"]]]:
        '''goop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        '''
        result = self._values.get("goop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualGoop"]]], result)

    @builtins.property
    def grayscale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualGrayscale"]]]:
        '''grayscale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        '''
        result = self._values.get("grayscale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualGrayscale"]]], result)

    @builtins.property
    def hsl(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualHsl"]]]:
        '''hsl block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        '''
        result = self._values.get("hsl")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualHsl"]]], result)

    @builtins.property
    def hsv(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualHsv"]]]:
        '''hsv block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        '''
        result = self._values.get("hsv")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualHsv"]]], result)

    @builtins.property
    def if_dimension(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfDimension"]]]:
        '''if_dimension block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        '''
        result = self._values.get("if_dimension")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfDimension"]]], result)

    @builtins.property
    def if_orientation(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientation"]]]:
        '''if_orientation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        '''
        result = self._values.get("if_orientation")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientation"]]], result)

    @builtins.property
    def max_colors(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualMaxColors"]]]:
        '''max_colors block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        '''
        result = self._values.get("max_colors")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualMaxColors"]]], result)

    @builtins.property
    def mirror(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualMirror"]]]:
        '''mirror block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        '''
        result = self._values.get("mirror")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualMirror"]]], result)

    @builtins.property
    def mono_hue(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualMonoHue"]]]:
        '''mono_hue block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        '''
        result = self._values.get("mono_hue")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualMonoHue"]]], result)

    @builtins.property
    def opacity(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualOpacity"]]]:
        '''opacity block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualOpacity"]]], result)

    @builtins.property
    def remove_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualRemoveColor"]]]:
        '''remove_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        '''
        result = self._values.get("remove_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualRemoveColor"]]], result)

    @builtins.property
    def unsharp_mask(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualUnsharpMask"]]]:
        '''unsharp_mask block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        result = self._values.get("unsharp_mask")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualUnsharpMask"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqual(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualBackgroundColor",
    jsii_struct_bases=[],
    name_mapping={"color": "color", "color_var": "colorVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualBackgroundColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__28ee60e73c1ae64b10b3676c1bd3f583c52ee648610943d25c6fd5dbeca1330b)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualBackgroundColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualBackgroundColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualBackgroundColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e4cb7311ab88de689dfeac825ef1906a5a1fbc059b2b474936b7fdba6cfe496d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualBackgroundColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__895bc430c337e93c41359276342fbe371694d4f30ac33f601f272e4361172608)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualBackgroundColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__224644f2fa5608ce8c46407bf32733c3babafd2566880ada6631761cd0b503bc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0303b81025d16be70714a0faafef215cc86e87e057bf04d47dfdb7da1a5ee358)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__17f24d22d6029cbd5177813c9272a77f5d9f77d853f123391e2a6fdf6f87b14d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualBackgroundColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualBackgroundColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ec51807209f48fc572df0d3840b5ea25d65c5d6025f7f5290382d41fed8eb1e6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualBackgroundColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualBackgroundColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cdea54a1eb090bb539e2447335bcca6ab50970514aa1fc41ac4dafa5cc7d9735)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ddff6e29f3d3cdc522fb1d6435577c946736abbeffdbcf27d20daf623b045966)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__800f8ed1760451e86aeac00944cb8b1b5aad018f3bf40bc2d451c8479b8b8fcc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualBackgroundColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualBackgroundColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualBackgroundColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__57ca41f4a7de175f66f6ed4b8ac56826e219f5b20f053497e35f955390a57e1b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualBlur",
    jsii_struct_bases=[],
    name_mapping={"sigma": "sigma", "sigma_var": "sigmaVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualBlur:
    def __init__(
        self,
        *,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param sigma: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ef4b35d7b0872db373545205ebef791bc0448ea8fe1576e5a9991cb19f91ddf)
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualBlur(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualBlurList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualBlurList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cb9143d125a559770d39736b9f2e84a25a97e1f24ff6992d662c1d713b304703)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualBlurOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__43ae67d9845dd64263c07060b807153f4ced8065666832b38216eee16f59a10b)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualBlurOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4da296092a0f0fcda4181580a42c605b5fcb395c24b2d051a6a851c87a1d9f0a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8e012f815153f3cb8719d15de97aef9ae9a067fbc04692764fd04e5352ad0fb8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b7c96167cd9773917db32ad88e2c3ae5d0dbad8c85d0e7f2b638de7ec4170f6f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualBlur]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualBlur]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bab6ec97d44fecd1d5ecbba635140a92e63e03ed31cc1b39d9253d9fef230f94)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualBlurOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualBlurOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__81b354ab3a830ff71417c11a12735dd5eeedec3cf804507034b8dd3af1461e24)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5b6dd8c640b320b01b61c417d00b7966b4830d442a8a1401ea2f3fefb68406a0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1cb82cc0c5a1588aa3cf3225c0ba1703fb8edf9bda604212f085e678726dab58)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualBlur]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualBlur]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualBlur]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8993dc42caa8a09d5886b3a0a8ea66ef11ab8a9c2898e3bd3b2f9036ed905748)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualChromaKey",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_feather": "hueFeather",
        "hue_feather_var": "hueFeatherVar",
        "hue_tolerance": "hueTolerance",
        "hue_tolerance_var": "hueToleranceVar",
        "hue_var": "hueVar",
        "lightness_feather": "lightnessFeather",
        "lightness_feather_var": "lightnessFeatherVar",
        "lightness_tolerance": "lightnessTolerance",
        "lightness_tolerance_var": "lightnessToleranceVar",
        "saturation_feather": "saturationFeather",
        "saturation_feather_var": "saturationFeatherVar",
        "saturation_tolerance": "saturationTolerance",
        "saturation_tolerance_var": "saturationToleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualChromaKey:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_feather: typing.Optional[builtins.str] = None,
        hue_feather_var: typing.Optional[builtins.str] = None,
        hue_tolerance: typing.Optional[builtins.str] = None,
        hue_tolerance_var: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness_feather: typing.Optional[builtins.str] = None,
        lightness_feather_var: typing.Optional[builtins.str] = None,
        lightness_tolerance: typing.Optional[builtins.str] = None,
        lightness_tolerance_var: typing.Optional[builtins.str] = None,
        saturation_feather: typing.Optional[builtins.str] = None,
        saturation_feather_var: typing.Optional[builtins.str] = None,
        saturation_tolerance: typing.Optional[builtins.str] = None,
        saturation_tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_feather: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        :param hue_feather_var: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        :param hue_tolerance: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        :param hue_tolerance_var: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        :param hue_var: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness_feather: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        :param lightness_feather_var: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        :param lightness_tolerance: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        :param lightness_tolerance_var: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        :param saturation_feather: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        :param saturation_feather_var: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        :param saturation_tolerance: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        :param saturation_tolerance_var: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1afc7919a90abdb5fba3655fbe71a6178756f9fcd86da00f67977699efb15b04)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_feather", value=hue_feather, expected_type=type_hints["hue_feather"])
            check_type(argname="argument hue_feather_var", value=hue_feather_var, expected_type=type_hints["hue_feather_var"])
            check_type(argname="argument hue_tolerance", value=hue_tolerance, expected_type=type_hints["hue_tolerance"])
            check_type(argname="argument hue_tolerance_var", value=hue_tolerance_var, expected_type=type_hints["hue_tolerance_var"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness_feather", value=lightness_feather, expected_type=type_hints["lightness_feather"])
            check_type(argname="argument lightness_feather_var", value=lightness_feather_var, expected_type=type_hints["lightness_feather_var"])
            check_type(argname="argument lightness_tolerance", value=lightness_tolerance, expected_type=type_hints["lightness_tolerance"])
            check_type(argname="argument lightness_tolerance_var", value=lightness_tolerance_var, expected_type=type_hints["lightness_tolerance_var"])
            check_type(argname="argument saturation_feather", value=saturation_feather, expected_type=type_hints["saturation_feather"])
            check_type(argname="argument saturation_feather_var", value=saturation_feather_var, expected_type=type_hints["saturation_feather_var"])
            check_type(argname="argument saturation_tolerance", value=saturation_tolerance, expected_type=type_hints["saturation_tolerance"])
            check_type(argname="argument saturation_tolerance_var", value=saturation_tolerance_var, expected_type=type_hints["saturation_tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_feather is not None:
            self._values["hue_feather"] = hue_feather
        if hue_feather_var is not None:
            self._values["hue_feather_var"] = hue_feather_var
        if hue_tolerance is not None:
            self._values["hue_tolerance"] = hue_tolerance
        if hue_tolerance_var is not None:
            self._values["hue_tolerance_var"] = hue_tolerance_var
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness_feather is not None:
            self._values["lightness_feather"] = lightness_feather
        if lightness_feather_var is not None:
            self._values["lightness_feather_var"] = lightness_feather_var
        if lightness_tolerance is not None:
            self._values["lightness_tolerance"] = lightness_tolerance
        if lightness_tolerance_var is not None:
            self._values["lightness_tolerance_var"] = lightness_tolerance_var
        if saturation_feather is not None:
            self._values["saturation_feather"] = saturation_feather
        if saturation_feather_var is not None:
            self._values["saturation_feather_var"] = saturation_feather_var
        if saturation_tolerance is not None:
            self._values["saturation_tolerance"] = saturation_tolerance
        if saturation_tolerance_var is not None:
            self._values["saturation_tolerance_var"] = saturation_tolerance_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        '''
        result = self._values.get("hue_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        '''
        result = self._values.get("hue_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        '''
        result = self._values.get("hue_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        '''
        result = self._values.get("hue_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        '''
        result = self._values.get("lightness_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        '''
        result = self._values.get("lightness_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        '''
        result = self._values.get("lightness_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        '''
        result = self._values.get("lightness_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        '''
        result = self._values.get("saturation_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        '''
        result = self._values.get("saturation_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        '''
        result = self._values.get("saturation_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        result = self._values.get("saturation_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualChromaKey(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualChromaKeyList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualChromaKeyList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__96b0fa4da39472d44ad271e2b56b3b459e0868dcc95ccbbb66296c2cd07d246a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualChromaKeyOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__871aaceeeb901a3c3588764ef9cfbfece9e45783b4154c2d051d430950edd2ef)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualChromaKeyOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dd81a9594cd600eee28c39479a6b0f9cde8214d36c9809afe7fbf905f70fee8e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__03401fb24cb842d6845ba99d7afbb46103fd9761e136bbf980b6723eccfc1aef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__47e667ad046a2374522149c9493056f7ef83e1508f4a82fc6c9f8a02fce63fa1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualChromaKey]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualChromaKey]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c5db70c606c4341d4bbfb5ea0a570a1cdc14239831c3915e8af9f08f52b09a87)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualChromaKeyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualChromaKeyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d3db47f5d95c2f1b2c46c93fe0fdc294f45203164eae95e86b11231e269255bf)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueFeather")
    def reset_hue_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeather", []))

    @jsii.member(jsii_name="resetHueFeatherVar")
    def reset_hue_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeatherVar", []))

    @jsii.member(jsii_name="resetHueTolerance")
    def reset_hue_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueTolerance", []))

    @jsii.member(jsii_name="resetHueToleranceVar")
    def reset_hue_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueToleranceVar", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightnessFeather")
    def reset_lightness_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeather", []))

    @jsii.member(jsii_name="resetLightnessFeatherVar")
    def reset_lightness_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeatherVar", []))

    @jsii.member(jsii_name="resetLightnessTolerance")
    def reset_lightness_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessTolerance", []))

    @jsii.member(jsii_name="resetLightnessToleranceVar")
    def reset_lightness_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessToleranceVar", []))

    @jsii.member(jsii_name="resetSaturationFeather")
    def reset_saturation_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeather", []))

    @jsii.member(jsii_name="resetSaturationFeatherVar")
    def reset_saturation_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeatherVar", []))

    @jsii.member(jsii_name="resetSaturationTolerance")
    def reset_saturation_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationTolerance", []))

    @jsii.member(jsii_name="resetSaturationToleranceVar")
    def reset_saturation_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherInput")
    def hue_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVarInput")
    def hue_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceInput")
    def hue_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVarInput")
    def hue_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherInput")
    def lightness_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVarInput")
    def lightness_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceInput")
    def lightness_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVarInput")
    def lightness_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherInput")
    def saturation_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVarInput")
    def saturation_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceInput")
    def saturation_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVarInput")
    def saturation_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4f3140d66b25dff70847af7a4f3af9a613f57893ef463891ee9ceef8bec4f781)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeather")
    def hue_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeather"))

    @hue_feather.setter
    def hue_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1d46495f6efb7fb83b2151e067b5cca676253d3a6c7563bd873c67aaaab22116)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeather", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVar")
    def hue_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeatherVar"))

    @hue_feather_var.setter
    def hue_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__583449708ef640d08e3e6bd1df7599d48584ad10dca6d9245d3bbadcfb97e017)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueTolerance")
    def hue_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueTolerance"))

    @hue_tolerance.setter
    def hue_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a6f9ba463dd5a2497cee980553ab33ec05514fe2a5d251c519f403231a946e9b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVar")
    def hue_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueToleranceVar"))

    @hue_tolerance_var.setter
    def hue_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__082dcbd12129a63d77c0a128258e5f637f784db9222d47f3505573f1f644e4ee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5c70358056ffc41e5f7130fdf474e7a702f1c5c13b4fc762cd21e28ebe15b204)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeather")
    def lightness_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeather"))

    @lightness_feather.setter
    def lightness_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__68ec33b6dbb2307b39e9c575386a15a741c4319807d58af3966678dc87000bb6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeather", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVar")
    def lightness_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeatherVar"))

    @lightness_feather_var.setter
    def lightness_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1fbab38bf4e84f1a5a3b67ef1669fe8aa5b57d56177e4b6713feb1e3d511069b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessTolerance")
    def lightness_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessTolerance"))

    @lightness_tolerance.setter
    def lightness_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e3ff7ac82e45d9a0228d0b29acc23c1954ce264ddda935b70d94dee2c0f7198)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVar")
    def lightness_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessToleranceVar"))

    @lightness_tolerance_var.setter
    def lightness_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2c4980e69da5522c2eb54d5819345d390366451c89ddf987471c9d932a592ad8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeather")
    def saturation_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeather"))

    @saturation_feather.setter
    def saturation_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__365ef1ab733744abff1dcb56f32eee38e2e2daea95c17f2f3c84f83708432785)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeather", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVar")
    def saturation_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeatherVar"))

    @saturation_feather_var.setter
    def saturation_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1cc313b3f3f3680f9ddd55fffc337e8993fa3c1e14066dfc479f726f3d2c80f6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationTolerance")
    def saturation_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationTolerance"))

    @saturation_tolerance.setter
    def saturation_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dd59dfc3d626fac2c20f1c0a7124eb359676a9de98f92454649077cf71f02683)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVar")
    def saturation_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationToleranceVar"))

    @saturation_tolerance_var.setter
    def saturation_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__39ac58a305c65a954fd5c053e360052f3358da4a60ddca80016c520adf70f669)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualChromaKey]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualChromaKey]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualChromaKey]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9085fd0f6468e286051e80c9325b43c4063488906dc165a91c5b5145b0c50106)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualComposite",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "placement": "placement",
        "placement_var": "placementVar",
        "scale": "scale",
        "scale_dimension": "scaleDimension",
        "scale_dimension_var": "scaleDimensionVar",
        "scale_var": "scaleVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualComposite:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualCompositeImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        placement: typing.Optional[builtins.str] = None,
        placement_var: typing.Optional[builtins.str] = None,
        scale: typing.Optional[builtins.str] = None,
        scale_dimension: typing.Optional[builtins.str] = None,
        scale_dimension_var: typing.Optional[builtins.str] = None,
        scale_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param placement: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        :param placement_var: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        :param scale: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param scale_dimension: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        :param scale_dimension_var: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        :param scale_var: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        :param x_position: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualCompositeImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cb3c50c0c33ae937d52d1cf9f3f4f1fac4e1b17ef9f0f1b7125c4dff06597842)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument placement", value=placement, expected_type=type_hints["placement"])
            check_type(argname="argument placement_var", value=placement_var, expected_type=type_hints["placement_var"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument scale_dimension", value=scale_dimension, expected_type=type_hints["scale_dimension"])
            check_type(argname="argument scale_dimension_var", value=scale_dimension_var, expected_type=type_hints["scale_dimension_var"])
            check_type(argname="argument scale_var", value=scale_var, expected_type=type_hints["scale_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if placement is not None:
            self._values["placement"] = placement
        if placement_var is not None:
            self._values["placement_var"] = placement_var
        if scale is not None:
            self._values["scale"] = scale
        if scale_dimension is not None:
            self._values["scale_dimension"] = scale_dimension
        if scale_dimension_var is not None:
            self._values["scale_dimension_var"] = scale_dimension_var
        if scale_var is not None:
            self._values["scale_var"] = scale_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualCompositeImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualCompositeImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        '''
        result = self._values.get("placement")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement_var(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        '''
        result = self._values.get("placement_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        '''
        result = self._values.get("scale_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        '''
        result = self._values.get("scale_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        '''
        result = self._values.get("scale_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualComposite(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualCompositeImage",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualCompositeImage:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualCompositeImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualCompositeImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualCompositeImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__94d92e97b693e46a0d18bff4c3104280f3ad2d9771bb166d8744b317a8cc27b3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualCompositeImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualCompositeImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__239eb977bc26d0bb13e0d9bf61ef56bdbfa1f97e54b2e5ac62c6488c52d7a53a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualCompositeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualCompositeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d465f3a648b3287fc09d5867b3942cbd2afcc502fe9a5802ee6792b16f391536)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualCompositeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__31975ec7e7af03efb1d870bf87d3b60936d80b3afbb01a4d9452989058cb35ce)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualCompositeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4e0d56e5bde4af3051a346ff9209fa701a8aaf2d9a1da552f8c343c560dcc3c0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b8a3a3b323844194ebd2fd95209324d3973ae8c7dc7d1b8858fee8f747e9e2f9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1b697d1b4be389caa0b7729c7c65a0b680fdb0db575cc17c470110dd55860bf5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualComposite]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualComposite]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__01cfcd4a55e2f265a266c8ac11bf89e3f68d5fcb2c33ae62f05e9f3efe7e20db)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualCompositeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualCompositeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9b34e52e56ca972270e0dcc5d2f2200c682ae0c4bff28604b10486d72625d46e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualCompositeImage()

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPlacement")
    def reset_placement(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacement", []))

    @jsii.member(jsii_name="resetPlacementVar")
    def reset_placement_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacementVar", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetScaleDimension")
    def reset_scale_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimension", []))

    @jsii.member(jsii_name="resetScaleDimensionVar")
    def reset_scale_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimensionVar", []))

    @jsii.member(jsii_name="resetScaleVar")
    def reset_scale_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualCompositeImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualCompositeImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualCompositeImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="placementInput")
    def placement_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementInput"))

    @builtins.property
    @jsii.member(jsii_name="placementVarInput")
    def placement_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionInput")
    def scale_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVarInput")
    def scale_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleVarInput")
    def scale_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__11860cc03b74923824d9bdf6dbbdb6b0b71740b8b9e609ea3fb0a15d7729bea4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6224c71b1c8484fca7710a633c12d262c25b515d2e004842b2a1d3653f94ea04)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="placement")
    def placement(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placement"))

    @placement.setter
    def placement(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__035faf3c91886ad1d2617bd16a3926c000fb9c7e12bc8afd28eb41c4fcd3a4d9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placement", value)

    @builtins.property
    @jsii.member(jsii_name="placementVar")
    def placement_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placementVar"))

    @placement_var.setter
    def placement_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6452597bbfa4a0f01108b73be5ac81d69b816c951957669c1f185b37dacd13dc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placementVar", value)

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scale"))

    @scale.setter
    def scale(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ae225ada48b2d4fe6a9402974c085ab11af186f4ea508ef91bebebbd2614077)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scale", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimension")
    def scale_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimension"))

    @scale_dimension.setter
    def scale_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cda4b8853d30cbe7a63dba6e6be913d0bcb6264d5daabc7d43610b08e286c716)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimension", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVar")
    def scale_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimensionVar"))

    @scale_dimension_var.setter
    def scale_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5a469244d1e0c34a749037f7a86d4e4e59dddd062e5ba89fc7a39e9080ad1fcc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="scaleVar")
    def scale_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleVar"))

    @scale_var.setter
    def scale_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__68f1970a39fd9032af0d80098d004aaefb9cb03c354cc26275af2f9cf193a997)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__52aee7ead20b0e6db0ae181a33d47f366704427b1471353f5c9a7ff7f90b2bac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cbd361e96e867336d70ef2899ad79b6c955ef3eb59510879d43104907ff41874)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__29cd613f5835f6d4c8a3affb8c25ea09c2e50658f2db9c195a4ac5062b52e5df)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__84517bd99f0078371a95f9bc928279eb2e17fd330780d85afe6c91ec2d42522b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualComposite]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualComposite]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualComposite]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a6f973f984811d4304f6bc1de4f7b3f977ea87c274b31434cf293c4bbd6bf4d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualCompound",
    jsii_struct_bases=[],
    name_mapping={"transformations": "transformations"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualCompound:
    def __init__(
        self,
        *,
        transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param transformations: transformations block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be22915b789c71bfc2b6d05559b255a03b0a313cf72509a1edd0c5dc5493c4f7)
            check_type(argname="argument transformations", value=transformations, expected_type=type_hints["transformations"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if transformations is not None:
            self._values["transformations"] = transformations

    @builtins.property
    def transformations(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualCompoundTransformations"]]]:
        '''transformations block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        result = self._values.get("transformations")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualCompoundTransformations"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualCompound(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualCompoundList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualCompoundList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__103f2774d0459fa5828747383eb0cba5a67ce358c7e9dde0a1340d7cb5fb8926)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualCompoundOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a7b9dd9334ea1a6d7fb2b7116f613ed09cea9eba525c0481269a427f683c3fbd)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualCompoundOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__23d0d0c0dc78a64d95d6e1580cb25648224b9a0f2378791757068d97c209dcbf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4f7c798ed05237c4f6bf2f49bd80f210698bbec7d0857525a8dcd47698665d53)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8b599d016bb1fe65993fcf8fbc0a84a4fb85d38c8d010febcc6a2c0cc0a0f1c6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualCompound]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualCompound]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6476503c84eca655f280051497e6a087afba951294a214d6a54580531576f3e5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualCompoundOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualCompoundOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7fce88821c0ea2af045181fff1570a2aac6b8f2f402582aa1069073a46244436)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformations")
    def put_transformations(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d346b4ead3e1c68965d84d93856a5a63e14b3806c4cae028144dd10c3646e9d8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTransformations", [value]))

    @jsii.member(jsii_name="resetTransformations")
    def reset_transformations(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformations", []))

    @builtins.property
    @jsii.member(jsii_name="transformations")
    def transformations(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualCompoundTransformationsList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualCompoundTransformationsList", jsii.get(self, "transformations"))

    @builtins.property
    @jsii.member(jsii_name="transformationsInput")
    def transformations_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualCompoundTransformations"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualCompoundTransformations"]]], jsii.get(self, "transformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualCompound]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualCompound]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualCompound]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4c2e9ed16ab820c89f92c84e4f97c1eb93a99f636b2c9c0b7f8bbfc50b00efa9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualCompoundTransformations",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualCompoundTransformations:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualCompoundTransformations(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualCompoundTransformationsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualCompoundTransformationsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af3f9c6625b13991ea25f2a06f8212552ada93ec85ce5f5e90e86916c0a34d77)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualCompoundTransformationsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7c60357c4c625493868f95462ef837b093032e7c257deed8295c3cd58c835e4c)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualCompoundTransformationsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__65aaa7a49974cab1619ec73c6c2d16ffc9492e366f58fe4bcb97229d11c3c039)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__79c42efa13dc769906bb03158ac01c861e7c8a17062dce01d13a0fb493002fdd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3efc5956f33f4034bfa8c6a185df4c0e7d67457b88c23aaca0b6f002b97c0a66)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualCompoundTransformations]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualCompoundTransformations]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualCompoundTransformations]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__782ec86055f1e3c35d5049ba871c2742208d4a2eb5321a5509a02c185db5c628)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualCompoundTransformationsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualCompoundTransformationsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__daeb445bceba8aedc1c1cfe5420e50011fc744f0161cd5bb8b7746dd3961653c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualCompoundTransformations]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualCompoundTransformations]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualCompoundTransformations]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dd3ddad3d77843c111e17338f0a781c738e55ce24f25ff75e41f146456db2d01)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualContrast",
    jsii_struct_bases=[],
    name_mapping={
        "brightness": "brightness",
        "brightness_var": "brightnessVar",
        "contrast": "contrast",
        "contrast_var": "contrastVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualContrast:
    def __init__(
        self,
        *,
        brightness: typing.Optional[builtins.str] = None,
        brightness_var: typing.Optional[builtins.str] = None,
        contrast: typing.Optional[builtins.str] = None,
        contrast_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param brightness: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        :param brightness_var: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        :param contrast: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param contrast_var: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9aa7b73535844aca1b07aa69f17f61237fe065241876e5f1bc0aa121a9efa538)
            check_type(argname="argument brightness", value=brightness, expected_type=type_hints["brightness"])
            check_type(argname="argument brightness_var", value=brightness_var, expected_type=type_hints["brightness_var"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument contrast_var", value=contrast_var, expected_type=type_hints["contrast_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if brightness is not None:
            self._values["brightness"] = brightness
        if brightness_var is not None:
            self._values["brightness_var"] = brightness_var
        if contrast is not None:
            self._values["contrast"] = contrast
        if contrast_var is not None:
            self._values["contrast_var"] = contrast_var

    @builtins.property
    def brightness(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        '''
        result = self._values.get("brightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def brightness_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        '''
        result = self._values.get("brightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        result = self._values.get("contrast_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualContrast(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualContrastList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualContrastList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__291fa519f1770a374b32ebd7a354974ac15e238ee8ad598982437d7d98621d25)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualContrastOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__381244d4197c1e7f84355d8dc9845d7512886df43dbdade16aeae478c639aabd)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualContrastOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4e3a4e2636bbdfde99b9b648b64b09f368f947dde388e6c0ecaf6e42d0c30837)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e2a1832b9215910703222d449958d061d6e0bb91e14a73a95818d261eff918aa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1aba479dce6cfd3ef4421e8f81d9aebedbfbdd32d30ae6dd07a49a125f7b842c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualContrast]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualContrast]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__adccd0cc4ffa67007429a8cca4f6b793ff4c9400ec4e62c280544420fef179fa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualContrastOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualContrastOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dc59a7b0be83fb01f617d799332b7a8203795984b5664f7ce8672a97b92b6a9b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetBrightness")
    def reset_brightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightness", []))

    @jsii.member(jsii_name="resetBrightnessVar")
    def reset_brightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightnessVar", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetContrastVar")
    def reset_contrast_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrastVar", []))

    @builtins.property
    @jsii.member(jsii_name="brightnessInput")
    def brightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="brightnessVarInput")
    def brightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastVarInput")
    def contrast_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="brightness")
    def brightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightness"))

    @brightness.setter
    def brightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__181314c97de1b15d64a7150482e4c658479b707cf06d4479ae4b4bf1c334b16b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightness", value)

    @builtins.property
    @jsii.member(jsii_name="brightnessVar")
    def brightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightnessVar"))

    @brightness_var.setter
    def brightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__95d0605f0665a46d9fd0626304b169adae4ff888d0cc4e60d7d9f782d2780fc6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrast"))

    @contrast.setter
    def contrast(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b86c15d79f74ad3f0afeb4f52dbc925e19ac2eafa81ebb8fa6d777118cce0a81)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrast", value)

    @builtins.property
    @jsii.member(jsii_name="contrastVar")
    def contrast_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrastVar"))

    @contrast_var.setter
    def contrast_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__96f778519fde9b668224b663f15aa570974e1dc396a057cd336e99a8c507b426)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrastVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualContrast]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualContrast]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualContrast]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__99df597fefeb5a04d4e59a7a7ff1ed13a1e8f736eb2c3f5b202ca9f361bc5896)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualGoop",
    jsii_struct_bases=[],
    name_mapping={
        "chaos": "chaos",
        "chaos_var": "chaosVar",
        "density": "density",
        "density_var": "densityVar",
        "power": "power",
        "power_var": "powerVar",
        "seed": "seed",
        "seed_var": "seedVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualGoop:
    def __init__(
        self,
        *,
        chaos: typing.Optional[builtins.str] = None,
        chaos_var: typing.Optional[builtins.str] = None,
        density: typing.Optional[builtins.str] = None,
        density_var: typing.Optional[builtins.str] = None,
        power: typing.Optional[builtins.str] = None,
        power_var: typing.Optional[builtins.str] = None,
        seed: typing.Optional[builtins.str] = None,
        seed_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param chaos: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        :param chaos_var: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        :param density: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        :param density_var: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        :param power: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        :param power_var: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        :param seed: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        :param seed_var: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd1eac37260eec4d78ec8973b3c9aa66b757d1c9f78557f25fd48993888ddc12)
            check_type(argname="argument chaos", value=chaos, expected_type=type_hints["chaos"])
            check_type(argname="argument chaos_var", value=chaos_var, expected_type=type_hints["chaos_var"])
            check_type(argname="argument density", value=density, expected_type=type_hints["density"])
            check_type(argname="argument density_var", value=density_var, expected_type=type_hints["density_var"])
            check_type(argname="argument power", value=power, expected_type=type_hints["power"])
            check_type(argname="argument power_var", value=power_var, expected_type=type_hints["power_var"])
            check_type(argname="argument seed", value=seed, expected_type=type_hints["seed"])
            check_type(argname="argument seed_var", value=seed_var, expected_type=type_hints["seed_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if chaos is not None:
            self._values["chaos"] = chaos
        if chaos_var is not None:
            self._values["chaos_var"] = chaos_var
        if density is not None:
            self._values["density"] = density
        if density_var is not None:
            self._values["density_var"] = density_var
        if power is not None:
            self._values["power"] = power
        if power_var is not None:
            self._values["power_var"] = power_var
        if seed is not None:
            self._values["seed"] = seed
        if seed_var is not None:
            self._values["seed_var"] = seed_var

    @builtins.property
    def chaos(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        '''
        result = self._values.get("chaos")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def chaos_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        '''
        result = self._values.get("chaos_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        '''
        result = self._values.get("density")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density_var(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        '''
        result = self._values.get("density_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        '''
        result = self._values.get("power")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power_var(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        '''
        result = self._values.get("power_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        '''
        result = self._values.get("seed")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed_var(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        result = self._values.get("seed_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualGoop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualGoopList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualGoopList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5bf08a1d505b5d2314ccef724988a6016c994e74ab0d3f04425eaa54080d4826)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualGoopOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__216e9be505af1820bb4c7986a3de14a915a8a74496f92307266c5c76c5d6838c)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualGoopOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df5113ec6c76f1b46d7c67fd5aea109b51d4ae7ac2fe4219f2bc2def5167a42a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6aebf9842753f7be5c36617ae71ec1354b2d328ae2568fef3d466eff7dd31532)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0b375aab7dd0befba34b8b2123129425451130f6e92284037eb6873260ac8a7b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualGoop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualGoop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d07ded153aeffc6126d766fb21f441873742ff83a08629d6281b83f851f0eb28)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualGoopOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualGoopOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2fd5deed8cde82f273e058a454853de89703a941d1e141eefccbae11343cb815)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetChaos")
    def reset_chaos(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaos", []))

    @jsii.member(jsii_name="resetChaosVar")
    def reset_chaos_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaosVar", []))

    @jsii.member(jsii_name="resetDensity")
    def reset_density(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensity", []))

    @jsii.member(jsii_name="resetDensityVar")
    def reset_density_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensityVar", []))

    @jsii.member(jsii_name="resetPower")
    def reset_power(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPower", []))

    @jsii.member(jsii_name="resetPowerVar")
    def reset_power_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPowerVar", []))

    @jsii.member(jsii_name="resetSeed")
    def reset_seed(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeed", []))

    @jsii.member(jsii_name="resetSeedVar")
    def reset_seed_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeedVar", []))

    @builtins.property
    @jsii.member(jsii_name="chaosInput")
    def chaos_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosInput"))

    @builtins.property
    @jsii.member(jsii_name="chaosVarInput")
    def chaos_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosVarInput"))

    @builtins.property
    @jsii.member(jsii_name="densityInput")
    def density_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityInput"))

    @builtins.property
    @jsii.member(jsii_name="densityVarInput")
    def density_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="powerInput")
    def power_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerInput"))

    @builtins.property
    @jsii.member(jsii_name="powerVarInput")
    def power_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerVarInput"))

    @builtins.property
    @jsii.member(jsii_name="seedInput")
    def seed_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedInput"))

    @builtins.property
    @jsii.member(jsii_name="seedVarInput")
    def seed_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedVarInput"))

    @builtins.property
    @jsii.member(jsii_name="chaos")
    def chaos(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaos"))

    @chaos.setter
    def chaos(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cae6b2a1d0d448d67515ae5e531ead9b71f62bca0f9ee24f57fdd2a51689fbf6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaos", value)

    @builtins.property
    @jsii.member(jsii_name="chaosVar")
    def chaos_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaosVar"))

    @chaos_var.setter
    def chaos_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f4dce19edea78e7944b0932e8b6d1c98b346f180cf1b4b3fdd9a52d2ce3a759a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaosVar", value)

    @builtins.property
    @jsii.member(jsii_name="density")
    def density(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "density"))

    @density.setter
    def density(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__642422318c74915af2b5acf732fd299eb5e734b78555827f0bebc5118514419b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "density", value)

    @builtins.property
    @jsii.member(jsii_name="densityVar")
    def density_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "densityVar"))

    @density_var.setter
    def density_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__37b63a7168ce44e917ead07d01be3245428ea42752ee37956d52cdd2ec0e886a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "densityVar", value)

    @builtins.property
    @jsii.member(jsii_name="power")
    def power(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "power"))

    @power.setter
    def power(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__841e0e80e18e1ff1dcc10293bfd0f822646655ac78c4eb99881870db8097ce9c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "power", value)

    @builtins.property
    @jsii.member(jsii_name="powerVar")
    def power_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "powerVar"))

    @power_var.setter
    def power_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aafa200413bf3b604855fff1b4c746bc12455445f0202a133a769a941d53b02d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "powerVar", value)

    @builtins.property
    @jsii.member(jsii_name="seed")
    def seed(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seed"))

    @seed.setter
    def seed(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__836afdc70d955c7f05b1bca90a1d8ca4b52e80208ea1fe55029c119279a5ee16)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seed", value)

    @builtins.property
    @jsii.member(jsii_name="seedVar")
    def seed_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seedVar"))

    @seed_var.setter
    def seed_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c8d057171738285a1bfe71700ab143ffcc9043ab7e0dd05662790856fe0e444a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seedVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualGoop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualGoop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualGoop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5a028f4136b406cf2ed6a8639af42a8cd21d3d4b3c227178ae9171a455f4ca9f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualGrayscale",
    jsii_struct_bases=[],
    name_mapping={"type": "type", "type_var": "typeVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualGrayscale:
    def __init__(
        self,
        *,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param type: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__768bb36849c37f0a7abf76f3253c44e0529fff0c4684adc90b49829477e69a7e)
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualGrayscale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualGrayscaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualGrayscaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0b0be8943257d75a5b0d4819959dcb26ff6e5716ca17ea0f29debde981748ab5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualGrayscaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d6b9abcd438b479b9c68c870d6953c51b5a22f8c3d6df3c75c8fc00b830df1f4)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualGrayscaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b14eeef94716df03c4895b32c786256e77ab256ac9354ac10f21d46f00612969)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0afed56edfe79055ed1672e567a6c7d3bac1d814432afae48d4aab734fca852f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f20e31572ce9be6bb4734e4c4fe22f8342533995dd6f6d094723e2110bfc7776)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualGrayscale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualGrayscale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fc5cc84256d36c39f697ffe0580e92f8c244a9c7d38b081192214c59a4bb3d42)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualGrayscaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualGrayscaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__573eaa1a9990d0d35f0babecce709552db76ca78af3f1cb0c4992d4bfddec81f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__72f656d588695dfb9f925860050a40f419ce85befafedeed060e0f4267a6f566)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a5e9cea434e68fcee42b01fe9c49b2ae7363345696f2c033e1709a444f8e8a5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualGrayscale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualGrayscale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualGrayscale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0d3413a288e4ae7f404fa64468bf7f0cb6713b411d59f3c3dab09684806a3d08)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualHsl",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "lightness": "lightness",
        "lightness_var": "lightnessVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualHsl:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness: typing.Optional[builtins.str] = None,
        lightness_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        :param lightness_var: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__77be28c69c937ce70ac165c61e4e9caef0079384e9243fa6d1310fb1968d962d)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness", value=lightness, expected_type=type_hints["lightness"])
            check_type(argname="argument lightness_var", value=lightness_var, expected_type=type_hints["lightness_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness is not None:
            self._values["lightness"] = lightness
        if lightness_var is not None:
            self._values["lightness_var"] = lightness_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        '''
        result = self._values.get("lightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        '''
        result = self._values.get("lightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualHsl(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualHslList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualHslList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b817a6f7ce9300667f4eb2f35aabc2917e7cff993329c0b3a8aed1979eaf5c1c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualHslOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d0e54e8dc921523bd54627f8ee4879184ffc44afce30f579e5bcfebe9d9efe34)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualHslOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bbeab4d9039e71129e188a7a525095f4fc1d71da8ea6a4d37fec49a2fb66dae0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a69108b2acf4b41b16755eee61469a37e85fe2dfef2207874434958fcd8bf998)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__15fcad66abebaa5d015599d7ad585c82313e7c2c36b78ab7ee3faacd9b13b4d1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualHsl]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualHsl]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9be803193129d0515f2c9d4d0c14da3568edef0b14d07e74da7a62bb7638e560)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualHslOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualHslOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c57db13c6477b21d17e1affb503845231e57586e864b807ffd7d78b43aae2957)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightness")
    def reset_lightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightness", []))

    @jsii.member(jsii_name="resetLightnessVar")
    def reset_lightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessInput")
    def lightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessVarInput")
    def lightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__837e56bd647cdd3d6df53c9430121a46e85292c828070e60536d08a9757ee0e2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e7055196b684331fc1b166ef8207533394bc7096c220cf680902eacd10f79c5c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightness")
    def lightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightness"))

    @lightness.setter
    def lightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__92b0e7fde68dbc7ae58dc9f23a62816c88b6bb9e2e22606b53bec028190c2195)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightness", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessVar")
    def lightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessVar"))

    @lightness_var.setter
    def lightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a642bffed09f6aee8b97817f9545e43cbec8d082336332fe7eee36f7b3ed0a93)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d7940ed52a8286ef5753f979399f08f63b29403860268c940c9fb744751eb64)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eb0260b95dac1111fdc51853d93f731383f7090279f35871666da6ea18a91f56)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualHsl]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualHsl]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualHsl]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__696fcb0cea0ebaa6abfe61954d44fc67e1444381a01659de87408ac4265705b7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualHsv",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualHsv:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        :param value: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2c6a2d02aa0df46194e1be3a928b53f95fde29ceb8610e73f0e975e15a613eb0)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualHsv(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualHsvList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualHsvList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2c6895c852f359124744749680ff8172a9aadb5e88c25b832c3929d84ce0768a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualHsvOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2e0cbe23b1030fafabbaca0dbf0d5aff9ee3e9446989294ced12f217849be4bd)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualHsvOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7e4a22ed462e51657c70b976529eb2e6615bf8cb26d370cc9ad1e8eb96bdba0b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9300df89127768058e2ba2fcbf472c763c88c65dc0e6de3b208a0e777ead56db)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__85a9c9393e8c55495bd2183067625273b506b81f7d9e63fa34a634ac05c554fd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualHsv]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualHsv]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa380b656ff32c653fe05112592201d22ab6a5ca3679c2e872863fad95730fd5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualHsvOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualHsvOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e54d615c8190627633c290f7ebbfa886fb8be41fb48078330114b01df96d4f43)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dfc165291734a8360f3aac235b1b50b191f7f6a79697af316413f208b241e008)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__59da591af9bf1f77bf3b4c10dfd831a3523381efbe35e78ca81880a557f53e0a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4253d176f8a0aa0e6bfe9afb6e1211dcea590baa7710d7f246b57363a0edb809)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e04301a64a1cd327e288deafd6509319ee2993f734f9a77c237046da599bd0da)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__22b4e126e1e7910e5aa74941eb809b70c40ee87e631b3f0dd2a1fa4d663f7b08)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__70c3c8e08cddcb8632072b956306892e714a244fac128177326edccb0241403b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualHsv]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualHsv]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualHsv]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__36f556536d42b6480a3f3ccde2ddcf0620e6b34cd2cde094645a529a5a488be8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfDimension",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "dimension": "dimension",
        "dimension_var": "dimensionVar",
        "equal": "equal",
        "greater_than": "greaterThan",
        "less_than": "lessThan",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfDimension:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        dimension: typing.Optional[builtins.str] = None,
        dimension_var: typing.Optional[builtins.str] = None,
        equal: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionEqual", typing.Dict[builtins.str, typing.Any]]] = None,
        greater_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionGreaterThan", typing.Dict[builtins.str, typing.Any]]] = None,
        less_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionLessThan", typing.Dict[builtins.str, typing.Any]]] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param dimension: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        :param dimension_var: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        :param equal: equal block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        :param greater_than: greater_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        :param less_than: less_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        :param value: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionDefault(**default)
        if isinstance(equal, dict):
            equal = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionEqual(**equal)
        if isinstance(greater_than, dict):
            greater_than = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionGreaterThan(**greater_than)
        if isinstance(less_than, dict):
            less_than = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionLessThan(**less_than)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f5ff147915175975a146528304a1a0edf2e5de367dbc2cb4b1db3d28403f687c)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument dimension", value=dimension, expected_type=type_hints["dimension"])
            check_type(argname="argument dimension_var", value=dimension_var, expected_type=type_hints["dimension_var"])
            check_type(argname="argument equal", value=equal, expected_type=type_hints["equal"])
            check_type(argname="argument greater_than", value=greater_than, expected_type=type_hints["greater_than"])
            check_type(argname="argument less_than", value=less_than, expected_type=type_hints["less_than"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if dimension is not None:
            self._values["dimension"] = dimension
        if dimension_var is not None:
            self._values["dimension_var"] = dimension_var
        if equal is not None:
            self._values["equal"] = equal
        if greater_than is not None:
            self._values["greater_than"] = greater_than
        if less_than is not None:
            self._values["less_than"] = less_than
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionDefault"], result)

    @builtins.property
    def dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        '''
        result = self._values.get("dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        '''
        result = self._values.get("dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def equal(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionEqual"]:
        '''equal block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        '''
        result = self._values.get("equal")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionEqual"], result)

    @builtins.property
    def greater_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionGreaterThan"]:
        '''greater_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        '''
        result = self._values.get("greater_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionGreaterThan"], result)

    @builtins.property
    def less_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionLessThan"]:
        '''less_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        '''
        result = self._values.get("less_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionLessThan"], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfDimension(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6c7508779c7266c691ccdbb7cdff779f38fbb235ea8e86cec3853df59a939b2d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8616b4e2be2021dbe000a44b29c5686731e039d433d8df583b261280e713dec2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionEqual",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionEqual:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionEqual(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionEqualOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionEqualOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a21f1ba3e63091b3c8c22eb68583749b59bdafa6c32c54c9f31029bff3d7129b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionEqual], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionEqual],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bce5337b44868db80db7e7d09dbeeb5883f55dc6a207917a55f759cea2e83080)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionGreaterThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionGreaterThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionGreaterThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionGreaterThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionGreaterThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa46cca0229881191b32e7a3388a08cf12d10f7a8d5b3e8fad247455fb85a6c7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionGreaterThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionGreaterThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8be6645cf801328244c0ee842ee66bd394b97d4a0732d01914e0052a6cf46197)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionLessThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionLessThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionLessThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionLessThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionLessThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__156c9b73b1a85bad9adc79ae2868ecdf2f5bc900e6a0b57e5f3d0f981c23b0f2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionLessThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionLessThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a740e9a7fc53c358ce9ba8cf441f5f6b696c96b19ca5fe4bb00015f78190a364)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a46fa37af3ed2ee02eef999d6f05d4aff5a147ffcddb884b48c41dedb190eacf)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1c104075c5417cec21dfab2cd59116eb71eaddb3aef5ed1dbaa548d6e463b188)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__191f2c0e547f72f3db857be732a4719c4a2c9297811b62d8fd81d687470c46d2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3f6d8f5384ef621c7b8ebb4af90719e43cfe4ad96c36f78e808c3d2af89b701c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__08ae310a4ea60e242caddcba17e77062ea6b353e6b5ca88c0e6b190cf3740854)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfDimension]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfDimension]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aeb9ff97937dc83d1f1d14f2740fc650259e12b7990e6c46fe8531b48ac8b124)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__77df8f3f6351aafc883beeff07926ec295f816a397ae7b64bae43be6a6391a85)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putEqual")
    def put_equal(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionEqual()

        return typing.cast(None, jsii.invoke(self, "putEqual", [value]))

    @jsii.member(jsii_name="putGreaterThan")
    def put_greater_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionGreaterThan()

        return typing.cast(None, jsii.invoke(self, "putGreaterThan", [value]))

    @jsii.member(jsii_name="putLessThan")
    def put_less_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionLessThan()

        return typing.cast(None, jsii.invoke(self, "putLessThan", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetDimension")
    def reset_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimension", []))

    @jsii.member(jsii_name="resetDimensionVar")
    def reset_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimensionVar", []))

    @jsii.member(jsii_name="resetEqual")
    def reset_equal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEqual", []))

    @jsii.member(jsii_name="resetGreaterThan")
    def reset_greater_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGreaterThan", []))

    @jsii.member(jsii_name="resetLessThan")
    def reset_less_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLessThan", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="equal")
    def equal(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionEqualOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionEqualOutputReference, jsii.get(self, "equal"))

    @builtins.property
    @jsii.member(jsii_name="greaterThan")
    def greater_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionGreaterThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionGreaterThanOutputReference, jsii.get(self, "greaterThan"))

    @builtins.property
    @jsii.member(jsii_name="lessThan")
    def less_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionLessThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionLessThanOutputReference, jsii.get(self, "lessThan"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionInput")
    def dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionVarInput")
    def dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="equalInput")
    def equal_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionEqual], jsii.get(self, "equalInput"))

    @builtins.property
    @jsii.member(jsii_name="greaterThanInput")
    def greater_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionGreaterThan], jsii.get(self, "greaterThanInput"))

    @builtins.property
    @jsii.member(jsii_name="lessThanInput")
    def less_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionLessThan], jsii.get(self, "lessThanInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="dimension")
    def dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimension"))

    @dimension.setter
    def dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a93bab11396627286ce10104d26084d4f52fecbe0f195918b5b1c932d80127e6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimension", value)

    @builtins.property
    @jsii.member(jsii_name="dimensionVar")
    def dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimensionVar"))

    @dimension_var.setter
    def dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e3a4773ccc20ea17b90f5ce4abf7d36bcbae0cd4dc545b91d5b766ccad909a36)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fd6326377fa554e98ab348d7117f29899adccf0a3b0464ca3b91eeb17fcf136d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__30044ff7fd0ee0456016581967bf6c14f0f296f7d4c55c3d8580a724ddabe69e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfDimension]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfDimension]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfDimension]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2681d09a497679a06706f877fba15fce0d601185f2496ba98cb486e361c801f6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientation",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "landscape": "landscape",
        "portrait": "portrait",
        "square": "square",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientation:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        landscape: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationLandscape", typing.Dict[builtins.str, typing.Any]]] = None,
        portrait: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationPortrait", typing.Dict[builtins.str, typing.Any]]] = None,
        square: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationSquare", typing.Dict[builtins.str, typing.Any]]] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param landscape: landscape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        :param portrait: portrait block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        :param square: square block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationDefault(**default)
        if isinstance(landscape, dict):
            landscape = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationLandscape(**landscape)
        if isinstance(portrait, dict):
            portrait = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationPortrait(**portrait)
        if isinstance(square, dict):
            square = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationSquare(**square)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a47b4a1a3a4f88a76c5bc113f46bc2872613df6828fd41a6e44ab586bf93bc37)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument landscape", value=landscape, expected_type=type_hints["landscape"])
            check_type(argname="argument portrait", value=portrait, expected_type=type_hints["portrait"])
            check_type(argname="argument square", value=square, expected_type=type_hints["square"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if landscape is not None:
            self._values["landscape"] = landscape
        if portrait is not None:
            self._values["portrait"] = portrait
        if square is not None:
            self._values["square"] = square

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationDefault"], result)

    @builtins.property
    def landscape(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationLandscape"]:
        '''landscape block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        '''
        result = self._values.get("landscape")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationLandscape"], result)

    @builtins.property
    def portrait(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationPortrait"]:
        '''portrait block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        '''
        result = self._values.get("portrait")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationPortrait"], result)

    @builtins.property
    def square(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationSquare"]:
        '''square block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        result = self._values.get("square")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationSquare"], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab843a3740c084cc316ba1bdf11accc3208f4b1e81dca244ceb7e609f7b5b0af)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ea29c79bb0fae685ff3e8297c41c5368b6ef778a877ac73472333dd8204f6e3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationLandscape",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationLandscape:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationLandscape(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationLandscapeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationLandscapeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb68409f92d51259859ddb53ec1d7ff9156be2dc89bf66508530cb9ba2f8c31a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationLandscape], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationLandscape],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9e74284f96bf08926223f4e94064cbe5074ab1d431eaef6e5262d8ebd91b89e8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__579df7f84b50a3781bb2c2c708e68b72d688b83bfc501b7294902d4883a76d45)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fc43aaebe3fda95bfd7460f20c220644da810b1b8314444c534b3f534ed76086)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cf82d046ca4b1a41b382a49315bc47a23030b46bdb550362d544ab76f4e3077f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1c25ed2ee6f63ac30a2845b10cf91a64c52a8a9b2159f8ea730b4c73ba857b13)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__33faa2c9e386ec79cb3a4919053787d0b54ee73aa4b550b88dbef9ef748a9283)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientation]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientation]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__55f316f1d505a9884b395ae2ce70c0a72d5cc0b1e804cc97aa0e5550daa89f23)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f86fed22c36accbaa9034f9bc7537c21f9f8356d5da5b545e4f0436b2713a8d3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putLandscape")
    def put_landscape(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationLandscape()

        return typing.cast(None, jsii.invoke(self, "putLandscape", [value]))

    @jsii.member(jsii_name="putPortrait")
    def put_portrait(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationPortrait()

        return typing.cast(None, jsii.invoke(self, "putPortrait", [value]))

    @jsii.member(jsii_name="putSquare")
    def put_square(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationSquare()

        return typing.cast(None, jsii.invoke(self, "putSquare", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetLandscape")
    def reset_landscape(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLandscape", []))

    @jsii.member(jsii_name="resetPortrait")
    def reset_portrait(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPortrait", []))

    @jsii.member(jsii_name="resetSquare")
    def reset_square(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSquare", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="landscape")
    def landscape(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationLandscapeOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationLandscapeOutputReference, jsii.get(self, "landscape"))

    @builtins.property
    @jsii.member(jsii_name="portrait")
    def portrait(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationPortraitOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationPortraitOutputReference", jsii.get(self, "portrait"))

    @builtins.property
    @jsii.member(jsii_name="square")
    def square(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationSquareOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationSquareOutputReference", jsii.get(self, "square"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="landscapeInput")
    def landscape_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationLandscape], jsii.get(self, "landscapeInput"))

    @builtins.property
    @jsii.member(jsii_name="portraitInput")
    def portrait_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationPortrait"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationPortrait"], jsii.get(self, "portraitInput"))

    @builtins.property
    @jsii.member(jsii_name="squareInput")
    def square_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationSquare"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationSquare"], jsii.get(self, "squareInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientation]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientation]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientation]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3235874d18390ca89a92c218a8c57126ab08370948d90fce194c284cd93d5813)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationPortrait",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationPortrait:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationPortrait(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationPortraitOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationPortraitOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ca10fac9905b2e7671d86ac908846d1ab5ebb614aeb98e38e0cae523c1bb937f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationPortrait]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationPortrait], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationPortrait],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fbeef3cfc2c3b1b67dcb0ee1d62b56406f5a3dc93a062169605e4ec9e20e50d3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationSquare",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationSquare:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationSquare(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationSquareOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationSquareOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f3a60da5169db281ac70d6450a9f87c526800ba357cae55134bb2272efef29b6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationSquare]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationSquare], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationSquare],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d8164e1e52a57b28bf2c0aad24cd7116572e31270688190085821c6c042d150)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualMaxColors",
    jsii_struct_bases=[],
    name_mapping={"colors": "colors", "colors_var": "colorsVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualMaxColors:
    def __init__(
        self,
        *,
        colors: typing.Optional[builtins.str] = None,
        colors_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param colors: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        :param colors_var: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0a5cbdc2fdbe7a23a062ebb4bf639b5343ad51833f53e7a410b210d763d88f0e)
            check_type(argname="argument colors", value=colors, expected_type=type_hints["colors"])
            check_type(argname="argument colors_var", value=colors_var, expected_type=type_hints["colors_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if colors is not None:
            self._values["colors"] = colors
        if colors_var is not None:
            self._values["colors_var"] = colors_var

    @builtins.property
    def colors(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        '''
        result = self._values.get("colors")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def colors_var(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        result = self._values.get("colors_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualMaxColors(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualMaxColorsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualMaxColorsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8b7aba05df2af8fea72ddbe181f256ac98a81685d3071f495fb729b71e3cd9ea)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualMaxColorsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__535fef9c9a1f203623ae2cab972b66195a36f48c4cc1c457574a49d024a4e099)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualMaxColorsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e29d5792e5fc3ef6323634c956dfdccc97ba18773c67d8366d9296ba1643274d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a9689a1374539ee2cc1512460b2bd67b3bb61437060a6f7174d9f15a9ca7ea7d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f02985c56f4b82b63394366d581865a687691cdb1d1d19a686209655cd5179d0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualMaxColors]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualMaxColors]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5d556c065dbe7fd54380e89e89ac604f0a2dff683ba6019788d5c1eecb75d903)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualMaxColorsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualMaxColorsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8f065e8a2c0ae39b6c9794ec777a7fa60e9b5cb4fe85869897087c813cb74493)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColors")
    def reset_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColors", []))

    @jsii.member(jsii_name="resetColorsVar")
    def reset_colors_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorsVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorsInput")
    def colors_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsInput"))

    @builtins.property
    @jsii.member(jsii_name="colorsVarInput")
    def colors_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsVarInput"))

    @builtins.property
    @jsii.member(jsii_name="colors")
    def colors(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colors"))

    @colors.setter
    def colors(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6c5d2c4ccc444e093fa40bd0b77fee8e2b251245bccedc41ffe50bfae81edbb9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colors", value)

    @builtins.property
    @jsii.member(jsii_name="colorsVar")
    def colors_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorsVar"))

    @colors_var.setter
    def colors_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0417daf90634fa93254edb24a78cc0027eba15b417e74ef39f02ecbbef08d84d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorsVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualMaxColors]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualMaxColors]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualMaxColors]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__51e145c0e1c6b1dfab8023a6d34efaa010c5e480a4c92bdad97fadc7623428f5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualMirror",
    jsii_struct_bases=[],
    name_mapping={
        "horizontal": "horizontal",
        "horizontal_var": "horizontalVar",
        "vertical": "vertical",
        "vertical_var": "verticalVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualMirror:
    def __init__(
        self,
        *,
        horizontal: typing.Optional[builtins.str] = None,
        horizontal_var: typing.Optional[builtins.str] = None,
        vertical: typing.Optional[builtins.str] = None,
        vertical_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param horizontal: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        :param horizontal_var: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        :param vertical: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        :param vertical_var: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5456822da24015faa8c5ce2c9aeda55a8d18d40049d9f85fc78647b15d86e0f2)
            check_type(argname="argument horizontal", value=horizontal, expected_type=type_hints["horizontal"])
            check_type(argname="argument horizontal_var", value=horizontal_var, expected_type=type_hints["horizontal_var"])
            check_type(argname="argument vertical", value=vertical, expected_type=type_hints["vertical"])
            check_type(argname="argument vertical_var", value=vertical_var, expected_type=type_hints["vertical_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if horizontal is not None:
            self._values["horizontal"] = horizontal
        if horizontal_var is not None:
            self._values["horizontal_var"] = horizontal_var
        if vertical is not None:
            self._values["vertical"] = vertical
        if vertical_var is not None:
            self._values["vertical_var"] = vertical_var

    @builtins.property
    def horizontal(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        '''
        result = self._values.get("horizontal")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def horizontal_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        '''
        result = self._values.get("horizontal_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        '''
        result = self._values.get("vertical")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        result = self._values.get("vertical_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualMirror(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualMirrorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualMirrorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__709b95d810a6d251a1409923f521c9c2c093371e9ff3c4cf1ba989fb577fab9c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualMirrorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__690929b6013512ded80bfe825656adf8223f6bed3345ecf1a23ca3786d0d7401)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualMirrorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__29bcc6de7d47daf23156ecbff3b1eb257978159dc9066f82637007c80c17813d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__964eae34aec31bff508a5dc4ff9e26c6019b32c0ca2017fab7a2c8a790b2e4dd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__179cf5e3ec74a6463cc82d5487a7b7f6975a4647c0e799bcba83c38bafda0b86)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualMirror]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualMirror]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c3b854bfc62e3ed9586bb6cfee09b56fa5290af7d0d3d2304acbf84affa30ca1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualMirrorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualMirrorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e415ab055b62e33628808c4ed46725f17cc8721ed8d79268cba90ee796c9693e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHorizontal")
    def reset_horizontal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontal", []))

    @jsii.member(jsii_name="resetHorizontalVar")
    def reset_horizontal_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontalVar", []))

    @jsii.member(jsii_name="resetVertical")
    def reset_vertical(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVertical", []))

    @jsii.member(jsii_name="resetVerticalVar")
    def reset_vertical_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVerticalVar", []))

    @builtins.property
    @jsii.member(jsii_name="horizontalInput")
    def horizontal_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontalVarInput")
    def horizontal_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalInput")
    def vertical_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalVarInput")
    def vertical_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontal")
    def horizontal(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontal"))

    @horizontal.setter
    def horizontal(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7cd1aba49eba80206582a5b8578b3e6e3b3793cc1726a204bea9d082574e57c1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontal", value)

    @builtins.property
    @jsii.member(jsii_name="horizontalVar")
    def horizontal_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontalVar"))

    @horizontal_var.setter
    def horizontal_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9bec1e56d29465e3a59838a1cb56994481e919969952d4291e8a7f90b1b4c5a9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontalVar", value)

    @builtins.property
    @jsii.member(jsii_name="vertical")
    def vertical(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "vertical"))

    @vertical.setter
    def vertical(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cb1e4cd2c7207f40107e8ea92a3af72717d1a2993687ce7729392ac7cb842efd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "vertical", value)

    @builtins.property
    @jsii.member(jsii_name="verticalVar")
    def vertical_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "verticalVar"))

    @vertical_var.setter
    def vertical_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6c4d65ca30724fe034d98632b399f1aae83b281e38c3c67e8f32a284757c3203)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "verticalVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualMirror]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualMirror]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualMirror]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fcdf515336d313fcffbecd4cbe74c98ec75e9b21d3b7cb2413ac4b56b4c2366e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualMonoHue",
    jsii_struct_bases=[],
    name_mapping={"hue": "hue", "hue_var": "hueVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualMonoHue:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5cd901db8080a1355c4b9611ea79a5d0e225f8d69155e1110629e9b6942d4c45)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualMonoHue(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualMonoHueList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualMonoHueList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5fd8210e7fa5e4d6f492ac316a396ac486c32f46a172e16666c458a646d7c6c7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualMonoHueOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b9568ba625865858b4c137a6d1e177d3c3ab05ea5416622647de62c5bf778033)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualMonoHueOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b305dd7c749a9b4bc91de95e8d599b5b4a9f903a6ffa2724b807ed4e8c9f944b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6cb603c2d7c874471e6992d9c2a4adb9fa037dc1467e680c922007d252917837)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ae24ac170da33fb78b51bc8bf056de18b6430c3f280982f3f37d7f6fbfc1a4af)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualMonoHue]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualMonoHue]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__340f7c3dcbb6df28d38f86e502561989509113d1864cf4571aec594037f246a0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualMonoHueOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualMonoHueOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9bc023db7084528af83e35660bc5483e23f375802ff0bc532307ccf04307c994)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__824951026a553f91cbb0d5f6991bfe18774131c3043bf73b2c27cbbd6151f313)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aa238b6d8a61012a878f025386d95f0ccdfe61babfb400ecb63217d49b5f8d6b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualMonoHue]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualMonoHue]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualMonoHue]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__63c65f3f296a3221fe3f20855960b19a65a9e19beb86917b53009260e534cca6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualOpacity",
    jsii_struct_bases=[],
    name_mapping={"opacity": "opacity", "opacity_var": "opacityVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualOpacity:
    def __init__(
        self,
        *,
        opacity: typing.Optional[builtins.str] = None,
        opacity_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param opacity: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param opacity_var: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a31a010741c31403eeb62a76d0bf212447e238b2f3605aaf56d0896927c0b28c)
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument opacity_var", value=opacity_var, expected_type=type_hints["opacity_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if opacity is not None:
            self._values["opacity"] = opacity
        if opacity_var is not None:
            self._values["opacity_var"] = opacity_var

    @builtins.property
    def opacity(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def opacity_var(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        result = self._values.get("opacity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualOpacity(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualOpacityList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualOpacityList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dc4217d9f1a717e542c13f20225ccc2143a3bca6f4aade65e4451c8f147e6a40)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualOpacityOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0d62dde397a49a98b6124c5c2f7591f423fbcb6db93aa44ea0a8225f8e980f5c)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualOpacityOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ad6d4d12970f5f1eb744ba51f00f508aebe8649365f9028c520c67050ffa0c04)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0196779e5187ad0763aabd1863f3e6d5a76e8cd0e1d0f9fc0ea6147625bed8be)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8d6a9b67bc2925b74073a55640d42ef4773fe87377613991b5811c7e24fc6723)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualOpacity]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualOpacity]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b010ef38c8d5fae383e2676c9f61c222905cf73a7d9586028d25e6be99a9a17c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualOpacityOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualOpacityOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__332804e7f05abf92f74336e0d7f353b8efa447cc590474d1d9a9e724dcf8d381)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetOpacityVar")
    def reset_opacity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacityVar", []))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityVarInput")
    def opacity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacity"))

    @opacity.setter
    def opacity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b0e9290c82f0b4f45508aba719b4d30bfb2ee9ece5aec7f780564d4de626428f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacity", value)

    @builtins.property
    @jsii.member(jsii_name="opacityVar")
    def opacity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacityVar"))

    @opacity_var.setter
    def opacity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__58fff9612e396cd5fb4b84b287a8be123eb5113e3b12aed75ac2c1d4b39c58c7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacityVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualOpacity]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualOpacity]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualOpacity]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7698f21421327331e982403f933a07b54277118c64e913ff86961c2accebb363)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__532ed1c4bb9caf9c6591436cac672a1152508b12f065513af00e5a6c37acd3b7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putBackgroundColor")
    def put_background_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b9714811fec077982196ab3673abafedec974e687dd7c8cee08f6b5daaa5d328)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBackgroundColor", [value]))

    @jsii.member(jsii_name="putBlur")
    def put_blur(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualBlur, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2f474cfaac7bc2d9048006da6f22faf40673a5f294d448276f467305156d06a5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBlur", [value]))

    @jsii.member(jsii_name="putChromaKey")
    def put_chroma_key(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualChromaKey, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__19b59ccdf880decefb877e81778f48495c8d32ee82cd61f0ee9f9f0e53580401)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putChromaKey", [value]))

    @jsii.member(jsii_name="putComposite")
    def put_composite(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualComposite, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ad0b97beedf3c4683925033f51f2f235afb2adece4a7fb73a7db612146c61c5c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putComposite", [value]))

    @jsii.member(jsii_name="putCompound")
    def put_compound(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualCompound, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5dc82610548cae67fd66fbb5d55349386e65272c9be811d806b3c2da719f7e2c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCompound", [value]))

    @jsii.member(jsii_name="putContrast")
    def put_contrast(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualContrast, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__88e5f57d2ed52b2f8df210799465db3fed571934f9274d4e68504bc6bb0cb9f1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putContrast", [value]))

    @jsii.member(jsii_name="putGoop")
    def put_goop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualGoop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__352429794d8159813b35f4ef8fb6ebca34f5997bd27b352d29970a03c8528dbe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGoop", [value]))

    @jsii.member(jsii_name="putGrayscale")
    def put_grayscale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualGrayscale, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b7d62548d6f5bc7cceabb1982a8e421107ac632ce8fe92326976f9659f0142cd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGrayscale", [value]))

    @jsii.member(jsii_name="putHsl")
    def put_hsl(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualHsl, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e7e4f8c181cfee63c5a1bef359657e706d97ca981ef0bf219fb05c3e13de70bd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsl", [value]))

    @jsii.member(jsii_name="putHsv")
    def put_hsv(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualHsv, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9057ce1beedb088e8fc751dde4692a9a765dfe4ec76459b430aecd981c810b4c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsv", [value]))

    @jsii.member(jsii_name="putIfDimension")
    def put_if_dimension(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfDimension, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__718c4fbe1482994314feccc353417bdff1aecbc079b3b67e8dbffbf2547a1aa0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfDimension", [value]))

    @jsii.member(jsii_name="putIfOrientation")
    def put_if_orientation(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__725938c829b40dea3e29828e57449a06bfc5840cedd77b88c0aeaa1f5fbf421e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfOrientation", [value]))

    @jsii.member(jsii_name="putMaxColors")
    def put_max_colors(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualMaxColors, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7b1e10b2507aa0cbbf8a53c083607ab8b31070a1d44e6df7336c74e1967ab3a8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMaxColors", [value]))

    @jsii.member(jsii_name="putMirror")
    def put_mirror(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualMirror, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5677a3ed66c43a84625a970c061d2417984c0b8c0e245f217e8c5c39c2d8c2e6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMirror", [value]))

    @jsii.member(jsii_name="putMonoHue")
    def put_mono_hue(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualMonoHue, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ce4f25795f9a9fdccc7e930b5b7b80365e1b2e74d5b32dc1271a3eae16cfd80)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMonoHue", [value]))

    @jsii.member(jsii_name="putOpacity")
    def put_opacity(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualOpacity, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6731f3f52e29f653d72c708ef5586a8e094be4015cc8e1ca58c7a6caea39e1b8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putOpacity", [value]))

    @jsii.member(jsii_name="putRemoveColor")
    def put_remove_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualRemoveColor", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__54f8c116f414153495551faafb28f5e91f2437ced167fc423ab0ef38466655a8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRemoveColor", [value]))

    @jsii.member(jsii_name="putUnsharpMask")
    def put_unsharp_mask(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualUnsharpMask", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__622874884b868de60520c16bfc4603918abe3eaf0e9cf15a862f6d5f1aad2afa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putUnsharpMask", [value]))

    @jsii.member(jsii_name="resetBackgroundColor")
    def reset_background_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBackgroundColor", []))

    @jsii.member(jsii_name="resetBlur")
    def reset_blur(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBlur", []))

    @jsii.member(jsii_name="resetChromaKey")
    def reset_chroma_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChromaKey", []))

    @jsii.member(jsii_name="resetComposite")
    def reset_composite(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetComposite", []))

    @jsii.member(jsii_name="resetCompound")
    def reset_compound(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCompound", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetGoop")
    def reset_goop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGoop", []))

    @jsii.member(jsii_name="resetGrayscale")
    def reset_grayscale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGrayscale", []))

    @jsii.member(jsii_name="resetHsl")
    def reset_hsl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsl", []))

    @jsii.member(jsii_name="resetHsv")
    def reset_hsv(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsv", []))

    @jsii.member(jsii_name="resetIfDimension")
    def reset_if_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfDimension", []))

    @jsii.member(jsii_name="resetIfOrientation")
    def reset_if_orientation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfOrientation", []))

    @jsii.member(jsii_name="resetMaxColors")
    def reset_max_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxColors", []))

    @jsii.member(jsii_name="resetMirror")
    def reset_mirror(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMirror", []))

    @jsii.member(jsii_name="resetMonoHue")
    def reset_mono_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonoHue", []))

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetRemoveColor")
    def reset_remove_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRemoveColor", []))

    @jsii.member(jsii_name="resetUnsharpMask")
    def reset_unsharp_mask(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUnsharpMask", []))

    @builtins.property
    @jsii.member(jsii_name="backgroundColor")
    def background_color(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualBackgroundColorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualBackgroundColorList, jsii.get(self, "backgroundColor"))

    @builtins.property
    @jsii.member(jsii_name="blur")
    def blur(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualBlurList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualBlurList, jsii.get(self, "blur"))

    @builtins.property
    @jsii.member(jsii_name="chromaKey")
    def chroma_key(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualChromaKeyList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualChromaKeyList, jsii.get(self, "chromaKey"))

    @builtins.property
    @jsii.member(jsii_name="composite")
    def composite(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualCompositeList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualCompositeList, jsii.get(self, "composite"))

    @builtins.property
    @jsii.member(jsii_name="compound")
    def compound(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualCompoundList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualCompoundList, jsii.get(self, "compound"))

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualContrastList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualContrastList, jsii.get(self, "contrast"))

    @builtins.property
    @jsii.member(jsii_name="goop")
    def goop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualGoopList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualGoopList, jsii.get(self, "goop"))

    @builtins.property
    @jsii.member(jsii_name="grayscale")
    def grayscale(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualGrayscaleList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualGrayscaleList, jsii.get(self, "grayscale"))

    @builtins.property
    @jsii.member(jsii_name="hsl")
    def hsl(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualHslList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualHslList, jsii.get(self, "hsl"))

    @builtins.property
    @jsii.member(jsii_name="hsv")
    def hsv(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualHsvList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualHsvList, jsii.get(self, "hsv"))

    @builtins.property
    @jsii.member(jsii_name="ifDimension")
    def if_dimension(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionList, jsii.get(self, "ifDimension"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientation")
    def if_orientation(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationList, jsii.get(self, "ifOrientation"))

    @builtins.property
    @jsii.member(jsii_name="maxColors")
    def max_colors(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualMaxColorsList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualMaxColorsList, jsii.get(self, "maxColors"))

    @builtins.property
    @jsii.member(jsii_name="mirror")
    def mirror(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualMirrorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualMirrorList, jsii.get(self, "mirror"))

    @builtins.property
    @jsii.member(jsii_name="monoHue")
    def mono_hue(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualMonoHueList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualMonoHueList, jsii.get(self, "monoHue"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualOpacityList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualOpacityList, jsii.get(self, "opacity"))

    @builtins.property
    @jsii.member(jsii_name="removeColor")
    def remove_color(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualRemoveColorList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualRemoveColorList", jsii.get(self, "removeColor"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMask")
    def unsharp_mask(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualUnsharpMaskList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualUnsharpMaskList", jsii.get(self, "unsharpMask"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColorInput")
    def background_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualBackgroundColor]]], jsii.get(self, "backgroundColorInput"))

    @builtins.property
    @jsii.member(jsii_name="blurInput")
    def blur_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualBlur]]], jsii.get(self, "blurInput"))

    @builtins.property
    @jsii.member(jsii_name="chromaKeyInput")
    def chroma_key_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualChromaKey]]], jsii.get(self, "chromaKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="compositeInput")
    def composite_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualComposite]]], jsii.get(self, "compositeInput"))

    @builtins.property
    @jsii.member(jsii_name="compoundInput")
    def compound_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualCompound]]], jsii.get(self, "compoundInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualContrast]]], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="goopInput")
    def goop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualGoop]]], jsii.get(self, "goopInput"))

    @builtins.property
    @jsii.member(jsii_name="grayscaleInput")
    def grayscale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualGrayscale]]], jsii.get(self, "grayscaleInput"))

    @builtins.property
    @jsii.member(jsii_name="hslInput")
    def hsl_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualHsl]]], jsii.get(self, "hslInput"))

    @builtins.property
    @jsii.member(jsii_name="hsvInput")
    def hsv_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualHsv]]], jsii.get(self, "hsvInput"))

    @builtins.property
    @jsii.member(jsii_name="ifDimensionInput")
    def if_dimension_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfDimension]]], jsii.get(self, "ifDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientationInput")
    def if_orientation_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientation]]], jsii.get(self, "ifOrientationInput"))

    @builtins.property
    @jsii.member(jsii_name="maxColorsInput")
    def max_colors_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualMaxColors]]], jsii.get(self, "maxColorsInput"))

    @builtins.property
    @jsii.member(jsii_name="mirrorInput")
    def mirror_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualMirror]]], jsii.get(self, "mirrorInput"))

    @builtins.property
    @jsii.member(jsii_name="monoHueInput")
    def mono_hue_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualMonoHue]]], jsii.get(self, "monoHueInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualOpacity]]], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="removeColorInput")
    def remove_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualRemoveColor"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualRemoveColor"]]], jsii.get(self, "removeColorInput"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMaskInput")
    def unsharp_mask_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualUnsharpMask"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualUnsharpMask"]]], jsii.get(self, "unsharpMaskInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqual], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqual],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc7bd7331038bf2c667a0f899f242c232c20f2fa6610a6fbca3e912fa1ec6efa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualRemoveColor",
    jsii_struct_bases=[],
    name_mapping={
        "color": "color",
        "color_var": "colorVar",
        "feather": "feather",
        "feather_var": "featherVar",
        "tolerance": "tolerance",
        "tolerance_var": "toleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualRemoveColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
        feather: typing.Optional[builtins.str] = None,
        feather_var: typing.Optional[builtins.str] = None,
        tolerance: typing.Optional[builtins.str] = None,
        tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        :param feather: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        :param feather_var: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        :param tolerance: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        :param tolerance_var: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__71985494962067235a2c3280fe217d470aa9ddbcff17f0781d0a15841a41af02)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
            check_type(argname="argument feather", value=feather, expected_type=type_hints["feather"])
            check_type(argname="argument feather_var", value=feather_var, expected_type=type_hints["feather_var"])
            check_type(argname="argument tolerance", value=tolerance, expected_type=type_hints["tolerance"])
            check_type(argname="argument tolerance_var", value=tolerance_var, expected_type=type_hints["tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var
        if feather is not None:
            self._values["feather"] = feather
        if feather_var is not None:
            self._values["feather_var"] = feather_var
        if tolerance is not None:
            self._values["tolerance"] = tolerance
        if tolerance_var is not None:
            self._values["tolerance_var"] = tolerance_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        '''
        result = self._values.get("feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather_var(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        '''
        result = self._values.get("feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        '''
        result = self._values.get("tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance_var(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        result = self._values.get("tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualRemoveColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualRemoveColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualRemoveColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d4815d9c6f9e959969668eeebf8ede82ed4bc0614b399c8da09d437ab9e3434)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualRemoveColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1465586b77273621727feba9b7109e56c87533406dc7c56a43e8a04a69f3ceb7)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualRemoveColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bef28f24e16bc8104bd47f08da0bfea7f07fad58fa0ca90504dcfbc3c8b2d970)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ab2a79980de677e19f896348317d49f6080f11554ee3df9fc17955e04c47a58)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__171ee99cd6849daa972f91238874d9d9f7b99f556d6d6182a5b5e71f65572df0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualRemoveColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualRemoveColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualRemoveColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__743057f79fe138ddfef44738eb741c565ea1536d9dc4528890676ba301111b64)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualRemoveColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualRemoveColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c3a959225e8e3382965e71ba08dddf4c5822f8808d2bfcbe5f6a8a8f17f7f699)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @jsii.member(jsii_name="resetFeather")
    def reset_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeather", []))

    @jsii.member(jsii_name="resetFeatherVar")
    def reset_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatherVar", []))

    @jsii.member(jsii_name="resetTolerance")
    def reset_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTolerance", []))

    @jsii.member(jsii_name="resetToleranceVar")
    def reset_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featherInput")
    def feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherInput"))

    @builtins.property
    @jsii.member(jsii_name="featherVarInput")
    def feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceInput")
    def tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceVarInput")
    def tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7c36daeff45c64d6871b6c846288184081c90b21acf768e5c575245939b9b30f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__07e2abd680e076abf29277d455e6ba95511c4cfafb07ecc159cd093e4b75a829)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="feather")
    def feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "feather"))

    @feather.setter
    def feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__045df1a1a0e99279dd81ee21b900f055a11e4f075ae3edbb4840477a0846ddcc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "feather", value)

    @builtins.property
    @jsii.member(jsii_name="featherVar")
    def feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featherVar"))

    @feather_var.setter
    def feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__73e30c99284c1a1eb533b4f44a346a688f2a1ac2f4849edbc060688dbe4ba71a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featherVar", value)

    @builtins.property
    @jsii.member(jsii_name="tolerance")
    def tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tolerance"))

    @tolerance.setter
    def tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__00d2f0e32f00048455ac6325046e33f2b283fdab176f37209248a008365b4ac8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tolerance", value)

    @builtins.property
    @jsii.member(jsii_name="toleranceVar")
    def tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "toleranceVar"))

    @tolerance_var.setter
    def tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5bd1e2100456eb654d187ba2d11b51612042b89ea364e8f71f6bd22101ad8e09)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "toleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualRemoveColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualRemoveColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualRemoveColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__51b77d2413cf5588e7c17305675026faa30c0e566add76a76d05fefb35dcdbe1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualUnsharpMask",
    jsii_struct_bases=[],
    name_mapping={
        "gain": "gain",
        "gain_var": "gainVar",
        "sigma": "sigma",
        "sigma_var": "sigmaVar",
        "threshold": "threshold",
        "threshold_var": "thresholdVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualUnsharpMask:
    def __init__(
        self,
        *,
        gain: typing.Optional[builtins.str] = None,
        gain_var: typing.Optional[builtins.str] = None,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
        threshold: typing.Optional[builtins.str] = None,
        threshold_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param gain: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        :param gain_var: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        :param sigma: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        :param threshold: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        :param threshold_var: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0d8791f0cc3e50f7eb0902e460d4b00e9d4a11099f0162b206e4b8e7b845841b)
            check_type(argname="argument gain", value=gain, expected_type=type_hints["gain"])
            check_type(argname="argument gain_var", value=gain_var, expected_type=type_hints["gain_var"])
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
            check_type(argname="argument threshold", value=threshold, expected_type=type_hints["threshold"])
            check_type(argname="argument threshold_var", value=threshold_var, expected_type=type_hints["threshold_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if gain is not None:
            self._values["gain"] = gain
        if gain_var is not None:
            self._values["gain_var"] = gain_var
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var
        if threshold is not None:
            self._values["threshold"] = threshold
        if threshold_var is not None:
            self._values["threshold_var"] = threshold_var

    @builtins.property
    def gain(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        '''
        result = self._values.get("gain")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gain_var(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        '''
        result = self._values.get("gain_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        '''
        result = self._values.get("threshold")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold_var(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        result = self._values.get("threshold_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualUnsharpMask(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualUnsharpMaskList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualUnsharpMaskList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__54ca4c3919fd14c3f49d009db95956b780f762f70bb695af20f5a3c6830c4de1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualUnsharpMaskOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ac3fda06b118cbe01c034cd5029d89994721a2c2b2c706494083087c1439372)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualUnsharpMaskOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__37e1526c8c3d7ff239c4320362c21f863cff7497fc99670391794693433ff24b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__72286111ca537f01a0db23c8e09bf4644761a19f693e27ed8af2569029701c81)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__723fce3fd2361223132d6f360f0ba40a8e7ae41d5ac7695954f92b7078e54973)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualUnsharpMask]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualUnsharpMask]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualUnsharpMask]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__276740e26ddbbfc0fa7d385ac38069c9cc20f60e5080a3a0d5ac8ccbb421aca6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualUnsharpMaskOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualUnsharpMaskOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f0390579e3e5725a939299e83241aa7a984ef05046ccb34347c024dab41c49ee)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetGain")
    def reset_gain(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGain", []))

    @jsii.member(jsii_name="resetGainVar")
    def reset_gain_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGainVar", []))

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @jsii.member(jsii_name="resetThreshold")
    def reset_threshold(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThreshold", []))

    @jsii.member(jsii_name="resetThresholdVar")
    def reset_threshold_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThresholdVar", []))

    @builtins.property
    @jsii.member(jsii_name="gainInput")
    def gain_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainInput"))

    @builtins.property
    @jsii.member(jsii_name="gainVarInput")
    def gain_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdInput")
    def threshold_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdVarInput")
    def threshold_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gain")
    def gain(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gain"))

    @gain.setter
    def gain(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1417520805af2cad5c2b5e0bfd0ac8381f1f9db2ea8ea6df9cf61c2227b2ffbc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gain", value)

    @builtins.property
    @jsii.member(jsii_name="gainVar")
    def gain_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gainVar"))

    @gain_var.setter
    def gain_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eef953665f67badaf1f891173fb1250b76a7bee2656b5d0549e1a17e789d0690)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gainVar", value)

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd35428ff331d33fc375c92caabc783798f7f520e5175112c6d12ba214d07250)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__65a96f7b71cc1854765fa532259659f6a528ad464b3cf4710eb563762befd946)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="threshold")
    def threshold(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "threshold"))

    @threshold.setter
    def threshold(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3051fc00e5cd7e3a517228c20d28b13fcea69a98b9fa7c31e26a9d34a17beced)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "threshold", value)

    @builtins.property
    @jsii.member(jsii_name="thresholdVar")
    def threshold_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "thresholdVar"))

    @threshold_var.setter
    def threshold_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1c3a7c8b86aadcd47f9a84383c609e640214d5a9dbbd9b9474ac737f737c6b5d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "thresholdVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualUnsharpMask]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualUnsharpMask]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualUnsharpMask]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3fb98fb40760713fbaac2d5c0023b89bdfcb7328d4f827ced06bdb597ae33025)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThan",
    jsii_struct_bases=[],
    name_mapping={
        "background_color": "backgroundColor",
        "blur": "blur",
        "chroma_key": "chromaKey",
        "composite": "composite",
        "compound": "compound",
        "contrast": "contrast",
        "goop": "goop",
        "grayscale": "grayscale",
        "hsl": "hsl",
        "hsv": "hsv",
        "if_dimension": "ifDimension",
        "if_orientation": "ifOrientation",
        "max_colors": "maxColors",
        "mirror": "mirror",
        "mono_hue": "monoHue",
        "opacity": "opacity",
        "remove_color": "removeColor",
        "unsharp_mask": "unsharpMask",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThan:
    def __init__(
        self,
        *,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanBackgroundColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanBlur", typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanChromaKey", typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanComposite", typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompound", typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanContrast", typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanGoop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanGrayscale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanHsl", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanHsv", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimension", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientation", typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanMaxColors", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanMirror", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanMonoHue", typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanOpacity", typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanRemoveColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanUnsharpMask", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b4227d89ebc7005d6e232a71363e85d6a0aa7158b489a037ef3af5b12938a9f3)
            check_type(argname="argument background_color", value=background_color, expected_type=type_hints["background_color"])
            check_type(argname="argument blur", value=blur, expected_type=type_hints["blur"])
            check_type(argname="argument chroma_key", value=chroma_key, expected_type=type_hints["chroma_key"])
            check_type(argname="argument composite", value=composite, expected_type=type_hints["composite"])
            check_type(argname="argument compound", value=compound, expected_type=type_hints["compound"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument goop", value=goop, expected_type=type_hints["goop"])
            check_type(argname="argument grayscale", value=grayscale, expected_type=type_hints["grayscale"])
            check_type(argname="argument hsl", value=hsl, expected_type=type_hints["hsl"])
            check_type(argname="argument hsv", value=hsv, expected_type=type_hints["hsv"])
            check_type(argname="argument if_dimension", value=if_dimension, expected_type=type_hints["if_dimension"])
            check_type(argname="argument if_orientation", value=if_orientation, expected_type=type_hints["if_orientation"])
            check_type(argname="argument max_colors", value=max_colors, expected_type=type_hints["max_colors"])
            check_type(argname="argument mirror", value=mirror, expected_type=type_hints["mirror"])
            check_type(argname="argument mono_hue", value=mono_hue, expected_type=type_hints["mono_hue"])
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument remove_color", value=remove_color, expected_type=type_hints["remove_color"])
            check_type(argname="argument unsharp_mask", value=unsharp_mask, expected_type=type_hints["unsharp_mask"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if background_color is not None:
            self._values["background_color"] = background_color
        if blur is not None:
            self._values["blur"] = blur
        if chroma_key is not None:
            self._values["chroma_key"] = chroma_key
        if composite is not None:
            self._values["composite"] = composite
        if compound is not None:
            self._values["compound"] = compound
        if contrast is not None:
            self._values["contrast"] = contrast
        if goop is not None:
            self._values["goop"] = goop
        if grayscale is not None:
            self._values["grayscale"] = grayscale
        if hsl is not None:
            self._values["hsl"] = hsl
        if hsv is not None:
            self._values["hsv"] = hsv
        if if_dimension is not None:
            self._values["if_dimension"] = if_dimension
        if if_orientation is not None:
            self._values["if_orientation"] = if_orientation
        if max_colors is not None:
            self._values["max_colors"] = max_colors
        if mirror is not None:
            self._values["mirror"] = mirror
        if mono_hue is not None:
            self._values["mono_hue"] = mono_hue
        if opacity is not None:
            self._values["opacity"] = opacity
        if remove_color is not None:
            self._values["remove_color"] = remove_color
        if unsharp_mask is not None:
            self._values["unsharp_mask"] = unsharp_mask

    @builtins.property
    def background_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanBackgroundColor"]]]:
        '''background_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        '''
        result = self._values.get("background_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanBackgroundColor"]]], result)

    @builtins.property
    def blur(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanBlur"]]]:
        '''blur block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        '''
        result = self._values.get("blur")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanBlur"]]], result)

    @builtins.property
    def chroma_key(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanChromaKey"]]]:
        '''chroma_key block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        '''
        result = self._values.get("chroma_key")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanChromaKey"]]], result)

    @builtins.property
    def composite(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanComposite"]]]:
        '''composite block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        '''
        result = self._values.get("composite")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanComposite"]]], result)

    @builtins.property
    def compound(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompound"]]]:
        '''compound block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        '''
        result = self._values.get("compound")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompound"]]], result)

    @builtins.property
    def contrast(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanContrast"]]]:
        '''contrast block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanContrast"]]], result)

    @builtins.property
    def goop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanGoop"]]]:
        '''goop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        '''
        result = self._values.get("goop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanGoop"]]], result)

    @builtins.property
    def grayscale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanGrayscale"]]]:
        '''grayscale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        '''
        result = self._values.get("grayscale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanGrayscale"]]], result)

    @builtins.property
    def hsl(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanHsl"]]]:
        '''hsl block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        '''
        result = self._values.get("hsl")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanHsl"]]], result)

    @builtins.property
    def hsv(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanHsv"]]]:
        '''hsv block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        '''
        result = self._values.get("hsv")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanHsv"]]], result)

    @builtins.property
    def if_dimension(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimension"]]]:
        '''if_dimension block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        '''
        result = self._values.get("if_dimension")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimension"]]], result)

    @builtins.property
    def if_orientation(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientation"]]]:
        '''if_orientation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        '''
        result = self._values.get("if_orientation")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientation"]]], result)

    @builtins.property
    def max_colors(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanMaxColors"]]]:
        '''max_colors block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        '''
        result = self._values.get("max_colors")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanMaxColors"]]], result)

    @builtins.property
    def mirror(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanMirror"]]]:
        '''mirror block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        '''
        result = self._values.get("mirror")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanMirror"]]], result)

    @builtins.property
    def mono_hue(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanMonoHue"]]]:
        '''mono_hue block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        '''
        result = self._values.get("mono_hue")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanMonoHue"]]], result)

    @builtins.property
    def opacity(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanOpacity"]]]:
        '''opacity block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanOpacity"]]], result)

    @builtins.property
    def remove_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanRemoveColor"]]]:
        '''remove_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        '''
        result = self._values.get("remove_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanRemoveColor"]]], result)

    @builtins.property
    def unsharp_mask(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanUnsharpMask"]]]:
        '''unsharp_mask block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        result = self._values.get("unsharp_mask")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanUnsharpMask"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanBackgroundColor",
    jsii_struct_bases=[],
    name_mapping={"color": "color", "color_var": "colorVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanBackgroundColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__839c7fb0fcef0ba37ae7166001cb9591e6fa18e0d73a9ca831b997bbb6b247ba)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanBackgroundColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanBackgroundColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanBackgroundColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5e222592f4da633d7051c47aff6e5e01ccedd48939d04fc5a19c8744c63ab6cd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanBackgroundColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f1b7b20f096d725a6b83324760c80c743431558fd58bd8eac25706b98c8d601b)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanBackgroundColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f7e70c30474a460fee63d90ee12dfeb5087ecaefd884926e6753efd7f5715d08)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7b6766398634d2d5450a85df2ea660f10d6e83707cdc306d626e98e24e8dfd04)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a0867f2dbf42973bef6dd2759034b907cd29c1e79734fd4e9b3ad2a4da941d18)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanBackgroundColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanBackgroundColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ebda05ecb71cef1cc4c2a971cdb2472ec077fef5228dc01dfbf1b38d89109474)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanBackgroundColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanBackgroundColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__21e2ad684046d73af255e8de8031e4cd2d6f17ea132d149d3b7e39be502fedbf)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__16cec6d12ddd165815b9bf7e2f7dd452159b1e57f6cbaa11080a4e699b54bd5e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dd3a697feaba07e64a3ef0a5678f751a252366fc48be55600ac4fb5d240c8b57)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanBackgroundColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanBackgroundColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanBackgroundColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__250a99e67792de8b6eb225649fffe920afaf94a2915c158ffc812aab9d45c6bc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanBlur",
    jsii_struct_bases=[],
    name_mapping={"sigma": "sigma", "sigma_var": "sigmaVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanBlur:
    def __init__(
        self,
        *,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param sigma: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bdc3a1b72a3644fb94ba38439dbab47d72e0a47239879c738ca20e54faa1359e)
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanBlur(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanBlurList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanBlurList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__65b9c400d2bb78c8f7b6926dbcba41c0ead51cff802b903efac6f5ad4296df60)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanBlurOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b20dc3b0a6ab83df3c3d6ace848957f0adf61f7371ed6844c90be3f7201adcd3)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanBlurOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ed0075c582d494d1e055d3c9884280f72301a56f0db575036c5996f69207fa50)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3e505a7b231f64e987efd939f4036b835716181522d96f824d55d689300c1077)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b9d5a22d0be0f7691cd942036edb6c700720c76734b433e839d11128f83cd082)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanBlur]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanBlur]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__71b2cf0a727f6f9b6a3780e86f7247e3b54662c92d61bd14c0ea61ad207a1e8d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanBlurOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanBlurOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__21984b299205438d9a7529c5f44f08e42987e5f0a0b74ec6ec77f3fafc6ea2e7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__29fcc7d5b9d196a5474d55cec60eaf7da3e4edbe4e22e2c6dbb84075d1f2a478)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b4e3d0122f6dc3a78b1d5a9c45799ad5e26e4b52637bc958d5059ebe27f7fbb3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanBlur]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanBlur]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanBlur]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d3808fd9a439cc28e06931a1e5eb8ff5ad603f3d207148e5d72aeb5aaa03041f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanChromaKey",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_feather": "hueFeather",
        "hue_feather_var": "hueFeatherVar",
        "hue_tolerance": "hueTolerance",
        "hue_tolerance_var": "hueToleranceVar",
        "hue_var": "hueVar",
        "lightness_feather": "lightnessFeather",
        "lightness_feather_var": "lightnessFeatherVar",
        "lightness_tolerance": "lightnessTolerance",
        "lightness_tolerance_var": "lightnessToleranceVar",
        "saturation_feather": "saturationFeather",
        "saturation_feather_var": "saturationFeatherVar",
        "saturation_tolerance": "saturationTolerance",
        "saturation_tolerance_var": "saturationToleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanChromaKey:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_feather: typing.Optional[builtins.str] = None,
        hue_feather_var: typing.Optional[builtins.str] = None,
        hue_tolerance: typing.Optional[builtins.str] = None,
        hue_tolerance_var: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness_feather: typing.Optional[builtins.str] = None,
        lightness_feather_var: typing.Optional[builtins.str] = None,
        lightness_tolerance: typing.Optional[builtins.str] = None,
        lightness_tolerance_var: typing.Optional[builtins.str] = None,
        saturation_feather: typing.Optional[builtins.str] = None,
        saturation_feather_var: typing.Optional[builtins.str] = None,
        saturation_tolerance: typing.Optional[builtins.str] = None,
        saturation_tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_feather: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        :param hue_feather_var: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        :param hue_tolerance: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        :param hue_tolerance_var: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        :param hue_var: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness_feather: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        :param lightness_feather_var: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        :param lightness_tolerance: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        :param lightness_tolerance_var: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        :param saturation_feather: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        :param saturation_feather_var: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        :param saturation_tolerance: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        :param saturation_tolerance_var: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ce1122842a62cff819ab28039008a3e8e1dc191befec46949a0c526833ae6d9)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_feather", value=hue_feather, expected_type=type_hints["hue_feather"])
            check_type(argname="argument hue_feather_var", value=hue_feather_var, expected_type=type_hints["hue_feather_var"])
            check_type(argname="argument hue_tolerance", value=hue_tolerance, expected_type=type_hints["hue_tolerance"])
            check_type(argname="argument hue_tolerance_var", value=hue_tolerance_var, expected_type=type_hints["hue_tolerance_var"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness_feather", value=lightness_feather, expected_type=type_hints["lightness_feather"])
            check_type(argname="argument lightness_feather_var", value=lightness_feather_var, expected_type=type_hints["lightness_feather_var"])
            check_type(argname="argument lightness_tolerance", value=lightness_tolerance, expected_type=type_hints["lightness_tolerance"])
            check_type(argname="argument lightness_tolerance_var", value=lightness_tolerance_var, expected_type=type_hints["lightness_tolerance_var"])
            check_type(argname="argument saturation_feather", value=saturation_feather, expected_type=type_hints["saturation_feather"])
            check_type(argname="argument saturation_feather_var", value=saturation_feather_var, expected_type=type_hints["saturation_feather_var"])
            check_type(argname="argument saturation_tolerance", value=saturation_tolerance, expected_type=type_hints["saturation_tolerance"])
            check_type(argname="argument saturation_tolerance_var", value=saturation_tolerance_var, expected_type=type_hints["saturation_tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_feather is not None:
            self._values["hue_feather"] = hue_feather
        if hue_feather_var is not None:
            self._values["hue_feather_var"] = hue_feather_var
        if hue_tolerance is not None:
            self._values["hue_tolerance"] = hue_tolerance
        if hue_tolerance_var is not None:
            self._values["hue_tolerance_var"] = hue_tolerance_var
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness_feather is not None:
            self._values["lightness_feather"] = lightness_feather
        if lightness_feather_var is not None:
            self._values["lightness_feather_var"] = lightness_feather_var
        if lightness_tolerance is not None:
            self._values["lightness_tolerance"] = lightness_tolerance
        if lightness_tolerance_var is not None:
            self._values["lightness_tolerance_var"] = lightness_tolerance_var
        if saturation_feather is not None:
            self._values["saturation_feather"] = saturation_feather
        if saturation_feather_var is not None:
            self._values["saturation_feather_var"] = saturation_feather_var
        if saturation_tolerance is not None:
            self._values["saturation_tolerance"] = saturation_tolerance
        if saturation_tolerance_var is not None:
            self._values["saturation_tolerance_var"] = saturation_tolerance_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        '''
        result = self._values.get("hue_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        '''
        result = self._values.get("hue_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        '''
        result = self._values.get("hue_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        '''
        result = self._values.get("hue_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        '''
        result = self._values.get("lightness_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        '''
        result = self._values.get("lightness_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        '''
        result = self._values.get("lightness_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        '''
        result = self._values.get("lightness_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        '''
        result = self._values.get("saturation_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        '''
        result = self._values.get("saturation_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        '''
        result = self._values.get("saturation_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        result = self._values.get("saturation_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanChromaKey(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanChromaKeyList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanChromaKeyList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__396f1733b73c5e9f98a4112095d6b23b632a6c728cb50a40cd297efa2379033c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanChromaKeyOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__09d4f4b94653f1f4b81efe71fec7f6e1bdb66643ee0c73e60283f9879ef7dc12)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanChromaKeyOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__61a3f10d141ef2e663445bb7a5e7b29a9d881335695d9be0041be4e21d2eb116)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ca17349b965e106b81d83cad2aae4318a48e388463f0538773ec71d45d54def)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ed424cff5fd67981524b9616e4176b8971ff802795127960dbfa1c4e0e42b4d0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanChromaKey]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanChromaKey]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__135bb5a149956fea15eddd435e287aa19ea5420c78e7b76623d5d7ac3a3f0ca1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanChromaKeyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanChromaKeyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__70d0566d4175adfe35385a48b3d051a7b1d44f5f67eff8738ebcdc9c1c23cf6f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueFeather")
    def reset_hue_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeather", []))

    @jsii.member(jsii_name="resetHueFeatherVar")
    def reset_hue_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeatherVar", []))

    @jsii.member(jsii_name="resetHueTolerance")
    def reset_hue_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueTolerance", []))

    @jsii.member(jsii_name="resetHueToleranceVar")
    def reset_hue_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueToleranceVar", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightnessFeather")
    def reset_lightness_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeather", []))

    @jsii.member(jsii_name="resetLightnessFeatherVar")
    def reset_lightness_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeatherVar", []))

    @jsii.member(jsii_name="resetLightnessTolerance")
    def reset_lightness_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessTolerance", []))

    @jsii.member(jsii_name="resetLightnessToleranceVar")
    def reset_lightness_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessToleranceVar", []))

    @jsii.member(jsii_name="resetSaturationFeather")
    def reset_saturation_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeather", []))

    @jsii.member(jsii_name="resetSaturationFeatherVar")
    def reset_saturation_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeatherVar", []))

    @jsii.member(jsii_name="resetSaturationTolerance")
    def reset_saturation_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationTolerance", []))

    @jsii.member(jsii_name="resetSaturationToleranceVar")
    def reset_saturation_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherInput")
    def hue_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVarInput")
    def hue_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceInput")
    def hue_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVarInput")
    def hue_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherInput")
    def lightness_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVarInput")
    def lightness_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceInput")
    def lightness_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVarInput")
    def lightness_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherInput")
    def saturation_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVarInput")
    def saturation_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceInput")
    def saturation_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVarInput")
    def saturation_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d4d303667d0b4c027a5bbb3204f545a4da180b189275ce43ffebafc14b756437)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeather")
    def hue_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeather"))

    @hue_feather.setter
    def hue_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4bc048e3025845017d5bc3a3cb6c711d4e1be0f9a2acde96139d48a0eec57ded)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeather", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVar")
    def hue_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeatherVar"))

    @hue_feather_var.setter
    def hue_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__171428bf58267c827fda6b24ec8f164bb23b9537f964a4759daf2cdaaec52bc0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueTolerance")
    def hue_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueTolerance"))

    @hue_tolerance.setter
    def hue_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f51cf26deca4c664bb41a93c7a9cd50d8d6a81af655b53730de77cc63f322af)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVar")
    def hue_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueToleranceVar"))

    @hue_tolerance_var.setter
    def hue_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__81798e8b12302295f3c640bf82ec2173448dfc0b657387e3ec9f6eb8f915d25e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8798e265c3a331ba77541a68761941fac40432c6314e1d1c5e1ddb686aca06eb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeather")
    def lightness_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeather"))

    @lightness_feather.setter
    def lightness_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__58f3ac80238fc82983a439895d589b2a52b0a012e3dde5b7288ab920b22ae744)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeather", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVar")
    def lightness_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeatherVar"))

    @lightness_feather_var.setter
    def lightness_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0fe6c89f2677fc482e2a4f3555dbe65b8c22d96f2a946150e877b2056a5cd8b2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessTolerance")
    def lightness_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessTolerance"))

    @lightness_tolerance.setter
    def lightness_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d38b382b2e9d699588326738971b2c5f6e0ab0bf370f1611481ecc335964c48)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVar")
    def lightness_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessToleranceVar"))

    @lightness_tolerance_var.setter
    def lightness_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7996d436961e7d0bda6bc069db286f1eb81fb7e64797e0aa5102c06d9715f6d5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeather")
    def saturation_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeather"))

    @saturation_feather.setter
    def saturation_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f6223120cce3707b899168bd73ab5f73aebdf4ca5b2fd159331e553b550422a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeather", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVar")
    def saturation_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeatherVar"))

    @saturation_feather_var.setter
    def saturation_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__929d58b3b6373049a4aa2912561ffbfc4f8a0ae7625b745cf86516040a5cb594)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationTolerance")
    def saturation_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationTolerance"))

    @saturation_tolerance.setter
    def saturation_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc4dcb1da34e4526ac62eed4682a6286b6426c0d369bfe0d69dd61699266d9f9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVar")
    def saturation_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationToleranceVar"))

    @saturation_tolerance_var.setter
    def saturation_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e1664ec272af27cf9bdfffdf92362c3da6e8f5c4af93e64b848e81e86629249e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanChromaKey]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanChromaKey]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanChromaKey]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__608f619dcad6b4cc56a9179b5f0de9104ba02621dd93325a9ab700fc916c180c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanComposite",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "placement": "placement",
        "placement_var": "placementVar",
        "scale": "scale",
        "scale_dimension": "scaleDimension",
        "scale_dimension_var": "scaleDimensionVar",
        "scale_var": "scaleVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanComposite:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompositeImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        placement: typing.Optional[builtins.str] = None,
        placement_var: typing.Optional[builtins.str] = None,
        scale: typing.Optional[builtins.str] = None,
        scale_dimension: typing.Optional[builtins.str] = None,
        scale_dimension_var: typing.Optional[builtins.str] = None,
        scale_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param placement: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        :param placement_var: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        :param scale: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param scale_dimension: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        :param scale_dimension_var: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        :param scale_var: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        :param x_position: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompositeImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__894feb7b1c5e823098e03a3812a49be59ec9cdb18fde47caf19e52d856f47f6a)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument placement", value=placement, expected_type=type_hints["placement"])
            check_type(argname="argument placement_var", value=placement_var, expected_type=type_hints["placement_var"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument scale_dimension", value=scale_dimension, expected_type=type_hints["scale_dimension"])
            check_type(argname="argument scale_dimension_var", value=scale_dimension_var, expected_type=type_hints["scale_dimension_var"])
            check_type(argname="argument scale_var", value=scale_var, expected_type=type_hints["scale_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if placement is not None:
            self._values["placement"] = placement
        if placement_var is not None:
            self._values["placement_var"] = placement_var
        if scale is not None:
            self._values["scale"] = scale
        if scale_dimension is not None:
            self._values["scale_dimension"] = scale_dimension
        if scale_dimension_var is not None:
            self._values["scale_dimension_var"] = scale_dimension_var
        if scale_var is not None:
            self._values["scale_var"] = scale_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompositeImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompositeImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        '''
        result = self._values.get("placement")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement_var(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        '''
        result = self._values.get("placement_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        '''
        result = self._values.get("scale_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        '''
        result = self._values.get("scale_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        '''
        result = self._values.get("scale_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanComposite(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompositeImage",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompositeImage:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompositeImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompositeImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompositeImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0eff61400261b693c6b6f694e0c10124012f987549ea45fae48955798605d53d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompositeImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompositeImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0754b90503dcddf0f1d56d9a30cbfea676034b7bcabd196f572c17c4ec82e9ae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompositeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompositeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__51e7271ecf0728b5464f72d2d5fbeb714f7e07d8d4fce10863c9f644b90d706b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompositeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__032731e869821a9ffec284dc7db0b9dc75c5a3e382f540467ad909b283ff521e)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompositeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3f7d1a5b1715cef10d101b23768b5624c0b8b1f69ac06a3b2eb8aa6f954da31f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6688af4e4c72bb101924b4bf7867c5ab6b2cb135d9cfe4a9dc7c314f789724fe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3e1afebf1cb9ccc795dd21d284a979388892ec9b86f19fd7e1bebbf186adb345)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanComposite]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanComposite]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__968b8cea067e4fa47c644dc83e2d4a154540808e0fc7bda010dd10c7cdc0996e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompositeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompositeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__513a71a6ef6a38703100356b8a6e4e1e2b6ffe6a5db4fdcf0b3e98223f842f84)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompositeImage()

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPlacement")
    def reset_placement(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacement", []))

    @jsii.member(jsii_name="resetPlacementVar")
    def reset_placement_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacementVar", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetScaleDimension")
    def reset_scale_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimension", []))

    @jsii.member(jsii_name="resetScaleDimensionVar")
    def reset_scale_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimensionVar", []))

    @jsii.member(jsii_name="resetScaleVar")
    def reset_scale_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompositeImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompositeImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompositeImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="placementInput")
    def placement_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementInput"))

    @builtins.property
    @jsii.member(jsii_name="placementVarInput")
    def placement_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionInput")
    def scale_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVarInput")
    def scale_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleVarInput")
    def scale_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__10f02062dbe9836c32fa0405e8728db3f4f042c81429bfde2dc6532bce80a0e9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__61227858770dedec14ee63a69c2b16fa5ede2cd73f6a0b3f15501cf3d5bc72ea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="placement")
    def placement(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placement"))

    @placement.setter
    def placement(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a4adfb42cdd80fb0c7768728fc56446cd9046c5481fe7480f2d10712c5b563ec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placement", value)

    @builtins.property
    @jsii.member(jsii_name="placementVar")
    def placement_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placementVar"))

    @placement_var.setter
    def placement_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0692791683c4e03126ca80a4ecd89e82077f771febe53ab9b03b57475e4f900e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placementVar", value)

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scale"))

    @scale.setter
    def scale(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__23f35b2d8a5c5d7765a772283cb88b237bd66486662749e9e725b9af2da89d94)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scale", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimension")
    def scale_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimension"))

    @scale_dimension.setter
    def scale_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e524dadd8d5bee20c64e08c697edcea3028af1d648e0a4099a6222114f2bf4ee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimension", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVar")
    def scale_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimensionVar"))

    @scale_dimension_var.setter
    def scale_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dd6c6919d94727dcf59b01aeed288cf590a97c01873165dcee2aa1de70282e8f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="scaleVar")
    def scale_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleVar"))

    @scale_var.setter
    def scale_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3e01951f6f196ab977583dfe95712993f9cd3abfc5bc669d8c50874dabd8c3f7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bf6619c60441388fd554ac2e9d6507e609557316b3b3db6a3fe62e7402cf6fb8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eaa0c6863e725c0bb3ae5bb31dfa91a62fec9d479fc8bfc63a782031132a08e3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__70abfa2aad4313be8e4336102b5d50b8db82a8926e95193fd18fcc4879d906e6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__706d4806400cf5391e68521ba689d59f802d7c6007b700fb5b3eabf85fcb74e6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanComposite]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanComposite]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanComposite]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dbcb18229050c55a36bdcd3e87ce039e780fe9fee8ab9703634198998a5b3c24)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompound",
    jsii_struct_bases=[],
    name_mapping={"transformations": "transformations"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompound:
    def __init__(
        self,
        *,
        transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param transformations: transformations block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__604031195322dd7bb84e4aa2d48297537dcb07fbf5e4487025ae7eab6ddd8383)
            check_type(argname="argument transformations", value=transformations, expected_type=type_hints["transformations"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if transformations is not None:
            self._values["transformations"] = transformations

    @builtins.property
    def transformations(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompoundTransformations"]]]:
        '''transformations block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        result = self._values.get("transformations")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompoundTransformations"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompound(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompoundList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompoundList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e3ccb9d01f3e3dd30cd47112d75958296f03321b6089b1622e1b0f6226fe832d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompoundOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__89d1457693f20cc69dfc7b7c7809ea54dcd998a61b7855343a7f74c65b66bb5d)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompoundOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab2bacdffe7b13cd77ed714b87066530b95e92a434bd691fd9d96cb23dd42257)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7e229738236de31d17ff2c0b4b2838232b7194546ea9abec118c9ff0345ba18d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fecf5d2a0c2bd81381971964ae002775df24800d8729aa4de51eb076f01c8cf3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompound]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompound]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a642608eb18d200e61f901f1968c858b363eba525d06ebb51e0d94f74a1acbdf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompoundOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompoundOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ff344150f5cde543bdadca0f39ed4db4da60565ed1239ba678dddf2a7abfe723)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformations")
    def put_transformations(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__108f50edee33a0c50158290052f517954c4c1dee6f8ed7daee3f9b59d8e39779)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTransformations", [value]))

    @jsii.member(jsii_name="resetTransformations")
    def reset_transformations(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformations", []))

    @builtins.property
    @jsii.member(jsii_name="transformations")
    def transformations(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompoundTransformationsList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompoundTransformationsList", jsii.get(self, "transformations"))

    @builtins.property
    @jsii.member(jsii_name="transformationsInput")
    def transformations_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompoundTransformations"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompoundTransformations"]]], jsii.get(self, "transformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompound]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompound]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompound]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a729a30c11ee1094bfa9489262b4aa8f736766a985727302698858a7a135ad7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompoundTransformations",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompoundTransformations:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompoundTransformations(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompoundTransformationsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompoundTransformationsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ebf661bd4f6c22ee29fb160a4b4070e157a0e1e1810be7d0e519296b7f0c292)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompoundTransformationsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__590f31194b018ebf2d7fca376ff5d07f79380d7be2c6481379e08dd425b2aeb6)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompoundTransformationsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4adcc617c5a3a45fd1986573a65deae9478efe9cd8758de5c35325b1ef344573)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__38691ba093452162d2e8980afa0e4eaa792608895d8df7c198cf9f5fcb11f2dd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4d530801ea267def94e65ec9d6b212a45fe644a366e972e5b4860271c8ecab17)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompoundTransformations]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompoundTransformations]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompoundTransformations]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a1525059a4399766cfe04865d8e5624c6a453ddde91670b4b83bc0455cb563e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompoundTransformationsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompoundTransformationsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__88a53f86ab4a5cb66b69550a88fae5baf6b23e4d8170009b9a8bc1a1e6a8afb5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompoundTransformations]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompoundTransformations]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompoundTransformations]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__61adb0c142c8b3e1704eb261c1c7f2cacf28c584322f2f34d1df62d94ec611aa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanContrast",
    jsii_struct_bases=[],
    name_mapping={
        "brightness": "brightness",
        "brightness_var": "brightnessVar",
        "contrast": "contrast",
        "contrast_var": "contrastVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanContrast:
    def __init__(
        self,
        *,
        brightness: typing.Optional[builtins.str] = None,
        brightness_var: typing.Optional[builtins.str] = None,
        contrast: typing.Optional[builtins.str] = None,
        contrast_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param brightness: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        :param brightness_var: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        :param contrast: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param contrast_var: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5eaa34ede69f8796d551440b0af10db5e6d3d8748473588019c19aaab84d188c)
            check_type(argname="argument brightness", value=brightness, expected_type=type_hints["brightness"])
            check_type(argname="argument brightness_var", value=brightness_var, expected_type=type_hints["brightness_var"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument contrast_var", value=contrast_var, expected_type=type_hints["contrast_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if brightness is not None:
            self._values["brightness"] = brightness
        if brightness_var is not None:
            self._values["brightness_var"] = brightness_var
        if contrast is not None:
            self._values["contrast"] = contrast
        if contrast_var is not None:
            self._values["contrast_var"] = contrast_var

    @builtins.property
    def brightness(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        '''
        result = self._values.get("brightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def brightness_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        '''
        result = self._values.get("brightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        result = self._values.get("contrast_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanContrast(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanContrastList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanContrastList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0841766f14dd938bdb79d79e70b6640bb6aa51ede20ee76c771f97399b667421)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanContrastOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3cc3489e1e1833485bf4b717ede5094355a6512d94cf872091cd1420bb90616e)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanContrastOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1dcf052b54f2099654c2c85a7b76e522228437357d0041b8ee16766b5dfb6faa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4efc827a16819c40aaf19712445f76fa82e447b353d95b8327411bbd5228944f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4d75ffd5e68dc7354e96df31e0007d5feae6290affd3cad1005bf1fe7fba10ef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanContrast]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanContrast]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__576b511fade97fb3a613cadce84998feeba31106649580ff6a3d5eab5e4a15a9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanContrastOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanContrastOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a6c14695a3f79e1d6029ef7012da2fa04107efdbbc80e53469e4c343e4a290ee)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetBrightness")
    def reset_brightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightness", []))

    @jsii.member(jsii_name="resetBrightnessVar")
    def reset_brightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightnessVar", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetContrastVar")
    def reset_contrast_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrastVar", []))

    @builtins.property
    @jsii.member(jsii_name="brightnessInput")
    def brightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="brightnessVarInput")
    def brightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastVarInput")
    def contrast_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="brightness")
    def brightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightness"))

    @brightness.setter
    def brightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b947339285332054d570f287c81c868e59af6a6d660e4ef84fa2fa4bb1d39220)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightness", value)

    @builtins.property
    @jsii.member(jsii_name="brightnessVar")
    def brightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightnessVar"))

    @brightness_var.setter
    def brightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fb7895036ba7432021a5220b93eebd5834b28b8b8cc2d723e4f0c437afa8633b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrast"))

    @contrast.setter
    def contrast(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__da39adb2340e3093bafbb9b07038cb89408a3b67725943dc97cf2c06e6e42602)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrast", value)

    @builtins.property
    @jsii.member(jsii_name="contrastVar")
    def contrast_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrastVar"))

    @contrast_var.setter
    def contrast_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d67639a13a542b95c9cadf43bf09c1075a0bba5717a5faab2df56b8e0caa77f7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrastVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanContrast]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanContrast]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanContrast]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b2cc9a4f9b7363fa74a55966d1c16fa98a7f6b60ac24e2b7cbbe9aba7311b9f9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanGoop",
    jsii_struct_bases=[],
    name_mapping={
        "chaos": "chaos",
        "chaos_var": "chaosVar",
        "density": "density",
        "density_var": "densityVar",
        "power": "power",
        "power_var": "powerVar",
        "seed": "seed",
        "seed_var": "seedVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanGoop:
    def __init__(
        self,
        *,
        chaos: typing.Optional[builtins.str] = None,
        chaos_var: typing.Optional[builtins.str] = None,
        density: typing.Optional[builtins.str] = None,
        density_var: typing.Optional[builtins.str] = None,
        power: typing.Optional[builtins.str] = None,
        power_var: typing.Optional[builtins.str] = None,
        seed: typing.Optional[builtins.str] = None,
        seed_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param chaos: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        :param chaos_var: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        :param density: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        :param density_var: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        :param power: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        :param power_var: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        :param seed: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        :param seed_var: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4347931dd64b5ecdbd9dcc0b7017f75916f70ccb054f9dc7cba453a72e9f6284)
            check_type(argname="argument chaos", value=chaos, expected_type=type_hints["chaos"])
            check_type(argname="argument chaos_var", value=chaos_var, expected_type=type_hints["chaos_var"])
            check_type(argname="argument density", value=density, expected_type=type_hints["density"])
            check_type(argname="argument density_var", value=density_var, expected_type=type_hints["density_var"])
            check_type(argname="argument power", value=power, expected_type=type_hints["power"])
            check_type(argname="argument power_var", value=power_var, expected_type=type_hints["power_var"])
            check_type(argname="argument seed", value=seed, expected_type=type_hints["seed"])
            check_type(argname="argument seed_var", value=seed_var, expected_type=type_hints["seed_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if chaos is not None:
            self._values["chaos"] = chaos
        if chaos_var is not None:
            self._values["chaos_var"] = chaos_var
        if density is not None:
            self._values["density"] = density
        if density_var is not None:
            self._values["density_var"] = density_var
        if power is not None:
            self._values["power"] = power
        if power_var is not None:
            self._values["power_var"] = power_var
        if seed is not None:
            self._values["seed"] = seed
        if seed_var is not None:
            self._values["seed_var"] = seed_var

    @builtins.property
    def chaos(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        '''
        result = self._values.get("chaos")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def chaos_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        '''
        result = self._values.get("chaos_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        '''
        result = self._values.get("density")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density_var(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        '''
        result = self._values.get("density_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        '''
        result = self._values.get("power")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power_var(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        '''
        result = self._values.get("power_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        '''
        result = self._values.get("seed")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed_var(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        result = self._values.get("seed_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanGoop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanGoopList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanGoopList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ab6834351fb0bfe1769f4034a1bef3e93448f083be80e5a2df1c6922e9f0513)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanGoopOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6364f3df8adad0ef84f900655f3f9f4ea08cfbbad1a04de74a1aef0a9d94d039)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanGoopOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5a977ca393c43a1e87bc83afcf895ececa80234db7cd9b4528d1be3a7c5cd4fa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f7ba748c2ea09732a5c603d997a8e5a20dcf3f8b21d97863a4862c3f44bfcf44)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cbc430bb7720a52477a8fdf6a174417ecd351fcace9f5725525b8e8c9ccc73c4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanGoop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanGoop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bbc7f2a6aae4a05e6536c1d47c40ee6103b4e741d2f16a5942a46a33ea76f404)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanGoopOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanGoopOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8ea9db087e9efc705600f26fc7644be76c9c7d1b93cb303883962c8dd168614b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetChaos")
    def reset_chaos(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaos", []))

    @jsii.member(jsii_name="resetChaosVar")
    def reset_chaos_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaosVar", []))

    @jsii.member(jsii_name="resetDensity")
    def reset_density(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensity", []))

    @jsii.member(jsii_name="resetDensityVar")
    def reset_density_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensityVar", []))

    @jsii.member(jsii_name="resetPower")
    def reset_power(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPower", []))

    @jsii.member(jsii_name="resetPowerVar")
    def reset_power_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPowerVar", []))

    @jsii.member(jsii_name="resetSeed")
    def reset_seed(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeed", []))

    @jsii.member(jsii_name="resetSeedVar")
    def reset_seed_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeedVar", []))

    @builtins.property
    @jsii.member(jsii_name="chaosInput")
    def chaos_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosInput"))

    @builtins.property
    @jsii.member(jsii_name="chaosVarInput")
    def chaos_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosVarInput"))

    @builtins.property
    @jsii.member(jsii_name="densityInput")
    def density_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityInput"))

    @builtins.property
    @jsii.member(jsii_name="densityVarInput")
    def density_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="powerInput")
    def power_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerInput"))

    @builtins.property
    @jsii.member(jsii_name="powerVarInput")
    def power_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerVarInput"))

    @builtins.property
    @jsii.member(jsii_name="seedInput")
    def seed_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedInput"))

    @builtins.property
    @jsii.member(jsii_name="seedVarInput")
    def seed_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedVarInput"))

    @builtins.property
    @jsii.member(jsii_name="chaos")
    def chaos(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaos"))

    @chaos.setter
    def chaos(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a7a3d25e03030cceac13a27b06de0affaf45d2778b7c91948ec43ae6c6045f2c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaos", value)

    @builtins.property
    @jsii.member(jsii_name="chaosVar")
    def chaos_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaosVar"))

    @chaos_var.setter
    def chaos_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__19d958caffa55ab022c99faaf4b559d963a165d9765731ebd3b80384792013f9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaosVar", value)

    @builtins.property
    @jsii.member(jsii_name="density")
    def density(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "density"))

    @density.setter
    def density(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ceb56abb24686cb454d0cafb6594682e7baefbeb72f0a8c4144ebeb24b2fcf40)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "density", value)

    @builtins.property
    @jsii.member(jsii_name="densityVar")
    def density_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "densityVar"))

    @density_var.setter
    def density_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8ee13cf0686de8bfa7927cce1d07a128f3d2f8118280f27f88f77533d11e2578)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "densityVar", value)

    @builtins.property
    @jsii.member(jsii_name="power")
    def power(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "power"))

    @power.setter
    def power(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__424b60e1d9992947836c021ce912d6848d682ea0202c8fff6a8e3e24184ec4c4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "power", value)

    @builtins.property
    @jsii.member(jsii_name="powerVar")
    def power_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "powerVar"))

    @power_var.setter
    def power_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4daa31315cba6631f8f5c80f8567bc435c943ea3afd9906b55e63da8cc2ec709)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "powerVar", value)

    @builtins.property
    @jsii.member(jsii_name="seed")
    def seed(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seed"))

    @seed.setter
    def seed(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0a3a0deb1efb288111f2fff90b766f572ccdafa27d246f5841d2da1527d71585)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seed", value)

    @builtins.property
    @jsii.member(jsii_name="seedVar")
    def seed_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seedVar"))

    @seed_var.setter
    def seed_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b344881a36a6ea004d59eab8b579fa1613e50fc6200578be9e8891700450edb3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seedVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanGoop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanGoop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanGoop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d64d635ffd037b015972ac5f25059853415f67b5dd770c059e9ea36a11bd24ef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanGrayscale",
    jsii_struct_bases=[],
    name_mapping={"type": "type", "type_var": "typeVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanGrayscale:
    def __init__(
        self,
        *,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param type: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1ab5da82e8f78dc654d9dc692dbd79562f07bc51cffac89920b9ce25a0aa9749)
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanGrayscale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanGrayscaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanGrayscaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f573ff2254d6bad66c8d7a1af6a70512aa59f283cb51926f2d76a33d22888f01)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanGrayscaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__170433e2ad94add7a7ed5ba980e17cf1c6cb8deb795ea329b02d85af5e1fe59e)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanGrayscaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__81c01b54763a205654d5a16f050de5551c5fe6368544076ef7556df5d81ebc18)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7b10cb618bffff2b978dcfd7c6736889e6bf78c353de4910750d7505350605fc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d023f4458323604263ac34041acdd60f2f24787fb7d30e95ba0adb48f7f6dda7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanGrayscale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanGrayscale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e64c2814271464b538e393983304d83fcb037da99c251bfb6898631a3f39987d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanGrayscaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanGrayscaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7ecba19bb2b4a8d7f7edfcdcd10850060f224e0fa0d20a663611047b39934984)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0133894af960f4fa279d8f3c37364d652cabce3394d2f9e660962a65d0451e58)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7b560200e14f17bbe7908d4c77ba2a2a7ebd1f39b5ab76fca7db2bc81a4266a7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanGrayscale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanGrayscale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanGrayscale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9c6984285a450fdaadb67744718473fd05e17315b228c2fa75e074ad4ebfe81e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanHsl",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "lightness": "lightness",
        "lightness_var": "lightnessVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanHsl:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness: typing.Optional[builtins.str] = None,
        lightness_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        :param lightness_var: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f81d870bffb06c4cd1815c49e39b8402c4b771b3c2e07d6f802bc4afdb86906c)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness", value=lightness, expected_type=type_hints["lightness"])
            check_type(argname="argument lightness_var", value=lightness_var, expected_type=type_hints["lightness_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness is not None:
            self._values["lightness"] = lightness
        if lightness_var is not None:
            self._values["lightness_var"] = lightness_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        '''
        result = self._values.get("lightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        '''
        result = self._values.get("lightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanHsl(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanHslList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanHslList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6c04a071d55db0db0082793247811a2d70437eb963b5878a676f9467ba65c730)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanHslOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a7dbc3af32a5ce651c777ba0443f905d8b920fa9a958163577eb98d1a9f43f75)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanHslOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1de5eff344eeed3d20e30a776498746338b83d971794af25988b43ffe4f46379)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9993b5964a8c718abbfe51a2bd368cc1192d6a54b486051a6a302a1dce381214)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c75cdfcc94c788783b0691b60e6bf1363f7b0c2409d2a261b377e818331575b2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanHsl]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanHsl]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__73901231584127c9b179ba35d6cdef171337b18afb31f3cd0150cd3996b0bb8f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanHslOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanHslOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d8203658e68745c524ea6b453183c168e8bd889a5a62b0213e3adb520c72dea)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightness")
    def reset_lightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightness", []))

    @jsii.member(jsii_name="resetLightnessVar")
    def reset_lightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessInput")
    def lightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessVarInput")
    def lightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5923375334d1e247e03d725fcfbfe198115be567d8622fd1e1fba79ddd18976a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__707e5d68727320cbeaecd68984d54fc658278fd5f1d5c9338a666b26bc907984)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightness")
    def lightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightness"))

    @lightness.setter
    def lightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a59cc3a157264bd2464dce8c96073043e3dbf877376364173fe369058fdbf98)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightness", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessVar")
    def lightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessVar"))

    @lightness_var.setter
    def lightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4af75fa20cc14fc3a1112eae6deac1bb1cdb89bf38bb09d7089922ca9e14c3b8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eb1027433d6beccf7d97619cfe53a12a0b456d31d42ce0f5c2341dff9c44afb8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a8cb40028dfb25f2b37ae8c0a3eb8402c5751011ba74e991900bc79c4f3cc5ff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanHsl]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanHsl]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanHsl]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a0ce6918eda7b7a5a517b6b0db93975f04823106b4d38b63310798264fbb5f01)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanHsv",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanHsv:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        :param value: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__366a89426c52078fcb972f44c1fbe201f315728fbb4503b31716f3097802b7df)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanHsv(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanHsvList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanHsvList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__17c88ab2aaa8658be20c722e2dc9307670f7f4f0f462eaeb5622b3714e17c02e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanHsvOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a0c0b03b57cb0f7bda386e42796c480dd74a995f84b1b689fa033d2de73db14)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanHsvOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__797735fd45956ce1dbb93e8681fe63b5a459cb84f838e60899125ed07e0d7112)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__383e5f19270909796012de82290bab950df8e7088a35879c4dcfe19ebc77960a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3c172dc27eb946bb21a0110f8723c63cf5918cf7b9b1b5028299ae3be1725063)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanHsv]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanHsv]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8b2f8beff099bddda647732ae6ab9d7c01eda7fe54767258e9768022a18ad1dd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanHsvOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanHsvOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a5274b74883f254aca25613772cf603d2794aca094e3b9f86410b0a9744b3345)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__65ef89acc2cf0d17ae6d561c3b04af1af50959edd93ca2a6ecd4f234e156699f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f3b05aae5e481cb37aab2baa36cd894a5a1916a918d7d768c26ce98cec8d09b9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5b10fecb7f11159dbd86edcf73afb5a4ba664e227a04543e82b9d40b15e3fa45)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e5e459a355bb5d6ef2b301e97fcbfe58b30c7448b018feb2d5575d69d762a701)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1df6e68bca4779ea2754312bfd33abdb8b61e5ed26bdb84b9113472c1b072951)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__65c8240827754842d2ebd5b87a7cec534cbc03988a104a3c73df80d53190f6cc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanHsv]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanHsv]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanHsv]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea9b4fcf0e54ba71c85a12db3926b4e6b1fc564ef7b1aa2c45586298f34c3b3e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimension",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "dimension": "dimension",
        "dimension_var": "dimensionVar",
        "equal": "equal",
        "greater_than": "greaterThan",
        "less_than": "lessThan",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimension:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        dimension: typing.Optional[builtins.str] = None,
        dimension_var: typing.Optional[builtins.str] = None,
        equal: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionEqual", typing.Dict[builtins.str, typing.Any]]] = None,
        greater_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionGreaterThan", typing.Dict[builtins.str, typing.Any]]] = None,
        less_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionLessThan", typing.Dict[builtins.str, typing.Any]]] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param dimension: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        :param dimension_var: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        :param equal: equal block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        :param greater_than: greater_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        :param less_than: less_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        :param value: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionDefault(**default)
        if isinstance(equal, dict):
            equal = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionEqual(**equal)
        if isinstance(greater_than, dict):
            greater_than = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionGreaterThan(**greater_than)
        if isinstance(less_than, dict):
            less_than = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionLessThan(**less_than)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__277ed9a9ae57fd24a0fec571b068f5b5b875f61a3ad7053264310ab86ff306b7)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument dimension", value=dimension, expected_type=type_hints["dimension"])
            check_type(argname="argument dimension_var", value=dimension_var, expected_type=type_hints["dimension_var"])
            check_type(argname="argument equal", value=equal, expected_type=type_hints["equal"])
            check_type(argname="argument greater_than", value=greater_than, expected_type=type_hints["greater_than"])
            check_type(argname="argument less_than", value=less_than, expected_type=type_hints["less_than"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if dimension is not None:
            self._values["dimension"] = dimension
        if dimension_var is not None:
            self._values["dimension_var"] = dimension_var
        if equal is not None:
            self._values["equal"] = equal
        if greater_than is not None:
            self._values["greater_than"] = greater_than
        if less_than is not None:
            self._values["less_than"] = less_than
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionDefault"], result)

    @builtins.property
    def dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        '''
        result = self._values.get("dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        '''
        result = self._values.get("dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def equal(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionEqual"]:
        '''equal block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        '''
        result = self._values.get("equal")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionEqual"], result)

    @builtins.property
    def greater_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionGreaterThan"]:
        '''greater_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        '''
        result = self._values.get("greater_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionGreaterThan"], result)

    @builtins.property
    def less_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionLessThan"]:
        '''less_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        '''
        result = self._values.get("less_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionLessThan"], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimension(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a63a504a327b328ca3e2b24f95ec7e83fd68b4be71a965219d3c9b5398a90c72)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__85c204995b5d3feb31681333f74b0080d4be1b2d286dd14d95dbe603041f258d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionEqual",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionEqual:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionEqual(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionEqualOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionEqualOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f722f3cacb7779c642a11e67bde2ff889f99bfee9cbb7426e53ea90025422b7f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionEqual], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionEqual],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a2cae17ad72ac9e5818551d92aff6d4f5db2c45fe987da8ea385e11e2d3897b8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionGreaterThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionGreaterThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionGreaterThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionGreaterThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionGreaterThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__180276bf13bebd96464f775afed32bccc46cbf3cb61f134c06fdad2ab0adcf7d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionGreaterThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionGreaterThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0627798b65de5ab7e246e1056c94ba91f12bd36311df0d5d6062e2115fd0c2fc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionLessThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionLessThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionLessThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionLessThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionLessThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__92583ecde8f5b498ab370cb3d78a1c5aa38f3fda6d2c8a38ab93c717e12fd87f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionLessThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionLessThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a47d7f7ce9e2f5856ff82873411e0092ccc02686d8e28a3cfef793c3a51d331d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bebba9646d004a7d4ba49bcec0140419059f7d8da791c7727ab62187c0c4a87f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dfa91acc19ca806f4fb555bba9a52a43ea36431719bf0ed4fd4ec243284f4505)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f4b13adeb14eecb62d9e083891e6c38ef35f1c8dfc1b1386fa60d8a7f623cb26)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b967db5c004ab9e17e1a78796bfc5f10f0c58bfbb863744eb954cf2afb9fcade)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a710862e6ae769c23340c29a6afb32a72762f54b9ca86e659001999872c876b5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimension]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimension]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__13649fe660786791a64f2cb54917d901f6e1fb9fbeeb0cdf1b33ae0831bc9448)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b49c17f3a0d02c2a8457ab1ce4e6aaf04da0ccbce1bc8fae5b2fe2209680a43f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putEqual")
    def put_equal(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionEqual()

        return typing.cast(None, jsii.invoke(self, "putEqual", [value]))

    @jsii.member(jsii_name="putGreaterThan")
    def put_greater_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionGreaterThan()

        return typing.cast(None, jsii.invoke(self, "putGreaterThan", [value]))

    @jsii.member(jsii_name="putLessThan")
    def put_less_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionLessThan()

        return typing.cast(None, jsii.invoke(self, "putLessThan", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetDimension")
    def reset_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimension", []))

    @jsii.member(jsii_name="resetDimensionVar")
    def reset_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimensionVar", []))

    @jsii.member(jsii_name="resetEqual")
    def reset_equal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEqual", []))

    @jsii.member(jsii_name="resetGreaterThan")
    def reset_greater_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGreaterThan", []))

    @jsii.member(jsii_name="resetLessThan")
    def reset_less_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLessThan", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="equal")
    def equal(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionEqualOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionEqualOutputReference, jsii.get(self, "equal"))

    @builtins.property
    @jsii.member(jsii_name="greaterThan")
    def greater_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionGreaterThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionGreaterThanOutputReference, jsii.get(self, "greaterThan"))

    @builtins.property
    @jsii.member(jsii_name="lessThan")
    def less_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionLessThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionLessThanOutputReference, jsii.get(self, "lessThan"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionInput")
    def dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionVarInput")
    def dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="equalInput")
    def equal_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionEqual], jsii.get(self, "equalInput"))

    @builtins.property
    @jsii.member(jsii_name="greaterThanInput")
    def greater_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionGreaterThan], jsii.get(self, "greaterThanInput"))

    @builtins.property
    @jsii.member(jsii_name="lessThanInput")
    def less_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionLessThan], jsii.get(self, "lessThanInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="dimension")
    def dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimension"))

    @dimension.setter
    def dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eaec5e7fe8e1436da68a8e675036124ab78af30f9bbab78b7e928237c100f675)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimension", value)

    @builtins.property
    @jsii.member(jsii_name="dimensionVar")
    def dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimensionVar"))

    @dimension_var.setter
    def dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__513815cdc8b3db3d856230c67d711948a7b87efe1c1b04d1d483ba12602d1bb9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__76c91437bfe162c96d6e435517a255fe36b9174ec703ffe5306479d23ebff223)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e1fd05cca11fadd5b99f6811117eb7cd7e6095f155d64f4ce95025b9b22e42e0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimension]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimension]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimension]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1d1903c31ec2fcb19f81440478bdd9d946c1b530ad317c734e719c9f109ce5c0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientation",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "landscape": "landscape",
        "portrait": "portrait",
        "square": "square",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientation:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        landscape: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationLandscape", typing.Dict[builtins.str, typing.Any]]] = None,
        portrait: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationPortrait", typing.Dict[builtins.str, typing.Any]]] = None,
        square: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationSquare", typing.Dict[builtins.str, typing.Any]]] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param landscape: landscape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        :param portrait: portrait block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        :param square: square block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationDefault(**default)
        if isinstance(landscape, dict):
            landscape = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationLandscape(**landscape)
        if isinstance(portrait, dict):
            portrait = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationPortrait(**portrait)
        if isinstance(square, dict):
            square = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationSquare(**square)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a2351e17cb6ca853a210fe9589999ae8facc926d07520412c7bd9a0a8dfd0799)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument landscape", value=landscape, expected_type=type_hints["landscape"])
            check_type(argname="argument portrait", value=portrait, expected_type=type_hints["portrait"])
            check_type(argname="argument square", value=square, expected_type=type_hints["square"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if landscape is not None:
            self._values["landscape"] = landscape
        if portrait is not None:
            self._values["portrait"] = portrait
        if square is not None:
            self._values["square"] = square

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationDefault"], result)

    @builtins.property
    def landscape(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationLandscape"]:
        '''landscape block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        '''
        result = self._values.get("landscape")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationLandscape"], result)

    @builtins.property
    def portrait(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationPortrait"]:
        '''portrait block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        '''
        result = self._values.get("portrait")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationPortrait"], result)

    @builtins.property
    def square(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationSquare"]:
        '''square block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        result = self._values.get("square")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationSquare"], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa6328c179d2e9fb200681404bc890e2b2652dc85c46e34ca0ad3fc5f7ab472e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__91a35fe50aea9fd8d6d5aa4b6e08cba76d62a274e3e11485dab1142790f784aa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationLandscape",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationLandscape:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationLandscape(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationLandscapeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationLandscapeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bac9d45ae1a7430daa0c25b6e49311a863f2dcd472fe049761dfc7786826f6c7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationLandscape], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationLandscape],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__640304fbd95ad6f9b769b4e9bca4f87b06251a14b469f79fc4b4280098a296fe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__44f6064b962ec2633d28cc4ed818067d14e71fd77640312ac5626ba33084a83c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__73cd736ff14d67880634535653acf4b6ac81cca5994ec06f239197aa502acd3e)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f1284f0921bf13e340a8a9ee338dd5e36cf05d63cedd478a160d803550daa25)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__45a82169cbeeb18ac79ecd11367b808da99b30bac891f58b116c783029cb8502)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8242857c08cf2113b735f0504cbb896f78d066659d11b1e997381ceed672c53a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientation]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientation]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__73400b82b555d2195321668a0e1ab58fd8163860e2856cd7210331cec99ed832)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5478e74b08e34a4863607bb8fe308c0924113061a815a3ad0c0133677dc6b8ee)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putLandscape")
    def put_landscape(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationLandscape()

        return typing.cast(None, jsii.invoke(self, "putLandscape", [value]))

    @jsii.member(jsii_name="putPortrait")
    def put_portrait(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationPortrait()

        return typing.cast(None, jsii.invoke(self, "putPortrait", [value]))

    @jsii.member(jsii_name="putSquare")
    def put_square(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationSquare()

        return typing.cast(None, jsii.invoke(self, "putSquare", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetLandscape")
    def reset_landscape(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLandscape", []))

    @jsii.member(jsii_name="resetPortrait")
    def reset_portrait(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPortrait", []))

    @jsii.member(jsii_name="resetSquare")
    def reset_square(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSquare", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="landscape")
    def landscape(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationLandscapeOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationLandscapeOutputReference, jsii.get(self, "landscape"))

    @builtins.property
    @jsii.member(jsii_name="portrait")
    def portrait(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationPortraitOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationPortraitOutputReference", jsii.get(self, "portrait"))

    @builtins.property
    @jsii.member(jsii_name="square")
    def square(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationSquareOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationSquareOutputReference", jsii.get(self, "square"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="landscapeInput")
    def landscape_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationLandscape], jsii.get(self, "landscapeInput"))

    @builtins.property
    @jsii.member(jsii_name="portraitInput")
    def portrait_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationPortrait"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationPortrait"], jsii.get(self, "portraitInput"))

    @builtins.property
    @jsii.member(jsii_name="squareInput")
    def square_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationSquare"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationSquare"], jsii.get(self, "squareInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientation]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientation]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientation]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f59204d6e33243a7cf35b31fcbae69e521c4ec9f1f2e6a81adc175bbb098cdcc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationPortrait",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationPortrait:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationPortrait(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationPortraitOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationPortraitOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__28b0ceba4fe8bd4f2dc11040d29736fa7f28b158c3b68fda9ea11e8788ed4bab)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationPortrait]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationPortrait], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationPortrait],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__376d5f81bf49e89bbf5befecfeefa0887b7c851d819b2e9feb703a0b6ba07504)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationSquare",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationSquare:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationSquare(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationSquareOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationSquareOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__71985464f50fc55a21000eea637b986108d2eea8713f217452c789f1b70ee5f7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationSquare]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationSquare], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationSquare],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2890af9ed2a03c75c3296a54467898f89cfe1f54edc00b04a735af86cb66dbd5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanMaxColors",
    jsii_struct_bases=[],
    name_mapping={"colors": "colors", "colors_var": "colorsVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanMaxColors:
    def __init__(
        self,
        *,
        colors: typing.Optional[builtins.str] = None,
        colors_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param colors: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        :param colors_var: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a560b6e475c810c22a60aa418be66b85c70a65c05ab5845f05e862af21c7548)
            check_type(argname="argument colors", value=colors, expected_type=type_hints["colors"])
            check_type(argname="argument colors_var", value=colors_var, expected_type=type_hints["colors_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if colors is not None:
            self._values["colors"] = colors
        if colors_var is not None:
            self._values["colors_var"] = colors_var

    @builtins.property
    def colors(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        '''
        result = self._values.get("colors")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def colors_var(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        result = self._values.get("colors_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanMaxColors(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanMaxColorsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanMaxColorsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6de0b3a28413eca10b58761a3a2355b8dc10b1d902dc40c6d95e7a2c4a723fa8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanMaxColorsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__41e74653b5fbbf1b76966768d311dc9a24df754f1774f42958c983b96fcd20b4)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanMaxColorsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__677054b0f2b0598a75dcb52009154c227cfc65463acd1fc4ae1e9a93a0076231)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eda901de90782300ed6cb4f72d2656454e7f107b32eafe2e823af3810227d7e7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__adf4571926045874e5372407e5efc0a515eb36823730d77f18bee94b252caa6a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanMaxColors]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanMaxColors]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3dd9faa766e699166fbce67e9aa2ca9133c8ac34fd32b137950c642636b5e11e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanMaxColorsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanMaxColorsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9bbad307f8dabdda39cc07985533d134e1359f3a8e70fb3f9585b88c5c2780d5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColors")
    def reset_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColors", []))

    @jsii.member(jsii_name="resetColorsVar")
    def reset_colors_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorsVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorsInput")
    def colors_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsInput"))

    @builtins.property
    @jsii.member(jsii_name="colorsVarInput")
    def colors_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsVarInput"))

    @builtins.property
    @jsii.member(jsii_name="colors")
    def colors(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colors"))

    @colors.setter
    def colors(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4606e71d8e66fd52cc3b28376964e2661c5b7f2819e2350f62b7140f97f29a7e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colors", value)

    @builtins.property
    @jsii.member(jsii_name="colorsVar")
    def colors_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorsVar"))

    @colors_var.setter
    def colors_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a8da01dc69b6be0107ee173ff8663cfa5ad9b099daca847c76512ff77e4c60e0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorsVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanMaxColors]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanMaxColors]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanMaxColors]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__48a5647880b584ac7dc465aee1aee306bd7e707b1d472ee45bf142d323dadf53)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanMirror",
    jsii_struct_bases=[],
    name_mapping={
        "horizontal": "horizontal",
        "horizontal_var": "horizontalVar",
        "vertical": "vertical",
        "vertical_var": "verticalVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanMirror:
    def __init__(
        self,
        *,
        horizontal: typing.Optional[builtins.str] = None,
        horizontal_var: typing.Optional[builtins.str] = None,
        vertical: typing.Optional[builtins.str] = None,
        vertical_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param horizontal: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        :param horizontal_var: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        :param vertical: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        :param vertical_var: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__793c1b37c7cccb63dd16705affd0daf056146bc8fc2772f2ed8508cbf74909bb)
            check_type(argname="argument horizontal", value=horizontal, expected_type=type_hints["horizontal"])
            check_type(argname="argument horizontal_var", value=horizontal_var, expected_type=type_hints["horizontal_var"])
            check_type(argname="argument vertical", value=vertical, expected_type=type_hints["vertical"])
            check_type(argname="argument vertical_var", value=vertical_var, expected_type=type_hints["vertical_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if horizontal is not None:
            self._values["horizontal"] = horizontal
        if horizontal_var is not None:
            self._values["horizontal_var"] = horizontal_var
        if vertical is not None:
            self._values["vertical"] = vertical
        if vertical_var is not None:
            self._values["vertical_var"] = vertical_var

    @builtins.property
    def horizontal(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        '''
        result = self._values.get("horizontal")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def horizontal_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        '''
        result = self._values.get("horizontal_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        '''
        result = self._values.get("vertical")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        result = self._values.get("vertical_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanMirror(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanMirrorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanMirrorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cddbdb987db8cc0f59c86c40ea64e159499f88c9cbc6167421eb8af3a93b1f9f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanMirrorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b1d2557e2e79b44e15bec276fef147a347d244433adf0f6f3eccf17848e78da4)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanMirrorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c15bc63e2ad6f9a877dd49a0b8ae324a45b1e8d0608e1e066e747f4d757c5d82)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__69d4905ade6f09f5676c01e84437f0be1cae22a2622f57c9d6a65fe8360d414d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2984e088a342e75dc2873cfcdaa1f103f00135b968def4dfb6e298629eebd766)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanMirror]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanMirror]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8f65fba8b8fdfe49ae8d0e8cde36c5b509063e9c3a8578485fa086518e0132a6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanMirrorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanMirrorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7122bfec6117cc73c64ecf1fe89e1d59951aa652cc4be3a1830b1d08709d208d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHorizontal")
    def reset_horizontal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontal", []))

    @jsii.member(jsii_name="resetHorizontalVar")
    def reset_horizontal_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontalVar", []))

    @jsii.member(jsii_name="resetVertical")
    def reset_vertical(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVertical", []))

    @jsii.member(jsii_name="resetVerticalVar")
    def reset_vertical_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVerticalVar", []))

    @builtins.property
    @jsii.member(jsii_name="horizontalInput")
    def horizontal_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontalVarInput")
    def horizontal_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalInput")
    def vertical_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalVarInput")
    def vertical_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontal")
    def horizontal(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontal"))

    @horizontal.setter
    def horizontal(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1ad0f7e9129d1098b5342a9d6dbb6d021a8fe06f1f1886a93a2c01c0a4cdacb6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontal", value)

    @builtins.property
    @jsii.member(jsii_name="horizontalVar")
    def horizontal_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontalVar"))

    @horizontal_var.setter
    def horizontal_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a8c1672cc2c678fb5f25140f460f1c218e03c5932af4c8dee92a1b853aa037f1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontalVar", value)

    @builtins.property
    @jsii.member(jsii_name="vertical")
    def vertical(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "vertical"))

    @vertical.setter
    def vertical(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0dc37afcd338d84340f403b88c526b6ba5ef575ecbbc41824bfd617185be1dd0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "vertical", value)

    @builtins.property
    @jsii.member(jsii_name="verticalVar")
    def vertical_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "verticalVar"))

    @vertical_var.setter
    def vertical_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e3059e30f70f0761ef2fe38198e9334ae4605b7037142df070bf50f89c41095b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "verticalVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanMirror]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanMirror]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanMirror]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a51aae9fc40687ca36cced7c014cd21a975927c551dd6835cbe92567b3ad6390)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanMonoHue",
    jsii_struct_bases=[],
    name_mapping={"hue": "hue", "hue_var": "hueVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanMonoHue:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eeff8a5525d8ae28103646da3f82782d823bc59601adecb0e68c73a131ec982a)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanMonoHue(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanMonoHueList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanMonoHueList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b4c3b43dfc5230d186da519e1f7c0f428922cb158e8567d1c5f7b8dc00637bb3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanMonoHueOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a28763d42e9f8faa80ee21d186a6868118a1d9168317cf5a656f2337832cfa3e)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanMonoHueOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5e8543f77cc64547d3d3b4b2bfbb3582aa1d3d240fffe594d412f842b4cea89f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7e3b7f60485c1740f7b35026e7d0412e119604b8560d3d01063288e442dba0eb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1664c5621c41db9747a5a696cf0e1716f2f8a66a1dff00bfcc4ad012a0bfa15d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanMonoHue]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanMonoHue]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a89b82df37950e694889bd8417c378894f087728d312159adf385201f067b6f1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanMonoHueOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanMonoHueOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e6baeae00527cb5a668b4232140f1522dc884979acd774e39e0871949551d1b7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9291588e7fa9f82e27617e3c9dd39f1bb47d4cb39e040b64b0abdaa865628c44)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0f93c3a6d38b944df0820e9ac8a21a3065d6e9828772d0878d2aef31ba7c4336)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanMonoHue]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanMonoHue]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanMonoHue]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__648c4f04a70ba12df48463bce0dda7f06ce414892b3fdcdb237984e1bf8a9593)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanOpacity",
    jsii_struct_bases=[],
    name_mapping={"opacity": "opacity", "opacity_var": "opacityVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanOpacity:
    def __init__(
        self,
        *,
        opacity: typing.Optional[builtins.str] = None,
        opacity_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param opacity: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param opacity_var: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__41a60de0bc40f3e9b2cfa68676aedb5017f1ad9e70340e242d8c487eeb47ec63)
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument opacity_var", value=opacity_var, expected_type=type_hints["opacity_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if opacity is not None:
            self._values["opacity"] = opacity
        if opacity_var is not None:
            self._values["opacity_var"] = opacity_var

    @builtins.property
    def opacity(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def opacity_var(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        result = self._values.get("opacity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanOpacity(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanOpacityList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanOpacityList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1abbd5e9f58a41a76fe2fb253721284b42b0190f4cee413d59e8076ec7e49dbb)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanOpacityOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f4c6af17a40e7f767915bbbc2216d1ff79eb5f9f1e7fe47395344aaee5a33ad0)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanOpacityOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8946ac5341de25c8c8aab268d844f55e29c175f7f9f69e6e6b54a860bf5ff644)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__64797b83c30ffab70d54d3b5883ad28ce292196ea37277039600e03445bc8283)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__baeb15c9c44c0324e07b8488897aa9b50f2fd0dfa4664711f6c94eb5a4c522fb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanOpacity]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanOpacity]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__26961b7ae634a9c875078862471705827263ebaa6890b9535024d3b6db1dfc15)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanOpacityOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanOpacityOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7b22c015be2ff9999b8cc2a1905468e0710f6e2405961c6a678b95aefa7e29d9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetOpacityVar")
    def reset_opacity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacityVar", []))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityVarInput")
    def opacity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacity"))

    @opacity.setter
    def opacity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4e921f8c15b14a7ef8397ea423316355901d4ea52aa602c6926f42d8075408bc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacity", value)

    @builtins.property
    @jsii.member(jsii_name="opacityVar")
    def opacity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacityVar"))

    @opacity_var.setter
    def opacity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__25fd4b7f109526e9a9deb2c2f980d0eaab2e68ad611b1b3c6e91e03ff26ff5dc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacityVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanOpacity]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanOpacity]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanOpacity]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5b989ee576f847a078209f1d71ae30af2d4da0bcbd41da99d7a38496f4293aa8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9aad4508b803d56f00c3aaa6e2d3180680f98748a7d1c5a2131431f9ced5902a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putBackgroundColor")
    def put_background_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__45e65623ebd454c9c9ece9db5ad96304a70d05f9101481d9362618d8f035462a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBackgroundColor", [value]))

    @jsii.member(jsii_name="putBlur")
    def put_blur(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanBlur, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0463a7555ebf1c63c2a4fb06e476e63fb4f8aa477a48f1a7c792d13299d307ac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBlur", [value]))

    @jsii.member(jsii_name="putChromaKey")
    def put_chroma_key(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanChromaKey, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3356064c2a32257cbe87b992230977571ca45cdb13c382eb9489b5c229d34ee6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putChromaKey", [value]))

    @jsii.member(jsii_name="putComposite")
    def put_composite(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanComposite, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0be9889688443e68cce9c6b511e1586e4ba763025a28d4dbc15ffe0dfeae47bf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putComposite", [value]))

    @jsii.member(jsii_name="putCompound")
    def put_compound(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompound, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2acf04298d507a5b62507d5e76d0f56467b112fb158fbfc23cd00ed616f95c3a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCompound", [value]))

    @jsii.member(jsii_name="putContrast")
    def put_contrast(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanContrast, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0bdbc492e436147610880b5ed028ec97be36e063a187cdd2e0429c9d310f1e0e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putContrast", [value]))

    @jsii.member(jsii_name="putGoop")
    def put_goop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanGoop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8e49309dbbf9950f81bc4886c1a6f0e10fb9ae984f863cf0ed468840a0f2a8e5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGoop", [value]))

    @jsii.member(jsii_name="putGrayscale")
    def put_grayscale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanGrayscale, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cf2959e29d51eb30e253b908c410c10483985cfbbbecf1daa20d44df6b71bfda)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGrayscale", [value]))

    @jsii.member(jsii_name="putHsl")
    def put_hsl(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanHsl, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__db842ac101aa684fc239941c511c150fc553e7ec4a74b819905e790e050bfb2a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsl", [value]))

    @jsii.member(jsii_name="putHsv")
    def put_hsv(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanHsv, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dfddb98edc3f5b5507b6838da670baa64687948aae1c8301b3262b34afd98eef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsv", [value]))

    @jsii.member(jsii_name="putIfDimension")
    def put_if_dimension(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimension, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ce77f262e15da71e5fbd8238c60a4766462c96465065060943eb4864322344e9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfDimension", [value]))

    @jsii.member(jsii_name="putIfOrientation")
    def put_if_orientation(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__350f39dabee97709d5f8eda7410bf8300157f3e9237f6caff06767adbe56b256)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfOrientation", [value]))

    @jsii.member(jsii_name="putMaxColors")
    def put_max_colors(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanMaxColors, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__586ed4fee44d45a316878abac0d59303b40a9296dc62f45a51ef410156a50707)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMaxColors", [value]))

    @jsii.member(jsii_name="putMirror")
    def put_mirror(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanMirror, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9f9d28fa4b6c2b7dd6173bcb6077b7b4a9dfacb5da7b0deba8daa011bf71c132)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMirror", [value]))

    @jsii.member(jsii_name="putMonoHue")
    def put_mono_hue(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanMonoHue, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__24e6216b02332575364b6969e603ac867095d877386044850ce36d95c5957413)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMonoHue", [value]))

    @jsii.member(jsii_name="putOpacity")
    def put_opacity(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanOpacity, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__51c95b897d90aac19193643bf7be0de142282c449bad49c2fecd4a26b14f7ab2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putOpacity", [value]))

    @jsii.member(jsii_name="putRemoveColor")
    def put_remove_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanRemoveColor", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0e2c171cbb7c1d40a6e525f861c80e56777936517e7fc98b88e2fe0fa1998ad8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRemoveColor", [value]))

    @jsii.member(jsii_name="putUnsharpMask")
    def put_unsharp_mask(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanUnsharpMask", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__21f8df5dad236946ae30fb90ba7676223c68c59b004248becd3d54eb3186a083)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putUnsharpMask", [value]))

    @jsii.member(jsii_name="resetBackgroundColor")
    def reset_background_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBackgroundColor", []))

    @jsii.member(jsii_name="resetBlur")
    def reset_blur(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBlur", []))

    @jsii.member(jsii_name="resetChromaKey")
    def reset_chroma_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChromaKey", []))

    @jsii.member(jsii_name="resetComposite")
    def reset_composite(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetComposite", []))

    @jsii.member(jsii_name="resetCompound")
    def reset_compound(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCompound", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetGoop")
    def reset_goop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGoop", []))

    @jsii.member(jsii_name="resetGrayscale")
    def reset_grayscale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGrayscale", []))

    @jsii.member(jsii_name="resetHsl")
    def reset_hsl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsl", []))

    @jsii.member(jsii_name="resetHsv")
    def reset_hsv(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsv", []))

    @jsii.member(jsii_name="resetIfDimension")
    def reset_if_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfDimension", []))

    @jsii.member(jsii_name="resetIfOrientation")
    def reset_if_orientation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfOrientation", []))

    @jsii.member(jsii_name="resetMaxColors")
    def reset_max_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxColors", []))

    @jsii.member(jsii_name="resetMirror")
    def reset_mirror(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMirror", []))

    @jsii.member(jsii_name="resetMonoHue")
    def reset_mono_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonoHue", []))

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetRemoveColor")
    def reset_remove_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRemoveColor", []))

    @jsii.member(jsii_name="resetUnsharpMask")
    def reset_unsharp_mask(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUnsharpMask", []))

    @builtins.property
    @jsii.member(jsii_name="backgroundColor")
    def background_color(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanBackgroundColorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanBackgroundColorList, jsii.get(self, "backgroundColor"))

    @builtins.property
    @jsii.member(jsii_name="blur")
    def blur(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanBlurList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanBlurList, jsii.get(self, "blur"))

    @builtins.property
    @jsii.member(jsii_name="chromaKey")
    def chroma_key(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanChromaKeyList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanChromaKeyList, jsii.get(self, "chromaKey"))

    @builtins.property
    @jsii.member(jsii_name="composite")
    def composite(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompositeList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompositeList, jsii.get(self, "composite"))

    @builtins.property
    @jsii.member(jsii_name="compound")
    def compound(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompoundList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompoundList, jsii.get(self, "compound"))

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanContrastList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanContrastList, jsii.get(self, "contrast"))

    @builtins.property
    @jsii.member(jsii_name="goop")
    def goop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanGoopList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanGoopList, jsii.get(self, "goop"))

    @builtins.property
    @jsii.member(jsii_name="grayscale")
    def grayscale(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanGrayscaleList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanGrayscaleList, jsii.get(self, "grayscale"))

    @builtins.property
    @jsii.member(jsii_name="hsl")
    def hsl(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanHslList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanHslList, jsii.get(self, "hsl"))

    @builtins.property
    @jsii.member(jsii_name="hsv")
    def hsv(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanHsvList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanHsvList, jsii.get(self, "hsv"))

    @builtins.property
    @jsii.member(jsii_name="ifDimension")
    def if_dimension(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionList, jsii.get(self, "ifDimension"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientation")
    def if_orientation(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationList, jsii.get(self, "ifOrientation"))

    @builtins.property
    @jsii.member(jsii_name="maxColors")
    def max_colors(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanMaxColorsList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanMaxColorsList, jsii.get(self, "maxColors"))

    @builtins.property
    @jsii.member(jsii_name="mirror")
    def mirror(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanMirrorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanMirrorList, jsii.get(self, "mirror"))

    @builtins.property
    @jsii.member(jsii_name="monoHue")
    def mono_hue(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanMonoHueList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanMonoHueList, jsii.get(self, "monoHue"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanOpacityList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanOpacityList, jsii.get(self, "opacity"))

    @builtins.property
    @jsii.member(jsii_name="removeColor")
    def remove_color(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanRemoveColorList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanRemoveColorList", jsii.get(self, "removeColor"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMask")
    def unsharp_mask(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanUnsharpMaskList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanUnsharpMaskList", jsii.get(self, "unsharpMask"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColorInput")
    def background_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanBackgroundColor]]], jsii.get(self, "backgroundColorInput"))

    @builtins.property
    @jsii.member(jsii_name="blurInput")
    def blur_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanBlur]]], jsii.get(self, "blurInput"))

    @builtins.property
    @jsii.member(jsii_name="chromaKeyInput")
    def chroma_key_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanChromaKey]]], jsii.get(self, "chromaKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="compositeInput")
    def composite_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanComposite]]], jsii.get(self, "compositeInput"))

    @builtins.property
    @jsii.member(jsii_name="compoundInput")
    def compound_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompound]]], jsii.get(self, "compoundInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanContrast]]], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="goopInput")
    def goop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanGoop]]], jsii.get(self, "goopInput"))

    @builtins.property
    @jsii.member(jsii_name="grayscaleInput")
    def grayscale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanGrayscale]]], jsii.get(self, "grayscaleInput"))

    @builtins.property
    @jsii.member(jsii_name="hslInput")
    def hsl_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanHsl]]], jsii.get(self, "hslInput"))

    @builtins.property
    @jsii.member(jsii_name="hsvInput")
    def hsv_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanHsv]]], jsii.get(self, "hsvInput"))

    @builtins.property
    @jsii.member(jsii_name="ifDimensionInput")
    def if_dimension_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimension]]], jsii.get(self, "ifDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientationInput")
    def if_orientation_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientation]]], jsii.get(self, "ifOrientationInput"))

    @builtins.property
    @jsii.member(jsii_name="maxColorsInput")
    def max_colors_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanMaxColors]]], jsii.get(self, "maxColorsInput"))

    @builtins.property
    @jsii.member(jsii_name="mirrorInput")
    def mirror_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanMirror]]], jsii.get(self, "mirrorInput"))

    @builtins.property
    @jsii.member(jsii_name="monoHueInput")
    def mono_hue_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanMonoHue]]], jsii.get(self, "monoHueInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanOpacity]]], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="removeColorInput")
    def remove_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanRemoveColor"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanRemoveColor"]]], jsii.get(self, "removeColorInput"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMaskInput")
    def unsharp_mask_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanUnsharpMask"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanUnsharpMask"]]], jsii.get(self, "unsharpMaskInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__62bfffafdc09c912fa64e036f59ceb2f0459290392e163654738fddd0af48bc2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanRemoveColor",
    jsii_struct_bases=[],
    name_mapping={
        "color": "color",
        "color_var": "colorVar",
        "feather": "feather",
        "feather_var": "featherVar",
        "tolerance": "tolerance",
        "tolerance_var": "toleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanRemoveColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
        feather: typing.Optional[builtins.str] = None,
        feather_var: typing.Optional[builtins.str] = None,
        tolerance: typing.Optional[builtins.str] = None,
        tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        :param feather: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        :param feather_var: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        :param tolerance: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        :param tolerance_var: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c344e30f9760864441e9a11c88f14aca8b66086eddab337e6750f8e53e5320bd)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
            check_type(argname="argument feather", value=feather, expected_type=type_hints["feather"])
            check_type(argname="argument feather_var", value=feather_var, expected_type=type_hints["feather_var"])
            check_type(argname="argument tolerance", value=tolerance, expected_type=type_hints["tolerance"])
            check_type(argname="argument tolerance_var", value=tolerance_var, expected_type=type_hints["tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var
        if feather is not None:
            self._values["feather"] = feather
        if feather_var is not None:
            self._values["feather_var"] = feather_var
        if tolerance is not None:
            self._values["tolerance"] = tolerance
        if tolerance_var is not None:
            self._values["tolerance_var"] = tolerance_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        '''
        result = self._values.get("feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather_var(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        '''
        result = self._values.get("feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        '''
        result = self._values.get("tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance_var(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        result = self._values.get("tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanRemoveColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanRemoveColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanRemoveColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__536c1789415997c8820d2b4e1abe2261fbad02352ae2f97a0e38c1ba2d6be03f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanRemoveColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7958e7dbe3525f4bec4f4a1d45a991e0d13c73310abc106b59036ffb98de24e8)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanRemoveColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8cacbbd2c69f035b4deb41f1770dca4d17bddb9a223fe740e7f056fdb5aa548a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__47978ee455d5fdd4cb2feedbbdec056411258470f261cdf2e07c01108cf9b45b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b8d86f399b98b84516fc547a5b68a6a3f4b9c7bc912be66ea972b5732ce09b64)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanRemoveColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanRemoveColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanRemoveColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__91cd94c488110c09f1046851af331be4ac05001fe29a6822352082aa848c0839)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanRemoveColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanRemoveColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7471d42281117c0b05af1a68fbd85060042b1e9dd1ba01f650209cf0e82be669)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @jsii.member(jsii_name="resetFeather")
    def reset_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeather", []))

    @jsii.member(jsii_name="resetFeatherVar")
    def reset_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatherVar", []))

    @jsii.member(jsii_name="resetTolerance")
    def reset_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTolerance", []))

    @jsii.member(jsii_name="resetToleranceVar")
    def reset_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featherInput")
    def feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherInput"))

    @builtins.property
    @jsii.member(jsii_name="featherVarInput")
    def feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceInput")
    def tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceVarInput")
    def tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ce85f242c7dbebc0d86269c50e5828d91e763ae9dfb78ffb28fdf3bd4c572fba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__46d0385fd31418cce7f865248674ad3d9bc670152be9bbceadcb7c423b39fe24)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="feather")
    def feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "feather"))

    @feather.setter
    def feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fdf3d8131a84b4d50ef69aa0d22213ceb46b215237b836e4729ff7e07d9f5142)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "feather", value)

    @builtins.property
    @jsii.member(jsii_name="featherVar")
    def feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featherVar"))

    @feather_var.setter
    def feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a40eb07916cec7ee52a9f0b7c76e4c7abea015b74caa78b5b59fa41afc8db24)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featherVar", value)

    @builtins.property
    @jsii.member(jsii_name="tolerance")
    def tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tolerance"))

    @tolerance.setter
    def tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d59d27c58ce69598d46632c3568468a149339c697a680cf041bbb00123d98079)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tolerance", value)

    @builtins.property
    @jsii.member(jsii_name="toleranceVar")
    def tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "toleranceVar"))

    @tolerance_var.setter
    def tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__30875814c87e54d7ba11ebb89f37e5ef4a9457ef73e90c25390e82896d5cb7c2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "toleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanRemoveColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanRemoveColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanRemoveColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__793faef9ac98e656387f8b11b46125032099216c93ea3ee2dbeafd82e1c78fbe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanUnsharpMask",
    jsii_struct_bases=[],
    name_mapping={
        "gain": "gain",
        "gain_var": "gainVar",
        "sigma": "sigma",
        "sigma_var": "sigmaVar",
        "threshold": "threshold",
        "threshold_var": "thresholdVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanUnsharpMask:
    def __init__(
        self,
        *,
        gain: typing.Optional[builtins.str] = None,
        gain_var: typing.Optional[builtins.str] = None,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
        threshold: typing.Optional[builtins.str] = None,
        threshold_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param gain: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        :param gain_var: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        :param sigma: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        :param threshold: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        :param threshold_var: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__93e2a1b9599b0fa52e8e86e4b87bf713615f46860cfbed276c72a79e45759a88)
            check_type(argname="argument gain", value=gain, expected_type=type_hints["gain"])
            check_type(argname="argument gain_var", value=gain_var, expected_type=type_hints["gain_var"])
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
            check_type(argname="argument threshold", value=threshold, expected_type=type_hints["threshold"])
            check_type(argname="argument threshold_var", value=threshold_var, expected_type=type_hints["threshold_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if gain is not None:
            self._values["gain"] = gain
        if gain_var is not None:
            self._values["gain_var"] = gain_var
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var
        if threshold is not None:
            self._values["threshold"] = threshold
        if threshold_var is not None:
            self._values["threshold_var"] = threshold_var

    @builtins.property
    def gain(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        '''
        result = self._values.get("gain")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gain_var(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        '''
        result = self._values.get("gain_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        '''
        result = self._values.get("threshold")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold_var(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        result = self._values.get("threshold_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanUnsharpMask(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanUnsharpMaskList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanUnsharpMaskList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4655406c9e843dde15012c29bb75deaf2d0d422bd6a09335ddc68196fe1ce6d2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanUnsharpMaskOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b9d19052d974031c07ffa02ead13c4003785de894561f9837c7a760e3b38f74a)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanUnsharpMaskOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__78ff823e7068b38df9924f25dbddfbe6ed02fb4edd0f19f02b1931e6b691b991)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c5fb396e648575257852e7ec65ef8ceb96b37672094fdcf96ebf295cdad7d1b3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__47669a300f2df18e0343a4bf7541d2290078ac0965b6fd31ce967f988966336e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanUnsharpMask]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanUnsharpMask]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanUnsharpMask]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e3071fe0b7f3b00ac2f704f2cb487d1de9356ea4650e26b5658bc5aed64c04e5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanUnsharpMaskOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanUnsharpMaskOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__04cf92720012241d4e858d49ba4d8a43d3f4a10c1844c1b4b6c13e111fbb313e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetGain")
    def reset_gain(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGain", []))

    @jsii.member(jsii_name="resetGainVar")
    def reset_gain_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGainVar", []))

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @jsii.member(jsii_name="resetThreshold")
    def reset_threshold(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThreshold", []))

    @jsii.member(jsii_name="resetThresholdVar")
    def reset_threshold_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThresholdVar", []))

    @builtins.property
    @jsii.member(jsii_name="gainInput")
    def gain_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainInput"))

    @builtins.property
    @jsii.member(jsii_name="gainVarInput")
    def gain_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdInput")
    def threshold_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdVarInput")
    def threshold_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gain")
    def gain(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gain"))

    @gain.setter
    def gain(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2c246a32f7ec2337a31efa82d2959b452ca1e12451473bc42e984e8830d7967f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gain", value)

    @builtins.property
    @jsii.member(jsii_name="gainVar")
    def gain_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gainVar"))

    @gain_var.setter
    def gain_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__62239f549c7b8f5cf135b35b38fa858fb45c2103f43db9e5a04d2485cb3d156c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gainVar", value)

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ce895000384f9a1e1c5b3e9382aabb22f34f0d0f00082c9a0f831fc55603946e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__46ddb291765a851b29752e8707602ca07064d60f33285b7438feefb506fb2efe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="threshold")
    def threshold(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "threshold"))

    @threshold.setter
    def threshold(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3f246403fb58f0353f6c1a85b4043eea1904300f477320657b1310be016167ac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "threshold", value)

    @builtins.property
    @jsii.member(jsii_name="thresholdVar")
    def threshold_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "thresholdVar"))

    @threshold_var.setter
    def threshold_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ca979c43e8c9268bd78d27b695af049a7c811f956df992e981814a8f95bf181)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "thresholdVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanUnsharpMask]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanUnsharpMask]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanUnsharpMask]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a7ad58a1bb033bc53b5bbc67717f0fb4e6b9b3d4f84478b9a6b672e9c675db5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThan",
    jsii_struct_bases=[],
    name_mapping={
        "background_color": "backgroundColor",
        "blur": "blur",
        "chroma_key": "chromaKey",
        "composite": "composite",
        "compound": "compound",
        "contrast": "contrast",
        "goop": "goop",
        "grayscale": "grayscale",
        "hsl": "hsl",
        "hsv": "hsv",
        "if_dimension": "ifDimension",
        "if_orientation": "ifOrientation",
        "max_colors": "maxColors",
        "mirror": "mirror",
        "mono_hue": "monoHue",
        "opacity": "opacity",
        "remove_color": "removeColor",
        "unsharp_mask": "unsharpMask",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThan:
    def __init__(
        self,
        *,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanBackgroundColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanBlur", typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanChromaKey", typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanComposite", typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanCompound", typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanContrast", typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanGoop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanGrayscale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanHsl", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanHsv", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimension", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientation", typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanMaxColors", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanMirror", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanMonoHue", typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanOpacity", typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanRemoveColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanUnsharpMask", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__913e41e98ca6dcd47a1c43651d489ad5d1d2f0ab7c63045b6de050fc3729c3ae)
            check_type(argname="argument background_color", value=background_color, expected_type=type_hints["background_color"])
            check_type(argname="argument blur", value=blur, expected_type=type_hints["blur"])
            check_type(argname="argument chroma_key", value=chroma_key, expected_type=type_hints["chroma_key"])
            check_type(argname="argument composite", value=composite, expected_type=type_hints["composite"])
            check_type(argname="argument compound", value=compound, expected_type=type_hints["compound"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument goop", value=goop, expected_type=type_hints["goop"])
            check_type(argname="argument grayscale", value=grayscale, expected_type=type_hints["grayscale"])
            check_type(argname="argument hsl", value=hsl, expected_type=type_hints["hsl"])
            check_type(argname="argument hsv", value=hsv, expected_type=type_hints["hsv"])
            check_type(argname="argument if_dimension", value=if_dimension, expected_type=type_hints["if_dimension"])
            check_type(argname="argument if_orientation", value=if_orientation, expected_type=type_hints["if_orientation"])
            check_type(argname="argument max_colors", value=max_colors, expected_type=type_hints["max_colors"])
            check_type(argname="argument mirror", value=mirror, expected_type=type_hints["mirror"])
            check_type(argname="argument mono_hue", value=mono_hue, expected_type=type_hints["mono_hue"])
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument remove_color", value=remove_color, expected_type=type_hints["remove_color"])
            check_type(argname="argument unsharp_mask", value=unsharp_mask, expected_type=type_hints["unsharp_mask"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if background_color is not None:
            self._values["background_color"] = background_color
        if blur is not None:
            self._values["blur"] = blur
        if chroma_key is not None:
            self._values["chroma_key"] = chroma_key
        if composite is not None:
            self._values["composite"] = composite
        if compound is not None:
            self._values["compound"] = compound
        if contrast is not None:
            self._values["contrast"] = contrast
        if goop is not None:
            self._values["goop"] = goop
        if grayscale is not None:
            self._values["grayscale"] = grayscale
        if hsl is not None:
            self._values["hsl"] = hsl
        if hsv is not None:
            self._values["hsv"] = hsv
        if if_dimension is not None:
            self._values["if_dimension"] = if_dimension
        if if_orientation is not None:
            self._values["if_orientation"] = if_orientation
        if max_colors is not None:
            self._values["max_colors"] = max_colors
        if mirror is not None:
            self._values["mirror"] = mirror
        if mono_hue is not None:
            self._values["mono_hue"] = mono_hue
        if opacity is not None:
            self._values["opacity"] = opacity
        if remove_color is not None:
            self._values["remove_color"] = remove_color
        if unsharp_mask is not None:
            self._values["unsharp_mask"] = unsharp_mask

    @builtins.property
    def background_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanBackgroundColor"]]]:
        '''background_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        '''
        result = self._values.get("background_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanBackgroundColor"]]], result)

    @builtins.property
    def blur(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanBlur"]]]:
        '''blur block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        '''
        result = self._values.get("blur")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanBlur"]]], result)

    @builtins.property
    def chroma_key(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanChromaKey"]]]:
        '''chroma_key block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        '''
        result = self._values.get("chroma_key")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanChromaKey"]]], result)

    @builtins.property
    def composite(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanComposite"]]]:
        '''composite block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        '''
        result = self._values.get("composite")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanComposite"]]], result)

    @builtins.property
    def compound(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanCompound"]]]:
        '''compound block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        '''
        result = self._values.get("compound")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanCompound"]]], result)

    @builtins.property
    def contrast(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanContrast"]]]:
        '''contrast block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanContrast"]]], result)

    @builtins.property
    def goop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanGoop"]]]:
        '''goop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        '''
        result = self._values.get("goop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanGoop"]]], result)

    @builtins.property
    def grayscale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanGrayscale"]]]:
        '''grayscale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        '''
        result = self._values.get("grayscale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanGrayscale"]]], result)

    @builtins.property
    def hsl(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanHsl"]]]:
        '''hsl block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        '''
        result = self._values.get("hsl")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanHsl"]]], result)

    @builtins.property
    def hsv(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanHsv"]]]:
        '''hsv block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        '''
        result = self._values.get("hsv")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanHsv"]]], result)

    @builtins.property
    def if_dimension(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimension"]]]:
        '''if_dimension block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        '''
        result = self._values.get("if_dimension")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimension"]]], result)

    @builtins.property
    def if_orientation(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientation"]]]:
        '''if_orientation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        '''
        result = self._values.get("if_orientation")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientation"]]], result)

    @builtins.property
    def max_colors(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanMaxColors"]]]:
        '''max_colors block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        '''
        result = self._values.get("max_colors")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanMaxColors"]]], result)

    @builtins.property
    def mirror(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanMirror"]]]:
        '''mirror block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        '''
        result = self._values.get("mirror")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanMirror"]]], result)

    @builtins.property
    def mono_hue(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanMonoHue"]]]:
        '''mono_hue block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        '''
        result = self._values.get("mono_hue")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanMonoHue"]]], result)

    @builtins.property
    def opacity(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanOpacity"]]]:
        '''opacity block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanOpacity"]]], result)

    @builtins.property
    def remove_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanRemoveColor"]]]:
        '''remove_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        '''
        result = self._values.get("remove_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanRemoveColor"]]], result)

    @builtins.property
    def unsharp_mask(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanUnsharpMask"]]]:
        '''unsharp_mask block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        result = self._values.get("unsharp_mask")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanUnsharpMask"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanBackgroundColor",
    jsii_struct_bases=[],
    name_mapping={"color": "color", "color_var": "colorVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanBackgroundColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__322fc16059a748e9ded1a1e89e6983d04d5670107565515ecfdf36e5fd97185e)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanBackgroundColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanBackgroundColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanBackgroundColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1bab3e4a81934b2272af14d1473f647081ac89c9c169fb300526581800ca2e3d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanBackgroundColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__485aa88d16ef0948a5cbbf8b0147483cce44d2839c936bc480e6164ecc9edbe0)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanBackgroundColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa1c2c84a54bdbdc9cfac650be18dfbfdb677b6dcd9b71171f8ad7996aef9c62)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dc7a0fa000c29669ded860414c138ef306949a7d55c93d067daf9804c459e91d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d81d82090b20dddb4ab9db65b43c49d3bc75df863f69e3dfcee76d54266ad643)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanBackgroundColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanBackgroundColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cc4d1ab461fb6f61439604096d8715e5183bb3285b43a42ac0c844042205329c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanBackgroundColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanBackgroundColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__91f7f0d900ac6e1e961bef94d2ca09aa12d42b0c25391ff77f2e0fd59ab587c6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__152ac4c50e04022a818f6577c7c9333806c6914be7d80c1f5278ee13edaaa6c8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__18a178974dfeefaabc0b28cb6ffc90a834b2ce27ddd5b902e41515de91b363ec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanBackgroundColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanBackgroundColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanBackgroundColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f5bd08b5ee05170ed452565c6ac4bed62511657775ba34cffa8afa8c0742937)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanBlur",
    jsii_struct_bases=[],
    name_mapping={"sigma": "sigma", "sigma_var": "sigmaVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanBlur:
    def __init__(
        self,
        *,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param sigma: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6bf932ed17d2b5c1957cecae6d6dd957ebff7c4f155d57209e486d02105aea92)
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanBlur(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanBlurList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanBlurList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cb67226526ad328326a19482d80a279a52866a0cb93a0d6cfde7db9961f8a6a0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanBlurOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8ee5ca295f61c66eb80286c9a02d53f580d05926d79631617516a8a0336fdabe)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanBlurOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fb59258592f280df6eeb1b5a9c8e5f4414506c084687a49ef5b74130c18de9e1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d46589259137a0eea731385e503699c51211f5b9fb971cb2299737a48ef61a07)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e8ca54cd3b27c00855b26c49a571a7ee4f0aae9ac159848bc64dcdfc69bc3308)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanBlur]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanBlur]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4da8d28dc370e839b8a99b392618d6243f1958e7911ef4c22bd07ecf3aea5446)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanBlurOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanBlurOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5510a7d85c19e3d407039582144d3559d7fff4f42eabc56dde2270ae3a830fa7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__38a874503b084f9018015491a16978e5283db1bb323e86aed63d8d7ecf29e94f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4474cd792560623ecc021ed01aaa80173795a8211ef5a57e161ffedb98707e65)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanBlur]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanBlur]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanBlur]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e16d8a7cc915835f4a25e9b4ada15243d58261f33b1841139ba4aed634facf9a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanChromaKey",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_feather": "hueFeather",
        "hue_feather_var": "hueFeatherVar",
        "hue_tolerance": "hueTolerance",
        "hue_tolerance_var": "hueToleranceVar",
        "hue_var": "hueVar",
        "lightness_feather": "lightnessFeather",
        "lightness_feather_var": "lightnessFeatherVar",
        "lightness_tolerance": "lightnessTolerance",
        "lightness_tolerance_var": "lightnessToleranceVar",
        "saturation_feather": "saturationFeather",
        "saturation_feather_var": "saturationFeatherVar",
        "saturation_tolerance": "saturationTolerance",
        "saturation_tolerance_var": "saturationToleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanChromaKey:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_feather: typing.Optional[builtins.str] = None,
        hue_feather_var: typing.Optional[builtins.str] = None,
        hue_tolerance: typing.Optional[builtins.str] = None,
        hue_tolerance_var: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness_feather: typing.Optional[builtins.str] = None,
        lightness_feather_var: typing.Optional[builtins.str] = None,
        lightness_tolerance: typing.Optional[builtins.str] = None,
        lightness_tolerance_var: typing.Optional[builtins.str] = None,
        saturation_feather: typing.Optional[builtins.str] = None,
        saturation_feather_var: typing.Optional[builtins.str] = None,
        saturation_tolerance: typing.Optional[builtins.str] = None,
        saturation_tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_feather: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        :param hue_feather_var: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        :param hue_tolerance: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        :param hue_tolerance_var: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        :param hue_var: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness_feather: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        :param lightness_feather_var: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        :param lightness_tolerance: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        :param lightness_tolerance_var: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        :param saturation_feather: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        :param saturation_feather_var: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        :param saturation_tolerance: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        :param saturation_tolerance_var: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb4c763e48db8c0da89ccee58d4da629b49c1331dac812e699a2a10bf492bd67)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_feather", value=hue_feather, expected_type=type_hints["hue_feather"])
            check_type(argname="argument hue_feather_var", value=hue_feather_var, expected_type=type_hints["hue_feather_var"])
            check_type(argname="argument hue_tolerance", value=hue_tolerance, expected_type=type_hints["hue_tolerance"])
            check_type(argname="argument hue_tolerance_var", value=hue_tolerance_var, expected_type=type_hints["hue_tolerance_var"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness_feather", value=lightness_feather, expected_type=type_hints["lightness_feather"])
            check_type(argname="argument lightness_feather_var", value=lightness_feather_var, expected_type=type_hints["lightness_feather_var"])
            check_type(argname="argument lightness_tolerance", value=lightness_tolerance, expected_type=type_hints["lightness_tolerance"])
            check_type(argname="argument lightness_tolerance_var", value=lightness_tolerance_var, expected_type=type_hints["lightness_tolerance_var"])
            check_type(argname="argument saturation_feather", value=saturation_feather, expected_type=type_hints["saturation_feather"])
            check_type(argname="argument saturation_feather_var", value=saturation_feather_var, expected_type=type_hints["saturation_feather_var"])
            check_type(argname="argument saturation_tolerance", value=saturation_tolerance, expected_type=type_hints["saturation_tolerance"])
            check_type(argname="argument saturation_tolerance_var", value=saturation_tolerance_var, expected_type=type_hints["saturation_tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_feather is not None:
            self._values["hue_feather"] = hue_feather
        if hue_feather_var is not None:
            self._values["hue_feather_var"] = hue_feather_var
        if hue_tolerance is not None:
            self._values["hue_tolerance"] = hue_tolerance
        if hue_tolerance_var is not None:
            self._values["hue_tolerance_var"] = hue_tolerance_var
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness_feather is not None:
            self._values["lightness_feather"] = lightness_feather
        if lightness_feather_var is not None:
            self._values["lightness_feather_var"] = lightness_feather_var
        if lightness_tolerance is not None:
            self._values["lightness_tolerance"] = lightness_tolerance
        if lightness_tolerance_var is not None:
            self._values["lightness_tolerance_var"] = lightness_tolerance_var
        if saturation_feather is not None:
            self._values["saturation_feather"] = saturation_feather
        if saturation_feather_var is not None:
            self._values["saturation_feather_var"] = saturation_feather_var
        if saturation_tolerance is not None:
            self._values["saturation_tolerance"] = saturation_tolerance
        if saturation_tolerance_var is not None:
            self._values["saturation_tolerance_var"] = saturation_tolerance_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        '''
        result = self._values.get("hue_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        '''
        result = self._values.get("hue_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        '''
        result = self._values.get("hue_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        '''
        result = self._values.get("hue_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        '''
        result = self._values.get("lightness_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        '''
        result = self._values.get("lightness_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        '''
        result = self._values.get("lightness_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        '''
        result = self._values.get("lightness_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        '''
        result = self._values.get("saturation_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        '''
        result = self._values.get("saturation_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        '''
        result = self._values.get("saturation_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        result = self._values.get("saturation_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanChromaKey(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanChromaKeyList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanChromaKeyList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dfbd150c7634f9ea19b2ace670554d12d20c41d71285736a33ca57810400ffbb)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanChromaKeyOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bf485a5311e6d5c555bfc200027c4b843d46f7136e7468a7f26e339eabf66d8e)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanChromaKeyOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6376e45bbbaa4703ab9cd0be65d4d50ac95fd08bd5ad466d40129cd7c0617061)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b3a3188bdc2dd6969ab6e275c97b1fefc85c78efbc0a42af158b8c49b3c4002f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7064175a9614208f4bb89981c66db1424b68ed4f492523fbc3fad17729f3c9ab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanChromaKey]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanChromaKey]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__05ea33e8fc243e230fc6f0b5bec6c71c7fc8a20d73dabce2617205dbd8ffb64c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanChromaKeyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanChromaKeyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f4079c3e439b7015ad3771fc1f8fb7f8ba077adddf02399a97054fd44e19321)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueFeather")
    def reset_hue_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeather", []))

    @jsii.member(jsii_name="resetHueFeatherVar")
    def reset_hue_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeatherVar", []))

    @jsii.member(jsii_name="resetHueTolerance")
    def reset_hue_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueTolerance", []))

    @jsii.member(jsii_name="resetHueToleranceVar")
    def reset_hue_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueToleranceVar", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightnessFeather")
    def reset_lightness_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeather", []))

    @jsii.member(jsii_name="resetLightnessFeatherVar")
    def reset_lightness_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeatherVar", []))

    @jsii.member(jsii_name="resetLightnessTolerance")
    def reset_lightness_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessTolerance", []))

    @jsii.member(jsii_name="resetLightnessToleranceVar")
    def reset_lightness_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessToleranceVar", []))

    @jsii.member(jsii_name="resetSaturationFeather")
    def reset_saturation_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeather", []))

    @jsii.member(jsii_name="resetSaturationFeatherVar")
    def reset_saturation_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeatherVar", []))

    @jsii.member(jsii_name="resetSaturationTolerance")
    def reset_saturation_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationTolerance", []))

    @jsii.member(jsii_name="resetSaturationToleranceVar")
    def reset_saturation_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherInput")
    def hue_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVarInput")
    def hue_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceInput")
    def hue_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVarInput")
    def hue_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherInput")
    def lightness_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVarInput")
    def lightness_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceInput")
    def lightness_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVarInput")
    def lightness_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherInput")
    def saturation_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVarInput")
    def saturation_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceInput")
    def saturation_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVarInput")
    def saturation_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__74c41b7c1e6e9f1df2d8a8bf0d5e37e3a405adf3a535da2acdf7b000d4a7efde)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeather")
    def hue_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeather"))

    @hue_feather.setter
    def hue_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fcee8f9cb21f53840ce9020411919efe33eef394ee2b8e3bb98adfbb83e90ff3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeather", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVar")
    def hue_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeatherVar"))

    @hue_feather_var.setter
    def hue_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8145d7c1e2ae959f3b097243f1352244243c7f08ce5ae7b4a4320980b4eb7427)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueTolerance")
    def hue_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueTolerance"))

    @hue_tolerance.setter
    def hue_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d4a30df95f6cd0862df98055f7dea0d4e8c9e93019017b1221b333d49862f8f8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVar")
    def hue_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueToleranceVar"))

    @hue_tolerance_var.setter
    def hue_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__86322952edb0da905c2a6d0be9acb21e7446047ad5d2a115872a2b11b3539479)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f76ea858f541ef66eeb32a33ddc865b847e941502d465ed1efaaa43476a99b10)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeather")
    def lightness_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeather"))

    @lightness_feather.setter
    def lightness_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cf8b9626f2e22ad16d69dfce8f00d72b48bcd36fd67c826e874ed3d6dbc0188f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeather", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVar")
    def lightness_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeatherVar"))

    @lightness_feather_var.setter
    def lightness_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a4b3cdc61cba06c163f24856ab0d5936d28c4f2816ed7f9b1dc42050f78339f0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessTolerance")
    def lightness_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessTolerance"))

    @lightness_tolerance.setter
    def lightness_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8da67f7c67fec49d162371edb51f9e737e8be48ecd0497566ee811a831f065c5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVar")
    def lightness_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessToleranceVar"))

    @lightness_tolerance_var.setter
    def lightness_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3cbfcef9aca98c93f604fa508e3ceb7a3fbbce928f9b394d762ff3daa821ff5a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeather")
    def saturation_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeather"))

    @saturation_feather.setter
    def saturation_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1b8e21a18f3cb18469946ed4dcdaf5f409f2d2da8dcb7905bb7d17d45681a984)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeather", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVar")
    def saturation_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeatherVar"))

    @saturation_feather_var.setter
    def saturation_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af4f097e6dc3dcebdf58b5b97fbc69b94dd8f97032900becc796c4cd4a8d80b8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationTolerance")
    def saturation_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationTolerance"))

    @saturation_tolerance.setter
    def saturation_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__963c7c23b09c6cd06ce3f1ee1f7fe6d7e36bf7f797136ede95ba01869ddea44f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVar")
    def saturation_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationToleranceVar"))

    @saturation_tolerance_var.setter
    def saturation_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b7c5cc569eca460a6d708533ec806225e4c7e2c1f1cce23d239f845b2b3aeee9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanChromaKey]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanChromaKey]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanChromaKey]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__063e188a73f6e1a1e5045b53717621c2cc201ab935323cdde595401a41be0a7c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanComposite",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "placement": "placement",
        "placement_var": "placementVar",
        "scale": "scale",
        "scale_dimension": "scaleDimension",
        "scale_dimension_var": "scaleDimensionVar",
        "scale_var": "scaleVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanComposite:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanCompositeImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        placement: typing.Optional[builtins.str] = None,
        placement_var: typing.Optional[builtins.str] = None,
        scale: typing.Optional[builtins.str] = None,
        scale_dimension: typing.Optional[builtins.str] = None,
        scale_dimension_var: typing.Optional[builtins.str] = None,
        scale_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param placement: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        :param placement_var: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        :param scale: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param scale_dimension: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        :param scale_dimension_var: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        :param scale_var: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        :param x_position: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanCompositeImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d87fbf63418843478d7a79042c70ed7069c9b4b4a3e08f9b15301ec6a4bb393)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument placement", value=placement, expected_type=type_hints["placement"])
            check_type(argname="argument placement_var", value=placement_var, expected_type=type_hints["placement_var"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument scale_dimension", value=scale_dimension, expected_type=type_hints["scale_dimension"])
            check_type(argname="argument scale_dimension_var", value=scale_dimension_var, expected_type=type_hints["scale_dimension_var"])
            check_type(argname="argument scale_var", value=scale_var, expected_type=type_hints["scale_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if placement is not None:
            self._values["placement"] = placement
        if placement_var is not None:
            self._values["placement_var"] = placement_var
        if scale is not None:
            self._values["scale"] = scale
        if scale_dimension is not None:
            self._values["scale_dimension"] = scale_dimension
        if scale_dimension_var is not None:
            self._values["scale_dimension_var"] = scale_dimension_var
        if scale_var is not None:
            self._values["scale_var"] = scale_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanCompositeImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanCompositeImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        '''
        result = self._values.get("placement")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement_var(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        '''
        result = self._values.get("placement_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        '''
        result = self._values.get("scale_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        '''
        result = self._values.get("scale_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        '''
        result = self._values.get("scale_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanComposite(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanCompositeImage",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanCompositeImage:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanCompositeImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanCompositeImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanCompositeImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1e36bd98525b9046777f6cbce9c7027b51014938b3259a657bdcd4dea50d584b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanCompositeImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanCompositeImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c4b3bc270877ae8c703a55330e61afdcf2e43ba29ec1d4feacb7c5f75ccdf7b5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanCompositeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanCompositeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0bdb8265c86e2c860e2b4b51914cd1ca1ac6a9091a256e409d91e606d7cd99e9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanCompositeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__16267bca95d901e10e70002a06535227a054b15f87b6b446ca18ad767eb0cae3)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanCompositeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__05a35efb6be00a4de37351a638b248d5d60a3030a2ed6818439164b9576e6f83)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cbd6680cb63355da7448f65d5d6b4973cd877872be04ed2d6d8a5ad6bf999221)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ac64272834d18a350ed7d1f7ef196589be710c63c13319310abc231e0599803)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanComposite]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanComposite]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__554baf26a9d2331b3aa8b35d1d64859a2b3482b148a22fcbe2b3aca827d74855)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanCompositeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanCompositeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__23a010266ace8034da7128b6c31927075e2cc382228510e9c6e43f4efb516cf9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanCompositeImage()

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPlacement")
    def reset_placement(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacement", []))

    @jsii.member(jsii_name="resetPlacementVar")
    def reset_placement_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacementVar", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetScaleDimension")
    def reset_scale_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimension", []))

    @jsii.member(jsii_name="resetScaleDimensionVar")
    def reset_scale_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimensionVar", []))

    @jsii.member(jsii_name="resetScaleVar")
    def reset_scale_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanCompositeImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanCompositeImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanCompositeImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="placementInput")
    def placement_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementInput"))

    @builtins.property
    @jsii.member(jsii_name="placementVarInput")
    def placement_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionInput")
    def scale_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVarInput")
    def scale_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleVarInput")
    def scale_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b5f90a9fbe3909771c7d64d3c029636b169a7d6e4d9b0a9bd145dd49f176b8b3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bf02395356e62658a12951865f26741c56ffb3fddf491b36c3aa47e94c857552)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="placement")
    def placement(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placement"))

    @placement.setter
    def placement(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3c5ccd9a111b3a09dde19c256105b17bd6864742215650e06640c269bfaaec11)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placement", value)

    @builtins.property
    @jsii.member(jsii_name="placementVar")
    def placement_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placementVar"))

    @placement_var.setter
    def placement_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6c3b8eb271eaeba379c42517f48674ad6ae20a7d384454fee8d7133b9e0198f8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placementVar", value)

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scale"))

    @scale.setter
    def scale(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e8745666113da0298b5ad609ce56eb146ed2a96cd97bd70f58beb6084c4204b3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scale", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimension")
    def scale_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimension"))

    @scale_dimension.setter
    def scale_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__46ee8daece4a0a750bf3d5853951b18a81aebe48690977ee2d364772400e447c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimension", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVar")
    def scale_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimensionVar"))

    @scale_dimension_var.setter
    def scale_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bd97f5f6bfe2591def442aaaf1db267140bf81de77da22036d1ab5e2a99b5b8a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="scaleVar")
    def scale_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleVar"))

    @scale_var.setter
    def scale_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5921d3a83a049f26bbdc5a5ced2d4f3451946cff32479312629210269dee5ece)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4456f8f9206fbcbd1ed1ecbee8c1f0117d05386e97b8640caf302762906a20eb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3c6bb197b4db9a2e083a71e7a6a45bca43a62a1cd70a454d17e9f9d8d31f18fe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5a336ca78b6e78f283fb2ab7b45c2b0f156b0a9f635f87fa5c78a095daf18af8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__44561ed273ee353fd2d3cd824849e16eddbee1d1c9f015542336ce1519c6bbfc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanComposite]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanComposite]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanComposite]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__10ba7628fcc8946acb458830ffeaf85bfbfdd2d77cab19a58aa1a1f32c1cec5e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanCompound",
    jsii_struct_bases=[],
    name_mapping={"transformations": "transformations"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanCompound:
    def __init__(
        self,
        *,
        transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param transformations: transformations block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1595f921bbd98d9821fa107e8744c04a359748394adccd61d5254615fcc707c8)
            check_type(argname="argument transformations", value=transformations, expected_type=type_hints["transformations"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if transformations is not None:
            self._values["transformations"] = transformations

    @builtins.property
    def transformations(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanCompoundTransformations"]]]:
        '''transformations block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        result = self._values.get("transformations")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanCompoundTransformations"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanCompound(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanCompoundList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanCompoundList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7368a154be4afec7535a66fd50e32f6badfc9d96539c815753b4b9ecc0b2d69d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanCompoundOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a1eb75b793b04b46c16adabe55787c5b1f4ee5161fd5dec592a096ed03ff5eff)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanCompoundOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__91a01655fa73f546513a7fac773610fa6dcc689f52afa3e9b16a16a8ae306f4b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__43e61f48311f043bf0e3ce19684288144bd598d1914bc06be5a93b6666cac1bf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e429d6c1499884fbbf4d8cc2cf6e82faf00bf4d064e7019a95479cce44d60a78)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanCompound]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanCompound]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f597a38ea8ee9d84e38331061cfd374b8ea3513cdfa96671a10259c6ba7e3e48)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanCompoundOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanCompoundOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__674b26a94f6378f7a0081d668ee814f18882ef44d662bae0d7a788415ac63441)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformations")
    def put_transformations(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e8f5d16b465fbce4e7b670f6500789213b360d21ec29f2baf59bd838d25e285b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTransformations", [value]))

    @jsii.member(jsii_name="resetTransformations")
    def reset_transformations(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformations", []))

    @builtins.property
    @jsii.member(jsii_name="transformations")
    def transformations(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanCompoundTransformationsList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanCompoundTransformationsList", jsii.get(self, "transformations"))

    @builtins.property
    @jsii.member(jsii_name="transformationsInput")
    def transformations_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanCompoundTransformations"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanCompoundTransformations"]]], jsii.get(self, "transformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanCompound]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanCompound]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanCompound]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7ca745839d597aacb9daa43033a0a2ceadaf4e8ddaf6767d0a42df439f8c9c53)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanCompoundTransformations",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanCompoundTransformations:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanCompoundTransformations(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanCompoundTransformationsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanCompoundTransformationsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__872e6537f8e6b9e99de58f3f677e2d8d08896919ba95664d70dbb5945d405fca)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanCompoundTransformationsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ff7f94a75752b14c6f37a9853480d8d2a5b906306a0600966454294c16ad0203)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanCompoundTransformationsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ac43f31b1319082c56807321bd341671fef7d6f9ceb1bac9fb2a229b4d93ead)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb17300551478b4c2498a6f8619f5920e58a4f6e1ed3740736d8f041ba77044e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__98db10e6b34ad7bb6e8ef9b9d677fa375c6720be098b5ac32da70e81aedf099f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanCompoundTransformations]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanCompoundTransformations]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanCompoundTransformations]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a1e2dabc4ab006c38bb4128392c4959dedf33abdaccfbd1ea4d5c84152a99012)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanCompoundTransformationsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanCompoundTransformationsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c2757fa4fc4f1c8b135dfb1baf767b48b4c1d1eea548b678470848459be79469)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanCompoundTransformations]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanCompoundTransformations]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanCompoundTransformations]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f0e2b2b97d2dcae1dcbc450acccc88118395491ae5c6eb61ea97cd57e1aeea8b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanContrast",
    jsii_struct_bases=[],
    name_mapping={
        "brightness": "brightness",
        "brightness_var": "brightnessVar",
        "contrast": "contrast",
        "contrast_var": "contrastVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanContrast:
    def __init__(
        self,
        *,
        brightness: typing.Optional[builtins.str] = None,
        brightness_var: typing.Optional[builtins.str] = None,
        contrast: typing.Optional[builtins.str] = None,
        contrast_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param brightness: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        :param brightness_var: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        :param contrast: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param contrast_var: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a9a3501462a628f5514e4f052dcf4383e499ece21c591b7a5fcf694b1c9101d)
            check_type(argname="argument brightness", value=brightness, expected_type=type_hints["brightness"])
            check_type(argname="argument brightness_var", value=brightness_var, expected_type=type_hints["brightness_var"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument contrast_var", value=contrast_var, expected_type=type_hints["contrast_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if brightness is not None:
            self._values["brightness"] = brightness
        if brightness_var is not None:
            self._values["brightness_var"] = brightness_var
        if contrast is not None:
            self._values["contrast"] = contrast
        if contrast_var is not None:
            self._values["contrast_var"] = contrast_var

    @builtins.property
    def brightness(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        '''
        result = self._values.get("brightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def brightness_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        '''
        result = self._values.get("brightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        result = self._values.get("contrast_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanContrast(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanContrastList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanContrastList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__adb7ba857ca143bf698cd69f00a02d9782141079f4469927666b909adba4ec10)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanContrastOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__456a2b5bec23eebce35ed952f6dbef6ff6bcc818ddbc993921faf45a5433613b)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanContrastOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5c16c3c6f97b3d1d31203da3499be034f8720361ec0d02a6c65331eb9de7011a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8ba03a36ad5394d8036f9beb75713222d96966e09f0f64ccdc69c83d1b4d8c7c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7cce165152fa94d5367a0aac330049d54c99c8427316525a50320d9b0929734c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanContrast]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanContrast]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a3d2ba92945e1045d23e75f7b95f7e91600bc164e4a58c4108c39d73c6432389)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanContrastOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanContrastOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c81345c224a6f35aef7211df73350364a3b818234d76e7bfd82aae6004c42c28)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetBrightness")
    def reset_brightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightness", []))

    @jsii.member(jsii_name="resetBrightnessVar")
    def reset_brightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightnessVar", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetContrastVar")
    def reset_contrast_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrastVar", []))

    @builtins.property
    @jsii.member(jsii_name="brightnessInput")
    def brightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="brightnessVarInput")
    def brightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastVarInput")
    def contrast_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="brightness")
    def brightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightness"))

    @brightness.setter
    def brightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__48ed764998db72d1cbb6d7f97c07968cbe441d531f3c18d54a174013c3e79449)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightness", value)

    @builtins.property
    @jsii.member(jsii_name="brightnessVar")
    def brightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightnessVar"))

    @brightness_var.setter
    def brightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3572ce8186d19527e6e46f9378b5179bea4a2f1220cb36489956949fd7681039)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrast"))

    @contrast.setter
    def contrast(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ef97c70b7a6a81b7231627727ec737a6e627a99e7ef50f1d3a05fa17af2ac153)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrast", value)

    @builtins.property
    @jsii.member(jsii_name="contrastVar")
    def contrast_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrastVar"))

    @contrast_var.setter
    def contrast_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b2bcb708e4413823f1445a7b65a3d6c327cbc2ce28b499d0d4b262579f7986bf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrastVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanContrast]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanContrast]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanContrast]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bcb2c3408fb544b0ed0795ebd8c72502faec36f5facdbc5683eac1a469b7c728)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanGoop",
    jsii_struct_bases=[],
    name_mapping={
        "chaos": "chaos",
        "chaos_var": "chaosVar",
        "density": "density",
        "density_var": "densityVar",
        "power": "power",
        "power_var": "powerVar",
        "seed": "seed",
        "seed_var": "seedVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanGoop:
    def __init__(
        self,
        *,
        chaos: typing.Optional[builtins.str] = None,
        chaos_var: typing.Optional[builtins.str] = None,
        density: typing.Optional[builtins.str] = None,
        density_var: typing.Optional[builtins.str] = None,
        power: typing.Optional[builtins.str] = None,
        power_var: typing.Optional[builtins.str] = None,
        seed: typing.Optional[builtins.str] = None,
        seed_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param chaos: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        :param chaos_var: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        :param density: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        :param density_var: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        :param power: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        :param power_var: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        :param seed: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        :param seed_var: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__77e434c3cf6282a04e3517d9180be36ad1169609d64d7660589e43d312c4493e)
            check_type(argname="argument chaos", value=chaos, expected_type=type_hints["chaos"])
            check_type(argname="argument chaos_var", value=chaos_var, expected_type=type_hints["chaos_var"])
            check_type(argname="argument density", value=density, expected_type=type_hints["density"])
            check_type(argname="argument density_var", value=density_var, expected_type=type_hints["density_var"])
            check_type(argname="argument power", value=power, expected_type=type_hints["power"])
            check_type(argname="argument power_var", value=power_var, expected_type=type_hints["power_var"])
            check_type(argname="argument seed", value=seed, expected_type=type_hints["seed"])
            check_type(argname="argument seed_var", value=seed_var, expected_type=type_hints["seed_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if chaos is not None:
            self._values["chaos"] = chaos
        if chaos_var is not None:
            self._values["chaos_var"] = chaos_var
        if density is not None:
            self._values["density"] = density
        if density_var is not None:
            self._values["density_var"] = density_var
        if power is not None:
            self._values["power"] = power
        if power_var is not None:
            self._values["power_var"] = power_var
        if seed is not None:
            self._values["seed"] = seed
        if seed_var is not None:
            self._values["seed_var"] = seed_var

    @builtins.property
    def chaos(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        '''
        result = self._values.get("chaos")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def chaos_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        '''
        result = self._values.get("chaos_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        '''
        result = self._values.get("density")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density_var(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        '''
        result = self._values.get("density_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        '''
        result = self._values.get("power")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power_var(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        '''
        result = self._values.get("power_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        '''
        result = self._values.get("seed")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed_var(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        result = self._values.get("seed_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanGoop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanGoopList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanGoopList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d230ee11f6391cf68e116f60098000010feed22adcd3b7fc805415c7790951ad)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanGoopOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__98df1294b8ab4afdf7d3d8555eb61921ad833fe4a9a91aea5781d268044c9668)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanGoopOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a9162da40dab088399781563366c37f1bf000f5b8d484468c4568432c9a78993)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__79fac613ede76d0d8b802d329aba17e5711c85e7fce16d0fb165a005a9cee4e4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__14092ad34002cb6a7c2a0966595190961b6fa7defc8fe3dd9680e291ba887999)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanGoop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanGoop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c36e11c6e9665b28983003980f9835a2352ea3ee616eea8dc6aa1481f26b4f31)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanGoopOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanGoopOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1a782fd5034d77f4b4b33f378d0ff3cd6eecb168caacea7d54f5f79ea157781e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetChaos")
    def reset_chaos(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaos", []))

    @jsii.member(jsii_name="resetChaosVar")
    def reset_chaos_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaosVar", []))

    @jsii.member(jsii_name="resetDensity")
    def reset_density(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensity", []))

    @jsii.member(jsii_name="resetDensityVar")
    def reset_density_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensityVar", []))

    @jsii.member(jsii_name="resetPower")
    def reset_power(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPower", []))

    @jsii.member(jsii_name="resetPowerVar")
    def reset_power_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPowerVar", []))

    @jsii.member(jsii_name="resetSeed")
    def reset_seed(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeed", []))

    @jsii.member(jsii_name="resetSeedVar")
    def reset_seed_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeedVar", []))

    @builtins.property
    @jsii.member(jsii_name="chaosInput")
    def chaos_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosInput"))

    @builtins.property
    @jsii.member(jsii_name="chaosVarInput")
    def chaos_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosVarInput"))

    @builtins.property
    @jsii.member(jsii_name="densityInput")
    def density_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityInput"))

    @builtins.property
    @jsii.member(jsii_name="densityVarInput")
    def density_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="powerInput")
    def power_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerInput"))

    @builtins.property
    @jsii.member(jsii_name="powerVarInput")
    def power_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerVarInput"))

    @builtins.property
    @jsii.member(jsii_name="seedInput")
    def seed_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedInput"))

    @builtins.property
    @jsii.member(jsii_name="seedVarInput")
    def seed_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedVarInput"))

    @builtins.property
    @jsii.member(jsii_name="chaos")
    def chaos(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaos"))

    @chaos.setter
    def chaos(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__00536ab58454b6342736a2489cfad4519f86e7fd4d8ed2a45a3b49983264d0ec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaos", value)

    @builtins.property
    @jsii.member(jsii_name="chaosVar")
    def chaos_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaosVar"))

    @chaos_var.setter
    def chaos_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f609460e7ecbe7e4032062530189c8633ce501893a8d9e47c3a1450c9c40fa00)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaosVar", value)

    @builtins.property
    @jsii.member(jsii_name="density")
    def density(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "density"))

    @density.setter
    def density(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__38ade8e1672afb89da2e35c07682e5d9fa4b716b4ebe2945337ab317bffa3dc4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "density", value)

    @builtins.property
    @jsii.member(jsii_name="densityVar")
    def density_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "densityVar"))

    @density_var.setter
    def density_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__45bec1207974b36fc268ec43c7259547e552d2bc2cfb2c3a4e2812d7fa04b2e7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "densityVar", value)

    @builtins.property
    @jsii.member(jsii_name="power")
    def power(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "power"))

    @power.setter
    def power(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__24f1af24110be2362d99ae6d572ed0b98c9f21495cc3e3835e5d11cde2bb8f29)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "power", value)

    @builtins.property
    @jsii.member(jsii_name="powerVar")
    def power_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "powerVar"))

    @power_var.setter
    def power_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__93e5c7d65d52f08e9b8dfcfcde583b2cf880d8e6d0ca13f7c469232be34fc207)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "powerVar", value)

    @builtins.property
    @jsii.member(jsii_name="seed")
    def seed(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seed"))

    @seed.setter
    def seed(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__18ede557fcef937cbb752ab8a54a0bd0f809a4962f94fb3aaa5292bc817df737)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seed", value)

    @builtins.property
    @jsii.member(jsii_name="seedVar")
    def seed_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seedVar"))

    @seed_var.setter
    def seed_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dadc95bdb1e344951d63939660ff394cb23ea8bf8852bab803ee7d1ea126cb95)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seedVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanGoop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanGoop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanGoop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__abbf91d17b415a91af34bbe6cc5f34ab6eb955282ba13a16e528e9ffd2a17cfc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanGrayscale",
    jsii_struct_bases=[],
    name_mapping={"type": "type", "type_var": "typeVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanGrayscale:
    def __init__(
        self,
        *,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param type: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d0c804fe2ffd9212d74729316dfaaba7f156db8ea5cf1f417db8495501360298)
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanGrayscale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanGrayscaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanGrayscaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__944da86dce9b40f425f5519c2280c4302f1952e4aeb4cc6bba17c9790be3b599)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanGrayscaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b2b000fd7e4469a7178fc9dee440cedb8da75d8f893e2818fc8f3811acbbe985)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanGrayscaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9838290847c1bf8f00eb3bd886b7da6d4292dfffb62aa38126db23d97dad0258)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cba9effba4e5313494d3bf4cb69a82f67da677b13d5482513532d650b8e17ace)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__916166ca187c5aa9e2075efedf81b710bea50e4b08dadba804a9155e8abb895c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanGrayscale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanGrayscale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__495848179f19af584f321bccd0109c2e59235400cba9ee58ff2cc592e82e4a5c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanGrayscaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanGrayscaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__51178c19688e0695bc7aad23835023846615ac2fd8388df36f9b50601d7f4845)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ae18254b4f934eda13781055062191b7fae4ebd742a18c8e04b8073b6f7f06aa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b39b682d3b4f284a6d14af9779fd1528113f72eaad6c9e6c08dac29ac39806dd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanGrayscale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanGrayscale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanGrayscale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ae28b1430979cd45e45f243aed803311581c34f722e1a7494c83b64bc3e7e5ec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanHsl",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "lightness": "lightness",
        "lightness_var": "lightnessVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanHsl:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness: typing.Optional[builtins.str] = None,
        lightness_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        :param lightness_var: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c772213d95f9dc313d9054d46553e67c744836f71cc6c68e346927f6bc52f334)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness", value=lightness, expected_type=type_hints["lightness"])
            check_type(argname="argument lightness_var", value=lightness_var, expected_type=type_hints["lightness_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness is not None:
            self._values["lightness"] = lightness
        if lightness_var is not None:
            self._values["lightness_var"] = lightness_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        '''
        result = self._values.get("lightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        '''
        result = self._values.get("lightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanHsl(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanHslList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanHslList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a00894f6205ad50aa244c634d4efc2a29e9fe021b201337fc4c2b2c84612a26b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanHslOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d326a552834c6e848d879a7cd74138f9c191f87def5c66cd9b85a799ebf0dc33)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanHslOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__18ab5fbb82bc2f926f40b8724c64e9212cd1871840c6bcb70b781ea0e5a85174)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ed78da30c2aa35a3171291899f3f91e407f20324eb95f481e8b104b12cd6de8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c929771f1c233b6a90cce007ca305664c7ab6ee5917c1cbb5b6bd15a820519e6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanHsl]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanHsl]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e21c2916cf12cc12d8b09e03dc21692e6f6e91d80eff089f71908510071e5318)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanHslOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanHslOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b2c8a3bc119736e1da46a3129450bf4776ac39b72764811099b5870089309522)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightness")
    def reset_lightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightness", []))

    @jsii.member(jsii_name="resetLightnessVar")
    def reset_lightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessInput")
    def lightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessVarInput")
    def lightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__88a052259fc1b53f6ebd3198804efa74100e7f11e4a94b095f37eb9f481b9b7f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5bb572fcea01ca268151a6a8877208e92ceb2b864b180ab92fd94c25dbd9a37f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightness")
    def lightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightness"))

    @lightness.setter
    def lightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aab1129acc0391f5b49b5bda87d0c1670e58c5aae3f087b5ce96037dc353626b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightness", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessVar")
    def lightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessVar"))

    @lightness_var.setter
    def lightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6d9c35504b5e244631be7899cd2f04d795becb10e82a6e83751fc67a4b3e2626)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__53a8d958a24135e1b9f3e52259f6d6369cf71ff5b5c19d5144802e7c5488e9ff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__88bef94fc1265d2707fea0eeb8aca236760de3fbb6a7f19cf6b180a4a9ebe3a6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanHsl]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanHsl]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanHsl]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__625ef6b15644d1b31dc416b1a11df32ed25751194ae9ced792a7b7b4e0e84d22)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanHsv",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanHsv:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        :param value: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cf23057e25ce93f5a090986f3c44ced71f6952e69743aa27d285c78beeb52866)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanHsv(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanHsvList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanHsvList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__82e559e6a10d8f7bdad226ef1457f323548f3a62317bbd9c511e349b740e226f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanHsvOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7adb0931ece3b1feb2f48552359d72be9c4188a8342072937c26910b606f83b4)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanHsvOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__76c775cb6c2162b75b6acc30cfdece7be8fd93c2e5fbb994baf4ab1924b139cc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f10ac2d8189ecd5992807faa2b812a3c6335f2d9fa10d844274c0e0219863872)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6315aa320bf192d24510af6140ab748aaad68710c70d365dae3b58ebae149997)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanHsv]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanHsv]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a0af4eb4ecae612793ea1f128e672652f7127d5f53f5afd5f93de0b440518b1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanHsvOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanHsvOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__15f7a6c4cb7c6a7dc2d3bf21b508184ca0d702e753b1e54fd765def3e26079b4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__610eb2025639348eedea82c177d84e5df4a5915bb95de117445a183245cb8a4c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bcd9d1c544aeee604639a6b783eb03daf0e2700e8a55ef3753daa14195017b6c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__357d054168306845454fe6168902fc837ec9fdea0539717da3dc9301c087b5c3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c045cf8883361d622a9e59b596a063bd8b5c588b84374c66046bb16e57ae1869)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea83806b5eb05d73f459d7287211a6073ae549119679f3d4f813fde954bc8d7d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6752006e992cdb71820ebb075b937d842b6d54dd010105c7b35cbd5a47df2974)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanHsv]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanHsv]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanHsv]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a34fd0c18d6eb2e90a5bfc97130904516b7fdc6775ca14066f045e55c1704999)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimension",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "dimension": "dimension",
        "dimension_var": "dimensionVar",
        "equal": "equal",
        "greater_than": "greaterThan",
        "less_than": "lessThan",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimension:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        dimension: typing.Optional[builtins.str] = None,
        dimension_var: typing.Optional[builtins.str] = None,
        equal: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionEqual", typing.Dict[builtins.str, typing.Any]]] = None,
        greater_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionGreaterThan", typing.Dict[builtins.str, typing.Any]]] = None,
        less_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionLessThan", typing.Dict[builtins.str, typing.Any]]] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param dimension: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        :param dimension_var: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        :param equal: equal block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        :param greater_than: greater_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        :param less_than: less_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        :param value: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionDefault(**default)
        if isinstance(equal, dict):
            equal = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionEqual(**equal)
        if isinstance(greater_than, dict):
            greater_than = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionGreaterThan(**greater_than)
        if isinstance(less_than, dict):
            less_than = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionLessThan(**less_than)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__844ca183f557dcc7545b553ee0aca863b95317578587d8cf714079360e42650d)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument dimension", value=dimension, expected_type=type_hints["dimension"])
            check_type(argname="argument dimension_var", value=dimension_var, expected_type=type_hints["dimension_var"])
            check_type(argname="argument equal", value=equal, expected_type=type_hints["equal"])
            check_type(argname="argument greater_than", value=greater_than, expected_type=type_hints["greater_than"])
            check_type(argname="argument less_than", value=less_than, expected_type=type_hints["less_than"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if dimension is not None:
            self._values["dimension"] = dimension
        if dimension_var is not None:
            self._values["dimension_var"] = dimension_var
        if equal is not None:
            self._values["equal"] = equal
        if greater_than is not None:
            self._values["greater_than"] = greater_than
        if less_than is not None:
            self._values["less_than"] = less_than
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionDefault"], result)

    @builtins.property
    def dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        '''
        result = self._values.get("dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        '''
        result = self._values.get("dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def equal(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionEqual"]:
        '''equal block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        '''
        result = self._values.get("equal")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionEqual"], result)

    @builtins.property
    def greater_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionGreaterThan"]:
        '''greater_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        '''
        result = self._values.get("greater_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionGreaterThan"], result)

    @builtins.property
    def less_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionLessThan"]:
        '''less_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        '''
        result = self._values.get("less_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionLessThan"], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimension(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d1de5776a6c8a0c53215ba3d1751bd7a04bf7d6223f69971a826f0236845e766)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8cb5db5ea7bd0d395acae86690b1d998f632294f5a7f113bf882303e990cdfa0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionEqual",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionEqual:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionEqual(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionEqualOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionEqualOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__493bc9607af8d61ebc018db2ecceb723111619bc9e489d7cf85de0fcb7853a38)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionEqual], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionEqual],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6256ff942cb66f7834761409b3a3945a80769e6b7e168dab8aae2dff8408a767)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionGreaterThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionGreaterThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionGreaterThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionGreaterThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionGreaterThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aaf605618d0dd796277b2feacae9b6d74db560c6113fbbcbc6898bc7b81b2982)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionGreaterThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionGreaterThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e7ff2990000ddf5e786480675394e98dfafc1590bb319fcb4a5c550bd870bdbd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionLessThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionLessThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionLessThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionLessThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionLessThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3036dcae3527e1b618fe18afaca91118aaee91a3127d02b814cae13a845aafef)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionLessThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionLessThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__966b3f1e6ea02227efb11b4b4d4743c2dfe0e2b0d8b2c28085125787015b802e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cee5ecb9974dfb7ea7ab0f74da102291e2c3650aad41702278bd88cc38c19030)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f2358d87d96713ed90fe3b2b0e5d1ed3e32a4341af85e2aa2cd3850e72f57385)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4e7141ca77cbd16ac52941202565e677799bca516527a7db33618fe43f6d1622)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cbf9c052f0e84fa16f314b5d171e7ff01e1edf5e73f2f7403c13c1caeb7856a7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab0487c4441dd7398b08cc2086ca5e721bc4f667a12f8b9149fcdb270ff6e00c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimension]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimension]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd82e062bc3bde8ce583230ffd706ec8ba36aeacb51a4815bb05fc934137eaa0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__84329fd9016394b9af0c185c5398033b8fc730298a5c43b14e1facc65bf625ab)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putEqual")
    def put_equal(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionEqual()

        return typing.cast(None, jsii.invoke(self, "putEqual", [value]))

    @jsii.member(jsii_name="putGreaterThan")
    def put_greater_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionGreaterThan()

        return typing.cast(None, jsii.invoke(self, "putGreaterThan", [value]))

    @jsii.member(jsii_name="putLessThan")
    def put_less_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionLessThan()

        return typing.cast(None, jsii.invoke(self, "putLessThan", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetDimension")
    def reset_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimension", []))

    @jsii.member(jsii_name="resetDimensionVar")
    def reset_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimensionVar", []))

    @jsii.member(jsii_name="resetEqual")
    def reset_equal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEqual", []))

    @jsii.member(jsii_name="resetGreaterThan")
    def reset_greater_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGreaterThan", []))

    @jsii.member(jsii_name="resetLessThan")
    def reset_less_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLessThan", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="equal")
    def equal(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionEqualOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionEqualOutputReference, jsii.get(self, "equal"))

    @builtins.property
    @jsii.member(jsii_name="greaterThan")
    def greater_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionGreaterThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionGreaterThanOutputReference, jsii.get(self, "greaterThan"))

    @builtins.property
    @jsii.member(jsii_name="lessThan")
    def less_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionLessThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionLessThanOutputReference, jsii.get(self, "lessThan"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionInput")
    def dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionVarInput")
    def dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="equalInput")
    def equal_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionEqual], jsii.get(self, "equalInput"))

    @builtins.property
    @jsii.member(jsii_name="greaterThanInput")
    def greater_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionGreaterThan], jsii.get(self, "greaterThanInput"))

    @builtins.property
    @jsii.member(jsii_name="lessThanInput")
    def less_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionLessThan], jsii.get(self, "lessThanInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="dimension")
    def dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimension"))

    @dimension.setter
    def dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__75ec9f2add95d057340acc3f31a67192d75d3808d2feadc12772678ef599e535)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimension", value)

    @builtins.property
    @jsii.member(jsii_name="dimensionVar")
    def dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimensionVar"))

    @dimension_var.setter
    def dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8fb02207493f00551ae3473bc964bb44d665a42a8fbb1d52da15cf55878d8f9e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d3dc263f35ebda9930bdceeb30bafd1aefe761eca1dd62beca1d860954bfd132)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1aa392fdbcf22793cdbe881943c66ddc01caf51203f660cd5ee361c093d577ff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimension]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimension]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimension]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__316b872d966abcc3d39ba2c8d5bb17126bc73af0b7c74add5b815d6d4ac227de)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientation",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "landscape": "landscape",
        "portrait": "portrait",
        "square": "square",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientation:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        landscape: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationLandscape", typing.Dict[builtins.str, typing.Any]]] = None,
        portrait: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationPortrait", typing.Dict[builtins.str, typing.Any]]] = None,
        square: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationSquare", typing.Dict[builtins.str, typing.Any]]] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param landscape: landscape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        :param portrait: portrait block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        :param square: square block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationDefault(**default)
        if isinstance(landscape, dict):
            landscape = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationLandscape(**landscape)
        if isinstance(portrait, dict):
            portrait = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationPortrait(**portrait)
        if isinstance(square, dict):
            square = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationSquare(**square)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__645338b91834ad4c83d2df6fce2724e814e7ad7a8e169f96763cfb4bb6082edf)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument landscape", value=landscape, expected_type=type_hints["landscape"])
            check_type(argname="argument portrait", value=portrait, expected_type=type_hints["portrait"])
            check_type(argname="argument square", value=square, expected_type=type_hints["square"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if landscape is not None:
            self._values["landscape"] = landscape
        if portrait is not None:
            self._values["portrait"] = portrait
        if square is not None:
            self._values["square"] = square

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationDefault"], result)

    @builtins.property
    def landscape(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationLandscape"]:
        '''landscape block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        '''
        result = self._values.get("landscape")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationLandscape"], result)

    @builtins.property
    def portrait(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationPortrait"]:
        '''portrait block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        '''
        result = self._values.get("portrait")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationPortrait"], result)

    @builtins.property
    def square(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationSquare"]:
        '''square block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        result = self._values.get("square")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationSquare"], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9038f1c13fbd08507050d9f34fb51e8d2a3617f27d9d0dfdba62e56b44321ebd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6aa2b960b495be677b98911cff94accdbc0dbfa6143bda6a73eeb4f50adf7fd7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationLandscape",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationLandscape:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationLandscape(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationLandscapeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationLandscapeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__348b174aaabe18f383c08764a6119d2192e85b3fb9718256e654ed7eb7e723ea)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationLandscape], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationLandscape],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__806e8f2c23efd5f2404b3ac8899e3a7c6f17ca2e31410b61f30e5c4cb7eba952)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1b2c37e4c65c0515dca35beb34bb503d2802004f60a82a624a5fc5e9c779dc59)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e4a9f365e4a2f4a69a1fbdac938b87e532e36c05d2274c3622ada060bc538804)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8808b43f90bd734e75776ecf1be9e4396135f75ba487ae59d70953ea0bc4561e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__16a3ad1ec41be275c85ecffbc18b6836c2147215f5b1f60fb5d6e126fc3f7a04)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1cceef1f3c5c0584f9b717b0fc0eb73344e5507a0879dfcebba30e2e9fe02ebd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientation]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientation]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__489d8278dc0d9fa3b9988699ade28587337bfc6a566911327fd7fb47dcba06ba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__48099098b82d3df8c8d6fb1cfcac721a5ba76914f8dd644dc0e9ebccc8d36978)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putLandscape")
    def put_landscape(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationLandscape()

        return typing.cast(None, jsii.invoke(self, "putLandscape", [value]))

    @jsii.member(jsii_name="putPortrait")
    def put_portrait(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationPortrait()

        return typing.cast(None, jsii.invoke(self, "putPortrait", [value]))

    @jsii.member(jsii_name="putSquare")
    def put_square(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationSquare()

        return typing.cast(None, jsii.invoke(self, "putSquare", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetLandscape")
    def reset_landscape(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLandscape", []))

    @jsii.member(jsii_name="resetPortrait")
    def reset_portrait(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPortrait", []))

    @jsii.member(jsii_name="resetSquare")
    def reset_square(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSquare", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="landscape")
    def landscape(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationLandscapeOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationLandscapeOutputReference, jsii.get(self, "landscape"))

    @builtins.property
    @jsii.member(jsii_name="portrait")
    def portrait(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationPortraitOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationPortraitOutputReference", jsii.get(self, "portrait"))

    @builtins.property
    @jsii.member(jsii_name="square")
    def square(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationSquareOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationSquareOutputReference", jsii.get(self, "square"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="landscapeInput")
    def landscape_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationLandscape], jsii.get(self, "landscapeInput"))

    @builtins.property
    @jsii.member(jsii_name="portraitInput")
    def portrait_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationPortrait"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationPortrait"], jsii.get(self, "portraitInput"))

    @builtins.property
    @jsii.member(jsii_name="squareInput")
    def square_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationSquare"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationSquare"], jsii.get(self, "squareInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientation]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientation]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientation]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7e32675475c89ea648c6e8667ef623475aea87e0e9524211ee38776108164fd8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationPortrait",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationPortrait:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationPortrait(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationPortraitOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationPortraitOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4673e4072bc6d89ced3faec26912f8fa4dc8e40b1069f0f9aedca6ed63eedbbc)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationPortrait]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationPortrait], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationPortrait],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__44ae36768da36351567b2700e6f39d8020f4032e708c402eb8eb4441e51c8b5c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationSquare",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationSquare:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationSquare(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationSquareOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationSquareOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__271e4d02e0b336d62f479508545b451543b119cc08d2fea61e99c60ccf444e26)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationSquare]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationSquare], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationSquare],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__50d2a59173594f16e2114ef1b52ff472ad06e220881281ffb8778fe1b2a07d8c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanMaxColors",
    jsii_struct_bases=[],
    name_mapping={"colors": "colors", "colors_var": "colorsVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanMaxColors:
    def __init__(
        self,
        *,
        colors: typing.Optional[builtins.str] = None,
        colors_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param colors: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        :param colors_var: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eab7b2f8a18e2c500eac38cb8decf0261de0c566aa9270d62f06f77785066d79)
            check_type(argname="argument colors", value=colors, expected_type=type_hints["colors"])
            check_type(argname="argument colors_var", value=colors_var, expected_type=type_hints["colors_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if colors is not None:
            self._values["colors"] = colors
        if colors_var is not None:
            self._values["colors_var"] = colors_var

    @builtins.property
    def colors(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        '''
        result = self._values.get("colors")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def colors_var(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        result = self._values.get("colors_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanMaxColors(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanMaxColorsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanMaxColorsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a1894b32912bddcdcd7885ca7cea0b52d2740205744b8ae5e567d61e9ff2e2e4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanMaxColorsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3f2cc97695b7ce0ec52f61b6e4efec0cba6e80cc6b12cd74ec64c43b82b41c8f)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanMaxColorsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3c55aa4bb8db5ebf6d69077b64d24557ab7e158c32ac050c3341b134f6f430ee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__de0b4057af34027389ee40522842846b2023d883fbd08110ee406b7191cc490b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__58fbaeada404ea1ed22f1bf4c5fcb9e00e10807de8d8e93d6533e727b6f901c9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanMaxColors]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanMaxColors]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3c55003fb1df5442ebbec6502bd615b409ea96068394f82386bbc19805d4186d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanMaxColorsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanMaxColorsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a246f3af9270ed9ecdf2f2340e269f8e30228c45d5bac523f5a92ae915fcdd1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColors")
    def reset_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColors", []))

    @jsii.member(jsii_name="resetColorsVar")
    def reset_colors_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorsVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorsInput")
    def colors_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsInput"))

    @builtins.property
    @jsii.member(jsii_name="colorsVarInput")
    def colors_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsVarInput"))

    @builtins.property
    @jsii.member(jsii_name="colors")
    def colors(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colors"))

    @colors.setter
    def colors(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7fe817e7a864be9630c9c1ca6635e8f8b9ab5ec4310f9d65810ab61bb0df2e13)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colors", value)

    @builtins.property
    @jsii.member(jsii_name="colorsVar")
    def colors_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorsVar"))

    @colors_var.setter
    def colors_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fb9b9c9b25eb19766051dde4853f4e9afefe5631674972e2b5b9c812be4a9e90)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorsVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanMaxColors]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanMaxColors]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanMaxColors]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d4967ef4642e9c841f4301b0275c36de03de15db9dad9576dc6cf701d9fe2449)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanMirror",
    jsii_struct_bases=[],
    name_mapping={
        "horizontal": "horizontal",
        "horizontal_var": "horizontalVar",
        "vertical": "vertical",
        "vertical_var": "verticalVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanMirror:
    def __init__(
        self,
        *,
        horizontal: typing.Optional[builtins.str] = None,
        horizontal_var: typing.Optional[builtins.str] = None,
        vertical: typing.Optional[builtins.str] = None,
        vertical_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param horizontal: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        :param horizontal_var: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        :param vertical: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        :param vertical_var: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__39afc6f99a02ca4e0198718cf5fab1198a33e89a5610f6a745f54ceed319633f)
            check_type(argname="argument horizontal", value=horizontal, expected_type=type_hints["horizontal"])
            check_type(argname="argument horizontal_var", value=horizontal_var, expected_type=type_hints["horizontal_var"])
            check_type(argname="argument vertical", value=vertical, expected_type=type_hints["vertical"])
            check_type(argname="argument vertical_var", value=vertical_var, expected_type=type_hints["vertical_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if horizontal is not None:
            self._values["horizontal"] = horizontal
        if horizontal_var is not None:
            self._values["horizontal_var"] = horizontal_var
        if vertical is not None:
            self._values["vertical"] = vertical
        if vertical_var is not None:
            self._values["vertical_var"] = vertical_var

    @builtins.property
    def horizontal(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        '''
        result = self._values.get("horizontal")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def horizontal_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        '''
        result = self._values.get("horizontal_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        '''
        result = self._values.get("vertical")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        result = self._values.get("vertical_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanMirror(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanMirrorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanMirrorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__037a3fb4e0608be8473a932c0e130aa50767e422a559431a02fbc757fd4ea31b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanMirrorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__847556d625d06f32511291640113d153899e080f524b3eb1d1338bc38ebc05a9)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanMirrorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a343c1895a1dabc7e04a22912744f4ddcfdebfebae74de436241dec88ccefd4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fd1f6694913aa7f6681e2375ccf5187cd12499ab8efb96fdb1a466cfdf9c27a1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fba91463fbdd17ba73d3f61792c4daf1a046d9cbbf912edc7ea66d419a817f8e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanMirror]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanMirror]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__234c3dc86ba8cd8a7e60dad7c393c054a53b98e0087f6a278f6660d7be0d298b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanMirrorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanMirrorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__610bd52c5adb1e7330efe1d86d4c706b2ebef17aa3a6e337f0637fe99ae6d3b4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHorizontal")
    def reset_horizontal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontal", []))

    @jsii.member(jsii_name="resetHorizontalVar")
    def reset_horizontal_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontalVar", []))

    @jsii.member(jsii_name="resetVertical")
    def reset_vertical(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVertical", []))

    @jsii.member(jsii_name="resetVerticalVar")
    def reset_vertical_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVerticalVar", []))

    @builtins.property
    @jsii.member(jsii_name="horizontalInput")
    def horizontal_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontalVarInput")
    def horizontal_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalInput")
    def vertical_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalVarInput")
    def vertical_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontal")
    def horizontal(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontal"))

    @horizontal.setter
    def horizontal(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a2a9a9d0e470d437fcead8143a12aa77852dc7695e202f66c77736c0e800750d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontal", value)

    @builtins.property
    @jsii.member(jsii_name="horizontalVar")
    def horizontal_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontalVar"))

    @horizontal_var.setter
    def horizontal_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b609cff8a5b14f815e214b4fcdad5f399a4f82f5e6d8c82879c36855f3059e47)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontalVar", value)

    @builtins.property
    @jsii.member(jsii_name="vertical")
    def vertical(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "vertical"))

    @vertical.setter
    def vertical(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__01184e246bcff032770bd35a5599de415b95c5820d06f8bf30bac6127709f200)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "vertical", value)

    @builtins.property
    @jsii.member(jsii_name="verticalVar")
    def vertical_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "verticalVar"))

    @vertical_var.setter
    def vertical_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e9defdd0a2c2b1b52c8844981c96646a811ebfb85a7fc747fda3fd618beae778)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "verticalVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanMirror]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanMirror]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanMirror]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eec286587b9395675ea6d1fc6e43107899c435ee34b1f002c054fadc9c918577)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanMonoHue",
    jsii_struct_bases=[],
    name_mapping={"hue": "hue", "hue_var": "hueVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanMonoHue:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__467c6b0654f3414ba51d2d9f537d31880b13f66a236491ba1f18531ee1575d17)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanMonoHue(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanMonoHueList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanMonoHueList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4d8b1f607aa0fb0a87fbe63a38963cb1083b4cadcfdc423e10ed18cb24960ce6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanMonoHueOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8cda007dc8158f069e571cd250a7d7168610fbdc042d97c7ae91fc333dcd7d73)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanMonoHueOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__462c1fd741727648aa1da7af54183106a03a89a807a234dc0933492443a35dae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__26de6fe64b082752da98eb4d9698e8a8847eba33bc8949e78ccf3b7c7a646df6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d89358086e7d0e1f5f6ee945d85eaaf9acd8f2c84f4aba94ff475ce02bdc4d7e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanMonoHue]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanMonoHue]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2f27a57adfe00ba273f599078a9a52745e342c6418e0ef40b7b8f061f4b0d690)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanMonoHueOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanMonoHueOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ad93581b1553f6d113a6c0f98eec611f608d87700d3b31728caf57d07e75aaf8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__93a3932f566e66310427bc8a5afb6f7e867b39f59aa9513889e615e545023d76)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__201039bf159605e46e4c1eca1fc158cdbf04fc6ce5f0d391ac2db5621ad500f6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanMonoHue]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanMonoHue]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanMonoHue]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__546a27bda27b17735ac1cc24aa9e0d45c9288a5ac9e2871e26d6ceaab36eab3e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanOpacity",
    jsii_struct_bases=[],
    name_mapping={"opacity": "opacity", "opacity_var": "opacityVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanOpacity:
    def __init__(
        self,
        *,
        opacity: typing.Optional[builtins.str] = None,
        opacity_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param opacity: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param opacity_var: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__20b12abe1442c0316e16577dd66a9c69b9c263e8c4b440e81a65225fc81d8c4c)
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument opacity_var", value=opacity_var, expected_type=type_hints["opacity_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if opacity is not None:
            self._values["opacity"] = opacity
        if opacity_var is not None:
            self._values["opacity_var"] = opacity_var

    @builtins.property
    def opacity(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def opacity_var(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        result = self._values.get("opacity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanOpacity(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanOpacityList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanOpacityList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__feaae36f9541fc27729bfccaa474467d6944a6f775fa47f0bd23ab7d9a446602)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanOpacityOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0a102a3f1fcbe5e0b049348a5e835c14a2119507e9acf6d8025526355b465e9c)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanOpacityOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__74e711affa9f7fe02146facc5d7a999980969dea789141c38d9efe8e47101767)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b1304f387923684016086a4b19d6a70c7fd18eb5b87cbdcb767250ce432d3ca8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3738f73220e44e96854d23530a9705e6fb087c82515e46f699dcef6d9cbe11d3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanOpacity]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanOpacity]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7bca26419564ca0cae02425d074ef4ec10ed214457d01189b8180f58fafa2b7a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanOpacityOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanOpacityOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a021fdabb4d5c4e6219c984f2929ba12578aaac2da359b85c83caa26537cc0a0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetOpacityVar")
    def reset_opacity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacityVar", []))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityVarInput")
    def opacity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacity"))

    @opacity.setter
    def opacity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9b7f7da97b5442b8d0010a3cf861e5d57d6d4089b3ec9e339a4758d841f542de)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacity", value)

    @builtins.property
    @jsii.member(jsii_name="opacityVar")
    def opacity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacityVar"))

    @opacity_var.setter
    def opacity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c62307c3ea5f7d17a364d009ee8f723d35e5c5b08c486de995524a5e7f3ef365)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacityVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanOpacity]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanOpacity]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanOpacity]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__50baf1a21fee8c89b216415844e47867d468e7e2f9883fcdcb08ad2ee7541f68)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5440201ab70edcef4698d6e27dbeacc3c8337fb8ae367deadedd6a1bcc817a46)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putBackgroundColor")
    def put_background_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__14539ea062b1bc5cbbf797e5143a1b2f35584317f6aeea63cea219656736260b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBackgroundColor", [value]))

    @jsii.member(jsii_name="putBlur")
    def put_blur(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanBlur, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b000e7b06299ce132fe1249fa1c6b1c0d9d9dbc15b8418c345abb60b5a67254d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBlur", [value]))

    @jsii.member(jsii_name="putChromaKey")
    def put_chroma_key(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanChromaKey, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d70409cee45f48d82fb271c8996e312993d8542808d9ad9c82a565a9445dccd7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putChromaKey", [value]))

    @jsii.member(jsii_name="putComposite")
    def put_composite(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanComposite, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__12eabdd41d1d5df867f0122203a39773ffffbde7019932ee86d60f3a98ebc3db)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putComposite", [value]))

    @jsii.member(jsii_name="putCompound")
    def put_compound(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanCompound, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__999b33e209a7958310e442fcb938524f1db3542a368ccd2838b4a771fe38d2ff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCompound", [value]))

    @jsii.member(jsii_name="putContrast")
    def put_contrast(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanContrast, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f60406cd344638437bf30a389e0b94e9c019e4dadd7ff82c842dcec0ee45aae5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putContrast", [value]))

    @jsii.member(jsii_name="putGoop")
    def put_goop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanGoop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e69945ebd6f87b711df5feb65c16def9abc53bbed4a5fe4abe76ff43e36cb45)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGoop", [value]))

    @jsii.member(jsii_name="putGrayscale")
    def put_grayscale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanGrayscale, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cfb77c532e1e70f40babb5ce5ad184aed5db42283104e1ea82028a39ce922187)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGrayscale", [value]))

    @jsii.member(jsii_name="putHsl")
    def put_hsl(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanHsl, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0721c921bd1537fff436f3a0b47200d0b7cb919c15f414c984c58d775c247045)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsl", [value]))

    @jsii.member(jsii_name="putHsv")
    def put_hsv(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanHsv, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1fa769c56d016b121082365c5334a5f608632d199f5b1775ce13f879bd95cd8d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsv", [value]))

    @jsii.member(jsii_name="putIfDimension")
    def put_if_dimension(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimension, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7a9eadb14ef04076a252c3ac64a30ae8223848d2b9ff66711f41aaa42a16c568)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfDimension", [value]))

    @jsii.member(jsii_name="putIfOrientation")
    def put_if_orientation(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0c0097115d917dd888001ca8e19483b2caca785256755da8120e667935695b08)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfOrientation", [value]))

    @jsii.member(jsii_name="putMaxColors")
    def put_max_colors(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanMaxColors, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8590d79cfe226d6574981fff6be181bb1f95aef0276a236ecae4e7e3139af1b2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMaxColors", [value]))

    @jsii.member(jsii_name="putMirror")
    def put_mirror(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanMirror, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__28b2ce6fa036967121c09a96b204e966f19fad9a70c39a85dda90c1836474ca0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMirror", [value]))

    @jsii.member(jsii_name="putMonoHue")
    def put_mono_hue(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanMonoHue, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e29c8451c5906d420d1b4c8526a1516f6e79163a90afadc4590ea69923e95d1f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMonoHue", [value]))

    @jsii.member(jsii_name="putOpacity")
    def put_opacity(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanOpacity, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__30fd5558da3753ec3f66c9668220d2e58dc15b3932be214f411a463defa943a8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putOpacity", [value]))

    @jsii.member(jsii_name="putRemoveColor")
    def put_remove_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanRemoveColor", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__096b31f700e76b16c6d48edde49de5f93d25294b13b2bd28b7933d2842316c1b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRemoveColor", [value]))

    @jsii.member(jsii_name="putUnsharpMask")
    def put_unsharp_mask(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanUnsharpMask", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__34e2a66ba0df3144a5d3e0e261461bc59df70621abb706892e1c7a594d38548f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putUnsharpMask", [value]))

    @jsii.member(jsii_name="resetBackgroundColor")
    def reset_background_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBackgroundColor", []))

    @jsii.member(jsii_name="resetBlur")
    def reset_blur(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBlur", []))

    @jsii.member(jsii_name="resetChromaKey")
    def reset_chroma_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChromaKey", []))

    @jsii.member(jsii_name="resetComposite")
    def reset_composite(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetComposite", []))

    @jsii.member(jsii_name="resetCompound")
    def reset_compound(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCompound", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetGoop")
    def reset_goop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGoop", []))

    @jsii.member(jsii_name="resetGrayscale")
    def reset_grayscale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGrayscale", []))

    @jsii.member(jsii_name="resetHsl")
    def reset_hsl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsl", []))

    @jsii.member(jsii_name="resetHsv")
    def reset_hsv(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsv", []))

    @jsii.member(jsii_name="resetIfDimension")
    def reset_if_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfDimension", []))

    @jsii.member(jsii_name="resetIfOrientation")
    def reset_if_orientation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfOrientation", []))

    @jsii.member(jsii_name="resetMaxColors")
    def reset_max_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxColors", []))

    @jsii.member(jsii_name="resetMirror")
    def reset_mirror(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMirror", []))

    @jsii.member(jsii_name="resetMonoHue")
    def reset_mono_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonoHue", []))

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetRemoveColor")
    def reset_remove_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRemoveColor", []))

    @jsii.member(jsii_name="resetUnsharpMask")
    def reset_unsharp_mask(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUnsharpMask", []))

    @builtins.property
    @jsii.member(jsii_name="backgroundColor")
    def background_color(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanBackgroundColorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanBackgroundColorList, jsii.get(self, "backgroundColor"))

    @builtins.property
    @jsii.member(jsii_name="blur")
    def blur(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanBlurList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanBlurList, jsii.get(self, "blur"))

    @builtins.property
    @jsii.member(jsii_name="chromaKey")
    def chroma_key(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanChromaKeyList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanChromaKeyList, jsii.get(self, "chromaKey"))

    @builtins.property
    @jsii.member(jsii_name="composite")
    def composite(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanCompositeList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanCompositeList, jsii.get(self, "composite"))

    @builtins.property
    @jsii.member(jsii_name="compound")
    def compound(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanCompoundList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanCompoundList, jsii.get(self, "compound"))

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanContrastList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanContrastList, jsii.get(self, "contrast"))

    @builtins.property
    @jsii.member(jsii_name="goop")
    def goop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanGoopList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanGoopList, jsii.get(self, "goop"))

    @builtins.property
    @jsii.member(jsii_name="grayscale")
    def grayscale(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanGrayscaleList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanGrayscaleList, jsii.get(self, "grayscale"))

    @builtins.property
    @jsii.member(jsii_name="hsl")
    def hsl(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanHslList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanHslList, jsii.get(self, "hsl"))

    @builtins.property
    @jsii.member(jsii_name="hsv")
    def hsv(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanHsvList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanHsvList, jsii.get(self, "hsv"))

    @builtins.property
    @jsii.member(jsii_name="ifDimension")
    def if_dimension(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionList, jsii.get(self, "ifDimension"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientation")
    def if_orientation(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationList, jsii.get(self, "ifOrientation"))

    @builtins.property
    @jsii.member(jsii_name="maxColors")
    def max_colors(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanMaxColorsList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanMaxColorsList, jsii.get(self, "maxColors"))

    @builtins.property
    @jsii.member(jsii_name="mirror")
    def mirror(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanMirrorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanMirrorList, jsii.get(self, "mirror"))

    @builtins.property
    @jsii.member(jsii_name="monoHue")
    def mono_hue(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanMonoHueList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanMonoHueList, jsii.get(self, "monoHue"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanOpacityList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanOpacityList, jsii.get(self, "opacity"))

    @builtins.property
    @jsii.member(jsii_name="removeColor")
    def remove_color(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanRemoveColorList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanRemoveColorList", jsii.get(self, "removeColor"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMask")
    def unsharp_mask(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanUnsharpMaskList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanUnsharpMaskList", jsii.get(self, "unsharpMask"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColorInput")
    def background_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanBackgroundColor]]], jsii.get(self, "backgroundColorInput"))

    @builtins.property
    @jsii.member(jsii_name="blurInput")
    def blur_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanBlur]]], jsii.get(self, "blurInput"))

    @builtins.property
    @jsii.member(jsii_name="chromaKeyInput")
    def chroma_key_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanChromaKey]]], jsii.get(self, "chromaKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="compositeInput")
    def composite_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanComposite]]], jsii.get(self, "compositeInput"))

    @builtins.property
    @jsii.member(jsii_name="compoundInput")
    def compound_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanCompound]]], jsii.get(self, "compoundInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanContrast]]], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="goopInput")
    def goop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanGoop]]], jsii.get(self, "goopInput"))

    @builtins.property
    @jsii.member(jsii_name="grayscaleInput")
    def grayscale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanGrayscale]]], jsii.get(self, "grayscaleInput"))

    @builtins.property
    @jsii.member(jsii_name="hslInput")
    def hsl_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanHsl]]], jsii.get(self, "hslInput"))

    @builtins.property
    @jsii.member(jsii_name="hsvInput")
    def hsv_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanHsv]]], jsii.get(self, "hsvInput"))

    @builtins.property
    @jsii.member(jsii_name="ifDimensionInput")
    def if_dimension_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimension]]], jsii.get(self, "ifDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientationInput")
    def if_orientation_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientation]]], jsii.get(self, "ifOrientationInput"))

    @builtins.property
    @jsii.member(jsii_name="maxColorsInput")
    def max_colors_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanMaxColors]]], jsii.get(self, "maxColorsInput"))

    @builtins.property
    @jsii.member(jsii_name="mirrorInput")
    def mirror_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanMirror]]], jsii.get(self, "mirrorInput"))

    @builtins.property
    @jsii.member(jsii_name="monoHueInput")
    def mono_hue_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanMonoHue]]], jsii.get(self, "monoHueInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanOpacity]]], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="removeColorInput")
    def remove_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanRemoveColor"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanRemoveColor"]]], jsii.get(self, "removeColorInput"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMaskInput")
    def unsharp_mask_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanUnsharpMask"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanUnsharpMask"]]], jsii.get(self, "unsharpMaskInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__749e5322fc4dc44f4f06a10323df6cee0860e8b76491db2a759d19c915c5fd6c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanRemoveColor",
    jsii_struct_bases=[],
    name_mapping={
        "color": "color",
        "color_var": "colorVar",
        "feather": "feather",
        "feather_var": "featherVar",
        "tolerance": "tolerance",
        "tolerance_var": "toleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanRemoveColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
        feather: typing.Optional[builtins.str] = None,
        feather_var: typing.Optional[builtins.str] = None,
        tolerance: typing.Optional[builtins.str] = None,
        tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        :param feather: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        :param feather_var: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        :param tolerance: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        :param tolerance_var: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6815ff56ecc39564d7e7a236d947a7b0f3e0104785db2c89001cf867a59a3d87)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
            check_type(argname="argument feather", value=feather, expected_type=type_hints["feather"])
            check_type(argname="argument feather_var", value=feather_var, expected_type=type_hints["feather_var"])
            check_type(argname="argument tolerance", value=tolerance, expected_type=type_hints["tolerance"])
            check_type(argname="argument tolerance_var", value=tolerance_var, expected_type=type_hints["tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var
        if feather is not None:
            self._values["feather"] = feather
        if feather_var is not None:
            self._values["feather_var"] = feather_var
        if tolerance is not None:
            self._values["tolerance"] = tolerance
        if tolerance_var is not None:
            self._values["tolerance_var"] = tolerance_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        '''
        result = self._values.get("feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather_var(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        '''
        result = self._values.get("feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        '''
        result = self._values.get("tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance_var(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        result = self._values.get("tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanRemoveColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanRemoveColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanRemoveColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0edcc2cda24efeaf268dc2d89959fb69e49af09d8a92c9e1fb7b76a662dafae7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanRemoveColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5a7b8696778240dea4ccb51f03e11c8781d6c5df464ab3029e223fb8c1ca59c3)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanRemoveColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1510ed00a0114e99e566abf434a40ebd18361cea247098996ef914f23e78f79c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__74c868f7a3c648f54dceeb03cf2adf6e8d4baba910e7f83070509946b2e10722)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__34c67160063676d99019840c1333c02c0d425bf2fc51cc205519a6288c6ea4a9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanRemoveColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanRemoveColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanRemoveColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__31a2db0b242ba8beb0013bfa44349887dcdb562ab4d1e7345581bde5944b04ad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanRemoveColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanRemoveColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b9e963f020b3b7276d7879f66475a3d63e26ca4b24e5bec17e218edeec9af9da)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @jsii.member(jsii_name="resetFeather")
    def reset_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeather", []))

    @jsii.member(jsii_name="resetFeatherVar")
    def reset_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatherVar", []))

    @jsii.member(jsii_name="resetTolerance")
    def reset_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTolerance", []))

    @jsii.member(jsii_name="resetToleranceVar")
    def reset_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featherInput")
    def feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherInput"))

    @builtins.property
    @jsii.member(jsii_name="featherVarInput")
    def feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceInput")
    def tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceVarInput")
    def tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c77e9f543021cb9277dd851d4f2b2330deb01957568acb3c665ff324b593a837)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a21e32abae9a865680dd69aeef61c413f1abfc4dbea8440ca21671cc3bdd1608)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="feather")
    def feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "feather"))

    @feather.setter
    def feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2e710dce96522b4a2f236d591785059c99c602c975c42ac8c568ec5fd61efeec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "feather", value)

    @builtins.property
    @jsii.member(jsii_name="featherVar")
    def feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featherVar"))

    @feather_var.setter
    def feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0cc6096b786ccef8ee8832df5de26243d01c22310c4716bcbc884e85ecbdb258)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featherVar", value)

    @builtins.property
    @jsii.member(jsii_name="tolerance")
    def tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tolerance"))

    @tolerance.setter
    def tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dd08817b25222cda96ad0e08d6bbcecf894f39b44af2b30923af41f24c4e1591)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tolerance", value)

    @builtins.property
    @jsii.member(jsii_name="toleranceVar")
    def tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "toleranceVar"))

    @tolerance_var.setter
    def tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f88f18f97ecec45d38964e4c6c99dca7f63934768c76007766e76b6e03626d31)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "toleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanRemoveColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanRemoveColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanRemoveColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c0b10721701afc1b9285a174f446a12ce4176f3737e8f29e7f8cb4f64288c8af)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanUnsharpMask",
    jsii_struct_bases=[],
    name_mapping={
        "gain": "gain",
        "gain_var": "gainVar",
        "sigma": "sigma",
        "sigma_var": "sigmaVar",
        "threshold": "threshold",
        "threshold_var": "thresholdVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanUnsharpMask:
    def __init__(
        self,
        *,
        gain: typing.Optional[builtins.str] = None,
        gain_var: typing.Optional[builtins.str] = None,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
        threshold: typing.Optional[builtins.str] = None,
        threshold_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param gain: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        :param gain_var: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        :param sigma: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        :param threshold: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        :param threshold_var: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8ecb2ebb8b792cfc622d7d7c8500c22f53e8ab4d6fd126814c89219a1c173187)
            check_type(argname="argument gain", value=gain, expected_type=type_hints["gain"])
            check_type(argname="argument gain_var", value=gain_var, expected_type=type_hints["gain_var"])
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
            check_type(argname="argument threshold", value=threshold, expected_type=type_hints["threshold"])
            check_type(argname="argument threshold_var", value=threshold_var, expected_type=type_hints["threshold_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if gain is not None:
            self._values["gain"] = gain
        if gain_var is not None:
            self._values["gain_var"] = gain_var
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var
        if threshold is not None:
            self._values["threshold"] = threshold
        if threshold_var is not None:
            self._values["threshold_var"] = threshold_var

    @builtins.property
    def gain(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        '''
        result = self._values.get("gain")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gain_var(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        '''
        result = self._values.get("gain_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        '''
        result = self._values.get("threshold")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold_var(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        result = self._values.get("threshold_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanUnsharpMask(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanUnsharpMaskList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanUnsharpMaskList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eb817c8dfeac0a2e352632ba28c3d7a823a643832b1d3a59031ad99ae6d08c7c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanUnsharpMaskOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__67a72dcd2e4fc56c06bee6146f4ea8a7fd42cf5ce16b3f45b22445c969b15b6f)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanUnsharpMaskOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5185325f017828a27c21c5efe396f66c673b491c98beeee331802c2bd88d435d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e0de14670cdedaa0c03a28b19975e13f1dfd3aba8deb3dd74f86de85ac6b1409)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__47112a5d736acbafa1345baec6d92666c96fab7970f59af4f42bc65adaf1524a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanUnsharpMask]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanUnsharpMask]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanUnsharpMask]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__455d9c2b1f2074f3fa9252985e73cc2125ce786116dd66e834a0fc1f9348be99)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanUnsharpMaskOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanUnsharpMaskOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__20c6193b3b241063c80e545d1cc0745337f21972a663d026ceea10b7b9c3614c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetGain")
    def reset_gain(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGain", []))

    @jsii.member(jsii_name="resetGainVar")
    def reset_gain_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGainVar", []))

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @jsii.member(jsii_name="resetThreshold")
    def reset_threshold(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThreshold", []))

    @jsii.member(jsii_name="resetThresholdVar")
    def reset_threshold_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThresholdVar", []))

    @builtins.property
    @jsii.member(jsii_name="gainInput")
    def gain_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainInput"))

    @builtins.property
    @jsii.member(jsii_name="gainVarInput")
    def gain_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdInput")
    def threshold_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdVarInput")
    def threshold_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gain")
    def gain(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gain"))

    @gain.setter
    def gain(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__11c352bec3357e3865c124525432776b7d11d5db3ee6cca42e846ef97a62683d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gain", value)

    @builtins.property
    @jsii.member(jsii_name="gainVar")
    def gain_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gainVar"))

    @gain_var.setter
    def gain_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__97c90762093fe0eac6022ada72311694a599b6aebfac7049e081096a299bd713)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gainVar", value)

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__42f966d7168498e3b732bffeee2d4fd60774ea4fe1e8d872d8b4b7f115058332)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4bd1221198cf00f0bea90d9bd1a0edc06f59de59e2b56ce8d30a7db87886c686)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="threshold")
    def threshold(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "threshold"))

    @threshold.setter
    def threshold(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__40f0466eb493d8780244640fcf68ce2786d50ae084d94f2488719e7ffbf790e3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "threshold", value)

    @builtins.property
    @jsii.member(jsii_name="thresholdVar")
    def threshold_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "thresholdVar"))

    @threshold_var.setter
    def threshold_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b2b9827ddfa4dfa4335275f468f6a8d1f47902b733200f1d03ff1c2ca636075d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "thresholdVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanUnsharpMask]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanUnsharpMask]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanUnsharpMask]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0451f2d8f7a73840272a194e62797226ce25063bdecf0a1d71777f39115c2182)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e8877a8ac2964c551f60ef334757143fbc7ca34e9e0d410850be39769f8fd41e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d7359ea34a5e9a3080108a07fc28f594d1cc54a11648a07449bf6ea59d80cb34)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__96d86d09835a414124bba54a7ed8949eecb9156538e36dbee58c3fd5380bf100)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7cad569700b98523105eef11c873b1ffe53e9aca550af65559337e8c09aadef1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__67c200ab29c45196531c98356b5ec81dbda0ec34ddcc9b1db5780e91a9a5a49d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimension]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimension]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__42c4ac830fcba2eac7ffdb0bf50b89d34f4e6c7c0839b88fec54dae96e0e6c50)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__853a3fe9c35f5bc19017ebbda0d59ab4160b806f5cbf875fa492d12515d3a751)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(
        self,
        *,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefault(
            background_color=background_color,
            blur=blur,
            chroma_key=chroma_key,
            composite=composite,
            compound=compound,
            contrast=contrast,
            goop=goop,
            grayscale=grayscale,
            hsl=hsl,
            hsv=hsv,
            if_dimension=if_dimension,
            if_orientation=if_orientation,
            max_colors=max_colors,
            mirror=mirror,
            mono_hue=mono_hue,
            opacity=opacity,
            remove_color=remove_color,
            unsharp_mask=unsharp_mask,
        )

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putEqual")
    def put_equal(
        self,
        *,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqual(
            background_color=background_color,
            blur=blur,
            chroma_key=chroma_key,
            composite=composite,
            compound=compound,
            contrast=contrast,
            goop=goop,
            grayscale=grayscale,
            hsl=hsl,
            hsv=hsv,
            if_dimension=if_dimension,
            if_orientation=if_orientation,
            max_colors=max_colors,
            mirror=mirror,
            mono_hue=mono_hue,
            opacity=opacity,
            remove_color=remove_color,
            unsharp_mask=unsharp_mask,
        )

        return typing.cast(None, jsii.invoke(self, "putEqual", [value]))

    @jsii.member(jsii_name="putGreaterThan")
    def put_greater_than(
        self,
        *,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThan(
            background_color=background_color,
            blur=blur,
            chroma_key=chroma_key,
            composite=composite,
            compound=compound,
            contrast=contrast,
            goop=goop,
            grayscale=grayscale,
            hsl=hsl,
            hsv=hsv,
            if_dimension=if_dimension,
            if_orientation=if_orientation,
            max_colors=max_colors,
            mirror=mirror,
            mono_hue=mono_hue,
            opacity=opacity,
            remove_color=remove_color,
            unsharp_mask=unsharp_mask,
        )

        return typing.cast(None, jsii.invoke(self, "putGreaterThan", [value]))

    @jsii.member(jsii_name="putLessThan")
    def put_less_than(
        self,
        *,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThan(
            background_color=background_color,
            blur=blur,
            chroma_key=chroma_key,
            composite=composite,
            compound=compound,
            contrast=contrast,
            goop=goop,
            grayscale=grayscale,
            hsl=hsl,
            hsv=hsv,
            if_dimension=if_dimension,
            if_orientation=if_orientation,
            max_colors=max_colors,
            mirror=mirror,
            mono_hue=mono_hue,
            opacity=opacity,
            remove_color=remove_color,
            unsharp_mask=unsharp_mask,
        )

        return typing.cast(None, jsii.invoke(self, "putLessThan", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetDimension")
    def reset_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimension", []))

    @jsii.member(jsii_name="resetDimensionVar")
    def reset_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimensionVar", []))

    @jsii.member(jsii_name="resetEqual")
    def reset_equal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEqual", []))

    @jsii.member(jsii_name="resetGreaterThan")
    def reset_greater_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGreaterThan", []))

    @jsii.member(jsii_name="resetLessThan")
    def reset_less_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLessThan", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="equal")
    def equal(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualOutputReference, jsii.get(self, "equal"))

    @builtins.property
    @jsii.member(jsii_name="greaterThan")
    def greater_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanOutputReference, jsii.get(self, "greaterThan"))

    @builtins.property
    @jsii.member(jsii_name="lessThan")
    def less_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanOutputReference, jsii.get(self, "lessThan"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionInput")
    def dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionVarInput")
    def dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="equalInput")
    def equal_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqual], jsii.get(self, "equalInput"))

    @builtins.property
    @jsii.member(jsii_name="greaterThanInput")
    def greater_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThan], jsii.get(self, "greaterThanInput"))

    @builtins.property
    @jsii.member(jsii_name="lessThanInput")
    def less_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThan], jsii.get(self, "lessThanInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="dimension")
    def dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimension"))

    @dimension.setter
    def dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e8874b3414d5ac9d193876c6bed1be9a22144a79e00f8205e6b5344c5d85569e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimension", value)

    @builtins.property
    @jsii.member(jsii_name="dimensionVar")
    def dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimensionVar"))

    @dimension_var.setter
    def dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3716f4ae2704663d184e9ce3d23d24888301cbdcd3eff04070a7aa5c152493ff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__42714635ed0d516ed7f35bb93d1f6fbaf054d5418ceed0a7a2fe165662b63d52)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e5794a1024c2da21629ee8ac7318a4a3405d3d4d5bc9ba7e37a35e936f084cf8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimension]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimension]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimension]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e6b29d276a9b474a2227934f756b60c1dcd60fe2f6cec122ce3023d96b64f4a4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeMaxColors",
    jsii_struct_bases=[],
    name_mapping={"colors": "colors", "colors_var": "colorsVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeMaxColors:
    def __init__(
        self,
        *,
        colors: typing.Optional[builtins.str] = None,
        colors_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param colors: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        :param colors_var: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3475062fc15d6791e9cef72402abd6c48f4ef32afe222d560122a2e01663f086)
            check_type(argname="argument colors", value=colors, expected_type=type_hints["colors"])
            check_type(argname="argument colors_var", value=colors_var, expected_type=type_hints["colors_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if colors is not None:
            self._values["colors"] = colors
        if colors_var is not None:
            self._values["colors_var"] = colors_var

    @builtins.property
    def colors(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        '''
        result = self._values.get("colors")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def colors_var(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        result = self._values.get("colors_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeMaxColors(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeMaxColorsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeMaxColorsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__954ae67629bd8bc2c3a87d70462d0401e997daf040d13a68a469b69eb5ec9982)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeMaxColorsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a34ca5802aa6cb2fc2b7d964678c4086b75c712ec403f6eaac1776ebcd1b05bb)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeMaxColorsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cccb2be04b0199d87f44185d90a30eda7d9b21f477bf1b841c077ba46cc8a226)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__25bf71a6aedf6d1d37c7c7e8e1e99312833d97500fd7bf703e391b2829643b99)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9f3c5b6f7fdfaed3dda0114329181f5721a90032382dbcde52920dc29df0bddd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeMaxColors]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeMaxColors]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__34a9005f78a8aaf66a69c4f9d64f64b41722ccb04321ce636ee9cfc804e543d2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeMaxColorsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeMaxColorsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__95e5bab21e6f458f3348835c6107d040f0617025e209d6dc3522054faee46a83)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColors")
    def reset_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColors", []))

    @jsii.member(jsii_name="resetColorsVar")
    def reset_colors_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorsVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorsInput")
    def colors_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsInput"))

    @builtins.property
    @jsii.member(jsii_name="colorsVarInput")
    def colors_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsVarInput"))

    @builtins.property
    @jsii.member(jsii_name="colors")
    def colors(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colors"))

    @colors.setter
    def colors(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1b747b03dfe59da5402646361208270e40cfa21e0404b4ff8ac5c29952fe5b4d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colors", value)

    @builtins.property
    @jsii.member(jsii_name="colorsVar")
    def colors_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorsVar"))

    @colors_var.setter
    def colors_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__704fbeaf0e43d28615b1a696a6784c21efbec468bd79eb111d76fd01ae7f06b1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorsVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeMaxColors]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeMaxColors]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeMaxColors]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9f5dd405f24dcab86c991c26710f6be0f86a84e34d9a1158887a3fea5b54d341)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeMirror",
    jsii_struct_bases=[],
    name_mapping={
        "horizontal": "horizontal",
        "horizontal_var": "horizontalVar",
        "vertical": "vertical",
        "vertical_var": "verticalVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeMirror:
    def __init__(
        self,
        *,
        horizontal: typing.Optional[builtins.str] = None,
        horizontal_var: typing.Optional[builtins.str] = None,
        vertical: typing.Optional[builtins.str] = None,
        vertical_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param horizontal: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        :param horizontal_var: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        :param vertical: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        :param vertical_var: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__872458755cf51d43c6b30031b8adcecc4819d313d9d4f360560ed888dba85df0)
            check_type(argname="argument horizontal", value=horizontal, expected_type=type_hints["horizontal"])
            check_type(argname="argument horizontal_var", value=horizontal_var, expected_type=type_hints["horizontal_var"])
            check_type(argname="argument vertical", value=vertical, expected_type=type_hints["vertical"])
            check_type(argname="argument vertical_var", value=vertical_var, expected_type=type_hints["vertical_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if horizontal is not None:
            self._values["horizontal"] = horizontal
        if horizontal_var is not None:
            self._values["horizontal_var"] = horizontal_var
        if vertical is not None:
            self._values["vertical"] = vertical
        if vertical_var is not None:
            self._values["vertical_var"] = vertical_var

    @builtins.property
    def horizontal(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        '''
        result = self._values.get("horizontal")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def horizontal_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        '''
        result = self._values.get("horizontal_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        '''
        result = self._values.get("vertical")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        result = self._values.get("vertical_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeMirror(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeMirrorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeMirrorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__75558bfaa2f412c03dd3ffa8ccbe4500a70406ffb06390db34fa8fbb1c87aab9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeMirrorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7c8767184d5fb03b9d233df51738740014f1f621ad9b132387df105c2a6c8e1d)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeMirrorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__589c7953448b8560f5ab2d394833e1d3884d9c6eff416e60c2577ed9768c23f6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bdf2488df575c80430bd894e925f95a4d6ffc764989a7ea0b8027957d7233be4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e219fbffa863d1fc625c324279e95625143cb93e5c2260b4285b14699c9fe223)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeMirror]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeMirror]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ccc46d147043905ca7c49778355988072d18370e89d12772fb529a8748f17369)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeMirrorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeMirrorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__acce14c7264f16c721a9af74afb59aad2d377a658daeba1cc7e5e60e1c075631)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHorizontal")
    def reset_horizontal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontal", []))

    @jsii.member(jsii_name="resetHorizontalVar")
    def reset_horizontal_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontalVar", []))

    @jsii.member(jsii_name="resetVertical")
    def reset_vertical(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVertical", []))

    @jsii.member(jsii_name="resetVerticalVar")
    def reset_vertical_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVerticalVar", []))

    @builtins.property
    @jsii.member(jsii_name="horizontalInput")
    def horizontal_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontalVarInput")
    def horizontal_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalInput")
    def vertical_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalVarInput")
    def vertical_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontal")
    def horizontal(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontal"))

    @horizontal.setter
    def horizontal(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__94ebbc3cb3c8bab635abe3dc65f43fb3ebc33d64a8c2f30463f590532c9e70a1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontal", value)

    @builtins.property
    @jsii.member(jsii_name="horizontalVar")
    def horizontal_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontalVar"))

    @horizontal_var.setter
    def horizontal_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d1cb528b84aa4928420937d814779901a83dea23c4a319f86835733aacb0efb5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontalVar", value)

    @builtins.property
    @jsii.member(jsii_name="vertical")
    def vertical(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "vertical"))

    @vertical.setter
    def vertical(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__704b25d490a0452653ecc91cafa90f6576ea49e252aac95fe42d47548b891d7f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "vertical", value)

    @builtins.property
    @jsii.member(jsii_name="verticalVar")
    def vertical_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "verticalVar"))

    @vertical_var.setter
    def vertical_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f617bd5970fe68660bd047aae09acfd0ab2d2a0cccf9bc000147f6db8bd148c7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "verticalVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeMirror]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeMirror]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeMirror]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__29101d22230b6dcbb75383f725b80984e390888ca3b89489e55747995a1fa524)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeMonoHue",
    jsii_struct_bases=[],
    name_mapping={"hue": "hue", "hue_var": "hueVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeMonoHue:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__39dd8f653d140e29383125c57aebb15cecc17d8b39b0ccaaca9c798021e44b05)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeMonoHue(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeMonoHueList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeMonoHueList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6b938e7f8b3a54f1c629bed7806df40b2726abd5f3a3913b91f00eea36e4b9db)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeMonoHueOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cef02c29974ddb3cb046cf9f3876377c907f0ea2c1140ef066fd47bd1a27f259)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeMonoHueOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f3266e07e5210801e5e7cb02e8345a8c74308270a537c12889ae3095d94220b4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__66cce3f9575b16b2690306326c4d9c1c7fea4324eba590eb4b7b603cd2c17d82)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__41c9ae5ddfe1954868d2e3d5568281dcbc0bc45803e8ae23ad71ac5174fa2db5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeMonoHue]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeMonoHue]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e20f5e9eee328270c60b43014f24f4253c4688543c03438a1f15c622dd6de263)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeMonoHueOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeMonoHueOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__56b921518edb661af7ac214309662df1fe2bac981d31d184efc66c6c1611f764)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cc42cb1b9d25cd4db036b0646665fb4b51f45055a3eae9c1120c2b905a6c1771)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__178b50bd7815f2b1b58a3321aef539dd8c50cbdbaa5777bd7aede66c1de385a4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeMonoHue]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeMonoHue]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeMonoHue]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__de0592bee3fbb003f31ce31275ec5d14bd060a0fa21cf31f457a06d556e0cc7b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeOpacity",
    jsii_struct_bases=[],
    name_mapping={"opacity": "opacity", "opacity_var": "opacityVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeOpacity:
    def __init__(
        self,
        *,
        opacity: typing.Optional[builtins.str] = None,
        opacity_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param opacity: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param opacity_var: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__50e8a02a42dd0a341d4ee5c3e1cd4fe2df08c4c23c7c8e857ec878c57c13d25f)
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument opacity_var", value=opacity_var, expected_type=type_hints["opacity_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if opacity is not None:
            self._values["opacity"] = opacity
        if opacity_var is not None:
            self._values["opacity_var"] = opacity_var

    @builtins.property
    def opacity(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def opacity_var(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        result = self._values.get("opacity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeOpacity(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeOpacityList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeOpacityList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b559c57d6bf87e660fc0130c909a9235bca3779a32a4bcc7c4416c2adf631c1f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeOpacityOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__acfd3f32737440b049cbdf31c434463fe5f09233d05dc2dfe3e8e44550591c92)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeOpacityOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a6981fa1fa423ee28944518b6dac38414e86e67ccf0c9472e57ce751ea3a865)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0d00ff359d3edc42f617d651a1a0295ca66acda7e8fd14b995d9abb1fe7d9044)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8aea52bb49515ddecdf6d1ba46482bec2f7d6a4e5a2720b580e25f936b02be1f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeOpacity]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeOpacity]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a4967bd29899407eade2a34452049e4a14c2a3dc7cc46014fffff888d9fea87d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeOpacityOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeOpacityOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__87cc2d91bf208156fedb82ba2ff231b65af1960d294f1c0c00bba39d181b97dd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetOpacityVar")
    def reset_opacity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacityVar", []))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityVarInput")
    def opacity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacity"))

    @opacity.setter
    def opacity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__77c4b87d88dd06430eb01ed91a4075c4d6762914be2c4517d1849f1bb2c6e9e2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacity", value)

    @builtins.property
    @jsii.member(jsii_name="opacityVar")
    def opacity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacityVar"))

    @opacity_var.setter
    def opacity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6c6474d10c04b99366954ffb0df08cc02c9c13a78f43abc2a48d5f718a37b66f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacityVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeOpacity]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeOpacity]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeOpacity]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e432bace0cc3b7528084a41295ade2bf1779fd5ada394bcdd9acd785c4bb0325)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3c03c525ca2acceb98a210d778ffb1cf2a6bb328d0b90d3e5c20d00207913c14)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putBackgroundColor")
    def put_background_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d9f828cc05a843e3f02714f11db366b32124175d1cd12e44ee9b68479e02c740)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBackgroundColor", [value]))

    @jsii.member(jsii_name="putBlur")
    def put_blur(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeBlur, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa6767c1fa47a925e2ea8a296631508dfcc329cd0265b1fda23c01676ef28025)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBlur", [value]))

    @jsii.member(jsii_name="putChromaKey")
    def put_chroma_key(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeChromaKey, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__13d2198bb14af970abd918937e6ef8fd5d5daa0e6ba8a74c940ac87866776f2b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putChromaKey", [value]))

    @jsii.member(jsii_name="putComposite")
    def put_composite(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeComposite, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8cafef903765582548d1721375607878a3a2d8d73d12fda4a44697f38bdf99a0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putComposite", [value]))

    @jsii.member(jsii_name="putCompound")
    def put_compound(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompound, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__15e97aee62aa90d5466956ef26a49e86d9ee5c210a99e2b64efef44e923dd677)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCompound", [value]))

    @jsii.member(jsii_name="putContrast")
    def put_contrast(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeContrast, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c9fa440f8730817e923b1ac9de9d0ad0dc595cf3d57cadadefbf8139483593b5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putContrast", [value]))

    @jsii.member(jsii_name="putGoop")
    def put_goop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeGoop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__730d3201678aad03227aec6a184e53fe409d8259750cce5090bc8cca967e72f7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGoop", [value]))

    @jsii.member(jsii_name="putGrayscale")
    def put_grayscale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeGrayscale, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__96627c9cc80cb33c24dbabeeebbd42b1ebbc6caa0de1a426cab81338e478c123)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGrayscale", [value]))

    @jsii.member(jsii_name="putHsl")
    def put_hsl(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeHsl, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__77befbb7242fa56fabdec20def0f8b8c9d7a2dcc3d3dfe1f1d1bbaab5babae86)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsl", [value]))

    @jsii.member(jsii_name="putHsv")
    def put_hsv(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeHsv, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5a203bd17ced9ca3dac971730999fb4a24fe48093b1fd30ab03cd9c399b17bec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsv", [value]))

    @jsii.member(jsii_name="putIfDimension")
    def put_if_dimension(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimension, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c22de40ba26d31d55ddf3b25a916b943789b67931cef20ba0cb5d7327f3f5dd6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfDimension", [value]))

    @jsii.member(jsii_name="putIfOrientation")
    def put_if_orientation(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e6e55be45029e0dca3ea675b44dcf5e7c067134b67fe2c7425e4ee5a59d8e1a9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfOrientation", [value]))

    @jsii.member(jsii_name="putMaxColors")
    def put_max_colors(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeMaxColors, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__333e1ba26872fdd67839d2a1ff85de050074588816e79a0bc37669a81d583b58)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMaxColors", [value]))

    @jsii.member(jsii_name="putMirror")
    def put_mirror(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeMirror, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8857aae5b2217b47b941f0cb3005ab8cfc3f10320ff2d6893f56718b83b47caf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMirror", [value]))

    @jsii.member(jsii_name="putMonoHue")
    def put_mono_hue(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeMonoHue, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d23796765a002ecd26fac70cd8ca151a9f553d94357f532825d1439eb169bf06)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMonoHue", [value]))

    @jsii.member(jsii_name="putOpacity")
    def put_opacity(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeOpacity, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9e92bc3e9e2fc4eba9477fb59cab414ba6d763561c5be3fe63a974a0311909d4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putOpacity", [value]))

    @jsii.member(jsii_name="putRemoveColor")
    def put_remove_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeRemoveColor", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e1f639dde5c06306dba0fc1140e9ce9985f7cf434be468e8de87ec0db09c56eb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRemoveColor", [value]))

    @jsii.member(jsii_name="putUnsharpMask")
    def put_unsharp_mask(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeUnsharpMask", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b01f55e214ffa776c819e5397cc6b9aae786bac268bdff7bede70f1f00c6d96c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putUnsharpMask", [value]))

    @jsii.member(jsii_name="resetBackgroundColor")
    def reset_background_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBackgroundColor", []))

    @jsii.member(jsii_name="resetBlur")
    def reset_blur(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBlur", []))

    @jsii.member(jsii_name="resetChromaKey")
    def reset_chroma_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChromaKey", []))

    @jsii.member(jsii_name="resetComposite")
    def reset_composite(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetComposite", []))

    @jsii.member(jsii_name="resetCompound")
    def reset_compound(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCompound", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetGoop")
    def reset_goop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGoop", []))

    @jsii.member(jsii_name="resetGrayscale")
    def reset_grayscale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGrayscale", []))

    @jsii.member(jsii_name="resetHsl")
    def reset_hsl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsl", []))

    @jsii.member(jsii_name="resetHsv")
    def reset_hsv(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsv", []))

    @jsii.member(jsii_name="resetIfDimension")
    def reset_if_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfDimension", []))

    @jsii.member(jsii_name="resetIfOrientation")
    def reset_if_orientation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfOrientation", []))

    @jsii.member(jsii_name="resetMaxColors")
    def reset_max_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxColors", []))

    @jsii.member(jsii_name="resetMirror")
    def reset_mirror(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMirror", []))

    @jsii.member(jsii_name="resetMonoHue")
    def reset_mono_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonoHue", []))

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetRemoveColor")
    def reset_remove_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRemoveColor", []))

    @jsii.member(jsii_name="resetUnsharpMask")
    def reset_unsharp_mask(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUnsharpMask", []))

    @builtins.property
    @jsii.member(jsii_name="backgroundColor")
    def background_color(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeBackgroundColorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeBackgroundColorList, jsii.get(self, "backgroundColor"))

    @builtins.property
    @jsii.member(jsii_name="blur")
    def blur(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeBlurList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeBlurList, jsii.get(self, "blur"))

    @builtins.property
    @jsii.member(jsii_name="chromaKey")
    def chroma_key(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeChromaKeyList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeChromaKeyList, jsii.get(self, "chromaKey"))

    @builtins.property
    @jsii.member(jsii_name="composite")
    def composite(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeList, jsii.get(self, "composite"))

    @builtins.property
    @jsii.member(jsii_name="compound")
    def compound(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundList, jsii.get(self, "compound"))

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeContrastList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeContrastList, jsii.get(self, "contrast"))

    @builtins.property
    @jsii.member(jsii_name="goop")
    def goop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeGoopList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeGoopList, jsii.get(self, "goop"))

    @builtins.property
    @jsii.member(jsii_name="grayscale")
    def grayscale(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeGrayscaleList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeGrayscaleList, jsii.get(self, "grayscale"))

    @builtins.property
    @jsii.member(jsii_name="hsl")
    def hsl(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeHslList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeHslList, jsii.get(self, "hsl"))

    @builtins.property
    @jsii.member(jsii_name="hsv")
    def hsv(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeHsvList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeHsvList, jsii.get(self, "hsv"))

    @builtins.property
    @jsii.member(jsii_name="ifDimension")
    def if_dimension(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionList, jsii.get(self, "ifDimension"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientation")
    def if_orientation(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationList", jsii.get(self, "ifOrientation"))

    @builtins.property
    @jsii.member(jsii_name="maxColors")
    def max_colors(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeMaxColorsList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeMaxColorsList, jsii.get(self, "maxColors"))

    @builtins.property
    @jsii.member(jsii_name="mirror")
    def mirror(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeMirrorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeMirrorList, jsii.get(self, "mirror"))

    @builtins.property
    @jsii.member(jsii_name="monoHue")
    def mono_hue(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeMonoHueList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeMonoHueList, jsii.get(self, "monoHue"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeOpacityList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeOpacityList, jsii.get(self, "opacity"))

    @builtins.property
    @jsii.member(jsii_name="removeColor")
    def remove_color(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeRemoveColorList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeRemoveColorList", jsii.get(self, "removeColor"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMask")
    def unsharp_mask(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeUnsharpMaskList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeUnsharpMaskList", jsii.get(self, "unsharpMask"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColorInput")
    def background_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeBackgroundColor]]], jsii.get(self, "backgroundColorInput"))

    @builtins.property
    @jsii.member(jsii_name="blurInput")
    def blur_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeBlur]]], jsii.get(self, "blurInput"))

    @builtins.property
    @jsii.member(jsii_name="chromaKeyInput")
    def chroma_key_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeChromaKey]]], jsii.get(self, "chromaKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="compositeInput")
    def composite_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeComposite]]], jsii.get(self, "compositeInput"))

    @builtins.property
    @jsii.member(jsii_name="compoundInput")
    def compound_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompound]]], jsii.get(self, "compoundInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeContrast]]], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="goopInput")
    def goop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeGoop]]], jsii.get(self, "goopInput"))

    @builtins.property
    @jsii.member(jsii_name="grayscaleInput")
    def grayscale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeGrayscale]]], jsii.get(self, "grayscaleInput"))

    @builtins.property
    @jsii.member(jsii_name="hslInput")
    def hsl_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeHsl]]], jsii.get(self, "hslInput"))

    @builtins.property
    @jsii.member(jsii_name="hsvInput")
    def hsv_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeHsv]]], jsii.get(self, "hsvInput"))

    @builtins.property
    @jsii.member(jsii_name="ifDimensionInput")
    def if_dimension_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimension]]], jsii.get(self, "ifDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientationInput")
    def if_orientation_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientation]]], jsii.get(self, "ifOrientationInput"))

    @builtins.property
    @jsii.member(jsii_name="maxColorsInput")
    def max_colors_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeMaxColors]]], jsii.get(self, "maxColorsInput"))

    @builtins.property
    @jsii.member(jsii_name="mirrorInput")
    def mirror_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeMirror]]], jsii.get(self, "mirrorInput"))

    @builtins.property
    @jsii.member(jsii_name="monoHueInput")
    def mono_hue_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeMonoHue]]], jsii.get(self, "monoHueInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeOpacity]]], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="removeColorInput")
    def remove_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeRemoveColor"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeRemoveColor"]]], jsii.get(self, "removeColorInput"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMaskInput")
    def unsharp_mask_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeUnsharpMask"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeUnsharpMask"]]], jsii.get(self, "unsharpMaskInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscape], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscape],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__162c7fb3b65f277fd52feb347dab769dce3a3b66be1e5231d05e91b4de13b6af)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeRemoveColor",
    jsii_struct_bases=[],
    name_mapping={
        "color": "color",
        "color_var": "colorVar",
        "feather": "feather",
        "feather_var": "featherVar",
        "tolerance": "tolerance",
        "tolerance_var": "toleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeRemoveColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
        feather: typing.Optional[builtins.str] = None,
        feather_var: typing.Optional[builtins.str] = None,
        tolerance: typing.Optional[builtins.str] = None,
        tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        :param feather: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        :param feather_var: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        :param tolerance: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        :param tolerance_var: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cef0b3f9701b17c04984c551a661e0f11e0dfb12fbf57e1678373a51d935fa64)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
            check_type(argname="argument feather", value=feather, expected_type=type_hints["feather"])
            check_type(argname="argument feather_var", value=feather_var, expected_type=type_hints["feather_var"])
            check_type(argname="argument tolerance", value=tolerance, expected_type=type_hints["tolerance"])
            check_type(argname="argument tolerance_var", value=tolerance_var, expected_type=type_hints["tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var
        if feather is not None:
            self._values["feather"] = feather
        if feather_var is not None:
            self._values["feather_var"] = feather_var
        if tolerance is not None:
            self._values["tolerance"] = tolerance
        if tolerance_var is not None:
            self._values["tolerance_var"] = tolerance_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        '''
        result = self._values.get("feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather_var(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        '''
        result = self._values.get("feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        '''
        result = self._values.get("tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance_var(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        result = self._values.get("tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeRemoveColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeRemoveColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeRemoveColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fb8d6cecf65626003fc35c3bc06cfef8275c89a2bf87b2d118cf07ee93d71a81)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeRemoveColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6555e3799e2cac8971b5841364e11f9be4854761c25b70afa6d0adba338cb629)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeRemoveColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__efeb3207a1be4483818a4764ff1457814343a30f6447040a822eba725ece8f5b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d7c3038055f3cd7bdbddba0847dadada0c5881ad5886a3e2ae5d4d92b0006ada)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ec207aeab4fa73bf6f9719a32fffb4c61570b2636cc28a1131f3ab6e1bb58de1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeRemoveColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeRemoveColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeRemoveColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3b97103180e95418ec026da5f08fa0f6fa39a53ec4c463eb93f3fb1213c0de9d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeRemoveColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeRemoveColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b03e48e1690beb1cbbe8679a08a5b889f6cc47024c9b5dc3c5a35f5960401d6e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @jsii.member(jsii_name="resetFeather")
    def reset_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeather", []))

    @jsii.member(jsii_name="resetFeatherVar")
    def reset_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatherVar", []))

    @jsii.member(jsii_name="resetTolerance")
    def reset_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTolerance", []))

    @jsii.member(jsii_name="resetToleranceVar")
    def reset_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featherInput")
    def feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherInput"))

    @builtins.property
    @jsii.member(jsii_name="featherVarInput")
    def feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceInput")
    def tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceVarInput")
    def tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6b6aefaed4c801b480853375dd5a9caae19b5a013b62840d46c779f01c8d181e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0353e7519394edf6813525a937a754166786d803bc2770cab2ed8341bb41e4dc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="feather")
    def feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "feather"))

    @feather.setter
    def feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__64c4f25cfc04e9fac3587f62b0b0bcfecb2863cb25f36ecba425b2256a51bb16)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "feather", value)

    @builtins.property
    @jsii.member(jsii_name="featherVar")
    def feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featherVar"))

    @feather_var.setter
    def feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__621a50d40c93b5b84506d7e994aa69dfec7b757830d9ce94cc61545b5baf0e54)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featherVar", value)

    @builtins.property
    @jsii.member(jsii_name="tolerance")
    def tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tolerance"))

    @tolerance.setter
    def tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bcbd28ad0f71577ed173ec271d3de8e267f2b086cd4609e9daedb10434287566)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tolerance", value)

    @builtins.property
    @jsii.member(jsii_name="toleranceVar")
    def tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "toleranceVar"))

    @tolerance_var.setter
    def tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cf5bc7ded168a322155143c6aadc0c7f1b56b959c74f8a80bfebf86d616aa375)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "toleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeRemoveColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeRemoveColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeRemoveColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__feac9da18a46a302405894fe28df8c011724cbabe8803474168dc514a295f3bb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeUnsharpMask",
    jsii_struct_bases=[],
    name_mapping={
        "gain": "gain",
        "gain_var": "gainVar",
        "sigma": "sigma",
        "sigma_var": "sigmaVar",
        "threshold": "threshold",
        "threshold_var": "thresholdVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeUnsharpMask:
    def __init__(
        self,
        *,
        gain: typing.Optional[builtins.str] = None,
        gain_var: typing.Optional[builtins.str] = None,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
        threshold: typing.Optional[builtins.str] = None,
        threshold_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param gain: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        :param gain_var: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        :param sigma: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        :param threshold: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        :param threshold_var: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9566124c2bb9846157da7609fb5d991cb20a1e318d5e63e30d2c928ac67f6f76)
            check_type(argname="argument gain", value=gain, expected_type=type_hints["gain"])
            check_type(argname="argument gain_var", value=gain_var, expected_type=type_hints["gain_var"])
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
            check_type(argname="argument threshold", value=threshold, expected_type=type_hints["threshold"])
            check_type(argname="argument threshold_var", value=threshold_var, expected_type=type_hints["threshold_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if gain is not None:
            self._values["gain"] = gain
        if gain_var is not None:
            self._values["gain_var"] = gain_var
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var
        if threshold is not None:
            self._values["threshold"] = threshold
        if threshold_var is not None:
            self._values["threshold_var"] = threshold_var

    @builtins.property
    def gain(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        '''
        result = self._values.get("gain")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gain_var(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        '''
        result = self._values.get("gain_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        '''
        result = self._values.get("threshold")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold_var(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        result = self._values.get("threshold_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeUnsharpMask(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeUnsharpMaskList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeUnsharpMaskList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__91525357e572184e62a9df3a264284b4a597030ef2f3630f491f162244265f5d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeUnsharpMaskOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a72090980a4d367001109ae3d67d3d6502c4b8b8af5cb30a4ddab60a7d516c79)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeUnsharpMaskOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__232252c5e3560b2e91566224500de53d0fbb4ef557e18039592d592286c03c33)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f6276a4ab97f326669dd9bd33557bc737508f462abc77fc2f22a82b07518388)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f5250196f0e4846feb1921fbec63a054265682b4b7c3efbf536d41b0e84643fa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeUnsharpMask]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeUnsharpMask]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeUnsharpMask]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6d1d9a7a1e88a2dda77e96337d9829d62e4bd79ca2536d00131613752f75f1bd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeUnsharpMaskOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeUnsharpMaskOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__41634d1e6f6d62cf940926fef4a93be23e57d143ea36cc4f7bb635936bcad0a3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetGain")
    def reset_gain(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGain", []))

    @jsii.member(jsii_name="resetGainVar")
    def reset_gain_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGainVar", []))

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @jsii.member(jsii_name="resetThreshold")
    def reset_threshold(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThreshold", []))

    @jsii.member(jsii_name="resetThresholdVar")
    def reset_threshold_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThresholdVar", []))

    @builtins.property
    @jsii.member(jsii_name="gainInput")
    def gain_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainInput"))

    @builtins.property
    @jsii.member(jsii_name="gainVarInput")
    def gain_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdInput")
    def threshold_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdVarInput")
    def threshold_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gain")
    def gain(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gain"))

    @gain.setter
    def gain(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3bbca4947caa321f394ecda34dfcbfa186f8a35aca26247c1ba0e991eac1379f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gain", value)

    @builtins.property
    @jsii.member(jsii_name="gainVar")
    def gain_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gainVar"))

    @gain_var.setter
    def gain_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__17df0e4201fe8f12552f29c06fd846aacd03fed075b42299e86d8b304e1b3938)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gainVar", value)

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ca779cd12d204fe09687e554aace8774ae96bc207835a1b818e1866b8074213a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c25197644e659dbeb6ded4a20116b65a0aa74fbba7892ec16b57c1c636fa675a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="threshold")
    def threshold(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "threshold"))

    @threshold.setter
    def threshold(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__445b223ac2b957c963f5437fbc8afc0efeaa83251663876e46406207ea90c102)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "threshold", value)

    @builtins.property
    @jsii.member(jsii_name="thresholdVar")
    def threshold_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "thresholdVar"))

    @threshold_var.setter
    def threshold_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5e5b3e130b24f1af4810069b1e1257a54fe6c49f292aa294093945a7deb53fcd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "thresholdVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeUnsharpMask]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeUnsharpMask]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeUnsharpMask]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__07d97e9ebd0e656aca7c870101f16ce6d92665ade53bc4ae2ed6d8f7c61d5454)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3491f1c16f9fc7ac6e37dd431a4f9780f9b66639c5db3c26ed84c380b8e98410)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3c32f00ca1055d10b7dd45e8f76199b68466251a3c2d849aa574ff5a11a864b3)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__90f2c4d8597be5e3248f35102197beac08bd5b2bb4057d1daa5f033db2527f43)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8f476b4d23c1effd5a8605855567df9e423463a0f9e0577b41cb121bcdb4fc49)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__752e76c6eefda2830036ddad33d520ca9ed780677607db399cc4b7b6410d0f52)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientation]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientation]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__db68611e46d6b3a41293e15311c65b4e6a2acd93cc95c657a26d6b8f00223ca7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c74d1f05a30fe7dbd30f3a6ed168d5ecf275c4c665c9fea2f9d0cc9c50395e92)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(
        self,
        *,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefault(
            background_color=background_color,
            blur=blur,
            chroma_key=chroma_key,
            composite=composite,
            compound=compound,
            contrast=contrast,
            goop=goop,
            grayscale=grayscale,
            hsl=hsl,
            hsv=hsv,
            if_dimension=if_dimension,
            if_orientation=if_orientation,
            max_colors=max_colors,
            mirror=mirror,
            mono_hue=mono_hue,
            opacity=opacity,
            remove_color=remove_color,
            unsharp_mask=unsharp_mask,
        )

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putLandscape")
    def put_landscape(
        self,
        *,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscape(
            background_color=background_color,
            blur=blur,
            chroma_key=chroma_key,
            composite=composite,
            compound=compound,
            contrast=contrast,
            goop=goop,
            grayscale=grayscale,
            hsl=hsl,
            hsv=hsv,
            if_dimension=if_dimension,
            if_orientation=if_orientation,
            max_colors=max_colors,
            mirror=mirror,
            mono_hue=mono_hue,
            opacity=opacity,
            remove_color=remove_color,
            unsharp_mask=unsharp_mask,
        )

        return typing.cast(None, jsii.invoke(self, "putLandscape", [value]))

    @jsii.member(jsii_name="putPortrait")
    def put_portrait(
        self,
        *,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitBackgroundColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitBlur", typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitChromaKey", typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitComposite", typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompound", typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitContrast", typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitGoop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitGrayscale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitHsl", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitHsv", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimension", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitMaxColors", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitMirror", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitMonoHue", typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitOpacity", typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitRemoveColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitUnsharpMask", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortrait(
            background_color=background_color,
            blur=blur,
            chroma_key=chroma_key,
            composite=composite,
            compound=compound,
            contrast=contrast,
            goop=goop,
            grayscale=grayscale,
            hsl=hsl,
            hsv=hsv,
            if_dimension=if_dimension,
            if_orientation=if_orientation,
            max_colors=max_colors,
            mirror=mirror,
            mono_hue=mono_hue,
            opacity=opacity,
            remove_color=remove_color,
            unsharp_mask=unsharp_mask,
        )

        return typing.cast(None, jsii.invoke(self, "putPortrait", [value]))

    @jsii.member(jsii_name="putSquare")
    def put_square(
        self,
        *,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareBackgroundColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareBlur", typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareChromaKey", typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareComposite", typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompound", typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareContrast", typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareGoop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareGrayscale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareHsl", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareHsv", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimension", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareMaxColors", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareMirror", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareMonoHue", typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareOpacity", typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareRemoveColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareUnsharpMask", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquare(
            background_color=background_color,
            blur=blur,
            chroma_key=chroma_key,
            composite=composite,
            compound=compound,
            contrast=contrast,
            goop=goop,
            grayscale=grayscale,
            hsl=hsl,
            hsv=hsv,
            if_dimension=if_dimension,
            if_orientation=if_orientation,
            max_colors=max_colors,
            mirror=mirror,
            mono_hue=mono_hue,
            opacity=opacity,
            remove_color=remove_color,
            unsharp_mask=unsharp_mask,
        )

        return typing.cast(None, jsii.invoke(self, "putSquare", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetLandscape")
    def reset_landscape(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLandscape", []))

    @jsii.member(jsii_name="resetPortrait")
    def reset_portrait(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPortrait", []))

    @jsii.member(jsii_name="resetSquare")
    def reset_square(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSquare", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="landscape")
    def landscape(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeOutputReference, jsii.get(self, "landscape"))

    @builtins.property
    @jsii.member(jsii_name="portrait")
    def portrait(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitOutputReference", jsii.get(self, "portrait"))

    @builtins.property
    @jsii.member(jsii_name="square")
    def square(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareOutputReference", jsii.get(self, "square"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="landscapeInput")
    def landscape_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscape], jsii.get(self, "landscapeInput"))

    @builtins.property
    @jsii.member(jsii_name="portraitInput")
    def portrait_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortrait"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortrait"], jsii.get(self, "portraitInput"))

    @builtins.property
    @jsii.member(jsii_name="squareInput")
    def square_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquare"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquare"], jsii.get(self, "squareInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientation]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientation]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientation]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a6aa77d5cd5a515d03f13651463a891caab9c832cd4583c3638bc9d71d6a8228)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortrait",
    jsii_struct_bases=[],
    name_mapping={
        "background_color": "backgroundColor",
        "blur": "blur",
        "chroma_key": "chromaKey",
        "composite": "composite",
        "compound": "compound",
        "contrast": "contrast",
        "goop": "goop",
        "grayscale": "grayscale",
        "hsl": "hsl",
        "hsv": "hsv",
        "if_dimension": "ifDimension",
        "if_orientation": "ifOrientation",
        "max_colors": "maxColors",
        "mirror": "mirror",
        "mono_hue": "monoHue",
        "opacity": "opacity",
        "remove_color": "removeColor",
        "unsharp_mask": "unsharpMask",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortrait:
    def __init__(
        self,
        *,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitBackgroundColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitBlur", typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitChromaKey", typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitComposite", typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompound", typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitContrast", typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitGoop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitGrayscale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitHsl", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitHsv", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimension", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitMaxColors", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitMirror", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitMonoHue", typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitOpacity", typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitRemoveColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitUnsharpMask", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__69621a44ffcee1796b305e9faa73742bc20f4c1f4898073b22de0f83f40365d7)
            check_type(argname="argument background_color", value=background_color, expected_type=type_hints["background_color"])
            check_type(argname="argument blur", value=blur, expected_type=type_hints["blur"])
            check_type(argname="argument chroma_key", value=chroma_key, expected_type=type_hints["chroma_key"])
            check_type(argname="argument composite", value=composite, expected_type=type_hints["composite"])
            check_type(argname="argument compound", value=compound, expected_type=type_hints["compound"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument goop", value=goop, expected_type=type_hints["goop"])
            check_type(argname="argument grayscale", value=grayscale, expected_type=type_hints["grayscale"])
            check_type(argname="argument hsl", value=hsl, expected_type=type_hints["hsl"])
            check_type(argname="argument hsv", value=hsv, expected_type=type_hints["hsv"])
            check_type(argname="argument if_dimension", value=if_dimension, expected_type=type_hints["if_dimension"])
            check_type(argname="argument if_orientation", value=if_orientation, expected_type=type_hints["if_orientation"])
            check_type(argname="argument max_colors", value=max_colors, expected_type=type_hints["max_colors"])
            check_type(argname="argument mirror", value=mirror, expected_type=type_hints["mirror"])
            check_type(argname="argument mono_hue", value=mono_hue, expected_type=type_hints["mono_hue"])
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument remove_color", value=remove_color, expected_type=type_hints["remove_color"])
            check_type(argname="argument unsharp_mask", value=unsharp_mask, expected_type=type_hints["unsharp_mask"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if background_color is not None:
            self._values["background_color"] = background_color
        if blur is not None:
            self._values["blur"] = blur
        if chroma_key is not None:
            self._values["chroma_key"] = chroma_key
        if composite is not None:
            self._values["composite"] = composite
        if compound is not None:
            self._values["compound"] = compound
        if contrast is not None:
            self._values["contrast"] = contrast
        if goop is not None:
            self._values["goop"] = goop
        if grayscale is not None:
            self._values["grayscale"] = grayscale
        if hsl is not None:
            self._values["hsl"] = hsl
        if hsv is not None:
            self._values["hsv"] = hsv
        if if_dimension is not None:
            self._values["if_dimension"] = if_dimension
        if if_orientation is not None:
            self._values["if_orientation"] = if_orientation
        if max_colors is not None:
            self._values["max_colors"] = max_colors
        if mirror is not None:
            self._values["mirror"] = mirror
        if mono_hue is not None:
            self._values["mono_hue"] = mono_hue
        if opacity is not None:
            self._values["opacity"] = opacity
        if remove_color is not None:
            self._values["remove_color"] = remove_color
        if unsharp_mask is not None:
            self._values["unsharp_mask"] = unsharp_mask

    @builtins.property
    def background_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitBackgroundColor"]]]:
        '''background_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        '''
        result = self._values.get("background_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitBackgroundColor"]]], result)

    @builtins.property
    def blur(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitBlur"]]]:
        '''blur block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        '''
        result = self._values.get("blur")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitBlur"]]], result)

    @builtins.property
    def chroma_key(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitChromaKey"]]]:
        '''chroma_key block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        '''
        result = self._values.get("chroma_key")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitChromaKey"]]], result)

    @builtins.property
    def composite(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitComposite"]]]:
        '''composite block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        '''
        result = self._values.get("composite")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitComposite"]]], result)

    @builtins.property
    def compound(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompound"]]]:
        '''compound block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        '''
        result = self._values.get("compound")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompound"]]], result)

    @builtins.property
    def contrast(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitContrast"]]]:
        '''contrast block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitContrast"]]], result)

    @builtins.property
    def goop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitGoop"]]]:
        '''goop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        '''
        result = self._values.get("goop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitGoop"]]], result)

    @builtins.property
    def grayscale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitGrayscale"]]]:
        '''grayscale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        '''
        result = self._values.get("grayscale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitGrayscale"]]], result)

    @builtins.property
    def hsl(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitHsl"]]]:
        '''hsl block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        '''
        result = self._values.get("hsl")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitHsl"]]], result)

    @builtins.property
    def hsv(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitHsv"]]]:
        '''hsv block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        '''
        result = self._values.get("hsv")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitHsv"]]], result)

    @builtins.property
    def if_dimension(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimension"]]]:
        '''if_dimension block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        '''
        result = self._values.get("if_dimension")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimension"]]], result)

    @builtins.property
    def if_orientation(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientation]]]:
        '''if_orientation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        '''
        result = self._values.get("if_orientation")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientation]]], result)

    @builtins.property
    def max_colors(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitMaxColors"]]]:
        '''max_colors block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        '''
        result = self._values.get("max_colors")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitMaxColors"]]], result)

    @builtins.property
    def mirror(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitMirror"]]]:
        '''mirror block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        '''
        result = self._values.get("mirror")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitMirror"]]], result)

    @builtins.property
    def mono_hue(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitMonoHue"]]]:
        '''mono_hue block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        '''
        result = self._values.get("mono_hue")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitMonoHue"]]], result)

    @builtins.property
    def opacity(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitOpacity"]]]:
        '''opacity block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitOpacity"]]], result)

    @builtins.property
    def remove_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitRemoveColor"]]]:
        '''remove_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        '''
        result = self._values.get("remove_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitRemoveColor"]]], result)

    @builtins.property
    def unsharp_mask(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitUnsharpMask"]]]:
        '''unsharp_mask block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        result = self._values.get("unsharp_mask")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitUnsharpMask"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortrait(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitBackgroundColor",
    jsii_struct_bases=[],
    name_mapping={"color": "color", "color_var": "colorVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitBackgroundColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2fd2c07a39288a3c91ab489cbfefb45186689c0226655f55b44640139ce9cdc7)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitBackgroundColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitBackgroundColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitBackgroundColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__64840646e5b7a3999686f23184f3c6deeaa63ebca26ffd2e4c2bb87b9b90a207)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitBackgroundColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__00cfd01e2ba3d03d2e3944d30452bd043346e1a9a95cc2fb119868a32a20a56b)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitBackgroundColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be62826f5bf5f07ce34b84e958dad2363855580dd1e71ca8baead9e41ca1a204)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fc130a651faf79f2cfdc5a33caf4c7367396a0495ddf908d9253b44d238f047f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ccc9a020041e144ec6460eaade8fb70c97bc7c7a01f52397a0beecd8bdab8dce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitBackgroundColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitBackgroundColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ac1f7adb76f77dd9dab0b9c161096b8fb077cba5e3a03c7c4b0d2bdeae5eafd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitBackgroundColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitBackgroundColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2fa441903f3e192746246787f1858e65865236581a3e8c2f520c2dc2d8146222)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f5c436a6efcb8879cdf1a60423c357a3eb271b0d4787d5cf98208d43689d0dca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c112b77bbe64925620eaf82e1d023c313f0cc9981ad68f60f43cbacf80cd5590)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitBackgroundColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitBackgroundColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitBackgroundColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7ce975705507d7ea1909bb18765862ce2319674619570994268a3d770d2ec17a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitBlur",
    jsii_struct_bases=[],
    name_mapping={"sigma": "sigma", "sigma_var": "sigmaVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitBlur:
    def __init__(
        self,
        *,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param sigma: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ddc3c3a545171aaece2c0b7d59e32948282805837bed8b5cdbf21349d43cbbd9)
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitBlur(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitBlurList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitBlurList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7563fb516c77fb3359569150ec25bb848271c5f41dbb07ff6443c567cfb3a61b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitBlurOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__60aea7751026a3d60ae0d2452ab81402f37f358d6956a573226c492c490cd0c8)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitBlurOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e1d17d6ebfad2f37c8d9e144dff8d17b9759a31b5193a7013e28d0957a462de1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1dc15461c360eaea53fd4d9b8cb266cdf87adaeb74587ac4bafacae1a64fbcbe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c57f6c83445b0f32586a32ebd20ff35e476df659f3bf936b3ece21621f2bbc2e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitBlur]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitBlur]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__87640aa91a1dfbb399b296ad0d43bdd3f05e7d5567f3dda8c0dc1eced2427b08)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitBlurOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitBlurOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2f2f579eba576a2e3814cdb6af40059b32ec2f2af4a796d0dc62e01bc201e184)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__faa4790e0a97d87a586fe2af439d069ad443efbcf7afcd24380abd58b64a434b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__03476b1e17450636794d2602f46adcacbaf317d067b02401485a4ad9751eb209)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitBlur]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitBlur]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitBlur]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8e197ec573b7d38170ee6b35cf4a23d86b8abaea19b07a163338b1d82e0ee972)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitChromaKey",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_feather": "hueFeather",
        "hue_feather_var": "hueFeatherVar",
        "hue_tolerance": "hueTolerance",
        "hue_tolerance_var": "hueToleranceVar",
        "hue_var": "hueVar",
        "lightness_feather": "lightnessFeather",
        "lightness_feather_var": "lightnessFeatherVar",
        "lightness_tolerance": "lightnessTolerance",
        "lightness_tolerance_var": "lightnessToleranceVar",
        "saturation_feather": "saturationFeather",
        "saturation_feather_var": "saturationFeatherVar",
        "saturation_tolerance": "saturationTolerance",
        "saturation_tolerance_var": "saturationToleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitChromaKey:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_feather: typing.Optional[builtins.str] = None,
        hue_feather_var: typing.Optional[builtins.str] = None,
        hue_tolerance: typing.Optional[builtins.str] = None,
        hue_tolerance_var: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness_feather: typing.Optional[builtins.str] = None,
        lightness_feather_var: typing.Optional[builtins.str] = None,
        lightness_tolerance: typing.Optional[builtins.str] = None,
        lightness_tolerance_var: typing.Optional[builtins.str] = None,
        saturation_feather: typing.Optional[builtins.str] = None,
        saturation_feather_var: typing.Optional[builtins.str] = None,
        saturation_tolerance: typing.Optional[builtins.str] = None,
        saturation_tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_feather: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        :param hue_feather_var: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        :param hue_tolerance: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        :param hue_tolerance_var: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        :param hue_var: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness_feather: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        :param lightness_feather_var: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        :param lightness_tolerance: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        :param lightness_tolerance_var: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        :param saturation_feather: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        :param saturation_feather_var: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        :param saturation_tolerance: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        :param saturation_tolerance_var: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c143006a84149b2cd338de8d6a299ab9f18a572c47b560219e94eb58a6dd5ce8)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_feather", value=hue_feather, expected_type=type_hints["hue_feather"])
            check_type(argname="argument hue_feather_var", value=hue_feather_var, expected_type=type_hints["hue_feather_var"])
            check_type(argname="argument hue_tolerance", value=hue_tolerance, expected_type=type_hints["hue_tolerance"])
            check_type(argname="argument hue_tolerance_var", value=hue_tolerance_var, expected_type=type_hints["hue_tolerance_var"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness_feather", value=lightness_feather, expected_type=type_hints["lightness_feather"])
            check_type(argname="argument lightness_feather_var", value=lightness_feather_var, expected_type=type_hints["lightness_feather_var"])
            check_type(argname="argument lightness_tolerance", value=lightness_tolerance, expected_type=type_hints["lightness_tolerance"])
            check_type(argname="argument lightness_tolerance_var", value=lightness_tolerance_var, expected_type=type_hints["lightness_tolerance_var"])
            check_type(argname="argument saturation_feather", value=saturation_feather, expected_type=type_hints["saturation_feather"])
            check_type(argname="argument saturation_feather_var", value=saturation_feather_var, expected_type=type_hints["saturation_feather_var"])
            check_type(argname="argument saturation_tolerance", value=saturation_tolerance, expected_type=type_hints["saturation_tolerance"])
            check_type(argname="argument saturation_tolerance_var", value=saturation_tolerance_var, expected_type=type_hints["saturation_tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_feather is not None:
            self._values["hue_feather"] = hue_feather
        if hue_feather_var is not None:
            self._values["hue_feather_var"] = hue_feather_var
        if hue_tolerance is not None:
            self._values["hue_tolerance"] = hue_tolerance
        if hue_tolerance_var is not None:
            self._values["hue_tolerance_var"] = hue_tolerance_var
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness_feather is not None:
            self._values["lightness_feather"] = lightness_feather
        if lightness_feather_var is not None:
            self._values["lightness_feather_var"] = lightness_feather_var
        if lightness_tolerance is not None:
            self._values["lightness_tolerance"] = lightness_tolerance
        if lightness_tolerance_var is not None:
            self._values["lightness_tolerance_var"] = lightness_tolerance_var
        if saturation_feather is not None:
            self._values["saturation_feather"] = saturation_feather
        if saturation_feather_var is not None:
            self._values["saturation_feather_var"] = saturation_feather_var
        if saturation_tolerance is not None:
            self._values["saturation_tolerance"] = saturation_tolerance
        if saturation_tolerance_var is not None:
            self._values["saturation_tolerance_var"] = saturation_tolerance_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        '''
        result = self._values.get("hue_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        '''
        result = self._values.get("hue_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        '''
        result = self._values.get("hue_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        '''
        result = self._values.get("hue_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        '''
        result = self._values.get("lightness_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        '''
        result = self._values.get("lightness_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        '''
        result = self._values.get("lightness_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        '''
        result = self._values.get("lightness_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        '''
        result = self._values.get("saturation_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        '''
        result = self._values.get("saturation_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        '''
        result = self._values.get("saturation_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        result = self._values.get("saturation_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitChromaKey(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitChromaKeyList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitChromaKeyList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__34c9aeb6574ba5de353d53618e77a9e3ae92eb50f679b4c984b9f02ec77f99f5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitChromaKeyOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__837633ef61ff4847ed6134e9c09ec080125606c0cf2834f3942fff9ec2ce1138)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitChromaKeyOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__552902520ff1515cfb4d23740027ccaf9763f3188cc70a083f719f464dd5c9de)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5c65110b1be572a532ff6203f52d8d114641ab899ad5b3af925e4f761cb940a2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5d869470f5cee26665f0cb00d2bd052cec1e8bb1389573664de3141bf923b105)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitChromaKey]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitChromaKey]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__60baa05c5e92986e8e0f8e2685f2283ae919daac348ca4a1acd15d86dbe3f406)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitChromaKeyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitChromaKeyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__810e84020d19d9d7a752731c4d1f33b0bd6f137dfaa2b74d22ecc62a72c44ed6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueFeather")
    def reset_hue_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeather", []))

    @jsii.member(jsii_name="resetHueFeatherVar")
    def reset_hue_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeatherVar", []))

    @jsii.member(jsii_name="resetHueTolerance")
    def reset_hue_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueTolerance", []))

    @jsii.member(jsii_name="resetHueToleranceVar")
    def reset_hue_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueToleranceVar", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightnessFeather")
    def reset_lightness_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeather", []))

    @jsii.member(jsii_name="resetLightnessFeatherVar")
    def reset_lightness_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeatherVar", []))

    @jsii.member(jsii_name="resetLightnessTolerance")
    def reset_lightness_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessTolerance", []))

    @jsii.member(jsii_name="resetLightnessToleranceVar")
    def reset_lightness_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessToleranceVar", []))

    @jsii.member(jsii_name="resetSaturationFeather")
    def reset_saturation_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeather", []))

    @jsii.member(jsii_name="resetSaturationFeatherVar")
    def reset_saturation_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeatherVar", []))

    @jsii.member(jsii_name="resetSaturationTolerance")
    def reset_saturation_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationTolerance", []))

    @jsii.member(jsii_name="resetSaturationToleranceVar")
    def reset_saturation_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherInput")
    def hue_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVarInput")
    def hue_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceInput")
    def hue_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVarInput")
    def hue_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherInput")
    def lightness_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVarInput")
    def lightness_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceInput")
    def lightness_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVarInput")
    def lightness_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherInput")
    def saturation_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVarInput")
    def saturation_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceInput")
    def saturation_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVarInput")
    def saturation_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c5c53fbbda10977752e9887c4775ecf94635152db84fe30493e25e893424cb52)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeather")
    def hue_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeather"))

    @hue_feather.setter
    def hue_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__157bf2170746f6f25b9f785c824788728849f1475e16047f9b66cbc0207ce434)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeather", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVar")
    def hue_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeatherVar"))

    @hue_feather_var.setter
    def hue_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5fb4bce3b567cdbae52b848b34cfdc73de3af43bb5fac3e8eac0b6324a0c135e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueTolerance")
    def hue_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueTolerance"))

    @hue_tolerance.setter
    def hue_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0218e460a6776a29365a342bdb739528ec03070311f2688cf8bfa76310462c3c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVar")
    def hue_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueToleranceVar"))

    @hue_tolerance_var.setter
    def hue_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__660b5d0f47e3f9d2354f076b87f91926dfda931c07db8f76af9de5f2a4a0d6b1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5352589ea5bd792b7e1d0caa023c7131e7690ec28cbbfc3d28fad77d113938af)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeather")
    def lightness_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeather"))

    @lightness_feather.setter
    def lightness_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f64cd197c5657ff14c6cb0e406a350a4abb51dba5f8eb8e62b27e4ff41cd3b7f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeather", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVar")
    def lightness_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeatherVar"))

    @lightness_feather_var.setter
    def lightness_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f3fbd72ef2f86a4d3bcdc5f46587918d99dbd5075769d1fda5757d565477d8e0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessTolerance")
    def lightness_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessTolerance"))

    @lightness_tolerance.setter
    def lightness_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b019da8bd80d18f08a0af206ae5f22065ab99e0d827dfdc765ac27c02b6a15bd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVar")
    def lightness_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessToleranceVar"))

    @lightness_tolerance_var.setter
    def lightness_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__650ec81592748cc199fa35ace56e831543c4e720bd5d53a10ac81c06ffc5d2cf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeather")
    def saturation_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeather"))

    @saturation_feather.setter
    def saturation_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__028abc4015b8d575723f88a8b605ab5f710ce0674a4685f7e2f74e716140de96)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeather", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVar")
    def saturation_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeatherVar"))

    @saturation_feather_var.setter
    def saturation_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__19b011168f6e80f7f72e3067fb54d9becb7f0b1873d9aff4f2159846278446c9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationTolerance")
    def saturation_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationTolerance"))

    @saturation_tolerance.setter
    def saturation_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8115fcd0711920dcf7d0e360d01ae9e87a5a71395b1a75b43a41470235886660)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVar")
    def saturation_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationToleranceVar"))

    @saturation_tolerance_var.setter
    def saturation_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2568892c039c950778aeec5c103fcfec695c582f83db391f3c8933074fd1b60f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitChromaKey]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitChromaKey]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitChromaKey]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1acbcd3cf4f76619364de97bdd1d1fa19767d5f254c5536649d621ad4f69cda5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitComposite",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "placement": "placement",
        "placement_var": "placementVar",
        "scale": "scale",
        "scale_dimension": "scaleDimension",
        "scale_dimension_var": "scaleDimensionVar",
        "scale_var": "scaleVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitComposite:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        placement: typing.Optional[builtins.str] = None,
        placement_var: typing.Optional[builtins.str] = None,
        scale: typing.Optional[builtins.str] = None,
        scale_dimension: typing.Optional[builtins.str] = None,
        scale_dimension_var: typing.Optional[builtins.str] = None,
        scale_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param placement: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        :param placement_var: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        :param scale: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param scale_dimension: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        :param scale_dimension_var: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        :param scale_var: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        :param x_position: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e9df9c035f666baf2ac8945f98ac7be9594e1559f7f64c1d1702b95658f16a2d)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument placement", value=placement, expected_type=type_hints["placement"])
            check_type(argname="argument placement_var", value=placement_var, expected_type=type_hints["placement_var"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument scale_dimension", value=scale_dimension, expected_type=type_hints["scale_dimension"])
            check_type(argname="argument scale_dimension_var", value=scale_dimension_var, expected_type=type_hints["scale_dimension_var"])
            check_type(argname="argument scale_var", value=scale_var, expected_type=type_hints["scale_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if placement is not None:
            self._values["placement"] = placement
        if placement_var is not None:
            self._values["placement_var"] = placement_var
        if scale is not None:
            self._values["scale"] = scale
        if scale_dimension is not None:
            self._values["scale_dimension"] = scale_dimension
        if scale_dimension_var is not None:
            self._values["scale_dimension_var"] = scale_dimension_var
        if scale_var is not None:
            self._values["scale_var"] = scale_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        '''
        result = self._values.get("placement")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement_var(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        '''
        result = self._values.get("placement_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        '''
        result = self._values.get("scale_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        '''
        result = self._values.get("scale_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        '''
        result = self._values.get("scale_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitComposite(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImage",
    jsii_struct_bases=[],
    name_mapping={
        "box_image": "boxImage",
        "circle_image": "circleImage",
        "text_image": "textImage",
        "url_image": "urlImage",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImage:
    def __init__(
        self,
        *,
        box_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageBoxImage", typing.Dict[builtins.str, typing.Any]]]]] = None,
        circle_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageCircleImage", typing.Dict[builtins.str, typing.Any]]]]] = None,
        text_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageTextImage", typing.Dict[builtins.str, typing.Any]]]]] = None,
        url_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageUrlImage", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param box_image: box_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#box_image DataAkamaiImagingPolicyImage#box_image}
        :param circle_image: circle_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#circle_image DataAkamaiImagingPolicyImage#circle_image}
        :param text_image: text_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text_image DataAkamaiImagingPolicyImage#text_image}
        :param url_image: url_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url_image DataAkamaiImagingPolicyImage#url_image}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ebcf98616abddc99180fddccfb081a2f2800a73ca8cd937483e648190b9c02cf)
            check_type(argname="argument box_image", value=box_image, expected_type=type_hints["box_image"])
            check_type(argname="argument circle_image", value=circle_image, expected_type=type_hints["circle_image"])
            check_type(argname="argument text_image", value=text_image, expected_type=type_hints["text_image"])
            check_type(argname="argument url_image", value=url_image, expected_type=type_hints["url_image"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if box_image is not None:
            self._values["box_image"] = box_image
        if circle_image is not None:
            self._values["circle_image"] = circle_image
        if text_image is not None:
            self._values["text_image"] = text_image
        if url_image is not None:
            self._values["url_image"] = url_image

    @builtins.property
    def box_image(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageBoxImage"]]]:
        '''box_image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#box_image DataAkamaiImagingPolicyImage#box_image}
        '''
        result = self._values.get("box_image")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageBoxImage"]]], result)

    @builtins.property
    def circle_image(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageCircleImage"]]]:
        '''circle_image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#circle_image DataAkamaiImagingPolicyImage#circle_image}
        '''
        result = self._values.get("circle_image")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageCircleImage"]]], result)

    @builtins.property
    def text_image(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageTextImage"]]]:
        '''text_image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text_image DataAkamaiImagingPolicyImage#text_image}
        '''
        result = self._values.get("text_image")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageTextImage"]]], result)

    @builtins.property
    def url_image(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageUrlImage"]]]:
        '''url_image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url_image DataAkamaiImagingPolicyImage#url_image}
        '''
        result = self._values.get("url_image")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageUrlImage"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageBoxImage",
    jsii_struct_bases=[],
    name_mapping={
        "color": "color",
        "color_var": "colorVar",
        "height": "height",
        "height_var": "heightVar",
        "transformation": "transformation",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageBoxImage:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        transformation: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageBoxImageTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The fill color of the box, not the edge of the box. The API supports hexadecimal representation and CSS hexadecimal color values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The fill color of the box, not the edge of the box. The API supports hexadecimal representation and CSS hexadecimal color values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        :param height: The height of the box in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height of the box in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param transformation: transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        :param width: The width of the box in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width of the box in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(transformation, dict):
            transformation = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageBoxImageTransformation(**transformation)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__921849e583d0b036e029bf0051ed29c0bbadef3d8c1c15591068f5bcc4d14914)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument transformation", value=transformation, expected_type=type_hints["transformation"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if transformation is not None:
            self._values["transformation"] = transformation
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The fill color of the box, not the edge of the box.

        The API supports hexadecimal representation and CSS hexadecimal color values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The fill color of the box, not the edge of the box.

        The API supports hexadecimal representation and CSS hexadecimal color values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height of the box in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height of the box in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def transformation(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageBoxImageTransformation"]:
        '''transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        '''
        result = self._values.get("transformation")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageBoxImageTransformation"], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width of the box in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width of the box in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageBoxImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageBoxImageList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageBoxImageList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__770b254692255eeddec26e834694d09e6d2edc34f0ceb5ce83de76830a1c7e80)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageBoxImageOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__25ecabc896cfe488ed0ac1f85a2118ad13df305a13c4fc7bf6e529bf05a574bc)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageBoxImageOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__055314fbc98f6878eaf65b75efb65df042fd42f887e33ecd7d224155ebed445d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7ea852a654fed2f8e025027dbdbe72baf7c0e8b9448e091e4f7712b70c191fb7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cabcedc106f81f4b81f398fd999cc748fbddee78eb1c48381589bfd73a3f1e77)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageBoxImage]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageBoxImage]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageBoxImage]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__74607873ebe758e4c8ad58a105aa9f112691b02dbebe219f5fe7f2e698ff2f2c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageBoxImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageBoxImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a96e33b79c317bce46632da769d82bf5c294d630954312a6b68a6d7768128a2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformation")
    def put_transformation(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageBoxImageTransformation()

        return typing.cast(None, jsii.invoke(self, "putTransformation", [value]))

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetTransformation")
    def reset_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformation", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="transformation")
    def transformation(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageBoxImageTransformationOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageBoxImageTransformationOutputReference", jsii.get(self, "transformation"))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="transformationInput")
    def transformation_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageBoxImageTransformation"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageBoxImageTransformation"], jsii.get(self, "transformationInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__50511d8d846c90ddb8a8fe3fcc89f7914b43a8234fae21f09a697c30011b39fb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3c57af4dc8b48001a4d826a88271688b918f4fe99b817da74aa2532c1736bc55)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__826d4e609a454ad70fb0350a03946286685aabaf809197a99219dfec68b13f19)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c6ab4d47c72daac70a1de2281afb7ee9f1d638e653afe088e6a1a5e7cc33f20b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4b7acbf06f909b65b115b03d74c76513af5cc11da334c18744905188163bac50)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b9edbf844712782751323d3f02cc96a7bf413a4cff1ac1958007d19caa672789)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageBoxImage]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageBoxImage]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageBoxImage]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__34916615dec37e8ace6fb374c5f90ff597665804ace4b40d2d9d3f6ab2080359)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageBoxImageTransformation",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageBoxImageTransformation:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageBoxImageTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageBoxImageTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageBoxImageTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7a4b02e4939229df17699ef19fc48d2263e75e40620abe337944a7820bc7b2d0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageBoxImageTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageBoxImageTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageBoxImageTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d32a64650633e45c8220c86539aaf2922432a855aea269b9f32e8896a7f6d2f4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageCircleImage",
    jsii_struct_bases=[],
    name_mapping={
        "color": "color",
        "color_var": "colorVar",
        "diameter": "diameter",
        "diameter_var": "diameterVar",
        "transformation": "transformation",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageCircleImage:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
        diameter: typing.Optional[builtins.str] = None,
        diameter_var: typing.Optional[builtins.str] = None,
        transformation: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageCircleImageTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The fill color of the circle. The API supports hexadecimal representation and CSS hexadecimal color values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The fill color of the circle. The API supports hexadecimal representation and CSS hexadecimal color values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        :param diameter: The diameter of the circle. The diameter will be the width and the height of the image in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#diameter DataAkamaiImagingPolicyImage#diameter}
        :param diameter_var: The diameter of the circle. The diameter will be the width and the height of the image in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#diameter_var DataAkamaiImagingPolicyImage#diameter_var}
        :param transformation: transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        :param width: The width of the box in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width of the box in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(transformation, dict):
            transformation = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageCircleImageTransformation(**transformation)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a32274ac3fb966dd4f6fba9bfb05084b327d66194505b74d53f2180eef1cf0f2)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
            check_type(argname="argument diameter", value=diameter, expected_type=type_hints["diameter"])
            check_type(argname="argument diameter_var", value=diameter_var, expected_type=type_hints["diameter_var"])
            check_type(argname="argument transformation", value=transformation, expected_type=type_hints["transformation"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var
        if diameter is not None:
            self._values["diameter"] = diameter
        if diameter_var is not None:
            self._values["diameter_var"] = diameter_var
        if transformation is not None:
            self._values["transformation"] = transformation
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The fill color of the circle. The API supports hexadecimal representation and CSS hexadecimal color values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The fill color of the circle. The API supports hexadecimal representation and CSS hexadecimal color values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def diameter(self) -> typing.Optional[builtins.str]:
        '''The diameter of the circle. The diameter will be the width and the height of the image in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#diameter DataAkamaiImagingPolicyImage#diameter}
        '''
        result = self._values.get("diameter")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def diameter_var(self) -> typing.Optional[builtins.str]:
        '''The diameter of the circle. The diameter will be the width and the height of the image in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#diameter_var DataAkamaiImagingPolicyImage#diameter_var}
        '''
        result = self._values.get("diameter_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def transformation(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageCircleImageTransformation"]:
        '''transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        '''
        result = self._values.get("transformation")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageCircleImageTransformation"], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width of the box in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width of the box in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageCircleImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageCircleImageList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageCircleImageList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__175b42e7f368852c06e3e0d62ae4c776fe1df705d970b21ecef37ecb6ecdd29d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageCircleImageOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6a1a04dc927311117a153fe44b7a31314e219f0a4073bc46e5f8863980ff7ca2)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageCircleImageOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__305a27da08d33dd881a89c1bfc54fc41dc1d29a2a2d6cce1b9b3519aadbde948)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9bdefd72b25396a1f8dc2da3990539f6985f9b287f78a7244b14d9ffa057e78b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4df2c5f1115f491f71820fd0f1c75051e699f070db19a1c79bd8ea535e33e905)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageCircleImage]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageCircleImage]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageCircleImage]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c5808627071e8ede236a9bb171fe9d35bec9cf610055e5a8ad5efc2907fb5742)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageCircleImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageCircleImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1931596b0da7217f099bf13c5570c48f3587720dfe5067ac440cf4b9d8b13a3c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformation")
    def put_transformation(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageCircleImageTransformation()

        return typing.cast(None, jsii.invoke(self, "putTransformation", [value]))

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @jsii.member(jsii_name="resetDiameter")
    def reset_diameter(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDiameter", []))

    @jsii.member(jsii_name="resetDiameterVar")
    def reset_diameter_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDiameterVar", []))

    @jsii.member(jsii_name="resetTransformation")
    def reset_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformation", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="transformation")
    def transformation(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageCircleImageTransformationOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageCircleImageTransformationOutputReference", jsii.get(self, "transformation"))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="diameterInput")
    def diameter_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "diameterInput"))

    @builtins.property
    @jsii.member(jsii_name="diameterVarInput")
    def diameter_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "diameterVarInput"))

    @builtins.property
    @jsii.member(jsii_name="transformationInput")
    def transformation_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageCircleImageTransformation"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageCircleImageTransformation"], jsii.get(self, "transformationInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e288eebd67f40bdc04efa32a81a9be37fd5066157fd88e2fe5a07b590d9603b1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__02e8294da28364daa51fa4ebf20ce45453cb993891247b558fd19daab5ec8ccb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="diameter")
    def diameter(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "diameter"))

    @diameter.setter
    def diameter(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__db67cb82c27dac2fa37c50c12811602d709d743283630a44d7e664190007dde0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "diameter", value)

    @builtins.property
    @jsii.member(jsii_name="diameterVar")
    def diameter_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "diameterVar"))

    @diameter_var.setter
    def diameter_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__19b9989d5e25e65abf8c636438f91dacf7ea1f94bed5ff7386ba0e23b753f810)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "diameterVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2031672c7a31b9925e9ad259bd0e1b23ae3383661b48211a684de24b3620ccf4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__138d7852cbfc3b8b85f01309cc7fdbc74f0eedcef483d4bc2f607b48e1d27719)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageCircleImage]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageCircleImage]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageCircleImage]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b760f54cd88f22e3c01c1122ae07fb8928566b3d5f9aa673d2b020f238bbf0f0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageCircleImageTransformation",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageCircleImageTransformation:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageCircleImageTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageCircleImageTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageCircleImageTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__08673219a1725ff163ee82feb768c6cabcb57e23c3663ce9aa400f72688eb383)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageCircleImageTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageCircleImageTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageCircleImageTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e8da601ea29bea81c8d1ea56ad708fefaf112b0aa387fd31a10b5d86935687bd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9166f058751d40088e6a08ad23a7ce760031659a94e24e85316e869457aea949)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putBoxImage")
    def put_box_image(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageBoxImage, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d6a1d40482f179902449b74943c3189fc737ed05a2e1a2caf37db2bdb01daad9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBoxImage", [value]))

    @jsii.member(jsii_name="putCircleImage")
    def put_circle_image(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageCircleImage, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b109248b45afc24f0e60c6a299c8c5210990d44b431ac32fab96eb54dc791c30)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCircleImage", [value]))

    @jsii.member(jsii_name="putTextImage")
    def put_text_image(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageTextImage", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__58c874169b4f31ec41d242b42b5e2d36788c1bbecbdc6ebd06b0c14728f67944)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTextImage", [value]))

    @jsii.member(jsii_name="putUrlImage")
    def put_url_image(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageUrlImage", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ee629d7c8c9349a87ada6be487f3b6c79867aad814c5ee19232c8afd665b6bb3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putUrlImage", [value]))

    @jsii.member(jsii_name="resetBoxImage")
    def reset_box_image(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBoxImage", []))

    @jsii.member(jsii_name="resetCircleImage")
    def reset_circle_image(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCircleImage", []))

    @jsii.member(jsii_name="resetTextImage")
    def reset_text_image(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTextImage", []))

    @jsii.member(jsii_name="resetUrlImage")
    def reset_url_image(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUrlImage", []))

    @builtins.property
    @jsii.member(jsii_name="boxImage")
    def box_image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageBoxImageList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageBoxImageList, jsii.get(self, "boxImage"))

    @builtins.property
    @jsii.member(jsii_name="circleImage")
    def circle_image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageCircleImageList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageCircleImageList, jsii.get(self, "circleImage"))

    @builtins.property
    @jsii.member(jsii_name="textImage")
    def text_image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageTextImageList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageTextImageList", jsii.get(self, "textImage"))

    @builtins.property
    @jsii.member(jsii_name="urlImage")
    def url_image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageUrlImageList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageUrlImageList", jsii.get(self, "urlImage"))

    @builtins.property
    @jsii.member(jsii_name="boxImageInput")
    def box_image_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageBoxImage]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageBoxImage]]], jsii.get(self, "boxImageInput"))

    @builtins.property
    @jsii.member(jsii_name="circleImageInput")
    def circle_image_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageCircleImage]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageCircleImage]]], jsii.get(self, "circleImageInput"))

    @builtins.property
    @jsii.member(jsii_name="textImageInput")
    def text_image_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageTextImage"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageTextImage"]]], jsii.get(self, "textImageInput"))

    @builtins.property
    @jsii.member(jsii_name="urlImageInput")
    def url_image_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageUrlImage"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageUrlImage"]]], jsii.get(self, "urlImageInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a2301fdce6e1644faa0d9c2afea6b37841c13893b8a83ed8cbc22c111d3970c8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageTextImage",
    jsii_struct_bases=[],
    name_mapping={
        "fill": "fill",
        "fill_var": "fillVar",
        "size": "size",
        "size_var": "sizeVar",
        "stroke": "stroke",
        "stroke_size": "strokeSize",
        "stroke_size_var": "strokeSizeVar",
        "stroke_var": "strokeVar",
        "text": "text",
        "text_var": "textVar",
        "transformation": "transformation",
        "typeface": "typeface",
        "typeface_var": "typefaceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageTextImage:
    def __init__(
        self,
        *,
        fill: typing.Optional[builtins.str] = None,
        fill_var: typing.Optional[builtins.str] = None,
        size: typing.Optional[builtins.str] = None,
        size_var: typing.Optional[builtins.str] = None,
        stroke: typing.Optional[builtins.str] = None,
        stroke_size: typing.Optional[builtins.str] = None,
        stroke_size_var: typing.Optional[builtins.str] = None,
        stroke_var: typing.Optional[builtins.str] = None,
        text: typing.Optional[builtins.str] = None,
        text_var: typing.Optional[builtins.str] = None,
        transformation: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageTextImageTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        typeface: typing.Optional[builtins.str] = None,
        typeface_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fill: The main fill color of the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill DataAkamaiImagingPolicyImage#fill}
        :param fill_var: The main fill color of the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_var DataAkamaiImagingPolicyImage#fill_var}
        :param size: The size in pixels to render the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#size DataAkamaiImagingPolicyImage#size}
        :param size_var: The size in pixels to render the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#size_var DataAkamaiImagingPolicyImage#size_var}
        :param stroke: The color for the outline of the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke DataAkamaiImagingPolicyImage#stroke}
        :param stroke_size: The thickness in points for the outline of the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_size DataAkamaiImagingPolicyImage#stroke_size}
        :param stroke_size_var: The thickness in points for the outline of the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_size_var DataAkamaiImagingPolicyImage#stroke_size_var}
        :param stroke_var: The color for the outline of the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_var DataAkamaiImagingPolicyImage#stroke_var}
        :param text: The line of text to render. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text DataAkamaiImagingPolicyImage#text}
        :param text_var: The line of text to render. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text_var DataAkamaiImagingPolicyImage#text_var}
        :param transformation: transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        :param typeface: The font family to apply to the text image. This may be a URL to a TrueType or WOFF (v1) typeface, or a string that refers to one of the standard built-in browser fonts. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#typeface DataAkamaiImagingPolicyImage#typeface}
        :param typeface_var: The font family to apply to the text image. This may be a URL to a TrueType or WOFF (v1) typeface, or a string that refers to one of the standard built-in browser fonts. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#typeface_var DataAkamaiImagingPolicyImage#typeface_var}
        '''
        if isinstance(transformation, dict):
            transformation = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageTextImageTransformation(**transformation)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3556a3a5be309d5dbd08f823277128526498ecf6a8dddcbb9660a7179ec916ff)
            check_type(argname="argument fill", value=fill, expected_type=type_hints["fill"])
            check_type(argname="argument fill_var", value=fill_var, expected_type=type_hints["fill_var"])
            check_type(argname="argument size", value=size, expected_type=type_hints["size"])
            check_type(argname="argument size_var", value=size_var, expected_type=type_hints["size_var"])
            check_type(argname="argument stroke", value=stroke, expected_type=type_hints["stroke"])
            check_type(argname="argument stroke_size", value=stroke_size, expected_type=type_hints["stroke_size"])
            check_type(argname="argument stroke_size_var", value=stroke_size_var, expected_type=type_hints["stroke_size_var"])
            check_type(argname="argument stroke_var", value=stroke_var, expected_type=type_hints["stroke_var"])
            check_type(argname="argument text", value=text, expected_type=type_hints["text"])
            check_type(argname="argument text_var", value=text_var, expected_type=type_hints["text_var"])
            check_type(argname="argument transformation", value=transformation, expected_type=type_hints["transformation"])
            check_type(argname="argument typeface", value=typeface, expected_type=type_hints["typeface"])
            check_type(argname="argument typeface_var", value=typeface_var, expected_type=type_hints["typeface_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fill is not None:
            self._values["fill"] = fill
        if fill_var is not None:
            self._values["fill_var"] = fill_var
        if size is not None:
            self._values["size"] = size
        if size_var is not None:
            self._values["size_var"] = size_var
        if stroke is not None:
            self._values["stroke"] = stroke
        if stroke_size is not None:
            self._values["stroke_size"] = stroke_size
        if stroke_size_var is not None:
            self._values["stroke_size_var"] = stroke_size_var
        if stroke_var is not None:
            self._values["stroke_var"] = stroke_var
        if text is not None:
            self._values["text"] = text
        if text_var is not None:
            self._values["text_var"] = text_var
        if transformation is not None:
            self._values["transformation"] = transformation
        if typeface is not None:
            self._values["typeface"] = typeface
        if typeface_var is not None:
            self._values["typeface_var"] = typeface_var

    @builtins.property
    def fill(self) -> typing.Optional[builtins.str]:
        '''The main fill color of the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill DataAkamaiImagingPolicyImage#fill}
        '''
        result = self._values.get("fill")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fill_var(self) -> typing.Optional[builtins.str]:
        '''The main fill color of the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_var DataAkamaiImagingPolicyImage#fill_var}
        '''
        result = self._values.get("fill_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def size(self) -> typing.Optional[builtins.str]:
        '''The size in pixels to render the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#size DataAkamaiImagingPolicyImage#size}
        '''
        result = self._values.get("size")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def size_var(self) -> typing.Optional[builtins.str]:
        '''The size in pixels to render the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#size_var DataAkamaiImagingPolicyImage#size_var}
        '''
        result = self._values.get("size_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def stroke(self) -> typing.Optional[builtins.str]:
        '''The color for the outline of the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke DataAkamaiImagingPolicyImage#stroke}
        '''
        result = self._values.get("stroke")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def stroke_size(self) -> typing.Optional[builtins.str]:
        '''The thickness in points for the outline of the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_size DataAkamaiImagingPolicyImage#stroke_size}
        '''
        result = self._values.get("stroke_size")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def stroke_size_var(self) -> typing.Optional[builtins.str]:
        '''The thickness in points for the outline of the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_size_var DataAkamaiImagingPolicyImage#stroke_size_var}
        '''
        result = self._values.get("stroke_size_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def stroke_var(self) -> typing.Optional[builtins.str]:
        '''The color for the outline of the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_var DataAkamaiImagingPolicyImage#stroke_var}
        '''
        result = self._values.get("stroke_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def text(self) -> typing.Optional[builtins.str]:
        '''The line of text to render.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text DataAkamaiImagingPolicyImage#text}
        '''
        result = self._values.get("text")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def text_var(self) -> typing.Optional[builtins.str]:
        '''The line of text to render.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text_var DataAkamaiImagingPolicyImage#text_var}
        '''
        result = self._values.get("text_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def transformation(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageTextImageTransformation"]:
        '''transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        '''
        result = self._values.get("transformation")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageTextImageTransformation"], result)

    @builtins.property
    def typeface(self) -> typing.Optional[builtins.str]:
        '''The font family to apply to the text image.

        This may be a URL to a TrueType or WOFF (v1) typeface, or a string that refers to one of the standard built-in browser fonts.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#typeface DataAkamaiImagingPolicyImage#typeface}
        '''
        result = self._values.get("typeface")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def typeface_var(self) -> typing.Optional[builtins.str]:
        '''The font family to apply to the text image.

        This may be a URL to a TrueType or WOFF (v1) typeface, or a string that refers to one of the standard built-in browser fonts.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#typeface_var DataAkamaiImagingPolicyImage#typeface_var}
        '''
        result = self._values.get("typeface_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageTextImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageTextImageList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageTextImageList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f20c28b26c7842084aed00cefcd3f28a1830e64680ec56524a398f8e9c89cc61)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageTextImageOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__223f02f10807886b47c03d5463af6d90e2c52039cfc41fac7fce8ff2cb2e6375)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageTextImageOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__198017118cb19538873c082e55be1f8651a5f42265de19ea8536919bb18d2118)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dedf50de275e160d1302e61b9053442b0556d94ba613871fa693639759286197)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__21e18787bf1e52252764e85730a71991181c3644225817bb3c092408d39b8f9b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageTextImage]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageTextImage]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageTextImage]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__82a477fb282b09abd7b1ec0df859522ed2ad951e2fa5bcf2e73896b130f074ff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageTextImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageTextImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c17875bd1e9018a095716e080a55b4b04efaa556e6845061f8312a28258142ce)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformation")
    def put_transformation(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageTextImageTransformation()

        return typing.cast(None, jsii.invoke(self, "putTransformation", [value]))

    @jsii.member(jsii_name="resetFill")
    def reset_fill(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFill", []))

    @jsii.member(jsii_name="resetFillVar")
    def reset_fill_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFillVar", []))

    @jsii.member(jsii_name="resetSize")
    def reset_size(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSize", []))

    @jsii.member(jsii_name="resetSizeVar")
    def reset_size_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSizeVar", []))

    @jsii.member(jsii_name="resetStroke")
    def reset_stroke(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStroke", []))

    @jsii.member(jsii_name="resetStrokeSize")
    def reset_stroke_size(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStrokeSize", []))

    @jsii.member(jsii_name="resetStrokeSizeVar")
    def reset_stroke_size_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStrokeSizeVar", []))

    @jsii.member(jsii_name="resetStrokeVar")
    def reset_stroke_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStrokeVar", []))

    @jsii.member(jsii_name="resetText")
    def reset_text(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetText", []))

    @jsii.member(jsii_name="resetTextVar")
    def reset_text_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTextVar", []))

    @jsii.member(jsii_name="resetTransformation")
    def reset_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformation", []))

    @jsii.member(jsii_name="resetTypeface")
    def reset_typeface(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeface", []))

    @jsii.member(jsii_name="resetTypefaceVar")
    def reset_typeface_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypefaceVar", []))

    @builtins.property
    @jsii.member(jsii_name="transformation")
    def transformation(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageTextImageTransformationOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageTextImageTransformationOutputReference", jsii.get(self, "transformation"))

    @builtins.property
    @jsii.member(jsii_name="fillInput")
    def fill_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fillInput"))

    @builtins.property
    @jsii.member(jsii_name="fillVarInput")
    def fill_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fillVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sizeInput")
    def size_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sizeInput"))

    @builtins.property
    @jsii.member(jsii_name="sizeVarInput")
    def size_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sizeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="strokeInput")
    def stroke_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "strokeInput"))

    @builtins.property
    @jsii.member(jsii_name="strokeSizeInput")
    def stroke_size_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "strokeSizeInput"))

    @builtins.property
    @jsii.member(jsii_name="strokeSizeVarInput")
    def stroke_size_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "strokeSizeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="strokeVarInput")
    def stroke_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "strokeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="textInput")
    def text_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "textInput"))

    @builtins.property
    @jsii.member(jsii_name="textVarInput")
    def text_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "textVarInput"))

    @builtins.property
    @jsii.member(jsii_name="transformationInput")
    def transformation_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageTextImageTransformation"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageTextImageTransformation"], jsii.get(self, "transformationInput"))

    @builtins.property
    @jsii.member(jsii_name="typefaceInput")
    def typeface_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typefaceInput"))

    @builtins.property
    @jsii.member(jsii_name="typefaceVarInput")
    def typeface_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typefaceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="fill")
    def fill(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fill"))

    @fill.setter
    def fill(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c2356de6c78a0bdd633f549a3fed0059f2cdef8a70bb09f4e745b4e35ae9aadd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fill", value)

    @builtins.property
    @jsii.member(jsii_name="fillVar")
    def fill_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fillVar"))

    @fill_var.setter
    def fill_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a5482dd14242f82cdbff83ab1e96a71404e1cc6feebae707e53eb71c4f4be1b4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fillVar", value)

    @builtins.property
    @jsii.member(jsii_name="size")
    def size(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "size"))

    @size.setter
    def size(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bfeba03864f05a902e002ee52d255dd44de103478acecdfff435d829c3c57ece)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "size", value)

    @builtins.property
    @jsii.member(jsii_name="sizeVar")
    def size_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sizeVar"))

    @size_var.setter
    def size_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__45336edc3e27ad2ef3360c4d8a8a8a31137997c0857c4987cbd22cf37b85e52f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sizeVar", value)

    @builtins.property
    @jsii.member(jsii_name="stroke")
    def stroke(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "stroke"))

    @stroke.setter
    def stroke(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b72885f8d131c0ffeb5a05e202e9f4012948125f8a6eaf3ce637e3f0fadca8fa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "stroke", value)

    @builtins.property
    @jsii.member(jsii_name="strokeSize")
    def stroke_size(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "strokeSize"))

    @stroke_size.setter
    def stroke_size(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__00322bf4372389fb703014959af441c1a6f524e631874e2ce4fb1df779a326bf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "strokeSize", value)

    @builtins.property
    @jsii.member(jsii_name="strokeSizeVar")
    def stroke_size_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "strokeSizeVar"))

    @stroke_size_var.setter
    def stroke_size_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f785c01ec0d03222439d4103d6cf69b767947d0860301bb0d0bbb6875824b3b0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "strokeSizeVar", value)

    @builtins.property
    @jsii.member(jsii_name="strokeVar")
    def stroke_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "strokeVar"))

    @stroke_var.setter
    def stroke_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d3b61413f8d1503fbcddd711f1f279d5b215414e5032526681e95ac3bb74bb1c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "strokeVar", value)

    @builtins.property
    @jsii.member(jsii_name="text")
    def text(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "text"))

    @text.setter
    def text(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ec088a9661b550777d3c88ced0f153f2bace138a00149ef7771edb67947f515)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "text", value)

    @builtins.property
    @jsii.member(jsii_name="textVar")
    def text_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "textVar"))

    @text_var.setter
    def text_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cb0fe80262395a64ec3caab53946805691e2c69cd5c232033e68e27d8568f3fa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "textVar", value)

    @builtins.property
    @jsii.member(jsii_name="typeface")
    def typeface(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeface"))

    @typeface.setter
    def typeface(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a2280082b9633bc2140d66256a5423b6814c6ffa4690f7054661edfb247f2602)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeface", value)

    @builtins.property
    @jsii.member(jsii_name="typefaceVar")
    def typeface_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typefaceVar"))

    @typeface_var.setter
    def typeface_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6150deb2c5c3e300bde0585613272a12cf44aaa2f756d6e0e896d210854a460e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typefaceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageTextImage]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageTextImage]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageTextImage]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dce3a60a11daa19a5d80a52ca6a056a4ac56a11306fd05cef0280ede524288e1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageTextImageTransformation",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageTextImageTransformation:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageTextImageTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageTextImageTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageTextImageTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__92a0ed8cf2eeb721c42123b592994c51b0713b80a155aadf8b5932e667457651)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageTextImageTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageTextImageTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageTextImageTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8f32dc3e8e3cd5ea031705aaae7ccdbe0bf4288c96083ea880ebd943ddc942db)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageUrlImage",
    jsii_struct_bases=[],
    name_mapping={
        "transformation": "transformation",
        "url": "url",
        "url_var": "urlVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageUrlImage:
    def __init__(
        self,
        *,
        transformation: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageUrlImageTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        url: typing.Optional[builtins.str] = None,
        url_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param transformation: transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        :param url: The URL of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url DataAkamaiImagingPolicyImage#url}
        :param url_var: The URL of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url_var DataAkamaiImagingPolicyImage#url_var}
        '''
        if isinstance(transformation, dict):
            transformation = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageUrlImageTransformation(**transformation)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f1ce7a552c1441e5e443a585986df583d404804da08790f8a03a1507713c6d99)
            check_type(argname="argument transformation", value=transformation, expected_type=type_hints["transformation"])
            check_type(argname="argument url", value=url, expected_type=type_hints["url"])
            check_type(argname="argument url_var", value=url_var, expected_type=type_hints["url_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if transformation is not None:
            self._values["transformation"] = transformation
        if url is not None:
            self._values["url"] = url
        if url_var is not None:
            self._values["url_var"] = url_var

    @builtins.property
    def transformation(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageUrlImageTransformation"]:
        '''transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        '''
        result = self._values.get("transformation")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageUrlImageTransformation"], result)

    @builtins.property
    def url(self) -> typing.Optional[builtins.str]:
        '''The URL of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url DataAkamaiImagingPolicyImage#url}
        '''
        result = self._values.get("url")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def url_var(self) -> typing.Optional[builtins.str]:
        '''The URL of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url_var DataAkamaiImagingPolicyImage#url_var}
        '''
        result = self._values.get("url_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageUrlImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageUrlImageList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageUrlImageList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__454ac020b2d85637c1a7b55d2a94eb52143fd4a7257f1cb38cfab49c5867bebf)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageUrlImageOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5118ac7e56607acedce501a03877fae11f20c62d91b012a8e77f4f4d65666a5f)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageUrlImageOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d7b0738b871db30fa7d93cb7904c2b12b09fd05ccea6828de939296ef3a690ee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b55f4c821f4f7c504404365f40f62af55c2a530390a3a390d49567abf77cb5a4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__12841645779e0186ddb4069a13407aae7b7ac450f9e74f4542367f97a8ca86c9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageUrlImage]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageUrlImage]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageUrlImage]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b6ea570f1263b0f1db1ca8988ae81101f03ed36dd76a5bfde5b0f3dc9b511fbf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageUrlImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageUrlImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d0c590834f362315260046f3087bd326ca9a2da0ac02e5a63bf484ea84ae376b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformation")
    def put_transformation(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageUrlImageTransformation()

        return typing.cast(None, jsii.invoke(self, "putTransformation", [value]))

    @jsii.member(jsii_name="resetTransformation")
    def reset_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformation", []))

    @jsii.member(jsii_name="resetUrl")
    def reset_url(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUrl", []))

    @jsii.member(jsii_name="resetUrlVar")
    def reset_url_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUrlVar", []))

    @builtins.property
    @jsii.member(jsii_name="transformation")
    def transformation(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageUrlImageTransformationOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageUrlImageTransformationOutputReference", jsii.get(self, "transformation"))

    @builtins.property
    @jsii.member(jsii_name="transformationInput")
    def transformation_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageUrlImageTransformation"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageUrlImageTransformation"], jsii.get(self, "transformationInput"))

    @builtins.property
    @jsii.member(jsii_name="urlInput")
    def url_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "urlInput"))

    @builtins.property
    @jsii.member(jsii_name="urlVarInput")
    def url_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "urlVarInput"))

    @builtins.property
    @jsii.member(jsii_name="url")
    def url(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "url"))

    @url.setter
    def url(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1b10a9036f055d97d5aee61bda4f54562cbcdbebbe86dd8b6e745e20c8c8389d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "url", value)

    @builtins.property
    @jsii.member(jsii_name="urlVar")
    def url_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "urlVar"))

    @url_var.setter
    def url_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ba4b8157f43933edb6cdf2c290c9f948008a2436a3dd413ae815cecba99268c2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "urlVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageUrlImage]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageUrlImage]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageUrlImage]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ffc5fecf95e640caa7c5bdad26e01ad8feaef660b5edb61433606fcc7a978961)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageUrlImageTransformation",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageUrlImageTransformation:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageUrlImageTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageUrlImageTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageUrlImageTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b77d63541e1a98488ce5fee819093a2a79025529c1b819057d54d21a33e3ba02)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageUrlImageTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageUrlImageTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageUrlImageTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a7a308180208120d07ad45573c06d3074ab3ecb982a0db4aa3931296d2a8d8b4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0a4314b000bacefa8f4d49d68e47a8bf465ca3f11a5deca5471d75ccbf15ad7f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c0adb75609678f9ce1aee47cdb31448fbf94bc598af5de7948c549e5cb751cf1)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__542fcb6f8994986576b426a212a03aabd088aaa1a163ac93945677df4763d149)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5251ab022a73489f2982af31390fc59a27d673e3888ad709cf0fe84aae2cad86)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bf238fbde26fde3975e084baca3f502f03083150ec74f55e4be7d87cec08eebc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitComposite]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitComposite]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cf1b5bbb2362c4e16366dadfd6591e1dd708c1e9e4e1f68e05473da8af61465e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6b657c1f8fd03fdeae88b03ef804a2ffeffba7edf4db498087ccee7ed88131a5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(
        self,
        *,
        box_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageBoxImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
        circle_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageCircleImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
        text_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageTextImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
        url_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageUrlImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param box_image: box_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#box_image DataAkamaiImagingPolicyImage#box_image}
        :param circle_image: circle_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#circle_image DataAkamaiImagingPolicyImage#circle_image}
        :param text_image: text_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text_image DataAkamaiImagingPolicyImage#text_image}
        :param url_image: url_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url_image DataAkamaiImagingPolicyImage#url_image}
        '''
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImage(
            box_image=box_image,
            circle_image=circle_image,
            text_image=text_image,
            url_image=url_image,
        )

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPlacement")
    def reset_placement(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacement", []))

    @jsii.member(jsii_name="resetPlacementVar")
    def reset_placement_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacementVar", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetScaleDimension")
    def reset_scale_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimension", []))

    @jsii.member(jsii_name="resetScaleDimensionVar")
    def reset_scale_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimensionVar", []))

    @jsii.member(jsii_name="resetScaleVar")
    def reset_scale_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="placementInput")
    def placement_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementInput"))

    @builtins.property
    @jsii.member(jsii_name="placementVarInput")
    def placement_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionInput")
    def scale_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVarInput")
    def scale_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleVarInput")
    def scale_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__89a71d8425a2be02399660d3199885bcb8aebc857862a609b1f3e8b1e8736ed4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9f69942685063f835d45b9b9edc7d8ba96d7f770e21a7113fad223c0caca615b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="placement")
    def placement(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placement"))

    @placement.setter
    def placement(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e12903dc79d408b8b75f984c677ebe9850cd402aa1fca25c9e04782ad2df73f9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placement", value)

    @builtins.property
    @jsii.member(jsii_name="placementVar")
    def placement_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placementVar"))

    @placement_var.setter
    def placement_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d13f82f3cd27a040b57e4e0384c4c8982ca2c77cb1722fa33dcef5e9037f401d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placementVar", value)

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scale"))

    @scale.setter
    def scale(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8564c7d3c4f72069a8dc6ec2e0a8a1f57dd0698687f4b53b77b4d1e4c6c308a8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scale", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimension")
    def scale_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimension"))

    @scale_dimension.setter
    def scale_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__640b3499174346a6163675be4290f23f54f99270041aa899fe0e5d9bc6f3b8c5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimension", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVar")
    def scale_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimensionVar"))

    @scale_dimension_var.setter
    def scale_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ea5a677c254db016f72840359e984e4d42a7971fb701ef1c31262e26302a733)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="scaleVar")
    def scale_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleVar"))

    @scale_var.setter
    def scale_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cddfc37ca4dbaebdf02c76388b85ac732fe2ecb873918a5af36869af4f54bfea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dfb72075beafdad4a93ef2b01ac945f8a31cb015daf4c207dd42387d6784653a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__214f9dac9d4700ddb35e971449025884bc4dfb480809f4228ee6a9facfec54b0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f20e794d0b708f80a5e295f1e59d1f1980ea7ede90dea15d686236df8a4dc739)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e3638a7d75235696a1c8d0e2586a0ca8c16a1994ef7797b9fae3258766f1eb12)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitComposite]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitComposite]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitComposite]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6a5e0f4972ce2b695784d86093b32ee43cb8abe489916eb3c6ab570502d4708b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompound",
    jsii_struct_bases=[],
    name_mapping={"transformations": "transformations"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompound:
    def __init__(
        self,
        *,
        transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param transformations: transformations block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb06f7437ed4747bad845434b1c087cd5fabbef2eaa95353f232634aa9e1e49b)
            check_type(argname="argument transformations", value=transformations, expected_type=type_hints["transformations"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if transformations is not None:
            self._values["transformations"] = transformations

    @builtins.property
    def transformations(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformations"]]]:
        '''transformations block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        result = self._values.get("transformations")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformations"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompound(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__64aee2edee707ecb41548de01ca3f47bfb99a4f336d9e28d15412e75dcffdbd0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a985dc7dbc2942195159586518aa62008e1fbcfceb314ff34ed1ee77f044d649)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5cacc92b3bbf02c5474b902c575accac510325bc60fcca02326ef65b3e27838b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9545ac7b5a824b8d250134e9f79973272bb21175714b250d83f7c3c94b2366d9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d2031655efe90fd6c18b779e4a9d751178370c6573172bc4879a914fbd0bca6f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompound]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompound]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fac48ec634f4a4ecf6d3341f7a9b8663589d4a272353637165b854b2d7b4410a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f409b2dac59028bddc7afa8011cba3ee2f40b45b5d7b308b156908fa52aca69d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformations")
    def put_transformations(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5dfee8fe19f03d145068f7efc86ee6b577fd97e1551fa8586e320d779e9eed8b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTransformations", [value]))

    @jsii.member(jsii_name="resetTransformations")
    def reset_transformations(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformations", []))

    @builtins.property
    @jsii.member(jsii_name="transformations")
    def transformations(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsList", jsii.get(self, "transformations"))

    @builtins.property
    @jsii.member(jsii_name="transformationsInput")
    def transformations_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformations"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformations"]]], jsii.get(self, "transformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompound]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompound]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompound]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__75114c8ef30246595ab519d2a29ba93dcfc34e5f6d1850bc84cab1252201b59a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformations",
    jsii_struct_bases=[],
    name_mapping={
        "background_color": "backgroundColor",
        "blur": "blur",
        "chroma_key": "chromaKey",
        "composite": "composite",
        "compound": "compound",
        "contrast": "contrast",
        "goop": "goop",
        "grayscale": "grayscale",
        "hsl": "hsl",
        "hsv": "hsv",
        "if_dimension": "ifDimension",
        "if_orientation": "ifOrientation",
        "max_colors": "maxColors",
        "mirror": "mirror",
        "mono_hue": "monoHue",
        "opacity": "opacity",
        "remove_color": "removeColor",
        "unsharp_mask": "unsharpMask",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformations:
    def __init__(
        self,
        *,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsBackgroundColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsBlur", typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsChromaKey", typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsComposite", typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsCompound", typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsContrast", typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsGoop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsGrayscale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsHsl", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsHsv", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfDimension", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfOrientation", typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsMaxColors", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsMirror", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsMonoHue", typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsOpacity", typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsRemoveColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsUnsharpMask", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cba58d5e07a585c8fe8c349dbe84a5812161544f297e3a40f5f8abbf0f55e273)
            check_type(argname="argument background_color", value=background_color, expected_type=type_hints["background_color"])
            check_type(argname="argument blur", value=blur, expected_type=type_hints["blur"])
            check_type(argname="argument chroma_key", value=chroma_key, expected_type=type_hints["chroma_key"])
            check_type(argname="argument composite", value=composite, expected_type=type_hints["composite"])
            check_type(argname="argument compound", value=compound, expected_type=type_hints["compound"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument goop", value=goop, expected_type=type_hints["goop"])
            check_type(argname="argument grayscale", value=grayscale, expected_type=type_hints["grayscale"])
            check_type(argname="argument hsl", value=hsl, expected_type=type_hints["hsl"])
            check_type(argname="argument hsv", value=hsv, expected_type=type_hints["hsv"])
            check_type(argname="argument if_dimension", value=if_dimension, expected_type=type_hints["if_dimension"])
            check_type(argname="argument if_orientation", value=if_orientation, expected_type=type_hints["if_orientation"])
            check_type(argname="argument max_colors", value=max_colors, expected_type=type_hints["max_colors"])
            check_type(argname="argument mirror", value=mirror, expected_type=type_hints["mirror"])
            check_type(argname="argument mono_hue", value=mono_hue, expected_type=type_hints["mono_hue"])
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument remove_color", value=remove_color, expected_type=type_hints["remove_color"])
            check_type(argname="argument unsharp_mask", value=unsharp_mask, expected_type=type_hints["unsharp_mask"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if background_color is not None:
            self._values["background_color"] = background_color
        if blur is not None:
            self._values["blur"] = blur
        if chroma_key is not None:
            self._values["chroma_key"] = chroma_key
        if composite is not None:
            self._values["composite"] = composite
        if compound is not None:
            self._values["compound"] = compound
        if contrast is not None:
            self._values["contrast"] = contrast
        if goop is not None:
            self._values["goop"] = goop
        if grayscale is not None:
            self._values["grayscale"] = grayscale
        if hsl is not None:
            self._values["hsl"] = hsl
        if hsv is not None:
            self._values["hsv"] = hsv
        if if_dimension is not None:
            self._values["if_dimension"] = if_dimension
        if if_orientation is not None:
            self._values["if_orientation"] = if_orientation
        if max_colors is not None:
            self._values["max_colors"] = max_colors
        if mirror is not None:
            self._values["mirror"] = mirror
        if mono_hue is not None:
            self._values["mono_hue"] = mono_hue
        if opacity is not None:
            self._values["opacity"] = opacity
        if remove_color is not None:
            self._values["remove_color"] = remove_color
        if unsharp_mask is not None:
            self._values["unsharp_mask"] = unsharp_mask

    @builtins.property
    def background_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsBackgroundColor"]]]:
        '''background_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        '''
        result = self._values.get("background_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsBackgroundColor"]]], result)

    @builtins.property
    def blur(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsBlur"]]]:
        '''blur block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        '''
        result = self._values.get("blur")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsBlur"]]], result)

    @builtins.property
    def chroma_key(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsChromaKey"]]]:
        '''chroma_key block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        '''
        result = self._values.get("chroma_key")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsChromaKey"]]], result)

    @builtins.property
    def composite(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsComposite"]]]:
        '''composite block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        '''
        result = self._values.get("composite")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsComposite"]]], result)

    @builtins.property
    def compound(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsCompound"]]]:
        '''compound block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        '''
        result = self._values.get("compound")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsCompound"]]], result)

    @builtins.property
    def contrast(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsContrast"]]]:
        '''contrast block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsContrast"]]], result)

    @builtins.property
    def goop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsGoop"]]]:
        '''goop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        '''
        result = self._values.get("goop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsGoop"]]], result)

    @builtins.property
    def grayscale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsGrayscale"]]]:
        '''grayscale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        '''
        result = self._values.get("grayscale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsGrayscale"]]], result)

    @builtins.property
    def hsl(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsHsl"]]]:
        '''hsl block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        '''
        result = self._values.get("hsl")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsHsl"]]], result)

    @builtins.property
    def hsv(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsHsv"]]]:
        '''hsv block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        '''
        result = self._values.get("hsv")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsHsv"]]], result)

    @builtins.property
    def if_dimension(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfDimension"]]]:
        '''if_dimension block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        '''
        result = self._values.get("if_dimension")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfDimension"]]], result)

    @builtins.property
    def if_orientation(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfOrientation"]]]:
        '''if_orientation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        '''
        result = self._values.get("if_orientation")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfOrientation"]]], result)

    @builtins.property
    def max_colors(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsMaxColors"]]]:
        '''max_colors block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        '''
        result = self._values.get("max_colors")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsMaxColors"]]], result)

    @builtins.property
    def mirror(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsMirror"]]]:
        '''mirror block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        '''
        result = self._values.get("mirror")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsMirror"]]], result)

    @builtins.property
    def mono_hue(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsMonoHue"]]]:
        '''mono_hue block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        '''
        result = self._values.get("mono_hue")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsMonoHue"]]], result)

    @builtins.property
    def opacity(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsOpacity"]]]:
        '''opacity block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsOpacity"]]], result)

    @builtins.property
    def remove_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsRemoveColor"]]]:
        '''remove_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        '''
        result = self._values.get("remove_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsRemoveColor"]]], result)

    @builtins.property
    def unsharp_mask(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsUnsharpMask"]]]:
        '''unsharp_mask block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        result = self._values.get("unsharp_mask")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsUnsharpMask"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformations(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsBackgroundColor",
    jsii_struct_bases=[],
    name_mapping={"color": "color", "color_var": "colorVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsBackgroundColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6016a515b6387ac1d92f2c35f33759b9b01e0de5196b1db89b8c3e90eb7fc139)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsBackgroundColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsBackgroundColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsBackgroundColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c2d8ec12c3f521b80ce0c5ae459aeda152cf93295dbd06df8f0e95219f78405b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsBackgroundColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d450985559b74a0386e712709591ea0ddf51a5c90beb37cb27a22faed4150a94)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsBackgroundColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a668894c100a57082b39c8799d850d8c58c29517ac7222c0eb5bffbb805ca9de)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5d71f2e5efc270d37fa0c0f2e545d0afcac0048547d64272d2cf4fc05faa1b20)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9c9ae1d9b502fdc210f1147148d12d48f839f92632c4efec8d394660779fb37d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsBackgroundColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsBackgroundColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5e96a55318abe2ff669688e4e01484c8e7d27d961c64fcf69253cddf08170259)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsBackgroundColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsBackgroundColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0e4a2d1d500143b3b90cbd031317e4f275801de3efa8e0cc9f0f53c880643346)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__154e22f3ffd46205360f46c0a4732c65d7ca5f03dea1de28bbbb3257e44e1ffc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fdbbf3e76b6dd38888b651d23458c0484372bb426f1885b7d7d5812853ba4207)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsBackgroundColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsBackgroundColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsBackgroundColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__63f94610b420db53bb234452ada81e184fe21f07a3fac3f4386ecebfaf4a3e01)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsBlur",
    jsii_struct_bases=[],
    name_mapping={"sigma": "sigma", "sigma_var": "sigmaVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsBlur:
    def __init__(
        self,
        *,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param sigma: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3c34db33c2a867e38d6ae26e0a60d6810f61500139b946ba60c2bbcb2eb7aee6)
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsBlur(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsBlurList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsBlurList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2fac5f4fe948e8364f88dc03cded72c3f110d445e4951fdef911e466dae84909)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsBlurOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__260315feb37f0725530baac32799357467b5e3c178b44ed32d7eb1c06d33efdc)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsBlurOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2e21173fe44acc8ba94ac33c64759acf2262fa4bb42fda0f3b2f3b4b25664df0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f5384d7aaae3420304d2fae120edfc621c528fe097825cea8583d5b756b2e7bb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4493fe45198f7e59a594892d8498492177b14708e150829c88a34189ca4cead0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsBlur]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsBlur]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c911aa7194b8d404caaf10b5cb284246399f2fb49dd7da4fdcf9d9b64088a925)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsBlurOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsBlurOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__691dc55dbdc852ed70f0d408af946ffe19b22165c1c5e7c19c65981642e1539e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__61747f7177d80e6807b503980731b0c8ee6d70c4f3cf0fd0434d6214772a6dc7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0469d13bcb1fc5694cca0d6517d859996b1d9a224a835ae583af817147c89102)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsBlur]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsBlur]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsBlur]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__654ad649c921d8e3d8f0bbed5c1e515603e57762cea98b38ab9e5f3ad379fe74)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsChromaKey",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_feather": "hueFeather",
        "hue_feather_var": "hueFeatherVar",
        "hue_tolerance": "hueTolerance",
        "hue_tolerance_var": "hueToleranceVar",
        "hue_var": "hueVar",
        "lightness_feather": "lightnessFeather",
        "lightness_feather_var": "lightnessFeatherVar",
        "lightness_tolerance": "lightnessTolerance",
        "lightness_tolerance_var": "lightnessToleranceVar",
        "saturation_feather": "saturationFeather",
        "saturation_feather_var": "saturationFeatherVar",
        "saturation_tolerance": "saturationTolerance",
        "saturation_tolerance_var": "saturationToleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsChromaKey:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_feather: typing.Optional[builtins.str] = None,
        hue_feather_var: typing.Optional[builtins.str] = None,
        hue_tolerance: typing.Optional[builtins.str] = None,
        hue_tolerance_var: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness_feather: typing.Optional[builtins.str] = None,
        lightness_feather_var: typing.Optional[builtins.str] = None,
        lightness_tolerance: typing.Optional[builtins.str] = None,
        lightness_tolerance_var: typing.Optional[builtins.str] = None,
        saturation_feather: typing.Optional[builtins.str] = None,
        saturation_feather_var: typing.Optional[builtins.str] = None,
        saturation_tolerance: typing.Optional[builtins.str] = None,
        saturation_tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_feather: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        :param hue_feather_var: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        :param hue_tolerance: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        :param hue_tolerance_var: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        :param hue_var: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness_feather: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        :param lightness_feather_var: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        :param lightness_tolerance: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        :param lightness_tolerance_var: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        :param saturation_feather: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        :param saturation_feather_var: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        :param saturation_tolerance: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        :param saturation_tolerance_var: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a8e0086adad8430e07d6657aa758afe27744d0e2aaa10a54e2d14bd7a501879b)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_feather", value=hue_feather, expected_type=type_hints["hue_feather"])
            check_type(argname="argument hue_feather_var", value=hue_feather_var, expected_type=type_hints["hue_feather_var"])
            check_type(argname="argument hue_tolerance", value=hue_tolerance, expected_type=type_hints["hue_tolerance"])
            check_type(argname="argument hue_tolerance_var", value=hue_tolerance_var, expected_type=type_hints["hue_tolerance_var"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness_feather", value=lightness_feather, expected_type=type_hints["lightness_feather"])
            check_type(argname="argument lightness_feather_var", value=lightness_feather_var, expected_type=type_hints["lightness_feather_var"])
            check_type(argname="argument lightness_tolerance", value=lightness_tolerance, expected_type=type_hints["lightness_tolerance"])
            check_type(argname="argument lightness_tolerance_var", value=lightness_tolerance_var, expected_type=type_hints["lightness_tolerance_var"])
            check_type(argname="argument saturation_feather", value=saturation_feather, expected_type=type_hints["saturation_feather"])
            check_type(argname="argument saturation_feather_var", value=saturation_feather_var, expected_type=type_hints["saturation_feather_var"])
            check_type(argname="argument saturation_tolerance", value=saturation_tolerance, expected_type=type_hints["saturation_tolerance"])
            check_type(argname="argument saturation_tolerance_var", value=saturation_tolerance_var, expected_type=type_hints["saturation_tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_feather is not None:
            self._values["hue_feather"] = hue_feather
        if hue_feather_var is not None:
            self._values["hue_feather_var"] = hue_feather_var
        if hue_tolerance is not None:
            self._values["hue_tolerance"] = hue_tolerance
        if hue_tolerance_var is not None:
            self._values["hue_tolerance_var"] = hue_tolerance_var
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness_feather is not None:
            self._values["lightness_feather"] = lightness_feather
        if lightness_feather_var is not None:
            self._values["lightness_feather_var"] = lightness_feather_var
        if lightness_tolerance is not None:
            self._values["lightness_tolerance"] = lightness_tolerance
        if lightness_tolerance_var is not None:
            self._values["lightness_tolerance_var"] = lightness_tolerance_var
        if saturation_feather is not None:
            self._values["saturation_feather"] = saturation_feather
        if saturation_feather_var is not None:
            self._values["saturation_feather_var"] = saturation_feather_var
        if saturation_tolerance is not None:
            self._values["saturation_tolerance"] = saturation_tolerance
        if saturation_tolerance_var is not None:
            self._values["saturation_tolerance_var"] = saturation_tolerance_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        '''
        result = self._values.get("hue_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        '''
        result = self._values.get("hue_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        '''
        result = self._values.get("hue_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        '''
        result = self._values.get("hue_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        '''
        result = self._values.get("lightness_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        '''
        result = self._values.get("lightness_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        '''
        result = self._values.get("lightness_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        '''
        result = self._values.get("lightness_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        '''
        result = self._values.get("saturation_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        '''
        result = self._values.get("saturation_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        '''
        result = self._values.get("saturation_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        result = self._values.get("saturation_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsChromaKey(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsChromaKeyList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsChromaKeyList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e445a80ce67a2aa338deae99d5bd92be6c91910010bfab8db7d192a047175092)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsChromaKeyOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__155d108dd5e61f8541d72e43807331be88b83a379c0751083e6686b94cfc1bbc)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsChromaKeyOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__11bfc3620e76197ebe2fb5d156700849500596c77d6c95c8667ead657732e3c9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b8f1c0d43112ef3e841f023b7250b92dfed90830de2b72ba339d1c4ed15525a5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b6feea70dc0f1c60e3f980ece637e317670bbd6c2b136f30f3a8b7a68b23c852)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsChromaKey]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsChromaKey]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__737864b0fe5ef6a582e0879609e96f92c7f7016c8ddc28015a07791a0526e429)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsChromaKeyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsChromaKeyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bec1bf689db5fdd4be1db5f84396b8692daa49fe87342a3a3506a5f3361ed143)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueFeather")
    def reset_hue_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeather", []))

    @jsii.member(jsii_name="resetHueFeatherVar")
    def reset_hue_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeatherVar", []))

    @jsii.member(jsii_name="resetHueTolerance")
    def reset_hue_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueTolerance", []))

    @jsii.member(jsii_name="resetHueToleranceVar")
    def reset_hue_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueToleranceVar", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightnessFeather")
    def reset_lightness_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeather", []))

    @jsii.member(jsii_name="resetLightnessFeatherVar")
    def reset_lightness_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeatherVar", []))

    @jsii.member(jsii_name="resetLightnessTolerance")
    def reset_lightness_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessTolerance", []))

    @jsii.member(jsii_name="resetLightnessToleranceVar")
    def reset_lightness_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessToleranceVar", []))

    @jsii.member(jsii_name="resetSaturationFeather")
    def reset_saturation_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeather", []))

    @jsii.member(jsii_name="resetSaturationFeatherVar")
    def reset_saturation_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeatherVar", []))

    @jsii.member(jsii_name="resetSaturationTolerance")
    def reset_saturation_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationTolerance", []))

    @jsii.member(jsii_name="resetSaturationToleranceVar")
    def reset_saturation_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherInput")
    def hue_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVarInput")
    def hue_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceInput")
    def hue_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVarInput")
    def hue_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherInput")
    def lightness_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVarInput")
    def lightness_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceInput")
    def lightness_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVarInput")
    def lightness_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherInput")
    def saturation_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVarInput")
    def saturation_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceInput")
    def saturation_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVarInput")
    def saturation_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a01d62029049816bcb06eb5217e2f6f4918a7a52f4164fdfd3d1c1a64c778c9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeather")
    def hue_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeather"))

    @hue_feather.setter
    def hue_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f7b540094dbbee5d24d09a86e16dadb57de16c956bc420e504d91973ebc68880)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeather", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVar")
    def hue_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeatherVar"))

    @hue_feather_var.setter
    def hue_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8c3b3eae98689d171669ac57911fd25da2ab19635aacb5ff8fc51281810891c3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueTolerance")
    def hue_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueTolerance"))

    @hue_tolerance.setter
    def hue_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cae5de5b110d1f2aa55ac5d4a0f3b1bd2d186a55a317274d8406d2227ca867de)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVar")
    def hue_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueToleranceVar"))

    @hue_tolerance_var.setter
    def hue_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__55a46a3c8138a9e4282803a2bd181dac2be2a1b316c71c9fb191065f5c7c7fc0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e1e8b6d39802554a42756a665916ce25ca60aae95545323859c1e6b4e6c2a4dd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeather")
    def lightness_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeather"))

    @lightness_feather.setter
    def lightness_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5eabab69f7222be5cf30794994cc273a4d65d11dd7201c59cda5d534d827a0d9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeather", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVar")
    def lightness_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeatherVar"))

    @lightness_feather_var.setter
    def lightness_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__283ea54ff3b284f28999641c45fabf603a1bbaa5d7dcb17325f2b951752af519)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessTolerance")
    def lightness_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessTolerance"))

    @lightness_tolerance.setter
    def lightness_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__148d41c2c0cf09ceb25891250dfaa26f30ad38b6f6b14a661882708696997c56)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVar")
    def lightness_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessToleranceVar"))

    @lightness_tolerance_var.setter
    def lightness_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a89187480845ac7b69f3b09446fd97698449c3973d33c87c864774f59c33e8a1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeather")
    def saturation_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeather"))

    @saturation_feather.setter
    def saturation_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6eb41538100710a608aeb63c9526a24c13a7c8cb28f92bfa966dab61a60065a4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeather", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVar")
    def saturation_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeatherVar"))

    @saturation_feather_var.setter
    def saturation_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ebea3a61c894faf7b1ba16c4a9dbffe7ee3785b5adafaadadf96cb9951cf26e5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationTolerance")
    def saturation_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationTolerance"))

    @saturation_tolerance.setter
    def saturation_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa9251e91f9b2e591d10a8c277dbe5befc85a4f4340338f29c2f4ecbe68c389e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVar")
    def saturation_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationToleranceVar"))

    @saturation_tolerance_var.setter
    def saturation_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__289f688996d145c3f93ab4739e16947075b2c8d5dc62317b2a6c910bb8f28632)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsChromaKey]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsChromaKey]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsChromaKey]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__60f6b9fc5a4b6bc7a43701d588135c7f371ad2dbdb411d903ee8799acc34ac35)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsComposite",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "placement": "placement",
        "placement_var": "placementVar",
        "scale": "scale",
        "scale_dimension": "scaleDimension",
        "scale_dimension_var": "scaleDimensionVar",
        "scale_var": "scaleVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsComposite:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsCompositeImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        placement: typing.Optional[builtins.str] = None,
        placement_var: typing.Optional[builtins.str] = None,
        scale: typing.Optional[builtins.str] = None,
        scale_dimension: typing.Optional[builtins.str] = None,
        scale_dimension_var: typing.Optional[builtins.str] = None,
        scale_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param placement: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        :param placement_var: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        :param scale: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param scale_dimension: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        :param scale_dimension_var: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        :param scale_var: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        :param x_position: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsCompositeImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e2fe6b8367d1ee6da7ec17c7a5c5bb7bc34bf06408be17a207133c9173ba8810)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument placement", value=placement, expected_type=type_hints["placement"])
            check_type(argname="argument placement_var", value=placement_var, expected_type=type_hints["placement_var"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument scale_dimension", value=scale_dimension, expected_type=type_hints["scale_dimension"])
            check_type(argname="argument scale_dimension_var", value=scale_dimension_var, expected_type=type_hints["scale_dimension_var"])
            check_type(argname="argument scale_var", value=scale_var, expected_type=type_hints["scale_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if placement is not None:
            self._values["placement"] = placement
        if placement_var is not None:
            self._values["placement_var"] = placement_var
        if scale is not None:
            self._values["scale"] = scale
        if scale_dimension is not None:
            self._values["scale_dimension"] = scale_dimension
        if scale_dimension_var is not None:
            self._values["scale_dimension_var"] = scale_dimension_var
        if scale_var is not None:
            self._values["scale_var"] = scale_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsCompositeImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsCompositeImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        '''
        result = self._values.get("placement")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement_var(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        '''
        result = self._values.get("placement_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        '''
        result = self._values.get("scale_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        '''
        result = self._values.get("scale_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        '''
        result = self._values.get("scale_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsComposite(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsCompositeImage",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsCompositeImage:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsCompositeImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsCompositeImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsCompositeImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__63ccf1762394586facf1a6967192b3a51d545e0d96c784a9e240cdfd25e16759)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsCompositeImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsCompositeImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__921593ef3e9f4fe0de95e6be41f8a29de02e06045228bd1cfddfe51e08a5e4e0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsCompositeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsCompositeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7c12aaa72507964bf87b83e0b610e6be5575563ca282c73af6ecccb0333c3660)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsCompositeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0187c91d8a79eb681ae248be4e67aa7d4cb84a6becb9659257bbb9fef0b84593)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsCompositeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__16968068f9e2274e0664263fc7fff125253fe443bbc3ae4d8231293862562d95)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dd831a31d9de1f26e8801eb9161814c36b9fb16faec10508e20e098b87e1dfad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e96da206669c24079f1563155fe3b286e60b9412157b8bff9b47c118bf4bb249)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsComposite]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsComposite]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c33bd1e1b3081e0749c819e2dde4569dc8abdf52961f92197533e2f0a901a29f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsCompositeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsCompositeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5a87eb7299afbc9d5832af9f81a255b8600e40b1ccbccd3b6b29bba0af08dcc8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsCompositeImage()

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPlacement")
    def reset_placement(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacement", []))

    @jsii.member(jsii_name="resetPlacementVar")
    def reset_placement_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacementVar", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetScaleDimension")
    def reset_scale_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimension", []))

    @jsii.member(jsii_name="resetScaleDimensionVar")
    def reset_scale_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimensionVar", []))

    @jsii.member(jsii_name="resetScaleVar")
    def reset_scale_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsCompositeImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsCompositeImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsCompositeImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="placementInput")
    def placement_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementInput"))

    @builtins.property
    @jsii.member(jsii_name="placementVarInput")
    def placement_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionInput")
    def scale_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVarInput")
    def scale_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleVarInput")
    def scale_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__26aea2c7715b028597b839503c05e536871890821000b5128ac1c39c65f84010)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__51b6a0a830759db8b8a04e49875ab16d184fd1796df4643c611f2911e3cb333b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="placement")
    def placement(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placement"))

    @placement.setter
    def placement(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__36ce3cbb5b3858fef004098c69c08d90a098516cdeda1a26f65c824ff905620f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placement", value)

    @builtins.property
    @jsii.member(jsii_name="placementVar")
    def placement_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placementVar"))

    @placement_var.setter
    def placement_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5230c399a23f88f24b3c019fb71001c31192ea354363cc3a9c81ec8c45eb3713)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placementVar", value)

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scale"))

    @scale.setter
    def scale(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__78bc56abdefb8dde02b017930b6f642bfe9e9add51e14bddf3547195829faeaa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scale", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimension")
    def scale_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimension"))

    @scale_dimension.setter
    def scale_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f0fcba8ca8bf1d17cf7baca38aff686a2ebd71532f0df858c91318be57cc29a5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimension", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVar")
    def scale_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimensionVar"))

    @scale_dimension_var.setter
    def scale_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d0305e83f4be00aae8e2f02b054b8d8e578139277ceee0a4f0d0b15dce9a231f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="scaleVar")
    def scale_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleVar"))

    @scale_var.setter
    def scale_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__74df533468739485a35821d6260587716d15a1937032b030f065302c9f4d925d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__45d4f21ee3f286d2e9eaaa5a36e02207a58d31f5ee405be6dad33a86f5a3a10e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dac49bf98396786cff914d1403679856138999efbd1dc26bd6e4790d8f28377e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__15375b0be85c08e34aa52ed66aba7b9474c63cf79cdbc96780f4c6293776b3d0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__05f7a4cc3a22a155bdbc02377688f0b62968031b939be137260ac20a1fb943a6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsComposite]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsComposite]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsComposite]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dc421ed2af95203b6e8511c0ec1f59dbf7422f100dab7e06bf93c7f58c7b08db)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsCompound",
    jsii_struct_bases=[],
    name_mapping={"transformations": "transformations"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsCompound:
    def __init__(
        self,
        *,
        transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param transformations: transformations block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8e9e01e657aba59d26c16c8cd0f0f1c7b08b0a2647b2fe9dda2bef47bc1b828f)
            check_type(argname="argument transformations", value=transformations, expected_type=type_hints["transformations"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if transformations is not None:
            self._values["transformations"] = transformations

    @builtins.property
    def transformations(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsCompoundTransformations"]]]:
        '''transformations block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        result = self._values.get("transformations")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsCompoundTransformations"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsCompound(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsCompoundList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsCompoundList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ca5e6c2a2995ad87524720adb66f7a29c35cc2b94504542f07a43786d0bd12ac)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsCompoundOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7a1caf577d512a123fb0c6801ee67c70165b228417557fefd12c4de93f917c70)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsCompoundOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8901f9d59cfcb8b0775f0123393f07cb971104dbc4419a00e4c4153e66baa1c1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d0e6dc9d2dca38eaf1d4fdd7623b77e6f52a38503250c436ddf8c9cd7c6321cd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__72cb9ca8c581829bf9547b58ca02ddc658b12731de897296ac1b1c03889c7539)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsCompound]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsCompound]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0798ce86fcfc9198f9816cff171a1e59b0dc0fdb724bb37e4c78f45518aa9ba4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsCompoundOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsCompoundOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1914a2ee7f53de59856b97040a01608c9f576abb608dd5e6567e51dcbfc5ebd5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformations")
    def put_transformations(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3dac10cbd742d948d335df6509b2ad3ef2f3bb13a1fadc84db00381d4eaa48f5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTransformations", [value]))

    @jsii.member(jsii_name="resetTransformations")
    def reset_transformations(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformations", []))

    @builtins.property
    @jsii.member(jsii_name="transformations")
    def transformations(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsCompoundTransformationsList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsCompoundTransformationsList", jsii.get(self, "transformations"))

    @builtins.property
    @jsii.member(jsii_name="transformationsInput")
    def transformations_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsCompoundTransformations"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsCompoundTransformations"]]], jsii.get(self, "transformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsCompound]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsCompound]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsCompound]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__47956ea28f371d866a36f867de710a79c61f7c076522dec3a5810e23ec2e7f01)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsCompoundTransformations",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsCompoundTransformations:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsCompoundTransformations(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsCompoundTransformationsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsCompoundTransformationsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a449f2f022bff3d9f07bd21425c950a02b1256e051d183702bf8a92534ec098f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsCompoundTransformationsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f3030172d1e2190c7b64f456ac9ea8b59c7602c80cd5868ca853324d30fed73a)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsCompoundTransformationsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d102c67b7f4bf6b7b8bf227373a4699de4c571bb027ac943c68202edc2cff3f1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__05d6bc3b742d680ca1708e2ced048d2f7478212e8e72d851982a56c6dd459bd8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e6ea488a757318dd8e3b5107f9f628c2aa375644db920b3d7466365001076a5d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsCompoundTransformations]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsCompoundTransformations]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsCompoundTransformations]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__39a81d73afc014d17b3c51a1185cfb4621d97cfd614a5a0364a9e926126d3afd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsCompoundTransformationsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsCompoundTransformationsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3454588cf36017cfa3c2784b878853588c4f151bc63b7d1646d307f2d1a41018)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsCompoundTransformations]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsCompoundTransformations]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsCompoundTransformations]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d832a9d741e52ec0b70c443352e7ddd3f2ed260e553c9794bfc046ed43809e9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsContrast",
    jsii_struct_bases=[],
    name_mapping={
        "brightness": "brightness",
        "brightness_var": "brightnessVar",
        "contrast": "contrast",
        "contrast_var": "contrastVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsContrast:
    def __init__(
        self,
        *,
        brightness: typing.Optional[builtins.str] = None,
        brightness_var: typing.Optional[builtins.str] = None,
        contrast: typing.Optional[builtins.str] = None,
        contrast_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param brightness: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        :param brightness_var: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        :param contrast: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param contrast_var: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e2203d451c37f251b19e00825685389c9f17e038cfbd5f6790c49d1528377e0a)
            check_type(argname="argument brightness", value=brightness, expected_type=type_hints["brightness"])
            check_type(argname="argument brightness_var", value=brightness_var, expected_type=type_hints["brightness_var"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument contrast_var", value=contrast_var, expected_type=type_hints["contrast_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if brightness is not None:
            self._values["brightness"] = brightness
        if brightness_var is not None:
            self._values["brightness_var"] = brightness_var
        if contrast is not None:
            self._values["contrast"] = contrast
        if contrast_var is not None:
            self._values["contrast_var"] = contrast_var

    @builtins.property
    def brightness(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        '''
        result = self._values.get("brightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def brightness_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        '''
        result = self._values.get("brightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        result = self._values.get("contrast_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsContrast(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsContrastList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsContrastList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__95748b5cdb3c69b3540270b224f873a3442173d1e6eb6f507ba0c92d8a2e093c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsContrastOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c68ee2349a68a78cde4b4ddedc1df636a7b78887611fcff0b93549a7f3be9853)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsContrastOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2b8520090e819a3d07355da026ffeefacb8dfe1f914a81cb340cde0a1630be3a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6621bc643adfad557f39f0fab4e914a6f3904f148d67519e528aa5179cf95364)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a0ce44ab1abda369f3b99198ec8f7a0ba1590d1af537ff27436e0e3ea6888086)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsContrast]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsContrast]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7728094b0a02e1539aeaee99a27b7362c47b917c06d44c7e7e49c48f6fde9d7e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsContrastOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsContrastOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea3d21b7a92fa87f1d9f1d6443e41f945ef83c40afa080de34be4e1f3cc13897)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetBrightness")
    def reset_brightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightness", []))

    @jsii.member(jsii_name="resetBrightnessVar")
    def reset_brightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightnessVar", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetContrastVar")
    def reset_contrast_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrastVar", []))

    @builtins.property
    @jsii.member(jsii_name="brightnessInput")
    def brightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="brightnessVarInput")
    def brightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastVarInput")
    def contrast_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="brightness")
    def brightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightness"))

    @brightness.setter
    def brightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__94cc01a3656ceb84646681fbd3a64152c9a908a962e328662b9fc42448226ba7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightness", value)

    @builtins.property
    @jsii.member(jsii_name="brightnessVar")
    def brightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightnessVar"))

    @brightness_var.setter
    def brightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__124aae644bcee7e2fb9a7b4e26adc2609640ddf83c065f1ad7a28c781fb4cb0e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrast"))

    @contrast.setter
    def contrast(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5a1a3c16449993f4977309f4266b9a478b412032bb5791506ab2f5e7ca9d19ed)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrast", value)

    @builtins.property
    @jsii.member(jsii_name="contrastVar")
    def contrast_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrastVar"))

    @contrast_var.setter
    def contrast_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__07444e2d4c61f4bb02527c426d22b720d816b9294468e9efecba743bf40a5b8c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrastVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsContrast]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsContrast]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsContrast]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8ae74f6cf8655c9779f67f04c2cb63fb42ce3850870bca5103a2d3d573870c5c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsGoop",
    jsii_struct_bases=[],
    name_mapping={
        "chaos": "chaos",
        "chaos_var": "chaosVar",
        "density": "density",
        "density_var": "densityVar",
        "power": "power",
        "power_var": "powerVar",
        "seed": "seed",
        "seed_var": "seedVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsGoop:
    def __init__(
        self,
        *,
        chaos: typing.Optional[builtins.str] = None,
        chaos_var: typing.Optional[builtins.str] = None,
        density: typing.Optional[builtins.str] = None,
        density_var: typing.Optional[builtins.str] = None,
        power: typing.Optional[builtins.str] = None,
        power_var: typing.Optional[builtins.str] = None,
        seed: typing.Optional[builtins.str] = None,
        seed_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param chaos: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        :param chaos_var: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        :param density: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        :param density_var: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        :param power: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        :param power_var: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        :param seed: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        :param seed_var: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b33277604b889d6a6179cf031b657b2d6e6edc7bbc3235ffbb23695b9bc345fe)
            check_type(argname="argument chaos", value=chaos, expected_type=type_hints["chaos"])
            check_type(argname="argument chaos_var", value=chaos_var, expected_type=type_hints["chaos_var"])
            check_type(argname="argument density", value=density, expected_type=type_hints["density"])
            check_type(argname="argument density_var", value=density_var, expected_type=type_hints["density_var"])
            check_type(argname="argument power", value=power, expected_type=type_hints["power"])
            check_type(argname="argument power_var", value=power_var, expected_type=type_hints["power_var"])
            check_type(argname="argument seed", value=seed, expected_type=type_hints["seed"])
            check_type(argname="argument seed_var", value=seed_var, expected_type=type_hints["seed_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if chaos is not None:
            self._values["chaos"] = chaos
        if chaos_var is not None:
            self._values["chaos_var"] = chaos_var
        if density is not None:
            self._values["density"] = density
        if density_var is not None:
            self._values["density_var"] = density_var
        if power is not None:
            self._values["power"] = power
        if power_var is not None:
            self._values["power_var"] = power_var
        if seed is not None:
            self._values["seed"] = seed
        if seed_var is not None:
            self._values["seed_var"] = seed_var

    @builtins.property
    def chaos(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        '''
        result = self._values.get("chaos")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def chaos_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        '''
        result = self._values.get("chaos_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        '''
        result = self._values.get("density")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density_var(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        '''
        result = self._values.get("density_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        '''
        result = self._values.get("power")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power_var(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        '''
        result = self._values.get("power_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        '''
        result = self._values.get("seed")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed_var(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        result = self._values.get("seed_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsGoop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsGoopList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsGoopList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__24824e89e4e3d87481306df86d1dac30230bc300181184792586547de329fa99)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsGoopOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a427791c6fa9c17af07505590073a62f9e8d31f0056c390ae181a850429cb59f)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsGoopOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a080f9eb7caf3b46dd095e67a5d7552af38be045edc2aa0322f1d7b098acdb42)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1586f1f6612054cb5fa3f8ed3a92f99896d989c79b9e0f539221a559fbab7e92)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e4cb0498cdfa019bb6ffbf5634b8323c78acbe9eea09bfeabc38352d180ad330)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsGoop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsGoop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd85ff3c6974db83b09b313c569c3fc699df07e67c65d312c4f0745bca0e9857)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsGoopOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsGoopOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d6c0ad84cc5485b6bf6c882c4f152e11cf347a31d608d2fa01fa3505b8ab2fed)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetChaos")
    def reset_chaos(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaos", []))

    @jsii.member(jsii_name="resetChaosVar")
    def reset_chaos_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaosVar", []))

    @jsii.member(jsii_name="resetDensity")
    def reset_density(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensity", []))

    @jsii.member(jsii_name="resetDensityVar")
    def reset_density_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensityVar", []))

    @jsii.member(jsii_name="resetPower")
    def reset_power(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPower", []))

    @jsii.member(jsii_name="resetPowerVar")
    def reset_power_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPowerVar", []))

    @jsii.member(jsii_name="resetSeed")
    def reset_seed(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeed", []))

    @jsii.member(jsii_name="resetSeedVar")
    def reset_seed_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeedVar", []))

    @builtins.property
    @jsii.member(jsii_name="chaosInput")
    def chaos_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosInput"))

    @builtins.property
    @jsii.member(jsii_name="chaosVarInput")
    def chaos_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosVarInput"))

    @builtins.property
    @jsii.member(jsii_name="densityInput")
    def density_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityInput"))

    @builtins.property
    @jsii.member(jsii_name="densityVarInput")
    def density_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="powerInput")
    def power_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerInput"))

    @builtins.property
    @jsii.member(jsii_name="powerVarInput")
    def power_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerVarInput"))

    @builtins.property
    @jsii.member(jsii_name="seedInput")
    def seed_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedInput"))

    @builtins.property
    @jsii.member(jsii_name="seedVarInput")
    def seed_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedVarInput"))

    @builtins.property
    @jsii.member(jsii_name="chaos")
    def chaos(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaos"))

    @chaos.setter
    def chaos(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__81cd5e6f0661943229e39bdcb51385e4dc7823728b3e3912498a8ae8c512b68a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaos", value)

    @builtins.property
    @jsii.member(jsii_name="chaosVar")
    def chaos_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaosVar"))

    @chaos_var.setter
    def chaos_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e4a2e235616a26ee72648af2883987f24f2089d709c96bb0289c67e68277f406)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaosVar", value)

    @builtins.property
    @jsii.member(jsii_name="density")
    def density(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "density"))

    @density.setter
    def density(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa29561580de64b352a0723ac9629a01e462e082f65793308d93ee090841f5b1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "density", value)

    @builtins.property
    @jsii.member(jsii_name="densityVar")
    def density_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "densityVar"))

    @density_var.setter
    def density_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bba69b153097882e1b116e3a396bc882f710c105b1dd8c5d0b7d5b8fd0971b73)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "densityVar", value)

    @builtins.property
    @jsii.member(jsii_name="power")
    def power(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "power"))

    @power.setter
    def power(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__09a2d9ca5bd89a404b6f6764045b41d1989c26c8bac9c0edbaca7410abdf9141)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "power", value)

    @builtins.property
    @jsii.member(jsii_name="powerVar")
    def power_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "powerVar"))

    @power_var.setter
    def power_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__83b6e10ee7d8ed3da7515d3b7f891016142336670ed4222cb8d7bf90cc48100d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "powerVar", value)

    @builtins.property
    @jsii.member(jsii_name="seed")
    def seed(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seed"))

    @seed.setter
    def seed(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c02fdfa450b09f72df9d97830bb5d1cc34269aba3b564d43b88194d2c813ce45)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seed", value)

    @builtins.property
    @jsii.member(jsii_name="seedVar")
    def seed_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seedVar"))

    @seed_var.setter
    def seed_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__501de0b5ead232287c5464758bcae6639d3127cd15f7a39d917954129851800e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seedVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsGoop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsGoop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsGoop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e7dd616d08d712529ea7b98758235b7212ba691c8cd990be070909594aef8269)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsGrayscale",
    jsii_struct_bases=[],
    name_mapping={"type": "type", "type_var": "typeVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsGrayscale:
    def __init__(
        self,
        *,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param type: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__894b83bceb0fd64cfb90105072ec7b3685ff578a60d33735080947e25d78cf25)
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsGrayscale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsGrayscaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsGrayscaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6c9228edd49d6389c73a629e57e4a88243cf12a2d5f08bbf359ef8f65437ecf7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsGrayscaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__abc60fe105c36bd286b96b055638499ef3d8afe620b5131894630bf47edd7df6)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsGrayscaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__61198f283c79ab28331d3832d2a351fe5065898276b99e0f3bdad335831f6e04)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3fcf73e7d212812f54c67427c33639eeeb0825ddb91dc3a07aef21d986553b90)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5fe63a5aabc18d6385e44c35992eefc9248fb3bc158bff53050a7d4e38794b1a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsGrayscale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsGrayscale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ddd5a260d9a317b50d5f65b655f6328b75dc1fd82cb35ce8f0a5fcda7f9a7fc3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsGrayscaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsGrayscaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ae45a3fce6bc195f1a5e272eae65e61970fe2f250f098b45268f2e2abdcf80d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7a5efcc1720e90aab680292a2bbb9416bfec39026b9831db6333ce4528e1a4e1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__023584f80fcada55bb49bdd2b5e614a92bc05400dda1374ba147141c40653e46)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsGrayscale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsGrayscale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsGrayscale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5a0c4523d9948bc983283374d3911b095525fbcd953892aa176a30872677a8f3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsHsl",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "lightness": "lightness",
        "lightness_var": "lightnessVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsHsl:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness: typing.Optional[builtins.str] = None,
        lightness_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        :param lightness_var: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__49caaaa438afafc70b10398bb3a641596accb75afb6f979b1351f7f964674755)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness", value=lightness, expected_type=type_hints["lightness"])
            check_type(argname="argument lightness_var", value=lightness_var, expected_type=type_hints["lightness_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness is not None:
            self._values["lightness"] = lightness
        if lightness_var is not None:
            self._values["lightness_var"] = lightness_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        '''
        result = self._values.get("lightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        '''
        result = self._values.get("lightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsHsl(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsHslList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsHslList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d41ab14dc8d3655deb8b60900e25079bd22478a3eb308c6762776c7485e29173)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsHslOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3f7ae6d38965b5e35eeebab6f67363c46f35cf353501d306521ef6b5f8092161)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsHslOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ef855b677d656682ac8f33b980ecab59e6ab4638683c4842d2fb66b90d81e843)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0bd2d76a891dd6019d672ef14737ba042951a53714662d0fcf5269a7f19b1b03)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b7f5a3ec819a777ece8075f1b0d3c3432f91d3027503acb2b4a51548fbee8b06)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsHsl]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsHsl]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4e01415dadbf0acca96aa63d1bdc82dd4c97e6bd3497abf378eb25b7965d11f7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsHslOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsHslOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab114efadafe9f0eabe648db6c8d2bb6aac5633282395d76c3ced6d7f25c042d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightness")
    def reset_lightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightness", []))

    @jsii.member(jsii_name="resetLightnessVar")
    def reset_lightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessInput")
    def lightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessVarInput")
    def lightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e1956acbfd51f5c2d76857b8c35cefcd4f940b55a97f014e5454cdc65df31ee1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2872c0376eced0c80aabf28aa0d2b9ae7b9d06c39900a5d0c42e7efaba4b8165)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightness")
    def lightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightness"))

    @lightness.setter
    def lightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e0c495dc45d982d44338be997f28012df34714f5a30bc38a11d941f59de0e54f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightness", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessVar")
    def lightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessVar"))

    @lightness_var.setter
    def lightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__436630569c2741b470bcc96510b6bf72b67cfc148aeab86a935a16a1111f41b5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bedcfa9e184f628b61d126594119363cd02c287eb92a56bceadd1f4e6066cd3e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__734f449c27a3ba0b069a35d4fd4aab60693cc6de795109e8f5fd838f224bc9e0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsHsl]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsHsl]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsHsl]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3d730f45de86d202e779660a5e06b03e90bd48e3c3c51db3fd9629756542aeb8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsHsv",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsHsv:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        :param value: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d5dfe1fb0339122c861ee94850e6e7d24db089296f542d447fc05653fd24d2b5)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsHsv(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsHsvList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsHsvList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a401e9f1727377300bb65ce889d02c269f0e6aa9dc639415d5f8e25bc11bd15)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsHsvOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0f7a7febfb67ea3f11d881ac949e588adf839a44c221c9aa8ad55c2afd8bc2b8)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsHsvOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4bc9232b16ff4b731e110d1e028b64c9fbc8b3952fb7517beeec865ed43c9320)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2887d560bf1163db86e30851edf11475915b77b2b032921ce1227bf7e77e19a8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d02ac139ec40d2527b341ac602c3238c5149aab24e2086ec364f944b86aea5d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsHsv]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsHsv]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f1a3a7f474673de82c03a8c92c554a11729935729802779a1a7b9425d7171427)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsHsvOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsHsvOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__02af5cdf4332b2adf16a2b311b9b8260e80c93216313192a8e84c9db8ea9ffe6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d57496b4c5eb0da5b895351e5ab3a4a182872927c064113299a0526955f06af)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__638b3b00709ba870cba7d6e6777185a7e5e08a4ce9541d688a4a7c14f1585d16)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a9331c072e85a610df08500c9ec2c6aacdf05bfc616d49b09e42588580fcc0a7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__76fc6adae9ea9b245f84a9a4c6f56d7c43bfa34e7bb13af4b09ec1616b9f0ddd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3fab33e8da40d2a18853c322a207a0b9c63a0a3dbae488a458b5889eba50cec9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa5155ff04432c9cfdb0c7e1ce8bec93a93edc770fc24c88a3c4a26058fb13f3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsHsv]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsHsv]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsHsv]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__adfce17c293d74b6c804f8cd353a1bd12054b7619a076bad1d688adfaf8ad34c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfDimension",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "dimension": "dimension",
        "dimension_var": "dimensionVar",
        "equal": "equal",
        "greater_than": "greaterThan",
        "less_than": "lessThan",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfDimension:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfDimensionDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        dimension: typing.Optional[builtins.str] = None,
        dimension_var: typing.Optional[builtins.str] = None,
        equal: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfDimensionEqual", typing.Dict[builtins.str, typing.Any]]] = None,
        greater_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfDimensionGreaterThan", typing.Dict[builtins.str, typing.Any]]] = None,
        less_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfDimensionLessThan", typing.Dict[builtins.str, typing.Any]]] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param dimension: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        :param dimension_var: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        :param equal: equal block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        :param greater_than: greater_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        :param less_than: less_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        :param value: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfDimensionDefault(**default)
        if isinstance(equal, dict):
            equal = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfDimensionEqual(**equal)
        if isinstance(greater_than, dict):
            greater_than = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfDimensionGreaterThan(**greater_than)
        if isinstance(less_than, dict):
            less_than = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfDimensionLessThan(**less_than)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3b3c37fc9a19ada38b014d82d3f0952d92a3eac695620cb9f2bcea132fc2b1c1)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument dimension", value=dimension, expected_type=type_hints["dimension"])
            check_type(argname="argument dimension_var", value=dimension_var, expected_type=type_hints["dimension_var"])
            check_type(argname="argument equal", value=equal, expected_type=type_hints["equal"])
            check_type(argname="argument greater_than", value=greater_than, expected_type=type_hints["greater_than"])
            check_type(argname="argument less_than", value=less_than, expected_type=type_hints["less_than"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if dimension is not None:
            self._values["dimension"] = dimension
        if dimension_var is not None:
            self._values["dimension_var"] = dimension_var
        if equal is not None:
            self._values["equal"] = equal
        if greater_than is not None:
            self._values["greater_than"] = greater_than
        if less_than is not None:
            self._values["less_than"] = less_than
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfDimensionDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfDimensionDefault"], result)

    @builtins.property
    def dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        '''
        result = self._values.get("dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        '''
        result = self._values.get("dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def equal(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfDimensionEqual"]:
        '''equal block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        '''
        result = self._values.get("equal")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfDimensionEqual"], result)

    @builtins.property
    def greater_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfDimensionGreaterThan"]:
        '''greater_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        '''
        result = self._values.get("greater_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfDimensionGreaterThan"], result)

    @builtins.property
    def less_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfDimensionLessThan"]:
        '''less_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        '''
        result = self._values.get("less_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfDimensionLessThan"], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfDimension(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfDimensionDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfDimensionDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfDimensionDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfDimensionDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfDimensionDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5c5b9d80a120ed8731b01647b8be98622cf6da4b80a0391a73b83df2d7679e26)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfDimensionDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfDimensionDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dd9bf224bb5fb83af1ce0ff97eba1434c72cb4d780203ff987d84f7f8f1c0c4b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfDimensionEqual",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfDimensionEqual:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfDimensionEqual(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfDimensionEqualOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfDimensionEqualOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2880330d06201eb53e54325785ed076d6922bb66aa82b8a6cfbed119c593bd88)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfDimensionEqual], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfDimensionEqual],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aea31a8f47938d27449a4e197c49007690b2351b69a941d3c18587c3e185a009)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfDimensionGreaterThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfDimensionGreaterThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfDimensionGreaterThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfDimensionGreaterThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfDimensionGreaterThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a98f1afe2f20536229668b85f9229c54d6bc5c2e16bf99cceb660386340f5c03)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfDimensionGreaterThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfDimensionGreaterThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__40e4a277bf20cf0c77f10e1af3a09eecf3968c244a0150e2cd81f98c5050beae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfDimensionLessThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfDimensionLessThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfDimensionLessThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfDimensionLessThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfDimensionLessThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__53de8f14138aee041c6c14776e619c5387a396c10f17500fa04524c8d5e6d4b8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfDimensionLessThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfDimensionLessThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__11f7b11d832865e3832fcedd940a3ba32493a4fde4a6eaaca689314e08159e6f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfDimensionList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfDimensionList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__64d4f431103e5952d786b202d712b015aaf276f2fd9259e6076d37cd44d3ba4b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfDimensionOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__78fb7a18d3b5f945bd8b5693f8f48ef7c8fec4bef4d3e40695610165b45752b7)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfDimensionOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__40b99d3cbeedcce45de503c8d912dba2930b7cbcd6752be80b325041b29dc66a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__07c783fefd0b6c7fca8bad44ede77771d750433d3ff08ccdba3792d43b4d461b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f7f3bb66c0b6c52c922d4bd1054511a9f89c6850ef78fb74df1a93b7cb4aaec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfDimension]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfDimension]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ed22e11266e69ad96b7de62cab295fcabd36e21e403525dfed133592c2c54a6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfDimensionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfDimensionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5a2aabfcc41b0982c204dcbaa11d991345802b31cb01c4bd6a2f15b2d9e378d1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfDimensionDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putEqual")
    def put_equal(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfDimensionEqual()

        return typing.cast(None, jsii.invoke(self, "putEqual", [value]))

    @jsii.member(jsii_name="putGreaterThan")
    def put_greater_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfDimensionGreaterThan()

        return typing.cast(None, jsii.invoke(self, "putGreaterThan", [value]))

    @jsii.member(jsii_name="putLessThan")
    def put_less_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfDimensionLessThan()

        return typing.cast(None, jsii.invoke(self, "putLessThan", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetDimension")
    def reset_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimension", []))

    @jsii.member(jsii_name="resetDimensionVar")
    def reset_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimensionVar", []))

    @jsii.member(jsii_name="resetEqual")
    def reset_equal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEqual", []))

    @jsii.member(jsii_name="resetGreaterThan")
    def reset_greater_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGreaterThan", []))

    @jsii.member(jsii_name="resetLessThan")
    def reset_less_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLessThan", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfDimensionDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfDimensionDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="equal")
    def equal(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfDimensionEqualOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfDimensionEqualOutputReference, jsii.get(self, "equal"))

    @builtins.property
    @jsii.member(jsii_name="greaterThan")
    def greater_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfDimensionGreaterThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfDimensionGreaterThanOutputReference, jsii.get(self, "greaterThan"))

    @builtins.property
    @jsii.member(jsii_name="lessThan")
    def less_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfDimensionLessThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfDimensionLessThanOutputReference, jsii.get(self, "lessThan"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfDimensionDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionInput")
    def dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionVarInput")
    def dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="equalInput")
    def equal_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfDimensionEqual], jsii.get(self, "equalInput"))

    @builtins.property
    @jsii.member(jsii_name="greaterThanInput")
    def greater_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfDimensionGreaterThan], jsii.get(self, "greaterThanInput"))

    @builtins.property
    @jsii.member(jsii_name="lessThanInput")
    def less_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfDimensionLessThan], jsii.get(self, "lessThanInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="dimension")
    def dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimension"))

    @dimension.setter
    def dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__97529cdb2eae9ea6b0bb168d534574c58d07d7ae17dd12d010127f334a7aeeb1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimension", value)

    @builtins.property
    @jsii.member(jsii_name="dimensionVar")
    def dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimensionVar"))

    @dimension_var.setter
    def dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1a62c42c2f7fb9f12a2a7001c9d899d2bd819af1bc1b5299fc7d576cc1f52bf4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9037aa3b1b3b86f2e61bd9edfd0d7cbbc17cabd598e9792693276a1fcbab8c8d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__11f264ebf0636685ebc1ddc36f101d71f284f2cbae8c61f379903e9fd5188272)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfDimension]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfDimension]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfDimension]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fb928b23e394b2c352170b3bc27adaac22cbf014abce04f97c6f3dc1bebefee6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfOrientation",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "landscape": "landscape",
        "portrait": "portrait",
        "square": "square",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfOrientation:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfOrientationDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        landscape: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfOrientationLandscape", typing.Dict[builtins.str, typing.Any]]] = None,
        portrait: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfOrientationPortrait", typing.Dict[builtins.str, typing.Any]]] = None,
        square: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfOrientationSquare", typing.Dict[builtins.str, typing.Any]]] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param landscape: landscape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        :param portrait: portrait block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        :param square: square block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfOrientationDefault(**default)
        if isinstance(landscape, dict):
            landscape = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfOrientationLandscape(**landscape)
        if isinstance(portrait, dict):
            portrait = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfOrientationPortrait(**portrait)
        if isinstance(square, dict):
            square = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfOrientationSquare(**square)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__975599c86e6f02bc3727088247589ad590fc06188ff088acbf68e2540642a730)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument landscape", value=landscape, expected_type=type_hints["landscape"])
            check_type(argname="argument portrait", value=portrait, expected_type=type_hints["portrait"])
            check_type(argname="argument square", value=square, expected_type=type_hints["square"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if landscape is not None:
            self._values["landscape"] = landscape
        if portrait is not None:
            self._values["portrait"] = portrait
        if square is not None:
            self._values["square"] = square

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfOrientationDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfOrientationDefault"], result)

    @builtins.property
    def landscape(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfOrientationLandscape"]:
        '''landscape block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        '''
        result = self._values.get("landscape")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfOrientationLandscape"], result)

    @builtins.property
    def portrait(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfOrientationPortrait"]:
        '''portrait block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        '''
        result = self._values.get("portrait")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfOrientationPortrait"], result)

    @builtins.property
    def square(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfOrientationSquare"]:
        '''square block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        result = self._values.get("square")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfOrientationSquare"], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfOrientation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfOrientationDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfOrientationDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfOrientationDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfOrientationDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfOrientationDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c7fbad6fa057f3225710e7f96486830cb3b4d4a25ef5054377e36b2f4fa723ea)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfOrientationDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfOrientationDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2b0388c9e59ba0bd0eb4a46e1d2263595e4bd800f6e01c214213270fc283287a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfOrientationLandscape",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfOrientationLandscape:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfOrientationLandscape(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfOrientationLandscapeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfOrientationLandscapeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5684e42a796c67d0ec35c4e1d5b685f5b1f8e6bf69394659c51004ea1292cd6d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfOrientationLandscape], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfOrientationLandscape],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9e7ec2c829cdec4a2ccc5dc408fceff8074e9f00809e351c3679c7fa11044b01)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfOrientationList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfOrientationList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e854d262d3d668692fcbc668a81cf2c9673446031f9120e739bc52dee6813ad3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfOrientationOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__37a79e92879b5621fc10f26009c33c2ca2c071541448a523c915516797c2fb0d)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfOrientationOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0d037cae0d90c5669089e36815158670dcfdb13b20c144d9ddada30188517e5f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3eb1dac7f9aaee9c6a4639da923ed3d0c7f393b37f7b74837a348c0358e9b1d0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__55e28c55229b16b10eca6663c10f42cceee86adcf028b94e1697b55834970144)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfOrientation]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfOrientation]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0c58d7217315f6dd8ea30d75f08025342b430bc3abbb855e2fb970933d2df7cb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfOrientationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfOrientationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e098662fc0430057c1909561e8525f50f337214be299108b41d5f4a02db8d4d8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfOrientationDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putLandscape")
    def put_landscape(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfOrientationLandscape()

        return typing.cast(None, jsii.invoke(self, "putLandscape", [value]))

    @jsii.member(jsii_name="putPortrait")
    def put_portrait(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfOrientationPortrait()

        return typing.cast(None, jsii.invoke(self, "putPortrait", [value]))

    @jsii.member(jsii_name="putSquare")
    def put_square(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfOrientationSquare()

        return typing.cast(None, jsii.invoke(self, "putSquare", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetLandscape")
    def reset_landscape(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLandscape", []))

    @jsii.member(jsii_name="resetPortrait")
    def reset_portrait(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPortrait", []))

    @jsii.member(jsii_name="resetSquare")
    def reset_square(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSquare", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfOrientationDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfOrientationDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="landscape")
    def landscape(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfOrientationLandscapeOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfOrientationLandscapeOutputReference, jsii.get(self, "landscape"))

    @builtins.property
    @jsii.member(jsii_name="portrait")
    def portrait(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfOrientationPortraitOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfOrientationPortraitOutputReference", jsii.get(self, "portrait"))

    @builtins.property
    @jsii.member(jsii_name="square")
    def square(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfOrientationSquareOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfOrientationSquareOutputReference", jsii.get(self, "square"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfOrientationDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="landscapeInput")
    def landscape_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfOrientationLandscape], jsii.get(self, "landscapeInput"))

    @builtins.property
    @jsii.member(jsii_name="portraitInput")
    def portrait_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfOrientationPortrait"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfOrientationPortrait"], jsii.get(self, "portraitInput"))

    @builtins.property
    @jsii.member(jsii_name="squareInput")
    def square_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfOrientationSquare"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfOrientationSquare"], jsii.get(self, "squareInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfOrientation]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfOrientation]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfOrientation]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__772b9b8b7462b4d3104fd25254a03afdff318cfde8957327de6a6c2ee8ae33a2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfOrientationPortrait",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfOrientationPortrait:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfOrientationPortrait(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfOrientationPortraitOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfOrientationPortraitOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bbad738149d0c8465303b1133553782c8ab9ea8bcc8caaa8a071671746936a97)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfOrientationPortrait]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfOrientationPortrait], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfOrientationPortrait],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__067045e357d1db8fa1a3812e333fc7dd558a0f121f219a250930e4b43b9d6bee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfOrientationSquare",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfOrientationSquare:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfOrientationSquare(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfOrientationSquareOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfOrientationSquareOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__80870c16b796151a5f5d8a11274aad8b6105fe572dc54279ad46d7c60229ab62)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfOrientationSquare]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfOrientationSquare], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfOrientationSquare],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4b2d697df9fb1b999b233e38cb24e7438ad431fe4bd37a4c32df96268757f5d7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d8eb6b6895d211d547d2f22ae8459535703906afc2424be36f32cbc4f76de5b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0a4ce0fde97bc39ca4dc498bed2f88bdcad0bbc5910b29569a04c0a315a6755e)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f8a5ab63ac5c23dd2c12d448971ebd92d7271b58bcd66f4b16bc90edb528be9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__77e51c6d1ff597ceb7c8a3f291974c3e6559be2eab90ae7d7056531d1ea53b7e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0c355cf480dde900779e79ab2f933e94d46da692a553b94cf4656a7748242377)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformations]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformations]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformations]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__63dbf5e6bfba7bff3569f112db140390bc878d919c97539e375e6c1ba8d9686b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsMaxColors",
    jsii_struct_bases=[],
    name_mapping={"colors": "colors", "colors_var": "colorsVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsMaxColors:
    def __init__(
        self,
        *,
        colors: typing.Optional[builtins.str] = None,
        colors_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param colors: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        :param colors_var: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ccd987d12244c3611e18ff1a8ea78b6b443b2e3df283b25d5b22104f68d6aab6)
            check_type(argname="argument colors", value=colors, expected_type=type_hints["colors"])
            check_type(argname="argument colors_var", value=colors_var, expected_type=type_hints["colors_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if colors is not None:
            self._values["colors"] = colors
        if colors_var is not None:
            self._values["colors_var"] = colors_var

    @builtins.property
    def colors(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        '''
        result = self._values.get("colors")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def colors_var(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        result = self._values.get("colors_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsMaxColors(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsMaxColorsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsMaxColorsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f27ec4d0a537550a0493ee05c6f1a8533b062c18b88fc4930bb73e6b767d9a5a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsMaxColorsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__842f3f0785c00cebfd6f6c945628e66547bd7d133e2f7e85f2158ec226cc116a)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsMaxColorsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__93c71d93038a0257a8b0530c84ff5ba6500eacccbc244575697c5ae5f260debf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__60d347377e344e2097b05b63b8dd6d07dd3bb17c8c6649e1aa5707315a638deb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d022c8469f74696885c877551229ec3ca94c233c255cf3bd082320e0997d4811)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsMaxColors]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsMaxColors]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b0c7ba74f0cb64483929b0f18f22e30c669afa8299017b68a2a9eddd90bfbd94)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsMaxColorsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsMaxColorsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6ab841c83825d96e48c87396555d2f328a31a960197cf7c8a9f0133cdd395467)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColors")
    def reset_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColors", []))

    @jsii.member(jsii_name="resetColorsVar")
    def reset_colors_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorsVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorsInput")
    def colors_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsInput"))

    @builtins.property
    @jsii.member(jsii_name="colorsVarInput")
    def colors_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsVarInput"))

    @builtins.property
    @jsii.member(jsii_name="colors")
    def colors(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colors"))

    @colors.setter
    def colors(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__330d96b7d68cc78de6d9c68ecbb261032bc9bb873b4a62143d9cb2ad78d32588)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colors", value)

    @builtins.property
    @jsii.member(jsii_name="colorsVar")
    def colors_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorsVar"))

    @colors_var.setter
    def colors_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__32ba8816ababba56353c7dde74a79a6f89845249f7422eba5bf8074b31aeb3cd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorsVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsMaxColors]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsMaxColors]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsMaxColors]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c3e7149e253c67421536ea849516c6440dd6aea260b66f1ae3c9c0fd6b800805)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsMirror",
    jsii_struct_bases=[],
    name_mapping={
        "horizontal": "horizontal",
        "horizontal_var": "horizontalVar",
        "vertical": "vertical",
        "vertical_var": "verticalVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsMirror:
    def __init__(
        self,
        *,
        horizontal: typing.Optional[builtins.str] = None,
        horizontal_var: typing.Optional[builtins.str] = None,
        vertical: typing.Optional[builtins.str] = None,
        vertical_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param horizontal: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        :param horizontal_var: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        :param vertical: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        :param vertical_var: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e80c87b5042cc6be754e4e0092bbe31ca809a7445253c8e24c14290149f45434)
            check_type(argname="argument horizontal", value=horizontal, expected_type=type_hints["horizontal"])
            check_type(argname="argument horizontal_var", value=horizontal_var, expected_type=type_hints["horizontal_var"])
            check_type(argname="argument vertical", value=vertical, expected_type=type_hints["vertical"])
            check_type(argname="argument vertical_var", value=vertical_var, expected_type=type_hints["vertical_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if horizontal is not None:
            self._values["horizontal"] = horizontal
        if horizontal_var is not None:
            self._values["horizontal_var"] = horizontal_var
        if vertical is not None:
            self._values["vertical"] = vertical
        if vertical_var is not None:
            self._values["vertical_var"] = vertical_var

    @builtins.property
    def horizontal(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        '''
        result = self._values.get("horizontal")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def horizontal_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        '''
        result = self._values.get("horizontal_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        '''
        result = self._values.get("vertical")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        result = self._values.get("vertical_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsMirror(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsMirrorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsMirrorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__221da8f90c854a77002eb18ea2a1c4727f17fdb671594fbd0e7c5745d23a3e67)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsMirrorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0fe14d207a5deb9f286c503c82e4431f2e59991f04c2c48543dc3c14a7501004)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsMirrorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a679c0c499cfb800201c18b5ebdc34326255162459b9a9cd8db4890fe65169e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__20708951214acb955c6f40875f9fa7def8d7b3c34af7e5a6d40d76f99a66e704)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b6b4039f8d3f405af8bbcc6f801ac6775ce00b19211d1915af6a126b0b54b60c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsMirror]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsMirror]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__183886b452ccb974ec50b82b962a63ad5591e02676a0fdf665aae05580ca20e5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsMirrorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsMirrorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f65b5ae2e053e5af44c81835ab94f77ddd00326857f626600fff212dd6fc4fc2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHorizontal")
    def reset_horizontal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontal", []))

    @jsii.member(jsii_name="resetHorizontalVar")
    def reset_horizontal_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontalVar", []))

    @jsii.member(jsii_name="resetVertical")
    def reset_vertical(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVertical", []))

    @jsii.member(jsii_name="resetVerticalVar")
    def reset_vertical_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVerticalVar", []))

    @builtins.property
    @jsii.member(jsii_name="horizontalInput")
    def horizontal_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontalVarInput")
    def horizontal_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalInput")
    def vertical_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalVarInput")
    def vertical_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontal")
    def horizontal(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontal"))

    @horizontal.setter
    def horizontal(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__42d993f22a3419c38a055d01e636e162b60adc82ae759cc6f5c06262d281c1d2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontal", value)

    @builtins.property
    @jsii.member(jsii_name="horizontalVar")
    def horizontal_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontalVar"))

    @horizontal_var.setter
    def horizontal_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cc42b3f916644b109a5f6617040cdf42962425e45bbf0c6f0cbbf04004c8db9f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontalVar", value)

    @builtins.property
    @jsii.member(jsii_name="vertical")
    def vertical(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "vertical"))

    @vertical.setter
    def vertical(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3f4563fc1d3dec67dff5bd91b27e236b9cb92f84dd8062c5a8e0c8d449e6ff22)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "vertical", value)

    @builtins.property
    @jsii.member(jsii_name="verticalVar")
    def vertical_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "verticalVar"))

    @vertical_var.setter
    def vertical_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1785bf20d210cab1abce076da85bf9dd85256ef01aac6aea5aaee468fcbb67f4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "verticalVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsMirror]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsMirror]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsMirror]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__877c5d240221f5455551761869b944203e73830c9273e54fc48299322dcea293)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsMonoHue",
    jsii_struct_bases=[],
    name_mapping={"hue": "hue", "hue_var": "hueVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsMonoHue:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f0e6b85244bfb711a1f4f97e7ad93d01c59ebcdcc19a18d5b75bd1921413a96d)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsMonoHue(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsMonoHueList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsMonoHueList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__28c1bab35cb028f6d3399731c0f1e6182faf6cb30b653fec729f7354ae99e13f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsMonoHueOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__04b59cc06a5fee3f6469a05d97149c5dc55d51aebf66b83f95623a7bc92264fc)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsMonoHueOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__180b4c55802c070edf5d11ab798e55106819214b34f97ebe21b98d1580334753)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__59b1c8dcbc181cba89207bb67686f51bcdd4d7a8d278a562cd3ce374c1dd655d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e22e0de953d41521f570ae5af5dbf3d249c634c77eebee45bb16dfb0de3b4f6a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsMonoHue]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsMonoHue]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6a02a06afa75e06b99c97572eb5a0b0192cf36c76c3c70802a57dc56d8a1476f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsMonoHueOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsMonoHueOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9b74baf74f8d5e782b6623abe754cf7693f78e03210ab6a3eaa61f56c59dfa71)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fff1bf9a4eb3b46b156a2f74cc988ee6af70f3c249873741dff076445c65054f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b69b61e1866b20ccab3e761b0f028ced1a11db9d757108b956d02aec5ba474c9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsMonoHue]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsMonoHue]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsMonoHue]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__699ccdf868320033c3684fe55746d9c5be7acf275929c47434713f49560bbaae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsOpacity",
    jsii_struct_bases=[],
    name_mapping={"opacity": "opacity", "opacity_var": "opacityVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsOpacity:
    def __init__(
        self,
        *,
        opacity: typing.Optional[builtins.str] = None,
        opacity_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param opacity: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param opacity_var: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d8b4ade7a01f1da87a0b5ea1c5ed197e8e832e96e54f4a822244a7f220d5b445)
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument opacity_var", value=opacity_var, expected_type=type_hints["opacity_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if opacity is not None:
            self._values["opacity"] = opacity
        if opacity_var is not None:
            self._values["opacity_var"] = opacity_var

    @builtins.property
    def opacity(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def opacity_var(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        result = self._values.get("opacity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsOpacity(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsOpacityList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsOpacityList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1770e1fc80134bff77a7ca235d265ae2b25aa928c8361a46bf70884c2e396249)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsOpacityOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__25bb0306526b62297c3765b3c8af44c6b45125344d5dcaaff0eff27f07e054ef)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsOpacityOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4abda42b5c2de0d173349eb3aee681e59931e638378a77fad8880ffac39a2717)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e8bd9a81a920d83df839eadc508ffc2aed0b938a37324b8c0f893104461248bb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b1d7c8ba6b0f0528b629b2d90b85ca49c53f02e1ebb3d03f2dee2980b7540c8b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsOpacity]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsOpacity]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd8616145ed0c81a26507f07f1bc98b5d118b495b40a4c909af6c950a4e02fc4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsOpacityOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsOpacityOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3565e23d9962d6760aabd4346e9c9d46db5eac9f47fa336c5fc0847df889d297)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetOpacityVar")
    def reset_opacity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacityVar", []))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityVarInput")
    def opacity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacity"))

    @opacity.setter
    def opacity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__72cbda63f21b377f4960bd6a77540c075be19aade7be308f076e46dde3cebeb5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacity", value)

    @builtins.property
    @jsii.member(jsii_name="opacityVar")
    def opacity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacityVar"))

    @opacity_var.setter
    def opacity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__938bea2859a46713566b4611217bc6d39ec869cd4f341b2e9e49c75c0ac898cd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacityVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsOpacity]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsOpacity]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsOpacity]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f13eaa459481cbec132257d05ad5f26ad17722410ab822500ae40f81c9384020)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__66d48f0b6749be2af660117e191f130c919133b87dd77addb306768603c45644)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putBackgroundColor")
    def put_background_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d3caefbcaa13fe18a118b503107661865e76653476f4c5eb9c7a1652c7f75e51)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBackgroundColor", [value]))

    @jsii.member(jsii_name="putBlur")
    def put_blur(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsBlur, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__151973698be23fc56feaba30ecc7519979d9899622cdacaede254257fbae1bc0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBlur", [value]))

    @jsii.member(jsii_name="putChromaKey")
    def put_chroma_key(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsChromaKey, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a6000a3cf509125354dafde38e96fb9c29509769be99a56e29c7d06fbad2ee49)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putChromaKey", [value]))

    @jsii.member(jsii_name="putComposite")
    def put_composite(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsComposite, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2575cfce11424a65e29d79ebe71a72b06ec26bd94c5ec20a6868431792845fb2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putComposite", [value]))

    @jsii.member(jsii_name="putCompound")
    def put_compound(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsCompound, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__47b73c75b68328656be738d3d2b8b2b3cb1e9f6cd72bb86adaaa0ba0b3fd2cf4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCompound", [value]))

    @jsii.member(jsii_name="putContrast")
    def put_contrast(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsContrast, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ae3d49434f5ed700ab57b7ddf8790110289d5c410d9d2935de1568a1930d5710)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putContrast", [value]))

    @jsii.member(jsii_name="putGoop")
    def put_goop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsGoop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d195fec3c2dda27733e7d296994a7c2a37126ac16d26a83c4a15ac19a925bd3b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGoop", [value]))

    @jsii.member(jsii_name="putGrayscale")
    def put_grayscale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsGrayscale, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4e51b050e88bca34ea2d8ca6ef1f26a1c8bb5c3889e380bddb047336ba12c400)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGrayscale", [value]))

    @jsii.member(jsii_name="putHsl")
    def put_hsl(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsHsl, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1a7f9d39bc7b5715643b3ddbd912c912d48aa63e5436595572b7ccf054dc0a12)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsl", [value]))

    @jsii.member(jsii_name="putHsv")
    def put_hsv(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsHsv, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f11f3af1f01955df00d89215b7b8b78471e7bd6c732928f5e528430917774f91)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsv", [value]))

    @jsii.member(jsii_name="putIfDimension")
    def put_if_dimension(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfDimension, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea752f0d5c6dfbf4cf782bb04041c2588f6df4be64ed2d7899dd30392dc8a99f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfDimension", [value]))

    @jsii.member(jsii_name="putIfOrientation")
    def put_if_orientation(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be85f7b9dfbc16a0e875188a884a1d9bf4ecb8f639963119d459c483f540acc6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfOrientation", [value]))

    @jsii.member(jsii_name="putMaxColors")
    def put_max_colors(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsMaxColors, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4f3b70e6ce23dbf3c38a3b6543b6557468ddbaa0694c6b1f7629dace4fcc1119)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMaxColors", [value]))

    @jsii.member(jsii_name="putMirror")
    def put_mirror(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsMirror, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e6147737aad5c8f29619ad959b2719446c2b1585bc88d1abbbc71c93009fc40a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMirror", [value]))

    @jsii.member(jsii_name="putMonoHue")
    def put_mono_hue(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsMonoHue, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5af6561b8ad48d695d935a990ab83e11bb801ef9e4c86986c24da0486e5f8815)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMonoHue", [value]))

    @jsii.member(jsii_name="putOpacity")
    def put_opacity(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsOpacity, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7810de5af66b0662e1565ab5f5279afb930bf1c9d5769cbb01dfc0c49b6cec7e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putOpacity", [value]))

    @jsii.member(jsii_name="putRemoveColor")
    def put_remove_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsRemoveColor", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__22eda382e6d1f2b0a850b13cddd2cf0f1a4c7938795be8712fea7511a1249b57)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRemoveColor", [value]))

    @jsii.member(jsii_name="putUnsharpMask")
    def put_unsharp_mask(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsUnsharpMask", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d4d99b3353d01a646828823e94573afdb053e7014149ac9772376f7936e1c427)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putUnsharpMask", [value]))

    @jsii.member(jsii_name="resetBackgroundColor")
    def reset_background_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBackgroundColor", []))

    @jsii.member(jsii_name="resetBlur")
    def reset_blur(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBlur", []))

    @jsii.member(jsii_name="resetChromaKey")
    def reset_chroma_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChromaKey", []))

    @jsii.member(jsii_name="resetComposite")
    def reset_composite(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetComposite", []))

    @jsii.member(jsii_name="resetCompound")
    def reset_compound(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCompound", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetGoop")
    def reset_goop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGoop", []))

    @jsii.member(jsii_name="resetGrayscale")
    def reset_grayscale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGrayscale", []))

    @jsii.member(jsii_name="resetHsl")
    def reset_hsl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsl", []))

    @jsii.member(jsii_name="resetHsv")
    def reset_hsv(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsv", []))

    @jsii.member(jsii_name="resetIfDimension")
    def reset_if_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfDimension", []))

    @jsii.member(jsii_name="resetIfOrientation")
    def reset_if_orientation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfOrientation", []))

    @jsii.member(jsii_name="resetMaxColors")
    def reset_max_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxColors", []))

    @jsii.member(jsii_name="resetMirror")
    def reset_mirror(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMirror", []))

    @jsii.member(jsii_name="resetMonoHue")
    def reset_mono_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonoHue", []))

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetRemoveColor")
    def reset_remove_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRemoveColor", []))

    @jsii.member(jsii_name="resetUnsharpMask")
    def reset_unsharp_mask(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUnsharpMask", []))

    @builtins.property
    @jsii.member(jsii_name="backgroundColor")
    def background_color(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsBackgroundColorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsBackgroundColorList, jsii.get(self, "backgroundColor"))

    @builtins.property
    @jsii.member(jsii_name="blur")
    def blur(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsBlurList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsBlurList, jsii.get(self, "blur"))

    @builtins.property
    @jsii.member(jsii_name="chromaKey")
    def chroma_key(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsChromaKeyList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsChromaKeyList, jsii.get(self, "chromaKey"))

    @builtins.property
    @jsii.member(jsii_name="composite")
    def composite(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsCompositeList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsCompositeList, jsii.get(self, "composite"))

    @builtins.property
    @jsii.member(jsii_name="compound")
    def compound(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsCompoundList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsCompoundList, jsii.get(self, "compound"))

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsContrastList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsContrastList, jsii.get(self, "contrast"))

    @builtins.property
    @jsii.member(jsii_name="goop")
    def goop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsGoopList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsGoopList, jsii.get(self, "goop"))

    @builtins.property
    @jsii.member(jsii_name="grayscale")
    def grayscale(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsGrayscaleList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsGrayscaleList, jsii.get(self, "grayscale"))

    @builtins.property
    @jsii.member(jsii_name="hsl")
    def hsl(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsHslList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsHslList, jsii.get(self, "hsl"))

    @builtins.property
    @jsii.member(jsii_name="hsv")
    def hsv(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsHsvList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsHsvList, jsii.get(self, "hsv"))

    @builtins.property
    @jsii.member(jsii_name="ifDimension")
    def if_dimension(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfDimensionList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfDimensionList, jsii.get(self, "ifDimension"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientation")
    def if_orientation(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfOrientationList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfOrientationList, jsii.get(self, "ifOrientation"))

    @builtins.property
    @jsii.member(jsii_name="maxColors")
    def max_colors(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsMaxColorsList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsMaxColorsList, jsii.get(self, "maxColors"))

    @builtins.property
    @jsii.member(jsii_name="mirror")
    def mirror(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsMirrorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsMirrorList, jsii.get(self, "mirror"))

    @builtins.property
    @jsii.member(jsii_name="monoHue")
    def mono_hue(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsMonoHueList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsMonoHueList, jsii.get(self, "monoHue"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsOpacityList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsOpacityList, jsii.get(self, "opacity"))

    @builtins.property
    @jsii.member(jsii_name="removeColor")
    def remove_color(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsRemoveColorList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsRemoveColorList", jsii.get(self, "removeColor"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMask")
    def unsharp_mask(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsUnsharpMaskList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsUnsharpMaskList", jsii.get(self, "unsharpMask"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColorInput")
    def background_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsBackgroundColor]]], jsii.get(self, "backgroundColorInput"))

    @builtins.property
    @jsii.member(jsii_name="blurInput")
    def blur_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsBlur]]], jsii.get(self, "blurInput"))

    @builtins.property
    @jsii.member(jsii_name="chromaKeyInput")
    def chroma_key_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsChromaKey]]], jsii.get(self, "chromaKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="compositeInput")
    def composite_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsComposite]]], jsii.get(self, "compositeInput"))

    @builtins.property
    @jsii.member(jsii_name="compoundInput")
    def compound_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsCompound]]], jsii.get(self, "compoundInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsContrast]]], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="goopInput")
    def goop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsGoop]]], jsii.get(self, "goopInput"))

    @builtins.property
    @jsii.member(jsii_name="grayscaleInput")
    def grayscale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsGrayscale]]], jsii.get(self, "grayscaleInput"))

    @builtins.property
    @jsii.member(jsii_name="hslInput")
    def hsl_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsHsl]]], jsii.get(self, "hslInput"))

    @builtins.property
    @jsii.member(jsii_name="hsvInput")
    def hsv_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsHsv]]], jsii.get(self, "hsvInput"))

    @builtins.property
    @jsii.member(jsii_name="ifDimensionInput")
    def if_dimension_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfDimension]]], jsii.get(self, "ifDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientationInput")
    def if_orientation_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfOrientation]]], jsii.get(self, "ifOrientationInput"))

    @builtins.property
    @jsii.member(jsii_name="maxColorsInput")
    def max_colors_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsMaxColors]]], jsii.get(self, "maxColorsInput"))

    @builtins.property
    @jsii.member(jsii_name="mirrorInput")
    def mirror_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsMirror]]], jsii.get(self, "mirrorInput"))

    @builtins.property
    @jsii.member(jsii_name="monoHueInput")
    def mono_hue_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsMonoHue]]], jsii.get(self, "monoHueInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsOpacity]]], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="removeColorInput")
    def remove_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsRemoveColor"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsRemoveColor"]]], jsii.get(self, "removeColorInput"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMaskInput")
    def unsharp_mask_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsUnsharpMask"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsUnsharpMask"]]], jsii.get(self, "unsharpMaskInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformations]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformations]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformations]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c8bda7d42ee2754c81146768caf99b3c306ab56ed135938425898add5cd9d22c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsRemoveColor",
    jsii_struct_bases=[],
    name_mapping={
        "color": "color",
        "color_var": "colorVar",
        "feather": "feather",
        "feather_var": "featherVar",
        "tolerance": "tolerance",
        "tolerance_var": "toleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsRemoveColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
        feather: typing.Optional[builtins.str] = None,
        feather_var: typing.Optional[builtins.str] = None,
        tolerance: typing.Optional[builtins.str] = None,
        tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        :param feather: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        :param feather_var: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        :param tolerance: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        :param tolerance_var: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dc87cfce7d5c7733694b1ac796f622f3420fd35264da630201d56b8c68d9f963)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
            check_type(argname="argument feather", value=feather, expected_type=type_hints["feather"])
            check_type(argname="argument feather_var", value=feather_var, expected_type=type_hints["feather_var"])
            check_type(argname="argument tolerance", value=tolerance, expected_type=type_hints["tolerance"])
            check_type(argname="argument tolerance_var", value=tolerance_var, expected_type=type_hints["tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var
        if feather is not None:
            self._values["feather"] = feather
        if feather_var is not None:
            self._values["feather_var"] = feather_var
        if tolerance is not None:
            self._values["tolerance"] = tolerance
        if tolerance_var is not None:
            self._values["tolerance_var"] = tolerance_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        '''
        result = self._values.get("feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather_var(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        '''
        result = self._values.get("feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        '''
        result = self._values.get("tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance_var(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        result = self._values.get("tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsRemoveColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsRemoveColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsRemoveColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1c12d8fd07d7c946ee3e183e046fbe130a6aab2015c134efb301453fe956b8b1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsRemoveColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5e2561808e5f1e6e1a488d9351e1f34a2b66d26a8879493d78ae74b9d7651cf1)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsRemoveColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__779a5cc363e0fd8dee2687fdc55af10e3af2f60a2698b3fb1d1ea11acf075662)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f1e030fed30d7d39962af9c86a74d2552cab9bc332bb9cd4cb22e870c0f1619c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0bba483e465d912e3cfd3b17632a8f38b4e38d5e1e5c73d460d16b2ad55f1e5c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsRemoveColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsRemoveColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsRemoveColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7831954baf594373a024f4337ac1554ace367fdd64f56111e1af62a2c05b4e46)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsRemoveColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsRemoveColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c8c911fa0d03913fb3f005957f603b272d4c49846e77769d5ae5c5f0b2ddc2f4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @jsii.member(jsii_name="resetFeather")
    def reset_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeather", []))

    @jsii.member(jsii_name="resetFeatherVar")
    def reset_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatherVar", []))

    @jsii.member(jsii_name="resetTolerance")
    def reset_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTolerance", []))

    @jsii.member(jsii_name="resetToleranceVar")
    def reset_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featherInput")
    def feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherInput"))

    @builtins.property
    @jsii.member(jsii_name="featherVarInput")
    def feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceInput")
    def tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceVarInput")
    def tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a8187df61cca6c44dcb550838bfb86bda8d1e0a4fa04e2a8edeea1fd62f2fd9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__857f533777cb9be24a682a1b2992d7bb88fc4e7316133150bdbb99f51377663b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="feather")
    def feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "feather"))

    @feather.setter
    def feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1843de1d51604380e8ab5eed6508c9d418ef62e0b81f7082db7f9523cb3b8a2c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "feather", value)

    @builtins.property
    @jsii.member(jsii_name="featherVar")
    def feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featherVar"))

    @feather_var.setter
    def feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0641334bbed02ab46f69794acd92c7b07c40a39c56cb5670ba8c2ac54b6bb339)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featherVar", value)

    @builtins.property
    @jsii.member(jsii_name="tolerance")
    def tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tolerance"))

    @tolerance.setter
    def tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b2af4dd72b536bcace060c868a15d0127a7d208fe6480f33b85ee159fae95c33)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tolerance", value)

    @builtins.property
    @jsii.member(jsii_name="toleranceVar")
    def tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "toleranceVar"))

    @tolerance_var.setter
    def tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__595854ea41e758921fc5a0d9760834b80ff529fae147c9fea9c0fabf6cf0ae83)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "toleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsRemoveColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsRemoveColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsRemoveColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__60b1998fceef376c812515aef52dedacec4c3077a3b1e16abdb536fe86da57c6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsUnsharpMask",
    jsii_struct_bases=[],
    name_mapping={
        "gain": "gain",
        "gain_var": "gainVar",
        "sigma": "sigma",
        "sigma_var": "sigmaVar",
        "threshold": "threshold",
        "threshold_var": "thresholdVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsUnsharpMask:
    def __init__(
        self,
        *,
        gain: typing.Optional[builtins.str] = None,
        gain_var: typing.Optional[builtins.str] = None,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
        threshold: typing.Optional[builtins.str] = None,
        threshold_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param gain: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        :param gain_var: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        :param sigma: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        :param threshold: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        :param threshold_var: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4285c80f838f1741fec6b3884c16b7d42fec6e2f27263d476d2b1c1355796dd5)
            check_type(argname="argument gain", value=gain, expected_type=type_hints["gain"])
            check_type(argname="argument gain_var", value=gain_var, expected_type=type_hints["gain_var"])
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
            check_type(argname="argument threshold", value=threshold, expected_type=type_hints["threshold"])
            check_type(argname="argument threshold_var", value=threshold_var, expected_type=type_hints["threshold_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if gain is not None:
            self._values["gain"] = gain
        if gain_var is not None:
            self._values["gain_var"] = gain_var
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var
        if threshold is not None:
            self._values["threshold"] = threshold
        if threshold_var is not None:
            self._values["threshold_var"] = threshold_var

    @builtins.property
    def gain(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        '''
        result = self._values.get("gain")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gain_var(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        '''
        result = self._values.get("gain_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        '''
        result = self._values.get("threshold")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold_var(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        result = self._values.get("threshold_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsUnsharpMask(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsUnsharpMaskList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsUnsharpMaskList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6204e8e9ebb69cf48029f710ff17bee0a1733d006a7a87db72a0be28f92f72b3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsUnsharpMaskOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a96365980c0ca30b21b46c92ff2cfcb41a0bb1a4df84c5a24699edee9871a765)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsUnsharpMaskOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dc4e9f8d41ed3fde878606d4dfe2a37f8b7a7d2f3274f47e27dff026fe2c7bf8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3568cde30f816494ef35301b223bd15b6373436ecb8714668e8390c4c3c524db)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1da1d36a50251acfa7b9f80a88da1af75f649550b12d1b6e88559aa3ee15279b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsUnsharpMask]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsUnsharpMask]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsUnsharpMask]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e86dec00f255afe876793a6d0c8458bf0302734e6dbc3ad26389e44933c7e1ad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsUnsharpMaskOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsUnsharpMaskOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c2df6faa17f7c8773d008a0caa11cfa83343430f0cdc9defa462f1761d814471)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetGain")
    def reset_gain(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGain", []))

    @jsii.member(jsii_name="resetGainVar")
    def reset_gain_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGainVar", []))

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @jsii.member(jsii_name="resetThreshold")
    def reset_threshold(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThreshold", []))

    @jsii.member(jsii_name="resetThresholdVar")
    def reset_threshold_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThresholdVar", []))

    @builtins.property
    @jsii.member(jsii_name="gainInput")
    def gain_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainInput"))

    @builtins.property
    @jsii.member(jsii_name="gainVarInput")
    def gain_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdInput")
    def threshold_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdVarInput")
    def threshold_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gain")
    def gain(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gain"))

    @gain.setter
    def gain(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__94b61f8cc232df4f47e66d94c978fb52a9034c8aca612a5af86c5e7be36ceb48)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gain", value)

    @builtins.property
    @jsii.member(jsii_name="gainVar")
    def gain_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gainVar"))

    @gain_var.setter
    def gain_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__487f9175a4e2c1f3d061fa1a9183cfb0c8a19ff5f17cb02a9c9dbc04e14c5321)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gainVar", value)

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5fc95ce02f87174c592a480772b7355a1bc2cff372fee7023e2c490046fcb164)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cdf03de271f0bc0939cb0aa58b24a4a7487014de6891293c07e0099de558d327)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="threshold")
    def threshold(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "threshold"))

    @threshold.setter
    def threshold(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__569563016460faf72525064ed9f07b50c36d35050478becfcaedcee71ad0b4a6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "threshold", value)

    @builtins.property
    @jsii.member(jsii_name="thresholdVar")
    def threshold_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "thresholdVar"))

    @threshold_var.setter
    def threshold_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__41b53ef3b6115e27a1f15578c32e27c6eb915dcafa994000bfa6ad215998a394)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "thresholdVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsUnsharpMask]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsUnsharpMask]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsUnsharpMask]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__15b3b89d28f0582d6e45a69b6d82f7e8d3ae95f32ebddba96889d8f40bd18cd3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitContrast",
    jsii_struct_bases=[],
    name_mapping={
        "brightness": "brightness",
        "brightness_var": "brightnessVar",
        "contrast": "contrast",
        "contrast_var": "contrastVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitContrast:
    def __init__(
        self,
        *,
        brightness: typing.Optional[builtins.str] = None,
        brightness_var: typing.Optional[builtins.str] = None,
        contrast: typing.Optional[builtins.str] = None,
        contrast_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param brightness: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        :param brightness_var: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        :param contrast: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param contrast_var: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__def202acf10ced1611a1578f93022adb8d8742c5fb4edf173171975cbc8f7c81)
            check_type(argname="argument brightness", value=brightness, expected_type=type_hints["brightness"])
            check_type(argname="argument brightness_var", value=brightness_var, expected_type=type_hints["brightness_var"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument contrast_var", value=contrast_var, expected_type=type_hints["contrast_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if brightness is not None:
            self._values["brightness"] = brightness
        if brightness_var is not None:
            self._values["brightness_var"] = brightness_var
        if contrast is not None:
            self._values["contrast"] = contrast
        if contrast_var is not None:
            self._values["contrast_var"] = contrast_var

    @builtins.property
    def brightness(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        '''
        result = self._values.get("brightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def brightness_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        '''
        result = self._values.get("brightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        result = self._values.get("contrast_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitContrast(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitContrastList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitContrastList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1efd71bd01458b1ce31185b41d1b886ace9e5d2abacae8544c8086bdb704fb3b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitContrastOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6280908f7a4ae433461a45bbcd8f1196903fcff8e68f8f9f3745b77ce064d7ec)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitContrastOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc2b8948c2b40c6e679f8d3d0a00826e987142cada1b2f23957537e4f72de2fe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__45877f6e43799227a8108fe98bea09764a1858e1b1b1d482f2ece4e757e19a7a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb967cc274e6b0497836a9e2c60bf3d56151117e9f87b957574f34069ca218d1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitContrast]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitContrast]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0e86163da7fc1822f5511bbfe32afbeafe17a43d0cbd2db6b96685c49800f764)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitContrastOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitContrastOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3e593b1cfa93efd8cea8f804e6165adca95bf8bf7ccf7385a99c8df4cd69cac0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetBrightness")
    def reset_brightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightness", []))

    @jsii.member(jsii_name="resetBrightnessVar")
    def reset_brightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightnessVar", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetContrastVar")
    def reset_contrast_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrastVar", []))

    @builtins.property
    @jsii.member(jsii_name="brightnessInput")
    def brightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="brightnessVarInput")
    def brightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastVarInput")
    def contrast_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="brightness")
    def brightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightness"))

    @brightness.setter
    def brightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df5ebd7039e28cb2585baeb19df41a67b68132bf56ef9e6244707573ca70ab68)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightness", value)

    @builtins.property
    @jsii.member(jsii_name="brightnessVar")
    def brightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightnessVar"))

    @brightness_var.setter
    def brightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__345d2100c6b963a4305bd9a7107bb7d1b699a80a0f3e792e83619da5abed258e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrast"))

    @contrast.setter
    def contrast(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c8008cc20501a9acf67171747e5ca05554428400450c88cfcf2e91052db2744a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrast", value)

    @builtins.property
    @jsii.member(jsii_name="contrastVar")
    def contrast_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrastVar"))

    @contrast_var.setter
    def contrast_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8b4d210ad9515d3d9ff3d800ed045b9b9a1a280a67c2fc48fdfccc8b4b522611)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrastVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitContrast]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitContrast]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitContrast]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2935adc8bb66a781c7f0b63fc37661116703d412f433075687419e5edd51c067)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitGoop",
    jsii_struct_bases=[],
    name_mapping={
        "chaos": "chaos",
        "chaos_var": "chaosVar",
        "density": "density",
        "density_var": "densityVar",
        "power": "power",
        "power_var": "powerVar",
        "seed": "seed",
        "seed_var": "seedVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitGoop:
    def __init__(
        self,
        *,
        chaos: typing.Optional[builtins.str] = None,
        chaos_var: typing.Optional[builtins.str] = None,
        density: typing.Optional[builtins.str] = None,
        density_var: typing.Optional[builtins.str] = None,
        power: typing.Optional[builtins.str] = None,
        power_var: typing.Optional[builtins.str] = None,
        seed: typing.Optional[builtins.str] = None,
        seed_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param chaos: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        :param chaos_var: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        :param density: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        :param density_var: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        :param power: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        :param power_var: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        :param seed: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        :param seed_var: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c6d7e745176eb2133a4363be29de15a1b5094c0eb03a881b7c90340da9689631)
            check_type(argname="argument chaos", value=chaos, expected_type=type_hints["chaos"])
            check_type(argname="argument chaos_var", value=chaos_var, expected_type=type_hints["chaos_var"])
            check_type(argname="argument density", value=density, expected_type=type_hints["density"])
            check_type(argname="argument density_var", value=density_var, expected_type=type_hints["density_var"])
            check_type(argname="argument power", value=power, expected_type=type_hints["power"])
            check_type(argname="argument power_var", value=power_var, expected_type=type_hints["power_var"])
            check_type(argname="argument seed", value=seed, expected_type=type_hints["seed"])
            check_type(argname="argument seed_var", value=seed_var, expected_type=type_hints["seed_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if chaos is not None:
            self._values["chaos"] = chaos
        if chaos_var is not None:
            self._values["chaos_var"] = chaos_var
        if density is not None:
            self._values["density"] = density
        if density_var is not None:
            self._values["density_var"] = density_var
        if power is not None:
            self._values["power"] = power
        if power_var is not None:
            self._values["power_var"] = power_var
        if seed is not None:
            self._values["seed"] = seed
        if seed_var is not None:
            self._values["seed_var"] = seed_var

    @builtins.property
    def chaos(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        '''
        result = self._values.get("chaos")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def chaos_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        '''
        result = self._values.get("chaos_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        '''
        result = self._values.get("density")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density_var(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        '''
        result = self._values.get("density_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        '''
        result = self._values.get("power")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power_var(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        '''
        result = self._values.get("power_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        '''
        result = self._values.get("seed")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed_var(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        result = self._values.get("seed_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitGoop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitGoopList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitGoopList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c24e919f0aec2ce50fcb126730996d5b6c67f3ab73ad63df26b05dde1614c58b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitGoopOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8d3d8b9856f8e37a217a458f98eda050e78d252ab41b8976010cbffde38e58f6)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitGoopOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a08d9dae7fc3764e2a13ec2cd6666e866fcf8d91781c5715de3f950fcecc144e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__503cb90ce89f874b8c835c7435cb736314736053a04d3704722549289d3fc629)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3170cf024dae1d180c527905e3ae17face341b935c754492aace5937cf301a21)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitGoop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitGoop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b908d72b67f8ec02c0523bea4b38e93c746dcf08f0e4d1327d4eb5689d4f6a43)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitGoopOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitGoopOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5d1dcedfc7eaa1f4339a59f719f026254b6068260dd470afb3decc385eccabd1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetChaos")
    def reset_chaos(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaos", []))

    @jsii.member(jsii_name="resetChaosVar")
    def reset_chaos_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaosVar", []))

    @jsii.member(jsii_name="resetDensity")
    def reset_density(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensity", []))

    @jsii.member(jsii_name="resetDensityVar")
    def reset_density_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensityVar", []))

    @jsii.member(jsii_name="resetPower")
    def reset_power(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPower", []))

    @jsii.member(jsii_name="resetPowerVar")
    def reset_power_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPowerVar", []))

    @jsii.member(jsii_name="resetSeed")
    def reset_seed(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeed", []))

    @jsii.member(jsii_name="resetSeedVar")
    def reset_seed_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeedVar", []))

    @builtins.property
    @jsii.member(jsii_name="chaosInput")
    def chaos_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosInput"))

    @builtins.property
    @jsii.member(jsii_name="chaosVarInput")
    def chaos_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosVarInput"))

    @builtins.property
    @jsii.member(jsii_name="densityInput")
    def density_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityInput"))

    @builtins.property
    @jsii.member(jsii_name="densityVarInput")
    def density_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="powerInput")
    def power_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerInput"))

    @builtins.property
    @jsii.member(jsii_name="powerVarInput")
    def power_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerVarInput"))

    @builtins.property
    @jsii.member(jsii_name="seedInput")
    def seed_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedInput"))

    @builtins.property
    @jsii.member(jsii_name="seedVarInput")
    def seed_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedVarInput"))

    @builtins.property
    @jsii.member(jsii_name="chaos")
    def chaos(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaos"))

    @chaos.setter
    def chaos(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f641f84ccb241813dea380dd5c638099750f8dd65a9ffb655e99632a1ebc35fc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaos", value)

    @builtins.property
    @jsii.member(jsii_name="chaosVar")
    def chaos_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaosVar"))

    @chaos_var.setter
    def chaos_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cf4a54046f0d7ced535d28aa1fd134bd50411f29428692bf652c4b01187c5bc6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaosVar", value)

    @builtins.property
    @jsii.member(jsii_name="density")
    def density(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "density"))

    @density.setter
    def density(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d2b77a1ab08c52a0facead24b61edf058a897048bf3e1dfa66137249d79812d6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "density", value)

    @builtins.property
    @jsii.member(jsii_name="densityVar")
    def density_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "densityVar"))

    @density_var.setter
    def density_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8c075a182eaf8b02811adc5e45ca21c913a35ab900892b3405be17895d377f5a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "densityVar", value)

    @builtins.property
    @jsii.member(jsii_name="power")
    def power(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "power"))

    @power.setter
    def power(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bba55ea2ab4dd2e2c11c1ac4e12ba38ea17562d0b5161e59c43f893b0826a715)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "power", value)

    @builtins.property
    @jsii.member(jsii_name="powerVar")
    def power_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "powerVar"))

    @power_var.setter
    def power_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e656543586cdd499c38c7a33d75e4df07f5a157171bbf54c3d424334d2fb9c2f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "powerVar", value)

    @builtins.property
    @jsii.member(jsii_name="seed")
    def seed(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seed"))

    @seed.setter
    def seed(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1ee3553134c7cab130690503f0764f74e92f6bcbf0a7ea69c5d8d504ac4e740c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seed", value)

    @builtins.property
    @jsii.member(jsii_name="seedVar")
    def seed_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seedVar"))

    @seed_var.setter
    def seed_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e73dc91c4151a7a954d96ccdeac8157ce0ced6591ebbd969b1d08797f7d7a965)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seedVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitGoop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitGoop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitGoop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__06660339a2c58993c940fe0837ef562c283cb88b5d75033d49de5a6e5f9a1e0f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitGrayscale",
    jsii_struct_bases=[],
    name_mapping={"type": "type", "type_var": "typeVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitGrayscale:
    def __init__(
        self,
        *,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param type: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0c4a0674e563e321e0119ac239ceedeffb8e745fa384829463e9374cc54f6207)
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitGrayscale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitGrayscaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitGrayscaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__818f1ea0651f3b2a750ad0a19617d24d8b081490ebfef16aca7b09b7b060cb46)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitGrayscaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e95db0f13c286a848b34b44a3207f6a6d8b0b14a67a9d74a2c34edb24fb98d4c)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitGrayscaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1453b1db210ec61cc7bb80fd7d5dc8e4c282608470364eef47a50d21b8ca7809)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a7d6d5f3aed48732e8616745f2693ca041e58d0fb99bea4376ab2dd0b6d4617)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c5992488c735296f7823f5ee30b391d3d6965ce3391e5754ba6fb0dd34d06fa0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitGrayscale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitGrayscale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__076c5e1316e85cce5986306c0e8accc5b869f32aae1b7b81d52504944bb0ca0d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitGrayscaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitGrayscaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9b4adf02b5e06fb265dd94006bbfe4c924da2f9c12616f52f264c902866e47a3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ae7c20dd7e35c95ea0cd6e17bd170840d12b51e9abe54fd3a02a9c3b51c2c82)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b71e61d387f81912567b14b0b2c0757d428864c467daa9171c803b4363c2cc9b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitGrayscale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitGrayscale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitGrayscale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__769f8c8141fb562f7d517f94789988ac8708098a3bec826254a675a6b3bf6d4a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitHsl",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "lightness": "lightness",
        "lightness_var": "lightnessVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitHsl:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness: typing.Optional[builtins.str] = None,
        lightness_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        :param lightness_var: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7c9117b971ccc79e0a1cf26e13bb750496a23f0fbeeaee3dd45707cea27af1dc)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness", value=lightness, expected_type=type_hints["lightness"])
            check_type(argname="argument lightness_var", value=lightness_var, expected_type=type_hints["lightness_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness is not None:
            self._values["lightness"] = lightness
        if lightness_var is not None:
            self._values["lightness_var"] = lightness_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        '''
        result = self._values.get("lightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        '''
        result = self._values.get("lightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitHsl(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitHslList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitHslList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ccb64e7257952b754250040ce2c38f5c5927c328a0d6a77259b7836c5270372)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitHslOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ae40bf79b37c9642298a7b1659752b4c936eef315da8d6eae5fcab87dd984e42)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitHslOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__90c42134673e90b62d4eb4117632c532abecce97d642d4f96ebcb06e67ae83d2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__43efddbbf5c87fad128ee12ab508cf91849b1270a4c0ebbe650d13a752995863)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2058396db07a8f3361d5420503ac7fea6fde405193d26a0eee862fccbe0e47be)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitHsl]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitHsl]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__29ffa3b7c68c8de65d3b8ea295609e80016f3f5527e49ab734427041d3559856)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitHslOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitHslOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__14101e056c3fe3196de23a0e7ff68f721d26265e9a9af2ecd74256ae385d2a95)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightness")
    def reset_lightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightness", []))

    @jsii.member(jsii_name="resetLightnessVar")
    def reset_lightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessInput")
    def lightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessVarInput")
    def lightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0744665b0e912e87768f8770a301080bba1fbe75a73a5d561dd555296eb65282)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d809c8ccf0fed85b8cc1783327e08fbd327616aa5f8868f41ccbae093b830628)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightness")
    def lightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightness"))

    @lightness.setter
    def lightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__41d42cc5ad8e0cf98baf2cf28088db8a1a5d644da3f4841c5305f382bb65920c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightness", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessVar")
    def lightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessVar"))

    @lightness_var.setter
    def lightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a7636405c0543b15a21ad07ebba81718c3857dd7771400d5217f80de3e936bc5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__84e0a6f7fac6be9645e7c3592a6f35a970dc65355ae64161521ea14966bcab5e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d4616684d4f8d9d05b95c41df69b2908075977ef9dad3cc4114c4bb2a8dc743)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitHsl]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitHsl]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitHsl]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8ff0fe9fce8a2e70a7a4f95ebb01dfe060e43ddbecd2f4656e47cf9063845323)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitHsv",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitHsv:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        :param value: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1e65a480ac32434be9b33cda0cbe804ef09b54e304c86ecea2dd758d72681022)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitHsv(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitHsvList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitHsvList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__07d25a5a1c14c0cf0046a2b49cb30ac59c4570c434898dd55374f63cd05a7042)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitHsvOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__52a1a2e326feb4eb07f3a73f6072882c0b3cce4e47ee5cb0c6bfe4e87565fd42)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitHsvOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c4e9392cff762488c7f4ce292e0e2a30867caf9935259c25b2cef80e02e9cb03)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__675170f4b99ceb86584cb9fcdc3b09dceda4a6fe00395ad7706e34094b7eef40)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a190c3b04dc578fd84507831dc0e8e4b96716a742083b92a62d197033284850)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitHsv]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitHsv]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__974e142857972d740b32947e611b3f07bb7bbc11972ca15401a4184b04dc43ef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitHsvOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitHsvOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ff3aeb4a900d1d0157829368a68c26e1fc67038a02f1b094a4b7274d97cb5236)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ad47b5c7d1ae04ef2d388bbbc4df7c9370eef8e484f24c3a9a2233ae050fd452)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__970224b4d457f83890e6af6019ad0278433389cd0c7fd26c270b1ea212a78007)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aca3689a12ab90c3531df1c5f6b6f73cf3c723b8fb8c340afdb3bd33ff600e2e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__85c173df607d43ac1ad61f81e9fee3e49f7609142cd5a3d230966d3c0f523396)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__93c01d3594a3b34241747c883d83fbcd417d56855937cc8629709c5d09fa1d10)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9307f2006540c6159ab8e5b79231e783efdbc3c38b2d48c458b51c788dd06f8f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitHsv]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitHsv]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitHsv]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c7b0d0d45bc656eff66143631804fb20d17a07f3899895844802fac65c117115)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimension",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "dimension": "dimension",
        "dimension_var": "dimensionVar",
        "equal": "equal",
        "greater_than": "greaterThan",
        "less_than": "lessThan",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimension:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        dimension: typing.Optional[builtins.str] = None,
        dimension_var: typing.Optional[builtins.str] = None,
        equal: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqual", typing.Dict[builtins.str, typing.Any]]] = None,
        greater_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThan", typing.Dict[builtins.str, typing.Any]]] = None,
        less_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThan", typing.Dict[builtins.str, typing.Any]]] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param dimension: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        :param dimension_var: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        :param equal: equal block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        :param greater_than: greater_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        :param less_than: less_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        :param value: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefault(**default)
        if isinstance(equal, dict):
            equal = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqual(**equal)
        if isinstance(greater_than, dict):
            greater_than = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThan(**greater_than)
        if isinstance(less_than, dict):
            less_than = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThan(**less_than)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__db849b91ad0f448f6c8d9f6da796d79f75113b71b6a1a38088941f1d159c662a)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument dimension", value=dimension, expected_type=type_hints["dimension"])
            check_type(argname="argument dimension_var", value=dimension_var, expected_type=type_hints["dimension_var"])
            check_type(argname="argument equal", value=equal, expected_type=type_hints["equal"])
            check_type(argname="argument greater_than", value=greater_than, expected_type=type_hints["greater_than"])
            check_type(argname="argument less_than", value=less_than, expected_type=type_hints["less_than"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if dimension is not None:
            self._values["dimension"] = dimension
        if dimension_var is not None:
            self._values["dimension_var"] = dimension_var
        if equal is not None:
            self._values["equal"] = equal
        if greater_than is not None:
            self._values["greater_than"] = greater_than
        if less_than is not None:
            self._values["less_than"] = less_than
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefault"], result)

    @builtins.property
    def dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        '''
        result = self._values.get("dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        '''
        result = self._values.get("dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def equal(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqual"]:
        '''equal block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        '''
        result = self._values.get("equal")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqual"], result)

    @builtins.property
    def greater_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThan"]:
        '''greater_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        '''
        result = self._values.get("greater_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThan"], result)

    @builtins.property
    def less_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThan"]:
        '''less_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        '''
        result = self._values.get("less_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThan"], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimension(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefault",
    jsii_struct_bases=[],
    name_mapping={
        "background_color": "backgroundColor",
        "blur": "blur",
        "chroma_key": "chromaKey",
        "composite": "composite",
        "compound": "compound",
        "contrast": "contrast",
        "goop": "goop",
        "grayscale": "grayscale",
        "hsl": "hsl",
        "hsv": "hsv",
        "if_dimension": "ifDimension",
        "if_orientation": "ifOrientation",
        "max_colors": "maxColors",
        "mirror": "mirror",
        "mono_hue": "monoHue",
        "opacity": "opacity",
        "remove_color": "removeColor",
        "unsharp_mask": "unsharpMask",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefault:
    def __init__(
        self,
        *,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultBackgroundColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultBlur", typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultChromaKey", typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultComposite", typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultCompound", typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultContrast", typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultGoop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultGrayscale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultHsl", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultHsv", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimension", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientation", typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultMaxColors", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultMirror", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultMonoHue", typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultOpacity", typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultRemoveColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultUnsharpMask", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__73a6067b0c04e8a37f5e51546de32ecce4b7ed463f8386e5c9764c0acb1f92b5)
            check_type(argname="argument background_color", value=background_color, expected_type=type_hints["background_color"])
            check_type(argname="argument blur", value=blur, expected_type=type_hints["blur"])
            check_type(argname="argument chroma_key", value=chroma_key, expected_type=type_hints["chroma_key"])
            check_type(argname="argument composite", value=composite, expected_type=type_hints["composite"])
            check_type(argname="argument compound", value=compound, expected_type=type_hints["compound"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument goop", value=goop, expected_type=type_hints["goop"])
            check_type(argname="argument grayscale", value=grayscale, expected_type=type_hints["grayscale"])
            check_type(argname="argument hsl", value=hsl, expected_type=type_hints["hsl"])
            check_type(argname="argument hsv", value=hsv, expected_type=type_hints["hsv"])
            check_type(argname="argument if_dimension", value=if_dimension, expected_type=type_hints["if_dimension"])
            check_type(argname="argument if_orientation", value=if_orientation, expected_type=type_hints["if_orientation"])
            check_type(argname="argument max_colors", value=max_colors, expected_type=type_hints["max_colors"])
            check_type(argname="argument mirror", value=mirror, expected_type=type_hints["mirror"])
            check_type(argname="argument mono_hue", value=mono_hue, expected_type=type_hints["mono_hue"])
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument remove_color", value=remove_color, expected_type=type_hints["remove_color"])
            check_type(argname="argument unsharp_mask", value=unsharp_mask, expected_type=type_hints["unsharp_mask"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if background_color is not None:
            self._values["background_color"] = background_color
        if blur is not None:
            self._values["blur"] = blur
        if chroma_key is not None:
            self._values["chroma_key"] = chroma_key
        if composite is not None:
            self._values["composite"] = composite
        if compound is not None:
            self._values["compound"] = compound
        if contrast is not None:
            self._values["contrast"] = contrast
        if goop is not None:
            self._values["goop"] = goop
        if grayscale is not None:
            self._values["grayscale"] = grayscale
        if hsl is not None:
            self._values["hsl"] = hsl
        if hsv is not None:
            self._values["hsv"] = hsv
        if if_dimension is not None:
            self._values["if_dimension"] = if_dimension
        if if_orientation is not None:
            self._values["if_orientation"] = if_orientation
        if max_colors is not None:
            self._values["max_colors"] = max_colors
        if mirror is not None:
            self._values["mirror"] = mirror
        if mono_hue is not None:
            self._values["mono_hue"] = mono_hue
        if opacity is not None:
            self._values["opacity"] = opacity
        if remove_color is not None:
            self._values["remove_color"] = remove_color
        if unsharp_mask is not None:
            self._values["unsharp_mask"] = unsharp_mask

    @builtins.property
    def background_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultBackgroundColor"]]]:
        '''background_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        '''
        result = self._values.get("background_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultBackgroundColor"]]], result)

    @builtins.property
    def blur(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultBlur"]]]:
        '''blur block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        '''
        result = self._values.get("blur")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultBlur"]]], result)

    @builtins.property
    def chroma_key(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultChromaKey"]]]:
        '''chroma_key block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        '''
        result = self._values.get("chroma_key")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultChromaKey"]]], result)

    @builtins.property
    def composite(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultComposite"]]]:
        '''composite block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        '''
        result = self._values.get("composite")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultComposite"]]], result)

    @builtins.property
    def compound(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultCompound"]]]:
        '''compound block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        '''
        result = self._values.get("compound")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultCompound"]]], result)

    @builtins.property
    def contrast(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultContrast"]]]:
        '''contrast block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultContrast"]]], result)

    @builtins.property
    def goop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultGoop"]]]:
        '''goop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        '''
        result = self._values.get("goop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultGoop"]]], result)

    @builtins.property
    def grayscale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultGrayscale"]]]:
        '''grayscale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        '''
        result = self._values.get("grayscale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultGrayscale"]]], result)

    @builtins.property
    def hsl(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultHsl"]]]:
        '''hsl block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        '''
        result = self._values.get("hsl")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultHsl"]]], result)

    @builtins.property
    def hsv(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultHsv"]]]:
        '''hsv block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        '''
        result = self._values.get("hsv")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultHsv"]]], result)

    @builtins.property
    def if_dimension(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimension"]]]:
        '''if_dimension block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        '''
        result = self._values.get("if_dimension")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimension"]]], result)

    @builtins.property
    def if_orientation(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientation"]]]:
        '''if_orientation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        '''
        result = self._values.get("if_orientation")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientation"]]], result)

    @builtins.property
    def max_colors(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultMaxColors"]]]:
        '''max_colors block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        '''
        result = self._values.get("max_colors")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultMaxColors"]]], result)

    @builtins.property
    def mirror(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultMirror"]]]:
        '''mirror block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        '''
        result = self._values.get("mirror")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultMirror"]]], result)

    @builtins.property
    def mono_hue(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultMonoHue"]]]:
        '''mono_hue block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        '''
        result = self._values.get("mono_hue")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultMonoHue"]]], result)

    @builtins.property
    def opacity(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultOpacity"]]]:
        '''opacity block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultOpacity"]]], result)

    @builtins.property
    def remove_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultRemoveColor"]]]:
        '''remove_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        '''
        result = self._values.get("remove_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultRemoveColor"]]], result)

    @builtins.property
    def unsharp_mask(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultUnsharpMask"]]]:
        '''unsharp_mask block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        result = self._values.get("unsharp_mask")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultUnsharpMask"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultBackgroundColor",
    jsii_struct_bases=[],
    name_mapping={"color": "color", "color_var": "colorVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultBackgroundColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__76db49e2ee11a87dd37523f2d17c4ce1a85077574385699c19fc34c92bee6be3)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultBackgroundColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultBackgroundColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultBackgroundColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fc30d7fcc57892bbd960a9a115cda0da5b500f32ba093104525ff81b994092fc)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultBackgroundColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__34244e0570f73d46eb1a95945aa0fb8f8d25d51ce8f9b220c869e9f0ac61b228)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultBackgroundColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eaf2d2ee5fd5359f1b08e1559965cd5ccb25e304e746e0ae6bfb086061b386ea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__189414c7db5b9042d6b75b82dbfda7e5b8075a9c0a4a9795cffcdf619af82b61)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6bddcd185b3cd0813e5603543b6361ec526b87a0bc74d0c32fa9df45d6269ae5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultBackgroundColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultBackgroundColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4d69f387a011aa65714d97576cafbb5109178c878c71cb5b53db0a5592c101d9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultBackgroundColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultBackgroundColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__51be0a1059d7a19d15dcdb62edbc466c633b7590f451f0b1e711e56262b5559d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b6bf20153d039813bb84f90c968db317efb6def4dd287ecc3773174f732233bf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__428d8733649097828188b87bee8344705d7ea7678070633feea49f77993de4c1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultBackgroundColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultBackgroundColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultBackgroundColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4495ac534142125908c547b3612b1c0f1001de60f09f5186c8624bb55447a710)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultBlur",
    jsii_struct_bases=[],
    name_mapping={"sigma": "sigma", "sigma_var": "sigmaVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultBlur:
    def __init__(
        self,
        *,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param sigma: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__79c17df2730f32fb9f8e9d5a14097b589d572c68476b828c310d15efb557d617)
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultBlur(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultBlurList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultBlurList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f820289da0344b93fe63139b2728c8d4dbbb558ee3765fab3a18d0762981aa84)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultBlurOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7e97ce30918fc0b6f652a9a420bf879bda5f7ca98b6ce6e4275ca66136eb6a75)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultBlurOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__492e4d005759049f1a7ca8a03922ff48014a89db2d01f0ca1f1b6f69f7202cc8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5c15ecf3d716be2ef51b94bfb1215287ad83ecae710043e46e14faead94d1822)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0a2754da82089174c00a91c793520d1e0aba056dccbd2392830dcd394de7f988)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultBlur]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultBlur]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7535b857741a27162f1bb20c9c9241b5152d28a7dc809c3ba967b667da7632b9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultBlurOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultBlurOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3388084293c76687b4de0905ac61ebec8aa3c4d73874399a63efd6333ed69aa6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c5326250b0ccd6855ee82e4b1711e3158849e1d04d51d9d796a5b33d46676638)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aab7ed5ece87f98b592f9d13280beefb4725e5a5156a59351e06b8de5b73f5ba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultBlur]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultBlur]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultBlur]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fc3e231e21a6063cc93afe7cc7e3fbf13c4c4df4288630806bc742267043c83d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultChromaKey",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_feather": "hueFeather",
        "hue_feather_var": "hueFeatherVar",
        "hue_tolerance": "hueTolerance",
        "hue_tolerance_var": "hueToleranceVar",
        "hue_var": "hueVar",
        "lightness_feather": "lightnessFeather",
        "lightness_feather_var": "lightnessFeatherVar",
        "lightness_tolerance": "lightnessTolerance",
        "lightness_tolerance_var": "lightnessToleranceVar",
        "saturation_feather": "saturationFeather",
        "saturation_feather_var": "saturationFeatherVar",
        "saturation_tolerance": "saturationTolerance",
        "saturation_tolerance_var": "saturationToleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultChromaKey:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_feather: typing.Optional[builtins.str] = None,
        hue_feather_var: typing.Optional[builtins.str] = None,
        hue_tolerance: typing.Optional[builtins.str] = None,
        hue_tolerance_var: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness_feather: typing.Optional[builtins.str] = None,
        lightness_feather_var: typing.Optional[builtins.str] = None,
        lightness_tolerance: typing.Optional[builtins.str] = None,
        lightness_tolerance_var: typing.Optional[builtins.str] = None,
        saturation_feather: typing.Optional[builtins.str] = None,
        saturation_feather_var: typing.Optional[builtins.str] = None,
        saturation_tolerance: typing.Optional[builtins.str] = None,
        saturation_tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_feather: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        :param hue_feather_var: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        :param hue_tolerance: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        :param hue_tolerance_var: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        :param hue_var: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness_feather: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        :param lightness_feather_var: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        :param lightness_tolerance: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        :param lightness_tolerance_var: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        :param saturation_feather: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        :param saturation_feather_var: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        :param saturation_tolerance: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        :param saturation_tolerance_var: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ed5ca04cf566f573188441464e832b6738203465699d44d7c5e1ee310f205815)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_feather", value=hue_feather, expected_type=type_hints["hue_feather"])
            check_type(argname="argument hue_feather_var", value=hue_feather_var, expected_type=type_hints["hue_feather_var"])
            check_type(argname="argument hue_tolerance", value=hue_tolerance, expected_type=type_hints["hue_tolerance"])
            check_type(argname="argument hue_tolerance_var", value=hue_tolerance_var, expected_type=type_hints["hue_tolerance_var"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness_feather", value=lightness_feather, expected_type=type_hints["lightness_feather"])
            check_type(argname="argument lightness_feather_var", value=lightness_feather_var, expected_type=type_hints["lightness_feather_var"])
            check_type(argname="argument lightness_tolerance", value=lightness_tolerance, expected_type=type_hints["lightness_tolerance"])
            check_type(argname="argument lightness_tolerance_var", value=lightness_tolerance_var, expected_type=type_hints["lightness_tolerance_var"])
            check_type(argname="argument saturation_feather", value=saturation_feather, expected_type=type_hints["saturation_feather"])
            check_type(argname="argument saturation_feather_var", value=saturation_feather_var, expected_type=type_hints["saturation_feather_var"])
            check_type(argname="argument saturation_tolerance", value=saturation_tolerance, expected_type=type_hints["saturation_tolerance"])
            check_type(argname="argument saturation_tolerance_var", value=saturation_tolerance_var, expected_type=type_hints["saturation_tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_feather is not None:
            self._values["hue_feather"] = hue_feather
        if hue_feather_var is not None:
            self._values["hue_feather_var"] = hue_feather_var
        if hue_tolerance is not None:
            self._values["hue_tolerance"] = hue_tolerance
        if hue_tolerance_var is not None:
            self._values["hue_tolerance_var"] = hue_tolerance_var
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness_feather is not None:
            self._values["lightness_feather"] = lightness_feather
        if lightness_feather_var is not None:
            self._values["lightness_feather_var"] = lightness_feather_var
        if lightness_tolerance is not None:
            self._values["lightness_tolerance"] = lightness_tolerance
        if lightness_tolerance_var is not None:
            self._values["lightness_tolerance_var"] = lightness_tolerance_var
        if saturation_feather is not None:
            self._values["saturation_feather"] = saturation_feather
        if saturation_feather_var is not None:
            self._values["saturation_feather_var"] = saturation_feather_var
        if saturation_tolerance is not None:
            self._values["saturation_tolerance"] = saturation_tolerance
        if saturation_tolerance_var is not None:
            self._values["saturation_tolerance_var"] = saturation_tolerance_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        '''
        result = self._values.get("hue_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        '''
        result = self._values.get("hue_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        '''
        result = self._values.get("hue_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        '''
        result = self._values.get("hue_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        '''
        result = self._values.get("lightness_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        '''
        result = self._values.get("lightness_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        '''
        result = self._values.get("lightness_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        '''
        result = self._values.get("lightness_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        '''
        result = self._values.get("saturation_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        '''
        result = self._values.get("saturation_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        '''
        result = self._values.get("saturation_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        result = self._values.get("saturation_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultChromaKey(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultChromaKeyList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultChromaKeyList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3d654647c417f8cfb7df566d91aed8857f599d2e0edc814450c63c7ca57afe83)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultChromaKeyOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bd2f5965e5b2913f5dae1965a429d2bdec165a980312f017955688e1b8e0b5c3)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultChromaKeyOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eec49da051f84f7f6b36023c745cf3c167548fbfda22f883818fce1a479e1791)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cddd37dad09351af1fdd44d108b4a3c501e41fe349c5c130b665e9c58fd30455)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d6c2c5e4a1087a3c364940c4ba01cd6a1425b0ae502e098c337d91a4cd59495d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultChromaKey]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultChromaKey]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d8342e304a01344f78afcb3af1f32c3cef2a62a2abad7cb6764b46feac41d4a5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultChromaKeyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultChromaKeyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f58bb50e02ccb8482ae338e557edb01c6e31280d57b68c40cbb2e07b87bcb011)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueFeather")
    def reset_hue_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeather", []))

    @jsii.member(jsii_name="resetHueFeatherVar")
    def reset_hue_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeatherVar", []))

    @jsii.member(jsii_name="resetHueTolerance")
    def reset_hue_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueTolerance", []))

    @jsii.member(jsii_name="resetHueToleranceVar")
    def reset_hue_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueToleranceVar", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightnessFeather")
    def reset_lightness_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeather", []))

    @jsii.member(jsii_name="resetLightnessFeatherVar")
    def reset_lightness_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeatherVar", []))

    @jsii.member(jsii_name="resetLightnessTolerance")
    def reset_lightness_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessTolerance", []))

    @jsii.member(jsii_name="resetLightnessToleranceVar")
    def reset_lightness_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessToleranceVar", []))

    @jsii.member(jsii_name="resetSaturationFeather")
    def reset_saturation_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeather", []))

    @jsii.member(jsii_name="resetSaturationFeatherVar")
    def reset_saturation_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeatherVar", []))

    @jsii.member(jsii_name="resetSaturationTolerance")
    def reset_saturation_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationTolerance", []))

    @jsii.member(jsii_name="resetSaturationToleranceVar")
    def reset_saturation_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherInput")
    def hue_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVarInput")
    def hue_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceInput")
    def hue_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVarInput")
    def hue_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherInput")
    def lightness_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVarInput")
    def lightness_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceInput")
    def lightness_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVarInput")
    def lightness_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherInput")
    def saturation_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVarInput")
    def saturation_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceInput")
    def saturation_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVarInput")
    def saturation_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6bbbafe737c4cb66152c7fc0c9bbcef7766758bed9a2711736d6848cf4aff2e0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeather")
    def hue_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeather"))

    @hue_feather.setter
    def hue_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a523d740db2f4f7115c3a1cab0cd290e9236146be1a69ad5ce86c976ef4665c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeather", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVar")
    def hue_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeatherVar"))

    @hue_feather_var.setter
    def hue_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__31f67e2a575c4debfd196483edf11370906dc039ce8cd8c90e9344d612863755)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueTolerance")
    def hue_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueTolerance"))

    @hue_tolerance.setter
    def hue_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f13eb5adedd82b6ede00818013f64adaff947b0602c111373e0d277caf99bd8d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVar")
    def hue_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueToleranceVar"))

    @hue_tolerance_var.setter
    def hue_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ff61f8d72b3b6224ab5ef775b10875789e4100b4423d093c246332c52126d86)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ceaf43ae35048c63adb6c0c367671d1dbe4ed7e59f77dfb2ad775e1e00e94e4e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeather")
    def lightness_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeather"))

    @lightness_feather.setter
    def lightness_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fe1d9881061b127e26c9256b74d7e983b5555f317e290b06b444ca2c97da636f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeather", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVar")
    def lightness_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeatherVar"))

    @lightness_feather_var.setter
    def lightness_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3c867da4842bbc4f51954885aac316abeec107fef8fd152ec737baa74b967e79)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessTolerance")
    def lightness_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessTolerance"))

    @lightness_tolerance.setter
    def lightness_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0800489b48d382d97c4b51ce021ef652cea2c91b8afd0e9566b60e82132bf9b9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVar")
    def lightness_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessToleranceVar"))

    @lightness_tolerance_var.setter
    def lightness_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0f5c966bab87f61adc1e42f75149a10342890d82ecee77ae816d08af3b0f6eb1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeather")
    def saturation_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeather"))

    @saturation_feather.setter
    def saturation_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3d5a282b4e87437573c2f75a61d6ee76b11b8929570feb758536be246b5ea108)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeather", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVar")
    def saturation_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeatherVar"))

    @saturation_feather_var.setter
    def saturation_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6297e0c9e221c2fba682de9a8e3a307c2be505f739862d5861e7fac0d5a3abcd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationTolerance")
    def saturation_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationTolerance"))

    @saturation_tolerance.setter
    def saturation_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8b80c89e90e8a565dd8e707ebe1d1f756c6f9965c1c048570eae9f02e2637dc4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVar")
    def saturation_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationToleranceVar"))

    @saturation_tolerance_var.setter
    def saturation_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dda2ada9ac0a725181281a8aba7b035ceb937e22fbb9084b00a6cdcd091ea419)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultChromaKey]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultChromaKey]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultChromaKey]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e7eaf35f40819b16413f07ec86547f07e0299e88f2ee474ccb1fde75db65812d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultComposite",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "placement": "placement",
        "placement_var": "placementVar",
        "scale": "scale",
        "scale_dimension": "scaleDimension",
        "scale_dimension_var": "scaleDimensionVar",
        "scale_var": "scaleVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultComposite:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultCompositeImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        placement: typing.Optional[builtins.str] = None,
        placement_var: typing.Optional[builtins.str] = None,
        scale: typing.Optional[builtins.str] = None,
        scale_dimension: typing.Optional[builtins.str] = None,
        scale_dimension_var: typing.Optional[builtins.str] = None,
        scale_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param placement: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        :param placement_var: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        :param scale: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param scale_dimension: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        :param scale_dimension_var: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        :param scale_var: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        :param x_position: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultCompositeImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e1a9ca04b9014e23481e9ffd1517634060320a341c2c009d6ed5ecca5c67f657)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument placement", value=placement, expected_type=type_hints["placement"])
            check_type(argname="argument placement_var", value=placement_var, expected_type=type_hints["placement_var"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument scale_dimension", value=scale_dimension, expected_type=type_hints["scale_dimension"])
            check_type(argname="argument scale_dimension_var", value=scale_dimension_var, expected_type=type_hints["scale_dimension_var"])
            check_type(argname="argument scale_var", value=scale_var, expected_type=type_hints["scale_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if placement is not None:
            self._values["placement"] = placement
        if placement_var is not None:
            self._values["placement_var"] = placement_var
        if scale is not None:
            self._values["scale"] = scale
        if scale_dimension is not None:
            self._values["scale_dimension"] = scale_dimension
        if scale_dimension_var is not None:
            self._values["scale_dimension_var"] = scale_dimension_var
        if scale_var is not None:
            self._values["scale_var"] = scale_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultCompositeImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultCompositeImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        '''
        result = self._values.get("placement")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement_var(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        '''
        result = self._values.get("placement_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        '''
        result = self._values.get("scale_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        '''
        result = self._values.get("scale_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        '''
        result = self._values.get("scale_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultComposite(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultCompositeImage",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultCompositeImage:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultCompositeImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultCompositeImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultCompositeImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd12e0be1f7bb790a4ef9e365b7ff5f77496eb6ccd3759385cc52f1e36101ebc)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultCompositeImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultCompositeImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5da1302c0398b635b6146691b1a03065425745a2b44bcbe1299957006ce72e61)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultCompositeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultCompositeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3fd977a6768b4c4ddaec2edba501bb1acd4eb250277757c57b149f83871d17f9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultCompositeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1dfbfa46f0b22697964ae7c663ec0ef2cdfa401399971d97be2281c702bf3b93)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultCompositeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__943ab9aa33c6d9f5f68c1151632e1210ee39dc096618ca26ea9f3f1ad95a1da1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7e512365669e7197b2a248af6b92962343703d2e1ea359c366b890d1becf4202)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df8dca750e55d6cdcbd3cc1a1ee6e7bd0fdbcf7fb59582d98f91f7b926f0cc79)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultComposite]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultComposite]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__307cfc1668dfe6ca9f267e5f7ea00f573d471827e0bed656caec61bfe6ab4c68)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultCompositeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultCompositeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__91765dee6784067fa36a8adfb0064389e6a74e6af9e80202e4f0626f662b2ce4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultCompositeImage()

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPlacement")
    def reset_placement(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacement", []))

    @jsii.member(jsii_name="resetPlacementVar")
    def reset_placement_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacementVar", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetScaleDimension")
    def reset_scale_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimension", []))

    @jsii.member(jsii_name="resetScaleDimensionVar")
    def reset_scale_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimensionVar", []))

    @jsii.member(jsii_name="resetScaleVar")
    def reset_scale_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultCompositeImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultCompositeImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultCompositeImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="placementInput")
    def placement_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementInput"))

    @builtins.property
    @jsii.member(jsii_name="placementVarInput")
    def placement_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionInput")
    def scale_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVarInput")
    def scale_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleVarInput")
    def scale_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__877a0302aac00b20b0d1e1b31c3e5218570fe577dc9a30ad36b7a280d88cd373)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6d11718934aaa8db891a876a6669bbe8b6e1b46074b433d0edc4deab277786b2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="placement")
    def placement(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placement"))

    @placement.setter
    def placement(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b808e9d3a19e5f7ce0ee6bfed01e930101e136709c682270187d97ce36dc86fc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placement", value)

    @builtins.property
    @jsii.member(jsii_name="placementVar")
    def placement_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placementVar"))

    @placement_var.setter
    def placement_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c589a6e1aa4746f265333f0b7e488643b33d0582ff7b261a791e70502ce481a7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placementVar", value)

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scale"))

    @scale.setter
    def scale(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cf6edc8e59ccc1764f9b545ea595d02c955b98aba21cab949f75ad9f6cb83d2e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scale", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimension")
    def scale_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimension"))

    @scale_dimension.setter
    def scale_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a5bf0113b183434298014ca5d125d051b608755db32d2421e44260d97d53dfd1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimension", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVar")
    def scale_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimensionVar"))

    @scale_dimension_var.setter
    def scale_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dee30db3c0691e2809dfd5cc9d643f1d82f14012242af4503c5fcfac90ac5731)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="scaleVar")
    def scale_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleVar"))

    @scale_var.setter
    def scale_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__63db7db8f5d633111084c0b08585c597e6ec51c9409a10047bb6723c6498b7ae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d6053ddeff0472592ba3b458a8c73e4bccf58d2fd7cebf21364667ffaf730303)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b935f1cbad3c5a4e25a051f034a5f7cb65a52993779d658082a7cb4bd4c72af2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a1dfce5827b3f7b06600279db93a97e789f9c92cf6db1ba935276548ee9ecfe5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6379c2c1bff48e2de5a2b98151671094c0d643fa8fc47c9c707899e343251db5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultComposite]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultComposite]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultComposite]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8d551c3370d040df28bccb05749d449a5672113141d612a2477c619684f5e0bc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultCompound",
    jsii_struct_bases=[],
    name_mapping={"transformations": "transformations"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultCompound:
    def __init__(
        self,
        *,
        transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param transformations: transformations block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f3a5feaad255d60331ee814025317e432925c11cd27f03cf4e2fcdde9bfd003e)
            check_type(argname="argument transformations", value=transformations, expected_type=type_hints["transformations"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if transformations is not None:
            self._values["transformations"] = transformations

    @builtins.property
    def transformations(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultCompoundTransformations"]]]:
        '''transformations block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        result = self._values.get("transformations")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultCompoundTransformations"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultCompound(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultCompoundList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultCompoundList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__204add88ce49b388b542d00af959fd30409ef04b58013dfd0f18cdd474f6ffcd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultCompoundOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__02a4fd1224b14382626433d7dff0520cdae57d2f24fea67c4201bf8569d39702)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultCompoundOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3eb50ef3f583a4009bc0072017d5c50c9da9a83baae32220953aa767523044c0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8eaa327bcf8383b998d302daded4c8c4e155dfb60f5928a48aed1790de5be8aa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5395914d7f09d67221a3bd05cdcaf9805cf5175d4706029ad7e4cc1add9787c5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultCompound]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultCompound]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1b72bc9c7df2f8685d590471a21bb020a58462c67fca7537188487f1790a8506)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultCompoundOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultCompoundOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__32029de4dd5fc5a4cc1d7efe1f23b58ded9309ea74adc7efd0a1cb424559f697)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformations")
    def put_transformations(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c5eca726cf36f34b7532b534f42d10f6a40e223a9b991c355eeba168e9a6b2aa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTransformations", [value]))

    @jsii.member(jsii_name="resetTransformations")
    def reset_transformations(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformations", []))

    @builtins.property
    @jsii.member(jsii_name="transformations")
    def transformations(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultCompoundTransformationsList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultCompoundTransformationsList", jsii.get(self, "transformations"))

    @builtins.property
    @jsii.member(jsii_name="transformationsInput")
    def transformations_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultCompoundTransformations"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultCompoundTransformations"]]], jsii.get(self, "transformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultCompound]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultCompound]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultCompound]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__78c5c61d5e815b1202567ebf5ec7c1e89e7eb8c05189823d77b432d6d3d62648)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultCompoundTransformations",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultCompoundTransformations:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultCompoundTransformations(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultCompoundTransformationsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultCompoundTransformationsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd5ef83699a634a64ecb085b422a1241ba3e566a34e48788563b5bf3428826d8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultCompoundTransformationsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__12e5cff09d7142030fb6142381e47d4475eb12d460251fac574ea60716730977)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultCompoundTransformationsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6408008c83589f5fa6da1b8e3f47caf7c21508b588574d31e5adb27252c52c6e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__256179f65ee3af516f428fce8ba18daa958784653102e9038af3102f0ce6dccc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cf79f08b96b557cb690e792f34ef29d02263c4e3cc4724f45b3c9dd896f2d2be)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultCompoundTransformations]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultCompoundTransformations]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultCompoundTransformations]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dd105f6f6f032a0b0b9c3b3e8281c279aa4ffcf606a29074d5ad724bc72be220)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultCompoundTransformationsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultCompoundTransformationsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a385e8c712762a1562c932755b6ab742401769f121ecc53ad722380c3e614332)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultCompoundTransformations]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultCompoundTransformations]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultCompoundTransformations]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__024ae8249a9195d988bf1149a7811d2876bd1f93faea7f2c2a64d2cecf2c7c02)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultContrast",
    jsii_struct_bases=[],
    name_mapping={
        "brightness": "brightness",
        "brightness_var": "brightnessVar",
        "contrast": "contrast",
        "contrast_var": "contrastVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultContrast:
    def __init__(
        self,
        *,
        brightness: typing.Optional[builtins.str] = None,
        brightness_var: typing.Optional[builtins.str] = None,
        contrast: typing.Optional[builtins.str] = None,
        contrast_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param brightness: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        :param brightness_var: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        :param contrast: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param contrast_var: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f617fa8ed791dd217c228561a4e8c7ca82530f05fc82efe84205896bb03d93dc)
            check_type(argname="argument brightness", value=brightness, expected_type=type_hints["brightness"])
            check_type(argname="argument brightness_var", value=brightness_var, expected_type=type_hints["brightness_var"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument contrast_var", value=contrast_var, expected_type=type_hints["contrast_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if brightness is not None:
            self._values["brightness"] = brightness
        if brightness_var is not None:
            self._values["brightness_var"] = brightness_var
        if contrast is not None:
            self._values["contrast"] = contrast
        if contrast_var is not None:
            self._values["contrast_var"] = contrast_var

    @builtins.property
    def brightness(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        '''
        result = self._values.get("brightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def brightness_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        '''
        result = self._values.get("brightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        result = self._values.get("contrast_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultContrast(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultContrastList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultContrastList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f7ed25edbe59aaa7b5b8344b651ffdf83efee8a9a9f5fd19118cb073b7c017e8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultContrastOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__21f12bdfee7644d588acbfd908fa0750a7dd687f6e06c7dc6acdcfc21a834eb9)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultContrastOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8cba66c7dc65ad65e7e00b1f16ffecd06197f380f2ea47b77a2f090f2dc9edcb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3c90c25fcdbdb1ee3638a496f32bc238624167bde1fa225db4222a05ec77b800)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d05cd32ed56084a108efd1f2537732b8c3c87e88cf0c44cfcf4691c57a711d93)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultContrast]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultContrast]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__53787261900ec2d9fa80ea8bfe3b37f314ae93ec1c01ff3d8b68a8955cb7e462)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultContrastOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultContrastOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__276abf6c431f2923f37f56ac027d8dd47ee7193a852ef4fdc832d66e32185001)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetBrightness")
    def reset_brightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightness", []))

    @jsii.member(jsii_name="resetBrightnessVar")
    def reset_brightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightnessVar", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetContrastVar")
    def reset_contrast_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrastVar", []))

    @builtins.property
    @jsii.member(jsii_name="brightnessInput")
    def brightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="brightnessVarInput")
    def brightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastVarInput")
    def contrast_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="brightness")
    def brightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightness"))

    @brightness.setter
    def brightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ea018ae86dadcfddb4c99baf8433a8c7ab8588d80d913df31f0cef82ad3c729)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightness", value)

    @builtins.property
    @jsii.member(jsii_name="brightnessVar")
    def brightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightnessVar"))

    @brightness_var.setter
    def brightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__312ea16f4abb0fa33c7637185a93b876fda63704646ed08bf610fe20386ab22d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrast"))

    @contrast.setter
    def contrast(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__28d8765e3de08c3de0f2425f7d5862c3ef0acc6331b2eeed8d971c3ad3d5b4b6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrast", value)

    @builtins.property
    @jsii.member(jsii_name="contrastVar")
    def contrast_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrastVar"))

    @contrast_var.setter
    def contrast_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__49841169882a87d894ef2ec2ed1a029605718f88092a6fbbe74fc82f5af12a44)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrastVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultContrast]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultContrast]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultContrast]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a4c63ca766c5cb91843dec2cfead698bdb533eb47024a209eee703173f1ec26)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultGoop",
    jsii_struct_bases=[],
    name_mapping={
        "chaos": "chaos",
        "chaos_var": "chaosVar",
        "density": "density",
        "density_var": "densityVar",
        "power": "power",
        "power_var": "powerVar",
        "seed": "seed",
        "seed_var": "seedVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultGoop:
    def __init__(
        self,
        *,
        chaos: typing.Optional[builtins.str] = None,
        chaos_var: typing.Optional[builtins.str] = None,
        density: typing.Optional[builtins.str] = None,
        density_var: typing.Optional[builtins.str] = None,
        power: typing.Optional[builtins.str] = None,
        power_var: typing.Optional[builtins.str] = None,
        seed: typing.Optional[builtins.str] = None,
        seed_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param chaos: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        :param chaos_var: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        :param density: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        :param density_var: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        :param power: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        :param power_var: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        :param seed: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        :param seed_var: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c77806c01527a840598593d2554a823d6990f0bd03424f84a354137ad7631bd2)
            check_type(argname="argument chaos", value=chaos, expected_type=type_hints["chaos"])
            check_type(argname="argument chaos_var", value=chaos_var, expected_type=type_hints["chaos_var"])
            check_type(argname="argument density", value=density, expected_type=type_hints["density"])
            check_type(argname="argument density_var", value=density_var, expected_type=type_hints["density_var"])
            check_type(argname="argument power", value=power, expected_type=type_hints["power"])
            check_type(argname="argument power_var", value=power_var, expected_type=type_hints["power_var"])
            check_type(argname="argument seed", value=seed, expected_type=type_hints["seed"])
            check_type(argname="argument seed_var", value=seed_var, expected_type=type_hints["seed_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if chaos is not None:
            self._values["chaos"] = chaos
        if chaos_var is not None:
            self._values["chaos_var"] = chaos_var
        if density is not None:
            self._values["density"] = density
        if density_var is not None:
            self._values["density_var"] = density_var
        if power is not None:
            self._values["power"] = power
        if power_var is not None:
            self._values["power_var"] = power_var
        if seed is not None:
            self._values["seed"] = seed
        if seed_var is not None:
            self._values["seed_var"] = seed_var

    @builtins.property
    def chaos(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        '''
        result = self._values.get("chaos")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def chaos_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        '''
        result = self._values.get("chaos_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        '''
        result = self._values.get("density")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density_var(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        '''
        result = self._values.get("density_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        '''
        result = self._values.get("power")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power_var(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        '''
        result = self._values.get("power_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        '''
        result = self._values.get("seed")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed_var(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        result = self._values.get("seed_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultGoop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultGoopList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultGoopList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__33eab7ff205fa28d40b9bc783ebce7bba92f1315cb469d749f9dac1c43258acc)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultGoopOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__89c7dab26718f8c46660c10479a1ebec193e966354c0c65b77e717e458eadfee)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultGoopOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e80fe4e7ce200061d0088b60fb6b2ff611e30318e65ce4a8e1f77c5944149149)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__801fda73d7aee0822f2ffc7cabb1cabd2cb35faba3c05db342d98ff6eaa7f365)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6fd5df473b861dde0e71d8ff0c7080e823fe617a66e418957a7e3364cde79239)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultGoop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultGoop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fbc0baf850c87fa35396b3f2fcc1ba8eb66b8a7a0594338c019ba84fd2e7c2e5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultGoopOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultGoopOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bfd8e2f39d955a322389f36729918f54f3a7422b71a85a001b85809728534abe)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetChaos")
    def reset_chaos(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaos", []))

    @jsii.member(jsii_name="resetChaosVar")
    def reset_chaos_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaosVar", []))

    @jsii.member(jsii_name="resetDensity")
    def reset_density(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensity", []))

    @jsii.member(jsii_name="resetDensityVar")
    def reset_density_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensityVar", []))

    @jsii.member(jsii_name="resetPower")
    def reset_power(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPower", []))

    @jsii.member(jsii_name="resetPowerVar")
    def reset_power_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPowerVar", []))

    @jsii.member(jsii_name="resetSeed")
    def reset_seed(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeed", []))

    @jsii.member(jsii_name="resetSeedVar")
    def reset_seed_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeedVar", []))

    @builtins.property
    @jsii.member(jsii_name="chaosInput")
    def chaos_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosInput"))

    @builtins.property
    @jsii.member(jsii_name="chaosVarInput")
    def chaos_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosVarInput"))

    @builtins.property
    @jsii.member(jsii_name="densityInput")
    def density_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityInput"))

    @builtins.property
    @jsii.member(jsii_name="densityVarInput")
    def density_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="powerInput")
    def power_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerInput"))

    @builtins.property
    @jsii.member(jsii_name="powerVarInput")
    def power_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerVarInput"))

    @builtins.property
    @jsii.member(jsii_name="seedInput")
    def seed_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedInput"))

    @builtins.property
    @jsii.member(jsii_name="seedVarInput")
    def seed_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedVarInput"))

    @builtins.property
    @jsii.member(jsii_name="chaos")
    def chaos(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaos"))

    @chaos.setter
    def chaos(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f0b648be366af419b4ff38b085bf7b48dbfa86fd1d02a0dca309eec542c201d2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaos", value)

    @builtins.property
    @jsii.member(jsii_name="chaosVar")
    def chaos_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaosVar"))

    @chaos_var.setter
    def chaos_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cb8ec3c02ccb341868c99e1c60757fff390312f58bbed735581665425c7efc75)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaosVar", value)

    @builtins.property
    @jsii.member(jsii_name="density")
    def density(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "density"))

    @density.setter
    def density(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__50ac770ed20c7d4d165dc10f0963a65bf7f36329850415f1b974a65c6cbb43ad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "density", value)

    @builtins.property
    @jsii.member(jsii_name="densityVar")
    def density_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "densityVar"))

    @density_var.setter
    def density_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a28d371a76adcadafdee2e4357d0f617d42f2b160f0649babde533c16d71ebf9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "densityVar", value)

    @builtins.property
    @jsii.member(jsii_name="power")
    def power(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "power"))

    @power.setter
    def power(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__20dc4afbaa7ed32c7c4119c1041f040200cc9a1bb3c7e53eb621273766104011)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "power", value)

    @builtins.property
    @jsii.member(jsii_name="powerVar")
    def power_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "powerVar"))

    @power_var.setter
    def power_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ef419ca9a9ab67a02f474ad85d1f1eeb6a7678cfdcefbca9c85680330a58dbc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "powerVar", value)

    @builtins.property
    @jsii.member(jsii_name="seed")
    def seed(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seed"))

    @seed.setter
    def seed(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a9386b4b8c4e65b7266ea71c5c4aee5c95f26a60f18b720e197e445032d10d23)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seed", value)

    @builtins.property
    @jsii.member(jsii_name="seedVar")
    def seed_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seedVar"))

    @seed_var.setter
    def seed_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e7e36fc9cfad75725d69523b893920b6e6cb436ed85aafc461c4ffd8b9294682)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seedVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultGoop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultGoop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultGoop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ef592f5ee07105a2b55dd40234df86018b62be0e271020c147d8e338a36471f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultGrayscale",
    jsii_struct_bases=[],
    name_mapping={"type": "type", "type_var": "typeVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultGrayscale:
    def __init__(
        self,
        *,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param type: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ace1f5065abbe6b5b83e3e0a879ec37361648f895e811c65d6107a3dc63315a3)
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultGrayscale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultGrayscaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultGrayscaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ba9fd0f1e14290967538383689583188235964ae20f7ed94711553bcadaef57)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultGrayscaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__50c79bce18d04c13f5ea1e08da506743cc3b19b60633380f58ed1d17476a509b)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultGrayscaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c1605ad52da25d7642d83f60df6480491b942d3b93cdc82f91cd72952d0db621)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8893db66256efb72d01997e53bb7156ea405d507a0d5a13c09373e51b1e5eaee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__efec026931546372b56adf1aacf0ec084d53425325c9c6ba2b60ba64bb94e2fe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultGrayscale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultGrayscale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c866fcd9392d58a4ecbe5a56b4edac642c3a4bc40ec03a99fd6cfa317c120255)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultGrayscaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultGrayscaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6233e09d034195faefbab7c7d574da3c66ed04328cacc756fdcb61e30404be16)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c15e4378a36d7768ea11cdb8b7f12353c21d636e23f82ff77ffd56cf7a989be9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__785f0a5a1a945bf61a8f2608fcbff6a714edcf1d6fbc4055285a893f415eda21)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultGrayscale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultGrayscale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultGrayscale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3421750e089bc91e87bbbe8462ef8439ebc7fdf0b4380f4f06cd1d7ef4a4ad12)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultHsl",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "lightness": "lightness",
        "lightness_var": "lightnessVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultHsl:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness: typing.Optional[builtins.str] = None,
        lightness_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        :param lightness_var: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7701a9cbd039aa76603278385d94025c8b4e26aefe2ff8cb3b20a283683315ff)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness", value=lightness, expected_type=type_hints["lightness"])
            check_type(argname="argument lightness_var", value=lightness_var, expected_type=type_hints["lightness_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness is not None:
            self._values["lightness"] = lightness
        if lightness_var is not None:
            self._values["lightness_var"] = lightness_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        '''
        result = self._values.get("lightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        '''
        result = self._values.get("lightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultHsl(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultHslList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultHslList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__72a62a7bbfddd79a6015921018c424a35607256fdc5a55a52edefe2da284ff07)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultHslOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e0d7ce7884824492de72d5f09e605b404b44c3cff81c1cd630d9592bb723155)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultHslOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0deb30569989014d0c5de3ecc2f60a0dca1ad343585d0233c6451b5322da38ac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__53f314dd031537a9e96641c8a0ea31e93eb9db63e4af796884e2e865a459fc88)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__abfa8dac5d6c656fb1908fc2fbb2a1b15409282dcc38d0eedf51c15562a09ea6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultHsl]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultHsl]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__45b45ac0a834767bcc84167a94ea12cee0d708545d7e561f069476b48ce7c97e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultHslOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultHslOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__da9892b30b7a0c2fcb8ba9ad915643c411dadd1e6006a50ce9a6e07d634b9671)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightness")
    def reset_lightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightness", []))

    @jsii.member(jsii_name="resetLightnessVar")
    def reset_lightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessInput")
    def lightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessVarInput")
    def lightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__725673aa37402b401ef61db87b200fc0c8e5493f8063583a2835e57e54b2a50f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6eb3b33cdbf5109ccc6888cff2c6ea9c14d42797e1a451a35e225b28c8e2aed8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightness")
    def lightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightness"))

    @lightness.setter
    def lightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__589c2f560e220a0ff040d0e21dba4bff27a965d2d722af5b3d239a2eac278bc3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightness", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessVar")
    def lightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessVar"))

    @lightness_var.setter
    def lightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c249ec89767c0fac06275625d0c9053e9d1c1efb407a522daee8cd60fcce7dc3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__655788c0abf315b2e8eb9ccb2ca69e282367ca56f18596f5e71f261002032dd4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0d54bf93684146a34d36fd16f893bde7a54892a14ec8336d9d55bcf76a43eaad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultHsl]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultHsl]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultHsl]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d53e0e9fd101e5bb7b912c2454561b672d1810f8bc2404d99dbe73ef3ac7cfe9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultHsv",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultHsv:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        :param value: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__30205b8867b7f3c356100c6cf088208a7cfaff4f92d83c56685ce8cbcc47be91)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultHsv(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultHsvList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultHsvList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e4a3abd5df1a5c63ddde52af7a9ee98d3b7719ffdc89344845e5e37a822e7552)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultHsvOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__79e51824b3b1f6412f42165802788d5555d97a5cb28d4987e8a63c62a7599030)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultHsvOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c21316e029a48f796cc799a5f1ea8ef1c38ff51c29f461d821af7fb458248e49)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e9b5fa43b9985961cbfc4b1b97fd696fdab73b592639b4d6db983d179907335c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1461db4ff27ed90f1c1631226a79e32bf50a0001c2f784e15c1f32175949326c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultHsv]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultHsv]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c94a1c75a04dfffd54d49aaa563dcedb1b153495f57f3d73354b5a92856894ff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultHsvOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultHsvOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ec5bab644db9f05bdcc742347298066f52a1bbbdbb8b3246d48addfc2a653630)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2eb0ba3ee6f2d2a1353a8ac174978e2bac115f7304817acfc63b30c13eb6a8da)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__432ab031cd5b5065c4d3ac0c774e46627af60915df1b621875d215ebc4ac5203)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4f1d482f48aba993caa7bdd09023b60f55da03ea7c6ed4b52ee9fc1cabaeb2f7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c494df40a5f1a91b7ba99ef9aada22b4ded0b77bbba614eb8420307acd6c4dc4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f519f95259a31abcaec6034d145980c700a4e7ef5356939d7eebf94e8001845b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b4edf0da5a2ec0a6ed8e6b43fc786b14f483963fcadd2c75c6c7bac30119c53d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultHsv]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultHsv]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultHsv]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__23bf60bbf7047c7e6dedeb94672980440f12add6e42c7ef659b78a013aa8c0e5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimension",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "dimension": "dimension",
        "dimension_var": "dimensionVar",
        "equal": "equal",
        "greater_than": "greaterThan",
        "less_than": "lessThan",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimension:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        dimension: typing.Optional[builtins.str] = None,
        dimension_var: typing.Optional[builtins.str] = None,
        equal: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionEqual", typing.Dict[builtins.str, typing.Any]]] = None,
        greater_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionGreaterThan", typing.Dict[builtins.str, typing.Any]]] = None,
        less_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionLessThan", typing.Dict[builtins.str, typing.Any]]] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param dimension: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        :param dimension_var: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        :param equal: equal block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        :param greater_than: greater_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        :param less_than: less_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        :param value: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionDefault(**default)
        if isinstance(equal, dict):
            equal = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionEqual(**equal)
        if isinstance(greater_than, dict):
            greater_than = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionGreaterThan(**greater_than)
        if isinstance(less_than, dict):
            less_than = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionLessThan(**less_than)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__93a918e31b2731c46c485387506a520ba2bfe884f9026a17d54d6d927616f015)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument dimension", value=dimension, expected_type=type_hints["dimension"])
            check_type(argname="argument dimension_var", value=dimension_var, expected_type=type_hints["dimension_var"])
            check_type(argname="argument equal", value=equal, expected_type=type_hints["equal"])
            check_type(argname="argument greater_than", value=greater_than, expected_type=type_hints["greater_than"])
            check_type(argname="argument less_than", value=less_than, expected_type=type_hints["less_than"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if dimension is not None:
            self._values["dimension"] = dimension
        if dimension_var is not None:
            self._values["dimension_var"] = dimension_var
        if equal is not None:
            self._values["equal"] = equal
        if greater_than is not None:
            self._values["greater_than"] = greater_than
        if less_than is not None:
            self._values["less_than"] = less_than
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionDefault"], result)

    @builtins.property
    def dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        '''
        result = self._values.get("dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        '''
        result = self._values.get("dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def equal(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionEqual"]:
        '''equal block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        '''
        result = self._values.get("equal")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionEqual"], result)

    @builtins.property
    def greater_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionGreaterThan"]:
        '''greater_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        '''
        result = self._values.get("greater_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionGreaterThan"], result)

    @builtins.property
    def less_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionLessThan"]:
        '''less_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        '''
        result = self._values.get("less_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionLessThan"], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimension(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__10b152a3d61b60c2ac8acbc45bc4de56fb25d3fca917b1c20d53ede9eddc1e45)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__828d344f00608a83b35ccd1d773b2f85c89cb74a5fdce9c0c210abbc77129f05)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionEqual",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionEqual:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionEqual(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionEqualOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionEqualOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2e357ff68aecd3a264cf9a7ada17eef05e6af9b6f367cfff121da36219b82c72)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionEqual], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionEqual],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c270c600abf062b33f4e414b5db32a9f0ef62dd533ebfca3fe17819a1d0bc920)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionGreaterThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionGreaterThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionGreaterThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionGreaterThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionGreaterThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bf8ea68d536a0382011fad7a04e736aaadf01fc8c44c54cb987b94738acab3a6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionGreaterThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionGreaterThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d032f436f2e3bb50cc7976ebb5e36cf0c930712badb986f2bf25833c328fccdf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionLessThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionLessThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionLessThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionLessThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionLessThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__88fa486f5df9b4938ce53da24b4cf814ea02570f39b178c942f204f8697cd17b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionLessThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionLessThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dc715e49b1e60b91c2d3e3215f4e8bab1e5d33daa591d42c22bd46c230efbe1a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__30a36cc0d51ef609c128d7bbf13bef4d65bb8cf496f19f0fa5c02a8c5809860b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7516f042a9a377ba81e92e3ba7a96084942ea5d367c63be7f4569793220dd9c6)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7f4241239f3f7c69091d51b6d251e4258164bd78f6aa23fb3d7bb5c52d575664)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__382efe72473e89ee6b6a1d50eec3eea52001a63d86c43f5936ca9d0ae37dbc66)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0dcf2913fd1256056824860d1001433fdf8240337774b1b02665e1d7a22645ee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimension]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimension]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd831ef9a6f379abf289d040ef9b763cb5512bc5183c475fc30f6dad6ea6dfc5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__170d24ca6a54127685722630a4fd818ff07e888b8778bcd42838ce0a9e4bdad6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putEqual")
    def put_equal(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionEqual()

        return typing.cast(None, jsii.invoke(self, "putEqual", [value]))

    @jsii.member(jsii_name="putGreaterThan")
    def put_greater_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionGreaterThan()

        return typing.cast(None, jsii.invoke(self, "putGreaterThan", [value]))

    @jsii.member(jsii_name="putLessThan")
    def put_less_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionLessThan()

        return typing.cast(None, jsii.invoke(self, "putLessThan", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetDimension")
    def reset_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimension", []))

    @jsii.member(jsii_name="resetDimensionVar")
    def reset_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimensionVar", []))

    @jsii.member(jsii_name="resetEqual")
    def reset_equal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEqual", []))

    @jsii.member(jsii_name="resetGreaterThan")
    def reset_greater_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGreaterThan", []))

    @jsii.member(jsii_name="resetLessThan")
    def reset_less_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLessThan", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="equal")
    def equal(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionEqualOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionEqualOutputReference, jsii.get(self, "equal"))

    @builtins.property
    @jsii.member(jsii_name="greaterThan")
    def greater_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionGreaterThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionGreaterThanOutputReference, jsii.get(self, "greaterThan"))

    @builtins.property
    @jsii.member(jsii_name="lessThan")
    def less_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionLessThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionLessThanOutputReference, jsii.get(self, "lessThan"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionInput")
    def dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionVarInput")
    def dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="equalInput")
    def equal_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionEqual], jsii.get(self, "equalInput"))

    @builtins.property
    @jsii.member(jsii_name="greaterThanInput")
    def greater_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionGreaterThan], jsii.get(self, "greaterThanInput"))

    @builtins.property
    @jsii.member(jsii_name="lessThanInput")
    def less_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionLessThan], jsii.get(self, "lessThanInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="dimension")
    def dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimension"))

    @dimension.setter
    def dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__77fe7dda768ea2fa570c4e2af06bc72c54de1ee735123a99110fb07866b94006)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimension", value)

    @builtins.property
    @jsii.member(jsii_name="dimensionVar")
    def dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimensionVar"))

    @dimension_var.setter
    def dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__da356bc7b8d6fec05032ce35f5a084688cf110edfa7e32820a6673009b005df4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0bf6525ecedc79bdd377b85976525011ca02c1dc5ed6ee143bbd8288635af9ca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__372ac0aa7c2b55a56a872836f33fe82c34e90ba79aad37eb8077a714a05f8d89)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimension]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimension]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimension]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1060a12a5390126e2f57fd653ff5c0033747e51526d11f495a409c297fd35a6a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientation",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "landscape": "landscape",
        "portrait": "portrait",
        "square": "square",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientation:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        landscape: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationLandscape", typing.Dict[builtins.str, typing.Any]]] = None,
        portrait: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationPortrait", typing.Dict[builtins.str, typing.Any]]] = None,
        square: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationSquare", typing.Dict[builtins.str, typing.Any]]] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param landscape: landscape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        :param portrait: portrait block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        :param square: square block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationDefault(**default)
        if isinstance(landscape, dict):
            landscape = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationLandscape(**landscape)
        if isinstance(portrait, dict):
            portrait = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationPortrait(**portrait)
        if isinstance(square, dict):
            square = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationSquare(**square)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1e870bf50e2c44b1cc20880c31e49fd79e1d5035ea96985d31d5ea6f79447741)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument landscape", value=landscape, expected_type=type_hints["landscape"])
            check_type(argname="argument portrait", value=portrait, expected_type=type_hints["portrait"])
            check_type(argname="argument square", value=square, expected_type=type_hints["square"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if landscape is not None:
            self._values["landscape"] = landscape
        if portrait is not None:
            self._values["portrait"] = portrait
        if square is not None:
            self._values["square"] = square

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationDefault"], result)

    @builtins.property
    def landscape(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationLandscape"]:
        '''landscape block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        '''
        result = self._values.get("landscape")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationLandscape"], result)

    @builtins.property
    def portrait(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationPortrait"]:
        '''portrait block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        '''
        result = self._values.get("portrait")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationPortrait"], result)

    @builtins.property
    def square(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationSquare"]:
        '''square block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        result = self._values.get("square")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationSquare"], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2fedd71a6ce78f847ec2ad0d5316221808fe1f07004b37279f9d1d54684857b4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ff695d7863782fb7440d7a8924bab2ca41a6276385fd10597a34f67d4749cb2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationLandscape",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationLandscape:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationLandscape(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationLandscapeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationLandscapeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d37962cadeaa35b417ec38d96e457381c441b9ecccfe8e41d490714d3df75a4f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationLandscape], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationLandscape],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4b3b7782f8fe6b3bb13c5867d2b56ffa31c039ea3c9a67b55dc2b86823e37525)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__379c06dac7123de1673a4b54179697dd21d9f43185c3b57c1122faaa3ccaee61)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f4bfefd79d3191bad7b8c0fb3c5d48e5bc3f9bb93b24215d8478a0abe021b1e)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__656031c369bfb3e7a89d40fef8157574cad2924df8310ecc02a48b707b349c9d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d2facefe2ae5994d6da5a95b30ef1d6e6e6c6f90a569fb51f49132af292d1540)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b7873caef942dd18a7d8574fe5ab2ab37f175d28c3db11253468218d8292e985)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientation]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientation]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1a12a293654f53e105ac0dacb07e1dd0a1f172af20773f3bc14de5d474d05ddb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea45bcfc6f1ca9fe58890ddbba732d72eadff4dbdffe1cb75b0f3ffdf460a100)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putLandscape")
    def put_landscape(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationLandscape()

        return typing.cast(None, jsii.invoke(self, "putLandscape", [value]))

    @jsii.member(jsii_name="putPortrait")
    def put_portrait(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationPortrait()

        return typing.cast(None, jsii.invoke(self, "putPortrait", [value]))

    @jsii.member(jsii_name="putSquare")
    def put_square(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationSquare()

        return typing.cast(None, jsii.invoke(self, "putSquare", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetLandscape")
    def reset_landscape(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLandscape", []))

    @jsii.member(jsii_name="resetPortrait")
    def reset_portrait(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPortrait", []))

    @jsii.member(jsii_name="resetSquare")
    def reset_square(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSquare", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="landscape")
    def landscape(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationLandscapeOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationLandscapeOutputReference, jsii.get(self, "landscape"))

    @builtins.property
    @jsii.member(jsii_name="portrait")
    def portrait(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationPortraitOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationPortraitOutputReference", jsii.get(self, "portrait"))

    @builtins.property
    @jsii.member(jsii_name="square")
    def square(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationSquareOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationSquareOutputReference", jsii.get(self, "square"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="landscapeInput")
    def landscape_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationLandscape], jsii.get(self, "landscapeInput"))

    @builtins.property
    @jsii.member(jsii_name="portraitInput")
    def portrait_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationPortrait"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationPortrait"], jsii.get(self, "portraitInput"))

    @builtins.property
    @jsii.member(jsii_name="squareInput")
    def square_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationSquare"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationSquare"], jsii.get(self, "squareInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientation]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientation]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientation]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c7c9877555096a9317dca26b4ff07ca9a6ed4fa8a42ca8fcf6828d8e082ad346)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationPortrait",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationPortrait:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationPortrait(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationPortraitOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationPortraitOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__72c02e98da978fbcf38110d768031b61b7d350653fb6a383589f298203a33f67)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationPortrait]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationPortrait], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationPortrait],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e8d2d3dc5b73ae2ad5e00176dd4bcfcd6059538c98bc1da566058ebbf6f2ad51)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationSquare",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationSquare:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationSquare(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationSquareOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationSquareOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b5c3edcae5273b8ce069c96a589ae3d17c905540682bab2e9ea5d3014ae42909)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationSquare]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationSquare], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationSquare],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a91c7d75aac73554bdcc61ea5d152b6d9aa13847aad870a2cec0f6ba7d08e28d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultMaxColors",
    jsii_struct_bases=[],
    name_mapping={"colors": "colors", "colors_var": "colorsVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultMaxColors:
    def __init__(
        self,
        *,
        colors: typing.Optional[builtins.str] = None,
        colors_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param colors: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        :param colors_var: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__20990357d58e04afcdcf4ce12d4591f648001d6b9c16bc2ca947dea966822e5d)
            check_type(argname="argument colors", value=colors, expected_type=type_hints["colors"])
            check_type(argname="argument colors_var", value=colors_var, expected_type=type_hints["colors_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if colors is not None:
            self._values["colors"] = colors
        if colors_var is not None:
            self._values["colors_var"] = colors_var

    @builtins.property
    def colors(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        '''
        result = self._values.get("colors")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def colors_var(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        result = self._values.get("colors_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultMaxColors(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultMaxColorsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultMaxColorsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8fd358a4cd0645292ddf821becf8bac34dbe596eb4d9f44c35bf7aac4089765e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultMaxColorsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__102f7ae09660e411693c4dc28bf817af164869af46987db60b04b0abb26cbaf6)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultMaxColorsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__43074952890dabd14c21d356caf1bbc809a4532babc7e84f3049e766c0e45eb8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__212255d1a0ed1a57c4ae3d42eb4a49285a9353d074f81ddaed90249c81d31283)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0a97c546aadcc3126faaaaf33cbc6d930ef5e3570cd9aa9a521b4dc86028ec24)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultMaxColors]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultMaxColors]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab33b6f752eb1bcfa2afd29a9a6d5ae8597bb0e20518fbc329dbca74caeb0a64)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultMaxColorsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultMaxColorsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b65ea84d61cad8a87e38bf751cdf68a3a5d3c65adbdeb944c7261135908fcdb3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColors")
    def reset_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColors", []))

    @jsii.member(jsii_name="resetColorsVar")
    def reset_colors_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorsVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorsInput")
    def colors_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsInput"))

    @builtins.property
    @jsii.member(jsii_name="colorsVarInput")
    def colors_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsVarInput"))

    @builtins.property
    @jsii.member(jsii_name="colors")
    def colors(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colors"))

    @colors.setter
    def colors(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c7bc1ab3b3ea14d9bfffeb009b7cf85da4e1802915c0a45582303356d1d05f84)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colors", value)

    @builtins.property
    @jsii.member(jsii_name="colorsVar")
    def colors_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorsVar"))

    @colors_var.setter
    def colors_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__888410912924d54c67dfa214b4bcd9edd1ade63e0432b07f78112e0a190d4eb5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorsVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultMaxColors]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultMaxColors]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultMaxColors]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__44420b3730fe978fba01e916d7643f52e90515bd0b79eb468fb60f79cdf87ca1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultMirror",
    jsii_struct_bases=[],
    name_mapping={
        "horizontal": "horizontal",
        "horizontal_var": "horizontalVar",
        "vertical": "vertical",
        "vertical_var": "verticalVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultMirror:
    def __init__(
        self,
        *,
        horizontal: typing.Optional[builtins.str] = None,
        horizontal_var: typing.Optional[builtins.str] = None,
        vertical: typing.Optional[builtins.str] = None,
        vertical_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param horizontal: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        :param horizontal_var: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        :param vertical: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        :param vertical_var: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e9deeb727e1c4aa4178c0433bf094c8aa568aa1b40059f49cd5a63a7d5347c67)
            check_type(argname="argument horizontal", value=horizontal, expected_type=type_hints["horizontal"])
            check_type(argname="argument horizontal_var", value=horizontal_var, expected_type=type_hints["horizontal_var"])
            check_type(argname="argument vertical", value=vertical, expected_type=type_hints["vertical"])
            check_type(argname="argument vertical_var", value=vertical_var, expected_type=type_hints["vertical_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if horizontal is not None:
            self._values["horizontal"] = horizontal
        if horizontal_var is not None:
            self._values["horizontal_var"] = horizontal_var
        if vertical is not None:
            self._values["vertical"] = vertical
        if vertical_var is not None:
            self._values["vertical_var"] = vertical_var

    @builtins.property
    def horizontal(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        '''
        result = self._values.get("horizontal")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def horizontal_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        '''
        result = self._values.get("horizontal_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        '''
        result = self._values.get("vertical")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        result = self._values.get("vertical_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultMirror(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultMirrorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultMirrorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cc0ccab8033a131c39b00484ed70c2db7e9cc590d2f410eca685c25fbfed5051)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultMirrorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__33eaa97cb3f019d834ed3771a4126f656480dd7d7046da1ee7a160a80fef8918)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultMirrorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9482349390748612a4f87aaea0cf46506318bd343d234b5659573f6c43077f9a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__99b4ae6e753ffec1d33f981529795ef6d695ccf2a410f614e4eb5f375df09316)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f727517dd19b732a457548e186eaf1b2ce815223acce0f7b05b8898d728779d1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultMirror]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultMirror]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f6ced9e746b01c90628ab558925d323d3c345251349086cf7dd96e09c2c8779a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultMirrorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultMirrorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8f838692057f79417035d02c5e9ba0d5213986e65b8c98f66a698e21ebb8b56c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHorizontal")
    def reset_horizontal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontal", []))

    @jsii.member(jsii_name="resetHorizontalVar")
    def reset_horizontal_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontalVar", []))

    @jsii.member(jsii_name="resetVertical")
    def reset_vertical(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVertical", []))

    @jsii.member(jsii_name="resetVerticalVar")
    def reset_vertical_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVerticalVar", []))

    @builtins.property
    @jsii.member(jsii_name="horizontalInput")
    def horizontal_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontalVarInput")
    def horizontal_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalInput")
    def vertical_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalVarInput")
    def vertical_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontal")
    def horizontal(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontal"))

    @horizontal.setter
    def horizontal(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6681bd17f680bf85b24f1bd48f92b4155003febbaf13399eb75b3cb4383cbd5f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontal", value)

    @builtins.property
    @jsii.member(jsii_name="horizontalVar")
    def horizontal_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontalVar"))

    @horizontal_var.setter
    def horizontal_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eabb386680641b1714d3f30298b116abea6a51eb612ea8540cc0a59f85ae1241)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontalVar", value)

    @builtins.property
    @jsii.member(jsii_name="vertical")
    def vertical(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "vertical"))

    @vertical.setter
    def vertical(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__227bb3aac763eab2b6cc97ef95ca93e8048bea237cafd567043567cf9ac900f8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "vertical", value)

    @builtins.property
    @jsii.member(jsii_name="verticalVar")
    def vertical_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "verticalVar"))

    @vertical_var.setter
    def vertical_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d65c4b782f727e853f55cf0e5c441d3d6af61efc796fe80191f1f23d2617f9bb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "verticalVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultMirror]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultMirror]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultMirror]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5c866fcf4b4e986cfc49a056ef4c474c93b3b1b289c1dcd16c280ca7b2c3216a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultMonoHue",
    jsii_struct_bases=[],
    name_mapping={"hue": "hue", "hue_var": "hueVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultMonoHue:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7f35d63e0899e289384e8a03c1fcbc134c8bcd4c7437c35152f90ff755a37aef)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultMonoHue(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultMonoHueList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultMonoHueList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0d5b45c63fc4947f8e8647da95228247c002f8e43fe9ebe1e8381f9b02656ec1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultMonoHueOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8e3f94ea3f63af279a5ebb0eaa7fbce9e1a1ec51461f304d67aeaaa71afc9c14)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultMonoHueOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ec9f17c0da2348f9e1933dd8c649424260fc9c9767f895aedb33d49d431c3947)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__940e26c59fd039e3cd89a870146b9b82b92e4edb935018e1a5d6823135f47fdf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d96b1a70849526cce42cf62872b232da41d2b53d03c2296a4828941869d36ba0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultMonoHue]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultMonoHue]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f4ec5294e566e3bbbc045ba3d8b2424596ac90f6c19d2f7cd29db28eae7748ba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultMonoHueOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultMonoHueOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__37903aaef29c52591d04d7fe3f4a2dcc9e91a4bb126954b83147e064b4b26b1b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__19892c98529762e286c880ae9bf960bed0499625fe0949fae538b7211eab03e2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b4cd90d56c67c0def2f6fc742f0963735c85186d6b63987ad3c82c4177971b08)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultMonoHue]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultMonoHue]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultMonoHue]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2569aef0aecdf34afc032e0ada7e4974940d613cdcba15290e5fbe92bbf42cfc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultOpacity",
    jsii_struct_bases=[],
    name_mapping={"opacity": "opacity", "opacity_var": "opacityVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultOpacity:
    def __init__(
        self,
        *,
        opacity: typing.Optional[builtins.str] = None,
        opacity_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param opacity: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param opacity_var: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1d01a2b42a6498a69d685615fea442992cab9e161bb0a09c4251b62160f7feeb)
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument opacity_var", value=opacity_var, expected_type=type_hints["opacity_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if opacity is not None:
            self._values["opacity"] = opacity
        if opacity_var is not None:
            self._values["opacity_var"] = opacity_var

    @builtins.property
    def opacity(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def opacity_var(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        result = self._values.get("opacity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultOpacity(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultOpacityList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultOpacityList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cbf0e5d81685dd0975c28518a1936155503701a2121cc1518b8df989d0d6fc35)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultOpacityOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__98ce6f3b38ffa234d42ec3c0547f07624ace78bdb726e681bd664c1bcdafb4f1)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultOpacityOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__666e88dc1241c26e05b49e8bad1ca2cab603e8ec152471956234c6dcf961fbd9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__801fd578f0c2ab9052ea89a3449a3935154a72c0ff3bf1a67fc5657bce3bf0e9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__652402f2ea5420e0820e8cc039c119c1cf3466ee9c0c11dbfaf55dc444e0e39e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultOpacity]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultOpacity]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2f724d9ba065d06fcedc3c4380e4d236732b2a468d0a0934677343a10fcbb866)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultOpacityOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultOpacityOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0814eb3adb5173f03bcab5be22a345c382475967e32819b07a4625543fbe1b99)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetOpacityVar")
    def reset_opacity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacityVar", []))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityVarInput")
    def opacity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacity"))

    @opacity.setter
    def opacity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab4ffbac6b66318f1018a7b838b8dd85483eaf0b2c6bfab9c36c050f943aee2c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacity", value)

    @builtins.property
    @jsii.member(jsii_name="opacityVar")
    def opacity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacityVar"))

    @opacity_var.setter
    def opacity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c1c57ada712e56efa4862ad079114527306c0c0029d165c199c9fb82622ed2b4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacityVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultOpacity]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultOpacity]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultOpacity]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c82e78f77fc62c77562da2e8cb869fd9d21ad5d8a73e1b8275786d27f41dead1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__164bc971332aa9f087fe8e36e37ccdea1254bd4c8e5f2687b26b2b305b56aa86)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putBackgroundColor")
    def put_background_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d4e2488ca06fd6943ad32f17db02cb07647f4a25a5467218a066935480d1ebf0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBackgroundColor", [value]))

    @jsii.member(jsii_name="putBlur")
    def put_blur(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultBlur, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__51bdc9872bf010102cbb39d6e0b1619724a46b3c89af874e8fe4c41d78024013)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBlur", [value]))

    @jsii.member(jsii_name="putChromaKey")
    def put_chroma_key(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultChromaKey, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__10fc31dc502e83953dcbdef876b2f6f495a466ac27b1450c37743a703a8543ff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putChromaKey", [value]))

    @jsii.member(jsii_name="putComposite")
    def put_composite(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultComposite, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__895b206bbac4d9bdf232463e42cd3c08c2555a3c7f3c15f6eeb46690154cc80b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putComposite", [value]))

    @jsii.member(jsii_name="putCompound")
    def put_compound(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultCompound, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f255085a0c8af8ac2e84d588f9ed3b5049b7d02fc32b04a0ab150010c14e0192)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCompound", [value]))

    @jsii.member(jsii_name="putContrast")
    def put_contrast(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultContrast, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d54ec5cff4bf461ca3fae24df9d282c1c78e6dc28dc78794390b155eef8748c7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putContrast", [value]))

    @jsii.member(jsii_name="putGoop")
    def put_goop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultGoop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__06b1c53c16ca351134a00f10140cba8b8fa25bc533207321c48c140200282329)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGoop", [value]))

    @jsii.member(jsii_name="putGrayscale")
    def put_grayscale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultGrayscale, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a131205cb97d242be8375425895ab513147537effef9b636d4c200459174316)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGrayscale", [value]))

    @jsii.member(jsii_name="putHsl")
    def put_hsl(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultHsl, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__47da944c8d6359137fdb90b2cf92a95f5d44f7fef6d42e6228d9a8007bc61ee8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsl", [value]))

    @jsii.member(jsii_name="putHsv")
    def put_hsv(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultHsv, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f0b98c4c65ace438a5f85b16a2206949d37d95dcaf72437ceac329855ceb6600)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsv", [value]))

    @jsii.member(jsii_name="putIfDimension")
    def put_if_dimension(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimension, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__67a6218df6cfb3f410ea040e583ba802ab9a71b5420a9c18f8521bf5c942e2d5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfDimension", [value]))

    @jsii.member(jsii_name="putIfOrientation")
    def put_if_orientation(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3f2dec45d42529d4236600f06f8f991676d1422b72c31bb8afeebed65006bdcf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfOrientation", [value]))

    @jsii.member(jsii_name="putMaxColors")
    def put_max_colors(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultMaxColors, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__136cc079bcc0deddbe477c7c3634cb2d440da95a241047b4a7115ea49d4a5bd5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMaxColors", [value]))

    @jsii.member(jsii_name="putMirror")
    def put_mirror(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultMirror, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af162935fdcebb348a8327e4ad3606d95f0736262077229e1f27c1589f11687d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMirror", [value]))

    @jsii.member(jsii_name="putMonoHue")
    def put_mono_hue(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultMonoHue, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__782b984ecb618b56673874ae443f0bfb2d3494d60a77f8a87463fb650c02db9e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMonoHue", [value]))

    @jsii.member(jsii_name="putOpacity")
    def put_opacity(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultOpacity, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd842e2400ab96a786e9b59df7d05c8ce7c19662da44d60c90e2d96078ae3a67)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putOpacity", [value]))

    @jsii.member(jsii_name="putRemoveColor")
    def put_remove_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultRemoveColor", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6408f464a49c636b69e2ee6d321ea205d9ced2d5762af3aa9f22141046c9da17)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRemoveColor", [value]))

    @jsii.member(jsii_name="putUnsharpMask")
    def put_unsharp_mask(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultUnsharpMask", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a23beda8a83f521176bd3f6e00595fe881eee5afe7ffd6d54708b9e858df6f61)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putUnsharpMask", [value]))

    @jsii.member(jsii_name="resetBackgroundColor")
    def reset_background_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBackgroundColor", []))

    @jsii.member(jsii_name="resetBlur")
    def reset_blur(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBlur", []))

    @jsii.member(jsii_name="resetChromaKey")
    def reset_chroma_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChromaKey", []))

    @jsii.member(jsii_name="resetComposite")
    def reset_composite(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetComposite", []))

    @jsii.member(jsii_name="resetCompound")
    def reset_compound(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCompound", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetGoop")
    def reset_goop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGoop", []))

    @jsii.member(jsii_name="resetGrayscale")
    def reset_grayscale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGrayscale", []))

    @jsii.member(jsii_name="resetHsl")
    def reset_hsl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsl", []))

    @jsii.member(jsii_name="resetHsv")
    def reset_hsv(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsv", []))

    @jsii.member(jsii_name="resetIfDimension")
    def reset_if_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfDimension", []))

    @jsii.member(jsii_name="resetIfOrientation")
    def reset_if_orientation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfOrientation", []))

    @jsii.member(jsii_name="resetMaxColors")
    def reset_max_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxColors", []))

    @jsii.member(jsii_name="resetMirror")
    def reset_mirror(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMirror", []))

    @jsii.member(jsii_name="resetMonoHue")
    def reset_mono_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonoHue", []))

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetRemoveColor")
    def reset_remove_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRemoveColor", []))

    @jsii.member(jsii_name="resetUnsharpMask")
    def reset_unsharp_mask(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUnsharpMask", []))

    @builtins.property
    @jsii.member(jsii_name="backgroundColor")
    def background_color(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultBackgroundColorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultBackgroundColorList, jsii.get(self, "backgroundColor"))

    @builtins.property
    @jsii.member(jsii_name="blur")
    def blur(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultBlurList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultBlurList, jsii.get(self, "blur"))

    @builtins.property
    @jsii.member(jsii_name="chromaKey")
    def chroma_key(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultChromaKeyList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultChromaKeyList, jsii.get(self, "chromaKey"))

    @builtins.property
    @jsii.member(jsii_name="composite")
    def composite(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultCompositeList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultCompositeList, jsii.get(self, "composite"))

    @builtins.property
    @jsii.member(jsii_name="compound")
    def compound(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultCompoundList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultCompoundList, jsii.get(self, "compound"))

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultContrastList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultContrastList, jsii.get(self, "contrast"))

    @builtins.property
    @jsii.member(jsii_name="goop")
    def goop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultGoopList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultGoopList, jsii.get(self, "goop"))

    @builtins.property
    @jsii.member(jsii_name="grayscale")
    def grayscale(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultGrayscaleList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultGrayscaleList, jsii.get(self, "grayscale"))

    @builtins.property
    @jsii.member(jsii_name="hsl")
    def hsl(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultHslList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultHslList, jsii.get(self, "hsl"))

    @builtins.property
    @jsii.member(jsii_name="hsv")
    def hsv(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultHsvList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultHsvList, jsii.get(self, "hsv"))

    @builtins.property
    @jsii.member(jsii_name="ifDimension")
    def if_dimension(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionList, jsii.get(self, "ifDimension"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientation")
    def if_orientation(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationList, jsii.get(self, "ifOrientation"))

    @builtins.property
    @jsii.member(jsii_name="maxColors")
    def max_colors(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultMaxColorsList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultMaxColorsList, jsii.get(self, "maxColors"))

    @builtins.property
    @jsii.member(jsii_name="mirror")
    def mirror(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultMirrorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultMirrorList, jsii.get(self, "mirror"))

    @builtins.property
    @jsii.member(jsii_name="monoHue")
    def mono_hue(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultMonoHueList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultMonoHueList, jsii.get(self, "monoHue"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultOpacityList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultOpacityList, jsii.get(self, "opacity"))

    @builtins.property
    @jsii.member(jsii_name="removeColor")
    def remove_color(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultRemoveColorList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultRemoveColorList", jsii.get(self, "removeColor"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMask")
    def unsharp_mask(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultUnsharpMaskList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultUnsharpMaskList", jsii.get(self, "unsharpMask"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColorInput")
    def background_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultBackgroundColor]]], jsii.get(self, "backgroundColorInput"))

    @builtins.property
    @jsii.member(jsii_name="blurInput")
    def blur_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultBlur]]], jsii.get(self, "blurInput"))

    @builtins.property
    @jsii.member(jsii_name="chromaKeyInput")
    def chroma_key_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultChromaKey]]], jsii.get(self, "chromaKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="compositeInput")
    def composite_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultComposite]]], jsii.get(self, "compositeInput"))

    @builtins.property
    @jsii.member(jsii_name="compoundInput")
    def compound_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultCompound]]], jsii.get(self, "compoundInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultContrast]]], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="goopInput")
    def goop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultGoop]]], jsii.get(self, "goopInput"))

    @builtins.property
    @jsii.member(jsii_name="grayscaleInput")
    def grayscale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultGrayscale]]], jsii.get(self, "grayscaleInput"))

    @builtins.property
    @jsii.member(jsii_name="hslInput")
    def hsl_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultHsl]]], jsii.get(self, "hslInput"))

    @builtins.property
    @jsii.member(jsii_name="hsvInput")
    def hsv_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultHsv]]], jsii.get(self, "hsvInput"))

    @builtins.property
    @jsii.member(jsii_name="ifDimensionInput")
    def if_dimension_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimension]]], jsii.get(self, "ifDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientationInput")
    def if_orientation_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientation]]], jsii.get(self, "ifOrientationInput"))

    @builtins.property
    @jsii.member(jsii_name="maxColorsInput")
    def max_colors_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultMaxColors]]], jsii.get(self, "maxColorsInput"))

    @builtins.property
    @jsii.member(jsii_name="mirrorInput")
    def mirror_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultMirror]]], jsii.get(self, "mirrorInput"))

    @builtins.property
    @jsii.member(jsii_name="monoHueInput")
    def mono_hue_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultMonoHue]]], jsii.get(self, "monoHueInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultOpacity]]], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="removeColorInput")
    def remove_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultRemoveColor"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultRemoveColor"]]], jsii.get(self, "removeColorInput"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMaskInput")
    def unsharp_mask_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultUnsharpMask"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultUnsharpMask"]]], jsii.get(self, "unsharpMaskInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d203fc5614e09b3b57031704a1bb96a936e175275313241c03651bc4f693a226)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultRemoveColor",
    jsii_struct_bases=[],
    name_mapping={
        "color": "color",
        "color_var": "colorVar",
        "feather": "feather",
        "feather_var": "featherVar",
        "tolerance": "tolerance",
        "tolerance_var": "toleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultRemoveColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
        feather: typing.Optional[builtins.str] = None,
        feather_var: typing.Optional[builtins.str] = None,
        tolerance: typing.Optional[builtins.str] = None,
        tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        :param feather: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        :param feather_var: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        :param tolerance: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        :param tolerance_var: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__24a3d76ff8f41c3c55af51f29ffba0157e150270cfb1cf4daf2b4e5d60ab9a17)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
            check_type(argname="argument feather", value=feather, expected_type=type_hints["feather"])
            check_type(argname="argument feather_var", value=feather_var, expected_type=type_hints["feather_var"])
            check_type(argname="argument tolerance", value=tolerance, expected_type=type_hints["tolerance"])
            check_type(argname="argument tolerance_var", value=tolerance_var, expected_type=type_hints["tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var
        if feather is not None:
            self._values["feather"] = feather
        if feather_var is not None:
            self._values["feather_var"] = feather_var
        if tolerance is not None:
            self._values["tolerance"] = tolerance
        if tolerance_var is not None:
            self._values["tolerance_var"] = tolerance_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        '''
        result = self._values.get("feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather_var(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        '''
        result = self._values.get("feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        '''
        result = self._values.get("tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance_var(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        result = self._values.get("tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultRemoveColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultRemoveColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultRemoveColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eb0bd9fb120e48d900d92af4adeb2730577664eb8cb80064a8c04396c1c77af2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultRemoveColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fe7cdcba6f645751b7807aedbffbabf73e5ef5baef7a0741fc49e0ef1e4f4d71)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultRemoveColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f49cb7d11e40636af6e25f8368e6f0fd7ae7e71f3e19f5800631a5de86fe5f5c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__05d4041bfee3da6247c11b7643cd7b3704ea7bd3361bc77fa36a71961f6cfbe5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1074079e7a0b0342c86acb8d51dc6e9939082043bc590e84e328bc670832df37)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultRemoveColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultRemoveColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultRemoveColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ee322ffe1d1db72ebdd66118bfae9f22dead9dce027f0d9024d5f30644aa73a1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultRemoveColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultRemoveColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8ccc520f5cb3d4bbf7998546c3ae93dcd1808b1db0ac30c5159035f610278953)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @jsii.member(jsii_name="resetFeather")
    def reset_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeather", []))

    @jsii.member(jsii_name="resetFeatherVar")
    def reset_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatherVar", []))

    @jsii.member(jsii_name="resetTolerance")
    def reset_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTolerance", []))

    @jsii.member(jsii_name="resetToleranceVar")
    def reset_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featherInput")
    def feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherInput"))

    @builtins.property
    @jsii.member(jsii_name="featherVarInput")
    def feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceInput")
    def tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceVarInput")
    def tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3be710174d831f86435bec3bef676546aa7486401b68a0797287e90dbd1daa91)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__89cdae5c613cc39252bbe9eea09b04eaaee00efcc1e7454b8da5ad9ea64d5b30)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="feather")
    def feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "feather"))

    @feather.setter
    def feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2004ef61a80c9d9cb3313f81dff82b910bdfa009cc2c44dcb2b2aa6ff624b2c6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "feather", value)

    @builtins.property
    @jsii.member(jsii_name="featherVar")
    def feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featherVar"))

    @feather_var.setter
    def feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__28466e82ec9910f7907384ee24d4fa811da4d7947051aeb80ba8ff9e7d4cbcda)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featherVar", value)

    @builtins.property
    @jsii.member(jsii_name="tolerance")
    def tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tolerance"))

    @tolerance.setter
    def tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f718a34724c55baaa68423f0efe25c6ba5d2a6689434edb9e02c44c4336c13fa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tolerance", value)

    @builtins.property
    @jsii.member(jsii_name="toleranceVar")
    def tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "toleranceVar"))

    @tolerance_var.setter
    def tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b8566ae7810ac19549a05b71fc47320e8aff67b14864889459c3752067d0eb9a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "toleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultRemoveColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultRemoveColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultRemoveColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f4bdf38ebc5ad152f01163f88441f886eb227d5cd6d02c6fbc41a512811287ad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultUnsharpMask",
    jsii_struct_bases=[],
    name_mapping={
        "gain": "gain",
        "gain_var": "gainVar",
        "sigma": "sigma",
        "sigma_var": "sigmaVar",
        "threshold": "threshold",
        "threshold_var": "thresholdVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultUnsharpMask:
    def __init__(
        self,
        *,
        gain: typing.Optional[builtins.str] = None,
        gain_var: typing.Optional[builtins.str] = None,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
        threshold: typing.Optional[builtins.str] = None,
        threshold_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param gain: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        :param gain_var: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        :param sigma: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        :param threshold: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        :param threshold_var: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__13088be7c4c2c843daf3800ac8e1f08799671f1eb94ebbf4b7b47cb11874ee7a)
            check_type(argname="argument gain", value=gain, expected_type=type_hints["gain"])
            check_type(argname="argument gain_var", value=gain_var, expected_type=type_hints["gain_var"])
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
            check_type(argname="argument threshold", value=threshold, expected_type=type_hints["threshold"])
            check_type(argname="argument threshold_var", value=threshold_var, expected_type=type_hints["threshold_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if gain is not None:
            self._values["gain"] = gain
        if gain_var is not None:
            self._values["gain_var"] = gain_var
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var
        if threshold is not None:
            self._values["threshold"] = threshold
        if threshold_var is not None:
            self._values["threshold_var"] = threshold_var

    @builtins.property
    def gain(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        '''
        result = self._values.get("gain")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gain_var(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        '''
        result = self._values.get("gain_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        '''
        result = self._values.get("threshold")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold_var(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        result = self._values.get("threshold_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultUnsharpMask(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultUnsharpMaskList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultUnsharpMaskList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e6c6d0da4d6e27b63610558b4abd3ea176e48b960d4f3f94ae8cfffd6e1daf2e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultUnsharpMaskOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1acb7a486f48cfacf83db818c879adfd2e5122078810f9f99bd26b358995e980)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultUnsharpMaskOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a115dd69f2a1db2fd997873326dc78054114af009247a40b33e48ecf830aa1e0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b529f42e3d7d382d8efcf16cfb0836dfb8430839366e9a8712381ba8a668cfcb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd8bf32a002f73e4042758e053543b27f646fc77cc8b6a3a1a890ef17efdc424)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultUnsharpMask]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultUnsharpMask]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultUnsharpMask]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__295ca8afd7a13132d09b1cbd3f4bbd011a1d6d4d52d7c63e89e98bd1e0dd6cad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultUnsharpMaskOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultUnsharpMaskOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b76e0d89f940effa052aa889e2ffb6ae818b92598082bdec071130b8ac0ac8ce)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetGain")
    def reset_gain(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGain", []))

    @jsii.member(jsii_name="resetGainVar")
    def reset_gain_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGainVar", []))

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @jsii.member(jsii_name="resetThreshold")
    def reset_threshold(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThreshold", []))

    @jsii.member(jsii_name="resetThresholdVar")
    def reset_threshold_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThresholdVar", []))

    @builtins.property
    @jsii.member(jsii_name="gainInput")
    def gain_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainInput"))

    @builtins.property
    @jsii.member(jsii_name="gainVarInput")
    def gain_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdInput")
    def threshold_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdVarInput")
    def threshold_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gain")
    def gain(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gain"))

    @gain.setter
    def gain(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c8560e35e59387e324e27c598f549c5c32713cbab05ce2bb6cdbb9dda7f1fc29)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gain", value)

    @builtins.property
    @jsii.member(jsii_name="gainVar")
    def gain_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gainVar"))

    @gain_var.setter
    def gain_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2c72bd2fa761ac991fe7d134aa93225b39156850078268b17152b5fff3e55132)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gainVar", value)

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ade88583d7cba9b22c237700ae683a291e2c3906fc0300688edbe93784e23c8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__67925507fb656fb5f1a8af976e1c1ef3161e05481cd6f8f305a7f1489c768f3a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="threshold")
    def threshold(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "threshold"))

    @threshold.setter
    def threshold(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b6b5e589ac51692f24a3d11ae9cd0de21e1a6d6a2f248c5d4b2f2dd59d37efdf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "threshold", value)

    @builtins.property
    @jsii.member(jsii_name="thresholdVar")
    def threshold_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "thresholdVar"))

    @threshold_var.setter
    def threshold_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a7b195ca0ed8e6724a31809c5bccc37c24f192a35ed27bde76dd9ae1c425d63)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "thresholdVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultUnsharpMask]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultUnsharpMask]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultUnsharpMask]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__11cec6a63dbe593194179f71648db5584f1f7b76dff4bd990ba83b2f5b150da4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqual",
    jsii_struct_bases=[],
    name_mapping={
        "background_color": "backgroundColor",
        "blur": "blur",
        "chroma_key": "chromaKey",
        "composite": "composite",
        "compound": "compound",
        "contrast": "contrast",
        "goop": "goop",
        "grayscale": "grayscale",
        "hsl": "hsl",
        "hsv": "hsv",
        "if_dimension": "ifDimension",
        "if_orientation": "ifOrientation",
        "max_colors": "maxColors",
        "mirror": "mirror",
        "mono_hue": "monoHue",
        "opacity": "opacity",
        "remove_color": "removeColor",
        "unsharp_mask": "unsharpMask",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqual:
    def __init__(
        self,
        *,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualBackgroundColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualBlur", typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualChromaKey", typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualComposite", typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualCompound", typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualContrast", typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualGoop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualGrayscale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualHsl", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualHsv", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimension", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientation", typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualMaxColors", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualMirror", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualMonoHue", typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualOpacity", typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualRemoveColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualUnsharpMask", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2099b9d535cbb3aa55254c9709ad5f8e8fec4602013d83732ac3e8a469ff522d)
            check_type(argname="argument background_color", value=background_color, expected_type=type_hints["background_color"])
            check_type(argname="argument blur", value=blur, expected_type=type_hints["blur"])
            check_type(argname="argument chroma_key", value=chroma_key, expected_type=type_hints["chroma_key"])
            check_type(argname="argument composite", value=composite, expected_type=type_hints["composite"])
            check_type(argname="argument compound", value=compound, expected_type=type_hints["compound"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument goop", value=goop, expected_type=type_hints["goop"])
            check_type(argname="argument grayscale", value=grayscale, expected_type=type_hints["grayscale"])
            check_type(argname="argument hsl", value=hsl, expected_type=type_hints["hsl"])
            check_type(argname="argument hsv", value=hsv, expected_type=type_hints["hsv"])
            check_type(argname="argument if_dimension", value=if_dimension, expected_type=type_hints["if_dimension"])
            check_type(argname="argument if_orientation", value=if_orientation, expected_type=type_hints["if_orientation"])
            check_type(argname="argument max_colors", value=max_colors, expected_type=type_hints["max_colors"])
            check_type(argname="argument mirror", value=mirror, expected_type=type_hints["mirror"])
            check_type(argname="argument mono_hue", value=mono_hue, expected_type=type_hints["mono_hue"])
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument remove_color", value=remove_color, expected_type=type_hints["remove_color"])
            check_type(argname="argument unsharp_mask", value=unsharp_mask, expected_type=type_hints["unsharp_mask"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if background_color is not None:
            self._values["background_color"] = background_color
        if blur is not None:
            self._values["blur"] = blur
        if chroma_key is not None:
            self._values["chroma_key"] = chroma_key
        if composite is not None:
            self._values["composite"] = composite
        if compound is not None:
            self._values["compound"] = compound
        if contrast is not None:
            self._values["contrast"] = contrast
        if goop is not None:
            self._values["goop"] = goop
        if grayscale is not None:
            self._values["grayscale"] = grayscale
        if hsl is not None:
            self._values["hsl"] = hsl
        if hsv is not None:
            self._values["hsv"] = hsv
        if if_dimension is not None:
            self._values["if_dimension"] = if_dimension
        if if_orientation is not None:
            self._values["if_orientation"] = if_orientation
        if max_colors is not None:
            self._values["max_colors"] = max_colors
        if mirror is not None:
            self._values["mirror"] = mirror
        if mono_hue is not None:
            self._values["mono_hue"] = mono_hue
        if opacity is not None:
            self._values["opacity"] = opacity
        if remove_color is not None:
            self._values["remove_color"] = remove_color
        if unsharp_mask is not None:
            self._values["unsharp_mask"] = unsharp_mask

    @builtins.property
    def background_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualBackgroundColor"]]]:
        '''background_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        '''
        result = self._values.get("background_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualBackgroundColor"]]], result)

    @builtins.property
    def blur(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualBlur"]]]:
        '''blur block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        '''
        result = self._values.get("blur")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualBlur"]]], result)

    @builtins.property
    def chroma_key(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualChromaKey"]]]:
        '''chroma_key block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        '''
        result = self._values.get("chroma_key")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualChromaKey"]]], result)

    @builtins.property
    def composite(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualComposite"]]]:
        '''composite block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        '''
        result = self._values.get("composite")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualComposite"]]], result)

    @builtins.property
    def compound(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualCompound"]]]:
        '''compound block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        '''
        result = self._values.get("compound")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualCompound"]]], result)

    @builtins.property
    def contrast(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualContrast"]]]:
        '''contrast block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualContrast"]]], result)

    @builtins.property
    def goop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualGoop"]]]:
        '''goop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        '''
        result = self._values.get("goop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualGoop"]]], result)

    @builtins.property
    def grayscale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualGrayscale"]]]:
        '''grayscale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        '''
        result = self._values.get("grayscale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualGrayscale"]]], result)

    @builtins.property
    def hsl(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualHsl"]]]:
        '''hsl block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        '''
        result = self._values.get("hsl")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualHsl"]]], result)

    @builtins.property
    def hsv(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualHsv"]]]:
        '''hsv block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        '''
        result = self._values.get("hsv")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualHsv"]]], result)

    @builtins.property
    def if_dimension(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimension"]]]:
        '''if_dimension block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        '''
        result = self._values.get("if_dimension")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimension"]]], result)

    @builtins.property
    def if_orientation(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientation"]]]:
        '''if_orientation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        '''
        result = self._values.get("if_orientation")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientation"]]], result)

    @builtins.property
    def max_colors(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualMaxColors"]]]:
        '''max_colors block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        '''
        result = self._values.get("max_colors")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualMaxColors"]]], result)

    @builtins.property
    def mirror(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualMirror"]]]:
        '''mirror block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        '''
        result = self._values.get("mirror")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualMirror"]]], result)

    @builtins.property
    def mono_hue(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualMonoHue"]]]:
        '''mono_hue block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        '''
        result = self._values.get("mono_hue")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualMonoHue"]]], result)

    @builtins.property
    def opacity(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualOpacity"]]]:
        '''opacity block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualOpacity"]]], result)

    @builtins.property
    def remove_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualRemoveColor"]]]:
        '''remove_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        '''
        result = self._values.get("remove_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualRemoveColor"]]], result)

    @builtins.property
    def unsharp_mask(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualUnsharpMask"]]]:
        '''unsharp_mask block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        result = self._values.get("unsharp_mask")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualUnsharpMask"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqual(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualBackgroundColor",
    jsii_struct_bases=[],
    name_mapping={"color": "color", "color_var": "colorVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualBackgroundColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2807adcecb2a702480ce565bcde680f13768d155afcd427d360c20476216e1b2)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualBackgroundColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualBackgroundColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualBackgroundColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fd428af5983038cbef5e3cf1c2ed116b1bb809299c3f42aaf6dfe9f49036024a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualBackgroundColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1bd8842ea9d1b9e226f6e7f9415b1c7dfa124aad6678a0898b6636a0148b1751)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualBackgroundColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e569260a19ea061642f2ee3189af5f84f4093559a92cbccdfe273cb4f74041bb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__90d17a976878b1e792ae7c53b762ee6ed870679e6159afa5e498a9569168e116)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3fa99c6adc32d5e91afae3a9a6551a1005fb4c8f2ea9cebc35f019f5d9b787d7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualBackgroundColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualBackgroundColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b51da16804980f9ea7b1dacea45185930c41849a178ce3ba360f6ca1670d62ae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualBackgroundColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualBackgroundColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7e80b74b0e9cbed1590f3e10dd5e19461a37acdb0d58c167dfa1b9dc74ae6151)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a65d90a882964522d7f4c8b3792d94265f8d88206523e7a16291ba29bda5b2be)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__978f6d29d83e5356e64c8b414a7fddb385a2a2cb753a79618894b20f141576ee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualBackgroundColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualBackgroundColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualBackgroundColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9bde5b4221bb947ecf0e737d737c7eebe720bee4c021711170da1d8d5ac77747)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualBlur",
    jsii_struct_bases=[],
    name_mapping={"sigma": "sigma", "sigma_var": "sigmaVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualBlur:
    def __init__(
        self,
        *,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param sigma: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__14457f1527b7ea98563e94d3d516b3e6a2329a1df6fea8ef58a1b11416c1abc5)
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualBlur(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualBlurList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualBlurList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af6ccfce82befe2f1d721f80a9268408c024aa7ce5215ad829c5eaf68006760a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualBlurOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1a33eaf7ff4df77492a4adec6a0243838e3258aeb330a1c9e033a59076202a87)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualBlurOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bae550586e3ced5f61187bdaa297a217cdeeb37189c621a5633c91a6e40d7f22)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a342294d9a9097852f458780b2ca255fa6be1cd0786fbb2d10db6b1b41ab5c4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4332245a1aaef41bee601790803e0bac47bb6240326cb518e242c220dacfcbe6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualBlur]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualBlur]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d0c4598f64604bb5d29ee8d5c72253b3900554043d97f77a2cc33060abb2001)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualBlurOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualBlurOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b755ba2b18f6c324995496e7d4ac3d20ef12c6e69f0e85b052e0763201face90)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e4b5c8b54864beb675b02f43751803152c6a61d2cf0729c8bbb91ebf04b75d29)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__007b080f1127f0f817db818c186f9762f901f26cfa92421c5556b3dccec7297b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualBlur]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualBlur]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualBlur]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6cbb02ee6212e470418748d6192771efd17b81189482f269644fbc8bafc045fe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualChromaKey",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_feather": "hueFeather",
        "hue_feather_var": "hueFeatherVar",
        "hue_tolerance": "hueTolerance",
        "hue_tolerance_var": "hueToleranceVar",
        "hue_var": "hueVar",
        "lightness_feather": "lightnessFeather",
        "lightness_feather_var": "lightnessFeatherVar",
        "lightness_tolerance": "lightnessTolerance",
        "lightness_tolerance_var": "lightnessToleranceVar",
        "saturation_feather": "saturationFeather",
        "saturation_feather_var": "saturationFeatherVar",
        "saturation_tolerance": "saturationTolerance",
        "saturation_tolerance_var": "saturationToleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualChromaKey:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_feather: typing.Optional[builtins.str] = None,
        hue_feather_var: typing.Optional[builtins.str] = None,
        hue_tolerance: typing.Optional[builtins.str] = None,
        hue_tolerance_var: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness_feather: typing.Optional[builtins.str] = None,
        lightness_feather_var: typing.Optional[builtins.str] = None,
        lightness_tolerance: typing.Optional[builtins.str] = None,
        lightness_tolerance_var: typing.Optional[builtins.str] = None,
        saturation_feather: typing.Optional[builtins.str] = None,
        saturation_feather_var: typing.Optional[builtins.str] = None,
        saturation_tolerance: typing.Optional[builtins.str] = None,
        saturation_tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_feather: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        :param hue_feather_var: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        :param hue_tolerance: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        :param hue_tolerance_var: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        :param hue_var: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness_feather: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        :param lightness_feather_var: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        :param lightness_tolerance: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        :param lightness_tolerance_var: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        :param saturation_feather: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        :param saturation_feather_var: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        :param saturation_tolerance: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        :param saturation_tolerance_var: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__91ee24ffbbb1d23761bad71d61d016517917bc65de4b82b5345bdb2fff4d0aa4)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_feather", value=hue_feather, expected_type=type_hints["hue_feather"])
            check_type(argname="argument hue_feather_var", value=hue_feather_var, expected_type=type_hints["hue_feather_var"])
            check_type(argname="argument hue_tolerance", value=hue_tolerance, expected_type=type_hints["hue_tolerance"])
            check_type(argname="argument hue_tolerance_var", value=hue_tolerance_var, expected_type=type_hints["hue_tolerance_var"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness_feather", value=lightness_feather, expected_type=type_hints["lightness_feather"])
            check_type(argname="argument lightness_feather_var", value=lightness_feather_var, expected_type=type_hints["lightness_feather_var"])
            check_type(argname="argument lightness_tolerance", value=lightness_tolerance, expected_type=type_hints["lightness_tolerance"])
            check_type(argname="argument lightness_tolerance_var", value=lightness_tolerance_var, expected_type=type_hints["lightness_tolerance_var"])
            check_type(argname="argument saturation_feather", value=saturation_feather, expected_type=type_hints["saturation_feather"])
            check_type(argname="argument saturation_feather_var", value=saturation_feather_var, expected_type=type_hints["saturation_feather_var"])
            check_type(argname="argument saturation_tolerance", value=saturation_tolerance, expected_type=type_hints["saturation_tolerance"])
            check_type(argname="argument saturation_tolerance_var", value=saturation_tolerance_var, expected_type=type_hints["saturation_tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_feather is not None:
            self._values["hue_feather"] = hue_feather
        if hue_feather_var is not None:
            self._values["hue_feather_var"] = hue_feather_var
        if hue_tolerance is not None:
            self._values["hue_tolerance"] = hue_tolerance
        if hue_tolerance_var is not None:
            self._values["hue_tolerance_var"] = hue_tolerance_var
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness_feather is not None:
            self._values["lightness_feather"] = lightness_feather
        if lightness_feather_var is not None:
            self._values["lightness_feather_var"] = lightness_feather_var
        if lightness_tolerance is not None:
            self._values["lightness_tolerance"] = lightness_tolerance
        if lightness_tolerance_var is not None:
            self._values["lightness_tolerance_var"] = lightness_tolerance_var
        if saturation_feather is not None:
            self._values["saturation_feather"] = saturation_feather
        if saturation_feather_var is not None:
            self._values["saturation_feather_var"] = saturation_feather_var
        if saturation_tolerance is not None:
            self._values["saturation_tolerance"] = saturation_tolerance
        if saturation_tolerance_var is not None:
            self._values["saturation_tolerance_var"] = saturation_tolerance_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        '''
        result = self._values.get("hue_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        '''
        result = self._values.get("hue_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        '''
        result = self._values.get("hue_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        '''
        result = self._values.get("hue_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        '''
        result = self._values.get("lightness_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        '''
        result = self._values.get("lightness_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        '''
        result = self._values.get("lightness_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        '''
        result = self._values.get("lightness_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        '''
        result = self._values.get("saturation_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        '''
        result = self._values.get("saturation_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        '''
        result = self._values.get("saturation_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        result = self._values.get("saturation_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualChromaKey(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualChromaKeyList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualChromaKeyList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0bb43fc5520d4f5f538707ff768edae1c42399167a8d0959569e0ed6a0074429)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualChromaKeyOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e45a435f5282f0dd544405d84a3c012432e5e733d5fc319fb9629316805f4868)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualChromaKeyOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__618195223614d6ef92a483301834689a62582529aa5ad0f2200078050fa01c99)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4e585dd79114e6387ba1682414c07817967200339bbd636d2ca20b5da93686c4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__74ff545ff46edf5204e7a90de84b448e48f072c3c09911818a7779f1fbba801d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualChromaKey]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualChromaKey]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d73b540dd6d934913a0a90c98afa6640899039b58ed34a08629d193e448e1944)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualChromaKeyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualChromaKeyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8ccab9dc84def8f7b2e9d5bc0e01b848972b8fec05fa5be52e12873d34e9dbbc)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueFeather")
    def reset_hue_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeather", []))

    @jsii.member(jsii_name="resetHueFeatherVar")
    def reset_hue_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeatherVar", []))

    @jsii.member(jsii_name="resetHueTolerance")
    def reset_hue_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueTolerance", []))

    @jsii.member(jsii_name="resetHueToleranceVar")
    def reset_hue_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueToleranceVar", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightnessFeather")
    def reset_lightness_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeather", []))

    @jsii.member(jsii_name="resetLightnessFeatherVar")
    def reset_lightness_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeatherVar", []))

    @jsii.member(jsii_name="resetLightnessTolerance")
    def reset_lightness_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessTolerance", []))

    @jsii.member(jsii_name="resetLightnessToleranceVar")
    def reset_lightness_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessToleranceVar", []))

    @jsii.member(jsii_name="resetSaturationFeather")
    def reset_saturation_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeather", []))

    @jsii.member(jsii_name="resetSaturationFeatherVar")
    def reset_saturation_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeatherVar", []))

    @jsii.member(jsii_name="resetSaturationTolerance")
    def reset_saturation_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationTolerance", []))

    @jsii.member(jsii_name="resetSaturationToleranceVar")
    def reset_saturation_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherInput")
    def hue_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVarInput")
    def hue_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceInput")
    def hue_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVarInput")
    def hue_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherInput")
    def lightness_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVarInput")
    def lightness_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceInput")
    def lightness_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVarInput")
    def lightness_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherInput")
    def saturation_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVarInput")
    def saturation_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceInput")
    def saturation_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVarInput")
    def saturation_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a971137a9c65a9995e5b29c336b830b13e09e75545335f25db8d6a54096eddb9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeather")
    def hue_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeather"))

    @hue_feather.setter
    def hue_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9eb8b55b6d82ed5f52484de2435bb99eaad3a14d0a4c9fdbeac34e2d73760bf6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeather", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVar")
    def hue_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeatherVar"))

    @hue_feather_var.setter
    def hue_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__54676d0592fde5c8aa44a964817eaaec19d0a1bf503f47c390b851982d33ecab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueTolerance")
    def hue_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueTolerance"))

    @hue_tolerance.setter
    def hue_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2706cdb36ab4c0b709c5b06b8ecb34c6a13f87eca9d11741c52c73af1f4c2e82)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVar")
    def hue_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueToleranceVar"))

    @hue_tolerance_var.setter
    def hue_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f8da2ae1f780d73031b75aa977e536270e05a4ac825cba6ead1701d7ce00863f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ce802b12709720983bc026d884bdbab484501e590714b5b4719418cdb88336de)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeather")
    def lightness_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeather"))

    @lightness_feather.setter
    def lightness_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e12a835ec10834122dd2a2a61ffcf69e185975141381397cfdfcebc7709c3311)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeather", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVar")
    def lightness_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeatherVar"))

    @lightness_feather_var.setter
    def lightness_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9c92cbe07c98db9ca9af18acbecb753561e2e0a0f3fd9b358906ab4c75dc1fd6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessTolerance")
    def lightness_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessTolerance"))

    @lightness_tolerance.setter
    def lightness_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__08f0909ffa6240346abf2dd1fab64c6ca723dbc2143c8befafcaeea507f95c9e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVar")
    def lightness_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessToleranceVar"))

    @lightness_tolerance_var.setter
    def lightness_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__da3e883887db1f5407e2dde88ac9d2793e2e5fe6abe219f1bed379e6aad9a598)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeather")
    def saturation_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeather"))

    @saturation_feather.setter
    def saturation_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c33aef6e6cbfe64fc5b720b55d5eb0bbb2b1ce73d4af87edc65f2010a95a0605)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeather", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVar")
    def saturation_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeatherVar"))

    @saturation_feather_var.setter
    def saturation_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e4fa892c6c96e7568267127854d24c978aed4302b4796ab995c3dbcbcbf2719d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationTolerance")
    def saturation_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationTolerance"))

    @saturation_tolerance.setter
    def saturation_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ae69c5ab4cca8159d74a5a1f18ac68a8e940636a66e69580ba8c7b2cc818ea8b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVar")
    def saturation_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationToleranceVar"))

    @saturation_tolerance_var.setter
    def saturation_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7c9c3d77d9a0773258a3c4757ff50511e0ab71404411e1483b9369224e859b48)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualChromaKey]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualChromaKey]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualChromaKey]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ef9f41a1ee6491e2017b72f9612a99f9f4a87aba2d3e4d33ee7fdefdb26a3cd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualComposite",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "placement": "placement",
        "placement_var": "placementVar",
        "scale": "scale",
        "scale_dimension": "scaleDimension",
        "scale_dimension_var": "scaleDimensionVar",
        "scale_var": "scaleVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualComposite:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualCompositeImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        placement: typing.Optional[builtins.str] = None,
        placement_var: typing.Optional[builtins.str] = None,
        scale: typing.Optional[builtins.str] = None,
        scale_dimension: typing.Optional[builtins.str] = None,
        scale_dimension_var: typing.Optional[builtins.str] = None,
        scale_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param placement: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        :param placement_var: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        :param scale: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param scale_dimension: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        :param scale_dimension_var: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        :param scale_var: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        :param x_position: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualCompositeImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cadbee98122cc61af440b82c108cb9e3213531d034904580fe28ad53aed3705e)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument placement", value=placement, expected_type=type_hints["placement"])
            check_type(argname="argument placement_var", value=placement_var, expected_type=type_hints["placement_var"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument scale_dimension", value=scale_dimension, expected_type=type_hints["scale_dimension"])
            check_type(argname="argument scale_dimension_var", value=scale_dimension_var, expected_type=type_hints["scale_dimension_var"])
            check_type(argname="argument scale_var", value=scale_var, expected_type=type_hints["scale_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if placement is not None:
            self._values["placement"] = placement
        if placement_var is not None:
            self._values["placement_var"] = placement_var
        if scale is not None:
            self._values["scale"] = scale
        if scale_dimension is not None:
            self._values["scale_dimension"] = scale_dimension
        if scale_dimension_var is not None:
            self._values["scale_dimension_var"] = scale_dimension_var
        if scale_var is not None:
            self._values["scale_var"] = scale_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualCompositeImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualCompositeImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        '''
        result = self._values.get("placement")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement_var(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        '''
        result = self._values.get("placement_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        '''
        result = self._values.get("scale_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        '''
        result = self._values.get("scale_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        '''
        result = self._values.get("scale_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualComposite(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualCompositeImage",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualCompositeImage:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualCompositeImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualCompositeImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualCompositeImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be34637629cf2cfd6082ae09c2d8820773a6f0326957a329231b24fe4cda5719)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualCompositeImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualCompositeImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dc0d97733f066bd9f38432f9dbe0956a35059b8613af4d1d71e5d6a35502c6dc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualCompositeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualCompositeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6038c7d6802961c85638332f39f7ed54110708b781b2cb9b203ccec13e951260)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualCompositeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__12b1ba16e6cadd274e32010108a699a858f642a8723ce3612b5df68c5f52e2ac)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualCompositeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__47b4c094c20226b5aca011aa7a2fa0aa36c7b04d16becaddeec035bb8ae60ee1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0cc786715aaf7d1af0e2cf86077994a2d359a122e7b60e95cce083e7ad3edfe9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__88b98a10cea7b5591ea4e23fda0e73f7c2102ab0ac095cc4f899ceb99d8e3da4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualComposite]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualComposite]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0088158ab89b319b2dbf39f6a114fc5a4c04c5f124d10e25192e10ca362ac235)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualCompositeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualCompositeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d1ffe13cbc5b0979d9f0eeec9f9836862ddbc2e1a98f3418ef9e7eea91f1b70)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualCompositeImage()

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPlacement")
    def reset_placement(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacement", []))

    @jsii.member(jsii_name="resetPlacementVar")
    def reset_placement_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacementVar", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetScaleDimension")
    def reset_scale_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimension", []))

    @jsii.member(jsii_name="resetScaleDimensionVar")
    def reset_scale_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimensionVar", []))

    @jsii.member(jsii_name="resetScaleVar")
    def reset_scale_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualCompositeImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualCompositeImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualCompositeImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="placementInput")
    def placement_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementInput"))

    @builtins.property
    @jsii.member(jsii_name="placementVarInput")
    def placement_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionInput")
    def scale_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVarInput")
    def scale_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleVarInput")
    def scale_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__869aa6d55d7528c38591f68a1772862c1c5a58fc91170255fd1d810c04408ba2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a1e099ba09c2417fadedf826b4b128edfb17813384bcb0fc5607a15f6995145)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="placement")
    def placement(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placement"))

    @placement.setter
    def placement(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c1f37c2166c072200d30aa65ddf25e7a701b7b18428e00838deaec5d7e085dab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placement", value)

    @builtins.property
    @jsii.member(jsii_name="placementVar")
    def placement_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placementVar"))

    @placement_var.setter
    def placement_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__35ff8ca62d980680e3fbdb31db485ea9dc4312ec25934b27fe67f62bf0f3e0b3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placementVar", value)

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scale"))

    @scale.setter
    def scale(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c9697994f2c317cfd48bc5fc876d457e266776b3c8b5ee77bb90529d81de3897)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scale", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimension")
    def scale_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimension"))

    @scale_dimension.setter
    def scale_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1106d5ee35577e088ba4017e8e3e00febe9f4760b018dd5c852771fb8ec5b021)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimension", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVar")
    def scale_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimensionVar"))

    @scale_dimension_var.setter
    def scale_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dc961a488552b51d864ae71d99a99161db294867f4d4211b2b77f19d041486dc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="scaleVar")
    def scale_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleVar"))

    @scale_var.setter
    def scale_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__446ef96dddbabe3e25cd6940eb2b3ef586a014f97f2eda9922c029f5f2be3695)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3bfbfdd2f799041cb5b184ab6aba727d19f3ba307bc334d1eeeeae550e21dda3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__504832df3db78bda539182ead47b8505cdbe2ce91352dca92b84f4b3b17dadb3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2632e7ce9b191753cc101f7b65770bd913c0c096c6f60dcb242aba6b9ab16984)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8d3212f07425917f7c4abe316d161cba50f584fae56d0dc234a77bbda40952be)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualComposite]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualComposite]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualComposite]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ae00399e3c633945e1a7c41d482565e555cdc6e0397103f0a5d922b64fac4946)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualCompound",
    jsii_struct_bases=[],
    name_mapping={"transformations": "transformations"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualCompound:
    def __init__(
        self,
        *,
        transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param transformations: transformations block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f9bd9704dc0fe061e6ff860e9fad9e780680e7d37f42bad0001bf45bb236c6a9)
            check_type(argname="argument transformations", value=transformations, expected_type=type_hints["transformations"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if transformations is not None:
            self._values["transformations"] = transformations

    @builtins.property
    def transformations(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualCompoundTransformations"]]]:
        '''transformations block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        result = self._values.get("transformations")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualCompoundTransformations"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualCompound(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualCompoundList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualCompoundList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aca45515802b961413109f2b236e3c94f1e94d4df48a95a3582923f8e456c6c0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualCompoundOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__576bdf5f04075d4e85ce3b47c4a1b060dd330121e5fd53a6c8bdfd545fb19927)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualCompoundOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fc5fda7e4fdda8e8fc879b62a23231c88ce9723c4845ddf8c017d066c3962296)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a5cc93d134744a78b0879b73577c8b5161af201b2e9f83c2d7fe856df1b2643d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__352bef2026111831ee3a4c970eee96f5872027a32471a1102c565b9c896513c6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualCompound]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualCompound]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7596b7f7bba1ea7541d8abcca8a24ba7249b1f6f057e44894056195ac65a64b2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualCompoundOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualCompoundOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__acffa869920238457656d2182812a2904b976437acd9559ecc398a173e25dd5e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformations")
    def put_transformations(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f3fe167ba2ee77131feefe930c67c3ada358b829915eaff55a0923680dd189ea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTransformations", [value]))

    @jsii.member(jsii_name="resetTransformations")
    def reset_transformations(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformations", []))

    @builtins.property
    @jsii.member(jsii_name="transformations")
    def transformations(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualCompoundTransformationsList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualCompoundTransformationsList", jsii.get(self, "transformations"))

    @builtins.property
    @jsii.member(jsii_name="transformationsInput")
    def transformations_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualCompoundTransformations"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualCompoundTransformations"]]], jsii.get(self, "transformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualCompound]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualCompound]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualCompound]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__895a0b19175abcdb9ddbd5cff1a487646b1c79510145bc63f82214a27398a893)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualCompoundTransformations",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualCompoundTransformations:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualCompoundTransformations(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualCompoundTransformationsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualCompoundTransformationsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc6a385d348a9b23315bb50aa41b978533d965b60cab8d0c89c1056f686d8873)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualCompoundTransformationsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b9e00e6fb17d30cacb326ff2796826430cbf26171a72503fbc628d17f61e0e07)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualCompoundTransformationsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c06f5a9f102baefbb43cdf9f825b1592bd971057ddf6b9fe0d511bab03a1b4af)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__41d62f5c9dc4b5cd0ca47b1595571ee550e652cc232f432e1cef16319af0154d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__006e64d4030668ad13871a26fba98966bca912991a082645956c7f3db89a50f5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualCompoundTransformations]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualCompoundTransformations]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualCompoundTransformations]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2439a17a450498f38d9eaefa9aa96a632fabbee4ceb6a3eb1355804ecc18b1c3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualCompoundTransformationsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualCompoundTransformationsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__62c521aaf08affaf18c27ea21ca9cb721cbea7aeb9777613c3b5f2205347751a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualCompoundTransformations]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualCompoundTransformations]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualCompoundTransformations]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__82c19b85d396e7319e93b5ac992afa13b5d1287b30d9005f0e35dee86cce2153)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualContrast",
    jsii_struct_bases=[],
    name_mapping={
        "brightness": "brightness",
        "brightness_var": "brightnessVar",
        "contrast": "contrast",
        "contrast_var": "contrastVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualContrast:
    def __init__(
        self,
        *,
        brightness: typing.Optional[builtins.str] = None,
        brightness_var: typing.Optional[builtins.str] = None,
        contrast: typing.Optional[builtins.str] = None,
        contrast_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param brightness: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        :param brightness_var: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        :param contrast: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param contrast_var: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__471edd4b15031ee643b8686c000c0303a8adab3ad9698018a283943c70438c77)
            check_type(argname="argument brightness", value=brightness, expected_type=type_hints["brightness"])
            check_type(argname="argument brightness_var", value=brightness_var, expected_type=type_hints["brightness_var"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument contrast_var", value=contrast_var, expected_type=type_hints["contrast_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if brightness is not None:
            self._values["brightness"] = brightness
        if brightness_var is not None:
            self._values["brightness_var"] = brightness_var
        if contrast is not None:
            self._values["contrast"] = contrast
        if contrast_var is not None:
            self._values["contrast_var"] = contrast_var

    @builtins.property
    def brightness(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        '''
        result = self._values.get("brightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def brightness_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        '''
        result = self._values.get("brightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        result = self._values.get("contrast_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualContrast(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualContrastList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualContrastList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c109c9149deb7cb23e514f20e84ec44fcb3bd4770c17cdeaf256dbf48ec04760)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualContrastOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac548fd91337f0c48bc093d6594f555bc704296b4cd0a780bddecde844316d81)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualContrastOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__48ee2402c7c4cc443b253267b4fc262f57ce9c8349e6f489967662e5071242c3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1510dd39545f483b7bdd3e93136d4e1fb4626fd716e112d17d0e327a8fb67c80)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3063c142e81e881619fced822bb3c8dee84ca645cf87e666abd21615605fdd10)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualContrast]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualContrast]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__33192a63294d34c80571774c989343c9abc05ea7d095093ea52ad90cf0069389)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualContrastOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualContrastOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5d6ac5cdac7fe0cd2efdc6fab2938c1d09f077a2fbe15d8e5d54e330afc65cf8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetBrightness")
    def reset_brightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightness", []))

    @jsii.member(jsii_name="resetBrightnessVar")
    def reset_brightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightnessVar", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetContrastVar")
    def reset_contrast_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrastVar", []))

    @builtins.property
    @jsii.member(jsii_name="brightnessInput")
    def brightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="brightnessVarInput")
    def brightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastVarInput")
    def contrast_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="brightness")
    def brightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightness"))

    @brightness.setter
    def brightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__393029bd10466e080c69d1a2f1906942db562bb484eb404a1512899cc69140a8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightness", value)

    @builtins.property
    @jsii.member(jsii_name="brightnessVar")
    def brightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightnessVar"))

    @brightness_var.setter
    def brightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fed8d30247f4190b1ff29093bc2d3985fd9c168f8408339047ae862782b5ebac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrast"))

    @contrast.setter
    def contrast(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d4261ba6a1243eded2056d86f4a7718af281cb158f7a3438bf28147754a50b00)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrast", value)

    @builtins.property
    @jsii.member(jsii_name="contrastVar")
    def contrast_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrastVar"))

    @contrast_var.setter
    def contrast_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c47e6f9b207a0c16d73fadbfc84b09b6c90048763c3276f279b4c3635c9afbe2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrastVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualContrast]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualContrast]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualContrast]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8c60a89c864e6f3407bd127c3b50d3d4ba214ce06267baeabad85f67b09d2cb9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualGoop",
    jsii_struct_bases=[],
    name_mapping={
        "chaos": "chaos",
        "chaos_var": "chaosVar",
        "density": "density",
        "density_var": "densityVar",
        "power": "power",
        "power_var": "powerVar",
        "seed": "seed",
        "seed_var": "seedVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualGoop:
    def __init__(
        self,
        *,
        chaos: typing.Optional[builtins.str] = None,
        chaos_var: typing.Optional[builtins.str] = None,
        density: typing.Optional[builtins.str] = None,
        density_var: typing.Optional[builtins.str] = None,
        power: typing.Optional[builtins.str] = None,
        power_var: typing.Optional[builtins.str] = None,
        seed: typing.Optional[builtins.str] = None,
        seed_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param chaos: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        :param chaos_var: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        :param density: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        :param density_var: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        :param power: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        :param power_var: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        :param seed: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        :param seed_var: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__336176b7927532b8c04f2ef7d657f5c38efc6bc47b82ee77e49283003691e08f)
            check_type(argname="argument chaos", value=chaos, expected_type=type_hints["chaos"])
            check_type(argname="argument chaos_var", value=chaos_var, expected_type=type_hints["chaos_var"])
            check_type(argname="argument density", value=density, expected_type=type_hints["density"])
            check_type(argname="argument density_var", value=density_var, expected_type=type_hints["density_var"])
            check_type(argname="argument power", value=power, expected_type=type_hints["power"])
            check_type(argname="argument power_var", value=power_var, expected_type=type_hints["power_var"])
            check_type(argname="argument seed", value=seed, expected_type=type_hints["seed"])
            check_type(argname="argument seed_var", value=seed_var, expected_type=type_hints["seed_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if chaos is not None:
            self._values["chaos"] = chaos
        if chaos_var is not None:
            self._values["chaos_var"] = chaos_var
        if density is not None:
            self._values["density"] = density
        if density_var is not None:
            self._values["density_var"] = density_var
        if power is not None:
            self._values["power"] = power
        if power_var is not None:
            self._values["power_var"] = power_var
        if seed is not None:
            self._values["seed"] = seed
        if seed_var is not None:
            self._values["seed_var"] = seed_var

    @builtins.property
    def chaos(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        '''
        result = self._values.get("chaos")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def chaos_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        '''
        result = self._values.get("chaos_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        '''
        result = self._values.get("density")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density_var(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        '''
        result = self._values.get("density_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        '''
        result = self._values.get("power")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power_var(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        '''
        result = self._values.get("power_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        '''
        result = self._values.get("seed")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed_var(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        result = self._values.get("seed_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualGoop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualGoopList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualGoopList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b0c892967737f2c228efe7e0e7a0f183fa58ae99e8e3853c60327795aedfca28)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualGoopOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ccc0c2428c9e6e68739ee868725e7629b6b5be310ae7e2b60f9deda94d5a03d8)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualGoopOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9bdbf18bdfe613658c176e857950542d1b73c09abb6c9f35e70c7ac699c4ead0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d8d9c904ded4ab26545710022c79e7cf5db88eca38ed150b158f8114c01ee960)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1af559bb974fca5ac30186010784f6f584b9a7af59e4567a93c77b2620cbf060)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualGoop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualGoop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__74b372b17b9a4cea9499fe504eee274ce55913c8746d16949a8e8d3c97c07cab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualGoopOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualGoopOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8c17a5d16befbcc3411e112667a1a563a6d554102c3cd068558dabe82e53845f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetChaos")
    def reset_chaos(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaos", []))

    @jsii.member(jsii_name="resetChaosVar")
    def reset_chaos_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaosVar", []))

    @jsii.member(jsii_name="resetDensity")
    def reset_density(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensity", []))

    @jsii.member(jsii_name="resetDensityVar")
    def reset_density_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensityVar", []))

    @jsii.member(jsii_name="resetPower")
    def reset_power(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPower", []))

    @jsii.member(jsii_name="resetPowerVar")
    def reset_power_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPowerVar", []))

    @jsii.member(jsii_name="resetSeed")
    def reset_seed(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeed", []))

    @jsii.member(jsii_name="resetSeedVar")
    def reset_seed_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeedVar", []))

    @builtins.property
    @jsii.member(jsii_name="chaosInput")
    def chaos_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosInput"))

    @builtins.property
    @jsii.member(jsii_name="chaosVarInput")
    def chaos_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosVarInput"))

    @builtins.property
    @jsii.member(jsii_name="densityInput")
    def density_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityInput"))

    @builtins.property
    @jsii.member(jsii_name="densityVarInput")
    def density_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="powerInput")
    def power_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerInput"))

    @builtins.property
    @jsii.member(jsii_name="powerVarInput")
    def power_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerVarInput"))

    @builtins.property
    @jsii.member(jsii_name="seedInput")
    def seed_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedInput"))

    @builtins.property
    @jsii.member(jsii_name="seedVarInput")
    def seed_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedVarInput"))

    @builtins.property
    @jsii.member(jsii_name="chaos")
    def chaos(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaos"))

    @chaos.setter
    def chaos(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__88018507bafadb2d37d97f27745a67b76e1afaaf8df17dd4303b4da17ebe0f15)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaos", value)

    @builtins.property
    @jsii.member(jsii_name="chaosVar")
    def chaos_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaosVar"))

    @chaos_var.setter
    def chaos_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc1681b6a28e9dbdaa5ff8610ec6454ac969c23d35ce069a3496b56e637eced2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaosVar", value)

    @builtins.property
    @jsii.member(jsii_name="density")
    def density(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "density"))

    @density.setter
    def density(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3fff0f2d01510e05796d913a55fd1013c826027902d46159be2712e5c9e4e03b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "density", value)

    @builtins.property
    @jsii.member(jsii_name="densityVar")
    def density_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "densityVar"))

    @density_var.setter
    def density_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__404d95be12210167e0063ea92c0ae61b32a87ef7c0420430d9ef498ebcfb8697)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "densityVar", value)

    @builtins.property
    @jsii.member(jsii_name="power")
    def power(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "power"))

    @power.setter
    def power(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c0e625333d02fd5f211e174c37ba9c50aa005a363bfd4e771e0dc6e39742f834)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "power", value)

    @builtins.property
    @jsii.member(jsii_name="powerVar")
    def power_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "powerVar"))

    @power_var.setter
    def power_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ec6d146e279bcdde733b79cca76fc525d6c21852e7045119f5eeb9074393c62)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "powerVar", value)

    @builtins.property
    @jsii.member(jsii_name="seed")
    def seed(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seed"))

    @seed.setter
    def seed(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ed3fd3ef1d015b6cb83942e0056f0686123db1c304cef06737399136557b6fc3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seed", value)

    @builtins.property
    @jsii.member(jsii_name="seedVar")
    def seed_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seedVar"))

    @seed_var.setter
    def seed_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5543d22597f80f1988acc2acb06c635d70ad60ea818db659b6473a100c05f526)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seedVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualGoop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualGoop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualGoop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cbf29320dbfb7f57354991ad612cd01bf2cfc20c90c65e534579d3a19d7dc68a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualGrayscale",
    jsii_struct_bases=[],
    name_mapping={"type": "type", "type_var": "typeVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualGrayscale:
    def __init__(
        self,
        *,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param type: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__279352e3ad1d6f45bfb46a4075fbda3d9298455b9a29af86f135aef0cfbea810)
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualGrayscale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualGrayscaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualGrayscaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__475bd3900a18f9e5b799ca8b672ad3fa6ede91fc11a2ec6f334cc58a44688854)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualGrayscaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__443209be1f8a6e90d48a2a86d763e66c6b4e6bd8f3086cbe9080ea1085d2d94b)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualGrayscaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__319705fdf4894f858b8f0c0cf0c2720a7b81e80f6a292144ef540ad919626e77)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3e0f680a23a544beb3fa47f1b804ab789ba29627eb1c151e26f3439bf8240198)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fec5d4c65938802e3d68f84090f3541b99c3f063045aaf120c44280f3d23078a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualGrayscale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualGrayscale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c865ef4d35361c468e317bbde7dce6a7cc14bc8f66bc3fd09bb41e163aa83d39)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualGrayscaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualGrayscaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a9b941db556114e408bb50587a427b5d1aa8e3dc35861dc979645871c2fa4189)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e2456bf36a4ddb96f76968373455f11ad5bc5f82af15e3e0c86623c7727c06c6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f74b0d437749615b1c0266ceecc42a0d7b5b43bae0949fdb743950dfef08a2a3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualGrayscale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualGrayscale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualGrayscale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f026898208446849c5ea491480c47dea6219edbc3dbd5533f92f3ec7c70556c6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualHsl",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "lightness": "lightness",
        "lightness_var": "lightnessVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualHsl:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness: typing.Optional[builtins.str] = None,
        lightness_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        :param lightness_var: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1dee581a4b64a8b568e3b678d6a59147838c86f1e11ad2d229af4fc57e71d7ce)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness", value=lightness, expected_type=type_hints["lightness"])
            check_type(argname="argument lightness_var", value=lightness_var, expected_type=type_hints["lightness_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness is not None:
            self._values["lightness"] = lightness
        if lightness_var is not None:
            self._values["lightness_var"] = lightness_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        '''
        result = self._values.get("lightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        '''
        result = self._values.get("lightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualHsl(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualHslList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualHslList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ed821d8e88c9bd1007dbc5be87f9609a8c49c08b6590cb76407c751d81cf0e92)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualHslOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9fbe7a8e232c18fa287620f10622099d391c138fa34981c6cb25a4bb0c94e56f)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualHslOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c11082821649fd9c90d1b1b0edf1e1009c5977753101f658efb869bb99285ee7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb094bb33338b9886c30d0fea8b5b54cc3492107efb1fb310a63a645e3efb926)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d3e3d4e026b4f0cc688232bc06ba3e1bc745cc69352db7fd109b554e1510d56)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualHsl]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualHsl]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ae1cb21195ebec9c3bc4c599dad5a06977f56bfd7a0d4681a2367d8c77a33849)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualHslOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualHslOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__369a6da902e88daff95ecdd5c55a466f0c4e23c9e7a94e18f72f64202dc3ae61)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightness")
    def reset_lightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightness", []))

    @jsii.member(jsii_name="resetLightnessVar")
    def reset_lightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessInput")
    def lightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessVarInput")
    def lightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ccbd9d122931ae17395587a34d4ef3783514126ab2235d26458faa0ad0eb863)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e4034d4dbe4b073914c90741883de00ca75d34e78f9fe32fd6f5b2901e5bb1eb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightness")
    def lightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightness"))

    @lightness.setter
    def lightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a140c9c0bd4de1617f83e9f32089eeb9f14cff984576f8f343bd83520bc04d2b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightness", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessVar")
    def lightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessVar"))

    @lightness_var.setter
    def lightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__772468d4d65178b94f8d623c426f76a059b74fee438ab2c9095fdd0cba02ffba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__58825b875d4b400808b23520aa083891e27c8ed741a889fb626a535baa94eba2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__911de98db8f5f70861dd2b99c41dcec7f7852e4a93e938818738414bcb30edbb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualHsl]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualHsl]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualHsl]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2fe84e40adf7c9a4d962735d2b713014b7723f7318abfba4cff8288fe554bf1e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualHsv",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualHsv:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        :param value: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__232aa06281720e6f8c9d3e7ed2fd41fe554cb28a61d2f298cd90e56b063b49e6)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualHsv(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualHsvList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualHsvList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7de50a89f26441e9e3b8808f00949dda75385c34dd7a35ba9021a6f9828cab48)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualHsvOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__edd0653458d64d5d30d46b54d9ddf12c0aff137a6f47126599c992e48571e9d7)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualHsvOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d450f3c7fdda05d92dcc8fd6a0b7a16715db6a31288c96bcddff1c4d1f7b2075)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d1e76dde79208f9bf0450e87735c5d56a32bb23ec65711f68dd181653c71dd2f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dc8af64d67309e64b2942be18192d461878288fa261ab2b6a3b75f906e1ea385)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualHsv]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualHsv]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__65e1aeb8230670d68824f5def09bf8c3d7b0f59de978ee2ef6062ad9fcd5a66b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualHsvOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualHsvOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__552a25f90b263e1421ba4fdc5e2414e822143a1fa4fb8981eaaa4bfb141b7d4b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__efe3547d69011528bfeed445b35aa71473bdd8c3397d8552ce5220781b6b3b86)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c217c02a58510399608be3fa559c35cc8afbbe74d1c754264e078bb537a716fd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f41f945e7cdb101b8628d0ab2689d591e0248bfb3ad19db36cd2843cb7a1369e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__776a655cdc89efafcafc98ff1587a6a7fb2b40ac9c0354baa3646352fd799f7c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ed1c5c90734e8574511187e1deab286b5df9e9e44e7d7f5d13dc657957a19b9e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ef3b7091a3ea70e59c337b894787c8006f155f79bc58dd4f43c51399e91562a3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualHsv]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualHsv]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualHsv]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__956213f111975cab9731df2828e93d78c99e686741a20c131e2801604b4113ff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimension",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "dimension": "dimension",
        "dimension_var": "dimensionVar",
        "equal": "equal",
        "greater_than": "greaterThan",
        "less_than": "lessThan",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimension:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        dimension: typing.Optional[builtins.str] = None,
        dimension_var: typing.Optional[builtins.str] = None,
        equal: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionEqual", typing.Dict[builtins.str, typing.Any]]] = None,
        greater_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionGreaterThan", typing.Dict[builtins.str, typing.Any]]] = None,
        less_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionLessThan", typing.Dict[builtins.str, typing.Any]]] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param dimension: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        :param dimension_var: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        :param equal: equal block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        :param greater_than: greater_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        :param less_than: less_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        :param value: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionDefault(**default)
        if isinstance(equal, dict):
            equal = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionEqual(**equal)
        if isinstance(greater_than, dict):
            greater_than = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionGreaterThan(**greater_than)
        if isinstance(less_than, dict):
            less_than = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionLessThan(**less_than)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__81a606b5e852de5642b0216fbc90c2f3720399da5d40d3b9da5daa4ab9276cc9)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument dimension", value=dimension, expected_type=type_hints["dimension"])
            check_type(argname="argument dimension_var", value=dimension_var, expected_type=type_hints["dimension_var"])
            check_type(argname="argument equal", value=equal, expected_type=type_hints["equal"])
            check_type(argname="argument greater_than", value=greater_than, expected_type=type_hints["greater_than"])
            check_type(argname="argument less_than", value=less_than, expected_type=type_hints["less_than"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if dimension is not None:
            self._values["dimension"] = dimension
        if dimension_var is not None:
            self._values["dimension_var"] = dimension_var
        if equal is not None:
            self._values["equal"] = equal
        if greater_than is not None:
            self._values["greater_than"] = greater_than
        if less_than is not None:
            self._values["less_than"] = less_than
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionDefault"], result)

    @builtins.property
    def dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        '''
        result = self._values.get("dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        '''
        result = self._values.get("dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def equal(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionEqual"]:
        '''equal block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        '''
        result = self._values.get("equal")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionEqual"], result)

    @builtins.property
    def greater_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionGreaterThan"]:
        '''greater_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        '''
        result = self._values.get("greater_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionGreaterThan"], result)

    @builtins.property
    def less_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionLessThan"]:
        '''less_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        '''
        result = self._values.get("less_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionLessThan"], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimension(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__145b60bac96a38ebfe672c7c69ce301f911056e26462fef63340fda5d46c7577)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__38deefedb1fcda8eff239e3deeac6376c4db8a65a312eb5c49bcc9740c0b3032)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionEqual",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionEqual:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionEqual(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionEqualOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionEqualOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab084858db04e225125b11e96a770df9350f5fb3b17ac79f071351137638fe95)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionEqual], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionEqual],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d8feffe3c4fadddcde3580bf952899741f3f5c8183a1023f0c6bcd869d911710)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionGreaterThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionGreaterThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionGreaterThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionGreaterThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionGreaterThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__28e8b6600aa2e58c2d9fb7a6257b2c2369dcefdd96c6241ca1f1abbe48fa86cc)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionGreaterThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionGreaterThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__80ddc414bffb2fd309217f1975778f58b498ef0ca04cc4b8fd1a31b5bfcc8137)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionLessThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionLessThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionLessThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionLessThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionLessThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__579a36839c3fe708af3410ce4695c8bcbfc9f260b23b2b9470ff942e78c9d6cd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionLessThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionLessThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__54c27e96fcfd5a48e09aed820a6c012eb2fa12cd8aa3fe084fa588173b4d9dfe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__41b32dd886b348fdc953ba9d62a870fdf279f544f4c432deaec4a8b330004fd7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__16d4b5c95200bfc6de925efcecf766ff529fa51dc1a526347a926a68e17a08fa)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__68b57b933c256055df553a79b7dea4e81a3ec4a57b42456cca6a347d05849956)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8285d576b3f53734e40f4d49ffbede6d02ffd907e9f62e87755bbc2e0580509c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__157df7d190b0db3586a7ee7c6425afa712d997691984e482c2dd0a96b193ead1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimension]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimension]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3f30a4f8e92ee8718012cffba860d91a2ebc7351c8590d81b9df0967735bfa42)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__73eb8e230298529a7c89a539e0b15524b24e0fb50507dffe5acf7582b20671ef)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putEqual")
    def put_equal(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionEqual()

        return typing.cast(None, jsii.invoke(self, "putEqual", [value]))

    @jsii.member(jsii_name="putGreaterThan")
    def put_greater_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionGreaterThan()

        return typing.cast(None, jsii.invoke(self, "putGreaterThan", [value]))

    @jsii.member(jsii_name="putLessThan")
    def put_less_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionLessThan()

        return typing.cast(None, jsii.invoke(self, "putLessThan", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetDimension")
    def reset_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimension", []))

    @jsii.member(jsii_name="resetDimensionVar")
    def reset_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimensionVar", []))

    @jsii.member(jsii_name="resetEqual")
    def reset_equal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEqual", []))

    @jsii.member(jsii_name="resetGreaterThan")
    def reset_greater_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGreaterThan", []))

    @jsii.member(jsii_name="resetLessThan")
    def reset_less_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLessThan", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="equal")
    def equal(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionEqualOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionEqualOutputReference, jsii.get(self, "equal"))

    @builtins.property
    @jsii.member(jsii_name="greaterThan")
    def greater_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionGreaterThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionGreaterThanOutputReference, jsii.get(self, "greaterThan"))

    @builtins.property
    @jsii.member(jsii_name="lessThan")
    def less_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionLessThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionLessThanOutputReference, jsii.get(self, "lessThan"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionInput")
    def dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionVarInput")
    def dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="equalInput")
    def equal_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionEqual], jsii.get(self, "equalInput"))

    @builtins.property
    @jsii.member(jsii_name="greaterThanInput")
    def greater_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionGreaterThan], jsii.get(self, "greaterThanInput"))

    @builtins.property
    @jsii.member(jsii_name="lessThanInput")
    def less_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionLessThan], jsii.get(self, "lessThanInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="dimension")
    def dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimension"))

    @dimension.setter
    def dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__410f94ecb444d3f717cfa7edc864d0bcb8d703b5ab4e692608c08602555fb862)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimension", value)

    @builtins.property
    @jsii.member(jsii_name="dimensionVar")
    def dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimensionVar"))

    @dimension_var.setter
    def dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__34a9f6716e69a8ac30222ac2cb481a30c82873d8affaff1e39415ef886a35c3d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__677fb16e44f9b9fd26b789564982eb954021dd7cb7b47840027db051d30332ee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__36cac7c4670c8fbb41811cf08b38d21540370ab32983d673d00689eed7dbca06)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimension]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimension]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimension]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__19775ccf74a4caf2e9e2d486e446ed1561fce035b55a368059feaa06a464590b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientation",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "landscape": "landscape",
        "portrait": "portrait",
        "square": "square",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientation:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        landscape: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationLandscape", typing.Dict[builtins.str, typing.Any]]] = None,
        portrait: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationPortrait", typing.Dict[builtins.str, typing.Any]]] = None,
        square: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationSquare", typing.Dict[builtins.str, typing.Any]]] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param landscape: landscape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        :param portrait: portrait block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        :param square: square block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationDefault(**default)
        if isinstance(landscape, dict):
            landscape = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationLandscape(**landscape)
        if isinstance(portrait, dict):
            portrait = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationPortrait(**portrait)
        if isinstance(square, dict):
            square = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationSquare(**square)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9e924a714dcd544b2b74a5a97963df0a5980a061e40b51f7e76eac299b7e6d45)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument landscape", value=landscape, expected_type=type_hints["landscape"])
            check_type(argname="argument portrait", value=portrait, expected_type=type_hints["portrait"])
            check_type(argname="argument square", value=square, expected_type=type_hints["square"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if landscape is not None:
            self._values["landscape"] = landscape
        if portrait is not None:
            self._values["portrait"] = portrait
        if square is not None:
            self._values["square"] = square

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationDefault"], result)

    @builtins.property
    def landscape(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationLandscape"]:
        '''landscape block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        '''
        result = self._values.get("landscape")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationLandscape"], result)

    @builtins.property
    def portrait(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationPortrait"]:
        '''portrait block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        '''
        result = self._values.get("portrait")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationPortrait"], result)

    @builtins.property
    def square(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationSquare"]:
        '''square block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        result = self._values.get("square")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationSquare"], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7a2f22cfc29bcb19b58fbf2bd1e9e909cc659e8e3acfaa360300e922eac3b1a8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__63181f3dd24b051332c833ec36989c328033805b2581a25fd5452e17844e6650)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationLandscape",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationLandscape:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationLandscape(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationLandscapeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationLandscapeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b4a5f2e10f38f50cc279333c6e9d79ac16b300f9408c7ccc4735ad62635c1404)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationLandscape], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationLandscape],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__87b022de5f5b1c2d6652446fd866b012c726bbfb56beda837d33d0525657cd10)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0136633f1c60710e9e0e67d9ba6dd28fe9a0ca04638dc075d5b28856474bdf35)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f4ff9180fcd2593849019db5b027305ff40a7e76cb9c0edc000ce94c0f94cad8)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__17bdebb824477abbc2763888f9065fa120326891a36a5d4656c3fa713bdca2b2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1e350b7304627aa24ea639aedcb0622c687f270d28d703466d9241850315de0f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__743f4caa2acfff098b3511ff818e8c3d95fae064c7f3664e11a9a52fe7f768ff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientation]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientation]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__71d87644a073aa10af3882e2e3216268ed76c981c7a1500f0c4b7933fbc5d59e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__847351e3c1f87bde002bac40b102425c3337cb8e0ef5bf7b00ac8a8bdb26c3a5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putLandscape")
    def put_landscape(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationLandscape()

        return typing.cast(None, jsii.invoke(self, "putLandscape", [value]))

    @jsii.member(jsii_name="putPortrait")
    def put_portrait(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationPortrait()

        return typing.cast(None, jsii.invoke(self, "putPortrait", [value]))

    @jsii.member(jsii_name="putSquare")
    def put_square(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationSquare()

        return typing.cast(None, jsii.invoke(self, "putSquare", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetLandscape")
    def reset_landscape(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLandscape", []))

    @jsii.member(jsii_name="resetPortrait")
    def reset_portrait(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPortrait", []))

    @jsii.member(jsii_name="resetSquare")
    def reset_square(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSquare", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="landscape")
    def landscape(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationLandscapeOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationLandscapeOutputReference, jsii.get(self, "landscape"))

    @builtins.property
    @jsii.member(jsii_name="portrait")
    def portrait(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationPortraitOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationPortraitOutputReference", jsii.get(self, "portrait"))

    @builtins.property
    @jsii.member(jsii_name="square")
    def square(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationSquareOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationSquareOutputReference", jsii.get(self, "square"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="landscapeInput")
    def landscape_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationLandscape], jsii.get(self, "landscapeInput"))

    @builtins.property
    @jsii.member(jsii_name="portraitInput")
    def portrait_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationPortrait"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationPortrait"], jsii.get(self, "portraitInput"))

    @builtins.property
    @jsii.member(jsii_name="squareInput")
    def square_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationSquare"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationSquare"], jsii.get(self, "squareInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientation]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientation]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientation]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9f6cd26073b56134900596b493d3e55a32ccc2ddd54e9cf456ddcd2e2ff68471)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationPortrait",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationPortrait:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationPortrait(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationPortraitOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationPortraitOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f86eee80eaef9a13124099fa55f1ff6aa4ada134f1eeb0912b9bf1cd71028091)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationPortrait]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationPortrait], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationPortrait],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa62ae133ead6c9cc6c157eccdb5e4dd3db4a24a3f53696bf50f523a1026f59e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationSquare",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationSquare:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationSquare(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationSquareOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationSquareOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d00828fbd40bf6fe91b56c2453a6b485761a762b03073b469ba69361ae23ba4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationSquare]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationSquare], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationSquare],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f60ebace3671a6746add199ddc30d8ea927e9819c2055c2f727e15cbdb2f4471)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualMaxColors",
    jsii_struct_bases=[],
    name_mapping={"colors": "colors", "colors_var": "colorsVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualMaxColors:
    def __init__(
        self,
        *,
        colors: typing.Optional[builtins.str] = None,
        colors_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param colors: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        :param colors_var: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2cbf81abf7569e355df6935b79bf106966685ba586c7c29699ada2ea8fc52a3d)
            check_type(argname="argument colors", value=colors, expected_type=type_hints["colors"])
            check_type(argname="argument colors_var", value=colors_var, expected_type=type_hints["colors_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if colors is not None:
            self._values["colors"] = colors
        if colors_var is not None:
            self._values["colors_var"] = colors_var

    @builtins.property
    def colors(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        '''
        result = self._values.get("colors")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def colors_var(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        result = self._values.get("colors_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualMaxColors(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualMaxColorsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualMaxColorsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e5b40a895e340b3eacd570db776e1fcd33a13534d78bab38bed30994f8bd1da4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualMaxColorsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__239e3cb3ddbb7d11331e665d761c6d585ed0bb007c71339d1c04adc2e08941bb)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualMaxColorsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__92aef9b767c83cfca47acd2d35deaac1f612214fd2214105bfad41251bb10d12)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__92b7d0309fcb7aa9ee78186ff4a7cff3ab1fa64a96c870e68b75c3fe98878f0a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__75002e6d7bb60a1a93b88de4e263de0b7cc5fe075e4634898f5894c7cda52160)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualMaxColors]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualMaxColors]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__03f514bcce7bfb97e22af01e3fd0ea59ce27405940c764477bb2388f35a8ba87)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualMaxColorsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualMaxColorsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7b64ac344eef9e7379670c53bb1bf685b4655a6d45f17f17baeb8c6f1ea0d66b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColors")
    def reset_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColors", []))

    @jsii.member(jsii_name="resetColorsVar")
    def reset_colors_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorsVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorsInput")
    def colors_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsInput"))

    @builtins.property
    @jsii.member(jsii_name="colorsVarInput")
    def colors_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsVarInput"))

    @builtins.property
    @jsii.member(jsii_name="colors")
    def colors(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colors"))

    @colors.setter
    def colors(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cf53e7aee0de5f04bda36e60cdf05b56e61d6270a9d6d937b88d708302ce6ba2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colors", value)

    @builtins.property
    @jsii.member(jsii_name="colorsVar")
    def colors_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorsVar"))

    @colors_var.setter
    def colors_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eefbeaa57200d5740d954b8ef1e19c3be8945038ecfe238c3794feb91b4ab499)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorsVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualMaxColors]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualMaxColors]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualMaxColors]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5fcad2a4f0917001aed9113d4223af844520fabbeb66385af5328e60640aa1db)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualMirror",
    jsii_struct_bases=[],
    name_mapping={
        "horizontal": "horizontal",
        "horizontal_var": "horizontalVar",
        "vertical": "vertical",
        "vertical_var": "verticalVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualMirror:
    def __init__(
        self,
        *,
        horizontal: typing.Optional[builtins.str] = None,
        horizontal_var: typing.Optional[builtins.str] = None,
        vertical: typing.Optional[builtins.str] = None,
        vertical_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param horizontal: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        :param horizontal_var: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        :param vertical: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        :param vertical_var: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c4298dba321107849339bd84085d4dc3d184e8897cf11f9143c88078526e55c6)
            check_type(argname="argument horizontal", value=horizontal, expected_type=type_hints["horizontal"])
            check_type(argname="argument horizontal_var", value=horizontal_var, expected_type=type_hints["horizontal_var"])
            check_type(argname="argument vertical", value=vertical, expected_type=type_hints["vertical"])
            check_type(argname="argument vertical_var", value=vertical_var, expected_type=type_hints["vertical_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if horizontal is not None:
            self._values["horizontal"] = horizontal
        if horizontal_var is not None:
            self._values["horizontal_var"] = horizontal_var
        if vertical is not None:
            self._values["vertical"] = vertical
        if vertical_var is not None:
            self._values["vertical_var"] = vertical_var

    @builtins.property
    def horizontal(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        '''
        result = self._values.get("horizontal")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def horizontal_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        '''
        result = self._values.get("horizontal_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        '''
        result = self._values.get("vertical")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        result = self._values.get("vertical_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualMirror(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualMirrorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualMirrorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cf76160e0ba7b6e76f4a3c655201f609094e0f8abc8ef06cbe43684610804420)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualMirrorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f495b5eaebac595f9a8ecef950c65ba40dcbcf6279bb5b7e53838a006e1794d9)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualMirrorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__97f95fe0ee26992c006b5dd26bb108c8640eb8669ee3ae9b6ba719b2aa21b081)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd7b879803886ae51d6293055b177caf5984f296a4ace54579aa61f0546ea6d9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__22e0ef29d4a3764f21e1f0f27af2de2fa9dc60e7c101071dc62abc2cce14fd47)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualMirror]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualMirror]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f9e3b836582d8914edf2abdcdc32e1eafc02b99299c8880f9645da5867004fca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualMirrorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualMirrorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a2f6e4e03517addc0ff46020e0d207ead24dfa9256b68974e1f01fea937efaba)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHorizontal")
    def reset_horizontal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontal", []))

    @jsii.member(jsii_name="resetHorizontalVar")
    def reset_horizontal_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontalVar", []))

    @jsii.member(jsii_name="resetVertical")
    def reset_vertical(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVertical", []))

    @jsii.member(jsii_name="resetVerticalVar")
    def reset_vertical_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVerticalVar", []))

    @builtins.property
    @jsii.member(jsii_name="horizontalInput")
    def horizontal_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontalVarInput")
    def horizontal_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalInput")
    def vertical_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalVarInput")
    def vertical_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontal")
    def horizontal(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontal"))

    @horizontal.setter
    def horizontal(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__495427de4c8d6f7be20d281b28a2d3691fd48dc7d74ac0be373e70951be519aa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontal", value)

    @builtins.property
    @jsii.member(jsii_name="horizontalVar")
    def horizontal_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontalVar"))

    @horizontal_var.setter
    def horizontal_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0725313fe047af47d267dd2961f2d1b72cd251fb112e05f0df586273e99c3f78)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontalVar", value)

    @builtins.property
    @jsii.member(jsii_name="vertical")
    def vertical(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "vertical"))

    @vertical.setter
    def vertical(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__514938944d3efe16fcdc526850c9e2ace5e093d673bc3c25d869ee185bae3531)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "vertical", value)

    @builtins.property
    @jsii.member(jsii_name="verticalVar")
    def vertical_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "verticalVar"))

    @vertical_var.setter
    def vertical_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e49876a9ea1974aa38616c7f0dbd439f5113e293fb6e8e7b58653059f3d5d864)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "verticalVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualMirror]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualMirror]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualMirror]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b08b1fc42dbbbd7d1fdc09ba39832a207d739a19a2e17b25f1b98ccadea85650)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualMonoHue",
    jsii_struct_bases=[],
    name_mapping={"hue": "hue", "hue_var": "hueVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualMonoHue:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b14642c5495b843d6c47a9fb5e6720b667c6836465b465b10262a87c21dd2c9d)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualMonoHue(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualMonoHueList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualMonoHueList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__198eae6abfd010c109b00b630d8eb2619ba06e69f261cb7290161f89b08d9d66)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualMonoHueOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d3402f7cea88bacc9cbe017f948c811d060d7ef6543d7c682a878fdafe1ccb86)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualMonoHueOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b27f5b69cfb9f9db63c16e40acd809350dca6a821ab27a4486a2bb3c457c7b10)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9c1348f9ed524d1a6232ea8aa804e1e6062b0c35901093281730cbd68d6a6c37)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f3ec52c3b2d9d491a9cfd768eed2f65d66f3229e030df6877ecd07ae78414c27)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualMonoHue]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualMonoHue]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e2e834a1cd008658797b12e3516b9ae0332c66f8097d4018b79f011997614212)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualMonoHueOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualMonoHueOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bea5447eccd5029448a8dbb076dc0ca0d99abb07fb5c142bceac6374d499d026)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3238520f6d6cfdfc9bbbe92c0baf1ab3580eb69b8eeca4c7f80d8b33c8c6bab4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9eb691a567a7bc2c897ab55a8e649afbfa2bc324c283138e729b0be6d4e0363e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualMonoHue]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualMonoHue]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualMonoHue]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__83e32cf81f988410512c28c176c71cb7209815d98fb2bc6700ca7f7ae396115f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualOpacity",
    jsii_struct_bases=[],
    name_mapping={"opacity": "opacity", "opacity_var": "opacityVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualOpacity:
    def __init__(
        self,
        *,
        opacity: typing.Optional[builtins.str] = None,
        opacity_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param opacity: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param opacity_var: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1bc4ef3b1deb7006be1a82de92642621a5d3bb3ecd7c67bb9935c84ad90bb06b)
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument opacity_var", value=opacity_var, expected_type=type_hints["opacity_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if opacity is not None:
            self._values["opacity"] = opacity
        if opacity_var is not None:
            self._values["opacity_var"] = opacity_var

    @builtins.property
    def opacity(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def opacity_var(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        result = self._values.get("opacity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualOpacity(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualOpacityList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualOpacityList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d58d12194f289b83715b9d300eb717ca41e36991b866d7f4e72829eb76576cb9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualOpacityOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9dd5e24509b9d6e4806567bc5b7ed375621b6b4f75c19fd4d25462c14721b662)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualOpacityOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__61488988b78b04853b41b84c9087c9321baeebf8c81ce488c6755612de9a5512)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1409c30389627d87cb7929c4402d3967ab8cfd5f29a551d31d244ba933036268)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__30378fea24e56f72aab79fd4240abf87d926811c17cb713357223fa664f69427)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualOpacity]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualOpacity]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aaf90c02c0c04ce51b744d59198815a707bbb00f84bf165568792e92a21d13fc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualOpacityOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualOpacityOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cf34743cc25db8db98c8e894aca2a40949a7316bdcc28b062bc85cc5362a7a24)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetOpacityVar")
    def reset_opacity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacityVar", []))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityVarInput")
    def opacity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacity"))

    @opacity.setter
    def opacity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0d485ca8a6044acf62abbf1f38c82c6d0248d603465c8bbcf7b0e7d884cb0573)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacity", value)

    @builtins.property
    @jsii.member(jsii_name="opacityVar")
    def opacity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacityVar"))

    @opacity_var.setter
    def opacity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f2547face475d494d78cac571cd53c3b3a4bbae4ccdc836095031fcdb181998e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacityVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualOpacity]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualOpacity]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualOpacity]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6b00885b629c97cd86782238cddbd6b4c265dc2f9b04f8bb944efa6f0847426f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__783d2b98bb95a37d910158084c139311c8c28925b2e74e48b6f16c7267d13d83)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putBackgroundColor")
    def put_background_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1a9729a9b1b0e1a6135c07d4c1708743a5160cf77f225e766a22734b0aaf108e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBackgroundColor", [value]))

    @jsii.member(jsii_name="putBlur")
    def put_blur(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualBlur, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__70fcaebf860fb11bf450ce9ac32542c114a7b64d14fd2d985752f7e92ebe82f6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBlur", [value]))

    @jsii.member(jsii_name="putChromaKey")
    def put_chroma_key(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualChromaKey, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__21805fc5549682f35ada359a1f8c85a73af3d62acb34f527f04fbd13c1f723ee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putChromaKey", [value]))

    @jsii.member(jsii_name="putComposite")
    def put_composite(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualComposite, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fcca0ec9c35b1785022c0ba626400ac50f9948457965ea19fbb4d0d286e7fff5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putComposite", [value]))

    @jsii.member(jsii_name="putCompound")
    def put_compound(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualCompound, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b3b0453566b4e3efe9cc1d5a826fcb0486459bcdb72919286716cfbd86af371d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCompound", [value]))

    @jsii.member(jsii_name="putContrast")
    def put_contrast(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualContrast, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__88eb81a9534c1d257f9cc03364c320fc8566872006826a63c6c061e994950591)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putContrast", [value]))

    @jsii.member(jsii_name="putGoop")
    def put_goop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualGoop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7f663900115114d958a77a5e3ba7869a96e5c2a6f8c632a8cf98afb4df045815)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGoop", [value]))

    @jsii.member(jsii_name="putGrayscale")
    def put_grayscale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualGrayscale, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__17e2045fc4b926510b44b12dfac29e3b9ac7b4657793057cfd8ecb1b377347af)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGrayscale", [value]))

    @jsii.member(jsii_name="putHsl")
    def put_hsl(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualHsl, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1d6dd59a6df9f98e4713cb6f0834c702e2e1b4de0ae252d56ac37b36702c4312)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsl", [value]))

    @jsii.member(jsii_name="putHsv")
    def put_hsv(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualHsv, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a14f9b03e308968dcce52bd9bacaaafafa6406530b4d147dcb6c8c3caf2e48b5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsv", [value]))

    @jsii.member(jsii_name="putIfDimension")
    def put_if_dimension(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimension, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ad10bf9a471d18382c5c6973ca0665b8ba89c4b95bc366564f58c36d1345d61)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfDimension", [value]))

    @jsii.member(jsii_name="putIfOrientation")
    def put_if_orientation(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__91f74697027893156b3fa0d18907641564d7285f3ad2be5a6b52add7e8ba7586)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfOrientation", [value]))

    @jsii.member(jsii_name="putMaxColors")
    def put_max_colors(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualMaxColors, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7f556d395f72c42364e45a4a91282bf266ce13607ae3d61406f212967f266746)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMaxColors", [value]))

    @jsii.member(jsii_name="putMirror")
    def put_mirror(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualMirror, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cbc406eca9bf464711fd607d73f2017bc9a0039bc6427b7f5968b9e0c30dbc2f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMirror", [value]))

    @jsii.member(jsii_name="putMonoHue")
    def put_mono_hue(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualMonoHue, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8f7ac22c62d0126b8bc7395bfaaf888f4853c39e0925812c68f17bc4326e3245)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMonoHue", [value]))

    @jsii.member(jsii_name="putOpacity")
    def put_opacity(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualOpacity, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__517ecc3696aad148ae411c6c35f245400e08f97906092a87cb3773352d566af3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putOpacity", [value]))

    @jsii.member(jsii_name="putRemoveColor")
    def put_remove_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualRemoveColor", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd7c69a9d2b7d3f2fac3abcb8d82ea11a039311f7c5980cbf127b8d96ac8fa99)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRemoveColor", [value]))

    @jsii.member(jsii_name="putUnsharpMask")
    def put_unsharp_mask(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualUnsharpMask", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac3a50bca450efe8dac87b6c503aca65b7aedc04362d00041780a2160c5ba341)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putUnsharpMask", [value]))

    @jsii.member(jsii_name="resetBackgroundColor")
    def reset_background_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBackgroundColor", []))

    @jsii.member(jsii_name="resetBlur")
    def reset_blur(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBlur", []))

    @jsii.member(jsii_name="resetChromaKey")
    def reset_chroma_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChromaKey", []))

    @jsii.member(jsii_name="resetComposite")
    def reset_composite(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetComposite", []))

    @jsii.member(jsii_name="resetCompound")
    def reset_compound(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCompound", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetGoop")
    def reset_goop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGoop", []))

    @jsii.member(jsii_name="resetGrayscale")
    def reset_grayscale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGrayscale", []))

    @jsii.member(jsii_name="resetHsl")
    def reset_hsl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsl", []))

    @jsii.member(jsii_name="resetHsv")
    def reset_hsv(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsv", []))

    @jsii.member(jsii_name="resetIfDimension")
    def reset_if_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfDimension", []))

    @jsii.member(jsii_name="resetIfOrientation")
    def reset_if_orientation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfOrientation", []))

    @jsii.member(jsii_name="resetMaxColors")
    def reset_max_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxColors", []))

    @jsii.member(jsii_name="resetMirror")
    def reset_mirror(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMirror", []))

    @jsii.member(jsii_name="resetMonoHue")
    def reset_mono_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonoHue", []))

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetRemoveColor")
    def reset_remove_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRemoveColor", []))

    @jsii.member(jsii_name="resetUnsharpMask")
    def reset_unsharp_mask(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUnsharpMask", []))

    @builtins.property
    @jsii.member(jsii_name="backgroundColor")
    def background_color(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualBackgroundColorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualBackgroundColorList, jsii.get(self, "backgroundColor"))

    @builtins.property
    @jsii.member(jsii_name="blur")
    def blur(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualBlurList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualBlurList, jsii.get(self, "blur"))

    @builtins.property
    @jsii.member(jsii_name="chromaKey")
    def chroma_key(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualChromaKeyList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualChromaKeyList, jsii.get(self, "chromaKey"))

    @builtins.property
    @jsii.member(jsii_name="composite")
    def composite(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualCompositeList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualCompositeList, jsii.get(self, "composite"))

    @builtins.property
    @jsii.member(jsii_name="compound")
    def compound(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualCompoundList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualCompoundList, jsii.get(self, "compound"))

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualContrastList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualContrastList, jsii.get(self, "contrast"))

    @builtins.property
    @jsii.member(jsii_name="goop")
    def goop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualGoopList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualGoopList, jsii.get(self, "goop"))

    @builtins.property
    @jsii.member(jsii_name="grayscale")
    def grayscale(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualGrayscaleList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualGrayscaleList, jsii.get(self, "grayscale"))

    @builtins.property
    @jsii.member(jsii_name="hsl")
    def hsl(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualHslList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualHslList, jsii.get(self, "hsl"))

    @builtins.property
    @jsii.member(jsii_name="hsv")
    def hsv(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualHsvList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualHsvList, jsii.get(self, "hsv"))

    @builtins.property
    @jsii.member(jsii_name="ifDimension")
    def if_dimension(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionList, jsii.get(self, "ifDimension"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientation")
    def if_orientation(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationList, jsii.get(self, "ifOrientation"))

    @builtins.property
    @jsii.member(jsii_name="maxColors")
    def max_colors(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualMaxColorsList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualMaxColorsList, jsii.get(self, "maxColors"))

    @builtins.property
    @jsii.member(jsii_name="mirror")
    def mirror(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualMirrorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualMirrorList, jsii.get(self, "mirror"))

    @builtins.property
    @jsii.member(jsii_name="monoHue")
    def mono_hue(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualMonoHueList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualMonoHueList, jsii.get(self, "monoHue"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualOpacityList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualOpacityList, jsii.get(self, "opacity"))

    @builtins.property
    @jsii.member(jsii_name="removeColor")
    def remove_color(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualRemoveColorList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualRemoveColorList", jsii.get(self, "removeColor"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMask")
    def unsharp_mask(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualUnsharpMaskList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualUnsharpMaskList", jsii.get(self, "unsharpMask"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColorInput")
    def background_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualBackgroundColor]]], jsii.get(self, "backgroundColorInput"))

    @builtins.property
    @jsii.member(jsii_name="blurInput")
    def blur_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualBlur]]], jsii.get(self, "blurInput"))

    @builtins.property
    @jsii.member(jsii_name="chromaKeyInput")
    def chroma_key_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualChromaKey]]], jsii.get(self, "chromaKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="compositeInput")
    def composite_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualComposite]]], jsii.get(self, "compositeInput"))

    @builtins.property
    @jsii.member(jsii_name="compoundInput")
    def compound_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualCompound]]], jsii.get(self, "compoundInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualContrast]]], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="goopInput")
    def goop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualGoop]]], jsii.get(self, "goopInput"))

    @builtins.property
    @jsii.member(jsii_name="grayscaleInput")
    def grayscale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualGrayscale]]], jsii.get(self, "grayscaleInput"))

    @builtins.property
    @jsii.member(jsii_name="hslInput")
    def hsl_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualHsl]]], jsii.get(self, "hslInput"))

    @builtins.property
    @jsii.member(jsii_name="hsvInput")
    def hsv_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualHsv]]], jsii.get(self, "hsvInput"))

    @builtins.property
    @jsii.member(jsii_name="ifDimensionInput")
    def if_dimension_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimension]]], jsii.get(self, "ifDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientationInput")
    def if_orientation_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientation]]], jsii.get(self, "ifOrientationInput"))

    @builtins.property
    @jsii.member(jsii_name="maxColorsInput")
    def max_colors_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualMaxColors]]], jsii.get(self, "maxColorsInput"))

    @builtins.property
    @jsii.member(jsii_name="mirrorInput")
    def mirror_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualMirror]]], jsii.get(self, "mirrorInput"))

    @builtins.property
    @jsii.member(jsii_name="monoHueInput")
    def mono_hue_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualMonoHue]]], jsii.get(self, "monoHueInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualOpacity]]], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="removeColorInput")
    def remove_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualRemoveColor"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualRemoveColor"]]], jsii.get(self, "removeColorInput"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMaskInput")
    def unsharp_mask_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualUnsharpMask"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualUnsharpMask"]]], jsii.get(self, "unsharpMaskInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqual], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqual],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ae429b111640b28664793a01e36275a33d567ae0196a954367329104a046311)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualRemoveColor",
    jsii_struct_bases=[],
    name_mapping={
        "color": "color",
        "color_var": "colorVar",
        "feather": "feather",
        "feather_var": "featherVar",
        "tolerance": "tolerance",
        "tolerance_var": "toleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualRemoveColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
        feather: typing.Optional[builtins.str] = None,
        feather_var: typing.Optional[builtins.str] = None,
        tolerance: typing.Optional[builtins.str] = None,
        tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        :param feather: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        :param feather_var: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        :param tolerance: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        :param tolerance_var: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d3ea131693e345f0bf0fd8322a1ef03a92da16dac80a49d74640baf3189c5320)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
            check_type(argname="argument feather", value=feather, expected_type=type_hints["feather"])
            check_type(argname="argument feather_var", value=feather_var, expected_type=type_hints["feather_var"])
            check_type(argname="argument tolerance", value=tolerance, expected_type=type_hints["tolerance"])
            check_type(argname="argument tolerance_var", value=tolerance_var, expected_type=type_hints["tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var
        if feather is not None:
            self._values["feather"] = feather
        if feather_var is not None:
            self._values["feather_var"] = feather_var
        if tolerance is not None:
            self._values["tolerance"] = tolerance
        if tolerance_var is not None:
            self._values["tolerance_var"] = tolerance_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        '''
        result = self._values.get("feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather_var(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        '''
        result = self._values.get("feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        '''
        result = self._values.get("tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance_var(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        result = self._values.get("tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualRemoveColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualRemoveColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualRemoveColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9b8dbb6f81d3de323a3cd512dfd239d37e1a719293d1f0108e5d2f69749c0635)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualRemoveColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__29b733fa6094bdbe2c72a673de5d79c6ff4d85d8044005a0cb78ef181c701e36)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualRemoveColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e9a5fb6f4479d9abddf4e74e4ddbe3bc9956cd154d70e8a31c492ea76f5070a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a10869ee299b6c7f1b30d376e21aeedbc54d60845ee0bb584990328d07192b59)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cec08d251935312f9af5c3220fdbd66b7d6d34e5d4418dbf3d2c9334e3dcbb17)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualRemoveColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualRemoveColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualRemoveColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__98398684a404e5b0b7ccba846fb657ba0b531f9095983bd5f7610ebdef70afe3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualRemoveColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualRemoveColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3cde0e1950a5171e268c2ac565f673288865cb44042da6cacfae79f84cc7783c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @jsii.member(jsii_name="resetFeather")
    def reset_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeather", []))

    @jsii.member(jsii_name="resetFeatherVar")
    def reset_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatherVar", []))

    @jsii.member(jsii_name="resetTolerance")
    def reset_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTolerance", []))

    @jsii.member(jsii_name="resetToleranceVar")
    def reset_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featherInput")
    def feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherInput"))

    @builtins.property
    @jsii.member(jsii_name="featherVarInput")
    def feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceInput")
    def tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceVarInput")
    def tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7c21ec855cd61c314d3682142ab71ac1870aebfd6fc695dc6da381a62dbc1ffa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d151ea83838c900925a83a955237707de0728b4d7d849c10bf0f5aaaa02483c7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="feather")
    def feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "feather"))

    @feather.setter
    def feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8069a8fec15d16f1ec6dce1aca3aea5ed7ad0971e62d00b163955ff9856ceee7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "feather", value)

    @builtins.property
    @jsii.member(jsii_name="featherVar")
    def feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featherVar"))

    @feather_var.setter
    def feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f3def86c4234e31538dcac397ad7745655b7be4cdd59efa5af69a83317897e05)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featherVar", value)

    @builtins.property
    @jsii.member(jsii_name="tolerance")
    def tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tolerance"))

    @tolerance.setter
    def tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__90c99ac3d5ddcf4f951a0967ea3bc3e7240bbdbd2d7f17eb8f81ec05a197b14f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tolerance", value)

    @builtins.property
    @jsii.member(jsii_name="toleranceVar")
    def tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "toleranceVar"))

    @tolerance_var.setter
    def tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3bc23a87f2a4e6939087fd8a1c5ee3b3007832d21ad226fe66f2c2245f0e8ea3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "toleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualRemoveColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualRemoveColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualRemoveColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f214626d2b0835b9e8acfc1efa255e7d58a66edf9fc280001de0ec8caa546e0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualUnsharpMask",
    jsii_struct_bases=[],
    name_mapping={
        "gain": "gain",
        "gain_var": "gainVar",
        "sigma": "sigma",
        "sigma_var": "sigmaVar",
        "threshold": "threshold",
        "threshold_var": "thresholdVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualUnsharpMask:
    def __init__(
        self,
        *,
        gain: typing.Optional[builtins.str] = None,
        gain_var: typing.Optional[builtins.str] = None,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
        threshold: typing.Optional[builtins.str] = None,
        threshold_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param gain: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        :param gain_var: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        :param sigma: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        :param threshold: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        :param threshold_var: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__92264a8d6005914f3f33e32c24dca704d8364b096cca0d2394491aad3ef08f68)
            check_type(argname="argument gain", value=gain, expected_type=type_hints["gain"])
            check_type(argname="argument gain_var", value=gain_var, expected_type=type_hints["gain_var"])
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
            check_type(argname="argument threshold", value=threshold, expected_type=type_hints["threshold"])
            check_type(argname="argument threshold_var", value=threshold_var, expected_type=type_hints["threshold_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if gain is not None:
            self._values["gain"] = gain
        if gain_var is not None:
            self._values["gain_var"] = gain_var
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var
        if threshold is not None:
            self._values["threshold"] = threshold
        if threshold_var is not None:
            self._values["threshold_var"] = threshold_var

    @builtins.property
    def gain(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        '''
        result = self._values.get("gain")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gain_var(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        '''
        result = self._values.get("gain_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        '''
        result = self._values.get("threshold")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold_var(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        result = self._values.get("threshold_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualUnsharpMask(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualUnsharpMaskList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualUnsharpMaskList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a68c51564750884e7097d932a045087a4a480bc3859c81c69104e76f0214c261)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualUnsharpMaskOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9e167099ee366b7296071765483c5ac875435f8247f4a0532482aa47280c7d0b)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualUnsharpMaskOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__774a9787ffed950d30c37df633624d91278038a358a9d2589de2c6dd717df841)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b4157a1f7586a4196a592c8524c6fe22327ff4eb7cbf31cd072168102e85ce28)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e30fa9ebffda974586ae8909c23e39aba2638932d5576c8ff2d0760ef62fe7f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualUnsharpMask]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualUnsharpMask]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualUnsharpMask]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e9a156151d8fbb80990bb57e8882a511210209828704494f712fe096c1f7bc60)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualUnsharpMaskOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualUnsharpMaskOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__22ae7f53c30a7599f5e221068d04f6251bc782c40139deee74703c0aa6c96b52)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetGain")
    def reset_gain(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGain", []))

    @jsii.member(jsii_name="resetGainVar")
    def reset_gain_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGainVar", []))

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @jsii.member(jsii_name="resetThreshold")
    def reset_threshold(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThreshold", []))

    @jsii.member(jsii_name="resetThresholdVar")
    def reset_threshold_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThresholdVar", []))

    @builtins.property
    @jsii.member(jsii_name="gainInput")
    def gain_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainInput"))

    @builtins.property
    @jsii.member(jsii_name="gainVarInput")
    def gain_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdInput")
    def threshold_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdVarInput")
    def threshold_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gain")
    def gain(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gain"))

    @gain.setter
    def gain(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__552a5e5a23553ec6587ba3d59d77ae8022c519d3fbc1e5ee2b129f4a227df34b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gain", value)

    @builtins.property
    @jsii.member(jsii_name="gainVar")
    def gain_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gainVar"))

    @gain_var.setter
    def gain_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b26f3c1207c20723a8d71c615d943ecf99fbf9bde14a837ad916dde85f020b95)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gainVar", value)

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d1a3a3f06a23be662b0b734aec33b7383bf64eeaa78077df4f0c20b111cf8d74)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b14db237d741ce71aa1bb656f256a9a4659484dd09f832b487669477a36cc5e6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="threshold")
    def threshold(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "threshold"))

    @threshold.setter
    def threshold(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e4b6c17f439051ab02b8c38f3510596d4ea5d041879df85c4c6859e3741f32ce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "threshold", value)

    @builtins.property
    @jsii.member(jsii_name="thresholdVar")
    def threshold_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "thresholdVar"))

    @threshold_var.setter
    def threshold_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd148cfb7f4ef272e5af763c75876c97f681331016e161a635d2fe51fac2bf19)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "thresholdVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualUnsharpMask]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualUnsharpMask]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualUnsharpMask]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b4d25be7d101fb323d57d17ad4f29d205b80c1690b592edf1adf416e31b1105d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThan",
    jsii_struct_bases=[],
    name_mapping={
        "background_color": "backgroundColor",
        "blur": "blur",
        "chroma_key": "chromaKey",
        "composite": "composite",
        "compound": "compound",
        "contrast": "contrast",
        "goop": "goop",
        "grayscale": "grayscale",
        "hsl": "hsl",
        "hsv": "hsv",
        "if_dimension": "ifDimension",
        "if_orientation": "ifOrientation",
        "max_colors": "maxColors",
        "mirror": "mirror",
        "mono_hue": "monoHue",
        "opacity": "opacity",
        "remove_color": "removeColor",
        "unsharp_mask": "unsharpMask",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThan:
    def __init__(
        self,
        *,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanBackgroundColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanBlur", typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanChromaKey", typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanComposite", typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanCompound", typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanContrast", typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanGoop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanGrayscale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanHsl", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanHsv", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimension", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientation", typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanMaxColors", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanMirror", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanMonoHue", typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanOpacity", typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanRemoveColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanUnsharpMask", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d750cc7377205782a81268066e59b80cc48891d12302b3ed0b3b6386f4715e77)
            check_type(argname="argument background_color", value=background_color, expected_type=type_hints["background_color"])
            check_type(argname="argument blur", value=blur, expected_type=type_hints["blur"])
            check_type(argname="argument chroma_key", value=chroma_key, expected_type=type_hints["chroma_key"])
            check_type(argname="argument composite", value=composite, expected_type=type_hints["composite"])
            check_type(argname="argument compound", value=compound, expected_type=type_hints["compound"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument goop", value=goop, expected_type=type_hints["goop"])
            check_type(argname="argument grayscale", value=grayscale, expected_type=type_hints["grayscale"])
            check_type(argname="argument hsl", value=hsl, expected_type=type_hints["hsl"])
            check_type(argname="argument hsv", value=hsv, expected_type=type_hints["hsv"])
            check_type(argname="argument if_dimension", value=if_dimension, expected_type=type_hints["if_dimension"])
            check_type(argname="argument if_orientation", value=if_orientation, expected_type=type_hints["if_orientation"])
            check_type(argname="argument max_colors", value=max_colors, expected_type=type_hints["max_colors"])
            check_type(argname="argument mirror", value=mirror, expected_type=type_hints["mirror"])
            check_type(argname="argument mono_hue", value=mono_hue, expected_type=type_hints["mono_hue"])
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument remove_color", value=remove_color, expected_type=type_hints["remove_color"])
            check_type(argname="argument unsharp_mask", value=unsharp_mask, expected_type=type_hints["unsharp_mask"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if background_color is not None:
            self._values["background_color"] = background_color
        if blur is not None:
            self._values["blur"] = blur
        if chroma_key is not None:
            self._values["chroma_key"] = chroma_key
        if composite is not None:
            self._values["composite"] = composite
        if compound is not None:
            self._values["compound"] = compound
        if contrast is not None:
            self._values["contrast"] = contrast
        if goop is not None:
            self._values["goop"] = goop
        if grayscale is not None:
            self._values["grayscale"] = grayscale
        if hsl is not None:
            self._values["hsl"] = hsl
        if hsv is not None:
            self._values["hsv"] = hsv
        if if_dimension is not None:
            self._values["if_dimension"] = if_dimension
        if if_orientation is not None:
            self._values["if_orientation"] = if_orientation
        if max_colors is not None:
            self._values["max_colors"] = max_colors
        if mirror is not None:
            self._values["mirror"] = mirror
        if mono_hue is not None:
            self._values["mono_hue"] = mono_hue
        if opacity is not None:
            self._values["opacity"] = opacity
        if remove_color is not None:
            self._values["remove_color"] = remove_color
        if unsharp_mask is not None:
            self._values["unsharp_mask"] = unsharp_mask

    @builtins.property
    def background_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanBackgroundColor"]]]:
        '''background_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        '''
        result = self._values.get("background_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanBackgroundColor"]]], result)

    @builtins.property
    def blur(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanBlur"]]]:
        '''blur block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        '''
        result = self._values.get("blur")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanBlur"]]], result)

    @builtins.property
    def chroma_key(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanChromaKey"]]]:
        '''chroma_key block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        '''
        result = self._values.get("chroma_key")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanChromaKey"]]], result)

    @builtins.property
    def composite(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanComposite"]]]:
        '''composite block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        '''
        result = self._values.get("composite")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanComposite"]]], result)

    @builtins.property
    def compound(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanCompound"]]]:
        '''compound block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        '''
        result = self._values.get("compound")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanCompound"]]], result)

    @builtins.property
    def contrast(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanContrast"]]]:
        '''contrast block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanContrast"]]], result)

    @builtins.property
    def goop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanGoop"]]]:
        '''goop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        '''
        result = self._values.get("goop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanGoop"]]], result)

    @builtins.property
    def grayscale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanGrayscale"]]]:
        '''grayscale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        '''
        result = self._values.get("grayscale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanGrayscale"]]], result)

    @builtins.property
    def hsl(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanHsl"]]]:
        '''hsl block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        '''
        result = self._values.get("hsl")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanHsl"]]], result)

    @builtins.property
    def hsv(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanHsv"]]]:
        '''hsv block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        '''
        result = self._values.get("hsv")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanHsv"]]], result)

    @builtins.property
    def if_dimension(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimension"]]]:
        '''if_dimension block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        '''
        result = self._values.get("if_dimension")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimension"]]], result)

    @builtins.property
    def if_orientation(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientation"]]]:
        '''if_orientation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        '''
        result = self._values.get("if_orientation")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientation"]]], result)

    @builtins.property
    def max_colors(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanMaxColors"]]]:
        '''max_colors block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        '''
        result = self._values.get("max_colors")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanMaxColors"]]], result)

    @builtins.property
    def mirror(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanMirror"]]]:
        '''mirror block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        '''
        result = self._values.get("mirror")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanMirror"]]], result)

    @builtins.property
    def mono_hue(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanMonoHue"]]]:
        '''mono_hue block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        '''
        result = self._values.get("mono_hue")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanMonoHue"]]], result)

    @builtins.property
    def opacity(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanOpacity"]]]:
        '''opacity block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanOpacity"]]], result)

    @builtins.property
    def remove_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanRemoveColor"]]]:
        '''remove_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        '''
        result = self._values.get("remove_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanRemoveColor"]]], result)

    @builtins.property
    def unsharp_mask(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanUnsharpMask"]]]:
        '''unsharp_mask block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        result = self._values.get("unsharp_mask")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanUnsharpMask"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanBackgroundColor",
    jsii_struct_bases=[],
    name_mapping={"color": "color", "color_var": "colorVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanBackgroundColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__290bd336dcbf391fe4fd2d1c1341b00d3da61a9138a0d37deca2671df15586e1)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanBackgroundColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanBackgroundColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanBackgroundColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6919daba2acad38f340dec75ce255a73f83419891bac87804ef196913f4808b2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanBackgroundColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8e7d678ceac9b653dac2e8648853ec4b4ede71e15c083afe12c3b3ec0bf047fc)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanBackgroundColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__780da4ed51a23cfc51dc9a3d58aef1865d116daf033251a132b019f6d4490be6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__47bf1b996050a25b47fcb45d9c2fd776dc2f7a55b5a83ba28bfca03695c37305)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__303cfd6326638be22b4fc5596d5aa41c3e904fe66167ffbe102ea8dfb0c462f8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanBackgroundColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanBackgroundColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__66b3f0eb3bb7c512437ab410db608ab2dfe3c618dc7a6391af4e6904250d2725)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanBackgroundColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanBackgroundColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d4df626dc29d1adadc0d257c1c193b170b65f544849069b19cc80498beefaf27)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea98670d500bf585e65b87030212f3ed0906e9433a5cb9192740723f0663f8fe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fba93e10cdf79ec4cd5fd781138c1d0b2c1cc0c11b056663e38cdaa4e4968242)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanBackgroundColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanBackgroundColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanBackgroundColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__511569ae0b615934a1d838b6793018ae0fdb608b69360431956c87d9f2895d48)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanBlur",
    jsii_struct_bases=[],
    name_mapping={"sigma": "sigma", "sigma_var": "sigmaVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanBlur:
    def __init__(
        self,
        *,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param sigma: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cad0c260fac22ffd677743c0743ab2af2f3076108f2f591104596cc3bcef2431)
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanBlur(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanBlurList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanBlurList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb8b662b8621cd57273b38d01b37ae130a50572a7c0b20c9fcdee5f91a92f76b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanBlurOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4aca9a43c0ac59d0608c8c9776fd48de9a41f0afa93c247427b07aaf90922ca3)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanBlurOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ecbffc14810ecee99110e8f3abd4983b4e1f5841bd8af5095300e71a25e255e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a06009c55f5799dfd12d0b3a69feecb85454074f98b2242a5df48cab2feb947)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a509d4cfbd794119d2e8cd2250156ab033d79fc6177ccc8a91ffb3d76a57c200)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanBlur]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanBlur]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c03a4a4527cace6f7297fedbdaac15fac489aa6b7663210c989b5662b0c35d27)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanBlurOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanBlurOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6d1bd5c4cdf3d0f3c52af719346d1df0bc20bb92281b30a91e2b01d2ac3d6dc9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1e650182b89783032e79ea52f66815442cfca39877d27af371274e1344a99d73)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8730121515725dfe4c01a356c2dbeaa39fa07c3b9c3922945d27f3ab38c854a4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanBlur]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanBlur]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanBlur]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b9513b96fa5f8d10d57e4830e3c8e021c12597e700671319d0b6ca6a35906f6f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanChromaKey",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_feather": "hueFeather",
        "hue_feather_var": "hueFeatherVar",
        "hue_tolerance": "hueTolerance",
        "hue_tolerance_var": "hueToleranceVar",
        "hue_var": "hueVar",
        "lightness_feather": "lightnessFeather",
        "lightness_feather_var": "lightnessFeatherVar",
        "lightness_tolerance": "lightnessTolerance",
        "lightness_tolerance_var": "lightnessToleranceVar",
        "saturation_feather": "saturationFeather",
        "saturation_feather_var": "saturationFeatherVar",
        "saturation_tolerance": "saturationTolerance",
        "saturation_tolerance_var": "saturationToleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanChromaKey:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_feather: typing.Optional[builtins.str] = None,
        hue_feather_var: typing.Optional[builtins.str] = None,
        hue_tolerance: typing.Optional[builtins.str] = None,
        hue_tolerance_var: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness_feather: typing.Optional[builtins.str] = None,
        lightness_feather_var: typing.Optional[builtins.str] = None,
        lightness_tolerance: typing.Optional[builtins.str] = None,
        lightness_tolerance_var: typing.Optional[builtins.str] = None,
        saturation_feather: typing.Optional[builtins.str] = None,
        saturation_feather_var: typing.Optional[builtins.str] = None,
        saturation_tolerance: typing.Optional[builtins.str] = None,
        saturation_tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_feather: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        :param hue_feather_var: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        :param hue_tolerance: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        :param hue_tolerance_var: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        :param hue_var: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness_feather: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        :param lightness_feather_var: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        :param lightness_tolerance: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        :param lightness_tolerance_var: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        :param saturation_feather: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        :param saturation_feather_var: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        :param saturation_tolerance: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        :param saturation_tolerance_var: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2588afd0d49734d7320a9e3a0a1234acf413e76e1fb35fb73b7ea684bd60d916)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_feather", value=hue_feather, expected_type=type_hints["hue_feather"])
            check_type(argname="argument hue_feather_var", value=hue_feather_var, expected_type=type_hints["hue_feather_var"])
            check_type(argname="argument hue_tolerance", value=hue_tolerance, expected_type=type_hints["hue_tolerance"])
            check_type(argname="argument hue_tolerance_var", value=hue_tolerance_var, expected_type=type_hints["hue_tolerance_var"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness_feather", value=lightness_feather, expected_type=type_hints["lightness_feather"])
            check_type(argname="argument lightness_feather_var", value=lightness_feather_var, expected_type=type_hints["lightness_feather_var"])
            check_type(argname="argument lightness_tolerance", value=lightness_tolerance, expected_type=type_hints["lightness_tolerance"])
            check_type(argname="argument lightness_tolerance_var", value=lightness_tolerance_var, expected_type=type_hints["lightness_tolerance_var"])
            check_type(argname="argument saturation_feather", value=saturation_feather, expected_type=type_hints["saturation_feather"])
            check_type(argname="argument saturation_feather_var", value=saturation_feather_var, expected_type=type_hints["saturation_feather_var"])
            check_type(argname="argument saturation_tolerance", value=saturation_tolerance, expected_type=type_hints["saturation_tolerance"])
            check_type(argname="argument saturation_tolerance_var", value=saturation_tolerance_var, expected_type=type_hints["saturation_tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_feather is not None:
            self._values["hue_feather"] = hue_feather
        if hue_feather_var is not None:
            self._values["hue_feather_var"] = hue_feather_var
        if hue_tolerance is not None:
            self._values["hue_tolerance"] = hue_tolerance
        if hue_tolerance_var is not None:
            self._values["hue_tolerance_var"] = hue_tolerance_var
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness_feather is not None:
            self._values["lightness_feather"] = lightness_feather
        if lightness_feather_var is not None:
            self._values["lightness_feather_var"] = lightness_feather_var
        if lightness_tolerance is not None:
            self._values["lightness_tolerance"] = lightness_tolerance
        if lightness_tolerance_var is not None:
            self._values["lightness_tolerance_var"] = lightness_tolerance_var
        if saturation_feather is not None:
            self._values["saturation_feather"] = saturation_feather
        if saturation_feather_var is not None:
            self._values["saturation_feather_var"] = saturation_feather_var
        if saturation_tolerance is not None:
            self._values["saturation_tolerance"] = saturation_tolerance
        if saturation_tolerance_var is not None:
            self._values["saturation_tolerance_var"] = saturation_tolerance_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        '''
        result = self._values.get("hue_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        '''
        result = self._values.get("hue_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        '''
        result = self._values.get("hue_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        '''
        result = self._values.get("hue_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        '''
        result = self._values.get("lightness_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        '''
        result = self._values.get("lightness_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        '''
        result = self._values.get("lightness_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        '''
        result = self._values.get("lightness_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        '''
        result = self._values.get("saturation_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        '''
        result = self._values.get("saturation_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        '''
        result = self._values.get("saturation_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        result = self._values.get("saturation_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanChromaKey(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanChromaKeyList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanChromaKeyList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f0084589c2d1cfb66d159dc81f01326413534e2166a884ec64377f50434ca6bc)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanChromaKeyOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__88ca0d9a68e83063ffe58743a80c664f9c0a42d10f38391fba00924abc6293f4)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanChromaKeyOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c276884f40637b68c658b32053b712ebc39f81260c4a5f29a5485498b9b8b3ea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0d3cbe5c929d1decc7834e8e3dda12030c92718632610b6732c039511cf006ae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6ef682e2921241542ca714307fabd17847d18922f0f053e296c237662287c9f6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanChromaKey]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanChromaKey]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__36e11eeb1e9d70f3968bd9dec3ca96f9731ab3a60b4d8ca3f05c00d739ca3dfe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanChromaKeyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanChromaKeyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__704e0bb154bfc5eccece66ea7735be0bdbf5e96bf62749a03fb64fead36aeb8f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueFeather")
    def reset_hue_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeather", []))

    @jsii.member(jsii_name="resetHueFeatherVar")
    def reset_hue_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeatherVar", []))

    @jsii.member(jsii_name="resetHueTolerance")
    def reset_hue_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueTolerance", []))

    @jsii.member(jsii_name="resetHueToleranceVar")
    def reset_hue_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueToleranceVar", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightnessFeather")
    def reset_lightness_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeather", []))

    @jsii.member(jsii_name="resetLightnessFeatherVar")
    def reset_lightness_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeatherVar", []))

    @jsii.member(jsii_name="resetLightnessTolerance")
    def reset_lightness_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessTolerance", []))

    @jsii.member(jsii_name="resetLightnessToleranceVar")
    def reset_lightness_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessToleranceVar", []))

    @jsii.member(jsii_name="resetSaturationFeather")
    def reset_saturation_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeather", []))

    @jsii.member(jsii_name="resetSaturationFeatherVar")
    def reset_saturation_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeatherVar", []))

    @jsii.member(jsii_name="resetSaturationTolerance")
    def reset_saturation_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationTolerance", []))

    @jsii.member(jsii_name="resetSaturationToleranceVar")
    def reset_saturation_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherInput")
    def hue_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVarInput")
    def hue_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceInput")
    def hue_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVarInput")
    def hue_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherInput")
    def lightness_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVarInput")
    def lightness_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceInput")
    def lightness_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVarInput")
    def lightness_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherInput")
    def saturation_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVarInput")
    def saturation_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceInput")
    def saturation_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVarInput")
    def saturation_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__905b6368959633858a4e98b48bf070a2fb6a75a1217e0f3ea1c5f6b23b2b58de)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeather")
    def hue_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeather"))

    @hue_feather.setter
    def hue_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__36aa489e8d0f62170857124d6ad2aae001b8be2fea9612907c2fa9adcd0bbd42)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeather", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVar")
    def hue_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeatherVar"))

    @hue_feather_var.setter
    def hue_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ed96743a9fd413ad47ddd335e19da08db06d61c82efab9e332c60340e2bb7102)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueTolerance")
    def hue_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueTolerance"))

    @hue_tolerance.setter
    def hue_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__67df94ec41ec6f977b5afde0ae6a134fba32ff6fb5a6e769a46e2667f5716579)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVar")
    def hue_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueToleranceVar"))

    @hue_tolerance_var.setter
    def hue_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7a98d70ff83ccb7f1a5b7ff0daed48b62cf60a3594a954f01c314249656afa52)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4b436d867e0373f09893466aa1da32f588875fa7f45a29678b3d5f18618317b4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeather")
    def lightness_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeather"))

    @lightness_feather.setter
    def lightness_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b189aa93cf0905c7d428d02f6c6d811c0b4dbccd07739de8dacdc9e4731dd0ab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeather", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVar")
    def lightness_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeatherVar"))

    @lightness_feather_var.setter
    def lightness_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aba7480ee9feeff4b05f05bbcf29771212be9a6599b020d258b92a60669cc453)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessTolerance")
    def lightness_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessTolerance"))

    @lightness_tolerance.setter
    def lightness_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__60a8df7cc237e82fd1126c2de36c1fab16410b92f4c26b99dcfa2edc11b77243)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVar")
    def lightness_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessToleranceVar"))

    @lightness_tolerance_var.setter
    def lightness_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5b9cdc13963ac7e13dce848bfa2721483a8225abe41687d4652d31d08a409e38)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeather")
    def saturation_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeather"))

    @saturation_feather.setter
    def saturation_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__18ca2fe122d18e95e07d8d0990e32b25bc6b32b2a7cf5f9efc827d3ad93773fc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeather", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVar")
    def saturation_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeatherVar"))

    @saturation_feather_var.setter
    def saturation_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b97df8db75eed9773e620b2c7a0370f2d95ca2892e9107b2332c28c013df73bc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationTolerance")
    def saturation_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationTolerance"))

    @saturation_tolerance.setter
    def saturation_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b374b1ca7866e95d8a90bcdd902202b0452186b96667ca00989fc5fa44e7f8f4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVar")
    def saturation_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationToleranceVar"))

    @saturation_tolerance_var.setter
    def saturation_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ccd5b03d9f594f146314b12945fe1f0c8309620bdd9880e3fe430305fa5dba11)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanChromaKey]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanChromaKey]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanChromaKey]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d0aa47ff264ee3e9e3d1df805a6eae95cabbbb2be7219a1182112db592466271)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanComposite",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "placement": "placement",
        "placement_var": "placementVar",
        "scale": "scale",
        "scale_dimension": "scaleDimension",
        "scale_dimension_var": "scaleDimensionVar",
        "scale_var": "scaleVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanComposite:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanCompositeImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        placement: typing.Optional[builtins.str] = None,
        placement_var: typing.Optional[builtins.str] = None,
        scale: typing.Optional[builtins.str] = None,
        scale_dimension: typing.Optional[builtins.str] = None,
        scale_dimension_var: typing.Optional[builtins.str] = None,
        scale_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param placement: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        :param placement_var: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        :param scale: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param scale_dimension: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        :param scale_dimension_var: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        :param scale_var: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        :param x_position: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanCompositeImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df6e1adc933c5062d958c27edbefc60067337827d96e417d1a7c519698becf1d)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument placement", value=placement, expected_type=type_hints["placement"])
            check_type(argname="argument placement_var", value=placement_var, expected_type=type_hints["placement_var"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument scale_dimension", value=scale_dimension, expected_type=type_hints["scale_dimension"])
            check_type(argname="argument scale_dimension_var", value=scale_dimension_var, expected_type=type_hints["scale_dimension_var"])
            check_type(argname="argument scale_var", value=scale_var, expected_type=type_hints["scale_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if placement is not None:
            self._values["placement"] = placement
        if placement_var is not None:
            self._values["placement_var"] = placement_var
        if scale is not None:
            self._values["scale"] = scale
        if scale_dimension is not None:
            self._values["scale_dimension"] = scale_dimension
        if scale_dimension_var is not None:
            self._values["scale_dimension_var"] = scale_dimension_var
        if scale_var is not None:
            self._values["scale_var"] = scale_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanCompositeImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanCompositeImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        '''
        result = self._values.get("placement")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement_var(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        '''
        result = self._values.get("placement_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        '''
        result = self._values.get("scale_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        '''
        result = self._values.get("scale_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        '''
        result = self._values.get("scale_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanComposite(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanCompositeImage",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanCompositeImage:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanCompositeImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanCompositeImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanCompositeImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__07c01a7766a43f8f837fa208909ec6db23330bc9b2548bf69dca5e41fc780990)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanCompositeImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanCompositeImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aa6ad784965d2a73d3202739f012f21ff041fa1f43a4b256ebd8483453fe45a0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanCompositeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanCompositeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a2ad081a6dca0b0261d9b1e34fc578707123b862dfba16d8c7a95d7e8d767500)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanCompositeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__25c00af45b0c12eac173d361c4e4f45acea23adc93a21ebe9ea22f419f15843c)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanCompositeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__070dbe96add653c9a4368519e7e610c75a07710c2c44408c937b7c2abe6305c8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2da3f3da6f56f299df0d1ae07c0ef051a0bfd96ab841bcba30c917d1a5892811)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e5ebfe03771bc1b2d5283a277b6bbf883181e13cd8ad600c63b2369d132aaa9e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanComposite]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanComposite]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0dd4b797c99570eb69da3fe1acf84a3e0976ef8bd468793d8573fc727f24970d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanCompositeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanCompositeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fd3956ee50ff8885c06300575755f2a547c7c999b3f051452ec04b0b087705ab)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanCompositeImage()

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPlacement")
    def reset_placement(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacement", []))

    @jsii.member(jsii_name="resetPlacementVar")
    def reset_placement_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacementVar", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetScaleDimension")
    def reset_scale_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimension", []))

    @jsii.member(jsii_name="resetScaleDimensionVar")
    def reset_scale_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimensionVar", []))

    @jsii.member(jsii_name="resetScaleVar")
    def reset_scale_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanCompositeImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanCompositeImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanCompositeImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="placementInput")
    def placement_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementInput"))

    @builtins.property
    @jsii.member(jsii_name="placementVarInput")
    def placement_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionInput")
    def scale_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVarInput")
    def scale_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleVarInput")
    def scale_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__15386877b8e6858cdc3dcddfad206891a11ac17c3a49d0239601901652620d2e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__191dbadebaa1ed2ad70cb2ae3a99ad347d4b98c4501cd0941e2d7221085ce53d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="placement")
    def placement(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placement"))

    @placement.setter
    def placement(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e2a8262fd51870ff5dafd02fc80015fb8521d5a1a0ae6a3833a1ae575964ac37)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placement", value)

    @builtins.property
    @jsii.member(jsii_name="placementVar")
    def placement_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placementVar"))

    @placement_var.setter
    def placement_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ffa1e7946a1d50bb3f3e1242f399acb231f0fbf16f0fe9d567bd84852dc57454)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placementVar", value)

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scale"))

    @scale.setter
    def scale(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a332af47bb067e5b39bc470b2e75f0470db7ac64b7cc2fab7672784ce2dfbd8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scale", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimension")
    def scale_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimension"))

    @scale_dimension.setter
    def scale_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1496c4e24cf38511548d3540df04a92b07732bcc62555c24224187c64b2200a9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimension", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVar")
    def scale_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimensionVar"))

    @scale_dimension_var.setter
    def scale_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b3a767a4b4e42c26668370894b90debb28f5e73d7a1fd528d15231cfb3402358)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="scaleVar")
    def scale_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleVar"))

    @scale_var.setter
    def scale_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e1596863f0433c2f8e6fb023db082528d8cfe4a2ba7ad8960486bdb9d139610b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__04a00fb4a9c765556e99158858069a82ea330f8e25901a92f013442c95d5a42d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a867086b9b59de34b74280a752cd95f358c6f59c6d17996e07272f7e09241572)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__90eac1f39db43789776ffcbf1636e20fc81c543e55b4ccc9896c54776fc2e8a0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6cb5e33d1c872f2521f4560d2271292268ad1e479ddf226fcfba150bd726584f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanComposite]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanComposite]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanComposite]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e3115a37e4ba0d9ae595b39e5ed9e7955bfcf7269de70358ac5984c792264e72)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanCompound",
    jsii_struct_bases=[],
    name_mapping={"transformations": "transformations"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanCompound:
    def __init__(
        self,
        *,
        transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param transformations: transformations block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8e53b3b54dfc56472b41632ce3ce4ffdd2f778ce22a36d2373121622b3e752e9)
            check_type(argname="argument transformations", value=transformations, expected_type=type_hints["transformations"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if transformations is not None:
            self._values["transformations"] = transformations

    @builtins.property
    def transformations(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanCompoundTransformations"]]]:
        '''transformations block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        result = self._values.get("transformations")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanCompoundTransformations"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanCompound(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanCompoundList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanCompoundList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__196318e2e711d41238e6d228fccbddbafd98719946f32b0abc242b17c8d805ac)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanCompoundOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e9ef47de65d16278840ca332420cd76f25cf4493319085614407a3f4141dfc0c)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanCompoundOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__13a17a384a3bdb7c73a04c382ce71054ef11e473d2238978606e1069fe58e040)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ada4d9a6da7b6a6bae104197a9701227793ae3006ec739e089dbdee5fa59a611)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c5b4fc85a215bc4026c209d9a8792a06cfa4a42dc558d796a9bf1ce3f4cd3771)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanCompound]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanCompound]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ef0af3ced37270369e8e67784fde896c73e16256572d39459583c50816788804)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanCompoundOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanCompoundOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__79095bad7a8a354fecf9e60c2608be519ee4010da61db543c87853f93f91cdff)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformations")
    def put_transformations(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d0a4ff8f272d05800a59b015bc14ba03935bcc8029ad853bb2430a7a708c647f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTransformations", [value]))

    @jsii.member(jsii_name="resetTransformations")
    def reset_transformations(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformations", []))

    @builtins.property
    @jsii.member(jsii_name="transformations")
    def transformations(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanCompoundTransformationsList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanCompoundTransformationsList", jsii.get(self, "transformations"))

    @builtins.property
    @jsii.member(jsii_name="transformationsInput")
    def transformations_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanCompoundTransformations"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanCompoundTransformations"]]], jsii.get(self, "transformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanCompound]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanCompound]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanCompound]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__13f7dffa60cb8594d28bf75e382a187d20c0710a3bb0fe946047820632ff26cc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanCompoundTransformations",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanCompoundTransformations:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanCompoundTransformations(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanCompoundTransformationsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanCompoundTransformationsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9393cb5ca1c53773c8edbbe2d84e1e0d1f8c498c55ccf3bc8c6a21f044ac6d8f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanCompoundTransformationsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b80019392a47770d4fac94267c46815da978142d0fc312d48771aa73864dff01)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanCompoundTransformationsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7545691e0f9e9833d59dce1a937fd8d371c5610166987d14e291ed48a70af938)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d34863ae2eb2c34830bc2d4a71c2688f8557aa92fcf3c57f17a3c06922d43855)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7675ef4dda4539d3ef3bb5bad88666c4d33b189eb5b259d1990ce6dfef79e773)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanCompoundTransformations]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanCompoundTransformations]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanCompoundTransformations]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0978c13725a67c0c50780772a1632a7a7cc9e9e0c49f534a88361b3a2f289e0e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanCompoundTransformationsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanCompoundTransformationsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5e9f4a1046ccbae847e53da66ebf0a7cb2b81d72d58fa0b70b41d335cf3f3657)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanCompoundTransformations]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanCompoundTransformations]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanCompoundTransformations]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__071133b5ff205bc82658533f06bedabf6e9eef5fa288809359e786f1ac711b09)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanContrast",
    jsii_struct_bases=[],
    name_mapping={
        "brightness": "brightness",
        "brightness_var": "brightnessVar",
        "contrast": "contrast",
        "contrast_var": "contrastVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanContrast:
    def __init__(
        self,
        *,
        brightness: typing.Optional[builtins.str] = None,
        brightness_var: typing.Optional[builtins.str] = None,
        contrast: typing.Optional[builtins.str] = None,
        contrast_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param brightness: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        :param brightness_var: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        :param contrast: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param contrast_var: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cb74241bca3359c2cfabbb7bd511cdbe07df5f7caed4f88bb928633cb64b4fe0)
            check_type(argname="argument brightness", value=brightness, expected_type=type_hints["brightness"])
            check_type(argname="argument brightness_var", value=brightness_var, expected_type=type_hints["brightness_var"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument contrast_var", value=contrast_var, expected_type=type_hints["contrast_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if brightness is not None:
            self._values["brightness"] = brightness
        if brightness_var is not None:
            self._values["brightness_var"] = brightness_var
        if contrast is not None:
            self._values["contrast"] = contrast
        if contrast_var is not None:
            self._values["contrast_var"] = contrast_var

    @builtins.property
    def brightness(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        '''
        result = self._values.get("brightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def brightness_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        '''
        result = self._values.get("brightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        result = self._values.get("contrast_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanContrast(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanContrastList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanContrastList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a822124752975806982560c66496deb02699aaeddc2ea14f3708d7b2a4ec796d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanContrastOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c4febd0c06738a92735e1ab41a0f987cbee70449b0c5061525091072c88ed2ff)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanContrastOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__59e55916ea11e2618b63eb7ee1cac9772b8dde3f15c76967efa546a9ea91cf4e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e46f6fd539a61e9b7838397ced48a09fcae69debf2c7b2c580cf8f93e419b1fb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d6495894b912dbb4e6eff24b1d8d5b099c5d2ae686143f637a0879d6584cece3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanContrast]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanContrast]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8627639331e0e3ac06d1fdddf467300d9d9d27dedd76e37ea47afc892e652172)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanContrastOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanContrastOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e479b0e61e829ff4cac090665ee45b88be38bc3cf963cfc788f18f688b3a951c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetBrightness")
    def reset_brightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightness", []))

    @jsii.member(jsii_name="resetBrightnessVar")
    def reset_brightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightnessVar", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetContrastVar")
    def reset_contrast_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrastVar", []))

    @builtins.property
    @jsii.member(jsii_name="brightnessInput")
    def brightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="brightnessVarInput")
    def brightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastVarInput")
    def contrast_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="brightness")
    def brightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightness"))

    @brightness.setter
    def brightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__26aed966cb7bb8055922e5a45d6c245ed5a3408e6aecdfaee8b50d7d9f7a5c55)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightness", value)

    @builtins.property
    @jsii.member(jsii_name="brightnessVar")
    def brightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightnessVar"))

    @brightness_var.setter
    def brightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__51fe3f82a13f8294e9bef4387e4c4b1e48dd5b86d1607a68e8875ee33fe0b005)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrast"))

    @contrast.setter
    def contrast(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2353e69d55129b8565116c7c572cb9b4b661fbff76392c0ad6225b8cec2a6229)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrast", value)

    @builtins.property
    @jsii.member(jsii_name="contrastVar")
    def contrast_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrastVar"))

    @contrast_var.setter
    def contrast_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__da66e3bd8f478d6b0b93681d0e8973dc1f17011fc0724b52944d36001695018e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrastVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanContrast]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanContrast]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanContrast]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__773ac663c382955c8dfe8093ce61acbee9e81aaaa2d2588274f9309be3dd11f9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanGoop",
    jsii_struct_bases=[],
    name_mapping={
        "chaos": "chaos",
        "chaos_var": "chaosVar",
        "density": "density",
        "density_var": "densityVar",
        "power": "power",
        "power_var": "powerVar",
        "seed": "seed",
        "seed_var": "seedVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanGoop:
    def __init__(
        self,
        *,
        chaos: typing.Optional[builtins.str] = None,
        chaos_var: typing.Optional[builtins.str] = None,
        density: typing.Optional[builtins.str] = None,
        density_var: typing.Optional[builtins.str] = None,
        power: typing.Optional[builtins.str] = None,
        power_var: typing.Optional[builtins.str] = None,
        seed: typing.Optional[builtins.str] = None,
        seed_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param chaos: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        :param chaos_var: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        :param density: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        :param density_var: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        :param power: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        :param power_var: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        :param seed: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        :param seed_var: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__53d531cb3d92e3599ba0d20083a9d4da84d11c5d8e3f4313fec559b8504a57a2)
            check_type(argname="argument chaos", value=chaos, expected_type=type_hints["chaos"])
            check_type(argname="argument chaos_var", value=chaos_var, expected_type=type_hints["chaos_var"])
            check_type(argname="argument density", value=density, expected_type=type_hints["density"])
            check_type(argname="argument density_var", value=density_var, expected_type=type_hints["density_var"])
            check_type(argname="argument power", value=power, expected_type=type_hints["power"])
            check_type(argname="argument power_var", value=power_var, expected_type=type_hints["power_var"])
            check_type(argname="argument seed", value=seed, expected_type=type_hints["seed"])
            check_type(argname="argument seed_var", value=seed_var, expected_type=type_hints["seed_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if chaos is not None:
            self._values["chaos"] = chaos
        if chaos_var is not None:
            self._values["chaos_var"] = chaos_var
        if density is not None:
            self._values["density"] = density
        if density_var is not None:
            self._values["density_var"] = density_var
        if power is not None:
            self._values["power"] = power
        if power_var is not None:
            self._values["power_var"] = power_var
        if seed is not None:
            self._values["seed"] = seed
        if seed_var is not None:
            self._values["seed_var"] = seed_var

    @builtins.property
    def chaos(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        '''
        result = self._values.get("chaos")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def chaos_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        '''
        result = self._values.get("chaos_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        '''
        result = self._values.get("density")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density_var(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        '''
        result = self._values.get("density_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        '''
        result = self._values.get("power")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power_var(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        '''
        result = self._values.get("power_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        '''
        result = self._values.get("seed")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed_var(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        result = self._values.get("seed_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanGoop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanGoopList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanGoopList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a6b945b6b1788c5bf1d913e8dccb8170e8c1f1931bfb4521aa4c9a33459c04f9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanGoopOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__21d4f37aad7a00b6fdae68c4cac6024a29e8351b5a5af50c4d74e9ff3762198e)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanGoopOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d57a36b03d7d7c63a55b5dd9ee262bb724f11eec84439b0715cda39265a7a7be)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2587f2c33c1cdde7bd5531213fed66a6dceb1112204d32cfd8a0c74d27c69ed6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3493eed3920c277bafa3b7db7f2f3643b083bba70e845d8d9ce7f20c64016060)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanGoop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanGoop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6ffbd7951ccfdae392d057d99a83196c07d30e7763c9fb1f0a838bd8a70ede98)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanGoopOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanGoopOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f63d6eea55aebfa10b8873cc38dd3f90a4810b81856538bd92ac5524db5ffc3c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetChaos")
    def reset_chaos(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaos", []))

    @jsii.member(jsii_name="resetChaosVar")
    def reset_chaos_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaosVar", []))

    @jsii.member(jsii_name="resetDensity")
    def reset_density(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensity", []))

    @jsii.member(jsii_name="resetDensityVar")
    def reset_density_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensityVar", []))

    @jsii.member(jsii_name="resetPower")
    def reset_power(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPower", []))

    @jsii.member(jsii_name="resetPowerVar")
    def reset_power_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPowerVar", []))

    @jsii.member(jsii_name="resetSeed")
    def reset_seed(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeed", []))

    @jsii.member(jsii_name="resetSeedVar")
    def reset_seed_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeedVar", []))

    @builtins.property
    @jsii.member(jsii_name="chaosInput")
    def chaos_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosInput"))

    @builtins.property
    @jsii.member(jsii_name="chaosVarInput")
    def chaos_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosVarInput"))

    @builtins.property
    @jsii.member(jsii_name="densityInput")
    def density_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityInput"))

    @builtins.property
    @jsii.member(jsii_name="densityVarInput")
    def density_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="powerInput")
    def power_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerInput"))

    @builtins.property
    @jsii.member(jsii_name="powerVarInput")
    def power_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerVarInput"))

    @builtins.property
    @jsii.member(jsii_name="seedInput")
    def seed_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedInput"))

    @builtins.property
    @jsii.member(jsii_name="seedVarInput")
    def seed_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedVarInput"))

    @builtins.property
    @jsii.member(jsii_name="chaos")
    def chaos(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaos"))

    @chaos.setter
    def chaos(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d7bb088db598779e4a79580879f7dec1c34c51f3c401ab464e1d027cd887d3de)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaos", value)

    @builtins.property
    @jsii.member(jsii_name="chaosVar")
    def chaos_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaosVar"))

    @chaos_var.setter
    def chaos_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__19ece81cc4d8e0f191623b8351cb21ce70650a4efa339b64fcb61eab70a01263)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaosVar", value)

    @builtins.property
    @jsii.member(jsii_name="density")
    def density(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "density"))

    @density.setter
    def density(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d007ade4038118a0c66c4c3787f4282aea1dc785ebff4ff3a84900ceb7040fd0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "density", value)

    @builtins.property
    @jsii.member(jsii_name="densityVar")
    def density_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "densityVar"))

    @density_var.setter
    def density_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8df505d1d41533960cef579d8243a6aa5ba7dd707581eac78fadea4078cc1e4d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "densityVar", value)

    @builtins.property
    @jsii.member(jsii_name="power")
    def power(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "power"))

    @power.setter
    def power(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f3feb26b6d87214ff08c22f239d6af8831c32ecf57505832a0af10349411a668)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "power", value)

    @builtins.property
    @jsii.member(jsii_name="powerVar")
    def power_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "powerVar"))

    @power_var.setter
    def power_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__84fe0b7cb9b2064118ea885f43576d827c025f9bbb939dc4273fb9e1819ab840)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "powerVar", value)

    @builtins.property
    @jsii.member(jsii_name="seed")
    def seed(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seed"))

    @seed.setter
    def seed(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ad14dd81f1bb572bdabecfe837f71a372837b794b986abb1b762d22fde7f662)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seed", value)

    @builtins.property
    @jsii.member(jsii_name="seedVar")
    def seed_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seedVar"))

    @seed_var.setter
    def seed_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__743efe19498a681dbbf7f6241305960c37022719e311d9dee318c444bf20470b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seedVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanGoop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanGoop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanGoop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f3b843bf5218f2046a594b0122a3f4ad1b64f7b479370244d2dbfa8589e669cf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanGrayscale",
    jsii_struct_bases=[],
    name_mapping={"type": "type", "type_var": "typeVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanGrayscale:
    def __init__(
        self,
        *,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param type: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__09c081c653e0579e38e601b17cdfc5f2a56151cb2b22e9a9005103fc198f4182)
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanGrayscale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanGrayscaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanGrayscaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__83c756f8a9dcb986d3c518303cf98cf85b344715d400bd94725bb72d20a2fa39)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanGrayscaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bae860838249771734e4d8e9c93a3145499e957e91b9aa7f21ab86d719f2b3cd)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanGrayscaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0e6ea1d576bb901186797fed79f80dc365d023e4c2211bd0c3bf5400e004cc55)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9eac1b7466e4f30499b3f4dbcfb011bd0fbee8767ff70a78de656f7d1ca0853b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2497eac620524b234e1e969697272bc8c3088059d968b2549fcc27aa107974cb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanGrayscale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanGrayscale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0c3502ef21fd1d02acb432f014e71913b13eed8e3f26c9adacff09fa0c0365f2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanGrayscaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanGrayscaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__abc0dedbedea4a0881cff7222eb303bbbb46d2b2b3fa9a74ee1bb95d30836b54)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d28b79f33aab96db8f1ba33e71326340d92f85de252d36e0f7c7b7892478ef3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8894b7083d32f42a308c6118ddf6687264619b9e3dc39c7138047dbe1e0cfb09)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanGrayscale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanGrayscale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanGrayscale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3446430fa6831f6a08171c862d975d1bdfa6986865b3e5183baf29767ad365c9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanHsl",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "lightness": "lightness",
        "lightness_var": "lightnessVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanHsl:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness: typing.Optional[builtins.str] = None,
        lightness_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        :param lightness_var: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9eb470fce3e08abb51c4d195371ef8c0722cc2e25b50e7e081ff73ed418724fa)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness", value=lightness, expected_type=type_hints["lightness"])
            check_type(argname="argument lightness_var", value=lightness_var, expected_type=type_hints["lightness_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness is not None:
            self._values["lightness"] = lightness
        if lightness_var is not None:
            self._values["lightness_var"] = lightness_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        '''
        result = self._values.get("lightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        '''
        result = self._values.get("lightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanHsl(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanHslList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanHslList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f506424fba439676b49901f3b1f1d3cf8a79375e6892712a9b3c7cf7837bc962)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanHslOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__da5fd386f488d3edbdd3f805e851b05bcebfa6a9d49e211fc64fde7a8025e5b7)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanHslOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc488cc4ee670a01883616b9431a30d1bf4a783ee19852a4490d021583baad3d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df20ba526482826dc3501e9a84dfdb61cf516f13691e0b74f83392ed7751dacb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__75703d638f46b1c77d155705848916a031688a0cc645e7e25ebce6329da7388c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanHsl]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanHsl]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__56b8bf604d8222b90a2e981c64d91cb2046f0ffd19e62821b06c33ad8ef2f8d5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanHslOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanHslOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__24f7a160ce34b9b00a8dc801ce7a139390bc4b80f00991f2f0e0ed449084f13e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightness")
    def reset_lightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightness", []))

    @jsii.member(jsii_name="resetLightnessVar")
    def reset_lightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessInput")
    def lightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessVarInput")
    def lightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a0f4fb7e6377f5670ce453b99651552b26ce58e97206129e2247a65f1c9e9f5f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2c8dc4cbd7fddc924794f5dd12c7a04441fc0e204877fecf09b378409e40c5bd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightness")
    def lightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightness"))

    @lightness.setter
    def lightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__07145bd873240846099b61a1acda5bd0836ce4a7978091081a7a80a542a041f1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightness", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessVar")
    def lightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessVar"))

    @lightness_var.setter
    def lightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8431403213cc9acfa4ec25e5212b3a1eeffd5840a683592189c925d6d0721925)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c77d20d384be518474c622cf19891ed2d3cbbaebd35b2116579456a1fda88f95)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__82a2823ee1ea06190980e5c5bb697014357664de07989b23ceb9bf7d9b5c4c80)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanHsl]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanHsl]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanHsl]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1d112cecf4e30c44dd615943874f369e27725c34bb4b76fd9c45c3e262479598)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanHsv",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanHsv:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        :param value: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aa45ac119bb8d118c761c77b9f976d740ea4b6889ccc2b3bd77538c08259a588)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanHsv(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanHsvList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanHsvList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__470d0b34cfd1f535aa1babc126d3b8ad4a58427390d5f1c912dcef86e219e489)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanHsvOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c6a53e79f25014ba2235edbd3c38c2c6934034dbaa787a0eb2d49b3ffb151869)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanHsvOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3f5285dc9cc9538eea2337113f1f487f8cd14d2bb88e40209db3b6adde186f02)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__60c31ae393c36f34de4fbf17804faef3fbe3e1006cccd8855bd9e25046518516)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4d5a9f7de9b5501bf9f7852af91beba61105dfa0b170816a61806b06810623d8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanHsv]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanHsv]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__05b179f06ae5db0d60f22df29e5d81b4ec3d85c92a7e84e2745c82975050c84b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanHsvOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanHsvOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d551209535668e9ead7f7d8ba177fe3cda8a02a6514a2af4170838459cb90870)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2586984a72362166026ed3bb5e59171f3fd7a09c60d5fffd7aa36316be8d1de2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4dff4d4f56dd695964a388c886230729fe2691ebd8190a44e1b762567ceb7ce5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b88ffe91ad932d00e0a3b2aba5a9d42f415740538845e14ebbf92eb4bf272832)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a11de03913442e479273ab40f5de8d5009483dd9330233182132044dd1e1119)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3bc112493960a8bc2ce538e45ca417045806a31a079f51d7799497df98750cfa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5c9533506992e8c677c8f8b8e892241e1acd9dcee29dac1dfcd17339a8af6ad5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanHsv]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanHsv]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanHsv]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__864360bb1259fef3231a9e70b30d1ac97a81bf5afa056b80aed3d56e767587b4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimension",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "dimension": "dimension",
        "dimension_var": "dimensionVar",
        "equal": "equal",
        "greater_than": "greaterThan",
        "less_than": "lessThan",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimension:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        dimension: typing.Optional[builtins.str] = None,
        dimension_var: typing.Optional[builtins.str] = None,
        equal: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionEqual", typing.Dict[builtins.str, typing.Any]]] = None,
        greater_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionGreaterThan", typing.Dict[builtins.str, typing.Any]]] = None,
        less_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionLessThan", typing.Dict[builtins.str, typing.Any]]] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param dimension: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        :param dimension_var: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        :param equal: equal block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        :param greater_than: greater_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        :param less_than: less_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        :param value: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionDefault(**default)
        if isinstance(equal, dict):
            equal = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionEqual(**equal)
        if isinstance(greater_than, dict):
            greater_than = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionGreaterThan(**greater_than)
        if isinstance(less_than, dict):
            less_than = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionLessThan(**less_than)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d64da2088731108758af0d4f9e6187c56401524d187d2767cbe073040d7e0304)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument dimension", value=dimension, expected_type=type_hints["dimension"])
            check_type(argname="argument dimension_var", value=dimension_var, expected_type=type_hints["dimension_var"])
            check_type(argname="argument equal", value=equal, expected_type=type_hints["equal"])
            check_type(argname="argument greater_than", value=greater_than, expected_type=type_hints["greater_than"])
            check_type(argname="argument less_than", value=less_than, expected_type=type_hints["less_than"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if dimension is not None:
            self._values["dimension"] = dimension
        if dimension_var is not None:
            self._values["dimension_var"] = dimension_var
        if equal is not None:
            self._values["equal"] = equal
        if greater_than is not None:
            self._values["greater_than"] = greater_than
        if less_than is not None:
            self._values["less_than"] = less_than
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionDefault"], result)

    @builtins.property
    def dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        '''
        result = self._values.get("dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        '''
        result = self._values.get("dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def equal(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionEqual"]:
        '''equal block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        '''
        result = self._values.get("equal")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionEqual"], result)

    @builtins.property
    def greater_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionGreaterThan"]:
        '''greater_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        '''
        result = self._values.get("greater_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionGreaterThan"], result)

    @builtins.property
    def less_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionLessThan"]:
        '''less_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        '''
        result = self._values.get("less_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionLessThan"], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimension(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__66edc8b6f040ea47ee277f327bb466ab77a603a237b253430c524b4dc5c06c74)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ae66a154204dc5ebe745a863ee0bf15bba12c3cfcc26ca6de590cec4017c9b79)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionEqual",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionEqual:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionEqual(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionEqualOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionEqualOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b0af8ebcbec5c3d12c77451b8490df31bf7cb6264ff0aeffec5ab05674bae6bf)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionEqual], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionEqual],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7e6e038be699d32cc475c1cb06c21ef969d79401d6f17ec27ed0e3e2c93d6a56)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionGreaterThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionGreaterThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionGreaterThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionGreaterThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionGreaterThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e73115e32d521cae8e4716488e804cb2ef0b863ba9cf8514fe89dcd94e4e737f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionGreaterThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionGreaterThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f4edea749d6eb07f9338dc8e20b3dab353d7771a37068e57e390dbd90867911f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionLessThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionLessThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionLessThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionLessThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionLessThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__11bdda87b92699efa101789de7da36a3f521449bd3b878edf8e3a3549f15ec08)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionLessThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionLessThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab4aa18c0656d9db2c9d7fa64b7c82b200d01a79154d79b419f9abbe12f5959a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ef8f9eae64fe3a738e0d2dca0199eb0cafef3cefd62d70884375e59a0176a120)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__274170dbfa2d8261653ff303f5037b9b23c0a892a9123b213d47fb8ac84a0681)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7f3700d440a404021776058f8d51a8cf2a62f8d1aa661d5347e1710a39afd9d9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0685c1dd296779a9df20cc970069ff2020185e54005c30b8d5f5fc45b99396ae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__94fda1b6864a2586bc2e0b2064aea4dce16209de57f3542448b7d7d014401f27)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimension]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimension]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f098126d5546a57d734d7fc275015bd6af014e6d74c9138abb5a312845979a2a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__363208d67a89dfdb9c8aa434152da5477dead7fcc65cfa630c56542836cfdc40)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putEqual")
    def put_equal(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionEqual()

        return typing.cast(None, jsii.invoke(self, "putEqual", [value]))

    @jsii.member(jsii_name="putGreaterThan")
    def put_greater_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionGreaterThan()

        return typing.cast(None, jsii.invoke(self, "putGreaterThan", [value]))

    @jsii.member(jsii_name="putLessThan")
    def put_less_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionLessThan()

        return typing.cast(None, jsii.invoke(self, "putLessThan", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetDimension")
    def reset_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimension", []))

    @jsii.member(jsii_name="resetDimensionVar")
    def reset_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimensionVar", []))

    @jsii.member(jsii_name="resetEqual")
    def reset_equal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEqual", []))

    @jsii.member(jsii_name="resetGreaterThan")
    def reset_greater_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGreaterThan", []))

    @jsii.member(jsii_name="resetLessThan")
    def reset_less_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLessThan", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="equal")
    def equal(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionEqualOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionEqualOutputReference, jsii.get(self, "equal"))

    @builtins.property
    @jsii.member(jsii_name="greaterThan")
    def greater_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionGreaterThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionGreaterThanOutputReference, jsii.get(self, "greaterThan"))

    @builtins.property
    @jsii.member(jsii_name="lessThan")
    def less_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionLessThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionLessThanOutputReference, jsii.get(self, "lessThan"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionInput")
    def dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionVarInput")
    def dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="equalInput")
    def equal_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionEqual], jsii.get(self, "equalInput"))

    @builtins.property
    @jsii.member(jsii_name="greaterThanInput")
    def greater_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionGreaterThan], jsii.get(self, "greaterThanInput"))

    @builtins.property
    @jsii.member(jsii_name="lessThanInput")
    def less_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionLessThan], jsii.get(self, "lessThanInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="dimension")
    def dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimension"))

    @dimension.setter
    def dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__03e7d7e86655a2b95247eba8114d3256ed830de9911006b9707b3b60ef1bcd4e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimension", value)

    @builtins.property
    @jsii.member(jsii_name="dimensionVar")
    def dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimensionVar"))

    @dimension_var.setter
    def dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7ce96698e71fb291fcb268525cf0d3e27a8bfdde544df0010fab8a6c2d4e3f46)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab781a6bbf66714b8f91a5c85b5d6f8b5584b31f236d5d6ba89dc98bb28ca2bc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aaec42db0a99c73904c0d2435f88dd877633341d9266030e218c1e566a7989ba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimension]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimension]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimension]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__968acdff3415a82ee3bf4c9f034eb5181cb3205f27e44fff85cc1459e53f1926)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientation",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "landscape": "landscape",
        "portrait": "portrait",
        "square": "square",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientation:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        landscape: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationLandscape", typing.Dict[builtins.str, typing.Any]]] = None,
        portrait: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationPortrait", typing.Dict[builtins.str, typing.Any]]] = None,
        square: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationSquare", typing.Dict[builtins.str, typing.Any]]] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param landscape: landscape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        :param portrait: portrait block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        :param square: square block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationDefault(**default)
        if isinstance(landscape, dict):
            landscape = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationLandscape(**landscape)
        if isinstance(portrait, dict):
            portrait = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationPortrait(**portrait)
        if isinstance(square, dict):
            square = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationSquare(**square)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fd090ee6c69eec5d201bc66d386d0ac0fc0ced888e992dcf89d5931ad99949a8)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument landscape", value=landscape, expected_type=type_hints["landscape"])
            check_type(argname="argument portrait", value=portrait, expected_type=type_hints["portrait"])
            check_type(argname="argument square", value=square, expected_type=type_hints["square"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if landscape is not None:
            self._values["landscape"] = landscape
        if portrait is not None:
            self._values["portrait"] = portrait
        if square is not None:
            self._values["square"] = square

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationDefault"], result)

    @builtins.property
    def landscape(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationLandscape"]:
        '''landscape block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        '''
        result = self._values.get("landscape")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationLandscape"], result)

    @builtins.property
    def portrait(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationPortrait"]:
        '''portrait block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        '''
        result = self._values.get("portrait")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationPortrait"], result)

    @builtins.property
    def square(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationSquare"]:
        '''square block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        result = self._values.get("square")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationSquare"], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__44d0be8360926bd1d8ab1d554ad82174018fdb334f22242dcf23cfc76f8d20b0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fce70e0e4aa8f52bed61785d9f979ca50e87f05fbed1c1fabdaab45937c34636)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationLandscape",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationLandscape:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationLandscape(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationLandscapeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationLandscapeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df7c5a3d9cd6691fb5c1a2e20c299f72c64e489123de8600d2e5d32f0b67a91b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationLandscape], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationLandscape],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1d0a47433d038ffb969923c7f12147aa61cdf232c32f5e1a80518880a9799f41)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__adb621e39e65cb3b65b0239c6ed1b91bd476e542b9482f009b2a0144873f1a8b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3884c18c10f228273f4142761dfdec5a84827dda9b0a20a4f020919ec0a4502f)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__45cc814551a36d8bdb119950deea02f2ec747a83bc408d5f20771b9b99e3bc2c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2b646f918c10c59ad00fa06e33974bf608a414a483147e7290edd7633a4cda2d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f275b22f83b572cd1abd89101452e12f0e26b71eb12183f6c8687d2963317d7e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientation]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientation]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__95fcd445538bf79b71023437ee5a966ac5c90ec221f821a4c525af1e4d585058)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__466d7458acc590456da3840cceaf571c44900798956cf9c2ae5fbb67eb94b4c5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putLandscape")
    def put_landscape(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationLandscape()

        return typing.cast(None, jsii.invoke(self, "putLandscape", [value]))

    @jsii.member(jsii_name="putPortrait")
    def put_portrait(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationPortrait()

        return typing.cast(None, jsii.invoke(self, "putPortrait", [value]))

    @jsii.member(jsii_name="putSquare")
    def put_square(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationSquare()

        return typing.cast(None, jsii.invoke(self, "putSquare", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetLandscape")
    def reset_landscape(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLandscape", []))

    @jsii.member(jsii_name="resetPortrait")
    def reset_portrait(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPortrait", []))

    @jsii.member(jsii_name="resetSquare")
    def reset_square(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSquare", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="landscape")
    def landscape(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationLandscapeOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationLandscapeOutputReference, jsii.get(self, "landscape"))

    @builtins.property
    @jsii.member(jsii_name="portrait")
    def portrait(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationPortraitOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationPortraitOutputReference", jsii.get(self, "portrait"))

    @builtins.property
    @jsii.member(jsii_name="square")
    def square(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationSquareOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationSquareOutputReference", jsii.get(self, "square"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="landscapeInput")
    def landscape_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationLandscape], jsii.get(self, "landscapeInput"))

    @builtins.property
    @jsii.member(jsii_name="portraitInput")
    def portrait_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationPortrait"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationPortrait"], jsii.get(self, "portraitInput"))

    @builtins.property
    @jsii.member(jsii_name="squareInput")
    def square_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationSquare"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationSquare"], jsii.get(self, "squareInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientation]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientation]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientation]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3f6e8725aed59ad848ca3d97fa23461bca829d5125a8ead2e7239a3ec9528c61)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationPortrait",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationPortrait:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationPortrait(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationPortraitOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationPortraitOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a9e6f9814f901db43838974176f672d48ebc1d48d9d0df677d2f05f780d83d56)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationPortrait]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationPortrait], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationPortrait],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a71b90ade41dd38d00df15a7c2ada4d638b2a030efe25fb0c7276d676568fc9a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationSquare",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationSquare:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationSquare(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationSquareOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationSquareOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__446cc18742313004e6481b1642ac2ee5247b4971b09c873a67754a70391ea336)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationSquare]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationSquare], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationSquare],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b2042224be8fa9cc6e5e7403b6c7ba4f1b83b2fe70d9fa09ed0ab79270daaedf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanMaxColors",
    jsii_struct_bases=[],
    name_mapping={"colors": "colors", "colors_var": "colorsVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanMaxColors:
    def __init__(
        self,
        *,
        colors: typing.Optional[builtins.str] = None,
        colors_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param colors: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        :param colors_var: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__37039f16b506ee029a488d68de57e73410ea8e4e04b86fa9945a027e9defee11)
            check_type(argname="argument colors", value=colors, expected_type=type_hints["colors"])
            check_type(argname="argument colors_var", value=colors_var, expected_type=type_hints["colors_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if colors is not None:
            self._values["colors"] = colors
        if colors_var is not None:
            self._values["colors_var"] = colors_var

    @builtins.property
    def colors(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        '''
        result = self._values.get("colors")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def colors_var(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        result = self._values.get("colors_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanMaxColors(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanMaxColorsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanMaxColorsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__13743f4e80aa3093e46c0cc16bc08e0c671d7bc04f8a6862a7a4ccb5535440a2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanMaxColorsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0f6eae2f4a08d5183caa898c63c9de2c9d8cd442398fa7974966a3d277260765)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanMaxColorsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f67607b6236605b9c5fdd9970f46125e3a9056d5f4def99f12a6fc46786e516a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2cadd19d001e0197e5773984cb695114a8d2a279a77d6707d28bac4f29ed6d8e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f7f1ceb53c714a796bf0727ca20fa05ea763ba10395119085f70d0e2c0bbbb0c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanMaxColors]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanMaxColors]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__84017c6ff6caff8990a56700b416a7ac1a02f6e4aeb212c3aad20e2ed1bc3fb1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanMaxColorsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanMaxColorsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__02e89e49c7d867449b3abed69c8edbf3e3ffcba0dd5ec648e6bcda1d0db5a32a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColors")
    def reset_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColors", []))

    @jsii.member(jsii_name="resetColorsVar")
    def reset_colors_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorsVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorsInput")
    def colors_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsInput"))

    @builtins.property
    @jsii.member(jsii_name="colorsVarInput")
    def colors_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsVarInput"))

    @builtins.property
    @jsii.member(jsii_name="colors")
    def colors(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colors"))

    @colors.setter
    def colors(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__02f51fde5938acbd02010d9aaaf86519571b2414d3369fc99f7f57118e8a4fe7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colors", value)

    @builtins.property
    @jsii.member(jsii_name="colorsVar")
    def colors_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorsVar"))

    @colors_var.setter
    def colors_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4db4fde280c251a1402e6f669373e205442306f7b3dd934486ca4ef6fa894367)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorsVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanMaxColors]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanMaxColors]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanMaxColors]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cec0994d4953852a00330aec39af0d31b4dc88e9b6b4c01e966d384606049508)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanMirror",
    jsii_struct_bases=[],
    name_mapping={
        "horizontal": "horizontal",
        "horizontal_var": "horizontalVar",
        "vertical": "vertical",
        "vertical_var": "verticalVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanMirror:
    def __init__(
        self,
        *,
        horizontal: typing.Optional[builtins.str] = None,
        horizontal_var: typing.Optional[builtins.str] = None,
        vertical: typing.Optional[builtins.str] = None,
        vertical_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param horizontal: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        :param horizontal_var: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        :param vertical: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        :param vertical_var: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__49785963fd20826e409ff51d725be129b7274e98e72084bdef6aec34d0acb68c)
            check_type(argname="argument horizontal", value=horizontal, expected_type=type_hints["horizontal"])
            check_type(argname="argument horizontal_var", value=horizontal_var, expected_type=type_hints["horizontal_var"])
            check_type(argname="argument vertical", value=vertical, expected_type=type_hints["vertical"])
            check_type(argname="argument vertical_var", value=vertical_var, expected_type=type_hints["vertical_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if horizontal is not None:
            self._values["horizontal"] = horizontal
        if horizontal_var is not None:
            self._values["horizontal_var"] = horizontal_var
        if vertical is not None:
            self._values["vertical"] = vertical
        if vertical_var is not None:
            self._values["vertical_var"] = vertical_var

    @builtins.property
    def horizontal(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        '''
        result = self._values.get("horizontal")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def horizontal_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        '''
        result = self._values.get("horizontal_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        '''
        result = self._values.get("vertical")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        result = self._values.get("vertical_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanMirror(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanMirrorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanMirrorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__81ade2afb007045dc4a77b698abd90e25eb8f240ca789a448ec0580e825afee6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanMirrorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__60beb7db3d085398287ac9e32387bdf7cc3e4f0c8262395c32ee38fea6230ee0)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanMirrorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__144002ff6b6ea83ace0d693bfe89d61f786d99b8b2362fbd42c2dae76b5f9b29)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3fa0550ccfdc6f39a01f298e5959f38bc851d6880141c8d1925fb867ab9729ec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2154c1a72a83cfb8b2ac468d4ed2d774ca7be10d21b5aba3afe71ab6bc1fa043)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanMirror]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanMirror]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f822456ac9b86505cf47ba2a3c331acec3170f6b34fbd68c9d061bab898ca7b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanMirrorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanMirrorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa97a6f733f5941efed6f0d79a0765387d86382c43db4ff49767b5e11a3aec31)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHorizontal")
    def reset_horizontal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontal", []))

    @jsii.member(jsii_name="resetHorizontalVar")
    def reset_horizontal_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontalVar", []))

    @jsii.member(jsii_name="resetVertical")
    def reset_vertical(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVertical", []))

    @jsii.member(jsii_name="resetVerticalVar")
    def reset_vertical_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVerticalVar", []))

    @builtins.property
    @jsii.member(jsii_name="horizontalInput")
    def horizontal_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontalVarInput")
    def horizontal_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalInput")
    def vertical_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalVarInput")
    def vertical_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontal")
    def horizontal(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontal"))

    @horizontal.setter
    def horizontal(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6420eae380805c68b04acf553a15d9590519d72ce9f9c40d7b81741d7abbff4e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontal", value)

    @builtins.property
    @jsii.member(jsii_name="horizontalVar")
    def horizontal_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontalVar"))

    @horizontal_var.setter
    def horizontal_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3816ed20969db60b995130b5936c6ae95463cff9d4027bbc0a5f55901fc2f636)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontalVar", value)

    @builtins.property
    @jsii.member(jsii_name="vertical")
    def vertical(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "vertical"))

    @vertical.setter
    def vertical(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6c903dc0655d3b5413f289a794707bb222c5a60fa8a69cfbf6114232da54fb51)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "vertical", value)

    @builtins.property
    @jsii.member(jsii_name="verticalVar")
    def vertical_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "verticalVar"))

    @vertical_var.setter
    def vertical_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e66202f6ed2d1aa24ba91b4837716d012a09d2b887a1a860dd040df8da0113be)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "verticalVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanMirror]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanMirror]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanMirror]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__87c7ef1f21a9d41d7367785ff9a954022fb1614a01982d3153f4bf2421c9dc60)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanMonoHue",
    jsii_struct_bases=[],
    name_mapping={"hue": "hue", "hue_var": "hueVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanMonoHue:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df4677ae8b5bf7186569ab20c00d789baec71e9ab37d3dc75537afab8bbaef6a)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanMonoHue(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanMonoHueList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanMonoHueList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__53bf46bbe3dd2435c2b9da605428dfeb9b43ae4eb69c495ea0c324195b8ca1a8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanMonoHueOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ec21f6e86283c586b981bebdd3a705e0018066219d55f0c14b8cddf7f8da1eb3)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanMonoHueOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__29184365e481eb38c52fabff26560c67e30a2e7d5db7c29d9168173ee1184c60)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__69b689c735b4ff0760878a1909b40b0c5b2adfdf7066428c7b815fc96ddff6b3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__337c94b5d13ac1fa6aeba67dc37675224f4ee9190397bed11a74e25e33c739c8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanMonoHue]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanMonoHue]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8b73aa21a61a20edf452514518ac33d613b4eb179eb4b023dfd1a19b1957e396)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanMonoHueOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanMonoHueOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__143ca7237901c08ea69f29c3a5073e1419996eaed6dafdb3c09f0c374ad871a3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5d1e117313f7d132b0742936ec23a67c58f50993c26eabd9143ae949a763c524)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e88b9e3e301608e88c62481caefdda87e96fa982b49aa4be6ac93a28092af0fb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanMonoHue]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanMonoHue]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanMonoHue]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e7024d72c22ad938bd48c76567fbd8ded85a43be7e616be8c13ed1b51d2d07c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanOpacity",
    jsii_struct_bases=[],
    name_mapping={"opacity": "opacity", "opacity_var": "opacityVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanOpacity:
    def __init__(
        self,
        *,
        opacity: typing.Optional[builtins.str] = None,
        opacity_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param opacity: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param opacity_var: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6a55cee7dbcbdffd588b9f892901448452466d493ae36daa82c82a5855fce21d)
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument opacity_var", value=opacity_var, expected_type=type_hints["opacity_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if opacity is not None:
            self._values["opacity"] = opacity
        if opacity_var is not None:
            self._values["opacity_var"] = opacity_var

    @builtins.property
    def opacity(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def opacity_var(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        result = self._values.get("opacity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanOpacity(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanOpacityList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanOpacityList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b7947accb36f935098982d4e901328184a274a5135ac505b0690be0cd1440cc4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanOpacityOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3124cc30f0bb646f313014766378f7873ea38c86565928dd139c7eb010b3a82b)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanOpacityOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8f057ed77bcb78e2699ac84268c82a8b01b8e4f18c3c9a3bfa4695a13aeaebbd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__189da537e5f3cdba40f5d996b7a3c3717e262ca71d8f3de8e60882c740db95a4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__376c27bb3df64b11f02b950fd7d41d804f80fa75338e43e2278aa9d05caa9240)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanOpacity]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanOpacity]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__edc64eaefbb625a2f0852ab280af74dde992b320b474240ae9bd6cbd710f340e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanOpacityOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanOpacityOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e6fb06c7386acfebea83f2092a7b740c67828cb3fd6eed5a2ee1112579c6000)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetOpacityVar")
    def reset_opacity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacityVar", []))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityVarInput")
    def opacity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacity"))

    @opacity.setter
    def opacity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8e2ff4022f5dda2405c0ab9279ac03f0bea4457f84c0e9a1b99db65ab9e490ab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacity", value)

    @builtins.property
    @jsii.member(jsii_name="opacityVar")
    def opacity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacityVar"))

    @opacity_var.setter
    def opacity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8f2345f0e95dde31110e9708c62332a3a7b1d120360218fb5c446f421f5fd307)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacityVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanOpacity]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanOpacity]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanOpacity]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__62adf70b98ddcedabe0be6126b610c076b1427cd7277a86337ea8d77f527bb19)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__10787bcce3775be961cff49583a620f35909275a6cc4f27f2c78f54753eaa07d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putBackgroundColor")
    def put_background_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d2d59d6170f05f37121ec0934b77f41c23bda6df8bd99834d697d415b016249f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBackgroundColor", [value]))

    @jsii.member(jsii_name="putBlur")
    def put_blur(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanBlur, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__53db6e5f3abce0885fec361cd86a0a4214f18740c74b5e5823b160222d3a51df)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBlur", [value]))

    @jsii.member(jsii_name="putChromaKey")
    def put_chroma_key(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanChromaKey, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c5e451bcd21fa8bfde1ebe7c4b50d2272ceed85fb92c6885f2dd9de53de268dc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putChromaKey", [value]))

    @jsii.member(jsii_name="putComposite")
    def put_composite(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanComposite, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7411a46bf52dc16777cd4d7dc794649d4a704860fca834f7398f4b9c25204859)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putComposite", [value]))

    @jsii.member(jsii_name="putCompound")
    def put_compound(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanCompound, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__78a1ae2b07ac4b6a74579674079cdc1f200f1afbbf33deba79fa6f1acda8277b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCompound", [value]))

    @jsii.member(jsii_name="putContrast")
    def put_contrast(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanContrast, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d3f518259d18f110e6c2047e879c1407bd2317609364b12ddb99cb0f289f0901)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putContrast", [value]))

    @jsii.member(jsii_name="putGoop")
    def put_goop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanGoop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c87ed5ad3149826f0220912e9660650045f5b46a41b765dddfce215658d048de)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGoop", [value]))

    @jsii.member(jsii_name="putGrayscale")
    def put_grayscale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanGrayscale, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc387804aad7cf0dc285e2ce2d4309a338e95fba1352d0ca420dfab2ba983c76)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGrayscale", [value]))

    @jsii.member(jsii_name="putHsl")
    def put_hsl(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanHsl, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b84f0d339f60b54f8f49a5c13b09ba44be460db96e6d51a965a4c59cc4d51662)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsl", [value]))

    @jsii.member(jsii_name="putHsv")
    def put_hsv(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanHsv, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__48d6d3b504349cc2331fb9532b96ec64220af8aceb3d14db99ad39d6026e4767)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsv", [value]))

    @jsii.member(jsii_name="putIfDimension")
    def put_if_dimension(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimension, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b168afcb7eeee6fcac846abbe30e7e129193b39a59db325e49db54fb1b5be36f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfDimension", [value]))

    @jsii.member(jsii_name="putIfOrientation")
    def put_if_orientation(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e4032dc9aa3b6023b5fdc1ade84723de1cd7df01032a83f4ba685753b4fbe416)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfOrientation", [value]))

    @jsii.member(jsii_name="putMaxColors")
    def put_max_colors(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanMaxColors, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3fc165b32be09a1b5caee8b296b07b4427402ab4883cddd0696e6cf14ab02e76)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMaxColors", [value]))

    @jsii.member(jsii_name="putMirror")
    def put_mirror(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanMirror, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1ef2f7cea7358c9fd02bd6cf7796ae19dcf518d67f9f25b6cc6268fffeb79901)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMirror", [value]))

    @jsii.member(jsii_name="putMonoHue")
    def put_mono_hue(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanMonoHue, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ca9ee5b1fbb923ea802a2446a43ec9689d99c5f510f41ba755bd84959abd736a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMonoHue", [value]))

    @jsii.member(jsii_name="putOpacity")
    def put_opacity(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanOpacity, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8adf985cc6fda4f52227b25a4296bbd044c25d695ba09dba63ca0f7a6ce8fdd0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putOpacity", [value]))

    @jsii.member(jsii_name="putRemoveColor")
    def put_remove_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanRemoveColor", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4fb0830fbd72c889f51cd493dcbe465a55f71cd43dbea767ea9cd632c3acbf8c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRemoveColor", [value]))

    @jsii.member(jsii_name="putUnsharpMask")
    def put_unsharp_mask(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanUnsharpMask", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e4ff3de85cd86df7f29b2866ce385f5520dc94a7b128b061f24bf0e9f78b1391)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putUnsharpMask", [value]))

    @jsii.member(jsii_name="resetBackgroundColor")
    def reset_background_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBackgroundColor", []))

    @jsii.member(jsii_name="resetBlur")
    def reset_blur(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBlur", []))

    @jsii.member(jsii_name="resetChromaKey")
    def reset_chroma_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChromaKey", []))

    @jsii.member(jsii_name="resetComposite")
    def reset_composite(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetComposite", []))

    @jsii.member(jsii_name="resetCompound")
    def reset_compound(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCompound", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetGoop")
    def reset_goop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGoop", []))

    @jsii.member(jsii_name="resetGrayscale")
    def reset_grayscale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGrayscale", []))

    @jsii.member(jsii_name="resetHsl")
    def reset_hsl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsl", []))

    @jsii.member(jsii_name="resetHsv")
    def reset_hsv(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsv", []))

    @jsii.member(jsii_name="resetIfDimension")
    def reset_if_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfDimension", []))

    @jsii.member(jsii_name="resetIfOrientation")
    def reset_if_orientation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfOrientation", []))

    @jsii.member(jsii_name="resetMaxColors")
    def reset_max_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxColors", []))

    @jsii.member(jsii_name="resetMirror")
    def reset_mirror(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMirror", []))

    @jsii.member(jsii_name="resetMonoHue")
    def reset_mono_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonoHue", []))

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetRemoveColor")
    def reset_remove_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRemoveColor", []))

    @jsii.member(jsii_name="resetUnsharpMask")
    def reset_unsharp_mask(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUnsharpMask", []))

    @builtins.property
    @jsii.member(jsii_name="backgroundColor")
    def background_color(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanBackgroundColorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanBackgroundColorList, jsii.get(self, "backgroundColor"))

    @builtins.property
    @jsii.member(jsii_name="blur")
    def blur(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanBlurList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanBlurList, jsii.get(self, "blur"))

    @builtins.property
    @jsii.member(jsii_name="chromaKey")
    def chroma_key(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanChromaKeyList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanChromaKeyList, jsii.get(self, "chromaKey"))

    @builtins.property
    @jsii.member(jsii_name="composite")
    def composite(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanCompositeList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanCompositeList, jsii.get(self, "composite"))

    @builtins.property
    @jsii.member(jsii_name="compound")
    def compound(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanCompoundList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanCompoundList, jsii.get(self, "compound"))

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanContrastList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanContrastList, jsii.get(self, "contrast"))

    @builtins.property
    @jsii.member(jsii_name="goop")
    def goop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanGoopList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanGoopList, jsii.get(self, "goop"))

    @builtins.property
    @jsii.member(jsii_name="grayscale")
    def grayscale(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanGrayscaleList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanGrayscaleList, jsii.get(self, "grayscale"))

    @builtins.property
    @jsii.member(jsii_name="hsl")
    def hsl(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanHslList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanHslList, jsii.get(self, "hsl"))

    @builtins.property
    @jsii.member(jsii_name="hsv")
    def hsv(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanHsvList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanHsvList, jsii.get(self, "hsv"))

    @builtins.property
    @jsii.member(jsii_name="ifDimension")
    def if_dimension(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionList, jsii.get(self, "ifDimension"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientation")
    def if_orientation(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationList, jsii.get(self, "ifOrientation"))

    @builtins.property
    @jsii.member(jsii_name="maxColors")
    def max_colors(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanMaxColorsList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanMaxColorsList, jsii.get(self, "maxColors"))

    @builtins.property
    @jsii.member(jsii_name="mirror")
    def mirror(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanMirrorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanMirrorList, jsii.get(self, "mirror"))

    @builtins.property
    @jsii.member(jsii_name="monoHue")
    def mono_hue(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanMonoHueList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanMonoHueList, jsii.get(self, "monoHue"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanOpacityList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanOpacityList, jsii.get(self, "opacity"))

    @builtins.property
    @jsii.member(jsii_name="removeColor")
    def remove_color(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanRemoveColorList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanRemoveColorList", jsii.get(self, "removeColor"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMask")
    def unsharp_mask(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanUnsharpMaskList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanUnsharpMaskList", jsii.get(self, "unsharpMask"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColorInput")
    def background_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanBackgroundColor]]], jsii.get(self, "backgroundColorInput"))

    @builtins.property
    @jsii.member(jsii_name="blurInput")
    def blur_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanBlur]]], jsii.get(self, "blurInput"))

    @builtins.property
    @jsii.member(jsii_name="chromaKeyInput")
    def chroma_key_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanChromaKey]]], jsii.get(self, "chromaKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="compositeInput")
    def composite_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanComposite]]], jsii.get(self, "compositeInput"))

    @builtins.property
    @jsii.member(jsii_name="compoundInput")
    def compound_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanCompound]]], jsii.get(self, "compoundInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanContrast]]], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="goopInput")
    def goop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanGoop]]], jsii.get(self, "goopInput"))

    @builtins.property
    @jsii.member(jsii_name="grayscaleInput")
    def grayscale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanGrayscale]]], jsii.get(self, "grayscaleInput"))

    @builtins.property
    @jsii.member(jsii_name="hslInput")
    def hsl_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanHsl]]], jsii.get(self, "hslInput"))

    @builtins.property
    @jsii.member(jsii_name="hsvInput")
    def hsv_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanHsv]]], jsii.get(self, "hsvInput"))

    @builtins.property
    @jsii.member(jsii_name="ifDimensionInput")
    def if_dimension_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimension]]], jsii.get(self, "ifDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientationInput")
    def if_orientation_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientation]]], jsii.get(self, "ifOrientationInput"))

    @builtins.property
    @jsii.member(jsii_name="maxColorsInput")
    def max_colors_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanMaxColors]]], jsii.get(self, "maxColorsInput"))

    @builtins.property
    @jsii.member(jsii_name="mirrorInput")
    def mirror_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanMirror]]], jsii.get(self, "mirrorInput"))

    @builtins.property
    @jsii.member(jsii_name="monoHueInput")
    def mono_hue_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanMonoHue]]], jsii.get(self, "monoHueInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanOpacity]]], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="removeColorInput")
    def remove_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanRemoveColor"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanRemoveColor"]]], jsii.get(self, "removeColorInput"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMaskInput")
    def unsharp_mask_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanUnsharpMask"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanUnsharpMask"]]], jsii.get(self, "unsharpMaskInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__322fe2291dd519667e8d64d7f659e32acad6e59aaec26e84da85761023b0621e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanRemoveColor",
    jsii_struct_bases=[],
    name_mapping={
        "color": "color",
        "color_var": "colorVar",
        "feather": "feather",
        "feather_var": "featherVar",
        "tolerance": "tolerance",
        "tolerance_var": "toleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanRemoveColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
        feather: typing.Optional[builtins.str] = None,
        feather_var: typing.Optional[builtins.str] = None,
        tolerance: typing.Optional[builtins.str] = None,
        tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        :param feather: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        :param feather_var: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        :param tolerance: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        :param tolerance_var: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c5edb6c34c4a284d26dbb23c28f0f9d5db1f70363b279edd25e94e817094cc39)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
            check_type(argname="argument feather", value=feather, expected_type=type_hints["feather"])
            check_type(argname="argument feather_var", value=feather_var, expected_type=type_hints["feather_var"])
            check_type(argname="argument tolerance", value=tolerance, expected_type=type_hints["tolerance"])
            check_type(argname="argument tolerance_var", value=tolerance_var, expected_type=type_hints["tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var
        if feather is not None:
            self._values["feather"] = feather
        if feather_var is not None:
            self._values["feather_var"] = feather_var
        if tolerance is not None:
            self._values["tolerance"] = tolerance
        if tolerance_var is not None:
            self._values["tolerance_var"] = tolerance_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        '''
        result = self._values.get("feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather_var(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        '''
        result = self._values.get("feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        '''
        result = self._values.get("tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance_var(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        result = self._values.get("tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanRemoveColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanRemoveColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanRemoveColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dd89218fca2ac13d965cff4f991b3e2796aa6d2aba0781a15cf98be6c4699538)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanRemoveColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f96b61fa1e16ffb860756ba262c9c41cd472710d0a8c67fde75b0c93b3761cba)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanRemoveColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5eab7c090d9f2eb7568a0373a752a8ab313f1d040b7d85cf1bee4a8cc4062672)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__79999960d4fc8f322a76a1df5522891ce15e656695f3fc411502d6f7adfee2ac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fe2bc0ee46bc37862c015ef0a176de6dcadc8b485d3ebed0a29b9ba44d33f9e0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanRemoveColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanRemoveColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanRemoveColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__41cfda7325037a33c570fca0814d49de112b9b4dc92d32440ab25fb1452a0b8f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanRemoveColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanRemoveColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bf317cd9e96d30dcbbbf9cce121c6e56ea3f956d7bd6d84d51249de830fad017)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @jsii.member(jsii_name="resetFeather")
    def reset_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeather", []))

    @jsii.member(jsii_name="resetFeatherVar")
    def reset_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatherVar", []))

    @jsii.member(jsii_name="resetTolerance")
    def reset_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTolerance", []))

    @jsii.member(jsii_name="resetToleranceVar")
    def reset_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featherInput")
    def feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherInput"))

    @builtins.property
    @jsii.member(jsii_name="featherVarInput")
    def feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceInput")
    def tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceVarInput")
    def tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8212c23080f741ac693538c15fa3b3ef3c61e774a685fb6395844f02c56dbe03)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e3ac4ee6192ece59eeeeb15e724c9dcc484556bb8905f2dff1babfaf0d562cc6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="feather")
    def feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "feather"))

    @feather.setter
    def feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9062d0dfd5e1fe744ea82213dc33c294f5a0d12548930ccc56b9cf202f0cb1f1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "feather", value)

    @builtins.property
    @jsii.member(jsii_name="featherVar")
    def feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featherVar"))

    @feather_var.setter
    def feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a1074166d84b337fcbe245580481395b19cd7dca62d639ede28b9d1130e0de9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featherVar", value)

    @builtins.property
    @jsii.member(jsii_name="tolerance")
    def tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tolerance"))

    @tolerance.setter
    def tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a17c3f6ba0d06390d0e67589319a5615a8bb5c6a7ef7a8729585a3f0c50ee96)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tolerance", value)

    @builtins.property
    @jsii.member(jsii_name="toleranceVar")
    def tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "toleranceVar"))

    @tolerance_var.setter
    def tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4f41ca9c56d3ae2d845a4c0a9abce6a45a67acc6367fce858fbace50b7846bc9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "toleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanRemoveColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanRemoveColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanRemoveColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ff7ce1a41ddd3622994872aefbf91eace0fdaebd15364cfa952ed617aca61fb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanUnsharpMask",
    jsii_struct_bases=[],
    name_mapping={
        "gain": "gain",
        "gain_var": "gainVar",
        "sigma": "sigma",
        "sigma_var": "sigmaVar",
        "threshold": "threshold",
        "threshold_var": "thresholdVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanUnsharpMask:
    def __init__(
        self,
        *,
        gain: typing.Optional[builtins.str] = None,
        gain_var: typing.Optional[builtins.str] = None,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
        threshold: typing.Optional[builtins.str] = None,
        threshold_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param gain: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        :param gain_var: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        :param sigma: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        :param threshold: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        :param threshold_var: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__87ab5b5b3ad88b9f8e021152df6e8f7d5aa4ab7a68b19ffda47d57733483cd4f)
            check_type(argname="argument gain", value=gain, expected_type=type_hints["gain"])
            check_type(argname="argument gain_var", value=gain_var, expected_type=type_hints["gain_var"])
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
            check_type(argname="argument threshold", value=threshold, expected_type=type_hints["threshold"])
            check_type(argname="argument threshold_var", value=threshold_var, expected_type=type_hints["threshold_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if gain is not None:
            self._values["gain"] = gain
        if gain_var is not None:
            self._values["gain_var"] = gain_var
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var
        if threshold is not None:
            self._values["threshold"] = threshold
        if threshold_var is not None:
            self._values["threshold_var"] = threshold_var

    @builtins.property
    def gain(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        '''
        result = self._values.get("gain")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gain_var(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        '''
        result = self._values.get("gain_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        '''
        result = self._values.get("threshold")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold_var(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        result = self._values.get("threshold_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanUnsharpMask(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanUnsharpMaskList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanUnsharpMaskList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__76781b9d0e16eee818facc181ce5b7943e94b670af70bba93ce1ea93738ae7c3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanUnsharpMaskOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__83a61337d36b3d2b491fd41de8db34b4125799c3209add84fc21c7a45db77589)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanUnsharpMaskOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d80d505a0ee5482111b80e6a0dd43cb35564d48f0460bb6b6b927513dd122742)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__11488edd635dbba30cc57af7bce9be700fdeb4192936d620d54082d7d888f8d3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__15d1c58d028d709f48d770f6515990a1c479a6eb4c1977bdf89ec622f3c04a36)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanUnsharpMask]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanUnsharpMask]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanUnsharpMask]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a0b751ab5a0ca05506c59c99c2152aaa7d4f1fb5bd69f30f2f85aa27bc76215e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanUnsharpMaskOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanUnsharpMaskOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1a35234cbd548b253d79d6c1db6490c784fad2a74ced77dfccfba4db80913b1a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetGain")
    def reset_gain(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGain", []))

    @jsii.member(jsii_name="resetGainVar")
    def reset_gain_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGainVar", []))

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @jsii.member(jsii_name="resetThreshold")
    def reset_threshold(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThreshold", []))

    @jsii.member(jsii_name="resetThresholdVar")
    def reset_threshold_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThresholdVar", []))

    @builtins.property
    @jsii.member(jsii_name="gainInput")
    def gain_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainInput"))

    @builtins.property
    @jsii.member(jsii_name="gainVarInput")
    def gain_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdInput")
    def threshold_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdVarInput")
    def threshold_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gain")
    def gain(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gain"))

    @gain.setter
    def gain(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f7d166c5d5485dd4f978093583c792615c2988ee1f907b8816e9bf389d4a24a8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gain", value)

    @builtins.property
    @jsii.member(jsii_name="gainVar")
    def gain_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gainVar"))

    @gain_var.setter
    def gain_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__15d925e539ad0292cb27d4a135ab74f47c9920cc6de86620a32f107dbba98ff2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gainVar", value)

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__22ea21e9866c0c9c42c1676d699e5156da109829fa4a070713a2d1174ee1f50c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e3131a3bcb92d2a1d59fdb27777466b0981569f2fc119d5dc6e909601d6ed44e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="threshold")
    def threshold(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "threshold"))

    @threshold.setter
    def threshold(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ef78b0996904906cb574057e594f632e95533e3de5fcb5eefffcf07952429077)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "threshold", value)

    @builtins.property
    @jsii.member(jsii_name="thresholdVar")
    def threshold_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "thresholdVar"))

    @threshold_var.setter
    def threshold_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6316a49c9b4cbb992fcc61505961a8bffcbc17e8c8df616957af9101c2571dbd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "thresholdVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanUnsharpMask]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanUnsharpMask]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanUnsharpMask]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5b9a0bb5b92215697415abd19dd39fa122d3658900278fbcc25e247a27497cbd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThan",
    jsii_struct_bases=[],
    name_mapping={
        "background_color": "backgroundColor",
        "blur": "blur",
        "chroma_key": "chromaKey",
        "composite": "composite",
        "compound": "compound",
        "contrast": "contrast",
        "goop": "goop",
        "grayscale": "grayscale",
        "hsl": "hsl",
        "hsv": "hsv",
        "if_dimension": "ifDimension",
        "if_orientation": "ifOrientation",
        "max_colors": "maxColors",
        "mirror": "mirror",
        "mono_hue": "monoHue",
        "opacity": "opacity",
        "remove_color": "removeColor",
        "unsharp_mask": "unsharpMask",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThan:
    def __init__(
        self,
        *,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanBackgroundColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanBlur", typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanChromaKey", typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanComposite", typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanCompound", typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanContrast", typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanGoop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanGrayscale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanHsl", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanHsv", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfDimension", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientation", typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanMaxColors", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanMirror", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanMonoHue", typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanOpacity", typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanRemoveColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanUnsharpMask", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f164c6abea37353234d6dcf634a24392fefa933c4a543537aedac7b23de1e9fb)
            check_type(argname="argument background_color", value=background_color, expected_type=type_hints["background_color"])
            check_type(argname="argument blur", value=blur, expected_type=type_hints["blur"])
            check_type(argname="argument chroma_key", value=chroma_key, expected_type=type_hints["chroma_key"])
            check_type(argname="argument composite", value=composite, expected_type=type_hints["composite"])
            check_type(argname="argument compound", value=compound, expected_type=type_hints["compound"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument goop", value=goop, expected_type=type_hints["goop"])
            check_type(argname="argument grayscale", value=grayscale, expected_type=type_hints["grayscale"])
            check_type(argname="argument hsl", value=hsl, expected_type=type_hints["hsl"])
            check_type(argname="argument hsv", value=hsv, expected_type=type_hints["hsv"])
            check_type(argname="argument if_dimension", value=if_dimension, expected_type=type_hints["if_dimension"])
            check_type(argname="argument if_orientation", value=if_orientation, expected_type=type_hints["if_orientation"])
            check_type(argname="argument max_colors", value=max_colors, expected_type=type_hints["max_colors"])
            check_type(argname="argument mirror", value=mirror, expected_type=type_hints["mirror"])
            check_type(argname="argument mono_hue", value=mono_hue, expected_type=type_hints["mono_hue"])
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument remove_color", value=remove_color, expected_type=type_hints["remove_color"])
            check_type(argname="argument unsharp_mask", value=unsharp_mask, expected_type=type_hints["unsharp_mask"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if background_color is not None:
            self._values["background_color"] = background_color
        if blur is not None:
            self._values["blur"] = blur
        if chroma_key is not None:
            self._values["chroma_key"] = chroma_key
        if composite is not None:
            self._values["composite"] = composite
        if compound is not None:
            self._values["compound"] = compound
        if contrast is not None:
            self._values["contrast"] = contrast
        if goop is not None:
            self._values["goop"] = goop
        if grayscale is not None:
            self._values["grayscale"] = grayscale
        if hsl is not None:
            self._values["hsl"] = hsl
        if hsv is not None:
            self._values["hsv"] = hsv
        if if_dimension is not None:
            self._values["if_dimension"] = if_dimension
        if if_orientation is not None:
            self._values["if_orientation"] = if_orientation
        if max_colors is not None:
            self._values["max_colors"] = max_colors
        if mirror is not None:
            self._values["mirror"] = mirror
        if mono_hue is not None:
            self._values["mono_hue"] = mono_hue
        if opacity is not None:
            self._values["opacity"] = opacity
        if remove_color is not None:
            self._values["remove_color"] = remove_color
        if unsharp_mask is not None:
            self._values["unsharp_mask"] = unsharp_mask

    @builtins.property
    def background_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanBackgroundColor"]]]:
        '''background_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        '''
        result = self._values.get("background_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanBackgroundColor"]]], result)

    @builtins.property
    def blur(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanBlur"]]]:
        '''blur block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        '''
        result = self._values.get("blur")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanBlur"]]], result)

    @builtins.property
    def chroma_key(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanChromaKey"]]]:
        '''chroma_key block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        '''
        result = self._values.get("chroma_key")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanChromaKey"]]], result)

    @builtins.property
    def composite(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanComposite"]]]:
        '''composite block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        '''
        result = self._values.get("composite")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanComposite"]]], result)

    @builtins.property
    def compound(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanCompound"]]]:
        '''compound block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        '''
        result = self._values.get("compound")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanCompound"]]], result)

    @builtins.property
    def contrast(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanContrast"]]]:
        '''contrast block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanContrast"]]], result)

    @builtins.property
    def goop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanGoop"]]]:
        '''goop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        '''
        result = self._values.get("goop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanGoop"]]], result)

    @builtins.property
    def grayscale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanGrayscale"]]]:
        '''grayscale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        '''
        result = self._values.get("grayscale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanGrayscale"]]], result)

    @builtins.property
    def hsl(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanHsl"]]]:
        '''hsl block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        '''
        result = self._values.get("hsl")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanHsl"]]], result)

    @builtins.property
    def hsv(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanHsv"]]]:
        '''hsv block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        '''
        result = self._values.get("hsv")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanHsv"]]], result)

    @builtins.property
    def if_dimension(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfDimension"]]]:
        '''if_dimension block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        '''
        result = self._values.get("if_dimension")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfDimension"]]], result)

    @builtins.property
    def if_orientation(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientation"]]]:
        '''if_orientation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        '''
        result = self._values.get("if_orientation")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientation"]]], result)

    @builtins.property
    def max_colors(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanMaxColors"]]]:
        '''max_colors block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        '''
        result = self._values.get("max_colors")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanMaxColors"]]], result)

    @builtins.property
    def mirror(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanMirror"]]]:
        '''mirror block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        '''
        result = self._values.get("mirror")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanMirror"]]], result)

    @builtins.property
    def mono_hue(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanMonoHue"]]]:
        '''mono_hue block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        '''
        result = self._values.get("mono_hue")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanMonoHue"]]], result)

    @builtins.property
    def opacity(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanOpacity"]]]:
        '''opacity block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanOpacity"]]], result)

    @builtins.property
    def remove_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanRemoveColor"]]]:
        '''remove_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        '''
        result = self._values.get("remove_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanRemoveColor"]]], result)

    @builtins.property
    def unsharp_mask(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanUnsharpMask"]]]:
        '''unsharp_mask block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        result = self._values.get("unsharp_mask")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanUnsharpMask"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanBackgroundColor",
    jsii_struct_bases=[],
    name_mapping={"color": "color", "color_var": "colorVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanBackgroundColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d37d3662c1f64e266cd702bb42988837b5ec456c01e1eee849b230de2b4e79d)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanBackgroundColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanBackgroundColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanBackgroundColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__58fef943497ed434de81d36bab160096808473fd129a5f9deef1e3c373bca003)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanBackgroundColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dc5cf4c778b5d63d81c403e053ee211f1a50dab45a13f6d26791adf3648f8c30)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanBackgroundColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a18769162ae2be277eb8a37dea2f9782b75846b116eea83d3ab91579b80e96b2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__37cd1f6a2a1da71a3b6b069862d164be8feb733e5d88f3f19d181fb7a1525438)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a004323bc525c8ec59290536d01775f070282ae7465d64eb2b7f4955b9633aeb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanBackgroundColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanBackgroundColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b9afc0165e394d3f3fb66bb9b9dd7032060144ce18c3c7cd03a220e2bde7b83f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanBackgroundColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanBackgroundColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd08a11c15cb15366edcbc508632f6cf5b62ccc3e539ae447ec69e51002a20af)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__82bbb55711bde28ec8b17e93b15fb3fee482b3fe2509ef262cdefe41f2f48379)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b792f6b5457e1021710224f21b22daa7440173f7e303a221af28fd82d42ea79b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanBackgroundColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanBackgroundColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanBackgroundColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c8e4671f5e39b2c2735221a8a0e6668fef6c8e94a36baf5de90f0a0c8884763e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanBlur",
    jsii_struct_bases=[],
    name_mapping={"sigma": "sigma", "sigma_var": "sigmaVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanBlur:
    def __init__(
        self,
        *,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param sigma: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cb330e85dc6d8fde9d2979c24e2179de0cc348a3c8c688c082dc30e11f4be65b)
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanBlur(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanBlurList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanBlurList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a17bb1572a0f5b6b1385955c0ee542b5efe20710b41036593eb6a88bc204e7bf)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanBlurOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__84a055d94781465987100f5ee2e9778cefbf795c3871dcccb361cab805b55ec5)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanBlurOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7e32cfb84fd0781e793754f1e2be14d280894121f27964ea5d34b4bb71e6b46c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__12089b16155c6544948829f462e70d5a1a9067aeff8153952afaee94160b01db)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__956f34bea2ddfc66de7a5af7e422f3e35ef4193b4c3fa31ddffc23a89fa9cb33)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanBlur]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanBlur]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0c8adc0a4ac141bc5b042941fd828cbee5c14d6f71408df67e5c600f947ae1f2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanBlurOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanBlurOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2acfe89de6baee55035ab5edd538399ac8fbe290ff3ea4e40dd01bce26dc72fb)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d5778a660c6e2c0b4e93f86d5cc5a2e6a2f8a38dbb1cae34e6723684be6a052d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4336c990ef0a700465b06ebd187f1abab54afa366df9dd637aae99140be4956f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanBlur]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanBlur]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanBlur]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__106f508920d119c9436420444f02059cf6d2a67657311b37fc197ecdd61083a4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanChromaKey",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_feather": "hueFeather",
        "hue_feather_var": "hueFeatherVar",
        "hue_tolerance": "hueTolerance",
        "hue_tolerance_var": "hueToleranceVar",
        "hue_var": "hueVar",
        "lightness_feather": "lightnessFeather",
        "lightness_feather_var": "lightnessFeatherVar",
        "lightness_tolerance": "lightnessTolerance",
        "lightness_tolerance_var": "lightnessToleranceVar",
        "saturation_feather": "saturationFeather",
        "saturation_feather_var": "saturationFeatherVar",
        "saturation_tolerance": "saturationTolerance",
        "saturation_tolerance_var": "saturationToleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanChromaKey:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_feather: typing.Optional[builtins.str] = None,
        hue_feather_var: typing.Optional[builtins.str] = None,
        hue_tolerance: typing.Optional[builtins.str] = None,
        hue_tolerance_var: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness_feather: typing.Optional[builtins.str] = None,
        lightness_feather_var: typing.Optional[builtins.str] = None,
        lightness_tolerance: typing.Optional[builtins.str] = None,
        lightness_tolerance_var: typing.Optional[builtins.str] = None,
        saturation_feather: typing.Optional[builtins.str] = None,
        saturation_feather_var: typing.Optional[builtins.str] = None,
        saturation_tolerance: typing.Optional[builtins.str] = None,
        saturation_tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_feather: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        :param hue_feather_var: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        :param hue_tolerance: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        :param hue_tolerance_var: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        :param hue_var: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness_feather: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        :param lightness_feather_var: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        :param lightness_tolerance: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        :param lightness_tolerance_var: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        :param saturation_feather: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        :param saturation_feather_var: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        :param saturation_tolerance: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        :param saturation_tolerance_var: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__985458d56db4ea60fb367229aba3b859f6b6a2cfda8ac725d302c2a2599bde8c)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_feather", value=hue_feather, expected_type=type_hints["hue_feather"])
            check_type(argname="argument hue_feather_var", value=hue_feather_var, expected_type=type_hints["hue_feather_var"])
            check_type(argname="argument hue_tolerance", value=hue_tolerance, expected_type=type_hints["hue_tolerance"])
            check_type(argname="argument hue_tolerance_var", value=hue_tolerance_var, expected_type=type_hints["hue_tolerance_var"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness_feather", value=lightness_feather, expected_type=type_hints["lightness_feather"])
            check_type(argname="argument lightness_feather_var", value=lightness_feather_var, expected_type=type_hints["lightness_feather_var"])
            check_type(argname="argument lightness_tolerance", value=lightness_tolerance, expected_type=type_hints["lightness_tolerance"])
            check_type(argname="argument lightness_tolerance_var", value=lightness_tolerance_var, expected_type=type_hints["lightness_tolerance_var"])
            check_type(argname="argument saturation_feather", value=saturation_feather, expected_type=type_hints["saturation_feather"])
            check_type(argname="argument saturation_feather_var", value=saturation_feather_var, expected_type=type_hints["saturation_feather_var"])
            check_type(argname="argument saturation_tolerance", value=saturation_tolerance, expected_type=type_hints["saturation_tolerance"])
            check_type(argname="argument saturation_tolerance_var", value=saturation_tolerance_var, expected_type=type_hints["saturation_tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_feather is not None:
            self._values["hue_feather"] = hue_feather
        if hue_feather_var is not None:
            self._values["hue_feather_var"] = hue_feather_var
        if hue_tolerance is not None:
            self._values["hue_tolerance"] = hue_tolerance
        if hue_tolerance_var is not None:
            self._values["hue_tolerance_var"] = hue_tolerance_var
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness_feather is not None:
            self._values["lightness_feather"] = lightness_feather
        if lightness_feather_var is not None:
            self._values["lightness_feather_var"] = lightness_feather_var
        if lightness_tolerance is not None:
            self._values["lightness_tolerance"] = lightness_tolerance
        if lightness_tolerance_var is not None:
            self._values["lightness_tolerance_var"] = lightness_tolerance_var
        if saturation_feather is not None:
            self._values["saturation_feather"] = saturation_feather
        if saturation_feather_var is not None:
            self._values["saturation_feather_var"] = saturation_feather_var
        if saturation_tolerance is not None:
            self._values["saturation_tolerance"] = saturation_tolerance
        if saturation_tolerance_var is not None:
            self._values["saturation_tolerance_var"] = saturation_tolerance_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        '''
        result = self._values.get("hue_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        '''
        result = self._values.get("hue_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        '''
        result = self._values.get("hue_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        '''
        result = self._values.get("hue_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        '''
        result = self._values.get("lightness_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        '''
        result = self._values.get("lightness_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        '''
        result = self._values.get("lightness_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        '''
        result = self._values.get("lightness_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        '''
        result = self._values.get("saturation_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        '''
        result = self._values.get("saturation_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        '''
        result = self._values.get("saturation_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        result = self._values.get("saturation_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanChromaKey(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanChromaKeyList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanChromaKeyList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d73961a7e03e43a30d594625e8983a33ce676547b6ddc3be1657cd645950a6cb)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanChromaKeyOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__587e8179498d4d996fab8dbf564921e74c3ca48e0fd68097121102f9411036ec)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanChromaKeyOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__de7cd02c1c1093b896fe0a08ac4528a704435b87908b7340d890fb3acb47e03f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0dc28de9c9be6a49d1ce8c634446b54c8e2f66014be270ff945afc558bb46ee9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4874f02c4fd2bd30c9c1f7294513969309658038a71aaf044266f7c24b91b9b1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanChromaKey]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanChromaKey]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__57490e96588b2d8dec109a8307c6062a78ba7d15c89ef394ac56bc96a1bccf3d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanChromaKeyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanChromaKeyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__850c01902a3ca7a6699e9dce2eae21319892db8eeeb5af1f8d54df3ae7a943d8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueFeather")
    def reset_hue_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeather", []))

    @jsii.member(jsii_name="resetHueFeatherVar")
    def reset_hue_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeatherVar", []))

    @jsii.member(jsii_name="resetHueTolerance")
    def reset_hue_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueTolerance", []))

    @jsii.member(jsii_name="resetHueToleranceVar")
    def reset_hue_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueToleranceVar", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightnessFeather")
    def reset_lightness_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeather", []))

    @jsii.member(jsii_name="resetLightnessFeatherVar")
    def reset_lightness_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeatherVar", []))

    @jsii.member(jsii_name="resetLightnessTolerance")
    def reset_lightness_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessTolerance", []))

    @jsii.member(jsii_name="resetLightnessToleranceVar")
    def reset_lightness_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessToleranceVar", []))

    @jsii.member(jsii_name="resetSaturationFeather")
    def reset_saturation_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeather", []))

    @jsii.member(jsii_name="resetSaturationFeatherVar")
    def reset_saturation_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeatherVar", []))

    @jsii.member(jsii_name="resetSaturationTolerance")
    def reset_saturation_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationTolerance", []))

    @jsii.member(jsii_name="resetSaturationToleranceVar")
    def reset_saturation_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherInput")
    def hue_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVarInput")
    def hue_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceInput")
    def hue_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVarInput")
    def hue_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherInput")
    def lightness_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVarInput")
    def lightness_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceInput")
    def lightness_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVarInput")
    def lightness_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherInput")
    def saturation_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVarInput")
    def saturation_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceInput")
    def saturation_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVarInput")
    def saturation_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e38772f0275dbfb4ae27b0256794dc6418f763444f6a70030647efd3d61b0a2d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeather")
    def hue_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeather"))

    @hue_feather.setter
    def hue_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__30b978ad6c57bee79a473e25b49d6e22a55118b8370be644b5033414ecabd004)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeather", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVar")
    def hue_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeatherVar"))

    @hue_feather_var.setter
    def hue_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f1f3af61d904c7cc3176af46640065d7a1dfe0827234bc2a3988f06933b7110d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueTolerance")
    def hue_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueTolerance"))

    @hue_tolerance.setter
    def hue_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__de0c02769aafdd076ade1e4cb9febc636c544a9d63049189aff12918bec15f01)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVar")
    def hue_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueToleranceVar"))

    @hue_tolerance_var.setter
    def hue_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cec0430f80a07993b4bc9245a67d239d50126e131b1eea043151ea1a405a8aa4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__656a7d47b8b13948c46d2faeca3ef3e23ef81f08917cf57bc4131c1542db257b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeather")
    def lightness_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeather"))

    @lightness_feather.setter
    def lightness_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__da6ff6d59d2dba8793f727b04f0645e0261f38a6f8646b7e6b27bee5d1d5e99c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeather", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVar")
    def lightness_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeatherVar"))

    @lightness_feather_var.setter
    def lightness_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fbbbcde42de5b8bc7b755eb884814ae880b0829eeff339eee78bc23fb337e283)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessTolerance")
    def lightness_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessTolerance"))

    @lightness_tolerance.setter
    def lightness_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__832ae0f0c44c0b3f23bfcafca4ad6050fb1cd38e9099553c0098af87e7ed47b5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVar")
    def lightness_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessToleranceVar"))

    @lightness_tolerance_var.setter
    def lightness_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ee90fad8f5f3431c0dfd9769c53b067311eaf8bbcaad328ac0b4ca9de4cca365)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeather")
    def saturation_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeather"))

    @saturation_feather.setter
    def saturation_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ff772435892516ba6711cbaa84d09528c49ce159eff1c6c267fe59a0ab10e6db)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeather", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVar")
    def saturation_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeatherVar"))

    @saturation_feather_var.setter
    def saturation_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3222253189180f0d6ee2703d68381f54744b73d67cdd39674a9547b2eb703ae4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationTolerance")
    def saturation_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationTolerance"))

    @saturation_tolerance.setter
    def saturation_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8e6ca17e70cdb316bc96c9b7b04ceaa065e5362d9abfad32f9ad192ae3571572)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVar")
    def saturation_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationToleranceVar"))

    @saturation_tolerance_var.setter
    def saturation_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__61b67f56d78099c81238d7aa1c1f51c79240db2f3dc08bb26f4b58705aa7b285)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanChromaKey]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanChromaKey]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanChromaKey]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e4ba01343128830387b29f9a8a7d879ccd6680e8a22708bc0248f76168f9716e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanComposite",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "placement": "placement",
        "placement_var": "placementVar",
        "scale": "scale",
        "scale_dimension": "scaleDimension",
        "scale_dimension_var": "scaleDimensionVar",
        "scale_var": "scaleVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanComposite:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanCompositeImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        placement: typing.Optional[builtins.str] = None,
        placement_var: typing.Optional[builtins.str] = None,
        scale: typing.Optional[builtins.str] = None,
        scale_dimension: typing.Optional[builtins.str] = None,
        scale_dimension_var: typing.Optional[builtins.str] = None,
        scale_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param placement: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        :param placement_var: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        :param scale: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param scale_dimension: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        :param scale_dimension_var: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        :param scale_var: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        :param x_position: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanCompositeImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__49038a48b6c532c6f55802b37c8cb19e37a669363127224315495b6d75f4c767)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument placement", value=placement, expected_type=type_hints["placement"])
            check_type(argname="argument placement_var", value=placement_var, expected_type=type_hints["placement_var"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument scale_dimension", value=scale_dimension, expected_type=type_hints["scale_dimension"])
            check_type(argname="argument scale_dimension_var", value=scale_dimension_var, expected_type=type_hints["scale_dimension_var"])
            check_type(argname="argument scale_var", value=scale_var, expected_type=type_hints["scale_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if placement is not None:
            self._values["placement"] = placement
        if placement_var is not None:
            self._values["placement_var"] = placement_var
        if scale is not None:
            self._values["scale"] = scale
        if scale_dimension is not None:
            self._values["scale_dimension"] = scale_dimension
        if scale_dimension_var is not None:
            self._values["scale_dimension_var"] = scale_dimension_var
        if scale_var is not None:
            self._values["scale_var"] = scale_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanCompositeImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanCompositeImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        '''
        result = self._values.get("placement")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement_var(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        '''
        result = self._values.get("placement_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        '''
        result = self._values.get("scale_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        '''
        result = self._values.get("scale_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        '''
        result = self._values.get("scale_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanComposite(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanCompositeImage",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanCompositeImage:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanCompositeImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanCompositeImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanCompositeImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__12d0f636d0bb0e86029342e8a4350e21cd15a40651f3a4c22d4f980afd159cce)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanCompositeImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanCompositeImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dc22f1c678b07e543cc5a2c0a43563f7c6aced71bf193c001d5297553189b36e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanCompositeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanCompositeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d40304f44ee010d0e4581c8b89564d5557952bd88c266d8b5c8597bc5badb84a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanCompositeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f3b371c4554d5412ec434a1efe90c696311c20704c769cb710e02ee2835ebaa)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanCompositeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cb1c56d3c71aa445b173ae56e38a3f948f145f3d3b91fbeda64c356150041d57)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dea95f3642a58ce3030403484d45d5150031b06d135df777140e9f438eec874a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1dbd6e628da1b09df325625caf871231c0310f4d7a8bb441d9c683f351646079)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanComposite]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanComposite]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dd936b018003fd647c5b60f8977863f4999bbd43317c0252e590aee4c953ce7b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanCompositeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanCompositeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__99501ba257aebf6e9a0b4a7218b2b8314e2c87fea4f58305e97784da75630180)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanCompositeImage()

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPlacement")
    def reset_placement(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacement", []))

    @jsii.member(jsii_name="resetPlacementVar")
    def reset_placement_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacementVar", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetScaleDimension")
    def reset_scale_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimension", []))

    @jsii.member(jsii_name="resetScaleDimensionVar")
    def reset_scale_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimensionVar", []))

    @jsii.member(jsii_name="resetScaleVar")
    def reset_scale_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanCompositeImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanCompositeImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanCompositeImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="placementInput")
    def placement_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementInput"))

    @builtins.property
    @jsii.member(jsii_name="placementVarInput")
    def placement_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionInput")
    def scale_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVarInput")
    def scale_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleVarInput")
    def scale_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac50dabb49c9e09af853c706836e135ba36408c3a89c96315ec57fe9f0abd60a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__74ff186708e1723fcf38305e035994548e740f011034e9102f3c0bea0b92fea3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="placement")
    def placement(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placement"))

    @placement.setter
    def placement(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6ff4d0ba5381e8e1cc21237ccd25130b98ac56707b98c0cdaf6c7eb7e12c4e4a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placement", value)

    @builtins.property
    @jsii.member(jsii_name="placementVar")
    def placement_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placementVar"))

    @placement_var.setter
    def placement_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__11126d2377a572794a2a63e7ac557ca01e42d09823c51fa6d19e6c7481575b1b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placementVar", value)

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scale"))

    @scale.setter
    def scale(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2827b7bba76424b913d402743874d5c2616db55826cbccc647a52e68fbf3865f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scale", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimension")
    def scale_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimension"))

    @scale_dimension.setter
    def scale_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2f665e1462efa21ea8d746bd94b5e98579f9bbf96f4ba3fd2e2de3df056bf938)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimension", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVar")
    def scale_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimensionVar"))

    @scale_dimension_var.setter
    def scale_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a5333d18122257e8c6d791ce0c88be820d340eccc75765a282cbfeee0677001)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="scaleVar")
    def scale_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleVar"))

    @scale_var.setter
    def scale_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__900ea66dd233fdeb6a480b928aacf7cd9e20ba92b5a0c4fea8ef73781c75e804)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f2d0130c94d00326892a0eab5e2f5204b2e9c84003e2c04cccebd735e372fb88)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a56bac8efd0c34c4be86af9cf7db9ad055cd3a6ebdb60bed60fb0d3cd910910)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__edd33ded2f4942777827f9032c3a073d6abe65747413bf5df5ac902b0bc11474)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4750699115940b2bdc09051ea2bfac5308d7b35a0551eec2b90161e127e4a563)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanComposite]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanComposite]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanComposite]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6a676488c6e863047348983d67c5b3a39e39e284ea894f3cc1102d6823baf221)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanCompound",
    jsii_struct_bases=[],
    name_mapping={"transformations": "transformations"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanCompound:
    def __init__(
        self,
        *,
        transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param transformations: transformations block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__504284d5d223f09d4f3dfce17f42a4dd828d3537165611bead69986dd7fb7d52)
            check_type(argname="argument transformations", value=transformations, expected_type=type_hints["transformations"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if transformations is not None:
            self._values["transformations"] = transformations

    @builtins.property
    def transformations(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanCompoundTransformations"]]]:
        '''transformations block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        result = self._values.get("transformations")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanCompoundTransformations"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanCompound(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanCompoundList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanCompoundList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__910e9395bf84828a94b13b3a8e6d86ae7e07983406d024436032b740dc289efc)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanCompoundOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be6a7b7526d21a8414a1850ba4679fffddf87e371647f7f4ecdc2f55687cb6cf)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanCompoundOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c88217a0669d83accb8caeec217298acda85a748db9f10d854572bbfa089c35b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c5c3b9ffc38aecb4bb9b7c367a8a8005ce06bc49563359875002963953b29785)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f6e43820f2553ed1f831f7b3ca99db58f813c1af9f284bdd5ee8ec3b49b4a50)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanCompound]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanCompound]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fc25be84b24ea1668dd24407ee2fc3a6619de6b827625d880627da420d63c851)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanCompoundOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanCompoundOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e8e2d070e5b0edba1e73d2b1bdef40d09bdddf20a49e5abf67b64cf8c9be6fb5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformations")
    def put_transformations(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__156646efd718f9f208c59c57a0d5447270033bc33c8ed85557a9ca7b47a46ecc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTransformations", [value]))

    @jsii.member(jsii_name="resetTransformations")
    def reset_transformations(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformations", []))

    @builtins.property
    @jsii.member(jsii_name="transformations")
    def transformations(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanCompoundTransformationsList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanCompoundTransformationsList", jsii.get(self, "transformations"))

    @builtins.property
    @jsii.member(jsii_name="transformationsInput")
    def transformations_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanCompoundTransformations"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanCompoundTransformations"]]], jsii.get(self, "transformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanCompound]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanCompound]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanCompound]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9fbc1e80372af8cf81e21a084cc68f1d5403e86555d377838078ae46824cf5b2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanCompoundTransformations",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanCompoundTransformations:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanCompoundTransformations(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanCompoundTransformationsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanCompoundTransformationsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f2747cd7c2f0a974982bdafbaf74fd46977431c4af9bbf12387242faeb13153c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanCompoundTransformationsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5412b739b583a74d76f2e87d7a168e1e55529b6f336cf7064d7bf9a5b83e411c)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanCompoundTransformationsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e75c09c6b56e7b7977e6144a9f29a042dd3eb568e5e9a0b406caebb105a1e00a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__41e3b0017266891e01a7d9463d0c3819e66e49f421764e34f42ac6a8af0e59a0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f5b32b54aa7824f7d7c004728e72443d3729202a959f748f06ece58f133a4e92)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanCompoundTransformations]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanCompoundTransformations]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanCompoundTransformations]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__18ceb9f711ccfb94d3fcbd667d5fc415b2232d7ec1ad3e35c38c2f984cf0848c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanCompoundTransformationsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanCompoundTransformationsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__45918a71c0988dd2b25e1617d008d74fa2aa6ed6c11ba1a45ab2ea85bea9f357)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanCompoundTransformations]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanCompoundTransformations]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanCompoundTransformations]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c79c7f5d4eb533edf1c933de487345eedb0dc8d27d82a36b6598609abbb3240c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanContrast",
    jsii_struct_bases=[],
    name_mapping={
        "brightness": "brightness",
        "brightness_var": "brightnessVar",
        "contrast": "contrast",
        "contrast_var": "contrastVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanContrast:
    def __init__(
        self,
        *,
        brightness: typing.Optional[builtins.str] = None,
        brightness_var: typing.Optional[builtins.str] = None,
        contrast: typing.Optional[builtins.str] = None,
        contrast_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param brightness: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        :param brightness_var: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        :param contrast: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param contrast_var: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6448e2e0510bf6054e99489fe94d58a1cd14fe9da5f1bb23ec10fc59dc0127d6)
            check_type(argname="argument brightness", value=brightness, expected_type=type_hints["brightness"])
            check_type(argname="argument brightness_var", value=brightness_var, expected_type=type_hints["brightness_var"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument contrast_var", value=contrast_var, expected_type=type_hints["contrast_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if brightness is not None:
            self._values["brightness"] = brightness
        if brightness_var is not None:
            self._values["brightness_var"] = brightness_var
        if contrast is not None:
            self._values["contrast"] = contrast
        if contrast_var is not None:
            self._values["contrast_var"] = contrast_var

    @builtins.property
    def brightness(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        '''
        result = self._values.get("brightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def brightness_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        '''
        result = self._values.get("brightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        result = self._values.get("contrast_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanContrast(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanContrastList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanContrastList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9dc7b0b9e85988a8e479c2df604d019c17a4cda0f3ff443ee518bc89ddbb6b2e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanContrastOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__04dd13c639ea37b90ebd290080b065fedbd25cedc6e29e93c7ca2c85642f3f99)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanContrastOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ee7e3f16330a8a7d42e4bc9de9e4bc817b4651503238ef832dd83112e76ba4a3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1bd50943751f9d7ed1d08c556a2df05239b8b7ce52b1267d71f6e5053198201d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0d4fc9b7beccb520d74b87cb78c5c60b788ccef22a844ac9f1a82f94ff31b7c0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanContrast]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanContrast]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d0541f5f71bcd5c88da65639029ad6ff252e041974db4312dc8f6afcb058b844)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanContrastOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanContrastOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b2269f469ccc271058d5c971ce055f535251c0c81df8a257a96891ae966a75e6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetBrightness")
    def reset_brightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightness", []))

    @jsii.member(jsii_name="resetBrightnessVar")
    def reset_brightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightnessVar", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetContrastVar")
    def reset_contrast_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrastVar", []))

    @builtins.property
    @jsii.member(jsii_name="brightnessInput")
    def brightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="brightnessVarInput")
    def brightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastVarInput")
    def contrast_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="brightness")
    def brightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightness"))

    @brightness.setter
    def brightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d6b3e675755b00e59e23f00dc281a3fc8df1c56dbad2febc40dff85a77ab6727)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightness", value)

    @builtins.property
    @jsii.member(jsii_name="brightnessVar")
    def brightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightnessVar"))

    @brightness_var.setter
    def brightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__276fecf4033c65b5d388dd29b14693c016f1433ece96d7828e5166713e1061e7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrast"))

    @contrast.setter
    def contrast(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__813cb08ce5c0f56e16c6539abfe50ca5098ce6c7b85b95eae16f02eb1a8ecfff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrast", value)

    @builtins.property
    @jsii.member(jsii_name="contrastVar")
    def contrast_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrastVar"))

    @contrast_var.setter
    def contrast_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a7249670ea8453a6d56a6b9b71af15bc24714983715f6f28ff3b7a6f5204a94f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrastVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanContrast]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanContrast]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanContrast]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be330e9b8c93ec8389183c3a70dcae29195fefa997a68a368a07f65c29d77211)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanGoop",
    jsii_struct_bases=[],
    name_mapping={
        "chaos": "chaos",
        "chaos_var": "chaosVar",
        "density": "density",
        "density_var": "densityVar",
        "power": "power",
        "power_var": "powerVar",
        "seed": "seed",
        "seed_var": "seedVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanGoop:
    def __init__(
        self,
        *,
        chaos: typing.Optional[builtins.str] = None,
        chaos_var: typing.Optional[builtins.str] = None,
        density: typing.Optional[builtins.str] = None,
        density_var: typing.Optional[builtins.str] = None,
        power: typing.Optional[builtins.str] = None,
        power_var: typing.Optional[builtins.str] = None,
        seed: typing.Optional[builtins.str] = None,
        seed_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param chaos: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        :param chaos_var: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        :param density: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        :param density_var: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        :param power: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        :param power_var: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        :param seed: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        :param seed_var: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2dfbb9d16aca8078ae6d9389ee9e1bc8a2fbe1ed9819a35c47cff097e85caaf9)
            check_type(argname="argument chaos", value=chaos, expected_type=type_hints["chaos"])
            check_type(argname="argument chaos_var", value=chaos_var, expected_type=type_hints["chaos_var"])
            check_type(argname="argument density", value=density, expected_type=type_hints["density"])
            check_type(argname="argument density_var", value=density_var, expected_type=type_hints["density_var"])
            check_type(argname="argument power", value=power, expected_type=type_hints["power"])
            check_type(argname="argument power_var", value=power_var, expected_type=type_hints["power_var"])
            check_type(argname="argument seed", value=seed, expected_type=type_hints["seed"])
            check_type(argname="argument seed_var", value=seed_var, expected_type=type_hints["seed_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if chaos is not None:
            self._values["chaos"] = chaos
        if chaos_var is not None:
            self._values["chaos_var"] = chaos_var
        if density is not None:
            self._values["density"] = density
        if density_var is not None:
            self._values["density_var"] = density_var
        if power is not None:
            self._values["power"] = power
        if power_var is not None:
            self._values["power_var"] = power_var
        if seed is not None:
            self._values["seed"] = seed
        if seed_var is not None:
            self._values["seed_var"] = seed_var

    @builtins.property
    def chaos(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        '''
        result = self._values.get("chaos")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def chaos_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        '''
        result = self._values.get("chaos_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        '''
        result = self._values.get("density")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density_var(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        '''
        result = self._values.get("density_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        '''
        result = self._values.get("power")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power_var(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        '''
        result = self._values.get("power_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        '''
        result = self._values.get("seed")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed_var(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        result = self._values.get("seed_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanGoop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanGoopList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanGoopList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9497033ed16705a3374701aff8bf05ef934703dfad9b46d198a903da9d09f61f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanGoopOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__58e77bb444b9cddf5c5254fe6cdab8bb4099e9ab843bb14e3430d8cb109623bf)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanGoopOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2acf0b4267727ac7fde37d41a9ee9e2cbc6f715322642d5624ab766c56ff8652)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a53289e7282f6bff1be9cbf64b949365e8628178243f0b2eb0f604cd2a0f210e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d84776da0f59279b5209fbdeab299f476cf005dea3742b299a7cb10c1b47d12d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanGoop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanGoop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__98254a267a679ed2f44d80b8f52fb1866e0832824651a84c102a9d1f5c8ee4df)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanGoopOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanGoopOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c5f1c34a96a68a063f721dc571d0fdfcc9c6ff5dac42eccd84d91d6f1516e02e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetChaos")
    def reset_chaos(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaos", []))

    @jsii.member(jsii_name="resetChaosVar")
    def reset_chaos_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaosVar", []))

    @jsii.member(jsii_name="resetDensity")
    def reset_density(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensity", []))

    @jsii.member(jsii_name="resetDensityVar")
    def reset_density_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensityVar", []))

    @jsii.member(jsii_name="resetPower")
    def reset_power(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPower", []))

    @jsii.member(jsii_name="resetPowerVar")
    def reset_power_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPowerVar", []))

    @jsii.member(jsii_name="resetSeed")
    def reset_seed(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeed", []))

    @jsii.member(jsii_name="resetSeedVar")
    def reset_seed_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeedVar", []))

    @builtins.property
    @jsii.member(jsii_name="chaosInput")
    def chaos_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosInput"))

    @builtins.property
    @jsii.member(jsii_name="chaosVarInput")
    def chaos_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosVarInput"))

    @builtins.property
    @jsii.member(jsii_name="densityInput")
    def density_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityInput"))

    @builtins.property
    @jsii.member(jsii_name="densityVarInput")
    def density_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="powerInput")
    def power_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerInput"))

    @builtins.property
    @jsii.member(jsii_name="powerVarInput")
    def power_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerVarInput"))

    @builtins.property
    @jsii.member(jsii_name="seedInput")
    def seed_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedInput"))

    @builtins.property
    @jsii.member(jsii_name="seedVarInput")
    def seed_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedVarInput"))

    @builtins.property
    @jsii.member(jsii_name="chaos")
    def chaos(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaos"))

    @chaos.setter
    def chaos(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5d9ea30d1c49c3ccfcfe20ce324fdfd6e73823122deb9a0cd7c5e7da7f93c7df)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaos", value)

    @builtins.property
    @jsii.member(jsii_name="chaosVar")
    def chaos_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaosVar"))

    @chaos_var.setter
    def chaos_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__06a5466e618de3f8265bdc9a9b8ffdaca9c36d40b4417b18511ccfe50f3e57e6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaosVar", value)

    @builtins.property
    @jsii.member(jsii_name="density")
    def density(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "density"))

    @density.setter
    def density(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a25a2d7f3a8dc621fd2d76d9e6280f470868ea7fe9f198f74890b7e4ef9a9bd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "density", value)

    @builtins.property
    @jsii.member(jsii_name="densityVar")
    def density_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "densityVar"))

    @density_var.setter
    def density_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f06abde92e5369d82dc282ce118fc41db62969df286984a7b9bd8ca6923b56a9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "densityVar", value)

    @builtins.property
    @jsii.member(jsii_name="power")
    def power(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "power"))

    @power.setter
    def power(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fc8b73f54e60d4d1e850a96113063e1a4cfe428a99353fc2fbef8060d6d3a940)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "power", value)

    @builtins.property
    @jsii.member(jsii_name="powerVar")
    def power_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "powerVar"))

    @power_var.setter
    def power_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3070121e53d09d5d72f358c0f7f059f7563fb77a8201b0209fadd1514fcd720e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "powerVar", value)

    @builtins.property
    @jsii.member(jsii_name="seed")
    def seed(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seed"))

    @seed.setter
    def seed(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4c1db0984e65d503f0b6d217ec64302de373bfa90f013e28769d7b0fd5f007dc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seed", value)

    @builtins.property
    @jsii.member(jsii_name="seedVar")
    def seed_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seedVar"))

    @seed_var.setter
    def seed_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d76828a43da03985d33b735318192d53bae5b7ae7ba891aab7d74636abc09ca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seedVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanGoop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanGoop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanGoop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ac6bc31fd70894e96fb42832a3e5d3f7894b128f8f9654a12b2c9118b6aefb8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanGrayscale",
    jsii_struct_bases=[],
    name_mapping={"type": "type", "type_var": "typeVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanGrayscale:
    def __init__(
        self,
        *,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param type: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1e2e872165a2590918168d5a376c81c2e25aab6b9b4031a3c00b01234929b410)
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanGrayscale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanGrayscaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanGrayscaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__daf9101ec2efcf02c04a1798077549f6efb915dcd7582bd7511c0b008f5e3e3d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanGrayscaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cee0785450348be2c905a41024da3d4300c8b9664364e66dfa4cd2f9ce6dc5b6)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanGrayscaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a53cc703da1045f4b98e758a8bcb3273051f4339fa2b95e54017a9e22ceabc23)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f2aa389d08962bc75a91c73edc8e91a1abf332a2519a16b505439d107a6bbe82)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f644d412571dea986010ecade98ea0609f386d2ba1c5cd2837387685d09d4b4a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanGrayscale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanGrayscale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9627b7e5aad29cd5bf75581a198e687868603a088a20285de32fd3b00e5721e9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanGrayscaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanGrayscaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6b17842e668651f07e779cd39e7ada2a4b65e524fb01a76527181ad764a2303b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__997c906fbfdceafdc6e4c8031727e19132e33d34378869bfcdff5aea706d602d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c5a8ca2e45621138fdeaeb84f98b175be627ca2a7a345e723e69e58acf5cea07)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanGrayscale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanGrayscale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanGrayscale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fbfe2b241987c0182a36452cacd50d81f3c11e48df347ae4282c4a3c76e1aeba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanHsl",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "lightness": "lightness",
        "lightness_var": "lightnessVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanHsl:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness: typing.Optional[builtins.str] = None,
        lightness_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        :param lightness_var: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4bd8d1e19e4bd830eb9dcffd1efc7c54bc0c30914ca496c1ee4f9f618d25cbbd)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness", value=lightness, expected_type=type_hints["lightness"])
            check_type(argname="argument lightness_var", value=lightness_var, expected_type=type_hints["lightness_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness is not None:
            self._values["lightness"] = lightness
        if lightness_var is not None:
            self._values["lightness_var"] = lightness_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        '''
        result = self._values.get("lightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        '''
        result = self._values.get("lightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanHsl(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanHslList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanHslList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__37087ff527ad21e048f84efc035e527ce43bc7c8a7fc0e08e8eeb7f121d95170)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanHslOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__387f5e7d4518fb37cc62e78c8c72cc9e54454b6ee4e3b0484e5f2617f4853611)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanHslOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4156331d118c98d97bdbe743e0d4c4690341ff260be9ef74661970e3e2b8c230)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2f6bea5220db4e0b81604a54a7014b86d2e13153386196c4d81b1977da6f4c78)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__21517c36ae0f121f7df5bd9cfe3a2b5f7a21996733d98d77d1124b559014ff43)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanHsl]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanHsl]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8975d79215bfd0a16aaee4fd7243c165874f661ff9c1adde3bcaf7db5fdbc45f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanHslOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanHslOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__60c4738b2e663681e61f137b88728793102a04a1026d0d1d69103a47a71f98f5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightness")
    def reset_lightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightness", []))

    @jsii.member(jsii_name="resetLightnessVar")
    def reset_lightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessInput")
    def lightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessVarInput")
    def lightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__38d33d55c2d24abd61f5277a98106497644977cd067b381e2528795c76e33ae4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__12fd1ebe111a8512c12360c8f586142589504cb8ba78d942adcbf6af18ee4d0c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightness")
    def lightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightness"))

    @lightness.setter
    def lightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e69991a1da82cbe24d17987ac816bb2a4a08c15cd5d6ae064f55ead68ce4f232)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightness", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessVar")
    def lightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessVar"))

    @lightness_var.setter
    def lightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4f3b774d192acc795e82998b2ce897f45100b540909855c459680fb92ae210f6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8428b5c26b5c6451029848cf9dbfd5dd7991dc971310a78f7847c9861c886121)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac46ecb195a63d7d7d77e930f50e27ab0a1605cd0cf94761b9a5fee18c366ee0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanHsl]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanHsl]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanHsl]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__196801816fd03d0c04450949b7c8ef2213edee99543440020a106c77961310d9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanHsv",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanHsv:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        :param value: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3d1abfedc444e44fcd3800557ac948386a470d55cca29689f7a90cea80ace0bd)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanHsv(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanHsvList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanHsvList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__72e32e7fb40e376ef7191682fa1bb4f111b593fabbbfd142b8f4842a50118cb3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanHsvOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__392487253cafd5911486019b4dc3b57a81b286bad3aa5d4a7a1d9a2059030b5e)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanHsvOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7dd3e59c71dc539a208f79ad6c841fb0d1465dff3cbea49f727b9137283bf9c0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8579366a88271425ebb356765a0037456f98f91b784565bf884b7805b1105f73)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__96f9b4191da5770b588c496c1b548e6151deac57a2e55f6e85529f70a4f5ddc7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanHsv]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanHsv]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6c2a71565eda9005211a9f6344ce34b1867efb9a70221483c6bcd1746d752757)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanHsvOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanHsvOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__37ff8cd5ae66e76611f0896dc709a412336f1896892843a2c6ee9715866be148)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e1437e74244d76afccfb42aa2c98338813fff12cd0ef3131b719b124890567f9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__192f61066d6c87b79b797c6e0d23d3dee624c076ef062c1501a62696d0bd24bb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a7ad5fb088cab6c658e3bd21ef1108f8bbf6f177213c71aaf8fbe4a86ebf6c74)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__20b9f6ca036227c487c65c2a7bbe5e202eb6a46e052c95bd2073555ca15fcc6e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5e617048947243a0deaeb0f2c64dcb4e8d5eac909e6f74cefc4167a4c74a6c81)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a3ebbc20def926d7d8929f60f3833efe7c0f886bbb06551053809bdb6a98e727)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanHsv]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanHsv]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanHsv]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__935b657c169aa3d722de7ffc4c56fa804037086fbb1068b99a0b8efb931a968c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfDimension",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "dimension": "dimension",
        "dimension_var": "dimensionVar",
        "equal": "equal",
        "greater_than": "greaterThan",
        "less_than": "lessThan",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfDimension:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        dimension: typing.Optional[builtins.str] = None,
        dimension_var: typing.Optional[builtins.str] = None,
        equal: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionEqual", typing.Dict[builtins.str, typing.Any]]] = None,
        greater_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionGreaterThan", typing.Dict[builtins.str, typing.Any]]] = None,
        less_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionLessThan", typing.Dict[builtins.str, typing.Any]]] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param dimension: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        :param dimension_var: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        :param equal: equal block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        :param greater_than: greater_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        :param less_than: less_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        :param value: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionDefault(**default)
        if isinstance(equal, dict):
            equal = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionEqual(**equal)
        if isinstance(greater_than, dict):
            greater_than = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionGreaterThan(**greater_than)
        if isinstance(less_than, dict):
            less_than = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionLessThan(**less_than)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__39abfb502f935d640f90e8c5b870d446b6e874ce18703ff17f21514381888d31)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument dimension", value=dimension, expected_type=type_hints["dimension"])
            check_type(argname="argument dimension_var", value=dimension_var, expected_type=type_hints["dimension_var"])
            check_type(argname="argument equal", value=equal, expected_type=type_hints["equal"])
            check_type(argname="argument greater_than", value=greater_than, expected_type=type_hints["greater_than"])
            check_type(argname="argument less_than", value=less_than, expected_type=type_hints["less_than"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if dimension is not None:
            self._values["dimension"] = dimension
        if dimension_var is not None:
            self._values["dimension_var"] = dimension_var
        if equal is not None:
            self._values["equal"] = equal
        if greater_than is not None:
            self._values["greater_than"] = greater_than
        if less_than is not None:
            self._values["less_than"] = less_than
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionDefault"], result)

    @builtins.property
    def dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        '''
        result = self._values.get("dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        '''
        result = self._values.get("dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def equal(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionEqual"]:
        '''equal block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        '''
        result = self._values.get("equal")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionEqual"], result)

    @builtins.property
    def greater_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionGreaterThan"]:
        '''greater_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        '''
        result = self._values.get("greater_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionGreaterThan"], result)

    @builtins.property
    def less_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionLessThan"]:
        '''less_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        '''
        result = self._values.get("less_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionLessThan"], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfDimension(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e68b7788b6cb8c44cb976778ca04801cbf3cb9b298097a2dda1e6a714b6f6299)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5af023c659abdc0cb351372dea1d5c05d6ee8425d0a047471ff55963aef0da78)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionEqual",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionEqual:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionEqual(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionEqualOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionEqualOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f3e3d2e355df6456af2edce24f90a3c431f19ded8347e605d0e4c3a48a473f3f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionEqual], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionEqual],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__92747d52c0be949c513b5c3a75145fd621516602158b918d86b02c05ce6af77c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionGreaterThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionGreaterThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionGreaterThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionGreaterThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionGreaterThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c416a4d3a6f2365f14e2cf184aaee67e7cfaa3b6cf157cb4382760f453df91d2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionGreaterThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionGreaterThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9711d121920917cedc1f46773c4eece557fb8b18491b3bf1fe096d350315a9c0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionLessThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionLessThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionLessThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionLessThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionLessThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__54932db3b855bab3566a13663a6e51b72efee124cdbe45a930b925656445805a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionLessThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionLessThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6a0edf2fd070a6f27d51a7c660f36b098e1b665b5c2d9695f2a436aea888094b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__360f38562d298925f35af80267e31e3a5033b304e015f35ab05a822235c758bd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__300a21aade30da0b343aa87a4348e4beb6b5bba3e3f7845e8d29862b564e9998)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e99057565ab705ec7cc371c0cac3997f983fe866bbe2d9954dafe1e97273d837)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2eb34e227c89fe5c6c026a69dbcdf7391d4d6a07dcf2dfb1f9e06b2d05bcdefb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__58d3bd72e29ce632bc6b80064c94be57f9e196bd34c652e519acf0d3f17725a3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfDimension]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfDimension]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a2bae3c91ba70503dff4dfac088ed1b40137f898a36b0de6d935824a5d6a6de3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5fddddbd836a86516aa92e0fc4b0771f64eb25669b6adfce8b5e738b7c179739)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putEqual")
    def put_equal(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionEqual()

        return typing.cast(None, jsii.invoke(self, "putEqual", [value]))

    @jsii.member(jsii_name="putGreaterThan")
    def put_greater_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionGreaterThan()

        return typing.cast(None, jsii.invoke(self, "putGreaterThan", [value]))

    @jsii.member(jsii_name="putLessThan")
    def put_less_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionLessThan()

        return typing.cast(None, jsii.invoke(self, "putLessThan", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetDimension")
    def reset_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimension", []))

    @jsii.member(jsii_name="resetDimensionVar")
    def reset_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimensionVar", []))

    @jsii.member(jsii_name="resetEqual")
    def reset_equal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEqual", []))

    @jsii.member(jsii_name="resetGreaterThan")
    def reset_greater_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGreaterThan", []))

    @jsii.member(jsii_name="resetLessThan")
    def reset_less_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLessThan", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="equal")
    def equal(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionEqualOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionEqualOutputReference, jsii.get(self, "equal"))

    @builtins.property
    @jsii.member(jsii_name="greaterThan")
    def greater_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionGreaterThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionGreaterThanOutputReference, jsii.get(self, "greaterThan"))

    @builtins.property
    @jsii.member(jsii_name="lessThan")
    def less_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionLessThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionLessThanOutputReference, jsii.get(self, "lessThan"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionInput")
    def dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionVarInput")
    def dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="equalInput")
    def equal_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionEqual], jsii.get(self, "equalInput"))

    @builtins.property
    @jsii.member(jsii_name="greaterThanInput")
    def greater_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionGreaterThan], jsii.get(self, "greaterThanInput"))

    @builtins.property
    @jsii.member(jsii_name="lessThanInput")
    def less_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionLessThan], jsii.get(self, "lessThanInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="dimension")
    def dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimension"))

    @dimension.setter
    def dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c8472c80bdeb83101e85a5fd3bd9b9111a7c091aff3d51983f03b050b3aa3ae9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimension", value)

    @builtins.property
    @jsii.member(jsii_name="dimensionVar")
    def dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimensionVar"))

    @dimension_var.setter
    def dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4dad7737cca9faf3c272348c0ea1d33b57927429d80c5220ea8cb1497eeac39d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__606524b9c49d48c339c20f48e5a7f2b4906ac353e6343ec57466bc2df7b17929)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__de9e4359850819b2c0415bdc974c74b109470f7a33e38778acc44f7dda5cf74b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfDimension]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfDimension]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfDimension]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3948acf0a0f0b49e75971787778af9442b43353bd363e8c8c952eb77b45b61b0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientation",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "landscape": "landscape",
        "portrait": "portrait",
        "square": "square",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientation:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        landscape: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationLandscape", typing.Dict[builtins.str, typing.Any]]] = None,
        portrait: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationPortrait", typing.Dict[builtins.str, typing.Any]]] = None,
        square: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationSquare", typing.Dict[builtins.str, typing.Any]]] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param landscape: landscape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        :param portrait: portrait block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        :param square: square block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationDefault(**default)
        if isinstance(landscape, dict):
            landscape = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationLandscape(**landscape)
        if isinstance(portrait, dict):
            portrait = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationPortrait(**portrait)
        if isinstance(square, dict):
            square = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationSquare(**square)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ffa7565b021b47364e915d482025352a3ee8462a64adec03197bb7202e823c7)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument landscape", value=landscape, expected_type=type_hints["landscape"])
            check_type(argname="argument portrait", value=portrait, expected_type=type_hints["portrait"])
            check_type(argname="argument square", value=square, expected_type=type_hints["square"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if landscape is not None:
            self._values["landscape"] = landscape
        if portrait is not None:
            self._values["portrait"] = portrait
        if square is not None:
            self._values["square"] = square

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationDefault"], result)

    @builtins.property
    def landscape(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationLandscape"]:
        '''landscape block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        '''
        result = self._values.get("landscape")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationLandscape"], result)

    @builtins.property
    def portrait(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationPortrait"]:
        '''portrait block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        '''
        result = self._values.get("portrait")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationPortrait"], result)

    @builtins.property
    def square(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationSquare"]:
        '''square block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        result = self._values.get("square")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationSquare"], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8c545a9662f8913d53668ad879b4f61c67f44815abda8104d6ac5f489ee85960)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0051466a71ee429731966742bc6592cd59cb1be1ec567f3e4ed75830b1f5fe0c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationLandscape",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationLandscape:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationLandscape(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationLandscapeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationLandscapeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7436b3a0cd4de5d0b068cc7bc08a53c6b146879f517c46c4a3c1765939171712)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationLandscape], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationLandscape],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d460a4718b5964bcb2cdcdc3e8bf2394d4cc45b038afdc8bfcce78e00a017596)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__36d64dd2473d9ac3dc87fc5e7a29a2abb3981031e5eab33634cb7b15b8a30154)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5c0d298a7648418a5f35a69d55c2fba0e78d0179631d6bfbe18bfbe8913a7802)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6ed7ad3d9c074aba57631b79844c719990289ac77882c4953b4ee8e73ba2c86b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8ededf31dddb7acfaaed03711c7f3f1e4321e112cf14a6ead748711a98ecc410)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ff51015f297d6ffd0251533da91b822c5f1006c1b2d68d046dad2655b8f89b39)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientation]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientation]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__07aa8d50e873ce53c99241c7bfe0fbb7e00841d96c838048502f674233bc022b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0eb02a2314014b859c519a537bce989fea386dd8c054e5dac6cff6823f705901)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putLandscape")
    def put_landscape(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationLandscape()

        return typing.cast(None, jsii.invoke(self, "putLandscape", [value]))

    @jsii.member(jsii_name="putPortrait")
    def put_portrait(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationPortrait()

        return typing.cast(None, jsii.invoke(self, "putPortrait", [value]))

    @jsii.member(jsii_name="putSquare")
    def put_square(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationSquare()

        return typing.cast(None, jsii.invoke(self, "putSquare", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetLandscape")
    def reset_landscape(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLandscape", []))

    @jsii.member(jsii_name="resetPortrait")
    def reset_portrait(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPortrait", []))

    @jsii.member(jsii_name="resetSquare")
    def reset_square(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSquare", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="landscape")
    def landscape(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationLandscapeOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationLandscapeOutputReference, jsii.get(self, "landscape"))

    @builtins.property
    @jsii.member(jsii_name="portrait")
    def portrait(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationPortraitOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationPortraitOutputReference", jsii.get(self, "portrait"))

    @builtins.property
    @jsii.member(jsii_name="square")
    def square(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationSquareOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationSquareOutputReference", jsii.get(self, "square"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="landscapeInput")
    def landscape_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationLandscape], jsii.get(self, "landscapeInput"))

    @builtins.property
    @jsii.member(jsii_name="portraitInput")
    def portrait_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationPortrait"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationPortrait"], jsii.get(self, "portraitInput"))

    @builtins.property
    @jsii.member(jsii_name="squareInput")
    def square_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationSquare"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationSquare"], jsii.get(self, "squareInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientation]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientation]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientation]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f0643323a86b9a42f16426eb236fd134f537a0c40ab0f2610cd8a68536fab28a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationPortrait",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationPortrait:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationPortrait(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationPortraitOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationPortraitOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4f5da75ccc1a7abe176c63f1a6bb2f86f33c00514de19b6e82c46c4fdebc5f95)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationPortrait]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationPortrait], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationPortrait],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e5bb40f182e458b25fe6ef95727ec7ebc3177f09dc12b0a0154d3f5989753cda)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationSquare",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationSquare:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationSquare(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationSquareOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationSquareOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__88ff18d13b24aa3326e80b2c3fc15d1f3377878cc987d7354b8d74caf4516274)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationSquare]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationSquare], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationSquare],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bcc1716f1647b8b80a77bfdbd50ec9145eb5eaad18d1a62000e61bba012597fb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanMaxColors",
    jsii_struct_bases=[],
    name_mapping={"colors": "colors", "colors_var": "colorsVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanMaxColors:
    def __init__(
        self,
        *,
        colors: typing.Optional[builtins.str] = None,
        colors_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param colors: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        :param colors_var: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a50129bf4d301f3fb8824a2f64e9ca79ff22a738eecad1c31efc0c8048058152)
            check_type(argname="argument colors", value=colors, expected_type=type_hints["colors"])
            check_type(argname="argument colors_var", value=colors_var, expected_type=type_hints["colors_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if colors is not None:
            self._values["colors"] = colors
        if colors_var is not None:
            self._values["colors_var"] = colors_var

    @builtins.property
    def colors(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        '''
        result = self._values.get("colors")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def colors_var(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        result = self._values.get("colors_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanMaxColors(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanMaxColorsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanMaxColorsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aa3f9808d6ee94f6c6b1d13aca3ce56e1d874c9513480de4e42eeebca9f629b9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanMaxColorsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a7c91236a8e8251e5e020e95afb919603870c736beb3fc2a33c1faa988f92242)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanMaxColorsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2f931e3ade9d454a953ed4721b3b29f6dc98ee636a8da1e629d9229ad591c189)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__68eb0e409d1260cd9583f8ae410682b19960aec1dbc588d44ba2cb7a264936b5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aa71d0c8101611ec2bc1f2b3b72c560ecafdebb686ebb4d852f5241397ef6674)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanMaxColors]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanMaxColors]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__18163a057059af574fd31c8f0ce6688c20279eaf5e69e60668d9f04b5578f592)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanMaxColorsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanMaxColorsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__40e9af155f21206f936ed343868dfb6f33b58ee7a5f388b71ce82a1ffe7dd024)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColors")
    def reset_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColors", []))

    @jsii.member(jsii_name="resetColorsVar")
    def reset_colors_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorsVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorsInput")
    def colors_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsInput"))

    @builtins.property
    @jsii.member(jsii_name="colorsVarInput")
    def colors_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsVarInput"))

    @builtins.property
    @jsii.member(jsii_name="colors")
    def colors(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colors"))

    @colors.setter
    def colors(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a3809985f81db3fff80c22e387548e4d167c6d7b58d9afda724e8abb5f1e54bd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colors", value)

    @builtins.property
    @jsii.member(jsii_name="colorsVar")
    def colors_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorsVar"))

    @colors_var.setter
    def colors_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dcccbb07e9be806654397855918937d050c7b774fa6b4c0f02547b3fc2f47a2f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorsVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanMaxColors]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanMaxColors]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanMaxColors]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d1a75a2034a34006fe88ee1649c7f1e0cf37d505555320c001aea927837be4fd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanMirror",
    jsii_struct_bases=[],
    name_mapping={
        "horizontal": "horizontal",
        "horizontal_var": "horizontalVar",
        "vertical": "vertical",
        "vertical_var": "verticalVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanMirror:
    def __init__(
        self,
        *,
        horizontal: typing.Optional[builtins.str] = None,
        horizontal_var: typing.Optional[builtins.str] = None,
        vertical: typing.Optional[builtins.str] = None,
        vertical_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param horizontal: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        :param horizontal_var: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        :param vertical: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        :param vertical_var: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c1983cfc44ed2f2c67ba7e55f623b5727f2a5e71c8e79e313944597e76f2e520)
            check_type(argname="argument horizontal", value=horizontal, expected_type=type_hints["horizontal"])
            check_type(argname="argument horizontal_var", value=horizontal_var, expected_type=type_hints["horizontal_var"])
            check_type(argname="argument vertical", value=vertical, expected_type=type_hints["vertical"])
            check_type(argname="argument vertical_var", value=vertical_var, expected_type=type_hints["vertical_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if horizontal is not None:
            self._values["horizontal"] = horizontal
        if horizontal_var is not None:
            self._values["horizontal_var"] = horizontal_var
        if vertical is not None:
            self._values["vertical"] = vertical
        if vertical_var is not None:
            self._values["vertical_var"] = vertical_var

    @builtins.property
    def horizontal(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        '''
        result = self._values.get("horizontal")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def horizontal_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        '''
        result = self._values.get("horizontal_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        '''
        result = self._values.get("vertical")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        result = self._values.get("vertical_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanMirror(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanMirrorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanMirrorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e28ced0f9fee5b2cef9967771d805285244313bd20773a0f26d0de48cd369b71)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanMirrorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__519e58bc6a05314ac29ffe49689c5bd673ba2c01cb5281485c788632c0cc2d49)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanMirrorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ddc6b7d785bdf4ce99d25adf6d96d6f24a03248424e30c64e40475569c991fe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aecd9a5313aca5b12a06718adc687a22e20a5c8e4fe5c0e10c374314719423e2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__61611b9a50a1058f37e56a3b86ab1fa6cb92786dfa226ba30c3a51475994c429)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanMirror]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanMirror]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6329b9a2b7cc50acfd7d018eed588782a60146ef2baaad57f121a86206862b3d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanMirrorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanMirrorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3473afc63401ea07cf04d3caae5b4298c0e7f7a6234b224ccc4b5f2ceb5529f5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHorizontal")
    def reset_horizontal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontal", []))

    @jsii.member(jsii_name="resetHorizontalVar")
    def reset_horizontal_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontalVar", []))

    @jsii.member(jsii_name="resetVertical")
    def reset_vertical(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVertical", []))

    @jsii.member(jsii_name="resetVerticalVar")
    def reset_vertical_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVerticalVar", []))

    @builtins.property
    @jsii.member(jsii_name="horizontalInput")
    def horizontal_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontalVarInput")
    def horizontal_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalInput")
    def vertical_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalVarInput")
    def vertical_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontal")
    def horizontal(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontal"))

    @horizontal.setter
    def horizontal(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__38cc5f206e216b0f1e3a2b671a51fb1f861074f6925d385cd2b27db78dc950d1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontal", value)

    @builtins.property
    @jsii.member(jsii_name="horizontalVar")
    def horizontal_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontalVar"))

    @horizontal_var.setter
    def horizontal_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__db3ec77d6c257863ab24e13129cc015b106db775fbe7da0d50e72289c2c27683)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontalVar", value)

    @builtins.property
    @jsii.member(jsii_name="vertical")
    def vertical(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "vertical"))

    @vertical.setter
    def vertical(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d4840b23f37003f830d6ca32803af1cb5a7a08869b336f658c372a93c0b28407)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "vertical", value)

    @builtins.property
    @jsii.member(jsii_name="verticalVar")
    def vertical_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "verticalVar"))

    @vertical_var.setter
    def vertical_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__57db5fb0c551cbcc3f035c2f1347d9cc938e3306b93b082cc55e867111639992)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "verticalVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanMirror]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanMirror]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanMirror]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3f54058a32a209f3f08b03d12b726683fd3b2d1ce154a805f4e8aad46e74fba7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanMonoHue",
    jsii_struct_bases=[],
    name_mapping={"hue": "hue", "hue_var": "hueVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanMonoHue:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__51f59ec6e2eb594a5e6c5a3b6aec3c75b8a5a49223fe894d24a054bf2a0778fe)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanMonoHue(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanMonoHueList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanMonoHueList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7712ccd23a55ef728ce302d78a0c4716d26479d493c7e1ec33fe7a8cac6b14fc)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanMonoHueOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9c80e88500ec394a07433e0258833c77fc9899a39a3d1fab28c85456838751dc)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanMonoHueOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b8399f9425e04ececc0f0b2a8b56029cf57ed66ee10b92f46f290fda764c676c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5e145e2941e51ff3ec887ee84e32beb683ed8fbc344feee5fcb0bb1f3e79dfea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e435a0871c7dff81a7510c76f0091f7cee2fe99462925986e8d910b6cce2b43)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanMonoHue]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanMonoHue]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4444cedcc2a81dde69c4a27c5bbd36889011e5f0b091f91bbae06b278f381b13)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanMonoHueOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanMonoHueOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f6840585bb1b56687d42c2fcffca9c81494fb605836d7ebcb08e02a3135b3e8b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6a8088a9c7213aff3bc8b598fcd74db3d37740655bb2cb8bd11973ad5c8cf603)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__58faf0055c1f52c89e1ce9880996cbb8a0c2bc83de44f051b9926a59696f0308)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanMonoHue]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanMonoHue]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanMonoHue]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4b729b5e6836dc3c2e146c7ca1914afd892f88d26316873d62eb505dadc841ca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanOpacity",
    jsii_struct_bases=[],
    name_mapping={"opacity": "opacity", "opacity_var": "opacityVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanOpacity:
    def __init__(
        self,
        *,
        opacity: typing.Optional[builtins.str] = None,
        opacity_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param opacity: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param opacity_var: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__535d2e96048596930da3b8fab59405fb7bea939e1402c5ad9041157194121511)
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument opacity_var", value=opacity_var, expected_type=type_hints["opacity_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if opacity is not None:
            self._values["opacity"] = opacity
        if opacity_var is not None:
            self._values["opacity_var"] = opacity_var

    @builtins.property
    def opacity(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def opacity_var(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        result = self._values.get("opacity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanOpacity(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanOpacityList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanOpacityList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bf773ba00f0684fed1ddd685921270347505ac59d54698e215b746790c97f894)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanOpacityOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2fe84602208ad6aa6b7ce8b7bacd6c7415d7ef2660016cd20488de6e2aee68e4)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanOpacityOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c5fe2335e09e99c362143684ec62a40f54db0753a176ed3fa81c90d88013ea59)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fccaf9f55d0683ae0b4da522146d8056869dc7255cf9e526577106099147b674)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__75e08719f418c7869cfd935b11f08e96943ec4659fff7b59fbf90811c3767a1d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanOpacity]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanOpacity]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__639c775fd1c4dca826d57eb4faab58d9e6dc1f0966e0c7458676d477544935d3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanOpacityOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanOpacityOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__694fcffeac55853204870806bff780d6c262691197291a54dab1aee8eaf73d9c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetOpacityVar")
    def reset_opacity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacityVar", []))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityVarInput")
    def opacity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacity"))

    @opacity.setter
    def opacity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a12f6e7d3bf11f023bed4d56cea853556a873a3534b3e78b83a4c31b74c89471)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacity", value)

    @builtins.property
    @jsii.member(jsii_name="opacityVar")
    def opacity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacityVar"))

    @opacity_var.setter
    def opacity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__096b8444c674623e18707c5e75bcdddef606e6aba74f5ec167bfc22906d470ef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacityVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanOpacity]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanOpacity]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanOpacity]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e9a74e375d18094d389fe442d605a84b087c41add383a9fb837b3d7b7d8fe43c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__504597e6aeefd9d5217d633bcb32685a037e29d7aad52f656cc48b499cb2d122)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putBackgroundColor")
    def put_background_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__746c4fdee515f644babd6127c7f79da1252eb64c9e3e6b3ad0bd6cf24fd16102)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBackgroundColor", [value]))

    @jsii.member(jsii_name="putBlur")
    def put_blur(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanBlur, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9b67489e63c8b120f7a96c20d18715b93be92c19acc2e77484a0dfa2698a042a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBlur", [value]))

    @jsii.member(jsii_name="putChromaKey")
    def put_chroma_key(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanChromaKey, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a6f282c36222b33b83a604d0192a091194f9711ff0048c08f84a401d63c505af)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putChromaKey", [value]))

    @jsii.member(jsii_name="putComposite")
    def put_composite(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanComposite, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f455573f84fd2016014c5cc7483c309ed12c5f8ec3c204f3adaa1201f8eddbea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putComposite", [value]))

    @jsii.member(jsii_name="putCompound")
    def put_compound(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanCompound, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e61bc4b541f1e61db7d051aff99621c98983b18893f4e031d1ff3f3a3e37c980)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCompound", [value]))

    @jsii.member(jsii_name="putContrast")
    def put_contrast(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanContrast, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8befae50bd246d5027ce701d0620b505c8dfc32145b886586a1a26f45056714e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putContrast", [value]))

    @jsii.member(jsii_name="putGoop")
    def put_goop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanGoop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9c0ec5ffbbd1ff160142eab0e17f56acb166a429024702e2c450cff1c9a5c63b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGoop", [value]))

    @jsii.member(jsii_name="putGrayscale")
    def put_grayscale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanGrayscale, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__701b94e14b29d90667e2de4567e0b6f440f6bfab41a175d5377791358912765c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGrayscale", [value]))

    @jsii.member(jsii_name="putHsl")
    def put_hsl(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanHsl, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__457ecacd36439140d5a97106a88c4707aa5eb5f9d1b8a447cfe8e34d3576916d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsl", [value]))

    @jsii.member(jsii_name="putHsv")
    def put_hsv(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanHsv, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1cf90634abf87817f7863383507ee3d9807c5df8a1755b970ce4da7dc7e204b5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsv", [value]))

    @jsii.member(jsii_name="putIfDimension")
    def put_if_dimension(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfDimension, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b5e46ba6e48017410afe7f064d2738667d8de7fc87b262054730eda280be8b61)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfDimension", [value]))

    @jsii.member(jsii_name="putIfOrientation")
    def put_if_orientation(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1043058755eb2c447a3d85bcd85950c7a04ed1fc3c630a3356c4f59e78432428)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfOrientation", [value]))

    @jsii.member(jsii_name="putMaxColors")
    def put_max_colors(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanMaxColors, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fd823faff0c0413d3d2a2d7b30b43c712413ae2d8229d72f95a213e69294947a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMaxColors", [value]))

    @jsii.member(jsii_name="putMirror")
    def put_mirror(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanMirror, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__21c40e76a6c10b62b553606d06780ff8af9d263f9a7261865bf8ae9f3e053fd0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMirror", [value]))

    @jsii.member(jsii_name="putMonoHue")
    def put_mono_hue(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanMonoHue, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f81709fd2d1a0da159b394fc36b1a80e14da9e1429c3cf6e05037b9395f367d5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMonoHue", [value]))

    @jsii.member(jsii_name="putOpacity")
    def put_opacity(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanOpacity, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b2ea81573a750d8e4f5487d172f7f4deef54757bee3fd87ecb0686971e8f3a5e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putOpacity", [value]))

    @jsii.member(jsii_name="putRemoveColor")
    def put_remove_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanRemoveColor", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f2bcfbe851a73f1b9024aa88dd925ecb6cc0cade222f619add47a4865879c96c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRemoveColor", [value]))

    @jsii.member(jsii_name="putUnsharpMask")
    def put_unsharp_mask(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanUnsharpMask", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6efa457a5c4d91c1aa3fba1770badaa5bb2c7347c4580b7607a988b1970c921b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putUnsharpMask", [value]))

    @jsii.member(jsii_name="resetBackgroundColor")
    def reset_background_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBackgroundColor", []))

    @jsii.member(jsii_name="resetBlur")
    def reset_blur(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBlur", []))

    @jsii.member(jsii_name="resetChromaKey")
    def reset_chroma_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChromaKey", []))

    @jsii.member(jsii_name="resetComposite")
    def reset_composite(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetComposite", []))

    @jsii.member(jsii_name="resetCompound")
    def reset_compound(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCompound", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetGoop")
    def reset_goop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGoop", []))

    @jsii.member(jsii_name="resetGrayscale")
    def reset_grayscale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGrayscale", []))

    @jsii.member(jsii_name="resetHsl")
    def reset_hsl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsl", []))

    @jsii.member(jsii_name="resetHsv")
    def reset_hsv(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsv", []))

    @jsii.member(jsii_name="resetIfDimension")
    def reset_if_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfDimension", []))

    @jsii.member(jsii_name="resetIfOrientation")
    def reset_if_orientation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfOrientation", []))

    @jsii.member(jsii_name="resetMaxColors")
    def reset_max_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxColors", []))

    @jsii.member(jsii_name="resetMirror")
    def reset_mirror(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMirror", []))

    @jsii.member(jsii_name="resetMonoHue")
    def reset_mono_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonoHue", []))

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetRemoveColor")
    def reset_remove_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRemoveColor", []))

    @jsii.member(jsii_name="resetUnsharpMask")
    def reset_unsharp_mask(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUnsharpMask", []))

    @builtins.property
    @jsii.member(jsii_name="backgroundColor")
    def background_color(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanBackgroundColorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanBackgroundColorList, jsii.get(self, "backgroundColor"))

    @builtins.property
    @jsii.member(jsii_name="blur")
    def blur(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanBlurList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanBlurList, jsii.get(self, "blur"))

    @builtins.property
    @jsii.member(jsii_name="chromaKey")
    def chroma_key(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanChromaKeyList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanChromaKeyList, jsii.get(self, "chromaKey"))

    @builtins.property
    @jsii.member(jsii_name="composite")
    def composite(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanCompositeList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanCompositeList, jsii.get(self, "composite"))

    @builtins.property
    @jsii.member(jsii_name="compound")
    def compound(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanCompoundList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanCompoundList, jsii.get(self, "compound"))

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanContrastList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanContrastList, jsii.get(self, "contrast"))

    @builtins.property
    @jsii.member(jsii_name="goop")
    def goop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanGoopList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanGoopList, jsii.get(self, "goop"))

    @builtins.property
    @jsii.member(jsii_name="grayscale")
    def grayscale(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanGrayscaleList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanGrayscaleList, jsii.get(self, "grayscale"))

    @builtins.property
    @jsii.member(jsii_name="hsl")
    def hsl(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanHslList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanHslList, jsii.get(self, "hsl"))

    @builtins.property
    @jsii.member(jsii_name="hsv")
    def hsv(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanHsvList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanHsvList, jsii.get(self, "hsv"))

    @builtins.property
    @jsii.member(jsii_name="ifDimension")
    def if_dimension(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionList, jsii.get(self, "ifDimension"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientation")
    def if_orientation(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationList, jsii.get(self, "ifOrientation"))

    @builtins.property
    @jsii.member(jsii_name="maxColors")
    def max_colors(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanMaxColorsList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanMaxColorsList, jsii.get(self, "maxColors"))

    @builtins.property
    @jsii.member(jsii_name="mirror")
    def mirror(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanMirrorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanMirrorList, jsii.get(self, "mirror"))

    @builtins.property
    @jsii.member(jsii_name="monoHue")
    def mono_hue(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanMonoHueList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanMonoHueList, jsii.get(self, "monoHue"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanOpacityList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanOpacityList, jsii.get(self, "opacity"))

    @builtins.property
    @jsii.member(jsii_name="removeColor")
    def remove_color(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanRemoveColorList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanRemoveColorList", jsii.get(self, "removeColor"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMask")
    def unsharp_mask(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanUnsharpMaskList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanUnsharpMaskList", jsii.get(self, "unsharpMask"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColorInput")
    def background_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanBackgroundColor]]], jsii.get(self, "backgroundColorInput"))

    @builtins.property
    @jsii.member(jsii_name="blurInput")
    def blur_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanBlur]]], jsii.get(self, "blurInput"))

    @builtins.property
    @jsii.member(jsii_name="chromaKeyInput")
    def chroma_key_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanChromaKey]]], jsii.get(self, "chromaKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="compositeInput")
    def composite_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanComposite]]], jsii.get(self, "compositeInput"))

    @builtins.property
    @jsii.member(jsii_name="compoundInput")
    def compound_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanCompound]]], jsii.get(self, "compoundInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanContrast]]], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="goopInput")
    def goop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanGoop]]], jsii.get(self, "goopInput"))

    @builtins.property
    @jsii.member(jsii_name="grayscaleInput")
    def grayscale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanGrayscale]]], jsii.get(self, "grayscaleInput"))

    @builtins.property
    @jsii.member(jsii_name="hslInput")
    def hsl_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanHsl]]], jsii.get(self, "hslInput"))

    @builtins.property
    @jsii.member(jsii_name="hsvInput")
    def hsv_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanHsv]]], jsii.get(self, "hsvInput"))

    @builtins.property
    @jsii.member(jsii_name="ifDimensionInput")
    def if_dimension_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfDimension]]], jsii.get(self, "ifDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientationInput")
    def if_orientation_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientation]]], jsii.get(self, "ifOrientationInput"))

    @builtins.property
    @jsii.member(jsii_name="maxColorsInput")
    def max_colors_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanMaxColors]]], jsii.get(self, "maxColorsInput"))

    @builtins.property
    @jsii.member(jsii_name="mirrorInput")
    def mirror_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanMirror]]], jsii.get(self, "mirrorInput"))

    @builtins.property
    @jsii.member(jsii_name="monoHueInput")
    def mono_hue_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanMonoHue]]], jsii.get(self, "monoHueInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanOpacity]]], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="removeColorInput")
    def remove_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanRemoveColor"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanRemoveColor"]]], jsii.get(self, "removeColorInput"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMaskInput")
    def unsharp_mask_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanUnsharpMask"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanUnsharpMask"]]], jsii.get(self, "unsharpMaskInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3f482538588aa0946578bf524c809a8329d91d3bb751905cff7b0b9112ffb2db)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanRemoveColor",
    jsii_struct_bases=[],
    name_mapping={
        "color": "color",
        "color_var": "colorVar",
        "feather": "feather",
        "feather_var": "featherVar",
        "tolerance": "tolerance",
        "tolerance_var": "toleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanRemoveColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
        feather: typing.Optional[builtins.str] = None,
        feather_var: typing.Optional[builtins.str] = None,
        tolerance: typing.Optional[builtins.str] = None,
        tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        :param feather: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        :param feather_var: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        :param tolerance: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        :param tolerance_var: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1858765d9c5b00a19388bd57e56d1bf318d50293a47be5538b8457aade83e387)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
            check_type(argname="argument feather", value=feather, expected_type=type_hints["feather"])
            check_type(argname="argument feather_var", value=feather_var, expected_type=type_hints["feather_var"])
            check_type(argname="argument tolerance", value=tolerance, expected_type=type_hints["tolerance"])
            check_type(argname="argument tolerance_var", value=tolerance_var, expected_type=type_hints["tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var
        if feather is not None:
            self._values["feather"] = feather
        if feather_var is not None:
            self._values["feather_var"] = feather_var
        if tolerance is not None:
            self._values["tolerance"] = tolerance
        if tolerance_var is not None:
            self._values["tolerance_var"] = tolerance_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        '''
        result = self._values.get("feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather_var(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        '''
        result = self._values.get("feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        '''
        result = self._values.get("tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance_var(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        result = self._values.get("tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanRemoveColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanRemoveColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanRemoveColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ce6724f1c26427001b01481441a861a54ee5bc7fb59e94ecf486a67efd9d465f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanRemoveColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f3bd055039bbd524be1344e224248b7d43fdd8d97ff04cca87f0d0ae145f3a89)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanRemoveColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b0081dd862d026dffdfc7c705b280475daf822664f9b6a7b7baedfafe4515186)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e75a0cd4e17b4631418982d939591412a16f2bf81a2000b065e9215bc7b2c3aa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__45396e079437cbf57d04604a8e3b43e1ede821e2b2d710bec70a564547d2e79d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanRemoveColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanRemoveColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanRemoveColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0e5afd8f91d3d83e9feae0851c16afd76675196f0fabc0e03d8184a24b5a8f8a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanRemoveColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanRemoveColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2dd1aed81e098b42d5ddd2e82a4f0363f3c75c3e83e45b08d8cff0e7e89eb74c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @jsii.member(jsii_name="resetFeather")
    def reset_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeather", []))

    @jsii.member(jsii_name="resetFeatherVar")
    def reset_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatherVar", []))

    @jsii.member(jsii_name="resetTolerance")
    def reset_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTolerance", []))

    @jsii.member(jsii_name="resetToleranceVar")
    def reset_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featherInput")
    def feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherInput"))

    @builtins.property
    @jsii.member(jsii_name="featherVarInput")
    def feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceInput")
    def tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceVarInput")
    def tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7b9c5d5fd94de6f6b565ab63df960f21fa3681b216154afeefa91e78ccf446c2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c647ff8edb58c93cf212e45adcd1ba8dabc6845ae2efbe6c85db4fa3856fd915)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="feather")
    def feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "feather"))

    @feather.setter
    def feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__636bc31f894d58c8a114f02c69e532f49a2b9b4b7b33821c55cbc3a84c220945)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "feather", value)

    @builtins.property
    @jsii.member(jsii_name="featherVar")
    def feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featherVar"))

    @feather_var.setter
    def feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7353ebde7e5f9c0127f9347bf000c7a7079d45b95d3037f3e2f166ebe17aa274)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featherVar", value)

    @builtins.property
    @jsii.member(jsii_name="tolerance")
    def tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tolerance"))

    @tolerance.setter
    def tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__67b68105c81aeddb5fad92ce49cf0403176a179702c74136f6142fd21c49e640)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tolerance", value)

    @builtins.property
    @jsii.member(jsii_name="toleranceVar")
    def tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "toleranceVar"))

    @tolerance_var.setter
    def tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df09a22b1c6ce6a5eb40281fc16d439508cbb75f1abcacf5e98266f16de150fe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "toleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanRemoveColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanRemoveColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanRemoveColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0d1e3269e7d8241ed828fda50a6f0c4fab33d8efb6c341039f3c9bf1f8c251fa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanUnsharpMask",
    jsii_struct_bases=[],
    name_mapping={
        "gain": "gain",
        "gain_var": "gainVar",
        "sigma": "sigma",
        "sigma_var": "sigmaVar",
        "threshold": "threshold",
        "threshold_var": "thresholdVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanUnsharpMask:
    def __init__(
        self,
        *,
        gain: typing.Optional[builtins.str] = None,
        gain_var: typing.Optional[builtins.str] = None,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
        threshold: typing.Optional[builtins.str] = None,
        threshold_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param gain: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        :param gain_var: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        :param sigma: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        :param threshold: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        :param threshold_var: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f06ead0ea85b81f1323c29c8063c22361538a4aa78ffbc73359c186c5e9d58dd)
            check_type(argname="argument gain", value=gain, expected_type=type_hints["gain"])
            check_type(argname="argument gain_var", value=gain_var, expected_type=type_hints["gain_var"])
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
            check_type(argname="argument threshold", value=threshold, expected_type=type_hints["threshold"])
            check_type(argname="argument threshold_var", value=threshold_var, expected_type=type_hints["threshold_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if gain is not None:
            self._values["gain"] = gain
        if gain_var is not None:
            self._values["gain_var"] = gain_var
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var
        if threshold is not None:
            self._values["threshold"] = threshold
        if threshold_var is not None:
            self._values["threshold_var"] = threshold_var

    @builtins.property
    def gain(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        '''
        result = self._values.get("gain")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gain_var(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        '''
        result = self._values.get("gain_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        '''
        result = self._values.get("threshold")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold_var(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        result = self._values.get("threshold_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanUnsharpMask(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanUnsharpMaskList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanUnsharpMaskList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a2092af77d36ddfaa015c1632319e2691c8130fdf3edc37516e53c61f6d3074c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanUnsharpMaskOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f44ab503306857c3ccae5385c4cd7635ec570fb78ec9eedd56efb76a54115a2f)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanUnsharpMaskOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e5e4b58d6bd572ecdeb59dfa3106995637dde122fde3d8b8d2063811121686e8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1399b0fbbfb4ef161bd9b58d2504337d855b8bb4266a67b55efc0e537da4f50b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e9f020d4c67da3d7c6cc8ed347b40b1748daae72992641300ec82f7d30124855)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanUnsharpMask]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanUnsharpMask]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanUnsharpMask]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a434063a48313ca085ecb1087bf1064db3046703bf9ba220e9a9f03459574b6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanUnsharpMaskOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanUnsharpMaskOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__95318143a668ed91610524a571a9288bc09a85fee1f9b38c4f829fc9818d65fe)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetGain")
    def reset_gain(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGain", []))

    @jsii.member(jsii_name="resetGainVar")
    def reset_gain_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGainVar", []))

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @jsii.member(jsii_name="resetThreshold")
    def reset_threshold(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThreshold", []))

    @jsii.member(jsii_name="resetThresholdVar")
    def reset_threshold_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThresholdVar", []))

    @builtins.property
    @jsii.member(jsii_name="gainInput")
    def gain_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainInput"))

    @builtins.property
    @jsii.member(jsii_name="gainVarInput")
    def gain_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdInput")
    def threshold_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdVarInput")
    def threshold_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gain")
    def gain(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gain"))

    @gain.setter
    def gain(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f6ebebfc569cadcf4dd21e625332fd22a2dea650074f4561f26dba659c4ff0e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gain", value)

    @builtins.property
    @jsii.member(jsii_name="gainVar")
    def gain_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gainVar"))

    @gain_var.setter
    def gain_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__efb6051fb26b84b238cb4388e63276715326de95daf02d1f9331887ba93e4918)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gainVar", value)

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a23ac13955c59352db71484a512e3294828c572474029bb8853c8ebd0cba710d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c40b44fbca5e65c180c9038dc1f81f07e9a992f814fc082197f71dbc35263826)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="threshold")
    def threshold(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "threshold"))

    @threshold.setter
    def threshold(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bbc3534ed9e8b598b74d3c8fb7774f42fadd2da438985083116103e30e4ec61d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "threshold", value)

    @builtins.property
    @jsii.member(jsii_name="thresholdVar")
    def threshold_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "thresholdVar"))

    @threshold_var.setter
    def threshold_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5656de7e54245732b62e961be74060de00fcc063bb9a9303c3ac82f81d84f291)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "thresholdVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanUnsharpMask]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanUnsharpMask]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanUnsharpMask]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__88598b55d217f6f302811239b4b0c587d7f5e6d3daa139a0ff9a7cd826c65a74)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__90a756df1637bd4fe11f903fe7d93933c02bb62fbcc2a6bcc91923284dae1d9f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__422fbc2368d16d87f8a073a6271fcd8b7ce1709b2dfd587a5692ab481d6a158f)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__92ffd894d3ab020fd405b7792ba62ad2104d6f7ca3e7b47ad5508335802ca335)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__37c2b7ac4b2cb59d083c907347f2811c10c560197108fcb49fd7363ac05a6926)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ce3275e91c8da916474167112a74a9720e246917e361e3423a14ff14f4f82715)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimension]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimension]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__757a9bb0f3001c10ad6e4851ff28c42b3a0bf62773fc53cf41a8e2a01df0802d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0d19a6e5b902a084e443c7175ccb1247043ad7ac05b6346a5c7b13228f512174)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(
        self,
        *,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefault(
            background_color=background_color,
            blur=blur,
            chroma_key=chroma_key,
            composite=composite,
            compound=compound,
            contrast=contrast,
            goop=goop,
            grayscale=grayscale,
            hsl=hsl,
            hsv=hsv,
            if_dimension=if_dimension,
            if_orientation=if_orientation,
            max_colors=max_colors,
            mirror=mirror,
            mono_hue=mono_hue,
            opacity=opacity,
            remove_color=remove_color,
            unsharp_mask=unsharp_mask,
        )

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putEqual")
    def put_equal(
        self,
        *,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqual(
            background_color=background_color,
            blur=blur,
            chroma_key=chroma_key,
            composite=composite,
            compound=compound,
            contrast=contrast,
            goop=goop,
            grayscale=grayscale,
            hsl=hsl,
            hsv=hsv,
            if_dimension=if_dimension,
            if_orientation=if_orientation,
            max_colors=max_colors,
            mirror=mirror,
            mono_hue=mono_hue,
            opacity=opacity,
            remove_color=remove_color,
            unsharp_mask=unsharp_mask,
        )

        return typing.cast(None, jsii.invoke(self, "putEqual", [value]))

    @jsii.member(jsii_name="putGreaterThan")
    def put_greater_than(
        self,
        *,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThan(
            background_color=background_color,
            blur=blur,
            chroma_key=chroma_key,
            composite=composite,
            compound=compound,
            contrast=contrast,
            goop=goop,
            grayscale=grayscale,
            hsl=hsl,
            hsv=hsv,
            if_dimension=if_dimension,
            if_orientation=if_orientation,
            max_colors=max_colors,
            mirror=mirror,
            mono_hue=mono_hue,
            opacity=opacity,
            remove_color=remove_color,
            unsharp_mask=unsharp_mask,
        )

        return typing.cast(None, jsii.invoke(self, "putGreaterThan", [value]))

    @jsii.member(jsii_name="putLessThan")
    def put_less_than(
        self,
        *,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThan(
            background_color=background_color,
            blur=blur,
            chroma_key=chroma_key,
            composite=composite,
            compound=compound,
            contrast=contrast,
            goop=goop,
            grayscale=grayscale,
            hsl=hsl,
            hsv=hsv,
            if_dimension=if_dimension,
            if_orientation=if_orientation,
            max_colors=max_colors,
            mirror=mirror,
            mono_hue=mono_hue,
            opacity=opacity,
            remove_color=remove_color,
            unsharp_mask=unsharp_mask,
        )

        return typing.cast(None, jsii.invoke(self, "putLessThan", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetDimension")
    def reset_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimension", []))

    @jsii.member(jsii_name="resetDimensionVar")
    def reset_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimensionVar", []))

    @jsii.member(jsii_name="resetEqual")
    def reset_equal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEqual", []))

    @jsii.member(jsii_name="resetGreaterThan")
    def reset_greater_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGreaterThan", []))

    @jsii.member(jsii_name="resetLessThan")
    def reset_less_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLessThan", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="equal")
    def equal(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualOutputReference, jsii.get(self, "equal"))

    @builtins.property
    @jsii.member(jsii_name="greaterThan")
    def greater_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanOutputReference, jsii.get(self, "greaterThan"))

    @builtins.property
    @jsii.member(jsii_name="lessThan")
    def less_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanOutputReference, jsii.get(self, "lessThan"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionInput")
    def dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionVarInput")
    def dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="equalInput")
    def equal_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqual], jsii.get(self, "equalInput"))

    @builtins.property
    @jsii.member(jsii_name="greaterThanInput")
    def greater_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThan], jsii.get(self, "greaterThanInput"))

    @builtins.property
    @jsii.member(jsii_name="lessThanInput")
    def less_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThan], jsii.get(self, "lessThanInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="dimension")
    def dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimension"))

    @dimension.setter
    def dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9dcee752e0667b97625b449561269f6a85c72c71486d7373efe0a8e6a2cdec50)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimension", value)

    @builtins.property
    @jsii.member(jsii_name="dimensionVar")
    def dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimensionVar"))

    @dimension_var.setter
    def dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__62fb3485de2e9cfbb81c610da08ed51a671e4c5836d05bedb62af72a8f4cdf3b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e163d90b40f01374a427ff04ac49bdbe6af46240ba2bba6230da5519a2e4a992)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__afbcef633fcaf91c3a6eb6b1664bb11a84c9f8cb0803218f66af9583b97209e6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimension]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimension]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimension]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__08efc22d7abc47f3a19260eaea93a667e6006a399a31c33aa2932598f2e8a839)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitMaxColors",
    jsii_struct_bases=[],
    name_mapping={"colors": "colors", "colors_var": "colorsVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitMaxColors:
    def __init__(
        self,
        *,
        colors: typing.Optional[builtins.str] = None,
        colors_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param colors: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        :param colors_var: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__17a2de514489d5b150e8b31d960201755b15397d383eed07f04dd61d39536934)
            check_type(argname="argument colors", value=colors, expected_type=type_hints["colors"])
            check_type(argname="argument colors_var", value=colors_var, expected_type=type_hints["colors_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if colors is not None:
            self._values["colors"] = colors
        if colors_var is not None:
            self._values["colors_var"] = colors_var

    @builtins.property
    def colors(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        '''
        result = self._values.get("colors")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def colors_var(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        result = self._values.get("colors_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitMaxColors(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitMaxColorsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitMaxColorsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__40c6d27bd3b56e0f38e3a4730f29df1d94bc7843c3cceae5654a6554c4910510)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitMaxColorsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__98456ce859bc919aa3e572fe75b7b06bdb763f5b95619c923d128851533cee3e)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitMaxColorsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__65a81cc8fd8eefa739a2cf3b1e128422e6661ac2af9635123ee295b9ae77f2d6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3c4c04c795ded7157f65df46686e814475a211c8fbbbcd11ce545010183091f1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8f00ca1185db4e9925dbeebe9f206e10e7bb07333b86f6ad577438a3d4d8409b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitMaxColors]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitMaxColors]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5be2507f791fd8d47a6b28cfb1fa928e87d1cb5b2a04378d2d2658e9ed4e66f2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitMaxColorsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitMaxColorsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__052c073017f0c3ec79d8b7b4e4969a1ac24da4f02ba6e44db4d952a4a3911f8f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColors")
    def reset_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColors", []))

    @jsii.member(jsii_name="resetColorsVar")
    def reset_colors_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorsVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorsInput")
    def colors_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsInput"))

    @builtins.property
    @jsii.member(jsii_name="colorsVarInput")
    def colors_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsVarInput"))

    @builtins.property
    @jsii.member(jsii_name="colors")
    def colors(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colors"))

    @colors.setter
    def colors(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__00fb8d8848ab465f9ef11bb1531cba98c565a708826b202154873cbc0e03dff0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colors", value)

    @builtins.property
    @jsii.member(jsii_name="colorsVar")
    def colors_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorsVar"))

    @colors_var.setter
    def colors_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__310be680ca3e00a24dbed1e51a64de405b7470455fb48120f3fbf06430756b2b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorsVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitMaxColors]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitMaxColors]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitMaxColors]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1c7f82f1e07ffef93d879830845f2265e28170f801dbbb6ece41669acba0f0e3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitMirror",
    jsii_struct_bases=[],
    name_mapping={
        "horizontal": "horizontal",
        "horizontal_var": "horizontalVar",
        "vertical": "vertical",
        "vertical_var": "verticalVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitMirror:
    def __init__(
        self,
        *,
        horizontal: typing.Optional[builtins.str] = None,
        horizontal_var: typing.Optional[builtins.str] = None,
        vertical: typing.Optional[builtins.str] = None,
        vertical_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param horizontal: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        :param horizontal_var: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        :param vertical: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        :param vertical_var: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__218f0abe02ebba743d698974c9421e749be2bda5908859d9ce1b3ef0062e105b)
            check_type(argname="argument horizontal", value=horizontal, expected_type=type_hints["horizontal"])
            check_type(argname="argument horizontal_var", value=horizontal_var, expected_type=type_hints["horizontal_var"])
            check_type(argname="argument vertical", value=vertical, expected_type=type_hints["vertical"])
            check_type(argname="argument vertical_var", value=vertical_var, expected_type=type_hints["vertical_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if horizontal is not None:
            self._values["horizontal"] = horizontal
        if horizontal_var is not None:
            self._values["horizontal_var"] = horizontal_var
        if vertical is not None:
            self._values["vertical"] = vertical
        if vertical_var is not None:
            self._values["vertical_var"] = vertical_var

    @builtins.property
    def horizontal(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        '''
        result = self._values.get("horizontal")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def horizontal_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        '''
        result = self._values.get("horizontal_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        '''
        result = self._values.get("vertical")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        result = self._values.get("vertical_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitMirror(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitMirrorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitMirrorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9682090699185f877c05a33904be4fa534a38a982fadd2224a68016bd8c1a2eb)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitMirrorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__656981ea0bc9c26c19663f16d0dd998894673c8956c620d7629c67885940e86a)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitMirrorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__78e5839f68bd0efb8bb2d25a80bcfff2b1b4b951b6d76430496f4ece5490ab6a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__21232a1da2cda00b5974b84f86e3746a8c3c4ac7f50a68664a320f6f4ccd19f6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc04de0a08989c8f2e22c26b3c6148680ac8a0037152bca2031e610560dc3106)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitMirror]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitMirror]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b82c2d628e9bb293fb2b7f5992e61f80380152c55ac60047707008748a511c34)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitMirrorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitMirrorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c7cc6353b3450f467dce27fcbdf7e9e3cacae7e698170ecffcd28bb3f84f852f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHorizontal")
    def reset_horizontal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontal", []))

    @jsii.member(jsii_name="resetHorizontalVar")
    def reset_horizontal_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontalVar", []))

    @jsii.member(jsii_name="resetVertical")
    def reset_vertical(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVertical", []))

    @jsii.member(jsii_name="resetVerticalVar")
    def reset_vertical_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVerticalVar", []))

    @builtins.property
    @jsii.member(jsii_name="horizontalInput")
    def horizontal_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontalVarInput")
    def horizontal_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalInput")
    def vertical_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalVarInput")
    def vertical_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontal")
    def horizontal(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontal"))

    @horizontal.setter
    def horizontal(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__74afb1af1be20def94a6f92e0ceab3788adf96541aceed5731523018c12c3eda)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontal", value)

    @builtins.property
    @jsii.member(jsii_name="horizontalVar")
    def horizontal_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontalVar"))

    @horizontal_var.setter
    def horizontal_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2fc6495e0887a36989b118f5af57c9d7fa48cd7fc9ab65fd2e13f09155e8fb76)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontalVar", value)

    @builtins.property
    @jsii.member(jsii_name="vertical")
    def vertical(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "vertical"))

    @vertical.setter
    def vertical(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2f8ff84a8b88cbfec047c394f85b6cc8a71b9e677323070fb068f017807d32de)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "vertical", value)

    @builtins.property
    @jsii.member(jsii_name="verticalVar")
    def vertical_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "verticalVar"))

    @vertical_var.setter
    def vertical_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ec3412e9cd78b60c9f3632f05bbbba93952edcafc06ae7de2da906e41af90762)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "verticalVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitMirror]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitMirror]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitMirror]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a4ad505dbacaa0f4f8cc42e50fac92edf3b6a0f753ef2118958adac440b14041)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitMonoHue",
    jsii_struct_bases=[],
    name_mapping={"hue": "hue", "hue_var": "hueVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitMonoHue:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__141c604b221e6592c7dd425573cb5ea617facefb1ca88d3c14f20ed0b283b494)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitMonoHue(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitMonoHueList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitMonoHueList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ca2b17790572d92b4401abc556c45c1f2d89e8b13a9784bff2f798356bdb414)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitMonoHueOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__613b35f6879f31a48b785afd801cc5a12629a84fa51641fd4f691fb6f1ff5712)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitMonoHueOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d33467362a08f4e2fe3009b3a89945116f524a1da3513b9e971ba4b882eb51c3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__75a0f7717cb9ed2b003b9db0c781a09f9a8e4be426feb3b230126479c9a43625)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6aa7256d8b48395bd3f2bc9bf748f79e490cad06170d131eb729fbfea7d0b7c7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitMonoHue]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitMonoHue]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d5b29bd7f11b489bdfbd2485435799e3ed1a5cb2b0437c2b743386281a20b66)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitMonoHueOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitMonoHueOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__27074fec7be74e2f4d92598d1b8782a8cdfac1686432a8877755110b0625ab16)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a8828b2c23542ad50ba7b229012c82a5fcc85621e193e3d2fcc6e7a1c801c329)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9dde7c47ada54bc285365ec5aa35b597de0cb8e6d5a42b4095ea55d8b414d710)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitMonoHue]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitMonoHue]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitMonoHue]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3f33436c26a52d97aba0f5b28d2c5bbc87270d540406f8e3e0807740404a027f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitOpacity",
    jsii_struct_bases=[],
    name_mapping={"opacity": "opacity", "opacity_var": "opacityVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitOpacity:
    def __init__(
        self,
        *,
        opacity: typing.Optional[builtins.str] = None,
        opacity_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param opacity: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param opacity_var: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a071f351780c77ab8bbf3c04915079c97dd8835b74e34e9d6752be963bc98510)
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument opacity_var", value=opacity_var, expected_type=type_hints["opacity_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if opacity is not None:
            self._values["opacity"] = opacity
        if opacity_var is not None:
            self._values["opacity_var"] = opacity_var

    @builtins.property
    def opacity(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def opacity_var(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        result = self._values.get("opacity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitOpacity(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitOpacityList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitOpacityList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5a48aed242031fe5134f22db720e605d01e042916a28ac421ea26ce8a3aeb5c8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitOpacityOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e8b786907f49fb8f56fec7c8e3cb7a9718553882d8c4a965265095ea64873600)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitOpacityOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3dbb02d2f7e0e2e286a42177cc674d920e4d91b61fe66276ac222d9ad339daca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a52906016fc60682057b3a20f1c6f6754a54327ca1807231814310170d8751f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fc75055459ef1fd9f75c11ef8bb5b5717d267a887c84c84386290598b6761a46)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitOpacity]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitOpacity]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6a7c376e0a36223366ec2e37cb8bb2376a8164a18712e3496db7821f0214564a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitOpacityOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitOpacityOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4620c0c86c192c37380ec0a3e34a12429fdb8305d8c207189cba50bed0bce7f2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetOpacityVar")
    def reset_opacity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacityVar", []))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityVarInput")
    def opacity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacity"))

    @opacity.setter
    def opacity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__505eee4604834dddb07581f24a739608607c7d5cf2f4edeb8dab3b7746756796)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacity", value)

    @builtins.property
    @jsii.member(jsii_name="opacityVar")
    def opacity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacityVar"))

    @opacity_var.setter
    def opacity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__642abb9b39dfd473f6f8ca00814f6866344f3bddaf8a8ae56e0f6b38e1bb8eda)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacityVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitOpacity]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitOpacity]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitOpacity]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7bfd49de2fae1abe178f0f915ee78b142e626598d4f8397ecb68914909d62946)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__24c391c7087317ea32adf125ef0401c7c93b5ed7887fb40c43a60159629f186c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putBackgroundColor")
    def put_background_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8dc555344efd0d22c00e4b22f32c38712cdd656f9373f4393aa69d3b15c2f3ad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBackgroundColor", [value]))

    @jsii.member(jsii_name="putBlur")
    def put_blur(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitBlur, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__80a9e8edc116a5046cb64ec831a70dc7ab513635aca2b61108e5f51b5dc72e30)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBlur", [value]))

    @jsii.member(jsii_name="putChromaKey")
    def put_chroma_key(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitChromaKey, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2dc9526e0de7c3a31b5842cc44a83e2655ffccde0e3bb6afcbaff3094ccf7ab9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putChromaKey", [value]))

    @jsii.member(jsii_name="putComposite")
    def put_composite(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitComposite, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cfea13d9eea1359f5fe50b90b71260ab4da7b689b2aa3e969fe2cebca2b224c6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putComposite", [value]))

    @jsii.member(jsii_name="putCompound")
    def put_compound(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompound, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__60a22ddd66ed608c85a5cdde3c876160acb5f8feecb803a10d972bda77db6246)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCompound", [value]))

    @jsii.member(jsii_name="putContrast")
    def put_contrast(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitContrast, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8e7d81807320215f4baf7478162b943fad4b14a2f7b997fde4f0a67f4e46b2d9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putContrast", [value]))

    @jsii.member(jsii_name="putGoop")
    def put_goop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitGoop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__228320cb6565e2c8467f6849cfebac25be564ac06ea17f7dc427e43368de398a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGoop", [value]))

    @jsii.member(jsii_name="putGrayscale")
    def put_grayscale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitGrayscale, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a1e1788278de0f1c88b8b862d1fc8f40ce5166470d86ea9930da71b13fc8a996)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGrayscale", [value]))

    @jsii.member(jsii_name="putHsl")
    def put_hsl(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitHsl, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__88c20755422b18f4f5ebfc08043ffa3f1cda697645ca641bf5a31e4e1ea61429)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsl", [value]))

    @jsii.member(jsii_name="putHsv")
    def put_hsv(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitHsv, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e29d9c8ab07226876b83891ba4307deeb5d73dfa13db199c624f6d51c4044827)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsv", [value]))

    @jsii.member(jsii_name="putIfDimension")
    def put_if_dimension(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimension, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa8895d8300403a8e1ac8a26cbc18ff586e7567d006405f264162c91fe887ebd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfDimension", [value]))

    @jsii.member(jsii_name="putIfOrientation")
    def put_if_orientation(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5c2f5e03c71407ff97b4d8ecf37ea29e6a202062c06e1f55ccf21d04d2bdaccf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfOrientation", [value]))

    @jsii.member(jsii_name="putMaxColors")
    def put_max_colors(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitMaxColors, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e9ddcf8fbb659a26c5443a4395071f1a17030e7fc09b1789b030c99237cdd838)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMaxColors", [value]))

    @jsii.member(jsii_name="putMirror")
    def put_mirror(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitMirror, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0cc3de6fb6b5ab099fda9f2e6789382410d2ceecd306cd7da28fcc21910cf38f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMirror", [value]))

    @jsii.member(jsii_name="putMonoHue")
    def put_mono_hue(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitMonoHue, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d3d5cdaef3be6d17ea0c8124ae1e9e9d6ee7df7e467cfbc579a3a94225db99ae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMonoHue", [value]))

    @jsii.member(jsii_name="putOpacity")
    def put_opacity(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitOpacity, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dcae4bae2cbcaccef2cdd3bc5dec6910fe779c5c0f2366ce97c9d04c4517c51c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putOpacity", [value]))

    @jsii.member(jsii_name="putRemoveColor")
    def put_remove_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitRemoveColor", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5893113cbfa6c100f99dd45ec89d8e31e391e64b78d26f1f0efd09ab8aeb0e4a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRemoveColor", [value]))

    @jsii.member(jsii_name="putUnsharpMask")
    def put_unsharp_mask(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitUnsharpMask", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2f9737fceb269aaf2e317009f16a8878cbee9ddf6c1ec77192eb3ff74ddcde77)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putUnsharpMask", [value]))

    @jsii.member(jsii_name="resetBackgroundColor")
    def reset_background_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBackgroundColor", []))

    @jsii.member(jsii_name="resetBlur")
    def reset_blur(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBlur", []))

    @jsii.member(jsii_name="resetChromaKey")
    def reset_chroma_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChromaKey", []))

    @jsii.member(jsii_name="resetComposite")
    def reset_composite(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetComposite", []))

    @jsii.member(jsii_name="resetCompound")
    def reset_compound(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCompound", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetGoop")
    def reset_goop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGoop", []))

    @jsii.member(jsii_name="resetGrayscale")
    def reset_grayscale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGrayscale", []))

    @jsii.member(jsii_name="resetHsl")
    def reset_hsl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsl", []))

    @jsii.member(jsii_name="resetHsv")
    def reset_hsv(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsv", []))

    @jsii.member(jsii_name="resetIfDimension")
    def reset_if_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfDimension", []))

    @jsii.member(jsii_name="resetIfOrientation")
    def reset_if_orientation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfOrientation", []))

    @jsii.member(jsii_name="resetMaxColors")
    def reset_max_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxColors", []))

    @jsii.member(jsii_name="resetMirror")
    def reset_mirror(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMirror", []))

    @jsii.member(jsii_name="resetMonoHue")
    def reset_mono_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonoHue", []))

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetRemoveColor")
    def reset_remove_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRemoveColor", []))

    @jsii.member(jsii_name="resetUnsharpMask")
    def reset_unsharp_mask(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUnsharpMask", []))

    @builtins.property
    @jsii.member(jsii_name="backgroundColor")
    def background_color(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitBackgroundColorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitBackgroundColorList, jsii.get(self, "backgroundColor"))

    @builtins.property
    @jsii.member(jsii_name="blur")
    def blur(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitBlurList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitBlurList, jsii.get(self, "blur"))

    @builtins.property
    @jsii.member(jsii_name="chromaKey")
    def chroma_key(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitChromaKeyList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitChromaKeyList, jsii.get(self, "chromaKey"))

    @builtins.property
    @jsii.member(jsii_name="composite")
    def composite(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeList, jsii.get(self, "composite"))

    @builtins.property
    @jsii.member(jsii_name="compound")
    def compound(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundList, jsii.get(self, "compound"))

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitContrastList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitContrastList, jsii.get(self, "contrast"))

    @builtins.property
    @jsii.member(jsii_name="goop")
    def goop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitGoopList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitGoopList, jsii.get(self, "goop"))

    @builtins.property
    @jsii.member(jsii_name="grayscale")
    def grayscale(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitGrayscaleList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitGrayscaleList, jsii.get(self, "grayscale"))

    @builtins.property
    @jsii.member(jsii_name="hsl")
    def hsl(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitHslList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitHslList, jsii.get(self, "hsl"))

    @builtins.property
    @jsii.member(jsii_name="hsv")
    def hsv(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitHsvList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitHsvList, jsii.get(self, "hsv"))

    @builtins.property
    @jsii.member(jsii_name="ifDimension")
    def if_dimension(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionList, jsii.get(self, "ifDimension"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientation")
    def if_orientation(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationList, jsii.get(self, "ifOrientation"))

    @builtins.property
    @jsii.member(jsii_name="maxColors")
    def max_colors(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitMaxColorsList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitMaxColorsList, jsii.get(self, "maxColors"))

    @builtins.property
    @jsii.member(jsii_name="mirror")
    def mirror(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitMirrorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitMirrorList, jsii.get(self, "mirror"))

    @builtins.property
    @jsii.member(jsii_name="monoHue")
    def mono_hue(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitMonoHueList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitMonoHueList, jsii.get(self, "monoHue"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitOpacityList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitOpacityList, jsii.get(self, "opacity"))

    @builtins.property
    @jsii.member(jsii_name="removeColor")
    def remove_color(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitRemoveColorList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitRemoveColorList", jsii.get(self, "removeColor"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMask")
    def unsharp_mask(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitUnsharpMaskList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitUnsharpMaskList", jsii.get(self, "unsharpMask"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColorInput")
    def background_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitBackgroundColor]]], jsii.get(self, "backgroundColorInput"))

    @builtins.property
    @jsii.member(jsii_name="blurInput")
    def blur_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitBlur]]], jsii.get(self, "blurInput"))

    @builtins.property
    @jsii.member(jsii_name="chromaKeyInput")
    def chroma_key_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitChromaKey]]], jsii.get(self, "chromaKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="compositeInput")
    def composite_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitComposite]]], jsii.get(self, "compositeInput"))

    @builtins.property
    @jsii.member(jsii_name="compoundInput")
    def compound_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompound]]], jsii.get(self, "compoundInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitContrast]]], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="goopInput")
    def goop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitGoop]]], jsii.get(self, "goopInput"))

    @builtins.property
    @jsii.member(jsii_name="grayscaleInput")
    def grayscale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitGrayscale]]], jsii.get(self, "grayscaleInput"))

    @builtins.property
    @jsii.member(jsii_name="hslInput")
    def hsl_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitHsl]]], jsii.get(self, "hslInput"))

    @builtins.property
    @jsii.member(jsii_name="hsvInput")
    def hsv_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitHsv]]], jsii.get(self, "hsvInput"))

    @builtins.property
    @jsii.member(jsii_name="ifDimensionInput")
    def if_dimension_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimension]]], jsii.get(self, "ifDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientationInput")
    def if_orientation_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientation]]], jsii.get(self, "ifOrientationInput"))

    @builtins.property
    @jsii.member(jsii_name="maxColorsInput")
    def max_colors_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitMaxColors]]], jsii.get(self, "maxColorsInput"))

    @builtins.property
    @jsii.member(jsii_name="mirrorInput")
    def mirror_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitMirror]]], jsii.get(self, "mirrorInput"))

    @builtins.property
    @jsii.member(jsii_name="monoHueInput")
    def mono_hue_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitMonoHue]]], jsii.get(self, "monoHueInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitOpacity]]], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="removeColorInput")
    def remove_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitRemoveColor"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitRemoveColor"]]], jsii.get(self, "removeColorInput"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMaskInput")
    def unsharp_mask_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitUnsharpMask"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitUnsharpMask"]]], jsii.get(self, "unsharpMaskInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortrait]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortrait], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortrait],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__74135cd740e15ad90b6d77af26b8b404d5401ebdf2e2aa7d7ecc4fb617e68592)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitRemoveColor",
    jsii_struct_bases=[],
    name_mapping={
        "color": "color",
        "color_var": "colorVar",
        "feather": "feather",
        "feather_var": "featherVar",
        "tolerance": "tolerance",
        "tolerance_var": "toleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitRemoveColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
        feather: typing.Optional[builtins.str] = None,
        feather_var: typing.Optional[builtins.str] = None,
        tolerance: typing.Optional[builtins.str] = None,
        tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        :param feather: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        :param feather_var: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        :param tolerance: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        :param tolerance_var: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d8d6d569c1aacb215ceaafc38c5dcfc4b2a00f64171ddef59b44bfcc4246197c)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
            check_type(argname="argument feather", value=feather, expected_type=type_hints["feather"])
            check_type(argname="argument feather_var", value=feather_var, expected_type=type_hints["feather_var"])
            check_type(argname="argument tolerance", value=tolerance, expected_type=type_hints["tolerance"])
            check_type(argname="argument tolerance_var", value=tolerance_var, expected_type=type_hints["tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var
        if feather is not None:
            self._values["feather"] = feather
        if feather_var is not None:
            self._values["feather_var"] = feather_var
        if tolerance is not None:
            self._values["tolerance"] = tolerance
        if tolerance_var is not None:
            self._values["tolerance_var"] = tolerance_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        '''
        result = self._values.get("feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather_var(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        '''
        result = self._values.get("feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        '''
        result = self._values.get("tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance_var(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        result = self._values.get("tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitRemoveColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitRemoveColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitRemoveColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4564b4b63a96b97eecd46abd9ab33bab443253887e69313aca3d304509db558b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitRemoveColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eed0a70a3782aac8ba8952b4c93b4e7967270eeb4dd6d08d3fe16a8afd887a81)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitRemoveColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a978a1bed24e0529b069ca4f1f9907bca9eda2cfc0766f54dd9cdd87af2e48c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a08b0f7d3db4344f8148312b1b0495e6013979bbfad2ae8ae861ab5314605e72)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b13b8e0cfb77ec6b21520ae0f3a3924febb3b83fdd6cd8f3466f0bcff62444ce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitRemoveColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitRemoveColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitRemoveColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a19f5a7bc81941741f09ae8288832c8cb676c07039cf0521b06df6bcfad385d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitRemoveColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitRemoveColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a263d1da18ef214d9ac70c302201586d0e349c02d09c0fbfa57bcb0d7e30acc6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @jsii.member(jsii_name="resetFeather")
    def reset_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeather", []))

    @jsii.member(jsii_name="resetFeatherVar")
    def reset_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatherVar", []))

    @jsii.member(jsii_name="resetTolerance")
    def reset_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTolerance", []))

    @jsii.member(jsii_name="resetToleranceVar")
    def reset_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featherInput")
    def feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherInput"))

    @builtins.property
    @jsii.member(jsii_name="featherVarInput")
    def feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceInput")
    def tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceVarInput")
    def tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aaea313d4b2a513ab8cb02bd0ff3065e30a4fffc09dbeefa70c997029479bf56)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2989c0d52436099f9d927f5a9c8e17a7c24b37aeba5ee5ee4416abaaec8ffece)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="feather")
    def feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "feather"))

    @feather.setter
    def feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d31454ac090051c50af8a7afd4569d250504577876da6bd757f8bd92e323cc7d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "feather", value)

    @builtins.property
    @jsii.member(jsii_name="featherVar")
    def feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featherVar"))

    @feather_var.setter
    def feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bfc1d35e543b4d6fc0bd4ebd3c122de4f6040aaf7b4afd1c52cd2612ba4d6652)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featherVar", value)

    @builtins.property
    @jsii.member(jsii_name="tolerance")
    def tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tolerance"))

    @tolerance.setter
    def tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b66692417ce52f5348046dc7270f5fff9f756798adc475ade028844fb8dd5ddd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tolerance", value)

    @builtins.property
    @jsii.member(jsii_name="toleranceVar")
    def tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "toleranceVar"))

    @tolerance_var.setter
    def tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e7220ae0561ae185ab1fab7ba2de7da67ce0a74cd281b559094172b387f88f09)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "toleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitRemoveColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitRemoveColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitRemoveColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__da3a457c6892afbe49673bcc30770cc49e6ee53aedd8242b571c74cca2cba483)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitUnsharpMask",
    jsii_struct_bases=[],
    name_mapping={
        "gain": "gain",
        "gain_var": "gainVar",
        "sigma": "sigma",
        "sigma_var": "sigmaVar",
        "threshold": "threshold",
        "threshold_var": "thresholdVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitUnsharpMask:
    def __init__(
        self,
        *,
        gain: typing.Optional[builtins.str] = None,
        gain_var: typing.Optional[builtins.str] = None,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
        threshold: typing.Optional[builtins.str] = None,
        threshold_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param gain: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        :param gain_var: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        :param sigma: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        :param threshold: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        :param threshold_var: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2028dafa24186c1b7658087915ff7253ed826f117b4e7f55b22211b49564b5f1)
            check_type(argname="argument gain", value=gain, expected_type=type_hints["gain"])
            check_type(argname="argument gain_var", value=gain_var, expected_type=type_hints["gain_var"])
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
            check_type(argname="argument threshold", value=threshold, expected_type=type_hints["threshold"])
            check_type(argname="argument threshold_var", value=threshold_var, expected_type=type_hints["threshold_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if gain is not None:
            self._values["gain"] = gain
        if gain_var is not None:
            self._values["gain_var"] = gain_var
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var
        if threshold is not None:
            self._values["threshold"] = threshold
        if threshold_var is not None:
            self._values["threshold_var"] = threshold_var

    @builtins.property
    def gain(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        '''
        result = self._values.get("gain")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gain_var(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        '''
        result = self._values.get("gain_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        '''
        result = self._values.get("threshold")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold_var(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        result = self._values.get("threshold_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitUnsharpMask(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitUnsharpMaskList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitUnsharpMaskList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0eb8cd4383baaf0f416cd55d25c852203790500430d9f1d8f2f978341ffc09ae)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitUnsharpMaskOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__969bb790c266ff743e701d8e834d7e6448a91fb5776c21f9c3d9afb26dc46b95)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitUnsharpMaskOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__76b4ed1a652399651f4e708113cb59ac112ee7d8a39841d68bf319534fdb519c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__50faa1df91e9bce27cf24c2ed81892c1a497f4dea77a34a8503a012af1c5a8cf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__13e34ce71e58a0e5c7d8c802c6aa77e07dbf96c02a5befc8a044f949aa38f2a9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitUnsharpMask]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitUnsharpMask]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitUnsharpMask]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__20793a157d1695822ef1ed37bfc6958a770eb25d42592ce7896b6dfeaccf181f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitUnsharpMaskOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitUnsharpMaskOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__29cb99c097f4fdc221f4b141a754361bf310580ac0d9fd4e2416b3916679f3dc)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetGain")
    def reset_gain(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGain", []))

    @jsii.member(jsii_name="resetGainVar")
    def reset_gain_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGainVar", []))

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @jsii.member(jsii_name="resetThreshold")
    def reset_threshold(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThreshold", []))

    @jsii.member(jsii_name="resetThresholdVar")
    def reset_threshold_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThresholdVar", []))

    @builtins.property
    @jsii.member(jsii_name="gainInput")
    def gain_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainInput"))

    @builtins.property
    @jsii.member(jsii_name="gainVarInput")
    def gain_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdInput")
    def threshold_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdVarInput")
    def threshold_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gain")
    def gain(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gain"))

    @gain.setter
    def gain(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__206a0c943ab10469f9707afce462a9056580c55ebed12dfa8134b1f994052398)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gain", value)

    @builtins.property
    @jsii.member(jsii_name="gainVar")
    def gain_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gainVar"))

    @gain_var.setter
    def gain_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__131b2c357bd00103f0bbc6b06aaa47f0ca09f7dba4c2e5b055535a982acb9783)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gainVar", value)

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8ae67c6f85df441f021433850b7f4399e7a1a3afc564c036c325ae07b5fa1ef2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d99c6d5be7cfc5e24a436c97848dd8b367ed556047d7d940a72d5fb14b613af2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="threshold")
    def threshold(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "threshold"))

    @threshold.setter
    def threshold(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c304b9aead4de00c5ba22cec002acbef5022853c5ebdb4e9cb9da8cb11756b57)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "threshold", value)

    @builtins.property
    @jsii.member(jsii_name="thresholdVar")
    def threshold_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "thresholdVar"))

    @threshold_var.setter
    def threshold_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6aa9d0a57abdd0aaf909e7a5b7fdcaf6fbe59b6a519c0ccf733ae4ec502415f4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "thresholdVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitUnsharpMask]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitUnsharpMask]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitUnsharpMask]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab93762e3b263a4c0eee928b6b04782e83d72cdff0260a653604bfd40f4d12b4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquare",
    jsii_struct_bases=[],
    name_mapping={
        "background_color": "backgroundColor",
        "blur": "blur",
        "chroma_key": "chromaKey",
        "composite": "composite",
        "compound": "compound",
        "contrast": "contrast",
        "goop": "goop",
        "grayscale": "grayscale",
        "hsl": "hsl",
        "hsv": "hsv",
        "if_dimension": "ifDimension",
        "if_orientation": "ifOrientation",
        "max_colors": "maxColors",
        "mirror": "mirror",
        "mono_hue": "monoHue",
        "opacity": "opacity",
        "remove_color": "removeColor",
        "unsharp_mask": "unsharpMask",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquare:
    def __init__(
        self,
        *,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareBackgroundColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareBlur", typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareChromaKey", typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareComposite", typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompound", typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareContrast", typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareGoop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareGrayscale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareHsl", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareHsv", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimension", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareMaxColors", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareMirror", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareMonoHue", typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareOpacity", typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareRemoveColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareUnsharpMask", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fde2d1e04e55ef3283e54705b446aaa6bd8e0fa7e4e45d5f4e5049773e8cbaf1)
            check_type(argname="argument background_color", value=background_color, expected_type=type_hints["background_color"])
            check_type(argname="argument blur", value=blur, expected_type=type_hints["blur"])
            check_type(argname="argument chroma_key", value=chroma_key, expected_type=type_hints["chroma_key"])
            check_type(argname="argument composite", value=composite, expected_type=type_hints["composite"])
            check_type(argname="argument compound", value=compound, expected_type=type_hints["compound"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument goop", value=goop, expected_type=type_hints["goop"])
            check_type(argname="argument grayscale", value=grayscale, expected_type=type_hints["grayscale"])
            check_type(argname="argument hsl", value=hsl, expected_type=type_hints["hsl"])
            check_type(argname="argument hsv", value=hsv, expected_type=type_hints["hsv"])
            check_type(argname="argument if_dimension", value=if_dimension, expected_type=type_hints["if_dimension"])
            check_type(argname="argument if_orientation", value=if_orientation, expected_type=type_hints["if_orientation"])
            check_type(argname="argument max_colors", value=max_colors, expected_type=type_hints["max_colors"])
            check_type(argname="argument mirror", value=mirror, expected_type=type_hints["mirror"])
            check_type(argname="argument mono_hue", value=mono_hue, expected_type=type_hints["mono_hue"])
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument remove_color", value=remove_color, expected_type=type_hints["remove_color"])
            check_type(argname="argument unsharp_mask", value=unsharp_mask, expected_type=type_hints["unsharp_mask"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if background_color is not None:
            self._values["background_color"] = background_color
        if blur is not None:
            self._values["blur"] = blur
        if chroma_key is not None:
            self._values["chroma_key"] = chroma_key
        if composite is not None:
            self._values["composite"] = composite
        if compound is not None:
            self._values["compound"] = compound
        if contrast is not None:
            self._values["contrast"] = contrast
        if goop is not None:
            self._values["goop"] = goop
        if grayscale is not None:
            self._values["grayscale"] = grayscale
        if hsl is not None:
            self._values["hsl"] = hsl
        if hsv is not None:
            self._values["hsv"] = hsv
        if if_dimension is not None:
            self._values["if_dimension"] = if_dimension
        if if_orientation is not None:
            self._values["if_orientation"] = if_orientation
        if max_colors is not None:
            self._values["max_colors"] = max_colors
        if mirror is not None:
            self._values["mirror"] = mirror
        if mono_hue is not None:
            self._values["mono_hue"] = mono_hue
        if opacity is not None:
            self._values["opacity"] = opacity
        if remove_color is not None:
            self._values["remove_color"] = remove_color
        if unsharp_mask is not None:
            self._values["unsharp_mask"] = unsharp_mask

    @builtins.property
    def background_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareBackgroundColor"]]]:
        '''background_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        '''
        result = self._values.get("background_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareBackgroundColor"]]], result)

    @builtins.property
    def blur(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareBlur"]]]:
        '''blur block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        '''
        result = self._values.get("blur")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareBlur"]]], result)

    @builtins.property
    def chroma_key(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareChromaKey"]]]:
        '''chroma_key block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        '''
        result = self._values.get("chroma_key")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareChromaKey"]]], result)

    @builtins.property
    def composite(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareComposite"]]]:
        '''composite block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        '''
        result = self._values.get("composite")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareComposite"]]], result)

    @builtins.property
    def compound(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompound"]]]:
        '''compound block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        '''
        result = self._values.get("compound")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompound"]]], result)

    @builtins.property
    def contrast(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareContrast"]]]:
        '''contrast block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareContrast"]]], result)

    @builtins.property
    def goop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareGoop"]]]:
        '''goop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        '''
        result = self._values.get("goop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareGoop"]]], result)

    @builtins.property
    def grayscale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareGrayscale"]]]:
        '''grayscale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        '''
        result = self._values.get("grayscale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareGrayscale"]]], result)

    @builtins.property
    def hsl(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareHsl"]]]:
        '''hsl block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        '''
        result = self._values.get("hsl")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareHsl"]]], result)

    @builtins.property
    def hsv(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareHsv"]]]:
        '''hsv block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        '''
        result = self._values.get("hsv")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareHsv"]]], result)

    @builtins.property
    def if_dimension(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimension"]]]:
        '''if_dimension block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        '''
        result = self._values.get("if_dimension")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimension"]]], result)

    @builtins.property
    def if_orientation(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientation]]]:
        '''if_orientation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        '''
        result = self._values.get("if_orientation")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientation]]], result)

    @builtins.property
    def max_colors(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareMaxColors"]]]:
        '''max_colors block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        '''
        result = self._values.get("max_colors")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareMaxColors"]]], result)

    @builtins.property
    def mirror(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareMirror"]]]:
        '''mirror block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        '''
        result = self._values.get("mirror")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareMirror"]]], result)

    @builtins.property
    def mono_hue(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareMonoHue"]]]:
        '''mono_hue block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        '''
        result = self._values.get("mono_hue")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareMonoHue"]]], result)

    @builtins.property
    def opacity(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareOpacity"]]]:
        '''opacity block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareOpacity"]]], result)

    @builtins.property
    def remove_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareRemoveColor"]]]:
        '''remove_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        '''
        result = self._values.get("remove_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareRemoveColor"]]], result)

    @builtins.property
    def unsharp_mask(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareUnsharpMask"]]]:
        '''unsharp_mask block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        result = self._values.get("unsharp_mask")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareUnsharpMask"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquare(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareBackgroundColor",
    jsii_struct_bases=[],
    name_mapping={"color": "color", "color_var": "colorVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareBackgroundColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1a334e186e59b23ac957e073a329f11681e1f4a7b795fdcf08ffae216dfa27b4)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareBackgroundColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareBackgroundColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareBackgroundColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__37366c200fc970175f65a045bc273b670537b416e6b0ec20b46096c8938529b6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareBackgroundColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__65fed233ce009324ee1df6e8069b1eed9e5964d22daff9dbd6cba57d170f95cf)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareBackgroundColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b3088613822cb461fa3bb6d1fad0647ad3a8870f3cee3e2da9627cdd7d6952be)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d3b90a7a33accbe4277852b63627101446c5ab2b44d7fe89de4a3edc1eecc872)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__35bc75c0f51917cdfda54cfc92afe1eb41f28aea76062035c0a495316e096489)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareBackgroundColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareBackgroundColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__70fcf8eee4836e6cb163cd72ffa5051ee0a39ad2c26978705dc16db0a70f2358)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareBackgroundColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareBackgroundColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1431f4adf8106ae97a446bd99a06bdf0e9ef77ef64e8f53d0fd1afd813b78222)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ffcee53886aa9a25c4754ff04dccf0047f23a6a4d4d42825480ab93923fe584b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__75c3db87d587fdc9d8f2a17abe971036f622adf18f33e553227b8f4bb8b0ccee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareBackgroundColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareBackgroundColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareBackgroundColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2b173d8012b0fb8cf0d5b56ac7254994273fcdac5d9c230beb4e80f7e2c5323e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareBlur",
    jsii_struct_bases=[],
    name_mapping={"sigma": "sigma", "sigma_var": "sigmaVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareBlur:
    def __init__(
        self,
        *,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param sigma: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c93f1162d4793b84dc173c5f494884ae2fe13c2cd215bd4c10a90ba28cf6a741)
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareBlur(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareBlurList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareBlurList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__72f7a0dbe5587edc24963898311c3558a6d36feb01c16b3a5c0692dbf5934f01)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareBlurOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eb224f05a3a8af5503ce17ffa31a35bb64230cf44db9c3176c1bf48d9c1bb2e3)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareBlurOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bf91f0dde4ebbb1b62f981046f76eecd3c8fefe7286ed6d1f6b7a3f92fd2cf21)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__22f663b28777ce71a3275e549f063616702bf446c7fd882dec9635e23fda94cc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b6c71d6efb211cc0974a23259f3b2da2f9bc712c97d52e9cdb599401bece1cc6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareBlur]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareBlur]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__da2658e055ceef05630f21d0ed8e7f0a9fc09a263287611ea55f88c99e1bbe8c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareBlurOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareBlurOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3eef5130ef126ad780f805395d62bb7651687e6988496c53929e6105502eebfe)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b30674cef0058cfb59ae226d4788564c980aacafc2e02bfaa583e919acaf992b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__771def2f29d6c1dbd4bf71f51cee3800c0928f176a9e2b62b83401a401a99daa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareBlur]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareBlur]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareBlur]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ee23f9f3ec5e31ff0d8f9dac4ee2b433ff44c6e0e44e13a67d754fe67cb98430)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareChromaKey",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_feather": "hueFeather",
        "hue_feather_var": "hueFeatherVar",
        "hue_tolerance": "hueTolerance",
        "hue_tolerance_var": "hueToleranceVar",
        "hue_var": "hueVar",
        "lightness_feather": "lightnessFeather",
        "lightness_feather_var": "lightnessFeatherVar",
        "lightness_tolerance": "lightnessTolerance",
        "lightness_tolerance_var": "lightnessToleranceVar",
        "saturation_feather": "saturationFeather",
        "saturation_feather_var": "saturationFeatherVar",
        "saturation_tolerance": "saturationTolerance",
        "saturation_tolerance_var": "saturationToleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareChromaKey:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_feather: typing.Optional[builtins.str] = None,
        hue_feather_var: typing.Optional[builtins.str] = None,
        hue_tolerance: typing.Optional[builtins.str] = None,
        hue_tolerance_var: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness_feather: typing.Optional[builtins.str] = None,
        lightness_feather_var: typing.Optional[builtins.str] = None,
        lightness_tolerance: typing.Optional[builtins.str] = None,
        lightness_tolerance_var: typing.Optional[builtins.str] = None,
        saturation_feather: typing.Optional[builtins.str] = None,
        saturation_feather_var: typing.Optional[builtins.str] = None,
        saturation_tolerance: typing.Optional[builtins.str] = None,
        saturation_tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_feather: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        :param hue_feather_var: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        :param hue_tolerance: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        :param hue_tolerance_var: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        :param hue_var: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness_feather: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        :param lightness_feather_var: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        :param lightness_tolerance: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        :param lightness_tolerance_var: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        :param saturation_feather: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        :param saturation_feather_var: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        :param saturation_tolerance: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        :param saturation_tolerance_var: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cc9e936e1666e9c899cb2607e41a641c7fdfaf34b6928653fe5801495ec20180)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_feather", value=hue_feather, expected_type=type_hints["hue_feather"])
            check_type(argname="argument hue_feather_var", value=hue_feather_var, expected_type=type_hints["hue_feather_var"])
            check_type(argname="argument hue_tolerance", value=hue_tolerance, expected_type=type_hints["hue_tolerance"])
            check_type(argname="argument hue_tolerance_var", value=hue_tolerance_var, expected_type=type_hints["hue_tolerance_var"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness_feather", value=lightness_feather, expected_type=type_hints["lightness_feather"])
            check_type(argname="argument lightness_feather_var", value=lightness_feather_var, expected_type=type_hints["lightness_feather_var"])
            check_type(argname="argument lightness_tolerance", value=lightness_tolerance, expected_type=type_hints["lightness_tolerance"])
            check_type(argname="argument lightness_tolerance_var", value=lightness_tolerance_var, expected_type=type_hints["lightness_tolerance_var"])
            check_type(argname="argument saturation_feather", value=saturation_feather, expected_type=type_hints["saturation_feather"])
            check_type(argname="argument saturation_feather_var", value=saturation_feather_var, expected_type=type_hints["saturation_feather_var"])
            check_type(argname="argument saturation_tolerance", value=saturation_tolerance, expected_type=type_hints["saturation_tolerance"])
            check_type(argname="argument saturation_tolerance_var", value=saturation_tolerance_var, expected_type=type_hints["saturation_tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_feather is not None:
            self._values["hue_feather"] = hue_feather
        if hue_feather_var is not None:
            self._values["hue_feather_var"] = hue_feather_var
        if hue_tolerance is not None:
            self._values["hue_tolerance"] = hue_tolerance
        if hue_tolerance_var is not None:
            self._values["hue_tolerance_var"] = hue_tolerance_var
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness_feather is not None:
            self._values["lightness_feather"] = lightness_feather
        if lightness_feather_var is not None:
            self._values["lightness_feather_var"] = lightness_feather_var
        if lightness_tolerance is not None:
            self._values["lightness_tolerance"] = lightness_tolerance
        if lightness_tolerance_var is not None:
            self._values["lightness_tolerance_var"] = lightness_tolerance_var
        if saturation_feather is not None:
            self._values["saturation_feather"] = saturation_feather
        if saturation_feather_var is not None:
            self._values["saturation_feather_var"] = saturation_feather_var
        if saturation_tolerance is not None:
            self._values["saturation_tolerance"] = saturation_tolerance
        if saturation_tolerance_var is not None:
            self._values["saturation_tolerance_var"] = saturation_tolerance_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        '''
        result = self._values.get("hue_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        '''
        result = self._values.get("hue_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        '''
        result = self._values.get("hue_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        '''
        result = self._values.get("hue_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        '''
        result = self._values.get("lightness_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        '''
        result = self._values.get("lightness_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        '''
        result = self._values.get("lightness_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        '''
        result = self._values.get("lightness_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        '''
        result = self._values.get("saturation_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        '''
        result = self._values.get("saturation_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        '''
        result = self._values.get("saturation_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        result = self._values.get("saturation_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareChromaKey(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareChromaKeyList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareChromaKeyList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0109e22311eca04d7ac9d181b5b65b8219609d1efaa65caa991541db756a9c4a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareChromaKeyOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df356fc058bf6254a703e631214aafeeff7425ccdde55424af12673dac8ad650)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareChromaKeyOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__23d37e1afc4248fb0a6f4358d5f855afcd4b86d16b6180fc90e3bfed8d962c80)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__612b14c086ae3e469cf33a44de7f6b15c329332e44c5490829d65598b5deb8ac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3cf098b935f61f67bc752b2db98b99fbcff09fa7928840e99d076e164ecc0d58)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareChromaKey]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareChromaKey]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d0b1a91dabee6914e4e1ab58d9180947b2a204ec0f38e71c953b20328c007cb3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareChromaKeyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareChromaKeyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f0b02445d04d7c3fb1313b139f55989620b4d61f3c4dfa4cac7aca0c2a50c024)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueFeather")
    def reset_hue_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeather", []))

    @jsii.member(jsii_name="resetHueFeatherVar")
    def reset_hue_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeatherVar", []))

    @jsii.member(jsii_name="resetHueTolerance")
    def reset_hue_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueTolerance", []))

    @jsii.member(jsii_name="resetHueToleranceVar")
    def reset_hue_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueToleranceVar", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightnessFeather")
    def reset_lightness_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeather", []))

    @jsii.member(jsii_name="resetLightnessFeatherVar")
    def reset_lightness_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeatherVar", []))

    @jsii.member(jsii_name="resetLightnessTolerance")
    def reset_lightness_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessTolerance", []))

    @jsii.member(jsii_name="resetLightnessToleranceVar")
    def reset_lightness_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessToleranceVar", []))

    @jsii.member(jsii_name="resetSaturationFeather")
    def reset_saturation_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeather", []))

    @jsii.member(jsii_name="resetSaturationFeatherVar")
    def reset_saturation_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeatherVar", []))

    @jsii.member(jsii_name="resetSaturationTolerance")
    def reset_saturation_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationTolerance", []))

    @jsii.member(jsii_name="resetSaturationToleranceVar")
    def reset_saturation_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherInput")
    def hue_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVarInput")
    def hue_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceInput")
    def hue_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVarInput")
    def hue_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherInput")
    def lightness_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVarInput")
    def lightness_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceInput")
    def lightness_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVarInput")
    def lightness_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherInput")
    def saturation_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVarInput")
    def saturation_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceInput")
    def saturation_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVarInput")
    def saturation_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d1b4df0864429b23b5a4a6c62ab2f624448028e81092aceeea1d735ebebca9be)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeather")
    def hue_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeather"))

    @hue_feather.setter
    def hue_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__50550e58b318b4e4460b4552562a8ffc64d77bc144d4e42df542cd64a8c89af9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeather", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVar")
    def hue_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeatherVar"))

    @hue_feather_var.setter
    def hue_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b30b2efa39212c1131d412790e0e6bb4a5e57315527a2f40446c331c6f8294a0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueTolerance")
    def hue_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueTolerance"))

    @hue_tolerance.setter
    def hue_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__55076e4bc39807210e5b72ef649139cf813e19004ccd4c4f939d3de049f6363b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVar")
    def hue_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueToleranceVar"))

    @hue_tolerance_var.setter
    def hue_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5b40649b7769063d156cd6979a4bc14ef9095c492254f6010c9e2615505220d1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dadb0f61b0a67bc95de6c582eed15a872d3067a6bdc340a4534a07de09c78c29)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeather")
    def lightness_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeather"))

    @lightness_feather.setter
    def lightness_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__80429befee2bf51e1810a0702dea9483f6a5d0c60da2d84678750cbb79a80359)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeather", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVar")
    def lightness_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeatherVar"))

    @lightness_feather_var.setter
    def lightness_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea1eb70d21fadcd85de41d3eff5712ce5140dd353cd9044accf2cda59f82b27f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessTolerance")
    def lightness_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessTolerance"))

    @lightness_tolerance.setter
    def lightness_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__408ebd2e1250c4c4b88a27866cc952ff46e6b158977457f1853bb8fc71d9ba27)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVar")
    def lightness_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessToleranceVar"))

    @lightness_tolerance_var.setter
    def lightness_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__76c0855b31dd42e6494866aef2016e66fd64364d4e0c4259a2d66e8c4a5cce1b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeather")
    def saturation_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeather"))

    @saturation_feather.setter
    def saturation_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fc76dd69a9230eafa5bcebbfecfb96a401d4043ce25407b9955e5a9a64916d93)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeather", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVar")
    def saturation_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeatherVar"))

    @saturation_feather_var.setter
    def saturation_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e2e8a282dbdb5970442e5e9335ad71df0636ef1bd71d4b43b0c57815013a9c83)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationTolerance")
    def saturation_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationTolerance"))

    @saturation_tolerance.setter
    def saturation_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__56baf62437f1168962f04058a4a28bd249421baa9e8878e5d79b9caae9464122)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVar")
    def saturation_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationToleranceVar"))

    @saturation_tolerance_var.setter
    def saturation_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0a1d736587781842fb9f63c8b361adc7b58147a633b08f6af5e6b7bb96c448fb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareChromaKey]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareChromaKey]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareChromaKey]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__124cebd425d12de13494fab2c926c8ce76216ee97fa6425179dea95628a797a5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareComposite",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "placement": "placement",
        "placement_var": "placementVar",
        "scale": "scale",
        "scale_dimension": "scaleDimension",
        "scale_dimension_var": "scaleDimensionVar",
        "scale_var": "scaleVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareComposite:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        placement: typing.Optional[builtins.str] = None,
        placement_var: typing.Optional[builtins.str] = None,
        scale: typing.Optional[builtins.str] = None,
        scale_dimension: typing.Optional[builtins.str] = None,
        scale_dimension_var: typing.Optional[builtins.str] = None,
        scale_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param placement: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        :param placement_var: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        :param scale: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param scale_dimension: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        :param scale_dimension_var: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        :param scale_var: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        :param x_position: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9bf2cbbb71bc6ca66e816cd36cff1448469ac2b6cb1b5e0f2fbd72c48f99cdc0)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument placement", value=placement, expected_type=type_hints["placement"])
            check_type(argname="argument placement_var", value=placement_var, expected_type=type_hints["placement_var"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument scale_dimension", value=scale_dimension, expected_type=type_hints["scale_dimension"])
            check_type(argname="argument scale_dimension_var", value=scale_dimension_var, expected_type=type_hints["scale_dimension_var"])
            check_type(argname="argument scale_var", value=scale_var, expected_type=type_hints["scale_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if placement is not None:
            self._values["placement"] = placement
        if placement_var is not None:
            self._values["placement_var"] = placement_var
        if scale is not None:
            self._values["scale"] = scale
        if scale_dimension is not None:
            self._values["scale_dimension"] = scale_dimension
        if scale_dimension_var is not None:
            self._values["scale_dimension_var"] = scale_dimension_var
        if scale_var is not None:
            self._values["scale_var"] = scale_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        '''
        result = self._values.get("placement")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement_var(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        '''
        result = self._values.get("placement_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        '''
        result = self._values.get("scale_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        '''
        result = self._values.get("scale_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        '''
        result = self._values.get("scale_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareComposite(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImage",
    jsii_struct_bases=[],
    name_mapping={
        "box_image": "boxImage",
        "circle_image": "circleImage",
        "text_image": "textImage",
        "url_image": "urlImage",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImage:
    def __init__(
        self,
        *,
        box_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageBoxImage", typing.Dict[builtins.str, typing.Any]]]]] = None,
        circle_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageCircleImage", typing.Dict[builtins.str, typing.Any]]]]] = None,
        text_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageTextImage", typing.Dict[builtins.str, typing.Any]]]]] = None,
        url_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageUrlImage", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param box_image: box_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#box_image DataAkamaiImagingPolicyImage#box_image}
        :param circle_image: circle_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#circle_image DataAkamaiImagingPolicyImage#circle_image}
        :param text_image: text_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text_image DataAkamaiImagingPolicyImage#text_image}
        :param url_image: url_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url_image DataAkamaiImagingPolicyImage#url_image}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0500a5cdea8166cbffd9b93cbe6b6d957985f915190b26b404f11fae397f2430)
            check_type(argname="argument box_image", value=box_image, expected_type=type_hints["box_image"])
            check_type(argname="argument circle_image", value=circle_image, expected_type=type_hints["circle_image"])
            check_type(argname="argument text_image", value=text_image, expected_type=type_hints["text_image"])
            check_type(argname="argument url_image", value=url_image, expected_type=type_hints["url_image"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if box_image is not None:
            self._values["box_image"] = box_image
        if circle_image is not None:
            self._values["circle_image"] = circle_image
        if text_image is not None:
            self._values["text_image"] = text_image
        if url_image is not None:
            self._values["url_image"] = url_image

    @builtins.property
    def box_image(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageBoxImage"]]]:
        '''box_image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#box_image DataAkamaiImagingPolicyImage#box_image}
        '''
        result = self._values.get("box_image")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageBoxImage"]]], result)

    @builtins.property
    def circle_image(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageCircleImage"]]]:
        '''circle_image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#circle_image DataAkamaiImagingPolicyImage#circle_image}
        '''
        result = self._values.get("circle_image")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageCircleImage"]]], result)

    @builtins.property
    def text_image(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageTextImage"]]]:
        '''text_image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text_image DataAkamaiImagingPolicyImage#text_image}
        '''
        result = self._values.get("text_image")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageTextImage"]]], result)

    @builtins.property
    def url_image(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageUrlImage"]]]:
        '''url_image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url_image DataAkamaiImagingPolicyImage#url_image}
        '''
        result = self._values.get("url_image")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageUrlImage"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageBoxImage",
    jsii_struct_bases=[],
    name_mapping={
        "color": "color",
        "color_var": "colorVar",
        "height": "height",
        "height_var": "heightVar",
        "transformation": "transformation",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageBoxImage:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        transformation: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageBoxImageTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The fill color of the box, not the edge of the box. The API supports hexadecimal representation and CSS hexadecimal color values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The fill color of the box, not the edge of the box. The API supports hexadecimal representation and CSS hexadecimal color values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        :param height: The height of the box in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height of the box in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param transformation: transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        :param width: The width of the box in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width of the box in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(transformation, dict):
            transformation = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageBoxImageTransformation(**transformation)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ee2aef863f0c1f044a24775f4e932886181b33be8b1e5077242341b2fc027dbb)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument transformation", value=transformation, expected_type=type_hints["transformation"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if transformation is not None:
            self._values["transformation"] = transformation
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The fill color of the box, not the edge of the box.

        The API supports hexadecimal representation and CSS hexadecimal color values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The fill color of the box, not the edge of the box.

        The API supports hexadecimal representation and CSS hexadecimal color values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height of the box in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height of the box in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def transformation(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageBoxImageTransformation"]:
        '''transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        '''
        result = self._values.get("transformation")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageBoxImageTransformation"], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width of the box in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width of the box in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageBoxImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageBoxImageList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageBoxImageList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1c14520f3e8b623e54e6bd44ab8eb61be18a64a982e7928a6668d9b4ad31e06d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageBoxImageOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b64a8c9265896040a3a6f3fab0f4372f0aca1f492f7da518c0df89199bc92567)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageBoxImageOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f45f906f7e46103175798bb03cac25fa92b691fae0a7178bbf8d9a18c6f0961c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__19229d7bccdb9e7b8c681c7f15119b56e639447dd3ab4876fc8d951812665b92)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__13490a71402102ef45738d08883d65b7f974a607a9fbf0d35843c474122ec8f4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageBoxImage]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageBoxImage]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageBoxImage]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__51c4da75aa36e7577bbb23b8d5ac315af425765e31f1d8fd7a68b1fa54d1227c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageBoxImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageBoxImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__556e815b7c90133b3ea1144e8615600a99a4bc19ad2efef8e950b9fa4aa2357c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformation")
    def put_transformation(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageBoxImageTransformation()

        return typing.cast(None, jsii.invoke(self, "putTransformation", [value]))

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetTransformation")
    def reset_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformation", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="transformation")
    def transformation(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageBoxImageTransformationOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageBoxImageTransformationOutputReference", jsii.get(self, "transformation"))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="transformationInput")
    def transformation_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageBoxImageTransformation"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageBoxImageTransformation"], jsii.get(self, "transformationInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b962b7b98c3bfe0427b84886d497cf556e7aade1d972c61cf9bc883093006f59)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab1d4fece1666aa04db12db125f97fdf3a3f6194bd12a27cbb97a1188afc4ac8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__15e3f62e929f87860523e29312c5c790d9326b37e3db98420539f701ba045d7c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__43f609b0315bbdb6885d966d3eb856947b1619a38df3a8fd95135dac686b8c83)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__298777cfcd4bb4e0cc05047c018ecae63bef9232cf6adc9d6277d0c0f113496c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__455c9ae88087640efeb8db83dcf1e879fa36b1d42d4eca39e09d25beea9101b1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageBoxImage]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageBoxImage]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageBoxImage]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__214f75e2d75380f3dd0e7c4b4621286cb7e8e4060395d5b56842f6413ec606d2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageBoxImageTransformation",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageBoxImageTransformation:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageBoxImageTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageBoxImageTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageBoxImageTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b39562cab00b38a0da8e52501a959fcd903610ea628ebb616f2a39078d6631e4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageBoxImageTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageBoxImageTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageBoxImageTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0e72870bb4cfc0b8a216b86491b1329eb90b7a6cf8367d9a445c0b2af8d8542e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageCircleImage",
    jsii_struct_bases=[],
    name_mapping={
        "color": "color",
        "color_var": "colorVar",
        "diameter": "diameter",
        "diameter_var": "diameterVar",
        "transformation": "transformation",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageCircleImage:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
        diameter: typing.Optional[builtins.str] = None,
        diameter_var: typing.Optional[builtins.str] = None,
        transformation: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageCircleImageTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The fill color of the circle. The API supports hexadecimal representation and CSS hexadecimal color values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The fill color of the circle. The API supports hexadecimal representation and CSS hexadecimal color values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        :param diameter: The diameter of the circle. The diameter will be the width and the height of the image in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#diameter DataAkamaiImagingPolicyImage#diameter}
        :param diameter_var: The diameter of the circle. The diameter will be the width and the height of the image in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#diameter_var DataAkamaiImagingPolicyImage#diameter_var}
        :param transformation: transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        :param width: The width of the box in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width of the box in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(transformation, dict):
            transformation = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageCircleImageTransformation(**transformation)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8664304ad6e808ffa808a3040d042a53f4983a59d9b281b67ea9f86d40548f8c)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
            check_type(argname="argument diameter", value=diameter, expected_type=type_hints["diameter"])
            check_type(argname="argument diameter_var", value=diameter_var, expected_type=type_hints["diameter_var"])
            check_type(argname="argument transformation", value=transformation, expected_type=type_hints["transformation"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var
        if diameter is not None:
            self._values["diameter"] = diameter
        if diameter_var is not None:
            self._values["diameter_var"] = diameter_var
        if transformation is not None:
            self._values["transformation"] = transformation
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The fill color of the circle. The API supports hexadecimal representation and CSS hexadecimal color values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The fill color of the circle. The API supports hexadecimal representation and CSS hexadecimal color values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def diameter(self) -> typing.Optional[builtins.str]:
        '''The diameter of the circle. The diameter will be the width and the height of the image in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#diameter DataAkamaiImagingPolicyImage#diameter}
        '''
        result = self._values.get("diameter")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def diameter_var(self) -> typing.Optional[builtins.str]:
        '''The diameter of the circle. The diameter will be the width and the height of the image in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#diameter_var DataAkamaiImagingPolicyImage#diameter_var}
        '''
        result = self._values.get("diameter_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def transformation(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageCircleImageTransformation"]:
        '''transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        '''
        result = self._values.get("transformation")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageCircleImageTransformation"], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width of the box in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width of the box in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageCircleImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageCircleImageList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageCircleImageList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd1bc95b8bf714fce1a7749b358f415022538178d237ad13fa1f9c9e252c946f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageCircleImageOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__48b9ad5b0ec4df7e2a22e10ff4b06ff34c537e252e4120da415e5f5766c389f2)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageCircleImageOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8fee449b6ec4b048c236b1a0f9b05e5170a2fc2ced99c7814ef7d407ad6e2ece)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4822f42e380b6c2f9c8b60bc216428552b2303066aca60d00d5a98b2dd6cb02e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b1d1fa003f92cf9072fd886a0c57ba8684d638352ff2289d392c50e60a5c009a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageCircleImage]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageCircleImage]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageCircleImage]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8581df7b7b4e0cd3bd0d41e1c097575f404cee208306ddfe6a5e9c5b41ad9e52)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageCircleImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageCircleImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6728aeb57ec30e31e91ff5129c53d02e148adbb93e70962ed4c0746546a45542)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformation")
    def put_transformation(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageCircleImageTransformation()

        return typing.cast(None, jsii.invoke(self, "putTransformation", [value]))

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @jsii.member(jsii_name="resetDiameter")
    def reset_diameter(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDiameter", []))

    @jsii.member(jsii_name="resetDiameterVar")
    def reset_diameter_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDiameterVar", []))

    @jsii.member(jsii_name="resetTransformation")
    def reset_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformation", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="transformation")
    def transformation(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageCircleImageTransformationOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageCircleImageTransformationOutputReference", jsii.get(self, "transformation"))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="diameterInput")
    def diameter_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "diameterInput"))

    @builtins.property
    @jsii.member(jsii_name="diameterVarInput")
    def diameter_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "diameterVarInput"))

    @builtins.property
    @jsii.member(jsii_name="transformationInput")
    def transformation_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageCircleImageTransformation"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageCircleImageTransformation"], jsii.get(self, "transformationInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fbd3377f4699f6cce3753713790c4c3507433c091fceca8860b6ee54d921410b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7fa30f3e16ed20e6dfcadd0bec8c3773444ed9d195bf02966298a2163f5c9040)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="diameter")
    def diameter(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "diameter"))

    @diameter.setter
    def diameter(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3e282a4c2ac1f8168a7fe3ec575145b169fcc192846e1beef36c763649c76c76)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "diameter", value)

    @builtins.property
    @jsii.member(jsii_name="diameterVar")
    def diameter_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "diameterVar"))

    @diameter_var.setter
    def diameter_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0330a4b12ba7deb09b3ac7cd404355c56266dcf7908564542e53384a402eba14)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "diameterVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cb39ac9ac61daed8493351b2cfc0cd41e528c42befb0ea97a9b69926aa477022)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__374923925af89713d13f0984fddf6ef5c1a2594fa36e902a75cb6736a1d00a8a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageCircleImage]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageCircleImage]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageCircleImage]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d7e9646d175b88cbc5e569e8c8627e8227335dd0bc0fce8573becfc314b088cc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageCircleImageTransformation",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageCircleImageTransformation:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageCircleImageTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageCircleImageTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageCircleImageTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fbaee11f4e150bd797b9bb08ff65aecba2a4a38f83e48d29dbf10e8f533c8e90)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageCircleImageTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageCircleImageTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageCircleImageTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a0438f9baf0f218d2c445564e9f68ad04e76653f7f2650e40d79b8877d3211b2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__176801e26f6700bc83150c1b43233f7961de2ee7b4dc58e6ef8c592a7ec7b77b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putBoxImage")
    def put_box_image(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageBoxImage, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c5e9e972576f8eb739dcbea3e4c1812367a25e4f190a0d2dbe27b7492770c064)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBoxImage", [value]))

    @jsii.member(jsii_name="putCircleImage")
    def put_circle_image(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageCircleImage, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__11147f3b872af76640f90a5000459205d7493c962782ff6740e9b31ebbe12958)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCircleImage", [value]))

    @jsii.member(jsii_name="putTextImage")
    def put_text_image(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageTextImage", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ba3ae2852817b21c106451175a7c6c50b022804124a48073442c0a1b1121d0e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTextImage", [value]))

    @jsii.member(jsii_name="putUrlImage")
    def put_url_image(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageUrlImage", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__593381c563ba07c377875177100522eb20c3029cef041a060901c7c7a4de26f7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putUrlImage", [value]))

    @jsii.member(jsii_name="resetBoxImage")
    def reset_box_image(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBoxImage", []))

    @jsii.member(jsii_name="resetCircleImage")
    def reset_circle_image(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCircleImage", []))

    @jsii.member(jsii_name="resetTextImage")
    def reset_text_image(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTextImage", []))

    @jsii.member(jsii_name="resetUrlImage")
    def reset_url_image(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUrlImage", []))

    @builtins.property
    @jsii.member(jsii_name="boxImage")
    def box_image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageBoxImageList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageBoxImageList, jsii.get(self, "boxImage"))

    @builtins.property
    @jsii.member(jsii_name="circleImage")
    def circle_image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageCircleImageList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageCircleImageList, jsii.get(self, "circleImage"))

    @builtins.property
    @jsii.member(jsii_name="textImage")
    def text_image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageTextImageList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageTextImageList", jsii.get(self, "textImage"))

    @builtins.property
    @jsii.member(jsii_name="urlImage")
    def url_image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageUrlImageList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageUrlImageList", jsii.get(self, "urlImage"))

    @builtins.property
    @jsii.member(jsii_name="boxImageInput")
    def box_image_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageBoxImage]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageBoxImage]]], jsii.get(self, "boxImageInput"))

    @builtins.property
    @jsii.member(jsii_name="circleImageInput")
    def circle_image_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageCircleImage]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageCircleImage]]], jsii.get(self, "circleImageInput"))

    @builtins.property
    @jsii.member(jsii_name="textImageInput")
    def text_image_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageTextImage"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageTextImage"]]], jsii.get(self, "textImageInput"))

    @builtins.property
    @jsii.member(jsii_name="urlImageInput")
    def url_image_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageUrlImage"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageUrlImage"]]], jsii.get(self, "urlImageInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fc37440f5088422e5708af59176064dba70ef4c95985a8a0959a780c4dfec280)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageTextImage",
    jsii_struct_bases=[],
    name_mapping={
        "fill": "fill",
        "fill_var": "fillVar",
        "size": "size",
        "size_var": "sizeVar",
        "stroke": "stroke",
        "stroke_size": "strokeSize",
        "stroke_size_var": "strokeSizeVar",
        "stroke_var": "strokeVar",
        "text": "text",
        "text_var": "textVar",
        "transformation": "transformation",
        "typeface": "typeface",
        "typeface_var": "typefaceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageTextImage:
    def __init__(
        self,
        *,
        fill: typing.Optional[builtins.str] = None,
        fill_var: typing.Optional[builtins.str] = None,
        size: typing.Optional[builtins.str] = None,
        size_var: typing.Optional[builtins.str] = None,
        stroke: typing.Optional[builtins.str] = None,
        stroke_size: typing.Optional[builtins.str] = None,
        stroke_size_var: typing.Optional[builtins.str] = None,
        stroke_var: typing.Optional[builtins.str] = None,
        text: typing.Optional[builtins.str] = None,
        text_var: typing.Optional[builtins.str] = None,
        transformation: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageTextImageTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        typeface: typing.Optional[builtins.str] = None,
        typeface_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fill: The main fill color of the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill DataAkamaiImagingPolicyImage#fill}
        :param fill_var: The main fill color of the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_var DataAkamaiImagingPolicyImage#fill_var}
        :param size: The size in pixels to render the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#size DataAkamaiImagingPolicyImage#size}
        :param size_var: The size in pixels to render the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#size_var DataAkamaiImagingPolicyImage#size_var}
        :param stroke: The color for the outline of the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke DataAkamaiImagingPolicyImage#stroke}
        :param stroke_size: The thickness in points for the outline of the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_size DataAkamaiImagingPolicyImage#stroke_size}
        :param stroke_size_var: The thickness in points for the outline of the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_size_var DataAkamaiImagingPolicyImage#stroke_size_var}
        :param stroke_var: The color for the outline of the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_var DataAkamaiImagingPolicyImage#stroke_var}
        :param text: The line of text to render. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text DataAkamaiImagingPolicyImage#text}
        :param text_var: The line of text to render. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text_var DataAkamaiImagingPolicyImage#text_var}
        :param transformation: transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        :param typeface: The font family to apply to the text image. This may be a URL to a TrueType or WOFF (v1) typeface, or a string that refers to one of the standard built-in browser fonts. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#typeface DataAkamaiImagingPolicyImage#typeface}
        :param typeface_var: The font family to apply to the text image. This may be a URL to a TrueType or WOFF (v1) typeface, or a string that refers to one of the standard built-in browser fonts. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#typeface_var DataAkamaiImagingPolicyImage#typeface_var}
        '''
        if isinstance(transformation, dict):
            transformation = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageTextImageTransformation(**transformation)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dc2bd63c1f74814f72b0d433943883d88a40c0365245c9db26e62362aaa67e6b)
            check_type(argname="argument fill", value=fill, expected_type=type_hints["fill"])
            check_type(argname="argument fill_var", value=fill_var, expected_type=type_hints["fill_var"])
            check_type(argname="argument size", value=size, expected_type=type_hints["size"])
            check_type(argname="argument size_var", value=size_var, expected_type=type_hints["size_var"])
            check_type(argname="argument stroke", value=stroke, expected_type=type_hints["stroke"])
            check_type(argname="argument stroke_size", value=stroke_size, expected_type=type_hints["stroke_size"])
            check_type(argname="argument stroke_size_var", value=stroke_size_var, expected_type=type_hints["stroke_size_var"])
            check_type(argname="argument stroke_var", value=stroke_var, expected_type=type_hints["stroke_var"])
            check_type(argname="argument text", value=text, expected_type=type_hints["text"])
            check_type(argname="argument text_var", value=text_var, expected_type=type_hints["text_var"])
            check_type(argname="argument transformation", value=transformation, expected_type=type_hints["transformation"])
            check_type(argname="argument typeface", value=typeface, expected_type=type_hints["typeface"])
            check_type(argname="argument typeface_var", value=typeface_var, expected_type=type_hints["typeface_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fill is not None:
            self._values["fill"] = fill
        if fill_var is not None:
            self._values["fill_var"] = fill_var
        if size is not None:
            self._values["size"] = size
        if size_var is not None:
            self._values["size_var"] = size_var
        if stroke is not None:
            self._values["stroke"] = stroke
        if stroke_size is not None:
            self._values["stroke_size"] = stroke_size
        if stroke_size_var is not None:
            self._values["stroke_size_var"] = stroke_size_var
        if stroke_var is not None:
            self._values["stroke_var"] = stroke_var
        if text is not None:
            self._values["text"] = text
        if text_var is not None:
            self._values["text_var"] = text_var
        if transformation is not None:
            self._values["transformation"] = transformation
        if typeface is not None:
            self._values["typeface"] = typeface
        if typeface_var is not None:
            self._values["typeface_var"] = typeface_var

    @builtins.property
    def fill(self) -> typing.Optional[builtins.str]:
        '''The main fill color of the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill DataAkamaiImagingPolicyImage#fill}
        '''
        result = self._values.get("fill")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fill_var(self) -> typing.Optional[builtins.str]:
        '''The main fill color of the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_var DataAkamaiImagingPolicyImage#fill_var}
        '''
        result = self._values.get("fill_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def size(self) -> typing.Optional[builtins.str]:
        '''The size in pixels to render the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#size DataAkamaiImagingPolicyImage#size}
        '''
        result = self._values.get("size")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def size_var(self) -> typing.Optional[builtins.str]:
        '''The size in pixels to render the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#size_var DataAkamaiImagingPolicyImage#size_var}
        '''
        result = self._values.get("size_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def stroke(self) -> typing.Optional[builtins.str]:
        '''The color for the outline of the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke DataAkamaiImagingPolicyImage#stroke}
        '''
        result = self._values.get("stroke")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def stroke_size(self) -> typing.Optional[builtins.str]:
        '''The thickness in points for the outline of the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_size DataAkamaiImagingPolicyImage#stroke_size}
        '''
        result = self._values.get("stroke_size")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def stroke_size_var(self) -> typing.Optional[builtins.str]:
        '''The thickness in points for the outline of the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_size_var DataAkamaiImagingPolicyImage#stroke_size_var}
        '''
        result = self._values.get("stroke_size_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def stroke_var(self) -> typing.Optional[builtins.str]:
        '''The color for the outline of the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_var DataAkamaiImagingPolicyImage#stroke_var}
        '''
        result = self._values.get("stroke_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def text(self) -> typing.Optional[builtins.str]:
        '''The line of text to render.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text DataAkamaiImagingPolicyImage#text}
        '''
        result = self._values.get("text")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def text_var(self) -> typing.Optional[builtins.str]:
        '''The line of text to render.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text_var DataAkamaiImagingPolicyImage#text_var}
        '''
        result = self._values.get("text_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def transformation(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageTextImageTransformation"]:
        '''transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        '''
        result = self._values.get("transformation")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageTextImageTransformation"], result)

    @builtins.property
    def typeface(self) -> typing.Optional[builtins.str]:
        '''The font family to apply to the text image.

        This may be a URL to a TrueType or WOFF (v1) typeface, or a string that refers to one of the standard built-in browser fonts.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#typeface DataAkamaiImagingPolicyImage#typeface}
        '''
        result = self._values.get("typeface")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def typeface_var(self) -> typing.Optional[builtins.str]:
        '''The font family to apply to the text image.

        This may be a URL to a TrueType or WOFF (v1) typeface, or a string that refers to one of the standard built-in browser fonts.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#typeface_var DataAkamaiImagingPolicyImage#typeface_var}
        '''
        result = self._values.get("typeface_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageTextImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageTextImageList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageTextImageList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ec90b22803a1e921e2502db0ec363bc5452cfefd0c05cf19e0c96e65811bc169)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageTextImageOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0dbf5ba3bdfa60d7c44255bb681d606ace99cc922abe9d12fd19024897577a61)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageTextImageOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b5b589bb702a548e682b201cb1bfb7f408b63f7d3146496e87239a69d42220a9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8c471d0413d5ccdb664ad7444cecdbd436f9b7c1df22e317f319b74fda7caa79)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__66433ac73249e422884020e95fc9ea6d82e44b7f84babc2bede87a961f5fd4da)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageTextImage]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageTextImage]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageTextImage]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ba79c078f92ea12bad90e2f70f3dca474857efea2a141c870f390c26fb06664f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageTextImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageTextImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f800026ef17c62f834eb0cae6e131ce20a0ca6d885cdc462e53014595f33c741)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformation")
    def put_transformation(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageTextImageTransformation()

        return typing.cast(None, jsii.invoke(self, "putTransformation", [value]))

    @jsii.member(jsii_name="resetFill")
    def reset_fill(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFill", []))

    @jsii.member(jsii_name="resetFillVar")
    def reset_fill_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFillVar", []))

    @jsii.member(jsii_name="resetSize")
    def reset_size(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSize", []))

    @jsii.member(jsii_name="resetSizeVar")
    def reset_size_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSizeVar", []))

    @jsii.member(jsii_name="resetStroke")
    def reset_stroke(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStroke", []))

    @jsii.member(jsii_name="resetStrokeSize")
    def reset_stroke_size(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStrokeSize", []))

    @jsii.member(jsii_name="resetStrokeSizeVar")
    def reset_stroke_size_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStrokeSizeVar", []))

    @jsii.member(jsii_name="resetStrokeVar")
    def reset_stroke_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStrokeVar", []))

    @jsii.member(jsii_name="resetText")
    def reset_text(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetText", []))

    @jsii.member(jsii_name="resetTextVar")
    def reset_text_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTextVar", []))

    @jsii.member(jsii_name="resetTransformation")
    def reset_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformation", []))

    @jsii.member(jsii_name="resetTypeface")
    def reset_typeface(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeface", []))

    @jsii.member(jsii_name="resetTypefaceVar")
    def reset_typeface_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypefaceVar", []))

    @builtins.property
    @jsii.member(jsii_name="transformation")
    def transformation(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageTextImageTransformationOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageTextImageTransformationOutputReference", jsii.get(self, "transformation"))

    @builtins.property
    @jsii.member(jsii_name="fillInput")
    def fill_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fillInput"))

    @builtins.property
    @jsii.member(jsii_name="fillVarInput")
    def fill_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fillVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sizeInput")
    def size_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sizeInput"))

    @builtins.property
    @jsii.member(jsii_name="sizeVarInput")
    def size_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sizeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="strokeInput")
    def stroke_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "strokeInput"))

    @builtins.property
    @jsii.member(jsii_name="strokeSizeInput")
    def stroke_size_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "strokeSizeInput"))

    @builtins.property
    @jsii.member(jsii_name="strokeSizeVarInput")
    def stroke_size_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "strokeSizeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="strokeVarInput")
    def stroke_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "strokeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="textInput")
    def text_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "textInput"))

    @builtins.property
    @jsii.member(jsii_name="textVarInput")
    def text_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "textVarInput"))

    @builtins.property
    @jsii.member(jsii_name="transformationInput")
    def transformation_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageTextImageTransformation"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageTextImageTransformation"], jsii.get(self, "transformationInput"))

    @builtins.property
    @jsii.member(jsii_name="typefaceInput")
    def typeface_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typefaceInput"))

    @builtins.property
    @jsii.member(jsii_name="typefaceVarInput")
    def typeface_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typefaceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="fill")
    def fill(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fill"))

    @fill.setter
    def fill(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__73235df27d6155bff287c729c4fac4e4ad1e4d13b68f235cfd84ab62d8908bd6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fill", value)

    @builtins.property
    @jsii.member(jsii_name="fillVar")
    def fill_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fillVar"))

    @fill_var.setter
    def fill_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a2dd9b3bccc7b922dccce51a524e7ee8063d819c89650c6e6dd4769d566de454)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fillVar", value)

    @builtins.property
    @jsii.member(jsii_name="size")
    def size(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "size"))

    @size.setter
    def size(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a5d352b55c7aaa308a9d9635e529d1b87463ced8a6cf7a8cd5261feb4f38722)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "size", value)

    @builtins.property
    @jsii.member(jsii_name="sizeVar")
    def size_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sizeVar"))

    @size_var.setter
    def size_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__65cfb721d9bc42e90f8d383a296392ad5be6d093b806334d1335c260610db793)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sizeVar", value)

    @builtins.property
    @jsii.member(jsii_name="stroke")
    def stroke(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "stroke"))

    @stroke.setter
    def stroke(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c9aa2a8ca9490a62c1a559133bcddb531544c1ecc77e11c3b59d19f26367e7c7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "stroke", value)

    @builtins.property
    @jsii.member(jsii_name="strokeSize")
    def stroke_size(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "strokeSize"))

    @stroke_size.setter
    def stroke_size(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b02e9c41a223325dbefbfcd62fc9db65b956c4b0933f372fee07e92751d17bc7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "strokeSize", value)

    @builtins.property
    @jsii.member(jsii_name="strokeSizeVar")
    def stroke_size_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "strokeSizeVar"))

    @stroke_size_var.setter
    def stroke_size_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6679b72bb0d56a9f7b70c06bed11997d82e36e93143d3eb569da26ef0694497b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "strokeSizeVar", value)

    @builtins.property
    @jsii.member(jsii_name="strokeVar")
    def stroke_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "strokeVar"))

    @stroke_var.setter
    def stroke_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c0f2671b0644ecdab869f08e9eb825fc262d94af08721af0afbc4efd886b13ce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "strokeVar", value)

    @builtins.property
    @jsii.member(jsii_name="text")
    def text(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "text"))

    @text.setter
    def text(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b15a22504bbfde520d77eda3304663da87e80c92ac889b5c7f3999843e8c94d9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "text", value)

    @builtins.property
    @jsii.member(jsii_name="textVar")
    def text_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "textVar"))

    @text_var.setter
    def text_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__51ac005a9407b13ec44fd27f2531cee637f1dd5caa9ded203fc439e4ebaf3194)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "textVar", value)

    @builtins.property
    @jsii.member(jsii_name="typeface")
    def typeface(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeface"))

    @typeface.setter
    def typeface(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__503d5a639c7d31f251ac5f83d76839c30be5700d810fe73a6c836b1e2e8c6226)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeface", value)

    @builtins.property
    @jsii.member(jsii_name="typefaceVar")
    def typeface_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typefaceVar"))

    @typeface_var.setter
    def typeface_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__98bf504af1330607c8d8f926a3ee9e99928ce2177c1840f3cd527029d17bc255)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typefaceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageTextImage]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageTextImage]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageTextImage]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6516bfae04ae4c53ec917302aa062738bdbe726ef60fa0d5b116a7eb1c1b924e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageTextImageTransformation",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageTextImageTransformation:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageTextImageTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageTextImageTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageTextImageTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9381318927d28c03af3cdacb2f2118d8b454993a064dbe1029c1e1540ad2ec5b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageTextImageTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageTextImageTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageTextImageTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9191a95b2ff46037f1618d05fbd08189743ac79ad4051026a9ea430da9935c63)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageUrlImage",
    jsii_struct_bases=[],
    name_mapping={
        "transformation": "transformation",
        "url": "url",
        "url_var": "urlVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageUrlImage:
    def __init__(
        self,
        *,
        transformation: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageUrlImageTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        url: typing.Optional[builtins.str] = None,
        url_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param transformation: transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        :param url: The URL of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url DataAkamaiImagingPolicyImage#url}
        :param url_var: The URL of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url_var DataAkamaiImagingPolicyImage#url_var}
        '''
        if isinstance(transformation, dict):
            transformation = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageUrlImageTransformation(**transformation)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__783ef07ad0983bd89b593c8d1087b95d5a57a8dfda1059480e436ddc8d8a6e2e)
            check_type(argname="argument transformation", value=transformation, expected_type=type_hints["transformation"])
            check_type(argname="argument url", value=url, expected_type=type_hints["url"])
            check_type(argname="argument url_var", value=url_var, expected_type=type_hints["url_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if transformation is not None:
            self._values["transformation"] = transformation
        if url is not None:
            self._values["url"] = url
        if url_var is not None:
            self._values["url_var"] = url_var

    @builtins.property
    def transformation(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageUrlImageTransformation"]:
        '''transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        '''
        result = self._values.get("transformation")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageUrlImageTransformation"], result)

    @builtins.property
    def url(self) -> typing.Optional[builtins.str]:
        '''The URL of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url DataAkamaiImagingPolicyImage#url}
        '''
        result = self._values.get("url")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def url_var(self) -> typing.Optional[builtins.str]:
        '''The URL of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url_var DataAkamaiImagingPolicyImage#url_var}
        '''
        result = self._values.get("url_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageUrlImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageUrlImageList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageUrlImageList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__73c6e9504f723444e865d1b313ad55b3cd67b0fbe2c598fcbe0e4348cdee9f19)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageUrlImageOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__328a3c7c78e680d8d699bcb811ea64afe3299ae64ddae78ee477fd5c53ec641c)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageUrlImageOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__41742388e26a54536fe2f28f419c080a2cd9f452079d79a9d76e42d501ba416e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa89091d0c7a6c55a22c877f860afb9d589c137f4dd75ec31ef2659dc7f61c09)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3afa5f7ba4f7cfb0b30ae54816eb64b62fb2c53bb691912b7c8bfdc4a2ea449c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageUrlImage]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageUrlImage]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageUrlImage]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__75eaf5c6a48118d588444a907d41f0fced0082d578db889201d6da0d3bd59387)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageUrlImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageUrlImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4116e5927c8abcda12aff5cdf971d7b27febb150701a714b9236f3f8cac67a87)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformation")
    def put_transformation(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageUrlImageTransformation()

        return typing.cast(None, jsii.invoke(self, "putTransformation", [value]))

    @jsii.member(jsii_name="resetTransformation")
    def reset_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformation", []))

    @jsii.member(jsii_name="resetUrl")
    def reset_url(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUrl", []))

    @jsii.member(jsii_name="resetUrlVar")
    def reset_url_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUrlVar", []))

    @builtins.property
    @jsii.member(jsii_name="transformation")
    def transformation(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageUrlImageTransformationOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageUrlImageTransformationOutputReference", jsii.get(self, "transformation"))

    @builtins.property
    @jsii.member(jsii_name="transformationInput")
    def transformation_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageUrlImageTransformation"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageUrlImageTransformation"], jsii.get(self, "transformationInput"))

    @builtins.property
    @jsii.member(jsii_name="urlInput")
    def url_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "urlInput"))

    @builtins.property
    @jsii.member(jsii_name="urlVarInput")
    def url_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "urlVarInput"))

    @builtins.property
    @jsii.member(jsii_name="url")
    def url(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "url"))

    @url.setter
    def url(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c06a1d56ffb16b378932621b1f918b6d64dd4104225143d475b2364554e4e2ac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "url", value)

    @builtins.property
    @jsii.member(jsii_name="urlVar")
    def url_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "urlVar"))

    @url_var.setter
    def url_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__24a60dfc09dc3ea2ca134d97445f32799e667313db32c08593f21d7788568480)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "urlVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageUrlImage]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageUrlImage]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageUrlImage]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d93a4da2954920171772b5c9aca24787326f82cbcbd1602a3ff33d0ef20f08b5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageUrlImageTransformation",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageUrlImageTransformation:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageUrlImageTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageUrlImageTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageUrlImageTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f4144791cc2379dd83a44919702ffab236e52b4e4ab81a1073b212d7a086e5a9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageUrlImageTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageUrlImageTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageUrlImageTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7dd1b490912d469ca48c6d6dd5c4be5c36e32d61e0f9e3d6b7f5148ebc8e3a40)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f7730af0579f0fcb628119e7a5d86291c585938b001f9570e61c30251a823072)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0376e965f3f37d387373333afd21fb2c626886db89748f2e9fb6cc70913e7c12)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d1aec2e00315ba419d9d18e6887d4a455b37a6abd001d6a79e46ffd3a948e143)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__88a8c98c5a6ce8554b99b264cf91479c9f0cb7e707bae745a3eec339ee24dfcf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__da29f326c1cb96b2638e67fc71718c4e0b693e74e628970e833599de2017da70)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareComposite]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareComposite]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fda3452797096163dadb3f276fd3f0308389179dd36b7ee57df6fceb8182cdce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__96e2190df8fb5a5a2fa8dd2f730657083810fd18b8a302a55accff60dde47020)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(
        self,
        *,
        box_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageBoxImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
        circle_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageCircleImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
        text_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageTextImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
        url_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageUrlImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param box_image: box_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#box_image DataAkamaiImagingPolicyImage#box_image}
        :param circle_image: circle_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#circle_image DataAkamaiImagingPolicyImage#circle_image}
        :param text_image: text_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text_image DataAkamaiImagingPolicyImage#text_image}
        :param url_image: url_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url_image DataAkamaiImagingPolicyImage#url_image}
        '''
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImage(
            box_image=box_image,
            circle_image=circle_image,
            text_image=text_image,
            url_image=url_image,
        )

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPlacement")
    def reset_placement(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacement", []))

    @jsii.member(jsii_name="resetPlacementVar")
    def reset_placement_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacementVar", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetScaleDimension")
    def reset_scale_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimension", []))

    @jsii.member(jsii_name="resetScaleDimensionVar")
    def reset_scale_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimensionVar", []))

    @jsii.member(jsii_name="resetScaleVar")
    def reset_scale_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="placementInput")
    def placement_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementInput"))

    @builtins.property
    @jsii.member(jsii_name="placementVarInput")
    def placement_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionInput")
    def scale_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVarInput")
    def scale_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleVarInput")
    def scale_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e70c9c1217cf52198e9dc7bd5268b5eb9e1420dbe6590356886a1ab75c4cb132)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__764d5dfcc8bc4586d393403974df89d70efdf5cd8d389aab41c31f69eb4970ab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="placement")
    def placement(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placement"))

    @placement.setter
    def placement(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__73c62e5b9b9ceec32f052a7fab9c06636f5f564d8c8c80ad3858f9dbbc3cd938)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placement", value)

    @builtins.property
    @jsii.member(jsii_name="placementVar")
    def placement_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placementVar"))

    @placement_var.setter
    def placement_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__464694a77e1b59a1ff623003a89293ca1dd7dac4245563cd1cea3ac2c69ebe42)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placementVar", value)

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scale"))

    @scale.setter
    def scale(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bdf53602ee5b07eca1647ae436113d32e6c1f34e7103e362ca375075b537cf93)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scale", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimension")
    def scale_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimension"))

    @scale_dimension.setter
    def scale_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__318184380cad000e755b37626f449eabae7689b00c027e8a0c41879da0a62ed0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimension", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVar")
    def scale_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimensionVar"))

    @scale_dimension_var.setter
    def scale_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8ac53c8cc3b546bf006826af1b795ff72f2ca4a7aadd1f1e575c0c65ea8ec740)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="scaleVar")
    def scale_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleVar"))

    @scale_var.setter
    def scale_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f59dcf19c184165a71711373eac913bb8e6789274025fda43818dd34c89262cc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bca67dbb5f85b60f86dcd3efa91e7b65ea74390eed3012923a48eefa447f985c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fc422597e1c750e080559e1a158c40f9c5356a858f1a22f58e92cfd01bbeb8d2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5b1fbb3eaa1cbea4c6874c468dfd411973a6912c698a59c8b2efd6bb2d2fa357)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__baa68ffdb4e01ad43553a55dfeebef0acad29060797c89f3b71521103f48af28)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareComposite]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareComposite]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareComposite]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5e5192fd748ec4f23c90f343a6327983fa1600bd6b47b39e4ab619ef65718e86)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompound",
    jsii_struct_bases=[],
    name_mapping={"transformations": "transformations"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompound:
    def __init__(
        self,
        *,
        transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param transformations: transformations block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bac33009b30bedc808ec5f57403eabbbd4bf31e1a04566cf2d41f84131fac239)
            check_type(argname="argument transformations", value=transformations, expected_type=type_hints["transformations"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if transformations is not None:
            self._values["transformations"] = transformations

    @builtins.property
    def transformations(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformations"]]]:
        '''transformations block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        result = self._values.get("transformations")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformations"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompound(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b0fc55cfcc35339275e2a98599f9d1d00798d5635bc063011471be25eccd8bf5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c3c285d5bdc8dec82669e8c0d2658079eb06405a35909cae2e8e9c3cb1bf5c62)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__787084001875cf755e3676028843caaccdfca85cd163d88c39217a50145fdcbd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__947b9a995fafac9e5eb36d849c40d58a5573937e3dda359d26ff8efd6a5a0cff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d65165d690ff965faf7434551123e52ad9d4efb23b17d766ad7f950827205e0a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompound]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompound]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3d37f6805fd8527bc18d04a5f4f4fff1ba8f37c7417346828755f3ae960a3886)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5b91289c29146b3aa8f8869fef962314724a2a0a904aac7f3e82cc3294507407)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformations")
    def put_transformations(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d8883027888985738e371c8689f7761cb5636d85b04b6ee6cc50f67d8dd8c58)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTransformations", [value]))

    @jsii.member(jsii_name="resetTransformations")
    def reset_transformations(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformations", []))

    @builtins.property
    @jsii.member(jsii_name="transformations")
    def transformations(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsList", jsii.get(self, "transformations"))

    @builtins.property
    @jsii.member(jsii_name="transformationsInput")
    def transformations_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformations"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformations"]]], jsii.get(self, "transformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompound]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompound]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompound]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a7d841a9ee06ff12f51d3ccc4be065db0451fe5717787c19b3562800879eb25)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformations",
    jsii_struct_bases=[],
    name_mapping={
        "background_color": "backgroundColor",
        "blur": "blur",
        "chroma_key": "chromaKey",
        "composite": "composite",
        "compound": "compound",
        "contrast": "contrast",
        "goop": "goop",
        "grayscale": "grayscale",
        "hsl": "hsl",
        "hsv": "hsv",
        "if_dimension": "ifDimension",
        "if_orientation": "ifOrientation",
        "max_colors": "maxColors",
        "mirror": "mirror",
        "mono_hue": "monoHue",
        "opacity": "opacity",
        "remove_color": "removeColor",
        "unsharp_mask": "unsharpMask",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformations:
    def __init__(
        self,
        *,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsBackgroundColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsBlur", typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsChromaKey", typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsComposite", typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsCompound", typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsContrast", typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsGoop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsGrayscale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsHsl", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsHsv", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfDimension", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfOrientation", typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsMaxColors", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsMirror", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsMonoHue", typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsOpacity", typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsRemoveColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsUnsharpMask", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e9b6aeaf6214af24514696e3859844b987411867fd813f54d1aedc01ccc09807)
            check_type(argname="argument background_color", value=background_color, expected_type=type_hints["background_color"])
            check_type(argname="argument blur", value=blur, expected_type=type_hints["blur"])
            check_type(argname="argument chroma_key", value=chroma_key, expected_type=type_hints["chroma_key"])
            check_type(argname="argument composite", value=composite, expected_type=type_hints["composite"])
            check_type(argname="argument compound", value=compound, expected_type=type_hints["compound"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument goop", value=goop, expected_type=type_hints["goop"])
            check_type(argname="argument grayscale", value=grayscale, expected_type=type_hints["grayscale"])
            check_type(argname="argument hsl", value=hsl, expected_type=type_hints["hsl"])
            check_type(argname="argument hsv", value=hsv, expected_type=type_hints["hsv"])
            check_type(argname="argument if_dimension", value=if_dimension, expected_type=type_hints["if_dimension"])
            check_type(argname="argument if_orientation", value=if_orientation, expected_type=type_hints["if_orientation"])
            check_type(argname="argument max_colors", value=max_colors, expected_type=type_hints["max_colors"])
            check_type(argname="argument mirror", value=mirror, expected_type=type_hints["mirror"])
            check_type(argname="argument mono_hue", value=mono_hue, expected_type=type_hints["mono_hue"])
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument remove_color", value=remove_color, expected_type=type_hints["remove_color"])
            check_type(argname="argument unsharp_mask", value=unsharp_mask, expected_type=type_hints["unsharp_mask"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if background_color is not None:
            self._values["background_color"] = background_color
        if blur is not None:
            self._values["blur"] = blur
        if chroma_key is not None:
            self._values["chroma_key"] = chroma_key
        if composite is not None:
            self._values["composite"] = composite
        if compound is not None:
            self._values["compound"] = compound
        if contrast is not None:
            self._values["contrast"] = contrast
        if goop is not None:
            self._values["goop"] = goop
        if grayscale is not None:
            self._values["grayscale"] = grayscale
        if hsl is not None:
            self._values["hsl"] = hsl
        if hsv is not None:
            self._values["hsv"] = hsv
        if if_dimension is not None:
            self._values["if_dimension"] = if_dimension
        if if_orientation is not None:
            self._values["if_orientation"] = if_orientation
        if max_colors is not None:
            self._values["max_colors"] = max_colors
        if mirror is not None:
            self._values["mirror"] = mirror
        if mono_hue is not None:
            self._values["mono_hue"] = mono_hue
        if opacity is not None:
            self._values["opacity"] = opacity
        if remove_color is not None:
            self._values["remove_color"] = remove_color
        if unsharp_mask is not None:
            self._values["unsharp_mask"] = unsharp_mask

    @builtins.property
    def background_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsBackgroundColor"]]]:
        '''background_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        '''
        result = self._values.get("background_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsBackgroundColor"]]], result)

    @builtins.property
    def blur(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsBlur"]]]:
        '''blur block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        '''
        result = self._values.get("blur")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsBlur"]]], result)

    @builtins.property
    def chroma_key(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsChromaKey"]]]:
        '''chroma_key block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        '''
        result = self._values.get("chroma_key")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsChromaKey"]]], result)

    @builtins.property
    def composite(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsComposite"]]]:
        '''composite block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        '''
        result = self._values.get("composite")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsComposite"]]], result)

    @builtins.property
    def compound(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsCompound"]]]:
        '''compound block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        '''
        result = self._values.get("compound")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsCompound"]]], result)

    @builtins.property
    def contrast(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsContrast"]]]:
        '''contrast block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsContrast"]]], result)

    @builtins.property
    def goop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsGoop"]]]:
        '''goop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        '''
        result = self._values.get("goop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsGoop"]]], result)

    @builtins.property
    def grayscale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsGrayscale"]]]:
        '''grayscale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        '''
        result = self._values.get("grayscale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsGrayscale"]]], result)

    @builtins.property
    def hsl(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsHsl"]]]:
        '''hsl block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        '''
        result = self._values.get("hsl")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsHsl"]]], result)

    @builtins.property
    def hsv(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsHsv"]]]:
        '''hsv block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        '''
        result = self._values.get("hsv")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsHsv"]]], result)

    @builtins.property
    def if_dimension(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfDimension"]]]:
        '''if_dimension block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        '''
        result = self._values.get("if_dimension")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfDimension"]]], result)

    @builtins.property
    def if_orientation(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfOrientation"]]]:
        '''if_orientation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        '''
        result = self._values.get("if_orientation")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfOrientation"]]], result)

    @builtins.property
    def max_colors(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsMaxColors"]]]:
        '''max_colors block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        '''
        result = self._values.get("max_colors")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsMaxColors"]]], result)

    @builtins.property
    def mirror(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsMirror"]]]:
        '''mirror block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        '''
        result = self._values.get("mirror")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsMirror"]]], result)

    @builtins.property
    def mono_hue(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsMonoHue"]]]:
        '''mono_hue block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        '''
        result = self._values.get("mono_hue")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsMonoHue"]]], result)

    @builtins.property
    def opacity(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsOpacity"]]]:
        '''opacity block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsOpacity"]]], result)

    @builtins.property
    def remove_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsRemoveColor"]]]:
        '''remove_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        '''
        result = self._values.get("remove_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsRemoveColor"]]], result)

    @builtins.property
    def unsharp_mask(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsUnsharpMask"]]]:
        '''unsharp_mask block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        result = self._values.get("unsharp_mask")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsUnsharpMask"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformations(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsBackgroundColor",
    jsii_struct_bases=[],
    name_mapping={"color": "color", "color_var": "colorVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsBackgroundColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f2dfb33d4bfe6f1ecc43630d7e097743a2ba0e439b0cab75db1b0473f6349a9d)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsBackgroundColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsBackgroundColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsBackgroundColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__15efddd01d9629946b4cd9974e44dd399af05bff07c3c48fdda7be26cfa1a189)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsBackgroundColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a432ee50145ded53a29672cb95162c853858017e83041696064f9f1c08f770e0)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsBackgroundColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__68e23d01aa867d1e1220ed7db77cd99970980fd3ec56dc42e528e7b908f48f35)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e682d6424a9fc73310113cb5c30ee99137489ce9023e7fb1973c0fa3f99b228f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1d57ea4ce3b43905355fecfbadc7abe85b3d5d599f7f1ea1f3e64a85d9f89a32)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsBackgroundColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsBackgroundColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f3c7b48fc43cbba4db1078cd5e54b19e01c37bac38cf56068ff04ceeb06540d8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsBackgroundColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsBackgroundColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ec539fad9e32121323bc2e5d0de11b50a0c3551605d3478e8057c2e8a8c7a4b7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0c638328f38049baa684f1fa9647b1ddae7b1bf585f9aa15f353b2ed064bd725)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b646176c6772d1b71ac99fb1b24a1df334a64f2375e208d1c95f6c2adea7bed1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsBackgroundColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsBackgroundColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsBackgroundColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be61c2f02ff918b9002a2c0f46d7e8db9fa6fa659d0cc8af35c79d5a2f836337)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsBlur",
    jsii_struct_bases=[],
    name_mapping={"sigma": "sigma", "sigma_var": "sigmaVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsBlur:
    def __init__(
        self,
        *,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param sigma: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__84eb4bfc7028a86f9ded966bd6496de9b7f748781feabf34ef4d9491a9b6862a)
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsBlur(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsBlurList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsBlurList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d23254bafc454192a6b004555b521daf2a399130e333f31a4311e02dca5a834)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsBlurOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b7ea3ac6a9aded229342956738fb3242b28b42e0c4e81130bfa6377b1d676939)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsBlurOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d42c6c37324a293744740e98ef23017a26586b2b12bc8e69131af02337260180)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7be66739344fc0cce823ac6dfbfb995ec4ae7c44db68b251298eda61789884e1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6cf2f91400c40837b4f3e7dda155a57fb4787a2246050df40909caca4879d4e6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsBlur]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsBlur]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0abe15a6707adac6cd80a8f838771031fafdefe506a39521b8ad65ba4051578d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsBlurOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsBlurOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a7311542c47e50c84678a8c637e27c79a3797c4595ded1eb2ce3b9d37074374)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3aeee80f03ffbc5d48080b95d549b612a90d50421d99214a4075f977dd260444)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__45f419eb3994d6e747e9726b626d9711bc8b217a2d9a9ba3a659e3a652b5074b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsBlur]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsBlur]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsBlur]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__15877f39af7aa2528a0d356cf397abeeb5a9c00ea11ddf3421e1746b358b648f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsChromaKey",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_feather": "hueFeather",
        "hue_feather_var": "hueFeatherVar",
        "hue_tolerance": "hueTolerance",
        "hue_tolerance_var": "hueToleranceVar",
        "hue_var": "hueVar",
        "lightness_feather": "lightnessFeather",
        "lightness_feather_var": "lightnessFeatherVar",
        "lightness_tolerance": "lightnessTolerance",
        "lightness_tolerance_var": "lightnessToleranceVar",
        "saturation_feather": "saturationFeather",
        "saturation_feather_var": "saturationFeatherVar",
        "saturation_tolerance": "saturationTolerance",
        "saturation_tolerance_var": "saturationToleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsChromaKey:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_feather: typing.Optional[builtins.str] = None,
        hue_feather_var: typing.Optional[builtins.str] = None,
        hue_tolerance: typing.Optional[builtins.str] = None,
        hue_tolerance_var: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness_feather: typing.Optional[builtins.str] = None,
        lightness_feather_var: typing.Optional[builtins.str] = None,
        lightness_tolerance: typing.Optional[builtins.str] = None,
        lightness_tolerance_var: typing.Optional[builtins.str] = None,
        saturation_feather: typing.Optional[builtins.str] = None,
        saturation_feather_var: typing.Optional[builtins.str] = None,
        saturation_tolerance: typing.Optional[builtins.str] = None,
        saturation_tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_feather: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        :param hue_feather_var: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        :param hue_tolerance: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        :param hue_tolerance_var: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        :param hue_var: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness_feather: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        :param lightness_feather_var: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        :param lightness_tolerance: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        :param lightness_tolerance_var: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        :param saturation_feather: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        :param saturation_feather_var: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        :param saturation_tolerance: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        :param saturation_tolerance_var: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__45adfcd848ed4a37f2ddcbc4a61cd1e5f7fdf6fa1b98aa8c8ade59e3bd497a3d)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_feather", value=hue_feather, expected_type=type_hints["hue_feather"])
            check_type(argname="argument hue_feather_var", value=hue_feather_var, expected_type=type_hints["hue_feather_var"])
            check_type(argname="argument hue_tolerance", value=hue_tolerance, expected_type=type_hints["hue_tolerance"])
            check_type(argname="argument hue_tolerance_var", value=hue_tolerance_var, expected_type=type_hints["hue_tolerance_var"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness_feather", value=lightness_feather, expected_type=type_hints["lightness_feather"])
            check_type(argname="argument lightness_feather_var", value=lightness_feather_var, expected_type=type_hints["lightness_feather_var"])
            check_type(argname="argument lightness_tolerance", value=lightness_tolerance, expected_type=type_hints["lightness_tolerance"])
            check_type(argname="argument lightness_tolerance_var", value=lightness_tolerance_var, expected_type=type_hints["lightness_tolerance_var"])
            check_type(argname="argument saturation_feather", value=saturation_feather, expected_type=type_hints["saturation_feather"])
            check_type(argname="argument saturation_feather_var", value=saturation_feather_var, expected_type=type_hints["saturation_feather_var"])
            check_type(argname="argument saturation_tolerance", value=saturation_tolerance, expected_type=type_hints["saturation_tolerance"])
            check_type(argname="argument saturation_tolerance_var", value=saturation_tolerance_var, expected_type=type_hints["saturation_tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_feather is not None:
            self._values["hue_feather"] = hue_feather
        if hue_feather_var is not None:
            self._values["hue_feather_var"] = hue_feather_var
        if hue_tolerance is not None:
            self._values["hue_tolerance"] = hue_tolerance
        if hue_tolerance_var is not None:
            self._values["hue_tolerance_var"] = hue_tolerance_var
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness_feather is not None:
            self._values["lightness_feather"] = lightness_feather
        if lightness_feather_var is not None:
            self._values["lightness_feather_var"] = lightness_feather_var
        if lightness_tolerance is not None:
            self._values["lightness_tolerance"] = lightness_tolerance
        if lightness_tolerance_var is not None:
            self._values["lightness_tolerance_var"] = lightness_tolerance_var
        if saturation_feather is not None:
            self._values["saturation_feather"] = saturation_feather
        if saturation_feather_var is not None:
            self._values["saturation_feather_var"] = saturation_feather_var
        if saturation_tolerance is not None:
            self._values["saturation_tolerance"] = saturation_tolerance
        if saturation_tolerance_var is not None:
            self._values["saturation_tolerance_var"] = saturation_tolerance_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        '''
        result = self._values.get("hue_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        '''
        result = self._values.get("hue_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        '''
        result = self._values.get("hue_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        '''
        result = self._values.get("hue_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        '''
        result = self._values.get("lightness_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        '''
        result = self._values.get("lightness_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        '''
        result = self._values.get("lightness_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        '''
        result = self._values.get("lightness_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        '''
        result = self._values.get("saturation_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        '''
        result = self._values.get("saturation_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        '''
        result = self._values.get("saturation_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        result = self._values.get("saturation_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsChromaKey(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsChromaKeyList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsChromaKeyList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__96ec818c86be8dc7db5477694e17873a3c775bebd1f54a4f5a075b294d9ae9be)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsChromaKeyOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0bab0f35247d6823a0801565160202ba7e1679f34cd1248eb758bf6d82b9da03)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsChromaKeyOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7a9c9fcd88ed2de783e52c9149fbf86a33ac0957b3b1191a4af922d36ccbe9ca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b48b3112e5ea9d8bc719213aa089158d22ea5072a544848c01630c9d06d14451)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1c131a2c43d13c0a37c6a4f2b3e48ecbd92034f1136e0559f5b01dd75fd8e1f5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsChromaKey]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsChromaKey]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__98e4380662312f145a857b918462bdeda35d98e3589db545a027ec712fece648)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsChromaKeyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsChromaKeyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5bef388c65ab96583e60d2abfd10250bb951cb23238289b32b524953dd43e5f1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueFeather")
    def reset_hue_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeather", []))

    @jsii.member(jsii_name="resetHueFeatherVar")
    def reset_hue_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeatherVar", []))

    @jsii.member(jsii_name="resetHueTolerance")
    def reset_hue_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueTolerance", []))

    @jsii.member(jsii_name="resetHueToleranceVar")
    def reset_hue_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueToleranceVar", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightnessFeather")
    def reset_lightness_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeather", []))

    @jsii.member(jsii_name="resetLightnessFeatherVar")
    def reset_lightness_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeatherVar", []))

    @jsii.member(jsii_name="resetLightnessTolerance")
    def reset_lightness_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessTolerance", []))

    @jsii.member(jsii_name="resetLightnessToleranceVar")
    def reset_lightness_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessToleranceVar", []))

    @jsii.member(jsii_name="resetSaturationFeather")
    def reset_saturation_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeather", []))

    @jsii.member(jsii_name="resetSaturationFeatherVar")
    def reset_saturation_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeatherVar", []))

    @jsii.member(jsii_name="resetSaturationTolerance")
    def reset_saturation_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationTolerance", []))

    @jsii.member(jsii_name="resetSaturationToleranceVar")
    def reset_saturation_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherInput")
    def hue_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVarInput")
    def hue_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceInput")
    def hue_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVarInput")
    def hue_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherInput")
    def lightness_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVarInput")
    def lightness_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceInput")
    def lightness_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVarInput")
    def lightness_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherInput")
    def saturation_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVarInput")
    def saturation_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceInput")
    def saturation_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVarInput")
    def saturation_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f3a95c33a356c8181992537598e7cfefa39480c9b04c5c7f8037deb97ae0fa2f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeather")
    def hue_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeather"))

    @hue_feather.setter
    def hue_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__34bd938526f10f062d4b57de6e94334170ec94bc79bffbebd1fe38646fd4f604)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeather", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVar")
    def hue_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeatherVar"))

    @hue_feather_var.setter
    def hue_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6a8e93ab69ee3e03de603993ff23ae2ff570721e9f527fe35b86435126bed0c6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueTolerance")
    def hue_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueTolerance"))

    @hue_tolerance.setter
    def hue_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ba43aeeade8252428d118fb3b8178b56879f875720b4db5751a6ee2c79f98ccd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVar")
    def hue_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueToleranceVar"))

    @hue_tolerance_var.setter
    def hue_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__61f9a8b48c09e50ce8db4472a6e59523ef40ef83a6817e2977692809d38a2455)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2c52cd6b951e529bf921ecb4f391e3c312091f1552b4dc48f2fae9c88ce94f2d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeather")
    def lightness_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeather"))

    @lightness_feather.setter
    def lightness_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8f112ded0ee2d29ef06b8213badf5bc7d26b3989a2721d81feb3bede4403ea39)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeather", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVar")
    def lightness_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeatherVar"))

    @lightness_feather_var.setter
    def lightness_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5cfa2db06ae54375994e9c74f69571f38af473ec549ee9eb2bf252ea985398cf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessTolerance")
    def lightness_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessTolerance"))

    @lightness_tolerance.setter
    def lightness_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0c349574bfe4f84480af585878144b2cdf9c25a3825c475338ab6f52bc3ab116)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVar")
    def lightness_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessToleranceVar"))

    @lightness_tolerance_var.setter
    def lightness_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aa16dbf53ee10cbdfe9aec239039fca2a355c4856a431191e3c8818d3732739b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeather")
    def saturation_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeather"))

    @saturation_feather.setter
    def saturation_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__231b22d736e51f93cfcea0b2f26c585ff0da50b997f244e30d585621b5d82012)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeather", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVar")
    def saturation_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeatherVar"))

    @saturation_feather_var.setter
    def saturation_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bdad4622e410ea419624005a09bec5949c74fe84e7ace1d13f1fe1c2cbcabfb8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationTolerance")
    def saturation_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationTolerance"))

    @saturation_tolerance.setter
    def saturation_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1c9bf4536b6d9f35f7c4a88659b6aa75b8bd7ac1b1b289e026331dece8fa0f8e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVar")
    def saturation_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationToleranceVar"))

    @saturation_tolerance_var.setter
    def saturation_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c12e3c70e39602b19dd488d15078fbe445900297f33af48ae67d38c4c1b0b233)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsChromaKey]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsChromaKey]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsChromaKey]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5800b0654233f8b5ee5b2f018966fbbd124c1baa29792b1bcc30295b6db56a43)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsComposite",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "placement": "placement",
        "placement_var": "placementVar",
        "scale": "scale",
        "scale_dimension": "scaleDimension",
        "scale_dimension_var": "scaleDimensionVar",
        "scale_var": "scaleVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsComposite:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsCompositeImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        placement: typing.Optional[builtins.str] = None,
        placement_var: typing.Optional[builtins.str] = None,
        scale: typing.Optional[builtins.str] = None,
        scale_dimension: typing.Optional[builtins.str] = None,
        scale_dimension_var: typing.Optional[builtins.str] = None,
        scale_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param placement: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        :param placement_var: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        :param scale: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param scale_dimension: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        :param scale_dimension_var: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        :param scale_var: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        :param x_position: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsCompositeImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__74791e42461090ac73130fb379aad82af18a648aa5a4ecc133c8679aef3ed695)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument placement", value=placement, expected_type=type_hints["placement"])
            check_type(argname="argument placement_var", value=placement_var, expected_type=type_hints["placement_var"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument scale_dimension", value=scale_dimension, expected_type=type_hints["scale_dimension"])
            check_type(argname="argument scale_dimension_var", value=scale_dimension_var, expected_type=type_hints["scale_dimension_var"])
            check_type(argname="argument scale_var", value=scale_var, expected_type=type_hints["scale_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if placement is not None:
            self._values["placement"] = placement
        if placement_var is not None:
            self._values["placement_var"] = placement_var
        if scale is not None:
            self._values["scale"] = scale
        if scale_dimension is not None:
            self._values["scale_dimension"] = scale_dimension
        if scale_dimension_var is not None:
            self._values["scale_dimension_var"] = scale_dimension_var
        if scale_var is not None:
            self._values["scale_var"] = scale_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsCompositeImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsCompositeImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        '''
        result = self._values.get("placement")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement_var(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        '''
        result = self._values.get("placement_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        '''
        result = self._values.get("scale_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        '''
        result = self._values.get("scale_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        '''
        result = self._values.get("scale_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsComposite(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsCompositeImage",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsCompositeImage:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsCompositeImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsCompositeImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsCompositeImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0c1f2c4f582a70f8c1329f626a095a79f1db1a6a1d199397d25eeff89ebfe57f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsCompositeImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsCompositeImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c5e543f34a066eb6b14cb92442626541d408fba466bdbd58fd53be32f8fea1e7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsCompositeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsCompositeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a14d4454fb7a49251bc79fca563aa9a16e5214f73f8b63c91291fd06927a70c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsCompositeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__87e9e0ea79347473c397bbdb2b7c0a3578175e41531d86f184edfcd8f0df6ff7)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsCompositeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f19590b24e1b3d9f2e3b7090563489ce3629325cb93ca2d21ad03acdf6927449)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8c1485fd3d246bbed22bb2126db280bb61b07dd123081fe0106e2aa8051930bf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a5daf55ef8bb367aae455e782b88065e9283adb4bf900da2e9a98adc36aa956e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsComposite]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsComposite]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9368d1ae85c00e9fc63b90fa7998c59dcc18553b57e6426a941f1ee966b34be0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsCompositeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsCompositeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f3fc847ae91cbc4ad89a0d543821900c213449251cc92f05cf6985f969aea67)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsCompositeImage()

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPlacement")
    def reset_placement(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacement", []))

    @jsii.member(jsii_name="resetPlacementVar")
    def reset_placement_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacementVar", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetScaleDimension")
    def reset_scale_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimension", []))

    @jsii.member(jsii_name="resetScaleDimensionVar")
    def reset_scale_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimensionVar", []))

    @jsii.member(jsii_name="resetScaleVar")
    def reset_scale_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsCompositeImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsCompositeImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsCompositeImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="placementInput")
    def placement_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementInput"))

    @builtins.property
    @jsii.member(jsii_name="placementVarInput")
    def placement_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionInput")
    def scale_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVarInput")
    def scale_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleVarInput")
    def scale_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0868c796294da9d8b19b95548d56feeba7509bda1c8315a1e22de9d06b0dcd8c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__40aa97b74cec65c12208c46dab154ef7eeedc07d4c5377c4aa26b1f9bb7aa5db)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="placement")
    def placement(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placement"))

    @placement.setter
    def placement(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3138b1c89ee6cecbc107996bf4d8cdb91e2688e621a430610efac5fa415f4bf2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placement", value)

    @builtins.property
    @jsii.member(jsii_name="placementVar")
    def placement_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placementVar"))

    @placement_var.setter
    def placement_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__14e74f859a6dabd13c6c9625c9af028207a266d601f86d0019a3078f525f3101)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placementVar", value)

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scale"))

    @scale.setter
    def scale(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e7af10a7264a89a35ec47e351623a85ddc2ab4ae779dee93187818dbc9d3cd86)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scale", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimension")
    def scale_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimension"))

    @scale_dimension.setter
    def scale_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ca418d7056545f98c6d2a38058e685312a10409631a0daab09547dc24f7e2dfe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimension", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVar")
    def scale_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimensionVar"))

    @scale_dimension_var.setter
    def scale_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dc37a1ffe5719d33f0157ef6cd7b01f8c4bb7dbb621f0e63628c3e89758514ed)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="scaleVar")
    def scale_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleVar"))

    @scale_var.setter
    def scale_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2770095a5cbb7bdcf1f4d7de0872c864e8861d473c72bc0ecef0533dd5293bca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__25a0019ca67354723c319d6edce15ec6395544eb488f22a6fe5fded2d9aecf0c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dccbcb21b20a70284b6b193725f1cf872fc502db3c4b819d9b8835963206a27a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f51fe35b2654f04042af1dd50907b797151d165673613cf5a57fac0db5f26e6d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb28b03b65d88e410a22df7ab4d99082dff99b5a03d48a532cbdf1112eb54b38)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsComposite]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsComposite]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsComposite]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a0ba04f05aff40b8341d1d429dd90d326827e02fc7ece60345f5718487040ab0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsCompound",
    jsii_struct_bases=[],
    name_mapping={"transformations": "transformations"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsCompound:
    def __init__(
        self,
        *,
        transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param transformations: transformations block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b8599cc1883b81d7d940a87f8ca47f5905d859dfb320a510d3edf0bf75a9902d)
            check_type(argname="argument transformations", value=transformations, expected_type=type_hints["transformations"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if transformations is not None:
            self._values["transformations"] = transformations

    @builtins.property
    def transformations(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsCompoundTransformations"]]]:
        '''transformations block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        result = self._values.get("transformations")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsCompoundTransformations"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsCompound(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsCompoundList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsCompoundList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1fab1883c23750897a9bfaf617d0e28ceeb39c4b21620bc57cdba75028803140)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsCompoundOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6095db2aaaca1203c808be56f4b5a591de6447ce4f8a8e37a52a22b53ea43a55)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsCompoundOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dde07d2cc33a80051ac4287443328de1cba1be6b504eb3290ff233c79dcfbbfc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fbdac4fdba547cd71c102ccce38f4717623eef397139a19c4f70b08ecee121de)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cbfc838162cce0a0d1b0c0523cc75488f04b51dbfe1b22fa519d0e36a7b62128)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsCompound]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsCompound]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6d6fa061c12a76305007350d4e8f449f14f924a6ab77d3810e7918f83d52c846)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsCompoundOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsCompoundOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b67b505229c6d9270faa70d281be2752eac1b07822e6ef7a9b51c9bc17e5607a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformations")
    def put_transformations(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__de748c6a3b3aecb4709d59c918c7be11d7fa9b423cd9d23621d606e7d426287e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTransformations", [value]))

    @jsii.member(jsii_name="resetTransformations")
    def reset_transformations(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformations", []))

    @builtins.property
    @jsii.member(jsii_name="transformations")
    def transformations(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsCompoundTransformationsList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsCompoundTransformationsList", jsii.get(self, "transformations"))

    @builtins.property
    @jsii.member(jsii_name="transformationsInput")
    def transformations_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsCompoundTransformations"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsCompoundTransformations"]]], jsii.get(self, "transformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsCompound]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsCompound]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsCompound]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3d6a0e091a47604718e19b1417bacf2c4a3008855a616d61d34efea0f7af8586)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsCompoundTransformations",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsCompoundTransformations:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsCompoundTransformations(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsCompoundTransformationsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsCompoundTransformationsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7ee78e236dd782b8ec4863cae74a2f4f23d72874b24dc329ab736055b1eff9a9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsCompoundTransformationsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__43d09a74b7e023fc083cdc872643c56bb6a02b3240ce960b490be532c1de22c4)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsCompoundTransformationsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__917b6893139015d57dcee2ba331a8ad81559d122ed370113efbff2cb71d69f47)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1d3aa752d122beb6320fe95a63d48ec01753e8ff64e055ddcb547212c8b0d449)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f1ea8ca11d567de5392e83618a0bae5a14ec1b3fb7f1686967952e3632991d97)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsCompoundTransformations]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsCompoundTransformations]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsCompoundTransformations]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__87f3d65370a5a1bd94059b2ee9dbf2747e90e9b2dbcb7d71eeaf2db1812fa995)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsCompoundTransformationsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsCompoundTransformationsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b5b20e34c5a59ef6e1ed4398381cfcffef67243db8ac456e55449e76fbfe4a7e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsCompoundTransformations]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsCompoundTransformations]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsCompoundTransformations]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f1b2ce1474f09fdf940d1c6f104becb357b0ee07c72305c30b95b7f0d8159404)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsContrast",
    jsii_struct_bases=[],
    name_mapping={
        "brightness": "brightness",
        "brightness_var": "brightnessVar",
        "contrast": "contrast",
        "contrast_var": "contrastVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsContrast:
    def __init__(
        self,
        *,
        brightness: typing.Optional[builtins.str] = None,
        brightness_var: typing.Optional[builtins.str] = None,
        contrast: typing.Optional[builtins.str] = None,
        contrast_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param brightness: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        :param brightness_var: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        :param contrast: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param contrast_var: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c89c3240950de4e0a5ef7ed28e6f762e37f035d313466ac546a01ec1b9ac92a9)
            check_type(argname="argument brightness", value=brightness, expected_type=type_hints["brightness"])
            check_type(argname="argument brightness_var", value=brightness_var, expected_type=type_hints["brightness_var"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument contrast_var", value=contrast_var, expected_type=type_hints["contrast_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if brightness is not None:
            self._values["brightness"] = brightness
        if brightness_var is not None:
            self._values["brightness_var"] = brightness_var
        if contrast is not None:
            self._values["contrast"] = contrast
        if contrast_var is not None:
            self._values["contrast_var"] = contrast_var

    @builtins.property
    def brightness(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        '''
        result = self._values.get("brightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def brightness_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        '''
        result = self._values.get("brightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        result = self._values.get("contrast_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsContrast(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsContrastList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsContrastList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4d61d0c1b2355dbeee60ec2882353d644b48681c780fab4714452cf0b0a9ed4c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsContrastOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5878cf3fd529278b8478be579f50c5f097f2b69c6a3924af548e8b39936c890b)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsContrastOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b4fcdefa357257c84712194de5a0367e9d2ec54ae3d420577438a1cc89b42f24)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__217ad8100c8b38afdc6b9140552d610a3a5ed95573fb4f06761e87fd3c6c9997)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ef295dae282567da572a865a85af52f2919706acc5a46635ecd32745f2a2663)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsContrast]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsContrast]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b27cea39df3652cd3599df903df1afaf25ba2cde2bc6a0922d6caad196bbd505)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsContrastOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsContrastOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e985f9af3ce02b3f2596b731e693d113ca2f01a3cb672aee11d4276e41c828b1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetBrightness")
    def reset_brightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightness", []))

    @jsii.member(jsii_name="resetBrightnessVar")
    def reset_brightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightnessVar", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetContrastVar")
    def reset_contrast_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrastVar", []))

    @builtins.property
    @jsii.member(jsii_name="brightnessInput")
    def brightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="brightnessVarInput")
    def brightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastVarInput")
    def contrast_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="brightness")
    def brightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightness"))

    @brightness.setter
    def brightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d2d3f683910dd546df311dd98793f994fc3f5f257130327558625c34f88b088c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightness", value)

    @builtins.property
    @jsii.member(jsii_name="brightnessVar")
    def brightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightnessVar"))

    @brightness_var.setter
    def brightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__231ac8c5260fa86f089266a0294e39f62667c8aea563e564b6c6ee24586a63ac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrast"))

    @contrast.setter
    def contrast(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1860cf8b701e5fdd61271e1a13b297b7f49ea1c763a6ce677146ee80fc293973)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrast", value)

    @builtins.property
    @jsii.member(jsii_name="contrastVar")
    def contrast_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrastVar"))

    @contrast_var.setter
    def contrast_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e9efa7806270fa01fb6d3979022d00b17c2f500f0119454bf2761da729f90fe6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrastVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsContrast]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsContrast]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsContrast]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e1ff1733803b243ef579fa4bc6e0df9a2c4197d12b7d44eae01d24c76b5e3b33)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsGoop",
    jsii_struct_bases=[],
    name_mapping={
        "chaos": "chaos",
        "chaos_var": "chaosVar",
        "density": "density",
        "density_var": "densityVar",
        "power": "power",
        "power_var": "powerVar",
        "seed": "seed",
        "seed_var": "seedVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsGoop:
    def __init__(
        self,
        *,
        chaos: typing.Optional[builtins.str] = None,
        chaos_var: typing.Optional[builtins.str] = None,
        density: typing.Optional[builtins.str] = None,
        density_var: typing.Optional[builtins.str] = None,
        power: typing.Optional[builtins.str] = None,
        power_var: typing.Optional[builtins.str] = None,
        seed: typing.Optional[builtins.str] = None,
        seed_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param chaos: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        :param chaos_var: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        :param density: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        :param density_var: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        :param power: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        :param power_var: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        :param seed: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        :param seed_var: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__69cee8929e39050cfc9447553c5c29868ef9886e84301942a500b85a56397afe)
            check_type(argname="argument chaos", value=chaos, expected_type=type_hints["chaos"])
            check_type(argname="argument chaos_var", value=chaos_var, expected_type=type_hints["chaos_var"])
            check_type(argname="argument density", value=density, expected_type=type_hints["density"])
            check_type(argname="argument density_var", value=density_var, expected_type=type_hints["density_var"])
            check_type(argname="argument power", value=power, expected_type=type_hints["power"])
            check_type(argname="argument power_var", value=power_var, expected_type=type_hints["power_var"])
            check_type(argname="argument seed", value=seed, expected_type=type_hints["seed"])
            check_type(argname="argument seed_var", value=seed_var, expected_type=type_hints["seed_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if chaos is not None:
            self._values["chaos"] = chaos
        if chaos_var is not None:
            self._values["chaos_var"] = chaos_var
        if density is not None:
            self._values["density"] = density
        if density_var is not None:
            self._values["density_var"] = density_var
        if power is not None:
            self._values["power"] = power
        if power_var is not None:
            self._values["power_var"] = power_var
        if seed is not None:
            self._values["seed"] = seed
        if seed_var is not None:
            self._values["seed_var"] = seed_var

    @builtins.property
    def chaos(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        '''
        result = self._values.get("chaos")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def chaos_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        '''
        result = self._values.get("chaos_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        '''
        result = self._values.get("density")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density_var(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        '''
        result = self._values.get("density_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        '''
        result = self._values.get("power")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power_var(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        '''
        result = self._values.get("power_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        '''
        result = self._values.get("seed")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed_var(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        result = self._values.get("seed_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsGoop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsGoopList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsGoopList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__025b1d8c775d35b6b3f02a9a41d2a51b6093af471e7fbc1a98e6f963a4ee10c2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsGoopOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e122705fee2cf28115d08f02796c3c66665d1639d05b142a052c7f6ae4e9fa76)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsGoopOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__152da460258d261b500a1ebfdf0599cb8b984f8df91156fccca0809f9e92615f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bbf9ae4839e2d326f386e23c4a3331ec54796a979b41340731ae0b864bc8548b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fad60949c4ccdb221a782d726ae0811cb4126c1987cf5da60bf60f6ba7c938d3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsGoop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsGoop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b4c07777ee5b0c72081bfbdfad4d59ccef25191f77b9959876a228508a24ea9d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsGoopOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsGoopOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__560659baf2f2156ec659464b7c1a2c4febb6bf337cde0399e0c607ed82077d81)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetChaos")
    def reset_chaos(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaos", []))

    @jsii.member(jsii_name="resetChaosVar")
    def reset_chaos_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaosVar", []))

    @jsii.member(jsii_name="resetDensity")
    def reset_density(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensity", []))

    @jsii.member(jsii_name="resetDensityVar")
    def reset_density_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensityVar", []))

    @jsii.member(jsii_name="resetPower")
    def reset_power(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPower", []))

    @jsii.member(jsii_name="resetPowerVar")
    def reset_power_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPowerVar", []))

    @jsii.member(jsii_name="resetSeed")
    def reset_seed(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeed", []))

    @jsii.member(jsii_name="resetSeedVar")
    def reset_seed_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeedVar", []))

    @builtins.property
    @jsii.member(jsii_name="chaosInput")
    def chaos_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosInput"))

    @builtins.property
    @jsii.member(jsii_name="chaosVarInput")
    def chaos_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosVarInput"))

    @builtins.property
    @jsii.member(jsii_name="densityInput")
    def density_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityInput"))

    @builtins.property
    @jsii.member(jsii_name="densityVarInput")
    def density_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="powerInput")
    def power_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerInput"))

    @builtins.property
    @jsii.member(jsii_name="powerVarInput")
    def power_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerVarInput"))

    @builtins.property
    @jsii.member(jsii_name="seedInput")
    def seed_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedInput"))

    @builtins.property
    @jsii.member(jsii_name="seedVarInput")
    def seed_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedVarInput"))

    @builtins.property
    @jsii.member(jsii_name="chaos")
    def chaos(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaos"))

    @chaos.setter
    def chaos(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f06627ed0a66c31892e335bc07971712f0c98c265bebe2d861cd7df6a3a14287)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaos", value)

    @builtins.property
    @jsii.member(jsii_name="chaosVar")
    def chaos_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaosVar"))

    @chaos_var.setter
    def chaos_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__93b41b86eec6def9bd733e7511e8d29c6dbb4a25d3eca68da485e042d3dcb317)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaosVar", value)

    @builtins.property
    @jsii.member(jsii_name="density")
    def density(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "density"))

    @density.setter
    def density(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d732b15d3b6d75135c33839cb929e15e6a0653e7e768c12e255e904df9d30acb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "density", value)

    @builtins.property
    @jsii.member(jsii_name="densityVar")
    def density_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "densityVar"))

    @density_var.setter
    def density_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ffe973f44d9657cf722df67b6dd2d675a86153c58a0c5714383d14ee7537cfe0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "densityVar", value)

    @builtins.property
    @jsii.member(jsii_name="power")
    def power(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "power"))

    @power.setter
    def power(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9e52fa8305de2671723da8ab96fec20630232682de5582ac0a76d73e3fe44084)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "power", value)

    @builtins.property
    @jsii.member(jsii_name="powerVar")
    def power_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "powerVar"))

    @power_var.setter
    def power_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__788c325217788206d88368273bc06fb101c41e2cdd1a87576cb443060b1eb71a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "powerVar", value)

    @builtins.property
    @jsii.member(jsii_name="seed")
    def seed(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seed"))

    @seed.setter
    def seed(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fecae9999f00935d480afa8d96bd054c39cafd9c6188d78a818cc0998f81da3d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seed", value)

    @builtins.property
    @jsii.member(jsii_name="seedVar")
    def seed_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seedVar"))

    @seed_var.setter
    def seed_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3f5d438922da7118f0f285d4e657c2c4bb062ffc64c398a70efb380f866dd9bd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seedVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsGoop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsGoop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsGoop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a0407bc132443803be7ab53261c514190f18a3445038a067a528373838a1b52a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsGrayscale",
    jsii_struct_bases=[],
    name_mapping={"type": "type", "type_var": "typeVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsGrayscale:
    def __init__(
        self,
        *,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param type: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e7bbe3f35694c58da3a692ccb68c08f7c4f902a79f011d390fe689481a3f2398)
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsGrayscale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsGrayscaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsGrayscaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d01c26bff4b16dee3c4a40590f27a6090c13cd8366fca3e8de07d3c3fd3bc068)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsGrayscaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__380f8eb33af42f1fdc0b04570b1ff266fa3ac1f41946a5704ef4dc01ed9cb455)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsGrayscaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8dcb9ae0416ef9cc94d56c2f55967b1bde847c7bc6e1e089ffbdc4305c3c125c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d2b67c159414c5384b03ae9ac2898af6d43a0199149a6ce16a6fd7d4e0f1fdd5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9af9d1b84d52c2bbb4a3fc4fda3dba11e878d2b0794b4b44553c9438067b83b3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsGrayscale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsGrayscale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__10b5c0f1a598c6e760e78cdbc5b46cc0b484914a2542302f525bd41f92f3c24d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsGrayscaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsGrayscaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e48cb1a5c2fa726ee0c22d77f42aafba2cc3176f48b1229be4f038e58ffd5acc)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5e1ddc841301945eac874e469f29f4cf82e316b5e20819e860ebf8aac14d6152)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__01ba121ed5ece7211b7e39d562bd221994023f3fb7dd31e4b08165ad64a24f10)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsGrayscale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsGrayscale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsGrayscale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0e6d14fa9fadf55e0a75399363fe413f80d34a021f95f5e9b0e04241e8bc780e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsHsl",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "lightness": "lightness",
        "lightness_var": "lightnessVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsHsl:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness: typing.Optional[builtins.str] = None,
        lightness_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        :param lightness_var: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__623d0666fe6e70796601b7f2b95296fde636c1f5aeb47c6ac3c0afa3b64b0c37)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness", value=lightness, expected_type=type_hints["lightness"])
            check_type(argname="argument lightness_var", value=lightness_var, expected_type=type_hints["lightness_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness is not None:
            self._values["lightness"] = lightness
        if lightness_var is not None:
            self._values["lightness_var"] = lightness_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        '''
        result = self._values.get("lightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        '''
        result = self._values.get("lightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsHsl(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsHslList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsHslList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__80c25b435b8ae202c4186be6bcb4719139d148a11be1a580a9f79bde1493bee0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsHslOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df866443b349b1304000966e40b7f146f407bfed2f8669f53f2bb71643fea356)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsHslOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa084d3bc75d7ba8c141ca7c8b9688e8488a3096c8f975a6b95ed5ee9dd611a8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__31be8cb681e09527597fdd82e8b73471700b179e2a485252e73645157e35604e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2030187ecd2f8f2c73c8d61c684b72043da32215a95372832bcae9efddbf5392)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsHsl]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsHsl]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6ea8a359f8cf4e6a5893fa3343bb37e95d25e05f6f4cfee9d0a96e25da9cf1e0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsHslOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsHslOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8be4a75f49ff22a364a3b82213dd69422f37a7893b01267323203b9caf1e1d7d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightness")
    def reset_lightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightness", []))

    @jsii.member(jsii_name="resetLightnessVar")
    def reset_lightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessInput")
    def lightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessVarInput")
    def lightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__855335c5cc207f9e6512300f48eb95ce8939b1b23bfaaf7623eb619a1acb5e84)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dfb313c6004fd601a82a76461300e251e4e2f7c14d9e09b2b09d1d24f547cb55)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightness")
    def lightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightness"))

    @lightness.setter
    def lightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__76f0c87a751edc24c85ae3c4923c3a86db5e855b8b2b39968666820d0e7f0b30)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightness", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessVar")
    def lightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessVar"))

    @lightness_var.setter
    def lightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d4668fc1f2d726920f25e015497ae89e2bdb0d6bbb3f3bf344f04be5f46b1712)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d57f61b63f1b86adfcc014fb1da409ff0572243e2ebcbe3d686cf7f16081a758)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ba58ab113e578c8be93d24cea232bc107d5aca09c36d9897765c59165612a05)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsHsl]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsHsl]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsHsl]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f482e5125fab862ce8621ac426b1e0a56c24d64162f9c551dbc2f2a756b7077)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsHsv",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsHsv:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        :param value: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__989ff064fae5dcdd80ad9363ff513002d8ac1c749a7ad615ae3c143b590c6d7d)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsHsv(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsHsvList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsHsvList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__277fb57a0c329b7365dc11ab3bdfd7dfcf644e3f78e883adb3c166564047a9d2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsHsvOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9c37d370323c8581e5130b870da7c8240299965bdedd44e0c29a0ebc18803c1d)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsHsvOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a9b1f0b6b5142eec0e913960554e84700a46d88a804e03269c25e611a0523a1d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1b923ec8a67ff36ca1073050d331c86d68e2daf283be50ac50a5d17bd5a50493)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b189410d804f2f5161c84906653eb58c1a8fef05318ffc0f951b16bb268a3346)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsHsv]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsHsv]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b917afc6f14f46f92b7c131e79cf7f51376386e90b3ba8305c359be68a4e15f3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsHsvOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsHsvOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__187c57643df0bc707210c652e8f3dbcaf85751cac8b47cd43260463c9b144a3e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d735a6a5d36eafe9a3cbb438c36a51450708c5547026963b374636d9702a6515)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__26841096caf7fce5c86baf0fce525dbce6fb0d6f559f421881dd896513c4a14e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4d3df65b1d2b92f15ac0e7e626a815d6f15e1c952231872945f9eb5365159ceb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__86a4d38cc43b7d05bb24551879d6b82720c3e0edf1d6e441c83c52172d01e4b9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ab06fd72aeae9d2ed3d1124eac02248490db3caa55b6285c4bd2c963b01bacd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__25572bcc0685d22630d6340f7a615f51dcdff16db30947a34cadb2cc722c9338)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsHsv]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsHsv]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsHsv]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0d45204d29215484be89239858daedc22b4443ebdb3a259be12f902ed5413245)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfDimension",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "dimension": "dimension",
        "dimension_var": "dimensionVar",
        "equal": "equal",
        "greater_than": "greaterThan",
        "less_than": "lessThan",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfDimension:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfDimensionDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        dimension: typing.Optional[builtins.str] = None,
        dimension_var: typing.Optional[builtins.str] = None,
        equal: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfDimensionEqual", typing.Dict[builtins.str, typing.Any]]] = None,
        greater_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfDimensionGreaterThan", typing.Dict[builtins.str, typing.Any]]] = None,
        less_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfDimensionLessThan", typing.Dict[builtins.str, typing.Any]]] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param dimension: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        :param dimension_var: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        :param equal: equal block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        :param greater_than: greater_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        :param less_than: less_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        :param value: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfDimensionDefault(**default)
        if isinstance(equal, dict):
            equal = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfDimensionEqual(**equal)
        if isinstance(greater_than, dict):
            greater_than = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfDimensionGreaterThan(**greater_than)
        if isinstance(less_than, dict):
            less_than = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfDimensionLessThan(**less_than)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bcb3cb6d8c771579f3d46dc99b44c00b94215803b02f51eb84b7b644aecf7ae9)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument dimension", value=dimension, expected_type=type_hints["dimension"])
            check_type(argname="argument dimension_var", value=dimension_var, expected_type=type_hints["dimension_var"])
            check_type(argname="argument equal", value=equal, expected_type=type_hints["equal"])
            check_type(argname="argument greater_than", value=greater_than, expected_type=type_hints["greater_than"])
            check_type(argname="argument less_than", value=less_than, expected_type=type_hints["less_than"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if dimension is not None:
            self._values["dimension"] = dimension
        if dimension_var is not None:
            self._values["dimension_var"] = dimension_var
        if equal is not None:
            self._values["equal"] = equal
        if greater_than is not None:
            self._values["greater_than"] = greater_than
        if less_than is not None:
            self._values["less_than"] = less_than
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfDimensionDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfDimensionDefault"], result)

    @builtins.property
    def dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        '''
        result = self._values.get("dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        '''
        result = self._values.get("dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def equal(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfDimensionEqual"]:
        '''equal block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        '''
        result = self._values.get("equal")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfDimensionEqual"], result)

    @builtins.property
    def greater_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfDimensionGreaterThan"]:
        '''greater_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        '''
        result = self._values.get("greater_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfDimensionGreaterThan"], result)

    @builtins.property
    def less_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfDimensionLessThan"]:
        '''less_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        '''
        result = self._values.get("less_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfDimensionLessThan"], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfDimension(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfDimensionDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfDimensionDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfDimensionDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfDimensionDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfDimensionDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c107b119c6586fdcdcea4e72c4db559b6168db6764e35284fb0d94f887747713)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfDimensionDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfDimensionDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4621c23039fee60c0d3bce7f5cb53b314586e6dab323d9cb900b1ef01da1f9f1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfDimensionEqual",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfDimensionEqual:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfDimensionEqual(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfDimensionEqualOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfDimensionEqualOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7159902d79b85f36a3bec0ba18abdd483059813abd72a19806d62cedae4d1dc9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfDimensionEqual], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfDimensionEqual],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__471ec5cb6abe61969791cfa6b93220d3336f4743bb609c52d335dc85b34dc001)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfDimensionGreaterThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfDimensionGreaterThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfDimensionGreaterThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfDimensionGreaterThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfDimensionGreaterThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6dcb80e8e570295715fe31a13acfac030666d1d7164ac4540b2c16ee8895a4b5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfDimensionGreaterThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfDimensionGreaterThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b26710b2bb3e8cd9259a7684673ff69a4d59f8c6bfa4b034d4f7abbad0dfb173)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfDimensionLessThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfDimensionLessThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfDimensionLessThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfDimensionLessThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfDimensionLessThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__63c5b3759519424a0a5e7ea4a158ee481c1835e8f4394088736c36955d02f12b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfDimensionLessThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfDimensionLessThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__025483375da1060d672ccb2e3c823c8fdc76fd95d095b5b98c4fe9795a20c3c8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfDimensionList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfDimensionList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1aab8be6c8a71cbb28eb9ff30a6089de81d0cca63272e51d2a221fc60c2a482a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfDimensionOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__29de2bfb27bc16837576991431062d93366abdba4ac1700c5d0332a20d05fbcb)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfDimensionOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__07c67f5df216b2348f800214846468290e4bf1ebdf0dda66c2a853d6f91096e3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9627ba0cd3dc31be9ddd377a5a794b3171c281a7de30c76cb04c1858bd192e45)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8bb3d81119a5f784dd4b478e733618f3c7b91e41f754149b61623090bd03161e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfDimension]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfDimension]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bed7a9309a0cc495604751a45d42f9a49ef9427bb015040eec0f884f6d80c081)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfDimensionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfDimensionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3b86fd6e4679490a55e6078c0256301315c1dd8cf7ef4931dc5c646a7a26f2a1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfDimensionDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putEqual")
    def put_equal(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfDimensionEqual()

        return typing.cast(None, jsii.invoke(self, "putEqual", [value]))

    @jsii.member(jsii_name="putGreaterThan")
    def put_greater_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfDimensionGreaterThan()

        return typing.cast(None, jsii.invoke(self, "putGreaterThan", [value]))

    @jsii.member(jsii_name="putLessThan")
    def put_less_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfDimensionLessThan()

        return typing.cast(None, jsii.invoke(self, "putLessThan", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetDimension")
    def reset_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimension", []))

    @jsii.member(jsii_name="resetDimensionVar")
    def reset_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimensionVar", []))

    @jsii.member(jsii_name="resetEqual")
    def reset_equal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEqual", []))

    @jsii.member(jsii_name="resetGreaterThan")
    def reset_greater_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGreaterThan", []))

    @jsii.member(jsii_name="resetLessThan")
    def reset_less_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLessThan", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfDimensionDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfDimensionDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="equal")
    def equal(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfDimensionEqualOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfDimensionEqualOutputReference, jsii.get(self, "equal"))

    @builtins.property
    @jsii.member(jsii_name="greaterThan")
    def greater_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfDimensionGreaterThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfDimensionGreaterThanOutputReference, jsii.get(self, "greaterThan"))

    @builtins.property
    @jsii.member(jsii_name="lessThan")
    def less_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfDimensionLessThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfDimensionLessThanOutputReference, jsii.get(self, "lessThan"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfDimensionDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionInput")
    def dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionVarInput")
    def dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="equalInput")
    def equal_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfDimensionEqual], jsii.get(self, "equalInput"))

    @builtins.property
    @jsii.member(jsii_name="greaterThanInput")
    def greater_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfDimensionGreaterThan], jsii.get(self, "greaterThanInput"))

    @builtins.property
    @jsii.member(jsii_name="lessThanInput")
    def less_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfDimensionLessThan], jsii.get(self, "lessThanInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="dimension")
    def dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimension"))

    @dimension.setter
    def dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e0a3be1a347e1230ea7dbcc559790cfadfc669f9ae8cc6acd2200cdfd7740efc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimension", value)

    @builtins.property
    @jsii.member(jsii_name="dimensionVar")
    def dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimensionVar"))

    @dimension_var.setter
    def dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cfff90b8dc8f8799c734fd6501f3715f38ac17d45d54107adc1f1e74bab7a5b2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__42e1e6a51018c788aba6d8617b9c62dc286c604ea22c16eacf89deb662b6ef81)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2160647ddca760b30c4c50faf69ada1fb1bac64c0ff42ef115608982b9d686f2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfDimension]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfDimension]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfDimension]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a61ca23959c30cfe2d617bcd4a3d0e6d03e02d3cdb4d4408b75db7f6ef47dc9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfOrientation",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "landscape": "landscape",
        "portrait": "portrait",
        "square": "square",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfOrientation:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfOrientationDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        landscape: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfOrientationLandscape", typing.Dict[builtins.str, typing.Any]]] = None,
        portrait: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfOrientationPortrait", typing.Dict[builtins.str, typing.Any]]] = None,
        square: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfOrientationSquare", typing.Dict[builtins.str, typing.Any]]] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param landscape: landscape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        :param portrait: portrait block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        :param square: square block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfOrientationDefault(**default)
        if isinstance(landscape, dict):
            landscape = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfOrientationLandscape(**landscape)
        if isinstance(portrait, dict):
            portrait = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfOrientationPortrait(**portrait)
        if isinstance(square, dict):
            square = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfOrientationSquare(**square)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3750a40ce8ef664a0fe640b1cf0e1d454b1387ce59194f6c2d4607eed1f7b359)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument landscape", value=landscape, expected_type=type_hints["landscape"])
            check_type(argname="argument portrait", value=portrait, expected_type=type_hints["portrait"])
            check_type(argname="argument square", value=square, expected_type=type_hints["square"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if landscape is not None:
            self._values["landscape"] = landscape
        if portrait is not None:
            self._values["portrait"] = portrait
        if square is not None:
            self._values["square"] = square

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfOrientationDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfOrientationDefault"], result)

    @builtins.property
    def landscape(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfOrientationLandscape"]:
        '''landscape block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        '''
        result = self._values.get("landscape")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfOrientationLandscape"], result)

    @builtins.property
    def portrait(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfOrientationPortrait"]:
        '''portrait block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        '''
        result = self._values.get("portrait")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfOrientationPortrait"], result)

    @builtins.property
    def square(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfOrientationSquare"]:
        '''square block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        result = self._values.get("square")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfOrientationSquare"], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfOrientation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfOrientationDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfOrientationDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfOrientationDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfOrientationDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfOrientationDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1938c106dc0def1d2dc8b802db90344dc308f8d67db0101956ab8cdc97379e19)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfOrientationDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfOrientationDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__34e9c25f5c1616cbc6df8e5b1002fe410351a14775ab5e851c21083b0ee812f0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfOrientationLandscape",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfOrientationLandscape:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfOrientationLandscape(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfOrientationLandscapeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfOrientationLandscapeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ff0bed37363824226caf07ea95b6066eb2ea1183399c20f949918f4323276e5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfOrientationLandscape], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfOrientationLandscape],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e8a2968f79b1ce788ff25b6dc52a1ec2cf72cc98db5447c14ab0c452a8bd19b6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfOrientationList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfOrientationList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c142bef703a3b51d272fe5de20eb5384f54f93761c6f384b7f421981edef2b09)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfOrientationOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2b6795ff8c191d7fa6e0f6bf518adb936121bbb7bc1b201015d5a2a0319ec32d)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfOrientationOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f0ea5e813685f8d9d608cd5e3073356ce0727f7ba9881befc12393aaa8b4047a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6da548cd2ccac45966696c7e1ddcbb34eddb1a297fa223ed1781d02f0b67d9bb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c3b333d93d27c0f752c9663f33f2d9b6ac097f4bcbd146fd11be465567cd85e0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfOrientation]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfOrientation]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d05d38392b6a6add3dd49f39d746ee2a04236864081f9053d7a14c06f162a232)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfOrientationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfOrientationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a780dd841adafbec6b23373396f2a36d235bd319b40a38fc6ba213df4165719)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfOrientationDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putLandscape")
    def put_landscape(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfOrientationLandscape()

        return typing.cast(None, jsii.invoke(self, "putLandscape", [value]))

    @jsii.member(jsii_name="putPortrait")
    def put_portrait(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfOrientationPortrait()

        return typing.cast(None, jsii.invoke(self, "putPortrait", [value]))

    @jsii.member(jsii_name="putSquare")
    def put_square(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfOrientationSquare()

        return typing.cast(None, jsii.invoke(self, "putSquare", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetLandscape")
    def reset_landscape(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLandscape", []))

    @jsii.member(jsii_name="resetPortrait")
    def reset_portrait(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPortrait", []))

    @jsii.member(jsii_name="resetSquare")
    def reset_square(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSquare", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfOrientationDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfOrientationDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="landscape")
    def landscape(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfOrientationLandscapeOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfOrientationLandscapeOutputReference, jsii.get(self, "landscape"))

    @builtins.property
    @jsii.member(jsii_name="portrait")
    def portrait(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfOrientationPortraitOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfOrientationPortraitOutputReference", jsii.get(self, "portrait"))

    @builtins.property
    @jsii.member(jsii_name="square")
    def square(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfOrientationSquareOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfOrientationSquareOutputReference", jsii.get(self, "square"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfOrientationDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="landscapeInput")
    def landscape_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfOrientationLandscape], jsii.get(self, "landscapeInput"))

    @builtins.property
    @jsii.member(jsii_name="portraitInput")
    def portrait_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfOrientationPortrait"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfOrientationPortrait"], jsii.get(self, "portraitInput"))

    @builtins.property
    @jsii.member(jsii_name="squareInput")
    def square_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfOrientationSquare"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfOrientationSquare"], jsii.get(self, "squareInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfOrientation]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfOrientation]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfOrientation]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d380e62fd7f2e0e041969f2d698cb3cfa32d3d7b6114b5b6cfbb2d1c89d623ee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfOrientationPortrait",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfOrientationPortrait:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfOrientationPortrait(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfOrientationPortraitOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfOrientationPortraitOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__08dec2ad71f8d6a621d08272aa17a8d1ebe58a10b1a105bc088d573e09ea89f3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfOrientationPortrait]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfOrientationPortrait], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfOrientationPortrait],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__88615cf4cf65db3ca4ea311b16b4c0f9eef3cfb84211c40cd98a4ac69ee22a85)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfOrientationSquare",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfOrientationSquare:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfOrientationSquare(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfOrientationSquareOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfOrientationSquareOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7002ef69b26c404b5de41bc9dd2b5bb27c83ff30b01a97cf3b60f5a16aac137e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfOrientationSquare]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfOrientationSquare], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfOrientationSquare],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__00ddc6c476db7f9c27a2b216efbdccc8db691d818f2e91b27f06eaa485eb8a81)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6b4c1f92d684b41f3375bab1ded8419060a3854f91014465ccff62a1bf27314c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__14d092879fdedeeff257fc4ccd9183e6309cfb5d69fb4da7c14cddeb24facc6a)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a4f730ee9c0abd65f007efc3195ff0a37af30e2e35f9c3749f31e97b669ee3a2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc4bf7d48fa6e0aa43006fb6c452bb02d25934218464dba1cfcb143aa5ea3604)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d9203a3e49e67631ca9804b3f4d64ff93ed0d8125b277ffd48e708dc7cff0f5f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformations]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformations]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformations]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__13126cc6cb1c85d3fb8d98e5d60d65b7d8931a3b420f8d41dceb996e98d53668)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsMaxColors",
    jsii_struct_bases=[],
    name_mapping={"colors": "colors", "colors_var": "colorsVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsMaxColors:
    def __init__(
        self,
        *,
        colors: typing.Optional[builtins.str] = None,
        colors_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param colors: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        :param colors_var: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__51a45bbc821198afd2488ee981d7fb8240b7494e85a4e93d1439d33f6a78b354)
            check_type(argname="argument colors", value=colors, expected_type=type_hints["colors"])
            check_type(argname="argument colors_var", value=colors_var, expected_type=type_hints["colors_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if colors is not None:
            self._values["colors"] = colors
        if colors_var is not None:
            self._values["colors_var"] = colors_var

    @builtins.property
    def colors(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        '''
        result = self._values.get("colors")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def colors_var(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        result = self._values.get("colors_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsMaxColors(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsMaxColorsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsMaxColorsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__14a7bedde0cd2ffc7ec281537217e34c4f3c89bb9b4e1124b9c0ab2ff4222961)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsMaxColorsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ed3cbc1b89e170969812c1d943829694a2448d2fa7a8d8f09d4f555134861a08)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsMaxColorsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ddb147b452ad8f7a8e833eca61878194ec3c51dba92e8b5068130d9ff336376)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__72830643adc520e3e8f55f08758e8d4843f2646c53eb8373808422e96fad2acd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ad1168c9cdac3914c9340cb067685ea97181c87cb6c48e12d35b69e313558e97)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsMaxColors]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsMaxColors]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d5d1aa7cf479a910627b088271babea2d4d4defe95e0fb03045b5381abf8d7d7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsMaxColorsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsMaxColorsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3cf0751d6b23cfd71c42389c81850b34c0dd4fe727b1db526baf8cdf305f75ae)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColors")
    def reset_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColors", []))

    @jsii.member(jsii_name="resetColorsVar")
    def reset_colors_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorsVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorsInput")
    def colors_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsInput"))

    @builtins.property
    @jsii.member(jsii_name="colorsVarInput")
    def colors_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsVarInput"))

    @builtins.property
    @jsii.member(jsii_name="colors")
    def colors(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colors"))

    @colors.setter
    def colors(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__becc81c640294607355b574197c723384ef790ddb643591ffca08db4c2dae77e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colors", value)

    @builtins.property
    @jsii.member(jsii_name="colorsVar")
    def colors_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorsVar"))

    @colors_var.setter
    def colors_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d6ff6ad4f0333f7d9a05c49485ba1cb92481491399fc818deff285ba4b41cc11)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorsVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsMaxColors]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsMaxColors]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsMaxColors]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__359e3bc175a34bb5fcca2e0a8744735d4d5875dd2efbfadfb6ec11d673e952a3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsMirror",
    jsii_struct_bases=[],
    name_mapping={
        "horizontal": "horizontal",
        "horizontal_var": "horizontalVar",
        "vertical": "vertical",
        "vertical_var": "verticalVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsMirror:
    def __init__(
        self,
        *,
        horizontal: typing.Optional[builtins.str] = None,
        horizontal_var: typing.Optional[builtins.str] = None,
        vertical: typing.Optional[builtins.str] = None,
        vertical_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param horizontal: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        :param horizontal_var: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        :param vertical: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        :param vertical_var: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d1ece8f9775edbc0f62d5d26a40165681f62b9d99643bef40ecada794f7656fa)
            check_type(argname="argument horizontal", value=horizontal, expected_type=type_hints["horizontal"])
            check_type(argname="argument horizontal_var", value=horizontal_var, expected_type=type_hints["horizontal_var"])
            check_type(argname="argument vertical", value=vertical, expected_type=type_hints["vertical"])
            check_type(argname="argument vertical_var", value=vertical_var, expected_type=type_hints["vertical_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if horizontal is not None:
            self._values["horizontal"] = horizontal
        if horizontal_var is not None:
            self._values["horizontal_var"] = horizontal_var
        if vertical is not None:
            self._values["vertical"] = vertical
        if vertical_var is not None:
            self._values["vertical_var"] = vertical_var

    @builtins.property
    def horizontal(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        '''
        result = self._values.get("horizontal")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def horizontal_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        '''
        result = self._values.get("horizontal_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        '''
        result = self._values.get("vertical")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        result = self._values.get("vertical_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsMirror(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsMirrorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsMirrorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__429803f2bb2179b182a303ede6666071455c074ebf9fe054fb1a2cc16ba4870d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsMirrorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bd200882396c1efba484c64b1763f77384c6a38f8fd107f1aad3d2b0419e5a14)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsMirrorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b344002b9c710099fe8d1cbedb2416e7a32fc361d11717da1757bb1a12b0a5b2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__423c32c22422166279a2e02636124362e5b0e28abeee0887d2c0914a87795536)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__099a73ed0aacfe49fc70bd33ea9b40cd2f339360fa892b4585eb61d8659f8ce5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsMirror]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsMirror]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__59a085666d4cf56533243e37d364e497d6926d7a96c50320c19715bc869e5f46)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsMirrorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsMirrorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a124d8a3c1095022a4646bf6c3a58a9dec0717f7625f98affe70fd8363332bbb)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHorizontal")
    def reset_horizontal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontal", []))

    @jsii.member(jsii_name="resetHorizontalVar")
    def reset_horizontal_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontalVar", []))

    @jsii.member(jsii_name="resetVertical")
    def reset_vertical(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVertical", []))

    @jsii.member(jsii_name="resetVerticalVar")
    def reset_vertical_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVerticalVar", []))

    @builtins.property
    @jsii.member(jsii_name="horizontalInput")
    def horizontal_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontalVarInput")
    def horizontal_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalInput")
    def vertical_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalVarInput")
    def vertical_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontal")
    def horizontal(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontal"))

    @horizontal.setter
    def horizontal(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6657ddc57ece7a21e2f3379291d7400a9faf42fec80d84d7aafcdf505bd7d5d4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontal", value)

    @builtins.property
    @jsii.member(jsii_name="horizontalVar")
    def horizontal_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontalVar"))

    @horizontal_var.setter
    def horizontal_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__471ed9c47a2e62f9d9a341cba1a1e5bfd1ddb014cfea3ccbbcc2d6771ac55eb8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontalVar", value)

    @builtins.property
    @jsii.member(jsii_name="vertical")
    def vertical(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "vertical"))

    @vertical.setter
    def vertical(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__20bb04fdc39aaf2a8d0293d51b35ac7873ecf65a1ded262b628d0640dc626d20)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "vertical", value)

    @builtins.property
    @jsii.member(jsii_name="verticalVar")
    def vertical_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "verticalVar"))

    @vertical_var.setter
    def vertical_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__beecb6a8d60ca512c10b8c185f332ffae6c236ed2f7094467b890c9b7123ab2e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "verticalVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsMirror]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsMirror]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsMirror]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7ba89550c798aefe7ddbb144f4f2950359ef38d1cd6b5e1dcb246b8430a4d262)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsMonoHue",
    jsii_struct_bases=[],
    name_mapping={"hue": "hue", "hue_var": "hueVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsMonoHue:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a9069903890cc7bf37945802af01b03b92c5fd612898fc6d9109771bdb5464e0)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsMonoHue(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsMonoHueList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsMonoHueList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__419bcea43f68b2952569b810b9a2e82e10ec6c28adbb9aa253fb92a5cc978ff8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsMonoHueOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e343e5c7a4a9fb42fa1b200f63d10a288c5a453838da05b963696f666860c6ce)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsMonoHueOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__05adb8b964cb490f01bd9b4f11b3ea328f699bedf0c2b062d390f35de3cd0f5c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c377f3fd41c3622ff2e57c7baf17e080bb9bc1e2c5c6df0019cd3bdad498591e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8f999588f6e2f9feb0321cd4e4228ee6320a6a7ba7069ada130e8855a6e1fb87)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsMonoHue]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsMonoHue]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9b82b7b58b3c65e796ce24fbd4eaaabbd457e423735421afd56b59289bf107ba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsMonoHueOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsMonoHueOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6c1efdd9d1f2940ad3d5fa637dd05d721fceac6e492b2a00b0af12bf96e654a7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd910c7a61455e441d4e76ad9bb14851845fa123172436092b2e2b99f54272cd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f92b8ea0bb59da2c68180780fd31f677f00098af881d261dbcc303e954467523)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsMonoHue]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsMonoHue]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsMonoHue]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5b39843a656a28b94f1dfc76c52f02417561eeabe880bf6af01a2048c9324e49)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsOpacity",
    jsii_struct_bases=[],
    name_mapping={"opacity": "opacity", "opacity_var": "opacityVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsOpacity:
    def __init__(
        self,
        *,
        opacity: typing.Optional[builtins.str] = None,
        opacity_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param opacity: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param opacity_var: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0f5d86ffab85cb752b524ad64337773b7a5ee92e5a9d2bbc50bbe6586e403303)
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument opacity_var", value=opacity_var, expected_type=type_hints["opacity_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if opacity is not None:
            self._values["opacity"] = opacity
        if opacity_var is not None:
            self._values["opacity_var"] = opacity_var

    @builtins.property
    def opacity(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def opacity_var(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        result = self._values.get("opacity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsOpacity(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsOpacityList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsOpacityList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__22552e9622ce6bf131926c18cb16ddb940c818a093014cbd81045307e1ffd71c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsOpacityOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__457ab7c87e63921a25c8d626c7683846584ec7b7a1154fdf7414a17ba6415f8e)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsOpacityOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ccc64700124a93c6989b7845962116631beed79a441e18ad4d016a0a36a4e054)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d00f07c6b59cb35d948f27ff2ca5b1ea33e9fc76e6ab685d6c80bb8a9a98b8f5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e9c8cc26271c178ed8a43da2345b007a78626459f2885b66a61de54e18ffae7f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsOpacity]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsOpacity]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__198f156017594751664d775b9839d0ae2403fb5d088a9e7a7617c3e909bed8b8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsOpacityOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsOpacityOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__58ac69fe22681e36d4d02aee94ebd37207959890054865cb0d5aa00d08ef200e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetOpacityVar")
    def reset_opacity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacityVar", []))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityVarInput")
    def opacity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacity"))

    @opacity.setter
    def opacity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1088e9587cd6d84d49de948a214a03fda2bef88b116916c53dbc71b8064a223b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacity", value)

    @builtins.property
    @jsii.member(jsii_name="opacityVar")
    def opacity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacityVar"))

    @opacity_var.setter
    def opacity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ff622e945d56b4737b5306781a306a10940f73d8751ce8f5b89eb5172e996a50)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacityVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsOpacity]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsOpacity]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsOpacity]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__750b3f6e549430bd555dc53ba7febe8caf84876fe460dfc503827d60d38c2cfa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__83f3627d1cf7c2e554e23dfc5e9b616b70faf4bb7c5632ef95c8a3754a702716)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putBackgroundColor")
    def put_background_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__80631cd1089e5ec3fd446af2c3af17085007b476c9d920b433baace9b28f15f2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBackgroundColor", [value]))

    @jsii.member(jsii_name="putBlur")
    def put_blur(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsBlur, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__430501bc7718f0e0da8f971ebf5d355f2b7abc392ac02bb417e65715f0618215)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBlur", [value]))

    @jsii.member(jsii_name="putChromaKey")
    def put_chroma_key(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsChromaKey, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__103d3793f7b966ed68bc82b8ebc35f548f02061dbc39c80cbb5cc843b0b78078)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putChromaKey", [value]))

    @jsii.member(jsii_name="putComposite")
    def put_composite(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsComposite, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9673f914cc5b53972d5835824184e565223908297f2c3be954ea52e4edfac3c2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putComposite", [value]))

    @jsii.member(jsii_name="putCompound")
    def put_compound(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsCompound, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8d5150a3b251b574631a654c1e78f1d1e30a2f146a8b6f4bf5d386012c259aef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCompound", [value]))

    @jsii.member(jsii_name="putContrast")
    def put_contrast(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsContrast, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__35fc1a0df8774ab3e19343bc9cc5a90df74cdda34d552a49eaca825a159fccb8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putContrast", [value]))

    @jsii.member(jsii_name="putGoop")
    def put_goop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsGoop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9c1e5ed164adc25f144d2f9eb685694ec23db5b2a79e25fca688fabed9680985)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGoop", [value]))

    @jsii.member(jsii_name="putGrayscale")
    def put_grayscale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsGrayscale, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d552306ebc33d3163c0ef4dfd41a2d0a2aede4cc8662a031a5e3a92493b5ec0e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGrayscale", [value]))

    @jsii.member(jsii_name="putHsl")
    def put_hsl(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsHsl, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__79459511c3118e16a6d66f268efb3ca176ceddcba7734c27063d994fcad2a4ac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsl", [value]))

    @jsii.member(jsii_name="putHsv")
    def put_hsv(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsHsv, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f48fdb61ea2d98cae52b7d16cd0ed73215c348cb32611e548dd6bd8a2f23ab7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsv", [value]))

    @jsii.member(jsii_name="putIfDimension")
    def put_if_dimension(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfDimension, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3b27731ffae5b4a4e99058d77d70a99f9571939df4c7084f424da3dafdf130e1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfDimension", [value]))

    @jsii.member(jsii_name="putIfOrientation")
    def put_if_orientation(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a88aa7b4da0151307f67dd9ad75e21989b36fdcccd630ddbf7c1d46786d23ca0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfOrientation", [value]))

    @jsii.member(jsii_name="putMaxColors")
    def put_max_colors(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsMaxColors, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0423fca8c1b8eefc9b763935f95cd7e7b2920d150320843b306318b4a04245ea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMaxColors", [value]))

    @jsii.member(jsii_name="putMirror")
    def put_mirror(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsMirror, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__995ae77184c269fab8623e8589cb36eb79f4126c0530432558d5ff1b525177df)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMirror", [value]))

    @jsii.member(jsii_name="putMonoHue")
    def put_mono_hue(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsMonoHue, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0b012b27336820c2297ccd379ce39f76374098b29949d4b5651b2219881ee59b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMonoHue", [value]))

    @jsii.member(jsii_name="putOpacity")
    def put_opacity(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsOpacity, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e8c20857daf928fb2c6679ca008a0fedb0a8dd514c9b82cf60b6933610cfe30f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putOpacity", [value]))

    @jsii.member(jsii_name="putRemoveColor")
    def put_remove_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsRemoveColor", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__90104574e7af4156198519d2529e43783e9b77b9298883bfa9106d01f114647a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRemoveColor", [value]))

    @jsii.member(jsii_name="putUnsharpMask")
    def put_unsharp_mask(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsUnsharpMask", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af522bd6eef2b1f292454afb27232c21d60892e2587f7a9be5ff8879e455ae07)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putUnsharpMask", [value]))

    @jsii.member(jsii_name="resetBackgroundColor")
    def reset_background_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBackgroundColor", []))

    @jsii.member(jsii_name="resetBlur")
    def reset_blur(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBlur", []))

    @jsii.member(jsii_name="resetChromaKey")
    def reset_chroma_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChromaKey", []))

    @jsii.member(jsii_name="resetComposite")
    def reset_composite(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetComposite", []))

    @jsii.member(jsii_name="resetCompound")
    def reset_compound(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCompound", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetGoop")
    def reset_goop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGoop", []))

    @jsii.member(jsii_name="resetGrayscale")
    def reset_grayscale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGrayscale", []))

    @jsii.member(jsii_name="resetHsl")
    def reset_hsl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsl", []))

    @jsii.member(jsii_name="resetHsv")
    def reset_hsv(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsv", []))

    @jsii.member(jsii_name="resetIfDimension")
    def reset_if_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfDimension", []))

    @jsii.member(jsii_name="resetIfOrientation")
    def reset_if_orientation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfOrientation", []))

    @jsii.member(jsii_name="resetMaxColors")
    def reset_max_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxColors", []))

    @jsii.member(jsii_name="resetMirror")
    def reset_mirror(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMirror", []))

    @jsii.member(jsii_name="resetMonoHue")
    def reset_mono_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonoHue", []))

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetRemoveColor")
    def reset_remove_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRemoveColor", []))

    @jsii.member(jsii_name="resetUnsharpMask")
    def reset_unsharp_mask(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUnsharpMask", []))

    @builtins.property
    @jsii.member(jsii_name="backgroundColor")
    def background_color(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsBackgroundColorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsBackgroundColorList, jsii.get(self, "backgroundColor"))

    @builtins.property
    @jsii.member(jsii_name="blur")
    def blur(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsBlurList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsBlurList, jsii.get(self, "blur"))

    @builtins.property
    @jsii.member(jsii_name="chromaKey")
    def chroma_key(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsChromaKeyList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsChromaKeyList, jsii.get(self, "chromaKey"))

    @builtins.property
    @jsii.member(jsii_name="composite")
    def composite(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsCompositeList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsCompositeList, jsii.get(self, "composite"))

    @builtins.property
    @jsii.member(jsii_name="compound")
    def compound(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsCompoundList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsCompoundList, jsii.get(self, "compound"))

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsContrastList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsContrastList, jsii.get(self, "contrast"))

    @builtins.property
    @jsii.member(jsii_name="goop")
    def goop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsGoopList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsGoopList, jsii.get(self, "goop"))

    @builtins.property
    @jsii.member(jsii_name="grayscale")
    def grayscale(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsGrayscaleList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsGrayscaleList, jsii.get(self, "grayscale"))

    @builtins.property
    @jsii.member(jsii_name="hsl")
    def hsl(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsHslList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsHslList, jsii.get(self, "hsl"))

    @builtins.property
    @jsii.member(jsii_name="hsv")
    def hsv(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsHsvList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsHsvList, jsii.get(self, "hsv"))

    @builtins.property
    @jsii.member(jsii_name="ifDimension")
    def if_dimension(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfDimensionList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfDimensionList, jsii.get(self, "ifDimension"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientation")
    def if_orientation(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfOrientationList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfOrientationList, jsii.get(self, "ifOrientation"))

    @builtins.property
    @jsii.member(jsii_name="maxColors")
    def max_colors(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsMaxColorsList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsMaxColorsList, jsii.get(self, "maxColors"))

    @builtins.property
    @jsii.member(jsii_name="mirror")
    def mirror(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsMirrorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsMirrorList, jsii.get(self, "mirror"))

    @builtins.property
    @jsii.member(jsii_name="monoHue")
    def mono_hue(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsMonoHueList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsMonoHueList, jsii.get(self, "monoHue"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsOpacityList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsOpacityList, jsii.get(self, "opacity"))

    @builtins.property
    @jsii.member(jsii_name="removeColor")
    def remove_color(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsRemoveColorList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsRemoveColorList", jsii.get(self, "removeColor"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMask")
    def unsharp_mask(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsUnsharpMaskList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsUnsharpMaskList", jsii.get(self, "unsharpMask"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColorInput")
    def background_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsBackgroundColor]]], jsii.get(self, "backgroundColorInput"))

    @builtins.property
    @jsii.member(jsii_name="blurInput")
    def blur_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsBlur]]], jsii.get(self, "blurInput"))

    @builtins.property
    @jsii.member(jsii_name="chromaKeyInput")
    def chroma_key_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsChromaKey]]], jsii.get(self, "chromaKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="compositeInput")
    def composite_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsComposite]]], jsii.get(self, "compositeInput"))

    @builtins.property
    @jsii.member(jsii_name="compoundInput")
    def compound_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsCompound]]], jsii.get(self, "compoundInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsContrast]]], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="goopInput")
    def goop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsGoop]]], jsii.get(self, "goopInput"))

    @builtins.property
    @jsii.member(jsii_name="grayscaleInput")
    def grayscale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsGrayscale]]], jsii.get(self, "grayscaleInput"))

    @builtins.property
    @jsii.member(jsii_name="hslInput")
    def hsl_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsHsl]]], jsii.get(self, "hslInput"))

    @builtins.property
    @jsii.member(jsii_name="hsvInput")
    def hsv_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsHsv]]], jsii.get(self, "hsvInput"))

    @builtins.property
    @jsii.member(jsii_name="ifDimensionInput")
    def if_dimension_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfDimension]]], jsii.get(self, "ifDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientationInput")
    def if_orientation_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfOrientation]]], jsii.get(self, "ifOrientationInput"))

    @builtins.property
    @jsii.member(jsii_name="maxColorsInput")
    def max_colors_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsMaxColors]]], jsii.get(self, "maxColorsInput"))

    @builtins.property
    @jsii.member(jsii_name="mirrorInput")
    def mirror_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsMirror]]], jsii.get(self, "mirrorInput"))

    @builtins.property
    @jsii.member(jsii_name="monoHueInput")
    def mono_hue_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsMonoHue]]], jsii.get(self, "monoHueInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsOpacity]]], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="removeColorInput")
    def remove_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsRemoveColor"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsRemoveColor"]]], jsii.get(self, "removeColorInput"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMaskInput")
    def unsharp_mask_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsUnsharpMask"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsUnsharpMask"]]], jsii.get(self, "unsharpMaskInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformations]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformations]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformations]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6756c07f5f8efefe50b2a6829223687c8d9643782b12f66fa9bb349bf66e4f43)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsRemoveColor",
    jsii_struct_bases=[],
    name_mapping={
        "color": "color",
        "color_var": "colorVar",
        "feather": "feather",
        "feather_var": "featherVar",
        "tolerance": "tolerance",
        "tolerance_var": "toleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsRemoveColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
        feather: typing.Optional[builtins.str] = None,
        feather_var: typing.Optional[builtins.str] = None,
        tolerance: typing.Optional[builtins.str] = None,
        tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        :param feather: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        :param feather_var: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        :param tolerance: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        :param tolerance_var: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7824c0098e70fdfe8c457868a8eecdeae77790cab4c56e0268b01a5b348f584a)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
            check_type(argname="argument feather", value=feather, expected_type=type_hints["feather"])
            check_type(argname="argument feather_var", value=feather_var, expected_type=type_hints["feather_var"])
            check_type(argname="argument tolerance", value=tolerance, expected_type=type_hints["tolerance"])
            check_type(argname="argument tolerance_var", value=tolerance_var, expected_type=type_hints["tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var
        if feather is not None:
            self._values["feather"] = feather
        if feather_var is not None:
            self._values["feather_var"] = feather_var
        if tolerance is not None:
            self._values["tolerance"] = tolerance
        if tolerance_var is not None:
            self._values["tolerance_var"] = tolerance_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        '''
        result = self._values.get("feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather_var(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        '''
        result = self._values.get("feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        '''
        result = self._values.get("tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance_var(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        result = self._values.get("tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsRemoveColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsRemoveColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsRemoveColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6401dff8abd610c6797ad5e2fdb890d670dd1689e9c4f78dfb5dbc3af2406bc6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsRemoveColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__031880c1a6b0b0e064e5ec6358e7d5cf34e0773015fd09544dbf04a8e0a6bb46)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsRemoveColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__37c956f01d1d80bdf6f484c010e59bf3da34566fa7c8df15195cb00b37f83af6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a6ff49e17937064ef637a991842c0094ab7a95dff591445503bdf3e9004b2a52)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ba2ee10e268107abfcd966a910d2e63419898bd038d4c5ba150661b0621ad13)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsRemoveColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsRemoveColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsRemoveColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a861085c72ac3aedbad65a50a7a219a1dadd9b35ede9350208f32a496fc92358)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsRemoveColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsRemoveColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__39acce1363edfb15b887e93dbb41d5741204759773db154ecd40466dd7385745)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @jsii.member(jsii_name="resetFeather")
    def reset_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeather", []))

    @jsii.member(jsii_name="resetFeatherVar")
    def reset_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatherVar", []))

    @jsii.member(jsii_name="resetTolerance")
    def reset_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTolerance", []))

    @jsii.member(jsii_name="resetToleranceVar")
    def reset_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featherInput")
    def feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherInput"))

    @builtins.property
    @jsii.member(jsii_name="featherVarInput")
    def feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceInput")
    def tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceVarInput")
    def tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8407b4b140d58bde9e2a81d01963cc3d8ac7b703796973ec5440ff07b0a41110)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__493b24360b8ce67f23ee02f6402f39c437333378bb771788bd61b3872d511193)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="feather")
    def feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "feather"))

    @feather.setter
    def feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__475267725a3098d381c783673baf4f172858e78672570c6673cb9c0999106fd5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "feather", value)

    @builtins.property
    @jsii.member(jsii_name="featherVar")
    def feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featherVar"))

    @feather_var.setter
    def feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__972d9a01910de0bb6ba66a0e7cd8320984e7d132e60616fba426c4a1456e8af8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featherVar", value)

    @builtins.property
    @jsii.member(jsii_name="tolerance")
    def tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tolerance"))

    @tolerance.setter
    def tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5b83f185625d48d74749ed0fb1643ca6123e75e9304c2552456513a5f2fa8c50)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tolerance", value)

    @builtins.property
    @jsii.member(jsii_name="toleranceVar")
    def tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "toleranceVar"))

    @tolerance_var.setter
    def tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c0729e94bd230b8ec698c57316d7f7eb54a90c332d0eddc49ba54bd924e47438)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "toleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsRemoveColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsRemoveColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsRemoveColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6be98487985b9af1c924b979d9c5c27a3d6be6e9907efe0006a8af1d484023a1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsUnsharpMask",
    jsii_struct_bases=[],
    name_mapping={
        "gain": "gain",
        "gain_var": "gainVar",
        "sigma": "sigma",
        "sigma_var": "sigmaVar",
        "threshold": "threshold",
        "threshold_var": "thresholdVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsUnsharpMask:
    def __init__(
        self,
        *,
        gain: typing.Optional[builtins.str] = None,
        gain_var: typing.Optional[builtins.str] = None,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
        threshold: typing.Optional[builtins.str] = None,
        threshold_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param gain: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        :param gain_var: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        :param sigma: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        :param threshold: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        :param threshold_var: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4957d00d61c3e959ea2c0aca0ad014ba69de7d89d5efcd6602f7f3e28afc6eaf)
            check_type(argname="argument gain", value=gain, expected_type=type_hints["gain"])
            check_type(argname="argument gain_var", value=gain_var, expected_type=type_hints["gain_var"])
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
            check_type(argname="argument threshold", value=threshold, expected_type=type_hints["threshold"])
            check_type(argname="argument threshold_var", value=threshold_var, expected_type=type_hints["threshold_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if gain is not None:
            self._values["gain"] = gain
        if gain_var is not None:
            self._values["gain_var"] = gain_var
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var
        if threshold is not None:
            self._values["threshold"] = threshold
        if threshold_var is not None:
            self._values["threshold_var"] = threshold_var

    @builtins.property
    def gain(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        '''
        result = self._values.get("gain")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gain_var(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        '''
        result = self._values.get("gain_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        '''
        result = self._values.get("threshold")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold_var(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        result = self._values.get("threshold_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsUnsharpMask(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsUnsharpMaskList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsUnsharpMaskList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__438514b8b056d0a5800b0a4fab196851aabe73228df9b9c7b1de3fad83491cf4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsUnsharpMaskOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6221c7716b8b858def6bda8cc2d028da615782294ce91aa98f2ff3025d4154e3)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsUnsharpMaskOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e0347455a1aa2fdc54fc3bbc9126ce7cd7262d76d7753a2efb9b676f02c3a145)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1444a7e492d4099aa7844314cbca34991af8ce62f0b962bf0a47c3949d995efe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9cfb6aa84fb68edf447c19b1e0075595ee1d8a3f2babc300e6921b9e3be07a76)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsUnsharpMask]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsUnsharpMask]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsUnsharpMask]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d2d776ffdafee03f7add704b960e8fe3693cce19968e1e1fb79a7a75aa5bc24)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsUnsharpMaskOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsUnsharpMaskOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c49cc3e42d8237bb4b61b4ce1a1299328b2686089b5a341d13f4a03e1c26d2e7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetGain")
    def reset_gain(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGain", []))

    @jsii.member(jsii_name="resetGainVar")
    def reset_gain_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGainVar", []))

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @jsii.member(jsii_name="resetThreshold")
    def reset_threshold(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThreshold", []))

    @jsii.member(jsii_name="resetThresholdVar")
    def reset_threshold_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThresholdVar", []))

    @builtins.property
    @jsii.member(jsii_name="gainInput")
    def gain_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainInput"))

    @builtins.property
    @jsii.member(jsii_name="gainVarInput")
    def gain_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdInput")
    def threshold_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdVarInput")
    def threshold_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gain")
    def gain(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gain"))

    @gain.setter
    def gain(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eb22c4744430baa1c8eb684b65ee83ceb3bca53c3b8ecd61258177d4b26c54a0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gain", value)

    @builtins.property
    @jsii.member(jsii_name="gainVar")
    def gain_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gainVar"))

    @gain_var.setter
    def gain_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__43bef0bc8d227300ea8e20ff37396491650a71c16377e7a2f203d97b9f3de22c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gainVar", value)

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__108507978c00e4061600784fd1ebd521df5171865533701b083723a9ed251d9b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c77d2ba10606b87dddafcd9cc4bed839319ce6acce16635a4bf08471df8406aa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="threshold")
    def threshold(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "threshold"))

    @threshold.setter
    def threshold(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__154fc70513651ed6da892940f9372d984314b1161c523c3c56eee22d304a6288)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "threshold", value)

    @builtins.property
    @jsii.member(jsii_name="thresholdVar")
    def threshold_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "thresholdVar"))

    @threshold_var.setter
    def threshold_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__77eee404e0218e05a8eee1c77e0a1ac7eee656ab7a34bb6f9069d5dcff052a5d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "thresholdVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsUnsharpMask]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsUnsharpMask]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsUnsharpMask]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d88e265b8a04944310dd2c9322c736e0d9b4bb6cfcfd3729e5de5fe903723236)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareContrast",
    jsii_struct_bases=[],
    name_mapping={
        "brightness": "brightness",
        "brightness_var": "brightnessVar",
        "contrast": "contrast",
        "contrast_var": "contrastVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareContrast:
    def __init__(
        self,
        *,
        brightness: typing.Optional[builtins.str] = None,
        brightness_var: typing.Optional[builtins.str] = None,
        contrast: typing.Optional[builtins.str] = None,
        contrast_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param brightness: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        :param brightness_var: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        :param contrast: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param contrast_var: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__95d03fa11becd20fb75966324f26d1554e9d694616f0329b2a63d48910695cf3)
            check_type(argname="argument brightness", value=brightness, expected_type=type_hints["brightness"])
            check_type(argname="argument brightness_var", value=brightness_var, expected_type=type_hints["brightness_var"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument contrast_var", value=contrast_var, expected_type=type_hints["contrast_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if brightness is not None:
            self._values["brightness"] = brightness
        if brightness_var is not None:
            self._values["brightness_var"] = brightness_var
        if contrast is not None:
            self._values["contrast"] = contrast
        if contrast_var is not None:
            self._values["contrast_var"] = contrast_var

    @builtins.property
    def brightness(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        '''
        result = self._values.get("brightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def brightness_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        '''
        result = self._values.get("brightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        result = self._values.get("contrast_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareContrast(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareContrastList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareContrastList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5e9f92b48ab7caa69ffa0f16d7d131925098aad65c9572174575321031f9a20e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareContrastOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a601041600f9140637501d9818b616ccd6570fb97af7f53daca03d612b54726)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareContrastOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__afc08c3b973a439252102f08b08cd47452e61c9cbf81636276ad511a229c74a2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__de105dc82857bf379ee7930dd8a1bf156a31845323d2225d889dd8813d5035e6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f40b03f06fcb50b3a37966a5be93763b039320568ea3cdcd4c478b7ea06eeedf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareContrast]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareContrast]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ddc441d592e67d6f68e5773995afe2bbca2c11553f3580c51c5e1d27ee51456f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareContrastOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareContrastOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__49e086feee580a1c1e657bc7d5116f9ee29cbe0eff44db8e096a3495a71fb214)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetBrightness")
    def reset_brightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightness", []))

    @jsii.member(jsii_name="resetBrightnessVar")
    def reset_brightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightnessVar", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetContrastVar")
    def reset_contrast_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrastVar", []))

    @builtins.property
    @jsii.member(jsii_name="brightnessInput")
    def brightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="brightnessVarInput")
    def brightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastVarInput")
    def contrast_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="brightness")
    def brightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightness"))

    @brightness.setter
    def brightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ae87a58469582e938bdabfdc0e8f1a7dcadfb0df37420047c8076b9beb68d724)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightness", value)

    @builtins.property
    @jsii.member(jsii_name="brightnessVar")
    def brightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightnessVar"))

    @brightness_var.setter
    def brightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__726514f4eb21e4b825fd317d396510faaec3965cb6c4bd306723085dbf0224e8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrast"))

    @contrast.setter
    def contrast(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__817943b7152bb929f424c867a270434dc34098dee82dee084b2d0d140bbc667d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrast", value)

    @builtins.property
    @jsii.member(jsii_name="contrastVar")
    def contrast_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrastVar"))

    @contrast_var.setter
    def contrast_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a239b0c3ce722e0de6b9978cad525d2387f56461a103e8f3d168d09e969a2c55)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrastVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareContrast]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareContrast]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareContrast]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__531419de21eebf176b2dc750c6a4411cd6887824e57bea3ffb8be8ab1f2a064a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareGoop",
    jsii_struct_bases=[],
    name_mapping={
        "chaos": "chaos",
        "chaos_var": "chaosVar",
        "density": "density",
        "density_var": "densityVar",
        "power": "power",
        "power_var": "powerVar",
        "seed": "seed",
        "seed_var": "seedVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareGoop:
    def __init__(
        self,
        *,
        chaos: typing.Optional[builtins.str] = None,
        chaos_var: typing.Optional[builtins.str] = None,
        density: typing.Optional[builtins.str] = None,
        density_var: typing.Optional[builtins.str] = None,
        power: typing.Optional[builtins.str] = None,
        power_var: typing.Optional[builtins.str] = None,
        seed: typing.Optional[builtins.str] = None,
        seed_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param chaos: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        :param chaos_var: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        :param density: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        :param density_var: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        :param power: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        :param power_var: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        :param seed: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        :param seed_var: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__21b8954e1506de4e4026fe1bc494d3ed6fc47d6a04ded58c6e3feb6052d7deff)
            check_type(argname="argument chaos", value=chaos, expected_type=type_hints["chaos"])
            check_type(argname="argument chaos_var", value=chaos_var, expected_type=type_hints["chaos_var"])
            check_type(argname="argument density", value=density, expected_type=type_hints["density"])
            check_type(argname="argument density_var", value=density_var, expected_type=type_hints["density_var"])
            check_type(argname="argument power", value=power, expected_type=type_hints["power"])
            check_type(argname="argument power_var", value=power_var, expected_type=type_hints["power_var"])
            check_type(argname="argument seed", value=seed, expected_type=type_hints["seed"])
            check_type(argname="argument seed_var", value=seed_var, expected_type=type_hints["seed_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if chaos is not None:
            self._values["chaos"] = chaos
        if chaos_var is not None:
            self._values["chaos_var"] = chaos_var
        if density is not None:
            self._values["density"] = density
        if density_var is not None:
            self._values["density_var"] = density_var
        if power is not None:
            self._values["power"] = power
        if power_var is not None:
            self._values["power_var"] = power_var
        if seed is not None:
            self._values["seed"] = seed
        if seed_var is not None:
            self._values["seed_var"] = seed_var

    @builtins.property
    def chaos(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        '''
        result = self._values.get("chaos")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def chaos_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        '''
        result = self._values.get("chaos_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        '''
        result = self._values.get("density")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density_var(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        '''
        result = self._values.get("density_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        '''
        result = self._values.get("power")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power_var(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        '''
        result = self._values.get("power_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        '''
        result = self._values.get("seed")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed_var(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        result = self._values.get("seed_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareGoop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareGoopList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareGoopList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__46c8a55edcfd66876b32e06af5d51a5f88c286a59df06ebd840a8335a6dba234)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareGoopOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e7e40d13a9c930d8420121772d0b3ab9b01565fb74f82186464122acf5834196)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareGoopOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c758282efdf3ad15f3908c6b2aa1af10d7cd29c79d223a872dbbccd329c597db)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a111ba289ef224a419e25cb07f8d6168e6c3f762853f3b2f4d540307bb9f342a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d52cbae84ecbfe92cef11699eee06a2a1c67a59494465ba41398347272011a56)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareGoop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareGoop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c843a3223758d2970ab4b54112df7fa15d87593d0c02e3962879d35553eea36b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareGoopOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareGoopOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7f75486d62ee16c2173de1a8d5abb832d5f7aba519ec083ea03efc882b296ec8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetChaos")
    def reset_chaos(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaos", []))

    @jsii.member(jsii_name="resetChaosVar")
    def reset_chaos_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaosVar", []))

    @jsii.member(jsii_name="resetDensity")
    def reset_density(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensity", []))

    @jsii.member(jsii_name="resetDensityVar")
    def reset_density_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensityVar", []))

    @jsii.member(jsii_name="resetPower")
    def reset_power(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPower", []))

    @jsii.member(jsii_name="resetPowerVar")
    def reset_power_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPowerVar", []))

    @jsii.member(jsii_name="resetSeed")
    def reset_seed(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeed", []))

    @jsii.member(jsii_name="resetSeedVar")
    def reset_seed_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeedVar", []))

    @builtins.property
    @jsii.member(jsii_name="chaosInput")
    def chaos_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosInput"))

    @builtins.property
    @jsii.member(jsii_name="chaosVarInput")
    def chaos_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosVarInput"))

    @builtins.property
    @jsii.member(jsii_name="densityInput")
    def density_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityInput"))

    @builtins.property
    @jsii.member(jsii_name="densityVarInput")
    def density_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="powerInput")
    def power_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerInput"))

    @builtins.property
    @jsii.member(jsii_name="powerVarInput")
    def power_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerVarInput"))

    @builtins.property
    @jsii.member(jsii_name="seedInput")
    def seed_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedInput"))

    @builtins.property
    @jsii.member(jsii_name="seedVarInput")
    def seed_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedVarInput"))

    @builtins.property
    @jsii.member(jsii_name="chaos")
    def chaos(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaos"))

    @chaos.setter
    def chaos(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e32f62673051396d7c78cdea228ac12f2c34a8837eb006142cf8dda9ea594472)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaos", value)

    @builtins.property
    @jsii.member(jsii_name="chaosVar")
    def chaos_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaosVar"))

    @chaos_var.setter
    def chaos_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__177b241899cdf51644298cb53e0de7f6e74d56099a9607a493dc3e658cf5009e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaosVar", value)

    @builtins.property
    @jsii.member(jsii_name="density")
    def density(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "density"))

    @density.setter
    def density(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__83ca94330492f4a8de67e520a3009cb98002323418868e5fe396d82b1d104e62)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "density", value)

    @builtins.property
    @jsii.member(jsii_name="densityVar")
    def density_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "densityVar"))

    @density_var.setter
    def density_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__62dfb08835d555284767e6701b1cd498fc2cbe405ffa8e25778af7fd38e880ac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "densityVar", value)

    @builtins.property
    @jsii.member(jsii_name="power")
    def power(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "power"))

    @power.setter
    def power(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3361fd78275852df7c828f7ed730a41506effd69c08a5335ca30506c288cc976)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "power", value)

    @builtins.property
    @jsii.member(jsii_name="powerVar")
    def power_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "powerVar"))

    @power_var.setter
    def power_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ef56b6060b6e9324c497583931c4744760c796c29fae7f133334f5107646320)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "powerVar", value)

    @builtins.property
    @jsii.member(jsii_name="seed")
    def seed(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seed"))

    @seed.setter
    def seed(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__08a18261d5d6780a34070993636d28278104b461f9e95271ac55339f63b2e09a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seed", value)

    @builtins.property
    @jsii.member(jsii_name="seedVar")
    def seed_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seedVar"))

    @seed_var.setter
    def seed_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__72ed1fc7a1e85735f6f7894ff9ef9666bb32e5fb007302afd563339f74ac6abb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seedVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareGoop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareGoop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareGoop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__51aa9be4d13907fece28b592eed705ab133b0eb9d2142904f9e7722cf3d2ffa9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareGrayscale",
    jsii_struct_bases=[],
    name_mapping={"type": "type", "type_var": "typeVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareGrayscale:
    def __init__(
        self,
        *,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param type: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0691f6075ef366c2fd784fd360e726ab73de1ea703969ab8971eed07d5115484)
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareGrayscale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareGrayscaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareGrayscaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__693ead22ed34a10b39d8640d092b1e750d28f465207a4ab7a21948c2bdf9b7fc)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareGrayscaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a171a288cc352000d27f9512523641f73cb345b947e8ecd4178bc9ad6c8f21b0)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareGrayscaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5484956369c155b3a28d6c21393b208decdef42ec4a40855839af49364358a77)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__61f3838d971854fc381a25d460b9ad2146e840c7f0b624147714c928a0fcda91)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ef1fd95ace88f7050feafcd8cd85ecc940b3ce4ef2970fd25d75559a5e9bfdd5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareGrayscale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareGrayscale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__85b2b40312911e34d440429207a86d5012ffadff6d6558142570674f946b5cb3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareGrayscaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareGrayscaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__313f3e1ac65d07efb0bed62cd6d3c5e99341b8cf4ff07f023fa4fa682e3e493e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b898e2a267d5ac7715b4118c88cc259cf575414ded54bb9b4a24002f27d88b3b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd1786f117dc9a1fa94c65d128afbaa93471222c86954d307a9e5db45141126b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareGrayscale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareGrayscale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareGrayscale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__77e31ada2fd54e05dfa43575d8ea9b808e024fa3ac53129f6b5a9ae45f1fe6c8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareHsl",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "lightness": "lightness",
        "lightness_var": "lightnessVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareHsl:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness: typing.Optional[builtins.str] = None,
        lightness_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        :param lightness_var: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__88561735b0d8352dfe9805546432a5d3b1721c8c320f14070735d068a1f81ad1)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness", value=lightness, expected_type=type_hints["lightness"])
            check_type(argname="argument lightness_var", value=lightness_var, expected_type=type_hints["lightness_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness is not None:
            self._values["lightness"] = lightness
        if lightness_var is not None:
            self._values["lightness_var"] = lightness_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        '''
        result = self._values.get("lightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        '''
        result = self._values.get("lightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareHsl(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareHslList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareHslList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2bc42f29456a9f46d3cc905cb9c9035804561861ede8767df84581a945482cd1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareHslOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e627bbe6bbe63ecf824deaf95e66d0759074f68efcea8b9c8b2c32cb52b6e07f)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareHslOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd3ae9484937ea0419dafca404ec0403a3d0a0b16ef84c5c22d8fe78cdfdc414)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7f90adbe28a0facaac9b90ae8b47a4f8a82189ff410b7e2916a2060e59618954)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b2beca44d35c8899343639cf177cb8b080a9815d94f14d31e8aa5caa3e1996e2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareHsl]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareHsl]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7b2eb969488085b1d4aaef8fc6f616c9fc3113c4b1e1c19b9f0cfbc6aea94bc1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareHslOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareHslOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__038f4f9a4aa9ebae3fede2f6351e2c3bf8292de911b5851c47d1781adb9795bd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightness")
    def reset_lightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightness", []))

    @jsii.member(jsii_name="resetLightnessVar")
    def reset_lightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessInput")
    def lightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessVarInput")
    def lightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c372d2aad1c9bdbabd5718b8e1c60eadb3b722a8014b1262bbe3671a24c7d394)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fcf17462c363dad73826cf6105f2135af6afa1b242e8e014c235dbf99d1685a4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightness")
    def lightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightness"))

    @lightness.setter
    def lightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd02350b8b852487e04caffd67069a8867b856b34aba08d799d9eb63aa1c59e0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightness", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessVar")
    def lightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessVar"))

    @lightness_var.setter
    def lightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c893f4c9685058fdf8b788d1b06d0e3a6ee6f85aeb45e3bbd4e1b01279975b37)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b748799cac258c6bf3ed2890d2fb2eefab54e2e741d7bda4f53c195f57d032ad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b73fa47e336c040614de24f5c3c3975c919040903355e3cbcc04a5999f4ed8f8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareHsl]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareHsl]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareHsl]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a4cf1824d3cb30296f2b68559557a1f6ee3fb5c27079353d700f5d11a0f2a85e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareHsv",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareHsv:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        :param value: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be7ffc538606f114a952469278ac50c49d47eefa21970ad7ee04fa8ddb667d70)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareHsv(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareHsvList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareHsvList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f1c505e7d703e0ce90c7a2f11a3a21888e404882474a759197ee185f3deeb003)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareHsvOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8b92da3c7387c76eb65062eb837f02262eafe661296dea3f7f07bdbb10aa68a0)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareHsvOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a6ec63cdbe2c9d9508071087f459c76843b4b4f1bdd938882f84cba8b02875d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f37e05683f7ff93c35e7331122ebd623013ea8f6aa50c2daaf1371249f1db371)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__474a375186549b8835d750c4af69b32cb2772b0a5cbcd4623fc37a9751be94a0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareHsv]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareHsv]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b4fcc5555350631f52c63bef7c5bb339651ffa36ea4d2395777972ab057b7398)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareHsvOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareHsvOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2b50ef65a921c67d870906e1210c8ad91338442ffb375dcd0d7b4d820bbbe5c7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__21bdc16610ddaa6c93ba3cc0ccf51906a9ea46b9c847a4f8b402682f028d9fa1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__595da34993038c3b3919257612aaaa807fbaa594852e6bee4f41a0d3c8d2a52b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f3567280ce2dd7c5e7cf9dbb587bc7c7ff8cf4fc584be5693baf95dc3030d04)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8f0db29a18c77c7548e0da747ab6c802ff845f09c93b99e070182096679829e5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__38643110bcdf3c36b2c1713981c69db52fffc5b3aefbdbf8b55abb4a8c3ad669)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a21db23299a76cdaaaf2333e60a16071cb96ac59a208c1f56d8ed42382f9ad0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareHsv]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareHsv]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareHsv]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__870e8c266d1e419fc8bc6ba4a57c9471c69cae0d31a916e8b06494341c031c6b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimension",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "dimension": "dimension",
        "dimension_var": "dimensionVar",
        "equal": "equal",
        "greater_than": "greaterThan",
        "less_than": "lessThan",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimension:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        dimension: typing.Optional[builtins.str] = None,
        dimension_var: typing.Optional[builtins.str] = None,
        equal: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqual", typing.Dict[builtins.str, typing.Any]]] = None,
        greater_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThan", typing.Dict[builtins.str, typing.Any]]] = None,
        less_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThan", typing.Dict[builtins.str, typing.Any]]] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param dimension: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        :param dimension_var: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        :param equal: equal block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        :param greater_than: greater_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        :param less_than: less_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        :param value: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefault(**default)
        if isinstance(equal, dict):
            equal = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqual(**equal)
        if isinstance(greater_than, dict):
            greater_than = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThan(**greater_than)
        if isinstance(less_than, dict):
            less_than = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThan(**less_than)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dd216e69e8ea1556a8a46c0e29ee4e3df7e98256129783f8ade7a38071beebf0)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument dimension", value=dimension, expected_type=type_hints["dimension"])
            check_type(argname="argument dimension_var", value=dimension_var, expected_type=type_hints["dimension_var"])
            check_type(argname="argument equal", value=equal, expected_type=type_hints["equal"])
            check_type(argname="argument greater_than", value=greater_than, expected_type=type_hints["greater_than"])
            check_type(argname="argument less_than", value=less_than, expected_type=type_hints["less_than"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if dimension is not None:
            self._values["dimension"] = dimension
        if dimension_var is not None:
            self._values["dimension_var"] = dimension_var
        if equal is not None:
            self._values["equal"] = equal
        if greater_than is not None:
            self._values["greater_than"] = greater_than
        if less_than is not None:
            self._values["less_than"] = less_than
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefault"], result)

    @builtins.property
    def dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        '''
        result = self._values.get("dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        '''
        result = self._values.get("dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def equal(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqual"]:
        '''equal block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        '''
        result = self._values.get("equal")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqual"], result)

    @builtins.property
    def greater_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThan"]:
        '''greater_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        '''
        result = self._values.get("greater_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThan"], result)

    @builtins.property
    def less_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThan"]:
        '''less_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        '''
        result = self._values.get("less_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThan"], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimension(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefault",
    jsii_struct_bases=[],
    name_mapping={
        "background_color": "backgroundColor",
        "blur": "blur",
        "chroma_key": "chromaKey",
        "composite": "composite",
        "compound": "compound",
        "contrast": "contrast",
        "goop": "goop",
        "grayscale": "grayscale",
        "hsl": "hsl",
        "hsv": "hsv",
        "if_dimension": "ifDimension",
        "if_orientation": "ifOrientation",
        "max_colors": "maxColors",
        "mirror": "mirror",
        "mono_hue": "monoHue",
        "opacity": "opacity",
        "remove_color": "removeColor",
        "unsharp_mask": "unsharpMask",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefault:
    def __init__(
        self,
        *,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultBackgroundColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultBlur", typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultChromaKey", typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultComposite", typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultCompound", typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultContrast", typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultGoop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultGrayscale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultHsl", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultHsv", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfDimension", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfOrientation", typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultMaxColors", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultMirror", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultMonoHue", typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultOpacity", typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultRemoveColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultUnsharpMask", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__378ae9720b26a21cd264ff6cf97a7aada4f2ea3ddcccced4eeed78f9132d748e)
            check_type(argname="argument background_color", value=background_color, expected_type=type_hints["background_color"])
            check_type(argname="argument blur", value=blur, expected_type=type_hints["blur"])
            check_type(argname="argument chroma_key", value=chroma_key, expected_type=type_hints["chroma_key"])
            check_type(argname="argument composite", value=composite, expected_type=type_hints["composite"])
            check_type(argname="argument compound", value=compound, expected_type=type_hints["compound"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument goop", value=goop, expected_type=type_hints["goop"])
            check_type(argname="argument grayscale", value=grayscale, expected_type=type_hints["grayscale"])
            check_type(argname="argument hsl", value=hsl, expected_type=type_hints["hsl"])
            check_type(argname="argument hsv", value=hsv, expected_type=type_hints["hsv"])
            check_type(argname="argument if_dimension", value=if_dimension, expected_type=type_hints["if_dimension"])
            check_type(argname="argument if_orientation", value=if_orientation, expected_type=type_hints["if_orientation"])
            check_type(argname="argument max_colors", value=max_colors, expected_type=type_hints["max_colors"])
            check_type(argname="argument mirror", value=mirror, expected_type=type_hints["mirror"])
            check_type(argname="argument mono_hue", value=mono_hue, expected_type=type_hints["mono_hue"])
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument remove_color", value=remove_color, expected_type=type_hints["remove_color"])
            check_type(argname="argument unsharp_mask", value=unsharp_mask, expected_type=type_hints["unsharp_mask"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if background_color is not None:
            self._values["background_color"] = background_color
        if blur is not None:
            self._values["blur"] = blur
        if chroma_key is not None:
            self._values["chroma_key"] = chroma_key
        if composite is not None:
            self._values["composite"] = composite
        if compound is not None:
            self._values["compound"] = compound
        if contrast is not None:
            self._values["contrast"] = contrast
        if goop is not None:
            self._values["goop"] = goop
        if grayscale is not None:
            self._values["grayscale"] = grayscale
        if hsl is not None:
            self._values["hsl"] = hsl
        if hsv is not None:
            self._values["hsv"] = hsv
        if if_dimension is not None:
            self._values["if_dimension"] = if_dimension
        if if_orientation is not None:
            self._values["if_orientation"] = if_orientation
        if max_colors is not None:
            self._values["max_colors"] = max_colors
        if mirror is not None:
            self._values["mirror"] = mirror
        if mono_hue is not None:
            self._values["mono_hue"] = mono_hue
        if opacity is not None:
            self._values["opacity"] = opacity
        if remove_color is not None:
            self._values["remove_color"] = remove_color
        if unsharp_mask is not None:
            self._values["unsharp_mask"] = unsharp_mask

    @builtins.property
    def background_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultBackgroundColor"]]]:
        '''background_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        '''
        result = self._values.get("background_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultBackgroundColor"]]], result)

    @builtins.property
    def blur(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultBlur"]]]:
        '''blur block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        '''
        result = self._values.get("blur")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultBlur"]]], result)

    @builtins.property
    def chroma_key(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultChromaKey"]]]:
        '''chroma_key block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        '''
        result = self._values.get("chroma_key")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultChromaKey"]]], result)

    @builtins.property
    def composite(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultComposite"]]]:
        '''composite block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        '''
        result = self._values.get("composite")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultComposite"]]], result)

    @builtins.property
    def compound(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultCompound"]]]:
        '''compound block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        '''
        result = self._values.get("compound")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultCompound"]]], result)

    @builtins.property
    def contrast(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultContrast"]]]:
        '''contrast block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultContrast"]]], result)

    @builtins.property
    def goop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultGoop"]]]:
        '''goop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        '''
        result = self._values.get("goop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultGoop"]]], result)

    @builtins.property
    def grayscale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultGrayscale"]]]:
        '''grayscale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        '''
        result = self._values.get("grayscale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultGrayscale"]]], result)

    @builtins.property
    def hsl(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultHsl"]]]:
        '''hsl block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        '''
        result = self._values.get("hsl")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultHsl"]]], result)

    @builtins.property
    def hsv(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultHsv"]]]:
        '''hsv block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        '''
        result = self._values.get("hsv")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultHsv"]]], result)

    @builtins.property
    def if_dimension(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfDimension"]]]:
        '''if_dimension block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        '''
        result = self._values.get("if_dimension")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfDimension"]]], result)

    @builtins.property
    def if_orientation(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfOrientation"]]]:
        '''if_orientation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        '''
        result = self._values.get("if_orientation")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfOrientation"]]], result)

    @builtins.property
    def max_colors(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultMaxColors"]]]:
        '''max_colors block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        '''
        result = self._values.get("max_colors")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultMaxColors"]]], result)

    @builtins.property
    def mirror(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultMirror"]]]:
        '''mirror block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        '''
        result = self._values.get("mirror")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultMirror"]]], result)

    @builtins.property
    def mono_hue(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultMonoHue"]]]:
        '''mono_hue block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        '''
        result = self._values.get("mono_hue")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultMonoHue"]]], result)

    @builtins.property
    def opacity(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultOpacity"]]]:
        '''opacity block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultOpacity"]]], result)

    @builtins.property
    def remove_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultRemoveColor"]]]:
        '''remove_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        '''
        result = self._values.get("remove_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultRemoveColor"]]], result)

    @builtins.property
    def unsharp_mask(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultUnsharpMask"]]]:
        '''unsharp_mask block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        result = self._values.get("unsharp_mask")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultUnsharpMask"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultBackgroundColor",
    jsii_struct_bases=[],
    name_mapping={"color": "color", "color_var": "colorVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultBackgroundColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8c0c874c5586f85362216ad9092862399145f4b88367756e1a617df9f75d5ebd)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultBackgroundColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultBackgroundColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultBackgroundColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4578183470463584307c008c9b78fbcba48ae3039d1e7dbdf20ee3c8bfc6ef07)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultBackgroundColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dc9250c520aaeab29c2e9b7e2e405592e40ac0e3ca1d095c89063ef9df8b08bc)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultBackgroundColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4d712cc69cce539e3e5611e0df516182e28369ea3630951a82b5b770176487e1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fd5b00ee37c0d863a525831772d33e9d0071ca17a18fafc1c43581866db9f2cc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ce45f53a98d20b77a6d5dc2c8cd21a61a4f63940ecd23bdc8a547c00a54246e4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultBackgroundColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultBackgroundColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__29b1df3b4b4f75a1995c9f2b67350595302f6efeaca929a7686ae7ea3537fcc9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultBackgroundColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultBackgroundColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__caa7e7dc6aed84321a52dc4dd480ed810a3ece29e317816bd00ffbeff7372aba)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__035d889de5e43f085ea0796324bb0dcaab131e87129293cf55a87541642a55ce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e65430f6a05df680bcf4664a2659291db0f1a74a4fa1f31cc881428fc6505166)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultBackgroundColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultBackgroundColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultBackgroundColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__26a223b293a02e5400824ee7b35ee906390dfed18c1bc5320677ada5655af849)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultBlur",
    jsii_struct_bases=[],
    name_mapping={"sigma": "sigma", "sigma_var": "sigmaVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultBlur:
    def __init__(
        self,
        *,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param sigma: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__450ae21020db30bb866be805e39d06f5d374f4f244f36a5098ab57973a3c0caf)
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultBlur(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultBlurList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultBlurList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6fbe87f3475784ea75a31e5625a99db6829710b3fa90661baa9d6b81904fbd0b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultBlurOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e67593d1ce88f130c3d2b070b48ff05c6f8ce81b763df8f42ebaf8d315289622)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultBlurOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a51e209ed44d2923c56cb2f8907c3647fe1885d7b6f389da4e353c3281847e32)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__96d02651e1d9773d66013b0acc61300a9e3b349fa7e9a195aba31d9b5ab32590)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3726229b5c9bc009c15dfc7c17dbeb2715e4046c3f1895151a53cd4e5581c8bf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultBlur]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultBlur]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__69926ebfc6d42349339cd137cccb5078f4e48ad48d4a0382194104bca1fddd11)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultBlurOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultBlurOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5557758617ab22d25fef4565adc5f5f6b52108a1b734f3087bd06a4beb62018e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__877a3816b8f70517f0e9677429e3cf70a7451b92d0375373ae5966f7467349a9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5bc6c52090334c1c9269e806822cdd9d053ee420735248ec5e22cba1200be816)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultBlur]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultBlur]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultBlur]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a158d9a1d89fb02963ac3a4d32b8cdd2dd8797bd80115605940d297a2e0c8e86)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultChromaKey",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_feather": "hueFeather",
        "hue_feather_var": "hueFeatherVar",
        "hue_tolerance": "hueTolerance",
        "hue_tolerance_var": "hueToleranceVar",
        "hue_var": "hueVar",
        "lightness_feather": "lightnessFeather",
        "lightness_feather_var": "lightnessFeatherVar",
        "lightness_tolerance": "lightnessTolerance",
        "lightness_tolerance_var": "lightnessToleranceVar",
        "saturation_feather": "saturationFeather",
        "saturation_feather_var": "saturationFeatherVar",
        "saturation_tolerance": "saturationTolerance",
        "saturation_tolerance_var": "saturationToleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultChromaKey:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_feather: typing.Optional[builtins.str] = None,
        hue_feather_var: typing.Optional[builtins.str] = None,
        hue_tolerance: typing.Optional[builtins.str] = None,
        hue_tolerance_var: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness_feather: typing.Optional[builtins.str] = None,
        lightness_feather_var: typing.Optional[builtins.str] = None,
        lightness_tolerance: typing.Optional[builtins.str] = None,
        lightness_tolerance_var: typing.Optional[builtins.str] = None,
        saturation_feather: typing.Optional[builtins.str] = None,
        saturation_feather_var: typing.Optional[builtins.str] = None,
        saturation_tolerance: typing.Optional[builtins.str] = None,
        saturation_tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_feather: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        :param hue_feather_var: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        :param hue_tolerance: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        :param hue_tolerance_var: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        :param hue_var: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness_feather: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        :param lightness_feather_var: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        :param lightness_tolerance: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        :param lightness_tolerance_var: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        :param saturation_feather: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        :param saturation_feather_var: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        :param saturation_tolerance: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        :param saturation_tolerance_var: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__806d36be01ad8f3023f76d696bf69bbe6170e5c384d046f42f0a2a99cd787e81)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_feather", value=hue_feather, expected_type=type_hints["hue_feather"])
            check_type(argname="argument hue_feather_var", value=hue_feather_var, expected_type=type_hints["hue_feather_var"])
            check_type(argname="argument hue_tolerance", value=hue_tolerance, expected_type=type_hints["hue_tolerance"])
            check_type(argname="argument hue_tolerance_var", value=hue_tolerance_var, expected_type=type_hints["hue_tolerance_var"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness_feather", value=lightness_feather, expected_type=type_hints["lightness_feather"])
            check_type(argname="argument lightness_feather_var", value=lightness_feather_var, expected_type=type_hints["lightness_feather_var"])
            check_type(argname="argument lightness_tolerance", value=lightness_tolerance, expected_type=type_hints["lightness_tolerance"])
            check_type(argname="argument lightness_tolerance_var", value=lightness_tolerance_var, expected_type=type_hints["lightness_tolerance_var"])
            check_type(argname="argument saturation_feather", value=saturation_feather, expected_type=type_hints["saturation_feather"])
            check_type(argname="argument saturation_feather_var", value=saturation_feather_var, expected_type=type_hints["saturation_feather_var"])
            check_type(argname="argument saturation_tolerance", value=saturation_tolerance, expected_type=type_hints["saturation_tolerance"])
            check_type(argname="argument saturation_tolerance_var", value=saturation_tolerance_var, expected_type=type_hints["saturation_tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_feather is not None:
            self._values["hue_feather"] = hue_feather
        if hue_feather_var is not None:
            self._values["hue_feather_var"] = hue_feather_var
        if hue_tolerance is not None:
            self._values["hue_tolerance"] = hue_tolerance
        if hue_tolerance_var is not None:
            self._values["hue_tolerance_var"] = hue_tolerance_var
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness_feather is not None:
            self._values["lightness_feather"] = lightness_feather
        if lightness_feather_var is not None:
            self._values["lightness_feather_var"] = lightness_feather_var
        if lightness_tolerance is not None:
            self._values["lightness_tolerance"] = lightness_tolerance
        if lightness_tolerance_var is not None:
            self._values["lightness_tolerance_var"] = lightness_tolerance_var
        if saturation_feather is not None:
            self._values["saturation_feather"] = saturation_feather
        if saturation_feather_var is not None:
            self._values["saturation_feather_var"] = saturation_feather_var
        if saturation_tolerance is not None:
            self._values["saturation_tolerance"] = saturation_tolerance
        if saturation_tolerance_var is not None:
            self._values["saturation_tolerance_var"] = saturation_tolerance_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        '''
        result = self._values.get("hue_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        '''
        result = self._values.get("hue_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        '''
        result = self._values.get("hue_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        '''
        result = self._values.get("hue_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        '''
        result = self._values.get("lightness_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        '''
        result = self._values.get("lightness_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        '''
        result = self._values.get("lightness_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        '''
        result = self._values.get("lightness_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        '''
        result = self._values.get("saturation_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        '''
        result = self._values.get("saturation_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        '''
        result = self._values.get("saturation_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        result = self._values.get("saturation_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultChromaKey(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultChromaKeyList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultChromaKeyList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__93fa4754f597f31fc0a58435db30b1a7c77977bd7afd7a18d73d10c6f54a6029)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultChromaKeyOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e6c24849cfadc3f03842809c7887f7685ceef07f960c7353b04b8146fad22df7)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultChromaKeyOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0d71b110083d6578758e5d66842bd1d23693e73ea6ba6bd363c348aeeed679a2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e52b645bc077bf93ca43ffb924408f89f5db843b5ae4bec11dc33fcba466b578)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__72b084bcf4a21a448da1083d607acfb99ffcdf81bf89ed45d4891c64ae6bccfe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultChromaKey]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultChromaKey]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5cdd7ccab359967aeb66fa59244790ea3f850e90b14573f9de1fd0a93086808c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultChromaKeyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultChromaKeyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__769de7e545a2e96078210ee720731ba4d92944066f1ff0a73ad3b3d6940bcde4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueFeather")
    def reset_hue_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeather", []))

    @jsii.member(jsii_name="resetHueFeatherVar")
    def reset_hue_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeatherVar", []))

    @jsii.member(jsii_name="resetHueTolerance")
    def reset_hue_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueTolerance", []))

    @jsii.member(jsii_name="resetHueToleranceVar")
    def reset_hue_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueToleranceVar", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightnessFeather")
    def reset_lightness_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeather", []))

    @jsii.member(jsii_name="resetLightnessFeatherVar")
    def reset_lightness_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeatherVar", []))

    @jsii.member(jsii_name="resetLightnessTolerance")
    def reset_lightness_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessTolerance", []))

    @jsii.member(jsii_name="resetLightnessToleranceVar")
    def reset_lightness_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessToleranceVar", []))

    @jsii.member(jsii_name="resetSaturationFeather")
    def reset_saturation_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeather", []))

    @jsii.member(jsii_name="resetSaturationFeatherVar")
    def reset_saturation_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeatherVar", []))

    @jsii.member(jsii_name="resetSaturationTolerance")
    def reset_saturation_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationTolerance", []))

    @jsii.member(jsii_name="resetSaturationToleranceVar")
    def reset_saturation_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherInput")
    def hue_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVarInput")
    def hue_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceInput")
    def hue_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVarInput")
    def hue_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherInput")
    def lightness_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVarInput")
    def lightness_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceInput")
    def lightness_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVarInput")
    def lightness_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherInput")
    def saturation_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVarInput")
    def saturation_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceInput")
    def saturation_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVarInput")
    def saturation_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d4c3c00773d45faf8f3a0d34145a6e72cebd7eb1795f8fca3bced2f6c0067cf2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeather")
    def hue_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeather"))

    @hue_feather.setter
    def hue_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3224bdf88ad21a43039496c68017d3f6ea5ab06bebef36418a53d2242c9f85c8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeather", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVar")
    def hue_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeatherVar"))

    @hue_feather_var.setter
    def hue_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__82d09303e19927cf7617114dc0ed1422541af081899dd6912d0b31a99093a68a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueTolerance")
    def hue_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueTolerance"))

    @hue_tolerance.setter
    def hue_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__13bff16c2b74c848f61b4cc6b2bcc13341963d91de7f6693783ce4957d2a5805)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVar")
    def hue_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueToleranceVar"))

    @hue_tolerance_var.setter
    def hue_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eb0a1b3e9a08ef6c7e7f1b0911f998d9f38f24c719c4e76ec7dd5df011e4d252)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__593f9add2c1fcafc3f055ed1dd7708d0b7ed6ce81a30e7088835de886ae75459)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeather")
    def lightness_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeather"))

    @lightness_feather.setter
    def lightness_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2f16c247cf9c7a1201b9fbdcd8aa1ae766db7ee365448879873bd13d74823b58)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeather", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVar")
    def lightness_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeatherVar"))

    @lightness_feather_var.setter
    def lightness_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__00f432c54b917cb5e6c454d3f2693a0a361f6ba7007983e009444831da839a87)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessTolerance")
    def lightness_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessTolerance"))

    @lightness_tolerance.setter
    def lightness_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__88d15c666ea8a11ae59c00644c0608ff7ab70773ff522b2849f81675d51d74a0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVar")
    def lightness_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessToleranceVar"))

    @lightness_tolerance_var.setter
    def lightness_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd8511be5def94aff31856d70909a676b371763ca460d63fe1b490b85a05669e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeather")
    def saturation_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeather"))

    @saturation_feather.setter
    def saturation_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3221e4fbc6b671742291091e617f0e3d290763093b4d764c0d916ed1e1e2ae77)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeather", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVar")
    def saturation_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeatherVar"))

    @saturation_feather_var.setter
    def saturation_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__89c403ce42276b87b823a64b17b2cf00522a7e90c666075d01d2f47baa92635f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationTolerance")
    def saturation_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationTolerance"))

    @saturation_tolerance.setter
    def saturation_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1c5cecececf110b2014fa89d008adcd41619629d9d665a1254efaa4d3f9aaa48)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVar")
    def saturation_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationToleranceVar"))

    @saturation_tolerance_var.setter
    def saturation_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__357c9a5d4b56d170425bb7cc62c2baa4151e3620f4faf86335df78f7a879d9c5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultChromaKey]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultChromaKey]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultChromaKey]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8fd3c6cee6c20d2d9422bc62d4dd0a5f9638dd1cb7a43fefb0d198042af99e78)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultComposite",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "placement": "placement",
        "placement_var": "placementVar",
        "scale": "scale",
        "scale_dimension": "scaleDimension",
        "scale_dimension_var": "scaleDimensionVar",
        "scale_var": "scaleVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultComposite:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultCompositeImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        placement: typing.Optional[builtins.str] = None,
        placement_var: typing.Optional[builtins.str] = None,
        scale: typing.Optional[builtins.str] = None,
        scale_dimension: typing.Optional[builtins.str] = None,
        scale_dimension_var: typing.Optional[builtins.str] = None,
        scale_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param placement: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        :param placement_var: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        :param scale: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param scale_dimension: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        :param scale_dimension_var: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        :param scale_var: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        :param x_position: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultCompositeImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__331f03d0cfccd77a5389ed6950575b61eb5745f35286318d94ac3051be9d7544)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument placement", value=placement, expected_type=type_hints["placement"])
            check_type(argname="argument placement_var", value=placement_var, expected_type=type_hints["placement_var"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument scale_dimension", value=scale_dimension, expected_type=type_hints["scale_dimension"])
            check_type(argname="argument scale_dimension_var", value=scale_dimension_var, expected_type=type_hints["scale_dimension_var"])
            check_type(argname="argument scale_var", value=scale_var, expected_type=type_hints["scale_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if placement is not None:
            self._values["placement"] = placement
        if placement_var is not None:
            self._values["placement_var"] = placement_var
        if scale is not None:
            self._values["scale"] = scale
        if scale_dimension is not None:
            self._values["scale_dimension"] = scale_dimension
        if scale_dimension_var is not None:
            self._values["scale_dimension_var"] = scale_dimension_var
        if scale_var is not None:
            self._values["scale_var"] = scale_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultCompositeImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultCompositeImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        '''
        result = self._values.get("placement")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement_var(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        '''
        result = self._values.get("placement_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        '''
        result = self._values.get("scale_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        '''
        result = self._values.get("scale_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        '''
        result = self._values.get("scale_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultComposite(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultCompositeImage",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultCompositeImage:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultCompositeImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultCompositeImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultCompositeImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__08c54be6618e30eafa521a5669715a44d2a0ad4433a58ca0efbf8113398838b2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultCompositeImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultCompositeImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f8f24866f96066b02bd82696512797720b8978e7d2d7ba71120a7c006405f450)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultCompositeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultCompositeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4cff544e9af14b1abfa4df12e8012c1e4c4ad6bff1ae2ca40d975ebb0f1e1809)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultCompositeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d0c6cfc5d6154edb2ad9a3b100d1c3ad44b8f6776731de7f5f699ba5ccf20845)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultCompositeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__958c040e1db170547cac738500b172717b0efb83670068e8fc7336b2806a0a53)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__138009b851ed8b27919c093bfccd6d51f9396bb8dac0534cc052feb64fac2ec5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1840c3b46719185a294c3a849874a781c113f1efb834523c400325c235da965a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultComposite]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultComposite]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6a9a56d9b8e4bd54e856a153376b891c81ada478e16f3f0b058f4be938e7526a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultCompositeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultCompositeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a8cdfe6f8fc7d95b84946ee5963f5a3d970df0e671346f39446f723eb1d407cc)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultCompositeImage()

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPlacement")
    def reset_placement(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacement", []))

    @jsii.member(jsii_name="resetPlacementVar")
    def reset_placement_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacementVar", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetScaleDimension")
    def reset_scale_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimension", []))

    @jsii.member(jsii_name="resetScaleDimensionVar")
    def reset_scale_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimensionVar", []))

    @jsii.member(jsii_name="resetScaleVar")
    def reset_scale_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultCompositeImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultCompositeImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultCompositeImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="placementInput")
    def placement_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementInput"))

    @builtins.property
    @jsii.member(jsii_name="placementVarInput")
    def placement_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionInput")
    def scale_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVarInput")
    def scale_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleVarInput")
    def scale_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cb066365afce230ec516152b150bd73e0cac7dfa3c12b5a625eeb9eb0f5f1bce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ee13f75ad3829e772729569f4229995dbdb8e9466d8d8d5ac5c4ae4b91bf2468)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="placement")
    def placement(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placement"))

    @placement.setter
    def placement(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c4405b21d9379a0b37733f5a5e2e0466e23da470859c2e1f7dd73bbd553d8ba9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placement", value)

    @builtins.property
    @jsii.member(jsii_name="placementVar")
    def placement_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placementVar"))

    @placement_var.setter
    def placement_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__98949c7c3fdaadf589874c1629d20fdcb0d664c4b213903544c05b6f2a456dd3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placementVar", value)

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scale"))

    @scale.setter
    def scale(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dd4ac3e9bda89efac6531fc57fd1464bc5854ec9cf8a131e6cdede88147c59c8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scale", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimension")
    def scale_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimension"))

    @scale_dimension.setter
    def scale_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d9a2f4236341d0fb0240d615ffa0d296f8e87c48080668d35756ff8689bddcf0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimension", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVar")
    def scale_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimensionVar"))

    @scale_dimension_var.setter
    def scale_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__66c5b6f2e9ff569bc01b4cb45a2489c28af067d57f9e0f04de360842e86e9688)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="scaleVar")
    def scale_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleVar"))

    @scale_var.setter
    def scale_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3365829253ff875ce08a87506f6f348efe37c7168eee3c01ae1d1efbef3905be)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4c231b21e906d86b41eb03813846ace9e1485ed194f5b55c9da08291f7874f15)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__10cf955ff8e5cf751363cbcd2f4494471d7e38d825065a7f042cd5ac784d4dbe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5245a0b4366cf6e3455f94bbc817dc0656e6a5b74b45b25c7bd847787cd294bb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fb1589dd6322a5d2e9d38cdf32081685f7f2bc52b40e1d3dfe2da52b03bd3d4e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultComposite]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultComposite]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultComposite]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8d9d6032633534e39eaacbeed9babce785b558a4a4620c589f1fae2b1c262938)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultCompound",
    jsii_struct_bases=[],
    name_mapping={"transformations": "transformations"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultCompound:
    def __init__(
        self,
        *,
        transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param transformations: transformations block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bbe3459d98c15e3416f9e93e8b68e0ef4af3741177a4bc8d061e342319ac42d2)
            check_type(argname="argument transformations", value=transformations, expected_type=type_hints["transformations"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if transformations is not None:
            self._values["transformations"] = transformations

    @builtins.property
    def transformations(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultCompoundTransformations"]]]:
        '''transformations block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        result = self._values.get("transformations")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultCompoundTransformations"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultCompound(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultCompoundList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultCompoundList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cab375127b6dad94b122effb73093c92317da2fb638a733f26d32fb223a45108)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultCompoundOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7039891800924d21dbcefed831106b10a594705ffccaf1be3218ab93a492d8da)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultCompoundOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c5a4cc261412b6d0ca493fa9ca55fe1d76990e1e402a52c768611b9cb3dab32d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f67e88f929b5e11dab85ad7f61c488b62caf0580b4031262baa8f4863858ccee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__70de3cb22f32ab8e3925af6ccd22b39727cd39abab4b6c98cc0940ba21f899f5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultCompound]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultCompound]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c3d3453df1171888fe63f42c1220613969f4fbeda3baaef0b99e98e2d1c42f17)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultCompoundOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultCompoundOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9c04aca2c616030018aad6b9ebb07af3ea2f85ec241ef625d4098696918af5b3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformations")
    def put_transformations(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b8a5252dd9ae4ee42f4fb563c82db4ac594d70c6e0a5e4fc0bccfb062d3d11c7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTransformations", [value]))

    @jsii.member(jsii_name="resetTransformations")
    def reset_transformations(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformations", []))

    @builtins.property
    @jsii.member(jsii_name="transformations")
    def transformations(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultCompoundTransformationsList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultCompoundTransformationsList", jsii.get(self, "transformations"))

    @builtins.property
    @jsii.member(jsii_name="transformationsInput")
    def transformations_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultCompoundTransformations"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultCompoundTransformations"]]], jsii.get(self, "transformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultCompound]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultCompound]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultCompound]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cfe9503adff467e5dc42872fc7492db13bfc6202be88bac120a4b8abf2edf12a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultCompoundTransformations",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultCompoundTransformations:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultCompoundTransformations(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultCompoundTransformationsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultCompoundTransformationsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2f6b29f67219b541641817defda11c296e9a17c6472e7671c06191f014b9e973)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultCompoundTransformationsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8ddf9459eb3ce6df92c8b617bd6a8f8b03d97e7a45d01973def55c2f547b541c)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultCompoundTransformationsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac5cf07291cad2999c31e22675e23d76d9dbe6cbc11d3c69b96316cc2b347cc6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4f46b33a1723832caa148e080d8aa53b9e7193543cb2fe0d5d50848398be2502)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2543951c8017a3bebb0d132a54ebe7f0b2b65aca9e7faf4b91a9d67e0ddd7541)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultCompoundTransformations]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultCompoundTransformations]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultCompoundTransformations]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b4d173084e1de34fc0c795e64970ddeabc080df6b0a5b7f5759710c5dd9e37d9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultCompoundTransformationsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultCompoundTransformationsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__80a5f0fc11bf273413546477e94ac31aa634d6ce302884a30b89f228504060f4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultCompoundTransformations]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultCompoundTransformations]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultCompoundTransformations]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3f82db996f7709ebecc5640829cedc8afb4713693bef0c33a8b6b13bbd7993d4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultContrast",
    jsii_struct_bases=[],
    name_mapping={
        "brightness": "brightness",
        "brightness_var": "brightnessVar",
        "contrast": "contrast",
        "contrast_var": "contrastVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultContrast:
    def __init__(
        self,
        *,
        brightness: typing.Optional[builtins.str] = None,
        brightness_var: typing.Optional[builtins.str] = None,
        contrast: typing.Optional[builtins.str] = None,
        contrast_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param brightness: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        :param brightness_var: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        :param contrast: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param contrast_var: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ad2e52dda1213d37daaf233b1155c1c2901d9c6b78b8188f36161e7e0ee5ee00)
            check_type(argname="argument brightness", value=brightness, expected_type=type_hints["brightness"])
            check_type(argname="argument brightness_var", value=brightness_var, expected_type=type_hints["brightness_var"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument contrast_var", value=contrast_var, expected_type=type_hints["contrast_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if brightness is not None:
            self._values["brightness"] = brightness
        if brightness_var is not None:
            self._values["brightness_var"] = brightness_var
        if contrast is not None:
            self._values["contrast"] = contrast
        if contrast_var is not None:
            self._values["contrast_var"] = contrast_var

    @builtins.property
    def brightness(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        '''
        result = self._values.get("brightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def brightness_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        '''
        result = self._values.get("brightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        result = self._values.get("contrast_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultContrast(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultContrastList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultContrastList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b588cbd690f8273b03368da0c1da61b9b4f2fe5231f76d4342b817106ec443f1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultContrastOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d7314351da9894f00260af6a372656587c601a038631b21230bf99fe69736e7)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultContrastOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cb12478aa3858a7e74909799a098fe0cf3c55fa862998ec9202a16cbde5183e5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__468fbd5d972abf0c9974ce457a27f9e7855dc5abaf52797d7a241090030726c9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d6ca00407a17df1e36b6fbbbc5accbb0b45c81d35b691ea477a598443fe94486)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultContrast]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultContrast]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7b9b5058ebee4881c2efc898975c30a6dc860745f45998d11a54b924f43eaefb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultContrastOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultContrastOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a4c888d39eae478f32879923980d359991478ef99f32b26733be9b68082e064f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetBrightness")
    def reset_brightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightness", []))

    @jsii.member(jsii_name="resetBrightnessVar")
    def reset_brightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightnessVar", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetContrastVar")
    def reset_contrast_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrastVar", []))

    @builtins.property
    @jsii.member(jsii_name="brightnessInput")
    def brightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="brightnessVarInput")
    def brightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastVarInput")
    def contrast_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="brightness")
    def brightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightness"))

    @brightness.setter
    def brightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3273c88cb97c25dbbe1d98eaf8ed068800f8369417d680ecd4da000314186093)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightness", value)

    @builtins.property
    @jsii.member(jsii_name="brightnessVar")
    def brightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightnessVar"))

    @brightness_var.setter
    def brightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__117744d250c029fd408f10048543424f8ed9eef5e4952df232cb896c1c143a8b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrast"))

    @contrast.setter
    def contrast(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a835cfc8aa58cd845fa8d63a2aa728d14883cfd22b211ae2b13ea6d01fedb070)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrast", value)

    @builtins.property
    @jsii.member(jsii_name="contrastVar")
    def contrast_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrastVar"))

    @contrast_var.setter
    def contrast_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d4c2d8d37ea9f099eff59caa798047b7b7e5af3a88644866375948c8d03ad544)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrastVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultContrast]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultContrast]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultContrast]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__18ac913f15fe02c31c27c9813ed20f0f862d2f09bfaba394ea936be6a7b79817)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultGoop",
    jsii_struct_bases=[],
    name_mapping={
        "chaos": "chaos",
        "chaos_var": "chaosVar",
        "density": "density",
        "density_var": "densityVar",
        "power": "power",
        "power_var": "powerVar",
        "seed": "seed",
        "seed_var": "seedVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultGoop:
    def __init__(
        self,
        *,
        chaos: typing.Optional[builtins.str] = None,
        chaos_var: typing.Optional[builtins.str] = None,
        density: typing.Optional[builtins.str] = None,
        density_var: typing.Optional[builtins.str] = None,
        power: typing.Optional[builtins.str] = None,
        power_var: typing.Optional[builtins.str] = None,
        seed: typing.Optional[builtins.str] = None,
        seed_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param chaos: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        :param chaos_var: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        :param density: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        :param density_var: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        :param power: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        :param power_var: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        :param seed: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        :param seed_var: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b5ba8dc606620541424adb036476fb761757c8df02a275f704b8cb6dd86b058d)
            check_type(argname="argument chaos", value=chaos, expected_type=type_hints["chaos"])
            check_type(argname="argument chaos_var", value=chaos_var, expected_type=type_hints["chaos_var"])
            check_type(argname="argument density", value=density, expected_type=type_hints["density"])
            check_type(argname="argument density_var", value=density_var, expected_type=type_hints["density_var"])
            check_type(argname="argument power", value=power, expected_type=type_hints["power"])
            check_type(argname="argument power_var", value=power_var, expected_type=type_hints["power_var"])
            check_type(argname="argument seed", value=seed, expected_type=type_hints["seed"])
            check_type(argname="argument seed_var", value=seed_var, expected_type=type_hints["seed_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if chaos is not None:
            self._values["chaos"] = chaos
        if chaos_var is not None:
            self._values["chaos_var"] = chaos_var
        if density is not None:
            self._values["density"] = density
        if density_var is not None:
            self._values["density_var"] = density_var
        if power is not None:
            self._values["power"] = power
        if power_var is not None:
            self._values["power_var"] = power_var
        if seed is not None:
            self._values["seed"] = seed
        if seed_var is not None:
            self._values["seed_var"] = seed_var

    @builtins.property
    def chaos(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        '''
        result = self._values.get("chaos")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def chaos_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        '''
        result = self._values.get("chaos_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        '''
        result = self._values.get("density")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density_var(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        '''
        result = self._values.get("density_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        '''
        result = self._values.get("power")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power_var(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        '''
        result = self._values.get("power_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        '''
        result = self._values.get("seed")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed_var(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        result = self._values.get("seed_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultGoop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultGoopList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultGoopList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df9a8966afe37928531f4123bcecded0bb2ac67d32d740a75539ab853290e22f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultGoopOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d023ac07b3ea50ba073ca25983ab6e3be900e756f7c3985a06c8ebe5a8ad17c7)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultGoopOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__031b631ef3d1f58534d73152bef8ef40af9d911f0b71d8d2e93d9f53e3ca78b3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ffeba32c0ffcb561c388621c66af46dd70baf8bd301f138b55d3d2d3faf62702)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__28d1f6fda604ab966c53adb3cef0c5b459937fe44e5269ae17412ef91edcdb02)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultGoop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultGoop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__102b6a56b583849481de864af3d466e995e42b1ae0522984110edc92b3ce4f4e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultGoopOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultGoopOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e1038a53f60087afacdc06bb884a9ce73ae9408207be3300ffc7575dfbacfa5d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetChaos")
    def reset_chaos(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaos", []))

    @jsii.member(jsii_name="resetChaosVar")
    def reset_chaos_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaosVar", []))

    @jsii.member(jsii_name="resetDensity")
    def reset_density(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensity", []))

    @jsii.member(jsii_name="resetDensityVar")
    def reset_density_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensityVar", []))

    @jsii.member(jsii_name="resetPower")
    def reset_power(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPower", []))

    @jsii.member(jsii_name="resetPowerVar")
    def reset_power_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPowerVar", []))

    @jsii.member(jsii_name="resetSeed")
    def reset_seed(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeed", []))

    @jsii.member(jsii_name="resetSeedVar")
    def reset_seed_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeedVar", []))

    @builtins.property
    @jsii.member(jsii_name="chaosInput")
    def chaos_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosInput"))

    @builtins.property
    @jsii.member(jsii_name="chaosVarInput")
    def chaos_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosVarInput"))

    @builtins.property
    @jsii.member(jsii_name="densityInput")
    def density_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityInput"))

    @builtins.property
    @jsii.member(jsii_name="densityVarInput")
    def density_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="powerInput")
    def power_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerInput"))

    @builtins.property
    @jsii.member(jsii_name="powerVarInput")
    def power_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerVarInput"))

    @builtins.property
    @jsii.member(jsii_name="seedInput")
    def seed_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedInput"))

    @builtins.property
    @jsii.member(jsii_name="seedVarInput")
    def seed_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedVarInput"))

    @builtins.property
    @jsii.member(jsii_name="chaos")
    def chaos(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaos"))

    @chaos.setter
    def chaos(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d8dde9a94b2f02f7f54cbbf58579b739854bf002ab33b3e22ffa1002c02e5ad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaos", value)

    @builtins.property
    @jsii.member(jsii_name="chaosVar")
    def chaos_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaosVar"))

    @chaos_var.setter
    def chaos_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ee2732ad667ed1f7dacb11cded52f89d5533af099a3dccc243f4c72aefed5d8c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaosVar", value)

    @builtins.property
    @jsii.member(jsii_name="density")
    def density(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "density"))

    @density.setter
    def density(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__03c0116e440825740eba1ad27afe3055d2753592f5ca3ed77a6ecca3b78ec309)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "density", value)

    @builtins.property
    @jsii.member(jsii_name="densityVar")
    def density_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "densityVar"))

    @density_var.setter
    def density_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3809dd6640b03caca5cad9bfff4ea2d6ee181c96db126c880c426a6eaaccfe35)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "densityVar", value)

    @builtins.property
    @jsii.member(jsii_name="power")
    def power(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "power"))

    @power.setter
    def power(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__07195b557f70fd1c4a67e8418039805111b91aefa64feddf75235ac27895ab34)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "power", value)

    @builtins.property
    @jsii.member(jsii_name="powerVar")
    def power_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "powerVar"))

    @power_var.setter
    def power_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c98f250e180f47f429c569d8eac901e48e589013dbf16b12f71ca6ffb289db13)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "powerVar", value)

    @builtins.property
    @jsii.member(jsii_name="seed")
    def seed(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seed"))

    @seed.setter
    def seed(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8e3e8decf2aaafba44a28683c2463ede3710af1d03e2036db3a5036b85ecdf44)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seed", value)

    @builtins.property
    @jsii.member(jsii_name="seedVar")
    def seed_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seedVar"))

    @seed_var.setter
    def seed_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7946161565d24749d6662764916d2e88492de47a73fc87008f8fcafe6316ff20)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seedVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultGoop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultGoop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultGoop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__02a288aa55021a19ae6f9850e3f7b315f771698fe1bae032c469009a96585275)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultGrayscale",
    jsii_struct_bases=[],
    name_mapping={"type": "type", "type_var": "typeVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultGrayscale:
    def __init__(
        self,
        *,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param type: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__46dfc5c080d4b727c53e9e924d75ce3c05bcf93a6c673f28bde482d983117867)
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultGrayscale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultGrayscaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultGrayscaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__305212325f824faa5d4090c9a7798a7daf4ace27e94aa83f0b6adea6cdd6f92d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultGrayscaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b41d249ebdd475e935b55b4a1b37e20db22aba64d434606c957c7093de0f8d70)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultGrayscaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2bfe3c09406670ca2cce150b517336dc8461e222057d1cdb3a1023e46f9928cf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a4d803e7f2269a99efb6bdc16331bc27ece1943d38c2e30f34ec8d97cec82efe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__172b5c26d662b8aae5c27c0ea93352a49d7091fc59b41fde859b2110fdf025e6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultGrayscale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultGrayscale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5c9f93ff5717d39c86a5cd379023d444b6daf3189a351637081d3344ca26cd94)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultGrayscaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultGrayscaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f9cd6843bc4099fa42cf84fd7571f100ec5a34f777ddcf964252289956a12c16)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a52a485ee574e282da7814de7ab69000abb55c2e2662328b54559631b9abfc05)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__529762f778336ee7184e0a6f752b47da917ad001bdcabf4fed5baf27b8ff5545)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultGrayscale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultGrayscale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultGrayscale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__996684303f2b2a068ea062d193e731610e58b55a6d15ff268b39f7e9f752daf1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultHsl",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "lightness": "lightness",
        "lightness_var": "lightnessVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultHsl:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness: typing.Optional[builtins.str] = None,
        lightness_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        :param lightness_var: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__40e0264878007ed333d161cb78d00a993697d61817dfe945917882902475ec20)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness", value=lightness, expected_type=type_hints["lightness"])
            check_type(argname="argument lightness_var", value=lightness_var, expected_type=type_hints["lightness_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness is not None:
            self._values["lightness"] = lightness
        if lightness_var is not None:
            self._values["lightness_var"] = lightness_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        '''
        result = self._values.get("lightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        '''
        result = self._values.get("lightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultHsl(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultHslList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultHslList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ef573b26c79446a2877a777729019ce48401236ac419aaeabf36839b6db4b7aa)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultHslOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c57c6e036a4d4f2898f062fe6dea31ad097d2b1f9b38193079fcc796b4ddf61c)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultHslOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ef3ceb0c630749ba20e5ff4ce7d9b8c022647d1a6326f27e5411ac0677beb574)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a51c18e9e151f69e9b5d284e9c1c25aa776afcc03df10dccd4ae90d2c9b5f213)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4d456edf210c08ba3435d9512602feb3afb7690025a24fc4e06be94de84b2800)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultHsl]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultHsl]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e2ffba1a89be383223875e2f8b0889f1a5c6dd0822818ea9078b92da490b3d04)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultHslOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultHslOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d2210817f4f38c57bf0648114a1e320755655829779d087389f4fa3447fe3b98)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightness")
    def reset_lightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightness", []))

    @jsii.member(jsii_name="resetLightnessVar")
    def reset_lightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessInput")
    def lightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessVarInput")
    def lightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7b5e8afdbd31a64fa3d2d4c3296e17a0d0e87bfe89b0f4e9fbd48b978cec1a6f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__48be0e52a872ad14dc9f1622d2623143fdbf5e0b2bbaf40295a1556d4d361f7f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightness")
    def lightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightness"))

    @lightness.setter
    def lightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cf5448a6180784910daed3c9297d78d10f42fa1d9d8336ba9d049c785e15f6f8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightness", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessVar")
    def lightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessVar"))

    @lightness_var.setter
    def lightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1ad64041c557edd147a9ce4f2651c47633c343b71a521730021e3117761857b9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f75e56055b37968af3fcb2edddf1045f67d9c1d8b9f05274eac23ff114b5bb2a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3d4857ad6d991c05a8c8571a44c9481efff617a7b0bf4f52b26ad483eb4d376f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultHsl]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultHsl]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultHsl]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d743f9159d0a2a02fe89de059271fbeb778cdfc8cb6eedea6e11e5c2b48da29c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultHsv",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultHsv:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        :param value: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__760196e2171bec33e4ecb865c3bef6aeff40ebf06c34f7df66ada9be1e350848)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultHsv(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultHsvList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultHsvList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2cdc56708e5bcec10115c64e377b52e90fe48b8494ffa8e183800ad4bc5a9b73)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultHsvOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fd52402a15422685ba887503b24829caf76ce468627139df57f0a212fcd6a2f1)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultHsvOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__07f63bc68d03774dae601c3dc781529cbe2de0d4efe7eda4ec80fdea4a5cd025)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d98add280e964881e8b9b2a26696e1770198808d3432cf7695af5bb7b81c4c35)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6960e0a5a6857973db6ed1a2ef5c0d936826d1094d968d5c247dfbad6eb18b62)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultHsv]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultHsv]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b5c8c04c5fec7b5f1af42b91a571fa6995ea9c60c6ba992e56d7a5f7e83a98e5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultHsvOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultHsvOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__58bf48114a1e5bdc50dac446be4b4de1b8290a51c8b6bc8a3301e3621ef96886)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ffa3f908a7659077725a81dd464535cb3a4b958f2923985c13ebf604c150786f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4741d867d9a9d05e675bfceb7eb315c9a46c8d14e9a27f6b42e8af7d1d2515e4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fb86565a7d01255a906df6001f47f9cafdce8908c952b05392699ae0f1a057c6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df716c45f61868acdbd423f9617a97e84c39f24de723e29ed9f0e13e2f3a46d8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0d698f545365ade38841d32737a3b678bfb233687d922559c1481cd657a95d9b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__68dc6be063860a19e276f3d13be0679707af605c099d1c2bb7c4e80319aaf013)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultHsv]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultHsv]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultHsv]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7fbffe6bba4a45a75bba16446a8d8c1dc92be7f2bd569da971cd034497186517)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfDimension",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "dimension": "dimension",
        "dimension_var": "dimensionVar",
        "equal": "equal",
        "greater_than": "greaterThan",
        "less_than": "lessThan",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfDimension:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        dimension: typing.Optional[builtins.str] = None,
        dimension_var: typing.Optional[builtins.str] = None,
        equal: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionEqual", typing.Dict[builtins.str, typing.Any]]] = None,
        greater_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionGreaterThan", typing.Dict[builtins.str, typing.Any]]] = None,
        less_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionLessThan", typing.Dict[builtins.str, typing.Any]]] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param dimension: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        :param dimension_var: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        :param equal: equal block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        :param greater_than: greater_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        :param less_than: less_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        :param value: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionDefault(**default)
        if isinstance(equal, dict):
            equal = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionEqual(**equal)
        if isinstance(greater_than, dict):
            greater_than = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionGreaterThan(**greater_than)
        if isinstance(less_than, dict):
            less_than = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionLessThan(**less_than)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b091d9c6b5b272d07171e33acad77cd4ffca3b3fd446544b8da3c475e89eb470)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument dimension", value=dimension, expected_type=type_hints["dimension"])
            check_type(argname="argument dimension_var", value=dimension_var, expected_type=type_hints["dimension_var"])
            check_type(argname="argument equal", value=equal, expected_type=type_hints["equal"])
            check_type(argname="argument greater_than", value=greater_than, expected_type=type_hints["greater_than"])
            check_type(argname="argument less_than", value=less_than, expected_type=type_hints["less_than"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if dimension is not None:
            self._values["dimension"] = dimension
        if dimension_var is not None:
            self._values["dimension_var"] = dimension_var
        if equal is not None:
            self._values["equal"] = equal
        if greater_than is not None:
            self._values["greater_than"] = greater_than
        if less_than is not None:
            self._values["less_than"] = less_than
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionDefault"], result)

    @builtins.property
    def dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        '''
        result = self._values.get("dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        '''
        result = self._values.get("dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def equal(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionEqual"]:
        '''equal block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        '''
        result = self._values.get("equal")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionEqual"], result)

    @builtins.property
    def greater_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionGreaterThan"]:
        '''greater_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        '''
        result = self._values.get("greater_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionGreaterThan"], result)

    @builtins.property
    def less_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionLessThan"]:
        '''less_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        '''
        result = self._values.get("less_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionLessThan"], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfDimension(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__54a91cc572edda24e35f491eaaff98f1bd5220b1416dc35dc35894f05dd02d51)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4d813a7ed6499d7ede868a914c36a2586982596ceeebbe1a7b8539d9c85ab982)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionEqual",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionEqual:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionEqual(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionEqualOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionEqualOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9b0059c6c4a38173044037699124bd46bab106fd99b06a9878060583a8d3c92d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionEqual], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionEqual],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8eb572d458f76363c07f462db348c40c9b2111007d1e6b2b7cd1d0b2d4ac89aa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionGreaterThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionGreaterThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionGreaterThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionGreaterThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionGreaterThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__23a618edab7a462a9b156e080e1d805810ef0dd55b49972409b50ffc419c0199)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionGreaterThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionGreaterThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__22870b2f592214fcc53d64d6f7bc3320dbbc43acc96e5c41b8669063cd9881c6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionLessThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionLessThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionLessThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionLessThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionLessThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3d26bc3bb5f3b01cbb719ab5cd1336529918055b72a2a21884fd2758228995af)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionLessThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionLessThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b878bb7334916ad13b11fd6ae45c3d88eabcbc68adc6901e5b4df63d39eb7d20)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f59d1b1b6cb2950adc5fe7c469b35f0856564fdba7d94ea343c5d4d52b7467af)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__00106576ca05ff32b569c20a4412a4fa5f261f64181426d95902b3818ad26cd2)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__efbce9fb47b8119115abe68a9618f52caf6e592c98d0fb77f65d15d929f0058a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c1267db8d4013bbdc25f06815959d12ce9b3f2cc4e0a642bddd2773d4801a1a9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__544dab6c96c550d2f1e3bd7c830378aef62952edaf52c020e1f480609e4762d0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfDimension]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfDimension]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b3dfb5de8ce4cd458be672f0fb454d9f7a2b6c14ef0572d13f8ebc233a2597f7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__23ef456b74e8562d9a8dfab1c19cc1cb7d43aa3ad67b1d8e6007d3d5f8b3e330)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putEqual")
    def put_equal(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionEqual()

        return typing.cast(None, jsii.invoke(self, "putEqual", [value]))

    @jsii.member(jsii_name="putGreaterThan")
    def put_greater_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionGreaterThan()

        return typing.cast(None, jsii.invoke(self, "putGreaterThan", [value]))

    @jsii.member(jsii_name="putLessThan")
    def put_less_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionLessThan()

        return typing.cast(None, jsii.invoke(self, "putLessThan", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetDimension")
    def reset_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimension", []))

    @jsii.member(jsii_name="resetDimensionVar")
    def reset_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimensionVar", []))

    @jsii.member(jsii_name="resetEqual")
    def reset_equal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEqual", []))

    @jsii.member(jsii_name="resetGreaterThan")
    def reset_greater_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGreaterThan", []))

    @jsii.member(jsii_name="resetLessThan")
    def reset_less_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLessThan", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="equal")
    def equal(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionEqualOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionEqualOutputReference, jsii.get(self, "equal"))

    @builtins.property
    @jsii.member(jsii_name="greaterThan")
    def greater_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionGreaterThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionGreaterThanOutputReference, jsii.get(self, "greaterThan"))

    @builtins.property
    @jsii.member(jsii_name="lessThan")
    def less_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionLessThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionLessThanOutputReference, jsii.get(self, "lessThan"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionInput")
    def dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionVarInput")
    def dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="equalInput")
    def equal_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionEqual], jsii.get(self, "equalInput"))

    @builtins.property
    @jsii.member(jsii_name="greaterThanInput")
    def greater_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionGreaterThan], jsii.get(self, "greaterThanInput"))

    @builtins.property
    @jsii.member(jsii_name="lessThanInput")
    def less_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionLessThan], jsii.get(self, "lessThanInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="dimension")
    def dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimension"))

    @dimension.setter
    def dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a105b8e02a871d6d0c525eca77199597b48267f5c42866f381c95f938b52ee1e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimension", value)

    @builtins.property
    @jsii.member(jsii_name="dimensionVar")
    def dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimensionVar"))

    @dimension_var.setter
    def dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ff07060c3a0446b580d8994b6ea3209d3c09024b67c46d53028d65bb2d4373bb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d325e61e447fe218d6122620f2a91949c77a22907f1a93ad79c287632f93a23a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__086c24dfc3ae8e7558a2d50d9a336f43030a6017f5a64c8cc83a69ab634deb63)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfDimension]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfDimension]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfDimension]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9b4f789639451b67b8d00f34405c8b0eb1ca23472f1cc09992a84f7ef8de29a6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfOrientation",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "landscape": "landscape",
        "portrait": "portrait",
        "square": "square",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfOrientation:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        landscape: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationLandscape", typing.Dict[builtins.str, typing.Any]]] = None,
        portrait: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationPortrait", typing.Dict[builtins.str, typing.Any]]] = None,
        square: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationSquare", typing.Dict[builtins.str, typing.Any]]] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param landscape: landscape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        :param portrait: portrait block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        :param square: square block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationDefault(**default)
        if isinstance(landscape, dict):
            landscape = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationLandscape(**landscape)
        if isinstance(portrait, dict):
            portrait = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationPortrait(**portrait)
        if isinstance(square, dict):
            square = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationSquare(**square)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__237697e2318fa57b7643b51d9c7717da38e0661147d56559ecbb4c9f0c8db87f)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument landscape", value=landscape, expected_type=type_hints["landscape"])
            check_type(argname="argument portrait", value=portrait, expected_type=type_hints["portrait"])
            check_type(argname="argument square", value=square, expected_type=type_hints["square"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if landscape is not None:
            self._values["landscape"] = landscape
        if portrait is not None:
            self._values["portrait"] = portrait
        if square is not None:
            self._values["square"] = square

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationDefault"], result)

    @builtins.property
    def landscape(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationLandscape"]:
        '''landscape block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        '''
        result = self._values.get("landscape")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationLandscape"], result)

    @builtins.property
    def portrait(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationPortrait"]:
        '''portrait block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        '''
        result = self._values.get("portrait")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationPortrait"], result)

    @builtins.property
    def square(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationSquare"]:
        '''square block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        result = self._values.get("square")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationSquare"], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfOrientation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ef4f94e6687b5d04107b55121d6b33d764e79af093acd47d357b2fd5e2fd0c8a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b97ff7cbd3394a2e5be92a3f78c14ee0d057a5c74361a8bc14a2bfd95a5d807c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationLandscape",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationLandscape:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationLandscape(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationLandscapeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationLandscapeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d493d9e094fc361bf97277e21e9c3957bed3779762275245d7211a81a5b207a8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationLandscape], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationLandscape],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b3a4ed3548eed24d2c237a26e214515051d709082b4e02aaded474691ceebafc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b80801494d8dfc3afcbe9ecd0623a09fb920ede9a5468abb96c2774052b162e8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e73eafb5957595bd5166ea5c646842da20362e4500785c8d4051e73f17f54203)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f3f826bafe7e0f6316048b4f85c20c6e781e95f07f7fd0001e339b428f702950)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e7faa3d3529759237922119984e94540b28cb37793795c4f744e93a7598e5f94)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b69862d0d126a67e3ffcf0c91a25796d33f6ccab35388eeb98b4c26aa493ea49)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfOrientation]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfOrientation]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__30468cf8db039810fe12b1b4df43e5221446678fe51e9b4429bd6599da334584)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__397e83c36654858159e4c0d2d7cd28c4d25ef828918170c236519d592c44d893)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putLandscape")
    def put_landscape(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationLandscape()

        return typing.cast(None, jsii.invoke(self, "putLandscape", [value]))

    @jsii.member(jsii_name="putPortrait")
    def put_portrait(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationPortrait()

        return typing.cast(None, jsii.invoke(self, "putPortrait", [value]))

    @jsii.member(jsii_name="putSquare")
    def put_square(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationSquare()

        return typing.cast(None, jsii.invoke(self, "putSquare", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetLandscape")
    def reset_landscape(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLandscape", []))

    @jsii.member(jsii_name="resetPortrait")
    def reset_portrait(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPortrait", []))

    @jsii.member(jsii_name="resetSquare")
    def reset_square(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSquare", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="landscape")
    def landscape(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationLandscapeOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationLandscapeOutputReference, jsii.get(self, "landscape"))

    @builtins.property
    @jsii.member(jsii_name="portrait")
    def portrait(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationPortraitOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationPortraitOutputReference", jsii.get(self, "portrait"))

    @builtins.property
    @jsii.member(jsii_name="square")
    def square(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationSquareOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationSquareOutputReference", jsii.get(self, "square"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="landscapeInput")
    def landscape_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationLandscape], jsii.get(self, "landscapeInput"))

    @builtins.property
    @jsii.member(jsii_name="portraitInput")
    def portrait_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationPortrait"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationPortrait"], jsii.get(self, "portraitInput"))

    @builtins.property
    @jsii.member(jsii_name="squareInput")
    def square_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationSquare"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationSquare"], jsii.get(self, "squareInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfOrientation]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfOrientation]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfOrientation]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d6613ba2359692996231a365407c2155c50f33d33dd328713a9b8f5563632728)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationPortrait",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationPortrait:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationPortrait(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationPortraitOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationPortraitOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3929c20ea2e7aec76e4542175da1c33514ea906ef76ff9d5f8564ab2a10872cc)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationPortrait]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationPortrait], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationPortrait],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0be57ea9b3dda5f7d00466a6511191d985c67e0d60824ab0fb678da0ddeef58b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationSquare",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationSquare:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationSquare(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationSquareOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationSquareOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4cf0de67e44bee121d47e248f44af1a07040dbc421f8794194e9a359da0b9e1f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationSquare]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationSquare], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationSquare],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b952aa1ebacab85716a05449cd054b7a6469c269dd282a7c4e404a992652f666)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultMaxColors",
    jsii_struct_bases=[],
    name_mapping={"colors": "colors", "colors_var": "colorsVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultMaxColors:
    def __init__(
        self,
        *,
        colors: typing.Optional[builtins.str] = None,
        colors_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param colors: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        :param colors_var: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a2bba9b10df9660bdd6dd5fed0681e72d8c87a0fb6e22666174f5dcb91a6adbf)
            check_type(argname="argument colors", value=colors, expected_type=type_hints["colors"])
            check_type(argname="argument colors_var", value=colors_var, expected_type=type_hints["colors_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if colors is not None:
            self._values["colors"] = colors
        if colors_var is not None:
            self._values["colors_var"] = colors_var

    @builtins.property
    def colors(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        '''
        result = self._values.get("colors")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def colors_var(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        result = self._values.get("colors_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultMaxColors(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultMaxColorsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultMaxColorsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ed51aa85db36c830420daab62d329fc5da948224968064554528404ed2f477c6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultMaxColorsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8b213b2473abac0b6abe644b2406056c98a222939fc6fb13c2dc0bd832d753ad)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultMaxColorsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d30887086a231c776ebb0c1bf42931d6a60a0426f50959c810ea1a2e40b09725)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7c180303d40ebc2e40a64ff95e60c30df534e475235f304e3ccf0c9a7da24595)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a4763d2f61a9d03ee82da8236e4ab522609bd8a2c518dc5c4898e542a380b748)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultMaxColors]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultMaxColors]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ebcde74e4694103bfcbae924fa62ae24dfe83bfde25c7f0f394a3b2c9686b2ca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultMaxColorsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultMaxColorsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8b8cfce98427ed52e5f5044b6ba8de21d20abddae92802e89c9189db5b78265e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColors")
    def reset_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColors", []))

    @jsii.member(jsii_name="resetColorsVar")
    def reset_colors_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorsVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorsInput")
    def colors_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsInput"))

    @builtins.property
    @jsii.member(jsii_name="colorsVarInput")
    def colors_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsVarInput"))

    @builtins.property
    @jsii.member(jsii_name="colors")
    def colors(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colors"))

    @colors.setter
    def colors(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__42393e5133a4621b79efa1c132497c1594f42f0f192089f64e436e39b65967b8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colors", value)

    @builtins.property
    @jsii.member(jsii_name="colorsVar")
    def colors_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorsVar"))

    @colors_var.setter
    def colors_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__95b85d17be750edbebb4e18dac209f53221489bd091e2030b40b2ca2f67b53ef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorsVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultMaxColors]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultMaxColors]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultMaxColors]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9398dc3f65f9e165a7ab42e6c7f84c3196114afb82e10d5486df5c7b81c5b984)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultMirror",
    jsii_struct_bases=[],
    name_mapping={
        "horizontal": "horizontal",
        "horizontal_var": "horizontalVar",
        "vertical": "vertical",
        "vertical_var": "verticalVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultMirror:
    def __init__(
        self,
        *,
        horizontal: typing.Optional[builtins.str] = None,
        horizontal_var: typing.Optional[builtins.str] = None,
        vertical: typing.Optional[builtins.str] = None,
        vertical_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param horizontal: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        :param horizontal_var: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        :param vertical: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        :param vertical_var: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__390430ea7d5daf35fd28f2918e01794e9c641a512d943adbd37b5ff8613119b8)
            check_type(argname="argument horizontal", value=horizontal, expected_type=type_hints["horizontal"])
            check_type(argname="argument horizontal_var", value=horizontal_var, expected_type=type_hints["horizontal_var"])
            check_type(argname="argument vertical", value=vertical, expected_type=type_hints["vertical"])
            check_type(argname="argument vertical_var", value=vertical_var, expected_type=type_hints["vertical_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if horizontal is not None:
            self._values["horizontal"] = horizontal
        if horizontal_var is not None:
            self._values["horizontal_var"] = horizontal_var
        if vertical is not None:
            self._values["vertical"] = vertical
        if vertical_var is not None:
            self._values["vertical_var"] = vertical_var

    @builtins.property
    def horizontal(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        '''
        result = self._values.get("horizontal")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def horizontal_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        '''
        result = self._values.get("horizontal_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        '''
        result = self._values.get("vertical")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        result = self._values.get("vertical_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultMirror(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultMirrorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultMirrorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__39f76c49b6b8de4fa6c2df81b0d847dffa071e3100b24be04d82d48c00e97b31)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultMirrorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__79d34de655dd63999a778500071a4bdb2e8c43e1661c6b9bb49dc2b11e631d77)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultMirrorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc05d51fd80beb16c176dd0ec53ca7555e8658fc8f071b98ae2f8c726388740b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0492df0f01a7ca821a7d72cd887f3f1916de2f94cea49982cd8de68793b62a65)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__58d587bbb589bae78ebdb64696adaef29640609fd8612949c8f5b56b08ddbdf5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultMirror]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultMirror]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__08bd2243b6296c02e727532ed42caf05530129187a5c75bdaeb56b0bead855b7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultMirrorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultMirrorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__024bf865e11b7a5e2d3e332e0f591538f02e1e51df80ee49fcbf4fd23e09cb57)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHorizontal")
    def reset_horizontal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontal", []))

    @jsii.member(jsii_name="resetHorizontalVar")
    def reset_horizontal_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontalVar", []))

    @jsii.member(jsii_name="resetVertical")
    def reset_vertical(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVertical", []))

    @jsii.member(jsii_name="resetVerticalVar")
    def reset_vertical_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVerticalVar", []))

    @builtins.property
    @jsii.member(jsii_name="horizontalInput")
    def horizontal_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontalVarInput")
    def horizontal_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalInput")
    def vertical_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalVarInput")
    def vertical_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontal")
    def horizontal(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontal"))

    @horizontal.setter
    def horizontal(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__445cb5d54e5a535d968e590da9c8b43b44aebc1ac54c8d937d8d8fba42312853)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontal", value)

    @builtins.property
    @jsii.member(jsii_name="horizontalVar")
    def horizontal_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontalVar"))

    @horizontal_var.setter
    def horizontal_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__deb3d38d24dd78baeea6121c088fcaab9af9981ad2a4fb02aa4ab79f77083872)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontalVar", value)

    @builtins.property
    @jsii.member(jsii_name="vertical")
    def vertical(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "vertical"))

    @vertical.setter
    def vertical(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__67aad7226296ce5c54effbeaa42391bd9df86021542c5cca3265c133313c1ead)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "vertical", value)

    @builtins.property
    @jsii.member(jsii_name="verticalVar")
    def vertical_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "verticalVar"))

    @vertical_var.setter
    def vertical_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1bc0359fd8c3f9561d134094e915cabc5dc8093ea10b42cab9c41909f6faf953)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "verticalVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultMirror]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultMirror]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultMirror]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__25354ce00192d3e3cee3ee2644a22ce4a626b43f2a3efde9f3cc6936f56be3f3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultMonoHue",
    jsii_struct_bases=[],
    name_mapping={"hue": "hue", "hue_var": "hueVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultMonoHue:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__224a8e058b902ab61cf279b0d56f3bec791457c0664fde69b656b40b7c7b09c1)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultMonoHue(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultMonoHueList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultMonoHueList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1faeb95996dcef09f5988bf342cce9cbb909a7da34209ba7634d4f520e999f29)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultMonoHueOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0980028272c4b6c3a0d7cb53e70c1a43ae9a5fcb25f0138962b2c2e269c0d01b)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultMonoHueOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__82ff8e4ea6820177930bf72d537d438cd077fc0f1196337e06abdfc6aaf32be1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bd955b69d9cac34b77a184dc1a8f600e34561701f2d156c991350fae54e021fd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__45aae5a4a9c1f9790dc6184352c4b58d466b4a2482b6271c7c9a86b10ee16ed2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultMonoHue]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultMonoHue]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d8fcf31d9025ed142fd2218347b42d9516d9b6fb009f297c5d2914f8f23335f8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultMonoHueOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultMonoHueOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb83dc3a47510ad07dbb881f3005981c6ff6b7dc0bdde7109eb2efd694f14bf9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__07c6d5fa0b869672b22d5a8e0c91c6599a6c08f1d7b05a98ab23735c3df5316f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__75ec1024a6273659372fa18779f28b5b6bd5ac6def7059774bd3d170b77aaa14)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultMonoHue]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultMonoHue]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultMonoHue]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a71cc00418d6297d69eaeece40bca85a3ddd2ef1bb1fcdc3f6e180190a89360)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultOpacity",
    jsii_struct_bases=[],
    name_mapping={"opacity": "opacity", "opacity_var": "opacityVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultOpacity:
    def __init__(
        self,
        *,
        opacity: typing.Optional[builtins.str] = None,
        opacity_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param opacity: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param opacity_var: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c852fb59c2d4d9a7b1f2ee9ba6ecb02444d0016858e87323a19bb6c09080cced)
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument opacity_var", value=opacity_var, expected_type=type_hints["opacity_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if opacity is not None:
            self._values["opacity"] = opacity
        if opacity_var is not None:
            self._values["opacity_var"] = opacity_var

    @builtins.property
    def opacity(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def opacity_var(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        result = self._values.get("opacity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultOpacity(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultOpacityList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultOpacityList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7312492d1640422ebfc99601d4005110ea3801e22f9f4b085eab8b17aa6223d8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultOpacityOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5b497ab39d91c8a8a1b2a525f7bf4eb2f66e39a9be5feed1f770cf7e12e3098b)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultOpacityOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f3caa48bc7b485f61744a52e50360c529f2a9bc731b4175c45566b8c63789f42)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__563048d3d51a16a176c17d63a7545d91e10f819f77e11b6975334f9f93e26c0e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__90a09254bcb00a53a665d4d6dd97cd6595017b4238d6a74445da178c03f7440d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultOpacity]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultOpacity]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__37b04f173a238ac059b6d44d3a8e21e284bb5ca44360632464fa26b42b6b4cb9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultOpacityOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultOpacityOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__304b4eded9ef3c49601c9428a9762700209dbfc33edd38af45101a7dc02c5f3b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetOpacityVar")
    def reset_opacity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacityVar", []))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityVarInput")
    def opacity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacity"))

    @opacity.setter
    def opacity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__64eabc8db74365b5dd9da41b97a00f671b59b58eecd1bcee0b4140ea6778f6dd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacity", value)

    @builtins.property
    @jsii.member(jsii_name="opacityVar")
    def opacity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacityVar"))

    @opacity_var.setter
    def opacity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f1ff4132a0b09287426316d8711f7423e27b356157ca4ca9328d1cc31a2dd4da)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacityVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultOpacity]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultOpacity]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultOpacity]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2451b6e06cb93567d0e0a7641b9b3ecaba3cd496b4f291c1f8ad6588dac7f47c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5dad12cfda8d905c5e303bff7f6493382acfe4404b10f38bdc6bbbe454ee741b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putBackgroundColor")
    def put_background_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__71935e84712ff1d0c5d17db73436c6c52963dbb246ee357a3538bf8072c11385)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBackgroundColor", [value]))

    @jsii.member(jsii_name="putBlur")
    def put_blur(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultBlur, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__530302549aaaffe1d8e13bbb1297774d1d1925c71def4aa51b8ad1e7e199c223)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBlur", [value]))

    @jsii.member(jsii_name="putChromaKey")
    def put_chroma_key(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultChromaKey, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1e39c277c511ff673cfbfc108896e3af93c30323ccd1b5fb4386aa230eefc1a4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putChromaKey", [value]))

    @jsii.member(jsii_name="putComposite")
    def put_composite(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultComposite, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9fe7c09dd26ccf0696e3b37d686d2f2f35d6d5feade5f1fd7659c0a78651a9e6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putComposite", [value]))

    @jsii.member(jsii_name="putCompound")
    def put_compound(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultCompound, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d0d64f2a62986b515ed0c3c7dc92b6d59be41cf545229ad308b33575c01b760)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCompound", [value]))

    @jsii.member(jsii_name="putContrast")
    def put_contrast(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultContrast, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__76458f862d908b263fa2580a0020aefd8c98bd954903737afaca07d99adc2b9f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putContrast", [value]))

    @jsii.member(jsii_name="putGoop")
    def put_goop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultGoop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__adc9a832781b0385a4b0e5cb7303e03f59f75e8a3d8235d46ed452b33ee622d8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGoop", [value]))

    @jsii.member(jsii_name="putGrayscale")
    def put_grayscale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultGrayscale, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__384967d58623bd59e36e925d4536305705776f41941a3e91e7ef40dc14d4b53d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGrayscale", [value]))

    @jsii.member(jsii_name="putHsl")
    def put_hsl(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultHsl, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc705c5b29c54d919f74a0d8cbd50cdb88fce181216fc456dad265b4f48c3214)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsl", [value]))

    @jsii.member(jsii_name="putHsv")
    def put_hsv(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultHsv, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0f3ea7bd1ae6f52466ca22ed26fb32d87079203642acebda4450a1ec471f81ac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsv", [value]))

    @jsii.member(jsii_name="putIfDimension")
    def put_if_dimension(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfDimension, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d449ab71eeae470fe9ed645e5f7d1b5f31e67ce24060c2ea2013c47be4d04a89)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfDimension", [value]))

    @jsii.member(jsii_name="putIfOrientation")
    def put_if_orientation(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ebe6d1c405a9f0e2dacd88221124947b004b3c8ca1fb2eafca7aa5f4fa877af3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfOrientation", [value]))

    @jsii.member(jsii_name="putMaxColors")
    def put_max_colors(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultMaxColors, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a0b9e8d46707d0cacb9a1613a4443be6c5247ce24279870806b7f6f6e3370502)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMaxColors", [value]))

    @jsii.member(jsii_name="putMirror")
    def put_mirror(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultMirror, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3c5a9df2c3ee8ac0fa1d394b7adb51363025a1970be870f3a7b32c8b1f6fdc13)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMirror", [value]))

    @jsii.member(jsii_name="putMonoHue")
    def put_mono_hue(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultMonoHue, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b689ad11ec59d4b2d741853cd4d87c040a2b595c32ee35d588d6f5f3b7710515)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMonoHue", [value]))

    @jsii.member(jsii_name="putOpacity")
    def put_opacity(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultOpacity, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f0ca9fcc207cb85419b2b6aae7817c863e64d3ca4cb95ef405e09e373f9b39f3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putOpacity", [value]))

    @jsii.member(jsii_name="putRemoveColor")
    def put_remove_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultRemoveColor", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2dc2c8e3ab280f5e85abde6fe1ab040668daf89122ae1e5d82d0b822ae2137c6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRemoveColor", [value]))

    @jsii.member(jsii_name="putUnsharpMask")
    def put_unsharp_mask(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultUnsharpMask", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__44e2ad6aafaf8b37f807aabbe8beb70866f8ec55dded2bcc734b2afb5196716e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putUnsharpMask", [value]))

    @jsii.member(jsii_name="resetBackgroundColor")
    def reset_background_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBackgroundColor", []))

    @jsii.member(jsii_name="resetBlur")
    def reset_blur(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBlur", []))

    @jsii.member(jsii_name="resetChromaKey")
    def reset_chroma_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChromaKey", []))

    @jsii.member(jsii_name="resetComposite")
    def reset_composite(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetComposite", []))

    @jsii.member(jsii_name="resetCompound")
    def reset_compound(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCompound", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetGoop")
    def reset_goop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGoop", []))

    @jsii.member(jsii_name="resetGrayscale")
    def reset_grayscale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGrayscale", []))

    @jsii.member(jsii_name="resetHsl")
    def reset_hsl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsl", []))

    @jsii.member(jsii_name="resetHsv")
    def reset_hsv(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsv", []))

    @jsii.member(jsii_name="resetIfDimension")
    def reset_if_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfDimension", []))

    @jsii.member(jsii_name="resetIfOrientation")
    def reset_if_orientation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfOrientation", []))

    @jsii.member(jsii_name="resetMaxColors")
    def reset_max_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxColors", []))

    @jsii.member(jsii_name="resetMirror")
    def reset_mirror(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMirror", []))

    @jsii.member(jsii_name="resetMonoHue")
    def reset_mono_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonoHue", []))

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetRemoveColor")
    def reset_remove_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRemoveColor", []))

    @jsii.member(jsii_name="resetUnsharpMask")
    def reset_unsharp_mask(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUnsharpMask", []))

    @builtins.property
    @jsii.member(jsii_name="backgroundColor")
    def background_color(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultBackgroundColorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultBackgroundColorList, jsii.get(self, "backgroundColor"))

    @builtins.property
    @jsii.member(jsii_name="blur")
    def blur(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultBlurList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultBlurList, jsii.get(self, "blur"))

    @builtins.property
    @jsii.member(jsii_name="chromaKey")
    def chroma_key(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultChromaKeyList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultChromaKeyList, jsii.get(self, "chromaKey"))

    @builtins.property
    @jsii.member(jsii_name="composite")
    def composite(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultCompositeList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultCompositeList, jsii.get(self, "composite"))

    @builtins.property
    @jsii.member(jsii_name="compound")
    def compound(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultCompoundList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultCompoundList, jsii.get(self, "compound"))

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultContrastList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultContrastList, jsii.get(self, "contrast"))

    @builtins.property
    @jsii.member(jsii_name="goop")
    def goop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultGoopList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultGoopList, jsii.get(self, "goop"))

    @builtins.property
    @jsii.member(jsii_name="grayscale")
    def grayscale(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultGrayscaleList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultGrayscaleList, jsii.get(self, "grayscale"))

    @builtins.property
    @jsii.member(jsii_name="hsl")
    def hsl(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultHslList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultHslList, jsii.get(self, "hsl"))

    @builtins.property
    @jsii.member(jsii_name="hsv")
    def hsv(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultHsvList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultHsvList, jsii.get(self, "hsv"))

    @builtins.property
    @jsii.member(jsii_name="ifDimension")
    def if_dimension(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionList, jsii.get(self, "ifDimension"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientation")
    def if_orientation(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationList, jsii.get(self, "ifOrientation"))

    @builtins.property
    @jsii.member(jsii_name="maxColors")
    def max_colors(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultMaxColorsList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultMaxColorsList, jsii.get(self, "maxColors"))

    @builtins.property
    @jsii.member(jsii_name="mirror")
    def mirror(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultMirrorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultMirrorList, jsii.get(self, "mirror"))

    @builtins.property
    @jsii.member(jsii_name="monoHue")
    def mono_hue(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultMonoHueList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultMonoHueList, jsii.get(self, "monoHue"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultOpacityList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultOpacityList, jsii.get(self, "opacity"))

    @builtins.property
    @jsii.member(jsii_name="removeColor")
    def remove_color(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultRemoveColorList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultRemoveColorList", jsii.get(self, "removeColor"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMask")
    def unsharp_mask(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultUnsharpMaskList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultUnsharpMaskList", jsii.get(self, "unsharpMask"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColorInput")
    def background_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultBackgroundColor]]], jsii.get(self, "backgroundColorInput"))

    @builtins.property
    @jsii.member(jsii_name="blurInput")
    def blur_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultBlur]]], jsii.get(self, "blurInput"))

    @builtins.property
    @jsii.member(jsii_name="chromaKeyInput")
    def chroma_key_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultChromaKey]]], jsii.get(self, "chromaKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="compositeInput")
    def composite_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultComposite]]], jsii.get(self, "compositeInput"))

    @builtins.property
    @jsii.member(jsii_name="compoundInput")
    def compound_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultCompound]]], jsii.get(self, "compoundInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultContrast]]], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="goopInput")
    def goop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultGoop]]], jsii.get(self, "goopInput"))

    @builtins.property
    @jsii.member(jsii_name="grayscaleInput")
    def grayscale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultGrayscale]]], jsii.get(self, "grayscaleInput"))

    @builtins.property
    @jsii.member(jsii_name="hslInput")
    def hsl_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultHsl]]], jsii.get(self, "hslInput"))

    @builtins.property
    @jsii.member(jsii_name="hsvInput")
    def hsv_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultHsv]]], jsii.get(self, "hsvInput"))

    @builtins.property
    @jsii.member(jsii_name="ifDimensionInput")
    def if_dimension_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfDimension]]], jsii.get(self, "ifDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientationInput")
    def if_orientation_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfOrientation]]], jsii.get(self, "ifOrientationInput"))

    @builtins.property
    @jsii.member(jsii_name="maxColorsInput")
    def max_colors_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultMaxColors]]], jsii.get(self, "maxColorsInput"))

    @builtins.property
    @jsii.member(jsii_name="mirrorInput")
    def mirror_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultMirror]]], jsii.get(self, "mirrorInput"))

    @builtins.property
    @jsii.member(jsii_name="monoHueInput")
    def mono_hue_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultMonoHue]]], jsii.get(self, "monoHueInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultOpacity]]], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="removeColorInput")
    def remove_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultRemoveColor"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultRemoveColor"]]], jsii.get(self, "removeColorInput"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMaskInput")
    def unsharp_mask_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultUnsharpMask"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultUnsharpMask"]]], jsii.get(self, "unsharpMaskInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3dd60dce6c3b2ffc2302e87b415c767d6550732eb7f1f3008b93a68308990124)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultRemoveColor",
    jsii_struct_bases=[],
    name_mapping={
        "color": "color",
        "color_var": "colorVar",
        "feather": "feather",
        "feather_var": "featherVar",
        "tolerance": "tolerance",
        "tolerance_var": "toleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultRemoveColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
        feather: typing.Optional[builtins.str] = None,
        feather_var: typing.Optional[builtins.str] = None,
        tolerance: typing.Optional[builtins.str] = None,
        tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        :param feather: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        :param feather_var: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        :param tolerance: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        :param tolerance_var: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__60965c311b364fb9ff6c7ec1f2055c1223280773a283b53fa1ec145077316b4c)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
            check_type(argname="argument feather", value=feather, expected_type=type_hints["feather"])
            check_type(argname="argument feather_var", value=feather_var, expected_type=type_hints["feather_var"])
            check_type(argname="argument tolerance", value=tolerance, expected_type=type_hints["tolerance"])
            check_type(argname="argument tolerance_var", value=tolerance_var, expected_type=type_hints["tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var
        if feather is not None:
            self._values["feather"] = feather
        if feather_var is not None:
            self._values["feather_var"] = feather_var
        if tolerance is not None:
            self._values["tolerance"] = tolerance
        if tolerance_var is not None:
            self._values["tolerance_var"] = tolerance_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        '''
        result = self._values.get("feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather_var(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        '''
        result = self._values.get("feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        '''
        result = self._values.get("tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance_var(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        result = self._values.get("tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultRemoveColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultRemoveColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultRemoveColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__52cf7898175b97b5c4338a179028b5ca7915d549837fb328e751445f5d403e5e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultRemoveColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4aa07d2865ae6e0e6ee7b9eacf91ed309684b6ca9ddfa5c4f330b4e170285f58)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultRemoveColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4f427e54892b4aa142a761057d2bc3e8570cb8bb87769978df74c460d646ef68)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c88cbb927e62012d3beb4b1fd021435a52e7007f3c4193d4b7a6ae09cc30c62f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__792cb28bc2a7c6a2789022ca8ccc8d228a711a0c8e720e701db77b1383322c74)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultRemoveColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultRemoveColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultRemoveColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__18d01f684557275da5f997ba0e6c58131c139f321d6cb0300ff7a44a5d421041)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultRemoveColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultRemoveColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__28eeede4b37219638ab8f1eaee3a8c95a2a00b1aa05bfc625874bcd13414d7a5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @jsii.member(jsii_name="resetFeather")
    def reset_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeather", []))

    @jsii.member(jsii_name="resetFeatherVar")
    def reset_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatherVar", []))

    @jsii.member(jsii_name="resetTolerance")
    def reset_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTolerance", []))

    @jsii.member(jsii_name="resetToleranceVar")
    def reset_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featherInput")
    def feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherInput"))

    @builtins.property
    @jsii.member(jsii_name="featherVarInput")
    def feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceInput")
    def tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceVarInput")
    def tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__830c06c8ebb8fa9f55bb9d396c14ca89b211edbe659266d8a6a5615df78e7c48)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4c26cb4534c470c192fb17a6d1b4c5c756c2c5e664129d871b8c784f0364e2cc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="feather")
    def feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "feather"))

    @feather.setter
    def feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__31afc8bd461ac2edba9b0218efa2599601f1368534b82a0c2bacf86d7cc6d8e8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "feather", value)

    @builtins.property
    @jsii.member(jsii_name="featherVar")
    def feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featherVar"))

    @feather_var.setter
    def feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d253af619f0aa025482ebd259e2b069854daf196da5331d7df316289b2280ecf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featherVar", value)

    @builtins.property
    @jsii.member(jsii_name="tolerance")
    def tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tolerance"))

    @tolerance.setter
    def tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ff6e5463304b9c02fede73331f4f4765de7c2ac8a0a77e62455996a0c1da55f5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tolerance", value)

    @builtins.property
    @jsii.member(jsii_name="toleranceVar")
    def tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "toleranceVar"))

    @tolerance_var.setter
    def tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e26d3483261f9df724a1b536de8a5cad89c4aa4f392991a91005382816b6f92c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "toleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultRemoveColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultRemoveColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultRemoveColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__da56d02727fc9946e5edf4378ea53872499afb6b4f5f7c919f85c45a1ab048d1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultUnsharpMask",
    jsii_struct_bases=[],
    name_mapping={
        "gain": "gain",
        "gain_var": "gainVar",
        "sigma": "sigma",
        "sigma_var": "sigmaVar",
        "threshold": "threshold",
        "threshold_var": "thresholdVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultUnsharpMask:
    def __init__(
        self,
        *,
        gain: typing.Optional[builtins.str] = None,
        gain_var: typing.Optional[builtins.str] = None,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
        threshold: typing.Optional[builtins.str] = None,
        threshold_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param gain: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        :param gain_var: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        :param sigma: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        :param threshold: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        :param threshold_var: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__632e277301b4ebc6c75e88b52f88db04bdc20d8108fdfafb99fea5bae28f7ab9)
            check_type(argname="argument gain", value=gain, expected_type=type_hints["gain"])
            check_type(argname="argument gain_var", value=gain_var, expected_type=type_hints["gain_var"])
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
            check_type(argname="argument threshold", value=threshold, expected_type=type_hints["threshold"])
            check_type(argname="argument threshold_var", value=threshold_var, expected_type=type_hints["threshold_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if gain is not None:
            self._values["gain"] = gain
        if gain_var is not None:
            self._values["gain_var"] = gain_var
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var
        if threshold is not None:
            self._values["threshold"] = threshold
        if threshold_var is not None:
            self._values["threshold_var"] = threshold_var

    @builtins.property
    def gain(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        '''
        result = self._values.get("gain")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gain_var(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        '''
        result = self._values.get("gain_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        '''
        result = self._values.get("threshold")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold_var(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        result = self._values.get("threshold_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultUnsharpMask(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultUnsharpMaskList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultUnsharpMaskList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bf3837e364c39ae06c320d700d4ad109172a6b2580b0c550e8cd082dbe6c876d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultUnsharpMaskOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__655648e19bfe1ac8f8ef9e8452b37fe869b461166c6eab370629e7222ff78315)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultUnsharpMaskOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__616bd5557d5c79da346618c4c6f57fe900b13f8d62cd238987f165020903040a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aacaa55ff884e24b05d8e6ef6e2313fd0ad1e49b5e12089bf3498c031fc2c860)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5df5a8b79b9723ef581d4c64d7183215f351647fc7328325ab8e995d5e3d5942)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultUnsharpMask]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultUnsharpMask]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultUnsharpMask]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c67f6645c60aa4dd3a4ba8a93d391f355c66fe9d73aaa98d4d378e33dda15da4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultUnsharpMaskOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultUnsharpMaskOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__24f562abd8a6795fbadde0669a4a3d580c64919c5d81d4658846051f0a3e09f1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetGain")
    def reset_gain(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGain", []))

    @jsii.member(jsii_name="resetGainVar")
    def reset_gain_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGainVar", []))

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @jsii.member(jsii_name="resetThreshold")
    def reset_threshold(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThreshold", []))

    @jsii.member(jsii_name="resetThresholdVar")
    def reset_threshold_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThresholdVar", []))

    @builtins.property
    @jsii.member(jsii_name="gainInput")
    def gain_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainInput"))

    @builtins.property
    @jsii.member(jsii_name="gainVarInput")
    def gain_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdInput")
    def threshold_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdVarInput")
    def threshold_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gain")
    def gain(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gain"))

    @gain.setter
    def gain(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__97221a0bb56eac26ff4b292d5684f6f7c9abb154c67c0b708a44166aeef8081f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gain", value)

    @builtins.property
    @jsii.member(jsii_name="gainVar")
    def gain_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gainVar"))

    @gain_var.setter
    def gain_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ac6689ac9c46fb412fd59a4ff3f3a3ac2a6996ed54aec549b3d937741bb2641)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gainVar", value)

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0b106132b9c3f3de999c3346a2f1e86ec85e334b67eb9f93c388967c5159d65e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6779b9f0ac7242fcd37b6dbaded810d8632fe7a49ccd87f5c05a829c1078b8ff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="threshold")
    def threshold(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "threshold"))

    @threshold.setter
    def threshold(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5b4f306ec06b8fc2ec5573413545e33c94774aa1f633989fd6cda952671049db)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "threshold", value)

    @builtins.property
    @jsii.member(jsii_name="thresholdVar")
    def threshold_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "thresholdVar"))

    @threshold_var.setter
    def threshold_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8803d88a5b08b3096ba6126af2393d5cc674da864dfebf312eb77d3c894ed0c9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "thresholdVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultUnsharpMask]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultUnsharpMask]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultUnsharpMask]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f4bd2200d7790d7855df529a987bb0893bb91b7beaafb953592e7e22d65faf0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqual",
    jsii_struct_bases=[],
    name_mapping={
        "background_color": "backgroundColor",
        "blur": "blur",
        "chroma_key": "chromaKey",
        "composite": "composite",
        "compound": "compound",
        "contrast": "contrast",
        "goop": "goop",
        "grayscale": "grayscale",
        "hsl": "hsl",
        "hsv": "hsv",
        "if_dimension": "ifDimension",
        "if_orientation": "ifOrientation",
        "max_colors": "maxColors",
        "mirror": "mirror",
        "mono_hue": "monoHue",
        "opacity": "opacity",
        "remove_color": "removeColor",
        "unsharp_mask": "unsharpMask",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqual:
    def __init__(
        self,
        *,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualBackgroundColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualBlur", typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualChromaKey", typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualComposite", typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualCompound", typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualContrast", typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualGoop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualGrayscale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualHsl", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualHsv", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfDimension", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfOrientation", typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualMaxColors", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualMirror", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualMonoHue", typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualOpacity", typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualRemoveColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualUnsharpMask", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__38f68342eb83e1b42b0b16ee18c87094c3a0bc13fd9605719e4b64dad8a2ef33)
            check_type(argname="argument background_color", value=background_color, expected_type=type_hints["background_color"])
            check_type(argname="argument blur", value=blur, expected_type=type_hints["blur"])
            check_type(argname="argument chroma_key", value=chroma_key, expected_type=type_hints["chroma_key"])
            check_type(argname="argument composite", value=composite, expected_type=type_hints["composite"])
            check_type(argname="argument compound", value=compound, expected_type=type_hints["compound"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument goop", value=goop, expected_type=type_hints["goop"])
            check_type(argname="argument grayscale", value=grayscale, expected_type=type_hints["grayscale"])
            check_type(argname="argument hsl", value=hsl, expected_type=type_hints["hsl"])
            check_type(argname="argument hsv", value=hsv, expected_type=type_hints["hsv"])
            check_type(argname="argument if_dimension", value=if_dimension, expected_type=type_hints["if_dimension"])
            check_type(argname="argument if_orientation", value=if_orientation, expected_type=type_hints["if_orientation"])
            check_type(argname="argument max_colors", value=max_colors, expected_type=type_hints["max_colors"])
            check_type(argname="argument mirror", value=mirror, expected_type=type_hints["mirror"])
            check_type(argname="argument mono_hue", value=mono_hue, expected_type=type_hints["mono_hue"])
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument remove_color", value=remove_color, expected_type=type_hints["remove_color"])
            check_type(argname="argument unsharp_mask", value=unsharp_mask, expected_type=type_hints["unsharp_mask"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if background_color is not None:
            self._values["background_color"] = background_color
        if blur is not None:
            self._values["blur"] = blur
        if chroma_key is not None:
            self._values["chroma_key"] = chroma_key
        if composite is not None:
            self._values["composite"] = composite
        if compound is not None:
            self._values["compound"] = compound
        if contrast is not None:
            self._values["contrast"] = contrast
        if goop is not None:
            self._values["goop"] = goop
        if grayscale is not None:
            self._values["grayscale"] = grayscale
        if hsl is not None:
            self._values["hsl"] = hsl
        if hsv is not None:
            self._values["hsv"] = hsv
        if if_dimension is not None:
            self._values["if_dimension"] = if_dimension
        if if_orientation is not None:
            self._values["if_orientation"] = if_orientation
        if max_colors is not None:
            self._values["max_colors"] = max_colors
        if mirror is not None:
            self._values["mirror"] = mirror
        if mono_hue is not None:
            self._values["mono_hue"] = mono_hue
        if opacity is not None:
            self._values["opacity"] = opacity
        if remove_color is not None:
            self._values["remove_color"] = remove_color
        if unsharp_mask is not None:
            self._values["unsharp_mask"] = unsharp_mask

    @builtins.property
    def background_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualBackgroundColor"]]]:
        '''background_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        '''
        result = self._values.get("background_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualBackgroundColor"]]], result)

    @builtins.property
    def blur(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualBlur"]]]:
        '''blur block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        '''
        result = self._values.get("blur")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualBlur"]]], result)

    @builtins.property
    def chroma_key(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualChromaKey"]]]:
        '''chroma_key block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        '''
        result = self._values.get("chroma_key")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualChromaKey"]]], result)

    @builtins.property
    def composite(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualComposite"]]]:
        '''composite block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        '''
        result = self._values.get("composite")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualComposite"]]], result)

    @builtins.property
    def compound(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualCompound"]]]:
        '''compound block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        '''
        result = self._values.get("compound")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualCompound"]]], result)

    @builtins.property
    def contrast(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualContrast"]]]:
        '''contrast block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualContrast"]]], result)

    @builtins.property
    def goop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualGoop"]]]:
        '''goop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        '''
        result = self._values.get("goop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualGoop"]]], result)

    @builtins.property
    def grayscale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualGrayscale"]]]:
        '''grayscale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        '''
        result = self._values.get("grayscale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualGrayscale"]]], result)

    @builtins.property
    def hsl(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualHsl"]]]:
        '''hsl block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        '''
        result = self._values.get("hsl")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualHsl"]]], result)

    @builtins.property
    def hsv(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualHsv"]]]:
        '''hsv block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        '''
        result = self._values.get("hsv")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualHsv"]]], result)

    @builtins.property
    def if_dimension(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfDimension"]]]:
        '''if_dimension block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        '''
        result = self._values.get("if_dimension")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfDimension"]]], result)

    @builtins.property
    def if_orientation(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfOrientation"]]]:
        '''if_orientation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        '''
        result = self._values.get("if_orientation")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfOrientation"]]], result)

    @builtins.property
    def max_colors(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualMaxColors"]]]:
        '''max_colors block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        '''
        result = self._values.get("max_colors")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualMaxColors"]]], result)

    @builtins.property
    def mirror(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualMirror"]]]:
        '''mirror block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        '''
        result = self._values.get("mirror")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualMirror"]]], result)

    @builtins.property
    def mono_hue(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualMonoHue"]]]:
        '''mono_hue block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        '''
        result = self._values.get("mono_hue")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualMonoHue"]]], result)

    @builtins.property
    def opacity(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualOpacity"]]]:
        '''opacity block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualOpacity"]]], result)

    @builtins.property
    def remove_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualRemoveColor"]]]:
        '''remove_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        '''
        result = self._values.get("remove_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualRemoveColor"]]], result)

    @builtins.property
    def unsharp_mask(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualUnsharpMask"]]]:
        '''unsharp_mask block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        result = self._values.get("unsharp_mask")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualUnsharpMask"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqual(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualBackgroundColor",
    jsii_struct_bases=[],
    name_mapping={"color": "color", "color_var": "colorVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualBackgroundColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c922358068dd186f1cad3befdfd4588c978b0258d3f3888dc36543a049c59f26)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualBackgroundColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualBackgroundColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualBackgroundColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a8d5c5552a08bf53a7b03af90ac577b9dcc5ebb27f01b6dce228dd368793fb47)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualBackgroundColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4d038be8766c3b8f75832f8ee802c559798b5524fb3b92ce6b1ed9eaafc9c109)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualBackgroundColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c555b2611afc362e9fdabb3c72f2365c683bdd1e3711c49762e75def720f4ae3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ef27b7d55e2ec4537aa192c9f3f4ed1a084aea3d975e36b1a8f1ef8365430a09)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__216d7285c4c0ddd79e60304ce1518237cf012b9bcec0da9a3994fcd92c109304)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualBackgroundColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualBackgroundColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5821815cf1b1fc43eb87912a1fcdb1b038e10d2a2680c1be92b848164737b15b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualBackgroundColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualBackgroundColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__78eca7d31679308eca76b94c212e6c206c3db44d2c2791c4311f5df72efbb8b2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5c71ef0b80d49957d574726b7c71de9343fec779c6b8832d6314a28c30696e80)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e44efb49d9457ff68812f3b25cba152073381a06dc47116c6a6cd08712fadf4f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualBackgroundColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualBackgroundColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualBackgroundColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6475e3cfc050311837874aa5c356ebd078c815246a0589543887ca87dad8508c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualBlur",
    jsii_struct_bases=[],
    name_mapping={"sigma": "sigma", "sigma_var": "sigmaVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualBlur:
    def __init__(
        self,
        *,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param sigma: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c11e17e5a78cec1067deea1833fcde49c2282a8b706e56a7c01d2084ef5a6243)
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualBlur(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualBlurList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualBlurList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5c0a8ef8d6441eaa1830de261626d7386079c5ee890a562a133a25fbf8cde27b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualBlurOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dc7c141620cd736511accbd02cebe35b0d7f746b0cd574a66ca80ffb78e15cbe)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualBlurOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a359c3b4f88b0a1b12e630e1a80b88de4ab420bf1d1785ec432dc46e23f6efc7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__31389ae787a16761d5f722dec9e4a06f0922497a92b539ed8df07318acd3b8dd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0b3fd789f0fcb4d5d48ea1f1f7e032ec457687bda451b266a65e096ced275d67)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualBlur]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualBlur]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2cd2310009130f251ea5d5f7869982aff1bb73b3faa3f22d50687e3392eff804)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualBlurOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualBlurOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__beccfec7b0fd92026b60a7cff9ace590b3a197083057f275b776eed7519eadb6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9f8938bd5549bd12f689e1e3879e4e16b28dc3023b59d5d858cb47a78accac01)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__246daa1cab2246c2436402face5c34b409819b87a4cfd5c374211c817a6e3184)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualBlur]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualBlur]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualBlur]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa5e972c643ae94607d744145095ee6d609dc1d9afdd3359efdfa75f3361cabd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualChromaKey",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_feather": "hueFeather",
        "hue_feather_var": "hueFeatherVar",
        "hue_tolerance": "hueTolerance",
        "hue_tolerance_var": "hueToleranceVar",
        "hue_var": "hueVar",
        "lightness_feather": "lightnessFeather",
        "lightness_feather_var": "lightnessFeatherVar",
        "lightness_tolerance": "lightnessTolerance",
        "lightness_tolerance_var": "lightnessToleranceVar",
        "saturation_feather": "saturationFeather",
        "saturation_feather_var": "saturationFeatherVar",
        "saturation_tolerance": "saturationTolerance",
        "saturation_tolerance_var": "saturationToleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualChromaKey:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_feather: typing.Optional[builtins.str] = None,
        hue_feather_var: typing.Optional[builtins.str] = None,
        hue_tolerance: typing.Optional[builtins.str] = None,
        hue_tolerance_var: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness_feather: typing.Optional[builtins.str] = None,
        lightness_feather_var: typing.Optional[builtins.str] = None,
        lightness_tolerance: typing.Optional[builtins.str] = None,
        lightness_tolerance_var: typing.Optional[builtins.str] = None,
        saturation_feather: typing.Optional[builtins.str] = None,
        saturation_feather_var: typing.Optional[builtins.str] = None,
        saturation_tolerance: typing.Optional[builtins.str] = None,
        saturation_tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_feather: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        :param hue_feather_var: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        :param hue_tolerance: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        :param hue_tolerance_var: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        :param hue_var: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness_feather: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        :param lightness_feather_var: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        :param lightness_tolerance: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        :param lightness_tolerance_var: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        :param saturation_feather: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        :param saturation_feather_var: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        :param saturation_tolerance: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        :param saturation_tolerance_var: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c7351f9e98762ccc07336b52b1d770d439411fd492ec40ce4e15cc65c6f91a0f)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_feather", value=hue_feather, expected_type=type_hints["hue_feather"])
            check_type(argname="argument hue_feather_var", value=hue_feather_var, expected_type=type_hints["hue_feather_var"])
            check_type(argname="argument hue_tolerance", value=hue_tolerance, expected_type=type_hints["hue_tolerance"])
            check_type(argname="argument hue_tolerance_var", value=hue_tolerance_var, expected_type=type_hints["hue_tolerance_var"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness_feather", value=lightness_feather, expected_type=type_hints["lightness_feather"])
            check_type(argname="argument lightness_feather_var", value=lightness_feather_var, expected_type=type_hints["lightness_feather_var"])
            check_type(argname="argument lightness_tolerance", value=lightness_tolerance, expected_type=type_hints["lightness_tolerance"])
            check_type(argname="argument lightness_tolerance_var", value=lightness_tolerance_var, expected_type=type_hints["lightness_tolerance_var"])
            check_type(argname="argument saturation_feather", value=saturation_feather, expected_type=type_hints["saturation_feather"])
            check_type(argname="argument saturation_feather_var", value=saturation_feather_var, expected_type=type_hints["saturation_feather_var"])
            check_type(argname="argument saturation_tolerance", value=saturation_tolerance, expected_type=type_hints["saturation_tolerance"])
            check_type(argname="argument saturation_tolerance_var", value=saturation_tolerance_var, expected_type=type_hints["saturation_tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_feather is not None:
            self._values["hue_feather"] = hue_feather
        if hue_feather_var is not None:
            self._values["hue_feather_var"] = hue_feather_var
        if hue_tolerance is not None:
            self._values["hue_tolerance"] = hue_tolerance
        if hue_tolerance_var is not None:
            self._values["hue_tolerance_var"] = hue_tolerance_var
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness_feather is not None:
            self._values["lightness_feather"] = lightness_feather
        if lightness_feather_var is not None:
            self._values["lightness_feather_var"] = lightness_feather_var
        if lightness_tolerance is not None:
            self._values["lightness_tolerance"] = lightness_tolerance
        if lightness_tolerance_var is not None:
            self._values["lightness_tolerance_var"] = lightness_tolerance_var
        if saturation_feather is not None:
            self._values["saturation_feather"] = saturation_feather
        if saturation_feather_var is not None:
            self._values["saturation_feather_var"] = saturation_feather_var
        if saturation_tolerance is not None:
            self._values["saturation_tolerance"] = saturation_tolerance
        if saturation_tolerance_var is not None:
            self._values["saturation_tolerance_var"] = saturation_tolerance_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        '''
        result = self._values.get("hue_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        '''
        result = self._values.get("hue_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        '''
        result = self._values.get("hue_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        '''
        result = self._values.get("hue_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        '''
        result = self._values.get("lightness_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        '''
        result = self._values.get("lightness_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        '''
        result = self._values.get("lightness_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        '''
        result = self._values.get("lightness_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        '''
        result = self._values.get("saturation_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        '''
        result = self._values.get("saturation_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        '''
        result = self._values.get("saturation_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        result = self._values.get("saturation_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualChromaKey(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualChromaKeyList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualChromaKeyList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e6f9e26bf9c13d90028f5b1cf54570e4dafff0a12946bdb07a6601426b8a3a0c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualChromaKeyOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e2cb2b381c29576ebff9483525691f10099352dbc83350585dcbb120a9785993)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualChromaKeyOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__45515d25cc7e98dd18c829629264d6cb480fb979182a7e63cad06610b7ff4d76)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__21384da469fcb5d87621fa25c79946011ec1b871df216963aba125d6b4b7e37e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fcb2a57a077dd5654669adb9c8f78a826567aa1bc78cc0a803f66683c37188e2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualChromaKey]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualChromaKey]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__44b2c3df6da9240b1835f04190b10d33ef595de8017b05f53f2b34a0247f20c5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualChromaKeyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualChromaKeyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__45b21a8a6232fd82930e9afcd188eadec51cfb14d22e46e44044fbb61738c7c8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueFeather")
    def reset_hue_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeather", []))

    @jsii.member(jsii_name="resetHueFeatherVar")
    def reset_hue_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeatherVar", []))

    @jsii.member(jsii_name="resetHueTolerance")
    def reset_hue_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueTolerance", []))

    @jsii.member(jsii_name="resetHueToleranceVar")
    def reset_hue_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueToleranceVar", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightnessFeather")
    def reset_lightness_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeather", []))

    @jsii.member(jsii_name="resetLightnessFeatherVar")
    def reset_lightness_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeatherVar", []))

    @jsii.member(jsii_name="resetLightnessTolerance")
    def reset_lightness_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessTolerance", []))

    @jsii.member(jsii_name="resetLightnessToleranceVar")
    def reset_lightness_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessToleranceVar", []))

    @jsii.member(jsii_name="resetSaturationFeather")
    def reset_saturation_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeather", []))

    @jsii.member(jsii_name="resetSaturationFeatherVar")
    def reset_saturation_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeatherVar", []))

    @jsii.member(jsii_name="resetSaturationTolerance")
    def reset_saturation_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationTolerance", []))

    @jsii.member(jsii_name="resetSaturationToleranceVar")
    def reset_saturation_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherInput")
    def hue_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVarInput")
    def hue_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceInput")
    def hue_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVarInput")
    def hue_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherInput")
    def lightness_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVarInput")
    def lightness_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceInput")
    def lightness_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVarInput")
    def lightness_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherInput")
    def saturation_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVarInput")
    def saturation_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceInput")
    def saturation_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVarInput")
    def saturation_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d79d18a8017336edbcbdd3866b5d92d1d4bdf001066ebf76dc1ad14c7b19dfed)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeather")
    def hue_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeather"))

    @hue_feather.setter
    def hue_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__57d700413fe244c9ae9d668d620bed22198870f9297ee92a8bb04ea54d8246ac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeather", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVar")
    def hue_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeatherVar"))

    @hue_feather_var.setter
    def hue_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__832b3a7f86fafe23cf77462e8860ea3ba3a588d42f239d115978b71aba9e2083)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueTolerance")
    def hue_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueTolerance"))

    @hue_tolerance.setter
    def hue_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a44adf9d2750eefdd793631a34c31261ccf1942d62cb0c45f0d6b4547886b140)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVar")
    def hue_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueToleranceVar"))

    @hue_tolerance_var.setter
    def hue_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c1dc19c2ffa971516c899ea996bec24380d43c0fa92bf9978f08e418e572f8cc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__87ce5a1a85620a8501408befaedd56a04abbecea105c1dfe178a19df4c82acda)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeather")
    def lightness_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeather"))

    @lightness_feather.setter
    def lightness_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2741fc7779d0465df985ab99351e2156e19a79f4d6574c4b92e981a3d97a74d2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeather", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVar")
    def lightness_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeatherVar"))

    @lightness_feather_var.setter
    def lightness_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a1ed7b1693f605aa11cccd15159aaa0183233daef5917c2e1c07aeeae231838)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessTolerance")
    def lightness_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessTolerance"))

    @lightness_tolerance.setter
    def lightness_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__32e993aff049555875325973635e2dd1a8f0566d01ca83b125b27cc99022645c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVar")
    def lightness_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessToleranceVar"))

    @lightness_tolerance_var.setter
    def lightness_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__33a4ef8c7dcce1a724633cfeec2889a9070f6ad99a5babf1f93df707de340161)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeather")
    def saturation_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeather"))

    @saturation_feather.setter
    def saturation_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__82aa0f6e352adf895249f8182958c6090499d7751acdee025f0c79e0c9ef6b6b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeather", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVar")
    def saturation_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeatherVar"))

    @saturation_feather_var.setter
    def saturation_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5b5dc0c0f0d11fec426075b948fdb0ab206293f1b468f8e06a2696c9af83d08d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationTolerance")
    def saturation_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationTolerance"))

    @saturation_tolerance.setter
    def saturation_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b10f83ad7ff8ac83a2449749e7e15a5ed2c2056b518d621973b47d2a7a8f6911)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVar")
    def saturation_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationToleranceVar"))

    @saturation_tolerance_var.setter
    def saturation_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5b96d2559ba60e104deef2b5dc02f9aab58fa2f7ee0b2be3b115ea58a21e8316)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualChromaKey]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualChromaKey]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualChromaKey]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__331d02c6746a2a91cf921de1dcef2046b97c6bd24cfc5ebeb43c971a8f253452)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualComposite",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "placement": "placement",
        "placement_var": "placementVar",
        "scale": "scale",
        "scale_dimension": "scaleDimension",
        "scale_dimension_var": "scaleDimensionVar",
        "scale_var": "scaleVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualComposite:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualCompositeImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        placement: typing.Optional[builtins.str] = None,
        placement_var: typing.Optional[builtins.str] = None,
        scale: typing.Optional[builtins.str] = None,
        scale_dimension: typing.Optional[builtins.str] = None,
        scale_dimension_var: typing.Optional[builtins.str] = None,
        scale_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param placement: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        :param placement_var: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        :param scale: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param scale_dimension: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        :param scale_dimension_var: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        :param scale_var: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        :param x_position: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualCompositeImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fde04c2c140d05c2566e9e066fa0663941f608c8841552c5a9274d5cf2977430)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument placement", value=placement, expected_type=type_hints["placement"])
            check_type(argname="argument placement_var", value=placement_var, expected_type=type_hints["placement_var"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument scale_dimension", value=scale_dimension, expected_type=type_hints["scale_dimension"])
            check_type(argname="argument scale_dimension_var", value=scale_dimension_var, expected_type=type_hints["scale_dimension_var"])
            check_type(argname="argument scale_var", value=scale_var, expected_type=type_hints["scale_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if placement is not None:
            self._values["placement"] = placement
        if placement_var is not None:
            self._values["placement_var"] = placement_var
        if scale is not None:
            self._values["scale"] = scale
        if scale_dimension is not None:
            self._values["scale_dimension"] = scale_dimension
        if scale_dimension_var is not None:
            self._values["scale_dimension_var"] = scale_dimension_var
        if scale_var is not None:
            self._values["scale_var"] = scale_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualCompositeImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualCompositeImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        '''
        result = self._values.get("placement")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement_var(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        '''
        result = self._values.get("placement_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        '''
        result = self._values.get("scale_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        '''
        result = self._values.get("scale_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        '''
        result = self._values.get("scale_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualComposite(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualCompositeImage",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualCompositeImage:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualCompositeImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualCompositeImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualCompositeImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__72d5d9a052df27f52cb74717c50814ed630997a51d4ea136cbe18fbdbd9ebb8c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualCompositeImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualCompositeImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__807a395f1f07c6984c9f300b4e956cdeb25a95337f2fda0384d3102405c400e9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualCompositeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualCompositeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b409ff34edd5ae9e380555bbcc25131052ccf4874bffa5337fea9fea6f8237fc)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualCompositeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6b1dd1a567c3d8ac72751b8eed459cbf5177ea1285c3c7fc711c49cbf66af309)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualCompositeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5811772de176aceccd2a14a69fadeef529df8d099c118d3e03731f8b8a1130b1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aed5fa3643b6036487c1c33c19915fc1a8ac0b093039a23ce75024b62b31d046)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac4f21e322fe4fe6c9a1ed1dbcc531405dbb8209ed280f88b6cf98d8d72efa66)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualComposite]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualComposite]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4df93105bef8d64c0e0eaa6610b167efc00d555b195c686aa17db0e4328dfc01)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualCompositeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualCompositeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b1214f9b8d19eae3c25d4fc74ab39cdbb3df96512e50a0e4ebb3e214dd1e0573)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualCompositeImage()

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPlacement")
    def reset_placement(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacement", []))

    @jsii.member(jsii_name="resetPlacementVar")
    def reset_placement_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacementVar", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetScaleDimension")
    def reset_scale_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimension", []))

    @jsii.member(jsii_name="resetScaleDimensionVar")
    def reset_scale_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimensionVar", []))

    @jsii.member(jsii_name="resetScaleVar")
    def reset_scale_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualCompositeImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualCompositeImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualCompositeImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="placementInput")
    def placement_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementInput"))

    @builtins.property
    @jsii.member(jsii_name="placementVarInput")
    def placement_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionInput")
    def scale_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVarInput")
    def scale_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleVarInput")
    def scale_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1ba00d53b4132486614b652d21397d5a09db9129b3cb68e34c6fc44a09f0db4b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cb27ba89781e28b7b825782beb508dbd6408d3ad387f2314f7305c109a91d28f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="placement")
    def placement(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placement"))

    @placement.setter
    def placement(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c2163ebb67d5f461b3b578a648d10d909e357f112f78c4a5c962b474a1474f92)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placement", value)

    @builtins.property
    @jsii.member(jsii_name="placementVar")
    def placement_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placementVar"))

    @placement_var.setter
    def placement_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ea1629224ce22af8c2648a28751d7f156c0530367c385f7a40c24c298915612)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placementVar", value)

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scale"))

    @scale.setter
    def scale(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9154a71a7fe277a812b4a91173a6700d6bf9715a5f9bea20079f9bf9fec6477a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scale", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimension")
    def scale_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimension"))

    @scale_dimension.setter
    def scale_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__94d342036c14df1ec44027c72e357669fe7ac1eb5867774bbc7d1abf211892bb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimension", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVar")
    def scale_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimensionVar"))

    @scale_dimension_var.setter
    def scale_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f82ae30011cf3cb969dcf7d126a65c8133837a13c380922c024b6e0c4f75171)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="scaleVar")
    def scale_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleVar"))

    @scale_var.setter
    def scale_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__764972b294046c9d6422045846c2d69ceb48ff3498f809bb77682a29090ca507)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__664eca8308414edb49b629e58a3cae9f02a540b38c6e02ee2682b8f37b1e8c59)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6c6667cd0d4882f8b17d45db734d7ece7929dc69af59207a7211feb63babcfa8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7bf12c41a710febbbb2e916854771d6d732df4d72e73fe53ae26f6a0f74ba4cd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a27ac4caa31faaf3ac4b63f9730b984cc54c9049608d4b083d3c2d0f4132ea79)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualComposite]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualComposite]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualComposite]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ecf821ef91cd7a0a230d3a33293d4ddd82c7ced757ebde951f7c3c3be64ddb5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualCompound",
    jsii_struct_bases=[],
    name_mapping={"transformations": "transformations"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualCompound:
    def __init__(
        self,
        *,
        transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param transformations: transformations block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a5dc9577606a3def934c51cc74c8679b365d3969eef2c61e84b38d60f6c4a94b)
            check_type(argname="argument transformations", value=transformations, expected_type=type_hints["transformations"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if transformations is not None:
            self._values["transformations"] = transformations

    @builtins.property
    def transformations(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualCompoundTransformations"]]]:
        '''transformations block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        result = self._values.get("transformations")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualCompoundTransformations"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualCompound(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualCompoundList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualCompoundList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9fa576089e4626815f9812e2acd786b097ac4b08e1bd39e931c02bde807f4265)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualCompoundOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f44007586f94c45ff005bc2402305a7700262fb75cac37f07dafc86d3f44f0bf)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualCompoundOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d11d4b613d1330824a7101101e000129d9920a9ddb51c10c42fef4548fd8c8b2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__861bf0e0a273e5e84f9df9fe553d3088dbc51b29c887f8edc4bb500f64ea9050)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fb7ac5a445e35c00f0d7a64dc7ec9a1bda99ce258ec34bffe6a0fde3dc221a22)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualCompound]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualCompound]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a924320b30784c7f2c028e3067e20348cc22332367be08edea07bb0a6ef433c7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualCompoundOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualCompoundOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d574a47cd29cfb5b6caf9e2dfae639f6d6f069e7d33b7386e53f74580ded7cfd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformations")
    def put_transformations(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c2c2fa04dc3188df652a1b1a283d2ff52256e141a00c95783ef924ca7e93aa91)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTransformations", [value]))

    @jsii.member(jsii_name="resetTransformations")
    def reset_transformations(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformations", []))

    @builtins.property
    @jsii.member(jsii_name="transformations")
    def transformations(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualCompoundTransformationsList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualCompoundTransformationsList", jsii.get(self, "transformations"))

    @builtins.property
    @jsii.member(jsii_name="transformationsInput")
    def transformations_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualCompoundTransformations"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualCompoundTransformations"]]], jsii.get(self, "transformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualCompound]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualCompound]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualCompound]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ce7e54a80b820b277c80b83b21011785f33f3ead0a2f5f5aa55da2c7a2da7f73)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualCompoundTransformations",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualCompoundTransformations:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualCompoundTransformations(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualCompoundTransformationsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualCompoundTransformationsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__46e1efa2ae6185d0941753bcf901e18c4301edb76060a51b14d7c0e11a44aebf)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualCompoundTransformationsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e0062467a733fed115e4dcf20ac625602be0317c35a2fc66964e058e6bbde396)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualCompoundTransformationsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9893449ac92ad26ad3ed9829b658c307e07f6df969950e6085faf8c3aedc1ff4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9c35e5cfae53af0b199bc93d470a64775f7135d2a433c26384ce60717de0ef66)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8da6b4a65feae15c1f097ffdfe89bb37f24ee7ee28e86d78962fa30ec9efec74)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualCompoundTransformations]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualCompoundTransformations]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualCompoundTransformations]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3cfcaf1b3c28ef15548125eedf4d5c4819624b689a830a61a955a4c2177a4e1e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualCompoundTransformationsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualCompoundTransformationsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dfadef6ea0f7dabae4301fc4cf9806ac9db4754fb86fb5ecadad7eeefa077c14)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualCompoundTransformations]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualCompoundTransformations]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualCompoundTransformations]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7ea68f955ba13cd0eec96342a00522871fe461c4cd09978f476337d28d4ad187)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualContrast",
    jsii_struct_bases=[],
    name_mapping={
        "brightness": "brightness",
        "brightness_var": "brightnessVar",
        "contrast": "contrast",
        "contrast_var": "contrastVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualContrast:
    def __init__(
        self,
        *,
        brightness: typing.Optional[builtins.str] = None,
        brightness_var: typing.Optional[builtins.str] = None,
        contrast: typing.Optional[builtins.str] = None,
        contrast_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param brightness: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        :param brightness_var: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        :param contrast: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param contrast_var: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e4ffc5bf27dc43da4a8a75956b2db5c3d5e8e3c5794d640205ff83e52521ee77)
            check_type(argname="argument brightness", value=brightness, expected_type=type_hints["brightness"])
            check_type(argname="argument brightness_var", value=brightness_var, expected_type=type_hints["brightness_var"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument contrast_var", value=contrast_var, expected_type=type_hints["contrast_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if brightness is not None:
            self._values["brightness"] = brightness
        if brightness_var is not None:
            self._values["brightness_var"] = brightness_var
        if contrast is not None:
            self._values["contrast"] = contrast
        if contrast_var is not None:
            self._values["contrast_var"] = contrast_var

    @builtins.property
    def brightness(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        '''
        result = self._values.get("brightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def brightness_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        '''
        result = self._values.get("brightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        result = self._values.get("contrast_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualContrast(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualContrastList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualContrastList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__652c47c766ad5bff610d34691d6cf74a7f8a3119f4c2efa780f35cd41d0bf4f7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualContrastOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c15f3772629a5ac69f23ce428016738f89cccb83d30d5c09137ed9eb26a4ae56)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualContrastOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__44e34f78c2e386e18273997a52483a11d0c7be397e3570be27b27ca5606341bf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a7308247ba64b6bec7490de1b05ae700c97b451aa61219189128ff1ce36fe352)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bf8f6e829471990c39e1730e72538691e8aa72dc0c8495be6e815ed922fa0996)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualContrast]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualContrast]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b2c09ae7f9bee107906e9ae8a729cd3a9f6bc898324169cd349fc5b54780e02c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualContrastOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualContrastOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e4a7a4a0513a43f48eb6c879cc1880664c147fc9fa9451a8ad7285b03d25e40f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetBrightness")
    def reset_brightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightness", []))

    @jsii.member(jsii_name="resetBrightnessVar")
    def reset_brightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightnessVar", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetContrastVar")
    def reset_contrast_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrastVar", []))

    @builtins.property
    @jsii.member(jsii_name="brightnessInput")
    def brightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="brightnessVarInput")
    def brightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastVarInput")
    def contrast_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="brightness")
    def brightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightness"))

    @brightness.setter
    def brightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__53de9c2efd452a8d35c786055ad7f5a0ee10ccfd9d8f933be2c7d63f8e1343de)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightness", value)

    @builtins.property
    @jsii.member(jsii_name="brightnessVar")
    def brightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightnessVar"))

    @brightness_var.setter
    def brightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__28b3613be0d6fd984fcfa3656089537735e84f9f2ff7b69c0e880595b93483e2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrast"))

    @contrast.setter
    def contrast(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__095b207dc759d48522aa567770d16e69e2d4bf2496c495e6cb9876553071c5c5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrast", value)

    @builtins.property
    @jsii.member(jsii_name="contrastVar")
    def contrast_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrastVar"))

    @contrast_var.setter
    def contrast_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__edb20eecc66c3046f500cc0f40109cf2ea1068130f971ca63de19df00ac52535)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrastVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualContrast]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualContrast]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualContrast]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cc94f27adce45a18c3785028e4ee6f9ef1dc656aefb171e0c05d8a4a6b8e8d7b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualGoop",
    jsii_struct_bases=[],
    name_mapping={
        "chaos": "chaos",
        "chaos_var": "chaosVar",
        "density": "density",
        "density_var": "densityVar",
        "power": "power",
        "power_var": "powerVar",
        "seed": "seed",
        "seed_var": "seedVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualGoop:
    def __init__(
        self,
        *,
        chaos: typing.Optional[builtins.str] = None,
        chaos_var: typing.Optional[builtins.str] = None,
        density: typing.Optional[builtins.str] = None,
        density_var: typing.Optional[builtins.str] = None,
        power: typing.Optional[builtins.str] = None,
        power_var: typing.Optional[builtins.str] = None,
        seed: typing.Optional[builtins.str] = None,
        seed_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param chaos: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        :param chaos_var: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        :param density: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        :param density_var: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        :param power: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        :param power_var: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        :param seed: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        :param seed_var: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__67be962abd5af87566e6d142d8465aa3edeea05c68427303c66cbd390434c2e3)
            check_type(argname="argument chaos", value=chaos, expected_type=type_hints["chaos"])
            check_type(argname="argument chaos_var", value=chaos_var, expected_type=type_hints["chaos_var"])
            check_type(argname="argument density", value=density, expected_type=type_hints["density"])
            check_type(argname="argument density_var", value=density_var, expected_type=type_hints["density_var"])
            check_type(argname="argument power", value=power, expected_type=type_hints["power"])
            check_type(argname="argument power_var", value=power_var, expected_type=type_hints["power_var"])
            check_type(argname="argument seed", value=seed, expected_type=type_hints["seed"])
            check_type(argname="argument seed_var", value=seed_var, expected_type=type_hints["seed_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if chaos is not None:
            self._values["chaos"] = chaos
        if chaos_var is not None:
            self._values["chaos_var"] = chaos_var
        if density is not None:
            self._values["density"] = density
        if density_var is not None:
            self._values["density_var"] = density_var
        if power is not None:
            self._values["power"] = power
        if power_var is not None:
            self._values["power_var"] = power_var
        if seed is not None:
            self._values["seed"] = seed
        if seed_var is not None:
            self._values["seed_var"] = seed_var

    @builtins.property
    def chaos(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        '''
        result = self._values.get("chaos")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def chaos_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        '''
        result = self._values.get("chaos_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        '''
        result = self._values.get("density")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density_var(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        '''
        result = self._values.get("density_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        '''
        result = self._values.get("power")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power_var(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        '''
        result = self._values.get("power_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        '''
        result = self._values.get("seed")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed_var(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        result = self._values.get("seed_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualGoop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualGoopList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualGoopList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6179e1bd49d399d66a78a0c29879f860fa989764f754083a8c6d6c84cea3d57f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualGoopOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__28004d0296a30ed4561c591229f21325b681eb59fee0379b992931d85f1413a9)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualGoopOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e8d3270f4050e1c383dfbaa624c3e04a94b5d04d893b052a687ff2d372510fe9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__69852b7f62faffb1a22bc9c9a773e09824db288bbef6a25c9a8aa97b3f98f3c9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc58813b037f36d7ea89df981f147ed2bdb7f146d3fe45a7cc3eb8fff0217707)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualGoop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualGoop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0406e1e6e8a738b5342e45ba4fbfd51823d3a46c49c12339499f86629b713037)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualGoopOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualGoopOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7c7eaf8b103f9888030adc8362bca1c58664626b7e38ad3ebbe53e4b2906cabd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetChaos")
    def reset_chaos(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaos", []))

    @jsii.member(jsii_name="resetChaosVar")
    def reset_chaos_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaosVar", []))

    @jsii.member(jsii_name="resetDensity")
    def reset_density(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensity", []))

    @jsii.member(jsii_name="resetDensityVar")
    def reset_density_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensityVar", []))

    @jsii.member(jsii_name="resetPower")
    def reset_power(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPower", []))

    @jsii.member(jsii_name="resetPowerVar")
    def reset_power_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPowerVar", []))

    @jsii.member(jsii_name="resetSeed")
    def reset_seed(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeed", []))

    @jsii.member(jsii_name="resetSeedVar")
    def reset_seed_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeedVar", []))

    @builtins.property
    @jsii.member(jsii_name="chaosInput")
    def chaos_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosInput"))

    @builtins.property
    @jsii.member(jsii_name="chaosVarInput")
    def chaos_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosVarInput"))

    @builtins.property
    @jsii.member(jsii_name="densityInput")
    def density_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityInput"))

    @builtins.property
    @jsii.member(jsii_name="densityVarInput")
    def density_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="powerInput")
    def power_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerInput"))

    @builtins.property
    @jsii.member(jsii_name="powerVarInput")
    def power_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerVarInput"))

    @builtins.property
    @jsii.member(jsii_name="seedInput")
    def seed_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedInput"))

    @builtins.property
    @jsii.member(jsii_name="seedVarInput")
    def seed_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedVarInput"))

    @builtins.property
    @jsii.member(jsii_name="chaos")
    def chaos(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaos"))

    @chaos.setter
    def chaos(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__630ecf7c04c195283bc396213784562d02953a1e797916456dd349e73d1c1911)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaos", value)

    @builtins.property
    @jsii.member(jsii_name="chaosVar")
    def chaos_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaosVar"))

    @chaos_var.setter
    def chaos_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2968c90f660321b59ce2de3bb06e806bf0e0f948efe05a05c514aa6251edf5f5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaosVar", value)

    @builtins.property
    @jsii.member(jsii_name="density")
    def density(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "density"))

    @density.setter
    def density(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__486243c59431bf11e093da232c803265a7904d8d5f4a47cb446d957e7d7eeadd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "density", value)

    @builtins.property
    @jsii.member(jsii_name="densityVar")
    def density_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "densityVar"))

    @density_var.setter
    def density_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__853cd51203b2ff5b44ffaa42a30fba323adb286228f64bff704ee9a325a60921)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "densityVar", value)

    @builtins.property
    @jsii.member(jsii_name="power")
    def power(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "power"))

    @power.setter
    def power(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f351e2f017f9e707cb7ac98c634f33e18b9837c25884d005f3017d5a0b479423)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "power", value)

    @builtins.property
    @jsii.member(jsii_name="powerVar")
    def power_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "powerVar"))

    @power_var.setter
    def power_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__280bd3cd7320c385d0c4aa3175ede49bf41ede1bd75a642d3ce79b48372c4aeb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "powerVar", value)

    @builtins.property
    @jsii.member(jsii_name="seed")
    def seed(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seed"))

    @seed.setter
    def seed(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__31464702e6016b21830a75fd2bfca310452c7c86f7c61fe57a8f292b3f15ed6b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seed", value)

    @builtins.property
    @jsii.member(jsii_name="seedVar")
    def seed_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seedVar"))

    @seed_var.setter
    def seed_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ebefdf06c5287aa23c4cd3d2e9ebc133cb695a4a839c2d9bba74024baf0cfad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seedVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualGoop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualGoop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualGoop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0b396ebd5c9c9db4af4ae49582d3099cd721854f284af2c72670aa913518f512)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualGrayscale",
    jsii_struct_bases=[],
    name_mapping={"type": "type", "type_var": "typeVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualGrayscale:
    def __init__(
        self,
        *,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param type: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3922ef640714c97f76ec81ad51805108d5b457c2ef199d8890674887fee9a4b2)
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualGrayscale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualGrayscaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualGrayscaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__038ca998d4dc838be83d2757292b451a823164159269196079e86243fa6a6b39)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualGrayscaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2f0b1e689d844df20ea89454513faf9636aa4d836d33d829b406e891f33c7a52)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualGrayscaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d79293da3eef22a6ae2c93ab018dbc31037eb03659f7e7d73e3bc6dc37db1bcb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e52bb3b6b64883f6ed6ebb07f54a6d6cd6de2e831dd3c341b572a4ffd6bbf784)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e955d007f82613a00819a58b3ea63042079fc6dcdb14a5cee0b7df6f5aacbd0e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualGrayscale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualGrayscale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c04683bb39eea9cf57c924e479e8557494814a7a11fdeafb1b4df18d0e6cca6b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualGrayscaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualGrayscaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2fe479277a83689d469f3d3e7951df072f57635c45de8460e0b6bc5981b041a3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5d5e66c687ce97dc7eba8f54bff973ae0bdf700d2de7fea5bea6531ddbde996f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d59ec7df523ee6186929bd3dd18773e6e701303c9b5b4ea2566b3116f4e060e4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualGrayscale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualGrayscale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualGrayscale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__526316e996e6c8a7eeedc7e95a4eb662409e3d4c8ddf884a16b1d8c143b17d16)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualHsl",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "lightness": "lightness",
        "lightness_var": "lightnessVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualHsl:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness: typing.Optional[builtins.str] = None,
        lightness_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        :param lightness_var: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5efc94ef5abffd624b535d7a6cf995948ef7446aba81d584d5f8733f120f3e0f)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness", value=lightness, expected_type=type_hints["lightness"])
            check_type(argname="argument lightness_var", value=lightness_var, expected_type=type_hints["lightness_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness is not None:
            self._values["lightness"] = lightness
        if lightness_var is not None:
            self._values["lightness_var"] = lightness_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        '''
        result = self._values.get("lightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        '''
        result = self._values.get("lightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualHsl(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualHslList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualHslList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a6ab0638580e5516f4d5959d7d13952e3b39d0e31f202944d4d38c40bda875c5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualHslOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__32be4ecd28ac91b3a178d1d49c053c951674bde750fba9dd1487458b1acc82bd)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualHslOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4702c8de7053dc258d6f54fea038a336562e175428a6850f9e144191a2cbdcd0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d80f3da17423bc13e01e8a6c96b5154f4510eb96a5841315955941e173823084)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d3c175d82f83f0865639c50429c8b4c968f828dfefba9649444ca4ef2477558b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualHsl]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualHsl]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc36d9ce722c14ffcbc5236eba8b23d146eeeaf3845d467c11142a80a9822192)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualHslOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualHslOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b9b4207cc1e17ab1d48ccc21a9f1414af7221f1e1cd31fc302df65d759427a9f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightness")
    def reset_lightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightness", []))

    @jsii.member(jsii_name="resetLightnessVar")
    def reset_lightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessInput")
    def lightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessVarInput")
    def lightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a31c911c2d4a4cda9b26c21a7d6d5ee5aac1ded8fd3f7738ee9c05adf7a4764f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2aa4cd8102c6c134787938ad874091f00ff146072473416b5e4cec69c136a650)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightness")
    def lightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightness"))

    @lightness.setter
    def lightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c4ee716838aa0fe8a0e33eab27996337a592c6b79077b3ed2e4970286ac50dca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightness", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessVar")
    def lightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessVar"))

    @lightness_var.setter
    def lightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__25b1a9efcc02fad7fcfb3ec4d630c99e2bc32b16e51a0275ca01ca54decdb220)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__23274d1132f719a23604f3f64ca3b6819ef5b62c4929f7d98a2ffa79e38a6b61)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bac578f81f7fb469b7b903a0e2474ba5949c33106093f73bae83a1c2c2a4b3bd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualHsl]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualHsl]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualHsl]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__625d10888367815865e4b8278f3943efd65bf0df4e681e2a5739d89708b674ff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualHsv",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualHsv:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        :param value: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b05e776cd4cf29036932cfae475404f993cf299d3b617d92f3b1ac647ca093cf)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualHsv(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualHsvList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualHsvList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__075079ec9550557ddc3a0c9721d169c14cfefc6579d9e9e0ebb914a4bfe7b778)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualHsvOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__40ddd0fe075235a1350a246219abbb9a0b4db7e1835464ce8e405837a42cb84b)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualHsvOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__618139e6d2f91137063a86051ed7b7b6395ea9587d251378c52b7469bf751603)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__06356c3f1b7a2675f9e9075f0e929349a8a8657bb0c74b5aae093ccdd300a95d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__00ff6a261f9502a79a45130b3e20a8fa8a8b6b08353917ef11193f68ea95fb22)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualHsv]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualHsv]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b1538a225f9ad2c9ddd021520ea3570d3400aaae2033d9e14b20fc8c21b7dbd3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualHsvOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualHsvOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d2066ac311ef7d8889bec5a17e1da22c2459aba34b79993b6c11874776bef7fb)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__efc8f1535f36967a46e04374af07473e0dac1106562b8197c3fd83d546cbd5d3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2e54b528a143bcdad002a159ff1e025545b77a38a965305e873025f7f00ee834)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af728854c3706d17c7878238b277fff4f92df9879dbfe9371abe73c5dbd158c8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1913716aab9646031d7a6f6ef5410abe657355213f0445a09432a4be615b6b86)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__51483882fb7f9b0d674ff1642cf70b581fdb6001821cb9781497732f584cc503)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a9121c3adce8c46ee7ba86e08651e6e0ac71b4f9af0f5d450f63c1964591310)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualHsv]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualHsv]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualHsv]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2c84173be1b61fd5150f0070a590191d39d5be20f8135e93d9c4dcaa37c749c3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfDimension",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "dimension": "dimension",
        "dimension_var": "dimensionVar",
        "equal": "equal",
        "greater_than": "greaterThan",
        "less_than": "lessThan",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfDimension:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfDimensionDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        dimension: typing.Optional[builtins.str] = None,
        dimension_var: typing.Optional[builtins.str] = None,
        equal: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfDimensionEqual", typing.Dict[builtins.str, typing.Any]]] = None,
        greater_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfDimensionGreaterThan", typing.Dict[builtins.str, typing.Any]]] = None,
        less_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfDimensionLessThan", typing.Dict[builtins.str, typing.Any]]] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param dimension: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        :param dimension_var: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        :param equal: equal block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        :param greater_than: greater_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        :param less_than: less_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        :param value: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfDimensionDefault(**default)
        if isinstance(equal, dict):
            equal = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfDimensionEqual(**equal)
        if isinstance(greater_than, dict):
            greater_than = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfDimensionGreaterThan(**greater_than)
        if isinstance(less_than, dict):
            less_than = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfDimensionLessThan(**less_than)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__393381a9612b44cc92a765d6989896433e9cf1ad4d970a2b100164bc69d48331)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument dimension", value=dimension, expected_type=type_hints["dimension"])
            check_type(argname="argument dimension_var", value=dimension_var, expected_type=type_hints["dimension_var"])
            check_type(argname="argument equal", value=equal, expected_type=type_hints["equal"])
            check_type(argname="argument greater_than", value=greater_than, expected_type=type_hints["greater_than"])
            check_type(argname="argument less_than", value=less_than, expected_type=type_hints["less_than"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if dimension is not None:
            self._values["dimension"] = dimension
        if dimension_var is not None:
            self._values["dimension_var"] = dimension_var
        if equal is not None:
            self._values["equal"] = equal
        if greater_than is not None:
            self._values["greater_than"] = greater_than
        if less_than is not None:
            self._values["less_than"] = less_than
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfDimensionDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfDimensionDefault"], result)

    @builtins.property
    def dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        '''
        result = self._values.get("dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        '''
        result = self._values.get("dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def equal(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfDimensionEqual"]:
        '''equal block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        '''
        result = self._values.get("equal")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfDimensionEqual"], result)

    @builtins.property
    def greater_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfDimensionGreaterThan"]:
        '''greater_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        '''
        result = self._values.get("greater_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfDimensionGreaterThan"], result)

    @builtins.property
    def less_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfDimensionLessThan"]:
        '''less_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        '''
        result = self._values.get("less_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfDimensionLessThan"], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfDimension(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfDimensionDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfDimensionDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfDimensionDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfDimensionDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfDimensionDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__93beca5718e44d258462ec2f179fb1f42b83b6cec71088efef80cd0ea7c876cf)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfDimensionDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfDimensionDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__99716a03e742139aefd6a55da66c25a78a99c1bc706bf290b40ba906fab58f6b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfDimensionEqual",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfDimensionEqual:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfDimensionEqual(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfDimensionEqualOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfDimensionEqualOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__77bf4ae68ce960147ba231452b021c5cbfb45a336e3cd6724b7280b360286022)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfDimensionEqual], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfDimensionEqual],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__85512f86e57f71c746f5845c1fc6414ff8aa9e878981f2dc5676c7698eb68bff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfDimensionGreaterThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfDimensionGreaterThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfDimensionGreaterThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfDimensionGreaterThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfDimensionGreaterThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ede1d7adf6e7ddb2ba8786f7f74a5857f1b1c7795edd91ce1ef6e19f2e687486)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfDimensionGreaterThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfDimensionGreaterThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aca8354e0175a18d419a811e8fd56b935ec1d8c10348ce0eb4bb790525a81f07)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfDimensionLessThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfDimensionLessThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfDimensionLessThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfDimensionLessThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfDimensionLessThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fbf665f8ba9fc1542f3b7e705b289451efd373d3d8c84dedd05e27eca079a0d4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfDimensionLessThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfDimensionLessThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d9bb44ecd2435288fa3fcf024081404dd5131a8e2beaadf03fcb2987ae000ec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfDimensionList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfDimensionList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0058909db05be213c6a0107dd51e4779d443187cd6c3ebdf8e566d0af5b2f52f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfDimensionOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__20e1224d4ee614c799b162a2e46d35167f6568008cae2019f8ef37631fe52aa0)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfDimensionOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d86471e8f8a3c2d4ed5310a3a5383fa88bc6468c565e9f72d1e219cd9801816c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__84831047ca5555e714dc6f0de928dd35e45bcbc3b931c959e40f2daacd726823)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4187e40fc369ebfc7793b6d56bb1533649839206ee4061ebd4139862594e1253)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfDimension]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfDimension]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9694589a4b5a10d6dab769399db9bc1d711ea84b170595b08b73df44420a4a76)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfDimensionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfDimensionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__12a3bc55b14ce0333ec79fc47063e008b233fd54f3df0e9f59b9b5bd126ae959)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfDimensionDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putEqual")
    def put_equal(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfDimensionEqual()

        return typing.cast(None, jsii.invoke(self, "putEqual", [value]))

    @jsii.member(jsii_name="putGreaterThan")
    def put_greater_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfDimensionGreaterThan()

        return typing.cast(None, jsii.invoke(self, "putGreaterThan", [value]))

    @jsii.member(jsii_name="putLessThan")
    def put_less_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfDimensionLessThan()

        return typing.cast(None, jsii.invoke(self, "putLessThan", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetDimension")
    def reset_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimension", []))

    @jsii.member(jsii_name="resetDimensionVar")
    def reset_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimensionVar", []))

    @jsii.member(jsii_name="resetEqual")
    def reset_equal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEqual", []))

    @jsii.member(jsii_name="resetGreaterThan")
    def reset_greater_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGreaterThan", []))

    @jsii.member(jsii_name="resetLessThan")
    def reset_less_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLessThan", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfDimensionDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfDimensionDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="equal")
    def equal(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfDimensionEqualOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfDimensionEqualOutputReference, jsii.get(self, "equal"))

    @builtins.property
    @jsii.member(jsii_name="greaterThan")
    def greater_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfDimensionGreaterThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfDimensionGreaterThanOutputReference, jsii.get(self, "greaterThan"))

    @builtins.property
    @jsii.member(jsii_name="lessThan")
    def less_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfDimensionLessThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfDimensionLessThanOutputReference, jsii.get(self, "lessThan"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfDimensionDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionInput")
    def dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionVarInput")
    def dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="equalInput")
    def equal_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfDimensionEqual], jsii.get(self, "equalInput"))

    @builtins.property
    @jsii.member(jsii_name="greaterThanInput")
    def greater_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfDimensionGreaterThan], jsii.get(self, "greaterThanInput"))

    @builtins.property
    @jsii.member(jsii_name="lessThanInput")
    def less_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfDimensionLessThan], jsii.get(self, "lessThanInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="dimension")
    def dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimension"))

    @dimension.setter
    def dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e9f49685f41cb07e489d35797dfd271eca190f76b024fd00fdfdb07a4ad58c0b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimension", value)

    @builtins.property
    @jsii.member(jsii_name="dimensionVar")
    def dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimensionVar"))

    @dimension_var.setter
    def dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab80b4a3862bc176081e77ed653f998745476e9ed5416aaa4feee10b899ac80c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bfaf1c4650604df100d22c0ccbc326ef61ab5d1fe6539781630183dfb7ef0785)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1315a357c4baa971b25580094b2a18b283415065ff78c929d87d00e483964591)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfDimension]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfDimension]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfDimension]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a168f41be41f52274b955cdc72a9361cb659987704164a2059909b13a99125a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfOrientation",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "landscape": "landscape",
        "portrait": "portrait",
        "square": "square",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfOrientation:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfOrientationDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        landscape: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfOrientationLandscape", typing.Dict[builtins.str, typing.Any]]] = None,
        portrait: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfOrientationPortrait", typing.Dict[builtins.str, typing.Any]]] = None,
        square: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfOrientationSquare", typing.Dict[builtins.str, typing.Any]]] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param landscape: landscape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        :param portrait: portrait block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        :param square: square block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfOrientationDefault(**default)
        if isinstance(landscape, dict):
            landscape = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfOrientationLandscape(**landscape)
        if isinstance(portrait, dict):
            portrait = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfOrientationPortrait(**portrait)
        if isinstance(square, dict):
            square = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfOrientationSquare(**square)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b8cbeba8507808a157c94266848e546db6745718c7544ca61fc86bd8594b745f)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument landscape", value=landscape, expected_type=type_hints["landscape"])
            check_type(argname="argument portrait", value=portrait, expected_type=type_hints["portrait"])
            check_type(argname="argument square", value=square, expected_type=type_hints["square"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if landscape is not None:
            self._values["landscape"] = landscape
        if portrait is not None:
            self._values["portrait"] = portrait
        if square is not None:
            self._values["square"] = square

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfOrientationDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfOrientationDefault"], result)

    @builtins.property
    def landscape(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfOrientationLandscape"]:
        '''landscape block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        '''
        result = self._values.get("landscape")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfOrientationLandscape"], result)

    @builtins.property
    def portrait(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfOrientationPortrait"]:
        '''portrait block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        '''
        result = self._values.get("portrait")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfOrientationPortrait"], result)

    @builtins.property
    def square(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfOrientationSquare"]:
        '''square block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        result = self._values.get("square")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfOrientationSquare"], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfOrientation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfOrientationDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfOrientationDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfOrientationDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfOrientationDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfOrientationDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5d09d4cfc52e41d86d4bfd03257fc85a5201fd79f83155db803ea82fe181bab2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfOrientationDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfOrientationDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__31ec7e3a0c9abffa4986252a0d6288292ef79bb14ad0170b8213e803a933e27b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfOrientationLandscape",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfOrientationLandscape:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfOrientationLandscape(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfOrientationLandscapeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfOrientationLandscapeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__49e08f40c5d5e406364b12a933b1a2c9f8258c8d552c97953b8b363db0a5643b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfOrientationLandscape], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfOrientationLandscape],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a84524810c5ff3075be5cb100b7e4c86c58387195626ea70b6d03b59538697d8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfOrientationList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfOrientationList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2607438c7a9fe037289d3472863dbb8ddd0749806a9a54b76b08871c1a65b59d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfOrientationOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6b455416b8554492e5652b0d3d9f637ed2aae704e4315563728bbf8690bec86e)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfOrientationOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__16757d96796e610222ea8505353c552d94f46396bff4d5d3e0b797d6382d4157)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e32fa223cf60afeb5e4996b33d86d60f472b5492a56f022279c19f4fcfbd2f88)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f9cf0feac87d6f58c5ddc66d77f695c618649611bf4cab138ae3b662be6d63a2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfOrientation]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfOrientation]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__202d2b69bd6b63562a670ce582f540e33290f5c498a7e9fa3e586a54041b59c1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfOrientationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfOrientationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1c43b196495471024d60bdc3d91190cd43b59ffaf2dcd4caaee700532226dd42)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfOrientationDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putLandscape")
    def put_landscape(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfOrientationLandscape()

        return typing.cast(None, jsii.invoke(self, "putLandscape", [value]))

    @jsii.member(jsii_name="putPortrait")
    def put_portrait(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfOrientationPortrait()

        return typing.cast(None, jsii.invoke(self, "putPortrait", [value]))

    @jsii.member(jsii_name="putSquare")
    def put_square(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfOrientationSquare()

        return typing.cast(None, jsii.invoke(self, "putSquare", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetLandscape")
    def reset_landscape(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLandscape", []))

    @jsii.member(jsii_name="resetPortrait")
    def reset_portrait(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPortrait", []))

    @jsii.member(jsii_name="resetSquare")
    def reset_square(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSquare", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfOrientationDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfOrientationDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="landscape")
    def landscape(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfOrientationLandscapeOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfOrientationLandscapeOutputReference, jsii.get(self, "landscape"))

    @builtins.property
    @jsii.member(jsii_name="portrait")
    def portrait(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfOrientationPortraitOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfOrientationPortraitOutputReference", jsii.get(self, "portrait"))

    @builtins.property
    @jsii.member(jsii_name="square")
    def square(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfOrientationSquareOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfOrientationSquareOutputReference", jsii.get(self, "square"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfOrientationDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="landscapeInput")
    def landscape_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfOrientationLandscape], jsii.get(self, "landscapeInput"))

    @builtins.property
    @jsii.member(jsii_name="portraitInput")
    def portrait_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfOrientationPortrait"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfOrientationPortrait"], jsii.get(self, "portraitInput"))

    @builtins.property
    @jsii.member(jsii_name="squareInput")
    def square_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfOrientationSquare"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfOrientationSquare"], jsii.get(self, "squareInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfOrientation]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfOrientation]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfOrientation]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f6e1e14d136b88d7f6ccc8de41d04d7e451aedc4ac82416552f30802c0c5485f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfOrientationPortrait",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfOrientationPortrait:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfOrientationPortrait(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfOrientationPortraitOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfOrientationPortraitOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8e78ab5c85cc42b145b31c7905d06aab16be24139a8e8977ec760dd62697a9cb)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfOrientationPortrait]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfOrientationPortrait], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfOrientationPortrait],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e14356f06639e21a786fb7df786c7f6562a8c1fdff2de26af428acf9fe4a4f16)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfOrientationSquare",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfOrientationSquare:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfOrientationSquare(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfOrientationSquareOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfOrientationSquareOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__47fda28d6d07b504d4b7e0f2557d9b5c9540cbdd19422985d2b3359d86ef7bb9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfOrientationSquare]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfOrientationSquare], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfOrientationSquare],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c64eb98546480325da6db54dafb264cca619af92c0c978e8cc2d1a37f62aa984)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualMaxColors",
    jsii_struct_bases=[],
    name_mapping={"colors": "colors", "colors_var": "colorsVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualMaxColors:
    def __init__(
        self,
        *,
        colors: typing.Optional[builtins.str] = None,
        colors_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param colors: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        :param colors_var: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4126fb5d0cfd8d46a80f83f3978255b7905e1a59f0a2a2e725b6d988b2916c29)
            check_type(argname="argument colors", value=colors, expected_type=type_hints["colors"])
            check_type(argname="argument colors_var", value=colors_var, expected_type=type_hints["colors_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if colors is not None:
            self._values["colors"] = colors
        if colors_var is not None:
            self._values["colors_var"] = colors_var

    @builtins.property
    def colors(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        '''
        result = self._values.get("colors")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def colors_var(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        result = self._values.get("colors_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualMaxColors(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualMaxColorsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualMaxColorsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b929ae7bbee4d919749e876a606f06ab5322bc471fc97998f9c6f87cb0b33b1e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualMaxColorsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b483239be98393d60b5f43e97d490b583f654e2b14b14a3a23a4b0593d6fe88a)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualMaxColorsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dc17bc50a51d557c5143e10ebf031fe747c52897fc0fa763247230de3aa43c26)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e975894d6e4ac9ed36921b678a5256c65d7050aa15ea840379aefbda88dab591)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ba5622b666ea5c6666fc548a3bbf0a12873fac175ae5d0b9e40f26c09906b7f8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualMaxColors]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualMaxColors]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8db8a68484ac1dd8247ba414b37ec65c41c716b43e933641aa7dfa75397367b1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualMaxColorsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualMaxColorsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b49b7635779983c42aa984b079e33df9a97abd54a5ed269c7f78355f3d70b799)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColors")
    def reset_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColors", []))

    @jsii.member(jsii_name="resetColorsVar")
    def reset_colors_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorsVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorsInput")
    def colors_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsInput"))

    @builtins.property
    @jsii.member(jsii_name="colorsVarInput")
    def colors_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsVarInput"))

    @builtins.property
    @jsii.member(jsii_name="colors")
    def colors(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colors"))

    @colors.setter
    def colors(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a61cf7fdc560caee4a0acbca6e76a27c42645ebdab008d400e209b4f6c973bdb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colors", value)

    @builtins.property
    @jsii.member(jsii_name="colorsVar")
    def colors_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorsVar"))

    @colors_var.setter
    def colors_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c5677ef701ffff1ee4eaee5e2246fe355c255eb80126019cb64291d4f3575cc6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorsVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualMaxColors]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualMaxColors]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualMaxColors]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a64e3a7d4b0e6ae584e572d38f44bfb34e725e40c2d2bd55a916ccfccf4e6c14)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualMirror",
    jsii_struct_bases=[],
    name_mapping={
        "horizontal": "horizontal",
        "horizontal_var": "horizontalVar",
        "vertical": "vertical",
        "vertical_var": "verticalVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualMirror:
    def __init__(
        self,
        *,
        horizontal: typing.Optional[builtins.str] = None,
        horizontal_var: typing.Optional[builtins.str] = None,
        vertical: typing.Optional[builtins.str] = None,
        vertical_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param horizontal: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        :param horizontal_var: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        :param vertical: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        :param vertical_var: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__743c257a8be1e456f95f1f2eca3ae383a30d6821a0d58bd64f1835b3732965ef)
            check_type(argname="argument horizontal", value=horizontal, expected_type=type_hints["horizontal"])
            check_type(argname="argument horizontal_var", value=horizontal_var, expected_type=type_hints["horizontal_var"])
            check_type(argname="argument vertical", value=vertical, expected_type=type_hints["vertical"])
            check_type(argname="argument vertical_var", value=vertical_var, expected_type=type_hints["vertical_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if horizontal is not None:
            self._values["horizontal"] = horizontal
        if horizontal_var is not None:
            self._values["horizontal_var"] = horizontal_var
        if vertical is not None:
            self._values["vertical"] = vertical
        if vertical_var is not None:
            self._values["vertical_var"] = vertical_var

    @builtins.property
    def horizontal(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        '''
        result = self._values.get("horizontal")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def horizontal_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        '''
        result = self._values.get("horizontal_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        '''
        result = self._values.get("vertical")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        result = self._values.get("vertical_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualMirror(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualMirrorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualMirrorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e5c07ab45a9694690f214956cf9f2e8aed72ef236b9697e9d7fc33cb369a5ca7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualMirrorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d6b41be91419bf9bbb3ff725d6e7b89b307efadf7bb34ad7eb41cf689a23529a)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualMirrorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f866452db93ac6583565fb3d6479e17788ad9f09ca8d6b0e73c0c538c08a001)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2313203f41fb383a556e335c7f090698f322f53a1576f8ced5ceaae8b42b7ef1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0716e015dbc55811bbfcbfbe2b5826dd03f1dc95ed763513af227cc43e3e62d5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualMirror]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualMirror]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5615ff8e4920143d7115d044b08fd5302e2b437d082ff77bb59bbc793de304dc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualMirrorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualMirrorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab35a3a81ca1edae15bde52a8f605073ae17939f248f9326692c6b59e19a8951)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHorizontal")
    def reset_horizontal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontal", []))

    @jsii.member(jsii_name="resetHorizontalVar")
    def reset_horizontal_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontalVar", []))

    @jsii.member(jsii_name="resetVertical")
    def reset_vertical(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVertical", []))

    @jsii.member(jsii_name="resetVerticalVar")
    def reset_vertical_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVerticalVar", []))

    @builtins.property
    @jsii.member(jsii_name="horizontalInput")
    def horizontal_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontalVarInput")
    def horizontal_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalInput")
    def vertical_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalVarInput")
    def vertical_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontal")
    def horizontal(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontal"))

    @horizontal.setter
    def horizontal(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__17b927657385589ef0455e0572d445e0b9c1941d74f95ab2b4dc1940299808ee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontal", value)

    @builtins.property
    @jsii.member(jsii_name="horizontalVar")
    def horizontal_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontalVar"))

    @horizontal_var.setter
    def horizontal_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b76a463243788d144a336b10da27bb9df3eee5906f3546ef01f0da4ed3587cff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontalVar", value)

    @builtins.property
    @jsii.member(jsii_name="vertical")
    def vertical(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "vertical"))

    @vertical.setter
    def vertical(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2746a97b3c2e4d2d2a42c63267cb5eba12a4d241422b06dfa8baf2d331eb1760)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "vertical", value)

    @builtins.property
    @jsii.member(jsii_name="verticalVar")
    def vertical_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "verticalVar"))

    @vertical_var.setter
    def vertical_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__492ff1280e2a3360c380c824af634546a31bcf3efd21e9246be8672031160501)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "verticalVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualMirror]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualMirror]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualMirror]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__11967942b83abe352de4d616d4d328c78e461b8bc5c318a070b11c69049c999e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualMonoHue",
    jsii_struct_bases=[],
    name_mapping={"hue": "hue", "hue_var": "hueVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualMonoHue:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cf4c78e2bad5f808ad586f76dc186f40a57e0f88afbf18d36fc83867c1e8a9e7)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualMonoHue(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualMonoHueList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualMonoHueList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a9dafa35ab57feba01bb2b988bd5d5f1620b8d1d3818d360623b29dc9e4dc543)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualMonoHueOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__76b5f66becd7c9ac92f14a702ded294a1be696d93c4affde018f500c43e38c7e)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualMonoHueOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ae1c818f828871d93a4182262345657d68699172c8fba664069389aac0ea66cf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__debe4ebf8ea72a6c2bf6bdfe504b75499976e528c8923cc387a6ef6dfb7c6898)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5d89403a9e0d015653d68760ec3c3ab73e23d3fdb018e9894b09e409779f9cec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualMonoHue]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualMonoHue]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2130998f4bb2d77aceae32945ef1daa5f7bd4b3d011851ba876f78b6d74b3c1f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualMonoHueOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualMonoHueOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9539607b11ceb4ef789bbb84fc13208fffc5e7f5fd76d98dc22573e3393e77fd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c9d005468c6d216b14480794fe656ff024b826f1b7b0cfe87ad1b3ae05e871f8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4c39c4bdaa9f69249834e1a199fd82e5738feecea4528d77c38d18b3f76bad75)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualMonoHue]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualMonoHue]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualMonoHue]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__31fa2573474656a9118531fdd3c4a4a3846e740b4d73d77c5cbcb4a6bf015221)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualOpacity",
    jsii_struct_bases=[],
    name_mapping={"opacity": "opacity", "opacity_var": "opacityVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualOpacity:
    def __init__(
        self,
        *,
        opacity: typing.Optional[builtins.str] = None,
        opacity_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param opacity: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param opacity_var: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__58ff3b7d561b1df03162a844d3eb5d882563abd553d23ffcfa346643f6fc13b2)
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument opacity_var", value=opacity_var, expected_type=type_hints["opacity_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if opacity is not None:
            self._values["opacity"] = opacity
        if opacity_var is not None:
            self._values["opacity_var"] = opacity_var

    @builtins.property
    def opacity(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def opacity_var(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        result = self._values.get("opacity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualOpacity(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualOpacityList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualOpacityList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__20f972b3a5a9adf078510321969c71dc0240f19ec15392d25c32490bd8a35351)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualOpacityOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__61946d346fafca1ef35c8f31b3f070d3d958b3b3ff55aa7e8be6875493fb76c1)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualOpacityOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__804667386b326089093a395184d04ca48c55af6f1fbb5252c533a9f48326dd31)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e495ae510f6dce857edbb4ec85e3b55fe4a8d7f0b6e1524abc831b44ac3a364d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ce48b1dc4a6452db77bb0a59fe3dbdd80b03385d6f99364b5e74665956ae71b7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualOpacity]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualOpacity]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__262459e2b1e150438e3e18b08c6348740c8c3e1869bd256af8e3d74eb58a144d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualOpacityOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualOpacityOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ed37032866c535de218ea19fd9fe4cd35756e1c2d2bb462675d89172bf39eb6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetOpacityVar")
    def reset_opacity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacityVar", []))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityVarInput")
    def opacity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacity"))

    @opacity.setter
    def opacity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1ed7242615fe3f628e073238d37b47944e664f6633bd8ecacde47a75db576068)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacity", value)

    @builtins.property
    @jsii.member(jsii_name="opacityVar")
    def opacity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacityVar"))

    @opacity_var.setter
    def opacity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8bd5d26a85ca461d07d6b145a633a506bc8f2d8f080d31a74a877d106eedd8df)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacityVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualOpacity]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualOpacity]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualOpacity]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__860810813a63255c48f1f4b4cae1e75d9017b69606eb6743d11046bbd27d09b0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__83f0bc5d17b70e1784a98f17cb29d341b4487b13a6425b1a8718f2f9b5ecf934)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putBackgroundColor")
    def put_background_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e8a3ef6ef809ed43564b498588a8899b4ea2cfc43316acc538314c5e06390cd1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBackgroundColor", [value]))

    @jsii.member(jsii_name="putBlur")
    def put_blur(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualBlur, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__58c1045ae84e212f1f2e5d570c0f9271ae9b4f71bccd7af68d1e792087054a2b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBlur", [value]))

    @jsii.member(jsii_name="putChromaKey")
    def put_chroma_key(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualChromaKey, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__830c9484038377a8fc1fd8c759e5ba2acd6c6580eeed64b6bdc70b72e220ea7d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putChromaKey", [value]))

    @jsii.member(jsii_name="putComposite")
    def put_composite(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualComposite, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f17cefd46061d1a02b2537d56745a94105e490e6ceb1d4eac7176bef0155ad57)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putComposite", [value]))

    @jsii.member(jsii_name="putCompound")
    def put_compound(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualCompound, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__302fa87b13ac674839536104bb66659c490310c64ddde3c95db3d5782b668f64)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCompound", [value]))

    @jsii.member(jsii_name="putContrast")
    def put_contrast(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualContrast, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__19cf4352336262df202b941b7f1568b2ed9c8e5b581da7ea7c8f2cfefaee35a0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putContrast", [value]))

    @jsii.member(jsii_name="putGoop")
    def put_goop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualGoop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cc1d2b5ff1b102bddfb2aff3aee9acbf9f3da85751f27db340f1b9bdb5b5f81f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGoop", [value]))

    @jsii.member(jsii_name="putGrayscale")
    def put_grayscale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualGrayscale, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a90e6454c61f6798b5e7e47c905d805be515690f1a8f6183fc815c34d20f44d6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGrayscale", [value]))

    @jsii.member(jsii_name="putHsl")
    def put_hsl(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualHsl, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__27f0b81db523e78e8902cc6a8c45afba7dd4d3df6dd9d0b116996ae36e1746b8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsl", [value]))

    @jsii.member(jsii_name="putHsv")
    def put_hsv(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualHsv, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8373a635706e2c39f1dfe4aca1c3fdca017548b8e16c4dfa24e2727e14fe9a92)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsv", [value]))

    @jsii.member(jsii_name="putIfDimension")
    def put_if_dimension(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfDimension, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__78b661d08d53b45d15a2d4fc6403a8405d332099f3259d8aab2077c4030d54bc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfDimension", [value]))

    @jsii.member(jsii_name="putIfOrientation")
    def put_if_orientation(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f28ff92de3131cbec7eed0f38c2d09bb29f4c703dc87d0c9339755e85a61186d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfOrientation", [value]))

    @jsii.member(jsii_name="putMaxColors")
    def put_max_colors(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualMaxColors, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5b817a89bd086bfdc464395e438762df99831bb0c2e6e21cc02ed4d1ccd28882)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMaxColors", [value]))

    @jsii.member(jsii_name="putMirror")
    def put_mirror(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualMirror, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__18df0989cc018440e2d1e9804cb4e056ccb51ce4402b3ab43849478419f91296)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMirror", [value]))

    @jsii.member(jsii_name="putMonoHue")
    def put_mono_hue(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualMonoHue, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__940c1e5da25f23566897b649a95e5d9e72a71e4de5536afb6bd21e3295f9f449)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMonoHue", [value]))

    @jsii.member(jsii_name="putOpacity")
    def put_opacity(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualOpacity, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__60b36d07b3d33428b3cb80d9b367c86c7e046c20fa5b86f3572783136446df0a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putOpacity", [value]))

    @jsii.member(jsii_name="putRemoveColor")
    def put_remove_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualRemoveColor", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3b87873fb2b5329c5b163ff0afad6c7ce534b0c3a0ef2126be77da3768c5ed5f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRemoveColor", [value]))

    @jsii.member(jsii_name="putUnsharpMask")
    def put_unsharp_mask(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualUnsharpMask", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__10172b6e6faf6e282c8a7ad0645d05a39ddd645535216725035666a85e0f6682)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putUnsharpMask", [value]))

    @jsii.member(jsii_name="resetBackgroundColor")
    def reset_background_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBackgroundColor", []))

    @jsii.member(jsii_name="resetBlur")
    def reset_blur(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBlur", []))

    @jsii.member(jsii_name="resetChromaKey")
    def reset_chroma_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChromaKey", []))

    @jsii.member(jsii_name="resetComposite")
    def reset_composite(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetComposite", []))

    @jsii.member(jsii_name="resetCompound")
    def reset_compound(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCompound", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetGoop")
    def reset_goop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGoop", []))

    @jsii.member(jsii_name="resetGrayscale")
    def reset_grayscale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGrayscale", []))

    @jsii.member(jsii_name="resetHsl")
    def reset_hsl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsl", []))

    @jsii.member(jsii_name="resetHsv")
    def reset_hsv(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsv", []))

    @jsii.member(jsii_name="resetIfDimension")
    def reset_if_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfDimension", []))

    @jsii.member(jsii_name="resetIfOrientation")
    def reset_if_orientation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfOrientation", []))

    @jsii.member(jsii_name="resetMaxColors")
    def reset_max_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxColors", []))

    @jsii.member(jsii_name="resetMirror")
    def reset_mirror(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMirror", []))

    @jsii.member(jsii_name="resetMonoHue")
    def reset_mono_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonoHue", []))

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetRemoveColor")
    def reset_remove_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRemoveColor", []))

    @jsii.member(jsii_name="resetUnsharpMask")
    def reset_unsharp_mask(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUnsharpMask", []))

    @builtins.property
    @jsii.member(jsii_name="backgroundColor")
    def background_color(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualBackgroundColorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualBackgroundColorList, jsii.get(self, "backgroundColor"))

    @builtins.property
    @jsii.member(jsii_name="blur")
    def blur(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualBlurList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualBlurList, jsii.get(self, "blur"))

    @builtins.property
    @jsii.member(jsii_name="chromaKey")
    def chroma_key(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualChromaKeyList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualChromaKeyList, jsii.get(self, "chromaKey"))

    @builtins.property
    @jsii.member(jsii_name="composite")
    def composite(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualCompositeList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualCompositeList, jsii.get(self, "composite"))

    @builtins.property
    @jsii.member(jsii_name="compound")
    def compound(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualCompoundList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualCompoundList, jsii.get(self, "compound"))

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualContrastList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualContrastList, jsii.get(self, "contrast"))

    @builtins.property
    @jsii.member(jsii_name="goop")
    def goop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualGoopList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualGoopList, jsii.get(self, "goop"))

    @builtins.property
    @jsii.member(jsii_name="grayscale")
    def grayscale(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualGrayscaleList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualGrayscaleList, jsii.get(self, "grayscale"))

    @builtins.property
    @jsii.member(jsii_name="hsl")
    def hsl(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualHslList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualHslList, jsii.get(self, "hsl"))

    @builtins.property
    @jsii.member(jsii_name="hsv")
    def hsv(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualHsvList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualHsvList, jsii.get(self, "hsv"))

    @builtins.property
    @jsii.member(jsii_name="ifDimension")
    def if_dimension(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfDimensionList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfDimensionList, jsii.get(self, "ifDimension"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientation")
    def if_orientation(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfOrientationList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfOrientationList, jsii.get(self, "ifOrientation"))

    @builtins.property
    @jsii.member(jsii_name="maxColors")
    def max_colors(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualMaxColorsList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualMaxColorsList, jsii.get(self, "maxColors"))

    @builtins.property
    @jsii.member(jsii_name="mirror")
    def mirror(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualMirrorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualMirrorList, jsii.get(self, "mirror"))

    @builtins.property
    @jsii.member(jsii_name="monoHue")
    def mono_hue(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualMonoHueList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualMonoHueList, jsii.get(self, "monoHue"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualOpacityList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualOpacityList, jsii.get(self, "opacity"))

    @builtins.property
    @jsii.member(jsii_name="removeColor")
    def remove_color(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualRemoveColorList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualRemoveColorList", jsii.get(self, "removeColor"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMask")
    def unsharp_mask(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualUnsharpMaskList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualUnsharpMaskList", jsii.get(self, "unsharpMask"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColorInput")
    def background_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualBackgroundColor]]], jsii.get(self, "backgroundColorInput"))

    @builtins.property
    @jsii.member(jsii_name="blurInput")
    def blur_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualBlur]]], jsii.get(self, "blurInput"))

    @builtins.property
    @jsii.member(jsii_name="chromaKeyInput")
    def chroma_key_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualChromaKey]]], jsii.get(self, "chromaKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="compositeInput")
    def composite_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualComposite]]], jsii.get(self, "compositeInput"))

    @builtins.property
    @jsii.member(jsii_name="compoundInput")
    def compound_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualCompound]]], jsii.get(self, "compoundInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualContrast]]], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="goopInput")
    def goop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualGoop]]], jsii.get(self, "goopInput"))

    @builtins.property
    @jsii.member(jsii_name="grayscaleInput")
    def grayscale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualGrayscale]]], jsii.get(self, "grayscaleInput"))

    @builtins.property
    @jsii.member(jsii_name="hslInput")
    def hsl_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualHsl]]], jsii.get(self, "hslInput"))

    @builtins.property
    @jsii.member(jsii_name="hsvInput")
    def hsv_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualHsv]]], jsii.get(self, "hsvInput"))

    @builtins.property
    @jsii.member(jsii_name="ifDimensionInput")
    def if_dimension_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfDimension]]], jsii.get(self, "ifDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientationInput")
    def if_orientation_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfOrientation]]], jsii.get(self, "ifOrientationInput"))

    @builtins.property
    @jsii.member(jsii_name="maxColorsInput")
    def max_colors_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualMaxColors]]], jsii.get(self, "maxColorsInput"))

    @builtins.property
    @jsii.member(jsii_name="mirrorInput")
    def mirror_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualMirror]]], jsii.get(self, "mirrorInput"))

    @builtins.property
    @jsii.member(jsii_name="monoHueInput")
    def mono_hue_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualMonoHue]]], jsii.get(self, "monoHueInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualOpacity]]], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="removeColorInput")
    def remove_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualRemoveColor"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualRemoveColor"]]], jsii.get(self, "removeColorInput"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMaskInput")
    def unsharp_mask_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualUnsharpMask"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualUnsharpMask"]]], jsii.get(self, "unsharpMaskInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqual], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqual],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3e8ab95b14a56f59c259ea5b3388631a77fb5120591c93826cfc865d5f8133e0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualRemoveColor",
    jsii_struct_bases=[],
    name_mapping={
        "color": "color",
        "color_var": "colorVar",
        "feather": "feather",
        "feather_var": "featherVar",
        "tolerance": "tolerance",
        "tolerance_var": "toleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualRemoveColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
        feather: typing.Optional[builtins.str] = None,
        feather_var: typing.Optional[builtins.str] = None,
        tolerance: typing.Optional[builtins.str] = None,
        tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        :param feather: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        :param feather_var: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        :param tolerance: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        :param tolerance_var: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eeb380a40c877e5e6913733de33e13726f45902ace0c739ef7d97765691f789d)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
            check_type(argname="argument feather", value=feather, expected_type=type_hints["feather"])
            check_type(argname="argument feather_var", value=feather_var, expected_type=type_hints["feather_var"])
            check_type(argname="argument tolerance", value=tolerance, expected_type=type_hints["tolerance"])
            check_type(argname="argument tolerance_var", value=tolerance_var, expected_type=type_hints["tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var
        if feather is not None:
            self._values["feather"] = feather
        if feather_var is not None:
            self._values["feather_var"] = feather_var
        if tolerance is not None:
            self._values["tolerance"] = tolerance
        if tolerance_var is not None:
            self._values["tolerance_var"] = tolerance_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        '''
        result = self._values.get("feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather_var(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        '''
        result = self._values.get("feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        '''
        result = self._values.get("tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance_var(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        result = self._values.get("tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualRemoveColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualRemoveColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualRemoveColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__416c7f0fe98098389d29491a5e25ed9d23db518cc31b014a377c6403ad0c7c99)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualRemoveColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__99c8da31d0e188239fa5ccbb92a7840f4404f6109aedd80214031c3081147734)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualRemoveColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__059dd565dc67f364155026dcc64a9abe4a9ab3b681b32a0e55ae02575c42e260)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c724c87dee0c46871c9df187111600a337dd3804ea123e8367e69d09d55ad62d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c0422631af0c4116915899c60a6ab5276f6b4c22a3c69773b8d56832c9f97241)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualRemoveColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualRemoveColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualRemoveColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7c4fe37d4f65159291787f40b9d280cab3c2a0bf2fa3cad84946910f50cbdae1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualRemoveColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualRemoveColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8e4945926d7554e32a2c9e3b4ec4d7255e5faacc90f3327bf79be1419b2fb767)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @jsii.member(jsii_name="resetFeather")
    def reset_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeather", []))

    @jsii.member(jsii_name="resetFeatherVar")
    def reset_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatherVar", []))

    @jsii.member(jsii_name="resetTolerance")
    def reset_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTolerance", []))

    @jsii.member(jsii_name="resetToleranceVar")
    def reset_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featherInput")
    def feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherInput"))

    @builtins.property
    @jsii.member(jsii_name="featherVarInput")
    def feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceInput")
    def tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceVarInput")
    def tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__425ba1d2a34cbf3763f18e00559d2a8efbe3cdea4bc44db0f00a1a80f3833389)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__541310009c511f3de1386abc7cf6003c0cb0e287ee2e57c922a3a86669b56210)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="feather")
    def feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "feather"))

    @feather.setter
    def feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__82bb5b856cd22a9a2b33d6b1349d178120ddadd0930ee0ca23eeb142fddabfd0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "feather", value)

    @builtins.property
    @jsii.member(jsii_name="featherVar")
    def feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featherVar"))

    @feather_var.setter
    def feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5cd8b61dfeb6a1f2951fbef03e7f14a4b9c63857d7924697d756a72ad403159b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featherVar", value)

    @builtins.property
    @jsii.member(jsii_name="tolerance")
    def tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tolerance"))

    @tolerance.setter
    def tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2951ae9c17ee3e86c8539eb24944f522ed6a9f1e309c18619917cd7eccec6eb2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tolerance", value)

    @builtins.property
    @jsii.member(jsii_name="toleranceVar")
    def tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "toleranceVar"))

    @tolerance_var.setter
    def tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4f06d4c647439a88adf15f445db7389c77c42be4635fa858c731633e055eaa2e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "toleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualRemoveColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualRemoveColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualRemoveColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f243e06fb5cd6deb88bc7e3ad31d5de6ebdd3d44cc3e199023ba7826a29fd0f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualUnsharpMask",
    jsii_struct_bases=[],
    name_mapping={
        "gain": "gain",
        "gain_var": "gainVar",
        "sigma": "sigma",
        "sigma_var": "sigmaVar",
        "threshold": "threshold",
        "threshold_var": "thresholdVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualUnsharpMask:
    def __init__(
        self,
        *,
        gain: typing.Optional[builtins.str] = None,
        gain_var: typing.Optional[builtins.str] = None,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
        threshold: typing.Optional[builtins.str] = None,
        threshold_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param gain: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        :param gain_var: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        :param sigma: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        :param threshold: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        :param threshold_var: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__43762e2b5037b0744dc4a4c8432278fbede14dc2762b1811c665c14ec07b7a6f)
            check_type(argname="argument gain", value=gain, expected_type=type_hints["gain"])
            check_type(argname="argument gain_var", value=gain_var, expected_type=type_hints["gain_var"])
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
            check_type(argname="argument threshold", value=threshold, expected_type=type_hints["threshold"])
            check_type(argname="argument threshold_var", value=threshold_var, expected_type=type_hints["threshold_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if gain is not None:
            self._values["gain"] = gain
        if gain_var is not None:
            self._values["gain_var"] = gain_var
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var
        if threshold is not None:
            self._values["threshold"] = threshold
        if threshold_var is not None:
            self._values["threshold_var"] = threshold_var

    @builtins.property
    def gain(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        '''
        result = self._values.get("gain")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gain_var(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        '''
        result = self._values.get("gain_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        '''
        result = self._values.get("threshold")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold_var(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        result = self._values.get("threshold_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualUnsharpMask(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualUnsharpMaskList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualUnsharpMaskList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__189231920890a688b49469c59125561cd390a2455d130e883daa249f4495a159)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualUnsharpMaskOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1dcd3975256822f8273c248a9c701e34cdb0d4f13626187414ee8f4ed3d20226)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualUnsharpMaskOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__97b2e90459c5dd56efb9f893307895e7ab88c73aa5a7032b72ae612fe56ad539)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1db53757cd067d5116102138d8ba19c14dc12554958fc593d8c61d4f8911ef91)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ad7987c0c73e2e3a9e99be5331f1e4d71ebbea968e8db5f15cfae3582ef20401)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualUnsharpMask]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualUnsharpMask]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualUnsharpMask]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e4047c454ade8252ad0a3cef39fabd72634ee06a0f81271838947c44fc509df7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualUnsharpMaskOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualUnsharpMaskOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f5056410bb1dbd09e5cff75bb5b1e8232e751e63baf6b7fbef1cc2b1321093ec)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetGain")
    def reset_gain(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGain", []))

    @jsii.member(jsii_name="resetGainVar")
    def reset_gain_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGainVar", []))

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @jsii.member(jsii_name="resetThreshold")
    def reset_threshold(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThreshold", []))

    @jsii.member(jsii_name="resetThresholdVar")
    def reset_threshold_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThresholdVar", []))

    @builtins.property
    @jsii.member(jsii_name="gainInput")
    def gain_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainInput"))

    @builtins.property
    @jsii.member(jsii_name="gainVarInput")
    def gain_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdInput")
    def threshold_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdVarInput")
    def threshold_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gain")
    def gain(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gain"))

    @gain.setter
    def gain(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0a0df1f01a50982d3f169a1cb78c9a99f0e69e276239bd8da3702ebee2dc6288)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gain", value)

    @builtins.property
    @jsii.member(jsii_name="gainVar")
    def gain_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gainVar"))

    @gain_var.setter
    def gain_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c9efc5679804e36df92ee50a7f59acedf6c35c34dbd13d3440aeccff894e3253)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gainVar", value)

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cfe7d2c2571fd39d9367921a408b04dffb606f535b4c06e5f16f93c563bb6fee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__17397c8c80928b838549742bd244cd04b1a32ce188860a0ec394a48354e6542b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="threshold")
    def threshold(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "threshold"))

    @threshold.setter
    def threshold(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1dd005c34999173e149d807643d8f6dda18447fcb54fa47f4ee603b27e69ccf1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "threshold", value)

    @builtins.property
    @jsii.member(jsii_name="thresholdVar")
    def threshold_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "thresholdVar"))

    @threshold_var.setter
    def threshold_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0d3dbf82044a37fc45ff34c9bb7bd73da473fa7f25cad4036936e7eec789e9b9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "thresholdVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualUnsharpMask]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualUnsharpMask]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualUnsharpMask]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__82347f75cdd9850c1ac9f193f4078f30f0a82a20324ee5b78bda1668e1f1c0ee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThan",
    jsii_struct_bases=[],
    name_mapping={
        "background_color": "backgroundColor",
        "blur": "blur",
        "chroma_key": "chromaKey",
        "composite": "composite",
        "compound": "compound",
        "contrast": "contrast",
        "goop": "goop",
        "grayscale": "grayscale",
        "hsl": "hsl",
        "hsv": "hsv",
        "if_dimension": "ifDimension",
        "if_orientation": "ifOrientation",
        "max_colors": "maxColors",
        "mirror": "mirror",
        "mono_hue": "monoHue",
        "opacity": "opacity",
        "remove_color": "removeColor",
        "unsharp_mask": "unsharpMask",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThan:
    def __init__(
        self,
        *,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanBackgroundColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanBlur", typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanChromaKey", typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanComposite", typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanCompound", typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanContrast", typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanGoop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanGrayscale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanHsl", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanHsv", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimension", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientation", typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanMaxColors", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanMirror", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanMonoHue", typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanOpacity", typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanRemoveColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanUnsharpMask", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__45a1855a5e1814ab06aae25a04b8b3cafed930911632aeaa4ac6c9922f2c1fc8)
            check_type(argname="argument background_color", value=background_color, expected_type=type_hints["background_color"])
            check_type(argname="argument blur", value=blur, expected_type=type_hints["blur"])
            check_type(argname="argument chroma_key", value=chroma_key, expected_type=type_hints["chroma_key"])
            check_type(argname="argument composite", value=composite, expected_type=type_hints["composite"])
            check_type(argname="argument compound", value=compound, expected_type=type_hints["compound"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument goop", value=goop, expected_type=type_hints["goop"])
            check_type(argname="argument grayscale", value=grayscale, expected_type=type_hints["grayscale"])
            check_type(argname="argument hsl", value=hsl, expected_type=type_hints["hsl"])
            check_type(argname="argument hsv", value=hsv, expected_type=type_hints["hsv"])
            check_type(argname="argument if_dimension", value=if_dimension, expected_type=type_hints["if_dimension"])
            check_type(argname="argument if_orientation", value=if_orientation, expected_type=type_hints["if_orientation"])
            check_type(argname="argument max_colors", value=max_colors, expected_type=type_hints["max_colors"])
            check_type(argname="argument mirror", value=mirror, expected_type=type_hints["mirror"])
            check_type(argname="argument mono_hue", value=mono_hue, expected_type=type_hints["mono_hue"])
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument remove_color", value=remove_color, expected_type=type_hints["remove_color"])
            check_type(argname="argument unsharp_mask", value=unsharp_mask, expected_type=type_hints["unsharp_mask"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if background_color is not None:
            self._values["background_color"] = background_color
        if blur is not None:
            self._values["blur"] = blur
        if chroma_key is not None:
            self._values["chroma_key"] = chroma_key
        if composite is not None:
            self._values["composite"] = composite
        if compound is not None:
            self._values["compound"] = compound
        if contrast is not None:
            self._values["contrast"] = contrast
        if goop is not None:
            self._values["goop"] = goop
        if grayscale is not None:
            self._values["grayscale"] = grayscale
        if hsl is not None:
            self._values["hsl"] = hsl
        if hsv is not None:
            self._values["hsv"] = hsv
        if if_dimension is not None:
            self._values["if_dimension"] = if_dimension
        if if_orientation is not None:
            self._values["if_orientation"] = if_orientation
        if max_colors is not None:
            self._values["max_colors"] = max_colors
        if mirror is not None:
            self._values["mirror"] = mirror
        if mono_hue is not None:
            self._values["mono_hue"] = mono_hue
        if opacity is not None:
            self._values["opacity"] = opacity
        if remove_color is not None:
            self._values["remove_color"] = remove_color
        if unsharp_mask is not None:
            self._values["unsharp_mask"] = unsharp_mask

    @builtins.property
    def background_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanBackgroundColor"]]]:
        '''background_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        '''
        result = self._values.get("background_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanBackgroundColor"]]], result)

    @builtins.property
    def blur(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanBlur"]]]:
        '''blur block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        '''
        result = self._values.get("blur")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanBlur"]]], result)

    @builtins.property
    def chroma_key(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanChromaKey"]]]:
        '''chroma_key block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        '''
        result = self._values.get("chroma_key")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanChromaKey"]]], result)

    @builtins.property
    def composite(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanComposite"]]]:
        '''composite block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        '''
        result = self._values.get("composite")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanComposite"]]], result)

    @builtins.property
    def compound(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanCompound"]]]:
        '''compound block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        '''
        result = self._values.get("compound")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanCompound"]]], result)

    @builtins.property
    def contrast(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanContrast"]]]:
        '''contrast block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanContrast"]]], result)

    @builtins.property
    def goop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanGoop"]]]:
        '''goop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        '''
        result = self._values.get("goop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanGoop"]]], result)

    @builtins.property
    def grayscale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanGrayscale"]]]:
        '''grayscale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        '''
        result = self._values.get("grayscale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanGrayscale"]]], result)

    @builtins.property
    def hsl(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanHsl"]]]:
        '''hsl block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        '''
        result = self._values.get("hsl")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanHsl"]]], result)

    @builtins.property
    def hsv(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanHsv"]]]:
        '''hsv block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        '''
        result = self._values.get("hsv")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanHsv"]]], result)

    @builtins.property
    def if_dimension(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimension"]]]:
        '''if_dimension block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        '''
        result = self._values.get("if_dimension")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimension"]]], result)

    @builtins.property
    def if_orientation(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientation"]]]:
        '''if_orientation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        '''
        result = self._values.get("if_orientation")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientation"]]], result)

    @builtins.property
    def max_colors(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanMaxColors"]]]:
        '''max_colors block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        '''
        result = self._values.get("max_colors")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanMaxColors"]]], result)

    @builtins.property
    def mirror(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanMirror"]]]:
        '''mirror block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        '''
        result = self._values.get("mirror")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanMirror"]]], result)

    @builtins.property
    def mono_hue(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanMonoHue"]]]:
        '''mono_hue block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        '''
        result = self._values.get("mono_hue")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanMonoHue"]]], result)

    @builtins.property
    def opacity(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanOpacity"]]]:
        '''opacity block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanOpacity"]]], result)

    @builtins.property
    def remove_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanRemoveColor"]]]:
        '''remove_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        '''
        result = self._values.get("remove_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanRemoveColor"]]], result)

    @builtins.property
    def unsharp_mask(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanUnsharpMask"]]]:
        '''unsharp_mask block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        result = self._values.get("unsharp_mask")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanUnsharpMask"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanBackgroundColor",
    jsii_struct_bases=[],
    name_mapping={"color": "color", "color_var": "colorVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanBackgroundColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__de08085164709bdc7a277a55b13a55afb5b6105fccfe7b3b811416e7d46a0d17)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanBackgroundColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanBackgroundColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanBackgroundColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ccaa71bea555d3673a51fadac321aefc39772e6df720d93125bb7d591081c68c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanBackgroundColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__704eb0232008a6b97bd3c5852af0e72c34add1450e5a9e577f48b7734d144a8a)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanBackgroundColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c5c332f7a5f94de4150d2fa26ff88d5661364223198927344fd3ac0afea8ff4e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4f03d91df51a63f6f1c55b9066d827cd35ae5bbc0dc226548e00b02203ae0819)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__32d2a2e06373909d369ebeef2fc057684f1ec435e03c6b4ebc24c5331852f597)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanBackgroundColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanBackgroundColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__006c6c8fbcf504e11738602c38aa4acd32a60c344cc19550a6bcc6a9b7e628ed)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanBackgroundColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanBackgroundColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f29c8aa2be6c1bc825387cf72542813013398bb7b84de85b0321d9a8d2abf48)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b4a5311f40a59e4d35ac8022f2ae9bfd791812a8bd750fcedbee868b3746ed28)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0b0d7f5344f71ff6c4259131a58f49368ca34d92d7cf7ff3d6c01785efac9f7b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanBackgroundColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanBackgroundColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanBackgroundColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__599fd7f48b25fdeb9d62c554172230bf0a29c8cdeac72d068db6e33dbfd20c3b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanBlur",
    jsii_struct_bases=[],
    name_mapping={"sigma": "sigma", "sigma_var": "sigmaVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanBlur:
    def __init__(
        self,
        *,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param sigma: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b5a061f715fa351dddda5969e704f953357e928cc9c25920673293852769534c)
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanBlur(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanBlurList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanBlurList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ecb5a1975720246ce364da8d370be6e4bbcf79038337e25816ff743d02f9c94f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanBlurOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0f483b83791c4b4374628caa6e9a6f7a3a07cbff7b08e4dcd6b01a0bdfb7ce22)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanBlurOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__96c57a75e32ad591fd32fb398a9a4894977ab3319620233d849b41d72cdb9554)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ff6b1728f6836ad8c2b164a273d31cb3a6962e3e0237b02930b96d3ab023a2f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__535d69a756232da0dc03f88d6a4a945198755cd8ac07b5e3b62881c22d1f860b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanBlur]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanBlur]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6c2a036be54757ff53d77cc4fe33f776ccdbd88f3a84be0e1f21c769db5bdb45)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanBlurOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanBlurOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bfd0220b36c2e9a4bb22a2dc50ae46b72a2cfcd4a0f46e8c408f8fc50128ce3d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e35e980b7ce8f2df8a7a63a00e58edc1ec6d896be1ba47a37509923d0e46b2e3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__75c2241cf41ad3d61bd3c9f0cd9c34f17f640db7d7ff37c5973ca1037897a67d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanBlur]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanBlur]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanBlur]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b720cc9def983e818fbcef9c1839491192b5c412554af735982e10b3a895ea10)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanChromaKey",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_feather": "hueFeather",
        "hue_feather_var": "hueFeatherVar",
        "hue_tolerance": "hueTolerance",
        "hue_tolerance_var": "hueToleranceVar",
        "hue_var": "hueVar",
        "lightness_feather": "lightnessFeather",
        "lightness_feather_var": "lightnessFeatherVar",
        "lightness_tolerance": "lightnessTolerance",
        "lightness_tolerance_var": "lightnessToleranceVar",
        "saturation_feather": "saturationFeather",
        "saturation_feather_var": "saturationFeatherVar",
        "saturation_tolerance": "saturationTolerance",
        "saturation_tolerance_var": "saturationToleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanChromaKey:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_feather: typing.Optional[builtins.str] = None,
        hue_feather_var: typing.Optional[builtins.str] = None,
        hue_tolerance: typing.Optional[builtins.str] = None,
        hue_tolerance_var: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness_feather: typing.Optional[builtins.str] = None,
        lightness_feather_var: typing.Optional[builtins.str] = None,
        lightness_tolerance: typing.Optional[builtins.str] = None,
        lightness_tolerance_var: typing.Optional[builtins.str] = None,
        saturation_feather: typing.Optional[builtins.str] = None,
        saturation_feather_var: typing.Optional[builtins.str] = None,
        saturation_tolerance: typing.Optional[builtins.str] = None,
        saturation_tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_feather: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        :param hue_feather_var: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        :param hue_tolerance: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        :param hue_tolerance_var: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        :param hue_var: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness_feather: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        :param lightness_feather_var: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        :param lightness_tolerance: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        :param lightness_tolerance_var: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        :param saturation_feather: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        :param saturation_feather_var: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        :param saturation_tolerance: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        :param saturation_tolerance_var: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__48e0856c612f9d8fddb7b3d8ff02fef09da6ecbc3977182a45da107f49f65c12)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_feather", value=hue_feather, expected_type=type_hints["hue_feather"])
            check_type(argname="argument hue_feather_var", value=hue_feather_var, expected_type=type_hints["hue_feather_var"])
            check_type(argname="argument hue_tolerance", value=hue_tolerance, expected_type=type_hints["hue_tolerance"])
            check_type(argname="argument hue_tolerance_var", value=hue_tolerance_var, expected_type=type_hints["hue_tolerance_var"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness_feather", value=lightness_feather, expected_type=type_hints["lightness_feather"])
            check_type(argname="argument lightness_feather_var", value=lightness_feather_var, expected_type=type_hints["lightness_feather_var"])
            check_type(argname="argument lightness_tolerance", value=lightness_tolerance, expected_type=type_hints["lightness_tolerance"])
            check_type(argname="argument lightness_tolerance_var", value=lightness_tolerance_var, expected_type=type_hints["lightness_tolerance_var"])
            check_type(argname="argument saturation_feather", value=saturation_feather, expected_type=type_hints["saturation_feather"])
            check_type(argname="argument saturation_feather_var", value=saturation_feather_var, expected_type=type_hints["saturation_feather_var"])
            check_type(argname="argument saturation_tolerance", value=saturation_tolerance, expected_type=type_hints["saturation_tolerance"])
            check_type(argname="argument saturation_tolerance_var", value=saturation_tolerance_var, expected_type=type_hints["saturation_tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_feather is not None:
            self._values["hue_feather"] = hue_feather
        if hue_feather_var is not None:
            self._values["hue_feather_var"] = hue_feather_var
        if hue_tolerance is not None:
            self._values["hue_tolerance"] = hue_tolerance
        if hue_tolerance_var is not None:
            self._values["hue_tolerance_var"] = hue_tolerance_var
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness_feather is not None:
            self._values["lightness_feather"] = lightness_feather
        if lightness_feather_var is not None:
            self._values["lightness_feather_var"] = lightness_feather_var
        if lightness_tolerance is not None:
            self._values["lightness_tolerance"] = lightness_tolerance
        if lightness_tolerance_var is not None:
            self._values["lightness_tolerance_var"] = lightness_tolerance_var
        if saturation_feather is not None:
            self._values["saturation_feather"] = saturation_feather
        if saturation_feather_var is not None:
            self._values["saturation_feather_var"] = saturation_feather_var
        if saturation_tolerance is not None:
            self._values["saturation_tolerance"] = saturation_tolerance
        if saturation_tolerance_var is not None:
            self._values["saturation_tolerance_var"] = saturation_tolerance_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        '''
        result = self._values.get("hue_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        '''
        result = self._values.get("hue_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        '''
        result = self._values.get("hue_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        '''
        result = self._values.get("hue_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        '''
        result = self._values.get("lightness_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        '''
        result = self._values.get("lightness_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        '''
        result = self._values.get("lightness_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        '''
        result = self._values.get("lightness_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        '''
        result = self._values.get("saturation_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        '''
        result = self._values.get("saturation_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        '''
        result = self._values.get("saturation_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        result = self._values.get("saturation_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanChromaKey(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanChromaKeyList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanChromaKeyList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__97b221f3b962aed9eaef0d5cefd81ecc894699d6f5ec6ccbe59f336b5b12de77)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanChromaKeyOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0c238e479260ccda80c6bd4d7f348a3b056a85453bce97cf676913bada23abd6)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanChromaKeyOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cb7c1bb97502fe8b716caf10c51450a3717c078e00e7784705c3112f5648a35c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d2ab54afe8edacb14b4bb3c90aa9b98d075976b7b6ea563b88af299534593082)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b407dbcc58c2951d7772bfd8488efe35f64818692742921867994bc1b954fd86)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanChromaKey]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanChromaKey]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f7bdc2f8a05ef0f3327070e0a6f8880670a1d3376da6061a8033f0474ed85ae7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanChromaKeyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanChromaKeyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c6b4042795931215fcc9e585024948c7433748f3e31c3edcce3b8ed08fb142c2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueFeather")
    def reset_hue_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeather", []))

    @jsii.member(jsii_name="resetHueFeatherVar")
    def reset_hue_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeatherVar", []))

    @jsii.member(jsii_name="resetHueTolerance")
    def reset_hue_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueTolerance", []))

    @jsii.member(jsii_name="resetHueToleranceVar")
    def reset_hue_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueToleranceVar", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightnessFeather")
    def reset_lightness_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeather", []))

    @jsii.member(jsii_name="resetLightnessFeatherVar")
    def reset_lightness_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeatherVar", []))

    @jsii.member(jsii_name="resetLightnessTolerance")
    def reset_lightness_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessTolerance", []))

    @jsii.member(jsii_name="resetLightnessToleranceVar")
    def reset_lightness_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessToleranceVar", []))

    @jsii.member(jsii_name="resetSaturationFeather")
    def reset_saturation_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeather", []))

    @jsii.member(jsii_name="resetSaturationFeatherVar")
    def reset_saturation_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeatherVar", []))

    @jsii.member(jsii_name="resetSaturationTolerance")
    def reset_saturation_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationTolerance", []))

    @jsii.member(jsii_name="resetSaturationToleranceVar")
    def reset_saturation_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherInput")
    def hue_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVarInput")
    def hue_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceInput")
    def hue_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVarInput")
    def hue_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherInput")
    def lightness_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVarInput")
    def lightness_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceInput")
    def lightness_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVarInput")
    def lightness_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherInput")
    def saturation_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVarInput")
    def saturation_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceInput")
    def saturation_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVarInput")
    def saturation_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a6b80f40957400a41343bb5eba32e5a5a3a0a92e96a5d4b3b7d10d9f3c2b3c39)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeather")
    def hue_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeather"))

    @hue_feather.setter
    def hue_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a2e60959c07fac60703170234ac7f3e25c828f4523d3bf6bed6099e7e844d7cb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeather", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVar")
    def hue_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeatherVar"))

    @hue_feather_var.setter
    def hue_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6ea2793cc5ccae15625613c4ed3d01ee785af3f27646725efb9c310c13c92e10)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueTolerance")
    def hue_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueTolerance"))

    @hue_tolerance.setter
    def hue_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e1a7b6cdd87d4b7df1b82da82b2c80e49c66e46b9caf2e3b471dfeb5bcd97339)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVar")
    def hue_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueToleranceVar"))

    @hue_tolerance_var.setter
    def hue_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__696d5eaa1a8e5bc368cd7be1d614ac213784a0e22bf65bd1771df0866aab6ee6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be3215afe020b70ed2a00d291dc1103435fd158dfdc3852ec30a13147fbe5da0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeather")
    def lightness_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeather"))

    @lightness_feather.setter
    def lightness_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3e110f8bd5ad0f8c5a6ae921f73d49c5ab01c8d565dbd9776a266304c5124e04)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeather", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVar")
    def lightness_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeatherVar"))

    @lightness_feather_var.setter
    def lightness_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5bc361f22fe31c6fc71336ee503158c41fcac5270be603f2dc9df2e8af57e527)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessTolerance")
    def lightness_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessTolerance"))

    @lightness_tolerance.setter
    def lightness_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dd172eba82ec1f2209f9191db13dc96a21e092c0b90193680c2d88f580761bbe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVar")
    def lightness_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessToleranceVar"))

    @lightness_tolerance_var.setter
    def lightness_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__616cde063f39cdfffde8f4148280f42bf6c08b13f33850074b37ed4983b5a35f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeather")
    def saturation_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeather"))

    @saturation_feather.setter
    def saturation_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a21cdc145f686f273cb130a8684f05ccf256cbbaba259daff8f7c974318002c5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeather", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVar")
    def saturation_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeatherVar"))

    @saturation_feather_var.setter
    def saturation_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__143a09071146d6aabc018f9edeb97471d3792f4e8e595f708b36974796a15777)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationTolerance")
    def saturation_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationTolerance"))

    @saturation_tolerance.setter
    def saturation_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__185aa12101c2a6041d71672bbf70ccd90e09ab8b3fe4bf126742ae9203f21928)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVar")
    def saturation_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationToleranceVar"))

    @saturation_tolerance_var.setter
    def saturation_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__245d41fc03e5f98b2e3bc8aafddd5aa90a260c861270b6cdf1da28e1bd14702e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanChromaKey]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanChromaKey]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanChromaKey]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__10a4cd7311afd77a61bec43449d1f1fde8446d730dfbed6c216ff81c7d745f27)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanComposite",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "placement": "placement",
        "placement_var": "placementVar",
        "scale": "scale",
        "scale_dimension": "scaleDimension",
        "scale_dimension_var": "scaleDimensionVar",
        "scale_var": "scaleVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanComposite:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanCompositeImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        placement: typing.Optional[builtins.str] = None,
        placement_var: typing.Optional[builtins.str] = None,
        scale: typing.Optional[builtins.str] = None,
        scale_dimension: typing.Optional[builtins.str] = None,
        scale_dimension_var: typing.Optional[builtins.str] = None,
        scale_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param placement: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        :param placement_var: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        :param scale: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param scale_dimension: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        :param scale_dimension_var: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        :param scale_var: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        :param x_position: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanCompositeImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6d325844e3d5183e4acc750c498741cbc319ce6b81af2028f3c2c746dbc00b9c)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument placement", value=placement, expected_type=type_hints["placement"])
            check_type(argname="argument placement_var", value=placement_var, expected_type=type_hints["placement_var"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument scale_dimension", value=scale_dimension, expected_type=type_hints["scale_dimension"])
            check_type(argname="argument scale_dimension_var", value=scale_dimension_var, expected_type=type_hints["scale_dimension_var"])
            check_type(argname="argument scale_var", value=scale_var, expected_type=type_hints["scale_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if placement is not None:
            self._values["placement"] = placement
        if placement_var is not None:
            self._values["placement_var"] = placement_var
        if scale is not None:
            self._values["scale"] = scale
        if scale_dimension is not None:
            self._values["scale_dimension"] = scale_dimension
        if scale_dimension_var is not None:
            self._values["scale_dimension_var"] = scale_dimension_var
        if scale_var is not None:
            self._values["scale_var"] = scale_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanCompositeImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanCompositeImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        '''
        result = self._values.get("placement")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement_var(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        '''
        result = self._values.get("placement_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        '''
        result = self._values.get("scale_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        '''
        result = self._values.get("scale_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        '''
        result = self._values.get("scale_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanComposite(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanCompositeImage",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanCompositeImage:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanCompositeImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanCompositeImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanCompositeImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c92c30c475a32b8c72af6c8954076b03c41c57d4fe90e3521464371a92b29724)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanCompositeImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanCompositeImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0e94f221855d9783fedf5efefc2b3b828f4e0ef0c7d649c523e5cf33a8337698)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanCompositeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanCompositeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__80f9d0f379e44123507b0d906f27433a781322667914a22f71851ff4d05ebc27)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanCompositeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__27cb098a013694ad20f732ab0393e0c66b6ae349d6bfbdaeb8d6aa2158e9d868)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanCompositeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d828ab175fc2cf8958e192a2427f41c5218b46e7be30218f9d3ba060d6253a97)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__29bb88e2baa89f9eebe390a026ea5ce382899fcce57208270427f28a62b37f79)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__692788b2e53ee82bc9eba42f1c5e54024b26c8de573d7106b614ccee94995289)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanComposite]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanComposite]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ddf07c741bcf228655446fd90dc1d0526db4e1a696edc717bdebd3d4c93c6fe6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanCompositeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanCompositeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8468c17e8cf2fb359d6152205ddc2d3225e88fb350856abb79500eba44f5f8a9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanCompositeImage()

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPlacement")
    def reset_placement(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacement", []))

    @jsii.member(jsii_name="resetPlacementVar")
    def reset_placement_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacementVar", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetScaleDimension")
    def reset_scale_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimension", []))

    @jsii.member(jsii_name="resetScaleDimensionVar")
    def reset_scale_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimensionVar", []))

    @jsii.member(jsii_name="resetScaleVar")
    def reset_scale_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanCompositeImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanCompositeImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanCompositeImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="placementInput")
    def placement_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementInput"))

    @builtins.property
    @jsii.member(jsii_name="placementVarInput")
    def placement_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionInput")
    def scale_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVarInput")
    def scale_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleVarInput")
    def scale_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__931798f35cde848c40d0fd10ddbb753f91d2afb243108fb11aaf9254b898355b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fe367792f07c10a4eb5710755f01469957c515b2fd926f3dd4554dc371371492)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="placement")
    def placement(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placement"))

    @placement.setter
    def placement(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__43d36f06b9a46d079db827cb6d54a05533e9157c45e1424e5f3cb6fa13222d5e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placement", value)

    @builtins.property
    @jsii.member(jsii_name="placementVar")
    def placement_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placementVar"))

    @placement_var.setter
    def placement_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3b7a3f3702a584f8cc86cc7bbeaa0493042dbf071e1108d92973559328a09d79)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placementVar", value)

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scale"))

    @scale.setter
    def scale(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea89fa42723f76d001ed0adfdb44b87589c1c7c7a137ec18df89f4b824298af5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scale", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimension")
    def scale_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimension"))

    @scale_dimension.setter
    def scale_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__05c63c0369e74c86222333c55a96335f24b51158466ff530d95ffba4969cd450)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimension", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVar")
    def scale_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimensionVar"))

    @scale_dimension_var.setter
    def scale_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bdcf7d06d4b57c82cee92979b6bd2495a6d9da1c89f31f65fd567c81a0c69562)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="scaleVar")
    def scale_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleVar"))

    @scale_var.setter
    def scale_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7790e90708ffd977ad7944973a8ffc220e83d784676bf785fbae0d148e74b563)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6214bb3be0ee7ad29b64c210a3f4edb5a7fd33f60ce8ba110f174f1929e7a42a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bba45bf42cf0776e56c02cc4b77b6a65b80318d6070cf632ae65ce686ee52772)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0c58a1a93b27e7df4dfb422077330f972beab695f4ebcf5f0a3d22fea5ba0ca2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ae39f8b25b783ca397651288cb7356254c88a6034ed98db2ffdd156c9fb7c9ad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanComposite]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanComposite]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanComposite]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9c8dc900f1334fd9d970d62fe9626a69aa96dc98b5459955983e6b779c62ce42)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanCompound",
    jsii_struct_bases=[],
    name_mapping={"transformations": "transformations"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanCompound:
    def __init__(
        self,
        *,
        transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param transformations: transformations block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__89dd4f83dbef2c93d81dad85d65e310c08006d3318e34bddec02c91a6479965f)
            check_type(argname="argument transformations", value=transformations, expected_type=type_hints["transformations"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if transformations is not None:
            self._values["transformations"] = transformations

    @builtins.property
    def transformations(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanCompoundTransformations"]]]:
        '''transformations block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        result = self._values.get("transformations")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanCompoundTransformations"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanCompound(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanCompoundList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanCompoundList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a1623dc771a357688baf028a26a4511ce2f181fa435c96789b1dfb569f2c515)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanCompoundOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ad3f43e2ce25b3eb433c8c14104bad615a9c27b1bbace910b793cff63cff265)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanCompoundOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e2d1a522160a6d26af165156ec41ac3e479dae91ce459eb5a6c5ec95c7c5ebfa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__69d1f3ca9aa417915f6799bfb42e9c29c04041ba4d2a474aff9237bb10bd86d1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8eb5504ff6dd4f56700b884cfa9026d906455f196abe5ce2dd3baef130d5d910)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanCompound]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanCompound]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a9b95a09b0671dcc3bc6e048ba4fc4084744513b61cb1a74df2308295d85aa9b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanCompoundOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanCompoundOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__30039e999ad02caffe54b574600573729b0b20610c8dec17d9124f600af4c778)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformations")
    def put_transformations(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__993880b46b1e949c46c796543d322d05ecff02c6517492a65b34f51410d9b287)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTransformations", [value]))

    @jsii.member(jsii_name="resetTransformations")
    def reset_transformations(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformations", []))

    @builtins.property
    @jsii.member(jsii_name="transformations")
    def transformations(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanCompoundTransformationsList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanCompoundTransformationsList", jsii.get(self, "transformations"))

    @builtins.property
    @jsii.member(jsii_name="transformationsInput")
    def transformations_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanCompoundTransformations"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanCompoundTransformations"]]], jsii.get(self, "transformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanCompound]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanCompound]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanCompound]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3f2f8b26450daee21488574f39ee232ee305fd6aed44a8cc145d530ec605caf7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanCompoundTransformations",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanCompoundTransformations:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanCompoundTransformations(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanCompoundTransformationsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanCompoundTransformationsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be41f0ee9bd902fef7ebb69d27f5e967fc278c710815b301f94fb78e490ad9fc)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanCompoundTransformationsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__740f0c44479de9b312b2905b56a922a038847fde834dd5c7a7d66025bf78a342)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanCompoundTransformationsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fac6281d851f95a357ecebb6dbf846d0aaec12d66ff2d2d244c0d1c478988ef9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0d0f779b5385aed1f9055fab7f2cd1ea3e4b3cb9705b6d3c0c97110f6c060d2f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2826b8a39d3b96aad2b1a49c9abca4a5a15c1240204f694566afcc5e095cb298)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanCompoundTransformations]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanCompoundTransformations]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanCompoundTransformations]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e7a09e94b69ec534b2da96a1a55976b7846e85e106ef23127f48a1e284e66dbb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanCompoundTransformationsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanCompoundTransformationsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1612a5fb5c11be0e3abc521e26cdeb0bb7d8cc0fa75417c6d835ce83f1f396d8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanCompoundTransformations]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanCompoundTransformations]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanCompoundTransformations]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e1919bc1fd5761c006091873e453346d98550e67e79ff66568fff692f6571fbf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanContrast",
    jsii_struct_bases=[],
    name_mapping={
        "brightness": "brightness",
        "brightness_var": "brightnessVar",
        "contrast": "contrast",
        "contrast_var": "contrastVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanContrast:
    def __init__(
        self,
        *,
        brightness: typing.Optional[builtins.str] = None,
        brightness_var: typing.Optional[builtins.str] = None,
        contrast: typing.Optional[builtins.str] = None,
        contrast_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param brightness: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        :param brightness_var: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        :param contrast: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param contrast_var: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a0a9ff7f22813a0ec97686de221d95d5909b3d6510f10a57c6c6a5928af583f0)
            check_type(argname="argument brightness", value=brightness, expected_type=type_hints["brightness"])
            check_type(argname="argument brightness_var", value=brightness_var, expected_type=type_hints["brightness_var"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument contrast_var", value=contrast_var, expected_type=type_hints["contrast_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if brightness is not None:
            self._values["brightness"] = brightness
        if brightness_var is not None:
            self._values["brightness_var"] = brightness_var
        if contrast is not None:
            self._values["contrast"] = contrast
        if contrast_var is not None:
            self._values["contrast_var"] = contrast_var

    @builtins.property
    def brightness(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        '''
        result = self._values.get("brightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def brightness_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        '''
        result = self._values.get("brightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        result = self._values.get("contrast_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanContrast(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanContrastList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanContrastList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__989df813390c8ec46d8b29d1f6f0abf960c691f7a9905e9cec4638ff96225c8f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanContrastOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5caf54ef5bfae4309c2df5dc02f09fd5e934798cc9a797ba069e67c15ac5dbc1)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanContrastOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f8e7829f2e5708feec15f95b8d3cca94837acc8cf9a97ee2969b568d02c72346)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__742e9f10632b143e99089f8825e7fe5dc0861f4d038e10a2c29a6d770b68dc38)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__891dd8f2ce24e2fd3069e53021cf9862ffd386d753e88407627eed2be2ddfc49)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanContrast]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanContrast]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__53900a832011f8f0c8b31f9286843c591644a270492de9019b69898860f9d6e4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanContrastOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanContrastOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a829e42a909be947600f0f584f41696b2af6cd5f3d5456dc2e1237e8f1bd34a6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetBrightness")
    def reset_brightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightness", []))

    @jsii.member(jsii_name="resetBrightnessVar")
    def reset_brightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightnessVar", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetContrastVar")
    def reset_contrast_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrastVar", []))

    @builtins.property
    @jsii.member(jsii_name="brightnessInput")
    def brightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="brightnessVarInput")
    def brightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastVarInput")
    def contrast_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="brightness")
    def brightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightness"))

    @brightness.setter
    def brightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a13b4b46e3abdc376a285d7ece5ef6b68612862713b3d68bec878de3e2a871bf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightness", value)

    @builtins.property
    @jsii.member(jsii_name="brightnessVar")
    def brightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightnessVar"))

    @brightness_var.setter
    def brightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5113a71977745ad40202277e71c8ae76af2876345cf0eadddbdb047d685a37d0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrast"))

    @contrast.setter
    def contrast(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e445ee42882453b54c2edd1dd98821d5ccd0f4049002d64268fc842fb83ca2df)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrast", value)

    @builtins.property
    @jsii.member(jsii_name="contrastVar")
    def contrast_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrastVar"))

    @contrast_var.setter
    def contrast_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__069b5ec58d1eea0e22d0fa5a509d0cc39c837edbaa759660f7d00d3420064827)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrastVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanContrast]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanContrast]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanContrast]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__80ff803619251e580fedfb518ea53ecea5f9bb6cf32fdf11fd279a478e9ad9ce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanGoop",
    jsii_struct_bases=[],
    name_mapping={
        "chaos": "chaos",
        "chaos_var": "chaosVar",
        "density": "density",
        "density_var": "densityVar",
        "power": "power",
        "power_var": "powerVar",
        "seed": "seed",
        "seed_var": "seedVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanGoop:
    def __init__(
        self,
        *,
        chaos: typing.Optional[builtins.str] = None,
        chaos_var: typing.Optional[builtins.str] = None,
        density: typing.Optional[builtins.str] = None,
        density_var: typing.Optional[builtins.str] = None,
        power: typing.Optional[builtins.str] = None,
        power_var: typing.Optional[builtins.str] = None,
        seed: typing.Optional[builtins.str] = None,
        seed_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param chaos: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        :param chaos_var: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        :param density: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        :param density_var: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        :param power: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        :param power_var: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        :param seed: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        :param seed_var: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fe19db3922fed77c0745a63b2d905851e8401cfd34ae499dce56cf07ef7a9a1d)
            check_type(argname="argument chaos", value=chaos, expected_type=type_hints["chaos"])
            check_type(argname="argument chaos_var", value=chaos_var, expected_type=type_hints["chaos_var"])
            check_type(argname="argument density", value=density, expected_type=type_hints["density"])
            check_type(argname="argument density_var", value=density_var, expected_type=type_hints["density_var"])
            check_type(argname="argument power", value=power, expected_type=type_hints["power"])
            check_type(argname="argument power_var", value=power_var, expected_type=type_hints["power_var"])
            check_type(argname="argument seed", value=seed, expected_type=type_hints["seed"])
            check_type(argname="argument seed_var", value=seed_var, expected_type=type_hints["seed_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if chaos is not None:
            self._values["chaos"] = chaos
        if chaos_var is not None:
            self._values["chaos_var"] = chaos_var
        if density is not None:
            self._values["density"] = density
        if density_var is not None:
            self._values["density_var"] = density_var
        if power is not None:
            self._values["power"] = power
        if power_var is not None:
            self._values["power_var"] = power_var
        if seed is not None:
            self._values["seed"] = seed
        if seed_var is not None:
            self._values["seed_var"] = seed_var

    @builtins.property
    def chaos(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        '''
        result = self._values.get("chaos")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def chaos_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        '''
        result = self._values.get("chaos_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        '''
        result = self._values.get("density")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density_var(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        '''
        result = self._values.get("density_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        '''
        result = self._values.get("power")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power_var(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        '''
        result = self._values.get("power_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        '''
        result = self._values.get("seed")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed_var(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        result = self._values.get("seed_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanGoop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanGoopList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanGoopList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8ba5fc29b525fe94703e52c6853650ec925c39c6cd4dfa89f7b2c73a4f1007d2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanGoopOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e28d00202c8e2d60b2d970ea52eec05fae420f9c36578b99a021409e6b8759bd)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanGoopOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__763a5d52ec780847212e5ca1cb14e5c313e7dd1d0c9ebe5d9c3624e73e921d0c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a998eda9dc6b7bd22e7d8ae8ab141802d83aff2df63aa1ea66eeaa6affb0ef63)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__56fc9994b89964cb380f994d9b2614bb3187f33028f1cc18fca7a23e690872ba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanGoop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanGoop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c3883bcc7588e4c2cc56942c399638ae78ddc35ec96b5228850bf69b1ae4540a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanGoopOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanGoopOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c39ae56085a2b04ca3219748fcfedcbca93a8a532260f4cac6a07fb09c615d8e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetChaos")
    def reset_chaos(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaos", []))

    @jsii.member(jsii_name="resetChaosVar")
    def reset_chaos_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaosVar", []))

    @jsii.member(jsii_name="resetDensity")
    def reset_density(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensity", []))

    @jsii.member(jsii_name="resetDensityVar")
    def reset_density_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensityVar", []))

    @jsii.member(jsii_name="resetPower")
    def reset_power(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPower", []))

    @jsii.member(jsii_name="resetPowerVar")
    def reset_power_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPowerVar", []))

    @jsii.member(jsii_name="resetSeed")
    def reset_seed(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeed", []))

    @jsii.member(jsii_name="resetSeedVar")
    def reset_seed_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeedVar", []))

    @builtins.property
    @jsii.member(jsii_name="chaosInput")
    def chaos_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosInput"))

    @builtins.property
    @jsii.member(jsii_name="chaosVarInput")
    def chaos_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosVarInput"))

    @builtins.property
    @jsii.member(jsii_name="densityInput")
    def density_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityInput"))

    @builtins.property
    @jsii.member(jsii_name="densityVarInput")
    def density_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="powerInput")
    def power_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerInput"))

    @builtins.property
    @jsii.member(jsii_name="powerVarInput")
    def power_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerVarInput"))

    @builtins.property
    @jsii.member(jsii_name="seedInput")
    def seed_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedInput"))

    @builtins.property
    @jsii.member(jsii_name="seedVarInput")
    def seed_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedVarInput"))

    @builtins.property
    @jsii.member(jsii_name="chaos")
    def chaos(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaos"))

    @chaos.setter
    def chaos(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__996d2afd5727980645994aaa506a6f1361dd2a7141fdb7b4c8a9883472283bd1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaos", value)

    @builtins.property
    @jsii.member(jsii_name="chaosVar")
    def chaos_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaosVar"))

    @chaos_var.setter
    def chaos_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__db1442f741af8f1be9b343c245b4ab92476edf5a44f0a795a39ab788fec896ac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaosVar", value)

    @builtins.property
    @jsii.member(jsii_name="density")
    def density(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "density"))

    @density.setter
    def density(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__10b0bdd208777610cef01aada0875fc302a75df6a1640605ef3433a8dbc20435)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "density", value)

    @builtins.property
    @jsii.member(jsii_name="densityVar")
    def density_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "densityVar"))

    @density_var.setter
    def density_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c9943c2c98e27ddb29a8210cad977ece3f1e162585f9e95f3ea5f8c0f5e935e3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "densityVar", value)

    @builtins.property
    @jsii.member(jsii_name="power")
    def power(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "power"))

    @power.setter
    def power(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d341dc991c100452e0e8578525d571989b084f0b94ecf8bd3abeb782bc3a87f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "power", value)

    @builtins.property
    @jsii.member(jsii_name="powerVar")
    def power_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "powerVar"))

    @power_var.setter
    def power_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e52d849418c8893cd9bead66c3ce688892cb3053efd84974b7433fbfd0020cab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "powerVar", value)

    @builtins.property
    @jsii.member(jsii_name="seed")
    def seed(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seed"))

    @seed.setter
    def seed(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ba2c4210cf2fcaa9e0ea107c27f2c1b0d6e5415d148d7d4a482d6d8de6c9ab84)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seed", value)

    @builtins.property
    @jsii.member(jsii_name="seedVar")
    def seed_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seedVar"))

    @seed_var.setter
    def seed_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b89ef214d630ad74b96d23a6275a7a85386574ee971194848172a06eba5e184f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seedVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanGoop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanGoop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanGoop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__767631aa2b672f21fc720fb0b527939595cfb811871f14a30af190a4bf83ed4c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanGrayscale",
    jsii_struct_bases=[],
    name_mapping={"type": "type", "type_var": "typeVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanGrayscale:
    def __init__(
        self,
        *,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param type: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2f878eaac1a3c091c83d4ced250a43f54a632e688dc443fafeeb15796f5987b2)
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanGrayscale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanGrayscaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanGrayscaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea2b70d6e22c3ca87f0a92e00025adfaba936de8fac6839d80d1117a49e51e54)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanGrayscaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__892b54f712a79a7a8e8b1e4331a979400f2a17971c92127c3691c637c4462dc6)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanGrayscaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d6185b9526f1da0fcb8a758d6d0396efb53d36fe5d718202ebcc19070fd9d2a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7efe3bfd29ea037f7c12df7ee8f1fb566050d39ba967abda36c79d632dc14b23)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a3e4a20688ee87030063daadd39aa3af4c77471e229f9968796f6aaef0eb82e0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanGrayscale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanGrayscale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a65a6bc4b783e02e207bf03448eaedfc38d95f27ec1d9a16a68e07b974277acd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanGrayscaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanGrayscaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aa7283da71641944fad175c49cb6340b997cb691379e8ae2c7760c8362ea069a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__17a0435a5944792e6e27dc7401c96767b5fbfb392f1893a7d86a0369c1bdc392)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5132286bceb7217e50323024fc99bcff120606aba2c0141ccec6b4a38a416c33)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanGrayscale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanGrayscale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanGrayscale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3d840c476e48c5b3020e56e617bff0e48b331d7e4134b04fac71da26f0415575)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanHsl",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "lightness": "lightness",
        "lightness_var": "lightnessVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanHsl:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness: typing.Optional[builtins.str] = None,
        lightness_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        :param lightness_var: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__90dce537685b08484221d91954f52a3d3a47830396194369e0ee2f869fd29d83)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness", value=lightness, expected_type=type_hints["lightness"])
            check_type(argname="argument lightness_var", value=lightness_var, expected_type=type_hints["lightness_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness is not None:
            self._values["lightness"] = lightness
        if lightness_var is not None:
            self._values["lightness_var"] = lightness_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        '''
        result = self._values.get("lightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        '''
        result = self._values.get("lightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanHsl(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanHslList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanHslList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__98cbc98520877c3542aacae7faa1f473ec27ea999a89b08a2cd3f1ed03aea451)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanHslOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f79e7a2bab0828e7fcbfacddb35060720b77d0492dfb731895c3fc6c04d8e5c)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanHslOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__efb579025d7222cde59f3278e8cb6ac5cd227b25ad780785165e8728c746d81c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7612d8f8e1b2dff2c2fffd89cbdbb2d11b4ae2abeb94149900cc9e3745fe3eb2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f28147bbb577e124748014f7ca5a709030cc0d8a83ac97d129917322537669d2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanHsl]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanHsl]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fb6724fa13b6c11027ca369600cca0a9540c7f139dab2a5a41eb8d2338f33bd5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanHslOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanHslOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__03968908d9c2ec2e594602f726d055b88a0ed083b41e0fec13309825f508a141)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightness")
    def reset_lightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightness", []))

    @jsii.member(jsii_name="resetLightnessVar")
    def reset_lightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessInput")
    def lightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessVarInput")
    def lightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f9a0caceb02215efe6d319d6294cc5887652b16a2469b73a6d3cb1ff76f5dc36)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8ad5e16e9b3603c09cdcb893f9a05fb7903279753c13a9734a8ca4a3fc39b092)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightness")
    def lightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightness"))

    @lightness.setter
    def lightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7a2c161951f4b72ff31ee6355d03ebe9951f92cab227e52f4eed39041bb9e718)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightness", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessVar")
    def lightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessVar"))

    @lightness_var.setter
    def lightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a881573b47e280e6f64bc6f9e6cb4d67dfd9d205e264b9fc383ec82347bb0ce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__103fd33c30744855d17b6a3351f52a964503d13864f960af10886c8141c8b33d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9e2d74efb2c6af2024f0850446850a6b847448c7662f74110987c4a50311f575)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanHsl]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanHsl]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanHsl]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__202716805bb2eb8200ef5c0ff73fbe29e86dea59028259c50ae1dcc58ba435d6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanHsv",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanHsv:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        :param value: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__65b3653a140591227ff1ae9f8729f6c07a0e1aa565d5b1465a14518393d83394)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanHsv(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanHsvList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanHsvList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__edd9fc42ba7c9525707712572eb0ee0c27f1e0f0bef2cbbae375ec59779f854c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanHsvOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c84407811c947ecb22ea9e1427b2f3b04e291967bbcffcdaf63582699be932d8)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanHsvOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1fcfcb5e5c1588553086b28d79eadb89d77687aa6e1344d91f779ffd8dbd8430)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ee02150afd8b6efc1416169af20086103f85aa3b8a189128fb6c0a1742df6ce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6eee32cd8f60747fa88243c13a70cfc3fdb9aa8ad936ce311456d162a126996f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanHsv]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanHsv]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9852381f22599320e26a0ea4d2da807f8ebdb92e403d7e485ec0a77a89f62d25)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanHsvOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanHsvOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__16bcde9732c18a7ba916e13e16bd7ba7e45b1a31a488983f80ef2a1e277c07a8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__29568949ada5beb3423534f28969998ea53eed2d312f3f26b69cac12e49102cf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc9ef63bae279b4a195c43fe8d5ebefe4220c0baea07816908513586340e9f80)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2e7d58a63400dbf74d61149b9dac9212bd7cff3d052d782544789244b19f52ff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7c34a8d4ce99e9b249e2f5bc422fe9a65f4dc9f584ec66dd9c8f952fbd0df532)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7a444ecedc83caa0fb8ca1b44cfbb5a9167969380dd9913b9291bc31549f4b09)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3d199ee0dacc7008ef8da0a6bbba3480a195f072e5d7346b367d663ff4ed91aa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanHsv]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanHsv]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanHsv]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8feabc1db564686bfbdf6ef5aff4330ea0c0a6bc5ef81cc9bcda11ffb23eac89)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimension",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "dimension": "dimension",
        "dimension_var": "dimensionVar",
        "equal": "equal",
        "greater_than": "greaterThan",
        "less_than": "lessThan",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimension:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        dimension: typing.Optional[builtins.str] = None,
        dimension_var: typing.Optional[builtins.str] = None,
        equal: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionEqual", typing.Dict[builtins.str, typing.Any]]] = None,
        greater_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionGreaterThan", typing.Dict[builtins.str, typing.Any]]] = None,
        less_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionLessThan", typing.Dict[builtins.str, typing.Any]]] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param dimension: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        :param dimension_var: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        :param equal: equal block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        :param greater_than: greater_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        :param less_than: less_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        :param value: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionDefault(**default)
        if isinstance(equal, dict):
            equal = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionEqual(**equal)
        if isinstance(greater_than, dict):
            greater_than = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionGreaterThan(**greater_than)
        if isinstance(less_than, dict):
            less_than = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionLessThan(**less_than)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a34c4e0daa6780216432f53fdd4564eaca11c7701d145e2217f94f6a73b91af8)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument dimension", value=dimension, expected_type=type_hints["dimension"])
            check_type(argname="argument dimension_var", value=dimension_var, expected_type=type_hints["dimension_var"])
            check_type(argname="argument equal", value=equal, expected_type=type_hints["equal"])
            check_type(argname="argument greater_than", value=greater_than, expected_type=type_hints["greater_than"])
            check_type(argname="argument less_than", value=less_than, expected_type=type_hints["less_than"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if dimension is not None:
            self._values["dimension"] = dimension
        if dimension_var is not None:
            self._values["dimension_var"] = dimension_var
        if equal is not None:
            self._values["equal"] = equal
        if greater_than is not None:
            self._values["greater_than"] = greater_than
        if less_than is not None:
            self._values["less_than"] = less_than
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionDefault"], result)

    @builtins.property
    def dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        '''
        result = self._values.get("dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        '''
        result = self._values.get("dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def equal(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionEqual"]:
        '''equal block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        '''
        result = self._values.get("equal")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionEqual"], result)

    @builtins.property
    def greater_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionGreaterThan"]:
        '''greater_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        '''
        result = self._values.get("greater_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionGreaterThan"], result)

    @builtins.property
    def less_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionLessThan"]:
        '''less_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        '''
        result = self._values.get("less_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionLessThan"], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimension(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__36cd7f8592795644009e43b93c94b499eb8864cb23a1e9e767ad56c33b2f1b76)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7a54a5825c20933c970a985735d65e55ba6df01135ec02fce55364b131d7ea2e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionEqual",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionEqual:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionEqual(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionEqualOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionEqualOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0c392a92be1f4a83c9c998885739b3cd2f6a1ec0fc1d7fc5a20da905a9c1c61a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionEqual], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionEqual],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9e5d8bcb08771bb27797e4ff9fc7fd615aae3c2ede2b243a6fb7d0616fc720e1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionGreaterThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionGreaterThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionGreaterThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionGreaterThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionGreaterThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__00d9454ba4683546fde35beedecd8225bc7643eb50f5de68fd352535d9921896)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionGreaterThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionGreaterThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a856cbe872d5ffec3b4ab51676d87a230e6619c497df481c97bb93f207024da)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionLessThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionLessThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionLessThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionLessThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionLessThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9bafa112dc3f852bd6bb099eda056bacce233a350d868009af6fb2607a4fd10f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionLessThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionLessThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__89f3d636e27f546db3e110bb28b3f710f5ee5f5dca9e874350bcea48be38a7d2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8bee668343937d9d24ef7f1763fd0f358657e7c25bdbeac7322a86a4d925b608)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f85a4dc6cdb4834e7636f0d45e4522bf40f54c19d854005326939290b54d262)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9c84cf803a4b555f54ea30fb0651ace62123321d610d12c3df2c03e45b815b2e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__516cb338a024d68521eb39a7eb3b886cf9b77bb4a45634adb6d2cf0c87fff2f5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c65070e531d58368b420662f7d910e72792df0bfcede2ea8ee97414474680b5b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimension]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimension]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fac580099065a752eb732e10ae08f5af4a9a812b18011d16f7d65248d199e969)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5a96cfe8fd4b6a5d679e6770b7ff693782db12b91447df21ab44b1731ef57e89)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putEqual")
    def put_equal(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionEqual()

        return typing.cast(None, jsii.invoke(self, "putEqual", [value]))

    @jsii.member(jsii_name="putGreaterThan")
    def put_greater_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionGreaterThan()

        return typing.cast(None, jsii.invoke(self, "putGreaterThan", [value]))

    @jsii.member(jsii_name="putLessThan")
    def put_less_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionLessThan()

        return typing.cast(None, jsii.invoke(self, "putLessThan", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetDimension")
    def reset_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimension", []))

    @jsii.member(jsii_name="resetDimensionVar")
    def reset_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimensionVar", []))

    @jsii.member(jsii_name="resetEqual")
    def reset_equal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEqual", []))

    @jsii.member(jsii_name="resetGreaterThan")
    def reset_greater_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGreaterThan", []))

    @jsii.member(jsii_name="resetLessThan")
    def reset_less_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLessThan", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="equal")
    def equal(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionEqualOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionEqualOutputReference, jsii.get(self, "equal"))

    @builtins.property
    @jsii.member(jsii_name="greaterThan")
    def greater_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionGreaterThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionGreaterThanOutputReference, jsii.get(self, "greaterThan"))

    @builtins.property
    @jsii.member(jsii_name="lessThan")
    def less_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionLessThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionLessThanOutputReference, jsii.get(self, "lessThan"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionInput")
    def dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionVarInput")
    def dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="equalInput")
    def equal_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionEqual], jsii.get(self, "equalInput"))

    @builtins.property
    @jsii.member(jsii_name="greaterThanInput")
    def greater_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionGreaterThan], jsii.get(self, "greaterThanInput"))

    @builtins.property
    @jsii.member(jsii_name="lessThanInput")
    def less_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionLessThan], jsii.get(self, "lessThanInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="dimension")
    def dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimension"))

    @dimension.setter
    def dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c7fcd9c7e888632ab162c37680cc7ab6d2b13f3aa92ea257d2f26057a0af20b1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimension", value)

    @builtins.property
    @jsii.member(jsii_name="dimensionVar")
    def dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimensionVar"))

    @dimension_var.setter
    def dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d804104cc518057e4cf54e88c549c025703c11eff57ce9871ecccf8c9c76e8be)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__53d50dfea25037b9e3562d6be736affc245e0c5e5008fd09857cdd4175dd4cfa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f643cb146f452c81a52338c70b09841275494ce02856ecdc74ea4ca5865d5069)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimension]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimension]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimension]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9e9b21d6bf649b49a69ded5f08569ae77da952f1b6dbfa97290a87ebf39631e5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientation",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "landscape": "landscape",
        "portrait": "portrait",
        "square": "square",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientation:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        landscape: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationLandscape", typing.Dict[builtins.str, typing.Any]]] = None,
        portrait: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationPortrait", typing.Dict[builtins.str, typing.Any]]] = None,
        square: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationSquare", typing.Dict[builtins.str, typing.Any]]] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param landscape: landscape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        :param portrait: portrait block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        :param square: square block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationDefault(**default)
        if isinstance(landscape, dict):
            landscape = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationLandscape(**landscape)
        if isinstance(portrait, dict):
            portrait = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationPortrait(**portrait)
        if isinstance(square, dict):
            square = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationSquare(**square)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e5afa49f35933bfc2958d9f91964d571cce9e339ae8bb982e8e5948d4697e1b7)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument landscape", value=landscape, expected_type=type_hints["landscape"])
            check_type(argname="argument portrait", value=portrait, expected_type=type_hints["portrait"])
            check_type(argname="argument square", value=square, expected_type=type_hints["square"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if landscape is not None:
            self._values["landscape"] = landscape
        if portrait is not None:
            self._values["portrait"] = portrait
        if square is not None:
            self._values["square"] = square

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationDefault"], result)

    @builtins.property
    def landscape(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationLandscape"]:
        '''landscape block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        '''
        result = self._values.get("landscape")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationLandscape"], result)

    @builtins.property
    def portrait(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationPortrait"]:
        '''portrait block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        '''
        result = self._values.get("portrait")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationPortrait"], result)

    @builtins.property
    def square(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationSquare"]:
        '''square block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        result = self._values.get("square")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationSquare"], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e231ff3232f316bf4669cd860cbfce35a79a765cab05cdd81c850bea25b3dec)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e0b7fcd80a92561a6e9fb62a8320476cc3a14594283cbb0b163afdfb325f3cb7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationLandscape",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationLandscape:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationLandscape(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationLandscapeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationLandscapeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d2705c61b2bcce29e41214a9d8f5ad7c7908cb89aec37975a06b45b56b5c2b45)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationLandscape], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationLandscape],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__29f9cb6033aa8d106b0c6ec7f8799ff4b59ea83d20b965d15024feeaa9de1c9c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a945729598c6d3f669c2696b270c7dd78f927c0a1232a379372c60704cb5a956)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a7a864c5a27001672fd9db02d3781c1d2ea62b71024818485badaedf57a74c28)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__48fe7498fd515ec2486527270c61152b0709a20d40a3de2c0ca4680bf6840fb7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5da95dd3dacff63131130ae2b20665702e606cad517b766dbbb015994eb70f84)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__da6be360904fdb71b6773d8afb9c028d7e39109b285822ae34a730dd9fe128fe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientation]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientation]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a020a150f437831710c176d67426dbd7bc07103baae94d9904e8376e29b4fe46)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__60e8146d01c3494b3e734759123454010defe12b5242f5464b1b788774d9a85b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putLandscape")
    def put_landscape(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationLandscape()

        return typing.cast(None, jsii.invoke(self, "putLandscape", [value]))

    @jsii.member(jsii_name="putPortrait")
    def put_portrait(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationPortrait()

        return typing.cast(None, jsii.invoke(self, "putPortrait", [value]))

    @jsii.member(jsii_name="putSquare")
    def put_square(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationSquare()

        return typing.cast(None, jsii.invoke(self, "putSquare", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetLandscape")
    def reset_landscape(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLandscape", []))

    @jsii.member(jsii_name="resetPortrait")
    def reset_portrait(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPortrait", []))

    @jsii.member(jsii_name="resetSquare")
    def reset_square(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSquare", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="landscape")
    def landscape(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationLandscapeOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationLandscapeOutputReference, jsii.get(self, "landscape"))

    @builtins.property
    @jsii.member(jsii_name="portrait")
    def portrait(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationPortraitOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationPortraitOutputReference", jsii.get(self, "portrait"))

    @builtins.property
    @jsii.member(jsii_name="square")
    def square(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationSquareOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationSquareOutputReference", jsii.get(self, "square"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="landscapeInput")
    def landscape_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationLandscape], jsii.get(self, "landscapeInput"))

    @builtins.property
    @jsii.member(jsii_name="portraitInput")
    def portrait_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationPortrait"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationPortrait"], jsii.get(self, "portraitInput"))

    @builtins.property
    @jsii.member(jsii_name="squareInput")
    def square_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationSquare"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationSquare"], jsii.get(self, "squareInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientation]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientation]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientation]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b45d228ab55e84380109a8371cdce7d733d87f0dd5a923e0b73eeaa91c8d2d45)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationPortrait",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationPortrait:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationPortrait(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationPortraitOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationPortraitOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e4f3f5efa292ba3674dfe978ea4c2bd57280b8baf960635acc9877cd93f125da)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationPortrait]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationPortrait], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationPortrait],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__13b546fb96a39dd0c412c0e1c100a5f25b9ea1f81310b3c152b344557f879afa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationSquare",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationSquare:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationSquare(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationSquareOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationSquareOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d4ae01f823bd1683dc4953b94d0eceee8ee46bec30c9c3018c4b2c1ccfb15fb)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationSquare]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationSquare], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationSquare],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9bbac0480bc6ab4db1fe4c3d57c6a870b6fa0b83bb65bf505d63e6c8519fc203)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanMaxColors",
    jsii_struct_bases=[],
    name_mapping={"colors": "colors", "colors_var": "colorsVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanMaxColors:
    def __init__(
        self,
        *,
        colors: typing.Optional[builtins.str] = None,
        colors_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param colors: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        :param colors_var: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac6bf17d403c92672c592f7944ce403db79b22b88071c2b262e6b6e05964f4c9)
            check_type(argname="argument colors", value=colors, expected_type=type_hints["colors"])
            check_type(argname="argument colors_var", value=colors_var, expected_type=type_hints["colors_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if colors is not None:
            self._values["colors"] = colors
        if colors_var is not None:
            self._values["colors_var"] = colors_var

    @builtins.property
    def colors(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        '''
        result = self._values.get("colors")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def colors_var(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        result = self._values.get("colors_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanMaxColors(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanMaxColorsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanMaxColorsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a34bb56693b9bd42e99c9180cfaf67e4ef7d16a758c9aff9e794a60e42b12e2a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanMaxColorsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__609dbe9dce85526633b8c35ed7443909bd3c2b5d9c3762b66d6bf8d0774336c0)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanMaxColorsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e88100563edb31c489d7d27bff89be5d86ed71d681b321c702f291f0f0d5ef6b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f0c265809c7667d5dfcac3c0f15fc88ac45b98de37dbc55302ac40932a1c8538)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a5e7ce4af5940293bcbda9a81e6dfcef1be4cb50f4ea8964b9c46ae49abc8d77)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanMaxColors]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanMaxColors]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3677b3bc5e80653425298d6104386a36c4f678cb52c22b1ad8cc1ba72124625c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanMaxColorsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanMaxColorsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2972fbc7a7c75556b79d8ea9c8e1e3541ee4d2398acbc0c84bb306ae3d570cc6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColors")
    def reset_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColors", []))

    @jsii.member(jsii_name="resetColorsVar")
    def reset_colors_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorsVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorsInput")
    def colors_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsInput"))

    @builtins.property
    @jsii.member(jsii_name="colorsVarInput")
    def colors_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsVarInput"))

    @builtins.property
    @jsii.member(jsii_name="colors")
    def colors(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colors"))

    @colors.setter
    def colors(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8988a8af13b5e6773b9507847a4ef4c991d3f295b85a07be6429db5c03296475)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colors", value)

    @builtins.property
    @jsii.member(jsii_name="colorsVar")
    def colors_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorsVar"))

    @colors_var.setter
    def colors_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8f5444fe0ce8097c187d580c6f9ce6e9ea346046c07d2bf9b1535d5801515405)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorsVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanMaxColors]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanMaxColors]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanMaxColors]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e07e9161a86bc150a943bb273f91031e546d3133efecd9cb627cc299f0f39aed)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanMirror",
    jsii_struct_bases=[],
    name_mapping={
        "horizontal": "horizontal",
        "horizontal_var": "horizontalVar",
        "vertical": "vertical",
        "vertical_var": "verticalVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanMirror:
    def __init__(
        self,
        *,
        horizontal: typing.Optional[builtins.str] = None,
        horizontal_var: typing.Optional[builtins.str] = None,
        vertical: typing.Optional[builtins.str] = None,
        vertical_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param horizontal: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        :param horizontal_var: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        :param vertical: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        :param vertical_var: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ca036daa74af8b134ff4955aff9785bdea334fb0b3fa02a20ecbf73a8ae6b69)
            check_type(argname="argument horizontal", value=horizontal, expected_type=type_hints["horizontal"])
            check_type(argname="argument horizontal_var", value=horizontal_var, expected_type=type_hints["horizontal_var"])
            check_type(argname="argument vertical", value=vertical, expected_type=type_hints["vertical"])
            check_type(argname="argument vertical_var", value=vertical_var, expected_type=type_hints["vertical_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if horizontal is not None:
            self._values["horizontal"] = horizontal
        if horizontal_var is not None:
            self._values["horizontal_var"] = horizontal_var
        if vertical is not None:
            self._values["vertical"] = vertical
        if vertical_var is not None:
            self._values["vertical_var"] = vertical_var

    @builtins.property
    def horizontal(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        '''
        result = self._values.get("horizontal")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def horizontal_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        '''
        result = self._values.get("horizontal_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        '''
        result = self._values.get("vertical")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        result = self._values.get("vertical_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanMirror(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanMirrorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanMirrorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__87f2386116f7604d1af53098c116cf0d12eca512c00de54776a6d3a05939b958)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanMirrorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__badadf5792ee6f97371eb8637dbb2fe2e9dec3c6c01328b47c91ecc6e08f19f8)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanMirrorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2006f511e28ffd98cedff7f4ed9f47c71044134718b8a827f5e429271b0f201b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8908db83b6fcd9f6f3f5938fce05293fbae40e0011f6867b92cbbd7eeff1f11a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c793b3b52f7feff3cc4aba865a782c6392a262822d079909d1d65b7a9f7e8b7d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanMirror]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanMirror]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3cd9c2a28ca52a69d1d89ae59c8f3b47338bfa18f20104b57dedb47a7e65f329)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanMirrorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanMirrorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__255e4fc950e7448282cb7eeebba86d8641c28deafadc3e23c20dd8dee0be201b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHorizontal")
    def reset_horizontal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontal", []))

    @jsii.member(jsii_name="resetHorizontalVar")
    def reset_horizontal_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontalVar", []))

    @jsii.member(jsii_name="resetVertical")
    def reset_vertical(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVertical", []))

    @jsii.member(jsii_name="resetVerticalVar")
    def reset_vertical_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVerticalVar", []))

    @builtins.property
    @jsii.member(jsii_name="horizontalInput")
    def horizontal_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontalVarInput")
    def horizontal_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalInput")
    def vertical_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalVarInput")
    def vertical_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontal")
    def horizontal(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontal"))

    @horizontal.setter
    def horizontal(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d328755855a86355c79e231706ce30b2c9d599ad9f2287b02e3eff2449fd696)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontal", value)

    @builtins.property
    @jsii.member(jsii_name="horizontalVar")
    def horizontal_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontalVar"))

    @horizontal_var.setter
    def horizontal_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__423f2e1937a7059bbee2c5a4d1db68d11b00d3f8a7927e07cf0a37ec19d26248)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontalVar", value)

    @builtins.property
    @jsii.member(jsii_name="vertical")
    def vertical(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "vertical"))

    @vertical.setter
    def vertical(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ef43ac34ac65f1047a116ad6ff3af3690762cd5259e4e13e57821e0177fb35c6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "vertical", value)

    @builtins.property
    @jsii.member(jsii_name="verticalVar")
    def vertical_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "verticalVar"))

    @vertical_var.setter
    def vertical_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f4029b8d40160a11581703c0355504447a37f4b6429bc9b11b2fdcc2a9faef1a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "verticalVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanMirror]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanMirror]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanMirror]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ba1f897855707bd09d26a2c148acb5e5ecf42e5cca15ef837e0d2ada6532e318)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanMonoHue",
    jsii_struct_bases=[],
    name_mapping={"hue": "hue", "hue_var": "hueVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanMonoHue:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9599ebc216fa4250ce430ed7e0369607f97ccf1fb35973d52c05fbece8aca233)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanMonoHue(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanMonoHueList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanMonoHueList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__74c1997044d4d2a7f9645e93fb25e2321f46e9efec78ccba4b485d06f7232396)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanMonoHueOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__98b4e697f4bc85a756ade3ac57e030f57f341e76d3468d3f7ffa99ffc0db74d3)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanMonoHueOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__99f7568dfe4432851ea9dc49e4c7f91f010642ad3bc4ee991447912c781006a0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be817c79d131fea7ff25e4fbb4f111677c0cb03dde38556e17ee8ea18b4af16e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__617dcc5eb93887d33b5cf0492c37c8276517f3d6ec1bb49d4cdca4bb545ba18f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanMonoHue]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanMonoHue]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9f3d869654720f693c58873a50256e2cea2caad5f1094b36681dc6beb8cf4de2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanMonoHueOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanMonoHueOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c73ba6f49bd5d02528a19ab891ee91c765d226c663cb582389b8f57c332590e9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb38031ad4a474947ef1b5eb3e853343304431b93247d8949e5911a0fac3c153)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b65e035e085d545997bd3466d001780e10c33bdbc4bdf45fc93a4b9edd95d670)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanMonoHue]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanMonoHue]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanMonoHue]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3dfda074423531e610fdd9b8fb498803d3bae19f3dfef736c0f801e93a7faccc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanOpacity",
    jsii_struct_bases=[],
    name_mapping={"opacity": "opacity", "opacity_var": "opacityVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanOpacity:
    def __init__(
        self,
        *,
        opacity: typing.Optional[builtins.str] = None,
        opacity_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param opacity: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param opacity_var: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ecd888c662a6b3c3484134121cf65c5ffa2c794768c1e43a46957043106b3e76)
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument opacity_var", value=opacity_var, expected_type=type_hints["opacity_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if opacity is not None:
            self._values["opacity"] = opacity
        if opacity_var is not None:
            self._values["opacity_var"] = opacity_var

    @builtins.property
    def opacity(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def opacity_var(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        result = self._values.get("opacity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanOpacity(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanOpacityList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanOpacityList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7024f363a06615b0a33d795b690e6a504bb3f6732fa8ed69deef381cf20111c9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanOpacityOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3046e1959cc84e12e1c4cade31ddde80546f44f64835b47b805b8bb6b065d8d6)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanOpacityOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f821d6a864776b36407ce128b4de7586211df8ad1748fdf8d70c97c6abc9f84b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4cd09042bc43fc3f8b9f484c40d8e6a267cb722e3dd6fca8691f0d69858df110)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d4928ac2d17b789bb22439cd1299eb50c35571b5e9823ceca1e3a2b8cce617a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanOpacity]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanOpacity]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d6fef3bd9c3c9abe650ec051ec46c73e562b8a4b740e956e6b0a27768cb5fbe5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanOpacityOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanOpacityOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__72634591cd2910ce1bb731f94108ef0fb5a71a14c1cc31779e40e2b3a224104d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetOpacityVar")
    def reset_opacity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacityVar", []))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityVarInput")
    def opacity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacity"))

    @opacity.setter
    def opacity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e83283e881625a81fd2e98530b9e6848e6de3b61b8e7b793a64e8578478d055f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacity", value)

    @builtins.property
    @jsii.member(jsii_name="opacityVar")
    def opacity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacityVar"))

    @opacity_var.setter
    def opacity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__936150fac57affcf794537d3e251aeabde34cb6069b80284f2c6f102faf2b724)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacityVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanOpacity]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanOpacity]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanOpacity]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__103102cd0e07d5679d5c79ad369ab282a599d343f92d8c0535e09281765e8ac2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a48f4d0afb08bdab14a11369b538cbcad6efab5c0ae3b91edcb3d2ce34b81ac3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putBackgroundColor")
    def put_background_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__485050d47b3ef503f5d2b7bd66d7d3300084a2d03d61ff2c069c1a36a5030da6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBackgroundColor", [value]))

    @jsii.member(jsii_name="putBlur")
    def put_blur(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanBlur, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__20d5547076469f324926c4a890a48f3d0e581c4d036cf5ad8f5fa38064c62989)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBlur", [value]))

    @jsii.member(jsii_name="putChromaKey")
    def put_chroma_key(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanChromaKey, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fc29edfaebca9fa71d66cc3a5bd9bf36c5a67845a56ab98f728b840089174c68)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putChromaKey", [value]))

    @jsii.member(jsii_name="putComposite")
    def put_composite(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanComposite, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f7e5bc92762a5f76c3bbf79390b4058965b0e3d5b23129bc660a7a6aa634e5ef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putComposite", [value]))

    @jsii.member(jsii_name="putCompound")
    def put_compound(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanCompound, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__60fba4cf4665eb090cbdc22a04a5288f97edcea878204921db444facf56ed05f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCompound", [value]))

    @jsii.member(jsii_name="putContrast")
    def put_contrast(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanContrast, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ff10ae9eba935177908f93f23781551b8301069dec208dfc5884f706ee8f9fb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putContrast", [value]))

    @jsii.member(jsii_name="putGoop")
    def put_goop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanGoop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bf745b566c6bbbeccb4e619f10854aee1b845589fd62f1dcbf46e77724c4b447)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGoop", [value]))

    @jsii.member(jsii_name="putGrayscale")
    def put_grayscale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanGrayscale, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ee465692fa5e66c86d24a8ced3b34a56d8cbfd457dd1e2302620c64a5965710f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGrayscale", [value]))

    @jsii.member(jsii_name="putHsl")
    def put_hsl(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanHsl, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1ae5b45c53b31ab6999f93c722453b984982f5c8d636cae47f8e50fc0da46ad7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsl", [value]))

    @jsii.member(jsii_name="putHsv")
    def put_hsv(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanHsv, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__607aa2ecdb57b5a41f5b226f6441928c5f18deb9d09aac9bd1556b8270256ce4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsv", [value]))

    @jsii.member(jsii_name="putIfDimension")
    def put_if_dimension(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimension, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa13a6d51387b5484e4f5301db0e48a1be980b63f91c3a4ed743e79bc35d98d0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfDimension", [value]))

    @jsii.member(jsii_name="putIfOrientation")
    def put_if_orientation(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__13e148129d8223f97691a3e8deb34afdf2c7c36763b3e9908d60b0a8734532ed)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfOrientation", [value]))

    @jsii.member(jsii_name="putMaxColors")
    def put_max_colors(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanMaxColors, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f127f75f1c165923f02d2cea55be666b07e1563adb8c8d95563d6f4476d3c86b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMaxColors", [value]))

    @jsii.member(jsii_name="putMirror")
    def put_mirror(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanMirror, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3c11367ecc2ec61577f476206638e1d308613aeb6bfdb74c8893e40814b0aa3f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMirror", [value]))

    @jsii.member(jsii_name="putMonoHue")
    def put_mono_hue(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanMonoHue, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7618406e05908ce18bc3ad785f0effd6a14dec400593384c0e2cc5facfd632be)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMonoHue", [value]))

    @jsii.member(jsii_name="putOpacity")
    def put_opacity(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanOpacity, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d783cae53f3977bf331994959d8cda94ad8880dca1479dbe808f8f51522ad84e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putOpacity", [value]))

    @jsii.member(jsii_name="putRemoveColor")
    def put_remove_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanRemoveColor", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9594e6017117f6259fdb3a6bc204e4224a76948e56a3e5a207aa126754be4478)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRemoveColor", [value]))

    @jsii.member(jsii_name="putUnsharpMask")
    def put_unsharp_mask(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanUnsharpMask", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0c0447f36d6366a20402807de4ee6b89837e6e0079d0de4649b149b1567f61a2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putUnsharpMask", [value]))

    @jsii.member(jsii_name="resetBackgroundColor")
    def reset_background_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBackgroundColor", []))

    @jsii.member(jsii_name="resetBlur")
    def reset_blur(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBlur", []))

    @jsii.member(jsii_name="resetChromaKey")
    def reset_chroma_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChromaKey", []))

    @jsii.member(jsii_name="resetComposite")
    def reset_composite(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetComposite", []))

    @jsii.member(jsii_name="resetCompound")
    def reset_compound(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCompound", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetGoop")
    def reset_goop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGoop", []))

    @jsii.member(jsii_name="resetGrayscale")
    def reset_grayscale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGrayscale", []))

    @jsii.member(jsii_name="resetHsl")
    def reset_hsl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsl", []))

    @jsii.member(jsii_name="resetHsv")
    def reset_hsv(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsv", []))

    @jsii.member(jsii_name="resetIfDimension")
    def reset_if_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfDimension", []))

    @jsii.member(jsii_name="resetIfOrientation")
    def reset_if_orientation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfOrientation", []))

    @jsii.member(jsii_name="resetMaxColors")
    def reset_max_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxColors", []))

    @jsii.member(jsii_name="resetMirror")
    def reset_mirror(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMirror", []))

    @jsii.member(jsii_name="resetMonoHue")
    def reset_mono_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonoHue", []))

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetRemoveColor")
    def reset_remove_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRemoveColor", []))

    @jsii.member(jsii_name="resetUnsharpMask")
    def reset_unsharp_mask(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUnsharpMask", []))

    @builtins.property
    @jsii.member(jsii_name="backgroundColor")
    def background_color(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanBackgroundColorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanBackgroundColorList, jsii.get(self, "backgroundColor"))

    @builtins.property
    @jsii.member(jsii_name="blur")
    def blur(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanBlurList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanBlurList, jsii.get(self, "blur"))

    @builtins.property
    @jsii.member(jsii_name="chromaKey")
    def chroma_key(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanChromaKeyList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanChromaKeyList, jsii.get(self, "chromaKey"))

    @builtins.property
    @jsii.member(jsii_name="composite")
    def composite(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanCompositeList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanCompositeList, jsii.get(self, "composite"))

    @builtins.property
    @jsii.member(jsii_name="compound")
    def compound(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanCompoundList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanCompoundList, jsii.get(self, "compound"))

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanContrastList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanContrastList, jsii.get(self, "contrast"))

    @builtins.property
    @jsii.member(jsii_name="goop")
    def goop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanGoopList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanGoopList, jsii.get(self, "goop"))

    @builtins.property
    @jsii.member(jsii_name="grayscale")
    def grayscale(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanGrayscaleList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanGrayscaleList, jsii.get(self, "grayscale"))

    @builtins.property
    @jsii.member(jsii_name="hsl")
    def hsl(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanHslList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanHslList, jsii.get(self, "hsl"))

    @builtins.property
    @jsii.member(jsii_name="hsv")
    def hsv(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanHsvList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanHsvList, jsii.get(self, "hsv"))

    @builtins.property
    @jsii.member(jsii_name="ifDimension")
    def if_dimension(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionList, jsii.get(self, "ifDimension"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientation")
    def if_orientation(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationList, jsii.get(self, "ifOrientation"))

    @builtins.property
    @jsii.member(jsii_name="maxColors")
    def max_colors(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanMaxColorsList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanMaxColorsList, jsii.get(self, "maxColors"))

    @builtins.property
    @jsii.member(jsii_name="mirror")
    def mirror(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanMirrorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanMirrorList, jsii.get(self, "mirror"))

    @builtins.property
    @jsii.member(jsii_name="monoHue")
    def mono_hue(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanMonoHueList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanMonoHueList, jsii.get(self, "monoHue"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanOpacityList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanOpacityList, jsii.get(self, "opacity"))

    @builtins.property
    @jsii.member(jsii_name="removeColor")
    def remove_color(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanRemoveColorList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanRemoveColorList", jsii.get(self, "removeColor"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMask")
    def unsharp_mask(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanUnsharpMaskList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanUnsharpMaskList", jsii.get(self, "unsharpMask"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColorInput")
    def background_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanBackgroundColor]]], jsii.get(self, "backgroundColorInput"))

    @builtins.property
    @jsii.member(jsii_name="blurInput")
    def blur_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanBlur]]], jsii.get(self, "blurInput"))

    @builtins.property
    @jsii.member(jsii_name="chromaKeyInput")
    def chroma_key_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanChromaKey]]], jsii.get(self, "chromaKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="compositeInput")
    def composite_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanComposite]]], jsii.get(self, "compositeInput"))

    @builtins.property
    @jsii.member(jsii_name="compoundInput")
    def compound_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanCompound]]], jsii.get(self, "compoundInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanContrast]]], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="goopInput")
    def goop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanGoop]]], jsii.get(self, "goopInput"))

    @builtins.property
    @jsii.member(jsii_name="grayscaleInput")
    def grayscale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanGrayscale]]], jsii.get(self, "grayscaleInput"))

    @builtins.property
    @jsii.member(jsii_name="hslInput")
    def hsl_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanHsl]]], jsii.get(self, "hslInput"))

    @builtins.property
    @jsii.member(jsii_name="hsvInput")
    def hsv_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanHsv]]], jsii.get(self, "hsvInput"))

    @builtins.property
    @jsii.member(jsii_name="ifDimensionInput")
    def if_dimension_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimension]]], jsii.get(self, "ifDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientationInput")
    def if_orientation_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientation]]], jsii.get(self, "ifOrientationInput"))

    @builtins.property
    @jsii.member(jsii_name="maxColorsInput")
    def max_colors_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanMaxColors]]], jsii.get(self, "maxColorsInput"))

    @builtins.property
    @jsii.member(jsii_name="mirrorInput")
    def mirror_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanMirror]]], jsii.get(self, "mirrorInput"))

    @builtins.property
    @jsii.member(jsii_name="monoHueInput")
    def mono_hue_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanMonoHue]]], jsii.get(self, "monoHueInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanOpacity]]], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="removeColorInput")
    def remove_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanRemoveColor"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanRemoveColor"]]], jsii.get(self, "removeColorInput"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMaskInput")
    def unsharp_mask_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanUnsharpMask"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanUnsharpMask"]]], jsii.get(self, "unsharpMaskInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9975111876e5327b6476954d1d356b271e0828ee3ccfb609890ab4de5b9e908d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanRemoveColor",
    jsii_struct_bases=[],
    name_mapping={
        "color": "color",
        "color_var": "colorVar",
        "feather": "feather",
        "feather_var": "featherVar",
        "tolerance": "tolerance",
        "tolerance_var": "toleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanRemoveColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
        feather: typing.Optional[builtins.str] = None,
        feather_var: typing.Optional[builtins.str] = None,
        tolerance: typing.Optional[builtins.str] = None,
        tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        :param feather: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        :param feather_var: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        :param tolerance: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        :param tolerance_var: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__803c07275b583987c625a3cca186af18eec3071a627dfdba9356aed64e807af9)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
            check_type(argname="argument feather", value=feather, expected_type=type_hints["feather"])
            check_type(argname="argument feather_var", value=feather_var, expected_type=type_hints["feather_var"])
            check_type(argname="argument tolerance", value=tolerance, expected_type=type_hints["tolerance"])
            check_type(argname="argument tolerance_var", value=tolerance_var, expected_type=type_hints["tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var
        if feather is not None:
            self._values["feather"] = feather
        if feather_var is not None:
            self._values["feather_var"] = feather_var
        if tolerance is not None:
            self._values["tolerance"] = tolerance
        if tolerance_var is not None:
            self._values["tolerance_var"] = tolerance_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        '''
        result = self._values.get("feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather_var(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        '''
        result = self._values.get("feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        '''
        result = self._values.get("tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance_var(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        result = self._values.get("tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanRemoveColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanRemoveColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanRemoveColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4f197b752460a77f92f018d7d5283a474c058298afc58a321b1912fa2d0093a8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanRemoveColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e03ac70ff2e760089984b75963bad65d0bcc0b26c5ef56cd885cff790fffd6c4)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanRemoveColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e89e326bd72696421cae76f76b21a6f900d4a4eadf6a6059463eaa9b2e312930)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e90cb282a68725435becd1a2d0637b10c9d12202275f3764265c6f5aa62b55f6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d8c117f8577308aaae191ee53730920bf64189b9a23795b37dad95de6ff8a75a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanRemoveColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanRemoveColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanRemoveColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c06c8250a564c7e3b7de3b45d2f07b92e401ddcc476f029aa93c2a5045cfdfb6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanRemoveColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanRemoveColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__62001fbec57e060501ea6b6964036f225ccaa978c7ef3415b8e41075c341dae4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @jsii.member(jsii_name="resetFeather")
    def reset_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeather", []))

    @jsii.member(jsii_name="resetFeatherVar")
    def reset_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatherVar", []))

    @jsii.member(jsii_name="resetTolerance")
    def reset_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTolerance", []))

    @jsii.member(jsii_name="resetToleranceVar")
    def reset_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featherInput")
    def feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherInput"))

    @builtins.property
    @jsii.member(jsii_name="featherVarInput")
    def feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceInput")
    def tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceVarInput")
    def tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6bb0e399a015a35ab9ce8c3ef0b40a32d5668ef1aa9b4e3a5b9cf9861a4d7a68)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eb15d97333d11363f1c02a193ac2d16561f57b158ed580e77cc91fd9499e4535)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="feather")
    def feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "feather"))

    @feather.setter
    def feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__866a2cc7b82b5c0ecc3e2b98c4c28ab5c1e94ecf69df54f38192f13f939135c0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "feather", value)

    @builtins.property
    @jsii.member(jsii_name="featherVar")
    def feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featherVar"))

    @feather_var.setter
    def feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e5a040b006fdd8be7584902baa8d42b7b59171028767c686749394d9329fd4b0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featherVar", value)

    @builtins.property
    @jsii.member(jsii_name="tolerance")
    def tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tolerance"))

    @tolerance.setter
    def tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bf55b976d850a375bdb5a74d04a4b6c70025ef1916c6c025e2fbcfff2920f638)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tolerance", value)

    @builtins.property
    @jsii.member(jsii_name="toleranceVar")
    def tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "toleranceVar"))

    @tolerance_var.setter
    def tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__21e6333d9b574896c5066d274eb766238e7f04a782613d301a03e02b7b8b5eaf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "toleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanRemoveColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanRemoveColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanRemoveColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0689da878ae5aa311314f21c59de5d0f71851e0725ed69031e25e4e9b7a5bdd4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanUnsharpMask",
    jsii_struct_bases=[],
    name_mapping={
        "gain": "gain",
        "gain_var": "gainVar",
        "sigma": "sigma",
        "sigma_var": "sigmaVar",
        "threshold": "threshold",
        "threshold_var": "thresholdVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanUnsharpMask:
    def __init__(
        self,
        *,
        gain: typing.Optional[builtins.str] = None,
        gain_var: typing.Optional[builtins.str] = None,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
        threshold: typing.Optional[builtins.str] = None,
        threshold_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param gain: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        :param gain_var: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        :param sigma: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        :param threshold: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        :param threshold_var: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a545a253e265aa050da5c655f596c66b39409b018bec7843e632849023153cf9)
            check_type(argname="argument gain", value=gain, expected_type=type_hints["gain"])
            check_type(argname="argument gain_var", value=gain_var, expected_type=type_hints["gain_var"])
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
            check_type(argname="argument threshold", value=threshold, expected_type=type_hints["threshold"])
            check_type(argname="argument threshold_var", value=threshold_var, expected_type=type_hints["threshold_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if gain is not None:
            self._values["gain"] = gain
        if gain_var is not None:
            self._values["gain_var"] = gain_var
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var
        if threshold is not None:
            self._values["threshold"] = threshold
        if threshold_var is not None:
            self._values["threshold_var"] = threshold_var

    @builtins.property
    def gain(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        '''
        result = self._values.get("gain")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gain_var(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        '''
        result = self._values.get("gain_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        '''
        result = self._values.get("threshold")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold_var(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        result = self._values.get("threshold_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanUnsharpMask(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanUnsharpMaskList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanUnsharpMaskList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__01d6b8c966605fdebeca736e3c7cd1ed8e3892f52bb7a07743f4bf3dda5945b9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanUnsharpMaskOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0393b02a500b599f0874747cb1e4e57eff7368208dc193d2898bc4469445f248)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanUnsharpMaskOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c4926f53648523d674b2bbcd9ab454709409e2a21d28cbccdd3854a40f43cd21)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__40193bf07c2c8644eeef34aaa82d00a2494c6967396b41dafce3285eaa429f3a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6eb90095dfd1e2cab1a50af2cce6bdac149228cc86a4fe15242f62a39d92ecc2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanUnsharpMask]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanUnsharpMask]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanUnsharpMask]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a51a0b30c9d3d925bb3487ac905c1f5ce2c1837ac64933f75ccd6d3ed30cc3a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanUnsharpMaskOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanUnsharpMaskOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b37dc92bcab03e6006d20bfa9afe4bf44a9ece424b2275116634d9c4b8e56517)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetGain")
    def reset_gain(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGain", []))

    @jsii.member(jsii_name="resetGainVar")
    def reset_gain_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGainVar", []))

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @jsii.member(jsii_name="resetThreshold")
    def reset_threshold(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThreshold", []))

    @jsii.member(jsii_name="resetThresholdVar")
    def reset_threshold_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThresholdVar", []))

    @builtins.property
    @jsii.member(jsii_name="gainInput")
    def gain_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainInput"))

    @builtins.property
    @jsii.member(jsii_name="gainVarInput")
    def gain_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdInput")
    def threshold_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdVarInput")
    def threshold_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gain")
    def gain(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gain"))

    @gain.setter
    def gain(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__885c4a8095b2959a8ee176b7a2fdfc82d99213c813277982451bfe3e79572cbd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gain", value)

    @builtins.property
    @jsii.member(jsii_name="gainVar")
    def gain_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gainVar"))

    @gain_var.setter
    def gain_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3452d478d7eb3ec869465a6dea1408f84f2d88da9163a3d282dd2703ff1b9ffb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gainVar", value)

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3067c8b5d2e8ff65cbc7c41a1df30ae2b0bfc534751593bbea23225d14fc6852)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5fa1b37891a48dbbcc88beb1aaffa2501bc10ca4383b0b2cc021098423d406e7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="threshold")
    def threshold(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "threshold"))

    @threshold.setter
    def threshold(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__39e0cb39d3292f09844838a7c6591a9be9c774912d7ea8e2f3d91802e7c55696)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "threshold", value)

    @builtins.property
    @jsii.member(jsii_name="thresholdVar")
    def threshold_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "thresholdVar"))

    @threshold_var.setter
    def threshold_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b9c9e47aebdf6b10bf35592048dc3014708b8723ebe84256234a0e2bdbd8c0f7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "thresholdVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanUnsharpMask]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanUnsharpMask]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanUnsharpMask]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f477684b76ce89d273e38db1dd2037ce84ea8dbc19f24206f0818c5313d8b521)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThan",
    jsii_struct_bases=[],
    name_mapping={
        "background_color": "backgroundColor",
        "blur": "blur",
        "chroma_key": "chromaKey",
        "composite": "composite",
        "compound": "compound",
        "contrast": "contrast",
        "goop": "goop",
        "grayscale": "grayscale",
        "hsl": "hsl",
        "hsv": "hsv",
        "if_dimension": "ifDimension",
        "if_orientation": "ifOrientation",
        "max_colors": "maxColors",
        "mirror": "mirror",
        "mono_hue": "monoHue",
        "opacity": "opacity",
        "remove_color": "removeColor",
        "unsharp_mask": "unsharpMask",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThan:
    def __init__(
        self,
        *,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanBackgroundColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanBlur", typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanChromaKey", typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanComposite", typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanCompound", typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanContrast", typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanGoop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanGrayscale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanHsl", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanHsv", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfDimension", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfOrientation", typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanMaxColors", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanMirror", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanMonoHue", typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanOpacity", typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanRemoveColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanUnsharpMask", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__281854866461f4ed3c27e6068a66cc403d58dc59e89d4572e7b17cd29429c0cb)
            check_type(argname="argument background_color", value=background_color, expected_type=type_hints["background_color"])
            check_type(argname="argument blur", value=blur, expected_type=type_hints["blur"])
            check_type(argname="argument chroma_key", value=chroma_key, expected_type=type_hints["chroma_key"])
            check_type(argname="argument composite", value=composite, expected_type=type_hints["composite"])
            check_type(argname="argument compound", value=compound, expected_type=type_hints["compound"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument goop", value=goop, expected_type=type_hints["goop"])
            check_type(argname="argument grayscale", value=grayscale, expected_type=type_hints["grayscale"])
            check_type(argname="argument hsl", value=hsl, expected_type=type_hints["hsl"])
            check_type(argname="argument hsv", value=hsv, expected_type=type_hints["hsv"])
            check_type(argname="argument if_dimension", value=if_dimension, expected_type=type_hints["if_dimension"])
            check_type(argname="argument if_orientation", value=if_orientation, expected_type=type_hints["if_orientation"])
            check_type(argname="argument max_colors", value=max_colors, expected_type=type_hints["max_colors"])
            check_type(argname="argument mirror", value=mirror, expected_type=type_hints["mirror"])
            check_type(argname="argument mono_hue", value=mono_hue, expected_type=type_hints["mono_hue"])
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument remove_color", value=remove_color, expected_type=type_hints["remove_color"])
            check_type(argname="argument unsharp_mask", value=unsharp_mask, expected_type=type_hints["unsharp_mask"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if background_color is not None:
            self._values["background_color"] = background_color
        if blur is not None:
            self._values["blur"] = blur
        if chroma_key is not None:
            self._values["chroma_key"] = chroma_key
        if composite is not None:
            self._values["composite"] = composite
        if compound is not None:
            self._values["compound"] = compound
        if contrast is not None:
            self._values["contrast"] = contrast
        if goop is not None:
            self._values["goop"] = goop
        if grayscale is not None:
            self._values["grayscale"] = grayscale
        if hsl is not None:
            self._values["hsl"] = hsl
        if hsv is not None:
            self._values["hsv"] = hsv
        if if_dimension is not None:
            self._values["if_dimension"] = if_dimension
        if if_orientation is not None:
            self._values["if_orientation"] = if_orientation
        if max_colors is not None:
            self._values["max_colors"] = max_colors
        if mirror is not None:
            self._values["mirror"] = mirror
        if mono_hue is not None:
            self._values["mono_hue"] = mono_hue
        if opacity is not None:
            self._values["opacity"] = opacity
        if remove_color is not None:
            self._values["remove_color"] = remove_color
        if unsharp_mask is not None:
            self._values["unsharp_mask"] = unsharp_mask

    @builtins.property
    def background_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanBackgroundColor"]]]:
        '''background_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        '''
        result = self._values.get("background_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanBackgroundColor"]]], result)

    @builtins.property
    def blur(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanBlur"]]]:
        '''blur block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        '''
        result = self._values.get("blur")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanBlur"]]], result)

    @builtins.property
    def chroma_key(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanChromaKey"]]]:
        '''chroma_key block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        '''
        result = self._values.get("chroma_key")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanChromaKey"]]], result)

    @builtins.property
    def composite(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanComposite"]]]:
        '''composite block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        '''
        result = self._values.get("composite")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanComposite"]]], result)

    @builtins.property
    def compound(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanCompound"]]]:
        '''compound block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        '''
        result = self._values.get("compound")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanCompound"]]], result)

    @builtins.property
    def contrast(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanContrast"]]]:
        '''contrast block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanContrast"]]], result)

    @builtins.property
    def goop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanGoop"]]]:
        '''goop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        '''
        result = self._values.get("goop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanGoop"]]], result)

    @builtins.property
    def grayscale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanGrayscale"]]]:
        '''grayscale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        '''
        result = self._values.get("grayscale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanGrayscale"]]], result)

    @builtins.property
    def hsl(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanHsl"]]]:
        '''hsl block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        '''
        result = self._values.get("hsl")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanHsl"]]], result)

    @builtins.property
    def hsv(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanHsv"]]]:
        '''hsv block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        '''
        result = self._values.get("hsv")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanHsv"]]], result)

    @builtins.property
    def if_dimension(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfDimension"]]]:
        '''if_dimension block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        '''
        result = self._values.get("if_dimension")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfDimension"]]], result)

    @builtins.property
    def if_orientation(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfOrientation"]]]:
        '''if_orientation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        '''
        result = self._values.get("if_orientation")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfOrientation"]]], result)

    @builtins.property
    def max_colors(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanMaxColors"]]]:
        '''max_colors block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        '''
        result = self._values.get("max_colors")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanMaxColors"]]], result)

    @builtins.property
    def mirror(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanMirror"]]]:
        '''mirror block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        '''
        result = self._values.get("mirror")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanMirror"]]], result)

    @builtins.property
    def mono_hue(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanMonoHue"]]]:
        '''mono_hue block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        '''
        result = self._values.get("mono_hue")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanMonoHue"]]], result)

    @builtins.property
    def opacity(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanOpacity"]]]:
        '''opacity block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanOpacity"]]], result)

    @builtins.property
    def remove_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanRemoveColor"]]]:
        '''remove_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        '''
        result = self._values.get("remove_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanRemoveColor"]]], result)

    @builtins.property
    def unsharp_mask(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanUnsharpMask"]]]:
        '''unsharp_mask block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        result = self._values.get("unsharp_mask")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanUnsharpMask"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanBackgroundColor",
    jsii_struct_bases=[],
    name_mapping={"color": "color", "color_var": "colorVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanBackgroundColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fcf0a02ecbf55f116bebd145fe739cc4bc1efa07898658b990c36dae25d53501)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanBackgroundColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanBackgroundColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanBackgroundColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6ae80af1a7435e9874ae536dfd6558d5b5d35a89f586996cacac9c9511db3519)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanBackgroundColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b24654cd27a0a72c5827915c7b72934e0adf7b32131e7df7af1f5fbe31e0e4be)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanBackgroundColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__22c23ddbac9c3c88753f2f53ab0d63d32c5daafb69efa30e8c6b4ad9542878a7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eccf7f6e0f952447161ff2130ad5ed1533e4ef1fad91201c42c343f5737e4071)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d29215b0280938505b600cf6deee5bb0bc4a2647e31ea87e04b30157290a566)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanBackgroundColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanBackgroundColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e4bd384cf2d5e1330c2f447be58e52e3296edc9dc32d0b4330d930ccf9e55e22)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanBackgroundColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanBackgroundColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__18dbc08e8e8dffef4406556d2774539d6345abd9b3930eb28ad5c9ffc46363ef)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__170f57fd30163b5550a8b5fb1768ab54b0b008e8ad2735d5be6e725561da2170)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3646e620ad84ed92f8bc351c09bfaaab08fa661c21ec5c0ce1b7a5f4334098be)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanBackgroundColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanBackgroundColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanBackgroundColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d9b9448aaeb638f6c0138d2e82406a993b474d1f5c595fdc768103a796055378)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanBlur",
    jsii_struct_bases=[],
    name_mapping={"sigma": "sigma", "sigma_var": "sigmaVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanBlur:
    def __init__(
        self,
        *,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param sigma: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__574e8ba4760cd9e99d667ff998cc6d7f8aca64b7f1306794d3d4769a1ff3cbdb)
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanBlur(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanBlurList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanBlurList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ad0fcbf11b2841bdf6beb9bdd008ab120fa70aa89c46445e0cfaeca6772b2579)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanBlurOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__105440442cbadc05d6b25f0c19e77ca2ae765ad7f6cc320fc2d8b7e087c6552c)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanBlurOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__640246e31b5c35f2e15dec7de57934d72410411b2a85560e47071e8c93b4c1db)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1d17b446cc66ae72bd9df9f95e2bab88dad222de610755140c40784f80d68616)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__36fb51c2882334d8d1f1b95e5a4453045dfa58b8f5ebaec50d5fe9deccb2cb83)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanBlur]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanBlur]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac5d6dbb52a1ab2875467cee90f4c634a327be5a57a815d75d846c5c2bb6f528)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanBlurOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanBlurOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__340517e56c61d442d5ba5475012e5561fb88280f07655011537b220be7aafc3b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d30f9cd7c09d8f1e5df5f98c1d88460ea61bd1e988dc2e071ab21e5c1c357ada)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dd0a1e7f02b83755b1b1b582e7c1fca48a174f8e03b16299709518eddc0a1206)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanBlur]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanBlur]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanBlur]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ae6e04c689d881f2225fa73ec446085b4ae45795ede374227c7018b3196f0adf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanChromaKey",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_feather": "hueFeather",
        "hue_feather_var": "hueFeatherVar",
        "hue_tolerance": "hueTolerance",
        "hue_tolerance_var": "hueToleranceVar",
        "hue_var": "hueVar",
        "lightness_feather": "lightnessFeather",
        "lightness_feather_var": "lightnessFeatherVar",
        "lightness_tolerance": "lightnessTolerance",
        "lightness_tolerance_var": "lightnessToleranceVar",
        "saturation_feather": "saturationFeather",
        "saturation_feather_var": "saturationFeatherVar",
        "saturation_tolerance": "saturationTolerance",
        "saturation_tolerance_var": "saturationToleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanChromaKey:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_feather: typing.Optional[builtins.str] = None,
        hue_feather_var: typing.Optional[builtins.str] = None,
        hue_tolerance: typing.Optional[builtins.str] = None,
        hue_tolerance_var: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness_feather: typing.Optional[builtins.str] = None,
        lightness_feather_var: typing.Optional[builtins.str] = None,
        lightness_tolerance: typing.Optional[builtins.str] = None,
        lightness_tolerance_var: typing.Optional[builtins.str] = None,
        saturation_feather: typing.Optional[builtins.str] = None,
        saturation_feather_var: typing.Optional[builtins.str] = None,
        saturation_tolerance: typing.Optional[builtins.str] = None,
        saturation_tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_feather: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        :param hue_feather_var: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        :param hue_tolerance: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        :param hue_tolerance_var: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        :param hue_var: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness_feather: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        :param lightness_feather_var: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        :param lightness_tolerance: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        :param lightness_tolerance_var: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        :param saturation_feather: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        :param saturation_feather_var: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        :param saturation_tolerance: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        :param saturation_tolerance_var: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f5050be6add95661e99d44b543498c28c67ce2b2391d0d55461b1345ad95d1c3)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_feather", value=hue_feather, expected_type=type_hints["hue_feather"])
            check_type(argname="argument hue_feather_var", value=hue_feather_var, expected_type=type_hints["hue_feather_var"])
            check_type(argname="argument hue_tolerance", value=hue_tolerance, expected_type=type_hints["hue_tolerance"])
            check_type(argname="argument hue_tolerance_var", value=hue_tolerance_var, expected_type=type_hints["hue_tolerance_var"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness_feather", value=lightness_feather, expected_type=type_hints["lightness_feather"])
            check_type(argname="argument lightness_feather_var", value=lightness_feather_var, expected_type=type_hints["lightness_feather_var"])
            check_type(argname="argument lightness_tolerance", value=lightness_tolerance, expected_type=type_hints["lightness_tolerance"])
            check_type(argname="argument lightness_tolerance_var", value=lightness_tolerance_var, expected_type=type_hints["lightness_tolerance_var"])
            check_type(argname="argument saturation_feather", value=saturation_feather, expected_type=type_hints["saturation_feather"])
            check_type(argname="argument saturation_feather_var", value=saturation_feather_var, expected_type=type_hints["saturation_feather_var"])
            check_type(argname="argument saturation_tolerance", value=saturation_tolerance, expected_type=type_hints["saturation_tolerance"])
            check_type(argname="argument saturation_tolerance_var", value=saturation_tolerance_var, expected_type=type_hints["saturation_tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_feather is not None:
            self._values["hue_feather"] = hue_feather
        if hue_feather_var is not None:
            self._values["hue_feather_var"] = hue_feather_var
        if hue_tolerance is not None:
            self._values["hue_tolerance"] = hue_tolerance
        if hue_tolerance_var is not None:
            self._values["hue_tolerance_var"] = hue_tolerance_var
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness_feather is not None:
            self._values["lightness_feather"] = lightness_feather
        if lightness_feather_var is not None:
            self._values["lightness_feather_var"] = lightness_feather_var
        if lightness_tolerance is not None:
            self._values["lightness_tolerance"] = lightness_tolerance
        if lightness_tolerance_var is not None:
            self._values["lightness_tolerance_var"] = lightness_tolerance_var
        if saturation_feather is not None:
            self._values["saturation_feather"] = saturation_feather
        if saturation_feather_var is not None:
            self._values["saturation_feather_var"] = saturation_feather_var
        if saturation_tolerance is not None:
            self._values["saturation_tolerance"] = saturation_tolerance
        if saturation_tolerance_var is not None:
            self._values["saturation_tolerance_var"] = saturation_tolerance_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        '''
        result = self._values.get("hue_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        '''
        result = self._values.get("hue_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        '''
        result = self._values.get("hue_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        '''
        result = self._values.get("hue_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        '''
        result = self._values.get("lightness_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        '''
        result = self._values.get("lightness_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        '''
        result = self._values.get("lightness_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        '''
        result = self._values.get("lightness_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        '''
        result = self._values.get("saturation_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        '''
        result = self._values.get("saturation_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        '''
        result = self._values.get("saturation_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        result = self._values.get("saturation_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanChromaKey(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanChromaKeyList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanChromaKeyList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ae4046eb149d3d37963ff4b9057f7ebf06fbf2b235c0e320e5edf942d2d15c0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanChromaKeyOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2b38af8b6983b552809156896e3c0e1c0307aafd8de780311a62fc0de4e084c1)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanChromaKeyOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__412c14e0ee82ef7f7297ae8eef44777a61de86660213266d3a2954cb0f4755f2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__63fed677876376dd9372eae5861cff79bbeab5d1e1157d8992a473a7863f2724)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac9c7812f6e890896f3e4dbd7ceecdf198bff367420b9e67c4375e83f2bf7c01)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanChromaKey]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanChromaKey]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__25224385fd607784bad6d44d15a6dc647402e276406a40a6d1b8f7fc24ad7523)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanChromaKeyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanChromaKeyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4316abe51fbb3fa86626d1e0b3041650dc027bd3227de8d2ac911f9a4dbace50)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueFeather")
    def reset_hue_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeather", []))

    @jsii.member(jsii_name="resetHueFeatherVar")
    def reset_hue_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeatherVar", []))

    @jsii.member(jsii_name="resetHueTolerance")
    def reset_hue_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueTolerance", []))

    @jsii.member(jsii_name="resetHueToleranceVar")
    def reset_hue_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueToleranceVar", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightnessFeather")
    def reset_lightness_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeather", []))

    @jsii.member(jsii_name="resetLightnessFeatherVar")
    def reset_lightness_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeatherVar", []))

    @jsii.member(jsii_name="resetLightnessTolerance")
    def reset_lightness_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessTolerance", []))

    @jsii.member(jsii_name="resetLightnessToleranceVar")
    def reset_lightness_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessToleranceVar", []))

    @jsii.member(jsii_name="resetSaturationFeather")
    def reset_saturation_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeather", []))

    @jsii.member(jsii_name="resetSaturationFeatherVar")
    def reset_saturation_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeatherVar", []))

    @jsii.member(jsii_name="resetSaturationTolerance")
    def reset_saturation_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationTolerance", []))

    @jsii.member(jsii_name="resetSaturationToleranceVar")
    def reset_saturation_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherInput")
    def hue_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVarInput")
    def hue_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceInput")
    def hue_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVarInput")
    def hue_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherInput")
    def lightness_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVarInput")
    def lightness_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceInput")
    def lightness_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVarInput")
    def lightness_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherInput")
    def saturation_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVarInput")
    def saturation_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceInput")
    def saturation_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVarInput")
    def saturation_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a7fda9ec37f90d2eb0f2c70cc78445caf8ed9e9fc39f6987eb9eb48df94e2851)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeather")
    def hue_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeather"))

    @hue_feather.setter
    def hue_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__50435fd701b7afd08f92c056ee14b8f1721c5e08afc87c699108d6ba289b87b0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeather", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVar")
    def hue_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeatherVar"))

    @hue_feather_var.setter
    def hue_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ae2aa9058f2557838ff618a5883159c877876521d09c175f91b16d5127c783c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueTolerance")
    def hue_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueTolerance"))

    @hue_tolerance.setter
    def hue_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__64ef5901326e266e4afa8e3b696749fefe86fc779e938e8a87817b08a2dee07e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVar")
    def hue_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueToleranceVar"))

    @hue_tolerance_var.setter
    def hue_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4e4d8aa7153b15eebd01ba5a18e6d46633bfac06e44c32d0973a84f4490add98)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__96b92d7e4ef65e10dbba41693a719caacdd83688908d81631054c7dbc502dc91)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeather")
    def lightness_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeather"))

    @lightness_feather.setter
    def lightness_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__50e7268e2f6f2a933b0aae1fdaf009cf31f2cca2683bc31e2d4814fa479d4993)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeather", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVar")
    def lightness_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeatherVar"))

    @lightness_feather_var.setter
    def lightness_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9751b5168a4c9c02953db905ac2963004d8f18460bdad3b9e76971eec9477761)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessTolerance")
    def lightness_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessTolerance"))

    @lightness_tolerance.setter
    def lightness_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__07b1b31a68e4b86c78c243f6bb44575b13a87e02826d96952343745e11d582f3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVar")
    def lightness_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessToleranceVar"))

    @lightness_tolerance_var.setter
    def lightness_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea7d17bf9a1e47d6017365dddfc7f38ef3bd43468a4dc70002230fe38829cf93)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeather")
    def saturation_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeather"))

    @saturation_feather.setter
    def saturation_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f16a5dcfcdadbd17add06f742d4ca5593196f8e35e0fc283c092a6397dd4c42f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeather", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVar")
    def saturation_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeatherVar"))

    @saturation_feather_var.setter
    def saturation_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ce1f4c291b62a96b250ed61af4eaf12dc18bfce8e1b6bd2452ad6f6f4266deb7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationTolerance")
    def saturation_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationTolerance"))

    @saturation_tolerance.setter
    def saturation_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c00c61e5bd927a377ba6ac2ab7e47545d9fb427f834473770cecc4ae7627a4e0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVar")
    def saturation_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationToleranceVar"))

    @saturation_tolerance_var.setter
    def saturation_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__256d1d7c1ad20ec0ebed693f000ba68d8d972d4a4787613e9191d374f59f740d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanChromaKey]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanChromaKey]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanChromaKey]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e6347d0f931edde525bdbb42445e83ca9d2db754c186b4a3da6f9f22d721d88)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanComposite",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "placement": "placement",
        "placement_var": "placementVar",
        "scale": "scale",
        "scale_dimension": "scaleDimension",
        "scale_dimension_var": "scaleDimensionVar",
        "scale_var": "scaleVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanComposite:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanCompositeImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        placement: typing.Optional[builtins.str] = None,
        placement_var: typing.Optional[builtins.str] = None,
        scale: typing.Optional[builtins.str] = None,
        scale_dimension: typing.Optional[builtins.str] = None,
        scale_dimension_var: typing.Optional[builtins.str] = None,
        scale_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param placement: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        :param placement_var: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        :param scale: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param scale_dimension: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        :param scale_dimension_var: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        :param scale_var: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        :param x_position: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanCompositeImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a0ad5476817e160d7604ba85d790c8ba89e4d9aa4d9f6355cc1580bfa3ece6ba)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument placement", value=placement, expected_type=type_hints["placement"])
            check_type(argname="argument placement_var", value=placement_var, expected_type=type_hints["placement_var"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument scale_dimension", value=scale_dimension, expected_type=type_hints["scale_dimension"])
            check_type(argname="argument scale_dimension_var", value=scale_dimension_var, expected_type=type_hints["scale_dimension_var"])
            check_type(argname="argument scale_var", value=scale_var, expected_type=type_hints["scale_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if placement is not None:
            self._values["placement"] = placement
        if placement_var is not None:
            self._values["placement_var"] = placement_var
        if scale is not None:
            self._values["scale"] = scale
        if scale_dimension is not None:
            self._values["scale_dimension"] = scale_dimension
        if scale_dimension_var is not None:
            self._values["scale_dimension_var"] = scale_dimension_var
        if scale_var is not None:
            self._values["scale_var"] = scale_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanCompositeImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanCompositeImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        '''
        result = self._values.get("placement")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement_var(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        '''
        result = self._values.get("placement_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        '''
        result = self._values.get("scale_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        '''
        result = self._values.get("scale_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        '''
        result = self._values.get("scale_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanComposite(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanCompositeImage",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanCompositeImage:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanCompositeImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanCompositeImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanCompositeImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__242aac662e5fd521d6297a9b928872c24df5642b428ef53517fa82ff42a54d95)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanCompositeImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanCompositeImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e913a037ae91bcd25409681d60e1d47be66048dece95f41e8e8c82a2ebe8911f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanCompositeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanCompositeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__22172c1c919bf1ac95c3a4399b566f658e38f5ff36ac7dd0a4727f72cbf8b7cd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanCompositeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e25cc0386ad32c560d3db334052da990d6c641c40b5400887fab8e0609728504)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanCompositeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2600a56ad47834a65bfb3f89c2992169c994eaa42d6d688ffd595b67612dee39)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__55463f36d0e6eb8ba4e9b01b18ec3109ad569252798d9e60414344320a4c8aa4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4cc62c182a0e1df37c7eb46754709886a214ce8bb9e864bb8837a353ba3d3b04)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanComposite]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanComposite]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e1c73feebc95e475ba2865735ca3b5e1fcf88a798e0ae7557fc9f84301f85041)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanCompositeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanCompositeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eeb6a765b333dc05073504af8f331680e4971c2ec08e9b56aed48371dac392ed)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanCompositeImage()

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPlacement")
    def reset_placement(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacement", []))

    @jsii.member(jsii_name="resetPlacementVar")
    def reset_placement_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacementVar", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetScaleDimension")
    def reset_scale_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimension", []))

    @jsii.member(jsii_name="resetScaleDimensionVar")
    def reset_scale_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimensionVar", []))

    @jsii.member(jsii_name="resetScaleVar")
    def reset_scale_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanCompositeImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanCompositeImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanCompositeImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="placementInput")
    def placement_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementInput"))

    @builtins.property
    @jsii.member(jsii_name="placementVarInput")
    def placement_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionInput")
    def scale_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVarInput")
    def scale_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleVarInput")
    def scale_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5d01fc50b03f3b9b58fb7b87d55c8f6ce44de4a4e5c25691980126ec01d67731)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f8ce763bffa6c0d0645fb8e375b3b3b24f57cdc42327b24a01fc1baa1734fc04)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="placement")
    def placement(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placement"))

    @placement.setter
    def placement(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4e2176969b75d6c74eba2df300f3c3a55a67742c514eb38cf88887af4e52fac2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placement", value)

    @builtins.property
    @jsii.member(jsii_name="placementVar")
    def placement_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placementVar"))

    @placement_var.setter
    def placement_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d3e58e99bfcb5404d6644ca2cafa197bf42844c2dd577483ecbc176eb4b989ae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placementVar", value)

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scale"))

    @scale.setter
    def scale(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__29b39bb12d7e84cb38c7b718e94c634ed6017f35fd13e7c0764e36eedb5ea0bd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scale", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimension")
    def scale_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimension"))

    @scale_dimension.setter
    def scale_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5a9c9fa01dada2f8f66413d304fb5352d6f2c87e786ddf142689b175190ad3dd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimension", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVar")
    def scale_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimensionVar"))

    @scale_dimension_var.setter
    def scale_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1dc841343e3ad9e75387b8c2bb98fff590708c12391824462a73b4a41b6ef1f1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="scaleVar")
    def scale_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleVar"))

    @scale_var.setter
    def scale_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__48f50c26525b425b0e4f6fbbd222d8c590f321604aaaf083285205a71fd5723d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__db8fb6162c18eeee16534d0472d160e2ec7ff30272a102d25f4e00f45885717a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ad7b7080a97d9303e638e40b4512f11e6f5e69ab13bf520df374a6a2dd8aa39)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__03de32caff4e3cae5f0faabfb646a4ba4ac3c7c0a5be2dab266d23b7da66471d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fdab9cfbbff25ef697e1f515788ca42d3c86eb21d54bcc63f051b209f5f26eab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanComposite]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanComposite]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanComposite]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b6426cf40660eaf91d6a1ba25572c8649fe767a06dbd3e6e1ecf99432aff8791)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanCompound",
    jsii_struct_bases=[],
    name_mapping={"transformations": "transformations"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanCompound:
    def __init__(
        self,
        *,
        transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param transformations: transformations block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a976c1d293e28bf30960c4b17978985ded0d44bf21814b660439e733e80a3844)
            check_type(argname="argument transformations", value=transformations, expected_type=type_hints["transformations"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if transformations is not None:
            self._values["transformations"] = transformations

    @builtins.property
    def transformations(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanCompoundTransformations"]]]:
        '''transformations block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        result = self._values.get("transformations")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanCompoundTransformations"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanCompound(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanCompoundList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanCompoundList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1c97e7a1854ea56dfb0686ec7c441f0655fbda622d98024c54ce88f9ab4066da)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanCompoundOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__824c9b9858c3487a455ac745328aee1e0206a47012a981ef7ba7ada4f6169da6)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanCompoundOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__74e13c9cb39577854a26db7d820a82abed533e747145e381264b0f9b173498f1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8bf27d99eb3d5f93633327dfeeccb7a5e25de31a0a715734ecd4e8151429a5ee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df9b585f6177f758908c4d656eb07a9778dbf566ab0270bdb4a696f192a92018)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanCompound]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanCompound]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0d9579aaf5455e9101322db6e298354685d4ebb2cfda5c7299ee2d1a4a17b24a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanCompoundOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanCompoundOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eab45720eb240cb6b9d404ee8ad7da6747d65c733b2c94b46e542d28a421b902)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformations")
    def put_transformations(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__21630122ea666354fdaa74dce2253e88d755c5980b0d1a8e688fe5c9f0eb99a9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTransformations", [value]))

    @jsii.member(jsii_name="resetTransformations")
    def reset_transformations(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformations", []))

    @builtins.property
    @jsii.member(jsii_name="transformations")
    def transformations(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanCompoundTransformationsList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanCompoundTransformationsList", jsii.get(self, "transformations"))

    @builtins.property
    @jsii.member(jsii_name="transformationsInput")
    def transformations_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanCompoundTransformations"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanCompoundTransformations"]]], jsii.get(self, "transformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanCompound]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanCompound]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanCompound]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a78ec8459a2970dcfd616bcdfe2f166ce22d277d84c238c5cd96a3e6a66970c6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanCompoundTransformations",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanCompoundTransformations:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanCompoundTransformations(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanCompoundTransformationsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanCompoundTransformationsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__66e5536bca3ada973b9318b9a47f7c49e2c55d52005a50c38f67b87919f35389)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanCompoundTransformationsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__68853b18b6be6ee2a02ad45e0f83e54aa08d16e820637fd928d625cab7ae8158)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanCompoundTransformationsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f7b2059f740b5393d399587f3ea714e4384374de3033a81c250cb908fade79ad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__083dce7abc6cda7b2cab8ecef39ddbb0b4bc2f9813db1e2c2f60fdbdd2460dac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1b5eed422a536cbc094268c9961c484c321a9333424d52d62e1957acde41ba45)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanCompoundTransformations]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanCompoundTransformations]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanCompoundTransformations]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__67162188dda7ee4bdc11ae56570771eedb9cea3187c6f8f50481d87f9317cdeb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanCompoundTransformationsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanCompoundTransformationsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__626b68250eab483050d7c6d34ffa33bca7db3aff47b9043a794d5d14248465cc)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanCompoundTransformations]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanCompoundTransformations]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanCompoundTransformations]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6108ffe643b8bd36f0d45819f182ec069a34f95d81bc34386b784c2e60a61084)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanContrast",
    jsii_struct_bases=[],
    name_mapping={
        "brightness": "brightness",
        "brightness_var": "brightnessVar",
        "contrast": "contrast",
        "contrast_var": "contrastVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanContrast:
    def __init__(
        self,
        *,
        brightness: typing.Optional[builtins.str] = None,
        brightness_var: typing.Optional[builtins.str] = None,
        contrast: typing.Optional[builtins.str] = None,
        contrast_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param brightness: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        :param brightness_var: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        :param contrast: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param contrast_var: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b0d2c9a1b68370ebd84ae8a4a53a8caa607acb9b85b28142fde915afdf7156e8)
            check_type(argname="argument brightness", value=brightness, expected_type=type_hints["brightness"])
            check_type(argname="argument brightness_var", value=brightness_var, expected_type=type_hints["brightness_var"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument contrast_var", value=contrast_var, expected_type=type_hints["contrast_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if brightness is not None:
            self._values["brightness"] = brightness
        if brightness_var is not None:
            self._values["brightness_var"] = brightness_var
        if contrast is not None:
            self._values["contrast"] = contrast
        if contrast_var is not None:
            self._values["contrast_var"] = contrast_var

    @builtins.property
    def brightness(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        '''
        result = self._values.get("brightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def brightness_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        '''
        result = self._values.get("brightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        result = self._values.get("contrast_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanContrast(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanContrastList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanContrastList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f6e3b7a35d2da18eaeb6910c578280444047072179a6fded43103bce12823e6e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanContrastOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1ac856d57ef630eca1f3518f7ee1cdbdc95c5dacbbcb5d3d9c9547733cc0508a)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanContrastOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9c86e35fd0860f6273396a596208c86a3fe933ec6387ab30f7fb62735b58dd2d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__85c51f25e07b706708401b26f688d591dedcb5b05de4cc7e235f3d580a442212)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d9a8575bb7687d5b35e7b1772b53b2dfe67604c39d6a06deb794da5e5737a0a6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanContrast]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanContrast]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7c25cf28f7bfa3b761d9c0e2573d39a93b70e3489ce6b04d7ab6128ea2c555fc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanContrastOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanContrastOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__003a5e8160cd2f7b6c4b2e5dbe21289b51ef3ab43926f45b0de420a73e1bff05)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetBrightness")
    def reset_brightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightness", []))

    @jsii.member(jsii_name="resetBrightnessVar")
    def reset_brightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightnessVar", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetContrastVar")
    def reset_contrast_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrastVar", []))

    @builtins.property
    @jsii.member(jsii_name="brightnessInput")
    def brightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="brightnessVarInput")
    def brightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastVarInput")
    def contrast_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="brightness")
    def brightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightness"))

    @brightness.setter
    def brightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9b9ad197690cc58c68d7d7d6cc48bf9dd8427c3d00016a413277015869c090a7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightness", value)

    @builtins.property
    @jsii.member(jsii_name="brightnessVar")
    def brightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightnessVar"))

    @brightness_var.setter
    def brightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1ae0a4ee2b31320e34d3f13622c6973db97d113c1f85336973829c15e2fd4fc6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrast"))

    @contrast.setter
    def contrast(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3dc2b67cf0efce2666d911501bd25ea9d24a65c665810a7e985aac95fa207cdf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrast", value)

    @builtins.property
    @jsii.member(jsii_name="contrastVar")
    def contrast_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrastVar"))

    @contrast_var.setter
    def contrast_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7cc1fa3e0ba8429d40afd7b796969f5e9c1f982c494a9d1d8c3a54a97d1e3e4b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrastVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanContrast]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanContrast]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanContrast]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__24272feff92b8d94e9a18faffc25638a02b226e08b7b1f2c09ccfcfa82502877)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanGoop",
    jsii_struct_bases=[],
    name_mapping={
        "chaos": "chaos",
        "chaos_var": "chaosVar",
        "density": "density",
        "density_var": "densityVar",
        "power": "power",
        "power_var": "powerVar",
        "seed": "seed",
        "seed_var": "seedVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanGoop:
    def __init__(
        self,
        *,
        chaos: typing.Optional[builtins.str] = None,
        chaos_var: typing.Optional[builtins.str] = None,
        density: typing.Optional[builtins.str] = None,
        density_var: typing.Optional[builtins.str] = None,
        power: typing.Optional[builtins.str] = None,
        power_var: typing.Optional[builtins.str] = None,
        seed: typing.Optional[builtins.str] = None,
        seed_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param chaos: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        :param chaos_var: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        :param density: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        :param density_var: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        :param power: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        :param power_var: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        :param seed: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        :param seed_var: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0756f9b390e334a9a47b2393b7dd909197b143954d679713b361555672f984e1)
            check_type(argname="argument chaos", value=chaos, expected_type=type_hints["chaos"])
            check_type(argname="argument chaos_var", value=chaos_var, expected_type=type_hints["chaos_var"])
            check_type(argname="argument density", value=density, expected_type=type_hints["density"])
            check_type(argname="argument density_var", value=density_var, expected_type=type_hints["density_var"])
            check_type(argname="argument power", value=power, expected_type=type_hints["power"])
            check_type(argname="argument power_var", value=power_var, expected_type=type_hints["power_var"])
            check_type(argname="argument seed", value=seed, expected_type=type_hints["seed"])
            check_type(argname="argument seed_var", value=seed_var, expected_type=type_hints["seed_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if chaos is not None:
            self._values["chaos"] = chaos
        if chaos_var is not None:
            self._values["chaos_var"] = chaos_var
        if density is not None:
            self._values["density"] = density
        if density_var is not None:
            self._values["density_var"] = density_var
        if power is not None:
            self._values["power"] = power
        if power_var is not None:
            self._values["power_var"] = power_var
        if seed is not None:
            self._values["seed"] = seed
        if seed_var is not None:
            self._values["seed_var"] = seed_var

    @builtins.property
    def chaos(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        '''
        result = self._values.get("chaos")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def chaos_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        '''
        result = self._values.get("chaos_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        '''
        result = self._values.get("density")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density_var(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        '''
        result = self._values.get("density_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        '''
        result = self._values.get("power")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power_var(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        '''
        result = self._values.get("power_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        '''
        result = self._values.get("seed")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed_var(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        result = self._values.get("seed_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanGoop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanGoopList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanGoopList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f621a4fe1fe9ffab94a89871becb6d7136d6ff93c982a0c2db3fdd1935d352f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanGoopOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__96a2e18b8e5c0f956e2a0da4acd2792fdcb9489a8df8c34b3c098d28c57f2c36)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanGoopOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd175aaa5d3f73166de39999afd33549d4476e57d1a043de0fa91877712d0252)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a6e5ddc05939ee617d8a637a314a39cfc9540c134cf8176607f19f0b54a6c26e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5e456cfbbb5e218cc09f58ff6832d9d3de0633de175064a901cf1ba2df32428f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanGoop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanGoop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a539d86440db47282329dbf27570d3cbde62bd503d0b8d8ad6c3a5c2853aea3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanGoopOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanGoopOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f6ae4eb6c272eaeb2d86264b4b0f4990a306ce877d968dde9d70f7354ebed057)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetChaos")
    def reset_chaos(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaos", []))

    @jsii.member(jsii_name="resetChaosVar")
    def reset_chaos_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaosVar", []))

    @jsii.member(jsii_name="resetDensity")
    def reset_density(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensity", []))

    @jsii.member(jsii_name="resetDensityVar")
    def reset_density_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensityVar", []))

    @jsii.member(jsii_name="resetPower")
    def reset_power(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPower", []))

    @jsii.member(jsii_name="resetPowerVar")
    def reset_power_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPowerVar", []))

    @jsii.member(jsii_name="resetSeed")
    def reset_seed(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeed", []))

    @jsii.member(jsii_name="resetSeedVar")
    def reset_seed_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeedVar", []))

    @builtins.property
    @jsii.member(jsii_name="chaosInput")
    def chaos_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosInput"))

    @builtins.property
    @jsii.member(jsii_name="chaosVarInput")
    def chaos_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosVarInput"))

    @builtins.property
    @jsii.member(jsii_name="densityInput")
    def density_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityInput"))

    @builtins.property
    @jsii.member(jsii_name="densityVarInput")
    def density_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="powerInput")
    def power_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerInput"))

    @builtins.property
    @jsii.member(jsii_name="powerVarInput")
    def power_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerVarInput"))

    @builtins.property
    @jsii.member(jsii_name="seedInput")
    def seed_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedInput"))

    @builtins.property
    @jsii.member(jsii_name="seedVarInput")
    def seed_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedVarInput"))

    @builtins.property
    @jsii.member(jsii_name="chaos")
    def chaos(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaos"))

    @chaos.setter
    def chaos(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f401bcb527f2ae27230eedc86bc8bbfb7989f9cc77959955fe9a797f6016b691)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaos", value)

    @builtins.property
    @jsii.member(jsii_name="chaosVar")
    def chaos_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaosVar"))

    @chaos_var.setter
    def chaos_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bfe713effd54b88c19c4ae9b49fe40c4c4da2fb3a196a51114783ad7853f8681)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaosVar", value)

    @builtins.property
    @jsii.member(jsii_name="density")
    def density(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "density"))

    @density.setter
    def density(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b083e93595680d2a5d391003130523c46e3106f90d820a07b6039c5cd3daa568)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "density", value)

    @builtins.property
    @jsii.member(jsii_name="densityVar")
    def density_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "densityVar"))

    @density_var.setter
    def density_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e13555efdcc958b80b03b79226c25caaf815d7c6d2b143858becc16ab67e60e7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "densityVar", value)

    @builtins.property
    @jsii.member(jsii_name="power")
    def power(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "power"))

    @power.setter
    def power(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__974b814e24d3aec8cc54d30a95b730c8d969dc7633210199823120c871feaa18)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "power", value)

    @builtins.property
    @jsii.member(jsii_name="powerVar")
    def power_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "powerVar"))

    @power_var.setter
    def power_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__17eefd02f8cf7f096ca097ead5b352f2af3a29d000f6e62a87fdc52e8ad5177a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "powerVar", value)

    @builtins.property
    @jsii.member(jsii_name="seed")
    def seed(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seed"))

    @seed.setter
    def seed(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab70da322de61839903e46c24f853e804c69ae7edd78597685d8dd7c79adbcdd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seed", value)

    @builtins.property
    @jsii.member(jsii_name="seedVar")
    def seed_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seedVar"))

    @seed_var.setter
    def seed_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0f09bb045730421369ae0be943a582dcd74f0ed62cc694d85b1d26d74f24a578)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seedVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanGoop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanGoop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanGoop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d26060c4124d19e7b28bec8fbbf1d10c3f8efe59364b2f7bbfabc5ca7668d9ad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanGrayscale",
    jsii_struct_bases=[],
    name_mapping={"type": "type", "type_var": "typeVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanGrayscale:
    def __init__(
        self,
        *,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param type: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5e660631bc799618315ade0818e06d86925862b5bc5fe8e0079313c16a7f1465)
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanGrayscale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanGrayscaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanGrayscaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9aca5a4e40c04fe6a7002ef596d54142286086d9d171c188a7f85fd6c26b27b1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanGrayscaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f741e2fea9f75e42847f4f667b3a38a572d788093d581571556337b64c6c6906)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanGrayscaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ca4c9c7f92fb9f2a5fbae22f93533c2efa15880f62df147bc89d1fa658719331)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1149afbdb49af66c9b8188bb46baac5bcff772d17c311bdd6d2d19bbe7de4096)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__35f020248e6b998e2eaf43ccd261e9b5cad76637eaac5b91cdfdcc78d0965687)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanGrayscale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanGrayscale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__25f86ab60a2623f763711010e263b9a2dd2a70c25f61328003db4dedf5003dab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanGrayscaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanGrayscaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4bdeace9c2ea84a17e2809edda11a3d502549b7b6d2edcbf4d0ffaca3aa98850)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7ab20724b7492952b1c4f555b69c819a01c3c511f366e0cf3cb418e620c0bf1e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2e6e1c75fd17bc4e1dfbc233ff5d8ca4aba0e643a4df937d25332b68e58179cc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanGrayscale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanGrayscale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanGrayscale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f0bf41d4c1027e002ffefc0b205c417e670fb4ae6c545be83fc0f169722881c0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanHsl",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "lightness": "lightness",
        "lightness_var": "lightnessVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanHsl:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness: typing.Optional[builtins.str] = None,
        lightness_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        :param lightness_var: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e37f4b4af4d1754a39edfd2f5c10e99ede2ca0ab17d5b496ad1d0a51e446193b)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness", value=lightness, expected_type=type_hints["lightness"])
            check_type(argname="argument lightness_var", value=lightness_var, expected_type=type_hints["lightness_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness is not None:
            self._values["lightness"] = lightness
        if lightness_var is not None:
            self._values["lightness_var"] = lightness_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        '''
        result = self._values.get("lightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        '''
        result = self._values.get("lightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanHsl(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanHslList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanHslList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c7e4e88a0e87a65c2e5885bf20ab3183f4ff7b58b6aacf8f51929e325c1913c8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanHslOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4c2a5b708c1e42741b6933ab09a1e4f8276e927bf34eee8ed3a4107fc3961f73)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanHslOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5c2966e8378b25aca3f4b1f4d57ee7fd03d352f8d93ff63bb0bbd6daebd61c57)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__210c9575177e4a7eb6d73ad2ae4c5c4ef024f967188281aaaabcecd270179627)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c50bbe9a0eabb88883c1967d5292cbf03fe9833f2170b375bb6136a718c85ae7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanHsl]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanHsl]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8fbe8531730bc4204c56f0c994861d92dcbe60e96430b2e5298c65300cec5b57)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanHslOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanHslOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ae7644ae3a27ee2664ec608ae56fdd64e64b64b2a6f46672644fa127a97890e7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightness")
    def reset_lightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightness", []))

    @jsii.member(jsii_name="resetLightnessVar")
    def reset_lightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessInput")
    def lightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessVarInput")
    def lightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b28d94b34ff5b6e1ea8c04a8f31016ab4429fb604017afb77e50a0d0ba741bc6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__811ba0a1e3a58052a260ff37e2f060d120e619c695092f237adb19419e64ff73)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightness")
    def lightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightness"))

    @lightness.setter
    def lightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a28a850fddcf2c32b1929b33716d4f9e7e88d3882e8c1e1dbb86787a8863aa6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightness", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessVar")
    def lightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessVar"))

    @lightness_var.setter
    def lightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0169a370e68d377b8ebff628673f770f5f3ca4c4739b23ecaaefe907aa861491)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3b87a8afd3ea90f2ac30a2d66b267a245f2d2a12efb3ec5de30dfe9aa07445f7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8209564e6295aea80fff0f810054aa7b6111687443ad9e1793bf29cfe00cc41b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanHsl]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanHsl]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanHsl]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e8438cb93207ad3fafdeec1f7cd2863326e2d8cc89dc71a87c03e1a2379c7dd0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanHsv",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanHsv:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        :param value: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__509e153aabce96cbc43724b51508c05995deae2c439253e6fdddeca163076234)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanHsv(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanHsvList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanHsvList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1d3829a635c680306a01f48513b3287894308922651e9d690d4891ee54c92055)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanHsvOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ed6c2897fa44096ed62770fd177bc16c2a90e2cf42844f1adc565293d67e8ca)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanHsvOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8f3e3ee868206928a2871a3cb5aa9ceff27fdf18d8b34621f4999686ca9fe7eb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2b6ce16226becdd0cc5e944d4f5953d10c7fcc808429e58fbe6afe14e1209c69)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d74b9abd10dd7ecd7c2dcd8b8c390acf9f37edae406ab3083596e959876543e1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanHsv]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanHsv]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e60f87bf7837c02b6871dd889b960c8a14849cf58d211f72e31b64af65e96dd9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanHsvOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanHsvOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__33fc9aa684d9ed61dde43cad3cf332b355fb8e0943199a8d081dc26f5d34381a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e3cf8e3b8ad4608543b348c0a7f821bc2b008d657779239219c1e73480c93cfd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d718d9555ff4546bc58f00bc5ae0215316b4ab9bdf2062063657aee130483a14)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8477498ace37a304d38162cc2a9ffa6973b8a5351dc4111ba3d33a2bffb554c7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b663b3447ef1922fa4e2cb3de7877804fe858d4b9afb824c2e8179f7154df8f2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d6ae5f41875a843263ac5e4dd2e5f4f9eebbbef047436137ec5e2efe542e0b3d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f9eef443a2346278f4ebec7b0fe254027665d282f2d7525c3899d167026d249)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanHsv]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanHsv]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanHsv]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab3affad75f8d473ff8d2ec8e274ead3bdf8713afbd837c4cb27ea92425d0f1a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfDimension",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "dimension": "dimension",
        "dimension_var": "dimensionVar",
        "equal": "equal",
        "greater_than": "greaterThan",
        "less_than": "lessThan",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfDimension:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        dimension: typing.Optional[builtins.str] = None,
        dimension_var: typing.Optional[builtins.str] = None,
        equal: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionEqual", typing.Dict[builtins.str, typing.Any]]] = None,
        greater_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionGreaterThan", typing.Dict[builtins.str, typing.Any]]] = None,
        less_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionLessThan", typing.Dict[builtins.str, typing.Any]]] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param dimension: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        :param dimension_var: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        :param equal: equal block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        :param greater_than: greater_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        :param less_than: less_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        :param value: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionDefault(**default)
        if isinstance(equal, dict):
            equal = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionEqual(**equal)
        if isinstance(greater_than, dict):
            greater_than = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionGreaterThan(**greater_than)
        if isinstance(less_than, dict):
            less_than = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionLessThan(**less_than)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__10e71c4a6a14e6d6530079977f25c6e26c17caf3a46a83deaa09e76dd2331199)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument dimension", value=dimension, expected_type=type_hints["dimension"])
            check_type(argname="argument dimension_var", value=dimension_var, expected_type=type_hints["dimension_var"])
            check_type(argname="argument equal", value=equal, expected_type=type_hints["equal"])
            check_type(argname="argument greater_than", value=greater_than, expected_type=type_hints["greater_than"])
            check_type(argname="argument less_than", value=less_than, expected_type=type_hints["less_than"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if dimension is not None:
            self._values["dimension"] = dimension
        if dimension_var is not None:
            self._values["dimension_var"] = dimension_var
        if equal is not None:
            self._values["equal"] = equal
        if greater_than is not None:
            self._values["greater_than"] = greater_than
        if less_than is not None:
            self._values["less_than"] = less_than
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionDefault"], result)

    @builtins.property
    def dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        '''
        result = self._values.get("dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        '''
        result = self._values.get("dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def equal(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionEqual"]:
        '''equal block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        '''
        result = self._values.get("equal")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionEqual"], result)

    @builtins.property
    def greater_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionGreaterThan"]:
        '''greater_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        '''
        result = self._values.get("greater_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionGreaterThan"], result)

    @builtins.property
    def less_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionLessThan"]:
        '''less_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        '''
        result = self._values.get("less_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionLessThan"], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfDimension(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__49273acf4536d04f1df18092de0d219af1476a48fa07958a58556dd9ab081108)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8133b29d9b0afc4574a2398514a42f161137480a131dac3a69cb912053ee740d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionEqual",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionEqual:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionEqual(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionEqualOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionEqualOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__136625bc615791e37d7548f4cd49445a6ddea94fc5e4bbf4accad05fcbefbfd7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionEqual], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionEqual],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8dada5465169c935ef663e9823af2587a874e66af1bbe72ddd389659ee02c382)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionGreaterThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionGreaterThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionGreaterThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionGreaterThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionGreaterThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__08cd688ead40371ae2171cd0c2356e4f2099d7dab72d9452cfdcb19ad2d6335d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionGreaterThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionGreaterThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__38d28d7d7dc8f866a45b2d1b7083526051b5c5300af6bb02a964318f276652ea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionLessThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionLessThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionLessThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionLessThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionLessThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1d3cb43ee16027f841c14b8b5f3e901c5ae8dbb84bde4269c9c977f6b05ecb49)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionLessThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionLessThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2c5864dd0adb74a62b4ce44b56d9beb862ad8018a1d5f1755d10314524863c49)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cf539fcfb88af0e84fa75cfbe32f40f16e257b9264423cc362b24aab99d7427d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0b6bf93655bf18dd2080719f61a9d3e6e63f40dd168da91d662add8e5b4f1450)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dfc4c5d68f4dbc3b79d043b184bbb2d8bbad1713409a9c98615324936174c8f5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b8a3205edb04fe9212f964af296a3cdf3e840e76486907dc0a713da447e7d3a7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__20b8242b930ccd55237251226c1a6d7ca093ca27cfc72bb31cdc3591c6c0fd88)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfDimension]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfDimension]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0e0d800f0448890a6439144b2c1da0a7e0f533f72deba32a56857ab3e16375fb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__68b3dc5aa3ef9ad1e081ed9e3aaa207ccb974e80bba43f34cd06f3d3ccb2f2bf)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putEqual")
    def put_equal(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionEqual()

        return typing.cast(None, jsii.invoke(self, "putEqual", [value]))

    @jsii.member(jsii_name="putGreaterThan")
    def put_greater_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionGreaterThan()

        return typing.cast(None, jsii.invoke(self, "putGreaterThan", [value]))

    @jsii.member(jsii_name="putLessThan")
    def put_less_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionLessThan()

        return typing.cast(None, jsii.invoke(self, "putLessThan", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetDimension")
    def reset_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimension", []))

    @jsii.member(jsii_name="resetDimensionVar")
    def reset_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimensionVar", []))

    @jsii.member(jsii_name="resetEqual")
    def reset_equal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEqual", []))

    @jsii.member(jsii_name="resetGreaterThan")
    def reset_greater_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGreaterThan", []))

    @jsii.member(jsii_name="resetLessThan")
    def reset_less_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLessThan", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="equal")
    def equal(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionEqualOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionEqualOutputReference, jsii.get(self, "equal"))

    @builtins.property
    @jsii.member(jsii_name="greaterThan")
    def greater_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionGreaterThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionGreaterThanOutputReference, jsii.get(self, "greaterThan"))

    @builtins.property
    @jsii.member(jsii_name="lessThan")
    def less_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionLessThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionLessThanOutputReference, jsii.get(self, "lessThan"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionInput")
    def dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionVarInput")
    def dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="equalInput")
    def equal_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionEqual], jsii.get(self, "equalInput"))

    @builtins.property
    @jsii.member(jsii_name="greaterThanInput")
    def greater_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionGreaterThan], jsii.get(self, "greaterThanInput"))

    @builtins.property
    @jsii.member(jsii_name="lessThanInput")
    def less_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionLessThan], jsii.get(self, "lessThanInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="dimension")
    def dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimension"))

    @dimension.setter
    def dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e9cb934eb73469907f14d5bde226525cbdc77449646e2cf28255c64a789c6e45)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimension", value)

    @builtins.property
    @jsii.member(jsii_name="dimensionVar")
    def dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimensionVar"))

    @dimension_var.setter
    def dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fc626fafc137c4477ec4e756d96689b891799f465baad6151e0086fa75f25882)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d10a7da302c78d90cec2604be0cfcf507e8d970d6051779c61e148d476a2a41)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d7e7f71f3d68d41a16a44931636fbe0886c18e0e251d2be303d557a0c85ca130)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfDimension]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfDimension]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfDimension]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7c41e6c61533d7fc610d8bba8f04ca7d0211f70af6af4bb2b41521a1cc79fa6e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfOrientation",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "landscape": "landscape",
        "portrait": "portrait",
        "square": "square",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfOrientation:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        landscape: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationLandscape", typing.Dict[builtins.str, typing.Any]]] = None,
        portrait: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationPortrait", typing.Dict[builtins.str, typing.Any]]] = None,
        square: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationSquare", typing.Dict[builtins.str, typing.Any]]] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param landscape: landscape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        :param portrait: portrait block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        :param square: square block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationDefault(**default)
        if isinstance(landscape, dict):
            landscape = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationLandscape(**landscape)
        if isinstance(portrait, dict):
            portrait = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationPortrait(**portrait)
        if isinstance(square, dict):
            square = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationSquare(**square)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__121cc42ebc0465c1884499e813eb96ab1e4a7fedb952202f90a7c8e7e6ca1b39)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument landscape", value=landscape, expected_type=type_hints["landscape"])
            check_type(argname="argument portrait", value=portrait, expected_type=type_hints["portrait"])
            check_type(argname="argument square", value=square, expected_type=type_hints["square"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if landscape is not None:
            self._values["landscape"] = landscape
        if portrait is not None:
            self._values["portrait"] = portrait
        if square is not None:
            self._values["square"] = square

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationDefault"], result)

    @builtins.property
    def landscape(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationLandscape"]:
        '''landscape block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        '''
        result = self._values.get("landscape")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationLandscape"], result)

    @builtins.property
    def portrait(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationPortrait"]:
        '''portrait block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        '''
        result = self._values.get("portrait")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationPortrait"], result)

    @builtins.property
    def square(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationSquare"]:
        '''square block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        result = self._values.get("square")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationSquare"], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfOrientation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__40398543ec779ee2923d5216f86195869019b40bdd1d20619428994c282361ab)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d4b8c8ca9bb92cbfc73e646c203cb8c14f5e3d252e6ceab74ac9dd08580cb05)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationLandscape",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationLandscape:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationLandscape(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationLandscapeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationLandscapeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__605e033dcbdd4b998d00706610115580c5a8ebe49d24e3e2d0b8bc97a4cfcac1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationLandscape], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationLandscape],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6ade9fcf5798b0e83f7af48dc74f8058651d461f5ebf0d01b709adc9a51b517a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__39303c86a003570d0f1a105d17bdddfeb4b31883802d36998df623c43ea69bbf)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__03a7084a07ad8251ff1a4a00a5d3a429fcbb8f68a99110fd354b5248f8c989ef)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d4e421514e6de4bf24a396a78ddb418740a36a90a4815ec716f303c0d8ac4cc8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8911b66882d903cab6fd499bcb87eec8255621e973eadffd439b456ef26b2b8c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4e70d295eebe48e8f012fbe0006a20fce0818692541ee522f316fd52d5ff826d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfOrientation]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfOrientation]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__63217fd3a1e083255aaae66beea48aa75e8148b1680ae37ccf3d5f1f3d753afa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0559e9e8d609ee26fbeaff41ca572dfc3ab635086b043b2ad4e7b5e7892062ca)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putLandscape")
    def put_landscape(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationLandscape()

        return typing.cast(None, jsii.invoke(self, "putLandscape", [value]))

    @jsii.member(jsii_name="putPortrait")
    def put_portrait(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationPortrait()

        return typing.cast(None, jsii.invoke(self, "putPortrait", [value]))

    @jsii.member(jsii_name="putSquare")
    def put_square(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationSquare()

        return typing.cast(None, jsii.invoke(self, "putSquare", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetLandscape")
    def reset_landscape(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLandscape", []))

    @jsii.member(jsii_name="resetPortrait")
    def reset_portrait(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPortrait", []))

    @jsii.member(jsii_name="resetSquare")
    def reset_square(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSquare", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="landscape")
    def landscape(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationLandscapeOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationLandscapeOutputReference, jsii.get(self, "landscape"))

    @builtins.property
    @jsii.member(jsii_name="portrait")
    def portrait(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationPortraitOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationPortraitOutputReference", jsii.get(self, "portrait"))

    @builtins.property
    @jsii.member(jsii_name="square")
    def square(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationSquareOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationSquareOutputReference", jsii.get(self, "square"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="landscapeInput")
    def landscape_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationLandscape], jsii.get(self, "landscapeInput"))

    @builtins.property
    @jsii.member(jsii_name="portraitInput")
    def portrait_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationPortrait"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationPortrait"], jsii.get(self, "portraitInput"))

    @builtins.property
    @jsii.member(jsii_name="squareInput")
    def square_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationSquare"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationSquare"], jsii.get(self, "squareInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfOrientation]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfOrientation]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfOrientation]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a6f1371481c7b73d53de4edca838ef7df368e9c5226064fbb4fdd248cb3946d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationPortrait",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationPortrait:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationPortrait(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationPortraitOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationPortraitOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6b5f8745500f1ee527f52929cdc672669c3079d67d27f04089090a905548822a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationPortrait]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationPortrait], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationPortrait],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__45a68e09e6eec9a085b3cf46ce25f0a25047db86c10b49bb09b74f0cbed76a7c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationSquare",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationSquare:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationSquare(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationSquareOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationSquareOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8efc1b95d518010a0ea59d1e81cdfeea85d728978c3f8168a3c089662eab7a59)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationSquare]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationSquare], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationSquare],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e14f95c1b17ead812e411fb5bdcf4ac18356fb360ca3377e9c65c1ca1ad27a82)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanMaxColors",
    jsii_struct_bases=[],
    name_mapping={"colors": "colors", "colors_var": "colorsVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanMaxColors:
    def __init__(
        self,
        *,
        colors: typing.Optional[builtins.str] = None,
        colors_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param colors: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        :param colors_var: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac6bb4db2f0242f8db028659c408d4123101fe5eaec7a9a20f34113392d7e621)
            check_type(argname="argument colors", value=colors, expected_type=type_hints["colors"])
            check_type(argname="argument colors_var", value=colors_var, expected_type=type_hints["colors_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if colors is not None:
            self._values["colors"] = colors
        if colors_var is not None:
            self._values["colors_var"] = colors_var

    @builtins.property
    def colors(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        '''
        result = self._values.get("colors")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def colors_var(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        result = self._values.get("colors_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanMaxColors(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanMaxColorsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanMaxColorsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be6f18c8dfd13d9a89565ea2969711a359a1729ec2327a5544f979603fe9f59a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanMaxColorsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2983d172152aa9cbad75160e203cf5fcc56567e6aaf14900a295aa5d5ae6e7b4)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanMaxColorsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5b9468f6dac6f53a856aaacaa875db55350c8a49326d35c119e2455a36258838)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e040530ba229601999441f6b37328222dc6b7d0d007c852ab00df83c3e0db54)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__abbd4f7b2921b093e078071e110ab8897923dcf3308d5636441ae08ff077aba3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanMaxColors]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanMaxColors]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__32dac6b6c56380bcab31ca110fd86b2265feca864e4adbf0967c98a0e7ac7575)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanMaxColorsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanMaxColorsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__61d7a91df89ec93dac629072fb5cf5c17431f40c0ceae2bdfb5fef8e855f3172)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColors")
    def reset_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColors", []))

    @jsii.member(jsii_name="resetColorsVar")
    def reset_colors_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorsVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorsInput")
    def colors_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsInput"))

    @builtins.property
    @jsii.member(jsii_name="colorsVarInput")
    def colors_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsVarInput"))

    @builtins.property
    @jsii.member(jsii_name="colors")
    def colors(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colors"))

    @colors.setter
    def colors(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3cb05561e73e0a3fe81dc38381749d83e2b8c4a140f2088e07874d9824b55617)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colors", value)

    @builtins.property
    @jsii.member(jsii_name="colorsVar")
    def colors_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorsVar"))

    @colors_var.setter
    def colors_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d013c8c9a573e13f2594edc244a11453a3486a17aa02a4c949631f12c172f50)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorsVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanMaxColors]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanMaxColors]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanMaxColors]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__864632653100843c878ce73b26da57321fa7e83909b2756ca831eb050c22374b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanMirror",
    jsii_struct_bases=[],
    name_mapping={
        "horizontal": "horizontal",
        "horizontal_var": "horizontalVar",
        "vertical": "vertical",
        "vertical_var": "verticalVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanMirror:
    def __init__(
        self,
        *,
        horizontal: typing.Optional[builtins.str] = None,
        horizontal_var: typing.Optional[builtins.str] = None,
        vertical: typing.Optional[builtins.str] = None,
        vertical_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param horizontal: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        :param horizontal_var: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        :param vertical: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        :param vertical_var: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f1d8393aeca793bfba06a39dac1353bdbf406f77f9a6eaaec0d964883038c061)
            check_type(argname="argument horizontal", value=horizontal, expected_type=type_hints["horizontal"])
            check_type(argname="argument horizontal_var", value=horizontal_var, expected_type=type_hints["horizontal_var"])
            check_type(argname="argument vertical", value=vertical, expected_type=type_hints["vertical"])
            check_type(argname="argument vertical_var", value=vertical_var, expected_type=type_hints["vertical_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if horizontal is not None:
            self._values["horizontal"] = horizontal
        if horizontal_var is not None:
            self._values["horizontal_var"] = horizontal_var
        if vertical is not None:
            self._values["vertical"] = vertical
        if vertical_var is not None:
            self._values["vertical_var"] = vertical_var

    @builtins.property
    def horizontal(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        '''
        result = self._values.get("horizontal")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def horizontal_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        '''
        result = self._values.get("horizontal_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        '''
        result = self._values.get("vertical")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        result = self._values.get("vertical_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanMirror(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanMirrorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanMirrorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d34623e8f9bc4cc93847168b84fd186a03c6ed034de60c1e62598ccad9a2b8e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanMirrorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__db63ae7a58d04b650a260f4a9b04cb86382fa65f558aa3447f9aad443141abfc)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanMirrorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2fb82e21adecd0f64cade2b62a8886e4f38dc317f11e785df080053e5e9915a1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a9c5575baa914eafdf2a9ffc0d871fecc4daac0f2015246444ab2331b0fae81f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fcc51bbffb237c17ad0d902fdd147c192d9dd71ae39237e62ca60c242b0510f3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanMirror]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanMirror]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dc584369e189b67944475822f9bf478119b1e4f130bc3fe5015184856d2c7d6c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanMirrorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanMirrorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d7c6e973cae21fd98856e389171de6b6e80bc8ba66671dfe731ef71937fc2610)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHorizontal")
    def reset_horizontal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontal", []))

    @jsii.member(jsii_name="resetHorizontalVar")
    def reset_horizontal_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontalVar", []))

    @jsii.member(jsii_name="resetVertical")
    def reset_vertical(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVertical", []))

    @jsii.member(jsii_name="resetVerticalVar")
    def reset_vertical_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVerticalVar", []))

    @builtins.property
    @jsii.member(jsii_name="horizontalInput")
    def horizontal_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontalVarInput")
    def horizontal_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalInput")
    def vertical_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalVarInput")
    def vertical_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontal")
    def horizontal(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontal"))

    @horizontal.setter
    def horizontal(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bdbfab1e84070522019189842b962eb93f3b936b6278d2aa4f83951765c8f906)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontal", value)

    @builtins.property
    @jsii.member(jsii_name="horizontalVar")
    def horizontal_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontalVar"))

    @horizontal_var.setter
    def horizontal_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a61f2a56f18aacf40ae6823ee582c8db34182fb567e4cb38236b39ca0f88b012)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontalVar", value)

    @builtins.property
    @jsii.member(jsii_name="vertical")
    def vertical(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "vertical"))

    @vertical.setter
    def vertical(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7cfe39a5cc9ba2003e9935d7505d388239f1d4df11a4fa35877a5c3dfdcf2c11)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "vertical", value)

    @builtins.property
    @jsii.member(jsii_name="verticalVar")
    def vertical_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "verticalVar"))

    @vertical_var.setter
    def vertical_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__db844a8b4168c8a6ca823756dd59e37a660c8e49e965663d2ae5b134f4292546)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "verticalVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanMirror]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanMirror]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanMirror]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__929b7db6ea5d9edcb67bda5f8916da31f907d583399403b32bda0d913846780a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanMonoHue",
    jsii_struct_bases=[],
    name_mapping={"hue": "hue", "hue_var": "hueVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanMonoHue:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a267596c1c081802f9416247f7af92ee70cf6a4e9c98d233499ed6362378a900)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanMonoHue(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanMonoHueList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanMonoHueList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__944195402c4609682597dd29d4eafd7826c1a670c1d652b03a25fe2505e18271)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanMonoHueOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f30cf70761fe825ca3a9e87aec59cc81dc15929c95e041a169aea7d78562602)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanMonoHueOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c62b6c691791d2865dc1e52e7304c1eaa9aeeef76f76b9808cfff8baf4acb17e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__03b634077d69b694e7afdfdd5b6781de2679d53ebd592bad6d1394021ffa5c2d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b0aacb0dd32c3a769b8da355d47c77d96a2b82eccc4fdf23211e0810ffeade62)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanMonoHue]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanMonoHue]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__daf04258d96f7b870f1e7b94d54599e3359aa4e137662e029e1504f6c8d8f047)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanMonoHueOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanMonoHueOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f6c280e831aa59c645861cd29018a445e5403dc20003cd287aa93d6295597e8e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__92612de651f9dc6ae897d5c2ffd05d22bae31a5394cff52187ceddbf14a89ed1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1e6a527e19c41c6e6ffc562de455e0a10588a3d2a802961d57bdee662771436b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanMonoHue]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanMonoHue]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanMonoHue]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3b0861a5456218074a880e0c37ad5a010c5362c9e4f535e3207f7df5d99edfa8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanOpacity",
    jsii_struct_bases=[],
    name_mapping={"opacity": "opacity", "opacity_var": "opacityVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanOpacity:
    def __init__(
        self,
        *,
        opacity: typing.Optional[builtins.str] = None,
        opacity_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param opacity: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param opacity_var: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__740d323368dd5ca8fed4017e22040a9e2b9e4bc3b42a740ddd443ec7cc317891)
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument opacity_var", value=opacity_var, expected_type=type_hints["opacity_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if opacity is not None:
            self._values["opacity"] = opacity
        if opacity_var is not None:
            self._values["opacity_var"] = opacity_var

    @builtins.property
    def opacity(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def opacity_var(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        result = self._values.get("opacity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanOpacity(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanOpacityList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanOpacityList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4303c0ec666aeb19fb154169473bc8580d934c9592e7406e50ec6aba294f8e3c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanOpacityOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8b8c1a53aa92e6a5268a7f68867f17a7730e5974b391016207d2b78686231190)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanOpacityOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__61418ced43e45139c56c5ea61ca5328a40f52ec614cfbda1d0dff8b6a5144f46)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__790ab8c7f015cf677bfdd68d4688761f78da05edc34ec377db275d228a8667a9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__42bdb507da679f72326805fce223eff5be5e3036d54b2d1f2ed86fd58f9dc844)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanOpacity]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanOpacity]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4cfe46ba619c0069c49381908fd756fedc07d2fd01875870e733b43f16074f47)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanOpacityOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanOpacityOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3564a0e82d2aaa13cdec4f95cb007df08a71acf0b821255b4e7d1ed99c6e1343)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetOpacityVar")
    def reset_opacity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacityVar", []))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityVarInput")
    def opacity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacity"))

    @opacity.setter
    def opacity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7ac5776f380de24c02e21047105a4a4c5e149c5a3d55943ecfcea093b96aa347)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacity", value)

    @builtins.property
    @jsii.member(jsii_name="opacityVar")
    def opacity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacityVar"))

    @opacity_var.setter
    def opacity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4f60ed8395b6782e8a5c35063d0f5a058ac8b1eaf93c328c61317806466840dc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacityVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanOpacity]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanOpacity]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanOpacity]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c8461cd9f6379d869eddc5abae124f215678d928aa161f31c46b9e28380e6455)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fda97b700da68f09837746436094ceeb58040ceafb8d07ae42888db64a19ad6c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putBackgroundColor")
    def put_background_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__499b412f6709cdeb774f34ebb2443712fc99abc1951f77016a143a5262e88551)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBackgroundColor", [value]))

    @jsii.member(jsii_name="putBlur")
    def put_blur(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanBlur, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a9b2cea88bd219fd0679a60d85e59bf89a576a64054f511e1540540415e9362)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBlur", [value]))

    @jsii.member(jsii_name="putChromaKey")
    def put_chroma_key(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanChromaKey, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e3a5ff29c7c53948c1fb441efe06f0e37bb8363ce1a0e1cd2b2e5107ea69b48)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putChromaKey", [value]))

    @jsii.member(jsii_name="putComposite")
    def put_composite(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanComposite, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__51a1715a809e74f39b9cb8e0f815425cb84c05d10fd4894c9c836c0ceeca0a94)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putComposite", [value]))

    @jsii.member(jsii_name="putCompound")
    def put_compound(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanCompound, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__893f38a2c770c5095382e07969f127d72459e4858ba00b6c9030abdab0c3140e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCompound", [value]))

    @jsii.member(jsii_name="putContrast")
    def put_contrast(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanContrast, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__52958bf990c31f130e7fbab6e0f2cc9dca1cdf2894e3699e1a8d2c14190a43e9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putContrast", [value]))

    @jsii.member(jsii_name="putGoop")
    def put_goop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanGoop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__09aa6e0c79e335f325ab7388f2098f8d646c041b16c73d616b57e64debc68e2c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGoop", [value]))

    @jsii.member(jsii_name="putGrayscale")
    def put_grayscale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanGrayscale, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b1e1b1f58f623b98a455157eac4293f1b5b8e6ae500c7b70be3a6ad5a3be6d60)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGrayscale", [value]))

    @jsii.member(jsii_name="putHsl")
    def put_hsl(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanHsl, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9247c4970379ed46759e9a0affa60d29e18b8f4d3dc3d69df11074ea9b14bdda)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsl", [value]))

    @jsii.member(jsii_name="putHsv")
    def put_hsv(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanHsv, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3c36cfd7f0f5cd4c9959ced027991f584a527bbbd4460811d8b36d71b5eeb5ec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsv", [value]))

    @jsii.member(jsii_name="putIfDimension")
    def put_if_dimension(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfDimension, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bcb27a730fa328ab6845e6e3d869c919d88c6d4064bcd6261c48a5a429a7d049)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfDimension", [value]))

    @jsii.member(jsii_name="putIfOrientation")
    def put_if_orientation(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac86d32282dae7061676ac219df3d7850b2dd710598ea500fe66c9520a8ea18d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfOrientation", [value]))

    @jsii.member(jsii_name="putMaxColors")
    def put_max_colors(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanMaxColors, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1c22b06a8ba3bb86de31547e94e7a404cfdbed7da7be333fdda52483adb95fe3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMaxColors", [value]))

    @jsii.member(jsii_name="putMirror")
    def put_mirror(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanMirror, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5736d4be9aeaf21e288e20893b17ea90da9743097973df3577cf0ff59fee7f75)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMirror", [value]))

    @jsii.member(jsii_name="putMonoHue")
    def put_mono_hue(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanMonoHue, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6fb576e907a25058ab0c3483a235b5de4457d1fb4b965e70316e7d86d0d88def)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMonoHue", [value]))

    @jsii.member(jsii_name="putOpacity")
    def put_opacity(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanOpacity, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e69e088096c0af948ac7499222f835ba8b72505a35dc43a20fee535c6eee2d02)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putOpacity", [value]))

    @jsii.member(jsii_name="putRemoveColor")
    def put_remove_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanRemoveColor", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__40fbdcaefd7cd93a193b49a809d318409ca698062d32a17e34fc50dfe658c5e2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRemoveColor", [value]))

    @jsii.member(jsii_name="putUnsharpMask")
    def put_unsharp_mask(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanUnsharpMask", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__de32fc280bba3bf50ec26f19207aba912e9f857fd9c37c2473b8bcbfe80b937b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putUnsharpMask", [value]))

    @jsii.member(jsii_name="resetBackgroundColor")
    def reset_background_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBackgroundColor", []))

    @jsii.member(jsii_name="resetBlur")
    def reset_blur(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBlur", []))

    @jsii.member(jsii_name="resetChromaKey")
    def reset_chroma_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChromaKey", []))

    @jsii.member(jsii_name="resetComposite")
    def reset_composite(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetComposite", []))

    @jsii.member(jsii_name="resetCompound")
    def reset_compound(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCompound", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetGoop")
    def reset_goop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGoop", []))

    @jsii.member(jsii_name="resetGrayscale")
    def reset_grayscale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGrayscale", []))

    @jsii.member(jsii_name="resetHsl")
    def reset_hsl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsl", []))

    @jsii.member(jsii_name="resetHsv")
    def reset_hsv(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsv", []))

    @jsii.member(jsii_name="resetIfDimension")
    def reset_if_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfDimension", []))

    @jsii.member(jsii_name="resetIfOrientation")
    def reset_if_orientation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfOrientation", []))

    @jsii.member(jsii_name="resetMaxColors")
    def reset_max_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxColors", []))

    @jsii.member(jsii_name="resetMirror")
    def reset_mirror(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMirror", []))

    @jsii.member(jsii_name="resetMonoHue")
    def reset_mono_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonoHue", []))

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetRemoveColor")
    def reset_remove_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRemoveColor", []))

    @jsii.member(jsii_name="resetUnsharpMask")
    def reset_unsharp_mask(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUnsharpMask", []))

    @builtins.property
    @jsii.member(jsii_name="backgroundColor")
    def background_color(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanBackgroundColorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanBackgroundColorList, jsii.get(self, "backgroundColor"))

    @builtins.property
    @jsii.member(jsii_name="blur")
    def blur(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanBlurList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanBlurList, jsii.get(self, "blur"))

    @builtins.property
    @jsii.member(jsii_name="chromaKey")
    def chroma_key(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanChromaKeyList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanChromaKeyList, jsii.get(self, "chromaKey"))

    @builtins.property
    @jsii.member(jsii_name="composite")
    def composite(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanCompositeList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanCompositeList, jsii.get(self, "composite"))

    @builtins.property
    @jsii.member(jsii_name="compound")
    def compound(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanCompoundList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanCompoundList, jsii.get(self, "compound"))

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanContrastList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanContrastList, jsii.get(self, "contrast"))

    @builtins.property
    @jsii.member(jsii_name="goop")
    def goop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanGoopList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanGoopList, jsii.get(self, "goop"))

    @builtins.property
    @jsii.member(jsii_name="grayscale")
    def grayscale(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanGrayscaleList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanGrayscaleList, jsii.get(self, "grayscale"))

    @builtins.property
    @jsii.member(jsii_name="hsl")
    def hsl(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanHslList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanHslList, jsii.get(self, "hsl"))

    @builtins.property
    @jsii.member(jsii_name="hsv")
    def hsv(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanHsvList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanHsvList, jsii.get(self, "hsv"))

    @builtins.property
    @jsii.member(jsii_name="ifDimension")
    def if_dimension(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionList, jsii.get(self, "ifDimension"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientation")
    def if_orientation(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationList, jsii.get(self, "ifOrientation"))

    @builtins.property
    @jsii.member(jsii_name="maxColors")
    def max_colors(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanMaxColorsList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanMaxColorsList, jsii.get(self, "maxColors"))

    @builtins.property
    @jsii.member(jsii_name="mirror")
    def mirror(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanMirrorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanMirrorList, jsii.get(self, "mirror"))

    @builtins.property
    @jsii.member(jsii_name="monoHue")
    def mono_hue(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanMonoHueList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanMonoHueList, jsii.get(self, "monoHue"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanOpacityList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanOpacityList, jsii.get(self, "opacity"))

    @builtins.property
    @jsii.member(jsii_name="removeColor")
    def remove_color(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanRemoveColorList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanRemoveColorList", jsii.get(self, "removeColor"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMask")
    def unsharp_mask(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanUnsharpMaskList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanUnsharpMaskList", jsii.get(self, "unsharpMask"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColorInput")
    def background_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanBackgroundColor]]], jsii.get(self, "backgroundColorInput"))

    @builtins.property
    @jsii.member(jsii_name="blurInput")
    def blur_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanBlur]]], jsii.get(self, "blurInput"))

    @builtins.property
    @jsii.member(jsii_name="chromaKeyInput")
    def chroma_key_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanChromaKey]]], jsii.get(self, "chromaKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="compositeInput")
    def composite_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanComposite]]], jsii.get(self, "compositeInput"))

    @builtins.property
    @jsii.member(jsii_name="compoundInput")
    def compound_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanCompound]]], jsii.get(self, "compoundInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanContrast]]], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="goopInput")
    def goop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanGoop]]], jsii.get(self, "goopInput"))

    @builtins.property
    @jsii.member(jsii_name="grayscaleInput")
    def grayscale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanGrayscale]]], jsii.get(self, "grayscaleInput"))

    @builtins.property
    @jsii.member(jsii_name="hslInput")
    def hsl_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanHsl]]], jsii.get(self, "hslInput"))

    @builtins.property
    @jsii.member(jsii_name="hsvInput")
    def hsv_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanHsv]]], jsii.get(self, "hsvInput"))

    @builtins.property
    @jsii.member(jsii_name="ifDimensionInput")
    def if_dimension_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfDimension]]], jsii.get(self, "ifDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientationInput")
    def if_orientation_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfOrientation]]], jsii.get(self, "ifOrientationInput"))

    @builtins.property
    @jsii.member(jsii_name="maxColorsInput")
    def max_colors_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanMaxColors]]], jsii.get(self, "maxColorsInput"))

    @builtins.property
    @jsii.member(jsii_name="mirrorInput")
    def mirror_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanMirror]]], jsii.get(self, "mirrorInput"))

    @builtins.property
    @jsii.member(jsii_name="monoHueInput")
    def mono_hue_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanMonoHue]]], jsii.get(self, "monoHueInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanOpacity]]], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="removeColorInput")
    def remove_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanRemoveColor"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanRemoveColor"]]], jsii.get(self, "removeColorInput"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMaskInput")
    def unsharp_mask_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanUnsharpMask"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanUnsharpMask"]]], jsii.get(self, "unsharpMaskInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ec34a25f31414308c6877bf1324f0caccb7d2678adf7c46a929ba29d4a194147)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanRemoveColor",
    jsii_struct_bases=[],
    name_mapping={
        "color": "color",
        "color_var": "colorVar",
        "feather": "feather",
        "feather_var": "featherVar",
        "tolerance": "tolerance",
        "tolerance_var": "toleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanRemoveColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
        feather: typing.Optional[builtins.str] = None,
        feather_var: typing.Optional[builtins.str] = None,
        tolerance: typing.Optional[builtins.str] = None,
        tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        :param feather: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        :param feather_var: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        :param tolerance: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        :param tolerance_var: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9eeb3d87b909702dfd1b089e6ee82fe099b32f6322af5d07a4e1b77db3aa4e81)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
            check_type(argname="argument feather", value=feather, expected_type=type_hints["feather"])
            check_type(argname="argument feather_var", value=feather_var, expected_type=type_hints["feather_var"])
            check_type(argname="argument tolerance", value=tolerance, expected_type=type_hints["tolerance"])
            check_type(argname="argument tolerance_var", value=tolerance_var, expected_type=type_hints["tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var
        if feather is not None:
            self._values["feather"] = feather
        if feather_var is not None:
            self._values["feather_var"] = feather_var
        if tolerance is not None:
            self._values["tolerance"] = tolerance
        if tolerance_var is not None:
            self._values["tolerance_var"] = tolerance_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        '''
        result = self._values.get("feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather_var(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        '''
        result = self._values.get("feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        '''
        result = self._values.get("tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance_var(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        result = self._values.get("tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanRemoveColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanRemoveColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanRemoveColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ef75796f3cf4d0e2be006fd455affdddab7d8e9fd3256b5ed1b17f8df63d29f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanRemoveColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1bb8e94b84f3628a55e8bfcdc229b9f052c5132afea2c92cb209749320f5c364)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanRemoveColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d0045b26431008af384b6736c2f1caf6450d7699e6c925658124c85605598cb4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__58e367d4bdd3bdffbc529f5252dc2f6602b9f2b7d8f675190c3b3b13b4a51141)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__16db809f8253f2852acb2339eb2a743ea910d1f3cfb27fe2cd82877c9aae6ed7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanRemoveColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanRemoveColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanRemoveColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b4e6ea8ad1e373e37ec6e6728f01ea896896d0a8caae144ea6bc805c26c697ab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanRemoveColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanRemoveColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__52271d9d634c884ccbd1494904fda1681474c3dff19ddb47cf7ab5b2e0d7ef27)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @jsii.member(jsii_name="resetFeather")
    def reset_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeather", []))

    @jsii.member(jsii_name="resetFeatherVar")
    def reset_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatherVar", []))

    @jsii.member(jsii_name="resetTolerance")
    def reset_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTolerance", []))

    @jsii.member(jsii_name="resetToleranceVar")
    def reset_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featherInput")
    def feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherInput"))

    @builtins.property
    @jsii.member(jsii_name="featherVarInput")
    def feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceInput")
    def tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceVarInput")
    def tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8c3d7f43e84cb55791e685da852427436b0863ce09ddbf5c707e3c38ccbea1d2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__348cb9940df4dc07f6538062a1dc4e15dda94804ed49d8d1ec20db99b767a7e0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="feather")
    def feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "feather"))

    @feather.setter
    def feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b0926097e1739a147ded5fcbe04ac346206e8c7a6ab9b78c4df2d1a3a2d3501b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "feather", value)

    @builtins.property
    @jsii.member(jsii_name="featherVar")
    def feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featherVar"))

    @feather_var.setter
    def feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2e99e53e31e4ed7d1ffce2125a599adeea14da7f4933a14c4659bcdf2a0d66bb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featherVar", value)

    @builtins.property
    @jsii.member(jsii_name="tolerance")
    def tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tolerance"))

    @tolerance.setter
    def tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5499d5dcccb97cf38b0bb53e2c558096622bc551102097ee2c81510fab8beacd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tolerance", value)

    @builtins.property
    @jsii.member(jsii_name="toleranceVar")
    def tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "toleranceVar"))

    @tolerance_var.setter
    def tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__806ddd24139757187660eed948d2f191ee97fdb362515fb1d34e5ca0d2295021)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "toleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanRemoveColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanRemoveColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanRemoveColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__667b794571c305578c9bc42eb48a72c5c2d0b551149ec3a897942a16fe98cf03)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanUnsharpMask",
    jsii_struct_bases=[],
    name_mapping={
        "gain": "gain",
        "gain_var": "gainVar",
        "sigma": "sigma",
        "sigma_var": "sigmaVar",
        "threshold": "threshold",
        "threshold_var": "thresholdVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanUnsharpMask:
    def __init__(
        self,
        *,
        gain: typing.Optional[builtins.str] = None,
        gain_var: typing.Optional[builtins.str] = None,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
        threshold: typing.Optional[builtins.str] = None,
        threshold_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param gain: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        :param gain_var: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        :param sigma: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        :param threshold: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        :param threshold_var: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6b64b3d5bad094c3c5cd3074767bdf10daba5b09b95bb49c6516b667fbbde654)
            check_type(argname="argument gain", value=gain, expected_type=type_hints["gain"])
            check_type(argname="argument gain_var", value=gain_var, expected_type=type_hints["gain_var"])
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
            check_type(argname="argument threshold", value=threshold, expected_type=type_hints["threshold"])
            check_type(argname="argument threshold_var", value=threshold_var, expected_type=type_hints["threshold_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if gain is not None:
            self._values["gain"] = gain
        if gain_var is not None:
            self._values["gain_var"] = gain_var
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var
        if threshold is not None:
            self._values["threshold"] = threshold
        if threshold_var is not None:
            self._values["threshold_var"] = threshold_var

    @builtins.property
    def gain(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        '''
        result = self._values.get("gain")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gain_var(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        '''
        result = self._values.get("gain_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        '''
        result = self._values.get("threshold")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold_var(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        result = self._values.get("threshold_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanUnsharpMask(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanUnsharpMaskList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanUnsharpMaskList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__418e2122d8415003230fb528f50cb6d4c5352ef761e37ba61d419239e834dec3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanUnsharpMaskOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__46e7c858523172149bdcc5093deb7010bbfb706acdcc7404ad82d9a148553302)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanUnsharpMaskOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e7b3dbeac84691483f612792eacf15350d2f521d82758d82268bcf4bc81029ea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8af1c5a54f0477a1800e39251c1c1485423ebd3aaacb3480087642ff84fa48c7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5d352572e811272d57f9be99a465b96108ec5da966facbc7fd3adef450a250aa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanUnsharpMask]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanUnsharpMask]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanUnsharpMask]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8d718f6536c4e8970531ca8448a4be629c6f5d8da2b6ef0a2cd8e9b0d76a435c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanUnsharpMaskOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanUnsharpMaskOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7c9cfacfaa603c93319ffae29d35f1f3e74b08edf6b0389f7e0edba9174962a8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetGain")
    def reset_gain(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGain", []))

    @jsii.member(jsii_name="resetGainVar")
    def reset_gain_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGainVar", []))

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @jsii.member(jsii_name="resetThreshold")
    def reset_threshold(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThreshold", []))

    @jsii.member(jsii_name="resetThresholdVar")
    def reset_threshold_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThresholdVar", []))

    @builtins.property
    @jsii.member(jsii_name="gainInput")
    def gain_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainInput"))

    @builtins.property
    @jsii.member(jsii_name="gainVarInput")
    def gain_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdInput")
    def threshold_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdVarInput")
    def threshold_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gain")
    def gain(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gain"))

    @gain.setter
    def gain(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7389b8b817401d0ad81f686e5c5f5f3608bd0ea321bdabffa4d5f2451cb0fe76)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gain", value)

    @builtins.property
    @jsii.member(jsii_name="gainVar")
    def gain_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gainVar"))

    @gain_var.setter
    def gain_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c68fb13e8522538dfcb6c90c15fdfc1fbf098bfafb1eb6a2344fd390d58020f0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gainVar", value)

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__25848f7e716badda96292ada1e5804c64a7e0772c6e8e8947002ade2459ef6e4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__55782794a0d398afe23dd4f0f8bf82f1ab07fa4446457c40e3781fe3b2d0a323)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="threshold")
    def threshold(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "threshold"))

    @threshold.setter
    def threshold(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2cbc99ff1fffc99e091b5841b103364383c93f75728dfd02278b18b49c318b45)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "threshold", value)

    @builtins.property
    @jsii.member(jsii_name="thresholdVar")
    def threshold_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "thresholdVar"))

    @threshold_var.setter
    def threshold_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af57382960e935b8069707ef45b441b6c6834abdd1ca6108a317e956ea7e496d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "thresholdVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanUnsharpMask]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanUnsharpMask]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanUnsharpMask]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7370c102e6e3782cb3fad5b9188a8a6b004c8d259b881ec744d7be9c118762f7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3af951f678ce01f394b4e955e6c7dcccf7e7ba4b50043fe9601f09303973a9dc)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a4d6a244bf2e499a5fa3be7779746c7e795b9e1f0b189e95f37af185550e21c6)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2671fe68ebbadc9b50f4c06125dac33597585afa5f60977373752cd75feb4fdf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a964f65dc46aa113f1f372be06b7d4670f7d1c0eded2d8e85e7839597bfb0bce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__75cba9f7d3aa5595b2f3f265b7876a240fd2982fd7a8067a2b7ab8fbbe86e36d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimension]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimension]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__775e9f01cb6b680b0039ce67987c3e12a3986d582c4d53d58f960f4ce298fc50)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b34658c75d2f35d24be929ff30a358caf2eeac0d3a5988dc9faf4765cc2c0e6e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(
        self,
        *,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefault(
            background_color=background_color,
            blur=blur,
            chroma_key=chroma_key,
            composite=composite,
            compound=compound,
            contrast=contrast,
            goop=goop,
            grayscale=grayscale,
            hsl=hsl,
            hsv=hsv,
            if_dimension=if_dimension,
            if_orientation=if_orientation,
            max_colors=max_colors,
            mirror=mirror,
            mono_hue=mono_hue,
            opacity=opacity,
            remove_color=remove_color,
            unsharp_mask=unsharp_mask,
        )

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putEqual")
    def put_equal(
        self,
        *,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqual(
            background_color=background_color,
            blur=blur,
            chroma_key=chroma_key,
            composite=composite,
            compound=compound,
            contrast=contrast,
            goop=goop,
            grayscale=grayscale,
            hsl=hsl,
            hsv=hsv,
            if_dimension=if_dimension,
            if_orientation=if_orientation,
            max_colors=max_colors,
            mirror=mirror,
            mono_hue=mono_hue,
            opacity=opacity,
            remove_color=remove_color,
            unsharp_mask=unsharp_mask,
        )

        return typing.cast(None, jsii.invoke(self, "putEqual", [value]))

    @jsii.member(jsii_name="putGreaterThan")
    def put_greater_than(
        self,
        *,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThan(
            background_color=background_color,
            blur=blur,
            chroma_key=chroma_key,
            composite=composite,
            compound=compound,
            contrast=contrast,
            goop=goop,
            grayscale=grayscale,
            hsl=hsl,
            hsv=hsv,
            if_dimension=if_dimension,
            if_orientation=if_orientation,
            max_colors=max_colors,
            mirror=mirror,
            mono_hue=mono_hue,
            opacity=opacity,
            remove_color=remove_color,
            unsharp_mask=unsharp_mask,
        )

        return typing.cast(None, jsii.invoke(self, "putGreaterThan", [value]))

    @jsii.member(jsii_name="putLessThan")
    def put_less_than(
        self,
        *,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        value = DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThan(
            background_color=background_color,
            blur=blur,
            chroma_key=chroma_key,
            composite=composite,
            compound=compound,
            contrast=contrast,
            goop=goop,
            grayscale=grayscale,
            hsl=hsl,
            hsv=hsv,
            if_dimension=if_dimension,
            if_orientation=if_orientation,
            max_colors=max_colors,
            mirror=mirror,
            mono_hue=mono_hue,
            opacity=opacity,
            remove_color=remove_color,
            unsharp_mask=unsharp_mask,
        )

        return typing.cast(None, jsii.invoke(self, "putLessThan", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetDimension")
    def reset_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimension", []))

    @jsii.member(jsii_name="resetDimensionVar")
    def reset_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimensionVar", []))

    @jsii.member(jsii_name="resetEqual")
    def reset_equal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEqual", []))

    @jsii.member(jsii_name="resetGreaterThan")
    def reset_greater_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGreaterThan", []))

    @jsii.member(jsii_name="resetLessThan")
    def reset_less_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLessThan", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="equal")
    def equal(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualOutputReference, jsii.get(self, "equal"))

    @builtins.property
    @jsii.member(jsii_name="greaterThan")
    def greater_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanOutputReference, jsii.get(self, "greaterThan"))

    @builtins.property
    @jsii.member(jsii_name="lessThan")
    def less_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanOutputReference, jsii.get(self, "lessThan"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionInput")
    def dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionVarInput")
    def dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="equalInput")
    def equal_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqual], jsii.get(self, "equalInput"))

    @builtins.property
    @jsii.member(jsii_name="greaterThanInput")
    def greater_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThan], jsii.get(self, "greaterThanInput"))

    @builtins.property
    @jsii.member(jsii_name="lessThanInput")
    def less_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThan], jsii.get(self, "lessThanInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="dimension")
    def dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimension"))

    @dimension.setter
    def dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a6f47928caaf870b4be68bc59c4c5f0045dcb33ffae884f4c7ab5cb77a5fc700)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimension", value)

    @builtins.property
    @jsii.member(jsii_name="dimensionVar")
    def dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimensionVar"))

    @dimension_var.setter
    def dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b647b579fa2c0eb37dc130ba329f72d801332765bde69a37151b642041cf5c8a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f9d9102b2b1ca50cc9357caa16e28b0d4cfd7b83ed9a311d0d29c39fc0a31d2a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7e15f05c3d62baa65fa5bba1dbc10f357ae066103e4f2e6fe759612851462db9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimension]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimension]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimension]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b2e8a1945bfc408f6df9144710973d51c05218de69a2f2d4ff76313cf290a2dd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareMaxColors",
    jsii_struct_bases=[],
    name_mapping={"colors": "colors", "colors_var": "colorsVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareMaxColors:
    def __init__(
        self,
        *,
        colors: typing.Optional[builtins.str] = None,
        colors_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param colors: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        :param colors_var: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c350698b63c04bacf631792f9a6f582a9b0d9f8eeb5881d7639d54a14bfda59a)
            check_type(argname="argument colors", value=colors, expected_type=type_hints["colors"])
            check_type(argname="argument colors_var", value=colors_var, expected_type=type_hints["colors_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if colors is not None:
            self._values["colors"] = colors
        if colors_var is not None:
            self._values["colors_var"] = colors_var

    @builtins.property
    def colors(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        '''
        result = self._values.get("colors")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def colors_var(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        result = self._values.get("colors_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareMaxColors(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareMaxColorsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareMaxColorsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9fdd45d319066bb7a97b744890c32343524c569adbfde709c145bb9a44142681)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareMaxColorsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f1247898b9b88b138b254fb1741d72f328358b76dad384d1bb7db13439466dc2)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareMaxColorsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b5090223c52fa60737f7e4cf6da2383b721ea0feca0ba79952c8252c895c90c0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e68c1388cbf5edb36e673123ceb16bf1b36b2d63b1f4d5cd8764aa9d8a422ee8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e777b98ce51b6d7cc159fd12a36f19b266631d9b6b420b6137d3880b3f6482b3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareMaxColors]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareMaxColors]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9451e5d75b920378fcaa0f6b458453767770e01be59ca29e18cce3be6ffe8ed3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareMaxColorsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareMaxColorsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__06815e9161350e2bcbbad39256e62903dd1521478bd76f1773557371eb7f2854)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColors")
    def reset_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColors", []))

    @jsii.member(jsii_name="resetColorsVar")
    def reset_colors_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorsVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorsInput")
    def colors_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsInput"))

    @builtins.property
    @jsii.member(jsii_name="colorsVarInput")
    def colors_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsVarInput"))

    @builtins.property
    @jsii.member(jsii_name="colors")
    def colors(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colors"))

    @colors.setter
    def colors(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ae79749a0c3267ff33009c181843d88c020611e6e1fd9e844758387a733043ad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colors", value)

    @builtins.property
    @jsii.member(jsii_name="colorsVar")
    def colors_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorsVar"))

    @colors_var.setter
    def colors_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__346cc14174801e157b25f868bb1ca32b119e7a23d784ebadff1ef1414145a293)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorsVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareMaxColors]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareMaxColors]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareMaxColors]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__644d81518476886d839a2d368c9ba9a4442c4617fd51d3730b114261e5d3efda)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareMirror",
    jsii_struct_bases=[],
    name_mapping={
        "horizontal": "horizontal",
        "horizontal_var": "horizontalVar",
        "vertical": "vertical",
        "vertical_var": "verticalVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareMirror:
    def __init__(
        self,
        *,
        horizontal: typing.Optional[builtins.str] = None,
        horizontal_var: typing.Optional[builtins.str] = None,
        vertical: typing.Optional[builtins.str] = None,
        vertical_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param horizontal: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        :param horizontal_var: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        :param vertical: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        :param vertical_var: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1b20d9400a165a7747830aec436175a5109fc00741a31aa532b03387e5ee4295)
            check_type(argname="argument horizontal", value=horizontal, expected_type=type_hints["horizontal"])
            check_type(argname="argument horizontal_var", value=horizontal_var, expected_type=type_hints["horizontal_var"])
            check_type(argname="argument vertical", value=vertical, expected_type=type_hints["vertical"])
            check_type(argname="argument vertical_var", value=vertical_var, expected_type=type_hints["vertical_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if horizontal is not None:
            self._values["horizontal"] = horizontal
        if horizontal_var is not None:
            self._values["horizontal_var"] = horizontal_var
        if vertical is not None:
            self._values["vertical"] = vertical
        if vertical_var is not None:
            self._values["vertical_var"] = vertical_var

    @builtins.property
    def horizontal(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        '''
        result = self._values.get("horizontal")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def horizontal_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        '''
        result = self._values.get("horizontal_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        '''
        result = self._values.get("vertical")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        result = self._values.get("vertical_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareMirror(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareMirrorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareMirrorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bffab46fa1255c212125b56a13c90bdc80ead6d124dbcb45876884e9c323fd62)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareMirrorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__88520f81535ed767104a1752035e2cec1ed4f902bcd8655a35c0d5cc2f5c9893)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareMirrorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__868f3e0f554e7398ad3709a34db26213b00b2c547d37327779360433f3225360)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2c4eee29bbc8cb7243f0bbaca1e729702e227c8ba240f9b58eef99f72ecc73bf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__618234439834f3cc133d9e3e6eed6b764d1546de524eabe4e83ee83e3068a6e5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareMirror]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareMirror]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__71a6e73771e8aa48147a1939169e06547733af6de16c438ae5a4d797252cca43)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareMirrorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareMirrorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__90e9c741609aaa9a2f11a48bf9f6e7cd60e4e42beb20f38f26eb843355f24ed0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHorizontal")
    def reset_horizontal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontal", []))

    @jsii.member(jsii_name="resetHorizontalVar")
    def reset_horizontal_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontalVar", []))

    @jsii.member(jsii_name="resetVertical")
    def reset_vertical(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVertical", []))

    @jsii.member(jsii_name="resetVerticalVar")
    def reset_vertical_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVerticalVar", []))

    @builtins.property
    @jsii.member(jsii_name="horizontalInput")
    def horizontal_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontalVarInput")
    def horizontal_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalInput")
    def vertical_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalVarInput")
    def vertical_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontal")
    def horizontal(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontal"))

    @horizontal.setter
    def horizontal(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__99a8d8d15c21d2343f44f2f22d6d7220c17b14c2a55548cbc149513e73fe0180)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontal", value)

    @builtins.property
    @jsii.member(jsii_name="horizontalVar")
    def horizontal_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontalVar"))

    @horizontal_var.setter
    def horizontal_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__80b8c11bb2163239b07001113a5d81eb09afd177d3e8f2080044c3efdc8a7261)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontalVar", value)

    @builtins.property
    @jsii.member(jsii_name="vertical")
    def vertical(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "vertical"))

    @vertical.setter
    def vertical(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d21bfef86c8355a9d88661bacb8f300c8d556a8efdef7405fcee9dc48f3c7225)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "vertical", value)

    @builtins.property
    @jsii.member(jsii_name="verticalVar")
    def vertical_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "verticalVar"))

    @vertical_var.setter
    def vertical_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c72474655cf46b3b6cdd1181e2992866eaaae3c37dfa69365da157363233a5ba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "verticalVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareMirror]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareMirror]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareMirror]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f277c227834a8427aec04a50b6018f5ccc957e0c7fb203f62ed6fbeaf12199f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareMonoHue",
    jsii_struct_bases=[],
    name_mapping={"hue": "hue", "hue_var": "hueVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareMonoHue:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__632948b27dbd217adda95ce74f257ce048a4343ea543209aba78d61a43f47144)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareMonoHue(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareMonoHueList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareMonoHueList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1659c9ca041b7aaa5e06b8e74a951be55f187922138fed4ca39043d869be7efd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareMonoHueOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__77da94019b1c72d36d30002b8f06addff6ef1481eaf77c544cd8f80f2a58573e)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareMonoHueOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd34fd92e70ae36a630003dddefc75f938f4bd5841be44a7f3fa07985d15cc94)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9fc52c75827aea4ed4f3a7c203283ef03cddec7e7b13f68de68c42a28f7d8404)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3fb53d2330cdcfff64f43f5cd70e40367c3e94976c8e2a94888912fb9e7b577b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareMonoHue]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareMonoHue]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__86e0659ca67687bf215f6f18aa0fff3cf227fdc379527db85650ba438d604231)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareMonoHueOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareMonoHueOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fc4701d3283632d409d61bc2f531598c652e9207a7c3e5ad1c10542678c849c9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__820a16cb6c095dc1e0111ec77ee41f85b9b9bd78e079ab2621c5b46c1604f6e5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__afd4b7b636a8d1f932c6e2d8d31b451dbf621f3ba75eb85f0539adb1a15dfc82)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareMonoHue]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareMonoHue]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareMonoHue]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e1169075f9ad2bd28dcaa205e569e426fed6008601f4c9248533cda4af91881f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareOpacity",
    jsii_struct_bases=[],
    name_mapping={"opacity": "opacity", "opacity_var": "opacityVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareOpacity:
    def __init__(
        self,
        *,
        opacity: typing.Optional[builtins.str] = None,
        opacity_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param opacity: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param opacity_var: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__43deb0d74b506b9ef8ff54bd82f595a623969afd54d170f1ce7edc0f5f83ff1a)
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument opacity_var", value=opacity_var, expected_type=type_hints["opacity_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if opacity is not None:
            self._values["opacity"] = opacity
        if opacity_var is not None:
            self._values["opacity_var"] = opacity_var

    @builtins.property
    def opacity(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def opacity_var(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        result = self._values.get("opacity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareOpacity(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareOpacityList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareOpacityList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0323015d3bbebef572efb736d2c99809351f8b2a2fa63bec1f21ee9c6a7b083b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareOpacityOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7a2bd3bedba5b0d639f07c3429a80b8c6de69ef7142d7cba6e10a43bc88b1d2c)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareOpacityOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5abc686610754a528c13cffb0085dd96d9435cd8e496005306181b36aacbad19)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aca50911f53c088e8f7ba89f57b5a18586a904965b6263db04e88240dc31a3a9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e1604d088174856b2d9f101db54a3e207b2aa3f83b9227d01c245a573125dbb6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareOpacity]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareOpacity]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d813ccd10b026902b1235091675996818d2fb1472d7e0933f72a1e0fa480284b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareOpacityOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareOpacityOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a2978fbe71750ab27fbd72144260bd4728f96c520ce2ea8a35ad6ae67d3aceee)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetOpacityVar")
    def reset_opacity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacityVar", []))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityVarInput")
    def opacity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacity"))

    @opacity.setter
    def opacity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f73ff1af03257fca779a8355e339037c6f4902a917be8fe824c20cc4e3bdb34b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacity", value)

    @builtins.property
    @jsii.member(jsii_name="opacityVar")
    def opacity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacityVar"))

    @opacity_var.setter
    def opacity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d9764520e418bb4e3926efcd09952b1776e0281f3449d5afddc8baecc5def820)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacityVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareOpacity]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareOpacity]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareOpacity]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e26caf742d83c1e97f43ea6ba74138b90631ff2802e30d2760ee928b2b780443)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d734da07dc311caf31b71c3c8acd89af91328c89b5224583d3e64cc85a538a6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putBackgroundColor")
    def put_background_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7a6fd0c097bba1562686959c85f3a477acfc6b31f12a6c65e73e8e393653095d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBackgroundColor", [value]))

    @jsii.member(jsii_name="putBlur")
    def put_blur(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareBlur, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a838b8e8f52ed3b20b42b21043899f75241c75e69afe63f0c6d22e3e9718a78f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBlur", [value]))

    @jsii.member(jsii_name="putChromaKey")
    def put_chroma_key(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareChromaKey, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f69f4ece1eee458b71ac7720541f232d76f2515fbfbd7fcbe93396a8ec6619df)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putChromaKey", [value]))

    @jsii.member(jsii_name="putComposite")
    def put_composite(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareComposite, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__26e28a8f4e0312ce43823ac6fe6d65e7b69b2b0b75b7384b4799412601ea1a33)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putComposite", [value]))

    @jsii.member(jsii_name="putCompound")
    def put_compound(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompound, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3791d267bfbb60004129c40b9f7db731338d386ca83c1d0180e3287abb731259)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCompound", [value]))

    @jsii.member(jsii_name="putContrast")
    def put_contrast(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareContrast, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__13eaa2764ded42232a4ed6dc2ad0996a27ac656938362cbd579efa794096ad85)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putContrast", [value]))

    @jsii.member(jsii_name="putGoop")
    def put_goop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareGoop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5c112af0f03d3755d0e6ee4a1685fd05de3d1a51bab1b6a8c0d31f199df82e71)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGoop", [value]))

    @jsii.member(jsii_name="putGrayscale")
    def put_grayscale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareGrayscale, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ea9b1edc16d1d257ad39f1706583b31b6b0a5e07e62e260cdb70ad3f2a68227)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGrayscale", [value]))

    @jsii.member(jsii_name="putHsl")
    def put_hsl(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareHsl, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ca01429803c3aa11a1500ff6e7ae0bb04f32465dc959f1f7d0b6dcabcaca55f4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsl", [value]))

    @jsii.member(jsii_name="putHsv")
    def put_hsv(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareHsv, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__301242b6d4437263b2f597f5c7220bb8a2caebb57751e7733916010eb51505c1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsv", [value]))

    @jsii.member(jsii_name="putIfDimension")
    def put_if_dimension(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimension, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8e9ed35a88e40f93fe5289268c2dce702c4fad7a4cbf74c3895c25b3b3a85214)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfDimension", [value]))

    @jsii.member(jsii_name="putIfOrientation")
    def put_if_orientation(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9f907c82e87bd7953406c6956130a744d155f88c375bbb720d5e556c5bc28187)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfOrientation", [value]))

    @jsii.member(jsii_name="putMaxColors")
    def put_max_colors(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareMaxColors, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__21cfde728808418b2bb0211144ec62a76d821ac44c7d987313ea1a934a03c477)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMaxColors", [value]))

    @jsii.member(jsii_name="putMirror")
    def put_mirror(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareMirror, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__97d982ea8fda498baffcb3469d9462bdb8ed0fa6d2cee1d71cf46604485b38a7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMirror", [value]))

    @jsii.member(jsii_name="putMonoHue")
    def put_mono_hue(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareMonoHue, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b213eaab76b399bfaed01efcfc0ef94a5b96a696e237c6fc1d33d70ae7d7932f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMonoHue", [value]))

    @jsii.member(jsii_name="putOpacity")
    def put_opacity(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareOpacity, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__51e764acd8f89bafa29e803172fcf7f132351b5543392992939c246356582e07)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putOpacity", [value]))

    @jsii.member(jsii_name="putRemoveColor")
    def put_remove_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareRemoveColor", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8e82eccff7e8531bde930196ef8e745417a4a64ef93a48e3ef30a064aa574f26)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRemoveColor", [value]))

    @jsii.member(jsii_name="putUnsharpMask")
    def put_unsharp_mask(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareUnsharpMask", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5a710d4fbce72afaf56f1405033fe325fc9954f299843463177919b84111d17f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putUnsharpMask", [value]))

    @jsii.member(jsii_name="resetBackgroundColor")
    def reset_background_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBackgroundColor", []))

    @jsii.member(jsii_name="resetBlur")
    def reset_blur(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBlur", []))

    @jsii.member(jsii_name="resetChromaKey")
    def reset_chroma_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChromaKey", []))

    @jsii.member(jsii_name="resetComposite")
    def reset_composite(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetComposite", []))

    @jsii.member(jsii_name="resetCompound")
    def reset_compound(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCompound", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetGoop")
    def reset_goop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGoop", []))

    @jsii.member(jsii_name="resetGrayscale")
    def reset_grayscale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGrayscale", []))

    @jsii.member(jsii_name="resetHsl")
    def reset_hsl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsl", []))

    @jsii.member(jsii_name="resetHsv")
    def reset_hsv(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsv", []))

    @jsii.member(jsii_name="resetIfDimension")
    def reset_if_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfDimension", []))

    @jsii.member(jsii_name="resetIfOrientation")
    def reset_if_orientation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfOrientation", []))

    @jsii.member(jsii_name="resetMaxColors")
    def reset_max_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxColors", []))

    @jsii.member(jsii_name="resetMirror")
    def reset_mirror(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMirror", []))

    @jsii.member(jsii_name="resetMonoHue")
    def reset_mono_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonoHue", []))

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetRemoveColor")
    def reset_remove_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRemoveColor", []))

    @jsii.member(jsii_name="resetUnsharpMask")
    def reset_unsharp_mask(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUnsharpMask", []))

    @builtins.property
    @jsii.member(jsii_name="backgroundColor")
    def background_color(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareBackgroundColorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareBackgroundColorList, jsii.get(self, "backgroundColor"))

    @builtins.property
    @jsii.member(jsii_name="blur")
    def blur(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareBlurList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareBlurList, jsii.get(self, "blur"))

    @builtins.property
    @jsii.member(jsii_name="chromaKey")
    def chroma_key(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareChromaKeyList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareChromaKeyList, jsii.get(self, "chromaKey"))

    @builtins.property
    @jsii.member(jsii_name="composite")
    def composite(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeList, jsii.get(self, "composite"))

    @builtins.property
    @jsii.member(jsii_name="compound")
    def compound(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundList, jsii.get(self, "compound"))

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareContrastList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareContrastList, jsii.get(self, "contrast"))

    @builtins.property
    @jsii.member(jsii_name="goop")
    def goop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareGoopList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareGoopList, jsii.get(self, "goop"))

    @builtins.property
    @jsii.member(jsii_name="grayscale")
    def grayscale(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareGrayscaleList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareGrayscaleList, jsii.get(self, "grayscale"))

    @builtins.property
    @jsii.member(jsii_name="hsl")
    def hsl(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareHslList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareHslList, jsii.get(self, "hsl"))

    @builtins.property
    @jsii.member(jsii_name="hsv")
    def hsv(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareHsvList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareHsvList, jsii.get(self, "hsv"))

    @builtins.property
    @jsii.member(jsii_name="ifDimension")
    def if_dimension(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionList, jsii.get(self, "ifDimension"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientation")
    def if_orientation(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationList, jsii.get(self, "ifOrientation"))

    @builtins.property
    @jsii.member(jsii_name="maxColors")
    def max_colors(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareMaxColorsList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareMaxColorsList, jsii.get(self, "maxColors"))

    @builtins.property
    @jsii.member(jsii_name="mirror")
    def mirror(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareMirrorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareMirrorList, jsii.get(self, "mirror"))

    @builtins.property
    @jsii.member(jsii_name="monoHue")
    def mono_hue(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareMonoHueList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareMonoHueList, jsii.get(self, "monoHue"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareOpacityList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareOpacityList, jsii.get(self, "opacity"))

    @builtins.property
    @jsii.member(jsii_name="removeColor")
    def remove_color(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareRemoveColorList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareRemoveColorList", jsii.get(self, "removeColor"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMask")
    def unsharp_mask(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareUnsharpMaskList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareUnsharpMaskList", jsii.get(self, "unsharpMask"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColorInput")
    def background_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareBackgroundColor]]], jsii.get(self, "backgroundColorInput"))

    @builtins.property
    @jsii.member(jsii_name="blurInput")
    def blur_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareBlur]]], jsii.get(self, "blurInput"))

    @builtins.property
    @jsii.member(jsii_name="chromaKeyInput")
    def chroma_key_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareChromaKey]]], jsii.get(self, "chromaKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="compositeInput")
    def composite_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareComposite]]], jsii.get(self, "compositeInput"))

    @builtins.property
    @jsii.member(jsii_name="compoundInput")
    def compound_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompound]]], jsii.get(self, "compoundInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareContrast]]], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="goopInput")
    def goop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareGoop]]], jsii.get(self, "goopInput"))

    @builtins.property
    @jsii.member(jsii_name="grayscaleInput")
    def grayscale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareGrayscale]]], jsii.get(self, "grayscaleInput"))

    @builtins.property
    @jsii.member(jsii_name="hslInput")
    def hsl_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareHsl]]], jsii.get(self, "hslInput"))

    @builtins.property
    @jsii.member(jsii_name="hsvInput")
    def hsv_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareHsv]]], jsii.get(self, "hsvInput"))

    @builtins.property
    @jsii.member(jsii_name="ifDimensionInput")
    def if_dimension_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimension]]], jsii.get(self, "ifDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientationInput")
    def if_orientation_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientation]]], jsii.get(self, "ifOrientationInput"))

    @builtins.property
    @jsii.member(jsii_name="maxColorsInput")
    def max_colors_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareMaxColors]]], jsii.get(self, "maxColorsInput"))

    @builtins.property
    @jsii.member(jsii_name="mirrorInput")
    def mirror_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareMirror]]], jsii.get(self, "mirrorInput"))

    @builtins.property
    @jsii.member(jsii_name="monoHueInput")
    def mono_hue_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareMonoHue]]], jsii.get(self, "monoHueInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareOpacity]]], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="removeColorInput")
    def remove_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareRemoveColor"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareRemoveColor"]]], jsii.get(self, "removeColorInput"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMaskInput")
    def unsharp_mask_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareUnsharpMask"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareUnsharpMask"]]], jsii.get(self, "unsharpMaskInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquare]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquare], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquare],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5e44fe3d17114ae11d54b75b1fa9686bb7bfccdbdb3065e0c06d0204d0f7771b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareRemoveColor",
    jsii_struct_bases=[],
    name_mapping={
        "color": "color",
        "color_var": "colorVar",
        "feather": "feather",
        "feather_var": "featherVar",
        "tolerance": "tolerance",
        "tolerance_var": "toleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareRemoveColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
        feather: typing.Optional[builtins.str] = None,
        feather_var: typing.Optional[builtins.str] = None,
        tolerance: typing.Optional[builtins.str] = None,
        tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        :param feather: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        :param feather_var: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        :param tolerance: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        :param tolerance_var: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2afb0d09bd27deb7866b1209a1334e9c8739877c667a89e15ecc14a1a3f1bc94)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
            check_type(argname="argument feather", value=feather, expected_type=type_hints["feather"])
            check_type(argname="argument feather_var", value=feather_var, expected_type=type_hints["feather_var"])
            check_type(argname="argument tolerance", value=tolerance, expected_type=type_hints["tolerance"])
            check_type(argname="argument tolerance_var", value=tolerance_var, expected_type=type_hints["tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var
        if feather is not None:
            self._values["feather"] = feather
        if feather_var is not None:
            self._values["feather_var"] = feather_var
        if tolerance is not None:
            self._values["tolerance"] = tolerance
        if tolerance_var is not None:
            self._values["tolerance_var"] = tolerance_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        '''
        result = self._values.get("feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather_var(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        '''
        result = self._values.get("feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        '''
        result = self._values.get("tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance_var(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        result = self._values.get("tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareRemoveColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareRemoveColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareRemoveColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0d372982429b8adf0593362337bc11eabb2f3fdfe11c19185294272f0a5cc526)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareRemoveColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__273751fb38b3c53e7d4d6a2808b7d27079b2b32a4c515f7f5419e8ad1e483355)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareRemoveColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__782c1c46faf95df6f719f04b4a0b920fe7b456bf2fb9e57e2d5482043eaa704a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__734b0ac8147954ba6f54637a8d683e41728fd4680ac42fae262e09c94fe67016)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2b852ead06b72d138e8b99095c9a389b149f6137e03a4348ba2fbfc8977e6363)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareRemoveColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareRemoveColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareRemoveColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8461b8d5ae629a3649f2d3365df7d997c4e92eb502e8814c5f360878837e8d74)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareRemoveColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareRemoveColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7b073fa5f9ebd40029f2fe3b98a7c20eb6b40fbd744c56719e4f1d806d7ed41c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @jsii.member(jsii_name="resetFeather")
    def reset_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeather", []))

    @jsii.member(jsii_name="resetFeatherVar")
    def reset_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatherVar", []))

    @jsii.member(jsii_name="resetTolerance")
    def reset_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTolerance", []))

    @jsii.member(jsii_name="resetToleranceVar")
    def reset_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featherInput")
    def feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherInput"))

    @builtins.property
    @jsii.member(jsii_name="featherVarInput")
    def feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceInput")
    def tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceVarInput")
    def tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d1cfb3f60de88915024ab2386300415631c9f60c8340c3864a2d91acb12b09e9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eb4496348339ba8b57229f695fd7030fecb6619c9260cac437da9e44ae167adf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="feather")
    def feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "feather"))

    @feather.setter
    def feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d4f7a5cdbc5e04bfeb2ef67876332a998372d125f8552f9eb140597c5bf5d258)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "feather", value)

    @builtins.property
    @jsii.member(jsii_name="featherVar")
    def feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featherVar"))

    @feather_var.setter
    def feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c234eaba8d1fe48a4e95777e4d319f514224b971a0daa8acc232c79dc2464beb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featherVar", value)

    @builtins.property
    @jsii.member(jsii_name="tolerance")
    def tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tolerance"))

    @tolerance.setter
    def tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__34038f751db69669e38ef9617a63d665b109a9686b8b1231f69d7127c1e3a308)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tolerance", value)

    @builtins.property
    @jsii.member(jsii_name="toleranceVar")
    def tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "toleranceVar"))

    @tolerance_var.setter
    def tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__84f70d7a2b1217b32d6381e989164c145661f75338f51d81454ad3c3e2849518)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "toleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareRemoveColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareRemoveColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareRemoveColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0aa5f5635194897149058d6844b3c01e2769693e53e63eeb83b6c39732be83e0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareUnsharpMask",
    jsii_struct_bases=[],
    name_mapping={
        "gain": "gain",
        "gain_var": "gainVar",
        "sigma": "sigma",
        "sigma_var": "sigmaVar",
        "threshold": "threshold",
        "threshold_var": "thresholdVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareUnsharpMask:
    def __init__(
        self,
        *,
        gain: typing.Optional[builtins.str] = None,
        gain_var: typing.Optional[builtins.str] = None,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
        threshold: typing.Optional[builtins.str] = None,
        threshold_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param gain: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        :param gain_var: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        :param sigma: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        :param threshold: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        :param threshold_var: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__22754ee1f5b20695366d0c666ca260f787ee4354f1af9105b24a7bf2221f0fd4)
            check_type(argname="argument gain", value=gain, expected_type=type_hints["gain"])
            check_type(argname="argument gain_var", value=gain_var, expected_type=type_hints["gain_var"])
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
            check_type(argname="argument threshold", value=threshold, expected_type=type_hints["threshold"])
            check_type(argname="argument threshold_var", value=threshold_var, expected_type=type_hints["threshold_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if gain is not None:
            self._values["gain"] = gain
        if gain_var is not None:
            self._values["gain_var"] = gain_var
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var
        if threshold is not None:
            self._values["threshold"] = threshold
        if threshold_var is not None:
            self._values["threshold_var"] = threshold_var

    @builtins.property
    def gain(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        '''
        result = self._values.get("gain")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gain_var(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        '''
        result = self._values.get("gain_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        '''
        result = self._values.get("threshold")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold_var(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        result = self._values.get("threshold_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareUnsharpMask(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareUnsharpMaskList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareUnsharpMaskList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1db575fb02e68b2b5239d770879ec5ff5248bb3da76287abad4a28a0e4ade342)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareUnsharpMaskOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c91ee3482c415d3d26d64f71d6e73b3841a1a2e789cc80fcb5d66b8a66735c5f)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareUnsharpMaskOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e1b2f0e155519766cf4210da97d7364ed074708696aafb0ca74eff5fba3381c8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__98d3877026f1da576943dc349ec4474317f09de110c8ed4f0f1fe0f68f82afcf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__daa858afa3bda7871515b43c46fab66e1411dcccf06f086740d830fd5d8132e3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareUnsharpMask]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareUnsharpMask]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareUnsharpMask]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1ff7ce41c632011817bda78cc43f047b5ed00cede73c3af6109824ded30ae8f3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareUnsharpMaskOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareUnsharpMaskOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ce7cd06837cd0760f30297b0401529621639a2654b03a31a00f5e1aa8207df7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetGain")
    def reset_gain(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGain", []))

    @jsii.member(jsii_name="resetGainVar")
    def reset_gain_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGainVar", []))

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @jsii.member(jsii_name="resetThreshold")
    def reset_threshold(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThreshold", []))

    @jsii.member(jsii_name="resetThresholdVar")
    def reset_threshold_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThresholdVar", []))

    @builtins.property
    @jsii.member(jsii_name="gainInput")
    def gain_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainInput"))

    @builtins.property
    @jsii.member(jsii_name="gainVarInput")
    def gain_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdInput")
    def threshold_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdVarInput")
    def threshold_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gain")
    def gain(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gain"))

    @gain.setter
    def gain(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d6c6bb1dca497f9d84db4633536c997279e76208aa3a72baf38a06af296a36a6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gain", value)

    @builtins.property
    @jsii.member(jsii_name="gainVar")
    def gain_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gainVar"))

    @gain_var.setter
    def gain_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__de8cab2f00721d28dc07de3cc6061f13343c767c0a72497c57905b8927598196)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gainVar", value)

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4227bf3ca964816b4bf4366bbba41047c72b886d33f7bda19f20e394da34440a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__28de90b84ab98cf6aae3e779de37af5bf1f804e300557c3ede90f76730963ae3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="threshold")
    def threshold(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "threshold"))

    @threshold.setter
    def threshold(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6fb1f5d4ab28a48c256ae43bbf36afe869d38bce7e8a81c15b19d9aea6e67b93)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "threshold", value)

    @builtins.property
    @jsii.member(jsii_name="thresholdVar")
    def threshold_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "thresholdVar"))

    @threshold_var.setter
    def threshold_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8195bcb52ddb3d8788e4c40cacd3c7daac78e284dce2300c69ac87f3826b714c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "thresholdVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareUnsharpMask]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareUnsharpMask]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareUnsharpMask]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ab7ac8d119a39f5784c586258167464c64942b1d72f0ccfcd315d42508c91b6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7c06b99930c543cdd5143b9fc9085f24e9b3da6e4d8ecdb77c97c81a60967283)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d455f9f9d1657548b13d70b7007048e2545c0667b62f0e153ad98bdd92bae355)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a184d550629e1c5152548913135ebb1406084a2e2d027775bbd238e77119ce3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__60a6ee8aea2aaf271198c42ba66498f8f9941dbc58fc8ea5e62b6e6187a93338)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e48b6393c76886f48a3cbe054d3cbdad093940796944e4853686cfb3c0f68f12)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformations]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformations]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformations]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__357ea0850bdc630294db3af035790cb2b8de81b87fe83f5a2986c4f5bdf14e73)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsMaxColors",
    jsii_struct_bases=[],
    name_mapping={"colors": "colors", "colors_var": "colorsVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsMaxColors:
    def __init__(
        self,
        *,
        colors: typing.Optional[builtins.str] = None,
        colors_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param colors: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        :param colors_var: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bf958555f31533b5f817695211bae6d9b94b015a1cfa98dc1e5b66565529eab2)
            check_type(argname="argument colors", value=colors, expected_type=type_hints["colors"])
            check_type(argname="argument colors_var", value=colors_var, expected_type=type_hints["colors_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if colors is not None:
            self._values["colors"] = colors
        if colors_var is not None:
            self._values["colors_var"] = colors_var

    @builtins.property
    def colors(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        '''
        result = self._values.get("colors")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def colors_var(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        result = self._values.get("colors_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsMaxColors(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsMaxColorsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsMaxColorsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ce6335439f0e7d79770d308247dff2262e542cc62cc3797c31ed7a2173153e5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsMaxColorsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a3f312f425971f59b5482b55c1c75a99cdb116f5168a83fc36ca728e58ee4a0a)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsMaxColorsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9eec94818be97bede66553e16de7dbf6752e8c0d7fcb14b84ac3cab1b24aa8a6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e767386c869aba5ca079d284bb9f027169c8775e277ac43a5eb9f9daf8f5e83e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fdb291e4dc1dc3c3aaaf8d8865692fa47b8bd22da68cba98751a2cc73558d87e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsMaxColors]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsMaxColors]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e241773f612931d54103a6465b7771a763dc1c928c52aafd322e1f89a10d74a3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsMaxColorsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsMaxColorsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f8e7a7ebcd5ed6c02c427b2bb471c3c391223cbb119cc73fab6b3ef361d4ff61)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColors")
    def reset_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColors", []))

    @jsii.member(jsii_name="resetColorsVar")
    def reset_colors_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorsVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorsInput")
    def colors_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsInput"))

    @builtins.property
    @jsii.member(jsii_name="colorsVarInput")
    def colors_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsVarInput"))

    @builtins.property
    @jsii.member(jsii_name="colors")
    def colors(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colors"))

    @colors.setter
    def colors(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a6e28d37eb7cf2b3465e43e476dc0a0b005bd9a61032f164872a731f61e03021)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colors", value)

    @builtins.property
    @jsii.member(jsii_name="colorsVar")
    def colors_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorsVar"))

    @colors_var.setter
    def colors_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1ae4c9123462eee2d0716250a6d05740c2988ebd0f2f3746b2001e7491c8419e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorsVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsMaxColors]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsMaxColors]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsMaxColors]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3d122bfc6b8a28eb1c9e06ce7c5693d8d44aee72dcfab6d67d5c2246477bb4f0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsMirror",
    jsii_struct_bases=[],
    name_mapping={
        "horizontal": "horizontal",
        "horizontal_var": "horizontalVar",
        "vertical": "vertical",
        "vertical_var": "verticalVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsMirror:
    def __init__(
        self,
        *,
        horizontal: typing.Optional[builtins.str] = None,
        horizontal_var: typing.Optional[builtins.str] = None,
        vertical: typing.Optional[builtins.str] = None,
        vertical_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param horizontal: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        :param horizontal_var: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        :param vertical: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        :param vertical_var: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3183901d75b2e2c17ecf697c51cff6c53e7bf91ed51aef4ba8bbc64b461fd8cb)
            check_type(argname="argument horizontal", value=horizontal, expected_type=type_hints["horizontal"])
            check_type(argname="argument horizontal_var", value=horizontal_var, expected_type=type_hints["horizontal_var"])
            check_type(argname="argument vertical", value=vertical, expected_type=type_hints["vertical"])
            check_type(argname="argument vertical_var", value=vertical_var, expected_type=type_hints["vertical_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if horizontal is not None:
            self._values["horizontal"] = horizontal
        if horizontal_var is not None:
            self._values["horizontal_var"] = horizontal_var
        if vertical is not None:
            self._values["vertical"] = vertical
        if vertical_var is not None:
            self._values["vertical_var"] = vertical_var

    @builtins.property
    def horizontal(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        '''
        result = self._values.get("horizontal")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def horizontal_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        '''
        result = self._values.get("horizontal_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        '''
        result = self._values.get("vertical")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        result = self._values.get("vertical_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsMirror(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsMirrorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsMirrorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c2633054903cafb87fd561e1026e7bb198a20d1effb71b344a82cb1d0458bfd5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsMirrorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c35846d08d4e9da5a9e04744624a64c4ebbcf7ec04b4ee7f34eecdd45beaa575)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsMirrorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__398fb3f9e5e3d4e5f726043e385f72be5bb9d70c8f25f3777554d721178a7281)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__094cc735a008c188677e72692d217449b229abcd3349eacc20b21f352a5baddd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a1c0570682975c055d12c6ca371aed99559e02a761fb88bb8045b713d43b7651)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsMirror]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsMirror]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e451fca464ca52d15f8d2d1849370e0990c0a8b508e19b66ac35c8136a218850)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsMirrorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsMirrorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__37dfaf12c60695d5b490a9a2e342b5c7d44ee3aba3a2d22980426306a316eb00)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHorizontal")
    def reset_horizontal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontal", []))

    @jsii.member(jsii_name="resetHorizontalVar")
    def reset_horizontal_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontalVar", []))

    @jsii.member(jsii_name="resetVertical")
    def reset_vertical(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVertical", []))

    @jsii.member(jsii_name="resetVerticalVar")
    def reset_vertical_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVerticalVar", []))

    @builtins.property
    @jsii.member(jsii_name="horizontalInput")
    def horizontal_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontalVarInput")
    def horizontal_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalInput")
    def vertical_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalVarInput")
    def vertical_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontal")
    def horizontal(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontal"))

    @horizontal.setter
    def horizontal(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d6b11b383f4b15f01324a4eaae37ded6b0ef10511d967fc12ec105f1383c5ae0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontal", value)

    @builtins.property
    @jsii.member(jsii_name="horizontalVar")
    def horizontal_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontalVar"))

    @horizontal_var.setter
    def horizontal_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a4d9d5646080dd8b38b5d33ecc1d8f500123340ffe826a8f01567559e688ed62)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontalVar", value)

    @builtins.property
    @jsii.member(jsii_name="vertical")
    def vertical(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "vertical"))

    @vertical.setter
    def vertical(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b1cdbc73432dfc3de92c4be46bc4ce5273707370ea841f6348da3aaa26dea0ce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "vertical", value)

    @builtins.property
    @jsii.member(jsii_name="verticalVar")
    def vertical_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "verticalVar"))

    @vertical_var.setter
    def vertical_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__68a3714b2985dc642eff211b3eb9d863d79e7ab6a2da1bcbcd06bb342d3e52af)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "verticalVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsMirror]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsMirror]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsMirror]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8ab476157b8843230d55006c34206ef13beeb3f544ec9297d836f49b1016ed78)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsMonoHue",
    jsii_struct_bases=[],
    name_mapping={"hue": "hue", "hue_var": "hueVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsMonoHue:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d0828224110a6674e2a3c0d9f72fca65b7bf9d1b0cc228d8739b0bea4b63f93a)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsMonoHue(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsMonoHueList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsMonoHueList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a2f032a55aa3f23c4438e8de158533b5974d95702bd0e8f09905a6947e934ef6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsMonoHueOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__041eb3eced7a2ac44fb37ffd850fa54ead71294f0ee56406e4626ebf8896c080)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsMonoHueOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0c9bbd78084636d06d75700648828bd133f0e0a8a90a1e81e11106d85f515865)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__54d5bc9d5f98ceb62890baede4edd61d60367474e99fb8fde84926291414e1f3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__470b1f28cbc5bed40dc5e8fe0b395bcf5829f00f1eb8616de187e65b7737f127)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsMonoHue]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsMonoHue]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__669f389c497a9af808df85d2fc025d6cc2707fe5eee8cb663292d02c65f7fecf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsMonoHueOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsMonoHueOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d8777bebe294404f13e431d354be255423b29cc4f98b8a8f3c875e6129454600)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d74b2992168b46b3c7d914f61355d0ee80fea7293294f3173a6c6e187581f8c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6bf7d651f57168ded3a622c5ff8be34a303e3e3e3dc27f2307d1a65ee65af074)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsMonoHue]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsMonoHue]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsMonoHue]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__73d85924c7be4a142ffd455030483e29d99c825b84437cee5b2777568fd6bc27)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsOpacity",
    jsii_struct_bases=[],
    name_mapping={"opacity": "opacity", "opacity_var": "opacityVar"},
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsOpacity:
    def __init__(
        self,
        *,
        opacity: typing.Optional[builtins.str] = None,
        opacity_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param opacity: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param opacity_var: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a85573015ffa2855ceb4469ee95eea8ed5064f37df8efdf9eb55977017fc99ca)
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument opacity_var", value=opacity_var, expected_type=type_hints["opacity_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if opacity is not None:
            self._values["opacity"] = opacity
        if opacity_var is not None:
            self._values["opacity_var"] = opacity_var

    @builtins.property
    def opacity(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def opacity_var(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        result = self._values.get("opacity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsOpacity(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsOpacityList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsOpacityList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f72de442955d414c9290793a0eedc39061fc73b74f54ee28926774296c0c4907)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsOpacityOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__88f412b5d7bfc801b2c0aef5a05c5b0190647585e79c15f48cf225ef6085a109)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsOpacityOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a54e6d5e535ce280eae00dc1ca8af481b036f2d13a10457813e99214f1c5ba27)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a5522a1a378a4ad5947fab8bb5a5a9ab8a74eb85f3a11a90af07a19395253f55)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eaefb3d6b349cd807cfff0b71fd79e82b92b0b48cce582c55502b7bd5fecd6bd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsOpacity]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsOpacity]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e12a383c172b83a72881248bad6d2f187c7df003fc19766ee409c212745501e9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsOpacityOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsOpacityOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f230b6979c4827724d598e543611fcd0fbcd007638708c4eddd6eeacb8e5cfa)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetOpacityVar")
    def reset_opacity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacityVar", []))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityVarInput")
    def opacity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacity"))

    @opacity.setter
    def opacity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9f29dea7e6c509b0e01d7ae0aaf548a9f5075b76da4f9e1ea2738bad39be0475)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacity", value)

    @builtins.property
    @jsii.member(jsii_name="opacityVar")
    def opacity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacityVar"))

    @opacity_var.setter
    def opacity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__02351a7369e2e43d22cbf0cd9ce316e0ed5cdfc5c107896c0e5e080ac99efa6b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacityVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsOpacity]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsOpacity]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsOpacity]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__14f233fa75d0edf0212656dcc667c35cefc4c7b8e6743dd2c903c9228a7e7012)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a8515c841eef63cceaf5d8f08d74195070470653a25b6db84f11d52c73dc3105)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putBackgroundColor")
    def put_background_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c03e1261006112ed996ac947b4bb2bd5cc9c4dacb73d114debf94ce70aed4810)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBackgroundColor", [value]))

    @jsii.member(jsii_name="putBlur")
    def put_blur(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsBlur, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5b08241e7abaacd6490b835afeabbf42e5b014a9b778003d428673f90a042ab0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBlur", [value]))

    @jsii.member(jsii_name="putChromaKey")
    def put_chroma_key(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsChromaKey, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8af72ebbadfa1b70e384a659fa132211d35c5381c9c4163c90dabc95722e267e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putChromaKey", [value]))

    @jsii.member(jsii_name="putComposite")
    def put_composite(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsComposite, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__16a1d1c9f40c8b747e13e0aea15ca79d509c066d1a2125d7daa4e07df2b302d1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putComposite", [value]))

    @jsii.member(jsii_name="putCompound")
    def put_compound(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompound, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__32c0ecce1b977536b62276b460ac4f15f6c6c58db9324b5eac318f947b9c5351)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCompound", [value]))

    @jsii.member(jsii_name="putContrast")
    def put_contrast(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsContrast, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a0858d5248d2abff619a727376d49eb5ccf37e45984efe20c748340ea4cd4716)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putContrast", [value]))

    @jsii.member(jsii_name="putGoop")
    def put_goop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsGoop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb33032acd67ace1d9c0d048e58ec9bb259e9c64fd685db882b7c44f7b66f280)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGoop", [value]))

    @jsii.member(jsii_name="putGrayscale")
    def put_grayscale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsGrayscale, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f965fcfbe7655578d8c116cab50b6a9a5b0d0f7871d96603f0ad6c088aac3397)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGrayscale", [value]))

    @jsii.member(jsii_name="putHsl")
    def put_hsl(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsHsl, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6ae40c9f2894e1df209915185249fc43c36f2a89c7620987c297c7146e95564a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsl", [value]))

    @jsii.member(jsii_name="putHsv")
    def put_hsv(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsHsv, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9056ffa593d30dc56c7fec477bb2acb642ec23540ee5f98b3328e6d10b19788a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsv", [value]))

    @jsii.member(jsii_name="putIfDimension")
    def put_if_dimension(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimension, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b23982c0e3b1a2932daf4cc03f9cbacadc625256fc994cc6bab22909737657f0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfDimension", [value]))

    @jsii.member(jsii_name="putIfOrientation")
    def put_if_orientation(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b58c99b5a108dfe878f54f9b8edd8d182c3939431a9b2069a4b7e44ffc51ccc8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfOrientation", [value]))

    @jsii.member(jsii_name="putMaxColors")
    def put_max_colors(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsMaxColors, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d2240aaf107108c09ff7e96ba40cd4ee37f785205ba2d0656e2f9933f6c8311c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMaxColors", [value]))

    @jsii.member(jsii_name="putMirror")
    def put_mirror(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsMirror, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__34933008d61b5ed1b1a02a129d0ce7f04b7e02c1e753d0999fc2c6b74bdd48a9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMirror", [value]))

    @jsii.member(jsii_name="putMonoHue")
    def put_mono_hue(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsMonoHue, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__143fe64218e4b22c2f4bf486171ede39c436b5fe9d9179f193edf3a8ca2c2691)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMonoHue", [value]))

    @jsii.member(jsii_name="putOpacity")
    def put_opacity(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsOpacity, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e95aa54b895e9f93143dca4f6452bd7cf658283fa466ab92303c53d8949342ea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putOpacity", [value]))

    @jsii.member(jsii_name="putRemoveColor")
    def put_remove_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsRemoveColor", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab78354fb3949446abd0030500fa4bc7532e919353d7990acb46e66b8675e5ec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRemoveColor", [value]))

    @jsii.member(jsii_name="putUnsharpMask")
    def put_unsharp_mask(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsUnsharpMask", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8017f23ee8b2f3b229217029928f1ddd7600eec4d69162302eab2e65612dace5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putUnsharpMask", [value]))

    @jsii.member(jsii_name="resetBackgroundColor")
    def reset_background_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBackgroundColor", []))

    @jsii.member(jsii_name="resetBlur")
    def reset_blur(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBlur", []))

    @jsii.member(jsii_name="resetChromaKey")
    def reset_chroma_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChromaKey", []))

    @jsii.member(jsii_name="resetComposite")
    def reset_composite(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetComposite", []))

    @jsii.member(jsii_name="resetCompound")
    def reset_compound(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCompound", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetGoop")
    def reset_goop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGoop", []))

    @jsii.member(jsii_name="resetGrayscale")
    def reset_grayscale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGrayscale", []))

    @jsii.member(jsii_name="resetHsl")
    def reset_hsl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsl", []))

    @jsii.member(jsii_name="resetHsv")
    def reset_hsv(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsv", []))

    @jsii.member(jsii_name="resetIfDimension")
    def reset_if_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfDimension", []))

    @jsii.member(jsii_name="resetIfOrientation")
    def reset_if_orientation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfOrientation", []))

    @jsii.member(jsii_name="resetMaxColors")
    def reset_max_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxColors", []))

    @jsii.member(jsii_name="resetMirror")
    def reset_mirror(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMirror", []))

    @jsii.member(jsii_name="resetMonoHue")
    def reset_mono_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonoHue", []))

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetRemoveColor")
    def reset_remove_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRemoveColor", []))

    @jsii.member(jsii_name="resetUnsharpMask")
    def reset_unsharp_mask(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUnsharpMask", []))

    @builtins.property
    @jsii.member(jsii_name="backgroundColor")
    def background_color(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsBackgroundColorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsBackgroundColorList, jsii.get(self, "backgroundColor"))

    @builtins.property
    @jsii.member(jsii_name="blur")
    def blur(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsBlurList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsBlurList, jsii.get(self, "blur"))

    @builtins.property
    @jsii.member(jsii_name="chromaKey")
    def chroma_key(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsChromaKeyList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsChromaKeyList, jsii.get(self, "chromaKey"))

    @builtins.property
    @jsii.member(jsii_name="composite")
    def composite(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeList, jsii.get(self, "composite"))

    @builtins.property
    @jsii.member(jsii_name="compound")
    def compound(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundList, jsii.get(self, "compound"))

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsContrastList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsContrastList, jsii.get(self, "contrast"))

    @builtins.property
    @jsii.member(jsii_name="goop")
    def goop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsGoopList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsGoopList, jsii.get(self, "goop"))

    @builtins.property
    @jsii.member(jsii_name="grayscale")
    def grayscale(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsGrayscaleList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsGrayscaleList, jsii.get(self, "grayscale"))

    @builtins.property
    @jsii.member(jsii_name="hsl")
    def hsl(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsHslList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsHslList, jsii.get(self, "hsl"))

    @builtins.property
    @jsii.member(jsii_name="hsv")
    def hsv(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsHsvList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsHsvList, jsii.get(self, "hsv"))

    @builtins.property
    @jsii.member(jsii_name="ifDimension")
    def if_dimension(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionList, jsii.get(self, "ifDimension"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientation")
    def if_orientation(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationList, jsii.get(self, "ifOrientation"))

    @builtins.property
    @jsii.member(jsii_name="maxColors")
    def max_colors(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsMaxColorsList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsMaxColorsList, jsii.get(self, "maxColors"))

    @builtins.property
    @jsii.member(jsii_name="mirror")
    def mirror(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsMirrorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsMirrorList, jsii.get(self, "mirror"))

    @builtins.property
    @jsii.member(jsii_name="monoHue")
    def mono_hue(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsMonoHueList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsMonoHueList, jsii.get(self, "monoHue"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsOpacityList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsOpacityList, jsii.get(self, "opacity"))

    @builtins.property
    @jsii.member(jsii_name="removeColor")
    def remove_color(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsRemoveColorList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsRemoveColorList", jsii.get(self, "removeColor"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMask")
    def unsharp_mask(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsUnsharpMaskList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsUnsharpMaskList", jsii.get(self, "unsharpMask"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColorInput")
    def background_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsBackgroundColor]]], jsii.get(self, "backgroundColorInput"))

    @builtins.property
    @jsii.member(jsii_name="blurInput")
    def blur_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsBlur]]], jsii.get(self, "blurInput"))

    @builtins.property
    @jsii.member(jsii_name="chromaKeyInput")
    def chroma_key_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsChromaKey]]], jsii.get(self, "chromaKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="compositeInput")
    def composite_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsComposite]]], jsii.get(self, "compositeInput"))

    @builtins.property
    @jsii.member(jsii_name="compoundInput")
    def compound_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompound]]], jsii.get(self, "compoundInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsContrast]]], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="goopInput")
    def goop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsGoop]]], jsii.get(self, "goopInput"))

    @builtins.property
    @jsii.member(jsii_name="grayscaleInput")
    def grayscale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsGrayscale]]], jsii.get(self, "grayscaleInput"))

    @builtins.property
    @jsii.member(jsii_name="hslInput")
    def hsl_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsHsl]]], jsii.get(self, "hslInput"))

    @builtins.property
    @jsii.member(jsii_name="hsvInput")
    def hsv_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsHsv]]], jsii.get(self, "hsvInput"))

    @builtins.property
    @jsii.member(jsii_name="ifDimensionInput")
    def if_dimension_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimension]]], jsii.get(self, "ifDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientationInput")
    def if_orientation_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientation]]], jsii.get(self, "ifOrientationInput"))

    @builtins.property
    @jsii.member(jsii_name="maxColorsInput")
    def max_colors_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsMaxColors]]], jsii.get(self, "maxColorsInput"))

    @builtins.property
    @jsii.member(jsii_name="mirrorInput")
    def mirror_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsMirror]]], jsii.get(self, "mirrorInput"))

    @builtins.property
    @jsii.member(jsii_name="monoHueInput")
    def mono_hue_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsMonoHue]]], jsii.get(self, "monoHueInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsOpacity]]], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="removeColorInput")
    def remove_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsRemoveColor"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsRemoveColor"]]], jsii.get(self, "removeColorInput"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMaskInput")
    def unsharp_mask_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsUnsharpMask"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsUnsharpMask"]]], jsii.get(self, "unsharpMaskInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformations]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformations]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformations]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8e9b6c2e845d7166dc0df296dfde6ac191050c441fbce9e351275b42649af00a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsRemoveColor",
    jsii_struct_bases=[],
    name_mapping={
        "color": "color",
        "color_var": "colorVar",
        "feather": "feather",
        "feather_var": "featherVar",
        "tolerance": "tolerance",
        "tolerance_var": "toleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsRemoveColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
        feather: typing.Optional[builtins.str] = None,
        feather_var: typing.Optional[builtins.str] = None,
        tolerance: typing.Optional[builtins.str] = None,
        tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        :param feather: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        :param feather_var: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        :param tolerance: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        :param tolerance_var: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4bff67005b729f3a22730ad37aeedd57a6fb6388d055faae1b62cb56edccd804)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
            check_type(argname="argument feather", value=feather, expected_type=type_hints["feather"])
            check_type(argname="argument feather_var", value=feather_var, expected_type=type_hints["feather_var"])
            check_type(argname="argument tolerance", value=tolerance, expected_type=type_hints["tolerance"])
            check_type(argname="argument tolerance_var", value=tolerance_var, expected_type=type_hints["tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var
        if feather is not None:
            self._values["feather"] = feather
        if feather_var is not None:
            self._values["feather_var"] = feather_var
        if tolerance is not None:
            self._values["tolerance"] = tolerance
        if tolerance_var is not None:
            self._values["tolerance_var"] = tolerance_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        '''
        result = self._values.get("feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather_var(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        '''
        result = self._values.get("feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        '''
        result = self._values.get("tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance_var(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        result = self._values.get("tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsRemoveColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsRemoveColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsRemoveColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__12ded0dcfdec623db6221f9372a4b4f7e961a9d670b48a9db119436bbd7ed7a6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsRemoveColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3e06536ed8cb3341beeb7cda743d7287193acff3c7cb29b129ca1b10d479230a)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsRemoveColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__73fe544963815a7d39e6e67d12707179be132ef3bb7fb4b48c2c3798d3b799ab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__25315419c90ce9403fde9f7b2ecb4725cbda84ca38375ad023ff2767a1cdddcd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dec3f7869add0969700e6dadf7d747525608acb89f9d28a40374ed9563fc6e1e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsRemoveColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsRemoveColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsRemoveColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__238a5bf1e4fd7d7d20044bffca7b3e033028513d78fed4ff07873e949a59ec31)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsRemoveColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsRemoveColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__811067e5eb108ca1e49aa8d4afb2e77cf31ce8565a82b778a40452059f1580a4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @jsii.member(jsii_name="resetFeather")
    def reset_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeather", []))

    @jsii.member(jsii_name="resetFeatherVar")
    def reset_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatherVar", []))

    @jsii.member(jsii_name="resetTolerance")
    def reset_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTolerance", []))

    @jsii.member(jsii_name="resetToleranceVar")
    def reset_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featherInput")
    def feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherInput"))

    @builtins.property
    @jsii.member(jsii_name="featherVarInput")
    def feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceInput")
    def tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceVarInput")
    def tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__723bd23a5825dda3aa4dc24f623003bf2e2e4cf0fd7aaef81421f3bbc6459558)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__109a45045e53923d31b03a2934c8730dc71a1bbb26843aa955c546a424d7e8c3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="feather")
    def feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "feather"))

    @feather.setter
    def feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bec7ceeee75cdbd4023bb5066fc2d258772b5781ae972ca40eac59ec5a467ee2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "feather", value)

    @builtins.property
    @jsii.member(jsii_name="featherVar")
    def feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featherVar"))

    @feather_var.setter
    def feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e8c3e0a43adbd7ca70053d4ab497da41baffbda61b34ace72afabfb2656f530b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featherVar", value)

    @builtins.property
    @jsii.member(jsii_name="tolerance")
    def tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tolerance"))

    @tolerance.setter
    def tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0dfb9ce5753b484b62c1e17a012f0622b1ad1342dc028fe20c88c8c0de0d57bd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tolerance", value)

    @builtins.property
    @jsii.member(jsii_name="toleranceVar")
    def tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "toleranceVar"))

    @tolerance_var.setter
    def tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b5084b361fd04475604e211c965a29867d5841c1c7f7307b657b6eebf2b6132b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "toleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsRemoveColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsRemoveColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsRemoveColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__62e3df16b9438a8b53fad7af784e531517c5eb81e112a5479c20b531f8dde0de)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsUnsharpMask",
    jsii_struct_bases=[],
    name_mapping={
        "gain": "gain",
        "gain_var": "gainVar",
        "sigma": "sigma",
        "sigma_var": "sigmaVar",
        "threshold": "threshold",
        "threshold_var": "thresholdVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsUnsharpMask:
    def __init__(
        self,
        *,
        gain: typing.Optional[builtins.str] = None,
        gain_var: typing.Optional[builtins.str] = None,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
        threshold: typing.Optional[builtins.str] = None,
        threshold_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param gain: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        :param gain_var: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        :param sigma: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        :param threshold: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        :param threshold_var: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7c6180b03c60091419e550b12a55a79f822f1371a1ebe07d3a5052037e56d1aa)
            check_type(argname="argument gain", value=gain, expected_type=type_hints["gain"])
            check_type(argname="argument gain_var", value=gain_var, expected_type=type_hints["gain_var"])
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
            check_type(argname="argument threshold", value=threshold, expected_type=type_hints["threshold"])
            check_type(argname="argument threshold_var", value=threshold_var, expected_type=type_hints["threshold_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if gain is not None:
            self._values["gain"] = gain
        if gain_var is not None:
            self._values["gain_var"] = gain_var
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var
        if threshold is not None:
            self._values["threshold"] = threshold
        if threshold_var is not None:
            self._values["threshold_var"] = threshold_var

    @builtins.property
    def gain(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        '''
        result = self._values.get("gain")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gain_var(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        '''
        result = self._values.get("gain_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        '''
        result = self._values.get("threshold")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold_var(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        result = self._values.get("threshold_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsUnsharpMask(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsUnsharpMaskList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsUnsharpMaskList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9fa8f68c450ce1e03d9016b6b5632bdd94b63daa62b9d7359bf28f1f451bf666)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsUnsharpMaskOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a2d2eb6393b8eb8720876310f3cf0a1e20fb3678e5158308dba4a12ba41d8b0b)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsUnsharpMaskOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3062cd772b2b9182bfe7f12dd42cf72925cb4ba8f3132d7c4bdc19f64b18b0be)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a43111372ff1b0ee57bcafaf91cc5995791a4833322b35d84de06c2e711e3d21)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3e6c010659efd09da12ddca10aec4ee75b92125386c8fe2e428f1810f69ac520)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsUnsharpMask]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsUnsharpMask]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsUnsharpMask]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__75288cc35e2a3db7934abc623e7298a9fcfc4672c9b15fd2b1d7c188363e0d75)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsUnsharpMaskOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsUnsharpMaskOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e0d8e79feee9f87a40ac8e0991778a4915101ce7fdb1b10c9c8b554d276251b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetGain")
    def reset_gain(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGain", []))

    @jsii.member(jsii_name="resetGainVar")
    def reset_gain_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGainVar", []))

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @jsii.member(jsii_name="resetThreshold")
    def reset_threshold(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThreshold", []))

    @jsii.member(jsii_name="resetThresholdVar")
    def reset_threshold_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThresholdVar", []))

    @builtins.property
    @jsii.member(jsii_name="gainInput")
    def gain_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainInput"))

    @builtins.property
    @jsii.member(jsii_name="gainVarInput")
    def gain_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdInput")
    def threshold_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdVarInput")
    def threshold_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gain")
    def gain(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gain"))

    @gain.setter
    def gain(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ef2f575c5889fea0e14d32850807986b3b74d189b7231fbc75bf66c74a308c22)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gain", value)

    @builtins.property
    @jsii.member(jsii_name="gainVar")
    def gain_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gainVar"))

    @gain_var.setter
    def gain_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__05eeae90d9a7b2018e18bdd825a03963c24a5f671af9d42e213d2b6c5f8b1cfe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gainVar", value)

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6c815c7908b085084b0dd457a0e4d0f207073bb887c13362a010e67c67a4267f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3eba1837dc39795ac8590c86c86e93da9f34597c2e058644e1c1ec3019c2fab8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="threshold")
    def threshold(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "threshold"))

    @threshold.setter
    def threshold(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a07daff33eac9baeb916542bbb0f44859022480c12d455ef8f2e833663645df1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "threshold", value)

    @builtins.property
    @jsii.member(jsii_name="thresholdVar")
    def threshold_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "thresholdVar"))

    @threshold_var.setter
    def threshold_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e3458021990ce3e86c5f744a0f0af68796d515eeee5041b42d916fbc11793306)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "thresholdVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsUnsharpMask]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsUnsharpMask]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsUnsharpMask]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a7e143e30458c5293d54c94663b3bc865df8210fc5b39b8fe8b2906f2dcdb72b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformations",
    jsii_struct_bases=[],
    name_mapping={
        "append": "append",
        "aspect_crop": "aspectCrop",
        "background_color": "backgroundColor",
        "blur": "blur",
        "chroma_key": "chromaKey",
        "composite": "composite",
        "compound": "compound",
        "contrast": "contrast",
        "crop": "crop",
        "face_crop": "faceCrop",
        "feature_crop": "featureCrop",
        "fit_and_fill": "fitAndFill",
        "goop": "goop",
        "grayscale": "grayscale",
        "hsl": "hsl",
        "hsv": "hsv",
        "if_dimension": "ifDimension",
        "if_orientation": "ifOrientation",
        "im_query": "imQuery",
        "max_colors": "maxColors",
        "mirror": "mirror",
        "mono_hue": "monoHue",
        "opacity": "opacity",
        "region_of_interest_crop": "regionOfInterestCrop",
        "relative_crop": "relativeCrop",
        "remove_color": "removeColor",
        "resize": "resize",
        "rotate": "rotate",
        "scale": "scale",
        "shear": "shear",
        "trim": "trim",
        "unsharp_mask": "unsharpMask",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformations:
    def __init__(
        self,
        *,
        append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppend", typing.Dict[builtins.str, typing.Any]]]]] = None,
        aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAspectCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsBackgroundColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsBlur", typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsChromaKey", typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsComposite", typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompound", typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsContrast", typing.Dict[builtins.str, typing.Any]]]]] = None,
        crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFaceCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFeatureCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFill", typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsGoop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsGrayscale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsHsl", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsHsv", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimension", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientation", typing.Dict[builtins.str, typing.Any]]]]] = None,
        im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsImQuery", typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsMaxColors", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsMirror", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsMonoHue", typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsOpacity", typing.Dict[builtins.str, typing.Any]]]]] = None,
        region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsRelativeCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsRemoveColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsResize", typing.Dict[builtins.str, typing.Any]]]]] = None,
        rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsRotate", typing.Dict[builtins.str, typing.Any]]]]] = None,
        scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsScale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsShear", typing.Dict[builtins.str, typing.Any]]]]] = None,
        trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsTrim", typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsUnsharpMask", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param append: append block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        :param aspect_crop: aspect_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param crop: crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        :param face_crop: face_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        :param feature_crop: feature_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        :param fit_and_fill: fit_and_fill block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param im_query: im_query block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param region_of_interest_crop: region_of_interest_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        :param relative_crop: relative_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param resize: resize block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        :param rotate: rotate block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        :param scale: scale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param shear: shear block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        :param trim: trim block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bf59c345deb8d31de42602dd30951216f6deadef172dd6e278906c52e9728ae9)
            check_type(argname="argument append", value=append, expected_type=type_hints["append"])
            check_type(argname="argument aspect_crop", value=aspect_crop, expected_type=type_hints["aspect_crop"])
            check_type(argname="argument background_color", value=background_color, expected_type=type_hints["background_color"])
            check_type(argname="argument blur", value=blur, expected_type=type_hints["blur"])
            check_type(argname="argument chroma_key", value=chroma_key, expected_type=type_hints["chroma_key"])
            check_type(argname="argument composite", value=composite, expected_type=type_hints["composite"])
            check_type(argname="argument compound", value=compound, expected_type=type_hints["compound"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument crop", value=crop, expected_type=type_hints["crop"])
            check_type(argname="argument face_crop", value=face_crop, expected_type=type_hints["face_crop"])
            check_type(argname="argument feature_crop", value=feature_crop, expected_type=type_hints["feature_crop"])
            check_type(argname="argument fit_and_fill", value=fit_and_fill, expected_type=type_hints["fit_and_fill"])
            check_type(argname="argument goop", value=goop, expected_type=type_hints["goop"])
            check_type(argname="argument grayscale", value=grayscale, expected_type=type_hints["grayscale"])
            check_type(argname="argument hsl", value=hsl, expected_type=type_hints["hsl"])
            check_type(argname="argument hsv", value=hsv, expected_type=type_hints["hsv"])
            check_type(argname="argument if_dimension", value=if_dimension, expected_type=type_hints["if_dimension"])
            check_type(argname="argument if_orientation", value=if_orientation, expected_type=type_hints["if_orientation"])
            check_type(argname="argument im_query", value=im_query, expected_type=type_hints["im_query"])
            check_type(argname="argument max_colors", value=max_colors, expected_type=type_hints["max_colors"])
            check_type(argname="argument mirror", value=mirror, expected_type=type_hints["mirror"])
            check_type(argname="argument mono_hue", value=mono_hue, expected_type=type_hints["mono_hue"])
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument region_of_interest_crop", value=region_of_interest_crop, expected_type=type_hints["region_of_interest_crop"])
            check_type(argname="argument relative_crop", value=relative_crop, expected_type=type_hints["relative_crop"])
            check_type(argname="argument remove_color", value=remove_color, expected_type=type_hints["remove_color"])
            check_type(argname="argument resize", value=resize, expected_type=type_hints["resize"])
            check_type(argname="argument rotate", value=rotate, expected_type=type_hints["rotate"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument shear", value=shear, expected_type=type_hints["shear"])
            check_type(argname="argument trim", value=trim, expected_type=type_hints["trim"])
            check_type(argname="argument unsharp_mask", value=unsharp_mask, expected_type=type_hints["unsharp_mask"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if append is not None:
            self._values["append"] = append
        if aspect_crop is not None:
            self._values["aspect_crop"] = aspect_crop
        if background_color is not None:
            self._values["background_color"] = background_color
        if blur is not None:
            self._values["blur"] = blur
        if chroma_key is not None:
            self._values["chroma_key"] = chroma_key
        if composite is not None:
            self._values["composite"] = composite
        if compound is not None:
            self._values["compound"] = compound
        if contrast is not None:
            self._values["contrast"] = contrast
        if crop is not None:
            self._values["crop"] = crop
        if face_crop is not None:
            self._values["face_crop"] = face_crop
        if feature_crop is not None:
            self._values["feature_crop"] = feature_crop
        if fit_and_fill is not None:
            self._values["fit_and_fill"] = fit_and_fill
        if goop is not None:
            self._values["goop"] = goop
        if grayscale is not None:
            self._values["grayscale"] = grayscale
        if hsl is not None:
            self._values["hsl"] = hsl
        if hsv is not None:
            self._values["hsv"] = hsv
        if if_dimension is not None:
            self._values["if_dimension"] = if_dimension
        if if_orientation is not None:
            self._values["if_orientation"] = if_orientation
        if im_query is not None:
            self._values["im_query"] = im_query
        if max_colors is not None:
            self._values["max_colors"] = max_colors
        if mirror is not None:
            self._values["mirror"] = mirror
        if mono_hue is not None:
            self._values["mono_hue"] = mono_hue
        if opacity is not None:
            self._values["opacity"] = opacity
        if region_of_interest_crop is not None:
            self._values["region_of_interest_crop"] = region_of_interest_crop
        if relative_crop is not None:
            self._values["relative_crop"] = relative_crop
        if remove_color is not None:
            self._values["remove_color"] = remove_color
        if resize is not None:
            self._values["resize"] = resize
        if rotate is not None:
            self._values["rotate"] = rotate
        if scale is not None:
            self._values["scale"] = scale
        if shear is not None:
            self._values["shear"] = shear
        if trim is not None:
            self._values["trim"] = trim
        if unsharp_mask is not None:
            self._values["unsharp_mask"] = unsharp_mask

    @builtins.property
    def append(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppend"]]]:
        '''append block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        '''
        result = self._values.get("append")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppend"]]], result)

    @builtins.property
    def aspect_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAspectCrop"]]]:
        '''aspect_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        '''
        result = self._values.get("aspect_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAspectCrop"]]], result)

    @builtins.property
    def background_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsBackgroundColor"]]]:
        '''background_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        '''
        result = self._values.get("background_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsBackgroundColor"]]], result)

    @builtins.property
    def blur(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsBlur"]]]:
        '''blur block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        '''
        result = self._values.get("blur")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsBlur"]]], result)

    @builtins.property
    def chroma_key(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsChromaKey"]]]:
        '''chroma_key block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        '''
        result = self._values.get("chroma_key")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsChromaKey"]]], result)

    @builtins.property
    def composite(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsComposite"]]]:
        '''composite block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        '''
        result = self._values.get("composite")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsComposite"]]], result)

    @builtins.property
    def compound(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompound"]]]:
        '''compound block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        '''
        result = self._values.get("compound")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompound"]]], result)

    @builtins.property
    def contrast(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsContrast"]]]:
        '''contrast block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsContrast"]]], result)

    @builtins.property
    def crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCrop"]]]:
        '''crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        '''
        result = self._values.get("crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCrop"]]], result)

    @builtins.property
    def face_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFaceCrop"]]]:
        '''face_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        '''
        result = self._values.get("face_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFaceCrop"]]], result)

    @builtins.property
    def feature_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFeatureCrop"]]]:
        '''feature_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        '''
        result = self._values.get("feature_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFeatureCrop"]]], result)

    @builtins.property
    def fit_and_fill(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFill"]]]:
        '''fit_and_fill block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        '''
        result = self._values.get("fit_and_fill")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFill"]]], result)

    @builtins.property
    def goop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsGoop"]]]:
        '''goop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        '''
        result = self._values.get("goop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsGoop"]]], result)

    @builtins.property
    def grayscale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsGrayscale"]]]:
        '''grayscale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        '''
        result = self._values.get("grayscale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsGrayscale"]]], result)

    @builtins.property
    def hsl(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsHsl"]]]:
        '''hsl block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        '''
        result = self._values.get("hsl")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsHsl"]]], result)

    @builtins.property
    def hsv(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsHsv"]]]:
        '''hsv block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        '''
        result = self._values.get("hsv")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsHsv"]]], result)

    @builtins.property
    def if_dimension(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimension"]]]:
        '''if_dimension block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        '''
        result = self._values.get("if_dimension")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimension"]]], result)

    @builtins.property
    def if_orientation(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientation"]]]:
        '''if_orientation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        '''
        result = self._values.get("if_orientation")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientation"]]], result)

    @builtins.property
    def im_query(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsImQuery"]]]:
        '''im_query block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        '''
        result = self._values.get("im_query")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsImQuery"]]], result)

    @builtins.property
    def max_colors(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsMaxColors"]]]:
        '''max_colors block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        '''
        result = self._values.get("max_colors")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsMaxColors"]]], result)

    @builtins.property
    def mirror(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsMirror"]]]:
        '''mirror block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        '''
        result = self._values.get("mirror")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsMirror"]]], result)

    @builtins.property
    def mono_hue(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsMonoHue"]]]:
        '''mono_hue block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        '''
        result = self._values.get("mono_hue")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsMonoHue"]]], result)

    @builtins.property
    def opacity(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsOpacity"]]]:
        '''opacity block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsOpacity"]]], result)

    @builtins.property
    def region_of_interest_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCrop"]]]:
        '''region_of_interest_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        '''
        result = self._values.get("region_of_interest_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCrop"]]], result)

    @builtins.property
    def relative_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsRelativeCrop"]]]:
        '''relative_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        '''
        result = self._values.get("relative_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsRelativeCrop"]]], result)

    @builtins.property
    def remove_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsRemoveColor"]]]:
        '''remove_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        '''
        result = self._values.get("remove_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsRemoveColor"]]], result)

    @builtins.property
    def resize(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsResize"]]]:
        '''resize block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        '''
        result = self._values.get("resize")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsResize"]]], result)

    @builtins.property
    def rotate(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsRotate"]]]:
        '''rotate block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        '''
        result = self._values.get("rotate")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsRotate"]]], result)

    @builtins.property
    def scale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsScale"]]]:
        '''scale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsScale"]]], result)

    @builtins.property
    def shear(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsShear"]]]:
        '''shear block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        '''
        result = self._values.get("shear")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsShear"]]], result)

    @builtins.property
    def trim(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsTrim"]]]:
        '''trim block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        '''
        result = self._values.get("trim")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsTrim"]]], result)

    @builtins.property
    def unsharp_mask(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsUnsharpMask"]]]:
        '''unsharp_mask block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        result = self._values.get("unsharp_mask")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsUnsharpMask"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformations(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppend",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_priority": "gravityPriority",
        "gravity_priority_var": "gravityPriorityVar",
        "gravity_var": "gravityVar",
        "preserve_minor_dimension": "preserveMinorDimension",
        "preserve_minor_dimension_var": "preserveMinorDimensionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppend:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_priority: typing.Optional[builtins.str] = None,
        gravity_priority_var: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        preserve_minor_dimension: typing.Optional[builtins.str] = None,
        preserve_minor_dimension_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Specifies where to place the ``image`` relative to the source image. The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_priority: Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal. The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority DataAkamaiImagingPolicyImage#gravity_priority}
        :param gravity_priority_var: Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal. The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority_var DataAkamaiImagingPolicyImage#gravity_priority_var}
        :param gravity_var: Specifies where to place the ``image`` relative to the source image. The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param preserve_minor_dimension: Whether to preserve the source image's minor dimension, ``false`` by default. The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension DataAkamaiImagingPolicyImage#preserve_minor_dimension}
        :param preserve_minor_dimension_var: Whether to preserve the source image's minor dimension, ``false`` by default. The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension_var DataAkamaiImagingPolicyImage#preserve_minor_dimension_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyTransformationsAppendImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__40469326e5e44412f7c9820ab1609667892430fa832f30ded55adbf5ea33fb51)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_priority", value=gravity_priority, expected_type=type_hints["gravity_priority"])
            check_type(argname="argument gravity_priority_var", value=gravity_priority_var, expected_type=type_hints["gravity_priority_var"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument preserve_minor_dimension", value=preserve_minor_dimension, expected_type=type_hints["preserve_minor_dimension"])
            check_type(argname="argument preserve_minor_dimension_var", value=preserve_minor_dimension_var, expected_type=type_hints["preserve_minor_dimension_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_priority is not None:
            self._values["gravity_priority"] = gravity_priority
        if gravity_priority_var is not None:
            self._values["gravity_priority_var"] = gravity_priority_var
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if preserve_minor_dimension is not None:
            self._values["preserve_minor_dimension"] = preserve_minor_dimension
        if preserve_minor_dimension_var is not None:
            self._values["preserve_minor_dimension_var"] = preserve_minor_dimension_var

    @builtins.property
    def image(self) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Specifies where to place the ``image`` relative to the source image.

        The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_priority(self) -> typing.Optional[builtins.str]:
        '''Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal.

        The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority DataAkamaiImagingPolicyImage#gravity_priority}
        '''
        result = self._values.get("gravity_priority")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_priority_var(self) -> typing.Optional[builtins.str]:
        '''Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal.

        The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority_var DataAkamaiImagingPolicyImage#gravity_priority_var}
        '''
        result = self._values.get("gravity_priority_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Specifies where to place the ``image`` relative to the source image.

        The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def preserve_minor_dimension(self) -> typing.Optional[builtins.str]:
        '''Whether to preserve the source image's minor dimension, ``false`` by default.

        The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension DataAkamaiImagingPolicyImage#preserve_minor_dimension}
        '''
        result = self._values.get("preserve_minor_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def preserve_minor_dimension_var(self) -> typing.Optional[builtins.str]:
        '''Whether to preserve the source image's minor dimension, ``false`` by default.

        The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension_var DataAkamaiImagingPolicyImage#preserve_minor_dimension_var}
        '''
        result = self._values.get("preserve_minor_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppend(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImage",
    jsii_struct_bases=[],
    name_mapping={
        "box_image": "boxImage",
        "circle_image": "circleImage",
        "text_image": "textImage",
        "url_image": "urlImage",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImage:
    def __init__(
        self,
        *,
        box_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImage", typing.Dict[builtins.str, typing.Any]]]]] = None,
        circle_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImage", typing.Dict[builtins.str, typing.Any]]]]] = None,
        text_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImage", typing.Dict[builtins.str, typing.Any]]]]] = None,
        url_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImage", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param box_image: box_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#box_image DataAkamaiImagingPolicyImage#box_image}
        :param circle_image: circle_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#circle_image DataAkamaiImagingPolicyImage#circle_image}
        :param text_image: text_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text_image DataAkamaiImagingPolicyImage#text_image}
        :param url_image: url_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url_image DataAkamaiImagingPolicyImage#url_image}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__57c9eb235a16d83dd88a116303eb48f7abfa7a01c6c1d985a1d65c93d4658b82)
            check_type(argname="argument box_image", value=box_image, expected_type=type_hints["box_image"])
            check_type(argname="argument circle_image", value=circle_image, expected_type=type_hints["circle_image"])
            check_type(argname="argument text_image", value=text_image, expected_type=type_hints["text_image"])
            check_type(argname="argument url_image", value=url_image, expected_type=type_hints["url_image"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if box_image is not None:
            self._values["box_image"] = box_image
        if circle_image is not None:
            self._values["circle_image"] = circle_image
        if text_image is not None:
            self._values["text_image"] = text_image
        if url_image is not None:
            self._values["url_image"] = url_image

    @builtins.property
    def box_image(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImage"]]]:
        '''box_image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#box_image DataAkamaiImagingPolicyImage#box_image}
        '''
        result = self._values.get("box_image")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImage"]]], result)

    @builtins.property
    def circle_image(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImage"]]]:
        '''circle_image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#circle_image DataAkamaiImagingPolicyImage#circle_image}
        '''
        result = self._values.get("circle_image")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImage"]]], result)

    @builtins.property
    def text_image(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImage"]]]:
        '''text_image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text_image DataAkamaiImagingPolicyImage#text_image}
        '''
        result = self._values.get("text_image")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImage"]]], result)

    @builtins.property
    def url_image(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImage"]]]:
        '''url_image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url_image DataAkamaiImagingPolicyImage#url_image}
        '''
        result = self._values.get("url_image")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImage"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImage",
    jsii_struct_bases=[],
    name_mapping={
        "color": "color",
        "color_var": "colorVar",
        "height": "height",
        "height_var": "heightVar",
        "transformation": "transformation",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImage:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        transformation: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The fill color of the box, not the edge of the box. The API supports hexadecimal representation and CSS hexadecimal color values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The fill color of the box, not the edge of the box. The API supports hexadecimal representation and CSS hexadecimal color values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        :param height: The height of the box in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height of the box in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param transformation: transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        :param width: The width of the box in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width of the box in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(transformation, dict):
            transformation = DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformation(**transformation)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__087f80c5a9b4960d5321776af549f56d2b6fc2975d6d88187e34fb9a3f51d1ed)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument transformation", value=transformation, expected_type=type_hints["transformation"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if transformation is not None:
            self._values["transformation"] = transformation
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The fill color of the box, not the edge of the box.

        The API supports hexadecimal representation and CSS hexadecimal color values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The fill color of the box, not the edge of the box.

        The API supports hexadecimal representation and CSS hexadecimal color values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height of the box in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height of the box in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def transformation(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformation"]:
        '''transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        '''
        result = self._values.get("transformation")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformation"], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width of the box in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width of the box in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__21c5b73d6f98c725b950dc7de5ebbabe48b66f2fd9e3edc44bd8571a30cbb6c9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fe9c9ee4e0dcfa6f28e1971c4dbcc52bce21afea3d5040e3ed300c5308eea435)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4b9dc9e6114c0f8467bf9192cc3be2ec26e181bf68bfab93a16b8b9b4c012fce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea5255a8a234a0a2e5f0485979459aaa31a7bc5124c4a6828464f6553e5ab5d1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f4d49b75cb96c02ec27043143d03019812b436533a86b255127b2a910f150fa2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImage]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImage]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImage]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__715f80429e463651f482693bcace06ad8f0b05719fd57c0cdbe85e5a8589b975)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e80a1697b41fe4d768a7d48ba3dd4f743b136b051ab65c9a51b6e9c70b322a6b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformation")
    def put_transformation(
        self,
        *,
        append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationAppend", typing.Dict[builtins.str, typing.Any]]]]] = None,
        aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationAspectCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationBackgroundColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationBlur", typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationChromaKey", typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationComposite", typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationCompound", typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationContrast", typing.Dict[builtins.str, typing.Any]]]]] = None,
        crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationFaceCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationFeatureCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationFitAndFill", typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationGoop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationGrayscale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationHsl", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationHsv", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfDimension", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfOrientation", typing.Dict[builtins.str, typing.Any]]]]] = None,
        im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationImQuery", typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationMaxColors", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationMirror", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationMonoHue", typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationOpacity", typing.Dict[builtins.str, typing.Any]]]]] = None,
        region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationRegionOfInterestCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationRelativeCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationRemoveColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationResize", typing.Dict[builtins.str, typing.Any]]]]] = None,
        rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationRotate", typing.Dict[builtins.str, typing.Any]]]]] = None,
        scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationScale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationShear", typing.Dict[builtins.str, typing.Any]]]]] = None,
        trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationTrim", typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationUnsharpMask", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param append: append block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        :param aspect_crop: aspect_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param crop: crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        :param face_crop: face_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        :param feature_crop: feature_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        :param fit_and_fill: fit_and_fill block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param im_query: im_query block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param region_of_interest_crop: region_of_interest_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        :param relative_crop: relative_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param resize: resize block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        :param rotate: rotate block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        :param scale: scale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param shear: shear block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        :param trim: trim block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        value = DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformation(
            append=append,
            aspect_crop=aspect_crop,
            background_color=background_color,
            blur=blur,
            chroma_key=chroma_key,
            composite=composite,
            compound=compound,
            contrast=contrast,
            crop=crop,
            face_crop=face_crop,
            feature_crop=feature_crop,
            fit_and_fill=fit_and_fill,
            goop=goop,
            grayscale=grayscale,
            hsl=hsl,
            hsv=hsv,
            if_dimension=if_dimension,
            if_orientation=if_orientation,
            im_query=im_query,
            max_colors=max_colors,
            mirror=mirror,
            mono_hue=mono_hue,
            opacity=opacity,
            region_of_interest_crop=region_of_interest_crop,
            relative_crop=relative_crop,
            remove_color=remove_color,
            resize=resize,
            rotate=rotate,
            scale=scale,
            shear=shear,
            trim=trim,
            unsharp_mask=unsharp_mask,
        )

        return typing.cast(None, jsii.invoke(self, "putTransformation", [value]))

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetTransformation")
    def reset_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformation", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="transformation")
    def transformation(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationOutputReference", jsii.get(self, "transformation"))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="transformationInput")
    def transformation_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformation"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformation"], jsii.get(self, "transformationInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d7ef12a7b78065fdbe8bd91587404749864e0ab99c87e0705fd51e6fe0335b2d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d6aca3c65e27d6ba5f387e513568b1c9bbc370e870ef70d2cd047a771e469242)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a8f3c0a5a676c4e60a9e980c2e46e88d488252a20335a3ba8af6b28934faeccb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1deffa5ed6e7c25479e3e126721fb0decfb5b41f8140667e79b7d8331ef31e84)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__50eb699f908912a987072239a81c0613c2a747e828b8d6887a161df3a8c4ed2a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e3c07a26949956d8edadebf01822ef64021ec78e2e0b55e5466c1416fe4983df)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImage]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImage]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImage]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4d43785bab6d8e3e7c3157578e063c95152efb869c7144f7a0c1a5099c7a69ee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformation",
    jsii_struct_bases=[],
    name_mapping={
        "append": "append",
        "aspect_crop": "aspectCrop",
        "background_color": "backgroundColor",
        "blur": "blur",
        "chroma_key": "chromaKey",
        "composite": "composite",
        "compound": "compound",
        "contrast": "contrast",
        "crop": "crop",
        "face_crop": "faceCrop",
        "feature_crop": "featureCrop",
        "fit_and_fill": "fitAndFill",
        "goop": "goop",
        "grayscale": "grayscale",
        "hsl": "hsl",
        "hsv": "hsv",
        "if_dimension": "ifDimension",
        "if_orientation": "ifOrientation",
        "im_query": "imQuery",
        "max_colors": "maxColors",
        "mirror": "mirror",
        "mono_hue": "monoHue",
        "opacity": "opacity",
        "region_of_interest_crop": "regionOfInterestCrop",
        "relative_crop": "relativeCrop",
        "remove_color": "removeColor",
        "resize": "resize",
        "rotate": "rotate",
        "scale": "scale",
        "shear": "shear",
        "trim": "trim",
        "unsharp_mask": "unsharpMask",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformation:
    def __init__(
        self,
        *,
        append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationAppend", typing.Dict[builtins.str, typing.Any]]]]] = None,
        aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationAspectCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationBackgroundColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationBlur", typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationChromaKey", typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationComposite", typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationCompound", typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationContrast", typing.Dict[builtins.str, typing.Any]]]]] = None,
        crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationFaceCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationFeatureCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationFitAndFill", typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationGoop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationGrayscale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationHsl", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationHsv", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfDimension", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfOrientation", typing.Dict[builtins.str, typing.Any]]]]] = None,
        im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationImQuery", typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationMaxColors", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationMirror", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationMonoHue", typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationOpacity", typing.Dict[builtins.str, typing.Any]]]]] = None,
        region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationRegionOfInterestCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationRelativeCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationRemoveColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationResize", typing.Dict[builtins.str, typing.Any]]]]] = None,
        rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationRotate", typing.Dict[builtins.str, typing.Any]]]]] = None,
        scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationScale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationShear", typing.Dict[builtins.str, typing.Any]]]]] = None,
        trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationTrim", typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationUnsharpMask", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param append: append block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        :param aspect_crop: aspect_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param crop: crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        :param face_crop: face_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        :param feature_crop: feature_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        :param fit_and_fill: fit_and_fill block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param im_query: im_query block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param region_of_interest_crop: region_of_interest_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        :param relative_crop: relative_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param resize: resize block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        :param rotate: rotate block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        :param scale: scale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param shear: shear block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        :param trim: trim block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b57bf7ade4772c48a5d459fc343aa598270e08f9356b34d62849b30ec8a33801)
            check_type(argname="argument append", value=append, expected_type=type_hints["append"])
            check_type(argname="argument aspect_crop", value=aspect_crop, expected_type=type_hints["aspect_crop"])
            check_type(argname="argument background_color", value=background_color, expected_type=type_hints["background_color"])
            check_type(argname="argument blur", value=blur, expected_type=type_hints["blur"])
            check_type(argname="argument chroma_key", value=chroma_key, expected_type=type_hints["chroma_key"])
            check_type(argname="argument composite", value=composite, expected_type=type_hints["composite"])
            check_type(argname="argument compound", value=compound, expected_type=type_hints["compound"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument crop", value=crop, expected_type=type_hints["crop"])
            check_type(argname="argument face_crop", value=face_crop, expected_type=type_hints["face_crop"])
            check_type(argname="argument feature_crop", value=feature_crop, expected_type=type_hints["feature_crop"])
            check_type(argname="argument fit_and_fill", value=fit_and_fill, expected_type=type_hints["fit_and_fill"])
            check_type(argname="argument goop", value=goop, expected_type=type_hints["goop"])
            check_type(argname="argument grayscale", value=grayscale, expected_type=type_hints["grayscale"])
            check_type(argname="argument hsl", value=hsl, expected_type=type_hints["hsl"])
            check_type(argname="argument hsv", value=hsv, expected_type=type_hints["hsv"])
            check_type(argname="argument if_dimension", value=if_dimension, expected_type=type_hints["if_dimension"])
            check_type(argname="argument if_orientation", value=if_orientation, expected_type=type_hints["if_orientation"])
            check_type(argname="argument im_query", value=im_query, expected_type=type_hints["im_query"])
            check_type(argname="argument max_colors", value=max_colors, expected_type=type_hints["max_colors"])
            check_type(argname="argument mirror", value=mirror, expected_type=type_hints["mirror"])
            check_type(argname="argument mono_hue", value=mono_hue, expected_type=type_hints["mono_hue"])
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument region_of_interest_crop", value=region_of_interest_crop, expected_type=type_hints["region_of_interest_crop"])
            check_type(argname="argument relative_crop", value=relative_crop, expected_type=type_hints["relative_crop"])
            check_type(argname="argument remove_color", value=remove_color, expected_type=type_hints["remove_color"])
            check_type(argname="argument resize", value=resize, expected_type=type_hints["resize"])
            check_type(argname="argument rotate", value=rotate, expected_type=type_hints["rotate"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument shear", value=shear, expected_type=type_hints["shear"])
            check_type(argname="argument trim", value=trim, expected_type=type_hints["trim"])
            check_type(argname="argument unsharp_mask", value=unsharp_mask, expected_type=type_hints["unsharp_mask"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if append is not None:
            self._values["append"] = append
        if aspect_crop is not None:
            self._values["aspect_crop"] = aspect_crop
        if background_color is not None:
            self._values["background_color"] = background_color
        if blur is not None:
            self._values["blur"] = blur
        if chroma_key is not None:
            self._values["chroma_key"] = chroma_key
        if composite is not None:
            self._values["composite"] = composite
        if compound is not None:
            self._values["compound"] = compound
        if contrast is not None:
            self._values["contrast"] = contrast
        if crop is not None:
            self._values["crop"] = crop
        if face_crop is not None:
            self._values["face_crop"] = face_crop
        if feature_crop is not None:
            self._values["feature_crop"] = feature_crop
        if fit_and_fill is not None:
            self._values["fit_and_fill"] = fit_and_fill
        if goop is not None:
            self._values["goop"] = goop
        if grayscale is not None:
            self._values["grayscale"] = grayscale
        if hsl is not None:
            self._values["hsl"] = hsl
        if hsv is not None:
            self._values["hsv"] = hsv
        if if_dimension is not None:
            self._values["if_dimension"] = if_dimension
        if if_orientation is not None:
            self._values["if_orientation"] = if_orientation
        if im_query is not None:
            self._values["im_query"] = im_query
        if max_colors is not None:
            self._values["max_colors"] = max_colors
        if mirror is not None:
            self._values["mirror"] = mirror
        if mono_hue is not None:
            self._values["mono_hue"] = mono_hue
        if opacity is not None:
            self._values["opacity"] = opacity
        if region_of_interest_crop is not None:
            self._values["region_of_interest_crop"] = region_of_interest_crop
        if relative_crop is not None:
            self._values["relative_crop"] = relative_crop
        if remove_color is not None:
            self._values["remove_color"] = remove_color
        if resize is not None:
            self._values["resize"] = resize
        if rotate is not None:
            self._values["rotate"] = rotate
        if scale is not None:
            self._values["scale"] = scale
        if shear is not None:
            self._values["shear"] = shear
        if trim is not None:
            self._values["trim"] = trim
        if unsharp_mask is not None:
            self._values["unsharp_mask"] = unsharp_mask

    @builtins.property
    def append(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationAppend"]]]:
        '''append block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        '''
        result = self._values.get("append")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationAppend"]]], result)

    @builtins.property
    def aspect_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationAspectCrop"]]]:
        '''aspect_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        '''
        result = self._values.get("aspect_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationAspectCrop"]]], result)

    @builtins.property
    def background_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationBackgroundColor"]]]:
        '''background_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        '''
        result = self._values.get("background_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationBackgroundColor"]]], result)

    @builtins.property
    def blur(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationBlur"]]]:
        '''blur block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        '''
        result = self._values.get("blur")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationBlur"]]], result)

    @builtins.property
    def chroma_key(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationChromaKey"]]]:
        '''chroma_key block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        '''
        result = self._values.get("chroma_key")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationChromaKey"]]], result)

    @builtins.property
    def composite(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationComposite"]]]:
        '''composite block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        '''
        result = self._values.get("composite")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationComposite"]]], result)

    @builtins.property
    def compound(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationCompound"]]]:
        '''compound block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        '''
        result = self._values.get("compound")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationCompound"]]], result)

    @builtins.property
    def contrast(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationContrast"]]]:
        '''contrast block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationContrast"]]], result)

    @builtins.property
    def crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationCrop"]]]:
        '''crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        '''
        result = self._values.get("crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationCrop"]]], result)

    @builtins.property
    def face_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationFaceCrop"]]]:
        '''face_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        '''
        result = self._values.get("face_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationFaceCrop"]]], result)

    @builtins.property
    def feature_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationFeatureCrop"]]]:
        '''feature_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        '''
        result = self._values.get("feature_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationFeatureCrop"]]], result)

    @builtins.property
    def fit_and_fill(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationFitAndFill"]]]:
        '''fit_and_fill block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        '''
        result = self._values.get("fit_and_fill")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationFitAndFill"]]], result)

    @builtins.property
    def goop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationGoop"]]]:
        '''goop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        '''
        result = self._values.get("goop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationGoop"]]], result)

    @builtins.property
    def grayscale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationGrayscale"]]]:
        '''grayscale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        '''
        result = self._values.get("grayscale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationGrayscale"]]], result)

    @builtins.property
    def hsl(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationHsl"]]]:
        '''hsl block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        '''
        result = self._values.get("hsl")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationHsl"]]], result)

    @builtins.property
    def hsv(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationHsv"]]]:
        '''hsv block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        '''
        result = self._values.get("hsv")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationHsv"]]], result)

    @builtins.property
    def if_dimension(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfDimension"]]]:
        '''if_dimension block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        '''
        result = self._values.get("if_dimension")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfDimension"]]], result)

    @builtins.property
    def if_orientation(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfOrientation"]]]:
        '''if_orientation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        '''
        result = self._values.get("if_orientation")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfOrientation"]]], result)

    @builtins.property
    def im_query(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationImQuery"]]]:
        '''im_query block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        '''
        result = self._values.get("im_query")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationImQuery"]]], result)

    @builtins.property
    def max_colors(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationMaxColors"]]]:
        '''max_colors block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        '''
        result = self._values.get("max_colors")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationMaxColors"]]], result)

    @builtins.property
    def mirror(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationMirror"]]]:
        '''mirror block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        '''
        result = self._values.get("mirror")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationMirror"]]], result)

    @builtins.property
    def mono_hue(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationMonoHue"]]]:
        '''mono_hue block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        '''
        result = self._values.get("mono_hue")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationMonoHue"]]], result)

    @builtins.property
    def opacity(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationOpacity"]]]:
        '''opacity block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationOpacity"]]], result)

    @builtins.property
    def region_of_interest_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationRegionOfInterestCrop"]]]:
        '''region_of_interest_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        '''
        result = self._values.get("region_of_interest_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationRegionOfInterestCrop"]]], result)

    @builtins.property
    def relative_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationRelativeCrop"]]]:
        '''relative_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        '''
        result = self._values.get("relative_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationRelativeCrop"]]], result)

    @builtins.property
    def remove_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationRemoveColor"]]]:
        '''remove_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        '''
        result = self._values.get("remove_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationRemoveColor"]]], result)

    @builtins.property
    def resize(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationResize"]]]:
        '''resize block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        '''
        result = self._values.get("resize")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationResize"]]], result)

    @builtins.property
    def rotate(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationRotate"]]]:
        '''rotate block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        '''
        result = self._values.get("rotate")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationRotate"]]], result)

    @builtins.property
    def scale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationScale"]]]:
        '''scale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationScale"]]], result)

    @builtins.property
    def shear(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationShear"]]]:
        '''shear block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        '''
        result = self._values.get("shear")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationShear"]]], result)

    @builtins.property
    def trim(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationTrim"]]]:
        '''trim block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        '''
        result = self._values.get("trim")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationTrim"]]], result)

    @builtins.property
    def unsharp_mask(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationUnsharpMask"]]]:
        '''unsharp_mask block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        result = self._values.get("unsharp_mask")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationUnsharpMask"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationAppend",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_priority": "gravityPriority",
        "gravity_priority_var": "gravityPriorityVar",
        "gravity_var": "gravityVar",
        "preserve_minor_dimension": "preserveMinorDimension",
        "preserve_minor_dimension_var": "preserveMinorDimensionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationAppend:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationAppendImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_priority: typing.Optional[builtins.str] = None,
        gravity_priority_var: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        preserve_minor_dimension: typing.Optional[builtins.str] = None,
        preserve_minor_dimension_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Specifies where to place the ``image`` relative to the source image. The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_priority: Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal. The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority DataAkamaiImagingPolicyImage#gravity_priority}
        :param gravity_priority_var: Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal. The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority_var DataAkamaiImagingPolicyImage#gravity_priority_var}
        :param gravity_var: Specifies where to place the ``image`` relative to the source image. The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param preserve_minor_dimension: Whether to preserve the source image's minor dimension, ``false`` by default. The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension DataAkamaiImagingPolicyImage#preserve_minor_dimension}
        :param preserve_minor_dimension_var: Whether to preserve the source image's minor dimension, ``false`` by default. The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension_var DataAkamaiImagingPolicyImage#preserve_minor_dimension_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationAppendImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b6db311bea1abafd70fec83a56a45c22ab1ea90155e08ca5ce5537dcedf1a8d4)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_priority", value=gravity_priority, expected_type=type_hints["gravity_priority"])
            check_type(argname="argument gravity_priority_var", value=gravity_priority_var, expected_type=type_hints["gravity_priority_var"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument preserve_minor_dimension", value=preserve_minor_dimension, expected_type=type_hints["preserve_minor_dimension"])
            check_type(argname="argument preserve_minor_dimension_var", value=preserve_minor_dimension_var, expected_type=type_hints["preserve_minor_dimension_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_priority is not None:
            self._values["gravity_priority"] = gravity_priority
        if gravity_priority_var is not None:
            self._values["gravity_priority_var"] = gravity_priority_var
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if preserve_minor_dimension is not None:
            self._values["preserve_minor_dimension"] = preserve_minor_dimension
        if preserve_minor_dimension_var is not None:
            self._values["preserve_minor_dimension_var"] = preserve_minor_dimension_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationAppendImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationAppendImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Specifies where to place the ``image`` relative to the source image.

        The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_priority(self) -> typing.Optional[builtins.str]:
        '''Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal.

        The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority DataAkamaiImagingPolicyImage#gravity_priority}
        '''
        result = self._values.get("gravity_priority")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_priority_var(self) -> typing.Optional[builtins.str]:
        '''Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal.

        The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority_var DataAkamaiImagingPolicyImage#gravity_priority_var}
        '''
        result = self._values.get("gravity_priority_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Specifies where to place the ``image`` relative to the source image.

        The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def preserve_minor_dimension(self) -> typing.Optional[builtins.str]:
        '''Whether to preserve the source image's minor dimension, ``false`` by default.

        The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension DataAkamaiImagingPolicyImage#preserve_minor_dimension}
        '''
        result = self._values.get("preserve_minor_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def preserve_minor_dimension_var(self) -> typing.Optional[builtins.str]:
        '''Whether to preserve the source image's minor dimension, ``false`` by default.

        The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension_var DataAkamaiImagingPolicyImage#preserve_minor_dimension_var}
        '''
        result = self._values.get("preserve_minor_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationAppend(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationAppendImage",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationAppendImage:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationAppendImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationAppendImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationAppendImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__155150b12b9717194394b127956393a51e445b89747f71f7e42285475cdd92db)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationAppendImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationAppendImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationAppendImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0a2a16401708df2f0ffbdf282f1b081ff3ed8bb371fa00fd8ed54fc1491c1179)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationAppendList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationAppendList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__39bc0607eec7fc3876e3fce4efbcff979cd72a6fab74a2ff0f3ff2844459c946)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationAppendOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__25f7a89447320f9926f23b6845b9ec4130f3796c91856c97fef84b97f1844a53)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationAppendOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0f4761b4fe59c277fda2140e4ec978981a7dbb0c1cd55f2a7a143caa34bbb60c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a5c9379effe7ce34ec80e68e8d04a4f44336e7cd9fe7103eb74bb81c1a9562cb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0fe1250217cc786017637e2ceb33582c48d42a720eb1718e9df81215b025acb7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationAppend]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationAppend]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationAppend]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ae19e4b04a662d5c58ff2ceaaddd5ac5ec60746c5fb1062bd7ff4c9ecb933d73)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationAppendOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationAppendOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb2de65c938e0780a4959aacad97fc9f2f8e2d88aaf5ac53f10f48a66721d390)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationAppendImage()

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityPriority")
    def reset_gravity_priority(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityPriority", []))

    @jsii.member(jsii_name="resetGravityPriorityVar")
    def reset_gravity_priority_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityPriorityVar", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPreserveMinorDimension")
    def reset_preserve_minor_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPreserveMinorDimension", []))

    @jsii.member(jsii_name="resetPreserveMinorDimensionVar")
    def reset_preserve_minor_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPreserveMinorDimensionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationAppendImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationAppendImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityInput")
    def gravity_priority_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityPriorityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityVarInput")
    def gravity_priority_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityPriorityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationAppendImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationAppendImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionInput")
    def preserve_minor_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "preserveMinorDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionVarInput")
    def preserve_minor_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "preserveMinorDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0dba69fe3f61d92d895e8c1be4d9c093f64148c1b49737cc7800341fa341fe1a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityPriority")
    def gravity_priority(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityPriority"))

    @gravity_priority.setter
    def gravity_priority(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__36f313cdfa6ed3ea4a9962716b9cd9a52cc234124291593b08e64fb111cc5285)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityPriority", value)

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityVar")
    def gravity_priority_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityPriorityVar"))

    @gravity_priority_var.setter
    def gravity_priority_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5bbfb9e36f701862133f4ce64f9034f9719d93d7edb4655fa0e39fe19eece506)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityPriorityVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d22c9ac32c228d2a9b37b91c3b1910f46716e51941051abb6b34e5fe1af03f0a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimension")
    def preserve_minor_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "preserveMinorDimension"))

    @preserve_minor_dimension.setter
    def preserve_minor_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be462f71589aa15b0eacca927e8e3eee6f5b96ac6de4841c223c726327597bcc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "preserveMinorDimension", value)

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionVar")
    def preserve_minor_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "preserveMinorDimensionVar"))

    @preserve_minor_dimension_var.setter
    def preserve_minor_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5364be47a14afd726a76cf1e41726408138265d24d6fbec097fbaa15c1e3ae8a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "preserveMinorDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationAppend]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationAppend]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationAppend]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dc73b77e933289780cdd9bf0a9737c29449c642b41c2cc99a6257dc52671c85f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationAspectCrop",
    jsii_struct_bases=[],
    name_mapping={
        "allow_expansion": "allowExpansion",
        "allow_expansion_var": "allowExpansionVar",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationAspectCrop:
    def __init__(
        self,
        *,
        allow_expansion: typing.Optional[builtins.str] = None,
        allow_expansion_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_expansion: Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image. Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        :param allow_expansion_var: Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image. Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        :param height: The height term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The width term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        :param x_position: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1673a860c2793512336b495706d5a48b2898b3f79335b7d278703711b9141af1)
            check_type(argname="argument allow_expansion", value=allow_expansion, expected_type=type_hints["allow_expansion"])
            check_type(argname="argument allow_expansion_var", value=allow_expansion_var, expected_type=type_hints["allow_expansion_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if allow_expansion is not None:
            self._values["allow_expansion"] = allow_expansion
        if allow_expansion_var is not None:
            self._values["allow_expansion_var"] = allow_expansion_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def allow_expansion(self) -> typing.Optional[builtins.str]:
        '''Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image.

        Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        '''
        result = self._values.get("allow_expansion")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def allow_expansion_var(self) -> typing.Optional[builtins.str]:
        '''Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image.

        Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        '''
        result = self._values.get("allow_expansion_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationAspectCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationAspectCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationAspectCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d688fbf344180295d9b1369fe79c6d2723a5ca37128b36599841e5d225eb97a1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationAspectCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d012927c2e87cdf65a6e53e998f2f69b996648db0d93416032453d77304f8395)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationAspectCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fc877555a5c6d173643dd79e520afcbaaa3fb651836206531444e68a5247a028)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7a9b1c81a8b54d94a3ed6cd58eb5373a43e0bdc8bd1cf3eb0dd1f6ceb41ec4dd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d21cb2f18a337871d4bbae1244f6327f57ce06dc0193f76f6d8b095efa54e402)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationAspectCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationAspectCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationAspectCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ba18b8fdaacd18fe61903992f8ea9663f703c09bcdc1eba574b0ead98e4b3ac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationAspectCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationAspectCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__425c0ef7eb85648fb92198db7e1d22697fb4501206d5da57aa0d5c35cee7fa2b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAllowExpansion")
    def reset_allow_expansion(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansion", []))

    @jsii.member(jsii_name="resetAllowExpansionVar")
    def reset_allow_expansion_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansionVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionInput")
    def allow_expansion_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVarInput")
    def allow_expansion_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansion")
    def allow_expansion(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansion"))

    @allow_expansion.setter
    def allow_expansion(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6b281d49e2d97133e6f26278a4172110c77466743a34f628b452dbafc6083b67)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansion", value)

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVar")
    def allow_expansion_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansionVar"))

    @allow_expansion_var.setter
    def allow_expansion_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5655f76c4da7ef2e6e0df2e4bcbe0a3a9ce4267a1c68af4f7b21b09c06f792ee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansionVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__89f60a55228232ad6f94f9a044fbeeb77d34bbcd485b0e15001f7b3c4fecc594)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ef8c36f2a0da76f814c7a7cc73fc3d235b2f97ded7c9b70340392d1ab382735b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0e5a15a9398609c240cfbb08ef1231747d370ddb2fe6382a1b20afbe8e60f7d8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b7ff039d15747b5289f699c55178179166fd7b030cbf4a31610ea8aba4a52e26)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__34632a3fd996a7d88a24511d17dc7cd56b016cb705770ccf163457eb29801f59)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__40b247b428e3c291139d39072d6c32e7f81c7d149e70481e8b406f59ae6202ce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3864ce3ab360b36b03a5f4ded24a8a0edf9e27fce87926161d7ef95c7e6f2664)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2be16777866ef73592262b9b880663ff45a70b20e13a5b223431debe0c1aa0cd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationAspectCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationAspectCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationAspectCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__68ef6c9a2e808af2b58735de7cfb89f35253545b01ae431a71c98524cc37cfb7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationBackgroundColor",
    jsii_struct_bases=[],
    name_mapping={"color": "color", "color_var": "colorVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationBackgroundColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__13186aa4efb7660e93ce17080f27bc0b6fddfcfd5d5b248efca4b1b225c83b81)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationBackgroundColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationBackgroundColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationBackgroundColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__04282ca55c49fd6cd25421339dbf4fca35c3ef099be6e2725df7a4a8ec24ddb0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationBackgroundColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1bc4de741b66ea2660ecd0d0f711c5d8ff255433dafc62761c0ae00ec40bbec7)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationBackgroundColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a923d3fd113fc61399f71cdc2ff358d57f5f9ac4f5303baa6943b99c4701ee53)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__404223f03dbccfde666d18e65d54ac3cb37a1b2f6eb79b12b5fbe257d1afdc8b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__564e4cefd978080f77c6944a306946d42ae6e3d38df189468566e424f417f25c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationBackgroundColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationBackgroundColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8b8a15f3c423a4b6734921aad99ab28409bc836cdceb82d26e2ad29e0ff453a8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationBackgroundColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationBackgroundColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9c28cb8c71a88c52c2a1304d6f32959cc09098dbfc666e68b8b5b5e5a3c89a59)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1083d40a5f644cbf7181f7dede5df41f75f89431826a630985e72fc1d3898caf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__988047f4465fba8d5ba57294634dee40554c5ec178c61a65cf10a9fb9f9d79ae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationBackgroundColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationBackgroundColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationBackgroundColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a4bd361d5572c4b615b3689a937097e8606adfdf326b4033d60e89b250e5698d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationBlur",
    jsii_struct_bases=[],
    name_mapping={"sigma": "sigma", "sigma_var": "sigmaVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationBlur:
    def __init__(
        self,
        *,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param sigma: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d350ba131d9800991c15abf9f5e99f57a35978893f9c08f1704520debbabf57)
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationBlur(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationBlurList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationBlurList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__776ea2113c0e4e44efa70a6cf44ce41d7fcc0dd88e2201f5c7c4cffc2abc433b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationBlurOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0be522c1ada3659628dac234971599ba8418e71c3cedfe02a2b443930c7e62bd)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationBlurOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5a539d7540f5d862e8958646d790096575fe81595f58165ccc9e124bf4521d62)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eb4d267a21ed58d32422da3cf9e5fcf5ec1cc6cc128131e39f0d72b8d197c625)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e289c4318b2ed2e68ce0c1123a9bc3a26c5d630afa2e9c1ee27b6cba1fc976eb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationBlur]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationBlur]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f5d33ec56d0590af47a4da3d95a39c3cf4f4da419d2d532cc05c4c79b1a98e0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationBlurOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationBlurOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__70a3d761ece9152e61bb05dd727cf9fe51e84ef3b3be824920b4bfaa2fbdf923)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__86df0c4a5e7c80ac7550e0a16cc7998b01850835d8b71ba25fd01230be9f9c9b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__629ef945cedb17edab003354e0a10c7ab9fb9747f7d50fd8d28bd5b6c0e6d751)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationBlur]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationBlur]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationBlur]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8408de57ee61a63b7411165b4fb5588093f401937f31f7db7254d5ef0d5c66be)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationChromaKey",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_feather": "hueFeather",
        "hue_feather_var": "hueFeatherVar",
        "hue_tolerance": "hueTolerance",
        "hue_tolerance_var": "hueToleranceVar",
        "hue_var": "hueVar",
        "lightness_feather": "lightnessFeather",
        "lightness_feather_var": "lightnessFeatherVar",
        "lightness_tolerance": "lightnessTolerance",
        "lightness_tolerance_var": "lightnessToleranceVar",
        "saturation_feather": "saturationFeather",
        "saturation_feather_var": "saturationFeatherVar",
        "saturation_tolerance": "saturationTolerance",
        "saturation_tolerance_var": "saturationToleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationChromaKey:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_feather: typing.Optional[builtins.str] = None,
        hue_feather_var: typing.Optional[builtins.str] = None,
        hue_tolerance: typing.Optional[builtins.str] = None,
        hue_tolerance_var: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness_feather: typing.Optional[builtins.str] = None,
        lightness_feather_var: typing.Optional[builtins.str] = None,
        lightness_tolerance: typing.Optional[builtins.str] = None,
        lightness_tolerance_var: typing.Optional[builtins.str] = None,
        saturation_feather: typing.Optional[builtins.str] = None,
        saturation_feather_var: typing.Optional[builtins.str] = None,
        saturation_tolerance: typing.Optional[builtins.str] = None,
        saturation_tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_feather: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        :param hue_feather_var: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        :param hue_tolerance: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        :param hue_tolerance_var: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        :param hue_var: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness_feather: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        :param lightness_feather_var: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        :param lightness_tolerance: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        :param lightness_tolerance_var: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        :param saturation_feather: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        :param saturation_feather_var: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        :param saturation_tolerance: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        :param saturation_tolerance_var: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__69909065f0635db0a84366e689b2844d96d538adc7a00c3b9acd8c8de15d26f8)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_feather", value=hue_feather, expected_type=type_hints["hue_feather"])
            check_type(argname="argument hue_feather_var", value=hue_feather_var, expected_type=type_hints["hue_feather_var"])
            check_type(argname="argument hue_tolerance", value=hue_tolerance, expected_type=type_hints["hue_tolerance"])
            check_type(argname="argument hue_tolerance_var", value=hue_tolerance_var, expected_type=type_hints["hue_tolerance_var"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness_feather", value=lightness_feather, expected_type=type_hints["lightness_feather"])
            check_type(argname="argument lightness_feather_var", value=lightness_feather_var, expected_type=type_hints["lightness_feather_var"])
            check_type(argname="argument lightness_tolerance", value=lightness_tolerance, expected_type=type_hints["lightness_tolerance"])
            check_type(argname="argument lightness_tolerance_var", value=lightness_tolerance_var, expected_type=type_hints["lightness_tolerance_var"])
            check_type(argname="argument saturation_feather", value=saturation_feather, expected_type=type_hints["saturation_feather"])
            check_type(argname="argument saturation_feather_var", value=saturation_feather_var, expected_type=type_hints["saturation_feather_var"])
            check_type(argname="argument saturation_tolerance", value=saturation_tolerance, expected_type=type_hints["saturation_tolerance"])
            check_type(argname="argument saturation_tolerance_var", value=saturation_tolerance_var, expected_type=type_hints["saturation_tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_feather is not None:
            self._values["hue_feather"] = hue_feather
        if hue_feather_var is not None:
            self._values["hue_feather_var"] = hue_feather_var
        if hue_tolerance is not None:
            self._values["hue_tolerance"] = hue_tolerance
        if hue_tolerance_var is not None:
            self._values["hue_tolerance_var"] = hue_tolerance_var
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness_feather is not None:
            self._values["lightness_feather"] = lightness_feather
        if lightness_feather_var is not None:
            self._values["lightness_feather_var"] = lightness_feather_var
        if lightness_tolerance is not None:
            self._values["lightness_tolerance"] = lightness_tolerance
        if lightness_tolerance_var is not None:
            self._values["lightness_tolerance_var"] = lightness_tolerance_var
        if saturation_feather is not None:
            self._values["saturation_feather"] = saturation_feather
        if saturation_feather_var is not None:
            self._values["saturation_feather_var"] = saturation_feather_var
        if saturation_tolerance is not None:
            self._values["saturation_tolerance"] = saturation_tolerance
        if saturation_tolerance_var is not None:
            self._values["saturation_tolerance_var"] = saturation_tolerance_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        '''
        result = self._values.get("hue_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        '''
        result = self._values.get("hue_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        '''
        result = self._values.get("hue_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        '''
        result = self._values.get("hue_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        '''
        result = self._values.get("lightness_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        '''
        result = self._values.get("lightness_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        '''
        result = self._values.get("lightness_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        '''
        result = self._values.get("lightness_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        '''
        result = self._values.get("saturation_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        '''
        result = self._values.get("saturation_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        '''
        result = self._values.get("saturation_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        result = self._values.get("saturation_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationChromaKey(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationChromaKeyList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationChromaKeyList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a8102ca68e242fdfcd9b5f3c8b95d02e1d35ab27bdb5a61232953147b772d96)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationChromaKeyOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6ae65790c88fc1582898a4f3a76cc1026463bc23580589bbcbe68903e64a0129)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationChromaKeyOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f2858f566d248cc46ed155df0e92c635b2963d51c2db3e37f10de9e321a18a94)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4b0f6a067ee33f24af153e9a772bf66ef52c5270c05258cf528b395407b3985f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8fac82627cdf89a9a406ff25c04d4b69b9ace79e3e185881e55acf8f6b053c02)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationChromaKey]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationChromaKey]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a6ef7a49989d39f0c7f445d2b0668d8b50c2a2acdaf35cf0238dfa094b9bc5e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationChromaKeyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationChromaKeyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9029cc6a49b2fab328507ebbfbb517c591ab259b1f56534d94f05f7a4aa4aa3d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueFeather")
    def reset_hue_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeather", []))

    @jsii.member(jsii_name="resetHueFeatherVar")
    def reset_hue_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeatherVar", []))

    @jsii.member(jsii_name="resetHueTolerance")
    def reset_hue_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueTolerance", []))

    @jsii.member(jsii_name="resetHueToleranceVar")
    def reset_hue_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueToleranceVar", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightnessFeather")
    def reset_lightness_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeather", []))

    @jsii.member(jsii_name="resetLightnessFeatherVar")
    def reset_lightness_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeatherVar", []))

    @jsii.member(jsii_name="resetLightnessTolerance")
    def reset_lightness_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessTolerance", []))

    @jsii.member(jsii_name="resetLightnessToleranceVar")
    def reset_lightness_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessToleranceVar", []))

    @jsii.member(jsii_name="resetSaturationFeather")
    def reset_saturation_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeather", []))

    @jsii.member(jsii_name="resetSaturationFeatherVar")
    def reset_saturation_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeatherVar", []))

    @jsii.member(jsii_name="resetSaturationTolerance")
    def reset_saturation_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationTolerance", []))

    @jsii.member(jsii_name="resetSaturationToleranceVar")
    def reset_saturation_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherInput")
    def hue_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVarInput")
    def hue_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceInput")
    def hue_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVarInput")
    def hue_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherInput")
    def lightness_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVarInput")
    def lightness_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceInput")
    def lightness_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVarInput")
    def lightness_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherInput")
    def saturation_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVarInput")
    def saturation_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceInput")
    def saturation_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVarInput")
    def saturation_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7846501524c72a1e98116b8b4a2ce1ddc3709aa49b033de056754a800f4efba8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeather")
    def hue_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeather"))

    @hue_feather.setter
    def hue_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__24aba8ef230ca3a1c4aa2b27152a79bb5f58ca2178547e1aa89b90412c80f389)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeather", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVar")
    def hue_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeatherVar"))

    @hue_feather_var.setter
    def hue_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f5231b3929b965cabb20cae7aa7929ca5780cdfa392ce9fb9710759ef4ef2b02)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueTolerance")
    def hue_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueTolerance"))

    @hue_tolerance.setter
    def hue_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__89eaa7e9e66dc9ea1a694933e6a355a2764be7e2dea1c9a280e8f70dda86e847)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVar")
    def hue_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueToleranceVar"))

    @hue_tolerance_var.setter
    def hue_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__80cb4437d6be84ced00ba1389632aadfc0a4da5f4dcfc04270c9973ec6b9ea8f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a94ee3aaa72c8df1f11bc0f9148a3464a9d9e2b7f7989594f8d28114735fbaf2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeather")
    def lightness_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeather"))

    @lightness_feather.setter
    def lightness_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f3175d0db508e5ab2e2f3f102a742ff3e0060715bc8c5d4d91370d55afe08551)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeather", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVar")
    def lightness_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeatherVar"))

    @lightness_feather_var.setter
    def lightness_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2133ef1345ea25b0cc1a706261cfd960325b9aa314c2bf1d6f644722208b5766)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessTolerance")
    def lightness_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessTolerance"))

    @lightness_tolerance.setter
    def lightness_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__153b0295e89252082033447124eeef602ce4b73e5ee2eb0451002cb722c13ca8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVar")
    def lightness_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessToleranceVar"))

    @lightness_tolerance_var.setter
    def lightness_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7721552bb78e30cbcd66f4f63eba70d28e94daefaa5a8d9722e13118629f3c3e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeather")
    def saturation_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeather"))

    @saturation_feather.setter
    def saturation_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7681556c47e1d2ebe5c1a7a4a6d6a2e1b3b1c6266b195cbaff89dca0aec460b6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeather", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVar")
    def saturation_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeatherVar"))

    @saturation_feather_var.setter
    def saturation_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ae75b9af852cbf54c29424dc2a1de5430c6549c938dbd9f485f103f0c8b0376)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationTolerance")
    def saturation_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationTolerance"))

    @saturation_tolerance.setter
    def saturation_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e726e5d403c878406743155b081af42180d0a8c3b87f72f024757075528550eb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVar")
    def saturation_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationToleranceVar"))

    @saturation_tolerance_var.setter
    def saturation_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea5af0d28eb2675bff58ada4cf2696fb30284d1630f0dd4d11a1501de2e342f1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationChromaKey]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationChromaKey]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationChromaKey]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6988e9ec73536c78443a01dd3534b9acc0cf75604b0f951f176a030377a5b294)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationComposite",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "placement": "placement",
        "placement_var": "placementVar",
        "scale": "scale",
        "scale_dimension": "scaleDimension",
        "scale_dimension_var": "scaleDimensionVar",
        "scale_var": "scaleVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationComposite:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationCompositeImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        placement: typing.Optional[builtins.str] = None,
        placement_var: typing.Optional[builtins.str] = None,
        scale: typing.Optional[builtins.str] = None,
        scale_dimension: typing.Optional[builtins.str] = None,
        scale_dimension_var: typing.Optional[builtins.str] = None,
        scale_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param placement: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        :param placement_var: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        :param scale: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param scale_dimension: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        :param scale_dimension_var: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        :param scale_var: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        :param x_position: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationCompositeImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ee4e648fbcdc86ff57b9a4f07f4789fa29518061c30fbba15725184062b75c4)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument placement", value=placement, expected_type=type_hints["placement"])
            check_type(argname="argument placement_var", value=placement_var, expected_type=type_hints["placement_var"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument scale_dimension", value=scale_dimension, expected_type=type_hints["scale_dimension"])
            check_type(argname="argument scale_dimension_var", value=scale_dimension_var, expected_type=type_hints["scale_dimension_var"])
            check_type(argname="argument scale_var", value=scale_var, expected_type=type_hints["scale_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if placement is not None:
            self._values["placement"] = placement
        if placement_var is not None:
            self._values["placement_var"] = placement_var
        if scale is not None:
            self._values["scale"] = scale
        if scale_dimension is not None:
            self._values["scale_dimension"] = scale_dimension
        if scale_dimension_var is not None:
            self._values["scale_dimension_var"] = scale_dimension_var
        if scale_var is not None:
            self._values["scale_var"] = scale_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationCompositeImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationCompositeImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        '''
        result = self._values.get("placement")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement_var(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        '''
        result = self._values.get("placement_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        '''
        result = self._values.get("scale_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        '''
        result = self._values.get("scale_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        '''
        result = self._values.get("scale_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationComposite(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationCompositeImage",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationCompositeImage:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationCompositeImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationCompositeImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationCompositeImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0d15f4d8b8ee9facda5bb63938c2e6ec3cb3b3f02508dd2f4d43652c8862249c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationCompositeImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationCompositeImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__50b1f9e39ab1dc1b6b14104c7983f55c6feff1a2bf62e7303fc3ea705fc5b698)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationCompositeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationCompositeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e59983c997427586601a9b4842e2784a12b6ba658d08b3a3602184eee61f82ee)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationCompositeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__87eeaabebbec1a72b5c647fab0de2af32f23cb7112408c4516d9fa253bd0fb0b)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationCompositeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5748b248cebba76ba3228dfae3ade2140f31bb92348ab362d49c129d9f3d7ce2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1d4a7d0cf1895df3b883a28e4af6a0d4d208e7c6a9c417b7ebad8cb2e7e89cec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a975392b82f21017809227d67f4ba00e725bddad4a4556b51e26c2e49e66d4ae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationComposite]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationComposite]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__21f8990fc9c0babfb73bf899afc14cc6119dda78a2f9e743d36628bae563d858)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationCompositeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationCompositeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2b713eb581e9c3f322419c149519a196354e03f5915a35e4fddd299ae53a9ef8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationCompositeImage()

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPlacement")
    def reset_placement(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacement", []))

    @jsii.member(jsii_name="resetPlacementVar")
    def reset_placement_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacementVar", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetScaleDimension")
    def reset_scale_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimension", []))

    @jsii.member(jsii_name="resetScaleDimensionVar")
    def reset_scale_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimensionVar", []))

    @jsii.member(jsii_name="resetScaleVar")
    def reset_scale_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationCompositeImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationCompositeImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationCompositeImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="placementInput")
    def placement_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementInput"))

    @builtins.property
    @jsii.member(jsii_name="placementVarInput")
    def placement_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionInput")
    def scale_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVarInput")
    def scale_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleVarInput")
    def scale_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__626ed45d2a7258325341e113bd2dad31958c2653494dc38ab9bc6aeefe7cb6b1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5fd1e86ed5ae85e41f2480cac80861a01be873631eef1914cffafced1c6dbdbf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="placement")
    def placement(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placement"))

    @placement.setter
    def placement(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__47628e83a25dcb46e900dae30cf64891371fecff64650b9c48af3ce17fb9520d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placement", value)

    @builtins.property
    @jsii.member(jsii_name="placementVar")
    def placement_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placementVar"))

    @placement_var.setter
    def placement_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__13330820f53d2dce1679b0f871fa0b27a0187a3dd778155030dd0ca52bfaa986)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placementVar", value)

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scale"))

    @scale.setter
    def scale(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2b531c6421752919a74539cfbe14b7fb5b3477c3e9a09e247171abd8f8886b57)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scale", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimension")
    def scale_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimension"))

    @scale_dimension.setter
    def scale_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6386f8680c2470c114c30179270904640d3a30308765f72fc3a6e42806c01b99)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimension", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVar")
    def scale_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimensionVar"))

    @scale_dimension_var.setter
    def scale_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a29e1d4e77a253b097aea369774e1140d736d8dc4b7f770ce7ebb597b5e4d2b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="scaleVar")
    def scale_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleVar"))

    @scale_var.setter
    def scale_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4b626aa97ef154df85238b07a5fcf771ea79443f4b7bbc0eb1a916483ad22dc1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e7adb160b4bff166f74e3afd97134bda9b58e98e24dce65f30a13ef45dc44588)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aa1b9143d49e8a7a6c4182f447778ba7979e6f7955113ec76ca294491a7eebd7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a292699e47a48badcf1cd85b41dd2f6b20440854db325bb7168873b4fa29362f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b253234d579ce19d0e3f2165a3212575f806920b26a5d797b8d1180ccc158a2f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationComposite]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationComposite]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationComposite]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1891a5e59c51e197bbc223951a79abf15c4f4d45117a38d475959bfef98c39c3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationCompound",
    jsii_struct_bases=[],
    name_mapping={"transformations": "transformations"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationCompound:
    def __init__(
        self,
        *,
        transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param transformations: transformations block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__32c8d623645b35bfc9639606bc01a1b849f49c4ef43c68385509d0c06a527137)
            check_type(argname="argument transformations", value=transformations, expected_type=type_hints["transformations"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if transformations is not None:
            self._values["transformations"] = transformations

    @builtins.property
    def transformations(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationCompoundTransformations"]]]:
        '''transformations block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        result = self._values.get("transformations")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationCompoundTransformations"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationCompound(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationCompoundList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationCompoundList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__caebd8b2159fda4e82f0365bfe1706c1e3fa8bff2fe8c8d6c0cb3a5010fe4cf9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationCompoundOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e5b4a96625e2805c40183e08ac05b1c0bed392f5fda58c66a404b0f8ad34b983)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationCompoundOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__14380dac9ae49e9654abc673bd671ea757cc5b8a4d2c0aa9fb9175f864c96cda)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__05f7e454bbcc7da29d63c3433054292db863afde456ce208df443669973f0812)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__67c5ad6e6c474b96e0e796997d4401ce7a657b6a196d8de3b6ca76bfadf9969d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationCompound]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationCompound]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__800ed29dbe142af681e8fb4fcd51c32a9dbe95f385cdf9f8465d9c0c8ede28d3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationCompoundOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationCompoundOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a3ac33f12d80625bf43bd8b0e31580b9dafb0b4437d2b3fcb525ff9f1487af0d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformations")
    def put_transformations(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__64a0b553911037146347d37345a43696862f182479e12702e2c8223842720a6b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTransformations", [value]))

    @jsii.member(jsii_name="resetTransformations")
    def reset_transformations(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformations", []))

    @builtins.property
    @jsii.member(jsii_name="transformations")
    def transformations(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationCompoundTransformationsList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationCompoundTransformationsList", jsii.get(self, "transformations"))

    @builtins.property
    @jsii.member(jsii_name="transformationsInput")
    def transformations_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationCompoundTransformations"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationCompoundTransformations"]]], jsii.get(self, "transformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationCompound]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationCompound]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationCompound]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__09c857dad06be213c80b0f778727e918225abbfdb5f347c073a67666f7ab7350)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationCompoundTransformations",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationCompoundTransformations:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationCompoundTransformations(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationCompoundTransformationsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationCompoundTransformationsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b81cefe50298086518b5a2d8f19eae297aef3cc627c830230514fa146cd85167)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationCompoundTransformationsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__67552e8a247b0fbb146c74c99a75a7c59461374d5e698ed6b84b30e57fe7b764)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationCompoundTransformationsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fbec378c17a9a953fa9dccf09312ecaba39335ceb039db22929fded0e2d00e64)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f46ef30376f04fbe398caa9f60434929c66c7a27b0327fea252a35f5e3b785e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e096eb0731e0633974d866a9c1932861941eb46238504c3a9177c85c4d494a69)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationCompoundTransformations]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationCompoundTransformations]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationCompoundTransformations]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__96e331c22277a23fabb2192a920e11eb6b0c971c6ddc0244cc23700643180a93)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationCompoundTransformationsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationCompoundTransformationsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3d7d0a90265e5c4a06e55e5e89e9c149598f120d42226553129aebc8cb83ba00)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationCompoundTransformations]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationCompoundTransformations]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationCompoundTransformations]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8d413177f0b7afc5a9d40a4f14ad43ad4d140f5c01b0edf6cc47810765759f77)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationContrast",
    jsii_struct_bases=[],
    name_mapping={
        "brightness": "brightness",
        "brightness_var": "brightnessVar",
        "contrast": "contrast",
        "contrast_var": "contrastVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationContrast:
    def __init__(
        self,
        *,
        brightness: typing.Optional[builtins.str] = None,
        brightness_var: typing.Optional[builtins.str] = None,
        contrast: typing.Optional[builtins.str] = None,
        contrast_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param brightness: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        :param brightness_var: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        :param contrast: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param contrast_var: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__17db9030e59331613c98f6754c871ca3949f7201cd88c4431e61baa93dce22ba)
            check_type(argname="argument brightness", value=brightness, expected_type=type_hints["brightness"])
            check_type(argname="argument brightness_var", value=brightness_var, expected_type=type_hints["brightness_var"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument contrast_var", value=contrast_var, expected_type=type_hints["contrast_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if brightness is not None:
            self._values["brightness"] = brightness
        if brightness_var is not None:
            self._values["brightness_var"] = brightness_var
        if contrast is not None:
            self._values["contrast"] = contrast
        if contrast_var is not None:
            self._values["contrast_var"] = contrast_var

    @builtins.property
    def brightness(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        '''
        result = self._values.get("brightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def brightness_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        '''
        result = self._values.get("brightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        result = self._values.get("contrast_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationContrast(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationContrastList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationContrastList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b0e07b1c0d582841d859202970cf71acf540ed9695d544e0b3534bd078d5f8f5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationContrastOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__551df55dc7c404a9e97a33fe7ced8afb641050ee2fc64ccf15dc741a0cfb135f)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationContrastOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0521bf92ea356a29f5b3578342f62017b3ac03ba4085f98fa2685af1d010513b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2703933a3af52b24a91962825dc0ceaed441ba81ae33aa626ccb18feac6efd18)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a5abee1b829d516d3cec20bd06a92f87c270782d301a04520d545ce6cb7b80f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationContrast]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationContrast]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__68ab79612705f865ce86b045b4d52721ee1fe9fcdaa1091de7b6af6ee8d2cafd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationContrastOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationContrastOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__269620048ce2798337a67410dbffefa84cf0d0217cd5c6fe1512827234a6fadb)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetBrightness")
    def reset_brightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightness", []))

    @jsii.member(jsii_name="resetBrightnessVar")
    def reset_brightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightnessVar", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetContrastVar")
    def reset_contrast_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrastVar", []))

    @builtins.property
    @jsii.member(jsii_name="brightnessInput")
    def brightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="brightnessVarInput")
    def brightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastVarInput")
    def contrast_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="brightness")
    def brightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightness"))

    @brightness.setter
    def brightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__059e7307ac7a4146854c04d0d668bc5fab029b37f0497eb6f452ba043cadd6c6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightness", value)

    @builtins.property
    @jsii.member(jsii_name="brightnessVar")
    def brightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightnessVar"))

    @brightness_var.setter
    def brightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__85295200fc12b347e2f7907203f5f2eac599f72976c2a954c3d2ac126333f1a5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrast"))

    @contrast.setter
    def contrast(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f24bfbd352c6649957db03a8c7034ff796c94a7545017eb4bc5d6d69d0747e12)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrast", value)

    @builtins.property
    @jsii.member(jsii_name="contrastVar")
    def contrast_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrastVar"))

    @contrast_var.setter
    def contrast_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__738f77f2dc8ee581f3099240d5c831d05d515b869e73fc4be20fc4daee41c04f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrastVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationContrast]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationContrast]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationContrast]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5477bc5fe6ea7f0f1876054c06356589cf06314c14772c9c8295e54a990b0d36)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationCrop",
    jsii_struct_bases=[],
    name_mapping={
        "allow_expansion": "allowExpansion",
        "allow_expansion_var": "allowExpansionVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationCrop:
    def __init__(
        self,
        *,
        allow_expansion: typing.Optional[builtins.str] = None,
        allow_expansion_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_expansion: If cropping an area outside of the existing canvas, expands the image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        :param allow_expansion_var: If cropping an area outside of the existing canvas, expands the image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        :param gravity: Frame of reference for X and Y Positions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Frame of reference for X and Y Positions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The number of pixels to crop along the y-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The number of pixels to crop along the y-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The number of pixels to crop along the x-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The number of pixels to crop along the x-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        :param x_position: The x-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__978a169301768d2ef2fca6ef3bb54b2226cc5fcdc839aa894bbf33fbd80068bb)
            check_type(argname="argument allow_expansion", value=allow_expansion, expected_type=type_hints["allow_expansion"])
            check_type(argname="argument allow_expansion_var", value=allow_expansion_var, expected_type=type_hints["allow_expansion_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if allow_expansion is not None:
            self._values["allow_expansion"] = allow_expansion
        if allow_expansion_var is not None:
            self._values["allow_expansion_var"] = allow_expansion_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def allow_expansion(self) -> typing.Optional[builtins.str]:
        '''If cropping an area outside of the existing canvas, expands the image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        '''
        result = self._values.get("allow_expansion")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def allow_expansion_var(self) -> typing.Optional[builtins.str]:
        '''If cropping an area outside of the existing canvas, expands the image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        '''
        result = self._values.get("allow_expansion_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Frame of reference for X and Y Positions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Frame of reference for X and Y Positions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the y-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the y-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the x-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the x-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__78ed87aa3b8fedb4e4ab9194f42a0c26f0abefbe5193196c1d42b4fd4646c056)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__727b764863ec14fc3ed318a93ebf7a87db8e579f4baaf7571f68484287c0fe60)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__617fe5840ab39bb514f7511bb92bd7da328a8576b65a0e75210287e551c070c1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__10952a4606d2c03c047cc32890419e7df76002472664602cdf9cb61680774f09)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8ab32eb12f69ca901343feca845d5cdc0fa33d5764c8f9edc1003e339bea60bf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9c6875426b0db2b435a2a9bd98d1c46266489d73028fc3660300ce6bdfc79999)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e8480af38367880054311a66d9dbe6ed137e9f9cfd5e8a8d265e9ad4cc94e2b6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAllowExpansion")
    def reset_allow_expansion(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansion", []))

    @jsii.member(jsii_name="resetAllowExpansionVar")
    def reset_allow_expansion_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansionVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionInput")
    def allow_expansion_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVarInput")
    def allow_expansion_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansion")
    def allow_expansion(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansion"))

    @allow_expansion.setter
    def allow_expansion(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__003bdbeb5e02aa09cfbd6264819409c27d19138b51138924c8d60273a0dda860)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansion", value)

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVar")
    def allow_expansion_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansionVar"))

    @allow_expansion_var.setter
    def allow_expansion_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__813b35eaa29e12b90e01c0cd2e5c46b502eecf863aabae35509d900fe3580615)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansionVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7219ae78975d2739c0213e1644d296e8cbc79b5213a0c602ead3778ef6b4e8d8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__73385375fd1551d9f6433ac49b85661a6612d5968d1a804e3c0b6ab866ded93f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea1837bafd68370a013d8dac5b7bcaca92d327b9720f26eba3bed53b887bee31)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9980000058d2996b5e92a019ab90951ad2ead31de34ea089de8af2d3fe55812b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b220deba9b1d964d8822cda609113a51578802835d66f8444a462825d01ac261)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1a0968d18a99f15a6b25a7cf516c19ef9cd480db9476ef0669be500482f02afd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a1192c801ec16bfc56d99ea456d61db11038f0e69c3b1efb4e998be4db8019d6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__533f989b6a8f1077b1b7c4785827cc6b6930b22ed27a18ccc1678e73c29b2806)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2b0f418b82d16dc19d90a79ab46246272ae68368947384a614ee9e69246f5175)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ba6dece10a6a260a91dfa0091782e081ffc7dc8c751350e772c03581e157c05)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ff55c7aa09e4ccec5795d8fd6b253af2e3f9731f55bb4c96c351c3378fb33c31)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationFaceCrop",
    jsii_struct_bases=[],
    name_mapping={
        "algorithm": "algorithm",
        "algorithm_var": "algorithmVar",
        "confidence": "confidence",
        "confidence_var": "confidenceVar",
        "fail_gravity": "failGravity",
        "fail_gravity_var": "failGravityVar",
        "focus": "focus",
        "focus_var": "focusVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "padding": "padding",
        "padding_var": "paddingVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationFaceCrop:
    def __init__(
        self,
        *,
        algorithm: typing.Optional[builtins.str] = None,
        algorithm_var: typing.Optional[builtins.str] = None,
        confidence: typing.Optional[builtins.str] = None,
        confidence_var: typing.Optional[builtins.str] = None,
        fail_gravity: typing.Optional[builtins.str] = None,
        fail_gravity_var: typing.Optional[builtins.str] = None,
        focus: typing.Optional[builtins.str] = None,
        focus_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param algorithm: Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm DataAkamaiImagingPolicyImage#algorithm}
        :param algorithm_var: Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm_var DataAkamaiImagingPolicyImage#algorithm_var}
        :param confidence: With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image. Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence DataAkamaiImagingPolicyImage#confidence}
        :param confidence_var: With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image. Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence_var DataAkamaiImagingPolicyImage#confidence_var}
        :param fail_gravity: Controls placement of the crop if Image and Video Manager does not detect any faces in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        :param fail_gravity_var: Controls placement of the crop if Image and Video Manager does not detect any faces in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        :param focus: Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus DataAkamaiImagingPolicyImage#focus}
        :param focus_var: Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus_var DataAkamaiImagingPolicyImage#focus_var}
        :param gravity: Controls placement of the crop. Directions are relative to the face(s) plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Controls placement of the crop. Directions are relative to the face(s) plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param padding: The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        :param style: Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__27e98e229d2490c984c30ebda3b4c343fd4523a552c263727300298e42d180a1)
            check_type(argname="argument algorithm", value=algorithm, expected_type=type_hints["algorithm"])
            check_type(argname="argument algorithm_var", value=algorithm_var, expected_type=type_hints["algorithm_var"])
            check_type(argname="argument confidence", value=confidence, expected_type=type_hints["confidence"])
            check_type(argname="argument confidence_var", value=confidence_var, expected_type=type_hints["confidence_var"])
            check_type(argname="argument fail_gravity", value=fail_gravity, expected_type=type_hints["fail_gravity"])
            check_type(argname="argument fail_gravity_var", value=fail_gravity_var, expected_type=type_hints["fail_gravity_var"])
            check_type(argname="argument focus", value=focus, expected_type=type_hints["focus"])
            check_type(argname="argument focus_var", value=focus_var, expected_type=type_hints["focus_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if algorithm is not None:
            self._values["algorithm"] = algorithm
        if algorithm_var is not None:
            self._values["algorithm_var"] = algorithm_var
        if confidence is not None:
            self._values["confidence"] = confidence
        if confidence_var is not None:
            self._values["confidence_var"] = confidence_var
        if fail_gravity is not None:
            self._values["fail_gravity"] = fail_gravity
        if fail_gravity_var is not None:
            self._values["fail_gravity_var"] = fail_gravity_var
        if focus is not None:
            self._values["focus"] = focus
        if focus_var is not None:
            self._values["focus_var"] = focus_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def algorithm(self) -> typing.Optional[builtins.str]:
        '''Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm DataAkamaiImagingPolicyImage#algorithm}
        '''
        result = self._values.get("algorithm")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def algorithm_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm_var DataAkamaiImagingPolicyImage#algorithm_var}
        '''
        result = self._values.get("algorithm_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def confidence(self) -> typing.Optional[builtins.str]:
        '''With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image.

        Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence DataAkamaiImagingPolicyImage#confidence}
        '''
        result = self._values.get("confidence")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def confidence_var(self) -> typing.Optional[builtins.str]:
        '''With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image.

        Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence_var DataAkamaiImagingPolicyImage#confidence_var}
        '''
        result = self._values.get("confidence_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any faces in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        '''
        result = self._values.get("fail_gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any faces in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        '''
        result = self._values.get("fail_gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def focus(self) -> typing.Optional[builtins.str]:
        '''Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus DataAkamaiImagingPolicyImage#focus}
        '''
        result = self._values.get("focus")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def focus_var(self) -> typing.Optional[builtins.str]:
        '''Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus_var DataAkamaiImagingPolicyImage#focus_var}
        '''
        result = self._values.get("focus_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the face(s) plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the face(s) plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationFaceCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationFaceCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationFaceCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__974278d19e61428daaa372e2433b5927f8aad207c21faf2748e98255f2fb5698)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationFaceCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__24293bbbca96ac33fdd7f9de958381919dc2106119b556a582676300b904e357)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationFaceCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__00c01f4cdadd12ef8a722b3d76918412ac6c2f1743993c99a9fa90a0840e4e6c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__209c51e01d50d1dc5688cbee5588adfc3940ab4b3b99e03426343acc8dd15011)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f740ae8d18363143bc8d1b5dda59dd2fe1bfb1ccd8126460abc9f04361f52269)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationFaceCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationFaceCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationFaceCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5d0f92823f173c72d17c03330bd1194275cefd6519978606373cf63865393d7b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationFaceCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationFaceCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2b778a0df1cecdbe0d36ee9390685c66b36672fd01585ba4a630c9a351f92940)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAlgorithm")
    def reset_algorithm(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAlgorithm", []))

    @jsii.member(jsii_name="resetAlgorithmVar")
    def reset_algorithm_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAlgorithmVar", []))

    @jsii.member(jsii_name="resetConfidence")
    def reset_confidence(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetConfidence", []))

    @jsii.member(jsii_name="resetConfidenceVar")
    def reset_confidence_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetConfidenceVar", []))

    @jsii.member(jsii_name="resetFailGravity")
    def reset_fail_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravity", []))

    @jsii.member(jsii_name="resetFailGravityVar")
    def reset_fail_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravityVar", []))

    @jsii.member(jsii_name="resetFocus")
    def reset_focus(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFocus", []))

    @jsii.member(jsii_name="resetFocusVar")
    def reset_focus_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFocusVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="algorithmInput")
    def algorithm_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "algorithmInput"))

    @builtins.property
    @jsii.member(jsii_name="algorithmVarInput")
    def algorithm_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "algorithmVarInput"))

    @builtins.property
    @jsii.member(jsii_name="confidenceInput")
    def confidence_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "confidenceInput"))

    @builtins.property
    @jsii.member(jsii_name="confidenceVarInput")
    def confidence_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "confidenceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityInput")
    def fail_gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityVarInput")
    def fail_gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="focusInput")
    def focus_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "focusInput"))

    @builtins.property
    @jsii.member(jsii_name="focusVarInput")
    def focus_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "focusVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="algorithm")
    def algorithm(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "algorithm"))

    @algorithm.setter
    def algorithm(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df233c5e6d3ab32e397de5ee6b95b392d9fae4537118ffc3d1158fa930e2920d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "algorithm", value)

    @builtins.property
    @jsii.member(jsii_name="algorithmVar")
    def algorithm_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "algorithmVar"))

    @algorithm_var.setter
    def algorithm_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__695e54d411fa1f03ed633165ad41e9f154b1cd07a7c7c7b7fa9f577cd0862f23)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "algorithmVar", value)

    @builtins.property
    @jsii.member(jsii_name="confidence")
    def confidence(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "confidence"))

    @confidence.setter
    def confidence(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__698a29540095b4e0fb7c961fa59e7bacf3a6189b518ad87b6b5fde3ee93c220b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "confidence", value)

    @builtins.property
    @jsii.member(jsii_name="confidenceVar")
    def confidence_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "confidenceVar"))

    @confidence_var.setter
    def confidence_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7bf2c68c8228b05fe370df95b4fa6d85074c45b74973af106b7f4b5fd2a4fd22)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "confidenceVar", value)

    @builtins.property
    @jsii.member(jsii_name="failGravity")
    def fail_gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravity"))

    @fail_gravity.setter
    def fail_gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0185eac279ae33c416ea31184d59e3596fb412f39a1c292f903b6498d585ac5e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravity", value)

    @builtins.property
    @jsii.member(jsii_name="failGravityVar")
    def fail_gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravityVar"))

    @fail_gravity_var.setter
    def fail_gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1a1774b21406997d14456e8076c7dc1df52ddcf8de018efadfbb06dad8218f41)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="focus")
    def focus(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "focus"))

    @focus.setter
    def focus(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e08b8e47898e3a8129bd3665568507c19c8fc99077dabb10e42b68ce56b2c17d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "focus", value)

    @builtins.property
    @jsii.member(jsii_name="focusVar")
    def focus_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "focusVar"))

    @focus_var.setter
    def focus_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__15910beaeb09833a5148060d9cce48599da28d1cfc752c572a1612fbb8453ea0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "focusVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8f720f4363b6b9a46eead3e8bd26ba77f248779ae9e0b9fcc6b590fbc1810efb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__83bd614a5c881b4e8fffa5d42294488ba16ef659d44420a145c8cbf351bae3ed)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e83a5013d5414d41f5e8e28ba53db1d5a04c211418c7103f254a7994e4e7194b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7fff3e45c2d4cbb181bf424a1e9f1c7346f520102e460f99035d2670c5c9efea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af7d9ee1c9b8bffaa723a8d21b8c4299bb85fba061b78d03bfdb96ccf2257f68)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a6dad5ddb1146e44ee78e586f50d3664ed48f5fe02c5ecdbac042655c09ba0e4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c100c7a233f316696f9c7ae947165274b2ce19dfc6196083c06956c6c3cbfef8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c0625687f878628a4b7ed7f9b101f6e5543d69cf6f9600066a4e82958be43e66)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1e2cac64c80f2aeed370f4d5e87d5703fa07aec43e1e664157417c96bf40aef8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__877466f849429be92c35081cc52bef27118645ab93ba48403e81bed340b8d8b4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationFaceCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationFaceCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationFaceCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__889ac4a5c2915fe96fd697672a43e8d4154c09845ad0481e2ec4a6415e4112c1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationFeatureCrop",
    jsii_struct_bases=[],
    name_mapping={
        "fail_gravity": "failGravity",
        "fail_gravity_var": "failGravityVar",
        "feature_radius": "featureRadius",
        "feature_radius_var": "featureRadiusVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "max_features": "maxFeatures",
        "max_features_var": "maxFeaturesVar",
        "min_feature_quality": "minFeatureQuality",
        "min_feature_quality_var": "minFeatureQualityVar",
        "padding": "padding",
        "padding_var": "paddingVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationFeatureCrop:
    def __init__(
        self,
        *,
        fail_gravity: typing.Optional[builtins.str] = None,
        fail_gravity_var: typing.Optional[builtins.str] = None,
        feature_radius: typing.Optional[builtins.str] = None,
        feature_radius_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        max_features: typing.Optional[builtins.str] = None,
        max_features_var: typing.Optional[builtins.str] = None,
        min_feature_quality: typing.Optional[builtins.str] = None,
        min_feature_quality_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fail_gravity: Controls placement of the crop if Image and Video Manager does not detect any features in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        :param fail_gravity_var: Controls placement of the crop if Image and Video Manager does not detect any features in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        :param feature_radius: The size in pixels of the important features to search for. If identified, two features never appear closer together than this value, ``8.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius DataAkamaiImagingPolicyImage#feature_radius}
        :param feature_radius_var: The size in pixels of the important features to search for. If identified, two features never appear closer together than this value, ``8.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius_var DataAkamaiImagingPolicyImage#feature_radius_var}
        :param gravity: Controls placement of the crop. Directions are relative to the region of interest plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Controls placement of the crop. Directions are relative to the region of interest plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param max_features: The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features DataAkamaiImagingPolicyImage#max_features}
        :param max_features_var: The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features_var DataAkamaiImagingPolicyImage#max_features_var}
        :param min_feature_quality: Determines the minimum quality level of the feature identified. To consider a feature important, the feature needs to surpass this value. Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality DataAkamaiImagingPolicyImage#min_feature_quality}
        :param min_feature_quality_var: Determines the minimum quality level of the feature identified. To consider a feature important, the feature needs to surpass this value. Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality_var DataAkamaiImagingPolicyImage#min_feature_quality_var}
        :param padding: Adds space around the region of interest. The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: Adds space around the region of interest. The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        :param style: Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c6e4b1b50ab0b353f63d060bdaad2107656211722fca78341bd7991fa10f5597)
            check_type(argname="argument fail_gravity", value=fail_gravity, expected_type=type_hints["fail_gravity"])
            check_type(argname="argument fail_gravity_var", value=fail_gravity_var, expected_type=type_hints["fail_gravity_var"])
            check_type(argname="argument feature_radius", value=feature_radius, expected_type=type_hints["feature_radius"])
            check_type(argname="argument feature_radius_var", value=feature_radius_var, expected_type=type_hints["feature_radius_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument max_features", value=max_features, expected_type=type_hints["max_features"])
            check_type(argname="argument max_features_var", value=max_features_var, expected_type=type_hints["max_features_var"])
            check_type(argname="argument min_feature_quality", value=min_feature_quality, expected_type=type_hints["min_feature_quality"])
            check_type(argname="argument min_feature_quality_var", value=min_feature_quality_var, expected_type=type_hints["min_feature_quality_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fail_gravity is not None:
            self._values["fail_gravity"] = fail_gravity
        if fail_gravity_var is not None:
            self._values["fail_gravity_var"] = fail_gravity_var
        if feature_radius is not None:
            self._values["feature_radius"] = feature_radius
        if feature_radius_var is not None:
            self._values["feature_radius_var"] = feature_radius_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if max_features is not None:
            self._values["max_features"] = max_features
        if max_features_var is not None:
            self._values["max_features_var"] = max_features_var
        if min_feature_quality is not None:
            self._values["min_feature_quality"] = min_feature_quality
        if min_feature_quality_var is not None:
            self._values["min_feature_quality_var"] = min_feature_quality_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def fail_gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any features in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        '''
        result = self._values.get("fail_gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any features in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        '''
        result = self._values.get("fail_gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feature_radius(self) -> typing.Optional[builtins.str]:
        '''The size in pixels of the important features to search for.

        If identified, two features never appear closer together than this value, ``8.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius DataAkamaiImagingPolicyImage#feature_radius}
        '''
        result = self._values.get("feature_radius")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feature_radius_var(self) -> typing.Optional[builtins.str]:
        '''The size in pixels of the important features to search for.

        If identified, two features never appear closer together than this value, ``8.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius_var DataAkamaiImagingPolicyImage#feature_radius_var}
        '''
        result = self._values.get("feature_radius_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the region of interest plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the region of interest plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def max_features(self) -> typing.Optional[builtins.str]:
        '''The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features DataAkamaiImagingPolicyImage#max_features}
        '''
        result = self._values.get("max_features")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def max_features_var(self) -> typing.Optional[builtins.str]:
        '''The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features_var DataAkamaiImagingPolicyImage#max_features_var}
        '''
        result = self._values.get("max_features_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def min_feature_quality(self) -> typing.Optional[builtins.str]:
        '''Determines the minimum quality level of the feature identified.

        To consider a feature important, the feature needs to surpass this value.  Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality DataAkamaiImagingPolicyImage#min_feature_quality}
        '''
        result = self._values.get("min_feature_quality")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def min_feature_quality_var(self) -> typing.Optional[builtins.str]:
        '''Determines the minimum quality level of the feature identified.

        To consider a feature important, the feature needs to surpass this value.  Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality_var DataAkamaiImagingPolicyImage#min_feature_quality_var}
        '''
        result = self._values.get("min_feature_quality_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''Adds space around the region of interest.

        The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''Adds space around the region of interest.

        The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationFeatureCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationFeatureCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationFeatureCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cb7198de47332993892ba8e9f747cf929c9b4ae07b42a03228ac86545fa6c395)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationFeatureCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__74fecdbe66e9f5e76a48d35d51b9d0a9ab26961275131f9010900ca0110c31c8)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationFeatureCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d1dac18bd2ab699080a4ad83d3cce3620cd84a48a9da681d21a8d9bf7f8ba1f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f0fe2584d5778993c8eda32bcda8f98bed2c57de892fb27b92f25d825978f9e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__57aa49903ab2bb83efce1a7603e83b2ef8e6fc58aabf19b7bc65effdd7d7e3d2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationFeatureCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationFeatureCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationFeatureCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0a464633908f91c27240ba47448ef4ec6ffef915b06484e64373fda31df33624)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationFeatureCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationFeatureCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__585dfc3efe0bb16a729e336a59bed611b095921b17efb53ed07949fd80347bc9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetFailGravity")
    def reset_fail_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravity", []))

    @jsii.member(jsii_name="resetFailGravityVar")
    def reset_fail_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravityVar", []))

    @jsii.member(jsii_name="resetFeatureRadius")
    def reset_feature_radius(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureRadius", []))

    @jsii.member(jsii_name="resetFeatureRadiusVar")
    def reset_feature_radius_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureRadiusVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetMaxFeatures")
    def reset_max_features(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxFeatures", []))

    @jsii.member(jsii_name="resetMaxFeaturesVar")
    def reset_max_features_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxFeaturesVar", []))

    @jsii.member(jsii_name="resetMinFeatureQuality")
    def reset_min_feature_quality(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMinFeatureQuality", []))

    @jsii.member(jsii_name="resetMinFeatureQualityVar")
    def reset_min_feature_quality_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMinFeatureQualityVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="failGravityInput")
    def fail_gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityVarInput")
    def fail_gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featureRadiusInput")
    def feature_radius_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featureRadiusInput"))

    @builtins.property
    @jsii.member(jsii_name="featureRadiusVarInput")
    def feature_radius_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featureRadiusVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesInput")
    def max_features_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "maxFeaturesInput"))

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesVarInput")
    def max_features_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "maxFeaturesVarInput"))

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityInput")
    def min_feature_quality_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "minFeatureQualityInput"))

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityVarInput")
    def min_feature_quality_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "minFeatureQualityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravity")
    def fail_gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravity"))

    @fail_gravity.setter
    def fail_gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5145f01096755964dffe5d66f722f9703c3205910a75966af820e3d2a7bba45e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravity", value)

    @builtins.property
    @jsii.member(jsii_name="failGravityVar")
    def fail_gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravityVar"))

    @fail_gravity_var.setter
    def fail_gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a6b8c2077df76781abdd0156f1e4785c313ff8d1c6c35be2d59a07749889f816)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="featureRadius")
    def feature_radius(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featureRadius"))

    @feature_radius.setter
    def feature_radius(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bdf92a55e5cebb345a3fa6a9684d0538571f693d956bfb6d9d01f492a48fa9d3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featureRadius", value)

    @builtins.property
    @jsii.member(jsii_name="featureRadiusVar")
    def feature_radius_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featureRadiusVar"))

    @feature_radius_var.setter
    def feature_radius_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f909062f403fe3805c0e9fbfda71847198422c8bde5fe09ccc41afd56d796106)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featureRadiusVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ae2f1fca636cd44ee51129a24ceec0995c2f6f3a0fe0a2493d31a4619c565359)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c8a5196a5cdf011c5d2d22c7ceb3ab17cd2f27e7d46f4b7e342307f58c665027)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6ba104bc24910a1fcc21783462480eb97c423f5f969971e5537a5cd1760677d2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bbfea382fb4f00e6b13d8f18ed1a9ab3932262d979978ab9e1dfaff3d6087c21)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="maxFeatures")
    def max_features(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "maxFeatures"))

    @max_features.setter
    def max_features(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4f52f8308b7e27ae1d5202d367173127490f741087c0c766da3330550273b736)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "maxFeatures", value)

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesVar")
    def max_features_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "maxFeaturesVar"))

    @max_features_var.setter
    def max_features_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__902ca6af7bc19e7cb05b58e82328c459bd729ade466492c9064ec36eba94969e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "maxFeaturesVar", value)

    @builtins.property
    @jsii.member(jsii_name="minFeatureQuality")
    def min_feature_quality(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "minFeatureQuality"))

    @min_feature_quality.setter
    def min_feature_quality(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d65dbbca1f511a386523589587ce80a074a6044c85af87364d82905181a0e33e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "minFeatureQuality", value)

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityVar")
    def min_feature_quality_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "minFeatureQualityVar"))

    @min_feature_quality_var.setter
    def min_feature_quality_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__46b05752c091b34f82402da127e1b0f5408eb37adb04ac135ee8e3bcb576b94b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "minFeatureQualityVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c389e3cf5879c4608bc4eff2360dd4f578ca45908b5106cb123b30fa022e8923)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__91c40b4f5c159351580214a0a6e3b8f11e4734bcfe4477c46ff57c886b209fae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b5a81dc031d14321a65477b8384f2ce5b1c439ec21669d3f9218a2c1b03b18c4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__00e09db6d5d9e2c66681bc87e4519c6c91ac451a634fc4ccedca5976bb9840d6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea26dbea854a571865dbf13f75adcd731bc0cb2f88aafad022e464f0a9bbccf3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dc27a99d2fe6b7032aca1eb28058f081bfcbb75b85a93bce7d4c79a2efa8a89a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationFeatureCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationFeatureCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationFeatureCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa576968cf6511f3e88ed5ef54b94a9862982c75eb24669b07a5c3e20c12f25d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationFitAndFill",
    jsii_struct_bases=[],
    name_mapping={
        "fill_transformation": "fillTransformation",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationFitAndFill:
    def __init__(
        self,
        *,
        fill_transformation: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationFitAndFillFillTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fill_transformation: fill_transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_transformation DataAkamaiImagingPolicyImage#fill_transformation}
        :param height: The height value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The width value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(fill_transformation, dict):
            fill_transformation = DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationFitAndFillFillTransformation(**fill_transformation)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7ed46a9f80b434181808f9e919b9cfc79e984319add6ecc836fd2ae5b1e81f78)
            check_type(argname="argument fill_transformation", value=fill_transformation, expected_type=type_hints["fill_transformation"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fill_transformation is not None:
            self._values["fill_transformation"] = fill_transformation
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def fill_transformation(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationFitAndFillFillTransformation"]:
        '''fill_transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_transformation DataAkamaiImagingPolicyImage#fill_transformation}
        '''
        result = self._values.get("fill_transformation")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationFitAndFillFillTransformation"], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationFitAndFill(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationFitAndFillFillTransformation",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationFitAndFillFillTransformation:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationFitAndFillFillTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationFitAndFillFillTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationFitAndFillFillTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a30fd6ed83f84839f43cab610f5549ac5d060a9ad8164d02bbc9788b57e296e7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationFitAndFillFillTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationFitAndFillFillTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationFitAndFillFillTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2b4696ba7fd8738118029f1979852acdc623ee0c894c39bfbeff039f5c90c6ea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationFitAndFillList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationFitAndFillList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fc4218f4a2ed503bd169bc37a45d7089420d995d992bd1c23c1780f8d942a003)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationFitAndFillOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bf4236dd901dd9029c420d2455e2591b3907d477d39d2bf0ce6409e8d616db93)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationFitAndFillOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__31f856e663df2a49718f7a6a15c1ee2c683e84a3e7f85de370ebe8207814a725)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__13e1a7843cc8805dd588d74c49633482d2a50536f3ffdf73be5f8ff1a4b4dbdf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__93b6a51d97a4bcb1e5dd5ad70e4007b617a176b129a9359113319ee044cdf09c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationFitAndFill]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationFitAndFill]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationFitAndFill]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__42956a67fbc4ea1d1d78429bc27f79ae9082704b82ea36754563ae6c1f07b89c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationFitAndFillOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationFitAndFillOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9512a306b393435b6a841bd7f15e52bdb17ad20d59987f58c1c12b574fef92e5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putFillTransformation")
    def put_fill_transformation(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationFitAndFillFillTransformation()

        return typing.cast(None, jsii.invoke(self, "putFillTransformation", [value]))

    @jsii.member(jsii_name="resetFillTransformation")
    def reset_fill_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFillTransformation", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="fillTransformation")
    def fill_transformation(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationFitAndFillFillTransformationOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationFitAndFillFillTransformationOutputReference, jsii.get(self, "fillTransformation"))

    @builtins.property
    @jsii.member(jsii_name="fillTransformationInput")
    def fill_transformation_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationFitAndFillFillTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationFitAndFillFillTransformation], jsii.get(self, "fillTransformationInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e4214066cb1fba22b48a4077d52759b8a73a2e03d2b7b08e43bec69d044a9cad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4177e0c0d8567b989762da2d8a9c4323f188ed99fc759e0c7bf60c721df8083d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bebb4cb04c5cf4507361723e80b9333ddd6b8686c0d48318291c8d4f4c35936c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4aa3a6fa4a7318ab066a5d0c6a405deaca7bf4dabe8d6a9e9e73f49bcc3b58a1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationFitAndFill]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationFitAndFill]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationFitAndFill]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ae46f74ef4bde82f884f421e7d4953f7840a8b28bab37a78e6f653e4d790018b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationGoop",
    jsii_struct_bases=[],
    name_mapping={
        "chaos": "chaos",
        "chaos_var": "chaosVar",
        "density": "density",
        "density_var": "densityVar",
        "power": "power",
        "power_var": "powerVar",
        "seed": "seed",
        "seed_var": "seedVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationGoop:
    def __init__(
        self,
        *,
        chaos: typing.Optional[builtins.str] = None,
        chaos_var: typing.Optional[builtins.str] = None,
        density: typing.Optional[builtins.str] = None,
        density_var: typing.Optional[builtins.str] = None,
        power: typing.Optional[builtins.str] = None,
        power_var: typing.Optional[builtins.str] = None,
        seed: typing.Optional[builtins.str] = None,
        seed_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param chaos: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        :param chaos_var: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        :param density: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        :param density_var: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        :param power: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        :param power_var: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        :param seed: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        :param seed_var: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a1f5f874a5d3ec9bcebba011afaee069f62b33d356363ee39de49e9dff4606b)
            check_type(argname="argument chaos", value=chaos, expected_type=type_hints["chaos"])
            check_type(argname="argument chaos_var", value=chaos_var, expected_type=type_hints["chaos_var"])
            check_type(argname="argument density", value=density, expected_type=type_hints["density"])
            check_type(argname="argument density_var", value=density_var, expected_type=type_hints["density_var"])
            check_type(argname="argument power", value=power, expected_type=type_hints["power"])
            check_type(argname="argument power_var", value=power_var, expected_type=type_hints["power_var"])
            check_type(argname="argument seed", value=seed, expected_type=type_hints["seed"])
            check_type(argname="argument seed_var", value=seed_var, expected_type=type_hints["seed_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if chaos is not None:
            self._values["chaos"] = chaos
        if chaos_var is not None:
            self._values["chaos_var"] = chaos_var
        if density is not None:
            self._values["density"] = density
        if density_var is not None:
            self._values["density_var"] = density_var
        if power is not None:
            self._values["power"] = power
        if power_var is not None:
            self._values["power_var"] = power_var
        if seed is not None:
            self._values["seed"] = seed
        if seed_var is not None:
            self._values["seed_var"] = seed_var

    @builtins.property
    def chaos(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        '''
        result = self._values.get("chaos")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def chaos_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        '''
        result = self._values.get("chaos_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        '''
        result = self._values.get("density")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density_var(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        '''
        result = self._values.get("density_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        '''
        result = self._values.get("power")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power_var(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        '''
        result = self._values.get("power_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        '''
        result = self._values.get("seed")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed_var(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        result = self._values.get("seed_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationGoop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationGoopList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationGoopList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cb6fdd4a09531759d776000872da612461632d1ef063e17d9bb34a00ccde0434)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationGoopOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__02f42b04bc2f3a143e48df86cab38d44ae83b4537323a2d0421f5502bf422de0)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationGoopOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e95d5079e81bae2522130e182cc21133b1128fce8019dcd49a989660c9aab42c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__44c324fe1f5d7499268009d00fb0021b1be8335827e5ed684ff532ae701c4884)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e49ff221de92466543af18ef9d8622d35fead16b58b4b297019950422e28e613)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationGoop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationGoop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__75909a134fd3c46258221081fe7e2d6cd94c523574efa1b05dd0cd02004a33a8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationGoopOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationGoopOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__83b8493a5bce32fb3812306759555b70d6f7828a4b413d407f32bd9c7f8edc49)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetChaos")
    def reset_chaos(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaos", []))

    @jsii.member(jsii_name="resetChaosVar")
    def reset_chaos_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaosVar", []))

    @jsii.member(jsii_name="resetDensity")
    def reset_density(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensity", []))

    @jsii.member(jsii_name="resetDensityVar")
    def reset_density_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensityVar", []))

    @jsii.member(jsii_name="resetPower")
    def reset_power(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPower", []))

    @jsii.member(jsii_name="resetPowerVar")
    def reset_power_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPowerVar", []))

    @jsii.member(jsii_name="resetSeed")
    def reset_seed(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeed", []))

    @jsii.member(jsii_name="resetSeedVar")
    def reset_seed_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeedVar", []))

    @builtins.property
    @jsii.member(jsii_name="chaosInput")
    def chaos_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosInput"))

    @builtins.property
    @jsii.member(jsii_name="chaosVarInput")
    def chaos_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosVarInput"))

    @builtins.property
    @jsii.member(jsii_name="densityInput")
    def density_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityInput"))

    @builtins.property
    @jsii.member(jsii_name="densityVarInput")
    def density_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="powerInput")
    def power_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerInput"))

    @builtins.property
    @jsii.member(jsii_name="powerVarInput")
    def power_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerVarInput"))

    @builtins.property
    @jsii.member(jsii_name="seedInput")
    def seed_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedInput"))

    @builtins.property
    @jsii.member(jsii_name="seedVarInput")
    def seed_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedVarInput"))

    @builtins.property
    @jsii.member(jsii_name="chaos")
    def chaos(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaos"))

    @chaos.setter
    def chaos(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ca47302c7e56588c91653d926740e16cb3b67158297b64f2d3ce0ba4030f239e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaos", value)

    @builtins.property
    @jsii.member(jsii_name="chaosVar")
    def chaos_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaosVar"))

    @chaos_var.setter
    def chaos_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__65a8c8174716122986a4e216504beecc3ff40879e7a154700812f991a9cda850)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaosVar", value)

    @builtins.property
    @jsii.member(jsii_name="density")
    def density(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "density"))

    @density.setter
    def density(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7fa58835992ea2028a0c74e8b42bc06cbe45c693ba2aa096b0157165ba466eba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "density", value)

    @builtins.property
    @jsii.member(jsii_name="densityVar")
    def density_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "densityVar"))

    @density_var.setter
    def density_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4aa54725033298ecf56990fd31eb2e6c66d6220cdef468a592021430c0cf6fcb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "densityVar", value)

    @builtins.property
    @jsii.member(jsii_name="power")
    def power(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "power"))

    @power.setter
    def power(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f5fe7f558908dd0992c8d3ad83a48e2c0063f36d778259a3038de5c1c393a175)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "power", value)

    @builtins.property
    @jsii.member(jsii_name="powerVar")
    def power_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "powerVar"))

    @power_var.setter
    def power_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0308aa91a5c4375948d0e400a4186408c6982f9603e8749ebc9eab2a4552adf6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "powerVar", value)

    @builtins.property
    @jsii.member(jsii_name="seed")
    def seed(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seed"))

    @seed.setter
    def seed(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a0cd848c1b341e234d84682ae6ca2d8908e6cf6e1087386361e61175616fc38)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seed", value)

    @builtins.property
    @jsii.member(jsii_name="seedVar")
    def seed_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seedVar"))

    @seed_var.setter
    def seed_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8bf3725a01fc29d40b4cddf886d985a1016099f1bd0d2c1a1e27d12801c3dbf8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seedVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationGoop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationGoop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationGoop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e489382ee43cb88d5ec63403b01d77f1cbc94fbc9ec3f3a04f70301b5ea5a170)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationGrayscale",
    jsii_struct_bases=[],
    name_mapping={"type": "type", "type_var": "typeVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationGrayscale:
    def __init__(
        self,
        *,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param type: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aebdff91e0b79e8caa781f36f8d64c35b7a3f7df288857067362097393b1f0fc)
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationGrayscale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationGrayscaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationGrayscaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__540a4f4d9fba77bc116d589f16185020e275e229d660becb42ab46a279a88457)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationGrayscaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__864fe51f6e2393418c4b64280db9ddcd55931e93b20fc51adc69dec4f2920ff3)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationGrayscaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a4e4149d5b222b76774038d5d267cad03f79c1597f10ef187bf960a431e89db8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7bb60dc3460ff32c16998fbf4cbe713d60267f23699fed92c309ea215beb7973)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__59da27a7f02de4ea93379e5c3f9c8c7f32b380f9e8ab18123da3171aa05037b0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationGrayscale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationGrayscale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b4dc442e43ed6ac41d0ed6a3227319ad7786420f0afa6f5b52195f915043476a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationGrayscaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationGrayscaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9f566769f1a208c1ad50fe65b7b01761fc028c7fb8fe341625344885544fd9ce)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3eee9cd7f8bfbdbf0544091f4735f3027bcd5cd7a961e9dc3c7c6a9c5aab0c09)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f7c389c8ee58f0ffdcbb1dc6d3693a69709a8d7b87378031e6d0a2af3b3773e9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationGrayscale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationGrayscale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationGrayscale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7ea7167c813a550ebe4343906adefc5cdb47b938bd5bbbd175c8b8cb4469470a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationHsl",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "lightness": "lightness",
        "lightness_var": "lightnessVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationHsl:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness: typing.Optional[builtins.str] = None,
        lightness_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        :param lightness_var: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b7f4b4eaae12d584e954e7ea6a43d52596080b7a14eb71c1c8e2756760fde02a)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness", value=lightness, expected_type=type_hints["lightness"])
            check_type(argname="argument lightness_var", value=lightness_var, expected_type=type_hints["lightness_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness is not None:
            self._values["lightness"] = lightness
        if lightness_var is not None:
            self._values["lightness_var"] = lightness_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        '''
        result = self._values.get("lightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        '''
        result = self._values.get("lightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationHsl(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationHslList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationHslList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8f82f92cb892cfdf3fb61a1e4d496595f8a8aac03c1c6d24acbb0821983b2d5d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationHslOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dfa8c0f6e41e6266c49aca40410a58e486096d604511a5c6366f4b0073fd506b)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationHslOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__09c6ed311be25833ac0d0d07bc9229603ba211b12a3ee353722c6fe5c6bf0115)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ade54b9ca5943dd8a2d3c11dd7c7e696166357d2e1b8f5ecfa047e6c3679a382)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__40b567d106f8e77c9bb729264a37ad42f17b91008991c61c58d730158d63511d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationHsl]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationHsl]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6197938336fc793ef9ed1ef6183ed696a6e2fae5c87dd4b0665b6298135c755f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationHslOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationHslOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eb6081a1a8a70c7e76fa06e77f624e58f43bf4899efebb92a6251775cbc16c99)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightness")
    def reset_lightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightness", []))

    @jsii.member(jsii_name="resetLightnessVar")
    def reset_lightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessInput")
    def lightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessVarInput")
    def lightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0d91cff179e49f3f26627e1c7a9675d4fcbbdfb94a72f6c0b78c6b80d46c1ac5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__55dbf2a522d64927bf55964a1a34fbe683e8a7de0e53cd61b83725c6d8948f53)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightness")
    def lightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightness"))

    @lightness.setter
    def lightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__00aa4dea4d82b1f8d88e21188f59b99720a9e71c0a006de824a735d54165c254)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightness", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessVar")
    def lightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessVar"))

    @lightness_var.setter
    def lightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c365a0bc5da37bec645d4c664c0bf15f1a537d0bf60e398bdb31267a79e57064)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__03fb5eb2c8a4ccd9847fdf4e93cd59c66f841920583eb7e406597ac146120054)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d4ce46c9b160a22034d4c1acf7af66edf74128d86ab6599a83a881f1fc555b89)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationHsl]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationHsl]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationHsl]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2f46b04a35aec68f74e3a32e792010fde18fc53dac2198be180518a87e490499)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationHsv",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationHsv:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        :param value: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b25e85fb412c4b0d76eee320e0f09f941232653c89d832292bd619baf81dccbf)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationHsv(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationHsvList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationHsvList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c037b4d22a0a4ac646de1cb0c7acf5025338702209b230462ecad4e85056eac9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationHsvOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__feefb6f0c0ce9045fa9b7d441d2d7529ce0a1374911c2b609bb3c3eaf2755768)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationHsvOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b24c01be9ef9ff2eeb974bca1d7a53119622c52a2d12b1887bd5af5c08861a33)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__03434cbcb8afc776ee7aed7bc157fe1faefe2ffa631ac9b857a3e8b0f29b19a0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3597d9d9d1c878cb08ccf5220c2cf67ffc9af1d0e34c976f3880e34a7286c9d2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationHsv]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationHsv]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0abb127c77a05ac7192cd12b5ee869cca33f4f07e65d521e776c5d90f102e300)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationHsvOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationHsvOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3dd230cbf23608ad65b347b4e609ba9abb478844dc8a14a9ed3551093e43c4b9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ae536a7cdeaac244c87aeb6c8c385808652218d566f9f10ad230ff409b28cd4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__89e481c45c767a6d4a5240a7e022041e962ee05c4aebe23ef8633c0d25e1bdd9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f6f925e3e0e28211f27ec52c4b92cb983e12f9247d0d7695e42d38156f4ec14)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__77b653c81419336fb85e06b356ee2f36c33f45d1876ad0167d79c8bff99b307b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e4159d1f493c03dd92b089fe1b6c5181b21614228932b1b404d98bde0cde68f4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__627e49f62ea3ab8a1a99fcbbafee21b584894162b56633c33f726944e4d0d5c8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationHsv]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationHsv]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationHsv]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bbf9a9a847e1e257c0ce43dcd967c22b0e9416f836680b532dee62161de8d346)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfDimension",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "dimension": "dimension",
        "dimension_var": "dimensionVar",
        "equal": "equal",
        "greater_than": "greaterThan",
        "less_than": "lessThan",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfDimension:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfDimensionDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        dimension: typing.Optional[builtins.str] = None,
        dimension_var: typing.Optional[builtins.str] = None,
        equal: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfDimensionEqual", typing.Dict[builtins.str, typing.Any]]] = None,
        greater_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfDimensionGreaterThan", typing.Dict[builtins.str, typing.Any]]] = None,
        less_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfDimensionLessThan", typing.Dict[builtins.str, typing.Any]]] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param dimension: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        :param dimension_var: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        :param equal: equal block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        :param greater_than: greater_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        :param less_than: less_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        :param value: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfDimensionDefault(**default)
        if isinstance(equal, dict):
            equal = DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfDimensionEqual(**equal)
        if isinstance(greater_than, dict):
            greater_than = DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfDimensionGreaterThan(**greater_than)
        if isinstance(less_than, dict):
            less_than = DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfDimensionLessThan(**less_than)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3375b728c8384d02b79fa4baf92ae3aa192451666fd681404a1e1b33b4cac241)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument dimension", value=dimension, expected_type=type_hints["dimension"])
            check_type(argname="argument dimension_var", value=dimension_var, expected_type=type_hints["dimension_var"])
            check_type(argname="argument equal", value=equal, expected_type=type_hints["equal"])
            check_type(argname="argument greater_than", value=greater_than, expected_type=type_hints["greater_than"])
            check_type(argname="argument less_than", value=less_than, expected_type=type_hints["less_than"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if dimension is not None:
            self._values["dimension"] = dimension
        if dimension_var is not None:
            self._values["dimension_var"] = dimension_var
        if equal is not None:
            self._values["equal"] = equal
        if greater_than is not None:
            self._values["greater_than"] = greater_than
        if less_than is not None:
            self._values["less_than"] = less_than
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfDimensionDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfDimensionDefault"], result)

    @builtins.property
    def dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        '''
        result = self._values.get("dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        '''
        result = self._values.get("dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def equal(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfDimensionEqual"]:
        '''equal block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        '''
        result = self._values.get("equal")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfDimensionEqual"], result)

    @builtins.property
    def greater_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfDimensionGreaterThan"]:
        '''greater_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        '''
        result = self._values.get("greater_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfDimensionGreaterThan"], result)

    @builtins.property
    def less_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfDimensionLessThan"]:
        '''less_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        '''
        result = self._values.get("less_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfDimensionLessThan"], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfDimension(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfDimensionDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfDimensionDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfDimensionDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfDimensionDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfDimensionDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4cd4e81bab1f229f6fada9d3316016a0fd1d72a1777e0adb229f8e32502e75bd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfDimensionDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfDimensionDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a7c84a3323fd2abaa716d82fca810172e339f02cf5df7973b4c1824ab13ca725)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfDimensionEqual",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfDimensionEqual:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfDimensionEqual(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfDimensionEqualOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfDimensionEqualOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__873672a5edcf551eb1aa34c5bbb95749b1e4ecbe978ae34721f5701ce6e51102)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfDimensionEqual], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfDimensionEqual],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b95941e9ee29446af058c4c932d233a03e347bb9ae87412d438606cd42af603d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfDimensionGreaterThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfDimensionGreaterThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfDimensionGreaterThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfDimensionGreaterThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfDimensionGreaterThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f1aa8715a145c82cf751a31b362cd9e2bd901fc6971569592a66dc3c93e6a1a3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfDimensionGreaterThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfDimensionGreaterThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0caa24dc97eb18a95486da3094d93bead7e2379a4e7f3e1c93053aa27d9ff2f9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfDimensionLessThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfDimensionLessThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfDimensionLessThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfDimensionLessThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfDimensionLessThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__07e3eb3aaa31e727b878605ef04d26f4d751fea3aeda234ed1b293f68cd5f6cd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfDimensionLessThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfDimensionLessThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3fad04492175a188d115cc1581d3d4e9073bda88572b0340f1c9f3cbf31e3607)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfDimensionList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfDimensionList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2dd950ab0253d035a35cdbb7675d88953fb503411420f6ac3fc95008cdefb04f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfDimensionOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c3b9a770d1a8674b954fe17f47d4ac3bc5e58be58a21ac9675b9c14425be57b8)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfDimensionOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ea8d63cdcd129391ac05fb96bbacbde3de53ef07aece28541ff6921e007398a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1034aa5b6c142cb3525c4ff0bcbcf36cfc639abc35ed40aac04bf32377921282)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1d0f7722aeafe6e30c5fa09a0ea5740b93de6f2c8c435e56be0c80da37b0f659)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfDimension]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfDimension]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c107930c3dfb6846672c5755122f511b1d8d5db21a8c8e048f686d905fdd20f7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfDimensionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfDimensionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__76c60d085ee37487e638d3f5902a6cb8fc2b4cbb84242ef8c321d02dba4367ae)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfDimensionDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putEqual")
    def put_equal(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfDimensionEqual()

        return typing.cast(None, jsii.invoke(self, "putEqual", [value]))

    @jsii.member(jsii_name="putGreaterThan")
    def put_greater_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfDimensionGreaterThan()

        return typing.cast(None, jsii.invoke(self, "putGreaterThan", [value]))

    @jsii.member(jsii_name="putLessThan")
    def put_less_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfDimensionLessThan()

        return typing.cast(None, jsii.invoke(self, "putLessThan", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetDimension")
    def reset_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimension", []))

    @jsii.member(jsii_name="resetDimensionVar")
    def reset_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimensionVar", []))

    @jsii.member(jsii_name="resetEqual")
    def reset_equal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEqual", []))

    @jsii.member(jsii_name="resetGreaterThan")
    def reset_greater_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGreaterThan", []))

    @jsii.member(jsii_name="resetLessThan")
    def reset_less_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLessThan", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfDimensionDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfDimensionDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="equal")
    def equal(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfDimensionEqualOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfDimensionEqualOutputReference, jsii.get(self, "equal"))

    @builtins.property
    @jsii.member(jsii_name="greaterThan")
    def greater_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfDimensionGreaterThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfDimensionGreaterThanOutputReference, jsii.get(self, "greaterThan"))

    @builtins.property
    @jsii.member(jsii_name="lessThan")
    def less_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfDimensionLessThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfDimensionLessThanOutputReference, jsii.get(self, "lessThan"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfDimensionDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionInput")
    def dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionVarInput")
    def dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="equalInput")
    def equal_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfDimensionEqual], jsii.get(self, "equalInput"))

    @builtins.property
    @jsii.member(jsii_name="greaterThanInput")
    def greater_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfDimensionGreaterThan], jsii.get(self, "greaterThanInput"))

    @builtins.property
    @jsii.member(jsii_name="lessThanInput")
    def less_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfDimensionLessThan], jsii.get(self, "lessThanInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="dimension")
    def dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimension"))

    @dimension.setter
    def dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__71a639dad04c13e60ee50ba56aaa3344c44f0b271460aec7e269877be23b7f8b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimension", value)

    @builtins.property
    @jsii.member(jsii_name="dimensionVar")
    def dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimensionVar"))

    @dimension_var.setter
    def dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__169a9fc2091c8b1bf177f496238b694f0acfc841fd4d21e1a9e19652c82666bf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__830053a5130cccfdae5ed49714c575838e7edc59cd2c15cde935086ea59f29fa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d54022d88e860ef9a11f70f56c5dc2868caf5d7bdb306079520a4147af9fc37c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfDimension]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfDimension]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfDimension]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__771d348270d0f0eea02d9ff3b3b34bb5a63abda8db58467b7a877ab3297268aa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfOrientation",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "landscape": "landscape",
        "portrait": "portrait",
        "square": "square",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfOrientation:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfOrientationDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        landscape: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfOrientationLandscape", typing.Dict[builtins.str, typing.Any]]] = None,
        portrait: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfOrientationPortrait", typing.Dict[builtins.str, typing.Any]]] = None,
        square: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfOrientationSquare", typing.Dict[builtins.str, typing.Any]]] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param landscape: landscape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        :param portrait: portrait block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        :param square: square block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfOrientationDefault(**default)
        if isinstance(landscape, dict):
            landscape = DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfOrientationLandscape(**landscape)
        if isinstance(portrait, dict):
            portrait = DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfOrientationPortrait(**portrait)
        if isinstance(square, dict):
            square = DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfOrientationSquare(**square)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b8934af39b7425c15e7283000d28da2ef54a49c2e31b69879b683986f334c57d)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument landscape", value=landscape, expected_type=type_hints["landscape"])
            check_type(argname="argument portrait", value=portrait, expected_type=type_hints["portrait"])
            check_type(argname="argument square", value=square, expected_type=type_hints["square"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if landscape is not None:
            self._values["landscape"] = landscape
        if portrait is not None:
            self._values["portrait"] = portrait
        if square is not None:
            self._values["square"] = square

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfOrientationDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfOrientationDefault"], result)

    @builtins.property
    def landscape(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfOrientationLandscape"]:
        '''landscape block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        '''
        result = self._values.get("landscape")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfOrientationLandscape"], result)

    @builtins.property
    def portrait(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfOrientationPortrait"]:
        '''portrait block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        '''
        result = self._values.get("portrait")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfOrientationPortrait"], result)

    @builtins.property
    def square(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfOrientationSquare"]:
        '''square block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        result = self._values.get("square")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfOrientationSquare"], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfOrientation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfOrientationDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfOrientationDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfOrientationDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfOrientationDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfOrientationDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d929339da189f1e2f8aa60cfaac9249516e16cf87d01c490aaca66bc737e905f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfOrientationDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfOrientationDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ed9549ea040e0dad25f181e11294767f8ffb42a5d8b24974eb21b013a3eb1f11)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfOrientationLandscape",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfOrientationLandscape:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfOrientationLandscape(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfOrientationLandscapeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfOrientationLandscapeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eb563af5c4ae917709bfffedcc36522ab8e54369306aa6ff02199c4c18adacf0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfOrientationLandscape], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfOrientationLandscape],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__84e2404bc76d4227b9a8eafe6cd87a0399a0f11ba52dd69766e3047ecd777a8e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfOrientationList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfOrientationList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d67a879089a0727eab9c8852a9593763cce0cec888c4d65457afedf25dd465e6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfOrientationOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__655f0c9f563e4ff2cfb0d6721bb5338a1c881b709c056f9bf45d3f2b5eea1ecc)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfOrientationOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__98a72e32166178c4436292f6c9ce450eda751de160b3a79ce8b83e9c1a3aebb1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d2fd7630425cf41f479020d126cdc985b9fc793326196175a6a5cb839f3d56dc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__15cc78e8f3d9542d9c697c3753d426fe1315c032bc8e6f26a40d98f4c560c480)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfOrientation]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfOrientation]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2cfb231b93f1315939ef62c023f3ea6861caaec745d2826aefed8c4f6d597ada)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfOrientationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfOrientationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c6d1e410b71abcb37572e8a6772f08885257672ba9e18d4055030caa0e0c2f82)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfOrientationDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putLandscape")
    def put_landscape(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfOrientationLandscape()

        return typing.cast(None, jsii.invoke(self, "putLandscape", [value]))

    @jsii.member(jsii_name="putPortrait")
    def put_portrait(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfOrientationPortrait()

        return typing.cast(None, jsii.invoke(self, "putPortrait", [value]))

    @jsii.member(jsii_name="putSquare")
    def put_square(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfOrientationSquare()

        return typing.cast(None, jsii.invoke(self, "putSquare", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetLandscape")
    def reset_landscape(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLandscape", []))

    @jsii.member(jsii_name="resetPortrait")
    def reset_portrait(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPortrait", []))

    @jsii.member(jsii_name="resetSquare")
    def reset_square(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSquare", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfOrientationDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfOrientationDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="landscape")
    def landscape(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfOrientationLandscapeOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfOrientationLandscapeOutputReference, jsii.get(self, "landscape"))

    @builtins.property
    @jsii.member(jsii_name="portrait")
    def portrait(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfOrientationPortraitOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfOrientationPortraitOutputReference", jsii.get(self, "portrait"))

    @builtins.property
    @jsii.member(jsii_name="square")
    def square(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfOrientationSquareOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfOrientationSquareOutputReference", jsii.get(self, "square"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfOrientationDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="landscapeInput")
    def landscape_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfOrientationLandscape], jsii.get(self, "landscapeInput"))

    @builtins.property
    @jsii.member(jsii_name="portraitInput")
    def portrait_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfOrientationPortrait"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfOrientationPortrait"], jsii.get(self, "portraitInput"))

    @builtins.property
    @jsii.member(jsii_name="squareInput")
    def square_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfOrientationSquare"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfOrientationSquare"], jsii.get(self, "squareInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfOrientation]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfOrientation]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfOrientation]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__75fbfa3ddfdcdc25876cd0b2f8dd9eac1cd288b2c53b350ce5279aafe7da6435)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfOrientationPortrait",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfOrientationPortrait:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfOrientationPortrait(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfOrientationPortraitOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfOrientationPortraitOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cea2344d0dbfea201c4f689ad1eb0a52207c5042e460e6945b4f4033ec67044d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfOrientationPortrait]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfOrientationPortrait], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfOrientationPortrait],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2515f9eea1d5db7589a4a933fcfb84023f6fc1f3c064a7b423421406d51a99c6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfOrientationSquare",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfOrientationSquare:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfOrientationSquare(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfOrientationSquareOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfOrientationSquareOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af95f25bcd941f1c7dcb48852a398da6b01b8dc28f33a2423f57e5ab5eecb31a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfOrientationSquare]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfOrientationSquare], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfOrientationSquare],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2699712642f13ba410d5673d0155e821d72d66ad73fc1043e2f443dbbb7f25cc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationImQuery",
    jsii_struct_bases=[],
    name_mapping={
        "allowed_transformations": "allowedTransformations",
        "query_var": "queryVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationImQuery:
    def __init__(
        self,
        *,
        allowed_transformations: typing.Sequence[builtins.str],
        query_var: builtins.str,
    ) -> None:
        '''
        :param allowed_transformations: Specifies the transformations that can be applied using the query string parameter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allowed_transformations DataAkamaiImagingPolicyImage#allowed_transformations}
        :param query_var: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#query_var DataAkamaiImagingPolicyImage#query_var}.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b87de97123f5e3f31fa85450823cfc6163ca98b667d45278fe4ee8d32ee23d68)
            check_type(argname="argument allowed_transformations", value=allowed_transformations, expected_type=type_hints["allowed_transformations"])
            check_type(argname="argument query_var", value=query_var, expected_type=type_hints["query_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "allowed_transformations": allowed_transformations,
            "query_var": query_var,
        }

    @builtins.property
    def allowed_transformations(self) -> typing.List[builtins.str]:
        '''Specifies the transformations that can be applied using the query string parameter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allowed_transformations DataAkamaiImagingPolicyImage#allowed_transformations}
        '''
        result = self._values.get("allowed_transformations")
        assert result is not None, "Required property 'allowed_transformations' is missing"
        return typing.cast(typing.List[builtins.str], result)

    @builtins.property
    def query_var(self) -> builtins.str:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#query_var DataAkamaiImagingPolicyImage#query_var}.'''
        result = self._values.get("query_var")
        assert result is not None, "Required property 'query_var' is missing"
        return typing.cast(builtins.str, result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationImQuery(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationImQueryList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationImQueryList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab60bde9291229336db93e76fdad2c7a8c1ee58408998504c8fc9589d14c14a4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationImQueryOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ff54eb6fc07b109ceb3d6e18f833312af0b90bda46d9d3a1446c5a440883284)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationImQueryOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__39705cdb4f510c7913f69221f80735dd31fe0a5383a2b40362c42f230b696580)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__09537a663213ed34b79f9c61a9c904737c4dbd4f712b556e2ced17e3cedb0293)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a70c2cc66ffed624707df49889d6b6801152ca83e1c08f1d1a6eda37f2109d95)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationImQuery]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationImQuery]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationImQuery]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0968aa500a63a7a9467b61b73c476fd75e4095f1354319fc1c7e3cceecec21a5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationImQueryOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationImQueryOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ed4968e70b8ec865473b56f4269da34d704d982f09f8fd384a4030beef771617)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @builtins.property
    @jsii.member(jsii_name="allowedTransformationsInput")
    def allowed_transformations_input(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "allowedTransformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="queryVarInput")
    def query_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "queryVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowedTransformations")
    def allowed_transformations(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "allowedTransformations"))

    @allowed_transformations.setter
    def allowed_transformations(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__427203b87f1406d505c9ab241f8ca696adb353afb66bd80124303b50c9917e95)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowedTransformations", value)

    @builtins.property
    @jsii.member(jsii_name="queryVar")
    def query_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "queryVar"))

    @query_var.setter
    def query_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c1fd9a25d6ced651eeddb6c7156fe0134735df8a413d571d19123a1e28b7a5de)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "queryVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationImQuery]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationImQuery]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationImQuery]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df9bbf3543168f874326341944fa567884b48ab82fe52031ec678bf42ce1cfdf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationMaxColors",
    jsii_struct_bases=[],
    name_mapping={"colors": "colors", "colors_var": "colorsVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationMaxColors:
    def __init__(
        self,
        *,
        colors: typing.Optional[builtins.str] = None,
        colors_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param colors: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        :param colors_var: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__38c17947830ddd2d5044b163efa4918282a70d409f2f9723d82a375e156c1ad5)
            check_type(argname="argument colors", value=colors, expected_type=type_hints["colors"])
            check_type(argname="argument colors_var", value=colors_var, expected_type=type_hints["colors_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if colors is not None:
            self._values["colors"] = colors
        if colors_var is not None:
            self._values["colors_var"] = colors_var

    @builtins.property
    def colors(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        '''
        result = self._values.get("colors")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def colors_var(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        result = self._values.get("colors_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationMaxColors(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationMaxColorsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationMaxColorsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5c03dbbc5b6aaeb1a4d9c31c5d1a6ab35c6315a1686356de152965beffa02416)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationMaxColorsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__91b9abf3fbed85d5b043563f42c2078ffa81bfa6faa32e8f0e21728169ccf9f5)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationMaxColorsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a7e8ed4bd77b41c39372aaf28eca26a1c026e559c835069c434b82a2e2d52ec8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bafd93c2e0b9c1c8b186fc8c185c1b03bc28b840b8b2d6ea619d1b66efe9fad4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a17bc6a647a8332179293b42bee0b97b6ad4c53633ee0009060d3bafe9cf9ee5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationMaxColors]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationMaxColors]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3f93bb8a06e5714739910013e4e7b35885259248b6481201c70ef7ff38ffeac0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationMaxColorsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationMaxColorsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a028f28692e26bad8782e95647611d552bcedb6eefd23c62161fefb8f60f5273)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColors")
    def reset_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColors", []))

    @jsii.member(jsii_name="resetColorsVar")
    def reset_colors_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorsVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorsInput")
    def colors_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsInput"))

    @builtins.property
    @jsii.member(jsii_name="colorsVarInput")
    def colors_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsVarInput"))

    @builtins.property
    @jsii.member(jsii_name="colors")
    def colors(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colors"))

    @colors.setter
    def colors(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d7eb89f88a0963ec8963386c339cf0df8eec47f2b3e94c3abd8dbbca4b90b853)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colors", value)

    @builtins.property
    @jsii.member(jsii_name="colorsVar")
    def colors_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorsVar"))

    @colors_var.setter
    def colors_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2beb097210a8070ea80f2ee2d570f5f0c570a822305e1794ccbdf6a583d4d421)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorsVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationMaxColors]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationMaxColors]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationMaxColors]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__22db725c2e2465b9afc4214a9c39619a1b16cae793c6f615787057b2be782bbf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationMirror",
    jsii_struct_bases=[],
    name_mapping={
        "horizontal": "horizontal",
        "horizontal_var": "horizontalVar",
        "vertical": "vertical",
        "vertical_var": "verticalVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationMirror:
    def __init__(
        self,
        *,
        horizontal: typing.Optional[builtins.str] = None,
        horizontal_var: typing.Optional[builtins.str] = None,
        vertical: typing.Optional[builtins.str] = None,
        vertical_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param horizontal: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        :param horizontal_var: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        :param vertical: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        :param vertical_var: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8afb233fe1d9746c3ebae4b889269b50b8db1b54c2e9474796d541ad4192e9cf)
            check_type(argname="argument horizontal", value=horizontal, expected_type=type_hints["horizontal"])
            check_type(argname="argument horizontal_var", value=horizontal_var, expected_type=type_hints["horizontal_var"])
            check_type(argname="argument vertical", value=vertical, expected_type=type_hints["vertical"])
            check_type(argname="argument vertical_var", value=vertical_var, expected_type=type_hints["vertical_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if horizontal is not None:
            self._values["horizontal"] = horizontal
        if horizontal_var is not None:
            self._values["horizontal_var"] = horizontal_var
        if vertical is not None:
            self._values["vertical"] = vertical
        if vertical_var is not None:
            self._values["vertical_var"] = vertical_var

    @builtins.property
    def horizontal(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        '''
        result = self._values.get("horizontal")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def horizontal_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        '''
        result = self._values.get("horizontal_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        '''
        result = self._values.get("vertical")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        result = self._values.get("vertical_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationMirror(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationMirrorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationMirrorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2dd1260d8775f9c0c2023e2a7523574dd680ed9ac78af6474b1e0fd7a1f3afde)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationMirrorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1a92318186c4764f8a0445d6cecccfe09c0170f4101597a2044bfec181fc02d5)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationMirrorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5a77419b9d0307586995c407b81f810d347ac1f2d734e25cdc27f7319608ef7b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c154b239d6d7234adaeec10091a908fc7167bcab1b22ef3f6e8e7557d43c1485)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a741f819215646654d17af7c98ef95ecb218995714910e5a16b06211562535e3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationMirror]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationMirror]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1173dd52d81c554e8d0f0bcb5cb10a30e811df0669c0f1ebf0329d912a35f1cb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationMirrorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationMirrorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a2b8efba80be7b18df405c01a17342e3e30859be81c71df28c38abcddf35b51f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHorizontal")
    def reset_horizontal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontal", []))

    @jsii.member(jsii_name="resetHorizontalVar")
    def reset_horizontal_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontalVar", []))

    @jsii.member(jsii_name="resetVertical")
    def reset_vertical(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVertical", []))

    @jsii.member(jsii_name="resetVerticalVar")
    def reset_vertical_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVerticalVar", []))

    @builtins.property
    @jsii.member(jsii_name="horizontalInput")
    def horizontal_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontalVarInput")
    def horizontal_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalInput")
    def vertical_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalVarInput")
    def vertical_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontal")
    def horizontal(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontal"))

    @horizontal.setter
    def horizontal(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4f7bd437305bed0a93841e10b709cd4b5fe46062718710a603951f96a6d1758a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontal", value)

    @builtins.property
    @jsii.member(jsii_name="horizontalVar")
    def horizontal_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontalVar"))

    @horizontal_var.setter
    def horizontal_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__60e0e1a4ef0399531f2190407ee9e8d441309c903ee2f80e84af4044a8260026)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontalVar", value)

    @builtins.property
    @jsii.member(jsii_name="vertical")
    def vertical(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "vertical"))

    @vertical.setter
    def vertical(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e8d19a75c2ac59e36772cffd0a6dcfdb6318e2ac580a8e38d6502fb045ce2cf1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "vertical", value)

    @builtins.property
    @jsii.member(jsii_name="verticalVar")
    def vertical_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "verticalVar"))

    @vertical_var.setter
    def vertical_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be69e2958da06f7e8797113e15b130f6cb477a7d3b7948353a5e46a5921cdbff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "verticalVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationMirror]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationMirror]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationMirror]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__77565c4be52b2f7cfd75ab36b05749f50fd516eb662a20a77b235e763f043356)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationMonoHue",
    jsii_struct_bases=[],
    name_mapping={"hue": "hue", "hue_var": "hueVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationMonoHue:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c6d24c4df3310feb06e041394b77d5db06738a60f7346d1935df6e75c8a476e9)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationMonoHue(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationMonoHueList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationMonoHueList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a6cca37522c4f057dbc860c3831087b82263c67bf3cac13a528aa9ac7ae2b98e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationMonoHueOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5517732c00733fff93268b89ad3d386bf8e91ff3eb1cb3f741d6f06cf35429fe)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationMonoHueOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bf4c1670083700912234f893788c7b115f13aa4f94972551db6dba8889d35fdb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ca860012b7c66741d5ac368be49f968c35063e0255be082872ec7e5605d95a8f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__02303abab80998254d80e0b29519c93a3526a156b0581504fb19fbbfe9b7f6f0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationMonoHue]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationMonoHue]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__271e31cf57288235eda145d89c7eecb6444ddd9c6cf8ecd3fcadc4302d2feb6a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationMonoHueOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationMonoHueOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cdd884c3a9ee801f60cc45fa2d64229177c886f7fa8d4ad70a373108021e1b40)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__850d48b30cb2aab1089d4b22053fd6051dfcc13c9928d3ab717ef5345677ab51)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f97c7e1589c31e92b25fc967ce480169e48f1418a98f70738e29864df9d4ced)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationMonoHue]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationMonoHue]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationMonoHue]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a1fc6845cb49ca99b4b5d102ea86329480d84ddb119ed2ad0213d77399cf5f06)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationOpacity",
    jsii_struct_bases=[],
    name_mapping={"opacity": "opacity", "opacity_var": "opacityVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationOpacity:
    def __init__(
        self,
        *,
        opacity: typing.Optional[builtins.str] = None,
        opacity_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param opacity: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param opacity_var: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d75a1f0a008937925b5ac03b494aa9da33cc01b0475de40d568d8f65ab67b03c)
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument opacity_var", value=opacity_var, expected_type=type_hints["opacity_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if opacity is not None:
            self._values["opacity"] = opacity
        if opacity_var is not None:
            self._values["opacity_var"] = opacity_var

    @builtins.property
    def opacity(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def opacity_var(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        result = self._values.get("opacity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationOpacity(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationOpacityList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationOpacityList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__62500eb310fd7314218e7d1a672e0791e31d73c3fdda3506a3d6668249e0142e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationOpacityOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a1ceda3b0719fb1cdf8e1af3cd8084fe4f27a826bb31f548d9d308d6312a677a)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationOpacityOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fd21d7be556cbe7d228367b0853315900526b8081e4ea2ea4e6e1b4e7ea1957e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__15971f8d1758cd90ae29e7d640e3318d650414e676326cde8ec714ced649b0b7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ed14504da7d3821cd0e218de0aecf5f3780c06f6bff1f132a05724822f5ada79)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationOpacity]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationOpacity]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e3846b51e6d908ac9f78ce654e423bc3b7434161ab5408cd7f2d6d4e033b18cf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationOpacityOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationOpacityOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__65ed6e7bfd222a36ff585e50607a6509b92ef37b1ba99afd65baf7af0c4b2d1b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetOpacityVar")
    def reset_opacity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacityVar", []))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityVarInput")
    def opacity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacity"))

    @opacity.setter
    def opacity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__588147b939d33cd935a1327f93e03f353a92809f0cca4f05dfe0011e0967b2af)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacity", value)

    @builtins.property
    @jsii.member(jsii_name="opacityVar")
    def opacity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacityVar"))

    @opacity_var.setter
    def opacity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4c699e2f52eae3981a2f1056807b1788cf221985ef55c2bd8c652bc51b8c5221)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacityVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationOpacity]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationOpacity]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationOpacity]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3683e3103ff41b873ed696e4bf7c57017664125fe3472e4e2950ac3a3084653c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a3c7b3ed3a49becb366652db051b1aa95a27319a43b6d78cfb3bb27b0459dc1a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putAppend")
    def put_append(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationAppend, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0331769115a04959c87e59f714557ec68e8a5e276d72b5cae333adae573a0914)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putAppend", [value]))

    @jsii.member(jsii_name="putAspectCrop")
    def put_aspect_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationAspectCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8b89bfd07a017c3099391fbc37a3cf5a5c8a039dbac5ea731be2c9d40c5796a7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putAspectCrop", [value]))

    @jsii.member(jsii_name="putBackgroundColor")
    def put_background_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d822619593cbb366aee60eea3c0df168e4cbec65b1ef594018e3c953c3124de3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBackgroundColor", [value]))

    @jsii.member(jsii_name="putBlur")
    def put_blur(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationBlur, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e1d9517364e7f81be8e120e6423963c8c6bc179627da1898e1c2f855500b3a45)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBlur", [value]))

    @jsii.member(jsii_name="putChromaKey")
    def put_chroma_key(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationChromaKey, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f3151f287c4b4658d9644af31575689c1645cd1bc5a5f4ea5bd6ca7ed44b32e9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putChromaKey", [value]))

    @jsii.member(jsii_name="putComposite")
    def put_composite(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationComposite, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5970c1fa1d49ae0754bf307a746881cbc8f62f3aaba9f76bdaee448a0d10baf1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putComposite", [value]))

    @jsii.member(jsii_name="putCompound")
    def put_compound(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationCompound, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__059faddc6e48b87031d66b3460e6f7a520d29f272723b6c514d30dc76624cb3e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCompound", [value]))

    @jsii.member(jsii_name="putContrast")
    def put_contrast(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationContrast, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b275e629ec48d243bb01667c0f65444b517667e62fa916bf23e09c677a5c38fc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putContrast", [value]))

    @jsii.member(jsii_name="putCrop")
    def put_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__65411b87bd67145de183ed0c08493665d166dcc71a5958bf5bd37664229868da)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCrop", [value]))

    @jsii.member(jsii_name="putFaceCrop")
    def put_face_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationFaceCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c049529dae01b8ab4792fba55c1b92918ef2f1f6c0b5a27007a81981dd6d8f89)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFaceCrop", [value]))

    @jsii.member(jsii_name="putFeatureCrop")
    def put_feature_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationFeatureCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b04abb4fbd1cddba5d512fe6e8464423c52236b1d418479cb3a7e3b4be1cba9c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFeatureCrop", [value]))

    @jsii.member(jsii_name="putFitAndFill")
    def put_fit_and_fill(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationFitAndFill, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f156f9275d872d489d5953a86237aa4d363293c59acab79e8e2db041a71fe3d7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFitAndFill", [value]))

    @jsii.member(jsii_name="putGoop")
    def put_goop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationGoop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__61902067de9f57c5bb7daf5644c0d91477bacf1d1907645bef089d57a4b1c2c0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGoop", [value]))

    @jsii.member(jsii_name="putGrayscale")
    def put_grayscale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationGrayscale, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be3e78ad940d9064b74a4c9888b0069e1e0d2955eb8bf566e5d6b218a7c15f8e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGrayscale", [value]))

    @jsii.member(jsii_name="putHsl")
    def put_hsl(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationHsl, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e09d08092ad61b124fd7cb6c89c3ba5730c1b88eb655c4ab48ad8f430ca708a0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsl", [value]))

    @jsii.member(jsii_name="putHsv")
    def put_hsv(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationHsv, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f552e5b997c12ea1eb05a5d9a6bdfb1ab3c83598bed81f523bbaf7bbec85e722)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsv", [value]))

    @jsii.member(jsii_name="putIfDimension")
    def put_if_dimension(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfDimension, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__74e12ec73f6ef11a290f1d636528122df4f565e4fae4a49dd75cacc1f408e078)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfDimension", [value]))

    @jsii.member(jsii_name="putIfOrientation")
    def put_if_orientation(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d8f0fb0434d6bd3e8844f099489f438fb54a95b0b4abc6780153479a179a4c1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfOrientation", [value]))

    @jsii.member(jsii_name="putImQuery")
    def put_im_query(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationImQuery, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3da58448cfc292b57d688d51c24cbf3c36aea00c7173a2bd8cb6ab50b679b9d5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putImQuery", [value]))

    @jsii.member(jsii_name="putMaxColors")
    def put_max_colors(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationMaxColors, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e857f7ee7333021666a8c419276446d001091818598ae6acc29146f2949fa655)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMaxColors", [value]))

    @jsii.member(jsii_name="putMirror")
    def put_mirror(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationMirror, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7ef7c2db277a14b2a9ec634c881e367235328c7b8b5480343f78badd1525e4a0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMirror", [value]))

    @jsii.member(jsii_name="putMonoHue")
    def put_mono_hue(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationMonoHue, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__69592073253f0be7714edfb5bbffc4bc1c0f57011e4f2c1fac77980f2a2a0982)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMonoHue", [value]))

    @jsii.member(jsii_name="putOpacity")
    def put_opacity(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationOpacity, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__12df4c9f0f15f1d34fbf0f8a44719f06b9ccac715f2ce29be172bfdfa8ff2fa7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putOpacity", [value]))

    @jsii.member(jsii_name="putRegionOfInterestCrop")
    def put_region_of_interest_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationRegionOfInterestCrop", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__56537332d077396da95353f4b97812e17d1bec5178356ecce3274c5f4d60ce1e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRegionOfInterestCrop", [value]))

    @jsii.member(jsii_name="putRelativeCrop")
    def put_relative_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationRelativeCrop", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__995c4103eacbf627e3334b1989e49a6d6a5bc8f12cacc7107504dc305f0ae150)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRelativeCrop", [value]))

    @jsii.member(jsii_name="putRemoveColor")
    def put_remove_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationRemoveColor", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e85fb197352af329d81ec5231141e2d03400400e3154498ad89f93ec350c2955)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRemoveColor", [value]))

    @jsii.member(jsii_name="putResize")
    def put_resize(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationResize", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f8f62f648f3435644d8ec47b9245f46999878432179a9f78bac376b6f60eb625)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putResize", [value]))

    @jsii.member(jsii_name="putRotate")
    def put_rotate(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationRotate", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8d6aa6ae562b642145206c0ae30af90c575d4a6e8f7b0902edf3fb7f32ab217e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRotate", [value]))

    @jsii.member(jsii_name="putScale")
    def put_scale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationScale", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d574a6ad7e8c8f7da4b9888dcfd6c69ad9f06c41f0b26656aaf63834dfd72352)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putScale", [value]))

    @jsii.member(jsii_name="putShear")
    def put_shear(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationShear", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b6ab2d49bc3dafb18ac7f90353edca6e022e6f5318e0d5d4fe4b9e9df35a6b06)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putShear", [value]))

    @jsii.member(jsii_name="putTrim")
    def put_trim(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationTrim", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6af7a47cd5a268f6d2658e684f9771c3db476a3c489a63b4e5189822cd22a6a2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTrim", [value]))

    @jsii.member(jsii_name="putUnsharpMask")
    def put_unsharp_mask(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationUnsharpMask", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a3d0d71179a4a256cf25ddbcbb8b9993818230d6ac85fd47b9f0abb391350e7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putUnsharpMask", [value]))

    @jsii.member(jsii_name="resetAppend")
    def reset_append(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAppend", []))

    @jsii.member(jsii_name="resetAspectCrop")
    def reset_aspect_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspectCrop", []))

    @jsii.member(jsii_name="resetBackgroundColor")
    def reset_background_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBackgroundColor", []))

    @jsii.member(jsii_name="resetBlur")
    def reset_blur(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBlur", []))

    @jsii.member(jsii_name="resetChromaKey")
    def reset_chroma_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChromaKey", []))

    @jsii.member(jsii_name="resetComposite")
    def reset_composite(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetComposite", []))

    @jsii.member(jsii_name="resetCompound")
    def reset_compound(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCompound", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetCrop")
    def reset_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCrop", []))

    @jsii.member(jsii_name="resetFaceCrop")
    def reset_face_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFaceCrop", []))

    @jsii.member(jsii_name="resetFeatureCrop")
    def reset_feature_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureCrop", []))

    @jsii.member(jsii_name="resetFitAndFill")
    def reset_fit_and_fill(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFitAndFill", []))

    @jsii.member(jsii_name="resetGoop")
    def reset_goop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGoop", []))

    @jsii.member(jsii_name="resetGrayscale")
    def reset_grayscale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGrayscale", []))

    @jsii.member(jsii_name="resetHsl")
    def reset_hsl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsl", []))

    @jsii.member(jsii_name="resetHsv")
    def reset_hsv(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsv", []))

    @jsii.member(jsii_name="resetIfDimension")
    def reset_if_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfDimension", []))

    @jsii.member(jsii_name="resetIfOrientation")
    def reset_if_orientation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfOrientation", []))

    @jsii.member(jsii_name="resetImQuery")
    def reset_im_query(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetImQuery", []))

    @jsii.member(jsii_name="resetMaxColors")
    def reset_max_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxColors", []))

    @jsii.member(jsii_name="resetMirror")
    def reset_mirror(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMirror", []))

    @jsii.member(jsii_name="resetMonoHue")
    def reset_mono_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonoHue", []))

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetRegionOfInterestCrop")
    def reset_region_of_interest_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRegionOfInterestCrop", []))

    @jsii.member(jsii_name="resetRelativeCrop")
    def reset_relative_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRelativeCrop", []))

    @jsii.member(jsii_name="resetRemoveColor")
    def reset_remove_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRemoveColor", []))

    @jsii.member(jsii_name="resetResize")
    def reset_resize(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetResize", []))

    @jsii.member(jsii_name="resetRotate")
    def reset_rotate(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRotate", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetShear")
    def reset_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetShear", []))

    @jsii.member(jsii_name="resetTrim")
    def reset_trim(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTrim", []))

    @jsii.member(jsii_name="resetUnsharpMask")
    def reset_unsharp_mask(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUnsharpMask", []))

    @builtins.property
    @jsii.member(jsii_name="append")
    def append(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationAppendList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationAppendList, jsii.get(self, "append"))

    @builtins.property
    @jsii.member(jsii_name="aspectCrop")
    def aspect_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationAspectCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationAspectCropList, jsii.get(self, "aspectCrop"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColor")
    def background_color(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationBackgroundColorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationBackgroundColorList, jsii.get(self, "backgroundColor"))

    @builtins.property
    @jsii.member(jsii_name="blur")
    def blur(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationBlurList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationBlurList, jsii.get(self, "blur"))

    @builtins.property
    @jsii.member(jsii_name="chromaKey")
    def chroma_key(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationChromaKeyList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationChromaKeyList, jsii.get(self, "chromaKey"))

    @builtins.property
    @jsii.member(jsii_name="composite")
    def composite(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationCompositeList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationCompositeList, jsii.get(self, "composite"))

    @builtins.property
    @jsii.member(jsii_name="compound")
    def compound(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationCompoundList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationCompoundList, jsii.get(self, "compound"))

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationContrastList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationContrastList, jsii.get(self, "contrast"))

    @builtins.property
    @jsii.member(jsii_name="crop")
    def crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationCropList, jsii.get(self, "crop"))

    @builtins.property
    @jsii.member(jsii_name="faceCrop")
    def face_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationFaceCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationFaceCropList, jsii.get(self, "faceCrop"))

    @builtins.property
    @jsii.member(jsii_name="featureCrop")
    def feature_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationFeatureCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationFeatureCropList, jsii.get(self, "featureCrop"))

    @builtins.property
    @jsii.member(jsii_name="fitAndFill")
    def fit_and_fill(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationFitAndFillList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationFitAndFillList, jsii.get(self, "fitAndFill"))

    @builtins.property
    @jsii.member(jsii_name="goop")
    def goop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationGoopList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationGoopList, jsii.get(self, "goop"))

    @builtins.property
    @jsii.member(jsii_name="grayscale")
    def grayscale(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationGrayscaleList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationGrayscaleList, jsii.get(self, "grayscale"))

    @builtins.property
    @jsii.member(jsii_name="hsl")
    def hsl(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationHslList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationHslList, jsii.get(self, "hsl"))

    @builtins.property
    @jsii.member(jsii_name="hsv")
    def hsv(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationHsvList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationHsvList, jsii.get(self, "hsv"))

    @builtins.property
    @jsii.member(jsii_name="ifDimension")
    def if_dimension(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfDimensionList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfDimensionList, jsii.get(self, "ifDimension"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientation")
    def if_orientation(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfOrientationList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfOrientationList, jsii.get(self, "ifOrientation"))

    @builtins.property
    @jsii.member(jsii_name="imQuery")
    def im_query(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationImQueryList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationImQueryList, jsii.get(self, "imQuery"))

    @builtins.property
    @jsii.member(jsii_name="maxColors")
    def max_colors(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationMaxColorsList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationMaxColorsList, jsii.get(self, "maxColors"))

    @builtins.property
    @jsii.member(jsii_name="mirror")
    def mirror(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationMirrorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationMirrorList, jsii.get(self, "mirror"))

    @builtins.property
    @jsii.member(jsii_name="monoHue")
    def mono_hue(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationMonoHueList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationMonoHueList, jsii.get(self, "monoHue"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationOpacityList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationOpacityList, jsii.get(self, "opacity"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestCrop")
    def region_of_interest_crop(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationRegionOfInterestCropList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationRegionOfInterestCropList", jsii.get(self, "regionOfInterestCrop"))

    @builtins.property
    @jsii.member(jsii_name="relativeCrop")
    def relative_crop(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationRelativeCropList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationRelativeCropList", jsii.get(self, "relativeCrop"))

    @builtins.property
    @jsii.member(jsii_name="removeColor")
    def remove_color(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationRemoveColorList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationRemoveColorList", jsii.get(self, "removeColor"))

    @builtins.property
    @jsii.member(jsii_name="resize")
    def resize(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationResizeList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationResizeList", jsii.get(self, "resize"))

    @builtins.property
    @jsii.member(jsii_name="rotate")
    def rotate(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationRotateList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationRotateList", jsii.get(self, "rotate"))

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationScaleList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationScaleList", jsii.get(self, "scale"))

    @builtins.property
    @jsii.member(jsii_name="shear")
    def shear(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationShearList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationShearList", jsii.get(self, "shear"))

    @builtins.property
    @jsii.member(jsii_name="trim")
    def trim(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationTrimList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationTrimList", jsii.get(self, "trim"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMask")
    def unsharp_mask(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationUnsharpMaskList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationUnsharpMaskList", jsii.get(self, "unsharpMask"))

    @builtins.property
    @jsii.member(jsii_name="appendInput")
    def append_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationAppend]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationAppend]]], jsii.get(self, "appendInput"))

    @builtins.property
    @jsii.member(jsii_name="aspectCropInput")
    def aspect_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationAspectCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationAspectCrop]]], jsii.get(self, "aspectCropInput"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColorInput")
    def background_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationBackgroundColor]]], jsii.get(self, "backgroundColorInput"))

    @builtins.property
    @jsii.member(jsii_name="blurInput")
    def blur_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationBlur]]], jsii.get(self, "blurInput"))

    @builtins.property
    @jsii.member(jsii_name="chromaKeyInput")
    def chroma_key_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationChromaKey]]], jsii.get(self, "chromaKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="compositeInput")
    def composite_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationComposite]]], jsii.get(self, "compositeInput"))

    @builtins.property
    @jsii.member(jsii_name="compoundInput")
    def compound_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationCompound]]], jsii.get(self, "compoundInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationContrast]]], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="cropInput")
    def crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationCrop]]], jsii.get(self, "cropInput"))

    @builtins.property
    @jsii.member(jsii_name="faceCropInput")
    def face_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationFaceCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationFaceCrop]]], jsii.get(self, "faceCropInput"))

    @builtins.property
    @jsii.member(jsii_name="featureCropInput")
    def feature_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationFeatureCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationFeatureCrop]]], jsii.get(self, "featureCropInput"))

    @builtins.property
    @jsii.member(jsii_name="fitAndFillInput")
    def fit_and_fill_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationFitAndFill]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationFitAndFill]]], jsii.get(self, "fitAndFillInput"))

    @builtins.property
    @jsii.member(jsii_name="goopInput")
    def goop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationGoop]]], jsii.get(self, "goopInput"))

    @builtins.property
    @jsii.member(jsii_name="grayscaleInput")
    def grayscale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationGrayscale]]], jsii.get(self, "grayscaleInput"))

    @builtins.property
    @jsii.member(jsii_name="hslInput")
    def hsl_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationHsl]]], jsii.get(self, "hslInput"))

    @builtins.property
    @jsii.member(jsii_name="hsvInput")
    def hsv_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationHsv]]], jsii.get(self, "hsvInput"))

    @builtins.property
    @jsii.member(jsii_name="ifDimensionInput")
    def if_dimension_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfDimension]]], jsii.get(self, "ifDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientationInput")
    def if_orientation_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfOrientation]]], jsii.get(self, "ifOrientationInput"))

    @builtins.property
    @jsii.member(jsii_name="imQueryInput")
    def im_query_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationImQuery]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationImQuery]]], jsii.get(self, "imQueryInput"))

    @builtins.property
    @jsii.member(jsii_name="maxColorsInput")
    def max_colors_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationMaxColors]]], jsii.get(self, "maxColorsInput"))

    @builtins.property
    @jsii.member(jsii_name="mirrorInput")
    def mirror_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationMirror]]], jsii.get(self, "mirrorInput"))

    @builtins.property
    @jsii.member(jsii_name="monoHueInput")
    def mono_hue_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationMonoHue]]], jsii.get(self, "monoHueInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationOpacity]]], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestCropInput")
    def region_of_interest_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationRegionOfInterestCrop"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationRegionOfInterestCrop"]]], jsii.get(self, "regionOfInterestCropInput"))

    @builtins.property
    @jsii.member(jsii_name="relativeCropInput")
    def relative_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationRelativeCrop"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationRelativeCrop"]]], jsii.get(self, "relativeCropInput"))

    @builtins.property
    @jsii.member(jsii_name="removeColorInput")
    def remove_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationRemoveColor"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationRemoveColor"]]], jsii.get(self, "removeColorInput"))

    @builtins.property
    @jsii.member(jsii_name="resizeInput")
    def resize_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationResize"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationResize"]]], jsii.get(self, "resizeInput"))

    @builtins.property
    @jsii.member(jsii_name="rotateInput")
    def rotate_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationRotate"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationRotate"]]], jsii.get(self, "rotateInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationScale"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationScale"]]], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="shearInput")
    def shear_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationShear"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationShear"]]], jsii.get(self, "shearInput"))

    @builtins.property
    @jsii.member(jsii_name="trimInput")
    def trim_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationTrim"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationTrim"]]], jsii.get(self, "trimInput"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMaskInput")
    def unsharp_mask_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationUnsharpMask"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationUnsharpMask"]]], jsii.get(self, "unsharpMaskInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be884e6a1be2c22a0aaa12f46340d39eabe1446666d999a429b05cf6c9932a91)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationRegionOfInterestCrop",
    jsii_struct_bases=[],
    name_mapping={
        "region_of_interest": "regionOfInterest",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationRegionOfInterestCrop:
    def __init__(
        self,
        *,
        region_of_interest: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationRegionOfInterestCropRegionOfInterest", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param region_of_interest: region_of_interest block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest DataAkamaiImagingPolicyImage#region_of_interest}
        :param gravity: The placement of the crop area relative to the specified area of interest. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: The placement of the crop area relative to the specified area of interest. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param style: Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(region_of_interest, dict):
            region_of_interest = DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationRegionOfInterestCropRegionOfInterest(**region_of_interest)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a9e4d916ba7ef840743c699e91707eac19f81b501d263a77181a0565979db087)
            check_type(argname="argument region_of_interest", value=region_of_interest, expected_type=type_hints["region_of_interest"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "region_of_interest": region_of_interest,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def region_of_interest(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationRegionOfInterestCropRegionOfInterest":
        '''region_of_interest block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest DataAkamaiImagingPolicyImage#region_of_interest}
        '''
        result = self._values.get("region_of_interest")
        assert result is not None, "Required property 'region_of_interest' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationRegionOfInterestCropRegionOfInterest", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''The placement of the crop area relative to the specified area of interest.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''The placement of the crop area relative to the specified area of interest.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationRegionOfInterestCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationRegionOfInterestCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationRegionOfInterestCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__18eeb45fc238398d49a5a8db2926cf412e3e5e90d0ecc9608d61241447068a59)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationRegionOfInterestCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__92f081f52feebd547767c65f88a4b9fd2b3db18d3245d581dc2374b35fb8c1ad)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationRegionOfInterestCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__59432e79ecc0c75cf489d41d8a1b29d8a4365c05a85fb8fe5e02d63e1b27b708)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5408b4605ca28dbae037f0a731b1392cb105a8533068eb3556bb318779cea805)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd9b0d43818f3ca915cba930d8053d951d42403caa186d350f873329a7daf79a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationRegionOfInterestCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationRegionOfInterestCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationRegionOfInterestCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__02c9d3821057ac816ed3aa9f3e1003b436217ebb5904d549f72918ac4ff829bc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationRegionOfInterestCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationRegionOfInterestCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d14718e05549db24ecc56124a734e077942942fc91fa45ac560016b527dc65f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putRegionOfInterest")
    def put_region_of_interest(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationRegionOfInterestCropRegionOfInterest()

        return typing.cast(None, jsii.invoke(self, "putRegionOfInterest", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterest")
    def region_of_interest(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationRegionOfInterestCropRegionOfInterestOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationRegionOfInterestCropRegionOfInterestOutputReference", jsii.get(self, "regionOfInterest"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestInput")
    def region_of_interest_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationRegionOfInterestCropRegionOfInterest"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationRegionOfInterestCropRegionOfInterest"], jsii.get(self, "regionOfInterestInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c011a16ed2425e02ee494df64a412d98fa39743ef00e3daac7c47a2eaa48140a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a0a501e800c71acf5186634d9032b7f6d894178ec2f60ea041b52eab538f7469)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7732dca521e68ad39fa8e3fe63ac76b583e10c0332c0de727b33939559301444)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ece86d9a88ca2b4026e7da441f0379437f7e667228a3001518656666e6ddcd4c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0575b90cfadcc62202c920d7239ca10e5672384159fe66ebc2559b2607656258)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a3bcb1a15fde553ee12ac7e51058606f25f621424d49c95a87ab6ea097748d78)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ef6dd3cb79bfe97200102a48ac1b20a630ec34614a16da4acfc9224cb467476)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e6fb59d24df37d5ea4f111e76407f48abc2fbf54e6e51f486b7e6995812230cc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationRegionOfInterestCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationRegionOfInterestCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationRegionOfInterestCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__80a11aa9df38d189915b9334affa79bde661a96c7d56334e224cd9f7f94fbe06)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationRegionOfInterestCropRegionOfInterest",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationRegionOfInterestCropRegionOfInterest:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationRegionOfInterestCropRegionOfInterest(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationRegionOfInterestCropRegionOfInterestOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationRegionOfInterestCropRegionOfInterestOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a6701eff0a0e8ebd0c1a2a363c6fa7138d402d9c82fb63a49ae48f0756d93da5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationRegionOfInterestCropRegionOfInterest]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationRegionOfInterestCropRegionOfInterest], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationRegionOfInterestCropRegionOfInterest],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b90b5fd5634b8f4532d0fcd50ecfc8dd13620e5926724bd09bb82038d96099e2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationRelativeCrop",
    jsii_struct_bases=[],
    name_mapping={
        "east": "east",
        "east_var": "eastVar",
        "north": "north",
        "north_var": "northVar",
        "south": "south",
        "south_var": "southVar",
        "west": "west",
        "west_var": "westVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationRelativeCrop:
    def __init__(
        self,
        *,
        east: typing.Optional[builtins.str] = None,
        east_var: typing.Optional[builtins.str] = None,
        north: typing.Optional[builtins.str] = None,
        north_var: typing.Optional[builtins.str] = None,
        south: typing.Optional[builtins.str] = None,
        south_var: typing.Optional[builtins.str] = None,
        west: typing.Optional[builtins.str] = None,
        west_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param east: The number of pixels to shrink or expand the right side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east DataAkamaiImagingPolicyImage#east}
        :param east_var: The number of pixels to shrink or expand the right side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east_var DataAkamaiImagingPolicyImage#east_var}
        :param north: The number of pixels to shrink or expand the top side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north DataAkamaiImagingPolicyImage#north}
        :param north_var: The number of pixels to shrink or expand the top side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north_var DataAkamaiImagingPolicyImage#north_var}
        :param south: The number of pixels to shrink or expand the bottom side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south DataAkamaiImagingPolicyImage#south}
        :param south_var: The number of pixels to shrink or expand the bottom side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south_var DataAkamaiImagingPolicyImage#south_var}
        :param west: The number of pixels to shrink or expand the left side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west DataAkamaiImagingPolicyImage#west}
        :param west_var: The number of pixels to shrink or expand the left side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west_var DataAkamaiImagingPolicyImage#west_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a6e4a5074ea9fbad68b0cb7e28f34c8ceffefb16552f02f148fc28e06250f778)
            check_type(argname="argument east", value=east, expected_type=type_hints["east"])
            check_type(argname="argument east_var", value=east_var, expected_type=type_hints["east_var"])
            check_type(argname="argument north", value=north, expected_type=type_hints["north"])
            check_type(argname="argument north_var", value=north_var, expected_type=type_hints["north_var"])
            check_type(argname="argument south", value=south, expected_type=type_hints["south"])
            check_type(argname="argument south_var", value=south_var, expected_type=type_hints["south_var"])
            check_type(argname="argument west", value=west, expected_type=type_hints["west"])
            check_type(argname="argument west_var", value=west_var, expected_type=type_hints["west_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if east is not None:
            self._values["east"] = east
        if east_var is not None:
            self._values["east_var"] = east_var
        if north is not None:
            self._values["north"] = north
        if north_var is not None:
            self._values["north_var"] = north_var
        if south is not None:
            self._values["south"] = south
        if south_var is not None:
            self._values["south_var"] = south_var
        if west is not None:
            self._values["west"] = west
        if west_var is not None:
            self._values["west_var"] = west_var

    @builtins.property
    def east(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the right side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east DataAkamaiImagingPolicyImage#east}
        '''
        result = self._values.get("east")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def east_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the right side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east_var DataAkamaiImagingPolicyImage#east_var}
        '''
        result = self._values.get("east_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def north(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the top side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north DataAkamaiImagingPolicyImage#north}
        '''
        result = self._values.get("north")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def north_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the top side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north_var DataAkamaiImagingPolicyImage#north_var}
        '''
        result = self._values.get("north_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def south(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the bottom side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south DataAkamaiImagingPolicyImage#south}
        '''
        result = self._values.get("south")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def south_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the bottom side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south_var DataAkamaiImagingPolicyImage#south_var}
        '''
        result = self._values.get("south_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def west(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the left side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west DataAkamaiImagingPolicyImage#west}
        '''
        result = self._values.get("west")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def west_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the left side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west_var DataAkamaiImagingPolicyImage#west_var}
        '''
        result = self._values.get("west_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationRelativeCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationRelativeCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationRelativeCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c6cf280bf12ad3e712dd2764fbe9af9cadbfd7203e991dc505b5711f7ea7b6d9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationRelativeCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__958bcaac7fd8ebacb1ab10b545503703ca42be37e35c26e4ec7c63ea4f02d1b1)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationRelativeCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dfc4c824a57b34df7190bb0d577571eeaa469af99036cf0998a670196833a3e1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1d2aab6ec6c87c66eff2941ce7e992a9c0762f1ee4db4574104c673f7457f4ed)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7f144397f9cad311a2ccc5af5b527001155b2eb0ed76b6fb482f5d2a03309e00)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationRelativeCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationRelativeCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationRelativeCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__77723a0cb44eb8ad199434015482b87a2ea3ee3d8fd13af53d9543056f790b71)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationRelativeCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationRelativeCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2b50c707ca7bfa173eb9d9ee57da16dd85f4c3f4310fcbfb722b6517b4ad065d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetEast")
    def reset_east(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEast", []))

    @jsii.member(jsii_name="resetEastVar")
    def reset_east_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEastVar", []))

    @jsii.member(jsii_name="resetNorth")
    def reset_north(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNorth", []))

    @jsii.member(jsii_name="resetNorthVar")
    def reset_north_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNorthVar", []))

    @jsii.member(jsii_name="resetSouth")
    def reset_south(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSouth", []))

    @jsii.member(jsii_name="resetSouthVar")
    def reset_south_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSouthVar", []))

    @jsii.member(jsii_name="resetWest")
    def reset_west(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWest", []))

    @jsii.member(jsii_name="resetWestVar")
    def reset_west_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWestVar", []))

    @builtins.property
    @jsii.member(jsii_name="eastInput")
    def east_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "eastInput"))

    @builtins.property
    @jsii.member(jsii_name="eastVarInput")
    def east_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "eastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="northInput")
    def north_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "northInput"))

    @builtins.property
    @jsii.member(jsii_name="northVarInput")
    def north_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "northVarInput"))

    @builtins.property
    @jsii.member(jsii_name="southInput")
    def south_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "southInput"))

    @builtins.property
    @jsii.member(jsii_name="southVarInput")
    def south_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "southVarInput"))

    @builtins.property
    @jsii.member(jsii_name="westInput")
    def west_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "westInput"))

    @builtins.property
    @jsii.member(jsii_name="westVarInput")
    def west_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "westVarInput"))

    @builtins.property
    @jsii.member(jsii_name="east")
    def east(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "east"))

    @east.setter
    def east(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__37917f43761d0b747fc62d3d5dfaf17bb6779b39607c193710ca98f6ace94f4d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "east", value)

    @builtins.property
    @jsii.member(jsii_name="eastVar")
    def east_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "eastVar"))

    @east_var.setter
    def east_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b4469939759cfad2f2674e294c418416f90fe523d7d8334a5928fccdb2fc9c76)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "eastVar", value)

    @builtins.property
    @jsii.member(jsii_name="north")
    def north(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "north"))

    @north.setter
    def north(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__308eb028b2aa27c249e22d0835fd21e333277a9e3569ebc44dccff4529c1187b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "north", value)

    @builtins.property
    @jsii.member(jsii_name="northVar")
    def north_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "northVar"))

    @north_var.setter
    def north_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__689654be8ec9b781a92783560298bee4ae129e9e3ca2ef025f1f42d17f5bbc44)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "northVar", value)

    @builtins.property
    @jsii.member(jsii_name="south")
    def south(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "south"))

    @south.setter
    def south(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c4820b0c99baa9a5a79c08bd29ca175ebedad0f1a9c00586188bb9253f71a288)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "south", value)

    @builtins.property
    @jsii.member(jsii_name="southVar")
    def south_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "southVar"))

    @south_var.setter
    def south_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fb5c42560e007aba363973732ad294f90f1061f0cf5da6a5460c93d30c81de83)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "southVar", value)

    @builtins.property
    @jsii.member(jsii_name="west")
    def west(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "west"))

    @west.setter
    def west(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6918b475a7368ce73a0c64a8076fbecedec3feeca3fd1faa1a29fc7fe42d06ab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "west", value)

    @builtins.property
    @jsii.member(jsii_name="westVar")
    def west_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "westVar"))

    @west_var.setter
    def west_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__91df78aa98cc1cbbd166e6ccd2893ae215bd6dc2dab0a10d3d73a3168f97eda9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "westVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationRelativeCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationRelativeCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationRelativeCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0f1a03d0c5883e8aeac774c3ec5712fc20586b5e37d46c6483d9966722cd2d5e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationRemoveColor",
    jsii_struct_bases=[],
    name_mapping={
        "color": "color",
        "color_var": "colorVar",
        "feather": "feather",
        "feather_var": "featherVar",
        "tolerance": "tolerance",
        "tolerance_var": "toleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationRemoveColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
        feather: typing.Optional[builtins.str] = None,
        feather_var: typing.Optional[builtins.str] = None,
        tolerance: typing.Optional[builtins.str] = None,
        tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        :param feather: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        :param feather_var: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        :param tolerance: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        :param tolerance_var: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__37ac8bedf745d09de824325b28b44bbd743ddadc32b6f4af6370ee4eeea28701)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
            check_type(argname="argument feather", value=feather, expected_type=type_hints["feather"])
            check_type(argname="argument feather_var", value=feather_var, expected_type=type_hints["feather_var"])
            check_type(argname="argument tolerance", value=tolerance, expected_type=type_hints["tolerance"])
            check_type(argname="argument tolerance_var", value=tolerance_var, expected_type=type_hints["tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var
        if feather is not None:
            self._values["feather"] = feather
        if feather_var is not None:
            self._values["feather_var"] = feather_var
        if tolerance is not None:
            self._values["tolerance"] = tolerance
        if tolerance_var is not None:
            self._values["tolerance_var"] = tolerance_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        '''
        result = self._values.get("feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather_var(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        '''
        result = self._values.get("feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        '''
        result = self._values.get("tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance_var(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        result = self._values.get("tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationRemoveColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationRemoveColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationRemoveColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e9bea6cb59b665961165c25b8df65759173dfa18a4a8959f3d9a8058d9f76917)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationRemoveColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0cfea71921fda4fab75c0fe4785966bf37a0bc8ad1d318809c030e34c8545c8f)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationRemoveColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__940afa00b2d60cbbd2d1317633e3075f738a8fd2544dead3adae35bce2489235)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b35295dd982561fd8fb195d324f39b6eaf92fb23c95d6736e314a320585787bd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7e984296db8b86fc0f9483d7a3556efdb83290d937288af354029717228148a1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationRemoveColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationRemoveColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationRemoveColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2f03ea578e2518c2104f6792d5753715de8e8ee3bcc328898785543029b99b6c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationRemoveColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationRemoveColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2934d72a8e4efabe59baeb466288bd06fea758d82ed9dea21bd831b893973f83)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @jsii.member(jsii_name="resetFeather")
    def reset_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeather", []))

    @jsii.member(jsii_name="resetFeatherVar")
    def reset_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatherVar", []))

    @jsii.member(jsii_name="resetTolerance")
    def reset_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTolerance", []))

    @jsii.member(jsii_name="resetToleranceVar")
    def reset_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featherInput")
    def feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherInput"))

    @builtins.property
    @jsii.member(jsii_name="featherVarInput")
    def feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceInput")
    def tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceVarInput")
    def tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a36495f58eb15872692537bafac523ec05b4000872e17b2147bb8c353efc0d69)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ef489ed21eb89ecac3c65ddc234bcdec048789515e320f3522f9a29f1ef99ce3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="feather")
    def feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "feather"))

    @feather.setter
    def feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__24b43c2c4fc0fd64f0eb9675935b81fdc5d69d180ea6b77a882b6a640b475c1f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "feather", value)

    @builtins.property
    @jsii.member(jsii_name="featherVar")
    def feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featherVar"))

    @feather_var.setter
    def feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__96675395a1c0c19d4a827b060c319a3882e79d0a9a641fafbb4e76f83b9b1329)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featherVar", value)

    @builtins.property
    @jsii.member(jsii_name="tolerance")
    def tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tolerance"))

    @tolerance.setter
    def tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__35e3dcd7f2654344dd607addc1418adfd178e3be91e24c0461d74414955b1a14)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tolerance", value)

    @builtins.property
    @jsii.member(jsii_name="toleranceVar")
    def tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "toleranceVar"))

    @tolerance_var.setter
    def tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__73a4e7c4b9d4fbf5b7fceae1ffab9df0e6e73375f7d08e0afd1d6ba3f3da84e2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "toleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationRemoveColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationRemoveColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationRemoveColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fb49d83e1965cf84fb11db87406f050b7a76f6c37c13500e87b06e080451e5c4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationResize",
    jsii_struct_bases=[],
    name_mapping={
        "aspect": "aspect",
        "aspect_var": "aspectVar",
        "height": "height",
        "height_var": "heightVar",
        "type": "type",
        "type_var": "typeVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationResize:
    def __init__(
        self,
        *,
        aspect: typing.Optional[builtins.str] = None,
        aspect_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param aspect: Preserves the aspect ratio. Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect DataAkamaiImagingPolicyImage#aspect}
        :param aspect_var: Preserves the aspect ratio. Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_var DataAkamaiImagingPolicyImage#aspect_var}
        :param height: The height to resize the source image to. Must be set if height is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height to resize the source image to. Must be set if height is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param type: Sets constraints for the image resize. Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: Sets constraints for the image resize. Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        :param width: The width to resize the source image to. Must be set if width is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width to resize the source image to. Must be set if width is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ce50661f59997981618ffeefe20eee5b4f665092930ee1fca84a91a91e2e9c0b)
            check_type(argname="argument aspect", value=aspect, expected_type=type_hints["aspect"])
            check_type(argname="argument aspect_var", value=aspect_var, expected_type=type_hints["aspect_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if aspect is not None:
            self._values["aspect"] = aspect
        if aspect_var is not None:
            self._values["aspect_var"] = aspect_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def aspect(self) -> typing.Optional[builtins.str]:
        '''Preserves the aspect ratio.

        Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect DataAkamaiImagingPolicyImage#aspect}
        '''
        result = self._values.get("aspect")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def aspect_var(self) -> typing.Optional[builtins.str]:
        '''Preserves the aspect ratio.

        Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_var DataAkamaiImagingPolicyImage#aspect_var}
        '''
        result = self._values.get("aspect_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height to resize the source image to. Must be set if height is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height to resize the source image to. Must be set if height is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''Sets constraints for the image resize.

        Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''Sets constraints for the image resize.

        Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width to resize the source image to. Must be set if width is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width to resize the source image to. Must be set if width is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationResize(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationResizeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationResizeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ef44b1841faa976d95e92176f3613cb63f1a62e2ed5a257b6f881e61f18f4a10)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationResizeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b7b18a4bc3aeee1c3b27b9463cd17086adb4c4dc1c1c497e02c48caafde26dc4)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationResizeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__26d3b149bf3b132b7f24d4645e81ed887091c6aae795956fc48b63e95172e4cc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__513bf899758e1e56eb4e04fd96612aff868975837b8ea769537345e76c1bc3af)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__536877b2705792f7e37d8e3c859c0129e424d3193b2e6965250e89224128c48e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationResize]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationResize]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationResize]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__46cec2a3d089665cac2648ab35866aaa1d027fe256b9d229bce8fb5bad970eb5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationResizeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationResizeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fe7dca02410ed0e2bcf17e9af500c84c2631404aba0fb348bf13dd203966e7bd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAspect")
    def reset_aspect(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspect", []))

    @jsii.member(jsii_name="resetAspectVar")
    def reset_aspect_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspectVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="aspectInput")
    def aspect_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "aspectInput"))

    @builtins.property
    @jsii.member(jsii_name="aspectVarInput")
    def aspect_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "aspectVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="aspect")
    def aspect(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "aspect"))

    @aspect.setter
    def aspect(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__819e12077beb5b4ba8af5cd911af88b08afbf912e0fcbfb5eb7cfb1bcffe2783)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "aspect", value)

    @builtins.property
    @jsii.member(jsii_name="aspectVar")
    def aspect_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "aspectVar"))

    @aspect_var.setter
    def aspect_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c1ca6e5507ee56666fee49937cfe7a6ab618910f6f38861a81daaa2893014c05)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "aspectVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9eb6a790f075a35a98da4c0547d7e30cc8bdf5ee39d152c561c125c9f18ef422)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e7f5dee33fff6fd6ddb0dccb8dcf9c5dd8579cdad6306ead1b099cb7910a556d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ff8e5c49e0f564dfd80bd206377a85f4dba60593ec7fce20f7f8bd701057fd0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__00bab9af0ada47e6ca6f959e0b79f7ff261aad4cfa76f596a29f5e85ca3c0457)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__037084c2373fa64d514453c4a2351c982a4629f2998dafe17787cd0129e24de6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__55bbbc7367956f34f50304503557331fa0966ba9c924b2efcc8bfc0730a26d01)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationResize]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationResize]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationResize]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__73f663b423d0dcba4bfb9daf06c60e7b4f08a1eae25afea6de22e7565aba4976)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationRotate",
    jsii_struct_bases=[],
    name_mapping={"degrees": "degrees", "degrees_var": "degreesVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationRotate:
    def __init__(
        self,
        *,
        degrees: typing.Optional[builtins.str] = None,
        degrees_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param degrees: The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees DataAkamaiImagingPolicyImage#degrees}
        :param degrees_var: The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees_var DataAkamaiImagingPolicyImage#degrees_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d962251849052023db3ef334feb4059c7f5c46b879bdd5feca5774fef315c72d)
            check_type(argname="argument degrees", value=degrees, expected_type=type_hints["degrees"])
            check_type(argname="argument degrees_var", value=degrees_var, expected_type=type_hints["degrees_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if degrees is not None:
            self._values["degrees"] = degrees
        if degrees_var is not None:
            self._values["degrees_var"] = degrees_var

    @builtins.property
    def degrees(self) -> typing.Optional[builtins.str]:
        '''The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees DataAkamaiImagingPolicyImage#degrees}
        '''
        result = self._values.get("degrees")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def degrees_var(self) -> typing.Optional[builtins.str]:
        '''The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees_var DataAkamaiImagingPolicyImage#degrees_var}
        '''
        result = self._values.get("degrees_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationRotate(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationRotateList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationRotateList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bf025c44fc812d5f0c73da77396ceacf7319b39de07c5754ba6849d3e9c119c6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationRotateOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__66e9a539cd2d6c51a1dba748d7d523e7c718bf55271f136065cfdd8c3dfe2ac4)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationRotateOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__11965b46a1bbfce89a2af8780e90e3f904e60d931ed861ea5d3c794b325e467b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e2540e59e47314b62a28aaec2a05d333bf5a3a4a75057e88cc67100b2b8acc56)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5accf0b417782507f88202d400dd28f8fac4714dbcd041ec63d766ae37ca05cd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationRotate]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationRotate]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationRotate]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3753d382ea6aaadaa3efa678322cf96036f5209fd2847c1cb0c98d33f3ce6e44)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationRotateOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationRotateOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__312935c5a57fba8048f4508934d77d10cc2d34740f00766138af2655aeeaa5b9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetDegrees")
    def reset_degrees(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDegrees", []))

    @jsii.member(jsii_name="resetDegreesVar")
    def reset_degrees_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDegreesVar", []))

    @builtins.property
    @jsii.member(jsii_name="degreesInput")
    def degrees_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "degreesInput"))

    @builtins.property
    @jsii.member(jsii_name="degreesVarInput")
    def degrees_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "degreesVarInput"))

    @builtins.property
    @jsii.member(jsii_name="degrees")
    def degrees(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "degrees"))

    @degrees.setter
    def degrees(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7bf78714e7df5c8d376590fe4a40cbc04224c25209cea385fe4b56f2f1bb3219)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "degrees", value)

    @builtins.property
    @jsii.member(jsii_name="degreesVar")
    def degrees_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "degreesVar"))

    @degrees_var.setter
    def degrees_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be01a1f1c0c1df84873e18d4107bada79b0baa6f44383ea5521464e57e1f7725)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "degreesVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationRotate]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationRotate]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationRotate]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__465152eef9a7d54ef2c428cc05a58a320090aba57f39d5c83e231a9de8734d98)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationScale",
    jsii_struct_bases=[],
    name_mapping={
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationScale:
    def __init__(
        self,
        *,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param height: Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged. Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged. Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__040c59d596a010045e643143ac2b73fe3200a33a4590146b01b1ba23930fc296)
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size.

        Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size.

        Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged.

        Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged.

        Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationScale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationScaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationScaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0eb3a8a6c459918c485cfa401cbc601949e99d9cc3453701b89a81071c50f224)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationScaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1a4e3d339b2746690f246e336c60a356174f2290393ea98316dbad420c4dc9f1)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationScaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9b2d8edaeca6f8ae09aa2da6543491c92abbc9b90874d8e36c8b3591f593c967)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d69b3e10248f3051e158561aabb17bd9750511aabb698cc185c1132e2166d437)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dea96b0d2bd05121531ff703ae25189aee56356c89964f7aeedee8cf703f024a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationScale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationScale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationScale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5120ca9c4f90465e27fda56b8ec11a0f25418529e02bcfa3dbe4af652b48b786)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationScaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationScaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5531f87ea635af344a702253436b6ff750e530004d91850d7abf32ed9f0ea6b6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0b216b799b491ab7a98f065244ee9dbe57da06d9ead4c7cc8b4118271bc053bf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d545052ac6e51595dd40cf5a94a991a62676b871610a9344b91ac1ab47f4f18b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7fe16f7dedfa7da96c6dc288f1e6f6c160f82d43c735dc8527cf171d71252ff2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__08b0e49094082c55b994ec4c188251e99ad2ca1bad642ab3674fb1755f7ac443)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationScale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationScale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationScale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5b73c3a073e84e2f6013de05b277cfa21bf4768385ae3d61831c545a1c344a5f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationShear",
    jsii_struct_bases=[],
    name_mapping={
        "x_shear": "xShear",
        "x_shear_var": "xShearVar",
        "y_shear": "yShear",
        "y_shear_var": "yShearVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationShear:
    def __init__(
        self,
        *,
        x_shear: typing.Optional[builtins.str] = None,
        x_shear_var: typing.Optional[builtins.str] = None,
        y_shear: typing.Optional[builtins.str] = None,
        y_shear_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param x_shear: The amount to shear along the x-axis, measured in multiples of the image's width. Must be set if yShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear DataAkamaiImagingPolicyImage#x_shear}
        :param x_shear_var: The amount to shear along the x-axis, measured in multiples of the image's width. Must be set if yShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear_var DataAkamaiImagingPolicyImage#x_shear_var}
        :param y_shear: The amount to shear along the y-axis, measured in multiples of the image's height. Must be set if xShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear DataAkamaiImagingPolicyImage#y_shear}
        :param y_shear_var: The amount to shear along the y-axis, measured in multiples of the image's height. Must be set if xShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear_var DataAkamaiImagingPolicyImage#y_shear_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f7b047677e63f3f2ebef53bd2fbced572f2d3755cef1f2e207e7461cfc4bcfa0)
            check_type(argname="argument x_shear", value=x_shear, expected_type=type_hints["x_shear"])
            check_type(argname="argument x_shear_var", value=x_shear_var, expected_type=type_hints["x_shear_var"])
            check_type(argname="argument y_shear", value=y_shear, expected_type=type_hints["y_shear"])
            check_type(argname="argument y_shear_var", value=y_shear_var, expected_type=type_hints["y_shear_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if x_shear is not None:
            self._values["x_shear"] = x_shear
        if x_shear_var is not None:
            self._values["x_shear_var"] = x_shear_var
        if y_shear is not None:
            self._values["y_shear"] = y_shear
        if y_shear_var is not None:
            self._values["y_shear_var"] = y_shear_var

    @builtins.property
    def x_shear(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the x-axis, measured in multiples of the image's width.

        Must be set if yShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear DataAkamaiImagingPolicyImage#x_shear}
        '''
        result = self._values.get("x_shear")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_shear_var(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the x-axis, measured in multiples of the image's width.

        Must be set if yShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear_var DataAkamaiImagingPolicyImage#x_shear_var}
        '''
        result = self._values.get("x_shear_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_shear(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the y-axis, measured in multiples of the image's height.

        Must be set if xShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear DataAkamaiImagingPolicyImage#y_shear}
        '''
        result = self._values.get("y_shear")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_shear_var(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the y-axis, measured in multiples of the image's height.

        Must be set if xShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear_var DataAkamaiImagingPolicyImage#y_shear_var}
        '''
        result = self._values.get("y_shear_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationShear(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationShearList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationShearList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2fd1af883e4318d703c023821921582df8f4d69f1372dd2ced4cf084cea694b7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationShearOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0fbde4b1549ff5dae1e5eee5773042901748cb5c0a83d25d6aa9cc99663b36c7)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationShearOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1bbcf8f710acbba42b36b1942be79d0abc00f83a84f27018f325fda0dfcf935c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9b1b2a9a4d3eba2424920b57ff18119a70d5ee5be472bdd2617201ed0012e923)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0136701be5621475cb3663dbbf059640a4fc64dcaafd14352324b7b25372e7ca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationShear]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationShear]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationShear]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e9325db7326946944ba88e4359175a0674992804cd6d63023d7c12d30244398a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationShearOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationShearOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__357bbacc3c28f8870fe89e6f8a671a518dab5f4fef08433aa627f9fd9ac92ce1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetXShear")
    def reset_x_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXShear", []))

    @jsii.member(jsii_name="resetXShearVar")
    def reset_x_shear_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXShearVar", []))

    @jsii.member(jsii_name="resetYShear")
    def reset_y_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYShear", []))

    @jsii.member(jsii_name="resetYShearVar")
    def reset_y_shear_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYShearVar", []))

    @builtins.property
    @jsii.member(jsii_name="xShearInput")
    def x_shear_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xShearInput"))

    @builtins.property
    @jsii.member(jsii_name="xShearVarInput")
    def x_shear_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xShearVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yShearInput")
    def y_shear_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yShearInput"))

    @builtins.property
    @jsii.member(jsii_name="yShearVarInput")
    def y_shear_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yShearVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xShear")
    def x_shear(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xShear"))

    @x_shear.setter
    def x_shear(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6ba845ae82446b296ce73700373ef298e8c55b9833807753744e5542e6921677)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xShear", value)

    @builtins.property
    @jsii.member(jsii_name="xShearVar")
    def x_shear_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xShearVar"))

    @x_shear_var.setter
    def x_shear_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e987c2bd28bf3414238e078febbc34cc0298c5ecac3baf81a271bb1ce617c27b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xShearVar", value)

    @builtins.property
    @jsii.member(jsii_name="yShear")
    def y_shear(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yShear"))

    @y_shear.setter
    def y_shear(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__942b8a1fdbef8a4c2d4e3c008a2dc317827bf34977e2ff4e9ae7224917b71fcb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yShear", value)

    @builtins.property
    @jsii.member(jsii_name="yShearVar")
    def y_shear_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yShearVar"))

    @y_shear_var.setter
    def y_shear_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d5b2e97cfb148fb4baee8bc5657fc2529125a498da2860cdce44ce7def3f073a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yShearVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationShear]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationShear]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationShear]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ba7a6f5c6b431c45b443ff1e78eadf27702281f9e3d53e3be73054767a5f601b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationTrim",
    jsii_struct_bases=[],
    name_mapping={
        "fuzz": "fuzz",
        "fuzz_var": "fuzzVar",
        "padding": "padding",
        "padding_var": "paddingVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationTrim:
    def __init__(
        self,
        *,
        fuzz: typing.Optional[builtins.str] = None,
        fuzz_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fuzz: The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz DataAkamaiImagingPolicyImage#fuzz}
        :param fuzz_var: The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz_var DataAkamaiImagingPolicyImage#fuzz_var}
        :param padding: The amount of padding in pixels to add to the trimmed image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: The amount of padding in pixels to add to the trimmed image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__89d5e54966987fc92c216f003aeb587b24779d9e6991f826cd836ae3740f3338)
            check_type(argname="argument fuzz", value=fuzz, expected_type=type_hints["fuzz"])
            check_type(argname="argument fuzz_var", value=fuzz_var, expected_type=type_hints["fuzz_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fuzz is not None:
            self._values["fuzz"] = fuzz
        if fuzz_var is not None:
            self._values["fuzz_var"] = fuzz_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var

    @builtins.property
    def fuzz(self) -> typing.Optional[builtins.str]:
        '''The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz DataAkamaiImagingPolicyImage#fuzz}
        '''
        result = self._values.get("fuzz")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fuzz_var(self) -> typing.Optional[builtins.str]:
        '''The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz_var DataAkamaiImagingPolicyImage#fuzz_var}
        '''
        result = self._values.get("fuzz_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''The amount of padding in pixels to add to the trimmed image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''The amount of padding in pixels to add to the trimmed image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationTrim(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationTrimList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationTrimList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bf50e5c6a60be216e53da52d3b56944f79516c7dec1096bd2b77d9ad63a85da7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationTrimOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d15891ed29441e48ad9b3430ecdc627ad5ba35b95fc40256297742a1bc4612f4)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationTrimOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__045a1fa8e9690cbda1d696f397f332e903b856aa44e68be9fda85caac3ba6d82)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a327ac9737b81f6738a3ca949f0e0e8b0337ae8067b219d241e956a3f5806835)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__620be186aa668790f451c388de7fa37bdf16ff9c7ad2f551712fa22abbbdb532)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationTrim]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationTrim]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationTrim]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5a8492c02681042e861195b060dfa5c789872d8631750f2f597fa7a5286f4e09)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationTrimOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationTrimOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__195d451546663412f52fcfd8774bc87960ae3ac814ca3cdb1b41dd4b1dfe9d8a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetFuzz")
    def reset_fuzz(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFuzz", []))

    @jsii.member(jsii_name="resetFuzzVar")
    def reset_fuzz_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFuzzVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @builtins.property
    @jsii.member(jsii_name="fuzzInput")
    def fuzz_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fuzzInput"))

    @builtins.property
    @jsii.member(jsii_name="fuzzVarInput")
    def fuzz_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fuzzVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="fuzz")
    def fuzz(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fuzz"))

    @fuzz.setter
    def fuzz(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ec24a90163bbe123470b25f7c42e8fdc2abe6d4b039e49bba7c584c3378c5a52)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fuzz", value)

    @builtins.property
    @jsii.member(jsii_name="fuzzVar")
    def fuzz_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fuzzVar"))

    @fuzz_var.setter
    def fuzz_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__560dbb3cd9342eac7fe6526480e2f9e97ad082ce69bb391af2857096c4e469fb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fuzzVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9c7bb0e24ad62b91f161820ef186a6634b59f3b13847c333d4f4f8553ca66bd2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c8a76d8b87f941fc90610405064ce33dc7ad7ab2c5985b914756ba9d289d8759)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationTrim]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationTrim]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationTrim]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e4b9f5de7c2e14cd0c252cb955b149622622e58a15bcb8832824864f2a51853)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationUnsharpMask",
    jsii_struct_bases=[],
    name_mapping={
        "gain": "gain",
        "gain_var": "gainVar",
        "sigma": "sigma",
        "sigma_var": "sigmaVar",
        "threshold": "threshold",
        "threshold_var": "thresholdVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationUnsharpMask:
    def __init__(
        self,
        *,
        gain: typing.Optional[builtins.str] = None,
        gain_var: typing.Optional[builtins.str] = None,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
        threshold: typing.Optional[builtins.str] = None,
        threshold_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param gain: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        :param gain_var: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        :param sigma: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        :param threshold: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        :param threshold_var: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__399652be7e4fc0f029e480c551b44d9772f90d9d8147bcd552de265e04902db2)
            check_type(argname="argument gain", value=gain, expected_type=type_hints["gain"])
            check_type(argname="argument gain_var", value=gain_var, expected_type=type_hints["gain_var"])
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
            check_type(argname="argument threshold", value=threshold, expected_type=type_hints["threshold"])
            check_type(argname="argument threshold_var", value=threshold_var, expected_type=type_hints["threshold_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if gain is not None:
            self._values["gain"] = gain
        if gain_var is not None:
            self._values["gain_var"] = gain_var
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var
        if threshold is not None:
            self._values["threshold"] = threshold
        if threshold_var is not None:
            self._values["threshold_var"] = threshold_var

    @builtins.property
    def gain(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        '''
        result = self._values.get("gain")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gain_var(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        '''
        result = self._values.get("gain_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        '''
        result = self._values.get("threshold")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold_var(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        result = self._values.get("threshold_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationUnsharpMask(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationUnsharpMaskList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationUnsharpMaskList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__424647279cb87451c9ad9cd0621e17a7c3801194fc91a69cabd366c14943e8a7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationUnsharpMaskOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__71a514ce0ed4612ef90c67aae9677d3b056cc257b4a1cafe16a2f72ce3f46844)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationUnsharpMaskOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b64a0f6d0d9b368392905edf25a458d364252dbdf3b9e5d88dfeb1fcd9a23e63)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8afec551eb6e6c2233363dfc92d545d17cb4232176de8b82fa30dafd65d57277)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a92ecc91c202c9535b458b5f1f226e4740eb59c36136fc722efb3d2ad2733d05)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationUnsharpMask]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationUnsharpMask]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationUnsharpMask]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ce0882b05c0f5877f2151ccb110ee49292183105636ad2414f5354d56e41e40d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationUnsharpMaskOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationUnsharpMaskOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5abc53611979646574f1e1083cd38f5b4a83fc4fd3f8f20253063356ecd99156)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetGain")
    def reset_gain(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGain", []))

    @jsii.member(jsii_name="resetGainVar")
    def reset_gain_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGainVar", []))

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @jsii.member(jsii_name="resetThreshold")
    def reset_threshold(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThreshold", []))

    @jsii.member(jsii_name="resetThresholdVar")
    def reset_threshold_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThresholdVar", []))

    @builtins.property
    @jsii.member(jsii_name="gainInput")
    def gain_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainInput"))

    @builtins.property
    @jsii.member(jsii_name="gainVarInput")
    def gain_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdInput")
    def threshold_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdVarInput")
    def threshold_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gain")
    def gain(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gain"))

    @gain.setter
    def gain(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__992771b4632202545ea9942efae44b3238eda6b1f97f4099bdd38796ac0fd877)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gain", value)

    @builtins.property
    @jsii.member(jsii_name="gainVar")
    def gain_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gainVar"))

    @gain_var.setter
    def gain_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2e54b96aad77fdffd20e9eb3af4c1e7a6b1bda39ac62de9b8119e95e46f52aa3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gainVar", value)

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__de3e3a540830a43c7c768c77ee9f780cbdaa75cddd5d43a223de60bd473ddf93)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2f6c2a43ddbe65110ac97f5c618a0b2139fa89450b63fa29423d23c200e8b591)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="threshold")
    def threshold(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "threshold"))

    @threshold.setter
    def threshold(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d8fa852831d6dcd7d7d7cdd2b6fe260f1f660848c9680d93854e990d086ce07c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "threshold", value)

    @builtins.property
    @jsii.member(jsii_name="thresholdVar")
    def threshold_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "thresholdVar"))

    @threshold_var.setter
    def threshold_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a88ecb2b067c5a3b16504162168172048fb792ca6aa0b0ebf8e8e95834e83878)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "thresholdVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationUnsharpMask]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationUnsharpMask]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationUnsharpMask]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__835d24334377b7a9074bc1ed5ac50a1f188407da8a2ed948ad3d08ac6f668162)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImage",
    jsii_struct_bases=[],
    name_mapping={
        "color": "color",
        "color_var": "colorVar",
        "diameter": "diameter",
        "diameter_var": "diameterVar",
        "transformation": "transformation",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImage:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
        diameter: typing.Optional[builtins.str] = None,
        diameter_var: typing.Optional[builtins.str] = None,
        transformation: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The fill color of the circle. The API supports hexadecimal representation and CSS hexadecimal color values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The fill color of the circle. The API supports hexadecimal representation and CSS hexadecimal color values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        :param diameter: The diameter of the circle. The diameter will be the width and the height of the image in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#diameter DataAkamaiImagingPolicyImage#diameter}
        :param diameter_var: The diameter of the circle. The diameter will be the width and the height of the image in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#diameter_var DataAkamaiImagingPolicyImage#diameter_var}
        :param transformation: transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        :param width: The width of the box in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width of the box in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(transformation, dict):
            transformation = DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformation(**transformation)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fc3ab738051b6fcab1bb1357602786f260bca83f2e56de60ef48288babf3e3d4)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
            check_type(argname="argument diameter", value=diameter, expected_type=type_hints["diameter"])
            check_type(argname="argument diameter_var", value=diameter_var, expected_type=type_hints["diameter_var"])
            check_type(argname="argument transformation", value=transformation, expected_type=type_hints["transformation"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var
        if diameter is not None:
            self._values["diameter"] = diameter
        if diameter_var is not None:
            self._values["diameter_var"] = diameter_var
        if transformation is not None:
            self._values["transformation"] = transformation
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The fill color of the circle. The API supports hexadecimal representation and CSS hexadecimal color values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The fill color of the circle. The API supports hexadecimal representation and CSS hexadecimal color values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def diameter(self) -> typing.Optional[builtins.str]:
        '''The diameter of the circle. The diameter will be the width and the height of the image in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#diameter DataAkamaiImagingPolicyImage#diameter}
        '''
        result = self._values.get("diameter")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def diameter_var(self) -> typing.Optional[builtins.str]:
        '''The diameter of the circle. The diameter will be the width and the height of the image in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#diameter_var DataAkamaiImagingPolicyImage#diameter_var}
        '''
        result = self._values.get("diameter_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def transformation(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformation"]:
        '''transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        '''
        result = self._values.get("transformation")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformation"], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width of the box in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width of the box in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ec7704c978f2a9580d354bfac8dbb7b2bfdd520fc48ff1c46d602641509e9c6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b0e2b5e06ba54a1561fdb17361122e885a0fc720f13c49c068a7ea62ca409f82)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__490c5872dd89a27bd73087a845b0d853f01f2e887ebe9fa59adf33681b853c52)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0119f9982880fc40bbf124a0d791b1e122fd4cc1cf3482afd7a46591085d73a4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d4f85133b5e9edbef858dfe23e2c6dcc96c03cbf4b8320408526490592feef8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImage]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImage]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImage]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__78724672d05c32c980bdd40bd5ca2e061ad175917858ddc25551a578bb10dbce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb064e3cce74940caa473e1653912240dcc8703e9aa17e86481a5bf9a0223032)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformation")
    def put_transformation(
        self,
        *,
        append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationAppend", typing.Dict[builtins.str, typing.Any]]]]] = None,
        aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationAspectCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationBackgroundColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationBlur", typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationChromaKey", typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationComposite", typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationCompound", typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationContrast", typing.Dict[builtins.str, typing.Any]]]]] = None,
        crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationFaceCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationFeatureCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationFitAndFill", typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationGoop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationGrayscale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationHsl", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationHsv", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfDimension", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfOrientation", typing.Dict[builtins.str, typing.Any]]]]] = None,
        im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationImQuery", typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationMaxColors", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationMirror", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationMonoHue", typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationOpacity", typing.Dict[builtins.str, typing.Any]]]]] = None,
        region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationRegionOfInterestCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationRelativeCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationRemoveColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationResize", typing.Dict[builtins.str, typing.Any]]]]] = None,
        rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationRotate", typing.Dict[builtins.str, typing.Any]]]]] = None,
        scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationScale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationShear", typing.Dict[builtins.str, typing.Any]]]]] = None,
        trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationTrim", typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationUnsharpMask", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param append: append block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        :param aspect_crop: aspect_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param crop: crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        :param face_crop: face_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        :param feature_crop: feature_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        :param fit_and_fill: fit_and_fill block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param im_query: im_query block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param region_of_interest_crop: region_of_interest_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        :param relative_crop: relative_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param resize: resize block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        :param rotate: rotate block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        :param scale: scale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param shear: shear block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        :param trim: trim block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        value = DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformation(
            append=append,
            aspect_crop=aspect_crop,
            background_color=background_color,
            blur=blur,
            chroma_key=chroma_key,
            composite=composite,
            compound=compound,
            contrast=contrast,
            crop=crop,
            face_crop=face_crop,
            feature_crop=feature_crop,
            fit_and_fill=fit_and_fill,
            goop=goop,
            grayscale=grayscale,
            hsl=hsl,
            hsv=hsv,
            if_dimension=if_dimension,
            if_orientation=if_orientation,
            im_query=im_query,
            max_colors=max_colors,
            mirror=mirror,
            mono_hue=mono_hue,
            opacity=opacity,
            region_of_interest_crop=region_of_interest_crop,
            relative_crop=relative_crop,
            remove_color=remove_color,
            resize=resize,
            rotate=rotate,
            scale=scale,
            shear=shear,
            trim=trim,
            unsharp_mask=unsharp_mask,
        )

        return typing.cast(None, jsii.invoke(self, "putTransformation", [value]))

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @jsii.member(jsii_name="resetDiameter")
    def reset_diameter(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDiameter", []))

    @jsii.member(jsii_name="resetDiameterVar")
    def reset_diameter_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDiameterVar", []))

    @jsii.member(jsii_name="resetTransformation")
    def reset_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformation", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="transformation")
    def transformation(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationOutputReference", jsii.get(self, "transformation"))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="diameterInput")
    def diameter_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "diameterInput"))

    @builtins.property
    @jsii.member(jsii_name="diameterVarInput")
    def diameter_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "diameterVarInput"))

    @builtins.property
    @jsii.member(jsii_name="transformationInput")
    def transformation_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformation"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformation"], jsii.get(self, "transformationInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d6dd14218aa5a5aa8a392e3b20cf3c83f7d494a512ebfb5c3d9d20d670227bec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6b393f662e9b0a4a07734de3e76825276308ab35b89024264c0149a9b204fc73)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="diameter")
    def diameter(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "diameter"))

    @diameter.setter
    def diameter(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__91c8a2e94e861a7b5e4068621e0b4ac62fbd01aa289a491f9b5f60b76c33ef56)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "diameter", value)

    @builtins.property
    @jsii.member(jsii_name="diameterVar")
    def diameter_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "diameterVar"))

    @diameter_var.setter
    def diameter_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d5328890ae4af6ed394cd033a5923f1dce6782f42608597bc51258e7de129776)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "diameterVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e71a8f64663139eee7b9eb0895103c25cc0564f4e3cb648504365fe6ecdf3fbc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__10b8f03aa76aebe313d8ee977c4d735420125bf3f276b92c53d13abe818d53a8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImage]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImage]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImage]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c63d0f09411a9e46beeaf64eb432a3b06c66fbb8a1fa75c1452fd277748beaec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformation",
    jsii_struct_bases=[],
    name_mapping={
        "append": "append",
        "aspect_crop": "aspectCrop",
        "background_color": "backgroundColor",
        "blur": "blur",
        "chroma_key": "chromaKey",
        "composite": "composite",
        "compound": "compound",
        "contrast": "contrast",
        "crop": "crop",
        "face_crop": "faceCrop",
        "feature_crop": "featureCrop",
        "fit_and_fill": "fitAndFill",
        "goop": "goop",
        "grayscale": "grayscale",
        "hsl": "hsl",
        "hsv": "hsv",
        "if_dimension": "ifDimension",
        "if_orientation": "ifOrientation",
        "im_query": "imQuery",
        "max_colors": "maxColors",
        "mirror": "mirror",
        "mono_hue": "monoHue",
        "opacity": "opacity",
        "region_of_interest_crop": "regionOfInterestCrop",
        "relative_crop": "relativeCrop",
        "remove_color": "removeColor",
        "resize": "resize",
        "rotate": "rotate",
        "scale": "scale",
        "shear": "shear",
        "trim": "trim",
        "unsharp_mask": "unsharpMask",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformation:
    def __init__(
        self,
        *,
        append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationAppend", typing.Dict[builtins.str, typing.Any]]]]] = None,
        aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationAspectCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationBackgroundColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationBlur", typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationChromaKey", typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationComposite", typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationCompound", typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationContrast", typing.Dict[builtins.str, typing.Any]]]]] = None,
        crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationFaceCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationFeatureCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationFitAndFill", typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationGoop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationGrayscale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationHsl", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationHsv", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfDimension", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfOrientation", typing.Dict[builtins.str, typing.Any]]]]] = None,
        im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationImQuery", typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationMaxColors", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationMirror", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationMonoHue", typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationOpacity", typing.Dict[builtins.str, typing.Any]]]]] = None,
        region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationRegionOfInterestCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationRelativeCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationRemoveColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationResize", typing.Dict[builtins.str, typing.Any]]]]] = None,
        rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationRotate", typing.Dict[builtins.str, typing.Any]]]]] = None,
        scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationScale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationShear", typing.Dict[builtins.str, typing.Any]]]]] = None,
        trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationTrim", typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationUnsharpMask", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param append: append block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        :param aspect_crop: aspect_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param crop: crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        :param face_crop: face_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        :param feature_crop: feature_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        :param fit_and_fill: fit_and_fill block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param im_query: im_query block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param region_of_interest_crop: region_of_interest_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        :param relative_crop: relative_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param resize: resize block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        :param rotate: rotate block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        :param scale: scale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param shear: shear block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        :param trim: trim block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e593c69617631d130257e37f966c90988c34dd63147a44de87e6597900acdf5d)
            check_type(argname="argument append", value=append, expected_type=type_hints["append"])
            check_type(argname="argument aspect_crop", value=aspect_crop, expected_type=type_hints["aspect_crop"])
            check_type(argname="argument background_color", value=background_color, expected_type=type_hints["background_color"])
            check_type(argname="argument blur", value=blur, expected_type=type_hints["blur"])
            check_type(argname="argument chroma_key", value=chroma_key, expected_type=type_hints["chroma_key"])
            check_type(argname="argument composite", value=composite, expected_type=type_hints["composite"])
            check_type(argname="argument compound", value=compound, expected_type=type_hints["compound"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument crop", value=crop, expected_type=type_hints["crop"])
            check_type(argname="argument face_crop", value=face_crop, expected_type=type_hints["face_crop"])
            check_type(argname="argument feature_crop", value=feature_crop, expected_type=type_hints["feature_crop"])
            check_type(argname="argument fit_and_fill", value=fit_and_fill, expected_type=type_hints["fit_and_fill"])
            check_type(argname="argument goop", value=goop, expected_type=type_hints["goop"])
            check_type(argname="argument grayscale", value=grayscale, expected_type=type_hints["grayscale"])
            check_type(argname="argument hsl", value=hsl, expected_type=type_hints["hsl"])
            check_type(argname="argument hsv", value=hsv, expected_type=type_hints["hsv"])
            check_type(argname="argument if_dimension", value=if_dimension, expected_type=type_hints["if_dimension"])
            check_type(argname="argument if_orientation", value=if_orientation, expected_type=type_hints["if_orientation"])
            check_type(argname="argument im_query", value=im_query, expected_type=type_hints["im_query"])
            check_type(argname="argument max_colors", value=max_colors, expected_type=type_hints["max_colors"])
            check_type(argname="argument mirror", value=mirror, expected_type=type_hints["mirror"])
            check_type(argname="argument mono_hue", value=mono_hue, expected_type=type_hints["mono_hue"])
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument region_of_interest_crop", value=region_of_interest_crop, expected_type=type_hints["region_of_interest_crop"])
            check_type(argname="argument relative_crop", value=relative_crop, expected_type=type_hints["relative_crop"])
            check_type(argname="argument remove_color", value=remove_color, expected_type=type_hints["remove_color"])
            check_type(argname="argument resize", value=resize, expected_type=type_hints["resize"])
            check_type(argname="argument rotate", value=rotate, expected_type=type_hints["rotate"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument shear", value=shear, expected_type=type_hints["shear"])
            check_type(argname="argument trim", value=trim, expected_type=type_hints["trim"])
            check_type(argname="argument unsharp_mask", value=unsharp_mask, expected_type=type_hints["unsharp_mask"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if append is not None:
            self._values["append"] = append
        if aspect_crop is not None:
            self._values["aspect_crop"] = aspect_crop
        if background_color is not None:
            self._values["background_color"] = background_color
        if blur is not None:
            self._values["blur"] = blur
        if chroma_key is not None:
            self._values["chroma_key"] = chroma_key
        if composite is not None:
            self._values["composite"] = composite
        if compound is not None:
            self._values["compound"] = compound
        if contrast is not None:
            self._values["contrast"] = contrast
        if crop is not None:
            self._values["crop"] = crop
        if face_crop is not None:
            self._values["face_crop"] = face_crop
        if feature_crop is not None:
            self._values["feature_crop"] = feature_crop
        if fit_and_fill is not None:
            self._values["fit_and_fill"] = fit_and_fill
        if goop is not None:
            self._values["goop"] = goop
        if grayscale is not None:
            self._values["grayscale"] = grayscale
        if hsl is not None:
            self._values["hsl"] = hsl
        if hsv is not None:
            self._values["hsv"] = hsv
        if if_dimension is not None:
            self._values["if_dimension"] = if_dimension
        if if_orientation is not None:
            self._values["if_orientation"] = if_orientation
        if im_query is not None:
            self._values["im_query"] = im_query
        if max_colors is not None:
            self._values["max_colors"] = max_colors
        if mirror is not None:
            self._values["mirror"] = mirror
        if mono_hue is not None:
            self._values["mono_hue"] = mono_hue
        if opacity is not None:
            self._values["opacity"] = opacity
        if region_of_interest_crop is not None:
            self._values["region_of_interest_crop"] = region_of_interest_crop
        if relative_crop is not None:
            self._values["relative_crop"] = relative_crop
        if remove_color is not None:
            self._values["remove_color"] = remove_color
        if resize is not None:
            self._values["resize"] = resize
        if rotate is not None:
            self._values["rotate"] = rotate
        if scale is not None:
            self._values["scale"] = scale
        if shear is not None:
            self._values["shear"] = shear
        if trim is not None:
            self._values["trim"] = trim
        if unsharp_mask is not None:
            self._values["unsharp_mask"] = unsharp_mask

    @builtins.property
    def append(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationAppend"]]]:
        '''append block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        '''
        result = self._values.get("append")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationAppend"]]], result)

    @builtins.property
    def aspect_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationAspectCrop"]]]:
        '''aspect_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        '''
        result = self._values.get("aspect_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationAspectCrop"]]], result)

    @builtins.property
    def background_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationBackgroundColor"]]]:
        '''background_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        '''
        result = self._values.get("background_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationBackgroundColor"]]], result)

    @builtins.property
    def blur(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationBlur"]]]:
        '''blur block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        '''
        result = self._values.get("blur")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationBlur"]]], result)

    @builtins.property
    def chroma_key(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationChromaKey"]]]:
        '''chroma_key block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        '''
        result = self._values.get("chroma_key")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationChromaKey"]]], result)

    @builtins.property
    def composite(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationComposite"]]]:
        '''composite block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        '''
        result = self._values.get("composite")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationComposite"]]], result)

    @builtins.property
    def compound(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationCompound"]]]:
        '''compound block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        '''
        result = self._values.get("compound")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationCompound"]]], result)

    @builtins.property
    def contrast(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationContrast"]]]:
        '''contrast block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationContrast"]]], result)

    @builtins.property
    def crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationCrop"]]]:
        '''crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        '''
        result = self._values.get("crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationCrop"]]], result)

    @builtins.property
    def face_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationFaceCrop"]]]:
        '''face_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        '''
        result = self._values.get("face_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationFaceCrop"]]], result)

    @builtins.property
    def feature_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationFeatureCrop"]]]:
        '''feature_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        '''
        result = self._values.get("feature_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationFeatureCrop"]]], result)

    @builtins.property
    def fit_and_fill(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationFitAndFill"]]]:
        '''fit_and_fill block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        '''
        result = self._values.get("fit_and_fill")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationFitAndFill"]]], result)

    @builtins.property
    def goop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationGoop"]]]:
        '''goop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        '''
        result = self._values.get("goop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationGoop"]]], result)

    @builtins.property
    def grayscale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationGrayscale"]]]:
        '''grayscale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        '''
        result = self._values.get("grayscale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationGrayscale"]]], result)

    @builtins.property
    def hsl(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationHsl"]]]:
        '''hsl block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        '''
        result = self._values.get("hsl")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationHsl"]]], result)

    @builtins.property
    def hsv(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationHsv"]]]:
        '''hsv block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        '''
        result = self._values.get("hsv")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationHsv"]]], result)

    @builtins.property
    def if_dimension(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfDimension"]]]:
        '''if_dimension block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        '''
        result = self._values.get("if_dimension")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfDimension"]]], result)

    @builtins.property
    def if_orientation(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfOrientation"]]]:
        '''if_orientation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        '''
        result = self._values.get("if_orientation")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfOrientation"]]], result)

    @builtins.property
    def im_query(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationImQuery"]]]:
        '''im_query block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        '''
        result = self._values.get("im_query")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationImQuery"]]], result)

    @builtins.property
    def max_colors(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationMaxColors"]]]:
        '''max_colors block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        '''
        result = self._values.get("max_colors")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationMaxColors"]]], result)

    @builtins.property
    def mirror(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationMirror"]]]:
        '''mirror block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        '''
        result = self._values.get("mirror")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationMirror"]]], result)

    @builtins.property
    def mono_hue(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationMonoHue"]]]:
        '''mono_hue block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        '''
        result = self._values.get("mono_hue")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationMonoHue"]]], result)

    @builtins.property
    def opacity(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationOpacity"]]]:
        '''opacity block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationOpacity"]]], result)

    @builtins.property
    def region_of_interest_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationRegionOfInterestCrop"]]]:
        '''region_of_interest_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        '''
        result = self._values.get("region_of_interest_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationRegionOfInterestCrop"]]], result)

    @builtins.property
    def relative_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationRelativeCrop"]]]:
        '''relative_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        '''
        result = self._values.get("relative_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationRelativeCrop"]]], result)

    @builtins.property
    def remove_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationRemoveColor"]]]:
        '''remove_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        '''
        result = self._values.get("remove_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationRemoveColor"]]], result)

    @builtins.property
    def resize(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationResize"]]]:
        '''resize block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        '''
        result = self._values.get("resize")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationResize"]]], result)

    @builtins.property
    def rotate(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationRotate"]]]:
        '''rotate block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        '''
        result = self._values.get("rotate")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationRotate"]]], result)

    @builtins.property
    def scale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationScale"]]]:
        '''scale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationScale"]]], result)

    @builtins.property
    def shear(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationShear"]]]:
        '''shear block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        '''
        result = self._values.get("shear")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationShear"]]], result)

    @builtins.property
    def trim(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationTrim"]]]:
        '''trim block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        '''
        result = self._values.get("trim")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationTrim"]]], result)

    @builtins.property
    def unsharp_mask(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationUnsharpMask"]]]:
        '''unsharp_mask block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        result = self._values.get("unsharp_mask")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationUnsharpMask"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationAppend",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_priority": "gravityPriority",
        "gravity_priority_var": "gravityPriorityVar",
        "gravity_var": "gravityVar",
        "preserve_minor_dimension": "preserveMinorDimension",
        "preserve_minor_dimension_var": "preserveMinorDimensionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationAppend:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationAppendImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_priority: typing.Optional[builtins.str] = None,
        gravity_priority_var: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        preserve_minor_dimension: typing.Optional[builtins.str] = None,
        preserve_minor_dimension_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Specifies where to place the ``image`` relative to the source image. The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_priority: Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal. The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority DataAkamaiImagingPolicyImage#gravity_priority}
        :param gravity_priority_var: Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal. The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority_var DataAkamaiImagingPolicyImage#gravity_priority_var}
        :param gravity_var: Specifies where to place the ``image`` relative to the source image. The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param preserve_minor_dimension: Whether to preserve the source image's minor dimension, ``false`` by default. The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension DataAkamaiImagingPolicyImage#preserve_minor_dimension}
        :param preserve_minor_dimension_var: Whether to preserve the source image's minor dimension, ``false`` by default. The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension_var DataAkamaiImagingPolicyImage#preserve_minor_dimension_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationAppendImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__031b9f5dc8e6d0de350a255ec59a59000eac3f6286cd298e6a85780f7f647977)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_priority", value=gravity_priority, expected_type=type_hints["gravity_priority"])
            check_type(argname="argument gravity_priority_var", value=gravity_priority_var, expected_type=type_hints["gravity_priority_var"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument preserve_minor_dimension", value=preserve_minor_dimension, expected_type=type_hints["preserve_minor_dimension"])
            check_type(argname="argument preserve_minor_dimension_var", value=preserve_minor_dimension_var, expected_type=type_hints["preserve_minor_dimension_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_priority is not None:
            self._values["gravity_priority"] = gravity_priority
        if gravity_priority_var is not None:
            self._values["gravity_priority_var"] = gravity_priority_var
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if preserve_minor_dimension is not None:
            self._values["preserve_minor_dimension"] = preserve_minor_dimension
        if preserve_minor_dimension_var is not None:
            self._values["preserve_minor_dimension_var"] = preserve_minor_dimension_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationAppendImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationAppendImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Specifies where to place the ``image`` relative to the source image.

        The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_priority(self) -> typing.Optional[builtins.str]:
        '''Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal.

        The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority DataAkamaiImagingPolicyImage#gravity_priority}
        '''
        result = self._values.get("gravity_priority")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_priority_var(self) -> typing.Optional[builtins.str]:
        '''Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal.

        The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority_var DataAkamaiImagingPolicyImage#gravity_priority_var}
        '''
        result = self._values.get("gravity_priority_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Specifies where to place the ``image`` relative to the source image.

        The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def preserve_minor_dimension(self) -> typing.Optional[builtins.str]:
        '''Whether to preserve the source image's minor dimension, ``false`` by default.

        The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension DataAkamaiImagingPolicyImage#preserve_minor_dimension}
        '''
        result = self._values.get("preserve_minor_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def preserve_minor_dimension_var(self) -> typing.Optional[builtins.str]:
        '''Whether to preserve the source image's minor dimension, ``false`` by default.

        The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension_var DataAkamaiImagingPolicyImage#preserve_minor_dimension_var}
        '''
        result = self._values.get("preserve_minor_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationAppend(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationAppendImage",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationAppendImage:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationAppendImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationAppendImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationAppendImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__56ec11d579bc3e47d0c70fce189e4e95844dd939522b5bf445c8bb1be452184e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationAppendImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationAppendImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationAppendImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e72e9b4ed9a2f827e14967cdbfa758e64182ab4e8b872d36d267137220c6e677)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationAppendList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationAppendList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__febd5f0ebe374ab2c5ecd4d2829959981148cfb4baacae7ce6c4b86b9a0e05e2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationAppendOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__581e6c813528ddf29f66c3b0368efd1d8f4804794a45c6018e356ef8fbf21fad)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationAppendOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__49c508fa8ea47ed14db4d70e0cc9606e51793172bbc129eb362d9ab9a31bab64)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dc23d933c1185ffce38ceb4ca83bf9fcf0867b7c72705d79bc02954fa91fa76d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__adbf3b80d44328f8439018a888c1c533d794d7cdab3c7b7d1b88cece4fbcd423)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationAppend]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationAppend]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationAppend]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__77549b1b141b492c196f90d32a1171f78d78188f0a6716018dbfec6eda201d06)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationAppendOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationAppendOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6af847561853d928adb3f049fbe5e4c07e6d024163d565a5b51c12e0aea04582)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationAppendImage()

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityPriority")
    def reset_gravity_priority(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityPriority", []))

    @jsii.member(jsii_name="resetGravityPriorityVar")
    def reset_gravity_priority_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityPriorityVar", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPreserveMinorDimension")
    def reset_preserve_minor_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPreserveMinorDimension", []))

    @jsii.member(jsii_name="resetPreserveMinorDimensionVar")
    def reset_preserve_minor_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPreserveMinorDimensionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationAppendImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationAppendImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityInput")
    def gravity_priority_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityPriorityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityVarInput")
    def gravity_priority_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityPriorityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationAppendImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationAppendImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionInput")
    def preserve_minor_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "preserveMinorDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionVarInput")
    def preserve_minor_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "preserveMinorDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ba965d4341d6f26a7499562bc1486e06a32d903e47df373c50cb916a5561c58)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityPriority")
    def gravity_priority(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityPriority"))

    @gravity_priority.setter
    def gravity_priority(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1e71108f6e1f5e216f4fb4e6f7e0bf36c14947a3256f66f5b3708e4bd5df9d9f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityPriority", value)

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityVar")
    def gravity_priority_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityPriorityVar"))

    @gravity_priority_var.setter
    def gravity_priority_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1ee8decea5dda1e60e8757e1f95ce4b5f70ac68f0e1a04c1cc936e01e150b579)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityPriorityVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a030b310a749dbbf206377299479717d5b7c34ecc67ac5cc024b10f9c921b3e2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimension")
    def preserve_minor_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "preserveMinorDimension"))

    @preserve_minor_dimension.setter
    def preserve_minor_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__35c4d9eab25f685e29c0e802c93f9c49244229c3137cd44284257721695b287c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "preserveMinorDimension", value)

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionVar")
    def preserve_minor_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "preserveMinorDimensionVar"))

    @preserve_minor_dimension_var.setter
    def preserve_minor_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3055b3eb7e558272c5812362d036bcbe2d712997e3c1ac94cbcf7ae739ef4208)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "preserveMinorDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationAppend]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationAppend]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationAppend]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__09a831d79aef9da0745886b52ba76545b9b7eac18ec2f08dc47dededaa3f2021)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationAspectCrop",
    jsii_struct_bases=[],
    name_mapping={
        "allow_expansion": "allowExpansion",
        "allow_expansion_var": "allowExpansionVar",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationAspectCrop:
    def __init__(
        self,
        *,
        allow_expansion: typing.Optional[builtins.str] = None,
        allow_expansion_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_expansion: Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image. Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        :param allow_expansion_var: Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image. Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        :param height: The height term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The width term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        :param x_position: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cf5ff2b1471e036d0f98dbec761b6ed531e9111d5fb749311c4aa66678c3976e)
            check_type(argname="argument allow_expansion", value=allow_expansion, expected_type=type_hints["allow_expansion"])
            check_type(argname="argument allow_expansion_var", value=allow_expansion_var, expected_type=type_hints["allow_expansion_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if allow_expansion is not None:
            self._values["allow_expansion"] = allow_expansion
        if allow_expansion_var is not None:
            self._values["allow_expansion_var"] = allow_expansion_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def allow_expansion(self) -> typing.Optional[builtins.str]:
        '''Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image.

        Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        '''
        result = self._values.get("allow_expansion")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def allow_expansion_var(self) -> typing.Optional[builtins.str]:
        '''Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image.

        Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        '''
        result = self._values.get("allow_expansion_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationAspectCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationAspectCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationAspectCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e8fb593d12f61fe7f52b43cec40bb1a9f028dd50bb52fdf3941da438b2ac4179)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationAspectCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f6cb822d0503d8e5982bcee2d43a0a82f9726f69ee69d473ddcd46b74b7c8eb6)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationAspectCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e8d1609460515c2ec174dc306c983c4c1bae6958ec6cb229247113043dccf1ca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ef529417c5f754ef1f05fcef1e3dfc8aed9ee318f5344635e272c673d2d4f5a1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f794e6280056ff093414b18bc928c2ff94ca8c7422682ca9a9b25c605ad6d4e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationAspectCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationAspectCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationAspectCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a17127d7b950299ba793195a8ae29214d2dae9aeb568b0af680df8e04163e93e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationAspectCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationAspectCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__743d557e9153f96bd3e46c27057e729cdbd92a960e2ed03e2bc3d5db24d311c7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAllowExpansion")
    def reset_allow_expansion(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansion", []))

    @jsii.member(jsii_name="resetAllowExpansionVar")
    def reset_allow_expansion_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansionVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionInput")
    def allow_expansion_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVarInput")
    def allow_expansion_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansion")
    def allow_expansion(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansion"))

    @allow_expansion.setter
    def allow_expansion(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8b479a47f9e7f86849d996fc57700a7260d578000221fa75b159328ed40808bc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansion", value)

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVar")
    def allow_expansion_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansionVar"))

    @allow_expansion_var.setter
    def allow_expansion_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__425662a2e8064934d9b9a6ed3713473ef58e49f49bb356315e5cf1754eb7ed33)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansionVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9386561180c016fc8f9a6bd3adf39df9125daea7d726f3fea7a155ea3c636f53)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__974a598e2f63b3fe026edbb90e6712ef4e7b732774c3241e67f705a36633a847)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8925b697e91f4430b198a9e421a97e8ac76cfc4340cb932a2640f40279f6594a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3dd0cf140a0be033541b008caa0aea8c126981d532824dc661e926530ce04a25)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__270171f7b07b6ff691c0a33be3e2c6d992e1f10b275ee91f70870095af18238b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c813ffad4515ccdc6207dbda98f7193b412eb2ae8d6abef85b39e196ca9eaf27)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fbd0020b6980f9924171a48108e5bc6af8d4b4284906b25985c21c32c2fef818)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__337459a500ff3364391419b56a494338ce0b5cfcce0d4e39a21137193ce97b65)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationAspectCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationAspectCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationAspectCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__255e25ccf323a90a14db824c21ef7e8541b0b847ea33a88a24484aa6ed3037fd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationBackgroundColor",
    jsii_struct_bases=[],
    name_mapping={"color": "color", "color_var": "colorVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationBackgroundColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1654cb92ecebcf975dcf80e953edc6d4b8936b8e79f4bbdd8739380b172b09a9)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationBackgroundColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationBackgroundColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationBackgroundColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e8ef5281487629ae4534afb9403e6afb4bab612806877cc5e6f9fb4be0b0b922)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationBackgroundColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b9034ab79a8c5cf2a9b7d42ddefa7662b85ad9f3c6db3beb22d0e625321d12f2)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationBackgroundColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__128a72c0c0b266e24862dd9a044315bcf6fbeeffb06300e988e56be93e95a9b1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ddcd475ff43bb2d7284f0f511ce90e6d602c72c187748bb3bb8d1cd41cfc21cf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__781078b4fefbc47c4682b95c5c706b1c349628c47ffcb488cff35c795be74ccb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationBackgroundColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationBackgroundColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2f6fe472f2e67809a9c027d5c6872e99cde37431e785227a0eb4eca149921dce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationBackgroundColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationBackgroundColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__35f3162b378516256b3876c7117297753d42b6f9efe3fdc0e367d498af32f2c3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6daaba9582995a152baa836e55c2d8276a7a7628af5f57fd4582a50edbd579bc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c76f2d7449529470e7e536c9a504c1307bdad1543794218c8a8c1c7ccf7c3a77)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationBackgroundColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationBackgroundColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationBackgroundColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ad9943b3ad0900e5aa332cc216420604bef7a61673051e2e667bd45c52d2d150)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationBlur",
    jsii_struct_bases=[],
    name_mapping={"sigma": "sigma", "sigma_var": "sigmaVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationBlur:
    def __init__(
        self,
        *,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param sigma: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8b2cf0e640bac8f01972650b10f445f0a53a311ff6662742203cbdcd009ae3f6)
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationBlur(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationBlurList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationBlurList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d38ea603394885fc7cb4ac868b223230332cc0229a4df41e1e884d4d75562b40)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationBlurOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__40f12c1caf779c46eaca686b8a33f34435f799de8c804c7c0a66943553f9fb08)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationBlurOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f2412688b6163c4fc3a283e2f85f6dbe0abf2d7ad6f0a180fe92a260988ad2bd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c91043d2b580f91ddf9de26e7dc496cf6084cc51517038700b282be9f797ed95)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__891d379f3e64767c87e43f28b47cea02d5003ba679644f22c6ff2c5dd75c6cc7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationBlur]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationBlur]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0c2ecdb47106cd01c7d5f1bc06351516a4006ef95aba71fddad57573c040e417)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationBlurOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationBlurOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__11f03988d27001e6a52556c244837ba3c5171e4958857b51b1fdb29685d34d8d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__978b001aef966e443990e6e39cda7902b9c9e9d696d1018a7164ce2abe0b85c7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__57bd5a7ef333c488ca63ef5146bf11e91b5c95728dfe69fe1e941a235ccd7f58)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationBlur]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationBlur]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationBlur]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__58a2437760e2d421f79ce19ed72c7d9eb583611c5a3086a605f4098a0e7932e1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationChromaKey",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_feather": "hueFeather",
        "hue_feather_var": "hueFeatherVar",
        "hue_tolerance": "hueTolerance",
        "hue_tolerance_var": "hueToleranceVar",
        "hue_var": "hueVar",
        "lightness_feather": "lightnessFeather",
        "lightness_feather_var": "lightnessFeatherVar",
        "lightness_tolerance": "lightnessTolerance",
        "lightness_tolerance_var": "lightnessToleranceVar",
        "saturation_feather": "saturationFeather",
        "saturation_feather_var": "saturationFeatherVar",
        "saturation_tolerance": "saturationTolerance",
        "saturation_tolerance_var": "saturationToleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationChromaKey:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_feather: typing.Optional[builtins.str] = None,
        hue_feather_var: typing.Optional[builtins.str] = None,
        hue_tolerance: typing.Optional[builtins.str] = None,
        hue_tolerance_var: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness_feather: typing.Optional[builtins.str] = None,
        lightness_feather_var: typing.Optional[builtins.str] = None,
        lightness_tolerance: typing.Optional[builtins.str] = None,
        lightness_tolerance_var: typing.Optional[builtins.str] = None,
        saturation_feather: typing.Optional[builtins.str] = None,
        saturation_feather_var: typing.Optional[builtins.str] = None,
        saturation_tolerance: typing.Optional[builtins.str] = None,
        saturation_tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_feather: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        :param hue_feather_var: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        :param hue_tolerance: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        :param hue_tolerance_var: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        :param hue_var: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness_feather: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        :param lightness_feather_var: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        :param lightness_tolerance: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        :param lightness_tolerance_var: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        :param saturation_feather: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        :param saturation_feather_var: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        :param saturation_tolerance: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        :param saturation_tolerance_var: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fd359383794185ce92587e0a78faa649f8073c02ba7cb6a314971660a2b09754)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_feather", value=hue_feather, expected_type=type_hints["hue_feather"])
            check_type(argname="argument hue_feather_var", value=hue_feather_var, expected_type=type_hints["hue_feather_var"])
            check_type(argname="argument hue_tolerance", value=hue_tolerance, expected_type=type_hints["hue_tolerance"])
            check_type(argname="argument hue_tolerance_var", value=hue_tolerance_var, expected_type=type_hints["hue_tolerance_var"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness_feather", value=lightness_feather, expected_type=type_hints["lightness_feather"])
            check_type(argname="argument lightness_feather_var", value=lightness_feather_var, expected_type=type_hints["lightness_feather_var"])
            check_type(argname="argument lightness_tolerance", value=lightness_tolerance, expected_type=type_hints["lightness_tolerance"])
            check_type(argname="argument lightness_tolerance_var", value=lightness_tolerance_var, expected_type=type_hints["lightness_tolerance_var"])
            check_type(argname="argument saturation_feather", value=saturation_feather, expected_type=type_hints["saturation_feather"])
            check_type(argname="argument saturation_feather_var", value=saturation_feather_var, expected_type=type_hints["saturation_feather_var"])
            check_type(argname="argument saturation_tolerance", value=saturation_tolerance, expected_type=type_hints["saturation_tolerance"])
            check_type(argname="argument saturation_tolerance_var", value=saturation_tolerance_var, expected_type=type_hints["saturation_tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_feather is not None:
            self._values["hue_feather"] = hue_feather
        if hue_feather_var is not None:
            self._values["hue_feather_var"] = hue_feather_var
        if hue_tolerance is not None:
            self._values["hue_tolerance"] = hue_tolerance
        if hue_tolerance_var is not None:
            self._values["hue_tolerance_var"] = hue_tolerance_var
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness_feather is not None:
            self._values["lightness_feather"] = lightness_feather
        if lightness_feather_var is not None:
            self._values["lightness_feather_var"] = lightness_feather_var
        if lightness_tolerance is not None:
            self._values["lightness_tolerance"] = lightness_tolerance
        if lightness_tolerance_var is not None:
            self._values["lightness_tolerance_var"] = lightness_tolerance_var
        if saturation_feather is not None:
            self._values["saturation_feather"] = saturation_feather
        if saturation_feather_var is not None:
            self._values["saturation_feather_var"] = saturation_feather_var
        if saturation_tolerance is not None:
            self._values["saturation_tolerance"] = saturation_tolerance
        if saturation_tolerance_var is not None:
            self._values["saturation_tolerance_var"] = saturation_tolerance_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        '''
        result = self._values.get("hue_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        '''
        result = self._values.get("hue_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        '''
        result = self._values.get("hue_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        '''
        result = self._values.get("hue_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        '''
        result = self._values.get("lightness_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        '''
        result = self._values.get("lightness_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        '''
        result = self._values.get("lightness_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        '''
        result = self._values.get("lightness_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        '''
        result = self._values.get("saturation_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        '''
        result = self._values.get("saturation_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        '''
        result = self._values.get("saturation_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        result = self._values.get("saturation_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationChromaKey(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationChromaKeyList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationChromaKeyList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ce0e786cb2e3a86db17fddd3420dd0b3947cdfc53b0d78857ebe189b72e0525a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationChromaKeyOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5018d6305d556e30e610ad57afe1e90d4505abe25ef03c2aa86e00d9a073424c)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationChromaKeyOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__12119e14c786fb8c0fe2126c387d6985c14f89d4775374d5c693a2890d53c1af)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__67afc6a7d9e4367df25e5dcca41eb7a988920389e83e0787932c116c5ffde749)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9533e0295edc0c389366164c195cbc15a18b1e53e9d11b9ab519174d99cf783e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationChromaKey]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationChromaKey]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bdd0bfb4e601baea64be6597b9d99a5b98f6f6523efc56e978f2478859c5d3eb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationChromaKeyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationChromaKeyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bdcc7bb3761d0034b55cd57bfc318ef01e9fc6f5c05b755e21ede8e0bac9ff00)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueFeather")
    def reset_hue_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeather", []))

    @jsii.member(jsii_name="resetHueFeatherVar")
    def reset_hue_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeatherVar", []))

    @jsii.member(jsii_name="resetHueTolerance")
    def reset_hue_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueTolerance", []))

    @jsii.member(jsii_name="resetHueToleranceVar")
    def reset_hue_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueToleranceVar", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightnessFeather")
    def reset_lightness_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeather", []))

    @jsii.member(jsii_name="resetLightnessFeatherVar")
    def reset_lightness_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeatherVar", []))

    @jsii.member(jsii_name="resetLightnessTolerance")
    def reset_lightness_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessTolerance", []))

    @jsii.member(jsii_name="resetLightnessToleranceVar")
    def reset_lightness_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessToleranceVar", []))

    @jsii.member(jsii_name="resetSaturationFeather")
    def reset_saturation_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeather", []))

    @jsii.member(jsii_name="resetSaturationFeatherVar")
    def reset_saturation_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeatherVar", []))

    @jsii.member(jsii_name="resetSaturationTolerance")
    def reset_saturation_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationTolerance", []))

    @jsii.member(jsii_name="resetSaturationToleranceVar")
    def reset_saturation_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherInput")
    def hue_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVarInput")
    def hue_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceInput")
    def hue_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVarInput")
    def hue_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherInput")
    def lightness_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVarInput")
    def lightness_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceInput")
    def lightness_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVarInput")
    def lightness_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherInput")
    def saturation_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVarInput")
    def saturation_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceInput")
    def saturation_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVarInput")
    def saturation_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f1a33be938aab30b081146cabead6650ebc48dd31f6cb63bd780f38fba007a50)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeather")
    def hue_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeather"))

    @hue_feather.setter
    def hue_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5fd3472e9bc39becb6c6522d30f6ca1afe83a30be9a013f5ae65bba312f99cdb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeather", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVar")
    def hue_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeatherVar"))

    @hue_feather_var.setter
    def hue_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__da8fa36f87f59c35e1f963c68feb771fe79d0208d774ccb8c81eefb3c932436c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueTolerance")
    def hue_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueTolerance"))

    @hue_tolerance.setter
    def hue_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab5244e86e4d23359b27dd7bba37697fc63aa7bbc45fff6a1b8c89d305777510)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVar")
    def hue_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueToleranceVar"))

    @hue_tolerance_var.setter
    def hue_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7e37afc5bf13fd3545ee36ce2c0af62595a043a325e0617d34533d83647f6206)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c2f1bf271229bd053bc47d6b5cd19948542e281cf6a1f82da91e77e6de7c3f84)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeather")
    def lightness_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeather"))

    @lightness_feather.setter
    def lightness_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e8d1aa935b66de6912a672b770384259a9170c82853a998ddac148d66b0b6c1c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeather", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVar")
    def lightness_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeatherVar"))

    @lightness_feather_var.setter
    def lightness_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__78d151a0e0c8666d69c0a5e8206cc2448298dfaba24a858c200fa9e71df0ebde)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessTolerance")
    def lightness_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessTolerance"))

    @lightness_tolerance.setter
    def lightness_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eccb505acc1b4b58cf0c79e374d973e468246d813e18bbc2d76614085c504430)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVar")
    def lightness_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessToleranceVar"))

    @lightness_tolerance_var.setter
    def lightness_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a85891f8d91f8995fd1f9c4c5228d881671dcd436e8908746c3cb462485518de)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeather")
    def saturation_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeather"))

    @saturation_feather.setter
    def saturation_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__04958afdcdeae9b8d77baab9015d651a71c0a6f8697f6a8f28a295e45072ebeb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeather", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVar")
    def saturation_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeatherVar"))

    @saturation_feather_var.setter
    def saturation_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3603183827195847a60203257ef6f8f6076ba45d51e30eb3bb5d91ee432aeddd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationTolerance")
    def saturation_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationTolerance"))

    @saturation_tolerance.setter
    def saturation_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1125f66d0994ba97566de193e342370b5c016cf717fea7b88d11bfa16df2b859)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVar")
    def saturation_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationToleranceVar"))

    @saturation_tolerance_var.setter
    def saturation_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1a405c13565d9349c08fa3e50d43e2b883bd91d95e6b3a05913b7899fa1c94e9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationChromaKey]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationChromaKey]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationChromaKey]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__30db4bcafafb151a437fa80b5c170968022fd82334a48f102260e2029701d2d3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationComposite",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "placement": "placement",
        "placement_var": "placementVar",
        "scale": "scale",
        "scale_dimension": "scaleDimension",
        "scale_dimension_var": "scaleDimensionVar",
        "scale_var": "scaleVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationComposite:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationCompositeImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        placement: typing.Optional[builtins.str] = None,
        placement_var: typing.Optional[builtins.str] = None,
        scale: typing.Optional[builtins.str] = None,
        scale_dimension: typing.Optional[builtins.str] = None,
        scale_dimension_var: typing.Optional[builtins.str] = None,
        scale_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param placement: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        :param placement_var: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        :param scale: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param scale_dimension: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        :param scale_dimension_var: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        :param scale_var: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        :param x_position: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationCompositeImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6c1e3f9ace6736ad7ad3c33da953f1f0d69a9b5e0c2a9e6c5d54e6faa59c3e4d)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument placement", value=placement, expected_type=type_hints["placement"])
            check_type(argname="argument placement_var", value=placement_var, expected_type=type_hints["placement_var"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument scale_dimension", value=scale_dimension, expected_type=type_hints["scale_dimension"])
            check_type(argname="argument scale_dimension_var", value=scale_dimension_var, expected_type=type_hints["scale_dimension_var"])
            check_type(argname="argument scale_var", value=scale_var, expected_type=type_hints["scale_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if placement is not None:
            self._values["placement"] = placement
        if placement_var is not None:
            self._values["placement_var"] = placement_var
        if scale is not None:
            self._values["scale"] = scale
        if scale_dimension is not None:
            self._values["scale_dimension"] = scale_dimension
        if scale_dimension_var is not None:
            self._values["scale_dimension_var"] = scale_dimension_var
        if scale_var is not None:
            self._values["scale_var"] = scale_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationCompositeImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationCompositeImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        '''
        result = self._values.get("placement")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement_var(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        '''
        result = self._values.get("placement_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        '''
        result = self._values.get("scale_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        '''
        result = self._values.get("scale_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        '''
        result = self._values.get("scale_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationComposite(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationCompositeImage",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationCompositeImage:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationCompositeImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationCompositeImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationCompositeImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__971b1eca754e4a747ab7828f3332c82b371c0cfa65e04337138a49a7c65be73c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationCompositeImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationCompositeImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__68df4d41254120417aa63b295fdaad319989bf6a9c730eefc0762ebcde6892cb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationCompositeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationCompositeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__905367733ee6c683470a22ca53d41ebb3f6b73f5ef42c9818c3b54317613a77f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationCompositeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__507be29d02164ecf0480a868870e357f3ae04b2cfd676a7620aa3b8ef04daa9b)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationCompositeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b90d9f7cc5e3d6cb99b87d99d143c07bd4918d45fbd68fdef4a3bbd23f709d69)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2aef74deffe1508c387112e68c9352d7d4b5cb413385d732bc1c3bec6300c524)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ee94e6ffcc3d6be66f8b489fde725c40cfdcbaecd28378b9aa5c1144904e6a6e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationComposite]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationComposite]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f2ebcc49134337296bc791438235784f3e4da447c40512578ab02972c9e0a275)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationCompositeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationCompositeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d34ae57b839760211e8e5b7656051098eee77d90aa3dd5013ba58e1ebe98f5b6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationCompositeImage()

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPlacement")
    def reset_placement(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacement", []))

    @jsii.member(jsii_name="resetPlacementVar")
    def reset_placement_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacementVar", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetScaleDimension")
    def reset_scale_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimension", []))

    @jsii.member(jsii_name="resetScaleDimensionVar")
    def reset_scale_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimensionVar", []))

    @jsii.member(jsii_name="resetScaleVar")
    def reset_scale_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationCompositeImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationCompositeImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationCompositeImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="placementInput")
    def placement_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementInput"))

    @builtins.property
    @jsii.member(jsii_name="placementVarInput")
    def placement_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionInput")
    def scale_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVarInput")
    def scale_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleVarInput")
    def scale_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1d8936192113969cf631b5fade2d903bd4ed89736f9d7632b530caa206b36028)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2e4b39626f9a0fd14e5e6b043051aae09efe08a2bde8ccea998c6602eba252e1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="placement")
    def placement(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placement"))

    @placement.setter
    def placement(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d7ede5e5ac1031cbc71d964cc418091000063623dbad41ddd8e88d9fff2fc1cb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placement", value)

    @builtins.property
    @jsii.member(jsii_name="placementVar")
    def placement_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placementVar"))

    @placement_var.setter
    def placement_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1ab6703197502f7af55e853ca883bbae047e26a36bcc62927ade41aac8e681b7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placementVar", value)

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scale"))

    @scale.setter
    def scale(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ba73d710e06144d23c00588e96e73581c76c4c254f058c1dafef7eb99a0be3d5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scale", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimension")
    def scale_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimension"))

    @scale_dimension.setter
    def scale_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dd4e3ebf835e48be8325e29485d8b4ce716d13fcfbc88dea2c0e3d8c4e57c0ba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimension", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVar")
    def scale_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimensionVar"))

    @scale_dimension_var.setter
    def scale_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0de08673bae5e664a777057a223aa781b05c9917d78faa085e85c52b5fce3e85)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="scaleVar")
    def scale_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleVar"))

    @scale_var.setter
    def scale_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5b9a7ae9046c7d05844721f82eb35540ad24e116aa5690b1aba1061d0684bd9a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa7cf25388ec62811bb75c7166705f26bac88461f9e1a264fa651413bb13828e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__861673fd28f01fe02457cf893cd5d87e7f1f3861a786606ad03462f64dee2b35)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e4b65e402550fe742a9d9ebd0c1194a4b2bdbe6e9204adb6d5c345cd060ba0f7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__69ceea4808d34e1f4ce6e0944bfd5de870833d9bc34731dc4d746b3c2ec68c38)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationComposite]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationComposite]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationComposite]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ea2d92fc7a7742fa520af4d8ece639b13f23fa550989e29dfdcc956b2d85275)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationCompound",
    jsii_struct_bases=[],
    name_mapping={"transformations": "transformations"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationCompound:
    def __init__(
        self,
        *,
        transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param transformations: transformations block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7c0267d18aa144cd2bf8d11b31facf7033a5ba1e6785cd090e2686925040243d)
            check_type(argname="argument transformations", value=transformations, expected_type=type_hints["transformations"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if transformations is not None:
            self._values["transformations"] = transformations

    @builtins.property
    def transformations(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationCompoundTransformations"]]]:
        '''transformations block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        result = self._values.get("transformations")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationCompoundTransformations"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationCompound(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationCompoundList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationCompoundList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d3f31fbfcf8625cbc48500d77ebdbab7a125db9e1978ed210f64016fdf06394f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationCompoundOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0a866e9feea189eb9b5e128d0160c8bf7fb1e729164302fefcd00621b33421c6)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationCompoundOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1e1b028f92913fc990068c6f62fa3fc4e43ea0ceb0e69b9e82d2c9c63974cf46)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f7440f0052076d5d5972133946f127776bc2b6a5a604b05b006504e267f770a8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e4e386d17c55e0128c41e1720f39c0af4c551d7f4527a510ddfb40b45357f1fe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationCompound]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationCompound]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aba7cdadf729bacfd0e1420a7bfc751851eb7ff6c56889b18124bae643d39e3a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationCompoundOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationCompoundOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__242d3137b9ce861e00b032a21ed8bfed15184ebf613425aa8aa9b0fbdc72d410)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformations")
    def put_transformations(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__674a6aee420ce438b3d4d92e42beee6ef1ee348ce2f1a19ba69c13840e93fcc2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTransformations", [value]))

    @jsii.member(jsii_name="resetTransformations")
    def reset_transformations(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformations", []))

    @builtins.property
    @jsii.member(jsii_name="transformations")
    def transformations(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationCompoundTransformationsList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationCompoundTransformationsList", jsii.get(self, "transformations"))

    @builtins.property
    @jsii.member(jsii_name="transformationsInput")
    def transformations_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationCompoundTransformations"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationCompoundTransformations"]]], jsii.get(self, "transformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationCompound]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationCompound]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationCompound]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b4231d03e8473fb0ad09d0abc9841ac55aec7b32ab418f2213c10e4c040fc4b0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationCompoundTransformations",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationCompoundTransformations:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationCompoundTransformations(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationCompoundTransformationsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationCompoundTransformationsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e817cb5a90754141a0ffed8ef83eb40ec6ccecc99951c18c6009264098211ca5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationCompoundTransformationsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8d4e756f5f6ced58aae094d54208ff5513f7de49304c8f7616cd319cae376a9f)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationCompoundTransformationsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f86a0c676c6b91064f3140a415e59b33c2d989cf21a6d4fc3e9155cb77b9e1a8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d558edc3372e9b831311b3b2d7bbd154dcc2baeba98b4c8e1eead662463a147)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5abec25c6d584175d66f87b2bc67aa454c3fb27275705af33d96cc42820a0636)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationCompoundTransformations]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationCompoundTransformations]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationCompoundTransformations]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b79790fb576a670f102b1eed5af94a52cf86b4853da3d16855e2e97b98973d78)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationCompoundTransformationsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationCompoundTransformationsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a2e1b409be81ce8457c206663c9ea016253c1a9b4aeae9fe4c96fe671a6e945e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationCompoundTransformations]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationCompoundTransformations]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationCompoundTransformations]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__079c1ebe42f443a95f337f2b898eee3f5deda01cb8e447e1545b0727b5309715)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationContrast",
    jsii_struct_bases=[],
    name_mapping={
        "brightness": "brightness",
        "brightness_var": "brightnessVar",
        "contrast": "contrast",
        "contrast_var": "contrastVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationContrast:
    def __init__(
        self,
        *,
        brightness: typing.Optional[builtins.str] = None,
        brightness_var: typing.Optional[builtins.str] = None,
        contrast: typing.Optional[builtins.str] = None,
        contrast_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param brightness: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        :param brightness_var: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        :param contrast: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param contrast_var: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d6d0761e7608877bf98d33c39727fc86b0420e02f9f86d058638fcb5c5898f26)
            check_type(argname="argument brightness", value=brightness, expected_type=type_hints["brightness"])
            check_type(argname="argument brightness_var", value=brightness_var, expected_type=type_hints["brightness_var"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument contrast_var", value=contrast_var, expected_type=type_hints["contrast_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if brightness is not None:
            self._values["brightness"] = brightness
        if brightness_var is not None:
            self._values["brightness_var"] = brightness_var
        if contrast is not None:
            self._values["contrast"] = contrast
        if contrast_var is not None:
            self._values["contrast_var"] = contrast_var

    @builtins.property
    def brightness(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        '''
        result = self._values.get("brightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def brightness_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        '''
        result = self._values.get("brightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        result = self._values.get("contrast_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationContrast(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationContrastList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationContrastList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8735ff8add76e3d613a59d827b26dd77f7d535d380fad2f7814a41e1ea595e08)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationContrastOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7cdc8013fb1c14c043134e28a2aa7d40c185dbf844422bbdc4847771394bb987)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationContrastOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ff09347668fcd4fa6a4da1dc42bc48d4ef7cf75dfb909144850ca73e77df981c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d01ca45199b7eb042a899b4dc38fcefa454d9921bdf03032e360fff3cb55ffa6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__beb5b912c31a32a947412362a4d317d021cc164ab157ea521429d5a68789ff9d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationContrast]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationContrast]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4d49d634facc3f537ee2a032a688e8520b32824266fd2760e41e7f824ca7519d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationContrastOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationContrastOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e7425e17b0175de0eba1223d450fb6961afe486cf0792ace3538327427b9e3f9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetBrightness")
    def reset_brightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightness", []))

    @jsii.member(jsii_name="resetBrightnessVar")
    def reset_brightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightnessVar", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetContrastVar")
    def reset_contrast_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrastVar", []))

    @builtins.property
    @jsii.member(jsii_name="brightnessInput")
    def brightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="brightnessVarInput")
    def brightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastVarInput")
    def contrast_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="brightness")
    def brightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightness"))

    @brightness.setter
    def brightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b08e1cd8ad4a86776ef73a879d0824ded980ee5aa0b3ec370f24162b81f6f71a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightness", value)

    @builtins.property
    @jsii.member(jsii_name="brightnessVar")
    def brightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightnessVar"))

    @brightness_var.setter
    def brightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a41aa03805f1a3f0fbec84e7cb8b919875cfb8db4295c6c711f5828c3119e78a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrast"))

    @contrast.setter
    def contrast(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e3948739627c625c5bd15dd79cbc30d3751afaf342f92d5642418ce5a22d9438)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrast", value)

    @builtins.property
    @jsii.member(jsii_name="contrastVar")
    def contrast_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrastVar"))

    @contrast_var.setter
    def contrast_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a1f0d01685edf9cd00ceb78b691e1f428546e732c6dda10abfeafd9eeade7a83)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrastVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationContrast]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationContrast]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationContrast]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f7961823d43c9ae250bb2c9d705c34c50805fcfedfe9ee135ddbf24f1c4188fb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationCrop",
    jsii_struct_bases=[],
    name_mapping={
        "allow_expansion": "allowExpansion",
        "allow_expansion_var": "allowExpansionVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationCrop:
    def __init__(
        self,
        *,
        allow_expansion: typing.Optional[builtins.str] = None,
        allow_expansion_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_expansion: If cropping an area outside of the existing canvas, expands the image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        :param allow_expansion_var: If cropping an area outside of the existing canvas, expands the image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        :param gravity: Frame of reference for X and Y Positions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Frame of reference for X and Y Positions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The number of pixels to crop along the y-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The number of pixels to crop along the y-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The number of pixels to crop along the x-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The number of pixels to crop along the x-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        :param x_position: The x-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cda57196c4d1ccd62781ae843a71dcfbff962b4b9b08a9267ea6a60807204116)
            check_type(argname="argument allow_expansion", value=allow_expansion, expected_type=type_hints["allow_expansion"])
            check_type(argname="argument allow_expansion_var", value=allow_expansion_var, expected_type=type_hints["allow_expansion_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if allow_expansion is not None:
            self._values["allow_expansion"] = allow_expansion
        if allow_expansion_var is not None:
            self._values["allow_expansion_var"] = allow_expansion_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def allow_expansion(self) -> typing.Optional[builtins.str]:
        '''If cropping an area outside of the existing canvas, expands the image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        '''
        result = self._values.get("allow_expansion")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def allow_expansion_var(self) -> typing.Optional[builtins.str]:
        '''If cropping an area outside of the existing canvas, expands the image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        '''
        result = self._values.get("allow_expansion_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Frame of reference for X and Y Positions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Frame of reference for X and Y Positions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the y-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the y-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the x-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the x-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4f18fa5225570674f2d2de38c8d3919387ca07f12accb1e93496549a0d46a28c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__438bd80d9e816f7a1b529d31281907429341b1ffbadf0bd185ce7ef3edf658aa)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1093cbc97f6df7014dc678d61865af41378f18bd1dc6116a15b4eb1d96b78eda)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__66f33e45a4b49a238207a09e6a5345d806d6d4cf5906af4225018de877d17775)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__558cb88cb6fb53c2137d3c2fbce6efd71a3a65fb991ff84b5c98647ba8aca9b2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7ebbd1b3b6ffc62fb28733a01330e4a4797613adcff0e2f242b875c8763f01b7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__db1a8708fd0fcd7b73eed6bf7635bbd66458388a43d884ef776240e8fe21cb3f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAllowExpansion")
    def reset_allow_expansion(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansion", []))

    @jsii.member(jsii_name="resetAllowExpansionVar")
    def reset_allow_expansion_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansionVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionInput")
    def allow_expansion_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVarInput")
    def allow_expansion_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansion")
    def allow_expansion(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansion"))

    @allow_expansion.setter
    def allow_expansion(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__01d6cea248d637f4db19f3007d8aa100f67ebb97017aec9fa71111a931a11374)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansion", value)

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVar")
    def allow_expansion_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansionVar"))

    @allow_expansion_var.setter
    def allow_expansion_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f864160794f628f990d77fc12a18b3763b4cf4957da581a1ecb849ea1c95e028)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansionVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bd51540a44f5708c6b356ab3e902ecc7cb2c61e05441f134978b06015b085686)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__413a8b59af0b84824491fdc7c4557ba2c51d3655c93686fb106cd9b2163b8c26)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__25510fca43eb652e1844e6550bf2f0702a05ed173692410fdd986c54fdbaffb6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4d4f7762a51bd61f5b576d20bca23ee03202c952900a7d226c8f5bcfa1a9ec7b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c72de201e481020109be6bb6fbd8f21fd3fbf5ebaf9731431f2f874aac8b479b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b7c04aeca441d114ef6e524600a5dfb56f7f00fb3f5ec0c963ac5fe92d3a3dd3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5b93ea3ebd2fd3e079f475ad60b6f4d4a8645770ae572f964fa27e79c0c78b64)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8b2569dfc9e6c657036f70d6b46e110039e4a67aec8ee8d85ee83036a7a393ec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3601c3dcfe9443ed817b1f9f46583d41cff2030082c5341eff2d42be48fdb733)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1e314e47232550984420e74b72b8cfd937ffd727ac46f4a27c6f099e45dcc620)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__747c7de712373a0a5a9e6ce81a259a3ce9a551e6f6eb9cb8d3ee3bfe3ea28405)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationFaceCrop",
    jsii_struct_bases=[],
    name_mapping={
        "algorithm": "algorithm",
        "algorithm_var": "algorithmVar",
        "confidence": "confidence",
        "confidence_var": "confidenceVar",
        "fail_gravity": "failGravity",
        "fail_gravity_var": "failGravityVar",
        "focus": "focus",
        "focus_var": "focusVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "padding": "padding",
        "padding_var": "paddingVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationFaceCrop:
    def __init__(
        self,
        *,
        algorithm: typing.Optional[builtins.str] = None,
        algorithm_var: typing.Optional[builtins.str] = None,
        confidence: typing.Optional[builtins.str] = None,
        confidence_var: typing.Optional[builtins.str] = None,
        fail_gravity: typing.Optional[builtins.str] = None,
        fail_gravity_var: typing.Optional[builtins.str] = None,
        focus: typing.Optional[builtins.str] = None,
        focus_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param algorithm: Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm DataAkamaiImagingPolicyImage#algorithm}
        :param algorithm_var: Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm_var DataAkamaiImagingPolicyImage#algorithm_var}
        :param confidence: With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image. Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence DataAkamaiImagingPolicyImage#confidence}
        :param confidence_var: With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image. Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence_var DataAkamaiImagingPolicyImage#confidence_var}
        :param fail_gravity: Controls placement of the crop if Image and Video Manager does not detect any faces in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        :param fail_gravity_var: Controls placement of the crop if Image and Video Manager does not detect any faces in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        :param focus: Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus DataAkamaiImagingPolicyImage#focus}
        :param focus_var: Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus_var DataAkamaiImagingPolicyImage#focus_var}
        :param gravity: Controls placement of the crop. Directions are relative to the face(s) plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Controls placement of the crop. Directions are relative to the face(s) plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param padding: The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        :param style: Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0f93e3667ec62504f21b91f26a52d539ff81e37e47444bb1d03316534b7c417d)
            check_type(argname="argument algorithm", value=algorithm, expected_type=type_hints["algorithm"])
            check_type(argname="argument algorithm_var", value=algorithm_var, expected_type=type_hints["algorithm_var"])
            check_type(argname="argument confidence", value=confidence, expected_type=type_hints["confidence"])
            check_type(argname="argument confidence_var", value=confidence_var, expected_type=type_hints["confidence_var"])
            check_type(argname="argument fail_gravity", value=fail_gravity, expected_type=type_hints["fail_gravity"])
            check_type(argname="argument fail_gravity_var", value=fail_gravity_var, expected_type=type_hints["fail_gravity_var"])
            check_type(argname="argument focus", value=focus, expected_type=type_hints["focus"])
            check_type(argname="argument focus_var", value=focus_var, expected_type=type_hints["focus_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if algorithm is not None:
            self._values["algorithm"] = algorithm
        if algorithm_var is not None:
            self._values["algorithm_var"] = algorithm_var
        if confidence is not None:
            self._values["confidence"] = confidence
        if confidence_var is not None:
            self._values["confidence_var"] = confidence_var
        if fail_gravity is not None:
            self._values["fail_gravity"] = fail_gravity
        if fail_gravity_var is not None:
            self._values["fail_gravity_var"] = fail_gravity_var
        if focus is not None:
            self._values["focus"] = focus
        if focus_var is not None:
            self._values["focus_var"] = focus_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def algorithm(self) -> typing.Optional[builtins.str]:
        '''Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm DataAkamaiImagingPolicyImage#algorithm}
        '''
        result = self._values.get("algorithm")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def algorithm_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm_var DataAkamaiImagingPolicyImage#algorithm_var}
        '''
        result = self._values.get("algorithm_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def confidence(self) -> typing.Optional[builtins.str]:
        '''With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image.

        Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence DataAkamaiImagingPolicyImage#confidence}
        '''
        result = self._values.get("confidence")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def confidence_var(self) -> typing.Optional[builtins.str]:
        '''With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image.

        Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence_var DataAkamaiImagingPolicyImage#confidence_var}
        '''
        result = self._values.get("confidence_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any faces in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        '''
        result = self._values.get("fail_gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any faces in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        '''
        result = self._values.get("fail_gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def focus(self) -> typing.Optional[builtins.str]:
        '''Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus DataAkamaiImagingPolicyImage#focus}
        '''
        result = self._values.get("focus")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def focus_var(self) -> typing.Optional[builtins.str]:
        '''Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus_var DataAkamaiImagingPolicyImage#focus_var}
        '''
        result = self._values.get("focus_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the face(s) plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the face(s) plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationFaceCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationFaceCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationFaceCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0e0e7758e09870bc1d634d459eaa91119750473c8bcae8668002aa9af0711676)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationFaceCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ef6acfec12a2d59045432e013fce3168bd97e4dd113ee3f3e2f018b70e2d2bb)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationFaceCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b927f9dbbf1080a737efcd983721169feeabb8f321b8962f4986f291fb007130)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a2f0fb27c03ffc78635a0355e62d8653439f6e32e56000f6467c0658e08eb45c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9555b5ac6914be4daf0249f40201789a626b5bbb2854e1b51a6ae2ff5e490b27)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationFaceCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationFaceCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationFaceCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8533d89fb7dcd6687bd3dbfff42336c3eaefe146b484f613c0b9f4b7519356ca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationFaceCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationFaceCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b8f3aa1d607e0af3422db527e03198ff526652c9967d306314704f2cbac99e88)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAlgorithm")
    def reset_algorithm(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAlgorithm", []))

    @jsii.member(jsii_name="resetAlgorithmVar")
    def reset_algorithm_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAlgorithmVar", []))

    @jsii.member(jsii_name="resetConfidence")
    def reset_confidence(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetConfidence", []))

    @jsii.member(jsii_name="resetConfidenceVar")
    def reset_confidence_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetConfidenceVar", []))

    @jsii.member(jsii_name="resetFailGravity")
    def reset_fail_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravity", []))

    @jsii.member(jsii_name="resetFailGravityVar")
    def reset_fail_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravityVar", []))

    @jsii.member(jsii_name="resetFocus")
    def reset_focus(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFocus", []))

    @jsii.member(jsii_name="resetFocusVar")
    def reset_focus_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFocusVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="algorithmInput")
    def algorithm_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "algorithmInput"))

    @builtins.property
    @jsii.member(jsii_name="algorithmVarInput")
    def algorithm_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "algorithmVarInput"))

    @builtins.property
    @jsii.member(jsii_name="confidenceInput")
    def confidence_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "confidenceInput"))

    @builtins.property
    @jsii.member(jsii_name="confidenceVarInput")
    def confidence_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "confidenceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityInput")
    def fail_gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityVarInput")
    def fail_gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="focusInput")
    def focus_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "focusInput"))

    @builtins.property
    @jsii.member(jsii_name="focusVarInput")
    def focus_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "focusVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="algorithm")
    def algorithm(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "algorithm"))

    @algorithm.setter
    def algorithm(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0fd37f13d94118d36b1c70461ec35e3cfa8238070dac78212b076b492640a89f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "algorithm", value)

    @builtins.property
    @jsii.member(jsii_name="algorithmVar")
    def algorithm_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "algorithmVar"))

    @algorithm_var.setter
    def algorithm_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a1cb2ef5b82b7236a7d3c66dceda899f6c156a3c33d24a3d03f6a5906dbfd33b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "algorithmVar", value)

    @builtins.property
    @jsii.member(jsii_name="confidence")
    def confidence(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "confidence"))

    @confidence.setter
    def confidence(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__878081ce18a6d9c7edf5a76d66921d75aa600c89f3318e43b3d4ea8e864d16f0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "confidence", value)

    @builtins.property
    @jsii.member(jsii_name="confidenceVar")
    def confidence_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "confidenceVar"))

    @confidence_var.setter
    def confidence_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__00f80b9a80460e8cde101120a4d54dfe483d789f3289ed60f12b7f91c8b90d68)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "confidenceVar", value)

    @builtins.property
    @jsii.member(jsii_name="failGravity")
    def fail_gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravity"))

    @fail_gravity.setter
    def fail_gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6bf9e12f3653b4e35e69633a1a525aca9e1c075efa3bdb1b94069a5f3b7697e8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravity", value)

    @builtins.property
    @jsii.member(jsii_name="failGravityVar")
    def fail_gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravityVar"))

    @fail_gravity_var.setter
    def fail_gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dd95ccbf00810cf5b69209c5644a23021376a99372f2a05b1d5313ee6c5745d8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="focus")
    def focus(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "focus"))

    @focus.setter
    def focus(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d4188e5a712d88560269e8cb9946184edd3ac86196f4b6c917e9a6ab543224c1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "focus", value)

    @builtins.property
    @jsii.member(jsii_name="focusVar")
    def focus_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "focusVar"))

    @focus_var.setter
    def focus_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9066048cadc1391279345fc8626ef26b42ee265aae5c3beb46bcf639c413097a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "focusVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__790ab47f23e4a2a93061e48ce3da1efba5f821b47f4ecdd267312059b65f8588)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f1389f98329108ea6479d560318b6372e2c0ca46d74ce52e2a811b1d7cddb982)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__067ce19342b7bf86a643c9d90b2ee640cbac49d0068c0b36d6e3e1533a88658a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dc719f7dec797684cbdc43d13eacba695609bebf7f53ed1185ea8b5a042264e3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__02bfe9c3e79a1910321f4264a2ecda96124d94f3f1e897084b2c55efe6273cb4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4976f0dede48d2c8094030ce079696af5c2a015346bcfb04c81f0fea58b18350)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7e37f30f2acc1c065c3882554ab264d173eb3122b66b1c50583e5f97f0a64afb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__56b66edee80a692c53c5f3617cd7b1d1681db1f0391525853efad827becccc45)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3290f6208ab12166d080570f4b973f33c14dab70077d5abb67d25e0e867404dc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__482017bb1ec56503525850720c62f9ff1462aebdcb8cf82a50e7e42f4a9ecc20)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationFaceCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationFaceCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationFaceCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__85d61a05822cc8a11e63e6656493e6b2aad8301d3ddcc0a54e14124f7bff87bd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationFeatureCrop",
    jsii_struct_bases=[],
    name_mapping={
        "fail_gravity": "failGravity",
        "fail_gravity_var": "failGravityVar",
        "feature_radius": "featureRadius",
        "feature_radius_var": "featureRadiusVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "max_features": "maxFeatures",
        "max_features_var": "maxFeaturesVar",
        "min_feature_quality": "minFeatureQuality",
        "min_feature_quality_var": "minFeatureQualityVar",
        "padding": "padding",
        "padding_var": "paddingVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationFeatureCrop:
    def __init__(
        self,
        *,
        fail_gravity: typing.Optional[builtins.str] = None,
        fail_gravity_var: typing.Optional[builtins.str] = None,
        feature_radius: typing.Optional[builtins.str] = None,
        feature_radius_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        max_features: typing.Optional[builtins.str] = None,
        max_features_var: typing.Optional[builtins.str] = None,
        min_feature_quality: typing.Optional[builtins.str] = None,
        min_feature_quality_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fail_gravity: Controls placement of the crop if Image and Video Manager does not detect any features in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        :param fail_gravity_var: Controls placement of the crop if Image and Video Manager does not detect any features in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        :param feature_radius: The size in pixels of the important features to search for. If identified, two features never appear closer together than this value, ``8.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius DataAkamaiImagingPolicyImage#feature_radius}
        :param feature_radius_var: The size in pixels of the important features to search for. If identified, two features never appear closer together than this value, ``8.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius_var DataAkamaiImagingPolicyImage#feature_radius_var}
        :param gravity: Controls placement of the crop. Directions are relative to the region of interest plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Controls placement of the crop. Directions are relative to the region of interest plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param max_features: The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features DataAkamaiImagingPolicyImage#max_features}
        :param max_features_var: The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features_var DataAkamaiImagingPolicyImage#max_features_var}
        :param min_feature_quality: Determines the minimum quality level of the feature identified. To consider a feature important, the feature needs to surpass this value. Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality DataAkamaiImagingPolicyImage#min_feature_quality}
        :param min_feature_quality_var: Determines the minimum quality level of the feature identified. To consider a feature important, the feature needs to surpass this value. Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality_var DataAkamaiImagingPolicyImage#min_feature_quality_var}
        :param padding: Adds space around the region of interest. The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: Adds space around the region of interest. The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        :param style: Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6459cfa0225ad708bcabc4d88e6f49e552284f72ad8e9b01651b65bb9c8c3b95)
            check_type(argname="argument fail_gravity", value=fail_gravity, expected_type=type_hints["fail_gravity"])
            check_type(argname="argument fail_gravity_var", value=fail_gravity_var, expected_type=type_hints["fail_gravity_var"])
            check_type(argname="argument feature_radius", value=feature_radius, expected_type=type_hints["feature_radius"])
            check_type(argname="argument feature_radius_var", value=feature_radius_var, expected_type=type_hints["feature_radius_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument max_features", value=max_features, expected_type=type_hints["max_features"])
            check_type(argname="argument max_features_var", value=max_features_var, expected_type=type_hints["max_features_var"])
            check_type(argname="argument min_feature_quality", value=min_feature_quality, expected_type=type_hints["min_feature_quality"])
            check_type(argname="argument min_feature_quality_var", value=min_feature_quality_var, expected_type=type_hints["min_feature_quality_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fail_gravity is not None:
            self._values["fail_gravity"] = fail_gravity
        if fail_gravity_var is not None:
            self._values["fail_gravity_var"] = fail_gravity_var
        if feature_radius is not None:
            self._values["feature_radius"] = feature_radius
        if feature_radius_var is not None:
            self._values["feature_radius_var"] = feature_radius_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if max_features is not None:
            self._values["max_features"] = max_features
        if max_features_var is not None:
            self._values["max_features_var"] = max_features_var
        if min_feature_quality is not None:
            self._values["min_feature_quality"] = min_feature_quality
        if min_feature_quality_var is not None:
            self._values["min_feature_quality_var"] = min_feature_quality_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def fail_gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any features in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        '''
        result = self._values.get("fail_gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any features in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        '''
        result = self._values.get("fail_gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feature_radius(self) -> typing.Optional[builtins.str]:
        '''The size in pixels of the important features to search for.

        If identified, two features never appear closer together than this value, ``8.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius DataAkamaiImagingPolicyImage#feature_radius}
        '''
        result = self._values.get("feature_radius")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feature_radius_var(self) -> typing.Optional[builtins.str]:
        '''The size in pixels of the important features to search for.

        If identified, two features never appear closer together than this value, ``8.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius_var DataAkamaiImagingPolicyImage#feature_radius_var}
        '''
        result = self._values.get("feature_radius_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the region of interest plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the region of interest plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def max_features(self) -> typing.Optional[builtins.str]:
        '''The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features DataAkamaiImagingPolicyImage#max_features}
        '''
        result = self._values.get("max_features")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def max_features_var(self) -> typing.Optional[builtins.str]:
        '''The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features_var DataAkamaiImagingPolicyImage#max_features_var}
        '''
        result = self._values.get("max_features_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def min_feature_quality(self) -> typing.Optional[builtins.str]:
        '''Determines the minimum quality level of the feature identified.

        To consider a feature important, the feature needs to surpass this value.  Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality DataAkamaiImagingPolicyImage#min_feature_quality}
        '''
        result = self._values.get("min_feature_quality")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def min_feature_quality_var(self) -> typing.Optional[builtins.str]:
        '''Determines the minimum quality level of the feature identified.

        To consider a feature important, the feature needs to surpass this value.  Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality_var DataAkamaiImagingPolicyImage#min_feature_quality_var}
        '''
        result = self._values.get("min_feature_quality_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''Adds space around the region of interest.

        The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''Adds space around the region of interest.

        The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationFeatureCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationFeatureCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationFeatureCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d0e32002016ec0281b7c8bac59688e2d7cb8013181139eb10919d951ddf89d0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationFeatureCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d9a28329d6e47716d0e15bbea70b0bd366e74324ac614c0daa5e4dc8227c0f2d)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationFeatureCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7ea9f8561ce81e36ef26c9d752a770c6c59bb492447d01d6db0ae44308bcdb63)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__648a3f5c5cdf73f58c3f09b08c0709fcf858f305819559ba10b013fa324f5b40)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2fd0f5cb514211e103339b9e70d3ff9dfab956d96e0324454ac66d4e7daca98c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationFeatureCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationFeatureCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationFeatureCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__99fbbef73a263b1467220a0f25f84220692406134581891fa1cd6b83102d17bb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationFeatureCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationFeatureCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7b8b7b8873bb4670783e41e318a2a48b018d72f5463d052c1037bf573af476a5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetFailGravity")
    def reset_fail_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravity", []))

    @jsii.member(jsii_name="resetFailGravityVar")
    def reset_fail_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravityVar", []))

    @jsii.member(jsii_name="resetFeatureRadius")
    def reset_feature_radius(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureRadius", []))

    @jsii.member(jsii_name="resetFeatureRadiusVar")
    def reset_feature_radius_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureRadiusVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetMaxFeatures")
    def reset_max_features(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxFeatures", []))

    @jsii.member(jsii_name="resetMaxFeaturesVar")
    def reset_max_features_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxFeaturesVar", []))

    @jsii.member(jsii_name="resetMinFeatureQuality")
    def reset_min_feature_quality(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMinFeatureQuality", []))

    @jsii.member(jsii_name="resetMinFeatureQualityVar")
    def reset_min_feature_quality_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMinFeatureQualityVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="failGravityInput")
    def fail_gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityVarInput")
    def fail_gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featureRadiusInput")
    def feature_radius_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featureRadiusInput"))

    @builtins.property
    @jsii.member(jsii_name="featureRadiusVarInput")
    def feature_radius_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featureRadiusVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesInput")
    def max_features_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "maxFeaturesInput"))

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesVarInput")
    def max_features_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "maxFeaturesVarInput"))

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityInput")
    def min_feature_quality_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "minFeatureQualityInput"))

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityVarInput")
    def min_feature_quality_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "minFeatureQualityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravity")
    def fail_gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravity"))

    @fail_gravity.setter
    def fail_gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d6a2983bf7a5434dc836e73de2ca8de95e835bc6db3dc994874eb9c4e8660a59)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravity", value)

    @builtins.property
    @jsii.member(jsii_name="failGravityVar")
    def fail_gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravityVar"))

    @fail_gravity_var.setter
    def fail_gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9e8ea0c229314623e869da6b746f87e4cee4959af3e1228e68b75ad7c009d0db)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="featureRadius")
    def feature_radius(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featureRadius"))

    @feature_radius.setter
    def feature_radius(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a32709bde1a9963495d88ba2b7f4f2a23bf21eb46ec7c3481f8795323c3182d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featureRadius", value)

    @builtins.property
    @jsii.member(jsii_name="featureRadiusVar")
    def feature_radius_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featureRadiusVar"))

    @feature_radius_var.setter
    def feature_radius_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dfbc0cccea58b0bfa7faabb8068d75c06dde8a0254295443273cd2fb5f1f7a27)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featureRadiusVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__16d5f055e0a094e6fa6f7847fe645022ab7d1340d7fe9c88ed3a0d7ba0f30def)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cddeeae99b32bcdf5e2b4b6621c2fc61326b722c43d593cba965b5fed2932f5c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9729024536e6ea2121610f809357d78b122d670d80849f825a27e6a987d3d488)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab2101a002b5c07b1a9649ca6260b6b7644943a0de3d183ca35bc324410729c1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="maxFeatures")
    def max_features(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "maxFeatures"))

    @max_features.setter
    def max_features(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__826a75d7fc26f290f17ab52bb8a64978f70c4ea393116c62037852d8b7870a0a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "maxFeatures", value)

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesVar")
    def max_features_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "maxFeaturesVar"))

    @max_features_var.setter
    def max_features_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a8268d828aefa91d5229313cf07c6777bfaca9d3a0c08c4a8f5b7f0290ff761a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "maxFeaturesVar", value)

    @builtins.property
    @jsii.member(jsii_name="minFeatureQuality")
    def min_feature_quality(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "minFeatureQuality"))

    @min_feature_quality.setter
    def min_feature_quality(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__59a928b64fb8fb923064ec86957e79518225abb8ee208824f95273bcaa478ad0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "minFeatureQuality", value)

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityVar")
    def min_feature_quality_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "minFeatureQualityVar"))

    @min_feature_quality_var.setter
    def min_feature_quality_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fac57b3b6a97aebb7a48cdec4acdce223f9e45e659317bf08f2022872ec344a4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "minFeatureQualityVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cf4012af428b9f3079b2ba7b0d8a5b2203f20a6f7e055ca7cfe60a9363622683)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__09248c861810a2188b19b0a3da05a0c1b87023003b47effd3a01c688717ec2f4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f951c67e7e4f1a8e5db885b8afd9fd340d20bbd4e175848b31544f6c95aad0cd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__16f6c3ff8d2f8eb143267b313f6abb0aa86ad076336b0c7bc9f23e739c69d102)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dcb4237a62ac004899b0037e70fdb94676f4c53cbaf4d1f2b4e89954aaf73896)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0e115fce980ccf20315ac9e3f050b55f68587ad39c3959a5d360ffe86538cc38)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationFeatureCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationFeatureCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationFeatureCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__39ba288a67860d2450258957bc816d292e1075ddf1ddb7c6a0e0122ed427c653)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationFitAndFill",
    jsii_struct_bases=[],
    name_mapping={
        "fill_transformation": "fillTransformation",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationFitAndFill:
    def __init__(
        self,
        *,
        fill_transformation: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationFitAndFillFillTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fill_transformation: fill_transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_transformation DataAkamaiImagingPolicyImage#fill_transformation}
        :param height: The height value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The width value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(fill_transformation, dict):
            fill_transformation = DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationFitAndFillFillTransformation(**fill_transformation)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__54d0dc4144e342499b60e560e1d230d5bcd2c5af83b160a63f7eb935a592652f)
            check_type(argname="argument fill_transformation", value=fill_transformation, expected_type=type_hints["fill_transformation"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fill_transformation is not None:
            self._values["fill_transformation"] = fill_transformation
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def fill_transformation(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationFitAndFillFillTransformation"]:
        '''fill_transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_transformation DataAkamaiImagingPolicyImage#fill_transformation}
        '''
        result = self._values.get("fill_transformation")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationFitAndFillFillTransformation"], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationFitAndFill(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationFitAndFillFillTransformation",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationFitAndFillFillTransformation:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationFitAndFillFillTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationFitAndFillFillTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationFitAndFillFillTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c22d1a91333ad5a98ea05d4f60129bbc47b5a4e909deb6cf69a08f9468b78508)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationFitAndFillFillTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationFitAndFillFillTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationFitAndFillFillTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__556f699d471d04c18d9f215e8d05c055300c8bbf764f249110995b93cab5bcb4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationFitAndFillList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationFitAndFillList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb8d11620cf4059088ec04173060a541ea07ef0bef75a1876e8c70fa236f7244)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationFitAndFillOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bcda21e770e87d8e058015c21ff50bd858aaf6899415d4d65a279f5e97f79b89)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationFitAndFillOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__61565d1b58a271e695c4a82c59eb46a70499bc6b642d208c6e1c3ca95f104e06)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__733e8fd005c5cc9993627d3cd205e2a299a2be0aaa6aa918204fb68d433bf56a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4e5c8a555915b80ec633e6cd228a5dce587b99fcdc8d9c1b5c3482aafc46199e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationFitAndFill]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationFitAndFill]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationFitAndFill]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b87168a002334f2532ae512b3a97fe4fbaa950611508725b49dbaa145b3453ba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationFitAndFillOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationFitAndFillOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__80c302b90b891c021a1526dedbe68eb1e7e9b33101fc6b2cd5c94e6a9be9dd03)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putFillTransformation")
    def put_fill_transformation(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationFitAndFillFillTransformation()

        return typing.cast(None, jsii.invoke(self, "putFillTransformation", [value]))

    @jsii.member(jsii_name="resetFillTransformation")
    def reset_fill_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFillTransformation", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="fillTransformation")
    def fill_transformation(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationFitAndFillFillTransformationOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationFitAndFillFillTransformationOutputReference, jsii.get(self, "fillTransformation"))

    @builtins.property
    @jsii.member(jsii_name="fillTransformationInput")
    def fill_transformation_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationFitAndFillFillTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationFitAndFillFillTransformation], jsii.get(self, "fillTransformationInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__02fd909646f4b133d6e0b4127934ddfa729a189518031cdcd9874bed73b6f52c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ca3e515a33bd6a21ec2441a6bbdbc7b771a6b776ddb7ce6d3d2e8f31283b24f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3d1ef1d0385b7b181b0ae45c9331f7eb59a13487911640e0192648012377e9da)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e84a22583b5606fead14a4aa62ce22216bf5f075712e71e28e0b77e8d47f0f41)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationFitAndFill]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationFitAndFill]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationFitAndFill]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f712aec5e28b890c686591ec0b2fced0b9364a0df3293617a6d2475e1ec83308)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationGoop",
    jsii_struct_bases=[],
    name_mapping={
        "chaos": "chaos",
        "chaos_var": "chaosVar",
        "density": "density",
        "density_var": "densityVar",
        "power": "power",
        "power_var": "powerVar",
        "seed": "seed",
        "seed_var": "seedVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationGoop:
    def __init__(
        self,
        *,
        chaos: typing.Optional[builtins.str] = None,
        chaos_var: typing.Optional[builtins.str] = None,
        density: typing.Optional[builtins.str] = None,
        density_var: typing.Optional[builtins.str] = None,
        power: typing.Optional[builtins.str] = None,
        power_var: typing.Optional[builtins.str] = None,
        seed: typing.Optional[builtins.str] = None,
        seed_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param chaos: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        :param chaos_var: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        :param density: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        :param density_var: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        :param power: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        :param power_var: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        :param seed: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        :param seed_var: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cf4c23499e673bbd737164048cfa882003b219a71785f5b31fc1f8691d14cc95)
            check_type(argname="argument chaos", value=chaos, expected_type=type_hints["chaos"])
            check_type(argname="argument chaos_var", value=chaos_var, expected_type=type_hints["chaos_var"])
            check_type(argname="argument density", value=density, expected_type=type_hints["density"])
            check_type(argname="argument density_var", value=density_var, expected_type=type_hints["density_var"])
            check_type(argname="argument power", value=power, expected_type=type_hints["power"])
            check_type(argname="argument power_var", value=power_var, expected_type=type_hints["power_var"])
            check_type(argname="argument seed", value=seed, expected_type=type_hints["seed"])
            check_type(argname="argument seed_var", value=seed_var, expected_type=type_hints["seed_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if chaos is not None:
            self._values["chaos"] = chaos
        if chaos_var is not None:
            self._values["chaos_var"] = chaos_var
        if density is not None:
            self._values["density"] = density
        if density_var is not None:
            self._values["density_var"] = density_var
        if power is not None:
            self._values["power"] = power
        if power_var is not None:
            self._values["power_var"] = power_var
        if seed is not None:
            self._values["seed"] = seed
        if seed_var is not None:
            self._values["seed_var"] = seed_var

    @builtins.property
    def chaos(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        '''
        result = self._values.get("chaos")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def chaos_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        '''
        result = self._values.get("chaos_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        '''
        result = self._values.get("density")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density_var(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        '''
        result = self._values.get("density_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        '''
        result = self._values.get("power")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power_var(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        '''
        result = self._values.get("power_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        '''
        result = self._values.get("seed")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed_var(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        result = self._values.get("seed_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationGoop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationGoopList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationGoopList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1d4be1568e12cff06e5eb91838c41da56c2835d8acb683e5fbd91f9b55529128)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationGoopOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__215e3c870c151914389ec4b7117d75f6c87817fe3713805f4efb8e3df837e968)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationGoopOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8c0c89a2934688abdde9d283e425a9c167e4180022557cc96f513eaec628a2f1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4d27c8c36bb73d978a2cec0940c75adf233339fb9ee4d436f4cb2f2b9cf16e21)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be85f30708ec72296ff1bd408f849a546a5584db2f61b951d59a6fab8787abd1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationGoop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationGoop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1429e947732661d2da7fdf371989ce09cdee9a097ea9c542c41744ea5b14e4b5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationGoopOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationGoopOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bf263bb0fa238894717a2b1e475acf03ab00663429a89115c9668182f89fa069)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetChaos")
    def reset_chaos(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaos", []))

    @jsii.member(jsii_name="resetChaosVar")
    def reset_chaos_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaosVar", []))

    @jsii.member(jsii_name="resetDensity")
    def reset_density(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensity", []))

    @jsii.member(jsii_name="resetDensityVar")
    def reset_density_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensityVar", []))

    @jsii.member(jsii_name="resetPower")
    def reset_power(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPower", []))

    @jsii.member(jsii_name="resetPowerVar")
    def reset_power_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPowerVar", []))

    @jsii.member(jsii_name="resetSeed")
    def reset_seed(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeed", []))

    @jsii.member(jsii_name="resetSeedVar")
    def reset_seed_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeedVar", []))

    @builtins.property
    @jsii.member(jsii_name="chaosInput")
    def chaos_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosInput"))

    @builtins.property
    @jsii.member(jsii_name="chaosVarInput")
    def chaos_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosVarInput"))

    @builtins.property
    @jsii.member(jsii_name="densityInput")
    def density_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityInput"))

    @builtins.property
    @jsii.member(jsii_name="densityVarInput")
    def density_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="powerInput")
    def power_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerInput"))

    @builtins.property
    @jsii.member(jsii_name="powerVarInput")
    def power_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerVarInput"))

    @builtins.property
    @jsii.member(jsii_name="seedInput")
    def seed_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedInput"))

    @builtins.property
    @jsii.member(jsii_name="seedVarInput")
    def seed_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedVarInput"))

    @builtins.property
    @jsii.member(jsii_name="chaos")
    def chaos(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaos"))

    @chaos.setter
    def chaos(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__83ec2bfa6cd8b432f487d7a0d19191091a8bf7730088b3206ecbf93cd8ad4a9e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaos", value)

    @builtins.property
    @jsii.member(jsii_name="chaosVar")
    def chaos_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaosVar"))

    @chaos_var.setter
    def chaos_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1262138d0d613e3aafda065e3efca13c85f6b5dad415a72dee1f3ef7ba2b780b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaosVar", value)

    @builtins.property
    @jsii.member(jsii_name="density")
    def density(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "density"))

    @density.setter
    def density(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1eb95cb79956901b802ab244f44e6a4bc36b9956d0c5ed149ad71ea09b66b4d7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "density", value)

    @builtins.property
    @jsii.member(jsii_name="densityVar")
    def density_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "densityVar"))

    @density_var.setter
    def density_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__da403187ced504c27a050cc90b25fa486d77933778ba16dfc70e4dbce2d1af67)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "densityVar", value)

    @builtins.property
    @jsii.member(jsii_name="power")
    def power(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "power"))

    @power.setter
    def power(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d662f39c748a46f37527b648bafec4c29210ff6dab5e0b05a0e30f0bd7c26a3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "power", value)

    @builtins.property
    @jsii.member(jsii_name="powerVar")
    def power_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "powerVar"))

    @power_var.setter
    def power_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9c66002d2fb7af7e34fc27df54cc72de04bc136384cc116de8d5a4481332d533)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "powerVar", value)

    @builtins.property
    @jsii.member(jsii_name="seed")
    def seed(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seed"))

    @seed.setter
    def seed(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__10ea398e75e5d41de470de71d5f66848e65eeeba3554d8901b13a394c17e12ba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seed", value)

    @builtins.property
    @jsii.member(jsii_name="seedVar")
    def seed_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seedVar"))

    @seed_var.setter
    def seed_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__03e8e8ea79fee0e5bb209f57876f82b738c44353e4747ba8c1387e1e8a145fb3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seedVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationGoop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationGoop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationGoop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5209839759d7e42309c8421dc9f1664626d21de7fe373528ce663547d88e4c4a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationGrayscale",
    jsii_struct_bases=[],
    name_mapping={"type": "type", "type_var": "typeVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationGrayscale:
    def __init__(
        self,
        *,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param type: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fae7470907f60554b09cb6cf2a06789a7d7c6c1b1db2073d3bb1ce8fa45730ed)
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationGrayscale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationGrayscaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationGrayscaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__42fe1ad6001f27ee2165d336b5dcfdb20d567f843c6b296161516fca2f936e06)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationGrayscaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__471f1fd33f284f40b5fe2534d93f4bd8911b8a825480e53e353d6a88c2ed832f)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationGrayscaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f9570df51ac24890c078a2a416c35c18adc4e0ada73b4f956f69223ca754b5d3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a13797460840739a486177ee651f2888a5fd4389c8dd4c53ba8e8f00c9b0cc08)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8e9d9aa1ca9222d0c14d1217aee90f3ce068656b06a64e6ed2410cfae5541629)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationGrayscale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationGrayscale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__42c0ee756e8c12aa98d6a66163d3bb0387c4d84923f7f70839e210e3e0475f7d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationGrayscaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationGrayscaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f63f315ecfca3153658fd5c87254b3d6270f82b2cd9abe3049cf86fa05f45c20)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5a60669e9d32a0febca77dda6984d1eb67ac569b525926f53dd4a41d36f0465e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0118e4db73110863296c798b32aa69bc008ed180dc7f5be64800aecc2fdf8f05)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationGrayscale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationGrayscale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationGrayscale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cc8f7805f844cd051a122f235e683d4e04a7126ead59c6686f21c8ff042d5060)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationHsl",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "lightness": "lightness",
        "lightness_var": "lightnessVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationHsl:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness: typing.Optional[builtins.str] = None,
        lightness_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        :param lightness_var: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0486bf56728fe8b5427a6a1c53836e39b3f3c889391cce7a4cd2d25c4a1b53c2)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness", value=lightness, expected_type=type_hints["lightness"])
            check_type(argname="argument lightness_var", value=lightness_var, expected_type=type_hints["lightness_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness is not None:
            self._values["lightness"] = lightness
        if lightness_var is not None:
            self._values["lightness_var"] = lightness_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        '''
        result = self._values.get("lightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        '''
        result = self._values.get("lightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationHsl(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationHslList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationHslList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e5b9c3442c083c9003f604406ae18dec8c611c79b5edc2b98bb44e7dabfd5741)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationHslOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fd51610e9bd0a773694b6376f98a2af8664274df36b4c2aea88df7cc11a24abc)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationHslOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f9c2964efed8b36a0d5be51aa5172b1b64a869458f6eeff93b6f0479da18b8d9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be2e52d0ea017b5f3058c4bdb2ca5e867b4bdaca4db347b10873f8c1fd6c5800)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6bd5a660c30bdc439d2c7a1a6bbb59044943b1b3a718777569177520101f29b9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationHsl]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationHsl]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f7d11ee628f2d70b794dd86bbf88d6d079f23bdac76e25fd9b38b6c819001fd2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationHslOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationHslOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__60334ac3efbbf0e36e638fb2ea1a9f35d4bf2b63bd6ffab64a20a3428178a05e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightness")
    def reset_lightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightness", []))

    @jsii.member(jsii_name="resetLightnessVar")
    def reset_lightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessInput")
    def lightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessVarInput")
    def lightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ec4f54e63d85e141a1f5edac5ed7d82fee0bc768850e93ac95a68a5961a5262e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__534f3dd094bef47f48071ceb576ed771ded364ca186ec39e00bfec8ec44308ab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightness")
    def lightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightness"))

    @lightness.setter
    def lightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0fa6cb0e84e79da9db05fa0fbc5986702f27a3a0f7e7033d701520b7a101e8d0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightness", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessVar")
    def lightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessVar"))

    @lightness_var.setter
    def lightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__31d39daf4778ee93039fdc9ab8b626a5cefc3992de714d136e3ef4f774e6a696)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__79fae0a7b15d06f7ccaf15862085366f0c0b547c25b6988b64e54a731c18e704)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__70c1d68a02a76001a9638539633cf58bf6249937e9c70cf35dc1705349d28f32)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationHsl]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationHsl]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationHsl]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f0375238723094cceb1fbbf19a05a2d2bee38ca47245d53d1fa8c2ace97d9de9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationHsv",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationHsv:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        :param value: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a4584f02f1a3d85a1887f8c0fffbc49ac8fac098967cab25cb9d460e0cbe9256)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationHsv(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationHsvList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationHsvList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af80d8eff4ed1938de724a38ba60c71435e04d7d9cbbf483ff98920ece909c38)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationHsvOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__620b1027ddafec944e2112219a86596ac5931f625dc6ec7cc967805eb56dcaae)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationHsvOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__695b07f52b1ff746f5d4c6716e88bb63c0cda20267f313ba306ec96a02cc09e0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c6b2604b1e61eea4c4c045f098e9b744c96ad21d8c7c6a236b0b3961da9295ec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4fed4fe567f1881c584257c2248448d58f849c0236d0fcd5bfcddb854808b183)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationHsv]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationHsv]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__39a1edb5643e97d0c695b5a68018541e84b632306a2c769d0b5f6520f0c25687)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationHsvOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationHsvOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9bd0831bd9c9dae0e23e23a90481aa1d3a558376342708e2efc64706891e8686)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0581184f776aaefbf31273f0b2c1dc1bfd154643804c4dcf57bf6a1c3885e0a8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cbee38e5d63d2347606b47ad4bd86f2843e78f55a8cd31c38b7c23ad53313c15)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b6754d30fd49bc787d4329f7091fb1757c0b8f38da5f75074d6e1daf88d64007)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fb32a7ef5544ebe64a650662e085870e26a7a995d6906f8d5a37372fb3752cb9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f84fe5cdf4a96e9410f1136ac44d2a7c5649a46f0265c876bd8e99db3a7f7d2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aaa2cd4bf5dad19415c0fc285d81b4a8cec1b56810dd3f7d84b91d24acdb18da)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationHsv]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationHsv]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationHsv]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0c84a8d945eec6cce6f131d643ebb893657745b6299f0dad2c76d271836a2341)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfDimension",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "dimension": "dimension",
        "dimension_var": "dimensionVar",
        "equal": "equal",
        "greater_than": "greaterThan",
        "less_than": "lessThan",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfDimension:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfDimensionDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        dimension: typing.Optional[builtins.str] = None,
        dimension_var: typing.Optional[builtins.str] = None,
        equal: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfDimensionEqual", typing.Dict[builtins.str, typing.Any]]] = None,
        greater_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfDimensionGreaterThan", typing.Dict[builtins.str, typing.Any]]] = None,
        less_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfDimensionLessThan", typing.Dict[builtins.str, typing.Any]]] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param dimension: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        :param dimension_var: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        :param equal: equal block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        :param greater_than: greater_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        :param less_than: less_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        :param value: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfDimensionDefault(**default)
        if isinstance(equal, dict):
            equal = DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfDimensionEqual(**equal)
        if isinstance(greater_than, dict):
            greater_than = DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfDimensionGreaterThan(**greater_than)
        if isinstance(less_than, dict):
            less_than = DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfDimensionLessThan(**less_than)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e7ea378e630ff63bfc18bad22c8068757603d9f3d81a7d44423e204d5b6b1272)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument dimension", value=dimension, expected_type=type_hints["dimension"])
            check_type(argname="argument dimension_var", value=dimension_var, expected_type=type_hints["dimension_var"])
            check_type(argname="argument equal", value=equal, expected_type=type_hints["equal"])
            check_type(argname="argument greater_than", value=greater_than, expected_type=type_hints["greater_than"])
            check_type(argname="argument less_than", value=less_than, expected_type=type_hints["less_than"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if dimension is not None:
            self._values["dimension"] = dimension
        if dimension_var is not None:
            self._values["dimension_var"] = dimension_var
        if equal is not None:
            self._values["equal"] = equal
        if greater_than is not None:
            self._values["greater_than"] = greater_than
        if less_than is not None:
            self._values["less_than"] = less_than
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfDimensionDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfDimensionDefault"], result)

    @builtins.property
    def dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        '''
        result = self._values.get("dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        '''
        result = self._values.get("dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def equal(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfDimensionEqual"]:
        '''equal block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        '''
        result = self._values.get("equal")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfDimensionEqual"], result)

    @builtins.property
    def greater_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfDimensionGreaterThan"]:
        '''greater_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        '''
        result = self._values.get("greater_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfDimensionGreaterThan"], result)

    @builtins.property
    def less_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfDimensionLessThan"]:
        '''less_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        '''
        result = self._values.get("less_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfDimensionLessThan"], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfDimension(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfDimensionDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfDimensionDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfDimensionDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfDimensionDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfDimensionDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e3202d67f27a8ac5b9e81f3699348d10952d69550a0da54e504c98a4cc3f0d5d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfDimensionDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfDimensionDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__113b6f91fe21378ee692051d85dce9c130f9522a701a4552ac94336de3050582)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfDimensionEqual",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfDimensionEqual:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfDimensionEqual(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfDimensionEqualOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfDimensionEqualOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ee49533513a13b788c45c6ea4edec9d13b2d079b456257f3bc17f3d6428f4b61)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfDimensionEqual], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfDimensionEqual],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e69c69860053bec0d45b99abafb5287e537943d356ea6d8c278f8b7efef09e2d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfDimensionGreaterThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfDimensionGreaterThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfDimensionGreaterThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfDimensionGreaterThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfDimensionGreaterThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__86a861d3c6ac551092c659cb4543160fea8e8cace54c4f4c1e44fb5d76287cce)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfDimensionGreaterThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfDimensionGreaterThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fc7ff9833f8d273cf418263545c7b3567029edbac5b8fd908daac903f7c42d1f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfDimensionLessThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfDimensionLessThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfDimensionLessThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfDimensionLessThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfDimensionLessThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__676d05c7cedde48a57c17734017ff9d9c4b1aedb40e892d56f01db0100e833f5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfDimensionLessThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfDimensionLessThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1c91fa4d2afafd1fd96cb358d07e4db24d01bf4f541d6ee48a9100a7f0843537)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfDimensionList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfDimensionList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__399caaf28fcdef170df4666f68578010527948d70312e3629525dac26a7f7710)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfDimensionOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__72a5d2b088dd3f99329c6970160b5f675af671b067e517a392756599440d925f)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfDimensionOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f19eac15165370f6d44b41abf8e98d5ac50edf279e5a1212a0b666a789cde427)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d7ea326cae3c431905aa441006c073d2cfc22f5e1a4e68c4061e2913bffe653d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8fb7e3dacc4a7396c54eb7653e3bad501fa452c87267370a649452eb30563882)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfDimension]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfDimension]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7e64a6e985670e9becf8888d8cec8003dc8263709d1aef4ae392b4bb3316d603)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfDimensionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfDimensionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d67943ef9a708c5b89c13ef219fbd405d6c86c2b8be9ac071f12b5ac15015a3d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfDimensionDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putEqual")
    def put_equal(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfDimensionEqual()

        return typing.cast(None, jsii.invoke(self, "putEqual", [value]))

    @jsii.member(jsii_name="putGreaterThan")
    def put_greater_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfDimensionGreaterThan()

        return typing.cast(None, jsii.invoke(self, "putGreaterThan", [value]))

    @jsii.member(jsii_name="putLessThan")
    def put_less_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfDimensionLessThan()

        return typing.cast(None, jsii.invoke(self, "putLessThan", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetDimension")
    def reset_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimension", []))

    @jsii.member(jsii_name="resetDimensionVar")
    def reset_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimensionVar", []))

    @jsii.member(jsii_name="resetEqual")
    def reset_equal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEqual", []))

    @jsii.member(jsii_name="resetGreaterThan")
    def reset_greater_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGreaterThan", []))

    @jsii.member(jsii_name="resetLessThan")
    def reset_less_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLessThan", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfDimensionDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfDimensionDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="equal")
    def equal(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfDimensionEqualOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfDimensionEqualOutputReference, jsii.get(self, "equal"))

    @builtins.property
    @jsii.member(jsii_name="greaterThan")
    def greater_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfDimensionGreaterThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfDimensionGreaterThanOutputReference, jsii.get(self, "greaterThan"))

    @builtins.property
    @jsii.member(jsii_name="lessThan")
    def less_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfDimensionLessThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfDimensionLessThanOutputReference, jsii.get(self, "lessThan"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfDimensionDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionInput")
    def dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionVarInput")
    def dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="equalInput")
    def equal_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfDimensionEqual], jsii.get(self, "equalInput"))

    @builtins.property
    @jsii.member(jsii_name="greaterThanInput")
    def greater_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfDimensionGreaterThan], jsii.get(self, "greaterThanInput"))

    @builtins.property
    @jsii.member(jsii_name="lessThanInput")
    def less_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfDimensionLessThan], jsii.get(self, "lessThanInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="dimension")
    def dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimension"))

    @dimension.setter
    def dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0a74788ef2835011afa60f8d0f58fedeb2b853acf9b5d113c7a9cffdb00c24bc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimension", value)

    @builtins.property
    @jsii.member(jsii_name="dimensionVar")
    def dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimensionVar"))

    @dimension_var.setter
    def dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f04ca611c8dfd408b4d6f8ee3817410fea345d88464b7f3e7a6adef73641f689)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cbeaa98f467606ed9e3000fd94b851b105983794c2d6aecc8f515960cfaed38f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5a15aea99dbb50dabd131a8a97fd8162a5fc67523fb50eb5b573946e8ab56d4e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfDimension]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfDimension]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfDimension]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8016568045cd98daddcdd2d3fe126349633d566bc023e786dac9b207f417d850)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfOrientation",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "landscape": "landscape",
        "portrait": "portrait",
        "square": "square",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfOrientation:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfOrientationDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        landscape: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfOrientationLandscape", typing.Dict[builtins.str, typing.Any]]] = None,
        portrait: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfOrientationPortrait", typing.Dict[builtins.str, typing.Any]]] = None,
        square: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfOrientationSquare", typing.Dict[builtins.str, typing.Any]]] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param landscape: landscape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        :param portrait: portrait block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        :param square: square block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfOrientationDefault(**default)
        if isinstance(landscape, dict):
            landscape = DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfOrientationLandscape(**landscape)
        if isinstance(portrait, dict):
            portrait = DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfOrientationPortrait(**portrait)
        if isinstance(square, dict):
            square = DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfOrientationSquare(**square)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cea0059201f8fb6d4e0f9527d3067862da2a0ed4cd758330636d466cbc24ac7b)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument landscape", value=landscape, expected_type=type_hints["landscape"])
            check_type(argname="argument portrait", value=portrait, expected_type=type_hints["portrait"])
            check_type(argname="argument square", value=square, expected_type=type_hints["square"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if landscape is not None:
            self._values["landscape"] = landscape
        if portrait is not None:
            self._values["portrait"] = portrait
        if square is not None:
            self._values["square"] = square

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfOrientationDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfOrientationDefault"], result)

    @builtins.property
    def landscape(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfOrientationLandscape"]:
        '''landscape block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        '''
        result = self._values.get("landscape")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfOrientationLandscape"], result)

    @builtins.property
    def portrait(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfOrientationPortrait"]:
        '''portrait block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        '''
        result = self._values.get("portrait")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfOrientationPortrait"], result)

    @builtins.property
    def square(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfOrientationSquare"]:
        '''square block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        result = self._values.get("square")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfOrientationSquare"], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfOrientation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfOrientationDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfOrientationDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfOrientationDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfOrientationDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfOrientationDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b146ff9510626b779b10657566f414fa14ddb8acbf52419ebb4aa5ba70ff19ff)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfOrientationDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfOrientationDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__95924f0930b7e0ba940fc22666dc3606e689fcedd79539d50b7e12aab85e21e7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfOrientationLandscape",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfOrientationLandscape:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfOrientationLandscape(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfOrientationLandscapeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfOrientationLandscapeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__68cf1bbee3c0d4f41601f4f67b178d9dd09a9276c48108dddca03aeb9b1ad3bd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfOrientationLandscape], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfOrientationLandscape],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6a415fa980bb88d8154d3fa39f860e9dc44a90460f3266f8a4c0d02c4340ad3d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfOrientationList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfOrientationList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c0642217c1a6585b69b97e838462a469b50c164e07e6a308ed370bab23192edd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfOrientationOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5a5b1d8997ba28694f88efcb6c44e5ccea61b13990e481ae62c1e5b82e5cf02f)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfOrientationOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__218beaf3f5a8dcb26430d5e4a51df8713a8ebf3a28bdea34609d326b99db5c56)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__85aa8ddc3ca422638b11317edd6892fe5a56e64d700a3acef87db050670e3c8a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bbf25d1995a7607522ad3f13504461d406823b29798fd1a415d9b059c590138f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfOrientation]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfOrientation]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1530491d7f1cad9813d95e20161c95e2cba6af255d429df914ac508d7ce1578e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfOrientationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfOrientationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ad02f68ac7731fa4ea7f5999ee93053774d2b1e6d28d18c1cd9966a19039177)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfOrientationDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putLandscape")
    def put_landscape(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfOrientationLandscape()

        return typing.cast(None, jsii.invoke(self, "putLandscape", [value]))

    @jsii.member(jsii_name="putPortrait")
    def put_portrait(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfOrientationPortrait()

        return typing.cast(None, jsii.invoke(self, "putPortrait", [value]))

    @jsii.member(jsii_name="putSquare")
    def put_square(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfOrientationSquare()

        return typing.cast(None, jsii.invoke(self, "putSquare", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetLandscape")
    def reset_landscape(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLandscape", []))

    @jsii.member(jsii_name="resetPortrait")
    def reset_portrait(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPortrait", []))

    @jsii.member(jsii_name="resetSquare")
    def reset_square(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSquare", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfOrientationDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfOrientationDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="landscape")
    def landscape(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfOrientationLandscapeOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfOrientationLandscapeOutputReference, jsii.get(self, "landscape"))

    @builtins.property
    @jsii.member(jsii_name="portrait")
    def portrait(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfOrientationPortraitOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfOrientationPortraitOutputReference", jsii.get(self, "portrait"))

    @builtins.property
    @jsii.member(jsii_name="square")
    def square(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfOrientationSquareOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfOrientationSquareOutputReference", jsii.get(self, "square"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfOrientationDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="landscapeInput")
    def landscape_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfOrientationLandscape], jsii.get(self, "landscapeInput"))

    @builtins.property
    @jsii.member(jsii_name="portraitInput")
    def portrait_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfOrientationPortrait"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfOrientationPortrait"], jsii.get(self, "portraitInput"))

    @builtins.property
    @jsii.member(jsii_name="squareInput")
    def square_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfOrientationSquare"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfOrientationSquare"], jsii.get(self, "squareInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfOrientation]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfOrientation]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfOrientation]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2802a045b19cbd1bfe418c0f5b1b576213999ca336ffbca043cf9ee31033582c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfOrientationPortrait",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfOrientationPortrait:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfOrientationPortrait(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfOrientationPortraitOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfOrientationPortraitOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f4c270916b7bb9ed4d1eb0f79f8a6e873df9e7b81cc3bb4e1150224a851b5c4d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfOrientationPortrait]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfOrientationPortrait], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfOrientationPortrait],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8767cb42e0918f685f9689b55ae97706bf7a564820f6692f01de1686115d926c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfOrientationSquare",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfOrientationSquare:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfOrientationSquare(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfOrientationSquareOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfOrientationSquareOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e0f930575440601ec28b8299c4e69bba4b6f9ab505bf9b9138f726694b54ecf3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfOrientationSquare]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfOrientationSquare], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfOrientationSquare],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac77af70115815b607aea4bf3f4f81d3d1e479bd4877946b964e6396be43372a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationImQuery",
    jsii_struct_bases=[],
    name_mapping={
        "allowed_transformations": "allowedTransformations",
        "query_var": "queryVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationImQuery:
    def __init__(
        self,
        *,
        allowed_transformations: typing.Sequence[builtins.str],
        query_var: builtins.str,
    ) -> None:
        '''
        :param allowed_transformations: Specifies the transformations that can be applied using the query string parameter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allowed_transformations DataAkamaiImagingPolicyImage#allowed_transformations}
        :param query_var: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#query_var DataAkamaiImagingPolicyImage#query_var}.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6179fe29ffcf47d7beea1aa4e92016789f195fbb59e2f73e1c414d6d8fa8a6f4)
            check_type(argname="argument allowed_transformations", value=allowed_transformations, expected_type=type_hints["allowed_transformations"])
            check_type(argname="argument query_var", value=query_var, expected_type=type_hints["query_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "allowed_transformations": allowed_transformations,
            "query_var": query_var,
        }

    @builtins.property
    def allowed_transformations(self) -> typing.List[builtins.str]:
        '''Specifies the transformations that can be applied using the query string parameter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allowed_transformations DataAkamaiImagingPolicyImage#allowed_transformations}
        '''
        result = self._values.get("allowed_transformations")
        assert result is not None, "Required property 'allowed_transformations' is missing"
        return typing.cast(typing.List[builtins.str], result)

    @builtins.property
    def query_var(self) -> builtins.str:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#query_var DataAkamaiImagingPolicyImage#query_var}.'''
        result = self._values.get("query_var")
        assert result is not None, "Required property 'query_var' is missing"
        return typing.cast(builtins.str, result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationImQuery(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationImQueryList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationImQueryList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c76d2277bbf7335c8212f25416b229c0b6d3b8a39e64251cfaf9a1babe37fd2d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationImQueryOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__28136507e4dc717fd25e577c7c97ececb37862787c3ad3afe3f65c71e21ba49c)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationImQueryOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5814a1c28f620021148d8b42b23ec7f61f153f83787fbfb8fe263d4f391e4aed)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9bd58f703454af2393b5b5df81a5ce3d5a0c81b84b2b61c9c6612c89da13bb1f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__27a708ccf5d4462ee07b4394d86b99b193cb8c1ab18f9e750ad3b57c29a174ec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationImQuery]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationImQuery]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationImQuery]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aaace832debc0d0656a4870050011cd2afd2cd0a6abd8cd50277d92dabf16914)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationImQueryOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationImQueryOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a2637a4873fea54d32f630d90462c91de0936d0242e17348fdb8cccd056651b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @builtins.property
    @jsii.member(jsii_name="allowedTransformationsInput")
    def allowed_transformations_input(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "allowedTransformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="queryVarInput")
    def query_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "queryVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowedTransformations")
    def allowed_transformations(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "allowedTransformations"))

    @allowed_transformations.setter
    def allowed_transformations(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e20786e871264c332cbb4417b50ee6e6e8371331c439b103b030433de709c23b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowedTransformations", value)

    @builtins.property
    @jsii.member(jsii_name="queryVar")
    def query_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "queryVar"))

    @query_var.setter
    def query_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__82bed6a515aa2e67ea919b8dc211f9b177f6349218902ed7e6be5002a41faa58)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "queryVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationImQuery]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationImQuery]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationImQuery]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__728f1f2d22bfbb26d7b7c0170a777a6c459e34271e3448b7779762b891d1ce98)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationMaxColors",
    jsii_struct_bases=[],
    name_mapping={"colors": "colors", "colors_var": "colorsVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationMaxColors:
    def __init__(
        self,
        *,
        colors: typing.Optional[builtins.str] = None,
        colors_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param colors: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        :param colors_var: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d3c3f468e1fc48d10d3abcc05261ea29840ea7cf84864c9f19f6105f21dc76d1)
            check_type(argname="argument colors", value=colors, expected_type=type_hints["colors"])
            check_type(argname="argument colors_var", value=colors_var, expected_type=type_hints["colors_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if colors is not None:
            self._values["colors"] = colors
        if colors_var is not None:
            self._values["colors_var"] = colors_var

    @builtins.property
    def colors(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        '''
        result = self._values.get("colors")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def colors_var(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        result = self._values.get("colors_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationMaxColors(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationMaxColorsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationMaxColorsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ab14e06096c2615563dacee97561f1334854202d1644f315dce3db24b43ff98)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationMaxColorsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__022217e66a5b2624ddc1266fceeb63903193c211787edf3a988abbbcd785468d)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationMaxColorsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__227d95145a61e9640bd9930277540deb8aeaaac247cf6c797c879d37429d8d92)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d985a093ef763008ebf9c6349d1231fd136e56070c3576537c78f32da06259a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a9b8ca157cabf2b998615ae230da8bab357b569573d28476e9fcf4b705fdac9d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationMaxColors]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationMaxColors]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c68afb1a62a750fded72c9060679a7e863456104a28493428c8d1702c49ac9f9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationMaxColorsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationMaxColorsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f514f1df8791bc9da149273f56e8b218e4e3cc4ea962d474079c9b73e0234e8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColors")
    def reset_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColors", []))

    @jsii.member(jsii_name="resetColorsVar")
    def reset_colors_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorsVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorsInput")
    def colors_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsInput"))

    @builtins.property
    @jsii.member(jsii_name="colorsVarInput")
    def colors_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsVarInput"))

    @builtins.property
    @jsii.member(jsii_name="colors")
    def colors(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colors"))

    @colors.setter
    def colors(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__590c71c01d7adaa3cdbb86d7a7182b14d4eab58d045ea80f3c44a1f747c6a385)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colors", value)

    @builtins.property
    @jsii.member(jsii_name="colorsVar")
    def colors_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorsVar"))

    @colors_var.setter
    def colors_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__78f5567ac52c2ca78ceccdc7d43bff4a5f89aeac2c72d5e078263c3c4a317d08)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorsVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationMaxColors]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationMaxColors]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationMaxColors]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c325e5f2d12672fc28278e87d7f36f7b4630e1fe8b62efaaa49f8b2bbfea54d6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationMirror",
    jsii_struct_bases=[],
    name_mapping={
        "horizontal": "horizontal",
        "horizontal_var": "horizontalVar",
        "vertical": "vertical",
        "vertical_var": "verticalVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationMirror:
    def __init__(
        self,
        *,
        horizontal: typing.Optional[builtins.str] = None,
        horizontal_var: typing.Optional[builtins.str] = None,
        vertical: typing.Optional[builtins.str] = None,
        vertical_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param horizontal: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        :param horizontal_var: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        :param vertical: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        :param vertical_var: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ed6b27a2adf8fa9c4e5c76fd07a4cbf373939bd3a4fbff49ed7ec0712cc10b7)
            check_type(argname="argument horizontal", value=horizontal, expected_type=type_hints["horizontal"])
            check_type(argname="argument horizontal_var", value=horizontal_var, expected_type=type_hints["horizontal_var"])
            check_type(argname="argument vertical", value=vertical, expected_type=type_hints["vertical"])
            check_type(argname="argument vertical_var", value=vertical_var, expected_type=type_hints["vertical_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if horizontal is not None:
            self._values["horizontal"] = horizontal
        if horizontal_var is not None:
            self._values["horizontal_var"] = horizontal_var
        if vertical is not None:
            self._values["vertical"] = vertical
        if vertical_var is not None:
            self._values["vertical_var"] = vertical_var

    @builtins.property
    def horizontal(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        '''
        result = self._values.get("horizontal")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def horizontal_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        '''
        result = self._values.get("horizontal_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        '''
        result = self._values.get("vertical")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        result = self._values.get("vertical_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationMirror(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationMirrorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationMirrorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f6e4a3bad9b424596f6b0537f2391bbed0b7968f005bfe72c80373bd1e32b7e4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationMirrorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__56522ca0c8b1474e486a5c7cd391d4c61fd13b9a0bb914b3450df1fc9bebca19)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationMirrorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6691cfc654d7651a89d8cf6de5c74ab4af393e89fe833106944b49cc0bce0015)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8dc84dc8ad478a3166a7e21ce3d9943f158fb6acbdd944cc0354743188535743)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__131a01fc08d025b6676c200f27b299a75df4031b419a6d7208363116850a29dc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationMirror]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationMirror]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2e6814bf6659476533050d8e8347d0917e08bbb49fc9d77bd336e49e342ba088)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationMirrorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationMirrorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d7edb31e8a1648e9bfdae8d7eae7b13ddc17d60a526b64f56230f763aa0e939d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHorizontal")
    def reset_horizontal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontal", []))

    @jsii.member(jsii_name="resetHorizontalVar")
    def reset_horizontal_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontalVar", []))

    @jsii.member(jsii_name="resetVertical")
    def reset_vertical(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVertical", []))

    @jsii.member(jsii_name="resetVerticalVar")
    def reset_vertical_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVerticalVar", []))

    @builtins.property
    @jsii.member(jsii_name="horizontalInput")
    def horizontal_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontalVarInput")
    def horizontal_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalInput")
    def vertical_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalVarInput")
    def vertical_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontal")
    def horizontal(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontal"))

    @horizontal.setter
    def horizontal(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c8e2c898cc77f8af7a9404a5ec63cf2d90dfc7b17d3fdf33567e3a0f20ba5745)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontal", value)

    @builtins.property
    @jsii.member(jsii_name="horizontalVar")
    def horizontal_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontalVar"))

    @horizontal_var.setter
    def horizontal_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ecf4e5eb442468c1b4711fa43231be278825ee672a269c0d26c842e59eae9991)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontalVar", value)

    @builtins.property
    @jsii.member(jsii_name="vertical")
    def vertical(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "vertical"))

    @vertical.setter
    def vertical(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6247b997d187c101228ec07dba07ccc56b7667e08ce06ea1b5aaea05b60683e3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "vertical", value)

    @builtins.property
    @jsii.member(jsii_name="verticalVar")
    def vertical_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "verticalVar"))

    @vertical_var.setter
    def vertical_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__de2c022cff87ce4c100301413dc6fcec340f95e5b4c34b2b15c666a9a5e1212f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "verticalVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationMirror]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationMirror]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationMirror]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac4dd3a7c05882992b84a7406dd67809e5daf120c1f518c89ad799436eb89c5c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationMonoHue",
    jsii_struct_bases=[],
    name_mapping={"hue": "hue", "hue_var": "hueVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationMonoHue:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__958dcca45669fed26dbcaf9e17456cf7147dddf411be276b25fe0c4b87eeb2da)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationMonoHue(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationMonoHueList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationMonoHueList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6289376e109d62a78be5ede865ea070ed59df417bdeee58da60a2d25eb5560b6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationMonoHueOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__02b9e659f0d69621b7cfc68383590837b73d8fef6382616a9ec1fa841e1961cd)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationMonoHueOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ed4ef2e92dd4249b4eae45ecd3559a69a4e39bfa3afdbb439e3114bd06544393)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__356a4fab250cbec036dd08168136b210b647099d28c34f2c4ea9ac0135746e86)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ca50e9b58d465009bbaaf0e97ae6f85bdf8d9c34298096b02f3de9ffd5506e94)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationMonoHue]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationMonoHue]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f6ce8131b476fe8d982c07df82316f988a60a93a8c8ca0f952bf3c0cf4eaffd4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationMonoHueOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationMonoHueOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e0b02cc9a110967c496b264f48d52cb1fb1f6d3ad929eca09cdd3683cf59704d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__364b1ecdb304609f4fecdacdb3d7d7ebecab802141417f93ca06c742b2485331)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__65b6e952762aa62604706dd5034e8455920fb8b6c5f861277fe59bfcb7cc040e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationMonoHue]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationMonoHue]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationMonoHue]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__686210ae28f53c0054a842c19d1f2dafde8f1871c26ffba2a992ca86c880af03)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationOpacity",
    jsii_struct_bases=[],
    name_mapping={"opacity": "opacity", "opacity_var": "opacityVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationOpacity:
    def __init__(
        self,
        *,
        opacity: typing.Optional[builtins.str] = None,
        opacity_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param opacity: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param opacity_var: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9dd0a3e68281cbab3e8e2cd438a563aaadac1a98f843de1fd6d3f2f9afc6915f)
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument opacity_var", value=opacity_var, expected_type=type_hints["opacity_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if opacity is not None:
            self._values["opacity"] = opacity
        if opacity_var is not None:
            self._values["opacity_var"] = opacity_var

    @builtins.property
    def opacity(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def opacity_var(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        result = self._values.get("opacity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationOpacity(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationOpacityList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationOpacityList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a531903a6bf9a64573ce2d13d64d75e9145d0a32777bd8ece1992e52bee6be8a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationOpacityOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d99d5bdfecfd563a726fcfd411ddaf17a1df2dc4b2bbd467bf93c46d03eee4a2)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationOpacityOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fed1b66cb87e6171cd952a7b78711b787482082ef297219904c79100bf796d35)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a11df75333ab9398d9051e0144ad8b9bb950c98aa802a351ad7fa6758fd8d79)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4cf607aa3279854ecc555b4de59517140037569e522e8fcc75057c8e4ac09e1b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationOpacity]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationOpacity]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fd5d45a879a875f8c67f13496eb9a00aff162275d3fb490fc45f7da0c5593085)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationOpacityOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationOpacityOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e7e6d7f8ebb46cca993fa88b27df9dbcd8a9199fdcca85f8e79440ef9b61a635)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetOpacityVar")
    def reset_opacity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacityVar", []))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityVarInput")
    def opacity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacity"))

    @opacity.setter
    def opacity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__88d86f2f6a4d2b697ec06861c8f7814ab7e04d449c90fa67ce3115b3e54cb79a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacity", value)

    @builtins.property
    @jsii.member(jsii_name="opacityVar")
    def opacity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacityVar"))

    @opacity_var.setter
    def opacity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__197b1cfb41475dcc75d00a15d6c0393fa90521e578438b0e449a10416586b072)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacityVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationOpacity]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationOpacity]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationOpacity]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d197b605dc472b4bd6d8e86af69157678aafce73567b205edb7f8e8886381bc2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2fc24bf139d3a87382dd0b213e0999c20d19eba54795e0f43aa508e8710cb769)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putAppend")
    def put_append(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationAppend, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e6b95590d50ccf863fdc7f0d9e6c83a39ff479fc8e0ed2e5e3a8e7a52ecfaaa1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putAppend", [value]))

    @jsii.member(jsii_name="putAspectCrop")
    def put_aspect_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationAspectCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__982b6db1c628f5f1b474646802a2e5a20990ace25682f53153a50dd0c4a6ac2a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putAspectCrop", [value]))

    @jsii.member(jsii_name="putBackgroundColor")
    def put_background_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4dda560f4653f8f77721eea21a8f04e4d02297f517453358020fca6b37a00b2a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBackgroundColor", [value]))

    @jsii.member(jsii_name="putBlur")
    def put_blur(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationBlur, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ef24622eacefd35302077c59806dbf205888db8e1df35021cb4fa55ff9e9cb14)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBlur", [value]))

    @jsii.member(jsii_name="putChromaKey")
    def put_chroma_key(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationChromaKey, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c2c718355f05211312b3f6095dbb7e96ae761dbaae4500f10bbe3f8edcf05d33)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putChromaKey", [value]))

    @jsii.member(jsii_name="putComposite")
    def put_composite(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationComposite, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__887af053102a0c0916c77ff9a76ca9b55da2f4ad08a30a8a550f29c2f31a0f23)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putComposite", [value]))

    @jsii.member(jsii_name="putCompound")
    def put_compound(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationCompound, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__29b324805272964c93711cf27d2de3fc3851689ec3842ce0f2dbe99ad7c4f230)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCompound", [value]))

    @jsii.member(jsii_name="putContrast")
    def put_contrast(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationContrast, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__46d0406a2d728709009a0c2c78f7b2c4c31376197fc11b538004a4b04a96ffab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putContrast", [value]))

    @jsii.member(jsii_name="putCrop")
    def put_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__234851b81f0d44109ea5677a22f6338df32371c957fb5bd6fcca126c4c4538c1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCrop", [value]))

    @jsii.member(jsii_name="putFaceCrop")
    def put_face_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationFaceCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc8faa53302c70148f3864d6c38a2f07246684fe27a7b4f21ffa22b5544ffb08)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFaceCrop", [value]))

    @jsii.member(jsii_name="putFeatureCrop")
    def put_feature_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationFeatureCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ce707d1f7d40167fd23023d9a096a33f1f7f1d1cccb0b7a60b9781f16cb09d23)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFeatureCrop", [value]))

    @jsii.member(jsii_name="putFitAndFill")
    def put_fit_and_fill(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationFitAndFill, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fb7fab1282bed3be5c9f5b7dec1c5379c9fff2ff6c5af480cb6af77cba6b5aa5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFitAndFill", [value]))

    @jsii.member(jsii_name="putGoop")
    def put_goop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationGoop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__837015ab7f6456ab1a2a0aadfa005a551f9ef2db63e65a35729c41f9a0f3943f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGoop", [value]))

    @jsii.member(jsii_name="putGrayscale")
    def put_grayscale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationGrayscale, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__41aaa394bb3f62ce095d3d47bdcdda82aedf296de8d1cd9dca7df94a0b5333f5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGrayscale", [value]))

    @jsii.member(jsii_name="putHsl")
    def put_hsl(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationHsl, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5dabf26aa5fa8aff0f4a066917fcb7f96ccf54ecd456bdc07da257faa4d31037)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsl", [value]))

    @jsii.member(jsii_name="putHsv")
    def put_hsv(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationHsv, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7584ac1af29e579996ecb95b81200aaf25109cbc245d556f7166e3c630811dae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsv", [value]))

    @jsii.member(jsii_name="putIfDimension")
    def put_if_dimension(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfDimension, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7f979a25a6f20d71dddb01eb24f882f965672e3c2fdfb15b6a1731e64c8f843f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfDimension", [value]))

    @jsii.member(jsii_name="putIfOrientation")
    def put_if_orientation(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7b4ce9dd4c1232656a80a52c1c64ecc4ca72f53e8535e69c6cb95c92f42c279b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfOrientation", [value]))

    @jsii.member(jsii_name="putImQuery")
    def put_im_query(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationImQuery, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d441f28d76b1c1b5e44888dccaa2672ebec06aa9eef28b6e21c01936d3e65b3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putImQuery", [value]))

    @jsii.member(jsii_name="putMaxColors")
    def put_max_colors(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationMaxColors, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__15a8a23d69096e3f2d4c541be5a1be573ba249b6486754af539dbcf26d625f6a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMaxColors", [value]))

    @jsii.member(jsii_name="putMirror")
    def put_mirror(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationMirror, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bd165a02fac82bf3972bf2eddfb6e2efe7241f1efaecc2e8037e86fe91868e35)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMirror", [value]))

    @jsii.member(jsii_name="putMonoHue")
    def put_mono_hue(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationMonoHue, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__640ecd76041e9c2d56ffcf836eb38d2e2d836e2a5dc9eff56e3731e75f55f09d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMonoHue", [value]))

    @jsii.member(jsii_name="putOpacity")
    def put_opacity(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationOpacity, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4c380892f136bf8ce9a743418fb2c884ce0632b3c3b878cba78eae4b03213b4e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putOpacity", [value]))

    @jsii.member(jsii_name="putRegionOfInterestCrop")
    def put_region_of_interest_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationRegionOfInterestCrop", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1da5af7e737c9a5d6aaca5e265bdac1d6ba53fce8d045e948ceddbb998b3c114)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRegionOfInterestCrop", [value]))

    @jsii.member(jsii_name="putRelativeCrop")
    def put_relative_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationRelativeCrop", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c454d9508d808885a53a30c5386c6e490cc41023289977d5a24ec399f5976a36)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRelativeCrop", [value]))

    @jsii.member(jsii_name="putRemoveColor")
    def put_remove_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationRemoveColor", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ed2cabd92cdcfa5637a1580e90db47427b3617d4fb2176e38339f574279d1e73)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRemoveColor", [value]))

    @jsii.member(jsii_name="putResize")
    def put_resize(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationResize", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__22877278c65a26ac0db730ee75586a2a5d18b5eadced6414628540dbbd61f21d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putResize", [value]))

    @jsii.member(jsii_name="putRotate")
    def put_rotate(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationRotate", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__879a5edddc03c53ccb5db08707323c238af9173c98174e277ff247a065d6fd50)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRotate", [value]))

    @jsii.member(jsii_name="putScale")
    def put_scale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationScale", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a81c75fa8eb9f107f3ccb2d42a6861350d950e373e165ae9053633e8869e4f66)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putScale", [value]))

    @jsii.member(jsii_name="putShear")
    def put_shear(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationShear", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1d43e9829456f8776b537d7d9273457d8606a747a804f4ad76c02186e966c741)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putShear", [value]))

    @jsii.member(jsii_name="putTrim")
    def put_trim(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationTrim", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8c31e921fc9ed36e111d7e990d77c8bb81eaa6ab6d19fd0a2621363b771d0294)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTrim", [value]))

    @jsii.member(jsii_name="putUnsharpMask")
    def put_unsharp_mask(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationUnsharpMask", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6aec40641b51c2b77e41496607acf89fd65f5775440a0595f6f37a299ca0819a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putUnsharpMask", [value]))

    @jsii.member(jsii_name="resetAppend")
    def reset_append(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAppend", []))

    @jsii.member(jsii_name="resetAspectCrop")
    def reset_aspect_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspectCrop", []))

    @jsii.member(jsii_name="resetBackgroundColor")
    def reset_background_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBackgroundColor", []))

    @jsii.member(jsii_name="resetBlur")
    def reset_blur(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBlur", []))

    @jsii.member(jsii_name="resetChromaKey")
    def reset_chroma_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChromaKey", []))

    @jsii.member(jsii_name="resetComposite")
    def reset_composite(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetComposite", []))

    @jsii.member(jsii_name="resetCompound")
    def reset_compound(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCompound", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetCrop")
    def reset_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCrop", []))

    @jsii.member(jsii_name="resetFaceCrop")
    def reset_face_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFaceCrop", []))

    @jsii.member(jsii_name="resetFeatureCrop")
    def reset_feature_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureCrop", []))

    @jsii.member(jsii_name="resetFitAndFill")
    def reset_fit_and_fill(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFitAndFill", []))

    @jsii.member(jsii_name="resetGoop")
    def reset_goop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGoop", []))

    @jsii.member(jsii_name="resetGrayscale")
    def reset_grayscale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGrayscale", []))

    @jsii.member(jsii_name="resetHsl")
    def reset_hsl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsl", []))

    @jsii.member(jsii_name="resetHsv")
    def reset_hsv(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsv", []))

    @jsii.member(jsii_name="resetIfDimension")
    def reset_if_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfDimension", []))

    @jsii.member(jsii_name="resetIfOrientation")
    def reset_if_orientation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfOrientation", []))

    @jsii.member(jsii_name="resetImQuery")
    def reset_im_query(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetImQuery", []))

    @jsii.member(jsii_name="resetMaxColors")
    def reset_max_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxColors", []))

    @jsii.member(jsii_name="resetMirror")
    def reset_mirror(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMirror", []))

    @jsii.member(jsii_name="resetMonoHue")
    def reset_mono_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonoHue", []))

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetRegionOfInterestCrop")
    def reset_region_of_interest_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRegionOfInterestCrop", []))

    @jsii.member(jsii_name="resetRelativeCrop")
    def reset_relative_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRelativeCrop", []))

    @jsii.member(jsii_name="resetRemoveColor")
    def reset_remove_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRemoveColor", []))

    @jsii.member(jsii_name="resetResize")
    def reset_resize(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetResize", []))

    @jsii.member(jsii_name="resetRotate")
    def reset_rotate(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRotate", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetShear")
    def reset_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetShear", []))

    @jsii.member(jsii_name="resetTrim")
    def reset_trim(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTrim", []))

    @jsii.member(jsii_name="resetUnsharpMask")
    def reset_unsharp_mask(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUnsharpMask", []))

    @builtins.property
    @jsii.member(jsii_name="append")
    def append(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationAppendList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationAppendList, jsii.get(self, "append"))

    @builtins.property
    @jsii.member(jsii_name="aspectCrop")
    def aspect_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationAspectCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationAspectCropList, jsii.get(self, "aspectCrop"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColor")
    def background_color(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationBackgroundColorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationBackgroundColorList, jsii.get(self, "backgroundColor"))

    @builtins.property
    @jsii.member(jsii_name="blur")
    def blur(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationBlurList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationBlurList, jsii.get(self, "blur"))

    @builtins.property
    @jsii.member(jsii_name="chromaKey")
    def chroma_key(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationChromaKeyList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationChromaKeyList, jsii.get(self, "chromaKey"))

    @builtins.property
    @jsii.member(jsii_name="composite")
    def composite(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationCompositeList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationCompositeList, jsii.get(self, "composite"))

    @builtins.property
    @jsii.member(jsii_name="compound")
    def compound(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationCompoundList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationCompoundList, jsii.get(self, "compound"))

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationContrastList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationContrastList, jsii.get(self, "contrast"))

    @builtins.property
    @jsii.member(jsii_name="crop")
    def crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationCropList, jsii.get(self, "crop"))

    @builtins.property
    @jsii.member(jsii_name="faceCrop")
    def face_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationFaceCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationFaceCropList, jsii.get(self, "faceCrop"))

    @builtins.property
    @jsii.member(jsii_name="featureCrop")
    def feature_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationFeatureCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationFeatureCropList, jsii.get(self, "featureCrop"))

    @builtins.property
    @jsii.member(jsii_name="fitAndFill")
    def fit_and_fill(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationFitAndFillList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationFitAndFillList, jsii.get(self, "fitAndFill"))

    @builtins.property
    @jsii.member(jsii_name="goop")
    def goop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationGoopList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationGoopList, jsii.get(self, "goop"))

    @builtins.property
    @jsii.member(jsii_name="grayscale")
    def grayscale(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationGrayscaleList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationGrayscaleList, jsii.get(self, "grayscale"))

    @builtins.property
    @jsii.member(jsii_name="hsl")
    def hsl(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationHslList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationHslList, jsii.get(self, "hsl"))

    @builtins.property
    @jsii.member(jsii_name="hsv")
    def hsv(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationHsvList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationHsvList, jsii.get(self, "hsv"))

    @builtins.property
    @jsii.member(jsii_name="ifDimension")
    def if_dimension(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfDimensionList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfDimensionList, jsii.get(self, "ifDimension"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientation")
    def if_orientation(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfOrientationList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfOrientationList, jsii.get(self, "ifOrientation"))

    @builtins.property
    @jsii.member(jsii_name="imQuery")
    def im_query(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationImQueryList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationImQueryList, jsii.get(self, "imQuery"))

    @builtins.property
    @jsii.member(jsii_name="maxColors")
    def max_colors(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationMaxColorsList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationMaxColorsList, jsii.get(self, "maxColors"))

    @builtins.property
    @jsii.member(jsii_name="mirror")
    def mirror(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationMirrorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationMirrorList, jsii.get(self, "mirror"))

    @builtins.property
    @jsii.member(jsii_name="monoHue")
    def mono_hue(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationMonoHueList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationMonoHueList, jsii.get(self, "monoHue"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationOpacityList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationOpacityList, jsii.get(self, "opacity"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestCrop")
    def region_of_interest_crop(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationRegionOfInterestCropList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationRegionOfInterestCropList", jsii.get(self, "regionOfInterestCrop"))

    @builtins.property
    @jsii.member(jsii_name="relativeCrop")
    def relative_crop(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationRelativeCropList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationRelativeCropList", jsii.get(self, "relativeCrop"))

    @builtins.property
    @jsii.member(jsii_name="removeColor")
    def remove_color(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationRemoveColorList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationRemoveColorList", jsii.get(self, "removeColor"))

    @builtins.property
    @jsii.member(jsii_name="resize")
    def resize(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationResizeList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationResizeList", jsii.get(self, "resize"))

    @builtins.property
    @jsii.member(jsii_name="rotate")
    def rotate(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationRotateList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationRotateList", jsii.get(self, "rotate"))

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationScaleList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationScaleList", jsii.get(self, "scale"))

    @builtins.property
    @jsii.member(jsii_name="shear")
    def shear(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationShearList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationShearList", jsii.get(self, "shear"))

    @builtins.property
    @jsii.member(jsii_name="trim")
    def trim(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationTrimList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationTrimList", jsii.get(self, "trim"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMask")
    def unsharp_mask(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationUnsharpMaskList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationUnsharpMaskList", jsii.get(self, "unsharpMask"))

    @builtins.property
    @jsii.member(jsii_name="appendInput")
    def append_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationAppend]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationAppend]]], jsii.get(self, "appendInput"))

    @builtins.property
    @jsii.member(jsii_name="aspectCropInput")
    def aspect_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationAspectCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationAspectCrop]]], jsii.get(self, "aspectCropInput"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColorInput")
    def background_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationBackgroundColor]]], jsii.get(self, "backgroundColorInput"))

    @builtins.property
    @jsii.member(jsii_name="blurInput")
    def blur_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationBlur]]], jsii.get(self, "blurInput"))

    @builtins.property
    @jsii.member(jsii_name="chromaKeyInput")
    def chroma_key_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationChromaKey]]], jsii.get(self, "chromaKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="compositeInput")
    def composite_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationComposite]]], jsii.get(self, "compositeInput"))

    @builtins.property
    @jsii.member(jsii_name="compoundInput")
    def compound_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationCompound]]], jsii.get(self, "compoundInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationContrast]]], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="cropInput")
    def crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationCrop]]], jsii.get(self, "cropInput"))

    @builtins.property
    @jsii.member(jsii_name="faceCropInput")
    def face_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationFaceCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationFaceCrop]]], jsii.get(self, "faceCropInput"))

    @builtins.property
    @jsii.member(jsii_name="featureCropInput")
    def feature_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationFeatureCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationFeatureCrop]]], jsii.get(self, "featureCropInput"))

    @builtins.property
    @jsii.member(jsii_name="fitAndFillInput")
    def fit_and_fill_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationFitAndFill]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationFitAndFill]]], jsii.get(self, "fitAndFillInput"))

    @builtins.property
    @jsii.member(jsii_name="goopInput")
    def goop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationGoop]]], jsii.get(self, "goopInput"))

    @builtins.property
    @jsii.member(jsii_name="grayscaleInput")
    def grayscale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationGrayscale]]], jsii.get(self, "grayscaleInput"))

    @builtins.property
    @jsii.member(jsii_name="hslInput")
    def hsl_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationHsl]]], jsii.get(self, "hslInput"))

    @builtins.property
    @jsii.member(jsii_name="hsvInput")
    def hsv_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationHsv]]], jsii.get(self, "hsvInput"))

    @builtins.property
    @jsii.member(jsii_name="ifDimensionInput")
    def if_dimension_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfDimension]]], jsii.get(self, "ifDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientationInput")
    def if_orientation_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfOrientation]]], jsii.get(self, "ifOrientationInput"))

    @builtins.property
    @jsii.member(jsii_name="imQueryInput")
    def im_query_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationImQuery]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationImQuery]]], jsii.get(self, "imQueryInput"))

    @builtins.property
    @jsii.member(jsii_name="maxColorsInput")
    def max_colors_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationMaxColors]]], jsii.get(self, "maxColorsInput"))

    @builtins.property
    @jsii.member(jsii_name="mirrorInput")
    def mirror_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationMirror]]], jsii.get(self, "mirrorInput"))

    @builtins.property
    @jsii.member(jsii_name="monoHueInput")
    def mono_hue_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationMonoHue]]], jsii.get(self, "monoHueInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationOpacity]]], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestCropInput")
    def region_of_interest_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationRegionOfInterestCrop"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationRegionOfInterestCrop"]]], jsii.get(self, "regionOfInterestCropInput"))

    @builtins.property
    @jsii.member(jsii_name="relativeCropInput")
    def relative_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationRelativeCrop"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationRelativeCrop"]]], jsii.get(self, "relativeCropInput"))

    @builtins.property
    @jsii.member(jsii_name="removeColorInput")
    def remove_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationRemoveColor"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationRemoveColor"]]], jsii.get(self, "removeColorInput"))

    @builtins.property
    @jsii.member(jsii_name="resizeInput")
    def resize_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationResize"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationResize"]]], jsii.get(self, "resizeInput"))

    @builtins.property
    @jsii.member(jsii_name="rotateInput")
    def rotate_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationRotate"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationRotate"]]], jsii.get(self, "rotateInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationScale"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationScale"]]], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="shearInput")
    def shear_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationShear"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationShear"]]], jsii.get(self, "shearInput"))

    @builtins.property
    @jsii.member(jsii_name="trimInput")
    def trim_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationTrim"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationTrim"]]], jsii.get(self, "trimInput"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMaskInput")
    def unsharp_mask_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationUnsharpMask"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationUnsharpMask"]]], jsii.get(self, "unsharpMaskInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc225e7138da3fd40efcf8cdcb90dcae08b545813a7c8423142af12e54fd1d80)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationRegionOfInterestCrop",
    jsii_struct_bases=[],
    name_mapping={
        "region_of_interest": "regionOfInterest",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationRegionOfInterestCrop:
    def __init__(
        self,
        *,
        region_of_interest: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationRegionOfInterestCropRegionOfInterest", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param region_of_interest: region_of_interest block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest DataAkamaiImagingPolicyImage#region_of_interest}
        :param gravity: The placement of the crop area relative to the specified area of interest. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: The placement of the crop area relative to the specified area of interest. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param style: Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(region_of_interest, dict):
            region_of_interest = DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationRegionOfInterestCropRegionOfInterest(**region_of_interest)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a75b4b60c3e4aeb50703a7dfb9bbdb767f710170a2c7cf60275b360b40e0a5a)
            check_type(argname="argument region_of_interest", value=region_of_interest, expected_type=type_hints["region_of_interest"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "region_of_interest": region_of_interest,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def region_of_interest(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationRegionOfInterestCropRegionOfInterest":
        '''region_of_interest block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest DataAkamaiImagingPolicyImage#region_of_interest}
        '''
        result = self._values.get("region_of_interest")
        assert result is not None, "Required property 'region_of_interest' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationRegionOfInterestCropRegionOfInterest", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''The placement of the crop area relative to the specified area of interest.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''The placement of the crop area relative to the specified area of interest.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationRegionOfInterestCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationRegionOfInterestCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationRegionOfInterestCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4083070230142de377a23416197767618325e5a0faf104c3b28b2cbd200e5366)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationRegionOfInterestCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9e3e4279c2a65cb22563a4d97780f539824008a75879765cbc134ea18d86d736)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationRegionOfInterestCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__166dfae403e68b07c579d893b520e2319534b5aec6e14b6cd018b02870531e87)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6ac403d43337ef1c6352896177b9b7d3371cba8b2dd4bdadb3425fc395ef2ad7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6ea0cacd180c759d3e76b916290f07332dde62bb87c95631b7ecb1aa6f291b63)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationRegionOfInterestCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationRegionOfInterestCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationRegionOfInterestCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c5e4145ea2bd49c9706ed744c43cd1131e0041d3bbbecd37b3538a0192be3625)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationRegionOfInterestCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationRegionOfInterestCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3c48bb50e604dde3c4b3850f4b9230d26becfdbf428c12e60102c474a16daa48)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putRegionOfInterest")
    def put_region_of_interest(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationRegionOfInterestCropRegionOfInterest()

        return typing.cast(None, jsii.invoke(self, "putRegionOfInterest", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterest")
    def region_of_interest(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationRegionOfInterestCropRegionOfInterestOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationRegionOfInterestCropRegionOfInterestOutputReference", jsii.get(self, "regionOfInterest"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestInput")
    def region_of_interest_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationRegionOfInterestCropRegionOfInterest"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationRegionOfInterestCropRegionOfInterest"], jsii.get(self, "regionOfInterestInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9c074b6c83fc8423fd288102f601184097e6319a28cd67e57b1b528ef8fa1b8a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e769bd3b0975ba8f09f559b6e96ee66a7cf303852a5d6c520b1e1c8b3bd674d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d8139af8d0b872d5176184b572e98effdbc89957774b891db0ee6cf49208a981)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0404ac59e88e646daeb8bceed20bd75afb35e81e96ef17630b85018ea9f17282)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bbe799d973a9b9da4c37cd6a06b9f4fd1b1e7d36698f0f5825bf49475c126768)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b6a02afda702d2ec3c9daf217e13d07d573e380f9ad5d1155aa0ded1379b926e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b099177ca7e80f6da7ee936456397e5ab6ae21ecaa261edae92556cb916fc285)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__10de32f8b679a40300111daa3021e5bbe7c3f85a65c01771e06429a57054e512)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationRegionOfInterestCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationRegionOfInterestCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationRegionOfInterestCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5e3c055384d4a98f20c594a43fd6e32dd1f5e29338436f342bedc6029d3c7efa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationRegionOfInterestCropRegionOfInterest",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationRegionOfInterestCropRegionOfInterest:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationRegionOfInterestCropRegionOfInterest(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationRegionOfInterestCropRegionOfInterestOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationRegionOfInterestCropRegionOfInterestOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9e01fcd77f5c6831c483236a4146eec9b6866598ebb668a4fcc411c29703e1c9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationRegionOfInterestCropRegionOfInterest]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationRegionOfInterestCropRegionOfInterest], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationRegionOfInterestCropRegionOfInterest],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__92d68513b5f5dbfa695bb0500ed1975cc19061d0311a2ea3bed3e3623aeeff55)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationRelativeCrop",
    jsii_struct_bases=[],
    name_mapping={
        "east": "east",
        "east_var": "eastVar",
        "north": "north",
        "north_var": "northVar",
        "south": "south",
        "south_var": "southVar",
        "west": "west",
        "west_var": "westVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationRelativeCrop:
    def __init__(
        self,
        *,
        east: typing.Optional[builtins.str] = None,
        east_var: typing.Optional[builtins.str] = None,
        north: typing.Optional[builtins.str] = None,
        north_var: typing.Optional[builtins.str] = None,
        south: typing.Optional[builtins.str] = None,
        south_var: typing.Optional[builtins.str] = None,
        west: typing.Optional[builtins.str] = None,
        west_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param east: The number of pixels to shrink or expand the right side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east DataAkamaiImagingPolicyImage#east}
        :param east_var: The number of pixels to shrink or expand the right side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east_var DataAkamaiImagingPolicyImage#east_var}
        :param north: The number of pixels to shrink or expand the top side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north DataAkamaiImagingPolicyImage#north}
        :param north_var: The number of pixels to shrink or expand the top side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north_var DataAkamaiImagingPolicyImage#north_var}
        :param south: The number of pixels to shrink or expand the bottom side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south DataAkamaiImagingPolicyImage#south}
        :param south_var: The number of pixels to shrink or expand the bottom side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south_var DataAkamaiImagingPolicyImage#south_var}
        :param west: The number of pixels to shrink or expand the left side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west DataAkamaiImagingPolicyImage#west}
        :param west_var: The number of pixels to shrink or expand the left side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west_var DataAkamaiImagingPolicyImage#west_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7ea4f516a493d7ef38d0e2acb637cf80e5d09083b4a2a93e4fba17e55280d50f)
            check_type(argname="argument east", value=east, expected_type=type_hints["east"])
            check_type(argname="argument east_var", value=east_var, expected_type=type_hints["east_var"])
            check_type(argname="argument north", value=north, expected_type=type_hints["north"])
            check_type(argname="argument north_var", value=north_var, expected_type=type_hints["north_var"])
            check_type(argname="argument south", value=south, expected_type=type_hints["south"])
            check_type(argname="argument south_var", value=south_var, expected_type=type_hints["south_var"])
            check_type(argname="argument west", value=west, expected_type=type_hints["west"])
            check_type(argname="argument west_var", value=west_var, expected_type=type_hints["west_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if east is not None:
            self._values["east"] = east
        if east_var is not None:
            self._values["east_var"] = east_var
        if north is not None:
            self._values["north"] = north
        if north_var is not None:
            self._values["north_var"] = north_var
        if south is not None:
            self._values["south"] = south
        if south_var is not None:
            self._values["south_var"] = south_var
        if west is not None:
            self._values["west"] = west
        if west_var is not None:
            self._values["west_var"] = west_var

    @builtins.property
    def east(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the right side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east DataAkamaiImagingPolicyImage#east}
        '''
        result = self._values.get("east")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def east_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the right side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east_var DataAkamaiImagingPolicyImage#east_var}
        '''
        result = self._values.get("east_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def north(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the top side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north DataAkamaiImagingPolicyImage#north}
        '''
        result = self._values.get("north")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def north_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the top side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north_var DataAkamaiImagingPolicyImage#north_var}
        '''
        result = self._values.get("north_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def south(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the bottom side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south DataAkamaiImagingPolicyImage#south}
        '''
        result = self._values.get("south")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def south_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the bottom side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south_var DataAkamaiImagingPolicyImage#south_var}
        '''
        result = self._values.get("south_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def west(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the left side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west DataAkamaiImagingPolicyImage#west}
        '''
        result = self._values.get("west")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def west_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the left side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west_var DataAkamaiImagingPolicyImage#west_var}
        '''
        result = self._values.get("west_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationRelativeCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationRelativeCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationRelativeCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d89f60ca79594441d2165a7978942a493933b20b524c795e199549045d9ac64)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationRelativeCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b7577f51791d79d227cd938c1a79b8eeea596db2c64e3c4856e677dd2cfea9a1)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationRelativeCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__14038dec01e6d7887253da6a74a50a5dfa1e1a4e8871245906157d14fd29b17e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__18d0e887e8fa63712c487d64cd4ac304331c5fce7ea350c2d7e16f8e90c642b8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f31a16c42b0a02cf725974ee74bbf5b33f87721bac3e5fb900768dc970a4e439)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationRelativeCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationRelativeCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationRelativeCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eef1d50829a67e639fd1440e7a9affb81ed00e3b3f947e3d4631ca1f301f6da2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationRelativeCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationRelativeCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dccb78f40a9f20a656b77f2936fc8417f32f2a7d204f480eab8c5921f8d1c745)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetEast")
    def reset_east(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEast", []))

    @jsii.member(jsii_name="resetEastVar")
    def reset_east_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEastVar", []))

    @jsii.member(jsii_name="resetNorth")
    def reset_north(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNorth", []))

    @jsii.member(jsii_name="resetNorthVar")
    def reset_north_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNorthVar", []))

    @jsii.member(jsii_name="resetSouth")
    def reset_south(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSouth", []))

    @jsii.member(jsii_name="resetSouthVar")
    def reset_south_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSouthVar", []))

    @jsii.member(jsii_name="resetWest")
    def reset_west(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWest", []))

    @jsii.member(jsii_name="resetWestVar")
    def reset_west_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWestVar", []))

    @builtins.property
    @jsii.member(jsii_name="eastInput")
    def east_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "eastInput"))

    @builtins.property
    @jsii.member(jsii_name="eastVarInput")
    def east_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "eastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="northInput")
    def north_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "northInput"))

    @builtins.property
    @jsii.member(jsii_name="northVarInput")
    def north_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "northVarInput"))

    @builtins.property
    @jsii.member(jsii_name="southInput")
    def south_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "southInput"))

    @builtins.property
    @jsii.member(jsii_name="southVarInput")
    def south_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "southVarInput"))

    @builtins.property
    @jsii.member(jsii_name="westInput")
    def west_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "westInput"))

    @builtins.property
    @jsii.member(jsii_name="westVarInput")
    def west_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "westVarInput"))

    @builtins.property
    @jsii.member(jsii_name="east")
    def east(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "east"))

    @east.setter
    def east(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e150ab41b1635388eb95c77bc98ff167b2ffe0a0ef1c5bf9eab067f6019159a6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "east", value)

    @builtins.property
    @jsii.member(jsii_name="eastVar")
    def east_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "eastVar"))

    @east_var.setter
    def east_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__472259650579c09c5ddfc990292f3b9279cdc5779315dedfa2e4c584e2bc5de4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "eastVar", value)

    @builtins.property
    @jsii.member(jsii_name="north")
    def north(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "north"))

    @north.setter
    def north(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1d5b29c1ff972f403e67181c6497f8a7c0421e7576ec3bf7be3c00eed8d6a1cc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "north", value)

    @builtins.property
    @jsii.member(jsii_name="northVar")
    def north_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "northVar"))

    @north_var.setter
    def north_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e288233a36e2aee9d7ed3a679e49cc40d0d07c12ba205742083fe9a1796ff3e7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "northVar", value)

    @builtins.property
    @jsii.member(jsii_name="south")
    def south(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "south"))

    @south.setter
    def south(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ca9c2651443439fa17fecc382e4c0a46c7271521c3163a9e2df17f61c3179d9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "south", value)

    @builtins.property
    @jsii.member(jsii_name="southVar")
    def south_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "southVar"))

    @south_var.setter
    def south_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__73f24fdb04ada7e522f4453c895ee9cc1480ac3d5febaab59003a114eabc4c1b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "southVar", value)

    @builtins.property
    @jsii.member(jsii_name="west")
    def west(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "west"))

    @west.setter
    def west(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ace3fd51fa102e84a9c145d61b6311b3f5efb7845a8b3729c426aa2f4b64cf22)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "west", value)

    @builtins.property
    @jsii.member(jsii_name="westVar")
    def west_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "westVar"))

    @west_var.setter
    def west_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c2841d59797ccff5be15a2c042a79f3912e4440edde321bd3b074f41d1850dd0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "westVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationRelativeCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationRelativeCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationRelativeCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__48f5067b3ccfdcf5380b5ba0274666dfa08bd7b5be577da7330bff725a05b43a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationRemoveColor",
    jsii_struct_bases=[],
    name_mapping={
        "color": "color",
        "color_var": "colorVar",
        "feather": "feather",
        "feather_var": "featherVar",
        "tolerance": "tolerance",
        "tolerance_var": "toleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationRemoveColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
        feather: typing.Optional[builtins.str] = None,
        feather_var: typing.Optional[builtins.str] = None,
        tolerance: typing.Optional[builtins.str] = None,
        tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        :param feather: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        :param feather_var: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        :param tolerance: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        :param tolerance_var: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5d4ee1674691308d01d7c5d98dd52225a56afbc89a92475db7c8900fc090c2fa)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
            check_type(argname="argument feather", value=feather, expected_type=type_hints["feather"])
            check_type(argname="argument feather_var", value=feather_var, expected_type=type_hints["feather_var"])
            check_type(argname="argument tolerance", value=tolerance, expected_type=type_hints["tolerance"])
            check_type(argname="argument tolerance_var", value=tolerance_var, expected_type=type_hints["tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var
        if feather is not None:
            self._values["feather"] = feather
        if feather_var is not None:
            self._values["feather_var"] = feather_var
        if tolerance is not None:
            self._values["tolerance"] = tolerance
        if tolerance_var is not None:
            self._values["tolerance_var"] = tolerance_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        '''
        result = self._values.get("feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather_var(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        '''
        result = self._values.get("feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        '''
        result = self._values.get("tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance_var(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        result = self._values.get("tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationRemoveColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationRemoveColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationRemoveColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6b272bc78961ca60efdad863597fe6949496f382f9959c172425a910245d2840)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationRemoveColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__290c6ce7e128f074787c1def05d8723fcb6dc3e7f7ebb584fbed10f3dbf147e9)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationRemoveColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8968520867555cd56142465331eed53804fd7bc286d5ab8f2be0d0e9884b28eb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6b2b0cbf288aa415752c4a636079786ad83acd1033583df852e0141ccfa4fb2c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea31d91e10eb244580f3468d41a29abd4fc5a5b2227bd220969bc2f703c650fc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationRemoveColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationRemoveColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationRemoveColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ba945c1c2ffa8b8a142abf5cca5ef6e48ebebc66fb58aaf021caf1e2f273e66)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationRemoveColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationRemoveColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__697a933da99c40e3ac5c284e934778f1bab0608a45f5e671d0aee143370d1ee1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @jsii.member(jsii_name="resetFeather")
    def reset_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeather", []))

    @jsii.member(jsii_name="resetFeatherVar")
    def reset_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatherVar", []))

    @jsii.member(jsii_name="resetTolerance")
    def reset_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTolerance", []))

    @jsii.member(jsii_name="resetToleranceVar")
    def reset_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featherInput")
    def feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherInput"))

    @builtins.property
    @jsii.member(jsii_name="featherVarInput")
    def feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceInput")
    def tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceVarInput")
    def tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__97a7445a82af2e7599aea15c707bcc49784805182750b35e49ccef54508153af)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__02a7182a50aecb76742cdb0030117ff15d9bfdfa53871f2762088dc165455f75)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="feather")
    def feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "feather"))

    @feather.setter
    def feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__28dee3264b3acfda151d404e0ae830b962245a92535b93fc7fb36c22d8f9f6bd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "feather", value)

    @builtins.property
    @jsii.member(jsii_name="featherVar")
    def feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featherVar"))

    @feather_var.setter
    def feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__72fc8aa380aec697f8bcdc2f0933e54026ee56d206c184181b4f42f87fd682f6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featherVar", value)

    @builtins.property
    @jsii.member(jsii_name="tolerance")
    def tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tolerance"))

    @tolerance.setter
    def tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8b441e6a03edfbe3cdc088f8ebbe5f58a376d882de8662541bb04c13b41a8cc2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tolerance", value)

    @builtins.property
    @jsii.member(jsii_name="toleranceVar")
    def tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "toleranceVar"))

    @tolerance_var.setter
    def tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2e66845f2c79d2ff3dbeb348c19bf335ea69ad40fa07e6dd3f05c545f3d19aef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "toleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationRemoveColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationRemoveColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationRemoveColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8d3dcdde4840c62a8447404bcef79cade407db49f283d3f2cc6436c3b95f0164)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationResize",
    jsii_struct_bases=[],
    name_mapping={
        "aspect": "aspect",
        "aspect_var": "aspectVar",
        "height": "height",
        "height_var": "heightVar",
        "type": "type",
        "type_var": "typeVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationResize:
    def __init__(
        self,
        *,
        aspect: typing.Optional[builtins.str] = None,
        aspect_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param aspect: Preserves the aspect ratio. Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect DataAkamaiImagingPolicyImage#aspect}
        :param aspect_var: Preserves the aspect ratio. Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_var DataAkamaiImagingPolicyImage#aspect_var}
        :param height: The height to resize the source image to. Must be set if height is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height to resize the source image to. Must be set if height is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param type: Sets constraints for the image resize. Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: Sets constraints for the image resize. Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        :param width: The width to resize the source image to. Must be set if width is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width to resize the source image to. Must be set if width is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__635b161fd751032d07f8b2f8896bf0c81e0696d97cf9ab0a63250ff441c7d3b7)
            check_type(argname="argument aspect", value=aspect, expected_type=type_hints["aspect"])
            check_type(argname="argument aspect_var", value=aspect_var, expected_type=type_hints["aspect_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if aspect is not None:
            self._values["aspect"] = aspect
        if aspect_var is not None:
            self._values["aspect_var"] = aspect_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def aspect(self) -> typing.Optional[builtins.str]:
        '''Preserves the aspect ratio.

        Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect DataAkamaiImagingPolicyImage#aspect}
        '''
        result = self._values.get("aspect")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def aspect_var(self) -> typing.Optional[builtins.str]:
        '''Preserves the aspect ratio.

        Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_var DataAkamaiImagingPolicyImage#aspect_var}
        '''
        result = self._values.get("aspect_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height to resize the source image to. Must be set if height is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height to resize the source image to. Must be set if height is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''Sets constraints for the image resize.

        Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''Sets constraints for the image resize.

        Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width to resize the source image to. Must be set if width is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width to resize the source image to. Must be set if width is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationResize(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationResizeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationResizeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5806cf29c45ea7c48f096a8ec2b23f2ba65c40bcd762119436673aaf756792c7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationResizeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5c6fdc608fdbc10cdca793bacfb4c8d9825a79142ba1068e6a3f9457cb5e9fba)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationResizeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ba8fa6d24baada891cc580cfaa393ef7accb2c72ff7e244b708b9cd1da9a147)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3d6a9f5e6ae29ad5fd474c390378a89b582af5e34da8d87b6b8cdd564dbc16c0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cba5adc1cb0701729befc71217b315272e171bb36871b7436146ca252e43c0bb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationResize]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationResize]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationResize]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__772d68b46a8c328aaabd4b564f209da5b81865d2f6397645201e945701db2fe7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationResizeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationResizeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__57c9873513ba7825abcc02f6003b42ac290efe398f861288181275fc36a2ffe0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAspect")
    def reset_aspect(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspect", []))

    @jsii.member(jsii_name="resetAspectVar")
    def reset_aspect_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspectVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="aspectInput")
    def aspect_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "aspectInput"))

    @builtins.property
    @jsii.member(jsii_name="aspectVarInput")
    def aspect_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "aspectVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="aspect")
    def aspect(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "aspect"))

    @aspect.setter
    def aspect(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8741ed6dce0c1b08eaa9f20c3e4c973109ca739d9d79a97d325c34356bcff6a9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "aspect", value)

    @builtins.property
    @jsii.member(jsii_name="aspectVar")
    def aspect_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "aspectVar"))

    @aspect_var.setter
    def aspect_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aa4445362c23599e415ca68d8f0c50d39fd4a03f8eb82d38fd150b511c9e66ca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "aspectVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ff59a1291570f49c781141a98f9e04dd12648ea7d3df827808c520d1f734f45)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__24ec4537f56f06285b84027208de87108f2b9d2b9bc22e4660661bd60da4712c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b6be9889e3cf09a19127cb934b6cd1a9a20a7a91c295a0de0cfacd04b84269c5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__14fa9c380856b7311bf99d9de22c6c537b9b13792f7b47d5ed6be259b5754be6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dd022406b51186e2dd57eb725ff1cf24c51554cda7db2a073752922aae60c709)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__090d0bb5c33e58b225fecaff1da2f0db5c9c7b06c3395932d8a9a5583c62c96c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationResize]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationResize]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationResize]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1cd91a73ce52f11605441ef0df39a34570e5029f848e3bf2c3e68c58534055d5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationRotate",
    jsii_struct_bases=[],
    name_mapping={"degrees": "degrees", "degrees_var": "degreesVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationRotate:
    def __init__(
        self,
        *,
        degrees: typing.Optional[builtins.str] = None,
        degrees_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param degrees: The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees DataAkamaiImagingPolicyImage#degrees}
        :param degrees_var: The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees_var DataAkamaiImagingPolicyImage#degrees_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__afc01e50a25c03a5077933767e3ee83e17dfd0ca4d23cb9dc4b4e027494ccb96)
            check_type(argname="argument degrees", value=degrees, expected_type=type_hints["degrees"])
            check_type(argname="argument degrees_var", value=degrees_var, expected_type=type_hints["degrees_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if degrees is not None:
            self._values["degrees"] = degrees
        if degrees_var is not None:
            self._values["degrees_var"] = degrees_var

    @builtins.property
    def degrees(self) -> typing.Optional[builtins.str]:
        '''The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees DataAkamaiImagingPolicyImage#degrees}
        '''
        result = self._values.get("degrees")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def degrees_var(self) -> typing.Optional[builtins.str]:
        '''The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees_var DataAkamaiImagingPolicyImage#degrees_var}
        '''
        result = self._values.get("degrees_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationRotate(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationRotateList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationRotateList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a09f9c9454f7cd106e60141aece251e85c1e546cee7ae6afa03a2e652fe33e80)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationRotateOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6ec60c7f80eb47b78d970bdb8bbc3d5ae999b07b9041c327313529c3fb7583dc)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationRotateOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2813b8a22e633db7c83065eaa9fe5ee9ca1eaa98887c2aa481f00d0590950521)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b9457593520ec3bc1408ac393daf727688fc72195b6c03284c04f0ee0eb9839a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__141630ff49309ba4ef572d7522a9627101030ab1f2796b81d93ced78331e5cc6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationRotate]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationRotate]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationRotate]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d5111fdace177faa9fa5028103f16a71daf8e6e939ac9f3ae04b0ec0a540b924)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationRotateOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationRotateOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8434d2a4bae091a3de3c25c39c54b264dd68389c5f2f0bd89e793e91d96fcc1d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetDegrees")
    def reset_degrees(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDegrees", []))

    @jsii.member(jsii_name="resetDegreesVar")
    def reset_degrees_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDegreesVar", []))

    @builtins.property
    @jsii.member(jsii_name="degreesInput")
    def degrees_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "degreesInput"))

    @builtins.property
    @jsii.member(jsii_name="degreesVarInput")
    def degrees_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "degreesVarInput"))

    @builtins.property
    @jsii.member(jsii_name="degrees")
    def degrees(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "degrees"))

    @degrees.setter
    def degrees(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__feded2e2addb6b1c44fba6f544f56b550e5eb42e1f56fb4addd2d81320d0a6e1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "degrees", value)

    @builtins.property
    @jsii.member(jsii_name="degreesVar")
    def degrees_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "degreesVar"))

    @degrees_var.setter
    def degrees_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__45d683450b54fcbfa38797aa771f7e64fb46ce6bbd0502517a3302fde748439f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "degreesVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationRotate]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationRotate]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationRotate]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__34a8828fde0286b1497198b6c67e9c10d681739088cb76bfa237887b433a94e0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationScale",
    jsii_struct_bases=[],
    name_mapping={
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationScale:
    def __init__(
        self,
        *,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param height: Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged. Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged. Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4c5d111e2638dd38c0991c461209e4cdbba1c34df94e2822e18e6dec1dea7113)
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size.

        Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size.

        Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged.

        Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged.

        Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationScale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationScaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationScaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ee8cd547fd68eba84f28249dda4dec226113e35198186622d5278b8f2968b36b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationScaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ff684068c678daed03ac75b29503dd2fdc15cea57e708f5411fa851ef6f6008)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationScaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__68b247112806e73c6b6d963e52b3c0c639b71419aa71ba28491c80de4da9e409)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__56e85596f7e84d76bc7400c0141fa04eaf846bb37d412ead76ed7b4275bd8bd7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3f30b29080e71026386ac9d95a4f26228a83e12d5f2726c977379307122adc30)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationScale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationScale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationScale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7788ae081b27efba21a3d82f3561a3e8eb28e83b560571d805a7b189a39534ab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationScaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationScaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4bce6716b2f7a1749a24becf2aacb0126b64002f77953f011b34d179ddc3634c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__40a6fb834f5c09075f15b622ad68bd934d663a2d34f45b50ca5dbd9c09af7037)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f1f6d516e04b9ef325a6ec24917bb738b8ff049c8cf27aa20a74952b46ba659)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fb5cb6d4bb1d09fcd81749853b3e4e2e7af37512435cd3a8a3d007dc82838987)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f6e5a27d9736ff10105c93a97386efd356e9917d5ae5a8f8cec7f79768374da6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationScale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationScale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationScale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f02b91813bf20d985c864985297c18fbf9bf0c550ada4cf17d7ca6203bd154f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationShear",
    jsii_struct_bases=[],
    name_mapping={
        "x_shear": "xShear",
        "x_shear_var": "xShearVar",
        "y_shear": "yShear",
        "y_shear_var": "yShearVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationShear:
    def __init__(
        self,
        *,
        x_shear: typing.Optional[builtins.str] = None,
        x_shear_var: typing.Optional[builtins.str] = None,
        y_shear: typing.Optional[builtins.str] = None,
        y_shear_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param x_shear: The amount to shear along the x-axis, measured in multiples of the image's width. Must be set if yShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear DataAkamaiImagingPolicyImage#x_shear}
        :param x_shear_var: The amount to shear along the x-axis, measured in multiples of the image's width. Must be set if yShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear_var DataAkamaiImagingPolicyImage#x_shear_var}
        :param y_shear: The amount to shear along the y-axis, measured in multiples of the image's height. Must be set if xShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear DataAkamaiImagingPolicyImage#y_shear}
        :param y_shear_var: The amount to shear along the y-axis, measured in multiples of the image's height. Must be set if xShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear_var DataAkamaiImagingPolicyImage#y_shear_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8f233af17c77380809f46a72db33472df7941801178ed68550cfa67fbe6199f8)
            check_type(argname="argument x_shear", value=x_shear, expected_type=type_hints["x_shear"])
            check_type(argname="argument x_shear_var", value=x_shear_var, expected_type=type_hints["x_shear_var"])
            check_type(argname="argument y_shear", value=y_shear, expected_type=type_hints["y_shear"])
            check_type(argname="argument y_shear_var", value=y_shear_var, expected_type=type_hints["y_shear_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if x_shear is not None:
            self._values["x_shear"] = x_shear
        if x_shear_var is not None:
            self._values["x_shear_var"] = x_shear_var
        if y_shear is not None:
            self._values["y_shear"] = y_shear
        if y_shear_var is not None:
            self._values["y_shear_var"] = y_shear_var

    @builtins.property
    def x_shear(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the x-axis, measured in multiples of the image's width.

        Must be set if yShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear DataAkamaiImagingPolicyImage#x_shear}
        '''
        result = self._values.get("x_shear")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_shear_var(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the x-axis, measured in multiples of the image's width.

        Must be set if yShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear_var DataAkamaiImagingPolicyImage#x_shear_var}
        '''
        result = self._values.get("x_shear_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_shear(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the y-axis, measured in multiples of the image's height.

        Must be set if xShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear DataAkamaiImagingPolicyImage#y_shear}
        '''
        result = self._values.get("y_shear")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_shear_var(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the y-axis, measured in multiples of the image's height.

        Must be set if xShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear_var DataAkamaiImagingPolicyImage#y_shear_var}
        '''
        result = self._values.get("y_shear_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationShear(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationShearList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationShearList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1b43ce1b2c94fec674d396839d1c75b884e487688d661ed182c5988b7878ebb0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationShearOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__54b3b4a8d8ab8a54554f05acd3a786df5740b9aab27def784da864ff9d7230f9)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationShearOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__384b5da1a0941b44168725d8b8d6e8e407278b148491265431c2aa4d9143d255)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1cd8f7626948f86b2d0e62dda74530883e15b899127e478ee4b3c1b535c18d94)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a7d9771bbd011e7e11694229c4330a7cd765c8f29418aff1120bf6f77c15e4f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationShear]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationShear]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationShear]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__84c0c8f4f8af21896c1177332c824744b52922b7b31ec88514300fb8845a4a6c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationShearOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationShearOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2dae629f3c636c1f21e949835ef0842122f72a5b78b6ba0f9cc482dd2c45ec86)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetXShear")
    def reset_x_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXShear", []))

    @jsii.member(jsii_name="resetXShearVar")
    def reset_x_shear_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXShearVar", []))

    @jsii.member(jsii_name="resetYShear")
    def reset_y_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYShear", []))

    @jsii.member(jsii_name="resetYShearVar")
    def reset_y_shear_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYShearVar", []))

    @builtins.property
    @jsii.member(jsii_name="xShearInput")
    def x_shear_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xShearInput"))

    @builtins.property
    @jsii.member(jsii_name="xShearVarInput")
    def x_shear_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xShearVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yShearInput")
    def y_shear_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yShearInput"))

    @builtins.property
    @jsii.member(jsii_name="yShearVarInput")
    def y_shear_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yShearVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xShear")
    def x_shear(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xShear"))

    @x_shear.setter
    def x_shear(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__591d6500a6f243814943e65038a6153f8c505a4bbfea4e02de07ff137506b5c8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xShear", value)

    @builtins.property
    @jsii.member(jsii_name="xShearVar")
    def x_shear_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xShearVar"))

    @x_shear_var.setter
    def x_shear_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a8f9469c3164ad5ccf4bd022ffbb34cf2554ef4ff717d23fa875948deeb39e6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xShearVar", value)

    @builtins.property
    @jsii.member(jsii_name="yShear")
    def y_shear(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yShear"))

    @y_shear.setter
    def y_shear(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6b65fd814981a97eba04e2409338b5519b4773934ef0f997a2b30f93d33f3950)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yShear", value)

    @builtins.property
    @jsii.member(jsii_name="yShearVar")
    def y_shear_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yShearVar"))

    @y_shear_var.setter
    def y_shear_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__46f1c53b7e4c5915520cfe1bbedd35dc05f17e896de5a467f295859de7e12c37)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yShearVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationShear]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationShear]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationShear]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8868c3caefaa237f3d82e832da377a6907b8c38169150ff27578d3ddf7e8116c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationTrim",
    jsii_struct_bases=[],
    name_mapping={
        "fuzz": "fuzz",
        "fuzz_var": "fuzzVar",
        "padding": "padding",
        "padding_var": "paddingVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationTrim:
    def __init__(
        self,
        *,
        fuzz: typing.Optional[builtins.str] = None,
        fuzz_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fuzz: The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz DataAkamaiImagingPolicyImage#fuzz}
        :param fuzz_var: The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz_var DataAkamaiImagingPolicyImage#fuzz_var}
        :param padding: The amount of padding in pixels to add to the trimmed image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: The amount of padding in pixels to add to the trimmed image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a87779201e0aaecf11271a706bc44776e98294a13b72701a2e33ea5206d3d641)
            check_type(argname="argument fuzz", value=fuzz, expected_type=type_hints["fuzz"])
            check_type(argname="argument fuzz_var", value=fuzz_var, expected_type=type_hints["fuzz_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fuzz is not None:
            self._values["fuzz"] = fuzz
        if fuzz_var is not None:
            self._values["fuzz_var"] = fuzz_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var

    @builtins.property
    def fuzz(self) -> typing.Optional[builtins.str]:
        '''The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz DataAkamaiImagingPolicyImage#fuzz}
        '''
        result = self._values.get("fuzz")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fuzz_var(self) -> typing.Optional[builtins.str]:
        '''The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz_var DataAkamaiImagingPolicyImage#fuzz_var}
        '''
        result = self._values.get("fuzz_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''The amount of padding in pixels to add to the trimmed image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''The amount of padding in pixels to add to the trimmed image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationTrim(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationTrimList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationTrimList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1261baab9e853e2a67896246965a82df5d854412ca1deb866aa5760858039f70)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationTrimOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4eb9217a57c9420a6916bd08824f08c068e2369220ec6d6d0ed33c37d3d33fff)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationTrimOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c921194ce50195743aefcf041cc84ad0acbe30b471534e7d688a128b71694362)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__68ec4f5b8360dfe405210aff6b23ce0f86a881ba57f86f104a1397234705b0b0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7ea5bdda167b8a97970d992d455dba06e203634d257902c9ec6d4b2b0d8cbdb4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationTrim]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationTrim]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationTrim]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__28d8b838f2e355d9f1d034fe3e888ee2d9b6b24fe49c73dfca0ee8343b89de60)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationTrimOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationTrimOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d909e8da0e5e69287c6a645a2af57ce02407aefffe77879ea86c06af6e11ffed)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetFuzz")
    def reset_fuzz(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFuzz", []))

    @jsii.member(jsii_name="resetFuzzVar")
    def reset_fuzz_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFuzzVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @builtins.property
    @jsii.member(jsii_name="fuzzInput")
    def fuzz_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fuzzInput"))

    @builtins.property
    @jsii.member(jsii_name="fuzzVarInput")
    def fuzz_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fuzzVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="fuzz")
    def fuzz(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fuzz"))

    @fuzz.setter
    def fuzz(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cbfc51634c65be812adb3010086f5ef8e528fdb1aafc2b695388cea2735ba1ed)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fuzz", value)

    @builtins.property
    @jsii.member(jsii_name="fuzzVar")
    def fuzz_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fuzzVar"))

    @fuzz_var.setter
    def fuzz_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6fd2f06c32a58326ef66aee8115ae7637dcd77420bf65a3a4203989077537e9a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fuzzVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aafdc4c453b9d8327869ca57c08810e7c9d6e050cdb9fce22edd7561423ee3aa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1886630b67e9658d05b6f583af96dc0be8204498c55b0e5e68ea3e565b6dc47b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationTrim]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationTrim]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationTrim]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f0b538ce134221245f8ebd0680bea3fd979a343aad249d779c1893582ce72a08)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationUnsharpMask",
    jsii_struct_bases=[],
    name_mapping={
        "gain": "gain",
        "gain_var": "gainVar",
        "sigma": "sigma",
        "sigma_var": "sigmaVar",
        "threshold": "threshold",
        "threshold_var": "thresholdVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationUnsharpMask:
    def __init__(
        self,
        *,
        gain: typing.Optional[builtins.str] = None,
        gain_var: typing.Optional[builtins.str] = None,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
        threshold: typing.Optional[builtins.str] = None,
        threshold_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param gain: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        :param gain_var: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        :param sigma: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        :param threshold: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        :param threshold_var: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d18b55a21fe8f6f97d2a08c4a36d9c116099c0af9b4a4b3da94c179859ab1bff)
            check_type(argname="argument gain", value=gain, expected_type=type_hints["gain"])
            check_type(argname="argument gain_var", value=gain_var, expected_type=type_hints["gain_var"])
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
            check_type(argname="argument threshold", value=threshold, expected_type=type_hints["threshold"])
            check_type(argname="argument threshold_var", value=threshold_var, expected_type=type_hints["threshold_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if gain is not None:
            self._values["gain"] = gain
        if gain_var is not None:
            self._values["gain_var"] = gain_var
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var
        if threshold is not None:
            self._values["threshold"] = threshold
        if threshold_var is not None:
            self._values["threshold_var"] = threshold_var

    @builtins.property
    def gain(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        '''
        result = self._values.get("gain")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gain_var(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        '''
        result = self._values.get("gain_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        '''
        result = self._values.get("threshold")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold_var(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        result = self._values.get("threshold_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationUnsharpMask(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationUnsharpMaskList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationUnsharpMaskList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a4d7f9bd285a93531ba722e6c62d4e50e4cd84697d05126b2d371a53e57db5ce)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationUnsharpMaskOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__535ad640e071fad5b7feae943943c253879975751c8719d1af5c58ad99760592)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationUnsharpMaskOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__85dbfba01e9b3ab62681567836b7ebcfb88ef80850eef54241a9d491fc662c9d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bd89a4cb75807a21cf1507856f34ebe46ee98e96c9541d999fcb12590ada0705)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2f74ca0cc89c89c1b0122480dd491f68c2417f83da92e056a509f9ef39e6b23d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationUnsharpMask]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationUnsharpMask]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationUnsharpMask]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be7f45b573f62618c9aa9beb4b72d9325c7626fc46df9af7e4e245f25b8f0a85)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationUnsharpMaskOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationUnsharpMaskOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__daa875315df324e64023ed3b3cdc9df4c042a4e0c7842b26c705767ccaec1ed6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetGain")
    def reset_gain(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGain", []))

    @jsii.member(jsii_name="resetGainVar")
    def reset_gain_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGainVar", []))

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @jsii.member(jsii_name="resetThreshold")
    def reset_threshold(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThreshold", []))

    @jsii.member(jsii_name="resetThresholdVar")
    def reset_threshold_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThresholdVar", []))

    @builtins.property
    @jsii.member(jsii_name="gainInput")
    def gain_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainInput"))

    @builtins.property
    @jsii.member(jsii_name="gainVarInput")
    def gain_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdInput")
    def threshold_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdVarInput")
    def threshold_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gain")
    def gain(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gain"))

    @gain.setter
    def gain(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ee80a8b48d3fd129574d20c6080223941c1fce348a5706670cb44a63f5862eab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gain", value)

    @builtins.property
    @jsii.member(jsii_name="gainVar")
    def gain_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gainVar"))

    @gain_var.setter
    def gain_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__904ec9b54ca70742aa2259d8e7fdffee7fdbb37b4074c74da113013b82a7025a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gainVar", value)

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b06d1fc8e2e14f0d15dbb3aebe01da60a5b8ca2603270129d5bac7ee6eb602e6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d8235446b0d4556d3e96bd8efc9a38761efae38dff2d0fc62a177cb0100588f5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="threshold")
    def threshold(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "threshold"))

    @threshold.setter
    def threshold(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3f9276cb847927d904650f6675d1ffbff04abeb5b2c210bc858b6c3e427b4666)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "threshold", value)

    @builtins.property
    @jsii.member(jsii_name="thresholdVar")
    def threshold_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "thresholdVar"))

    @threshold_var.setter
    def threshold_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1a9b35384c1eae51581f8435dcc6b67e2553b870c0260713ca5f00f1d69092c4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "thresholdVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationUnsharpMask]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationUnsharpMask]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationUnsharpMask]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__91a537a483e0e7204e18bf6b167a4422a174eee1593cac67697028a5e1314c48)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__417136cccaec1e4ffdcf1ab5af35cdae6ea2357303510f587b7516e0cdb000ca)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putBoxImage")
    def put_box_image(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImage, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dc44a0922fb233b32f88113a2d01e1de64f8594e5b99a2545f1ab324769fcd44)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBoxImage", [value]))

    @jsii.member(jsii_name="putCircleImage")
    def put_circle_image(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImage, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac078b54969234695cd4aff7310f65ec458e20c608ef783431f6be80e6de6ef2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCircleImage", [value]))

    @jsii.member(jsii_name="putTextImage")
    def put_text_image(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImage", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b83b44713b10fd2ba0da771dce49739cfcf874c2f36d5a71574986d4595d8032)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTextImage", [value]))

    @jsii.member(jsii_name="putUrlImage")
    def put_url_image(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImage", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f811e1fc7a0f71702651070ffdb1d70729ec87154b7a9c072107aa21ffb1fee3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putUrlImage", [value]))

    @jsii.member(jsii_name="resetBoxImage")
    def reset_box_image(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBoxImage", []))

    @jsii.member(jsii_name="resetCircleImage")
    def reset_circle_image(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCircleImage", []))

    @jsii.member(jsii_name="resetTextImage")
    def reset_text_image(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTextImage", []))

    @jsii.member(jsii_name="resetUrlImage")
    def reset_url_image(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUrlImage", []))

    @builtins.property
    @jsii.member(jsii_name="boxImage")
    def box_image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageList, jsii.get(self, "boxImage"))

    @builtins.property
    @jsii.member(jsii_name="circleImage")
    def circle_image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageList, jsii.get(self, "circleImage"))

    @builtins.property
    @jsii.member(jsii_name="textImage")
    def text_image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageList", jsii.get(self, "textImage"))

    @builtins.property
    @jsii.member(jsii_name="urlImage")
    def url_image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageList", jsii.get(self, "urlImage"))

    @builtins.property
    @jsii.member(jsii_name="boxImageInput")
    def box_image_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImage]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImage]]], jsii.get(self, "boxImageInput"))

    @builtins.property
    @jsii.member(jsii_name="circleImageInput")
    def circle_image_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImage]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImage]]], jsii.get(self, "circleImageInput"))

    @builtins.property
    @jsii.member(jsii_name="textImageInput")
    def text_image_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImage"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImage"]]], jsii.get(self, "textImageInput"))

    @builtins.property
    @jsii.member(jsii_name="urlImageInput")
    def url_image_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImage"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImage"]]], jsii.get(self, "urlImageInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d90f6897671e63d8294b828fab6e3e611104619850674c28f703c470fb4c7c7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImage",
    jsii_struct_bases=[],
    name_mapping={
        "fill": "fill",
        "fill_var": "fillVar",
        "size": "size",
        "size_var": "sizeVar",
        "stroke": "stroke",
        "stroke_size": "strokeSize",
        "stroke_size_var": "strokeSizeVar",
        "stroke_var": "strokeVar",
        "text": "text",
        "text_var": "textVar",
        "transformation": "transformation",
        "typeface": "typeface",
        "typeface_var": "typefaceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImage:
    def __init__(
        self,
        *,
        fill: typing.Optional[builtins.str] = None,
        fill_var: typing.Optional[builtins.str] = None,
        size: typing.Optional[builtins.str] = None,
        size_var: typing.Optional[builtins.str] = None,
        stroke: typing.Optional[builtins.str] = None,
        stroke_size: typing.Optional[builtins.str] = None,
        stroke_size_var: typing.Optional[builtins.str] = None,
        stroke_var: typing.Optional[builtins.str] = None,
        text: typing.Optional[builtins.str] = None,
        text_var: typing.Optional[builtins.str] = None,
        transformation: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        typeface: typing.Optional[builtins.str] = None,
        typeface_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fill: The main fill color of the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill DataAkamaiImagingPolicyImage#fill}
        :param fill_var: The main fill color of the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_var DataAkamaiImagingPolicyImage#fill_var}
        :param size: The size in pixels to render the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#size DataAkamaiImagingPolicyImage#size}
        :param size_var: The size in pixels to render the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#size_var DataAkamaiImagingPolicyImage#size_var}
        :param stroke: The color for the outline of the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke DataAkamaiImagingPolicyImage#stroke}
        :param stroke_size: The thickness in points for the outline of the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_size DataAkamaiImagingPolicyImage#stroke_size}
        :param stroke_size_var: The thickness in points for the outline of the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_size_var DataAkamaiImagingPolicyImage#stroke_size_var}
        :param stroke_var: The color for the outline of the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_var DataAkamaiImagingPolicyImage#stroke_var}
        :param text: The line of text to render. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text DataAkamaiImagingPolicyImage#text}
        :param text_var: The line of text to render. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text_var DataAkamaiImagingPolicyImage#text_var}
        :param transformation: transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        :param typeface: The font family to apply to the text image. This may be a URL to a TrueType or WOFF (v1) typeface, or a string that refers to one of the standard built-in browser fonts. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#typeface DataAkamaiImagingPolicyImage#typeface}
        :param typeface_var: The font family to apply to the text image. This may be a URL to a TrueType or WOFF (v1) typeface, or a string that refers to one of the standard built-in browser fonts. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#typeface_var DataAkamaiImagingPolicyImage#typeface_var}
        '''
        if isinstance(transformation, dict):
            transformation = DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformation(**transformation)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be04ed75847a005538cfb2455785cb52e0687ae684c9423931e73b9f9e5dd806)
            check_type(argname="argument fill", value=fill, expected_type=type_hints["fill"])
            check_type(argname="argument fill_var", value=fill_var, expected_type=type_hints["fill_var"])
            check_type(argname="argument size", value=size, expected_type=type_hints["size"])
            check_type(argname="argument size_var", value=size_var, expected_type=type_hints["size_var"])
            check_type(argname="argument stroke", value=stroke, expected_type=type_hints["stroke"])
            check_type(argname="argument stroke_size", value=stroke_size, expected_type=type_hints["stroke_size"])
            check_type(argname="argument stroke_size_var", value=stroke_size_var, expected_type=type_hints["stroke_size_var"])
            check_type(argname="argument stroke_var", value=stroke_var, expected_type=type_hints["stroke_var"])
            check_type(argname="argument text", value=text, expected_type=type_hints["text"])
            check_type(argname="argument text_var", value=text_var, expected_type=type_hints["text_var"])
            check_type(argname="argument transformation", value=transformation, expected_type=type_hints["transformation"])
            check_type(argname="argument typeface", value=typeface, expected_type=type_hints["typeface"])
            check_type(argname="argument typeface_var", value=typeface_var, expected_type=type_hints["typeface_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fill is not None:
            self._values["fill"] = fill
        if fill_var is not None:
            self._values["fill_var"] = fill_var
        if size is not None:
            self._values["size"] = size
        if size_var is not None:
            self._values["size_var"] = size_var
        if stroke is not None:
            self._values["stroke"] = stroke
        if stroke_size is not None:
            self._values["stroke_size"] = stroke_size
        if stroke_size_var is not None:
            self._values["stroke_size_var"] = stroke_size_var
        if stroke_var is not None:
            self._values["stroke_var"] = stroke_var
        if text is not None:
            self._values["text"] = text
        if text_var is not None:
            self._values["text_var"] = text_var
        if transformation is not None:
            self._values["transformation"] = transformation
        if typeface is not None:
            self._values["typeface"] = typeface
        if typeface_var is not None:
            self._values["typeface_var"] = typeface_var

    @builtins.property
    def fill(self) -> typing.Optional[builtins.str]:
        '''The main fill color of the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill DataAkamaiImagingPolicyImage#fill}
        '''
        result = self._values.get("fill")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fill_var(self) -> typing.Optional[builtins.str]:
        '''The main fill color of the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_var DataAkamaiImagingPolicyImage#fill_var}
        '''
        result = self._values.get("fill_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def size(self) -> typing.Optional[builtins.str]:
        '''The size in pixels to render the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#size DataAkamaiImagingPolicyImage#size}
        '''
        result = self._values.get("size")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def size_var(self) -> typing.Optional[builtins.str]:
        '''The size in pixels to render the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#size_var DataAkamaiImagingPolicyImage#size_var}
        '''
        result = self._values.get("size_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def stroke(self) -> typing.Optional[builtins.str]:
        '''The color for the outline of the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke DataAkamaiImagingPolicyImage#stroke}
        '''
        result = self._values.get("stroke")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def stroke_size(self) -> typing.Optional[builtins.str]:
        '''The thickness in points for the outline of the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_size DataAkamaiImagingPolicyImage#stroke_size}
        '''
        result = self._values.get("stroke_size")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def stroke_size_var(self) -> typing.Optional[builtins.str]:
        '''The thickness in points for the outline of the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_size_var DataAkamaiImagingPolicyImage#stroke_size_var}
        '''
        result = self._values.get("stroke_size_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def stroke_var(self) -> typing.Optional[builtins.str]:
        '''The color for the outline of the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_var DataAkamaiImagingPolicyImage#stroke_var}
        '''
        result = self._values.get("stroke_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def text(self) -> typing.Optional[builtins.str]:
        '''The line of text to render.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text DataAkamaiImagingPolicyImage#text}
        '''
        result = self._values.get("text")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def text_var(self) -> typing.Optional[builtins.str]:
        '''The line of text to render.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text_var DataAkamaiImagingPolicyImage#text_var}
        '''
        result = self._values.get("text_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def transformation(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformation"]:
        '''transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        '''
        result = self._values.get("transformation")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformation"], result)

    @builtins.property
    def typeface(self) -> typing.Optional[builtins.str]:
        '''The font family to apply to the text image.

        This may be a URL to a TrueType or WOFF (v1) typeface, or a string that refers to one of the standard built-in browser fonts.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#typeface DataAkamaiImagingPolicyImage#typeface}
        '''
        result = self._values.get("typeface")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def typeface_var(self) -> typing.Optional[builtins.str]:
        '''The font family to apply to the text image.

        This may be a URL to a TrueType or WOFF (v1) typeface, or a string that refers to one of the standard built-in browser fonts.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#typeface_var DataAkamaiImagingPolicyImage#typeface_var}
        '''
        result = self._values.get("typeface_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0187c207de92d6fe0db85ee73760ecc557e1dce6fb3f238c49b9b1482441c0de)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fb8369766e5c88f5fc72de617cf6e9e80b020d8712ceb1356e9110e8f3a4eb08)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1ce1c0ed5110629c64b61426450608bf920ab6e5a0ffc3ac594c2d1ace672924)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__17c1c208b956ff16fd44d77534cf903827766de057a4928d616c33784f1472fd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__68deec2c4d2fb0f0d0c5a78e43120413ca7da1703bde20db1b067ffc8e74e2b5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImage]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImage]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImage]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__78dd074676283bcb96b0af7c7227a086ff1f733b34bc0ee8649d77520b0901fe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9c3a6088c519650871dc625adbc5ca0352220cd78bcfb762222b0af6560b0d6c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformation")
    def put_transformation(
        self,
        *,
        append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationAppend", typing.Dict[builtins.str, typing.Any]]]]] = None,
        aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationAspectCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationBackgroundColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationBlur", typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationChromaKey", typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationComposite", typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationCompound", typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationContrast", typing.Dict[builtins.str, typing.Any]]]]] = None,
        crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationFaceCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationFeatureCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationFitAndFill", typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationGoop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationGrayscale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationHsl", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationHsv", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfDimension", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfOrientation", typing.Dict[builtins.str, typing.Any]]]]] = None,
        im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationImQuery", typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationMaxColors", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationMirror", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationMonoHue", typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationOpacity", typing.Dict[builtins.str, typing.Any]]]]] = None,
        region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationRegionOfInterestCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationRelativeCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationRemoveColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationResize", typing.Dict[builtins.str, typing.Any]]]]] = None,
        rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationRotate", typing.Dict[builtins.str, typing.Any]]]]] = None,
        scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationScale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationShear", typing.Dict[builtins.str, typing.Any]]]]] = None,
        trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationTrim", typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationUnsharpMask", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param append: append block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        :param aspect_crop: aspect_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param crop: crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        :param face_crop: face_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        :param feature_crop: feature_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        :param fit_and_fill: fit_and_fill block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param im_query: im_query block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param region_of_interest_crop: region_of_interest_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        :param relative_crop: relative_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param resize: resize block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        :param rotate: rotate block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        :param scale: scale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param shear: shear block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        :param trim: trim block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        value = DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformation(
            append=append,
            aspect_crop=aspect_crop,
            background_color=background_color,
            blur=blur,
            chroma_key=chroma_key,
            composite=composite,
            compound=compound,
            contrast=contrast,
            crop=crop,
            face_crop=face_crop,
            feature_crop=feature_crop,
            fit_and_fill=fit_and_fill,
            goop=goop,
            grayscale=grayscale,
            hsl=hsl,
            hsv=hsv,
            if_dimension=if_dimension,
            if_orientation=if_orientation,
            im_query=im_query,
            max_colors=max_colors,
            mirror=mirror,
            mono_hue=mono_hue,
            opacity=opacity,
            region_of_interest_crop=region_of_interest_crop,
            relative_crop=relative_crop,
            remove_color=remove_color,
            resize=resize,
            rotate=rotate,
            scale=scale,
            shear=shear,
            trim=trim,
            unsharp_mask=unsharp_mask,
        )

        return typing.cast(None, jsii.invoke(self, "putTransformation", [value]))

    @jsii.member(jsii_name="resetFill")
    def reset_fill(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFill", []))

    @jsii.member(jsii_name="resetFillVar")
    def reset_fill_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFillVar", []))

    @jsii.member(jsii_name="resetSize")
    def reset_size(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSize", []))

    @jsii.member(jsii_name="resetSizeVar")
    def reset_size_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSizeVar", []))

    @jsii.member(jsii_name="resetStroke")
    def reset_stroke(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStroke", []))

    @jsii.member(jsii_name="resetStrokeSize")
    def reset_stroke_size(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStrokeSize", []))

    @jsii.member(jsii_name="resetStrokeSizeVar")
    def reset_stroke_size_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStrokeSizeVar", []))

    @jsii.member(jsii_name="resetStrokeVar")
    def reset_stroke_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStrokeVar", []))

    @jsii.member(jsii_name="resetText")
    def reset_text(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetText", []))

    @jsii.member(jsii_name="resetTextVar")
    def reset_text_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTextVar", []))

    @jsii.member(jsii_name="resetTransformation")
    def reset_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformation", []))

    @jsii.member(jsii_name="resetTypeface")
    def reset_typeface(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeface", []))

    @jsii.member(jsii_name="resetTypefaceVar")
    def reset_typeface_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypefaceVar", []))

    @builtins.property
    @jsii.member(jsii_name="transformation")
    def transformation(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationOutputReference", jsii.get(self, "transformation"))

    @builtins.property
    @jsii.member(jsii_name="fillInput")
    def fill_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fillInput"))

    @builtins.property
    @jsii.member(jsii_name="fillVarInput")
    def fill_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fillVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sizeInput")
    def size_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sizeInput"))

    @builtins.property
    @jsii.member(jsii_name="sizeVarInput")
    def size_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sizeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="strokeInput")
    def stroke_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "strokeInput"))

    @builtins.property
    @jsii.member(jsii_name="strokeSizeInput")
    def stroke_size_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "strokeSizeInput"))

    @builtins.property
    @jsii.member(jsii_name="strokeSizeVarInput")
    def stroke_size_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "strokeSizeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="strokeVarInput")
    def stroke_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "strokeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="textInput")
    def text_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "textInput"))

    @builtins.property
    @jsii.member(jsii_name="textVarInput")
    def text_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "textVarInput"))

    @builtins.property
    @jsii.member(jsii_name="transformationInput")
    def transformation_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformation"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformation"], jsii.get(self, "transformationInput"))

    @builtins.property
    @jsii.member(jsii_name="typefaceInput")
    def typeface_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typefaceInput"))

    @builtins.property
    @jsii.member(jsii_name="typefaceVarInput")
    def typeface_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typefaceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="fill")
    def fill(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fill"))

    @fill.setter
    def fill(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b1384b8f2a708b6d2d95dee20bcf04a8991b26802439dcf65aad7d138296da11)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fill", value)

    @builtins.property
    @jsii.member(jsii_name="fillVar")
    def fill_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fillVar"))

    @fill_var.setter
    def fill_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__43d9a3c9c8ce83d5b119910290f754698c9adfd0d33aac8900780e12d4d446fc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fillVar", value)

    @builtins.property
    @jsii.member(jsii_name="size")
    def size(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "size"))

    @size.setter
    def size(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b1554b933e34767bb580c89d30fd5d080903a5353a9ce414267d010584ce8e14)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "size", value)

    @builtins.property
    @jsii.member(jsii_name="sizeVar")
    def size_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sizeVar"))

    @size_var.setter
    def size_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4b58f258885ee088c6057f56e917bb1c5714cc0848dc6016832e21ccf5cb1d0c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sizeVar", value)

    @builtins.property
    @jsii.member(jsii_name="stroke")
    def stroke(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "stroke"))

    @stroke.setter
    def stroke(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0a926f3f5a44eb857cb86b7f1acae0ca83baddaec08bfd4bab675d43bae027fe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "stroke", value)

    @builtins.property
    @jsii.member(jsii_name="strokeSize")
    def stroke_size(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "strokeSize"))

    @stroke_size.setter
    def stroke_size(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__991562fc40e49171f58a12006b9912ced76a2dcd683f3b2a63ecb7bf7c23e4c1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "strokeSize", value)

    @builtins.property
    @jsii.member(jsii_name="strokeSizeVar")
    def stroke_size_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "strokeSizeVar"))

    @stroke_size_var.setter
    def stroke_size_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__92375f171024bb9491eae0dd1fac8228b1d53b6cd6266be8cab16e7472939e18)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "strokeSizeVar", value)

    @builtins.property
    @jsii.member(jsii_name="strokeVar")
    def stroke_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "strokeVar"))

    @stroke_var.setter
    def stroke_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__32f8b27081307d6aaa46fb4f49c150c5292355f9e124171f11896784ed0e9eab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "strokeVar", value)

    @builtins.property
    @jsii.member(jsii_name="text")
    def text(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "text"))

    @text.setter
    def text(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a5a6ebcf6718f939a1de55206ccb9161d7a787ac27339976e27267c66a3ca58d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "text", value)

    @builtins.property
    @jsii.member(jsii_name="textVar")
    def text_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "textVar"))

    @text_var.setter
    def text_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa1b8477e5c633521fb77e56ae55889f95a9edf454e59e1517c5e0bd84674d0f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "textVar", value)

    @builtins.property
    @jsii.member(jsii_name="typeface")
    def typeface(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeface"))

    @typeface.setter
    def typeface(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__063c04cc6a4177d78dcf82502e2fcd82fed2eecc04cc94d7fe3be82c30faafc6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeface", value)

    @builtins.property
    @jsii.member(jsii_name="typefaceVar")
    def typeface_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typefaceVar"))

    @typeface_var.setter
    def typeface_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__47a3efe47733e8db6cb3435ff8f22bdd7a79cb6edb23fd0000cee59a0f78d2ae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typefaceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImage]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImage]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImage]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d0193d14b4155b072e8a2fd92da43cf4c48d4a1ca7da46be0f4843d506792297)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformation",
    jsii_struct_bases=[],
    name_mapping={
        "append": "append",
        "aspect_crop": "aspectCrop",
        "background_color": "backgroundColor",
        "blur": "blur",
        "chroma_key": "chromaKey",
        "composite": "composite",
        "compound": "compound",
        "contrast": "contrast",
        "crop": "crop",
        "face_crop": "faceCrop",
        "feature_crop": "featureCrop",
        "fit_and_fill": "fitAndFill",
        "goop": "goop",
        "grayscale": "grayscale",
        "hsl": "hsl",
        "hsv": "hsv",
        "if_dimension": "ifDimension",
        "if_orientation": "ifOrientation",
        "im_query": "imQuery",
        "max_colors": "maxColors",
        "mirror": "mirror",
        "mono_hue": "monoHue",
        "opacity": "opacity",
        "region_of_interest_crop": "regionOfInterestCrop",
        "relative_crop": "relativeCrop",
        "remove_color": "removeColor",
        "resize": "resize",
        "rotate": "rotate",
        "scale": "scale",
        "shear": "shear",
        "trim": "trim",
        "unsharp_mask": "unsharpMask",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformation:
    def __init__(
        self,
        *,
        append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationAppend", typing.Dict[builtins.str, typing.Any]]]]] = None,
        aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationAspectCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationBackgroundColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationBlur", typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationChromaKey", typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationComposite", typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationCompound", typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationContrast", typing.Dict[builtins.str, typing.Any]]]]] = None,
        crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationFaceCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationFeatureCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationFitAndFill", typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationGoop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationGrayscale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationHsl", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationHsv", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfDimension", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfOrientation", typing.Dict[builtins.str, typing.Any]]]]] = None,
        im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationImQuery", typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationMaxColors", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationMirror", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationMonoHue", typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationOpacity", typing.Dict[builtins.str, typing.Any]]]]] = None,
        region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationRegionOfInterestCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationRelativeCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationRemoveColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationResize", typing.Dict[builtins.str, typing.Any]]]]] = None,
        rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationRotate", typing.Dict[builtins.str, typing.Any]]]]] = None,
        scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationScale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationShear", typing.Dict[builtins.str, typing.Any]]]]] = None,
        trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationTrim", typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationUnsharpMask", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param append: append block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        :param aspect_crop: aspect_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param crop: crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        :param face_crop: face_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        :param feature_crop: feature_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        :param fit_and_fill: fit_and_fill block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param im_query: im_query block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param region_of_interest_crop: region_of_interest_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        :param relative_crop: relative_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param resize: resize block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        :param rotate: rotate block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        :param scale: scale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param shear: shear block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        :param trim: trim block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af961fe8d9c3ed0d239c9012ff885f341f2bb9c3fc5e9605c1407e0a72746c23)
            check_type(argname="argument append", value=append, expected_type=type_hints["append"])
            check_type(argname="argument aspect_crop", value=aspect_crop, expected_type=type_hints["aspect_crop"])
            check_type(argname="argument background_color", value=background_color, expected_type=type_hints["background_color"])
            check_type(argname="argument blur", value=blur, expected_type=type_hints["blur"])
            check_type(argname="argument chroma_key", value=chroma_key, expected_type=type_hints["chroma_key"])
            check_type(argname="argument composite", value=composite, expected_type=type_hints["composite"])
            check_type(argname="argument compound", value=compound, expected_type=type_hints["compound"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument crop", value=crop, expected_type=type_hints["crop"])
            check_type(argname="argument face_crop", value=face_crop, expected_type=type_hints["face_crop"])
            check_type(argname="argument feature_crop", value=feature_crop, expected_type=type_hints["feature_crop"])
            check_type(argname="argument fit_and_fill", value=fit_and_fill, expected_type=type_hints["fit_and_fill"])
            check_type(argname="argument goop", value=goop, expected_type=type_hints["goop"])
            check_type(argname="argument grayscale", value=grayscale, expected_type=type_hints["grayscale"])
            check_type(argname="argument hsl", value=hsl, expected_type=type_hints["hsl"])
            check_type(argname="argument hsv", value=hsv, expected_type=type_hints["hsv"])
            check_type(argname="argument if_dimension", value=if_dimension, expected_type=type_hints["if_dimension"])
            check_type(argname="argument if_orientation", value=if_orientation, expected_type=type_hints["if_orientation"])
            check_type(argname="argument im_query", value=im_query, expected_type=type_hints["im_query"])
            check_type(argname="argument max_colors", value=max_colors, expected_type=type_hints["max_colors"])
            check_type(argname="argument mirror", value=mirror, expected_type=type_hints["mirror"])
            check_type(argname="argument mono_hue", value=mono_hue, expected_type=type_hints["mono_hue"])
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument region_of_interest_crop", value=region_of_interest_crop, expected_type=type_hints["region_of_interest_crop"])
            check_type(argname="argument relative_crop", value=relative_crop, expected_type=type_hints["relative_crop"])
            check_type(argname="argument remove_color", value=remove_color, expected_type=type_hints["remove_color"])
            check_type(argname="argument resize", value=resize, expected_type=type_hints["resize"])
            check_type(argname="argument rotate", value=rotate, expected_type=type_hints["rotate"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument shear", value=shear, expected_type=type_hints["shear"])
            check_type(argname="argument trim", value=trim, expected_type=type_hints["trim"])
            check_type(argname="argument unsharp_mask", value=unsharp_mask, expected_type=type_hints["unsharp_mask"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if append is not None:
            self._values["append"] = append
        if aspect_crop is not None:
            self._values["aspect_crop"] = aspect_crop
        if background_color is not None:
            self._values["background_color"] = background_color
        if blur is not None:
            self._values["blur"] = blur
        if chroma_key is not None:
            self._values["chroma_key"] = chroma_key
        if composite is not None:
            self._values["composite"] = composite
        if compound is not None:
            self._values["compound"] = compound
        if contrast is not None:
            self._values["contrast"] = contrast
        if crop is not None:
            self._values["crop"] = crop
        if face_crop is not None:
            self._values["face_crop"] = face_crop
        if feature_crop is not None:
            self._values["feature_crop"] = feature_crop
        if fit_and_fill is not None:
            self._values["fit_and_fill"] = fit_and_fill
        if goop is not None:
            self._values["goop"] = goop
        if grayscale is not None:
            self._values["grayscale"] = grayscale
        if hsl is not None:
            self._values["hsl"] = hsl
        if hsv is not None:
            self._values["hsv"] = hsv
        if if_dimension is not None:
            self._values["if_dimension"] = if_dimension
        if if_orientation is not None:
            self._values["if_orientation"] = if_orientation
        if im_query is not None:
            self._values["im_query"] = im_query
        if max_colors is not None:
            self._values["max_colors"] = max_colors
        if mirror is not None:
            self._values["mirror"] = mirror
        if mono_hue is not None:
            self._values["mono_hue"] = mono_hue
        if opacity is not None:
            self._values["opacity"] = opacity
        if region_of_interest_crop is not None:
            self._values["region_of_interest_crop"] = region_of_interest_crop
        if relative_crop is not None:
            self._values["relative_crop"] = relative_crop
        if remove_color is not None:
            self._values["remove_color"] = remove_color
        if resize is not None:
            self._values["resize"] = resize
        if rotate is not None:
            self._values["rotate"] = rotate
        if scale is not None:
            self._values["scale"] = scale
        if shear is not None:
            self._values["shear"] = shear
        if trim is not None:
            self._values["trim"] = trim
        if unsharp_mask is not None:
            self._values["unsharp_mask"] = unsharp_mask

    @builtins.property
    def append(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationAppend"]]]:
        '''append block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        '''
        result = self._values.get("append")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationAppend"]]], result)

    @builtins.property
    def aspect_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationAspectCrop"]]]:
        '''aspect_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        '''
        result = self._values.get("aspect_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationAspectCrop"]]], result)

    @builtins.property
    def background_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationBackgroundColor"]]]:
        '''background_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        '''
        result = self._values.get("background_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationBackgroundColor"]]], result)

    @builtins.property
    def blur(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationBlur"]]]:
        '''blur block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        '''
        result = self._values.get("blur")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationBlur"]]], result)

    @builtins.property
    def chroma_key(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationChromaKey"]]]:
        '''chroma_key block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        '''
        result = self._values.get("chroma_key")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationChromaKey"]]], result)

    @builtins.property
    def composite(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationComposite"]]]:
        '''composite block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        '''
        result = self._values.get("composite")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationComposite"]]], result)

    @builtins.property
    def compound(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationCompound"]]]:
        '''compound block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        '''
        result = self._values.get("compound")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationCompound"]]], result)

    @builtins.property
    def contrast(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationContrast"]]]:
        '''contrast block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationContrast"]]], result)

    @builtins.property
    def crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationCrop"]]]:
        '''crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        '''
        result = self._values.get("crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationCrop"]]], result)

    @builtins.property
    def face_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationFaceCrop"]]]:
        '''face_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        '''
        result = self._values.get("face_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationFaceCrop"]]], result)

    @builtins.property
    def feature_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationFeatureCrop"]]]:
        '''feature_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        '''
        result = self._values.get("feature_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationFeatureCrop"]]], result)

    @builtins.property
    def fit_and_fill(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationFitAndFill"]]]:
        '''fit_and_fill block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        '''
        result = self._values.get("fit_and_fill")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationFitAndFill"]]], result)

    @builtins.property
    def goop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationGoop"]]]:
        '''goop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        '''
        result = self._values.get("goop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationGoop"]]], result)

    @builtins.property
    def grayscale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationGrayscale"]]]:
        '''grayscale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        '''
        result = self._values.get("grayscale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationGrayscale"]]], result)

    @builtins.property
    def hsl(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationHsl"]]]:
        '''hsl block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        '''
        result = self._values.get("hsl")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationHsl"]]], result)

    @builtins.property
    def hsv(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationHsv"]]]:
        '''hsv block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        '''
        result = self._values.get("hsv")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationHsv"]]], result)

    @builtins.property
    def if_dimension(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfDimension"]]]:
        '''if_dimension block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        '''
        result = self._values.get("if_dimension")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfDimension"]]], result)

    @builtins.property
    def if_orientation(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfOrientation"]]]:
        '''if_orientation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        '''
        result = self._values.get("if_orientation")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfOrientation"]]], result)

    @builtins.property
    def im_query(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationImQuery"]]]:
        '''im_query block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        '''
        result = self._values.get("im_query")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationImQuery"]]], result)

    @builtins.property
    def max_colors(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationMaxColors"]]]:
        '''max_colors block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        '''
        result = self._values.get("max_colors")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationMaxColors"]]], result)

    @builtins.property
    def mirror(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationMirror"]]]:
        '''mirror block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        '''
        result = self._values.get("mirror")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationMirror"]]], result)

    @builtins.property
    def mono_hue(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationMonoHue"]]]:
        '''mono_hue block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        '''
        result = self._values.get("mono_hue")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationMonoHue"]]], result)

    @builtins.property
    def opacity(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationOpacity"]]]:
        '''opacity block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationOpacity"]]], result)

    @builtins.property
    def region_of_interest_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationRegionOfInterestCrop"]]]:
        '''region_of_interest_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        '''
        result = self._values.get("region_of_interest_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationRegionOfInterestCrop"]]], result)

    @builtins.property
    def relative_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationRelativeCrop"]]]:
        '''relative_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        '''
        result = self._values.get("relative_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationRelativeCrop"]]], result)

    @builtins.property
    def remove_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationRemoveColor"]]]:
        '''remove_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        '''
        result = self._values.get("remove_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationRemoveColor"]]], result)

    @builtins.property
    def resize(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationResize"]]]:
        '''resize block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        '''
        result = self._values.get("resize")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationResize"]]], result)

    @builtins.property
    def rotate(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationRotate"]]]:
        '''rotate block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        '''
        result = self._values.get("rotate")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationRotate"]]], result)

    @builtins.property
    def scale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationScale"]]]:
        '''scale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationScale"]]], result)

    @builtins.property
    def shear(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationShear"]]]:
        '''shear block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        '''
        result = self._values.get("shear")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationShear"]]], result)

    @builtins.property
    def trim(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationTrim"]]]:
        '''trim block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        '''
        result = self._values.get("trim")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationTrim"]]], result)

    @builtins.property
    def unsharp_mask(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationUnsharpMask"]]]:
        '''unsharp_mask block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        result = self._values.get("unsharp_mask")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationUnsharpMask"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationAppend",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_priority": "gravityPriority",
        "gravity_priority_var": "gravityPriorityVar",
        "gravity_var": "gravityVar",
        "preserve_minor_dimension": "preserveMinorDimension",
        "preserve_minor_dimension_var": "preserveMinorDimensionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationAppend:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationAppendImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_priority: typing.Optional[builtins.str] = None,
        gravity_priority_var: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        preserve_minor_dimension: typing.Optional[builtins.str] = None,
        preserve_minor_dimension_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Specifies where to place the ``image`` relative to the source image. The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_priority: Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal. The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority DataAkamaiImagingPolicyImage#gravity_priority}
        :param gravity_priority_var: Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal. The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority_var DataAkamaiImagingPolicyImage#gravity_priority_var}
        :param gravity_var: Specifies where to place the ``image`` relative to the source image. The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param preserve_minor_dimension: Whether to preserve the source image's minor dimension, ``false`` by default. The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension DataAkamaiImagingPolicyImage#preserve_minor_dimension}
        :param preserve_minor_dimension_var: Whether to preserve the source image's minor dimension, ``false`` by default. The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension_var DataAkamaiImagingPolicyImage#preserve_minor_dimension_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationAppendImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a0d0847848d274f280c2cc45c642879d3cc737c8a9eed5770c0ba5671d206747)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_priority", value=gravity_priority, expected_type=type_hints["gravity_priority"])
            check_type(argname="argument gravity_priority_var", value=gravity_priority_var, expected_type=type_hints["gravity_priority_var"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument preserve_minor_dimension", value=preserve_minor_dimension, expected_type=type_hints["preserve_minor_dimension"])
            check_type(argname="argument preserve_minor_dimension_var", value=preserve_minor_dimension_var, expected_type=type_hints["preserve_minor_dimension_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_priority is not None:
            self._values["gravity_priority"] = gravity_priority
        if gravity_priority_var is not None:
            self._values["gravity_priority_var"] = gravity_priority_var
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if preserve_minor_dimension is not None:
            self._values["preserve_minor_dimension"] = preserve_minor_dimension
        if preserve_minor_dimension_var is not None:
            self._values["preserve_minor_dimension_var"] = preserve_minor_dimension_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationAppendImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationAppendImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Specifies where to place the ``image`` relative to the source image.

        The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_priority(self) -> typing.Optional[builtins.str]:
        '''Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal.

        The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority DataAkamaiImagingPolicyImage#gravity_priority}
        '''
        result = self._values.get("gravity_priority")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_priority_var(self) -> typing.Optional[builtins.str]:
        '''Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal.

        The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority_var DataAkamaiImagingPolicyImage#gravity_priority_var}
        '''
        result = self._values.get("gravity_priority_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Specifies where to place the ``image`` relative to the source image.

        The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def preserve_minor_dimension(self) -> typing.Optional[builtins.str]:
        '''Whether to preserve the source image's minor dimension, ``false`` by default.

        The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension DataAkamaiImagingPolicyImage#preserve_minor_dimension}
        '''
        result = self._values.get("preserve_minor_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def preserve_minor_dimension_var(self) -> typing.Optional[builtins.str]:
        '''Whether to preserve the source image's minor dimension, ``false`` by default.

        The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension_var DataAkamaiImagingPolicyImage#preserve_minor_dimension_var}
        '''
        result = self._values.get("preserve_minor_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationAppend(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationAppendImage",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationAppendImage:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationAppendImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationAppendImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationAppendImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5e3fa51de49729fea8b9fa10437bfa485afbdc99409e5d8c5523a150f5e2c1ba)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationAppendImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationAppendImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationAppendImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b6f73432f7c0a375f67cc35e53e324a015924c43fde3ce6963fdce3a6fec7ade)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationAppendList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationAppendList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__05e02bee7bf73e7acac453fc9f27db34822597f531b0128536c57c8e8ebc70b1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationAppendOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__926ea3687ce4327e130b42704c23d1e58cbeeba5a03ccc21c06eca3d00f5890b)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationAppendOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4de8c409f32d4d1b8be6c76ed25a1301bcb0e183310be42571a357b8716f6561)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1374175e27a5ddd06de4af24a5d573d76b8d34d4ffa0c81b72d283ad123eba0e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6d48a7dc329306bb02f9296b5ff554e769ba249fcc69d41e503a50f55b9aa7eb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationAppend]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationAppend]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationAppend]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c64b1f55e529172ce7866252b5d6ca4b677e9a420b1e1ed5141bc30128510594)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationAppendOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationAppendOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f96c0f61073d3d57ea4a4c7b2ebd66f8f220c9e16393aafce96034ed63136acf)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationAppendImage()

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityPriority")
    def reset_gravity_priority(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityPriority", []))

    @jsii.member(jsii_name="resetGravityPriorityVar")
    def reset_gravity_priority_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityPriorityVar", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPreserveMinorDimension")
    def reset_preserve_minor_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPreserveMinorDimension", []))

    @jsii.member(jsii_name="resetPreserveMinorDimensionVar")
    def reset_preserve_minor_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPreserveMinorDimensionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationAppendImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationAppendImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityInput")
    def gravity_priority_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityPriorityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityVarInput")
    def gravity_priority_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityPriorityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationAppendImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationAppendImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionInput")
    def preserve_minor_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "preserveMinorDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionVarInput")
    def preserve_minor_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "preserveMinorDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f7888066ea66f608d5ef8e7bd645d1c25fe132ab02204fed7710e501da356b91)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityPriority")
    def gravity_priority(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityPriority"))

    @gravity_priority.setter
    def gravity_priority(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab09433e2b6f66bcab5012a7070865aeccc0a28c30d2c99739ad4dc3d690a88a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityPriority", value)

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityVar")
    def gravity_priority_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityPriorityVar"))

    @gravity_priority_var.setter
    def gravity_priority_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__916d3467ce0007c1b8a06dc3285afcfea9077eddf4254546cedca45921f2f3f7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityPriorityVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a452635e27db21c440184ec6156d251a01fe9191deb282e75174f749c433fe0d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimension")
    def preserve_minor_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "preserveMinorDimension"))

    @preserve_minor_dimension.setter
    def preserve_minor_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c79ec849de3d8b3cf4a6b44802c42a572c00dc4f7c24e3cbc289412173effe1c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "preserveMinorDimension", value)

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionVar")
    def preserve_minor_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "preserveMinorDimensionVar"))

    @preserve_minor_dimension_var.setter
    def preserve_minor_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__19a34e258476ca6d5afecb6df47c2ad6621fb0e2d54c0a8dca0e8ac2af0a10ea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "preserveMinorDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationAppend]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationAppend]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationAppend]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8588fae6ae720e26dc787e242c549bd950a33f549ae304e2bd1266ce5f4d109f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationAspectCrop",
    jsii_struct_bases=[],
    name_mapping={
        "allow_expansion": "allowExpansion",
        "allow_expansion_var": "allowExpansionVar",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationAspectCrop:
    def __init__(
        self,
        *,
        allow_expansion: typing.Optional[builtins.str] = None,
        allow_expansion_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_expansion: Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image. Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        :param allow_expansion_var: Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image. Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        :param height: The height term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The width term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        :param x_position: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0e262776c5e4e72ed246121bfac713676961f73c05c60a8441479cb8c932f9f8)
            check_type(argname="argument allow_expansion", value=allow_expansion, expected_type=type_hints["allow_expansion"])
            check_type(argname="argument allow_expansion_var", value=allow_expansion_var, expected_type=type_hints["allow_expansion_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if allow_expansion is not None:
            self._values["allow_expansion"] = allow_expansion
        if allow_expansion_var is not None:
            self._values["allow_expansion_var"] = allow_expansion_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def allow_expansion(self) -> typing.Optional[builtins.str]:
        '''Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image.

        Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        '''
        result = self._values.get("allow_expansion")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def allow_expansion_var(self) -> typing.Optional[builtins.str]:
        '''Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image.

        Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        '''
        result = self._values.get("allow_expansion_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationAspectCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationAspectCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationAspectCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c734a61fcc010f45391bd29feb8092fba9a8db3c2117879102939c6fce9bb324)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationAspectCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dd775edc13c95a05a2440a6fbe9c2344ec3236acd6d02497bc341a9c37ee5da9)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationAspectCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__139677411c61f7c7e48795495090b5e99e3ec2ed2e69bc7303726ee3abaeefb1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__22478f3831438ab6f3eed62eb8ba12c3b51152b88a257828f0b3e4589948b036)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8460422beba9055e1df10bff847894ea7ecc420f0fc7cfd2bd7b2146bb540e2f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationAspectCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationAspectCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationAspectCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__80e3bd5223859bdb7c1b8d819b5fef261d77205b4b39918233bb8d33237bdf81)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationAspectCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationAspectCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b29018e962b7eb53426c9a3cbdae465b3d584647978f37cf4384fa4a654d70a2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAllowExpansion")
    def reset_allow_expansion(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansion", []))

    @jsii.member(jsii_name="resetAllowExpansionVar")
    def reset_allow_expansion_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansionVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionInput")
    def allow_expansion_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVarInput")
    def allow_expansion_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansion")
    def allow_expansion(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansion"))

    @allow_expansion.setter
    def allow_expansion(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__29a7646893f55accdd93d2587e90c27eb7fd0784639e511c148b02e6d7208d45)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansion", value)

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVar")
    def allow_expansion_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansionVar"))

    @allow_expansion_var.setter
    def allow_expansion_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__13e643529c012f1d88337640f5d963199152ba1b6cf2554a4bbd7070b73fbcf8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansionVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__566a0425a7c9ae9c2444a64827992dac094c44a0698959c3dea137bf8a5cdc90)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0c3ce1330e1197601a94cdf79c893e573b1ad219682c00268e3f5fa50fc9e17a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5172148acf86f844e6b4d1ac019898686641ebb872210afd6f2bcb5a897db655)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cc6a277db18c0a95d37bbecb186c8d6a06b837b452ec4b7fd8a5271da0fe2042)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__93c9fe0a349a64a5aa82c5d182d8eb1bb8163ab12de8a2ae3e3409f680e7ea70)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5a9478d7dddc68c5c619d8d79e2d2376f4f91c078db65dc595b7cb8ddf48bcc5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__149bb344a5788096417598182c71cb3c83206c985973a9463e6be6b6e99cbb8a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__65cb0ddc80ec4c136b06cbc38a9f1f15b7ef43c3553660f564eb377ae40ef57c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationAspectCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationAspectCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationAspectCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__75c2b1ef00a2661757e3629700dc7d57da5bc0a3e67a907d17556e5b02e63a3d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationBackgroundColor",
    jsii_struct_bases=[],
    name_mapping={"color": "color", "color_var": "colorVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationBackgroundColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e6b26f457b7344a6816cb53be72441f28755964c246ab6ba8965703d266eb3d4)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationBackgroundColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationBackgroundColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationBackgroundColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__82ebfc081b93fdf74632b88fbe98f1d1c2f0426140a880b3231e305a4a321154)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationBackgroundColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__07846f7d3ccf7a62d8c6d1e0708f7605d866290621a8d76c6cda44d1f5d1a3e9)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationBackgroundColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7eb380acd1b733789a99e05bb102f2b869a38257152096228b0fb3b8c27b74e6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__75ec3c768ebeb3506fe13eab5ae7d753350edee23c3d1f05c00c5d9b08120fc4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__41119e8f9fb76fc1eff87e6238cc73c29accc0bb4751fc17f3278b95d3b4dcb1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationBackgroundColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationBackgroundColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ba973b966fb9f93d1c8def15da7ede19fc346b2f9c92fb6b2b13b2173316e0db)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationBackgroundColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationBackgroundColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9e648ddcdc696067faa47007f205a2cee396501ef24e393595f6c2c243a30ed1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f7d7c6d6bf806e5089f9d29db78f24345dc66affabd919bf0178e8d6d4d11ceb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__342e4d60c09fccf3cc8ad14cb94e0f4dfa8f0a8458d440c413c68eafa0076104)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationBackgroundColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationBackgroundColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationBackgroundColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4beca366d6922d40fe0aa6eed37049bbf8293340aae3e990a493157b56257d8d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationBlur",
    jsii_struct_bases=[],
    name_mapping={"sigma": "sigma", "sigma_var": "sigmaVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationBlur:
    def __init__(
        self,
        *,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param sigma: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f8ab06d6746461b09c237665f1de0d460a59749b95cc0a54facdddfd86844ce)
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationBlur(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationBlurList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationBlurList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__32f8911f97883a51cd3ae38d2dbf8dd45f0410b45ae06c8d746efe2df48a484a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationBlurOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f93a0ff0b892b2105b6236f09b2d94f022d50769d88009cfb7e2a23c040c3b15)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationBlurOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__557cde2a8bdbed3f8e5f3d8c26291691081fd516d8000b7ffc0d8f1258a6d280)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__04fd21f27ede0b96d8c51aece06c3fb1477d34d7884932ea5ce6826743dbc9a9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__854072b1036805763f1cc741b8be8eae0d1131f0dc2baf49aeb362a28f3c9ba5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationBlur]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationBlur]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__44cc697f73c25a8516c60898052b65c5dacf7448c39540f3c6bfc9a00b98e449)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationBlurOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationBlurOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a80ad53d7ddbaac480e8e9b1a23a80355d1912144d79e53db1173f1fb52008e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1bab105667f325732785a62f7470c555fd660548490f65dc70e53837f43fe5cc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__60ea73c5e7533fb7a9da563965a11170fdaee6a6f4b2fdc5a78b1bece9378d02)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationBlur]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationBlur]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationBlur]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d6f40ad413fb7f0c2444f7060b9136e7c6dd67e5d8abbacf8097d98e32fa51a6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationChromaKey",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_feather": "hueFeather",
        "hue_feather_var": "hueFeatherVar",
        "hue_tolerance": "hueTolerance",
        "hue_tolerance_var": "hueToleranceVar",
        "hue_var": "hueVar",
        "lightness_feather": "lightnessFeather",
        "lightness_feather_var": "lightnessFeatherVar",
        "lightness_tolerance": "lightnessTolerance",
        "lightness_tolerance_var": "lightnessToleranceVar",
        "saturation_feather": "saturationFeather",
        "saturation_feather_var": "saturationFeatherVar",
        "saturation_tolerance": "saturationTolerance",
        "saturation_tolerance_var": "saturationToleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationChromaKey:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_feather: typing.Optional[builtins.str] = None,
        hue_feather_var: typing.Optional[builtins.str] = None,
        hue_tolerance: typing.Optional[builtins.str] = None,
        hue_tolerance_var: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness_feather: typing.Optional[builtins.str] = None,
        lightness_feather_var: typing.Optional[builtins.str] = None,
        lightness_tolerance: typing.Optional[builtins.str] = None,
        lightness_tolerance_var: typing.Optional[builtins.str] = None,
        saturation_feather: typing.Optional[builtins.str] = None,
        saturation_feather_var: typing.Optional[builtins.str] = None,
        saturation_tolerance: typing.Optional[builtins.str] = None,
        saturation_tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_feather: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        :param hue_feather_var: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        :param hue_tolerance: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        :param hue_tolerance_var: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        :param hue_var: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness_feather: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        :param lightness_feather_var: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        :param lightness_tolerance: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        :param lightness_tolerance_var: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        :param saturation_feather: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        :param saturation_feather_var: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        :param saturation_tolerance: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        :param saturation_tolerance_var: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__32228c75a664fddc6e1f0f1d7f40981e26043a85615d733516db8cf4ea3bf5bd)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_feather", value=hue_feather, expected_type=type_hints["hue_feather"])
            check_type(argname="argument hue_feather_var", value=hue_feather_var, expected_type=type_hints["hue_feather_var"])
            check_type(argname="argument hue_tolerance", value=hue_tolerance, expected_type=type_hints["hue_tolerance"])
            check_type(argname="argument hue_tolerance_var", value=hue_tolerance_var, expected_type=type_hints["hue_tolerance_var"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness_feather", value=lightness_feather, expected_type=type_hints["lightness_feather"])
            check_type(argname="argument lightness_feather_var", value=lightness_feather_var, expected_type=type_hints["lightness_feather_var"])
            check_type(argname="argument lightness_tolerance", value=lightness_tolerance, expected_type=type_hints["lightness_tolerance"])
            check_type(argname="argument lightness_tolerance_var", value=lightness_tolerance_var, expected_type=type_hints["lightness_tolerance_var"])
            check_type(argname="argument saturation_feather", value=saturation_feather, expected_type=type_hints["saturation_feather"])
            check_type(argname="argument saturation_feather_var", value=saturation_feather_var, expected_type=type_hints["saturation_feather_var"])
            check_type(argname="argument saturation_tolerance", value=saturation_tolerance, expected_type=type_hints["saturation_tolerance"])
            check_type(argname="argument saturation_tolerance_var", value=saturation_tolerance_var, expected_type=type_hints["saturation_tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_feather is not None:
            self._values["hue_feather"] = hue_feather
        if hue_feather_var is not None:
            self._values["hue_feather_var"] = hue_feather_var
        if hue_tolerance is not None:
            self._values["hue_tolerance"] = hue_tolerance
        if hue_tolerance_var is not None:
            self._values["hue_tolerance_var"] = hue_tolerance_var
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness_feather is not None:
            self._values["lightness_feather"] = lightness_feather
        if lightness_feather_var is not None:
            self._values["lightness_feather_var"] = lightness_feather_var
        if lightness_tolerance is not None:
            self._values["lightness_tolerance"] = lightness_tolerance
        if lightness_tolerance_var is not None:
            self._values["lightness_tolerance_var"] = lightness_tolerance_var
        if saturation_feather is not None:
            self._values["saturation_feather"] = saturation_feather
        if saturation_feather_var is not None:
            self._values["saturation_feather_var"] = saturation_feather_var
        if saturation_tolerance is not None:
            self._values["saturation_tolerance"] = saturation_tolerance
        if saturation_tolerance_var is not None:
            self._values["saturation_tolerance_var"] = saturation_tolerance_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        '''
        result = self._values.get("hue_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        '''
        result = self._values.get("hue_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        '''
        result = self._values.get("hue_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        '''
        result = self._values.get("hue_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        '''
        result = self._values.get("lightness_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        '''
        result = self._values.get("lightness_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        '''
        result = self._values.get("lightness_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        '''
        result = self._values.get("lightness_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        '''
        result = self._values.get("saturation_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        '''
        result = self._values.get("saturation_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        '''
        result = self._values.get("saturation_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        result = self._values.get("saturation_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationChromaKey(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationChromaKeyList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationChromaKeyList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f5adde7a0a26f8e386716a31941d51de368a57ad9d1f26343d324bf2e36a0bb)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationChromaKeyOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea820f2714ed649cb8508320696a739a5a5b12b1e7f087a0e5db97131a130e76)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationChromaKeyOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7fcf65a603600a1fd65bd6e81d9017935b1ddeabe210636e9b433791763798ef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__75bc92ffb844f3ac2cb42cc887c7509b58acd9d1b7dcea2a153bf1999761d44c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__40f5bbc6e1956287bed4e9ff831994bbb2dd54717e7b643ab5fe9d92687002dc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationChromaKey]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationChromaKey]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eb40f4ded2ae923e76875b4c1f6cada76f1aedafd8ac20add81e356664ed6230)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationChromaKeyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationChromaKeyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__40cc0c1298502fe8eeda536ff5917552bb831f768397f37f7840a088e1e4ff3b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueFeather")
    def reset_hue_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeather", []))

    @jsii.member(jsii_name="resetHueFeatherVar")
    def reset_hue_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeatherVar", []))

    @jsii.member(jsii_name="resetHueTolerance")
    def reset_hue_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueTolerance", []))

    @jsii.member(jsii_name="resetHueToleranceVar")
    def reset_hue_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueToleranceVar", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightnessFeather")
    def reset_lightness_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeather", []))

    @jsii.member(jsii_name="resetLightnessFeatherVar")
    def reset_lightness_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeatherVar", []))

    @jsii.member(jsii_name="resetLightnessTolerance")
    def reset_lightness_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessTolerance", []))

    @jsii.member(jsii_name="resetLightnessToleranceVar")
    def reset_lightness_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessToleranceVar", []))

    @jsii.member(jsii_name="resetSaturationFeather")
    def reset_saturation_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeather", []))

    @jsii.member(jsii_name="resetSaturationFeatherVar")
    def reset_saturation_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeatherVar", []))

    @jsii.member(jsii_name="resetSaturationTolerance")
    def reset_saturation_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationTolerance", []))

    @jsii.member(jsii_name="resetSaturationToleranceVar")
    def reset_saturation_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherInput")
    def hue_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVarInput")
    def hue_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceInput")
    def hue_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVarInput")
    def hue_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherInput")
    def lightness_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVarInput")
    def lightness_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceInput")
    def lightness_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVarInput")
    def lightness_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherInput")
    def saturation_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVarInput")
    def saturation_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceInput")
    def saturation_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVarInput")
    def saturation_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0baef5d613ee6646f29d8d628a1a511724ba7567690a255ff744b2c7451a230b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeather")
    def hue_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeather"))

    @hue_feather.setter
    def hue_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ef2e8297fbb3476964cd5189dc597ab93ed350c8d029b917f069d77ef2452bfc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeather", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVar")
    def hue_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeatherVar"))

    @hue_feather_var.setter
    def hue_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__34bfe2eba4589d3a84ca9ff72b240aee5dc5568d2ae2e4552f5a857fea270f7b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueTolerance")
    def hue_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueTolerance"))

    @hue_tolerance.setter
    def hue_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__29011340eb5f4a08b796ea88490275f0c6609c473daa1ea93788cd32fb5b2e3c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVar")
    def hue_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueToleranceVar"))

    @hue_tolerance_var.setter
    def hue_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c36bf2ec05e8325dc848f2448cac796c1e1e6c0bf276e1818881ac898f6ac781)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8c270dd616397433216a5148e46670c12dcfdbf33e75f291ffe9aa0a1f381811)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeather")
    def lightness_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeather"))

    @lightness_feather.setter
    def lightness_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9cd7637747ea13adce7451d484999077cd9396e1c6541ce8dc134e2947bd7d88)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeather", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVar")
    def lightness_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeatherVar"))

    @lightness_feather_var.setter
    def lightness_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8725efa01bd2cb6dc1eae19c1042c7ffb3a89fda1155e81423b18b2ee6c728bc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessTolerance")
    def lightness_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessTolerance"))

    @lightness_tolerance.setter
    def lightness_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ef69ff20fd032d6b6ff7d2743e91f31419915ae8e328bc55e3823541cc6d8280)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVar")
    def lightness_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessToleranceVar"))

    @lightness_tolerance_var.setter
    def lightness_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0a052fc8d5e1d4205625a99571946e774c68735e09f838dd61034507a81bdabb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeather")
    def saturation_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeather"))

    @saturation_feather.setter
    def saturation_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c9cba9c42b63f9f9e19cbbad86783535bd56ea23ecfde8fc22ed9c32cb618961)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeather", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVar")
    def saturation_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeatherVar"))

    @saturation_feather_var.setter
    def saturation_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__493a32de63d05279aef2fcef6d8dcb3cb9c6310ba6cae2c516a68eb4ffb1b7a4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationTolerance")
    def saturation_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationTolerance"))

    @saturation_tolerance.setter
    def saturation_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__984ebe1b6ec3527c1ebb029462c354f1a7433c876087cf484e64c5e0a668694e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVar")
    def saturation_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationToleranceVar"))

    @saturation_tolerance_var.setter
    def saturation_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__09d9824912082329c0893d0ad8f76ab078fda306813bdd91faaec4ebb2595190)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationChromaKey]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationChromaKey]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationChromaKey]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2001b23079ecc99b0b1904e70094f09f902df1fdae351b0967b90d5a2b037148)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationComposite",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "placement": "placement",
        "placement_var": "placementVar",
        "scale": "scale",
        "scale_dimension": "scaleDimension",
        "scale_dimension_var": "scaleDimensionVar",
        "scale_var": "scaleVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationComposite:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationCompositeImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        placement: typing.Optional[builtins.str] = None,
        placement_var: typing.Optional[builtins.str] = None,
        scale: typing.Optional[builtins.str] = None,
        scale_dimension: typing.Optional[builtins.str] = None,
        scale_dimension_var: typing.Optional[builtins.str] = None,
        scale_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param placement: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        :param placement_var: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        :param scale: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param scale_dimension: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        :param scale_dimension_var: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        :param scale_var: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        :param x_position: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationCompositeImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__87eafd7e456348849b94d8548140acce3c53768a5bf585aae9d3fb0271d499d9)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument placement", value=placement, expected_type=type_hints["placement"])
            check_type(argname="argument placement_var", value=placement_var, expected_type=type_hints["placement_var"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument scale_dimension", value=scale_dimension, expected_type=type_hints["scale_dimension"])
            check_type(argname="argument scale_dimension_var", value=scale_dimension_var, expected_type=type_hints["scale_dimension_var"])
            check_type(argname="argument scale_var", value=scale_var, expected_type=type_hints["scale_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if placement is not None:
            self._values["placement"] = placement
        if placement_var is not None:
            self._values["placement_var"] = placement_var
        if scale is not None:
            self._values["scale"] = scale
        if scale_dimension is not None:
            self._values["scale_dimension"] = scale_dimension
        if scale_dimension_var is not None:
            self._values["scale_dimension_var"] = scale_dimension_var
        if scale_var is not None:
            self._values["scale_var"] = scale_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationCompositeImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationCompositeImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        '''
        result = self._values.get("placement")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement_var(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        '''
        result = self._values.get("placement_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        '''
        result = self._values.get("scale_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        '''
        result = self._values.get("scale_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        '''
        result = self._values.get("scale_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationComposite(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationCompositeImage",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationCompositeImage:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationCompositeImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationCompositeImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationCompositeImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a0d5afc04bae74e3ceaeb41d0f87d38de3602fadafe0a6429c38945b9ba81ddd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationCompositeImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationCompositeImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__45174bd0ce271593e26bcda11aeb4b27e4f8c1592fab7437b8c97d806ba98ebf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationCompositeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationCompositeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__351582479d426e789a2941d35073fa1a70590131c316e6e99e2a39fe2310fc67)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationCompositeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5d5b27b97ecc27774bfffdd9c1170dc8a2cfd6307ab9297cacea7bb2d1f7ddf5)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationCompositeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__84aaf4a0d70b99660e2127534545eaa315ea5ed21bc7e9557e3c80c335c71ebd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f1f7fcf1bcbbc01c3af94e1728b382bdb28fe06d79250ab07076c8ab882be7e0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d053f0c8b3dc81e933dded72093c7e996c72b86434abbab3f7b2da11e8b8dd99)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationComposite]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationComposite]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7882b8d37e433431fcecae931cc1b0f1b691d54ec34f351ab8659d8efecdcc16)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationCompositeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationCompositeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__77144c8ae1b0bf4a127248590744cd40049d389a36643f3e45b8cfed4c26004f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationCompositeImage()

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPlacement")
    def reset_placement(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacement", []))

    @jsii.member(jsii_name="resetPlacementVar")
    def reset_placement_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacementVar", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetScaleDimension")
    def reset_scale_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimension", []))

    @jsii.member(jsii_name="resetScaleDimensionVar")
    def reset_scale_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimensionVar", []))

    @jsii.member(jsii_name="resetScaleVar")
    def reset_scale_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationCompositeImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationCompositeImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationCompositeImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="placementInput")
    def placement_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementInput"))

    @builtins.property
    @jsii.member(jsii_name="placementVarInput")
    def placement_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionInput")
    def scale_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVarInput")
    def scale_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleVarInput")
    def scale_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0bc7d48f1b630c437be817d9f96eb5f93359dfef870b4a1a04ce7e7d50362df7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__28df57f5584f2eb11b9bc9e5898be9ba6caa83f558d05801c9a9c97e247d744e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="placement")
    def placement(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placement"))

    @placement.setter
    def placement(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f57b54c5f5d52037eb9d20066c2f883ff8dd51414c692db9134e615d151037a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placement", value)

    @builtins.property
    @jsii.member(jsii_name="placementVar")
    def placement_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placementVar"))

    @placement_var.setter
    def placement_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__51cc6971e1b311686455d6b0d7749eeda7fb62d837119be8b3a3717a8ba9f449)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placementVar", value)

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scale"))

    @scale.setter
    def scale(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__edc850ec8df138e280746101aa30262362a01c8adaa86ce1c1c291bfe4fde085)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scale", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimension")
    def scale_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimension"))

    @scale_dimension.setter
    def scale_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ffcf459bd10b88b3cf5c3418bfd886365eb31e0d4489b1c82a52943656632ba3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimension", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVar")
    def scale_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimensionVar"))

    @scale_dimension_var.setter
    def scale_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__244037c88e3cb26fd3ebe57685213ce655d2eb93f5846710ec04f8ae6fe96561)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="scaleVar")
    def scale_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleVar"))

    @scale_var.setter
    def scale_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2630dd70768a952813cafe0d22ec085abcdc8402bf972dabb0f41a3862735f31)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bea6b4efac1c2cd0b3b02e990514cb493e2325921c71a60a105e4c11441a01c0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c3b0887b504ec9965b5421d17dd6fa73ec72e401a4234be6860da01f59bcc2f1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__67df5c16bf6e14a025a6c141db2350ffb2690e25785cba2b0da798a057871fd2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b38de1a126b0ee8d6ea22cb891d2478b0cb538237f506902605a21c4aa4fb3a1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationComposite]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationComposite]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationComposite]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__48acd6bce5cb018a7a19a033552acdfb3ec8f7b6250e9185a3c4d73f58909159)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationCompound",
    jsii_struct_bases=[],
    name_mapping={"transformations": "transformations"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationCompound:
    def __init__(
        self,
        *,
        transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param transformations: transformations block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f58e7bb793b7892e45edf41395a28de33587b4840cb9402d5c6dfb218591d44d)
            check_type(argname="argument transformations", value=transformations, expected_type=type_hints["transformations"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if transformations is not None:
            self._values["transformations"] = transformations

    @builtins.property
    def transformations(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationCompoundTransformations"]]]:
        '''transformations block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        result = self._values.get("transformations")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationCompoundTransformations"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationCompound(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationCompoundList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationCompoundList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__85f61962638685258723f2c9090923bd6ca27d2958f2768087d2e8583a0edb0e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationCompoundOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__908db4e92303fb2e8c17f3de91f726d2830ab0fee0df1279de0fade097e0c27d)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationCompoundOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c9a8d882fe222bbdd56655cdc65512e9bf52aed2ff31193d20c76ec284b4aa73)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__116caf8ab8241a527e0aeaf37cf38aaeadf5c555d947aef3020d33cf0496292d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__99473c39680dee1000bc0f2222b252c6a191b858607e12556ffa058e21049ffa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationCompound]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationCompound]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d06a21ccbe2fbb40db27c013dcbdf0e2acc80e68319de109d948da073273cdc4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationCompoundOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationCompoundOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c56680f78e7759af52d677998f4a7130b5195b25a21d693ac7627ac0d08f1d0d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformations")
    def put_transformations(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1c3a8f6db57a280f5e1367cb786e8e2b04df9f4f6461f19ab1c89ea7045d607b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTransformations", [value]))

    @jsii.member(jsii_name="resetTransformations")
    def reset_transformations(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformations", []))

    @builtins.property
    @jsii.member(jsii_name="transformations")
    def transformations(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationCompoundTransformationsList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationCompoundTransformationsList", jsii.get(self, "transformations"))

    @builtins.property
    @jsii.member(jsii_name="transformationsInput")
    def transformations_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationCompoundTransformations"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationCompoundTransformations"]]], jsii.get(self, "transformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationCompound]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationCompound]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationCompound]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e469aba73614240c32166815f3e5078d528d77c8b1688472aaa4dbb120cb7535)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationCompoundTransformations",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationCompoundTransformations:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationCompoundTransformations(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationCompoundTransformationsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationCompoundTransformationsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__92f0edacbdf65acad0eebf197be1bacb6ee55b693195af113c4233381d0d54fe)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationCompoundTransformationsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f0309413b58d8592480534ab3dc0fefef6f634a2952296466e5c48148701edfb)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationCompoundTransformationsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eb22d99dcaf540fbd38b314a722f69fe34321ac4b2b54dba93052ed0f67fbe03)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ebc99bcbf8f0f250e2bf12cd15cac494c4f73559366bbcdbcfe8376995c1d276)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0181c82b986e132bfe4cfa4c562c4d5f20b406a4c762f6609ff7afdcbdebfc23)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationCompoundTransformations]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationCompoundTransformations]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationCompoundTransformations]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0375ec9eaae0a10377bb6b5cae63eb4b9d6975ece0b338262d48e12825246f7c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationCompoundTransformationsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationCompoundTransformationsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a4c561217736b98aa7fa9dd04c4350cebf2dd2a6f22f14fc117947362fd96f74)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationCompoundTransformations]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationCompoundTransformations]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationCompoundTransformations]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ce277e608895e4659a2f61770b5bd81d4f04a9ccaf3c44d5e7225327e2e4168b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationContrast",
    jsii_struct_bases=[],
    name_mapping={
        "brightness": "brightness",
        "brightness_var": "brightnessVar",
        "contrast": "contrast",
        "contrast_var": "contrastVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationContrast:
    def __init__(
        self,
        *,
        brightness: typing.Optional[builtins.str] = None,
        brightness_var: typing.Optional[builtins.str] = None,
        contrast: typing.Optional[builtins.str] = None,
        contrast_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param brightness: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        :param brightness_var: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        :param contrast: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param contrast_var: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aec56fd199ea3edfcf2ee200f410e49f8b01e66113b4eb389ecc80f06900a00d)
            check_type(argname="argument brightness", value=brightness, expected_type=type_hints["brightness"])
            check_type(argname="argument brightness_var", value=brightness_var, expected_type=type_hints["brightness_var"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument contrast_var", value=contrast_var, expected_type=type_hints["contrast_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if brightness is not None:
            self._values["brightness"] = brightness
        if brightness_var is not None:
            self._values["brightness_var"] = brightness_var
        if contrast is not None:
            self._values["contrast"] = contrast
        if contrast_var is not None:
            self._values["contrast_var"] = contrast_var

    @builtins.property
    def brightness(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        '''
        result = self._values.get("brightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def brightness_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        '''
        result = self._values.get("brightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        result = self._values.get("contrast_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationContrast(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationContrastList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationContrastList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2e6c9ef0f5062d3c4288e515ab819f492e4a6b3e059a2e5622b5373632396013)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationContrastOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d5eec0514e83234f402c1ed89bc71c61cb3bb1da1dc4fa4df0c5d4a6808d0d25)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationContrastOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ee7cc1e7e74915911ed5a8dee4a8d1baefa771e66596afa91edb6d7a778c1167)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1ca0d4b3cc4177b792402bcbc92fc6e36e9baef2d827cb6b39c867fc3445248d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9951e1878f88935f815972a80f045f61688c6e4b25f261d22cfda27e53af977b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationContrast]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationContrast]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fb10c3b3534d49a49cb5f03acb9f1a06fb90fd62c3d882952a69271b5a5cf796)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationContrastOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationContrastOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__125aea9f302a9868686c5db3126fc9f19010cc12a0c46f409dba67760b01e0cd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetBrightness")
    def reset_brightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightness", []))

    @jsii.member(jsii_name="resetBrightnessVar")
    def reset_brightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightnessVar", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetContrastVar")
    def reset_contrast_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrastVar", []))

    @builtins.property
    @jsii.member(jsii_name="brightnessInput")
    def brightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="brightnessVarInput")
    def brightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastVarInput")
    def contrast_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="brightness")
    def brightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightness"))

    @brightness.setter
    def brightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__327772cb172e0435178912401cd471a96dda994a1bf66c35cdcb2e6520223ef5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightness", value)

    @builtins.property
    @jsii.member(jsii_name="brightnessVar")
    def brightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightnessVar"))

    @brightness_var.setter
    def brightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cefb3fa4877e701fab64220b7e3ba21c234d6b35eff1b54f522108ee48dbd5ad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrast"))

    @contrast.setter
    def contrast(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__35dd4dfdf1bbd3314ea9c36a196134704996036ef68c1ebe704fb0e9f88e2329)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrast", value)

    @builtins.property
    @jsii.member(jsii_name="contrastVar")
    def contrast_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrastVar"))

    @contrast_var.setter
    def contrast_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__84989965ee1e10ec5d4800ee92574e7d00a6be2bb148bc32940b5ec54e327cb8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrastVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationContrast]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationContrast]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationContrast]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cb10b28103ff092b559bd166fc1a4fd5dc8928c727088b69eccea8110e3d5b8b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationCrop",
    jsii_struct_bases=[],
    name_mapping={
        "allow_expansion": "allowExpansion",
        "allow_expansion_var": "allowExpansionVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationCrop:
    def __init__(
        self,
        *,
        allow_expansion: typing.Optional[builtins.str] = None,
        allow_expansion_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_expansion: If cropping an area outside of the existing canvas, expands the image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        :param allow_expansion_var: If cropping an area outside of the existing canvas, expands the image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        :param gravity: Frame of reference for X and Y Positions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Frame of reference for X and Y Positions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The number of pixels to crop along the y-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The number of pixels to crop along the y-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The number of pixels to crop along the x-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The number of pixels to crop along the x-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        :param x_position: The x-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7306a7655422e5a941f644ed755109b9ab39bbb34f37f35c07ced9c28aeda740)
            check_type(argname="argument allow_expansion", value=allow_expansion, expected_type=type_hints["allow_expansion"])
            check_type(argname="argument allow_expansion_var", value=allow_expansion_var, expected_type=type_hints["allow_expansion_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if allow_expansion is not None:
            self._values["allow_expansion"] = allow_expansion
        if allow_expansion_var is not None:
            self._values["allow_expansion_var"] = allow_expansion_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def allow_expansion(self) -> typing.Optional[builtins.str]:
        '''If cropping an area outside of the existing canvas, expands the image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        '''
        result = self._values.get("allow_expansion")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def allow_expansion_var(self) -> typing.Optional[builtins.str]:
        '''If cropping an area outside of the existing canvas, expands the image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        '''
        result = self._values.get("allow_expansion_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Frame of reference for X and Y Positions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Frame of reference for X and Y Positions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the y-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the y-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the x-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the x-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__676cdb77781520505229f62ca0bc410b58f543b5dde72e5ea0bbc1a6ba34a45e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e86600085528da6414b04c22f36f1d17bfa46241c3bb61c02b5e583cec8b5433)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a246f1a3ac688b6657b7d12478dafa89ab06ca085d1407315dd315cdde0890fe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e99edb9fd866095d0a9f5bd6987fc17c4599173fec2e16ba314d852045977c48)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ca45eb779f973bf4fd90565b99895a0bd0ed01f5499db6c977eca759be57029)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a92ed7274926a6b48601a86838d20754eced8459b30b56265dfa9c677202780d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c5810a7c75186cee186c524b3e6c0793622d51182805d7f1964cac654dcc10eb)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAllowExpansion")
    def reset_allow_expansion(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansion", []))

    @jsii.member(jsii_name="resetAllowExpansionVar")
    def reset_allow_expansion_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansionVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionInput")
    def allow_expansion_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVarInput")
    def allow_expansion_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansion")
    def allow_expansion(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansion"))

    @allow_expansion.setter
    def allow_expansion(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7bc7e8ee60fc57245f3e8ed0d8a33a40609551c02f0a077c32d91e998f089a01)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansion", value)

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVar")
    def allow_expansion_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansionVar"))

    @allow_expansion_var.setter
    def allow_expansion_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6954654574a01a01fdc1c467308c12f568db434eab5c7541b8cccfdea1c0b3a4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansionVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a2eea20150cf90a48d5a03f07c08fe0427bc3a940e9341f48680837ec9560938)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__414928af59722ce943752b58f5a836f983c52cac94b160ce024a2895d801deca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3c7480ea76b8ed33a6bcb80bd5f3ef4b4927e08e0d45171cec5244d5e4bdeca1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__67a14fa9b3cd37510241e59f81782f5e1cb31e3cf2aa9b36632bd8ce59e59435)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1da1d6eb748b480ffe0fe4f2384407b5ac3c62cb6732d1c197dfa1b519c2ded5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5a98e5b3656de79ed5c4928594db8a769b1aee42e636ebd5171486ab794c1a9b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__deb6a543e7157efe340a3d61e574bbe142735c63a8d6a1f33805270d8cfe0c4c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__70620b5a13d5167ab7875daf88cb05bc7177dfbe201769b38c5ce7c991984669)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1a27ed65d9dd3621d022c776c7ed290b230b7b8e56a5c8f63eaa95fd58bdf523)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8b2f318452a918d7c120b67995fd6927ea3b447c4e0a861cf81c3364d47cd5f6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__db678e2485db9077b6c0b9654857b8e3d454cad55032f2340e4ce8c81c038b84)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationFaceCrop",
    jsii_struct_bases=[],
    name_mapping={
        "algorithm": "algorithm",
        "algorithm_var": "algorithmVar",
        "confidence": "confidence",
        "confidence_var": "confidenceVar",
        "fail_gravity": "failGravity",
        "fail_gravity_var": "failGravityVar",
        "focus": "focus",
        "focus_var": "focusVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "padding": "padding",
        "padding_var": "paddingVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationFaceCrop:
    def __init__(
        self,
        *,
        algorithm: typing.Optional[builtins.str] = None,
        algorithm_var: typing.Optional[builtins.str] = None,
        confidence: typing.Optional[builtins.str] = None,
        confidence_var: typing.Optional[builtins.str] = None,
        fail_gravity: typing.Optional[builtins.str] = None,
        fail_gravity_var: typing.Optional[builtins.str] = None,
        focus: typing.Optional[builtins.str] = None,
        focus_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param algorithm: Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm DataAkamaiImagingPolicyImage#algorithm}
        :param algorithm_var: Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm_var DataAkamaiImagingPolicyImage#algorithm_var}
        :param confidence: With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image. Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence DataAkamaiImagingPolicyImage#confidence}
        :param confidence_var: With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image. Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence_var DataAkamaiImagingPolicyImage#confidence_var}
        :param fail_gravity: Controls placement of the crop if Image and Video Manager does not detect any faces in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        :param fail_gravity_var: Controls placement of the crop if Image and Video Manager does not detect any faces in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        :param focus: Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus DataAkamaiImagingPolicyImage#focus}
        :param focus_var: Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus_var DataAkamaiImagingPolicyImage#focus_var}
        :param gravity: Controls placement of the crop. Directions are relative to the face(s) plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Controls placement of the crop. Directions are relative to the face(s) plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param padding: The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        :param style: Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f42ded627018952faacc67a95d2843efe5dde841c78e55df93e40603e39759a1)
            check_type(argname="argument algorithm", value=algorithm, expected_type=type_hints["algorithm"])
            check_type(argname="argument algorithm_var", value=algorithm_var, expected_type=type_hints["algorithm_var"])
            check_type(argname="argument confidence", value=confidence, expected_type=type_hints["confidence"])
            check_type(argname="argument confidence_var", value=confidence_var, expected_type=type_hints["confidence_var"])
            check_type(argname="argument fail_gravity", value=fail_gravity, expected_type=type_hints["fail_gravity"])
            check_type(argname="argument fail_gravity_var", value=fail_gravity_var, expected_type=type_hints["fail_gravity_var"])
            check_type(argname="argument focus", value=focus, expected_type=type_hints["focus"])
            check_type(argname="argument focus_var", value=focus_var, expected_type=type_hints["focus_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if algorithm is not None:
            self._values["algorithm"] = algorithm
        if algorithm_var is not None:
            self._values["algorithm_var"] = algorithm_var
        if confidence is not None:
            self._values["confidence"] = confidence
        if confidence_var is not None:
            self._values["confidence_var"] = confidence_var
        if fail_gravity is not None:
            self._values["fail_gravity"] = fail_gravity
        if fail_gravity_var is not None:
            self._values["fail_gravity_var"] = fail_gravity_var
        if focus is not None:
            self._values["focus"] = focus
        if focus_var is not None:
            self._values["focus_var"] = focus_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def algorithm(self) -> typing.Optional[builtins.str]:
        '''Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm DataAkamaiImagingPolicyImage#algorithm}
        '''
        result = self._values.get("algorithm")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def algorithm_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm_var DataAkamaiImagingPolicyImage#algorithm_var}
        '''
        result = self._values.get("algorithm_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def confidence(self) -> typing.Optional[builtins.str]:
        '''With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image.

        Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence DataAkamaiImagingPolicyImage#confidence}
        '''
        result = self._values.get("confidence")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def confidence_var(self) -> typing.Optional[builtins.str]:
        '''With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image.

        Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence_var DataAkamaiImagingPolicyImage#confidence_var}
        '''
        result = self._values.get("confidence_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any faces in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        '''
        result = self._values.get("fail_gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any faces in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        '''
        result = self._values.get("fail_gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def focus(self) -> typing.Optional[builtins.str]:
        '''Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus DataAkamaiImagingPolicyImage#focus}
        '''
        result = self._values.get("focus")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def focus_var(self) -> typing.Optional[builtins.str]:
        '''Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus_var DataAkamaiImagingPolicyImage#focus_var}
        '''
        result = self._values.get("focus_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the face(s) plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the face(s) plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationFaceCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationFaceCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationFaceCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f1a3ed8f44500b777b2a444b51c48acf0101d4fa56cd4f918920d87771925d70)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationFaceCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__05274f23b69c0ddcc005b9b226f8bca173a6f0ca90174088b79def77122ad37b)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationFaceCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6d64522b2366ad2472165aa93dff791c1d42c6349c52febac5d9ce9f88ae795f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8800727d10f44cc7dbc929919e8e795c5f1024deaa600ed21acd5f5edb036279)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a2c11343468de6f3c1dbc1050834becb611c06fa17fc54ae78d40164aa7103a4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationFaceCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationFaceCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationFaceCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c53b7811a053ee8c46a11ec62361de54583678c16e8e57a2caba48b0823bc74a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationFaceCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationFaceCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__becaf2ccad2d3ed123616e02e0c21c357ddb375a2f0d4880c74f5d7867d936db)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAlgorithm")
    def reset_algorithm(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAlgorithm", []))

    @jsii.member(jsii_name="resetAlgorithmVar")
    def reset_algorithm_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAlgorithmVar", []))

    @jsii.member(jsii_name="resetConfidence")
    def reset_confidence(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetConfidence", []))

    @jsii.member(jsii_name="resetConfidenceVar")
    def reset_confidence_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetConfidenceVar", []))

    @jsii.member(jsii_name="resetFailGravity")
    def reset_fail_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravity", []))

    @jsii.member(jsii_name="resetFailGravityVar")
    def reset_fail_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravityVar", []))

    @jsii.member(jsii_name="resetFocus")
    def reset_focus(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFocus", []))

    @jsii.member(jsii_name="resetFocusVar")
    def reset_focus_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFocusVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="algorithmInput")
    def algorithm_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "algorithmInput"))

    @builtins.property
    @jsii.member(jsii_name="algorithmVarInput")
    def algorithm_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "algorithmVarInput"))

    @builtins.property
    @jsii.member(jsii_name="confidenceInput")
    def confidence_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "confidenceInput"))

    @builtins.property
    @jsii.member(jsii_name="confidenceVarInput")
    def confidence_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "confidenceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityInput")
    def fail_gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityVarInput")
    def fail_gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="focusInput")
    def focus_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "focusInput"))

    @builtins.property
    @jsii.member(jsii_name="focusVarInput")
    def focus_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "focusVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="algorithm")
    def algorithm(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "algorithm"))

    @algorithm.setter
    def algorithm(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__025e67bd2b3dcc30d8847ad838341bfed184891644be2a9fd3cf2bd89ed956f1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "algorithm", value)

    @builtins.property
    @jsii.member(jsii_name="algorithmVar")
    def algorithm_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "algorithmVar"))

    @algorithm_var.setter
    def algorithm_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f760b4f21789ca18071aebbb926a00419f14a655ecdf5c1c900834f2365471f1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "algorithmVar", value)

    @builtins.property
    @jsii.member(jsii_name="confidence")
    def confidence(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "confidence"))

    @confidence.setter
    def confidence(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4021371044ec805bf040e4625a03eccb2de5e26e83384e4b9fe2ed1f8a51f796)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "confidence", value)

    @builtins.property
    @jsii.member(jsii_name="confidenceVar")
    def confidence_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "confidenceVar"))

    @confidence_var.setter
    def confidence_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f384644baa90d826a24808e9be6a20d0bc6dd23314cf4dc86c66ded50c50f4a1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "confidenceVar", value)

    @builtins.property
    @jsii.member(jsii_name="failGravity")
    def fail_gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravity"))

    @fail_gravity.setter
    def fail_gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c23f96c75973eb20b29d619413d26f654e527ecc12df7fd703c2210cbd226c24)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravity", value)

    @builtins.property
    @jsii.member(jsii_name="failGravityVar")
    def fail_gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravityVar"))

    @fail_gravity_var.setter
    def fail_gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c122a3034d232c1bab9003c13d224aeb217999e9ffd6163b3aabb03da53f2a01)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="focus")
    def focus(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "focus"))

    @focus.setter
    def focus(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a588196462fe280d1cc6757066c3921252413d72be28055b0026307a311d3881)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "focus", value)

    @builtins.property
    @jsii.member(jsii_name="focusVar")
    def focus_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "focusVar"))

    @focus_var.setter
    def focus_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__41bea81ea55c197abc07db3c49815b2e59508e433f808c8c8dc3edb3a6b312b5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "focusVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7aa6a9c46968b8eb440b64b58ba69bb27a25ee6cc1540170801aad94ac746399)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2c352be7c7367b1e933d79a34ef8e0e257582d13e94b94eb8fcc32901fa7a234)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__272de261e3bd1a398d618fff3dcabc762896c13cdfc4aa5411e88eadafdcebc2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d1712e0301fdd2b8fdaa1fb6ad69d5622c82967bab05d97fe5abd7b5da4f32de)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f90b55069507fcd749db7dace6cccafc3d82f70fd715c34d2f80ad91a355671f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3623e3fe412e469822c489fd83e488c8372f68266f4398f84b0c3bf52b82c701)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eb8985d13a961076e231a7f2bf5ddd83039401b95a9efe12bb6fb68f679b0b08)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fc3e7987969c3db6228938a0dc3bea1c1067b5fcdba6c477310574468c1df2a9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2fe6f625424e4566b3abb06fa1a7cd800cbe7c640722a7d745738402385cc912)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7acca0f7e70b00ab094c56edd961cc89e851bb86fd6febbe8eaaa7542e9c5fad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationFaceCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationFaceCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationFaceCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c15f42baa7fedb8d4331df0e7163216097d22fdba345af218f8a11973f004887)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationFeatureCrop",
    jsii_struct_bases=[],
    name_mapping={
        "fail_gravity": "failGravity",
        "fail_gravity_var": "failGravityVar",
        "feature_radius": "featureRadius",
        "feature_radius_var": "featureRadiusVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "max_features": "maxFeatures",
        "max_features_var": "maxFeaturesVar",
        "min_feature_quality": "minFeatureQuality",
        "min_feature_quality_var": "minFeatureQualityVar",
        "padding": "padding",
        "padding_var": "paddingVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationFeatureCrop:
    def __init__(
        self,
        *,
        fail_gravity: typing.Optional[builtins.str] = None,
        fail_gravity_var: typing.Optional[builtins.str] = None,
        feature_radius: typing.Optional[builtins.str] = None,
        feature_radius_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        max_features: typing.Optional[builtins.str] = None,
        max_features_var: typing.Optional[builtins.str] = None,
        min_feature_quality: typing.Optional[builtins.str] = None,
        min_feature_quality_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fail_gravity: Controls placement of the crop if Image and Video Manager does not detect any features in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        :param fail_gravity_var: Controls placement of the crop if Image and Video Manager does not detect any features in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        :param feature_radius: The size in pixels of the important features to search for. If identified, two features never appear closer together than this value, ``8.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius DataAkamaiImagingPolicyImage#feature_radius}
        :param feature_radius_var: The size in pixels of the important features to search for. If identified, two features never appear closer together than this value, ``8.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius_var DataAkamaiImagingPolicyImage#feature_radius_var}
        :param gravity: Controls placement of the crop. Directions are relative to the region of interest plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Controls placement of the crop. Directions are relative to the region of interest plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param max_features: The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features DataAkamaiImagingPolicyImage#max_features}
        :param max_features_var: The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features_var DataAkamaiImagingPolicyImage#max_features_var}
        :param min_feature_quality: Determines the minimum quality level of the feature identified. To consider a feature important, the feature needs to surpass this value. Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality DataAkamaiImagingPolicyImage#min_feature_quality}
        :param min_feature_quality_var: Determines the minimum quality level of the feature identified. To consider a feature important, the feature needs to surpass this value. Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality_var DataAkamaiImagingPolicyImage#min_feature_quality_var}
        :param padding: Adds space around the region of interest. The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: Adds space around the region of interest. The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        :param style: Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__de73fa0cafda879bc1543ef6b553fef8b656cc301f977f008afbc35244602698)
            check_type(argname="argument fail_gravity", value=fail_gravity, expected_type=type_hints["fail_gravity"])
            check_type(argname="argument fail_gravity_var", value=fail_gravity_var, expected_type=type_hints["fail_gravity_var"])
            check_type(argname="argument feature_radius", value=feature_radius, expected_type=type_hints["feature_radius"])
            check_type(argname="argument feature_radius_var", value=feature_radius_var, expected_type=type_hints["feature_radius_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument max_features", value=max_features, expected_type=type_hints["max_features"])
            check_type(argname="argument max_features_var", value=max_features_var, expected_type=type_hints["max_features_var"])
            check_type(argname="argument min_feature_quality", value=min_feature_quality, expected_type=type_hints["min_feature_quality"])
            check_type(argname="argument min_feature_quality_var", value=min_feature_quality_var, expected_type=type_hints["min_feature_quality_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fail_gravity is not None:
            self._values["fail_gravity"] = fail_gravity
        if fail_gravity_var is not None:
            self._values["fail_gravity_var"] = fail_gravity_var
        if feature_radius is not None:
            self._values["feature_radius"] = feature_radius
        if feature_radius_var is not None:
            self._values["feature_radius_var"] = feature_radius_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if max_features is not None:
            self._values["max_features"] = max_features
        if max_features_var is not None:
            self._values["max_features_var"] = max_features_var
        if min_feature_quality is not None:
            self._values["min_feature_quality"] = min_feature_quality
        if min_feature_quality_var is not None:
            self._values["min_feature_quality_var"] = min_feature_quality_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def fail_gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any features in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        '''
        result = self._values.get("fail_gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any features in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        '''
        result = self._values.get("fail_gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feature_radius(self) -> typing.Optional[builtins.str]:
        '''The size in pixels of the important features to search for.

        If identified, two features never appear closer together than this value, ``8.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius DataAkamaiImagingPolicyImage#feature_radius}
        '''
        result = self._values.get("feature_radius")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feature_radius_var(self) -> typing.Optional[builtins.str]:
        '''The size in pixels of the important features to search for.

        If identified, two features never appear closer together than this value, ``8.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius_var DataAkamaiImagingPolicyImage#feature_radius_var}
        '''
        result = self._values.get("feature_radius_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the region of interest plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the region of interest plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def max_features(self) -> typing.Optional[builtins.str]:
        '''The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features DataAkamaiImagingPolicyImage#max_features}
        '''
        result = self._values.get("max_features")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def max_features_var(self) -> typing.Optional[builtins.str]:
        '''The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features_var DataAkamaiImagingPolicyImage#max_features_var}
        '''
        result = self._values.get("max_features_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def min_feature_quality(self) -> typing.Optional[builtins.str]:
        '''Determines the minimum quality level of the feature identified.

        To consider a feature important, the feature needs to surpass this value.  Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality DataAkamaiImagingPolicyImage#min_feature_quality}
        '''
        result = self._values.get("min_feature_quality")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def min_feature_quality_var(self) -> typing.Optional[builtins.str]:
        '''Determines the minimum quality level of the feature identified.

        To consider a feature important, the feature needs to surpass this value.  Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality_var DataAkamaiImagingPolicyImage#min_feature_quality_var}
        '''
        result = self._values.get("min_feature_quality_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''Adds space around the region of interest.

        The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''Adds space around the region of interest.

        The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationFeatureCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationFeatureCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationFeatureCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__37c08887474a972aedb104dbbd64a764f224a2a9e4b31afa8d129f0a808a5968)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationFeatureCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a702360bdd8e9fa98465d2adbf320e0b3fd588e772b3f768ce76d31d8c223b7)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationFeatureCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2718c3e7dde4c3de22a7a78ebdb02773cf12d33e2ac61589dddff8f27e4633fb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2c8a1b07b2120549ad9de472929982f5d48eb73bc8c261f23ada35bc3e205aff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a8b3d1c70ad12c808c353ef00218d0ace8cd493fe8936535f09ce0fd05bee43c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationFeatureCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationFeatureCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationFeatureCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3d9bf7f0fa7e2d795b9ca8927ba1b5fe48410d614edce95e29b305e49eac8ca6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationFeatureCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationFeatureCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2dccb19bf89dca13f22893d4cf6649165791b1aac9f73de1e194ec3444996de6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetFailGravity")
    def reset_fail_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravity", []))

    @jsii.member(jsii_name="resetFailGravityVar")
    def reset_fail_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravityVar", []))

    @jsii.member(jsii_name="resetFeatureRadius")
    def reset_feature_radius(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureRadius", []))

    @jsii.member(jsii_name="resetFeatureRadiusVar")
    def reset_feature_radius_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureRadiusVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetMaxFeatures")
    def reset_max_features(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxFeatures", []))

    @jsii.member(jsii_name="resetMaxFeaturesVar")
    def reset_max_features_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxFeaturesVar", []))

    @jsii.member(jsii_name="resetMinFeatureQuality")
    def reset_min_feature_quality(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMinFeatureQuality", []))

    @jsii.member(jsii_name="resetMinFeatureQualityVar")
    def reset_min_feature_quality_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMinFeatureQualityVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="failGravityInput")
    def fail_gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityVarInput")
    def fail_gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featureRadiusInput")
    def feature_radius_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featureRadiusInput"))

    @builtins.property
    @jsii.member(jsii_name="featureRadiusVarInput")
    def feature_radius_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featureRadiusVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesInput")
    def max_features_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "maxFeaturesInput"))

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesVarInput")
    def max_features_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "maxFeaturesVarInput"))

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityInput")
    def min_feature_quality_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "minFeatureQualityInput"))

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityVarInput")
    def min_feature_quality_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "minFeatureQualityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravity")
    def fail_gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravity"))

    @fail_gravity.setter
    def fail_gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__54c4862f628f91886030f7ea2249fb82db6aa6c29a80f1590d945f397a751216)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravity", value)

    @builtins.property
    @jsii.member(jsii_name="failGravityVar")
    def fail_gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravityVar"))

    @fail_gravity_var.setter
    def fail_gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7f54a6c5b438c92ad52fc70adbe0b3a5927c22e316428ebfe65660429050755c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="featureRadius")
    def feature_radius(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featureRadius"))

    @feature_radius.setter
    def feature_radius(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cfff417571048c836ebcce00c06d8925f9d7ac95b7d0dfa56609bc15a462b03b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featureRadius", value)

    @builtins.property
    @jsii.member(jsii_name="featureRadiusVar")
    def feature_radius_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featureRadiusVar"))

    @feature_radius_var.setter
    def feature_radius_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0a964c666ce602baf4804fe803c42f104f192ec9dea5ce9753243572feaa956c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featureRadiusVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e8a31e609210f80d2a81f56504a9294279535be537e7fb5660b6a22efc4ee102)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c147276a1c913b6dbc153840474510322ad888cad5a568cc3f8d264ab70f1e01)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ade32497f4be5719bc3ec8b17d72379a7a63a354a52f10840b225418ac590ffc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f1938dccce82ee731933f83e9fe3b8aa6c212c1acf6f73e5869c5d5615464c5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="maxFeatures")
    def max_features(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "maxFeatures"))

    @max_features.setter
    def max_features(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cad0e2d00fa92b5154373836205543bd6fe893c7393c5be9c7648f0d41eddeff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "maxFeatures", value)

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesVar")
    def max_features_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "maxFeaturesVar"))

    @max_features_var.setter
    def max_features_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0b8e1ab8eb2f45275ca2070d175a984c0a488d4a1ebf20ba136b67dbdc687d8b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "maxFeaturesVar", value)

    @builtins.property
    @jsii.member(jsii_name="minFeatureQuality")
    def min_feature_quality(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "minFeatureQuality"))

    @min_feature_quality.setter
    def min_feature_quality(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f56c8f5a8f4fd2880674cf8047e085daf84cdcf4fa81446615d05d6093d6ec59)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "minFeatureQuality", value)

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityVar")
    def min_feature_quality_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "minFeatureQualityVar"))

    @min_feature_quality_var.setter
    def min_feature_quality_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3d27b936dde9bf0b0e6864e6bb07fda83ecadd3455bcab6d968cd2fa883d9e43)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "minFeatureQualityVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9942f025abe1353053d1bd6b6a501c78a9eb5dd4f641ab35cfbafac0dcdc06f4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__72d7637fb8674e5195eb6e09a09b9b28f33657cd9926429ac6d53c36579cc2ab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb0fcef97b3033f6aa3244db78934353302e7094d2874c903f1808e16b157f1f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d3c3e47d957d313c95dd0585a4783f20022a30b28c2b6617eb7aa1428a9bb1dc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__33a196f14c8973bc4e92eefa3f1e54ed2c70fd6ff31c7e38d9ce019919fc26bd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3f759c757d14d1e4d274d03d061d0c30d456e4f6ad63a08290e5e34c6ea2ed2c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationFeatureCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationFeatureCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationFeatureCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__51c5ee69ad911961a2901c8da40a35d7cf52bceda98ff9a8365e856206ce7dce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationFitAndFill",
    jsii_struct_bases=[],
    name_mapping={
        "fill_transformation": "fillTransformation",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationFitAndFill:
    def __init__(
        self,
        *,
        fill_transformation: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationFitAndFillFillTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fill_transformation: fill_transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_transformation DataAkamaiImagingPolicyImage#fill_transformation}
        :param height: The height value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The width value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(fill_transformation, dict):
            fill_transformation = DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationFitAndFillFillTransformation(**fill_transformation)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__927227a4c1b727d342251f8ce3beacc1b725026a09885b1b6615f0abf311d825)
            check_type(argname="argument fill_transformation", value=fill_transformation, expected_type=type_hints["fill_transformation"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fill_transformation is not None:
            self._values["fill_transformation"] = fill_transformation
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def fill_transformation(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationFitAndFillFillTransformation"]:
        '''fill_transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_transformation DataAkamaiImagingPolicyImage#fill_transformation}
        '''
        result = self._values.get("fill_transformation")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationFitAndFillFillTransformation"], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationFitAndFill(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationFitAndFillFillTransformation",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationFitAndFillFillTransformation:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationFitAndFillFillTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationFitAndFillFillTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationFitAndFillFillTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__822c21c5d416f662f1107a66b757f60de8e3e230289cd4006572127fa2099fb8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationFitAndFillFillTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationFitAndFillFillTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationFitAndFillFillTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fcd48529ee23c366ff8b57386581f0880aa1616e2ea2622bd8f7839dc80c110f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationFitAndFillList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationFitAndFillList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8ddf40a1be3b49dcb1183908d499da5c43bffdeaceaf1ba1a8358c9118a02c64)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationFitAndFillOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d057b7e6b041dd01d13cbacea5d1fb4354014991af2f1c44683dbbae7dfb601)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationFitAndFillOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9849c171f2afe77b158bad15f01800b9058b9d7dd94a6b05f29f530a12fa6340)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f4299c7aec03df887965b3c8e206a02ab9e685b5db7eba28b5d25880b47f3c3c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__43a5bb1d30f4ef0be62855cca2664847d909bad3b00dc41c92a7cceb2a2fbba4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationFitAndFill]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationFitAndFill]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationFitAndFill]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__558340eb7835085dce9d3fe99c9b276872874fb9cc6d6e032328026304bd7c91)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationFitAndFillOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationFitAndFillOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3c63b9398a4149fd605eeee4fb775bea085151011cfb9d5f47fff98e48578679)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putFillTransformation")
    def put_fill_transformation(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationFitAndFillFillTransformation()

        return typing.cast(None, jsii.invoke(self, "putFillTransformation", [value]))

    @jsii.member(jsii_name="resetFillTransformation")
    def reset_fill_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFillTransformation", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="fillTransformation")
    def fill_transformation(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationFitAndFillFillTransformationOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationFitAndFillFillTransformationOutputReference, jsii.get(self, "fillTransformation"))

    @builtins.property
    @jsii.member(jsii_name="fillTransformationInput")
    def fill_transformation_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationFitAndFillFillTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationFitAndFillFillTransformation], jsii.get(self, "fillTransformationInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7b8ab72e90dd0fa62a9a6730033542ad1b2465c481a54ccc104e860fb9e2cc2d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9b2a871b0633d1460b3b6758144fec5f8d77f5bb82544a414f13dc03c430158e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7be3c957b3e9a94d62cbfbb7141d7a86f3e1d760416bbea1d8b754c424dc26a7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c4acc9075f5299748d01cfa1dc0a8b1c5e90be505c325c982409950b83f283ad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationFitAndFill]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationFitAndFill]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationFitAndFill]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f79c65dc9cb8e5ac129673e776f78418ca939655cb4ce0e250a8079a0755d44f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationGoop",
    jsii_struct_bases=[],
    name_mapping={
        "chaos": "chaos",
        "chaos_var": "chaosVar",
        "density": "density",
        "density_var": "densityVar",
        "power": "power",
        "power_var": "powerVar",
        "seed": "seed",
        "seed_var": "seedVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationGoop:
    def __init__(
        self,
        *,
        chaos: typing.Optional[builtins.str] = None,
        chaos_var: typing.Optional[builtins.str] = None,
        density: typing.Optional[builtins.str] = None,
        density_var: typing.Optional[builtins.str] = None,
        power: typing.Optional[builtins.str] = None,
        power_var: typing.Optional[builtins.str] = None,
        seed: typing.Optional[builtins.str] = None,
        seed_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param chaos: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        :param chaos_var: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        :param density: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        :param density_var: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        :param power: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        :param power_var: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        :param seed: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        :param seed_var: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d93f646b369dd9b1b78bddaf136585ef9d12853e5adb0c71e25218242a5e94ae)
            check_type(argname="argument chaos", value=chaos, expected_type=type_hints["chaos"])
            check_type(argname="argument chaos_var", value=chaos_var, expected_type=type_hints["chaos_var"])
            check_type(argname="argument density", value=density, expected_type=type_hints["density"])
            check_type(argname="argument density_var", value=density_var, expected_type=type_hints["density_var"])
            check_type(argname="argument power", value=power, expected_type=type_hints["power"])
            check_type(argname="argument power_var", value=power_var, expected_type=type_hints["power_var"])
            check_type(argname="argument seed", value=seed, expected_type=type_hints["seed"])
            check_type(argname="argument seed_var", value=seed_var, expected_type=type_hints["seed_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if chaos is not None:
            self._values["chaos"] = chaos
        if chaos_var is not None:
            self._values["chaos_var"] = chaos_var
        if density is not None:
            self._values["density"] = density
        if density_var is not None:
            self._values["density_var"] = density_var
        if power is not None:
            self._values["power"] = power
        if power_var is not None:
            self._values["power_var"] = power_var
        if seed is not None:
            self._values["seed"] = seed
        if seed_var is not None:
            self._values["seed_var"] = seed_var

    @builtins.property
    def chaos(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        '''
        result = self._values.get("chaos")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def chaos_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        '''
        result = self._values.get("chaos_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        '''
        result = self._values.get("density")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density_var(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        '''
        result = self._values.get("density_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        '''
        result = self._values.get("power")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power_var(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        '''
        result = self._values.get("power_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        '''
        result = self._values.get("seed")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed_var(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        result = self._values.get("seed_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationGoop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationGoopList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationGoopList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__74cb9181c6210febde50ce2c62171da223edd6bfc515a5bd275715ce0c1f965d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationGoopOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ba912131c4ef807c82251c12184048cebe10044b81a1b4d762e552ae8b35e567)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationGoopOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a844c316bd7f748b48c839722b906756acd5a9b25e6ff04d73bbdebd9ed65ba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d9b1a10f5a6d6d4c10a2670d3b7da9ea3579fa743a2ff0a1fce182c43950ef46)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__70407caaad908dc2d03de9d7350a0724365eea7be83fe7aab9e30142ba3230cf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationGoop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationGoop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a0e468ed07a7865b10e0347b632dd3e6a8921059a98bc44adf3d0d676b0f643)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationGoopOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationGoopOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a0d3b9b838b96fe2534f09432d639a2979b5607e29951c5f992944090d209508)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetChaos")
    def reset_chaos(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaos", []))

    @jsii.member(jsii_name="resetChaosVar")
    def reset_chaos_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaosVar", []))

    @jsii.member(jsii_name="resetDensity")
    def reset_density(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensity", []))

    @jsii.member(jsii_name="resetDensityVar")
    def reset_density_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensityVar", []))

    @jsii.member(jsii_name="resetPower")
    def reset_power(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPower", []))

    @jsii.member(jsii_name="resetPowerVar")
    def reset_power_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPowerVar", []))

    @jsii.member(jsii_name="resetSeed")
    def reset_seed(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeed", []))

    @jsii.member(jsii_name="resetSeedVar")
    def reset_seed_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeedVar", []))

    @builtins.property
    @jsii.member(jsii_name="chaosInput")
    def chaos_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosInput"))

    @builtins.property
    @jsii.member(jsii_name="chaosVarInput")
    def chaos_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosVarInput"))

    @builtins.property
    @jsii.member(jsii_name="densityInput")
    def density_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityInput"))

    @builtins.property
    @jsii.member(jsii_name="densityVarInput")
    def density_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="powerInput")
    def power_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerInput"))

    @builtins.property
    @jsii.member(jsii_name="powerVarInput")
    def power_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerVarInput"))

    @builtins.property
    @jsii.member(jsii_name="seedInput")
    def seed_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedInput"))

    @builtins.property
    @jsii.member(jsii_name="seedVarInput")
    def seed_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedVarInput"))

    @builtins.property
    @jsii.member(jsii_name="chaos")
    def chaos(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaos"))

    @chaos.setter
    def chaos(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ee976ce6c7924a69fb22462bc85c0deb7f7ac206c6f648e809db5f97a969fa3e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaos", value)

    @builtins.property
    @jsii.member(jsii_name="chaosVar")
    def chaos_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaosVar"))

    @chaos_var.setter
    def chaos_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b83553e1a6aa6c89eec6b173adb07925f2d77cdf6df2a691cac2f9abfb31d48c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaosVar", value)

    @builtins.property
    @jsii.member(jsii_name="density")
    def density(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "density"))

    @density.setter
    def density(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f8d5d4140d6e5f5666671b1c00dd9479f4c3f34ce2b3142d2bf53d91a1256b9a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "density", value)

    @builtins.property
    @jsii.member(jsii_name="densityVar")
    def density_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "densityVar"))

    @density_var.setter
    def density_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2c0275c53a6db815708d2707ad7c6eb6ab236fb88a3f453f2728f45c0b6cc2a0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "densityVar", value)

    @builtins.property
    @jsii.member(jsii_name="power")
    def power(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "power"))

    @power.setter
    def power(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ac2310b5b76392bc83c9b7365768809698e9457f133148e79fd0580c0f4b749)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "power", value)

    @builtins.property
    @jsii.member(jsii_name="powerVar")
    def power_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "powerVar"))

    @power_var.setter
    def power_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c1d550d895eaf500c37ee2d0a212bf4742b1f7a577e86f45ae073b9be82a209f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "powerVar", value)

    @builtins.property
    @jsii.member(jsii_name="seed")
    def seed(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seed"))

    @seed.setter
    def seed(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__37af77ccca165cd8f5f2fe783e6e0e68f919e274f08f35da104d93cd6f00eb94)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seed", value)

    @builtins.property
    @jsii.member(jsii_name="seedVar")
    def seed_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seedVar"))

    @seed_var.setter
    def seed_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__59de438de4091a225617df6bdb57673a76d9f4d1a4da1e28f551b0dbbf56cc4d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seedVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationGoop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationGoop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationGoop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fd2039efb9b9dedc4a8653142f41c8fd4605aed307975e0545854564b0a98a15)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationGrayscale",
    jsii_struct_bases=[],
    name_mapping={"type": "type", "type_var": "typeVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationGrayscale:
    def __init__(
        self,
        *,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param type: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7baecdda2eb4701e071d50fdd7df9d11a09debdbcb22b349a100a8b51b76fa6b)
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationGrayscale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationGrayscaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationGrayscaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7c8342fc9194536a2d8e8aba1ad0c813406ad8b0ea29b3237d2ad0ef89681d15)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationGrayscaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__87e4296f4f5721bef0d9a1240d34080a56cced00f196669d9638677924b7b7ea)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationGrayscaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7f6f1b21098b367c0887099ecbe0382c002209263fae569b26982f2648b3d393)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e83fa97a7bfc13f1d31d50b2d524c7a5afd01a5d1328c1c151772568fa9424d9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3dc2c270c690c6626bece888e481eca4b028f2990f3650a3eb15d14cde605d7f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationGrayscale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationGrayscale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5855a417ac44593038202d7b9e1d78f80382d9d9c90865dbac1726a95727f3f3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationGrayscaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationGrayscaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5eff6e9987b2b43c1e38ab55c092b030a8ba643077016ea9406744bf68943410)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8fa037980624ecf6d7754d3195a769bf5df522d23856b71c5ce5e54d1bf779a5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__46bc5ab2982cae57dc6de4b15740ccb1131a2f66a3adc8165e5b174625cb2aea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationGrayscale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationGrayscale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationGrayscale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4b221e88ce9723deb16b5811e3b20600fdb33fc57d62aae76990a29d47e6dfbe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationHsl",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "lightness": "lightness",
        "lightness_var": "lightnessVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationHsl:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness: typing.Optional[builtins.str] = None,
        lightness_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        :param lightness_var: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4715566057e85cb02ba45fd95abb0f5e42aa9ac6bd45dfe01ce773dbc59aeb06)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness", value=lightness, expected_type=type_hints["lightness"])
            check_type(argname="argument lightness_var", value=lightness_var, expected_type=type_hints["lightness_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness is not None:
            self._values["lightness"] = lightness
        if lightness_var is not None:
            self._values["lightness_var"] = lightness_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        '''
        result = self._values.get("lightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        '''
        result = self._values.get("lightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationHsl(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationHslList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationHslList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e7220ed2625fcae33932371dbb2eb4735411dc3d64c47a418c74c2b3d733eaac)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationHslOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8f3dfeb6510a61ed1659037b232e4607985b3b6d52e98040562fba5483de3a8f)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationHslOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ca9f72ca12e7e2dc13baaa57f4bce6a5cf0f9433f301a2d33c4654859188021b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2984a184a480a3db9eca167ec59726f3e05507d4e814e6791247852897b24a4c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a15560f007cbc96a1fa0cffdec397d5002bcb4d9c074cbafba75f8771b6c1021)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationHsl]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationHsl]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0a155cdc51571ec35ba69c63e549d1804b6a65e450c13f96070d43ab43895949)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationHslOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationHslOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e819d4028aeb8b29f7e24546132ebf84e95216198894eb172a69aff647c6ec22)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightness")
    def reset_lightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightness", []))

    @jsii.member(jsii_name="resetLightnessVar")
    def reset_lightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessInput")
    def lightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessVarInput")
    def lightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__21e0c590654202d18f744b0411738056359f85eae23a3fbc0026b088911dbf7a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3357c730b26b48fbc186ffa1c7efee7ba1544deb97dd2706a867a9954fc2a23a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightness")
    def lightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightness"))

    @lightness.setter
    def lightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2f6015069dd3fec29c209eff9a570d0cd7f863715d0c06adff172a266704a993)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightness", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessVar")
    def lightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessVar"))

    @lightness_var.setter
    def lightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ca5ebca46db34d38620559d3669a7dbf16a8d51fa4ab6b33ac06af44d65eabef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cf8dee90f16383ab9f31d09d5e0b17d7a22f232278ee22947db8515eb8a732cc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b14caf1383a0a01791acec8a14c99e0aa93089111367c9b00a0f300640b4aadc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationHsl]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationHsl]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationHsl]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5243235fe41a5d403b8f07baf0c7aad6f2fdca94d51f0c240f3913134819d776)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationHsv",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationHsv:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        :param value: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__51c707527795fbf1af32c140e85d21a4e14c1107cbdc2270a4c049de8dbadcfb)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationHsv(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationHsvList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationHsvList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ce2ce3ed9cd7e339d88d7d48d8c9b6a68b125b80e14910206435c1cbaf905070)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationHsvOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f22d0d3848ea5a4a5a13006e093db0f0d81a98a9a28ff021d1056f0807832a1)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationHsvOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dfcabbf62548b053709ad16ce9853bcc41503d1ed78db65b3e3c476803f0a301)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e105adaaa7a5e7fd01b918a58b653e6a6928b407458de49be831bd690ac45a8c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ec2411707256e5a32c0cc1afa24659876c61a8d4334280c012d7f411974d0c7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationHsv]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationHsv]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__39b74aad3d4e82f543e18c4d6fd8de99dd27b573fc9ecf84427eb98c57e72d45)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationHsvOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationHsvOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d1e0849d5a9b7363693846b34899db0156d12e218122124b70e66d7e57875c44)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__11064446f853bc53e1db3dc8585502200925d6dce5c9a36cde7db8945cbd5d35)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea3bdc8c76e3263c7e359d6410ddc533b83eb60fa6751ba0e0809a6f1f551960)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2edf1bdc57c32dcc33fa87548898973df008fae7dc4748456af7e7f372b7edde)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__00e8fd0f11be083f91eae99a2c98030f3171bef73f09f020f6afbb3881c7d586)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5763f0246be36bd1900ae1d7c790626b4a058fdc8f085c3c7a23ce643c1b2329)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eecf07b83c33d99431db165966fe244241193510fbd4afa7bafb159ef1058e9d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationHsv]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationHsv]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationHsv]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af22f17882a68a3b0423c5fb278e977e0b5c7dbb2f79e354a25bf68b566aff66)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfDimension",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "dimension": "dimension",
        "dimension_var": "dimensionVar",
        "equal": "equal",
        "greater_than": "greaterThan",
        "less_than": "lessThan",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfDimension:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfDimensionDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        dimension: typing.Optional[builtins.str] = None,
        dimension_var: typing.Optional[builtins.str] = None,
        equal: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfDimensionEqual", typing.Dict[builtins.str, typing.Any]]] = None,
        greater_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfDimensionGreaterThan", typing.Dict[builtins.str, typing.Any]]] = None,
        less_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfDimensionLessThan", typing.Dict[builtins.str, typing.Any]]] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param dimension: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        :param dimension_var: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        :param equal: equal block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        :param greater_than: greater_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        :param less_than: less_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        :param value: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfDimensionDefault(**default)
        if isinstance(equal, dict):
            equal = DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfDimensionEqual(**equal)
        if isinstance(greater_than, dict):
            greater_than = DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfDimensionGreaterThan(**greater_than)
        if isinstance(less_than, dict):
            less_than = DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfDimensionLessThan(**less_than)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a21d229e345c9f8ffff2c173ae819640d8d898e2fb376931a216efb21b33d14)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument dimension", value=dimension, expected_type=type_hints["dimension"])
            check_type(argname="argument dimension_var", value=dimension_var, expected_type=type_hints["dimension_var"])
            check_type(argname="argument equal", value=equal, expected_type=type_hints["equal"])
            check_type(argname="argument greater_than", value=greater_than, expected_type=type_hints["greater_than"])
            check_type(argname="argument less_than", value=less_than, expected_type=type_hints["less_than"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if dimension is not None:
            self._values["dimension"] = dimension
        if dimension_var is not None:
            self._values["dimension_var"] = dimension_var
        if equal is not None:
            self._values["equal"] = equal
        if greater_than is not None:
            self._values["greater_than"] = greater_than
        if less_than is not None:
            self._values["less_than"] = less_than
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfDimensionDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfDimensionDefault"], result)

    @builtins.property
    def dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        '''
        result = self._values.get("dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        '''
        result = self._values.get("dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def equal(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfDimensionEqual"]:
        '''equal block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        '''
        result = self._values.get("equal")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfDimensionEqual"], result)

    @builtins.property
    def greater_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfDimensionGreaterThan"]:
        '''greater_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        '''
        result = self._values.get("greater_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfDimensionGreaterThan"], result)

    @builtins.property
    def less_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfDimensionLessThan"]:
        '''less_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        '''
        result = self._values.get("less_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfDimensionLessThan"], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfDimension(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfDimensionDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfDimensionDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfDimensionDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfDimensionDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfDimensionDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2080e987dea9fd0460cc35d24d7f3d07a483d65af82f51f64eace3ddd7032444)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfDimensionDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfDimensionDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8367561f9ea9c4f39f26e22e310fb604b6aab4567d204a3ec3669b61ef85e7d9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfDimensionEqual",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfDimensionEqual:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfDimensionEqual(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfDimensionEqualOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfDimensionEqualOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__78c95e8ccb5dc0e72d0807a22ac54c3031b8c52898278c2e66c8361ae0e56a6e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfDimensionEqual], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfDimensionEqual],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__24990b141dc4ef4418adec49e1ca0f8d902dc17fa24673eeb5418199dec3322b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfDimensionGreaterThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfDimensionGreaterThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfDimensionGreaterThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfDimensionGreaterThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfDimensionGreaterThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8456a30da9ec32c671d5da29602637df88dcc097cd905cd6a9c6be6c387f2bba)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfDimensionGreaterThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfDimensionGreaterThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e0fe1feeea0af17af3e9c942c3e4a47526c8b53c13d1e985cb5597b898fabc4e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfDimensionLessThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfDimensionLessThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfDimensionLessThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfDimensionLessThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfDimensionLessThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__33f8e25bddad2fc4447d2c089620f715e0fc29b2179709fb8d6596f420256e25)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfDimensionLessThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfDimensionLessThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__41c9ebe1d708173e3aac81ce83a470f422ab245e907eb344b72fe1ffc223d76f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfDimensionList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfDimensionList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7983afa4d789271af3e6fe4737491b8dff760fbcf4891fd58e770b6760fef0b1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfDimensionOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3fa1b63623d91dc2185e6a9d4c3a6032620f41bc94dac51d36096057b145fb12)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfDimensionOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eb54dd6e4243090aedd738bc153b5dc9dd8f367c75c52582c26e8ea5d533fde5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b630f497d5a3723205f179317c27a488616e18a60c52c774053681fa015dd408)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__59b51978817acc371443cceca391d572db28fb3dd6583955a703d75ea906bc6c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfDimension]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfDimension]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6ced45dee025f2ef3ae7308f033777a0d04195c02faab903dd6fd7cfdda3c0ef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfDimensionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfDimensionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c3a25c5b9a522e336b8fe32c9ae022fb557865a0fa94a9466b347638ad745a78)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfDimensionDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putEqual")
    def put_equal(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfDimensionEqual()

        return typing.cast(None, jsii.invoke(self, "putEqual", [value]))

    @jsii.member(jsii_name="putGreaterThan")
    def put_greater_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfDimensionGreaterThan()

        return typing.cast(None, jsii.invoke(self, "putGreaterThan", [value]))

    @jsii.member(jsii_name="putLessThan")
    def put_less_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfDimensionLessThan()

        return typing.cast(None, jsii.invoke(self, "putLessThan", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetDimension")
    def reset_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimension", []))

    @jsii.member(jsii_name="resetDimensionVar")
    def reset_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimensionVar", []))

    @jsii.member(jsii_name="resetEqual")
    def reset_equal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEqual", []))

    @jsii.member(jsii_name="resetGreaterThan")
    def reset_greater_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGreaterThan", []))

    @jsii.member(jsii_name="resetLessThan")
    def reset_less_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLessThan", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfDimensionDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfDimensionDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="equal")
    def equal(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfDimensionEqualOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfDimensionEqualOutputReference, jsii.get(self, "equal"))

    @builtins.property
    @jsii.member(jsii_name="greaterThan")
    def greater_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfDimensionGreaterThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfDimensionGreaterThanOutputReference, jsii.get(self, "greaterThan"))

    @builtins.property
    @jsii.member(jsii_name="lessThan")
    def less_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfDimensionLessThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfDimensionLessThanOutputReference, jsii.get(self, "lessThan"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfDimensionDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionInput")
    def dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionVarInput")
    def dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="equalInput")
    def equal_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfDimensionEqual], jsii.get(self, "equalInput"))

    @builtins.property
    @jsii.member(jsii_name="greaterThanInput")
    def greater_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfDimensionGreaterThan], jsii.get(self, "greaterThanInput"))

    @builtins.property
    @jsii.member(jsii_name="lessThanInput")
    def less_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfDimensionLessThan], jsii.get(self, "lessThanInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="dimension")
    def dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimension"))

    @dimension.setter
    def dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2853d67b5dc0989d8dc545cf2f48e7b12fc657e4fa42f0c004e32d793e0da50c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimension", value)

    @builtins.property
    @jsii.member(jsii_name="dimensionVar")
    def dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimensionVar"))

    @dimension_var.setter
    def dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__549f4420367be2df316b4ab1f04dd369458a4a195044d6d07e7cf7ec7747cdca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__33df4e90c2f630ae7b9033854015be4a5d3a4ef1f5382eb08c0cab3c81b8d0e3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b7d196244b2ad10dcd4e417b13bfaccc3f398d6b9c44d3b1f033ec5b6af65907)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfDimension]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfDimension]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfDimension]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__33375a2b56a2f0b4d6573cf9bf365b139c477b3aaf95debea24d0922d29228dd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfOrientation",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "landscape": "landscape",
        "portrait": "portrait",
        "square": "square",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfOrientation:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfOrientationDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        landscape: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfOrientationLandscape", typing.Dict[builtins.str, typing.Any]]] = None,
        portrait: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfOrientationPortrait", typing.Dict[builtins.str, typing.Any]]] = None,
        square: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfOrientationSquare", typing.Dict[builtins.str, typing.Any]]] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param landscape: landscape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        :param portrait: portrait block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        :param square: square block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfOrientationDefault(**default)
        if isinstance(landscape, dict):
            landscape = DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfOrientationLandscape(**landscape)
        if isinstance(portrait, dict):
            portrait = DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfOrientationPortrait(**portrait)
        if isinstance(square, dict):
            square = DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfOrientationSquare(**square)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6322ce0baa2c73a410c37160886d12430bf6a9b20f4293e205919b314978f08b)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument landscape", value=landscape, expected_type=type_hints["landscape"])
            check_type(argname="argument portrait", value=portrait, expected_type=type_hints["portrait"])
            check_type(argname="argument square", value=square, expected_type=type_hints["square"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if landscape is not None:
            self._values["landscape"] = landscape
        if portrait is not None:
            self._values["portrait"] = portrait
        if square is not None:
            self._values["square"] = square

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfOrientationDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfOrientationDefault"], result)

    @builtins.property
    def landscape(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfOrientationLandscape"]:
        '''landscape block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        '''
        result = self._values.get("landscape")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfOrientationLandscape"], result)

    @builtins.property
    def portrait(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfOrientationPortrait"]:
        '''portrait block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        '''
        result = self._values.get("portrait")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfOrientationPortrait"], result)

    @builtins.property
    def square(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfOrientationSquare"]:
        '''square block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        result = self._values.get("square")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfOrientationSquare"], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfOrientation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfOrientationDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfOrientationDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfOrientationDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfOrientationDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfOrientationDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6fb85c0ea4883ef4bf5d6ff6b456bd7fbba436bd2c70caad046808ad4b7a1b6e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfOrientationDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfOrientationDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c2ba94fbeb61121d96ce65b7f4fbe1a666ec1b7e4369e8ae14f6cc3090cefaf9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfOrientationLandscape",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfOrientationLandscape:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfOrientationLandscape(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfOrientationLandscapeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfOrientationLandscapeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f2c791da24c0aedc6780d78ad322e089622398b95325cd8220b4d168f71db889)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfOrientationLandscape], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfOrientationLandscape],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4be8aa8051a603379766205907da5a20ff4247e1c1a62c549a626d9d311474af)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfOrientationList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfOrientationList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__05bad461e01dde452bdfa73375cefbd6aebd42eb90c7f66588bf4ccaddae9983)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfOrientationOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__871c3a83bbe4a27815a699c13299feb17976a5408ea2c347fd1faca4b6f6e18a)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfOrientationOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__350e7f266b76c29b53f05662ef49eb56113d24a3c097aa7dd11ad5aea7333297)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f7abe2a11bc6bfbec5cf583c56431c56520f1c04049e0f48e25100e782943b3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5b1ed857437d2595a4725315599a5335decccc6547e71b500c2112de5379a452)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfOrientation]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfOrientation]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eae7df739a81c49462fe88451c58a3047ca6b343a7a7e7fe14a11a6ebbe47aa4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfOrientationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfOrientationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8bb032a1918c42664648b541578415902b647ccdab62e7da9826fe48abeb07bf)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfOrientationDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putLandscape")
    def put_landscape(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfOrientationLandscape()

        return typing.cast(None, jsii.invoke(self, "putLandscape", [value]))

    @jsii.member(jsii_name="putPortrait")
    def put_portrait(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfOrientationPortrait()

        return typing.cast(None, jsii.invoke(self, "putPortrait", [value]))

    @jsii.member(jsii_name="putSquare")
    def put_square(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfOrientationSquare()

        return typing.cast(None, jsii.invoke(self, "putSquare", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetLandscape")
    def reset_landscape(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLandscape", []))

    @jsii.member(jsii_name="resetPortrait")
    def reset_portrait(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPortrait", []))

    @jsii.member(jsii_name="resetSquare")
    def reset_square(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSquare", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfOrientationDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfOrientationDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="landscape")
    def landscape(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfOrientationLandscapeOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfOrientationLandscapeOutputReference, jsii.get(self, "landscape"))

    @builtins.property
    @jsii.member(jsii_name="portrait")
    def portrait(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfOrientationPortraitOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfOrientationPortraitOutputReference", jsii.get(self, "portrait"))

    @builtins.property
    @jsii.member(jsii_name="square")
    def square(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfOrientationSquareOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfOrientationSquareOutputReference", jsii.get(self, "square"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfOrientationDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="landscapeInput")
    def landscape_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfOrientationLandscape], jsii.get(self, "landscapeInput"))

    @builtins.property
    @jsii.member(jsii_name="portraitInput")
    def portrait_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfOrientationPortrait"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfOrientationPortrait"], jsii.get(self, "portraitInput"))

    @builtins.property
    @jsii.member(jsii_name="squareInput")
    def square_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfOrientationSquare"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfOrientationSquare"], jsii.get(self, "squareInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfOrientation]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfOrientation]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfOrientation]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__35caeddf56ea16ef3941351900fb526786bf3a3adb7aa826bd210be223d94fab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfOrientationPortrait",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfOrientationPortrait:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfOrientationPortrait(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfOrientationPortraitOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfOrientationPortraitOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a596a5fc8ccd96d8b7b0042d992ffadc55a22f7168b6d9fb4e0d2b32d0d75f48)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfOrientationPortrait]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfOrientationPortrait], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfOrientationPortrait],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1836f964125927d9703db0dc3604a71331da050e13446f6aa203093b9856ae58)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfOrientationSquare",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfOrientationSquare:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfOrientationSquare(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfOrientationSquareOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfOrientationSquareOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c73b9ff939e3e54233176e917065adc2cd91dac507e195d3b82c65102c211136)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfOrientationSquare]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfOrientationSquare], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfOrientationSquare],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d9991f629efbd2a4a4a44d925b4ae6765b97042be1b0642ec7e4d33738a940f5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationImQuery",
    jsii_struct_bases=[],
    name_mapping={
        "allowed_transformations": "allowedTransformations",
        "query_var": "queryVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationImQuery:
    def __init__(
        self,
        *,
        allowed_transformations: typing.Sequence[builtins.str],
        query_var: builtins.str,
    ) -> None:
        '''
        :param allowed_transformations: Specifies the transformations that can be applied using the query string parameter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allowed_transformations DataAkamaiImagingPolicyImage#allowed_transformations}
        :param query_var: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#query_var DataAkamaiImagingPolicyImage#query_var}.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f6fb8e6c06ba262bffeb98438107d4227a324d1aab5d85869b8827bb3d97d77c)
            check_type(argname="argument allowed_transformations", value=allowed_transformations, expected_type=type_hints["allowed_transformations"])
            check_type(argname="argument query_var", value=query_var, expected_type=type_hints["query_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "allowed_transformations": allowed_transformations,
            "query_var": query_var,
        }

    @builtins.property
    def allowed_transformations(self) -> typing.List[builtins.str]:
        '''Specifies the transformations that can be applied using the query string parameter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allowed_transformations DataAkamaiImagingPolicyImage#allowed_transformations}
        '''
        result = self._values.get("allowed_transformations")
        assert result is not None, "Required property 'allowed_transformations' is missing"
        return typing.cast(typing.List[builtins.str], result)

    @builtins.property
    def query_var(self) -> builtins.str:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#query_var DataAkamaiImagingPolicyImage#query_var}.'''
        result = self._values.get("query_var")
        assert result is not None, "Required property 'query_var' is missing"
        return typing.cast(builtins.str, result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationImQuery(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationImQueryList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationImQueryList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__56e5d09318b1d7ae65ebef197116e9a10b607488a3bb9a36210e4e6f11e06c35)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationImQueryOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ac69af078c27965327565ee73657aea325182d6016dd3113f3093d89b42117c)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationImQueryOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4e740d2f3ee92c590978b4ba04f9789ab2bedff31412ba0622fa609a5955287d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__28b7d516ec68a019e2e13968e88c3448cb440540352f8b122c49f06ffd77badd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7ddb664e0e75328a82dfced167ad4d84f266c7be0b197d6909c0eb138009e4d4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationImQuery]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationImQuery]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationImQuery]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ba8af3cb29cc633dfd3180fdf6d6d508878ebd3a124b93e2e86197832ce27e7a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationImQueryOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationImQueryOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8e06114aee05107e62b043ce8f5499f0b25edbee2d8e3d5efd587dafe9f6f70d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @builtins.property
    @jsii.member(jsii_name="allowedTransformationsInput")
    def allowed_transformations_input(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "allowedTransformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="queryVarInput")
    def query_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "queryVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowedTransformations")
    def allowed_transformations(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "allowedTransformations"))

    @allowed_transformations.setter
    def allowed_transformations(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd4627fab9cd7336c9f759865a27056cc053a58c236b2f51af16b4e11f5af3fd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowedTransformations", value)

    @builtins.property
    @jsii.member(jsii_name="queryVar")
    def query_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "queryVar"))

    @query_var.setter
    def query_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__746f5407964b6e3795f6d0b1f59aaee99a5799efdf8f587002b9fbdac30d53ca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "queryVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationImQuery]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationImQuery]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationImQuery]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d25d6406c4aa17915212ea70e96e8863facce9791d25acfcbdfd1e02ce80a3b4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationMaxColors",
    jsii_struct_bases=[],
    name_mapping={"colors": "colors", "colors_var": "colorsVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationMaxColors:
    def __init__(
        self,
        *,
        colors: typing.Optional[builtins.str] = None,
        colors_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param colors: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        :param colors_var: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__42c1106337d32df51259eee88c64935d03f0892032978fcac75b54c02380c8e6)
            check_type(argname="argument colors", value=colors, expected_type=type_hints["colors"])
            check_type(argname="argument colors_var", value=colors_var, expected_type=type_hints["colors_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if colors is not None:
            self._values["colors"] = colors
        if colors_var is not None:
            self._values["colors_var"] = colors_var

    @builtins.property
    def colors(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        '''
        result = self._values.get("colors")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def colors_var(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        result = self._values.get("colors_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationMaxColors(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationMaxColorsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationMaxColorsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__519392fdf4715f34c792628ebccddcf6a9a170d1e4103435906e7494a804eafd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationMaxColorsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b406a3b8387eedf11e6cb46393ab7a0bb09eec8ecb6d00df657432c588a8b962)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationMaxColorsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2be6bd04f879103685c9a50c0b7b5462fbc8f04cf63b2526864367eeb09dd902)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__345504e174d05c71d8c57ed113c9544eb775b722a35ffe35534ac8d6535c8f8e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1314cfbde9d76d08a3c3c84fa6f7284dc285d048c6d8feebafd68be7e95c92c2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationMaxColors]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationMaxColors]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d8e0ca5c595f5be8af72b25cc059c09a1a5aca8c75ea1eb01942ebdbdb3385f3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationMaxColorsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationMaxColorsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be5ce23ef9a528a18cdf0802da5a3430c118d5e7040955196de634e4f16deaa9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColors")
    def reset_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColors", []))

    @jsii.member(jsii_name="resetColorsVar")
    def reset_colors_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorsVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorsInput")
    def colors_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsInput"))

    @builtins.property
    @jsii.member(jsii_name="colorsVarInput")
    def colors_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsVarInput"))

    @builtins.property
    @jsii.member(jsii_name="colors")
    def colors(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colors"))

    @colors.setter
    def colors(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__65d76f5dcf2b341b552ed188084427208a61414fe1e6ffcc93a7c90b66405558)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colors", value)

    @builtins.property
    @jsii.member(jsii_name="colorsVar")
    def colors_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorsVar"))

    @colors_var.setter
    def colors_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__42793e81364534b58e1172c7fcb5e5d4e1270fda683b5a059ac023447fedf125)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorsVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationMaxColors]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationMaxColors]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationMaxColors]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7c3c34ccace52dda0bdea2d5ffdd0a6e3577b749933081e375df9e9bf9c7abca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationMirror",
    jsii_struct_bases=[],
    name_mapping={
        "horizontal": "horizontal",
        "horizontal_var": "horizontalVar",
        "vertical": "vertical",
        "vertical_var": "verticalVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationMirror:
    def __init__(
        self,
        *,
        horizontal: typing.Optional[builtins.str] = None,
        horizontal_var: typing.Optional[builtins.str] = None,
        vertical: typing.Optional[builtins.str] = None,
        vertical_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param horizontal: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        :param horizontal_var: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        :param vertical: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        :param vertical_var: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7ba49fe06e24a604be9b757d5a2c51d4459c3a0d890ed6e65557652a45e45bc7)
            check_type(argname="argument horizontal", value=horizontal, expected_type=type_hints["horizontal"])
            check_type(argname="argument horizontal_var", value=horizontal_var, expected_type=type_hints["horizontal_var"])
            check_type(argname="argument vertical", value=vertical, expected_type=type_hints["vertical"])
            check_type(argname="argument vertical_var", value=vertical_var, expected_type=type_hints["vertical_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if horizontal is not None:
            self._values["horizontal"] = horizontal
        if horizontal_var is not None:
            self._values["horizontal_var"] = horizontal_var
        if vertical is not None:
            self._values["vertical"] = vertical
        if vertical_var is not None:
            self._values["vertical_var"] = vertical_var

    @builtins.property
    def horizontal(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        '''
        result = self._values.get("horizontal")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def horizontal_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        '''
        result = self._values.get("horizontal_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        '''
        result = self._values.get("vertical")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        result = self._values.get("vertical_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationMirror(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationMirrorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationMirrorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d678c9a402a03a08c2965fd68d1e0cc6c02eb18ae8e1906dd83f02e293926407)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationMirrorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cafb2ba587f8a6146478435b838592d8b448ce30383d87119f592612ae823888)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationMirrorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ed020364a60a701465e53c0a099bf729c1ed2a3ba35fed275b003093753bd842)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__32cf43fae02d97e53d00b5ea6bab05b361aaadecf0ff6486dcbf116ca9c9d1bc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__71da8ceda65afb8bbc9d677dc3ca264d9e21b87bf3e83fdb6e2fd472f9135a81)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationMirror]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationMirror]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c136ed9558f6f70c954917877a2834346b380d0a2bad3533d6c89c81e36fd53e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationMirrorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationMirrorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__20ec2bb492b953e221221fa3c21538dc9bc08f0e853c82667ba6d498648998a4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHorizontal")
    def reset_horizontal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontal", []))

    @jsii.member(jsii_name="resetHorizontalVar")
    def reset_horizontal_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontalVar", []))

    @jsii.member(jsii_name="resetVertical")
    def reset_vertical(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVertical", []))

    @jsii.member(jsii_name="resetVerticalVar")
    def reset_vertical_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVerticalVar", []))

    @builtins.property
    @jsii.member(jsii_name="horizontalInput")
    def horizontal_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontalVarInput")
    def horizontal_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalInput")
    def vertical_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalVarInput")
    def vertical_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontal")
    def horizontal(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontal"))

    @horizontal.setter
    def horizontal(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__522381e6d27f1517e9f070fb39f233216cfd6fa609b0fde52e00c8fde995b3a9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontal", value)

    @builtins.property
    @jsii.member(jsii_name="horizontalVar")
    def horizontal_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontalVar"))

    @horizontal_var.setter
    def horizontal_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__21e810159ffc8c6110b3857d82fbc21f3f8cebb1734c29bc3af0c3a03705545c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontalVar", value)

    @builtins.property
    @jsii.member(jsii_name="vertical")
    def vertical(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "vertical"))

    @vertical.setter
    def vertical(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__effe3fe6d85bf1000afb95799b1b6595c2f63ecf92c76912ad680963b6f7817d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "vertical", value)

    @builtins.property
    @jsii.member(jsii_name="verticalVar")
    def vertical_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "verticalVar"))

    @vertical_var.setter
    def vertical_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__58dfb07e7b8ea60cc42967cbc6128752d787d3a7523055f072f1de816948787d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "verticalVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationMirror]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationMirror]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationMirror]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f23adcea327bb9ab2334001491861c5a074a824d4e74aaca1c3d2eef4f6c1692)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationMonoHue",
    jsii_struct_bases=[],
    name_mapping={"hue": "hue", "hue_var": "hueVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationMonoHue:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f82d48740b6e438d81c2f82169625ff00147b78f7758ca0a739253aa7bff239)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationMonoHue(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationMonoHueList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationMonoHueList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b0154aa8f31f862289388be6133a5f595f06a752a51671995ff6fdb7c9da0645)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationMonoHueOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a0da851d5b40e35e5e7fc20708493485c4712858c78446145720096f4925ab15)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationMonoHueOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__732c7713c0136934151d40ad4146dd5f48fd889e7802ad7a813ea24bccd73b2c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__16666ecdc6602bd014d553c0e38ca98e202ea189452147acdc066b0da81a2c8e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b4e8f89db29c561d23ab0f0fb7a7cb46b677342681bc7652ffcfcc57c913cf05)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationMonoHue]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationMonoHue]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ea3a82c13057e53f8bcad3c74bca582bc0bf9fc6911c66578a03aa858cf4bcd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationMonoHueOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationMonoHueOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__021c7dff10da7fb96423bdf4d376584061508d2eedfaab86dc735dd0e1274aa0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__89e55f47221452284750e946dea4d574ff0456339d787facc59428b1664f61de)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__57cb33ce7b6a49270671a0f711cb23ea6ec78a92ffd88723aac7705e16f23a31)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationMonoHue]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationMonoHue]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationMonoHue]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a37eba3f8c4b41aa06fae7acd2dce2f184061704cfb21ef191648b9dd5d5450)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationOpacity",
    jsii_struct_bases=[],
    name_mapping={"opacity": "opacity", "opacity_var": "opacityVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationOpacity:
    def __init__(
        self,
        *,
        opacity: typing.Optional[builtins.str] = None,
        opacity_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param opacity: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param opacity_var: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__015f41966032178dacc1ebd6e7b6155cfe5f6fb40c818651fa8e50b92f8b9f96)
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument opacity_var", value=opacity_var, expected_type=type_hints["opacity_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if opacity is not None:
            self._values["opacity"] = opacity
        if opacity_var is not None:
            self._values["opacity_var"] = opacity_var

    @builtins.property
    def opacity(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def opacity_var(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        result = self._values.get("opacity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationOpacity(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationOpacityList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationOpacityList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c08d4369f7f637dfc8a595bd332f7e9ed0e61a6b0b82fcfd913adbcdbbccb2ad)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationOpacityOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8838f16dfe46626dff7c749528fd56fc74301d7a272ddb8fc2f38ec557c93c27)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationOpacityOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__11c03ed25b47cd81e602936b1207c7c983f64693e2b98dab3af76932a4dd6eb5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__463429f2f6600cfed9b4a632901c904f5b02225a5f7d08f9a7d273cd3f2f0911)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d5f519670d1936b6267ce67a3168b356cefe735d42faf68cbcb4539957ead232)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationOpacity]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationOpacity]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__68e652b36ccf5042ffb9080ea0d197a1e0a03fee414a3df0366ba7a13bb89cbd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationOpacityOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationOpacityOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6b564807e28227ac04f01ec159ffafa4d29a3e37011c65eb27b508b4cfd83f31)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetOpacityVar")
    def reset_opacity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacityVar", []))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityVarInput")
    def opacity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacity"))

    @opacity.setter
    def opacity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac7c8ba7ed6ee17f06d38741df296a217d9dc33fafa3a64d189824e2bf3679eb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacity", value)

    @builtins.property
    @jsii.member(jsii_name="opacityVar")
    def opacity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacityVar"))

    @opacity_var.setter
    def opacity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f6bdda2ee64a2576d3314ccd45adc5d4970b971e289086c102099e7ad0b31f17)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacityVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationOpacity]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationOpacity]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationOpacity]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__788a3efa9b9954665c289a89d69a60394175dfe967b480ea61a61f920ae93c48)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__82695e73580de9eb9d4623b8bdae25283e81d71fdaed75673c840f86f74c7792)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putAppend")
    def put_append(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationAppend, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d308fd93a6920d8bff163cb7e55e9359aa9692f46ef1cfc322ac04296a56bb4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putAppend", [value]))

    @jsii.member(jsii_name="putAspectCrop")
    def put_aspect_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationAspectCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ccf1f1774bf53dfda01fcaedbc47311c281f3338e4bfc5f19790e9221763407)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putAspectCrop", [value]))

    @jsii.member(jsii_name="putBackgroundColor")
    def put_background_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__025904b17d0dae399dd7db7b2fabb63bc53db4c81b8e818c50b5201e6de0357e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBackgroundColor", [value]))

    @jsii.member(jsii_name="putBlur")
    def put_blur(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationBlur, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4cb96cb4a1767462ef34619088382ea9a39932811838fbc95bd3cbe48cbca6d9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBlur", [value]))

    @jsii.member(jsii_name="putChromaKey")
    def put_chroma_key(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationChromaKey, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b971357b06cb7d0b264ccaefdca9f67057e0853e5707eaa8b1526e22dcacdc96)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putChromaKey", [value]))

    @jsii.member(jsii_name="putComposite")
    def put_composite(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationComposite, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3f1a517b16d93d6f0f6e512dcd2c8fdc09b8b6fb7be7fde6b424955f1332589d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putComposite", [value]))

    @jsii.member(jsii_name="putCompound")
    def put_compound(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationCompound, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8832bf5be76d8de5a49b7bb7afcc8d6be2507145752a3bc4ef3c279909c47552)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCompound", [value]))

    @jsii.member(jsii_name="putContrast")
    def put_contrast(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationContrast, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__46fd389f1696feeb8ad74738d8e99b11ad4beedc64779f3610b407e6ce036821)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putContrast", [value]))

    @jsii.member(jsii_name="putCrop")
    def put_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b8463bc7367b953b5c3e721114b201388ad17ef02f4e5224fce0698e96c311dc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCrop", [value]))

    @jsii.member(jsii_name="putFaceCrop")
    def put_face_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationFaceCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bcb72db0e9a5b52adcdb97e29a08384abf1cdb1996133be775f2b53e990cb247)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFaceCrop", [value]))

    @jsii.member(jsii_name="putFeatureCrop")
    def put_feature_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationFeatureCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e9db29472de6eaa7af43adcaa895be9caa0910d139c482e0861189e89ee3cf99)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFeatureCrop", [value]))

    @jsii.member(jsii_name="putFitAndFill")
    def put_fit_and_fill(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationFitAndFill, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__064ea2173b36233a61534f795390f0928e90b80e8804ddb967901d2466b1d28d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFitAndFill", [value]))

    @jsii.member(jsii_name="putGoop")
    def put_goop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationGoop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__744ad14e72374e5554cc78bf27fe5c035c1760284a14f36cd327621c74a2591a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGoop", [value]))

    @jsii.member(jsii_name="putGrayscale")
    def put_grayscale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationGrayscale, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4fa174d4810550fb1f67cdb69aa54f95d8e19d29108cbe12e25b018a168cb9dd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGrayscale", [value]))

    @jsii.member(jsii_name="putHsl")
    def put_hsl(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationHsl, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__43c04483d9f8cc306132ca70589f50ed0ebbfaba6535533c23006221220f2676)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsl", [value]))

    @jsii.member(jsii_name="putHsv")
    def put_hsv(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationHsv, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4124fd33b4cea87aa3a4f41bdcca3c58b8679c6778607f0a6009d4de89d6dc77)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsv", [value]))

    @jsii.member(jsii_name="putIfDimension")
    def put_if_dimension(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfDimension, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__17edd892139617f98f788fe25c7b9c1582d906f97c3b962dc74ab4346b25574a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfDimension", [value]))

    @jsii.member(jsii_name="putIfOrientation")
    def put_if_orientation(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__054e2057b3e01ca40bdeece07744f8978dfab023ba19e65aac9b973abfe75df7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfOrientation", [value]))

    @jsii.member(jsii_name="putImQuery")
    def put_im_query(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationImQuery, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dc1f124fda43d33cc1d49a1d812bdd6496f6759df9bb3c850e4aa643966bbdda)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putImQuery", [value]))

    @jsii.member(jsii_name="putMaxColors")
    def put_max_colors(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationMaxColors, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4d0c8d031224c104310cdded563035f3495167e6fdd5b2d7e417e9fbc98423a3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMaxColors", [value]))

    @jsii.member(jsii_name="putMirror")
    def put_mirror(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationMirror, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e2442e5c6943a20a6fb70989706129374b04b9a02ab1b311a4b0e908ebb63e1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMirror", [value]))

    @jsii.member(jsii_name="putMonoHue")
    def put_mono_hue(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationMonoHue, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f8044cbc26784cf499e1b1f1b2f8a824ff191aaac70d3ae407574ba164fe0c5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMonoHue", [value]))

    @jsii.member(jsii_name="putOpacity")
    def put_opacity(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationOpacity, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4690947be38db44510198c04f58f85e5468d7c2062c3871a83b54b5839d81bd1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putOpacity", [value]))

    @jsii.member(jsii_name="putRegionOfInterestCrop")
    def put_region_of_interest_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationRegionOfInterestCrop", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a904b318d215bf8834248a12ddd472a6bdf248ec1e1021498f753ac1c684030e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRegionOfInterestCrop", [value]))

    @jsii.member(jsii_name="putRelativeCrop")
    def put_relative_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationRelativeCrop", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be541c7d4ae12aced41e1c848db741fdc4812a6213a29d87745af28cc3f9bf3d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRelativeCrop", [value]))

    @jsii.member(jsii_name="putRemoveColor")
    def put_remove_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationRemoveColor", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f0d673b760294c0e6874800f1607c38a5ffe8097cdc610ef13102497117f5b74)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRemoveColor", [value]))

    @jsii.member(jsii_name="putResize")
    def put_resize(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationResize", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bf69b606d8d5224ce0bc455883ee465323e62eb084a3e4c89e368baba249d795)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putResize", [value]))

    @jsii.member(jsii_name="putRotate")
    def put_rotate(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationRotate", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__393bb9669dddb28ce719590aee8b840e8ff2b3cdc56d54d6944475862c17b835)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRotate", [value]))

    @jsii.member(jsii_name="putScale")
    def put_scale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationScale", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bab25a3dbf5822abc0cbadb51bffd2d2e17a1f4c10da5686abed43a39777e00f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putScale", [value]))

    @jsii.member(jsii_name="putShear")
    def put_shear(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationShear", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8886126145b3cdb5a883c3570955b5506413ff06cf753354fe3106c573f8baef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putShear", [value]))

    @jsii.member(jsii_name="putTrim")
    def put_trim(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationTrim", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__89e090e92d7272ca105d3747d39815369aa51331fc40cadd1340467427c462a9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTrim", [value]))

    @jsii.member(jsii_name="putUnsharpMask")
    def put_unsharp_mask(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationUnsharpMask", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f45fea574e488c2aafcfe0e2de3b73498e896fb5d14ccdabcad2ed7cb5337967)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putUnsharpMask", [value]))

    @jsii.member(jsii_name="resetAppend")
    def reset_append(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAppend", []))

    @jsii.member(jsii_name="resetAspectCrop")
    def reset_aspect_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspectCrop", []))

    @jsii.member(jsii_name="resetBackgroundColor")
    def reset_background_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBackgroundColor", []))

    @jsii.member(jsii_name="resetBlur")
    def reset_blur(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBlur", []))

    @jsii.member(jsii_name="resetChromaKey")
    def reset_chroma_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChromaKey", []))

    @jsii.member(jsii_name="resetComposite")
    def reset_composite(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetComposite", []))

    @jsii.member(jsii_name="resetCompound")
    def reset_compound(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCompound", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetCrop")
    def reset_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCrop", []))

    @jsii.member(jsii_name="resetFaceCrop")
    def reset_face_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFaceCrop", []))

    @jsii.member(jsii_name="resetFeatureCrop")
    def reset_feature_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureCrop", []))

    @jsii.member(jsii_name="resetFitAndFill")
    def reset_fit_and_fill(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFitAndFill", []))

    @jsii.member(jsii_name="resetGoop")
    def reset_goop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGoop", []))

    @jsii.member(jsii_name="resetGrayscale")
    def reset_grayscale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGrayscale", []))

    @jsii.member(jsii_name="resetHsl")
    def reset_hsl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsl", []))

    @jsii.member(jsii_name="resetHsv")
    def reset_hsv(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsv", []))

    @jsii.member(jsii_name="resetIfDimension")
    def reset_if_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfDimension", []))

    @jsii.member(jsii_name="resetIfOrientation")
    def reset_if_orientation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfOrientation", []))

    @jsii.member(jsii_name="resetImQuery")
    def reset_im_query(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetImQuery", []))

    @jsii.member(jsii_name="resetMaxColors")
    def reset_max_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxColors", []))

    @jsii.member(jsii_name="resetMirror")
    def reset_mirror(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMirror", []))

    @jsii.member(jsii_name="resetMonoHue")
    def reset_mono_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonoHue", []))

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetRegionOfInterestCrop")
    def reset_region_of_interest_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRegionOfInterestCrop", []))

    @jsii.member(jsii_name="resetRelativeCrop")
    def reset_relative_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRelativeCrop", []))

    @jsii.member(jsii_name="resetRemoveColor")
    def reset_remove_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRemoveColor", []))

    @jsii.member(jsii_name="resetResize")
    def reset_resize(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetResize", []))

    @jsii.member(jsii_name="resetRotate")
    def reset_rotate(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRotate", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetShear")
    def reset_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetShear", []))

    @jsii.member(jsii_name="resetTrim")
    def reset_trim(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTrim", []))

    @jsii.member(jsii_name="resetUnsharpMask")
    def reset_unsharp_mask(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUnsharpMask", []))

    @builtins.property
    @jsii.member(jsii_name="append")
    def append(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationAppendList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationAppendList, jsii.get(self, "append"))

    @builtins.property
    @jsii.member(jsii_name="aspectCrop")
    def aspect_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationAspectCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationAspectCropList, jsii.get(self, "aspectCrop"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColor")
    def background_color(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationBackgroundColorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationBackgroundColorList, jsii.get(self, "backgroundColor"))

    @builtins.property
    @jsii.member(jsii_name="blur")
    def blur(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationBlurList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationBlurList, jsii.get(self, "blur"))

    @builtins.property
    @jsii.member(jsii_name="chromaKey")
    def chroma_key(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationChromaKeyList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationChromaKeyList, jsii.get(self, "chromaKey"))

    @builtins.property
    @jsii.member(jsii_name="composite")
    def composite(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationCompositeList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationCompositeList, jsii.get(self, "composite"))

    @builtins.property
    @jsii.member(jsii_name="compound")
    def compound(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationCompoundList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationCompoundList, jsii.get(self, "compound"))

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationContrastList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationContrastList, jsii.get(self, "contrast"))

    @builtins.property
    @jsii.member(jsii_name="crop")
    def crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationCropList, jsii.get(self, "crop"))

    @builtins.property
    @jsii.member(jsii_name="faceCrop")
    def face_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationFaceCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationFaceCropList, jsii.get(self, "faceCrop"))

    @builtins.property
    @jsii.member(jsii_name="featureCrop")
    def feature_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationFeatureCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationFeatureCropList, jsii.get(self, "featureCrop"))

    @builtins.property
    @jsii.member(jsii_name="fitAndFill")
    def fit_and_fill(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationFitAndFillList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationFitAndFillList, jsii.get(self, "fitAndFill"))

    @builtins.property
    @jsii.member(jsii_name="goop")
    def goop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationGoopList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationGoopList, jsii.get(self, "goop"))

    @builtins.property
    @jsii.member(jsii_name="grayscale")
    def grayscale(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationGrayscaleList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationGrayscaleList, jsii.get(self, "grayscale"))

    @builtins.property
    @jsii.member(jsii_name="hsl")
    def hsl(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationHslList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationHslList, jsii.get(self, "hsl"))

    @builtins.property
    @jsii.member(jsii_name="hsv")
    def hsv(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationHsvList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationHsvList, jsii.get(self, "hsv"))

    @builtins.property
    @jsii.member(jsii_name="ifDimension")
    def if_dimension(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfDimensionList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfDimensionList, jsii.get(self, "ifDimension"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientation")
    def if_orientation(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfOrientationList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfOrientationList, jsii.get(self, "ifOrientation"))

    @builtins.property
    @jsii.member(jsii_name="imQuery")
    def im_query(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationImQueryList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationImQueryList, jsii.get(self, "imQuery"))

    @builtins.property
    @jsii.member(jsii_name="maxColors")
    def max_colors(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationMaxColorsList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationMaxColorsList, jsii.get(self, "maxColors"))

    @builtins.property
    @jsii.member(jsii_name="mirror")
    def mirror(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationMirrorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationMirrorList, jsii.get(self, "mirror"))

    @builtins.property
    @jsii.member(jsii_name="monoHue")
    def mono_hue(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationMonoHueList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationMonoHueList, jsii.get(self, "monoHue"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationOpacityList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationOpacityList, jsii.get(self, "opacity"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestCrop")
    def region_of_interest_crop(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationRegionOfInterestCropList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationRegionOfInterestCropList", jsii.get(self, "regionOfInterestCrop"))

    @builtins.property
    @jsii.member(jsii_name="relativeCrop")
    def relative_crop(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationRelativeCropList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationRelativeCropList", jsii.get(self, "relativeCrop"))

    @builtins.property
    @jsii.member(jsii_name="removeColor")
    def remove_color(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationRemoveColorList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationRemoveColorList", jsii.get(self, "removeColor"))

    @builtins.property
    @jsii.member(jsii_name="resize")
    def resize(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationResizeList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationResizeList", jsii.get(self, "resize"))

    @builtins.property
    @jsii.member(jsii_name="rotate")
    def rotate(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationRotateList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationRotateList", jsii.get(self, "rotate"))

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationScaleList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationScaleList", jsii.get(self, "scale"))

    @builtins.property
    @jsii.member(jsii_name="shear")
    def shear(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationShearList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationShearList", jsii.get(self, "shear"))

    @builtins.property
    @jsii.member(jsii_name="trim")
    def trim(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationTrimList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationTrimList", jsii.get(self, "trim"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMask")
    def unsharp_mask(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationUnsharpMaskList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationUnsharpMaskList", jsii.get(self, "unsharpMask"))

    @builtins.property
    @jsii.member(jsii_name="appendInput")
    def append_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationAppend]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationAppend]]], jsii.get(self, "appendInput"))

    @builtins.property
    @jsii.member(jsii_name="aspectCropInput")
    def aspect_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationAspectCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationAspectCrop]]], jsii.get(self, "aspectCropInput"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColorInput")
    def background_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationBackgroundColor]]], jsii.get(self, "backgroundColorInput"))

    @builtins.property
    @jsii.member(jsii_name="blurInput")
    def blur_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationBlur]]], jsii.get(self, "blurInput"))

    @builtins.property
    @jsii.member(jsii_name="chromaKeyInput")
    def chroma_key_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationChromaKey]]], jsii.get(self, "chromaKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="compositeInput")
    def composite_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationComposite]]], jsii.get(self, "compositeInput"))

    @builtins.property
    @jsii.member(jsii_name="compoundInput")
    def compound_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationCompound]]], jsii.get(self, "compoundInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationContrast]]], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="cropInput")
    def crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationCrop]]], jsii.get(self, "cropInput"))

    @builtins.property
    @jsii.member(jsii_name="faceCropInput")
    def face_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationFaceCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationFaceCrop]]], jsii.get(self, "faceCropInput"))

    @builtins.property
    @jsii.member(jsii_name="featureCropInput")
    def feature_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationFeatureCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationFeatureCrop]]], jsii.get(self, "featureCropInput"))

    @builtins.property
    @jsii.member(jsii_name="fitAndFillInput")
    def fit_and_fill_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationFitAndFill]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationFitAndFill]]], jsii.get(self, "fitAndFillInput"))

    @builtins.property
    @jsii.member(jsii_name="goopInput")
    def goop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationGoop]]], jsii.get(self, "goopInput"))

    @builtins.property
    @jsii.member(jsii_name="grayscaleInput")
    def grayscale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationGrayscale]]], jsii.get(self, "grayscaleInput"))

    @builtins.property
    @jsii.member(jsii_name="hslInput")
    def hsl_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationHsl]]], jsii.get(self, "hslInput"))

    @builtins.property
    @jsii.member(jsii_name="hsvInput")
    def hsv_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationHsv]]], jsii.get(self, "hsvInput"))

    @builtins.property
    @jsii.member(jsii_name="ifDimensionInput")
    def if_dimension_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfDimension]]], jsii.get(self, "ifDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientationInput")
    def if_orientation_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfOrientation]]], jsii.get(self, "ifOrientationInput"))

    @builtins.property
    @jsii.member(jsii_name="imQueryInput")
    def im_query_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationImQuery]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationImQuery]]], jsii.get(self, "imQueryInput"))

    @builtins.property
    @jsii.member(jsii_name="maxColorsInput")
    def max_colors_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationMaxColors]]], jsii.get(self, "maxColorsInput"))

    @builtins.property
    @jsii.member(jsii_name="mirrorInput")
    def mirror_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationMirror]]], jsii.get(self, "mirrorInput"))

    @builtins.property
    @jsii.member(jsii_name="monoHueInput")
    def mono_hue_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationMonoHue]]], jsii.get(self, "monoHueInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationOpacity]]], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestCropInput")
    def region_of_interest_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationRegionOfInterestCrop"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationRegionOfInterestCrop"]]], jsii.get(self, "regionOfInterestCropInput"))

    @builtins.property
    @jsii.member(jsii_name="relativeCropInput")
    def relative_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationRelativeCrop"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationRelativeCrop"]]], jsii.get(self, "relativeCropInput"))

    @builtins.property
    @jsii.member(jsii_name="removeColorInput")
    def remove_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationRemoveColor"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationRemoveColor"]]], jsii.get(self, "removeColorInput"))

    @builtins.property
    @jsii.member(jsii_name="resizeInput")
    def resize_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationResize"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationResize"]]], jsii.get(self, "resizeInput"))

    @builtins.property
    @jsii.member(jsii_name="rotateInput")
    def rotate_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationRotate"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationRotate"]]], jsii.get(self, "rotateInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationScale"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationScale"]]], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="shearInput")
    def shear_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationShear"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationShear"]]], jsii.get(self, "shearInput"))

    @builtins.property
    @jsii.member(jsii_name="trimInput")
    def trim_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationTrim"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationTrim"]]], jsii.get(self, "trimInput"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMaskInput")
    def unsharp_mask_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationUnsharpMask"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationUnsharpMask"]]], jsii.get(self, "unsharpMaskInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1e553c5931f5b3f0c59f269eaed5647559aba36c29d9972d08ee03e84c63fe56)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationRegionOfInterestCrop",
    jsii_struct_bases=[],
    name_mapping={
        "region_of_interest": "regionOfInterest",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationRegionOfInterestCrop:
    def __init__(
        self,
        *,
        region_of_interest: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationRegionOfInterestCropRegionOfInterest", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param region_of_interest: region_of_interest block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest DataAkamaiImagingPolicyImage#region_of_interest}
        :param gravity: The placement of the crop area relative to the specified area of interest. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: The placement of the crop area relative to the specified area of interest. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param style: Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(region_of_interest, dict):
            region_of_interest = DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationRegionOfInterestCropRegionOfInterest(**region_of_interest)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f126b74d404a46cc5a3db36b82bb5f35765adf5160d98fdfbf288a9800ad3f0b)
            check_type(argname="argument region_of_interest", value=region_of_interest, expected_type=type_hints["region_of_interest"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "region_of_interest": region_of_interest,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def region_of_interest(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationRegionOfInterestCropRegionOfInterest":
        '''region_of_interest block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest DataAkamaiImagingPolicyImage#region_of_interest}
        '''
        result = self._values.get("region_of_interest")
        assert result is not None, "Required property 'region_of_interest' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationRegionOfInterestCropRegionOfInterest", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''The placement of the crop area relative to the specified area of interest.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''The placement of the crop area relative to the specified area of interest.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationRegionOfInterestCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationRegionOfInterestCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationRegionOfInterestCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e2ab9b1e9ef80539985e741b1e636bedd1f40fe4d7e8bf5ef6a0dee28cf92cee)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationRegionOfInterestCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__02950378e2d42307bdf0323e61b435c7ce6e66f1d6c290505ab232266a10af5f)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationRegionOfInterestCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__991004422550dea7f9a7a4614caa1da9a8b7593909fd1618d3f3dc642352ee51)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c5a57db6ef1cd531252e43a1d0d164a7a9844841e026a22def28917d51b6d7b4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b424a034e7c30cf433d4e9005af35c9a4e9f07d1f4ee0c28b16d865b917125b2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationRegionOfInterestCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationRegionOfInterestCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationRegionOfInterestCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4f1f7961c4e494eaf4e1ed6524e0ed286081971424b7ebbe9324f1e340aff51e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationRegionOfInterestCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationRegionOfInterestCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__198266631d338f9515c5efcbcbd83d763f2540de42248debf87dc463454a8a9e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putRegionOfInterest")
    def put_region_of_interest(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationRegionOfInterestCropRegionOfInterest()

        return typing.cast(None, jsii.invoke(self, "putRegionOfInterest", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterest")
    def region_of_interest(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationRegionOfInterestCropRegionOfInterestOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationRegionOfInterestCropRegionOfInterestOutputReference", jsii.get(self, "regionOfInterest"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestInput")
    def region_of_interest_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationRegionOfInterestCropRegionOfInterest"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationRegionOfInterestCropRegionOfInterest"], jsii.get(self, "regionOfInterestInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__50b4b474553eed98207b4408208be5879f27deccf3a52900906bcc1d476c4134)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__936ae7c0b361ae1401f6a0488bd6e4ea03594650d4be910e0aafc6c0756aca71)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1865b7206d882452dd66dfd60a829a3d08bb5a5c712bf5b8757706de3e32c62a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f027a33e601f317e8c2015d618f8e599bc38041c2f6b2fb825c9d242803fc6d1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__149f32913a657d9f8768c86e3c030083ad2911c53c620928e78f04208de5d831)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cf604ae238f05fe6ffb0bbf828cffd9567a9c029a81b84832376e12f72b9d6aa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ff716a30c02524479186e17ec95b14e2160933e9edfc84a3917c3a2f09427c3c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5a5237431952d2029c5a9fa9787c7eb68fa3e791dc303e5d39c93594389004d0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationRegionOfInterestCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationRegionOfInterestCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationRegionOfInterestCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__32cee28ce55c5cbd20a69d13f224e23b2c04a5c4cdf3eef9b251130f81f84ce8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationRegionOfInterestCropRegionOfInterest",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationRegionOfInterestCropRegionOfInterest:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationRegionOfInterestCropRegionOfInterest(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationRegionOfInterestCropRegionOfInterestOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationRegionOfInterestCropRegionOfInterestOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__383be52998d64487cb5dc71f1365708dcacbed04e45255a039c550d843306b18)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationRegionOfInterestCropRegionOfInterest]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationRegionOfInterestCropRegionOfInterest], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationRegionOfInterestCropRegionOfInterest],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9142dbfcd89398b85ebf3256c52698a2128c797c18c35ac7e1e728bf8b5199eb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationRelativeCrop",
    jsii_struct_bases=[],
    name_mapping={
        "east": "east",
        "east_var": "eastVar",
        "north": "north",
        "north_var": "northVar",
        "south": "south",
        "south_var": "southVar",
        "west": "west",
        "west_var": "westVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationRelativeCrop:
    def __init__(
        self,
        *,
        east: typing.Optional[builtins.str] = None,
        east_var: typing.Optional[builtins.str] = None,
        north: typing.Optional[builtins.str] = None,
        north_var: typing.Optional[builtins.str] = None,
        south: typing.Optional[builtins.str] = None,
        south_var: typing.Optional[builtins.str] = None,
        west: typing.Optional[builtins.str] = None,
        west_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param east: The number of pixels to shrink or expand the right side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east DataAkamaiImagingPolicyImage#east}
        :param east_var: The number of pixels to shrink or expand the right side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east_var DataAkamaiImagingPolicyImage#east_var}
        :param north: The number of pixels to shrink or expand the top side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north DataAkamaiImagingPolicyImage#north}
        :param north_var: The number of pixels to shrink or expand the top side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north_var DataAkamaiImagingPolicyImage#north_var}
        :param south: The number of pixels to shrink or expand the bottom side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south DataAkamaiImagingPolicyImage#south}
        :param south_var: The number of pixels to shrink or expand the bottom side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south_var DataAkamaiImagingPolicyImage#south_var}
        :param west: The number of pixels to shrink or expand the left side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west DataAkamaiImagingPolicyImage#west}
        :param west_var: The number of pixels to shrink or expand the left side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west_var DataAkamaiImagingPolicyImage#west_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c9976949944abc80ff33e849ad5ad65471c186ee3705bd7000627a5b37b2e728)
            check_type(argname="argument east", value=east, expected_type=type_hints["east"])
            check_type(argname="argument east_var", value=east_var, expected_type=type_hints["east_var"])
            check_type(argname="argument north", value=north, expected_type=type_hints["north"])
            check_type(argname="argument north_var", value=north_var, expected_type=type_hints["north_var"])
            check_type(argname="argument south", value=south, expected_type=type_hints["south"])
            check_type(argname="argument south_var", value=south_var, expected_type=type_hints["south_var"])
            check_type(argname="argument west", value=west, expected_type=type_hints["west"])
            check_type(argname="argument west_var", value=west_var, expected_type=type_hints["west_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if east is not None:
            self._values["east"] = east
        if east_var is not None:
            self._values["east_var"] = east_var
        if north is not None:
            self._values["north"] = north
        if north_var is not None:
            self._values["north_var"] = north_var
        if south is not None:
            self._values["south"] = south
        if south_var is not None:
            self._values["south_var"] = south_var
        if west is not None:
            self._values["west"] = west
        if west_var is not None:
            self._values["west_var"] = west_var

    @builtins.property
    def east(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the right side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east DataAkamaiImagingPolicyImage#east}
        '''
        result = self._values.get("east")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def east_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the right side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east_var DataAkamaiImagingPolicyImage#east_var}
        '''
        result = self._values.get("east_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def north(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the top side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north DataAkamaiImagingPolicyImage#north}
        '''
        result = self._values.get("north")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def north_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the top side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north_var DataAkamaiImagingPolicyImage#north_var}
        '''
        result = self._values.get("north_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def south(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the bottom side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south DataAkamaiImagingPolicyImage#south}
        '''
        result = self._values.get("south")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def south_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the bottom side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south_var DataAkamaiImagingPolicyImage#south_var}
        '''
        result = self._values.get("south_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def west(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the left side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west DataAkamaiImagingPolicyImage#west}
        '''
        result = self._values.get("west")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def west_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the left side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west_var DataAkamaiImagingPolicyImage#west_var}
        '''
        result = self._values.get("west_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationRelativeCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationRelativeCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationRelativeCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__308244057da3cfeff3373575a367d09899c6b80b822644a4a3a76f815b153fbd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationRelativeCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4262cac6e9304c75ee1f0b3327c7ae8e46cfb07505a8a102908ed262001b6dbd)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationRelativeCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cc0c6735145e29d1d3d0fffc1ace213e3354c6c91021c3ee21201a50ce846c7e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__759fdb35951d542c72f79cd240240f66528796c27256b2c2fe0247c645dcd2d4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0c8575e8d63f639cd0c799381b90158332d9e35ab935b0649abbc58b4c935798)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationRelativeCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationRelativeCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationRelativeCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fb0b067c4c51f3904bc187904207cbda32a121682a522f206406b7e943e99d14)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationRelativeCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationRelativeCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dada95568ab3be23ac8a5ac0fef6635d4a91654c68174fecdbf11948ec59a376)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetEast")
    def reset_east(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEast", []))

    @jsii.member(jsii_name="resetEastVar")
    def reset_east_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEastVar", []))

    @jsii.member(jsii_name="resetNorth")
    def reset_north(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNorth", []))

    @jsii.member(jsii_name="resetNorthVar")
    def reset_north_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNorthVar", []))

    @jsii.member(jsii_name="resetSouth")
    def reset_south(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSouth", []))

    @jsii.member(jsii_name="resetSouthVar")
    def reset_south_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSouthVar", []))

    @jsii.member(jsii_name="resetWest")
    def reset_west(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWest", []))

    @jsii.member(jsii_name="resetWestVar")
    def reset_west_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWestVar", []))

    @builtins.property
    @jsii.member(jsii_name="eastInput")
    def east_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "eastInput"))

    @builtins.property
    @jsii.member(jsii_name="eastVarInput")
    def east_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "eastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="northInput")
    def north_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "northInput"))

    @builtins.property
    @jsii.member(jsii_name="northVarInput")
    def north_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "northVarInput"))

    @builtins.property
    @jsii.member(jsii_name="southInput")
    def south_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "southInput"))

    @builtins.property
    @jsii.member(jsii_name="southVarInput")
    def south_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "southVarInput"))

    @builtins.property
    @jsii.member(jsii_name="westInput")
    def west_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "westInput"))

    @builtins.property
    @jsii.member(jsii_name="westVarInput")
    def west_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "westVarInput"))

    @builtins.property
    @jsii.member(jsii_name="east")
    def east(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "east"))

    @east.setter
    def east(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b2ee4aabf2fdfaa86fb3debe59cb57bc010031de40ec0105c3ef188f36525568)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "east", value)

    @builtins.property
    @jsii.member(jsii_name="eastVar")
    def east_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "eastVar"))

    @east_var.setter
    def east_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e3cf10c55b0389e0dad814db66d1e3ccceedf3099f6ee8d2c15ccf6fd6d29f5e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "eastVar", value)

    @builtins.property
    @jsii.member(jsii_name="north")
    def north(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "north"))

    @north.setter
    def north(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__24a482008734d11c7bb6d7adc8e1ba5cd2fc17ebeb6ca92354eec041c29dbbc1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "north", value)

    @builtins.property
    @jsii.member(jsii_name="northVar")
    def north_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "northVar"))

    @north_var.setter
    def north_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b0eadb6d3a8d35a25156b30eb69b3b3b9a4335f8db684a761daaa11534de0e39)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "northVar", value)

    @builtins.property
    @jsii.member(jsii_name="south")
    def south(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "south"))

    @south.setter
    def south(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8df2828020ab1c646155832e88780f91e276e063a404ce2e2412b82c1ae79853)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "south", value)

    @builtins.property
    @jsii.member(jsii_name="southVar")
    def south_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "southVar"))

    @south_var.setter
    def south_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9766c461724bb9e3a251adf427d4fbd1eab53de6d5024583dce312777fb6e275)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "southVar", value)

    @builtins.property
    @jsii.member(jsii_name="west")
    def west(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "west"))

    @west.setter
    def west(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d0cffd8a93973b7546588e92ee18453f4eb0b8d4813f62352d88bb6e8c365e87)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "west", value)

    @builtins.property
    @jsii.member(jsii_name="westVar")
    def west_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "westVar"))

    @west_var.setter
    def west_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c38891fbfe50518289cfe7e5c8dd9d581e6dfbd3c4d2ff04240f5cb8beb7c7ec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "westVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationRelativeCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationRelativeCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationRelativeCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7879b25baf5cfc8a6b3c6ef3ffd5f14081fa750b8048e9e88831457e68c815c8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationRemoveColor",
    jsii_struct_bases=[],
    name_mapping={
        "color": "color",
        "color_var": "colorVar",
        "feather": "feather",
        "feather_var": "featherVar",
        "tolerance": "tolerance",
        "tolerance_var": "toleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationRemoveColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
        feather: typing.Optional[builtins.str] = None,
        feather_var: typing.Optional[builtins.str] = None,
        tolerance: typing.Optional[builtins.str] = None,
        tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        :param feather: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        :param feather_var: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        :param tolerance: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        :param tolerance_var: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d6aa14027c9239c1a32d6c28c9a0adf6f89cd0e8d18fc2a8243c5a097684bd8c)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
            check_type(argname="argument feather", value=feather, expected_type=type_hints["feather"])
            check_type(argname="argument feather_var", value=feather_var, expected_type=type_hints["feather_var"])
            check_type(argname="argument tolerance", value=tolerance, expected_type=type_hints["tolerance"])
            check_type(argname="argument tolerance_var", value=tolerance_var, expected_type=type_hints["tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var
        if feather is not None:
            self._values["feather"] = feather
        if feather_var is not None:
            self._values["feather_var"] = feather_var
        if tolerance is not None:
            self._values["tolerance"] = tolerance
        if tolerance_var is not None:
            self._values["tolerance_var"] = tolerance_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        '''
        result = self._values.get("feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather_var(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        '''
        result = self._values.get("feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        '''
        result = self._values.get("tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance_var(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        result = self._values.get("tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationRemoveColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationRemoveColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationRemoveColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__840926818164a5a32cbcad1240960038b3180e599006e253ae0fcbf8cbbede40)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationRemoveColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac771d2d4242a5feba968eaa1aa17d516398add6cd5fe901089f50ea2056e3c0)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationRemoveColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b5672e76a860fa2bbca480d6a6ca469baf2e2399cabe94d739dbe9df999aaeb0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f1ab34594d1b1ff8b045905c3c9ed241c1d861d00b1c231fb180f2b9514edf81)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa5f30b0e04f2439277d5816568b5439ad624226d4dc813a7e556f25dfd813c6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationRemoveColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationRemoveColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationRemoveColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9379b631897be1b5b02613639a1d25620abd4a4a01b5fa44e0db09a48f19c2f8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationRemoveColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationRemoveColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e8f336605ee0546ab38c677fb4de3bc3a91ddbd983f047378042ffafcc933068)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @jsii.member(jsii_name="resetFeather")
    def reset_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeather", []))

    @jsii.member(jsii_name="resetFeatherVar")
    def reset_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatherVar", []))

    @jsii.member(jsii_name="resetTolerance")
    def reset_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTolerance", []))

    @jsii.member(jsii_name="resetToleranceVar")
    def reset_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featherInput")
    def feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherInput"))

    @builtins.property
    @jsii.member(jsii_name="featherVarInput")
    def feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceInput")
    def tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceVarInput")
    def tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__58110853affb9e112f298581d42f3cb964b8e8b0d093dde0a05cc7d9e9634fbe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ecf7b8d0f8cc4f882e86fd9258a042f0931fc1030730b8615edb7ebb2bcc0e58)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="feather")
    def feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "feather"))

    @feather.setter
    def feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3572f69b4e88e638100383836287861431de303a06e39bb2be9f67916050e774)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "feather", value)

    @builtins.property
    @jsii.member(jsii_name="featherVar")
    def feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featherVar"))

    @feather_var.setter
    def feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d406ff9061c10da3342a1d67c697667434c8b6a1e2364f7c179436ad5f890f58)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featherVar", value)

    @builtins.property
    @jsii.member(jsii_name="tolerance")
    def tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tolerance"))

    @tolerance.setter
    def tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__51f56cfb1f0e9cd4e9b10139487f6cab3825b955065bc9ee00fd9c6c52a0ce99)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tolerance", value)

    @builtins.property
    @jsii.member(jsii_name="toleranceVar")
    def tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "toleranceVar"))

    @tolerance_var.setter
    def tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f4208e392029df00bc89949bea4acb8b19fd4539371ed41c530b3313c8549754)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "toleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationRemoveColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationRemoveColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationRemoveColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2b522411c176aadbddaf3d56da02199800989e440355d926bd64ffa8610ff5f8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationResize",
    jsii_struct_bases=[],
    name_mapping={
        "aspect": "aspect",
        "aspect_var": "aspectVar",
        "height": "height",
        "height_var": "heightVar",
        "type": "type",
        "type_var": "typeVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationResize:
    def __init__(
        self,
        *,
        aspect: typing.Optional[builtins.str] = None,
        aspect_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param aspect: Preserves the aspect ratio. Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect DataAkamaiImagingPolicyImage#aspect}
        :param aspect_var: Preserves the aspect ratio. Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_var DataAkamaiImagingPolicyImage#aspect_var}
        :param height: The height to resize the source image to. Must be set if height is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height to resize the source image to. Must be set if height is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param type: Sets constraints for the image resize. Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: Sets constraints for the image resize. Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        :param width: The width to resize the source image to. Must be set if width is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width to resize the source image to. Must be set if width is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0cd38db3f6b702538ec5b5977d17ede2b9e2cd6382dc74d14a2d2355a545c002)
            check_type(argname="argument aspect", value=aspect, expected_type=type_hints["aspect"])
            check_type(argname="argument aspect_var", value=aspect_var, expected_type=type_hints["aspect_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if aspect is not None:
            self._values["aspect"] = aspect
        if aspect_var is not None:
            self._values["aspect_var"] = aspect_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def aspect(self) -> typing.Optional[builtins.str]:
        '''Preserves the aspect ratio.

        Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect DataAkamaiImagingPolicyImage#aspect}
        '''
        result = self._values.get("aspect")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def aspect_var(self) -> typing.Optional[builtins.str]:
        '''Preserves the aspect ratio.

        Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_var DataAkamaiImagingPolicyImage#aspect_var}
        '''
        result = self._values.get("aspect_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height to resize the source image to. Must be set if height is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height to resize the source image to. Must be set if height is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''Sets constraints for the image resize.

        Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''Sets constraints for the image resize.

        Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width to resize the source image to. Must be set if width is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width to resize the source image to. Must be set if width is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationResize(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationResizeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationResizeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7b1334f5bbcf35c1c6930b985b504456ad078dfba1969b24f61ef38e0f7b51b9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationResizeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f99b60c007e6ac800bb501cf6fa80a802a234a99a834b05f8059750435964c8)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationResizeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ef180cb7b1fc282f5da4d6ecb54976e108db0d4ffc936ba3b7c6593dca3ff59b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__48de6f168c18058196e07184f3b1c4d24e3721fb1510d96c43b3d8b765a93c62)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c78f393eadf6ebb91952c4c0b52575ef6a79ded27d866f42049559dc4c01f5bc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationResize]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationResize]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationResize]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2383b8d09b05c7dffd859610e5b2ff7228aa53014666b12d0a6ac6e7dcfe4bd6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationResizeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationResizeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6ebacf6d72e188506d79ad10ddb02cc0d83256885a4cee985ae87dc77d675c5e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAspect")
    def reset_aspect(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspect", []))

    @jsii.member(jsii_name="resetAspectVar")
    def reset_aspect_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspectVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="aspectInput")
    def aspect_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "aspectInput"))

    @builtins.property
    @jsii.member(jsii_name="aspectVarInput")
    def aspect_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "aspectVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="aspect")
    def aspect(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "aspect"))

    @aspect.setter
    def aspect(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__39f46c9c6a8868a20f96463841ef3ae9b58e60e4a7dd162ce86fec6e2256f290)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "aspect", value)

    @builtins.property
    @jsii.member(jsii_name="aspectVar")
    def aspect_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "aspectVar"))

    @aspect_var.setter
    def aspect_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c061a85ed834ebb35bc7968c73cd37c05f50a1c950b648d6507d4a00b57f0f20)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "aspectVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f1341fce133b420def97118ce865433a6e54f1bb49cfe759e4c55e9c9b3fca9d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__07b1ffea8df90fea690f407dfd3ea9ba066ea63d5c83f1e9149b65754a50aa7a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__983393fc92d618f0e67580688bb77fd26232bc402d589846bd016ca6a6eb2c87)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cfe68a599f6f6773ac4bdf244c9bea67612d807a06ba5077eec5b1a020de188f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__12b36ea0c8233ece7872aefdc6f94fbadb0f277c7a5f53f1b5d1c536865e59ce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__49a0d98b634a39052bc6576472bd7a2a2a0ef7621d2853aecd7513d4ed37f35d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationResize]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationResize]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationResize]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2289f85839d8985661bb7f2abe83331bc3d2230ad44d04814ad638e680c8a40d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationRotate",
    jsii_struct_bases=[],
    name_mapping={"degrees": "degrees", "degrees_var": "degreesVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationRotate:
    def __init__(
        self,
        *,
        degrees: typing.Optional[builtins.str] = None,
        degrees_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param degrees: The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees DataAkamaiImagingPolicyImage#degrees}
        :param degrees_var: The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees_var DataAkamaiImagingPolicyImage#degrees_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__39e995e3a19609df823a515538c387319da6c4b1ee8b56f3f8e7387c44d86962)
            check_type(argname="argument degrees", value=degrees, expected_type=type_hints["degrees"])
            check_type(argname="argument degrees_var", value=degrees_var, expected_type=type_hints["degrees_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if degrees is not None:
            self._values["degrees"] = degrees
        if degrees_var is not None:
            self._values["degrees_var"] = degrees_var

    @builtins.property
    def degrees(self) -> typing.Optional[builtins.str]:
        '''The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees DataAkamaiImagingPolicyImage#degrees}
        '''
        result = self._values.get("degrees")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def degrees_var(self) -> typing.Optional[builtins.str]:
        '''The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees_var DataAkamaiImagingPolicyImage#degrees_var}
        '''
        result = self._values.get("degrees_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationRotate(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationRotateList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationRotateList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5e6dbd6fc3cc924c6904254cc6a7ed2cac695cb62037aad4f34df9f5d28fa494)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationRotateOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f655d2db4afa1ad8e0aa7e13516dc92c18b561bc68dee37136279251e48a4f8)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationRotateOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__94f00c45df41e64ee70b1377719dbbe4ee2279509083ed705d2e8ed3f2bde578)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7e407f287e29d12fb3b78ecec9b237315e18853d8372593b8af87e810495ca32)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ed15964acfaf4bc4d3327d66eda14ec9ab0fa07b068b5ef985378e7a0bd067d8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationRotate]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationRotate]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationRotate]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3fb933d4c99de4cd1d93b9ca4f18f703fac062233e1c42cd4cfa9bfae42f41dc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationRotateOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationRotateOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d70065a0866589ab3715ee7cb1c279433f2ac080fcaf7ea951c0199b6768e4d9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetDegrees")
    def reset_degrees(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDegrees", []))

    @jsii.member(jsii_name="resetDegreesVar")
    def reset_degrees_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDegreesVar", []))

    @builtins.property
    @jsii.member(jsii_name="degreesInput")
    def degrees_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "degreesInput"))

    @builtins.property
    @jsii.member(jsii_name="degreesVarInput")
    def degrees_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "degreesVarInput"))

    @builtins.property
    @jsii.member(jsii_name="degrees")
    def degrees(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "degrees"))

    @degrees.setter
    def degrees(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2fc36151bcf92073d5713b9f4f07ea061c5067d476ec121e354ae824971670c9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "degrees", value)

    @builtins.property
    @jsii.member(jsii_name="degreesVar")
    def degrees_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "degreesVar"))

    @degrees_var.setter
    def degrees_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fb304e5d381ae7ff07f2a5643f37a329d326c1eb54524daecfdef8dc6bf5d8e1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "degreesVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationRotate]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationRotate]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationRotate]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cb6ed81629b0c022cf24a8c0681adcd9998684c17d670895d567762c2486266b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationScale",
    jsii_struct_bases=[],
    name_mapping={
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationScale:
    def __init__(
        self,
        *,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param height: Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged. Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged. Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a56d359a9a606d9b5cd1c50864612e86a12176776aa11590e7f86ac12d7eb747)
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size.

        Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size.

        Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged.

        Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged.

        Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationScale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationScaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationScaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac29048eff3da4a24365b5e2bfaafbce5a7e6c38a394f3020023779d9cc117ba)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationScaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a2823b8deb8c5416a5b9325f4210ef2557110efbe288656c6a82f72f7fdacb19)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationScaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bd90a6a334f02e60bbab37f703b3414f8edabfaacd997a6621e2b801bdf5fc3f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e965dbd85d80aad9d59f4684a284d6032c6931f31b921acde51b955bfd200864)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4873ce96ee3f195eaabc8542ed13bf7c1d5766d853f415c5ec11f3d2f8a939c9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationScale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationScale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationScale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b60f71dda669647d124610e8818a0ac6f96c3cc191358437220752b025495478)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationScaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationScaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__52c1d9d2b06ec53ff2dc2680c101260ac3642e6dc3e0c963f8312319c7853870)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb900bfbacf16cfa7c687203c4c33eb9cffac4fc50abc05ddc3cab2a405d4594)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af3455fc0a8e8d3517d91827c57e8f42a93808ce79c9d0fc2020fd7a7a385551)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__93aaf8cd8f8f7a04063737b253269187cb4fa7ea2e32073406145113c972f105)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bd7bc44d82f0dd2f07bbdb75e220505a7cb56296c15433d70d304b1594d45ddb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationScale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationScale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationScale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__82b97e4fdf3d20c6454c866e1b7c9b9eca1e4e40b0278a6a732b1d3a0e44a7d2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationShear",
    jsii_struct_bases=[],
    name_mapping={
        "x_shear": "xShear",
        "x_shear_var": "xShearVar",
        "y_shear": "yShear",
        "y_shear_var": "yShearVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationShear:
    def __init__(
        self,
        *,
        x_shear: typing.Optional[builtins.str] = None,
        x_shear_var: typing.Optional[builtins.str] = None,
        y_shear: typing.Optional[builtins.str] = None,
        y_shear_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param x_shear: The amount to shear along the x-axis, measured in multiples of the image's width. Must be set if yShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear DataAkamaiImagingPolicyImage#x_shear}
        :param x_shear_var: The amount to shear along the x-axis, measured in multiples of the image's width. Must be set if yShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear_var DataAkamaiImagingPolicyImage#x_shear_var}
        :param y_shear: The amount to shear along the y-axis, measured in multiples of the image's height. Must be set if xShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear DataAkamaiImagingPolicyImage#y_shear}
        :param y_shear_var: The amount to shear along the y-axis, measured in multiples of the image's height. Must be set if xShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear_var DataAkamaiImagingPolicyImage#y_shear_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c6c65de18e8c6e6708890ea50edeb3fa39eff224ce37727c3d2af9d625e5a709)
            check_type(argname="argument x_shear", value=x_shear, expected_type=type_hints["x_shear"])
            check_type(argname="argument x_shear_var", value=x_shear_var, expected_type=type_hints["x_shear_var"])
            check_type(argname="argument y_shear", value=y_shear, expected_type=type_hints["y_shear"])
            check_type(argname="argument y_shear_var", value=y_shear_var, expected_type=type_hints["y_shear_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if x_shear is not None:
            self._values["x_shear"] = x_shear
        if x_shear_var is not None:
            self._values["x_shear_var"] = x_shear_var
        if y_shear is not None:
            self._values["y_shear"] = y_shear
        if y_shear_var is not None:
            self._values["y_shear_var"] = y_shear_var

    @builtins.property
    def x_shear(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the x-axis, measured in multiples of the image's width.

        Must be set if yShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear DataAkamaiImagingPolicyImage#x_shear}
        '''
        result = self._values.get("x_shear")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_shear_var(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the x-axis, measured in multiples of the image's width.

        Must be set if yShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear_var DataAkamaiImagingPolicyImage#x_shear_var}
        '''
        result = self._values.get("x_shear_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_shear(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the y-axis, measured in multiples of the image's height.

        Must be set if xShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear DataAkamaiImagingPolicyImage#y_shear}
        '''
        result = self._values.get("y_shear")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_shear_var(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the y-axis, measured in multiples of the image's height.

        Must be set if xShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear_var DataAkamaiImagingPolicyImage#y_shear_var}
        '''
        result = self._values.get("y_shear_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationShear(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationShearList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationShearList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2228cb77059b356a8ada49bcb9eddddd1e02c5a3e13c7b0ee39590bb147a6cfa)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationShearOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7c03adbeba60f833360fc0e9d4f26cd0604801abf413a2533a0cd2fd076d36c7)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationShearOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__310f3e44705d6502e4bb0d4c1f10bf7764131edd64b3bb8bb5871d418cba2269)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4075141bd50453a42dba54a44a60bbde5be1f353057203e047979fd6a671bfe9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b14f01bba91434cdd5636c16e7e1970572a7c695797696c0ec696bd5fcae8f79)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationShear]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationShear]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationShear]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3f77d69813ba469601c3e4294e4aadad61680e5f44b78e1af6edec5207f53645)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationShearOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationShearOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea773f31af5e404887540370d6aeb66aa9db00277e96db17f05799016d970131)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetXShear")
    def reset_x_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXShear", []))

    @jsii.member(jsii_name="resetXShearVar")
    def reset_x_shear_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXShearVar", []))

    @jsii.member(jsii_name="resetYShear")
    def reset_y_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYShear", []))

    @jsii.member(jsii_name="resetYShearVar")
    def reset_y_shear_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYShearVar", []))

    @builtins.property
    @jsii.member(jsii_name="xShearInput")
    def x_shear_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xShearInput"))

    @builtins.property
    @jsii.member(jsii_name="xShearVarInput")
    def x_shear_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xShearVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yShearInput")
    def y_shear_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yShearInput"))

    @builtins.property
    @jsii.member(jsii_name="yShearVarInput")
    def y_shear_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yShearVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xShear")
    def x_shear(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xShear"))

    @x_shear.setter
    def x_shear(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0aeec3932547ca1167ce9a56244f17c073987fa347cbeeeae420db56abed4345)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xShear", value)

    @builtins.property
    @jsii.member(jsii_name="xShearVar")
    def x_shear_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xShearVar"))

    @x_shear_var.setter
    def x_shear_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b60467f2008bfbe5050c65596f77658b54077593b714fb0a87798bdaa52a7b86)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xShearVar", value)

    @builtins.property
    @jsii.member(jsii_name="yShear")
    def y_shear(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yShear"))

    @y_shear.setter
    def y_shear(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c7b59ac6c822cf159cfee3c387c8b0ce14b295c2a159e44bdc7060e37580133c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yShear", value)

    @builtins.property
    @jsii.member(jsii_name="yShearVar")
    def y_shear_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yShearVar"))

    @y_shear_var.setter
    def y_shear_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__569014d90187dc1cd3a8124ed88f5f3047d9187f4201c7dbb2a73d8ce484ad2c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yShearVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationShear]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationShear]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationShear]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__21c47ffe9043095f9bf598788f99ac88b68e48ed5f60896915fdcf97331f901b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationTrim",
    jsii_struct_bases=[],
    name_mapping={
        "fuzz": "fuzz",
        "fuzz_var": "fuzzVar",
        "padding": "padding",
        "padding_var": "paddingVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationTrim:
    def __init__(
        self,
        *,
        fuzz: typing.Optional[builtins.str] = None,
        fuzz_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fuzz: The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz DataAkamaiImagingPolicyImage#fuzz}
        :param fuzz_var: The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz_var DataAkamaiImagingPolicyImage#fuzz_var}
        :param padding: The amount of padding in pixels to add to the trimmed image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: The amount of padding in pixels to add to the trimmed image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8ee8d2e1f35a2b0c867b187fb2332f05b615b3e6bf1b1a69f4c1525535d3cca3)
            check_type(argname="argument fuzz", value=fuzz, expected_type=type_hints["fuzz"])
            check_type(argname="argument fuzz_var", value=fuzz_var, expected_type=type_hints["fuzz_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fuzz is not None:
            self._values["fuzz"] = fuzz
        if fuzz_var is not None:
            self._values["fuzz_var"] = fuzz_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var

    @builtins.property
    def fuzz(self) -> typing.Optional[builtins.str]:
        '''The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz DataAkamaiImagingPolicyImage#fuzz}
        '''
        result = self._values.get("fuzz")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fuzz_var(self) -> typing.Optional[builtins.str]:
        '''The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz_var DataAkamaiImagingPolicyImage#fuzz_var}
        '''
        result = self._values.get("fuzz_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''The amount of padding in pixels to add to the trimmed image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''The amount of padding in pixels to add to the trimmed image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationTrim(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationTrimList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationTrimList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4353ba51e9410b747091c8a00cb51078feb443c7c6c51c7ebba8ea4c5ec4450c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationTrimOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dd6e4f9881167f5aad6e28aa17afbcfff52aa75193183985979df7b92a2c50be)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationTrimOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a40d6367e3ecbae996d2c411e901fd6d434e61527d1f37029e5ce5710b4692a7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ea8e490da8ad6085e2e657a1a683ca5b5f77a66c95764cf225710ac854c0bd1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__afdb185a9bb0cfa02e3932c565d5a4bf8adaa01481db2cb367b5b7f17740412e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationTrim]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationTrim]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationTrim]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b7d6214351103b84e6f1d7fd7e066d43e464bcdfeb7d033a2a43d2b8833c5f56)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationTrimOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationTrimOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ede8f4726cc6460314795d0f8056272fecdf086dc839e065b6f456b18a24f63c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetFuzz")
    def reset_fuzz(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFuzz", []))

    @jsii.member(jsii_name="resetFuzzVar")
    def reset_fuzz_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFuzzVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @builtins.property
    @jsii.member(jsii_name="fuzzInput")
    def fuzz_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fuzzInput"))

    @builtins.property
    @jsii.member(jsii_name="fuzzVarInput")
    def fuzz_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fuzzVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="fuzz")
    def fuzz(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fuzz"))

    @fuzz.setter
    def fuzz(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5dbe70788b7564e9b4322f27b09117c08e3999942ff516da99215cf61235dacf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fuzz", value)

    @builtins.property
    @jsii.member(jsii_name="fuzzVar")
    def fuzz_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fuzzVar"))

    @fuzz_var.setter
    def fuzz_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8dc3de6289674008396b533a2aa0505fcd6b7347d174a0edf2529a724633605c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fuzzVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__678c883ddfc3c1da9546b77b2b059f9e3c2b23fe64a74150614b91d88edeafec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3577f81f1acdab5123627422014eed88f539aa15f3dc14addbdc7a0329ef1333)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationTrim]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationTrim]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationTrim]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__16c748686862ae7e9b3e1e7178c0fb2f22e8e3ab2475ee89b268d4f180925b31)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationUnsharpMask",
    jsii_struct_bases=[],
    name_mapping={
        "gain": "gain",
        "gain_var": "gainVar",
        "sigma": "sigma",
        "sigma_var": "sigmaVar",
        "threshold": "threshold",
        "threshold_var": "thresholdVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationUnsharpMask:
    def __init__(
        self,
        *,
        gain: typing.Optional[builtins.str] = None,
        gain_var: typing.Optional[builtins.str] = None,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
        threshold: typing.Optional[builtins.str] = None,
        threshold_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param gain: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        :param gain_var: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        :param sigma: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        :param threshold: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        :param threshold_var: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a1fc87b8cc1cac0dcf2bbfa1fe89bc85ef8d65d8480867b3e647a3caa1ea337c)
            check_type(argname="argument gain", value=gain, expected_type=type_hints["gain"])
            check_type(argname="argument gain_var", value=gain_var, expected_type=type_hints["gain_var"])
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
            check_type(argname="argument threshold", value=threshold, expected_type=type_hints["threshold"])
            check_type(argname="argument threshold_var", value=threshold_var, expected_type=type_hints["threshold_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if gain is not None:
            self._values["gain"] = gain
        if gain_var is not None:
            self._values["gain_var"] = gain_var
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var
        if threshold is not None:
            self._values["threshold"] = threshold
        if threshold_var is not None:
            self._values["threshold_var"] = threshold_var

    @builtins.property
    def gain(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        '''
        result = self._values.get("gain")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gain_var(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        '''
        result = self._values.get("gain_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        '''
        result = self._values.get("threshold")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold_var(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        result = self._values.get("threshold_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationUnsharpMask(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationUnsharpMaskList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationUnsharpMaskList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2aac4888410b789603396ae0d616d4940c8763b7932b9653765412c0bc15682b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationUnsharpMaskOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b108b54ab7fe852497a860b33a92e063d6260ae1b26c4abdcfc94742fc1e1bbd)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationUnsharpMaskOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a6235134b2d3f55aaeeb923152dd98fc46fea1613047b7be44b49f3f3424b0d0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b40025f9081a82b7ed0c7175f79f44200d69b6c547d211171606d04b2f3d74fc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a2f6fe961d1553dc86f04427ac8282612a13dc9858c0a5fe397f2eb4ef981bc1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationUnsharpMask]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationUnsharpMask]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationUnsharpMask]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1644744f4c59713b625076d97d2ad3fdfdc94b7add22718a86bdb34b76f1590f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationUnsharpMaskOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationUnsharpMaskOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5b0238c5845ce1130472ae98a1a58de4f59b31f3cb504782899eb63630232c6b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetGain")
    def reset_gain(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGain", []))

    @jsii.member(jsii_name="resetGainVar")
    def reset_gain_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGainVar", []))

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @jsii.member(jsii_name="resetThreshold")
    def reset_threshold(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThreshold", []))

    @jsii.member(jsii_name="resetThresholdVar")
    def reset_threshold_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThresholdVar", []))

    @builtins.property
    @jsii.member(jsii_name="gainInput")
    def gain_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainInput"))

    @builtins.property
    @jsii.member(jsii_name="gainVarInput")
    def gain_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdInput")
    def threshold_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdVarInput")
    def threshold_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gain")
    def gain(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gain"))

    @gain.setter
    def gain(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__55f210029ff83da029f4085513b8d55cacfbfa09684be53f65212934762543d2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gain", value)

    @builtins.property
    @jsii.member(jsii_name="gainVar")
    def gain_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gainVar"))

    @gain_var.setter
    def gain_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5caf7350137f2d4bfe036c5e05fa5dc98e1a3978c5475ec2ec89eec7f66ea31a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gainVar", value)

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b1fac1b3ddf78de3a946b6d67daf42e6a323c4528bdb60cede5f5ed22785aef8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e49d35d4763647613c60a20af54a31feb5c8a7f6348a2126ad1aab19bb8c9650)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="threshold")
    def threshold(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "threshold"))

    @threshold.setter
    def threshold(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5fa45fe81ca2aab8a07314875c441d08cff8d68fcc95314c6294cc47a7e56f13)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "threshold", value)

    @builtins.property
    @jsii.member(jsii_name="thresholdVar")
    def threshold_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "thresholdVar"))

    @threshold_var.setter
    def threshold_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ad49172cfd66d7ce8d85301c342ef5a16ed9334ff049bf5b236c2ae09941b2a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "thresholdVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationUnsharpMask]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationUnsharpMask]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationUnsharpMask]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__61b1e78c6495fa4964953e5dc8a3d9e4514a92cbd4eed54c5cf4f87beb4b021b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImage",
    jsii_struct_bases=[],
    name_mapping={
        "transformation": "transformation",
        "url": "url",
        "url_var": "urlVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImage:
    def __init__(
        self,
        *,
        transformation: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        url: typing.Optional[builtins.str] = None,
        url_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param transformation: transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        :param url: The URL of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url DataAkamaiImagingPolicyImage#url}
        :param url_var: The URL of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url_var DataAkamaiImagingPolicyImage#url_var}
        '''
        if isinstance(transformation, dict):
            transformation = DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformation(**transformation)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d181b7d2bfd8b174331e5a17f30376009779a261f8412e115c4b37a67b262afc)
            check_type(argname="argument transformation", value=transformation, expected_type=type_hints["transformation"])
            check_type(argname="argument url", value=url, expected_type=type_hints["url"])
            check_type(argname="argument url_var", value=url_var, expected_type=type_hints["url_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if transformation is not None:
            self._values["transformation"] = transformation
        if url is not None:
            self._values["url"] = url
        if url_var is not None:
            self._values["url_var"] = url_var

    @builtins.property
    def transformation(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformation"]:
        '''transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        '''
        result = self._values.get("transformation")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformation"], result)

    @builtins.property
    def url(self) -> typing.Optional[builtins.str]:
        '''The URL of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url DataAkamaiImagingPolicyImage#url}
        '''
        result = self._values.get("url")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def url_var(self) -> typing.Optional[builtins.str]:
        '''The URL of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url_var DataAkamaiImagingPolicyImage#url_var}
        '''
        result = self._values.get("url_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c3eee714f625377316916f9c68b6a210b93c07e6f03d2e9564f86b0d759d121c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be1223c2fbc97d7179a46b467beb4350944fb4fe7a8eb9a62a19ca5f1a9a68bc)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__040637e33442054985a7d2e561878d691567780f5f5236ce5bc85ebcda042ee5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__737183fc79deda7bc05a3eadf13f686fea8e2afdb7ef39c570d129abcc8efc2f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6ce1c80de5cb7bc37e62a2b54fbd696445bc2a0a88b139ff04cde26cae4b9f23)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImage]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImage]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImage]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a9fcc4e9ea9438e4c1bf40139595839c66a4f4c3a333d07df0e23bf0e5591a1c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a68c246a68a04cc46832200308b895f071083ab5e0c4c2d0e9f63f91e7a81de)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformation")
    def put_transformation(
        self,
        *,
        append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationAppend", typing.Dict[builtins.str, typing.Any]]]]] = None,
        aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationAspectCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationBackgroundColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationBlur", typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationChromaKey", typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationComposite", typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationCompound", typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationContrast", typing.Dict[builtins.str, typing.Any]]]]] = None,
        crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationFaceCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationFeatureCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationFitAndFill", typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationGoop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationGrayscale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationHsl", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationHsv", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfDimension", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfOrientation", typing.Dict[builtins.str, typing.Any]]]]] = None,
        im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationImQuery", typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationMaxColors", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationMirror", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationMonoHue", typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationOpacity", typing.Dict[builtins.str, typing.Any]]]]] = None,
        region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationRegionOfInterestCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationRelativeCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationRemoveColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationResize", typing.Dict[builtins.str, typing.Any]]]]] = None,
        rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationRotate", typing.Dict[builtins.str, typing.Any]]]]] = None,
        scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationScale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationShear", typing.Dict[builtins.str, typing.Any]]]]] = None,
        trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationTrim", typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationUnsharpMask", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param append: append block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        :param aspect_crop: aspect_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param crop: crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        :param face_crop: face_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        :param feature_crop: feature_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        :param fit_and_fill: fit_and_fill block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param im_query: im_query block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param region_of_interest_crop: region_of_interest_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        :param relative_crop: relative_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param resize: resize block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        :param rotate: rotate block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        :param scale: scale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param shear: shear block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        :param trim: trim block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        value = DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformation(
            append=append,
            aspect_crop=aspect_crop,
            background_color=background_color,
            blur=blur,
            chroma_key=chroma_key,
            composite=composite,
            compound=compound,
            contrast=contrast,
            crop=crop,
            face_crop=face_crop,
            feature_crop=feature_crop,
            fit_and_fill=fit_and_fill,
            goop=goop,
            grayscale=grayscale,
            hsl=hsl,
            hsv=hsv,
            if_dimension=if_dimension,
            if_orientation=if_orientation,
            im_query=im_query,
            max_colors=max_colors,
            mirror=mirror,
            mono_hue=mono_hue,
            opacity=opacity,
            region_of_interest_crop=region_of_interest_crop,
            relative_crop=relative_crop,
            remove_color=remove_color,
            resize=resize,
            rotate=rotate,
            scale=scale,
            shear=shear,
            trim=trim,
            unsharp_mask=unsharp_mask,
        )

        return typing.cast(None, jsii.invoke(self, "putTransformation", [value]))

    @jsii.member(jsii_name="resetTransformation")
    def reset_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformation", []))

    @jsii.member(jsii_name="resetUrl")
    def reset_url(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUrl", []))

    @jsii.member(jsii_name="resetUrlVar")
    def reset_url_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUrlVar", []))

    @builtins.property
    @jsii.member(jsii_name="transformation")
    def transformation(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationOutputReference", jsii.get(self, "transformation"))

    @builtins.property
    @jsii.member(jsii_name="transformationInput")
    def transformation_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformation"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformation"], jsii.get(self, "transformationInput"))

    @builtins.property
    @jsii.member(jsii_name="urlInput")
    def url_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "urlInput"))

    @builtins.property
    @jsii.member(jsii_name="urlVarInput")
    def url_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "urlVarInput"))

    @builtins.property
    @jsii.member(jsii_name="url")
    def url(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "url"))

    @url.setter
    def url(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ce749bc5f613b5d952a91d4c3873a528ec067d5f05de432dcab770e1325e3ea2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "url", value)

    @builtins.property
    @jsii.member(jsii_name="urlVar")
    def url_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "urlVar"))

    @url_var.setter
    def url_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d5f0d872b01fc41187d2a749704a0b1dbad3871af0487129fc555d45f1ec0d54)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "urlVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImage]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImage]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImage]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e394d319429e2e40aaf47c3ee120835fd833c309fcb6321079a5fe6c67277ade)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformation",
    jsii_struct_bases=[],
    name_mapping={
        "append": "append",
        "aspect_crop": "aspectCrop",
        "background_color": "backgroundColor",
        "blur": "blur",
        "chroma_key": "chromaKey",
        "composite": "composite",
        "compound": "compound",
        "contrast": "contrast",
        "crop": "crop",
        "face_crop": "faceCrop",
        "feature_crop": "featureCrop",
        "fit_and_fill": "fitAndFill",
        "goop": "goop",
        "grayscale": "grayscale",
        "hsl": "hsl",
        "hsv": "hsv",
        "if_dimension": "ifDimension",
        "if_orientation": "ifOrientation",
        "im_query": "imQuery",
        "max_colors": "maxColors",
        "mirror": "mirror",
        "mono_hue": "monoHue",
        "opacity": "opacity",
        "region_of_interest_crop": "regionOfInterestCrop",
        "relative_crop": "relativeCrop",
        "remove_color": "removeColor",
        "resize": "resize",
        "rotate": "rotate",
        "scale": "scale",
        "shear": "shear",
        "trim": "trim",
        "unsharp_mask": "unsharpMask",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformation:
    def __init__(
        self,
        *,
        append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationAppend", typing.Dict[builtins.str, typing.Any]]]]] = None,
        aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationAspectCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationBackgroundColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationBlur", typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationChromaKey", typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationComposite", typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationCompound", typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationContrast", typing.Dict[builtins.str, typing.Any]]]]] = None,
        crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationFaceCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationFeatureCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationFitAndFill", typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationGoop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationGrayscale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationHsl", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationHsv", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfDimension", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfOrientation", typing.Dict[builtins.str, typing.Any]]]]] = None,
        im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationImQuery", typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationMaxColors", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationMirror", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationMonoHue", typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationOpacity", typing.Dict[builtins.str, typing.Any]]]]] = None,
        region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationRegionOfInterestCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationRelativeCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationRemoveColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationResize", typing.Dict[builtins.str, typing.Any]]]]] = None,
        rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationRotate", typing.Dict[builtins.str, typing.Any]]]]] = None,
        scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationScale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationShear", typing.Dict[builtins.str, typing.Any]]]]] = None,
        trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationTrim", typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationUnsharpMask", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param append: append block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        :param aspect_crop: aspect_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param crop: crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        :param face_crop: face_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        :param feature_crop: feature_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        :param fit_and_fill: fit_and_fill block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param im_query: im_query block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param region_of_interest_crop: region_of_interest_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        :param relative_crop: relative_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param resize: resize block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        :param rotate: rotate block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        :param scale: scale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param shear: shear block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        :param trim: trim block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9c53ac741bf4657a5f6a91c7f85158ed9f97865cce0421c49df02a38c90c7297)
            check_type(argname="argument append", value=append, expected_type=type_hints["append"])
            check_type(argname="argument aspect_crop", value=aspect_crop, expected_type=type_hints["aspect_crop"])
            check_type(argname="argument background_color", value=background_color, expected_type=type_hints["background_color"])
            check_type(argname="argument blur", value=blur, expected_type=type_hints["blur"])
            check_type(argname="argument chroma_key", value=chroma_key, expected_type=type_hints["chroma_key"])
            check_type(argname="argument composite", value=composite, expected_type=type_hints["composite"])
            check_type(argname="argument compound", value=compound, expected_type=type_hints["compound"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument crop", value=crop, expected_type=type_hints["crop"])
            check_type(argname="argument face_crop", value=face_crop, expected_type=type_hints["face_crop"])
            check_type(argname="argument feature_crop", value=feature_crop, expected_type=type_hints["feature_crop"])
            check_type(argname="argument fit_and_fill", value=fit_and_fill, expected_type=type_hints["fit_and_fill"])
            check_type(argname="argument goop", value=goop, expected_type=type_hints["goop"])
            check_type(argname="argument grayscale", value=grayscale, expected_type=type_hints["grayscale"])
            check_type(argname="argument hsl", value=hsl, expected_type=type_hints["hsl"])
            check_type(argname="argument hsv", value=hsv, expected_type=type_hints["hsv"])
            check_type(argname="argument if_dimension", value=if_dimension, expected_type=type_hints["if_dimension"])
            check_type(argname="argument if_orientation", value=if_orientation, expected_type=type_hints["if_orientation"])
            check_type(argname="argument im_query", value=im_query, expected_type=type_hints["im_query"])
            check_type(argname="argument max_colors", value=max_colors, expected_type=type_hints["max_colors"])
            check_type(argname="argument mirror", value=mirror, expected_type=type_hints["mirror"])
            check_type(argname="argument mono_hue", value=mono_hue, expected_type=type_hints["mono_hue"])
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument region_of_interest_crop", value=region_of_interest_crop, expected_type=type_hints["region_of_interest_crop"])
            check_type(argname="argument relative_crop", value=relative_crop, expected_type=type_hints["relative_crop"])
            check_type(argname="argument remove_color", value=remove_color, expected_type=type_hints["remove_color"])
            check_type(argname="argument resize", value=resize, expected_type=type_hints["resize"])
            check_type(argname="argument rotate", value=rotate, expected_type=type_hints["rotate"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument shear", value=shear, expected_type=type_hints["shear"])
            check_type(argname="argument trim", value=trim, expected_type=type_hints["trim"])
            check_type(argname="argument unsharp_mask", value=unsharp_mask, expected_type=type_hints["unsharp_mask"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if append is not None:
            self._values["append"] = append
        if aspect_crop is not None:
            self._values["aspect_crop"] = aspect_crop
        if background_color is not None:
            self._values["background_color"] = background_color
        if blur is not None:
            self._values["blur"] = blur
        if chroma_key is not None:
            self._values["chroma_key"] = chroma_key
        if composite is not None:
            self._values["composite"] = composite
        if compound is not None:
            self._values["compound"] = compound
        if contrast is not None:
            self._values["contrast"] = contrast
        if crop is not None:
            self._values["crop"] = crop
        if face_crop is not None:
            self._values["face_crop"] = face_crop
        if feature_crop is not None:
            self._values["feature_crop"] = feature_crop
        if fit_and_fill is not None:
            self._values["fit_and_fill"] = fit_and_fill
        if goop is not None:
            self._values["goop"] = goop
        if grayscale is not None:
            self._values["grayscale"] = grayscale
        if hsl is not None:
            self._values["hsl"] = hsl
        if hsv is not None:
            self._values["hsv"] = hsv
        if if_dimension is not None:
            self._values["if_dimension"] = if_dimension
        if if_orientation is not None:
            self._values["if_orientation"] = if_orientation
        if im_query is not None:
            self._values["im_query"] = im_query
        if max_colors is not None:
            self._values["max_colors"] = max_colors
        if mirror is not None:
            self._values["mirror"] = mirror
        if mono_hue is not None:
            self._values["mono_hue"] = mono_hue
        if opacity is not None:
            self._values["opacity"] = opacity
        if region_of_interest_crop is not None:
            self._values["region_of_interest_crop"] = region_of_interest_crop
        if relative_crop is not None:
            self._values["relative_crop"] = relative_crop
        if remove_color is not None:
            self._values["remove_color"] = remove_color
        if resize is not None:
            self._values["resize"] = resize
        if rotate is not None:
            self._values["rotate"] = rotate
        if scale is not None:
            self._values["scale"] = scale
        if shear is not None:
            self._values["shear"] = shear
        if trim is not None:
            self._values["trim"] = trim
        if unsharp_mask is not None:
            self._values["unsharp_mask"] = unsharp_mask

    @builtins.property
    def append(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationAppend"]]]:
        '''append block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        '''
        result = self._values.get("append")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationAppend"]]], result)

    @builtins.property
    def aspect_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationAspectCrop"]]]:
        '''aspect_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        '''
        result = self._values.get("aspect_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationAspectCrop"]]], result)

    @builtins.property
    def background_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationBackgroundColor"]]]:
        '''background_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        '''
        result = self._values.get("background_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationBackgroundColor"]]], result)

    @builtins.property
    def blur(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationBlur"]]]:
        '''blur block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        '''
        result = self._values.get("blur")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationBlur"]]], result)

    @builtins.property
    def chroma_key(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationChromaKey"]]]:
        '''chroma_key block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        '''
        result = self._values.get("chroma_key")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationChromaKey"]]], result)

    @builtins.property
    def composite(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationComposite"]]]:
        '''composite block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        '''
        result = self._values.get("composite")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationComposite"]]], result)

    @builtins.property
    def compound(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationCompound"]]]:
        '''compound block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        '''
        result = self._values.get("compound")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationCompound"]]], result)

    @builtins.property
    def contrast(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationContrast"]]]:
        '''contrast block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationContrast"]]], result)

    @builtins.property
    def crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationCrop"]]]:
        '''crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        '''
        result = self._values.get("crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationCrop"]]], result)

    @builtins.property
    def face_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationFaceCrop"]]]:
        '''face_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        '''
        result = self._values.get("face_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationFaceCrop"]]], result)

    @builtins.property
    def feature_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationFeatureCrop"]]]:
        '''feature_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        '''
        result = self._values.get("feature_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationFeatureCrop"]]], result)

    @builtins.property
    def fit_and_fill(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationFitAndFill"]]]:
        '''fit_and_fill block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        '''
        result = self._values.get("fit_and_fill")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationFitAndFill"]]], result)

    @builtins.property
    def goop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationGoop"]]]:
        '''goop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        '''
        result = self._values.get("goop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationGoop"]]], result)

    @builtins.property
    def grayscale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationGrayscale"]]]:
        '''grayscale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        '''
        result = self._values.get("grayscale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationGrayscale"]]], result)

    @builtins.property
    def hsl(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationHsl"]]]:
        '''hsl block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        '''
        result = self._values.get("hsl")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationHsl"]]], result)

    @builtins.property
    def hsv(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationHsv"]]]:
        '''hsv block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        '''
        result = self._values.get("hsv")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationHsv"]]], result)

    @builtins.property
    def if_dimension(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfDimension"]]]:
        '''if_dimension block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        '''
        result = self._values.get("if_dimension")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfDimension"]]], result)

    @builtins.property
    def if_orientation(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfOrientation"]]]:
        '''if_orientation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        '''
        result = self._values.get("if_orientation")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfOrientation"]]], result)

    @builtins.property
    def im_query(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationImQuery"]]]:
        '''im_query block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        '''
        result = self._values.get("im_query")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationImQuery"]]], result)

    @builtins.property
    def max_colors(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationMaxColors"]]]:
        '''max_colors block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        '''
        result = self._values.get("max_colors")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationMaxColors"]]], result)

    @builtins.property
    def mirror(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationMirror"]]]:
        '''mirror block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        '''
        result = self._values.get("mirror")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationMirror"]]], result)

    @builtins.property
    def mono_hue(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationMonoHue"]]]:
        '''mono_hue block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        '''
        result = self._values.get("mono_hue")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationMonoHue"]]], result)

    @builtins.property
    def opacity(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationOpacity"]]]:
        '''opacity block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationOpacity"]]], result)

    @builtins.property
    def region_of_interest_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationRegionOfInterestCrop"]]]:
        '''region_of_interest_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        '''
        result = self._values.get("region_of_interest_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationRegionOfInterestCrop"]]], result)

    @builtins.property
    def relative_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationRelativeCrop"]]]:
        '''relative_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        '''
        result = self._values.get("relative_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationRelativeCrop"]]], result)

    @builtins.property
    def remove_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationRemoveColor"]]]:
        '''remove_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        '''
        result = self._values.get("remove_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationRemoveColor"]]], result)

    @builtins.property
    def resize(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationResize"]]]:
        '''resize block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        '''
        result = self._values.get("resize")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationResize"]]], result)

    @builtins.property
    def rotate(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationRotate"]]]:
        '''rotate block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        '''
        result = self._values.get("rotate")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationRotate"]]], result)

    @builtins.property
    def scale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationScale"]]]:
        '''scale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationScale"]]], result)

    @builtins.property
    def shear(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationShear"]]]:
        '''shear block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        '''
        result = self._values.get("shear")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationShear"]]], result)

    @builtins.property
    def trim(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationTrim"]]]:
        '''trim block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        '''
        result = self._values.get("trim")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationTrim"]]], result)

    @builtins.property
    def unsharp_mask(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationUnsharpMask"]]]:
        '''unsharp_mask block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        result = self._values.get("unsharp_mask")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationUnsharpMask"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationAppend",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_priority": "gravityPriority",
        "gravity_priority_var": "gravityPriorityVar",
        "gravity_var": "gravityVar",
        "preserve_minor_dimension": "preserveMinorDimension",
        "preserve_minor_dimension_var": "preserveMinorDimensionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationAppend:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationAppendImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_priority: typing.Optional[builtins.str] = None,
        gravity_priority_var: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        preserve_minor_dimension: typing.Optional[builtins.str] = None,
        preserve_minor_dimension_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Specifies where to place the ``image`` relative to the source image. The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_priority: Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal. The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority DataAkamaiImagingPolicyImage#gravity_priority}
        :param gravity_priority_var: Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal. The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority_var DataAkamaiImagingPolicyImage#gravity_priority_var}
        :param gravity_var: Specifies where to place the ``image`` relative to the source image. The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param preserve_minor_dimension: Whether to preserve the source image's minor dimension, ``false`` by default. The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension DataAkamaiImagingPolicyImage#preserve_minor_dimension}
        :param preserve_minor_dimension_var: Whether to preserve the source image's minor dimension, ``false`` by default. The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension_var DataAkamaiImagingPolicyImage#preserve_minor_dimension_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationAppendImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__342d65aac4e8c7fcae7093f78402950c0563f57e87794f25b2047081595427ce)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_priority", value=gravity_priority, expected_type=type_hints["gravity_priority"])
            check_type(argname="argument gravity_priority_var", value=gravity_priority_var, expected_type=type_hints["gravity_priority_var"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument preserve_minor_dimension", value=preserve_minor_dimension, expected_type=type_hints["preserve_minor_dimension"])
            check_type(argname="argument preserve_minor_dimension_var", value=preserve_minor_dimension_var, expected_type=type_hints["preserve_minor_dimension_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_priority is not None:
            self._values["gravity_priority"] = gravity_priority
        if gravity_priority_var is not None:
            self._values["gravity_priority_var"] = gravity_priority_var
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if preserve_minor_dimension is not None:
            self._values["preserve_minor_dimension"] = preserve_minor_dimension
        if preserve_minor_dimension_var is not None:
            self._values["preserve_minor_dimension_var"] = preserve_minor_dimension_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationAppendImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationAppendImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Specifies where to place the ``image`` relative to the source image.

        The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_priority(self) -> typing.Optional[builtins.str]:
        '''Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal.

        The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority DataAkamaiImagingPolicyImage#gravity_priority}
        '''
        result = self._values.get("gravity_priority")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_priority_var(self) -> typing.Optional[builtins.str]:
        '''Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal.

        The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority_var DataAkamaiImagingPolicyImage#gravity_priority_var}
        '''
        result = self._values.get("gravity_priority_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Specifies where to place the ``image`` relative to the source image.

        The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def preserve_minor_dimension(self) -> typing.Optional[builtins.str]:
        '''Whether to preserve the source image's minor dimension, ``false`` by default.

        The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension DataAkamaiImagingPolicyImage#preserve_minor_dimension}
        '''
        result = self._values.get("preserve_minor_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def preserve_minor_dimension_var(self) -> typing.Optional[builtins.str]:
        '''Whether to preserve the source image's minor dimension, ``false`` by default.

        The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension_var DataAkamaiImagingPolicyImage#preserve_minor_dimension_var}
        '''
        result = self._values.get("preserve_minor_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationAppend(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationAppendImage",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationAppendImage:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationAppendImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationAppendImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationAppendImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a4c7646f770dc778bfe0b00d4b919e9eb9389911f96247c39de51b6952e4e1e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationAppendImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationAppendImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationAppendImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6654494739ff85fcabe507068dc58d06d1af0b5164225cb7c4b6379173acf086)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationAppendList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationAppendList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f38cca77ea95ea8ea37001053476e116f9d4bcab637b1273a64a23d0e9977df1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationAppendOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a8c2f0fd0309fe56b5888c12cfdad16ffb8b8250214a97227022dbb2096b4911)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationAppendOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__20311c1cb8a20ba09324372b2b6c90697d1d2090252a15ba599e1b79a9227493)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c7996bf263a796bca74270371cc55ba51e73c6a37d0d3fc4c3230204471acca7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__721d052f6949da1e40b38dc2357488e28f7d6ccc0a830f09c2d7c08b3f0f60c3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationAppend]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationAppend]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationAppend]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__255d1647caccc13581b490ccfe9c61966174bcc3999110494823af662579d57f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationAppendOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationAppendOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4d66b3f2ea28d11e3a753d76001beab1202978d404d66060dfac61ce6697014f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationAppendImage()

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityPriority")
    def reset_gravity_priority(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityPriority", []))

    @jsii.member(jsii_name="resetGravityPriorityVar")
    def reset_gravity_priority_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityPriorityVar", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPreserveMinorDimension")
    def reset_preserve_minor_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPreserveMinorDimension", []))

    @jsii.member(jsii_name="resetPreserveMinorDimensionVar")
    def reset_preserve_minor_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPreserveMinorDimensionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationAppendImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationAppendImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityInput")
    def gravity_priority_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityPriorityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityVarInput")
    def gravity_priority_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityPriorityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationAppendImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationAppendImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionInput")
    def preserve_minor_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "preserveMinorDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionVarInput")
    def preserve_minor_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "preserveMinorDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6a83b61c3c273206022ca617ddf3931abf9701f1f9acd062bc3acee2eeae0e1b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityPriority")
    def gravity_priority(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityPriority"))

    @gravity_priority.setter
    def gravity_priority(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5d83cb140da0f475720c992453edea5803d0c3573d7e8eb529baf3804a535b12)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityPriority", value)

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityVar")
    def gravity_priority_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityPriorityVar"))

    @gravity_priority_var.setter
    def gravity_priority_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__04318ccba173005a7d9663ed033ab7daafd21bf32ddf5112e9c20dea9edbc190)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityPriorityVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b9b945e6339a8b0ae8ea87c2a2e79ed77451b925407107e242a1386afbfcd048)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimension")
    def preserve_minor_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "preserveMinorDimension"))

    @preserve_minor_dimension.setter
    def preserve_minor_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c880a67c7c39464ec2e1b49a5fbc07953ddc817b472a466c98592f91fdaa2172)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "preserveMinorDimension", value)

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionVar")
    def preserve_minor_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "preserveMinorDimensionVar"))

    @preserve_minor_dimension_var.setter
    def preserve_minor_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__73ba4a99f8e570f34d9d7173bdeb9c7ac9c5270d82727ec061d4f9713980f8d5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "preserveMinorDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationAppend]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationAppend]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationAppend]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d95d3e85f6bf23f86b8fa76b2cf6428ec6cd249facf4436279a97f2dd9d925d2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationAspectCrop",
    jsii_struct_bases=[],
    name_mapping={
        "allow_expansion": "allowExpansion",
        "allow_expansion_var": "allowExpansionVar",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationAspectCrop:
    def __init__(
        self,
        *,
        allow_expansion: typing.Optional[builtins.str] = None,
        allow_expansion_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_expansion: Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image. Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        :param allow_expansion_var: Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image. Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        :param height: The height term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The width term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        :param x_position: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__44455b78bd36e47c25198b01f1e23a17cbe0beb06f3b8c8fe35ee50fef99b587)
            check_type(argname="argument allow_expansion", value=allow_expansion, expected_type=type_hints["allow_expansion"])
            check_type(argname="argument allow_expansion_var", value=allow_expansion_var, expected_type=type_hints["allow_expansion_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if allow_expansion is not None:
            self._values["allow_expansion"] = allow_expansion
        if allow_expansion_var is not None:
            self._values["allow_expansion_var"] = allow_expansion_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def allow_expansion(self) -> typing.Optional[builtins.str]:
        '''Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image.

        Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        '''
        result = self._values.get("allow_expansion")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def allow_expansion_var(self) -> typing.Optional[builtins.str]:
        '''Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image.

        Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        '''
        result = self._values.get("allow_expansion_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationAspectCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationAspectCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationAspectCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9e53e60681e4f42ae0451fad850688b7494b0621cc228ad2d0348b3a1c751e3d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationAspectCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1711be50ac723b5de5236c9d07af628b78abd28ec8830d414a39834b6af75c81)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationAspectCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d1b8081ac45c5f598605343552a141c930b7741b7d29a8402473fcdb1de37bf3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__079f6c2b936fa3db7fad506187708059d8322df789632d18c439a377082a2eb6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b3bde60523ee44dfdf203654e0d74637be01dd05a01aa81ba52ef0dbbf50bbd6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationAspectCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationAspectCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationAspectCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__096d38ddf4307a18ce4c3e280a467c888131208008b397aa4848a57ff7d8956d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationAspectCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationAspectCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4270ca270f0d435573a09cd40133753808683d22b41595a912401fe46b4468ac)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAllowExpansion")
    def reset_allow_expansion(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansion", []))

    @jsii.member(jsii_name="resetAllowExpansionVar")
    def reset_allow_expansion_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansionVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionInput")
    def allow_expansion_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVarInput")
    def allow_expansion_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansion")
    def allow_expansion(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansion"))

    @allow_expansion.setter
    def allow_expansion(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__32b26bb9c6d8eff4763a4ce8a2387fab0ed3224388a4652df2313a4eb9094e3c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansion", value)

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVar")
    def allow_expansion_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansionVar"))

    @allow_expansion_var.setter
    def allow_expansion_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f4e800f37c094bda5a0df711ed7bad20c64c24a40c2cfc48cc28d09de64ac00)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansionVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4b347247f382124ddc5c02e6f506e4a3d35cf3259f159b0eb74673d11fad494e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ffcf52b2972e98e89ebc85ab7cbab43585db1d0ce063b6454e14f43c04df51e5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ecf6e42f882504c7cbb51f6e3bd5e114c715c807a7ed3d4bcc3e9d806d637ec3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ef8262125fd2952677d71d78aeed532ad8c88f4ac24cc7789fdf7261e64934f5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__83858675786e10ac3044e9a1c6a1c8c35da134d2c5c537279cbb224f1dbb4323)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8b00e5298ce4ac0d531899f4f2da570043e2b4cd63e0c6c2d45561b0e108311c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b4e688d98dffc8c3b906856ca94691f4df5e19daaec6093c7795834843bcfe64)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__81c6fa06b784e42e32cc040934e4747d0d13e457f8f47e4b1d6040c8ed926bb3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationAspectCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationAspectCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationAspectCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7871ac0e63837931c21aa602ae4d0e0e04d65edec4aa04a8ae6b56df6888b2b8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationBackgroundColor",
    jsii_struct_bases=[],
    name_mapping={"color": "color", "color_var": "colorVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationBackgroundColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5242fa747b953437dbf2e6fc49f41279ce9f579474b37db148d2cfc95fa74126)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationBackgroundColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationBackgroundColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationBackgroundColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__14c822537e0f4f58753d7d9a1bb5d7ae80b94babfa6370b40a4b9606e5af22be)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationBackgroundColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f125b9e1a8866d4759a9090f81626c65f870ec87bd1896f63adaa1f4c973740f)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationBackgroundColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__22347bb8aa5d868c9917cdb18cd13a66d0217c25ebc5cf992b495b33fb3bce84)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e0992569425b1727a5760384992d01f7ef8ba0f59262058a91eaa5441606b74e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ea05b81eb7e92548da733645cc227c9a05941225b469522812317bc1797f805)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationBackgroundColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationBackgroundColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6612856e5d33f0efac3cdd484cb9de3dfb8d917b1ee3b7896fb0efee7bf6e5a6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationBackgroundColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationBackgroundColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7b8a788086ca0e2dabee15c5d2a72ff870549fc1f3118d318d27530769a26aaa)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f00d5fef6a43efd6b0d3a92da0d75630a8ae6f3c50dc50764d105373c83df571)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__301266238e4d1e3d9ed020e0fd5b804a212b020f92eab9140ee9f6e4446ad199)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationBackgroundColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationBackgroundColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationBackgroundColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b17ae5e1a49d7b196cccb28c21daf90ac9636f0bc542c61b892e8da7cbd4b84c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationBlur",
    jsii_struct_bases=[],
    name_mapping={"sigma": "sigma", "sigma_var": "sigmaVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationBlur:
    def __init__(
        self,
        *,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param sigma: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a4eaf494eacdec894208e01672d5fd5f91fde132338291a259a7f73e7a0e678)
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationBlur(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationBlurList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationBlurList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a3c6920dfe6345be4b9519aa1484af849e1656885e8a3b801e0a5cfba12edf9a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationBlurOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__06160257e64fa289b724bea5d2e8ab5da2a599297d4102d10f78bbb0e1be9fca)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationBlurOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2207d6d792528dc05d1e780dc4594ca1d752d3e4f9dbf5467ff1854e9e5aa0a1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cfaac72b9dcf7e942a978047709ee36cc7856e91436980014a2f55d550c58998)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8ec4b2417081fe3fa87e5c47a17256f25a64dddb66e10403369dea5a9739e5c9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationBlur]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationBlur]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c87e2795b88a72f0fb748eb14272925fb89b12d1247b0a1db8661732d3d37b81)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationBlurOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationBlurOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__017a44c741be5fba4d21ee244c7f3fd0b99b39d919054d10ed089bf1cbeb82ac)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__689df0ce18828a0f3caa9fb08e29677f70552f5d9e6c75083df36267a0c15941)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__acbd13d334467b24a82bad7dc371b3ef5e0d34d3f033ef5e910255e4507bbb77)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationBlur]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationBlur]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationBlur]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__68f57df8ef5a289565ae582472f8eac82bafa10ae31151b70d7bccc4b59ec89d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationChromaKey",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_feather": "hueFeather",
        "hue_feather_var": "hueFeatherVar",
        "hue_tolerance": "hueTolerance",
        "hue_tolerance_var": "hueToleranceVar",
        "hue_var": "hueVar",
        "lightness_feather": "lightnessFeather",
        "lightness_feather_var": "lightnessFeatherVar",
        "lightness_tolerance": "lightnessTolerance",
        "lightness_tolerance_var": "lightnessToleranceVar",
        "saturation_feather": "saturationFeather",
        "saturation_feather_var": "saturationFeatherVar",
        "saturation_tolerance": "saturationTolerance",
        "saturation_tolerance_var": "saturationToleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationChromaKey:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_feather: typing.Optional[builtins.str] = None,
        hue_feather_var: typing.Optional[builtins.str] = None,
        hue_tolerance: typing.Optional[builtins.str] = None,
        hue_tolerance_var: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness_feather: typing.Optional[builtins.str] = None,
        lightness_feather_var: typing.Optional[builtins.str] = None,
        lightness_tolerance: typing.Optional[builtins.str] = None,
        lightness_tolerance_var: typing.Optional[builtins.str] = None,
        saturation_feather: typing.Optional[builtins.str] = None,
        saturation_feather_var: typing.Optional[builtins.str] = None,
        saturation_tolerance: typing.Optional[builtins.str] = None,
        saturation_tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_feather: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        :param hue_feather_var: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        :param hue_tolerance: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        :param hue_tolerance_var: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        :param hue_var: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness_feather: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        :param lightness_feather_var: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        :param lightness_tolerance: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        :param lightness_tolerance_var: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        :param saturation_feather: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        :param saturation_feather_var: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        :param saturation_tolerance: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        :param saturation_tolerance_var: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__45dbf6246b415c94fe2bc9f97eca26488c3878f475a90e86a913034646d86c08)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_feather", value=hue_feather, expected_type=type_hints["hue_feather"])
            check_type(argname="argument hue_feather_var", value=hue_feather_var, expected_type=type_hints["hue_feather_var"])
            check_type(argname="argument hue_tolerance", value=hue_tolerance, expected_type=type_hints["hue_tolerance"])
            check_type(argname="argument hue_tolerance_var", value=hue_tolerance_var, expected_type=type_hints["hue_tolerance_var"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness_feather", value=lightness_feather, expected_type=type_hints["lightness_feather"])
            check_type(argname="argument lightness_feather_var", value=lightness_feather_var, expected_type=type_hints["lightness_feather_var"])
            check_type(argname="argument lightness_tolerance", value=lightness_tolerance, expected_type=type_hints["lightness_tolerance"])
            check_type(argname="argument lightness_tolerance_var", value=lightness_tolerance_var, expected_type=type_hints["lightness_tolerance_var"])
            check_type(argname="argument saturation_feather", value=saturation_feather, expected_type=type_hints["saturation_feather"])
            check_type(argname="argument saturation_feather_var", value=saturation_feather_var, expected_type=type_hints["saturation_feather_var"])
            check_type(argname="argument saturation_tolerance", value=saturation_tolerance, expected_type=type_hints["saturation_tolerance"])
            check_type(argname="argument saturation_tolerance_var", value=saturation_tolerance_var, expected_type=type_hints["saturation_tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_feather is not None:
            self._values["hue_feather"] = hue_feather
        if hue_feather_var is not None:
            self._values["hue_feather_var"] = hue_feather_var
        if hue_tolerance is not None:
            self._values["hue_tolerance"] = hue_tolerance
        if hue_tolerance_var is not None:
            self._values["hue_tolerance_var"] = hue_tolerance_var
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness_feather is not None:
            self._values["lightness_feather"] = lightness_feather
        if lightness_feather_var is not None:
            self._values["lightness_feather_var"] = lightness_feather_var
        if lightness_tolerance is not None:
            self._values["lightness_tolerance"] = lightness_tolerance
        if lightness_tolerance_var is not None:
            self._values["lightness_tolerance_var"] = lightness_tolerance_var
        if saturation_feather is not None:
            self._values["saturation_feather"] = saturation_feather
        if saturation_feather_var is not None:
            self._values["saturation_feather_var"] = saturation_feather_var
        if saturation_tolerance is not None:
            self._values["saturation_tolerance"] = saturation_tolerance
        if saturation_tolerance_var is not None:
            self._values["saturation_tolerance_var"] = saturation_tolerance_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        '''
        result = self._values.get("hue_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        '''
        result = self._values.get("hue_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        '''
        result = self._values.get("hue_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        '''
        result = self._values.get("hue_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        '''
        result = self._values.get("lightness_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        '''
        result = self._values.get("lightness_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        '''
        result = self._values.get("lightness_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        '''
        result = self._values.get("lightness_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        '''
        result = self._values.get("saturation_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        '''
        result = self._values.get("saturation_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        '''
        result = self._values.get("saturation_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        result = self._values.get("saturation_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationChromaKey(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationChromaKeyList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationChromaKeyList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0e022d62f9b1d60fe2d57ce578beb7c3cf91ff3d429ddad3a2ceb27a084533c7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationChromaKeyOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__36320fb229dac717f5e50c1382d05e12a388a275ba8de2ea8201c4472f7a7fbb)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationChromaKeyOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d6b39da49969f1f657fa96ec08931b20976aec72f47767596e6c5869d785f450)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6dd2f4a9b9328a97bb5753ec9ebd4d2d88bb06a2f46f85b81953cddb2469e3b6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bcab15c1d7091bad8db0a80ae8dcb6dd7450b428b02eac219245ca23be8bab65)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationChromaKey]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationChromaKey]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4186779501b14f7c4c04fba86525910d3d6eb21bbc60969c888defe0980f61b6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationChromaKeyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationChromaKeyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c529988b5a9a8057a4ce8ec509b43387c381ea407d3f0aa29c8a1164b26f2d7c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueFeather")
    def reset_hue_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeather", []))

    @jsii.member(jsii_name="resetHueFeatherVar")
    def reset_hue_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeatherVar", []))

    @jsii.member(jsii_name="resetHueTolerance")
    def reset_hue_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueTolerance", []))

    @jsii.member(jsii_name="resetHueToleranceVar")
    def reset_hue_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueToleranceVar", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightnessFeather")
    def reset_lightness_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeather", []))

    @jsii.member(jsii_name="resetLightnessFeatherVar")
    def reset_lightness_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeatherVar", []))

    @jsii.member(jsii_name="resetLightnessTolerance")
    def reset_lightness_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessTolerance", []))

    @jsii.member(jsii_name="resetLightnessToleranceVar")
    def reset_lightness_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessToleranceVar", []))

    @jsii.member(jsii_name="resetSaturationFeather")
    def reset_saturation_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeather", []))

    @jsii.member(jsii_name="resetSaturationFeatherVar")
    def reset_saturation_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeatherVar", []))

    @jsii.member(jsii_name="resetSaturationTolerance")
    def reset_saturation_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationTolerance", []))

    @jsii.member(jsii_name="resetSaturationToleranceVar")
    def reset_saturation_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherInput")
    def hue_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVarInput")
    def hue_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceInput")
    def hue_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVarInput")
    def hue_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherInput")
    def lightness_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVarInput")
    def lightness_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceInput")
    def lightness_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVarInput")
    def lightness_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherInput")
    def saturation_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVarInput")
    def saturation_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceInput")
    def saturation_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVarInput")
    def saturation_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c5ed2f9047b420b0ef5453b2d530fc3be641684822fd99028b4eda90d1b2a905)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeather")
    def hue_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeather"))

    @hue_feather.setter
    def hue_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__93b3778d9877dc7addb2a227aaaf23ad144d1a807eae74a3a0a7bf6f7e577e33)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeather", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVar")
    def hue_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeatherVar"))

    @hue_feather_var.setter
    def hue_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4592a87c8a4e4e483773207174aa92f0da9f6cee6ec9abf54edbb0e0ec233955)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueTolerance")
    def hue_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueTolerance"))

    @hue_tolerance.setter
    def hue_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b6034452ceba4588a00769bbb2a644b57b294306a8f77f1e6b69970283f0a9cf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVar")
    def hue_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueToleranceVar"))

    @hue_tolerance_var.setter
    def hue_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1a15c0c9537550f14378c2be07c168f8347e78497019585b762ee0b82bd5c3ab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__41f20a412544fdc8475fcfc5c01be125cdc135dda3ca762a2656852593943f14)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeather")
    def lightness_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeather"))

    @lightness_feather.setter
    def lightness_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6eebcb8541ccb9a1b9c469d8696c38c73f989978b8f94a524013f184796b1894)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeather", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVar")
    def lightness_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeatherVar"))

    @lightness_feather_var.setter
    def lightness_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa3eecc64a7c11f02c8179ee1081930edc963ceba35f6dbfbb55a4bb7b5ae6a4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessTolerance")
    def lightness_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessTolerance"))

    @lightness_tolerance.setter
    def lightness_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8f3b9824e8a5c78bc043fad87c980293c27650c3a8aa25872560cf87c9e52e68)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVar")
    def lightness_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessToleranceVar"))

    @lightness_tolerance_var.setter
    def lightness_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__051bebb281d8a8261ad739da6a0e54583eb43ab3c3ee797eababa558c277d58b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeather")
    def saturation_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeather"))

    @saturation_feather.setter
    def saturation_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__72384bf62b1b590624ef86fc78104e3433d95e701fdc0314444f1eff5920cab1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeather", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVar")
    def saturation_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeatherVar"))

    @saturation_feather_var.setter
    def saturation_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2b2195a481ee86b02d061a36efd2e0bff97914f85f1196aebbb1a96f21debc2a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationTolerance")
    def saturation_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationTolerance"))

    @saturation_tolerance.setter
    def saturation_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9b785e07ed0c845c635d77f8d0aaf9afda02d7d928662f6a7faabb1394438185)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVar")
    def saturation_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationToleranceVar"))

    @saturation_tolerance_var.setter
    def saturation_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2858eee6577c47385bf54abf3d9f6034b2869abc4fd36a2411e29c452d5941f5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationChromaKey]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationChromaKey]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationChromaKey]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__949e39adbae010953daa00d0acaf12c902d60e02e15206557a1b6a547aaacb0e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationComposite",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "placement": "placement",
        "placement_var": "placementVar",
        "scale": "scale",
        "scale_dimension": "scaleDimension",
        "scale_dimension_var": "scaleDimensionVar",
        "scale_var": "scaleVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationComposite:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationCompositeImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        placement: typing.Optional[builtins.str] = None,
        placement_var: typing.Optional[builtins.str] = None,
        scale: typing.Optional[builtins.str] = None,
        scale_dimension: typing.Optional[builtins.str] = None,
        scale_dimension_var: typing.Optional[builtins.str] = None,
        scale_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param placement: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        :param placement_var: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        :param scale: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param scale_dimension: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        :param scale_dimension_var: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        :param scale_var: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        :param x_position: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationCompositeImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a85dc2b10fc3b60ffb5d1ad298454cf5608c685684a5199ac84a1bbd19dbd550)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument placement", value=placement, expected_type=type_hints["placement"])
            check_type(argname="argument placement_var", value=placement_var, expected_type=type_hints["placement_var"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument scale_dimension", value=scale_dimension, expected_type=type_hints["scale_dimension"])
            check_type(argname="argument scale_dimension_var", value=scale_dimension_var, expected_type=type_hints["scale_dimension_var"])
            check_type(argname="argument scale_var", value=scale_var, expected_type=type_hints["scale_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if placement is not None:
            self._values["placement"] = placement
        if placement_var is not None:
            self._values["placement_var"] = placement_var
        if scale is not None:
            self._values["scale"] = scale
        if scale_dimension is not None:
            self._values["scale_dimension"] = scale_dimension
        if scale_dimension_var is not None:
            self._values["scale_dimension_var"] = scale_dimension_var
        if scale_var is not None:
            self._values["scale_var"] = scale_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationCompositeImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationCompositeImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        '''
        result = self._values.get("placement")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement_var(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        '''
        result = self._values.get("placement_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        '''
        result = self._values.get("scale_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        '''
        result = self._values.get("scale_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        '''
        result = self._values.get("scale_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationComposite(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationCompositeImage",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationCompositeImage:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationCompositeImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationCompositeImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationCompositeImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3f5b8de4fa7e292e8a98e64d9131bc540b71941a3dc0692207c59dc5493ec99a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationCompositeImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationCompositeImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0269195247e0107e8083c74f9bfb8921c82c269c7ed31f9bc7963f52abf5fef8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationCompositeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationCompositeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dfa12630ea50ae7eb6f2626cdbf0199c52eed3fe3129f2126b22490b25459a25)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationCompositeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__48c1b71829c69477517fcdef414b7110958c1f37ebfef9fdc1aeba5734079221)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationCompositeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d4c9fc44300d97787bca18cd4a9188d53d2ce3d786c78d0812caa04daeaffe41)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd51a917dacefbc2cd94b732341608ddc4c03cddb74cae647f961c980e31d507)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb17610df514de3b5233744da808ae79baa62e05b057ac9491c84e92297ae530)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationComposite]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationComposite]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__772ee7318ea8359364bbd1b8a13a5c8c8084e13654242b677754eb7c16cfbe54)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationCompositeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationCompositeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__45f90a4ba09c1d01a55bd004a2b370a87b755d4661e1ed7120351140ed8bccf8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationCompositeImage()

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPlacement")
    def reset_placement(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacement", []))

    @jsii.member(jsii_name="resetPlacementVar")
    def reset_placement_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacementVar", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetScaleDimension")
    def reset_scale_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimension", []))

    @jsii.member(jsii_name="resetScaleDimensionVar")
    def reset_scale_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimensionVar", []))

    @jsii.member(jsii_name="resetScaleVar")
    def reset_scale_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationCompositeImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationCompositeImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationCompositeImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="placementInput")
    def placement_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementInput"))

    @builtins.property
    @jsii.member(jsii_name="placementVarInput")
    def placement_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionInput")
    def scale_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVarInput")
    def scale_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleVarInput")
    def scale_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__239681d0fd325afa69e221a3f480460e94466f4c2aadcd082f9939167f8d7b0c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b00a76476a3e83c5fc5f90dc1c00e5374bbe35bc6e1e40c58b40e844e0017c9a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="placement")
    def placement(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placement"))

    @placement.setter
    def placement(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fdbd0a311f2b39262232a5966a660cbbdaf356a4c724d040069cfebef9d10a82)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placement", value)

    @builtins.property
    @jsii.member(jsii_name="placementVar")
    def placement_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placementVar"))

    @placement_var.setter
    def placement_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dc704923417c40efba5ec1b694eee87cd339af4ba9f99f497220a46577c13b0b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placementVar", value)

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scale"))

    @scale.setter
    def scale(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__68a6e29ce4751b04b228142d85400dc6194d367b89e17cbcc7a60ef396ae25f4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scale", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimension")
    def scale_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimension"))

    @scale_dimension.setter
    def scale_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2f1382f70c6885ed25b5510dc6befd6a0280c42e33ee702482e57c563564fb28)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimension", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVar")
    def scale_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimensionVar"))

    @scale_dimension_var.setter
    def scale_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6fb9eca53cf0b4cb8eafa575b3bb58fc1e32a33be158af17ccdabfa314a03097)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="scaleVar")
    def scale_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleVar"))

    @scale_var.setter
    def scale_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3f108f7720a82331758fb575490e05d53e86a244fd1da7c23436b44cb8783444)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4fa9e5c8bcc02335a04845a7171f69d21b82d8a55a6a586de77dcf9381580aff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a7d97cd35aeecda3d444d8493dbf62a6ffddc2109026adf4cfdff54a80c06824)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__206431a530dd0bb69fce999f19043505358f3d9a26c2d9667f4e9ca006a0818c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d7ad7619bf10778ead10087e9619dfca8c5b6c75ac931e17ba3020be290fd2a0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationComposite]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationComposite]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationComposite]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e55aba129cfe5ca0c9b4faf9c32777c8ce10898697b89d10539ac8063f25ce1f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationCompound",
    jsii_struct_bases=[],
    name_mapping={"transformations": "transformations"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationCompound:
    def __init__(
        self,
        *,
        transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param transformations: transformations block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b473e60545f55e74410623a3b1f62f8d66f41b64836060e7e1b0ff5194a447e7)
            check_type(argname="argument transformations", value=transformations, expected_type=type_hints["transformations"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if transformations is not None:
            self._values["transformations"] = transformations

    @builtins.property
    def transformations(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationCompoundTransformations"]]]:
        '''transformations block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        result = self._values.get("transformations")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationCompoundTransformations"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationCompound(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationCompoundList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationCompoundList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2bafcfa6156e8228afabeff108eb19420991d5732b52f582143821cf6847f10f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationCompoundOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__514617949c2c5a5380d7528baba3090804860173b51373382574b54e75f30161)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationCompoundOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__60221f8490cb83bc5139fbc49e7578fed693fa8a30f5cdedec189fdece039f6a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__097228a2583a8c185c6c4049535a8b442ff6f287c8764cfbb62ca4cbe46f75c3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c66f29916c0d30cfd3695351dc3bae9721346a30719379193a32ba2ca0fb1b61)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationCompound]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationCompound]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab6cc5f59e5e85e862be87bed82ea8fc722a950ad089174bcfec4e3dc3143669)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationCompoundOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationCompoundOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d823b86bb1b3fb196c4f0b90b21e40c61e9500384754f8d8534ef0cedac61fe4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformations")
    def put_transformations(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5159e739e16679aadb1c38975ccbc9dacc86b8af6406f2df3814e5da82959785)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTransformations", [value]))

    @jsii.member(jsii_name="resetTransformations")
    def reset_transformations(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformations", []))

    @builtins.property
    @jsii.member(jsii_name="transformations")
    def transformations(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationCompoundTransformationsList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationCompoundTransformationsList", jsii.get(self, "transformations"))

    @builtins.property
    @jsii.member(jsii_name="transformationsInput")
    def transformations_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationCompoundTransformations"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationCompoundTransformations"]]], jsii.get(self, "transformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationCompound]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationCompound]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationCompound]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e051128ac9b41c4de2524fe555de1d42247b636c02804dc80f3ffc68f5d49ca7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationCompoundTransformations",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationCompoundTransformations:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationCompoundTransformations(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationCompoundTransformationsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationCompoundTransformationsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f2bced747e26388efe3b61ba12e9a5d67fe9d393c4acebe6d89bf6a655c2c23d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationCompoundTransformationsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a7782b6087bf2d2ba5463512fbd302e2598ddbe722c41818c2b60f08b7948434)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationCompoundTransformationsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6946da4fe59d848906f668b642fba5792968a7486b3f1bb0cd8dfa06e58268e3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b46cd1459a2237443f484427eeb103fe418f2eed2cc06185be3a87ea3b7b9127)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5d9ca663a2015a66e14cd4b8ebcbd07caf5a9bd56e7369c9dc4e11a10feadd53)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationCompoundTransformations]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationCompoundTransformations]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationCompoundTransformations]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__508ae840b573a88fd237ed17d3ffe376562d3f339249ab76a41f9eb613011463)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationCompoundTransformationsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationCompoundTransformationsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c727a0dfc99dde5469903f183fd6a37d9d99bef85d086a21dfe5922a2919715a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationCompoundTransformations]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationCompoundTransformations]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationCompoundTransformations]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__56313e2a1961539b8257b1e922dcf391fb6ea60e2c1bcc4cfda09c2da7f8027b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationContrast",
    jsii_struct_bases=[],
    name_mapping={
        "brightness": "brightness",
        "brightness_var": "brightnessVar",
        "contrast": "contrast",
        "contrast_var": "contrastVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationContrast:
    def __init__(
        self,
        *,
        brightness: typing.Optional[builtins.str] = None,
        brightness_var: typing.Optional[builtins.str] = None,
        contrast: typing.Optional[builtins.str] = None,
        contrast_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param brightness: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        :param brightness_var: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        :param contrast: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param contrast_var: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__12c5e45b586695a7685b485d05f12100c216d5b1b1771f20b2fb2d9d42c74e51)
            check_type(argname="argument brightness", value=brightness, expected_type=type_hints["brightness"])
            check_type(argname="argument brightness_var", value=brightness_var, expected_type=type_hints["brightness_var"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument contrast_var", value=contrast_var, expected_type=type_hints["contrast_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if brightness is not None:
            self._values["brightness"] = brightness
        if brightness_var is not None:
            self._values["brightness_var"] = brightness_var
        if contrast is not None:
            self._values["contrast"] = contrast
        if contrast_var is not None:
            self._values["contrast_var"] = contrast_var

    @builtins.property
    def brightness(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        '''
        result = self._values.get("brightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def brightness_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        '''
        result = self._values.get("brightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        result = self._values.get("contrast_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationContrast(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationContrastList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationContrastList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__325482d99e2b1e58bf9b1b28cee323d56ee3fd9dcdc4190451c2670e2dfd3273)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationContrastOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f663979784a98fd9e60fe8e6889921cd1757bd108daf6bb2297758825eaf72d4)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationContrastOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b0d99692c0be9d4777509f6c8c79dacf3338b4966caf0ab8c39fd3d0d9729817)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__60be57ffdefc800bf432a9a740ba6fd661decdc7c4b2f5aa2331b79a320bfc82)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c9987b6e879ca8c5253c8a2ed548a6b10e8527f76fdf8e767099ed0353b7922d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationContrast]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationContrast]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d2c71465704feeab7e2cb29cf0da1a270dd81bfc5447cdfa5ec9d8258d8582cf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationContrastOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationContrastOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a64202a9c2ea1ef9cf619308c2092405c863a4a14dfe4b93fee9d1e01d81eba)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetBrightness")
    def reset_brightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightness", []))

    @jsii.member(jsii_name="resetBrightnessVar")
    def reset_brightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightnessVar", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetContrastVar")
    def reset_contrast_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrastVar", []))

    @builtins.property
    @jsii.member(jsii_name="brightnessInput")
    def brightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="brightnessVarInput")
    def brightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastVarInput")
    def contrast_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="brightness")
    def brightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightness"))

    @brightness.setter
    def brightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c2c24bc62e0d9fae160873c530b96e5329c5c58eb7e843bf6bf41d70e7c966ba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightness", value)

    @builtins.property
    @jsii.member(jsii_name="brightnessVar")
    def brightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightnessVar"))

    @brightness_var.setter
    def brightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2aa99f70227154f2a8d0dfd9428118e95210542485a6bd0de156507f542a18c7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrast"))

    @contrast.setter
    def contrast(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__886b981fbc3a07dc5516e692ee624e28b7013c6af7454492257c81a2700c9faa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrast", value)

    @builtins.property
    @jsii.member(jsii_name="contrastVar")
    def contrast_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrastVar"))

    @contrast_var.setter
    def contrast_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__54877fadb72f11c178d18547f6a08ffe6a26c639140bf2b40797ebcd44ed572d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrastVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationContrast]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationContrast]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationContrast]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ddd1e1e0034865b3da0d110a9f16560b0a8253759f12b90cda52f95deea5a72)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationCrop",
    jsii_struct_bases=[],
    name_mapping={
        "allow_expansion": "allowExpansion",
        "allow_expansion_var": "allowExpansionVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationCrop:
    def __init__(
        self,
        *,
        allow_expansion: typing.Optional[builtins.str] = None,
        allow_expansion_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_expansion: If cropping an area outside of the existing canvas, expands the image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        :param allow_expansion_var: If cropping an area outside of the existing canvas, expands the image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        :param gravity: Frame of reference for X and Y Positions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Frame of reference for X and Y Positions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The number of pixels to crop along the y-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The number of pixels to crop along the y-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The number of pixels to crop along the x-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The number of pixels to crop along the x-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        :param x_position: The x-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0e8ab59b11f56b7fce9ad393b34f57ade9a368b81b7c5c083947023acd392fcb)
            check_type(argname="argument allow_expansion", value=allow_expansion, expected_type=type_hints["allow_expansion"])
            check_type(argname="argument allow_expansion_var", value=allow_expansion_var, expected_type=type_hints["allow_expansion_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if allow_expansion is not None:
            self._values["allow_expansion"] = allow_expansion
        if allow_expansion_var is not None:
            self._values["allow_expansion_var"] = allow_expansion_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def allow_expansion(self) -> typing.Optional[builtins.str]:
        '''If cropping an area outside of the existing canvas, expands the image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        '''
        result = self._values.get("allow_expansion")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def allow_expansion_var(self) -> typing.Optional[builtins.str]:
        '''If cropping an area outside of the existing canvas, expands the image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        '''
        result = self._values.get("allow_expansion_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Frame of reference for X and Y Positions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Frame of reference for X and Y Positions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the y-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the y-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the x-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the x-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__798735a25302af882718eb6a9957b5c983554129228699ca35c09e0f311dcaf5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cf2b139def0663f71134312f57d33d187a86175f70109921a7fd1fe7a09ceddb)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__72bb8d80cd656357cab6c325859c2fafc717cbad9b859f7ed101f1e9b312810d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__90c6380add704766eb8e2acbb113da488ccf4e305fbd72d52d26b445e7305ee6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9457289617ef8ea70287e5482455b016a8fbd47a63383924c72a974579b88514)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c01b8997ccb6cc51ac5d53aae01e71e6299a405e7e9e1761a444019802b09585)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5d93c94e1f978a1d7be3be708a92d0493a63bf88865684fda61fb98e7f426dd7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAllowExpansion")
    def reset_allow_expansion(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansion", []))

    @jsii.member(jsii_name="resetAllowExpansionVar")
    def reset_allow_expansion_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansionVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionInput")
    def allow_expansion_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVarInput")
    def allow_expansion_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansion")
    def allow_expansion(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansion"))

    @allow_expansion.setter
    def allow_expansion(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c94d35db09da6d64378dbecf35eac1f1eac37cbb6e7ca978f9f9b14e3a5c51cb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansion", value)

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVar")
    def allow_expansion_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansionVar"))

    @allow_expansion_var.setter
    def allow_expansion_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c2b6907a72104229a6379800500097cd49e2726796c31e52c5121b724ef2dda1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansionVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f9842864fd0c9a610a0c26b849faa79f41f69e0b1f001acb8151d8f77ca27bd8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f225e455ec84b6d48fc3d914cfa15a91aec909eb95c19752fb4eb0f409b058d3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6937938940c86e870e26a21ae52ff592ce273357f00d7bf438d15819ad86b86e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d3a4e372ae599f3ad48b16d6a24ec11c287294e08b07257a9f071669de91ce1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1687d74f5680f8210c1237ba77be03a97d8715fff3ab8d91687d9dc36759c9e8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9582626fc93db338494ceb58c17d5f1084b5e740c0119570dcb14d49bb463a1c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6d3532ba7da2ecb40421361cea6b98895515ba72f30e989b22db83568b78bbf1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__351bf0baa0a9a0e694326862c74f15239bbb787d8e916c96053d3d1f51dd40fe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9406a18f2545eacbc1e395b81fff8965b3ab63f8988cff6dcb81aa7c636f9344)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2607c7b9f9dab9b35e305a23d17970e11e48c7b10068d450182bfa211b41d96e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e50edad72591e6033a4a2156bd588cae2b86258feb016b26ed706530e21202c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationFaceCrop",
    jsii_struct_bases=[],
    name_mapping={
        "algorithm": "algorithm",
        "algorithm_var": "algorithmVar",
        "confidence": "confidence",
        "confidence_var": "confidenceVar",
        "fail_gravity": "failGravity",
        "fail_gravity_var": "failGravityVar",
        "focus": "focus",
        "focus_var": "focusVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "padding": "padding",
        "padding_var": "paddingVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationFaceCrop:
    def __init__(
        self,
        *,
        algorithm: typing.Optional[builtins.str] = None,
        algorithm_var: typing.Optional[builtins.str] = None,
        confidence: typing.Optional[builtins.str] = None,
        confidence_var: typing.Optional[builtins.str] = None,
        fail_gravity: typing.Optional[builtins.str] = None,
        fail_gravity_var: typing.Optional[builtins.str] = None,
        focus: typing.Optional[builtins.str] = None,
        focus_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param algorithm: Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm DataAkamaiImagingPolicyImage#algorithm}
        :param algorithm_var: Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm_var DataAkamaiImagingPolicyImage#algorithm_var}
        :param confidence: With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image. Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence DataAkamaiImagingPolicyImage#confidence}
        :param confidence_var: With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image. Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence_var DataAkamaiImagingPolicyImage#confidence_var}
        :param fail_gravity: Controls placement of the crop if Image and Video Manager does not detect any faces in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        :param fail_gravity_var: Controls placement of the crop if Image and Video Manager does not detect any faces in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        :param focus: Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus DataAkamaiImagingPolicyImage#focus}
        :param focus_var: Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus_var DataAkamaiImagingPolicyImage#focus_var}
        :param gravity: Controls placement of the crop. Directions are relative to the face(s) plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Controls placement of the crop. Directions are relative to the face(s) plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param padding: The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        :param style: Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a9b55d972a130c555f543bf5a2bbc89d963f6785f96edef14cbd89c57deb721)
            check_type(argname="argument algorithm", value=algorithm, expected_type=type_hints["algorithm"])
            check_type(argname="argument algorithm_var", value=algorithm_var, expected_type=type_hints["algorithm_var"])
            check_type(argname="argument confidence", value=confidence, expected_type=type_hints["confidence"])
            check_type(argname="argument confidence_var", value=confidence_var, expected_type=type_hints["confidence_var"])
            check_type(argname="argument fail_gravity", value=fail_gravity, expected_type=type_hints["fail_gravity"])
            check_type(argname="argument fail_gravity_var", value=fail_gravity_var, expected_type=type_hints["fail_gravity_var"])
            check_type(argname="argument focus", value=focus, expected_type=type_hints["focus"])
            check_type(argname="argument focus_var", value=focus_var, expected_type=type_hints["focus_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if algorithm is not None:
            self._values["algorithm"] = algorithm
        if algorithm_var is not None:
            self._values["algorithm_var"] = algorithm_var
        if confidence is not None:
            self._values["confidence"] = confidence
        if confidence_var is not None:
            self._values["confidence_var"] = confidence_var
        if fail_gravity is not None:
            self._values["fail_gravity"] = fail_gravity
        if fail_gravity_var is not None:
            self._values["fail_gravity_var"] = fail_gravity_var
        if focus is not None:
            self._values["focus"] = focus
        if focus_var is not None:
            self._values["focus_var"] = focus_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def algorithm(self) -> typing.Optional[builtins.str]:
        '''Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm DataAkamaiImagingPolicyImage#algorithm}
        '''
        result = self._values.get("algorithm")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def algorithm_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm_var DataAkamaiImagingPolicyImage#algorithm_var}
        '''
        result = self._values.get("algorithm_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def confidence(self) -> typing.Optional[builtins.str]:
        '''With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image.

        Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence DataAkamaiImagingPolicyImage#confidence}
        '''
        result = self._values.get("confidence")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def confidence_var(self) -> typing.Optional[builtins.str]:
        '''With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image.

        Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence_var DataAkamaiImagingPolicyImage#confidence_var}
        '''
        result = self._values.get("confidence_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any faces in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        '''
        result = self._values.get("fail_gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any faces in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        '''
        result = self._values.get("fail_gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def focus(self) -> typing.Optional[builtins.str]:
        '''Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus DataAkamaiImagingPolicyImage#focus}
        '''
        result = self._values.get("focus")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def focus_var(self) -> typing.Optional[builtins.str]:
        '''Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus_var DataAkamaiImagingPolicyImage#focus_var}
        '''
        result = self._values.get("focus_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the face(s) plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the face(s) plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationFaceCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationFaceCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationFaceCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__732f2a36d20d9404b5a8e2ad21b2028ca5e68f518d1f9370fcee2594877be245)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationFaceCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c80de277efd1c8b600244fb79f76d4402d7f055cbf7a2a5312612ee0b657a63d)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationFaceCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cf2022a0f3182ca0ed1a5522f6586537a094aca9273f82871524b3cf4c7a07a4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f8470abcb6f660733d31878858c93307c4d895c96e56847ab2687a821fb19d0d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__995e73c6dec0dead2421e47df3d8328f7bdfdec27a03c7d523f2640a18e4062d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationFaceCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationFaceCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationFaceCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a0ebfca2044ac45ff823826b004959eac48377c7ceb610167ebe9653c4c67b88)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationFaceCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationFaceCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9e664f5fe408dfd11ec195ee49612e371fdfcc24d8c26180b6e71a75fdafc68d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAlgorithm")
    def reset_algorithm(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAlgorithm", []))

    @jsii.member(jsii_name="resetAlgorithmVar")
    def reset_algorithm_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAlgorithmVar", []))

    @jsii.member(jsii_name="resetConfidence")
    def reset_confidence(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetConfidence", []))

    @jsii.member(jsii_name="resetConfidenceVar")
    def reset_confidence_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetConfidenceVar", []))

    @jsii.member(jsii_name="resetFailGravity")
    def reset_fail_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravity", []))

    @jsii.member(jsii_name="resetFailGravityVar")
    def reset_fail_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravityVar", []))

    @jsii.member(jsii_name="resetFocus")
    def reset_focus(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFocus", []))

    @jsii.member(jsii_name="resetFocusVar")
    def reset_focus_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFocusVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="algorithmInput")
    def algorithm_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "algorithmInput"))

    @builtins.property
    @jsii.member(jsii_name="algorithmVarInput")
    def algorithm_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "algorithmVarInput"))

    @builtins.property
    @jsii.member(jsii_name="confidenceInput")
    def confidence_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "confidenceInput"))

    @builtins.property
    @jsii.member(jsii_name="confidenceVarInput")
    def confidence_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "confidenceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityInput")
    def fail_gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityVarInput")
    def fail_gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="focusInput")
    def focus_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "focusInput"))

    @builtins.property
    @jsii.member(jsii_name="focusVarInput")
    def focus_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "focusVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="algorithm")
    def algorithm(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "algorithm"))

    @algorithm.setter
    def algorithm(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a4d265651e34f8c05f9f00dfb4b67af41f29f1f9f80400c1e559ffef80069b84)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "algorithm", value)

    @builtins.property
    @jsii.member(jsii_name="algorithmVar")
    def algorithm_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "algorithmVar"))

    @algorithm_var.setter
    def algorithm_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7dd3abde5a26ad90e6e4701da6b768e81767b5c3dd0827f5bb9e80d83460fc8f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "algorithmVar", value)

    @builtins.property
    @jsii.member(jsii_name="confidence")
    def confidence(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "confidence"))

    @confidence.setter
    def confidence(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__33a14b51816653a2014b6564e8bc51e075ce2f7eb76522e60fcba9ffcc5cf913)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "confidence", value)

    @builtins.property
    @jsii.member(jsii_name="confidenceVar")
    def confidence_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "confidenceVar"))

    @confidence_var.setter
    def confidence_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d02c70958ea507dcd3384768bed86675d4aa4b084145ba5c6ba1dd5fee76bfbc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "confidenceVar", value)

    @builtins.property
    @jsii.member(jsii_name="failGravity")
    def fail_gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravity"))

    @fail_gravity.setter
    def fail_gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__885e7614bece959460e481fabf45925fd15ef4eda80c719a82de7492c7324870)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravity", value)

    @builtins.property
    @jsii.member(jsii_name="failGravityVar")
    def fail_gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravityVar"))

    @fail_gravity_var.setter
    def fail_gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1b03f56c8522116ecf31f9bf19084fe6d5f90843246aaea00a8f226d58412e2e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="focus")
    def focus(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "focus"))

    @focus.setter
    def focus(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__16f7f715fe361d3e024fd7fc9d040e13bf21dd144726d7b1535e4507ef33ec10)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "focus", value)

    @builtins.property
    @jsii.member(jsii_name="focusVar")
    def focus_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "focusVar"))

    @focus_var.setter
    def focus_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7ddc86cd65a328d25d3c18d74caa325d61d8039e60c84950ac2ed56eccd53865)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "focusVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3245e576c7cb2bc5adf2f625d914a91a1bd60fb3db40be5cc74914554cf3a5fe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__497b2779678646a1f363b3d933f8645f63b8370c22a0f1e5336caa79f5187c2c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6c5b6b2589a3e07bfc841b7abf414a72d0a2935f3515bf8982020ef08709da7a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__35f34057e084d631ede7afff5b43b693c41c735c87b7979617c5ad4cdac325c5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d8eb049957242c5d722da0af73819050b600d705bc8c24df66738bd179888b8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__78a1218ebb5c561fc36dcbcedcc93b08dc9e63f7f68799751e7042e029d38ff6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d24ff850b176a70c11b6cb233f57ebfc9b19b41d0e038fa556c61d3f03824600)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b7f51f30e9eeaacfee9802b91412ebc9878e0c102886d32ce464667240d02f58)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__71a9c7fbd06e80b21b465fa466399cba9a6efeb5cfee0d3e7b0831b079b0cad5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__41669bbb8f485b861f1c9e6ebe3e4bbda56cf11f2f4fecde4673f8737bc5e381)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationFaceCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationFaceCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationFaceCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6dd753d083489475c7e8569b2b94b9ca5fe01e6378ad12a8ad673b3ce65f806c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationFeatureCrop",
    jsii_struct_bases=[],
    name_mapping={
        "fail_gravity": "failGravity",
        "fail_gravity_var": "failGravityVar",
        "feature_radius": "featureRadius",
        "feature_radius_var": "featureRadiusVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "max_features": "maxFeatures",
        "max_features_var": "maxFeaturesVar",
        "min_feature_quality": "minFeatureQuality",
        "min_feature_quality_var": "minFeatureQualityVar",
        "padding": "padding",
        "padding_var": "paddingVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationFeatureCrop:
    def __init__(
        self,
        *,
        fail_gravity: typing.Optional[builtins.str] = None,
        fail_gravity_var: typing.Optional[builtins.str] = None,
        feature_radius: typing.Optional[builtins.str] = None,
        feature_radius_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        max_features: typing.Optional[builtins.str] = None,
        max_features_var: typing.Optional[builtins.str] = None,
        min_feature_quality: typing.Optional[builtins.str] = None,
        min_feature_quality_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fail_gravity: Controls placement of the crop if Image and Video Manager does not detect any features in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        :param fail_gravity_var: Controls placement of the crop if Image and Video Manager does not detect any features in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        :param feature_radius: The size in pixels of the important features to search for. If identified, two features never appear closer together than this value, ``8.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius DataAkamaiImagingPolicyImage#feature_radius}
        :param feature_radius_var: The size in pixels of the important features to search for. If identified, two features never appear closer together than this value, ``8.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius_var DataAkamaiImagingPolicyImage#feature_radius_var}
        :param gravity: Controls placement of the crop. Directions are relative to the region of interest plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Controls placement of the crop. Directions are relative to the region of interest plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param max_features: The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features DataAkamaiImagingPolicyImage#max_features}
        :param max_features_var: The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features_var DataAkamaiImagingPolicyImage#max_features_var}
        :param min_feature_quality: Determines the minimum quality level of the feature identified. To consider a feature important, the feature needs to surpass this value. Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality DataAkamaiImagingPolicyImage#min_feature_quality}
        :param min_feature_quality_var: Determines the minimum quality level of the feature identified. To consider a feature important, the feature needs to surpass this value. Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality_var DataAkamaiImagingPolicyImage#min_feature_quality_var}
        :param padding: Adds space around the region of interest. The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: Adds space around the region of interest. The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        :param style: Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1609f6d66d5c70c876cf95017c75488011a064f278bd6b62bcbca6aa4775cca7)
            check_type(argname="argument fail_gravity", value=fail_gravity, expected_type=type_hints["fail_gravity"])
            check_type(argname="argument fail_gravity_var", value=fail_gravity_var, expected_type=type_hints["fail_gravity_var"])
            check_type(argname="argument feature_radius", value=feature_radius, expected_type=type_hints["feature_radius"])
            check_type(argname="argument feature_radius_var", value=feature_radius_var, expected_type=type_hints["feature_radius_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument max_features", value=max_features, expected_type=type_hints["max_features"])
            check_type(argname="argument max_features_var", value=max_features_var, expected_type=type_hints["max_features_var"])
            check_type(argname="argument min_feature_quality", value=min_feature_quality, expected_type=type_hints["min_feature_quality"])
            check_type(argname="argument min_feature_quality_var", value=min_feature_quality_var, expected_type=type_hints["min_feature_quality_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fail_gravity is not None:
            self._values["fail_gravity"] = fail_gravity
        if fail_gravity_var is not None:
            self._values["fail_gravity_var"] = fail_gravity_var
        if feature_radius is not None:
            self._values["feature_radius"] = feature_radius
        if feature_radius_var is not None:
            self._values["feature_radius_var"] = feature_radius_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if max_features is not None:
            self._values["max_features"] = max_features
        if max_features_var is not None:
            self._values["max_features_var"] = max_features_var
        if min_feature_quality is not None:
            self._values["min_feature_quality"] = min_feature_quality
        if min_feature_quality_var is not None:
            self._values["min_feature_quality_var"] = min_feature_quality_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def fail_gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any features in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        '''
        result = self._values.get("fail_gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any features in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        '''
        result = self._values.get("fail_gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feature_radius(self) -> typing.Optional[builtins.str]:
        '''The size in pixels of the important features to search for.

        If identified, two features never appear closer together than this value, ``8.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius DataAkamaiImagingPolicyImage#feature_radius}
        '''
        result = self._values.get("feature_radius")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feature_radius_var(self) -> typing.Optional[builtins.str]:
        '''The size in pixels of the important features to search for.

        If identified, two features never appear closer together than this value, ``8.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius_var DataAkamaiImagingPolicyImage#feature_radius_var}
        '''
        result = self._values.get("feature_radius_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the region of interest plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the region of interest plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def max_features(self) -> typing.Optional[builtins.str]:
        '''The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features DataAkamaiImagingPolicyImage#max_features}
        '''
        result = self._values.get("max_features")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def max_features_var(self) -> typing.Optional[builtins.str]:
        '''The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features_var DataAkamaiImagingPolicyImage#max_features_var}
        '''
        result = self._values.get("max_features_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def min_feature_quality(self) -> typing.Optional[builtins.str]:
        '''Determines the minimum quality level of the feature identified.

        To consider a feature important, the feature needs to surpass this value.  Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality DataAkamaiImagingPolicyImage#min_feature_quality}
        '''
        result = self._values.get("min_feature_quality")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def min_feature_quality_var(self) -> typing.Optional[builtins.str]:
        '''Determines the minimum quality level of the feature identified.

        To consider a feature important, the feature needs to surpass this value.  Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality_var DataAkamaiImagingPolicyImage#min_feature_quality_var}
        '''
        result = self._values.get("min_feature_quality_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''Adds space around the region of interest.

        The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''Adds space around the region of interest.

        The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationFeatureCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationFeatureCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationFeatureCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ef416a9571346294263bece97626107199de258304bf232880925c52faa691bc)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationFeatureCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__95b9d24fb4c3337812a004df7114d0683f59b61b60658b8081a92ea011d38812)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationFeatureCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ef1c58e856448926cca491e8c7b8ed2ed7bbfb0edc54a19778e321175d893e2b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__52943adb56b6cfe20bf8ae9b15e08636151a0e524245d4efe26793a12052f589)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9423dc37ef55c7a6e52093920e377a53248b2234dbeb8126932479d0036b4803)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationFeatureCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationFeatureCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationFeatureCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d169467ecc803cf07969cc64fffa3c14e159e1981770e4bea7220791e9bc8aab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationFeatureCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationFeatureCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6386527ad88f6cd1459d9bb2121f56146cf13e077e8a575ca972062ad5034239)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetFailGravity")
    def reset_fail_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravity", []))

    @jsii.member(jsii_name="resetFailGravityVar")
    def reset_fail_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravityVar", []))

    @jsii.member(jsii_name="resetFeatureRadius")
    def reset_feature_radius(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureRadius", []))

    @jsii.member(jsii_name="resetFeatureRadiusVar")
    def reset_feature_radius_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureRadiusVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetMaxFeatures")
    def reset_max_features(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxFeatures", []))

    @jsii.member(jsii_name="resetMaxFeaturesVar")
    def reset_max_features_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxFeaturesVar", []))

    @jsii.member(jsii_name="resetMinFeatureQuality")
    def reset_min_feature_quality(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMinFeatureQuality", []))

    @jsii.member(jsii_name="resetMinFeatureQualityVar")
    def reset_min_feature_quality_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMinFeatureQualityVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="failGravityInput")
    def fail_gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityVarInput")
    def fail_gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featureRadiusInput")
    def feature_radius_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featureRadiusInput"))

    @builtins.property
    @jsii.member(jsii_name="featureRadiusVarInput")
    def feature_radius_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featureRadiusVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesInput")
    def max_features_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "maxFeaturesInput"))

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesVarInput")
    def max_features_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "maxFeaturesVarInput"))

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityInput")
    def min_feature_quality_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "minFeatureQualityInput"))

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityVarInput")
    def min_feature_quality_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "minFeatureQualityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravity")
    def fail_gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravity"))

    @fail_gravity.setter
    def fail_gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9e6c79f2d463fa2ba1e9d8b1fc0c75b1f6f791bf25afcd62c889ab49db2ed329)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravity", value)

    @builtins.property
    @jsii.member(jsii_name="failGravityVar")
    def fail_gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravityVar"))

    @fail_gravity_var.setter
    def fail_gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5cc122843d298480f44f90559ccccd3d23e2f1f708671331fde0b25c4f1ab90a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="featureRadius")
    def feature_radius(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featureRadius"))

    @feature_radius.setter
    def feature_radius(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__03bf9931ac5e929cb88cdddf8865026d812dc5e9093d260b8bbdf136b95db417)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featureRadius", value)

    @builtins.property
    @jsii.member(jsii_name="featureRadiusVar")
    def feature_radius_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featureRadiusVar"))

    @feature_radius_var.setter
    def feature_radius_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c3657e15f2fea444f288c83cd1cd155e42740522840589052106a4d35728a671)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featureRadiusVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__78c9e067e830eed4940fce971260af10f1ff6022fb88579eae17f1ce67790303)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1c69713fff72dd90662c7702fc2b096820a07dc5f8773717d6472b82e61de5a8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c845ba7cf6dca8b2e4400079401b7bad47c1ea7b198f786bb8a7181618110768)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c827e2f4ceda722a3197d59954ee64145672f9f07c216b0ad9133d103ee29853)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="maxFeatures")
    def max_features(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "maxFeatures"))

    @max_features.setter
    def max_features(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b48926e47a9e93ef9188a3ca25e2872b5c4c38371c9499eb75a3249a604f749a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "maxFeatures", value)

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesVar")
    def max_features_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "maxFeaturesVar"))

    @max_features_var.setter
    def max_features_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c884b3071027254c7b3697599d33c69a22854a2bb34449e9906853c43201858d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "maxFeaturesVar", value)

    @builtins.property
    @jsii.member(jsii_name="minFeatureQuality")
    def min_feature_quality(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "minFeatureQuality"))

    @min_feature_quality.setter
    def min_feature_quality(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__89b9a2ca6561f4a59a104a753ca9ebd70061338589586b98cc092a979cd3beba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "minFeatureQuality", value)

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityVar")
    def min_feature_quality_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "minFeatureQualityVar"))

    @min_feature_quality_var.setter
    def min_feature_quality_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a15c06019acf28728de44dc1d905c2caf584d36235c249a2382e69a636e4aaa0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "minFeatureQualityVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2b42b69766c9326efffe17ed1f043046d41fe2432cd6f5a3dec64dd37d3397f7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__000ffde532853eda61f79e8b79bdf542da080b2dd0cc8bdb851d5873c359b8fa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__add74cef3ee5335e58a5c14f087bc12edd67b5a69de435892e231141ae768414)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7154f9b8c8cd3b454316164c516117b9cba13605fcbed8e34bccd64e928a654d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f274785ba54fe02c3db28f436d4d66367744605eb6effab3d2cf7818ec211b31)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__daea88ad6120485be2c6070862259453daec034111619c13d3201e8e3a12a139)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationFeatureCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationFeatureCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationFeatureCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b42ded2b04aaadbdaa30498997372e9090d79d7baa9ed955d08fc084826c2c41)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationFitAndFill",
    jsii_struct_bases=[],
    name_mapping={
        "fill_transformation": "fillTransformation",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationFitAndFill:
    def __init__(
        self,
        *,
        fill_transformation: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationFitAndFillFillTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fill_transformation: fill_transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_transformation DataAkamaiImagingPolicyImage#fill_transformation}
        :param height: The height value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The width value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(fill_transformation, dict):
            fill_transformation = DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationFitAndFillFillTransformation(**fill_transformation)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5629b8517d71b5a3ad8f72abcf433b504ed62ed337e7cb36ac3a7b4668344867)
            check_type(argname="argument fill_transformation", value=fill_transformation, expected_type=type_hints["fill_transformation"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fill_transformation is not None:
            self._values["fill_transformation"] = fill_transformation
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def fill_transformation(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationFitAndFillFillTransformation"]:
        '''fill_transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_transformation DataAkamaiImagingPolicyImage#fill_transformation}
        '''
        result = self._values.get("fill_transformation")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationFitAndFillFillTransformation"], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationFitAndFill(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationFitAndFillFillTransformation",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationFitAndFillFillTransformation:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationFitAndFillFillTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationFitAndFillFillTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationFitAndFillFillTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5487182fbf6c8c2c0be9815aec32cd17f218a9d977862b22860e1e09be834254)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationFitAndFillFillTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationFitAndFillFillTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationFitAndFillFillTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5d3f6c9fa5b73b44eca6d8f53c66c580be6fde2c281345b853a9d70107025e5e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationFitAndFillList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationFitAndFillList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8b96d892b038f3dfb53f5a1ed819d157a23733e407eeb60141ec1004dd63c62b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationFitAndFillOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c8dfac08a51824e20c6e5b27b7ddb699dd7719a7fc8a30fa7efb339692319fb2)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationFitAndFillOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3df958f4e67754ef0349deccc4941fbb41de7d8be3a5dad1f3bcf688ba5bda11)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__64e80a48e2ecc6b4d1e02b260b50f9b8de201132608fabc3de5309ee85b1f2d2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f0ad5dfc247fc986883178d498e2d689051246a553868adef2478e65bd9e35a6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationFitAndFill]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationFitAndFill]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationFitAndFill]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c3cd3ae9307c60fd22077b7eadbbcdcd972420036e6d326958337a6fc6983ab6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationFitAndFillOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationFitAndFillOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2f1726f05c443991058f67df682e5253c4b71d302a31a0977b56f331f0f7e7c9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putFillTransformation")
    def put_fill_transformation(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationFitAndFillFillTransformation()

        return typing.cast(None, jsii.invoke(self, "putFillTransformation", [value]))

    @jsii.member(jsii_name="resetFillTransformation")
    def reset_fill_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFillTransformation", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="fillTransformation")
    def fill_transformation(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationFitAndFillFillTransformationOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationFitAndFillFillTransformationOutputReference, jsii.get(self, "fillTransformation"))

    @builtins.property
    @jsii.member(jsii_name="fillTransformationInput")
    def fill_transformation_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationFitAndFillFillTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationFitAndFillFillTransformation], jsii.get(self, "fillTransformationInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__de1edbbc2b8e7843eafd14969f9c1a32ea21c5e3f6dd9b5ac06d35a4ac54af60)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d3ed55e82945ba26472583ea4f3c6c979c6ce00033f66a99b35eab0503c0f5ba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b66eccf95bf4f499303769762bf7a94707d8e0ccfff907af885e05cb09fec61f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__18a627dab5d502bcea1fdfe8097726a32f8581a1b8f1cb0a108104c04f50ac23)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationFitAndFill]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationFitAndFill]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationFitAndFill]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6475cee74ce506b707236ce6372422a6464abc810d29c1dd42dce2ba69fa9b6e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationGoop",
    jsii_struct_bases=[],
    name_mapping={
        "chaos": "chaos",
        "chaos_var": "chaosVar",
        "density": "density",
        "density_var": "densityVar",
        "power": "power",
        "power_var": "powerVar",
        "seed": "seed",
        "seed_var": "seedVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationGoop:
    def __init__(
        self,
        *,
        chaos: typing.Optional[builtins.str] = None,
        chaos_var: typing.Optional[builtins.str] = None,
        density: typing.Optional[builtins.str] = None,
        density_var: typing.Optional[builtins.str] = None,
        power: typing.Optional[builtins.str] = None,
        power_var: typing.Optional[builtins.str] = None,
        seed: typing.Optional[builtins.str] = None,
        seed_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param chaos: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        :param chaos_var: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        :param density: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        :param density_var: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        :param power: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        :param power_var: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        :param seed: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        :param seed_var: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ce95e85fe64bcf0c675ccbe30841cee3daf9846b3a139f37fbd2fb8a120ec717)
            check_type(argname="argument chaos", value=chaos, expected_type=type_hints["chaos"])
            check_type(argname="argument chaos_var", value=chaos_var, expected_type=type_hints["chaos_var"])
            check_type(argname="argument density", value=density, expected_type=type_hints["density"])
            check_type(argname="argument density_var", value=density_var, expected_type=type_hints["density_var"])
            check_type(argname="argument power", value=power, expected_type=type_hints["power"])
            check_type(argname="argument power_var", value=power_var, expected_type=type_hints["power_var"])
            check_type(argname="argument seed", value=seed, expected_type=type_hints["seed"])
            check_type(argname="argument seed_var", value=seed_var, expected_type=type_hints["seed_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if chaos is not None:
            self._values["chaos"] = chaos
        if chaos_var is not None:
            self._values["chaos_var"] = chaos_var
        if density is not None:
            self._values["density"] = density
        if density_var is not None:
            self._values["density_var"] = density_var
        if power is not None:
            self._values["power"] = power
        if power_var is not None:
            self._values["power_var"] = power_var
        if seed is not None:
            self._values["seed"] = seed
        if seed_var is not None:
            self._values["seed_var"] = seed_var

    @builtins.property
    def chaos(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        '''
        result = self._values.get("chaos")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def chaos_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        '''
        result = self._values.get("chaos_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        '''
        result = self._values.get("density")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density_var(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        '''
        result = self._values.get("density_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        '''
        result = self._values.get("power")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power_var(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        '''
        result = self._values.get("power_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        '''
        result = self._values.get("seed")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed_var(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        result = self._values.get("seed_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationGoop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationGoopList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationGoopList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5e1ca6b561e27cd54c634c4cfc29adbd87b53463e269e5ca070fb920df966b6b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationGoopOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a55ed77c16d5f4a09d20b7c21c31c6ffe93226276b3a46e1239a22e01a2cb56)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationGoopOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__091023ecc45feee2626108b6360e50fbed32ed77ff3ab8290129feeb0d9b755e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b836638745a5790ae285288b1307fd8dad3804ed477e00644cf26ca9b18cc85f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__283c7c123ba1a44d181ec50c751fc45d03e74b024a01360a76cc1d110a18ef8b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationGoop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationGoop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9bb354cd3549b638eeb9b5261029bee9a3485cf5237eda68134abcb4f7fc2576)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationGoopOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationGoopOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dc5fc19922967dae627bff467cd6cd5f1a2faa53c39a56969d7d2f1e66a62392)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetChaos")
    def reset_chaos(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaos", []))

    @jsii.member(jsii_name="resetChaosVar")
    def reset_chaos_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaosVar", []))

    @jsii.member(jsii_name="resetDensity")
    def reset_density(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensity", []))

    @jsii.member(jsii_name="resetDensityVar")
    def reset_density_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensityVar", []))

    @jsii.member(jsii_name="resetPower")
    def reset_power(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPower", []))

    @jsii.member(jsii_name="resetPowerVar")
    def reset_power_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPowerVar", []))

    @jsii.member(jsii_name="resetSeed")
    def reset_seed(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeed", []))

    @jsii.member(jsii_name="resetSeedVar")
    def reset_seed_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeedVar", []))

    @builtins.property
    @jsii.member(jsii_name="chaosInput")
    def chaos_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosInput"))

    @builtins.property
    @jsii.member(jsii_name="chaosVarInput")
    def chaos_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosVarInput"))

    @builtins.property
    @jsii.member(jsii_name="densityInput")
    def density_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityInput"))

    @builtins.property
    @jsii.member(jsii_name="densityVarInput")
    def density_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="powerInput")
    def power_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerInput"))

    @builtins.property
    @jsii.member(jsii_name="powerVarInput")
    def power_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerVarInput"))

    @builtins.property
    @jsii.member(jsii_name="seedInput")
    def seed_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedInput"))

    @builtins.property
    @jsii.member(jsii_name="seedVarInput")
    def seed_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedVarInput"))

    @builtins.property
    @jsii.member(jsii_name="chaos")
    def chaos(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaos"))

    @chaos.setter
    def chaos(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d57f6fefbfe984088c7cd63b7dd9fe1b46c056076ed5b6a68d8f512e00f49f10)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaos", value)

    @builtins.property
    @jsii.member(jsii_name="chaosVar")
    def chaos_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaosVar"))

    @chaos_var.setter
    def chaos_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__595789b9ac5a5f5ef65610864ace361539bccaae1d20270b6be180181f952006)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaosVar", value)

    @builtins.property
    @jsii.member(jsii_name="density")
    def density(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "density"))

    @density.setter
    def density(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ab06a81e4596cd7d626c61e4510f3c057ae24f479cec959307a52b85fa43fc4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "density", value)

    @builtins.property
    @jsii.member(jsii_name="densityVar")
    def density_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "densityVar"))

    @density_var.setter
    def density_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2003ae73e3eeea4efffd13568fd85dea91c498c2f919558d7d143ec7f37b94dc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "densityVar", value)

    @builtins.property
    @jsii.member(jsii_name="power")
    def power(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "power"))

    @power.setter
    def power(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__949881f270327d51b4862fe763dacabe91d881725bd0a8e9df733a2f5a87a4e5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "power", value)

    @builtins.property
    @jsii.member(jsii_name="powerVar")
    def power_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "powerVar"))

    @power_var.setter
    def power_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f2b92f2679f72ddc4a5cf0c73cf38e2cd6d430d3b642b18d6ab0928ab7e8deea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "powerVar", value)

    @builtins.property
    @jsii.member(jsii_name="seed")
    def seed(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seed"))

    @seed.setter
    def seed(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__520ab52c2f0d8ef0104508f238aab604a3e15c1cebf15c3b219f3cfbe7c35af2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seed", value)

    @builtins.property
    @jsii.member(jsii_name="seedVar")
    def seed_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seedVar"))

    @seed_var.setter
    def seed_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f2a6732dbbed69febd2edfa3212630497ef9a45ebca877533d2e9bf924820fac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seedVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationGoop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationGoop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationGoop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__62c5389a74931150eea945ab8570c01a25e8cc4bcdb4132f01062621ebfcbd01)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationGrayscale",
    jsii_struct_bases=[],
    name_mapping={"type": "type", "type_var": "typeVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationGrayscale:
    def __init__(
        self,
        *,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param type: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__00a27a7215280f26c12c714cd03f81ff6881cec16173822c77c199583540cfd0)
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationGrayscale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationGrayscaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationGrayscaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a1bc3c1129a980aaf3e4b0477d6450cfdcf8798970d32dc9eb12d2b2a07a99cd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationGrayscaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b6aee213720890364d2b952e9b17825feb39abf93a54000be11fbdf6d6bd8d33)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationGrayscaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__86a6f83e6ecc9ae32f58825f76841a8e7dd4f968f88f80f85fb7f4a4fb0a33de)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aa574f1d2954853c023561489cc8d8e16507b200696fa0f790258802ca7faefa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b8fa4c661d9c6055f65988ba6c02bb9d676c183d7ca1f94b964f30854ab12f5d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationGrayscale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationGrayscale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__49475175edbbe78e6915f128c877405086f0805002fd4e8b706f284720937538)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationGrayscaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationGrayscaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c08abb2fab8d0203fca49434a886a47f053e7536ea6b5b7b699740a5cde6bc9a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2675ef2d29d824e0b83e07f86ae51a219782cc6be7c807f39cd9b74e03bd8148)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4f54b1d327d9f49714499be9e52c36789c85fe667b39de9a727b5d5d3bf8698e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationGrayscale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationGrayscale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationGrayscale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__da0a71e64d7944ce3a90d5a30d3bb3f2b245f90bf3c1c6a0dc1974f8b45306b5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationHsl",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "lightness": "lightness",
        "lightness_var": "lightnessVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationHsl:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness: typing.Optional[builtins.str] = None,
        lightness_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        :param lightness_var: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8420253d657ff32429b4d2eda0043102e11465a239c834f6d0aaa79ef26b1add)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness", value=lightness, expected_type=type_hints["lightness"])
            check_type(argname="argument lightness_var", value=lightness_var, expected_type=type_hints["lightness_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness is not None:
            self._values["lightness"] = lightness
        if lightness_var is not None:
            self._values["lightness_var"] = lightness_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        '''
        result = self._values.get("lightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        '''
        result = self._values.get("lightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationHsl(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationHslList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationHslList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fc8f29525bd4be83d9e1548f793638b876e5c1dcfaa302af615ce4ea8b7528ca)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationHslOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__21c893fc759eca96ba37ca01092b0c4b8359124429da03fc5438e734155e2fa4)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationHslOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a53b67a62f1ae6f7b2939046de99e715587b5495b81426b10307d0bdd2a3bb8a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fcd09ea2d3ba02ac03655cdfa24e15ce6bea9b134513949561b793bc1dd73450)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__902f67dd0e5efed83e4bd21009817b3d41063bfa8217bf0c48762c40b75ed797)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationHsl]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationHsl]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__155d2afa8a9dd105b56ed8336f6b13eb809d38bc2e574b6f09da9fbd4f1b2734)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationHslOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationHslOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__915c2d5f6a3e8b7597fb98274fe9452197f8144da5eaa8282cf34f6d5eb9c690)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightness")
    def reset_lightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightness", []))

    @jsii.member(jsii_name="resetLightnessVar")
    def reset_lightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessInput")
    def lightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessVarInput")
    def lightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__20906f3e95193ba7c7db260c2b38e5f5efbe782f7150edb05ff397372e33cef5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__697cc3ea309d5fe90070ce5bda3af6d5ca14920af9ed7f85b12aff6c318ed28e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightness")
    def lightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightness"))

    @lightness.setter
    def lightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0589bcf270fcc7d7e6dd8c1c76f012ac80ecdbc84b340eede29336967bb1cc4c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightness", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessVar")
    def lightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessVar"))

    @lightness_var.setter
    def lightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ced453f8a1426bb41ecaab3f4653ccbfdfeab115068ddf1cca0b5199f601601)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c6cd588a213114bc1965d70d854fdc2ef844d18f4c06f28f15b2858ecadfe942)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5d057fa9d8408888cef33e27008120f88a4601841b7d4bc2cd0ed766ec93a9a8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationHsl]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationHsl]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationHsl]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b6b08cafb786279e2ce19d96003a1f07223bc10bd20d5039e8a41362a19f87dc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationHsv",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationHsv:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        :param value: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac78cd682803ae860eb87a5716337bec4b5edf2eb62cf7bc11cf3b13b5f167e2)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationHsv(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationHsvList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationHsvList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fd373181d42c5db9e5de13ee7a5d8d0ee624bbba4467d24b29b001cf221e920d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationHsvOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af872e7a863c6af6f9f2033fe2a98ad3d8f45169a8df23a3e3c684c0e684cda5)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationHsvOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__903e502baf6c1662e2790dd3b27b332fed4a3160d112dc76cae8fbb6ae3b3bdd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__03869cd7041d57d49f025b46f52ded0f8f583bed88a0ec9561ae9b84b4fe2f5d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__52aeb8f6796ce5cdbee7ef4bf72a600131fc32b05e63befc267b26764fbc5f94)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationHsv]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationHsv]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__986831f88c4d83447a0723fcaef8670a3f88ad6ee201b904df1464eee757064f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationHsvOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationHsvOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__25372970a52d3ad2f5b32a2dd38ff667e76aef0ce2f5b944e52e3cfebea4cdde)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__12ef0042cd36c2bc84fec3c8ccc0b4f1004fdc295ea0ba5aabfd21f15df52d23)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c924ec3d556e8bdd46b57725f3128e991573bc283e3c1dfca527eaaea9831850)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__abc8b70c386854c6c5721cfac6888a7e40f439d5044dcbe81187a556f790fbe5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__49ed4e3e396c864c6dbee53470b9d632ecf322c980adb1eef2606b82f30120f7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b29abe5e08b0d1b09a8bccc2c3f6cd65fca33c19a59aa19674599d68b32db159)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1b91723275ffedf703861433e91bf4d61b5d083ca2edbdbbdb1805c6e8a4a370)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationHsv]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationHsv]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationHsv]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__073f204f4b8363f984699a77e1da2dda618f4dd343c81f3867838487b75f38e2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfDimension",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "dimension": "dimension",
        "dimension_var": "dimensionVar",
        "equal": "equal",
        "greater_than": "greaterThan",
        "less_than": "lessThan",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfDimension:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfDimensionDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        dimension: typing.Optional[builtins.str] = None,
        dimension_var: typing.Optional[builtins.str] = None,
        equal: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfDimensionEqual", typing.Dict[builtins.str, typing.Any]]] = None,
        greater_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfDimensionGreaterThan", typing.Dict[builtins.str, typing.Any]]] = None,
        less_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfDimensionLessThan", typing.Dict[builtins.str, typing.Any]]] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param dimension: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        :param dimension_var: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        :param equal: equal block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        :param greater_than: greater_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        :param less_than: less_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        :param value: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfDimensionDefault(**default)
        if isinstance(equal, dict):
            equal = DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfDimensionEqual(**equal)
        if isinstance(greater_than, dict):
            greater_than = DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfDimensionGreaterThan(**greater_than)
        if isinstance(less_than, dict):
            less_than = DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfDimensionLessThan(**less_than)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8ef7dd28a363ae0b7a6eb2e691a001a4a444c0e707ad7ea0b1dfb3136af8f1fb)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument dimension", value=dimension, expected_type=type_hints["dimension"])
            check_type(argname="argument dimension_var", value=dimension_var, expected_type=type_hints["dimension_var"])
            check_type(argname="argument equal", value=equal, expected_type=type_hints["equal"])
            check_type(argname="argument greater_than", value=greater_than, expected_type=type_hints["greater_than"])
            check_type(argname="argument less_than", value=less_than, expected_type=type_hints["less_than"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if dimension is not None:
            self._values["dimension"] = dimension
        if dimension_var is not None:
            self._values["dimension_var"] = dimension_var
        if equal is not None:
            self._values["equal"] = equal
        if greater_than is not None:
            self._values["greater_than"] = greater_than
        if less_than is not None:
            self._values["less_than"] = less_than
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfDimensionDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfDimensionDefault"], result)

    @builtins.property
    def dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        '''
        result = self._values.get("dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        '''
        result = self._values.get("dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def equal(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfDimensionEqual"]:
        '''equal block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        '''
        result = self._values.get("equal")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfDimensionEqual"], result)

    @builtins.property
    def greater_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfDimensionGreaterThan"]:
        '''greater_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        '''
        result = self._values.get("greater_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfDimensionGreaterThan"], result)

    @builtins.property
    def less_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfDimensionLessThan"]:
        '''less_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        '''
        result = self._values.get("less_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfDimensionLessThan"], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfDimension(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfDimensionDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfDimensionDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfDimensionDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfDimensionDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfDimensionDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__075b135bde851a53091cbaf9c681689037e78b3088a6d79d3a39292b829231c2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfDimensionDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfDimensionDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__32ff85957e0d6485343f2cd7d893e4439f8ffd854c1e52bddc3bc85305812bde)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfDimensionEqual",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfDimensionEqual:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfDimensionEqual(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfDimensionEqualOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfDimensionEqualOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4f07eaf8da0f97a3fbf4e1295ff813b3e0fc812b85531a94447e8e23b621da53)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfDimensionEqual], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfDimensionEqual],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b95c15fb293386df93d3387903babf594bdf3e53adf2d84e36b2869fadb8e4e0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfDimensionGreaterThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfDimensionGreaterThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfDimensionGreaterThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfDimensionGreaterThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfDimensionGreaterThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3e821999f49af4e7b385114233a7984a20e495450922d79ee03d451280ce84a9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfDimensionGreaterThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfDimensionGreaterThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7f8c7fa447eb7d613a96b9168eaca3a455439eb78030a6004a3aa313aaa9422b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfDimensionLessThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfDimensionLessThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfDimensionLessThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfDimensionLessThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfDimensionLessThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__10e90acaf3b2fa29c473a15a28ef889c9d53e2951be7524a2c3fa10966b6973a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfDimensionLessThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfDimensionLessThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fcbd107ccbeed9629adf9b45f2c2a6e0bb6ee99f39c018b1d40413bdc33195c5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfDimensionList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfDimensionList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8ffb07b465cf5264d5301456d0816cfd1132a2f551ce6e44e6ca5d0eb8dbda37)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfDimensionOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__090609301452bc96762bf26867b7e22cb69e79a2534fe7a8220149792efc9db5)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfDimensionOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__53b959285b14fd60f6d3e73b8796b152ecde8d87296cd22ceb5e1c68417d74f6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__84b000762fea195640ca8347d2cfa17b88d83de44a0094fc79bb45d14663f5d3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__664de54e864559a80274d4e8a3ba4919b2e108644f23207b37eca1d5c279a611)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfDimension]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfDimension]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f75e256e366de9d37e51817a2d9b20d23fc069391094c13e1ab585bd50937f4e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfDimensionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfDimensionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__71b3f73f6d9b069dc51f847e351a1ea4642310bbb1ddb2f626ec4ee87517f646)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfDimensionDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putEqual")
    def put_equal(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfDimensionEqual()

        return typing.cast(None, jsii.invoke(self, "putEqual", [value]))

    @jsii.member(jsii_name="putGreaterThan")
    def put_greater_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfDimensionGreaterThan()

        return typing.cast(None, jsii.invoke(self, "putGreaterThan", [value]))

    @jsii.member(jsii_name="putLessThan")
    def put_less_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfDimensionLessThan()

        return typing.cast(None, jsii.invoke(self, "putLessThan", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetDimension")
    def reset_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimension", []))

    @jsii.member(jsii_name="resetDimensionVar")
    def reset_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimensionVar", []))

    @jsii.member(jsii_name="resetEqual")
    def reset_equal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEqual", []))

    @jsii.member(jsii_name="resetGreaterThan")
    def reset_greater_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGreaterThan", []))

    @jsii.member(jsii_name="resetLessThan")
    def reset_less_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLessThan", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfDimensionDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfDimensionDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="equal")
    def equal(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfDimensionEqualOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfDimensionEqualOutputReference, jsii.get(self, "equal"))

    @builtins.property
    @jsii.member(jsii_name="greaterThan")
    def greater_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfDimensionGreaterThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfDimensionGreaterThanOutputReference, jsii.get(self, "greaterThan"))

    @builtins.property
    @jsii.member(jsii_name="lessThan")
    def less_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfDimensionLessThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfDimensionLessThanOutputReference, jsii.get(self, "lessThan"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfDimensionDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionInput")
    def dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionVarInput")
    def dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="equalInput")
    def equal_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfDimensionEqual], jsii.get(self, "equalInput"))

    @builtins.property
    @jsii.member(jsii_name="greaterThanInput")
    def greater_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfDimensionGreaterThan], jsii.get(self, "greaterThanInput"))

    @builtins.property
    @jsii.member(jsii_name="lessThanInput")
    def less_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfDimensionLessThan], jsii.get(self, "lessThanInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="dimension")
    def dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimension"))

    @dimension.setter
    def dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b42d622ec4a18d733448b95de807ad78ee7d5ae1b733396ce7d786b7648f5484)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimension", value)

    @builtins.property
    @jsii.member(jsii_name="dimensionVar")
    def dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimensionVar"))

    @dimension_var.setter
    def dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__51c0c8f6f7649d9e1d0f0cd76736152d7af6893f54e066d24cf06fa331e297b5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fbda48a035ea5e691246c602c09849afbc85fe6a826d5e34d769c73267ca3b09)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8e6c7fc867d1d2fda289c903d3ad3c875826c41e43bdf7c2ed3d7bf9c0ff990f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfDimension]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfDimension]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfDimension]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b1e72777fc879f4513612297bde8ee9d60e81c3d5b3b80953f11f7443b668f44)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfOrientation",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "landscape": "landscape",
        "portrait": "portrait",
        "square": "square",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfOrientation:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfOrientationDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        landscape: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfOrientationLandscape", typing.Dict[builtins.str, typing.Any]]] = None,
        portrait: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfOrientationPortrait", typing.Dict[builtins.str, typing.Any]]] = None,
        square: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfOrientationSquare", typing.Dict[builtins.str, typing.Any]]] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param landscape: landscape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        :param portrait: portrait block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        :param square: square block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfOrientationDefault(**default)
        if isinstance(landscape, dict):
            landscape = DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfOrientationLandscape(**landscape)
        if isinstance(portrait, dict):
            portrait = DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfOrientationPortrait(**portrait)
        if isinstance(square, dict):
            square = DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfOrientationSquare(**square)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__24917377223e6edcd6b9804078e70278ec25434f83a183a87ce6b4ea7a63ba55)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument landscape", value=landscape, expected_type=type_hints["landscape"])
            check_type(argname="argument portrait", value=portrait, expected_type=type_hints["portrait"])
            check_type(argname="argument square", value=square, expected_type=type_hints["square"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if landscape is not None:
            self._values["landscape"] = landscape
        if portrait is not None:
            self._values["portrait"] = portrait
        if square is not None:
            self._values["square"] = square

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfOrientationDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfOrientationDefault"], result)

    @builtins.property
    def landscape(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfOrientationLandscape"]:
        '''landscape block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        '''
        result = self._values.get("landscape")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfOrientationLandscape"], result)

    @builtins.property
    def portrait(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfOrientationPortrait"]:
        '''portrait block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        '''
        result = self._values.get("portrait")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfOrientationPortrait"], result)

    @builtins.property
    def square(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfOrientationSquare"]:
        '''square block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        result = self._values.get("square")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfOrientationSquare"], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfOrientation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfOrientationDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfOrientationDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfOrientationDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfOrientationDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfOrientationDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__33d2f8cfc5ee4ef7f26d75c63e9c1940def70a350aa6ee5fff53a1add22f2a69)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfOrientationDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfOrientationDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f1946a0eb35d38889b6c47c45d8a79cc0aefcd927ed2be1712ae5459c8afda14)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfOrientationLandscape",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfOrientationLandscape:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfOrientationLandscape(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfOrientationLandscapeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfOrientationLandscapeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a4d0bebbfe4c6f7e068bf7edd870875fe759082edcb90087cbcca6d5159e998)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfOrientationLandscape], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfOrientationLandscape],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f08bf1f52a64d567003d164eecd69ed691af84aed475b2c85f40f34d0186a57)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfOrientationList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfOrientationList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f10ac27000f96e9e5c6ed9a00e0c047919e6b569ab582ea683c9198475537bc4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfOrientationOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6be56b1646b11ad40e8d5845377c8cb109182955faf8a99dcc884e46093fb52c)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfOrientationOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5cb120ad33c2f4123080b304653dd1b376673e18687e6375ae016c9efbcff261)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eea895b4b9ee9f553c6fe9f3ef18fdf5f118641a395eb733d87b5f08571231a6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__653260d3685dfa71bdc22f4c21065a731bb794f46739952efff83aefeaaca637)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfOrientation]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfOrientation]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__48045dc822e11f857fb6c571dec61b66260a92195f8257f25edae745934e892e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfOrientationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfOrientationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3dba0025905336a32cd75bfad4a2d2b36c06ee5e91efa3f09d851b9c171d00af)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfOrientationDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putLandscape")
    def put_landscape(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfOrientationLandscape()

        return typing.cast(None, jsii.invoke(self, "putLandscape", [value]))

    @jsii.member(jsii_name="putPortrait")
    def put_portrait(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfOrientationPortrait()

        return typing.cast(None, jsii.invoke(self, "putPortrait", [value]))

    @jsii.member(jsii_name="putSquare")
    def put_square(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfOrientationSquare()

        return typing.cast(None, jsii.invoke(self, "putSquare", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetLandscape")
    def reset_landscape(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLandscape", []))

    @jsii.member(jsii_name="resetPortrait")
    def reset_portrait(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPortrait", []))

    @jsii.member(jsii_name="resetSquare")
    def reset_square(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSquare", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfOrientationDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfOrientationDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="landscape")
    def landscape(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfOrientationLandscapeOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfOrientationLandscapeOutputReference, jsii.get(self, "landscape"))

    @builtins.property
    @jsii.member(jsii_name="portrait")
    def portrait(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfOrientationPortraitOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfOrientationPortraitOutputReference", jsii.get(self, "portrait"))

    @builtins.property
    @jsii.member(jsii_name="square")
    def square(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfOrientationSquareOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfOrientationSquareOutputReference", jsii.get(self, "square"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfOrientationDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="landscapeInput")
    def landscape_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfOrientationLandscape], jsii.get(self, "landscapeInput"))

    @builtins.property
    @jsii.member(jsii_name="portraitInput")
    def portrait_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfOrientationPortrait"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfOrientationPortrait"], jsii.get(self, "portraitInput"))

    @builtins.property
    @jsii.member(jsii_name="squareInput")
    def square_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfOrientationSquare"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfOrientationSquare"], jsii.get(self, "squareInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfOrientation]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfOrientation]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfOrientation]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ebc27a14f98c67cfee081300e403d8d7d19b76bed372b5c03817a7b4df8e92d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfOrientationPortrait",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfOrientationPortrait:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfOrientationPortrait(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfOrientationPortraitOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfOrientationPortraitOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bfb7d40c5bc994f70c386215c0b10fab0151c6a0c75e7910f61f642a95fc90e6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfOrientationPortrait]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfOrientationPortrait], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfOrientationPortrait],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8c1edd09c5a08d0189448de11ec60728823b8f7cba8dd820b10e9d6d710b36c2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfOrientationSquare",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfOrientationSquare:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfOrientationSquare(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfOrientationSquareOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfOrientationSquareOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__632e557529870fffe8c81216d93347a9ac8d66c9cf52081edbb6e08de70ee535)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfOrientationSquare]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfOrientationSquare], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfOrientationSquare],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__06fe57f7fc93515288f57d2b8dc877b8381dfc8e9927f070b9056f24752c2ba4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationImQuery",
    jsii_struct_bases=[],
    name_mapping={
        "allowed_transformations": "allowedTransformations",
        "query_var": "queryVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationImQuery:
    def __init__(
        self,
        *,
        allowed_transformations: typing.Sequence[builtins.str],
        query_var: builtins.str,
    ) -> None:
        '''
        :param allowed_transformations: Specifies the transformations that can be applied using the query string parameter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allowed_transformations DataAkamaiImagingPolicyImage#allowed_transformations}
        :param query_var: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#query_var DataAkamaiImagingPolicyImage#query_var}.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a20eb4773cbbabab5928d1d91b4d75f290b86b7fca0a174008527cbb86090d7)
            check_type(argname="argument allowed_transformations", value=allowed_transformations, expected_type=type_hints["allowed_transformations"])
            check_type(argname="argument query_var", value=query_var, expected_type=type_hints["query_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "allowed_transformations": allowed_transformations,
            "query_var": query_var,
        }

    @builtins.property
    def allowed_transformations(self) -> typing.List[builtins.str]:
        '''Specifies the transformations that can be applied using the query string parameter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allowed_transformations DataAkamaiImagingPolicyImage#allowed_transformations}
        '''
        result = self._values.get("allowed_transformations")
        assert result is not None, "Required property 'allowed_transformations' is missing"
        return typing.cast(typing.List[builtins.str], result)

    @builtins.property
    def query_var(self) -> builtins.str:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#query_var DataAkamaiImagingPolicyImage#query_var}.'''
        result = self._values.get("query_var")
        assert result is not None, "Required property 'query_var' is missing"
        return typing.cast(builtins.str, result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationImQuery(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationImQueryList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationImQueryList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a0ebe8c7a65bd5c290a03066e885cc1ff350f78e31518d5bbe8ba22f8e5e0708)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationImQueryOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__755c2848e8d544648d1ad40cf9a3aa5e0d4eed1661e79ceda75d0cfc3abf39e7)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationImQueryOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0be511ad96a915665e7b0a220dd97adb2df05fa59fb45a14eddd7af1b361ae85)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__da9db0b2ecf864079aee04435f432577b85d1c90335109fa5ac50ac71a5db36e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ed934c2653938ec1c1f8a0779ea8b1cb7d694a6fb6017c60a9053be24b4be89)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationImQuery]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationImQuery]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationImQuery]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ee7a222711a07c44123a15758b7f388ec2eb73751a4a2e2f4f1ebb147b4ba13)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationImQueryOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationImQueryOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f8bc36ae6aac5ec2cfdea34810589983b3e0927c8a71e81ac3169ee48e45bf82)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @builtins.property
    @jsii.member(jsii_name="allowedTransformationsInput")
    def allowed_transformations_input(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "allowedTransformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="queryVarInput")
    def query_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "queryVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowedTransformations")
    def allowed_transformations(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "allowedTransformations"))

    @allowed_transformations.setter
    def allowed_transformations(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d2556c03e3ceb0f0fd1f389603642dc1073210781189f98300129ce305955717)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowedTransformations", value)

    @builtins.property
    @jsii.member(jsii_name="queryVar")
    def query_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "queryVar"))

    @query_var.setter
    def query_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d345fa179c1b394660855bf0dce310f1741c2283f004136a2f342edbef22ff0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "queryVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationImQuery]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationImQuery]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationImQuery]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0544b387ad2267f27efedcce4939be95b5081d9464b8c802de8b7175599c6763)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationMaxColors",
    jsii_struct_bases=[],
    name_mapping={"colors": "colors", "colors_var": "colorsVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationMaxColors:
    def __init__(
        self,
        *,
        colors: typing.Optional[builtins.str] = None,
        colors_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param colors: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        :param colors_var: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__668d7f61f05e4a81b1c6aba96268c65e8aa5b963a9d47f78021916e7ebba874e)
            check_type(argname="argument colors", value=colors, expected_type=type_hints["colors"])
            check_type(argname="argument colors_var", value=colors_var, expected_type=type_hints["colors_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if colors is not None:
            self._values["colors"] = colors
        if colors_var is not None:
            self._values["colors_var"] = colors_var

    @builtins.property
    def colors(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        '''
        result = self._values.get("colors")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def colors_var(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        result = self._values.get("colors_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationMaxColors(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationMaxColorsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationMaxColorsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5e6f493e9e2aab120c68d4ffd098e09a11fbb33108bfb9bb7e6168efdb6298cf)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationMaxColorsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__99247df490a22a7cb02cad21d333dc37eaf7eb0ce4022dbb6c9f1c1d9a4918ac)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationMaxColorsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cc1adf3d8ce6e2cc15084b457fdf4c9f36cfa023f538d8f8616cd7d482406381)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__29c9bd85f63069b702440aa57e9c53f321a4931ffdf81da259d77a657349a4cf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fd92a4e9dc388147ce435660081edd11711e07cee85425576d662e75373286a2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationMaxColors]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationMaxColors]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6882ad413f10f6e2fb09dbdbd4c3fab18b678701d7d9483e7317e7eb99a710a1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationMaxColorsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationMaxColorsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__00702b4278f0a60c6b906764fceb398a5597723b042f0bf1e11ceaa23174faa1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColors")
    def reset_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColors", []))

    @jsii.member(jsii_name="resetColorsVar")
    def reset_colors_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorsVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorsInput")
    def colors_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsInput"))

    @builtins.property
    @jsii.member(jsii_name="colorsVarInput")
    def colors_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsVarInput"))

    @builtins.property
    @jsii.member(jsii_name="colors")
    def colors(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colors"))

    @colors.setter
    def colors(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a6bff8182afc8f43545fa68d35b07e96719ad0bee35eec2febd614ab3e07089)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colors", value)

    @builtins.property
    @jsii.member(jsii_name="colorsVar")
    def colors_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorsVar"))

    @colors_var.setter
    def colors_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__12832c1bb8fe8d1c29fcc93842a7a11e5a2b8b00753f7f395dc3a0c73deabc19)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorsVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationMaxColors]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationMaxColors]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationMaxColors]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f6ad92e730e4a8bfec5ddcc1560a42641c88f6a87a476f80c0f8d12ce812bd0b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationMirror",
    jsii_struct_bases=[],
    name_mapping={
        "horizontal": "horizontal",
        "horizontal_var": "horizontalVar",
        "vertical": "vertical",
        "vertical_var": "verticalVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationMirror:
    def __init__(
        self,
        *,
        horizontal: typing.Optional[builtins.str] = None,
        horizontal_var: typing.Optional[builtins.str] = None,
        vertical: typing.Optional[builtins.str] = None,
        vertical_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param horizontal: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        :param horizontal_var: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        :param vertical: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        :param vertical_var: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b485f9684b5407ba365cf837e572d3e87d1f79b0cd9a5d43b5ead455827f46ed)
            check_type(argname="argument horizontal", value=horizontal, expected_type=type_hints["horizontal"])
            check_type(argname="argument horizontal_var", value=horizontal_var, expected_type=type_hints["horizontal_var"])
            check_type(argname="argument vertical", value=vertical, expected_type=type_hints["vertical"])
            check_type(argname="argument vertical_var", value=vertical_var, expected_type=type_hints["vertical_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if horizontal is not None:
            self._values["horizontal"] = horizontal
        if horizontal_var is not None:
            self._values["horizontal_var"] = horizontal_var
        if vertical is not None:
            self._values["vertical"] = vertical
        if vertical_var is not None:
            self._values["vertical_var"] = vertical_var

    @builtins.property
    def horizontal(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        '''
        result = self._values.get("horizontal")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def horizontal_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        '''
        result = self._values.get("horizontal_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        '''
        result = self._values.get("vertical")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        result = self._values.get("vertical_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationMirror(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationMirrorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationMirrorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aa4efb487620ba8d1025ba1da8b33f643a42abc118bbd6cff5793e2b01b51318)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationMirrorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__53811279d515f605d949854b9e31e3e444e93e43a8c5ede98cead3313ea3de03)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationMirrorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__db7e3378da1c942d63b66cfb50a2664c9866c86b8bc7e3752787b84ab1a381d7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__08bccf4ccb2fc3b15fddc93daada97411d1ed2f7d4e6f6d1d8ce06596ceb94c6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d4a0b7fefa0e36a499577b1a2f0664e48ae995965e53ecf7d2720d13e70b239d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationMirror]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationMirror]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a853af0537a0f06483680166dd70eb4a2d322a5880c14c2d28c102a0946bbd57)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationMirrorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationMirrorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1ce172ce7ad33b622ecb06844cda9e3b47127bd51f13e32c38409674babd0a90)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHorizontal")
    def reset_horizontal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontal", []))

    @jsii.member(jsii_name="resetHorizontalVar")
    def reset_horizontal_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontalVar", []))

    @jsii.member(jsii_name="resetVertical")
    def reset_vertical(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVertical", []))

    @jsii.member(jsii_name="resetVerticalVar")
    def reset_vertical_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVerticalVar", []))

    @builtins.property
    @jsii.member(jsii_name="horizontalInput")
    def horizontal_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontalVarInput")
    def horizontal_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalInput")
    def vertical_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalVarInput")
    def vertical_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontal")
    def horizontal(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontal"))

    @horizontal.setter
    def horizontal(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__61cbf5707d18d3b0793d225535ed3bcc2ef662d40f3fd837228583896180ddeb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontal", value)

    @builtins.property
    @jsii.member(jsii_name="horizontalVar")
    def horizontal_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontalVar"))

    @horizontal_var.setter
    def horizontal_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__65c26e33e3c7dfe2c23705daae84bf92b1f38718417edbb595f5cb519f0be11b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontalVar", value)

    @builtins.property
    @jsii.member(jsii_name="vertical")
    def vertical(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "vertical"))

    @vertical.setter
    def vertical(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bec016d055e067eba95f114f1cb603fd6d0ef2f232356d7ec5b885c5782fbf49)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "vertical", value)

    @builtins.property
    @jsii.member(jsii_name="verticalVar")
    def vertical_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "verticalVar"))

    @vertical_var.setter
    def vertical_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__edc96190e38ac3e4f2135726f273441e1f8a6eac51f2c5e880283fb1a5534085)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "verticalVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationMirror]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationMirror]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationMirror]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d1847f08bd202ca19d2dd781efe24c9cd7371f3d83b89ea39f3d753b3567eeb0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationMonoHue",
    jsii_struct_bases=[],
    name_mapping={"hue": "hue", "hue_var": "hueVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationMonoHue:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8394dbae9dac9640c9b99657f406752b0fc5053a3cc739584ece70dd4980542c)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationMonoHue(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationMonoHueList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationMonoHueList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ba76f3f9604487948366f8204a2022e98a5ff2e5ce841a61f934ca171efeaaaa)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationMonoHueOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__01bb84f6e263fee6dc6471cd7c25bb43d234785764be8395132d9e4be5dabe5b)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationMonoHueOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9079cc57370ad084317179024ec592b590e870cd99a8986f35f0313eb6efb078)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af4c846270a0d9396b11b1bf892f0f5ccfd7a76f510be5c3556404b734009033)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d50f50d356db6af920ab18d68032e4d39b80a6f355d73a6b7d26ffc7415258b3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationMonoHue]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationMonoHue]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__27265987e45563a24fcc8c468cbd4b84125f84ae021cc0e84ba4b4b2335a4542)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationMonoHueOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationMonoHueOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ad85a295808a86fb52bf2b46c21bda6bcda4e6162f41922680e1237cdec25602)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d7c904317f5fc6e0cc072eb060f03bcc409a5265b5d66b9b0554fe00fbdd226a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ebe00566929cf008b306bc88d17284236f1ce9586ffe87722c87260893d5b13a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationMonoHue]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationMonoHue]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationMonoHue]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1081930d96908ba3a4c8bb9e5b917fcd18974ea26447a69b77dec63e1750d0f3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationOpacity",
    jsii_struct_bases=[],
    name_mapping={"opacity": "opacity", "opacity_var": "opacityVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationOpacity:
    def __init__(
        self,
        *,
        opacity: typing.Optional[builtins.str] = None,
        opacity_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param opacity: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param opacity_var: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f86c567f31c6bd6917b1b406f4d26f4c743dda37b6158013317b4d9080d7a5e3)
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument opacity_var", value=opacity_var, expected_type=type_hints["opacity_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if opacity is not None:
            self._values["opacity"] = opacity
        if opacity_var is not None:
            self._values["opacity_var"] = opacity_var

    @builtins.property
    def opacity(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def opacity_var(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        result = self._values.get("opacity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationOpacity(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationOpacityList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationOpacityList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f696ae27d6ee854e42f941b38fb5e8495ea5c766efe0f380c7b9d153508ab34c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationOpacityOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0fc302e680ef13e6ab62ffa85b2b42d392c72468120624721e343f3d7ca8586d)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationOpacityOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b86ce471af6a38c381fe52e336491f20c1f6c8908fa0ae3892c1818bff105dc8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af880586a97c8b20ff5ec0cf522a5fe4a6aad84cecd951d42b788666a824c030)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b1fdf8bc7a55660898a6986be3a5cbae37db735b724209d4851f63e04636674c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationOpacity]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationOpacity]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fd9759f8295f8e27f20c1fd51b3321e1576c57db674224c96820e527fc4d6fb1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationOpacityOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationOpacityOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e8697d9b16a6802dae03e9008d74574e641d059507999c2e3b953476c84984df)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetOpacityVar")
    def reset_opacity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacityVar", []))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityVarInput")
    def opacity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacity"))

    @opacity.setter
    def opacity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__84064e2bb15d0c0c057702612b6ba092b6123493598abb306bf1e099b4f7293b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacity", value)

    @builtins.property
    @jsii.member(jsii_name="opacityVar")
    def opacity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacityVar"))

    @opacity_var.setter
    def opacity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__64a038f7a42e034f1025fc5cf3b665ebee97ea6d98df99fd97b784626395bfaa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacityVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationOpacity]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationOpacity]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationOpacity]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ba0c621d763c2a7587c4f3a4e5327a2f6c32e2edcb80c334f884ae9e941b093)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e10a2572d354d782bf062dd9785353293f6c44fb7409d9602f237fb1c65e9e15)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putAppend")
    def put_append(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationAppend, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d282564d6af7f7bcb52eeec70100019b936b06fb76664171e7518c3289e518d2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putAppend", [value]))

    @jsii.member(jsii_name="putAspectCrop")
    def put_aspect_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationAspectCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e23e8803937ef68043ae852167ff6176dc5ed02b5c817baedddb169d7b63ce1e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putAspectCrop", [value]))

    @jsii.member(jsii_name="putBackgroundColor")
    def put_background_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4315d517c6fc8d5d60c1479ee3b540e01688a83ae946fef47196ff638f0ca45c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBackgroundColor", [value]))

    @jsii.member(jsii_name="putBlur")
    def put_blur(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationBlur, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b0f710e942d752c38c329bb4c26ad7805e0ff2b5e66a1ff707563d6acdc8f313)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBlur", [value]))

    @jsii.member(jsii_name="putChromaKey")
    def put_chroma_key(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationChromaKey, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e707f29775327468c54f9244766c543667e35f83f8b9372ed84f1368e7fc9de2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putChromaKey", [value]))

    @jsii.member(jsii_name="putComposite")
    def put_composite(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationComposite, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c42685d7574bfb87e2575a296afaea319359531bf7e30d752c8db5495c3382d1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putComposite", [value]))

    @jsii.member(jsii_name="putCompound")
    def put_compound(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationCompound, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f62e44942085ac0ab20492b265d2c139bfb5e66cb0103c053f7551d2f8bcc624)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCompound", [value]))

    @jsii.member(jsii_name="putContrast")
    def put_contrast(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationContrast, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c5d65029520e6a03ca6dee7dedd82c70454c885a5ec77ef2eb3c684390e15f89)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putContrast", [value]))

    @jsii.member(jsii_name="putCrop")
    def put_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__79421a9c2f78154de46f2c0d3241b6ba43e6f6b22d9f3f35c5c9faacd5342a78)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCrop", [value]))

    @jsii.member(jsii_name="putFaceCrop")
    def put_face_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationFaceCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f6393875ad3aaf21ec18d147481ca8b8f9cb75a3a38452649d8de34d699864d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFaceCrop", [value]))

    @jsii.member(jsii_name="putFeatureCrop")
    def put_feature_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationFeatureCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea2bcb61c8a635652c4e10dd52c69fee4f3b5d4f6214a62669bd2d62a47b32b8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFeatureCrop", [value]))

    @jsii.member(jsii_name="putFitAndFill")
    def put_fit_and_fill(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationFitAndFill, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2b7febfac5a056f7ef5bd1fc626bb118de065dd914cebc57cdce34b50117ec3c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFitAndFill", [value]))

    @jsii.member(jsii_name="putGoop")
    def put_goop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationGoop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e582a981463a4281674a2167828b0d8d52210c6f408eee62c1dda28569d3065c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGoop", [value]))

    @jsii.member(jsii_name="putGrayscale")
    def put_grayscale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationGrayscale, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b25cebf3de8ad44907f000dd0b6464e6d2bbeeea6e312afbd509abf594af0e62)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGrayscale", [value]))

    @jsii.member(jsii_name="putHsl")
    def put_hsl(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationHsl, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f66cc4f4b0152ec9cf1072fbd913d9de152fca8b618b00208cb712a928b5933)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsl", [value]))

    @jsii.member(jsii_name="putHsv")
    def put_hsv(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationHsv, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dab85109a73b5c98f42be9d24867c798c40d9db82331c097eb453b88f6c103cc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsv", [value]))

    @jsii.member(jsii_name="putIfDimension")
    def put_if_dimension(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfDimension, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1d0e25bb0009f7367107ad325f1202ab1d3004e24b86f6c39159df75ed145980)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfDimension", [value]))

    @jsii.member(jsii_name="putIfOrientation")
    def put_if_orientation(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__42dd73f7bdde6664ce7b9344fa1e6884bdd9e08409b7cebe587d87e20cb69056)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfOrientation", [value]))

    @jsii.member(jsii_name="putImQuery")
    def put_im_query(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationImQuery, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0b5715108d6375fe05ac941c67ecf675f18b382e0830d30a4379c2c3d636fa19)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putImQuery", [value]))

    @jsii.member(jsii_name="putMaxColors")
    def put_max_colors(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationMaxColors, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a5bff9263d8cfe4d07c083db80c52656bcbf10b7f5e0ef667475eb27c744239b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMaxColors", [value]))

    @jsii.member(jsii_name="putMirror")
    def put_mirror(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationMirror, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a130c75543050ecfb504d54f04d689aad71e5ff6e9917a4c2ad704bf46a67bf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMirror", [value]))

    @jsii.member(jsii_name="putMonoHue")
    def put_mono_hue(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationMonoHue, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__69774e3c3fc5769600de96295595cfaba7313b8ef7b7ad5bcc4852c5487777cf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMonoHue", [value]))

    @jsii.member(jsii_name="putOpacity")
    def put_opacity(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationOpacity, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6d651460ac87c6241dde93b0d71f53dd22505eb461f6237d702cb1e40c557655)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putOpacity", [value]))

    @jsii.member(jsii_name="putRegionOfInterestCrop")
    def put_region_of_interest_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationRegionOfInterestCrop", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__68ab8855015a21d70fd1cb74b994bd8fa81ae195ed208bf77e77bdfcc56d568c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRegionOfInterestCrop", [value]))

    @jsii.member(jsii_name="putRelativeCrop")
    def put_relative_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationRelativeCrop", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b47d1281f1b41021aee3a85ad331ec8896c8b7ac1971832fff6c58767aa7daf9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRelativeCrop", [value]))

    @jsii.member(jsii_name="putRemoveColor")
    def put_remove_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationRemoveColor", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f1b5e0d23c7cd402c0fb1fe00b4b6dfb1df6781e37b056f60d2dd5730a7c33b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRemoveColor", [value]))

    @jsii.member(jsii_name="putResize")
    def put_resize(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationResize", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__87e57cf15d78d32fd623c9ce772ac5fc07fe6c5d0e7bfe922fde3b491c3e6c07)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putResize", [value]))

    @jsii.member(jsii_name="putRotate")
    def put_rotate(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationRotate", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__993d1857cc71ef09123a902039a13eee57c2c115979c4f1a6b969107de0b089c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRotate", [value]))

    @jsii.member(jsii_name="putScale")
    def put_scale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationScale", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9aacbe6adda1ae4636a44450a476e502b1a5202723c10ac7c89e239dbb128182)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putScale", [value]))

    @jsii.member(jsii_name="putShear")
    def put_shear(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationShear", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d42e601849f67d80a92d94df0020326131b7d977513a0a4ee026e4868e19b4f9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putShear", [value]))

    @jsii.member(jsii_name="putTrim")
    def put_trim(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationTrim", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9c5717eefa3f9a58c3838775cb633c9aa5ef95ac1742e85bcf0fb307bd8362fa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTrim", [value]))

    @jsii.member(jsii_name="putUnsharpMask")
    def put_unsharp_mask(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationUnsharpMask", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e0138e953cd19689fceee837e6260a51e93cee87a7f81358e3aa68e1107673bc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putUnsharpMask", [value]))

    @jsii.member(jsii_name="resetAppend")
    def reset_append(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAppend", []))

    @jsii.member(jsii_name="resetAspectCrop")
    def reset_aspect_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspectCrop", []))

    @jsii.member(jsii_name="resetBackgroundColor")
    def reset_background_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBackgroundColor", []))

    @jsii.member(jsii_name="resetBlur")
    def reset_blur(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBlur", []))

    @jsii.member(jsii_name="resetChromaKey")
    def reset_chroma_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChromaKey", []))

    @jsii.member(jsii_name="resetComposite")
    def reset_composite(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetComposite", []))

    @jsii.member(jsii_name="resetCompound")
    def reset_compound(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCompound", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetCrop")
    def reset_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCrop", []))

    @jsii.member(jsii_name="resetFaceCrop")
    def reset_face_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFaceCrop", []))

    @jsii.member(jsii_name="resetFeatureCrop")
    def reset_feature_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureCrop", []))

    @jsii.member(jsii_name="resetFitAndFill")
    def reset_fit_and_fill(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFitAndFill", []))

    @jsii.member(jsii_name="resetGoop")
    def reset_goop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGoop", []))

    @jsii.member(jsii_name="resetGrayscale")
    def reset_grayscale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGrayscale", []))

    @jsii.member(jsii_name="resetHsl")
    def reset_hsl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsl", []))

    @jsii.member(jsii_name="resetHsv")
    def reset_hsv(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsv", []))

    @jsii.member(jsii_name="resetIfDimension")
    def reset_if_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfDimension", []))

    @jsii.member(jsii_name="resetIfOrientation")
    def reset_if_orientation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfOrientation", []))

    @jsii.member(jsii_name="resetImQuery")
    def reset_im_query(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetImQuery", []))

    @jsii.member(jsii_name="resetMaxColors")
    def reset_max_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxColors", []))

    @jsii.member(jsii_name="resetMirror")
    def reset_mirror(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMirror", []))

    @jsii.member(jsii_name="resetMonoHue")
    def reset_mono_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonoHue", []))

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetRegionOfInterestCrop")
    def reset_region_of_interest_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRegionOfInterestCrop", []))

    @jsii.member(jsii_name="resetRelativeCrop")
    def reset_relative_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRelativeCrop", []))

    @jsii.member(jsii_name="resetRemoveColor")
    def reset_remove_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRemoveColor", []))

    @jsii.member(jsii_name="resetResize")
    def reset_resize(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetResize", []))

    @jsii.member(jsii_name="resetRotate")
    def reset_rotate(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRotate", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetShear")
    def reset_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetShear", []))

    @jsii.member(jsii_name="resetTrim")
    def reset_trim(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTrim", []))

    @jsii.member(jsii_name="resetUnsharpMask")
    def reset_unsharp_mask(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUnsharpMask", []))

    @builtins.property
    @jsii.member(jsii_name="append")
    def append(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationAppendList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationAppendList, jsii.get(self, "append"))

    @builtins.property
    @jsii.member(jsii_name="aspectCrop")
    def aspect_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationAspectCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationAspectCropList, jsii.get(self, "aspectCrop"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColor")
    def background_color(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationBackgroundColorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationBackgroundColorList, jsii.get(self, "backgroundColor"))

    @builtins.property
    @jsii.member(jsii_name="blur")
    def blur(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationBlurList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationBlurList, jsii.get(self, "blur"))

    @builtins.property
    @jsii.member(jsii_name="chromaKey")
    def chroma_key(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationChromaKeyList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationChromaKeyList, jsii.get(self, "chromaKey"))

    @builtins.property
    @jsii.member(jsii_name="composite")
    def composite(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationCompositeList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationCompositeList, jsii.get(self, "composite"))

    @builtins.property
    @jsii.member(jsii_name="compound")
    def compound(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationCompoundList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationCompoundList, jsii.get(self, "compound"))

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationContrastList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationContrastList, jsii.get(self, "contrast"))

    @builtins.property
    @jsii.member(jsii_name="crop")
    def crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationCropList, jsii.get(self, "crop"))

    @builtins.property
    @jsii.member(jsii_name="faceCrop")
    def face_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationFaceCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationFaceCropList, jsii.get(self, "faceCrop"))

    @builtins.property
    @jsii.member(jsii_name="featureCrop")
    def feature_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationFeatureCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationFeatureCropList, jsii.get(self, "featureCrop"))

    @builtins.property
    @jsii.member(jsii_name="fitAndFill")
    def fit_and_fill(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationFitAndFillList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationFitAndFillList, jsii.get(self, "fitAndFill"))

    @builtins.property
    @jsii.member(jsii_name="goop")
    def goop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationGoopList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationGoopList, jsii.get(self, "goop"))

    @builtins.property
    @jsii.member(jsii_name="grayscale")
    def grayscale(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationGrayscaleList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationGrayscaleList, jsii.get(self, "grayscale"))

    @builtins.property
    @jsii.member(jsii_name="hsl")
    def hsl(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationHslList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationHslList, jsii.get(self, "hsl"))

    @builtins.property
    @jsii.member(jsii_name="hsv")
    def hsv(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationHsvList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationHsvList, jsii.get(self, "hsv"))

    @builtins.property
    @jsii.member(jsii_name="ifDimension")
    def if_dimension(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfDimensionList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfDimensionList, jsii.get(self, "ifDimension"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientation")
    def if_orientation(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfOrientationList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfOrientationList, jsii.get(self, "ifOrientation"))

    @builtins.property
    @jsii.member(jsii_name="imQuery")
    def im_query(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationImQueryList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationImQueryList, jsii.get(self, "imQuery"))

    @builtins.property
    @jsii.member(jsii_name="maxColors")
    def max_colors(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationMaxColorsList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationMaxColorsList, jsii.get(self, "maxColors"))

    @builtins.property
    @jsii.member(jsii_name="mirror")
    def mirror(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationMirrorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationMirrorList, jsii.get(self, "mirror"))

    @builtins.property
    @jsii.member(jsii_name="monoHue")
    def mono_hue(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationMonoHueList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationMonoHueList, jsii.get(self, "monoHue"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationOpacityList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationOpacityList, jsii.get(self, "opacity"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestCrop")
    def region_of_interest_crop(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationRegionOfInterestCropList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationRegionOfInterestCropList", jsii.get(self, "regionOfInterestCrop"))

    @builtins.property
    @jsii.member(jsii_name="relativeCrop")
    def relative_crop(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationRelativeCropList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationRelativeCropList", jsii.get(self, "relativeCrop"))

    @builtins.property
    @jsii.member(jsii_name="removeColor")
    def remove_color(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationRemoveColorList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationRemoveColorList", jsii.get(self, "removeColor"))

    @builtins.property
    @jsii.member(jsii_name="resize")
    def resize(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationResizeList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationResizeList", jsii.get(self, "resize"))

    @builtins.property
    @jsii.member(jsii_name="rotate")
    def rotate(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationRotateList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationRotateList", jsii.get(self, "rotate"))

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationScaleList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationScaleList", jsii.get(self, "scale"))

    @builtins.property
    @jsii.member(jsii_name="shear")
    def shear(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationShearList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationShearList", jsii.get(self, "shear"))

    @builtins.property
    @jsii.member(jsii_name="trim")
    def trim(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationTrimList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationTrimList", jsii.get(self, "trim"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMask")
    def unsharp_mask(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationUnsharpMaskList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationUnsharpMaskList", jsii.get(self, "unsharpMask"))

    @builtins.property
    @jsii.member(jsii_name="appendInput")
    def append_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationAppend]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationAppend]]], jsii.get(self, "appendInput"))

    @builtins.property
    @jsii.member(jsii_name="aspectCropInput")
    def aspect_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationAspectCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationAspectCrop]]], jsii.get(self, "aspectCropInput"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColorInput")
    def background_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationBackgroundColor]]], jsii.get(self, "backgroundColorInput"))

    @builtins.property
    @jsii.member(jsii_name="blurInput")
    def blur_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationBlur]]], jsii.get(self, "blurInput"))

    @builtins.property
    @jsii.member(jsii_name="chromaKeyInput")
    def chroma_key_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationChromaKey]]], jsii.get(self, "chromaKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="compositeInput")
    def composite_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationComposite]]], jsii.get(self, "compositeInput"))

    @builtins.property
    @jsii.member(jsii_name="compoundInput")
    def compound_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationCompound]]], jsii.get(self, "compoundInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationContrast]]], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="cropInput")
    def crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationCrop]]], jsii.get(self, "cropInput"))

    @builtins.property
    @jsii.member(jsii_name="faceCropInput")
    def face_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationFaceCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationFaceCrop]]], jsii.get(self, "faceCropInput"))

    @builtins.property
    @jsii.member(jsii_name="featureCropInput")
    def feature_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationFeatureCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationFeatureCrop]]], jsii.get(self, "featureCropInput"))

    @builtins.property
    @jsii.member(jsii_name="fitAndFillInput")
    def fit_and_fill_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationFitAndFill]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationFitAndFill]]], jsii.get(self, "fitAndFillInput"))

    @builtins.property
    @jsii.member(jsii_name="goopInput")
    def goop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationGoop]]], jsii.get(self, "goopInput"))

    @builtins.property
    @jsii.member(jsii_name="grayscaleInput")
    def grayscale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationGrayscale]]], jsii.get(self, "grayscaleInput"))

    @builtins.property
    @jsii.member(jsii_name="hslInput")
    def hsl_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationHsl]]], jsii.get(self, "hslInput"))

    @builtins.property
    @jsii.member(jsii_name="hsvInput")
    def hsv_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationHsv]]], jsii.get(self, "hsvInput"))

    @builtins.property
    @jsii.member(jsii_name="ifDimensionInput")
    def if_dimension_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfDimension]]], jsii.get(self, "ifDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientationInput")
    def if_orientation_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfOrientation]]], jsii.get(self, "ifOrientationInput"))

    @builtins.property
    @jsii.member(jsii_name="imQueryInput")
    def im_query_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationImQuery]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationImQuery]]], jsii.get(self, "imQueryInput"))

    @builtins.property
    @jsii.member(jsii_name="maxColorsInput")
    def max_colors_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationMaxColors]]], jsii.get(self, "maxColorsInput"))

    @builtins.property
    @jsii.member(jsii_name="mirrorInput")
    def mirror_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationMirror]]], jsii.get(self, "mirrorInput"))

    @builtins.property
    @jsii.member(jsii_name="monoHueInput")
    def mono_hue_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationMonoHue]]], jsii.get(self, "monoHueInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationOpacity]]], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestCropInput")
    def region_of_interest_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationRegionOfInterestCrop"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationRegionOfInterestCrop"]]], jsii.get(self, "regionOfInterestCropInput"))

    @builtins.property
    @jsii.member(jsii_name="relativeCropInput")
    def relative_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationRelativeCrop"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationRelativeCrop"]]], jsii.get(self, "relativeCropInput"))

    @builtins.property
    @jsii.member(jsii_name="removeColorInput")
    def remove_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationRemoveColor"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationRemoveColor"]]], jsii.get(self, "removeColorInput"))

    @builtins.property
    @jsii.member(jsii_name="resizeInput")
    def resize_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationResize"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationResize"]]], jsii.get(self, "resizeInput"))

    @builtins.property
    @jsii.member(jsii_name="rotateInput")
    def rotate_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationRotate"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationRotate"]]], jsii.get(self, "rotateInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationScale"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationScale"]]], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="shearInput")
    def shear_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationShear"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationShear"]]], jsii.get(self, "shearInput"))

    @builtins.property
    @jsii.member(jsii_name="trimInput")
    def trim_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationTrim"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationTrim"]]], jsii.get(self, "trimInput"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMaskInput")
    def unsharp_mask_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationUnsharpMask"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationUnsharpMask"]]], jsii.get(self, "unsharpMaskInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e43b1713ef639ae1573ad56af9159e81228d6100118efed72cb1b80948479980)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationRegionOfInterestCrop",
    jsii_struct_bases=[],
    name_mapping={
        "region_of_interest": "regionOfInterest",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationRegionOfInterestCrop:
    def __init__(
        self,
        *,
        region_of_interest: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationRegionOfInterestCropRegionOfInterest", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param region_of_interest: region_of_interest block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest DataAkamaiImagingPolicyImage#region_of_interest}
        :param gravity: The placement of the crop area relative to the specified area of interest. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: The placement of the crop area relative to the specified area of interest. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param style: Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(region_of_interest, dict):
            region_of_interest = DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationRegionOfInterestCropRegionOfInterest(**region_of_interest)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f193af7db4fdcc3b6f680dd4476a9b920c8f542d4c2e5322aba74221822d4576)
            check_type(argname="argument region_of_interest", value=region_of_interest, expected_type=type_hints["region_of_interest"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "region_of_interest": region_of_interest,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def region_of_interest(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationRegionOfInterestCropRegionOfInterest":
        '''region_of_interest block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest DataAkamaiImagingPolicyImage#region_of_interest}
        '''
        result = self._values.get("region_of_interest")
        assert result is not None, "Required property 'region_of_interest' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationRegionOfInterestCropRegionOfInterest", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''The placement of the crop area relative to the specified area of interest.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''The placement of the crop area relative to the specified area of interest.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationRegionOfInterestCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationRegionOfInterestCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationRegionOfInterestCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cb4e984964e94a8f7d14321974ca39901ff4aaef2fd8dbb922b9f30ddff3d567)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationRegionOfInterestCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0f71e1a0fef17101ec660a686c7cd2f341f142d81211bb781f9427500e2ce603)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationRegionOfInterestCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__62795e0d04b0885bac799c026c5e0fcc34f8dcbebdf8da9c25850fb46abcc6ce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9165bd4b3f017ce33a632bee7dec6b2e2a8d94a5f2a22fd0337ce910c0588bdc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__60f149dc829bb2dc0fc2a64ce2debf4f90e49979ff216817b3a04b4fb2163b40)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationRegionOfInterestCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationRegionOfInterestCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationRegionOfInterestCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ccd23f4fb38a0ccd279b2f851e40ada198c412af316fe0501cbd9840cd10086)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationRegionOfInterestCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationRegionOfInterestCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8cb90699454cc439dc4d6f1eb2daa3b9068bfef37e7e36d0c4e3ef73cc5b94c9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putRegionOfInterest")
    def put_region_of_interest(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationRegionOfInterestCropRegionOfInterest()

        return typing.cast(None, jsii.invoke(self, "putRegionOfInterest", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterest")
    def region_of_interest(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationRegionOfInterestCropRegionOfInterestOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationRegionOfInterestCropRegionOfInterestOutputReference", jsii.get(self, "regionOfInterest"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestInput")
    def region_of_interest_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationRegionOfInterestCropRegionOfInterest"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationRegionOfInterestCropRegionOfInterest"], jsii.get(self, "regionOfInterestInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9cf43a3fd252de207f9eddccc38c9415ae375cda60bcc0d6d5c1a4cc7b8f152c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__639d1b6eaf321da08e55b853efc6650b08019c050200fa34046aa997c1acd26d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d2fee954db659f782d894f31a722346b773f8b2cccef48bb4c37e4290a801bf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8842f89e091b28bbe83ff5befe14a114e42e0a244925fe3a109ceb0256c8bb4e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__58f088f44702afec214c88782b0744860a074094366d0132156729f00a42555c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a005c28c61241f15eb95347e920d51d4cc915bd03294d0459507d92143844df7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4c9e51c33ff792d8c0aff4a4bb51bedf7f34d76297a4708de0f2ba4e60e30087)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__96ad0ca7051ebf552be9127354ea51678ff0939f0103d3ae5d7650b05b28ca86)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationRegionOfInterestCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationRegionOfInterestCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationRegionOfInterestCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a326606edeca7166c1653f6efa2548876110302a79fa4abc4d87f04e50e8441)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationRegionOfInterestCropRegionOfInterest",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationRegionOfInterestCropRegionOfInterest:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationRegionOfInterestCropRegionOfInterest(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationRegionOfInterestCropRegionOfInterestOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationRegionOfInterestCropRegionOfInterestOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b5212a0bdd6a2891b2e7185529b23a8c3f14546bc9103c6732d0ae5a95455780)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationRegionOfInterestCropRegionOfInterest]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationRegionOfInterestCropRegionOfInterest], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationRegionOfInterestCropRegionOfInterest],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__05fea5020ed4c800c6caa9e4afedf2e1fcef9dfbaa87e8af432ee4bf7bfd3406)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationRelativeCrop",
    jsii_struct_bases=[],
    name_mapping={
        "east": "east",
        "east_var": "eastVar",
        "north": "north",
        "north_var": "northVar",
        "south": "south",
        "south_var": "southVar",
        "west": "west",
        "west_var": "westVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationRelativeCrop:
    def __init__(
        self,
        *,
        east: typing.Optional[builtins.str] = None,
        east_var: typing.Optional[builtins.str] = None,
        north: typing.Optional[builtins.str] = None,
        north_var: typing.Optional[builtins.str] = None,
        south: typing.Optional[builtins.str] = None,
        south_var: typing.Optional[builtins.str] = None,
        west: typing.Optional[builtins.str] = None,
        west_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param east: The number of pixels to shrink or expand the right side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east DataAkamaiImagingPolicyImage#east}
        :param east_var: The number of pixels to shrink or expand the right side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east_var DataAkamaiImagingPolicyImage#east_var}
        :param north: The number of pixels to shrink or expand the top side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north DataAkamaiImagingPolicyImage#north}
        :param north_var: The number of pixels to shrink or expand the top side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north_var DataAkamaiImagingPolicyImage#north_var}
        :param south: The number of pixels to shrink or expand the bottom side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south DataAkamaiImagingPolicyImage#south}
        :param south_var: The number of pixels to shrink or expand the bottom side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south_var DataAkamaiImagingPolicyImage#south_var}
        :param west: The number of pixels to shrink or expand the left side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west DataAkamaiImagingPolicyImage#west}
        :param west_var: The number of pixels to shrink or expand the left side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west_var DataAkamaiImagingPolicyImage#west_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9f0b9e56e4c8fae859cc4c79d8ec2c77acb35cbfdb54ce3532bc125fd3ee9178)
            check_type(argname="argument east", value=east, expected_type=type_hints["east"])
            check_type(argname="argument east_var", value=east_var, expected_type=type_hints["east_var"])
            check_type(argname="argument north", value=north, expected_type=type_hints["north"])
            check_type(argname="argument north_var", value=north_var, expected_type=type_hints["north_var"])
            check_type(argname="argument south", value=south, expected_type=type_hints["south"])
            check_type(argname="argument south_var", value=south_var, expected_type=type_hints["south_var"])
            check_type(argname="argument west", value=west, expected_type=type_hints["west"])
            check_type(argname="argument west_var", value=west_var, expected_type=type_hints["west_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if east is not None:
            self._values["east"] = east
        if east_var is not None:
            self._values["east_var"] = east_var
        if north is not None:
            self._values["north"] = north
        if north_var is not None:
            self._values["north_var"] = north_var
        if south is not None:
            self._values["south"] = south
        if south_var is not None:
            self._values["south_var"] = south_var
        if west is not None:
            self._values["west"] = west
        if west_var is not None:
            self._values["west_var"] = west_var

    @builtins.property
    def east(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the right side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east DataAkamaiImagingPolicyImage#east}
        '''
        result = self._values.get("east")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def east_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the right side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east_var DataAkamaiImagingPolicyImage#east_var}
        '''
        result = self._values.get("east_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def north(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the top side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north DataAkamaiImagingPolicyImage#north}
        '''
        result = self._values.get("north")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def north_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the top side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north_var DataAkamaiImagingPolicyImage#north_var}
        '''
        result = self._values.get("north_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def south(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the bottom side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south DataAkamaiImagingPolicyImage#south}
        '''
        result = self._values.get("south")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def south_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the bottom side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south_var DataAkamaiImagingPolicyImage#south_var}
        '''
        result = self._values.get("south_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def west(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the left side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west DataAkamaiImagingPolicyImage#west}
        '''
        result = self._values.get("west")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def west_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the left side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west_var DataAkamaiImagingPolicyImage#west_var}
        '''
        result = self._values.get("west_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationRelativeCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationRelativeCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationRelativeCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6a50fc1e29ffb16e15793fceb9992e570e2c2ebacfa049a91550ba314a2d080c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationRelativeCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c6b3686fda25ed24998429120afe8b00f748e6727ced14b342234891dcdbd4d9)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationRelativeCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ef90d14c58923758bd299ee8e9ce3016c1f776b11de9e6a2d1d796f31eeb3430)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__74fadc7dfdf3fec9d78318fa1da67905fa1a532d929d021b00b8a60fd79c335c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c94ee5493c9c7d4ae9314ab79227c33e6243f5d154234ff16fad8db289fc8d60)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationRelativeCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationRelativeCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationRelativeCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f457ebd07a3d57ee4bf38c5f074700ddfeb9111a9a865f4bc2dc08ccfcbcb5f5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationRelativeCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationRelativeCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4230fcbe1648c7c90af99b96a9105bd2387cad150f7d36857474e6018630f419)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetEast")
    def reset_east(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEast", []))

    @jsii.member(jsii_name="resetEastVar")
    def reset_east_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEastVar", []))

    @jsii.member(jsii_name="resetNorth")
    def reset_north(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNorth", []))

    @jsii.member(jsii_name="resetNorthVar")
    def reset_north_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNorthVar", []))

    @jsii.member(jsii_name="resetSouth")
    def reset_south(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSouth", []))

    @jsii.member(jsii_name="resetSouthVar")
    def reset_south_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSouthVar", []))

    @jsii.member(jsii_name="resetWest")
    def reset_west(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWest", []))

    @jsii.member(jsii_name="resetWestVar")
    def reset_west_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWestVar", []))

    @builtins.property
    @jsii.member(jsii_name="eastInput")
    def east_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "eastInput"))

    @builtins.property
    @jsii.member(jsii_name="eastVarInput")
    def east_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "eastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="northInput")
    def north_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "northInput"))

    @builtins.property
    @jsii.member(jsii_name="northVarInput")
    def north_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "northVarInput"))

    @builtins.property
    @jsii.member(jsii_name="southInput")
    def south_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "southInput"))

    @builtins.property
    @jsii.member(jsii_name="southVarInput")
    def south_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "southVarInput"))

    @builtins.property
    @jsii.member(jsii_name="westInput")
    def west_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "westInput"))

    @builtins.property
    @jsii.member(jsii_name="westVarInput")
    def west_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "westVarInput"))

    @builtins.property
    @jsii.member(jsii_name="east")
    def east(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "east"))

    @east.setter
    def east(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d9dffd7fd1076b563b4ed5364ab12181880ef7d89e43d7bf75d37d9ecd377a0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "east", value)

    @builtins.property
    @jsii.member(jsii_name="eastVar")
    def east_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "eastVar"))

    @east_var.setter
    def east_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c77cc67e8ff678a3e7ec272d06a0c7e4e4d1db7f1701819035e3c01ff4ef5bda)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "eastVar", value)

    @builtins.property
    @jsii.member(jsii_name="north")
    def north(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "north"))

    @north.setter
    def north(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c932ad28ddbf255d470208e55d80d752de3e4956716e5ee20c06628f92bd5f1f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "north", value)

    @builtins.property
    @jsii.member(jsii_name="northVar")
    def north_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "northVar"))

    @north_var.setter
    def north_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__569dded4a6c61d496827384098201a4a8a39b6e241c5e8dbd772ad93de4dde46)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "northVar", value)

    @builtins.property
    @jsii.member(jsii_name="south")
    def south(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "south"))

    @south.setter
    def south(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6714b0cd999abadf1bdccd3ef1304781cc49b99b33d52828d5a58a3e83fce4f9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "south", value)

    @builtins.property
    @jsii.member(jsii_name="southVar")
    def south_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "southVar"))

    @south_var.setter
    def south_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0daf1c210d572101ea30720b91be94afa23084799b268f4525daf6894c416244)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "southVar", value)

    @builtins.property
    @jsii.member(jsii_name="west")
    def west(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "west"))

    @west.setter
    def west(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__14c32bc56a169beaf7e65382ccd7bb110bc470ed54ed6b77a55124df9b02b87b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "west", value)

    @builtins.property
    @jsii.member(jsii_name="westVar")
    def west_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "westVar"))

    @west_var.setter
    def west_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__73f2f3ed6fbbec94844ae811edfdf2e3cf40fa351fe2a343561c657a819f4051)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "westVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationRelativeCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationRelativeCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationRelativeCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a7ffc49170d83a319f8516ccfb9f1d16eb173e92fb6239ddcdd5ce37ccdbdd10)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationRemoveColor",
    jsii_struct_bases=[],
    name_mapping={
        "color": "color",
        "color_var": "colorVar",
        "feather": "feather",
        "feather_var": "featherVar",
        "tolerance": "tolerance",
        "tolerance_var": "toleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationRemoveColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
        feather: typing.Optional[builtins.str] = None,
        feather_var: typing.Optional[builtins.str] = None,
        tolerance: typing.Optional[builtins.str] = None,
        tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        :param feather: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        :param feather_var: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        :param tolerance: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        :param tolerance_var: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d4bf443ba7685e8e79d145182795c924a4f15448d572317b168d3f420b63402f)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
            check_type(argname="argument feather", value=feather, expected_type=type_hints["feather"])
            check_type(argname="argument feather_var", value=feather_var, expected_type=type_hints["feather_var"])
            check_type(argname="argument tolerance", value=tolerance, expected_type=type_hints["tolerance"])
            check_type(argname="argument tolerance_var", value=tolerance_var, expected_type=type_hints["tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var
        if feather is not None:
            self._values["feather"] = feather
        if feather_var is not None:
            self._values["feather_var"] = feather_var
        if tolerance is not None:
            self._values["tolerance"] = tolerance
        if tolerance_var is not None:
            self._values["tolerance_var"] = tolerance_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        '''
        result = self._values.get("feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather_var(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        '''
        result = self._values.get("feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        '''
        result = self._values.get("tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance_var(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        result = self._values.get("tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationRemoveColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationRemoveColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationRemoveColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3da1a7b3d48e4442951a37b9d2041b2687171db7a41e1ee86465965c7498908b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationRemoveColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__067e22abd5900f388f22e8fdce8ffcff312cd7467fdbcd87bfc14c651afe1d06)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationRemoveColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3af606744f52654edd57ec828d71a935570bc12892026af75b094e2b6aa182be)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__24766d421ce45b4bf47135b7e3cd5cbcb6d2da07e44ee360e29907b1a99e224b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__51600a3b1969aec380f9c3245cbd2780244280051adc9a14c98918a8d554bbbe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationRemoveColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationRemoveColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationRemoveColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab8420aedf55f0c6a1c32301980ee9182a8a63a55e2e264944e440fb08cf1eb5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationRemoveColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationRemoveColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d4da0380fb96e41d44f1a655265530fe17240e36bca76dc1262c24b33fbecd23)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @jsii.member(jsii_name="resetFeather")
    def reset_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeather", []))

    @jsii.member(jsii_name="resetFeatherVar")
    def reset_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatherVar", []))

    @jsii.member(jsii_name="resetTolerance")
    def reset_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTolerance", []))

    @jsii.member(jsii_name="resetToleranceVar")
    def reset_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featherInput")
    def feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherInput"))

    @builtins.property
    @jsii.member(jsii_name="featherVarInput")
    def feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceInput")
    def tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceVarInput")
    def tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d5c99b5727adf40c02e4b96c7e844a40a7fe2264da95af69d70a67e3d8e217ab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0e04951e74e8cf316fdb73dbb3c5492657575cd6b5f92647d20eb0d63f9273b1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="feather")
    def feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "feather"))

    @feather.setter
    def feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aaccd4e6c66fc93e5410ab7b6da3e76e9040ddf5277251f5d0ef6b348ab0839d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "feather", value)

    @builtins.property
    @jsii.member(jsii_name="featherVar")
    def feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featherVar"))

    @feather_var.setter
    def feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__952379bc05cf0f4e42edb91ac8053111f11af090078f69ffee3e4ff5e1f036bf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featherVar", value)

    @builtins.property
    @jsii.member(jsii_name="tolerance")
    def tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tolerance"))

    @tolerance.setter
    def tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__79793739da8e10900f2939689d15c7cd21b3b81da27eb09831ae4fb693ffe1b6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tolerance", value)

    @builtins.property
    @jsii.member(jsii_name="toleranceVar")
    def tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "toleranceVar"))

    @tolerance_var.setter
    def tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9091a75cfc9198bd7c3aadb064a45d375597a9b4ff6f9a7c85f2f269bbbaf51a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "toleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationRemoveColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationRemoveColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationRemoveColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7f46a93108e9da6d1eeb6e8043364d7524994641895580ec2c777730e49b0f91)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationResize",
    jsii_struct_bases=[],
    name_mapping={
        "aspect": "aspect",
        "aspect_var": "aspectVar",
        "height": "height",
        "height_var": "heightVar",
        "type": "type",
        "type_var": "typeVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationResize:
    def __init__(
        self,
        *,
        aspect: typing.Optional[builtins.str] = None,
        aspect_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param aspect: Preserves the aspect ratio. Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect DataAkamaiImagingPolicyImage#aspect}
        :param aspect_var: Preserves the aspect ratio. Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_var DataAkamaiImagingPolicyImage#aspect_var}
        :param height: The height to resize the source image to. Must be set if height is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height to resize the source image to. Must be set if height is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param type: Sets constraints for the image resize. Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: Sets constraints for the image resize. Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        :param width: The width to resize the source image to. Must be set if width is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width to resize the source image to. Must be set if width is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a94277b9fdba0029b2ff234ce48fee664111302d3a9c37031975298bcffba0ff)
            check_type(argname="argument aspect", value=aspect, expected_type=type_hints["aspect"])
            check_type(argname="argument aspect_var", value=aspect_var, expected_type=type_hints["aspect_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if aspect is not None:
            self._values["aspect"] = aspect
        if aspect_var is not None:
            self._values["aspect_var"] = aspect_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def aspect(self) -> typing.Optional[builtins.str]:
        '''Preserves the aspect ratio.

        Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect DataAkamaiImagingPolicyImage#aspect}
        '''
        result = self._values.get("aspect")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def aspect_var(self) -> typing.Optional[builtins.str]:
        '''Preserves the aspect ratio.

        Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_var DataAkamaiImagingPolicyImage#aspect_var}
        '''
        result = self._values.get("aspect_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height to resize the source image to. Must be set if height is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height to resize the source image to. Must be set if height is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''Sets constraints for the image resize.

        Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''Sets constraints for the image resize.

        Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width to resize the source image to. Must be set if width is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width to resize the source image to. Must be set if width is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationResize(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationResizeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationResizeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f7b7a8c50e39c3db0a2bd90655fa88ac248a1eac8d291214554def31ad5b80f0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationResizeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a605478d6bd477cf933dbb870efd8a8a38b9da493d94e0bf987289513b55ffd5)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationResizeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cb658f24025392dc64d3524d023f4915ec9530fbda68eec5cdf4bbaf640a0dfe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__131dceda9d631e063e332d68dae0ab808405037f773a44f71bb0b56785bcc5d4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e45415c2d3be8c9942cf50b33a1b19f67d301b622075934e3092bf832f08b392)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationResize]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationResize]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationResize]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__efc46bd2b086dbfba7afb986357205bf0172dc927222fd349bda308193160669)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationResizeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationResizeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__02119a0576810576f4b9cb873d5a29c7a51545feb7f8ec21600b6ad388cf88d3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAspect")
    def reset_aspect(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspect", []))

    @jsii.member(jsii_name="resetAspectVar")
    def reset_aspect_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspectVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="aspectInput")
    def aspect_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "aspectInput"))

    @builtins.property
    @jsii.member(jsii_name="aspectVarInput")
    def aspect_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "aspectVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="aspect")
    def aspect(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "aspect"))

    @aspect.setter
    def aspect(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4d1342309c81ed0a473920a367f463d565275521f9e5ca1fe1e44ed298bbb088)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "aspect", value)

    @builtins.property
    @jsii.member(jsii_name="aspectVar")
    def aspect_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "aspectVar"))

    @aspect_var.setter
    def aspect_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a17947486d59fe52dfa4c1640aabe50e139cf2263be1f2c5fb3764d0e65a5049)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "aspectVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3b772d3375cd253a10963672f5f94f6136d3c1b62ba76c72c29bbc58cef2fd5d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b9582e345e2c466ecd78bf5b6f8301786041ec83e95d0905bb8ed9b846063065)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5aeec0419cd008e36f4acff477612887247b0d2d2ec06701f3a5eeddd68c15e8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__494f38d987f0b2cb893990cb29dac3b0c5188b856a28f1a181db664db87698b8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__079ce9a75179b9aeb23a469c6a24e0cf7d5b4d540c88205c4182fc0d186a5a97)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3db7ce24a39a1342ae82f6967de67ad55856af5131de7b6c5b36da7744d28938)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationResize]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationResize]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationResize]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__60b4e3f5f29f5804c57266b24491ee4db07949d2bab902ccd13b0e11c9a095ea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationRotate",
    jsii_struct_bases=[],
    name_mapping={"degrees": "degrees", "degrees_var": "degreesVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationRotate:
    def __init__(
        self,
        *,
        degrees: typing.Optional[builtins.str] = None,
        degrees_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param degrees: The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees DataAkamaiImagingPolicyImage#degrees}
        :param degrees_var: The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees_var DataAkamaiImagingPolicyImage#degrees_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__815546a47347f640caf6ffeda80be2b37953bb7a25359315eed0f84131e2cb6a)
            check_type(argname="argument degrees", value=degrees, expected_type=type_hints["degrees"])
            check_type(argname="argument degrees_var", value=degrees_var, expected_type=type_hints["degrees_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if degrees is not None:
            self._values["degrees"] = degrees
        if degrees_var is not None:
            self._values["degrees_var"] = degrees_var

    @builtins.property
    def degrees(self) -> typing.Optional[builtins.str]:
        '''The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees DataAkamaiImagingPolicyImage#degrees}
        '''
        result = self._values.get("degrees")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def degrees_var(self) -> typing.Optional[builtins.str]:
        '''The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees_var DataAkamaiImagingPolicyImage#degrees_var}
        '''
        result = self._values.get("degrees_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationRotate(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationRotateList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationRotateList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__35d78c5b613d84d33e71d0ddda9ae66de328fa1ac6de119154da12c864d7769e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationRotateOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__49127a6a9c5b2b23c8165b7249d0887786810572cd76386b6a9158ddaf84bac1)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationRotateOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__64a8c18d9b890f6ce28af06a0ccedb5b28cfe542346b56630a958135f0a5c34c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5c60d3cd00c82d6480e72cd307d143d347d8240a31e2c8d0680f19c0836ddb93)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__117b927a2f1b2adefda813c8a7d5d1256546e878a11aec977d9a394d97a91ba9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationRotate]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationRotate]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationRotate]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a726d078de22b86de34b1938785c13f8a04e91b145825d02edfc8a592f12b292)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationRotateOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationRotateOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0034c8044ec09994ab9310d2bec203dd32f7a0c9f38426e242267fcc4bcdbd82)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetDegrees")
    def reset_degrees(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDegrees", []))

    @jsii.member(jsii_name="resetDegreesVar")
    def reset_degrees_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDegreesVar", []))

    @builtins.property
    @jsii.member(jsii_name="degreesInput")
    def degrees_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "degreesInput"))

    @builtins.property
    @jsii.member(jsii_name="degreesVarInput")
    def degrees_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "degreesVarInput"))

    @builtins.property
    @jsii.member(jsii_name="degrees")
    def degrees(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "degrees"))

    @degrees.setter
    def degrees(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__22853267418f91372508677f9eae429a2e57aade5b1c9fa6fca8fbc608cb553f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "degrees", value)

    @builtins.property
    @jsii.member(jsii_name="degreesVar")
    def degrees_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "degreesVar"))

    @degrees_var.setter
    def degrees_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__56691c461c66e3985d6598c80b67094d1688e10fd94ea45f10905c4ffc1ed445)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "degreesVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationRotate]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationRotate]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationRotate]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__09c95df846755a8b36828472c508f9fb0fd7fb90d582a1ded78f620dbca221ac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationScale",
    jsii_struct_bases=[],
    name_mapping={
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationScale:
    def __init__(
        self,
        *,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param height: Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged. Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged. Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ae6e5e89c0f487fd2f95ee1f28f085ec929707f6cef8f137a085cb4bbf0aad3)
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size.

        Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size.

        Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged.

        Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged.

        Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationScale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationScaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationScaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__692e94f53f0177ef16bcb0413c63ae2bbf5190a5f2c854261135d0e0e9c0eeda)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationScaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0e4e2c6312b920ed8562de92f941c37d585f8f5e062c06f57e9bc8d7d62f7f46)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationScaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__27b4f0e7201a8b4612eb1b3e48f911fea36832d933fd26401436200725806d7e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__564c0da055dd2b38a90836a978e45432469245652232729bdeada7585cecd3aa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5cc717bedd6f5c90e22cafe5e98f2b59d5cfa1e348582eae60bf502997e07d06)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationScale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationScale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationScale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e7a0d0d6e19bb49f9b66a5c60f75b913d9fe81ba349ea8cafa6d466d0bf99659)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationScaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationScaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__83ef9c04338142657f4c824a01d4eda6a84726519d7b5b9ebfa58be0f3fce278)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6003fcf4f338dc2c7ea1e6e9ddb5d775b9ea3a7dd6bc0e89c2fd8cc7110a45b3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__afc7fed0023a741c8bf15a3132fd5bbe92990bc532a46605b3c8ce394f2984f2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d8fb5d09b537e472978129669e461b0853140abf647115c529698d23e4c8f46b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__48e0f33d6b60f86b659b15598ea8811ea57447cba825c664205f90ebf12d0a9e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationScale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationScale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationScale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__04466450e5dbcbfc7b34c021e6d18bdf78de20deabdf88ee25e3ff1113e7ba7d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationShear",
    jsii_struct_bases=[],
    name_mapping={
        "x_shear": "xShear",
        "x_shear_var": "xShearVar",
        "y_shear": "yShear",
        "y_shear_var": "yShearVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationShear:
    def __init__(
        self,
        *,
        x_shear: typing.Optional[builtins.str] = None,
        x_shear_var: typing.Optional[builtins.str] = None,
        y_shear: typing.Optional[builtins.str] = None,
        y_shear_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param x_shear: The amount to shear along the x-axis, measured in multiples of the image's width. Must be set if yShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear DataAkamaiImagingPolicyImage#x_shear}
        :param x_shear_var: The amount to shear along the x-axis, measured in multiples of the image's width. Must be set if yShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear_var DataAkamaiImagingPolicyImage#x_shear_var}
        :param y_shear: The amount to shear along the y-axis, measured in multiples of the image's height. Must be set if xShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear DataAkamaiImagingPolicyImage#y_shear}
        :param y_shear_var: The amount to shear along the y-axis, measured in multiples of the image's height. Must be set if xShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear_var DataAkamaiImagingPolicyImage#y_shear_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8e4096e0dd640b45597cc622e3a064e4590ad112f353928ca162c663317d8c97)
            check_type(argname="argument x_shear", value=x_shear, expected_type=type_hints["x_shear"])
            check_type(argname="argument x_shear_var", value=x_shear_var, expected_type=type_hints["x_shear_var"])
            check_type(argname="argument y_shear", value=y_shear, expected_type=type_hints["y_shear"])
            check_type(argname="argument y_shear_var", value=y_shear_var, expected_type=type_hints["y_shear_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if x_shear is not None:
            self._values["x_shear"] = x_shear
        if x_shear_var is not None:
            self._values["x_shear_var"] = x_shear_var
        if y_shear is not None:
            self._values["y_shear"] = y_shear
        if y_shear_var is not None:
            self._values["y_shear_var"] = y_shear_var

    @builtins.property
    def x_shear(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the x-axis, measured in multiples of the image's width.

        Must be set if yShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear DataAkamaiImagingPolicyImage#x_shear}
        '''
        result = self._values.get("x_shear")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_shear_var(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the x-axis, measured in multiples of the image's width.

        Must be set if yShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear_var DataAkamaiImagingPolicyImage#x_shear_var}
        '''
        result = self._values.get("x_shear_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_shear(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the y-axis, measured in multiples of the image's height.

        Must be set if xShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear DataAkamaiImagingPolicyImage#y_shear}
        '''
        result = self._values.get("y_shear")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_shear_var(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the y-axis, measured in multiples of the image's height.

        Must be set if xShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear_var DataAkamaiImagingPolicyImage#y_shear_var}
        '''
        result = self._values.get("y_shear_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationShear(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationShearList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationShearList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9138bb3e4cb197956daeef6644a6b3026519779e72f0d54af395d84482165b9c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationShearOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ee4d65cc4e6de3249603a96c810b0b23f6889e9fbc7a835bd49e079a4b66b72a)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationShearOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__64a3b52278e9514b47548a19dc1a050afcea79bd1687f7c7ed40bf654eb08141)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2b658d8e16ae75506b6c5ae3e68f45b2470c0012a4fd908d0c54114ef46719e7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c845569ed39b263f6e6a3aba02bd21b831dbd46331a7be8e0ecbc9c8ed72b09c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationShear]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationShear]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationShear]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__61cb6130e55fc35f0fb670e964d16a4445afdd4a87d37d925be254f9b12ea19b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationShearOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationShearOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7339a12dfd303f0c806e1af9a7570f1cd753d91de0a677d431301e2751054b84)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetXShear")
    def reset_x_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXShear", []))

    @jsii.member(jsii_name="resetXShearVar")
    def reset_x_shear_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXShearVar", []))

    @jsii.member(jsii_name="resetYShear")
    def reset_y_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYShear", []))

    @jsii.member(jsii_name="resetYShearVar")
    def reset_y_shear_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYShearVar", []))

    @builtins.property
    @jsii.member(jsii_name="xShearInput")
    def x_shear_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xShearInput"))

    @builtins.property
    @jsii.member(jsii_name="xShearVarInput")
    def x_shear_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xShearVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yShearInput")
    def y_shear_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yShearInput"))

    @builtins.property
    @jsii.member(jsii_name="yShearVarInput")
    def y_shear_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yShearVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xShear")
    def x_shear(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xShear"))

    @x_shear.setter
    def x_shear(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__126084c7b88266e18b1696ac4becb83bd21bac2b9333255861491a60328e4d5e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xShear", value)

    @builtins.property
    @jsii.member(jsii_name="xShearVar")
    def x_shear_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xShearVar"))

    @x_shear_var.setter
    def x_shear_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7a1c5cd43c8b03990c9a425384365e4f2d28818a105570efe2633304fb44215a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xShearVar", value)

    @builtins.property
    @jsii.member(jsii_name="yShear")
    def y_shear(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yShear"))

    @y_shear.setter
    def y_shear(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ff15e5dd5db5d78493da33708765e04f13f5b75382d7dee6e3ab65af060049e5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yShear", value)

    @builtins.property
    @jsii.member(jsii_name="yShearVar")
    def y_shear_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yShearVar"))

    @y_shear_var.setter
    def y_shear_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3818795862b9c7952f16471a5cc168c30edc07119af23c4fc20b55001247eef6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yShearVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationShear]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationShear]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationShear]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__165386d4d5e42631aa72b06eb95d047512953b6f18c3914c24cdd37dc65b8099)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationTrim",
    jsii_struct_bases=[],
    name_mapping={
        "fuzz": "fuzz",
        "fuzz_var": "fuzzVar",
        "padding": "padding",
        "padding_var": "paddingVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationTrim:
    def __init__(
        self,
        *,
        fuzz: typing.Optional[builtins.str] = None,
        fuzz_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fuzz: The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz DataAkamaiImagingPolicyImage#fuzz}
        :param fuzz_var: The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz_var DataAkamaiImagingPolicyImage#fuzz_var}
        :param padding: The amount of padding in pixels to add to the trimmed image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: The amount of padding in pixels to add to the trimmed image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b0379e13a392b1845cc32ad48b145392e8368ea495f0893bd0e1c059cb5a892a)
            check_type(argname="argument fuzz", value=fuzz, expected_type=type_hints["fuzz"])
            check_type(argname="argument fuzz_var", value=fuzz_var, expected_type=type_hints["fuzz_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fuzz is not None:
            self._values["fuzz"] = fuzz
        if fuzz_var is not None:
            self._values["fuzz_var"] = fuzz_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var

    @builtins.property
    def fuzz(self) -> typing.Optional[builtins.str]:
        '''The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz DataAkamaiImagingPolicyImage#fuzz}
        '''
        result = self._values.get("fuzz")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fuzz_var(self) -> typing.Optional[builtins.str]:
        '''The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz_var DataAkamaiImagingPolicyImage#fuzz_var}
        '''
        result = self._values.get("fuzz_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''The amount of padding in pixels to add to the trimmed image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''The amount of padding in pixels to add to the trimmed image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationTrim(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationTrimList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationTrimList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a622e985c0e8dc6ac2dc0b669d4a5d6cfe841b5517e0348c6ebeeea3003f7bc)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationTrimOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d9c0fe08225528de2b98e14113b4eacacf3749a211e7f748ffb2cf95e68def0e)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationTrimOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eea2d01fb77ef826e953d3823cdb0fc5ed5832b5ffad3bc2a722470e5e414e23)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ccfd7c86d3db43f868d2f91a3b661e0035d685064efd269ceb9ac0dbf5aba61f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d1c6520ac03730d6aed7c032b180588366550a18c2ca69631cdd8b73cc0e85df)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationTrim]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationTrim]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationTrim]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d7e853267986175233a745616270f64555ea016cf73c3ef9181df8be3f653e7e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationTrimOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationTrimOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__96db5bffab2fcccd5cc14b3dff1a0c10878654ce4a8522d62d3e7014d77dce47)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetFuzz")
    def reset_fuzz(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFuzz", []))

    @jsii.member(jsii_name="resetFuzzVar")
    def reset_fuzz_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFuzzVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @builtins.property
    @jsii.member(jsii_name="fuzzInput")
    def fuzz_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fuzzInput"))

    @builtins.property
    @jsii.member(jsii_name="fuzzVarInput")
    def fuzz_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fuzzVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="fuzz")
    def fuzz(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fuzz"))

    @fuzz.setter
    def fuzz(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__70b5a0ae37337057041402a76e9a2a5f2248d993b2ca041de2077da8ee9e5521)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fuzz", value)

    @builtins.property
    @jsii.member(jsii_name="fuzzVar")
    def fuzz_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fuzzVar"))

    @fuzz_var.setter
    def fuzz_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c4a56fb797af9fe6b755d07865b899a1b440731f15cbaa479c18d8196267d59d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fuzzVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df6d1ca93b9ff5d0ea0c8d31bc1bcb2cecbd72acaf1dac15cc33cbd1b76ba59f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__492469adfc7312073b3cb19a57cd2a42f348b4d8ed37a5b515d93e3a91508e9a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationTrim]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationTrim]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationTrim]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ccee434cd5bfad9e9c0a09460089b0e4175f7bec0cc245ce8b9a641c99bd31e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationUnsharpMask",
    jsii_struct_bases=[],
    name_mapping={
        "gain": "gain",
        "gain_var": "gainVar",
        "sigma": "sigma",
        "sigma_var": "sigmaVar",
        "threshold": "threshold",
        "threshold_var": "thresholdVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationUnsharpMask:
    def __init__(
        self,
        *,
        gain: typing.Optional[builtins.str] = None,
        gain_var: typing.Optional[builtins.str] = None,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
        threshold: typing.Optional[builtins.str] = None,
        threshold_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param gain: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        :param gain_var: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        :param sigma: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        :param threshold: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        :param threshold_var: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__77b2e6eb2cf98bfadd0f85d7a3a28dac85769d3926bf4ab820d933a88cdfe0f2)
            check_type(argname="argument gain", value=gain, expected_type=type_hints["gain"])
            check_type(argname="argument gain_var", value=gain_var, expected_type=type_hints["gain_var"])
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
            check_type(argname="argument threshold", value=threshold, expected_type=type_hints["threshold"])
            check_type(argname="argument threshold_var", value=threshold_var, expected_type=type_hints["threshold_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if gain is not None:
            self._values["gain"] = gain
        if gain_var is not None:
            self._values["gain_var"] = gain_var
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var
        if threshold is not None:
            self._values["threshold"] = threshold
        if threshold_var is not None:
            self._values["threshold_var"] = threshold_var

    @builtins.property
    def gain(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        '''
        result = self._values.get("gain")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gain_var(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        '''
        result = self._values.get("gain_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        '''
        result = self._values.get("threshold")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold_var(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        result = self._values.get("threshold_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationUnsharpMask(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationUnsharpMaskList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationUnsharpMaskList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6ca6ad1e4458b5d12671af4925f31a5ca32c3218fd2c99cc717d8fd60bb05fe9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationUnsharpMaskOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1b04567ffbc15fac2194e51a6c6fa2377b82f61e37633907dc8734a4c5fa6932)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationUnsharpMaskOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9328e89d53af9f5b885af31c99391f74c794424fd775c6e90b30fde89fae7504)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2afdd9d0833defbc95578b7a14cfc87eab64fb2412b450742ca73f18eec7f605)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fc527105ef3d75fe185a03df8815ce5205e4990f7cc26a618472779860422c3d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationUnsharpMask]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationUnsharpMask]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationUnsharpMask]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2592c0a83152ca123e181191b024571fb102169c70d1782f29be5632ae82b2c2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationUnsharpMaskOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationUnsharpMaskOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__040e0b0f43c82d4339c9b3be620be9d4b1e486f1d017e8f21f579b020a45c6c6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetGain")
    def reset_gain(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGain", []))

    @jsii.member(jsii_name="resetGainVar")
    def reset_gain_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGainVar", []))

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @jsii.member(jsii_name="resetThreshold")
    def reset_threshold(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThreshold", []))

    @jsii.member(jsii_name="resetThresholdVar")
    def reset_threshold_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThresholdVar", []))

    @builtins.property
    @jsii.member(jsii_name="gainInput")
    def gain_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainInput"))

    @builtins.property
    @jsii.member(jsii_name="gainVarInput")
    def gain_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdInput")
    def threshold_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdVarInput")
    def threshold_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gain")
    def gain(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gain"))

    @gain.setter
    def gain(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__18c5bddfb7c30c102b72a57fe2b64bf6ce5337b2945d04fc45f5c7bb1cea6de4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gain", value)

    @builtins.property
    @jsii.member(jsii_name="gainVar")
    def gain_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gainVar"))

    @gain_var.setter
    def gain_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1cc4c9dcfb94d24bfbd16225fb88274a033307deb909178659a1bd44e05919d5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gainVar", value)

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d1c827dafb941c47bf65900d4564bf1b9e85be20c1a59da6e86b7a19ed8e9c5b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8501c50f8fd8938d61972387f4ecdc2c024f1dd7797dbd26362c2fcd5fbefd7f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="threshold")
    def threshold(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "threshold"))

    @threshold.setter
    def threshold(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9748de274431c3893bef49cab4e2ebcfb0c8afddb89801dae609f95b83a89a95)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "threshold", value)

    @builtins.property
    @jsii.member(jsii_name="thresholdVar")
    def threshold_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "thresholdVar"))

    @threshold_var.setter
    def threshold_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4594f476674ea3baaf71718e45b3f2ea144bada992edf47a7213b5e12369e06f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "thresholdVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationUnsharpMask]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationUnsharpMask]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationUnsharpMask]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8573566209d599131444a55f248121f938c956f5e8c24accf1c9be9e226d9b55)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5fdff205df3f3ade30d2e6e8a6fd17ce3a6052d094da710d9c52f92fae557636)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAppendOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7dc07dd0f484c7597f35665d4720ec37b1d6b520292919512f49a0cd052b2bd4)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAppendOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__821dd5584781dfe4cc066b8d1a2c4eb357e5465dbafe4b05c86f5e96704599d6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c1eb1cbb75b582df336a525c34ecc08e5bb42199daefa93f8ae78f0ec5a62670)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9587cb670cbc926e55eb5571260e8d8cc147b73921e48f0bd450d073a918577a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppend]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppend]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppend]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__89ba5d99708bbe41d3e5e1c39503b2f100f8fe5d572dcdb911f3a8ae885f88ca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsAppendOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAppendOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__49dd42bffd617ce247128fd75a6542e9f41ad097b95e4f21a72ee0b7c040e255)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(
        self,
        *,
        box_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
        circle_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
        text_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
        url_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param box_image: box_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#box_image DataAkamaiImagingPolicyImage#box_image}
        :param circle_image: circle_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#circle_image DataAkamaiImagingPolicyImage#circle_image}
        :param text_image: text_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text_image DataAkamaiImagingPolicyImage#text_image}
        :param url_image: url_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url_image DataAkamaiImagingPolicyImage#url_image}
        '''
        value = DataAkamaiImagingPolicyImagePolicyTransformationsAppendImage(
            box_image=box_image,
            circle_image=circle_image,
            text_image=text_image,
            url_image=url_image,
        )

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityPriority")
    def reset_gravity_priority(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityPriority", []))

    @jsii.member(jsii_name="resetGravityPriorityVar")
    def reset_gravity_priority_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityPriorityVar", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPreserveMinorDimension")
    def reset_preserve_minor_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPreserveMinorDimension", []))

    @jsii.member(jsii_name="resetPreserveMinorDimensionVar")
    def reset_preserve_minor_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPreserveMinorDimensionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityInput")
    def gravity_priority_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityPriorityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityVarInput")
    def gravity_priority_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityPriorityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionInput")
    def preserve_minor_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "preserveMinorDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionVarInput")
    def preserve_minor_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "preserveMinorDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cecb51bf7685ac06e7556e8895c9dda864824859e5e4bbad7ac1b9915854d641)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityPriority")
    def gravity_priority(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityPriority"))

    @gravity_priority.setter
    def gravity_priority(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4f73f1fd0ff57c5fbca2304edb58c07aa6d58a944b2bf02eb432c9957b13c14a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityPriority", value)

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityVar")
    def gravity_priority_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityPriorityVar"))

    @gravity_priority_var.setter
    def gravity_priority_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3b593d023505d842b7df136903e554ad066dcca2b5fe07d4b09aa55d4752745a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityPriorityVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7244e3b344585b0cb72f2e5dca8f9350a8fc31a3da6a2394e893ae6e5c949b48)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimension")
    def preserve_minor_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "preserveMinorDimension"))

    @preserve_minor_dimension.setter
    def preserve_minor_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__78ea0e7cb37f165c317133dd9c4d4e00129b975b283d967fab336fe86d2d9002)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "preserveMinorDimension", value)

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionVar")
    def preserve_minor_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "preserveMinorDimensionVar"))

    @preserve_minor_dimension_var.setter
    def preserve_minor_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eca45b25c902cad1c973040e2c532ad34d959642c5d5fdf2a4aef4a585050faa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "preserveMinorDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppend]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppend]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppend]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e47876f995ed003e9bad4c2784d2ebe811e36d12400bbc713d258f990e26719a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAspectCrop",
    jsii_struct_bases=[],
    name_mapping={
        "allow_expansion": "allowExpansion",
        "allow_expansion_var": "allowExpansionVar",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsAspectCrop:
    def __init__(
        self,
        *,
        allow_expansion: typing.Optional[builtins.str] = None,
        allow_expansion_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_expansion: Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image. Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        :param allow_expansion_var: Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image. Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        :param height: The height term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The width term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        :param x_position: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__efd952d57a6d7a15ac8a3b63104f8422471126a0a2a6231381b5a0115604a7d9)
            check_type(argname="argument allow_expansion", value=allow_expansion, expected_type=type_hints["allow_expansion"])
            check_type(argname="argument allow_expansion_var", value=allow_expansion_var, expected_type=type_hints["allow_expansion_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if allow_expansion is not None:
            self._values["allow_expansion"] = allow_expansion
        if allow_expansion_var is not None:
            self._values["allow_expansion_var"] = allow_expansion_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def allow_expansion(self) -> typing.Optional[builtins.str]:
        '''Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image.

        Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        '''
        result = self._values.get("allow_expansion")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def allow_expansion_var(self) -> typing.Optional[builtins.str]:
        '''Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image.

        Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        '''
        result = self._values.get("allow_expansion_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsAspectCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsAspectCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAspectCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__909fd9f81e7f390a46d7842f36f01cac22ab1c4d2cb1eeb76757d7865795f211)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsAspectCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b1772bb429cc3416bd8a36d0b1cb81918c7a8ace146a35007958ae4ed3bb65e2)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsAspectCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__646d592b8d580f8a564ebdf511163a402275feddf1483a41e690ff27e0c2d47d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__63ae683e43807172d54da3ef3db6edc32384e89d52af7b43cd9ef4465b443f73)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__759354895143d03865781cf33a3c5cbfd8f08c3ccc27d42f858f2119a5eae4c1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAspectCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAspectCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAspectCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__85b3660889989b7e3c6cf69c8b32c730f502649eb505163f498d151cc01fccb9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsAspectCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsAspectCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d2136eff98cf044fffff9259dd461323ca159f8586bc1d960810feb5d1f2f8f4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAllowExpansion")
    def reset_allow_expansion(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansion", []))

    @jsii.member(jsii_name="resetAllowExpansionVar")
    def reset_allow_expansion_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansionVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionInput")
    def allow_expansion_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVarInput")
    def allow_expansion_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansion")
    def allow_expansion(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansion"))

    @allow_expansion.setter
    def allow_expansion(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6ce1fdbab91664554b16f7f9a554bd2d2584ad24e95f50d6124aadd9449ae931)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansion", value)

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVar")
    def allow_expansion_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansionVar"))

    @allow_expansion_var.setter
    def allow_expansion_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1777c7ee2cb0acea1ac7c8d45228cfd52de37318a545f780d0dd9126a4f6dcd3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansionVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__85baa6cf1faa57aa02bdb588bb13f2029552cde615cda7f4498945957a4b7b4b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__76d957310bf225857bdb24fab75115757dba19f681f37abaf2b2157b9e02ebf0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7f5d49730e37e1a66297e78547dc2b43b96dcdb8ebda820974b70e38fd1c0f5b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2bb4568dcbe7d5288993b29117ce5630d66b771aba8d450cd5e3a3b028517250)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a0c585ea88c0fb3ebb58cc1d6791709841a84aa06247578690afb4aac6f9a09b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1ffd36853aa2303f9b28e6373348eb165330690de4d2454548f2ef4fb5dd348a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f8f71ebc5f7a502c8b56bf573bbb5f77545403d2ed49ab3d0c3ee53782ac8f8a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f94f3f0689c58aed22a41721aab1bccd25185768f2f5145da0ee4db55eb66599)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAspectCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAspectCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAspectCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3c0ff0085f091cdfe7071292637354ec1c148c265fc7d2d1bb1ffe66fa8b8a0a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsBackgroundColor",
    jsii_struct_bases=[],
    name_mapping={"color": "color", "color_var": "colorVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsBackgroundColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ee2fd85fdfdb81dbda3a24e9df4707146c81d3179c5b24c4a3c86f825052258c)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsBackgroundColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsBackgroundColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsBackgroundColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f757e673f05dd002d939cc3be6ee1c4916165bb314e996cfd92d70e92ae5d0c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsBackgroundColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__101336cba61caef6b08d746add796a91283d4343e55be0255b2c3e3e8a3bcc76)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsBackgroundColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__03bfc0815bccc431987670eda03d2e6ff76232ba5b69fc172d3a61a657a1376a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__900e653d545c105336a122a10406d17ea799fed3b770eb3d585edddc675ca667)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0a6ab2c8fe900e15cdfa420e9706eef90b2097c571807da197c2914328db5989)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsBackgroundColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsBackgroundColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cdd0392c389e1afef0f7d76d84b4bcb030a406a1fc2caab5a7542e1c841357ce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsBackgroundColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsBackgroundColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__76df0dfa6739ffc81cdb8eeb1c9335e380676f8301d8301d5d6cc2029b322895)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b61e8a8297ddde4b7c396b5d9a80d899c53c202f7b34cff1cd713838a647bc87)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__397badf618e12158d27bb7131e86099767bd1e2af5cfafbb8f119108102691ef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsBackgroundColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsBackgroundColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsBackgroundColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__42cf7b1f80d73362bda1e0f7f0a3c2f955b743530d807ff40abc3dc7c849ac2f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsBlur",
    jsii_struct_bases=[],
    name_mapping={"sigma": "sigma", "sigma_var": "sigmaVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsBlur:
    def __init__(
        self,
        *,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param sigma: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dda77361ff160f0e7b017be871ea3c4c0bbb1788f3c0554b9474d08eceeb9b28)
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsBlur(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsBlurList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsBlurList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e8f3d5ba8a78cf91b743b34ec2e7a33a953b44d88cc8b8b75bd0805c2f788419)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsBlurOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bf7d4cf1347dc6c703a476cd73269d9f02be3476fb497a02ba34530ee2af3678)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsBlurOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__54b5381f6e89f170fc9de5ef3c430870d4988983002c77b7c0dd12119cf2ba26)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e5355cf8126681bb938d134b7bdd4d27ac992455d3c2f17e3abe32b8c2e83067)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d1badc82b7fea334877e3eeb60a4c213913de269b3e512d4eef38be23b408a7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsBlur]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsBlur]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ca85f7f24185cc4b2681bcf97ee40c3fcc920d28624e5bebfbd315d2f5a5a1f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsBlurOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsBlurOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__234b1cb3a6b739cf9d52711a1420564fb2eb6228576baaa4622ae3947549250f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f8137734564a9bd17b17d7471758ebbd330658fd8c82d35c056738ffc2089c65)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__084dac126dc5af4982a67557f79b9d98c736dc70efa5e2331f1999d69d755f06)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsBlur]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsBlur]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsBlur]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__78db30c13ba4dc7eba4b5acab4d59b726e1badc93b1ca188be3cbb3aa31f6565)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsChromaKey",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_feather": "hueFeather",
        "hue_feather_var": "hueFeatherVar",
        "hue_tolerance": "hueTolerance",
        "hue_tolerance_var": "hueToleranceVar",
        "hue_var": "hueVar",
        "lightness_feather": "lightnessFeather",
        "lightness_feather_var": "lightnessFeatherVar",
        "lightness_tolerance": "lightnessTolerance",
        "lightness_tolerance_var": "lightnessToleranceVar",
        "saturation_feather": "saturationFeather",
        "saturation_feather_var": "saturationFeatherVar",
        "saturation_tolerance": "saturationTolerance",
        "saturation_tolerance_var": "saturationToleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsChromaKey:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_feather: typing.Optional[builtins.str] = None,
        hue_feather_var: typing.Optional[builtins.str] = None,
        hue_tolerance: typing.Optional[builtins.str] = None,
        hue_tolerance_var: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness_feather: typing.Optional[builtins.str] = None,
        lightness_feather_var: typing.Optional[builtins.str] = None,
        lightness_tolerance: typing.Optional[builtins.str] = None,
        lightness_tolerance_var: typing.Optional[builtins.str] = None,
        saturation_feather: typing.Optional[builtins.str] = None,
        saturation_feather_var: typing.Optional[builtins.str] = None,
        saturation_tolerance: typing.Optional[builtins.str] = None,
        saturation_tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_feather: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        :param hue_feather_var: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        :param hue_tolerance: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        :param hue_tolerance_var: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        :param hue_var: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness_feather: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        :param lightness_feather_var: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        :param lightness_tolerance: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        :param lightness_tolerance_var: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        :param saturation_feather: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        :param saturation_feather_var: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        :param saturation_tolerance: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        :param saturation_tolerance_var: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__98885f7da124b8e471205ae6f96a87043709946a560535fb8ca86871e558283b)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_feather", value=hue_feather, expected_type=type_hints["hue_feather"])
            check_type(argname="argument hue_feather_var", value=hue_feather_var, expected_type=type_hints["hue_feather_var"])
            check_type(argname="argument hue_tolerance", value=hue_tolerance, expected_type=type_hints["hue_tolerance"])
            check_type(argname="argument hue_tolerance_var", value=hue_tolerance_var, expected_type=type_hints["hue_tolerance_var"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness_feather", value=lightness_feather, expected_type=type_hints["lightness_feather"])
            check_type(argname="argument lightness_feather_var", value=lightness_feather_var, expected_type=type_hints["lightness_feather_var"])
            check_type(argname="argument lightness_tolerance", value=lightness_tolerance, expected_type=type_hints["lightness_tolerance"])
            check_type(argname="argument lightness_tolerance_var", value=lightness_tolerance_var, expected_type=type_hints["lightness_tolerance_var"])
            check_type(argname="argument saturation_feather", value=saturation_feather, expected_type=type_hints["saturation_feather"])
            check_type(argname="argument saturation_feather_var", value=saturation_feather_var, expected_type=type_hints["saturation_feather_var"])
            check_type(argname="argument saturation_tolerance", value=saturation_tolerance, expected_type=type_hints["saturation_tolerance"])
            check_type(argname="argument saturation_tolerance_var", value=saturation_tolerance_var, expected_type=type_hints["saturation_tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_feather is not None:
            self._values["hue_feather"] = hue_feather
        if hue_feather_var is not None:
            self._values["hue_feather_var"] = hue_feather_var
        if hue_tolerance is not None:
            self._values["hue_tolerance"] = hue_tolerance
        if hue_tolerance_var is not None:
            self._values["hue_tolerance_var"] = hue_tolerance_var
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness_feather is not None:
            self._values["lightness_feather"] = lightness_feather
        if lightness_feather_var is not None:
            self._values["lightness_feather_var"] = lightness_feather_var
        if lightness_tolerance is not None:
            self._values["lightness_tolerance"] = lightness_tolerance
        if lightness_tolerance_var is not None:
            self._values["lightness_tolerance_var"] = lightness_tolerance_var
        if saturation_feather is not None:
            self._values["saturation_feather"] = saturation_feather
        if saturation_feather_var is not None:
            self._values["saturation_feather_var"] = saturation_feather_var
        if saturation_tolerance is not None:
            self._values["saturation_tolerance"] = saturation_tolerance
        if saturation_tolerance_var is not None:
            self._values["saturation_tolerance_var"] = saturation_tolerance_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        '''
        result = self._values.get("hue_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        '''
        result = self._values.get("hue_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        '''
        result = self._values.get("hue_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        '''
        result = self._values.get("hue_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        '''
        result = self._values.get("lightness_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        '''
        result = self._values.get("lightness_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        '''
        result = self._values.get("lightness_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        '''
        result = self._values.get("lightness_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        '''
        result = self._values.get("saturation_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        '''
        result = self._values.get("saturation_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        '''
        result = self._values.get("saturation_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        result = self._values.get("saturation_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsChromaKey(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsChromaKeyList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsChromaKeyList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a0d6f1b45bebd2b81d8b4eeba8a5edc93548c9b9dbe05bf780f279b387d2b63)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsChromaKeyOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a9d6de0ca460c87a5f2af5056717acda090814e9912cc92d686c22b39869b563)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsChromaKeyOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c63fecd0b18a936bbb187fbd078a38ebf121ecd60838c9619c54a54692f893d8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__77c1c2ee612a8e369ac8711f1679d8a59008f9f603c707e2b310ce0df5fc692e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__adc9c5839b3c389f74e341d4981914dbef12478962b066bc03c1831988f2b347)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsChromaKey]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsChromaKey]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d392589750d590c2285e6ce674cfd518f3231cc51641d1e1a52c10e4a1b6e1c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsChromaKeyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsChromaKeyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__87556385d847f27d96fb095cb3ecb5051a4504509834241b0c97e9864e80638b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueFeather")
    def reset_hue_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeather", []))

    @jsii.member(jsii_name="resetHueFeatherVar")
    def reset_hue_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeatherVar", []))

    @jsii.member(jsii_name="resetHueTolerance")
    def reset_hue_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueTolerance", []))

    @jsii.member(jsii_name="resetHueToleranceVar")
    def reset_hue_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueToleranceVar", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightnessFeather")
    def reset_lightness_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeather", []))

    @jsii.member(jsii_name="resetLightnessFeatherVar")
    def reset_lightness_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeatherVar", []))

    @jsii.member(jsii_name="resetLightnessTolerance")
    def reset_lightness_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessTolerance", []))

    @jsii.member(jsii_name="resetLightnessToleranceVar")
    def reset_lightness_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessToleranceVar", []))

    @jsii.member(jsii_name="resetSaturationFeather")
    def reset_saturation_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeather", []))

    @jsii.member(jsii_name="resetSaturationFeatherVar")
    def reset_saturation_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeatherVar", []))

    @jsii.member(jsii_name="resetSaturationTolerance")
    def reset_saturation_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationTolerance", []))

    @jsii.member(jsii_name="resetSaturationToleranceVar")
    def reset_saturation_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherInput")
    def hue_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVarInput")
    def hue_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceInput")
    def hue_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVarInput")
    def hue_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherInput")
    def lightness_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVarInput")
    def lightness_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceInput")
    def lightness_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVarInput")
    def lightness_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherInput")
    def saturation_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVarInput")
    def saturation_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceInput")
    def saturation_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVarInput")
    def saturation_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ce5622bd46b9a25c6c48bf9860f0d7271d780b80e5948ae83cfe610d302b204)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeather")
    def hue_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeather"))

    @hue_feather.setter
    def hue_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__32d339ac80f2873edde141e62576a0fd24c45cc280eb86670c28b8b6b3a1f137)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeather", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVar")
    def hue_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeatherVar"))

    @hue_feather_var.setter
    def hue_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fb117c0dc4b990ad6479c8efcd915d6ff603924c073fd8f6d0b3a2e38e315572)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueTolerance")
    def hue_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueTolerance"))

    @hue_tolerance.setter
    def hue_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e97607e90371a6325fa892ac97796794ff9f9888fb433638f50c14c483d09c37)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVar")
    def hue_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueToleranceVar"))

    @hue_tolerance_var.setter
    def hue_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c373a582c75a09a7c4d51f1f36051b69e2ad351d675319e201c351ae8e8df3b3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__57677d28b97a60032dd0359e9740fd22971b66945af93f00fd8b4747e5c4ba70)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeather")
    def lightness_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeather"))

    @lightness_feather.setter
    def lightness_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0c250bc68f8abc59d574a70784bbd703ca2ca58399eacd254c99042c27a8b936)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeather", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVar")
    def lightness_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeatherVar"))

    @lightness_feather_var.setter
    def lightness_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0e3314cc979f6e91a2fc1963867812990610307dfb75f014f5ea792b5539dcf6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessTolerance")
    def lightness_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessTolerance"))

    @lightness_tolerance.setter
    def lightness_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9773107e61bfae524db7678ec5c1ccb83a4af50d951594aaa29a1fbebdf65439)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVar")
    def lightness_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessToleranceVar"))

    @lightness_tolerance_var.setter
    def lightness_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__229fe4e7d5aaf4016239bee18d10f6608393fc7545478b7cd5d64854d6ddb03e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeather")
    def saturation_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeather"))

    @saturation_feather.setter
    def saturation_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b9402e3159c0b979499e1b22513e3593717999ea49a6bc3b2a3727dfae7f837e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeather", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVar")
    def saturation_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeatherVar"))

    @saturation_feather_var.setter
    def saturation_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__258d335827c267dcef3286ab39e9f9ebbe0ca6b412a37e7116bf3fb9c2cbbd28)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationTolerance")
    def saturation_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationTolerance"))

    @saturation_tolerance.setter
    def saturation_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c5eb549c7a70ea7bc25904bc575e744ee6ff042ae0f6cdedb517841054c6c99f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVar")
    def saturation_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationToleranceVar"))

    @saturation_tolerance_var.setter
    def saturation_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dc2bbf8be28495efa7ab02154abf6bce49a7d8e2149e0e7a97a7b79c6778da54)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsChromaKey]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsChromaKey]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsChromaKey]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7641264decb01843b68eff6d0522ca1957302bd059778432e91bc8f02cd402ae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsComposite",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "placement": "placement",
        "placement_var": "placementVar",
        "scale": "scale",
        "scale_dimension": "scaleDimension",
        "scale_dimension_var": "scaleDimensionVar",
        "scale_var": "scaleVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsComposite:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        placement: typing.Optional[builtins.str] = None,
        placement_var: typing.Optional[builtins.str] = None,
        scale: typing.Optional[builtins.str] = None,
        scale_dimension: typing.Optional[builtins.str] = None,
        scale_dimension_var: typing.Optional[builtins.str] = None,
        scale_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param placement: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        :param placement_var: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        :param scale: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param scale_dimension: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        :param scale_dimension_var: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        :param scale_var: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        :param x_position: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__593593c19968fce59a0f5803f8fdf9d6c73ed10fbc8666bae35086d10b7cf4e9)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument placement", value=placement, expected_type=type_hints["placement"])
            check_type(argname="argument placement_var", value=placement_var, expected_type=type_hints["placement_var"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument scale_dimension", value=scale_dimension, expected_type=type_hints["scale_dimension"])
            check_type(argname="argument scale_dimension_var", value=scale_dimension_var, expected_type=type_hints["scale_dimension_var"])
            check_type(argname="argument scale_var", value=scale_var, expected_type=type_hints["scale_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if placement is not None:
            self._values["placement"] = placement
        if placement_var is not None:
            self._values["placement_var"] = placement_var
        if scale is not None:
            self._values["scale"] = scale
        if scale_dimension is not None:
            self._values["scale_dimension"] = scale_dimension
        if scale_dimension_var is not None:
            self._values["scale_dimension_var"] = scale_dimension_var
        if scale_var is not None:
            self._values["scale_var"] = scale_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        '''
        result = self._values.get("placement")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement_var(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        '''
        result = self._values.get("placement_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        '''
        result = self._values.get("scale_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        '''
        result = self._values.get("scale_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        '''
        result = self._values.get("scale_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsComposite(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImage",
    jsii_struct_bases=[],
    name_mapping={
        "box_image": "boxImage",
        "circle_image": "circleImage",
        "text_image": "textImage",
        "url_image": "urlImage",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImage:
    def __init__(
        self,
        *,
        box_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImage", typing.Dict[builtins.str, typing.Any]]]]] = None,
        circle_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImage", typing.Dict[builtins.str, typing.Any]]]]] = None,
        text_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImage", typing.Dict[builtins.str, typing.Any]]]]] = None,
        url_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImage", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param box_image: box_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#box_image DataAkamaiImagingPolicyImage#box_image}
        :param circle_image: circle_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#circle_image DataAkamaiImagingPolicyImage#circle_image}
        :param text_image: text_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text_image DataAkamaiImagingPolicyImage#text_image}
        :param url_image: url_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url_image DataAkamaiImagingPolicyImage#url_image}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2f40b35f6a30b8acbb02c5c8d12d19fab6e2aff2c1d837b6f094d612050b7feb)
            check_type(argname="argument box_image", value=box_image, expected_type=type_hints["box_image"])
            check_type(argname="argument circle_image", value=circle_image, expected_type=type_hints["circle_image"])
            check_type(argname="argument text_image", value=text_image, expected_type=type_hints["text_image"])
            check_type(argname="argument url_image", value=url_image, expected_type=type_hints["url_image"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if box_image is not None:
            self._values["box_image"] = box_image
        if circle_image is not None:
            self._values["circle_image"] = circle_image
        if text_image is not None:
            self._values["text_image"] = text_image
        if url_image is not None:
            self._values["url_image"] = url_image

    @builtins.property
    def box_image(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImage"]]]:
        '''box_image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#box_image DataAkamaiImagingPolicyImage#box_image}
        '''
        result = self._values.get("box_image")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImage"]]], result)

    @builtins.property
    def circle_image(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImage"]]]:
        '''circle_image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#circle_image DataAkamaiImagingPolicyImage#circle_image}
        '''
        result = self._values.get("circle_image")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImage"]]], result)

    @builtins.property
    def text_image(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImage"]]]:
        '''text_image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text_image DataAkamaiImagingPolicyImage#text_image}
        '''
        result = self._values.get("text_image")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImage"]]], result)

    @builtins.property
    def url_image(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImage"]]]:
        '''url_image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url_image DataAkamaiImagingPolicyImage#url_image}
        '''
        result = self._values.get("url_image")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImage"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImage",
    jsii_struct_bases=[],
    name_mapping={
        "color": "color",
        "color_var": "colorVar",
        "height": "height",
        "height_var": "heightVar",
        "transformation": "transformation",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImage:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        transformation: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The fill color of the box, not the edge of the box. The API supports hexadecimal representation and CSS hexadecimal color values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The fill color of the box, not the edge of the box. The API supports hexadecimal representation and CSS hexadecimal color values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        :param height: The height of the box in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height of the box in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param transformation: transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        :param width: The width of the box in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width of the box in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(transformation, dict):
            transformation = DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformation(**transformation)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8aba99a388f031f6d4dffb59b706690e63d19d759242781b1ad4fba8a239fbcc)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument transformation", value=transformation, expected_type=type_hints["transformation"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if transformation is not None:
            self._values["transformation"] = transformation
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The fill color of the box, not the edge of the box.

        The API supports hexadecimal representation and CSS hexadecimal color values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The fill color of the box, not the edge of the box.

        The API supports hexadecimal representation and CSS hexadecimal color values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height of the box in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height of the box in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def transformation(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformation"]:
        '''transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        '''
        result = self._values.get("transformation")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformation"], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width of the box in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width of the box in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8e53077bdcc7daf3d5047b895557079323f410c70bebad1c69b0f4b430a72410)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f3d518dfe279e6e3827702a4e0ec17759ac64d08cfd48575ccca16559774357)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__36daa76cea4e36166949ff9eaa25ed1a432ddc4c18876245ed9cbf878078f572)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1c40cdfc9bcd3b2f1a7c968aea52d8af1e7750c4c0d48ec25f45a4cbface36c7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__92d5b78f47dd9299567f969c2448cd6a42b4de2b9fd7c998f2b4f62b2cef7991)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImage]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImage]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImage]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__05a075b11afd54ec886d587c59cdc2c585a94bb65b10c868add755d1715f3b4d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a74910e884ccc9b49ec4d77870c448f0533085c2a3483d88a7827b1f22ef8076)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformation")
    def put_transformation(
        self,
        *,
        append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationAppend", typing.Dict[builtins.str, typing.Any]]]]] = None,
        aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationAspectCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationBackgroundColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationBlur", typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationChromaKey", typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationComposite", typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationCompound", typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationContrast", typing.Dict[builtins.str, typing.Any]]]]] = None,
        crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationFaceCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationFeatureCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationFitAndFill", typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationGoop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationGrayscale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationHsl", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationHsv", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfDimension", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfOrientation", typing.Dict[builtins.str, typing.Any]]]]] = None,
        im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationImQuery", typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationMaxColors", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationMirror", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationMonoHue", typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationOpacity", typing.Dict[builtins.str, typing.Any]]]]] = None,
        region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationRegionOfInterestCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationRelativeCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationRemoveColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationResize", typing.Dict[builtins.str, typing.Any]]]]] = None,
        rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationRotate", typing.Dict[builtins.str, typing.Any]]]]] = None,
        scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationScale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationShear", typing.Dict[builtins.str, typing.Any]]]]] = None,
        trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationTrim", typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationUnsharpMask", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param append: append block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        :param aspect_crop: aspect_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param crop: crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        :param face_crop: face_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        :param feature_crop: feature_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        :param fit_and_fill: fit_and_fill block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param im_query: im_query block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param region_of_interest_crop: region_of_interest_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        :param relative_crop: relative_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param resize: resize block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        :param rotate: rotate block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        :param scale: scale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param shear: shear block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        :param trim: trim block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        value = DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformation(
            append=append,
            aspect_crop=aspect_crop,
            background_color=background_color,
            blur=blur,
            chroma_key=chroma_key,
            composite=composite,
            compound=compound,
            contrast=contrast,
            crop=crop,
            face_crop=face_crop,
            feature_crop=feature_crop,
            fit_and_fill=fit_and_fill,
            goop=goop,
            grayscale=grayscale,
            hsl=hsl,
            hsv=hsv,
            if_dimension=if_dimension,
            if_orientation=if_orientation,
            im_query=im_query,
            max_colors=max_colors,
            mirror=mirror,
            mono_hue=mono_hue,
            opacity=opacity,
            region_of_interest_crop=region_of_interest_crop,
            relative_crop=relative_crop,
            remove_color=remove_color,
            resize=resize,
            rotate=rotate,
            scale=scale,
            shear=shear,
            trim=trim,
            unsharp_mask=unsharp_mask,
        )

        return typing.cast(None, jsii.invoke(self, "putTransformation", [value]))

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetTransformation")
    def reset_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformation", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="transformation")
    def transformation(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationOutputReference", jsii.get(self, "transformation"))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="transformationInput")
    def transformation_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformation"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformation"], jsii.get(self, "transformationInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c9f7d86c469880a6694f14ad785a824d295a5597939f4ab455284bc229da51c0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0bf518061e29e5b7091def99f23c57ffc016e774e6ce015dc5d69dede824c4bf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__101796514f2db95489532e2ece3f81b701bc8855d774b895209e825332d93c8d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5742ad4f2e009928508838cd68f50b6fcca97dc7bd3cd9e9c75e1c0401c0700a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af46059c0a498c51cdd7ffcf7242841515b4ea3ee518e6acd1de359cdb1622dd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__33e3464af66a88f98ec401cc62bb531685952a6cc738ad28cba6a2297a8bed69)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImage]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImage]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImage]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fb9ce194484bb5e58c2d476b1104c7686091477f0f61aca825fc016e6bdec7f9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformation",
    jsii_struct_bases=[],
    name_mapping={
        "append": "append",
        "aspect_crop": "aspectCrop",
        "background_color": "backgroundColor",
        "blur": "blur",
        "chroma_key": "chromaKey",
        "composite": "composite",
        "compound": "compound",
        "contrast": "contrast",
        "crop": "crop",
        "face_crop": "faceCrop",
        "feature_crop": "featureCrop",
        "fit_and_fill": "fitAndFill",
        "goop": "goop",
        "grayscale": "grayscale",
        "hsl": "hsl",
        "hsv": "hsv",
        "if_dimension": "ifDimension",
        "if_orientation": "ifOrientation",
        "im_query": "imQuery",
        "max_colors": "maxColors",
        "mirror": "mirror",
        "mono_hue": "monoHue",
        "opacity": "opacity",
        "region_of_interest_crop": "regionOfInterestCrop",
        "relative_crop": "relativeCrop",
        "remove_color": "removeColor",
        "resize": "resize",
        "rotate": "rotate",
        "scale": "scale",
        "shear": "shear",
        "trim": "trim",
        "unsharp_mask": "unsharpMask",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformation:
    def __init__(
        self,
        *,
        append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationAppend", typing.Dict[builtins.str, typing.Any]]]]] = None,
        aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationAspectCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationBackgroundColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationBlur", typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationChromaKey", typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationComposite", typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationCompound", typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationContrast", typing.Dict[builtins.str, typing.Any]]]]] = None,
        crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationFaceCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationFeatureCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationFitAndFill", typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationGoop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationGrayscale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationHsl", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationHsv", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfDimension", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfOrientation", typing.Dict[builtins.str, typing.Any]]]]] = None,
        im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationImQuery", typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationMaxColors", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationMirror", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationMonoHue", typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationOpacity", typing.Dict[builtins.str, typing.Any]]]]] = None,
        region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationRegionOfInterestCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationRelativeCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationRemoveColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationResize", typing.Dict[builtins.str, typing.Any]]]]] = None,
        rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationRotate", typing.Dict[builtins.str, typing.Any]]]]] = None,
        scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationScale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationShear", typing.Dict[builtins.str, typing.Any]]]]] = None,
        trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationTrim", typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationUnsharpMask", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param append: append block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        :param aspect_crop: aspect_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param crop: crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        :param face_crop: face_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        :param feature_crop: feature_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        :param fit_and_fill: fit_and_fill block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param im_query: im_query block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param region_of_interest_crop: region_of_interest_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        :param relative_crop: relative_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param resize: resize block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        :param rotate: rotate block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        :param scale: scale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param shear: shear block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        :param trim: trim block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b0e180d98105b190150693a46773387f121ceaab59ce2084e3b0511add1502f0)
            check_type(argname="argument append", value=append, expected_type=type_hints["append"])
            check_type(argname="argument aspect_crop", value=aspect_crop, expected_type=type_hints["aspect_crop"])
            check_type(argname="argument background_color", value=background_color, expected_type=type_hints["background_color"])
            check_type(argname="argument blur", value=blur, expected_type=type_hints["blur"])
            check_type(argname="argument chroma_key", value=chroma_key, expected_type=type_hints["chroma_key"])
            check_type(argname="argument composite", value=composite, expected_type=type_hints["composite"])
            check_type(argname="argument compound", value=compound, expected_type=type_hints["compound"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument crop", value=crop, expected_type=type_hints["crop"])
            check_type(argname="argument face_crop", value=face_crop, expected_type=type_hints["face_crop"])
            check_type(argname="argument feature_crop", value=feature_crop, expected_type=type_hints["feature_crop"])
            check_type(argname="argument fit_and_fill", value=fit_and_fill, expected_type=type_hints["fit_and_fill"])
            check_type(argname="argument goop", value=goop, expected_type=type_hints["goop"])
            check_type(argname="argument grayscale", value=grayscale, expected_type=type_hints["grayscale"])
            check_type(argname="argument hsl", value=hsl, expected_type=type_hints["hsl"])
            check_type(argname="argument hsv", value=hsv, expected_type=type_hints["hsv"])
            check_type(argname="argument if_dimension", value=if_dimension, expected_type=type_hints["if_dimension"])
            check_type(argname="argument if_orientation", value=if_orientation, expected_type=type_hints["if_orientation"])
            check_type(argname="argument im_query", value=im_query, expected_type=type_hints["im_query"])
            check_type(argname="argument max_colors", value=max_colors, expected_type=type_hints["max_colors"])
            check_type(argname="argument mirror", value=mirror, expected_type=type_hints["mirror"])
            check_type(argname="argument mono_hue", value=mono_hue, expected_type=type_hints["mono_hue"])
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument region_of_interest_crop", value=region_of_interest_crop, expected_type=type_hints["region_of_interest_crop"])
            check_type(argname="argument relative_crop", value=relative_crop, expected_type=type_hints["relative_crop"])
            check_type(argname="argument remove_color", value=remove_color, expected_type=type_hints["remove_color"])
            check_type(argname="argument resize", value=resize, expected_type=type_hints["resize"])
            check_type(argname="argument rotate", value=rotate, expected_type=type_hints["rotate"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument shear", value=shear, expected_type=type_hints["shear"])
            check_type(argname="argument trim", value=trim, expected_type=type_hints["trim"])
            check_type(argname="argument unsharp_mask", value=unsharp_mask, expected_type=type_hints["unsharp_mask"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if append is not None:
            self._values["append"] = append
        if aspect_crop is not None:
            self._values["aspect_crop"] = aspect_crop
        if background_color is not None:
            self._values["background_color"] = background_color
        if blur is not None:
            self._values["blur"] = blur
        if chroma_key is not None:
            self._values["chroma_key"] = chroma_key
        if composite is not None:
            self._values["composite"] = composite
        if compound is not None:
            self._values["compound"] = compound
        if contrast is not None:
            self._values["contrast"] = contrast
        if crop is not None:
            self._values["crop"] = crop
        if face_crop is not None:
            self._values["face_crop"] = face_crop
        if feature_crop is not None:
            self._values["feature_crop"] = feature_crop
        if fit_and_fill is not None:
            self._values["fit_and_fill"] = fit_and_fill
        if goop is not None:
            self._values["goop"] = goop
        if grayscale is not None:
            self._values["grayscale"] = grayscale
        if hsl is not None:
            self._values["hsl"] = hsl
        if hsv is not None:
            self._values["hsv"] = hsv
        if if_dimension is not None:
            self._values["if_dimension"] = if_dimension
        if if_orientation is not None:
            self._values["if_orientation"] = if_orientation
        if im_query is not None:
            self._values["im_query"] = im_query
        if max_colors is not None:
            self._values["max_colors"] = max_colors
        if mirror is not None:
            self._values["mirror"] = mirror
        if mono_hue is not None:
            self._values["mono_hue"] = mono_hue
        if opacity is not None:
            self._values["opacity"] = opacity
        if region_of_interest_crop is not None:
            self._values["region_of_interest_crop"] = region_of_interest_crop
        if relative_crop is not None:
            self._values["relative_crop"] = relative_crop
        if remove_color is not None:
            self._values["remove_color"] = remove_color
        if resize is not None:
            self._values["resize"] = resize
        if rotate is not None:
            self._values["rotate"] = rotate
        if scale is not None:
            self._values["scale"] = scale
        if shear is not None:
            self._values["shear"] = shear
        if trim is not None:
            self._values["trim"] = trim
        if unsharp_mask is not None:
            self._values["unsharp_mask"] = unsharp_mask

    @builtins.property
    def append(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationAppend"]]]:
        '''append block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        '''
        result = self._values.get("append")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationAppend"]]], result)

    @builtins.property
    def aspect_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationAspectCrop"]]]:
        '''aspect_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        '''
        result = self._values.get("aspect_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationAspectCrop"]]], result)

    @builtins.property
    def background_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationBackgroundColor"]]]:
        '''background_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        '''
        result = self._values.get("background_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationBackgroundColor"]]], result)

    @builtins.property
    def blur(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationBlur"]]]:
        '''blur block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        '''
        result = self._values.get("blur")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationBlur"]]], result)

    @builtins.property
    def chroma_key(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationChromaKey"]]]:
        '''chroma_key block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        '''
        result = self._values.get("chroma_key")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationChromaKey"]]], result)

    @builtins.property
    def composite(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationComposite"]]]:
        '''composite block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        '''
        result = self._values.get("composite")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationComposite"]]], result)

    @builtins.property
    def compound(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationCompound"]]]:
        '''compound block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        '''
        result = self._values.get("compound")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationCompound"]]], result)

    @builtins.property
    def contrast(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationContrast"]]]:
        '''contrast block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationContrast"]]], result)

    @builtins.property
    def crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationCrop"]]]:
        '''crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        '''
        result = self._values.get("crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationCrop"]]], result)

    @builtins.property
    def face_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationFaceCrop"]]]:
        '''face_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        '''
        result = self._values.get("face_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationFaceCrop"]]], result)

    @builtins.property
    def feature_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationFeatureCrop"]]]:
        '''feature_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        '''
        result = self._values.get("feature_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationFeatureCrop"]]], result)

    @builtins.property
    def fit_and_fill(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationFitAndFill"]]]:
        '''fit_and_fill block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        '''
        result = self._values.get("fit_and_fill")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationFitAndFill"]]], result)

    @builtins.property
    def goop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationGoop"]]]:
        '''goop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        '''
        result = self._values.get("goop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationGoop"]]], result)

    @builtins.property
    def grayscale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationGrayscale"]]]:
        '''grayscale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        '''
        result = self._values.get("grayscale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationGrayscale"]]], result)

    @builtins.property
    def hsl(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationHsl"]]]:
        '''hsl block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        '''
        result = self._values.get("hsl")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationHsl"]]], result)

    @builtins.property
    def hsv(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationHsv"]]]:
        '''hsv block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        '''
        result = self._values.get("hsv")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationHsv"]]], result)

    @builtins.property
    def if_dimension(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfDimension"]]]:
        '''if_dimension block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        '''
        result = self._values.get("if_dimension")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfDimension"]]], result)

    @builtins.property
    def if_orientation(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfOrientation"]]]:
        '''if_orientation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        '''
        result = self._values.get("if_orientation")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfOrientation"]]], result)

    @builtins.property
    def im_query(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationImQuery"]]]:
        '''im_query block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        '''
        result = self._values.get("im_query")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationImQuery"]]], result)

    @builtins.property
    def max_colors(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationMaxColors"]]]:
        '''max_colors block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        '''
        result = self._values.get("max_colors")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationMaxColors"]]], result)

    @builtins.property
    def mirror(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationMirror"]]]:
        '''mirror block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        '''
        result = self._values.get("mirror")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationMirror"]]], result)

    @builtins.property
    def mono_hue(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationMonoHue"]]]:
        '''mono_hue block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        '''
        result = self._values.get("mono_hue")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationMonoHue"]]], result)

    @builtins.property
    def opacity(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationOpacity"]]]:
        '''opacity block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationOpacity"]]], result)

    @builtins.property
    def region_of_interest_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationRegionOfInterestCrop"]]]:
        '''region_of_interest_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        '''
        result = self._values.get("region_of_interest_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationRegionOfInterestCrop"]]], result)

    @builtins.property
    def relative_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationRelativeCrop"]]]:
        '''relative_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        '''
        result = self._values.get("relative_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationRelativeCrop"]]], result)

    @builtins.property
    def remove_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationRemoveColor"]]]:
        '''remove_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        '''
        result = self._values.get("remove_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationRemoveColor"]]], result)

    @builtins.property
    def resize(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationResize"]]]:
        '''resize block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        '''
        result = self._values.get("resize")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationResize"]]], result)

    @builtins.property
    def rotate(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationRotate"]]]:
        '''rotate block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        '''
        result = self._values.get("rotate")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationRotate"]]], result)

    @builtins.property
    def scale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationScale"]]]:
        '''scale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationScale"]]], result)

    @builtins.property
    def shear(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationShear"]]]:
        '''shear block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        '''
        result = self._values.get("shear")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationShear"]]], result)

    @builtins.property
    def trim(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationTrim"]]]:
        '''trim block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        '''
        result = self._values.get("trim")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationTrim"]]], result)

    @builtins.property
    def unsharp_mask(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationUnsharpMask"]]]:
        '''unsharp_mask block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        result = self._values.get("unsharp_mask")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationUnsharpMask"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationAppend",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_priority": "gravityPriority",
        "gravity_priority_var": "gravityPriorityVar",
        "gravity_var": "gravityVar",
        "preserve_minor_dimension": "preserveMinorDimension",
        "preserve_minor_dimension_var": "preserveMinorDimensionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationAppend:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationAppendImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_priority: typing.Optional[builtins.str] = None,
        gravity_priority_var: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        preserve_minor_dimension: typing.Optional[builtins.str] = None,
        preserve_minor_dimension_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Specifies where to place the ``image`` relative to the source image. The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_priority: Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal. The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority DataAkamaiImagingPolicyImage#gravity_priority}
        :param gravity_priority_var: Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal. The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority_var DataAkamaiImagingPolicyImage#gravity_priority_var}
        :param gravity_var: Specifies where to place the ``image`` relative to the source image. The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param preserve_minor_dimension: Whether to preserve the source image's minor dimension, ``false`` by default. The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension DataAkamaiImagingPolicyImage#preserve_minor_dimension}
        :param preserve_minor_dimension_var: Whether to preserve the source image's minor dimension, ``false`` by default. The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension_var DataAkamaiImagingPolicyImage#preserve_minor_dimension_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationAppendImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3be3169d07be53b5d6452dd888d5cc30dc933444175568527a05f25290ab1e89)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_priority", value=gravity_priority, expected_type=type_hints["gravity_priority"])
            check_type(argname="argument gravity_priority_var", value=gravity_priority_var, expected_type=type_hints["gravity_priority_var"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument preserve_minor_dimension", value=preserve_minor_dimension, expected_type=type_hints["preserve_minor_dimension"])
            check_type(argname="argument preserve_minor_dimension_var", value=preserve_minor_dimension_var, expected_type=type_hints["preserve_minor_dimension_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_priority is not None:
            self._values["gravity_priority"] = gravity_priority
        if gravity_priority_var is not None:
            self._values["gravity_priority_var"] = gravity_priority_var
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if preserve_minor_dimension is not None:
            self._values["preserve_minor_dimension"] = preserve_minor_dimension
        if preserve_minor_dimension_var is not None:
            self._values["preserve_minor_dimension_var"] = preserve_minor_dimension_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationAppendImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationAppendImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Specifies where to place the ``image`` relative to the source image.

        The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_priority(self) -> typing.Optional[builtins.str]:
        '''Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal.

        The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority DataAkamaiImagingPolicyImage#gravity_priority}
        '''
        result = self._values.get("gravity_priority")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_priority_var(self) -> typing.Optional[builtins.str]:
        '''Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal.

        The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority_var DataAkamaiImagingPolicyImage#gravity_priority_var}
        '''
        result = self._values.get("gravity_priority_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Specifies where to place the ``image`` relative to the source image.

        The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def preserve_minor_dimension(self) -> typing.Optional[builtins.str]:
        '''Whether to preserve the source image's minor dimension, ``false`` by default.

        The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension DataAkamaiImagingPolicyImage#preserve_minor_dimension}
        '''
        result = self._values.get("preserve_minor_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def preserve_minor_dimension_var(self) -> typing.Optional[builtins.str]:
        '''Whether to preserve the source image's minor dimension, ``false`` by default.

        The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension_var DataAkamaiImagingPolicyImage#preserve_minor_dimension_var}
        '''
        result = self._values.get("preserve_minor_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationAppend(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationAppendImage",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationAppendImage:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationAppendImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationAppendImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationAppendImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e90a40f9a85b345da5bbc500071a5108e5cd5cb4a55774ffa8078bfd18144cc5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationAppendImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationAppendImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationAppendImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f1d0aa22d9a13f6176fec7598790420858093f90190c43c27e342e7a72ca11f5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationAppendList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationAppendList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__62f5ccb6c363fa092d07bec0b1e2b6302724e956fb2acb32d7b1b14baf51162c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationAppendOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b9ed3848564d1d02559170040226030072467fee9a0e5ed43add2a3530db9dbe)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationAppendOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d5d54560680c9fd0129b932bf284ca5119cedd73103260784ea0468a4a17cb24)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f055cc68d783bb8aeff66fa24f2975b696b102c1f0da5b0b1055cc7a04a52a40)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0f8ce9b75b51bb88209945f127cae2705c95e6ffcefad6df832cbf5d0c3fd836)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationAppend]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationAppend]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationAppend]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8ec311fc5180b536777887059b516318e716bc180b978505bfae071c69f8a8ab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationAppendOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationAppendOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d95428f3f99fc205861f1971fa64a7cc32b149192e793f2ced531321aa95dcd3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationAppendImage()

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityPriority")
    def reset_gravity_priority(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityPriority", []))

    @jsii.member(jsii_name="resetGravityPriorityVar")
    def reset_gravity_priority_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityPriorityVar", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPreserveMinorDimension")
    def reset_preserve_minor_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPreserveMinorDimension", []))

    @jsii.member(jsii_name="resetPreserveMinorDimensionVar")
    def reset_preserve_minor_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPreserveMinorDimensionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationAppendImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationAppendImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityInput")
    def gravity_priority_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityPriorityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityVarInput")
    def gravity_priority_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityPriorityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationAppendImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationAppendImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionInput")
    def preserve_minor_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "preserveMinorDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionVarInput")
    def preserve_minor_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "preserveMinorDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df411505704bd4bcbf5268a678df4629c3163110838beecfb0390a28745740b1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityPriority")
    def gravity_priority(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityPriority"))

    @gravity_priority.setter
    def gravity_priority(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ca81ac1eb9ea053d340f87913250c6e9975c08b6eb8b62064cb806366beb0aed)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityPriority", value)

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityVar")
    def gravity_priority_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityPriorityVar"))

    @gravity_priority_var.setter
    def gravity_priority_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__706d9fbb43940e85f6520413cc40d0146f9740c5281541018dfcef3fc9c203f7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityPriorityVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a1c0eab79df47777443680c6c53453b28b3eceb8f65795bf4ddd708c9717bd8b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimension")
    def preserve_minor_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "preserveMinorDimension"))

    @preserve_minor_dimension.setter
    def preserve_minor_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aa14d7dcfccbacd676896dc6035baf3c01a7295bf2a45833261d9ab5db1daadb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "preserveMinorDimension", value)

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionVar")
    def preserve_minor_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "preserveMinorDimensionVar"))

    @preserve_minor_dimension_var.setter
    def preserve_minor_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__36d61e14e06e7a9dc9bebef230c4370e835f3d13629821fe8411a35accfbfd5e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "preserveMinorDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationAppend]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationAppend]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationAppend]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__57c0e9fbd5f08525a413340e8beb707631556a148563b13a9323385ec7b82f41)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationAspectCrop",
    jsii_struct_bases=[],
    name_mapping={
        "allow_expansion": "allowExpansion",
        "allow_expansion_var": "allowExpansionVar",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationAspectCrop:
    def __init__(
        self,
        *,
        allow_expansion: typing.Optional[builtins.str] = None,
        allow_expansion_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_expansion: Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image. Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        :param allow_expansion_var: Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image. Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        :param height: The height term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The width term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        :param x_position: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ca551ffe016d5f53b4c3d46e7a9a109eb7e9de93454c0ab12339acbe0f9bf691)
            check_type(argname="argument allow_expansion", value=allow_expansion, expected_type=type_hints["allow_expansion"])
            check_type(argname="argument allow_expansion_var", value=allow_expansion_var, expected_type=type_hints["allow_expansion_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if allow_expansion is not None:
            self._values["allow_expansion"] = allow_expansion
        if allow_expansion_var is not None:
            self._values["allow_expansion_var"] = allow_expansion_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def allow_expansion(self) -> typing.Optional[builtins.str]:
        '''Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image.

        Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        '''
        result = self._values.get("allow_expansion")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def allow_expansion_var(self) -> typing.Optional[builtins.str]:
        '''Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image.

        Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        '''
        result = self._values.get("allow_expansion_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationAspectCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationAspectCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationAspectCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0064981234220fada02ac5a98597625d443cc02634ca88301d169e2c561caa98)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationAspectCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b76cbd3e4f747877746d20aedefe9b05c4f13170c7935e5f6dd85395249a510e)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationAspectCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ab377d2d9761638617f5ab2ccadd021608799bb63bce9adae31233ebb8876b3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5cbcd2986e841125b55e2340e8b56d61a80f2ff9242715d2457124711c206f7b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1bdb54c9d32b1f25c0074ae68d14eabf99a3296a543beb1d686a0a978d9b5dd1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationAspectCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationAspectCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationAspectCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ba2d660206ec1f0706fd24f20716124e6b4161ea7783c043f2c125afea054e6f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationAspectCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationAspectCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a5a616d4a38bff18a898965e047418c6483761e84d3c75d7128da1fffe3d269b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAllowExpansion")
    def reset_allow_expansion(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansion", []))

    @jsii.member(jsii_name="resetAllowExpansionVar")
    def reset_allow_expansion_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansionVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionInput")
    def allow_expansion_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVarInput")
    def allow_expansion_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansion")
    def allow_expansion(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansion"))

    @allow_expansion.setter
    def allow_expansion(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7b49e26aaa5bb136b09ab922052edd033e9d89860638aaa2c8c1f395eab17939)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansion", value)

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVar")
    def allow_expansion_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansionVar"))

    @allow_expansion_var.setter
    def allow_expansion_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b4df4ef4605b255c7ab7b552d045cd8f003076ba2684baa77e26abf687eec15e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansionVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__852cdc4068a68577ec7d475877e4875d8562b4c2d478df415acc40792fea2854)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab3a47d919d95074d83be3e3dbb99b9f5db492d319060a0475afe74f467db521)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c14d3083ce9928754bbbd4e4ca576a8975ff69f116cb38d610d2c1a0465a52b6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__132c802ea3562ce28aff150517a22a2648f48e916fe3cac6bac7578326046aae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f0d11ddee51d21e3d1c2c816d12343e5d032757e6226d017747a705344c9b03f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__86846538d68ed76ced30cd2be9c4866ac26ae90c3423dba74e77139a6eaf307c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__81d9b76ae76a328c9cd19e7cc9471c7876a2289ae0b84064bf42e10fb1641a61)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fc59e30c52208e87613170e78a14ee26d85d6fd2fa585b40b04cda73f09ed0fc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationAspectCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationAspectCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationAspectCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2991bca5fb40cd7b6ca9f16ba8965f2c85d8e4821b8011140c6b4e4575c8b169)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationBackgroundColor",
    jsii_struct_bases=[],
    name_mapping={"color": "color", "color_var": "colorVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationBackgroundColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f30c926453702a04e667986569a88910638e1092420faae11e93386a8b5df544)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationBackgroundColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationBackgroundColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationBackgroundColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__69bdfe41e61ebe530a4f1adbaaf47732269eeb36548fdee853257141aff07f7f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationBackgroundColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6179778e7366471e4877cfab3491408546623c2f270ed82e9618f6c8a7fd9b2e)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationBackgroundColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7798c24f815169874630b8d4d4e0908ff26c3ba3f00f42e3afc8838599e4573d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__05b8608120e5cadf60ca00d7aa5e79fe9f2c936cfb3d44e1d5798ea84482eb13)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__499d49973f51ee5a7751e54e9208686f1422e98327d5bcc8830583e114d313ff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationBackgroundColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationBackgroundColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ead2d015f06f634fb811372f26d58c72a79387bdde8c2315dac3ccbc6353451a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationBackgroundColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationBackgroundColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__552539701e9cfac7379046358997aa1a048c4935842c5285b60a0bce741fa962)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc3c38fb20e8edf25e6f45a61d2a880742fdf559d7e5a63a30f5bd52108a29ce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1c284fb6bc514952f531e9e4ad8cfbb2a6e7533da8b24080f2651ff2c4aa06f8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationBackgroundColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationBackgroundColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationBackgroundColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__130828121974a93b1aba86bac4ae1c9473d6bdc7d85d4647c417f76b073b6d78)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationBlur",
    jsii_struct_bases=[],
    name_mapping={"sigma": "sigma", "sigma_var": "sigmaVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationBlur:
    def __init__(
        self,
        *,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param sigma: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ed0340a76f788415e00cdb2f01a695ca0d0d4d03bd5cc17a7ba34b38da42fcb)
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationBlur(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationBlurList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationBlurList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6d11681c13717a86e9c9bb112c4b870061e00ce5f060ef5d9f041e94e856ad4c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationBlurOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0e1b4d8d4662d2e468583077e59960b430a8e02315373dc0b1e93f3447f324ce)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationBlurOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__452ab0d19125dd00db8a683837586f862801ce807252d75071870e33211fa72c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__02f14c2de2ec0efafdbe17ff0eac4af2cc6f4d43ba5959f7e10b92ea7aa78046)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c90f6f8452a52b1c7a1c9c7f3f6b8447baf7c06defbecd39986a9b6e6b8957f3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationBlur]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationBlur]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cb003e27efb65604bee9918231bbeb70cd3fdf5c324b79c6b619e40761fde3ec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationBlurOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationBlurOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cdc8dc10d8efeb07a9000df3ed763a312aaa820e155e30903ba87b181a390215)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__34b9ae72285504b52282659a8fefc7eb95aa6cd632888a54c31e45cce52287e5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__68aa46fe8edd22f8fab648bc4401d3c93ae2fd212201a55b4a8bb0d399b4069d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationBlur]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationBlur]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationBlur]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__877f7dbef82674655388127d9cad94abf75bfcda7ad0fc2096a31d7463f69647)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationChromaKey",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_feather": "hueFeather",
        "hue_feather_var": "hueFeatherVar",
        "hue_tolerance": "hueTolerance",
        "hue_tolerance_var": "hueToleranceVar",
        "hue_var": "hueVar",
        "lightness_feather": "lightnessFeather",
        "lightness_feather_var": "lightnessFeatherVar",
        "lightness_tolerance": "lightnessTolerance",
        "lightness_tolerance_var": "lightnessToleranceVar",
        "saturation_feather": "saturationFeather",
        "saturation_feather_var": "saturationFeatherVar",
        "saturation_tolerance": "saturationTolerance",
        "saturation_tolerance_var": "saturationToleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationChromaKey:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_feather: typing.Optional[builtins.str] = None,
        hue_feather_var: typing.Optional[builtins.str] = None,
        hue_tolerance: typing.Optional[builtins.str] = None,
        hue_tolerance_var: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness_feather: typing.Optional[builtins.str] = None,
        lightness_feather_var: typing.Optional[builtins.str] = None,
        lightness_tolerance: typing.Optional[builtins.str] = None,
        lightness_tolerance_var: typing.Optional[builtins.str] = None,
        saturation_feather: typing.Optional[builtins.str] = None,
        saturation_feather_var: typing.Optional[builtins.str] = None,
        saturation_tolerance: typing.Optional[builtins.str] = None,
        saturation_tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_feather: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        :param hue_feather_var: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        :param hue_tolerance: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        :param hue_tolerance_var: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        :param hue_var: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness_feather: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        :param lightness_feather_var: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        :param lightness_tolerance: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        :param lightness_tolerance_var: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        :param saturation_feather: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        :param saturation_feather_var: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        :param saturation_tolerance: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        :param saturation_tolerance_var: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9798b28410099717826ad4bb6961ccd1f398c0f7fb6977b023482064655734c4)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_feather", value=hue_feather, expected_type=type_hints["hue_feather"])
            check_type(argname="argument hue_feather_var", value=hue_feather_var, expected_type=type_hints["hue_feather_var"])
            check_type(argname="argument hue_tolerance", value=hue_tolerance, expected_type=type_hints["hue_tolerance"])
            check_type(argname="argument hue_tolerance_var", value=hue_tolerance_var, expected_type=type_hints["hue_tolerance_var"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness_feather", value=lightness_feather, expected_type=type_hints["lightness_feather"])
            check_type(argname="argument lightness_feather_var", value=lightness_feather_var, expected_type=type_hints["lightness_feather_var"])
            check_type(argname="argument lightness_tolerance", value=lightness_tolerance, expected_type=type_hints["lightness_tolerance"])
            check_type(argname="argument lightness_tolerance_var", value=lightness_tolerance_var, expected_type=type_hints["lightness_tolerance_var"])
            check_type(argname="argument saturation_feather", value=saturation_feather, expected_type=type_hints["saturation_feather"])
            check_type(argname="argument saturation_feather_var", value=saturation_feather_var, expected_type=type_hints["saturation_feather_var"])
            check_type(argname="argument saturation_tolerance", value=saturation_tolerance, expected_type=type_hints["saturation_tolerance"])
            check_type(argname="argument saturation_tolerance_var", value=saturation_tolerance_var, expected_type=type_hints["saturation_tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_feather is not None:
            self._values["hue_feather"] = hue_feather
        if hue_feather_var is not None:
            self._values["hue_feather_var"] = hue_feather_var
        if hue_tolerance is not None:
            self._values["hue_tolerance"] = hue_tolerance
        if hue_tolerance_var is not None:
            self._values["hue_tolerance_var"] = hue_tolerance_var
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness_feather is not None:
            self._values["lightness_feather"] = lightness_feather
        if lightness_feather_var is not None:
            self._values["lightness_feather_var"] = lightness_feather_var
        if lightness_tolerance is not None:
            self._values["lightness_tolerance"] = lightness_tolerance
        if lightness_tolerance_var is not None:
            self._values["lightness_tolerance_var"] = lightness_tolerance_var
        if saturation_feather is not None:
            self._values["saturation_feather"] = saturation_feather
        if saturation_feather_var is not None:
            self._values["saturation_feather_var"] = saturation_feather_var
        if saturation_tolerance is not None:
            self._values["saturation_tolerance"] = saturation_tolerance
        if saturation_tolerance_var is not None:
            self._values["saturation_tolerance_var"] = saturation_tolerance_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        '''
        result = self._values.get("hue_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        '''
        result = self._values.get("hue_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        '''
        result = self._values.get("hue_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        '''
        result = self._values.get("hue_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        '''
        result = self._values.get("lightness_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        '''
        result = self._values.get("lightness_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        '''
        result = self._values.get("lightness_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        '''
        result = self._values.get("lightness_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        '''
        result = self._values.get("saturation_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        '''
        result = self._values.get("saturation_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        '''
        result = self._values.get("saturation_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        result = self._values.get("saturation_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationChromaKey(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationChromaKeyList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationChromaKeyList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__771055cce8117a091992eaa1307229392721ccf8b6e62fe6e0c9111148cec6e7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationChromaKeyOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2f55219163a1a336e448b80be4aac491f972c785c76d76f6840d6fe434a955e7)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationChromaKeyOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4d921e0fecf0ba72dfd42de076b13321aff222abee41f0d0f4961ae695a0f765)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7cd40742ec7095e9ff7ba93cf71aba2a2d2d8101e120e27840de2df7f9ddb451)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__023b90cb821921b4b98ef031e76dbb581f551e8172b26800f492b35087031583)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationChromaKey]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationChromaKey]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ba1e0a2cd5bf653c4d221f3de668e445156b0920aa3353035dfd6e5de7467153)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationChromaKeyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationChromaKeyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a268611858de5809c376e28e261e95b901e26c39b1480d941b38401ff5f1d6f2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueFeather")
    def reset_hue_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeather", []))

    @jsii.member(jsii_name="resetHueFeatherVar")
    def reset_hue_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeatherVar", []))

    @jsii.member(jsii_name="resetHueTolerance")
    def reset_hue_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueTolerance", []))

    @jsii.member(jsii_name="resetHueToleranceVar")
    def reset_hue_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueToleranceVar", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightnessFeather")
    def reset_lightness_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeather", []))

    @jsii.member(jsii_name="resetLightnessFeatherVar")
    def reset_lightness_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeatherVar", []))

    @jsii.member(jsii_name="resetLightnessTolerance")
    def reset_lightness_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessTolerance", []))

    @jsii.member(jsii_name="resetLightnessToleranceVar")
    def reset_lightness_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessToleranceVar", []))

    @jsii.member(jsii_name="resetSaturationFeather")
    def reset_saturation_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeather", []))

    @jsii.member(jsii_name="resetSaturationFeatherVar")
    def reset_saturation_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeatherVar", []))

    @jsii.member(jsii_name="resetSaturationTolerance")
    def reset_saturation_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationTolerance", []))

    @jsii.member(jsii_name="resetSaturationToleranceVar")
    def reset_saturation_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherInput")
    def hue_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVarInput")
    def hue_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceInput")
    def hue_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVarInput")
    def hue_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherInput")
    def lightness_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVarInput")
    def lightness_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceInput")
    def lightness_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVarInput")
    def lightness_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherInput")
    def saturation_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVarInput")
    def saturation_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceInput")
    def saturation_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVarInput")
    def saturation_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af033d6226734b2fc3004378661132afcf5d32937955e1b36aecc413eabcb253)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeather")
    def hue_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeather"))

    @hue_feather.setter
    def hue_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c590aa6613c6a7d5cdad687c2995311c7639f7869dd3e0e9b0d3fc1cabc7090d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeather", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVar")
    def hue_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeatherVar"))

    @hue_feather_var.setter
    def hue_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__99ded2d3871dc993d527f86cad99f357d20bb02417f5fe77ece174d2a8b1cc6e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueTolerance")
    def hue_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueTolerance"))

    @hue_tolerance.setter
    def hue_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aaa825ab7f90d5eb2ab232b64eb96eafc0d5762362eafab9bbc6ded75b54e4fd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVar")
    def hue_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueToleranceVar"))

    @hue_tolerance_var.setter
    def hue_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4c6bc2c91c69d9c0ca888c0f80457699531d1c4c38ad29e9d9ec14e0e7d13a1d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cda95611cd30c4146f9edae8519e6ef873a2e79fb5267a55609922716b0c9309)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeather")
    def lightness_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeather"))

    @lightness_feather.setter
    def lightness_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5db596aa9a0ea3122e5a0be983a7343ef1bebbf8dfd5c229f7d9aa961004e222)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeather", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVar")
    def lightness_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeatherVar"))

    @lightness_feather_var.setter
    def lightness_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c6fe0c1086aa4147e7be54e84a46d9d837fa3dc2392473e803f05cfa5b5234de)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessTolerance")
    def lightness_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessTolerance"))

    @lightness_tolerance.setter
    def lightness_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0a5e2d20522a6d5abc8f9a592794b9ec6d5dec3b6badb5e9d11af824907e0894)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVar")
    def lightness_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessToleranceVar"))

    @lightness_tolerance_var.setter
    def lightness_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7b57339089fbee5398b42cce06a8af50821c40c147242a700fb64b153bc93d26)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeather")
    def saturation_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeather"))

    @saturation_feather.setter
    def saturation_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a3c363e022046e73f4757db6660024cb6cfdf74c488ba32c73a12d610b7edb57)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeather", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVar")
    def saturation_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeatherVar"))

    @saturation_feather_var.setter
    def saturation_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f759fbe369ca1e173c5c9eb433d8e22d1703d6acc42a7a7d80399426a45afd14)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationTolerance")
    def saturation_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationTolerance"))

    @saturation_tolerance.setter
    def saturation_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bbcbd4a1a5f24d1cc3560bcf8da6da5cbe1fb017b82d6cab9a71f5c69832f6c2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVar")
    def saturation_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationToleranceVar"))

    @saturation_tolerance_var.setter
    def saturation_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__45a15b2b2347fcea51c78d237b0e243083ee78d15592b7b8a78b0ed54adfc66a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationChromaKey]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationChromaKey]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationChromaKey]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__92c49c75d0df5911c2ec1de9fbb6e8caff650cb0cac04c70b4c4ab0902ccef0c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationComposite",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "placement": "placement",
        "placement_var": "placementVar",
        "scale": "scale",
        "scale_dimension": "scaleDimension",
        "scale_dimension_var": "scaleDimensionVar",
        "scale_var": "scaleVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationComposite:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationCompositeImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        placement: typing.Optional[builtins.str] = None,
        placement_var: typing.Optional[builtins.str] = None,
        scale: typing.Optional[builtins.str] = None,
        scale_dimension: typing.Optional[builtins.str] = None,
        scale_dimension_var: typing.Optional[builtins.str] = None,
        scale_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param placement: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        :param placement_var: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        :param scale: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param scale_dimension: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        :param scale_dimension_var: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        :param scale_var: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        :param x_position: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationCompositeImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__01fb31fb816556273bb82e48d6f5757484b45a708cd9cfa960c4117edbf5c3a0)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument placement", value=placement, expected_type=type_hints["placement"])
            check_type(argname="argument placement_var", value=placement_var, expected_type=type_hints["placement_var"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument scale_dimension", value=scale_dimension, expected_type=type_hints["scale_dimension"])
            check_type(argname="argument scale_dimension_var", value=scale_dimension_var, expected_type=type_hints["scale_dimension_var"])
            check_type(argname="argument scale_var", value=scale_var, expected_type=type_hints["scale_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if placement is not None:
            self._values["placement"] = placement
        if placement_var is not None:
            self._values["placement_var"] = placement_var
        if scale is not None:
            self._values["scale"] = scale
        if scale_dimension is not None:
            self._values["scale_dimension"] = scale_dimension
        if scale_dimension_var is not None:
            self._values["scale_dimension_var"] = scale_dimension_var
        if scale_var is not None:
            self._values["scale_var"] = scale_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationCompositeImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationCompositeImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        '''
        result = self._values.get("placement")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement_var(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        '''
        result = self._values.get("placement_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        '''
        result = self._values.get("scale_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        '''
        result = self._values.get("scale_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        '''
        result = self._values.get("scale_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationComposite(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationCompositeImage",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationCompositeImage:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationCompositeImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationCompositeImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationCompositeImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f4ca9e3e28c256e72809d02bb0aa1efbe3a80507ef46c8836b84a5d8b875444f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationCompositeImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationCompositeImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__27f24b8708a6dd5a325ac1fc6406fb131d381640c8c07718a3352b0961aaa528)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationCompositeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationCompositeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aeaf3a05520bfd7e2793392b0671070b98369df7060743e7bd1c82952140ec5c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationCompositeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a5bf65bd92edd61ee14035ca607965b305643473dc0f6d9dcfdb88d9c241119)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationCompositeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__78704aade71a49fd450c75e543ac088dc1ccdbcbd70264314b9b41c595f3fae4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5fcfc248c78b7c99355351a0c2c565b59cea82853eb9576d3ce320402dc41faf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3fa2a60cb8e98f4c3f27bcdf65da3b0b35b67305e674565e0a78edb98aa51d91)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationComposite]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationComposite]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__88aa370cccec92f4d1cb94552ea73023a77248292aba22c5a1ac6aefcc7d5320)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationCompositeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationCompositeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__73412ab8017f13ab5654a69e5353e9fc658f468a1931f8e564565f0735fe75af)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationCompositeImage()

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPlacement")
    def reset_placement(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacement", []))

    @jsii.member(jsii_name="resetPlacementVar")
    def reset_placement_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacementVar", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetScaleDimension")
    def reset_scale_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimension", []))

    @jsii.member(jsii_name="resetScaleDimensionVar")
    def reset_scale_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimensionVar", []))

    @jsii.member(jsii_name="resetScaleVar")
    def reset_scale_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationCompositeImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationCompositeImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationCompositeImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="placementInput")
    def placement_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementInput"))

    @builtins.property
    @jsii.member(jsii_name="placementVarInput")
    def placement_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionInput")
    def scale_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVarInput")
    def scale_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleVarInput")
    def scale_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bcce6e7117473014ad7c0cf238b80e05e71b68deb4aff00fe112b7ee243d4385)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f3e4b122be9b8b198c820d4e8c41ae61c455c35dbf321c6917125ae596674c5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="placement")
    def placement(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placement"))

    @placement.setter
    def placement(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__899191ae24674c22cc5e15b4ad42241bccddb2cf60cd866b75bbce363ee980fa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placement", value)

    @builtins.property
    @jsii.member(jsii_name="placementVar")
    def placement_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placementVar"))

    @placement_var.setter
    def placement_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__30a0af52802617c4291cd645c367ee7c417cc2c60d6de5914988f95aa8313ce7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placementVar", value)

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scale"))

    @scale.setter
    def scale(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__67e8d71b97c9384708b26a19c6ebf4202ee51a0136dfa3cd0ad0803342e844bb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scale", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimension")
    def scale_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimension"))

    @scale_dimension.setter
    def scale_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4d14619a9564fff80c8de4bc4fbed5a0bbd08e542b957c48163c5fbab6956410)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimension", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVar")
    def scale_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimensionVar"))

    @scale_dimension_var.setter
    def scale_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c8473b7e2376bdf23c1f206ddb5dc5e7d5503d08fa2cccceaef26cac3f87e4b1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="scaleVar")
    def scale_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleVar"))

    @scale_var.setter
    def scale_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ae7a54ed517c5ce26e71ed86e4640fdd33248800086fde8c017f5947ab4f135)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ad8f7a8fbcfd2d2778614d89c26ff281c4c93dc2611942f21d5462fb7e64749d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1e17cb287a700234184114dbf94f345367368bebde460cedd7c7734fb39fa198)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a96bf2b6ab67735fde47f3782b68e11e4c796c807311de027f2dbded980664d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__41f91547bb68543592ddf31d0bd690ff0927c66dd940f80b6378b4d9b4d39004)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationComposite]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationComposite]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationComposite]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1fcf38d518ad4709baa561c845cf9dc0a9026750e3c35d7eb19a0f934754a13a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationCompound",
    jsii_struct_bases=[],
    name_mapping={"transformations": "transformations"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationCompound:
    def __init__(
        self,
        *,
        transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param transformations: transformations block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4378a900669e5630f4c4d82ff2b1bd1c19e91f485093beae62ca4d05da6b5fc5)
            check_type(argname="argument transformations", value=transformations, expected_type=type_hints["transformations"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if transformations is not None:
            self._values["transformations"] = transformations

    @builtins.property
    def transformations(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationCompoundTransformations"]]]:
        '''transformations block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        result = self._values.get("transformations")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationCompoundTransformations"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationCompound(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationCompoundList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationCompoundList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3b22fcfbcf1b7d6a841c06d35433d2dad76f6d560629dbf16c909ff6d15aa13e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationCompoundOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9c32b47b26ab9985cfd4a1b7e84839519faecbfcf22ab8a5c18b8264129a4ac2)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationCompoundOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e36e7caee8b35946996bc2a72fc9fe8489d99cc53073803bfa34c4a75ab48cf0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c1c72c38fda9c7b72d821ec7283c3444884264ac601f0894024320525d85c8f0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f29c7b51d0e6dd87791dc221fc7112d2ac59eda352032508a450185387c6677)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationCompound]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationCompound]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__113fa5ee8aae6df60b55d636408991785f81fe018df3480043f9d28539138ebf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationCompoundOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationCompoundOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c9e4ed6dac00f85a0b7560aab7172c6573d2cbf76bf82fdaa45f6cecd7f6f483)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformations")
    def put_transformations(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__893087ec69b13ce083a3b31b93419b407ea84428d605b937a26d3ae9cb1f63a9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTransformations", [value]))

    @jsii.member(jsii_name="resetTransformations")
    def reset_transformations(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformations", []))

    @builtins.property
    @jsii.member(jsii_name="transformations")
    def transformations(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationCompoundTransformationsList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationCompoundTransformationsList", jsii.get(self, "transformations"))

    @builtins.property
    @jsii.member(jsii_name="transformationsInput")
    def transformations_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationCompoundTransformations"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationCompoundTransformations"]]], jsii.get(self, "transformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationCompound]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationCompound]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationCompound]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3954410ea2d7310c01d0fbe8cee760c06e6c5145e327e45c0cff2392b2e61ab7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationCompoundTransformations",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationCompoundTransformations:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationCompoundTransformations(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationCompoundTransformationsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationCompoundTransformationsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a7186867f09a9ef88fc7a4eb5acccc19e8877d130a48e993069d684bc7d71b55)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationCompoundTransformationsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0e890ba70c2e330f47a5336a7bd4bb7bf3f584427bcbf938e48d4d846ad60a7b)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationCompoundTransformationsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d61aeaaa1a42681d9a2d7237c9b7ceab823ab3e3c9b9321c0a31ccb57960c7b6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f0cddb63468f1c8a9222bef031b3bfb4d98c2c4a8ae292ad52d0a70f7b954f9e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__112f7b9eb4087d738cd55856327b90ee30776de7813ea43c39767b40d8f7e6f3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationCompoundTransformations]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationCompoundTransformations]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationCompoundTransformations]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b60b7ceeafeff6a843da8a61ed0a899d0d402d560a2fc21dda87cdfeba9f70ab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationCompoundTransformationsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationCompoundTransformationsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d5059b19b887e531b6fd325fea4bba8824d1c5dd8869646de7180fd8d5ea62b2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationCompoundTransformations]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationCompoundTransformations]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationCompoundTransformations]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__49f48d50e16ea0bc394da6c2909b9094814371ed81df2f493136869c56b04015)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationContrast",
    jsii_struct_bases=[],
    name_mapping={
        "brightness": "brightness",
        "brightness_var": "brightnessVar",
        "contrast": "contrast",
        "contrast_var": "contrastVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationContrast:
    def __init__(
        self,
        *,
        brightness: typing.Optional[builtins.str] = None,
        brightness_var: typing.Optional[builtins.str] = None,
        contrast: typing.Optional[builtins.str] = None,
        contrast_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param brightness: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        :param brightness_var: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        :param contrast: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param contrast_var: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__abec26cd1fd9e75e82acd66fa218f3f81dcd0fddf98baa16b3574ea2352ab8e2)
            check_type(argname="argument brightness", value=brightness, expected_type=type_hints["brightness"])
            check_type(argname="argument brightness_var", value=brightness_var, expected_type=type_hints["brightness_var"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument contrast_var", value=contrast_var, expected_type=type_hints["contrast_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if brightness is not None:
            self._values["brightness"] = brightness
        if brightness_var is not None:
            self._values["brightness_var"] = brightness_var
        if contrast is not None:
            self._values["contrast"] = contrast
        if contrast_var is not None:
            self._values["contrast_var"] = contrast_var

    @builtins.property
    def brightness(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        '''
        result = self._values.get("brightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def brightness_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        '''
        result = self._values.get("brightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        result = self._values.get("contrast_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationContrast(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationContrastList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationContrastList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc78b01e405900dc104d0411bcfad63a97c42e530bc40eee76414d3a8adc08f3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationContrastOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dd45fd8c01a3d3d6009ca55d1cdd6851f130aab5b8dfb6b514c12f89532ab329)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationContrastOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d74953f7f56f88d960bfb099a958ce89112481dd65d43d69a18bcdf201ca0095)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__459b47b972f26ee05d2a86cd042468fe6670fbe31a06505cc25da89fd3b71113)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4bc96d4f4b255421177d4a5f39744e8be708fc54ede4a57f16c5b4ff3b525105)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationContrast]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationContrast]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__70d237b3fad87389033580c97c0cb066dab2b1422077f1c9da9e87cc99f3e3fe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationContrastOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationContrastOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d446ae6294ee614ac008144ebb85f7a4fa9cdfd13a9e39eed6576e2b7069bf69)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetBrightness")
    def reset_brightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightness", []))

    @jsii.member(jsii_name="resetBrightnessVar")
    def reset_brightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightnessVar", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetContrastVar")
    def reset_contrast_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrastVar", []))

    @builtins.property
    @jsii.member(jsii_name="brightnessInput")
    def brightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="brightnessVarInput")
    def brightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastVarInput")
    def contrast_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="brightness")
    def brightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightness"))

    @brightness.setter
    def brightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fd80fe2039a7a153b34376c9326fa98a84232aade75a3ddb1aaf0458fdcf6cc8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightness", value)

    @builtins.property
    @jsii.member(jsii_name="brightnessVar")
    def brightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightnessVar"))

    @brightness_var.setter
    def brightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b875f5c0b78495c309dd310ac5f02d8befbf4d90986c99353086ad8e5948bb5b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrast"))

    @contrast.setter
    def contrast(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bd79bf35413b926f3629d81ed801b404f8c3aa7271f9c5f4c3acc3fb7c5be7a4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrast", value)

    @builtins.property
    @jsii.member(jsii_name="contrastVar")
    def contrast_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrastVar"))

    @contrast_var.setter
    def contrast_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ee1bfd7992fbd7f3941cd9c3e12387ecd6a7cb5b8a842e69f481d040f5bd756)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrastVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationContrast]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationContrast]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationContrast]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__22346e508b9570501dc02c987d15b5b7f5c23d01f562cd72e7c6ee5875d1591c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationCrop",
    jsii_struct_bases=[],
    name_mapping={
        "allow_expansion": "allowExpansion",
        "allow_expansion_var": "allowExpansionVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationCrop:
    def __init__(
        self,
        *,
        allow_expansion: typing.Optional[builtins.str] = None,
        allow_expansion_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_expansion: If cropping an area outside of the existing canvas, expands the image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        :param allow_expansion_var: If cropping an area outside of the existing canvas, expands the image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        :param gravity: Frame of reference for X and Y Positions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Frame of reference for X and Y Positions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The number of pixels to crop along the y-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The number of pixels to crop along the y-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The number of pixels to crop along the x-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The number of pixels to crop along the x-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        :param x_position: The x-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9c28a3095966d925df68d831a5698a065537fdee53cf150b2b61e6de45dbbbc2)
            check_type(argname="argument allow_expansion", value=allow_expansion, expected_type=type_hints["allow_expansion"])
            check_type(argname="argument allow_expansion_var", value=allow_expansion_var, expected_type=type_hints["allow_expansion_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if allow_expansion is not None:
            self._values["allow_expansion"] = allow_expansion
        if allow_expansion_var is not None:
            self._values["allow_expansion_var"] = allow_expansion_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def allow_expansion(self) -> typing.Optional[builtins.str]:
        '''If cropping an area outside of the existing canvas, expands the image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        '''
        result = self._values.get("allow_expansion")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def allow_expansion_var(self) -> typing.Optional[builtins.str]:
        '''If cropping an area outside of the existing canvas, expands the image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        '''
        result = self._values.get("allow_expansion_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Frame of reference for X and Y Positions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Frame of reference for X and Y Positions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the y-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the y-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the x-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the x-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f0320be8d0b589353deb5ebbfa5f648b16d9a9753e71152080646f07d7ecd9b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__16a4f605179562a12ee727e54ee6adca4de06390a3cecea5560dabf065bdba09)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__120087d20c49e60db5996cf000ee87415c8f46a416239a5802be6fc5e562a18b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ed18e757bc36182e82699503839a19befbdfd018d289e6aedb39e59ef1570875)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a1ea1f6ae95d0e61091668a15dc4935fbc0c531ab72ac26dc8d46615a9fc40be)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8fcdc4250373a435bc7a463bf9477969405116439c97a1b08145754ceccf1288)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__435020554961c90739dddad5003de74e2316fc40ab1ecfb4990c00b7239e7438)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAllowExpansion")
    def reset_allow_expansion(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansion", []))

    @jsii.member(jsii_name="resetAllowExpansionVar")
    def reset_allow_expansion_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansionVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionInput")
    def allow_expansion_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVarInput")
    def allow_expansion_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansion")
    def allow_expansion(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansion"))

    @allow_expansion.setter
    def allow_expansion(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9605dd68f97183a3bcc176a34730831e98344e22850a8e1c5baddde38a28fa1d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansion", value)

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVar")
    def allow_expansion_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansionVar"))

    @allow_expansion_var.setter
    def allow_expansion_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__735d5129237898d3608212134a4545c5abe40f2c691b1a7d2366d43b7139b6e7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansionVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e64eccd002a68406bbfb0cac8bff57172fb96ca95af881b89b4c6ab0f0dab6ea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b187acec606f244f57e9ec21c60b01a0f9d847a6a3aa298e31ae0954de8c8ccf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__41ee05a4fb56c1f6bc8d269ef99251d634ccdcbeea5404beb724a66c0ef96c43)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a4acdc8d76372fa83a7fc473e1a37836813a81a4312e18dcaee6bb1ce629a82a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aadce366974140175a52eb742cfee41ee348959cf1e0948de3d5128b101cb140)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2db6967e8f18a672921618a073aea15606113a4e59d0176f1b1337caca06c79f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8f78c9f8a3f72533d3997bd48b7a7ca587c0ad5c50313a6aa7bf046c92c85ee5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7bf41dd88b5b6614ea3382c413b3f099f244f3ef673526f375847b19ef8aefc7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__74d22660eb9a3a661f1cc9bd8507781b0fb6584c29d3de13a2547328f2b17846)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b2b2b08d1c4515f949d0371d4f744a1c0147c7999b05a926704efccd853d5455)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__41adc9a6af4eb0f0753b565e01d7aaf28bfc7290991b158794f73d44421d00b1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationFaceCrop",
    jsii_struct_bases=[],
    name_mapping={
        "algorithm": "algorithm",
        "algorithm_var": "algorithmVar",
        "confidence": "confidence",
        "confidence_var": "confidenceVar",
        "fail_gravity": "failGravity",
        "fail_gravity_var": "failGravityVar",
        "focus": "focus",
        "focus_var": "focusVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "padding": "padding",
        "padding_var": "paddingVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationFaceCrop:
    def __init__(
        self,
        *,
        algorithm: typing.Optional[builtins.str] = None,
        algorithm_var: typing.Optional[builtins.str] = None,
        confidence: typing.Optional[builtins.str] = None,
        confidence_var: typing.Optional[builtins.str] = None,
        fail_gravity: typing.Optional[builtins.str] = None,
        fail_gravity_var: typing.Optional[builtins.str] = None,
        focus: typing.Optional[builtins.str] = None,
        focus_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param algorithm: Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm DataAkamaiImagingPolicyImage#algorithm}
        :param algorithm_var: Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm_var DataAkamaiImagingPolicyImage#algorithm_var}
        :param confidence: With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image. Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence DataAkamaiImagingPolicyImage#confidence}
        :param confidence_var: With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image. Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence_var DataAkamaiImagingPolicyImage#confidence_var}
        :param fail_gravity: Controls placement of the crop if Image and Video Manager does not detect any faces in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        :param fail_gravity_var: Controls placement of the crop if Image and Video Manager does not detect any faces in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        :param focus: Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus DataAkamaiImagingPolicyImage#focus}
        :param focus_var: Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus_var DataAkamaiImagingPolicyImage#focus_var}
        :param gravity: Controls placement of the crop. Directions are relative to the face(s) plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Controls placement of the crop. Directions are relative to the face(s) plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param padding: The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        :param style: Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__157f2c1676efaad77054e4c88274d332de7a8c7e2ba318dc6f6e572b5a5df7af)
            check_type(argname="argument algorithm", value=algorithm, expected_type=type_hints["algorithm"])
            check_type(argname="argument algorithm_var", value=algorithm_var, expected_type=type_hints["algorithm_var"])
            check_type(argname="argument confidence", value=confidence, expected_type=type_hints["confidence"])
            check_type(argname="argument confidence_var", value=confidence_var, expected_type=type_hints["confidence_var"])
            check_type(argname="argument fail_gravity", value=fail_gravity, expected_type=type_hints["fail_gravity"])
            check_type(argname="argument fail_gravity_var", value=fail_gravity_var, expected_type=type_hints["fail_gravity_var"])
            check_type(argname="argument focus", value=focus, expected_type=type_hints["focus"])
            check_type(argname="argument focus_var", value=focus_var, expected_type=type_hints["focus_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if algorithm is not None:
            self._values["algorithm"] = algorithm
        if algorithm_var is not None:
            self._values["algorithm_var"] = algorithm_var
        if confidence is not None:
            self._values["confidence"] = confidence
        if confidence_var is not None:
            self._values["confidence_var"] = confidence_var
        if fail_gravity is not None:
            self._values["fail_gravity"] = fail_gravity
        if fail_gravity_var is not None:
            self._values["fail_gravity_var"] = fail_gravity_var
        if focus is not None:
            self._values["focus"] = focus
        if focus_var is not None:
            self._values["focus_var"] = focus_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def algorithm(self) -> typing.Optional[builtins.str]:
        '''Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm DataAkamaiImagingPolicyImage#algorithm}
        '''
        result = self._values.get("algorithm")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def algorithm_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm_var DataAkamaiImagingPolicyImage#algorithm_var}
        '''
        result = self._values.get("algorithm_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def confidence(self) -> typing.Optional[builtins.str]:
        '''With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image.

        Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence DataAkamaiImagingPolicyImage#confidence}
        '''
        result = self._values.get("confidence")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def confidence_var(self) -> typing.Optional[builtins.str]:
        '''With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image.

        Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence_var DataAkamaiImagingPolicyImage#confidence_var}
        '''
        result = self._values.get("confidence_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any faces in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        '''
        result = self._values.get("fail_gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any faces in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        '''
        result = self._values.get("fail_gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def focus(self) -> typing.Optional[builtins.str]:
        '''Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus DataAkamaiImagingPolicyImage#focus}
        '''
        result = self._values.get("focus")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def focus_var(self) -> typing.Optional[builtins.str]:
        '''Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus_var DataAkamaiImagingPolicyImage#focus_var}
        '''
        result = self._values.get("focus_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the face(s) plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the face(s) plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationFaceCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationFaceCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationFaceCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__352b514ea795c6480a9a5303037412f4575d738fdf167ff053a59daa96b2de14)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationFaceCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__184c69c837a6611b5f13f57434003b735d819bb18ab3d4f2e6e04886510eeff8)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationFaceCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2532a7def0a9a4c3f3beaa2ff815a0980ec0ba8e9b3843160952421a8d591204)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a30470cde576f9bdb653302a07060974e2a657f6b2f1be1710581e5721d3643e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cc19ebe5cb27bf629aa336158c2c0fe60bd09ffb293ecb0f899a381485c2d412)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationFaceCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationFaceCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationFaceCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e5710e0562bf03531a7ea86964815efd6031c2ad89fed5be4b3a1181a9d945b9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationFaceCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationFaceCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b7f8f4c1748f502f90bf49d9f886cfa1813a0f542c7bfba7d1b114d8b22ddaa2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAlgorithm")
    def reset_algorithm(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAlgorithm", []))

    @jsii.member(jsii_name="resetAlgorithmVar")
    def reset_algorithm_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAlgorithmVar", []))

    @jsii.member(jsii_name="resetConfidence")
    def reset_confidence(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetConfidence", []))

    @jsii.member(jsii_name="resetConfidenceVar")
    def reset_confidence_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetConfidenceVar", []))

    @jsii.member(jsii_name="resetFailGravity")
    def reset_fail_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravity", []))

    @jsii.member(jsii_name="resetFailGravityVar")
    def reset_fail_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravityVar", []))

    @jsii.member(jsii_name="resetFocus")
    def reset_focus(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFocus", []))

    @jsii.member(jsii_name="resetFocusVar")
    def reset_focus_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFocusVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="algorithmInput")
    def algorithm_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "algorithmInput"))

    @builtins.property
    @jsii.member(jsii_name="algorithmVarInput")
    def algorithm_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "algorithmVarInput"))

    @builtins.property
    @jsii.member(jsii_name="confidenceInput")
    def confidence_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "confidenceInput"))

    @builtins.property
    @jsii.member(jsii_name="confidenceVarInput")
    def confidence_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "confidenceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityInput")
    def fail_gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityVarInput")
    def fail_gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="focusInput")
    def focus_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "focusInput"))

    @builtins.property
    @jsii.member(jsii_name="focusVarInput")
    def focus_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "focusVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="algorithm")
    def algorithm(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "algorithm"))

    @algorithm.setter
    def algorithm(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__70627cd8d852579962446605f0417e59d5c200a0c3f0722b539f259277cad689)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "algorithm", value)

    @builtins.property
    @jsii.member(jsii_name="algorithmVar")
    def algorithm_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "algorithmVar"))

    @algorithm_var.setter
    def algorithm_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e1bece9bad744bd29edfbbb6072d3503275d9bc62782aa216223a11d2614d9bf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "algorithmVar", value)

    @builtins.property
    @jsii.member(jsii_name="confidence")
    def confidence(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "confidence"))

    @confidence.setter
    def confidence(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__38aefdb5631db2222a65f500356a745eba5284e066f235cb28ec1d8ba3d1c39d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "confidence", value)

    @builtins.property
    @jsii.member(jsii_name="confidenceVar")
    def confidence_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "confidenceVar"))

    @confidence_var.setter
    def confidence_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1cd09d2d0af1a1142bebb7d9e2e4e0440caa3006496361ce987714da2d31de89)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "confidenceVar", value)

    @builtins.property
    @jsii.member(jsii_name="failGravity")
    def fail_gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravity"))

    @fail_gravity.setter
    def fail_gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__95d1179444281ac636df1ec44d36f22ec9ff4ba740be93d4f2f440f4576c67e5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravity", value)

    @builtins.property
    @jsii.member(jsii_name="failGravityVar")
    def fail_gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravityVar"))

    @fail_gravity_var.setter
    def fail_gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d9d739645c4fed88321dedbbee9f94d527757783439c93d055ef172ff9842b04)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="focus")
    def focus(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "focus"))

    @focus.setter
    def focus(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac2bac7bae424825224425c910299fbea24bdc121c4c5b6da55a3b16248f3e23)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "focus", value)

    @builtins.property
    @jsii.member(jsii_name="focusVar")
    def focus_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "focusVar"))

    @focus_var.setter
    def focus_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__11051a1c494bd104cdcf74cd11546043e47463d6de17dfbac5140c3edc1238c2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "focusVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f888147e7c03d1c34a23ec4fc0732ac645c6d1408945e165a2fb9253b536f214)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__672a927dd0f4ca68edce8bd8e0b039ebbaec463ce17c59ae15c6bd0a6664689b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3510796dd42b6bb161f855544e45c1ef1796d0dfc5d5f070aa5c57b0053fffe1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__81bf7f07b642828d120aa0743720ac8ae267bc5b1950dba9b36c71d8e29f6118)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7abdc112dfee165634ed7a3ed6e222f62a0d0380dbfac382bd00ae8a293f5ed3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d202a5ad781b0e1b8479dee24207390a5653ee4c73216d1548413bce7952970)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c2dcc8b09cdfc6b4c98c91e88062e643e43b642dbdd57b99c2e8c3c82e427e41)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__04f7edebae712e53ca6ed621608b91c3476ad40b8a95e8096cab0e978960ecb6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8df3249ba931c73a63edbcfed0fa891f529840510580f23d6f7a8fdd01d416b1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c3df365f62ba8a2681b580d2b38bb05e78623af15d80d4f5dc61a6011b3e4681)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationFaceCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationFaceCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationFaceCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8ff808a13ea1f5f7871727324db70e138c40b4676287aa6dbddaada742503490)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationFeatureCrop",
    jsii_struct_bases=[],
    name_mapping={
        "fail_gravity": "failGravity",
        "fail_gravity_var": "failGravityVar",
        "feature_radius": "featureRadius",
        "feature_radius_var": "featureRadiusVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "max_features": "maxFeatures",
        "max_features_var": "maxFeaturesVar",
        "min_feature_quality": "minFeatureQuality",
        "min_feature_quality_var": "minFeatureQualityVar",
        "padding": "padding",
        "padding_var": "paddingVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationFeatureCrop:
    def __init__(
        self,
        *,
        fail_gravity: typing.Optional[builtins.str] = None,
        fail_gravity_var: typing.Optional[builtins.str] = None,
        feature_radius: typing.Optional[builtins.str] = None,
        feature_radius_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        max_features: typing.Optional[builtins.str] = None,
        max_features_var: typing.Optional[builtins.str] = None,
        min_feature_quality: typing.Optional[builtins.str] = None,
        min_feature_quality_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fail_gravity: Controls placement of the crop if Image and Video Manager does not detect any features in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        :param fail_gravity_var: Controls placement of the crop if Image and Video Manager does not detect any features in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        :param feature_radius: The size in pixels of the important features to search for. If identified, two features never appear closer together than this value, ``8.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius DataAkamaiImagingPolicyImage#feature_radius}
        :param feature_radius_var: The size in pixels of the important features to search for. If identified, two features never appear closer together than this value, ``8.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius_var DataAkamaiImagingPolicyImage#feature_radius_var}
        :param gravity: Controls placement of the crop. Directions are relative to the region of interest plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Controls placement of the crop. Directions are relative to the region of interest plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param max_features: The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features DataAkamaiImagingPolicyImage#max_features}
        :param max_features_var: The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features_var DataAkamaiImagingPolicyImage#max_features_var}
        :param min_feature_quality: Determines the minimum quality level of the feature identified. To consider a feature important, the feature needs to surpass this value. Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality DataAkamaiImagingPolicyImage#min_feature_quality}
        :param min_feature_quality_var: Determines the minimum quality level of the feature identified. To consider a feature important, the feature needs to surpass this value. Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality_var DataAkamaiImagingPolicyImage#min_feature_quality_var}
        :param padding: Adds space around the region of interest. The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: Adds space around the region of interest. The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        :param style: Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dcaa5bd341c9e4d4cdce77559913881cdbab5e9affee5a6e055d8c2d768694e8)
            check_type(argname="argument fail_gravity", value=fail_gravity, expected_type=type_hints["fail_gravity"])
            check_type(argname="argument fail_gravity_var", value=fail_gravity_var, expected_type=type_hints["fail_gravity_var"])
            check_type(argname="argument feature_radius", value=feature_radius, expected_type=type_hints["feature_radius"])
            check_type(argname="argument feature_radius_var", value=feature_radius_var, expected_type=type_hints["feature_radius_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument max_features", value=max_features, expected_type=type_hints["max_features"])
            check_type(argname="argument max_features_var", value=max_features_var, expected_type=type_hints["max_features_var"])
            check_type(argname="argument min_feature_quality", value=min_feature_quality, expected_type=type_hints["min_feature_quality"])
            check_type(argname="argument min_feature_quality_var", value=min_feature_quality_var, expected_type=type_hints["min_feature_quality_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fail_gravity is not None:
            self._values["fail_gravity"] = fail_gravity
        if fail_gravity_var is not None:
            self._values["fail_gravity_var"] = fail_gravity_var
        if feature_radius is not None:
            self._values["feature_radius"] = feature_radius
        if feature_radius_var is not None:
            self._values["feature_radius_var"] = feature_radius_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if max_features is not None:
            self._values["max_features"] = max_features
        if max_features_var is not None:
            self._values["max_features_var"] = max_features_var
        if min_feature_quality is not None:
            self._values["min_feature_quality"] = min_feature_quality
        if min_feature_quality_var is not None:
            self._values["min_feature_quality_var"] = min_feature_quality_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def fail_gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any features in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        '''
        result = self._values.get("fail_gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any features in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        '''
        result = self._values.get("fail_gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feature_radius(self) -> typing.Optional[builtins.str]:
        '''The size in pixels of the important features to search for.

        If identified, two features never appear closer together than this value, ``8.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius DataAkamaiImagingPolicyImage#feature_radius}
        '''
        result = self._values.get("feature_radius")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feature_radius_var(self) -> typing.Optional[builtins.str]:
        '''The size in pixels of the important features to search for.

        If identified, two features never appear closer together than this value, ``8.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius_var DataAkamaiImagingPolicyImage#feature_radius_var}
        '''
        result = self._values.get("feature_radius_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the region of interest plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the region of interest plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def max_features(self) -> typing.Optional[builtins.str]:
        '''The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features DataAkamaiImagingPolicyImage#max_features}
        '''
        result = self._values.get("max_features")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def max_features_var(self) -> typing.Optional[builtins.str]:
        '''The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features_var DataAkamaiImagingPolicyImage#max_features_var}
        '''
        result = self._values.get("max_features_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def min_feature_quality(self) -> typing.Optional[builtins.str]:
        '''Determines the minimum quality level of the feature identified.

        To consider a feature important, the feature needs to surpass this value.  Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality DataAkamaiImagingPolicyImage#min_feature_quality}
        '''
        result = self._values.get("min_feature_quality")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def min_feature_quality_var(self) -> typing.Optional[builtins.str]:
        '''Determines the minimum quality level of the feature identified.

        To consider a feature important, the feature needs to surpass this value.  Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality_var DataAkamaiImagingPolicyImage#min_feature_quality_var}
        '''
        result = self._values.get("min_feature_quality_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''Adds space around the region of interest.

        The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''Adds space around the region of interest.

        The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationFeatureCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationFeatureCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationFeatureCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ad6e856b69dc84ddd2e94396564d537ba40e8cce6b574839255834a7f786e14)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationFeatureCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c058e13f3064637dcdb2fe862188f70576b5760bd9f50c8fe4d17b8bafa0a129)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationFeatureCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__08d65ff3640ca9137faa80350cddab778aa573b1e2c6e1be93bf6d5fd0c7c9d0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af74ac0ca21f4e994cf88ea2dc064ca54dae62bb1bfb4ca612e6e8396934e1ea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__380f075ef63533dda5177f92b9577e6027eab3f2661e53b80d88df60415bb809)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationFeatureCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationFeatureCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationFeatureCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dc6c416eb01dcce4a597e852eb1e9d0ec1c7346ada71f7c06fde32c08d581e81)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationFeatureCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationFeatureCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__662e922d7b4f212f9bfa5c4ad75ba89d96436f40b289f2a351e4deb2937ee7d1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetFailGravity")
    def reset_fail_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravity", []))

    @jsii.member(jsii_name="resetFailGravityVar")
    def reset_fail_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravityVar", []))

    @jsii.member(jsii_name="resetFeatureRadius")
    def reset_feature_radius(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureRadius", []))

    @jsii.member(jsii_name="resetFeatureRadiusVar")
    def reset_feature_radius_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureRadiusVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetMaxFeatures")
    def reset_max_features(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxFeatures", []))

    @jsii.member(jsii_name="resetMaxFeaturesVar")
    def reset_max_features_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxFeaturesVar", []))

    @jsii.member(jsii_name="resetMinFeatureQuality")
    def reset_min_feature_quality(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMinFeatureQuality", []))

    @jsii.member(jsii_name="resetMinFeatureQualityVar")
    def reset_min_feature_quality_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMinFeatureQualityVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="failGravityInput")
    def fail_gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityVarInput")
    def fail_gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featureRadiusInput")
    def feature_radius_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featureRadiusInput"))

    @builtins.property
    @jsii.member(jsii_name="featureRadiusVarInput")
    def feature_radius_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featureRadiusVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesInput")
    def max_features_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "maxFeaturesInput"))

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesVarInput")
    def max_features_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "maxFeaturesVarInput"))

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityInput")
    def min_feature_quality_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "minFeatureQualityInput"))

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityVarInput")
    def min_feature_quality_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "minFeatureQualityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravity")
    def fail_gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravity"))

    @fail_gravity.setter
    def fail_gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6292e76d98e7590a5ec2cd92352ff221de3f82119d861d79cc109d84cb641130)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravity", value)

    @builtins.property
    @jsii.member(jsii_name="failGravityVar")
    def fail_gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravityVar"))

    @fail_gravity_var.setter
    def fail_gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6b473a63dd72c6b86cfd7b779d3b86d6b281697b63bb22b44728598056451389)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="featureRadius")
    def feature_radius(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featureRadius"))

    @feature_radius.setter
    def feature_radius(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__37fdda287e04f7c2a95c52563562e2e36ac427510ae0a787d16e1dbdb89dabae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featureRadius", value)

    @builtins.property
    @jsii.member(jsii_name="featureRadiusVar")
    def feature_radius_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featureRadiusVar"))

    @feature_radius_var.setter
    def feature_radius_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fe6bec4717253d0af2a8e9a8766b8d73dcbd42ed1acad43450b2b5838fcef0b1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featureRadiusVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2c4d36a39f4c120e9a5e031bb41bd15403541f3a03e6d20deaa4fc3cff0288b6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4acf5cf66f12744febef4021aa290fab362db79cd346d14ed54f7abec2950477)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c6017ffa013ce0b05065a6ff829028540fac73a8e36b59cfa8214e71eb47901d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc8ab01dc83d1c587943e03bcd6101763068eea865c942e1b1f02e4dc37a6e4a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="maxFeatures")
    def max_features(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "maxFeatures"))

    @max_features.setter
    def max_features(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5428c48465ba31ff17d00e8565a1d5f033a7273368798387f08c257432590423)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "maxFeatures", value)

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesVar")
    def max_features_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "maxFeaturesVar"))

    @max_features_var.setter
    def max_features_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0d14ff9c72a7dbd0576bf06734535f8dedf809d6b628a3e2e2fe990e9f8859c4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "maxFeaturesVar", value)

    @builtins.property
    @jsii.member(jsii_name="minFeatureQuality")
    def min_feature_quality(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "minFeatureQuality"))

    @min_feature_quality.setter
    def min_feature_quality(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4e6acfc22d45964cb147a0877c1a9a39d2493638791577d844d8221f317661f4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "minFeatureQuality", value)

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityVar")
    def min_feature_quality_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "minFeatureQualityVar"))

    @min_feature_quality_var.setter
    def min_feature_quality_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bfccf281bcf74d1b834953fcca970bbc29c5088c64a7b2675a7d1baa20df019a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "minFeatureQualityVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__72211b05e76b4db27c4b2403076fa47818fc3877d33120d701b87f0441d562cb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__52ef97eac1a8b5194139ed0bd41772620702e55f64db3ded63271203daaa7a5e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__19b23c39dd480c8781dca0fd702f8a0a6c6c727825ebc252727e67d4be5ed1d0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__40e5b72e45288020b31196c0b79a18f0d813cc5f8713cc29828c1237fe4a274a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a2133725e9526475ae4307da791a7eb9437a997bd38739884b3bb86747dfc8ca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cf728d6f3a4d8e974a1fbe518bcc81c356f07d4d129aefa35bfebe14ba729179)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationFeatureCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationFeatureCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationFeatureCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d63e5940f8a291f160c0d1fee42cad5e77a2d8f69dcf9a99cc67ede6e6fc4e8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationFitAndFill",
    jsii_struct_bases=[],
    name_mapping={
        "fill_transformation": "fillTransformation",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationFitAndFill:
    def __init__(
        self,
        *,
        fill_transformation: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationFitAndFillFillTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fill_transformation: fill_transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_transformation DataAkamaiImagingPolicyImage#fill_transformation}
        :param height: The height value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The width value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(fill_transformation, dict):
            fill_transformation = DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationFitAndFillFillTransformation(**fill_transformation)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2c0e775b6505a26b6f8023aee4079d050e302c1b4fcfc5e15a28809314d100be)
            check_type(argname="argument fill_transformation", value=fill_transformation, expected_type=type_hints["fill_transformation"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fill_transformation is not None:
            self._values["fill_transformation"] = fill_transformation
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def fill_transformation(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationFitAndFillFillTransformation"]:
        '''fill_transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_transformation DataAkamaiImagingPolicyImage#fill_transformation}
        '''
        result = self._values.get("fill_transformation")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationFitAndFillFillTransformation"], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationFitAndFill(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationFitAndFillFillTransformation",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationFitAndFillFillTransformation:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationFitAndFillFillTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationFitAndFillFillTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationFitAndFillFillTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9782694de19b16920302ed8d366d284b9914a31f0b2f0871491aa95e134160d3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationFitAndFillFillTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationFitAndFillFillTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationFitAndFillFillTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fe2a858180e90264eb32980cdd4057c5b87a6c1165a29c430ee02e86cdd7951a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationFitAndFillList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationFitAndFillList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5c0484ffa042f068fe742ad0f8305a7f9fa1bdc1278941890a4570887b4a0d03)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationFitAndFillOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__589d3af2a7908737cbc24a36fad3598067060307b1a1d427cbb16e668dad9921)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationFitAndFillOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__15c52fa470bd627c71fdfc60394d947aaa79a2905e825d0b65f1c3efbbc83a90)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__74f3772603b2b8aed3d6ad479e83b2e6511f318287e350d1d4fc2adb17a1b85f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7aa9b14c5a68fb56096ac78e45c4b67ead498d4db488bc0dc441da06f2d85652)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationFitAndFill]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationFitAndFill]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationFitAndFill]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__070140141d9ba8159b18ed1ed21c12e70c08e56683b9cbf7cfb63fc94496c228)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationFitAndFillOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationFitAndFillOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2f526eb6142d25be7184478c11347a19d425d6b77670e3294e6cbe13a9a8fe4c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putFillTransformation")
    def put_fill_transformation(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationFitAndFillFillTransformation()

        return typing.cast(None, jsii.invoke(self, "putFillTransformation", [value]))

    @jsii.member(jsii_name="resetFillTransformation")
    def reset_fill_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFillTransformation", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="fillTransformation")
    def fill_transformation(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationFitAndFillFillTransformationOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationFitAndFillFillTransformationOutputReference, jsii.get(self, "fillTransformation"))

    @builtins.property
    @jsii.member(jsii_name="fillTransformationInput")
    def fill_transformation_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationFitAndFillFillTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationFitAndFillFillTransformation], jsii.get(self, "fillTransformationInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__46dbbce7953577bbda5bdc1275e22e80c9699a5e3c2a7b7ade6ebd8eb14f3193)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e2fb24caa4047da85daaca810dd865a125e8271e92e78281d2f11b7b5ebeb823)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__80c87a83b96595ddea74825509b9f5d814f0c8130a4fdf0331288b5c3ed50f42)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ca9e50ccf18104b490a8e8c42171d021f5a7f9e9e1eb21804271014b2c1763b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationFitAndFill]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationFitAndFill]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationFitAndFill]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__62656d2f013150797f55021300396aa9711382ded657e61cb77987ff9ce89cb7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationGoop",
    jsii_struct_bases=[],
    name_mapping={
        "chaos": "chaos",
        "chaos_var": "chaosVar",
        "density": "density",
        "density_var": "densityVar",
        "power": "power",
        "power_var": "powerVar",
        "seed": "seed",
        "seed_var": "seedVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationGoop:
    def __init__(
        self,
        *,
        chaos: typing.Optional[builtins.str] = None,
        chaos_var: typing.Optional[builtins.str] = None,
        density: typing.Optional[builtins.str] = None,
        density_var: typing.Optional[builtins.str] = None,
        power: typing.Optional[builtins.str] = None,
        power_var: typing.Optional[builtins.str] = None,
        seed: typing.Optional[builtins.str] = None,
        seed_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param chaos: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        :param chaos_var: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        :param density: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        :param density_var: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        :param power: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        :param power_var: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        :param seed: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        :param seed_var: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8f93271a58acf2cd78fe582a320fea4d743b7465172bddcfa1d33211343dc7d5)
            check_type(argname="argument chaos", value=chaos, expected_type=type_hints["chaos"])
            check_type(argname="argument chaos_var", value=chaos_var, expected_type=type_hints["chaos_var"])
            check_type(argname="argument density", value=density, expected_type=type_hints["density"])
            check_type(argname="argument density_var", value=density_var, expected_type=type_hints["density_var"])
            check_type(argname="argument power", value=power, expected_type=type_hints["power"])
            check_type(argname="argument power_var", value=power_var, expected_type=type_hints["power_var"])
            check_type(argname="argument seed", value=seed, expected_type=type_hints["seed"])
            check_type(argname="argument seed_var", value=seed_var, expected_type=type_hints["seed_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if chaos is not None:
            self._values["chaos"] = chaos
        if chaos_var is not None:
            self._values["chaos_var"] = chaos_var
        if density is not None:
            self._values["density"] = density
        if density_var is not None:
            self._values["density_var"] = density_var
        if power is not None:
            self._values["power"] = power
        if power_var is not None:
            self._values["power_var"] = power_var
        if seed is not None:
            self._values["seed"] = seed
        if seed_var is not None:
            self._values["seed_var"] = seed_var

    @builtins.property
    def chaos(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        '''
        result = self._values.get("chaos")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def chaos_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        '''
        result = self._values.get("chaos_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        '''
        result = self._values.get("density")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density_var(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        '''
        result = self._values.get("density_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        '''
        result = self._values.get("power")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power_var(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        '''
        result = self._values.get("power_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        '''
        result = self._values.get("seed")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed_var(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        result = self._values.get("seed_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationGoop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationGoopList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationGoopList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__30033bcfd16fe75c6a858ee36ed7b77f2db99feff067062121d6488552698246)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationGoopOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8c5e75651792706a90a9bc39f9d0786fdf9cbfa6eb77f7b4c69138bd9d094c03)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationGoopOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__439ce4ab2cb95e38bd6ca38a2a85becc71c2f6d2d6a2fca55b5b9c03ff89d5c9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d0546dba7e595a5ada98063314f11a0c345ef2b031e83c678ebcbaec06303bf7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f3460a488e5366f192d40fb7960358cdbdfe9f1d5a0e08d5774fed222024b7d0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationGoop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationGoop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__88c18ffbd3081e8f1c05a6573d751c92f9662f54344caacf0a57d2f1e1ce8ba7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationGoopOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationGoopOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__158f077a9e0e9ebbeb741fe1444251ee5918816a9b0007f743fc5b6c2e5d3697)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetChaos")
    def reset_chaos(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaos", []))

    @jsii.member(jsii_name="resetChaosVar")
    def reset_chaos_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaosVar", []))

    @jsii.member(jsii_name="resetDensity")
    def reset_density(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensity", []))

    @jsii.member(jsii_name="resetDensityVar")
    def reset_density_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensityVar", []))

    @jsii.member(jsii_name="resetPower")
    def reset_power(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPower", []))

    @jsii.member(jsii_name="resetPowerVar")
    def reset_power_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPowerVar", []))

    @jsii.member(jsii_name="resetSeed")
    def reset_seed(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeed", []))

    @jsii.member(jsii_name="resetSeedVar")
    def reset_seed_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeedVar", []))

    @builtins.property
    @jsii.member(jsii_name="chaosInput")
    def chaos_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosInput"))

    @builtins.property
    @jsii.member(jsii_name="chaosVarInput")
    def chaos_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosVarInput"))

    @builtins.property
    @jsii.member(jsii_name="densityInput")
    def density_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityInput"))

    @builtins.property
    @jsii.member(jsii_name="densityVarInput")
    def density_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="powerInput")
    def power_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerInput"))

    @builtins.property
    @jsii.member(jsii_name="powerVarInput")
    def power_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerVarInput"))

    @builtins.property
    @jsii.member(jsii_name="seedInput")
    def seed_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedInput"))

    @builtins.property
    @jsii.member(jsii_name="seedVarInput")
    def seed_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedVarInput"))

    @builtins.property
    @jsii.member(jsii_name="chaos")
    def chaos(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaos"))

    @chaos.setter
    def chaos(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f2d84df34a896d55c14df7cd93a29237abd7659577c7ea7ca76a438b3b4a1fa7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaos", value)

    @builtins.property
    @jsii.member(jsii_name="chaosVar")
    def chaos_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaosVar"))

    @chaos_var.setter
    def chaos_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__800b517f02624594aedd4eb17cceb8cc752fb6fb9b0d6002eb1d15d65b2a9dd9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaosVar", value)

    @builtins.property
    @jsii.member(jsii_name="density")
    def density(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "density"))

    @density.setter
    def density(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bf53557ed2a83dce34db5c5be26eaf0a886dbcb76fb6bbdd1e4319340024f81c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "density", value)

    @builtins.property
    @jsii.member(jsii_name="densityVar")
    def density_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "densityVar"))

    @density_var.setter
    def density_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cac786d6bd5ca456486d4e7758e2bc8e7e4a750f63404ea7b18bfa1efc763abb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "densityVar", value)

    @builtins.property
    @jsii.member(jsii_name="power")
    def power(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "power"))

    @power.setter
    def power(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__92680ba46698195816ed61d852b33db3d994d944f78bb0058ece97bf4cda0fa1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "power", value)

    @builtins.property
    @jsii.member(jsii_name="powerVar")
    def power_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "powerVar"))

    @power_var.setter
    def power_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4716532697768d2beee1a490eb9f05e83cbad5c93e8ca37282bff09df3432812)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "powerVar", value)

    @builtins.property
    @jsii.member(jsii_name="seed")
    def seed(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seed"))

    @seed.setter
    def seed(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb637998d93cc7debda1439fcf95a170dbf5451c1bc04032b985cefce61c2470)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seed", value)

    @builtins.property
    @jsii.member(jsii_name="seedVar")
    def seed_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seedVar"))

    @seed_var.setter
    def seed_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__db974d8e5d26f26510b2e12169552b39a9a856a684852d6da0153bb3a9ac6176)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seedVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationGoop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationGoop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationGoop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f6d315a92ab2d2f85670347d70dcb41ea25438cc11bc39b591e686dbf20388c6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationGrayscale",
    jsii_struct_bases=[],
    name_mapping={"type": "type", "type_var": "typeVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationGrayscale:
    def __init__(
        self,
        *,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param type: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ad142cda03d5141c4839ae7fa69930e62382a23a2931162b6118d4d0067076ea)
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationGrayscale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationGrayscaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationGrayscaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d5a93e42b0f3c2cc2548d0377b44094b0f548291cc2772189e0026c3636b563b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationGrayscaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b1041faa273162ed329cf3f1d03137109e34d513c9d104a6e672324f72c3b675)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationGrayscaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5170b97e3f93311df7b2865fa1046ffa8696ef028ba7bd0429112ea0c9fdf799)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__55cc1a8690f2c9ca744b648c96b00117e935bfb72e5112090f48677de0c16e19)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__84a9d022f82b49b6639899c4f042d7c21527f0fc4283a35915fbbf7edeb832cf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationGrayscale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationGrayscale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3c1992a2ebd581befc1e645e623b0942a9c9e473a8d64d42a51eac34d6b1c564)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationGrayscaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationGrayscaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c37659ee1af2dfbbc991d8b54b08200dbbf6a181463adb8f723656bfeb9a497e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a1b2358a6dc5ce0e47d08120da944374ce357a626006f67bad2c3f22fc8ce64d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__06340bcf8799015f5300f75ea7ce00affe05da72fe2c364a357f71c199fbc288)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationGrayscale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationGrayscale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationGrayscale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__98247c353adad9dc1259f40ef5f9d88eaff1d4e81be154cb4bc284e1c102f7f2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationHsl",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "lightness": "lightness",
        "lightness_var": "lightnessVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationHsl:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness: typing.Optional[builtins.str] = None,
        lightness_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        :param lightness_var: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__21978b14e27494987099b0c872ce2b440134387e1a8c3054526967e896fff06c)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness", value=lightness, expected_type=type_hints["lightness"])
            check_type(argname="argument lightness_var", value=lightness_var, expected_type=type_hints["lightness_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness is not None:
            self._values["lightness"] = lightness
        if lightness_var is not None:
            self._values["lightness_var"] = lightness_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        '''
        result = self._values.get("lightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        '''
        result = self._values.get("lightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationHsl(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationHslList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationHslList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__90660fc8f00ed304ee84c997039ce88a79f351bfe419813e0b0485e82ea075c9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationHslOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac54b82f027af678ee9215becc32774b90ad643501db0f5e2023ff36acd67484)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationHslOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__16ecabaca63ed8227ff08b46a491559c9611c9620d9c8ed1ec11e03b865cfcb1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__418aa9049637348a1f8a64ec2b87fa6295d431ecbf3eccfc15499229b0d9d100)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cdc29b9d17453a5eb30adcdda8189a021fa765fc0f2b4502719f7182e84c7071)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationHsl]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationHsl]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__04522e2346f0b8a065931224f90a9fae8654d4d0aeb895f2b883bdbda8ac9549)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationHslOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationHslOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7652440e4c5e003fa73239ce82f28a37f155fa1f20eb8ecc75c35c90e0e569e3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightness")
    def reset_lightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightness", []))

    @jsii.member(jsii_name="resetLightnessVar")
    def reset_lightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessInput")
    def lightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessVarInput")
    def lightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__91be8c03d4207749f163ed34ff73c49ce60f62219c4976ff11fcdd498ab1a488)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d0c8f4d8135554f507900936cd066b26e29827918ec4999fa93a79a5d26320a3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightness")
    def lightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightness"))

    @lightness.setter
    def lightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a407fdbd510b884b76dc7b5ece554dbbba208528ef464be6c9a63248d6fce705)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightness", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessVar")
    def lightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessVar"))

    @lightness_var.setter
    def lightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a53324ba7d4a5dbd992799c4cc6dc7430a3389eb45e9998369f1f05213f4f1d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f988ecd3d7a5d50ab8e11e795e6219e144a9c7641b03fddc995c105a3738e6df)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a2ecf0a2286d48b78ca5b865c3da2aadf6c1c26976b68f4fd29f65e4768b61ab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationHsl]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationHsl]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationHsl]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6d2fb289372aa7a5e6d2e3d2a886fa87ce0e176a609e22166bcd665feb98316e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationHsv",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationHsv:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        :param value: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__707237da2f09210ff30fcf9656c9ddde2ba80b2e06f71977347962ded811cf2e)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationHsv(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationHsvList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationHsvList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b12405fcd70a799ccf8ac274ea5268537e0f2f6f6f00460e9aa3d3712b9aa00f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationHsvOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f7c10209ac8ee51166bef0bb7d5889a5ca11ffa37020b707d64c2455ea559cdb)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationHsvOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6098c052d99e0ec70038acb65064a1d5d633defd52727357565a8e2070834e5b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3999a7a3424b8c60fbc79e081965c9fb9be175117e30f3be71adc02542852e27)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__da133f69f2367eb38fed117e8a5745a6bc22fb20692472b778591c0d70bade5e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationHsv]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationHsv]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1b9c2cdd20c40975bddbabc499f84976750af0726a9a685cc4226d273900db41)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationHsvOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationHsvOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__56b585a80f9e1c550631f6000b54dd7bfd4ed1c1d54e5145df6ba1c6318af883)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__72fadb339dd378392bce539bc691bba81d3ebc4244e5e46a83727474871a5c67)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__12f12bd46e0eef08ea24e0f52e31fe8180ea5abe002f7ae28dc96a14abfcafa8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__78ec5f099ce7a275d0b79e84d67c4f1126c3e4ca3f8785c405919ff6988925f7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ff6bb90c1112abf5552168a5c5a4d7e77f264dc8eaaffd2a30a03f797128c804)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__79e5b480c6cd94d286b82d2bc4164a59da76fd97911d8151872c9fd9c7b14d77)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f9c2969ed79324c6d5049bf8310b9ca2211230eda83f4f17c33459eff34fbb9f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationHsv]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationHsv]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationHsv]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e6661d1d71c10c586aa7e70ea899ddc714d5e1b63ba0f77f1bf1078f23d5d5a1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfDimension",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "dimension": "dimension",
        "dimension_var": "dimensionVar",
        "equal": "equal",
        "greater_than": "greaterThan",
        "less_than": "lessThan",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfDimension:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfDimensionDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        dimension: typing.Optional[builtins.str] = None,
        dimension_var: typing.Optional[builtins.str] = None,
        equal: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfDimensionEqual", typing.Dict[builtins.str, typing.Any]]] = None,
        greater_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfDimensionGreaterThan", typing.Dict[builtins.str, typing.Any]]] = None,
        less_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfDimensionLessThan", typing.Dict[builtins.str, typing.Any]]] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param dimension: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        :param dimension_var: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        :param equal: equal block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        :param greater_than: greater_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        :param less_than: less_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        :param value: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfDimensionDefault(**default)
        if isinstance(equal, dict):
            equal = DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfDimensionEqual(**equal)
        if isinstance(greater_than, dict):
            greater_than = DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfDimensionGreaterThan(**greater_than)
        if isinstance(less_than, dict):
            less_than = DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfDimensionLessThan(**less_than)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8e62a7b7afd1d7fd10244eaf92e944fdccdff1d01afb748e6822ced78fb6ca33)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument dimension", value=dimension, expected_type=type_hints["dimension"])
            check_type(argname="argument dimension_var", value=dimension_var, expected_type=type_hints["dimension_var"])
            check_type(argname="argument equal", value=equal, expected_type=type_hints["equal"])
            check_type(argname="argument greater_than", value=greater_than, expected_type=type_hints["greater_than"])
            check_type(argname="argument less_than", value=less_than, expected_type=type_hints["less_than"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if dimension is not None:
            self._values["dimension"] = dimension
        if dimension_var is not None:
            self._values["dimension_var"] = dimension_var
        if equal is not None:
            self._values["equal"] = equal
        if greater_than is not None:
            self._values["greater_than"] = greater_than
        if less_than is not None:
            self._values["less_than"] = less_than
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfDimensionDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfDimensionDefault"], result)

    @builtins.property
    def dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        '''
        result = self._values.get("dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        '''
        result = self._values.get("dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def equal(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfDimensionEqual"]:
        '''equal block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        '''
        result = self._values.get("equal")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfDimensionEqual"], result)

    @builtins.property
    def greater_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfDimensionGreaterThan"]:
        '''greater_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        '''
        result = self._values.get("greater_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfDimensionGreaterThan"], result)

    @builtins.property
    def less_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfDimensionLessThan"]:
        '''less_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        '''
        result = self._values.get("less_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfDimensionLessThan"], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfDimension(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfDimensionDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfDimensionDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfDimensionDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfDimensionDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfDimensionDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__86e678b5373dbcc5dea933d84e7476c5b16c6a84be91325f6c795f022b4fc178)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfDimensionDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfDimensionDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f0ea3428f0dc2ed74e3d5eca12c32784299d011164bda1b4829f3ebfba7e0dd2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfDimensionEqual",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfDimensionEqual:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfDimensionEqual(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfDimensionEqualOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfDimensionEqualOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dc9c564c60c50171985c951281cdca931953725c6db173ddb5d657e68ef2f0e6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfDimensionEqual], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfDimensionEqual],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4d733e7e45b96283e82c4f022dc4768a9fee034ca5b0e0468ca584b31ac1deeb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfDimensionGreaterThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfDimensionGreaterThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfDimensionGreaterThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfDimensionGreaterThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfDimensionGreaterThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__95abdfb8e89c928a8f0d4073a64d7b0974275cd3167359a7d9b4d99aca6d2e04)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfDimensionGreaterThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfDimensionGreaterThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cda4f2c78d31bdbc821a15a965ff982c0dc6fb5952559d33c13e4804656e3547)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfDimensionLessThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfDimensionLessThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfDimensionLessThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfDimensionLessThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfDimensionLessThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3b2c66bcfd8b792f97d24fd4758681bac301a9be9bb7467095cafddc5b0590e8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfDimensionLessThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfDimensionLessThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__925ab8a98c391497b6517a05f693936179371c412d94bd4db9f351d896c7cdcd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfDimensionList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfDimensionList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8848d522a7f42687cbc6b0d56045902a0a9d0adb54e2a24dc4406eaf179eb7f0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfDimensionOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1ada42729633bd364acb67b05b0257bca87c33ee9b0ae2c0f0d152fb4cacd997)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfDimensionOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7fcd5d30b4095699b72f98aa0e2db91ae659b03b09602d564e0554ee9f797d0c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__487eb8776a74da88a0de8b7d25c8d8710727b371fea2b1a75d3587e0ca85040d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__229966e3cf9d2b6ad16127b434a894ede05801d943121ff76873cfb59a61105f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfDimension]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfDimension]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c4912e8b60a54594945035a4f5b95be651a094860412ba80143c9880ea254b2d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfDimensionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfDimensionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e5e964b5b040369f125c35c39fd3c900ca0afb5334376dba190700864e9e7ced)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfDimensionDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putEqual")
    def put_equal(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfDimensionEqual()

        return typing.cast(None, jsii.invoke(self, "putEqual", [value]))

    @jsii.member(jsii_name="putGreaterThan")
    def put_greater_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfDimensionGreaterThan()

        return typing.cast(None, jsii.invoke(self, "putGreaterThan", [value]))

    @jsii.member(jsii_name="putLessThan")
    def put_less_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfDimensionLessThan()

        return typing.cast(None, jsii.invoke(self, "putLessThan", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetDimension")
    def reset_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimension", []))

    @jsii.member(jsii_name="resetDimensionVar")
    def reset_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimensionVar", []))

    @jsii.member(jsii_name="resetEqual")
    def reset_equal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEqual", []))

    @jsii.member(jsii_name="resetGreaterThan")
    def reset_greater_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGreaterThan", []))

    @jsii.member(jsii_name="resetLessThan")
    def reset_less_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLessThan", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfDimensionDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfDimensionDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="equal")
    def equal(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfDimensionEqualOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfDimensionEqualOutputReference, jsii.get(self, "equal"))

    @builtins.property
    @jsii.member(jsii_name="greaterThan")
    def greater_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfDimensionGreaterThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfDimensionGreaterThanOutputReference, jsii.get(self, "greaterThan"))

    @builtins.property
    @jsii.member(jsii_name="lessThan")
    def less_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfDimensionLessThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfDimensionLessThanOutputReference, jsii.get(self, "lessThan"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfDimensionDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionInput")
    def dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionVarInput")
    def dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="equalInput")
    def equal_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfDimensionEqual], jsii.get(self, "equalInput"))

    @builtins.property
    @jsii.member(jsii_name="greaterThanInput")
    def greater_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfDimensionGreaterThan], jsii.get(self, "greaterThanInput"))

    @builtins.property
    @jsii.member(jsii_name="lessThanInput")
    def less_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfDimensionLessThan], jsii.get(self, "lessThanInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="dimension")
    def dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimension"))

    @dimension.setter
    def dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f1b1d6e075c12a4c5440bcfdd24e5c72b43291f326ee591fdc52f081a94cb4bc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimension", value)

    @builtins.property
    @jsii.member(jsii_name="dimensionVar")
    def dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimensionVar"))

    @dimension_var.setter
    def dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fd18cf61b294961f69c0d4ca6a9affb1607113167fe19ffc4800752d67ac24ee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ebd0d7afa94c82b97acf411192b6b566de7732a8a4ab479c95eb513176f0fd34)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ffb9ca7cca899c04eb8b22f48c0c4fe8434fdbd4efd2d95134f9c6cd776e6178)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfDimension]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfDimension]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfDimension]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__30f4dd436430c0255758c3333d6d6a722bdec6321d3d65d6ecb678ad21594219)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfOrientation",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "landscape": "landscape",
        "portrait": "portrait",
        "square": "square",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfOrientation:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfOrientationDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        landscape: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfOrientationLandscape", typing.Dict[builtins.str, typing.Any]]] = None,
        portrait: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfOrientationPortrait", typing.Dict[builtins.str, typing.Any]]] = None,
        square: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfOrientationSquare", typing.Dict[builtins.str, typing.Any]]] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param landscape: landscape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        :param portrait: portrait block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        :param square: square block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfOrientationDefault(**default)
        if isinstance(landscape, dict):
            landscape = DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfOrientationLandscape(**landscape)
        if isinstance(portrait, dict):
            portrait = DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfOrientationPortrait(**portrait)
        if isinstance(square, dict):
            square = DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfOrientationSquare(**square)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8fc9c313b7cd435f7a8ea337dbd7882fa8572681acbfb0d1d4ae66b3bb666d85)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument landscape", value=landscape, expected_type=type_hints["landscape"])
            check_type(argname="argument portrait", value=portrait, expected_type=type_hints["portrait"])
            check_type(argname="argument square", value=square, expected_type=type_hints["square"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if landscape is not None:
            self._values["landscape"] = landscape
        if portrait is not None:
            self._values["portrait"] = portrait
        if square is not None:
            self._values["square"] = square

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfOrientationDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfOrientationDefault"], result)

    @builtins.property
    def landscape(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfOrientationLandscape"]:
        '''landscape block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        '''
        result = self._values.get("landscape")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfOrientationLandscape"], result)

    @builtins.property
    def portrait(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfOrientationPortrait"]:
        '''portrait block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        '''
        result = self._values.get("portrait")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfOrientationPortrait"], result)

    @builtins.property
    def square(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfOrientationSquare"]:
        '''square block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        result = self._values.get("square")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfOrientationSquare"], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfOrientation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfOrientationDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfOrientationDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfOrientationDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfOrientationDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfOrientationDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8b0789cff498460f8b0f0a45645807b17bacf82921b6320e8f92a652dfc7ecdd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfOrientationDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfOrientationDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5e8f2fea940b233920fa05b5c1b7525d0d3b5080e1ee6de892024e07c08713cd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfOrientationLandscape",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfOrientationLandscape:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfOrientationLandscape(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfOrientationLandscapeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfOrientationLandscapeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d6f270602f8f8e13dca7ead90a098c399afa513b819a4ed093bf8452c1188f7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfOrientationLandscape], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfOrientationLandscape],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a18694fac429e9f72754edad92dd0cc20a0c6ac73a5a883617a3fb2dba8d024)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfOrientationList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfOrientationList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e8326c465aefe746d3387ad2480e414c57082e4089cf6b40f2d8df1c1bf97291)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfOrientationOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ece91b2f94c4573e2c8ce14014a39ee14a9e348a4ea0563b797c524d313d3b7c)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfOrientationOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e7bebb217a11411f2e594a8adcbb9e9d111f46ba1962f185d7595d154a8b7b39)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__055c661f85ee7f5d859e39c80f0cf024bbbb33a8a02765eb911ea36e2b421f05)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2c79359bfda8c6142952fff9d5e4e48e9e1147ba9a547aad3e534ba6bf055fc8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfOrientation]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfOrientation]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__59846f8ffbb2de5f4c5ad011df915b8e757c5ad06dacf0112d8de14aeff3b726)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfOrientationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfOrientationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0866e52b127f6a6069beefffa7b12d8359c563a99df001716fa7d57f48c34dbb)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfOrientationDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putLandscape")
    def put_landscape(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfOrientationLandscape()

        return typing.cast(None, jsii.invoke(self, "putLandscape", [value]))

    @jsii.member(jsii_name="putPortrait")
    def put_portrait(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfOrientationPortrait()

        return typing.cast(None, jsii.invoke(self, "putPortrait", [value]))

    @jsii.member(jsii_name="putSquare")
    def put_square(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfOrientationSquare()

        return typing.cast(None, jsii.invoke(self, "putSquare", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetLandscape")
    def reset_landscape(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLandscape", []))

    @jsii.member(jsii_name="resetPortrait")
    def reset_portrait(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPortrait", []))

    @jsii.member(jsii_name="resetSquare")
    def reset_square(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSquare", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfOrientationDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfOrientationDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="landscape")
    def landscape(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfOrientationLandscapeOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfOrientationLandscapeOutputReference, jsii.get(self, "landscape"))

    @builtins.property
    @jsii.member(jsii_name="portrait")
    def portrait(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfOrientationPortraitOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfOrientationPortraitOutputReference", jsii.get(self, "portrait"))

    @builtins.property
    @jsii.member(jsii_name="square")
    def square(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfOrientationSquareOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfOrientationSquareOutputReference", jsii.get(self, "square"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfOrientationDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="landscapeInput")
    def landscape_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfOrientationLandscape], jsii.get(self, "landscapeInput"))

    @builtins.property
    @jsii.member(jsii_name="portraitInput")
    def portrait_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfOrientationPortrait"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfOrientationPortrait"], jsii.get(self, "portraitInput"))

    @builtins.property
    @jsii.member(jsii_name="squareInput")
    def square_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfOrientationSquare"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfOrientationSquare"], jsii.get(self, "squareInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfOrientation]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfOrientation]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfOrientation]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cfd6af7fedfb11b259f4608099f24a0e7020d658ff9f7f8fe8a72c02e617e93a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfOrientationPortrait",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfOrientationPortrait:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfOrientationPortrait(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfOrientationPortraitOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfOrientationPortraitOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__48730d2c6e52d8bee39f94b30a9609439393d9939aa76bd30f84252be2aa86fe)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfOrientationPortrait]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfOrientationPortrait], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfOrientationPortrait],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fc0cb0edb8cfb9613ecf9fe0c8aaf33abaad5754abf9af418584ddd0793cf133)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfOrientationSquare",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfOrientationSquare:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfOrientationSquare(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfOrientationSquareOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfOrientationSquareOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ddd4c64c25e7cf5da4f6cb792948a58c0e7fb31c2ee0049e52bafa0507e47a7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfOrientationSquare]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfOrientationSquare], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfOrientationSquare],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5fc716967f03889f2ebd73bfeb0640dbeddda4c7c2d77868ec7e7dec97acac0c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationImQuery",
    jsii_struct_bases=[],
    name_mapping={
        "allowed_transformations": "allowedTransformations",
        "query_var": "queryVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationImQuery:
    def __init__(
        self,
        *,
        allowed_transformations: typing.Sequence[builtins.str],
        query_var: builtins.str,
    ) -> None:
        '''
        :param allowed_transformations: Specifies the transformations that can be applied using the query string parameter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allowed_transformations DataAkamaiImagingPolicyImage#allowed_transformations}
        :param query_var: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#query_var DataAkamaiImagingPolicyImage#query_var}.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d019445bb7f1b668e437b4cd29ce3a34da6e8440ab135018abd3e8f66d771657)
            check_type(argname="argument allowed_transformations", value=allowed_transformations, expected_type=type_hints["allowed_transformations"])
            check_type(argname="argument query_var", value=query_var, expected_type=type_hints["query_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "allowed_transformations": allowed_transformations,
            "query_var": query_var,
        }

    @builtins.property
    def allowed_transformations(self) -> typing.List[builtins.str]:
        '''Specifies the transformations that can be applied using the query string parameter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allowed_transformations DataAkamaiImagingPolicyImage#allowed_transformations}
        '''
        result = self._values.get("allowed_transformations")
        assert result is not None, "Required property 'allowed_transformations' is missing"
        return typing.cast(typing.List[builtins.str], result)

    @builtins.property
    def query_var(self) -> builtins.str:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#query_var DataAkamaiImagingPolicyImage#query_var}.'''
        result = self._values.get("query_var")
        assert result is not None, "Required property 'query_var' is missing"
        return typing.cast(builtins.str, result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationImQuery(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationImQueryList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationImQueryList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__782e3e7da8b07f8380df25dcd0ac962ddcda9fc40a84136290ffa355f7140009)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationImQueryOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__840604fadbc3558f3be80164da9759de9a8f632578f66b5af9c3922dec7c184e)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationImQueryOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__60c52ab7b883d396df8ec7916ab33e9fe2f06bc12c1476fc6a149267c8401b9c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__02c87de3bb4b28c7595062939105b329aba13149d680e7082420034aca133ab2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5fb852f636eefb1e3645c5ad3031a3ed580ef38bd3e1b6ffbb40e87181952b7b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationImQuery]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationImQuery]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationImQuery]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c4b2ac70f216e7427b3d6cbcd9cfd30adc6b6cadf8b5b52ca3f6cc1797dbd7b1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationImQueryOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationImQueryOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a35771b74dbb0cace5ce0c65f9d173b979aa3d8e6718f0d92fcd7ecc6ceaeb8e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @builtins.property
    @jsii.member(jsii_name="allowedTransformationsInput")
    def allowed_transformations_input(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "allowedTransformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="queryVarInput")
    def query_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "queryVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowedTransformations")
    def allowed_transformations(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "allowedTransformations"))

    @allowed_transformations.setter
    def allowed_transformations(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ede61e0017e40f4c41a2f9b75dee48d75ccef6f37729a17ce0afa5122e121e5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowedTransformations", value)

    @builtins.property
    @jsii.member(jsii_name="queryVar")
    def query_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "queryVar"))

    @query_var.setter
    def query_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__55139d1128da138ec29b3a1319aaef2308eecbf497da81f851cb8f942c580899)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "queryVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationImQuery]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationImQuery]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationImQuery]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d66d78df115260dd599e89e711ecbbf1b58493caaa62f03ab2ee1a167930aa04)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationMaxColors",
    jsii_struct_bases=[],
    name_mapping={"colors": "colors", "colors_var": "colorsVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationMaxColors:
    def __init__(
        self,
        *,
        colors: typing.Optional[builtins.str] = None,
        colors_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param colors: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        :param colors_var: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__28b41e1675862357ed6c8f86cb2169d5747812b8e8b94d17b22ff921c24e6183)
            check_type(argname="argument colors", value=colors, expected_type=type_hints["colors"])
            check_type(argname="argument colors_var", value=colors_var, expected_type=type_hints["colors_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if colors is not None:
            self._values["colors"] = colors
        if colors_var is not None:
            self._values["colors_var"] = colors_var

    @builtins.property
    def colors(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        '''
        result = self._values.get("colors")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def colors_var(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        result = self._values.get("colors_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationMaxColors(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationMaxColorsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationMaxColorsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fec13dad14fe7c3776f930a692bef6be23b1f961b121f231f6fadaf37d6b8f96)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationMaxColorsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__136f8e96f092cf20da7ac25e7b4b2cdb728c5b192a41cdaf34075bf9f9248c1a)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationMaxColorsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fd29cf58609e4a115763160d60cc4e89436b6da087bd45c6aaaf7dd0645e2049)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__27b9f8a101ba88fe05686c3641ae5600520dafec44a363e03b44ef97a02af025)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7fb50843749b8c457fbf675186d78c70f52dfc9451e4acdedbdc5953ca241b1c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationMaxColors]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationMaxColors]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0413804e010fc17241af3dc5ac33437686464580fe157d1d70a1014a7db00993)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationMaxColorsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationMaxColorsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2afa6753dbe28609d7a1d2ddbc89a81ba5da51f26f395343c5f02621e7d2555e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColors")
    def reset_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColors", []))

    @jsii.member(jsii_name="resetColorsVar")
    def reset_colors_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorsVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorsInput")
    def colors_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsInput"))

    @builtins.property
    @jsii.member(jsii_name="colorsVarInput")
    def colors_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsVarInput"))

    @builtins.property
    @jsii.member(jsii_name="colors")
    def colors(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colors"))

    @colors.setter
    def colors(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f155dc1ea740705e3fbc4567c7698886a456684e2e8240b63c5ffd60564c9869)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colors", value)

    @builtins.property
    @jsii.member(jsii_name="colorsVar")
    def colors_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorsVar"))

    @colors_var.setter
    def colors_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9270845468ac6c22a7259d5b15013c7757262f381e5659869790a677ac752d91)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorsVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationMaxColors]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationMaxColors]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationMaxColors]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2b4554894ff6f08064af567e53d3bf0582b4d4d15994d7e84338fa1644d37f5f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationMirror",
    jsii_struct_bases=[],
    name_mapping={
        "horizontal": "horizontal",
        "horizontal_var": "horizontalVar",
        "vertical": "vertical",
        "vertical_var": "verticalVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationMirror:
    def __init__(
        self,
        *,
        horizontal: typing.Optional[builtins.str] = None,
        horizontal_var: typing.Optional[builtins.str] = None,
        vertical: typing.Optional[builtins.str] = None,
        vertical_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param horizontal: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        :param horizontal_var: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        :param vertical: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        :param vertical_var: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__55f46db330f76223edc1d443580fce9def4b43e5f642409533762be1a2ede91e)
            check_type(argname="argument horizontal", value=horizontal, expected_type=type_hints["horizontal"])
            check_type(argname="argument horizontal_var", value=horizontal_var, expected_type=type_hints["horizontal_var"])
            check_type(argname="argument vertical", value=vertical, expected_type=type_hints["vertical"])
            check_type(argname="argument vertical_var", value=vertical_var, expected_type=type_hints["vertical_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if horizontal is not None:
            self._values["horizontal"] = horizontal
        if horizontal_var is not None:
            self._values["horizontal_var"] = horizontal_var
        if vertical is not None:
            self._values["vertical"] = vertical
        if vertical_var is not None:
            self._values["vertical_var"] = vertical_var

    @builtins.property
    def horizontal(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        '''
        result = self._values.get("horizontal")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def horizontal_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        '''
        result = self._values.get("horizontal_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        '''
        result = self._values.get("vertical")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        result = self._values.get("vertical_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationMirror(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationMirrorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationMirrorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b886194829ca9d301179258fa28e078a138d4e479e5870c448658fd261bb6845)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationMirrorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__495cd3da4ca41eeb076bc3b5e76073fc59392f7e8d4f996b0caba1df5bf6e99a)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationMirrorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e5671b5331f761a149297ae0a1ccf85a5cd33a18f4773801bad9e5b30c09fd1d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fcc1bdeadd1c40d08790f9f9f29d28c048ca62b6ad12529cef3e68afc2d1a453)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__423f5537a2e0b6a2119bfbd80857474a1c2493c2d000cbdd1a49bf1c46ff5489)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationMirror]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationMirror]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8661e9bb560050a876c2620958d4345964f29cc5df8f1c2f95eb91383f632d40)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationMirrorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationMirrorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0f20db82713304b98f3d25cff423b5b5cd0d218b3044d1c99ab195be82c5b837)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHorizontal")
    def reset_horizontal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontal", []))

    @jsii.member(jsii_name="resetHorizontalVar")
    def reset_horizontal_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontalVar", []))

    @jsii.member(jsii_name="resetVertical")
    def reset_vertical(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVertical", []))

    @jsii.member(jsii_name="resetVerticalVar")
    def reset_vertical_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVerticalVar", []))

    @builtins.property
    @jsii.member(jsii_name="horizontalInput")
    def horizontal_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontalVarInput")
    def horizontal_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalInput")
    def vertical_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalVarInput")
    def vertical_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontal")
    def horizontal(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontal"))

    @horizontal.setter
    def horizontal(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eb82ef875b91d847dd81c1e04c02338a2c076fb501f322f3ae0d6dd8c5d99d82)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontal", value)

    @builtins.property
    @jsii.member(jsii_name="horizontalVar")
    def horizontal_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontalVar"))

    @horizontal_var.setter
    def horizontal_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dfecf0a24317d92c54d2177d03a8fc1b1df51cc3545265b33bec9154f7bba428)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontalVar", value)

    @builtins.property
    @jsii.member(jsii_name="vertical")
    def vertical(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "vertical"))

    @vertical.setter
    def vertical(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8e14e5e5ce08e80d9212df96030d478eef7a53c38489f9820be3d9346358237c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "vertical", value)

    @builtins.property
    @jsii.member(jsii_name="verticalVar")
    def vertical_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "verticalVar"))

    @vertical_var.setter
    def vertical_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__508b910ce829574a13700ec12dace11a8455c27ed01f5b16362d5bbe0fc757a4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "verticalVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationMirror]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationMirror]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationMirror]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__003a3b1e89b1360fb167bfa11b23d56ffff1f58157b524f2f8cfc9bbb873c3fc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationMonoHue",
    jsii_struct_bases=[],
    name_mapping={"hue": "hue", "hue_var": "hueVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationMonoHue:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__92b1db63db4ccb1f2e0099e327668b96e7eccb128fe7a537e477c03acc7d2495)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationMonoHue(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationMonoHueList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationMonoHueList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__32adf7da82958c53a2f07104a5b6c431d2be7f0af0734ea0111664e57c6aadfa)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationMonoHueOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__03fa51a00a74d6dd0b006f9c74e0040a9ead5a817278d5899ce7f6d564d4465b)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationMonoHueOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9953e8533389d0720de6435f2fe31a0c97bce476586b6cc493e86f52d1093787)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__da19075e78f9c116048612a60d68a3c41e9c59b6be973bd7a693a0b3f24bce3c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4d14879d342f12bfd11d5cbaaae04f9ea33c0d64bea704e837988f5e57ad69ff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationMonoHue]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationMonoHue]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__82489f9f88f8fe2874992717cf02c00c4e4ea9cc4ab967ab405e029211c7cf8f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationMonoHueOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationMonoHueOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__40c022b4e7440a8bb7e0af33e1e6e26249f3dc1eb394c36d46724867b0a07049)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5debf2d62da4b8070924e9344e672cd2b6bc9d10856c77baaebc51a6da04756d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8ab954fbf1db6d9c2290198e49ec3bdf477c4e00fce0fe97aff4b291ef2d2d7f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationMonoHue]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationMonoHue]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationMonoHue]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc1ec93a29a346276422f512f2ddf5456f2ef5c1a5a5ae148725ceb986ffdffc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationOpacity",
    jsii_struct_bases=[],
    name_mapping={"opacity": "opacity", "opacity_var": "opacityVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationOpacity:
    def __init__(
        self,
        *,
        opacity: typing.Optional[builtins.str] = None,
        opacity_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param opacity: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param opacity_var: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6ee68c28326cfe98601f6f0dbef3715f61d9cb773434730d9ba3d81d5117c3a1)
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument opacity_var", value=opacity_var, expected_type=type_hints["opacity_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if opacity is not None:
            self._values["opacity"] = opacity
        if opacity_var is not None:
            self._values["opacity_var"] = opacity_var

    @builtins.property
    def opacity(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def opacity_var(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        result = self._values.get("opacity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationOpacity(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationOpacityList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationOpacityList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__23bc4515d7f2e287a187a265a21b1f6bf595c54dff08e45da7dc995edfe07bd2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationOpacityOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__72f878a060b20cc55868536c401fc2120654f2f35c881942f9641b48b244d050)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationOpacityOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fab666ad817e5d550efd239e05fc61ebfa06870b5289f85c351ae41d05e1f4d8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__65c6970e4f5c9997a0b392a1c7106e59d9405e74d22f1d9014ddea23867e3b32)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__74f68e90ff7e4d7c4c60a0eea21eecda809f3c99ddf6e1079d9ac2519c99165c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationOpacity]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationOpacity]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__323a393766e44f1aeec4064799e570ad28eb388bcc2babfae215b2427ae8536f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationOpacityOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationOpacityOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be1826e28fdfa41c83d04fe8c17401fcc537735608c654490804947ea3d93787)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetOpacityVar")
    def reset_opacity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacityVar", []))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityVarInput")
    def opacity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacity"))

    @opacity.setter
    def opacity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d9bc9c8028e4cdea183da5b8302ac6b24281777fef6f647ed509ed26eff8c4e3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacity", value)

    @builtins.property
    @jsii.member(jsii_name="opacityVar")
    def opacity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacityVar"))

    @opacity_var.setter
    def opacity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2fed5867fe26db40a3152d37234ff058f7e623cf56538e44045f630db934c69f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacityVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationOpacity]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationOpacity]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationOpacity]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c2677d00f5d0660758b5d1e0c1394ad9e10fc3a91e2f2815d4d3b96cb6bd842f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__42df00463af1c3656d83878a7bf035c22d4d8025b3a930a447ddfe5c634593ba)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putAppend")
    def put_append(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationAppend, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__28af8954f467138319a22b5b8e3dc4e70f4a9f6e0b8c36fec438c83fd5cdf7ee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putAppend", [value]))

    @jsii.member(jsii_name="putAspectCrop")
    def put_aspect_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationAspectCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__93bf1bebb87eb6ae19bf971f7e1f314b3ca4753862d814af7866a49d2aae4f02)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putAspectCrop", [value]))

    @jsii.member(jsii_name="putBackgroundColor")
    def put_background_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e57b2c1a20243f6b54e5138532325cb0e0251d57539270bede73e9bbb5188aac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBackgroundColor", [value]))

    @jsii.member(jsii_name="putBlur")
    def put_blur(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationBlur, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b6ee9393456dc12716484bd084faaa99b0127d5e41b9e8535c66b87639ca1cc0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBlur", [value]))

    @jsii.member(jsii_name="putChromaKey")
    def put_chroma_key(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationChromaKey, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__778f3fd7d1b78b90c28aaf00b31459db0321aac77648aa420f8c0bc7aa7551b8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putChromaKey", [value]))

    @jsii.member(jsii_name="putComposite")
    def put_composite(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationComposite, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e9752e836a67132f01752f4b18d6490435e713f6b2698c941819fa5813108ebb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putComposite", [value]))

    @jsii.member(jsii_name="putCompound")
    def put_compound(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationCompound, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5cef6bcd61f404e751147ed5cbd949761f639bdcca083407b8caac3b4bccbd00)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCompound", [value]))

    @jsii.member(jsii_name="putContrast")
    def put_contrast(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationContrast, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a35c74d0aff7c6c59694a6abecdcbd7209fb4c2df73bc9ebbc6c65d412bac255)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putContrast", [value]))

    @jsii.member(jsii_name="putCrop")
    def put_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8dcc09b30640eb577d1ced7b3725b66b61de14a3399be6c0ef3473971ee8beee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCrop", [value]))

    @jsii.member(jsii_name="putFaceCrop")
    def put_face_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationFaceCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa05d853568f6e52d0bdf7cc1f0bf01f0cd2f6f2e7a147ba5282e46de19b7766)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFaceCrop", [value]))

    @jsii.member(jsii_name="putFeatureCrop")
    def put_feature_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationFeatureCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__08dd1f8178910b7fb9c78770a50db84edd2e8db2d2d4932a3742081941f1ac60)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFeatureCrop", [value]))

    @jsii.member(jsii_name="putFitAndFill")
    def put_fit_and_fill(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationFitAndFill, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__45d480eb07189f0d78656a4ae03f164e5b44940b533ccb64bca57b688915b102)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFitAndFill", [value]))

    @jsii.member(jsii_name="putGoop")
    def put_goop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationGoop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d3da9678351d307e319c3dff95fb0d895a05931904495d39fbce7158bc613d0b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGoop", [value]))

    @jsii.member(jsii_name="putGrayscale")
    def put_grayscale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationGrayscale, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a8a037e4752f5012911e918f6d7eb2fc7ccac483b6ff943ba0845f83f667bae7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGrayscale", [value]))

    @jsii.member(jsii_name="putHsl")
    def put_hsl(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationHsl, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bbbbc0e689a43fa30816978855978d122c955300297ad66f1d1932e0b7c3c939)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsl", [value]))

    @jsii.member(jsii_name="putHsv")
    def put_hsv(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationHsv, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fc9733086c7b3bba6f85f9cef968baed77a3c7db4860a4f080974b617c5067d1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsv", [value]))

    @jsii.member(jsii_name="putIfDimension")
    def put_if_dimension(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfDimension, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5c9a617911e7f6d85b2cec43a277c4c68e7af49cae76fb09bdf677c8d6afcbc5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfDimension", [value]))

    @jsii.member(jsii_name="putIfOrientation")
    def put_if_orientation(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ddefd0b6fad09f6fdc3bd5934dabfdc99b9cffa3d3be393e7626603e1909e208)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfOrientation", [value]))

    @jsii.member(jsii_name="putImQuery")
    def put_im_query(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationImQuery, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c5183142c68702e1e3651f1f18860e370a9abad6e25f98ad22662bf926152c7b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putImQuery", [value]))

    @jsii.member(jsii_name="putMaxColors")
    def put_max_colors(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationMaxColors, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__902b226479b145211f42c0307738160a26cb06db0d52856fb1b635382be6b82f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMaxColors", [value]))

    @jsii.member(jsii_name="putMirror")
    def put_mirror(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationMirror, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__57c689ac82d1a3eaa5d5da1fbbe2edd8c51dcaef8b9269838429dd5f5d7ec8db)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMirror", [value]))

    @jsii.member(jsii_name="putMonoHue")
    def put_mono_hue(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationMonoHue, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__71ef6035d52abb718dc9f04f83ada67746a022515cf34c94e61104e94d52091b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMonoHue", [value]))

    @jsii.member(jsii_name="putOpacity")
    def put_opacity(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationOpacity, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__91a26eaac34f40b2d75d24bf6a50a5d747a5f025c1f2dd5a2b990a69ef9a49bd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putOpacity", [value]))

    @jsii.member(jsii_name="putRegionOfInterestCrop")
    def put_region_of_interest_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationRegionOfInterestCrop", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c01699537fc379138092bfbd33c19712248e9e30dddc4295a815d3a359438eae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRegionOfInterestCrop", [value]))

    @jsii.member(jsii_name="putRelativeCrop")
    def put_relative_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationRelativeCrop", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__126e3a0aaca97e73ab303d55129f699aca18fe3d42f54a803fdca90a216d463f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRelativeCrop", [value]))

    @jsii.member(jsii_name="putRemoveColor")
    def put_remove_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationRemoveColor", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bfb30ebcd5766a023c7f28db3ffe2d1eba2777ed8abe34fd06017d6998451d40)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRemoveColor", [value]))

    @jsii.member(jsii_name="putResize")
    def put_resize(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationResize", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2deda08f1335bcc5f05c395d39c39e69fce4bfb8f29a03c829bcd4be5dbb66c7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putResize", [value]))

    @jsii.member(jsii_name="putRotate")
    def put_rotate(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationRotate", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7e9f4483c1753fd7856b87bb80a91d3fd292fe147ff72865211814a73ee75439)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRotate", [value]))

    @jsii.member(jsii_name="putScale")
    def put_scale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationScale", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__76c4050ede48c3ff3c3d463132295d847d6eb7666a38fc8cfa4a83dd813ce38e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putScale", [value]))

    @jsii.member(jsii_name="putShear")
    def put_shear(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationShear", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__59332129780e45799e4d4b0f8e8388e5ecd2e81082c21e86c52f4240c9f150b2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putShear", [value]))

    @jsii.member(jsii_name="putTrim")
    def put_trim(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationTrim", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1da03bd0551ee50403e0ccfca39be359fb472a595386f8f593526439b04077ce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTrim", [value]))

    @jsii.member(jsii_name="putUnsharpMask")
    def put_unsharp_mask(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationUnsharpMask", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b1230e91126e9ebad79d323f90184151174a515bf6238ce0324a954395567cc1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putUnsharpMask", [value]))

    @jsii.member(jsii_name="resetAppend")
    def reset_append(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAppend", []))

    @jsii.member(jsii_name="resetAspectCrop")
    def reset_aspect_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspectCrop", []))

    @jsii.member(jsii_name="resetBackgroundColor")
    def reset_background_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBackgroundColor", []))

    @jsii.member(jsii_name="resetBlur")
    def reset_blur(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBlur", []))

    @jsii.member(jsii_name="resetChromaKey")
    def reset_chroma_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChromaKey", []))

    @jsii.member(jsii_name="resetComposite")
    def reset_composite(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetComposite", []))

    @jsii.member(jsii_name="resetCompound")
    def reset_compound(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCompound", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetCrop")
    def reset_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCrop", []))

    @jsii.member(jsii_name="resetFaceCrop")
    def reset_face_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFaceCrop", []))

    @jsii.member(jsii_name="resetFeatureCrop")
    def reset_feature_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureCrop", []))

    @jsii.member(jsii_name="resetFitAndFill")
    def reset_fit_and_fill(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFitAndFill", []))

    @jsii.member(jsii_name="resetGoop")
    def reset_goop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGoop", []))

    @jsii.member(jsii_name="resetGrayscale")
    def reset_grayscale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGrayscale", []))

    @jsii.member(jsii_name="resetHsl")
    def reset_hsl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsl", []))

    @jsii.member(jsii_name="resetHsv")
    def reset_hsv(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsv", []))

    @jsii.member(jsii_name="resetIfDimension")
    def reset_if_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfDimension", []))

    @jsii.member(jsii_name="resetIfOrientation")
    def reset_if_orientation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfOrientation", []))

    @jsii.member(jsii_name="resetImQuery")
    def reset_im_query(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetImQuery", []))

    @jsii.member(jsii_name="resetMaxColors")
    def reset_max_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxColors", []))

    @jsii.member(jsii_name="resetMirror")
    def reset_mirror(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMirror", []))

    @jsii.member(jsii_name="resetMonoHue")
    def reset_mono_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonoHue", []))

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetRegionOfInterestCrop")
    def reset_region_of_interest_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRegionOfInterestCrop", []))

    @jsii.member(jsii_name="resetRelativeCrop")
    def reset_relative_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRelativeCrop", []))

    @jsii.member(jsii_name="resetRemoveColor")
    def reset_remove_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRemoveColor", []))

    @jsii.member(jsii_name="resetResize")
    def reset_resize(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetResize", []))

    @jsii.member(jsii_name="resetRotate")
    def reset_rotate(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRotate", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetShear")
    def reset_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetShear", []))

    @jsii.member(jsii_name="resetTrim")
    def reset_trim(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTrim", []))

    @jsii.member(jsii_name="resetUnsharpMask")
    def reset_unsharp_mask(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUnsharpMask", []))

    @builtins.property
    @jsii.member(jsii_name="append")
    def append(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationAppendList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationAppendList, jsii.get(self, "append"))

    @builtins.property
    @jsii.member(jsii_name="aspectCrop")
    def aspect_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationAspectCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationAspectCropList, jsii.get(self, "aspectCrop"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColor")
    def background_color(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationBackgroundColorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationBackgroundColorList, jsii.get(self, "backgroundColor"))

    @builtins.property
    @jsii.member(jsii_name="blur")
    def blur(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationBlurList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationBlurList, jsii.get(self, "blur"))

    @builtins.property
    @jsii.member(jsii_name="chromaKey")
    def chroma_key(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationChromaKeyList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationChromaKeyList, jsii.get(self, "chromaKey"))

    @builtins.property
    @jsii.member(jsii_name="composite")
    def composite(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationCompositeList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationCompositeList, jsii.get(self, "composite"))

    @builtins.property
    @jsii.member(jsii_name="compound")
    def compound(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationCompoundList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationCompoundList, jsii.get(self, "compound"))

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationContrastList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationContrastList, jsii.get(self, "contrast"))

    @builtins.property
    @jsii.member(jsii_name="crop")
    def crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationCropList, jsii.get(self, "crop"))

    @builtins.property
    @jsii.member(jsii_name="faceCrop")
    def face_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationFaceCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationFaceCropList, jsii.get(self, "faceCrop"))

    @builtins.property
    @jsii.member(jsii_name="featureCrop")
    def feature_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationFeatureCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationFeatureCropList, jsii.get(self, "featureCrop"))

    @builtins.property
    @jsii.member(jsii_name="fitAndFill")
    def fit_and_fill(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationFitAndFillList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationFitAndFillList, jsii.get(self, "fitAndFill"))

    @builtins.property
    @jsii.member(jsii_name="goop")
    def goop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationGoopList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationGoopList, jsii.get(self, "goop"))

    @builtins.property
    @jsii.member(jsii_name="grayscale")
    def grayscale(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationGrayscaleList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationGrayscaleList, jsii.get(self, "grayscale"))

    @builtins.property
    @jsii.member(jsii_name="hsl")
    def hsl(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationHslList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationHslList, jsii.get(self, "hsl"))

    @builtins.property
    @jsii.member(jsii_name="hsv")
    def hsv(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationHsvList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationHsvList, jsii.get(self, "hsv"))

    @builtins.property
    @jsii.member(jsii_name="ifDimension")
    def if_dimension(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfDimensionList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfDimensionList, jsii.get(self, "ifDimension"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientation")
    def if_orientation(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfOrientationList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfOrientationList, jsii.get(self, "ifOrientation"))

    @builtins.property
    @jsii.member(jsii_name="imQuery")
    def im_query(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationImQueryList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationImQueryList, jsii.get(self, "imQuery"))

    @builtins.property
    @jsii.member(jsii_name="maxColors")
    def max_colors(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationMaxColorsList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationMaxColorsList, jsii.get(self, "maxColors"))

    @builtins.property
    @jsii.member(jsii_name="mirror")
    def mirror(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationMirrorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationMirrorList, jsii.get(self, "mirror"))

    @builtins.property
    @jsii.member(jsii_name="monoHue")
    def mono_hue(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationMonoHueList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationMonoHueList, jsii.get(self, "monoHue"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationOpacityList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationOpacityList, jsii.get(self, "opacity"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestCrop")
    def region_of_interest_crop(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationRegionOfInterestCropList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationRegionOfInterestCropList", jsii.get(self, "regionOfInterestCrop"))

    @builtins.property
    @jsii.member(jsii_name="relativeCrop")
    def relative_crop(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationRelativeCropList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationRelativeCropList", jsii.get(self, "relativeCrop"))

    @builtins.property
    @jsii.member(jsii_name="removeColor")
    def remove_color(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationRemoveColorList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationRemoveColorList", jsii.get(self, "removeColor"))

    @builtins.property
    @jsii.member(jsii_name="resize")
    def resize(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationResizeList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationResizeList", jsii.get(self, "resize"))

    @builtins.property
    @jsii.member(jsii_name="rotate")
    def rotate(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationRotateList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationRotateList", jsii.get(self, "rotate"))

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationScaleList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationScaleList", jsii.get(self, "scale"))

    @builtins.property
    @jsii.member(jsii_name="shear")
    def shear(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationShearList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationShearList", jsii.get(self, "shear"))

    @builtins.property
    @jsii.member(jsii_name="trim")
    def trim(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationTrimList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationTrimList", jsii.get(self, "trim"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMask")
    def unsharp_mask(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationUnsharpMaskList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationUnsharpMaskList", jsii.get(self, "unsharpMask"))

    @builtins.property
    @jsii.member(jsii_name="appendInput")
    def append_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationAppend]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationAppend]]], jsii.get(self, "appendInput"))

    @builtins.property
    @jsii.member(jsii_name="aspectCropInput")
    def aspect_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationAspectCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationAspectCrop]]], jsii.get(self, "aspectCropInput"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColorInput")
    def background_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationBackgroundColor]]], jsii.get(self, "backgroundColorInput"))

    @builtins.property
    @jsii.member(jsii_name="blurInput")
    def blur_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationBlur]]], jsii.get(self, "blurInput"))

    @builtins.property
    @jsii.member(jsii_name="chromaKeyInput")
    def chroma_key_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationChromaKey]]], jsii.get(self, "chromaKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="compositeInput")
    def composite_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationComposite]]], jsii.get(self, "compositeInput"))

    @builtins.property
    @jsii.member(jsii_name="compoundInput")
    def compound_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationCompound]]], jsii.get(self, "compoundInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationContrast]]], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="cropInput")
    def crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationCrop]]], jsii.get(self, "cropInput"))

    @builtins.property
    @jsii.member(jsii_name="faceCropInput")
    def face_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationFaceCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationFaceCrop]]], jsii.get(self, "faceCropInput"))

    @builtins.property
    @jsii.member(jsii_name="featureCropInput")
    def feature_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationFeatureCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationFeatureCrop]]], jsii.get(self, "featureCropInput"))

    @builtins.property
    @jsii.member(jsii_name="fitAndFillInput")
    def fit_and_fill_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationFitAndFill]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationFitAndFill]]], jsii.get(self, "fitAndFillInput"))

    @builtins.property
    @jsii.member(jsii_name="goopInput")
    def goop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationGoop]]], jsii.get(self, "goopInput"))

    @builtins.property
    @jsii.member(jsii_name="grayscaleInput")
    def grayscale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationGrayscale]]], jsii.get(self, "grayscaleInput"))

    @builtins.property
    @jsii.member(jsii_name="hslInput")
    def hsl_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationHsl]]], jsii.get(self, "hslInput"))

    @builtins.property
    @jsii.member(jsii_name="hsvInput")
    def hsv_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationHsv]]], jsii.get(self, "hsvInput"))

    @builtins.property
    @jsii.member(jsii_name="ifDimensionInput")
    def if_dimension_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfDimension]]], jsii.get(self, "ifDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientationInput")
    def if_orientation_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfOrientation]]], jsii.get(self, "ifOrientationInput"))

    @builtins.property
    @jsii.member(jsii_name="imQueryInput")
    def im_query_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationImQuery]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationImQuery]]], jsii.get(self, "imQueryInput"))

    @builtins.property
    @jsii.member(jsii_name="maxColorsInput")
    def max_colors_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationMaxColors]]], jsii.get(self, "maxColorsInput"))

    @builtins.property
    @jsii.member(jsii_name="mirrorInput")
    def mirror_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationMirror]]], jsii.get(self, "mirrorInput"))

    @builtins.property
    @jsii.member(jsii_name="monoHueInput")
    def mono_hue_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationMonoHue]]], jsii.get(self, "monoHueInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationOpacity]]], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestCropInput")
    def region_of_interest_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationRegionOfInterestCrop"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationRegionOfInterestCrop"]]], jsii.get(self, "regionOfInterestCropInput"))

    @builtins.property
    @jsii.member(jsii_name="relativeCropInput")
    def relative_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationRelativeCrop"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationRelativeCrop"]]], jsii.get(self, "relativeCropInput"))

    @builtins.property
    @jsii.member(jsii_name="removeColorInput")
    def remove_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationRemoveColor"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationRemoveColor"]]], jsii.get(self, "removeColorInput"))

    @builtins.property
    @jsii.member(jsii_name="resizeInput")
    def resize_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationResize"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationResize"]]], jsii.get(self, "resizeInput"))

    @builtins.property
    @jsii.member(jsii_name="rotateInput")
    def rotate_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationRotate"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationRotate"]]], jsii.get(self, "rotateInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationScale"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationScale"]]], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="shearInput")
    def shear_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationShear"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationShear"]]], jsii.get(self, "shearInput"))

    @builtins.property
    @jsii.member(jsii_name="trimInput")
    def trim_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationTrim"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationTrim"]]], jsii.get(self, "trimInput"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMaskInput")
    def unsharp_mask_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationUnsharpMask"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationUnsharpMask"]]], jsii.get(self, "unsharpMaskInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__43618d05e7b3c612be507675fb0427490a9825460c67027270e1c399c4c69ca0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationRegionOfInterestCrop",
    jsii_struct_bases=[],
    name_mapping={
        "region_of_interest": "regionOfInterest",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationRegionOfInterestCrop:
    def __init__(
        self,
        *,
        region_of_interest: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationRegionOfInterestCropRegionOfInterest", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param region_of_interest: region_of_interest block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest DataAkamaiImagingPolicyImage#region_of_interest}
        :param gravity: The placement of the crop area relative to the specified area of interest. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: The placement of the crop area relative to the specified area of interest. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param style: Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(region_of_interest, dict):
            region_of_interest = DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationRegionOfInterestCropRegionOfInterest(**region_of_interest)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aa668e5665bb0687b08019b571d05cd4c6df2e28d20aa6756b84915e8799a13e)
            check_type(argname="argument region_of_interest", value=region_of_interest, expected_type=type_hints["region_of_interest"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "region_of_interest": region_of_interest,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def region_of_interest(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationRegionOfInterestCropRegionOfInterest":
        '''region_of_interest block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest DataAkamaiImagingPolicyImage#region_of_interest}
        '''
        result = self._values.get("region_of_interest")
        assert result is not None, "Required property 'region_of_interest' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationRegionOfInterestCropRegionOfInterest", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''The placement of the crop area relative to the specified area of interest.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''The placement of the crop area relative to the specified area of interest.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationRegionOfInterestCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationRegionOfInterestCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationRegionOfInterestCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fcc5059e084fd6e9e505424ff4d5e3f418d83650d6a150eba222ef5e398e1b07)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationRegionOfInterestCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3b39fd234aad4ba0392dd6079c744a2790ba64af6eb285368c711883e97b9a38)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationRegionOfInterestCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__540bbf1cf1895b9a7346ebe35f01f3c4f9e7fc0c5e09dfa8bc7fec1a0090f102)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__643a4898ca7919160386d271dcb31b0a6d61531f46969794adb14a5cb101d79e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6a42bdeed477a53e6fc5300ba604691c1aa3031180c6ac985e8c00706b150a50)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationRegionOfInterestCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationRegionOfInterestCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationRegionOfInterestCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bff5b37a3cf9dc757762e0a628ba3bb7601e2898e2c44d86c123e61661827f03)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationRegionOfInterestCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationRegionOfInterestCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ae0072d1f7da5cfb79b79f4a4f528f372248229629d5a75fae276a3ee3c1096b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putRegionOfInterest")
    def put_region_of_interest(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationRegionOfInterestCropRegionOfInterest()

        return typing.cast(None, jsii.invoke(self, "putRegionOfInterest", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterest")
    def region_of_interest(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationRegionOfInterestCropRegionOfInterestOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationRegionOfInterestCropRegionOfInterestOutputReference", jsii.get(self, "regionOfInterest"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestInput")
    def region_of_interest_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationRegionOfInterestCropRegionOfInterest"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationRegionOfInterestCropRegionOfInterest"], jsii.get(self, "regionOfInterestInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8c3627bb97a36c1053a77813019522311fe64f835ab654b5b45914ad6e2aaa31)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__621f035390b05972dc7f08c5f408159d6a5d707d7c5779eb2d28a20cd552a3a3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__55f58cc66d37a118d64bc5bd666dd6842f060bfc12693b5396d04b86a9fe3bf2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__667444534c24ebdb8ed3606ddc599a073e8598e9e1df91268bdc8c8c0810437b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a0fd549bd8e26abb5b48511abd0c8107885621b6022f315eb823497bc16455dd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__15b90f4e2062fc5ed02ad39fc7411b488e52c2869ac40415365cc637202ab6b2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__efc5de8eefc10ef886e6710e9fa1cfc20cb654115b3536711fb506ea01f13b35)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cc7252cdbd0ff12528d7fd0e20337b73dccde4d1bfad0b641733095fc2de20f3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationRegionOfInterestCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationRegionOfInterestCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationRegionOfInterestCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a0fa4bd84ca5a5c8b2b570b6fe8466141fd5b91e8bab238a944293a79d41eddb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationRegionOfInterestCropRegionOfInterest",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationRegionOfInterestCropRegionOfInterest:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationRegionOfInterestCropRegionOfInterest(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationRegionOfInterestCropRegionOfInterestOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationRegionOfInterestCropRegionOfInterestOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f68e0fcce973094ac892fec8934c9fd086df3e7955a222c5663d598b49db760)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationRegionOfInterestCropRegionOfInterest]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationRegionOfInterestCropRegionOfInterest], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationRegionOfInterestCropRegionOfInterest],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5a2a2b2b82fe26717a676d21e0ba734f2a418446ab25aa2fafa03a5844e53c4e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationRelativeCrop",
    jsii_struct_bases=[],
    name_mapping={
        "east": "east",
        "east_var": "eastVar",
        "north": "north",
        "north_var": "northVar",
        "south": "south",
        "south_var": "southVar",
        "west": "west",
        "west_var": "westVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationRelativeCrop:
    def __init__(
        self,
        *,
        east: typing.Optional[builtins.str] = None,
        east_var: typing.Optional[builtins.str] = None,
        north: typing.Optional[builtins.str] = None,
        north_var: typing.Optional[builtins.str] = None,
        south: typing.Optional[builtins.str] = None,
        south_var: typing.Optional[builtins.str] = None,
        west: typing.Optional[builtins.str] = None,
        west_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param east: The number of pixels to shrink or expand the right side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east DataAkamaiImagingPolicyImage#east}
        :param east_var: The number of pixels to shrink or expand the right side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east_var DataAkamaiImagingPolicyImage#east_var}
        :param north: The number of pixels to shrink or expand the top side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north DataAkamaiImagingPolicyImage#north}
        :param north_var: The number of pixels to shrink or expand the top side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north_var DataAkamaiImagingPolicyImage#north_var}
        :param south: The number of pixels to shrink or expand the bottom side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south DataAkamaiImagingPolicyImage#south}
        :param south_var: The number of pixels to shrink or expand the bottom side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south_var DataAkamaiImagingPolicyImage#south_var}
        :param west: The number of pixels to shrink or expand the left side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west DataAkamaiImagingPolicyImage#west}
        :param west_var: The number of pixels to shrink or expand the left side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west_var DataAkamaiImagingPolicyImage#west_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__35f91d769af71843725ed8af3a32f486918f3c4e0d386aaaa989494e79a456c6)
            check_type(argname="argument east", value=east, expected_type=type_hints["east"])
            check_type(argname="argument east_var", value=east_var, expected_type=type_hints["east_var"])
            check_type(argname="argument north", value=north, expected_type=type_hints["north"])
            check_type(argname="argument north_var", value=north_var, expected_type=type_hints["north_var"])
            check_type(argname="argument south", value=south, expected_type=type_hints["south"])
            check_type(argname="argument south_var", value=south_var, expected_type=type_hints["south_var"])
            check_type(argname="argument west", value=west, expected_type=type_hints["west"])
            check_type(argname="argument west_var", value=west_var, expected_type=type_hints["west_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if east is not None:
            self._values["east"] = east
        if east_var is not None:
            self._values["east_var"] = east_var
        if north is not None:
            self._values["north"] = north
        if north_var is not None:
            self._values["north_var"] = north_var
        if south is not None:
            self._values["south"] = south
        if south_var is not None:
            self._values["south_var"] = south_var
        if west is not None:
            self._values["west"] = west
        if west_var is not None:
            self._values["west_var"] = west_var

    @builtins.property
    def east(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the right side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east DataAkamaiImagingPolicyImage#east}
        '''
        result = self._values.get("east")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def east_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the right side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east_var DataAkamaiImagingPolicyImage#east_var}
        '''
        result = self._values.get("east_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def north(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the top side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north DataAkamaiImagingPolicyImage#north}
        '''
        result = self._values.get("north")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def north_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the top side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north_var DataAkamaiImagingPolicyImage#north_var}
        '''
        result = self._values.get("north_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def south(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the bottom side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south DataAkamaiImagingPolicyImage#south}
        '''
        result = self._values.get("south")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def south_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the bottom side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south_var DataAkamaiImagingPolicyImage#south_var}
        '''
        result = self._values.get("south_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def west(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the left side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west DataAkamaiImagingPolicyImage#west}
        '''
        result = self._values.get("west")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def west_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the left side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west_var DataAkamaiImagingPolicyImage#west_var}
        '''
        result = self._values.get("west_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationRelativeCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationRelativeCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationRelativeCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ae7c665af977223c71d5b8f5f2c9de51d9883416dcda195b998bdf8fbc882c9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationRelativeCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ced21acfa3af9d8bea6754a532a48b0c3839a7164ac03d473aa6c42eaaad885)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationRelativeCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__23bb611bccd2bfb179cf51bae73f1bcf85748c485ada10281e82a4a6c793dcfc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0f133ddc4cf494ec07424a61457e8a8af5972aa97fe4df515347705028f60f34)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2767c49d09d59880ca61ad44ad97a8d9b94a5404dc16ac465ae55c87f51439a6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationRelativeCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationRelativeCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationRelativeCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c25f2b33d6d4493bfbfd6a68cafbab1e3dd445f3c74699a660ea7ceb08eea45c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationRelativeCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationRelativeCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2991ba004f51406c716f0d3d51ea0a0dbdc10aabd2c95dbc4d46f70a473f5e58)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetEast")
    def reset_east(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEast", []))

    @jsii.member(jsii_name="resetEastVar")
    def reset_east_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEastVar", []))

    @jsii.member(jsii_name="resetNorth")
    def reset_north(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNorth", []))

    @jsii.member(jsii_name="resetNorthVar")
    def reset_north_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNorthVar", []))

    @jsii.member(jsii_name="resetSouth")
    def reset_south(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSouth", []))

    @jsii.member(jsii_name="resetSouthVar")
    def reset_south_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSouthVar", []))

    @jsii.member(jsii_name="resetWest")
    def reset_west(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWest", []))

    @jsii.member(jsii_name="resetWestVar")
    def reset_west_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWestVar", []))

    @builtins.property
    @jsii.member(jsii_name="eastInput")
    def east_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "eastInput"))

    @builtins.property
    @jsii.member(jsii_name="eastVarInput")
    def east_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "eastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="northInput")
    def north_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "northInput"))

    @builtins.property
    @jsii.member(jsii_name="northVarInput")
    def north_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "northVarInput"))

    @builtins.property
    @jsii.member(jsii_name="southInput")
    def south_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "southInput"))

    @builtins.property
    @jsii.member(jsii_name="southVarInput")
    def south_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "southVarInput"))

    @builtins.property
    @jsii.member(jsii_name="westInput")
    def west_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "westInput"))

    @builtins.property
    @jsii.member(jsii_name="westVarInput")
    def west_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "westVarInput"))

    @builtins.property
    @jsii.member(jsii_name="east")
    def east(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "east"))

    @east.setter
    def east(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a43f8c60b78d98ba4865bd80d7c8e0d5826bd79efac3bb92eb7bd72bfde23dad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "east", value)

    @builtins.property
    @jsii.member(jsii_name="eastVar")
    def east_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "eastVar"))

    @east_var.setter
    def east_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dbea39c7fdff8f94f3a8c30c0e25ed68bf1bae48c656fc9e12640d3c217c394f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "eastVar", value)

    @builtins.property
    @jsii.member(jsii_name="north")
    def north(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "north"))

    @north.setter
    def north(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d21a26aafda96a49696738f199e18321aa647d920d7748dc6e4afb74fe896a36)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "north", value)

    @builtins.property
    @jsii.member(jsii_name="northVar")
    def north_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "northVar"))

    @north_var.setter
    def north_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c285280fc6559cf10cf16d976c1e83c9cff95602df6da0c365da0f2939975a9c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "northVar", value)

    @builtins.property
    @jsii.member(jsii_name="south")
    def south(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "south"))

    @south.setter
    def south(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a4ceb7770c9c4ce0167561edb803fc0531528fbe330b5dc134eb165a9eb504d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "south", value)

    @builtins.property
    @jsii.member(jsii_name="southVar")
    def south_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "southVar"))

    @south_var.setter
    def south_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1161e0f2b6969e77618c737e27eeae04ceccf61f61fc21d4b40aab147529480e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "southVar", value)

    @builtins.property
    @jsii.member(jsii_name="west")
    def west(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "west"))

    @west.setter
    def west(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ac47b50f9336bb3e945392625925f9d7411ab42990a93e803cef7b9f5a53a72)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "west", value)

    @builtins.property
    @jsii.member(jsii_name="westVar")
    def west_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "westVar"))

    @west_var.setter
    def west_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__568c239b19800f07216d29359067802fc5c6d6db730abbd90a22e23364940cad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "westVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationRelativeCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationRelativeCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationRelativeCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2465f57f98514c369d3b1665c6ecd1f1f647f39882b54e26a5ba2b20f3a71c3c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationRemoveColor",
    jsii_struct_bases=[],
    name_mapping={
        "color": "color",
        "color_var": "colorVar",
        "feather": "feather",
        "feather_var": "featherVar",
        "tolerance": "tolerance",
        "tolerance_var": "toleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationRemoveColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
        feather: typing.Optional[builtins.str] = None,
        feather_var: typing.Optional[builtins.str] = None,
        tolerance: typing.Optional[builtins.str] = None,
        tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        :param feather: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        :param feather_var: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        :param tolerance: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        :param tolerance_var: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f90bb90ed166a351a2090da7d61d87e6e4ba7dc34102257720ccbc0a5279db95)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
            check_type(argname="argument feather", value=feather, expected_type=type_hints["feather"])
            check_type(argname="argument feather_var", value=feather_var, expected_type=type_hints["feather_var"])
            check_type(argname="argument tolerance", value=tolerance, expected_type=type_hints["tolerance"])
            check_type(argname="argument tolerance_var", value=tolerance_var, expected_type=type_hints["tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var
        if feather is not None:
            self._values["feather"] = feather
        if feather_var is not None:
            self._values["feather_var"] = feather_var
        if tolerance is not None:
            self._values["tolerance"] = tolerance
        if tolerance_var is not None:
            self._values["tolerance_var"] = tolerance_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        '''
        result = self._values.get("feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather_var(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        '''
        result = self._values.get("feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        '''
        result = self._values.get("tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance_var(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        result = self._values.get("tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationRemoveColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationRemoveColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationRemoveColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5edcf7caefce271126358839c140dd58f4a84deba7388bee3c42858a50d3dd84)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationRemoveColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__974939e85968c455e4625771486fc39b6c033bc7f2be2f018ec8411ed6ea94b4)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationRemoveColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8b111b1aa78f59d52c8f58364986311991b51dcb026dc2261606e021414f699c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a5dcb7f3a130958c4ac48858dd6f12b047ed894aa667ed52f4f2ac6a4addb9c0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__61decd8b44720db4c44f5a05c9baa16a481effbd67772f75061d25cd39c6cfe8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationRemoveColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationRemoveColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationRemoveColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e953491684b54d034d059cfbcd1d1f346204fef7aac3aa3b855be6293fd25786)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationRemoveColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationRemoveColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e305d5bbd103d76f1ae1ebb2349312a1faf3832152616dc8a1465f41d3136d9a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @jsii.member(jsii_name="resetFeather")
    def reset_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeather", []))

    @jsii.member(jsii_name="resetFeatherVar")
    def reset_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatherVar", []))

    @jsii.member(jsii_name="resetTolerance")
    def reset_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTolerance", []))

    @jsii.member(jsii_name="resetToleranceVar")
    def reset_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featherInput")
    def feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherInput"))

    @builtins.property
    @jsii.member(jsii_name="featherVarInput")
    def feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceInput")
    def tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceVarInput")
    def tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__674c413f0ef443698f4d9632f8a9ffea2eb4e13cf725c04ce33fb1acc72c5863)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ec2a36aaa7bc8163d9dd1f098e620754b935101a45d7947b2395d1ea041170a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="feather")
    def feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "feather"))

    @feather.setter
    def feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__48b19717dfc183065fd7ff591aa0c97a5a09688a94950574f00e1cb91deed4c7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "feather", value)

    @builtins.property
    @jsii.member(jsii_name="featherVar")
    def feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featherVar"))

    @feather_var.setter
    def feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e1b02ecfa7edbb2d6ec36ae0c1f91bfbc250781718f5762410b0e3230cee4bb7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featherVar", value)

    @builtins.property
    @jsii.member(jsii_name="tolerance")
    def tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tolerance"))

    @tolerance.setter
    def tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ac4ab70a090f46300b7a4760c43fb1c88906d26b050e4c40e2ca34cc92bf1a6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tolerance", value)

    @builtins.property
    @jsii.member(jsii_name="toleranceVar")
    def tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "toleranceVar"))

    @tolerance_var.setter
    def tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a4294f2c465f93c56ba35c0fcda563f8c9d8989809a960c0f00e03269d56285)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "toleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationRemoveColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationRemoveColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationRemoveColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0a06aa745f3f13376c1d7c700dc7fcb61e5e6c63c0ee74adf5655138d4481716)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationResize",
    jsii_struct_bases=[],
    name_mapping={
        "aspect": "aspect",
        "aspect_var": "aspectVar",
        "height": "height",
        "height_var": "heightVar",
        "type": "type",
        "type_var": "typeVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationResize:
    def __init__(
        self,
        *,
        aspect: typing.Optional[builtins.str] = None,
        aspect_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param aspect: Preserves the aspect ratio. Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect DataAkamaiImagingPolicyImage#aspect}
        :param aspect_var: Preserves the aspect ratio. Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_var DataAkamaiImagingPolicyImage#aspect_var}
        :param height: The height to resize the source image to. Must be set if height is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height to resize the source image to. Must be set if height is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param type: Sets constraints for the image resize. Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: Sets constraints for the image resize. Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        :param width: The width to resize the source image to. Must be set if width is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width to resize the source image to. Must be set if width is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__65534ebffc06c71c7d12c3a697be3417b818ebb7a3c4e02e0a0e5fe6b90143f3)
            check_type(argname="argument aspect", value=aspect, expected_type=type_hints["aspect"])
            check_type(argname="argument aspect_var", value=aspect_var, expected_type=type_hints["aspect_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if aspect is not None:
            self._values["aspect"] = aspect
        if aspect_var is not None:
            self._values["aspect_var"] = aspect_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def aspect(self) -> typing.Optional[builtins.str]:
        '''Preserves the aspect ratio.

        Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect DataAkamaiImagingPolicyImage#aspect}
        '''
        result = self._values.get("aspect")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def aspect_var(self) -> typing.Optional[builtins.str]:
        '''Preserves the aspect ratio.

        Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_var DataAkamaiImagingPolicyImage#aspect_var}
        '''
        result = self._values.get("aspect_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height to resize the source image to. Must be set if height is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height to resize the source image to. Must be set if height is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''Sets constraints for the image resize.

        Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''Sets constraints for the image resize.

        Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width to resize the source image to. Must be set if width is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width to resize the source image to. Must be set if width is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationResize(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationResizeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationResizeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__51bc12ac7d4669828524bf659ef0be62f66477932c9784c83cf6d31706004ab9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationResizeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a21d60da17989610ff5cdb5b6e91baf9ef992e56c287d11b825980bf4748cdf4)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationResizeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac96fb0f4eda33a9b1b30db00ac22b7696a3b1aa617c4648bbc5dec48057c384)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7971b14c2697aabbfd0b9aabba4bfe1eff0fe0b6f78d82def73ec5ae6b9124dd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1db52251ab83152bbbfd68b9dc48b78627169b38f68ca9f7c12554402ce1c561)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationResize]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationResize]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationResize]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f47cc35fd1886450e2f76d28fa91169af3321232409d3de5c3e6dd106e801471)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationResizeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationResizeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d9b82a46ba193cc36acfd76be3692b870fe15172d2de38ffd8bb9862d027a525)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAspect")
    def reset_aspect(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspect", []))

    @jsii.member(jsii_name="resetAspectVar")
    def reset_aspect_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspectVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="aspectInput")
    def aspect_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "aspectInput"))

    @builtins.property
    @jsii.member(jsii_name="aspectVarInput")
    def aspect_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "aspectVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="aspect")
    def aspect(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "aspect"))

    @aspect.setter
    def aspect(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__99b331ba278fd0f9d37a9bacf49d781fd1ff577ac9149a8081e26b05f2e23720)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "aspect", value)

    @builtins.property
    @jsii.member(jsii_name="aspectVar")
    def aspect_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "aspectVar"))

    @aspect_var.setter
    def aspect_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b231256a15dfe6686fec760964ca0c3549cd4a682b5c8cdab2e7439740b4c4b7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "aspectVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__78462e0d69328c5e6e8aecaaecb12310979798144d89023f478cd50845f982e8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7a21168ac02fecaad6eecb9ea02d4ecf78a2c8a8afa41459b637b2f93f0791d3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a3781791c82a2ffe24f0404858be0037dd23a7abd523b9e99e9ae77c2e33d60d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3febe641d0031a9dfb34ebb214f77fa0c7f5254e59ebbfbb60d3f58a63a7881d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bfb89eeceae31fd55dd4b9b78be4c6c82dbd9e4be8b0741b21418f001557b27c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__301c38b7dd29c14760be39a1017ceff7c3124105f9a8ce2ef8a2dad34efbe77c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationResize]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationResize]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationResize]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__446bcc55efda30c16dba843f9fe7d2499e70e941326068194978c52135c9bddc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationRotate",
    jsii_struct_bases=[],
    name_mapping={"degrees": "degrees", "degrees_var": "degreesVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationRotate:
    def __init__(
        self,
        *,
        degrees: typing.Optional[builtins.str] = None,
        degrees_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param degrees: The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees DataAkamaiImagingPolicyImage#degrees}
        :param degrees_var: The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees_var DataAkamaiImagingPolicyImage#degrees_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fed1b63bc84fec088e8963548caec870e938418fce87676a8427536b1a823a88)
            check_type(argname="argument degrees", value=degrees, expected_type=type_hints["degrees"])
            check_type(argname="argument degrees_var", value=degrees_var, expected_type=type_hints["degrees_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if degrees is not None:
            self._values["degrees"] = degrees
        if degrees_var is not None:
            self._values["degrees_var"] = degrees_var

    @builtins.property
    def degrees(self) -> typing.Optional[builtins.str]:
        '''The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees DataAkamaiImagingPolicyImage#degrees}
        '''
        result = self._values.get("degrees")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def degrees_var(self) -> typing.Optional[builtins.str]:
        '''The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees_var DataAkamaiImagingPolicyImage#degrees_var}
        '''
        result = self._values.get("degrees_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationRotate(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationRotateList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationRotateList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1e98b653eeb76472a1c17c6e49db88561f84eafaf0513c0e85c2fd9fe4ca2405)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationRotateOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5c25068489ab98df76f018e89be22751ca62ed4377e8311ec9bf4997f7992d31)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationRotateOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__03bbaeead95db697bee42861a34ef8b2475d9f2aee356ce98faa2c3372ac7822)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__48c38d95e7f129fba36c31b13eb72703240dfa98970404af351abef71a20c99f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d5b6dee838470e2474337c47a1b4239cd528adafda7bb67b3cbb83cc9d09c64a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationRotate]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationRotate]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationRotate]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ea204b023c2e36bbf2e79cdafed107cf1c0d18aceddce5df79fb285e0626229)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationRotateOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationRotateOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4401c01e734fc7c3e7ecf7d259e9fc73e9c56f10859d069374fc141f77c9c95a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetDegrees")
    def reset_degrees(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDegrees", []))

    @jsii.member(jsii_name="resetDegreesVar")
    def reset_degrees_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDegreesVar", []))

    @builtins.property
    @jsii.member(jsii_name="degreesInput")
    def degrees_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "degreesInput"))

    @builtins.property
    @jsii.member(jsii_name="degreesVarInput")
    def degrees_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "degreesVarInput"))

    @builtins.property
    @jsii.member(jsii_name="degrees")
    def degrees(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "degrees"))

    @degrees.setter
    def degrees(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__98cc3f71bf75ee8bbc261109d7cab292739d9dda05324c657c810803f9014b5b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "degrees", value)

    @builtins.property
    @jsii.member(jsii_name="degreesVar")
    def degrees_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "degreesVar"))

    @degrees_var.setter
    def degrees_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2dccd755a1c27f60c9699ecc1d5cdde657338059174282afab3c27a0ff373284)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "degreesVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationRotate]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationRotate]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationRotate]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aefbc381bc5f65c57f21e5013d74ada2a357462928c4627c13e40b5f0d55dac8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationScale",
    jsii_struct_bases=[],
    name_mapping={
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationScale:
    def __init__(
        self,
        *,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param height: Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged. Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged. Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f298ca7e8485c22964e80f39a2727f639b322f9325227b8c4ff98de4e0ce6b86)
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size.

        Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size.

        Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged.

        Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged.

        Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationScale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationScaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationScaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__37df1685f7ec9a83fa39676a57ed01f4e56eed6ce7235872c54d688bf4549f6a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationScaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac5343b62aa404b22f0d2bb17e767469006c00c9faa7a4388952136553672c16)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationScaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7a2db01c8cce307a8fe0b063a3a96fa7ebb632a8a2efc12ebe8adcb41b9cf0a8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7113bdc77908f1f3ef11a2d99a56c349ba5ba4579763a86fd457f4eec0428088)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__415c35adea11ed59913a4db523b8af4b372dc0befdcdb747abe041b05d34343c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationScale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationScale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationScale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__890ab07ecec7a1289b4772bc8ca84f4ac9f4d6d1098cfaf32a29657c222e1d0e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationScaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationScaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1b45e678531261b05de5f854defd39301d64ee4a30d22e5f1d2138e3a0d722e3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1ea42a0e40ed257f44d3462e0028b980de949c7497bb0c86f69dfb1c6252649f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f4dd9176a45cd2c6797f00d2789dc54cdf9ae962f00ab39a474346c38441c18)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__966dde4de256921363fb0eab82eeda7ff5823dbca1fed81e893ecb0b53a4f542)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__986ca57f7d31bbb1d1de9a2eac91780b030e3321697f6e00e3e41f027c62bbcf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationScale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationScale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationScale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2da9e67f887536f7f34d80a5b71ed0bcd36861fa444ed8e516997178bfe1a9fc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationShear",
    jsii_struct_bases=[],
    name_mapping={
        "x_shear": "xShear",
        "x_shear_var": "xShearVar",
        "y_shear": "yShear",
        "y_shear_var": "yShearVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationShear:
    def __init__(
        self,
        *,
        x_shear: typing.Optional[builtins.str] = None,
        x_shear_var: typing.Optional[builtins.str] = None,
        y_shear: typing.Optional[builtins.str] = None,
        y_shear_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param x_shear: The amount to shear along the x-axis, measured in multiples of the image's width. Must be set if yShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear DataAkamaiImagingPolicyImage#x_shear}
        :param x_shear_var: The amount to shear along the x-axis, measured in multiples of the image's width. Must be set if yShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear_var DataAkamaiImagingPolicyImage#x_shear_var}
        :param y_shear: The amount to shear along the y-axis, measured in multiples of the image's height. Must be set if xShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear DataAkamaiImagingPolicyImage#y_shear}
        :param y_shear_var: The amount to shear along the y-axis, measured in multiples of the image's height. Must be set if xShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear_var DataAkamaiImagingPolicyImage#y_shear_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e303d17fa5712c5b8e6224e5fbaa772e96b963cb9d875bc76c6c8098665074ff)
            check_type(argname="argument x_shear", value=x_shear, expected_type=type_hints["x_shear"])
            check_type(argname="argument x_shear_var", value=x_shear_var, expected_type=type_hints["x_shear_var"])
            check_type(argname="argument y_shear", value=y_shear, expected_type=type_hints["y_shear"])
            check_type(argname="argument y_shear_var", value=y_shear_var, expected_type=type_hints["y_shear_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if x_shear is not None:
            self._values["x_shear"] = x_shear
        if x_shear_var is not None:
            self._values["x_shear_var"] = x_shear_var
        if y_shear is not None:
            self._values["y_shear"] = y_shear
        if y_shear_var is not None:
            self._values["y_shear_var"] = y_shear_var

    @builtins.property
    def x_shear(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the x-axis, measured in multiples of the image's width.

        Must be set if yShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear DataAkamaiImagingPolicyImage#x_shear}
        '''
        result = self._values.get("x_shear")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_shear_var(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the x-axis, measured in multiples of the image's width.

        Must be set if yShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear_var DataAkamaiImagingPolicyImage#x_shear_var}
        '''
        result = self._values.get("x_shear_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_shear(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the y-axis, measured in multiples of the image's height.

        Must be set if xShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear DataAkamaiImagingPolicyImage#y_shear}
        '''
        result = self._values.get("y_shear")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_shear_var(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the y-axis, measured in multiples of the image's height.

        Must be set if xShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear_var DataAkamaiImagingPolicyImage#y_shear_var}
        '''
        result = self._values.get("y_shear_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationShear(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationShearList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationShearList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__792ef99371275bf1d63ae255ee879f7eebcd48f186fcd7f4291ec1ed0db3e4dd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationShearOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2de3a3f19812aa9c6ea4311c53cd2a78ea6712af142815b0f076057b6f59de57)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationShearOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__31b450bc87ff56da7e5ab22a90b6f4bca9867d48abe4dc5f342ea840c64961c6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__efb080e89f911093411a2251656fa33cdab4cacdde741bd1f3fcd02766bb5db6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cfc2c8c8cf9a33108e56e2d35d5b9be911b0941f0a19ea4842c104e3fa293467)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationShear]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationShear]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationShear]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f2303b39c3bd02fcb70ad8cfdd3db5797b42d9ec0bebdf5b7e5d96ec238d090)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationShearOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationShearOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__53a47b4b5024db5379f7d321a0f34e92acf76cb2009472c23314c894c798e27f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetXShear")
    def reset_x_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXShear", []))

    @jsii.member(jsii_name="resetXShearVar")
    def reset_x_shear_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXShearVar", []))

    @jsii.member(jsii_name="resetYShear")
    def reset_y_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYShear", []))

    @jsii.member(jsii_name="resetYShearVar")
    def reset_y_shear_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYShearVar", []))

    @builtins.property
    @jsii.member(jsii_name="xShearInput")
    def x_shear_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xShearInput"))

    @builtins.property
    @jsii.member(jsii_name="xShearVarInput")
    def x_shear_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xShearVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yShearInput")
    def y_shear_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yShearInput"))

    @builtins.property
    @jsii.member(jsii_name="yShearVarInput")
    def y_shear_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yShearVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xShear")
    def x_shear(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xShear"))

    @x_shear.setter
    def x_shear(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a548aa2511e11611635ca5f0fcde4f8b1c2f64b75ff5741b855a02e52bcbc072)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xShear", value)

    @builtins.property
    @jsii.member(jsii_name="xShearVar")
    def x_shear_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xShearVar"))

    @x_shear_var.setter
    def x_shear_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__35eb05cc1bf7f775f07d4a29e90dc254075e8a4d006c5c3ee05bbd4909750325)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xShearVar", value)

    @builtins.property
    @jsii.member(jsii_name="yShear")
    def y_shear(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yShear"))

    @y_shear.setter
    def y_shear(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__208fbd059816d5a6474a903944f324bbf0f487ffa948ba0dedd0e0c2d0df2c50)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yShear", value)

    @builtins.property
    @jsii.member(jsii_name="yShearVar")
    def y_shear_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yShearVar"))

    @y_shear_var.setter
    def y_shear_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f3a639b763177cc7b58ca32c6894f87f0939d301c075729a3646ce224d00d88)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yShearVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationShear]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationShear]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationShear]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__91b308208a863e672f47128ff6d910010043646f8b02b28e316cbea35a36ca94)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationTrim",
    jsii_struct_bases=[],
    name_mapping={
        "fuzz": "fuzz",
        "fuzz_var": "fuzzVar",
        "padding": "padding",
        "padding_var": "paddingVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationTrim:
    def __init__(
        self,
        *,
        fuzz: typing.Optional[builtins.str] = None,
        fuzz_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fuzz: The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz DataAkamaiImagingPolicyImage#fuzz}
        :param fuzz_var: The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz_var DataAkamaiImagingPolicyImage#fuzz_var}
        :param padding: The amount of padding in pixels to add to the trimmed image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: The amount of padding in pixels to add to the trimmed image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eb13209de431908566669745e2da15e4d4a3e53d8bf40c627beee6dc351d7cef)
            check_type(argname="argument fuzz", value=fuzz, expected_type=type_hints["fuzz"])
            check_type(argname="argument fuzz_var", value=fuzz_var, expected_type=type_hints["fuzz_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fuzz is not None:
            self._values["fuzz"] = fuzz
        if fuzz_var is not None:
            self._values["fuzz_var"] = fuzz_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var

    @builtins.property
    def fuzz(self) -> typing.Optional[builtins.str]:
        '''The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz DataAkamaiImagingPolicyImage#fuzz}
        '''
        result = self._values.get("fuzz")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fuzz_var(self) -> typing.Optional[builtins.str]:
        '''The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz_var DataAkamaiImagingPolicyImage#fuzz_var}
        '''
        result = self._values.get("fuzz_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''The amount of padding in pixels to add to the trimmed image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''The amount of padding in pixels to add to the trimmed image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationTrim(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationTrimList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationTrimList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f4d3d2a5a7601257ffadf28ecf603d4e29d0afb76e5846bb141c67f40dde2cb2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationTrimOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df68d55bb6b5c02e8f1d368f80ec4082177c0c10ed61191e08db528897eff336)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationTrimOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eca91769d17f42c22ab8b00d66fed904fb9750c8f76f2256445be23841677d95)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c2714fc988bdfecbde79bc1f3add1c263ce7359db741e16711bd040c777fe8a6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c44ea4626a4dcb9cfab01cc9d54c8507d3db0193f319a1360627aa598a2877ce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationTrim]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationTrim]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationTrim]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a5262d9cf1aa88292d5b3778cd30308464254e9e497ce104ccc98501a9a0c0be)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationTrimOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationTrimOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__828e02f6bda7db542506f8607223f67090eead67ddf868010390da40c0156729)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetFuzz")
    def reset_fuzz(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFuzz", []))

    @jsii.member(jsii_name="resetFuzzVar")
    def reset_fuzz_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFuzzVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @builtins.property
    @jsii.member(jsii_name="fuzzInput")
    def fuzz_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fuzzInput"))

    @builtins.property
    @jsii.member(jsii_name="fuzzVarInput")
    def fuzz_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fuzzVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="fuzz")
    def fuzz(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fuzz"))

    @fuzz.setter
    def fuzz(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2febf1377955a0c2e1cf7b56874c1696cce8910e1d7a898317f922df54a16471)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fuzz", value)

    @builtins.property
    @jsii.member(jsii_name="fuzzVar")
    def fuzz_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fuzzVar"))

    @fuzz_var.setter
    def fuzz_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a15f38d9367b3b7c1f19c7c57177f5125b3190a873a49213707a0f59bf81a866)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fuzzVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b92a52a3a4594ed3287d1946185c574e6c8bd85fc6c2523124be233622fb4710)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__33261721edf28c923b3a9c01088c398f01154ab55705dd1737bc456b7103dc09)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationTrim]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationTrim]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationTrim]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c0f78c4d819089bcf8e7f0618075d9f3c620c062a1f2016ef04223e300776d19)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationUnsharpMask",
    jsii_struct_bases=[],
    name_mapping={
        "gain": "gain",
        "gain_var": "gainVar",
        "sigma": "sigma",
        "sigma_var": "sigmaVar",
        "threshold": "threshold",
        "threshold_var": "thresholdVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationUnsharpMask:
    def __init__(
        self,
        *,
        gain: typing.Optional[builtins.str] = None,
        gain_var: typing.Optional[builtins.str] = None,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
        threshold: typing.Optional[builtins.str] = None,
        threshold_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param gain: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        :param gain_var: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        :param sigma: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        :param threshold: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        :param threshold_var: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__63762bf2f7a9613e410b3cc32ce551e12e11f74b09b9086c3bdad27ab8806cc2)
            check_type(argname="argument gain", value=gain, expected_type=type_hints["gain"])
            check_type(argname="argument gain_var", value=gain_var, expected_type=type_hints["gain_var"])
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
            check_type(argname="argument threshold", value=threshold, expected_type=type_hints["threshold"])
            check_type(argname="argument threshold_var", value=threshold_var, expected_type=type_hints["threshold_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if gain is not None:
            self._values["gain"] = gain
        if gain_var is not None:
            self._values["gain_var"] = gain_var
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var
        if threshold is not None:
            self._values["threshold"] = threshold
        if threshold_var is not None:
            self._values["threshold_var"] = threshold_var

    @builtins.property
    def gain(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        '''
        result = self._values.get("gain")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gain_var(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        '''
        result = self._values.get("gain_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        '''
        result = self._values.get("threshold")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold_var(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        result = self._values.get("threshold_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationUnsharpMask(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationUnsharpMaskList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationUnsharpMaskList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e4f21ef5f6519cc804424b69c9efcc4dcd35fb5208ef7074f5b518d989c0d0ab)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationUnsharpMaskOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__22c43d80db547375123c730e7c19c86d6f8db1117db2d3a590f17fe558fb13f8)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationUnsharpMaskOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__24da9c61dc34f98514cde5ca72bdd2183127d0621d07be75e39f08699c4c3cf0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__40cbd5ab311f56002345f544c824c93cda74f17e5b04ca921a2bb8bea0373ff6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb6033c0aea1c769630fb1a0cfc45136f4fe661f6dd1caa6cb9981c113b3939a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationUnsharpMask]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationUnsharpMask]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationUnsharpMask]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a9c3c19b8b917f43ebd047f020a9c486075d61fb4c5c4bec97fb0e814f059c7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationUnsharpMaskOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationUnsharpMaskOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__725404a323f7f9d9a86052362a6beb94198802d4374c17d19ea68b43d354c402)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetGain")
    def reset_gain(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGain", []))

    @jsii.member(jsii_name="resetGainVar")
    def reset_gain_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGainVar", []))

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @jsii.member(jsii_name="resetThreshold")
    def reset_threshold(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThreshold", []))

    @jsii.member(jsii_name="resetThresholdVar")
    def reset_threshold_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThresholdVar", []))

    @builtins.property
    @jsii.member(jsii_name="gainInput")
    def gain_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainInput"))

    @builtins.property
    @jsii.member(jsii_name="gainVarInput")
    def gain_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdInput")
    def threshold_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdVarInput")
    def threshold_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gain")
    def gain(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gain"))

    @gain.setter
    def gain(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3674389604428ccea4179ef8efa2c84be7a39bc385c1636ddb6f1c04928f7c92)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gain", value)

    @builtins.property
    @jsii.member(jsii_name="gainVar")
    def gain_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gainVar"))

    @gain_var.setter
    def gain_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ed5eb33c6384c99257e6aab9c5c0e4c25e494c3f4d4aada5905332ab03e4bf5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gainVar", value)

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2e9d0a0ee3b4e4d7287402cba73b27ce84d57636460b47bc7dbe142b25339adb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__684a4513ff6d704dfdeb430bf6c716964da3596637e05a240eb56e933bf18b7e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="threshold")
    def threshold(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "threshold"))

    @threshold.setter
    def threshold(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__72a8cba00bff0c13c6bd9cabf68d1cb56657660187961f2ab8f9b1471082253e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "threshold", value)

    @builtins.property
    @jsii.member(jsii_name="thresholdVar")
    def threshold_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "thresholdVar"))

    @threshold_var.setter
    def threshold_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5050180b4ee694b1062ef88fa1519c3fb39efee8c12856b82e04b7cafe9bf27b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "thresholdVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationUnsharpMask]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationUnsharpMask]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationUnsharpMask]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__741367e55a43d2e8816d50e2312c1eab2fa03c516e3b5b73463fe573b147878a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImage",
    jsii_struct_bases=[],
    name_mapping={
        "color": "color",
        "color_var": "colorVar",
        "diameter": "diameter",
        "diameter_var": "diameterVar",
        "transformation": "transformation",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImage:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
        diameter: typing.Optional[builtins.str] = None,
        diameter_var: typing.Optional[builtins.str] = None,
        transformation: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The fill color of the circle. The API supports hexadecimal representation and CSS hexadecimal color values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The fill color of the circle. The API supports hexadecimal representation and CSS hexadecimal color values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        :param diameter: The diameter of the circle. The diameter will be the width and the height of the image in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#diameter DataAkamaiImagingPolicyImage#diameter}
        :param diameter_var: The diameter of the circle. The diameter will be the width and the height of the image in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#diameter_var DataAkamaiImagingPolicyImage#diameter_var}
        :param transformation: transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        :param width: The width of the box in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width of the box in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(transformation, dict):
            transformation = DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformation(**transformation)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f060fefd765c4db4f8147eb0208e5826616755c9ccab30bef906618e7a55ab7a)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
            check_type(argname="argument diameter", value=diameter, expected_type=type_hints["diameter"])
            check_type(argname="argument diameter_var", value=diameter_var, expected_type=type_hints["diameter_var"])
            check_type(argname="argument transformation", value=transformation, expected_type=type_hints["transformation"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var
        if diameter is not None:
            self._values["diameter"] = diameter
        if diameter_var is not None:
            self._values["diameter_var"] = diameter_var
        if transformation is not None:
            self._values["transformation"] = transformation
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The fill color of the circle. The API supports hexadecimal representation and CSS hexadecimal color values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The fill color of the circle. The API supports hexadecimal representation and CSS hexadecimal color values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def diameter(self) -> typing.Optional[builtins.str]:
        '''The diameter of the circle. The diameter will be the width and the height of the image in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#diameter DataAkamaiImagingPolicyImage#diameter}
        '''
        result = self._values.get("diameter")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def diameter_var(self) -> typing.Optional[builtins.str]:
        '''The diameter of the circle. The diameter will be the width and the height of the image in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#diameter_var DataAkamaiImagingPolicyImage#diameter_var}
        '''
        result = self._values.get("diameter_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def transformation(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformation"]:
        '''transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        '''
        result = self._values.get("transformation")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformation"], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width of the box in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width of the box in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__055478d6c4b9f6c09e21bfaf56c170b744ef36ae445fa23b38ee7764509aa0f5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__490901806672f0409c469dc395c87af0367a3467353cce4fe74be468c5b8f1b7)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3f1844ba7ac5fa1910fb069219a592b0ab2505e4b45d707af9b1ddfb3cd43738)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1dc8de3ad526189fe30f1ec180c593f645044f851427aa75925da8047eccec6e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7726675fd3879ada780f02281698d35ddc7f496b46fb722ba7a7c1d5e4fff8b3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImage]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImage]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImage]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__28db2ec1bb53fca11171af15d756beea94d156ae15b4fb1a0fe3f4a757dceef1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5fe36306b7d5b995a371a78daeda992e47504f116640afb8f179fe1407835b0d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformation")
    def put_transformation(
        self,
        *,
        append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationAppend", typing.Dict[builtins.str, typing.Any]]]]] = None,
        aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationAspectCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationBackgroundColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationBlur", typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationChromaKey", typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationComposite", typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationCompound", typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationContrast", typing.Dict[builtins.str, typing.Any]]]]] = None,
        crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationFaceCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationFeatureCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationFitAndFill", typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationGoop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationGrayscale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationHsl", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationHsv", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfDimension", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfOrientation", typing.Dict[builtins.str, typing.Any]]]]] = None,
        im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationImQuery", typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationMaxColors", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationMirror", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationMonoHue", typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationOpacity", typing.Dict[builtins.str, typing.Any]]]]] = None,
        region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationRegionOfInterestCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationRelativeCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationRemoveColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationResize", typing.Dict[builtins.str, typing.Any]]]]] = None,
        rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationRotate", typing.Dict[builtins.str, typing.Any]]]]] = None,
        scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationScale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationShear", typing.Dict[builtins.str, typing.Any]]]]] = None,
        trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationTrim", typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationUnsharpMask", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param append: append block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        :param aspect_crop: aspect_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param crop: crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        :param face_crop: face_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        :param feature_crop: feature_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        :param fit_and_fill: fit_and_fill block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param im_query: im_query block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param region_of_interest_crop: region_of_interest_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        :param relative_crop: relative_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param resize: resize block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        :param rotate: rotate block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        :param scale: scale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param shear: shear block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        :param trim: trim block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        value = DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformation(
            append=append,
            aspect_crop=aspect_crop,
            background_color=background_color,
            blur=blur,
            chroma_key=chroma_key,
            composite=composite,
            compound=compound,
            contrast=contrast,
            crop=crop,
            face_crop=face_crop,
            feature_crop=feature_crop,
            fit_and_fill=fit_and_fill,
            goop=goop,
            grayscale=grayscale,
            hsl=hsl,
            hsv=hsv,
            if_dimension=if_dimension,
            if_orientation=if_orientation,
            im_query=im_query,
            max_colors=max_colors,
            mirror=mirror,
            mono_hue=mono_hue,
            opacity=opacity,
            region_of_interest_crop=region_of_interest_crop,
            relative_crop=relative_crop,
            remove_color=remove_color,
            resize=resize,
            rotate=rotate,
            scale=scale,
            shear=shear,
            trim=trim,
            unsharp_mask=unsharp_mask,
        )

        return typing.cast(None, jsii.invoke(self, "putTransformation", [value]))

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @jsii.member(jsii_name="resetDiameter")
    def reset_diameter(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDiameter", []))

    @jsii.member(jsii_name="resetDiameterVar")
    def reset_diameter_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDiameterVar", []))

    @jsii.member(jsii_name="resetTransformation")
    def reset_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformation", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="transformation")
    def transformation(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationOutputReference", jsii.get(self, "transformation"))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="diameterInput")
    def diameter_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "diameterInput"))

    @builtins.property
    @jsii.member(jsii_name="diameterVarInput")
    def diameter_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "diameterVarInput"))

    @builtins.property
    @jsii.member(jsii_name="transformationInput")
    def transformation_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformation"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformation"], jsii.get(self, "transformationInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__86fc6f06c5b2c64e073efb9eef7af2b83b285d02ea0569d32f0c4344b9970419)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__84adc63dc90bdd6eec131331d490774abc94378480e40691cd00e4457a9c4aca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="diameter")
    def diameter(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "diameter"))

    @diameter.setter
    def diameter(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__91932ba70929ddf2a7de0bdd3947d95a80eb107dd0d16bdf79b59c13cab48ab4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "diameter", value)

    @builtins.property
    @jsii.member(jsii_name="diameterVar")
    def diameter_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "diameterVar"))

    @diameter_var.setter
    def diameter_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2266d2ea22d41526f578baa2949101f9f0b1b8b51ff096622bf06bf0673c7d71)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "diameterVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0cd39622c885ffe2449c169f71677c8f872cb04c4cc694a046618847ffb78b60)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__753552d96b6372e03996990faf9faebeee54500ea8a22ed77e208553f1f2a81f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImage]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImage]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImage]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ed009245d48650aa000396e384056c46e92c3f4efbd6fb286cf0530d57fafc11)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformation",
    jsii_struct_bases=[],
    name_mapping={
        "append": "append",
        "aspect_crop": "aspectCrop",
        "background_color": "backgroundColor",
        "blur": "blur",
        "chroma_key": "chromaKey",
        "composite": "composite",
        "compound": "compound",
        "contrast": "contrast",
        "crop": "crop",
        "face_crop": "faceCrop",
        "feature_crop": "featureCrop",
        "fit_and_fill": "fitAndFill",
        "goop": "goop",
        "grayscale": "grayscale",
        "hsl": "hsl",
        "hsv": "hsv",
        "if_dimension": "ifDimension",
        "if_orientation": "ifOrientation",
        "im_query": "imQuery",
        "max_colors": "maxColors",
        "mirror": "mirror",
        "mono_hue": "monoHue",
        "opacity": "opacity",
        "region_of_interest_crop": "regionOfInterestCrop",
        "relative_crop": "relativeCrop",
        "remove_color": "removeColor",
        "resize": "resize",
        "rotate": "rotate",
        "scale": "scale",
        "shear": "shear",
        "trim": "trim",
        "unsharp_mask": "unsharpMask",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformation:
    def __init__(
        self,
        *,
        append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationAppend", typing.Dict[builtins.str, typing.Any]]]]] = None,
        aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationAspectCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationBackgroundColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationBlur", typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationChromaKey", typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationComposite", typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationCompound", typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationContrast", typing.Dict[builtins.str, typing.Any]]]]] = None,
        crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationFaceCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationFeatureCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationFitAndFill", typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationGoop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationGrayscale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationHsl", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationHsv", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfDimension", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfOrientation", typing.Dict[builtins.str, typing.Any]]]]] = None,
        im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationImQuery", typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationMaxColors", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationMirror", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationMonoHue", typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationOpacity", typing.Dict[builtins.str, typing.Any]]]]] = None,
        region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationRegionOfInterestCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationRelativeCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationRemoveColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationResize", typing.Dict[builtins.str, typing.Any]]]]] = None,
        rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationRotate", typing.Dict[builtins.str, typing.Any]]]]] = None,
        scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationScale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationShear", typing.Dict[builtins.str, typing.Any]]]]] = None,
        trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationTrim", typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationUnsharpMask", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param append: append block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        :param aspect_crop: aspect_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param crop: crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        :param face_crop: face_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        :param feature_crop: feature_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        :param fit_and_fill: fit_and_fill block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param im_query: im_query block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param region_of_interest_crop: region_of_interest_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        :param relative_crop: relative_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param resize: resize block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        :param rotate: rotate block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        :param scale: scale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param shear: shear block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        :param trim: trim block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8450fd2290c8b81a2daa83fd94843380cf00bcd62b5606a05eaea0e6f6f17c20)
            check_type(argname="argument append", value=append, expected_type=type_hints["append"])
            check_type(argname="argument aspect_crop", value=aspect_crop, expected_type=type_hints["aspect_crop"])
            check_type(argname="argument background_color", value=background_color, expected_type=type_hints["background_color"])
            check_type(argname="argument blur", value=blur, expected_type=type_hints["blur"])
            check_type(argname="argument chroma_key", value=chroma_key, expected_type=type_hints["chroma_key"])
            check_type(argname="argument composite", value=composite, expected_type=type_hints["composite"])
            check_type(argname="argument compound", value=compound, expected_type=type_hints["compound"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument crop", value=crop, expected_type=type_hints["crop"])
            check_type(argname="argument face_crop", value=face_crop, expected_type=type_hints["face_crop"])
            check_type(argname="argument feature_crop", value=feature_crop, expected_type=type_hints["feature_crop"])
            check_type(argname="argument fit_and_fill", value=fit_and_fill, expected_type=type_hints["fit_and_fill"])
            check_type(argname="argument goop", value=goop, expected_type=type_hints["goop"])
            check_type(argname="argument grayscale", value=grayscale, expected_type=type_hints["grayscale"])
            check_type(argname="argument hsl", value=hsl, expected_type=type_hints["hsl"])
            check_type(argname="argument hsv", value=hsv, expected_type=type_hints["hsv"])
            check_type(argname="argument if_dimension", value=if_dimension, expected_type=type_hints["if_dimension"])
            check_type(argname="argument if_orientation", value=if_orientation, expected_type=type_hints["if_orientation"])
            check_type(argname="argument im_query", value=im_query, expected_type=type_hints["im_query"])
            check_type(argname="argument max_colors", value=max_colors, expected_type=type_hints["max_colors"])
            check_type(argname="argument mirror", value=mirror, expected_type=type_hints["mirror"])
            check_type(argname="argument mono_hue", value=mono_hue, expected_type=type_hints["mono_hue"])
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument region_of_interest_crop", value=region_of_interest_crop, expected_type=type_hints["region_of_interest_crop"])
            check_type(argname="argument relative_crop", value=relative_crop, expected_type=type_hints["relative_crop"])
            check_type(argname="argument remove_color", value=remove_color, expected_type=type_hints["remove_color"])
            check_type(argname="argument resize", value=resize, expected_type=type_hints["resize"])
            check_type(argname="argument rotate", value=rotate, expected_type=type_hints["rotate"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument shear", value=shear, expected_type=type_hints["shear"])
            check_type(argname="argument trim", value=trim, expected_type=type_hints["trim"])
            check_type(argname="argument unsharp_mask", value=unsharp_mask, expected_type=type_hints["unsharp_mask"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if append is not None:
            self._values["append"] = append
        if aspect_crop is not None:
            self._values["aspect_crop"] = aspect_crop
        if background_color is not None:
            self._values["background_color"] = background_color
        if blur is not None:
            self._values["blur"] = blur
        if chroma_key is not None:
            self._values["chroma_key"] = chroma_key
        if composite is not None:
            self._values["composite"] = composite
        if compound is not None:
            self._values["compound"] = compound
        if contrast is not None:
            self._values["contrast"] = contrast
        if crop is not None:
            self._values["crop"] = crop
        if face_crop is not None:
            self._values["face_crop"] = face_crop
        if feature_crop is not None:
            self._values["feature_crop"] = feature_crop
        if fit_and_fill is not None:
            self._values["fit_and_fill"] = fit_and_fill
        if goop is not None:
            self._values["goop"] = goop
        if grayscale is not None:
            self._values["grayscale"] = grayscale
        if hsl is not None:
            self._values["hsl"] = hsl
        if hsv is not None:
            self._values["hsv"] = hsv
        if if_dimension is not None:
            self._values["if_dimension"] = if_dimension
        if if_orientation is not None:
            self._values["if_orientation"] = if_orientation
        if im_query is not None:
            self._values["im_query"] = im_query
        if max_colors is not None:
            self._values["max_colors"] = max_colors
        if mirror is not None:
            self._values["mirror"] = mirror
        if mono_hue is not None:
            self._values["mono_hue"] = mono_hue
        if opacity is not None:
            self._values["opacity"] = opacity
        if region_of_interest_crop is not None:
            self._values["region_of_interest_crop"] = region_of_interest_crop
        if relative_crop is not None:
            self._values["relative_crop"] = relative_crop
        if remove_color is not None:
            self._values["remove_color"] = remove_color
        if resize is not None:
            self._values["resize"] = resize
        if rotate is not None:
            self._values["rotate"] = rotate
        if scale is not None:
            self._values["scale"] = scale
        if shear is not None:
            self._values["shear"] = shear
        if trim is not None:
            self._values["trim"] = trim
        if unsharp_mask is not None:
            self._values["unsharp_mask"] = unsharp_mask

    @builtins.property
    def append(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationAppend"]]]:
        '''append block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        '''
        result = self._values.get("append")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationAppend"]]], result)

    @builtins.property
    def aspect_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationAspectCrop"]]]:
        '''aspect_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        '''
        result = self._values.get("aspect_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationAspectCrop"]]], result)

    @builtins.property
    def background_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationBackgroundColor"]]]:
        '''background_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        '''
        result = self._values.get("background_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationBackgroundColor"]]], result)

    @builtins.property
    def blur(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationBlur"]]]:
        '''blur block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        '''
        result = self._values.get("blur")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationBlur"]]], result)

    @builtins.property
    def chroma_key(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationChromaKey"]]]:
        '''chroma_key block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        '''
        result = self._values.get("chroma_key")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationChromaKey"]]], result)

    @builtins.property
    def composite(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationComposite"]]]:
        '''composite block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        '''
        result = self._values.get("composite")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationComposite"]]], result)

    @builtins.property
    def compound(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationCompound"]]]:
        '''compound block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        '''
        result = self._values.get("compound")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationCompound"]]], result)

    @builtins.property
    def contrast(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationContrast"]]]:
        '''contrast block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationContrast"]]], result)

    @builtins.property
    def crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationCrop"]]]:
        '''crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        '''
        result = self._values.get("crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationCrop"]]], result)

    @builtins.property
    def face_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationFaceCrop"]]]:
        '''face_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        '''
        result = self._values.get("face_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationFaceCrop"]]], result)

    @builtins.property
    def feature_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationFeatureCrop"]]]:
        '''feature_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        '''
        result = self._values.get("feature_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationFeatureCrop"]]], result)

    @builtins.property
    def fit_and_fill(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationFitAndFill"]]]:
        '''fit_and_fill block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        '''
        result = self._values.get("fit_and_fill")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationFitAndFill"]]], result)

    @builtins.property
    def goop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationGoop"]]]:
        '''goop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        '''
        result = self._values.get("goop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationGoop"]]], result)

    @builtins.property
    def grayscale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationGrayscale"]]]:
        '''grayscale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        '''
        result = self._values.get("grayscale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationGrayscale"]]], result)

    @builtins.property
    def hsl(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationHsl"]]]:
        '''hsl block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        '''
        result = self._values.get("hsl")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationHsl"]]], result)

    @builtins.property
    def hsv(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationHsv"]]]:
        '''hsv block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        '''
        result = self._values.get("hsv")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationHsv"]]], result)

    @builtins.property
    def if_dimension(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfDimension"]]]:
        '''if_dimension block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        '''
        result = self._values.get("if_dimension")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfDimension"]]], result)

    @builtins.property
    def if_orientation(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfOrientation"]]]:
        '''if_orientation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        '''
        result = self._values.get("if_orientation")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfOrientation"]]], result)

    @builtins.property
    def im_query(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationImQuery"]]]:
        '''im_query block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        '''
        result = self._values.get("im_query")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationImQuery"]]], result)

    @builtins.property
    def max_colors(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationMaxColors"]]]:
        '''max_colors block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        '''
        result = self._values.get("max_colors")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationMaxColors"]]], result)

    @builtins.property
    def mirror(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationMirror"]]]:
        '''mirror block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        '''
        result = self._values.get("mirror")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationMirror"]]], result)

    @builtins.property
    def mono_hue(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationMonoHue"]]]:
        '''mono_hue block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        '''
        result = self._values.get("mono_hue")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationMonoHue"]]], result)

    @builtins.property
    def opacity(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationOpacity"]]]:
        '''opacity block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationOpacity"]]], result)

    @builtins.property
    def region_of_interest_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationRegionOfInterestCrop"]]]:
        '''region_of_interest_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        '''
        result = self._values.get("region_of_interest_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationRegionOfInterestCrop"]]], result)

    @builtins.property
    def relative_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationRelativeCrop"]]]:
        '''relative_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        '''
        result = self._values.get("relative_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationRelativeCrop"]]], result)

    @builtins.property
    def remove_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationRemoveColor"]]]:
        '''remove_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        '''
        result = self._values.get("remove_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationRemoveColor"]]], result)

    @builtins.property
    def resize(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationResize"]]]:
        '''resize block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        '''
        result = self._values.get("resize")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationResize"]]], result)

    @builtins.property
    def rotate(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationRotate"]]]:
        '''rotate block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        '''
        result = self._values.get("rotate")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationRotate"]]], result)

    @builtins.property
    def scale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationScale"]]]:
        '''scale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationScale"]]], result)

    @builtins.property
    def shear(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationShear"]]]:
        '''shear block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        '''
        result = self._values.get("shear")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationShear"]]], result)

    @builtins.property
    def trim(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationTrim"]]]:
        '''trim block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        '''
        result = self._values.get("trim")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationTrim"]]], result)

    @builtins.property
    def unsharp_mask(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationUnsharpMask"]]]:
        '''unsharp_mask block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        result = self._values.get("unsharp_mask")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationUnsharpMask"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationAppend",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_priority": "gravityPriority",
        "gravity_priority_var": "gravityPriorityVar",
        "gravity_var": "gravityVar",
        "preserve_minor_dimension": "preserveMinorDimension",
        "preserve_minor_dimension_var": "preserveMinorDimensionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationAppend:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationAppendImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_priority: typing.Optional[builtins.str] = None,
        gravity_priority_var: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        preserve_minor_dimension: typing.Optional[builtins.str] = None,
        preserve_minor_dimension_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Specifies where to place the ``image`` relative to the source image. The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_priority: Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal. The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority DataAkamaiImagingPolicyImage#gravity_priority}
        :param gravity_priority_var: Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal. The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority_var DataAkamaiImagingPolicyImage#gravity_priority_var}
        :param gravity_var: Specifies where to place the ``image`` relative to the source image. The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param preserve_minor_dimension: Whether to preserve the source image's minor dimension, ``false`` by default. The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension DataAkamaiImagingPolicyImage#preserve_minor_dimension}
        :param preserve_minor_dimension_var: Whether to preserve the source image's minor dimension, ``false`` by default. The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension_var DataAkamaiImagingPolicyImage#preserve_minor_dimension_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationAppendImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fdda2c04ab7a350f3ea52e7739f9aaf36ba3c32c62324a5b93940daca1cbe34d)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_priority", value=gravity_priority, expected_type=type_hints["gravity_priority"])
            check_type(argname="argument gravity_priority_var", value=gravity_priority_var, expected_type=type_hints["gravity_priority_var"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument preserve_minor_dimension", value=preserve_minor_dimension, expected_type=type_hints["preserve_minor_dimension"])
            check_type(argname="argument preserve_minor_dimension_var", value=preserve_minor_dimension_var, expected_type=type_hints["preserve_minor_dimension_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_priority is not None:
            self._values["gravity_priority"] = gravity_priority
        if gravity_priority_var is not None:
            self._values["gravity_priority_var"] = gravity_priority_var
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if preserve_minor_dimension is not None:
            self._values["preserve_minor_dimension"] = preserve_minor_dimension
        if preserve_minor_dimension_var is not None:
            self._values["preserve_minor_dimension_var"] = preserve_minor_dimension_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationAppendImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationAppendImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Specifies where to place the ``image`` relative to the source image.

        The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_priority(self) -> typing.Optional[builtins.str]:
        '''Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal.

        The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority DataAkamaiImagingPolicyImage#gravity_priority}
        '''
        result = self._values.get("gravity_priority")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_priority_var(self) -> typing.Optional[builtins.str]:
        '''Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal.

        The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority_var DataAkamaiImagingPolicyImage#gravity_priority_var}
        '''
        result = self._values.get("gravity_priority_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Specifies where to place the ``image`` relative to the source image.

        The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def preserve_minor_dimension(self) -> typing.Optional[builtins.str]:
        '''Whether to preserve the source image's minor dimension, ``false`` by default.

        The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension DataAkamaiImagingPolicyImage#preserve_minor_dimension}
        '''
        result = self._values.get("preserve_minor_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def preserve_minor_dimension_var(self) -> typing.Optional[builtins.str]:
        '''Whether to preserve the source image's minor dimension, ``false`` by default.

        The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension_var DataAkamaiImagingPolicyImage#preserve_minor_dimension_var}
        '''
        result = self._values.get("preserve_minor_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationAppend(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationAppendImage",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationAppendImage:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationAppendImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationAppendImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationAppendImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f17d4605fd1eea82be494ab53f7c9a562e5ebf3123c4553181423b3dc4698dd7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationAppendImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationAppendImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationAppendImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a1e28780aeb8fa3cef63570317a930183a00870edbbcb3becf6fc58f99b0d93)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationAppendList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationAppendList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__664283db7f2bed0d64269f33bfb909c8689e2563026e85242ca2c5ecb8b18131)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationAppendOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ba4faf9e7bda10674073661c6bcbb863d4eaac5c87975eb6071db90b10ac379a)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationAppendOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c6368a99e7a7876083d049864f3349fb5fbceef9a67941233819b83ef80d47ae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__780a5738bd5a3dba134e8cbc396b6d54a654ccc3e261084692e82d9b68b58933)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2b468152fc8fbc587c05600d317c0dd394c153253cd97028b874f31eb462d050)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationAppend]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationAppend]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationAppend]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__99e3c8aa2538a492cc52938c803146de417d3b0933ff5dc06fb45401cbd2835e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationAppendOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationAppendOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__db44111b0e4a63ff1356a313e8568ac51771afb879cb3a9dccbc9526b8aba404)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationAppendImage()

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityPriority")
    def reset_gravity_priority(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityPriority", []))

    @jsii.member(jsii_name="resetGravityPriorityVar")
    def reset_gravity_priority_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityPriorityVar", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPreserveMinorDimension")
    def reset_preserve_minor_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPreserveMinorDimension", []))

    @jsii.member(jsii_name="resetPreserveMinorDimensionVar")
    def reset_preserve_minor_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPreserveMinorDimensionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationAppendImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationAppendImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityInput")
    def gravity_priority_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityPriorityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityVarInput")
    def gravity_priority_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityPriorityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationAppendImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationAppendImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionInput")
    def preserve_minor_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "preserveMinorDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionVarInput")
    def preserve_minor_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "preserveMinorDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__297853da4fbdc66a4dac8e2f4ccc9cca45a168971ef43c0df1c2a8084893c5cf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityPriority")
    def gravity_priority(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityPriority"))

    @gravity_priority.setter
    def gravity_priority(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d94c4a11700de36500dc3027b88da9ce1e1d75841233a273dc328afaa3dc100)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityPriority", value)

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityVar")
    def gravity_priority_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityPriorityVar"))

    @gravity_priority_var.setter
    def gravity_priority_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9dd557cf184d42f5d93d72bea9b0f0f01e7278a02bfa4c5ec4596a07ba2ba366)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityPriorityVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__88bc13487457ea98508efe04c8404ff2ef0b0085a76091d7d5d69f1f70a395e4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimension")
    def preserve_minor_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "preserveMinorDimension"))

    @preserve_minor_dimension.setter
    def preserve_minor_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__93a8236f73caefa3af6359fef04c8cc53711d9037c4275051a98866e5606667f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "preserveMinorDimension", value)

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionVar")
    def preserve_minor_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "preserveMinorDimensionVar"))

    @preserve_minor_dimension_var.setter
    def preserve_minor_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a1031821f1765e41b3012054997b0fa3db7e6968c16a643b678d9478539a95cb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "preserveMinorDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationAppend]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationAppend]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationAppend]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__558d41bddb482d2c6323d11dce14320a8cd288e4b839df1fee35df9b646dddcf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationAspectCrop",
    jsii_struct_bases=[],
    name_mapping={
        "allow_expansion": "allowExpansion",
        "allow_expansion_var": "allowExpansionVar",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationAspectCrop:
    def __init__(
        self,
        *,
        allow_expansion: typing.Optional[builtins.str] = None,
        allow_expansion_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_expansion: Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image. Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        :param allow_expansion_var: Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image. Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        :param height: The height term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The width term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        :param x_position: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3f1057cb581e5ac05e21235d996898c09a4afc260783aeda873bcf7697b2d085)
            check_type(argname="argument allow_expansion", value=allow_expansion, expected_type=type_hints["allow_expansion"])
            check_type(argname="argument allow_expansion_var", value=allow_expansion_var, expected_type=type_hints["allow_expansion_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if allow_expansion is not None:
            self._values["allow_expansion"] = allow_expansion
        if allow_expansion_var is not None:
            self._values["allow_expansion_var"] = allow_expansion_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def allow_expansion(self) -> typing.Optional[builtins.str]:
        '''Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image.

        Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        '''
        result = self._values.get("allow_expansion")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def allow_expansion_var(self) -> typing.Optional[builtins.str]:
        '''Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image.

        Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        '''
        result = self._values.get("allow_expansion_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationAspectCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationAspectCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationAspectCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__581bfb77f95eb94308f38d87a6153989ba7447365ff44d8baac5542d9ed79a78)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationAspectCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eb863a72e564d225dc7ebac667fa178b4805a6d6ee1eab12b071bf2f7e07fd2b)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationAspectCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__48ad50646083625c7b29479687916b8cd9cfccd1142c7a23f2503fb43389e1ba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__74f9f3a73b3e012957497717d4d406683c7e68243f010330f465da1f68f77c41)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5514ae03a71e4027fee5a867d25ebe237bb0abd0e45e833ca20572fa24744f3e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationAspectCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationAspectCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationAspectCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5d534055999ebb51e7a2826185a27b7988bc5ddb796afd7532909e508d30e854)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationAspectCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationAspectCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__09ec00394102da83917fbad2731e3b8edbc5fc8d778dfb1ebde4b581dca1d6eb)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAllowExpansion")
    def reset_allow_expansion(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansion", []))

    @jsii.member(jsii_name="resetAllowExpansionVar")
    def reset_allow_expansion_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansionVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionInput")
    def allow_expansion_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVarInput")
    def allow_expansion_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansion")
    def allow_expansion(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansion"))

    @allow_expansion.setter
    def allow_expansion(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__05e90d924dc9f6f0eea831c617fcd8b409a600292c0b12ed73e4dca95866af9e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansion", value)

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVar")
    def allow_expansion_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansionVar"))

    @allow_expansion_var.setter
    def allow_expansion_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a76d4256741abaa975d6f04882c2012757ba807d8ce5386027777dae4e9198b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansionVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3d34845329089b1539ac735bdaa643387aa643720ad964f1cc1f90c15d5fcfa6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4e104b507c23ad829b1110dd48f1ef7511329883391cf6f04c360189ec38e095)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__648d137e508e6f6321fc92b8e7864dad486cbc05213427946afa87ac293b0ed5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__370fa1428868fe2019433d639f677a6363021b90510b0e07a400c721a2eb68c8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d0030553800f7dff23f73894c4c589c9d37b7169a41037cca4cea3238e4791da)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__30d9fcd809eea9bfbd9088bd28ea3c6a71d14aa09ed622d73f2b12b9acb76401)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7f85da28b071b1c2a8497a6c6e00b69daa5c259bf3417e67728a3acdab1b2a8d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5892c126d2664f526df47b9e200880e5553946a6c1d8ed6884a307ca45ba03d3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationAspectCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationAspectCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationAspectCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3bc1944f9dc7adaa71c44d62108ebc17ad1cb2aa3b8a7a73c87c29953d1b814f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationBackgroundColor",
    jsii_struct_bases=[],
    name_mapping={"color": "color", "color_var": "colorVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationBackgroundColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0c0ee8ea295d8e9e12ec1b3b43be738063ebe73d9ed8b9c5dd659e215bec3176)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationBackgroundColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationBackgroundColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationBackgroundColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__355279d0f74c46a1ff12a859a1a1ccb11987fb917ff0d1b4b96fc8a31a2a1bc4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationBackgroundColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__11aa7ed2f0dc76957a5138fb018537eb87cbcb37ea86048ed66bd91d269ec4e2)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationBackgroundColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d1e2f671a2cf530c405b3b1fd027453cad6cbe42d7eca955fb57dc7a732bc15)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3c290717a93575e31fc1faa34b15383f339e259e240807f8137b6c93bb7eff73)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__418410912facf73932a86f85cdc6d29c8bb3070b94776ae94879fc8aa7ba9fb7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationBackgroundColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationBackgroundColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f426a157a5582456df7dbca705c2e8bb7086ccdec10de304123d5b248057cc2e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationBackgroundColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationBackgroundColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a9aca2d5612becbd8ccef6478cb4f930b24db17f4e1666a6007c01b516fcc270)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e114bf8cb50fa3928c991998e601159b791b0fc9f2e5922a7ac8f2e1bfaf4635)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b7d60acebeb62d91e87738ba6e76e66e5bb85ef00a433af8224c8a27c8e05050)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationBackgroundColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationBackgroundColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationBackgroundColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__051f997345cb707ebd976addb1c5c4ea95840ec39eb8a184fb28287073783628)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationBlur",
    jsii_struct_bases=[],
    name_mapping={"sigma": "sigma", "sigma_var": "sigmaVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationBlur:
    def __init__(
        self,
        *,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param sigma: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ae50535d61ffc6391729212d483af6df31d88ff093ba9939c467d10d3f8b2224)
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationBlur(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationBlurList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationBlurList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c68772f5f2730f76e882be4078cc0501b40ecfe1a669e2fe2c63a51078714112)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationBlurOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__779baa1ecd171e88ee802ca4dbd4d7f6186b09e8f6c9cebf6e212c1c5dacc225)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationBlurOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7fac221a6e17f3473862247d5e77e0b71359b65e593f33b18ff89ce8a3ec7849)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__56a17d7f0c575fb4254847d0d7b950016d44e0bf3123b0c7a9daf30bd7ea022d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2fcaf540a8e01a4194c2cc643d7be85e5c8bb6dc455295c73d43f41f377ddfaf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationBlur]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationBlur]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b71f5de337f87c766d8e92ed4cb761fa92969cad4be30e93d643833d1174fcbe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationBlurOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationBlurOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__626110a2b4dc94f0ae0cb266587b8bb17b4ec212d81c47fc124f1ad03de41313)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b5100c85516d7bec6a69fa5f45ef36033f954f3eae860aba9df36be8faa2133d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__96951a43d1fc30ad164c096e519d33ec31b9ec3ddacfa47f1b187079a24ddf68)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationBlur]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationBlur]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationBlur]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1a83b1e7e90f61bd22bcd3b95c5101e4bf03ac5ee592d66799aeea46e6b08c34)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationChromaKey",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_feather": "hueFeather",
        "hue_feather_var": "hueFeatherVar",
        "hue_tolerance": "hueTolerance",
        "hue_tolerance_var": "hueToleranceVar",
        "hue_var": "hueVar",
        "lightness_feather": "lightnessFeather",
        "lightness_feather_var": "lightnessFeatherVar",
        "lightness_tolerance": "lightnessTolerance",
        "lightness_tolerance_var": "lightnessToleranceVar",
        "saturation_feather": "saturationFeather",
        "saturation_feather_var": "saturationFeatherVar",
        "saturation_tolerance": "saturationTolerance",
        "saturation_tolerance_var": "saturationToleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationChromaKey:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_feather: typing.Optional[builtins.str] = None,
        hue_feather_var: typing.Optional[builtins.str] = None,
        hue_tolerance: typing.Optional[builtins.str] = None,
        hue_tolerance_var: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness_feather: typing.Optional[builtins.str] = None,
        lightness_feather_var: typing.Optional[builtins.str] = None,
        lightness_tolerance: typing.Optional[builtins.str] = None,
        lightness_tolerance_var: typing.Optional[builtins.str] = None,
        saturation_feather: typing.Optional[builtins.str] = None,
        saturation_feather_var: typing.Optional[builtins.str] = None,
        saturation_tolerance: typing.Optional[builtins.str] = None,
        saturation_tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_feather: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        :param hue_feather_var: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        :param hue_tolerance: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        :param hue_tolerance_var: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        :param hue_var: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness_feather: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        :param lightness_feather_var: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        :param lightness_tolerance: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        :param lightness_tolerance_var: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        :param saturation_feather: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        :param saturation_feather_var: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        :param saturation_tolerance: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        :param saturation_tolerance_var: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__08f4119bbb722364a6217d6b03f5ec992d9835f0f499ef43756eff73b44761bb)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_feather", value=hue_feather, expected_type=type_hints["hue_feather"])
            check_type(argname="argument hue_feather_var", value=hue_feather_var, expected_type=type_hints["hue_feather_var"])
            check_type(argname="argument hue_tolerance", value=hue_tolerance, expected_type=type_hints["hue_tolerance"])
            check_type(argname="argument hue_tolerance_var", value=hue_tolerance_var, expected_type=type_hints["hue_tolerance_var"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness_feather", value=lightness_feather, expected_type=type_hints["lightness_feather"])
            check_type(argname="argument lightness_feather_var", value=lightness_feather_var, expected_type=type_hints["lightness_feather_var"])
            check_type(argname="argument lightness_tolerance", value=lightness_tolerance, expected_type=type_hints["lightness_tolerance"])
            check_type(argname="argument lightness_tolerance_var", value=lightness_tolerance_var, expected_type=type_hints["lightness_tolerance_var"])
            check_type(argname="argument saturation_feather", value=saturation_feather, expected_type=type_hints["saturation_feather"])
            check_type(argname="argument saturation_feather_var", value=saturation_feather_var, expected_type=type_hints["saturation_feather_var"])
            check_type(argname="argument saturation_tolerance", value=saturation_tolerance, expected_type=type_hints["saturation_tolerance"])
            check_type(argname="argument saturation_tolerance_var", value=saturation_tolerance_var, expected_type=type_hints["saturation_tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_feather is not None:
            self._values["hue_feather"] = hue_feather
        if hue_feather_var is not None:
            self._values["hue_feather_var"] = hue_feather_var
        if hue_tolerance is not None:
            self._values["hue_tolerance"] = hue_tolerance
        if hue_tolerance_var is not None:
            self._values["hue_tolerance_var"] = hue_tolerance_var
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness_feather is not None:
            self._values["lightness_feather"] = lightness_feather
        if lightness_feather_var is not None:
            self._values["lightness_feather_var"] = lightness_feather_var
        if lightness_tolerance is not None:
            self._values["lightness_tolerance"] = lightness_tolerance
        if lightness_tolerance_var is not None:
            self._values["lightness_tolerance_var"] = lightness_tolerance_var
        if saturation_feather is not None:
            self._values["saturation_feather"] = saturation_feather
        if saturation_feather_var is not None:
            self._values["saturation_feather_var"] = saturation_feather_var
        if saturation_tolerance is not None:
            self._values["saturation_tolerance"] = saturation_tolerance
        if saturation_tolerance_var is not None:
            self._values["saturation_tolerance_var"] = saturation_tolerance_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        '''
        result = self._values.get("hue_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        '''
        result = self._values.get("hue_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        '''
        result = self._values.get("hue_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        '''
        result = self._values.get("hue_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        '''
        result = self._values.get("lightness_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        '''
        result = self._values.get("lightness_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        '''
        result = self._values.get("lightness_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        '''
        result = self._values.get("lightness_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        '''
        result = self._values.get("saturation_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        '''
        result = self._values.get("saturation_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        '''
        result = self._values.get("saturation_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        result = self._values.get("saturation_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationChromaKey(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationChromaKeyList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationChromaKeyList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8b7831be13dd7bcf4dba10bc05138cd2400bb82e03933f6cd3e0b0a2fd785596)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationChromaKeyOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6b9f6261b7c96db4f72c1098f6c039738811cd12617da2c96cfcf139f5c63e7e)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationChromaKeyOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__69c7f6662bb5dadff279bb9c62d50e9865af33a41cfabe4256222603e185d249)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f966098125aa020f94837bd1a030902a2a3240e5230c520a6a736eb42f6ce254)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0c5d657d71bb0e8a8af7d8b0c14b3237fd7e332c5bdec1948fcf0b47964e624f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationChromaKey]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationChromaKey]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3f6842ee6561b8655148b08e2d83edfcaf0e9455e8ae5b7a6c227430e33347bf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationChromaKeyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationChromaKeyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__043f2aeb4ed0b614ba27cbe6204d63b09bcf882064add785b61f6f4e9eaab341)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueFeather")
    def reset_hue_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeather", []))

    @jsii.member(jsii_name="resetHueFeatherVar")
    def reset_hue_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeatherVar", []))

    @jsii.member(jsii_name="resetHueTolerance")
    def reset_hue_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueTolerance", []))

    @jsii.member(jsii_name="resetHueToleranceVar")
    def reset_hue_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueToleranceVar", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightnessFeather")
    def reset_lightness_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeather", []))

    @jsii.member(jsii_name="resetLightnessFeatherVar")
    def reset_lightness_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeatherVar", []))

    @jsii.member(jsii_name="resetLightnessTolerance")
    def reset_lightness_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessTolerance", []))

    @jsii.member(jsii_name="resetLightnessToleranceVar")
    def reset_lightness_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessToleranceVar", []))

    @jsii.member(jsii_name="resetSaturationFeather")
    def reset_saturation_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeather", []))

    @jsii.member(jsii_name="resetSaturationFeatherVar")
    def reset_saturation_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeatherVar", []))

    @jsii.member(jsii_name="resetSaturationTolerance")
    def reset_saturation_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationTolerance", []))

    @jsii.member(jsii_name="resetSaturationToleranceVar")
    def reset_saturation_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherInput")
    def hue_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVarInput")
    def hue_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceInput")
    def hue_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVarInput")
    def hue_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherInput")
    def lightness_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVarInput")
    def lightness_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceInput")
    def lightness_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVarInput")
    def lightness_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherInput")
    def saturation_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVarInput")
    def saturation_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceInput")
    def saturation_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVarInput")
    def saturation_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6b09010d7a7dc8953f4efa557f244893fbe2b454c8ed47742f33efb3d06a527b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeather")
    def hue_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeather"))

    @hue_feather.setter
    def hue_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__18210b876436d9b73134ff5bb55c585effd2cee8616fa4e4c5f784d3beace02d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeather", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVar")
    def hue_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeatherVar"))

    @hue_feather_var.setter
    def hue_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b8a8c4dcba056080a82552122823449db017a503e32b6a3de2e54688c7319e5f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueTolerance")
    def hue_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueTolerance"))

    @hue_tolerance.setter
    def hue_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a843f4d21d427fc4f08b937a3f93c0c717ef05684bc3b4fe80d1570b96af540b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVar")
    def hue_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueToleranceVar"))

    @hue_tolerance_var.setter
    def hue_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b1e8e17046bb84feb551b6795a4acce09d89a137f0cf124c9b894323537e20bb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8f6210a1e5677f82fc6d76b8564f6b50d71abfa95f7a886dd0e6733964501140)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeather")
    def lightness_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeather"))

    @lightness_feather.setter
    def lightness_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fc04af43b9058a227638b62ff33eafb11824e0b82080875b241787e697ba3476)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeather", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVar")
    def lightness_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeatherVar"))

    @lightness_feather_var.setter
    def lightness_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8f35d2cf33d9640d78f9f2ea751628969105188a8cfefb3203d376045aafcd22)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessTolerance")
    def lightness_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessTolerance"))

    @lightness_tolerance.setter
    def lightness_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6ad20f5fee9ae00b9c01b59df7704a9aa5d0df989c0b8b11a39fdf758b5f2115)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVar")
    def lightness_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessToleranceVar"))

    @lightness_tolerance_var.setter
    def lightness_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cb7a77bd48fbd8bcd725f714fccb7ee6e66fcf4ddde37f0e06f9a14706ad270d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeather")
    def saturation_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeather"))

    @saturation_feather.setter
    def saturation_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f366eaa27087dbfefd825afe88f17009d534ae6ec14c71e67b8bf7be43c33ea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeather", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVar")
    def saturation_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeatherVar"))

    @saturation_feather_var.setter
    def saturation_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f2c3d14c1ac51e9d5dc4eed1787964377bc881f62ce62ac8cda235bb1d187c18)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationTolerance")
    def saturation_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationTolerance"))

    @saturation_tolerance.setter
    def saturation_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5240b714b757c517269824394434631b7fcbf68d290cf567472eed094265c864)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVar")
    def saturation_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationToleranceVar"))

    @saturation_tolerance_var.setter
    def saturation_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cbf9ae636208ac1456171fdfdb318cff7293ad8ada364218ca0a75e4184ed938)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationChromaKey]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationChromaKey]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationChromaKey]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__32371fbde6c99b0183b9cc6019f5fae3f4074f67933dcd37f04a98757c84fc00)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationComposite",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "placement": "placement",
        "placement_var": "placementVar",
        "scale": "scale",
        "scale_dimension": "scaleDimension",
        "scale_dimension_var": "scaleDimensionVar",
        "scale_var": "scaleVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationComposite:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationCompositeImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        placement: typing.Optional[builtins.str] = None,
        placement_var: typing.Optional[builtins.str] = None,
        scale: typing.Optional[builtins.str] = None,
        scale_dimension: typing.Optional[builtins.str] = None,
        scale_dimension_var: typing.Optional[builtins.str] = None,
        scale_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param placement: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        :param placement_var: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        :param scale: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param scale_dimension: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        :param scale_dimension_var: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        :param scale_var: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        :param x_position: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationCompositeImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c054ea468735855bc943fc412b1aed2225b6251d8729a97f87707f93dbad1f64)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument placement", value=placement, expected_type=type_hints["placement"])
            check_type(argname="argument placement_var", value=placement_var, expected_type=type_hints["placement_var"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument scale_dimension", value=scale_dimension, expected_type=type_hints["scale_dimension"])
            check_type(argname="argument scale_dimension_var", value=scale_dimension_var, expected_type=type_hints["scale_dimension_var"])
            check_type(argname="argument scale_var", value=scale_var, expected_type=type_hints["scale_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if placement is not None:
            self._values["placement"] = placement
        if placement_var is not None:
            self._values["placement_var"] = placement_var
        if scale is not None:
            self._values["scale"] = scale
        if scale_dimension is not None:
            self._values["scale_dimension"] = scale_dimension
        if scale_dimension_var is not None:
            self._values["scale_dimension_var"] = scale_dimension_var
        if scale_var is not None:
            self._values["scale_var"] = scale_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationCompositeImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationCompositeImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        '''
        result = self._values.get("placement")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement_var(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        '''
        result = self._values.get("placement_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        '''
        result = self._values.get("scale_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        '''
        result = self._values.get("scale_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        '''
        result = self._values.get("scale_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationComposite(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationCompositeImage",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationCompositeImage:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationCompositeImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationCompositeImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationCompositeImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__927a4c07645b533b3d12bd8a0b0bb9bd7ca26e181be0eba19073cac9f529e3b3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationCompositeImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationCompositeImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1c0e9db7f82fd05d0333fb7055b0b8e87fff8d3d8e194db01cbe073ead78e04a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationCompositeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationCompositeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a80d195d5087d42c3c8ba8f5bcc8188176b96a7d9de207783d436c403f0203d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationCompositeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f3cd6cc805e07c809b86df0d680a43c656e649b9a35b0d8b6d162b0484eddb9)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationCompositeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__843d39e747263feaf27f1b8f1f5cb4e631af46f824baf5606b32feb3ba73863b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d61247a57a2726200c644ac4b74ece112a02d7d162ffc69b9f31c904df88e03d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9b319d0919d60e276e63b391155fe61bc15577afeb267ef663ed7bab0bd95441)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationComposite]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationComposite]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9be7709a7a969a030524edd1a08ba344883a90358ba2280355fbb67b6c7f81b7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationCompositeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationCompositeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__83198f14ab16e7e19b3e5552c15eaf1ae6821f4f0debc7d28f25b0a766605e32)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationCompositeImage()

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPlacement")
    def reset_placement(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacement", []))

    @jsii.member(jsii_name="resetPlacementVar")
    def reset_placement_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacementVar", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetScaleDimension")
    def reset_scale_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimension", []))

    @jsii.member(jsii_name="resetScaleDimensionVar")
    def reset_scale_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimensionVar", []))

    @jsii.member(jsii_name="resetScaleVar")
    def reset_scale_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationCompositeImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationCompositeImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationCompositeImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="placementInput")
    def placement_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementInput"))

    @builtins.property
    @jsii.member(jsii_name="placementVarInput")
    def placement_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionInput")
    def scale_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVarInput")
    def scale_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleVarInput")
    def scale_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__032d6511e759f0c3c1939d24ed048b6985496875dafe1d2f54a41e7eb04e6fc1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f07b6233489de2264b09b3fea27e05b23e4686a489c54ced0de5cc04d2bdde35)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="placement")
    def placement(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placement"))

    @placement.setter
    def placement(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7811c3415767e48322b1ae8317a422a0b9b261d20f538e7557fd42c0d1f22fe6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placement", value)

    @builtins.property
    @jsii.member(jsii_name="placementVar")
    def placement_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placementVar"))

    @placement_var.setter
    def placement_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df195c7936328859f227f374a6d7582597226eac38db6ba9db74a6bb76a35cbe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placementVar", value)

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scale"))

    @scale.setter
    def scale(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a81a42bf25007e2353f9aa97dbd0111571ec47aba9035a02d5c37777f7a60ddd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scale", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimension")
    def scale_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimension"))

    @scale_dimension.setter
    def scale_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ce82e40f407a1bd37736fea1448b769f4ffe0359d5c4abdc6098ca525685a9cd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimension", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVar")
    def scale_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimensionVar"))

    @scale_dimension_var.setter
    def scale_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9232a0682b15c1c8bbda53c68a0535e44d8cb14c0a6a78c51c61c3e1d76886ae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="scaleVar")
    def scale_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleVar"))

    @scale_var.setter
    def scale_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__31de5aff9abcef091581b1dac38861f68afbd1a193a790a63c2d56dafa2f5483)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a1744c22a67937f3e3a1c26b203b34adf8f643ee6a75114e03d2849ecb7872dc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a0404ef7e176bc2ab232d25c782e46d3b3a79eb41b9267bf552e60e0ca4be177)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6a115b75c6180eca3dc32bfbf3d2cdaf879159b82c8f17ce0723f29de72a4147)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a2b723450175d52955ebc081a071ef34cf1b414f2650489baa03b9e46ec3e174)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationComposite]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationComposite]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationComposite]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__342bdcae0a930418a08ca1d1c6d9bde9d27fac0052e8e2a398e133b1908589aa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationCompound",
    jsii_struct_bases=[],
    name_mapping={"transformations": "transformations"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationCompound:
    def __init__(
        self,
        *,
        transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param transformations: transformations block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__507d8777bd614939beab6830fbf3d1b2d1f75ed6c13b0c085cb4acd7333bfc13)
            check_type(argname="argument transformations", value=transformations, expected_type=type_hints["transformations"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if transformations is not None:
            self._values["transformations"] = transformations

    @builtins.property
    def transformations(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationCompoundTransformations"]]]:
        '''transformations block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        result = self._values.get("transformations")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationCompoundTransformations"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationCompound(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationCompoundList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationCompoundList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6da43d3565e7c217bd8aa6e957bc8d8bc81435121875e034055052942d5b508d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationCompoundOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a93f490cf27f3c207fb98e1f7feaebda880ee999521882ee8bf30cd3b8075ba5)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationCompoundOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ae4ca9a4452deb58cc554f6e80d164ccb146581b796de32dc4f451ef5d1cf0a4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__833f423ae1d1bb63ff742d1a72aff9adcd6b4cba945f940729e56b8413fbde5f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__571808d4529141ea7d4707f32db62050265ecf226667b00c78d0397e7d0bb215)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationCompound]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationCompound]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__06bdfc90374c0a9a0a3ee7a838a754eb3e0e0f8bb6eee676381f352ce9953119)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationCompoundOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationCompoundOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__207038b89baf29b7908762f0ebe6bbc5131da86afb6f5d47b64ba4b856c7bb27)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformations")
    def put_transformations(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e22bee19a53a6b2c09e959acf999736b277954251bcd5951b9819600ae1b04d8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTransformations", [value]))

    @jsii.member(jsii_name="resetTransformations")
    def reset_transformations(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformations", []))

    @builtins.property
    @jsii.member(jsii_name="transformations")
    def transformations(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationCompoundTransformationsList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationCompoundTransformationsList", jsii.get(self, "transformations"))

    @builtins.property
    @jsii.member(jsii_name="transformationsInput")
    def transformations_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationCompoundTransformations"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationCompoundTransformations"]]], jsii.get(self, "transformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationCompound]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationCompound]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationCompound]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a161682a1934027641bf8c9e6fb9d097604673ac5081390bb8e8ea16751b837)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationCompoundTransformations",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationCompoundTransformations:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationCompoundTransformations(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationCompoundTransformationsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationCompoundTransformationsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6312cfd175a17ac418064847a5ae6321345e94cda40e5f0cdaabf2dd1e786c09)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationCompoundTransformationsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__beda92af0e9d889d498f9e293cdc31e5a7dfc4006deb1ca75e3b2cce974a4cba)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationCompoundTransformationsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0244e4ea91b08d95cbf46e79870ca2c3cd34f2bf9923a98441b44390f08226cb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9e7996efee52e359b67b5394a755976cba4fff8e8430785b14e2e1b908a9d1b3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fcb20037d36c9dd766af1e8c8ca189b77ea545d0030ffe4208ceb7c5abc24a71)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationCompoundTransformations]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationCompoundTransformations]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationCompoundTransformations]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d0f18902ddbe2325801d9baeef97cb535760b90df4345b59cb92437fcba628e0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationCompoundTransformationsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationCompoundTransformationsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__63ea02ad41d8e9b40468fc3f5e7880b4d5e057799ba799da9a6aa05ae8b04255)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationCompoundTransformations]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationCompoundTransformations]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationCompoundTransformations]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__39ecc9b38549874b8630f4bddd4de173f238c434a3bf90bd0f39f27ed4a5b175)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationContrast",
    jsii_struct_bases=[],
    name_mapping={
        "brightness": "brightness",
        "brightness_var": "brightnessVar",
        "contrast": "contrast",
        "contrast_var": "contrastVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationContrast:
    def __init__(
        self,
        *,
        brightness: typing.Optional[builtins.str] = None,
        brightness_var: typing.Optional[builtins.str] = None,
        contrast: typing.Optional[builtins.str] = None,
        contrast_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param brightness: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        :param brightness_var: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        :param contrast: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param contrast_var: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__77dcef1ee89bf2bcbe35851c4a763161949daad8057058dbbd9cda34e43d47a2)
            check_type(argname="argument brightness", value=brightness, expected_type=type_hints["brightness"])
            check_type(argname="argument brightness_var", value=brightness_var, expected_type=type_hints["brightness_var"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument contrast_var", value=contrast_var, expected_type=type_hints["contrast_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if brightness is not None:
            self._values["brightness"] = brightness
        if brightness_var is not None:
            self._values["brightness_var"] = brightness_var
        if contrast is not None:
            self._values["contrast"] = contrast
        if contrast_var is not None:
            self._values["contrast_var"] = contrast_var

    @builtins.property
    def brightness(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        '''
        result = self._values.get("brightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def brightness_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        '''
        result = self._values.get("brightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        result = self._values.get("contrast_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationContrast(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationContrastList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationContrastList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__62282072d5e3053ceb1b05c794818c8bd69d720544807cb24e0c3f15e99d1cf5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationContrastOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3256ca4d46102cdc520f530b8389ac9c7d0887d33e0112e24895df6f2c67725c)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationContrastOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__72f4d68feb619db7c5ea7aff954502f77a1f7d3f50f73aa3d17baa5a9358a685)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ecdb4048ee57747257d0a0b32bba8e98ce89716dfe617d06dbea03cd02da438d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__11d7be61ebc305eb0230e446910af6c5b46e4bc53ac5a75c98d056565f16cda6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationContrast]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationContrast]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bd6e3617b1aebdf37cce8379e3e82bef3e36df1b7013c8fff4e419dc463eb96f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationContrastOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationContrastOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cf8c7335ea417dd5cda735f7670895f9744b61afeb1e6426d548082599b91b8b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetBrightness")
    def reset_brightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightness", []))

    @jsii.member(jsii_name="resetBrightnessVar")
    def reset_brightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightnessVar", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetContrastVar")
    def reset_contrast_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrastVar", []))

    @builtins.property
    @jsii.member(jsii_name="brightnessInput")
    def brightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="brightnessVarInput")
    def brightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastVarInput")
    def contrast_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="brightness")
    def brightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightness"))

    @brightness.setter
    def brightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f30d51f9064f3a4824dfcd183ccf47f84b1de324b931076949223a1237297f49)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightness", value)

    @builtins.property
    @jsii.member(jsii_name="brightnessVar")
    def brightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightnessVar"))

    @brightness_var.setter
    def brightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a7e0b1823d88846ab90d5b9be32b9f4c1f436c48e7d5a151805c6062de8fc018)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrast"))

    @contrast.setter
    def contrast(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fcd2fbddcb440caa9d5e63c2cc7850c62865c7bab11653736f7c6fb9275276de)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrast", value)

    @builtins.property
    @jsii.member(jsii_name="contrastVar")
    def contrast_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrastVar"))

    @contrast_var.setter
    def contrast_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8e47c4e087e10bdf6b33fe18fa081472fb31cbf4e69e2d65a68fad85912bd0c8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrastVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationContrast]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationContrast]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationContrast]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6a795264284b569003fa106920554b4c68cc58b9561d0020a2bf645a8f9c68e4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationCrop",
    jsii_struct_bases=[],
    name_mapping={
        "allow_expansion": "allowExpansion",
        "allow_expansion_var": "allowExpansionVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationCrop:
    def __init__(
        self,
        *,
        allow_expansion: typing.Optional[builtins.str] = None,
        allow_expansion_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_expansion: If cropping an area outside of the existing canvas, expands the image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        :param allow_expansion_var: If cropping an area outside of the existing canvas, expands the image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        :param gravity: Frame of reference for X and Y Positions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Frame of reference for X and Y Positions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The number of pixels to crop along the y-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The number of pixels to crop along the y-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The number of pixels to crop along the x-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The number of pixels to crop along the x-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        :param x_position: The x-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__afa905dc2e20fe92e3ccae49e274027d86f81ec12e755ca5930f9225d66955aa)
            check_type(argname="argument allow_expansion", value=allow_expansion, expected_type=type_hints["allow_expansion"])
            check_type(argname="argument allow_expansion_var", value=allow_expansion_var, expected_type=type_hints["allow_expansion_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if allow_expansion is not None:
            self._values["allow_expansion"] = allow_expansion
        if allow_expansion_var is not None:
            self._values["allow_expansion_var"] = allow_expansion_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def allow_expansion(self) -> typing.Optional[builtins.str]:
        '''If cropping an area outside of the existing canvas, expands the image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        '''
        result = self._values.get("allow_expansion")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def allow_expansion_var(self) -> typing.Optional[builtins.str]:
        '''If cropping an area outside of the existing canvas, expands the image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        '''
        result = self._values.get("allow_expansion_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Frame of reference for X and Y Positions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Frame of reference for X and Y Positions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the y-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the y-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the x-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the x-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__335a968bfddc3d0b0325129e8547067019c028717767b8aa90be0bcf21383ced)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aad79b07588de8ed17efdfce0f4ae5450ca387e662717b603b9ed8f40b58121b)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d7fac67d31bc4d3439bda8b0fb67dd8328fed685ad2f79d710d58e0bd5b2cfa4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b088970c0048f120acea4b1edd33850cd0e2eeaeed55866bee3008f0d2405d33)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7e9ab6e333739a3efe56c6def29712e49184ab87c7e7cae004fb632a5cba4be7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac375a99cd4e544a3ec4b56b02bb72aafb18e64327166914521a04677f67d8c3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__467fe957a36098a7568bd3b106434151c519180026d5866dd462986913bfc2c0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAllowExpansion")
    def reset_allow_expansion(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansion", []))

    @jsii.member(jsii_name="resetAllowExpansionVar")
    def reset_allow_expansion_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansionVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionInput")
    def allow_expansion_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVarInput")
    def allow_expansion_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansion")
    def allow_expansion(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansion"))

    @allow_expansion.setter
    def allow_expansion(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ceabf7d2251e07346b74d520372371bdeba8dbf6c2d379cd99d1534769eef8f6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansion", value)

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVar")
    def allow_expansion_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansionVar"))

    @allow_expansion_var.setter
    def allow_expansion_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f0d39814479927020b6bf1ac3b932205ff96a93453b86ad3fa4bf7db3a81193)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansionVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__031b8a7c2dfb8efd384fa0f66bd988e658fcbe88f5a6a4042169917b385deb0d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__10f6b5dad56bfd012af711ea01f06214bd44cb9a8eaee95fdc6d8037bde1f2d6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__47f0edf3ec4ffbb7d8a0261c133803f2a51e7008b9eb60464a7005d67d0a1457)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3842ec23317c962879740a93d967b4ade78ee684ddef6b132fc516a79837aefc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a432ed5291f22ac204de5715d9a0ef8bf507e2aa276506b37f797703f02a8c45)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__40fb303c0ecaedb69c3082a6e1fb1e5940e95c840ec010b424d9b13160e75d60)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f5c60b23e0069526324a9cc60b5490c4de6c2c75fc067d0b6ce46a31a0f3dce4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__14d37ce9e97618775aec62d3134e8c38e6029458aac68fcd0dcffa64f660f5ca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__48d495758ca6216ced625e61dbe5c9f969ab9837a680cf3a9b23d30349640d58)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__326a391723d24f20659f2c0eb99223faba17daaba655f93a8eee950308b686ab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b1e634d90ad1b2e17293187be88eaab32834545b3b46d7376c2d74622748adb7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationFaceCrop",
    jsii_struct_bases=[],
    name_mapping={
        "algorithm": "algorithm",
        "algorithm_var": "algorithmVar",
        "confidence": "confidence",
        "confidence_var": "confidenceVar",
        "fail_gravity": "failGravity",
        "fail_gravity_var": "failGravityVar",
        "focus": "focus",
        "focus_var": "focusVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "padding": "padding",
        "padding_var": "paddingVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationFaceCrop:
    def __init__(
        self,
        *,
        algorithm: typing.Optional[builtins.str] = None,
        algorithm_var: typing.Optional[builtins.str] = None,
        confidence: typing.Optional[builtins.str] = None,
        confidence_var: typing.Optional[builtins.str] = None,
        fail_gravity: typing.Optional[builtins.str] = None,
        fail_gravity_var: typing.Optional[builtins.str] = None,
        focus: typing.Optional[builtins.str] = None,
        focus_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param algorithm: Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm DataAkamaiImagingPolicyImage#algorithm}
        :param algorithm_var: Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm_var DataAkamaiImagingPolicyImage#algorithm_var}
        :param confidence: With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image. Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence DataAkamaiImagingPolicyImage#confidence}
        :param confidence_var: With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image. Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence_var DataAkamaiImagingPolicyImage#confidence_var}
        :param fail_gravity: Controls placement of the crop if Image and Video Manager does not detect any faces in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        :param fail_gravity_var: Controls placement of the crop if Image and Video Manager does not detect any faces in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        :param focus: Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus DataAkamaiImagingPolicyImage#focus}
        :param focus_var: Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus_var DataAkamaiImagingPolicyImage#focus_var}
        :param gravity: Controls placement of the crop. Directions are relative to the face(s) plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Controls placement of the crop. Directions are relative to the face(s) plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param padding: The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        :param style: Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b14a4422350c3eac27c35302e80fc918db1cb4cf309482fe8cbb8c0d752e4648)
            check_type(argname="argument algorithm", value=algorithm, expected_type=type_hints["algorithm"])
            check_type(argname="argument algorithm_var", value=algorithm_var, expected_type=type_hints["algorithm_var"])
            check_type(argname="argument confidence", value=confidence, expected_type=type_hints["confidence"])
            check_type(argname="argument confidence_var", value=confidence_var, expected_type=type_hints["confidence_var"])
            check_type(argname="argument fail_gravity", value=fail_gravity, expected_type=type_hints["fail_gravity"])
            check_type(argname="argument fail_gravity_var", value=fail_gravity_var, expected_type=type_hints["fail_gravity_var"])
            check_type(argname="argument focus", value=focus, expected_type=type_hints["focus"])
            check_type(argname="argument focus_var", value=focus_var, expected_type=type_hints["focus_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if algorithm is not None:
            self._values["algorithm"] = algorithm
        if algorithm_var is not None:
            self._values["algorithm_var"] = algorithm_var
        if confidence is not None:
            self._values["confidence"] = confidence
        if confidence_var is not None:
            self._values["confidence_var"] = confidence_var
        if fail_gravity is not None:
            self._values["fail_gravity"] = fail_gravity
        if fail_gravity_var is not None:
            self._values["fail_gravity_var"] = fail_gravity_var
        if focus is not None:
            self._values["focus"] = focus
        if focus_var is not None:
            self._values["focus_var"] = focus_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def algorithm(self) -> typing.Optional[builtins.str]:
        '''Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm DataAkamaiImagingPolicyImage#algorithm}
        '''
        result = self._values.get("algorithm")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def algorithm_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm_var DataAkamaiImagingPolicyImage#algorithm_var}
        '''
        result = self._values.get("algorithm_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def confidence(self) -> typing.Optional[builtins.str]:
        '''With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image.

        Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence DataAkamaiImagingPolicyImage#confidence}
        '''
        result = self._values.get("confidence")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def confidence_var(self) -> typing.Optional[builtins.str]:
        '''With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image.

        Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence_var DataAkamaiImagingPolicyImage#confidence_var}
        '''
        result = self._values.get("confidence_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any faces in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        '''
        result = self._values.get("fail_gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any faces in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        '''
        result = self._values.get("fail_gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def focus(self) -> typing.Optional[builtins.str]:
        '''Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus DataAkamaiImagingPolicyImage#focus}
        '''
        result = self._values.get("focus")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def focus_var(self) -> typing.Optional[builtins.str]:
        '''Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus_var DataAkamaiImagingPolicyImage#focus_var}
        '''
        result = self._values.get("focus_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the face(s) plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the face(s) plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationFaceCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationFaceCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationFaceCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac7fd9dfa49a033fabee2afff698d5874741ba354a9c194641a92a5445c21a30)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationFaceCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__45dc2c0522fdfb7b717b0a4c0377dbfd0fa78c0ef8e608d30b258c7494092ab6)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationFaceCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__38ec2227c9858f91d67b92d356659ff33a94b5df227d71e49d9bfb69b2810266)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e5dd0c7cefb77e3c9a668b22a261c4a6fd9e0e506ae5e6e850792ec2b7a4d5d5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__857d28af6559b63b831f2aab8b810912d65c211afa8a14ed1bad9e37f6b9bf9c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationFaceCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationFaceCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationFaceCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c6c0829e3ef88f252f888842779b9df9a319f4d591f76fc54aaee73efa2b5064)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationFaceCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationFaceCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0738944727669837c5b3357d9854b1fbfe676fd7cc19346ef88a01d9c7b5d888)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAlgorithm")
    def reset_algorithm(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAlgorithm", []))

    @jsii.member(jsii_name="resetAlgorithmVar")
    def reset_algorithm_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAlgorithmVar", []))

    @jsii.member(jsii_name="resetConfidence")
    def reset_confidence(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetConfidence", []))

    @jsii.member(jsii_name="resetConfidenceVar")
    def reset_confidence_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetConfidenceVar", []))

    @jsii.member(jsii_name="resetFailGravity")
    def reset_fail_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravity", []))

    @jsii.member(jsii_name="resetFailGravityVar")
    def reset_fail_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravityVar", []))

    @jsii.member(jsii_name="resetFocus")
    def reset_focus(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFocus", []))

    @jsii.member(jsii_name="resetFocusVar")
    def reset_focus_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFocusVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="algorithmInput")
    def algorithm_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "algorithmInput"))

    @builtins.property
    @jsii.member(jsii_name="algorithmVarInput")
    def algorithm_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "algorithmVarInput"))

    @builtins.property
    @jsii.member(jsii_name="confidenceInput")
    def confidence_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "confidenceInput"))

    @builtins.property
    @jsii.member(jsii_name="confidenceVarInput")
    def confidence_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "confidenceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityInput")
    def fail_gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityVarInput")
    def fail_gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="focusInput")
    def focus_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "focusInput"))

    @builtins.property
    @jsii.member(jsii_name="focusVarInput")
    def focus_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "focusVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="algorithm")
    def algorithm(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "algorithm"))

    @algorithm.setter
    def algorithm(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__62f921f83d200ff062a71b833b1499352b3a8df020a0aa77fd710f04bc1a3bb9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "algorithm", value)

    @builtins.property
    @jsii.member(jsii_name="algorithmVar")
    def algorithm_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "algorithmVar"))

    @algorithm_var.setter
    def algorithm_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b7378ca5e54b56b3ee5318edec2e92ae16f45cf9f4e2045e5720a83c4c74f82f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "algorithmVar", value)

    @builtins.property
    @jsii.member(jsii_name="confidence")
    def confidence(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "confidence"))

    @confidence.setter
    def confidence(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__057946bd71d523f2270016f04b95b0522818cc8831b454e7b3b7610008f749bc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "confidence", value)

    @builtins.property
    @jsii.member(jsii_name="confidenceVar")
    def confidence_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "confidenceVar"))

    @confidence_var.setter
    def confidence_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f7511929ebd2ec40dbb7aa053b6bfb8b2af51b0edb1bc258edcd85d4bf66b870)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "confidenceVar", value)

    @builtins.property
    @jsii.member(jsii_name="failGravity")
    def fail_gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravity"))

    @fail_gravity.setter
    def fail_gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1fc0c84f9362f00757fa45cb455428436a863a8a3265b670d4015a6f2fff25bb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravity", value)

    @builtins.property
    @jsii.member(jsii_name="failGravityVar")
    def fail_gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravityVar"))

    @fail_gravity_var.setter
    def fail_gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cb9c7521ba4a368532339d2920fac6f6e4f28f99ef50eda8805f0f37b1b5f474)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="focus")
    def focus(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "focus"))

    @focus.setter
    def focus(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__434602c91444a380a38b1bd6b3cc3613484547aba61d823740587b989a40f8bb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "focus", value)

    @builtins.property
    @jsii.member(jsii_name="focusVar")
    def focus_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "focusVar"))

    @focus_var.setter
    def focus_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__641b851dbef8e550ef177e64149eea91749e034795ed549c577b96917901c703)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "focusVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__94e0a20c8509c2fe9578db7560f8d09b855219866a3456629e3121f200c82b58)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a3368f94059ca48105cdd23a8daa20a64b92def9a844a727fa3defd854b021ca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3d6dc73d7dfa03fa87f2a809f0cd89b417ac6b8c92356c2ec45bfbcab29ec129)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b143446725d0df1bc514034ea743deaa3d9eca32d19e10f7be31582f51cc0a01)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b39127cd3bbb5d0efbefff92d456589957a50f392acbef9a15605e322c647486)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e67a871b8780b0ae26c068788e4240c15725e8e8e4ad3d29c7aa3ed8f4e8008e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2cfccfcb5a3883442476356e827edbf106a3d914dea8e4ec31905954ab0fdc3e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d17fb1d010b49a976247c39108b81557be5348f2ac2d9345d37eaf735ba260d4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a44ed0c5ba1aca261efcb9e1051c54ecbf21148d85aac0c3029cec5b16c9802)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fc13126f5e8bb021fdffb080e30d63a6e0ea5318259fc640380765c8fd38c3bf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationFaceCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationFaceCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationFaceCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__729cab8882b01cd716772ce00096cf49849176734edc518ce9a44931545a2e88)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationFeatureCrop",
    jsii_struct_bases=[],
    name_mapping={
        "fail_gravity": "failGravity",
        "fail_gravity_var": "failGravityVar",
        "feature_radius": "featureRadius",
        "feature_radius_var": "featureRadiusVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "max_features": "maxFeatures",
        "max_features_var": "maxFeaturesVar",
        "min_feature_quality": "minFeatureQuality",
        "min_feature_quality_var": "minFeatureQualityVar",
        "padding": "padding",
        "padding_var": "paddingVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationFeatureCrop:
    def __init__(
        self,
        *,
        fail_gravity: typing.Optional[builtins.str] = None,
        fail_gravity_var: typing.Optional[builtins.str] = None,
        feature_radius: typing.Optional[builtins.str] = None,
        feature_radius_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        max_features: typing.Optional[builtins.str] = None,
        max_features_var: typing.Optional[builtins.str] = None,
        min_feature_quality: typing.Optional[builtins.str] = None,
        min_feature_quality_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fail_gravity: Controls placement of the crop if Image and Video Manager does not detect any features in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        :param fail_gravity_var: Controls placement of the crop if Image and Video Manager does not detect any features in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        :param feature_radius: The size in pixels of the important features to search for. If identified, two features never appear closer together than this value, ``8.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius DataAkamaiImagingPolicyImage#feature_radius}
        :param feature_radius_var: The size in pixels of the important features to search for. If identified, two features never appear closer together than this value, ``8.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius_var DataAkamaiImagingPolicyImage#feature_radius_var}
        :param gravity: Controls placement of the crop. Directions are relative to the region of interest plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Controls placement of the crop. Directions are relative to the region of interest plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param max_features: The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features DataAkamaiImagingPolicyImage#max_features}
        :param max_features_var: The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features_var DataAkamaiImagingPolicyImage#max_features_var}
        :param min_feature_quality: Determines the minimum quality level of the feature identified. To consider a feature important, the feature needs to surpass this value. Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality DataAkamaiImagingPolicyImage#min_feature_quality}
        :param min_feature_quality_var: Determines the minimum quality level of the feature identified. To consider a feature important, the feature needs to surpass this value. Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality_var DataAkamaiImagingPolicyImage#min_feature_quality_var}
        :param padding: Adds space around the region of interest. The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: Adds space around the region of interest. The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        :param style: Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__58c4f763cf9af9ac731372e6591f0bf6551377f7b0460d8e383f6212d509f110)
            check_type(argname="argument fail_gravity", value=fail_gravity, expected_type=type_hints["fail_gravity"])
            check_type(argname="argument fail_gravity_var", value=fail_gravity_var, expected_type=type_hints["fail_gravity_var"])
            check_type(argname="argument feature_radius", value=feature_radius, expected_type=type_hints["feature_radius"])
            check_type(argname="argument feature_radius_var", value=feature_radius_var, expected_type=type_hints["feature_radius_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument max_features", value=max_features, expected_type=type_hints["max_features"])
            check_type(argname="argument max_features_var", value=max_features_var, expected_type=type_hints["max_features_var"])
            check_type(argname="argument min_feature_quality", value=min_feature_quality, expected_type=type_hints["min_feature_quality"])
            check_type(argname="argument min_feature_quality_var", value=min_feature_quality_var, expected_type=type_hints["min_feature_quality_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fail_gravity is not None:
            self._values["fail_gravity"] = fail_gravity
        if fail_gravity_var is not None:
            self._values["fail_gravity_var"] = fail_gravity_var
        if feature_radius is not None:
            self._values["feature_radius"] = feature_radius
        if feature_radius_var is not None:
            self._values["feature_radius_var"] = feature_radius_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if max_features is not None:
            self._values["max_features"] = max_features
        if max_features_var is not None:
            self._values["max_features_var"] = max_features_var
        if min_feature_quality is not None:
            self._values["min_feature_quality"] = min_feature_quality
        if min_feature_quality_var is not None:
            self._values["min_feature_quality_var"] = min_feature_quality_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def fail_gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any features in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        '''
        result = self._values.get("fail_gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any features in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        '''
        result = self._values.get("fail_gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feature_radius(self) -> typing.Optional[builtins.str]:
        '''The size in pixels of the important features to search for.

        If identified, two features never appear closer together than this value, ``8.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius DataAkamaiImagingPolicyImage#feature_radius}
        '''
        result = self._values.get("feature_radius")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feature_radius_var(self) -> typing.Optional[builtins.str]:
        '''The size in pixels of the important features to search for.

        If identified, two features never appear closer together than this value, ``8.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius_var DataAkamaiImagingPolicyImage#feature_radius_var}
        '''
        result = self._values.get("feature_radius_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the region of interest plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the region of interest plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def max_features(self) -> typing.Optional[builtins.str]:
        '''The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features DataAkamaiImagingPolicyImage#max_features}
        '''
        result = self._values.get("max_features")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def max_features_var(self) -> typing.Optional[builtins.str]:
        '''The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features_var DataAkamaiImagingPolicyImage#max_features_var}
        '''
        result = self._values.get("max_features_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def min_feature_quality(self) -> typing.Optional[builtins.str]:
        '''Determines the minimum quality level of the feature identified.

        To consider a feature important, the feature needs to surpass this value.  Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality DataAkamaiImagingPolicyImage#min_feature_quality}
        '''
        result = self._values.get("min_feature_quality")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def min_feature_quality_var(self) -> typing.Optional[builtins.str]:
        '''Determines the minimum quality level of the feature identified.

        To consider a feature important, the feature needs to surpass this value.  Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality_var DataAkamaiImagingPolicyImage#min_feature_quality_var}
        '''
        result = self._values.get("min_feature_quality_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''Adds space around the region of interest.

        The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''Adds space around the region of interest.

        The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationFeatureCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationFeatureCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationFeatureCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e32d0a19b8baee4cb9e5f2f5175cfc06f5f4b1ab8376ec8217009fb783ae6ef0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationFeatureCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a65c5358d18944636881ec35d00e1f96dc1293df1244d1843407244e424c2804)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationFeatureCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9e41538adf3698e779c49910ef513fda45830f1f9a70226363a44210fe3a315e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__14dec77d637ad9c63efe868f3b5b487880928cb4f2147d7d11cf1467fe3efcbd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5df01279816b82af7ff76334c63970748ae32d45e3696821f1b9e2f0f1dfc97b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationFeatureCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationFeatureCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationFeatureCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c6dbfba147f64c8e6813ca531f4e18c30c005c883b2041f3f19d4904c5658001)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationFeatureCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationFeatureCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8576065e7e349a450b105cc1f78cb11ae5a306a4f60e7e88653f11e1b288eca9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetFailGravity")
    def reset_fail_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravity", []))

    @jsii.member(jsii_name="resetFailGravityVar")
    def reset_fail_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravityVar", []))

    @jsii.member(jsii_name="resetFeatureRadius")
    def reset_feature_radius(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureRadius", []))

    @jsii.member(jsii_name="resetFeatureRadiusVar")
    def reset_feature_radius_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureRadiusVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetMaxFeatures")
    def reset_max_features(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxFeatures", []))

    @jsii.member(jsii_name="resetMaxFeaturesVar")
    def reset_max_features_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxFeaturesVar", []))

    @jsii.member(jsii_name="resetMinFeatureQuality")
    def reset_min_feature_quality(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMinFeatureQuality", []))

    @jsii.member(jsii_name="resetMinFeatureQualityVar")
    def reset_min_feature_quality_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMinFeatureQualityVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="failGravityInput")
    def fail_gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityVarInput")
    def fail_gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featureRadiusInput")
    def feature_radius_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featureRadiusInput"))

    @builtins.property
    @jsii.member(jsii_name="featureRadiusVarInput")
    def feature_radius_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featureRadiusVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesInput")
    def max_features_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "maxFeaturesInput"))

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesVarInput")
    def max_features_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "maxFeaturesVarInput"))

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityInput")
    def min_feature_quality_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "minFeatureQualityInput"))

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityVarInput")
    def min_feature_quality_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "minFeatureQualityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravity")
    def fail_gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravity"))

    @fail_gravity.setter
    def fail_gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8882a27d0519a994c7045e788dce6b5a87afe6c7cad9548dca94bff94f0bf72d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravity", value)

    @builtins.property
    @jsii.member(jsii_name="failGravityVar")
    def fail_gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravityVar"))

    @fail_gravity_var.setter
    def fail_gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c9726cfb5de5ae87420aa434346c45c94939a830e6fbc47e02007c284b1ce874)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="featureRadius")
    def feature_radius(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featureRadius"))

    @feature_radius.setter
    def feature_radius(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__73d2904b1ccba1daaee72a95132a6238e6a09ec3da2285273d52b067093e4436)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featureRadius", value)

    @builtins.property
    @jsii.member(jsii_name="featureRadiusVar")
    def feature_radius_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featureRadiusVar"))

    @feature_radius_var.setter
    def feature_radius_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3292780d7103d4d786f9e3d1812b32434c18ebe542b543a83157c0955a43b1e7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featureRadiusVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fd50621728e77d65b5bbef4266fa3f7f93d01d55f138452966cba136dc5445c4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1cb8487fcc8b2e6005846d7da3ad86fa7366ecfa9359842a822de8fa31120315)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c76924d4af43327f9d627bdd9325827508735c38b41568eec0c109ce1b39d489)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f38e0d50cc9f6422dcbc4c4dfabd39d95cac491d5fa7ae0596752aeacada59e2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="maxFeatures")
    def max_features(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "maxFeatures"))

    @max_features.setter
    def max_features(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c8076d0688930b71b2fea28db709bd27f554f13a1d237f3f25f5199c2fd2725b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "maxFeatures", value)

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesVar")
    def max_features_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "maxFeaturesVar"))

    @max_features_var.setter
    def max_features_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__95387154da2722e24c67f59576ba4ffa8e111d609c9435a51472df48bc2974e5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "maxFeaturesVar", value)

    @builtins.property
    @jsii.member(jsii_name="minFeatureQuality")
    def min_feature_quality(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "minFeatureQuality"))

    @min_feature_quality.setter
    def min_feature_quality(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__49ff247a8402ffb0b96240455c8f86e42703bd2727b19b3250b74ed024efadb4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "minFeatureQuality", value)

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityVar")
    def min_feature_quality_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "minFeatureQualityVar"))

    @min_feature_quality_var.setter
    def min_feature_quality_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__32131e8a6e206be3c8492f33b2acb915d184b7f9816053a869e432a6d704d85a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "minFeatureQualityVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d37287ff292b8607bb25a502d8d3f2d9f1ff9c52b47c3245894f6c38f38bc463)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9458594998a9a49d59fb9d4be6de981a706f55f347006ecbc42eb9ae4e6a9a71)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__692117c07fb206791f5b49ca86def72c710bcaca160913b33d52d5b390697846)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a23bb8a2c2c88954f750830bf997231d1a9108197721eea00dd1809c2d73f85b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__038bb77a8012588da97124691aed7cf6384ed9e0d9a4deba22f9e9d711555bd5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8ecaf3f565c5eded1a7ec327c87a0dce331d22af2bc6bacfcffc6549178865a6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationFeatureCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationFeatureCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationFeatureCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ee2adacc04d1920132a90633156c1b3cc23f935ed510d2235114c13a1378271)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationFitAndFill",
    jsii_struct_bases=[],
    name_mapping={
        "fill_transformation": "fillTransformation",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationFitAndFill:
    def __init__(
        self,
        *,
        fill_transformation: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationFitAndFillFillTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fill_transformation: fill_transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_transformation DataAkamaiImagingPolicyImage#fill_transformation}
        :param height: The height value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The width value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(fill_transformation, dict):
            fill_transformation = DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationFitAndFillFillTransformation(**fill_transformation)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__438863c2136af3716571296ce2fd8c45de5b4ded4cca3f44829b0557672672e9)
            check_type(argname="argument fill_transformation", value=fill_transformation, expected_type=type_hints["fill_transformation"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fill_transformation is not None:
            self._values["fill_transformation"] = fill_transformation
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def fill_transformation(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationFitAndFillFillTransformation"]:
        '''fill_transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_transformation DataAkamaiImagingPolicyImage#fill_transformation}
        '''
        result = self._values.get("fill_transformation")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationFitAndFillFillTransformation"], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationFitAndFill(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationFitAndFillFillTransformation",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationFitAndFillFillTransformation:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationFitAndFillFillTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationFitAndFillFillTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationFitAndFillFillTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__90aafd15fde3029226c834731ad8445313ade01a63177686fe38d13c4fd1d0c1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationFitAndFillFillTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationFitAndFillFillTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationFitAndFillFillTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5e146bf88508e555bf7ec2da851d10efa867d7e77c36fbcf47bf015891489acc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationFitAndFillList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationFitAndFillList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3244e930de1390a4e1a43a73dbbbcf270792cdebacd32b692377c461f8e11b9c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationFitAndFillOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dedd9ca71a6e8af876593f7bcbd52abbb204be40de33de1d76f9c830758f01e8)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationFitAndFillOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4e4659c636aac146bc7f33a088a58a4550ae8fc390546e270e05055a729a2924)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__58f3d3d809033cec0a616509913f8aa770d9796a78137b39c6c88a1444259413)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3966dab3b893dc7093fd147dbb6477a6edcaaa0f82f32e9b52aad3dbf6f335bf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationFitAndFill]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationFitAndFill]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationFitAndFill]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d7b2d1d404bc729103ad9f5d6698c8922ef78d5be909fe67b83c74ba06423327)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationFitAndFillOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationFitAndFillOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b4e39ff74314bb9a5b2ae19df7b2a3e01e7ca0b2ce1e7bedb939f1e6d6eee628)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putFillTransformation")
    def put_fill_transformation(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationFitAndFillFillTransformation()

        return typing.cast(None, jsii.invoke(self, "putFillTransformation", [value]))

    @jsii.member(jsii_name="resetFillTransformation")
    def reset_fill_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFillTransformation", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="fillTransformation")
    def fill_transformation(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationFitAndFillFillTransformationOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationFitAndFillFillTransformationOutputReference, jsii.get(self, "fillTransformation"))

    @builtins.property
    @jsii.member(jsii_name="fillTransformationInput")
    def fill_transformation_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationFitAndFillFillTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationFitAndFillFillTransformation], jsii.get(self, "fillTransformationInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb1d003728020781a91059331f13838069b9fc491a0a0d8a3e9a95220d971997)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cf1ee39012a5f0da502539fcc5d5c7c585f53ac7fa58a16ace8fd4f11e484aa6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__504838eff4c4efb0957ff0f16d76886d3ef4dbabf7cca1def9b6243f6fa9ef4f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6a0fb90a61d4123d5cae625841c0abea13a01129142376636c30af2cfc89370e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationFitAndFill]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationFitAndFill]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationFitAndFill]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b0f4aa4b1c6f811ae648623c1d1c61471e1ecb5463d6d011d3daa07c5218dd43)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationGoop",
    jsii_struct_bases=[],
    name_mapping={
        "chaos": "chaos",
        "chaos_var": "chaosVar",
        "density": "density",
        "density_var": "densityVar",
        "power": "power",
        "power_var": "powerVar",
        "seed": "seed",
        "seed_var": "seedVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationGoop:
    def __init__(
        self,
        *,
        chaos: typing.Optional[builtins.str] = None,
        chaos_var: typing.Optional[builtins.str] = None,
        density: typing.Optional[builtins.str] = None,
        density_var: typing.Optional[builtins.str] = None,
        power: typing.Optional[builtins.str] = None,
        power_var: typing.Optional[builtins.str] = None,
        seed: typing.Optional[builtins.str] = None,
        seed_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param chaos: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        :param chaos_var: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        :param density: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        :param density_var: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        :param power: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        :param power_var: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        :param seed: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        :param seed_var: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dcae865fdf32147b421d7dde8f79e358afc9f03f0836d8e4d5fc4e11ce6f73a8)
            check_type(argname="argument chaos", value=chaos, expected_type=type_hints["chaos"])
            check_type(argname="argument chaos_var", value=chaos_var, expected_type=type_hints["chaos_var"])
            check_type(argname="argument density", value=density, expected_type=type_hints["density"])
            check_type(argname="argument density_var", value=density_var, expected_type=type_hints["density_var"])
            check_type(argname="argument power", value=power, expected_type=type_hints["power"])
            check_type(argname="argument power_var", value=power_var, expected_type=type_hints["power_var"])
            check_type(argname="argument seed", value=seed, expected_type=type_hints["seed"])
            check_type(argname="argument seed_var", value=seed_var, expected_type=type_hints["seed_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if chaos is not None:
            self._values["chaos"] = chaos
        if chaos_var is not None:
            self._values["chaos_var"] = chaos_var
        if density is not None:
            self._values["density"] = density
        if density_var is not None:
            self._values["density_var"] = density_var
        if power is not None:
            self._values["power"] = power
        if power_var is not None:
            self._values["power_var"] = power_var
        if seed is not None:
            self._values["seed"] = seed
        if seed_var is not None:
            self._values["seed_var"] = seed_var

    @builtins.property
    def chaos(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        '''
        result = self._values.get("chaos")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def chaos_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        '''
        result = self._values.get("chaos_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        '''
        result = self._values.get("density")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density_var(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        '''
        result = self._values.get("density_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        '''
        result = self._values.get("power")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power_var(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        '''
        result = self._values.get("power_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        '''
        result = self._values.get("seed")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed_var(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        result = self._values.get("seed_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationGoop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationGoopList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationGoopList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__27d0180a7a234c37eb0c418a6234f7cb1595b7726184639665bdae14dfba5657)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationGoopOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea465c2620fa189c7de28883ada5c7ddd4c45fb2e8b6f9040503bff6e4f3b7e0)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationGoopOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e496218a963bf48db8fcf3d326953de7a36357c7b42f48f5c8938c2a0e02d57d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0cd16a84b240a75b1d3904b77abaae77f7f1551dd8d7dcb908a99aae271c229f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__071e8d1abf9c0231636f703d10d93124a6a9258d6268ce3057cc8a2864d449ef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationGoop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationGoop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__808a5ebc4f42c75b495fa4eb0e717f287c5c4c84e19aa98819f48ba83655f29d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationGoopOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationGoopOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__76639e25325c1b2ec184d1a39824822e26cc2a54588a171450f39f3cd813642c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetChaos")
    def reset_chaos(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaos", []))

    @jsii.member(jsii_name="resetChaosVar")
    def reset_chaos_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaosVar", []))

    @jsii.member(jsii_name="resetDensity")
    def reset_density(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensity", []))

    @jsii.member(jsii_name="resetDensityVar")
    def reset_density_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensityVar", []))

    @jsii.member(jsii_name="resetPower")
    def reset_power(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPower", []))

    @jsii.member(jsii_name="resetPowerVar")
    def reset_power_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPowerVar", []))

    @jsii.member(jsii_name="resetSeed")
    def reset_seed(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeed", []))

    @jsii.member(jsii_name="resetSeedVar")
    def reset_seed_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeedVar", []))

    @builtins.property
    @jsii.member(jsii_name="chaosInput")
    def chaos_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosInput"))

    @builtins.property
    @jsii.member(jsii_name="chaosVarInput")
    def chaos_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosVarInput"))

    @builtins.property
    @jsii.member(jsii_name="densityInput")
    def density_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityInput"))

    @builtins.property
    @jsii.member(jsii_name="densityVarInput")
    def density_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="powerInput")
    def power_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerInput"))

    @builtins.property
    @jsii.member(jsii_name="powerVarInput")
    def power_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerVarInput"))

    @builtins.property
    @jsii.member(jsii_name="seedInput")
    def seed_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedInput"))

    @builtins.property
    @jsii.member(jsii_name="seedVarInput")
    def seed_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedVarInput"))

    @builtins.property
    @jsii.member(jsii_name="chaos")
    def chaos(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaos"))

    @chaos.setter
    def chaos(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b8ca3c04d2feffb9a4edf9e51ddf84323f4aa817d1ce6954022d06f1a45aa1a6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaos", value)

    @builtins.property
    @jsii.member(jsii_name="chaosVar")
    def chaos_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaosVar"))

    @chaos_var.setter
    def chaos_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b90635cf1dd82e4b0f4b9a40fd44a6e7c9e60d78589b65ecd30a11e25d5ec812)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaosVar", value)

    @builtins.property
    @jsii.member(jsii_name="density")
    def density(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "density"))

    @density.setter
    def density(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fad836daac02c6976db30bc481f393876948822db8e0da24d066525ca8c39fbe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "density", value)

    @builtins.property
    @jsii.member(jsii_name="densityVar")
    def density_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "densityVar"))

    @density_var.setter
    def density_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2b40a35a6789135c13becbe2c534901964ae1d70ab982d22dd22b1eb807b0bc8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "densityVar", value)

    @builtins.property
    @jsii.member(jsii_name="power")
    def power(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "power"))

    @power.setter
    def power(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1d0da73b73f136d529d7dc38b29b0b94b292d5790964849f0d96434ed0311acd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "power", value)

    @builtins.property
    @jsii.member(jsii_name="powerVar")
    def power_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "powerVar"))

    @power_var.setter
    def power_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__97902bf6ac0a8d25cac033cb716b180a84f251342714f256fc9ad482b9541546)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "powerVar", value)

    @builtins.property
    @jsii.member(jsii_name="seed")
    def seed(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seed"))

    @seed.setter
    def seed(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__efb5775a048ef5a45f1f7ccff7bc6ca436a3581d0966326d81d61397222cb709)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seed", value)

    @builtins.property
    @jsii.member(jsii_name="seedVar")
    def seed_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seedVar"))

    @seed_var.setter
    def seed_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__88957f0fc0dda249cbcabd623d8bb6601abfdc9a070e5f2025e74f21706acc14)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seedVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationGoop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationGoop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationGoop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7ee2384c4253db84cb5f49eba09c721d5b10449c4df7f93042cd9b436cb969ad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationGrayscale",
    jsii_struct_bases=[],
    name_mapping={"type": "type", "type_var": "typeVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationGrayscale:
    def __init__(
        self,
        *,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param type: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7e328a92654de84f3cfe829dc884ace67c871932202ce3b4d81cddea9ed11ed3)
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationGrayscale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationGrayscaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationGrayscaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6ba3b17490754b423b0f74483b7f4828749e5b77403452fe0b0d5f29d5277707)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationGrayscaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__79d5a60cf3ba96c1558fcd03f8443de1144fecad9cb5db3326a97c48db5ea1c4)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationGrayscaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5a5f662be7d1e6d52e5ac3c7e8749c701e0ba01f722d31fc8bae2e01836a6d81)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__19e7d46c1d6c730fda9f36cdc11fa996361ff2654e5c998bff94bdb6db7b1eab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6126b62c6f1f78133f836eb3edc33219c8674467e8c7f0ba0612d6a8d0f09ef9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationGrayscale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationGrayscale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5add1374d34369bf14747e11ab85742da732ffce8fc561c4eae2288826e95a6b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationGrayscaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationGrayscaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4278c3f0c365e048efec1ef62c801990848a133913625794eda468483249e715)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5722bffd613068d7cfa0e34bf945a82262e913a63952965b7f8bbb42548a0bea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2905e0ee039302be555e6408b8d2e81de651fca2afbfed903c61a6328a15026c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationGrayscale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationGrayscale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationGrayscale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2e22e47e18cc6ca1f4dfb2af4a0d40e3cc61477cb9c5418cf30b1ef6a8c1f2af)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationHsl",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "lightness": "lightness",
        "lightness_var": "lightnessVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationHsl:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness: typing.Optional[builtins.str] = None,
        lightness_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        :param lightness_var: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8ff4265d95c22b67433317b1786bcaf46dff75ecddfe512cb5c2065719c1bc29)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness", value=lightness, expected_type=type_hints["lightness"])
            check_type(argname="argument lightness_var", value=lightness_var, expected_type=type_hints["lightness_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness is not None:
            self._values["lightness"] = lightness
        if lightness_var is not None:
            self._values["lightness_var"] = lightness_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        '''
        result = self._values.get("lightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        '''
        result = self._values.get("lightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationHsl(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationHslList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationHslList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b838b418144f00c9d33587fa09a3eb3615fec504870db0d732e062428293d50e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationHslOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0553ffb80533305c9c7213ca39461e19a1414d26db16d48cc175f1763e216c70)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationHslOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__89aa86ab2b5e804d04b408ac7b03f367c5bf2e67265439490f6b4a44f12e4b77)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__42a7e0efc1d5d6b3fd3ba9e18a09b63434bde9d3efc2fea642656471732fe089)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0fcdeb1c2e2a6858ac3032c297a85e0d6785aa2d220ac065a3e1ec55f73c342e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationHsl]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationHsl]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__07363bfc1ee339b85f6e594f96b7150e5b5ce94a36eaac360fef10fbee483110)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationHslOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationHslOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fe47d8c6012173504bf32912d4bf2fdbe2062140e0e76565bcbfcac14941dc1e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightness")
    def reset_lightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightness", []))

    @jsii.member(jsii_name="resetLightnessVar")
    def reset_lightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessInput")
    def lightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessVarInput")
    def lightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4150cc854d8634d60e9ea90d716969374fc5a7e70a1692b7d837237111fd4686)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4f40ac70d677e16961e9707555db92a505eeae93df0ee161be9669a5ec228531)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightness")
    def lightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightness"))

    @lightness.setter
    def lightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a5ea94027d19b56bb18cffd9ac64238d608dc416b57b2a0a26c783f0a5c307f9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightness", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessVar")
    def lightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessVar"))

    @lightness_var.setter
    def lightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9247345c7d4d3dc87efd6be0f8e2cff366c27d9a989267160a1a92d3f5057988)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__584220328eeba2b39f0cac8a3085ba8bb738b1e95846bf42c28d50137e2da54d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fce645ad244de666d3dd37831844b0a2a3b9872a585dfd58685f670508c48196)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationHsl]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationHsl]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationHsl]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be08102d29753ca730583bbb0a3f2f9aa0caf4de8e11009473d3b2d4a9f22c7e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationHsv",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationHsv:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        :param value: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__63e2e3f3dc8bb2c1aaa77885b923a9b96be5a154a2e43f17a351c52e712a0e32)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationHsv(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationHsvList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationHsvList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0139cf157aeb1855f34c619a942c3723b83294b3da5118c51861e68757d65622)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationHsvOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__926837c1923811adc29f53c0e11ee6cc222c6aafe4d7c2a0993e53889c6a4ef2)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationHsvOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1ea71c144bfb99994dde8cbb98ca4d1067dc7b99b3c0652b3eb673b9ebcb5ef8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a525cde0330c4388be99ed85fe6aa6d67d33dbf76cfcc4a775b20813c0c6ab0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3638ac1bddad7dc384dd7af006555d0f7797138a1625316b9932dda9cb4aa0fa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationHsv]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationHsv]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__93a1f4cfea18fa6bba839549a943fc65a0fc87e325e57eb0a3b7cbd5abd165c0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationHsvOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationHsvOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__63d3ef3a8a3ca83d54da2a637753a3cd0879a426da0e0bdfb932ec22c8cc8b95)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2c13341db7c0f140369b1229f4b0fbc273219f4d9f248472f484ede77383f22f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b3e4a620ee2cb8b121287e4bfa9f22086f6ef89c50c527753100f815e56283f9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e2ffae2fc1bf450b247e6523bebe1f153bde100294c01d0dfb9bb939bf56e850)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__54d63450de5c8894a4219f0351d97cb0364c3b03d53b004bae91f37aabcb33b1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df3abab31ee69fd657ddfee082cf5cdb8503d251beaef9a9be44dba68de27d93)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__279f35fa46e11b1805815659aeea252a88ce4c7eff12018dee3f5b3f040fa8ed)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationHsv]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationHsv]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationHsv]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6421c05562845eced9e807b056a8a74e7ffcc93919a65d76377bcb34084b427f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfDimension",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "dimension": "dimension",
        "dimension_var": "dimensionVar",
        "equal": "equal",
        "greater_than": "greaterThan",
        "less_than": "lessThan",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfDimension:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfDimensionDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        dimension: typing.Optional[builtins.str] = None,
        dimension_var: typing.Optional[builtins.str] = None,
        equal: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfDimensionEqual", typing.Dict[builtins.str, typing.Any]]] = None,
        greater_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfDimensionGreaterThan", typing.Dict[builtins.str, typing.Any]]] = None,
        less_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfDimensionLessThan", typing.Dict[builtins.str, typing.Any]]] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param dimension: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        :param dimension_var: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        :param equal: equal block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        :param greater_than: greater_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        :param less_than: less_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        :param value: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfDimensionDefault(**default)
        if isinstance(equal, dict):
            equal = DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfDimensionEqual(**equal)
        if isinstance(greater_than, dict):
            greater_than = DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfDimensionGreaterThan(**greater_than)
        if isinstance(less_than, dict):
            less_than = DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfDimensionLessThan(**less_than)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2e0fdb53536910576155de92d88da73b60b6aec37387734892fa982d13f518cd)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument dimension", value=dimension, expected_type=type_hints["dimension"])
            check_type(argname="argument dimension_var", value=dimension_var, expected_type=type_hints["dimension_var"])
            check_type(argname="argument equal", value=equal, expected_type=type_hints["equal"])
            check_type(argname="argument greater_than", value=greater_than, expected_type=type_hints["greater_than"])
            check_type(argname="argument less_than", value=less_than, expected_type=type_hints["less_than"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if dimension is not None:
            self._values["dimension"] = dimension
        if dimension_var is not None:
            self._values["dimension_var"] = dimension_var
        if equal is not None:
            self._values["equal"] = equal
        if greater_than is not None:
            self._values["greater_than"] = greater_than
        if less_than is not None:
            self._values["less_than"] = less_than
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfDimensionDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfDimensionDefault"], result)

    @builtins.property
    def dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        '''
        result = self._values.get("dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        '''
        result = self._values.get("dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def equal(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfDimensionEqual"]:
        '''equal block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        '''
        result = self._values.get("equal")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfDimensionEqual"], result)

    @builtins.property
    def greater_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfDimensionGreaterThan"]:
        '''greater_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        '''
        result = self._values.get("greater_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfDimensionGreaterThan"], result)

    @builtins.property
    def less_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfDimensionLessThan"]:
        '''less_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        '''
        result = self._values.get("less_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfDimensionLessThan"], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfDimension(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfDimensionDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfDimensionDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfDimensionDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfDimensionDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfDimensionDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__635bcfdd7504bf8cf30b135cc369895f455c19ed17600b854c15bb5e0efc9deb)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfDimensionDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfDimensionDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__21c1bdfca3af0d8841644d32987ff2c66cd4cf2b687e56d2a803d27e78e0df14)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfDimensionEqual",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfDimensionEqual:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfDimensionEqual(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfDimensionEqualOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfDimensionEqualOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ec6535490067d1e7912dc8ebafcfda6c5ab08aeb882e2dce9de5e1596544e4af)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfDimensionEqual], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfDimensionEqual],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__086e2915e403fb00322b9d5c9077f4dfdae48acc8a0cf9e50d5b1cd425dcf9de)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfDimensionGreaterThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfDimensionGreaterThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfDimensionGreaterThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfDimensionGreaterThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfDimensionGreaterThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__379441527a9079b560ad43d662db2580453b2d097a841cc203f9f569655729d0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfDimensionGreaterThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfDimensionGreaterThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6ca6bbc4b73eed57d6c32eb5ecf06a0d53d9524502d8e939efb9add522285260)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfDimensionLessThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfDimensionLessThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfDimensionLessThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfDimensionLessThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfDimensionLessThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e4b0d501931644d71ce7e8844d6e839676b7f6e21615f795257cfb314ee0aa9a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfDimensionLessThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfDimensionLessThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e8410bbced7c2c9a24492c4892945c49e30f7f7b2e8228102b01cbab513d496c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfDimensionList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfDimensionList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0a82fe9051594cf1bfd2c5d5bac1c5fb36b3d02ed0ebb78a02789ae1ad2f953f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfDimensionOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__55a82871fe6c3548f0c8d6160bb8d126154a59d6ab24c04d5655e6ec00a5b818)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfDimensionOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa2cfc52e6115f9c3a1ebbfad6bda25b9b92f2c81232409000959c47adb8f388)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__498c72c9ab908f5342913c02b9252be00b3c9d78e8b25846a646662f1acb565b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__197db6e37119270c9e11666b59fd1332d46ae313dc4840bf42ce8093afedd480)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfDimension]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfDimension]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__42633ff433c12c79490aa7c508b9aa5bb72b71dfbf1b3e29bcf1f4086c782120)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfDimensionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfDimensionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5e5522a4256d866d4a873d856f089c06f49d8e7bf5277e922a38053180a8f07f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfDimensionDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putEqual")
    def put_equal(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfDimensionEqual()

        return typing.cast(None, jsii.invoke(self, "putEqual", [value]))

    @jsii.member(jsii_name="putGreaterThan")
    def put_greater_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfDimensionGreaterThan()

        return typing.cast(None, jsii.invoke(self, "putGreaterThan", [value]))

    @jsii.member(jsii_name="putLessThan")
    def put_less_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfDimensionLessThan()

        return typing.cast(None, jsii.invoke(self, "putLessThan", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetDimension")
    def reset_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimension", []))

    @jsii.member(jsii_name="resetDimensionVar")
    def reset_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimensionVar", []))

    @jsii.member(jsii_name="resetEqual")
    def reset_equal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEqual", []))

    @jsii.member(jsii_name="resetGreaterThan")
    def reset_greater_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGreaterThan", []))

    @jsii.member(jsii_name="resetLessThan")
    def reset_less_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLessThan", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfDimensionDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfDimensionDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="equal")
    def equal(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfDimensionEqualOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfDimensionEqualOutputReference, jsii.get(self, "equal"))

    @builtins.property
    @jsii.member(jsii_name="greaterThan")
    def greater_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfDimensionGreaterThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfDimensionGreaterThanOutputReference, jsii.get(self, "greaterThan"))

    @builtins.property
    @jsii.member(jsii_name="lessThan")
    def less_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfDimensionLessThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfDimensionLessThanOutputReference, jsii.get(self, "lessThan"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfDimensionDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionInput")
    def dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionVarInput")
    def dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="equalInput")
    def equal_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfDimensionEqual], jsii.get(self, "equalInput"))

    @builtins.property
    @jsii.member(jsii_name="greaterThanInput")
    def greater_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfDimensionGreaterThan], jsii.get(self, "greaterThanInput"))

    @builtins.property
    @jsii.member(jsii_name="lessThanInput")
    def less_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfDimensionLessThan], jsii.get(self, "lessThanInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="dimension")
    def dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimension"))

    @dimension.setter
    def dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__45c7e463c66be79fa5c2b498b61a56ea5a527e8276fe7a7e332c5990ed98371b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimension", value)

    @builtins.property
    @jsii.member(jsii_name="dimensionVar")
    def dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimensionVar"))

    @dimension_var.setter
    def dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__93ccb00fc92fd0ab9baacf3b4f60ea559bf6fced0280eb044d10d61f4115d1cb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f03ee3d22e89345e73400a07d3d95446b823beb6c24e6e141b34831b628d44f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__badd1604e0883159b140f6a8741391993249115f6b626c8357937576c8ee6e3f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfDimension]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfDimension]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfDimension]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__16ec9fe8d7f215f5dfc498e57376b70231986ad30d8aa2f4b870e02268db267a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfOrientation",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "landscape": "landscape",
        "portrait": "portrait",
        "square": "square",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfOrientation:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfOrientationDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        landscape: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfOrientationLandscape", typing.Dict[builtins.str, typing.Any]]] = None,
        portrait: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfOrientationPortrait", typing.Dict[builtins.str, typing.Any]]] = None,
        square: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfOrientationSquare", typing.Dict[builtins.str, typing.Any]]] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param landscape: landscape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        :param portrait: portrait block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        :param square: square block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfOrientationDefault(**default)
        if isinstance(landscape, dict):
            landscape = DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfOrientationLandscape(**landscape)
        if isinstance(portrait, dict):
            portrait = DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfOrientationPortrait(**portrait)
        if isinstance(square, dict):
            square = DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfOrientationSquare(**square)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5a5198433f1f79aa6187172978e087e63e45c8d319ab8bcbb3d6c2f19e4d26d9)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument landscape", value=landscape, expected_type=type_hints["landscape"])
            check_type(argname="argument portrait", value=portrait, expected_type=type_hints["portrait"])
            check_type(argname="argument square", value=square, expected_type=type_hints["square"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if landscape is not None:
            self._values["landscape"] = landscape
        if portrait is not None:
            self._values["portrait"] = portrait
        if square is not None:
            self._values["square"] = square

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfOrientationDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfOrientationDefault"], result)

    @builtins.property
    def landscape(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfOrientationLandscape"]:
        '''landscape block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        '''
        result = self._values.get("landscape")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfOrientationLandscape"], result)

    @builtins.property
    def portrait(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfOrientationPortrait"]:
        '''portrait block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        '''
        result = self._values.get("portrait")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfOrientationPortrait"], result)

    @builtins.property
    def square(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfOrientationSquare"]:
        '''square block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        result = self._values.get("square")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfOrientationSquare"], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfOrientation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfOrientationDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfOrientationDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfOrientationDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfOrientationDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfOrientationDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3f395f13bd9324a40404add27f2007a763cf09be59efa9d521f38cc53234da40)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfOrientationDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfOrientationDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4d901d3bc4e6c979dc755cf70343a29f6693830bd2281b8e82b3aacf7bca3f8c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfOrientationLandscape",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfOrientationLandscape:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfOrientationLandscape(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfOrientationLandscapeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfOrientationLandscapeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__acf496ecd2cb3bb34bf0d2c1cd3f20a6434f7d31a80e897efddb8db8d99cb8e5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfOrientationLandscape], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfOrientationLandscape],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7090cfe01d13573f648aba52d30f2e95a8b146a50f40d9e653990d156f10a327)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfOrientationList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfOrientationList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__613f6edd313cc1f2463d58c9bedb0ea23b911987f6c7e53192f47790a3e9d108)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfOrientationOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0d0e43f422503cb2308dfb6196d3f1526def8d7347891054f5b07bbe67f631a8)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfOrientationOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7e751dfab4d502e744b7ac6c22a372298ee892b25ae71e60bdbb1ce5b9a90fcc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1c78220cdfd19c8371b5242beee008844993a659dc864d16b169b77c5cf12d97)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__813bb2d0757e5115a3a2b367da3e8aab3cd212ddafb36edd986000b017b8b4ec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfOrientation]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfOrientation]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eaf0d522797384add7f6ff102fd853e1b8401389e261ab9d95ca4a75be7282be)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfOrientationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfOrientationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a4da559aecdaf0f747f15cfd1b6cb2ec0319dac88596a3ee31d8c1e99ed8f1bd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfOrientationDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putLandscape")
    def put_landscape(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfOrientationLandscape()

        return typing.cast(None, jsii.invoke(self, "putLandscape", [value]))

    @jsii.member(jsii_name="putPortrait")
    def put_portrait(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfOrientationPortrait()

        return typing.cast(None, jsii.invoke(self, "putPortrait", [value]))

    @jsii.member(jsii_name="putSquare")
    def put_square(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfOrientationSquare()

        return typing.cast(None, jsii.invoke(self, "putSquare", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetLandscape")
    def reset_landscape(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLandscape", []))

    @jsii.member(jsii_name="resetPortrait")
    def reset_portrait(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPortrait", []))

    @jsii.member(jsii_name="resetSquare")
    def reset_square(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSquare", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfOrientationDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfOrientationDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="landscape")
    def landscape(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfOrientationLandscapeOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfOrientationLandscapeOutputReference, jsii.get(self, "landscape"))

    @builtins.property
    @jsii.member(jsii_name="portrait")
    def portrait(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfOrientationPortraitOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfOrientationPortraitOutputReference", jsii.get(self, "portrait"))

    @builtins.property
    @jsii.member(jsii_name="square")
    def square(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfOrientationSquareOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfOrientationSquareOutputReference", jsii.get(self, "square"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfOrientationDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="landscapeInput")
    def landscape_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfOrientationLandscape], jsii.get(self, "landscapeInput"))

    @builtins.property
    @jsii.member(jsii_name="portraitInput")
    def portrait_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfOrientationPortrait"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfOrientationPortrait"], jsii.get(self, "portraitInput"))

    @builtins.property
    @jsii.member(jsii_name="squareInput")
    def square_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfOrientationSquare"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfOrientationSquare"], jsii.get(self, "squareInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfOrientation]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfOrientation]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfOrientation]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fda459c85dd08edeeb14e9ef7118e55d7951ffa80db79ef57e4818c1c29b36f2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfOrientationPortrait",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfOrientationPortrait:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfOrientationPortrait(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfOrientationPortraitOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfOrientationPortraitOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9faeb80186cecc0ee4d299c5f4f7030fc812e19428a3ac3a2d862d912d630a43)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfOrientationPortrait]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfOrientationPortrait], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfOrientationPortrait],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__64dde9d48b575b277b7efc1e108982bd21b35891d1eedfe9e1bbbc23bed35401)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfOrientationSquare",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfOrientationSquare:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfOrientationSquare(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfOrientationSquareOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfOrientationSquareOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df706778e365195020d2084367970a5a713f566cae46bb51db94c1bfadd0ddaf)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfOrientationSquare]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfOrientationSquare], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfOrientationSquare],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4d875ebae254e3a0b4ad240acd0b50972260c99879cededc031699eda31289d9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationImQuery",
    jsii_struct_bases=[],
    name_mapping={
        "allowed_transformations": "allowedTransformations",
        "query_var": "queryVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationImQuery:
    def __init__(
        self,
        *,
        allowed_transformations: typing.Sequence[builtins.str],
        query_var: builtins.str,
    ) -> None:
        '''
        :param allowed_transformations: Specifies the transformations that can be applied using the query string parameter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allowed_transformations DataAkamaiImagingPolicyImage#allowed_transformations}
        :param query_var: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#query_var DataAkamaiImagingPolicyImage#query_var}.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b2c82247372ead848259b66da7cae2cbb6b84073b6137983af352c9ac0c052a8)
            check_type(argname="argument allowed_transformations", value=allowed_transformations, expected_type=type_hints["allowed_transformations"])
            check_type(argname="argument query_var", value=query_var, expected_type=type_hints["query_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "allowed_transformations": allowed_transformations,
            "query_var": query_var,
        }

    @builtins.property
    def allowed_transformations(self) -> typing.List[builtins.str]:
        '''Specifies the transformations that can be applied using the query string parameter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allowed_transformations DataAkamaiImagingPolicyImage#allowed_transformations}
        '''
        result = self._values.get("allowed_transformations")
        assert result is not None, "Required property 'allowed_transformations' is missing"
        return typing.cast(typing.List[builtins.str], result)

    @builtins.property
    def query_var(self) -> builtins.str:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#query_var DataAkamaiImagingPolicyImage#query_var}.'''
        result = self._values.get("query_var")
        assert result is not None, "Required property 'query_var' is missing"
        return typing.cast(builtins.str, result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationImQuery(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationImQueryList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationImQueryList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c677885897f507d1aca66cd2ea5c9f52593decb8916070d737e3a5023ec6c822)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationImQueryOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4de44278892128cdf639128a2486de05eeda354839eedfe87b3539fd1c4bdd16)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationImQueryOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e06a4658ea45889bc7c99de695a5b715420b5493941b54b604cd41d4d2f03a01)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a2bd6bb8ed6b09b95cb6f3c29d8d262e496c76d8d3ac8c2e38b735929cdcea2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9983af3357a3ec666122e69a26ea4e3b44b60cc05b936e998239c9c0e1a917d5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationImQuery]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationImQuery]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationImQuery]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__960cc929c8c78cbe8255cff241c86b1643a2d0695ff51dea7aa7221cde5dc87c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationImQueryOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationImQueryOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__82a36defaec1b7520ff93db11c26d46d69ed51e87f1d4dd6443493228ac2ba58)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @builtins.property
    @jsii.member(jsii_name="allowedTransformationsInput")
    def allowed_transformations_input(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "allowedTransformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="queryVarInput")
    def query_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "queryVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowedTransformations")
    def allowed_transformations(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "allowedTransformations"))

    @allowed_transformations.setter
    def allowed_transformations(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__887aa958307a9416d30352b7d082d3a3a1dc5e98ead6f3e8f71692c46eafef2a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowedTransformations", value)

    @builtins.property
    @jsii.member(jsii_name="queryVar")
    def query_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "queryVar"))

    @query_var.setter
    def query_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6dee3a8a6acc125d1f8ecd9a5c01848271bcf95ba7ac3032025f13af7e3e578d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "queryVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationImQuery]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationImQuery]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationImQuery]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ffcc348959e64c6003ec1448c36c844ca0fbdc1f3b74db2d695dcf38dbe038b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationMaxColors",
    jsii_struct_bases=[],
    name_mapping={"colors": "colors", "colors_var": "colorsVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationMaxColors:
    def __init__(
        self,
        *,
        colors: typing.Optional[builtins.str] = None,
        colors_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param colors: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        :param colors_var: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__16bbbd37b40d2d9fbb019245a52afa07ab68ec96494e8bb6f9db2648ca6da913)
            check_type(argname="argument colors", value=colors, expected_type=type_hints["colors"])
            check_type(argname="argument colors_var", value=colors_var, expected_type=type_hints["colors_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if colors is not None:
            self._values["colors"] = colors
        if colors_var is not None:
            self._values["colors_var"] = colors_var

    @builtins.property
    def colors(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        '''
        result = self._values.get("colors")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def colors_var(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        result = self._values.get("colors_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationMaxColors(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationMaxColorsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationMaxColorsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dea1a4f5ffff9d542e648179a855957dd8222562d56484c3992ef9aed6b52ca2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationMaxColorsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__44e3c3f47b4f9e7ca03a9a56920e15cb5419a4052779f25f6171307776f703ac)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationMaxColorsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__997f31608e29156a3d31dfef3e6f2e0a1185a188cff64f33d6dde03429f769ae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0a01ba4a558973cc85c47e2bbf1a367d31a0ec843d9b0a06fe4c44701a2b8978)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6fdb1dd91294623b432fc83ab7b2d5f55f50291aa0ae5c3ac0bfd41347325d9d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationMaxColors]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationMaxColors]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__541b2de8445bd68755c97c0741e78cd9bf6a1e4ed00783c4ba36ed40ddf8b641)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationMaxColorsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationMaxColorsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5c5a0c01b46f389ee7a6cf0121f912d1b616f5e5ca9f297173add2e7be23bf85)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColors")
    def reset_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColors", []))

    @jsii.member(jsii_name="resetColorsVar")
    def reset_colors_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorsVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorsInput")
    def colors_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsInput"))

    @builtins.property
    @jsii.member(jsii_name="colorsVarInput")
    def colors_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsVarInput"))

    @builtins.property
    @jsii.member(jsii_name="colors")
    def colors(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colors"))

    @colors.setter
    def colors(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__030c40c95fc51305fc3c480cae6da144ac0e93fc12343b66ec726d8426a54a91)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colors", value)

    @builtins.property
    @jsii.member(jsii_name="colorsVar")
    def colors_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorsVar"))

    @colors_var.setter
    def colors_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5e4915b02839a2a7804f4abd49cdeffd9b6db0d125abdb2f65d9b5c69ecf24aa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorsVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationMaxColors]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationMaxColors]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationMaxColors]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8c5d023de65c1aa2092ca4a82fc27d07cda4a0992dc04cce95dbdf71dd12bb5d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationMirror",
    jsii_struct_bases=[],
    name_mapping={
        "horizontal": "horizontal",
        "horizontal_var": "horizontalVar",
        "vertical": "vertical",
        "vertical_var": "verticalVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationMirror:
    def __init__(
        self,
        *,
        horizontal: typing.Optional[builtins.str] = None,
        horizontal_var: typing.Optional[builtins.str] = None,
        vertical: typing.Optional[builtins.str] = None,
        vertical_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param horizontal: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        :param horizontal_var: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        :param vertical: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        :param vertical_var: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8d5c722a215e9287544c71c76063e22137915bf404049dca6a35db1fd10666af)
            check_type(argname="argument horizontal", value=horizontal, expected_type=type_hints["horizontal"])
            check_type(argname="argument horizontal_var", value=horizontal_var, expected_type=type_hints["horizontal_var"])
            check_type(argname="argument vertical", value=vertical, expected_type=type_hints["vertical"])
            check_type(argname="argument vertical_var", value=vertical_var, expected_type=type_hints["vertical_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if horizontal is not None:
            self._values["horizontal"] = horizontal
        if horizontal_var is not None:
            self._values["horizontal_var"] = horizontal_var
        if vertical is not None:
            self._values["vertical"] = vertical
        if vertical_var is not None:
            self._values["vertical_var"] = vertical_var

    @builtins.property
    def horizontal(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        '''
        result = self._values.get("horizontal")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def horizontal_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        '''
        result = self._values.get("horizontal_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        '''
        result = self._values.get("vertical")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        result = self._values.get("vertical_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationMirror(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationMirrorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationMirrorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bf7142c131175f76a162291f1574986806e752ddc67ebb35116d824d364ad0e6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationMirrorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b55b749ac31b994a559f49b126f86d5e6bfc7851fd4edc327d68133a9a51d567)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationMirrorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d5d01b9d65b8c1bf3f0d196e9743d34fdc7226868c017a49b4e4cbcaedc58eaf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6d769b3265423e7c08aa9d90113672185389c088915e92e0642d51967316eeed)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bf6828312a5800cb18a5d37fcd9c71bcf93de5e431ac037235eb64eb24893b7b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationMirror]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationMirror]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4f9eaceefcfb2e9b5a6e2a8a9d95389890f96e1d29e8fd9746363c1516c7dfd0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationMirrorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationMirrorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__50c0f279ca16ca7d3395a652356aedc4fb1f7801eda515384d942f38653c8680)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHorizontal")
    def reset_horizontal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontal", []))

    @jsii.member(jsii_name="resetHorizontalVar")
    def reset_horizontal_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontalVar", []))

    @jsii.member(jsii_name="resetVertical")
    def reset_vertical(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVertical", []))

    @jsii.member(jsii_name="resetVerticalVar")
    def reset_vertical_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVerticalVar", []))

    @builtins.property
    @jsii.member(jsii_name="horizontalInput")
    def horizontal_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontalVarInput")
    def horizontal_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalInput")
    def vertical_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalVarInput")
    def vertical_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontal")
    def horizontal(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontal"))

    @horizontal.setter
    def horizontal(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7e548a62293864849a5c021fe38bec46326ddbf759cf5599e90c1efff26b8294)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontal", value)

    @builtins.property
    @jsii.member(jsii_name="horizontalVar")
    def horizontal_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontalVar"))

    @horizontal_var.setter
    def horizontal_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__714ca50f05833eaa6302c74412bde3ec2e65bdce64940b28e687031bf29bef8d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontalVar", value)

    @builtins.property
    @jsii.member(jsii_name="vertical")
    def vertical(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "vertical"))

    @vertical.setter
    def vertical(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d80273639b07c2d798e4278fc7486520a0c4e2d79e56eb706c424065c9708826)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "vertical", value)

    @builtins.property
    @jsii.member(jsii_name="verticalVar")
    def vertical_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "verticalVar"))

    @vertical_var.setter
    def vertical_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0108cd58f109617c5d741707bd9cc30b133e2b12758423a57ac6cd4ecbcd29b3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "verticalVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationMirror]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationMirror]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationMirror]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8de0980f95804f3d7f5f15869fd8973f5f65d9912db7725a56d903884b890a16)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationMonoHue",
    jsii_struct_bases=[],
    name_mapping={"hue": "hue", "hue_var": "hueVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationMonoHue:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6fc5a78d70b34a7906ff3b7587b42e86a7ed000867716613d9e936b3f21b6bc7)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationMonoHue(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationMonoHueList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationMonoHueList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__29f80520e51964fe7525539aa6937fedf5f8c1b55cf8095d470f308829b5f856)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationMonoHueOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e652542cd536d7d1f8f56bd3ec9d94cdd35015d541c887c82b69d3412fb5015e)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationMonoHueOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4d315400a44674928b105d99b72ae23222efbfd28c6023570f8eda8400165346)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__87bee1da7814eb63a7299d3de7d834b121de8d07399b0124887b1ddf0550c906)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5e4b1b87cf459e7435bb2d73966406d52a094f35f47ce8e923dd811cf542afd7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationMonoHue]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationMonoHue]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__38c39709cac5703d236db51937bbfe6f8880abda8c57b7b90256abc24ddbfd20)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationMonoHueOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationMonoHueOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a1e1ebd75f90cc9c7be3ecddc4c95c34c83233abd120cbc30e6e21660e655a0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f9b952f0870bfc6c97f913b42ed24b84d2105000c94fac68bad7bff0c631d73d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__618138a17f9d0fb1c7ade9a3534cade6ee382c8f41b055e49893dfb660e9ec73)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationMonoHue]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationMonoHue]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationMonoHue]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a4ec6ded4563b087be10014faf94df2612d88d551b76a725a9c08455f84bdbeb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationOpacity",
    jsii_struct_bases=[],
    name_mapping={"opacity": "opacity", "opacity_var": "opacityVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationOpacity:
    def __init__(
        self,
        *,
        opacity: typing.Optional[builtins.str] = None,
        opacity_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param opacity: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param opacity_var: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d1f41ffcdb7792d1e09810eeaed3e6d240778d7a429ffc5e68e3e167454dfa2c)
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument opacity_var", value=opacity_var, expected_type=type_hints["opacity_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if opacity is not None:
            self._values["opacity"] = opacity
        if opacity_var is not None:
            self._values["opacity_var"] = opacity_var

    @builtins.property
    def opacity(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def opacity_var(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        result = self._values.get("opacity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationOpacity(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationOpacityList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationOpacityList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8668261472188cb66aff8385d9444f27bc0816bf16a16a668e11be70f5724ccb)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationOpacityOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d930e9eb114c4a644d9ab9ff58dea1e8681eed4457ee1b8a617c81edfdf3345f)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationOpacityOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__db187683924e1b795cd07dafeebfa7ac089fab83fc4cf8a4c2af71391f2b5650)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__de87b16a79050d8f898a27c597a92e33ad6d256e17d87896bfe88e5817cdd246)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c5bbd535e7159a63632a8b73492877c413712d895d3f842f38fb2ac7410ff4b9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationOpacity]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationOpacity]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5dc3edc3c377cd7ccde201e61e68e3a180157dfe22d5e4b56db91281a6429b34)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationOpacityOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationOpacityOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b2ff6fbf6d978c6e4dbb31214de43e26ad315552454e18ac020d516e9ec88775)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetOpacityVar")
    def reset_opacity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacityVar", []))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityVarInput")
    def opacity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacity"))

    @opacity.setter
    def opacity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc9c4347052af96d4e93f35aee4331302ded4fe564a4394aa17264fba93947d6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacity", value)

    @builtins.property
    @jsii.member(jsii_name="opacityVar")
    def opacity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacityVar"))

    @opacity_var.setter
    def opacity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cc1c562cb6d4f7070dbc1654a3205ac125757988c2b974f89e7fd0c97d75d8eb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacityVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationOpacity]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationOpacity]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationOpacity]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5eb653041a93bbfbbee4d8fd6cb0829a8c75da3f0e57c5a3eb54e2768085082a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d0324e6606e121dd810bebb0109d7cf197b82862035da4e7329e2de169246125)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putAppend")
    def put_append(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationAppend, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__15fc75f7cd83c861ac4f9bf5065c83877226fff4e59be8d5449266df355bd6b5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putAppend", [value]))

    @jsii.member(jsii_name="putAspectCrop")
    def put_aspect_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationAspectCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__46817987e58c7c03066065370a5b38158345aa57b78cfdc56a8a10ee6849b174)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putAspectCrop", [value]))

    @jsii.member(jsii_name="putBackgroundColor")
    def put_background_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__41b33fe79dce5b0fa6f0f38ead8e3ff7a65dcadd8c48e138a285efcb51a31609)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBackgroundColor", [value]))

    @jsii.member(jsii_name="putBlur")
    def put_blur(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationBlur, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__82e80562bdd3f1bdd3ee6dbaf3a29df26cdd9be2ba0ee8abda56d71b4c1ee20f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBlur", [value]))

    @jsii.member(jsii_name="putChromaKey")
    def put_chroma_key(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationChromaKey, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__192b5abf0e901555f9c61d43e1eb07453c85b64a1c54bd21e397a06cbab5171b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putChromaKey", [value]))

    @jsii.member(jsii_name="putComposite")
    def put_composite(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationComposite, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e34d751fc16bf0fab1f925ea801463e988554e2df8346ba58f4e3d2dbcc5e5b0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putComposite", [value]))

    @jsii.member(jsii_name="putCompound")
    def put_compound(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationCompound, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a944baa1bb10f04dffa5ab6f7667e1805851c5d24ff96b0bc3409cb01769188)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCompound", [value]))

    @jsii.member(jsii_name="putContrast")
    def put_contrast(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationContrast, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3434bb98a5e8e2b9796e7ba44276c7b88df2a7233bb1537441af855dc007163a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putContrast", [value]))

    @jsii.member(jsii_name="putCrop")
    def put_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ea44fa7454e74023ea89e06af7ad92efdf9407ef344e27e7dc2ed95afccdbf2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCrop", [value]))

    @jsii.member(jsii_name="putFaceCrop")
    def put_face_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationFaceCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f40cfe3af4d1b70268de5972affc5a1a25c3823f2ad44b45cb7e3c6255493d5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFaceCrop", [value]))

    @jsii.member(jsii_name="putFeatureCrop")
    def put_feature_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationFeatureCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2fd63849227a046c150389c4dc1e8ce55c06e01b3c93e2dcc5da196d7b9e37c7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFeatureCrop", [value]))

    @jsii.member(jsii_name="putFitAndFill")
    def put_fit_and_fill(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationFitAndFill, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9855ce73b3effcab57be00808c2002f285b6cb4ca1410be1cb67341194db0eb1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFitAndFill", [value]))

    @jsii.member(jsii_name="putGoop")
    def put_goop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationGoop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ceffb18b66a71bf32307046aa48042411a2499349a44e0a858746ee6535c41b2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGoop", [value]))

    @jsii.member(jsii_name="putGrayscale")
    def put_grayscale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationGrayscale, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a878a0183e4ec72b16420c58a5f44c8ce75e46ee6464ccf0987bfbd788bf6499)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGrayscale", [value]))

    @jsii.member(jsii_name="putHsl")
    def put_hsl(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationHsl, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__70a19b75fc69eeb878adf81eca10dcad1d758d258d6cc713489d17883b56de25)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsl", [value]))

    @jsii.member(jsii_name="putHsv")
    def put_hsv(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationHsv, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa41ebadb492c57bb2c36dfa65414f857f9fb3a7a73f8a14eacf0a62f1ddc7b1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsv", [value]))

    @jsii.member(jsii_name="putIfDimension")
    def put_if_dimension(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfDimension, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__72466990400b24ae7a9c7fd129dae0d8ff816ae7ec27553da500da82d254f3e0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfDimension", [value]))

    @jsii.member(jsii_name="putIfOrientation")
    def put_if_orientation(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__476797a17d554fcac5f2a8d450709612b12d7cb4b69b8434c803eaa76e04c6e1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfOrientation", [value]))

    @jsii.member(jsii_name="putImQuery")
    def put_im_query(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationImQuery, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__19a8aa3cb8406e5c1bde0118382066ed1172e1566352c526b6ab61d692f34f81)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putImQuery", [value]))

    @jsii.member(jsii_name="putMaxColors")
    def put_max_colors(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationMaxColors, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c78e0b899d2d2a1ba9c5ab2980f9798293de3093ba5d5c377a6be43bf115f623)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMaxColors", [value]))

    @jsii.member(jsii_name="putMirror")
    def put_mirror(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationMirror, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3751a897ee74ba1929d3d72aadd6f8a472251c33c22d330ad061f33211cbf028)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMirror", [value]))

    @jsii.member(jsii_name="putMonoHue")
    def put_mono_hue(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationMonoHue, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b8b3ed2b29c134b37e5c7e0008a3909c02470bc5424057bf2c14cf40664838f1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMonoHue", [value]))

    @jsii.member(jsii_name="putOpacity")
    def put_opacity(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationOpacity, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4e702cd559ed52b4e64afa59fd538ec7ab9b89f32c8d0d2833a62c32052df378)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putOpacity", [value]))

    @jsii.member(jsii_name="putRegionOfInterestCrop")
    def put_region_of_interest_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationRegionOfInterestCrop", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9f6a0ec13b552d9b932f0382766820ff57e7e27366e8c4204fa3361275e041ee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRegionOfInterestCrop", [value]))

    @jsii.member(jsii_name="putRelativeCrop")
    def put_relative_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationRelativeCrop", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__83a15ff19fda98299e61fd0f5bce125e127f5f68e6eec3af8f0507f1566812fc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRelativeCrop", [value]))

    @jsii.member(jsii_name="putRemoveColor")
    def put_remove_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationRemoveColor", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0048b4867e07b43ef34dcce43069cd09f9660090957757d834acf962aa0d5880)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRemoveColor", [value]))

    @jsii.member(jsii_name="putResize")
    def put_resize(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationResize", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__095d3583e465b601c362c8baa8d836fad1e303857da99658f5eeec29615977ad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putResize", [value]))

    @jsii.member(jsii_name="putRotate")
    def put_rotate(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationRotate", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4682889a8389ea2cc900c13db4f118508a043ccba161b5ec320bbb6a826e3153)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRotate", [value]))

    @jsii.member(jsii_name="putScale")
    def put_scale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationScale", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cff4af670e960163cdb5360a646dcd31f0fbc368ab093ef95bd97cdd51e2568f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putScale", [value]))

    @jsii.member(jsii_name="putShear")
    def put_shear(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationShear", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fe86a761c72f1bdeda2da065e429b077f695cdd33f714b4c0612460f1a40a089)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putShear", [value]))

    @jsii.member(jsii_name="putTrim")
    def put_trim(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationTrim", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__243a1d53396c9a598b292b95ba3beb9f88124d1ade3a2b4e80cea98c3cd205df)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTrim", [value]))

    @jsii.member(jsii_name="putUnsharpMask")
    def put_unsharp_mask(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationUnsharpMask", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__02844cfe8a541d4c89241e051c1ac8d3467c5ef3680037bd945c6d51aaf0896e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putUnsharpMask", [value]))

    @jsii.member(jsii_name="resetAppend")
    def reset_append(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAppend", []))

    @jsii.member(jsii_name="resetAspectCrop")
    def reset_aspect_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspectCrop", []))

    @jsii.member(jsii_name="resetBackgroundColor")
    def reset_background_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBackgroundColor", []))

    @jsii.member(jsii_name="resetBlur")
    def reset_blur(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBlur", []))

    @jsii.member(jsii_name="resetChromaKey")
    def reset_chroma_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChromaKey", []))

    @jsii.member(jsii_name="resetComposite")
    def reset_composite(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetComposite", []))

    @jsii.member(jsii_name="resetCompound")
    def reset_compound(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCompound", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetCrop")
    def reset_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCrop", []))

    @jsii.member(jsii_name="resetFaceCrop")
    def reset_face_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFaceCrop", []))

    @jsii.member(jsii_name="resetFeatureCrop")
    def reset_feature_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureCrop", []))

    @jsii.member(jsii_name="resetFitAndFill")
    def reset_fit_and_fill(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFitAndFill", []))

    @jsii.member(jsii_name="resetGoop")
    def reset_goop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGoop", []))

    @jsii.member(jsii_name="resetGrayscale")
    def reset_grayscale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGrayscale", []))

    @jsii.member(jsii_name="resetHsl")
    def reset_hsl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsl", []))

    @jsii.member(jsii_name="resetHsv")
    def reset_hsv(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsv", []))

    @jsii.member(jsii_name="resetIfDimension")
    def reset_if_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfDimension", []))

    @jsii.member(jsii_name="resetIfOrientation")
    def reset_if_orientation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfOrientation", []))

    @jsii.member(jsii_name="resetImQuery")
    def reset_im_query(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetImQuery", []))

    @jsii.member(jsii_name="resetMaxColors")
    def reset_max_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxColors", []))

    @jsii.member(jsii_name="resetMirror")
    def reset_mirror(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMirror", []))

    @jsii.member(jsii_name="resetMonoHue")
    def reset_mono_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonoHue", []))

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetRegionOfInterestCrop")
    def reset_region_of_interest_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRegionOfInterestCrop", []))

    @jsii.member(jsii_name="resetRelativeCrop")
    def reset_relative_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRelativeCrop", []))

    @jsii.member(jsii_name="resetRemoveColor")
    def reset_remove_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRemoveColor", []))

    @jsii.member(jsii_name="resetResize")
    def reset_resize(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetResize", []))

    @jsii.member(jsii_name="resetRotate")
    def reset_rotate(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRotate", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetShear")
    def reset_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetShear", []))

    @jsii.member(jsii_name="resetTrim")
    def reset_trim(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTrim", []))

    @jsii.member(jsii_name="resetUnsharpMask")
    def reset_unsharp_mask(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUnsharpMask", []))

    @builtins.property
    @jsii.member(jsii_name="append")
    def append(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationAppendList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationAppendList, jsii.get(self, "append"))

    @builtins.property
    @jsii.member(jsii_name="aspectCrop")
    def aspect_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationAspectCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationAspectCropList, jsii.get(self, "aspectCrop"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColor")
    def background_color(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationBackgroundColorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationBackgroundColorList, jsii.get(self, "backgroundColor"))

    @builtins.property
    @jsii.member(jsii_name="blur")
    def blur(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationBlurList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationBlurList, jsii.get(self, "blur"))

    @builtins.property
    @jsii.member(jsii_name="chromaKey")
    def chroma_key(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationChromaKeyList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationChromaKeyList, jsii.get(self, "chromaKey"))

    @builtins.property
    @jsii.member(jsii_name="composite")
    def composite(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationCompositeList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationCompositeList, jsii.get(self, "composite"))

    @builtins.property
    @jsii.member(jsii_name="compound")
    def compound(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationCompoundList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationCompoundList, jsii.get(self, "compound"))

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationContrastList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationContrastList, jsii.get(self, "contrast"))

    @builtins.property
    @jsii.member(jsii_name="crop")
    def crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationCropList, jsii.get(self, "crop"))

    @builtins.property
    @jsii.member(jsii_name="faceCrop")
    def face_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationFaceCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationFaceCropList, jsii.get(self, "faceCrop"))

    @builtins.property
    @jsii.member(jsii_name="featureCrop")
    def feature_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationFeatureCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationFeatureCropList, jsii.get(self, "featureCrop"))

    @builtins.property
    @jsii.member(jsii_name="fitAndFill")
    def fit_and_fill(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationFitAndFillList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationFitAndFillList, jsii.get(self, "fitAndFill"))

    @builtins.property
    @jsii.member(jsii_name="goop")
    def goop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationGoopList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationGoopList, jsii.get(self, "goop"))

    @builtins.property
    @jsii.member(jsii_name="grayscale")
    def grayscale(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationGrayscaleList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationGrayscaleList, jsii.get(self, "grayscale"))

    @builtins.property
    @jsii.member(jsii_name="hsl")
    def hsl(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationHslList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationHslList, jsii.get(self, "hsl"))

    @builtins.property
    @jsii.member(jsii_name="hsv")
    def hsv(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationHsvList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationHsvList, jsii.get(self, "hsv"))

    @builtins.property
    @jsii.member(jsii_name="ifDimension")
    def if_dimension(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfDimensionList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfDimensionList, jsii.get(self, "ifDimension"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientation")
    def if_orientation(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfOrientationList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfOrientationList, jsii.get(self, "ifOrientation"))

    @builtins.property
    @jsii.member(jsii_name="imQuery")
    def im_query(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationImQueryList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationImQueryList, jsii.get(self, "imQuery"))

    @builtins.property
    @jsii.member(jsii_name="maxColors")
    def max_colors(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationMaxColorsList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationMaxColorsList, jsii.get(self, "maxColors"))

    @builtins.property
    @jsii.member(jsii_name="mirror")
    def mirror(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationMirrorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationMirrorList, jsii.get(self, "mirror"))

    @builtins.property
    @jsii.member(jsii_name="monoHue")
    def mono_hue(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationMonoHueList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationMonoHueList, jsii.get(self, "monoHue"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationOpacityList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationOpacityList, jsii.get(self, "opacity"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestCrop")
    def region_of_interest_crop(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationRegionOfInterestCropList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationRegionOfInterestCropList", jsii.get(self, "regionOfInterestCrop"))

    @builtins.property
    @jsii.member(jsii_name="relativeCrop")
    def relative_crop(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationRelativeCropList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationRelativeCropList", jsii.get(self, "relativeCrop"))

    @builtins.property
    @jsii.member(jsii_name="removeColor")
    def remove_color(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationRemoveColorList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationRemoveColorList", jsii.get(self, "removeColor"))

    @builtins.property
    @jsii.member(jsii_name="resize")
    def resize(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationResizeList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationResizeList", jsii.get(self, "resize"))

    @builtins.property
    @jsii.member(jsii_name="rotate")
    def rotate(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationRotateList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationRotateList", jsii.get(self, "rotate"))

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationScaleList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationScaleList", jsii.get(self, "scale"))

    @builtins.property
    @jsii.member(jsii_name="shear")
    def shear(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationShearList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationShearList", jsii.get(self, "shear"))

    @builtins.property
    @jsii.member(jsii_name="trim")
    def trim(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationTrimList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationTrimList", jsii.get(self, "trim"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMask")
    def unsharp_mask(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationUnsharpMaskList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationUnsharpMaskList", jsii.get(self, "unsharpMask"))

    @builtins.property
    @jsii.member(jsii_name="appendInput")
    def append_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationAppend]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationAppend]]], jsii.get(self, "appendInput"))

    @builtins.property
    @jsii.member(jsii_name="aspectCropInput")
    def aspect_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationAspectCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationAspectCrop]]], jsii.get(self, "aspectCropInput"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColorInput")
    def background_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationBackgroundColor]]], jsii.get(self, "backgroundColorInput"))

    @builtins.property
    @jsii.member(jsii_name="blurInput")
    def blur_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationBlur]]], jsii.get(self, "blurInput"))

    @builtins.property
    @jsii.member(jsii_name="chromaKeyInput")
    def chroma_key_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationChromaKey]]], jsii.get(self, "chromaKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="compositeInput")
    def composite_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationComposite]]], jsii.get(self, "compositeInput"))

    @builtins.property
    @jsii.member(jsii_name="compoundInput")
    def compound_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationCompound]]], jsii.get(self, "compoundInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationContrast]]], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="cropInput")
    def crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationCrop]]], jsii.get(self, "cropInput"))

    @builtins.property
    @jsii.member(jsii_name="faceCropInput")
    def face_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationFaceCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationFaceCrop]]], jsii.get(self, "faceCropInput"))

    @builtins.property
    @jsii.member(jsii_name="featureCropInput")
    def feature_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationFeatureCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationFeatureCrop]]], jsii.get(self, "featureCropInput"))

    @builtins.property
    @jsii.member(jsii_name="fitAndFillInput")
    def fit_and_fill_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationFitAndFill]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationFitAndFill]]], jsii.get(self, "fitAndFillInput"))

    @builtins.property
    @jsii.member(jsii_name="goopInput")
    def goop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationGoop]]], jsii.get(self, "goopInput"))

    @builtins.property
    @jsii.member(jsii_name="grayscaleInput")
    def grayscale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationGrayscale]]], jsii.get(self, "grayscaleInput"))

    @builtins.property
    @jsii.member(jsii_name="hslInput")
    def hsl_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationHsl]]], jsii.get(self, "hslInput"))

    @builtins.property
    @jsii.member(jsii_name="hsvInput")
    def hsv_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationHsv]]], jsii.get(self, "hsvInput"))

    @builtins.property
    @jsii.member(jsii_name="ifDimensionInput")
    def if_dimension_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfDimension]]], jsii.get(self, "ifDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientationInput")
    def if_orientation_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfOrientation]]], jsii.get(self, "ifOrientationInput"))

    @builtins.property
    @jsii.member(jsii_name="imQueryInput")
    def im_query_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationImQuery]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationImQuery]]], jsii.get(self, "imQueryInput"))

    @builtins.property
    @jsii.member(jsii_name="maxColorsInput")
    def max_colors_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationMaxColors]]], jsii.get(self, "maxColorsInput"))

    @builtins.property
    @jsii.member(jsii_name="mirrorInput")
    def mirror_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationMirror]]], jsii.get(self, "mirrorInput"))

    @builtins.property
    @jsii.member(jsii_name="monoHueInput")
    def mono_hue_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationMonoHue]]], jsii.get(self, "monoHueInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationOpacity]]], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestCropInput")
    def region_of_interest_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationRegionOfInterestCrop"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationRegionOfInterestCrop"]]], jsii.get(self, "regionOfInterestCropInput"))

    @builtins.property
    @jsii.member(jsii_name="relativeCropInput")
    def relative_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationRelativeCrop"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationRelativeCrop"]]], jsii.get(self, "relativeCropInput"))

    @builtins.property
    @jsii.member(jsii_name="removeColorInput")
    def remove_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationRemoveColor"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationRemoveColor"]]], jsii.get(self, "removeColorInput"))

    @builtins.property
    @jsii.member(jsii_name="resizeInput")
    def resize_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationResize"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationResize"]]], jsii.get(self, "resizeInput"))

    @builtins.property
    @jsii.member(jsii_name="rotateInput")
    def rotate_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationRotate"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationRotate"]]], jsii.get(self, "rotateInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationScale"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationScale"]]], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="shearInput")
    def shear_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationShear"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationShear"]]], jsii.get(self, "shearInput"))

    @builtins.property
    @jsii.member(jsii_name="trimInput")
    def trim_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationTrim"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationTrim"]]], jsii.get(self, "trimInput"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMaskInput")
    def unsharp_mask_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationUnsharpMask"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationUnsharpMask"]]], jsii.get(self, "unsharpMaskInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__93e9078c2f5d97ab2fcadce59757c5cbddc0036336ebfe5be58b377a9744d4f2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationRegionOfInterestCrop",
    jsii_struct_bases=[],
    name_mapping={
        "region_of_interest": "regionOfInterest",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationRegionOfInterestCrop:
    def __init__(
        self,
        *,
        region_of_interest: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationRegionOfInterestCropRegionOfInterest", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param region_of_interest: region_of_interest block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest DataAkamaiImagingPolicyImage#region_of_interest}
        :param gravity: The placement of the crop area relative to the specified area of interest. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: The placement of the crop area relative to the specified area of interest. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param style: Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(region_of_interest, dict):
            region_of_interest = DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationRegionOfInterestCropRegionOfInterest(**region_of_interest)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6add4f8536c474f617c286723e2218ed68993d878fc4afca8d30b133348ecec3)
            check_type(argname="argument region_of_interest", value=region_of_interest, expected_type=type_hints["region_of_interest"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "region_of_interest": region_of_interest,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def region_of_interest(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationRegionOfInterestCropRegionOfInterest":
        '''region_of_interest block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest DataAkamaiImagingPolicyImage#region_of_interest}
        '''
        result = self._values.get("region_of_interest")
        assert result is not None, "Required property 'region_of_interest' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationRegionOfInterestCropRegionOfInterest", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''The placement of the crop area relative to the specified area of interest.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''The placement of the crop area relative to the specified area of interest.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationRegionOfInterestCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationRegionOfInterestCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationRegionOfInterestCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__707e61f4d155e4fb19d93ae391eae1bad5f4c061c8fa43cd3cbda4124ee1bed0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationRegionOfInterestCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a5e31ebc4b6723a8be318b2cc6a23ce90d4ce700f1cce651a68fb125000ba0b)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationRegionOfInterestCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__073360fa11952c8b98d08809231d12daf527fdbdf1fc211fc36f0800ea87be52)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ec156184518ac3f78f4f706ca496bf74d6fd5b89e043ee1d5585056b5f325f32)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__15e72c99f30381242403505bdbcca010aa01533134e278cd08737e471cdcd7ea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationRegionOfInterestCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationRegionOfInterestCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationRegionOfInterestCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a6ae90b42b76f7576f8f73eb504d0f50d12d218b975b346a54a3f9755c5417c6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationRegionOfInterestCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationRegionOfInterestCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c3b834550d6a67e10afb3c2d25b5c7d52c796b06f92f6d751698eb38995dcd33)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putRegionOfInterest")
    def put_region_of_interest(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationRegionOfInterestCropRegionOfInterest()

        return typing.cast(None, jsii.invoke(self, "putRegionOfInterest", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterest")
    def region_of_interest(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationRegionOfInterestCropRegionOfInterestOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationRegionOfInterestCropRegionOfInterestOutputReference", jsii.get(self, "regionOfInterest"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestInput")
    def region_of_interest_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationRegionOfInterestCropRegionOfInterest"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationRegionOfInterestCropRegionOfInterest"], jsii.get(self, "regionOfInterestInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5e964020c16f957b39a986ff5e1be66323628a58f1d86b0bfb32ab0822cea92f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4631533b8b13bb4caa9aac887bf281f9badccf87c286faa202cfbfc6012aa1da)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7f7b06ae36efda623904378beb0fc64de82bf04b27f86d10be5de7d69f679d7d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5c63dd03193ce57293a479aeab5a5945da01bd3145ba2ed7ee86497a2a2e1ef1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f37792c2428c35d92f39f61baa343c942ed48f1827bbb2847c1618e2aad2cd3c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1ce52b461a1914c9b57459d0d63d7b6b060aabbf9a2b50963015290d5d7cdbea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b567eb4fff9e598371da86196c98abfe3fead54f9c992f93f7d21c153b8f13a7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ad9cbeb137485ee73d5a89630af7cb5f915852d193f714d1e67e720c4b255743)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationRegionOfInterestCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationRegionOfInterestCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationRegionOfInterestCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a046de41ccc872e4ac9d8c50e28c376840ea56a475296d4b137d32bc00b41115)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationRegionOfInterestCropRegionOfInterest",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationRegionOfInterestCropRegionOfInterest:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationRegionOfInterestCropRegionOfInterest(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationRegionOfInterestCropRegionOfInterestOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationRegionOfInterestCropRegionOfInterestOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__837c5e522362642af4f8de8fca96af53763495a6c67834cb750f6a1653c06d2c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationRegionOfInterestCropRegionOfInterest]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationRegionOfInterestCropRegionOfInterest], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationRegionOfInterestCropRegionOfInterest],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0eb8cf083d3017eefec1b251337cf34bf839daa4b86e2ee5f9dfa6e660f29f1e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationRelativeCrop",
    jsii_struct_bases=[],
    name_mapping={
        "east": "east",
        "east_var": "eastVar",
        "north": "north",
        "north_var": "northVar",
        "south": "south",
        "south_var": "southVar",
        "west": "west",
        "west_var": "westVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationRelativeCrop:
    def __init__(
        self,
        *,
        east: typing.Optional[builtins.str] = None,
        east_var: typing.Optional[builtins.str] = None,
        north: typing.Optional[builtins.str] = None,
        north_var: typing.Optional[builtins.str] = None,
        south: typing.Optional[builtins.str] = None,
        south_var: typing.Optional[builtins.str] = None,
        west: typing.Optional[builtins.str] = None,
        west_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param east: The number of pixels to shrink or expand the right side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east DataAkamaiImagingPolicyImage#east}
        :param east_var: The number of pixels to shrink or expand the right side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east_var DataAkamaiImagingPolicyImage#east_var}
        :param north: The number of pixels to shrink or expand the top side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north DataAkamaiImagingPolicyImage#north}
        :param north_var: The number of pixels to shrink or expand the top side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north_var DataAkamaiImagingPolicyImage#north_var}
        :param south: The number of pixels to shrink or expand the bottom side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south DataAkamaiImagingPolicyImage#south}
        :param south_var: The number of pixels to shrink or expand the bottom side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south_var DataAkamaiImagingPolicyImage#south_var}
        :param west: The number of pixels to shrink or expand the left side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west DataAkamaiImagingPolicyImage#west}
        :param west_var: The number of pixels to shrink or expand the left side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west_var DataAkamaiImagingPolicyImage#west_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__581a1840923a5f26dfaea456daf40f7a6e5c2c8d50ec27c26a30b4a5b805eaf7)
            check_type(argname="argument east", value=east, expected_type=type_hints["east"])
            check_type(argname="argument east_var", value=east_var, expected_type=type_hints["east_var"])
            check_type(argname="argument north", value=north, expected_type=type_hints["north"])
            check_type(argname="argument north_var", value=north_var, expected_type=type_hints["north_var"])
            check_type(argname="argument south", value=south, expected_type=type_hints["south"])
            check_type(argname="argument south_var", value=south_var, expected_type=type_hints["south_var"])
            check_type(argname="argument west", value=west, expected_type=type_hints["west"])
            check_type(argname="argument west_var", value=west_var, expected_type=type_hints["west_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if east is not None:
            self._values["east"] = east
        if east_var is not None:
            self._values["east_var"] = east_var
        if north is not None:
            self._values["north"] = north
        if north_var is not None:
            self._values["north_var"] = north_var
        if south is not None:
            self._values["south"] = south
        if south_var is not None:
            self._values["south_var"] = south_var
        if west is not None:
            self._values["west"] = west
        if west_var is not None:
            self._values["west_var"] = west_var

    @builtins.property
    def east(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the right side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east DataAkamaiImagingPolicyImage#east}
        '''
        result = self._values.get("east")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def east_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the right side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east_var DataAkamaiImagingPolicyImage#east_var}
        '''
        result = self._values.get("east_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def north(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the top side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north DataAkamaiImagingPolicyImage#north}
        '''
        result = self._values.get("north")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def north_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the top side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north_var DataAkamaiImagingPolicyImage#north_var}
        '''
        result = self._values.get("north_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def south(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the bottom side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south DataAkamaiImagingPolicyImage#south}
        '''
        result = self._values.get("south")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def south_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the bottom side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south_var DataAkamaiImagingPolicyImage#south_var}
        '''
        result = self._values.get("south_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def west(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the left side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west DataAkamaiImagingPolicyImage#west}
        '''
        result = self._values.get("west")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def west_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the left side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west_var DataAkamaiImagingPolicyImage#west_var}
        '''
        result = self._values.get("west_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationRelativeCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationRelativeCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationRelativeCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ccbb094a5428c447f16126038f6bc1b0d94bbc859bf9e57e55254119fd9cd25b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationRelativeCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8f829fa31d0e42459dea46d94d8a9ce0253ff06202b5b57a87d8af2d6513bbe7)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationRelativeCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f8e969d420bd6587b2d2a1c7dd8c51daad30a09661972a0aa457642959ca58ab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a4e1e8bc2463a60ef5f0ec7dd9e20a29686318fb6295e55ff1fe3d88f1a1c025)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f9deb9e02f6407e24e579fa02147a4f6077f11e302808f5bcc1eb044d2fce171)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationRelativeCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationRelativeCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationRelativeCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2623aeefe66d4c0e2c8ac7d0337107ab83644b09d0ae9c796ae4514b65d4328c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationRelativeCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationRelativeCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cb623219aa6ee9b925ae615dfb9e40f1130e4ff0d9d72a48849834a631f6f70d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetEast")
    def reset_east(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEast", []))

    @jsii.member(jsii_name="resetEastVar")
    def reset_east_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEastVar", []))

    @jsii.member(jsii_name="resetNorth")
    def reset_north(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNorth", []))

    @jsii.member(jsii_name="resetNorthVar")
    def reset_north_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNorthVar", []))

    @jsii.member(jsii_name="resetSouth")
    def reset_south(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSouth", []))

    @jsii.member(jsii_name="resetSouthVar")
    def reset_south_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSouthVar", []))

    @jsii.member(jsii_name="resetWest")
    def reset_west(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWest", []))

    @jsii.member(jsii_name="resetWestVar")
    def reset_west_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWestVar", []))

    @builtins.property
    @jsii.member(jsii_name="eastInput")
    def east_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "eastInput"))

    @builtins.property
    @jsii.member(jsii_name="eastVarInput")
    def east_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "eastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="northInput")
    def north_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "northInput"))

    @builtins.property
    @jsii.member(jsii_name="northVarInput")
    def north_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "northVarInput"))

    @builtins.property
    @jsii.member(jsii_name="southInput")
    def south_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "southInput"))

    @builtins.property
    @jsii.member(jsii_name="southVarInput")
    def south_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "southVarInput"))

    @builtins.property
    @jsii.member(jsii_name="westInput")
    def west_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "westInput"))

    @builtins.property
    @jsii.member(jsii_name="westVarInput")
    def west_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "westVarInput"))

    @builtins.property
    @jsii.member(jsii_name="east")
    def east(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "east"))

    @east.setter
    def east(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__80ddc4e8cc7d0f2cc5643791393d141d9bf7ded387db357f0478458ca0e8ac02)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "east", value)

    @builtins.property
    @jsii.member(jsii_name="eastVar")
    def east_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "eastVar"))

    @east_var.setter
    def east_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9dc0d504a9cbfaa72731e8df67512cac11a2774a13678b61979fb109f7c07f89)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "eastVar", value)

    @builtins.property
    @jsii.member(jsii_name="north")
    def north(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "north"))

    @north.setter
    def north(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc2edea2b7b2772d13a89a6a57e1a4563f0685c22b466963499c01594c919293)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "north", value)

    @builtins.property
    @jsii.member(jsii_name="northVar")
    def north_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "northVar"))

    @north_var.setter
    def north_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f1415ad849a741c4fa89a20c797b59b9ec64e8108566f5a298ea22b732d1f4bb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "northVar", value)

    @builtins.property
    @jsii.member(jsii_name="south")
    def south(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "south"))

    @south.setter
    def south(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be9b32a93ca11e0c0416a986fbe5891d7da149a8709ac86a1db10e0f1b3a4252)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "south", value)

    @builtins.property
    @jsii.member(jsii_name="southVar")
    def south_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "southVar"))

    @south_var.setter
    def south_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1bccc57f8bd521e233c8ee4e2dcbfb5a01fd6329f0290511b4a118240ce194d7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "southVar", value)

    @builtins.property
    @jsii.member(jsii_name="west")
    def west(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "west"))

    @west.setter
    def west(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__745452b0edc6d01876e65d57d67dfed3c5fd361cca86db38af3886d044e4c339)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "west", value)

    @builtins.property
    @jsii.member(jsii_name="westVar")
    def west_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "westVar"))

    @west_var.setter
    def west_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__de47af95b8b2592e3d872640d104e91e978d79516c51eeb2d587a98fcd285c51)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "westVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationRelativeCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationRelativeCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationRelativeCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4cd2971a369451459d5ff143970aa1a84998182e2ad82f8a7d7baaf8a784e620)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationRemoveColor",
    jsii_struct_bases=[],
    name_mapping={
        "color": "color",
        "color_var": "colorVar",
        "feather": "feather",
        "feather_var": "featherVar",
        "tolerance": "tolerance",
        "tolerance_var": "toleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationRemoveColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
        feather: typing.Optional[builtins.str] = None,
        feather_var: typing.Optional[builtins.str] = None,
        tolerance: typing.Optional[builtins.str] = None,
        tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        :param feather: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        :param feather_var: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        :param tolerance: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        :param tolerance_var: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e8c13a9cd1aed043b450461bc7c0586716d046bd320b2f982731a660462bff0a)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
            check_type(argname="argument feather", value=feather, expected_type=type_hints["feather"])
            check_type(argname="argument feather_var", value=feather_var, expected_type=type_hints["feather_var"])
            check_type(argname="argument tolerance", value=tolerance, expected_type=type_hints["tolerance"])
            check_type(argname="argument tolerance_var", value=tolerance_var, expected_type=type_hints["tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var
        if feather is not None:
            self._values["feather"] = feather
        if feather_var is not None:
            self._values["feather_var"] = feather_var
        if tolerance is not None:
            self._values["tolerance"] = tolerance
        if tolerance_var is not None:
            self._values["tolerance_var"] = tolerance_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        '''
        result = self._values.get("feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather_var(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        '''
        result = self._values.get("feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        '''
        result = self._values.get("tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance_var(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        result = self._values.get("tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationRemoveColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationRemoveColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationRemoveColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__210ccf6d52eb108eb6ad87cb8a50fcd7ed3e38c116ca86874a22cdc64e03350a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationRemoveColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__08f689d9ccbe6078503c42d9a9ab5be8086c01e396ee8eb6d311bdafe988e3ab)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationRemoveColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__864a3cdc570b9267c6b1c8b7193640aef55a677b927a71e38fbac8ec465f74f8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__42a2e569dd43379d8d36208c05e6318c9cbf78f15d44cc0ae69bce802d3f0d63)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__02af8a0bca24eb377a844499b955288b7f22c6f30f21a0d2418eefc1b8c3af89)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationRemoveColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationRemoveColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationRemoveColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5d720a0ff17c07b0ce3407035b08ac1c4ebd2bd7e80600f1aece516f9fe80150)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationRemoveColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationRemoveColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ae1ee0ba435d3b3075958a72256d06d0065d68405b07e92c5bb4907aa142c0a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @jsii.member(jsii_name="resetFeather")
    def reset_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeather", []))

    @jsii.member(jsii_name="resetFeatherVar")
    def reset_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatherVar", []))

    @jsii.member(jsii_name="resetTolerance")
    def reset_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTolerance", []))

    @jsii.member(jsii_name="resetToleranceVar")
    def reset_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featherInput")
    def feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherInput"))

    @builtins.property
    @jsii.member(jsii_name="featherVarInput")
    def feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceInput")
    def tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceVarInput")
    def tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__14636d01b461ada37320dd78228d462f20001364784ec54b3a7c070471db2295)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0fe0813d46c6de87093d54254f2fa2486b5dd97e79e4819dd24a296a50324817)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="feather")
    def feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "feather"))

    @feather.setter
    def feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ceeb3839e9dfe51bedee0e0bd5b4c03c6c0d52560acebfc705a18ccd4d4f69dc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "feather", value)

    @builtins.property
    @jsii.member(jsii_name="featherVar")
    def feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featherVar"))

    @feather_var.setter
    def feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ac71e120a3525284c180ced95ca62c0038217ccc4506642e4849663ddd2f0d6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featherVar", value)

    @builtins.property
    @jsii.member(jsii_name="tolerance")
    def tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tolerance"))

    @tolerance.setter
    def tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0a7eb119324a066335bd80cb845142be917ea37bcc41f371ce8c564b74f3b919)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tolerance", value)

    @builtins.property
    @jsii.member(jsii_name="toleranceVar")
    def tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "toleranceVar"))

    @tolerance_var.setter
    def tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__27b829b93a3485342bf3294801237765a5ffdad869e87375f8feb202fe8c9c35)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "toleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationRemoveColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationRemoveColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationRemoveColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e6d59edc92b8c1d2048c6d14cc40afce2df85c66bb17f00238252e2493c2a12)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationResize",
    jsii_struct_bases=[],
    name_mapping={
        "aspect": "aspect",
        "aspect_var": "aspectVar",
        "height": "height",
        "height_var": "heightVar",
        "type": "type",
        "type_var": "typeVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationResize:
    def __init__(
        self,
        *,
        aspect: typing.Optional[builtins.str] = None,
        aspect_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param aspect: Preserves the aspect ratio. Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect DataAkamaiImagingPolicyImage#aspect}
        :param aspect_var: Preserves the aspect ratio. Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_var DataAkamaiImagingPolicyImage#aspect_var}
        :param height: The height to resize the source image to. Must be set if height is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height to resize the source image to. Must be set if height is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param type: Sets constraints for the image resize. Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: Sets constraints for the image resize. Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        :param width: The width to resize the source image to. Must be set if width is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width to resize the source image to. Must be set if width is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4aafc891ec3cce0111d11df754061d73b67e339cbcf2a01b93e514bd95182e44)
            check_type(argname="argument aspect", value=aspect, expected_type=type_hints["aspect"])
            check_type(argname="argument aspect_var", value=aspect_var, expected_type=type_hints["aspect_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if aspect is not None:
            self._values["aspect"] = aspect
        if aspect_var is not None:
            self._values["aspect_var"] = aspect_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def aspect(self) -> typing.Optional[builtins.str]:
        '''Preserves the aspect ratio.

        Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect DataAkamaiImagingPolicyImage#aspect}
        '''
        result = self._values.get("aspect")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def aspect_var(self) -> typing.Optional[builtins.str]:
        '''Preserves the aspect ratio.

        Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_var DataAkamaiImagingPolicyImage#aspect_var}
        '''
        result = self._values.get("aspect_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height to resize the source image to. Must be set if height is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height to resize the source image to. Must be set if height is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''Sets constraints for the image resize.

        Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''Sets constraints for the image resize.

        Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width to resize the source image to. Must be set if width is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width to resize the source image to. Must be set if width is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationResize(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationResizeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationResizeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a3420c276ad45ff0d75d72c4e2f34bd8e36b4b3c9bddcb85890450aa70cc5f7a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationResizeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ee8acb969f4373de212550047217f27d0b7c3b5502adfff6ea724b0eef60aa0)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationResizeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4d3761bfc4f7a79e3cec068d4caa4ebc79fb47af549b44e194a85ae299f92592)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fb8cc09b8208ba168e721cbc56328beb7dce6bc8701c4a1789cc3652a9fe4036)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e8632927997d645ec37861b86daa740669b3501f81baa11301b6c3667ca00ad8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationResize]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationResize]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationResize]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7c86dc83b46223d700ef4b42b8ed92c8a9ff91d585e3fb69ab5c0e98f4448fa7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationResizeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationResizeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e70d572246b23648cab80b84f498a9b2c95312b7331442ce51a39f0e43154843)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAspect")
    def reset_aspect(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspect", []))

    @jsii.member(jsii_name="resetAspectVar")
    def reset_aspect_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspectVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="aspectInput")
    def aspect_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "aspectInput"))

    @builtins.property
    @jsii.member(jsii_name="aspectVarInput")
    def aspect_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "aspectVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="aspect")
    def aspect(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "aspect"))

    @aspect.setter
    def aspect(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ef999d9e816746524409e3b45d642b758fb370a12e7bd95b8a4a19fed26ab72)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "aspect", value)

    @builtins.property
    @jsii.member(jsii_name="aspectVar")
    def aspect_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "aspectVar"))

    @aspect_var.setter
    def aspect_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__44a95df8adcdae37386df43941fbcdcd15c313d12e9e68f65b2e5acec80218dd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "aspectVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__026f7fe21e2294dbf5e31631672570be0f0e6208b509a017564966a6bf77441b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8c376909f64603d1f73d081efbf9ad8c2229d190085fad7f75640a5fff952902)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d693157f686375cbe1a9ddad75fe4c71fe71731f3dae0637bde982cb35742125)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ef1e4793606bc5ceea26f5e332f77f0bc34d3c6cb9403a1ea8ed775e00893af0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__09ec63755f064bad931a9113ef13cbb4dfda018ccdeabee11b6ad8ef1ca21ded)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__844f1329b1e4bf2a87e89d13fa60796176c6a33f21f744b9a8c2d6439781ef65)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationResize]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationResize]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationResize]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c6e9477e0424da697526d2a7ce208d52c1412c731c0c200f5c200eff7e8d38c2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationRotate",
    jsii_struct_bases=[],
    name_mapping={"degrees": "degrees", "degrees_var": "degreesVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationRotate:
    def __init__(
        self,
        *,
        degrees: typing.Optional[builtins.str] = None,
        degrees_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param degrees: The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees DataAkamaiImagingPolicyImage#degrees}
        :param degrees_var: The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees_var DataAkamaiImagingPolicyImage#degrees_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4be25c36848ab3bbe515fc0a4b44d2980b959cbcd54bf250cd5b2cb9dfd5799b)
            check_type(argname="argument degrees", value=degrees, expected_type=type_hints["degrees"])
            check_type(argname="argument degrees_var", value=degrees_var, expected_type=type_hints["degrees_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if degrees is not None:
            self._values["degrees"] = degrees
        if degrees_var is not None:
            self._values["degrees_var"] = degrees_var

    @builtins.property
    def degrees(self) -> typing.Optional[builtins.str]:
        '''The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees DataAkamaiImagingPolicyImage#degrees}
        '''
        result = self._values.get("degrees")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def degrees_var(self) -> typing.Optional[builtins.str]:
        '''The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees_var DataAkamaiImagingPolicyImage#degrees_var}
        '''
        result = self._values.get("degrees_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationRotate(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationRotateList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationRotateList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a1b9f4b5d33cd334811860f6bc6b406709a1625e124038d9c035666c7c96670)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationRotateOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d2d49146a0e3a5cb117c3cae6166f2cb9f241e4acc6a6c7c3d312d2cadf75e3d)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationRotateOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ad68c51a9da6d8645b7bb5e1e817a043f165514b2f4e97d315aec7c3aa0f29dc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__26991d4e2e07cf20d7c4f49fbba86aa79f4f75f4cf4f176263c7b9d2642d1983)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__21a7ee3e8898d33648ea29ca9eb6864c9110c8f69ea09949749d28d2889afe46)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationRotate]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationRotate]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationRotate]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bd7a47d7bb0543eb90cf8552d73c12720c6abf52aaca10dc51921aabb7087a5e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationRotateOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationRotateOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea0845a7413aa57103e9680af06ebc3033d6f904dab16a02ceaf17697a05f2e9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetDegrees")
    def reset_degrees(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDegrees", []))

    @jsii.member(jsii_name="resetDegreesVar")
    def reset_degrees_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDegreesVar", []))

    @builtins.property
    @jsii.member(jsii_name="degreesInput")
    def degrees_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "degreesInput"))

    @builtins.property
    @jsii.member(jsii_name="degreesVarInput")
    def degrees_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "degreesVarInput"))

    @builtins.property
    @jsii.member(jsii_name="degrees")
    def degrees(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "degrees"))

    @degrees.setter
    def degrees(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__91781db69acec6540b019c5074b6c24f4dfe01587165cc3f7c60cb22b1409bef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "degrees", value)

    @builtins.property
    @jsii.member(jsii_name="degreesVar")
    def degrees_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "degreesVar"))

    @degrees_var.setter
    def degrees_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b02e20f70e7b5aef934cf10bf4b707db36182b8de1adf3434d6c17482a13f25b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "degreesVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationRotate]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationRotate]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationRotate]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a2b848b929100bd13642afdb3e802314c3f687875322546c5a80e9d907d2533b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationScale",
    jsii_struct_bases=[],
    name_mapping={
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationScale:
    def __init__(
        self,
        *,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param height: Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged. Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged. Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab487b78e225ad457399925ce1203e35699597c452d8bbe8ab1b7eacda0793e3)
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size.

        Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size.

        Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged.

        Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged.

        Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationScale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationScaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationScaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a7745a38761bcd63771065276cf827ceeaa134a6024ddd98af62b8f6db519ec4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationScaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c1e608c8c9dabc93c5ad91b162442f4b441cbed1efcbe7543d11372c3c1194c8)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationScaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d0ce4487ab2402e6aaa7d457204aa60c8b4cdc11c1d4b5961567f98a10126d53)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__84a113f6f3086bca17e880375314069238d6b92e977bdec8c7240398ed2a5803)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__41c0874ef888312b74f2b274b84a4ba3d7dc6f1e5d79ce28f33e323fa24ab738)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationScale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationScale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationScale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dde67af185524a81c34780a80d3e9488d182a9b11580e2b12209662408953884)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationScaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationScaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7a108b8925955fc5323c6dcc22ff9764b38cf989aa28d284877f927c22724b2a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5cc83d9bdc19d0293c91205494a817f760e462911a562582f67f9a517dac2d5d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4be7c97f975ab138c75fd8cc74e22336bdad1e8ab313b6f53a46c86335a449b3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__078a9e6f532311e5c0eba655b86c60376c3bc9d705a2ef4818fd09f8bbf3ef7e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ebb84fba3b28f38be685f96dc6e615c8bfdd8ea8bad567c740755e9835b26027)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationScale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationScale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationScale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__983878a0040acb221623e067ae30400cca8cce12983f924c897f87cdd9c2094d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationShear",
    jsii_struct_bases=[],
    name_mapping={
        "x_shear": "xShear",
        "x_shear_var": "xShearVar",
        "y_shear": "yShear",
        "y_shear_var": "yShearVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationShear:
    def __init__(
        self,
        *,
        x_shear: typing.Optional[builtins.str] = None,
        x_shear_var: typing.Optional[builtins.str] = None,
        y_shear: typing.Optional[builtins.str] = None,
        y_shear_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param x_shear: The amount to shear along the x-axis, measured in multiples of the image's width. Must be set if yShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear DataAkamaiImagingPolicyImage#x_shear}
        :param x_shear_var: The amount to shear along the x-axis, measured in multiples of the image's width. Must be set if yShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear_var DataAkamaiImagingPolicyImage#x_shear_var}
        :param y_shear: The amount to shear along the y-axis, measured in multiples of the image's height. Must be set if xShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear DataAkamaiImagingPolicyImage#y_shear}
        :param y_shear_var: The amount to shear along the y-axis, measured in multiples of the image's height. Must be set if xShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear_var DataAkamaiImagingPolicyImage#y_shear_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8196ebe43954063d3a5457cd07371346b91fd211539e7c82c1b642f81a777c93)
            check_type(argname="argument x_shear", value=x_shear, expected_type=type_hints["x_shear"])
            check_type(argname="argument x_shear_var", value=x_shear_var, expected_type=type_hints["x_shear_var"])
            check_type(argname="argument y_shear", value=y_shear, expected_type=type_hints["y_shear"])
            check_type(argname="argument y_shear_var", value=y_shear_var, expected_type=type_hints["y_shear_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if x_shear is not None:
            self._values["x_shear"] = x_shear
        if x_shear_var is not None:
            self._values["x_shear_var"] = x_shear_var
        if y_shear is not None:
            self._values["y_shear"] = y_shear
        if y_shear_var is not None:
            self._values["y_shear_var"] = y_shear_var

    @builtins.property
    def x_shear(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the x-axis, measured in multiples of the image's width.

        Must be set if yShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear DataAkamaiImagingPolicyImage#x_shear}
        '''
        result = self._values.get("x_shear")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_shear_var(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the x-axis, measured in multiples of the image's width.

        Must be set if yShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear_var DataAkamaiImagingPolicyImage#x_shear_var}
        '''
        result = self._values.get("x_shear_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_shear(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the y-axis, measured in multiples of the image's height.

        Must be set if xShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear DataAkamaiImagingPolicyImage#y_shear}
        '''
        result = self._values.get("y_shear")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_shear_var(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the y-axis, measured in multiples of the image's height.

        Must be set if xShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear_var DataAkamaiImagingPolicyImage#y_shear_var}
        '''
        result = self._values.get("y_shear_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationShear(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationShearList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationShearList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c494f5765a57d544944c7534dd1ff3005577c9e1b8187784f207c505d4dc417c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationShearOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__67770287f697774ea0995137a4e13c82ab697151d38393f762fd0526f8024db1)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationShearOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6060581e2fc030bdbf99afdfcfe47ab8288d2b8d1655cb0ef351f1c2c6b3c8d3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9b710a7227d36ef88a7fb6c4c3e5f0fc17de4f85f51b6d49c8699d71c6cf629a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ddf6f85e8dcb27281b298b933dc4f15133b84b3aab24431148aca597a6d96cf7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationShear]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationShear]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationShear]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2c2069282a0442b710c68f823a8be705e559d3ce60ed22fa59d75947503f305d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationShearOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationShearOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f77298b3a5a7bfbdef7a8ea45e077387ffb722f36c51965794f6de958b474ca7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetXShear")
    def reset_x_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXShear", []))

    @jsii.member(jsii_name="resetXShearVar")
    def reset_x_shear_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXShearVar", []))

    @jsii.member(jsii_name="resetYShear")
    def reset_y_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYShear", []))

    @jsii.member(jsii_name="resetYShearVar")
    def reset_y_shear_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYShearVar", []))

    @builtins.property
    @jsii.member(jsii_name="xShearInput")
    def x_shear_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xShearInput"))

    @builtins.property
    @jsii.member(jsii_name="xShearVarInput")
    def x_shear_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xShearVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yShearInput")
    def y_shear_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yShearInput"))

    @builtins.property
    @jsii.member(jsii_name="yShearVarInput")
    def y_shear_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yShearVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xShear")
    def x_shear(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xShear"))

    @x_shear.setter
    def x_shear(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0a0f5d0ee1394d0f4f378f2e66f20c262df89790dbd1ca62ac616cc18199f4c5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xShear", value)

    @builtins.property
    @jsii.member(jsii_name="xShearVar")
    def x_shear_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xShearVar"))

    @x_shear_var.setter
    def x_shear_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5a2bcdc1593291069a0b67480fc19d8e22e64a94e38aedf497abd84a2397cb83)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xShearVar", value)

    @builtins.property
    @jsii.member(jsii_name="yShear")
    def y_shear(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yShear"))

    @y_shear.setter
    def y_shear(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b0ca6c2fd7b0ba411e7b48eb923a9a31d8e14c5c3e3eb4f9310cfbd4348a9558)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yShear", value)

    @builtins.property
    @jsii.member(jsii_name="yShearVar")
    def y_shear_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yShearVar"))

    @y_shear_var.setter
    def y_shear_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4f762f84f90c092553450d4c864d2a2003be6135e6b2bdbbe0ef9971d3d620ad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yShearVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationShear]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationShear]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationShear]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2f5000fadf33c7a41be56263e3f9e71ca66d9fe2edb8f0a3115f333ae2874639)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationTrim",
    jsii_struct_bases=[],
    name_mapping={
        "fuzz": "fuzz",
        "fuzz_var": "fuzzVar",
        "padding": "padding",
        "padding_var": "paddingVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationTrim:
    def __init__(
        self,
        *,
        fuzz: typing.Optional[builtins.str] = None,
        fuzz_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fuzz: The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz DataAkamaiImagingPolicyImage#fuzz}
        :param fuzz_var: The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz_var DataAkamaiImagingPolicyImage#fuzz_var}
        :param padding: The amount of padding in pixels to add to the trimmed image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: The amount of padding in pixels to add to the trimmed image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__70190df1987417a52edbec64845110bdba0cad8d86423437bdb8229855dbb351)
            check_type(argname="argument fuzz", value=fuzz, expected_type=type_hints["fuzz"])
            check_type(argname="argument fuzz_var", value=fuzz_var, expected_type=type_hints["fuzz_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fuzz is not None:
            self._values["fuzz"] = fuzz
        if fuzz_var is not None:
            self._values["fuzz_var"] = fuzz_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var

    @builtins.property
    def fuzz(self) -> typing.Optional[builtins.str]:
        '''The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz DataAkamaiImagingPolicyImage#fuzz}
        '''
        result = self._values.get("fuzz")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fuzz_var(self) -> typing.Optional[builtins.str]:
        '''The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz_var DataAkamaiImagingPolicyImage#fuzz_var}
        '''
        result = self._values.get("fuzz_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''The amount of padding in pixels to add to the trimmed image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''The amount of padding in pixels to add to the trimmed image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationTrim(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationTrimList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationTrimList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea0c3ba434de77795f05c7e6327adbcc9f578c53fa67ecb2314d1aa7a1554f74)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationTrimOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b3d932d24201738a2485d13d1a431e09711388cb7287f84f77db16fe91df2caf)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationTrimOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__557b82afb8e16bcd6f14c3147b4497be738a6641eaccc0f1a1ffaa0aeeddd633)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f5db89a872edfef62ec285102bd63932e43a0978453a5a1a2d5dab63f61d2233)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ad85ae1d4048ac1dc8cb302ab308463ea586fee36ed669555bff54be1966d241)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationTrim]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationTrim]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationTrim]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4421807b01ad284e196992a0226b01fd5d0004e7b0b948d15ca74a108187821d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationTrimOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationTrimOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e4a1457c976ad37e049c12de80706b3b11a89940b2fec4acb154f769350ae6de)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetFuzz")
    def reset_fuzz(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFuzz", []))

    @jsii.member(jsii_name="resetFuzzVar")
    def reset_fuzz_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFuzzVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @builtins.property
    @jsii.member(jsii_name="fuzzInput")
    def fuzz_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fuzzInput"))

    @builtins.property
    @jsii.member(jsii_name="fuzzVarInput")
    def fuzz_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fuzzVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="fuzz")
    def fuzz(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fuzz"))

    @fuzz.setter
    def fuzz(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__268cb03514fe689ec621763c095aea9faf7a01d1b42e615954e7a18c9f54369f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fuzz", value)

    @builtins.property
    @jsii.member(jsii_name="fuzzVar")
    def fuzz_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fuzzVar"))

    @fuzz_var.setter
    def fuzz_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d8f6e0c0a669847d123530a23179eed9a9f92c44e5bf8fda60dc917853cfae2e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fuzzVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__feff93c57542c55f0e78d1365d2f03831d06e34e29299fdf28011cecefad5002)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a51c0cc7a21fd86f53ecfe720ef34df4d59dc04849eb6f957a8bda976d0365d3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationTrim]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationTrim]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationTrim]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__14659543152ebbc2fab09340e0155765afdff279f941a3385cad2b3e696416c4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationUnsharpMask",
    jsii_struct_bases=[],
    name_mapping={
        "gain": "gain",
        "gain_var": "gainVar",
        "sigma": "sigma",
        "sigma_var": "sigmaVar",
        "threshold": "threshold",
        "threshold_var": "thresholdVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationUnsharpMask:
    def __init__(
        self,
        *,
        gain: typing.Optional[builtins.str] = None,
        gain_var: typing.Optional[builtins.str] = None,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
        threshold: typing.Optional[builtins.str] = None,
        threshold_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param gain: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        :param gain_var: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        :param sigma: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        :param threshold: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        :param threshold_var: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__892eb902a26a731b773f8e0078029dd7226868faf9d146c23075deb33681fb7a)
            check_type(argname="argument gain", value=gain, expected_type=type_hints["gain"])
            check_type(argname="argument gain_var", value=gain_var, expected_type=type_hints["gain_var"])
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
            check_type(argname="argument threshold", value=threshold, expected_type=type_hints["threshold"])
            check_type(argname="argument threshold_var", value=threshold_var, expected_type=type_hints["threshold_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if gain is not None:
            self._values["gain"] = gain
        if gain_var is not None:
            self._values["gain_var"] = gain_var
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var
        if threshold is not None:
            self._values["threshold"] = threshold
        if threshold_var is not None:
            self._values["threshold_var"] = threshold_var

    @builtins.property
    def gain(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        '''
        result = self._values.get("gain")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gain_var(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        '''
        result = self._values.get("gain_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        '''
        result = self._values.get("threshold")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold_var(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        result = self._values.get("threshold_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationUnsharpMask(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationUnsharpMaskList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationUnsharpMaskList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f8d0f7b95b14715db610d380add353c81e4b0b5ee67a8d2e8a6ca7bf73e472a2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationUnsharpMaskOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0be3c434990f00b94909d39264a5255a9382f68a8e93a665bf91d7492792bfc8)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationUnsharpMaskOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4b112bcb745c24a4d4f7943ef22c264f93600cc2e3964db877bb1be9f2c59c1b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f7b05fe403cc108663f2a80e937a74cda0070ab60963ec76d15ea9c8165e6c08)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e78538c64e04b753c2a07da127e2acf7e8f45e8bd712b50e02674f3c616c4fdf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationUnsharpMask]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationUnsharpMask]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationUnsharpMask]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9e485855572c45231d1fcc1eba9b8fce077f0b8f39b86f54048495477f02f1ae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationUnsharpMaskOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationUnsharpMaskOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aaac9456556c7f1593978f3177eaebc06feb6fd978fc8a034533b5f688378cb1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetGain")
    def reset_gain(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGain", []))

    @jsii.member(jsii_name="resetGainVar")
    def reset_gain_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGainVar", []))

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @jsii.member(jsii_name="resetThreshold")
    def reset_threshold(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThreshold", []))

    @jsii.member(jsii_name="resetThresholdVar")
    def reset_threshold_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThresholdVar", []))

    @builtins.property
    @jsii.member(jsii_name="gainInput")
    def gain_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainInput"))

    @builtins.property
    @jsii.member(jsii_name="gainVarInput")
    def gain_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdInput")
    def threshold_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdVarInput")
    def threshold_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gain")
    def gain(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gain"))

    @gain.setter
    def gain(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__50d9dfee512b47892899c6163adfd2d61ff1a2fa00a8186986faf0feca7ff82e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gain", value)

    @builtins.property
    @jsii.member(jsii_name="gainVar")
    def gain_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gainVar"))

    @gain_var.setter
    def gain_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__145bf57f955a3d186337b9ecb5460366222d37b26aa4211738347b3ad7e0eaed)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gainVar", value)

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fbf717115860b53c723e990b437bcd2f1e96f1aff72f298a9e50a4c539238e88)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f4406839aeaaf3fe8a6a90f5c114f46a39ebf47fe4eb1faea8ce8afedcecca10)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="threshold")
    def threshold(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "threshold"))

    @threshold.setter
    def threshold(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f1ac8b5de5c726a2108642238d26c2e07c2f099436db9b83d104d6f980559fd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "threshold", value)

    @builtins.property
    @jsii.member(jsii_name="thresholdVar")
    def threshold_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "thresholdVar"))

    @threshold_var.setter
    def threshold_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3f6f96ce3b9b3048597ed592d8d333c68ea97c8bd3724aa2d1ef4c1797fbb7c6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "thresholdVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationUnsharpMask]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationUnsharpMask]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationUnsharpMask]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__543a5e30d32a84f98c2a6f822f20babf734e8e18cfa8fd327c98117868b63df5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__97cd1fa3c0170fcf874c33d6bdb0832e03a4b08ff8f600059cf9a5cc4fa786fc)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putBoxImage")
    def put_box_image(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImage, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cac558e4128528a73cbc2c08bc6c851e788200d4573a51f0b1bf20cde6f64eac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBoxImage", [value]))

    @jsii.member(jsii_name="putCircleImage")
    def put_circle_image(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImage, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3959bcb12c1e1f5b37c4753acf5c6fb9fe38463c40fbfd7c9ed5a43eada45ed9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCircleImage", [value]))

    @jsii.member(jsii_name="putTextImage")
    def put_text_image(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImage", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6fd08d0a870b077c0d301772fa69bd9e6b4960125b7598820b5c5253de786fbf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTextImage", [value]))

    @jsii.member(jsii_name="putUrlImage")
    def put_url_image(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImage", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__880c1c35723218982c2aca348468518371ea8737c1dfd5ca18d2df02b0090568)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putUrlImage", [value]))

    @jsii.member(jsii_name="resetBoxImage")
    def reset_box_image(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBoxImage", []))

    @jsii.member(jsii_name="resetCircleImage")
    def reset_circle_image(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCircleImage", []))

    @jsii.member(jsii_name="resetTextImage")
    def reset_text_image(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTextImage", []))

    @jsii.member(jsii_name="resetUrlImage")
    def reset_url_image(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUrlImage", []))

    @builtins.property
    @jsii.member(jsii_name="boxImage")
    def box_image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageList, jsii.get(self, "boxImage"))

    @builtins.property
    @jsii.member(jsii_name="circleImage")
    def circle_image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageList, jsii.get(self, "circleImage"))

    @builtins.property
    @jsii.member(jsii_name="textImage")
    def text_image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageList", jsii.get(self, "textImage"))

    @builtins.property
    @jsii.member(jsii_name="urlImage")
    def url_image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageList", jsii.get(self, "urlImage"))

    @builtins.property
    @jsii.member(jsii_name="boxImageInput")
    def box_image_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImage]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImage]]], jsii.get(self, "boxImageInput"))

    @builtins.property
    @jsii.member(jsii_name="circleImageInput")
    def circle_image_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImage]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImage]]], jsii.get(self, "circleImageInput"))

    @builtins.property
    @jsii.member(jsii_name="textImageInput")
    def text_image_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImage"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImage"]]], jsii.get(self, "textImageInput"))

    @builtins.property
    @jsii.member(jsii_name="urlImageInput")
    def url_image_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImage"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImage"]]], jsii.get(self, "urlImageInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f3015457c065242637306ce63fa93c397a29d35f1684d25c89d123b7128321c3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImage",
    jsii_struct_bases=[],
    name_mapping={
        "fill": "fill",
        "fill_var": "fillVar",
        "size": "size",
        "size_var": "sizeVar",
        "stroke": "stroke",
        "stroke_size": "strokeSize",
        "stroke_size_var": "strokeSizeVar",
        "stroke_var": "strokeVar",
        "text": "text",
        "text_var": "textVar",
        "transformation": "transformation",
        "typeface": "typeface",
        "typeface_var": "typefaceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImage:
    def __init__(
        self,
        *,
        fill: typing.Optional[builtins.str] = None,
        fill_var: typing.Optional[builtins.str] = None,
        size: typing.Optional[builtins.str] = None,
        size_var: typing.Optional[builtins.str] = None,
        stroke: typing.Optional[builtins.str] = None,
        stroke_size: typing.Optional[builtins.str] = None,
        stroke_size_var: typing.Optional[builtins.str] = None,
        stroke_var: typing.Optional[builtins.str] = None,
        text: typing.Optional[builtins.str] = None,
        text_var: typing.Optional[builtins.str] = None,
        transformation: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        typeface: typing.Optional[builtins.str] = None,
        typeface_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fill: The main fill color of the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill DataAkamaiImagingPolicyImage#fill}
        :param fill_var: The main fill color of the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_var DataAkamaiImagingPolicyImage#fill_var}
        :param size: The size in pixels to render the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#size DataAkamaiImagingPolicyImage#size}
        :param size_var: The size in pixels to render the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#size_var DataAkamaiImagingPolicyImage#size_var}
        :param stroke: The color for the outline of the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke DataAkamaiImagingPolicyImage#stroke}
        :param stroke_size: The thickness in points for the outline of the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_size DataAkamaiImagingPolicyImage#stroke_size}
        :param stroke_size_var: The thickness in points for the outline of the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_size_var DataAkamaiImagingPolicyImage#stroke_size_var}
        :param stroke_var: The color for the outline of the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_var DataAkamaiImagingPolicyImage#stroke_var}
        :param text: The line of text to render. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text DataAkamaiImagingPolicyImage#text}
        :param text_var: The line of text to render. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text_var DataAkamaiImagingPolicyImage#text_var}
        :param transformation: transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        :param typeface: The font family to apply to the text image. This may be a URL to a TrueType or WOFF (v1) typeface, or a string that refers to one of the standard built-in browser fonts. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#typeface DataAkamaiImagingPolicyImage#typeface}
        :param typeface_var: The font family to apply to the text image. This may be a URL to a TrueType or WOFF (v1) typeface, or a string that refers to one of the standard built-in browser fonts. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#typeface_var DataAkamaiImagingPolicyImage#typeface_var}
        '''
        if isinstance(transformation, dict):
            transformation = DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformation(**transformation)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__435f2530b971e0267a8ae6d76cb939e81c73e9531db440a136a4a0378701c72d)
            check_type(argname="argument fill", value=fill, expected_type=type_hints["fill"])
            check_type(argname="argument fill_var", value=fill_var, expected_type=type_hints["fill_var"])
            check_type(argname="argument size", value=size, expected_type=type_hints["size"])
            check_type(argname="argument size_var", value=size_var, expected_type=type_hints["size_var"])
            check_type(argname="argument stroke", value=stroke, expected_type=type_hints["stroke"])
            check_type(argname="argument stroke_size", value=stroke_size, expected_type=type_hints["stroke_size"])
            check_type(argname="argument stroke_size_var", value=stroke_size_var, expected_type=type_hints["stroke_size_var"])
            check_type(argname="argument stroke_var", value=stroke_var, expected_type=type_hints["stroke_var"])
            check_type(argname="argument text", value=text, expected_type=type_hints["text"])
            check_type(argname="argument text_var", value=text_var, expected_type=type_hints["text_var"])
            check_type(argname="argument transformation", value=transformation, expected_type=type_hints["transformation"])
            check_type(argname="argument typeface", value=typeface, expected_type=type_hints["typeface"])
            check_type(argname="argument typeface_var", value=typeface_var, expected_type=type_hints["typeface_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fill is not None:
            self._values["fill"] = fill
        if fill_var is not None:
            self._values["fill_var"] = fill_var
        if size is not None:
            self._values["size"] = size
        if size_var is not None:
            self._values["size_var"] = size_var
        if stroke is not None:
            self._values["stroke"] = stroke
        if stroke_size is not None:
            self._values["stroke_size"] = stroke_size
        if stroke_size_var is not None:
            self._values["stroke_size_var"] = stroke_size_var
        if stroke_var is not None:
            self._values["stroke_var"] = stroke_var
        if text is not None:
            self._values["text"] = text
        if text_var is not None:
            self._values["text_var"] = text_var
        if transformation is not None:
            self._values["transformation"] = transformation
        if typeface is not None:
            self._values["typeface"] = typeface
        if typeface_var is not None:
            self._values["typeface_var"] = typeface_var

    @builtins.property
    def fill(self) -> typing.Optional[builtins.str]:
        '''The main fill color of the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill DataAkamaiImagingPolicyImage#fill}
        '''
        result = self._values.get("fill")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fill_var(self) -> typing.Optional[builtins.str]:
        '''The main fill color of the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_var DataAkamaiImagingPolicyImage#fill_var}
        '''
        result = self._values.get("fill_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def size(self) -> typing.Optional[builtins.str]:
        '''The size in pixels to render the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#size DataAkamaiImagingPolicyImage#size}
        '''
        result = self._values.get("size")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def size_var(self) -> typing.Optional[builtins.str]:
        '''The size in pixels to render the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#size_var DataAkamaiImagingPolicyImage#size_var}
        '''
        result = self._values.get("size_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def stroke(self) -> typing.Optional[builtins.str]:
        '''The color for the outline of the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke DataAkamaiImagingPolicyImage#stroke}
        '''
        result = self._values.get("stroke")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def stroke_size(self) -> typing.Optional[builtins.str]:
        '''The thickness in points for the outline of the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_size DataAkamaiImagingPolicyImage#stroke_size}
        '''
        result = self._values.get("stroke_size")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def stroke_size_var(self) -> typing.Optional[builtins.str]:
        '''The thickness in points for the outline of the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_size_var DataAkamaiImagingPolicyImage#stroke_size_var}
        '''
        result = self._values.get("stroke_size_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def stroke_var(self) -> typing.Optional[builtins.str]:
        '''The color for the outline of the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_var DataAkamaiImagingPolicyImage#stroke_var}
        '''
        result = self._values.get("stroke_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def text(self) -> typing.Optional[builtins.str]:
        '''The line of text to render.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text DataAkamaiImagingPolicyImage#text}
        '''
        result = self._values.get("text")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def text_var(self) -> typing.Optional[builtins.str]:
        '''The line of text to render.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text_var DataAkamaiImagingPolicyImage#text_var}
        '''
        result = self._values.get("text_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def transformation(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformation"]:
        '''transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        '''
        result = self._values.get("transformation")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformation"], result)

    @builtins.property
    def typeface(self) -> typing.Optional[builtins.str]:
        '''The font family to apply to the text image.

        This may be a URL to a TrueType or WOFF (v1) typeface, or a string that refers to one of the standard built-in browser fonts.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#typeface DataAkamaiImagingPolicyImage#typeface}
        '''
        result = self._values.get("typeface")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def typeface_var(self) -> typing.Optional[builtins.str]:
        '''The font family to apply to the text image.

        This may be a URL to a TrueType or WOFF (v1) typeface, or a string that refers to one of the standard built-in browser fonts.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#typeface_var DataAkamaiImagingPolicyImage#typeface_var}
        '''
        result = self._values.get("typeface_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b7b445af5e2ae1515988949d5245447b2efb7a0dd1a4d0ded2ff417fc7a151c8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__117bd174367eb3b949bd9cb883301db11813ffe2a0260ef5005e31f34fd6d674)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d2d0f218a19075a976f02809fbd52b66d4430814970952bec9ef1d8cf8329f2e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c94f2b97eb17c41e1c16c9c816868995f72659ef462acbdc31596d0e2d9dfb35)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__235c213f0f612bae04b3f16628e1d09f4f3acd737e88b53a17d51ffa33c5d19d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImage]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImage]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImage]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__13b646118d1f8ae4a3d46768e02442e9d343f79ccc694c18501d05ebad0392a0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8d405f779db437a340155d2d0e07b13f73cc53922f12b72f65c335fb2d69bdf7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformation")
    def put_transformation(
        self,
        *,
        append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationAppend", typing.Dict[builtins.str, typing.Any]]]]] = None,
        aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationAspectCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationBackgroundColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationBlur", typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationChromaKey", typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationComposite", typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationCompound", typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationContrast", typing.Dict[builtins.str, typing.Any]]]]] = None,
        crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationFaceCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationFeatureCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationFitAndFill", typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationGoop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationGrayscale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationHsl", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationHsv", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfDimension", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfOrientation", typing.Dict[builtins.str, typing.Any]]]]] = None,
        im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationImQuery", typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationMaxColors", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationMirror", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationMonoHue", typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationOpacity", typing.Dict[builtins.str, typing.Any]]]]] = None,
        region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationRegionOfInterestCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationRelativeCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationRemoveColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationResize", typing.Dict[builtins.str, typing.Any]]]]] = None,
        rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationRotate", typing.Dict[builtins.str, typing.Any]]]]] = None,
        scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationScale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationShear", typing.Dict[builtins.str, typing.Any]]]]] = None,
        trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationTrim", typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationUnsharpMask", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param append: append block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        :param aspect_crop: aspect_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param crop: crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        :param face_crop: face_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        :param feature_crop: feature_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        :param fit_and_fill: fit_and_fill block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param im_query: im_query block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param region_of_interest_crop: region_of_interest_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        :param relative_crop: relative_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param resize: resize block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        :param rotate: rotate block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        :param scale: scale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param shear: shear block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        :param trim: trim block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        value = DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformation(
            append=append,
            aspect_crop=aspect_crop,
            background_color=background_color,
            blur=blur,
            chroma_key=chroma_key,
            composite=composite,
            compound=compound,
            contrast=contrast,
            crop=crop,
            face_crop=face_crop,
            feature_crop=feature_crop,
            fit_and_fill=fit_and_fill,
            goop=goop,
            grayscale=grayscale,
            hsl=hsl,
            hsv=hsv,
            if_dimension=if_dimension,
            if_orientation=if_orientation,
            im_query=im_query,
            max_colors=max_colors,
            mirror=mirror,
            mono_hue=mono_hue,
            opacity=opacity,
            region_of_interest_crop=region_of_interest_crop,
            relative_crop=relative_crop,
            remove_color=remove_color,
            resize=resize,
            rotate=rotate,
            scale=scale,
            shear=shear,
            trim=trim,
            unsharp_mask=unsharp_mask,
        )

        return typing.cast(None, jsii.invoke(self, "putTransformation", [value]))

    @jsii.member(jsii_name="resetFill")
    def reset_fill(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFill", []))

    @jsii.member(jsii_name="resetFillVar")
    def reset_fill_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFillVar", []))

    @jsii.member(jsii_name="resetSize")
    def reset_size(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSize", []))

    @jsii.member(jsii_name="resetSizeVar")
    def reset_size_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSizeVar", []))

    @jsii.member(jsii_name="resetStroke")
    def reset_stroke(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStroke", []))

    @jsii.member(jsii_name="resetStrokeSize")
    def reset_stroke_size(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStrokeSize", []))

    @jsii.member(jsii_name="resetStrokeSizeVar")
    def reset_stroke_size_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStrokeSizeVar", []))

    @jsii.member(jsii_name="resetStrokeVar")
    def reset_stroke_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStrokeVar", []))

    @jsii.member(jsii_name="resetText")
    def reset_text(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetText", []))

    @jsii.member(jsii_name="resetTextVar")
    def reset_text_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTextVar", []))

    @jsii.member(jsii_name="resetTransformation")
    def reset_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformation", []))

    @jsii.member(jsii_name="resetTypeface")
    def reset_typeface(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeface", []))

    @jsii.member(jsii_name="resetTypefaceVar")
    def reset_typeface_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypefaceVar", []))

    @builtins.property
    @jsii.member(jsii_name="transformation")
    def transformation(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationOutputReference", jsii.get(self, "transformation"))

    @builtins.property
    @jsii.member(jsii_name="fillInput")
    def fill_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fillInput"))

    @builtins.property
    @jsii.member(jsii_name="fillVarInput")
    def fill_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fillVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sizeInput")
    def size_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sizeInput"))

    @builtins.property
    @jsii.member(jsii_name="sizeVarInput")
    def size_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sizeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="strokeInput")
    def stroke_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "strokeInput"))

    @builtins.property
    @jsii.member(jsii_name="strokeSizeInput")
    def stroke_size_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "strokeSizeInput"))

    @builtins.property
    @jsii.member(jsii_name="strokeSizeVarInput")
    def stroke_size_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "strokeSizeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="strokeVarInput")
    def stroke_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "strokeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="textInput")
    def text_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "textInput"))

    @builtins.property
    @jsii.member(jsii_name="textVarInput")
    def text_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "textVarInput"))

    @builtins.property
    @jsii.member(jsii_name="transformationInput")
    def transformation_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformation"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformation"], jsii.get(self, "transformationInput"))

    @builtins.property
    @jsii.member(jsii_name="typefaceInput")
    def typeface_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typefaceInput"))

    @builtins.property
    @jsii.member(jsii_name="typefaceVarInput")
    def typeface_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typefaceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="fill")
    def fill(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fill"))

    @fill.setter
    def fill(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7ef632897b89b10669a22b496ed6f2376f7a86a7d0004334ab7bedf1db2b44b0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fill", value)

    @builtins.property
    @jsii.member(jsii_name="fillVar")
    def fill_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fillVar"))

    @fill_var.setter
    def fill_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__36d6178b23b2db364315155b385ce8e622247e3bfc51ca70d0e7c53d4c5f4090)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fillVar", value)

    @builtins.property
    @jsii.member(jsii_name="size")
    def size(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "size"))

    @size.setter
    def size(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0acb70dda7cdf933b27f5c77a841754b95206ad2ac07f67648ea6bd5b0893109)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "size", value)

    @builtins.property
    @jsii.member(jsii_name="sizeVar")
    def size_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sizeVar"))

    @size_var.setter
    def size_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__64f90ac5cdfb92719a6473510ba0ba23fbb674c19b0cb0b908f91ade1bebb097)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sizeVar", value)

    @builtins.property
    @jsii.member(jsii_name="stroke")
    def stroke(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "stroke"))

    @stroke.setter
    def stroke(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a6b909eaf207af2caf5c40b69e76b611c4dea1d2702a0b9293d1c60f4ccb4f77)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "stroke", value)

    @builtins.property
    @jsii.member(jsii_name="strokeSize")
    def stroke_size(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "strokeSize"))

    @stroke_size.setter
    def stroke_size(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__487e815615d241479506825e74c9182798f7648b34e1325d2a84cfd47f0eb9e1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "strokeSize", value)

    @builtins.property
    @jsii.member(jsii_name="strokeSizeVar")
    def stroke_size_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "strokeSizeVar"))

    @stroke_size_var.setter
    def stroke_size_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4b05864a7bf8299d122cad4f5e6287f105ec19ab554f67abadb22e131a6d15cc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "strokeSizeVar", value)

    @builtins.property
    @jsii.member(jsii_name="strokeVar")
    def stroke_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "strokeVar"))

    @stroke_var.setter
    def stroke_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__78b4604496ad724de3baf6ea9d68efb8012ae4d6fa6db6ec4511d0046397396e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "strokeVar", value)

    @builtins.property
    @jsii.member(jsii_name="text")
    def text(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "text"))

    @text.setter
    def text(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d5419c369acb8c19da44044f4554f1f072b0416f3bcdd13034a90fa76dbe593)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "text", value)

    @builtins.property
    @jsii.member(jsii_name="textVar")
    def text_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "textVar"))

    @text_var.setter
    def text_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9c8ff7453b950eb69878ac189486c529d8ac06aa7753aabad5619c87f265d916)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "textVar", value)

    @builtins.property
    @jsii.member(jsii_name="typeface")
    def typeface(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeface"))

    @typeface.setter
    def typeface(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8713eb0b8bea8c5d6b53f9341873fe7dc6357344649e9fab63dde72670f31c70)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeface", value)

    @builtins.property
    @jsii.member(jsii_name="typefaceVar")
    def typeface_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typefaceVar"))

    @typeface_var.setter
    def typeface_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a0e3b714ce3be328d8fe15de45b36958a5ac3cef89758a2b483f5e6f2a889852)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typefaceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImage]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImage]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImage]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ded636fefc7e6ed7b64fb894bdeac2e553d5755237a101adc1e3d55e2113d58a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformation",
    jsii_struct_bases=[],
    name_mapping={
        "append": "append",
        "aspect_crop": "aspectCrop",
        "background_color": "backgroundColor",
        "blur": "blur",
        "chroma_key": "chromaKey",
        "composite": "composite",
        "compound": "compound",
        "contrast": "contrast",
        "crop": "crop",
        "face_crop": "faceCrop",
        "feature_crop": "featureCrop",
        "fit_and_fill": "fitAndFill",
        "goop": "goop",
        "grayscale": "grayscale",
        "hsl": "hsl",
        "hsv": "hsv",
        "if_dimension": "ifDimension",
        "if_orientation": "ifOrientation",
        "im_query": "imQuery",
        "max_colors": "maxColors",
        "mirror": "mirror",
        "mono_hue": "monoHue",
        "opacity": "opacity",
        "region_of_interest_crop": "regionOfInterestCrop",
        "relative_crop": "relativeCrop",
        "remove_color": "removeColor",
        "resize": "resize",
        "rotate": "rotate",
        "scale": "scale",
        "shear": "shear",
        "trim": "trim",
        "unsharp_mask": "unsharpMask",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformation:
    def __init__(
        self,
        *,
        append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationAppend", typing.Dict[builtins.str, typing.Any]]]]] = None,
        aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationAspectCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationBackgroundColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationBlur", typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationChromaKey", typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationComposite", typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationCompound", typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationContrast", typing.Dict[builtins.str, typing.Any]]]]] = None,
        crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationFaceCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationFeatureCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationFitAndFill", typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationGoop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationGrayscale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationHsl", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationHsv", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfDimension", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfOrientation", typing.Dict[builtins.str, typing.Any]]]]] = None,
        im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationImQuery", typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationMaxColors", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationMirror", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationMonoHue", typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationOpacity", typing.Dict[builtins.str, typing.Any]]]]] = None,
        region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationRegionOfInterestCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationRelativeCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationRemoveColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationResize", typing.Dict[builtins.str, typing.Any]]]]] = None,
        rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationRotate", typing.Dict[builtins.str, typing.Any]]]]] = None,
        scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationScale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationShear", typing.Dict[builtins.str, typing.Any]]]]] = None,
        trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationTrim", typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationUnsharpMask", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param append: append block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        :param aspect_crop: aspect_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param crop: crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        :param face_crop: face_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        :param feature_crop: feature_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        :param fit_and_fill: fit_and_fill block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param im_query: im_query block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param region_of_interest_crop: region_of_interest_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        :param relative_crop: relative_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param resize: resize block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        :param rotate: rotate block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        :param scale: scale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param shear: shear block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        :param trim: trim block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e0db7b9b27a35c242f0fdfa685168d03747fed630753355c1cc8eb723f668510)
            check_type(argname="argument append", value=append, expected_type=type_hints["append"])
            check_type(argname="argument aspect_crop", value=aspect_crop, expected_type=type_hints["aspect_crop"])
            check_type(argname="argument background_color", value=background_color, expected_type=type_hints["background_color"])
            check_type(argname="argument blur", value=blur, expected_type=type_hints["blur"])
            check_type(argname="argument chroma_key", value=chroma_key, expected_type=type_hints["chroma_key"])
            check_type(argname="argument composite", value=composite, expected_type=type_hints["composite"])
            check_type(argname="argument compound", value=compound, expected_type=type_hints["compound"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument crop", value=crop, expected_type=type_hints["crop"])
            check_type(argname="argument face_crop", value=face_crop, expected_type=type_hints["face_crop"])
            check_type(argname="argument feature_crop", value=feature_crop, expected_type=type_hints["feature_crop"])
            check_type(argname="argument fit_and_fill", value=fit_and_fill, expected_type=type_hints["fit_and_fill"])
            check_type(argname="argument goop", value=goop, expected_type=type_hints["goop"])
            check_type(argname="argument grayscale", value=grayscale, expected_type=type_hints["grayscale"])
            check_type(argname="argument hsl", value=hsl, expected_type=type_hints["hsl"])
            check_type(argname="argument hsv", value=hsv, expected_type=type_hints["hsv"])
            check_type(argname="argument if_dimension", value=if_dimension, expected_type=type_hints["if_dimension"])
            check_type(argname="argument if_orientation", value=if_orientation, expected_type=type_hints["if_orientation"])
            check_type(argname="argument im_query", value=im_query, expected_type=type_hints["im_query"])
            check_type(argname="argument max_colors", value=max_colors, expected_type=type_hints["max_colors"])
            check_type(argname="argument mirror", value=mirror, expected_type=type_hints["mirror"])
            check_type(argname="argument mono_hue", value=mono_hue, expected_type=type_hints["mono_hue"])
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument region_of_interest_crop", value=region_of_interest_crop, expected_type=type_hints["region_of_interest_crop"])
            check_type(argname="argument relative_crop", value=relative_crop, expected_type=type_hints["relative_crop"])
            check_type(argname="argument remove_color", value=remove_color, expected_type=type_hints["remove_color"])
            check_type(argname="argument resize", value=resize, expected_type=type_hints["resize"])
            check_type(argname="argument rotate", value=rotate, expected_type=type_hints["rotate"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument shear", value=shear, expected_type=type_hints["shear"])
            check_type(argname="argument trim", value=trim, expected_type=type_hints["trim"])
            check_type(argname="argument unsharp_mask", value=unsharp_mask, expected_type=type_hints["unsharp_mask"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if append is not None:
            self._values["append"] = append
        if aspect_crop is not None:
            self._values["aspect_crop"] = aspect_crop
        if background_color is not None:
            self._values["background_color"] = background_color
        if blur is not None:
            self._values["blur"] = blur
        if chroma_key is not None:
            self._values["chroma_key"] = chroma_key
        if composite is not None:
            self._values["composite"] = composite
        if compound is not None:
            self._values["compound"] = compound
        if contrast is not None:
            self._values["contrast"] = contrast
        if crop is not None:
            self._values["crop"] = crop
        if face_crop is not None:
            self._values["face_crop"] = face_crop
        if feature_crop is not None:
            self._values["feature_crop"] = feature_crop
        if fit_and_fill is not None:
            self._values["fit_and_fill"] = fit_and_fill
        if goop is not None:
            self._values["goop"] = goop
        if grayscale is not None:
            self._values["grayscale"] = grayscale
        if hsl is not None:
            self._values["hsl"] = hsl
        if hsv is not None:
            self._values["hsv"] = hsv
        if if_dimension is not None:
            self._values["if_dimension"] = if_dimension
        if if_orientation is not None:
            self._values["if_orientation"] = if_orientation
        if im_query is not None:
            self._values["im_query"] = im_query
        if max_colors is not None:
            self._values["max_colors"] = max_colors
        if mirror is not None:
            self._values["mirror"] = mirror
        if mono_hue is not None:
            self._values["mono_hue"] = mono_hue
        if opacity is not None:
            self._values["opacity"] = opacity
        if region_of_interest_crop is not None:
            self._values["region_of_interest_crop"] = region_of_interest_crop
        if relative_crop is not None:
            self._values["relative_crop"] = relative_crop
        if remove_color is not None:
            self._values["remove_color"] = remove_color
        if resize is not None:
            self._values["resize"] = resize
        if rotate is not None:
            self._values["rotate"] = rotate
        if scale is not None:
            self._values["scale"] = scale
        if shear is not None:
            self._values["shear"] = shear
        if trim is not None:
            self._values["trim"] = trim
        if unsharp_mask is not None:
            self._values["unsharp_mask"] = unsharp_mask

    @builtins.property
    def append(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationAppend"]]]:
        '''append block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        '''
        result = self._values.get("append")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationAppend"]]], result)

    @builtins.property
    def aspect_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationAspectCrop"]]]:
        '''aspect_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        '''
        result = self._values.get("aspect_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationAspectCrop"]]], result)

    @builtins.property
    def background_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationBackgroundColor"]]]:
        '''background_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        '''
        result = self._values.get("background_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationBackgroundColor"]]], result)

    @builtins.property
    def blur(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationBlur"]]]:
        '''blur block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        '''
        result = self._values.get("blur")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationBlur"]]], result)

    @builtins.property
    def chroma_key(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationChromaKey"]]]:
        '''chroma_key block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        '''
        result = self._values.get("chroma_key")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationChromaKey"]]], result)

    @builtins.property
    def composite(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationComposite"]]]:
        '''composite block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        '''
        result = self._values.get("composite")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationComposite"]]], result)

    @builtins.property
    def compound(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationCompound"]]]:
        '''compound block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        '''
        result = self._values.get("compound")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationCompound"]]], result)

    @builtins.property
    def contrast(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationContrast"]]]:
        '''contrast block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationContrast"]]], result)

    @builtins.property
    def crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationCrop"]]]:
        '''crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        '''
        result = self._values.get("crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationCrop"]]], result)

    @builtins.property
    def face_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationFaceCrop"]]]:
        '''face_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        '''
        result = self._values.get("face_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationFaceCrop"]]], result)

    @builtins.property
    def feature_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationFeatureCrop"]]]:
        '''feature_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        '''
        result = self._values.get("feature_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationFeatureCrop"]]], result)

    @builtins.property
    def fit_and_fill(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationFitAndFill"]]]:
        '''fit_and_fill block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        '''
        result = self._values.get("fit_and_fill")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationFitAndFill"]]], result)

    @builtins.property
    def goop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationGoop"]]]:
        '''goop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        '''
        result = self._values.get("goop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationGoop"]]], result)

    @builtins.property
    def grayscale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationGrayscale"]]]:
        '''grayscale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        '''
        result = self._values.get("grayscale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationGrayscale"]]], result)

    @builtins.property
    def hsl(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationHsl"]]]:
        '''hsl block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        '''
        result = self._values.get("hsl")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationHsl"]]], result)

    @builtins.property
    def hsv(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationHsv"]]]:
        '''hsv block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        '''
        result = self._values.get("hsv")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationHsv"]]], result)

    @builtins.property
    def if_dimension(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfDimension"]]]:
        '''if_dimension block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        '''
        result = self._values.get("if_dimension")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfDimension"]]], result)

    @builtins.property
    def if_orientation(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfOrientation"]]]:
        '''if_orientation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        '''
        result = self._values.get("if_orientation")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfOrientation"]]], result)

    @builtins.property
    def im_query(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationImQuery"]]]:
        '''im_query block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        '''
        result = self._values.get("im_query")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationImQuery"]]], result)

    @builtins.property
    def max_colors(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationMaxColors"]]]:
        '''max_colors block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        '''
        result = self._values.get("max_colors")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationMaxColors"]]], result)

    @builtins.property
    def mirror(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationMirror"]]]:
        '''mirror block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        '''
        result = self._values.get("mirror")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationMirror"]]], result)

    @builtins.property
    def mono_hue(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationMonoHue"]]]:
        '''mono_hue block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        '''
        result = self._values.get("mono_hue")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationMonoHue"]]], result)

    @builtins.property
    def opacity(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationOpacity"]]]:
        '''opacity block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationOpacity"]]], result)

    @builtins.property
    def region_of_interest_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationRegionOfInterestCrop"]]]:
        '''region_of_interest_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        '''
        result = self._values.get("region_of_interest_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationRegionOfInterestCrop"]]], result)

    @builtins.property
    def relative_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationRelativeCrop"]]]:
        '''relative_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        '''
        result = self._values.get("relative_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationRelativeCrop"]]], result)

    @builtins.property
    def remove_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationRemoveColor"]]]:
        '''remove_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        '''
        result = self._values.get("remove_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationRemoveColor"]]], result)

    @builtins.property
    def resize(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationResize"]]]:
        '''resize block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        '''
        result = self._values.get("resize")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationResize"]]], result)

    @builtins.property
    def rotate(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationRotate"]]]:
        '''rotate block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        '''
        result = self._values.get("rotate")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationRotate"]]], result)

    @builtins.property
    def scale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationScale"]]]:
        '''scale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationScale"]]], result)

    @builtins.property
    def shear(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationShear"]]]:
        '''shear block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        '''
        result = self._values.get("shear")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationShear"]]], result)

    @builtins.property
    def trim(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationTrim"]]]:
        '''trim block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        '''
        result = self._values.get("trim")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationTrim"]]], result)

    @builtins.property
    def unsharp_mask(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationUnsharpMask"]]]:
        '''unsharp_mask block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        result = self._values.get("unsharp_mask")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationUnsharpMask"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationAppend",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_priority": "gravityPriority",
        "gravity_priority_var": "gravityPriorityVar",
        "gravity_var": "gravityVar",
        "preserve_minor_dimension": "preserveMinorDimension",
        "preserve_minor_dimension_var": "preserveMinorDimensionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationAppend:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationAppendImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_priority: typing.Optional[builtins.str] = None,
        gravity_priority_var: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        preserve_minor_dimension: typing.Optional[builtins.str] = None,
        preserve_minor_dimension_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Specifies where to place the ``image`` relative to the source image. The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_priority: Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal. The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority DataAkamaiImagingPolicyImage#gravity_priority}
        :param gravity_priority_var: Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal. The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority_var DataAkamaiImagingPolicyImage#gravity_priority_var}
        :param gravity_var: Specifies where to place the ``image`` relative to the source image. The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param preserve_minor_dimension: Whether to preserve the source image's minor dimension, ``false`` by default. The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension DataAkamaiImagingPolicyImage#preserve_minor_dimension}
        :param preserve_minor_dimension_var: Whether to preserve the source image's minor dimension, ``false`` by default. The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension_var DataAkamaiImagingPolicyImage#preserve_minor_dimension_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationAppendImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7081ba3bbf19adbf55a35c3bcde5d44a863e8bb9b92626c224fc1d8ef8551044)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_priority", value=gravity_priority, expected_type=type_hints["gravity_priority"])
            check_type(argname="argument gravity_priority_var", value=gravity_priority_var, expected_type=type_hints["gravity_priority_var"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument preserve_minor_dimension", value=preserve_minor_dimension, expected_type=type_hints["preserve_minor_dimension"])
            check_type(argname="argument preserve_minor_dimension_var", value=preserve_minor_dimension_var, expected_type=type_hints["preserve_minor_dimension_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_priority is not None:
            self._values["gravity_priority"] = gravity_priority
        if gravity_priority_var is not None:
            self._values["gravity_priority_var"] = gravity_priority_var
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if preserve_minor_dimension is not None:
            self._values["preserve_minor_dimension"] = preserve_minor_dimension
        if preserve_minor_dimension_var is not None:
            self._values["preserve_minor_dimension_var"] = preserve_minor_dimension_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationAppendImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationAppendImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Specifies where to place the ``image`` relative to the source image.

        The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_priority(self) -> typing.Optional[builtins.str]:
        '''Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal.

        The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority DataAkamaiImagingPolicyImage#gravity_priority}
        '''
        result = self._values.get("gravity_priority")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_priority_var(self) -> typing.Optional[builtins.str]:
        '''Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal.

        The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority_var DataAkamaiImagingPolicyImage#gravity_priority_var}
        '''
        result = self._values.get("gravity_priority_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Specifies where to place the ``image`` relative to the source image.

        The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def preserve_minor_dimension(self) -> typing.Optional[builtins.str]:
        '''Whether to preserve the source image's minor dimension, ``false`` by default.

        The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension DataAkamaiImagingPolicyImage#preserve_minor_dimension}
        '''
        result = self._values.get("preserve_minor_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def preserve_minor_dimension_var(self) -> typing.Optional[builtins.str]:
        '''Whether to preserve the source image's minor dimension, ``false`` by default.

        The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension_var DataAkamaiImagingPolicyImage#preserve_minor_dimension_var}
        '''
        result = self._values.get("preserve_minor_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationAppend(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationAppendImage",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationAppendImage:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationAppendImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationAppendImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationAppendImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4026e7f9a0eab990e27f5eec89d79b989848e1d841fb2a85d38ee31e4e26d343)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationAppendImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationAppendImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationAppendImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4b5440d621e6f91a9e1cf9814b780440e1ccad62f622098f91e9f804835072f0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationAppendList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationAppendList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ffbbec117532877fade9545ab2a503734b6504672e405e4a9e7c53ba4678e314)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationAppendOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c3197dc2c9f1cdc0c6c0d34ed194b69dde561572498bc51df94b5d59dffce7db)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationAppendOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__743559d5dd71f4c793d959273551b7821fd348c443ca1deddca770cf465945e6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9fcc15ce64d761a03ec2f400b993df5765cc15bf993e859cfbdaa0a640fc3edc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6b201aed27ca8f54f9cd5ee3b8940bc5e031d43c5d33374b0098ba3e45ead838)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationAppend]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationAppend]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationAppend]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fb3f0f0bb1e2f4f30bd8ccc330e9dbcbb10c73a7931ac88f704a3407a96b6c28)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationAppendOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationAppendOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__00c477c37ffda396709fae307ae52519c374db7425c58ed504ffef55ece5a58f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationAppendImage()

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityPriority")
    def reset_gravity_priority(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityPriority", []))

    @jsii.member(jsii_name="resetGravityPriorityVar")
    def reset_gravity_priority_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityPriorityVar", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPreserveMinorDimension")
    def reset_preserve_minor_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPreserveMinorDimension", []))

    @jsii.member(jsii_name="resetPreserveMinorDimensionVar")
    def reset_preserve_minor_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPreserveMinorDimensionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationAppendImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationAppendImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityInput")
    def gravity_priority_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityPriorityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityVarInput")
    def gravity_priority_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityPriorityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationAppendImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationAppendImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionInput")
    def preserve_minor_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "preserveMinorDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionVarInput")
    def preserve_minor_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "preserveMinorDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be803e159dc331d793faf291aa8637c94b02a4363dfcca72fc9898c60f051ca1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityPriority")
    def gravity_priority(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityPriority"))

    @gravity_priority.setter
    def gravity_priority(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__741c4466166abdacaaf53e67198ae8639c05f31b281927368e98f99a0f41edbc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityPriority", value)

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityVar")
    def gravity_priority_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityPriorityVar"))

    @gravity_priority_var.setter
    def gravity_priority_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0d1a7e2635f436a47960f10873511203d6516e2cbe1e40f2603b0ddbd690a7ee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityPriorityVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f58666bef05c0d04c1707ab35d976cd675f78071c4c43f42023c3174d85eb448)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimension")
    def preserve_minor_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "preserveMinorDimension"))

    @preserve_minor_dimension.setter
    def preserve_minor_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bbf90fd935c7f2b2ca305ed4b0bd05d7dbc9634a399c8b8246c590e4bcb99208)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "preserveMinorDimension", value)

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionVar")
    def preserve_minor_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "preserveMinorDimensionVar"))

    @preserve_minor_dimension_var.setter
    def preserve_minor_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__864b806f5c2e110d351dd79b8595dee134431ddeedee4e8dd87e403ab0b8a650)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "preserveMinorDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationAppend]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationAppend]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationAppend]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__71bdc910c69bdc6bac350ee92d60dae06ef41076cdae0830b05e0711c9039717)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationAspectCrop",
    jsii_struct_bases=[],
    name_mapping={
        "allow_expansion": "allowExpansion",
        "allow_expansion_var": "allowExpansionVar",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationAspectCrop:
    def __init__(
        self,
        *,
        allow_expansion: typing.Optional[builtins.str] = None,
        allow_expansion_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_expansion: Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image. Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        :param allow_expansion_var: Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image. Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        :param height: The height term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The width term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        :param x_position: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__992423aac26c17e3fbd65b6285b5b0a4581774599e3aec9cb28426ecbce211cb)
            check_type(argname="argument allow_expansion", value=allow_expansion, expected_type=type_hints["allow_expansion"])
            check_type(argname="argument allow_expansion_var", value=allow_expansion_var, expected_type=type_hints["allow_expansion_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if allow_expansion is not None:
            self._values["allow_expansion"] = allow_expansion
        if allow_expansion_var is not None:
            self._values["allow_expansion_var"] = allow_expansion_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def allow_expansion(self) -> typing.Optional[builtins.str]:
        '''Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image.

        Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        '''
        result = self._values.get("allow_expansion")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def allow_expansion_var(self) -> typing.Optional[builtins.str]:
        '''Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image.

        Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        '''
        result = self._values.get("allow_expansion_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationAspectCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationAspectCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationAspectCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c4b9eb4e48143ae6c048ea76bb327c31f503686d56cfc1ea3f17b33e1ed1cb47)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationAspectCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__02bc4ecc4574361f4d05045a327231d0edcd0677e38a3934e680614c2b01ee22)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationAspectCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__80a8e939307eec15d8b6cfcde3f2cc1ec9d124024984f6b1024532a7afe5951d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bee992d283f53f5082ce36107dd04dd29a978d70ff39a4b302027b88e3beb996)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f4904371bfdab3a427f5df8e6c2f77eaa8e0010f332897cd7e4ffffeaa85e94)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationAspectCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationAspectCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationAspectCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__539c1acd14b24563fc14ea4506d771b97843a9d5996eed4d2d6fbc8a62f1ca81)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationAspectCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationAspectCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9f86c644b48bdb43c9f949486a5a7218c5e8eae892c2289bdd3f3f342bbf6dcd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAllowExpansion")
    def reset_allow_expansion(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansion", []))

    @jsii.member(jsii_name="resetAllowExpansionVar")
    def reset_allow_expansion_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansionVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionInput")
    def allow_expansion_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVarInput")
    def allow_expansion_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansion")
    def allow_expansion(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansion"))

    @allow_expansion.setter
    def allow_expansion(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__527bd28c880f9e4d5376d0807477494cc719cefc9217f023a75ee8b1a73b57ca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansion", value)

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVar")
    def allow_expansion_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansionVar"))

    @allow_expansion_var.setter
    def allow_expansion_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f7a42fc220e579042f200be41f8e6bb0970f2f4cd076ebdf5ed8c1a6db2d4d1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansionVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__367411f205e5f7dc739d4bb698b43d29dddd893391f2499560f983ad9d973539)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ca302f2d357da5f56e14df20062c2246fdbc58880652405899c294df38367232)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__614f2905640552cfd4dae585eec266d4024c95ca6c583292c3f195c208f3bffd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ce98658da4d2dea8f421a99cd4725b76ab41f085323f6b3710217329fd25a6ff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9e4bb343a830690a890ae2007eff685769e4260057d78a8e1ac89220cd7e5c6f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__967d320141f5c3bde534280f6a1b8fdd6c60ab9db3aba1c76563c3e38548066a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0c813bb7efcd0b18ee7d6535ec4027c326a9095ac51e88e1963593483422c0be)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d66493a2ca9af0f0dd0c125682dc361061be27d00556e17cd463fa8583d6ef21)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationAspectCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationAspectCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationAspectCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__07d00d6740be83f483b9ecffe4de14348f7289b9fac28d56b915395fdef93f84)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationBackgroundColor",
    jsii_struct_bases=[],
    name_mapping={"color": "color", "color_var": "colorVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationBackgroundColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4866b3534a0a3a104e7c4f39a11c380df9ffc71dea03215731436d9b42324a41)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationBackgroundColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationBackgroundColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationBackgroundColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ae806c833cdf2876522492a6ea7486f0c3dce963501e57315f1bbf7844cd6b2a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationBackgroundColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e76fc3f7774e958d37bf607280c53ce07c5270ac112fe817ff0b6ba5fcfd76dc)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationBackgroundColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__81fee86f60751d767d78c99077525def4e19cbfcb3bbb0c8022e78141eee4266)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e90cc62aaf9de8204ca32ccabeb5e860853db7409d35b02af7da1fd957ffaa53)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a7f1b0738d414fe2432cf9fa19ed61203237f06262bcc3d559ff0f584344e37)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationBackgroundColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationBackgroundColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b1c46f8fde04b2f31a05686be649ebc4dc4655128612bfd0c918f592219622b2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationBackgroundColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationBackgroundColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__910a0fa9f3a96016288e10d775a1c0cc3d208e6ba22433c1c0d48da8d5ec32fe)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__163a611149741eee3e3eba74095c0fa2301f8d7beea6012f89e19a77e13fec67)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9357f72361772363d164da989388905e80754e89c4b014032ee9fe610c714877)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationBackgroundColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationBackgroundColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationBackgroundColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0914bffcdd27ff89afb1f66e77edcb65bb4ba14cbafa898dd995c8fed61b1ce8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationBlur",
    jsii_struct_bases=[],
    name_mapping={"sigma": "sigma", "sigma_var": "sigmaVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationBlur:
    def __init__(
        self,
        *,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param sigma: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__42f0d5c3f9f248b83927c6ea587a2cfbf89d153e7219e2f705377225ba2034e3)
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationBlur(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationBlurList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationBlurList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b0aad6104fe571fba25eabd73ae59a65af76dd1fe4ac41a2485c7956d7e4f9b6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationBlurOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__90cf2f98c83c2e715ed59f65f44692a113c5cdfa97c1a64f7998950cfb706cce)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationBlurOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fda96434e3e19dd2aa316af3b3ea7df2102bf4f6681996578000220db0b5ca6c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d56a598b6824b3e3c9dae3bffa71280508321e852574d708cc37d3d7e6d65139)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__683b21351af230106755951f8e89f72472a12821e2768c19163c42144f3a5449)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationBlur]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationBlur]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ca6d76fd346a8ada1d690f198db779dc8ad93f1a29b0cd44ac6f7e29c20ebf7f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationBlurOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationBlurOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__49146d5df2ed96577ca226bdf322fc46be0ce6fe49a22ad3b3e75f429be0f7ff)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__54c05b9f1e0fdcbd5ea792447c14da0872514a6f691ff728f042f04ddd0cfddb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__419cc980b7dc112ed7cfed06229ec574d3844f068bcd66d1529a4675deda61fb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationBlur]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationBlur]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationBlur]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a8a444685b1158e767600a6c0e45a45523bee70441a1a9be9d60a9c72976afc6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationChromaKey",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_feather": "hueFeather",
        "hue_feather_var": "hueFeatherVar",
        "hue_tolerance": "hueTolerance",
        "hue_tolerance_var": "hueToleranceVar",
        "hue_var": "hueVar",
        "lightness_feather": "lightnessFeather",
        "lightness_feather_var": "lightnessFeatherVar",
        "lightness_tolerance": "lightnessTolerance",
        "lightness_tolerance_var": "lightnessToleranceVar",
        "saturation_feather": "saturationFeather",
        "saturation_feather_var": "saturationFeatherVar",
        "saturation_tolerance": "saturationTolerance",
        "saturation_tolerance_var": "saturationToleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationChromaKey:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_feather: typing.Optional[builtins.str] = None,
        hue_feather_var: typing.Optional[builtins.str] = None,
        hue_tolerance: typing.Optional[builtins.str] = None,
        hue_tolerance_var: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness_feather: typing.Optional[builtins.str] = None,
        lightness_feather_var: typing.Optional[builtins.str] = None,
        lightness_tolerance: typing.Optional[builtins.str] = None,
        lightness_tolerance_var: typing.Optional[builtins.str] = None,
        saturation_feather: typing.Optional[builtins.str] = None,
        saturation_feather_var: typing.Optional[builtins.str] = None,
        saturation_tolerance: typing.Optional[builtins.str] = None,
        saturation_tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_feather: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        :param hue_feather_var: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        :param hue_tolerance: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        :param hue_tolerance_var: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        :param hue_var: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness_feather: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        :param lightness_feather_var: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        :param lightness_tolerance: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        :param lightness_tolerance_var: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        :param saturation_feather: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        :param saturation_feather_var: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        :param saturation_tolerance: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        :param saturation_tolerance_var: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d14926da8f9be0f0d4bf96b5981426f5f0b50a601ea652379bfc8d65dd9c686)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_feather", value=hue_feather, expected_type=type_hints["hue_feather"])
            check_type(argname="argument hue_feather_var", value=hue_feather_var, expected_type=type_hints["hue_feather_var"])
            check_type(argname="argument hue_tolerance", value=hue_tolerance, expected_type=type_hints["hue_tolerance"])
            check_type(argname="argument hue_tolerance_var", value=hue_tolerance_var, expected_type=type_hints["hue_tolerance_var"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness_feather", value=lightness_feather, expected_type=type_hints["lightness_feather"])
            check_type(argname="argument lightness_feather_var", value=lightness_feather_var, expected_type=type_hints["lightness_feather_var"])
            check_type(argname="argument lightness_tolerance", value=lightness_tolerance, expected_type=type_hints["lightness_tolerance"])
            check_type(argname="argument lightness_tolerance_var", value=lightness_tolerance_var, expected_type=type_hints["lightness_tolerance_var"])
            check_type(argname="argument saturation_feather", value=saturation_feather, expected_type=type_hints["saturation_feather"])
            check_type(argname="argument saturation_feather_var", value=saturation_feather_var, expected_type=type_hints["saturation_feather_var"])
            check_type(argname="argument saturation_tolerance", value=saturation_tolerance, expected_type=type_hints["saturation_tolerance"])
            check_type(argname="argument saturation_tolerance_var", value=saturation_tolerance_var, expected_type=type_hints["saturation_tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_feather is not None:
            self._values["hue_feather"] = hue_feather
        if hue_feather_var is not None:
            self._values["hue_feather_var"] = hue_feather_var
        if hue_tolerance is not None:
            self._values["hue_tolerance"] = hue_tolerance
        if hue_tolerance_var is not None:
            self._values["hue_tolerance_var"] = hue_tolerance_var
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness_feather is not None:
            self._values["lightness_feather"] = lightness_feather
        if lightness_feather_var is not None:
            self._values["lightness_feather_var"] = lightness_feather_var
        if lightness_tolerance is not None:
            self._values["lightness_tolerance"] = lightness_tolerance
        if lightness_tolerance_var is not None:
            self._values["lightness_tolerance_var"] = lightness_tolerance_var
        if saturation_feather is not None:
            self._values["saturation_feather"] = saturation_feather
        if saturation_feather_var is not None:
            self._values["saturation_feather_var"] = saturation_feather_var
        if saturation_tolerance is not None:
            self._values["saturation_tolerance"] = saturation_tolerance
        if saturation_tolerance_var is not None:
            self._values["saturation_tolerance_var"] = saturation_tolerance_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        '''
        result = self._values.get("hue_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        '''
        result = self._values.get("hue_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        '''
        result = self._values.get("hue_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        '''
        result = self._values.get("hue_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        '''
        result = self._values.get("lightness_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        '''
        result = self._values.get("lightness_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        '''
        result = self._values.get("lightness_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        '''
        result = self._values.get("lightness_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        '''
        result = self._values.get("saturation_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        '''
        result = self._values.get("saturation_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        '''
        result = self._values.get("saturation_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        result = self._values.get("saturation_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationChromaKey(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationChromaKeyList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationChromaKeyList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__289027f41a9af3ba1779e9ea119f03c24a180a029727d992681dedcbac947c7d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationChromaKeyOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__15ccf057d76d0b4a4becc8c956400d80dc9331495a0f18e7fd6d9ba74aa73048)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationChromaKeyOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__58b46e621c9e76a090de2fdad31e5c9a9f9c8924d03fa7a2f3565f4d3d5ae57a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a5d6ec10b63a601b285d79c2d51739eea15e0062624c3cfb0728cf7281f03579)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5941bef0b51e5dcffcfe0b0723fb0fcb73c4e69c9249f4f27ea42afeee68a300)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationChromaKey]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationChromaKey]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c8211af55e65e12bcbb1ad6a9e675424f2cc9b5edb200120bd23c7bc189827a2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationChromaKeyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationChromaKeyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3013121721f1e336b2c8f29021d08017cd5091e693a19d1ffe20e1fb67785e47)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueFeather")
    def reset_hue_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeather", []))

    @jsii.member(jsii_name="resetHueFeatherVar")
    def reset_hue_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeatherVar", []))

    @jsii.member(jsii_name="resetHueTolerance")
    def reset_hue_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueTolerance", []))

    @jsii.member(jsii_name="resetHueToleranceVar")
    def reset_hue_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueToleranceVar", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightnessFeather")
    def reset_lightness_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeather", []))

    @jsii.member(jsii_name="resetLightnessFeatherVar")
    def reset_lightness_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeatherVar", []))

    @jsii.member(jsii_name="resetLightnessTolerance")
    def reset_lightness_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessTolerance", []))

    @jsii.member(jsii_name="resetLightnessToleranceVar")
    def reset_lightness_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessToleranceVar", []))

    @jsii.member(jsii_name="resetSaturationFeather")
    def reset_saturation_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeather", []))

    @jsii.member(jsii_name="resetSaturationFeatherVar")
    def reset_saturation_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeatherVar", []))

    @jsii.member(jsii_name="resetSaturationTolerance")
    def reset_saturation_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationTolerance", []))

    @jsii.member(jsii_name="resetSaturationToleranceVar")
    def reset_saturation_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherInput")
    def hue_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVarInput")
    def hue_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceInput")
    def hue_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVarInput")
    def hue_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherInput")
    def lightness_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVarInput")
    def lightness_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceInput")
    def lightness_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVarInput")
    def lightness_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherInput")
    def saturation_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVarInput")
    def saturation_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceInput")
    def saturation_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVarInput")
    def saturation_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d74ac4d4b5fd200c4cc8fbc50251487fdae4b8d4cbafe977d8782762fb1a48a1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeather")
    def hue_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeather"))

    @hue_feather.setter
    def hue_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d2e6199e31e39a69eecfafb3d5251cbe0bfd80e5147236cb82a1f659921bbb07)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeather", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVar")
    def hue_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeatherVar"))

    @hue_feather_var.setter
    def hue_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__67190850790fffb101a6040b0d691e22118c19802fbf88098c9ffe6ee97f5710)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueTolerance")
    def hue_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueTolerance"))

    @hue_tolerance.setter
    def hue_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__92e43a29c82cbcaf8ba583aa1da77a88606f15a975e9a6c2db9ced92f1c6cc9e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVar")
    def hue_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueToleranceVar"))

    @hue_tolerance_var.setter
    def hue_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7cabd04b2a926ef1ffe84c4afca32ed6d1fe78e045a796480632de6cc5c08bd3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e62c715da73e3e833d60bd5211657a10b246411668d90fc9305b81f8fffe7205)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeather")
    def lightness_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeather"))

    @lightness_feather.setter
    def lightness_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5d216c530cc2d5ba618df46d5a95b2272b7b47e1e8144c517a1d348079040145)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeather", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVar")
    def lightness_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeatherVar"))

    @lightness_feather_var.setter
    def lightness_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dc7d9b1cd5ee4945954420ef2befb40729c6a6de703b06e03760bbe4109f5527)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessTolerance")
    def lightness_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessTolerance"))

    @lightness_tolerance.setter
    def lightness_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dde9361e906023ba8cb2fff3f823e19e04e7172c78bdcb296534fb0c8056d39d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVar")
    def lightness_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessToleranceVar"))

    @lightness_tolerance_var.setter
    def lightness_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__78f9156b4b8baa439355e5cbc9a822f276b52ed92e93e26d941c117797f847c7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeather")
    def saturation_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeather"))

    @saturation_feather.setter
    def saturation_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b63d7038bf2e3e31d1bd4d062bf468dc5146b3ba5926e0012532689ff6ae77ae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeather", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVar")
    def saturation_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeatherVar"))

    @saturation_feather_var.setter
    def saturation_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__240fc43a451811d57d736caa1ce2c72185e5bd10a2d98d7870d9fb86aa5df7af)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationTolerance")
    def saturation_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationTolerance"))

    @saturation_tolerance.setter
    def saturation_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d011fb103635ec4cda3aa3dcdcf590f917afc4021cfa14b397d0ddf650bb30e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVar")
    def saturation_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationToleranceVar"))

    @saturation_tolerance_var.setter
    def saturation_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__86ded3d9a3b5a1ab7ad5ed6a88ef723faa07e0b989bbe5e2450adc976a5d0a09)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationChromaKey]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationChromaKey]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationChromaKey]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e47dc862688a293e88b45a24c06249567a97df39f111cb0a6128ef44702a691d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationComposite",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "placement": "placement",
        "placement_var": "placementVar",
        "scale": "scale",
        "scale_dimension": "scaleDimension",
        "scale_dimension_var": "scaleDimensionVar",
        "scale_var": "scaleVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationComposite:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationCompositeImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        placement: typing.Optional[builtins.str] = None,
        placement_var: typing.Optional[builtins.str] = None,
        scale: typing.Optional[builtins.str] = None,
        scale_dimension: typing.Optional[builtins.str] = None,
        scale_dimension_var: typing.Optional[builtins.str] = None,
        scale_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param placement: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        :param placement_var: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        :param scale: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param scale_dimension: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        :param scale_dimension_var: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        :param scale_var: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        :param x_position: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationCompositeImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f9a1acf1ad238384686ac6ff13f3bcdc46026c63192b10aa8bb82f946c99b719)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument placement", value=placement, expected_type=type_hints["placement"])
            check_type(argname="argument placement_var", value=placement_var, expected_type=type_hints["placement_var"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument scale_dimension", value=scale_dimension, expected_type=type_hints["scale_dimension"])
            check_type(argname="argument scale_dimension_var", value=scale_dimension_var, expected_type=type_hints["scale_dimension_var"])
            check_type(argname="argument scale_var", value=scale_var, expected_type=type_hints["scale_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if placement is not None:
            self._values["placement"] = placement
        if placement_var is not None:
            self._values["placement_var"] = placement_var
        if scale is not None:
            self._values["scale"] = scale
        if scale_dimension is not None:
            self._values["scale_dimension"] = scale_dimension
        if scale_dimension_var is not None:
            self._values["scale_dimension_var"] = scale_dimension_var
        if scale_var is not None:
            self._values["scale_var"] = scale_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationCompositeImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationCompositeImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        '''
        result = self._values.get("placement")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement_var(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        '''
        result = self._values.get("placement_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        '''
        result = self._values.get("scale_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        '''
        result = self._values.get("scale_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        '''
        result = self._values.get("scale_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationComposite(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationCompositeImage",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationCompositeImage:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationCompositeImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationCompositeImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationCompositeImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f05bba057444df9b1643fdf8187499c45703ced38ab12c1558a69c1c54c46413)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationCompositeImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationCompositeImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__13f769cc5b6c49eb4dc3ddc46f3940d9f260729299ebe09276607baf83c1ec75)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationCompositeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationCompositeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8e9ffeda97194abff4e889da9389b15f35fba3dff89b6b7552e16820411caf31)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationCompositeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e9622751b4de91f8bf754a2ff5f977cbd30b8422549d73eb848405f5f326643)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationCompositeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__407de8542918701a901162dc63f7dd4aa0ef45315d7b801242ab8fc1a0c31763)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0a7594c9b032c8cbccd6cd96cd23580896b911117dd450d9e86798dee2061470)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__794d1f04b7c79661eec566e161150d8e9c2c16159b057e62a8ba3e63d07d2ef8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationComposite]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationComposite]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d174606b7dc5418302d66a12735f5e4cc07d7946f22a69bfb0ae558ce74b3b10)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationCompositeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationCompositeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8ae94be9d33daf137f9e992f50a237e6aa4975cf181018d36a1a9162dd16afab)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationCompositeImage()

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPlacement")
    def reset_placement(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacement", []))

    @jsii.member(jsii_name="resetPlacementVar")
    def reset_placement_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacementVar", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetScaleDimension")
    def reset_scale_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimension", []))

    @jsii.member(jsii_name="resetScaleDimensionVar")
    def reset_scale_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimensionVar", []))

    @jsii.member(jsii_name="resetScaleVar")
    def reset_scale_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationCompositeImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationCompositeImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationCompositeImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="placementInput")
    def placement_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementInput"))

    @builtins.property
    @jsii.member(jsii_name="placementVarInput")
    def placement_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionInput")
    def scale_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVarInput")
    def scale_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleVarInput")
    def scale_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d6309352c8491a2aa439fe56234d808cb23a5742fa0aa934d9fb4d3b1af6dee7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3796d0d095932454e5844f230ef1447d1090465587dd8efe9917f2ca8ea0a40c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="placement")
    def placement(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placement"))

    @placement.setter
    def placement(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__532416950ecdfef9cb280102cb65ced11578e776a1f4aff549d72af9be5b7456)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placement", value)

    @builtins.property
    @jsii.member(jsii_name="placementVar")
    def placement_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placementVar"))

    @placement_var.setter
    def placement_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6174a41208273c642d6441228d8a16d2a112c11b91b0e80e0b61c1a2e7f070c5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placementVar", value)

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scale"))

    @scale.setter
    def scale(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a819519969a113453269f7114832f21ef99bbdf60459bba0e1a9cda0fad9d032)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scale", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimension")
    def scale_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimension"))

    @scale_dimension.setter
    def scale_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4db2c0967f82dc58e817ab41659856293d74e53468df2cc3a03ba3f746205acb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimension", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVar")
    def scale_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimensionVar"))

    @scale_dimension_var.setter
    def scale_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5745acf5f5b5fcc71b40e9db0dd941eae40a5cde7b777aad70228bf99988380b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="scaleVar")
    def scale_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleVar"))

    @scale_var.setter
    def scale_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cc16ae30302d0f4c9fee35e5b71bb9c1172b73bf53034325bc96184b2e632232)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5c48dbb34fa91dc1ff5a33eab55e72ef920ea9fd6a6903f974ac12f4a66b0f6f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ed92a7041f478c9a7a22dc74be2aec687e66416018132485bb83d0e855a3e86)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f1eb03762f59d66f9ce3734dbf290c3de338659f74bc9d6c98a1957d0a9f9abf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1b4bd0d294370d16d68382f76839e68466d44ae51620be7bf619e3fb6a4478ed)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationComposite]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationComposite]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationComposite]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cfef355f0c57ea3eb67685d831571de332c030574075c6dd4f12de0dbfd1af07)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationCompound",
    jsii_struct_bases=[],
    name_mapping={"transformations": "transformations"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationCompound:
    def __init__(
        self,
        *,
        transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param transformations: transformations block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8f5033edfd329837005a79875d1b57898c8c7b7e43b2533a01ff77ad7577e049)
            check_type(argname="argument transformations", value=transformations, expected_type=type_hints["transformations"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if transformations is not None:
            self._values["transformations"] = transformations

    @builtins.property
    def transformations(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationCompoundTransformations"]]]:
        '''transformations block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        result = self._values.get("transformations")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationCompoundTransformations"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationCompound(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationCompoundList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationCompoundList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__702b43df36a5fb33c41398813e773be12a34fa33ff8dd4d27f28dbb7e4961d74)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationCompoundOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4bdfca86ba44f0513eef516f14f98f9e6772470764ac6b8c60e399649694295d)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationCompoundOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ffff4868212109fc75dbf574633af4fc060341c3d2071034c0c413ca57de015)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4f42235649cce44942a53345e875e690c6b283c373fc8fc8354270d5740e64c9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__776ed5b5ea3ab1ba2c76795bb4040b2b3ead4b79e273d37ee54e287ee0b71725)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationCompound]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationCompound]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ada21b5fde09ef42171e38297a621389f796280842444fc75ee30e88dfe0a15e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationCompoundOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationCompoundOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1b4b8944f6413f6b73f0fd5bf2dee4341db522f39f7dbcccdbcebe28b17d212f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformations")
    def put_transformations(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3bb05c53e740ccd7f21b31e16ebb163029899fabd7b53e713e2f215d8fc6c931)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTransformations", [value]))

    @jsii.member(jsii_name="resetTransformations")
    def reset_transformations(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformations", []))

    @builtins.property
    @jsii.member(jsii_name="transformations")
    def transformations(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationCompoundTransformationsList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationCompoundTransformationsList", jsii.get(self, "transformations"))

    @builtins.property
    @jsii.member(jsii_name="transformationsInput")
    def transformations_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationCompoundTransformations"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationCompoundTransformations"]]], jsii.get(self, "transformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationCompound]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationCompound]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationCompound]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ebca6b3021e60f5565ef58bbb1d0b69623c1b1bf8e36b3e54b5d06ab0f82cab3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationCompoundTransformations",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationCompoundTransformations:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationCompoundTransformations(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationCompoundTransformationsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationCompoundTransformationsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__788004fde9c44132e6a8365ace685bc823e57eb25499455be46755c1e965343f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationCompoundTransformationsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ff442eaefc7e635111f3f5da14cb8a553e9fed34d24352ac6b0b108a1f270f02)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationCompoundTransformationsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__baf36d737832ef297cd726c20609afe2726cfd39971ea30d49077e3f55edfade)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__53a3c21ea553d6a2d1fcdecec24acc44f8149b5d8424c8b87e4c2f2fdf5cd00a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2376b333f3e6a6e79235a34f2532197cba7c433fb390152b1ee47779421682ba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationCompoundTransformations]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationCompoundTransformations]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationCompoundTransformations]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5476982de6031efe83c987740a6aaf1509c0726376aa2985243c30be166bc048)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationCompoundTransformationsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationCompoundTransformationsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9787ab085430bce82a9a95805fd17a3a046b2aa717d9d7d62bddc5ac475f3f1c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationCompoundTransformations]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationCompoundTransformations]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationCompoundTransformations]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__225c145be395ffc4fcedfbf15a3a1d7d7b54b035a344660382cfc0b79424ca87)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationContrast",
    jsii_struct_bases=[],
    name_mapping={
        "brightness": "brightness",
        "brightness_var": "brightnessVar",
        "contrast": "contrast",
        "contrast_var": "contrastVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationContrast:
    def __init__(
        self,
        *,
        brightness: typing.Optional[builtins.str] = None,
        brightness_var: typing.Optional[builtins.str] = None,
        contrast: typing.Optional[builtins.str] = None,
        contrast_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param brightness: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        :param brightness_var: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        :param contrast: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param contrast_var: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__20736d762eb87e0974c21a473f894b658fe8b0fca5ed3afa51813d6072f57a1c)
            check_type(argname="argument brightness", value=brightness, expected_type=type_hints["brightness"])
            check_type(argname="argument brightness_var", value=brightness_var, expected_type=type_hints["brightness_var"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument contrast_var", value=contrast_var, expected_type=type_hints["contrast_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if brightness is not None:
            self._values["brightness"] = brightness
        if brightness_var is not None:
            self._values["brightness_var"] = brightness_var
        if contrast is not None:
            self._values["contrast"] = contrast
        if contrast_var is not None:
            self._values["contrast_var"] = contrast_var

    @builtins.property
    def brightness(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        '''
        result = self._values.get("brightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def brightness_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        '''
        result = self._values.get("brightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        result = self._values.get("contrast_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationContrast(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationContrastList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationContrastList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ccd3a9cab631f8a7224ce6a120bfc2eb2dc294efd4a26c38d9e394093b071eb4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationContrastOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0a27eec7667cffd9d172c7329f80ded383b43b08743493761b590174fc069e74)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationContrastOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2e390cda25ab14d2e57b4cfa076d340673449790ef1a8328670f280721253d24)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__afa68c894852f9aeb54733731e9c7ab4db58f66f54790ee4830fb228ef808a23)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ac83438f79623d83b8da445283a64a3fb6bc1ec44126e4415789e13231efebb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationContrast]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationContrast]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a0e79d39ee806e51344dd5bff756fd7fcad2e9458890710f99bc0524bacc695)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationContrastOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationContrastOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c15ca523a25567c8cd6e83cc06069ceffdcac02f430ee4b4703876426d421e6e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetBrightness")
    def reset_brightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightness", []))

    @jsii.member(jsii_name="resetBrightnessVar")
    def reset_brightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightnessVar", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetContrastVar")
    def reset_contrast_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrastVar", []))

    @builtins.property
    @jsii.member(jsii_name="brightnessInput")
    def brightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="brightnessVarInput")
    def brightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastVarInput")
    def contrast_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="brightness")
    def brightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightness"))

    @brightness.setter
    def brightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dcaf157f7e1706450623f093b24615868685932cb2570e518978780a6fc5fdef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightness", value)

    @builtins.property
    @jsii.member(jsii_name="brightnessVar")
    def brightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightnessVar"))

    @brightness_var.setter
    def brightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d0d149eeaca8feeceeba10c0b79a67d7faaafa8dde44316c94c1de7329726ec8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrast"))

    @contrast.setter
    def contrast(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e58a8be670c0ef2c481846adc7a616e57f5173e76ea91c2241dd6965b20087f9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrast", value)

    @builtins.property
    @jsii.member(jsii_name="contrastVar")
    def contrast_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrastVar"))

    @contrast_var.setter
    def contrast_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8ce6f2d81861b948efcb5bc44f92a8ce6c72f43ba6a537befb4520014b4c205a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrastVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationContrast]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationContrast]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationContrast]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0248bf9c8193b8c336d64ade05df03f286cbb89bf45bbcc2ac94b2c2a29fb097)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationCrop",
    jsii_struct_bases=[],
    name_mapping={
        "allow_expansion": "allowExpansion",
        "allow_expansion_var": "allowExpansionVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationCrop:
    def __init__(
        self,
        *,
        allow_expansion: typing.Optional[builtins.str] = None,
        allow_expansion_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_expansion: If cropping an area outside of the existing canvas, expands the image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        :param allow_expansion_var: If cropping an area outside of the existing canvas, expands the image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        :param gravity: Frame of reference for X and Y Positions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Frame of reference for X and Y Positions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The number of pixels to crop along the y-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The number of pixels to crop along the y-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The number of pixels to crop along the x-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The number of pixels to crop along the x-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        :param x_position: The x-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__39ca28917964df43ac3204e99d93f7f75af7ac575968c66b0a503337ca0152b5)
            check_type(argname="argument allow_expansion", value=allow_expansion, expected_type=type_hints["allow_expansion"])
            check_type(argname="argument allow_expansion_var", value=allow_expansion_var, expected_type=type_hints["allow_expansion_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if allow_expansion is not None:
            self._values["allow_expansion"] = allow_expansion
        if allow_expansion_var is not None:
            self._values["allow_expansion_var"] = allow_expansion_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def allow_expansion(self) -> typing.Optional[builtins.str]:
        '''If cropping an area outside of the existing canvas, expands the image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        '''
        result = self._values.get("allow_expansion")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def allow_expansion_var(self) -> typing.Optional[builtins.str]:
        '''If cropping an area outside of the existing canvas, expands the image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        '''
        result = self._values.get("allow_expansion_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Frame of reference for X and Y Positions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Frame of reference for X and Y Positions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the y-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the y-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the x-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the x-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__30027e4f41dcfaedc37ad8f4c838aea9074f56d15749e6856255f4636c0ff89d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fe6e2c3f13ae6f0e80e98dff6c0c6a165fc3b8de34a390eadc86c89c7b283430)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__35b1a5a91ba5d7ed9b1074278f1dec616b7284f995906d7093dac1a474b1b352)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0e36a2c4fed98543b33788b4f392b1f8e195bbb7426abfc4cca972310ddab111)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ce95f452002e3006c000352a880a51dced28008b082003ec144972b8de2dc49)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6725dc170bb31dbd6049156d53e872fa5d4f27407188cd52d62662b683924cf3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b8c92f9201c0372afeb3a44bbe2ac84e83f6b5da29454ff423d1acbff372e964)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAllowExpansion")
    def reset_allow_expansion(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansion", []))

    @jsii.member(jsii_name="resetAllowExpansionVar")
    def reset_allow_expansion_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansionVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionInput")
    def allow_expansion_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVarInput")
    def allow_expansion_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansion")
    def allow_expansion(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansion"))

    @allow_expansion.setter
    def allow_expansion(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c56a2e07ca34fe506585e5812a8b4b18082f89aca5a3b9eb8aca8f2924c935af)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansion", value)

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVar")
    def allow_expansion_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansionVar"))

    @allow_expansion_var.setter
    def allow_expansion_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4e1f382d779179fc6612003b262179ec7674fd683c3a05221220f7c6f069e3a5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansionVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4bc728149840162dd54dcaedd1d00e2ef2156ba3aca25effd5bf818509f78ffb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2963abd85b52c819cc8526d5f08cfac85f5f3016796c51076e6b7a9b2c858a14)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4adf50e2ecde2c299b9dc93ce19b5742427e73688f962140c55bfad32779be09)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f8b445300ec4c1e2c2c09e0423ddb49ebd3fb5121a0bc7a7148f360517f56df)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d0ade273ad23a2399400190306e3031141e949e2aacd594c8490265e17103f88)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c20b1326ef6b0168bff1be4d80edebf06788e4c5ec9e01f704aaca30b9bb6c60)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2311b8d18bd4e9ccd7aa37e65877a51a021b6b8ed37925062136743893d88196)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa2d4512db37b7e537735a5a0417b765771d65a7cdbef862c20c7aefe44de9b0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a82d66de07bb07f97e44d4d0efd4d84160ce8df17a29ebd0deeff003baaacce5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c2ce96c6f7ec9c9bbf07f0fc3e430d8d5afb6688053efc8dd38be0cb31cb9d5d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3e6a67986773ceb296d35ebad8947179a887f7c7be93e7f639c2c84826bd4678)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationFaceCrop",
    jsii_struct_bases=[],
    name_mapping={
        "algorithm": "algorithm",
        "algorithm_var": "algorithmVar",
        "confidence": "confidence",
        "confidence_var": "confidenceVar",
        "fail_gravity": "failGravity",
        "fail_gravity_var": "failGravityVar",
        "focus": "focus",
        "focus_var": "focusVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "padding": "padding",
        "padding_var": "paddingVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationFaceCrop:
    def __init__(
        self,
        *,
        algorithm: typing.Optional[builtins.str] = None,
        algorithm_var: typing.Optional[builtins.str] = None,
        confidence: typing.Optional[builtins.str] = None,
        confidence_var: typing.Optional[builtins.str] = None,
        fail_gravity: typing.Optional[builtins.str] = None,
        fail_gravity_var: typing.Optional[builtins.str] = None,
        focus: typing.Optional[builtins.str] = None,
        focus_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param algorithm: Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm DataAkamaiImagingPolicyImage#algorithm}
        :param algorithm_var: Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm_var DataAkamaiImagingPolicyImage#algorithm_var}
        :param confidence: With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image. Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence DataAkamaiImagingPolicyImage#confidence}
        :param confidence_var: With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image. Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence_var DataAkamaiImagingPolicyImage#confidence_var}
        :param fail_gravity: Controls placement of the crop if Image and Video Manager does not detect any faces in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        :param fail_gravity_var: Controls placement of the crop if Image and Video Manager does not detect any faces in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        :param focus: Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus DataAkamaiImagingPolicyImage#focus}
        :param focus_var: Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus_var DataAkamaiImagingPolicyImage#focus_var}
        :param gravity: Controls placement of the crop. Directions are relative to the face(s) plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Controls placement of the crop. Directions are relative to the face(s) plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param padding: The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        :param style: Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aef6b83f633990a6bad0d30ec828d682e376cec7c658feb3e45ac7a7a242c2f1)
            check_type(argname="argument algorithm", value=algorithm, expected_type=type_hints["algorithm"])
            check_type(argname="argument algorithm_var", value=algorithm_var, expected_type=type_hints["algorithm_var"])
            check_type(argname="argument confidence", value=confidence, expected_type=type_hints["confidence"])
            check_type(argname="argument confidence_var", value=confidence_var, expected_type=type_hints["confidence_var"])
            check_type(argname="argument fail_gravity", value=fail_gravity, expected_type=type_hints["fail_gravity"])
            check_type(argname="argument fail_gravity_var", value=fail_gravity_var, expected_type=type_hints["fail_gravity_var"])
            check_type(argname="argument focus", value=focus, expected_type=type_hints["focus"])
            check_type(argname="argument focus_var", value=focus_var, expected_type=type_hints["focus_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if algorithm is not None:
            self._values["algorithm"] = algorithm
        if algorithm_var is not None:
            self._values["algorithm_var"] = algorithm_var
        if confidence is not None:
            self._values["confidence"] = confidence
        if confidence_var is not None:
            self._values["confidence_var"] = confidence_var
        if fail_gravity is not None:
            self._values["fail_gravity"] = fail_gravity
        if fail_gravity_var is not None:
            self._values["fail_gravity_var"] = fail_gravity_var
        if focus is not None:
            self._values["focus"] = focus
        if focus_var is not None:
            self._values["focus_var"] = focus_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def algorithm(self) -> typing.Optional[builtins.str]:
        '''Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm DataAkamaiImagingPolicyImage#algorithm}
        '''
        result = self._values.get("algorithm")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def algorithm_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm_var DataAkamaiImagingPolicyImage#algorithm_var}
        '''
        result = self._values.get("algorithm_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def confidence(self) -> typing.Optional[builtins.str]:
        '''With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image.

        Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence DataAkamaiImagingPolicyImage#confidence}
        '''
        result = self._values.get("confidence")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def confidence_var(self) -> typing.Optional[builtins.str]:
        '''With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image.

        Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence_var DataAkamaiImagingPolicyImage#confidence_var}
        '''
        result = self._values.get("confidence_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any faces in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        '''
        result = self._values.get("fail_gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any faces in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        '''
        result = self._values.get("fail_gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def focus(self) -> typing.Optional[builtins.str]:
        '''Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus DataAkamaiImagingPolicyImage#focus}
        '''
        result = self._values.get("focus")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def focus_var(self) -> typing.Optional[builtins.str]:
        '''Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus_var DataAkamaiImagingPolicyImage#focus_var}
        '''
        result = self._values.get("focus_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the face(s) plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the face(s) plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationFaceCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationFaceCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationFaceCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fe8d96be769c36661f165b661cc46c3b60450999207541418c3ba6e2d3b6a1ec)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationFaceCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a5614a5e5743a79f81d304294789c6357e45037137688423177bb3dbc94c2357)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationFaceCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7f0a061e1057f04b72f41dd436d9730f5ecfc02bfa376df5c889b2259a7eaa2d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea22b51bac1a34b8a15d68cd293938bfa974963cff284f64c9f32e66113e59dd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8e7bbe4417acca8772584daa1a6cc75cc9e957104e3877567db128f355407596)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationFaceCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationFaceCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationFaceCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c00e5fef83e05752804bbc8606e80bafec263ba10847ef93b4aa10dc1a6210f6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationFaceCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationFaceCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3bb5d48879603bd75972b31baadac80a3410d5416a6627cac831f4ce5c3897a9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAlgorithm")
    def reset_algorithm(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAlgorithm", []))

    @jsii.member(jsii_name="resetAlgorithmVar")
    def reset_algorithm_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAlgorithmVar", []))

    @jsii.member(jsii_name="resetConfidence")
    def reset_confidence(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetConfidence", []))

    @jsii.member(jsii_name="resetConfidenceVar")
    def reset_confidence_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetConfidenceVar", []))

    @jsii.member(jsii_name="resetFailGravity")
    def reset_fail_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravity", []))

    @jsii.member(jsii_name="resetFailGravityVar")
    def reset_fail_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravityVar", []))

    @jsii.member(jsii_name="resetFocus")
    def reset_focus(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFocus", []))

    @jsii.member(jsii_name="resetFocusVar")
    def reset_focus_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFocusVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="algorithmInput")
    def algorithm_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "algorithmInput"))

    @builtins.property
    @jsii.member(jsii_name="algorithmVarInput")
    def algorithm_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "algorithmVarInput"))

    @builtins.property
    @jsii.member(jsii_name="confidenceInput")
    def confidence_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "confidenceInput"))

    @builtins.property
    @jsii.member(jsii_name="confidenceVarInput")
    def confidence_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "confidenceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityInput")
    def fail_gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityVarInput")
    def fail_gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="focusInput")
    def focus_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "focusInput"))

    @builtins.property
    @jsii.member(jsii_name="focusVarInput")
    def focus_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "focusVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="algorithm")
    def algorithm(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "algorithm"))

    @algorithm.setter
    def algorithm(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__97b485a53fb47878c135a110582e68be32cf259619e7e54e8b5016a06e67aa5d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "algorithm", value)

    @builtins.property
    @jsii.member(jsii_name="algorithmVar")
    def algorithm_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "algorithmVar"))

    @algorithm_var.setter
    def algorithm_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9cd52268ee719d0c5a3a47764962b522c8af2168bff027e5d52ac515d017de13)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "algorithmVar", value)

    @builtins.property
    @jsii.member(jsii_name="confidence")
    def confidence(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "confidence"))

    @confidence.setter
    def confidence(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6801e3621409e87863d9a13f318af60ee32bcd1f5760ab691df9a33d7cbfcb48)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "confidence", value)

    @builtins.property
    @jsii.member(jsii_name="confidenceVar")
    def confidence_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "confidenceVar"))

    @confidence_var.setter
    def confidence_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ebcc16ac78f10d44498b173524be31644a756358cdd934d5141769e31ef8a840)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "confidenceVar", value)

    @builtins.property
    @jsii.member(jsii_name="failGravity")
    def fail_gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravity"))

    @fail_gravity.setter
    def fail_gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e0f7e6894e5a3fc17adafaea125f60590301dd20cb271c8782992c160f6d615c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravity", value)

    @builtins.property
    @jsii.member(jsii_name="failGravityVar")
    def fail_gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravityVar"))

    @fail_gravity_var.setter
    def fail_gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ba03ac700270387ebfd29bf6000e53ddce04a11d3151a634018b55a628eff53)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="focus")
    def focus(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "focus"))

    @focus.setter
    def focus(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__28365a5e8561505b5b250ecd673e482d91bf17d488e79d64b5ed858a4f49bac0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "focus", value)

    @builtins.property
    @jsii.member(jsii_name="focusVar")
    def focus_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "focusVar"))

    @focus_var.setter
    def focus_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bacaacc7043e8fad48137d8c0e67b658f29cb5150471de3df6d4f496ec7c4524)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "focusVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e7bd7bc3c0d75bbf2eec8fe69501c36e1aeefe763226b51ad629d20246a8198a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__51596bebb9c486db155d1102e6caa3a80172651c250cc3e01fcff22801f98232)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5cf6553f46e18c0355ffa7e91f0f32fcff72aeac91bd7efa4a5fd2c4857aadca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be92fd2972e44e4177f41b2d80fd53f688181b31e471354461ed00997ef3a88b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b556b3c43fd99e351c38df2b01c9a144216f3eaece6f92b8c2bc87cb11296a81)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__370c4134fd7b62f0fdccaf67a9f8288848f8e8a9f44a0d7f14adba6e2b5485f2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__603b1bddfd16063272ccb088e03e95597de9f4f9cffce487ef509c1353668114)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9f152730fc9a7a32924fd36037765c3ed5d2083394ac999e64a434bec3ba97f9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__91a764a797a07bac353b4f6b2b9ca30b565300b394129985034ac88a57e2787a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ddb2ae45634ad1d03846b5eecf9fbc3e3d706773ab0e4a86712be556c4c08a7c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationFaceCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationFaceCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationFaceCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__89c62e34599d997384df3b9fcb9272086c73dadaaea8be63e3684f4f38afe1c7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationFeatureCrop",
    jsii_struct_bases=[],
    name_mapping={
        "fail_gravity": "failGravity",
        "fail_gravity_var": "failGravityVar",
        "feature_radius": "featureRadius",
        "feature_radius_var": "featureRadiusVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "max_features": "maxFeatures",
        "max_features_var": "maxFeaturesVar",
        "min_feature_quality": "minFeatureQuality",
        "min_feature_quality_var": "minFeatureQualityVar",
        "padding": "padding",
        "padding_var": "paddingVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationFeatureCrop:
    def __init__(
        self,
        *,
        fail_gravity: typing.Optional[builtins.str] = None,
        fail_gravity_var: typing.Optional[builtins.str] = None,
        feature_radius: typing.Optional[builtins.str] = None,
        feature_radius_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        max_features: typing.Optional[builtins.str] = None,
        max_features_var: typing.Optional[builtins.str] = None,
        min_feature_quality: typing.Optional[builtins.str] = None,
        min_feature_quality_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fail_gravity: Controls placement of the crop if Image and Video Manager does not detect any features in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        :param fail_gravity_var: Controls placement of the crop if Image and Video Manager does not detect any features in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        :param feature_radius: The size in pixels of the important features to search for. If identified, two features never appear closer together than this value, ``8.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius DataAkamaiImagingPolicyImage#feature_radius}
        :param feature_radius_var: The size in pixels of the important features to search for. If identified, two features never appear closer together than this value, ``8.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius_var DataAkamaiImagingPolicyImage#feature_radius_var}
        :param gravity: Controls placement of the crop. Directions are relative to the region of interest plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Controls placement of the crop. Directions are relative to the region of interest plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param max_features: The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features DataAkamaiImagingPolicyImage#max_features}
        :param max_features_var: The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features_var DataAkamaiImagingPolicyImage#max_features_var}
        :param min_feature_quality: Determines the minimum quality level of the feature identified. To consider a feature important, the feature needs to surpass this value. Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality DataAkamaiImagingPolicyImage#min_feature_quality}
        :param min_feature_quality_var: Determines the minimum quality level of the feature identified. To consider a feature important, the feature needs to surpass this value. Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality_var DataAkamaiImagingPolicyImage#min_feature_quality_var}
        :param padding: Adds space around the region of interest. The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: Adds space around the region of interest. The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        :param style: Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f2422f96fd3ce0c91b4cc21f10054c9371a335231970a6e4868ae6f5bf4099cd)
            check_type(argname="argument fail_gravity", value=fail_gravity, expected_type=type_hints["fail_gravity"])
            check_type(argname="argument fail_gravity_var", value=fail_gravity_var, expected_type=type_hints["fail_gravity_var"])
            check_type(argname="argument feature_radius", value=feature_radius, expected_type=type_hints["feature_radius"])
            check_type(argname="argument feature_radius_var", value=feature_radius_var, expected_type=type_hints["feature_radius_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument max_features", value=max_features, expected_type=type_hints["max_features"])
            check_type(argname="argument max_features_var", value=max_features_var, expected_type=type_hints["max_features_var"])
            check_type(argname="argument min_feature_quality", value=min_feature_quality, expected_type=type_hints["min_feature_quality"])
            check_type(argname="argument min_feature_quality_var", value=min_feature_quality_var, expected_type=type_hints["min_feature_quality_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fail_gravity is not None:
            self._values["fail_gravity"] = fail_gravity
        if fail_gravity_var is not None:
            self._values["fail_gravity_var"] = fail_gravity_var
        if feature_radius is not None:
            self._values["feature_radius"] = feature_radius
        if feature_radius_var is not None:
            self._values["feature_radius_var"] = feature_radius_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if max_features is not None:
            self._values["max_features"] = max_features
        if max_features_var is not None:
            self._values["max_features_var"] = max_features_var
        if min_feature_quality is not None:
            self._values["min_feature_quality"] = min_feature_quality
        if min_feature_quality_var is not None:
            self._values["min_feature_quality_var"] = min_feature_quality_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def fail_gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any features in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        '''
        result = self._values.get("fail_gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any features in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        '''
        result = self._values.get("fail_gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feature_radius(self) -> typing.Optional[builtins.str]:
        '''The size in pixels of the important features to search for.

        If identified, two features never appear closer together than this value, ``8.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius DataAkamaiImagingPolicyImage#feature_radius}
        '''
        result = self._values.get("feature_radius")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feature_radius_var(self) -> typing.Optional[builtins.str]:
        '''The size in pixels of the important features to search for.

        If identified, two features never appear closer together than this value, ``8.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius_var DataAkamaiImagingPolicyImage#feature_radius_var}
        '''
        result = self._values.get("feature_radius_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the region of interest plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the region of interest plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def max_features(self) -> typing.Optional[builtins.str]:
        '''The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features DataAkamaiImagingPolicyImage#max_features}
        '''
        result = self._values.get("max_features")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def max_features_var(self) -> typing.Optional[builtins.str]:
        '''The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features_var DataAkamaiImagingPolicyImage#max_features_var}
        '''
        result = self._values.get("max_features_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def min_feature_quality(self) -> typing.Optional[builtins.str]:
        '''Determines the minimum quality level of the feature identified.

        To consider a feature important, the feature needs to surpass this value.  Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality DataAkamaiImagingPolicyImage#min_feature_quality}
        '''
        result = self._values.get("min_feature_quality")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def min_feature_quality_var(self) -> typing.Optional[builtins.str]:
        '''Determines the minimum quality level of the feature identified.

        To consider a feature important, the feature needs to surpass this value.  Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality_var DataAkamaiImagingPolicyImage#min_feature_quality_var}
        '''
        result = self._values.get("min_feature_quality_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''Adds space around the region of interest.

        The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''Adds space around the region of interest.

        The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationFeatureCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationFeatureCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationFeatureCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7fdb6d54efaf040942ca6959bea1bed3e2f5ed2f18fd0c26805054223758d546)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationFeatureCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a538e1479e73a029906bbd256bb054c7802b1fb97fafa0bc0d3a3ba623ec7e23)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationFeatureCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb7873f2014ab3ea411595a903026715e88ab0bf1a2151d89721f655ef6ffa19)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0346eb933828d3e1d30ff9f1dc9f33011a4b93714fa56438e93c4fe207c04d19)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__261181cfb61f92fdd8e126b4c8b7c0661c868cf0eab6ac36714160a54017b8df)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationFeatureCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationFeatureCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationFeatureCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab66c6a658b6954cc8443cb3471ca580b24490be9eced45dab6ae7d48d5b2603)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationFeatureCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationFeatureCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b733afbdd5c8c7858c6993c821a60a277b2ad23bba60e606cb8960440487028f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetFailGravity")
    def reset_fail_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravity", []))

    @jsii.member(jsii_name="resetFailGravityVar")
    def reset_fail_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravityVar", []))

    @jsii.member(jsii_name="resetFeatureRadius")
    def reset_feature_radius(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureRadius", []))

    @jsii.member(jsii_name="resetFeatureRadiusVar")
    def reset_feature_radius_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureRadiusVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetMaxFeatures")
    def reset_max_features(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxFeatures", []))

    @jsii.member(jsii_name="resetMaxFeaturesVar")
    def reset_max_features_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxFeaturesVar", []))

    @jsii.member(jsii_name="resetMinFeatureQuality")
    def reset_min_feature_quality(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMinFeatureQuality", []))

    @jsii.member(jsii_name="resetMinFeatureQualityVar")
    def reset_min_feature_quality_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMinFeatureQualityVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="failGravityInput")
    def fail_gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityVarInput")
    def fail_gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featureRadiusInput")
    def feature_radius_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featureRadiusInput"))

    @builtins.property
    @jsii.member(jsii_name="featureRadiusVarInput")
    def feature_radius_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featureRadiusVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesInput")
    def max_features_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "maxFeaturesInput"))

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesVarInput")
    def max_features_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "maxFeaturesVarInput"))

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityInput")
    def min_feature_quality_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "minFeatureQualityInput"))

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityVarInput")
    def min_feature_quality_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "minFeatureQualityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravity")
    def fail_gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravity"))

    @fail_gravity.setter
    def fail_gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d75ecdc9c99ef159e35256175370a0e359274d4ee570724b2d7e988a5b72f20)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravity", value)

    @builtins.property
    @jsii.member(jsii_name="failGravityVar")
    def fail_gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravityVar"))

    @fail_gravity_var.setter
    def fail_gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5e6ba3cf2d2102426bdcfc0c48ac8c1e93e1d54150ac4703f35a945c117d69bd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="featureRadius")
    def feature_radius(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featureRadius"))

    @feature_radius.setter
    def feature_radius(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cf65bf9ce6891e2c26752396276f85c69e73dc091e8354dfcd5a52873aa9a1b0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featureRadius", value)

    @builtins.property
    @jsii.member(jsii_name="featureRadiusVar")
    def feature_radius_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featureRadiusVar"))

    @feature_radius_var.setter
    def feature_radius_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__48f809868e88657f5aec8a85be1dccb61564e36ce33a96d56ea172d52b68fad9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featureRadiusVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__93827421f351afa8c094c2917e61b0cf3533ba4416823ae7c2aa9865fbc58ca5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ecefddd39b0772b7a87a7fb87d36c5eaec5621d7f935b0355d458f65ea85ce40)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d133226c1bfa9d8aa4d8c71c70837e5c45e22209bdbad9c61b4adcd7befe79d9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df5c01820a521156cebeb062afed51d2f83fe8509fe019c9be2b211b12534772)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="maxFeatures")
    def max_features(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "maxFeatures"))

    @max_features.setter
    def max_features(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__986705937af7fd041e60e273bb2a0c5c285ce1bf330dc522192a0f6227a2eb63)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "maxFeatures", value)

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesVar")
    def max_features_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "maxFeaturesVar"))

    @max_features_var.setter
    def max_features_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f6a7933df4ca7039ed7c5a84157c983209dbb50e506284a443816c1a3610fa75)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "maxFeaturesVar", value)

    @builtins.property
    @jsii.member(jsii_name="minFeatureQuality")
    def min_feature_quality(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "minFeatureQuality"))

    @min_feature_quality.setter
    def min_feature_quality(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1de0eb8bd0083f129a549857a1abb929118eb94c27f9a20d7827a70dac92e3cb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "minFeatureQuality", value)

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityVar")
    def min_feature_quality_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "minFeatureQualityVar"))

    @min_feature_quality_var.setter
    def min_feature_quality_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7e7711b549e698c0368d2ce95747133838754d7c6d173369ece75a14e9c92905)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "minFeatureQualityVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dce59fab35eaa209482087c63f78074bec0dd2776538bc5bad37075d90e98fd5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6406fbfda271e37afab98528c53cc2bd9b5aa3f5ed8e0f5cd84841191b17f0d4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__85df14ab14e9d9524eb7e5d0cbb97cdc5cb5a3a389cdc2a392c2c30fbefcda47)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__57b9e5ba4535d4ce2207ac7d78aa4a3edb6059dbc6ccd909ffba3b8c0e3b1182)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__368a244b29b4e4c26f85a20cda6aec5c8dad755ffc3e349bbb643431aeeafc98)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a34092495540576663866d1b3a1dea54b509f8c4d8244256477b929715499a7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationFeatureCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationFeatureCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationFeatureCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d7e239f4ecdafdfa7ad744a92834f2740311ab41307a6ec33cf2049987687e2b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationFitAndFill",
    jsii_struct_bases=[],
    name_mapping={
        "fill_transformation": "fillTransformation",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationFitAndFill:
    def __init__(
        self,
        *,
        fill_transformation: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationFitAndFillFillTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fill_transformation: fill_transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_transformation DataAkamaiImagingPolicyImage#fill_transformation}
        :param height: The height value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The width value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(fill_transformation, dict):
            fill_transformation = DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationFitAndFillFillTransformation(**fill_transformation)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a180c21cdcae61598cb1bb8e354bd9347ae6a9e8defc952420b1d641d451c8db)
            check_type(argname="argument fill_transformation", value=fill_transformation, expected_type=type_hints["fill_transformation"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fill_transformation is not None:
            self._values["fill_transformation"] = fill_transformation
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def fill_transformation(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationFitAndFillFillTransformation"]:
        '''fill_transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_transformation DataAkamaiImagingPolicyImage#fill_transformation}
        '''
        result = self._values.get("fill_transformation")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationFitAndFillFillTransformation"], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationFitAndFill(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationFitAndFillFillTransformation",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationFitAndFillFillTransformation:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationFitAndFillFillTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationFitAndFillFillTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationFitAndFillFillTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__590a62d9c27daf80ee1aca44035588c9a59a25aaa634800548750a33a823f05d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationFitAndFillFillTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationFitAndFillFillTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationFitAndFillFillTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9cc6b737d14bbeff0727867188b82459fdb0c2b944aea56e36e894ae00f584a9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationFitAndFillList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationFitAndFillList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__32ba4947bc21dd0e065494007296fd6c80b7581fd423b726e22ec318cbf992db)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationFitAndFillOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__53e1cb92925897e42bd64b3d9eb74fd27c6dcba099c76b2a464ee6fd67dadefc)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationFitAndFillOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0714b5cb97a338cd1f215f23eb503af354253020d210780ad21bff10a4318d96)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d286a422ee9f83a8d97d566baf182bdb78ce1f5e5ad08fff9a3094d53d928da0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__37e60afe0eb20d566adfaf5cd96dbcd0e917f8a41cf1380cb1d2c3f06379e624)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationFitAndFill]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationFitAndFill]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationFitAndFill]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f3a0c90e4bffc788bf372afa4a8d850bd9eb6fd5d0ecfd90a37215fd789cc427)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationFitAndFillOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationFitAndFillOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2912a65edb6b59f068734fe119e789eab140817e16384c07ce016c6bb235baa8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putFillTransformation")
    def put_fill_transformation(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationFitAndFillFillTransformation()

        return typing.cast(None, jsii.invoke(self, "putFillTransformation", [value]))

    @jsii.member(jsii_name="resetFillTransformation")
    def reset_fill_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFillTransformation", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="fillTransformation")
    def fill_transformation(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationFitAndFillFillTransformationOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationFitAndFillFillTransformationOutputReference, jsii.get(self, "fillTransformation"))

    @builtins.property
    @jsii.member(jsii_name="fillTransformationInput")
    def fill_transformation_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationFitAndFillFillTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationFitAndFillFillTransformation], jsii.get(self, "fillTransformationInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a04e0a78d3c6f943a7536a7023f1964450f58b8cd34533abe911ad8aaa316fe4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3c84ce9d7425181c4d3916b7f15547229f43f72b6187168012b769a3e83551b8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7774256410516c63c6ef226d49493a2b08d7db513fbf5ab334fc4790bbccc3ee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c6891910a8345ea873e3a8ad8ce1b399ca41718c4329629fc96a76313044055c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationFitAndFill]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationFitAndFill]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationFitAndFill]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b67cd52a524f56a7baa607aac9a43599aedfe6f0658600daf2c95946c44ffff6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationGoop",
    jsii_struct_bases=[],
    name_mapping={
        "chaos": "chaos",
        "chaos_var": "chaosVar",
        "density": "density",
        "density_var": "densityVar",
        "power": "power",
        "power_var": "powerVar",
        "seed": "seed",
        "seed_var": "seedVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationGoop:
    def __init__(
        self,
        *,
        chaos: typing.Optional[builtins.str] = None,
        chaos_var: typing.Optional[builtins.str] = None,
        density: typing.Optional[builtins.str] = None,
        density_var: typing.Optional[builtins.str] = None,
        power: typing.Optional[builtins.str] = None,
        power_var: typing.Optional[builtins.str] = None,
        seed: typing.Optional[builtins.str] = None,
        seed_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param chaos: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        :param chaos_var: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        :param density: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        :param density_var: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        :param power: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        :param power_var: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        :param seed: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        :param seed_var: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__860b72ef7ec3426320832f5d802e0676c67ddfa70180e3866272231c317d211b)
            check_type(argname="argument chaos", value=chaos, expected_type=type_hints["chaos"])
            check_type(argname="argument chaos_var", value=chaos_var, expected_type=type_hints["chaos_var"])
            check_type(argname="argument density", value=density, expected_type=type_hints["density"])
            check_type(argname="argument density_var", value=density_var, expected_type=type_hints["density_var"])
            check_type(argname="argument power", value=power, expected_type=type_hints["power"])
            check_type(argname="argument power_var", value=power_var, expected_type=type_hints["power_var"])
            check_type(argname="argument seed", value=seed, expected_type=type_hints["seed"])
            check_type(argname="argument seed_var", value=seed_var, expected_type=type_hints["seed_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if chaos is not None:
            self._values["chaos"] = chaos
        if chaos_var is not None:
            self._values["chaos_var"] = chaos_var
        if density is not None:
            self._values["density"] = density
        if density_var is not None:
            self._values["density_var"] = density_var
        if power is not None:
            self._values["power"] = power
        if power_var is not None:
            self._values["power_var"] = power_var
        if seed is not None:
            self._values["seed"] = seed
        if seed_var is not None:
            self._values["seed_var"] = seed_var

    @builtins.property
    def chaos(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        '''
        result = self._values.get("chaos")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def chaos_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        '''
        result = self._values.get("chaos_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        '''
        result = self._values.get("density")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density_var(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        '''
        result = self._values.get("density_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        '''
        result = self._values.get("power")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power_var(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        '''
        result = self._values.get("power_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        '''
        result = self._values.get("seed")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed_var(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        result = self._values.get("seed_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationGoop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationGoopList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationGoopList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f19d2dab6b43dfa7535a6f824d12f7bd69044e35c277cd5409ad50d7c56ed5c2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationGoopOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4d4c014d5ae49bf7aa987a6d973ba3ad8a124f8f319499d1c626a96b54fc3b7e)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationGoopOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__37039975105ccc05fe798941c893636b48d04a957f10e73b2a536a5b8880abee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b7c9ff021fa81a55927942855a685ae682de4059bf9eafcc4d94a4e0c41c8862)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__31a8275e37eaf99bd1c30288309231fb83c797f4347de2e47bc263a073112e41)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationGoop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationGoop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4d27b2a4ea5ba2c0fcca5b2eefa2ed1bc50afec3581c78c3616f906c65b40154)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationGoopOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationGoopOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__003107f77e95ab88b6fb638fab8b4b19879ffcc5f3e6aff1b040ca4636c6e592)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetChaos")
    def reset_chaos(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaos", []))

    @jsii.member(jsii_name="resetChaosVar")
    def reset_chaos_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaosVar", []))

    @jsii.member(jsii_name="resetDensity")
    def reset_density(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensity", []))

    @jsii.member(jsii_name="resetDensityVar")
    def reset_density_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensityVar", []))

    @jsii.member(jsii_name="resetPower")
    def reset_power(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPower", []))

    @jsii.member(jsii_name="resetPowerVar")
    def reset_power_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPowerVar", []))

    @jsii.member(jsii_name="resetSeed")
    def reset_seed(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeed", []))

    @jsii.member(jsii_name="resetSeedVar")
    def reset_seed_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeedVar", []))

    @builtins.property
    @jsii.member(jsii_name="chaosInput")
    def chaos_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosInput"))

    @builtins.property
    @jsii.member(jsii_name="chaosVarInput")
    def chaos_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosVarInput"))

    @builtins.property
    @jsii.member(jsii_name="densityInput")
    def density_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityInput"))

    @builtins.property
    @jsii.member(jsii_name="densityVarInput")
    def density_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="powerInput")
    def power_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerInput"))

    @builtins.property
    @jsii.member(jsii_name="powerVarInput")
    def power_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerVarInput"))

    @builtins.property
    @jsii.member(jsii_name="seedInput")
    def seed_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedInput"))

    @builtins.property
    @jsii.member(jsii_name="seedVarInput")
    def seed_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedVarInput"))

    @builtins.property
    @jsii.member(jsii_name="chaos")
    def chaos(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaos"))

    @chaos.setter
    def chaos(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c7ad044ad6f37b6b0124e8859f6be87f4ae5840c390bcabc4017ee37e90bc39f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaos", value)

    @builtins.property
    @jsii.member(jsii_name="chaosVar")
    def chaos_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaosVar"))

    @chaos_var.setter
    def chaos_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__691c7c2c05a3b26de5b98887c743ea761698f9e0568bb676e7907f5644c2aec6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaosVar", value)

    @builtins.property
    @jsii.member(jsii_name="density")
    def density(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "density"))

    @density.setter
    def density(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__91db3c161990ab208c00f46028c04ebf4723beb086501fd8541c0f47314f3522)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "density", value)

    @builtins.property
    @jsii.member(jsii_name="densityVar")
    def density_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "densityVar"))

    @density_var.setter
    def density_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__069c607bf36369016b99625455c922e8cfabf380add4c27fa51ea27cd0b521dd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "densityVar", value)

    @builtins.property
    @jsii.member(jsii_name="power")
    def power(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "power"))

    @power.setter
    def power(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__acffeb2ecc8958ace6a7eb4fe20cf43e132c50ec415bd5c30bddf7abfc3676ee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "power", value)

    @builtins.property
    @jsii.member(jsii_name="powerVar")
    def power_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "powerVar"))

    @power_var.setter
    def power_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1212fb50883ab7e9656ccfb99574e09d04c27cfbf27f3f656c8f8e70b09c60af)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "powerVar", value)

    @builtins.property
    @jsii.member(jsii_name="seed")
    def seed(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seed"))

    @seed.setter
    def seed(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1fc6d564135b776f2e868b0d90dddcb36acb6db35b18f3ee812d80a576c5fff5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seed", value)

    @builtins.property
    @jsii.member(jsii_name="seedVar")
    def seed_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seedVar"))

    @seed_var.setter
    def seed_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7f7823c45acfdea6d1947236be945ef9778b22fd4ffee759da6245fba320dd8d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seedVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationGoop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationGoop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationGoop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6ee787af850948b9a7b5ec26d9a7e4df36e9428eea7722769c8c0ead3d2adb1c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationGrayscale",
    jsii_struct_bases=[],
    name_mapping={"type": "type", "type_var": "typeVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationGrayscale:
    def __init__(
        self,
        *,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param type: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__52b53d26d3e04477ceea4494cd73178dd762c51cd78d8373293381a4d6fc8d35)
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationGrayscale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationGrayscaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationGrayscaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c5621adb683e96ba9ea213e4d7e30eb62dd255bdcd3ad83039749143406f2ed5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationGrayscaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bbee52abeaf6c0d2799e26b351e571d31bfb689d2cbd23e7df060e9f05190ac8)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationGrayscaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1e835085bdc0231d666d2596b2d29f72be444e703940b540e79f8f18b2d57508)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b62ce495afd7b23301dbf3c62922f61beada217d6681724b282989d06c071540)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6353366c3b86b9b89e9eed88eb3a0ad1a6f9acfd14b6b55142b404fad0fb2da3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationGrayscale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationGrayscale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1b2ad0a925503ed8a1c7a71e293e014a57c2ff86160159ec31f4da363be873ea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationGrayscaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationGrayscaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__93b7f2d02fc27ebb091345402d916dc5df67363f625397f4838d140da94fc2e8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9fadb7b7604968fa4272053c3edb85e46645abd292d685ffe794c62dcb6afad1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__15089987858e1980232cc94f74220ce472325dca6204496ac2e5929506366413)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationGrayscale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationGrayscale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationGrayscale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e49813d8fe5e31702f19fcb3d3d6c0b4e130391a14245244753b8a92cdc57233)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationHsl",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "lightness": "lightness",
        "lightness_var": "lightnessVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationHsl:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness: typing.Optional[builtins.str] = None,
        lightness_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        :param lightness_var: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f21e2aebe3cbc5b35da0ac76c47b2f3b58a213c65ea77e1a8bbca104f182e843)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness", value=lightness, expected_type=type_hints["lightness"])
            check_type(argname="argument lightness_var", value=lightness_var, expected_type=type_hints["lightness_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness is not None:
            self._values["lightness"] = lightness
        if lightness_var is not None:
            self._values["lightness_var"] = lightness_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        '''
        result = self._values.get("lightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        '''
        result = self._values.get("lightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationHsl(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationHslList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationHslList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c0b3d77f7498cfe29543dd2955960621e91eea3af26c0214441d40ab1fcb7324)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationHslOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__24973e99efd8609068827687b5f39eabda5cd69f1bd4cf2d16f32d9dfa5ff592)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationHslOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__54e519ea18ac641ae98f1b89ef060b8973e06cc6bb9094f9a35678dfd60b3877)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9c52e25e87e2c24d1a0ac4371566d0ab457c99e01c0a6bb2c4fe72a9012511e6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0d4a0d180836eeaba1c6c8ddf1f2635b04a8b546971feb102acc7b11fd684a55)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationHsl]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationHsl]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__deb1575d2639f833eb732ecc2bec18daecc85afc3c1cc33fd5e7cd74b5a074c4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationHslOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationHslOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8767ca6487ebedcc562a7e2654d61116d237aa7a6cda62825986ddacb17088d7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightness")
    def reset_lightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightness", []))

    @jsii.member(jsii_name="resetLightnessVar")
    def reset_lightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessInput")
    def lightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessVarInput")
    def lightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a09048e102db1e12813daee1dca0e7ab096818390d0d64c591591d3b7c8b4743)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__986e61ac3d5318664636e97d6b58b0d7f62e586779c2ab5470237eb52b6f0ae2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightness")
    def lightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightness"))

    @lightness.setter
    def lightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__54fb643b6bfda7849f04b6adc3fb140b3916bdddae525a529909e28a14a37719)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightness", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessVar")
    def lightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessVar"))

    @lightness_var.setter
    def lightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bf09b1d082d3d4b9fb0c68190a556f6c406b8cf9148b6fe186d9f463a966b113)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f5c8cedaeeb52209ddf9345562789f4fe26abd4aec7d7123f272e267a25fce5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6509ff4a7f815cd99a7e01e4f8089686b80f481447c5aa5e20cef6791542b2d2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationHsl]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationHsl]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationHsl]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7839119e5701bbc49b8c53cfb45e755a1fcdba49dd83f66336e1d3c8bc2fc860)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationHsv",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationHsv:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        :param value: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fffc04f70ce63c79dba78edb78993739fd58850152c60657636f435a2513e2ae)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationHsv(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationHsvList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationHsvList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dcc63ea03b86ed6f92bf16790d467718f554e056e9c61b3c167c61a27e4d69f1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationHsvOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ccf2aa4a5e2861d6f7b63ca1e85669da643392cad6986a170f739c8d8105f36d)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationHsvOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__89287407ceeb4da99a994ec172c7889989af14ee9102f524662b7b6a7f5385e0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ec1fb7adda63f46bbaef91128ba3f4a504c008af1bf483a85fcdbc981c00b85b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a728c1d6e0ce76f3c9bd1e04f68f1e511281f466f64d3a9f4a99c9a28ba0508)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationHsv]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationHsv]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5797ecbda7574329d27a6ecc368bbbf220e773deba2badd9fe514109b761acdb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationHsvOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationHsvOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__406d083174de4427a17dac1b5525484d7119006868e88d9265c45606683542d2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__54dcf44da095a36e2cd3b2946601edc1caa69f05c5ba364830acd5151d8d43c0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b18d7c7acd0886699738a807f1a1bd31efed6f16380062d2d26fa06fe1d147d8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__61ed7bfce61832f6efe1703f8be7453eba48b8c4f99e319311c6e5a952fbc7e9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c86928d4828bb3d0dbfb12f06a91a5aacef872eb042fcf13983a3b2b51cf8aff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__44398840065e9054e27a258e4ee8df404818a7fc0683c377edcbc840ca77960c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d2dff4caf634021e6247a9b5efd45c7c1eee8c00d902c1e29525eff896c601ae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationHsv]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationHsv]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationHsv]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__01ac3f7059d8c201b12b3fdd287edcd6140e8691a9efb424ee110247c3f2126c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfDimension",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "dimension": "dimension",
        "dimension_var": "dimensionVar",
        "equal": "equal",
        "greater_than": "greaterThan",
        "less_than": "lessThan",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfDimension:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfDimensionDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        dimension: typing.Optional[builtins.str] = None,
        dimension_var: typing.Optional[builtins.str] = None,
        equal: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfDimensionEqual", typing.Dict[builtins.str, typing.Any]]] = None,
        greater_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfDimensionGreaterThan", typing.Dict[builtins.str, typing.Any]]] = None,
        less_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfDimensionLessThan", typing.Dict[builtins.str, typing.Any]]] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param dimension: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        :param dimension_var: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        :param equal: equal block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        :param greater_than: greater_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        :param less_than: less_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        :param value: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfDimensionDefault(**default)
        if isinstance(equal, dict):
            equal = DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfDimensionEqual(**equal)
        if isinstance(greater_than, dict):
            greater_than = DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfDimensionGreaterThan(**greater_than)
        if isinstance(less_than, dict):
            less_than = DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfDimensionLessThan(**less_than)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d1a83d117919a70f80eb25960adf652b7783e27d8ce2d61fe0bbd20a078a9733)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument dimension", value=dimension, expected_type=type_hints["dimension"])
            check_type(argname="argument dimension_var", value=dimension_var, expected_type=type_hints["dimension_var"])
            check_type(argname="argument equal", value=equal, expected_type=type_hints["equal"])
            check_type(argname="argument greater_than", value=greater_than, expected_type=type_hints["greater_than"])
            check_type(argname="argument less_than", value=less_than, expected_type=type_hints["less_than"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if dimension is not None:
            self._values["dimension"] = dimension
        if dimension_var is not None:
            self._values["dimension_var"] = dimension_var
        if equal is not None:
            self._values["equal"] = equal
        if greater_than is not None:
            self._values["greater_than"] = greater_than
        if less_than is not None:
            self._values["less_than"] = less_than
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfDimensionDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfDimensionDefault"], result)

    @builtins.property
    def dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        '''
        result = self._values.get("dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        '''
        result = self._values.get("dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def equal(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfDimensionEqual"]:
        '''equal block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        '''
        result = self._values.get("equal")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfDimensionEqual"], result)

    @builtins.property
    def greater_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfDimensionGreaterThan"]:
        '''greater_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        '''
        result = self._values.get("greater_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfDimensionGreaterThan"], result)

    @builtins.property
    def less_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfDimensionLessThan"]:
        '''less_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        '''
        result = self._values.get("less_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfDimensionLessThan"], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfDimension(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfDimensionDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfDimensionDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfDimensionDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfDimensionDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfDimensionDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f9c9c3cb3dfba4dc34d68b3c5cfa27bcb324bdd44f0683596bfad1dfa3644c7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfDimensionDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfDimensionDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea32f5bdc6873e18622ea73efc65c9a9088116bd1c8c044e9e3b8f831c23c44d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfDimensionEqual",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfDimensionEqual:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfDimensionEqual(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfDimensionEqualOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfDimensionEqualOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__12529aea5b0ce5a62dc4f7cb03b7292d455330eae8b0550343478cc030b2f281)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfDimensionEqual], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfDimensionEqual],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__24bb689823e42283c95f20c618f8de860c67942827a89061dcbb8dd61a8ba8b6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfDimensionGreaterThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfDimensionGreaterThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfDimensionGreaterThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfDimensionGreaterThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfDimensionGreaterThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3f9a64672f13ba4b5501ca0a15bac297bb2bc4ffed41c226eaa363e290ede495)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfDimensionGreaterThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfDimensionGreaterThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f2cd5f74b862ad2966e5ed271178cb4b70128f72518c4d0578dcb8c3fda7283)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfDimensionLessThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfDimensionLessThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfDimensionLessThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfDimensionLessThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfDimensionLessThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__85866914a640635716b2ed56fbccbcd831b2b3dda81677e42187ba6654d1582e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfDimensionLessThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfDimensionLessThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__60b8304908c3db4c015d8be4539aaa8665bb6eb82cef85374f0afd4abca39f41)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfDimensionList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfDimensionList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e7b0884a41870b9ea0272ca04ff0859f128dd7a210e7ea4c1ca5db5a160bfddc)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfDimensionOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2af2b240d95e9c25587811695fc37717274d997dc436c58fa20e46407894292c)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfDimensionOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7345a3ceabdb1ed1ef00ea82143e77ff713bd3a96a8d6035d7011a975192c79f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__db7d05de827eab352b6064fc6d888651f70a7c5c6c715e0435eba408a1abf279)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8d7341fb603fb2126b4de3e03abf2e94eb31730e380108e834913850345089c2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfDimension]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfDimension]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__904efa3e3e7da235fec8e94fd6ebd65c7481cc70338ca2399a6bb6becfab7563)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfDimensionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfDimensionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__920dcbf84e266109c13e14876789a84e667a2b273f34cd093fa6817f2c679512)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfDimensionDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putEqual")
    def put_equal(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfDimensionEqual()

        return typing.cast(None, jsii.invoke(self, "putEqual", [value]))

    @jsii.member(jsii_name="putGreaterThan")
    def put_greater_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfDimensionGreaterThan()

        return typing.cast(None, jsii.invoke(self, "putGreaterThan", [value]))

    @jsii.member(jsii_name="putLessThan")
    def put_less_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfDimensionLessThan()

        return typing.cast(None, jsii.invoke(self, "putLessThan", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetDimension")
    def reset_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimension", []))

    @jsii.member(jsii_name="resetDimensionVar")
    def reset_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimensionVar", []))

    @jsii.member(jsii_name="resetEqual")
    def reset_equal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEqual", []))

    @jsii.member(jsii_name="resetGreaterThan")
    def reset_greater_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGreaterThan", []))

    @jsii.member(jsii_name="resetLessThan")
    def reset_less_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLessThan", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfDimensionDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfDimensionDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="equal")
    def equal(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfDimensionEqualOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfDimensionEqualOutputReference, jsii.get(self, "equal"))

    @builtins.property
    @jsii.member(jsii_name="greaterThan")
    def greater_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfDimensionGreaterThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfDimensionGreaterThanOutputReference, jsii.get(self, "greaterThan"))

    @builtins.property
    @jsii.member(jsii_name="lessThan")
    def less_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfDimensionLessThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfDimensionLessThanOutputReference, jsii.get(self, "lessThan"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfDimensionDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionInput")
    def dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionVarInput")
    def dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="equalInput")
    def equal_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfDimensionEqual], jsii.get(self, "equalInput"))

    @builtins.property
    @jsii.member(jsii_name="greaterThanInput")
    def greater_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfDimensionGreaterThan], jsii.get(self, "greaterThanInput"))

    @builtins.property
    @jsii.member(jsii_name="lessThanInput")
    def less_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfDimensionLessThan], jsii.get(self, "lessThanInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="dimension")
    def dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimension"))

    @dimension.setter
    def dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ebae62761ec15aaabcee3d963ae2e73ac74663f20f7740f8698511e70122a694)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimension", value)

    @builtins.property
    @jsii.member(jsii_name="dimensionVar")
    def dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimensionVar"))

    @dimension_var.setter
    def dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d7f84d17c5c1bee3961c3f4595a7c57c4ba1f4e2781b31e7d00aae10a19c3f80)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1775a207fed906738852f8ac516eeb20075e51dc21ec52e69dc4e0b7c9ec2df2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd4032dd954200872738712ad7d5db5dc106ebd91ac6634f4af79673eab0044a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfDimension]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfDimension]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfDimension]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0e672249a0703f81d823cc6fbe5349d7cf855b90febfc594eb99613ec7ebac2d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfOrientation",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "landscape": "landscape",
        "portrait": "portrait",
        "square": "square",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfOrientation:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfOrientationDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        landscape: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfOrientationLandscape", typing.Dict[builtins.str, typing.Any]]] = None,
        portrait: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfOrientationPortrait", typing.Dict[builtins.str, typing.Any]]] = None,
        square: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfOrientationSquare", typing.Dict[builtins.str, typing.Any]]] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param landscape: landscape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        :param portrait: portrait block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        :param square: square block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfOrientationDefault(**default)
        if isinstance(landscape, dict):
            landscape = DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfOrientationLandscape(**landscape)
        if isinstance(portrait, dict):
            portrait = DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfOrientationPortrait(**portrait)
        if isinstance(square, dict):
            square = DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfOrientationSquare(**square)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1c80f798443ea6e5628564df229f27aad0d832fb56fca4f02b461d65953c8cb9)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument landscape", value=landscape, expected_type=type_hints["landscape"])
            check_type(argname="argument portrait", value=portrait, expected_type=type_hints["portrait"])
            check_type(argname="argument square", value=square, expected_type=type_hints["square"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if landscape is not None:
            self._values["landscape"] = landscape
        if portrait is not None:
            self._values["portrait"] = portrait
        if square is not None:
            self._values["square"] = square

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfOrientationDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfOrientationDefault"], result)

    @builtins.property
    def landscape(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfOrientationLandscape"]:
        '''landscape block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        '''
        result = self._values.get("landscape")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfOrientationLandscape"], result)

    @builtins.property
    def portrait(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfOrientationPortrait"]:
        '''portrait block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        '''
        result = self._values.get("portrait")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfOrientationPortrait"], result)

    @builtins.property
    def square(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfOrientationSquare"]:
        '''square block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        result = self._values.get("square")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfOrientationSquare"], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfOrientation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfOrientationDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfOrientationDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfOrientationDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfOrientationDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfOrientationDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__db10a28dedd92af85b6c29f3320568745fbb64f7de67b1a3eaec09b4e6a5e28f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfOrientationDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfOrientationDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ff119e11eac1d45554feda2317b1c8e9de55fd5d3a202130ff91d6dead8b5d0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfOrientationLandscape",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfOrientationLandscape:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfOrientationLandscape(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfOrientationLandscapeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfOrientationLandscapeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a8cf1e8e9cdae331bd32999cb95b1dde82a07ce61543bdb102758b405853316a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfOrientationLandscape], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfOrientationLandscape],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2bbbb9c0a4ffe6bb7485f2a0bebc40d3fc9e3d7616d0b7721d3039b85b5a72b3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfOrientationList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfOrientationList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac47c039b35c1b72a6be8a5a43e84daeacd3299a181813f88a60ba7b128cd3f3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfOrientationOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__08c55f060c15771a040ed4450c76d2e5ff3034dea8a9bbcddca9401346840ba2)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfOrientationOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2229b0c63de840e5b3c576a6a3d506b763ea3ba9c1198cbdbdaeceaab3dc6d15)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__82e90c86dac41f6d55d9e81168afa3af225566d4c6128fced6ca0fab4dff0277)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7b420b2bd17c13dc2a37c2c81ecd86066ddf62675b886649e0b45e13a25fb936)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfOrientation]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfOrientation]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a2ea377bdb7062dfc6d48adb2d877544732732af2419db9eae41fe2c0a713363)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfOrientationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfOrientationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f56b00d84d5fb7d33a5c50998db6e71070626103d8db69c6b55514c1dc1ceef)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfOrientationDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putLandscape")
    def put_landscape(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfOrientationLandscape()

        return typing.cast(None, jsii.invoke(self, "putLandscape", [value]))

    @jsii.member(jsii_name="putPortrait")
    def put_portrait(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfOrientationPortrait()

        return typing.cast(None, jsii.invoke(self, "putPortrait", [value]))

    @jsii.member(jsii_name="putSquare")
    def put_square(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfOrientationSquare()

        return typing.cast(None, jsii.invoke(self, "putSquare", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetLandscape")
    def reset_landscape(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLandscape", []))

    @jsii.member(jsii_name="resetPortrait")
    def reset_portrait(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPortrait", []))

    @jsii.member(jsii_name="resetSquare")
    def reset_square(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSquare", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfOrientationDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfOrientationDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="landscape")
    def landscape(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfOrientationLandscapeOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfOrientationLandscapeOutputReference, jsii.get(self, "landscape"))

    @builtins.property
    @jsii.member(jsii_name="portrait")
    def portrait(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfOrientationPortraitOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfOrientationPortraitOutputReference", jsii.get(self, "portrait"))

    @builtins.property
    @jsii.member(jsii_name="square")
    def square(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfOrientationSquareOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfOrientationSquareOutputReference", jsii.get(self, "square"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfOrientationDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="landscapeInput")
    def landscape_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfOrientationLandscape], jsii.get(self, "landscapeInput"))

    @builtins.property
    @jsii.member(jsii_name="portraitInput")
    def portrait_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfOrientationPortrait"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfOrientationPortrait"], jsii.get(self, "portraitInput"))

    @builtins.property
    @jsii.member(jsii_name="squareInput")
    def square_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfOrientationSquare"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfOrientationSquare"], jsii.get(self, "squareInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfOrientation]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfOrientation]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfOrientation]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6ddd4cfc0f28549caaf44b0ef193374728966c90ce9c3e656bc58db5dc35b462)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfOrientationPortrait",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfOrientationPortrait:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfOrientationPortrait(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfOrientationPortraitOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfOrientationPortraitOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4b71a38211f43b452c6c7c689cc807542fc81488d3d1505f7c0fb4ecabe981df)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfOrientationPortrait]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfOrientationPortrait], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfOrientationPortrait],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__34b3c6ab1ebdb7a658d9b270043c723c27da44eee7c59880c7b0859bf379659b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfOrientationSquare",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfOrientationSquare:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfOrientationSquare(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfOrientationSquareOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfOrientationSquareOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e9e22bd82101ba6365005647488e49935ce5ebd1d8e0463082986aca9f7a071b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfOrientationSquare]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfOrientationSquare], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfOrientationSquare],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__26b92fa4b840e776ef1a29077a1e57679da2de628f2bb4c2855ac60f3ff69653)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationImQuery",
    jsii_struct_bases=[],
    name_mapping={
        "allowed_transformations": "allowedTransformations",
        "query_var": "queryVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationImQuery:
    def __init__(
        self,
        *,
        allowed_transformations: typing.Sequence[builtins.str],
        query_var: builtins.str,
    ) -> None:
        '''
        :param allowed_transformations: Specifies the transformations that can be applied using the query string parameter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allowed_transformations DataAkamaiImagingPolicyImage#allowed_transformations}
        :param query_var: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#query_var DataAkamaiImagingPolicyImage#query_var}.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0690383a03f9c3f2e5a4a7245d150fff336871f047b349be16a05bc5b5aa6265)
            check_type(argname="argument allowed_transformations", value=allowed_transformations, expected_type=type_hints["allowed_transformations"])
            check_type(argname="argument query_var", value=query_var, expected_type=type_hints["query_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "allowed_transformations": allowed_transformations,
            "query_var": query_var,
        }

    @builtins.property
    def allowed_transformations(self) -> typing.List[builtins.str]:
        '''Specifies the transformations that can be applied using the query string parameter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allowed_transformations DataAkamaiImagingPolicyImage#allowed_transformations}
        '''
        result = self._values.get("allowed_transformations")
        assert result is not None, "Required property 'allowed_transformations' is missing"
        return typing.cast(typing.List[builtins.str], result)

    @builtins.property
    def query_var(self) -> builtins.str:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#query_var DataAkamaiImagingPolicyImage#query_var}.'''
        result = self._values.get("query_var")
        assert result is not None, "Required property 'query_var' is missing"
        return typing.cast(builtins.str, result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationImQuery(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationImQueryList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationImQueryList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e903d2dd92242b75150bd1b543ae2f5d5fb43f1c1c66f9457f6bcf9cd9e1ea2a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationImQueryOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bfa407256ae0a047140b69f1e8216b3074c970380d11ca03d6abf9e5db1ad431)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationImQueryOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__586614a695f80c2ebf4def2f5b46c346e719cc37b5e1f6fb5d1db04c44950fa2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ba75b40bc97e6ce2d1b458885ce0eac7527356d08af56e68d9c3ea8cb5125f6e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__438cccb625da945dae1352833c8017e85cb528ef7535e2a79e069cebf81d0ee4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationImQuery]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationImQuery]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationImQuery]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e55f29fbfffefd25aa3c2b92e0152903da84e4e89658cbf7408e50f24183b459)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationImQueryOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationImQueryOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aa37dfde7085245436792d2242ef85d633bc905aacee062796337b01af175aab)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @builtins.property
    @jsii.member(jsii_name="allowedTransformationsInput")
    def allowed_transformations_input(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "allowedTransformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="queryVarInput")
    def query_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "queryVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowedTransformations")
    def allowed_transformations(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "allowedTransformations"))

    @allowed_transformations.setter
    def allowed_transformations(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__78133597e687c4eee690f9aa140ca58aaebe0adc525c57e599d2d7c93410f21b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowedTransformations", value)

    @builtins.property
    @jsii.member(jsii_name="queryVar")
    def query_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "queryVar"))

    @query_var.setter
    def query_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7c1f83218409fef96490a9fad2e77c535739caf6994b7acd41c840d3bfbf305c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "queryVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationImQuery]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationImQuery]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationImQuery]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__52d3b42cf77540c150ec5479ae5216fe2e2955f53ccb29edfcf820304ce29ad2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationMaxColors",
    jsii_struct_bases=[],
    name_mapping={"colors": "colors", "colors_var": "colorsVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationMaxColors:
    def __init__(
        self,
        *,
        colors: typing.Optional[builtins.str] = None,
        colors_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param colors: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        :param colors_var: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__02e5970369494df7c9767a0c61e4cdcbeaee7ad77d47a45ed8c12e17f5ed6393)
            check_type(argname="argument colors", value=colors, expected_type=type_hints["colors"])
            check_type(argname="argument colors_var", value=colors_var, expected_type=type_hints["colors_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if colors is not None:
            self._values["colors"] = colors
        if colors_var is not None:
            self._values["colors_var"] = colors_var

    @builtins.property
    def colors(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        '''
        result = self._values.get("colors")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def colors_var(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        result = self._values.get("colors_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationMaxColors(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationMaxColorsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationMaxColorsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__67a170be55dbb7e5b93753e7683fbcbb0667e14e02832e08fbfb3805d7d53a75)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationMaxColorsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__82744589302b55d032f7fd76eaf43b76da1d4cd79a657e5180e5e0b7a67d0c63)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationMaxColorsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c23b7f5849b2e0323e39c30b171c3deccd171d6a04e9c654007a8c1d70322739)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__482a0e907c131f863a2a8710d08443cb59537d9d9c0f372da9f6bdab09b44752)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6551743e57e8a894dfaec4ec9bbc63efd8397b5f0ae62c813d2c546bb309e5a0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationMaxColors]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationMaxColors]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__007a4725f5b6d0d00d9a4d2fa16cf6ff64dd65d53aef0c899a2997748ad8ca11)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationMaxColorsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationMaxColorsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__01831af3a427958d4ca1114b125b4db376758f27ce705f822e07b20ea1851f51)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColors")
    def reset_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColors", []))

    @jsii.member(jsii_name="resetColorsVar")
    def reset_colors_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorsVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorsInput")
    def colors_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsInput"))

    @builtins.property
    @jsii.member(jsii_name="colorsVarInput")
    def colors_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsVarInput"))

    @builtins.property
    @jsii.member(jsii_name="colors")
    def colors(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colors"))

    @colors.setter
    def colors(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f25e401732db2f996d1a69ea6d36cd15d41fa86cc9ccb998ced82d92ca5037c2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colors", value)

    @builtins.property
    @jsii.member(jsii_name="colorsVar")
    def colors_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorsVar"))

    @colors_var.setter
    def colors_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__24640630db692fcd3a48001c0ac0193234aae569edf330febd3df80d6153aa70)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorsVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationMaxColors]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationMaxColors]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationMaxColors]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4eb425d2f27c79f86a88872b4a6936c22e31e19c2231bf1053fcc9dd5e8fb89b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationMirror",
    jsii_struct_bases=[],
    name_mapping={
        "horizontal": "horizontal",
        "horizontal_var": "horizontalVar",
        "vertical": "vertical",
        "vertical_var": "verticalVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationMirror:
    def __init__(
        self,
        *,
        horizontal: typing.Optional[builtins.str] = None,
        horizontal_var: typing.Optional[builtins.str] = None,
        vertical: typing.Optional[builtins.str] = None,
        vertical_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param horizontal: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        :param horizontal_var: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        :param vertical: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        :param vertical_var: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ac51ed2c65bc5b835caafa9df447428b6474277fd483b0c8243ab7a4f7b3d0f)
            check_type(argname="argument horizontal", value=horizontal, expected_type=type_hints["horizontal"])
            check_type(argname="argument horizontal_var", value=horizontal_var, expected_type=type_hints["horizontal_var"])
            check_type(argname="argument vertical", value=vertical, expected_type=type_hints["vertical"])
            check_type(argname="argument vertical_var", value=vertical_var, expected_type=type_hints["vertical_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if horizontal is not None:
            self._values["horizontal"] = horizontal
        if horizontal_var is not None:
            self._values["horizontal_var"] = horizontal_var
        if vertical is not None:
            self._values["vertical"] = vertical
        if vertical_var is not None:
            self._values["vertical_var"] = vertical_var

    @builtins.property
    def horizontal(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        '''
        result = self._values.get("horizontal")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def horizontal_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        '''
        result = self._values.get("horizontal_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        '''
        result = self._values.get("vertical")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        result = self._values.get("vertical_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationMirror(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationMirrorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationMirrorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0d0cb85fd93b8fc814ff04dad2f1bc5e60e17185f54d5ef5f65ad52f59f98324)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationMirrorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a325f3607f446ade30ae351638fa51b53f76d78eb64a7fc9d59c0f5dce14f4ae)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationMirrorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5d954b9083b7c99f1ad97c43564760ec27ccdf58095b298879b9065e587870b0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1defa7825868b681b4299d57fbc5c5931e6319e0687a499ee1da5a8d498f148f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__08f9fcbe9ab3bf5ddb6297cce2ac118f2522a65088b16c05ad4f68abdb6c1eef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationMirror]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationMirror]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f8505e0c02cf3c21b4c52d79629192e9df5456104f3c995b788531ceb21083d0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationMirrorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationMirrorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__48f55c357f66404c53302eae6652fc169ad6c862910b6ac71e24c2e9ac180012)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHorizontal")
    def reset_horizontal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontal", []))

    @jsii.member(jsii_name="resetHorizontalVar")
    def reset_horizontal_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontalVar", []))

    @jsii.member(jsii_name="resetVertical")
    def reset_vertical(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVertical", []))

    @jsii.member(jsii_name="resetVerticalVar")
    def reset_vertical_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVerticalVar", []))

    @builtins.property
    @jsii.member(jsii_name="horizontalInput")
    def horizontal_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontalVarInput")
    def horizontal_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalInput")
    def vertical_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalVarInput")
    def vertical_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontal")
    def horizontal(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontal"))

    @horizontal.setter
    def horizontal(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c495c560c0e11d204e0ec370b43e3f23b604297193bdb9f283db83eae08a7bf7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontal", value)

    @builtins.property
    @jsii.member(jsii_name="horizontalVar")
    def horizontal_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontalVar"))

    @horizontal_var.setter
    def horizontal_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c5321f21ec818073f8e2762d0d0ec0d4619d6ffdbb56af22926a36dc3c36d146)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontalVar", value)

    @builtins.property
    @jsii.member(jsii_name="vertical")
    def vertical(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "vertical"))

    @vertical.setter
    def vertical(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3e77e1a44f25eae90f455f322a0ae9399f0871ebea4b206be23ae3c1fd856002)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "vertical", value)

    @builtins.property
    @jsii.member(jsii_name="verticalVar")
    def vertical_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "verticalVar"))

    @vertical_var.setter
    def vertical_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__741788a3f79e128405d7e362f67000436cd6b7fe7836961480f95d33d98857ec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "verticalVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationMirror]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationMirror]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationMirror]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__08c441c4ba65e4f69f118c112d364dee1d49342439a7044fbd3d809df6b19cd7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationMonoHue",
    jsii_struct_bases=[],
    name_mapping={"hue": "hue", "hue_var": "hueVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationMonoHue:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__301afbb677b43b6cf12ddb877db21c1ca42cc6bf5f0d0db2931a80d26fe05bc9)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationMonoHue(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationMonoHueList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationMonoHueList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3b8d1146c16d6edc879c34f768c7f54840d63640b019bf2878ca45d4eba0289f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationMonoHueOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4b51be2cc4ec62637b1594fec2ee0fb4553d706749b00615e84c6e93980975cc)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationMonoHueOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__120c11b4f978488aff88a9f8f9894b6e03140b7d4a6c6f93f6c832a780bb4ca3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e4686db897bd70c032be6695d2114fa0cdd0465d54be06a7d4ee03ecdc5139e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__13c504a1b104e253688a786945bc63cbf26026b16cd6abffbb7bdb38916171e3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationMonoHue]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationMonoHue]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d78cc5d6b25e58f4d56948de918a0652ad7790f7b6fde0a8b1bd519b2a6d65c8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationMonoHueOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationMonoHueOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__365d96cc2c8cbba51cc0e80a1961677de39089afb0435b37c1ce175bf17afc81)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__39ab993d0f40c0a79508a4867adc79b84e009d7222019e7fa1ac267d9f3c97d2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__06fd18cd9c7060d494e04dac0fb7462bfc526fd48f67d2c2f357401b04c12e25)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationMonoHue]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationMonoHue]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationMonoHue]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8422f89180dfc6acef614840b6cd260bc07cbff45b8c2f91a1a2f873c40acdfa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationOpacity",
    jsii_struct_bases=[],
    name_mapping={"opacity": "opacity", "opacity_var": "opacityVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationOpacity:
    def __init__(
        self,
        *,
        opacity: typing.Optional[builtins.str] = None,
        opacity_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param opacity: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param opacity_var: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ff3c6c16e2ba1e23aa452001cc4a96980a53d347c7559fb16e32567e37db1edc)
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument opacity_var", value=opacity_var, expected_type=type_hints["opacity_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if opacity is not None:
            self._values["opacity"] = opacity
        if opacity_var is not None:
            self._values["opacity_var"] = opacity_var

    @builtins.property
    def opacity(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def opacity_var(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        result = self._values.get("opacity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationOpacity(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationOpacityList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationOpacityList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aa22f066fcdaae3f23370288d0735efbbcbf7f4ab645086fb6bd9e5e5301bace)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationOpacityOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5128cc11406f9e2d4e8384869d6f69667333f5f9cd4465b63677f9783c203907)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationOpacityOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ad8150a0c0fa4d54f20ef67d0fa84e2996cbba0763dd2aa3b937b9d31868b7a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7a4d9d4e6b2ab3bac6a557f2df41022a1130cf6aca8cb8726097d16ecdfed62a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__47b64d779ca1f122d826d1be9f407392a7319dffa66f26192074a152a2fcf77c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationOpacity]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationOpacity]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bcda6e6d42719660a5f69965de8c8bedacf4b53911d9c7d57a54beb6e845cd8e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationOpacityOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationOpacityOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7aa827f71d35a538488928df6b814b5266f23373026a8fa7766baac02b0ccd1b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetOpacityVar")
    def reset_opacity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacityVar", []))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityVarInput")
    def opacity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacity"))

    @opacity.setter
    def opacity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__87d08ea9dfccc3da5280fbe0bcd4161f630b7575c08459ec2b98ee4c27425df2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacity", value)

    @builtins.property
    @jsii.member(jsii_name="opacityVar")
    def opacity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacityVar"))

    @opacity_var.setter
    def opacity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7e3d4ef3f163608a85b9d1a36b2e48068c31a2dd49a86f364e948fe68dc2e043)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacityVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationOpacity]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationOpacity]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationOpacity]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a2ebcc8deddb65e23d50bf99459c791c57362f38c0fcef6e7b9e7514acb38ef8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cb1e4242d07af8f78ec3b6a6cddf64dcc94b01cce8b7670e4bead907757b0344)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putAppend")
    def put_append(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationAppend, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2fbc0202e98173faa4263387cdce1a174497f7abb65bfe032b08cff2062c0e99)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putAppend", [value]))

    @jsii.member(jsii_name="putAspectCrop")
    def put_aspect_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationAspectCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e9b963add25270025864c27cc586bd503979ad02f55d0481674771781157a2de)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putAspectCrop", [value]))

    @jsii.member(jsii_name="putBackgroundColor")
    def put_background_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__41adaec54577ed09c0aefbd609d46f7c722bda2dd38eb1825c63457c6928212d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBackgroundColor", [value]))

    @jsii.member(jsii_name="putBlur")
    def put_blur(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationBlur, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__836e6dd380bc427ae7008cd5adb88b80ef0c0bf5eb8e6db200a3f2e537c71d5d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBlur", [value]))

    @jsii.member(jsii_name="putChromaKey")
    def put_chroma_key(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationChromaKey, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__51f242647e1ff028b37f9b26a611e3d117fecad92add92b6cba088dc874cc8b8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putChromaKey", [value]))

    @jsii.member(jsii_name="putComposite")
    def put_composite(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationComposite, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9b08d42c9f6d02b9be73c2d41178c149581bc1536415ce4393f08d68721af4c2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putComposite", [value]))

    @jsii.member(jsii_name="putCompound")
    def put_compound(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationCompound, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df2549be62099da5a451d40d55786903930c6509373804ef74ab765d1cc8e54d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCompound", [value]))

    @jsii.member(jsii_name="putContrast")
    def put_contrast(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationContrast, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__56eca23c18204da464b7aed5a78a864513e222b95bc9a770dda580b309ade25e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putContrast", [value]))

    @jsii.member(jsii_name="putCrop")
    def put_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3929279c27be07876b887d027ac4e82568c345cac76a7a902d7a1fd7c739d8b3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCrop", [value]))

    @jsii.member(jsii_name="putFaceCrop")
    def put_face_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationFaceCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5b8c70fdbd0b17b2cac1e1b6c43c488f554cd41af3592876cdede92dd1042ff9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFaceCrop", [value]))

    @jsii.member(jsii_name="putFeatureCrop")
    def put_feature_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationFeatureCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e2e0ed816368c68467b2d56a5112f90ff595f6f29f0d57891f9f9976c678cf1a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFeatureCrop", [value]))

    @jsii.member(jsii_name="putFitAndFill")
    def put_fit_and_fill(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationFitAndFill, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fbb643e849b43aea8fc40b469857ac9e3066e6ddf71f49c316e3f389da6a367e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFitAndFill", [value]))

    @jsii.member(jsii_name="putGoop")
    def put_goop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationGoop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f525a681d685d862ace423cd34c2ac09a406a02ba099270e551feab3706cc2c4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGoop", [value]))

    @jsii.member(jsii_name="putGrayscale")
    def put_grayscale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationGrayscale, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__17d30bf8c5a8452737c55db010d3cd37acc4506562ac7c317b9d37d3ce509011)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGrayscale", [value]))

    @jsii.member(jsii_name="putHsl")
    def put_hsl(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationHsl, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fb7ff1c61c0ae1dd02a58916658eea43065e04a6bff28d735fecb0f2acd6d3a5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsl", [value]))

    @jsii.member(jsii_name="putHsv")
    def put_hsv(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationHsv, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__083766bc6a6f417835302ab4abf977506b89f0544baf60fde889f2aa82e6ac6b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsv", [value]))

    @jsii.member(jsii_name="putIfDimension")
    def put_if_dimension(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfDimension, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__61321fc22c3f5b3dc2ed0690f9eb56e64a87af73eeb554ded3003483d0d3c4b1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfDimension", [value]))

    @jsii.member(jsii_name="putIfOrientation")
    def put_if_orientation(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e559a0d0fab17c100b771ed6a8e9d501b308d7aa3e36240167c5c19a1ef0f0c3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfOrientation", [value]))

    @jsii.member(jsii_name="putImQuery")
    def put_im_query(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationImQuery, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b2d0bc63553b381c01963e744b0b81bad139b0ad18a42157887fa4b66bcee097)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putImQuery", [value]))

    @jsii.member(jsii_name="putMaxColors")
    def put_max_colors(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationMaxColors, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ceecf29fcd3abda35c9bd7613108e41cf7d59d5f31a30c01a285e6bbee2b0459)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMaxColors", [value]))

    @jsii.member(jsii_name="putMirror")
    def put_mirror(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationMirror, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d4e8bd3c47a9692bc3cdcfa2565dc3a083f41d970c4c3d39ec166c0d4b6eacb3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMirror", [value]))

    @jsii.member(jsii_name="putMonoHue")
    def put_mono_hue(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationMonoHue, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__abfe9c23f755dd52885b2cbee41d8e48e9ed3afa2b346eaa7f9cfe5c34094e28)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMonoHue", [value]))

    @jsii.member(jsii_name="putOpacity")
    def put_opacity(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationOpacity, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a75e92abe8ec39ff5982ab52280dc9dc56c7e7a639d528d51b8ceeb9240ce288)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putOpacity", [value]))

    @jsii.member(jsii_name="putRegionOfInterestCrop")
    def put_region_of_interest_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationRegionOfInterestCrop", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__68b06ba2959cbe81b566e70063de70d5df7f3f2da2880a2c4e296717c047f172)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRegionOfInterestCrop", [value]))

    @jsii.member(jsii_name="putRelativeCrop")
    def put_relative_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationRelativeCrop", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0c457f42364254a144da4760df24b3dce53beab6bf71571481c537eff9ba8baa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRelativeCrop", [value]))

    @jsii.member(jsii_name="putRemoveColor")
    def put_remove_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationRemoveColor", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b4b97b2e41c86f082f7dda02ccce07570a596d0e2ea7333b2c9ead31760401e9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRemoveColor", [value]))

    @jsii.member(jsii_name="putResize")
    def put_resize(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationResize", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a3968566d4c216b2fee5c08e87885b726675344864b9429bd8c22d28a69d274)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putResize", [value]))

    @jsii.member(jsii_name="putRotate")
    def put_rotate(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationRotate", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0e6f5177227f220136bede16a9aa8fdd2da96d961c8249d6e8c323113af96e14)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRotate", [value]))

    @jsii.member(jsii_name="putScale")
    def put_scale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationScale", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__834d37502f4601a3caa0816e8b08d507fac11cab6be05b50a700611ecbddfcf2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putScale", [value]))

    @jsii.member(jsii_name="putShear")
    def put_shear(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationShear", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c01c655aa61d663ed47191a7c321320cd7328848a1e3f07f9745ad3bed41d6bb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putShear", [value]))

    @jsii.member(jsii_name="putTrim")
    def put_trim(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationTrim", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__213deb501dcef7729945af5996cbded8f92b2c44dd5a9b99ff0c9c6b33b7f038)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTrim", [value]))

    @jsii.member(jsii_name="putUnsharpMask")
    def put_unsharp_mask(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationUnsharpMask", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ad6c05c7777e0ab14ca53282121c03132516f5fa9808abe56704f434cf393b08)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putUnsharpMask", [value]))

    @jsii.member(jsii_name="resetAppend")
    def reset_append(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAppend", []))

    @jsii.member(jsii_name="resetAspectCrop")
    def reset_aspect_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspectCrop", []))

    @jsii.member(jsii_name="resetBackgroundColor")
    def reset_background_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBackgroundColor", []))

    @jsii.member(jsii_name="resetBlur")
    def reset_blur(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBlur", []))

    @jsii.member(jsii_name="resetChromaKey")
    def reset_chroma_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChromaKey", []))

    @jsii.member(jsii_name="resetComposite")
    def reset_composite(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetComposite", []))

    @jsii.member(jsii_name="resetCompound")
    def reset_compound(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCompound", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetCrop")
    def reset_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCrop", []))

    @jsii.member(jsii_name="resetFaceCrop")
    def reset_face_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFaceCrop", []))

    @jsii.member(jsii_name="resetFeatureCrop")
    def reset_feature_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureCrop", []))

    @jsii.member(jsii_name="resetFitAndFill")
    def reset_fit_and_fill(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFitAndFill", []))

    @jsii.member(jsii_name="resetGoop")
    def reset_goop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGoop", []))

    @jsii.member(jsii_name="resetGrayscale")
    def reset_grayscale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGrayscale", []))

    @jsii.member(jsii_name="resetHsl")
    def reset_hsl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsl", []))

    @jsii.member(jsii_name="resetHsv")
    def reset_hsv(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsv", []))

    @jsii.member(jsii_name="resetIfDimension")
    def reset_if_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfDimension", []))

    @jsii.member(jsii_name="resetIfOrientation")
    def reset_if_orientation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfOrientation", []))

    @jsii.member(jsii_name="resetImQuery")
    def reset_im_query(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetImQuery", []))

    @jsii.member(jsii_name="resetMaxColors")
    def reset_max_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxColors", []))

    @jsii.member(jsii_name="resetMirror")
    def reset_mirror(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMirror", []))

    @jsii.member(jsii_name="resetMonoHue")
    def reset_mono_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonoHue", []))

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetRegionOfInterestCrop")
    def reset_region_of_interest_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRegionOfInterestCrop", []))

    @jsii.member(jsii_name="resetRelativeCrop")
    def reset_relative_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRelativeCrop", []))

    @jsii.member(jsii_name="resetRemoveColor")
    def reset_remove_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRemoveColor", []))

    @jsii.member(jsii_name="resetResize")
    def reset_resize(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetResize", []))

    @jsii.member(jsii_name="resetRotate")
    def reset_rotate(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRotate", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetShear")
    def reset_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetShear", []))

    @jsii.member(jsii_name="resetTrim")
    def reset_trim(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTrim", []))

    @jsii.member(jsii_name="resetUnsharpMask")
    def reset_unsharp_mask(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUnsharpMask", []))

    @builtins.property
    @jsii.member(jsii_name="append")
    def append(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationAppendList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationAppendList, jsii.get(self, "append"))

    @builtins.property
    @jsii.member(jsii_name="aspectCrop")
    def aspect_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationAspectCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationAspectCropList, jsii.get(self, "aspectCrop"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColor")
    def background_color(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationBackgroundColorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationBackgroundColorList, jsii.get(self, "backgroundColor"))

    @builtins.property
    @jsii.member(jsii_name="blur")
    def blur(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationBlurList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationBlurList, jsii.get(self, "blur"))

    @builtins.property
    @jsii.member(jsii_name="chromaKey")
    def chroma_key(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationChromaKeyList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationChromaKeyList, jsii.get(self, "chromaKey"))

    @builtins.property
    @jsii.member(jsii_name="composite")
    def composite(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationCompositeList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationCompositeList, jsii.get(self, "composite"))

    @builtins.property
    @jsii.member(jsii_name="compound")
    def compound(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationCompoundList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationCompoundList, jsii.get(self, "compound"))

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationContrastList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationContrastList, jsii.get(self, "contrast"))

    @builtins.property
    @jsii.member(jsii_name="crop")
    def crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationCropList, jsii.get(self, "crop"))

    @builtins.property
    @jsii.member(jsii_name="faceCrop")
    def face_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationFaceCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationFaceCropList, jsii.get(self, "faceCrop"))

    @builtins.property
    @jsii.member(jsii_name="featureCrop")
    def feature_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationFeatureCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationFeatureCropList, jsii.get(self, "featureCrop"))

    @builtins.property
    @jsii.member(jsii_name="fitAndFill")
    def fit_and_fill(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationFitAndFillList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationFitAndFillList, jsii.get(self, "fitAndFill"))

    @builtins.property
    @jsii.member(jsii_name="goop")
    def goop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationGoopList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationGoopList, jsii.get(self, "goop"))

    @builtins.property
    @jsii.member(jsii_name="grayscale")
    def grayscale(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationGrayscaleList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationGrayscaleList, jsii.get(self, "grayscale"))

    @builtins.property
    @jsii.member(jsii_name="hsl")
    def hsl(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationHslList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationHslList, jsii.get(self, "hsl"))

    @builtins.property
    @jsii.member(jsii_name="hsv")
    def hsv(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationHsvList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationHsvList, jsii.get(self, "hsv"))

    @builtins.property
    @jsii.member(jsii_name="ifDimension")
    def if_dimension(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfDimensionList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfDimensionList, jsii.get(self, "ifDimension"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientation")
    def if_orientation(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfOrientationList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfOrientationList, jsii.get(self, "ifOrientation"))

    @builtins.property
    @jsii.member(jsii_name="imQuery")
    def im_query(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationImQueryList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationImQueryList, jsii.get(self, "imQuery"))

    @builtins.property
    @jsii.member(jsii_name="maxColors")
    def max_colors(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationMaxColorsList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationMaxColorsList, jsii.get(self, "maxColors"))

    @builtins.property
    @jsii.member(jsii_name="mirror")
    def mirror(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationMirrorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationMirrorList, jsii.get(self, "mirror"))

    @builtins.property
    @jsii.member(jsii_name="monoHue")
    def mono_hue(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationMonoHueList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationMonoHueList, jsii.get(self, "monoHue"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationOpacityList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationOpacityList, jsii.get(self, "opacity"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestCrop")
    def region_of_interest_crop(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationRegionOfInterestCropList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationRegionOfInterestCropList", jsii.get(self, "regionOfInterestCrop"))

    @builtins.property
    @jsii.member(jsii_name="relativeCrop")
    def relative_crop(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationRelativeCropList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationRelativeCropList", jsii.get(self, "relativeCrop"))

    @builtins.property
    @jsii.member(jsii_name="removeColor")
    def remove_color(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationRemoveColorList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationRemoveColorList", jsii.get(self, "removeColor"))

    @builtins.property
    @jsii.member(jsii_name="resize")
    def resize(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationResizeList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationResizeList", jsii.get(self, "resize"))

    @builtins.property
    @jsii.member(jsii_name="rotate")
    def rotate(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationRotateList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationRotateList", jsii.get(self, "rotate"))

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationScaleList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationScaleList", jsii.get(self, "scale"))

    @builtins.property
    @jsii.member(jsii_name="shear")
    def shear(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationShearList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationShearList", jsii.get(self, "shear"))

    @builtins.property
    @jsii.member(jsii_name="trim")
    def trim(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationTrimList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationTrimList", jsii.get(self, "trim"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMask")
    def unsharp_mask(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationUnsharpMaskList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationUnsharpMaskList", jsii.get(self, "unsharpMask"))

    @builtins.property
    @jsii.member(jsii_name="appendInput")
    def append_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationAppend]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationAppend]]], jsii.get(self, "appendInput"))

    @builtins.property
    @jsii.member(jsii_name="aspectCropInput")
    def aspect_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationAspectCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationAspectCrop]]], jsii.get(self, "aspectCropInput"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColorInput")
    def background_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationBackgroundColor]]], jsii.get(self, "backgroundColorInput"))

    @builtins.property
    @jsii.member(jsii_name="blurInput")
    def blur_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationBlur]]], jsii.get(self, "blurInput"))

    @builtins.property
    @jsii.member(jsii_name="chromaKeyInput")
    def chroma_key_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationChromaKey]]], jsii.get(self, "chromaKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="compositeInput")
    def composite_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationComposite]]], jsii.get(self, "compositeInput"))

    @builtins.property
    @jsii.member(jsii_name="compoundInput")
    def compound_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationCompound]]], jsii.get(self, "compoundInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationContrast]]], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="cropInput")
    def crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationCrop]]], jsii.get(self, "cropInput"))

    @builtins.property
    @jsii.member(jsii_name="faceCropInput")
    def face_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationFaceCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationFaceCrop]]], jsii.get(self, "faceCropInput"))

    @builtins.property
    @jsii.member(jsii_name="featureCropInput")
    def feature_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationFeatureCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationFeatureCrop]]], jsii.get(self, "featureCropInput"))

    @builtins.property
    @jsii.member(jsii_name="fitAndFillInput")
    def fit_and_fill_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationFitAndFill]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationFitAndFill]]], jsii.get(self, "fitAndFillInput"))

    @builtins.property
    @jsii.member(jsii_name="goopInput")
    def goop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationGoop]]], jsii.get(self, "goopInput"))

    @builtins.property
    @jsii.member(jsii_name="grayscaleInput")
    def grayscale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationGrayscale]]], jsii.get(self, "grayscaleInput"))

    @builtins.property
    @jsii.member(jsii_name="hslInput")
    def hsl_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationHsl]]], jsii.get(self, "hslInput"))

    @builtins.property
    @jsii.member(jsii_name="hsvInput")
    def hsv_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationHsv]]], jsii.get(self, "hsvInput"))

    @builtins.property
    @jsii.member(jsii_name="ifDimensionInput")
    def if_dimension_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfDimension]]], jsii.get(self, "ifDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientationInput")
    def if_orientation_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfOrientation]]], jsii.get(self, "ifOrientationInput"))

    @builtins.property
    @jsii.member(jsii_name="imQueryInput")
    def im_query_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationImQuery]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationImQuery]]], jsii.get(self, "imQueryInput"))

    @builtins.property
    @jsii.member(jsii_name="maxColorsInput")
    def max_colors_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationMaxColors]]], jsii.get(self, "maxColorsInput"))

    @builtins.property
    @jsii.member(jsii_name="mirrorInput")
    def mirror_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationMirror]]], jsii.get(self, "mirrorInput"))

    @builtins.property
    @jsii.member(jsii_name="monoHueInput")
    def mono_hue_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationMonoHue]]], jsii.get(self, "monoHueInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationOpacity]]], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestCropInput")
    def region_of_interest_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationRegionOfInterestCrop"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationRegionOfInterestCrop"]]], jsii.get(self, "regionOfInterestCropInput"))

    @builtins.property
    @jsii.member(jsii_name="relativeCropInput")
    def relative_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationRelativeCrop"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationRelativeCrop"]]], jsii.get(self, "relativeCropInput"))

    @builtins.property
    @jsii.member(jsii_name="removeColorInput")
    def remove_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationRemoveColor"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationRemoveColor"]]], jsii.get(self, "removeColorInput"))

    @builtins.property
    @jsii.member(jsii_name="resizeInput")
    def resize_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationResize"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationResize"]]], jsii.get(self, "resizeInput"))

    @builtins.property
    @jsii.member(jsii_name="rotateInput")
    def rotate_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationRotate"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationRotate"]]], jsii.get(self, "rotateInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationScale"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationScale"]]], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="shearInput")
    def shear_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationShear"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationShear"]]], jsii.get(self, "shearInput"))

    @builtins.property
    @jsii.member(jsii_name="trimInput")
    def trim_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationTrim"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationTrim"]]], jsii.get(self, "trimInput"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMaskInput")
    def unsharp_mask_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationUnsharpMask"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationUnsharpMask"]]], jsii.get(self, "unsharpMaskInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dd547db439946b92342514dd83a5396f864667b4a6b1f17786d154e71ef80934)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationRegionOfInterestCrop",
    jsii_struct_bases=[],
    name_mapping={
        "region_of_interest": "regionOfInterest",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationRegionOfInterestCrop:
    def __init__(
        self,
        *,
        region_of_interest: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationRegionOfInterestCropRegionOfInterest", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param region_of_interest: region_of_interest block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest DataAkamaiImagingPolicyImage#region_of_interest}
        :param gravity: The placement of the crop area relative to the specified area of interest. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: The placement of the crop area relative to the specified area of interest. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param style: Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(region_of_interest, dict):
            region_of_interest = DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationRegionOfInterestCropRegionOfInterest(**region_of_interest)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0e5d53e223366fef4ff3f52c91d957cc83948c431ddb0fb86786db46273f256f)
            check_type(argname="argument region_of_interest", value=region_of_interest, expected_type=type_hints["region_of_interest"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "region_of_interest": region_of_interest,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def region_of_interest(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationRegionOfInterestCropRegionOfInterest":
        '''region_of_interest block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest DataAkamaiImagingPolicyImage#region_of_interest}
        '''
        result = self._values.get("region_of_interest")
        assert result is not None, "Required property 'region_of_interest' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationRegionOfInterestCropRegionOfInterest", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''The placement of the crop area relative to the specified area of interest.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''The placement of the crop area relative to the specified area of interest.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationRegionOfInterestCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationRegionOfInterestCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationRegionOfInterestCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7f8f05a4798258d4b6cf51cd57f729014f8daef8248aee42ff10719a502d37aa)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationRegionOfInterestCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bbae698698c8a052fc083913f0458054ef45a2dce5d9dd0f9749424d1aacba33)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationRegionOfInterestCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__580296f3a4f844eb430628f164a93c0fca6657bfa8e28da7b90b3b258dd6b717)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3cde6e0a959b867774cd3f6d6af0c92aaf95aef5ed5b7ff8f54e56615092f1c8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0e8cde813195b3045eced7a2eae3fef22cd9439649f9bc23b4e72bb7dd5e07af)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationRegionOfInterestCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationRegionOfInterestCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationRegionOfInterestCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__12c21c14590b605f4f465672013dd0114b71d27e9b7718610e42b79dc47fabfe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationRegionOfInterestCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationRegionOfInterestCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dc90589309c0c402e3c953c4694a83a6062d314eb95ef0055ad921dba1482809)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putRegionOfInterest")
    def put_region_of_interest(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationRegionOfInterestCropRegionOfInterest()

        return typing.cast(None, jsii.invoke(self, "putRegionOfInterest", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterest")
    def region_of_interest(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationRegionOfInterestCropRegionOfInterestOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationRegionOfInterestCropRegionOfInterestOutputReference", jsii.get(self, "regionOfInterest"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestInput")
    def region_of_interest_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationRegionOfInterestCropRegionOfInterest"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationRegionOfInterestCropRegionOfInterest"], jsii.get(self, "regionOfInterestInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5414644e52263baa173804d45f5dfc1dc835b316ea6031d504fb3ad981e99435)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__30a9d9eb839eb0e9d05645e1c783c807306767ff70e3d71bc1c29a79caa7ca5c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0082e54d0ae123e331fc32a001801886ccd867ad3d8ea7b0df1fab0e9b278350)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__52e2c1b320c27bb0ad63fcef3d1464b553f52f3574a154b04d55edd5f0280dfd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f0b137a077e9446e6f3b7e8cd0215cc83f3fdb651ae795189d47ee1fff4d4883)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a32e29cdee412532639d465844d348d321cc8e4a1e60415cddea250da40822cd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__06f61effa2c29f9e5dfd3f48cb8e8b73eb754949663f1f0eb940ea7e1db1e5b9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__501b74eb9e681639316205d0b9da101757cbc7da8ce469e6e70e82ba4dc78190)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationRegionOfInterestCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationRegionOfInterestCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationRegionOfInterestCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__54f47fc2c5d2a5c19cc3b95d6e2d20f6d92ea7fde957936f06c13721f0256edc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationRegionOfInterestCropRegionOfInterest",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationRegionOfInterestCropRegionOfInterest:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationRegionOfInterestCropRegionOfInterest(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationRegionOfInterestCropRegionOfInterestOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationRegionOfInterestCropRegionOfInterestOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2dc9176643ce292a8a9151925058caa14fe9b866760ed14bbb09353ee047802b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationRegionOfInterestCropRegionOfInterest]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationRegionOfInterestCropRegionOfInterest], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationRegionOfInterestCropRegionOfInterest],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b34b5a61060a981203a34c371005d5b0ddad37eedcba6094d093d404233d7d2e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationRelativeCrop",
    jsii_struct_bases=[],
    name_mapping={
        "east": "east",
        "east_var": "eastVar",
        "north": "north",
        "north_var": "northVar",
        "south": "south",
        "south_var": "southVar",
        "west": "west",
        "west_var": "westVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationRelativeCrop:
    def __init__(
        self,
        *,
        east: typing.Optional[builtins.str] = None,
        east_var: typing.Optional[builtins.str] = None,
        north: typing.Optional[builtins.str] = None,
        north_var: typing.Optional[builtins.str] = None,
        south: typing.Optional[builtins.str] = None,
        south_var: typing.Optional[builtins.str] = None,
        west: typing.Optional[builtins.str] = None,
        west_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param east: The number of pixels to shrink or expand the right side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east DataAkamaiImagingPolicyImage#east}
        :param east_var: The number of pixels to shrink or expand the right side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east_var DataAkamaiImagingPolicyImage#east_var}
        :param north: The number of pixels to shrink or expand the top side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north DataAkamaiImagingPolicyImage#north}
        :param north_var: The number of pixels to shrink or expand the top side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north_var DataAkamaiImagingPolicyImage#north_var}
        :param south: The number of pixels to shrink or expand the bottom side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south DataAkamaiImagingPolicyImage#south}
        :param south_var: The number of pixels to shrink or expand the bottom side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south_var DataAkamaiImagingPolicyImage#south_var}
        :param west: The number of pixels to shrink or expand the left side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west DataAkamaiImagingPolicyImage#west}
        :param west_var: The number of pixels to shrink or expand the left side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west_var DataAkamaiImagingPolicyImage#west_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cc11630804e206035c40d0955121447d4ebd6723523e9f39976cc1e1ad9b9a9f)
            check_type(argname="argument east", value=east, expected_type=type_hints["east"])
            check_type(argname="argument east_var", value=east_var, expected_type=type_hints["east_var"])
            check_type(argname="argument north", value=north, expected_type=type_hints["north"])
            check_type(argname="argument north_var", value=north_var, expected_type=type_hints["north_var"])
            check_type(argname="argument south", value=south, expected_type=type_hints["south"])
            check_type(argname="argument south_var", value=south_var, expected_type=type_hints["south_var"])
            check_type(argname="argument west", value=west, expected_type=type_hints["west"])
            check_type(argname="argument west_var", value=west_var, expected_type=type_hints["west_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if east is not None:
            self._values["east"] = east
        if east_var is not None:
            self._values["east_var"] = east_var
        if north is not None:
            self._values["north"] = north
        if north_var is not None:
            self._values["north_var"] = north_var
        if south is not None:
            self._values["south"] = south
        if south_var is not None:
            self._values["south_var"] = south_var
        if west is not None:
            self._values["west"] = west
        if west_var is not None:
            self._values["west_var"] = west_var

    @builtins.property
    def east(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the right side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east DataAkamaiImagingPolicyImage#east}
        '''
        result = self._values.get("east")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def east_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the right side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east_var DataAkamaiImagingPolicyImage#east_var}
        '''
        result = self._values.get("east_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def north(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the top side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north DataAkamaiImagingPolicyImage#north}
        '''
        result = self._values.get("north")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def north_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the top side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north_var DataAkamaiImagingPolicyImage#north_var}
        '''
        result = self._values.get("north_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def south(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the bottom side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south DataAkamaiImagingPolicyImage#south}
        '''
        result = self._values.get("south")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def south_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the bottom side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south_var DataAkamaiImagingPolicyImage#south_var}
        '''
        result = self._values.get("south_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def west(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the left side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west DataAkamaiImagingPolicyImage#west}
        '''
        result = self._values.get("west")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def west_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the left side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west_var DataAkamaiImagingPolicyImage#west_var}
        '''
        result = self._values.get("west_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationRelativeCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationRelativeCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationRelativeCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c5a39c068609f3cb0701ed9800617d5616365975708d4cf100d7439984727274)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationRelativeCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__51e63b9bf4885681f0760bba8195f79457c887ce9a69965d98509f664149c44f)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationRelativeCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__86d0383c5b9cfc6af54ece107770ca3bc7d1f521fdc4d70c97f96934e7e85ad3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a7dd28b9979fa57600389a05db0d326ba8e3435599cb4163f80cf191b12c973)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4878bd223e2acdf041984411b72c87be436ba38fd5aecf7fe24218c8c88c4db8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationRelativeCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationRelativeCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationRelativeCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__00f15ac81ed0b45d093585cbc0a3d7c707fac8fc3ed73a5499e21c6f772efc5a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationRelativeCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationRelativeCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e03fb81bd3b529fef8707e7a95ee88c15ce46161c5725907ee01dbfe3137dc76)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetEast")
    def reset_east(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEast", []))

    @jsii.member(jsii_name="resetEastVar")
    def reset_east_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEastVar", []))

    @jsii.member(jsii_name="resetNorth")
    def reset_north(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNorth", []))

    @jsii.member(jsii_name="resetNorthVar")
    def reset_north_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNorthVar", []))

    @jsii.member(jsii_name="resetSouth")
    def reset_south(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSouth", []))

    @jsii.member(jsii_name="resetSouthVar")
    def reset_south_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSouthVar", []))

    @jsii.member(jsii_name="resetWest")
    def reset_west(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWest", []))

    @jsii.member(jsii_name="resetWestVar")
    def reset_west_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWestVar", []))

    @builtins.property
    @jsii.member(jsii_name="eastInput")
    def east_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "eastInput"))

    @builtins.property
    @jsii.member(jsii_name="eastVarInput")
    def east_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "eastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="northInput")
    def north_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "northInput"))

    @builtins.property
    @jsii.member(jsii_name="northVarInput")
    def north_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "northVarInput"))

    @builtins.property
    @jsii.member(jsii_name="southInput")
    def south_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "southInput"))

    @builtins.property
    @jsii.member(jsii_name="southVarInput")
    def south_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "southVarInput"))

    @builtins.property
    @jsii.member(jsii_name="westInput")
    def west_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "westInput"))

    @builtins.property
    @jsii.member(jsii_name="westVarInput")
    def west_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "westVarInput"))

    @builtins.property
    @jsii.member(jsii_name="east")
    def east(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "east"))

    @east.setter
    def east(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__120ad741725972bfaa171a4d38a1bb9bfd8530e004cbcdfc220f66e04fb42881)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "east", value)

    @builtins.property
    @jsii.member(jsii_name="eastVar")
    def east_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "eastVar"))

    @east_var.setter
    def east_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__abdaf8c6f70ee6f09cfdf88536e1b51228fda554aee7e55a835c75775f004811)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "eastVar", value)

    @builtins.property
    @jsii.member(jsii_name="north")
    def north(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "north"))

    @north.setter
    def north(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__06d2b3a9a8beb11a4ce8e6cebf4eab2e577298625e15a6ab370690050a5cf93b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "north", value)

    @builtins.property
    @jsii.member(jsii_name="northVar")
    def north_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "northVar"))

    @north_var.setter
    def north_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__35bd6eb54afad24ad5e3165205fe112b77ea0617f6df9031dcf3fd96e89806d4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "northVar", value)

    @builtins.property
    @jsii.member(jsii_name="south")
    def south(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "south"))

    @south.setter
    def south(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__820869d1bccd2edad63ca55ba170b307136a06d8cf4e628685d32e74ae93b6ed)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "south", value)

    @builtins.property
    @jsii.member(jsii_name="southVar")
    def south_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "southVar"))

    @south_var.setter
    def south_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2b44bee384e4f4ec1cd48f3b30cd35d7247cfc1ad8668d4a2bfccba3067c5db2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "southVar", value)

    @builtins.property
    @jsii.member(jsii_name="west")
    def west(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "west"))

    @west.setter
    def west(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c8628bd228b8a1a56a029805089f341f40469798a20643799d42bd9980af29e0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "west", value)

    @builtins.property
    @jsii.member(jsii_name="westVar")
    def west_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "westVar"))

    @west_var.setter
    def west_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3072c54c6fd11f53c38963d0d72bf6c11f5f0923a8b6dd56947075dd6b48befc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "westVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationRelativeCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationRelativeCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationRelativeCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ca430f0cc1c3cfc7bfaba31713b6bb16ed9e7be3f728e3a475303622746b3e7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationRemoveColor",
    jsii_struct_bases=[],
    name_mapping={
        "color": "color",
        "color_var": "colorVar",
        "feather": "feather",
        "feather_var": "featherVar",
        "tolerance": "tolerance",
        "tolerance_var": "toleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationRemoveColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
        feather: typing.Optional[builtins.str] = None,
        feather_var: typing.Optional[builtins.str] = None,
        tolerance: typing.Optional[builtins.str] = None,
        tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        :param feather: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        :param feather_var: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        :param tolerance: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        :param tolerance_var: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e67af28ebbc1a8ba14defbee939b9c72e499e6ec7d93276ac21cc141ae5ddce4)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
            check_type(argname="argument feather", value=feather, expected_type=type_hints["feather"])
            check_type(argname="argument feather_var", value=feather_var, expected_type=type_hints["feather_var"])
            check_type(argname="argument tolerance", value=tolerance, expected_type=type_hints["tolerance"])
            check_type(argname="argument tolerance_var", value=tolerance_var, expected_type=type_hints["tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var
        if feather is not None:
            self._values["feather"] = feather
        if feather_var is not None:
            self._values["feather_var"] = feather_var
        if tolerance is not None:
            self._values["tolerance"] = tolerance
        if tolerance_var is not None:
            self._values["tolerance_var"] = tolerance_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        '''
        result = self._values.get("feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather_var(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        '''
        result = self._values.get("feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        '''
        result = self._values.get("tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance_var(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        result = self._values.get("tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationRemoveColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationRemoveColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationRemoveColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__364be25791df8747afc0f8fa73c4d2606a3eb9231f591708995dc1469b249a1d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationRemoveColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bd32b0cf8692c2b4ad0ada66d17b68871fce23c80ac384112b2bbdf0676e4b94)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationRemoveColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__883289501afd98ffc5badca6440f85a95e62a1c694b999cae030b0fc694d5810)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__75491687bea3c02a94f346b4823fc2c030abbd5ce9803ca7c30a68082e92ba8b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d84271ae219ba20e77b33febd730a24e9a5b37be357e8bc934d355bd54b5010d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationRemoveColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationRemoveColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationRemoveColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a6339f46c5cddf476e8e89aa80509487874bfc552b90c61c0d8c1d850cdee32c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationRemoveColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationRemoveColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0582fb30b59f7f575f8a9c74869931f1a8c67bc96c106d0d96b8fcaacd246bed)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @jsii.member(jsii_name="resetFeather")
    def reset_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeather", []))

    @jsii.member(jsii_name="resetFeatherVar")
    def reset_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatherVar", []))

    @jsii.member(jsii_name="resetTolerance")
    def reset_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTolerance", []))

    @jsii.member(jsii_name="resetToleranceVar")
    def reset_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featherInput")
    def feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherInput"))

    @builtins.property
    @jsii.member(jsii_name="featherVarInput")
    def feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceInput")
    def tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceVarInput")
    def tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e4455ada3b25f40291c1818bf6f165af3e86c1b6adb36c37738f97ba3966a5b6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd5c1428dd8f82665f84b0115876edd33671ed4151a3252bbfb9662d92b262af)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="feather")
    def feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "feather"))

    @feather.setter
    def feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6991509741cfa570a8d3994cf663522762223df8ffe328035b767f137c33d366)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "feather", value)

    @builtins.property
    @jsii.member(jsii_name="featherVar")
    def feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featherVar"))

    @feather_var.setter
    def feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8c17b7ae0a8daf7c1bdf1ee29bd86d884f415d4aad4248f289b97bbd8042f73f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featherVar", value)

    @builtins.property
    @jsii.member(jsii_name="tolerance")
    def tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tolerance"))

    @tolerance.setter
    def tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__15dd3d42578e9ac4f97a54a45b34a932300add44ada74c03e407b629ee45257e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tolerance", value)

    @builtins.property
    @jsii.member(jsii_name="toleranceVar")
    def tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "toleranceVar"))

    @tolerance_var.setter
    def tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab26f68310ab53bae916245bde838add578435f3ec09d7be08283f47c82997a4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "toleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationRemoveColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationRemoveColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationRemoveColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__56ea5ee1ec07e4c3437e71f1cbf8af7cf6e1c10ac5ce805f52b0ba3e5a13fa1c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationResize",
    jsii_struct_bases=[],
    name_mapping={
        "aspect": "aspect",
        "aspect_var": "aspectVar",
        "height": "height",
        "height_var": "heightVar",
        "type": "type",
        "type_var": "typeVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationResize:
    def __init__(
        self,
        *,
        aspect: typing.Optional[builtins.str] = None,
        aspect_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param aspect: Preserves the aspect ratio. Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect DataAkamaiImagingPolicyImage#aspect}
        :param aspect_var: Preserves the aspect ratio. Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_var DataAkamaiImagingPolicyImage#aspect_var}
        :param height: The height to resize the source image to. Must be set if height is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height to resize the source image to. Must be set if height is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param type: Sets constraints for the image resize. Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: Sets constraints for the image resize. Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        :param width: The width to resize the source image to. Must be set if width is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width to resize the source image to. Must be set if width is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a0e4618a91f7e1ca0418b57f6b56e3ec08aae32b71ef584a98d95d3c6ae2be1e)
            check_type(argname="argument aspect", value=aspect, expected_type=type_hints["aspect"])
            check_type(argname="argument aspect_var", value=aspect_var, expected_type=type_hints["aspect_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if aspect is not None:
            self._values["aspect"] = aspect
        if aspect_var is not None:
            self._values["aspect_var"] = aspect_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def aspect(self) -> typing.Optional[builtins.str]:
        '''Preserves the aspect ratio.

        Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect DataAkamaiImagingPolicyImage#aspect}
        '''
        result = self._values.get("aspect")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def aspect_var(self) -> typing.Optional[builtins.str]:
        '''Preserves the aspect ratio.

        Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_var DataAkamaiImagingPolicyImage#aspect_var}
        '''
        result = self._values.get("aspect_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height to resize the source image to. Must be set if height is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height to resize the source image to. Must be set if height is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''Sets constraints for the image resize.

        Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''Sets constraints for the image resize.

        Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width to resize the source image to. Must be set if width is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width to resize the source image to. Must be set if width is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationResize(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationResizeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationResizeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2022b339288bceb13cea7f7bdfafcbbf91b20a3b9a655d8824de583691c95026)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationResizeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a270d9cba1a4e9740226ac47443eb326650bb1b8106c152e60e1b1647c6b0ede)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationResizeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bf3eeef21dbb71c21db357dc560c7c0f11ebdbcbc3b0269d6442aad08589e929)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d8ebf4685c9298a2acb1b187373156e9805d22105f83105f544aab1378ae5e9f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f652ca639cf0a2191b0d95992682ffef8a00020e84957ae31f854888c0bbeeea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationResize]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationResize]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationResize]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__211e0780193bc748b6981aa1083075ec3ae4f584120e9c243a1b55bf86925245)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationResizeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationResizeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fb86f3493b1b64ac5a16b4f1f649d02d82e7a4ba2ee504f236a27041693f9071)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAspect")
    def reset_aspect(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspect", []))

    @jsii.member(jsii_name="resetAspectVar")
    def reset_aspect_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspectVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="aspectInput")
    def aspect_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "aspectInput"))

    @builtins.property
    @jsii.member(jsii_name="aspectVarInput")
    def aspect_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "aspectVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="aspect")
    def aspect(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "aspect"))

    @aspect.setter
    def aspect(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__80aa62ba61a2237f8ebf7e90878aa5a9f9c8e8bad18314da235383f242fc8c15)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "aspect", value)

    @builtins.property
    @jsii.member(jsii_name="aspectVar")
    def aspect_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "aspectVar"))

    @aspect_var.setter
    def aspect_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0deaf46e5b6914c45bc472920e9b7ec7d2f8e3c6ebeceb9a7e17b655e62c284c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "aspectVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__36dc39dea66ec581e8bb5a3f4809e97ebc94bcd052bf26421e8f477c05476a7e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5a48048d20bf02e55e2816461708805fe4b0a5bed828a3e978f7ead9a1cf3f8b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ebc22b38c42eec2e2372dafbe1c768f8aa377c38350496dfc8ffc31ecd71486)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f6fe7edf09be3e1dd0409e8b937eddb5e72d22993900040c3da3caa98cb1006)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eb78dce24dfaceab5cde3d53a565da12e3f5b8258a48463468e9b81ebd6751e7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e59bfd59017a12685ca9a15d693bec9bcc8f0ba3e054535695d42928e642f803)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationResize]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationResize]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationResize]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6ff68d451dc8e2a95fad009d2b7970f2e3f119aa093a56f8ff4c21115d58aad0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationRotate",
    jsii_struct_bases=[],
    name_mapping={"degrees": "degrees", "degrees_var": "degreesVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationRotate:
    def __init__(
        self,
        *,
        degrees: typing.Optional[builtins.str] = None,
        degrees_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param degrees: The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees DataAkamaiImagingPolicyImage#degrees}
        :param degrees_var: The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees_var DataAkamaiImagingPolicyImage#degrees_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__569eb6019e071ec797c8bee7487d89b10649130e67573509c4b88a4bd613877c)
            check_type(argname="argument degrees", value=degrees, expected_type=type_hints["degrees"])
            check_type(argname="argument degrees_var", value=degrees_var, expected_type=type_hints["degrees_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if degrees is not None:
            self._values["degrees"] = degrees
        if degrees_var is not None:
            self._values["degrees_var"] = degrees_var

    @builtins.property
    def degrees(self) -> typing.Optional[builtins.str]:
        '''The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees DataAkamaiImagingPolicyImage#degrees}
        '''
        result = self._values.get("degrees")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def degrees_var(self) -> typing.Optional[builtins.str]:
        '''The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees_var DataAkamaiImagingPolicyImage#degrees_var}
        '''
        result = self._values.get("degrees_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationRotate(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationRotateList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationRotateList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5c59318a9a1bad36680a79ff9296d7260bd2adc12302a5fd0acfe6518f2984a0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationRotateOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7efd97dcbfbb08fe6e35fe63a486b709b59f154d7f1c84c8439a724fef733d4e)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationRotateOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6fc62d1556b93450f0bc465cf48aab0acc77113d048e856719872f2f77325750)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6ec74eecedb641d984892b447840d5c51526e491dc6fe65157614e7b67e2336e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bbe00a49feeef11355a6e4862b3a6cb10b522590dfd8df439eb05cb246c77e3f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationRotate]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationRotate]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationRotate]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__88ffd0434f8d71c1bba89b3c5b3e6f3b49020890541faf38f18bb0f8e9a19120)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationRotateOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationRotateOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0468a3e2e3a4e0a9bc9d367d3b23926fadaa7c43ad39ddd073d1b3e7d379e7a8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetDegrees")
    def reset_degrees(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDegrees", []))

    @jsii.member(jsii_name="resetDegreesVar")
    def reset_degrees_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDegreesVar", []))

    @builtins.property
    @jsii.member(jsii_name="degreesInput")
    def degrees_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "degreesInput"))

    @builtins.property
    @jsii.member(jsii_name="degreesVarInput")
    def degrees_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "degreesVarInput"))

    @builtins.property
    @jsii.member(jsii_name="degrees")
    def degrees(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "degrees"))

    @degrees.setter
    def degrees(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2b92fdfadbb8d9868f9d62244d468176fe028474b5fd308211ec0de0a9ccc24a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "degrees", value)

    @builtins.property
    @jsii.member(jsii_name="degreesVar")
    def degrees_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "degreesVar"))

    @degrees_var.setter
    def degrees_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fe43aa4c57ba9827eb5cac7f4dcae8e601b21dfc8134f3abb78e6d37d0462067)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "degreesVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationRotate]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationRotate]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationRotate]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1d079eb2044ca875a1b9221e1524807fabbd79531931e0d8424711c10992747a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationScale",
    jsii_struct_bases=[],
    name_mapping={
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationScale:
    def __init__(
        self,
        *,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param height: Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged. Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged. Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__635336c992d21367cb548fb8b764a221bc80b897ac10cdb9679f1ff86ec1b58e)
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size.

        Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size.

        Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged.

        Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged.

        Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationScale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationScaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationScaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c0798c032da5032d119b2f39081bfdd5cec9dfe397d1d34922c90761a01e5f1f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationScaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__98e2d82eba647460b89e1026759a45490f885fb759e1bfa0384bd8f246783174)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationScaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__359376fe1c1e359303caf5cf66315951e8de7a2cc9dacfa16157a64a500c9f34)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9062dc6741482e06f36c6158f0af77a702994a6285b1d3b3deb96758054f05b1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2eaf7cee57f653f5ebe3b72eeb05d9b8e92ae95e7d455612c77d15d713cd5679)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationScale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationScale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationScale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__abfa26489d6285f6b4e5e9dbf10047708b30c8aa7611c39c86b8e576ad82edc2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationScaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationScaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dc4497e6e8f3213a57d2bb27babb4d6b83e526c34d253f0a8cc87a175cf6a781)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__730740e459b759dedba8685e05011c2e27f1f68b0c365df1d114a2ffc0139eda)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c0673198fc85f1e71bf011e4e4800bdf034f4b46980ebc7aa5da5953a79b3ac5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d849389ce92df08506c6d885d7e3a218d54d349e56007e5d7d3907ccfc952637)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3af44f56f32f29230faef496a8e78d129415d400ce96518d1d67e9a19ffde0ee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationScale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationScale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationScale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__edf8a3b9c40318bd4c45ba1c81a34474e6128f71fcff5cff96cc15b8dd23cf50)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationShear",
    jsii_struct_bases=[],
    name_mapping={
        "x_shear": "xShear",
        "x_shear_var": "xShearVar",
        "y_shear": "yShear",
        "y_shear_var": "yShearVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationShear:
    def __init__(
        self,
        *,
        x_shear: typing.Optional[builtins.str] = None,
        x_shear_var: typing.Optional[builtins.str] = None,
        y_shear: typing.Optional[builtins.str] = None,
        y_shear_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param x_shear: The amount to shear along the x-axis, measured in multiples of the image's width. Must be set if yShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear DataAkamaiImagingPolicyImage#x_shear}
        :param x_shear_var: The amount to shear along the x-axis, measured in multiples of the image's width. Must be set if yShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear_var DataAkamaiImagingPolicyImage#x_shear_var}
        :param y_shear: The amount to shear along the y-axis, measured in multiples of the image's height. Must be set if xShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear DataAkamaiImagingPolicyImage#y_shear}
        :param y_shear_var: The amount to shear along the y-axis, measured in multiples of the image's height. Must be set if xShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear_var DataAkamaiImagingPolicyImage#y_shear_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a74041304c980ac0b46c2866abb85e6326b1c6c4e606dc1f88d1282339197f88)
            check_type(argname="argument x_shear", value=x_shear, expected_type=type_hints["x_shear"])
            check_type(argname="argument x_shear_var", value=x_shear_var, expected_type=type_hints["x_shear_var"])
            check_type(argname="argument y_shear", value=y_shear, expected_type=type_hints["y_shear"])
            check_type(argname="argument y_shear_var", value=y_shear_var, expected_type=type_hints["y_shear_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if x_shear is not None:
            self._values["x_shear"] = x_shear
        if x_shear_var is not None:
            self._values["x_shear_var"] = x_shear_var
        if y_shear is not None:
            self._values["y_shear"] = y_shear
        if y_shear_var is not None:
            self._values["y_shear_var"] = y_shear_var

    @builtins.property
    def x_shear(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the x-axis, measured in multiples of the image's width.

        Must be set if yShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear DataAkamaiImagingPolicyImage#x_shear}
        '''
        result = self._values.get("x_shear")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_shear_var(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the x-axis, measured in multiples of the image's width.

        Must be set if yShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear_var DataAkamaiImagingPolicyImage#x_shear_var}
        '''
        result = self._values.get("x_shear_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_shear(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the y-axis, measured in multiples of the image's height.

        Must be set if xShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear DataAkamaiImagingPolicyImage#y_shear}
        '''
        result = self._values.get("y_shear")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_shear_var(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the y-axis, measured in multiples of the image's height.

        Must be set if xShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear_var DataAkamaiImagingPolicyImage#y_shear_var}
        '''
        result = self._values.get("y_shear_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationShear(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationShearList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationShearList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a37a5e99a633ca8faa97bceba3fca23e2f2ffb4982362b7668c6075044856aa)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationShearOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c2848a40813a1a9c332cd2e003c7b249500cbb84e6d6ae02ac003ba3c46eac78)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationShearOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2608876798e8e06f453a5e6e2bd70374e0e17d48c2d9c7df96aab58ee8b258c1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ec63a66df3d8e1a046ae6b93d92481d160e47723f93f86b46f2a237cde1a38ae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ca9def6de1cfd9093d15c68a2c4f3a4b39b361914af393cbd4cca10734bbbc34)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationShear]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationShear]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationShear]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__216560f63f9f3ee98c6bbc90ddda2bb1d45dba49c4533b9e08e6c224b4490004)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationShearOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationShearOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1a7af855b37540f601587e00b8325f46201bcc0c7a8f395eb4cb6e7f6d5853b6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetXShear")
    def reset_x_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXShear", []))

    @jsii.member(jsii_name="resetXShearVar")
    def reset_x_shear_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXShearVar", []))

    @jsii.member(jsii_name="resetYShear")
    def reset_y_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYShear", []))

    @jsii.member(jsii_name="resetYShearVar")
    def reset_y_shear_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYShearVar", []))

    @builtins.property
    @jsii.member(jsii_name="xShearInput")
    def x_shear_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xShearInput"))

    @builtins.property
    @jsii.member(jsii_name="xShearVarInput")
    def x_shear_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xShearVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yShearInput")
    def y_shear_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yShearInput"))

    @builtins.property
    @jsii.member(jsii_name="yShearVarInput")
    def y_shear_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yShearVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xShear")
    def x_shear(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xShear"))

    @x_shear.setter
    def x_shear(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5c6253b9a3a341c18753a1d576c624e4a227182035fbf0bbc22f078fee43cc8c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xShear", value)

    @builtins.property
    @jsii.member(jsii_name="xShearVar")
    def x_shear_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xShearVar"))

    @x_shear_var.setter
    def x_shear_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0a8e178fb10292571c4eae2f98818b56232ea9e925d59f716664efe5cfe50cd5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xShearVar", value)

    @builtins.property
    @jsii.member(jsii_name="yShear")
    def y_shear(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yShear"))

    @y_shear.setter
    def y_shear(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__343666be889f431c33398c76f7b95a432ba86663836118fb71a6a5a985a8519c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yShear", value)

    @builtins.property
    @jsii.member(jsii_name="yShearVar")
    def y_shear_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yShearVar"))

    @y_shear_var.setter
    def y_shear_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__959953178ef2a91423627f872c2a709f55516084dc6dfbe06a39cb64f252c7a9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yShearVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationShear]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationShear]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationShear]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b0fd4bb2a31d0c7bd8b3a920fd27f40b074d9bbbad3359aa09a8f5ffde786ad6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationTrim",
    jsii_struct_bases=[],
    name_mapping={
        "fuzz": "fuzz",
        "fuzz_var": "fuzzVar",
        "padding": "padding",
        "padding_var": "paddingVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationTrim:
    def __init__(
        self,
        *,
        fuzz: typing.Optional[builtins.str] = None,
        fuzz_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fuzz: The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz DataAkamaiImagingPolicyImage#fuzz}
        :param fuzz_var: The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz_var DataAkamaiImagingPolicyImage#fuzz_var}
        :param padding: The amount of padding in pixels to add to the trimmed image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: The amount of padding in pixels to add to the trimmed image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6c04ecb5f8c4bc58cd81db80fb48844aeca2fa20c640d39150540d79c4abf222)
            check_type(argname="argument fuzz", value=fuzz, expected_type=type_hints["fuzz"])
            check_type(argname="argument fuzz_var", value=fuzz_var, expected_type=type_hints["fuzz_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fuzz is not None:
            self._values["fuzz"] = fuzz
        if fuzz_var is not None:
            self._values["fuzz_var"] = fuzz_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var

    @builtins.property
    def fuzz(self) -> typing.Optional[builtins.str]:
        '''The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz DataAkamaiImagingPolicyImage#fuzz}
        '''
        result = self._values.get("fuzz")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fuzz_var(self) -> typing.Optional[builtins.str]:
        '''The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz_var DataAkamaiImagingPolicyImage#fuzz_var}
        '''
        result = self._values.get("fuzz_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''The amount of padding in pixels to add to the trimmed image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''The amount of padding in pixels to add to the trimmed image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationTrim(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationTrimList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationTrimList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9fe899cfde8db142bd29eb932a97cfd173c1335ae6a316230f6f16ee0acf4524)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationTrimOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b4e6696fd6a244138ed6723dce2f961ebcf7b6304ae8f575b7b50d896859a3a2)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationTrimOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2cd97c33eea9e12b0a7d2884f80a98483257ef8348a0c349445507f7cfdfecd6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7c0c30738caa56993e37d0bd36851215ede2fb96c9099db989beb298e94d3a37)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f4ee055679bc1eca31cb85623bda4f3b429a0cad2be2d5955a5d2a69c7f4ef50)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationTrim]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationTrim]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationTrim]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d7c967ea88cf620c33bd33d13d32b72845d78a834443bd966f291dda3e1f6428)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationTrimOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationTrimOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c3216de0775057e466332f34e91faf7d786ca8e25f3eaefec396936dba934d3d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetFuzz")
    def reset_fuzz(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFuzz", []))

    @jsii.member(jsii_name="resetFuzzVar")
    def reset_fuzz_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFuzzVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @builtins.property
    @jsii.member(jsii_name="fuzzInput")
    def fuzz_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fuzzInput"))

    @builtins.property
    @jsii.member(jsii_name="fuzzVarInput")
    def fuzz_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fuzzVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="fuzz")
    def fuzz(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fuzz"))

    @fuzz.setter
    def fuzz(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7fa56cc526fc033ba9cdaae7c544a7b74de2bb407643a6ae91fe1663a67a62a7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fuzz", value)

    @builtins.property
    @jsii.member(jsii_name="fuzzVar")
    def fuzz_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fuzzVar"))

    @fuzz_var.setter
    def fuzz_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ee6e6452de90144b43cf0c05b79a4f585671ad447c90541818a3660642cc4e4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fuzzVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1377514258c04b955c4fabb8621f43e92698a8476df77327353cf34654aecc91)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__711fef0cad70201e736afed650c76c1f14576a3027bb81b8ef302945307da61f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationTrim]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationTrim]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationTrim]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c7f957d34cf28aa24595e796135c495405a56d3cf36c10c7c34a71045e00c011)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationUnsharpMask",
    jsii_struct_bases=[],
    name_mapping={
        "gain": "gain",
        "gain_var": "gainVar",
        "sigma": "sigma",
        "sigma_var": "sigmaVar",
        "threshold": "threshold",
        "threshold_var": "thresholdVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationUnsharpMask:
    def __init__(
        self,
        *,
        gain: typing.Optional[builtins.str] = None,
        gain_var: typing.Optional[builtins.str] = None,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
        threshold: typing.Optional[builtins.str] = None,
        threshold_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param gain: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        :param gain_var: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        :param sigma: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        :param threshold: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        :param threshold_var: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9cec933295365a284bcdf03af71aa3265ca9580ffbab359d90f3007e66f209ba)
            check_type(argname="argument gain", value=gain, expected_type=type_hints["gain"])
            check_type(argname="argument gain_var", value=gain_var, expected_type=type_hints["gain_var"])
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
            check_type(argname="argument threshold", value=threshold, expected_type=type_hints["threshold"])
            check_type(argname="argument threshold_var", value=threshold_var, expected_type=type_hints["threshold_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if gain is not None:
            self._values["gain"] = gain
        if gain_var is not None:
            self._values["gain_var"] = gain_var
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var
        if threshold is not None:
            self._values["threshold"] = threshold
        if threshold_var is not None:
            self._values["threshold_var"] = threshold_var

    @builtins.property
    def gain(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        '''
        result = self._values.get("gain")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gain_var(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        '''
        result = self._values.get("gain_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        '''
        result = self._values.get("threshold")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold_var(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        result = self._values.get("threshold_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationUnsharpMask(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationUnsharpMaskList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationUnsharpMaskList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__099250d1b38bb26b74d1e59beda7ac681fa6c3d007f227d6bbc0726311621056)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationUnsharpMaskOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d71ae87c13857ee6036d4153378ad905fc9f77143cc1ba0e8b1b2941a26c5e02)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationUnsharpMaskOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__24fd68da97e21105b7d1088bc312769dd422542ca64572a66d52eee89f38a87d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ff45d668d6d65aff1e611166c8594c1474075120d227499bf160cd771e65068)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f03b9e0366d9c62aeac181b76fbffb053b4aaf8d635289baae7712411c462183)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationUnsharpMask]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationUnsharpMask]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationUnsharpMask]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__89a214298377750e03d697098189a3dea7d7194e98692e21d3528019a743d05c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationUnsharpMaskOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationUnsharpMaskOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9b5a28807d4e82f97dedc73427f3a012def5015ef7e0963745c25214cd7a03a1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetGain")
    def reset_gain(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGain", []))

    @jsii.member(jsii_name="resetGainVar")
    def reset_gain_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGainVar", []))

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @jsii.member(jsii_name="resetThreshold")
    def reset_threshold(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThreshold", []))

    @jsii.member(jsii_name="resetThresholdVar")
    def reset_threshold_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThresholdVar", []))

    @builtins.property
    @jsii.member(jsii_name="gainInput")
    def gain_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainInput"))

    @builtins.property
    @jsii.member(jsii_name="gainVarInput")
    def gain_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdInput")
    def threshold_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdVarInput")
    def threshold_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gain")
    def gain(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gain"))

    @gain.setter
    def gain(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ddbcae455eb3bc0a285fd54564acac27b566b96a70baaf3733034b2c595a912)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gain", value)

    @builtins.property
    @jsii.member(jsii_name="gainVar")
    def gain_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gainVar"))

    @gain_var.setter
    def gain_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0a793d9413d9a1eea169d5106152eceeda74520c298f9987a1121abcdc8cd814)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gainVar", value)

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2bac4ba96485659fe804ea494b36b575b20468935acadecbf5356b66489a1e4b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__383e14aa7402a6ad1c98a2ab74f42df2a32e4f1006753c11f06cb637d6a52fab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="threshold")
    def threshold(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "threshold"))

    @threshold.setter
    def threshold(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__89d9991b32ca3d6d9df137fc283a88c773e43a25daf678540f370e7d809b7489)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "threshold", value)

    @builtins.property
    @jsii.member(jsii_name="thresholdVar")
    def threshold_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "thresholdVar"))

    @threshold_var.setter
    def threshold_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__382524699b458a409b991f0a5e9d7749a8ff4ea3007962e23e0b549f7bb63547)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "thresholdVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationUnsharpMask]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationUnsharpMask]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationUnsharpMask]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__31a488b7e24266399457cb50a91df262f4beba2e56e788b488a4c35ed25a61bb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImage",
    jsii_struct_bases=[],
    name_mapping={
        "transformation": "transformation",
        "url": "url",
        "url_var": "urlVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImage:
    def __init__(
        self,
        *,
        transformation: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        url: typing.Optional[builtins.str] = None,
        url_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param transformation: transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        :param url: The URL of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url DataAkamaiImagingPolicyImage#url}
        :param url_var: The URL of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url_var DataAkamaiImagingPolicyImage#url_var}
        '''
        if isinstance(transformation, dict):
            transformation = DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformation(**transformation)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f66e3eca7fe860b693bcc427095a0c5d16d8875138ae0edb64b7b7178298568c)
            check_type(argname="argument transformation", value=transformation, expected_type=type_hints["transformation"])
            check_type(argname="argument url", value=url, expected_type=type_hints["url"])
            check_type(argname="argument url_var", value=url_var, expected_type=type_hints["url_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if transformation is not None:
            self._values["transformation"] = transformation
        if url is not None:
            self._values["url"] = url
        if url_var is not None:
            self._values["url_var"] = url_var

    @builtins.property
    def transformation(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformation"]:
        '''transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        '''
        result = self._values.get("transformation")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformation"], result)

    @builtins.property
    def url(self) -> typing.Optional[builtins.str]:
        '''The URL of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url DataAkamaiImagingPolicyImage#url}
        '''
        result = self._values.get("url")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def url_var(self) -> typing.Optional[builtins.str]:
        '''The URL of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url_var DataAkamaiImagingPolicyImage#url_var}
        '''
        result = self._values.get("url_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__56728eefc4905328f1d504445c2e50c483ed47785d3b27bfd6b42b31a2562405)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a7a4e530e1e99c5b059c8224475b524b21c612b53a01221fbc5d1a000e3a327)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e349aff20c1d6796a078f2e88aac9af18b9aff8d3585dc9fabc4ecdf60227f12)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9dffa9055ea9428b0f0363c26f6a7f5af84d4f59cea4b0e55d9fbb9e268c9e3c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__449e499654a4ddec8cea0ee7e8a7118f04a41bbccb003841ea12b59681c7b917)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImage]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImage]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImage]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__105795251b088a5a0172e8821037cb5dc825280faa520ac97d18feb571efa4c2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0f5de3558516832109b9b391e299e5b84c75c980f4910a196ccb4a696d927ae3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformation")
    def put_transformation(
        self,
        *,
        append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationAppend", typing.Dict[builtins.str, typing.Any]]]]] = None,
        aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationAspectCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationBackgroundColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationBlur", typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationChromaKey", typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationComposite", typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCompound", typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationContrast", typing.Dict[builtins.str, typing.Any]]]]] = None,
        crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationFaceCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationFeatureCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationFitAndFill", typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationGoop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationGrayscale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationHsl", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationHsv", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimension", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientation", typing.Dict[builtins.str, typing.Any]]]]] = None,
        im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationImQuery", typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationMaxColors", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationMirror", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationMonoHue", typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationOpacity", typing.Dict[builtins.str, typing.Any]]]]] = None,
        region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRegionOfInterestCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRelativeCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRemoveColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationResize", typing.Dict[builtins.str, typing.Any]]]]] = None,
        rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRotate", typing.Dict[builtins.str, typing.Any]]]]] = None,
        scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationScale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationShear", typing.Dict[builtins.str, typing.Any]]]]] = None,
        trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationTrim", typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationUnsharpMask", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param append: append block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        :param aspect_crop: aspect_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param crop: crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        :param face_crop: face_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        :param feature_crop: feature_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        :param fit_and_fill: fit_and_fill block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param im_query: im_query block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param region_of_interest_crop: region_of_interest_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        :param relative_crop: relative_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param resize: resize block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        :param rotate: rotate block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        :param scale: scale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param shear: shear block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        :param trim: trim block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        value = DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformation(
            append=append,
            aspect_crop=aspect_crop,
            background_color=background_color,
            blur=blur,
            chroma_key=chroma_key,
            composite=composite,
            compound=compound,
            contrast=contrast,
            crop=crop,
            face_crop=face_crop,
            feature_crop=feature_crop,
            fit_and_fill=fit_and_fill,
            goop=goop,
            grayscale=grayscale,
            hsl=hsl,
            hsv=hsv,
            if_dimension=if_dimension,
            if_orientation=if_orientation,
            im_query=im_query,
            max_colors=max_colors,
            mirror=mirror,
            mono_hue=mono_hue,
            opacity=opacity,
            region_of_interest_crop=region_of_interest_crop,
            relative_crop=relative_crop,
            remove_color=remove_color,
            resize=resize,
            rotate=rotate,
            scale=scale,
            shear=shear,
            trim=trim,
            unsharp_mask=unsharp_mask,
        )

        return typing.cast(None, jsii.invoke(self, "putTransformation", [value]))

    @jsii.member(jsii_name="resetTransformation")
    def reset_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformation", []))

    @jsii.member(jsii_name="resetUrl")
    def reset_url(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUrl", []))

    @jsii.member(jsii_name="resetUrlVar")
    def reset_url_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUrlVar", []))

    @builtins.property
    @jsii.member(jsii_name="transformation")
    def transformation(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationOutputReference", jsii.get(self, "transformation"))

    @builtins.property
    @jsii.member(jsii_name="transformationInput")
    def transformation_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformation"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformation"], jsii.get(self, "transformationInput"))

    @builtins.property
    @jsii.member(jsii_name="urlInput")
    def url_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "urlInput"))

    @builtins.property
    @jsii.member(jsii_name="urlVarInput")
    def url_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "urlVarInput"))

    @builtins.property
    @jsii.member(jsii_name="url")
    def url(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "url"))

    @url.setter
    def url(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f781c66fa99955fb8314eb0201e5f4949d95f08488ca0443a7cf081d3a493182)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "url", value)

    @builtins.property
    @jsii.member(jsii_name="urlVar")
    def url_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "urlVar"))

    @url_var.setter
    def url_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0efaa17cb27888ab95b40a12ef35741fa312606f52bc8be39fdb13917f48d0cd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "urlVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImage]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImage]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImage]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__17db799594c5900bd57b1b5b4959b0d5f0f0f3019081d10acdbb1fef55424dc4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformation",
    jsii_struct_bases=[],
    name_mapping={
        "append": "append",
        "aspect_crop": "aspectCrop",
        "background_color": "backgroundColor",
        "blur": "blur",
        "chroma_key": "chromaKey",
        "composite": "composite",
        "compound": "compound",
        "contrast": "contrast",
        "crop": "crop",
        "face_crop": "faceCrop",
        "feature_crop": "featureCrop",
        "fit_and_fill": "fitAndFill",
        "goop": "goop",
        "grayscale": "grayscale",
        "hsl": "hsl",
        "hsv": "hsv",
        "if_dimension": "ifDimension",
        "if_orientation": "ifOrientation",
        "im_query": "imQuery",
        "max_colors": "maxColors",
        "mirror": "mirror",
        "mono_hue": "monoHue",
        "opacity": "opacity",
        "region_of_interest_crop": "regionOfInterestCrop",
        "relative_crop": "relativeCrop",
        "remove_color": "removeColor",
        "resize": "resize",
        "rotate": "rotate",
        "scale": "scale",
        "shear": "shear",
        "trim": "trim",
        "unsharp_mask": "unsharpMask",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformation:
    def __init__(
        self,
        *,
        append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationAppend", typing.Dict[builtins.str, typing.Any]]]]] = None,
        aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationAspectCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationBackgroundColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationBlur", typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationChromaKey", typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationComposite", typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCompound", typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationContrast", typing.Dict[builtins.str, typing.Any]]]]] = None,
        crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationFaceCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationFeatureCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationFitAndFill", typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationGoop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationGrayscale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationHsl", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationHsv", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimension", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientation", typing.Dict[builtins.str, typing.Any]]]]] = None,
        im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationImQuery", typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationMaxColors", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationMirror", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationMonoHue", typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationOpacity", typing.Dict[builtins.str, typing.Any]]]]] = None,
        region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRegionOfInterestCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRelativeCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRemoveColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationResize", typing.Dict[builtins.str, typing.Any]]]]] = None,
        rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRotate", typing.Dict[builtins.str, typing.Any]]]]] = None,
        scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationScale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationShear", typing.Dict[builtins.str, typing.Any]]]]] = None,
        trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationTrim", typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationUnsharpMask", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param append: append block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        :param aspect_crop: aspect_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param crop: crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        :param face_crop: face_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        :param feature_crop: feature_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        :param fit_and_fill: fit_and_fill block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param im_query: im_query block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param region_of_interest_crop: region_of_interest_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        :param relative_crop: relative_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param resize: resize block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        :param rotate: rotate block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        :param scale: scale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param shear: shear block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        :param trim: trim block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d46067ed6bf71aac47723539dba1fd774ec17137dc770e8ed93f314247ce0e11)
            check_type(argname="argument append", value=append, expected_type=type_hints["append"])
            check_type(argname="argument aspect_crop", value=aspect_crop, expected_type=type_hints["aspect_crop"])
            check_type(argname="argument background_color", value=background_color, expected_type=type_hints["background_color"])
            check_type(argname="argument blur", value=blur, expected_type=type_hints["blur"])
            check_type(argname="argument chroma_key", value=chroma_key, expected_type=type_hints["chroma_key"])
            check_type(argname="argument composite", value=composite, expected_type=type_hints["composite"])
            check_type(argname="argument compound", value=compound, expected_type=type_hints["compound"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument crop", value=crop, expected_type=type_hints["crop"])
            check_type(argname="argument face_crop", value=face_crop, expected_type=type_hints["face_crop"])
            check_type(argname="argument feature_crop", value=feature_crop, expected_type=type_hints["feature_crop"])
            check_type(argname="argument fit_and_fill", value=fit_and_fill, expected_type=type_hints["fit_and_fill"])
            check_type(argname="argument goop", value=goop, expected_type=type_hints["goop"])
            check_type(argname="argument grayscale", value=grayscale, expected_type=type_hints["grayscale"])
            check_type(argname="argument hsl", value=hsl, expected_type=type_hints["hsl"])
            check_type(argname="argument hsv", value=hsv, expected_type=type_hints["hsv"])
            check_type(argname="argument if_dimension", value=if_dimension, expected_type=type_hints["if_dimension"])
            check_type(argname="argument if_orientation", value=if_orientation, expected_type=type_hints["if_orientation"])
            check_type(argname="argument im_query", value=im_query, expected_type=type_hints["im_query"])
            check_type(argname="argument max_colors", value=max_colors, expected_type=type_hints["max_colors"])
            check_type(argname="argument mirror", value=mirror, expected_type=type_hints["mirror"])
            check_type(argname="argument mono_hue", value=mono_hue, expected_type=type_hints["mono_hue"])
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument region_of_interest_crop", value=region_of_interest_crop, expected_type=type_hints["region_of_interest_crop"])
            check_type(argname="argument relative_crop", value=relative_crop, expected_type=type_hints["relative_crop"])
            check_type(argname="argument remove_color", value=remove_color, expected_type=type_hints["remove_color"])
            check_type(argname="argument resize", value=resize, expected_type=type_hints["resize"])
            check_type(argname="argument rotate", value=rotate, expected_type=type_hints["rotate"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument shear", value=shear, expected_type=type_hints["shear"])
            check_type(argname="argument trim", value=trim, expected_type=type_hints["trim"])
            check_type(argname="argument unsharp_mask", value=unsharp_mask, expected_type=type_hints["unsharp_mask"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if append is not None:
            self._values["append"] = append
        if aspect_crop is not None:
            self._values["aspect_crop"] = aspect_crop
        if background_color is not None:
            self._values["background_color"] = background_color
        if blur is not None:
            self._values["blur"] = blur
        if chroma_key is not None:
            self._values["chroma_key"] = chroma_key
        if composite is not None:
            self._values["composite"] = composite
        if compound is not None:
            self._values["compound"] = compound
        if contrast is not None:
            self._values["contrast"] = contrast
        if crop is not None:
            self._values["crop"] = crop
        if face_crop is not None:
            self._values["face_crop"] = face_crop
        if feature_crop is not None:
            self._values["feature_crop"] = feature_crop
        if fit_and_fill is not None:
            self._values["fit_and_fill"] = fit_and_fill
        if goop is not None:
            self._values["goop"] = goop
        if grayscale is not None:
            self._values["grayscale"] = grayscale
        if hsl is not None:
            self._values["hsl"] = hsl
        if hsv is not None:
            self._values["hsv"] = hsv
        if if_dimension is not None:
            self._values["if_dimension"] = if_dimension
        if if_orientation is not None:
            self._values["if_orientation"] = if_orientation
        if im_query is not None:
            self._values["im_query"] = im_query
        if max_colors is not None:
            self._values["max_colors"] = max_colors
        if mirror is not None:
            self._values["mirror"] = mirror
        if mono_hue is not None:
            self._values["mono_hue"] = mono_hue
        if opacity is not None:
            self._values["opacity"] = opacity
        if region_of_interest_crop is not None:
            self._values["region_of_interest_crop"] = region_of_interest_crop
        if relative_crop is not None:
            self._values["relative_crop"] = relative_crop
        if remove_color is not None:
            self._values["remove_color"] = remove_color
        if resize is not None:
            self._values["resize"] = resize
        if rotate is not None:
            self._values["rotate"] = rotate
        if scale is not None:
            self._values["scale"] = scale
        if shear is not None:
            self._values["shear"] = shear
        if trim is not None:
            self._values["trim"] = trim
        if unsharp_mask is not None:
            self._values["unsharp_mask"] = unsharp_mask

    @builtins.property
    def append(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationAppend"]]]:
        '''append block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        '''
        result = self._values.get("append")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationAppend"]]], result)

    @builtins.property
    def aspect_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationAspectCrop"]]]:
        '''aspect_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        '''
        result = self._values.get("aspect_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationAspectCrop"]]], result)

    @builtins.property
    def background_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationBackgroundColor"]]]:
        '''background_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        '''
        result = self._values.get("background_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationBackgroundColor"]]], result)

    @builtins.property
    def blur(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationBlur"]]]:
        '''blur block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        '''
        result = self._values.get("blur")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationBlur"]]], result)

    @builtins.property
    def chroma_key(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationChromaKey"]]]:
        '''chroma_key block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        '''
        result = self._values.get("chroma_key")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationChromaKey"]]], result)

    @builtins.property
    def composite(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationComposite"]]]:
        '''composite block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        '''
        result = self._values.get("composite")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationComposite"]]], result)

    @builtins.property
    def compound(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCompound"]]]:
        '''compound block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        '''
        result = self._values.get("compound")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCompound"]]], result)

    @builtins.property
    def contrast(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationContrast"]]]:
        '''contrast block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationContrast"]]], result)

    @builtins.property
    def crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCrop"]]]:
        '''crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        '''
        result = self._values.get("crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCrop"]]], result)

    @builtins.property
    def face_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationFaceCrop"]]]:
        '''face_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        '''
        result = self._values.get("face_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationFaceCrop"]]], result)

    @builtins.property
    def feature_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationFeatureCrop"]]]:
        '''feature_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        '''
        result = self._values.get("feature_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationFeatureCrop"]]], result)

    @builtins.property
    def fit_and_fill(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationFitAndFill"]]]:
        '''fit_and_fill block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        '''
        result = self._values.get("fit_and_fill")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationFitAndFill"]]], result)

    @builtins.property
    def goop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationGoop"]]]:
        '''goop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        '''
        result = self._values.get("goop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationGoop"]]], result)

    @builtins.property
    def grayscale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationGrayscale"]]]:
        '''grayscale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        '''
        result = self._values.get("grayscale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationGrayscale"]]], result)

    @builtins.property
    def hsl(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationHsl"]]]:
        '''hsl block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        '''
        result = self._values.get("hsl")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationHsl"]]], result)

    @builtins.property
    def hsv(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationHsv"]]]:
        '''hsv block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        '''
        result = self._values.get("hsv")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationHsv"]]], result)

    @builtins.property
    def if_dimension(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimension"]]]:
        '''if_dimension block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        '''
        result = self._values.get("if_dimension")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimension"]]], result)

    @builtins.property
    def if_orientation(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientation"]]]:
        '''if_orientation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        '''
        result = self._values.get("if_orientation")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientation"]]], result)

    @builtins.property
    def im_query(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationImQuery"]]]:
        '''im_query block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        '''
        result = self._values.get("im_query")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationImQuery"]]], result)

    @builtins.property
    def max_colors(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationMaxColors"]]]:
        '''max_colors block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        '''
        result = self._values.get("max_colors")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationMaxColors"]]], result)

    @builtins.property
    def mirror(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationMirror"]]]:
        '''mirror block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        '''
        result = self._values.get("mirror")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationMirror"]]], result)

    @builtins.property
    def mono_hue(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationMonoHue"]]]:
        '''mono_hue block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        '''
        result = self._values.get("mono_hue")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationMonoHue"]]], result)

    @builtins.property
    def opacity(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationOpacity"]]]:
        '''opacity block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationOpacity"]]], result)

    @builtins.property
    def region_of_interest_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRegionOfInterestCrop"]]]:
        '''region_of_interest_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        '''
        result = self._values.get("region_of_interest_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRegionOfInterestCrop"]]], result)

    @builtins.property
    def relative_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRelativeCrop"]]]:
        '''relative_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        '''
        result = self._values.get("relative_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRelativeCrop"]]], result)

    @builtins.property
    def remove_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRemoveColor"]]]:
        '''remove_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        '''
        result = self._values.get("remove_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRemoveColor"]]], result)

    @builtins.property
    def resize(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationResize"]]]:
        '''resize block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        '''
        result = self._values.get("resize")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationResize"]]], result)

    @builtins.property
    def rotate(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRotate"]]]:
        '''rotate block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        '''
        result = self._values.get("rotate")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRotate"]]], result)

    @builtins.property
    def scale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationScale"]]]:
        '''scale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationScale"]]], result)

    @builtins.property
    def shear(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationShear"]]]:
        '''shear block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        '''
        result = self._values.get("shear")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationShear"]]], result)

    @builtins.property
    def trim(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationTrim"]]]:
        '''trim block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        '''
        result = self._values.get("trim")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationTrim"]]], result)

    @builtins.property
    def unsharp_mask(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationUnsharpMask"]]]:
        '''unsharp_mask block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        result = self._values.get("unsharp_mask")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationUnsharpMask"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationAppend",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_priority": "gravityPriority",
        "gravity_priority_var": "gravityPriorityVar",
        "gravity_var": "gravityVar",
        "preserve_minor_dimension": "preserveMinorDimension",
        "preserve_minor_dimension_var": "preserveMinorDimensionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationAppend:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationAppendImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_priority: typing.Optional[builtins.str] = None,
        gravity_priority_var: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        preserve_minor_dimension: typing.Optional[builtins.str] = None,
        preserve_minor_dimension_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Specifies where to place the ``image`` relative to the source image. The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_priority: Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal. The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority DataAkamaiImagingPolicyImage#gravity_priority}
        :param gravity_priority_var: Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal. The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority_var DataAkamaiImagingPolicyImage#gravity_priority_var}
        :param gravity_var: Specifies where to place the ``image`` relative to the source image. The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param preserve_minor_dimension: Whether to preserve the source image's minor dimension, ``false`` by default. The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension DataAkamaiImagingPolicyImage#preserve_minor_dimension}
        :param preserve_minor_dimension_var: Whether to preserve the source image's minor dimension, ``false`` by default. The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension_var DataAkamaiImagingPolicyImage#preserve_minor_dimension_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationAppendImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__28327db453dd9304855c66529c972257c68e7ec3a73d08c60be007177ead90dc)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_priority", value=gravity_priority, expected_type=type_hints["gravity_priority"])
            check_type(argname="argument gravity_priority_var", value=gravity_priority_var, expected_type=type_hints["gravity_priority_var"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument preserve_minor_dimension", value=preserve_minor_dimension, expected_type=type_hints["preserve_minor_dimension"])
            check_type(argname="argument preserve_minor_dimension_var", value=preserve_minor_dimension_var, expected_type=type_hints["preserve_minor_dimension_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_priority is not None:
            self._values["gravity_priority"] = gravity_priority
        if gravity_priority_var is not None:
            self._values["gravity_priority_var"] = gravity_priority_var
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if preserve_minor_dimension is not None:
            self._values["preserve_minor_dimension"] = preserve_minor_dimension
        if preserve_minor_dimension_var is not None:
            self._values["preserve_minor_dimension_var"] = preserve_minor_dimension_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationAppendImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationAppendImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Specifies where to place the ``image`` relative to the source image.

        The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_priority(self) -> typing.Optional[builtins.str]:
        '''Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal.

        The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority DataAkamaiImagingPolicyImage#gravity_priority}
        '''
        result = self._values.get("gravity_priority")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_priority_var(self) -> typing.Optional[builtins.str]:
        '''Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal.

        The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority_var DataAkamaiImagingPolicyImage#gravity_priority_var}
        '''
        result = self._values.get("gravity_priority_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Specifies where to place the ``image`` relative to the source image.

        The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def preserve_minor_dimension(self) -> typing.Optional[builtins.str]:
        '''Whether to preserve the source image's minor dimension, ``false`` by default.

        The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension DataAkamaiImagingPolicyImage#preserve_minor_dimension}
        '''
        result = self._values.get("preserve_minor_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def preserve_minor_dimension_var(self) -> typing.Optional[builtins.str]:
        '''Whether to preserve the source image's minor dimension, ``false`` by default.

        The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension_var DataAkamaiImagingPolicyImage#preserve_minor_dimension_var}
        '''
        result = self._values.get("preserve_minor_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationAppend(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationAppendImage",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationAppendImage:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationAppendImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationAppendImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationAppendImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd892860f69c98384a0e0a4ea2e2ee4d024fec22c347c619a6b75b4d1617e2e4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationAppendImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationAppendImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationAppendImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a0dec10f3f6e3e73dd3fbb2adbe3bbf79e8545a15d38e8e945b12c0eb893eec0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationAppendList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationAppendList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__414fd6c6d33c3aa275f8d3f3d53ddfaf9bc89da4d438e34dbeed2a79f19641bc)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationAppendOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dacd53d5d1d4fdd3659ccb7acd86c87ac396421fa1191bbaa858e0adbe4abb7c)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationAppendOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac2387651c2be0e4ca5131c3aae0761b37d94a3d3a82c078b34237915f228e78)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f0f7dcb11d6fe135c7f17ff307d8920e9874e0ee1d2a37d59a4bd470f3eca19f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d7698edb6c32a1fc4abda9673afbf70dd978773690dd98dd67372fc5d7147ecd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationAppend]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationAppend]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationAppend]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8740ebf7fc15fba9666ae491c3d6c84c5452132174174141680c82364e80270e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationAppendOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationAppendOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f2b327581dd22245419c81f14173e4aa2b40a02ecd4635d0de66017fad2eac98)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationAppendImage()

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityPriority")
    def reset_gravity_priority(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityPriority", []))

    @jsii.member(jsii_name="resetGravityPriorityVar")
    def reset_gravity_priority_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityPriorityVar", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPreserveMinorDimension")
    def reset_preserve_minor_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPreserveMinorDimension", []))

    @jsii.member(jsii_name="resetPreserveMinorDimensionVar")
    def reset_preserve_minor_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPreserveMinorDimensionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationAppendImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationAppendImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityInput")
    def gravity_priority_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityPriorityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityVarInput")
    def gravity_priority_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityPriorityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationAppendImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationAppendImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionInput")
    def preserve_minor_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "preserveMinorDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionVarInput")
    def preserve_minor_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "preserveMinorDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6cc6a65f020d4e02d73601ca68c7f0ee5c307f5437dd28cb99f2511e15fddab2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityPriority")
    def gravity_priority(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityPriority"))

    @gravity_priority.setter
    def gravity_priority(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__16ac1cbb0d72ae76daf1bbe6c0b0f8fb64d00bed182155db02168c19b0f76ea6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityPriority", value)

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityVar")
    def gravity_priority_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityPriorityVar"))

    @gravity_priority_var.setter
    def gravity_priority_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dc232dbe0ae1240fe8704cd83a16b43adfe1cb89ae77772e9a482734c6d5691c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityPriorityVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c8f879f9c2237123b416d671b69d6ee2dc9229de7494263a4857e55c2b1dfe2b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimension")
    def preserve_minor_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "preserveMinorDimension"))

    @preserve_minor_dimension.setter
    def preserve_minor_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__70a29ffaba78728329fc369fd753bbbc0f9bf02862fe637475406d05a3818032)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "preserveMinorDimension", value)

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionVar")
    def preserve_minor_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "preserveMinorDimensionVar"))

    @preserve_minor_dimension_var.setter
    def preserve_minor_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d2a62c9963725d80ea81f7a6b1dd72f482507121638938f188a9b0da02db7139)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "preserveMinorDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationAppend]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationAppend]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationAppend]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__05b5c2fab175e7bb9826218df2c51aa7b601d94d2df27ce90340c8c5a9b14893)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationAspectCrop",
    jsii_struct_bases=[],
    name_mapping={
        "allow_expansion": "allowExpansion",
        "allow_expansion_var": "allowExpansionVar",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationAspectCrop:
    def __init__(
        self,
        *,
        allow_expansion: typing.Optional[builtins.str] = None,
        allow_expansion_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_expansion: Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image. Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        :param allow_expansion_var: Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image. Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        :param height: The height term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The width term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        :param x_position: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a7dc777fa49aa25dada377f8bfdb9613b8158e0ea2b808f5f692c9a07e635a42)
            check_type(argname="argument allow_expansion", value=allow_expansion, expected_type=type_hints["allow_expansion"])
            check_type(argname="argument allow_expansion_var", value=allow_expansion_var, expected_type=type_hints["allow_expansion_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if allow_expansion is not None:
            self._values["allow_expansion"] = allow_expansion
        if allow_expansion_var is not None:
            self._values["allow_expansion_var"] = allow_expansion_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def allow_expansion(self) -> typing.Optional[builtins.str]:
        '''Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image.

        Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        '''
        result = self._values.get("allow_expansion")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def allow_expansion_var(self) -> typing.Optional[builtins.str]:
        '''Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image.

        Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        '''
        result = self._values.get("allow_expansion_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationAspectCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationAspectCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationAspectCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__73ff5a2efec3c3e381573f4a889bd016f520a327969ab47f3bc051158e93570d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationAspectCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0af1b3087bafc9c775fd228c1092e1cd953a88a0269f799991d47994a909f896)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationAspectCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5dac497fe97980e2e422f528d6a4a71b9d81e1873c9222add5cd7c75bbdf1fe2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__951c15111ec6192ccd5758a0f20e58ecbfde3428760d3f34c2895bb7f58ba628)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d178d3b38722ccac5699409f2eb5cc7ed717f9b8d8c503bb0d828264768bf77e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationAspectCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationAspectCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationAspectCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5d73c4f92650ee858422953426f190dbae6bda5110525d7a3202b1ebe39687e5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationAspectCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationAspectCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2e4882df6a411ad973ef09d7b482590c30627932e3aa05c843e1ed1f6abbe2c0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAllowExpansion")
    def reset_allow_expansion(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansion", []))

    @jsii.member(jsii_name="resetAllowExpansionVar")
    def reset_allow_expansion_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansionVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionInput")
    def allow_expansion_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVarInput")
    def allow_expansion_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansion")
    def allow_expansion(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansion"))

    @allow_expansion.setter
    def allow_expansion(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__baa7f363405461938dc4e78116ea2339b30c396430ac39e6c8c054b926496009)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansion", value)

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVar")
    def allow_expansion_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansionVar"))

    @allow_expansion_var.setter
    def allow_expansion_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eafb0e1e83b5213b448e2063dc4178cce1ee99478daf6f7f433144771bf08079)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansionVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__78e8443a521b6b4ebc8f8b05b1e15f58c67509009de4ec53dcc053adbe842a7c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc6d8055034f27ed8b3adc02fd13505ebe190b9f006f241eadd6ef0bd6f83ecb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8cd134f189118125802086e2ddfddc0159091b1781e25bf7da0272519151b705)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__efd05be02ee336c4aaeadc36bd0cfe86243263d0f55a89b56d729aff5a07c75d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5cdc67d908bf9c68b8a56e22e758501aa98682ed74e765be298e2d65d830f75c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c3c4775a713182e107d9532f49ee2acc8a0116c992de0d13a49e363774fa0b4d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0f20f3b936bbaf2ff182f3ed634ee418e09039bce7bee5106f8d94ac59c8fdc8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__20e5766deeae134e6b88df4be02ec5fac9bfcedc53038bb80f290a94ff827e4a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationAspectCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationAspectCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationAspectCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6657d768b79624937d1f217ab4af0d7028a9e3b9cb85f685c474b4a267afa5e4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationBackgroundColor",
    jsii_struct_bases=[],
    name_mapping={"color": "color", "color_var": "colorVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationBackgroundColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5fac844bbc113f9968cb2bf29f45f33808636b581a1c2e7bd54deb110d0e07b0)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationBackgroundColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationBackgroundColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationBackgroundColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__20d06df67830b0c56fb794af22105e476e4740b45c986283bb94a4a626a1bb65)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationBackgroundColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__da9987ae7f23c8994fbb930d5803bfdcbff05556ff6bd4b8a79e82e5ff1882ba)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationBackgroundColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__45cc967c21ce76673ea8e180b4dfcce7b9c278232558aead3b62ab6edf57fc83)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a11a25d297881919717fb25f59899b9944cf240a17c81bedaf7c4983e7ee460)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__87ed49ad36da886ef6ae34bf5f32b19966b342817343b1ce3446c3ff1a9c89a2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationBackgroundColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationBackgroundColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c8ebe9dd4318a8678b969b1966c7b4e2c54be797f157f8372b843d626fd11023)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationBackgroundColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationBackgroundColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d5a23ac43168325152ea07f3fb4e34b7ba030cfd1ec8fe014fd37dcdccda848)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__efe6e486f7e9bd911ec9c38e167a1ff010d01fb754648f79fb49083259deecd6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__36378591e86ba9ad5a32078badfb0b3de760588e060429ea1359f7c05ba5d3fc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationBackgroundColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationBackgroundColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationBackgroundColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cf7c3e8b0e2c498b97039b3b0934a942fff8ee97023d4f76c1fb2893ca64d27c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationBlur",
    jsii_struct_bases=[],
    name_mapping={"sigma": "sigma", "sigma_var": "sigmaVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationBlur:
    def __init__(
        self,
        *,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param sigma: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d329d8a217b5925ada33d89653c8d068d18836f53446b9a9a59a5ebeed013eb)
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationBlur(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationBlurList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationBlurList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3d7b2a9e123d44afbe54e30e74785713c193181fb114600a94c443ec667e120b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationBlurOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7aa7349d3b24d54fbca302f4115fd2ddee734b5ffa19d4422d6baf27a6365e05)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationBlurOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__327c637c66e07d4b1f8ed9ee74ca46c5d3f295db3495820ef12d9db6e35dd2e1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b5d1aae28bf79ab98e00372d5b5841df6ea8ad31f828fe5af24057156f551f0d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__56e5eb1098896d1499524742184a66fa2109d80efb2f35d419797e1e05150e93)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationBlur]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationBlur]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6d766e26702520552ea404cc228e90e326ad4b13e3bbb3ccedf6faac6e4886d5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationBlurOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationBlurOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9130f87a93f53a40f9c02d699ae1e7be6151b918e2a38600ebf75310b4962eda)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a30cf6f11507445c4a0ec0271ce9aa15b03dddd29ff6b4a769805b8017be51c6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__892e4aa810d620ba7b7da9142b9d9e491028e3b6a31b50be421eb87038539c69)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationBlur]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationBlur]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationBlur]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__28d619f57d09ef2ecd6a1f0dc2ad2a3f36b6d1fc6f545aad22c26100c885ca2c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationChromaKey",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_feather": "hueFeather",
        "hue_feather_var": "hueFeatherVar",
        "hue_tolerance": "hueTolerance",
        "hue_tolerance_var": "hueToleranceVar",
        "hue_var": "hueVar",
        "lightness_feather": "lightnessFeather",
        "lightness_feather_var": "lightnessFeatherVar",
        "lightness_tolerance": "lightnessTolerance",
        "lightness_tolerance_var": "lightnessToleranceVar",
        "saturation_feather": "saturationFeather",
        "saturation_feather_var": "saturationFeatherVar",
        "saturation_tolerance": "saturationTolerance",
        "saturation_tolerance_var": "saturationToleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationChromaKey:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_feather: typing.Optional[builtins.str] = None,
        hue_feather_var: typing.Optional[builtins.str] = None,
        hue_tolerance: typing.Optional[builtins.str] = None,
        hue_tolerance_var: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness_feather: typing.Optional[builtins.str] = None,
        lightness_feather_var: typing.Optional[builtins.str] = None,
        lightness_tolerance: typing.Optional[builtins.str] = None,
        lightness_tolerance_var: typing.Optional[builtins.str] = None,
        saturation_feather: typing.Optional[builtins.str] = None,
        saturation_feather_var: typing.Optional[builtins.str] = None,
        saturation_tolerance: typing.Optional[builtins.str] = None,
        saturation_tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_feather: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        :param hue_feather_var: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        :param hue_tolerance: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        :param hue_tolerance_var: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        :param hue_var: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness_feather: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        :param lightness_feather_var: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        :param lightness_tolerance: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        :param lightness_tolerance_var: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        :param saturation_feather: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        :param saturation_feather_var: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        :param saturation_tolerance: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        :param saturation_tolerance_var: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__38f86639343269af5b8eaf1d484105242b82dd8b863ab2ee7cbb8cdc2e6a84c0)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_feather", value=hue_feather, expected_type=type_hints["hue_feather"])
            check_type(argname="argument hue_feather_var", value=hue_feather_var, expected_type=type_hints["hue_feather_var"])
            check_type(argname="argument hue_tolerance", value=hue_tolerance, expected_type=type_hints["hue_tolerance"])
            check_type(argname="argument hue_tolerance_var", value=hue_tolerance_var, expected_type=type_hints["hue_tolerance_var"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness_feather", value=lightness_feather, expected_type=type_hints["lightness_feather"])
            check_type(argname="argument lightness_feather_var", value=lightness_feather_var, expected_type=type_hints["lightness_feather_var"])
            check_type(argname="argument lightness_tolerance", value=lightness_tolerance, expected_type=type_hints["lightness_tolerance"])
            check_type(argname="argument lightness_tolerance_var", value=lightness_tolerance_var, expected_type=type_hints["lightness_tolerance_var"])
            check_type(argname="argument saturation_feather", value=saturation_feather, expected_type=type_hints["saturation_feather"])
            check_type(argname="argument saturation_feather_var", value=saturation_feather_var, expected_type=type_hints["saturation_feather_var"])
            check_type(argname="argument saturation_tolerance", value=saturation_tolerance, expected_type=type_hints["saturation_tolerance"])
            check_type(argname="argument saturation_tolerance_var", value=saturation_tolerance_var, expected_type=type_hints["saturation_tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_feather is not None:
            self._values["hue_feather"] = hue_feather
        if hue_feather_var is not None:
            self._values["hue_feather_var"] = hue_feather_var
        if hue_tolerance is not None:
            self._values["hue_tolerance"] = hue_tolerance
        if hue_tolerance_var is not None:
            self._values["hue_tolerance_var"] = hue_tolerance_var
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness_feather is not None:
            self._values["lightness_feather"] = lightness_feather
        if lightness_feather_var is not None:
            self._values["lightness_feather_var"] = lightness_feather_var
        if lightness_tolerance is not None:
            self._values["lightness_tolerance"] = lightness_tolerance
        if lightness_tolerance_var is not None:
            self._values["lightness_tolerance_var"] = lightness_tolerance_var
        if saturation_feather is not None:
            self._values["saturation_feather"] = saturation_feather
        if saturation_feather_var is not None:
            self._values["saturation_feather_var"] = saturation_feather_var
        if saturation_tolerance is not None:
            self._values["saturation_tolerance"] = saturation_tolerance
        if saturation_tolerance_var is not None:
            self._values["saturation_tolerance_var"] = saturation_tolerance_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        '''
        result = self._values.get("hue_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        '''
        result = self._values.get("hue_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        '''
        result = self._values.get("hue_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        '''
        result = self._values.get("hue_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        '''
        result = self._values.get("lightness_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        '''
        result = self._values.get("lightness_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        '''
        result = self._values.get("lightness_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        '''
        result = self._values.get("lightness_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        '''
        result = self._values.get("saturation_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        '''
        result = self._values.get("saturation_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        '''
        result = self._values.get("saturation_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        result = self._values.get("saturation_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationChromaKey(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationChromaKeyList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationChromaKeyList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bbde82c4732be4cf26a362eb026bd51c3c7997d0534316a9e98afc0d45507999)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationChromaKeyOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d2760b12f71a63e6461a4b69311b2d0ba6bef5a4e32190b2b4725a45fcfd91df)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationChromaKeyOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d02e654b806c4e0472c45108e992482cb50a9472d4fbf1183fc6064c7c8b29e1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3d05150a7cd132bb782943b4527883c86c16720df2042bef45cd1380c4dafb85)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2317e36730e8eeb09625eb95a69fea64f3da65add43bd096beaa1ed694594925)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationChromaKey]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationChromaKey]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2c068d667ee30a5ff9ff54454a84abf2fced7f0b6bdc488ec1039178d7f70873)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationChromaKeyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationChromaKeyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c123d54a4183b338a7fe60a57a3bd005e0239d81136812329cf121addbb4fbcd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueFeather")
    def reset_hue_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeather", []))

    @jsii.member(jsii_name="resetHueFeatherVar")
    def reset_hue_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeatherVar", []))

    @jsii.member(jsii_name="resetHueTolerance")
    def reset_hue_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueTolerance", []))

    @jsii.member(jsii_name="resetHueToleranceVar")
    def reset_hue_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueToleranceVar", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightnessFeather")
    def reset_lightness_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeather", []))

    @jsii.member(jsii_name="resetLightnessFeatherVar")
    def reset_lightness_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeatherVar", []))

    @jsii.member(jsii_name="resetLightnessTolerance")
    def reset_lightness_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessTolerance", []))

    @jsii.member(jsii_name="resetLightnessToleranceVar")
    def reset_lightness_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessToleranceVar", []))

    @jsii.member(jsii_name="resetSaturationFeather")
    def reset_saturation_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeather", []))

    @jsii.member(jsii_name="resetSaturationFeatherVar")
    def reset_saturation_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeatherVar", []))

    @jsii.member(jsii_name="resetSaturationTolerance")
    def reset_saturation_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationTolerance", []))

    @jsii.member(jsii_name="resetSaturationToleranceVar")
    def reset_saturation_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherInput")
    def hue_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVarInput")
    def hue_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceInput")
    def hue_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVarInput")
    def hue_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherInput")
    def lightness_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVarInput")
    def lightness_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceInput")
    def lightness_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVarInput")
    def lightness_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherInput")
    def saturation_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVarInput")
    def saturation_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceInput")
    def saturation_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVarInput")
    def saturation_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__74d22984b014fe04458b649c1ddc5d1b26b02ef787d7a093169b0431ac03a629)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeather")
    def hue_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeather"))

    @hue_feather.setter
    def hue_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f761a0f295302fd346437c1028ee04f5912ac5216f67c09e98cdb52a798d196)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeather", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVar")
    def hue_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeatherVar"))

    @hue_feather_var.setter
    def hue_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__40d7012f2c00433778004fb9a3989260938fc9c6291bda932f980bd129b21b31)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueTolerance")
    def hue_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueTolerance"))

    @hue_tolerance.setter
    def hue_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__72ea2a0f0ddc4b4693159bd6ee63c69ae22cf90f5dc7f3cfff93480d42c95173)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVar")
    def hue_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueToleranceVar"))

    @hue_tolerance_var.setter
    def hue_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__98a6338ea0b13a275ca4b8b8a83075746527bbebacb2c5c28051246d8f3b372e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__52c1fb3dcc601c6f09c2171e8772644a7d3629abb027396b641b8aa4d1cf72c2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeather")
    def lightness_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeather"))

    @lightness_feather.setter
    def lightness_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__451e015f0926e9eb4558e325b594bd8fcdbe6bd324d8d457938b499c5e14c726)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeather", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVar")
    def lightness_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeatherVar"))

    @lightness_feather_var.setter
    def lightness_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9fc1b29268d586b88513ec6cf1b75a7f15e94f344a61462a3fbb63315957c8df)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessTolerance")
    def lightness_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessTolerance"))

    @lightness_tolerance.setter
    def lightness_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aa925658837edea073b4507382bb86e4d28515931c02c030195cf2be59d5a5a8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVar")
    def lightness_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessToleranceVar"))

    @lightness_tolerance_var.setter
    def lightness_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0c481420a2f97ff62e6eb6f1157f7ec12276b21df142b0fa5ec7cd6c205fe85a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeather")
    def saturation_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeather"))

    @saturation_feather.setter
    def saturation_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fdafff43457e9c52f55a3bdc44d45ab0e9b8e9b5605c7b204d207da759d1bdf2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeather", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVar")
    def saturation_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeatherVar"))

    @saturation_feather_var.setter
    def saturation_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a7e2618dc5378166889a9e8b6968ef0ddfd421b0c3c464ff67e1615aabf2a88d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationTolerance")
    def saturation_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationTolerance"))

    @saturation_tolerance.setter
    def saturation_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bbe474c3aa050037e1e7a5cf233b4f39dbb203300361b945bec340c8303a01a8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVar")
    def saturation_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationToleranceVar"))

    @saturation_tolerance_var.setter
    def saturation_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a6f85b6df3a4c478fffc010467a3dcffc188ccabd034c063e23f294e23d75f2d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationChromaKey]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationChromaKey]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationChromaKey]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__487c148d62277c09f48954bfa22e759c337715d63ca0b0af5d8144a948439092)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationComposite",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "placement": "placement",
        "placement_var": "placementVar",
        "scale": "scale",
        "scale_dimension": "scaleDimension",
        "scale_dimension_var": "scaleDimensionVar",
        "scale_var": "scaleVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationComposite:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCompositeImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        placement: typing.Optional[builtins.str] = None,
        placement_var: typing.Optional[builtins.str] = None,
        scale: typing.Optional[builtins.str] = None,
        scale_dimension: typing.Optional[builtins.str] = None,
        scale_dimension_var: typing.Optional[builtins.str] = None,
        scale_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param placement: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        :param placement_var: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        :param scale: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param scale_dimension: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        :param scale_dimension_var: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        :param scale_var: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        :param x_position: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCompositeImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d5597c3cb3a51bf08449bc95978bba54d4f29cdfe6b48d423919a617a392946)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument placement", value=placement, expected_type=type_hints["placement"])
            check_type(argname="argument placement_var", value=placement_var, expected_type=type_hints["placement_var"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument scale_dimension", value=scale_dimension, expected_type=type_hints["scale_dimension"])
            check_type(argname="argument scale_dimension_var", value=scale_dimension_var, expected_type=type_hints["scale_dimension_var"])
            check_type(argname="argument scale_var", value=scale_var, expected_type=type_hints["scale_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if placement is not None:
            self._values["placement"] = placement
        if placement_var is not None:
            self._values["placement_var"] = placement_var
        if scale is not None:
            self._values["scale"] = scale
        if scale_dimension is not None:
            self._values["scale_dimension"] = scale_dimension
        if scale_dimension_var is not None:
            self._values["scale_dimension_var"] = scale_dimension_var
        if scale_var is not None:
            self._values["scale_var"] = scale_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCompositeImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCompositeImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        '''
        result = self._values.get("placement")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement_var(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        '''
        result = self._values.get("placement_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        '''
        result = self._values.get("scale_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        '''
        result = self._values.get("scale_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        '''
        result = self._values.get("scale_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationComposite(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCompositeImage",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCompositeImage:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCompositeImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCompositeImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCompositeImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4c0453a525723378129d006ca843a9cc641eefea23aea66cc904453104438753)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCompositeImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCompositeImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ac103ea433a26413d3ef8ac1965485db763446763913bbaf8620e7ab215e2a7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCompositeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCompositeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b98fcf2782a57864977e8896daae5547cfe491c18f577b31306db120352417f0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCompositeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3d5be0ddff3830e728e1b56fb5dbc62f9935f06e0e3f5dcb24223fbdf94671ac)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCompositeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__55c5a0ad97399ddd5f7df60baa73c1d2a46215d5432915740a2d5d9017364fce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2c9dec57f9e19d4d43750c045ac26b9097ac3606f9b67b9b61f1527196962e3f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__36dfed5046a2d946e86bd11915eb6999b5b360c40ad74d514545bb7fb258e056)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationComposite]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationComposite]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd2e0e25289d375db25ac6e741ab26e44e9a9b699f4b3a3f98d04de76f77b1b1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCompositeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCompositeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5a666da9de00e389081e80f225dd3f79f0896628f49c0ded0a5eefacef4317e1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCompositeImage()

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPlacement")
    def reset_placement(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacement", []))

    @jsii.member(jsii_name="resetPlacementVar")
    def reset_placement_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacementVar", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetScaleDimension")
    def reset_scale_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimension", []))

    @jsii.member(jsii_name="resetScaleDimensionVar")
    def reset_scale_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimensionVar", []))

    @jsii.member(jsii_name="resetScaleVar")
    def reset_scale_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCompositeImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCompositeImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCompositeImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="placementInput")
    def placement_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementInput"))

    @builtins.property
    @jsii.member(jsii_name="placementVarInput")
    def placement_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionInput")
    def scale_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVarInput")
    def scale_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleVarInput")
    def scale_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__973b25c9426b2cbfff2607a0d68288988aa58ec153737ac82311708cf8af46bb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__342f776332d38bbaa5313290da168f52bbf25b01870c755782212cf3337c6c6f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="placement")
    def placement(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placement"))

    @placement.setter
    def placement(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__da6aa0fd79850590bfef67836f59687bd8f18f693a20df1a691ca7d406b4dc6a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placement", value)

    @builtins.property
    @jsii.member(jsii_name="placementVar")
    def placement_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placementVar"))

    @placement_var.setter
    def placement_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea69413beda11401f477121620431a17bf9196c384eaabe1cd53a877b33b51ce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placementVar", value)

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scale"))

    @scale.setter
    def scale(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__193de6df164dce638e4a1277da96349d118bb35b755de4bcac56665b37abef41)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scale", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimension")
    def scale_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimension"))

    @scale_dimension.setter
    def scale_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1d0a03b58a87828d7bf4f749d7a90be3cc0ed8d8d360235315a6a1f65731f05c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimension", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVar")
    def scale_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimensionVar"))

    @scale_dimension_var.setter
    def scale_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ccd19b1bdc90ce2bf206022850c483957370ebc5dca788ca075579bea5aa1349)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="scaleVar")
    def scale_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleVar"))

    @scale_var.setter
    def scale_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3be709719b9a9f6c7a28d509f7ed0297dbc5a714c635786a05617ba25b3af6cd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aa37c93d62083c11821154b77faa077a0df805800bbffb4735be32b31b7910c5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6505fda8e15004368bcbbd3fcd94e29364b56714f38d560022233c66b91575b0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__92106bbb3b56f229913f31957aa58d91945f05bf3677c4465e0d2db6254e10b6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6da58fda8aa597f1ea5bb62d36b0682c013e6391115322c2939953a6a8beb0f5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationComposite]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationComposite]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationComposite]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fe21517afa9b8d96dc5d6cff96a0e8c3b6773f04eeeea38cfaef44702d033090)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCompound",
    jsii_struct_bases=[],
    name_mapping={"transformations": "transformations"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCompound:
    def __init__(
        self,
        *,
        transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param transformations: transformations block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4eada07088d35306a589b1159b5ef01ee5da1c43a9df451637f26673f57283f9)
            check_type(argname="argument transformations", value=transformations, expected_type=type_hints["transformations"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if transformations is not None:
            self._values["transformations"] = transformations

    @builtins.property
    def transformations(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCompoundTransformations"]]]:
        '''transformations block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        result = self._values.get("transformations")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCompoundTransformations"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCompound(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCompoundList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCompoundList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5a1b27453da760baa48806ec561ba9d1de15da0293900c39c33ad17fc787d967)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCompoundOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d55d446f524f6377fef28285832a9cc1e9943a11972eadda600e60fe26492bf4)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCompoundOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b5c55d8712510d6760df87989be9713dfd780d332872f34dba764beb834a2228)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__13999884d93c2b1541cdf70e7bad75ff0a8a9c8c6cd2f1dc320708b1b673b1a7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1d8cb3afee6ab338e9a2275d8b89ca4e14cd0df2aea1a787e303269e8e79f227)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCompound]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCompound]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f26534518aaa56a1a124a589a26e5b6a6e5a47637ee3b6e6a6dcade7e068b03c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCompoundOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCompoundOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9f1db51804ffc90883cdab3ed404e3e3356161d953bbb99c467787b1fc2522d9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformations")
    def put_transformations(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b34a1d7c8f6a190db19653d029a4d362315a88679aae84b7916db3033165a24d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTransformations", [value]))

    @jsii.member(jsii_name="resetTransformations")
    def reset_transformations(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformations", []))

    @builtins.property
    @jsii.member(jsii_name="transformations")
    def transformations(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCompoundTransformationsList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCompoundTransformationsList", jsii.get(self, "transformations"))

    @builtins.property
    @jsii.member(jsii_name="transformationsInput")
    def transformations_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCompoundTransformations"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCompoundTransformations"]]], jsii.get(self, "transformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCompound]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCompound]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCompound]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__319011b9fca4cb392eea32a64837261abfc309d171cfce58e8d17c8d9d1a4b8b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCompoundTransformations",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCompoundTransformations:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCompoundTransformations(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCompoundTransformationsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCompoundTransformationsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__227ec50e71fc031b6f5faf59c730be62520516760a6c5419c11351a17e8b8915)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCompoundTransformationsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9b15e4f5778a53dd049297d748a7b727bf9537f6de48e5cf28288c0d591d8f25)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCompoundTransformationsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__06d97ed55064fd759482159f885723a06fece69e3f430f98a808360cdabdef2f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__657791624b382cf3f052ffe179851f0966c3c30938ea38be06af5e64b378b930)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab64d4ddb45e360805a83e0a1564808c43407a832d59d4009e43ab46dc527f05)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCompoundTransformations]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCompoundTransformations]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCompoundTransformations]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6a47665f88e1c4af6bef9e1a8a81d5a763e5c44723ffe3ef806cd79618e45953)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCompoundTransformationsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCompoundTransformationsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a475e9496546eb96f00d8e0f077ce76b05d5ff04815cf862f2fbd945ab6fd819)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCompoundTransformations]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCompoundTransformations]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCompoundTransformations]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__468535f0a7732438089f19e3b93cad99f52ee93d1be1fe381de2bdf5c5f34d46)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationContrast",
    jsii_struct_bases=[],
    name_mapping={
        "brightness": "brightness",
        "brightness_var": "brightnessVar",
        "contrast": "contrast",
        "contrast_var": "contrastVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationContrast:
    def __init__(
        self,
        *,
        brightness: typing.Optional[builtins.str] = None,
        brightness_var: typing.Optional[builtins.str] = None,
        contrast: typing.Optional[builtins.str] = None,
        contrast_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param brightness: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        :param brightness_var: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        :param contrast: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param contrast_var: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__41833abcd7040621db7ef57649d8e6c8bdee86f8e58c907099138fdc27ebd266)
            check_type(argname="argument brightness", value=brightness, expected_type=type_hints["brightness"])
            check_type(argname="argument brightness_var", value=brightness_var, expected_type=type_hints["brightness_var"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument contrast_var", value=contrast_var, expected_type=type_hints["contrast_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if brightness is not None:
            self._values["brightness"] = brightness
        if brightness_var is not None:
            self._values["brightness_var"] = brightness_var
        if contrast is not None:
            self._values["contrast"] = contrast
        if contrast_var is not None:
            self._values["contrast_var"] = contrast_var

    @builtins.property
    def brightness(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        '''
        result = self._values.get("brightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def brightness_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        '''
        result = self._values.get("brightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        result = self._values.get("contrast_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationContrast(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationContrastList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationContrastList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc27940e509f1878bccd7db80a5017007e5328ab0562b6d847142c455f085397)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationContrastOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__63030a8d4d727146ba56f289bf833a530d6cca4a36a4949ce8a606d257cab929)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationContrastOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__839c18a6da309c1659883260d96088c5e65d2464085a2ac4ce9370afb06e9d5b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d1a6937a4f0b94ae3bc8ead3b201af75d13fa8afb98b1ac8d1f870bd2c98044f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8d8d14d40df4700275a43b1d52e44eae8cb532aea005b8b7c05b8b1525806333)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationContrast]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationContrast]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1052d59d73b42d69031b32f65f6e31c94ced518bed0237b5d32f3f0fcd0ed423)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationContrastOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationContrastOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc759707c2dcf3691fcbdbeca941fd38dbceaa190c020bdaccc0d546af41defc)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetBrightness")
    def reset_brightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightness", []))

    @jsii.member(jsii_name="resetBrightnessVar")
    def reset_brightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightnessVar", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetContrastVar")
    def reset_contrast_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrastVar", []))

    @builtins.property
    @jsii.member(jsii_name="brightnessInput")
    def brightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="brightnessVarInput")
    def brightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastVarInput")
    def contrast_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="brightness")
    def brightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightness"))

    @brightness.setter
    def brightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eeef393b1b0b232bf9d04684aef6c0c351c5afe00d5af8dbf465afb49844f2a6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightness", value)

    @builtins.property
    @jsii.member(jsii_name="brightnessVar")
    def brightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightnessVar"))

    @brightness_var.setter
    def brightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a6933017bd4010cb4ac6add043c3a27d994f47d3ee1d27b57fa0ec4e7188686)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrast"))

    @contrast.setter
    def contrast(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f7f2eac099cd5cfc43826df856a21f4d2e4a96666a624e06fba109fce94865ce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrast", value)

    @builtins.property
    @jsii.member(jsii_name="contrastVar")
    def contrast_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrastVar"))

    @contrast_var.setter
    def contrast_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3e09e64866d8cc3708593acb01b1ae8a2ada4d225123551c3fed6160e093279d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrastVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationContrast]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationContrast]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationContrast]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1a7dad27c4d21f93bf5729b73a27ff3127a042ec23c4bc681c6283772f59042e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCrop",
    jsii_struct_bases=[],
    name_mapping={
        "allow_expansion": "allowExpansion",
        "allow_expansion_var": "allowExpansionVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCrop:
    def __init__(
        self,
        *,
        allow_expansion: typing.Optional[builtins.str] = None,
        allow_expansion_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_expansion: If cropping an area outside of the existing canvas, expands the image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        :param allow_expansion_var: If cropping an area outside of the existing canvas, expands the image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        :param gravity: Frame of reference for X and Y Positions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Frame of reference for X and Y Positions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The number of pixels to crop along the y-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The number of pixels to crop along the y-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The number of pixels to crop along the x-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The number of pixels to crop along the x-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        :param x_position: The x-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4e964e66fc984544f545c96e556d4a15d9a33861afde7bfbb70bc6ddcedd9d83)
            check_type(argname="argument allow_expansion", value=allow_expansion, expected_type=type_hints["allow_expansion"])
            check_type(argname="argument allow_expansion_var", value=allow_expansion_var, expected_type=type_hints["allow_expansion_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if allow_expansion is not None:
            self._values["allow_expansion"] = allow_expansion
        if allow_expansion_var is not None:
            self._values["allow_expansion_var"] = allow_expansion_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def allow_expansion(self) -> typing.Optional[builtins.str]:
        '''If cropping an area outside of the existing canvas, expands the image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        '''
        result = self._values.get("allow_expansion")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def allow_expansion_var(self) -> typing.Optional[builtins.str]:
        '''If cropping an area outside of the existing canvas, expands the image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        '''
        result = self._values.get("allow_expansion_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Frame of reference for X and Y Positions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Frame of reference for X and Y Positions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the y-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the y-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the x-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the x-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1cd07a6525815c857d6c37d17f66b2d2c91dbf0f3117b1c268768831837c6a46)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__83f1a1cec5b60f2287b69adbaeafb410c03ab038ad8e43ac385c3365af90a269)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7fc4f6412f984bded465349d399ddabd5816d0560d88fc73504796b92e8ed3d6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__60386bb8373a5b2d69715d20b440f44c9d09f96c9414fa8091b7bb005af2fbca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__167c7df1e758f242c706de5ebac00dfcdee35a73860d50330f09a47356b00804)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ad8175d25135481c752753d9d599ce7f76d7872fb0cf4f0251d5cd52ee8f7d4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d72409de9fcc627191a4df259bba04e3d9df32ab4d0b0bc7c48633faf815931c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAllowExpansion")
    def reset_allow_expansion(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansion", []))

    @jsii.member(jsii_name="resetAllowExpansionVar")
    def reset_allow_expansion_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansionVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionInput")
    def allow_expansion_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVarInput")
    def allow_expansion_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansion")
    def allow_expansion(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansion"))

    @allow_expansion.setter
    def allow_expansion(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2141cf611d45115739ab3f517fc27f5e472e9f0625aef801bdd7bd5d9900185b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansion", value)

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVar")
    def allow_expansion_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansionVar"))

    @allow_expansion_var.setter
    def allow_expansion_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8fdba869876c6989ab88836a65b31f9cc6229aaf0f7fadf124d660f33fbd6444)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansionVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7060f703f03a48287b49c6cf01f493ea607c97300468d94c047ff7753414d712)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f6cd3cd7721fdcb6f808b069c975939f31c92125189ac8ccd6ab2c3f488afba1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7f343bbd217ea83efc557aef75508bb57d455ad6f018df7ec8f00eb889865d84)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__08d0904c0fd23a8b025551f2f7bfa42e5b4428dcc87712757e029c048d718107)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__09f08a887585c39e72f4c235817c3e52c17eff888ee804716f093466bc3507cc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a58debb9bb2e6ec77651e51ddad963813feced8e63d00df03fc6230f9f2f23f0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bf9612c7e6a345bf13ce2e18d6ac33e7c81420bd74202b4dbbb0d6c59cb64ce7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fbcd921bc90f0a04ba5d2543076b239ec530268abb0a63d051f61a486b7db294)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a6a3d00059575bd744711bea4f0c3b94d71ed85b7259a39571d669b5ffcc873f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__71a622ba33065c61d4ed81c6dcb5feaf6f39ace259db962045c6b9070f988e98)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__140df4d6dfd87ec5832e765a70f14b5fe6cd23ffd336f50aa4ebe09556e5191b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationFaceCrop",
    jsii_struct_bases=[],
    name_mapping={
        "algorithm": "algorithm",
        "algorithm_var": "algorithmVar",
        "confidence": "confidence",
        "confidence_var": "confidenceVar",
        "fail_gravity": "failGravity",
        "fail_gravity_var": "failGravityVar",
        "focus": "focus",
        "focus_var": "focusVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "padding": "padding",
        "padding_var": "paddingVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationFaceCrop:
    def __init__(
        self,
        *,
        algorithm: typing.Optional[builtins.str] = None,
        algorithm_var: typing.Optional[builtins.str] = None,
        confidence: typing.Optional[builtins.str] = None,
        confidence_var: typing.Optional[builtins.str] = None,
        fail_gravity: typing.Optional[builtins.str] = None,
        fail_gravity_var: typing.Optional[builtins.str] = None,
        focus: typing.Optional[builtins.str] = None,
        focus_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param algorithm: Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm DataAkamaiImagingPolicyImage#algorithm}
        :param algorithm_var: Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm_var DataAkamaiImagingPolicyImage#algorithm_var}
        :param confidence: With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image. Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence DataAkamaiImagingPolicyImage#confidence}
        :param confidence_var: With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image. Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence_var DataAkamaiImagingPolicyImage#confidence_var}
        :param fail_gravity: Controls placement of the crop if Image and Video Manager does not detect any faces in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        :param fail_gravity_var: Controls placement of the crop if Image and Video Manager does not detect any faces in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        :param focus: Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus DataAkamaiImagingPolicyImage#focus}
        :param focus_var: Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus_var DataAkamaiImagingPolicyImage#focus_var}
        :param gravity: Controls placement of the crop. Directions are relative to the face(s) plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Controls placement of the crop. Directions are relative to the face(s) plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param padding: The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        :param style: Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b6a20d094cffc37fb3646340f73c847d5b803ecf967829a4b1498d0a9323e78a)
            check_type(argname="argument algorithm", value=algorithm, expected_type=type_hints["algorithm"])
            check_type(argname="argument algorithm_var", value=algorithm_var, expected_type=type_hints["algorithm_var"])
            check_type(argname="argument confidence", value=confidence, expected_type=type_hints["confidence"])
            check_type(argname="argument confidence_var", value=confidence_var, expected_type=type_hints["confidence_var"])
            check_type(argname="argument fail_gravity", value=fail_gravity, expected_type=type_hints["fail_gravity"])
            check_type(argname="argument fail_gravity_var", value=fail_gravity_var, expected_type=type_hints["fail_gravity_var"])
            check_type(argname="argument focus", value=focus, expected_type=type_hints["focus"])
            check_type(argname="argument focus_var", value=focus_var, expected_type=type_hints["focus_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if algorithm is not None:
            self._values["algorithm"] = algorithm
        if algorithm_var is not None:
            self._values["algorithm_var"] = algorithm_var
        if confidence is not None:
            self._values["confidence"] = confidence
        if confidence_var is not None:
            self._values["confidence_var"] = confidence_var
        if fail_gravity is not None:
            self._values["fail_gravity"] = fail_gravity
        if fail_gravity_var is not None:
            self._values["fail_gravity_var"] = fail_gravity_var
        if focus is not None:
            self._values["focus"] = focus
        if focus_var is not None:
            self._values["focus_var"] = focus_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def algorithm(self) -> typing.Optional[builtins.str]:
        '''Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm DataAkamaiImagingPolicyImage#algorithm}
        '''
        result = self._values.get("algorithm")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def algorithm_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm_var DataAkamaiImagingPolicyImage#algorithm_var}
        '''
        result = self._values.get("algorithm_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def confidence(self) -> typing.Optional[builtins.str]:
        '''With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image.

        Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence DataAkamaiImagingPolicyImage#confidence}
        '''
        result = self._values.get("confidence")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def confidence_var(self) -> typing.Optional[builtins.str]:
        '''With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image.

        Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence_var DataAkamaiImagingPolicyImage#confidence_var}
        '''
        result = self._values.get("confidence_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any faces in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        '''
        result = self._values.get("fail_gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any faces in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        '''
        result = self._values.get("fail_gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def focus(self) -> typing.Optional[builtins.str]:
        '''Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus DataAkamaiImagingPolicyImage#focus}
        '''
        result = self._values.get("focus")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def focus_var(self) -> typing.Optional[builtins.str]:
        '''Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus_var DataAkamaiImagingPolicyImage#focus_var}
        '''
        result = self._values.get("focus_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the face(s) plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the face(s) plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationFaceCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationFaceCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationFaceCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d68b07c51964d053b1a36a90ed36af94fb403b42305ce98517673838400c01e5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationFaceCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__49421d0911fed6a52dab95a2379ac8f9a67a5f85c34afe63ef8c1473312855b3)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationFaceCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7f4939fcc220d1703e0b119623141bc02759ebbbd7b68e69338056175b25ba68)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0bf4e2d6a8ebc455f35a2665e47654d3dff7347a8d9baf2cf6c46d1fe301a425)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__443a7245b87aff80b50298c8ddb65061378b4a9f06113c1a8ec43cc7b2f943d9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationFaceCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationFaceCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationFaceCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7775e1092a8d4a338f573013201f4111037bb7834bef7fe97be79b5091b16821)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationFaceCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationFaceCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c467a0042bbcb9428444e12588f0e83aca90c640507dc535dca9464b604a9d73)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAlgorithm")
    def reset_algorithm(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAlgorithm", []))

    @jsii.member(jsii_name="resetAlgorithmVar")
    def reset_algorithm_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAlgorithmVar", []))

    @jsii.member(jsii_name="resetConfidence")
    def reset_confidence(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetConfidence", []))

    @jsii.member(jsii_name="resetConfidenceVar")
    def reset_confidence_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetConfidenceVar", []))

    @jsii.member(jsii_name="resetFailGravity")
    def reset_fail_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravity", []))

    @jsii.member(jsii_name="resetFailGravityVar")
    def reset_fail_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravityVar", []))

    @jsii.member(jsii_name="resetFocus")
    def reset_focus(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFocus", []))

    @jsii.member(jsii_name="resetFocusVar")
    def reset_focus_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFocusVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="algorithmInput")
    def algorithm_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "algorithmInput"))

    @builtins.property
    @jsii.member(jsii_name="algorithmVarInput")
    def algorithm_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "algorithmVarInput"))

    @builtins.property
    @jsii.member(jsii_name="confidenceInput")
    def confidence_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "confidenceInput"))

    @builtins.property
    @jsii.member(jsii_name="confidenceVarInput")
    def confidence_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "confidenceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityInput")
    def fail_gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityVarInput")
    def fail_gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="focusInput")
    def focus_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "focusInput"))

    @builtins.property
    @jsii.member(jsii_name="focusVarInput")
    def focus_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "focusVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="algorithm")
    def algorithm(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "algorithm"))

    @algorithm.setter
    def algorithm(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c2654b11708c9b3bb0a2dc6e53919050cc45818e09e5805ccae17377451237d7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "algorithm", value)

    @builtins.property
    @jsii.member(jsii_name="algorithmVar")
    def algorithm_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "algorithmVar"))

    @algorithm_var.setter
    def algorithm_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8fc52aefd1e5fb6f8af06f209b7eec84e78caa306f4783244d232df9f265f47a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "algorithmVar", value)

    @builtins.property
    @jsii.member(jsii_name="confidence")
    def confidence(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "confidence"))

    @confidence.setter
    def confidence(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cf7657352c74138959561bd6526a87ffb628ebf977293f74c6b2e430ad99d38a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "confidence", value)

    @builtins.property
    @jsii.member(jsii_name="confidenceVar")
    def confidence_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "confidenceVar"))

    @confidence_var.setter
    def confidence_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd62cced23e307a00d0ca8431c256772889cff21488ffa711c23f658564f6e6d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "confidenceVar", value)

    @builtins.property
    @jsii.member(jsii_name="failGravity")
    def fail_gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravity"))

    @fail_gravity.setter
    def fail_gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b1e23be6afa2a2a7239cecd4074700e115e9f29f7e7687355aed83c615103f74)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravity", value)

    @builtins.property
    @jsii.member(jsii_name="failGravityVar")
    def fail_gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravityVar"))

    @fail_gravity_var.setter
    def fail_gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6623a4699e9d857212369430af94c5c743536c77bb2070426682f85e3e197d13)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="focus")
    def focus(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "focus"))

    @focus.setter
    def focus(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5a7c8d4a53547b224db53603a4a5607e95f0469e56b2e0c1e041886824c96600)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "focus", value)

    @builtins.property
    @jsii.member(jsii_name="focusVar")
    def focus_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "focusVar"))

    @focus_var.setter
    def focus_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__87c29a24eac1136aea3cb9ce28c5a8ebf464b29953e2c23bcd9f741df26684a0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "focusVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f5b10cd98c6915b08587868422aea3928c0d0f4a4efe43e8aae73398d7b944a1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__66296dc35ba15bcc6c0643a7cff416a65a7aeef283b9eddf4ac5e40a786f1223)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ca42d52c2213ad2fb8538bdab92d6f7604ebc7f1568f8a9a364a6e99ebd6fab6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8ff28dcc4970b09e1d376104c56f5b7d2a57c6a445f668b1cf8a74b7945e71c4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__794ceec1ea7c81278c66284bd634359c02bdd43f9952f61e9292dc6d86437c82)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d653916137e2bcc820748d3a3ec120f7e435042c83115ed8d6038246ba5d511)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c660269c1aac9c909bb418dabf1d3dd6252a8e07ed9c412096807494b64ce768)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__49f325624f200be593f8efff439f5adb32686b7cb60fb0c2538f3e0d25e6afeb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__26846e0fe2becf22662b6b1a78e22c625bd780736ff4301cb2e793d3d3f63c32)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1720801724ceeb0473784bc306927c6b9dbab19ce35de4c0b65a782ea3b63250)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationFaceCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationFaceCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationFaceCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ae01e337bec96df0c63e150728d0c6303f6858d0b254819065e78fbd7520ae8f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationFeatureCrop",
    jsii_struct_bases=[],
    name_mapping={
        "fail_gravity": "failGravity",
        "fail_gravity_var": "failGravityVar",
        "feature_radius": "featureRadius",
        "feature_radius_var": "featureRadiusVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "max_features": "maxFeatures",
        "max_features_var": "maxFeaturesVar",
        "min_feature_quality": "minFeatureQuality",
        "min_feature_quality_var": "minFeatureQualityVar",
        "padding": "padding",
        "padding_var": "paddingVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationFeatureCrop:
    def __init__(
        self,
        *,
        fail_gravity: typing.Optional[builtins.str] = None,
        fail_gravity_var: typing.Optional[builtins.str] = None,
        feature_radius: typing.Optional[builtins.str] = None,
        feature_radius_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        max_features: typing.Optional[builtins.str] = None,
        max_features_var: typing.Optional[builtins.str] = None,
        min_feature_quality: typing.Optional[builtins.str] = None,
        min_feature_quality_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fail_gravity: Controls placement of the crop if Image and Video Manager does not detect any features in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        :param fail_gravity_var: Controls placement of the crop if Image and Video Manager does not detect any features in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        :param feature_radius: The size in pixels of the important features to search for. If identified, two features never appear closer together than this value, ``8.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius DataAkamaiImagingPolicyImage#feature_radius}
        :param feature_radius_var: The size in pixels of the important features to search for. If identified, two features never appear closer together than this value, ``8.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius_var DataAkamaiImagingPolicyImage#feature_radius_var}
        :param gravity: Controls placement of the crop. Directions are relative to the region of interest plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Controls placement of the crop. Directions are relative to the region of interest plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param max_features: The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features DataAkamaiImagingPolicyImage#max_features}
        :param max_features_var: The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features_var DataAkamaiImagingPolicyImage#max_features_var}
        :param min_feature_quality: Determines the minimum quality level of the feature identified. To consider a feature important, the feature needs to surpass this value. Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality DataAkamaiImagingPolicyImage#min_feature_quality}
        :param min_feature_quality_var: Determines the minimum quality level of the feature identified. To consider a feature important, the feature needs to surpass this value. Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality_var DataAkamaiImagingPolicyImage#min_feature_quality_var}
        :param padding: Adds space around the region of interest. The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: Adds space around the region of interest. The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        :param style: Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__16d2fc9a59d19ceb648a4f7883944a651a710b4e263baa041e4453ce21769d5c)
            check_type(argname="argument fail_gravity", value=fail_gravity, expected_type=type_hints["fail_gravity"])
            check_type(argname="argument fail_gravity_var", value=fail_gravity_var, expected_type=type_hints["fail_gravity_var"])
            check_type(argname="argument feature_radius", value=feature_radius, expected_type=type_hints["feature_radius"])
            check_type(argname="argument feature_radius_var", value=feature_radius_var, expected_type=type_hints["feature_radius_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument max_features", value=max_features, expected_type=type_hints["max_features"])
            check_type(argname="argument max_features_var", value=max_features_var, expected_type=type_hints["max_features_var"])
            check_type(argname="argument min_feature_quality", value=min_feature_quality, expected_type=type_hints["min_feature_quality"])
            check_type(argname="argument min_feature_quality_var", value=min_feature_quality_var, expected_type=type_hints["min_feature_quality_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fail_gravity is not None:
            self._values["fail_gravity"] = fail_gravity
        if fail_gravity_var is not None:
            self._values["fail_gravity_var"] = fail_gravity_var
        if feature_radius is not None:
            self._values["feature_radius"] = feature_radius
        if feature_radius_var is not None:
            self._values["feature_radius_var"] = feature_radius_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if max_features is not None:
            self._values["max_features"] = max_features
        if max_features_var is not None:
            self._values["max_features_var"] = max_features_var
        if min_feature_quality is not None:
            self._values["min_feature_quality"] = min_feature_quality
        if min_feature_quality_var is not None:
            self._values["min_feature_quality_var"] = min_feature_quality_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def fail_gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any features in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        '''
        result = self._values.get("fail_gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any features in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        '''
        result = self._values.get("fail_gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feature_radius(self) -> typing.Optional[builtins.str]:
        '''The size in pixels of the important features to search for.

        If identified, two features never appear closer together than this value, ``8.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius DataAkamaiImagingPolicyImage#feature_radius}
        '''
        result = self._values.get("feature_radius")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feature_radius_var(self) -> typing.Optional[builtins.str]:
        '''The size in pixels of the important features to search for.

        If identified, two features never appear closer together than this value, ``8.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius_var DataAkamaiImagingPolicyImage#feature_radius_var}
        '''
        result = self._values.get("feature_radius_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the region of interest plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the region of interest plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def max_features(self) -> typing.Optional[builtins.str]:
        '''The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features DataAkamaiImagingPolicyImage#max_features}
        '''
        result = self._values.get("max_features")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def max_features_var(self) -> typing.Optional[builtins.str]:
        '''The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features_var DataAkamaiImagingPolicyImage#max_features_var}
        '''
        result = self._values.get("max_features_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def min_feature_quality(self) -> typing.Optional[builtins.str]:
        '''Determines the minimum quality level of the feature identified.

        To consider a feature important, the feature needs to surpass this value.  Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality DataAkamaiImagingPolicyImage#min_feature_quality}
        '''
        result = self._values.get("min_feature_quality")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def min_feature_quality_var(self) -> typing.Optional[builtins.str]:
        '''Determines the minimum quality level of the feature identified.

        To consider a feature important, the feature needs to surpass this value.  Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality_var DataAkamaiImagingPolicyImage#min_feature_quality_var}
        '''
        result = self._values.get("min_feature_quality_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''Adds space around the region of interest.

        The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''Adds space around the region of interest.

        The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationFeatureCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationFeatureCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationFeatureCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ed36c6c48f7233f94aabced4356245f6cfccb98a080c3d0eb9f3f4ba3cb3a24d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationFeatureCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eb7b3092def76366b24ef736495376bd8978d88ac0439665505f3cfedc134091)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationFeatureCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7aa12ac4f8d55914e7c5cb2cfbea2445a106d3cd20098db8150fde4e612bb565)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5983ee89e33c9103b9533b85cf144158fee3b5c0da6805ef9a0b77e8c897cfe9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2206dc6147e3291da917783a3a992af0e1e446595154e9b00fee8c9b3f9e9010)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationFeatureCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationFeatureCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationFeatureCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f8c9a89067a16dedec5911e48bb384c400428c3c8c66d21548ddb62bf7f7c548)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationFeatureCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationFeatureCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eba87b8177f30559aa11f5fd5728013a79d90fd891bcc8caa94206735ffc7601)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetFailGravity")
    def reset_fail_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravity", []))

    @jsii.member(jsii_name="resetFailGravityVar")
    def reset_fail_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravityVar", []))

    @jsii.member(jsii_name="resetFeatureRadius")
    def reset_feature_radius(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureRadius", []))

    @jsii.member(jsii_name="resetFeatureRadiusVar")
    def reset_feature_radius_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureRadiusVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetMaxFeatures")
    def reset_max_features(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxFeatures", []))

    @jsii.member(jsii_name="resetMaxFeaturesVar")
    def reset_max_features_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxFeaturesVar", []))

    @jsii.member(jsii_name="resetMinFeatureQuality")
    def reset_min_feature_quality(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMinFeatureQuality", []))

    @jsii.member(jsii_name="resetMinFeatureQualityVar")
    def reset_min_feature_quality_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMinFeatureQualityVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="failGravityInput")
    def fail_gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityVarInput")
    def fail_gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featureRadiusInput")
    def feature_radius_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featureRadiusInput"))

    @builtins.property
    @jsii.member(jsii_name="featureRadiusVarInput")
    def feature_radius_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featureRadiusVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesInput")
    def max_features_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "maxFeaturesInput"))

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesVarInput")
    def max_features_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "maxFeaturesVarInput"))

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityInput")
    def min_feature_quality_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "minFeatureQualityInput"))

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityVarInput")
    def min_feature_quality_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "minFeatureQualityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravity")
    def fail_gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravity"))

    @fail_gravity.setter
    def fail_gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9fa32118968bd878ff7d1ccbe83b48d64b27d146bdb57f58f20968931d4e226c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravity", value)

    @builtins.property
    @jsii.member(jsii_name="failGravityVar")
    def fail_gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravityVar"))

    @fail_gravity_var.setter
    def fail_gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__413c1c3c2c5fd4249053abee924105be7fa0e94ced1e1dcbe0194de2b56e69a6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="featureRadius")
    def feature_radius(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featureRadius"))

    @feature_radius.setter
    def feature_radius(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__90e037304c8850ee87b45273115fa9bcac0431d117be65e811d0e939408e7827)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featureRadius", value)

    @builtins.property
    @jsii.member(jsii_name="featureRadiusVar")
    def feature_radius_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featureRadiusVar"))

    @feature_radius_var.setter
    def feature_radius_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__82e114b24c13c5df4dbc3d9e77024b56450df6674a87299dfb296237ac115407)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featureRadiusVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d440da5d34e320ae80e2dede315d6e0ef95ea412a7dbb7a84c401359e11089b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__83a5b2c237244fe5eb6fce1f6004b8a6d841995ee6ff10e982fec0f31294dfb3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ace7f3e3f1781d6f70d419b77c1be0faa87caa92503f2461b0f7a6e5fdce5e44)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5b33a9c5ebb4ae0546d6354c77a36bede85e0400184139eb3917051546702721)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="maxFeatures")
    def max_features(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "maxFeatures"))

    @max_features.setter
    def max_features(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a5c0a25e9d8e951416286ddff2bc512059089573ff06b5ee08d289d50e0f90a4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "maxFeatures", value)

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesVar")
    def max_features_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "maxFeaturesVar"))

    @max_features_var.setter
    def max_features_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3654aa15ccb2867ce9546d3d6f2c29db0098d8d0d0ffef8f1b4609e04a32a4da)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "maxFeaturesVar", value)

    @builtins.property
    @jsii.member(jsii_name="minFeatureQuality")
    def min_feature_quality(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "minFeatureQuality"))

    @min_feature_quality.setter
    def min_feature_quality(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6201a0fef59f0f5822261e852a1fc92cef43a2b29c87cc6f4742162504c74c6f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "minFeatureQuality", value)

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityVar")
    def min_feature_quality_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "minFeatureQualityVar"))

    @min_feature_quality_var.setter
    def min_feature_quality_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ef45ecd2b59506fe05704dbe0e5b7a4aa061331046befd53df31e187ad04e6be)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "minFeatureQualityVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ff1bc42c938494089ed54c42712343c6094e60a8dbd161f69d17ae0de210fa63)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac61c2c8f5fc51d7e46375699be92294ca54f7b95c8dca0171edf3ed3b6fad76)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__67eef7bb4d8db379e4beb5cac4913095bbcc0d84314f4b4a7c1a70d5432fe10c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e50e204f1ef3fba4ad087e919077cf5e6ce916968624253cc6a7ecfd886b8a22)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b0714e024eacf8b1902e6a1b6a154393138a292d136b5af732e2590c5d5cd772)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a1ee87452d32a4776f5254c9e50eb36aa798b00a52b3f9a840af984ef6b781fc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationFeatureCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationFeatureCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationFeatureCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dcce896386e4299b513fcd08c6a226ab9ac63e68dfb6722e160049f579c6eb46)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationFitAndFill",
    jsii_struct_bases=[],
    name_mapping={
        "fill_transformation": "fillTransformation",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationFitAndFill:
    def __init__(
        self,
        *,
        fill_transformation: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationFitAndFillFillTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fill_transformation: fill_transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_transformation DataAkamaiImagingPolicyImage#fill_transformation}
        :param height: The height value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The width value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(fill_transformation, dict):
            fill_transformation = DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationFitAndFillFillTransformation(**fill_transformation)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ebd61d072a94b5b80c8b39966c920bd8e6bdf574c18f480032fa4ca023f49e63)
            check_type(argname="argument fill_transformation", value=fill_transformation, expected_type=type_hints["fill_transformation"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fill_transformation is not None:
            self._values["fill_transformation"] = fill_transformation
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def fill_transformation(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationFitAndFillFillTransformation"]:
        '''fill_transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_transformation DataAkamaiImagingPolicyImage#fill_transformation}
        '''
        result = self._values.get("fill_transformation")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationFitAndFillFillTransformation"], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationFitAndFill(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationFitAndFillFillTransformation",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationFitAndFillFillTransformation:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationFitAndFillFillTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationFitAndFillFillTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationFitAndFillFillTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__824700393047dbe66d44330345043e600400b78e26ad3297685fb7f4e7bfc53c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationFitAndFillFillTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationFitAndFillFillTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationFitAndFillFillTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fc7dc01d9b091e7e88b66020253a366f162d91d39cb342e068f01b5d7a06da0e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationFitAndFillList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationFitAndFillList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__da86f122c36ae957ac42a12bfaa0e2c797c1fe4b60188fc6f7e71338d902dec1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationFitAndFillOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d41455b5cbc5e9e7e1dd263be09ee401e83733f309f09710a076a411b9be4b6d)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationFitAndFillOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fc6f43b35dab42914e14bac45405e148d466eb25655a93ef63ba86d735cc0593)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a6fee9e8cbc28d284f4e9f321a07fdff35c646b62cbbd1eac283a7ecfb5957ac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df670b4a3c70a522d00096c66f9c472f4740f41a32d2dd16abf8f7449e867eb0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationFitAndFill]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationFitAndFill]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationFitAndFill]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__10f84d48840785b99b66a85320c8c3a236b5a15de68b7985fa54ab63ee0e3bc8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationFitAndFillOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationFitAndFillOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8887671d26e5a251ef4c4f80bdde2340d1a1ec5666b1648e7eb27db436230e87)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putFillTransformation")
    def put_fill_transformation(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationFitAndFillFillTransformation()

        return typing.cast(None, jsii.invoke(self, "putFillTransformation", [value]))

    @jsii.member(jsii_name="resetFillTransformation")
    def reset_fill_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFillTransformation", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="fillTransformation")
    def fill_transformation(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationFitAndFillFillTransformationOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationFitAndFillFillTransformationOutputReference, jsii.get(self, "fillTransformation"))

    @builtins.property
    @jsii.member(jsii_name="fillTransformationInput")
    def fill_transformation_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationFitAndFillFillTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationFitAndFillFillTransformation], jsii.get(self, "fillTransformationInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d0a9085d7f145c869baa347d7dbd37d90d7c045a0b6c4896fa37c40d96cac40e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e673131e66c3415aa19f7da746423c7138eea3d32d526994d1a361d330947cc4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__87e9efb6926297749a18b4dd0d31093938769268864c8aac9208ba390e55b105)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6aa11c7d26a937e21e82567316bdb7ed16b98736bef24b882a1f670860752ba8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationFitAndFill]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationFitAndFill]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationFitAndFill]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7c6408ff578af0b33fddd2309665cdd27191311c4f1b998c66da9f981b5a263a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationGoop",
    jsii_struct_bases=[],
    name_mapping={
        "chaos": "chaos",
        "chaos_var": "chaosVar",
        "density": "density",
        "density_var": "densityVar",
        "power": "power",
        "power_var": "powerVar",
        "seed": "seed",
        "seed_var": "seedVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationGoop:
    def __init__(
        self,
        *,
        chaos: typing.Optional[builtins.str] = None,
        chaos_var: typing.Optional[builtins.str] = None,
        density: typing.Optional[builtins.str] = None,
        density_var: typing.Optional[builtins.str] = None,
        power: typing.Optional[builtins.str] = None,
        power_var: typing.Optional[builtins.str] = None,
        seed: typing.Optional[builtins.str] = None,
        seed_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param chaos: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        :param chaos_var: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        :param density: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        :param density_var: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        :param power: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        :param power_var: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        :param seed: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        :param seed_var: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__98d3e178d86d30036a291dcf73c25281aeaffc7d403cfe15b36499602b9a6376)
            check_type(argname="argument chaos", value=chaos, expected_type=type_hints["chaos"])
            check_type(argname="argument chaos_var", value=chaos_var, expected_type=type_hints["chaos_var"])
            check_type(argname="argument density", value=density, expected_type=type_hints["density"])
            check_type(argname="argument density_var", value=density_var, expected_type=type_hints["density_var"])
            check_type(argname="argument power", value=power, expected_type=type_hints["power"])
            check_type(argname="argument power_var", value=power_var, expected_type=type_hints["power_var"])
            check_type(argname="argument seed", value=seed, expected_type=type_hints["seed"])
            check_type(argname="argument seed_var", value=seed_var, expected_type=type_hints["seed_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if chaos is not None:
            self._values["chaos"] = chaos
        if chaos_var is not None:
            self._values["chaos_var"] = chaos_var
        if density is not None:
            self._values["density"] = density
        if density_var is not None:
            self._values["density_var"] = density_var
        if power is not None:
            self._values["power"] = power
        if power_var is not None:
            self._values["power_var"] = power_var
        if seed is not None:
            self._values["seed"] = seed
        if seed_var is not None:
            self._values["seed_var"] = seed_var

    @builtins.property
    def chaos(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        '''
        result = self._values.get("chaos")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def chaos_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        '''
        result = self._values.get("chaos_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        '''
        result = self._values.get("density")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density_var(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        '''
        result = self._values.get("density_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        '''
        result = self._values.get("power")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power_var(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        '''
        result = self._values.get("power_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        '''
        result = self._values.get("seed")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed_var(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        result = self._values.get("seed_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationGoop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationGoopList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationGoopList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7cf8a951bbf1e7fc6e91c20b78a4294dfbaddbcdb0c5f6eabde768ae17a720c2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationGoopOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9eb241bd960a181d4a30e504c177cf137495f4acbb458bde457e6fe80d42fa41)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationGoopOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f63606bcf3919437d666a91de5ef20595faa149af3516819e2b6bb7c40c2faa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0e5a56084c580a349523ea0fb0d0a2aab1ddc410a8c9294dd381c1968835921f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fd8e7f4cd95f853a19753910edfa7f4ada5627ca343011e5f17d35886133807e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationGoop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationGoop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6dd3d3964d01ec9821ddc72df0d5f81a73c1f72cbd4dff01c5c4760e6ee71ab8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationGoopOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationGoopOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8934f01c5d4e07e89ea37f50bbaf8255c9564f9d2b84c256e0376598f841bf09)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetChaos")
    def reset_chaos(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaos", []))

    @jsii.member(jsii_name="resetChaosVar")
    def reset_chaos_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaosVar", []))

    @jsii.member(jsii_name="resetDensity")
    def reset_density(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensity", []))

    @jsii.member(jsii_name="resetDensityVar")
    def reset_density_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensityVar", []))

    @jsii.member(jsii_name="resetPower")
    def reset_power(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPower", []))

    @jsii.member(jsii_name="resetPowerVar")
    def reset_power_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPowerVar", []))

    @jsii.member(jsii_name="resetSeed")
    def reset_seed(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeed", []))

    @jsii.member(jsii_name="resetSeedVar")
    def reset_seed_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeedVar", []))

    @builtins.property
    @jsii.member(jsii_name="chaosInput")
    def chaos_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosInput"))

    @builtins.property
    @jsii.member(jsii_name="chaosVarInput")
    def chaos_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosVarInput"))

    @builtins.property
    @jsii.member(jsii_name="densityInput")
    def density_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityInput"))

    @builtins.property
    @jsii.member(jsii_name="densityVarInput")
    def density_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="powerInput")
    def power_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerInput"))

    @builtins.property
    @jsii.member(jsii_name="powerVarInput")
    def power_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerVarInput"))

    @builtins.property
    @jsii.member(jsii_name="seedInput")
    def seed_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedInput"))

    @builtins.property
    @jsii.member(jsii_name="seedVarInput")
    def seed_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedVarInput"))

    @builtins.property
    @jsii.member(jsii_name="chaos")
    def chaos(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaos"))

    @chaos.setter
    def chaos(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c15b98e2839870b62aafc3fc412bf9645565ec4be41a402715d3067eef259aea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaos", value)

    @builtins.property
    @jsii.member(jsii_name="chaosVar")
    def chaos_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaosVar"))

    @chaos_var.setter
    def chaos_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d25eb7f71f8bf4a4f69d9ba5bb5441047c0f4a2577ccb011b0db36b75f5ea665)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaosVar", value)

    @builtins.property
    @jsii.member(jsii_name="density")
    def density(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "density"))

    @density.setter
    def density(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d6682f1c3dde4bc3814b20cc84550b431a144ef3fb319d2ec3c7a37a9856ab14)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "density", value)

    @builtins.property
    @jsii.member(jsii_name="densityVar")
    def density_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "densityVar"))

    @density_var.setter
    def density_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4846f375edf2f855ff71bc739d0fbdf0d9213dee11a35aae89d459fa5c4dce8b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "densityVar", value)

    @builtins.property
    @jsii.member(jsii_name="power")
    def power(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "power"))

    @power.setter
    def power(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3bbdc2d6030d245319592bccdf996718ceefc60553027a3fa4f5f04c4c0f4c6b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "power", value)

    @builtins.property
    @jsii.member(jsii_name="powerVar")
    def power_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "powerVar"))

    @power_var.setter
    def power_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__109af45490141fdc798f44182e1d53a6993476f9d5240a54fdb5b503dd52758e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "powerVar", value)

    @builtins.property
    @jsii.member(jsii_name="seed")
    def seed(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seed"))

    @seed.setter
    def seed(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__273d6a39306ead474ce833b2daf79f869b9466694ab9f8d82bf8c06e66b62aeb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seed", value)

    @builtins.property
    @jsii.member(jsii_name="seedVar")
    def seed_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seedVar"))

    @seed_var.setter
    def seed_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__09dbd04125935e97c1cbb42b8c88c947f479973f13b314ac7ad756da2d25062c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seedVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationGoop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationGoop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationGoop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__69988ef792eb3f6d0d21dbc23916a152eeebe300250ba6d47abe4f4811e784a7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationGrayscale",
    jsii_struct_bases=[],
    name_mapping={"type": "type", "type_var": "typeVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationGrayscale:
    def __init__(
        self,
        *,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param type: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ae2213d93f7dfb945bae6cc3316ba69966b90a7ca967803b143997ac9b2d72b5)
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationGrayscale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationGrayscaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationGrayscaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__330c7d9844836f457dcdb731eb57a82bdf59f8c73105d24b881fa289ba27ce5f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationGrayscaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c2e85aeef7c218ec11697129335723b7bb47a4929395abbecd3f2e0b7af89156)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationGrayscaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__09c07ffceb82af71072548db14c4195bd97559acc3a91f121d0fe4f222caf912)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__57cdaa1e645b35e6b2e173f72ca5d5090a77c076e829bb0b4496db9a094633fb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b14881261a3703ed41a8299f2a7520e16a849c7805531358c17caf3a6e15afd1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationGrayscale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationGrayscale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__368c404b96360f94ac52fcdd19ccb79d395cfaaca9b5a5636a8eebb934159af6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationGrayscaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationGrayscaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b6defbf45682cb2f4b0bd0564044adad5c551a2210a846a5ad91c81f6a0b9dfb)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ca1ad6f8896e7755a8d76c177f7e230af7adfaa6aab57335bdbf67a1c197dc25)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__16c46fc2b4f6c3736d36bca15d01a1f826a87d8b7dcedd636003adb1f119417c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationGrayscale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationGrayscale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationGrayscale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b4f6bfd08b1580a8ffb03a3a531961c657a90884f3ad84f051549876443b4cab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationHsl",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "lightness": "lightness",
        "lightness_var": "lightnessVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationHsl:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness: typing.Optional[builtins.str] = None,
        lightness_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        :param lightness_var: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__61cbbf045f58869bdd1fb6d2220d475906eae3ae39c99f7382894e7498b541da)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness", value=lightness, expected_type=type_hints["lightness"])
            check_type(argname="argument lightness_var", value=lightness_var, expected_type=type_hints["lightness_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness is not None:
            self._values["lightness"] = lightness
        if lightness_var is not None:
            self._values["lightness_var"] = lightness_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        '''
        result = self._values.get("lightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        '''
        result = self._values.get("lightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationHsl(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationHslList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationHslList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6a8dba43887be59bf7764f7bea9b83a3ccb9091355bdf8d5a98ecc32472cf9e5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationHslOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a108d2e7534ec07f6153d42d09662903d8ff5b55eef3366bdbf8f7989f30f48)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationHslOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f6835d0f4eea6ef5a9fef46ad28a4d15f7f33d1c310cf1e7fc9db0ae95628fe6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__15291eb4529b6d4062117e09e8543376da1690d0f9565a14dd495bc6d3e34413)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__93a144525b28dd93dcea619e074626f2a59eeb7244efcfb91ee2c0d40dd6bf4c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationHsl]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationHsl]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__70258dc2611adc6ebf0c3776aac5bc9b40b513754757ac13da1cee7b457eb9dc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationHslOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationHslOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d7f19fc8bd01153fcd881c360b8ccf7bfe3d4a3d18ba042134b25072bee421de)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightness")
    def reset_lightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightness", []))

    @jsii.member(jsii_name="resetLightnessVar")
    def reset_lightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessInput")
    def lightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessVarInput")
    def lightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3c307b06f666d47b2c66fb5ddfd540f3b714c56bf92bf51b553746b7215b2526)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c5dced2f82db7d7eca9d186c9eab47485b3058fe2be10a0d8869a1d7105b67c5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightness")
    def lightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightness"))

    @lightness.setter
    def lightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ca6c330903e2bc810357e62d478456305afb6505f93ae2c929813d705d542515)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightness", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessVar")
    def lightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessVar"))

    @lightness_var.setter
    def lightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eb948d372197f43532a9b68240886831b261f7af5794439af268750870f3ac4b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__adc9dc92173fc9d0d7b9e3526571bf082fceb964deface052448e61e0ca3730b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__49d20ea8fd9a12d0a07f2609ceca4f22aa21005e134cad9b2121081e8fcd47f1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationHsl]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationHsl]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationHsl]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aff0e49d4f8b64de01cdde9c5504ead7ead4d1d71d3e3505d5304bdad5fa3024)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationHsv",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationHsv:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        :param value: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af601b9e714ab0e004f38f0acccb76d8fbf14999e24361da2e511823a7c01be9)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationHsv(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationHsvList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationHsvList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__25392ec868a7d982596c06a8af678d2e423e1ba01ed500c55e8da06d87368d32)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationHsvOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0774d85345fbab2cbba85203eb96f0d9c41fd86af668f4c0a03c01d2a15e5407)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationHsvOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6ffe98524e22b0c26bebbbad1bb0138157fa09ed02aa57d6b0ac8f23eb5c60cf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7a971d50f4d9b0d1003cbc4920b428cb9221d1a8446667804916aa9185c3ace7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__53a5edccb537bd7f71474b6542b5ffe8e99ae95c80852079a65c20729a1c9dda)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationHsv]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationHsv]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__413406f8384c9e19b41df9a90d09aa49fa6973bc47357283c95d1635c5ce696c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationHsvOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationHsvOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__11daf8cf8e66ec6fc3c3d40e9ede2acc87ca7bc11933f0bc00665bdaecf2ac87)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb038ec578ad615064949c3906ce7fefa229285b62b40044fcf7e9f81ff724a3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df89ef7478f73adc5f3d4080609fddcc0f44cd54cb1e1b204b4be8491891b18b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e069d465bd8ffb17cf8481b6b23ab9d9c0798f4c962a6d863e036ced0980adec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__76780c6834d22544d3f3bdcacd978e586189a044b5460a2f07f8b7e3ad88dd0b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a65d2fb09edbd17932d8075307f7657ba37b9cc91bead0d4d14c478a7ca61f83)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4c9c64553ac4daa3f35c7da081e68956a0d917d672e606985e5dce9400a42f3b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationHsv]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationHsv]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationHsv]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__91ab62bd5dc47403feda2f20a8905cc9729b39cbbb5ff4dcc9a757aa52069374)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimension",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "dimension": "dimension",
        "dimension_var": "dimensionVar",
        "equal": "equal",
        "greater_than": "greaterThan",
        "less_than": "lessThan",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimension:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimensionDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        dimension: typing.Optional[builtins.str] = None,
        dimension_var: typing.Optional[builtins.str] = None,
        equal: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimensionEqual", typing.Dict[builtins.str, typing.Any]]] = None,
        greater_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimensionGreaterThan", typing.Dict[builtins.str, typing.Any]]] = None,
        less_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimensionLessThan", typing.Dict[builtins.str, typing.Any]]] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param dimension: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        :param dimension_var: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        :param equal: equal block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        :param greater_than: greater_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        :param less_than: less_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        :param value: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimensionDefault(**default)
        if isinstance(equal, dict):
            equal = DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimensionEqual(**equal)
        if isinstance(greater_than, dict):
            greater_than = DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimensionGreaterThan(**greater_than)
        if isinstance(less_than, dict):
            less_than = DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimensionLessThan(**less_than)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eeba431c2f4dd26b981acac832c22c8d7975178a19602d4dbce229ff30f27b3d)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument dimension", value=dimension, expected_type=type_hints["dimension"])
            check_type(argname="argument dimension_var", value=dimension_var, expected_type=type_hints["dimension_var"])
            check_type(argname="argument equal", value=equal, expected_type=type_hints["equal"])
            check_type(argname="argument greater_than", value=greater_than, expected_type=type_hints["greater_than"])
            check_type(argname="argument less_than", value=less_than, expected_type=type_hints["less_than"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if dimension is not None:
            self._values["dimension"] = dimension
        if dimension_var is not None:
            self._values["dimension_var"] = dimension_var
        if equal is not None:
            self._values["equal"] = equal
        if greater_than is not None:
            self._values["greater_than"] = greater_than
        if less_than is not None:
            self._values["less_than"] = less_than
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimensionDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimensionDefault"], result)

    @builtins.property
    def dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        '''
        result = self._values.get("dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        '''
        result = self._values.get("dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def equal(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimensionEqual"]:
        '''equal block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        '''
        result = self._values.get("equal")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimensionEqual"], result)

    @builtins.property
    def greater_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimensionGreaterThan"]:
        '''greater_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        '''
        result = self._values.get("greater_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimensionGreaterThan"], result)

    @builtins.property
    def less_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimensionLessThan"]:
        '''less_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        '''
        result = self._values.get("less_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimensionLessThan"], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimension(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimensionDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimensionDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimensionDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimensionDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimensionDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fe581b2a350847b5b132975e08c436f629ab30ec5b1371a9df05294ea2cc4458)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimensionDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimensionDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fd028d14a688e0997b60df1c23e64d0048f587ac17d92db32cc12b17c05284ab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimensionEqual",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimensionEqual:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimensionEqual(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimensionEqualOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimensionEqualOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d219b5d9002e9d0013a5ede639bc040da7680e1c177dc6cc3eaa15b9bdd15f4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimensionEqual], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimensionEqual],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d1091e897458137ad48873f015396202941c99dea1a6ab1951e3177a643ba1a3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimensionGreaterThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimensionGreaterThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimensionGreaterThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimensionGreaterThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimensionGreaterThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__59e3b69c8d51befdd6587d330ea94f5066b81a04ed89420340e848b8ecd8565f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimensionGreaterThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimensionGreaterThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__23f627b283938ff162798369e3035c3fbd07e01fe73624d56d7cfe7bb09492f8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimensionLessThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimensionLessThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimensionLessThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimensionLessThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimensionLessThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2f52b504fc4906a7b7242299eda8f389cca19ec8843e36e4b51239baa30aa743)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimensionLessThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimensionLessThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3631c0285b32aa26a7964f22c40a043bff71587503d8683a05c7ea5f27243168)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimensionList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimensionList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3841ee8816902f083632d9f421025954bbf3a73783cd25aab83f768734a06f53)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimensionOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__289bdd355b91d9db98f3c5edc666ccf111e7fd17cc91a3922cec615c90b9b781)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimensionOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__45d6a00b7a098a0fddf6e739540f1d8333c68f2ce987eb755680c268cd50ee0f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__51ad45df05a1897568479d49f4ffadcc17c3b4aad8d9a75ef8f34eb4e7c18c01)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__28fc574b4fc75ccace2a6efa68b810370521fb0803907bd9e2815d686c019d4f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimension]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimension]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a3fd4e9dc532e04fca1f68df5e0952e3555f2f92d47534ae075c2dc8b3a018ed)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimensionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimensionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__144cfedecbc012ec614fa07ae8f16a6c8c61eecd1a594a7c6abf0a024efaed3f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimensionDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putEqual")
    def put_equal(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimensionEqual()

        return typing.cast(None, jsii.invoke(self, "putEqual", [value]))

    @jsii.member(jsii_name="putGreaterThan")
    def put_greater_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimensionGreaterThan()

        return typing.cast(None, jsii.invoke(self, "putGreaterThan", [value]))

    @jsii.member(jsii_name="putLessThan")
    def put_less_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimensionLessThan()

        return typing.cast(None, jsii.invoke(self, "putLessThan", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetDimension")
    def reset_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimension", []))

    @jsii.member(jsii_name="resetDimensionVar")
    def reset_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimensionVar", []))

    @jsii.member(jsii_name="resetEqual")
    def reset_equal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEqual", []))

    @jsii.member(jsii_name="resetGreaterThan")
    def reset_greater_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGreaterThan", []))

    @jsii.member(jsii_name="resetLessThan")
    def reset_less_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLessThan", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimensionDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimensionDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="equal")
    def equal(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimensionEqualOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimensionEqualOutputReference, jsii.get(self, "equal"))

    @builtins.property
    @jsii.member(jsii_name="greaterThan")
    def greater_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimensionGreaterThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimensionGreaterThanOutputReference, jsii.get(self, "greaterThan"))

    @builtins.property
    @jsii.member(jsii_name="lessThan")
    def less_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimensionLessThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimensionLessThanOutputReference, jsii.get(self, "lessThan"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimensionDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionInput")
    def dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionVarInput")
    def dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="equalInput")
    def equal_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimensionEqual], jsii.get(self, "equalInput"))

    @builtins.property
    @jsii.member(jsii_name="greaterThanInput")
    def greater_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimensionGreaterThan], jsii.get(self, "greaterThanInput"))

    @builtins.property
    @jsii.member(jsii_name="lessThanInput")
    def less_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimensionLessThan], jsii.get(self, "lessThanInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="dimension")
    def dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimension"))

    @dimension.setter
    def dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5d20159ed4460fb25db35cc5bb783d4bae33d484d82355ecc2ef75b2cb16a015)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimension", value)

    @builtins.property
    @jsii.member(jsii_name="dimensionVar")
    def dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimensionVar"))

    @dimension_var.setter
    def dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2bbca99c5c4d00c7050517d4638f81a71a4e03596e80113f7fc33a9d9ecaf5ce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ead0837f748fb620008c743b53276c289c4dc75899363329e994d80897dec4ff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__95bdfcec04a036b855b7396d3a8bb216be5eff20ad6f93e1c4910f718ac72903)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimension]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimension]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimension]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e14b4c87ddb86c0e28bca828afc56f34b99950c659492ab329dcac5aa51e93b7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientation",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "landscape": "landscape",
        "portrait": "portrait",
        "square": "square",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientation:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientationDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        landscape: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientationLandscape", typing.Dict[builtins.str, typing.Any]]] = None,
        portrait: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientationPortrait", typing.Dict[builtins.str, typing.Any]]] = None,
        square: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientationSquare", typing.Dict[builtins.str, typing.Any]]] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param landscape: landscape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        :param portrait: portrait block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        :param square: square block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientationDefault(**default)
        if isinstance(landscape, dict):
            landscape = DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientationLandscape(**landscape)
        if isinstance(portrait, dict):
            portrait = DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientationPortrait(**portrait)
        if isinstance(square, dict):
            square = DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientationSquare(**square)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__520639e9dbde170aa8995a47e1896ef960566c9b093b4647dd7917b288eee8a4)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument landscape", value=landscape, expected_type=type_hints["landscape"])
            check_type(argname="argument portrait", value=portrait, expected_type=type_hints["portrait"])
            check_type(argname="argument square", value=square, expected_type=type_hints["square"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if landscape is not None:
            self._values["landscape"] = landscape
        if portrait is not None:
            self._values["portrait"] = portrait
        if square is not None:
            self._values["square"] = square

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientationDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientationDefault"], result)

    @builtins.property
    def landscape(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientationLandscape"]:
        '''landscape block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        '''
        result = self._values.get("landscape")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientationLandscape"], result)

    @builtins.property
    def portrait(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientationPortrait"]:
        '''portrait block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        '''
        result = self._values.get("portrait")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientationPortrait"], result)

    @builtins.property
    def square(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientationSquare"]:
        '''square block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        result = self._values.get("square")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientationSquare"], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientationDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientationDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientationDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientationDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientationDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9f09dc8f7bbfbe3a9b099b645e68a867d2651ce0fcc16b17cbbe0fb0beaea31c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientationDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientationDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__85f72d600f0fd8b2483aa0c980c76fbb04dbb8f2159c9325247c5844532e0a1e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientationLandscape",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientationLandscape:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientationLandscape(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientationLandscapeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientationLandscapeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6298f01e9a22e39aadb1f0a0a5d83d7b4417356c16bf2a9f070653e9a2d8f51f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientationLandscape], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientationLandscape],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e9ca8bef591c7356daef60c7fa0ed0ec595dc6b06f879e1478214932d9b3b058)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientationList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientationList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e283227da0c582a6f28debdc8ac3488dbb20208866808497f4fd17aa371bc16e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientationOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__78b935d616b2fc03ef21eead5424cda86330f0c3bc79d034dc54686796f2fd6e)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientationOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6ccead64585495b90c14f4d87224e6cf5782db668df2e2a79750bf8660c88933)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f33647a271b9b604c238eef2e9c4812269523d6beeb78d7b1f2dadd3d020666c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__257be52cb99e60c3fce56ff37538699760e5cfc882009f297721037b450aeca2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientation]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientation]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b85797232d75a10806fe6d8aef3859a459ac19bd3e1bed360e07b969ec021fc3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f34c5b3264049160304e76fa8472c4551dad28cc203c5891f12f1bed7b7988e3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientationDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putLandscape")
    def put_landscape(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientationLandscape()

        return typing.cast(None, jsii.invoke(self, "putLandscape", [value]))

    @jsii.member(jsii_name="putPortrait")
    def put_portrait(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientationPortrait()

        return typing.cast(None, jsii.invoke(self, "putPortrait", [value]))

    @jsii.member(jsii_name="putSquare")
    def put_square(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientationSquare()

        return typing.cast(None, jsii.invoke(self, "putSquare", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetLandscape")
    def reset_landscape(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLandscape", []))

    @jsii.member(jsii_name="resetPortrait")
    def reset_portrait(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPortrait", []))

    @jsii.member(jsii_name="resetSquare")
    def reset_square(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSquare", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientationDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientationDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="landscape")
    def landscape(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientationLandscapeOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientationLandscapeOutputReference, jsii.get(self, "landscape"))

    @builtins.property
    @jsii.member(jsii_name="portrait")
    def portrait(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientationPortraitOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientationPortraitOutputReference", jsii.get(self, "portrait"))

    @builtins.property
    @jsii.member(jsii_name="square")
    def square(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientationSquareOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientationSquareOutputReference", jsii.get(self, "square"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientationDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="landscapeInput")
    def landscape_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientationLandscape], jsii.get(self, "landscapeInput"))

    @builtins.property
    @jsii.member(jsii_name="portraitInput")
    def portrait_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientationPortrait"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientationPortrait"], jsii.get(self, "portraitInput"))

    @builtins.property
    @jsii.member(jsii_name="squareInput")
    def square_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientationSquare"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientationSquare"], jsii.get(self, "squareInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientation]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientation]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientation]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd298441c0236cfd78d4bafba16b2f2cbeefc707a23a83bcc584ccd510682426)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientationPortrait",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientationPortrait:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientationPortrait(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientationPortraitOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientationPortraitOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__281faeeccdb6eca686e907553fbd58613667777845f003d5df280f8ccf45a20a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientationPortrait]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientationPortrait], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientationPortrait],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__18379edc1b2bc5a5ed4626c8c35f2aa1bce0fe9599b7e5e16a96851337a39243)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientationSquare",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientationSquare:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientationSquare(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientationSquareOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientationSquareOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7979ad2fd55b214b0b33b20aebe962f49feb6ceecae04c0979b5654aad335a6b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientationSquare]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientationSquare], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientationSquare],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ea6c8f0dfd2b0d6dc67294444ee9c0a5d117b5e78e0c2af3bd939b7f190b703)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationImQuery",
    jsii_struct_bases=[],
    name_mapping={
        "allowed_transformations": "allowedTransformations",
        "query_var": "queryVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationImQuery:
    def __init__(
        self,
        *,
        allowed_transformations: typing.Sequence[builtins.str],
        query_var: builtins.str,
    ) -> None:
        '''
        :param allowed_transformations: Specifies the transformations that can be applied using the query string parameter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allowed_transformations DataAkamaiImagingPolicyImage#allowed_transformations}
        :param query_var: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#query_var DataAkamaiImagingPolicyImage#query_var}.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3d22b808254e98e23d7e46cf52e27a72a8a9b565a698903d88ff25df136ea934)
            check_type(argname="argument allowed_transformations", value=allowed_transformations, expected_type=type_hints["allowed_transformations"])
            check_type(argname="argument query_var", value=query_var, expected_type=type_hints["query_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "allowed_transformations": allowed_transformations,
            "query_var": query_var,
        }

    @builtins.property
    def allowed_transformations(self) -> typing.List[builtins.str]:
        '''Specifies the transformations that can be applied using the query string parameter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allowed_transformations DataAkamaiImagingPolicyImage#allowed_transformations}
        '''
        result = self._values.get("allowed_transformations")
        assert result is not None, "Required property 'allowed_transformations' is missing"
        return typing.cast(typing.List[builtins.str], result)

    @builtins.property
    def query_var(self) -> builtins.str:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#query_var DataAkamaiImagingPolicyImage#query_var}.'''
        result = self._values.get("query_var")
        assert result is not None, "Required property 'query_var' is missing"
        return typing.cast(builtins.str, result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationImQuery(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationImQueryList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationImQueryList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__65748e620e0ba9f17722aa5ae3c159cdf61dc0d2a684cd0f10e4c305096e6af4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationImQueryOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e96fcb92463046cf3dd66f38706ddb5709f5c13e2b7d601b66d744f5a6da38fd)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationImQueryOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b661306053c7f8f5c7ab918294e308356e04bc312feb3a7297555a10eafe0cbc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__85f46d5445a9bd927fedc5222943f15a6ef7e870fb13257dc72456c413869989)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__da91d37cfb29ae4976b399d7daee4d19f715e8b2abe33f99a9e41da0f081a945)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationImQuery]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationImQuery]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationImQuery]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__69891c5535e5979ce2ac31426fd39bd782eba07dc840d8fdf4a5bc911acf910b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationImQueryOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationImQueryOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0b04646daa01980738c438648306be8049f3c8e5919ed2441340dea66ce8a620)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @builtins.property
    @jsii.member(jsii_name="allowedTransformationsInput")
    def allowed_transformations_input(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "allowedTransformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="queryVarInput")
    def query_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "queryVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowedTransformations")
    def allowed_transformations(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "allowedTransformations"))

    @allowed_transformations.setter
    def allowed_transformations(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac54792089ba002e1885716decea43cabcfac3f5216727c11b13d8065b178aaa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowedTransformations", value)

    @builtins.property
    @jsii.member(jsii_name="queryVar")
    def query_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "queryVar"))

    @query_var.setter
    def query_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8712839c8ddb9f5c53d04fc9aa983d6ef1063086e7694fe7801aae912a973738)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "queryVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationImQuery]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationImQuery]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationImQuery]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0f6384122612b40623889837831fe43ff84fbe3c853a4fa01fe609e98fe7b94c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationMaxColors",
    jsii_struct_bases=[],
    name_mapping={"colors": "colors", "colors_var": "colorsVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationMaxColors:
    def __init__(
        self,
        *,
        colors: typing.Optional[builtins.str] = None,
        colors_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param colors: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        :param colors_var: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ed837a03896a6f2bdfdaff70b9cc3127ace1c3285f24a8b0eb2fdcfd349afb47)
            check_type(argname="argument colors", value=colors, expected_type=type_hints["colors"])
            check_type(argname="argument colors_var", value=colors_var, expected_type=type_hints["colors_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if colors is not None:
            self._values["colors"] = colors
        if colors_var is not None:
            self._values["colors_var"] = colors_var

    @builtins.property
    def colors(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        '''
        result = self._values.get("colors")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def colors_var(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        result = self._values.get("colors_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationMaxColors(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationMaxColorsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationMaxColorsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__08809a6ad8c57affc1a6bacfd542acbf5e617a940d4a179f511e155ea0ba106f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationMaxColorsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__968076aabb3e2987482c15defd2f10140148a82429c1242ed4b2633eeda22911)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationMaxColorsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3cb1a0a243f2277d67896f959bed0b85bf98e318bf5608f0cd9cd9d8354a892d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e4b3d8eac2e2998615eea4a34c22fae6dca34101ea8e1cd6bcc8cf6819f2318f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea993f9da9436647b166a8f8c27da36f14cb80eb7fc24d6a9484b4326c94dfd7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationMaxColors]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationMaxColors]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1c9ca72e03b89f5b68309345fe5f022459776b9e9b8f288b66972e89577161c9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationMaxColorsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationMaxColorsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__db0053810fe8ed309e5a5ce0defe1bfc1ac6458c93e80616c6423f58e0e3f01e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColors")
    def reset_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColors", []))

    @jsii.member(jsii_name="resetColorsVar")
    def reset_colors_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorsVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorsInput")
    def colors_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsInput"))

    @builtins.property
    @jsii.member(jsii_name="colorsVarInput")
    def colors_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsVarInput"))

    @builtins.property
    @jsii.member(jsii_name="colors")
    def colors(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colors"))

    @colors.setter
    def colors(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b8b8131f87dc03965b538df048bff4f12ad6ce7a6cd5928be462d23e57dabf08)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colors", value)

    @builtins.property
    @jsii.member(jsii_name="colorsVar")
    def colors_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorsVar"))

    @colors_var.setter
    def colors_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c3466b59f25e215d696cedb2317dd4ba3fb591eeaf638bd0e70f5cdfc60c30aa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorsVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationMaxColors]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationMaxColors]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationMaxColors]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5531db86929b94a4fe9ea9646e1ac71f35356ffcba74068aa063c31fab4be37c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationMirror",
    jsii_struct_bases=[],
    name_mapping={
        "horizontal": "horizontal",
        "horizontal_var": "horizontalVar",
        "vertical": "vertical",
        "vertical_var": "verticalVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationMirror:
    def __init__(
        self,
        *,
        horizontal: typing.Optional[builtins.str] = None,
        horizontal_var: typing.Optional[builtins.str] = None,
        vertical: typing.Optional[builtins.str] = None,
        vertical_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param horizontal: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        :param horizontal_var: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        :param vertical: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        :param vertical_var: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__88ec9449acaa03526c675c123c0c0388dbe68dcffaf1e4bcfe1a6d3d7536193b)
            check_type(argname="argument horizontal", value=horizontal, expected_type=type_hints["horizontal"])
            check_type(argname="argument horizontal_var", value=horizontal_var, expected_type=type_hints["horizontal_var"])
            check_type(argname="argument vertical", value=vertical, expected_type=type_hints["vertical"])
            check_type(argname="argument vertical_var", value=vertical_var, expected_type=type_hints["vertical_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if horizontal is not None:
            self._values["horizontal"] = horizontal
        if horizontal_var is not None:
            self._values["horizontal_var"] = horizontal_var
        if vertical is not None:
            self._values["vertical"] = vertical
        if vertical_var is not None:
            self._values["vertical_var"] = vertical_var

    @builtins.property
    def horizontal(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        '''
        result = self._values.get("horizontal")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def horizontal_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        '''
        result = self._values.get("horizontal_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        '''
        result = self._values.get("vertical")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        result = self._values.get("vertical_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationMirror(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationMirrorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationMirrorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2295ddf3ef9188590a399e1189f1665982823fc61ebc5f6c4d45579e28ea952e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationMirrorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1561ee99823b1a9a933472118daffb19f51647d5d8a54bc88071e2b34103b538)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationMirrorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__950ba05defbf062b910296f2359df168d819c51e44258a1ca9418cf2be07050c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__13802e7ed52ab51c7f757ba498f16de6f530f6b72176bead6002785205a30086)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2971e279543d0b66ed8c55f1e7108a0c0a5e09cdffd15ccbcd9a082ec6d0165a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationMirror]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationMirror]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5083700a795359b3511a51ea4de60423f68c2d2c23f3786046c506212c495d63)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationMirrorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationMirrorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__351358e6e4b225753113a8453a4d0817c8e2e627399341d7c140eb7aa03c819c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHorizontal")
    def reset_horizontal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontal", []))

    @jsii.member(jsii_name="resetHorizontalVar")
    def reset_horizontal_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontalVar", []))

    @jsii.member(jsii_name="resetVertical")
    def reset_vertical(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVertical", []))

    @jsii.member(jsii_name="resetVerticalVar")
    def reset_vertical_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVerticalVar", []))

    @builtins.property
    @jsii.member(jsii_name="horizontalInput")
    def horizontal_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontalVarInput")
    def horizontal_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalInput")
    def vertical_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalVarInput")
    def vertical_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontal")
    def horizontal(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontal"))

    @horizontal.setter
    def horizontal(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3f44b6dab6ccd0d9a23581102315d9fc202801326b2686e26a4aba7a18e3358c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontal", value)

    @builtins.property
    @jsii.member(jsii_name="horizontalVar")
    def horizontal_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontalVar"))

    @horizontal_var.setter
    def horizontal_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__21dd50109b75866bbb310bdfd7886a1eff6ae0f05ae446d14a3a128ade873db3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontalVar", value)

    @builtins.property
    @jsii.member(jsii_name="vertical")
    def vertical(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "vertical"))

    @vertical.setter
    def vertical(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__90727c5ea4dad8a061432684cada5965080757297fae2bebd5f3d46c4f71b002)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "vertical", value)

    @builtins.property
    @jsii.member(jsii_name="verticalVar")
    def vertical_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "verticalVar"))

    @vertical_var.setter
    def vertical_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bad3156cc9813e8fd206bad1e1a5ef0b22ae613d180f91d60f727c1e4f86b64e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "verticalVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationMirror]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationMirror]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationMirror]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__892f23e8630c3dbcaf661c3f964c3fde2e602c348439bd91b14cd1500bb5576e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationMonoHue",
    jsii_struct_bases=[],
    name_mapping={"hue": "hue", "hue_var": "hueVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationMonoHue:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b37edefb3704cb24f432715594d6cf9d56913910cab524bb1c2608caeb7dd647)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationMonoHue(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationMonoHueList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationMonoHueList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5fc6c3a6b11e3d1accdd9a83c367cb7bfe8710739ac5728bed1b0bf3ab7ed6ba)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationMonoHueOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__69f6e40900a7be26306dc2b1cf4fd40e2b1bacea0ebaf29b560b5b106a6a8d4c)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationMonoHueOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c7867a2d102df3aa36e11afb75dad99f583f1282000460bbd091076c6c800e68)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c0c4aa129205c9faa0b8f190ba3419038e78edc6e94ce58db8777a86bcced371)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4522f208b140ef906b5b85e731f659cfdbf65a4479d69c3eb0e6beecc52fd102)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationMonoHue]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationMonoHue]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__857fc849c73a4e83f2f0e36fb394764af0c06db948cfb81409ce211a1f7febfc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationMonoHueOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationMonoHueOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8228366be639fb0f153848976998b0264a823cf92882bd0586d8cf81f53d0c20)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8c791fced105821472a2972fccc3b52b2a23914ebe25093dfe32841a6c2500d0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bdc5babd2426b4680cf8e85af20fcf8837ac3753bc971cfad16b854754ff560d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationMonoHue]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationMonoHue]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationMonoHue]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__96338e02eeec7cf445955c852446d5663d418e6f00fd97c0b904033d28feab82)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationOpacity",
    jsii_struct_bases=[],
    name_mapping={"opacity": "opacity", "opacity_var": "opacityVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationOpacity:
    def __init__(
        self,
        *,
        opacity: typing.Optional[builtins.str] = None,
        opacity_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param opacity: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param opacity_var: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a1ffa79bdaf4924e06b1de5e6d9247bb2cb493c01fb77c52d1c5a4d0107153b9)
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument opacity_var", value=opacity_var, expected_type=type_hints["opacity_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if opacity is not None:
            self._values["opacity"] = opacity
        if opacity_var is not None:
            self._values["opacity_var"] = opacity_var

    @builtins.property
    def opacity(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def opacity_var(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        result = self._values.get("opacity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationOpacity(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationOpacityList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationOpacityList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a9f7dce1b4b5a2231a626bbe38c049f73f7b52ef48b554dce41ce08360266fa1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationOpacityOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__66c968591aea399656e175bbc3ce4243df056cde512f6cbfae5512458aeb7e91)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationOpacityOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c80f4dcc9f466449482936d24a8d957d228b6f74877bbd29447b8c7e30be1a69)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__57cf5793ff0c06b86c2539f1e62dd5be7109d63251d17dc1db5b42d80193efa6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c04258c0d12df14b74dc8b8cb09cbe15954703699d41e47ae4675727e0307f78)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationOpacity]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationOpacity]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1b95b7c2dafb1d70609db26b885c2dff8f6a32fc2bf4fae0f919d61100080056)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationOpacityOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationOpacityOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bf595163d369f85423f4fe80246aa735f28ce989daeaaedc773fbeb85336a568)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetOpacityVar")
    def reset_opacity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacityVar", []))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityVarInput")
    def opacity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacity"))

    @opacity.setter
    def opacity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__089ad6bb85c4e65cb4c9445079891ecb7598e3b1ec9428a089b09c74d3bb24e6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacity", value)

    @builtins.property
    @jsii.member(jsii_name="opacityVar")
    def opacity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacityVar"))

    @opacity_var.setter
    def opacity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cdf7127fccbb7a51f31c697861bd6f85e1f94fab0b2e2ebe8f602557c9912c9c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacityVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationOpacity]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationOpacity]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationOpacity]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b58eef98b19415e59ea495b0d4e06637d89efef4ced0c1792831b858cdda05cd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a0571fa242a336313a463e0fb381f3b6ada806e3f3f2b34ae62ee6ac058f513b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putAppend")
    def put_append(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationAppend, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e6209a439aa17701dd979be9d931007460d56953b53dd662d6cbfc8bc063b581)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putAppend", [value]))

    @jsii.member(jsii_name="putAspectCrop")
    def put_aspect_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationAspectCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c7a40834d8c99916b42fed0c83f3a67037ad801dce1925fabe073a8937fb6e32)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putAspectCrop", [value]))

    @jsii.member(jsii_name="putBackgroundColor")
    def put_background_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__842fdc4f21d5e14df3f1628b4cc3373e84cefc3f309c44d8564e3d437c1beee8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBackgroundColor", [value]))

    @jsii.member(jsii_name="putBlur")
    def put_blur(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationBlur, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5c404c17a86240c6f312d484388ae936131eab475c9622f72da6d05ede94f7dd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBlur", [value]))

    @jsii.member(jsii_name="putChromaKey")
    def put_chroma_key(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationChromaKey, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df136d75c3d5fa1cf797a43ac4e94e61d41c6a44b999b538f8be5880933afcc1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putChromaKey", [value]))

    @jsii.member(jsii_name="putComposite")
    def put_composite(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationComposite, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ce64ca0fa1fd1897c529db650493ce4bef994b3f0a04dd837c37b9a6a32fbbee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putComposite", [value]))

    @jsii.member(jsii_name="putCompound")
    def put_compound(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCompound, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4f7f6ff54d5aa54f6e283bded08c7f12295e160c9d29a95757e1c7aa3cf57439)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCompound", [value]))

    @jsii.member(jsii_name="putContrast")
    def put_contrast(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationContrast, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c052ba2a9d4977218a8c770ef5042c384add9f552e97c2f18ad1fcffb07a619b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putContrast", [value]))

    @jsii.member(jsii_name="putCrop")
    def put_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__75a7c37308e3bf6e280bdbeaeda379018587de12979a5ba8f34a51aa8ee4f8cc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCrop", [value]))

    @jsii.member(jsii_name="putFaceCrop")
    def put_face_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationFaceCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__968a0471594420cc1e77585bedca1384e404b48465f470ffbb1d18ef2705cef4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFaceCrop", [value]))

    @jsii.member(jsii_name="putFeatureCrop")
    def put_feature_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationFeatureCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__81f2f296a92439572e9424163ff5bf346d3792184da99f4e50bfc92257af8a6e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFeatureCrop", [value]))

    @jsii.member(jsii_name="putFitAndFill")
    def put_fit_and_fill(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationFitAndFill, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0bac135f73f2af3a72342a7eeed77ff27d5c0503fbba69384ee47839e2362ebc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFitAndFill", [value]))

    @jsii.member(jsii_name="putGoop")
    def put_goop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationGoop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ccffab0ff31f9ac9ffff8f25e5491bccd86c12eeaf3a3cacdb7356f9c2b003bf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGoop", [value]))

    @jsii.member(jsii_name="putGrayscale")
    def put_grayscale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationGrayscale, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac2805cc0d4b93db1e19e095b7b8c228c672316c8631e43cb07203887ddd1088)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGrayscale", [value]))

    @jsii.member(jsii_name="putHsl")
    def put_hsl(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationHsl, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6c5e9c0169c5a705f5477732c1590625e4b295d718dcb4dbea5304463264849f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsl", [value]))

    @jsii.member(jsii_name="putHsv")
    def put_hsv(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationHsv, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__88e1ec821eebfaf2d135240af9868d8b800ee8a202c9059d06d21726ea76bbe7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsv", [value]))

    @jsii.member(jsii_name="putIfDimension")
    def put_if_dimension(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimension, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e482e3348e33601097a9921a8896d7e44494a00e41fae729dafc7bce1ec98676)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfDimension", [value]))

    @jsii.member(jsii_name="putIfOrientation")
    def put_if_orientation(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b0df359e56ed993f97500d1253a80e42e8abcf8c9b8cb1b86b7e1fac9814a907)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfOrientation", [value]))

    @jsii.member(jsii_name="putImQuery")
    def put_im_query(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationImQuery, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__afcf405e6d9f5c78b020232387a382a877056681fd7fb77a1f8fc8552b2bd0af)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putImQuery", [value]))

    @jsii.member(jsii_name="putMaxColors")
    def put_max_colors(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationMaxColors, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c35a5b19875a7a6faa344ad57cc2c147767ad4680b6fe230d80f5484226131a6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMaxColors", [value]))

    @jsii.member(jsii_name="putMirror")
    def put_mirror(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationMirror, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__529d9f1a44f6b0f24ccde2303330405d7f7f5066b1fdf97f3e4a112ef592125c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMirror", [value]))

    @jsii.member(jsii_name="putMonoHue")
    def put_mono_hue(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationMonoHue, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a1223a8d9b62081a995011fd8d5099bc300e3b35a5b53b502e55f0a14fc5d6b4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMonoHue", [value]))

    @jsii.member(jsii_name="putOpacity")
    def put_opacity(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationOpacity, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d3393ab32bd8b0901b62e633eca3412f2a052bac3f9918fb4c1fd842b31dbcbd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putOpacity", [value]))

    @jsii.member(jsii_name="putRegionOfInterestCrop")
    def put_region_of_interest_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRegionOfInterestCrop", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__50731f5b06f3763acaae28cf85c156c31d61f7964abccdfb9d030acc6d6e6192)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRegionOfInterestCrop", [value]))

    @jsii.member(jsii_name="putRelativeCrop")
    def put_relative_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRelativeCrop", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df2dba51c55169a7a2b95e89f5d48f07d97b54ca968fb68053ab32535ea72281)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRelativeCrop", [value]))

    @jsii.member(jsii_name="putRemoveColor")
    def put_remove_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRemoveColor", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__41dd6466e6c2d39bb17984ef0d8ccc0e97c4da9224378ab4dfd130c13f603024)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRemoveColor", [value]))

    @jsii.member(jsii_name="putResize")
    def put_resize(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationResize", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dd31d77a7355e88e079efe6485a09b8cb5548dc51f8a98d220805a9a2876315e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putResize", [value]))

    @jsii.member(jsii_name="putRotate")
    def put_rotate(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRotate", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2045bb63167549c934d403475624c9cdc4ef07e6d982657639e698a3a20eedac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRotate", [value]))

    @jsii.member(jsii_name="putScale")
    def put_scale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationScale", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__db95f9fc29423db1943f36384013d661bcd82d1427e6d00e962f014b02dd0c89)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putScale", [value]))

    @jsii.member(jsii_name="putShear")
    def put_shear(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationShear", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ee6c9b7bd923c4e4570545084b845d965d8bc7a10d30da844f7cd1e5357e1f1b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putShear", [value]))

    @jsii.member(jsii_name="putTrim")
    def put_trim(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationTrim", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f35800aa7ba898ffd2c51821fef9bf0c25ca1fbb84dcd320a04f2f7387e0ed41)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTrim", [value]))

    @jsii.member(jsii_name="putUnsharpMask")
    def put_unsharp_mask(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationUnsharpMask", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__71039b8ef570e718e04639de12528a072d86d6d12440372ff76c8ccb340e33db)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putUnsharpMask", [value]))

    @jsii.member(jsii_name="resetAppend")
    def reset_append(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAppend", []))

    @jsii.member(jsii_name="resetAspectCrop")
    def reset_aspect_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspectCrop", []))

    @jsii.member(jsii_name="resetBackgroundColor")
    def reset_background_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBackgroundColor", []))

    @jsii.member(jsii_name="resetBlur")
    def reset_blur(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBlur", []))

    @jsii.member(jsii_name="resetChromaKey")
    def reset_chroma_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChromaKey", []))

    @jsii.member(jsii_name="resetComposite")
    def reset_composite(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetComposite", []))

    @jsii.member(jsii_name="resetCompound")
    def reset_compound(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCompound", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetCrop")
    def reset_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCrop", []))

    @jsii.member(jsii_name="resetFaceCrop")
    def reset_face_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFaceCrop", []))

    @jsii.member(jsii_name="resetFeatureCrop")
    def reset_feature_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureCrop", []))

    @jsii.member(jsii_name="resetFitAndFill")
    def reset_fit_and_fill(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFitAndFill", []))

    @jsii.member(jsii_name="resetGoop")
    def reset_goop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGoop", []))

    @jsii.member(jsii_name="resetGrayscale")
    def reset_grayscale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGrayscale", []))

    @jsii.member(jsii_name="resetHsl")
    def reset_hsl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsl", []))

    @jsii.member(jsii_name="resetHsv")
    def reset_hsv(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsv", []))

    @jsii.member(jsii_name="resetIfDimension")
    def reset_if_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfDimension", []))

    @jsii.member(jsii_name="resetIfOrientation")
    def reset_if_orientation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfOrientation", []))

    @jsii.member(jsii_name="resetImQuery")
    def reset_im_query(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetImQuery", []))

    @jsii.member(jsii_name="resetMaxColors")
    def reset_max_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxColors", []))

    @jsii.member(jsii_name="resetMirror")
    def reset_mirror(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMirror", []))

    @jsii.member(jsii_name="resetMonoHue")
    def reset_mono_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonoHue", []))

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetRegionOfInterestCrop")
    def reset_region_of_interest_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRegionOfInterestCrop", []))

    @jsii.member(jsii_name="resetRelativeCrop")
    def reset_relative_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRelativeCrop", []))

    @jsii.member(jsii_name="resetRemoveColor")
    def reset_remove_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRemoveColor", []))

    @jsii.member(jsii_name="resetResize")
    def reset_resize(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetResize", []))

    @jsii.member(jsii_name="resetRotate")
    def reset_rotate(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRotate", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetShear")
    def reset_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetShear", []))

    @jsii.member(jsii_name="resetTrim")
    def reset_trim(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTrim", []))

    @jsii.member(jsii_name="resetUnsharpMask")
    def reset_unsharp_mask(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUnsharpMask", []))

    @builtins.property
    @jsii.member(jsii_name="append")
    def append(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationAppendList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationAppendList, jsii.get(self, "append"))

    @builtins.property
    @jsii.member(jsii_name="aspectCrop")
    def aspect_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationAspectCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationAspectCropList, jsii.get(self, "aspectCrop"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColor")
    def background_color(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationBackgroundColorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationBackgroundColorList, jsii.get(self, "backgroundColor"))

    @builtins.property
    @jsii.member(jsii_name="blur")
    def blur(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationBlurList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationBlurList, jsii.get(self, "blur"))

    @builtins.property
    @jsii.member(jsii_name="chromaKey")
    def chroma_key(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationChromaKeyList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationChromaKeyList, jsii.get(self, "chromaKey"))

    @builtins.property
    @jsii.member(jsii_name="composite")
    def composite(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCompositeList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCompositeList, jsii.get(self, "composite"))

    @builtins.property
    @jsii.member(jsii_name="compound")
    def compound(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCompoundList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCompoundList, jsii.get(self, "compound"))

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationContrastList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationContrastList, jsii.get(self, "contrast"))

    @builtins.property
    @jsii.member(jsii_name="crop")
    def crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCropList, jsii.get(self, "crop"))

    @builtins.property
    @jsii.member(jsii_name="faceCrop")
    def face_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationFaceCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationFaceCropList, jsii.get(self, "faceCrop"))

    @builtins.property
    @jsii.member(jsii_name="featureCrop")
    def feature_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationFeatureCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationFeatureCropList, jsii.get(self, "featureCrop"))

    @builtins.property
    @jsii.member(jsii_name="fitAndFill")
    def fit_and_fill(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationFitAndFillList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationFitAndFillList, jsii.get(self, "fitAndFill"))

    @builtins.property
    @jsii.member(jsii_name="goop")
    def goop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationGoopList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationGoopList, jsii.get(self, "goop"))

    @builtins.property
    @jsii.member(jsii_name="grayscale")
    def grayscale(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationGrayscaleList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationGrayscaleList, jsii.get(self, "grayscale"))

    @builtins.property
    @jsii.member(jsii_name="hsl")
    def hsl(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationHslList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationHslList, jsii.get(self, "hsl"))

    @builtins.property
    @jsii.member(jsii_name="hsv")
    def hsv(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationHsvList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationHsvList, jsii.get(self, "hsv"))

    @builtins.property
    @jsii.member(jsii_name="ifDimension")
    def if_dimension(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimensionList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimensionList, jsii.get(self, "ifDimension"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientation")
    def if_orientation(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientationList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientationList, jsii.get(self, "ifOrientation"))

    @builtins.property
    @jsii.member(jsii_name="imQuery")
    def im_query(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationImQueryList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationImQueryList, jsii.get(self, "imQuery"))

    @builtins.property
    @jsii.member(jsii_name="maxColors")
    def max_colors(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationMaxColorsList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationMaxColorsList, jsii.get(self, "maxColors"))

    @builtins.property
    @jsii.member(jsii_name="mirror")
    def mirror(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationMirrorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationMirrorList, jsii.get(self, "mirror"))

    @builtins.property
    @jsii.member(jsii_name="monoHue")
    def mono_hue(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationMonoHueList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationMonoHueList, jsii.get(self, "monoHue"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationOpacityList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationOpacityList, jsii.get(self, "opacity"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestCrop")
    def region_of_interest_crop(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRegionOfInterestCropList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRegionOfInterestCropList", jsii.get(self, "regionOfInterestCrop"))

    @builtins.property
    @jsii.member(jsii_name="relativeCrop")
    def relative_crop(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRelativeCropList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRelativeCropList", jsii.get(self, "relativeCrop"))

    @builtins.property
    @jsii.member(jsii_name="removeColor")
    def remove_color(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRemoveColorList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRemoveColorList", jsii.get(self, "removeColor"))

    @builtins.property
    @jsii.member(jsii_name="resize")
    def resize(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationResizeList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationResizeList", jsii.get(self, "resize"))

    @builtins.property
    @jsii.member(jsii_name="rotate")
    def rotate(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRotateList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRotateList", jsii.get(self, "rotate"))

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationScaleList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationScaleList", jsii.get(self, "scale"))

    @builtins.property
    @jsii.member(jsii_name="shear")
    def shear(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationShearList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationShearList", jsii.get(self, "shear"))

    @builtins.property
    @jsii.member(jsii_name="trim")
    def trim(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationTrimList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationTrimList", jsii.get(self, "trim"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMask")
    def unsharp_mask(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationUnsharpMaskList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationUnsharpMaskList", jsii.get(self, "unsharpMask"))

    @builtins.property
    @jsii.member(jsii_name="appendInput")
    def append_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationAppend]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationAppend]]], jsii.get(self, "appendInput"))

    @builtins.property
    @jsii.member(jsii_name="aspectCropInput")
    def aspect_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationAspectCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationAspectCrop]]], jsii.get(self, "aspectCropInput"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColorInput")
    def background_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationBackgroundColor]]], jsii.get(self, "backgroundColorInput"))

    @builtins.property
    @jsii.member(jsii_name="blurInput")
    def blur_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationBlur]]], jsii.get(self, "blurInput"))

    @builtins.property
    @jsii.member(jsii_name="chromaKeyInput")
    def chroma_key_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationChromaKey]]], jsii.get(self, "chromaKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="compositeInput")
    def composite_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationComposite]]], jsii.get(self, "compositeInput"))

    @builtins.property
    @jsii.member(jsii_name="compoundInput")
    def compound_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCompound]]], jsii.get(self, "compoundInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationContrast]]], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="cropInput")
    def crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCrop]]], jsii.get(self, "cropInput"))

    @builtins.property
    @jsii.member(jsii_name="faceCropInput")
    def face_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationFaceCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationFaceCrop]]], jsii.get(self, "faceCropInput"))

    @builtins.property
    @jsii.member(jsii_name="featureCropInput")
    def feature_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationFeatureCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationFeatureCrop]]], jsii.get(self, "featureCropInput"))

    @builtins.property
    @jsii.member(jsii_name="fitAndFillInput")
    def fit_and_fill_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationFitAndFill]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationFitAndFill]]], jsii.get(self, "fitAndFillInput"))

    @builtins.property
    @jsii.member(jsii_name="goopInput")
    def goop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationGoop]]], jsii.get(self, "goopInput"))

    @builtins.property
    @jsii.member(jsii_name="grayscaleInput")
    def grayscale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationGrayscale]]], jsii.get(self, "grayscaleInput"))

    @builtins.property
    @jsii.member(jsii_name="hslInput")
    def hsl_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationHsl]]], jsii.get(self, "hslInput"))

    @builtins.property
    @jsii.member(jsii_name="hsvInput")
    def hsv_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationHsv]]], jsii.get(self, "hsvInput"))

    @builtins.property
    @jsii.member(jsii_name="ifDimensionInput")
    def if_dimension_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimension]]], jsii.get(self, "ifDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientationInput")
    def if_orientation_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientation]]], jsii.get(self, "ifOrientationInput"))

    @builtins.property
    @jsii.member(jsii_name="imQueryInput")
    def im_query_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationImQuery]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationImQuery]]], jsii.get(self, "imQueryInput"))

    @builtins.property
    @jsii.member(jsii_name="maxColorsInput")
    def max_colors_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationMaxColors]]], jsii.get(self, "maxColorsInput"))

    @builtins.property
    @jsii.member(jsii_name="mirrorInput")
    def mirror_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationMirror]]], jsii.get(self, "mirrorInput"))

    @builtins.property
    @jsii.member(jsii_name="monoHueInput")
    def mono_hue_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationMonoHue]]], jsii.get(self, "monoHueInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationOpacity]]], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestCropInput")
    def region_of_interest_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRegionOfInterestCrop"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRegionOfInterestCrop"]]], jsii.get(self, "regionOfInterestCropInput"))

    @builtins.property
    @jsii.member(jsii_name="relativeCropInput")
    def relative_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRelativeCrop"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRelativeCrop"]]], jsii.get(self, "relativeCropInput"))

    @builtins.property
    @jsii.member(jsii_name="removeColorInput")
    def remove_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRemoveColor"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRemoveColor"]]], jsii.get(self, "removeColorInput"))

    @builtins.property
    @jsii.member(jsii_name="resizeInput")
    def resize_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationResize"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationResize"]]], jsii.get(self, "resizeInput"))

    @builtins.property
    @jsii.member(jsii_name="rotateInput")
    def rotate_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRotate"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRotate"]]], jsii.get(self, "rotateInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationScale"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationScale"]]], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="shearInput")
    def shear_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationShear"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationShear"]]], jsii.get(self, "shearInput"))

    @builtins.property
    @jsii.member(jsii_name="trimInput")
    def trim_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationTrim"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationTrim"]]], jsii.get(self, "trimInput"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMaskInput")
    def unsharp_mask_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationUnsharpMask"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationUnsharpMask"]]], jsii.get(self, "unsharpMaskInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb7d6eb981833530da15066447f56c05583941cf4dfa3530563100be69964e07)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRegionOfInterestCrop",
    jsii_struct_bases=[],
    name_mapping={
        "region_of_interest": "regionOfInterest",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRegionOfInterestCrop:
    def __init__(
        self,
        *,
        region_of_interest: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRegionOfInterestCropRegionOfInterest", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param region_of_interest: region_of_interest block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest DataAkamaiImagingPolicyImage#region_of_interest}
        :param gravity: The placement of the crop area relative to the specified area of interest. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: The placement of the crop area relative to the specified area of interest. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param style: Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(region_of_interest, dict):
            region_of_interest = DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRegionOfInterestCropRegionOfInterest(**region_of_interest)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__42f1ab5b390d85a04a865881fbe9eba0fbe34dd065d5c4a8bf0939daaa6941cb)
            check_type(argname="argument region_of_interest", value=region_of_interest, expected_type=type_hints["region_of_interest"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "region_of_interest": region_of_interest,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def region_of_interest(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRegionOfInterestCropRegionOfInterest":
        '''region_of_interest block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest DataAkamaiImagingPolicyImage#region_of_interest}
        '''
        result = self._values.get("region_of_interest")
        assert result is not None, "Required property 'region_of_interest' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRegionOfInterestCropRegionOfInterest", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''The placement of the crop area relative to the specified area of interest.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''The placement of the crop area relative to the specified area of interest.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRegionOfInterestCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRegionOfInterestCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRegionOfInterestCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c6ababf1a6013e392a388b289cbc3c7e7aca2bd2d1dd835764664b73718a3a10)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRegionOfInterestCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__61a7dfd2cbb77de39f36be7d6d0e1a3b1a80ff07960fa08c6f1d3f2e0ff9048f)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRegionOfInterestCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f6b9c69409aeb7ad858e8ea895e2d03611d72ce052445e7d17eaf8225c42f55a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ddfa3d04eb3666a6c53524f79ea86d5a61c4c419912056fa41c1867acaa4d82)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a22a010dafcd7bafb86775b345c18f2817ddb19848d0d461ff0a6b1a0c3d0adf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRegionOfInterestCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRegionOfInterestCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRegionOfInterestCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e152971a8d1f3dd491b33ff798e6acbdb88faa47501385ef3b94ab291ba620b5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRegionOfInterestCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRegionOfInterestCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__141f874edec5ab23d7a834eaca1d32982ee8d603927851d245348b38ee7ba66d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putRegionOfInterest")
    def put_region_of_interest(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRegionOfInterestCropRegionOfInterest()

        return typing.cast(None, jsii.invoke(self, "putRegionOfInterest", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterest")
    def region_of_interest(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRegionOfInterestCropRegionOfInterestOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRegionOfInterestCropRegionOfInterestOutputReference", jsii.get(self, "regionOfInterest"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestInput")
    def region_of_interest_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRegionOfInterestCropRegionOfInterest"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRegionOfInterestCropRegionOfInterest"], jsii.get(self, "regionOfInterestInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__41ae2a3c6ead777a8aba4483f355539479ec5c94c5605e6b47e0fe056fecb319)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c4a2b1df38c55f6afeb6f9ab99a44114f0d0c64166592fa3b331dc6898fec372)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2af6734a43a047cec2a2e53704dc52a591fe9c15af7a50e086e2395012ec0e20)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d6e7c1a33abe6e659f03eaf6d35a79c397672205416b303386cdc74231e121d9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a9d216b415d586c2e663e99d88418f7d288d8c9dfd34d6e24cf523dcf451511)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8d8537e10218a15accbcadc68087baacd101e18c9c4edb80a315b0432c46f93b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__15976aff11f463b7d0c4b039c8b2fa7d987938beae4a128f6d98c233f2d6ccf6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e8830f53bf1282600c7e3482bdcde788e4185516241222f90fac2e7b259255e8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRegionOfInterestCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRegionOfInterestCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRegionOfInterestCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__026762356511f2dc4860de6910b090a93beaedd3e94dffa861c7ea2b5a321817)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRegionOfInterestCropRegionOfInterest",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRegionOfInterestCropRegionOfInterest:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRegionOfInterestCropRegionOfInterest(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRegionOfInterestCropRegionOfInterestOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRegionOfInterestCropRegionOfInterestOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__057453f77c92cdee15e460aaa06872fadf16f9c7db481bc2b985f7286b9e06dd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRegionOfInterestCropRegionOfInterest]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRegionOfInterestCropRegionOfInterest], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRegionOfInterestCropRegionOfInterest],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ecf0dee5c14b2599d52723d1b5c15f61479153a3ecbd279a0bf3ffba1970a666)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRelativeCrop",
    jsii_struct_bases=[],
    name_mapping={
        "east": "east",
        "east_var": "eastVar",
        "north": "north",
        "north_var": "northVar",
        "south": "south",
        "south_var": "southVar",
        "west": "west",
        "west_var": "westVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRelativeCrop:
    def __init__(
        self,
        *,
        east: typing.Optional[builtins.str] = None,
        east_var: typing.Optional[builtins.str] = None,
        north: typing.Optional[builtins.str] = None,
        north_var: typing.Optional[builtins.str] = None,
        south: typing.Optional[builtins.str] = None,
        south_var: typing.Optional[builtins.str] = None,
        west: typing.Optional[builtins.str] = None,
        west_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param east: The number of pixels to shrink or expand the right side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east DataAkamaiImagingPolicyImage#east}
        :param east_var: The number of pixels to shrink or expand the right side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east_var DataAkamaiImagingPolicyImage#east_var}
        :param north: The number of pixels to shrink or expand the top side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north DataAkamaiImagingPolicyImage#north}
        :param north_var: The number of pixels to shrink or expand the top side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north_var DataAkamaiImagingPolicyImage#north_var}
        :param south: The number of pixels to shrink or expand the bottom side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south DataAkamaiImagingPolicyImage#south}
        :param south_var: The number of pixels to shrink or expand the bottom side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south_var DataAkamaiImagingPolicyImage#south_var}
        :param west: The number of pixels to shrink or expand the left side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west DataAkamaiImagingPolicyImage#west}
        :param west_var: The number of pixels to shrink or expand the left side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west_var DataAkamaiImagingPolicyImage#west_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__80c9189c4e1984a393e94a5727827d93c251cdad0c1ad9b8f4ecfd57d8fd69b1)
            check_type(argname="argument east", value=east, expected_type=type_hints["east"])
            check_type(argname="argument east_var", value=east_var, expected_type=type_hints["east_var"])
            check_type(argname="argument north", value=north, expected_type=type_hints["north"])
            check_type(argname="argument north_var", value=north_var, expected_type=type_hints["north_var"])
            check_type(argname="argument south", value=south, expected_type=type_hints["south"])
            check_type(argname="argument south_var", value=south_var, expected_type=type_hints["south_var"])
            check_type(argname="argument west", value=west, expected_type=type_hints["west"])
            check_type(argname="argument west_var", value=west_var, expected_type=type_hints["west_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if east is not None:
            self._values["east"] = east
        if east_var is not None:
            self._values["east_var"] = east_var
        if north is not None:
            self._values["north"] = north
        if north_var is not None:
            self._values["north_var"] = north_var
        if south is not None:
            self._values["south"] = south
        if south_var is not None:
            self._values["south_var"] = south_var
        if west is not None:
            self._values["west"] = west
        if west_var is not None:
            self._values["west_var"] = west_var

    @builtins.property
    def east(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the right side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east DataAkamaiImagingPolicyImage#east}
        '''
        result = self._values.get("east")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def east_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the right side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east_var DataAkamaiImagingPolicyImage#east_var}
        '''
        result = self._values.get("east_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def north(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the top side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north DataAkamaiImagingPolicyImage#north}
        '''
        result = self._values.get("north")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def north_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the top side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north_var DataAkamaiImagingPolicyImage#north_var}
        '''
        result = self._values.get("north_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def south(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the bottom side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south DataAkamaiImagingPolicyImage#south}
        '''
        result = self._values.get("south")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def south_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the bottom side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south_var DataAkamaiImagingPolicyImage#south_var}
        '''
        result = self._values.get("south_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def west(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the left side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west DataAkamaiImagingPolicyImage#west}
        '''
        result = self._values.get("west")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def west_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the left side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west_var DataAkamaiImagingPolicyImage#west_var}
        '''
        result = self._values.get("west_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRelativeCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRelativeCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRelativeCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cb5b27e4b220bc27a206d0b769dc4cf4a9fe64a11c12a10b5ee910f1f5b90d6a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRelativeCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af70a3843c269f0d76b6b1b6e34c34c9ba5e667117dece52f5ef147caf710def)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRelativeCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2e30298c211660d46cba385984329b2c170dc2f3c9cb28885ca17ec3871085ce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4579519c352bce3bdb0e61beed9ef7b642b9788cc63b3509867670a83349f67c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2302ae25ba87b04dd51904dfdd9d0bf2f70f5f377b49466f61013f408eb6d2f5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRelativeCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRelativeCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRelativeCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f4349b793489615c4b4b9caf1beb651986ed99d6d216dc122ce5bd6d0af27b01)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRelativeCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRelativeCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c5e4444eb6751676f5621e88efe299fc5506d57ae3713d98f80aeddad5040e51)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetEast")
    def reset_east(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEast", []))

    @jsii.member(jsii_name="resetEastVar")
    def reset_east_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEastVar", []))

    @jsii.member(jsii_name="resetNorth")
    def reset_north(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNorth", []))

    @jsii.member(jsii_name="resetNorthVar")
    def reset_north_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNorthVar", []))

    @jsii.member(jsii_name="resetSouth")
    def reset_south(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSouth", []))

    @jsii.member(jsii_name="resetSouthVar")
    def reset_south_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSouthVar", []))

    @jsii.member(jsii_name="resetWest")
    def reset_west(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWest", []))

    @jsii.member(jsii_name="resetWestVar")
    def reset_west_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWestVar", []))

    @builtins.property
    @jsii.member(jsii_name="eastInput")
    def east_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "eastInput"))

    @builtins.property
    @jsii.member(jsii_name="eastVarInput")
    def east_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "eastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="northInput")
    def north_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "northInput"))

    @builtins.property
    @jsii.member(jsii_name="northVarInput")
    def north_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "northVarInput"))

    @builtins.property
    @jsii.member(jsii_name="southInput")
    def south_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "southInput"))

    @builtins.property
    @jsii.member(jsii_name="southVarInput")
    def south_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "southVarInput"))

    @builtins.property
    @jsii.member(jsii_name="westInput")
    def west_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "westInput"))

    @builtins.property
    @jsii.member(jsii_name="westVarInput")
    def west_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "westVarInput"))

    @builtins.property
    @jsii.member(jsii_name="east")
    def east(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "east"))

    @east.setter
    def east(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e5b0dfe31c81680e659f6ec082c0e6464cbe4d0e3732494052dc57cb710c02bd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "east", value)

    @builtins.property
    @jsii.member(jsii_name="eastVar")
    def east_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "eastVar"))

    @east_var.setter
    def east_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__49d40885d5484e74299e697045a3c2ab39cfd045cd29d86e2ce83dc86e1084d4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "eastVar", value)

    @builtins.property
    @jsii.member(jsii_name="north")
    def north(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "north"))

    @north.setter
    def north(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b1099db70971231ed722b02e6024df603a5142fd961b60dcf2d86fa942f9a315)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "north", value)

    @builtins.property
    @jsii.member(jsii_name="northVar")
    def north_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "northVar"))

    @north_var.setter
    def north_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__16108b3a989739f206f2a5b330872fb18c715625e7cf8b85351afd7a71d0637e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "northVar", value)

    @builtins.property
    @jsii.member(jsii_name="south")
    def south(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "south"))

    @south.setter
    def south(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c48510de7dcd30a3f179de99e12d26cb76f9677c71b557c55896c11861cf379e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "south", value)

    @builtins.property
    @jsii.member(jsii_name="southVar")
    def south_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "southVar"))

    @south_var.setter
    def south_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__94d792af03792e92457e2478b020d2f7ed5f10ffb9f0f4ca3d30ae5454c4ba1a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "southVar", value)

    @builtins.property
    @jsii.member(jsii_name="west")
    def west(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "west"))

    @west.setter
    def west(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__873d6493004f4968a13f5e490345660b0cfe1a569791db544a9dfec2dcc9c0ba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "west", value)

    @builtins.property
    @jsii.member(jsii_name="westVar")
    def west_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "westVar"))

    @west_var.setter
    def west_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__67dbc8464c1264d8d919995110290fecd3328cb69ac0d142914e7c37680d9db1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "westVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRelativeCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRelativeCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRelativeCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f98f4c389d1b8a5da8ee448e0505644e2d9a559f2fa551e9adbda3a7673a2d73)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRemoveColor",
    jsii_struct_bases=[],
    name_mapping={
        "color": "color",
        "color_var": "colorVar",
        "feather": "feather",
        "feather_var": "featherVar",
        "tolerance": "tolerance",
        "tolerance_var": "toleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRemoveColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
        feather: typing.Optional[builtins.str] = None,
        feather_var: typing.Optional[builtins.str] = None,
        tolerance: typing.Optional[builtins.str] = None,
        tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        :param feather: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        :param feather_var: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        :param tolerance: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        :param tolerance_var: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dd1513d6f1d3be56aa32fc94bc5c55d55838c308cbdbf2edf96260049dbe571e)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
            check_type(argname="argument feather", value=feather, expected_type=type_hints["feather"])
            check_type(argname="argument feather_var", value=feather_var, expected_type=type_hints["feather_var"])
            check_type(argname="argument tolerance", value=tolerance, expected_type=type_hints["tolerance"])
            check_type(argname="argument tolerance_var", value=tolerance_var, expected_type=type_hints["tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var
        if feather is not None:
            self._values["feather"] = feather
        if feather_var is not None:
            self._values["feather_var"] = feather_var
        if tolerance is not None:
            self._values["tolerance"] = tolerance
        if tolerance_var is not None:
            self._values["tolerance_var"] = tolerance_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        '''
        result = self._values.get("feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather_var(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        '''
        result = self._values.get("feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        '''
        result = self._values.get("tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance_var(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        result = self._values.get("tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRemoveColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRemoveColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRemoveColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__891d4dd9b76f7f7e4125d326639bdab55dfe9823e0e92189dcc7c8f842fc860c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRemoveColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bf27d01ce307466689007cb5bc1d8439020565284ae8bbd8a495c16a46c63389)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRemoveColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0c1014296bb6cdd86659d60dcb2e0df712713800c850e8b83b0b43f5e7db3c6c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__180a098f53258e5f81b7d4029a089fbe27e14ac4dd3bfeea93421b0af72cec83)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__866c55a341cc3f7507f932561fd05a08efa88f38ee3e2e9253b459bb4b79110f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRemoveColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRemoveColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRemoveColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5e9e7d68e05263a7355eb4bbdc91a9f967e5b78e118d0e3878464ca585e9c7a5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRemoveColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRemoveColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b1d965afcb018cb76b98a2898c6312c54cf99839442ea6ff21a4b16cc861f583)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @jsii.member(jsii_name="resetFeather")
    def reset_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeather", []))

    @jsii.member(jsii_name="resetFeatherVar")
    def reset_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatherVar", []))

    @jsii.member(jsii_name="resetTolerance")
    def reset_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTolerance", []))

    @jsii.member(jsii_name="resetToleranceVar")
    def reset_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featherInput")
    def feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherInput"))

    @builtins.property
    @jsii.member(jsii_name="featherVarInput")
    def feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceInput")
    def tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceVarInput")
    def tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__663ed7fb899dcf6d527af20a8e6ab3530c8b9280eef814b6f9d70800196024f1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4e0efd04f6606d4dc7952f7cbc94262a3c7505b6a3e150025aea7a201157498b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="feather")
    def feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "feather"))

    @feather.setter
    def feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f79ec0e0a72e60f4852d3ec00ee53b7cc4f720240e9b1b62f0d0eb10bd4047ef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "feather", value)

    @builtins.property
    @jsii.member(jsii_name="featherVar")
    def feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featherVar"))

    @feather_var.setter
    def feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f8cd783b0e5d1807eab2c314d3ecc6b6956e793505ccb934fa534aa8b8c6bb43)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featherVar", value)

    @builtins.property
    @jsii.member(jsii_name="tolerance")
    def tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tolerance"))

    @tolerance.setter
    def tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c4f6e8cc307f5dde989e047570d2f00379bc67df0249f2d85ac948d58052c8e6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tolerance", value)

    @builtins.property
    @jsii.member(jsii_name="toleranceVar")
    def tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "toleranceVar"))

    @tolerance_var.setter
    def tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bf9b1619e8bf6c2417b7629de1a3fdbb86a32ea1cef4cb502a4a4486aac37a97)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "toleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRemoveColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRemoveColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRemoveColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a2702bb63b00252aebf4837e4399a98e695b5b36189cce968d3fbdaa557fded)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationResize",
    jsii_struct_bases=[],
    name_mapping={
        "aspect": "aspect",
        "aspect_var": "aspectVar",
        "height": "height",
        "height_var": "heightVar",
        "type": "type",
        "type_var": "typeVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationResize:
    def __init__(
        self,
        *,
        aspect: typing.Optional[builtins.str] = None,
        aspect_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param aspect: Preserves the aspect ratio. Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect DataAkamaiImagingPolicyImage#aspect}
        :param aspect_var: Preserves the aspect ratio. Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_var DataAkamaiImagingPolicyImage#aspect_var}
        :param height: The height to resize the source image to. Must be set if height is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height to resize the source image to. Must be set if height is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param type: Sets constraints for the image resize. Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: Sets constraints for the image resize. Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        :param width: The width to resize the source image to. Must be set if width is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width to resize the source image to. Must be set if width is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__70dd73d548a15eb467837c09ed240c868e647d53198ebee6e0caa5c214dd2854)
            check_type(argname="argument aspect", value=aspect, expected_type=type_hints["aspect"])
            check_type(argname="argument aspect_var", value=aspect_var, expected_type=type_hints["aspect_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if aspect is not None:
            self._values["aspect"] = aspect
        if aspect_var is not None:
            self._values["aspect_var"] = aspect_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def aspect(self) -> typing.Optional[builtins.str]:
        '''Preserves the aspect ratio.

        Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect DataAkamaiImagingPolicyImage#aspect}
        '''
        result = self._values.get("aspect")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def aspect_var(self) -> typing.Optional[builtins.str]:
        '''Preserves the aspect ratio.

        Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_var DataAkamaiImagingPolicyImage#aspect_var}
        '''
        result = self._values.get("aspect_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height to resize the source image to. Must be set if height is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height to resize the source image to. Must be set if height is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''Sets constraints for the image resize.

        Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''Sets constraints for the image resize.

        Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width to resize the source image to. Must be set if width is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width to resize the source image to. Must be set if width is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationResize(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationResizeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationResizeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__55295017dddfa8c6965b1f61f844e5e110914071e3b4b055beb0fe72b9929a51)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationResizeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bed14dbaa271e2afb3e9a6f97dd2f8c67e67a5c94653df4f13128c04fa7f9889)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationResizeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8638d5ead0fb9c2c5102a6d25fed40022c13585139d47770f8b190492d195f56)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d9230871bbb6b96577e49616945989b99628f1f432c2ac30e394d68c523caf84)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6ca3b117e76ba2c69646b975b0f07f91f1e54ef19886046094c2d2c639de6ae8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationResize]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationResize]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationResize]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__48113c3aed3b96868e96869f6640d42487f3d6ab4aa16f530de7c76a26a6ed35)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationResizeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationResizeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7c1c5aafc474fdd6180d72cdfceb98dd32b1cdc4d027bcc31e757ea2a84737f0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAspect")
    def reset_aspect(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspect", []))

    @jsii.member(jsii_name="resetAspectVar")
    def reset_aspect_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspectVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="aspectInput")
    def aspect_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "aspectInput"))

    @builtins.property
    @jsii.member(jsii_name="aspectVarInput")
    def aspect_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "aspectVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="aspect")
    def aspect(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "aspect"))

    @aspect.setter
    def aspect(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a68677060d49ae5db3dd766e009469c620dd0d253d03edf562c4ba31833fd332)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "aspect", value)

    @builtins.property
    @jsii.member(jsii_name="aspectVar")
    def aspect_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "aspectVar"))

    @aspect_var.setter
    def aspect_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f4846d920dd0647d4c34b80b62075a77cd446c83554de9b99e462e4d75c5b708)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "aspectVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4c0a19dfac9ca1c2936be9133b7c9728f192b6c5f7b162406c316185447fa041)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__05b50d5002c71586082e122bc5f995b638af2cfc880d6fe0e69f859eb9a4ef5b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b6c2f692b207b217ffbeced3e4252feb5d32b226a77089cef43a0ab84c957075)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ecfba1bb227b1e09264c213eb58130ee6c779a279e5a436773dfd6605eb332b2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d7a5f4fe5731e8989e0c12a32b38fb152cac1bc147c46e27a390054f5b6f30ee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6b22eec492c5e1a6c58f1d5d146d56bd48b95514fea57799482b64f30489a1c8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationResize]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationResize]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationResize]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__736ad9d399c876be01610b33bcdb569ac4df8da8df62cb3e80d0edacd800f958)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRotate",
    jsii_struct_bases=[],
    name_mapping={"degrees": "degrees", "degrees_var": "degreesVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRotate:
    def __init__(
        self,
        *,
        degrees: typing.Optional[builtins.str] = None,
        degrees_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param degrees: The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees DataAkamaiImagingPolicyImage#degrees}
        :param degrees_var: The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees_var DataAkamaiImagingPolicyImage#degrees_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cb05125df563dc399faa178d2aeee9a29c2b3ca6e5d17cd96561225dae72f57b)
            check_type(argname="argument degrees", value=degrees, expected_type=type_hints["degrees"])
            check_type(argname="argument degrees_var", value=degrees_var, expected_type=type_hints["degrees_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if degrees is not None:
            self._values["degrees"] = degrees
        if degrees_var is not None:
            self._values["degrees_var"] = degrees_var

    @builtins.property
    def degrees(self) -> typing.Optional[builtins.str]:
        '''The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees DataAkamaiImagingPolicyImage#degrees}
        '''
        result = self._values.get("degrees")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def degrees_var(self) -> typing.Optional[builtins.str]:
        '''The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees_var DataAkamaiImagingPolicyImage#degrees_var}
        '''
        result = self._values.get("degrees_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRotate(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRotateList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRotateList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ca88ece34af24049585cabfa3bcf60b2e150f5d615ff008b8ac68e92eca486a7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRotateOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__32dc65742d0cd3cd86ab3ea16e185c4545c529548b51d3561aa4b240930d9c80)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRotateOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0102e628f8bf1e2be6012403f62502c92bf7e2d6d4434b4f4c59c7d31a1efb85)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__18e85de53f0b1f9ea519b6bb8690606c0874bda956d96622ba431ab0c08ce2ad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c596fd13c334ae2e8a0a0721c6ba12570b2f1933a52f07755e05013f56181be4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRotate]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRotate]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRotate]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a2a510b96c851f293b42e1eab8363f0e7eac3c7901a74789da4b18c4f0dc5ebe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRotateOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRotateOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e4ad24ed7172e074bf0b3fa8d8a408f52e9f20250981220e3df29366fb2ab5db)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetDegrees")
    def reset_degrees(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDegrees", []))

    @jsii.member(jsii_name="resetDegreesVar")
    def reset_degrees_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDegreesVar", []))

    @builtins.property
    @jsii.member(jsii_name="degreesInput")
    def degrees_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "degreesInput"))

    @builtins.property
    @jsii.member(jsii_name="degreesVarInput")
    def degrees_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "degreesVarInput"))

    @builtins.property
    @jsii.member(jsii_name="degrees")
    def degrees(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "degrees"))

    @degrees.setter
    def degrees(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df0e5fb87483967c6c3bed551ca1c5cf8d3b39d7c8c73f969489737b2828a5d9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "degrees", value)

    @builtins.property
    @jsii.member(jsii_name="degreesVar")
    def degrees_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "degreesVar"))

    @degrees_var.setter
    def degrees_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2fc3dd958cc660c58e9fd5d8f15bbd2f6417c2f82055bd0f74fafe241f4b8b33)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "degreesVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRotate]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRotate]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRotate]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4468dbfa8e2e2121812656e540daffca80453f224eafb988e6e6956057f19a0d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationScale",
    jsii_struct_bases=[],
    name_mapping={
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationScale:
    def __init__(
        self,
        *,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param height: Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged. Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged. Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3592b809f908994ffb9699d23ab5f06b12267293b5ff7f5c2baf7078459419cb)
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size.

        Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size.

        Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged.

        Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged.

        Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationScale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationScaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationScaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fc2e65cd772a956f10d15975d589f66f92c4dfe0b03738d0c2020f550ed104ed)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationScaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a90e5f9f5875aa03115c25dfdc891f1add3aeb2880c957e79414db765f4f3803)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationScaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9f650dc8198793d6ab557c1b3711d7c8327b08717646566bc8c938ff368e5fbe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f57072537f8acf8b73946188bb2708fdc0102c2948f23f2f02395ddb24b1591e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c612f932d4df5eacdd380e1f41453bfbeab27c233a66204a743859ce10d1e55f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationScale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationScale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationScale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bf1a88117e5d511aa40077d2913265875221bd9334074a4a82f5f7569e1de333)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationScaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationScaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c16e5b7e622cb5cb02e546ef48a7b31a897d5bae05b7c6a4f823cf0bf54b74b6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bedb3c3330b003544febd62c398d9046792fbe0e5b5a08512eb680d7af0303f5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__58880fc7c52f55d8ddce931aaebbebe06c296a339a24cc5cb9266323670b5234)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5be2bc65516966f5b4ed8ebdc7e34ae14f46b761671f594adeb7b2630b9264c1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__543b391b6ecfc5ffd275f298f38b8e429378de0207e0b19ac675d0aff7d01d06)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationScale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationScale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationScale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d7ac79bc22a174e0141c6fd9cdda0f5c302818ff4a6a7c418bf6600300e9fcca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationShear",
    jsii_struct_bases=[],
    name_mapping={
        "x_shear": "xShear",
        "x_shear_var": "xShearVar",
        "y_shear": "yShear",
        "y_shear_var": "yShearVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationShear:
    def __init__(
        self,
        *,
        x_shear: typing.Optional[builtins.str] = None,
        x_shear_var: typing.Optional[builtins.str] = None,
        y_shear: typing.Optional[builtins.str] = None,
        y_shear_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param x_shear: The amount to shear along the x-axis, measured in multiples of the image's width. Must be set if yShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear DataAkamaiImagingPolicyImage#x_shear}
        :param x_shear_var: The amount to shear along the x-axis, measured in multiples of the image's width. Must be set if yShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear_var DataAkamaiImagingPolicyImage#x_shear_var}
        :param y_shear: The amount to shear along the y-axis, measured in multiples of the image's height. Must be set if xShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear DataAkamaiImagingPolicyImage#y_shear}
        :param y_shear_var: The amount to shear along the y-axis, measured in multiples of the image's height. Must be set if xShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear_var DataAkamaiImagingPolicyImage#y_shear_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__efcfcfe0c775c6aaa2b323541bff4439a5117ba0302925bebb07052081d1ca4c)
            check_type(argname="argument x_shear", value=x_shear, expected_type=type_hints["x_shear"])
            check_type(argname="argument x_shear_var", value=x_shear_var, expected_type=type_hints["x_shear_var"])
            check_type(argname="argument y_shear", value=y_shear, expected_type=type_hints["y_shear"])
            check_type(argname="argument y_shear_var", value=y_shear_var, expected_type=type_hints["y_shear_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if x_shear is not None:
            self._values["x_shear"] = x_shear
        if x_shear_var is not None:
            self._values["x_shear_var"] = x_shear_var
        if y_shear is not None:
            self._values["y_shear"] = y_shear
        if y_shear_var is not None:
            self._values["y_shear_var"] = y_shear_var

    @builtins.property
    def x_shear(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the x-axis, measured in multiples of the image's width.

        Must be set if yShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear DataAkamaiImagingPolicyImage#x_shear}
        '''
        result = self._values.get("x_shear")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_shear_var(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the x-axis, measured in multiples of the image's width.

        Must be set if yShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear_var DataAkamaiImagingPolicyImage#x_shear_var}
        '''
        result = self._values.get("x_shear_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_shear(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the y-axis, measured in multiples of the image's height.

        Must be set if xShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear DataAkamaiImagingPolicyImage#y_shear}
        '''
        result = self._values.get("y_shear")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_shear_var(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the y-axis, measured in multiples of the image's height.

        Must be set if xShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear_var DataAkamaiImagingPolicyImage#y_shear_var}
        '''
        result = self._values.get("y_shear_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationShear(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationShearList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationShearList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__28b13283fc7304895b8179a17e357b03f5958b63118352696c955ee23c08b920)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationShearOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__22c6a14b9d34c8d4ae49bc85d224ef5b1944cf78fef0ab8ebf75cd2d3790925a)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationShearOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__123fa93977395072c010bdda8a802a7f8d354dde00b4da808bf10c86837de742)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__677d016f1826800bc6a036842ef94f68e8781345d1bd327d6445c040eaa14d91)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5581515e14d7a9ef691f644e4bc0a90a3631b294c367ad8fd20edb63c4f80ad9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationShear]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationShear]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationShear]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a2f8a16bd051e17b227d6c561ad473301c5019788a4a165c2b51a39140cce9f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationShearOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationShearOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__42158b99b9fd7d8b4926cbcea9ca80f9d30bd537fa69e1b1a8be2a2165938e99)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetXShear")
    def reset_x_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXShear", []))

    @jsii.member(jsii_name="resetXShearVar")
    def reset_x_shear_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXShearVar", []))

    @jsii.member(jsii_name="resetYShear")
    def reset_y_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYShear", []))

    @jsii.member(jsii_name="resetYShearVar")
    def reset_y_shear_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYShearVar", []))

    @builtins.property
    @jsii.member(jsii_name="xShearInput")
    def x_shear_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xShearInput"))

    @builtins.property
    @jsii.member(jsii_name="xShearVarInput")
    def x_shear_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xShearVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yShearInput")
    def y_shear_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yShearInput"))

    @builtins.property
    @jsii.member(jsii_name="yShearVarInput")
    def y_shear_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yShearVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xShear")
    def x_shear(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xShear"))

    @x_shear.setter
    def x_shear(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aa15cd2d7a6ad7e59e76eb2900079c499fe0b0d4feede57debc97240d035a553)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xShear", value)

    @builtins.property
    @jsii.member(jsii_name="xShearVar")
    def x_shear_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xShearVar"))

    @x_shear_var.setter
    def x_shear_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0e45cc51ef30c0f91e6ed9e9373f513e2b0d573a688220cfd053db83d834bfee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xShearVar", value)

    @builtins.property
    @jsii.member(jsii_name="yShear")
    def y_shear(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yShear"))

    @y_shear.setter
    def y_shear(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f5a4ab69fc7b0f0422faa1e118c299f5f379d3e8294370af8070ceb1746124d3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yShear", value)

    @builtins.property
    @jsii.member(jsii_name="yShearVar")
    def y_shear_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yShearVar"))

    @y_shear_var.setter
    def y_shear_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__577790ec9561c51225b093fd75d5cffde41ff4c4191422e5466ecb20ac5d85c1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yShearVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationShear]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationShear]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationShear]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__35b649330c5599821ad1ff8998f2eac5d432ef1c2934c630848e6e0cdbedfaf3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationTrim",
    jsii_struct_bases=[],
    name_mapping={
        "fuzz": "fuzz",
        "fuzz_var": "fuzzVar",
        "padding": "padding",
        "padding_var": "paddingVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationTrim:
    def __init__(
        self,
        *,
        fuzz: typing.Optional[builtins.str] = None,
        fuzz_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fuzz: The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz DataAkamaiImagingPolicyImage#fuzz}
        :param fuzz_var: The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz_var DataAkamaiImagingPolicyImage#fuzz_var}
        :param padding: The amount of padding in pixels to add to the trimmed image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: The amount of padding in pixels to add to the trimmed image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__410c5353b8ad26bbdad27efbc30c18a79ba1fd42baa6717f0f47145cb0a4e178)
            check_type(argname="argument fuzz", value=fuzz, expected_type=type_hints["fuzz"])
            check_type(argname="argument fuzz_var", value=fuzz_var, expected_type=type_hints["fuzz_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fuzz is not None:
            self._values["fuzz"] = fuzz
        if fuzz_var is not None:
            self._values["fuzz_var"] = fuzz_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var

    @builtins.property
    def fuzz(self) -> typing.Optional[builtins.str]:
        '''The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz DataAkamaiImagingPolicyImage#fuzz}
        '''
        result = self._values.get("fuzz")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fuzz_var(self) -> typing.Optional[builtins.str]:
        '''The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz_var DataAkamaiImagingPolicyImage#fuzz_var}
        '''
        result = self._values.get("fuzz_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''The amount of padding in pixels to add to the trimmed image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''The amount of padding in pixels to add to the trimmed image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationTrim(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationTrimList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationTrimList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a95f4b117717e25452ac5e8c57363656a27a268f9be9164ae58b980d3ff3a5f2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationTrimOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ff734d68c2e7e51df1d57f79f0aa134ec2b493005ede64642fd20371224ba315)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationTrimOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1124131e415ee83f00ac4c8433cd8d454bb1d19f253c00c37b6a71d6ec384f5c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__11974f0b08057b6527d2be3ae1d29759d0bb96cd847703a6cd2038ff50b9f7f3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ada467c256021b33d49cd5a2d917153424c57bf5f19de0d3dc411ca7bcc5144)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationTrim]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationTrim]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationTrim]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6b5d0b2cd46ab40cfa10bbc43f52645276a0c7db21605bec9d42d991fca281cd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationTrimOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationTrimOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c12284ec0564722419541edacee81a3f1a7ba4e16dc2ab83550d1de6c3eb8c60)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetFuzz")
    def reset_fuzz(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFuzz", []))

    @jsii.member(jsii_name="resetFuzzVar")
    def reset_fuzz_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFuzzVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @builtins.property
    @jsii.member(jsii_name="fuzzInput")
    def fuzz_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fuzzInput"))

    @builtins.property
    @jsii.member(jsii_name="fuzzVarInput")
    def fuzz_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fuzzVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="fuzz")
    def fuzz(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fuzz"))

    @fuzz.setter
    def fuzz(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b99008527c25171534713759f57087717a25255f4ee06dfa42e97847c7fe1611)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fuzz", value)

    @builtins.property
    @jsii.member(jsii_name="fuzzVar")
    def fuzz_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fuzzVar"))

    @fuzz_var.setter
    def fuzz_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c4ebd9b6ebf3adc85af0a05c82e58b9549e700f504b10c563d85cf4da4c6d6d2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fuzzVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c58d3412a246ceb6517d99b22bcc95c8f34e8aa2a8fd0e72f0ef4c7bbcfdef1b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__00c598869bca2f96fead2ae120bb6b8940fbf6ac423c81f5169711397c7036c9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationTrim]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationTrim]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationTrim]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e0667d3bb4257034eb3c9cd439d2860813aa9763b25d0df0ffebf2216634dafc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationUnsharpMask",
    jsii_struct_bases=[],
    name_mapping={
        "gain": "gain",
        "gain_var": "gainVar",
        "sigma": "sigma",
        "sigma_var": "sigmaVar",
        "threshold": "threshold",
        "threshold_var": "thresholdVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationUnsharpMask:
    def __init__(
        self,
        *,
        gain: typing.Optional[builtins.str] = None,
        gain_var: typing.Optional[builtins.str] = None,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
        threshold: typing.Optional[builtins.str] = None,
        threshold_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param gain: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        :param gain_var: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        :param sigma: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        :param threshold: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        :param threshold_var: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__837c92ab2ff8327d33f3d5faf644b6f1743dbf3923fc253234b874e5f57dbed5)
            check_type(argname="argument gain", value=gain, expected_type=type_hints["gain"])
            check_type(argname="argument gain_var", value=gain_var, expected_type=type_hints["gain_var"])
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
            check_type(argname="argument threshold", value=threshold, expected_type=type_hints["threshold"])
            check_type(argname="argument threshold_var", value=threshold_var, expected_type=type_hints["threshold_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if gain is not None:
            self._values["gain"] = gain
        if gain_var is not None:
            self._values["gain_var"] = gain_var
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var
        if threshold is not None:
            self._values["threshold"] = threshold
        if threshold_var is not None:
            self._values["threshold_var"] = threshold_var

    @builtins.property
    def gain(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        '''
        result = self._values.get("gain")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gain_var(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        '''
        result = self._values.get("gain_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        '''
        result = self._values.get("threshold")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold_var(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        result = self._values.get("threshold_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationUnsharpMask(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationUnsharpMaskList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationUnsharpMaskList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__36562ffba2cf8d1ed218c214bef840bd11087d6a49d35d6f376c9f5af26019dd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationUnsharpMaskOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a5c594615d6eecf23dfa34d946e3c43d683e9e620e20899b8e7554381c308641)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationUnsharpMaskOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__145d0be0ecd87b1f1186daba57925585286f62e3c56684f5155cb71bb8833006)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__894f536d649ec0f787af89bf35446b8a2434374e4c35bbd9be8822b24e90ac79)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d2690211bdc94bfe7621387fe70222f243f58f994c0040b9062fe384241bee4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationUnsharpMask]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationUnsharpMask]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationUnsharpMask]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__596e51152ae87b857f2a45a9b51b1755939ab9af6b9db73a843a48c469c126c1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationUnsharpMaskOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationUnsharpMaskOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d740f9f7784cc1d6dddcce80af33e1714c896668efd5c0fb4fbf9c0a54622b4a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetGain")
    def reset_gain(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGain", []))

    @jsii.member(jsii_name="resetGainVar")
    def reset_gain_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGainVar", []))

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @jsii.member(jsii_name="resetThreshold")
    def reset_threshold(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThreshold", []))

    @jsii.member(jsii_name="resetThresholdVar")
    def reset_threshold_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThresholdVar", []))

    @builtins.property
    @jsii.member(jsii_name="gainInput")
    def gain_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainInput"))

    @builtins.property
    @jsii.member(jsii_name="gainVarInput")
    def gain_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdInput")
    def threshold_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdVarInput")
    def threshold_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gain")
    def gain(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gain"))

    @gain.setter
    def gain(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__261d96b4f776f2a511069b292cf2e9c52bb361e0c1ff32b14d4479e80732009b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gain", value)

    @builtins.property
    @jsii.member(jsii_name="gainVar")
    def gain_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gainVar"))

    @gain_var.setter
    def gain_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__15e0f0f692d5fdaa69687f9c435f305d1a1143b6c3054be76ef442144177da76)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gainVar", value)

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__187bcc225961cee27d0ca500c708922c73fde3091fb5217eb4b3bf9d2327dd34)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b854958c47819da705c3ae35f3a1223edaf46eec6a192ed057c743ff09d832be)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="threshold")
    def threshold(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "threshold"))

    @threshold.setter
    def threshold(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aeaf17901374b116bda4e629c9075a3f739cf4ebd28c847880e5d89a75a5cc4c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "threshold", value)

    @builtins.property
    @jsii.member(jsii_name="thresholdVar")
    def threshold_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "thresholdVar"))

    @threshold_var.setter
    def threshold_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eef93fb0ce15619a03b62e6124a6577c19084328c50d58616af3e29d3eef9111)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "thresholdVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationUnsharpMask]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationUnsharpMask]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationUnsharpMask]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__92ed4cee714898bd77adec06e8c31297b78d46df910e3d72dbdd279484113a82)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f8942f1399b09eb0659cfd5628f707eaec5398ff2c6d81db0bc3f8e227f43ac)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__03a544b1d9ac7faeb24fed5ded39048695094c7b292a7d0df8d8a4b12346d49b)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompositeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__37578b3d0d06489c78bc52b3561ca3fc53e9cb92acafc6d36a1e9dc9abae3d1c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9f7a604990865c81b6086699118b588b04be63f6153a4cc6da59234562b4bf1a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3164405fb9bdcf5eae48d04f58bdace8fe9d4008265576b39e67d901a40f58b6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsComposite]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsComposite]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ef302a8c33eb5d99db7b1408332568eeaf9b03ffb786785147cb798b3744f9c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompositeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__67edf9f0f90f8cd2009ac9aa75271bc54032f808bf5f7ad661987bc733037fe0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(
        self,
        *,
        box_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
        circle_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
        text_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
        url_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param box_image: box_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#box_image DataAkamaiImagingPolicyImage#box_image}
        :param circle_image: circle_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#circle_image DataAkamaiImagingPolicyImage#circle_image}
        :param text_image: text_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text_image DataAkamaiImagingPolicyImage#text_image}
        :param url_image: url_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url_image DataAkamaiImagingPolicyImage#url_image}
        '''
        value = DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImage(
            box_image=box_image,
            circle_image=circle_image,
            text_image=text_image,
            url_image=url_image,
        )

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPlacement")
    def reset_placement(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacement", []))

    @jsii.member(jsii_name="resetPlacementVar")
    def reset_placement_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacementVar", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetScaleDimension")
    def reset_scale_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimension", []))

    @jsii.member(jsii_name="resetScaleDimensionVar")
    def reset_scale_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimensionVar", []))

    @jsii.member(jsii_name="resetScaleVar")
    def reset_scale_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="placementInput")
    def placement_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementInput"))

    @builtins.property
    @jsii.member(jsii_name="placementVarInput")
    def placement_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionInput")
    def scale_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVarInput")
    def scale_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleVarInput")
    def scale_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__82a8383ae430df98c7b90b3079d55f99a4448b16e01639c6aa2fae656b0dbb4c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1ffd28930bc926eddb86d0c462841232740d5db723eb836825ec9464a25f079a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="placement")
    def placement(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placement"))

    @placement.setter
    def placement(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0308da92be26ae82495f6b0e70d952f59cd714cc34f3d3059143db31cc14e31a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placement", value)

    @builtins.property
    @jsii.member(jsii_name="placementVar")
    def placement_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placementVar"))

    @placement_var.setter
    def placement_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__741cbf32bed3acdff9228a4b2c4fd2c3484a673005ce103c89fa73143622fea9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placementVar", value)

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scale"))

    @scale.setter
    def scale(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d90a298c249c3e4294b9f582ef4801ec92d98b5b529c543d557d29eec687a666)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scale", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimension")
    def scale_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimension"))

    @scale_dimension.setter
    def scale_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1ba550b818b2bb516fa0e1ae96e56fc48e7c732033cfd2398f75d572dab30487)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimension", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVar")
    def scale_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimensionVar"))

    @scale_dimension_var.setter
    def scale_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2da89058d2b9d0e5b3b4d6c16c1689bf07d4027925870bc4bd8f3fb5a49dc638)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="scaleVar")
    def scale_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleVar"))

    @scale_var.setter
    def scale_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f27550ed4c44a6ff474b590b979883b80eec92c3bf94e7f378017bb1fd0505be)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be6a8cc60d17c759f93e412a556fa15b237e0fa794ee3ac8cad011cc293cf6d7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e2c63eba139ad34f900c5425a5fe59198060eca01287314ade3fa13f318b4213)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9f0d02cb6b904c1c78c99948fcfe675b841b721d223f71189f47c57da5ab8ede)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__12824e2085dc12deff30d78e24249f8c443fb238e6b2269050deb6518143b946)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsComposite]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsComposite]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsComposite]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd8ef2e98de1c17da4565402995086ebb1ffc9702cdd7bde9cfe220ee6fde2ed)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompound",
    jsii_struct_bases=[],
    name_mapping={"transformations": "transformations"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCompound:
    def __init__(
        self,
        *,
        transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformations, typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param transformations: transformations block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0a658c3d581b4d91bd987a3792eb64150735dd08a172144a8c7600497bb3fab7)
            check_type(argname="argument transformations", value=transformations, expected_type=type_hints["transformations"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if transformations is not None:
            self._values["transformations"] = transformations

    @builtins.property
    def transformations(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformations]]]:
        '''transformations block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        result = self._values.get("transformations")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformations]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCompound(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsCompoundList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompoundList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1afb19b2b8c458e69ad2a8e9174cfd09d1d7cb33975390340279ab971600ac52)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCompoundOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c95e0d186e6f0d139d880d7c934ea904cd6f18fec693fb8c8beb1cb1540dda94)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCompoundOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8c7013debfc49db9a411deb0da79e74d8c7744ce4290a67f625e5e4ab68097b3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__efc4c40529db985e09bae2a82252d0948bdee652fdf76bd6597471ec9b42bbe1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0307bde751d2bae18997f3f9f115933802f71b21405cd0af104cc24012b09f48)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompound]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompound]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0df56fb56d89fd36e1c61cc777ed97227970cbdeea5793703795d2e8d122a991)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsCompoundOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCompoundOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e2b59b056fdf47cc9495a84680590057cba3cb9466f44ae4415ef2b194b218d3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformations")
    def put_transformations(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformations, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4f7d6ee1d6ea6165f168b9e504cc4aa08828cad4cfeddab6a9d15a46382b2d18)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTransformations", [value]))

    @jsii.member(jsii_name="resetTransformations")
    def reset_transformations(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformations", []))

    @builtins.property
    @jsii.member(jsii_name="transformations")
    def transformations(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsList", jsii.get(self, "transformations"))

    @builtins.property
    @jsii.member(jsii_name="transformationsInput")
    def transformations_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformations]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformations]]], jsii.get(self, "transformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompound]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompound]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCompound]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a823803f80c70a189d996b37e556f085650236ea51c4a79aa89f7849653649e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsContrast",
    jsii_struct_bases=[],
    name_mapping={
        "brightness": "brightness",
        "brightness_var": "brightnessVar",
        "contrast": "contrast",
        "contrast_var": "contrastVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsContrast:
    def __init__(
        self,
        *,
        brightness: typing.Optional[builtins.str] = None,
        brightness_var: typing.Optional[builtins.str] = None,
        contrast: typing.Optional[builtins.str] = None,
        contrast_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param brightness: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        :param brightness_var: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        :param contrast: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param contrast_var: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6dcfbf0281f7330266316f01450c53fffca6309deae8c2bfe3cd2bc172f735a6)
            check_type(argname="argument brightness", value=brightness, expected_type=type_hints["brightness"])
            check_type(argname="argument brightness_var", value=brightness_var, expected_type=type_hints["brightness_var"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument contrast_var", value=contrast_var, expected_type=type_hints["contrast_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if brightness is not None:
            self._values["brightness"] = brightness
        if brightness_var is not None:
            self._values["brightness_var"] = brightness_var
        if contrast is not None:
            self._values["contrast"] = contrast
        if contrast_var is not None:
            self._values["contrast_var"] = contrast_var

    @builtins.property
    def brightness(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        '''
        result = self._values.get("brightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def brightness_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        '''
        result = self._values.get("brightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        result = self._values.get("contrast_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsContrast(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsContrastList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsContrastList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bf1fa718109d8350c9c050c59d43effe0e8e742d5c58ed23715daaaad53e6b5a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsContrastOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f635202644926b2f562316230df48efa367720547a20cb7da036d62bf0cb4552)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsContrastOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6b1f03b8e09f5028ef1099fb8347de994fdbef64afef4756070310ec7621596d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__57ddc223f77ac1d8a2c0d2f5aa57622ff60299a1fc0fc43d44b9cb80d170ed30)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a7d201a0ac4b02481746541b2012136e2a50144e630edbe38894141fce89b5b4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsContrast]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsContrast]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df6a0b49361d5ef66af5cfe647bd55bedcc6943920eeff8704f5e455357f6a7c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsContrastOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsContrastOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1e6389be90a7b5533ab8b5cc9ba5595ba783b4f0e6e208cb88194ce7b5e86430)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetBrightness")
    def reset_brightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightness", []))

    @jsii.member(jsii_name="resetBrightnessVar")
    def reset_brightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightnessVar", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetContrastVar")
    def reset_contrast_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrastVar", []))

    @builtins.property
    @jsii.member(jsii_name="brightnessInput")
    def brightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="brightnessVarInput")
    def brightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastVarInput")
    def contrast_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="brightness")
    def brightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightness"))

    @brightness.setter
    def brightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9587b805b3864e70934bf637c5f9b42441604d0f3b6f797a084b7769460c4151)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightness", value)

    @builtins.property
    @jsii.member(jsii_name="brightnessVar")
    def brightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightnessVar"))

    @brightness_var.setter
    def brightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a3125cedb984150108f3da4c97fcbfd03eacea1f464bd75d919c5009fbbd301d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrast"))

    @contrast.setter
    def contrast(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5aeb50d2ddd0683d19f589cd2a3f240b425e5685a525537f66c9661980951be2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrast", value)

    @builtins.property
    @jsii.member(jsii_name="contrastVar")
    def contrast_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrastVar"))

    @contrast_var.setter
    def contrast_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__de2d3de6ee898fa300ecea3301456d1af8c24fa4408b2c5ac4d6c42152a31c57)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrastVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsContrast]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsContrast]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsContrast]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eb5e3b91cbb981244beae94c676b78bfc953de258e6f8ccbefe74c929024f4ea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCrop",
    jsii_struct_bases=[],
    name_mapping={
        "allow_expansion": "allowExpansion",
        "allow_expansion_var": "allowExpansionVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsCrop:
    def __init__(
        self,
        *,
        allow_expansion: typing.Optional[builtins.str] = None,
        allow_expansion_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_expansion: If cropping an area outside of the existing canvas, expands the image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        :param allow_expansion_var: If cropping an area outside of the existing canvas, expands the image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        :param gravity: Frame of reference for X and Y Positions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Frame of reference for X and Y Positions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The number of pixels to crop along the y-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The number of pixels to crop along the y-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The number of pixels to crop along the x-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The number of pixels to crop along the x-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        :param x_position: The x-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9df5b93bd868f5987f9c9a981a3b98be4f3097248ee9a688f3fcf1a0e4ce6714)
            check_type(argname="argument allow_expansion", value=allow_expansion, expected_type=type_hints["allow_expansion"])
            check_type(argname="argument allow_expansion_var", value=allow_expansion_var, expected_type=type_hints["allow_expansion_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if allow_expansion is not None:
            self._values["allow_expansion"] = allow_expansion
        if allow_expansion_var is not None:
            self._values["allow_expansion_var"] = allow_expansion_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def allow_expansion(self) -> typing.Optional[builtins.str]:
        '''If cropping an area outside of the existing canvas, expands the image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        '''
        result = self._values.get("allow_expansion")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def allow_expansion_var(self) -> typing.Optional[builtins.str]:
        '''If cropping an area outside of the existing canvas, expands the image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        '''
        result = self._values.get("allow_expansion_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Frame of reference for X and Y Positions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Frame of reference for X and Y Positions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the y-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the y-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the x-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the x-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__430e50070eba73461a69d0824f398c921169e420540ffc7524893b357147f022)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f1bc11bdfd48aebdfd5e1b0eb2ffd4c750751cf68508c8eda5949c44e02f06d0)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8e959b55e8dbfb8bba1ea586a7513883e99574bda11448b477ed06a7a7b6cbaf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1b4ad3cb64638465c445039180ab88255d60d477314dafc07ca194be6bdf045c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ebe4630da07588b361254c4a0a3d92d4641668db4e889222c5a5ca17f2e4e51)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__43f02ff1df01b0f31853c43e507d62bc9d1bcfe0a9f86a86f6bb21966c867b04)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__97354fe0d3e7afcf85c618fb27912d81bd369fe3de81603b372f5eb14886c5ab)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAllowExpansion")
    def reset_allow_expansion(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansion", []))

    @jsii.member(jsii_name="resetAllowExpansionVar")
    def reset_allow_expansion_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansionVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionInput")
    def allow_expansion_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVarInput")
    def allow_expansion_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansion")
    def allow_expansion(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansion"))

    @allow_expansion.setter
    def allow_expansion(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__873d0c2ecc4108b71c521806c54bdd5fcef63482ec903fb4be62a31600da23c0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansion", value)

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVar")
    def allow_expansion_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansionVar"))

    @allow_expansion_var.setter
    def allow_expansion_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a0c12e99b6bc71a9d6a2d66102ad18e957ffd58adfdfb024e12402c43f03874b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansionVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f4a883a1a2824940d29f19e22afd6232111a3378ed176cde3ca4b9d75e42ce6d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6a3b15621e023cc61454311582965d42ab7b57140956e3d9a4328c8e074b20df)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ee8768a6fac0f14af5b95d50ee290dd609a6413c76a998468855980b8f1e2795)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__45957c28fa4c5eb7860eea435dc4134bb29755de88ba50f0fac27d89dd891aac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c2f42c8755adfcc3c528a2b4e1157e70d4b710f1ce5cb0cdfc38fedc61beceda)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bf442704399bbb1f392d37ef6c80abfd00b7b076429e2cf3a62a0d36841d3871)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__55ee3264ce4110bc569eb415c7faaa7922d32c23c5d4ebaabef149fed72848d4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b1fba4b263b26f66ee7a6c170664754b078ca5fe7c85bc1eb76dbe3a5bc1b8e2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__645dec92b47ec356d59f57e732f140733db62dffb9b014c5a69273794d637497)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c80791e39521264f4a69274b1e84fa20a291d63744ccd5fe7a30a96a014cc849)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1afefb025401b1efb735543ee06725d3be68e9d5660fe1ea84e8c17c6586dc90)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFaceCrop",
    jsii_struct_bases=[],
    name_mapping={
        "algorithm": "algorithm",
        "algorithm_var": "algorithmVar",
        "confidence": "confidence",
        "confidence_var": "confidenceVar",
        "fail_gravity": "failGravity",
        "fail_gravity_var": "failGravityVar",
        "focus": "focus",
        "focus_var": "focusVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "padding": "padding",
        "padding_var": "paddingVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFaceCrop:
    def __init__(
        self,
        *,
        algorithm: typing.Optional[builtins.str] = None,
        algorithm_var: typing.Optional[builtins.str] = None,
        confidence: typing.Optional[builtins.str] = None,
        confidence_var: typing.Optional[builtins.str] = None,
        fail_gravity: typing.Optional[builtins.str] = None,
        fail_gravity_var: typing.Optional[builtins.str] = None,
        focus: typing.Optional[builtins.str] = None,
        focus_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param algorithm: Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm DataAkamaiImagingPolicyImage#algorithm}
        :param algorithm_var: Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm_var DataAkamaiImagingPolicyImage#algorithm_var}
        :param confidence: With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image. Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence DataAkamaiImagingPolicyImage#confidence}
        :param confidence_var: With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image. Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence_var DataAkamaiImagingPolicyImage#confidence_var}
        :param fail_gravity: Controls placement of the crop if Image and Video Manager does not detect any faces in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        :param fail_gravity_var: Controls placement of the crop if Image and Video Manager does not detect any faces in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        :param focus: Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus DataAkamaiImagingPolicyImage#focus}
        :param focus_var: Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus_var DataAkamaiImagingPolicyImage#focus_var}
        :param gravity: Controls placement of the crop. Directions are relative to the face(s) plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Controls placement of the crop. Directions are relative to the face(s) plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param padding: The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        :param style: Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e92b5394eadc23785c752d03917a7692741386d3f20e82442e7d25df17c6928a)
            check_type(argname="argument algorithm", value=algorithm, expected_type=type_hints["algorithm"])
            check_type(argname="argument algorithm_var", value=algorithm_var, expected_type=type_hints["algorithm_var"])
            check_type(argname="argument confidence", value=confidence, expected_type=type_hints["confidence"])
            check_type(argname="argument confidence_var", value=confidence_var, expected_type=type_hints["confidence_var"])
            check_type(argname="argument fail_gravity", value=fail_gravity, expected_type=type_hints["fail_gravity"])
            check_type(argname="argument fail_gravity_var", value=fail_gravity_var, expected_type=type_hints["fail_gravity_var"])
            check_type(argname="argument focus", value=focus, expected_type=type_hints["focus"])
            check_type(argname="argument focus_var", value=focus_var, expected_type=type_hints["focus_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if algorithm is not None:
            self._values["algorithm"] = algorithm
        if algorithm_var is not None:
            self._values["algorithm_var"] = algorithm_var
        if confidence is not None:
            self._values["confidence"] = confidence
        if confidence_var is not None:
            self._values["confidence_var"] = confidence_var
        if fail_gravity is not None:
            self._values["fail_gravity"] = fail_gravity
        if fail_gravity_var is not None:
            self._values["fail_gravity_var"] = fail_gravity_var
        if focus is not None:
            self._values["focus"] = focus
        if focus_var is not None:
            self._values["focus_var"] = focus_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def algorithm(self) -> typing.Optional[builtins.str]:
        '''Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm DataAkamaiImagingPolicyImage#algorithm}
        '''
        result = self._values.get("algorithm")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def algorithm_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm_var DataAkamaiImagingPolicyImage#algorithm_var}
        '''
        result = self._values.get("algorithm_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def confidence(self) -> typing.Optional[builtins.str]:
        '''With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image.

        Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence DataAkamaiImagingPolicyImage#confidence}
        '''
        result = self._values.get("confidence")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def confidence_var(self) -> typing.Optional[builtins.str]:
        '''With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image.

        Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence_var DataAkamaiImagingPolicyImage#confidence_var}
        '''
        result = self._values.get("confidence_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any faces in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        '''
        result = self._values.get("fail_gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any faces in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        '''
        result = self._values.get("fail_gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def focus(self) -> typing.Optional[builtins.str]:
        '''Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus DataAkamaiImagingPolicyImage#focus}
        '''
        result = self._values.get("focus")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def focus_var(self) -> typing.Optional[builtins.str]:
        '''Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus_var DataAkamaiImagingPolicyImage#focus_var}
        '''
        result = self._values.get("focus_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the face(s) plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the face(s) plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFaceCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFaceCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFaceCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7642e1f3e591b024d9199b1a8bb8d308f73b503f0fc28d02f0cb9ed8dcba869f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFaceCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3cf9e46ee20a6651cff599efacb80031b7ad169a233aacf1aa68a092341f3548)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFaceCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aab1d373d2db24d4e454cbd1e3134efd3b7a35a1c738747b61a37ccd67c82f79)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__757c9af8b53bdda3c08f063f2e99688a2cf7542fceab9c666de721f59e426c7b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c5efd2b9524d7a636d6baabdbd5a32b427d1f66d85ff1bb52d63864fced65294)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFaceCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFaceCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFaceCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dbe37f1c463e451eda292a07534b70b4e384ed6b58108aa0d6f575dd6bde87b9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFaceCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFaceCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f12f3c307f2159dbd5c7d175f3c102e4f56d4118bd5050a7b685830451f91e73)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAlgorithm")
    def reset_algorithm(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAlgorithm", []))

    @jsii.member(jsii_name="resetAlgorithmVar")
    def reset_algorithm_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAlgorithmVar", []))

    @jsii.member(jsii_name="resetConfidence")
    def reset_confidence(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetConfidence", []))

    @jsii.member(jsii_name="resetConfidenceVar")
    def reset_confidence_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetConfidenceVar", []))

    @jsii.member(jsii_name="resetFailGravity")
    def reset_fail_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravity", []))

    @jsii.member(jsii_name="resetFailGravityVar")
    def reset_fail_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravityVar", []))

    @jsii.member(jsii_name="resetFocus")
    def reset_focus(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFocus", []))

    @jsii.member(jsii_name="resetFocusVar")
    def reset_focus_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFocusVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="algorithmInput")
    def algorithm_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "algorithmInput"))

    @builtins.property
    @jsii.member(jsii_name="algorithmVarInput")
    def algorithm_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "algorithmVarInput"))

    @builtins.property
    @jsii.member(jsii_name="confidenceInput")
    def confidence_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "confidenceInput"))

    @builtins.property
    @jsii.member(jsii_name="confidenceVarInput")
    def confidence_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "confidenceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityInput")
    def fail_gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityVarInput")
    def fail_gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="focusInput")
    def focus_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "focusInput"))

    @builtins.property
    @jsii.member(jsii_name="focusVarInput")
    def focus_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "focusVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="algorithm")
    def algorithm(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "algorithm"))

    @algorithm.setter
    def algorithm(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__86ee2251714d1f0fe14f6f938462fd8e64f8a7b266458a043b9d6d2d654af743)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "algorithm", value)

    @builtins.property
    @jsii.member(jsii_name="algorithmVar")
    def algorithm_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "algorithmVar"))

    @algorithm_var.setter
    def algorithm_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f8a5126ac6578e7eb8abb37c2e5fa110b3fd6b674056ec661b4faaa6997857cb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "algorithmVar", value)

    @builtins.property
    @jsii.member(jsii_name="confidence")
    def confidence(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "confidence"))

    @confidence.setter
    def confidence(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d4e5a487090f58673c259e8d15cb8ef5fbabc1f6781f28090c678dd2c2e96a52)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "confidence", value)

    @builtins.property
    @jsii.member(jsii_name="confidenceVar")
    def confidence_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "confidenceVar"))

    @confidence_var.setter
    def confidence_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2c186b8be73b66aaf5a5c0a7cb6900fc64ab62534c98b15d5624c4c8237c210a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "confidenceVar", value)

    @builtins.property
    @jsii.member(jsii_name="failGravity")
    def fail_gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravity"))

    @fail_gravity.setter
    def fail_gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc7356c2e11cbade8a3f453a2a5d20afd867d42f9318ed9936c9e97ea432ff89)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravity", value)

    @builtins.property
    @jsii.member(jsii_name="failGravityVar")
    def fail_gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravityVar"))

    @fail_gravity_var.setter
    def fail_gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__91f7e343c84d2d1327aa7106d81ea1692caca6304f3f10e9d72d2503a0b041f7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="focus")
    def focus(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "focus"))

    @focus.setter
    def focus(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__45312c588d736a332bd3a4d53d0cdc97a1c1fabc98f270d1d56f4b059068936d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "focus", value)

    @builtins.property
    @jsii.member(jsii_name="focusVar")
    def focus_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "focusVar"))

    @focus_var.setter
    def focus_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c8d2d8c6d42ea847c5507e1baaa6020fa8a2dad070246dbc18919ee43b0f1cee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "focusVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8ad07b97b6e0863bd07ae7e05d4fe990b7bcdc88bc761d2b1eb2850ebdf1a4c9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ba3f87bd4e34a284e1eb0f67b5e0cf82300ba454e43bd96fb557df60b70f3de2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__afaf305a1843274c356632fd5c6d8c680359cf86ca29867454e6858c18592b9c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__00fde12997a5eaea7da5ac44eeddeff73882d9bfed316fe896b1322086208a60)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fc823a2f2f7ad465fd49507db9b91a920b6757bbf4bc3b9fc1b458b6daba4708)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__650eb71d1fcd3a7a10f6c2082cd0d76265b1545f18b2b56a69399a164bae896d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1cb4cf0dd76a78b467efc1cebbed28ac8ddb735b75166d754013201a84942e8f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6360f030d3646cc7abed1f2dc68be6f5fed8d1d97332b8406f0c206a7313358e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d3e583207ce97bab4c4f1b0f2b5ab8e1584c179f03029c4bc60670dc162f821d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__28ec19bc869f34433079538739a69dd9abf9abbd07468a7f6760701b05d95e53)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFaceCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFaceCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFaceCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ed67b7f70375181530c6e0fb706d8096ad05a5a2936d3420125fe069825e009)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFeatureCrop",
    jsii_struct_bases=[],
    name_mapping={
        "fail_gravity": "failGravity",
        "fail_gravity_var": "failGravityVar",
        "feature_radius": "featureRadius",
        "feature_radius_var": "featureRadiusVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "max_features": "maxFeatures",
        "max_features_var": "maxFeaturesVar",
        "min_feature_quality": "minFeatureQuality",
        "min_feature_quality_var": "minFeatureQualityVar",
        "padding": "padding",
        "padding_var": "paddingVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFeatureCrop:
    def __init__(
        self,
        *,
        fail_gravity: typing.Optional[builtins.str] = None,
        fail_gravity_var: typing.Optional[builtins.str] = None,
        feature_radius: typing.Optional[builtins.str] = None,
        feature_radius_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        max_features: typing.Optional[builtins.str] = None,
        max_features_var: typing.Optional[builtins.str] = None,
        min_feature_quality: typing.Optional[builtins.str] = None,
        min_feature_quality_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fail_gravity: Controls placement of the crop if Image and Video Manager does not detect any features in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        :param fail_gravity_var: Controls placement of the crop if Image and Video Manager does not detect any features in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        :param feature_radius: The size in pixels of the important features to search for. If identified, two features never appear closer together than this value, ``8.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius DataAkamaiImagingPolicyImage#feature_radius}
        :param feature_radius_var: The size in pixels of the important features to search for. If identified, two features never appear closer together than this value, ``8.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius_var DataAkamaiImagingPolicyImage#feature_radius_var}
        :param gravity: Controls placement of the crop. Directions are relative to the region of interest plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Controls placement of the crop. Directions are relative to the region of interest plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param max_features: The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features DataAkamaiImagingPolicyImage#max_features}
        :param max_features_var: The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features_var DataAkamaiImagingPolicyImage#max_features_var}
        :param min_feature_quality: Determines the minimum quality level of the feature identified. To consider a feature important, the feature needs to surpass this value. Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality DataAkamaiImagingPolicyImage#min_feature_quality}
        :param min_feature_quality_var: Determines the minimum quality level of the feature identified. To consider a feature important, the feature needs to surpass this value. Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality_var DataAkamaiImagingPolicyImage#min_feature_quality_var}
        :param padding: Adds space around the region of interest. The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: Adds space around the region of interest. The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        :param style: Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ef0bf2e8e633c851d9164c9732fe6c20bc2ca0fb8082457954235dcc39adaf2f)
            check_type(argname="argument fail_gravity", value=fail_gravity, expected_type=type_hints["fail_gravity"])
            check_type(argname="argument fail_gravity_var", value=fail_gravity_var, expected_type=type_hints["fail_gravity_var"])
            check_type(argname="argument feature_radius", value=feature_radius, expected_type=type_hints["feature_radius"])
            check_type(argname="argument feature_radius_var", value=feature_radius_var, expected_type=type_hints["feature_radius_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument max_features", value=max_features, expected_type=type_hints["max_features"])
            check_type(argname="argument max_features_var", value=max_features_var, expected_type=type_hints["max_features_var"])
            check_type(argname="argument min_feature_quality", value=min_feature_quality, expected_type=type_hints["min_feature_quality"])
            check_type(argname="argument min_feature_quality_var", value=min_feature_quality_var, expected_type=type_hints["min_feature_quality_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fail_gravity is not None:
            self._values["fail_gravity"] = fail_gravity
        if fail_gravity_var is not None:
            self._values["fail_gravity_var"] = fail_gravity_var
        if feature_radius is not None:
            self._values["feature_radius"] = feature_radius
        if feature_radius_var is not None:
            self._values["feature_radius_var"] = feature_radius_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if max_features is not None:
            self._values["max_features"] = max_features
        if max_features_var is not None:
            self._values["max_features_var"] = max_features_var
        if min_feature_quality is not None:
            self._values["min_feature_quality"] = min_feature_quality
        if min_feature_quality_var is not None:
            self._values["min_feature_quality_var"] = min_feature_quality_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def fail_gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any features in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        '''
        result = self._values.get("fail_gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any features in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        '''
        result = self._values.get("fail_gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feature_radius(self) -> typing.Optional[builtins.str]:
        '''The size in pixels of the important features to search for.

        If identified, two features never appear closer together than this value, ``8.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius DataAkamaiImagingPolicyImage#feature_radius}
        '''
        result = self._values.get("feature_radius")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feature_radius_var(self) -> typing.Optional[builtins.str]:
        '''The size in pixels of the important features to search for.

        If identified, two features never appear closer together than this value, ``8.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius_var DataAkamaiImagingPolicyImage#feature_radius_var}
        '''
        result = self._values.get("feature_radius_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the region of interest plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the region of interest plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def max_features(self) -> typing.Optional[builtins.str]:
        '''The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features DataAkamaiImagingPolicyImage#max_features}
        '''
        result = self._values.get("max_features")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def max_features_var(self) -> typing.Optional[builtins.str]:
        '''The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features_var DataAkamaiImagingPolicyImage#max_features_var}
        '''
        result = self._values.get("max_features_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def min_feature_quality(self) -> typing.Optional[builtins.str]:
        '''Determines the minimum quality level of the feature identified.

        To consider a feature important, the feature needs to surpass this value.  Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality DataAkamaiImagingPolicyImage#min_feature_quality}
        '''
        result = self._values.get("min_feature_quality")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def min_feature_quality_var(self) -> typing.Optional[builtins.str]:
        '''Determines the minimum quality level of the feature identified.

        To consider a feature important, the feature needs to surpass this value.  Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality_var DataAkamaiImagingPolicyImage#min_feature_quality_var}
        '''
        result = self._values.get("min_feature_quality_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''Adds space around the region of interest.

        The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''Adds space around the region of interest.

        The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFeatureCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFeatureCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFeatureCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f4e1202b1d4f3f3b1db89026c7ae31c35df905cb753e965fb18a229aabec192)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFeatureCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__16e058d8edd948da586335e98044542c30cf4dc7e83e82a057ad6283c87a08f2)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFeatureCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4fc6a2558e26cce3e4378b299b238fd9d5f08556e8c46fdf1e2051c12eb3a55d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8cc7aed56f600bedfab0395923391161b6d00f46036b8a6ecc7f40894eb6b1ad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fd92d7b4f050c8f6541c63be59a268a5effadf163a2545529d1158b13eba123d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFeatureCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFeatureCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFeatureCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a9d4ae010ca3e0a904fff0baa028940b4af80a96932d7b7f56806fdf3e2a87d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFeatureCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFeatureCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e6b9bb9f6f30e0afd5ec94d4498397a337df956250708fb26563b64986ff9e1f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetFailGravity")
    def reset_fail_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravity", []))

    @jsii.member(jsii_name="resetFailGravityVar")
    def reset_fail_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravityVar", []))

    @jsii.member(jsii_name="resetFeatureRadius")
    def reset_feature_radius(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureRadius", []))

    @jsii.member(jsii_name="resetFeatureRadiusVar")
    def reset_feature_radius_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureRadiusVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetMaxFeatures")
    def reset_max_features(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxFeatures", []))

    @jsii.member(jsii_name="resetMaxFeaturesVar")
    def reset_max_features_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxFeaturesVar", []))

    @jsii.member(jsii_name="resetMinFeatureQuality")
    def reset_min_feature_quality(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMinFeatureQuality", []))

    @jsii.member(jsii_name="resetMinFeatureQualityVar")
    def reset_min_feature_quality_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMinFeatureQualityVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="failGravityInput")
    def fail_gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityVarInput")
    def fail_gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featureRadiusInput")
    def feature_radius_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featureRadiusInput"))

    @builtins.property
    @jsii.member(jsii_name="featureRadiusVarInput")
    def feature_radius_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featureRadiusVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesInput")
    def max_features_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "maxFeaturesInput"))

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesVarInput")
    def max_features_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "maxFeaturesVarInput"))

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityInput")
    def min_feature_quality_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "minFeatureQualityInput"))

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityVarInput")
    def min_feature_quality_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "minFeatureQualityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravity")
    def fail_gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravity"))

    @fail_gravity.setter
    def fail_gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f4272e0b97db451453e64ac79a094fbf84a394443cb5feb28fadfbea29d405ec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravity", value)

    @builtins.property
    @jsii.member(jsii_name="failGravityVar")
    def fail_gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravityVar"))

    @fail_gravity_var.setter
    def fail_gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aa161aaf5cfa85fb7f67486770630b1afed3d63c1590e9bf1013e0ce066f7b4a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="featureRadius")
    def feature_radius(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featureRadius"))

    @feature_radius.setter
    def feature_radius(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4182a313cc045a67852c9d9a2ffbb2d703ed8d6381356b3a34fc65bb2da82287)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featureRadius", value)

    @builtins.property
    @jsii.member(jsii_name="featureRadiusVar")
    def feature_radius_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featureRadiusVar"))

    @feature_radius_var.setter
    def feature_radius_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__68a9e883fb06b59379448feda70f9cd80e347e7b0671ced18993dab9e619b1a1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featureRadiusVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f856b538bf8a5ad4302017b8b99d6779bfc2a95187c226e43d928c2449bea732)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4c1b0fe5897d42fe8cbe2cefb88392d2588c9e715db896987979fa6ee54c1755)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea7f13873720e410c81ad76773c56239fb6c8e078805deea40e48281497959a5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__59f9315b60f78779ccded783b11c7bac9f798dcb4df41b2c4ffe55278db9a18d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="maxFeatures")
    def max_features(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "maxFeatures"))

    @max_features.setter
    def max_features(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__93ccf88ee5152cb8399154aa6eb97ddec416f1fbcf81bdc7f9c3ee3a577af0a2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "maxFeatures", value)

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesVar")
    def max_features_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "maxFeaturesVar"))

    @max_features_var.setter
    def max_features_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__819beced5213330990f554468d30140129d09327a3afbc914ab29ce2f7922243)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "maxFeaturesVar", value)

    @builtins.property
    @jsii.member(jsii_name="minFeatureQuality")
    def min_feature_quality(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "minFeatureQuality"))

    @min_feature_quality.setter
    def min_feature_quality(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__630a4846df5702be5f3ef27c72ba0e4493062f0bfcdc055899bbd07e6a977db2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "minFeatureQuality", value)

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityVar")
    def min_feature_quality_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "minFeatureQualityVar"))

    @min_feature_quality_var.setter
    def min_feature_quality_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d8e75ec98391a7c6157a889d3413557919914db3b4741fff2491921396678f4c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "minFeatureQualityVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a60110d2a4b86e6910fda00a5aaf1894f18521755288e9d307ca1b51187426d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1d326d55c70064362af5dc243dcba6618d8ff0e396811e50f138164713997288)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c8ebd4732fb4d3a79ca402be921bb46e095b5904e074ff2e137d9dddb28e68ca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4b5cf6cab2fa24e245015b58e7f60f62193b9e21e6081ca5c07ef2d16d30aaf5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cb0ea01b6b268202b8b43875c7a9dc808546fa826fccaad5d723590525ae8272)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d8fbee5c4767a7aba042cfe1715e4980632de0ed73cc5d544119dfcc78477274)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFeatureCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFeatureCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFeatureCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1ed53fefc04f067c44ad6e6e2d120db812485c5f91b627ff9d48d030cfb0d879)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFill",
    jsii_struct_bases=[],
    name_mapping={
        "fill_transformation": "fillTransformation",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFill:
    def __init__(
        self,
        *,
        fill_transformation: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fill_transformation: fill_transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_transformation DataAkamaiImagingPolicyImage#fill_transformation}
        :param height: The height value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The width value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(fill_transformation, dict):
            fill_transformation = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformation(**fill_transformation)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd4698f17e3f81b44837da91d32e1f75e7c902968ad70241a2ff0cf1fe760342)
            check_type(argname="argument fill_transformation", value=fill_transformation, expected_type=type_hints["fill_transformation"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fill_transformation is not None:
            self._values["fill_transformation"] = fill_transformation
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def fill_transformation(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformation"]:
        '''fill_transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_transformation DataAkamaiImagingPolicyImage#fill_transformation}
        '''
        result = self._values.get("fill_transformation")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformation"], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFill(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformation",
    jsii_struct_bases=[],
    name_mapping={
        "append": "append",
        "aspect_crop": "aspectCrop",
        "background_color": "backgroundColor",
        "blur": "blur",
        "chroma_key": "chromaKey",
        "composite": "composite",
        "compound": "compound",
        "contrast": "contrast",
        "crop": "crop",
        "face_crop": "faceCrop",
        "feature_crop": "featureCrop",
        "fit_and_fill": "fitAndFill",
        "goop": "goop",
        "grayscale": "grayscale",
        "hsl": "hsl",
        "hsv": "hsv",
        "if_dimension": "ifDimension",
        "if_orientation": "ifOrientation",
        "im_query": "imQuery",
        "max_colors": "maxColors",
        "mirror": "mirror",
        "mono_hue": "monoHue",
        "opacity": "opacity",
        "region_of_interest_crop": "regionOfInterestCrop",
        "relative_crop": "relativeCrop",
        "remove_color": "removeColor",
        "resize": "resize",
        "rotate": "rotate",
        "scale": "scale",
        "shear": "shear",
        "trim": "trim",
        "unsharp_mask": "unsharpMask",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformation:
    def __init__(
        self,
        *,
        append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppend", typing.Dict[builtins.str, typing.Any]]]]] = None,
        aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAspectCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationBackgroundColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationBlur", typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationChromaKey", typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationComposite", typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompound", typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationContrast", typing.Dict[builtins.str, typing.Any]]]]] = None,
        crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationFaceCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationFeatureCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFill, typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationGoop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationGrayscale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationHsl", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationHsv", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimension", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientation", typing.Dict[builtins.str, typing.Any]]]]] = None,
        im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationImQuery", typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationMaxColors", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationMirror", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationMonoHue", typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationOpacity", typing.Dict[builtins.str, typing.Any]]]]] = None,
        region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRelativeCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRemoveColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationResize", typing.Dict[builtins.str, typing.Any]]]]] = None,
        rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRotate", typing.Dict[builtins.str, typing.Any]]]]] = None,
        scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationScale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationShear", typing.Dict[builtins.str, typing.Any]]]]] = None,
        trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationTrim", typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationUnsharpMask", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param append: append block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        :param aspect_crop: aspect_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param crop: crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        :param face_crop: face_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        :param feature_crop: feature_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        :param fit_and_fill: fit_and_fill block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param im_query: im_query block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param region_of_interest_crop: region_of_interest_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        :param relative_crop: relative_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param resize: resize block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        :param rotate: rotate block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        :param scale: scale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param shear: shear block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        :param trim: trim block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e155b4e2b7fc19c8cb8a2e94521eed20bebbbbb875a526bb3dd25414079051a4)
            check_type(argname="argument append", value=append, expected_type=type_hints["append"])
            check_type(argname="argument aspect_crop", value=aspect_crop, expected_type=type_hints["aspect_crop"])
            check_type(argname="argument background_color", value=background_color, expected_type=type_hints["background_color"])
            check_type(argname="argument blur", value=blur, expected_type=type_hints["blur"])
            check_type(argname="argument chroma_key", value=chroma_key, expected_type=type_hints["chroma_key"])
            check_type(argname="argument composite", value=composite, expected_type=type_hints["composite"])
            check_type(argname="argument compound", value=compound, expected_type=type_hints["compound"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument crop", value=crop, expected_type=type_hints["crop"])
            check_type(argname="argument face_crop", value=face_crop, expected_type=type_hints["face_crop"])
            check_type(argname="argument feature_crop", value=feature_crop, expected_type=type_hints["feature_crop"])
            check_type(argname="argument fit_and_fill", value=fit_and_fill, expected_type=type_hints["fit_and_fill"])
            check_type(argname="argument goop", value=goop, expected_type=type_hints["goop"])
            check_type(argname="argument grayscale", value=grayscale, expected_type=type_hints["grayscale"])
            check_type(argname="argument hsl", value=hsl, expected_type=type_hints["hsl"])
            check_type(argname="argument hsv", value=hsv, expected_type=type_hints["hsv"])
            check_type(argname="argument if_dimension", value=if_dimension, expected_type=type_hints["if_dimension"])
            check_type(argname="argument if_orientation", value=if_orientation, expected_type=type_hints["if_orientation"])
            check_type(argname="argument im_query", value=im_query, expected_type=type_hints["im_query"])
            check_type(argname="argument max_colors", value=max_colors, expected_type=type_hints["max_colors"])
            check_type(argname="argument mirror", value=mirror, expected_type=type_hints["mirror"])
            check_type(argname="argument mono_hue", value=mono_hue, expected_type=type_hints["mono_hue"])
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument region_of_interest_crop", value=region_of_interest_crop, expected_type=type_hints["region_of_interest_crop"])
            check_type(argname="argument relative_crop", value=relative_crop, expected_type=type_hints["relative_crop"])
            check_type(argname="argument remove_color", value=remove_color, expected_type=type_hints["remove_color"])
            check_type(argname="argument resize", value=resize, expected_type=type_hints["resize"])
            check_type(argname="argument rotate", value=rotate, expected_type=type_hints["rotate"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument shear", value=shear, expected_type=type_hints["shear"])
            check_type(argname="argument trim", value=trim, expected_type=type_hints["trim"])
            check_type(argname="argument unsharp_mask", value=unsharp_mask, expected_type=type_hints["unsharp_mask"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if append is not None:
            self._values["append"] = append
        if aspect_crop is not None:
            self._values["aspect_crop"] = aspect_crop
        if background_color is not None:
            self._values["background_color"] = background_color
        if blur is not None:
            self._values["blur"] = blur
        if chroma_key is not None:
            self._values["chroma_key"] = chroma_key
        if composite is not None:
            self._values["composite"] = composite
        if compound is not None:
            self._values["compound"] = compound
        if contrast is not None:
            self._values["contrast"] = contrast
        if crop is not None:
            self._values["crop"] = crop
        if face_crop is not None:
            self._values["face_crop"] = face_crop
        if feature_crop is not None:
            self._values["feature_crop"] = feature_crop
        if fit_and_fill is not None:
            self._values["fit_and_fill"] = fit_and_fill
        if goop is not None:
            self._values["goop"] = goop
        if grayscale is not None:
            self._values["grayscale"] = grayscale
        if hsl is not None:
            self._values["hsl"] = hsl
        if hsv is not None:
            self._values["hsv"] = hsv
        if if_dimension is not None:
            self._values["if_dimension"] = if_dimension
        if if_orientation is not None:
            self._values["if_orientation"] = if_orientation
        if im_query is not None:
            self._values["im_query"] = im_query
        if max_colors is not None:
            self._values["max_colors"] = max_colors
        if mirror is not None:
            self._values["mirror"] = mirror
        if mono_hue is not None:
            self._values["mono_hue"] = mono_hue
        if opacity is not None:
            self._values["opacity"] = opacity
        if region_of_interest_crop is not None:
            self._values["region_of_interest_crop"] = region_of_interest_crop
        if relative_crop is not None:
            self._values["relative_crop"] = relative_crop
        if remove_color is not None:
            self._values["remove_color"] = remove_color
        if resize is not None:
            self._values["resize"] = resize
        if rotate is not None:
            self._values["rotate"] = rotate
        if scale is not None:
            self._values["scale"] = scale
        if shear is not None:
            self._values["shear"] = shear
        if trim is not None:
            self._values["trim"] = trim
        if unsharp_mask is not None:
            self._values["unsharp_mask"] = unsharp_mask

    @builtins.property
    def append(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppend"]]]:
        '''append block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        '''
        result = self._values.get("append")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppend"]]], result)

    @builtins.property
    def aspect_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAspectCrop"]]]:
        '''aspect_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        '''
        result = self._values.get("aspect_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAspectCrop"]]], result)

    @builtins.property
    def background_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationBackgroundColor"]]]:
        '''background_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        '''
        result = self._values.get("background_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationBackgroundColor"]]], result)

    @builtins.property
    def blur(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationBlur"]]]:
        '''blur block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        '''
        result = self._values.get("blur")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationBlur"]]], result)

    @builtins.property
    def chroma_key(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationChromaKey"]]]:
        '''chroma_key block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        '''
        result = self._values.get("chroma_key")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationChromaKey"]]], result)

    @builtins.property
    def composite(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationComposite"]]]:
        '''composite block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        '''
        result = self._values.get("composite")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationComposite"]]], result)

    @builtins.property
    def compound(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompound"]]]:
        '''compound block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        '''
        result = self._values.get("compound")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompound"]]], result)

    @builtins.property
    def contrast(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationContrast"]]]:
        '''contrast block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationContrast"]]], result)

    @builtins.property
    def crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCrop"]]]:
        '''crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        '''
        result = self._values.get("crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCrop"]]], result)

    @builtins.property
    def face_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationFaceCrop"]]]:
        '''face_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        '''
        result = self._values.get("face_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationFaceCrop"]]], result)

    @builtins.property
    def feature_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationFeatureCrop"]]]:
        '''feature_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        '''
        result = self._values.get("feature_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationFeatureCrop"]]], result)

    @builtins.property
    def fit_and_fill(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFill]]]:
        '''fit_and_fill block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        '''
        result = self._values.get("fit_and_fill")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFill]]], result)

    @builtins.property
    def goop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationGoop"]]]:
        '''goop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        '''
        result = self._values.get("goop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationGoop"]]], result)

    @builtins.property
    def grayscale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationGrayscale"]]]:
        '''grayscale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        '''
        result = self._values.get("grayscale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationGrayscale"]]], result)

    @builtins.property
    def hsl(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationHsl"]]]:
        '''hsl block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        '''
        result = self._values.get("hsl")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationHsl"]]], result)

    @builtins.property
    def hsv(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationHsv"]]]:
        '''hsv block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        '''
        result = self._values.get("hsv")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationHsv"]]], result)

    @builtins.property
    def if_dimension(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimension"]]]:
        '''if_dimension block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        '''
        result = self._values.get("if_dimension")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimension"]]], result)

    @builtins.property
    def if_orientation(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientation"]]]:
        '''if_orientation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        '''
        result = self._values.get("if_orientation")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientation"]]], result)

    @builtins.property
    def im_query(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationImQuery"]]]:
        '''im_query block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        '''
        result = self._values.get("im_query")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationImQuery"]]], result)

    @builtins.property
    def max_colors(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationMaxColors"]]]:
        '''max_colors block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        '''
        result = self._values.get("max_colors")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationMaxColors"]]], result)

    @builtins.property
    def mirror(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationMirror"]]]:
        '''mirror block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        '''
        result = self._values.get("mirror")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationMirror"]]], result)

    @builtins.property
    def mono_hue(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationMonoHue"]]]:
        '''mono_hue block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        '''
        result = self._values.get("mono_hue")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationMonoHue"]]], result)

    @builtins.property
    def opacity(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationOpacity"]]]:
        '''opacity block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationOpacity"]]], result)

    @builtins.property
    def region_of_interest_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCrop"]]]:
        '''region_of_interest_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        '''
        result = self._values.get("region_of_interest_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCrop"]]], result)

    @builtins.property
    def relative_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRelativeCrop"]]]:
        '''relative_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        '''
        result = self._values.get("relative_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRelativeCrop"]]], result)

    @builtins.property
    def remove_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRemoveColor"]]]:
        '''remove_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        '''
        result = self._values.get("remove_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRemoveColor"]]], result)

    @builtins.property
    def resize(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationResize"]]]:
        '''resize block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        '''
        result = self._values.get("resize")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationResize"]]], result)

    @builtins.property
    def rotate(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRotate"]]]:
        '''rotate block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        '''
        result = self._values.get("rotate")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRotate"]]], result)

    @builtins.property
    def scale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationScale"]]]:
        '''scale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationScale"]]], result)

    @builtins.property
    def shear(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationShear"]]]:
        '''shear block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        '''
        result = self._values.get("shear")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationShear"]]], result)

    @builtins.property
    def trim(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationTrim"]]]:
        '''trim block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        '''
        result = self._values.get("trim")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationTrim"]]], result)

    @builtins.property
    def unsharp_mask(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationUnsharpMask"]]]:
        '''unsharp_mask block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        result = self._values.get("unsharp_mask")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationUnsharpMask"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppend",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_priority": "gravityPriority",
        "gravity_priority_var": "gravityPriorityVar",
        "gravity_var": "gravityVar",
        "preserve_minor_dimension": "preserveMinorDimension",
        "preserve_minor_dimension_var": "preserveMinorDimensionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppend:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_priority: typing.Optional[builtins.str] = None,
        gravity_priority_var: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        preserve_minor_dimension: typing.Optional[builtins.str] = None,
        preserve_minor_dimension_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Specifies where to place the ``image`` relative to the source image. The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_priority: Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal. The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority DataAkamaiImagingPolicyImage#gravity_priority}
        :param gravity_priority_var: Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal. The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority_var DataAkamaiImagingPolicyImage#gravity_priority_var}
        :param gravity_var: Specifies where to place the ``image`` relative to the source image. The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param preserve_minor_dimension: Whether to preserve the source image's minor dimension, ``false`` by default. The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension DataAkamaiImagingPolicyImage#preserve_minor_dimension}
        :param preserve_minor_dimension_var: Whether to preserve the source image's minor dimension, ``false`` by default. The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension_var DataAkamaiImagingPolicyImage#preserve_minor_dimension_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fea1eab7ac35118412e0eac9c37ad336c2c62029acdae7d53da681929a60f4b7)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_priority", value=gravity_priority, expected_type=type_hints["gravity_priority"])
            check_type(argname="argument gravity_priority_var", value=gravity_priority_var, expected_type=type_hints["gravity_priority_var"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument preserve_minor_dimension", value=preserve_minor_dimension, expected_type=type_hints["preserve_minor_dimension"])
            check_type(argname="argument preserve_minor_dimension_var", value=preserve_minor_dimension_var, expected_type=type_hints["preserve_minor_dimension_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_priority is not None:
            self._values["gravity_priority"] = gravity_priority
        if gravity_priority_var is not None:
            self._values["gravity_priority_var"] = gravity_priority_var
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if preserve_minor_dimension is not None:
            self._values["preserve_minor_dimension"] = preserve_minor_dimension
        if preserve_minor_dimension_var is not None:
            self._values["preserve_minor_dimension_var"] = preserve_minor_dimension_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Specifies where to place the ``image`` relative to the source image.

        The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_priority(self) -> typing.Optional[builtins.str]:
        '''Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal.

        The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority DataAkamaiImagingPolicyImage#gravity_priority}
        '''
        result = self._values.get("gravity_priority")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_priority_var(self) -> typing.Optional[builtins.str]:
        '''Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal.

        The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority_var DataAkamaiImagingPolicyImage#gravity_priority_var}
        '''
        result = self._values.get("gravity_priority_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Specifies where to place the ``image`` relative to the source image.

        The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def preserve_minor_dimension(self) -> typing.Optional[builtins.str]:
        '''Whether to preserve the source image's minor dimension, ``false`` by default.

        The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension DataAkamaiImagingPolicyImage#preserve_minor_dimension}
        '''
        result = self._values.get("preserve_minor_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def preserve_minor_dimension_var(self) -> typing.Optional[builtins.str]:
        '''Whether to preserve the source image's minor dimension, ``false`` by default.

        The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension_var DataAkamaiImagingPolicyImage#preserve_minor_dimension_var}
        '''
        result = self._values.get("preserve_minor_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppend(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImage",
    jsii_struct_bases=[],
    name_mapping={
        "box_image": "boxImage",
        "circle_image": "circleImage",
        "text_image": "textImage",
        "url_image": "urlImage",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImage:
    def __init__(
        self,
        *,
        box_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageBoxImage", typing.Dict[builtins.str, typing.Any]]]]] = None,
        circle_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageCircleImage", typing.Dict[builtins.str, typing.Any]]]]] = None,
        text_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageTextImage", typing.Dict[builtins.str, typing.Any]]]]] = None,
        url_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageUrlImage", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param box_image: box_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#box_image DataAkamaiImagingPolicyImage#box_image}
        :param circle_image: circle_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#circle_image DataAkamaiImagingPolicyImage#circle_image}
        :param text_image: text_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text_image DataAkamaiImagingPolicyImage#text_image}
        :param url_image: url_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url_image DataAkamaiImagingPolicyImage#url_image}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__586482363e60910c4bc5865f96b2cb5d260b2fd3e2f9f0a17c582a60ab9b1201)
            check_type(argname="argument box_image", value=box_image, expected_type=type_hints["box_image"])
            check_type(argname="argument circle_image", value=circle_image, expected_type=type_hints["circle_image"])
            check_type(argname="argument text_image", value=text_image, expected_type=type_hints["text_image"])
            check_type(argname="argument url_image", value=url_image, expected_type=type_hints["url_image"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if box_image is not None:
            self._values["box_image"] = box_image
        if circle_image is not None:
            self._values["circle_image"] = circle_image
        if text_image is not None:
            self._values["text_image"] = text_image
        if url_image is not None:
            self._values["url_image"] = url_image

    @builtins.property
    def box_image(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageBoxImage"]]]:
        '''box_image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#box_image DataAkamaiImagingPolicyImage#box_image}
        '''
        result = self._values.get("box_image")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageBoxImage"]]], result)

    @builtins.property
    def circle_image(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageCircleImage"]]]:
        '''circle_image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#circle_image DataAkamaiImagingPolicyImage#circle_image}
        '''
        result = self._values.get("circle_image")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageCircleImage"]]], result)

    @builtins.property
    def text_image(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageTextImage"]]]:
        '''text_image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text_image DataAkamaiImagingPolicyImage#text_image}
        '''
        result = self._values.get("text_image")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageTextImage"]]], result)

    @builtins.property
    def url_image(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageUrlImage"]]]:
        '''url_image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url_image DataAkamaiImagingPolicyImage#url_image}
        '''
        result = self._values.get("url_image")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageUrlImage"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageBoxImage",
    jsii_struct_bases=[],
    name_mapping={
        "color": "color",
        "color_var": "colorVar",
        "height": "height",
        "height_var": "heightVar",
        "transformation": "transformation",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageBoxImage:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        transformation: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageBoxImageTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The fill color of the box, not the edge of the box. The API supports hexadecimal representation and CSS hexadecimal color values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The fill color of the box, not the edge of the box. The API supports hexadecimal representation and CSS hexadecimal color values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        :param height: The height of the box in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height of the box in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param transformation: transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        :param width: The width of the box in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width of the box in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(transformation, dict):
            transformation = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageBoxImageTransformation(**transformation)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7fff82295bc1f8df4de60606c2d9ec832875f9ab2ce81b81d3369bb1c5d38a0d)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument transformation", value=transformation, expected_type=type_hints["transformation"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if transformation is not None:
            self._values["transformation"] = transformation
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The fill color of the box, not the edge of the box.

        The API supports hexadecimal representation and CSS hexadecimal color values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The fill color of the box, not the edge of the box.

        The API supports hexadecimal representation and CSS hexadecimal color values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height of the box in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height of the box in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def transformation(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageBoxImageTransformation"]:
        '''transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        '''
        result = self._values.get("transformation")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageBoxImageTransformation"], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width of the box in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width of the box in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageBoxImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageBoxImageList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageBoxImageList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6c2085d30c55f450eccf47e4b3d8ea5092081ae6558c4d60df94dcfb055977e5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageBoxImageOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e16caa5f164be2cf9677ba0b346f6905e4ac9b6b380662ac490eb478aec5403c)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageBoxImageOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ec5ecf4416c1f3865bb34a89d82fedb93eefefa9047023b52f225eda26e38cf7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__51849c5a886c4afe002f9fcbab0e81f16f19220cc96a6f1d1ddba21b5dd85949)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0bfe9c125f84a71cda998c91aa1262f9dd21d659224d5106e21e754b30ac1471)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageBoxImage]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageBoxImage]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageBoxImage]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__94135298ec406edd35d1fc1c5664040de25afb5e38f1bb8859de5e054bf85b98)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageBoxImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageBoxImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3fb5f9a0a590d28998fe89c77dccb134f69b7b62bdccbec6ebc3a59d8d6183c7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformation")
    def put_transformation(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageBoxImageTransformation()

        return typing.cast(None, jsii.invoke(self, "putTransformation", [value]))

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetTransformation")
    def reset_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformation", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="transformation")
    def transformation(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageBoxImageTransformationOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageBoxImageTransformationOutputReference", jsii.get(self, "transformation"))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="transformationInput")
    def transformation_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageBoxImageTransformation"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageBoxImageTransformation"], jsii.get(self, "transformationInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2cc6b9d4b1c98dcd07d2f8c3aa6fee9a09e0c941ee67b7bafca943b0736698d5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__93a7eb7b0f546dd02644d303fa899f1f3e081b2d9f97ed9f0e88a5b390ab35cd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6c80468ab86f151e0c85836410a6a2887526f1f1338ccce81f0e56d61691ea5c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e86577cc40adb76312a09df1f3d8278c22e0c268a804e4e48e8e3a86daafb186)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7ee0c72a8c64b36c2f6b68bbf26ccdb32cee961a04e5a387877a35df90c63f54)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__63905a0d54f422381467546398c55efee7f4cf75c8af351969bf459afd965da7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageBoxImage]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageBoxImage]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageBoxImage]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__064745402b525f5ebfe6d007f64dc70f3a13513bab3e822232b5145383601b40)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageBoxImageTransformation",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageBoxImageTransformation:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageBoxImageTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageBoxImageTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageBoxImageTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ee4642369329b5aaf1215a544940a155dab267cb3a1fe96728cdf66ac0ee30c1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageBoxImageTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageBoxImageTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageBoxImageTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__558d81d447ce22cb9fcb3488a6bb4dbfa5ce23641d2a6fcca83ef64002de4d64)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageCircleImage",
    jsii_struct_bases=[],
    name_mapping={
        "color": "color",
        "color_var": "colorVar",
        "diameter": "diameter",
        "diameter_var": "diameterVar",
        "transformation": "transformation",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageCircleImage:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
        diameter: typing.Optional[builtins.str] = None,
        diameter_var: typing.Optional[builtins.str] = None,
        transformation: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageCircleImageTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The fill color of the circle. The API supports hexadecimal representation and CSS hexadecimal color values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The fill color of the circle. The API supports hexadecimal representation and CSS hexadecimal color values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        :param diameter: The diameter of the circle. The diameter will be the width and the height of the image in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#diameter DataAkamaiImagingPolicyImage#diameter}
        :param diameter_var: The diameter of the circle. The diameter will be the width and the height of the image in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#diameter_var DataAkamaiImagingPolicyImage#diameter_var}
        :param transformation: transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        :param width: The width of the box in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width of the box in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(transformation, dict):
            transformation = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageCircleImageTransformation(**transformation)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7a3873c7fc6da5e138d6ebffffd01df50570505463fc26274ab597b5403b3759)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
            check_type(argname="argument diameter", value=diameter, expected_type=type_hints["diameter"])
            check_type(argname="argument diameter_var", value=diameter_var, expected_type=type_hints["diameter_var"])
            check_type(argname="argument transformation", value=transformation, expected_type=type_hints["transformation"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var
        if diameter is not None:
            self._values["diameter"] = diameter
        if diameter_var is not None:
            self._values["diameter_var"] = diameter_var
        if transformation is not None:
            self._values["transformation"] = transformation
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The fill color of the circle. The API supports hexadecimal representation and CSS hexadecimal color values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The fill color of the circle. The API supports hexadecimal representation and CSS hexadecimal color values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def diameter(self) -> typing.Optional[builtins.str]:
        '''The diameter of the circle. The diameter will be the width and the height of the image in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#diameter DataAkamaiImagingPolicyImage#diameter}
        '''
        result = self._values.get("diameter")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def diameter_var(self) -> typing.Optional[builtins.str]:
        '''The diameter of the circle. The diameter will be the width and the height of the image in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#diameter_var DataAkamaiImagingPolicyImage#diameter_var}
        '''
        result = self._values.get("diameter_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def transformation(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageCircleImageTransformation"]:
        '''transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        '''
        result = self._values.get("transformation")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageCircleImageTransformation"], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width of the box in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width of the box in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageCircleImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageCircleImageList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageCircleImageList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2f03704576d781550cfb9cdb891af7654f0eba27639a2c992f9073549eda1dd1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageCircleImageOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7587a55b64233bba8ec0e2015d093e82c35321d48fa57a588cdd2965f4235969)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageCircleImageOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__daaed866507e7d45264253a4a7ccb72f59b8cfc9dcb0aac1fc49e9366dfbecf3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c72940616f09c4df44ffdde11a07b603b681e4f7bdf20b917291774e5c1665ef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4f0f2bb3fe3a9392462f7d68f55555956c46d63a15462c3ef9641ed45a82fa51)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageCircleImage]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageCircleImage]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageCircleImage]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a0ce09a591f701793ba85f6ee21e1c83f22aeed2628058b92b01d8f05d624e9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageCircleImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageCircleImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ddd69fe4dad3b4cc80cec4ccb464f705296d21b3af1ebf352a24ca6503705da0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformation")
    def put_transformation(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageCircleImageTransformation()

        return typing.cast(None, jsii.invoke(self, "putTransformation", [value]))

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @jsii.member(jsii_name="resetDiameter")
    def reset_diameter(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDiameter", []))

    @jsii.member(jsii_name="resetDiameterVar")
    def reset_diameter_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDiameterVar", []))

    @jsii.member(jsii_name="resetTransformation")
    def reset_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformation", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="transformation")
    def transformation(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageCircleImageTransformationOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageCircleImageTransformationOutputReference", jsii.get(self, "transformation"))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="diameterInput")
    def diameter_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "diameterInput"))

    @builtins.property
    @jsii.member(jsii_name="diameterVarInput")
    def diameter_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "diameterVarInput"))

    @builtins.property
    @jsii.member(jsii_name="transformationInput")
    def transformation_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageCircleImageTransformation"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageCircleImageTransformation"], jsii.get(self, "transformationInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a29a266dd929393abbde1a01177006632683bd3141e0121da6b7a3e21d6c1d0b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cfd957f503bcbef36228c664c0c055480e8df4b50fcd78b42af54b8bbe88e8a4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="diameter")
    def diameter(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "diameter"))

    @diameter.setter
    def diameter(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1a70fc7f35803d143a99d89a46b3ca5a8125cfba744ffa4774e11e742bfc0843)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "diameter", value)

    @builtins.property
    @jsii.member(jsii_name="diameterVar")
    def diameter_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "diameterVar"))

    @diameter_var.setter
    def diameter_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d1a4a53be109663291911bd8216975727f26018b668d7005a24f0349cd0689b4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "diameterVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__80bdc5c4023c8bf624894c7d9cab62f0274b9fefc78eec52cd0eda7e98ad1944)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f8fa1639d6dc919c3395a3b824b2ede9e5ff1b26823226107e3c95c7fb1bcd79)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageCircleImage]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageCircleImage]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageCircleImage]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cfa24879acf62f961c83657fef8dca4d1b54fbac280b977e1deb8f04b06ca899)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageCircleImageTransformation",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageCircleImageTransformation:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageCircleImageTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageCircleImageTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageCircleImageTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0a6bc80395111f06523ca1f9d488dcdbcc161bea9de51cf37099371d96f77542)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageCircleImageTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageCircleImageTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageCircleImageTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__85178196607c70ac9c149cbb4ed623f766dc722e78dc55c60e04260b3bb23a10)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__18d7f654f045917979436fb04d519859d582320cf45ca1b88ddfe46a15928fdb)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putBoxImage")
    def put_box_image(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageBoxImage, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f1c8b66d4d34d7ae1255ed09387bb959c304114155feb5f88be71f4f956764b4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBoxImage", [value]))

    @jsii.member(jsii_name="putCircleImage")
    def put_circle_image(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageCircleImage, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6790db96385ad3ec294c38f68518b56fac3b9735a93fd9b040aa9899fe1bfa5f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCircleImage", [value]))

    @jsii.member(jsii_name="putTextImage")
    def put_text_image(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageTextImage", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4e65b33ab6765ccde33890bae95421ae5add882a447a49501292be4ae9968656)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTextImage", [value]))

    @jsii.member(jsii_name="putUrlImage")
    def put_url_image(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageUrlImage", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__db3e6f26f8378b79f087e5b3451beb09f9cae6900c89116fec395d8e194dcd94)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putUrlImage", [value]))

    @jsii.member(jsii_name="resetBoxImage")
    def reset_box_image(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBoxImage", []))

    @jsii.member(jsii_name="resetCircleImage")
    def reset_circle_image(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCircleImage", []))

    @jsii.member(jsii_name="resetTextImage")
    def reset_text_image(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTextImage", []))

    @jsii.member(jsii_name="resetUrlImage")
    def reset_url_image(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUrlImage", []))

    @builtins.property
    @jsii.member(jsii_name="boxImage")
    def box_image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageBoxImageList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageBoxImageList, jsii.get(self, "boxImage"))

    @builtins.property
    @jsii.member(jsii_name="circleImage")
    def circle_image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageCircleImageList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageCircleImageList, jsii.get(self, "circleImage"))

    @builtins.property
    @jsii.member(jsii_name="textImage")
    def text_image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageTextImageList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageTextImageList", jsii.get(self, "textImage"))

    @builtins.property
    @jsii.member(jsii_name="urlImage")
    def url_image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageUrlImageList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageUrlImageList", jsii.get(self, "urlImage"))

    @builtins.property
    @jsii.member(jsii_name="boxImageInput")
    def box_image_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageBoxImage]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageBoxImage]]], jsii.get(self, "boxImageInput"))

    @builtins.property
    @jsii.member(jsii_name="circleImageInput")
    def circle_image_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageCircleImage]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageCircleImage]]], jsii.get(self, "circleImageInput"))

    @builtins.property
    @jsii.member(jsii_name="textImageInput")
    def text_image_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageTextImage"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageTextImage"]]], jsii.get(self, "textImageInput"))

    @builtins.property
    @jsii.member(jsii_name="urlImageInput")
    def url_image_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageUrlImage"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageUrlImage"]]], jsii.get(self, "urlImageInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7dbdb10fe394b69e90b54cd56c456c158f6d891098d357aa0a1a1a387b8c2768)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageTextImage",
    jsii_struct_bases=[],
    name_mapping={
        "fill": "fill",
        "fill_var": "fillVar",
        "size": "size",
        "size_var": "sizeVar",
        "stroke": "stroke",
        "stroke_size": "strokeSize",
        "stroke_size_var": "strokeSizeVar",
        "stroke_var": "strokeVar",
        "text": "text",
        "text_var": "textVar",
        "transformation": "transformation",
        "typeface": "typeface",
        "typeface_var": "typefaceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageTextImage:
    def __init__(
        self,
        *,
        fill: typing.Optional[builtins.str] = None,
        fill_var: typing.Optional[builtins.str] = None,
        size: typing.Optional[builtins.str] = None,
        size_var: typing.Optional[builtins.str] = None,
        stroke: typing.Optional[builtins.str] = None,
        stroke_size: typing.Optional[builtins.str] = None,
        stroke_size_var: typing.Optional[builtins.str] = None,
        stroke_var: typing.Optional[builtins.str] = None,
        text: typing.Optional[builtins.str] = None,
        text_var: typing.Optional[builtins.str] = None,
        transformation: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageTextImageTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        typeface: typing.Optional[builtins.str] = None,
        typeface_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fill: The main fill color of the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill DataAkamaiImagingPolicyImage#fill}
        :param fill_var: The main fill color of the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_var DataAkamaiImagingPolicyImage#fill_var}
        :param size: The size in pixels to render the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#size DataAkamaiImagingPolicyImage#size}
        :param size_var: The size in pixels to render the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#size_var DataAkamaiImagingPolicyImage#size_var}
        :param stroke: The color for the outline of the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke DataAkamaiImagingPolicyImage#stroke}
        :param stroke_size: The thickness in points for the outline of the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_size DataAkamaiImagingPolicyImage#stroke_size}
        :param stroke_size_var: The thickness in points for the outline of the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_size_var DataAkamaiImagingPolicyImage#stroke_size_var}
        :param stroke_var: The color for the outline of the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_var DataAkamaiImagingPolicyImage#stroke_var}
        :param text: The line of text to render. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text DataAkamaiImagingPolicyImage#text}
        :param text_var: The line of text to render. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text_var DataAkamaiImagingPolicyImage#text_var}
        :param transformation: transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        :param typeface: The font family to apply to the text image. This may be a URL to a TrueType or WOFF (v1) typeface, or a string that refers to one of the standard built-in browser fonts. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#typeface DataAkamaiImagingPolicyImage#typeface}
        :param typeface_var: The font family to apply to the text image. This may be a URL to a TrueType or WOFF (v1) typeface, or a string that refers to one of the standard built-in browser fonts. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#typeface_var DataAkamaiImagingPolicyImage#typeface_var}
        '''
        if isinstance(transformation, dict):
            transformation = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageTextImageTransformation(**transformation)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__edec3eea4d77442351be079403e98557df9a5e73a8707b5541604cea1e729cac)
            check_type(argname="argument fill", value=fill, expected_type=type_hints["fill"])
            check_type(argname="argument fill_var", value=fill_var, expected_type=type_hints["fill_var"])
            check_type(argname="argument size", value=size, expected_type=type_hints["size"])
            check_type(argname="argument size_var", value=size_var, expected_type=type_hints["size_var"])
            check_type(argname="argument stroke", value=stroke, expected_type=type_hints["stroke"])
            check_type(argname="argument stroke_size", value=stroke_size, expected_type=type_hints["stroke_size"])
            check_type(argname="argument stroke_size_var", value=stroke_size_var, expected_type=type_hints["stroke_size_var"])
            check_type(argname="argument stroke_var", value=stroke_var, expected_type=type_hints["stroke_var"])
            check_type(argname="argument text", value=text, expected_type=type_hints["text"])
            check_type(argname="argument text_var", value=text_var, expected_type=type_hints["text_var"])
            check_type(argname="argument transformation", value=transformation, expected_type=type_hints["transformation"])
            check_type(argname="argument typeface", value=typeface, expected_type=type_hints["typeface"])
            check_type(argname="argument typeface_var", value=typeface_var, expected_type=type_hints["typeface_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fill is not None:
            self._values["fill"] = fill
        if fill_var is not None:
            self._values["fill_var"] = fill_var
        if size is not None:
            self._values["size"] = size
        if size_var is not None:
            self._values["size_var"] = size_var
        if stroke is not None:
            self._values["stroke"] = stroke
        if stroke_size is not None:
            self._values["stroke_size"] = stroke_size
        if stroke_size_var is not None:
            self._values["stroke_size_var"] = stroke_size_var
        if stroke_var is not None:
            self._values["stroke_var"] = stroke_var
        if text is not None:
            self._values["text"] = text
        if text_var is not None:
            self._values["text_var"] = text_var
        if transformation is not None:
            self._values["transformation"] = transformation
        if typeface is not None:
            self._values["typeface"] = typeface
        if typeface_var is not None:
            self._values["typeface_var"] = typeface_var

    @builtins.property
    def fill(self) -> typing.Optional[builtins.str]:
        '''The main fill color of the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill DataAkamaiImagingPolicyImage#fill}
        '''
        result = self._values.get("fill")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fill_var(self) -> typing.Optional[builtins.str]:
        '''The main fill color of the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_var DataAkamaiImagingPolicyImage#fill_var}
        '''
        result = self._values.get("fill_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def size(self) -> typing.Optional[builtins.str]:
        '''The size in pixels to render the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#size DataAkamaiImagingPolicyImage#size}
        '''
        result = self._values.get("size")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def size_var(self) -> typing.Optional[builtins.str]:
        '''The size in pixels to render the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#size_var DataAkamaiImagingPolicyImage#size_var}
        '''
        result = self._values.get("size_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def stroke(self) -> typing.Optional[builtins.str]:
        '''The color for the outline of the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke DataAkamaiImagingPolicyImage#stroke}
        '''
        result = self._values.get("stroke")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def stroke_size(self) -> typing.Optional[builtins.str]:
        '''The thickness in points for the outline of the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_size DataAkamaiImagingPolicyImage#stroke_size}
        '''
        result = self._values.get("stroke_size")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def stroke_size_var(self) -> typing.Optional[builtins.str]:
        '''The thickness in points for the outline of the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_size_var DataAkamaiImagingPolicyImage#stroke_size_var}
        '''
        result = self._values.get("stroke_size_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def stroke_var(self) -> typing.Optional[builtins.str]:
        '''The color for the outline of the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_var DataAkamaiImagingPolicyImage#stroke_var}
        '''
        result = self._values.get("stroke_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def text(self) -> typing.Optional[builtins.str]:
        '''The line of text to render.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text DataAkamaiImagingPolicyImage#text}
        '''
        result = self._values.get("text")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def text_var(self) -> typing.Optional[builtins.str]:
        '''The line of text to render.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text_var DataAkamaiImagingPolicyImage#text_var}
        '''
        result = self._values.get("text_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def transformation(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageTextImageTransformation"]:
        '''transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        '''
        result = self._values.get("transformation")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageTextImageTransformation"], result)

    @builtins.property
    def typeface(self) -> typing.Optional[builtins.str]:
        '''The font family to apply to the text image.

        This may be a URL to a TrueType or WOFF (v1) typeface, or a string that refers to one of the standard built-in browser fonts.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#typeface DataAkamaiImagingPolicyImage#typeface}
        '''
        result = self._values.get("typeface")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def typeface_var(self) -> typing.Optional[builtins.str]:
        '''The font family to apply to the text image.

        This may be a URL to a TrueType or WOFF (v1) typeface, or a string that refers to one of the standard built-in browser fonts.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#typeface_var DataAkamaiImagingPolicyImage#typeface_var}
        '''
        result = self._values.get("typeface_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageTextImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageTextImageList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageTextImageList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__576e57f57df7b72fab87bfc41f1f031a669a1d477e7db7c944b93e59c1f91367)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageTextImageOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__587c6e33ddf16859570ddf32065073d5980f3af8b00840c393b4f557967bb0b4)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageTextImageOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c720e0a73395c459b7d7040d80ddf6c7963f30c49eba5f5c415fa2e9c0e79b87)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__094f7cd5de50b554bf19965eff33bb5398bd92d2201217aa5e5d6f7e847d03e5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e0c8519d321fb9f10198312b02db80407797ffc63a4aba828c88c68767c222ef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageTextImage]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageTextImage]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageTextImage]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8009e3479839cdc967cc1a2400269d414d04674f9650a6117685e79ba718bad9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageTextImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageTextImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__19b93315c81e79cb7b65d840efbc70c041288fc44f2cbfb9090dc08fb34b7fa3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformation")
    def put_transformation(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageTextImageTransformation()

        return typing.cast(None, jsii.invoke(self, "putTransformation", [value]))

    @jsii.member(jsii_name="resetFill")
    def reset_fill(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFill", []))

    @jsii.member(jsii_name="resetFillVar")
    def reset_fill_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFillVar", []))

    @jsii.member(jsii_name="resetSize")
    def reset_size(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSize", []))

    @jsii.member(jsii_name="resetSizeVar")
    def reset_size_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSizeVar", []))

    @jsii.member(jsii_name="resetStroke")
    def reset_stroke(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStroke", []))

    @jsii.member(jsii_name="resetStrokeSize")
    def reset_stroke_size(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStrokeSize", []))

    @jsii.member(jsii_name="resetStrokeSizeVar")
    def reset_stroke_size_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStrokeSizeVar", []))

    @jsii.member(jsii_name="resetStrokeVar")
    def reset_stroke_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStrokeVar", []))

    @jsii.member(jsii_name="resetText")
    def reset_text(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetText", []))

    @jsii.member(jsii_name="resetTextVar")
    def reset_text_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTextVar", []))

    @jsii.member(jsii_name="resetTransformation")
    def reset_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformation", []))

    @jsii.member(jsii_name="resetTypeface")
    def reset_typeface(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeface", []))

    @jsii.member(jsii_name="resetTypefaceVar")
    def reset_typeface_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypefaceVar", []))

    @builtins.property
    @jsii.member(jsii_name="transformation")
    def transformation(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageTextImageTransformationOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageTextImageTransformationOutputReference", jsii.get(self, "transformation"))

    @builtins.property
    @jsii.member(jsii_name="fillInput")
    def fill_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fillInput"))

    @builtins.property
    @jsii.member(jsii_name="fillVarInput")
    def fill_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fillVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sizeInput")
    def size_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sizeInput"))

    @builtins.property
    @jsii.member(jsii_name="sizeVarInput")
    def size_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sizeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="strokeInput")
    def stroke_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "strokeInput"))

    @builtins.property
    @jsii.member(jsii_name="strokeSizeInput")
    def stroke_size_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "strokeSizeInput"))

    @builtins.property
    @jsii.member(jsii_name="strokeSizeVarInput")
    def stroke_size_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "strokeSizeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="strokeVarInput")
    def stroke_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "strokeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="textInput")
    def text_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "textInput"))

    @builtins.property
    @jsii.member(jsii_name="textVarInput")
    def text_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "textVarInput"))

    @builtins.property
    @jsii.member(jsii_name="transformationInput")
    def transformation_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageTextImageTransformation"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageTextImageTransformation"], jsii.get(self, "transformationInput"))

    @builtins.property
    @jsii.member(jsii_name="typefaceInput")
    def typeface_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typefaceInput"))

    @builtins.property
    @jsii.member(jsii_name="typefaceVarInput")
    def typeface_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typefaceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="fill")
    def fill(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fill"))

    @fill.setter
    def fill(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__68a566ff84fdf3c6aa1d4686b6e64d50956a6da26dab39a19fff3bd53b736df2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fill", value)

    @builtins.property
    @jsii.member(jsii_name="fillVar")
    def fill_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fillVar"))

    @fill_var.setter
    def fill_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6b2c76937845163c2341b5a6d1c39dd29b71eed29faf61fd7f0b458642d1f234)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fillVar", value)

    @builtins.property
    @jsii.member(jsii_name="size")
    def size(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "size"))

    @size.setter
    def size(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0e4da13988451fc478bb573749a75bc1f1685741777d5cf8ff7f68c265b975fd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "size", value)

    @builtins.property
    @jsii.member(jsii_name="sizeVar")
    def size_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sizeVar"))

    @size_var.setter
    def size_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__de67995e3812bf53211c75d90b02099292efd50dc6fec4632806f2a789aa9922)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sizeVar", value)

    @builtins.property
    @jsii.member(jsii_name="stroke")
    def stroke(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "stroke"))

    @stroke.setter
    def stroke(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__77b6249884f6caed65280a9697ec899c20569b075b1c859f4210057f27bd485f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "stroke", value)

    @builtins.property
    @jsii.member(jsii_name="strokeSize")
    def stroke_size(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "strokeSize"))

    @stroke_size.setter
    def stroke_size(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d57b20b69076b86e5431499534c79392d6c50ee1219846dcc086ce0396e2ed1c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "strokeSize", value)

    @builtins.property
    @jsii.member(jsii_name="strokeSizeVar")
    def stroke_size_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "strokeSizeVar"))

    @stroke_size_var.setter
    def stroke_size_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__061208d73ab2a286bbb75f03dc24e69bdbf355fb925eb949fd53a5a5c67c5481)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "strokeSizeVar", value)

    @builtins.property
    @jsii.member(jsii_name="strokeVar")
    def stroke_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "strokeVar"))

    @stroke_var.setter
    def stroke_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e0da3d8d3759abcbe9387ba07e85c539443190a1b2e707c2a3830ad9e95955da)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "strokeVar", value)

    @builtins.property
    @jsii.member(jsii_name="text")
    def text(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "text"))

    @text.setter
    def text(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5b73f53b0e4b41f0d1bd39a601ad2647e1e7d0fa14e5b85ef50c6a1e8677e597)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "text", value)

    @builtins.property
    @jsii.member(jsii_name="textVar")
    def text_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "textVar"))

    @text_var.setter
    def text_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c6eb29b666670e3ff5d0b1ad50e197571f025a90fd835b9d8415cf5f8850c091)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "textVar", value)

    @builtins.property
    @jsii.member(jsii_name="typeface")
    def typeface(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeface"))

    @typeface.setter
    def typeface(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__597f25f79d216cbf707779e46211dd1a1f68493890edccb331f90c75536106dd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeface", value)

    @builtins.property
    @jsii.member(jsii_name="typefaceVar")
    def typeface_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typefaceVar"))

    @typeface_var.setter
    def typeface_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b6896b1af63a405d6be85b592f13b51173255a986769f77ff1ac19ed82962ece)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typefaceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageTextImage]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageTextImage]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageTextImage]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9acb7c2c0e524c763e857250274763b4e0989e686ae9aaa03fe8f74df5eb64fe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageTextImageTransformation",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageTextImageTransformation:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageTextImageTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageTextImageTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageTextImageTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e6210ec8067b9b797e1f60e6eb0ae4b1871b276fb2b55969f2caa6ccd407a3f6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageTextImageTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageTextImageTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageTextImageTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__819f6665aaeac9005e76979b9bda8d0f35dc8125ff9fbf8fd439325d46c55d25)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageUrlImage",
    jsii_struct_bases=[],
    name_mapping={
        "transformation": "transformation",
        "url": "url",
        "url_var": "urlVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageUrlImage:
    def __init__(
        self,
        *,
        transformation: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageUrlImageTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        url: typing.Optional[builtins.str] = None,
        url_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param transformation: transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        :param url: The URL of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url DataAkamaiImagingPolicyImage#url}
        :param url_var: The URL of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url_var DataAkamaiImagingPolicyImage#url_var}
        '''
        if isinstance(transformation, dict):
            transformation = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageUrlImageTransformation(**transformation)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c49eadab4f1b8a8a5b40ffe0dd08cefc95380ebbd3498ab033d8fc83e8592182)
            check_type(argname="argument transformation", value=transformation, expected_type=type_hints["transformation"])
            check_type(argname="argument url", value=url, expected_type=type_hints["url"])
            check_type(argname="argument url_var", value=url_var, expected_type=type_hints["url_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if transformation is not None:
            self._values["transformation"] = transformation
        if url is not None:
            self._values["url"] = url
        if url_var is not None:
            self._values["url_var"] = url_var

    @builtins.property
    def transformation(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageUrlImageTransformation"]:
        '''transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        '''
        result = self._values.get("transformation")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageUrlImageTransformation"], result)

    @builtins.property
    def url(self) -> typing.Optional[builtins.str]:
        '''The URL of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url DataAkamaiImagingPolicyImage#url}
        '''
        result = self._values.get("url")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def url_var(self) -> typing.Optional[builtins.str]:
        '''The URL of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url_var DataAkamaiImagingPolicyImage#url_var}
        '''
        result = self._values.get("url_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageUrlImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageUrlImageList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageUrlImageList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f523d3ef61182eaaa52de2bccdbcf74a01e45f680c57d0f39015c4b1dee49ce9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageUrlImageOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ad84da71ddf9b446317ee1a34f7714582443e3164f1191a6c7cd0c11ce14a9fb)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageUrlImageOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1e27cf29fffedcd1110f9804b2a5954f55c1f65fdcc719adc65dfd4d2bd5bc92)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__094c7ef6ab2241afff8e9f3a0b6b9ef5d5d1d5a272281719c275ba57fe4bbaa9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8b86e6930dc02d04f5fa57c368bbc74eba4781f29ca3479c32a9f333238af20c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageUrlImage]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageUrlImage]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageUrlImage]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bfd2d4b8fc0de168495b9a0969c3a9b6bec71a2abe1d5482307f835e9baafaf2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageUrlImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageUrlImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9712a4554c84a12f4c736926717c830fa5eb01fe1e286120a624ea4f67817a30)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformation")
    def put_transformation(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageUrlImageTransformation()

        return typing.cast(None, jsii.invoke(self, "putTransformation", [value]))

    @jsii.member(jsii_name="resetTransformation")
    def reset_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformation", []))

    @jsii.member(jsii_name="resetUrl")
    def reset_url(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUrl", []))

    @jsii.member(jsii_name="resetUrlVar")
    def reset_url_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUrlVar", []))

    @builtins.property
    @jsii.member(jsii_name="transformation")
    def transformation(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageUrlImageTransformationOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageUrlImageTransformationOutputReference", jsii.get(self, "transformation"))

    @builtins.property
    @jsii.member(jsii_name="transformationInput")
    def transformation_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageUrlImageTransformation"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageUrlImageTransformation"], jsii.get(self, "transformationInput"))

    @builtins.property
    @jsii.member(jsii_name="urlInput")
    def url_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "urlInput"))

    @builtins.property
    @jsii.member(jsii_name="urlVarInput")
    def url_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "urlVarInput"))

    @builtins.property
    @jsii.member(jsii_name="url")
    def url(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "url"))

    @url.setter
    def url(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__255c06a45f61b663ff500a50b1cbbc1d8d961d6ae280ac5c4e129a94cb5f7acc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "url", value)

    @builtins.property
    @jsii.member(jsii_name="urlVar")
    def url_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "urlVar"))

    @url_var.setter
    def url_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d3c3451bb332025a36d0ba5913ed3991f0e68ce45fd4604111153d259bf1b3e6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "urlVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageUrlImage]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageUrlImage]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageUrlImage]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5fe4a92057d43fc5b0c419f1ef58f0d507981da3f1d8336912071015b53134c7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageUrlImageTransformation",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageUrlImageTransformation:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageUrlImageTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageUrlImageTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageUrlImageTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5fe8186ff453c4edd4d238d0afa8332b358a64ad3f7cc40fcb6993ef251e3931)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageUrlImageTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageUrlImageTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageUrlImageTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a0aeed75a42c0612f9d2fb1ac3bf3f076ead3421ccaaf34d1b5048b868c1b658)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__323fc62d67846ac7e40e29513ff3d0760a1cf51a724009e92aa6b8bda642c350)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d9e12a638d037658fccacb91b38961c10b58ac6bc0e695d0e2255dd1bc48de44)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d01537d570572faaec089dae5ce92c81a771372b9acc77b577726d9d998ea4e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d658028d31c25a335176b7e6e5f22771f824c13c52163f9b616ee38778e56395)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0258863f2972acd58ca4e9df1deb05c88280d10104894e84e302fd54567c3733)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppend]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppend]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppend]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__851f4a04769517247c27fd8d43b2a8b533c17ea723a455192d84019c69b6d9cb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6deb34f4de4d2b002c5644fabd47618c4c7b0bfbe1cd0c218d9bbbb5a67755bf)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(
        self,
        *,
        box_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageBoxImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
        circle_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageCircleImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
        text_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageTextImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
        url_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageUrlImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param box_image: box_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#box_image DataAkamaiImagingPolicyImage#box_image}
        :param circle_image: circle_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#circle_image DataAkamaiImagingPolicyImage#circle_image}
        :param text_image: text_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text_image DataAkamaiImagingPolicyImage#text_image}
        :param url_image: url_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url_image DataAkamaiImagingPolicyImage#url_image}
        '''
        value = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImage(
            box_image=box_image,
            circle_image=circle_image,
            text_image=text_image,
            url_image=url_image,
        )

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityPriority")
    def reset_gravity_priority(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityPriority", []))

    @jsii.member(jsii_name="resetGravityPriorityVar")
    def reset_gravity_priority_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityPriorityVar", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPreserveMinorDimension")
    def reset_preserve_minor_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPreserveMinorDimension", []))

    @jsii.member(jsii_name="resetPreserveMinorDimensionVar")
    def reset_preserve_minor_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPreserveMinorDimensionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityInput")
    def gravity_priority_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityPriorityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityVarInput")
    def gravity_priority_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityPriorityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionInput")
    def preserve_minor_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "preserveMinorDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionVarInput")
    def preserve_minor_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "preserveMinorDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__75d5093095baef6192370aae339298b324059410dd4ce25c469076aa06bd60c8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityPriority")
    def gravity_priority(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityPriority"))

    @gravity_priority.setter
    def gravity_priority(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5731d4592229722fef5441084826b7a72bc7aea8c7147cef883016098d6a5bc2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityPriority", value)

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityVar")
    def gravity_priority_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityPriorityVar"))

    @gravity_priority_var.setter
    def gravity_priority_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3f8cb062b91ac84a531db0070b400d28e5b25284de9647a49aa3794e9aab50b5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityPriorityVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4d9bf9a086f7995ba7afdc4b8820a1ba4f3d70e4b909c0afb1accf797884a179)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimension")
    def preserve_minor_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "preserveMinorDimension"))

    @preserve_minor_dimension.setter
    def preserve_minor_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a4ffdda05810909b557725eb3ad96eed01dcb55af7b751553c43b35353c47e56)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "preserveMinorDimension", value)

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionVar")
    def preserve_minor_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "preserveMinorDimensionVar"))

    @preserve_minor_dimension_var.setter
    def preserve_minor_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d644586eba9932d9369196c6013e3d60e00fc93238f878f29b0da4942de046d9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "preserveMinorDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppend]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppend]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppend]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dd6a20a94e4818cd09247c29606da133d2eea5c0b13ea4847179dec13e179fc6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAspectCrop",
    jsii_struct_bases=[],
    name_mapping={
        "allow_expansion": "allowExpansion",
        "allow_expansion_var": "allowExpansionVar",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAspectCrop:
    def __init__(
        self,
        *,
        allow_expansion: typing.Optional[builtins.str] = None,
        allow_expansion_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_expansion: Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image. Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        :param allow_expansion_var: Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image. Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        :param height: The height term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The width term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        :param x_position: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e7ab40c1edad3448d56ae79c2d90855460c5ce9fa0cec4c6e771d5f50a01208f)
            check_type(argname="argument allow_expansion", value=allow_expansion, expected_type=type_hints["allow_expansion"])
            check_type(argname="argument allow_expansion_var", value=allow_expansion_var, expected_type=type_hints["allow_expansion_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if allow_expansion is not None:
            self._values["allow_expansion"] = allow_expansion
        if allow_expansion_var is not None:
            self._values["allow_expansion_var"] = allow_expansion_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def allow_expansion(self) -> typing.Optional[builtins.str]:
        '''Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image.

        Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        '''
        result = self._values.get("allow_expansion")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def allow_expansion_var(self) -> typing.Optional[builtins.str]:
        '''Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image.

        Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        '''
        result = self._values.get("allow_expansion_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAspectCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAspectCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAspectCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a454ce1e89c02bbd28840f630ebeed4313d13c5f22437b529666f25dcc953440)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAspectCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6630a68574aaa8608528100946fd61e9291eb462246deadb5a0ef199f6bc8e9f)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAspectCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d1fa6e4366570b9d82b6a8fc56260b955031fa522925b25778901e1b46afe27e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1e6d01f9fe4dd20ffa7ee2351748a20acbeb37c7485f2c479703022a0885e6a9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__97458053e9ea5a35c48d3eaa36dd6c2c2ac0ae82eadf9196bd7cf4f2e5d647c6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAspectCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAspectCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAspectCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f90802fc5f573cb597d249519ad7da37bb6977d1b12f71ceb804cf4d1936054f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAspectCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAspectCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b9f5b68bfd37cdf920213d488f42282e4615cf27cc370fd037ae5c6c4b4dc4df)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAllowExpansion")
    def reset_allow_expansion(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansion", []))

    @jsii.member(jsii_name="resetAllowExpansionVar")
    def reset_allow_expansion_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansionVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionInput")
    def allow_expansion_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVarInput")
    def allow_expansion_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansion")
    def allow_expansion(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansion"))

    @allow_expansion.setter
    def allow_expansion(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__90301a36b8cffc19cb6b3b2024a283e123a8886804912b3af29bfa2f44c7b4e2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansion", value)

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVar")
    def allow_expansion_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansionVar"))

    @allow_expansion_var.setter
    def allow_expansion_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c965952cddb02afb4a1059842660a6eeeceb3a0e3e8960e085716c8088d37234)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansionVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0d39483ea24d247e28e0cf1d893e9683112dff1bfee60b69ac2858c147dd1c6b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d72d60bb01879e5a7e10424c9f6fee3993c1ec7d52aa4950d7b38c969b953c24)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c937291a21dd0d3edf2cc1cfa146c16ca9f1c228fc0eedac114c5989ef9abda9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d66414fa8f4afdc541f52556545046f42bedad057aaed7ebcb952282f84c0162)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b835cd2e9759c5a6008a171cb5c511efbb6ad5c2d70c9ddeab417cc6ceb86e6c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__489a4646c7d47a247f0f3b1b058b337deb1944b40fbb0707243a6d010364f44e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__66ef43b0ce54f1082194ffa65a7f5c03ad25f693fc7087f55284a5d147bc6418)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__77277ea9989c76295dc22c45cea2ca2344025fd6ba0491c6473cfeeeb00da653)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAspectCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAspectCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAspectCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0c87963e9d4582a8378eca68783ec7eedde363b378a444c3ee685bba799c98e2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationBackgroundColor",
    jsii_struct_bases=[],
    name_mapping={"color": "color", "color_var": "colorVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationBackgroundColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d4fae8f0b720a4848c4d8cbe7c7ce7d26bed95d24d8927a25b9664d0a2c0e5a5)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationBackgroundColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationBackgroundColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationBackgroundColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4e47c7e47983448263f9264af063830517d025ae5f8c6e5b36b701064db03505)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationBackgroundColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__edff08b1014d30719f9f91a27e3721d3c4d48fb56b3a3e4ab310e7b793646e9d)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationBackgroundColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9418f63f4a4132b1e0c44cb84955c35b5a54b93eaf87e550ac6519071d5fb137)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c32c709216a145dec05657153d5105ced57d43ada17e31d6f0009c2548d2920c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7a24ac1813d5ec08961a55041855f5afb883a1d97ec177efc399d8e62ea4a441)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationBackgroundColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationBackgroundColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8984fe404f562802a89efa3b7cb4d36e13a5bab463aeea6a1d6271a49f0cf55f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationBackgroundColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationBackgroundColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bd7c976e916d080fe2b19ed4a2845397bfcc08e9fb6aa2560fc9ffd039185b60)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__25e37e8a01a819d778d1b82023dac5878e2759c80a3db944d590978ee59fd9c7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e25833b6033419d0400bab1ddd21a627e2cdc973a823d3614007fc7df17421af)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationBackgroundColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationBackgroundColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationBackgroundColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__05c3ede8dc0c91754b14a424e471e39b2687adbc8b5becd26ee2638bad872595)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationBlur",
    jsii_struct_bases=[],
    name_mapping={"sigma": "sigma", "sigma_var": "sigmaVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationBlur:
    def __init__(
        self,
        *,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param sigma: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f2f823365e9ce9bfe16d2c264ea1da859f6cb2900962682f7f17b74ac5641fa)
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationBlur(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationBlurList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationBlurList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c7e80bb347ac1c59e2cb92679e155a16f0915fc7c634366f638e832f6bd19057)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationBlurOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__460cd2b269c429d38af12f181a2476ac722416ff3611de3a166b424f9941e191)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationBlurOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bbf07657ef4611b6372885a3ff40ce4d74e5cf6f149ca5b2afbf390b0a6b6d9c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__00aa8e820db5fe5ef5e39baefdca7cbc2817308f2867f060ded6fca5ac2c557b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d0f8aae1bf84ca0c129b3466296f2275e8065d25290dba063365427d2de1021)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationBlur]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationBlur]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4c269ee39d7833257ab9225d6ebb11f6b4551e8493ce50b6b1771cbdf974c447)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationBlurOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationBlurOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea5ca87672661a8a060e94c5f10a887d270c30d97c8a8073e2d06de4b21a4191)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__739eff69a138233bb889c46da3b837880c7ca30298bce41d42ec8867eccb7915)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ade50ad166c45a4c67e1e95f6b0c97d0ca6cb97b0c932c85e44c05a33a1d153c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationBlur]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationBlur]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationBlur]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3188c2ba4fba06f7c5d5a5513e7c31b4b207b123feba19f4ece2a177acb9c0ba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationChromaKey",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_feather": "hueFeather",
        "hue_feather_var": "hueFeatherVar",
        "hue_tolerance": "hueTolerance",
        "hue_tolerance_var": "hueToleranceVar",
        "hue_var": "hueVar",
        "lightness_feather": "lightnessFeather",
        "lightness_feather_var": "lightnessFeatherVar",
        "lightness_tolerance": "lightnessTolerance",
        "lightness_tolerance_var": "lightnessToleranceVar",
        "saturation_feather": "saturationFeather",
        "saturation_feather_var": "saturationFeatherVar",
        "saturation_tolerance": "saturationTolerance",
        "saturation_tolerance_var": "saturationToleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationChromaKey:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_feather: typing.Optional[builtins.str] = None,
        hue_feather_var: typing.Optional[builtins.str] = None,
        hue_tolerance: typing.Optional[builtins.str] = None,
        hue_tolerance_var: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness_feather: typing.Optional[builtins.str] = None,
        lightness_feather_var: typing.Optional[builtins.str] = None,
        lightness_tolerance: typing.Optional[builtins.str] = None,
        lightness_tolerance_var: typing.Optional[builtins.str] = None,
        saturation_feather: typing.Optional[builtins.str] = None,
        saturation_feather_var: typing.Optional[builtins.str] = None,
        saturation_tolerance: typing.Optional[builtins.str] = None,
        saturation_tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_feather: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        :param hue_feather_var: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        :param hue_tolerance: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        :param hue_tolerance_var: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        :param hue_var: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness_feather: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        :param lightness_feather_var: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        :param lightness_tolerance: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        :param lightness_tolerance_var: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        :param saturation_feather: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        :param saturation_feather_var: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        :param saturation_tolerance: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        :param saturation_tolerance_var: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4590b6569542b611977d0ab607d8e1f05c8801fd12f951f226bdb783936688c8)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_feather", value=hue_feather, expected_type=type_hints["hue_feather"])
            check_type(argname="argument hue_feather_var", value=hue_feather_var, expected_type=type_hints["hue_feather_var"])
            check_type(argname="argument hue_tolerance", value=hue_tolerance, expected_type=type_hints["hue_tolerance"])
            check_type(argname="argument hue_tolerance_var", value=hue_tolerance_var, expected_type=type_hints["hue_tolerance_var"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness_feather", value=lightness_feather, expected_type=type_hints["lightness_feather"])
            check_type(argname="argument lightness_feather_var", value=lightness_feather_var, expected_type=type_hints["lightness_feather_var"])
            check_type(argname="argument lightness_tolerance", value=lightness_tolerance, expected_type=type_hints["lightness_tolerance"])
            check_type(argname="argument lightness_tolerance_var", value=lightness_tolerance_var, expected_type=type_hints["lightness_tolerance_var"])
            check_type(argname="argument saturation_feather", value=saturation_feather, expected_type=type_hints["saturation_feather"])
            check_type(argname="argument saturation_feather_var", value=saturation_feather_var, expected_type=type_hints["saturation_feather_var"])
            check_type(argname="argument saturation_tolerance", value=saturation_tolerance, expected_type=type_hints["saturation_tolerance"])
            check_type(argname="argument saturation_tolerance_var", value=saturation_tolerance_var, expected_type=type_hints["saturation_tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_feather is not None:
            self._values["hue_feather"] = hue_feather
        if hue_feather_var is not None:
            self._values["hue_feather_var"] = hue_feather_var
        if hue_tolerance is not None:
            self._values["hue_tolerance"] = hue_tolerance
        if hue_tolerance_var is not None:
            self._values["hue_tolerance_var"] = hue_tolerance_var
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness_feather is not None:
            self._values["lightness_feather"] = lightness_feather
        if lightness_feather_var is not None:
            self._values["lightness_feather_var"] = lightness_feather_var
        if lightness_tolerance is not None:
            self._values["lightness_tolerance"] = lightness_tolerance
        if lightness_tolerance_var is not None:
            self._values["lightness_tolerance_var"] = lightness_tolerance_var
        if saturation_feather is not None:
            self._values["saturation_feather"] = saturation_feather
        if saturation_feather_var is not None:
            self._values["saturation_feather_var"] = saturation_feather_var
        if saturation_tolerance is not None:
            self._values["saturation_tolerance"] = saturation_tolerance
        if saturation_tolerance_var is not None:
            self._values["saturation_tolerance_var"] = saturation_tolerance_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        '''
        result = self._values.get("hue_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        '''
        result = self._values.get("hue_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        '''
        result = self._values.get("hue_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        '''
        result = self._values.get("hue_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        '''
        result = self._values.get("lightness_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        '''
        result = self._values.get("lightness_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        '''
        result = self._values.get("lightness_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        '''
        result = self._values.get("lightness_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        '''
        result = self._values.get("saturation_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        '''
        result = self._values.get("saturation_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        '''
        result = self._values.get("saturation_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        result = self._values.get("saturation_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationChromaKey(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationChromaKeyList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationChromaKeyList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2b1eefd946c8a5a3a430020d558047168e91b9c7b270e1c16fc1b9bf6cc1a933)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationChromaKeyOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e8bbb393f92da4f1a5ba2ecb534538521fbfdb43060d6a1862129cc6adc88a43)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationChromaKeyOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af3cd8623d87fae14dfdf1b164a6dee82c2c832d6ec683430a23c3d73dadb731)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ca46a65fd5d760fa9cf58bedbe79fec675b9e9d5a5f721960e3cfa288ebed178)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9b101fd4c65d7855ce122cb43ef0d64d3dee40d7867b4b4ba2d4aec9f689d1d0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationChromaKey]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationChromaKey]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d345e39f1fa6f84dbb1b34e0d5808a645802c179a38d72aad50c4db89bab0543)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationChromaKeyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationChromaKeyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__676727814bda73d77f36a46593e6839f1ba30159b0d4bc5e7420fbb196a132ff)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueFeather")
    def reset_hue_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeather", []))

    @jsii.member(jsii_name="resetHueFeatherVar")
    def reset_hue_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeatherVar", []))

    @jsii.member(jsii_name="resetHueTolerance")
    def reset_hue_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueTolerance", []))

    @jsii.member(jsii_name="resetHueToleranceVar")
    def reset_hue_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueToleranceVar", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightnessFeather")
    def reset_lightness_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeather", []))

    @jsii.member(jsii_name="resetLightnessFeatherVar")
    def reset_lightness_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeatherVar", []))

    @jsii.member(jsii_name="resetLightnessTolerance")
    def reset_lightness_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessTolerance", []))

    @jsii.member(jsii_name="resetLightnessToleranceVar")
    def reset_lightness_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessToleranceVar", []))

    @jsii.member(jsii_name="resetSaturationFeather")
    def reset_saturation_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeather", []))

    @jsii.member(jsii_name="resetSaturationFeatherVar")
    def reset_saturation_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeatherVar", []))

    @jsii.member(jsii_name="resetSaturationTolerance")
    def reset_saturation_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationTolerance", []))

    @jsii.member(jsii_name="resetSaturationToleranceVar")
    def reset_saturation_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherInput")
    def hue_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVarInput")
    def hue_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceInput")
    def hue_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVarInput")
    def hue_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherInput")
    def lightness_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVarInput")
    def lightness_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceInput")
    def lightness_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVarInput")
    def lightness_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherInput")
    def saturation_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVarInput")
    def saturation_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceInput")
    def saturation_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVarInput")
    def saturation_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e425992c6ff852b6fc76a623421fad6b22cbad7a2b2c8146aebc42207480b405)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeather")
    def hue_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeather"))

    @hue_feather.setter
    def hue_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__161af6b084bc38159d1c016897271314c23e039581939718b0f13b2fc8fc3fa7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeather", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVar")
    def hue_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeatherVar"))

    @hue_feather_var.setter
    def hue_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5eb84f8deac37f5419f3ce05f9d8faa1a0dff08d251d0d312c7169dd2553a76c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueTolerance")
    def hue_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueTolerance"))

    @hue_tolerance.setter
    def hue_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ba5956463ef79974779b97458ba7050bca6bb6ee31926c825735fcb2da87612)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVar")
    def hue_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueToleranceVar"))

    @hue_tolerance_var.setter
    def hue_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d3ad93a24e8ccc20b7c3fc2e05c0c1588a4e2645a6026899453949d93eb5a758)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cc61654f839e7173efc7fc07b7a86517a8c02c6b97bab359fc75f94a13e55b24)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeather")
    def lightness_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeather"))

    @lightness_feather.setter
    def lightness_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b08cc06acf487ff76a0c5d9d830a123a34098002ef29edb7984f3c271adcf799)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeather", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVar")
    def lightness_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeatherVar"))

    @lightness_feather_var.setter
    def lightness_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0993af54adb43d3b2f814f46a675b7c67cd81441825ebfd6e1a6f11c9117a4a5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessTolerance")
    def lightness_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessTolerance"))

    @lightness_tolerance.setter
    def lightness_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4fc570648382287eb7a3560449420d687ffa82755433b0b16e89363682e4ec72)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVar")
    def lightness_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessToleranceVar"))

    @lightness_tolerance_var.setter
    def lightness_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f80a85ea369661a486fbf227c9eb970cfad82123ba40141341f8be04c2a1668a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeather")
    def saturation_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeather"))

    @saturation_feather.setter
    def saturation_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1ce71598b83098d755acf62a3acb78e037066210b5a8cb9baf4df541af156142)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeather", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVar")
    def saturation_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeatherVar"))

    @saturation_feather_var.setter
    def saturation_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__895aa029c9a185e768b62f141457323631d7f90f110007fb92ab6be863b6ac93)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationTolerance")
    def saturation_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationTolerance"))

    @saturation_tolerance.setter
    def saturation_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a1e6e283417555356f0139527ea9eb174ade0436ed2a563be31e3512e0a13066)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVar")
    def saturation_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationToleranceVar"))

    @saturation_tolerance_var.setter
    def saturation_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__44f222924d570fbbb0bcd675a792c4aa0e46157130d47b6d456fee2581efc400)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationChromaKey]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationChromaKey]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationChromaKey]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ecf9879fdf927a7efa7887e4b2b792274ae938baafc06e78a1426f0c06a62b4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationComposite",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "placement": "placement",
        "placement_var": "placementVar",
        "scale": "scale",
        "scale_dimension": "scaleDimension",
        "scale_dimension_var": "scaleDimensionVar",
        "scale_var": "scaleVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationComposite:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        placement: typing.Optional[builtins.str] = None,
        placement_var: typing.Optional[builtins.str] = None,
        scale: typing.Optional[builtins.str] = None,
        scale_dimension: typing.Optional[builtins.str] = None,
        scale_dimension_var: typing.Optional[builtins.str] = None,
        scale_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param placement: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        :param placement_var: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        :param scale: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param scale_dimension: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        :param scale_dimension_var: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        :param scale_var: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        :param x_position: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8c770f49a4bcf181d01597f1fa036444569c9a8034c4e157311ad8ee43af3d57)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument placement", value=placement, expected_type=type_hints["placement"])
            check_type(argname="argument placement_var", value=placement_var, expected_type=type_hints["placement_var"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument scale_dimension", value=scale_dimension, expected_type=type_hints["scale_dimension"])
            check_type(argname="argument scale_dimension_var", value=scale_dimension_var, expected_type=type_hints["scale_dimension_var"])
            check_type(argname="argument scale_var", value=scale_var, expected_type=type_hints["scale_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if placement is not None:
            self._values["placement"] = placement
        if placement_var is not None:
            self._values["placement_var"] = placement_var
        if scale is not None:
            self._values["scale"] = scale
        if scale_dimension is not None:
            self._values["scale_dimension"] = scale_dimension
        if scale_dimension_var is not None:
            self._values["scale_dimension_var"] = scale_dimension_var
        if scale_var is not None:
            self._values["scale_var"] = scale_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        '''
        result = self._values.get("placement")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement_var(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        '''
        result = self._values.get("placement_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        '''
        result = self._values.get("scale_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        '''
        result = self._values.get("scale_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        '''
        result = self._values.get("scale_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationComposite(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImage",
    jsii_struct_bases=[],
    name_mapping={
        "box_image": "boxImage",
        "circle_image": "circleImage",
        "text_image": "textImage",
        "url_image": "urlImage",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImage:
    def __init__(
        self,
        *,
        box_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageBoxImage", typing.Dict[builtins.str, typing.Any]]]]] = None,
        circle_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageCircleImage", typing.Dict[builtins.str, typing.Any]]]]] = None,
        text_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageTextImage", typing.Dict[builtins.str, typing.Any]]]]] = None,
        url_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageUrlImage", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param box_image: box_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#box_image DataAkamaiImagingPolicyImage#box_image}
        :param circle_image: circle_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#circle_image DataAkamaiImagingPolicyImage#circle_image}
        :param text_image: text_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text_image DataAkamaiImagingPolicyImage#text_image}
        :param url_image: url_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url_image DataAkamaiImagingPolicyImage#url_image}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4fb5ce15b948dc9d0da1731e9e4c8436b8f5fa62c71da72f36a1eed522f18a51)
            check_type(argname="argument box_image", value=box_image, expected_type=type_hints["box_image"])
            check_type(argname="argument circle_image", value=circle_image, expected_type=type_hints["circle_image"])
            check_type(argname="argument text_image", value=text_image, expected_type=type_hints["text_image"])
            check_type(argname="argument url_image", value=url_image, expected_type=type_hints["url_image"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if box_image is not None:
            self._values["box_image"] = box_image
        if circle_image is not None:
            self._values["circle_image"] = circle_image
        if text_image is not None:
            self._values["text_image"] = text_image
        if url_image is not None:
            self._values["url_image"] = url_image

    @builtins.property
    def box_image(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageBoxImage"]]]:
        '''box_image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#box_image DataAkamaiImagingPolicyImage#box_image}
        '''
        result = self._values.get("box_image")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageBoxImage"]]], result)

    @builtins.property
    def circle_image(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageCircleImage"]]]:
        '''circle_image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#circle_image DataAkamaiImagingPolicyImage#circle_image}
        '''
        result = self._values.get("circle_image")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageCircleImage"]]], result)

    @builtins.property
    def text_image(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageTextImage"]]]:
        '''text_image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text_image DataAkamaiImagingPolicyImage#text_image}
        '''
        result = self._values.get("text_image")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageTextImage"]]], result)

    @builtins.property
    def url_image(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageUrlImage"]]]:
        '''url_image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url_image DataAkamaiImagingPolicyImage#url_image}
        '''
        result = self._values.get("url_image")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageUrlImage"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageBoxImage",
    jsii_struct_bases=[],
    name_mapping={
        "color": "color",
        "color_var": "colorVar",
        "height": "height",
        "height_var": "heightVar",
        "transformation": "transformation",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageBoxImage:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        transformation: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageBoxImageTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The fill color of the box, not the edge of the box. The API supports hexadecimal representation and CSS hexadecimal color values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The fill color of the box, not the edge of the box. The API supports hexadecimal representation and CSS hexadecimal color values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        :param height: The height of the box in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height of the box in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param transformation: transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        :param width: The width of the box in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width of the box in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(transformation, dict):
            transformation = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageBoxImageTransformation(**transformation)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6fc770d95f1048f9e26b8f8d8f99e1c3141152ed017956a5dec4fb109394867e)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument transformation", value=transformation, expected_type=type_hints["transformation"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if transformation is not None:
            self._values["transformation"] = transformation
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The fill color of the box, not the edge of the box.

        The API supports hexadecimal representation and CSS hexadecimal color values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The fill color of the box, not the edge of the box.

        The API supports hexadecimal representation and CSS hexadecimal color values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height of the box in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height of the box in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def transformation(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageBoxImageTransformation"]:
        '''transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        '''
        result = self._values.get("transformation")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageBoxImageTransformation"], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width of the box in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width of the box in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageBoxImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageBoxImageList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageBoxImageList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__149486a0b2e458ed5ef086458f87806c9392a9fe83ebec65e3e7f11b4e5df221)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageBoxImageOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__46f6a7c20c68419fae8de812078b2dee1d340d2a25629aa97231c097aece8aa4)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageBoxImageOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e54cbef9058b27e260d0630cabac82dd1ce352012c072c70fad41d7dfb8182ad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5264d30de1dcf81e77225a37dac6db460d12162b6f3b38dec7dd7b5cf5a4ee6a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c4059b1a6ce8e3adc50a4805b20b87e3803306022fcf0de6eda4a4fb4187d8cc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageBoxImage]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageBoxImage]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageBoxImage]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a81812cb274f14c9d033b4a37e58cb4f63e413c596d449f10e5d3685025e2d1e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageBoxImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageBoxImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__58d1d4e005946a95cc5621c95e9767f63ee33a19ceed7fb2b5b7e868fb2f6ef8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformation")
    def put_transformation(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageBoxImageTransformation()

        return typing.cast(None, jsii.invoke(self, "putTransformation", [value]))

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetTransformation")
    def reset_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformation", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="transformation")
    def transformation(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageBoxImageTransformationOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageBoxImageTransformationOutputReference", jsii.get(self, "transformation"))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="transformationInput")
    def transformation_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageBoxImageTransformation"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageBoxImageTransformation"], jsii.get(self, "transformationInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fe1db566455f5239ca80b58ea1f2e375afe2154162850d3f408c289d97b9a920)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4d94f3b424ca9c8437f75de9c220f07f30a0e605f2ff905fbebcba55d49aadec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a1c1ea4ebf0a031f1252324ad15a6fd9ac6cfbd075d1efab52fb92cc8d50e0c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f5a6c7c0dd768356a8003d60f90473ac2e77266dba15495bf473067ef1280c70)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7888c585013669f7a0578f8a4363ef48cceed4e95e75a47124f0546b2fbea48e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9f9859c21c4416e7420ad2639e3b9481d764b07d79fb2456d85637faac9be493)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageBoxImage]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageBoxImage]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageBoxImage]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__49cabb7c0af3d508d6e5902daf2e4b0c0f7d0b70e3794daf574f499f555ff5a4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageBoxImageTransformation",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageBoxImageTransformation:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageBoxImageTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageBoxImageTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageBoxImageTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3eea0f3de75b2030038fda278bb7a5beb1145adfe9a6314f4f2575abe700deeb)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageBoxImageTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageBoxImageTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageBoxImageTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cfa3020d2652e7e47988523e78d8902a79999a17fb7efe06fa17256e5659d47a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageCircleImage",
    jsii_struct_bases=[],
    name_mapping={
        "color": "color",
        "color_var": "colorVar",
        "diameter": "diameter",
        "diameter_var": "diameterVar",
        "transformation": "transformation",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageCircleImage:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
        diameter: typing.Optional[builtins.str] = None,
        diameter_var: typing.Optional[builtins.str] = None,
        transformation: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageCircleImageTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The fill color of the circle. The API supports hexadecimal representation and CSS hexadecimal color values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The fill color of the circle. The API supports hexadecimal representation and CSS hexadecimal color values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        :param diameter: The diameter of the circle. The diameter will be the width and the height of the image in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#diameter DataAkamaiImagingPolicyImage#diameter}
        :param diameter_var: The diameter of the circle. The diameter will be the width and the height of the image in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#diameter_var DataAkamaiImagingPolicyImage#diameter_var}
        :param transformation: transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        :param width: The width of the box in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width of the box in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(transformation, dict):
            transformation = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageCircleImageTransformation(**transformation)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d569a7bb7080a1e3d1f5f897a74b7b734fe2783e31711bbb2640233299ea6c6b)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
            check_type(argname="argument diameter", value=diameter, expected_type=type_hints["diameter"])
            check_type(argname="argument diameter_var", value=diameter_var, expected_type=type_hints["diameter_var"])
            check_type(argname="argument transformation", value=transformation, expected_type=type_hints["transformation"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var
        if diameter is not None:
            self._values["diameter"] = diameter
        if diameter_var is not None:
            self._values["diameter_var"] = diameter_var
        if transformation is not None:
            self._values["transformation"] = transformation
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The fill color of the circle. The API supports hexadecimal representation and CSS hexadecimal color values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The fill color of the circle. The API supports hexadecimal representation and CSS hexadecimal color values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def diameter(self) -> typing.Optional[builtins.str]:
        '''The diameter of the circle. The diameter will be the width and the height of the image in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#diameter DataAkamaiImagingPolicyImage#diameter}
        '''
        result = self._values.get("diameter")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def diameter_var(self) -> typing.Optional[builtins.str]:
        '''The diameter of the circle. The diameter will be the width and the height of the image in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#diameter_var DataAkamaiImagingPolicyImage#diameter_var}
        '''
        result = self._values.get("diameter_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def transformation(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageCircleImageTransformation"]:
        '''transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        '''
        result = self._values.get("transformation")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageCircleImageTransformation"], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width of the box in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width of the box in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageCircleImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageCircleImageList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageCircleImageList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bdfc4afb42b6896b10cdf045587188eda66f72750a5462d8e485f460d3e32e83)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageCircleImageOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__70e6b17c202a52a5a3ffc03f08258f1d9a27e69731b47684e1178bc1860771e5)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageCircleImageOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__66bd749e68c4164abe3a7c987a86cd0d8677964d81a6a8add95f0de454bb2a30)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__41f96dadb69a7144480834fdabd685dbfe11e06136d7021d24fe7bd5eaa1416d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d34667a61000c9f3f03de142ecda0bb22bae3c0772f16b3925fc0529fc7a0736)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageCircleImage]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageCircleImage]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageCircleImage]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1bdfd6033da07823a0d3ee1bf3cb9e065c76409d65558fb70a9eab1296d70648)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageCircleImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageCircleImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__12a44cf0ed0441826e5789ff9657976004193fafa2f73164b890b939a878d036)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformation")
    def put_transformation(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageCircleImageTransformation()

        return typing.cast(None, jsii.invoke(self, "putTransformation", [value]))

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @jsii.member(jsii_name="resetDiameter")
    def reset_diameter(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDiameter", []))

    @jsii.member(jsii_name="resetDiameterVar")
    def reset_diameter_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDiameterVar", []))

    @jsii.member(jsii_name="resetTransformation")
    def reset_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformation", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="transformation")
    def transformation(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageCircleImageTransformationOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageCircleImageTransformationOutputReference", jsii.get(self, "transformation"))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="diameterInput")
    def diameter_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "diameterInput"))

    @builtins.property
    @jsii.member(jsii_name="diameterVarInput")
    def diameter_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "diameterVarInput"))

    @builtins.property
    @jsii.member(jsii_name="transformationInput")
    def transformation_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageCircleImageTransformation"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageCircleImageTransformation"], jsii.get(self, "transformationInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9edc615b7637cc0139d03d396500ea9728c4988a2b49cec43341e2cae6d3f4df)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__51636ffa8b84b0221732facb08984703cae87cf188955aa3f580a47ecea9fdcc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="diameter")
    def diameter(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "diameter"))

    @diameter.setter
    def diameter(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ee201b75e7d53d2a7fde518f1cad35d6a795f88b549ef8a3342c93056f4d7ee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "diameter", value)

    @builtins.property
    @jsii.member(jsii_name="diameterVar")
    def diameter_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "diameterVar"))

    @diameter_var.setter
    def diameter_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1200e701fc3796c1ae2a3b3bd7e0ba257a499f70a5f20ab10cfe656aa1e1ab7f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "diameterVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2b82699452fee535d6bbc74bf243b48cd1c269c7e58b8e46bf6c175172c7faae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5e1e4337979a2fe5b686e0d74f0eaacd296101e99fec4763fa63be76a4f8cb54)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageCircleImage]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageCircleImage]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageCircleImage]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__06aa358037036267f6cc6dbc165f17195d6af8e8771f1a7e748ca68508a6f800)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageCircleImageTransformation",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageCircleImageTransformation:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageCircleImageTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageCircleImageTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageCircleImageTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8df3e9e2077e8074e17be64ee9c4db1c586a9faa03ff621f7c03573fa14b746a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageCircleImageTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageCircleImageTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageCircleImageTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__404670fc423fb73c6d905f28feb3d792619044f791bab1f16b1e7d482fdeb6a4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8548df85ea1169b25708266cfa5b51952a7bd8846415e1609c26ad63f276bd17)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putBoxImage")
    def put_box_image(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageBoxImage, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__51de2dbd121b11ba833c3a9890265e284ba605d0509e7e09d7d69cf075dd81b9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBoxImage", [value]))

    @jsii.member(jsii_name="putCircleImage")
    def put_circle_image(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageCircleImage, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e0331e723b8e2ad2b6697333f48e86b41d15c09dc8a1b5b563d6c2f342b45d28)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCircleImage", [value]))

    @jsii.member(jsii_name="putTextImage")
    def put_text_image(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageTextImage", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aa7c21746de29470ad3060a720c957788a1755b5dcc8480b25f5cf6cfb69f862)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTextImage", [value]))

    @jsii.member(jsii_name="putUrlImage")
    def put_url_image(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageUrlImage", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__15c0a3b5a07b1b7ee02facf69c456e8dfc28e02c1fd179c129361b8f89ce830d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putUrlImage", [value]))

    @jsii.member(jsii_name="resetBoxImage")
    def reset_box_image(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBoxImage", []))

    @jsii.member(jsii_name="resetCircleImage")
    def reset_circle_image(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCircleImage", []))

    @jsii.member(jsii_name="resetTextImage")
    def reset_text_image(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTextImage", []))

    @jsii.member(jsii_name="resetUrlImage")
    def reset_url_image(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUrlImage", []))

    @builtins.property
    @jsii.member(jsii_name="boxImage")
    def box_image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageBoxImageList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageBoxImageList, jsii.get(self, "boxImage"))

    @builtins.property
    @jsii.member(jsii_name="circleImage")
    def circle_image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageCircleImageList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageCircleImageList, jsii.get(self, "circleImage"))

    @builtins.property
    @jsii.member(jsii_name="textImage")
    def text_image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageTextImageList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageTextImageList", jsii.get(self, "textImage"))

    @builtins.property
    @jsii.member(jsii_name="urlImage")
    def url_image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageUrlImageList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageUrlImageList", jsii.get(self, "urlImage"))

    @builtins.property
    @jsii.member(jsii_name="boxImageInput")
    def box_image_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageBoxImage]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageBoxImage]]], jsii.get(self, "boxImageInput"))

    @builtins.property
    @jsii.member(jsii_name="circleImageInput")
    def circle_image_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageCircleImage]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageCircleImage]]], jsii.get(self, "circleImageInput"))

    @builtins.property
    @jsii.member(jsii_name="textImageInput")
    def text_image_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageTextImage"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageTextImage"]]], jsii.get(self, "textImageInput"))

    @builtins.property
    @jsii.member(jsii_name="urlImageInput")
    def url_image_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageUrlImage"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageUrlImage"]]], jsii.get(self, "urlImageInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__12096ba461442fb0b8eaa18e4afd0ddc8d7c1f5317e70ffc3dc5c20bab0a1421)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageTextImage",
    jsii_struct_bases=[],
    name_mapping={
        "fill": "fill",
        "fill_var": "fillVar",
        "size": "size",
        "size_var": "sizeVar",
        "stroke": "stroke",
        "stroke_size": "strokeSize",
        "stroke_size_var": "strokeSizeVar",
        "stroke_var": "strokeVar",
        "text": "text",
        "text_var": "textVar",
        "transformation": "transformation",
        "typeface": "typeface",
        "typeface_var": "typefaceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageTextImage:
    def __init__(
        self,
        *,
        fill: typing.Optional[builtins.str] = None,
        fill_var: typing.Optional[builtins.str] = None,
        size: typing.Optional[builtins.str] = None,
        size_var: typing.Optional[builtins.str] = None,
        stroke: typing.Optional[builtins.str] = None,
        stroke_size: typing.Optional[builtins.str] = None,
        stroke_size_var: typing.Optional[builtins.str] = None,
        stroke_var: typing.Optional[builtins.str] = None,
        text: typing.Optional[builtins.str] = None,
        text_var: typing.Optional[builtins.str] = None,
        transformation: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageTextImageTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        typeface: typing.Optional[builtins.str] = None,
        typeface_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fill: The main fill color of the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill DataAkamaiImagingPolicyImage#fill}
        :param fill_var: The main fill color of the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_var DataAkamaiImagingPolicyImage#fill_var}
        :param size: The size in pixels to render the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#size DataAkamaiImagingPolicyImage#size}
        :param size_var: The size in pixels to render the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#size_var DataAkamaiImagingPolicyImage#size_var}
        :param stroke: The color for the outline of the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke DataAkamaiImagingPolicyImage#stroke}
        :param stroke_size: The thickness in points for the outline of the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_size DataAkamaiImagingPolicyImage#stroke_size}
        :param stroke_size_var: The thickness in points for the outline of the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_size_var DataAkamaiImagingPolicyImage#stroke_size_var}
        :param stroke_var: The color for the outline of the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_var DataAkamaiImagingPolicyImage#stroke_var}
        :param text: The line of text to render. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text DataAkamaiImagingPolicyImage#text}
        :param text_var: The line of text to render. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text_var DataAkamaiImagingPolicyImage#text_var}
        :param transformation: transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        :param typeface: The font family to apply to the text image. This may be a URL to a TrueType or WOFF (v1) typeface, or a string that refers to one of the standard built-in browser fonts. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#typeface DataAkamaiImagingPolicyImage#typeface}
        :param typeface_var: The font family to apply to the text image. This may be a URL to a TrueType or WOFF (v1) typeface, or a string that refers to one of the standard built-in browser fonts. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#typeface_var DataAkamaiImagingPolicyImage#typeface_var}
        '''
        if isinstance(transformation, dict):
            transformation = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageTextImageTransformation(**transformation)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5365bd04e8ba90fd525bd245720dad541b71758f2c01f10c1c173c4b88cda73d)
            check_type(argname="argument fill", value=fill, expected_type=type_hints["fill"])
            check_type(argname="argument fill_var", value=fill_var, expected_type=type_hints["fill_var"])
            check_type(argname="argument size", value=size, expected_type=type_hints["size"])
            check_type(argname="argument size_var", value=size_var, expected_type=type_hints["size_var"])
            check_type(argname="argument stroke", value=stroke, expected_type=type_hints["stroke"])
            check_type(argname="argument stroke_size", value=stroke_size, expected_type=type_hints["stroke_size"])
            check_type(argname="argument stroke_size_var", value=stroke_size_var, expected_type=type_hints["stroke_size_var"])
            check_type(argname="argument stroke_var", value=stroke_var, expected_type=type_hints["stroke_var"])
            check_type(argname="argument text", value=text, expected_type=type_hints["text"])
            check_type(argname="argument text_var", value=text_var, expected_type=type_hints["text_var"])
            check_type(argname="argument transformation", value=transformation, expected_type=type_hints["transformation"])
            check_type(argname="argument typeface", value=typeface, expected_type=type_hints["typeface"])
            check_type(argname="argument typeface_var", value=typeface_var, expected_type=type_hints["typeface_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fill is not None:
            self._values["fill"] = fill
        if fill_var is not None:
            self._values["fill_var"] = fill_var
        if size is not None:
            self._values["size"] = size
        if size_var is not None:
            self._values["size_var"] = size_var
        if stroke is not None:
            self._values["stroke"] = stroke
        if stroke_size is not None:
            self._values["stroke_size"] = stroke_size
        if stroke_size_var is not None:
            self._values["stroke_size_var"] = stroke_size_var
        if stroke_var is not None:
            self._values["stroke_var"] = stroke_var
        if text is not None:
            self._values["text"] = text
        if text_var is not None:
            self._values["text_var"] = text_var
        if transformation is not None:
            self._values["transformation"] = transformation
        if typeface is not None:
            self._values["typeface"] = typeface
        if typeface_var is not None:
            self._values["typeface_var"] = typeface_var

    @builtins.property
    def fill(self) -> typing.Optional[builtins.str]:
        '''The main fill color of the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill DataAkamaiImagingPolicyImage#fill}
        '''
        result = self._values.get("fill")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fill_var(self) -> typing.Optional[builtins.str]:
        '''The main fill color of the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_var DataAkamaiImagingPolicyImage#fill_var}
        '''
        result = self._values.get("fill_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def size(self) -> typing.Optional[builtins.str]:
        '''The size in pixels to render the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#size DataAkamaiImagingPolicyImage#size}
        '''
        result = self._values.get("size")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def size_var(self) -> typing.Optional[builtins.str]:
        '''The size in pixels to render the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#size_var DataAkamaiImagingPolicyImage#size_var}
        '''
        result = self._values.get("size_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def stroke(self) -> typing.Optional[builtins.str]:
        '''The color for the outline of the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke DataAkamaiImagingPolicyImage#stroke}
        '''
        result = self._values.get("stroke")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def stroke_size(self) -> typing.Optional[builtins.str]:
        '''The thickness in points for the outline of the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_size DataAkamaiImagingPolicyImage#stroke_size}
        '''
        result = self._values.get("stroke_size")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def stroke_size_var(self) -> typing.Optional[builtins.str]:
        '''The thickness in points for the outline of the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_size_var DataAkamaiImagingPolicyImage#stroke_size_var}
        '''
        result = self._values.get("stroke_size_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def stroke_var(self) -> typing.Optional[builtins.str]:
        '''The color for the outline of the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_var DataAkamaiImagingPolicyImage#stroke_var}
        '''
        result = self._values.get("stroke_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def text(self) -> typing.Optional[builtins.str]:
        '''The line of text to render.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text DataAkamaiImagingPolicyImage#text}
        '''
        result = self._values.get("text")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def text_var(self) -> typing.Optional[builtins.str]:
        '''The line of text to render.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text_var DataAkamaiImagingPolicyImage#text_var}
        '''
        result = self._values.get("text_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def transformation(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageTextImageTransformation"]:
        '''transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        '''
        result = self._values.get("transformation")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageTextImageTransformation"], result)

    @builtins.property
    def typeface(self) -> typing.Optional[builtins.str]:
        '''The font family to apply to the text image.

        This may be a URL to a TrueType or WOFF (v1) typeface, or a string that refers to one of the standard built-in browser fonts.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#typeface DataAkamaiImagingPolicyImage#typeface}
        '''
        result = self._values.get("typeface")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def typeface_var(self) -> typing.Optional[builtins.str]:
        '''The font family to apply to the text image.

        This may be a URL to a TrueType or WOFF (v1) typeface, or a string that refers to one of the standard built-in browser fonts.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#typeface_var DataAkamaiImagingPolicyImage#typeface_var}
        '''
        result = self._values.get("typeface_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageTextImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageTextImageList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageTextImageList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e3b7dbf4c65233c4cbe85e282bcbf172435594bd4911a977058e4f40c3dddad5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageTextImageOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c4fb2596f899e8c69ca236db8fbdf5f8a333c10c072c9201d67fb076b563865d)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageTextImageOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c8b740c6fe7880fb0afa5a38aa85cd0e4b9a06b07d3c4ef3bba0f27d0642fd1c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__90aa40b72ed27cb53a8e1df4c48d8cf457b0c6363839c3a9af58edc66a1a159a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f03f7d36174aa0e718979915e999f20e41f5e05e6d26cf673ff5ee488ad64452)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageTextImage]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageTextImage]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageTextImage]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f3585b2e8ef8e2f28d75008ab4ae69492410f3754f5d87f55820cbece8a88e20)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageTextImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageTextImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8ef6dc9eb9b9738c5dba59dbf69f2013904809d47f4d30c231e879173022fe20)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformation")
    def put_transformation(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageTextImageTransformation()

        return typing.cast(None, jsii.invoke(self, "putTransformation", [value]))

    @jsii.member(jsii_name="resetFill")
    def reset_fill(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFill", []))

    @jsii.member(jsii_name="resetFillVar")
    def reset_fill_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFillVar", []))

    @jsii.member(jsii_name="resetSize")
    def reset_size(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSize", []))

    @jsii.member(jsii_name="resetSizeVar")
    def reset_size_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSizeVar", []))

    @jsii.member(jsii_name="resetStroke")
    def reset_stroke(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStroke", []))

    @jsii.member(jsii_name="resetStrokeSize")
    def reset_stroke_size(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStrokeSize", []))

    @jsii.member(jsii_name="resetStrokeSizeVar")
    def reset_stroke_size_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStrokeSizeVar", []))

    @jsii.member(jsii_name="resetStrokeVar")
    def reset_stroke_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStrokeVar", []))

    @jsii.member(jsii_name="resetText")
    def reset_text(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetText", []))

    @jsii.member(jsii_name="resetTextVar")
    def reset_text_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTextVar", []))

    @jsii.member(jsii_name="resetTransformation")
    def reset_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformation", []))

    @jsii.member(jsii_name="resetTypeface")
    def reset_typeface(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeface", []))

    @jsii.member(jsii_name="resetTypefaceVar")
    def reset_typeface_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypefaceVar", []))

    @builtins.property
    @jsii.member(jsii_name="transformation")
    def transformation(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageTextImageTransformationOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageTextImageTransformationOutputReference", jsii.get(self, "transformation"))

    @builtins.property
    @jsii.member(jsii_name="fillInput")
    def fill_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fillInput"))

    @builtins.property
    @jsii.member(jsii_name="fillVarInput")
    def fill_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fillVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sizeInput")
    def size_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sizeInput"))

    @builtins.property
    @jsii.member(jsii_name="sizeVarInput")
    def size_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sizeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="strokeInput")
    def stroke_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "strokeInput"))

    @builtins.property
    @jsii.member(jsii_name="strokeSizeInput")
    def stroke_size_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "strokeSizeInput"))

    @builtins.property
    @jsii.member(jsii_name="strokeSizeVarInput")
    def stroke_size_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "strokeSizeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="strokeVarInput")
    def stroke_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "strokeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="textInput")
    def text_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "textInput"))

    @builtins.property
    @jsii.member(jsii_name="textVarInput")
    def text_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "textVarInput"))

    @builtins.property
    @jsii.member(jsii_name="transformationInput")
    def transformation_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageTextImageTransformation"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageTextImageTransformation"], jsii.get(self, "transformationInput"))

    @builtins.property
    @jsii.member(jsii_name="typefaceInput")
    def typeface_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typefaceInput"))

    @builtins.property
    @jsii.member(jsii_name="typefaceVarInput")
    def typeface_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typefaceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="fill")
    def fill(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fill"))

    @fill.setter
    def fill(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e120601bc93253bf52cb8aeb712e3d780ca09368296281119af99da2dc1fbe1d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fill", value)

    @builtins.property
    @jsii.member(jsii_name="fillVar")
    def fill_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fillVar"))

    @fill_var.setter
    def fill_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__51ecc2b63c0693614a803c8c7f40d0af40888d6eed690532fc715a3a1909a138)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fillVar", value)

    @builtins.property
    @jsii.member(jsii_name="size")
    def size(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "size"))

    @size.setter
    def size(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2615bcd39de43bb7baed07b44bf0cf7ac5d10a934789f8805409af0d20ded1b1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "size", value)

    @builtins.property
    @jsii.member(jsii_name="sizeVar")
    def size_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sizeVar"))

    @size_var.setter
    def size_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3d3dd5fc266790c129c87e1598f784ffc0732475f2e767b59290dac24793b143)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sizeVar", value)

    @builtins.property
    @jsii.member(jsii_name="stroke")
    def stroke(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "stroke"))

    @stroke.setter
    def stroke(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__47efff32d55781ff7cf31263ab6fd2c3c8466486041b4e9e26b237ea801abe49)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "stroke", value)

    @builtins.property
    @jsii.member(jsii_name="strokeSize")
    def stroke_size(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "strokeSize"))

    @stroke_size.setter
    def stroke_size(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5451efa605edcb9c7d9701c8849c3e903ef2ab645b6be1bf39e92fb6a6530ea0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "strokeSize", value)

    @builtins.property
    @jsii.member(jsii_name="strokeSizeVar")
    def stroke_size_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "strokeSizeVar"))

    @stroke_size_var.setter
    def stroke_size_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__897ccc725ce7d03edefc43f649b280b7479f420e6dd623f8638186dd4cd430d1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "strokeSizeVar", value)

    @builtins.property
    @jsii.member(jsii_name="strokeVar")
    def stroke_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "strokeVar"))

    @stroke_var.setter
    def stroke_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cf9734198a1b7b13812a5c4e4d1b5ab2f053d9828abc9a6a31fd1a10deb6c366)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "strokeVar", value)

    @builtins.property
    @jsii.member(jsii_name="text")
    def text(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "text"))

    @text.setter
    def text(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e3269872baa5d48a720a90ba985cd508aa2a8acd42fabb1f2803c02572d29db4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "text", value)

    @builtins.property
    @jsii.member(jsii_name="textVar")
    def text_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "textVar"))

    @text_var.setter
    def text_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9dd5d73c0f113ce18fb2def584a41177fd007ca2e6b7bae8fea5e4bc5dc2d316)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "textVar", value)

    @builtins.property
    @jsii.member(jsii_name="typeface")
    def typeface(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeface"))

    @typeface.setter
    def typeface(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0d98ac559af6b9d8633fb952ba3f4d6d25b9e9a5592a57eb346327a8ef26f40a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeface", value)

    @builtins.property
    @jsii.member(jsii_name="typefaceVar")
    def typeface_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typefaceVar"))

    @typeface_var.setter
    def typeface_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__95740f7507d49de7606d72cdca1b06eab5712f6f3901bfebfd12ef146a98f6b4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typefaceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageTextImage]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageTextImage]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageTextImage]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e932a1e8e9cbdf60db2a9a102ff732d2f39e7f0d0ec7dd24bd6319899ed987cb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageTextImageTransformation",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageTextImageTransformation:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageTextImageTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageTextImageTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageTextImageTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ded7a5331399393710c121a0c27195d05633c25000b73050c3f15822baf40ea1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageTextImageTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageTextImageTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageTextImageTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c9ce960d173371a9c083c7f8c53b09a431e74cb6220008652728369abdbcd9f7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageUrlImage",
    jsii_struct_bases=[],
    name_mapping={
        "transformation": "transformation",
        "url": "url",
        "url_var": "urlVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageUrlImage:
    def __init__(
        self,
        *,
        transformation: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageUrlImageTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        url: typing.Optional[builtins.str] = None,
        url_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param transformation: transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        :param url: The URL of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url DataAkamaiImagingPolicyImage#url}
        :param url_var: The URL of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url_var DataAkamaiImagingPolicyImage#url_var}
        '''
        if isinstance(transformation, dict):
            transformation = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageUrlImageTransformation(**transformation)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__51308d948083507ba3c1e036fa5ba81d56d2a70c7a56404b70571fab1d764566)
            check_type(argname="argument transformation", value=transformation, expected_type=type_hints["transformation"])
            check_type(argname="argument url", value=url, expected_type=type_hints["url"])
            check_type(argname="argument url_var", value=url_var, expected_type=type_hints["url_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if transformation is not None:
            self._values["transformation"] = transformation
        if url is not None:
            self._values["url"] = url
        if url_var is not None:
            self._values["url_var"] = url_var

    @builtins.property
    def transformation(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageUrlImageTransformation"]:
        '''transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        '''
        result = self._values.get("transformation")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageUrlImageTransformation"], result)

    @builtins.property
    def url(self) -> typing.Optional[builtins.str]:
        '''The URL of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url DataAkamaiImagingPolicyImage#url}
        '''
        result = self._values.get("url")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def url_var(self) -> typing.Optional[builtins.str]:
        '''The URL of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url_var DataAkamaiImagingPolicyImage#url_var}
        '''
        result = self._values.get("url_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageUrlImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageUrlImageList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageUrlImageList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2b1553e5199e909a6172879d048e7f03dde01e14036527016ceab6925970d889)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageUrlImageOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8c4237985e1a612aa9c013a4fdf9a38366403ee9aa7161d62459ac2cfc120e87)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageUrlImageOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__186d1ce57d342dd1895ee9c3b14cc8d0ca9879cd4e70893c67df654b6fda9a28)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__09a74e21b2ad51c7957e37eae83a7526e12977b30f17483de880a24215df5350)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__339099bfb1b8faad7e637c78d7a43c8419d5210fdfb13baeb9ed14508c327415)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageUrlImage]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageUrlImage]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageUrlImage]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ec96e556a618ea00f1eda1ad6864ee9a0d7161a2078c51687e26cd85d530bd34)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageUrlImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageUrlImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d485b6e7be31f2cb48e95df0908bf016cd819322e5639a021982a3d2109d0a18)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformation")
    def put_transformation(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageUrlImageTransformation()

        return typing.cast(None, jsii.invoke(self, "putTransformation", [value]))

    @jsii.member(jsii_name="resetTransformation")
    def reset_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformation", []))

    @jsii.member(jsii_name="resetUrl")
    def reset_url(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUrl", []))

    @jsii.member(jsii_name="resetUrlVar")
    def reset_url_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUrlVar", []))

    @builtins.property
    @jsii.member(jsii_name="transformation")
    def transformation(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageUrlImageTransformationOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageUrlImageTransformationOutputReference", jsii.get(self, "transformation"))

    @builtins.property
    @jsii.member(jsii_name="transformationInput")
    def transformation_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageUrlImageTransformation"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageUrlImageTransformation"], jsii.get(self, "transformationInput"))

    @builtins.property
    @jsii.member(jsii_name="urlInput")
    def url_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "urlInput"))

    @builtins.property
    @jsii.member(jsii_name="urlVarInput")
    def url_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "urlVarInput"))

    @builtins.property
    @jsii.member(jsii_name="url")
    def url(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "url"))

    @url.setter
    def url(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a48df8becd2e7da4fe0bda92ff92a4a2cb190754b979ba2bcd3eaafc2562b876)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "url", value)

    @builtins.property
    @jsii.member(jsii_name="urlVar")
    def url_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "urlVar"))

    @url_var.setter
    def url_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d2a0bac3e4ee1f893bda8bb0a89882e735400269ce13791f6cb890ece890708c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "urlVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageUrlImage]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageUrlImage]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageUrlImage]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f3f0d2eceeda7189f8af8451d2fef3df9c0f6f13491564cda230d7d3ddd3da3a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageUrlImageTransformation",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageUrlImageTransformation:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageUrlImageTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageUrlImageTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageUrlImageTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ef6ae89f874ada4a4dd354083a88db02285b11d783616ed496d8105e4e43edab)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageUrlImageTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageUrlImageTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageUrlImageTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__496b38376f57fe2c3a7d38b0a53f9696fb046bb2215949b0a5fb106542d08134)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c8e74e31c1fbe4eca14cbef6a0a2e61b9abeaf589e6cbe2a0ead71b7540f9a25)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__73585bf76f744e9345835b899faba62a1c104335066d29851c86d163bea085b3)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__09d790c1a9166fb617fe9c28db7d0ddef6fbf8c491ec6a79a0071e368cadcf7a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__069b8dd1160e3f5e3deae3b97c193e5748108edcb61b7573c81249fde908b0a7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__27c7348f4c2d9995468857de8dfa99c2745c5cd713a237d6cdb597b2c338bea9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationComposite]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationComposite]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1db0fcd08c31a3d59f7b332fcda7a69b907b26b7bc721974600310374bfdfb00)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__27416cce7ea30503b6aca795a2dbb03cf793d0bb277183f46fd7e797c5729f0b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(
        self,
        *,
        box_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageBoxImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
        circle_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageCircleImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
        text_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageTextImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
        url_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageUrlImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param box_image: box_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#box_image DataAkamaiImagingPolicyImage#box_image}
        :param circle_image: circle_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#circle_image DataAkamaiImagingPolicyImage#circle_image}
        :param text_image: text_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text_image DataAkamaiImagingPolicyImage#text_image}
        :param url_image: url_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url_image DataAkamaiImagingPolicyImage#url_image}
        '''
        value = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImage(
            box_image=box_image,
            circle_image=circle_image,
            text_image=text_image,
            url_image=url_image,
        )

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPlacement")
    def reset_placement(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacement", []))

    @jsii.member(jsii_name="resetPlacementVar")
    def reset_placement_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacementVar", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetScaleDimension")
    def reset_scale_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimension", []))

    @jsii.member(jsii_name="resetScaleDimensionVar")
    def reset_scale_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimensionVar", []))

    @jsii.member(jsii_name="resetScaleVar")
    def reset_scale_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="placementInput")
    def placement_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementInput"))

    @builtins.property
    @jsii.member(jsii_name="placementVarInput")
    def placement_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionInput")
    def scale_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVarInput")
    def scale_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleVarInput")
    def scale_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e783e517bb59d13249721044003f5f23222adf0ca0233959ccf58e9dc7dcbcbb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b4618ddfef15a87321d738c4c0e20819feff5339872137b91d9b4758cbf908f7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="placement")
    def placement(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placement"))

    @placement.setter
    def placement(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b9d9cc2b4e3457abbf821b60db66e1b778dabefb58b084a30e75e7e8ca9bcfbc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placement", value)

    @builtins.property
    @jsii.member(jsii_name="placementVar")
    def placement_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placementVar"))

    @placement_var.setter
    def placement_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0312dd0c257a0f6e7f0fbebaac499cbcc1299eaee33ffef65ae5b789fd7b1701)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placementVar", value)

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scale"))

    @scale.setter
    def scale(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c9ca8b4e0a6bd7442b1bda337ad6fa877e595f0e868225ac6e163b618ca4cbad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scale", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimension")
    def scale_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimension"))

    @scale_dimension.setter
    def scale_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__90bc98de90ba6fefcf7bc18140d94f26fb1aeefe986d51c1911402d91a391ba3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimension", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVar")
    def scale_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimensionVar"))

    @scale_dimension_var.setter
    def scale_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__207a1fe4c2340a6c9d88e12d9de9dae3401a39a7a9812c63584224445e4b8d43)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="scaleVar")
    def scale_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleVar"))

    @scale_var.setter
    def scale_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__848ee66c095152db5842e3cf97d6531cc54f7665a373a9c48c4c471f1f9416aa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cde8d807a864d144f84e16981b4ce7c82e84257ed489ca97b549d9ea0d4f6b5d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0aeadee02e98e1b61cdbc203f295d5478e9296ef3abece6da4838ec8ad427c70)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__63be964462c08dde48fc8855c11ea37889b2d6855fc46147cc42767ac9e20d46)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__80fb2b66aeb243017afe071a5e0ab5de64a8a32534545994afa044f021c748d8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationComposite]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationComposite]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationComposite]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__280d82c6832158a83c1e4b88d7a3f2845072c84f68ca64ba36f0f6621fa2c655)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompound",
    jsii_struct_bases=[],
    name_mapping={"transformations": "transformations"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompound:
    def __init__(
        self,
        *,
        transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformations, typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param transformations: transformations block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__262db66695d7b3344b5a9cc63d09845ced09eae7198d9bb56213572355e10356)
            check_type(argname="argument transformations", value=transformations, expected_type=type_hints["transformations"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if transformations is not None:
            self._values["transformations"] = transformations

    @builtins.property
    def transformations(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformations]]]:
        '''transformations block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        result = self._values.get("transformations")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformations]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompound(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompoundList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompoundList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__83cfe45b24f976f809de4a238383c333033cac3f5bc85fb5465bdf9a211f1cca)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompoundOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__26bc3321c6636d3b467c0d4c049bd001760b875ae4ee136be62d2019bfdb7977)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompoundOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cde0d215d03e00a1cd3e5b83bf156f67fc61468ba9734195bcff12975386e24d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__61eaa4dbd08b86dff66287e128bdfe82b91e02f8fde32539f3b3ed18861da1b3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8f0b6f640d43433e3ba93f706df01242644a6d5fbec64b8aee6b86ee5ca4bf46)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompound]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompound]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__38b979282183ee2edb71b53848a0af5d1fdab596250074d7c23df83e93754756)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompoundOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompoundOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4cd4c429a3c334833609e82cd4efbfebdafc2c72abe8a75008728bcf83001f0d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformations")
    def put_transformations(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformations, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__06c851d99d2d4ed99793ede19a7bc91d8e4ff9612eabf2f77e69806cc4eac8f1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTransformations", [value]))

    @jsii.member(jsii_name="resetTransformations")
    def reset_transformations(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformations", []))

    @builtins.property
    @jsii.member(jsii_name="transformations")
    def transformations(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsList", jsii.get(self, "transformations"))

    @builtins.property
    @jsii.member(jsii_name="transformationsInput")
    def transformations_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformations]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformations]]], jsii.get(self, "transformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompound]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompound]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompound]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8b4bc23b64e1b9a9da066b10069adef71a89a9a1d8b5670d1349f4a2b9c5dc99)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationContrast",
    jsii_struct_bases=[],
    name_mapping={
        "brightness": "brightness",
        "brightness_var": "brightnessVar",
        "contrast": "contrast",
        "contrast_var": "contrastVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationContrast:
    def __init__(
        self,
        *,
        brightness: typing.Optional[builtins.str] = None,
        brightness_var: typing.Optional[builtins.str] = None,
        contrast: typing.Optional[builtins.str] = None,
        contrast_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param brightness: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        :param brightness_var: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        :param contrast: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param contrast_var: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__89456588fa0db743bc6daf77313e2334ee49feb6c199f21a29c46a8de41d4b2b)
            check_type(argname="argument brightness", value=brightness, expected_type=type_hints["brightness"])
            check_type(argname="argument brightness_var", value=brightness_var, expected_type=type_hints["brightness_var"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument contrast_var", value=contrast_var, expected_type=type_hints["contrast_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if brightness is not None:
            self._values["brightness"] = brightness
        if brightness_var is not None:
            self._values["brightness_var"] = brightness_var
        if contrast is not None:
            self._values["contrast"] = contrast
        if contrast_var is not None:
            self._values["contrast_var"] = contrast_var

    @builtins.property
    def brightness(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        '''
        result = self._values.get("brightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def brightness_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        '''
        result = self._values.get("brightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        result = self._values.get("contrast_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationContrast(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationContrastList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationContrastList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f94e84511cb730c7900295625f71d78ed23ba6a98283a0f5ce1f2011c61d30e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationContrastOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0a51025017de543d08c63ea301c742bfb75c72f9a29ec8bb24fd191534c5db2f)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationContrastOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f7903879bb1ff9623cbd87c8bd80e7d21526c15a801b06ba9fa4098e490c5ab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__02f85a6b7b8f689d0465f56913b9e3f3f52762ed9617909818b3c70578aa5feb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__735f739020c3ebfa43509204afb1ca8a06801df71b290c98592f64cf3da1a767)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationContrast]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationContrast]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0c31ea26381bd9ab0e00cc67ddbba1933a61db9296089c408e10543e54a4ae66)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationContrastOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationContrastOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c7ae899372a849a3f5b469ad296365429c198db4726ea8893a18b14ab6bc54a9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetBrightness")
    def reset_brightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightness", []))

    @jsii.member(jsii_name="resetBrightnessVar")
    def reset_brightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightnessVar", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetContrastVar")
    def reset_contrast_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrastVar", []))

    @builtins.property
    @jsii.member(jsii_name="brightnessInput")
    def brightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="brightnessVarInput")
    def brightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastVarInput")
    def contrast_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="brightness")
    def brightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightness"))

    @brightness.setter
    def brightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__73ec670ed6e33f9ae945004a098d6b7dc7d4f76dfd9456ed51f15efe518dfd68)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightness", value)

    @builtins.property
    @jsii.member(jsii_name="brightnessVar")
    def brightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightnessVar"))

    @brightness_var.setter
    def brightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a0560b12033d75c9a31eaf5a3c965deefb74468dc415caa12a79e3897d86fb9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrast"))

    @contrast.setter
    def contrast(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bf0cd4f49a60a261bb5a21d19136e6b8ca6112a490cd61ce128ab66a7da1e8e5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrast", value)

    @builtins.property
    @jsii.member(jsii_name="contrastVar")
    def contrast_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrastVar"))

    @contrast_var.setter
    def contrast_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ea63e25dfeac5a685092527cc610f6fa73060c20f5f302ed0221f09a9d9ee40)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrastVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationContrast]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationContrast]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationContrast]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b4d227ba5b814319fa560e29c84a6cb2198b664a1768759bb45980b92e4acf67)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCrop",
    jsii_struct_bases=[],
    name_mapping={
        "allow_expansion": "allowExpansion",
        "allow_expansion_var": "allowExpansionVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCrop:
    def __init__(
        self,
        *,
        allow_expansion: typing.Optional[builtins.str] = None,
        allow_expansion_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_expansion: If cropping an area outside of the existing canvas, expands the image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        :param allow_expansion_var: If cropping an area outside of the existing canvas, expands the image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        :param gravity: Frame of reference for X and Y Positions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Frame of reference for X and Y Positions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The number of pixels to crop along the y-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The number of pixels to crop along the y-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The number of pixels to crop along the x-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The number of pixels to crop along the x-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        :param x_position: The x-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a03ce83d383b0a76ca8b8ce8847dc957e2dc16ca5f22e18651829a2565ee54d5)
            check_type(argname="argument allow_expansion", value=allow_expansion, expected_type=type_hints["allow_expansion"])
            check_type(argname="argument allow_expansion_var", value=allow_expansion_var, expected_type=type_hints["allow_expansion_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if allow_expansion is not None:
            self._values["allow_expansion"] = allow_expansion
        if allow_expansion_var is not None:
            self._values["allow_expansion_var"] = allow_expansion_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def allow_expansion(self) -> typing.Optional[builtins.str]:
        '''If cropping an area outside of the existing canvas, expands the image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        '''
        result = self._values.get("allow_expansion")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def allow_expansion_var(self) -> typing.Optional[builtins.str]:
        '''If cropping an area outside of the existing canvas, expands the image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        '''
        result = self._values.get("allow_expansion_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Frame of reference for X and Y Positions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Frame of reference for X and Y Positions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the y-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the y-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the x-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the x-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cf279cbfb06739d1661c5e819007e73967479d74443519eec42eea96c328597a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ff9a2a20b9ddb780bd06c19ae3e089190cbd283f9063220bf7c4ecbc54d0766d)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb574c1dfd6fc796c94c9c470075d9bc0c9f0e673eedcefa294d35a24a0b9e9a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f09008e404252a99ca2898bc76f1442fb93360b47f5e9e5c2388ef5eab3ed69)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0cccf499dbfc29c92941f3c7cd98605ab1cb7fa2c0946e44f90900f3fe5d07d6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c455bd2007d4d71d3a266f748396159ec5d01f0f0e3c222198b8e328f7b0a10e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6726b0b569da00deb380ca3ffe489f9185dc5dac9a33a02d80f2a5c0879f435c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAllowExpansion")
    def reset_allow_expansion(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansion", []))

    @jsii.member(jsii_name="resetAllowExpansionVar")
    def reset_allow_expansion_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansionVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionInput")
    def allow_expansion_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVarInput")
    def allow_expansion_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansion")
    def allow_expansion(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansion"))

    @allow_expansion.setter
    def allow_expansion(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa773cc490d63bd69f59ba36d9bfb065db9b13455d0902acaa4d3a538f28660d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansion", value)

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVar")
    def allow_expansion_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansionVar"))

    @allow_expansion_var.setter
    def allow_expansion_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__204ebef81fbefbf26dcbfb25fb9dce26f8ebb9807823d38cbd6aaa4e3edcb369)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansionVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f870192cf4b0e56cd8102e9eb1683989f5d573f0f9b3fd6caa7ef4dbc5c28995)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2baf2e40f7633950a253b4773736972c4a2190cbc612c1a899ac3d465a6b399c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8c07028fea846bf916dcefede509b65327e12cfced35e872d04e5b1913213733)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ade69113441b4d773a96b5cf99acfc76e2f25f840482808aa89c9a94cfc9a6d2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f939c9c824a9a34e77801517ff373edaf20394296e4d07178bbfebb28d12b67)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1cecfe5601813d0fd875b3a22613490183177635912f8066abf3fe09b3be8921)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ade23c4c413dc91ef4a2a4d160294e64af77f784efb39546cc238ae33dd5d9f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e7f5367b1da2a648ca9dbb2a50d6727d36e42a9fdd3a3a1269dc0b44432566eb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f3a4c49b0765d4d999f6cae716ab1ed6cb03b9774b682ed64650eaf368fa71e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0d98429c8031a2ecee7453ae9aa1bdd186074e4e9388bbe3aa4e9af8a35aabce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__61dc9414529ef7e6a9848823c6e6e66992d733e1707b343b8e4bc3467649958a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationFaceCrop",
    jsii_struct_bases=[],
    name_mapping={
        "algorithm": "algorithm",
        "algorithm_var": "algorithmVar",
        "confidence": "confidence",
        "confidence_var": "confidenceVar",
        "fail_gravity": "failGravity",
        "fail_gravity_var": "failGravityVar",
        "focus": "focus",
        "focus_var": "focusVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "padding": "padding",
        "padding_var": "paddingVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationFaceCrop:
    def __init__(
        self,
        *,
        algorithm: typing.Optional[builtins.str] = None,
        algorithm_var: typing.Optional[builtins.str] = None,
        confidence: typing.Optional[builtins.str] = None,
        confidence_var: typing.Optional[builtins.str] = None,
        fail_gravity: typing.Optional[builtins.str] = None,
        fail_gravity_var: typing.Optional[builtins.str] = None,
        focus: typing.Optional[builtins.str] = None,
        focus_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param algorithm: Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm DataAkamaiImagingPolicyImage#algorithm}
        :param algorithm_var: Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm_var DataAkamaiImagingPolicyImage#algorithm_var}
        :param confidence: With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image. Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence DataAkamaiImagingPolicyImage#confidence}
        :param confidence_var: With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image. Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence_var DataAkamaiImagingPolicyImage#confidence_var}
        :param fail_gravity: Controls placement of the crop if Image and Video Manager does not detect any faces in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        :param fail_gravity_var: Controls placement of the crop if Image and Video Manager does not detect any faces in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        :param focus: Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus DataAkamaiImagingPolicyImage#focus}
        :param focus_var: Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus_var DataAkamaiImagingPolicyImage#focus_var}
        :param gravity: Controls placement of the crop. Directions are relative to the face(s) plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Controls placement of the crop. Directions are relative to the face(s) plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param padding: The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        :param style: Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__34618dd499766904e974732f2d3aa8a77d1e46cdff5afbab30aed77e2590e931)
            check_type(argname="argument algorithm", value=algorithm, expected_type=type_hints["algorithm"])
            check_type(argname="argument algorithm_var", value=algorithm_var, expected_type=type_hints["algorithm_var"])
            check_type(argname="argument confidence", value=confidence, expected_type=type_hints["confidence"])
            check_type(argname="argument confidence_var", value=confidence_var, expected_type=type_hints["confidence_var"])
            check_type(argname="argument fail_gravity", value=fail_gravity, expected_type=type_hints["fail_gravity"])
            check_type(argname="argument fail_gravity_var", value=fail_gravity_var, expected_type=type_hints["fail_gravity_var"])
            check_type(argname="argument focus", value=focus, expected_type=type_hints["focus"])
            check_type(argname="argument focus_var", value=focus_var, expected_type=type_hints["focus_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if algorithm is not None:
            self._values["algorithm"] = algorithm
        if algorithm_var is not None:
            self._values["algorithm_var"] = algorithm_var
        if confidence is not None:
            self._values["confidence"] = confidence
        if confidence_var is not None:
            self._values["confidence_var"] = confidence_var
        if fail_gravity is not None:
            self._values["fail_gravity"] = fail_gravity
        if fail_gravity_var is not None:
            self._values["fail_gravity_var"] = fail_gravity_var
        if focus is not None:
            self._values["focus"] = focus
        if focus_var is not None:
            self._values["focus_var"] = focus_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def algorithm(self) -> typing.Optional[builtins.str]:
        '''Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm DataAkamaiImagingPolicyImage#algorithm}
        '''
        result = self._values.get("algorithm")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def algorithm_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm_var DataAkamaiImagingPolicyImage#algorithm_var}
        '''
        result = self._values.get("algorithm_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def confidence(self) -> typing.Optional[builtins.str]:
        '''With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image.

        Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence DataAkamaiImagingPolicyImage#confidence}
        '''
        result = self._values.get("confidence")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def confidence_var(self) -> typing.Optional[builtins.str]:
        '''With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image.

        Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence_var DataAkamaiImagingPolicyImage#confidence_var}
        '''
        result = self._values.get("confidence_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any faces in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        '''
        result = self._values.get("fail_gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any faces in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        '''
        result = self._values.get("fail_gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def focus(self) -> typing.Optional[builtins.str]:
        '''Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus DataAkamaiImagingPolicyImage#focus}
        '''
        result = self._values.get("focus")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def focus_var(self) -> typing.Optional[builtins.str]:
        '''Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus_var DataAkamaiImagingPolicyImage#focus_var}
        '''
        result = self._values.get("focus_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the face(s) plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the face(s) plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationFaceCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationFaceCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationFaceCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a0dbfd0228ceef8d19988727bd2005f39f8c7e5a0073ab194b7f61e49755a68)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationFaceCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ce1bbf0d494a33b654a11bce66bd507877c09f99a3bbe2b2df4501b57e1afe1e)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationFaceCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cae807b437c2a00e7b5e42016ffe127288a4b2dfbc3594053c79570c7e98a791)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc38c929767d0524ec59118299fedc6cc6228ea317da46a248971735ba10e27b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__de0de711d7f0b133847e933aa88eb8bd24e93c94e87809e9b08824491870ffef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationFaceCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationFaceCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationFaceCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bd1f00007948e446b6eacabbb3f33ee68978b8cf06b8833e5918e05ccc0959bb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationFaceCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationFaceCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6b14b010eae5a92834cba5bcec08789f0aaecd6749a26a88a21678ff112c83a2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAlgorithm")
    def reset_algorithm(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAlgorithm", []))

    @jsii.member(jsii_name="resetAlgorithmVar")
    def reset_algorithm_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAlgorithmVar", []))

    @jsii.member(jsii_name="resetConfidence")
    def reset_confidence(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetConfidence", []))

    @jsii.member(jsii_name="resetConfidenceVar")
    def reset_confidence_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetConfidenceVar", []))

    @jsii.member(jsii_name="resetFailGravity")
    def reset_fail_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravity", []))

    @jsii.member(jsii_name="resetFailGravityVar")
    def reset_fail_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravityVar", []))

    @jsii.member(jsii_name="resetFocus")
    def reset_focus(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFocus", []))

    @jsii.member(jsii_name="resetFocusVar")
    def reset_focus_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFocusVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="algorithmInput")
    def algorithm_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "algorithmInput"))

    @builtins.property
    @jsii.member(jsii_name="algorithmVarInput")
    def algorithm_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "algorithmVarInput"))

    @builtins.property
    @jsii.member(jsii_name="confidenceInput")
    def confidence_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "confidenceInput"))

    @builtins.property
    @jsii.member(jsii_name="confidenceVarInput")
    def confidence_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "confidenceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityInput")
    def fail_gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityVarInput")
    def fail_gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="focusInput")
    def focus_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "focusInput"))

    @builtins.property
    @jsii.member(jsii_name="focusVarInput")
    def focus_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "focusVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="algorithm")
    def algorithm(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "algorithm"))

    @algorithm.setter
    def algorithm(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__65287cd34837bfaeb53ae89736dbff6a0ab36bb7b509c787c106a6dc64752aa4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "algorithm", value)

    @builtins.property
    @jsii.member(jsii_name="algorithmVar")
    def algorithm_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "algorithmVar"))

    @algorithm_var.setter
    def algorithm_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3361759629982417bf4b2e3845cd990230eb7e1bc8a2ae7c04538122b80d8bc2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "algorithmVar", value)

    @builtins.property
    @jsii.member(jsii_name="confidence")
    def confidence(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "confidence"))

    @confidence.setter
    def confidence(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0f7c9781ec74b4bafb744fe78741dfd94e0cc449374004d17c24979bc7ee6fb7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "confidence", value)

    @builtins.property
    @jsii.member(jsii_name="confidenceVar")
    def confidence_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "confidenceVar"))

    @confidence_var.setter
    def confidence_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f8208dc0b8211d3688a9a3e5de1e3e168e27cb5e87fa299788d417b5367d1e3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "confidenceVar", value)

    @builtins.property
    @jsii.member(jsii_name="failGravity")
    def fail_gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravity"))

    @fail_gravity.setter
    def fail_gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b5963f9612680f803b2a411458184399e3df13fef330448911cbf30c4624e097)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravity", value)

    @builtins.property
    @jsii.member(jsii_name="failGravityVar")
    def fail_gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravityVar"))

    @fail_gravity_var.setter
    def fail_gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__01366f3788c9617d86f652d7881d972baec265c269907f392aef7b57dd4e13dc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="focus")
    def focus(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "focus"))

    @focus.setter
    def focus(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fae23f9d9bdb5adeb7b7a86dbfa1a22d2a4ab8a01ffaa37f2f3363ec59e6c2ae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "focus", value)

    @builtins.property
    @jsii.member(jsii_name="focusVar")
    def focus_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "focusVar"))

    @focus_var.setter
    def focus_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b91387e814203c9fe47b857133a43e1a87a9e47da64b2369a75c703d5d1ae607)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "focusVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__64a0c28da02fadac7e138e3d4072eede39e44f20e7a1ffcd3d9004121c6260aa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4f8194770bf2ccca7f74fe9080e391378bd68c61e95a37206082ad9b58df592e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1e39309e4f0137d4150723dcde8e51731de7fc342cd596ba951e98d7953e706a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e69fb511bdd62366b3a5cc9bad764599d1538faad555fc875146d3a3509670b7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9c7dd8202c1082764cd9e5bc62c67b82ce4b9f80dbbabbf80bc742f089582990)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__79d33eaf3d5474f06a7cc9f6b4a688ab99abed445fff99be4648692a71854d62)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4b81f19107a6a4f990215cda032994a6403ae3ca4e022eb5afbcda1a9b853582)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5520a917d376eaa0d8a08c9236b70f46376786dceacc3aa7d068469bbe8507a7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6551112e607c52929a5917309ae1e130147424f0aaa7157dca90c31fef71ebd2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6c3757d509dc4d0581c548bcb407a2a35da980b1a9052b231e4fc5b32071476d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationFaceCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationFaceCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationFaceCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__15a0c4fa381d4b1337d58fb5d7039f4d283b890cae24aa04db558e42402ed2e7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationFeatureCrop",
    jsii_struct_bases=[],
    name_mapping={
        "fail_gravity": "failGravity",
        "fail_gravity_var": "failGravityVar",
        "feature_radius": "featureRadius",
        "feature_radius_var": "featureRadiusVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "max_features": "maxFeatures",
        "max_features_var": "maxFeaturesVar",
        "min_feature_quality": "minFeatureQuality",
        "min_feature_quality_var": "minFeatureQualityVar",
        "padding": "padding",
        "padding_var": "paddingVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationFeatureCrop:
    def __init__(
        self,
        *,
        fail_gravity: typing.Optional[builtins.str] = None,
        fail_gravity_var: typing.Optional[builtins.str] = None,
        feature_radius: typing.Optional[builtins.str] = None,
        feature_radius_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        max_features: typing.Optional[builtins.str] = None,
        max_features_var: typing.Optional[builtins.str] = None,
        min_feature_quality: typing.Optional[builtins.str] = None,
        min_feature_quality_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fail_gravity: Controls placement of the crop if Image and Video Manager does not detect any features in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        :param fail_gravity_var: Controls placement of the crop if Image and Video Manager does not detect any features in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        :param feature_radius: The size in pixels of the important features to search for. If identified, two features never appear closer together than this value, ``8.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius DataAkamaiImagingPolicyImage#feature_radius}
        :param feature_radius_var: The size in pixels of the important features to search for. If identified, two features never appear closer together than this value, ``8.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius_var DataAkamaiImagingPolicyImage#feature_radius_var}
        :param gravity: Controls placement of the crop. Directions are relative to the region of interest plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Controls placement of the crop. Directions are relative to the region of interest plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param max_features: The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features DataAkamaiImagingPolicyImage#max_features}
        :param max_features_var: The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features_var DataAkamaiImagingPolicyImage#max_features_var}
        :param min_feature_quality: Determines the minimum quality level of the feature identified. To consider a feature important, the feature needs to surpass this value. Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality DataAkamaiImagingPolicyImage#min_feature_quality}
        :param min_feature_quality_var: Determines the minimum quality level of the feature identified. To consider a feature important, the feature needs to surpass this value. Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality_var DataAkamaiImagingPolicyImage#min_feature_quality_var}
        :param padding: Adds space around the region of interest. The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: Adds space around the region of interest. The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        :param style: Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f04e1ae3ee116a7161b55bf2984d01401c89e75fddc653a379677ca1a4021951)
            check_type(argname="argument fail_gravity", value=fail_gravity, expected_type=type_hints["fail_gravity"])
            check_type(argname="argument fail_gravity_var", value=fail_gravity_var, expected_type=type_hints["fail_gravity_var"])
            check_type(argname="argument feature_radius", value=feature_radius, expected_type=type_hints["feature_radius"])
            check_type(argname="argument feature_radius_var", value=feature_radius_var, expected_type=type_hints["feature_radius_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument max_features", value=max_features, expected_type=type_hints["max_features"])
            check_type(argname="argument max_features_var", value=max_features_var, expected_type=type_hints["max_features_var"])
            check_type(argname="argument min_feature_quality", value=min_feature_quality, expected_type=type_hints["min_feature_quality"])
            check_type(argname="argument min_feature_quality_var", value=min_feature_quality_var, expected_type=type_hints["min_feature_quality_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fail_gravity is not None:
            self._values["fail_gravity"] = fail_gravity
        if fail_gravity_var is not None:
            self._values["fail_gravity_var"] = fail_gravity_var
        if feature_radius is not None:
            self._values["feature_radius"] = feature_radius
        if feature_radius_var is not None:
            self._values["feature_radius_var"] = feature_radius_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if max_features is not None:
            self._values["max_features"] = max_features
        if max_features_var is not None:
            self._values["max_features_var"] = max_features_var
        if min_feature_quality is not None:
            self._values["min_feature_quality"] = min_feature_quality
        if min_feature_quality_var is not None:
            self._values["min_feature_quality_var"] = min_feature_quality_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def fail_gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any features in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        '''
        result = self._values.get("fail_gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any features in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        '''
        result = self._values.get("fail_gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feature_radius(self) -> typing.Optional[builtins.str]:
        '''The size in pixels of the important features to search for.

        If identified, two features never appear closer together than this value, ``8.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius DataAkamaiImagingPolicyImage#feature_radius}
        '''
        result = self._values.get("feature_radius")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feature_radius_var(self) -> typing.Optional[builtins.str]:
        '''The size in pixels of the important features to search for.

        If identified, two features never appear closer together than this value, ``8.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius_var DataAkamaiImagingPolicyImage#feature_radius_var}
        '''
        result = self._values.get("feature_radius_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the region of interest plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the region of interest plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def max_features(self) -> typing.Optional[builtins.str]:
        '''The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features DataAkamaiImagingPolicyImage#max_features}
        '''
        result = self._values.get("max_features")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def max_features_var(self) -> typing.Optional[builtins.str]:
        '''The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features_var DataAkamaiImagingPolicyImage#max_features_var}
        '''
        result = self._values.get("max_features_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def min_feature_quality(self) -> typing.Optional[builtins.str]:
        '''Determines the minimum quality level of the feature identified.

        To consider a feature important, the feature needs to surpass this value.  Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality DataAkamaiImagingPolicyImage#min_feature_quality}
        '''
        result = self._values.get("min_feature_quality")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def min_feature_quality_var(self) -> typing.Optional[builtins.str]:
        '''Determines the minimum quality level of the feature identified.

        To consider a feature important, the feature needs to surpass this value.  Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality_var DataAkamaiImagingPolicyImage#min_feature_quality_var}
        '''
        result = self._values.get("min_feature_quality_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''Adds space around the region of interest.

        The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''Adds space around the region of interest.

        The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationFeatureCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationFeatureCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationFeatureCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0b56ff77394fda080f7bb941836573c46847f4865238163a17962269b2fbc514)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationFeatureCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7220cf1b973754a8741005f7eee0c842accd61de5e2218ef866d69c70062c8a9)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationFeatureCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__db450419d26bb734ea5338ee4cc5742cf5a779fd26441e843b7b633ee9af3061)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__338b712387ca8255ea30474e3bb92eb69effba1bb886abff8536294117bd82cf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f2d53b65131599b812b63e3a75d0ffb24d0f05a868ba2872ebaa02bd698b5f83)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationFeatureCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationFeatureCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationFeatureCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f2c691d8d94633d77ea864ede7f6fee981e7e9ea9aa112613c25e9f2507ac9ac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationFeatureCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationFeatureCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9facf087bb5cc0964a636e38d6f1a64df92416cb113e1e0e3cd7997e2c01ec8b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetFailGravity")
    def reset_fail_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravity", []))

    @jsii.member(jsii_name="resetFailGravityVar")
    def reset_fail_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravityVar", []))

    @jsii.member(jsii_name="resetFeatureRadius")
    def reset_feature_radius(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureRadius", []))

    @jsii.member(jsii_name="resetFeatureRadiusVar")
    def reset_feature_radius_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureRadiusVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetMaxFeatures")
    def reset_max_features(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxFeatures", []))

    @jsii.member(jsii_name="resetMaxFeaturesVar")
    def reset_max_features_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxFeaturesVar", []))

    @jsii.member(jsii_name="resetMinFeatureQuality")
    def reset_min_feature_quality(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMinFeatureQuality", []))

    @jsii.member(jsii_name="resetMinFeatureQualityVar")
    def reset_min_feature_quality_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMinFeatureQualityVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="failGravityInput")
    def fail_gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityVarInput")
    def fail_gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featureRadiusInput")
    def feature_radius_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featureRadiusInput"))

    @builtins.property
    @jsii.member(jsii_name="featureRadiusVarInput")
    def feature_radius_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featureRadiusVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesInput")
    def max_features_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "maxFeaturesInput"))

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesVarInput")
    def max_features_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "maxFeaturesVarInput"))

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityInput")
    def min_feature_quality_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "minFeatureQualityInput"))

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityVarInput")
    def min_feature_quality_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "minFeatureQualityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravity")
    def fail_gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravity"))

    @fail_gravity.setter
    def fail_gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8e8229c0283abf31849f948ea7a43466abf3bc9b040852ae201c3975a34d2735)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravity", value)

    @builtins.property
    @jsii.member(jsii_name="failGravityVar")
    def fail_gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravityVar"))

    @fail_gravity_var.setter
    def fail_gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc86ef11245e9ca6d52b72d6f420b8eb8213f6851a4f304ce29a26c53874316e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="featureRadius")
    def feature_radius(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featureRadius"))

    @feature_radius.setter
    def feature_radius(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ec19827094765be381657a0dc39cd3319428c97494f615d0e5c7747dfb5ce9a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featureRadius", value)

    @builtins.property
    @jsii.member(jsii_name="featureRadiusVar")
    def feature_radius_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featureRadiusVar"))

    @feature_radius_var.setter
    def feature_radius_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f1fb1d3709341ec1de83e9762de3cad9d2e94e6e537fd6d1808f4bd84d18db7d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featureRadiusVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e4026f68b6ca663efd2fc03a025a96a2a73aca1bf639a9ffa2922fa2c8d3fdc1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c540be024ba3e9e2e05100d2563794a52ea459e2a346ba1bb88175930e5f0109)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__602922b26a5bcb614a28531fc6f597ef6dda7be6a43ae4b60fc25c812027b414)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ce22d7db4b3cf61964cca3188bb37ac20018a496df65a922e0d635574378899f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="maxFeatures")
    def max_features(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "maxFeatures"))

    @max_features.setter
    def max_features(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d2455679e2b3d4cae4b417df4900b7d81cdc6bad11d070032c35fd0aaeb21e1e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "maxFeatures", value)

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesVar")
    def max_features_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "maxFeaturesVar"))

    @max_features_var.setter
    def max_features_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b3ce61128d1263299fab1664ba9d86da43a479c78db89baae1e365a6196174b1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "maxFeaturesVar", value)

    @builtins.property
    @jsii.member(jsii_name="minFeatureQuality")
    def min_feature_quality(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "minFeatureQuality"))

    @min_feature_quality.setter
    def min_feature_quality(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0f7dd2673bf29b0fa3975b1770874ff4ca31ad2e0e1819fa31f306dbbff76cda)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "minFeatureQuality", value)

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityVar")
    def min_feature_quality_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "minFeatureQualityVar"))

    @min_feature_quality_var.setter
    def min_feature_quality_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__31be5847958fbdc39139cf22e3b38c8fde76c2a920a6a9064c0cc13c6c893d6a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "minFeatureQualityVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__15e9a044ae10a8e4b6d8d685cb1ef901eb9ece769b54d5a4cfaa27b22e573710)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a4f137c67d20f0601e302631055930b86f40ab9b7789a42bcce86a96de25c015)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5578a931510cfdd8b0e6bc1d52c450ccf2e9ca8129624f6c8901b4a9faea31e8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab74c53a9cde42a40ac71c81418089124270b7267b5074e388720d5816d22394)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df463b35dfe8922743a3de43afe245b6e6196e08440502d2862ab12be2c6c0e3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ccda4085bc63be779bb0557bc5fbc0ef91143735d80a9dcc616342356887fe02)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationFeatureCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationFeatureCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationFeatureCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__85301ad657dd06c7a46a28b6fac89787b332bea18e61f312be7b0dcbd339b53e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationGoop",
    jsii_struct_bases=[],
    name_mapping={
        "chaos": "chaos",
        "chaos_var": "chaosVar",
        "density": "density",
        "density_var": "densityVar",
        "power": "power",
        "power_var": "powerVar",
        "seed": "seed",
        "seed_var": "seedVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationGoop:
    def __init__(
        self,
        *,
        chaos: typing.Optional[builtins.str] = None,
        chaos_var: typing.Optional[builtins.str] = None,
        density: typing.Optional[builtins.str] = None,
        density_var: typing.Optional[builtins.str] = None,
        power: typing.Optional[builtins.str] = None,
        power_var: typing.Optional[builtins.str] = None,
        seed: typing.Optional[builtins.str] = None,
        seed_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param chaos: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        :param chaos_var: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        :param density: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        :param density_var: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        :param power: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        :param power_var: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        :param seed: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        :param seed_var: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b3f1027188af280b87fa5f064efa1039dd48098ac190864dd14a05d8c7f8aa44)
            check_type(argname="argument chaos", value=chaos, expected_type=type_hints["chaos"])
            check_type(argname="argument chaos_var", value=chaos_var, expected_type=type_hints["chaos_var"])
            check_type(argname="argument density", value=density, expected_type=type_hints["density"])
            check_type(argname="argument density_var", value=density_var, expected_type=type_hints["density_var"])
            check_type(argname="argument power", value=power, expected_type=type_hints["power"])
            check_type(argname="argument power_var", value=power_var, expected_type=type_hints["power_var"])
            check_type(argname="argument seed", value=seed, expected_type=type_hints["seed"])
            check_type(argname="argument seed_var", value=seed_var, expected_type=type_hints["seed_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if chaos is not None:
            self._values["chaos"] = chaos
        if chaos_var is not None:
            self._values["chaos_var"] = chaos_var
        if density is not None:
            self._values["density"] = density
        if density_var is not None:
            self._values["density_var"] = density_var
        if power is not None:
            self._values["power"] = power
        if power_var is not None:
            self._values["power_var"] = power_var
        if seed is not None:
            self._values["seed"] = seed
        if seed_var is not None:
            self._values["seed_var"] = seed_var

    @builtins.property
    def chaos(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        '''
        result = self._values.get("chaos")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def chaos_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        '''
        result = self._values.get("chaos_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        '''
        result = self._values.get("density")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density_var(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        '''
        result = self._values.get("density_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        '''
        result = self._values.get("power")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power_var(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        '''
        result = self._values.get("power_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        '''
        result = self._values.get("seed")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed_var(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        result = self._values.get("seed_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationGoop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationGoopList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationGoopList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__47e3b833cafd02ee020f264a22abf333c26b39bfdd7cb757c6e8fa559513561f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationGoopOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__35b16c2bec0d238e75138dbcd3dfced64b25f0bd269e9c0602588e34608b67bb)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationGoopOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be46e9b603ebe01f54fac82847f1784b25c72a6431854ce47b5006f1a545c6ee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a85c2e05b4f7aac0a2f336e52d46f4a4a9aad5371fbe87f296f3fa71c45f46c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3deaa54c5b6f98501b2a321d548e6ff12b0a909336e99ef4a06181ff5bcad618)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationGoop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationGoop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0647e627f939975635401a2465c97042f737dc2af38d5860197227186b8f04e8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationGoopOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationGoopOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__35443d9da0c26e91f4f9216cbbc2ffafb16d3e1de5cce91e156eb5dfd6cf6a58)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetChaos")
    def reset_chaos(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaos", []))

    @jsii.member(jsii_name="resetChaosVar")
    def reset_chaos_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaosVar", []))

    @jsii.member(jsii_name="resetDensity")
    def reset_density(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensity", []))

    @jsii.member(jsii_name="resetDensityVar")
    def reset_density_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensityVar", []))

    @jsii.member(jsii_name="resetPower")
    def reset_power(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPower", []))

    @jsii.member(jsii_name="resetPowerVar")
    def reset_power_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPowerVar", []))

    @jsii.member(jsii_name="resetSeed")
    def reset_seed(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeed", []))

    @jsii.member(jsii_name="resetSeedVar")
    def reset_seed_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeedVar", []))

    @builtins.property
    @jsii.member(jsii_name="chaosInput")
    def chaos_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosInput"))

    @builtins.property
    @jsii.member(jsii_name="chaosVarInput")
    def chaos_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosVarInput"))

    @builtins.property
    @jsii.member(jsii_name="densityInput")
    def density_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityInput"))

    @builtins.property
    @jsii.member(jsii_name="densityVarInput")
    def density_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="powerInput")
    def power_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerInput"))

    @builtins.property
    @jsii.member(jsii_name="powerVarInput")
    def power_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerVarInput"))

    @builtins.property
    @jsii.member(jsii_name="seedInput")
    def seed_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedInput"))

    @builtins.property
    @jsii.member(jsii_name="seedVarInput")
    def seed_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedVarInput"))

    @builtins.property
    @jsii.member(jsii_name="chaos")
    def chaos(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaos"))

    @chaos.setter
    def chaos(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d1a7989e6d1bc7bd257af7348323ac0850a271c4c967db3c295d20a8cd6c9993)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaos", value)

    @builtins.property
    @jsii.member(jsii_name="chaosVar")
    def chaos_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaosVar"))

    @chaos_var.setter
    def chaos_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eda977e1d36402c6c2f4782ed609b6967cdfefa7a19ac22b7ee64eb52a48d54a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaosVar", value)

    @builtins.property
    @jsii.member(jsii_name="density")
    def density(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "density"))

    @density.setter
    def density(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b941f7486841eebb063d729a88574984bf3abdcaa1c87a914c17432c78d60504)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "density", value)

    @builtins.property
    @jsii.member(jsii_name="densityVar")
    def density_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "densityVar"))

    @density_var.setter
    def density_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ba6f8d84fa09a991e6c720c5566378ede6d8607a555a47b4b95f0930b71816c4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "densityVar", value)

    @builtins.property
    @jsii.member(jsii_name="power")
    def power(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "power"))

    @power.setter
    def power(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__42547fa85a5f1c7c241b15e19cb4119e955b40d85bb580ae56a4f1ad83bd2ddb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "power", value)

    @builtins.property
    @jsii.member(jsii_name="powerVar")
    def power_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "powerVar"))

    @power_var.setter
    def power_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fe61f842d204af4298f485ca8375b25be8d8365657038c797e7fbfe869fd374f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "powerVar", value)

    @builtins.property
    @jsii.member(jsii_name="seed")
    def seed(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seed"))

    @seed.setter
    def seed(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9dc8ae948dd7fa769fa23e2562924669458a49e89dc9dc513466e6779cd96f2c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seed", value)

    @builtins.property
    @jsii.member(jsii_name="seedVar")
    def seed_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seedVar"))

    @seed_var.setter
    def seed_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8153bed27390c075aee727182d3ec1b42014e4fa31fe8a098b683ce23b534109)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seedVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationGoop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationGoop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationGoop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2bdd1eeb8b3229ed9fd58162be376ea715780fe3ccd64eed2ad73bc31c729db3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationGrayscale",
    jsii_struct_bases=[],
    name_mapping={"type": "type", "type_var": "typeVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationGrayscale:
    def __init__(
        self,
        *,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param type: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d3e07ab890e86661a9b8dfcfa4cca037537b0073696a0d8e72cdf9bf3d2b4b4c)
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationGrayscale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationGrayscaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationGrayscaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9f052fdd392d0b9dbe7fb7c0df72d2de94396139d9d2f89f46c506e540f266f7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationGrayscaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f0e8827b21bb5ccfef482a7f9382da860e90ae4de4bc47a3d43eb0fc2cd8d73)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationGrayscaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0d3227f86a771d6518270ed58c9b44fd78cae4b71d0e82a88a300a13384d4fc3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f8b7f1820da1bdab6eca2c570d03853f7652c187af68056c4bde38829fa4dc39)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b07da05ef90214f53ceec50f11ad5e3d6077f8000808f636dce7c7fc99053fd1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationGrayscale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationGrayscale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__236be774b4e9a41fa9693ec02474c166291f0b49116ef80f7686684939284e88)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationGrayscaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationGrayscaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f2b3f928980246b1d6d1c781f0dcbebb1282e02182d744b10771a1244662eb5c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__03303696bbb60e781daca2c1a2129614bc980a8bd8b5d6673e16ce79a28b46f0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f2dcecef6d14eab3de14a896728a458fd58ea2e7b62388e95871adadd7956f72)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationGrayscale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationGrayscale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationGrayscale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f7b4bd3a99768be661a29a20154683a730af3c2a325942f47786f6e1280c8dec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationHsl",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "lightness": "lightness",
        "lightness_var": "lightnessVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationHsl:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness: typing.Optional[builtins.str] = None,
        lightness_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        :param lightness_var: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__536821214e42336dfbb6fdb8eee4c9dd2d011d93f301d23a2182741bd713cfa5)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness", value=lightness, expected_type=type_hints["lightness"])
            check_type(argname="argument lightness_var", value=lightness_var, expected_type=type_hints["lightness_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness is not None:
            self._values["lightness"] = lightness
        if lightness_var is not None:
            self._values["lightness_var"] = lightness_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        '''
        result = self._values.get("lightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        '''
        result = self._values.get("lightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationHsl(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationHslList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationHslList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__531cd55c8f5dc3dd07b2bfe058a084235109c5eab70fff8f7d3d4ec3a6bd583d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationHslOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7fba7eefde874ccba70a7afe378d1d7739950ff4483bfe007b0a87aba82e11bd)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationHslOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4f4110d4b8d4ad41150aec32ca5c915f8de407225e6a44ad8fc6ef2a4f430196)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c158e7811011dcf61fc76cb6a2f2336ca964deea252cec3438ca3ddbe4e565cd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1292dc5cbd90c25bb4dfdeb4e1b8e88e46df73053c749698e21ef8cb35ac988c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationHsl]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationHsl]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ae92cb2a0417810a5de1aafa15943f3c3caa7b11fb1ce37faa761f7a6dd2c65e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationHslOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationHslOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cca962067694eae71639608f6d8c846cfc677b3e1d489b93d6922f074e9e8ee9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightness")
    def reset_lightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightness", []))

    @jsii.member(jsii_name="resetLightnessVar")
    def reset_lightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessInput")
    def lightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessVarInput")
    def lightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0e30f52dcb3d2a914e8966b6e73b770a20525a1c8715524a8de902de2305615d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__21045544f93a996c9b717195a29dea1041ca1d5b5ae69e428af9e9305dabc78e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightness")
    def lightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightness"))

    @lightness.setter
    def lightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a2b8dd3f5cfa480d515f3d49b7a16c3e9163d8ac949777326f4b4684c1da679f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightness", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessVar")
    def lightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessVar"))

    @lightness_var.setter
    def lightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dd40f98ec28e9f11cafea01a0613f90bf55bf861161e5dba095cddc1a459f99f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__847e38be3674076dc800075b16d733e8ba97f0eb42085b2bc3c9999ea2f9a03c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f87917887c4e8c184ee085104637ba97755d42465db3b6aa6b2895753aa459d2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationHsl]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationHsl]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationHsl]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__447d7091a0a741b2b8e05e8d1145eabe6a237b8b73dc957fefece4547bc747b6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationHsv",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationHsv:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        :param value: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__51a338508e5ac9bccef9d4ad0fabf8b141f3dea171bbe6b991f7565aefc72218)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationHsv(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationHsvList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationHsvList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8e146cd6da706e2d6802e579ace4c5d22995532670cb781b6494ae50b839147c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationHsvOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__26e6ef209e753d881ad66d287b7085968f110fde45bf0700ef237ed3f2865e51)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationHsvOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2c87b477339ad3d96dc16f8f8f1633b5fe5337a15516904647bb4315ba9debfc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__498372983d721f4b509b5a0ed96574d2da5fe7c82a5463c747fc58681b41524b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c390bf70580f2d9d79ec48dafd76e4deb070bd18db7660636edd37b7e6392cd0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationHsv]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationHsv]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b27ae3d6dedcb643e36299489cccf98d7c5aa2fd71077051a95ea2d3f5b77cf4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationHsvOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationHsvOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1d3bde5a3e4b8d9da9a912a1963607278a8b038fa0fb8f1b972938ded455db60)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__73e9a6c75a6202f972efe722c36a8f6b3bd391313f056fe8bb3263e708dcb964)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cf0fc57fd4f419a4841d710c134e371c71f93b2095493b77c76a8cbde513fc2b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__906e83eba6a8707f17b0af961a02d2b86f5350ebbeb7bd2ac1dc60cd3d231951)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__915673857fdd64cd0db1fd7bf0490fe7a3e91577636bda427f3536c587ba8b80)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e878390e411890d66303ea3d107ec5d721c8bc28aa9067dd8465a111123d0a73)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__196cbd0b689485fb8465624d51966ed1e911f216b4009074e3a06c2cc2a493da)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationHsv]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationHsv]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationHsv]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e6c7c23299ba970b60e024cd3dfa0db1ce90c7ab312669948ea9b86efefffa20)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimension",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "dimension": "dimension",
        "dimension_var": "dimensionVar",
        "equal": "equal",
        "greater_than": "greaterThan",
        "less_than": "lessThan",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimension:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        dimension: typing.Optional[builtins.str] = None,
        dimension_var: typing.Optional[builtins.str] = None,
        equal: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqual", typing.Dict[builtins.str, typing.Any]]] = None,
        greater_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThan", typing.Dict[builtins.str, typing.Any]]] = None,
        less_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThan", typing.Dict[builtins.str, typing.Any]]] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param dimension: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        :param dimension_var: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        :param equal: equal block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        :param greater_than: greater_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        :param less_than: less_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        :param value: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefault(**default)
        if isinstance(equal, dict):
            equal = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqual(**equal)
        if isinstance(greater_than, dict):
            greater_than = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThan(**greater_than)
        if isinstance(less_than, dict):
            less_than = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThan(**less_than)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b3b457048284248bc184acba705276128ef0519b763f3b168c129eed816ced20)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument dimension", value=dimension, expected_type=type_hints["dimension"])
            check_type(argname="argument dimension_var", value=dimension_var, expected_type=type_hints["dimension_var"])
            check_type(argname="argument equal", value=equal, expected_type=type_hints["equal"])
            check_type(argname="argument greater_than", value=greater_than, expected_type=type_hints["greater_than"])
            check_type(argname="argument less_than", value=less_than, expected_type=type_hints["less_than"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if dimension is not None:
            self._values["dimension"] = dimension
        if dimension_var is not None:
            self._values["dimension_var"] = dimension_var
        if equal is not None:
            self._values["equal"] = equal
        if greater_than is not None:
            self._values["greater_than"] = greater_than
        if less_than is not None:
            self._values["less_than"] = less_than
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefault"], result)

    @builtins.property
    def dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        '''
        result = self._values.get("dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        '''
        result = self._values.get("dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def equal(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqual"]:
        '''equal block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        '''
        result = self._values.get("equal")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqual"], result)

    @builtins.property
    def greater_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThan"]:
        '''greater_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        '''
        result = self._values.get("greater_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThan"], result)

    @builtins.property
    def less_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThan"]:
        '''less_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        '''
        result = self._values.get("less_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThan"], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimension(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefault",
    jsii_struct_bases=[],
    name_mapping={
        "append": "append",
        "aspect_crop": "aspectCrop",
        "background_color": "backgroundColor",
        "blur": "blur",
        "chroma_key": "chromaKey",
        "composite": "composite",
        "compound": "compound",
        "contrast": "contrast",
        "crop": "crop",
        "face_crop": "faceCrop",
        "feature_crop": "featureCrop",
        "fit_and_fill": "fitAndFill",
        "goop": "goop",
        "grayscale": "grayscale",
        "hsl": "hsl",
        "hsv": "hsv",
        "if_dimension": "ifDimension",
        "if_orientation": "ifOrientation",
        "im_query": "imQuery",
        "max_colors": "maxColors",
        "mirror": "mirror",
        "mono_hue": "monoHue",
        "opacity": "opacity",
        "region_of_interest_crop": "regionOfInterestCrop",
        "relative_crop": "relativeCrop",
        "remove_color": "removeColor",
        "resize": "resize",
        "rotate": "rotate",
        "scale": "scale",
        "shear": "shear",
        "trim": "trim",
        "unsharp_mask": "unsharpMask",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefault:
    def __init__(
        self,
        *,
        append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultAppend", typing.Dict[builtins.str, typing.Any]]]]] = None,
        aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultAspectCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultBackgroundColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultBlur", typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultChromaKey", typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultComposite", typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultCompound", typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultContrast", typing.Dict[builtins.str, typing.Any]]]]] = None,
        crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultFaceCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultFeatureCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultFitAndFill", typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultGoop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultGrayscale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultHsl", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultHsv", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfDimension", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfOrientation", typing.Dict[builtins.str, typing.Any]]]]] = None,
        im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultImQuery", typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultMaxColors", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultMirror", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultMonoHue", typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultOpacity", typing.Dict[builtins.str, typing.Any]]]]] = None,
        region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultRegionOfInterestCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultRelativeCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultRemoveColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultResize", typing.Dict[builtins.str, typing.Any]]]]] = None,
        rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultRotate", typing.Dict[builtins.str, typing.Any]]]]] = None,
        scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultScale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultShear", typing.Dict[builtins.str, typing.Any]]]]] = None,
        trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultTrim", typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultUnsharpMask", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param append: append block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        :param aspect_crop: aspect_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param crop: crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        :param face_crop: face_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        :param feature_crop: feature_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        :param fit_and_fill: fit_and_fill block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param im_query: im_query block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param region_of_interest_crop: region_of_interest_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        :param relative_crop: relative_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param resize: resize block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        :param rotate: rotate block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        :param scale: scale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param shear: shear block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        :param trim: trim block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cbdd53a39d3c7efe40d3cbd954ceaf03e25dfdf8a8719eca0fd3481daa198727)
            check_type(argname="argument append", value=append, expected_type=type_hints["append"])
            check_type(argname="argument aspect_crop", value=aspect_crop, expected_type=type_hints["aspect_crop"])
            check_type(argname="argument background_color", value=background_color, expected_type=type_hints["background_color"])
            check_type(argname="argument blur", value=blur, expected_type=type_hints["blur"])
            check_type(argname="argument chroma_key", value=chroma_key, expected_type=type_hints["chroma_key"])
            check_type(argname="argument composite", value=composite, expected_type=type_hints["composite"])
            check_type(argname="argument compound", value=compound, expected_type=type_hints["compound"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument crop", value=crop, expected_type=type_hints["crop"])
            check_type(argname="argument face_crop", value=face_crop, expected_type=type_hints["face_crop"])
            check_type(argname="argument feature_crop", value=feature_crop, expected_type=type_hints["feature_crop"])
            check_type(argname="argument fit_and_fill", value=fit_and_fill, expected_type=type_hints["fit_and_fill"])
            check_type(argname="argument goop", value=goop, expected_type=type_hints["goop"])
            check_type(argname="argument grayscale", value=grayscale, expected_type=type_hints["grayscale"])
            check_type(argname="argument hsl", value=hsl, expected_type=type_hints["hsl"])
            check_type(argname="argument hsv", value=hsv, expected_type=type_hints["hsv"])
            check_type(argname="argument if_dimension", value=if_dimension, expected_type=type_hints["if_dimension"])
            check_type(argname="argument if_orientation", value=if_orientation, expected_type=type_hints["if_orientation"])
            check_type(argname="argument im_query", value=im_query, expected_type=type_hints["im_query"])
            check_type(argname="argument max_colors", value=max_colors, expected_type=type_hints["max_colors"])
            check_type(argname="argument mirror", value=mirror, expected_type=type_hints["mirror"])
            check_type(argname="argument mono_hue", value=mono_hue, expected_type=type_hints["mono_hue"])
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument region_of_interest_crop", value=region_of_interest_crop, expected_type=type_hints["region_of_interest_crop"])
            check_type(argname="argument relative_crop", value=relative_crop, expected_type=type_hints["relative_crop"])
            check_type(argname="argument remove_color", value=remove_color, expected_type=type_hints["remove_color"])
            check_type(argname="argument resize", value=resize, expected_type=type_hints["resize"])
            check_type(argname="argument rotate", value=rotate, expected_type=type_hints["rotate"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument shear", value=shear, expected_type=type_hints["shear"])
            check_type(argname="argument trim", value=trim, expected_type=type_hints["trim"])
            check_type(argname="argument unsharp_mask", value=unsharp_mask, expected_type=type_hints["unsharp_mask"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if append is not None:
            self._values["append"] = append
        if aspect_crop is not None:
            self._values["aspect_crop"] = aspect_crop
        if background_color is not None:
            self._values["background_color"] = background_color
        if blur is not None:
            self._values["blur"] = blur
        if chroma_key is not None:
            self._values["chroma_key"] = chroma_key
        if composite is not None:
            self._values["composite"] = composite
        if compound is not None:
            self._values["compound"] = compound
        if contrast is not None:
            self._values["contrast"] = contrast
        if crop is not None:
            self._values["crop"] = crop
        if face_crop is not None:
            self._values["face_crop"] = face_crop
        if feature_crop is not None:
            self._values["feature_crop"] = feature_crop
        if fit_and_fill is not None:
            self._values["fit_and_fill"] = fit_and_fill
        if goop is not None:
            self._values["goop"] = goop
        if grayscale is not None:
            self._values["grayscale"] = grayscale
        if hsl is not None:
            self._values["hsl"] = hsl
        if hsv is not None:
            self._values["hsv"] = hsv
        if if_dimension is not None:
            self._values["if_dimension"] = if_dimension
        if if_orientation is not None:
            self._values["if_orientation"] = if_orientation
        if im_query is not None:
            self._values["im_query"] = im_query
        if max_colors is not None:
            self._values["max_colors"] = max_colors
        if mirror is not None:
            self._values["mirror"] = mirror
        if mono_hue is not None:
            self._values["mono_hue"] = mono_hue
        if opacity is not None:
            self._values["opacity"] = opacity
        if region_of_interest_crop is not None:
            self._values["region_of_interest_crop"] = region_of_interest_crop
        if relative_crop is not None:
            self._values["relative_crop"] = relative_crop
        if remove_color is not None:
            self._values["remove_color"] = remove_color
        if resize is not None:
            self._values["resize"] = resize
        if rotate is not None:
            self._values["rotate"] = rotate
        if scale is not None:
            self._values["scale"] = scale
        if shear is not None:
            self._values["shear"] = shear
        if trim is not None:
            self._values["trim"] = trim
        if unsharp_mask is not None:
            self._values["unsharp_mask"] = unsharp_mask

    @builtins.property
    def append(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultAppend"]]]:
        '''append block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        '''
        result = self._values.get("append")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultAppend"]]], result)

    @builtins.property
    def aspect_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultAspectCrop"]]]:
        '''aspect_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        '''
        result = self._values.get("aspect_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultAspectCrop"]]], result)

    @builtins.property
    def background_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultBackgroundColor"]]]:
        '''background_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        '''
        result = self._values.get("background_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultBackgroundColor"]]], result)

    @builtins.property
    def blur(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultBlur"]]]:
        '''blur block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        '''
        result = self._values.get("blur")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultBlur"]]], result)

    @builtins.property
    def chroma_key(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultChromaKey"]]]:
        '''chroma_key block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        '''
        result = self._values.get("chroma_key")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultChromaKey"]]], result)

    @builtins.property
    def composite(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultComposite"]]]:
        '''composite block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        '''
        result = self._values.get("composite")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultComposite"]]], result)

    @builtins.property
    def compound(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultCompound"]]]:
        '''compound block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        '''
        result = self._values.get("compound")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultCompound"]]], result)

    @builtins.property
    def contrast(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultContrast"]]]:
        '''contrast block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultContrast"]]], result)

    @builtins.property
    def crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultCrop"]]]:
        '''crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        '''
        result = self._values.get("crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultCrop"]]], result)

    @builtins.property
    def face_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultFaceCrop"]]]:
        '''face_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        '''
        result = self._values.get("face_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultFaceCrop"]]], result)

    @builtins.property
    def feature_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultFeatureCrop"]]]:
        '''feature_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        '''
        result = self._values.get("feature_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultFeatureCrop"]]], result)

    @builtins.property
    def fit_and_fill(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultFitAndFill"]]]:
        '''fit_and_fill block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        '''
        result = self._values.get("fit_and_fill")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultFitAndFill"]]], result)

    @builtins.property
    def goop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultGoop"]]]:
        '''goop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        '''
        result = self._values.get("goop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultGoop"]]], result)

    @builtins.property
    def grayscale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultGrayscale"]]]:
        '''grayscale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        '''
        result = self._values.get("grayscale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultGrayscale"]]], result)

    @builtins.property
    def hsl(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultHsl"]]]:
        '''hsl block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        '''
        result = self._values.get("hsl")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultHsl"]]], result)

    @builtins.property
    def hsv(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultHsv"]]]:
        '''hsv block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        '''
        result = self._values.get("hsv")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultHsv"]]], result)

    @builtins.property
    def if_dimension(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfDimension"]]]:
        '''if_dimension block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        '''
        result = self._values.get("if_dimension")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfDimension"]]], result)

    @builtins.property
    def if_orientation(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfOrientation"]]]:
        '''if_orientation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        '''
        result = self._values.get("if_orientation")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfOrientation"]]], result)

    @builtins.property
    def im_query(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultImQuery"]]]:
        '''im_query block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        '''
        result = self._values.get("im_query")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultImQuery"]]], result)

    @builtins.property
    def max_colors(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultMaxColors"]]]:
        '''max_colors block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        '''
        result = self._values.get("max_colors")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultMaxColors"]]], result)

    @builtins.property
    def mirror(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultMirror"]]]:
        '''mirror block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        '''
        result = self._values.get("mirror")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultMirror"]]], result)

    @builtins.property
    def mono_hue(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultMonoHue"]]]:
        '''mono_hue block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        '''
        result = self._values.get("mono_hue")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultMonoHue"]]], result)

    @builtins.property
    def opacity(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultOpacity"]]]:
        '''opacity block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultOpacity"]]], result)

    @builtins.property
    def region_of_interest_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultRegionOfInterestCrop"]]]:
        '''region_of_interest_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        '''
        result = self._values.get("region_of_interest_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultRegionOfInterestCrop"]]], result)

    @builtins.property
    def relative_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultRelativeCrop"]]]:
        '''relative_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        '''
        result = self._values.get("relative_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultRelativeCrop"]]], result)

    @builtins.property
    def remove_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultRemoveColor"]]]:
        '''remove_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        '''
        result = self._values.get("remove_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultRemoveColor"]]], result)

    @builtins.property
    def resize(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultResize"]]]:
        '''resize block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        '''
        result = self._values.get("resize")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultResize"]]], result)

    @builtins.property
    def rotate(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultRotate"]]]:
        '''rotate block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        '''
        result = self._values.get("rotate")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultRotate"]]], result)

    @builtins.property
    def scale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultScale"]]]:
        '''scale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultScale"]]], result)

    @builtins.property
    def shear(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultShear"]]]:
        '''shear block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        '''
        result = self._values.get("shear")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultShear"]]], result)

    @builtins.property
    def trim(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultTrim"]]]:
        '''trim block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        '''
        result = self._values.get("trim")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultTrim"]]], result)

    @builtins.property
    def unsharp_mask(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultUnsharpMask"]]]:
        '''unsharp_mask block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        result = self._values.get("unsharp_mask")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultUnsharpMask"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultAppend",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_priority": "gravityPriority",
        "gravity_priority_var": "gravityPriorityVar",
        "gravity_var": "gravityVar",
        "preserve_minor_dimension": "preserveMinorDimension",
        "preserve_minor_dimension_var": "preserveMinorDimensionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultAppend:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultAppendImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_priority: typing.Optional[builtins.str] = None,
        gravity_priority_var: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        preserve_minor_dimension: typing.Optional[builtins.str] = None,
        preserve_minor_dimension_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Specifies where to place the ``image`` relative to the source image. The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_priority: Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal. The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority DataAkamaiImagingPolicyImage#gravity_priority}
        :param gravity_priority_var: Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal. The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority_var DataAkamaiImagingPolicyImage#gravity_priority_var}
        :param gravity_var: Specifies where to place the ``image`` relative to the source image. The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param preserve_minor_dimension: Whether to preserve the source image's minor dimension, ``false`` by default. The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension DataAkamaiImagingPolicyImage#preserve_minor_dimension}
        :param preserve_minor_dimension_var: Whether to preserve the source image's minor dimension, ``false`` by default. The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension_var DataAkamaiImagingPolicyImage#preserve_minor_dimension_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultAppendImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b4044e88d99916e83f046c12b0ff377b5942e89d10ec5b600513bd4b3df69a63)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_priority", value=gravity_priority, expected_type=type_hints["gravity_priority"])
            check_type(argname="argument gravity_priority_var", value=gravity_priority_var, expected_type=type_hints["gravity_priority_var"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument preserve_minor_dimension", value=preserve_minor_dimension, expected_type=type_hints["preserve_minor_dimension"])
            check_type(argname="argument preserve_minor_dimension_var", value=preserve_minor_dimension_var, expected_type=type_hints["preserve_minor_dimension_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_priority is not None:
            self._values["gravity_priority"] = gravity_priority
        if gravity_priority_var is not None:
            self._values["gravity_priority_var"] = gravity_priority_var
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if preserve_minor_dimension is not None:
            self._values["preserve_minor_dimension"] = preserve_minor_dimension
        if preserve_minor_dimension_var is not None:
            self._values["preserve_minor_dimension_var"] = preserve_minor_dimension_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultAppendImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultAppendImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Specifies where to place the ``image`` relative to the source image.

        The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_priority(self) -> typing.Optional[builtins.str]:
        '''Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal.

        The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority DataAkamaiImagingPolicyImage#gravity_priority}
        '''
        result = self._values.get("gravity_priority")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_priority_var(self) -> typing.Optional[builtins.str]:
        '''Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal.

        The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority_var DataAkamaiImagingPolicyImage#gravity_priority_var}
        '''
        result = self._values.get("gravity_priority_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Specifies where to place the ``image`` relative to the source image.

        The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def preserve_minor_dimension(self) -> typing.Optional[builtins.str]:
        '''Whether to preserve the source image's minor dimension, ``false`` by default.

        The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension DataAkamaiImagingPolicyImage#preserve_minor_dimension}
        '''
        result = self._values.get("preserve_minor_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def preserve_minor_dimension_var(self) -> typing.Optional[builtins.str]:
        '''Whether to preserve the source image's minor dimension, ``false`` by default.

        The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension_var DataAkamaiImagingPolicyImage#preserve_minor_dimension_var}
        '''
        result = self._values.get("preserve_minor_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultAppend(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultAppendImage",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultAppendImage:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultAppendImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultAppendImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultAppendImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__58884eb0633f493235f2fc9219ea65c5c2719d9432194361e82aa4c72f20913a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultAppendImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultAppendImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultAppendImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6a740ca3d4a384f55ed43f6f9efed4f3fc94d68ae335cc7f59813dff3e9c3ea2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultAppendList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultAppendList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5be3be03a5dc9f4bdc9ab435caeed42705b20619163db93be010fd0b3c71c3d3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultAppendOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dec21201b9b18bc9ef5c35f82760f18b2a1f39b300618d9dbf194d1594de9203)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultAppendOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e3f5d7d99790375c08e41f7e0e78fb5adfdee6f58f756254b542c10c2f95df9e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a304e28e8d644db4f41e8a0e478b288c0c2f0f70f3f2bf008d34a5c7d1ec781)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8ae2ffdd47e1b5341d01bd2e172afbebcbf79f0ba8151b8ae203961548f056f8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultAppend]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultAppend]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultAppend]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0f9eba5dcae6f6b731f03d581691c65d9bb74f1fcd1ade16d5c35c5cbdc7d90c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultAppendOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultAppendOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__629d31798c7277aaec973590662f371ef3d9968f5d1df1d4a760c593ad42d705)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultAppendImage()

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityPriority")
    def reset_gravity_priority(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityPriority", []))

    @jsii.member(jsii_name="resetGravityPriorityVar")
    def reset_gravity_priority_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityPriorityVar", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPreserveMinorDimension")
    def reset_preserve_minor_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPreserveMinorDimension", []))

    @jsii.member(jsii_name="resetPreserveMinorDimensionVar")
    def reset_preserve_minor_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPreserveMinorDimensionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultAppendImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultAppendImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityInput")
    def gravity_priority_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityPriorityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityVarInput")
    def gravity_priority_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityPriorityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultAppendImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultAppendImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionInput")
    def preserve_minor_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "preserveMinorDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionVarInput")
    def preserve_minor_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "preserveMinorDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f8f3b6a9dd73d21deea71f592df86594f230a8709efc58195a8201bb530f9525)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityPriority")
    def gravity_priority(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityPriority"))

    @gravity_priority.setter
    def gravity_priority(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4aec59e240e34901994c3ba90d7cc15fb5fbc90fd78bacc687f7a9eb6b662a38)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityPriority", value)

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityVar")
    def gravity_priority_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityPriorityVar"))

    @gravity_priority_var.setter
    def gravity_priority_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4488e44a5fd97444569c5b373821e49afe22bf9f3397f35d65230b1706d294d9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityPriorityVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b3bc3dcaca41a17bf30192f34647851ee27ecdae64279bf3eb869c53a0555389)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimension")
    def preserve_minor_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "preserveMinorDimension"))

    @preserve_minor_dimension.setter
    def preserve_minor_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__caccf22186a59b024b9bd25fe8416cf4e4b08cd167cb659d77ca9e93174459e5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "preserveMinorDimension", value)

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionVar")
    def preserve_minor_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "preserveMinorDimensionVar"))

    @preserve_minor_dimension_var.setter
    def preserve_minor_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__57fa4451c604f68cca39f47264ec4d3d4c93cb8abffcb02bf9829fbd02886ef2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "preserveMinorDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultAppend]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultAppend]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultAppend]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__48f8bd2c45ff43c107a976b4c9592233a561af4cac16eabb19bb327e71140d6b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultAspectCrop",
    jsii_struct_bases=[],
    name_mapping={
        "allow_expansion": "allowExpansion",
        "allow_expansion_var": "allowExpansionVar",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultAspectCrop:
    def __init__(
        self,
        *,
        allow_expansion: typing.Optional[builtins.str] = None,
        allow_expansion_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_expansion: Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image. Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        :param allow_expansion_var: Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image. Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        :param height: The height term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The width term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        :param x_position: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__72492375ffbc309b43addc31fd21d44a4ba61cb94c3e04c9e18f265e86376317)
            check_type(argname="argument allow_expansion", value=allow_expansion, expected_type=type_hints["allow_expansion"])
            check_type(argname="argument allow_expansion_var", value=allow_expansion_var, expected_type=type_hints["allow_expansion_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if allow_expansion is not None:
            self._values["allow_expansion"] = allow_expansion
        if allow_expansion_var is not None:
            self._values["allow_expansion_var"] = allow_expansion_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def allow_expansion(self) -> typing.Optional[builtins.str]:
        '''Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image.

        Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        '''
        result = self._values.get("allow_expansion")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def allow_expansion_var(self) -> typing.Optional[builtins.str]:
        '''Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image.

        Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        '''
        result = self._values.get("allow_expansion_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultAspectCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultAspectCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultAspectCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ed7a42f152f4b37f6b1021444c64cf650dcb71e992dd2b90faa6753512b9a51f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultAspectCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be561186363e7660bde52a593550bd57fee97598a7438aeb8d4bf28d0e3f8f74)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultAspectCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__58cc9a06e567a8d0662bac2ffe41e3d985f83031cfcfb0a20d59e0783697a64b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9def5201f6df67b234f6da92f411a8e63a244fe91027bf64c64143ab31d15c14)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a0ec321e0cca3084236459cf4be31f67f05477bfacf76ddbfe9b4feecdf0a260)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultAspectCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultAspectCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultAspectCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1521259012cce01d21bbafef168bb2f352c96e78286c457112d12620ee15cacb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultAspectCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultAspectCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d8210e905a9f387d0aacb368ece0b3fcad81e9e16fc037d1399a8fb3e7811e5a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAllowExpansion")
    def reset_allow_expansion(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansion", []))

    @jsii.member(jsii_name="resetAllowExpansionVar")
    def reset_allow_expansion_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansionVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionInput")
    def allow_expansion_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVarInput")
    def allow_expansion_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansion")
    def allow_expansion(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansion"))

    @allow_expansion.setter
    def allow_expansion(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__062d6ad05081e200d7e568aaf636ca8dde1b93d5c47f22b7ff902219772ccbe6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansion", value)

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVar")
    def allow_expansion_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansionVar"))

    @allow_expansion_var.setter
    def allow_expansion_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__68d8c3907b8079f039bb65e7201f180cd6ecd636e1d61f1da9e78bbc8e535f63)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansionVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aa3eafaf9d50b4cab77caca64e4c49e2abbc0fb3ed4a00cad417f546ec009e9b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b5f83382e9a4305f9096435a3e409f511d6fde7a251152b2092073c0e53bc8a4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3cf08c3f9da3596993aeff47660c214a2c7761ee60faad6b36fd4c7d88a0cd9f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1d6a1b20b90788ab4e36df0f554cffc327d32abdf31eda2b221b30f6c5f3066b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__49616f787552a18a932eb20d2d1557e5213f1295f94d317d0a5a3e24809629ad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1d4c2b85cfdb500bf31757de13b9c757cf79c838bc4909ae024d99581e71f302)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ad243628f03734402757534fe45a46c842461d2b3fdd36cd0de972c9a3c0b065)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a0f7cb0ab980b08d8cc2c7270173729cf9afbaa031bdf2a9d2ce083102fa5251)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultAspectCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultAspectCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultAspectCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a188efab9f1f800bf9f2a6929279b116083a0f6402bc7b399f3aef6be526fa4f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultBackgroundColor",
    jsii_struct_bases=[],
    name_mapping={"color": "color", "color_var": "colorVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultBackgroundColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ca9a32c0b4acbccce57939ca8e4d29d1a2042d42c401283f1dff8afad4f36d1)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultBackgroundColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultBackgroundColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultBackgroundColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fc5a773d65c4462a2361c1e81c09f80a12278c5a4eafc0668f954700a45da282)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultBackgroundColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__47f56cf3b28b70bc7e4a539bc03261f145efcac0b80377722df77f2f4a3b2e3e)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultBackgroundColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea75031583ebdec6a991c8eadbdfc7337cabc6bc2a0da52f3b1a210d570fe4b2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f17e3e0bb370e34652b86a2b06e3a4ef4beffb2c6e157e72927e5601f7a04071)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd596a90f6326cfb4021a85f7794d68b03de18676b8026d88a481cf654f1eb93)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultBackgroundColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultBackgroundColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2b11936e96076bf767aad54a22d4f74de14ec8df40b67de8546645d1ca4b2c1b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultBackgroundColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultBackgroundColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ae2ee119e161515692008dbd92ad3aebe092acf10143ca91be44e8dced9942d4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0e1075b37d83d3c6f750d5861ec35fa376ab2cbc4bae89a3b9d477123ac8bc37)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e001aeb272aaed759afa2437c39cf3c9fa06616738e59be4c49091f53c5281c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultBackgroundColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultBackgroundColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultBackgroundColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__01637f0b61accb13d1d17a13a59d89f8ab31f1fb8acf3717bbd672f80b53ca0d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultBlur",
    jsii_struct_bases=[],
    name_mapping={"sigma": "sigma", "sigma_var": "sigmaVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultBlur:
    def __init__(
        self,
        *,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param sigma: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5897609b36e39f18dc0e3a5669faffdc7c753f53ba4b1ca8b33f425bade368d6)
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultBlur(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultBlurList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultBlurList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__74bb3c95d5e8cf70347db422a802eea4c6771cbde879d53a222b33aa5c39bdd8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultBlurOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2131ceb12ea7907f8a58d5254e6dceabb3f8f42af5bc9e989f1dfa2a2d24b6c6)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultBlurOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cb3381471839529048ea6cf04fee2ca38d280660c9d403c745b79476c202f40a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c911d7f663adb19587220d8dc00749760f1a25b6dee7d8c3fca22f66f47f1a50)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__91d644ced76bd9959886959f50b76f626a6454bb6d133e8826e539a4f51382f5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultBlur]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultBlur]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fd3fd89218ec8243dd5c050c909ecc4c58ec4ed7af7e64651ec7d4f810a8a648)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultBlurOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultBlurOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d245f8137d7d0523184ba3511dc6c6071bd7f54f7c893b85941ed3571ecc0aef)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__80b3049ac9da7f62ac8607736763777a038de1f8c6051c8ffa0cb9c65552c199)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a0e5ed4457750e3a13e6f1d866b247f6d96cf473d04866723220625a7e310d41)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultBlur]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultBlur]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultBlur]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bdce5bf53e55cb47951e76eab8932477d900f534aac201a2fea2e70abb3e87bf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultChromaKey",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_feather": "hueFeather",
        "hue_feather_var": "hueFeatherVar",
        "hue_tolerance": "hueTolerance",
        "hue_tolerance_var": "hueToleranceVar",
        "hue_var": "hueVar",
        "lightness_feather": "lightnessFeather",
        "lightness_feather_var": "lightnessFeatherVar",
        "lightness_tolerance": "lightnessTolerance",
        "lightness_tolerance_var": "lightnessToleranceVar",
        "saturation_feather": "saturationFeather",
        "saturation_feather_var": "saturationFeatherVar",
        "saturation_tolerance": "saturationTolerance",
        "saturation_tolerance_var": "saturationToleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultChromaKey:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_feather: typing.Optional[builtins.str] = None,
        hue_feather_var: typing.Optional[builtins.str] = None,
        hue_tolerance: typing.Optional[builtins.str] = None,
        hue_tolerance_var: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness_feather: typing.Optional[builtins.str] = None,
        lightness_feather_var: typing.Optional[builtins.str] = None,
        lightness_tolerance: typing.Optional[builtins.str] = None,
        lightness_tolerance_var: typing.Optional[builtins.str] = None,
        saturation_feather: typing.Optional[builtins.str] = None,
        saturation_feather_var: typing.Optional[builtins.str] = None,
        saturation_tolerance: typing.Optional[builtins.str] = None,
        saturation_tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_feather: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        :param hue_feather_var: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        :param hue_tolerance: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        :param hue_tolerance_var: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        :param hue_var: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness_feather: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        :param lightness_feather_var: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        :param lightness_tolerance: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        :param lightness_tolerance_var: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        :param saturation_feather: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        :param saturation_feather_var: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        :param saturation_tolerance: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        :param saturation_tolerance_var: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b4183f937bac1e1f4b0e3b58e483f0b00339d3f4e966399afdd4b16f75c8238b)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_feather", value=hue_feather, expected_type=type_hints["hue_feather"])
            check_type(argname="argument hue_feather_var", value=hue_feather_var, expected_type=type_hints["hue_feather_var"])
            check_type(argname="argument hue_tolerance", value=hue_tolerance, expected_type=type_hints["hue_tolerance"])
            check_type(argname="argument hue_tolerance_var", value=hue_tolerance_var, expected_type=type_hints["hue_tolerance_var"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness_feather", value=lightness_feather, expected_type=type_hints["lightness_feather"])
            check_type(argname="argument lightness_feather_var", value=lightness_feather_var, expected_type=type_hints["lightness_feather_var"])
            check_type(argname="argument lightness_tolerance", value=lightness_tolerance, expected_type=type_hints["lightness_tolerance"])
            check_type(argname="argument lightness_tolerance_var", value=lightness_tolerance_var, expected_type=type_hints["lightness_tolerance_var"])
            check_type(argname="argument saturation_feather", value=saturation_feather, expected_type=type_hints["saturation_feather"])
            check_type(argname="argument saturation_feather_var", value=saturation_feather_var, expected_type=type_hints["saturation_feather_var"])
            check_type(argname="argument saturation_tolerance", value=saturation_tolerance, expected_type=type_hints["saturation_tolerance"])
            check_type(argname="argument saturation_tolerance_var", value=saturation_tolerance_var, expected_type=type_hints["saturation_tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_feather is not None:
            self._values["hue_feather"] = hue_feather
        if hue_feather_var is not None:
            self._values["hue_feather_var"] = hue_feather_var
        if hue_tolerance is not None:
            self._values["hue_tolerance"] = hue_tolerance
        if hue_tolerance_var is not None:
            self._values["hue_tolerance_var"] = hue_tolerance_var
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness_feather is not None:
            self._values["lightness_feather"] = lightness_feather
        if lightness_feather_var is not None:
            self._values["lightness_feather_var"] = lightness_feather_var
        if lightness_tolerance is not None:
            self._values["lightness_tolerance"] = lightness_tolerance
        if lightness_tolerance_var is not None:
            self._values["lightness_tolerance_var"] = lightness_tolerance_var
        if saturation_feather is not None:
            self._values["saturation_feather"] = saturation_feather
        if saturation_feather_var is not None:
            self._values["saturation_feather_var"] = saturation_feather_var
        if saturation_tolerance is not None:
            self._values["saturation_tolerance"] = saturation_tolerance
        if saturation_tolerance_var is not None:
            self._values["saturation_tolerance_var"] = saturation_tolerance_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        '''
        result = self._values.get("hue_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        '''
        result = self._values.get("hue_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        '''
        result = self._values.get("hue_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        '''
        result = self._values.get("hue_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        '''
        result = self._values.get("lightness_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        '''
        result = self._values.get("lightness_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        '''
        result = self._values.get("lightness_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        '''
        result = self._values.get("lightness_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        '''
        result = self._values.get("saturation_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        '''
        result = self._values.get("saturation_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        '''
        result = self._values.get("saturation_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        result = self._values.get("saturation_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultChromaKey(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultChromaKeyList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultChromaKeyList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b0c500706482a8ccf8e18fdb9f2706f339fe51ea1178c0f87ad6a11d6276c860)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultChromaKeyOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fc640f1145b02ad75bf5099e65b52df5402cf473cfd52efd053c3d90e7b5f908)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultChromaKeyOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2e54f46e10c749e61ba4436170c841d79ed52ea5fc280326e9180747b1d36746)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__82eb8eefb692ccde12cf5a8e2b56c62043161251993c3198a8476499a4a2eb18)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ec104e4c1589c4cf4584888496181415b9707ffb57c343cb17103563b59db442)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultChromaKey]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultChromaKey]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fe3567b5629c1f064a6965dc268f5c3786c135568d2d1fc5ffdd424ff05e307a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultChromaKeyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultChromaKeyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__276947d4ca0bc50382128f92b40b48becab64c8fac5cc9b86a800e2b5af9be9c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueFeather")
    def reset_hue_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeather", []))

    @jsii.member(jsii_name="resetHueFeatherVar")
    def reset_hue_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeatherVar", []))

    @jsii.member(jsii_name="resetHueTolerance")
    def reset_hue_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueTolerance", []))

    @jsii.member(jsii_name="resetHueToleranceVar")
    def reset_hue_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueToleranceVar", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightnessFeather")
    def reset_lightness_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeather", []))

    @jsii.member(jsii_name="resetLightnessFeatherVar")
    def reset_lightness_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeatherVar", []))

    @jsii.member(jsii_name="resetLightnessTolerance")
    def reset_lightness_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessTolerance", []))

    @jsii.member(jsii_name="resetLightnessToleranceVar")
    def reset_lightness_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessToleranceVar", []))

    @jsii.member(jsii_name="resetSaturationFeather")
    def reset_saturation_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeather", []))

    @jsii.member(jsii_name="resetSaturationFeatherVar")
    def reset_saturation_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeatherVar", []))

    @jsii.member(jsii_name="resetSaturationTolerance")
    def reset_saturation_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationTolerance", []))

    @jsii.member(jsii_name="resetSaturationToleranceVar")
    def reset_saturation_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherInput")
    def hue_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVarInput")
    def hue_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceInput")
    def hue_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVarInput")
    def hue_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherInput")
    def lightness_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVarInput")
    def lightness_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceInput")
    def lightness_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVarInput")
    def lightness_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherInput")
    def saturation_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVarInput")
    def saturation_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceInput")
    def saturation_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVarInput")
    def saturation_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d733e72378c5e57cf9a53f07a6fe420a31977af80690c782bc82c262f6626e88)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeather")
    def hue_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeather"))

    @hue_feather.setter
    def hue_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__73041552301b5fbd2c073e992dc617687e541b43a13e82824afeffa3848422ba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeather", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVar")
    def hue_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeatherVar"))

    @hue_feather_var.setter
    def hue_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8df07cc77a759f9bdaef53cd6ea99a8e8be710bc7cfa799bdf45575cd5a612cb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueTolerance")
    def hue_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueTolerance"))

    @hue_tolerance.setter
    def hue_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__44aa2a7c19f2a590cb0be33469afacdba961436be4e92877a3e681b00e1abc17)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVar")
    def hue_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueToleranceVar"))

    @hue_tolerance_var.setter
    def hue_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d7fb48132808f7df2a240812bfa0eaf72b9fddeb6cdc8302af040f2cf700466c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2fda8e29386e8e2e81359def48f9a78ec7c5d4ea55848d90d21d663938260630)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeather")
    def lightness_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeather"))

    @lightness_feather.setter
    def lightness_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cf57d4fe689fb2ae16fdea2b52d93f6b5fe27697a1d38556d26f86525d22ca73)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeather", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVar")
    def lightness_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeatherVar"))

    @lightness_feather_var.setter
    def lightness_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__00b1b5dbbab252b440e8f4e579429d6fe056c892ed42ec0dfc67d4a13d6354e1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessTolerance")
    def lightness_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessTolerance"))

    @lightness_tolerance.setter
    def lightness_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d1e359251f14dd370d3c4de7eaec510a193cef9899bf71231cd331962570ac3d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVar")
    def lightness_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessToleranceVar"))

    @lightness_tolerance_var.setter
    def lightness_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e73960425f26d76b82b55112530bc11067867a8675a34e9e4ce6935083c9d5eb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeather")
    def saturation_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeather"))

    @saturation_feather.setter
    def saturation_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__19a53b21b885fc2689b48b42accb9aa0548a7eebce38a284850862fd8b99f02b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeather", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVar")
    def saturation_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeatherVar"))

    @saturation_feather_var.setter
    def saturation_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a0281f509a76910891751d7fb85c59ed56ac344e88f780fc866f97051192aba1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationTolerance")
    def saturation_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationTolerance"))

    @saturation_tolerance.setter
    def saturation_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__665b1a730f38ad6ffffe8c789cb165a6e17a08d439d5096a2198883c004a80f5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVar")
    def saturation_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationToleranceVar"))

    @saturation_tolerance_var.setter
    def saturation_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__86fb9c8839a6f9016fbcd0ffd90b4e9f70c4b2c7dd3530cb3955532d66ef94ac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultChromaKey]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultChromaKey]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultChromaKey]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b4780549b147698cac51d881b2745ff285298d935edc87111d0f6a86f115abf7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultComposite",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "placement": "placement",
        "placement_var": "placementVar",
        "scale": "scale",
        "scale_dimension": "scaleDimension",
        "scale_dimension_var": "scaleDimensionVar",
        "scale_var": "scaleVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultComposite:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultCompositeImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        placement: typing.Optional[builtins.str] = None,
        placement_var: typing.Optional[builtins.str] = None,
        scale: typing.Optional[builtins.str] = None,
        scale_dimension: typing.Optional[builtins.str] = None,
        scale_dimension_var: typing.Optional[builtins.str] = None,
        scale_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param placement: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        :param placement_var: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        :param scale: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param scale_dimension: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        :param scale_dimension_var: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        :param scale_var: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        :param x_position: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultCompositeImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c3b0fd394196625d55275d98c1f9dca75614ef0fbf05023f90a1902cb2332bec)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument placement", value=placement, expected_type=type_hints["placement"])
            check_type(argname="argument placement_var", value=placement_var, expected_type=type_hints["placement_var"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument scale_dimension", value=scale_dimension, expected_type=type_hints["scale_dimension"])
            check_type(argname="argument scale_dimension_var", value=scale_dimension_var, expected_type=type_hints["scale_dimension_var"])
            check_type(argname="argument scale_var", value=scale_var, expected_type=type_hints["scale_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if placement is not None:
            self._values["placement"] = placement
        if placement_var is not None:
            self._values["placement_var"] = placement_var
        if scale is not None:
            self._values["scale"] = scale
        if scale_dimension is not None:
            self._values["scale_dimension"] = scale_dimension
        if scale_dimension_var is not None:
            self._values["scale_dimension_var"] = scale_dimension_var
        if scale_var is not None:
            self._values["scale_var"] = scale_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultCompositeImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultCompositeImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        '''
        result = self._values.get("placement")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement_var(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        '''
        result = self._values.get("placement_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        '''
        result = self._values.get("scale_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        '''
        result = self._values.get("scale_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        '''
        result = self._values.get("scale_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultComposite(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultCompositeImage",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultCompositeImage:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultCompositeImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultCompositeImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultCompositeImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3b7f58a02069123ad7b571452bb2ecd82f862f3109987b63d919cd31a69bdbad)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultCompositeImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultCompositeImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f6e4459d7d11f3e204b38b89a3d41e8b6693f1f3f3923370136e3343534de54c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultCompositeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultCompositeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2de33046174c7a762d9e2d89d8a56f818414eaf9ca953c403784771c4d9f1b03)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultCompositeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__787a132abfb833745fc36231581da72fdff3da6c2be804d8ba18fa70ea78450b)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultCompositeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__89f708f97e0fd3645fa86c4c464385040c273b05df0d3e5f98eef649a5762b8a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__db7efff6213035683450232f3ecfb2eeaebe68e783780fde738f7c6d15daedda)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__878864c7fb066a1ab135d5680ff5965e4161de3aedd9b924d15e653e5060db2b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultComposite]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultComposite]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__35ceb4ca52987437db1ec8c396b204abf59da3301c6b5a65eebdd58f6544e622)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultCompositeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultCompositeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c24a046d1fb5bf336212be110b387154e45b56f0d5628a2d4b2c26eddcbcdc62)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultCompositeImage()

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPlacement")
    def reset_placement(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacement", []))

    @jsii.member(jsii_name="resetPlacementVar")
    def reset_placement_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacementVar", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetScaleDimension")
    def reset_scale_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimension", []))

    @jsii.member(jsii_name="resetScaleDimensionVar")
    def reset_scale_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimensionVar", []))

    @jsii.member(jsii_name="resetScaleVar")
    def reset_scale_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultCompositeImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultCompositeImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultCompositeImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="placementInput")
    def placement_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementInput"))

    @builtins.property
    @jsii.member(jsii_name="placementVarInput")
    def placement_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionInput")
    def scale_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVarInput")
    def scale_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleVarInput")
    def scale_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4d405852e91d307acf95697612c400733a42e53be67a48a5d0b1b7829c3af335)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3fbd1465f00e99a73e7eb8d015c79a7338c58aeeac459bc092deafa88a3e10f3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="placement")
    def placement(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placement"))

    @placement.setter
    def placement(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e1d5483d2bc1a5cd9b9fd3e86df0984e1a059d9d5542f66e89c18ee5fe7bf019)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placement", value)

    @builtins.property
    @jsii.member(jsii_name="placementVar")
    def placement_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placementVar"))

    @placement_var.setter
    def placement_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4bb5d92a57125768acb51820e22f2db2963fa0a96b6288fa925319c8327e9073)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placementVar", value)

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scale"))

    @scale.setter
    def scale(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d802e777184d93391848f26126d720ff6ed60041d1da1e3423c9745255e27364)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scale", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimension")
    def scale_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimension"))

    @scale_dimension.setter
    def scale_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9462c3d462c16ec71cb518080b329262faf76b858c24b8c3168e6677512c8e25)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimension", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVar")
    def scale_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimensionVar"))

    @scale_dimension_var.setter
    def scale_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__224ca66d032d4098a503c8a7c6af4e2a31f265d0262a3ea9eeac3c6bebc0b908)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="scaleVar")
    def scale_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleVar"))

    @scale_var.setter
    def scale_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eedf6f25570d508c1fe2ec8c04fcfe31b1afe75988053fab7876947096f001fb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ec5bf7515b66ab848112c61db1c471aa2518dd421f95eaf0e72aedfbb99b11d4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3bcdb123c2940764f53185854cc892c9dd566d73af8c01b71365350b2ab1cf20)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3b11fde89274530e391e25f22f7b61f4167b31cffb73f5dbe0b9b1327a7428fc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c4aee7a41fc93db552107090bf1a1a5ef830aa1fb00b4fa730f6439b560b9cc7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultComposite]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultComposite]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultComposite]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dad734f879042048786f6c2f0ddcd70ef1a7d8cdd0b9ba2bcd72a9704f168265)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultCompound",
    jsii_struct_bases=[],
    name_mapping={"transformations": "transformations"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultCompound:
    def __init__(
        self,
        *,
        transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param transformations: transformations block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__291775ce4f3b2550120a2f038e817a4dcb5a9aa08d4718f75fc44009a2702155)
            check_type(argname="argument transformations", value=transformations, expected_type=type_hints["transformations"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if transformations is not None:
            self._values["transformations"] = transformations

    @builtins.property
    def transformations(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultCompoundTransformations"]]]:
        '''transformations block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        result = self._values.get("transformations")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultCompoundTransformations"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultCompound(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultCompoundList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultCompoundList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a107323773519015d8c13fd39ec507c0a01c4c931fd8ed1676a7414139c3fcde)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultCompoundOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ea8deae4c39e2c849f98273cdb3edc51b43a8acd1bf1d6b4a4696f5e90df155)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultCompoundOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d4d44e051f6db5b75ad9fe2c6b707ca21d7985608df6656fb957e2dd5a2d547d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d8d9835e572b723c25bb3ef6a9f0a68c1d69c6720e4a91f7b2a298f0d6f492c7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6966157c83248d94f56a6fbef001935e51349c8113cd9288a13614e0d3c57c16)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultCompound]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultCompound]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a95af5b175bafff0dd3de7c11cab03a06bacbf2ba5a429a6088113529750ad28)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultCompoundOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultCompoundOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__85c3eded4dea9714e1f49cd9394ceead0a2a4e7fea792beb893f9e870927cd6b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformations")
    def put_transformations(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eeb5a96f9918b03a7c4f8175525b5eb1d0f53d8822cf2563b0246a33e819a764)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTransformations", [value]))

    @jsii.member(jsii_name="resetTransformations")
    def reset_transformations(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformations", []))

    @builtins.property
    @jsii.member(jsii_name="transformations")
    def transformations(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultCompoundTransformationsList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultCompoundTransformationsList", jsii.get(self, "transformations"))

    @builtins.property
    @jsii.member(jsii_name="transformationsInput")
    def transformations_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultCompoundTransformations"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultCompoundTransformations"]]], jsii.get(self, "transformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultCompound]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultCompound]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultCompound]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eda8f209b61ebb83b3b41bf93eeca40a8b9b5f7213a57a11a31740b0cf11784f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultCompoundTransformations",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultCompoundTransformations:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultCompoundTransformations(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultCompoundTransformationsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultCompoundTransformationsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f913a5343b3bed87e1b8f44cbc30bb16604e0332e99687eab9f6eea405e29c9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultCompoundTransformationsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b31e1ea1106f8d661fb8d969a85d74fdfa6e4796c8d8efcbbb418dace7f77ab2)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultCompoundTransformationsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8ed9b4b5636cf428ea73383da94b6e4a8294250162f1178b81053d60d2d2bc1e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__338ffa08f32afce7b425718d7e1bf20f90f1950371d34942a75e01774b45f946)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3b11f8ebb8c1bb57e42641a3a489116a24341c3fba346d8913ffffffd42842c6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultCompoundTransformations]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultCompoundTransformations]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultCompoundTransformations]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3c553e812c3b312bf12dbb998a3928ca924167d5a3bf6b8cb165e0d1fc15696e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultCompoundTransformationsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultCompoundTransformationsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__14d861925ed409efca0c2b337dfc22d42c3b37fcb27d0fda53ea9781bb5a2471)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultCompoundTransformations]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultCompoundTransformations]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultCompoundTransformations]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__85a2829d7e2b95956d5335cd6437b9e980f5335b76588087296a0c6af0e08d8c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultContrast",
    jsii_struct_bases=[],
    name_mapping={
        "brightness": "brightness",
        "brightness_var": "brightnessVar",
        "contrast": "contrast",
        "contrast_var": "contrastVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultContrast:
    def __init__(
        self,
        *,
        brightness: typing.Optional[builtins.str] = None,
        brightness_var: typing.Optional[builtins.str] = None,
        contrast: typing.Optional[builtins.str] = None,
        contrast_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param brightness: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        :param brightness_var: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        :param contrast: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param contrast_var: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e6ff25bf50e2609a069fe8e1650869faf44bcde7a32d76cd59a68650bdafc4af)
            check_type(argname="argument brightness", value=brightness, expected_type=type_hints["brightness"])
            check_type(argname="argument brightness_var", value=brightness_var, expected_type=type_hints["brightness_var"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument contrast_var", value=contrast_var, expected_type=type_hints["contrast_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if brightness is not None:
            self._values["brightness"] = brightness
        if brightness_var is not None:
            self._values["brightness_var"] = brightness_var
        if contrast is not None:
            self._values["contrast"] = contrast
        if contrast_var is not None:
            self._values["contrast_var"] = contrast_var

    @builtins.property
    def brightness(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        '''
        result = self._values.get("brightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def brightness_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        '''
        result = self._values.get("brightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        result = self._values.get("contrast_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultContrast(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultContrastList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultContrastList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a680a1701f7213c0bb528f7974184b705209e65cb91b21beda2c80df73745a0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultContrastOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__555b991546a9e0aa8dffce4b06eec4471098540e55c333e83abe57751a5a6cda)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultContrastOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__087f3195031b9c02561dac32ff37a7bb05bc1949f8c0c6e8a04fa7630b71d286)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e64579588ad86292d130755e2bd19496e5d5e6dbace145be31eaf2fb19528a56)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__17bc2f70a5aa2c6d8b858e829177c044ec53aaeab7f965526ed8e3eef4db5e7a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultContrast]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultContrast]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__07e936697fcf98cab66feb6fc34d95552655b5831cbe940366192a22eb55df5e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultContrastOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultContrastOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6dd0cb10bc20d318b1f59fa520b0763434b70cfeb2d1cf348b4ea179eaead59d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetBrightness")
    def reset_brightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightness", []))

    @jsii.member(jsii_name="resetBrightnessVar")
    def reset_brightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightnessVar", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetContrastVar")
    def reset_contrast_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrastVar", []))

    @builtins.property
    @jsii.member(jsii_name="brightnessInput")
    def brightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="brightnessVarInput")
    def brightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastVarInput")
    def contrast_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="brightness")
    def brightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightness"))

    @brightness.setter
    def brightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__44c6c1331ca3e512bf6cace6a812f5304bedbd61006bb28c11d21bb7467a73e4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightness", value)

    @builtins.property
    @jsii.member(jsii_name="brightnessVar")
    def brightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightnessVar"))

    @brightness_var.setter
    def brightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__97b9d6ad5848be4a20f90eb04a8a813eb82096e550c11b735e96b53565c85891)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrast"))

    @contrast.setter
    def contrast(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__51b6c5224410b57115d75d9352e492b3794515f3e601a5a6c4ee1ed1b3003f2a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrast", value)

    @builtins.property
    @jsii.member(jsii_name="contrastVar")
    def contrast_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrastVar"))

    @contrast_var.setter
    def contrast_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__baa8a53581bcf0f2cba9f03370e53859f4d3e717be9529259dc91f5e281a967e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrastVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultContrast]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultContrast]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultContrast]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f30fddc4ae474386002cd85d16d4cd1983c6b7e3d5e807d2a01c5b7cbb9237bd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultCrop",
    jsii_struct_bases=[],
    name_mapping={
        "allow_expansion": "allowExpansion",
        "allow_expansion_var": "allowExpansionVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultCrop:
    def __init__(
        self,
        *,
        allow_expansion: typing.Optional[builtins.str] = None,
        allow_expansion_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_expansion: If cropping an area outside of the existing canvas, expands the image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        :param allow_expansion_var: If cropping an area outside of the existing canvas, expands the image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        :param gravity: Frame of reference for X and Y Positions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Frame of reference for X and Y Positions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The number of pixels to crop along the y-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The number of pixels to crop along the y-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The number of pixels to crop along the x-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The number of pixels to crop along the x-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        :param x_position: The x-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8cbb440aaeed90eb201d7160da921e69a87540b5439291ec75903abf46a950c8)
            check_type(argname="argument allow_expansion", value=allow_expansion, expected_type=type_hints["allow_expansion"])
            check_type(argname="argument allow_expansion_var", value=allow_expansion_var, expected_type=type_hints["allow_expansion_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if allow_expansion is not None:
            self._values["allow_expansion"] = allow_expansion
        if allow_expansion_var is not None:
            self._values["allow_expansion_var"] = allow_expansion_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def allow_expansion(self) -> typing.Optional[builtins.str]:
        '''If cropping an area outside of the existing canvas, expands the image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        '''
        result = self._values.get("allow_expansion")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def allow_expansion_var(self) -> typing.Optional[builtins.str]:
        '''If cropping an area outside of the existing canvas, expands the image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        '''
        result = self._values.get("allow_expansion_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Frame of reference for X and Y Positions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Frame of reference for X and Y Positions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the y-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the y-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the x-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the x-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c4d7b712d1432be35d759429dd5c611eb9ea353c9c4d76b936ab38e122db2f10)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7122258fbf6e1a79219c5e233fbbb3e0822ca0e355b482ac005635586e743d90)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7604b49611f87a6ad712dbd90027e482a7a9cf6b8b9c633729f781b557a1e679)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__645961da8b221942410635b6cd1d74df5c31631057dbe56342ce5bc7f21f2056)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e8fd77c18340bb1ebd709965987f57c1ff6df441c04e13445358cf90cb724290)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d3bdaaaf3c07451d3fdb38a4d13f666aea553bf87ece71d3c70999976f68d7b9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4adb6c014bae80590e66b44867361e036b730cc821763d5a8ba4f5d6d02e29d1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAllowExpansion")
    def reset_allow_expansion(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansion", []))

    @jsii.member(jsii_name="resetAllowExpansionVar")
    def reset_allow_expansion_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansionVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionInput")
    def allow_expansion_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVarInput")
    def allow_expansion_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansion")
    def allow_expansion(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansion"))

    @allow_expansion.setter
    def allow_expansion(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__278a665bd81a360a4110943b0c3adb66e49bba622b236f135e076969c1e43f28)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansion", value)

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVar")
    def allow_expansion_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansionVar"))

    @allow_expansion_var.setter
    def allow_expansion_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d70b2dd9ff8d39ba2c799777852e51a109bc8534b1ce78d18c27982fab6e9fc4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansionVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4b4502909172557504ebbf22580ee5fcd3e1f632847820a7ad7fbea098126cfc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__add49f8985c3c524ca6cf2148e6f8476ac9174a5feeeb6b761274f853a7a9cbd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fe1725e7b8b1ea31ec4f9933ef84b00dc8f84cbd5a019fc42f6cf404c86a1543)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__69e15c92a0c3b03b6f09d40028b517cb63b3f88491cba76a87c7be89eae910ba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f1a4fddaeda2af6c8efdd8310ab6bc0d044f4cf630804dbb2dbc28a0f2c1141e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b607c5f92102fe9d2e5d8add83f8285f33f3003d821ca05092dec84cef4fc8cd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d29b34c5c1c27aaffbd874e73df9727498f35aadcabda904b4546681a2dda063)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a94f332aca4e769e7684c1d4a1b18ca74ea5eedce3fb6bc42280fc85c7ae83b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5013464f97205c0d6b0f68a628c47340926987c5ca639e36006b26a98ae2566c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__404aba1845806fdd3cd5f7cfa3a3b41a2fe9fddca7c26743060b30b2a4feb6ba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6ce8d9d6df3d0084bec7d524955bd830c97cc334349098da162c85fdaf9b3f76)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultFaceCrop",
    jsii_struct_bases=[],
    name_mapping={
        "algorithm": "algorithm",
        "algorithm_var": "algorithmVar",
        "confidence": "confidence",
        "confidence_var": "confidenceVar",
        "fail_gravity": "failGravity",
        "fail_gravity_var": "failGravityVar",
        "focus": "focus",
        "focus_var": "focusVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "padding": "padding",
        "padding_var": "paddingVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultFaceCrop:
    def __init__(
        self,
        *,
        algorithm: typing.Optional[builtins.str] = None,
        algorithm_var: typing.Optional[builtins.str] = None,
        confidence: typing.Optional[builtins.str] = None,
        confidence_var: typing.Optional[builtins.str] = None,
        fail_gravity: typing.Optional[builtins.str] = None,
        fail_gravity_var: typing.Optional[builtins.str] = None,
        focus: typing.Optional[builtins.str] = None,
        focus_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param algorithm: Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm DataAkamaiImagingPolicyImage#algorithm}
        :param algorithm_var: Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm_var DataAkamaiImagingPolicyImage#algorithm_var}
        :param confidence: With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image. Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence DataAkamaiImagingPolicyImage#confidence}
        :param confidence_var: With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image. Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence_var DataAkamaiImagingPolicyImage#confidence_var}
        :param fail_gravity: Controls placement of the crop if Image and Video Manager does not detect any faces in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        :param fail_gravity_var: Controls placement of the crop if Image and Video Manager does not detect any faces in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        :param focus: Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus DataAkamaiImagingPolicyImage#focus}
        :param focus_var: Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus_var DataAkamaiImagingPolicyImage#focus_var}
        :param gravity: Controls placement of the crop. Directions are relative to the face(s) plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Controls placement of the crop. Directions are relative to the face(s) plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param padding: The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        :param style: Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e7684e91c2d3ee219a35e7f17b7d3fb910c94983a1c06f4846ff7ab6680189ee)
            check_type(argname="argument algorithm", value=algorithm, expected_type=type_hints["algorithm"])
            check_type(argname="argument algorithm_var", value=algorithm_var, expected_type=type_hints["algorithm_var"])
            check_type(argname="argument confidence", value=confidence, expected_type=type_hints["confidence"])
            check_type(argname="argument confidence_var", value=confidence_var, expected_type=type_hints["confidence_var"])
            check_type(argname="argument fail_gravity", value=fail_gravity, expected_type=type_hints["fail_gravity"])
            check_type(argname="argument fail_gravity_var", value=fail_gravity_var, expected_type=type_hints["fail_gravity_var"])
            check_type(argname="argument focus", value=focus, expected_type=type_hints["focus"])
            check_type(argname="argument focus_var", value=focus_var, expected_type=type_hints["focus_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if algorithm is not None:
            self._values["algorithm"] = algorithm
        if algorithm_var is not None:
            self._values["algorithm_var"] = algorithm_var
        if confidence is not None:
            self._values["confidence"] = confidence
        if confidence_var is not None:
            self._values["confidence_var"] = confidence_var
        if fail_gravity is not None:
            self._values["fail_gravity"] = fail_gravity
        if fail_gravity_var is not None:
            self._values["fail_gravity_var"] = fail_gravity_var
        if focus is not None:
            self._values["focus"] = focus
        if focus_var is not None:
            self._values["focus_var"] = focus_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def algorithm(self) -> typing.Optional[builtins.str]:
        '''Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm DataAkamaiImagingPolicyImage#algorithm}
        '''
        result = self._values.get("algorithm")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def algorithm_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm_var DataAkamaiImagingPolicyImage#algorithm_var}
        '''
        result = self._values.get("algorithm_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def confidence(self) -> typing.Optional[builtins.str]:
        '''With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image.

        Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence DataAkamaiImagingPolicyImage#confidence}
        '''
        result = self._values.get("confidence")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def confidence_var(self) -> typing.Optional[builtins.str]:
        '''With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image.

        Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence_var DataAkamaiImagingPolicyImage#confidence_var}
        '''
        result = self._values.get("confidence_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any faces in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        '''
        result = self._values.get("fail_gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any faces in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        '''
        result = self._values.get("fail_gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def focus(self) -> typing.Optional[builtins.str]:
        '''Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus DataAkamaiImagingPolicyImage#focus}
        '''
        result = self._values.get("focus")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def focus_var(self) -> typing.Optional[builtins.str]:
        '''Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus_var DataAkamaiImagingPolicyImage#focus_var}
        '''
        result = self._values.get("focus_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the face(s) plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the face(s) plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultFaceCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultFaceCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultFaceCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c75cdb181cb567561e3c48909918a455c990e1511e57069db8cf011db5383aea)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultFaceCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a3f240ffe1f977800b1afac6b1aa850029fd37fce62ae3e66ced80a23bca0744)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultFaceCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a989e1308a9c430ae43838406910ec048ebe42318381059ea58e9829b4bcfc45)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a26e77d2a0602fb58339801558b5dbb7f5e95856e254ae636ce30f06963e23a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be4271ccc5f1ea9c00de0812f977c53d7a5a7088b11ffe2722bf3a9146ae9d63)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultFaceCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultFaceCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultFaceCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c7cfd8ec3f4d12f6eea04fe9a0513306b260307d6e8b63fcaa770e7ea48093b0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultFaceCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultFaceCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__86ae53b196e5573f547c05cce73ed2abf2d5348a1b6e2c8f064f2c3d75941e59)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAlgorithm")
    def reset_algorithm(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAlgorithm", []))

    @jsii.member(jsii_name="resetAlgorithmVar")
    def reset_algorithm_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAlgorithmVar", []))

    @jsii.member(jsii_name="resetConfidence")
    def reset_confidence(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetConfidence", []))

    @jsii.member(jsii_name="resetConfidenceVar")
    def reset_confidence_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetConfidenceVar", []))

    @jsii.member(jsii_name="resetFailGravity")
    def reset_fail_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravity", []))

    @jsii.member(jsii_name="resetFailGravityVar")
    def reset_fail_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravityVar", []))

    @jsii.member(jsii_name="resetFocus")
    def reset_focus(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFocus", []))

    @jsii.member(jsii_name="resetFocusVar")
    def reset_focus_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFocusVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="algorithmInput")
    def algorithm_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "algorithmInput"))

    @builtins.property
    @jsii.member(jsii_name="algorithmVarInput")
    def algorithm_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "algorithmVarInput"))

    @builtins.property
    @jsii.member(jsii_name="confidenceInput")
    def confidence_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "confidenceInput"))

    @builtins.property
    @jsii.member(jsii_name="confidenceVarInput")
    def confidence_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "confidenceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityInput")
    def fail_gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityVarInput")
    def fail_gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="focusInput")
    def focus_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "focusInput"))

    @builtins.property
    @jsii.member(jsii_name="focusVarInput")
    def focus_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "focusVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="algorithm")
    def algorithm(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "algorithm"))

    @algorithm.setter
    def algorithm(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3b60eb4eb717d2afaf3b881a9e3e721bb56752edfd73b0ca14eac118c9a1e95a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "algorithm", value)

    @builtins.property
    @jsii.member(jsii_name="algorithmVar")
    def algorithm_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "algorithmVar"))

    @algorithm_var.setter
    def algorithm_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6bb785b68c864f529e974fc49e68702977b8223d90719733afc8b994a86a814f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "algorithmVar", value)

    @builtins.property
    @jsii.member(jsii_name="confidence")
    def confidence(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "confidence"))

    @confidence.setter
    def confidence(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b054fb9f0a09197f320d48a6d670b7c8215ecfc72f1b346d4c033fd83a3768d3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "confidence", value)

    @builtins.property
    @jsii.member(jsii_name="confidenceVar")
    def confidence_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "confidenceVar"))

    @confidence_var.setter
    def confidence_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f773a8a075b4f9f7234347cbdb5e734ca77832a179975e986a7bf60ee877f2e2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "confidenceVar", value)

    @builtins.property
    @jsii.member(jsii_name="failGravity")
    def fail_gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravity"))

    @fail_gravity.setter
    def fail_gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d5eefa2cb04f8592f9b22c1a0615842aae79dea2d24eb8a2a00d6579df311574)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravity", value)

    @builtins.property
    @jsii.member(jsii_name="failGravityVar")
    def fail_gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravityVar"))

    @fail_gravity_var.setter
    def fail_gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__48dc79445291e69386407111998dcf08b22d45af39294f35f3913cb8a1bcd9fa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="focus")
    def focus(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "focus"))

    @focus.setter
    def focus(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a3e4f9e6ccaccd2974eda590945981fcb6049b65f37c02ebb60f41314df0aa8c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "focus", value)

    @builtins.property
    @jsii.member(jsii_name="focusVar")
    def focus_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "focusVar"))

    @focus_var.setter
    def focus_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4b1b18787e646c637eac33b0b77663ffe78fb6475538bbf0573e9a820f4b40aa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "focusVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7a2fa76ffa9aa901d5eacad0b92b07f4c4064a1a8c7620d6abdd4eaba2cf6814)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9dde6b05daac8b40b40f3e8937c09c8cd107e2e54fb53ed86ccadd81c186dbeb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a3176705332f5b4bb7c238235c27dfe8e8f5ab20732ddc4fdad522c4218f10f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__758c8fc030f99ae1e2816d2432ce7dcf8e61f6c7eb28123706dc645be5a84684)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__94bcf6661b4306f34bafeada04729463c9960ae1f3345a098a5a208fa5f3f378)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0029bcc0df97658d630ddfcf3c4a6082395cbd58227e647b73c3a173d2f8cd23)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af7ecd8347423ffdd188e918a67e4e4b400f6078620f15411b1f4eb9e3eb1061)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__53cddf89cac7328b8f75f86dc756ce0fdc021be5c0a9f5ae882abbb49f182209)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a95b1441a86d1c928e15fd2bdcb89525064c620276d04f492f982fbae93b9f89)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ff55ee255836ee4134a84a0e77b0a4c73d2b8c1b735e6a705f257c551cd77b6c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultFaceCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultFaceCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultFaceCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ae047569080a9d6b35e055ff954be0b56e0b142c69375239d5ff03dd4272ec28)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultFeatureCrop",
    jsii_struct_bases=[],
    name_mapping={
        "fail_gravity": "failGravity",
        "fail_gravity_var": "failGravityVar",
        "feature_radius": "featureRadius",
        "feature_radius_var": "featureRadiusVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "max_features": "maxFeatures",
        "max_features_var": "maxFeaturesVar",
        "min_feature_quality": "minFeatureQuality",
        "min_feature_quality_var": "minFeatureQualityVar",
        "padding": "padding",
        "padding_var": "paddingVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultFeatureCrop:
    def __init__(
        self,
        *,
        fail_gravity: typing.Optional[builtins.str] = None,
        fail_gravity_var: typing.Optional[builtins.str] = None,
        feature_radius: typing.Optional[builtins.str] = None,
        feature_radius_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        max_features: typing.Optional[builtins.str] = None,
        max_features_var: typing.Optional[builtins.str] = None,
        min_feature_quality: typing.Optional[builtins.str] = None,
        min_feature_quality_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fail_gravity: Controls placement of the crop if Image and Video Manager does not detect any features in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        :param fail_gravity_var: Controls placement of the crop if Image and Video Manager does not detect any features in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        :param feature_radius: The size in pixels of the important features to search for. If identified, two features never appear closer together than this value, ``8.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius DataAkamaiImagingPolicyImage#feature_radius}
        :param feature_radius_var: The size in pixels of the important features to search for. If identified, two features never appear closer together than this value, ``8.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius_var DataAkamaiImagingPolicyImage#feature_radius_var}
        :param gravity: Controls placement of the crop. Directions are relative to the region of interest plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Controls placement of the crop. Directions are relative to the region of interest plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param max_features: The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features DataAkamaiImagingPolicyImage#max_features}
        :param max_features_var: The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features_var DataAkamaiImagingPolicyImage#max_features_var}
        :param min_feature_quality: Determines the minimum quality level of the feature identified. To consider a feature important, the feature needs to surpass this value. Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality DataAkamaiImagingPolicyImage#min_feature_quality}
        :param min_feature_quality_var: Determines the minimum quality level of the feature identified. To consider a feature important, the feature needs to surpass this value. Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality_var DataAkamaiImagingPolicyImage#min_feature_quality_var}
        :param padding: Adds space around the region of interest. The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: Adds space around the region of interest. The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        :param style: Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__583c365f4fe0fb4f95fa2fa2ed9d17412cdac76d4a2b06c04171db4350b8a1f6)
            check_type(argname="argument fail_gravity", value=fail_gravity, expected_type=type_hints["fail_gravity"])
            check_type(argname="argument fail_gravity_var", value=fail_gravity_var, expected_type=type_hints["fail_gravity_var"])
            check_type(argname="argument feature_radius", value=feature_radius, expected_type=type_hints["feature_radius"])
            check_type(argname="argument feature_radius_var", value=feature_radius_var, expected_type=type_hints["feature_radius_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument max_features", value=max_features, expected_type=type_hints["max_features"])
            check_type(argname="argument max_features_var", value=max_features_var, expected_type=type_hints["max_features_var"])
            check_type(argname="argument min_feature_quality", value=min_feature_quality, expected_type=type_hints["min_feature_quality"])
            check_type(argname="argument min_feature_quality_var", value=min_feature_quality_var, expected_type=type_hints["min_feature_quality_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fail_gravity is not None:
            self._values["fail_gravity"] = fail_gravity
        if fail_gravity_var is not None:
            self._values["fail_gravity_var"] = fail_gravity_var
        if feature_radius is not None:
            self._values["feature_radius"] = feature_radius
        if feature_radius_var is not None:
            self._values["feature_radius_var"] = feature_radius_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if max_features is not None:
            self._values["max_features"] = max_features
        if max_features_var is not None:
            self._values["max_features_var"] = max_features_var
        if min_feature_quality is not None:
            self._values["min_feature_quality"] = min_feature_quality
        if min_feature_quality_var is not None:
            self._values["min_feature_quality_var"] = min_feature_quality_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def fail_gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any features in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        '''
        result = self._values.get("fail_gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any features in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        '''
        result = self._values.get("fail_gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feature_radius(self) -> typing.Optional[builtins.str]:
        '''The size in pixels of the important features to search for.

        If identified, two features never appear closer together than this value, ``8.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius DataAkamaiImagingPolicyImage#feature_radius}
        '''
        result = self._values.get("feature_radius")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feature_radius_var(self) -> typing.Optional[builtins.str]:
        '''The size in pixels of the important features to search for.

        If identified, two features never appear closer together than this value, ``8.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius_var DataAkamaiImagingPolicyImage#feature_radius_var}
        '''
        result = self._values.get("feature_radius_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the region of interest plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the region of interest plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def max_features(self) -> typing.Optional[builtins.str]:
        '''The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features DataAkamaiImagingPolicyImage#max_features}
        '''
        result = self._values.get("max_features")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def max_features_var(self) -> typing.Optional[builtins.str]:
        '''The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features_var DataAkamaiImagingPolicyImage#max_features_var}
        '''
        result = self._values.get("max_features_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def min_feature_quality(self) -> typing.Optional[builtins.str]:
        '''Determines the minimum quality level of the feature identified.

        To consider a feature important, the feature needs to surpass this value.  Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality DataAkamaiImagingPolicyImage#min_feature_quality}
        '''
        result = self._values.get("min_feature_quality")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def min_feature_quality_var(self) -> typing.Optional[builtins.str]:
        '''Determines the minimum quality level of the feature identified.

        To consider a feature important, the feature needs to surpass this value.  Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality_var DataAkamaiImagingPolicyImage#min_feature_quality_var}
        '''
        result = self._values.get("min_feature_quality_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''Adds space around the region of interest.

        The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''Adds space around the region of interest.

        The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultFeatureCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultFeatureCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultFeatureCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3b131d3045f5560d44dae4b6be94fa46f00bb251abb04562fc5a45eaadfdd7c6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultFeatureCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e238154b231220571f1f5c0c3989fb0dac44e2a19d8ebc3261feb2846b400648)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultFeatureCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6b6a65d1bebe022c0daffb5a2e4494040125d348baa46e8bd25a045ae3402f36)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c6c4539d602823bd0555fd2db98b30b95ebefc37534f70c88ba9ac0858fd1a9c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__560cbd1d9c925c3ac91f1fa6b59d6e5bea85529039d15b87603f412f9270108d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultFeatureCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultFeatureCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultFeatureCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__09bfaf7e342f5ef4f80eab4fcb14872716ddcaf4c5833b5079ad9c9abfb3403c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultFeatureCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultFeatureCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9f1afd37a301a2eea2f9c3c63d5f21a8058426c002d77075906c596ac634aa75)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetFailGravity")
    def reset_fail_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravity", []))

    @jsii.member(jsii_name="resetFailGravityVar")
    def reset_fail_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravityVar", []))

    @jsii.member(jsii_name="resetFeatureRadius")
    def reset_feature_radius(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureRadius", []))

    @jsii.member(jsii_name="resetFeatureRadiusVar")
    def reset_feature_radius_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureRadiusVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetMaxFeatures")
    def reset_max_features(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxFeatures", []))

    @jsii.member(jsii_name="resetMaxFeaturesVar")
    def reset_max_features_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxFeaturesVar", []))

    @jsii.member(jsii_name="resetMinFeatureQuality")
    def reset_min_feature_quality(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMinFeatureQuality", []))

    @jsii.member(jsii_name="resetMinFeatureQualityVar")
    def reset_min_feature_quality_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMinFeatureQualityVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="failGravityInput")
    def fail_gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityVarInput")
    def fail_gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featureRadiusInput")
    def feature_radius_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featureRadiusInput"))

    @builtins.property
    @jsii.member(jsii_name="featureRadiusVarInput")
    def feature_radius_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featureRadiusVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesInput")
    def max_features_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "maxFeaturesInput"))

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesVarInput")
    def max_features_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "maxFeaturesVarInput"))

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityInput")
    def min_feature_quality_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "minFeatureQualityInput"))

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityVarInput")
    def min_feature_quality_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "minFeatureQualityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravity")
    def fail_gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravity"))

    @fail_gravity.setter
    def fail_gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7e97f02cd2fe2cd3555cb44a5e66d31067cac0732ed543b91cc79f7e70ad4966)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravity", value)

    @builtins.property
    @jsii.member(jsii_name="failGravityVar")
    def fail_gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravityVar"))

    @fail_gravity_var.setter
    def fail_gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__16405998e7d8050f5cd03d03f9d9a075556f1984d37fa18cd367ce0a46c80c5f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="featureRadius")
    def feature_radius(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featureRadius"))

    @feature_radius.setter
    def feature_radius(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fee848a569c2468d860dae6d26c01342646ffb0236b490643cdbc6a8f6a6dfe7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featureRadius", value)

    @builtins.property
    @jsii.member(jsii_name="featureRadiusVar")
    def feature_radius_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featureRadiusVar"))

    @feature_radius_var.setter
    def feature_radius_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__295dae3022bbb5fd264be9fd8267163b5f35b675524ac905a9cdc64ca2977218)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featureRadiusVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__98d826526acbc6444eff82f8867a64440a518f4372ec04de2aa3d7026dfdfc21)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2e9c860e91f3c7e6337aa9f2b0b8f17bcf8a77924462496a001a771666b2bb8c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5b9a9e7b7e92409aaab1d412881c821ce8c1e23571ec001395b5fb80924bfaef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9054ea17c7dfa72f2b91c8afad4a1bc30197eafe119b83a90c08ed1551290f74)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="maxFeatures")
    def max_features(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "maxFeatures"))

    @max_features.setter
    def max_features(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__89810baa66ab43dc4dc4de2b982f3c697379c1f0ba72002576f2a891ee220ff8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "maxFeatures", value)

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesVar")
    def max_features_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "maxFeaturesVar"))

    @max_features_var.setter
    def max_features_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ad89c4d6efe9950e4c5014f4ef400c098da61ff8f77ffab407722bd1fdf52c0e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "maxFeaturesVar", value)

    @builtins.property
    @jsii.member(jsii_name="minFeatureQuality")
    def min_feature_quality(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "minFeatureQuality"))

    @min_feature_quality.setter
    def min_feature_quality(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__94b9af6b843e650c287a0577418cbf9c07afa68aa0820342e50ceec50c1fd247)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "minFeatureQuality", value)

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityVar")
    def min_feature_quality_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "minFeatureQualityVar"))

    @min_feature_quality_var.setter
    def min_feature_quality_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bdd75255a8e8b3d961cc1942ac49b175793a4a0b1059d9408976f7c686e406cb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "minFeatureQualityVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__09434cca029409c1ba8165067863d8d0b77bc5d76e6692e9611a565127d5c272)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__53ab6d5f57caed0a605d6c6e6e3ed24a23f1ac0681060b4b075bd0df44a2c4b7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1627d99e9e9253413e0663fc4820967ccfc8d66ce93900b8043a0971e6ee3c21)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4326baa35e2f51633e76c599b0c171df2c35fef0454348503ba92c6dfdeff5a6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1ca9e73a1b295e5aee32674ffb0942eb78e7ef898747b5d64b1b0c0bf7a59fd2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__91de1fb09516aab7d4c7fa242420ba2b397f6aa14bd4e4f88b10f22ae16cc2df)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultFeatureCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultFeatureCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultFeatureCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__60ef0832c526c098aa6e2332410af8acc54781f6f5ca8038add0cbdc9a33c071)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultFitAndFill",
    jsii_struct_bases=[],
    name_mapping={
        "fill_transformation": "fillTransformation",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultFitAndFill:
    def __init__(
        self,
        *,
        fill_transformation: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultFitAndFillFillTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fill_transformation: fill_transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_transformation DataAkamaiImagingPolicyImage#fill_transformation}
        :param height: The height value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The width value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(fill_transformation, dict):
            fill_transformation = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultFitAndFillFillTransformation(**fill_transformation)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e4e4519645a039e30079a1c6ac2fa42d10c307ca6f9764718cd89efe9b14bb8f)
            check_type(argname="argument fill_transformation", value=fill_transformation, expected_type=type_hints["fill_transformation"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fill_transformation is not None:
            self._values["fill_transformation"] = fill_transformation
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def fill_transformation(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultFitAndFillFillTransformation"]:
        '''fill_transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_transformation DataAkamaiImagingPolicyImage#fill_transformation}
        '''
        result = self._values.get("fill_transformation")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultFitAndFillFillTransformation"], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultFitAndFill(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultFitAndFillFillTransformation",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultFitAndFillFillTransformation:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultFitAndFillFillTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultFitAndFillFillTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultFitAndFillFillTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__12623214d57c54d04a9163db8ea8a2389bdfdf42bc2d2a8f06d60db65b747797)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultFitAndFillFillTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultFitAndFillFillTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultFitAndFillFillTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f7a8fbf72d1b45bb4a0ed2ff9ecf04e3a6b68a220175551cd951651eff817b01)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultFitAndFillList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultFitAndFillList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__87e5f89c70b52d4e16ab3734b802e1e3b3da8d26ccc23f2a7d65075ede721045)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultFitAndFillOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__18893ad5da321267ff837523f8cadbe58c34070cbd5cb091f2f77644d53329e5)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultFitAndFillOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e21ba0869232e3390a8588282f5be5081a8b2162a45fc71f4f71ae09567569b6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3593db540de2d83dde559938190a269686918673a39628e5864ab7e0f1f63ca4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b291d7f3771dc81bb9783b60848c31641ca066aba17605d5820de4295e82ba01)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultFitAndFill]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultFitAndFill]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultFitAndFill]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__44dc73cc0339f734b8c54a95a0d1dd860fe3baead9a0f723932142e109b3a471)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultFitAndFillOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultFitAndFillOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f4ea9ab65b3b996d7b14b59035f509be830c689e8d9830ec201be2137936ec2c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putFillTransformation")
    def put_fill_transformation(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultFitAndFillFillTransformation()

        return typing.cast(None, jsii.invoke(self, "putFillTransformation", [value]))

    @jsii.member(jsii_name="resetFillTransformation")
    def reset_fill_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFillTransformation", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="fillTransformation")
    def fill_transformation(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultFitAndFillFillTransformationOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultFitAndFillFillTransformationOutputReference, jsii.get(self, "fillTransformation"))

    @builtins.property
    @jsii.member(jsii_name="fillTransformationInput")
    def fill_transformation_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultFitAndFillFillTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultFitAndFillFillTransformation], jsii.get(self, "fillTransformationInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8dd9f60962c004d92fc55fc658dd8b3c56a09bf248cbff079e50947432a9e7d8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__91420f770a94608a65cdcbb2b1644c2c1dbaeb7d2539ddf23ffea94560cad83a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9264083d67d033a9260687be403a2bc645054f291603d98bee35e09013064ef8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0796056f616e09ecef33ca33e3fedd3f70abe00f35662c8167e7246e60e4cec9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultFitAndFill]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultFitAndFill]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultFitAndFill]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f509a4a325971de2df94789932ce11d415564e15d46fd7023aee16b49c224c4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultGoop",
    jsii_struct_bases=[],
    name_mapping={
        "chaos": "chaos",
        "chaos_var": "chaosVar",
        "density": "density",
        "density_var": "densityVar",
        "power": "power",
        "power_var": "powerVar",
        "seed": "seed",
        "seed_var": "seedVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultGoop:
    def __init__(
        self,
        *,
        chaos: typing.Optional[builtins.str] = None,
        chaos_var: typing.Optional[builtins.str] = None,
        density: typing.Optional[builtins.str] = None,
        density_var: typing.Optional[builtins.str] = None,
        power: typing.Optional[builtins.str] = None,
        power_var: typing.Optional[builtins.str] = None,
        seed: typing.Optional[builtins.str] = None,
        seed_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param chaos: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        :param chaos_var: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        :param density: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        :param density_var: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        :param power: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        :param power_var: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        :param seed: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        :param seed_var: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e6ad6ddcb7592b31326e391539a8d50f8cd37a3470d0a2ecb3c514119365c89a)
            check_type(argname="argument chaos", value=chaos, expected_type=type_hints["chaos"])
            check_type(argname="argument chaos_var", value=chaos_var, expected_type=type_hints["chaos_var"])
            check_type(argname="argument density", value=density, expected_type=type_hints["density"])
            check_type(argname="argument density_var", value=density_var, expected_type=type_hints["density_var"])
            check_type(argname="argument power", value=power, expected_type=type_hints["power"])
            check_type(argname="argument power_var", value=power_var, expected_type=type_hints["power_var"])
            check_type(argname="argument seed", value=seed, expected_type=type_hints["seed"])
            check_type(argname="argument seed_var", value=seed_var, expected_type=type_hints["seed_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if chaos is not None:
            self._values["chaos"] = chaos
        if chaos_var is not None:
            self._values["chaos_var"] = chaos_var
        if density is not None:
            self._values["density"] = density
        if density_var is not None:
            self._values["density_var"] = density_var
        if power is not None:
            self._values["power"] = power
        if power_var is not None:
            self._values["power_var"] = power_var
        if seed is not None:
            self._values["seed"] = seed
        if seed_var is not None:
            self._values["seed_var"] = seed_var

    @builtins.property
    def chaos(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        '''
        result = self._values.get("chaos")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def chaos_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        '''
        result = self._values.get("chaos_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        '''
        result = self._values.get("density")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density_var(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        '''
        result = self._values.get("density_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        '''
        result = self._values.get("power")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power_var(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        '''
        result = self._values.get("power_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        '''
        result = self._values.get("seed")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed_var(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        result = self._values.get("seed_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultGoop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultGoopList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultGoopList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__91202aa9b8e78159005f66f0abfb7a93f8e310c80f248e320ea593e880919d8e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultGoopOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e4b9b7781737493598cb4ba0458c4a06d7240de50d69c5a9d5a8d50682180d0f)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultGoopOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7e7a2604ee04b75fa30ee7d8e4acbb493d2d678a685271e13afc9a726323c832)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__69e2341b7d9481f50d2ba7292454a83647f949d2ae21f02d73fd51200dfe43b2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d71c27da1ff38161138762a432f5fa94f42ff6f420d7095f10495d686883595b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultGoop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultGoop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__564c511d0bbf989743c2ce35778ecbd6589aca7ffd29760636563e02e7c88ff4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultGoopOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultGoopOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f57ef963efa467fa11b538c23f671ea2a7e5c9dcf0fd951ed9e08dd057d06e49)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetChaos")
    def reset_chaos(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaos", []))

    @jsii.member(jsii_name="resetChaosVar")
    def reset_chaos_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaosVar", []))

    @jsii.member(jsii_name="resetDensity")
    def reset_density(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensity", []))

    @jsii.member(jsii_name="resetDensityVar")
    def reset_density_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensityVar", []))

    @jsii.member(jsii_name="resetPower")
    def reset_power(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPower", []))

    @jsii.member(jsii_name="resetPowerVar")
    def reset_power_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPowerVar", []))

    @jsii.member(jsii_name="resetSeed")
    def reset_seed(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeed", []))

    @jsii.member(jsii_name="resetSeedVar")
    def reset_seed_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeedVar", []))

    @builtins.property
    @jsii.member(jsii_name="chaosInput")
    def chaos_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosInput"))

    @builtins.property
    @jsii.member(jsii_name="chaosVarInput")
    def chaos_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosVarInput"))

    @builtins.property
    @jsii.member(jsii_name="densityInput")
    def density_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityInput"))

    @builtins.property
    @jsii.member(jsii_name="densityVarInput")
    def density_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="powerInput")
    def power_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerInput"))

    @builtins.property
    @jsii.member(jsii_name="powerVarInput")
    def power_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerVarInput"))

    @builtins.property
    @jsii.member(jsii_name="seedInput")
    def seed_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedInput"))

    @builtins.property
    @jsii.member(jsii_name="seedVarInput")
    def seed_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedVarInput"))

    @builtins.property
    @jsii.member(jsii_name="chaos")
    def chaos(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaos"))

    @chaos.setter
    def chaos(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ff7137e9fb7566b4c2e0b3ce035b9336293755956600d289d7bcaa77a17a249)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaos", value)

    @builtins.property
    @jsii.member(jsii_name="chaosVar")
    def chaos_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaosVar"))

    @chaos_var.setter
    def chaos_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ca9615529b0ce4f9f2272658364684e663b08e2a182b232604370d27c75ce29d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaosVar", value)

    @builtins.property
    @jsii.member(jsii_name="density")
    def density(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "density"))

    @density.setter
    def density(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__77fb58c0afd719e13f856d48247137cdd878628411e2ff6e3d7f32e09a289131)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "density", value)

    @builtins.property
    @jsii.member(jsii_name="densityVar")
    def density_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "densityVar"))

    @density_var.setter
    def density_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eae948698d34d5e499b8f302a3a79a9b14279c0af158e326f3b4b2915bfe0e9a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "densityVar", value)

    @builtins.property
    @jsii.member(jsii_name="power")
    def power(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "power"))

    @power.setter
    def power(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7168a000ff916a5bf6c89e1802790ddfc4900d860341213633b9fa6b0f3479c1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "power", value)

    @builtins.property
    @jsii.member(jsii_name="powerVar")
    def power_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "powerVar"))

    @power_var.setter
    def power_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__59d87fc91c72a0162af559befdcc3f25a4df5a0e9750c7e5513e8c3227878cec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "powerVar", value)

    @builtins.property
    @jsii.member(jsii_name="seed")
    def seed(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seed"))

    @seed.setter
    def seed(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__482cda509db49abbb5dfaed77d4e4de1f5833f818fc8a2b6a0cd14d2578b409f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seed", value)

    @builtins.property
    @jsii.member(jsii_name="seedVar")
    def seed_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seedVar"))

    @seed_var.setter
    def seed_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e86504b1bbd1db8b1fffa5528138326e73558e683134734391d2fb8a52707080)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seedVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultGoop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultGoop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultGoop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__112fe45bf82f71c71e312a45e9b187506f342cbd626f9431c0fca4eadc1ae437)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultGrayscale",
    jsii_struct_bases=[],
    name_mapping={"type": "type", "type_var": "typeVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultGrayscale:
    def __init__(
        self,
        *,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param type: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9456fee0f7c1f531a6b3b7ddd09683ccd03947b928da33cb277382f282bc2bd6)
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultGrayscale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultGrayscaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultGrayscaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e68b56459c9584c34c105ca84a355cb45135aea1f57996c93be6276301006e1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultGrayscaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0d867ff4c8a1fdd0946678f000d8e4ada4d659a1fe6b92cdf589390b35b15a6b)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultGrayscaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ec4aa84c79881c66d136274291bad3705b89aa5f092e34662b13f560b872918c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b651629852e7030c6fff9a8d99017baad9b6959ec1f08babee0e6958ae4fcab9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fbcb72d39408f99e508e6831965672bfce615552b3d9418f20be1b751deef611)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultGrayscale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultGrayscale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc153df9f2006a4c8d233bf396a2ba053c4c13bdbe50f28f3c6329f03b7f3503)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultGrayscaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultGrayscaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d84b4e90b1fe4cc27950629c65dfcaf9d882bc06988c4f8197a47f96bab96286)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d5b4da04711dddf32ad6855394b6d4ee322a4c1ee41f52f7e8acc0e6c2f8bb4b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a728a9c9d034d7a10ceac99e2d3fdf55c11bab82c343833469270daec7b5b03e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultGrayscale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultGrayscale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultGrayscale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0fbae0a5d8df24881ffd9f9a9221f804cbc157e13b6fb88b0abcd0a51ec7b9a2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultHsl",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "lightness": "lightness",
        "lightness_var": "lightnessVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultHsl:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness: typing.Optional[builtins.str] = None,
        lightness_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        :param lightness_var: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e6b4745f90032bda14b95940e3d1484256a47393e787902be3674c8b05ac9199)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness", value=lightness, expected_type=type_hints["lightness"])
            check_type(argname="argument lightness_var", value=lightness_var, expected_type=type_hints["lightness_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness is not None:
            self._values["lightness"] = lightness
        if lightness_var is not None:
            self._values["lightness_var"] = lightness_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        '''
        result = self._values.get("lightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        '''
        result = self._values.get("lightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultHsl(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultHslList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultHslList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e7275089cf152080e40ac037c7cd2415b615adee2b9e46f7a1c11ba56ce5d31d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultHslOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1e045f684f2c78850916bd6519ee41dffb6cb75ed314dffc845b1e8b27fe929c)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultHslOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a1dfbda3ea9d2fc587fa619c1de7662ec776a6c85a9b692ea085da53d72cc51d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__68094fe6ff79629169ef16758243c21e9d70cb5dff119d88bbeaeee3d82b8f3c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4b4b4d5af78e57e6a7c6ce65f09dc64c109f9b0d169ca6282ac4d10e90eb57cb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultHsl]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultHsl]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__352b896b7fb6947e708653d51297cf830fb362cc5951b3c834ae6cc807e5097b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultHslOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultHslOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__220b9240472a0007519e5188504cd5c58cafd3b76ac466b506a49759bdd031a9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightness")
    def reset_lightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightness", []))

    @jsii.member(jsii_name="resetLightnessVar")
    def reset_lightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessInput")
    def lightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessVarInput")
    def lightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__23af4718a1f8ef6a68d21eb3303a78096b874d9df91915b4fef4d6e9ab3aedb4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea63114efb7de133a22d981ccdfd2b8c6723f88ce907f04d3406e80b6ee89b9d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightness")
    def lightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightness"))

    @lightness.setter
    def lightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__88c69a8d5d751dd484560dc847f3843733b916c3f4ec98b5d05c6a07116f198b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightness", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessVar")
    def lightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessVar"))

    @lightness_var.setter
    def lightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa1e66bba01e992d2fab60206c2cfd9c8e979fc1fc8fccfd594449f1a50814e4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e27a17dfce2588ccf68f04115eeae251ea228fb47977ebdbee2663f818bb5f9b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__46e6c4b853f83a29873e5d441e9c7cafbb2add55a7465e36d60a5055c82bf8af)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultHsl]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultHsl]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultHsl]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f583cebaf3118f6ea9e46f1dc2a4fe70f7570f21eb52f6019374f607f295bef5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultHsv",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultHsv:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        :param value: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c42c0175dc807a7b3098672056e73e7b9e9253d22d02494bcb05ae009deace12)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultHsv(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultHsvList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultHsvList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d9531c65d779b7ba2fb25c11ad3312ea6207705fe6ce546f626d31707a383640)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultHsvOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ee7705099c6bc80757f856c0e70f0794e122eed1c1db77160ef1dfc75afe26a)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultHsvOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d958a2d74e5518a906ac1df68b3352db3dd4f115e8c75406b55adfdf2a1d8300)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__056a1dbe2a31b139aade263d516880bc7b423031b5164b0bba5d9657d3d34d9e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e7998eb9cc056bc07a8ad302a4cdc42712c598c66267c459032a8a7b104ef055)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultHsv]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultHsv]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5c9f3b0ab0ae29d959313f97a4c2ee0d445e36d40ca45ae1a4fefcbc9ca4b0d6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultHsvOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultHsvOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4f38d5591e9b635959f0f20e3933d0e04e9b1b5c18f7457f954fb4e04f4e2b1e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__05ff758ab583b30d7e4bc31246af586a93c8ac003e7832bd26cce4f3b6ed1aac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__877428cc0346452d3aeb070c2e1e6d0f17bf45dc697c94864be0c52e70ea1543)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f280b8d2dc586b1939d364628a8c577aafeb6472eb9d23e533ba68ed0e57a838)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1eece13354174cbbd1bdc327072a9adaa175015976421562b4b58793e394c626)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__77561679c23aa68224347466eef846ef67e89ff00f2addb32e7c666d33a96326)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b609b5745f5605fdcad4b05f76595326503eaedd4fb64e4c19f102f45b65b7ec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultHsv]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultHsv]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultHsv]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__04ab1d943f911ed64fd2beccd0ec864ae941c9956e28ea63c051acfa5c5c57f1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfDimension",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "dimension": "dimension",
        "dimension_var": "dimensionVar",
        "equal": "equal",
        "greater_than": "greaterThan",
        "less_than": "lessThan",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfDimension:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfDimensionDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        dimension: typing.Optional[builtins.str] = None,
        dimension_var: typing.Optional[builtins.str] = None,
        equal: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfDimensionEqual", typing.Dict[builtins.str, typing.Any]]] = None,
        greater_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfDimensionGreaterThan", typing.Dict[builtins.str, typing.Any]]] = None,
        less_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfDimensionLessThan", typing.Dict[builtins.str, typing.Any]]] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param dimension: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        :param dimension_var: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        :param equal: equal block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        :param greater_than: greater_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        :param less_than: less_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        :param value: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfDimensionDefault(**default)
        if isinstance(equal, dict):
            equal = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfDimensionEqual(**equal)
        if isinstance(greater_than, dict):
            greater_than = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfDimensionGreaterThan(**greater_than)
        if isinstance(less_than, dict):
            less_than = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfDimensionLessThan(**less_than)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d13939563a9ab1291600421347930020beacb75bddac4a5580faed42d312b687)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument dimension", value=dimension, expected_type=type_hints["dimension"])
            check_type(argname="argument dimension_var", value=dimension_var, expected_type=type_hints["dimension_var"])
            check_type(argname="argument equal", value=equal, expected_type=type_hints["equal"])
            check_type(argname="argument greater_than", value=greater_than, expected_type=type_hints["greater_than"])
            check_type(argname="argument less_than", value=less_than, expected_type=type_hints["less_than"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if dimension is not None:
            self._values["dimension"] = dimension
        if dimension_var is not None:
            self._values["dimension_var"] = dimension_var
        if equal is not None:
            self._values["equal"] = equal
        if greater_than is not None:
            self._values["greater_than"] = greater_than
        if less_than is not None:
            self._values["less_than"] = less_than
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfDimensionDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfDimensionDefault"], result)

    @builtins.property
    def dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        '''
        result = self._values.get("dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        '''
        result = self._values.get("dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def equal(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfDimensionEqual"]:
        '''equal block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        '''
        result = self._values.get("equal")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfDimensionEqual"], result)

    @builtins.property
    def greater_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfDimensionGreaterThan"]:
        '''greater_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        '''
        result = self._values.get("greater_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfDimensionGreaterThan"], result)

    @builtins.property
    def less_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfDimensionLessThan"]:
        '''less_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        '''
        result = self._values.get("less_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfDimensionLessThan"], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfDimension(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfDimensionDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfDimensionDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfDimensionDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfDimensionDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfDimensionDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__51eb7858f40058764ed6ea185743706d36c7343003bc355231881bfa96c714c3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfDimensionDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfDimensionDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7e3a1747fa6eb8fe39ebd9583056b68b1ad94960ac672f238c80a9267b988b66)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfDimensionEqual",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfDimensionEqual:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfDimensionEqual(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfDimensionEqualOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfDimensionEqualOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a2dbbc5b7ff7199295ccbe69d1558d2728bd4a1ff1891d3af6db4eb8f5b5080e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfDimensionEqual], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfDimensionEqual],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a4f0b504d074f8ffa6bfb923bee70c320801c89d82cb7342e72232e505b8977)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfDimensionGreaterThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfDimensionGreaterThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfDimensionGreaterThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfDimensionGreaterThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfDimensionGreaterThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__926403e359fa12a127a167b642560843a05bca412d26f988c2ee24ecd24f993a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfDimensionGreaterThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfDimensionGreaterThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__15aa9d890f9d2adf45253a266c5ba88a5004fba954cdcc42126d6dceafa1f0f8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfDimensionLessThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfDimensionLessThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfDimensionLessThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfDimensionLessThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfDimensionLessThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0f37c471b83c9453ef3e39d8ee1c7c9554c0022a41936de83067b48308cd8d77)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfDimensionLessThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfDimensionLessThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b903e38a2d95d25d27f6eed9c1a69abdc89a8e48e073f912f4cc59630374f0eb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfDimensionList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfDimensionList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__973aef1ff7f3a2b0ca5d040aecb7af1141ba98fd6cae10d56115adc1eaef5ad6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfDimensionOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0c31e354ce3d44bcd22f2ec7e608ee45beb99dad083a5f22002a831376060da5)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfDimensionOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8d644cb26fa861b7f0dbbaca7335d1f686712b8b78a945431b2f60980099227f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cf97fc4e1db2ffd00450fd33ae26e412c9d56ac81976f6127b9791144d819a05)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__946c2f1cc2496b3d081ef2745283660a320556404ad0b19f4aec5d62d4e5081a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfDimension]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfDimension]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__98d736be2ddaaa6812c6025807edefac4e425fed61ad48bb066e51a6a1bb2f6f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfDimensionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfDimensionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4874a1df654cf6c99d34d64bbd96e007ca9b1bbe2c33196efba15f54bfaf863e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfDimensionDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putEqual")
    def put_equal(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfDimensionEqual()

        return typing.cast(None, jsii.invoke(self, "putEqual", [value]))

    @jsii.member(jsii_name="putGreaterThan")
    def put_greater_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfDimensionGreaterThan()

        return typing.cast(None, jsii.invoke(self, "putGreaterThan", [value]))

    @jsii.member(jsii_name="putLessThan")
    def put_less_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfDimensionLessThan()

        return typing.cast(None, jsii.invoke(self, "putLessThan", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetDimension")
    def reset_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimension", []))

    @jsii.member(jsii_name="resetDimensionVar")
    def reset_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimensionVar", []))

    @jsii.member(jsii_name="resetEqual")
    def reset_equal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEqual", []))

    @jsii.member(jsii_name="resetGreaterThan")
    def reset_greater_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGreaterThan", []))

    @jsii.member(jsii_name="resetLessThan")
    def reset_less_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLessThan", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfDimensionDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfDimensionDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="equal")
    def equal(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfDimensionEqualOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfDimensionEqualOutputReference, jsii.get(self, "equal"))

    @builtins.property
    @jsii.member(jsii_name="greaterThan")
    def greater_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfDimensionGreaterThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfDimensionGreaterThanOutputReference, jsii.get(self, "greaterThan"))

    @builtins.property
    @jsii.member(jsii_name="lessThan")
    def less_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfDimensionLessThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfDimensionLessThanOutputReference, jsii.get(self, "lessThan"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfDimensionDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionInput")
    def dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionVarInput")
    def dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="equalInput")
    def equal_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfDimensionEqual], jsii.get(self, "equalInput"))

    @builtins.property
    @jsii.member(jsii_name="greaterThanInput")
    def greater_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfDimensionGreaterThan], jsii.get(self, "greaterThanInput"))

    @builtins.property
    @jsii.member(jsii_name="lessThanInput")
    def less_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfDimensionLessThan], jsii.get(self, "lessThanInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="dimension")
    def dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimension"))

    @dimension.setter
    def dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__becd82651316008a97503268087724f47862238dc9007a036b7692464dc7803e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimension", value)

    @builtins.property
    @jsii.member(jsii_name="dimensionVar")
    def dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimensionVar"))

    @dimension_var.setter
    def dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9b5a47f90469acb708c08e39d79566c2f70dc3d78b4e63e73411bfcf1004d075)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__88d96d93070865322860385ceda499083483dbcea74700ddd6a37f4c66f270d7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f1adf84662a5359f5e5b88af820abdcb4c5c1acecbc93c26d97f1d533e408c0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfDimension]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfDimension]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfDimension]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4397cd2974b648cecf220f0a68774cd83347bbc391b21ab328e8b37ca3c9bf6e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfOrientation",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "landscape": "landscape",
        "portrait": "portrait",
        "square": "square",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfOrientation:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfOrientationDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        landscape: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfOrientationLandscape", typing.Dict[builtins.str, typing.Any]]] = None,
        portrait: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfOrientationPortrait", typing.Dict[builtins.str, typing.Any]]] = None,
        square: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfOrientationSquare", typing.Dict[builtins.str, typing.Any]]] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param landscape: landscape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        :param portrait: portrait block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        :param square: square block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfOrientationDefault(**default)
        if isinstance(landscape, dict):
            landscape = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfOrientationLandscape(**landscape)
        if isinstance(portrait, dict):
            portrait = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfOrientationPortrait(**portrait)
        if isinstance(square, dict):
            square = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfOrientationSquare(**square)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__04748e611acf9fb12372203513a51833a1f475f53a0aa0244e2fcb63a0ef4f79)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument landscape", value=landscape, expected_type=type_hints["landscape"])
            check_type(argname="argument portrait", value=portrait, expected_type=type_hints["portrait"])
            check_type(argname="argument square", value=square, expected_type=type_hints["square"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if landscape is not None:
            self._values["landscape"] = landscape
        if portrait is not None:
            self._values["portrait"] = portrait
        if square is not None:
            self._values["square"] = square

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfOrientationDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfOrientationDefault"], result)

    @builtins.property
    def landscape(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfOrientationLandscape"]:
        '''landscape block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        '''
        result = self._values.get("landscape")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfOrientationLandscape"], result)

    @builtins.property
    def portrait(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfOrientationPortrait"]:
        '''portrait block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        '''
        result = self._values.get("portrait")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfOrientationPortrait"], result)

    @builtins.property
    def square(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfOrientationSquare"]:
        '''square block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        result = self._values.get("square")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfOrientationSquare"], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfOrientation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfOrientationDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfOrientationDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfOrientationDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfOrientationDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfOrientationDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c95361b529cfcc15ed6cbe2c6fa1634fc381e299618281598095b944f15292e9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfOrientationDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfOrientationDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9eefa1018f07688af1cee033b3f7c08eebd125bb1b880e9f3e9752c252eefcdd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfOrientationLandscape",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfOrientationLandscape:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfOrientationLandscape(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfOrientationLandscapeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfOrientationLandscapeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7cacdeebf2e4aa85acc4c9b26fb3f7b77e979375cff8cbd9e6221f60e1668ffe)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfOrientationLandscape], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfOrientationLandscape],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f5634afa718d9da8abea90d3c7e747c2dace80208f104ba8109f75cd9e44f3fe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfOrientationList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfOrientationList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bbad04bad6c0d7d7adb149512578c82b5affb528cb966e1da92ed4d55197b560)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfOrientationOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dd2e8426045a40473a08576f8da9dd2c27c10450ac8aede488d4b2a790657cac)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfOrientationOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1187b1e7bfdc16fb8bc1ba69ab6861ab5f82745fbb6e0c49270fb3238ffe89a1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__173cf5b42fea28c6ba3cc9dfc14b372b67dae17195dbd86be2af420df92eb146)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0c5e99e384839ca7c19476f96d37986326f861ed330a3822efc0ff41aed401fb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfOrientation]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfOrientation]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__384d6eadd979d9b2d59d42f1a76bc70274223cad94c8fb708a0acd1fb7cc3440)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfOrientationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfOrientationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd6f0bf269cf996696a845eeb4651311319d0f211fedc7b0e0c77724207a351d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfOrientationDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putLandscape")
    def put_landscape(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfOrientationLandscape()

        return typing.cast(None, jsii.invoke(self, "putLandscape", [value]))

    @jsii.member(jsii_name="putPortrait")
    def put_portrait(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfOrientationPortrait()

        return typing.cast(None, jsii.invoke(self, "putPortrait", [value]))

    @jsii.member(jsii_name="putSquare")
    def put_square(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfOrientationSquare()

        return typing.cast(None, jsii.invoke(self, "putSquare", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetLandscape")
    def reset_landscape(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLandscape", []))

    @jsii.member(jsii_name="resetPortrait")
    def reset_portrait(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPortrait", []))

    @jsii.member(jsii_name="resetSquare")
    def reset_square(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSquare", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfOrientationDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfOrientationDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="landscape")
    def landscape(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfOrientationLandscapeOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfOrientationLandscapeOutputReference, jsii.get(self, "landscape"))

    @builtins.property
    @jsii.member(jsii_name="portrait")
    def portrait(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfOrientationPortraitOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfOrientationPortraitOutputReference", jsii.get(self, "portrait"))

    @builtins.property
    @jsii.member(jsii_name="square")
    def square(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfOrientationSquareOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfOrientationSquareOutputReference", jsii.get(self, "square"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfOrientationDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="landscapeInput")
    def landscape_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfOrientationLandscape], jsii.get(self, "landscapeInput"))

    @builtins.property
    @jsii.member(jsii_name="portraitInput")
    def portrait_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfOrientationPortrait"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfOrientationPortrait"], jsii.get(self, "portraitInput"))

    @builtins.property
    @jsii.member(jsii_name="squareInput")
    def square_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfOrientationSquare"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfOrientationSquare"], jsii.get(self, "squareInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfOrientation]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfOrientation]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfOrientation]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea21a2da497318b5d2e94fe817ad09b3d0ee9e51c99ffd056338bc4dbff731c8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfOrientationPortrait",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfOrientationPortrait:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfOrientationPortrait(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfOrientationPortraitOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfOrientationPortraitOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0709fff8a15afe83e742dde29714f384df0468d98035bbff7d1922247c9cdc68)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfOrientationPortrait]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfOrientationPortrait], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfOrientationPortrait],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fb337226142a1103f87cb5e2b8d3865744679261f9c2441ed33dc0015dd0835f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfOrientationSquare",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfOrientationSquare:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfOrientationSquare(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfOrientationSquareOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfOrientationSquareOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab74737c5bc8b27ec7e27b13879d5aa9ff301c357ea8a91f1a48f36b0b8067bc)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfOrientationSquare]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfOrientationSquare], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfOrientationSquare],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__10beb95382fa4b6c9546aa14e84d4ecd324650359072c0e9b9346539ae984d1c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultImQuery",
    jsii_struct_bases=[],
    name_mapping={
        "allowed_transformations": "allowedTransformations",
        "query_var": "queryVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultImQuery:
    def __init__(
        self,
        *,
        allowed_transformations: typing.Sequence[builtins.str],
        query_var: builtins.str,
    ) -> None:
        '''
        :param allowed_transformations: Specifies the transformations that can be applied using the query string parameter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allowed_transformations DataAkamaiImagingPolicyImage#allowed_transformations}
        :param query_var: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#query_var DataAkamaiImagingPolicyImage#query_var}.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a6a7a2011b54b1a71cd3e76a98cd33ba8bbf366446ed808cfe44ae77f80889c)
            check_type(argname="argument allowed_transformations", value=allowed_transformations, expected_type=type_hints["allowed_transformations"])
            check_type(argname="argument query_var", value=query_var, expected_type=type_hints["query_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "allowed_transformations": allowed_transformations,
            "query_var": query_var,
        }

    @builtins.property
    def allowed_transformations(self) -> typing.List[builtins.str]:
        '''Specifies the transformations that can be applied using the query string parameter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allowed_transformations DataAkamaiImagingPolicyImage#allowed_transformations}
        '''
        result = self._values.get("allowed_transformations")
        assert result is not None, "Required property 'allowed_transformations' is missing"
        return typing.cast(typing.List[builtins.str], result)

    @builtins.property
    def query_var(self) -> builtins.str:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#query_var DataAkamaiImagingPolicyImage#query_var}.'''
        result = self._values.get("query_var")
        assert result is not None, "Required property 'query_var' is missing"
        return typing.cast(builtins.str, result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultImQuery(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultImQueryList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultImQueryList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ca529e85e6f48adf443ee18d1997f3278d5f65a12c7c1e437576d4a03e89d15)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultImQueryOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0f58901d1b91323c54cf43ab21e073964e72d430aa10e6e8e6f86eb43db6a865)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultImQueryOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__515804976118012f1fbeb56b62b503e82a074c44fae6a98a2115a7d02d431eaf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a8d75438f9fab6a5a5f88cfceaf2aa72fe73ceeba40bc02ca8cda704bdc18e13)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6539e685fe4b0578c37611bcc21afaf8c83bd960b98d8e9a471e773f25591578)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultImQuery]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultImQuery]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultImQuery]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7301a01f0efeaa2e75a6ed24ff6968cedd707ef2da0f81390103c87412faca19)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultImQueryOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultImQueryOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__60393e5aa51be64cd34f734195e00b7e001a296d66598f44eb47fee82e2bfc18)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @builtins.property
    @jsii.member(jsii_name="allowedTransformationsInput")
    def allowed_transformations_input(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "allowedTransformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="queryVarInput")
    def query_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "queryVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowedTransformations")
    def allowed_transformations(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "allowedTransformations"))

    @allowed_transformations.setter
    def allowed_transformations(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__903c3e8dba9702c37d0b7b0a4e94ee97bd354050e9cfff1a79e3c62a8076596e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowedTransformations", value)

    @builtins.property
    @jsii.member(jsii_name="queryVar")
    def query_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "queryVar"))

    @query_var.setter
    def query_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a2def0e58014931c3fdcdec1a89c2a45fcbd6548293b1020d7d1791d5a88415a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "queryVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultImQuery]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultImQuery]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultImQuery]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c55dbb34de567def1a5af8c14de7f595eef5d0155d42fca3b9e0258c101dfaf3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultMaxColors",
    jsii_struct_bases=[],
    name_mapping={"colors": "colors", "colors_var": "colorsVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultMaxColors:
    def __init__(
        self,
        *,
        colors: typing.Optional[builtins.str] = None,
        colors_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param colors: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        :param colors_var: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__276d0f1638ee47ff205fe2e9c12d40d1f78bd64dbd08abf819259712914d7889)
            check_type(argname="argument colors", value=colors, expected_type=type_hints["colors"])
            check_type(argname="argument colors_var", value=colors_var, expected_type=type_hints["colors_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if colors is not None:
            self._values["colors"] = colors
        if colors_var is not None:
            self._values["colors_var"] = colors_var

    @builtins.property
    def colors(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        '''
        result = self._values.get("colors")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def colors_var(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        result = self._values.get("colors_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultMaxColors(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultMaxColorsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultMaxColorsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0d599aa310e63277533d2ca39926e5af3a0bafef18dd049041cc24ff78cb2acc)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultMaxColorsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3b711de11b9556efb59cfb8cf20b12f87db2a1efd45d2b5f42891e0ec144ec90)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultMaxColorsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb7d7319f1d10ed39657065b5d4138cbfdfe484a2a74ec518604af578d6413c3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aa887483372b3957a9f24d7e2a1d5b084930c4024f04130831a3a0e9da2a3b72)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__226d26f908839a16d94271412b8178df41d731100f0a51c4e1b9c643a8344222)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultMaxColors]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultMaxColors]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__867e2a2483df9a05f76e7a191076d00d324743f40c5e3fd2f035490772e9e2c3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultMaxColorsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultMaxColorsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a7517c86037b1a1067a4e04791146b3d7f767b39f4d9d92547652502886cd7dc)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColors")
    def reset_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColors", []))

    @jsii.member(jsii_name="resetColorsVar")
    def reset_colors_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorsVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorsInput")
    def colors_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsInput"))

    @builtins.property
    @jsii.member(jsii_name="colorsVarInput")
    def colors_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsVarInput"))

    @builtins.property
    @jsii.member(jsii_name="colors")
    def colors(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colors"))

    @colors.setter
    def colors(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8ee781d7f70da1f24f67c4eaacbf097b7e82de939be22b23b1e871bdb1873496)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colors", value)

    @builtins.property
    @jsii.member(jsii_name="colorsVar")
    def colors_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorsVar"))

    @colors_var.setter
    def colors_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bd3524e16a6c6856ddf6dd4dbe571b385a51b52d2609bf450543ef323c758d31)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorsVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultMaxColors]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultMaxColors]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultMaxColors]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d1c4a6842ed0ff24aa707aad6269a667ceb121abe092c55b3ada7c91a4d88f4c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultMirror",
    jsii_struct_bases=[],
    name_mapping={
        "horizontal": "horizontal",
        "horizontal_var": "horizontalVar",
        "vertical": "vertical",
        "vertical_var": "verticalVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultMirror:
    def __init__(
        self,
        *,
        horizontal: typing.Optional[builtins.str] = None,
        horizontal_var: typing.Optional[builtins.str] = None,
        vertical: typing.Optional[builtins.str] = None,
        vertical_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param horizontal: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        :param horizontal_var: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        :param vertical: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        :param vertical_var: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__57349b04c2ed7fc01238e7609e1934d254f6c76af90a1ffe907b44c8b2b8963d)
            check_type(argname="argument horizontal", value=horizontal, expected_type=type_hints["horizontal"])
            check_type(argname="argument horizontal_var", value=horizontal_var, expected_type=type_hints["horizontal_var"])
            check_type(argname="argument vertical", value=vertical, expected_type=type_hints["vertical"])
            check_type(argname="argument vertical_var", value=vertical_var, expected_type=type_hints["vertical_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if horizontal is not None:
            self._values["horizontal"] = horizontal
        if horizontal_var is not None:
            self._values["horizontal_var"] = horizontal_var
        if vertical is not None:
            self._values["vertical"] = vertical
        if vertical_var is not None:
            self._values["vertical_var"] = vertical_var

    @builtins.property
    def horizontal(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        '''
        result = self._values.get("horizontal")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def horizontal_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        '''
        result = self._values.get("horizontal_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        '''
        result = self._values.get("vertical")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        result = self._values.get("vertical_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultMirror(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultMirrorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultMirrorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__06de189ccc253097241c124de2912135eb6c457cfabad99464d9179d526ab21b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultMirrorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__34625f55bd65bf3b4724efcd3e2b9a6646c2df3cb39a4829801b7916982e6f7e)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultMirrorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__50fe301ea02afb4babcf5cb014626f04eb7631ba81c494f315f91e76dfcd4d29)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__35fa4a4734788999a397e3ccb95638e8d4b63297e19eea268131aa1e86d8c6cb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8332ace7eb2266860e180b00a1c495a4437e1cd471d47768f4fdd491a44df5f3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultMirror]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultMirror]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0548b62ba96a43b8b65c94e9c91bb9384e70d025680eb00305e203fd878bda42)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultMirrorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultMirrorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7a239dfe42a4d24286db81ed50a2fe42bfe29427205e137e82b23ed29c23fd56)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHorizontal")
    def reset_horizontal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontal", []))

    @jsii.member(jsii_name="resetHorizontalVar")
    def reset_horizontal_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontalVar", []))

    @jsii.member(jsii_name="resetVertical")
    def reset_vertical(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVertical", []))

    @jsii.member(jsii_name="resetVerticalVar")
    def reset_vertical_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVerticalVar", []))

    @builtins.property
    @jsii.member(jsii_name="horizontalInput")
    def horizontal_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontalVarInput")
    def horizontal_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalInput")
    def vertical_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalVarInput")
    def vertical_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontal")
    def horizontal(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontal"))

    @horizontal.setter
    def horizontal(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8f208bc8f6eada43c297b5bc5909717fbf287b3c68bebbb817b466e6da6d6758)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontal", value)

    @builtins.property
    @jsii.member(jsii_name="horizontalVar")
    def horizontal_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontalVar"))

    @horizontal_var.setter
    def horizontal_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bdeeb6a00778fc5fb2033177d011dabbd959b2bc7a8422855085372f6488ccf6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontalVar", value)

    @builtins.property
    @jsii.member(jsii_name="vertical")
    def vertical(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "vertical"))

    @vertical.setter
    def vertical(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__936d2c602a895a3d366b8cb0dad68e0e8056b71b838ed9d93f508ef4340a0a47)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "vertical", value)

    @builtins.property
    @jsii.member(jsii_name="verticalVar")
    def vertical_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "verticalVar"))

    @vertical_var.setter
    def vertical_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0f34c70a06bef0edf6241b59b1b6f7882de4c6257d3d131409eb10e4c5eb5d4c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "verticalVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultMirror]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultMirror]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultMirror]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__03bf4991ccb78e3ad93e67b556160cf10415df93044e61446fac4cd847cd4e9f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultMonoHue",
    jsii_struct_bases=[],
    name_mapping={"hue": "hue", "hue_var": "hueVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultMonoHue:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6bc4b3b7012006cd44850516a3dbc55344161bc84d7e083b26a628d10b13ae75)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultMonoHue(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultMonoHueList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultMonoHueList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__741f4cecdb183b1c9051ed32f496575dd93fcfdafd2f940a5ac94ae7f1939841)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultMonoHueOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b4024a1b9ef61363c62630ecb85c9c3a0d4bf6e7dfa5e029b1569aa8cb168fff)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultMonoHueOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8616a36a6074526427df555bc8793429f8acf93e97b20d7b6f4a52054589abab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__61728dcae1bcee78e80db56ff68e087bc5d36f638a900b21312061a44cdd39d4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__61d2fec4150b71d0e821010a29e008c55bd43639c8ec6ebf3b6193e65acf0ba5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultMonoHue]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultMonoHue]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a9156d80736af7547f908ec37863bff54c983f84f3868a2269f3e2b148af267f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultMonoHueOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultMonoHueOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__04020f4d1b31fe2eb5e29eaad207339b23f2e5a82cf671d67140a9ca475cffdf)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aeb8d15d4cb2fb5178b9577c193fe9b3d6ee1268e561cd664799916f6e768968)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d41a3df36d447c8d7be815093881f53757b02af061b125c4a3ae45e3359f9aac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultMonoHue]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultMonoHue]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultMonoHue]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__de2471a32a97d4f226ae809ef31bcd7fc301e28020d88a841573d7d8630ae628)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultOpacity",
    jsii_struct_bases=[],
    name_mapping={"opacity": "opacity", "opacity_var": "opacityVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultOpacity:
    def __init__(
        self,
        *,
        opacity: typing.Optional[builtins.str] = None,
        opacity_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param opacity: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param opacity_var: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__212e5cfb836b4fe2ed7bb8b389e5f710eca4f2e43dcc8563f116998a571503d2)
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument opacity_var", value=opacity_var, expected_type=type_hints["opacity_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if opacity is not None:
            self._values["opacity"] = opacity
        if opacity_var is not None:
            self._values["opacity_var"] = opacity_var

    @builtins.property
    def opacity(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def opacity_var(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        result = self._values.get("opacity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultOpacity(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultOpacityList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultOpacityList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af03e4fbc3dd88fbdb20596aab5c6c795e63cbd0241c0902b3b99a121b3fbd9f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultOpacityOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a3aecdd0912eb92ebf1e4392d920adc373633c073251cec0bb327b573c30bf4e)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultOpacityOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__69b37f4c3a21bdcf761bf6a4af966ab375480112c02aad4e3c606691b69e49cd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ba18dca3e036ee4f63d8999a92a146cab53c9b90507aef194db34a08bd699266)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3eb687f4dcbab90ca0ce3ad6ffed38b16be9b581a8c951ad838c929e6ca1b811)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultOpacity]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultOpacity]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9995c960b17d2883859b162ffb42f02594c35b7aa661363aa282ea689283a338)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultOpacityOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultOpacityOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4b5cf71105ab2cbb6de62933a2bbbf3593f0d0e83a03eb565243df797029be78)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetOpacityVar")
    def reset_opacity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacityVar", []))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityVarInput")
    def opacity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacity"))

    @opacity.setter
    def opacity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c3c617139efd80c962cc64782ba57f5a65e5163d82cec839746f58f881ed4485)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacity", value)

    @builtins.property
    @jsii.member(jsii_name="opacityVar")
    def opacity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacityVar"))

    @opacity_var.setter
    def opacity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__12f134bc1c4ed9d47e494737e9fd566eb957cd1dd6c3cae93dea113d30559eda)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacityVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultOpacity]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultOpacity]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultOpacity]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a36f98a2eec93ce3a2bd1464de0c58bc0f0ce806452adf0bb68819d24cc63738)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__66b50bfb80af825e9b53db19bcb4142188d226437ae994605d0bf0e1b93566c4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putAppend")
    def put_append(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultAppend, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1bfd42634223314a27e837bbc0084d7fd9ac4c4baeee9080e6b4c68f578cec50)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putAppend", [value]))

    @jsii.member(jsii_name="putAspectCrop")
    def put_aspect_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultAspectCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__14a3b7340f03dda4996bf7b3d362b784e0965f78ba101662641e391376a010f2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putAspectCrop", [value]))

    @jsii.member(jsii_name="putBackgroundColor")
    def put_background_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f011de134caa99ca190f02992d5adc6441998215c8acc066dbd1df3bca99d9f7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBackgroundColor", [value]))

    @jsii.member(jsii_name="putBlur")
    def put_blur(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultBlur, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6be17d774e78c2e5723d44b05067f19421956e30c9c007ef3f2d009e0c5a12ee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBlur", [value]))

    @jsii.member(jsii_name="putChromaKey")
    def put_chroma_key(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultChromaKey, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7bbd3133b8334dee5798e5908cb783b8c7b27c0860ec91fc319241a5f8df8012)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putChromaKey", [value]))

    @jsii.member(jsii_name="putComposite")
    def put_composite(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultComposite, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1ca53c58391a7ebba3c26454ea7be5b26efe62f06f5a8c3d6f036cf6e94f93eb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putComposite", [value]))

    @jsii.member(jsii_name="putCompound")
    def put_compound(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultCompound, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f46f44d0439a28a7e99058beb94b4e914d35b65a97fd8b6c927b16ab03df9665)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCompound", [value]))

    @jsii.member(jsii_name="putContrast")
    def put_contrast(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultContrast, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6a314fb234c2a7bd61e2c29005921356d1d478dcc1199ba2052d7e6925fb9782)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putContrast", [value]))

    @jsii.member(jsii_name="putCrop")
    def put_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__171fecd27cd35fab6e3eb3ff7e571acebec61ded6733c037b6ca26117a69350f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCrop", [value]))

    @jsii.member(jsii_name="putFaceCrop")
    def put_face_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultFaceCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c42e121c830fea98318d821493b10e0fed79db7a4a2296588052ce51497f94c3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFaceCrop", [value]))

    @jsii.member(jsii_name="putFeatureCrop")
    def put_feature_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultFeatureCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b8c754d97092fb45aa6a1d5d37d0d2195f2dfa0781b0e9b19f6809d6b0454507)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFeatureCrop", [value]))

    @jsii.member(jsii_name="putFitAndFill")
    def put_fit_and_fill(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultFitAndFill, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__05c281e8c05322d847db181b00dabed033df98e84f42865060819cda0589eb5d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFitAndFill", [value]))

    @jsii.member(jsii_name="putGoop")
    def put_goop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultGoop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__69221560bc72e65cec968aae9949c8d9e60503e3d68cbee9791494b3cc44c2ff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGoop", [value]))

    @jsii.member(jsii_name="putGrayscale")
    def put_grayscale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultGrayscale, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b87845b62933040d9c857cbc520b0ad18d9bddb236d04708abb1c4be92da3b4a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGrayscale", [value]))

    @jsii.member(jsii_name="putHsl")
    def put_hsl(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultHsl, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__31ec44e956867b5eb2db4cf3023de9c0a0ed32e31e0457203b37d3501a04d102)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsl", [value]))

    @jsii.member(jsii_name="putHsv")
    def put_hsv(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultHsv, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d630f5d3fda68c238f1f1ab90c9ae499e47e9111e0d71c4485999ddafbfe4a3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsv", [value]))

    @jsii.member(jsii_name="putIfDimension")
    def put_if_dimension(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfDimension, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__40cba01836578c6a03ea6bd31d1b0f9035dd31a9397a29a74cc1808616a16d1f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfDimension", [value]))

    @jsii.member(jsii_name="putIfOrientation")
    def put_if_orientation(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__685f6b000ad6f729319b4f5b40739df136411c204b19a86c3aca3e37c6053375)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfOrientation", [value]))

    @jsii.member(jsii_name="putImQuery")
    def put_im_query(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultImQuery, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f44b26ca0611d840c1738017cc76bbd5d3b2a05640808c973f8e758961283794)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putImQuery", [value]))

    @jsii.member(jsii_name="putMaxColors")
    def put_max_colors(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultMaxColors, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1cbd4ed882f9f1defe024c43585483258a885a12a960ade73f180299e3838437)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMaxColors", [value]))

    @jsii.member(jsii_name="putMirror")
    def put_mirror(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultMirror, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6eff0dbf05968d349b9da12ec883b2121602da86f619d43da709b0db467eed3f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMirror", [value]))

    @jsii.member(jsii_name="putMonoHue")
    def put_mono_hue(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultMonoHue, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__76f739dd89d03a1a086f8ec1ee031bb13b97c8e9eaef2bbbcf7d30511ab74bc9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMonoHue", [value]))

    @jsii.member(jsii_name="putOpacity")
    def put_opacity(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultOpacity, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fe534925b04e40422d954d7934af15232165c93d9f18fbc323bf6613a5c69d9e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putOpacity", [value]))

    @jsii.member(jsii_name="putRegionOfInterestCrop")
    def put_region_of_interest_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultRegionOfInterestCrop", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a3170852a7a0517405792ee3e4fa6b0469227dbb137b1cb6af6632e216be6ba6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRegionOfInterestCrop", [value]))

    @jsii.member(jsii_name="putRelativeCrop")
    def put_relative_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultRelativeCrop", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f4de5f2ef21f6cba806901dea7cef47ec2ef0c4619bf03648dc1cde7101cc4d4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRelativeCrop", [value]))

    @jsii.member(jsii_name="putRemoveColor")
    def put_remove_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultRemoveColor", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aa298973268d0cc1ac148d713667aee2940f62e66582dbb19725e77889fd51f6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRemoveColor", [value]))

    @jsii.member(jsii_name="putResize")
    def put_resize(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultResize", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3c4078a82b0d6ca9d1b14cde74a4d7a7c830705a0e10edbb9e6f9e04ce3e48ac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putResize", [value]))

    @jsii.member(jsii_name="putRotate")
    def put_rotate(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultRotate", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2685d103f65ccfc9fb15588e1db2bbb0530a1945e7aa91449b88416865ff51bb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRotate", [value]))

    @jsii.member(jsii_name="putScale")
    def put_scale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultScale", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__08663f45544ffabb655dce7a37dec0c00c36c693eae0fd21aab65034bbd6377a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putScale", [value]))

    @jsii.member(jsii_name="putShear")
    def put_shear(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultShear", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c72c28970893dacde483a21260177d7c0f7f4f68779eeb53443001e0ee51c0c4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putShear", [value]))

    @jsii.member(jsii_name="putTrim")
    def put_trim(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultTrim", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ad7ea4f701d4f934c1132ef0d4b233499f0a5b47a319149df06c807914f712e8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTrim", [value]))

    @jsii.member(jsii_name="putUnsharpMask")
    def put_unsharp_mask(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultUnsharpMask", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__544a6bf76b961dec640606b56a54b309f5543557daab8006e91ee0d222a0925c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putUnsharpMask", [value]))

    @jsii.member(jsii_name="resetAppend")
    def reset_append(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAppend", []))

    @jsii.member(jsii_name="resetAspectCrop")
    def reset_aspect_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspectCrop", []))

    @jsii.member(jsii_name="resetBackgroundColor")
    def reset_background_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBackgroundColor", []))

    @jsii.member(jsii_name="resetBlur")
    def reset_blur(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBlur", []))

    @jsii.member(jsii_name="resetChromaKey")
    def reset_chroma_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChromaKey", []))

    @jsii.member(jsii_name="resetComposite")
    def reset_composite(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetComposite", []))

    @jsii.member(jsii_name="resetCompound")
    def reset_compound(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCompound", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetCrop")
    def reset_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCrop", []))

    @jsii.member(jsii_name="resetFaceCrop")
    def reset_face_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFaceCrop", []))

    @jsii.member(jsii_name="resetFeatureCrop")
    def reset_feature_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureCrop", []))

    @jsii.member(jsii_name="resetFitAndFill")
    def reset_fit_and_fill(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFitAndFill", []))

    @jsii.member(jsii_name="resetGoop")
    def reset_goop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGoop", []))

    @jsii.member(jsii_name="resetGrayscale")
    def reset_grayscale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGrayscale", []))

    @jsii.member(jsii_name="resetHsl")
    def reset_hsl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsl", []))

    @jsii.member(jsii_name="resetHsv")
    def reset_hsv(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsv", []))

    @jsii.member(jsii_name="resetIfDimension")
    def reset_if_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfDimension", []))

    @jsii.member(jsii_name="resetIfOrientation")
    def reset_if_orientation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfOrientation", []))

    @jsii.member(jsii_name="resetImQuery")
    def reset_im_query(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetImQuery", []))

    @jsii.member(jsii_name="resetMaxColors")
    def reset_max_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxColors", []))

    @jsii.member(jsii_name="resetMirror")
    def reset_mirror(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMirror", []))

    @jsii.member(jsii_name="resetMonoHue")
    def reset_mono_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonoHue", []))

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetRegionOfInterestCrop")
    def reset_region_of_interest_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRegionOfInterestCrop", []))

    @jsii.member(jsii_name="resetRelativeCrop")
    def reset_relative_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRelativeCrop", []))

    @jsii.member(jsii_name="resetRemoveColor")
    def reset_remove_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRemoveColor", []))

    @jsii.member(jsii_name="resetResize")
    def reset_resize(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetResize", []))

    @jsii.member(jsii_name="resetRotate")
    def reset_rotate(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRotate", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetShear")
    def reset_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetShear", []))

    @jsii.member(jsii_name="resetTrim")
    def reset_trim(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTrim", []))

    @jsii.member(jsii_name="resetUnsharpMask")
    def reset_unsharp_mask(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUnsharpMask", []))

    @builtins.property
    @jsii.member(jsii_name="append")
    def append(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultAppendList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultAppendList, jsii.get(self, "append"))

    @builtins.property
    @jsii.member(jsii_name="aspectCrop")
    def aspect_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultAspectCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultAspectCropList, jsii.get(self, "aspectCrop"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColor")
    def background_color(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultBackgroundColorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultBackgroundColorList, jsii.get(self, "backgroundColor"))

    @builtins.property
    @jsii.member(jsii_name="blur")
    def blur(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultBlurList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultBlurList, jsii.get(self, "blur"))

    @builtins.property
    @jsii.member(jsii_name="chromaKey")
    def chroma_key(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultChromaKeyList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultChromaKeyList, jsii.get(self, "chromaKey"))

    @builtins.property
    @jsii.member(jsii_name="composite")
    def composite(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultCompositeList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultCompositeList, jsii.get(self, "composite"))

    @builtins.property
    @jsii.member(jsii_name="compound")
    def compound(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultCompoundList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultCompoundList, jsii.get(self, "compound"))

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultContrastList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultContrastList, jsii.get(self, "contrast"))

    @builtins.property
    @jsii.member(jsii_name="crop")
    def crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultCropList, jsii.get(self, "crop"))

    @builtins.property
    @jsii.member(jsii_name="faceCrop")
    def face_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultFaceCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultFaceCropList, jsii.get(self, "faceCrop"))

    @builtins.property
    @jsii.member(jsii_name="featureCrop")
    def feature_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultFeatureCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultFeatureCropList, jsii.get(self, "featureCrop"))

    @builtins.property
    @jsii.member(jsii_name="fitAndFill")
    def fit_and_fill(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultFitAndFillList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultFitAndFillList, jsii.get(self, "fitAndFill"))

    @builtins.property
    @jsii.member(jsii_name="goop")
    def goop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultGoopList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultGoopList, jsii.get(self, "goop"))

    @builtins.property
    @jsii.member(jsii_name="grayscale")
    def grayscale(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultGrayscaleList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultGrayscaleList, jsii.get(self, "grayscale"))

    @builtins.property
    @jsii.member(jsii_name="hsl")
    def hsl(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultHslList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultHslList, jsii.get(self, "hsl"))

    @builtins.property
    @jsii.member(jsii_name="hsv")
    def hsv(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultHsvList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultHsvList, jsii.get(self, "hsv"))

    @builtins.property
    @jsii.member(jsii_name="ifDimension")
    def if_dimension(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfDimensionList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfDimensionList, jsii.get(self, "ifDimension"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientation")
    def if_orientation(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfOrientationList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfOrientationList, jsii.get(self, "ifOrientation"))

    @builtins.property
    @jsii.member(jsii_name="imQuery")
    def im_query(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultImQueryList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultImQueryList, jsii.get(self, "imQuery"))

    @builtins.property
    @jsii.member(jsii_name="maxColors")
    def max_colors(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultMaxColorsList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultMaxColorsList, jsii.get(self, "maxColors"))

    @builtins.property
    @jsii.member(jsii_name="mirror")
    def mirror(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultMirrorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultMirrorList, jsii.get(self, "mirror"))

    @builtins.property
    @jsii.member(jsii_name="monoHue")
    def mono_hue(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultMonoHueList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultMonoHueList, jsii.get(self, "monoHue"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultOpacityList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultOpacityList, jsii.get(self, "opacity"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestCrop")
    def region_of_interest_crop(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultRegionOfInterestCropList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultRegionOfInterestCropList", jsii.get(self, "regionOfInterestCrop"))

    @builtins.property
    @jsii.member(jsii_name="relativeCrop")
    def relative_crop(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultRelativeCropList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultRelativeCropList", jsii.get(self, "relativeCrop"))

    @builtins.property
    @jsii.member(jsii_name="removeColor")
    def remove_color(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultRemoveColorList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultRemoveColorList", jsii.get(self, "removeColor"))

    @builtins.property
    @jsii.member(jsii_name="resize")
    def resize(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultResizeList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultResizeList", jsii.get(self, "resize"))

    @builtins.property
    @jsii.member(jsii_name="rotate")
    def rotate(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultRotateList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultRotateList", jsii.get(self, "rotate"))

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultScaleList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultScaleList", jsii.get(self, "scale"))

    @builtins.property
    @jsii.member(jsii_name="shear")
    def shear(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultShearList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultShearList", jsii.get(self, "shear"))

    @builtins.property
    @jsii.member(jsii_name="trim")
    def trim(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultTrimList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultTrimList", jsii.get(self, "trim"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMask")
    def unsharp_mask(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultUnsharpMaskList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultUnsharpMaskList", jsii.get(self, "unsharpMask"))

    @builtins.property
    @jsii.member(jsii_name="appendInput")
    def append_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultAppend]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultAppend]]], jsii.get(self, "appendInput"))

    @builtins.property
    @jsii.member(jsii_name="aspectCropInput")
    def aspect_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultAspectCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultAspectCrop]]], jsii.get(self, "aspectCropInput"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColorInput")
    def background_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultBackgroundColor]]], jsii.get(self, "backgroundColorInput"))

    @builtins.property
    @jsii.member(jsii_name="blurInput")
    def blur_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultBlur]]], jsii.get(self, "blurInput"))

    @builtins.property
    @jsii.member(jsii_name="chromaKeyInput")
    def chroma_key_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultChromaKey]]], jsii.get(self, "chromaKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="compositeInput")
    def composite_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultComposite]]], jsii.get(self, "compositeInput"))

    @builtins.property
    @jsii.member(jsii_name="compoundInput")
    def compound_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultCompound]]], jsii.get(self, "compoundInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultContrast]]], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="cropInput")
    def crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultCrop]]], jsii.get(self, "cropInput"))

    @builtins.property
    @jsii.member(jsii_name="faceCropInput")
    def face_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultFaceCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultFaceCrop]]], jsii.get(self, "faceCropInput"))

    @builtins.property
    @jsii.member(jsii_name="featureCropInput")
    def feature_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultFeatureCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultFeatureCrop]]], jsii.get(self, "featureCropInput"))

    @builtins.property
    @jsii.member(jsii_name="fitAndFillInput")
    def fit_and_fill_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultFitAndFill]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultFitAndFill]]], jsii.get(self, "fitAndFillInput"))

    @builtins.property
    @jsii.member(jsii_name="goopInput")
    def goop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultGoop]]], jsii.get(self, "goopInput"))

    @builtins.property
    @jsii.member(jsii_name="grayscaleInput")
    def grayscale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultGrayscale]]], jsii.get(self, "grayscaleInput"))

    @builtins.property
    @jsii.member(jsii_name="hslInput")
    def hsl_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultHsl]]], jsii.get(self, "hslInput"))

    @builtins.property
    @jsii.member(jsii_name="hsvInput")
    def hsv_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultHsv]]], jsii.get(self, "hsvInput"))

    @builtins.property
    @jsii.member(jsii_name="ifDimensionInput")
    def if_dimension_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfDimension]]], jsii.get(self, "ifDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientationInput")
    def if_orientation_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfOrientation]]], jsii.get(self, "ifOrientationInput"))

    @builtins.property
    @jsii.member(jsii_name="imQueryInput")
    def im_query_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultImQuery]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultImQuery]]], jsii.get(self, "imQueryInput"))

    @builtins.property
    @jsii.member(jsii_name="maxColorsInput")
    def max_colors_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultMaxColors]]], jsii.get(self, "maxColorsInput"))

    @builtins.property
    @jsii.member(jsii_name="mirrorInput")
    def mirror_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultMirror]]], jsii.get(self, "mirrorInput"))

    @builtins.property
    @jsii.member(jsii_name="monoHueInput")
    def mono_hue_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultMonoHue]]], jsii.get(self, "monoHueInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultOpacity]]], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestCropInput")
    def region_of_interest_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultRegionOfInterestCrop"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultRegionOfInterestCrop"]]], jsii.get(self, "regionOfInterestCropInput"))

    @builtins.property
    @jsii.member(jsii_name="relativeCropInput")
    def relative_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultRelativeCrop"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultRelativeCrop"]]], jsii.get(self, "relativeCropInput"))

    @builtins.property
    @jsii.member(jsii_name="removeColorInput")
    def remove_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultRemoveColor"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultRemoveColor"]]], jsii.get(self, "removeColorInput"))

    @builtins.property
    @jsii.member(jsii_name="resizeInput")
    def resize_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultResize"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultResize"]]], jsii.get(self, "resizeInput"))

    @builtins.property
    @jsii.member(jsii_name="rotateInput")
    def rotate_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultRotate"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultRotate"]]], jsii.get(self, "rotateInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultScale"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultScale"]]], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="shearInput")
    def shear_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultShear"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultShear"]]], jsii.get(self, "shearInput"))

    @builtins.property
    @jsii.member(jsii_name="trimInput")
    def trim_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultTrim"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultTrim"]]], jsii.get(self, "trimInput"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMaskInput")
    def unsharp_mask_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultUnsharpMask"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultUnsharpMask"]]], jsii.get(self, "unsharpMaskInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c7daabdb81d0c98befed8667feb585be58d7a9eacdc3f95aae7c80c09bb2d5f9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultRegionOfInterestCrop",
    jsii_struct_bases=[],
    name_mapping={
        "region_of_interest": "regionOfInterest",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultRegionOfInterestCrop:
    def __init__(
        self,
        *,
        region_of_interest: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultRegionOfInterestCropRegionOfInterest", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param region_of_interest: region_of_interest block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest DataAkamaiImagingPolicyImage#region_of_interest}
        :param gravity: The placement of the crop area relative to the specified area of interest. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: The placement of the crop area relative to the specified area of interest. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param style: Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(region_of_interest, dict):
            region_of_interest = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultRegionOfInterestCropRegionOfInterest(**region_of_interest)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ea1336be089e28c5d7be9a6e651c812f194c53a5fa76ff83ebfe9ef36a7c066)
            check_type(argname="argument region_of_interest", value=region_of_interest, expected_type=type_hints["region_of_interest"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "region_of_interest": region_of_interest,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def region_of_interest(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultRegionOfInterestCropRegionOfInterest":
        '''region_of_interest block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest DataAkamaiImagingPolicyImage#region_of_interest}
        '''
        result = self._values.get("region_of_interest")
        assert result is not None, "Required property 'region_of_interest' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultRegionOfInterestCropRegionOfInterest", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''The placement of the crop area relative to the specified area of interest.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''The placement of the crop area relative to the specified area of interest.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultRegionOfInterestCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultRegionOfInterestCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultRegionOfInterestCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a5586c5474fd48f825631afc2575b9bc72f2be5ffe1e74c841329e1f16b84084)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultRegionOfInterestCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e80fc6dc66fcbb5323d0d1789c90b301df4a6a81b50e76aaebb05bf3aac49b4d)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultRegionOfInterestCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__119abbe07755287668ae99d788a9c6405f4baa61863fc01fe5e28540cb7fb7ab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cce915765d1aa3c0c6fbe6e07d95a48db2b34e1951a211c1eae7590669a92b1f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6690879ea41c6dc5c982674ea1c1ba10a50c900310242da2d6ad20a66022d7ab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultRegionOfInterestCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultRegionOfInterestCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultRegionOfInterestCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f28e55d3697c94ca9b700ddbee06acf5347a42edeca2aa027bb4d0152a41c1ef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultRegionOfInterestCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultRegionOfInterestCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0d3fe7b34a6b62e474612ebfb3330c8bec1732ca050f1bf526ab9a7be3716b9e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putRegionOfInterest")
    def put_region_of_interest(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultRegionOfInterestCropRegionOfInterest()

        return typing.cast(None, jsii.invoke(self, "putRegionOfInterest", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterest")
    def region_of_interest(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultRegionOfInterestCropRegionOfInterestOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultRegionOfInterestCropRegionOfInterestOutputReference", jsii.get(self, "regionOfInterest"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestInput")
    def region_of_interest_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultRegionOfInterestCropRegionOfInterest"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultRegionOfInterestCropRegionOfInterest"], jsii.get(self, "regionOfInterestInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9b56c6b4d9e026439039ea61e98f09fea4a0dd81b2641e911e5fe532692eea57)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7b3801e667d68308955eb6e41fff7da8110c6c72500fed4818bd443797e1e860)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c5b314ec64cf3cd5a47f6588644f410898da8155be0340c1e81be3b36a9bef18)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__93a9c11c0a2d272ca42e2e0bcc437b571a007a20de07c3c0e45bcfb0e3591105)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d1e5fd95916eac3d70765af629a3cd274098d9f3e7768d5549e81a02a46143f1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3e44a95ded625a4c1cf4c3109c7e99ea9f10e62f4f5d0627979681d3988218a1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c72a31ea541e2fb107ecfc9412891b12e32a04ba6aafb0922e9d47796f482a0b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8d45733f35c35c84a8f4ff0b678fd21575c60ac2a11b5dd14cef92256af91fda)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultRegionOfInterestCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultRegionOfInterestCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultRegionOfInterestCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f47c13da72b5785f1c93fa375c935fb1a2f7e9fca9efcc817b78b733815315d9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultRegionOfInterestCropRegionOfInterest",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultRegionOfInterestCropRegionOfInterest:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultRegionOfInterestCropRegionOfInterest(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultRegionOfInterestCropRegionOfInterestOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultRegionOfInterestCropRegionOfInterestOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3e75b2ccf3fd7e5f05ad76ecf15193fe52096fb06f0bdf37525ecda2144a97d2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultRegionOfInterestCropRegionOfInterest]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultRegionOfInterestCropRegionOfInterest], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultRegionOfInterestCropRegionOfInterest],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d256a5e04d4bc6edc89c57cfa7b392fdc9032e884e92944cd3176b76d061227e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultRelativeCrop",
    jsii_struct_bases=[],
    name_mapping={
        "east": "east",
        "east_var": "eastVar",
        "north": "north",
        "north_var": "northVar",
        "south": "south",
        "south_var": "southVar",
        "west": "west",
        "west_var": "westVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultRelativeCrop:
    def __init__(
        self,
        *,
        east: typing.Optional[builtins.str] = None,
        east_var: typing.Optional[builtins.str] = None,
        north: typing.Optional[builtins.str] = None,
        north_var: typing.Optional[builtins.str] = None,
        south: typing.Optional[builtins.str] = None,
        south_var: typing.Optional[builtins.str] = None,
        west: typing.Optional[builtins.str] = None,
        west_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param east: The number of pixels to shrink or expand the right side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east DataAkamaiImagingPolicyImage#east}
        :param east_var: The number of pixels to shrink or expand the right side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east_var DataAkamaiImagingPolicyImage#east_var}
        :param north: The number of pixels to shrink or expand the top side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north DataAkamaiImagingPolicyImage#north}
        :param north_var: The number of pixels to shrink or expand the top side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north_var DataAkamaiImagingPolicyImage#north_var}
        :param south: The number of pixels to shrink or expand the bottom side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south DataAkamaiImagingPolicyImage#south}
        :param south_var: The number of pixels to shrink or expand the bottom side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south_var DataAkamaiImagingPolicyImage#south_var}
        :param west: The number of pixels to shrink or expand the left side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west DataAkamaiImagingPolicyImage#west}
        :param west_var: The number of pixels to shrink or expand the left side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west_var DataAkamaiImagingPolicyImage#west_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e483af8ef16ef9af67fb0b5220865d8486d56a4e2dbd0d56914a198625b92810)
            check_type(argname="argument east", value=east, expected_type=type_hints["east"])
            check_type(argname="argument east_var", value=east_var, expected_type=type_hints["east_var"])
            check_type(argname="argument north", value=north, expected_type=type_hints["north"])
            check_type(argname="argument north_var", value=north_var, expected_type=type_hints["north_var"])
            check_type(argname="argument south", value=south, expected_type=type_hints["south"])
            check_type(argname="argument south_var", value=south_var, expected_type=type_hints["south_var"])
            check_type(argname="argument west", value=west, expected_type=type_hints["west"])
            check_type(argname="argument west_var", value=west_var, expected_type=type_hints["west_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if east is not None:
            self._values["east"] = east
        if east_var is not None:
            self._values["east_var"] = east_var
        if north is not None:
            self._values["north"] = north
        if north_var is not None:
            self._values["north_var"] = north_var
        if south is not None:
            self._values["south"] = south
        if south_var is not None:
            self._values["south_var"] = south_var
        if west is not None:
            self._values["west"] = west
        if west_var is not None:
            self._values["west_var"] = west_var

    @builtins.property
    def east(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the right side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east DataAkamaiImagingPolicyImage#east}
        '''
        result = self._values.get("east")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def east_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the right side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east_var DataAkamaiImagingPolicyImage#east_var}
        '''
        result = self._values.get("east_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def north(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the top side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north DataAkamaiImagingPolicyImage#north}
        '''
        result = self._values.get("north")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def north_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the top side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north_var DataAkamaiImagingPolicyImage#north_var}
        '''
        result = self._values.get("north_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def south(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the bottom side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south DataAkamaiImagingPolicyImage#south}
        '''
        result = self._values.get("south")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def south_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the bottom side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south_var DataAkamaiImagingPolicyImage#south_var}
        '''
        result = self._values.get("south_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def west(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the left side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west DataAkamaiImagingPolicyImage#west}
        '''
        result = self._values.get("west")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def west_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the left side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west_var DataAkamaiImagingPolicyImage#west_var}
        '''
        result = self._values.get("west_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultRelativeCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultRelativeCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultRelativeCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5dc968c6bc3ac107186edd72ae07b5998e043c62e1db0c914f55780317a1cebd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultRelativeCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__971235e4072d374e603e7b3280585dd7dfaff44e29bda0a9e4855dacaf7fb9e3)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultRelativeCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__67572d87eb31b493df0b83d3988dc86df0bc75737c1cda75511873cf0ffda820)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__754de9d806ae531a648e1cc4f9995e014ace4fa85e247ff42f2616b9417774fd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a9b1aa839982c47eeb9cd0b2ce8d874c4d789ba10db5c9d32bc8e6e81610c44)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultRelativeCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultRelativeCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultRelativeCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5e8bc10ab77a8187c870a9b45fb7c291d29d8549576c1a4a944dd5fca3fcd1ec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultRelativeCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultRelativeCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a60c224c3df5bac8fbe60faec4ebb0218a5af060d41a672782994c3a9b72d9ef)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetEast")
    def reset_east(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEast", []))

    @jsii.member(jsii_name="resetEastVar")
    def reset_east_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEastVar", []))

    @jsii.member(jsii_name="resetNorth")
    def reset_north(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNorth", []))

    @jsii.member(jsii_name="resetNorthVar")
    def reset_north_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNorthVar", []))

    @jsii.member(jsii_name="resetSouth")
    def reset_south(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSouth", []))

    @jsii.member(jsii_name="resetSouthVar")
    def reset_south_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSouthVar", []))

    @jsii.member(jsii_name="resetWest")
    def reset_west(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWest", []))

    @jsii.member(jsii_name="resetWestVar")
    def reset_west_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWestVar", []))

    @builtins.property
    @jsii.member(jsii_name="eastInput")
    def east_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "eastInput"))

    @builtins.property
    @jsii.member(jsii_name="eastVarInput")
    def east_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "eastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="northInput")
    def north_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "northInput"))

    @builtins.property
    @jsii.member(jsii_name="northVarInput")
    def north_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "northVarInput"))

    @builtins.property
    @jsii.member(jsii_name="southInput")
    def south_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "southInput"))

    @builtins.property
    @jsii.member(jsii_name="southVarInput")
    def south_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "southVarInput"))

    @builtins.property
    @jsii.member(jsii_name="westInput")
    def west_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "westInput"))

    @builtins.property
    @jsii.member(jsii_name="westVarInput")
    def west_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "westVarInput"))

    @builtins.property
    @jsii.member(jsii_name="east")
    def east(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "east"))

    @east.setter
    def east(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fabac393777681c6ff5a9940cbe12262f6ea25d197da19b0f3f7f452a682a333)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "east", value)

    @builtins.property
    @jsii.member(jsii_name="eastVar")
    def east_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "eastVar"))

    @east_var.setter
    def east_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fee730ce497ac2186c0f46e530400ddedd1165d5006306fe6dcd14bd67bb86ca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "eastVar", value)

    @builtins.property
    @jsii.member(jsii_name="north")
    def north(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "north"))

    @north.setter
    def north(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2f008a0c596750d22d2681a59e779eeed69cd9b6fc58e233b6b26ddd1620d0e5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "north", value)

    @builtins.property
    @jsii.member(jsii_name="northVar")
    def north_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "northVar"))

    @north_var.setter
    def north_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9650181642a9034f4a1e65e3b3458d981de1f72a977a451287702d17fb2eab96)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "northVar", value)

    @builtins.property
    @jsii.member(jsii_name="south")
    def south(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "south"))

    @south.setter
    def south(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c417837adfb1712f34169bf52f61e667c095ab5c6e1e05193be0ffd7577a773b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "south", value)

    @builtins.property
    @jsii.member(jsii_name="southVar")
    def south_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "southVar"))

    @south_var.setter
    def south_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d11c9324fb5d2b615963a1dcaf83023197fffa03ffbdfbe130b3bcbe513fd06)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "southVar", value)

    @builtins.property
    @jsii.member(jsii_name="west")
    def west(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "west"))

    @west.setter
    def west(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b268dc4d0d3b27cc018d6ddd0380ae3edc8807a19d939416a99b5c0bd53bd866)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "west", value)

    @builtins.property
    @jsii.member(jsii_name="westVar")
    def west_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "westVar"))

    @west_var.setter
    def west_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__36d524974c759922449d15b902cc55c6645dd69f4de30607d4a391f11ea85b4c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "westVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultRelativeCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultRelativeCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultRelativeCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0110a5dc2bc6d85cab68f12fdc6c1f7574c121caa706f909f5249ebdfd15589f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultRemoveColor",
    jsii_struct_bases=[],
    name_mapping={
        "color": "color",
        "color_var": "colorVar",
        "feather": "feather",
        "feather_var": "featherVar",
        "tolerance": "tolerance",
        "tolerance_var": "toleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultRemoveColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
        feather: typing.Optional[builtins.str] = None,
        feather_var: typing.Optional[builtins.str] = None,
        tolerance: typing.Optional[builtins.str] = None,
        tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        :param feather: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        :param feather_var: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        :param tolerance: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        :param tolerance_var: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f218bca3e60ac91dd3514ec3e367ea5f3e18b33ef189a41a43d5f91cc8c11cfc)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
            check_type(argname="argument feather", value=feather, expected_type=type_hints["feather"])
            check_type(argname="argument feather_var", value=feather_var, expected_type=type_hints["feather_var"])
            check_type(argname="argument tolerance", value=tolerance, expected_type=type_hints["tolerance"])
            check_type(argname="argument tolerance_var", value=tolerance_var, expected_type=type_hints["tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var
        if feather is not None:
            self._values["feather"] = feather
        if feather_var is not None:
            self._values["feather_var"] = feather_var
        if tolerance is not None:
            self._values["tolerance"] = tolerance
        if tolerance_var is not None:
            self._values["tolerance_var"] = tolerance_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        '''
        result = self._values.get("feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather_var(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        '''
        result = self._values.get("feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        '''
        result = self._values.get("tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance_var(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        result = self._values.get("tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultRemoveColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultRemoveColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultRemoveColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a0249dd9f197e2cd8868fdc3b2ac0375e6385c87d525446bbf0e1c7c1b8d97c0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultRemoveColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fd5a1f472ea4cf54d8182f652575a13f0331752b4c9c9335be71c14d221e5576)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultRemoveColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6d1543d789ea3c2e21643facd95608851663d34a6836f88f29cf8448faa36023)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6430e8fe1294b62f339048123593e9506db755f92866e71dca36284f3e04c4f9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__08c2454123b3f0b910e6774c17d39eaaa4ce25711cfc558eaad95dd87b135e21)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultRemoveColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultRemoveColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultRemoveColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__37fba9e71c08278b9f2247efc9357ac178e5e8296ea332b60415eaf474851833)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultRemoveColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultRemoveColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e3b4ae2db202fbec15d8be45599efae85912efcbacd2307c729802b43b6bccde)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @jsii.member(jsii_name="resetFeather")
    def reset_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeather", []))

    @jsii.member(jsii_name="resetFeatherVar")
    def reset_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatherVar", []))

    @jsii.member(jsii_name="resetTolerance")
    def reset_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTolerance", []))

    @jsii.member(jsii_name="resetToleranceVar")
    def reset_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featherInput")
    def feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherInput"))

    @builtins.property
    @jsii.member(jsii_name="featherVarInput")
    def feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceInput")
    def tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceVarInput")
    def tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d99ed0321f279de6ff92be53e2628dcfe26b57b657423979bc2bf1be11fd64dd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c4409bca9e0b2651f976b7f1810b3b37dc377b7680a9b24a8bd9b37be1384d1b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="feather")
    def feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "feather"))

    @feather.setter
    def feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab0e9f251a2dd4277aaf3e684e639f6d830c9963e818bbfca79ff266592fc747)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "feather", value)

    @builtins.property
    @jsii.member(jsii_name="featherVar")
    def feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featherVar"))

    @feather_var.setter
    def feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__470be7b5f0e687c1d4d937ef74ca32caa0684d993908cea04779f0b12e28c1a9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featherVar", value)

    @builtins.property
    @jsii.member(jsii_name="tolerance")
    def tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tolerance"))

    @tolerance.setter
    def tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__26186ad1b3d94140429321af7740d8b362e26aaed657222da04ecef2c0c588b2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tolerance", value)

    @builtins.property
    @jsii.member(jsii_name="toleranceVar")
    def tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "toleranceVar"))

    @tolerance_var.setter
    def tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__41fd0b167b287c864d6d9962efb4ed4ddc19af2dbea42c16dafb2ec3ffe0336f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "toleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultRemoveColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultRemoveColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultRemoveColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__73eb660b914914886bded7b73b22f8012e0a0d42df2988707f4d1ea049103c28)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultResize",
    jsii_struct_bases=[],
    name_mapping={
        "aspect": "aspect",
        "aspect_var": "aspectVar",
        "height": "height",
        "height_var": "heightVar",
        "type": "type",
        "type_var": "typeVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultResize:
    def __init__(
        self,
        *,
        aspect: typing.Optional[builtins.str] = None,
        aspect_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param aspect: Preserves the aspect ratio. Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect DataAkamaiImagingPolicyImage#aspect}
        :param aspect_var: Preserves the aspect ratio. Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_var DataAkamaiImagingPolicyImage#aspect_var}
        :param height: The height to resize the source image to. Must be set if height is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height to resize the source image to. Must be set if height is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param type: Sets constraints for the image resize. Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: Sets constraints for the image resize. Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        :param width: The width to resize the source image to. Must be set if width is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width to resize the source image to. Must be set if width is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d4b90baa36d6027d7ca0b51152e199ba53b29ee03b51b5c5321cef00e771c0e3)
            check_type(argname="argument aspect", value=aspect, expected_type=type_hints["aspect"])
            check_type(argname="argument aspect_var", value=aspect_var, expected_type=type_hints["aspect_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if aspect is not None:
            self._values["aspect"] = aspect
        if aspect_var is not None:
            self._values["aspect_var"] = aspect_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def aspect(self) -> typing.Optional[builtins.str]:
        '''Preserves the aspect ratio.

        Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect DataAkamaiImagingPolicyImage#aspect}
        '''
        result = self._values.get("aspect")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def aspect_var(self) -> typing.Optional[builtins.str]:
        '''Preserves the aspect ratio.

        Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_var DataAkamaiImagingPolicyImage#aspect_var}
        '''
        result = self._values.get("aspect_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height to resize the source image to. Must be set if height is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height to resize the source image to. Must be set if height is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''Sets constraints for the image resize.

        Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''Sets constraints for the image resize.

        Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width to resize the source image to. Must be set if width is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width to resize the source image to. Must be set if width is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultResize(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultResizeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultResizeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b643b3764ad60708d349ca7311b8c46514166c5fc11b6d15d3470a315e698ef1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultResizeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6db8eb3c01c3de1d82ae955b2f48a63d424de98880ff387767794c08f6d4ae92)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultResizeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c30a16f4b7a1c48799f3d1aba27c803bea96e3f6cf202011efaaf342f767a5a6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__25bf3a386297f69c887cefde3a867d68cf10fcf65cb2bef45e5fb510b5cf736f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ada9cab0ec45f650a03f10075af9ceb54e1a60e79db916fd3e1edeefe117f29)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultResize]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultResize]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultResize]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__572cafc541cd468fbf311347c67763ce96e0a9766e56aaf7d7d3e27dd22527fb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultResizeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultResizeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__35aab3ebad4ef34662e7c6775f446d57b1f9961e65c816422abc151ca6e17a12)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAspect")
    def reset_aspect(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspect", []))

    @jsii.member(jsii_name="resetAspectVar")
    def reset_aspect_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspectVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="aspectInput")
    def aspect_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "aspectInput"))

    @builtins.property
    @jsii.member(jsii_name="aspectVarInput")
    def aspect_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "aspectVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="aspect")
    def aspect(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "aspect"))

    @aspect.setter
    def aspect(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5c17d966dda2b4ed2b403ca238068bf8121f5642190320a16ef8dcb908f5c95b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "aspect", value)

    @builtins.property
    @jsii.member(jsii_name="aspectVar")
    def aspect_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "aspectVar"))

    @aspect_var.setter
    def aspect_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c56acadd9200429e812dd1e45e70641c79f179d609c69cc1ee50aa7f1a7a1733)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "aspectVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e554658911cd8f45b8763813f5cabe3493b94ad71409a9f16cc6e5414d4186a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4f854450b40a3c69daac71985d698f6a51db11864ae13fcc2dad24d7261b5fa4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3de2e34cfcd871c7cef82237866c61dd81809c634b2a4f3364c68025c524d1fc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__063aa9603d7d1a2c1bfaa219268a8015940c8cc026d891f71b65f0f708e75360)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__464c5bf4e66b0ed23f5d3c07a3de80b81444d3d32e6482fdbe8808a05a884e17)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__58fc9496909bc278a82e9505f497ee4dd7c99e356dbc3478a587d2eae75f5155)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultResize]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultResize]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultResize]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2516f3081de17f8940c20bc67af72f9d0dda7520bd39f77d736b4114724fbe22)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultRotate",
    jsii_struct_bases=[],
    name_mapping={"degrees": "degrees", "degrees_var": "degreesVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultRotate:
    def __init__(
        self,
        *,
        degrees: typing.Optional[builtins.str] = None,
        degrees_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param degrees: The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees DataAkamaiImagingPolicyImage#degrees}
        :param degrees_var: The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees_var DataAkamaiImagingPolicyImage#degrees_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e2c57674ecc25d4d716e62482209bf6dc34de45ebaaf8494f8033d3046fa2ff4)
            check_type(argname="argument degrees", value=degrees, expected_type=type_hints["degrees"])
            check_type(argname="argument degrees_var", value=degrees_var, expected_type=type_hints["degrees_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if degrees is not None:
            self._values["degrees"] = degrees
        if degrees_var is not None:
            self._values["degrees_var"] = degrees_var

    @builtins.property
    def degrees(self) -> typing.Optional[builtins.str]:
        '''The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees DataAkamaiImagingPolicyImage#degrees}
        '''
        result = self._values.get("degrees")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def degrees_var(self) -> typing.Optional[builtins.str]:
        '''The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees_var DataAkamaiImagingPolicyImage#degrees_var}
        '''
        result = self._values.get("degrees_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultRotate(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultRotateList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultRotateList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__72761fd8e927dd27c7b81227812a3a94764487768548ad56faf6ac15d3c39c8c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultRotateOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__66591677e7660d88f9d491082206f64145b11a44be8ae5705c518e8b45961217)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultRotateOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e29dccad24d3365e57a39c0d181e7fa1aa2d5fe5c78b5a2b13c55e74c83459f9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__355eb5c150e741ad761cfb5ad0af5e06458a0852783b5632c6a31f39cf0d8a54)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__56bc60e65934ab0af9350e1b73e58063363544c6128c8828d78ff3ed5f55755c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultRotate]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultRotate]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultRotate]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af511c51280dc43d0d463a59640476b96edf000530790ada82ee2a7ead1aaa2f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultRotateOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultRotateOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__774f6318846ace03c3ad9341a8a05df09133019343d77a22a201721ce53b97a4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetDegrees")
    def reset_degrees(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDegrees", []))

    @jsii.member(jsii_name="resetDegreesVar")
    def reset_degrees_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDegreesVar", []))

    @builtins.property
    @jsii.member(jsii_name="degreesInput")
    def degrees_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "degreesInput"))

    @builtins.property
    @jsii.member(jsii_name="degreesVarInput")
    def degrees_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "degreesVarInput"))

    @builtins.property
    @jsii.member(jsii_name="degrees")
    def degrees(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "degrees"))

    @degrees.setter
    def degrees(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8999336ddc3396c1a01db0072ae2348646ab57a9f0f2698eccf7d5b0e57b1dd1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "degrees", value)

    @builtins.property
    @jsii.member(jsii_name="degreesVar")
    def degrees_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "degreesVar"))

    @degrees_var.setter
    def degrees_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cfce4b04a5232d38feb4bf3e61bfcb9176f889cdf8285adf03b5a7cbb48818c0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "degreesVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultRotate]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultRotate]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultRotate]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__126cb78bb8db7e92167d3d188c0b24574e3e49fa8d0280c50e718a5673ed0ce1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultScale",
    jsii_struct_bases=[],
    name_mapping={
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultScale:
    def __init__(
        self,
        *,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param height: Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged. Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged. Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f0c7ea40fdc315e996f45481392f491e4c3971492cf006b1920931e078c04fa)
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size.

        Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size.

        Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged.

        Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged.

        Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultScale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultScaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultScaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6a55c707e52a591c56b377b2d42df7d4a61292194188aea44650656237573d52)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultScaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__013244632f0d9e3e25f2951804724dc18e3ac37540bd83c1fafe05a74f1d15b9)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultScaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c994777fa606e91d64cf9a68ea142e847a0c2178a7814e1a42643be766be5ceb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a0d3f457e7049e592adea2c806de7785d4760ad76028c3eb195503eba47ed8d2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0fb8e98f227912a0b8a65d6b12820fda73272dee71fcb4c54ef6479e1afefaae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultScale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultScale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultScale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__096b7affaa8bd0c2fb0def8543e2535bdb1ebb9f80f8651cc19d46005cb5c033)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultScaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultScaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b7531277527921c420d221547b021b8c6a475978f49b56b74ac99e72e3b59a4e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aace9291f497d110f9bbd9017720502e19da67c9f1e879f1d8a79166fff6dc21)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__60918896a6b69a110c37b5d7b8b4223772f4f4b8f0177d2c247680c99541e0c6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dd08c6d3366d8273225704de6794403d4e3dd56033af569b060846ff00cbdac9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2fb3d4367bced4d29d7439ebed5d31e917bb121b303029ba7024bdc1ba77b894)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultScale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultScale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultScale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c20867f0b2615ea756e99480705cda32f561464a6d5c7f88f0805361dafc2445)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultShear",
    jsii_struct_bases=[],
    name_mapping={
        "x_shear": "xShear",
        "x_shear_var": "xShearVar",
        "y_shear": "yShear",
        "y_shear_var": "yShearVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultShear:
    def __init__(
        self,
        *,
        x_shear: typing.Optional[builtins.str] = None,
        x_shear_var: typing.Optional[builtins.str] = None,
        y_shear: typing.Optional[builtins.str] = None,
        y_shear_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param x_shear: The amount to shear along the x-axis, measured in multiples of the image's width. Must be set if yShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear DataAkamaiImagingPolicyImage#x_shear}
        :param x_shear_var: The amount to shear along the x-axis, measured in multiples of the image's width. Must be set if yShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear_var DataAkamaiImagingPolicyImage#x_shear_var}
        :param y_shear: The amount to shear along the y-axis, measured in multiples of the image's height. Must be set if xShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear DataAkamaiImagingPolicyImage#y_shear}
        :param y_shear_var: The amount to shear along the y-axis, measured in multiples of the image's height. Must be set if xShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear_var DataAkamaiImagingPolicyImage#y_shear_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4adf6472b72eabf1f6c7c26f12168ba68d6db438eec0024381b1f8820ff434a7)
            check_type(argname="argument x_shear", value=x_shear, expected_type=type_hints["x_shear"])
            check_type(argname="argument x_shear_var", value=x_shear_var, expected_type=type_hints["x_shear_var"])
            check_type(argname="argument y_shear", value=y_shear, expected_type=type_hints["y_shear"])
            check_type(argname="argument y_shear_var", value=y_shear_var, expected_type=type_hints["y_shear_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if x_shear is not None:
            self._values["x_shear"] = x_shear
        if x_shear_var is not None:
            self._values["x_shear_var"] = x_shear_var
        if y_shear is not None:
            self._values["y_shear"] = y_shear
        if y_shear_var is not None:
            self._values["y_shear_var"] = y_shear_var

    @builtins.property
    def x_shear(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the x-axis, measured in multiples of the image's width.

        Must be set if yShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear DataAkamaiImagingPolicyImage#x_shear}
        '''
        result = self._values.get("x_shear")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_shear_var(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the x-axis, measured in multiples of the image's width.

        Must be set if yShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear_var DataAkamaiImagingPolicyImage#x_shear_var}
        '''
        result = self._values.get("x_shear_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_shear(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the y-axis, measured in multiples of the image's height.

        Must be set if xShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear DataAkamaiImagingPolicyImage#y_shear}
        '''
        result = self._values.get("y_shear")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_shear_var(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the y-axis, measured in multiples of the image's height.

        Must be set if xShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear_var DataAkamaiImagingPolicyImage#y_shear_var}
        '''
        result = self._values.get("y_shear_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultShear(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultShearList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultShearList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__74777d14acbdf075d5e0753a7fbc18f31f44ff38513c2546bbd0280cf08dff80)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultShearOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__540479051de744c4785fe818218998e2a2583bdb95c9116819e94021af62e7a7)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultShearOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f1dd134ed052bcd3b85293088f85b4ff374f07cf29dad9b064bd3c2c0428ef3d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a8240fecfc206fbfb51cf178992444fcbea541cc0b805480c9ccd42cb3b9f884)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a0305496290df2310572626a2ddd0902bedbe70d691e2cb7c8bf9c8d04e11163)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultShear]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultShear]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultShear]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__11ed73dfde69973ba6fb0d34a41587abc292e4624edb1f341fb196fa7598f31e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultShearOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultShearOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9c6a0a70cecbed79dffbe672ca908c880a81241c5cbf712630eccd673d6637a7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetXShear")
    def reset_x_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXShear", []))

    @jsii.member(jsii_name="resetXShearVar")
    def reset_x_shear_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXShearVar", []))

    @jsii.member(jsii_name="resetYShear")
    def reset_y_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYShear", []))

    @jsii.member(jsii_name="resetYShearVar")
    def reset_y_shear_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYShearVar", []))

    @builtins.property
    @jsii.member(jsii_name="xShearInput")
    def x_shear_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xShearInput"))

    @builtins.property
    @jsii.member(jsii_name="xShearVarInput")
    def x_shear_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xShearVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yShearInput")
    def y_shear_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yShearInput"))

    @builtins.property
    @jsii.member(jsii_name="yShearVarInput")
    def y_shear_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yShearVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xShear")
    def x_shear(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xShear"))

    @x_shear.setter
    def x_shear(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__416af7b260eb9a8938b8e31a1cb0a73fadb9460e0a8d290715027ca1856c8020)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xShear", value)

    @builtins.property
    @jsii.member(jsii_name="xShearVar")
    def x_shear_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xShearVar"))

    @x_shear_var.setter
    def x_shear_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aa83ca970f5309758a0bebf3bb9b03a5b57a14e9afb78ff2056ffc9f0b6344f8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xShearVar", value)

    @builtins.property
    @jsii.member(jsii_name="yShear")
    def y_shear(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yShear"))

    @y_shear.setter
    def y_shear(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c46156101422216f0191b6fe2a4652060b82abe85c07136c1aa364c870346e6c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yShear", value)

    @builtins.property
    @jsii.member(jsii_name="yShearVar")
    def y_shear_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yShearVar"))

    @y_shear_var.setter
    def y_shear_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5328b2e3097a72db5507e57d063e546c47fd8e1cf186dcacf535cf452b270691)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yShearVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultShear]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultShear]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultShear]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__67851ee42126eeee92540323a0cff4d4970fde5076485f81dcd4d5b4aa0a6b44)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultTrim",
    jsii_struct_bases=[],
    name_mapping={
        "fuzz": "fuzz",
        "fuzz_var": "fuzzVar",
        "padding": "padding",
        "padding_var": "paddingVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultTrim:
    def __init__(
        self,
        *,
        fuzz: typing.Optional[builtins.str] = None,
        fuzz_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fuzz: The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz DataAkamaiImagingPolicyImage#fuzz}
        :param fuzz_var: The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz_var DataAkamaiImagingPolicyImage#fuzz_var}
        :param padding: The amount of padding in pixels to add to the trimmed image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: The amount of padding in pixels to add to the trimmed image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f4a6133167caee8408e0bd5891c2339af426e9a23564ce0ac2d4ac99129ff1f1)
            check_type(argname="argument fuzz", value=fuzz, expected_type=type_hints["fuzz"])
            check_type(argname="argument fuzz_var", value=fuzz_var, expected_type=type_hints["fuzz_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fuzz is not None:
            self._values["fuzz"] = fuzz
        if fuzz_var is not None:
            self._values["fuzz_var"] = fuzz_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var

    @builtins.property
    def fuzz(self) -> typing.Optional[builtins.str]:
        '''The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz DataAkamaiImagingPolicyImage#fuzz}
        '''
        result = self._values.get("fuzz")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fuzz_var(self) -> typing.Optional[builtins.str]:
        '''The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz_var DataAkamaiImagingPolicyImage#fuzz_var}
        '''
        result = self._values.get("fuzz_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''The amount of padding in pixels to add to the trimmed image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''The amount of padding in pixels to add to the trimmed image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultTrim(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultTrimList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultTrimList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab28d81ccf3c38f2d46d6a8db74ca449fbd451329bc340aa9be1724cf76c43fa)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultTrimOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__35220359ca7c539d49e685a4d51cfd76d73dcac908bb0bb1ee755b2139d32b07)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultTrimOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__72935a8bbf3b964fe4f48f2dcc8ea8f0a2c52831a0e4973c3a5749abfe50b050)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__67d5ecb383ef354bd76debd45fbeb983cc93d2f52a36dee8678f4735c37accd4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__11053855276e5fac9beb2bb80bbfee5458edfd27796a6f29831a6bba5cba5470)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultTrim]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultTrim]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultTrim]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__39030537a660979aa6b2ec5b83586b004440c47a514e226747adcd068879beb0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultTrimOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultTrimOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1fad9cbabf7efac98ed7d383c8bbb8eb0a8fdc39147915c6b7bc58e1b6705e8b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetFuzz")
    def reset_fuzz(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFuzz", []))

    @jsii.member(jsii_name="resetFuzzVar")
    def reset_fuzz_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFuzzVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @builtins.property
    @jsii.member(jsii_name="fuzzInput")
    def fuzz_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fuzzInput"))

    @builtins.property
    @jsii.member(jsii_name="fuzzVarInput")
    def fuzz_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fuzzVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="fuzz")
    def fuzz(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fuzz"))

    @fuzz.setter
    def fuzz(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f0fa766a8d3e7748b34a793d97ff7007cd3ff1244f37806b3cc5c8e46e6931be)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fuzz", value)

    @builtins.property
    @jsii.member(jsii_name="fuzzVar")
    def fuzz_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fuzzVar"))

    @fuzz_var.setter
    def fuzz_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e171a4d2982c1cac96e4bfa7f2cbced028a93f0bb6bebe7355f673c58af2f583)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fuzzVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__46bdfc5b97f480d9f66f9076c2b157fb2d9c846b2d678fe6db204fffcdbd3492)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6d70ac0dbbb93a204dafc19df8fcdd3838e5d49ddcdb344dcba694ba76f6ec27)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultTrim]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultTrim]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultTrim]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d823fd892ffcae880fb2f2d73e40d55dba8d3892392baec6573d7fbf2e859e8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultUnsharpMask",
    jsii_struct_bases=[],
    name_mapping={
        "gain": "gain",
        "gain_var": "gainVar",
        "sigma": "sigma",
        "sigma_var": "sigmaVar",
        "threshold": "threshold",
        "threshold_var": "thresholdVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultUnsharpMask:
    def __init__(
        self,
        *,
        gain: typing.Optional[builtins.str] = None,
        gain_var: typing.Optional[builtins.str] = None,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
        threshold: typing.Optional[builtins.str] = None,
        threshold_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param gain: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        :param gain_var: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        :param sigma: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        :param threshold: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        :param threshold_var: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df21951b6e81c85178b83755bc183050a91b1cd6b3c6d50b3e5caa517a184826)
            check_type(argname="argument gain", value=gain, expected_type=type_hints["gain"])
            check_type(argname="argument gain_var", value=gain_var, expected_type=type_hints["gain_var"])
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
            check_type(argname="argument threshold", value=threshold, expected_type=type_hints["threshold"])
            check_type(argname="argument threshold_var", value=threshold_var, expected_type=type_hints["threshold_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if gain is not None:
            self._values["gain"] = gain
        if gain_var is not None:
            self._values["gain_var"] = gain_var
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var
        if threshold is not None:
            self._values["threshold"] = threshold
        if threshold_var is not None:
            self._values["threshold_var"] = threshold_var

    @builtins.property
    def gain(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        '''
        result = self._values.get("gain")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gain_var(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        '''
        result = self._values.get("gain_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        '''
        result = self._values.get("threshold")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold_var(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        result = self._values.get("threshold_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultUnsharpMask(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultUnsharpMaskList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultUnsharpMaskList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__44122011b67f8a07717655292ea998e0039ce3fb7d5f2ebdc0d2c5f5a3b5f401)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultUnsharpMaskOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8e258222bb76181b95379811c853799dc092104f5d3efd05171383e67fc01eeb)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultUnsharpMaskOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4fbeee5d2fc7e43581f11d2547909eb852c52078dde8ba48242cadac63d147a8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fd3184113f5a612e108d2dc458f77e75bf80365a165ba6f508256013f269cab0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e2bf33cf56b631aa00a8dceb90dcceee6d248ff7b75f7e03f58b7949ba52e96d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultUnsharpMask]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultUnsharpMask]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultUnsharpMask]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__111fc052ac170804cd47b5505f65b60e54a9f8e24fbb79bb97c747cf3c3fb193)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultUnsharpMaskOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultUnsharpMaskOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ca0afd02ade0a63bb77fda3be0a0cc99f9f0d1692dc638e08ec8dfd59e60cf7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetGain")
    def reset_gain(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGain", []))

    @jsii.member(jsii_name="resetGainVar")
    def reset_gain_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGainVar", []))

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @jsii.member(jsii_name="resetThreshold")
    def reset_threshold(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThreshold", []))

    @jsii.member(jsii_name="resetThresholdVar")
    def reset_threshold_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThresholdVar", []))

    @builtins.property
    @jsii.member(jsii_name="gainInput")
    def gain_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainInput"))

    @builtins.property
    @jsii.member(jsii_name="gainVarInput")
    def gain_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdInput")
    def threshold_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdVarInput")
    def threshold_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gain")
    def gain(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gain"))

    @gain.setter
    def gain(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f1c067af8b9b3570939105a51a960907451293f68273de4d4f3e878e77c8b904)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gain", value)

    @builtins.property
    @jsii.member(jsii_name="gainVar")
    def gain_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gainVar"))

    @gain_var.setter
    def gain_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5fcf9ef75e6bf03c45631cddeec6881ebbc5f62881ce266323f7fd34fadcab84)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gainVar", value)

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d3005cd651971facb34b1530eed498213683252040b86e7fd609b6b68250fa33)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eb741df8b50f5173ca12d16426d0a46815a81f23f85bdf7890604b0361b2656a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="threshold")
    def threshold(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "threshold"))

    @threshold.setter
    def threshold(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__37a8a139c62c5cdb584f2599d0c3ba5aaa365ed32b00ab0c5dc5f9199bde0673)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "threshold", value)

    @builtins.property
    @jsii.member(jsii_name="thresholdVar")
    def threshold_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "thresholdVar"))

    @threshold_var.setter
    def threshold_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8866f66eedf45b7ee7befbf4d370f127a13994e57cffce1e4ac825967e1ecd43)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "thresholdVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultUnsharpMask]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultUnsharpMask]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultUnsharpMask]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ff15a77c0f723637cde05ba7b03e58df7c0463d85f3e4232b38b5049ec6eb061)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqual",
    jsii_struct_bases=[],
    name_mapping={
        "append": "append",
        "aspect_crop": "aspectCrop",
        "background_color": "backgroundColor",
        "blur": "blur",
        "chroma_key": "chromaKey",
        "composite": "composite",
        "compound": "compound",
        "contrast": "contrast",
        "crop": "crop",
        "face_crop": "faceCrop",
        "feature_crop": "featureCrop",
        "fit_and_fill": "fitAndFill",
        "goop": "goop",
        "grayscale": "grayscale",
        "hsl": "hsl",
        "hsv": "hsv",
        "if_dimension": "ifDimension",
        "if_orientation": "ifOrientation",
        "im_query": "imQuery",
        "max_colors": "maxColors",
        "mirror": "mirror",
        "mono_hue": "monoHue",
        "opacity": "opacity",
        "region_of_interest_crop": "regionOfInterestCrop",
        "relative_crop": "relativeCrop",
        "remove_color": "removeColor",
        "resize": "resize",
        "rotate": "rotate",
        "scale": "scale",
        "shear": "shear",
        "trim": "trim",
        "unsharp_mask": "unsharpMask",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqual:
    def __init__(
        self,
        *,
        append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualAppend", typing.Dict[builtins.str, typing.Any]]]]] = None,
        aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualAspectCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualBackgroundColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualBlur", typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualChromaKey", typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualComposite", typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualCompound", typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualContrast", typing.Dict[builtins.str, typing.Any]]]]] = None,
        crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualFaceCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualFeatureCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualFitAndFill", typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualGoop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualGrayscale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualHsl", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualHsv", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfDimension", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfOrientation", typing.Dict[builtins.str, typing.Any]]]]] = None,
        im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualImQuery", typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualMaxColors", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualMirror", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualMonoHue", typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualOpacity", typing.Dict[builtins.str, typing.Any]]]]] = None,
        region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualRegionOfInterestCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualRelativeCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualRemoveColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualResize", typing.Dict[builtins.str, typing.Any]]]]] = None,
        rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualRotate", typing.Dict[builtins.str, typing.Any]]]]] = None,
        scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualScale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualShear", typing.Dict[builtins.str, typing.Any]]]]] = None,
        trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualTrim", typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualUnsharpMask", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param append: append block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        :param aspect_crop: aspect_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param crop: crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        :param face_crop: face_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        :param feature_crop: feature_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        :param fit_and_fill: fit_and_fill block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param im_query: im_query block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param region_of_interest_crop: region_of_interest_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        :param relative_crop: relative_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param resize: resize block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        :param rotate: rotate block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        :param scale: scale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param shear: shear block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        :param trim: trim block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be9dca5fbdc6507184ce8f1dcec668ca3659614a362c918d832f77801320759a)
            check_type(argname="argument append", value=append, expected_type=type_hints["append"])
            check_type(argname="argument aspect_crop", value=aspect_crop, expected_type=type_hints["aspect_crop"])
            check_type(argname="argument background_color", value=background_color, expected_type=type_hints["background_color"])
            check_type(argname="argument blur", value=blur, expected_type=type_hints["blur"])
            check_type(argname="argument chroma_key", value=chroma_key, expected_type=type_hints["chroma_key"])
            check_type(argname="argument composite", value=composite, expected_type=type_hints["composite"])
            check_type(argname="argument compound", value=compound, expected_type=type_hints["compound"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument crop", value=crop, expected_type=type_hints["crop"])
            check_type(argname="argument face_crop", value=face_crop, expected_type=type_hints["face_crop"])
            check_type(argname="argument feature_crop", value=feature_crop, expected_type=type_hints["feature_crop"])
            check_type(argname="argument fit_and_fill", value=fit_and_fill, expected_type=type_hints["fit_and_fill"])
            check_type(argname="argument goop", value=goop, expected_type=type_hints["goop"])
            check_type(argname="argument grayscale", value=grayscale, expected_type=type_hints["grayscale"])
            check_type(argname="argument hsl", value=hsl, expected_type=type_hints["hsl"])
            check_type(argname="argument hsv", value=hsv, expected_type=type_hints["hsv"])
            check_type(argname="argument if_dimension", value=if_dimension, expected_type=type_hints["if_dimension"])
            check_type(argname="argument if_orientation", value=if_orientation, expected_type=type_hints["if_orientation"])
            check_type(argname="argument im_query", value=im_query, expected_type=type_hints["im_query"])
            check_type(argname="argument max_colors", value=max_colors, expected_type=type_hints["max_colors"])
            check_type(argname="argument mirror", value=mirror, expected_type=type_hints["mirror"])
            check_type(argname="argument mono_hue", value=mono_hue, expected_type=type_hints["mono_hue"])
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument region_of_interest_crop", value=region_of_interest_crop, expected_type=type_hints["region_of_interest_crop"])
            check_type(argname="argument relative_crop", value=relative_crop, expected_type=type_hints["relative_crop"])
            check_type(argname="argument remove_color", value=remove_color, expected_type=type_hints["remove_color"])
            check_type(argname="argument resize", value=resize, expected_type=type_hints["resize"])
            check_type(argname="argument rotate", value=rotate, expected_type=type_hints["rotate"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument shear", value=shear, expected_type=type_hints["shear"])
            check_type(argname="argument trim", value=trim, expected_type=type_hints["trim"])
            check_type(argname="argument unsharp_mask", value=unsharp_mask, expected_type=type_hints["unsharp_mask"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if append is not None:
            self._values["append"] = append
        if aspect_crop is not None:
            self._values["aspect_crop"] = aspect_crop
        if background_color is not None:
            self._values["background_color"] = background_color
        if blur is not None:
            self._values["blur"] = blur
        if chroma_key is not None:
            self._values["chroma_key"] = chroma_key
        if composite is not None:
            self._values["composite"] = composite
        if compound is not None:
            self._values["compound"] = compound
        if contrast is not None:
            self._values["contrast"] = contrast
        if crop is not None:
            self._values["crop"] = crop
        if face_crop is not None:
            self._values["face_crop"] = face_crop
        if feature_crop is not None:
            self._values["feature_crop"] = feature_crop
        if fit_and_fill is not None:
            self._values["fit_and_fill"] = fit_and_fill
        if goop is not None:
            self._values["goop"] = goop
        if grayscale is not None:
            self._values["grayscale"] = grayscale
        if hsl is not None:
            self._values["hsl"] = hsl
        if hsv is not None:
            self._values["hsv"] = hsv
        if if_dimension is not None:
            self._values["if_dimension"] = if_dimension
        if if_orientation is not None:
            self._values["if_orientation"] = if_orientation
        if im_query is not None:
            self._values["im_query"] = im_query
        if max_colors is not None:
            self._values["max_colors"] = max_colors
        if mirror is not None:
            self._values["mirror"] = mirror
        if mono_hue is not None:
            self._values["mono_hue"] = mono_hue
        if opacity is not None:
            self._values["opacity"] = opacity
        if region_of_interest_crop is not None:
            self._values["region_of_interest_crop"] = region_of_interest_crop
        if relative_crop is not None:
            self._values["relative_crop"] = relative_crop
        if remove_color is not None:
            self._values["remove_color"] = remove_color
        if resize is not None:
            self._values["resize"] = resize
        if rotate is not None:
            self._values["rotate"] = rotate
        if scale is not None:
            self._values["scale"] = scale
        if shear is not None:
            self._values["shear"] = shear
        if trim is not None:
            self._values["trim"] = trim
        if unsharp_mask is not None:
            self._values["unsharp_mask"] = unsharp_mask

    @builtins.property
    def append(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualAppend"]]]:
        '''append block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        '''
        result = self._values.get("append")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualAppend"]]], result)

    @builtins.property
    def aspect_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualAspectCrop"]]]:
        '''aspect_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        '''
        result = self._values.get("aspect_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualAspectCrop"]]], result)

    @builtins.property
    def background_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualBackgroundColor"]]]:
        '''background_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        '''
        result = self._values.get("background_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualBackgroundColor"]]], result)

    @builtins.property
    def blur(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualBlur"]]]:
        '''blur block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        '''
        result = self._values.get("blur")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualBlur"]]], result)

    @builtins.property
    def chroma_key(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualChromaKey"]]]:
        '''chroma_key block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        '''
        result = self._values.get("chroma_key")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualChromaKey"]]], result)

    @builtins.property
    def composite(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualComposite"]]]:
        '''composite block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        '''
        result = self._values.get("composite")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualComposite"]]], result)

    @builtins.property
    def compound(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualCompound"]]]:
        '''compound block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        '''
        result = self._values.get("compound")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualCompound"]]], result)

    @builtins.property
    def contrast(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualContrast"]]]:
        '''contrast block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualContrast"]]], result)

    @builtins.property
    def crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualCrop"]]]:
        '''crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        '''
        result = self._values.get("crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualCrop"]]], result)

    @builtins.property
    def face_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualFaceCrop"]]]:
        '''face_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        '''
        result = self._values.get("face_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualFaceCrop"]]], result)

    @builtins.property
    def feature_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualFeatureCrop"]]]:
        '''feature_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        '''
        result = self._values.get("feature_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualFeatureCrop"]]], result)

    @builtins.property
    def fit_and_fill(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualFitAndFill"]]]:
        '''fit_and_fill block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        '''
        result = self._values.get("fit_and_fill")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualFitAndFill"]]], result)

    @builtins.property
    def goop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualGoop"]]]:
        '''goop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        '''
        result = self._values.get("goop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualGoop"]]], result)

    @builtins.property
    def grayscale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualGrayscale"]]]:
        '''grayscale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        '''
        result = self._values.get("grayscale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualGrayscale"]]], result)

    @builtins.property
    def hsl(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualHsl"]]]:
        '''hsl block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        '''
        result = self._values.get("hsl")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualHsl"]]], result)

    @builtins.property
    def hsv(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualHsv"]]]:
        '''hsv block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        '''
        result = self._values.get("hsv")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualHsv"]]], result)

    @builtins.property
    def if_dimension(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfDimension"]]]:
        '''if_dimension block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        '''
        result = self._values.get("if_dimension")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfDimension"]]], result)

    @builtins.property
    def if_orientation(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfOrientation"]]]:
        '''if_orientation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        '''
        result = self._values.get("if_orientation")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfOrientation"]]], result)

    @builtins.property
    def im_query(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualImQuery"]]]:
        '''im_query block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        '''
        result = self._values.get("im_query")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualImQuery"]]], result)

    @builtins.property
    def max_colors(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualMaxColors"]]]:
        '''max_colors block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        '''
        result = self._values.get("max_colors")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualMaxColors"]]], result)

    @builtins.property
    def mirror(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualMirror"]]]:
        '''mirror block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        '''
        result = self._values.get("mirror")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualMirror"]]], result)

    @builtins.property
    def mono_hue(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualMonoHue"]]]:
        '''mono_hue block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        '''
        result = self._values.get("mono_hue")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualMonoHue"]]], result)

    @builtins.property
    def opacity(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualOpacity"]]]:
        '''opacity block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualOpacity"]]], result)

    @builtins.property
    def region_of_interest_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualRegionOfInterestCrop"]]]:
        '''region_of_interest_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        '''
        result = self._values.get("region_of_interest_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualRegionOfInterestCrop"]]], result)

    @builtins.property
    def relative_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualRelativeCrop"]]]:
        '''relative_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        '''
        result = self._values.get("relative_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualRelativeCrop"]]], result)

    @builtins.property
    def remove_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualRemoveColor"]]]:
        '''remove_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        '''
        result = self._values.get("remove_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualRemoveColor"]]], result)

    @builtins.property
    def resize(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualResize"]]]:
        '''resize block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        '''
        result = self._values.get("resize")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualResize"]]], result)

    @builtins.property
    def rotate(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualRotate"]]]:
        '''rotate block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        '''
        result = self._values.get("rotate")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualRotate"]]], result)

    @builtins.property
    def scale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualScale"]]]:
        '''scale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualScale"]]], result)

    @builtins.property
    def shear(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualShear"]]]:
        '''shear block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        '''
        result = self._values.get("shear")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualShear"]]], result)

    @builtins.property
    def trim(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualTrim"]]]:
        '''trim block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        '''
        result = self._values.get("trim")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualTrim"]]], result)

    @builtins.property
    def unsharp_mask(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualUnsharpMask"]]]:
        '''unsharp_mask block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        result = self._values.get("unsharp_mask")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualUnsharpMask"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqual(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualAppend",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_priority": "gravityPriority",
        "gravity_priority_var": "gravityPriorityVar",
        "gravity_var": "gravityVar",
        "preserve_minor_dimension": "preserveMinorDimension",
        "preserve_minor_dimension_var": "preserveMinorDimensionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualAppend:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualAppendImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_priority: typing.Optional[builtins.str] = None,
        gravity_priority_var: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        preserve_minor_dimension: typing.Optional[builtins.str] = None,
        preserve_minor_dimension_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Specifies where to place the ``image`` relative to the source image. The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_priority: Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal. The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority DataAkamaiImagingPolicyImage#gravity_priority}
        :param gravity_priority_var: Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal. The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority_var DataAkamaiImagingPolicyImage#gravity_priority_var}
        :param gravity_var: Specifies where to place the ``image`` relative to the source image. The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param preserve_minor_dimension: Whether to preserve the source image's minor dimension, ``false`` by default. The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension DataAkamaiImagingPolicyImage#preserve_minor_dimension}
        :param preserve_minor_dimension_var: Whether to preserve the source image's minor dimension, ``false`` by default. The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension_var DataAkamaiImagingPolicyImage#preserve_minor_dimension_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualAppendImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a179e0e3ff182d5fb9d6a7390d1807eefd6754a61cf19014f1f758d46b5ed53)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_priority", value=gravity_priority, expected_type=type_hints["gravity_priority"])
            check_type(argname="argument gravity_priority_var", value=gravity_priority_var, expected_type=type_hints["gravity_priority_var"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument preserve_minor_dimension", value=preserve_minor_dimension, expected_type=type_hints["preserve_minor_dimension"])
            check_type(argname="argument preserve_minor_dimension_var", value=preserve_minor_dimension_var, expected_type=type_hints["preserve_minor_dimension_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_priority is not None:
            self._values["gravity_priority"] = gravity_priority
        if gravity_priority_var is not None:
            self._values["gravity_priority_var"] = gravity_priority_var
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if preserve_minor_dimension is not None:
            self._values["preserve_minor_dimension"] = preserve_minor_dimension
        if preserve_minor_dimension_var is not None:
            self._values["preserve_minor_dimension_var"] = preserve_minor_dimension_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualAppendImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualAppendImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Specifies where to place the ``image`` relative to the source image.

        The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_priority(self) -> typing.Optional[builtins.str]:
        '''Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal.

        The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority DataAkamaiImagingPolicyImage#gravity_priority}
        '''
        result = self._values.get("gravity_priority")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_priority_var(self) -> typing.Optional[builtins.str]:
        '''Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal.

        The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority_var DataAkamaiImagingPolicyImage#gravity_priority_var}
        '''
        result = self._values.get("gravity_priority_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Specifies where to place the ``image`` relative to the source image.

        The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def preserve_minor_dimension(self) -> typing.Optional[builtins.str]:
        '''Whether to preserve the source image's minor dimension, ``false`` by default.

        The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension DataAkamaiImagingPolicyImage#preserve_minor_dimension}
        '''
        result = self._values.get("preserve_minor_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def preserve_minor_dimension_var(self) -> typing.Optional[builtins.str]:
        '''Whether to preserve the source image's minor dimension, ``false`` by default.

        The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension_var DataAkamaiImagingPolicyImage#preserve_minor_dimension_var}
        '''
        result = self._values.get("preserve_minor_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualAppend(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualAppendImage",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualAppendImage:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualAppendImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualAppendImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualAppendImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b1619b817beb076974f35c8d3b977e0299219dc6baae3a09a6ca6658fc2d6dc3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualAppendImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualAppendImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualAppendImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__49e306b5ffed3617dfa39b5fd4ab8a30900c34a7696edec7a78454444b5abd51)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualAppendList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualAppendList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a194ceabb703a6b7c224ff8b97abf0d7debc7932a165737f0812949e609db275)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualAppendOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a719e1d127361a8b5c18fc0d2fc34d0da9b3e7fed907766c14048e9a995f78ca)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualAppendOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__93ec27349025df3155cc1a22c71052ec4be78a467cd2e368f37349e9e2dbca93)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__15b73cef36a3fcc13075abf219578832e83673594497910e06c5e4b4a6901069)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__73608884b106d80dc544e4c8f3725df9d79ae564c26289be13141aa4246ac1eb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualAppend]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualAppend]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualAppend]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__99baa55c306b0e98be3d7a77c75ced1d670e07e02a4303700041be3584c3f620)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualAppendOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualAppendOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1e7bd475350d3c5f5a2254fb2916a6febceee13f41949d6debf0ff48d77b4b52)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualAppendImage()

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityPriority")
    def reset_gravity_priority(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityPriority", []))

    @jsii.member(jsii_name="resetGravityPriorityVar")
    def reset_gravity_priority_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityPriorityVar", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPreserveMinorDimension")
    def reset_preserve_minor_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPreserveMinorDimension", []))

    @jsii.member(jsii_name="resetPreserveMinorDimensionVar")
    def reset_preserve_minor_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPreserveMinorDimensionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualAppendImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualAppendImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityInput")
    def gravity_priority_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityPriorityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityVarInput")
    def gravity_priority_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityPriorityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualAppendImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualAppendImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionInput")
    def preserve_minor_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "preserveMinorDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionVarInput")
    def preserve_minor_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "preserveMinorDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__07a3c1ead13fc43d9deaa62f42e64ab7a893e2790e600450d76497ba46f5c92a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityPriority")
    def gravity_priority(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityPriority"))

    @gravity_priority.setter
    def gravity_priority(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__10928852513cd5471c4a36c8a8ac6e5967441d1e7d8870f8e685a97b77e3b1c1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityPriority", value)

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityVar")
    def gravity_priority_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityPriorityVar"))

    @gravity_priority_var.setter
    def gravity_priority_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8735ee1406025b5b30463106b3fe2f5e0da55442720859df5aa1b85971da654a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityPriorityVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__042bb6e046109ba95a68145fbe6ac8dd136861aa420b39523dd7063d62aae474)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimension")
    def preserve_minor_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "preserveMinorDimension"))

    @preserve_minor_dimension.setter
    def preserve_minor_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dab4d28e0c545ee9462a85b0060f17f09638299bf0491cf0c9d4566aa491ae64)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "preserveMinorDimension", value)

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionVar")
    def preserve_minor_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "preserveMinorDimensionVar"))

    @preserve_minor_dimension_var.setter
    def preserve_minor_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f79f877899e0b15b801e4b15749286e038fb847ff6c2e7229d3c30cd73a0edf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "preserveMinorDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualAppend]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualAppend]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualAppend]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b28cd01ecc86d9b70905b731ba4f83b0adf37cbfc76842294ff6a0ada0348b30)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualAspectCrop",
    jsii_struct_bases=[],
    name_mapping={
        "allow_expansion": "allowExpansion",
        "allow_expansion_var": "allowExpansionVar",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualAspectCrop:
    def __init__(
        self,
        *,
        allow_expansion: typing.Optional[builtins.str] = None,
        allow_expansion_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_expansion: Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image. Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        :param allow_expansion_var: Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image. Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        :param height: The height term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The width term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        :param x_position: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d5247b2c5532697ec219223ad50e2a29178ab215aee8a56eaf744af998b60c93)
            check_type(argname="argument allow_expansion", value=allow_expansion, expected_type=type_hints["allow_expansion"])
            check_type(argname="argument allow_expansion_var", value=allow_expansion_var, expected_type=type_hints["allow_expansion_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if allow_expansion is not None:
            self._values["allow_expansion"] = allow_expansion
        if allow_expansion_var is not None:
            self._values["allow_expansion_var"] = allow_expansion_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def allow_expansion(self) -> typing.Optional[builtins.str]:
        '''Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image.

        Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        '''
        result = self._values.get("allow_expansion")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def allow_expansion_var(self) -> typing.Optional[builtins.str]:
        '''Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image.

        Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        '''
        result = self._values.get("allow_expansion_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualAspectCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualAspectCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualAspectCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__598e15af827520481ec5f878250973e74635cec0b463792d6206f957ba168ceb)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualAspectCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__98ba7c93a71e5c1f80f199b3d3e1737c7dd53c153a365d4c9a2bc12ff8a638fc)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualAspectCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__04310102cadebb5a02cfee73f621d6e69927c4921b3324254118d0eb6d171055)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__587af4d3ce84889ee38c8a4c32b7759d2ccdccf5e117fa3a722abbf9d7ff7376)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c1c6b0c0897be36f6a8eb4400ac9285e9aa4b622a708f5d6128f5b06f2f7af7e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualAspectCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualAspectCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualAspectCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__affc1395f2544039464dc393042fc848f268de8920abb0d1685c8b6d66660631)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualAspectCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualAspectCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8843950cd36dbe66898a5f9155fe826898ecf703a1992402a7f9b725f77f0e8b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAllowExpansion")
    def reset_allow_expansion(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansion", []))

    @jsii.member(jsii_name="resetAllowExpansionVar")
    def reset_allow_expansion_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansionVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionInput")
    def allow_expansion_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVarInput")
    def allow_expansion_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansion")
    def allow_expansion(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansion"))

    @allow_expansion.setter
    def allow_expansion(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ed6d55328952a87c0bc3cc6d3b6b7e377d34b0b8c1ff95e9d7f65cfdcc424f5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansion", value)

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVar")
    def allow_expansion_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansionVar"))

    @allow_expansion_var.setter
    def allow_expansion_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dc574550f8d5c323fa3ed5e1668874713d8eb9599a465b1b50392729ca7f2b08)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansionVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__81d5ec323917164d888afffaf268a9838ceaceebc4281030cb48d04735c2ceb8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4e2a4186e257299243ebe244036d27722ae31b870b4fc26fceb130a79e4ddb58)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c2158923a99ca7fb6b99fc62af8d4e2eb85210eb7b3a9b39bd8faba9beab6430)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__62a35c955aa74ce4894610d33aecc5c6113d32974ff83a325e3c22d05c052b13)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__60c05f0abf94a9d5699bd3b57659724d34358bdebc38145cc536a463cc197726)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__90b7cf57d772f62536b91c1e9f458fe0405b4a9f46d377644d094b392e4a183b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__873eabb71b9a9485ba8f17f820dcf2471f9ba307e0a63e95931b5b84c4b24b50)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__278e35103064581634dfea42c3174100140e8107dc5fa117bae2c0725f83b68a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualAspectCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualAspectCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualAspectCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__170d8d0aed6c1e9409b51d68b7b84e69b036b519dcc77cabd37df5283a97b8e1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualBackgroundColor",
    jsii_struct_bases=[],
    name_mapping={"color": "color", "color_var": "colorVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualBackgroundColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a12fd9f182e0db0e3a11a04491e4db23676f214f582e736c81a3165753f8b8d3)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualBackgroundColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualBackgroundColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualBackgroundColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a121a8282de7f59d3a2ab4751d8e9e15ae6acc864116b5e53932b4cb5d9072ad)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualBackgroundColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c2f8b8d0039491350c5fcf6cf2140a79c70ff39eff4430e6f6575657ba456388)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualBackgroundColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ce2c538caf8a7752701f3ca417b0449440eae2625b52aa562a7bda7a4de5b313)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__64bd5328533e001be62a617656b27482316ad5c2c77f7d497e21caafafa40d87)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__43415075afd1516b7a723d9d2b9819234c25986921eda13e9c8ba66555c6e00d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualBackgroundColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualBackgroundColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fc947e7baa99d7971faed3b75b8097e2c7dc69a3aa81ee9c73768f296b2b48d5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualBackgroundColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualBackgroundColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__350aac2caefa644595e1afef49935259ea2365d908be49b908461e9ec1431fd4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__83743f8aebc70299bc12ab0aff7d2aa2b5b6391a5da27037a273a67138021b62)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__31b47b7578991c2baa80a8e5f2ef93f99f9771e409685e99c0c57df885b550f0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualBackgroundColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualBackgroundColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualBackgroundColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ba4a660542666c4fc5f1d42ae6ad7455356c859c7ab3593e7850bb6415ee3392)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualBlur",
    jsii_struct_bases=[],
    name_mapping={"sigma": "sigma", "sigma_var": "sigmaVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualBlur:
    def __init__(
        self,
        *,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param sigma: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__96f063aacfabd8e6f8a710a519b185c0e91cf8fdc3f7287ef6a53d0272ca8b6e)
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualBlur(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualBlurList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualBlurList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2e502afe219509eece185ef5df19c4f947952300578b00aea9c36fe30ced7e58)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualBlurOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__08d5fa036359a4df152cfbffe764bd44f2f6baa8e2fc2a7f91e62dba693aacf7)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualBlurOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c84c585c4809e3dfb98310f48432430cb327e8535e1d001ad56188c901b4617f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__38b9aae2d737e0e39f0f5f34723328fee90c3b57cb4abcf94b3498d8ffcf93a4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4615c5c3c69fe8fec6ca730c7073a921d96c17396c61389337dcdbde11f96e0d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualBlur]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualBlur]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6cf488f9929ee36e47d8af9141c5185b5cd56cff9fee8c298910de7a4edc5d0f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualBlurOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualBlurOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__74203c61c874a21876c2a448aa207e71fa2ce59e367657b172e5d06aa18e585b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2cb0b34ef05c20d2058eb6358a099a8106225cea15d9d7259cb9df8cc3d88546)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4c7c943a3a27355722462b232675cc07be00ea547912c998700e962fce18b588)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualBlur]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualBlur]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualBlur]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9abb371956bc4783c6378acdd87ad9d37bc0a2087d748fd512313c122a573383)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualChromaKey",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_feather": "hueFeather",
        "hue_feather_var": "hueFeatherVar",
        "hue_tolerance": "hueTolerance",
        "hue_tolerance_var": "hueToleranceVar",
        "hue_var": "hueVar",
        "lightness_feather": "lightnessFeather",
        "lightness_feather_var": "lightnessFeatherVar",
        "lightness_tolerance": "lightnessTolerance",
        "lightness_tolerance_var": "lightnessToleranceVar",
        "saturation_feather": "saturationFeather",
        "saturation_feather_var": "saturationFeatherVar",
        "saturation_tolerance": "saturationTolerance",
        "saturation_tolerance_var": "saturationToleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualChromaKey:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_feather: typing.Optional[builtins.str] = None,
        hue_feather_var: typing.Optional[builtins.str] = None,
        hue_tolerance: typing.Optional[builtins.str] = None,
        hue_tolerance_var: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness_feather: typing.Optional[builtins.str] = None,
        lightness_feather_var: typing.Optional[builtins.str] = None,
        lightness_tolerance: typing.Optional[builtins.str] = None,
        lightness_tolerance_var: typing.Optional[builtins.str] = None,
        saturation_feather: typing.Optional[builtins.str] = None,
        saturation_feather_var: typing.Optional[builtins.str] = None,
        saturation_tolerance: typing.Optional[builtins.str] = None,
        saturation_tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_feather: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        :param hue_feather_var: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        :param hue_tolerance: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        :param hue_tolerance_var: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        :param hue_var: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness_feather: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        :param lightness_feather_var: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        :param lightness_tolerance: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        :param lightness_tolerance_var: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        :param saturation_feather: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        :param saturation_feather_var: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        :param saturation_tolerance: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        :param saturation_tolerance_var: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__819a56185cead57e024b2c295965cd917812a243acfdd05002351d4af2d28a19)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_feather", value=hue_feather, expected_type=type_hints["hue_feather"])
            check_type(argname="argument hue_feather_var", value=hue_feather_var, expected_type=type_hints["hue_feather_var"])
            check_type(argname="argument hue_tolerance", value=hue_tolerance, expected_type=type_hints["hue_tolerance"])
            check_type(argname="argument hue_tolerance_var", value=hue_tolerance_var, expected_type=type_hints["hue_tolerance_var"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness_feather", value=lightness_feather, expected_type=type_hints["lightness_feather"])
            check_type(argname="argument lightness_feather_var", value=lightness_feather_var, expected_type=type_hints["lightness_feather_var"])
            check_type(argname="argument lightness_tolerance", value=lightness_tolerance, expected_type=type_hints["lightness_tolerance"])
            check_type(argname="argument lightness_tolerance_var", value=lightness_tolerance_var, expected_type=type_hints["lightness_tolerance_var"])
            check_type(argname="argument saturation_feather", value=saturation_feather, expected_type=type_hints["saturation_feather"])
            check_type(argname="argument saturation_feather_var", value=saturation_feather_var, expected_type=type_hints["saturation_feather_var"])
            check_type(argname="argument saturation_tolerance", value=saturation_tolerance, expected_type=type_hints["saturation_tolerance"])
            check_type(argname="argument saturation_tolerance_var", value=saturation_tolerance_var, expected_type=type_hints["saturation_tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_feather is not None:
            self._values["hue_feather"] = hue_feather
        if hue_feather_var is not None:
            self._values["hue_feather_var"] = hue_feather_var
        if hue_tolerance is not None:
            self._values["hue_tolerance"] = hue_tolerance
        if hue_tolerance_var is not None:
            self._values["hue_tolerance_var"] = hue_tolerance_var
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness_feather is not None:
            self._values["lightness_feather"] = lightness_feather
        if lightness_feather_var is not None:
            self._values["lightness_feather_var"] = lightness_feather_var
        if lightness_tolerance is not None:
            self._values["lightness_tolerance"] = lightness_tolerance
        if lightness_tolerance_var is not None:
            self._values["lightness_tolerance_var"] = lightness_tolerance_var
        if saturation_feather is not None:
            self._values["saturation_feather"] = saturation_feather
        if saturation_feather_var is not None:
            self._values["saturation_feather_var"] = saturation_feather_var
        if saturation_tolerance is not None:
            self._values["saturation_tolerance"] = saturation_tolerance
        if saturation_tolerance_var is not None:
            self._values["saturation_tolerance_var"] = saturation_tolerance_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        '''
        result = self._values.get("hue_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        '''
        result = self._values.get("hue_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        '''
        result = self._values.get("hue_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        '''
        result = self._values.get("hue_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        '''
        result = self._values.get("lightness_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        '''
        result = self._values.get("lightness_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        '''
        result = self._values.get("lightness_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        '''
        result = self._values.get("lightness_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        '''
        result = self._values.get("saturation_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        '''
        result = self._values.get("saturation_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        '''
        result = self._values.get("saturation_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        result = self._values.get("saturation_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualChromaKey(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualChromaKeyList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualChromaKeyList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f72bb2fe62409d92ac20d0be8557c485d5916a933ce5d49f87dc8eaaad0cbfc2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualChromaKeyOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e536ad507ea1e9f8c01d8692febaaadb6b09da8170a796bb8ba22c20db99b286)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualChromaKeyOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3c6037849358f2eacba3ff68e57820541b031aefa854747d77f2611151cbe9f3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__abe4c32b2c60ede870720949099f2aa132ea28a6d6de4f2d35766248ab78aea2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7812da497a1483926595aa753e4e168f1838a3c060329ef751eb0aaa264bf195)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualChromaKey]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualChromaKey]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c28272cba9e78c68e58572bb15814aabf7577795fba5745f6f827ba09ea17684)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualChromaKeyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualChromaKeyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__01f6212f7260ce4e283ea99c599c9b15086605594d0e0334cf9880330cd21d92)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueFeather")
    def reset_hue_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeather", []))

    @jsii.member(jsii_name="resetHueFeatherVar")
    def reset_hue_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeatherVar", []))

    @jsii.member(jsii_name="resetHueTolerance")
    def reset_hue_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueTolerance", []))

    @jsii.member(jsii_name="resetHueToleranceVar")
    def reset_hue_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueToleranceVar", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightnessFeather")
    def reset_lightness_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeather", []))

    @jsii.member(jsii_name="resetLightnessFeatherVar")
    def reset_lightness_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeatherVar", []))

    @jsii.member(jsii_name="resetLightnessTolerance")
    def reset_lightness_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessTolerance", []))

    @jsii.member(jsii_name="resetLightnessToleranceVar")
    def reset_lightness_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessToleranceVar", []))

    @jsii.member(jsii_name="resetSaturationFeather")
    def reset_saturation_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeather", []))

    @jsii.member(jsii_name="resetSaturationFeatherVar")
    def reset_saturation_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeatherVar", []))

    @jsii.member(jsii_name="resetSaturationTolerance")
    def reset_saturation_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationTolerance", []))

    @jsii.member(jsii_name="resetSaturationToleranceVar")
    def reset_saturation_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherInput")
    def hue_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVarInput")
    def hue_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceInput")
    def hue_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVarInput")
    def hue_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherInput")
    def lightness_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVarInput")
    def lightness_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceInput")
    def lightness_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVarInput")
    def lightness_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherInput")
    def saturation_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVarInput")
    def saturation_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceInput")
    def saturation_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVarInput")
    def saturation_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a53289a6288c31ef8bc5c04d3ffa2b99dd4d58ec2104ff7ca26a9396b3f7be87)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeather")
    def hue_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeather"))

    @hue_feather.setter
    def hue_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c25f4a015d4195fd95f924de9a4bc198421d00340fe54be728cacd9a27a61699)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeather", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVar")
    def hue_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeatherVar"))

    @hue_feather_var.setter
    def hue_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bd3e653a100dc28fa675b7e8f3ef3efb67d48c5889fa4c8a3181f599e8a5bd8b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueTolerance")
    def hue_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueTolerance"))

    @hue_tolerance.setter
    def hue_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__38005e8fc347d7207229e92707bf840f464d5176d538423c2527dae6cbeacb29)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVar")
    def hue_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueToleranceVar"))

    @hue_tolerance_var.setter
    def hue_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e974f354ddfd19fe8050a215cbf0aaa0bb78529a81a6310378f89798a4b28bf4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__73b3d7b5bd0b943f6f023fa1590c2f515d3195de2c6f03a9c1d0d3d36ed3dba8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeather")
    def lightness_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeather"))

    @lightness_feather.setter
    def lightness_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2c574c333d1d7fd90c40e1fe7f52156247c0a8c6e3f68cc3e5b98be0aed4143d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeather", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVar")
    def lightness_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeatherVar"))

    @lightness_feather_var.setter
    def lightness_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b5431f7d3752559e577d948c32b6871a35a57a02ea07d9afcf9f9968bd371452)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessTolerance")
    def lightness_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessTolerance"))

    @lightness_tolerance.setter
    def lightness_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1411bd4811f43d9972dafd26b470c2ced43d696e3266a7a1eb7908c231902fb7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVar")
    def lightness_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessToleranceVar"))

    @lightness_tolerance_var.setter
    def lightness_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2fedaa8103d72d78242227266f9651e45433372535a063bb817618f33edf72c9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeather")
    def saturation_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeather"))

    @saturation_feather.setter
    def saturation_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cb1e0b68608e1b8bc547fcbc6b0b93e5e97951260398f0b74fe8781d8509d9db)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeather", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVar")
    def saturation_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeatherVar"))

    @saturation_feather_var.setter
    def saturation_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1361c60da1773ed5e38b1e2323221412ac6240763800608f083c675b379c2d5c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationTolerance")
    def saturation_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationTolerance"))

    @saturation_tolerance.setter
    def saturation_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1b86ee27e8764d5bd796e939f38a80a20b577e2d1ee3d7a7c38ac6bdc47e9562)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVar")
    def saturation_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationToleranceVar"))

    @saturation_tolerance_var.setter
    def saturation_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8625383e2837b62a0e9542c236684858e7ea988fac90e9e9b4579b02fd2747fc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualChromaKey]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualChromaKey]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualChromaKey]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ef1e30417a428541dcab85b112bc8accdf69dde260e501434ec021dec5a01eb6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualComposite",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "placement": "placement",
        "placement_var": "placementVar",
        "scale": "scale",
        "scale_dimension": "scaleDimension",
        "scale_dimension_var": "scaleDimensionVar",
        "scale_var": "scaleVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualComposite:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualCompositeImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        placement: typing.Optional[builtins.str] = None,
        placement_var: typing.Optional[builtins.str] = None,
        scale: typing.Optional[builtins.str] = None,
        scale_dimension: typing.Optional[builtins.str] = None,
        scale_dimension_var: typing.Optional[builtins.str] = None,
        scale_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param placement: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        :param placement_var: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        :param scale: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param scale_dimension: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        :param scale_dimension_var: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        :param scale_var: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        :param x_position: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualCompositeImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e1f89d2999ef553fd1b0c1e3a93af11dacd4b15782c3059c650685acdf599317)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument placement", value=placement, expected_type=type_hints["placement"])
            check_type(argname="argument placement_var", value=placement_var, expected_type=type_hints["placement_var"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument scale_dimension", value=scale_dimension, expected_type=type_hints["scale_dimension"])
            check_type(argname="argument scale_dimension_var", value=scale_dimension_var, expected_type=type_hints["scale_dimension_var"])
            check_type(argname="argument scale_var", value=scale_var, expected_type=type_hints["scale_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if placement is not None:
            self._values["placement"] = placement
        if placement_var is not None:
            self._values["placement_var"] = placement_var
        if scale is not None:
            self._values["scale"] = scale
        if scale_dimension is not None:
            self._values["scale_dimension"] = scale_dimension
        if scale_dimension_var is not None:
            self._values["scale_dimension_var"] = scale_dimension_var
        if scale_var is not None:
            self._values["scale_var"] = scale_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualCompositeImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualCompositeImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        '''
        result = self._values.get("placement")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement_var(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        '''
        result = self._values.get("placement_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        '''
        result = self._values.get("scale_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        '''
        result = self._values.get("scale_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        '''
        result = self._values.get("scale_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualComposite(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualCompositeImage",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualCompositeImage:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualCompositeImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualCompositeImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualCompositeImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__45305f5d18218d2457c555d2a00ccb875719773e0bcc3ba4b8c198ccebc97072)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualCompositeImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualCompositeImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a6caf4f7618b67a0db3b05199238f37bf8188c30670d0fd02aadd4bdd81c6397)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualCompositeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualCompositeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__57ff28ab99fd722c11ff57523708529e3029c881bf9b11c9de2b7ff59cde8b42)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualCompositeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__212552427229e84418ccab95a24f600eaa91420fe7f2f18377179585922f8f38)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualCompositeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__05000e18d01ed792249944e91b21b8e852717001bba18fee367fcdf25decce4c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e314efd260da72c5729b5a7a125c017cb7a93a63275c63900be647f7810820c7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__35d6536d341c774235533bdbbd3e0e0f9b769642dca032b7adaa2596b4a805be)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualComposite]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualComposite]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__27a9e865e05c203bfe1b0b12777d09fd7b554b41066844b13127782f6bbceac8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualCompositeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualCompositeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e65b4bf99e9bc7fd14258d8b3eb79f94dc3bb45a519001d2ac99b82b7ffc7f69)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualCompositeImage()

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPlacement")
    def reset_placement(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacement", []))

    @jsii.member(jsii_name="resetPlacementVar")
    def reset_placement_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacementVar", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetScaleDimension")
    def reset_scale_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimension", []))

    @jsii.member(jsii_name="resetScaleDimensionVar")
    def reset_scale_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimensionVar", []))

    @jsii.member(jsii_name="resetScaleVar")
    def reset_scale_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualCompositeImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualCompositeImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualCompositeImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="placementInput")
    def placement_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementInput"))

    @builtins.property
    @jsii.member(jsii_name="placementVarInput")
    def placement_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionInput")
    def scale_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVarInput")
    def scale_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleVarInput")
    def scale_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f9a270db9789efe46cd4577eba978851dcec93e0660ae0e714ba2efa5bff3507)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__74e2f27bd40918cbaff1384d188f5140e410974f57754419e7d3ee0de8c47ea0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="placement")
    def placement(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placement"))

    @placement.setter
    def placement(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__722d5be75c77f03a557817e56bb79a70508491d1d0e0c0ca10080273ef4acd79)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placement", value)

    @builtins.property
    @jsii.member(jsii_name="placementVar")
    def placement_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placementVar"))

    @placement_var.setter
    def placement_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4d1f3ce6e2ca58fc19b47a418c79259ae7b7245341cc46708f84cb5c9e68ddbe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placementVar", value)

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scale"))

    @scale.setter
    def scale(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e979451f99658c8e96f60321c64a47c425a446aa40b9c462af38bffefbf0fb9a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scale", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimension")
    def scale_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimension"))

    @scale_dimension.setter
    def scale_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__077c1b0b231f5d737b6469c3d7e5276c23c3b40e0c5445a511ee37062e6ddb69)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimension", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVar")
    def scale_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimensionVar"))

    @scale_dimension_var.setter
    def scale_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1472175579bbef0d1062c306c41cc57f5e7232a263b154e7e4e14f24f60593cf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="scaleVar")
    def scale_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleVar"))

    @scale_var.setter
    def scale_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af1479e2028ba5b7b2824ad7e8976b9e7ea957a6f8cee78d412205ca43b4d0e7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__82a01ffc73743d1fb944a2b1bc45c9fe67cc4e9defc8f9c0faa6c5bfc311f200)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f6f3e68749ede62f1b2bcaac3bb52f4f991d31de6127abba5c6c397afc46aedb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__566246a9a6e31afe1f5d091c32ed36e865b50825a6855c8f70c245fe828d5d7b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a862113cf2cdeab7bae2dd7ce9aa5acfa2ab84410110fc16e06e116bbf897b9f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualComposite]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualComposite]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualComposite]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9cd2015b56b6e8f6b59dfa970fea13dab9c49d45f09f43e533952314823a8e97)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualCompound",
    jsii_struct_bases=[],
    name_mapping={"transformations": "transformations"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualCompound:
    def __init__(
        self,
        *,
        transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param transformations: transformations block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a932bbeaeb35f2550d67a5d2a4aa7443d970316879b3d3b622bd8c0a67d18b3)
            check_type(argname="argument transformations", value=transformations, expected_type=type_hints["transformations"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if transformations is not None:
            self._values["transformations"] = transformations

    @builtins.property
    def transformations(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualCompoundTransformations"]]]:
        '''transformations block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        result = self._values.get("transformations")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualCompoundTransformations"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualCompound(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualCompoundList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualCompoundList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1d1748b9bca270da31ee48f89ad04cc92333e8ecd072379b8c2f18517e14541a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualCompoundOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5e1befcd57a780b740aaadb66c2c8e9b714ef8183f578fb4e0d24b1d5cf468fb)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualCompoundOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f51c93cc058437c4934a8a27e3a35248098fc3f242dac84786345c2e960d7722)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ee1f493f2cc69b5f5a7f201a553b8a98aba8dc61e96a32fac937e4909fd1ea3f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b491816c7ab4b6f2946b4de119b6bde844f23192da9af1cb77e8f8d07071e297)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualCompound]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualCompound]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__73af970a798b0d476b9686c84c59951829c22c39725d2f3f588f5494dfad120b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualCompoundOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualCompoundOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__514055392f0f1a4a28400be41762be638cd0ca79ce6d4077e0df0bb40ec76662)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformations")
    def put_transformations(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__204b8ab74e2e179366cb36c7dd8f1f789b3444bbb15bced78ccd7dc4582ed382)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTransformations", [value]))

    @jsii.member(jsii_name="resetTransformations")
    def reset_transformations(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformations", []))

    @builtins.property
    @jsii.member(jsii_name="transformations")
    def transformations(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualCompoundTransformationsList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualCompoundTransformationsList", jsii.get(self, "transformations"))

    @builtins.property
    @jsii.member(jsii_name="transformationsInput")
    def transformations_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualCompoundTransformations"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualCompoundTransformations"]]], jsii.get(self, "transformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualCompound]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualCompound]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualCompound]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7c064334d15841d94d767ee06e7a8d7f4ac64044dff3aa2fe0b14e0370f50e7a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualCompoundTransformations",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualCompoundTransformations:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualCompoundTransformations(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualCompoundTransformationsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualCompoundTransformationsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__090845c0cb0dac399ca25ef1a442774ea5addc7a84224288a3622988a5d81e92)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualCompoundTransformationsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__75de51c7318b93e57a40fa1fd97df3d6da933bed7e69bfd864f8bb7ba60d04de)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualCompoundTransformationsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f1ae8e3dc2171d88bdd0592b383e677df3287ba23924ee01d6ba8e81385b385)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__11b31e17ff91df5c1af7f4e30b99a6ce8b9dec7e647849194a3c450dec065bbe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c98e67e46aa7c599eee2cff55a0b6b5c4209e42e499d77f0d5c6548c5177b1fd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualCompoundTransformations]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualCompoundTransformations]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualCompoundTransformations]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bef6729941c9b1524eefd2ed69d58ef1a1886d448f10f468cacec12415f1b844)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualCompoundTransformationsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualCompoundTransformationsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9b5d1988ad1ae379af030c6f3a15580ad1389388bd6401188b2b7721c3a4bda1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualCompoundTransformations]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualCompoundTransformations]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualCompoundTransformations]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b7a92c05cf4ce21f6229a0c4c829b4954eea5e74c6bb275924761bb38e620d44)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualContrast",
    jsii_struct_bases=[],
    name_mapping={
        "brightness": "brightness",
        "brightness_var": "brightnessVar",
        "contrast": "contrast",
        "contrast_var": "contrastVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualContrast:
    def __init__(
        self,
        *,
        brightness: typing.Optional[builtins.str] = None,
        brightness_var: typing.Optional[builtins.str] = None,
        contrast: typing.Optional[builtins.str] = None,
        contrast_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param brightness: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        :param brightness_var: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        :param contrast: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param contrast_var: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__952c2ef4dceeccaecaf1247b4ad941c67537ad251bb48edc10c56a93f6b79b6c)
            check_type(argname="argument brightness", value=brightness, expected_type=type_hints["brightness"])
            check_type(argname="argument brightness_var", value=brightness_var, expected_type=type_hints["brightness_var"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument contrast_var", value=contrast_var, expected_type=type_hints["contrast_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if brightness is not None:
            self._values["brightness"] = brightness
        if brightness_var is not None:
            self._values["brightness_var"] = brightness_var
        if contrast is not None:
            self._values["contrast"] = contrast
        if contrast_var is not None:
            self._values["contrast_var"] = contrast_var

    @builtins.property
    def brightness(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        '''
        result = self._values.get("brightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def brightness_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        '''
        result = self._values.get("brightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        result = self._values.get("contrast_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualContrast(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualContrastList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualContrastList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__267d43e17556bd34ad16610799346a63f767f24e6c219e635eb360d4beeafe88)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualContrastOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c12c3e351d0172e569d3792acb3a8c268b87d826652334c9e525d95e2d6420fe)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualContrastOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f14c8a62c8ce89788e3b5eb1f7cf18b1d57a060174f7f63f9f3aeb3b64ce7bd8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__72b0532fd5d91b2b25dbc26325dcfe08db771ea671aa41afe96fc7f4f9ba2f7b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aa9e064d07e92099dda013fe38de8aed9151cdeac385d1ac0fe7300e4d145ce3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualContrast]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualContrast]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__75b219adc59917fa35034a1ea1f15de9d3d2f5c7396e124c3a0a5ca91f723bd5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualContrastOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualContrastOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fcaba042380189e74eba2868666998c15aec7b50dfa3c60864e46b35811a6c80)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetBrightness")
    def reset_brightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightness", []))

    @jsii.member(jsii_name="resetBrightnessVar")
    def reset_brightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightnessVar", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetContrastVar")
    def reset_contrast_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrastVar", []))

    @builtins.property
    @jsii.member(jsii_name="brightnessInput")
    def brightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="brightnessVarInput")
    def brightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastVarInput")
    def contrast_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="brightness")
    def brightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightness"))

    @brightness.setter
    def brightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4da59185257bbad4a1eb496e8b0876b845f5089554f0bac6085e899b57e9994f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightness", value)

    @builtins.property
    @jsii.member(jsii_name="brightnessVar")
    def brightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightnessVar"))

    @brightness_var.setter
    def brightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__226ed6674372438be584410d384704da19795c3d65a8d50646eba855a792ad15)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrast"))

    @contrast.setter
    def contrast(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__97e9a4257b51abdafd82dbc2474758a0cde1e77e863043081919bfa78fb85172)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrast", value)

    @builtins.property
    @jsii.member(jsii_name="contrastVar")
    def contrast_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrastVar"))

    @contrast_var.setter
    def contrast_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__37d9cbe06496533430e4c48c1403d5f97c8512f984df8a30521c6a5c08b39ffa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrastVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualContrast]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualContrast]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualContrast]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__da10a4820d32e904836c052a715ca280a9feaeea7b51f8f39b9c028fdda07645)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualCrop",
    jsii_struct_bases=[],
    name_mapping={
        "allow_expansion": "allowExpansion",
        "allow_expansion_var": "allowExpansionVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualCrop:
    def __init__(
        self,
        *,
        allow_expansion: typing.Optional[builtins.str] = None,
        allow_expansion_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_expansion: If cropping an area outside of the existing canvas, expands the image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        :param allow_expansion_var: If cropping an area outside of the existing canvas, expands the image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        :param gravity: Frame of reference for X and Y Positions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Frame of reference for X and Y Positions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The number of pixels to crop along the y-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The number of pixels to crop along the y-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The number of pixels to crop along the x-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The number of pixels to crop along the x-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        :param x_position: The x-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ddf67001867df5d4241a8572ca691c5c2b9d02c604b24b570191ace0e4066e26)
            check_type(argname="argument allow_expansion", value=allow_expansion, expected_type=type_hints["allow_expansion"])
            check_type(argname="argument allow_expansion_var", value=allow_expansion_var, expected_type=type_hints["allow_expansion_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if allow_expansion is not None:
            self._values["allow_expansion"] = allow_expansion
        if allow_expansion_var is not None:
            self._values["allow_expansion_var"] = allow_expansion_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def allow_expansion(self) -> typing.Optional[builtins.str]:
        '''If cropping an area outside of the existing canvas, expands the image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        '''
        result = self._values.get("allow_expansion")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def allow_expansion_var(self) -> typing.Optional[builtins.str]:
        '''If cropping an area outside of the existing canvas, expands the image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        '''
        result = self._values.get("allow_expansion_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Frame of reference for X and Y Positions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Frame of reference for X and Y Positions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the y-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the y-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the x-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the x-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0c8e03c17b4b50450dd8b6a5be6ed24662bd64090d34b38e727a2e7986d8241f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__db69aa73789194e517dbe3336321f93c5a67d886f7d841c4c9a84cfc6174f22b)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f318d0d194deda3f70ac1dea86e20158685fed8c584a8bf3b3e3aa8a16c8ffe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__708909c1cfe353e2ee200fbf632a9693019df152516bcb26dde06e094768b119)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__24645e28d36eacd544197d5b7e246b8d8c6cb630fe18839ef1d8ae7245eff225)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__763c27209ad03826419adfb31d7463c6e3054a6dbe2f7b790e553267aca06a20)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__681f7b30288738ccba0466d6557296347e14c03b721fd3a7a7a3407e355f088a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAllowExpansion")
    def reset_allow_expansion(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansion", []))

    @jsii.member(jsii_name="resetAllowExpansionVar")
    def reset_allow_expansion_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansionVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionInput")
    def allow_expansion_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVarInput")
    def allow_expansion_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansion")
    def allow_expansion(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansion"))

    @allow_expansion.setter
    def allow_expansion(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__412de0e0aa79e9116f21fac4c490e88694adbd075729f4e7b2ed05f7f26d0d28)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansion", value)

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVar")
    def allow_expansion_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansionVar"))

    @allow_expansion_var.setter
    def allow_expansion_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6975a586b09aa7b14b0f6a4e1aa20a44deea8c523bb998db3a02cc241cd4a716)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansionVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8c69b5ac73a2deb707adcd9532927b10be92370e093717c53e99ab1c39a42bd9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b0b305689086ba57404415978ca9539b8883845ce6434218427b87250f78d534)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc9c9f5c3d6c12091ab81143ffe43f97b6aecb62257f161c00aff8f5945a8412)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d3694b1a2fb9a46451971e7f500b7e33c9af34dd1111dfef1c4adcb86307ccb4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6188589d41e646bbb63062d48a3b818348fca0cffadcc178ef56b191d20d9d80)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ac2dfdc7182aee35d35d0cc400317d31c636eea3eba2b9b740fae2cadc61d6e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aa40c169d864160264c3ec6ff2e595a2288123319ee360b1e5e954f8bf1d8f63)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__888817f5f1b506ac88c036c18b309c06f1aab8eafd31b199a626adcc06f0d78e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a7818e030a4d02fc522b981aabc92387a38a4dec2396e83a26c2de244b408668)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__36befe6ec083d265d59cc06b8ba91c8b9f5c8a5e6188173fb7285e1c70c5914b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a5e9dabb919097f91afea24017c09fc5bc00fbffa8d6168d77b282cb8d2f6a6d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualFaceCrop",
    jsii_struct_bases=[],
    name_mapping={
        "algorithm": "algorithm",
        "algorithm_var": "algorithmVar",
        "confidence": "confidence",
        "confidence_var": "confidenceVar",
        "fail_gravity": "failGravity",
        "fail_gravity_var": "failGravityVar",
        "focus": "focus",
        "focus_var": "focusVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "padding": "padding",
        "padding_var": "paddingVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualFaceCrop:
    def __init__(
        self,
        *,
        algorithm: typing.Optional[builtins.str] = None,
        algorithm_var: typing.Optional[builtins.str] = None,
        confidence: typing.Optional[builtins.str] = None,
        confidence_var: typing.Optional[builtins.str] = None,
        fail_gravity: typing.Optional[builtins.str] = None,
        fail_gravity_var: typing.Optional[builtins.str] = None,
        focus: typing.Optional[builtins.str] = None,
        focus_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param algorithm: Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm DataAkamaiImagingPolicyImage#algorithm}
        :param algorithm_var: Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm_var DataAkamaiImagingPolicyImage#algorithm_var}
        :param confidence: With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image. Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence DataAkamaiImagingPolicyImage#confidence}
        :param confidence_var: With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image. Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence_var DataAkamaiImagingPolicyImage#confidence_var}
        :param fail_gravity: Controls placement of the crop if Image and Video Manager does not detect any faces in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        :param fail_gravity_var: Controls placement of the crop if Image and Video Manager does not detect any faces in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        :param focus: Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus DataAkamaiImagingPolicyImage#focus}
        :param focus_var: Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus_var DataAkamaiImagingPolicyImage#focus_var}
        :param gravity: Controls placement of the crop. Directions are relative to the face(s) plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Controls placement of the crop. Directions are relative to the face(s) plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param padding: The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        :param style: Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__775e5c29d1d3bee846c4891fdb039697860238c003168746e3ee5fcaae6c8b3d)
            check_type(argname="argument algorithm", value=algorithm, expected_type=type_hints["algorithm"])
            check_type(argname="argument algorithm_var", value=algorithm_var, expected_type=type_hints["algorithm_var"])
            check_type(argname="argument confidence", value=confidence, expected_type=type_hints["confidence"])
            check_type(argname="argument confidence_var", value=confidence_var, expected_type=type_hints["confidence_var"])
            check_type(argname="argument fail_gravity", value=fail_gravity, expected_type=type_hints["fail_gravity"])
            check_type(argname="argument fail_gravity_var", value=fail_gravity_var, expected_type=type_hints["fail_gravity_var"])
            check_type(argname="argument focus", value=focus, expected_type=type_hints["focus"])
            check_type(argname="argument focus_var", value=focus_var, expected_type=type_hints["focus_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if algorithm is not None:
            self._values["algorithm"] = algorithm
        if algorithm_var is not None:
            self._values["algorithm_var"] = algorithm_var
        if confidence is not None:
            self._values["confidence"] = confidence
        if confidence_var is not None:
            self._values["confidence_var"] = confidence_var
        if fail_gravity is not None:
            self._values["fail_gravity"] = fail_gravity
        if fail_gravity_var is not None:
            self._values["fail_gravity_var"] = fail_gravity_var
        if focus is not None:
            self._values["focus"] = focus
        if focus_var is not None:
            self._values["focus_var"] = focus_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def algorithm(self) -> typing.Optional[builtins.str]:
        '''Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm DataAkamaiImagingPolicyImage#algorithm}
        '''
        result = self._values.get("algorithm")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def algorithm_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm_var DataAkamaiImagingPolicyImage#algorithm_var}
        '''
        result = self._values.get("algorithm_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def confidence(self) -> typing.Optional[builtins.str]:
        '''With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image.

        Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence DataAkamaiImagingPolicyImage#confidence}
        '''
        result = self._values.get("confidence")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def confidence_var(self) -> typing.Optional[builtins.str]:
        '''With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image.

        Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence_var DataAkamaiImagingPolicyImage#confidence_var}
        '''
        result = self._values.get("confidence_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any faces in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        '''
        result = self._values.get("fail_gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any faces in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        '''
        result = self._values.get("fail_gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def focus(self) -> typing.Optional[builtins.str]:
        '''Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus DataAkamaiImagingPolicyImage#focus}
        '''
        result = self._values.get("focus")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def focus_var(self) -> typing.Optional[builtins.str]:
        '''Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus_var DataAkamaiImagingPolicyImage#focus_var}
        '''
        result = self._values.get("focus_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the face(s) plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the face(s) plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualFaceCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualFaceCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualFaceCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__09f258911f6301c912a6b1851a284d0e63a48caf1c75ebec93b350c1b11fa951)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualFaceCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b4d3ed319dcddd96769022a273304030364a52a5d9526e87eb15fea431ad5b8e)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualFaceCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b8c9a74cd9bb0f4d7e4a92849daa51ef536594b642a762e5d5117e19bb8bbc50)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be09f37e1399bc757fae2bb43d95acc435ec7552ac67f864920631a02cb8a451)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__82940e9eef6f72c3df22aecf7e1231054b4e0ec060b0aec40c76e268b50b1ea1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualFaceCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualFaceCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualFaceCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d20a535d9da1a94f3c3626bd5e9a8520fd0bc2272a624e6b6eb4bc9403899b34)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualFaceCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualFaceCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__50ed553e82cb1f24a953d901b81c1b799b5e90001a1bbf8389d56ec33af6f4d4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAlgorithm")
    def reset_algorithm(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAlgorithm", []))

    @jsii.member(jsii_name="resetAlgorithmVar")
    def reset_algorithm_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAlgorithmVar", []))

    @jsii.member(jsii_name="resetConfidence")
    def reset_confidence(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetConfidence", []))

    @jsii.member(jsii_name="resetConfidenceVar")
    def reset_confidence_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetConfidenceVar", []))

    @jsii.member(jsii_name="resetFailGravity")
    def reset_fail_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravity", []))

    @jsii.member(jsii_name="resetFailGravityVar")
    def reset_fail_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravityVar", []))

    @jsii.member(jsii_name="resetFocus")
    def reset_focus(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFocus", []))

    @jsii.member(jsii_name="resetFocusVar")
    def reset_focus_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFocusVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="algorithmInput")
    def algorithm_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "algorithmInput"))

    @builtins.property
    @jsii.member(jsii_name="algorithmVarInput")
    def algorithm_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "algorithmVarInput"))

    @builtins.property
    @jsii.member(jsii_name="confidenceInput")
    def confidence_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "confidenceInput"))

    @builtins.property
    @jsii.member(jsii_name="confidenceVarInput")
    def confidence_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "confidenceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityInput")
    def fail_gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityVarInput")
    def fail_gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="focusInput")
    def focus_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "focusInput"))

    @builtins.property
    @jsii.member(jsii_name="focusVarInput")
    def focus_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "focusVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="algorithm")
    def algorithm(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "algorithm"))

    @algorithm.setter
    def algorithm(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b29408ab086614b226a8d2a6200956e4ab980cb49e122091002c5a731a07baba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "algorithm", value)

    @builtins.property
    @jsii.member(jsii_name="algorithmVar")
    def algorithm_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "algorithmVar"))

    @algorithm_var.setter
    def algorithm_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e3cbeda00d62d7b3194cf016e49f773e28699338e445a6c2d768dbbdc601180d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "algorithmVar", value)

    @builtins.property
    @jsii.member(jsii_name="confidence")
    def confidence(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "confidence"))

    @confidence.setter
    def confidence(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__81dc5e29442eaaa37088b322774d858516a78216e85130fcddbea9726e129baa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "confidence", value)

    @builtins.property
    @jsii.member(jsii_name="confidenceVar")
    def confidence_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "confidenceVar"))

    @confidence_var.setter
    def confidence_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6acc1fef1467d22b7811ba1020a9cf34d16a4a277cb64d7490c72d549f23a751)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "confidenceVar", value)

    @builtins.property
    @jsii.member(jsii_name="failGravity")
    def fail_gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravity"))

    @fail_gravity.setter
    def fail_gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ab2e5258d3af76199413182533f65b83212ce9bf9e1f784280d8b2deca7ddae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravity", value)

    @builtins.property
    @jsii.member(jsii_name="failGravityVar")
    def fail_gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravityVar"))

    @fail_gravity_var.setter
    def fail_gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e97261f43c8230d9d39356da1f7a6230b6d2c65ae3fe187830fefb8430988e32)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="focus")
    def focus(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "focus"))

    @focus.setter
    def focus(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8794c18093307f3524ff6f919dd6ba47d64a4e026a341f38b2aa491e8df831de)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "focus", value)

    @builtins.property
    @jsii.member(jsii_name="focusVar")
    def focus_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "focusVar"))

    @focus_var.setter
    def focus_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c1ce4c95866fc7afb19fb188284092de19332f851c3b2cc94949a626131acd49)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "focusVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1c1a81cb9a657beff05e5c7158ce39e282b0d5d4ae57330bd19df20f96ac5017)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b8035272d0c3cc5e3b49a072e1f42fa032dbaae79cb7b4aa07bc817f47b8e473)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__27c2c79ca284d2f07be2092be1b66415eb6747f97371ed6f0564f039c3573c22)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bca9dc3d20b883d1e6678c29a5dae07d923bd03c67f2273a49dccc2dd4f62aaf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1a5b7b1a05ea918ca277a460bf9631b210a85000923da9b8ec6bf4a6a686ba55)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0bbd6922352486ca315806bc08b2bbf8790fd9e5d7ddaa07f1b3060c0c725c55)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ae403f59e0291c76e5c54d6d74417a168b95b2340681b67a67b0d8dc15587c7b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cac67c69deeeb0f0f0320f69deca3f65b1729623480dc6e44f96be986aefb346)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c740ea257e2c3e2f7a6ee4fdc9c7ac3159b36ee35e6f9267ddaffd5570ccbd2c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__60a99b586a419cf8b876e2bfbd888a89ade63ac5e6dd96a0d42851372e2f77a1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualFaceCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualFaceCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualFaceCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1742bb1192fb07c34b2a7ff6b04a110e564d8238b342babb3f343ffc3a910b32)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualFeatureCrop",
    jsii_struct_bases=[],
    name_mapping={
        "fail_gravity": "failGravity",
        "fail_gravity_var": "failGravityVar",
        "feature_radius": "featureRadius",
        "feature_radius_var": "featureRadiusVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "max_features": "maxFeatures",
        "max_features_var": "maxFeaturesVar",
        "min_feature_quality": "minFeatureQuality",
        "min_feature_quality_var": "minFeatureQualityVar",
        "padding": "padding",
        "padding_var": "paddingVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualFeatureCrop:
    def __init__(
        self,
        *,
        fail_gravity: typing.Optional[builtins.str] = None,
        fail_gravity_var: typing.Optional[builtins.str] = None,
        feature_radius: typing.Optional[builtins.str] = None,
        feature_radius_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        max_features: typing.Optional[builtins.str] = None,
        max_features_var: typing.Optional[builtins.str] = None,
        min_feature_quality: typing.Optional[builtins.str] = None,
        min_feature_quality_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fail_gravity: Controls placement of the crop if Image and Video Manager does not detect any features in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        :param fail_gravity_var: Controls placement of the crop if Image and Video Manager does not detect any features in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        :param feature_radius: The size in pixels of the important features to search for. If identified, two features never appear closer together than this value, ``8.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius DataAkamaiImagingPolicyImage#feature_radius}
        :param feature_radius_var: The size in pixels of the important features to search for. If identified, two features never appear closer together than this value, ``8.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius_var DataAkamaiImagingPolicyImage#feature_radius_var}
        :param gravity: Controls placement of the crop. Directions are relative to the region of interest plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Controls placement of the crop. Directions are relative to the region of interest plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param max_features: The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features DataAkamaiImagingPolicyImage#max_features}
        :param max_features_var: The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features_var DataAkamaiImagingPolicyImage#max_features_var}
        :param min_feature_quality: Determines the minimum quality level of the feature identified. To consider a feature important, the feature needs to surpass this value. Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality DataAkamaiImagingPolicyImage#min_feature_quality}
        :param min_feature_quality_var: Determines the minimum quality level of the feature identified. To consider a feature important, the feature needs to surpass this value. Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality_var DataAkamaiImagingPolicyImage#min_feature_quality_var}
        :param padding: Adds space around the region of interest. The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: Adds space around the region of interest. The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        :param style: Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__784c96a8b8084c34a414beb6be64e34c42c11c51a3b292f8eb22f34dd49fbd43)
            check_type(argname="argument fail_gravity", value=fail_gravity, expected_type=type_hints["fail_gravity"])
            check_type(argname="argument fail_gravity_var", value=fail_gravity_var, expected_type=type_hints["fail_gravity_var"])
            check_type(argname="argument feature_radius", value=feature_radius, expected_type=type_hints["feature_radius"])
            check_type(argname="argument feature_radius_var", value=feature_radius_var, expected_type=type_hints["feature_radius_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument max_features", value=max_features, expected_type=type_hints["max_features"])
            check_type(argname="argument max_features_var", value=max_features_var, expected_type=type_hints["max_features_var"])
            check_type(argname="argument min_feature_quality", value=min_feature_quality, expected_type=type_hints["min_feature_quality"])
            check_type(argname="argument min_feature_quality_var", value=min_feature_quality_var, expected_type=type_hints["min_feature_quality_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fail_gravity is not None:
            self._values["fail_gravity"] = fail_gravity
        if fail_gravity_var is not None:
            self._values["fail_gravity_var"] = fail_gravity_var
        if feature_radius is not None:
            self._values["feature_radius"] = feature_radius
        if feature_radius_var is not None:
            self._values["feature_radius_var"] = feature_radius_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if max_features is not None:
            self._values["max_features"] = max_features
        if max_features_var is not None:
            self._values["max_features_var"] = max_features_var
        if min_feature_quality is not None:
            self._values["min_feature_quality"] = min_feature_quality
        if min_feature_quality_var is not None:
            self._values["min_feature_quality_var"] = min_feature_quality_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def fail_gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any features in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        '''
        result = self._values.get("fail_gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any features in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        '''
        result = self._values.get("fail_gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feature_radius(self) -> typing.Optional[builtins.str]:
        '''The size in pixels of the important features to search for.

        If identified, two features never appear closer together than this value, ``8.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius DataAkamaiImagingPolicyImage#feature_radius}
        '''
        result = self._values.get("feature_radius")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feature_radius_var(self) -> typing.Optional[builtins.str]:
        '''The size in pixels of the important features to search for.

        If identified, two features never appear closer together than this value, ``8.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius_var DataAkamaiImagingPolicyImage#feature_radius_var}
        '''
        result = self._values.get("feature_radius_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the region of interest plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the region of interest plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def max_features(self) -> typing.Optional[builtins.str]:
        '''The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features DataAkamaiImagingPolicyImage#max_features}
        '''
        result = self._values.get("max_features")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def max_features_var(self) -> typing.Optional[builtins.str]:
        '''The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features_var DataAkamaiImagingPolicyImage#max_features_var}
        '''
        result = self._values.get("max_features_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def min_feature_quality(self) -> typing.Optional[builtins.str]:
        '''Determines the minimum quality level of the feature identified.

        To consider a feature important, the feature needs to surpass this value.  Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality DataAkamaiImagingPolicyImage#min_feature_quality}
        '''
        result = self._values.get("min_feature_quality")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def min_feature_quality_var(self) -> typing.Optional[builtins.str]:
        '''Determines the minimum quality level of the feature identified.

        To consider a feature important, the feature needs to surpass this value.  Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality_var DataAkamaiImagingPolicyImage#min_feature_quality_var}
        '''
        result = self._values.get("min_feature_quality_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''Adds space around the region of interest.

        The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''Adds space around the region of interest.

        The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualFeatureCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualFeatureCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualFeatureCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2758cd213a6dc24327592fd5f26a97f87159d0722df1f5a136bc9e96d89749b7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualFeatureCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6fdf5e018d33646fa778dfbc23ade8090098c5f563a4830e65e8e2be3d323603)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualFeatureCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__502a847113f1767fbd08ad2e3869402b2cfd5fe9e30b7ccd7a616ba3f68f3f23)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af60cfe816025fc6508b0936a80ab575b97505a07184885d092ec7c3d907308f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__652516a0cd66a515cd15441a7a13088365c5b8399f67fbbd120dffc379cf8e28)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualFeatureCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualFeatureCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualFeatureCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ca44c2bc387623a644809552930eb9e4c4281c59ed0b440058eca0b0f6687e5d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualFeatureCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualFeatureCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__600a431d631215458811d2794622b2c736c86959ed77e843febf09dbeeb4d481)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetFailGravity")
    def reset_fail_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravity", []))

    @jsii.member(jsii_name="resetFailGravityVar")
    def reset_fail_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravityVar", []))

    @jsii.member(jsii_name="resetFeatureRadius")
    def reset_feature_radius(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureRadius", []))

    @jsii.member(jsii_name="resetFeatureRadiusVar")
    def reset_feature_radius_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureRadiusVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetMaxFeatures")
    def reset_max_features(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxFeatures", []))

    @jsii.member(jsii_name="resetMaxFeaturesVar")
    def reset_max_features_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxFeaturesVar", []))

    @jsii.member(jsii_name="resetMinFeatureQuality")
    def reset_min_feature_quality(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMinFeatureQuality", []))

    @jsii.member(jsii_name="resetMinFeatureQualityVar")
    def reset_min_feature_quality_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMinFeatureQualityVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="failGravityInput")
    def fail_gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityVarInput")
    def fail_gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featureRadiusInput")
    def feature_radius_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featureRadiusInput"))

    @builtins.property
    @jsii.member(jsii_name="featureRadiusVarInput")
    def feature_radius_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featureRadiusVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesInput")
    def max_features_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "maxFeaturesInput"))

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesVarInput")
    def max_features_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "maxFeaturesVarInput"))

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityInput")
    def min_feature_quality_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "minFeatureQualityInput"))

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityVarInput")
    def min_feature_quality_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "minFeatureQualityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravity")
    def fail_gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravity"))

    @fail_gravity.setter
    def fail_gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab9c640e4778a69284640050ad15a5f4e6888df17dbaf7788c3c1d63071fb8c3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravity", value)

    @builtins.property
    @jsii.member(jsii_name="failGravityVar")
    def fail_gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravityVar"))

    @fail_gravity_var.setter
    def fail_gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__27454a30fecdc3938e1e420595d7ad732e8fbd7bcc9afe80ea8e607c48095d4e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="featureRadius")
    def feature_radius(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featureRadius"))

    @feature_radius.setter
    def feature_radius(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a6a27f414a239d9589378885f4b6939d9b0eac3083891d3f6c3b3ef505626f57)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featureRadius", value)

    @builtins.property
    @jsii.member(jsii_name="featureRadiusVar")
    def feature_radius_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featureRadiusVar"))

    @feature_radius_var.setter
    def feature_radius_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e341fe7e2a69b81e838530d483b47bdebcdc09d62281d2a392a9d35f8ee2a46b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featureRadiusVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1e096071cc0006b07e4b7247544976a1212ac515b4f3c35b3b15e5c57b93b9a5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3d3c3eea5d9551c3540e7fa494fb89467b2b2600c4845601673b2220a5aa5acd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3e41af1ca78ea24bfcaa8013a482ed089be631688697708c7088909a318ac92f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__67a611aae074401a99a16e1abf33aa8b2e9668773809e2c8d4414414a5f0e5b2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="maxFeatures")
    def max_features(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "maxFeatures"))

    @max_features.setter
    def max_features(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__86665615c891eca7d787b10b30257e710d57dfc84832b6caa41da73c107f3e58)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "maxFeatures", value)

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesVar")
    def max_features_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "maxFeaturesVar"))

    @max_features_var.setter
    def max_features_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f4ed636ce9b05fd9b57ca6db6dd6b9db5f2915afabf2183a5f5ab21a360b3858)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "maxFeaturesVar", value)

    @builtins.property
    @jsii.member(jsii_name="minFeatureQuality")
    def min_feature_quality(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "minFeatureQuality"))

    @min_feature_quality.setter
    def min_feature_quality(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cf68e1b6f52cb0b94590994a9663af0045eed209b315f53f7f91b1ecf3144233)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "minFeatureQuality", value)

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityVar")
    def min_feature_quality_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "minFeatureQualityVar"))

    @min_feature_quality_var.setter
    def min_feature_quality_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a7c50cd7887226976459ce25b55da480fbcc09b7977b83ff596e017591ad6764)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "minFeatureQualityVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c05750e1ec2f5ad109b7cd410d2488c7d81b187fe86858823de6692c00319ec0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d1703865b9da72ea500ee680883e7f5c97f840f9cb9327905096678e1be2a80e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fb21ef1925271c4dcbcffb3645c4787d19a7964f9e1080316ddf02ee917937fa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a3df7a183f5712bcc180f06ab0d308deda0b4d1b6033c44c7af494c282e1305e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7b9ba4774acf50e673a7146ee232c65fa9a517bdd444d1d539755d01dd39d392)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7a325c2207fa741f47208244b581a570a1128aa98719231881d2376915644fc7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualFeatureCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualFeatureCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualFeatureCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__82dac5010658200a342e964a56c3d831cf15893a03cf3e0fb43bc5ae4ae8fc3b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualFitAndFill",
    jsii_struct_bases=[],
    name_mapping={
        "fill_transformation": "fillTransformation",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualFitAndFill:
    def __init__(
        self,
        *,
        fill_transformation: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualFitAndFillFillTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fill_transformation: fill_transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_transformation DataAkamaiImagingPolicyImage#fill_transformation}
        :param height: The height value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The width value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(fill_transformation, dict):
            fill_transformation = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualFitAndFillFillTransformation(**fill_transformation)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__23c6b268d683fac87c251efed31407d918d7a5f37f4f6b5a110197fcaa71350e)
            check_type(argname="argument fill_transformation", value=fill_transformation, expected_type=type_hints["fill_transformation"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fill_transformation is not None:
            self._values["fill_transformation"] = fill_transformation
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def fill_transformation(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualFitAndFillFillTransformation"]:
        '''fill_transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_transformation DataAkamaiImagingPolicyImage#fill_transformation}
        '''
        result = self._values.get("fill_transformation")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualFitAndFillFillTransformation"], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualFitAndFill(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualFitAndFillFillTransformation",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualFitAndFillFillTransformation:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualFitAndFillFillTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualFitAndFillFillTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualFitAndFillFillTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6299d93c7712e9e5b98d4ce8e165751ec17e6154407118526ad4f3d76f8de8f9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualFitAndFillFillTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualFitAndFillFillTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualFitAndFillFillTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cb77e1525d1d64b9e8b8c2a80b9759813ba061722c720059aa8e048a2e921526)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualFitAndFillList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualFitAndFillList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c835ed8c716db112493f7a27a2eab5a35b8fcf0fd732bb19c18a273b4094d6c2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualFitAndFillOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d9e0b77a9002c75c832543af099fa2382cf938e8974c0eef98bed93e3498cabd)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualFitAndFillOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e32a0cc13d054915cb6d25a6a54d4d86fbe917479d476fe5afeb374d85a6339a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__52007c87a5325083732ae2a53a0aefa945d31564070aad12f2d9584515e6efd5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ae14f75de968ff88b2621e8dca9d7c66ac3a1997288579c2bae251a9d19395f7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualFitAndFill]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualFitAndFill]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualFitAndFill]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e973022c1487d5e3118344bc916a475f770c8f21621f6f427283e03f4dbb80ff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualFitAndFillOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualFitAndFillOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bd9febdb809b8be7f091c174e0afe80116b3434bd80733d4b437ea3c215ba97d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putFillTransformation")
    def put_fill_transformation(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualFitAndFillFillTransformation()

        return typing.cast(None, jsii.invoke(self, "putFillTransformation", [value]))

    @jsii.member(jsii_name="resetFillTransformation")
    def reset_fill_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFillTransformation", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="fillTransformation")
    def fill_transformation(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualFitAndFillFillTransformationOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualFitAndFillFillTransformationOutputReference, jsii.get(self, "fillTransformation"))

    @builtins.property
    @jsii.member(jsii_name="fillTransformationInput")
    def fill_transformation_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualFitAndFillFillTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualFitAndFillFillTransformation], jsii.get(self, "fillTransformationInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a0a38d5ad6002192dd6a34f624e09fecef661c95674108b83647ee81e77d7f60)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c05e55d92b821cdcc84805be2263e96afec225e02753f4eed480c73a3a7e4eeb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__67e24f61e500eca5e49e6d8629d5844c5fad91b410dfa743cd0f73e6ed6aabb2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__732d3718c34ad66d1ed61391f47f8be3b387685a3d1faf23b4cae3e059184c20)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualFitAndFill]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualFitAndFill]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualFitAndFill]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e922a119482bf20f0f0313608e16f0c9505bacc8f563611d0d9ddc6126292291)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualGoop",
    jsii_struct_bases=[],
    name_mapping={
        "chaos": "chaos",
        "chaos_var": "chaosVar",
        "density": "density",
        "density_var": "densityVar",
        "power": "power",
        "power_var": "powerVar",
        "seed": "seed",
        "seed_var": "seedVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualGoop:
    def __init__(
        self,
        *,
        chaos: typing.Optional[builtins.str] = None,
        chaos_var: typing.Optional[builtins.str] = None,
        density: typing.Optional[builtins.str] = None,
        density_var: typing.Optional[builtins.str] = None,
        power: typing.Optional[builtins.str] = None,
        power_var: typing.Optional[builtins.str] = None,
        seed: typing.Optional[builtins.str] = None,
        seed_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param chaos: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        :param chaos_var: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        :param density: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        :param density_var: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        :param power: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        :param power_var: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        :param seed: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        :param seed_var: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b2e81a9930e38e987a09ed0845c73917a23b72dfcf2e0b3f43d4946d47e937c9)
            check_type(argname="argument chaos", value=chaos, expected_type=type_hints["chaos"])
            check_type(argname="argument chaos_var", value=chaos_var, expected_type=type_hints["chaos_var"])
            check_type(argname="argument density", value=density, expected_type=type_hints["density"])
            check_type(argname="argument density_var", value=density_var, expected_type=type_hints["density_var"])
            check_type(argname="argument power", value=power, expected_type=type_hints["power"])
            check_type(argname="argument power_var", value=power_var, expected_type=type_hints["power_var"])
            check_type(argname="argument seed", value=seed, expected_type=type_hints["seed"])
            check_type(argname="argument seed_var", value=seed_var, expected_type=type_hints["seed_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if chaos is not None:
            self._values["chaos"] = chaos
        if chaos_var is not None:
            self._values["chaos_var"] = chaos_var
        if density is not None:
            self._values["density"] = density
        if density_var is not None:
            self._values["density_var"] = density_var
        if power is not None:
            self._values["power"] = power
        if power_var is not None:
            self._values["power_var"] = power_var
        if seed is not None:
            self._values["seed"] = seed
        if seed_var is not None:
            self._values["seed_var"] = seed_var

    @builtins.property
    def chaos(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        '''
        result = self._values.get("chaos")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def chaos_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        '''
        result = self._values.get("chaos_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        '''
        result = self._values.get("density")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density_var(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        '''
        result = self._values.get("density_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        '''
        result = self._values.get("power")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power_var(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        '''
        result = self._values.get("power_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        '''
        result = self._values.get("seed")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed_var(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        result = self._values.get("seed_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualGoop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualGoopList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualGoopList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5127ca5da99f793759cbb3539f2961005c8b9f98d07f4eb0ab2bf2db344a1e60)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualGoopOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__25960b1119d8f4ef87f13d4d53065a1f99145b09a0250f640186423b46ae706e)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualGoopOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bdcac14ec4643995e4c79ed619eddf8380374061208b49096cbd2d489e8bb8e6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c504db7796114184bed92a7281f6f600da80f9768263cad3d9e26820874a9128)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d4427f7ec9f7a5e306519760a5cadaf107b5c1c48dafe3dbc36f4ca8342d543c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualGoop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualGoop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7e0cbc933c1200adde0eff6564ae325173fe8ade08386726a0bc668dbeb7e609)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualGoopOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualGoopOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d726ebb6b60102b5580f990be60b3349e9dde25da795274d44086fafe1a3cdac)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetChaos")
    def reset_chaos(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaos", []))

    @jsii.member(jsii_name="resetChaosVar")
    def reset_chaos_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaosVar", []))

    @jsii.member(jsii_name="resetDensity")
    def reset_density(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensity", []))

    @jsii.member(jsii_name="resetDensityVar")
    def reset_density_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensityVar", []))

    @jsii.member(jsii_name="resetPower")
    def reset_power(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPower", []))

    @jsii.member(jsii_name="resetPowerVar")
    def reset_power_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPowerVar", []))

    @jsii.member(jsii_name="resetSeed")
    def reset_seed(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeed", []))

    @jsii.member(jsii_name="resetSeedVar")
    def reset_seed_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeedVar", []))

    @builtins.property
    @jsii.member(jsii_name="chaosInput")
    def chaos_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosInput"))

    @builtins.property
    @jsii.member(jsii_name="chaosVarInput")
    def chaos_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosVarInput"))

    @builtins.property
    @jsii.member(jsii_name="densityInput")
    def density_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityInput"))

    @builtins.property
    @jsii.member(jsii_name="densityVarInput")
    def density_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="powerInput")
    def power_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerInput"))

    @builtins.property
    @jsii.member(jsii_name="powerVarInput")
    def power_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerVarInput"))

    @builtins.property
    @jsii.member(jsii_name="seedInput")
    def seed_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedInput"))

    @builtins.property
    @jsii.member(jsii_name="seedVarInput")
    def seed_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedVarInput"))

    @builtins.property
    @jsii.member(jsii_name="chaos")
    def chaos(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaos"))

    @chaos.setter
    def chaos(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d842a0edba31d00bdf81e59b6a33f1d03312823d4373638ff0d84301d6f459d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaos", value)

    @builtins.property
    @jsii.member(jsii_name="chaosVar")
    def chaos_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaosVar"))

    @chaos_var.setter
    def chaos_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6930ed7122ee228ceb0dad4c2fffc8bbd6a8ffec19a44542b4968200bc66eae2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaosVar", value)

    @builtins.property
    @jsii.member(jsii_name="density")
    def density(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "density"))

    @density.setter
    def density(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a6fe2120edd3069f3fcb8c1b78af04cd98d3028fb879937fd54b15024f4e0876)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "density", value)

    @builtins.property
    @jsii.member(jsii_name="densityVar")
    def density_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "densityVar"))

    @density_var.setter
    def density_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d88559bb5a1bedc40cae81b8e216a8655f3fa5243344d0bb96d84dc70d0fbc25)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "densityVar", value)

    @builtins.property
    @jsii.member(jsii_name="power")
    def power(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "power"))

    @power.setter
    def power(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f2334d4de438e0100cde49f2c44567369b0ff9909ff71db171f1c87330792bb9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "power", value)

    @builtins.property
    @jsii.member(jsii_name="powerVar")
    def power_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "powerVar"))

    @power_var.setter
    def power_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d940fbf42d0c5f56b010276a325ad8bd0d9e52c6ed015e0977b4dff1fe0171a7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "powerVar", value)

    @builtins.property
    @jsii.member(jsii_name="seed")
    def seed(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seed"))

    @seed.setter
    def seed(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f231e7a157128f172f1ce66b8b3e9637d5260016c2a326abfb7013a0519ff75f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seed", value)

    @builtins.property
    @jsii.member(jsii_name="seedVar")
    def seed_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seedVar"))

    @seed_var.setter
    def seed_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__374c2464954e75a39ed220107d9d765e84d33c848ffb80a80789a46f2ea998f2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seedVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualGoop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualGoop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualGoop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d28bc53c974a45f2c598a283d23af7313f1b08c081c341fb5047c151ea87e80b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualGrayscale",
    jsii_struct_bases=[],
    name_mapping={"type": "type", "type_var": "typeVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualGrayscale:
    def __init__(
        self,
        *,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param type: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f8578aaa24b0bae3121423a424ceff369040176f9cdd8a409d0cdb292b37dc34)
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualGrayscale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualGrayscaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualGrayscaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d51cbef6224ff7e689787d007e39cb2b0562f1af06d69a4d4550d64486411894)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualGrayscaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1e59965d626203a955f216153ad03d989dd130d7f6a4645ff264c37ea069270e)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualGrayscaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2b2c3d7506f720eda6fdd7405dc1aae79361cb92c0a08ba5e59e5ad011d11e91)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__13c5fa73149423397e413b27428dc2b6bf6c4b2be18c666fb0633ca069d932d5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a3e7d775ca4c0abd445678c2ee6560e2077245fce50bc8b24f906939a42a63fe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualGrayscale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualGrayscale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__28fd2582b037a8762060511c9cf5cecd8224be2935996303b155d8ba0c77cc2a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualGrayscaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualGrayscaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__39be2b82153f5a800e5aae42e988e30ff6d7ddbb04f3f4f6abe818b22599d3df)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__579a03ef0de4816387ff336b7918e1cb02193e6db500fb49b01c53cc42336ce4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0a8e2dc746f7b0ea3053763848cc122b8bc325fd114a202475bb55f027abe45c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualGrayscale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualGrayscale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualGrayscale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__787602d4a5645f4b6003ca62f0dd783b54c6dfbfeb7db729568f02411be2063a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualHsl",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "lightness": "lightness",
        "lightness_var": "lightnessVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualHsl:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness: typing.Optional[builtins.str] = None,
        lightness_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        :param lightness_var: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a4bae521a4233e5f73d23b612ad21eb561dc4ee5d908ced0ca74f80e12b414f2)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness", value=lightness, expected_type=type_hints["lightness"])
            check_type(argname="argument lightness_var", value=lightness_var, expected_type=type_hints["lightness_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness is not None:
            self._values["lightness"] = lightness
        if lightness_var is not None:
            self._values["lightness_var"] = lightness_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        '''
        result = self._values.get("lightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        '''
        result = self._values.get("lightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualHsl(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualHslList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualHslList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ceaa0420daa478f98970cbf16f34a64f91e2bcbb2b6cdf5b747b240964013f9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualHslOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3d224b4032b5ddeb0462fc358d9bb6096e652f17667c87a87f2df4a8ea78caf0)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualHslOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__770b8b442e3a397c04d0111afc904c725e24546a3e922ca11690746b47918cef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__14727f3f6b0cbf60b8b0c5e00adaea1db779dffb6818e02df77c145889c30d95)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa0094f8f964f611b22377640b68432a86cb58a943a31e22192503a8bf2334c7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualHsl]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualHsl]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f19ecca2b4141e073718592e8a7a77a2ce6d6935df13331efe0a0385f925dc9d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualHslOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualHslOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0e58e50c86812ebe9e5de1d49de9c5b0e7a56f592141f799c3fb285597f34408)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightness")
    def reset_lightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightness", []))

    @jsii.member(jsii_name="resetLightnessVar")
    def reset_lightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessInput")
    def lightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessVarInput")
    def lightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__93c33c542230399e49ea9eff2a067c5bda4a178c0b4cb96cfbc6aada3b63d42f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__65b8bd73cddd67fffcb38de62a9aabe4857c73c43d40b094a88f0ef4aa7017c5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightness")
    def lightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightness"))

    @lightness.setter
    def lightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__45deb9b48dabc1041c77a1ff045ac5e7a35a0ed6133c3280f83b53b33abb73c8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightness", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessVar")
    def lightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessVar"))

    @lightness_var.setter
    def lightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__910390ac552eeddc73fe3cb5a1167fcd2e8a96473307be70dc2ff80ad5ab163f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4f9a032e24bc3ec59b02e4c8ba784f8d7bb3efc93fb331fefe69bd9110dd5cbd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__077583e0a69f17a9c56be193d479593e4af6b18cfdd5f96f0226376baf51f061)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualHsl]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualHsl]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualHsl]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8efb1e6945c7a1ac0160ee8330b9d3eaf336069eb8dac841611c7cd9e09ed638)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualHsv",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualHsv:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        :param value: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1c2ae85bbdb68afb1352192ffc08be5fc10345fce860ea9a65b1a272911d4c22)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualHsv(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualHsvList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualHsvList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5cb22882f031b385812e1d4e911e9aad39ad0e09ac0b98a161ee209a56efe9ee)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualHsvOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__088e3beb7c1e4965fa822cfb91b51d7f3dc3f5cbffd6a308b353e8be0a6b8388)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualHsvOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bda41b55b62c649b468578754b14be08078e09218472b9c3ef7c29a5f17e9eb8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1b6ffeee9f31eb3b11d32122cb295e39639bb3d49554a171fbcc0e77fc4fc625)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3dabe0a65bddf45b7db7ab4ddefceea7607de6fd9bf46a29e04e92eb301c5529)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualHsv]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualHsv]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c2d39f0c54e94d287c07ae9e43ee76f7ba2eb2ead9d8497d226153b4ad259b6c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualHsvOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualHsvOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__23cbfe13a61ffb507faa0552bbbbd0ca6d1034c7668e164d69250c9d5ffdfc81)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac9f90f29bf188fff489106dd19ee8efe757b4fc4cfb11aa31f5fa4e6f3ede90)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0a0882e0346559eaa4ca69d0915c1a17349d51a8c497a1c03743e83dd770a090)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5e5d0a2e9e1f4a9a9c39a77db875c91ce284fdc0947985628f7aac5428f12a09)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3d53acdd7a8448ba01279e3849ca9ac55690f03c5559d6e4e48512d325c53391)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c3ea8b973ce3f93a0cf949fbda7c65e905e688fde3b6e2ad5de112a77db6813d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6639ea9119c12d966180405332309727f4e933372d0a5725c58c640c3ea268e9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualHsv]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualHsv]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualHsv]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4b7ae2d9697bce0d70074c9cc558de5b065912457fae18e8e2c6362b0c617923)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfDimension",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "dimension": "dimension",
        "dimension_var": "dimensionVar",
        "equal": "equal",
        "greater_than": "greaterThan",
        "less_than": "lessThan",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfDimension:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfDimensionDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        dimension: typing.Optional[builtins.str] = None,
        dimension_var: typing.Optional[builtins.str] = None,
        equal: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfDimensionEqual", typing.Dict[builtins.str, typing.Any]]] = None,
        greater_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfDimensionGreaterThan", typing.Dict[builtins.str, typing.Any]]] = None,
        less_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfDimensionLessThan", typing.Dict[builtins.str, typing.Any]]] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param dimension: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        :param dimension_var: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        :param equal: equal block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        :param greater_than: greater_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        :param less_than: less_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        :param value: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfDimensionDefault(**default)
        if isinstance(equal, dict):
            equal = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfDimensionEqual(**equal)
        if isinstance(greater_than, dict):
            greater_than = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfDimensionGreaterThan(**greater_than)
        if isinstance(less_than, dict):
            less_than = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfDimensionLessThan(**less_than)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__292c121facc4aa6c7e485fb849552f28f055f4690fa525b855b8c5c450a81426)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument dimension", value=dimension, expected_type=type_hints["dimension"])
            check_type(argname="argument dimension_var", value=dimension_var, expected_type=type_hints["dimension_var"])
            check_type(argname="argument equal", value=equal, expected_type=type_hints["equal"])
            check_type(argname="argument greater_than", value=greater_than, expected_type=type_hints["greater_than"])
            check_type(argname="argument less_than", value=less_than, expected_type=type_hints["less_than"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if dimension is not None:
            self._values["dimension"] = dimension
        if dimension_var is not None:
            self._values["dimension_var"] = dimension_var
        if equal is not None:
            self._values["equal"] = equal
        if greater_than is not None:
            self._values["greater_than"] = greater_than
        if less_than is not None:
            self._values["less_than"] = less_than
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfDimensionDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfDimensionDefault"], result)

    @builtins.property
    def dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        '''
        result = self._values.get("dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        '''
        result = self._values.get("dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def equal(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfDimensionEqual"]:
        '''equal block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        '''
        result = self._values.get("equal")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfDimensionEqual"], result)

    @builtins.property
    def greater_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfDimensionGreaterThan"]:
        '''greater_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        '''
        result = self._values.get("greater_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfDimensionGreaterThan"], result)

    @builtins.property
    def less_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfDimensionLessThan"]:
        '''less_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        '''
        result = self._values.get("less_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfDimensionLessThan"], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfDimension(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfDimensionDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfDimensionDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfDimensionDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfDimensionDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfDimensionDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c5795cc34f27c66021208f8cf2edc9e5510bb8161e3c56040e4a862752b91542)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfDimensionDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfDimensionDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8ef5bb0ae2e835bfbeaba67beae2c5fd9810a818dc2782ab0f53b2610703d5fe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfDimensionEqual",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfDimensionEqual:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfDimensionEqual(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfDimensionEqualOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfDimensionEqualOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bdd1f050fd5d8da79f3c64308789b3bd89de53d13b61f7fb40d254c250b5bd0d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfDimensionEqual], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfDimensionEqual],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c7db84b0ee2fac679b9e465d2d1340e2a2f8e8f6b5d163a11e040ffe887c1349)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfDimensionGreaterThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfDimensionGreaterThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfDimensionGreaterThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfDimensionGreaterThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfDimensionGreaterThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f1236ea3c9fb647f2056d99ddcad7d4508783995e697cbb7b46e91f99e669bdf)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfDimensionGreaterThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfDimensionGreaterThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a96fc2bc5f3ada1f9a9b0ca1def0f4609d267564bd040cb3314bd0a94791a759)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfDimensionLessThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfDimensionLessThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfDimensionLessThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfDimensionLessThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfDimensionLessThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__21d1072c251d40885ebbdf3d3062370a91f3fad234e166010303e09a8410bd0f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfDimensionLessThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfDimensionLessThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6cdf6b8dd54eb7e266058d3178c81fb7ac1e1348962ae50825342cf2a2a54398)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfDimensionList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfDimensionList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ae8fdfe40f60546bd00507fdba2b43abfab39e9e479767962d1376eccd25b6bb)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfDimensionOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d6f48592f7577875fdb9366c15aaad8df1916038a7e49839682c311821cadcfc)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfDimensionOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0dcbecbe782917831585fb26a5872a4dc9030f5180b766bababb8ff4c0fe8532)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__12278cf720e5267a525c54f8e4786a62c1bd93a070888178535010f5c0ce0e11)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1e9cf37883249b1d6a7f3e30a538a6c0bd903cb4c4b55364675425a0d32d1887)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfDimension]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfDimension]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e0dca66ddbaa7ade757a1a769d425a4f74890d7319ba59d5536960a509ad0815)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfDimensionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfDimensionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e17a6fc1449a466e203cb077cff660e87f92cacff458a601539aa2b649505143)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfDimensionDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putEqual")
    def put_equal(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfDimensionEqual()

        return typing.cast(None, jsii.invoke(self, "putEqual", [value]))

    @jsii.member(jsii_name="putGreaterThan")
    def put_greater_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfDimensionGreaterThan()

        return typing.cast(None, jsii.invoke(self, "putGreaterThan", [value]))

    @jsii.member(jsii_name="putLessThan")
    def put_less_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfDimensionLessThan()

        return typing.cast(None, jsii.invoke(self, "putLessThan", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetDimension")
    def reset_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimension", []))

    @jsii.member(jsii_name="resetDimensionVar")
    def reset_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimensionVar", []))

    @jsii.member(jsii_name="resetEqual")
    def reset_equal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEqual", []))

    @jsii.member(jsii_name="resetGreaterThan")
    def reset_greater_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGreaterThan", []))

    @jsii.member(jsii_name="resetLessThan")
    def reset_less_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLessThan", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfDimensionDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfDimensionDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="equal")
    def equal(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfDimensionEqualOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfDimensionEqualOutputReference, jsii.get(self, "equal"))

    @builtins.property
    @jsii.member(jsii_name="greaterThan")
    def greater_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfDimensionGreaterThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfDimensionGreaterThanOutputReference, jsii.get(self, "greaterThan"))

    @builtins.property
    @jsii.member(jsii_name="lessThan")
    def less_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfDimensionLessThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfDimensionLessThanOutputReference, jsii.get(self, "lessThan"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfDimensionDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionInput")
    def dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionVarInput")
    def dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="equalInput")
    def equal_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfDimensionEqual], jsii.get(self, "equalInput"))

    @builtins.property
    @jsii.member(jsii_name="greaterThanInput")
    def greater_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfDimensionGreaterThan], jsii.get(self, "greaterThanInput"))

    @builtins.property
    @jsii.member(jsii_name="lessThanInput")
    def less_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfDimensionLessThan], jsii.get(self, "lessThanInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="dimension")
    def dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimension"))

    @dimension.setter
    def dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ff0b273defab6c3fc80517716e7cd2091fde3d558075603e1ac0fd5eca2fcf4f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimension", value)

    @builtins.property
    @jsii.member(jsii_name="dimensionVar")
    def dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimensionVar"))

    @dimension_var.setter
    def dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ec7762e382c3d327fa68b3f50d7fdb5961125fa9040610b608645498f4bc72b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bd9539fa904b87487e4e9868dcc02abafb00b7f32075ced1995aee7896f403ca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__26031a3250e5b23d2191082c7fae47a188f41c7b56055a55495f1f0fc0cfa55c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfDimension]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfDimension]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfDimension]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c2b0662970a60711155edd657dfc7bdd109d8b8320ab7defa3a2f7f30563756d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfOrientation",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "landscape": "landscape",
        "portrait": "portrait",
        "square": "square",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfOrientation:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfOrientationDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        landscape: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfOrientationLandscape", typing.Dict[builtins.str, typing.Any]]] = None,
        portrait: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfOrientationPortrait", typing.Dict[builtins.str, typing.Any]]] = None,
        square: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfOrientationSquare", typing.Dict[builtins.str, typing.Any]]] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param landscape: landscape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        :param portrait: portrait block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        :param square: square block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfOrientationDefault(**default)
        if isinstance(landscape, dict):
            landscape = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfOrientationLandscape(**landscape)
        if isinstance(portrait, dict):
            portrait = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfOrientationPortrait(**portrait)
        if isinstance(square, dict):
            square = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfOrientationSquare(**square)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__48421246f8cec789e6745c489c8b25053d537860b6e2e46c12b673f1912fa1ec)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument landscape", value=landscape, expected_type=type_hints["landscape"])
            check_type(argname="argument portrait", value=portrait, expected_type=type_hints["portrait"])
            check_type(argname="argument square", value=square, expected_type=type_hints["square"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if landscape is not None:
            self._values["landscape"] = landscape
        if portrait is not None:
            self._values["portrait"] = portrait
        if square is not None:
            self._values["square"] = square

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfOrientationDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfOrientationDefault"], result)

    @builtins.property
    def landscape(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfOrientationLandscape"]:
        '''landscape block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        '''
        result = self._values.get("landscape")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfOrientationLandscape"], result)

    @builtins.property
    def portrait(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfOrientationPortrait"]:
        '''portrait block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        '''
        result = self._values.get("portrait")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfOrientationPortrait"], result)

    @builtins.property
    def square(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfOrientationSquare"]:
        '''square block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        result = self._values.get("square")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfOrientationSquare"], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfOrientation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfOrientationDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfOrientationDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfOrientationDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfOrientationDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfOrientationDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__577a0051f83860fbfb3b55d44fb87d70b5d50c9e7d834fced6472a8bf67e9692)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfOrientationDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfOrientationDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__acbc6dcca949ea47a979ebe5ccb96a54620fa3f99b235d08c0eb20819e3784ad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfOrientationLandscape",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfOrientationLandscape:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfOrientationLandscape(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfOrientationLandscapeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfOrientationLandscapeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ade2506934127434844799e51172e0e6174ad416cec3ad916f41df91bb154220)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfOrientationLandscape], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfOrientationLandscape],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dba7631193d68f4eace5c16480e3c37e332b8bd8e32dd4d5662b4850ff012412)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfOrientationList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfOrientationList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3d388afc02a637fa3305d042bc2eb0b0b04496935399b92afff3f742e1c88eef)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfOrientationOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__47770a384568aae2228a32026426807d52880c26779c231eba318aab5808d6b0)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfOrientationOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3d5faec7e03710df4c53bc6d239f9269ea721eb2b6b9e473456118181aaefdd2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__db691008719429502efea7688e3d2836d70c378931267f4c2ccb7cfea1d4c390)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__05a64e3a6fd6500ae2ea297330ce64ad86817401ae35a4b1872519f0a0e7e421)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfOrientation]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfOrientation]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__641932e67629d069344307994a0ee1c3cf9b9f29394bd63fdafa8c326bb20bc1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfOrientationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfOrientationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c737d1f06566bdb88382f70fa5eb130d594ee173b3da8c65fa7ce0d2e285d302)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfOrientationDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putLandscape")
    def put_landscape(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfOrientationLandscape()

        return typing.cast(None, jsii.invoke(self, "putLandscape", [value]))

    @jsii.member(jsii_name="putPortrait")
    def put_portrait(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfOrientationPortrait()

        return typing.cast(None, jsii.invoke(self, "putPortrait", [value]))

    @jsii.member(jsii_name="putSquare")
    def put_square(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfOrientationSquare()

        return typing.cast(None, jsii.invoke(self, "putSquare", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetLandscape")
    def reset_landscape(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLandscape", []))

    @jsii.member(jsii_name="resetPortrait")
    def reset_portrait(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPortrait", []))

    @jsii.member(jsii_name="resetSquare")
    def reset_square(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSquare", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfOrientationDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfOrientationDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="landscape")
    def landscape(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfOrientationLandscapeOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfOrientationLandscapeOutputReference, jsii.get(self, "landscape"))

    @builtins.property
    @jsii.member(jsii_name="portrait")
    def portrait(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfOrientationPortraitOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfOrientationPortraitOutputReference", jsii.get(self, "portrait"))

    @builtins.property
    @jsii.member(jsii_name="square")
    def square(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfOrientationSquareOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfOrientationSquareOutputReference", jsii.get(self, "square"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfOrientationDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="landscapeInput")
    def landscape_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfOrientationLandscape], jsii.get(self, "landscapeInput"))

    @builtins.property
    @jsii.member(jsii_name="portraitInput")
    def portrait_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfOrientationPortrait"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfOrientationPortrait"], jsii.get(self, "portraitInput"))

    @builtins.property
    @jsii.member(jsii_name="squareInput")
    def square_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfOrientationSquare"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfOrientationSquare"], jsii.get(self, "squareInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfOrientation]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfOrientation]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfOrientation]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__19b265c08f7e7f1e4f757a10773d08f89f50a28e97aacb4f866792f0761ea199)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfOrientationPortrait",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfOrientationPortrait:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfOrientationPortrait(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfOrientationPortraitOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfOrientationPortraitOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6af24c322fd1a95b39ecc9634051d51fafa77f3afca474a54860a60649ac63af)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfOrientationPortrait]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfOrientationPortrait], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfOrientationPortrait],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__34a087d74727cf52b8eb28b03d5b104051ebb237270247de77d3f9a88156b606)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfOrientationSquare",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfOrientationSquare:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfOrientationSquare(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfOrientationSquareOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfOrientationSquareOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__58a1fb68d990f37d47b2653104b90d2de4700170bd2b84df3cee5928d0fc5e51)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfOrientationSquare]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfOrientationSquare], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfOrientationSquare],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__896e6a9a42c4f3e7f246a1e7f91ac6c33f11bf43f4aaf09749277ca21019ff14)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualImQuery",
    jsii_struct_bases=[],
    name_mapping={
        "allowed_transformations": "allowedTransformations",
        "query_var": "queryVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualImQuery:
    def __init__(
        self,
        *,
        allowed_transformations: typing.Sequence[builtins.str],
        query_var: builtins.str,
    ) -> None:
        '''
        :param allowed_transformations: Specifies the transformations that can be applied using the query string parameter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allowed_transformations DataAkamaiImagingPolicyImage#allowed_transformations}
        :param query_var: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#query_var DataAkamaiImagingPolicyImage#query_var}.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3f81342e0b2ebef96b472c87be4b9bf7dd5a3d02cb3a34e7e2ce2168b158e9b8)
            check_type(argname="argument allowed_transformations", value=allowed_transformations, expected_type=type_hints["allowed_transformations"])
            check_type(argname="argument query_var", value=query_var, expected_type=type_hints["query_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "allowed_transformations": allowed_transformations,
            "query_var": query_var,
        }

    @builtins.property
    def allowed_transformations(self) -> typing.List[builtins.str]:
        '''Specifies the transformations that can be applied using the query string parameter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allowed_transformations DataAkamaiImagingPolicyImage#allowed_transformations}
        '''
        result = self._values.get("allowed_transformations")
        assert result is not None, "Required property 'allowed_transformations' is missing"
        return typing.cast(typing.List[builtins.str], result)

    @builtins.property
    def query_var(self) -> builtins.str:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#query_var DataAkamaiImagingPolicyImage#query_var}.'''
        result = self._values.get("query_var")
        assert result is not None, "Required property 'query_var' is missing"
        return typing.cast(builtins.str, result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualImQuery(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualImQueryList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualImQueryList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d33247dedeb514903b7e4e55fe7271d39a499435f29e93a1ee7327e1e40cac03)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualImQueryOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d9356667eaefe500641d1c991b888edad637c6607dc1b2f0aafd0697a233f0bf)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualImQueryOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__792c279eb7de7cffe795fa76c28199d81e9f2c8e3d405ddbd1d504cf3a5d63e5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a27058ebfaf164b5a6021ad8ddfc376e65fdf3541ab61585c0d417c555a8763f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__712b7d57219697b2281e7a4f1af504a83be3bef22c8579b586ca3315b2494e6f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualImQuery]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualImQuery]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualImQuery]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ab0d465907fbc13f7257361c40e646332eacd6e582473cfcf194cbe78f30568)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualImQueryOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualImQueryOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7228d8ed0e783660b313fd61729bdd460200945b4ec74756475c532db053f07c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @builtins.property
    @jsii.member(jsii_name="allowedTransformationsInput")
    def allowed_transformations_input(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "allowedTransformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="queryVarInput")
    def query_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "queryVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowedTransformations")
    def allowed_transformations(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "allowedTransformations"))

    @allowed_transformations.setter
    def allowed_transformations(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__350ba57595ff5f2481cff4caec18f1634fe1a6d2d06b3bb8b72b7098c8e49f61)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowedTransformations", value)

    @builtins.property
    @jsii.member(jsii_name="queryVar")
    def query_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "queryVar"))

    @query_var.setter
    def query_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a1a91e4792d7fdc4ed33bba519a5420e7e06737720361a9b82358108c79d400b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "queryVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualImQuery]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualImQuery]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualImQuery]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5e0a8fa7b0908e9c93550a4823273735bd77c748ff6492c92ca86a53c3dbdbaf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualMaxColors",
    jsii_struct_bases=[],
    name_mapping={"colors": "colors", "colors_var": "colorsVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualMaxColors:
    def __init__(
        self,
        *,
        colors: typing.Optional[builtins.str] = None,
        colors_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param colors: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        :param colors_var: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__541d9a857866bd9fec8f4a2c05ccdf0f60ca87d0ad96de5c0d57f5d74f582ca6)
            check_type(argname="argument colors", value=colors, expected_type=type_hints["colors"])
            check_type(argname="argument colors_var", value=colors_var, expected_type=type_hints["colors_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if colors is not None:
            self._values["colors"] = colors
        if colors_var is not None:
            self._values["colors_var"] = colors_var

    @builtins.property
    def colors(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        '''
        result = self._values.get("colors")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def colors_var(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        result = self._values.get("colors_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualMaxColors(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualMaxColorsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualMaxColorsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__61d0c3a7ad9e9c88e84c5c3f2d38f62671372835ef0d73fa4088d1b514e738ff)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualMaxColorsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e2582efcaf618f8ac30b9ff6bbc734930378d2b1e06ce4e3e4e9ea18bf488e3b)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualMaxColorsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f70a4bba1991aac46484f1015ab30af607ecf2daeac33063859a5b2a864c828)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f0ec93aa8347c39772ebbd0b7d6070541f37606d9cec977615222a25e30cefe0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__88abccb8d5325e7c9bb128de44bbfc5d72bf190de1ce6665a8333be076b9a6d6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualMaxColors]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualMaxColors]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4c8c75644061c58620aec5dac8886de1cbee2fe775a4b69b983cd31f656ef77d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualMaxColorsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualMaxColorsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__05b834abbf525b554bb5269cb2d23ed18fcc334291ede6e15fc76a3d96a3dde7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColors")
    def reset_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColors", []))

    @jsii.member(jsii_name="resetColorsVar")
    def reset_colors_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorsVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorsInput")
    def colors_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsInput"))

    @builtins.property
    @jsii.member(jsii_name="colorsVarInput")
    def colors_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsVarInput"))

    @builtins.property
    @jsii.member(jsii_name="colors")
    def colors(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colors"))

    @colors.setter
    def colors(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8815e0b71ac781ac8764a185e78b5ceb523ee4d2770e45af918512a1ba337dde)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colors", value)

    @builtins.property
    @jsii.member(jsii_name="colorsVar")
    def colors_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorsVar"))

    @colors_var.setter
    def colors_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dc0e3ba1619313baec95defb8e67c9fd0a32e6348588f6a201e8ee8d0e001ace)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorsVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualMaxColors]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualMaxColors]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualMaxColors]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eb7421ae7b9a6fe1bc0eb03c1e219d645c673f6c318070da8645d3469226a87c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualMirror",
    jsii_struct_bases=[],
    name_mapping={
        "horizontal": "horizontal",
        "horizontal_var": "horizontalVar",
        "vertical": "vertical",
        "vertical_var": "verticalVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualMirror:
    def __init__(
        self,
        *,
        horizontal: typing.Optional[builtins.str] = None,
        horizontal_var: typing.Optional[builtins.str] = None,
        vertical: typing.Optional[builtins.str] = None,
        vertical_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param horizontal: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        :param horizontal_var: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        :param vertical: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        :param vertical_var: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd3059321df5551b673f73684050aec03bc495fd7d177109e65c9d1e847dcaa2)
            check_type(argname="argument horizontal", value=horizontal, expected_type=type_hints["horizontal"])
            check_type(argname="argument horizontal_var", value=horizontal_var, expected_type=type_hints["horizontal_var"])
            check_type(argname="argument vertical", value=vertical, expected_type=type_hints["vertical"])
            check_type(argname="argument vertical_var", value=vertical_var, expected_type=type_hints["vertical_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if horizontal is not None:
            self._values["horizontal"] = horizontal
        if horizontal_var is not None:
            self._values["horizontal_var"] = horizontal_var
        if vertical is not None:
            self._values["vertical"] = vertical
        if vertical_var is not None:
            self._values["vertical_var"] = vertical_var

    @builtins.property
    def horizontal(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        '''
        result = self._values.get("horizontal")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def horizontal_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        '''
        result = self._values.get("horizontal_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        '''
        result = self._values.get("vertical")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        result = self._values.get("vertical_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualMirror(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualMirrorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualMirrorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9682ed6bdb7d9bdcfab963ed494e7f99ca6530fa92d2a6f84b12fc3b6d336f91)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualMirrorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b6414a73e154dd73b9b79341e2c7cc36703bb68e9bd22ec944910f8843289e2b)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualMirrorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6004abfa0dd56327be3367be63e79bf814538ef192d90568520755d6c0f15490)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e5154d9bae529d2fa4e482cfafb27675133a39af0fe43fc581f203b5c8ac638e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5084c89c7fae259bf6399d6d87d53043480564518422133d0175636a64379b08)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualMirror]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualMirror]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__204aa5d947264e7aa4fb4090ad9d581c3ce7f2dfdafc10b846902848f9d80344)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualMirrorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualMirrorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3468f893ef25f71f25268e150cef756207c0a832faa1008fc19c6755bcc31f03)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHorizontal")
    def reset_horizontal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontal", []))

    @jsii.member(jsii_name="resetHorizontalVar")
    def reset_horizontal_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontalVar", []))

    @jsii.member(jsii_name="resetVertical")
    def reset_vertical(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVertical", []))

    @jsii.member(jsii_name="resetVerticalVar")
    def reset_vertical_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVerticalVar", []))

    @builtins.property
    @jsii.member(jsii_name="horizontalInput")
    def horizontal_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontalVarInput")
    def horizontal_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalInput")
    def vertical_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalVarInput")
    def vertical_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontal")
    def horizontal(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontal"))

    @horizontal.setter
    def horizontal(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__141dd70795594e22c306f2d99a45e01aba03e1e55e5f1a71c9338b1315cc94cb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontal", value)

    @builtins.property
    @jsii.member(jsii_name="horizontalVar")
    def horizontal_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontalVar"))

    @horizontal_var.setter
    def horizontal_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__57445422956f764fc99d39d775c7046cc4c830dc6ff134ebd4d4986ad2f325e7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontalVar", value)

    @builtins.property
    @jsii.member(jsii_name="vertical")
    def vertical(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "vertical"))

    @vertical.setter
    def vertical(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e62a36d86025a2a743d38c93b65496954fb033b23ddecfc242be5f09dbffa667)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "vertical", value)

    @builtins.property
    @jsii.member(jsii_name="verticalVar")
    def vertical_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "verticalVar"))

    @vertical_var.setter
    def vertical_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c66739daebd631b5b79011820a6583dd86d24fbf7255a6eec22d736314633e38)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "verticalVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualMirror]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualMirror]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualMirror]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b8b2854c8b28deb92ece411b046956da976a8ade25a07db24dda12478ef39e28)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualMonoHue",
    jsii_struct_bases=[],
    name_mapping={"hue": "hue", "hue_var": "hueVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualMonoHue:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8b8e3f2cea35e596e9a1c7eeedc8d48e70dd8fa0b4a6aaa68e6b5efb041f7e66)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualMonoHue(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualMonoHueList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualMonoHueList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__afb9c838d91c815e24c7887ef63f7da8782d96309af4cf78e17f3c0b76654e88)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualMonoHueOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__950c0c0a2204d03c8c067da67b4f611a553f968bc0fcabc68144a7ad14267a34)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualMonoHueOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2997b8bb6c23fdb5034b553fadc6e959fd889455c6dfb7937286270e4128bf8e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b22c8293079c473ad6eebdf240e555aa7e051d15055ef008eacddb58f371ec42)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__05b86e4494ba7d8ce033174bc62dfbd663070a3beb98cd7ec82fb4485ebf19f7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualMonoHue]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualMonoHue]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__03978465cfb6704e925024edba613b16c18a66d1d73154ebeb263135b0a3a1ec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualMonoHueOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualMonoHueOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2669202d1513fabf3707d2a0a10a11a1448d89c9e8bf3bb9c1314b907c5c6a2b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a9d3aedf8df02b3fd6c5075e40b2e1e5a04718356ca207dd717bb6308bef6c7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6094ba7156c4f1ee9a6a283a8375de391c005499225af723b89d6f517999fa7d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualMonoHue]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualMonoHue]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualMonoHue]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__20f393ac45b3e09066e163033e418b5a6b35aaacb454707849c29c0b108a37f7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualOpacity",
    jsii_struct_bases=[],
    name_mapping={"opacity": "opacity", "opacity_var": "opacityVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualOpacity:
    def __init__(
        self,
        *,
        opacity: typing.Optional[builtins.str] = None,
        opacity_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param opacity: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param opacity_var: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__84164f0a00abfb1b443c91c792ee19a4ae655ef823b8da886fe6e72c362976f2)
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument opacity_var", value=opacity_var, expected_type=type_hints["opacity_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if opacity is not None:
            self._values["opacity"] = opacity
        if opacity_var is not None:
            self._values["opacity_var"] = opacity_var

    @builtins.property
    def opacity(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def opacity_var(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        result = self._values.get("opacity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualOpacity(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualOpacityList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualOpacityList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a2d16e9aa908674e9baa4150c98de5698d450985d46640f90e03108f0ddf9a9b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualOpacityOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f80dd1eaaca4edced0d4b685b37887f9e118650eb21610ff288d4bb6a5e43d84)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualOpacityOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4b315b11dece8d83f25c9afa66c59e486b4d6734e6c475dea5a5f6e2bce83b94)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b9e0c357849cea9dde6199c553f2a89ebbc5d4c572c25f9e471827a019f2ea48)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0c3c40ca9a1a49b1ce97bf719e949803cc9fc22e0c2136e52cbe232ba087561b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualOpacity]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualOpacity]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__948d4ccadce24a7fc7bd7eb9a22e2b73d4c5aac8f188327b9655f2a568c0da13)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualOpacityOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualOpacityOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0c30efd41671547bede89bf1435422352b7f839b5739c60921312f8073cc9607)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetOpacityVar")
    def reset_opacity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacityVar", []))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityVarInput")
    def opacity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacity"))

    @opacity.setter
    def opacity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8c32beb60c23cd2a48c973db64c0d3d1840986b819084dae9bf4765e5166ad5c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacity", value)

    @builtins.property
    @jsii.member(jsii_name="opacityVar")
    def opacity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacityVar"))

    @opacity_var.setter
    def opacity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__23d1e179b207aff98391e9595b9af598b72caf3858e8bbd4a2e613cd1de5d5c4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacityVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualOpacity]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualOpacity]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualOpacity]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cc79780b765a1060c75357518414bad7e388ef840c3e4e9569e30edcb58a9979)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__10de5862f5ab253b8e97fff9bd7f28834fbd4b98769b868322f23d1f62575bff)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putAppend")
    def put_append(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualAppend, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e3a58c4e0f2829ac42d663c84d49ebd316b13140d2bfb3a5d18e273be699d191)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putAppend", [value]))

    @jsii.member(jsii_name="putAspectCrop")
    def put_aspect_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualAspectCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a28cb424d0fe75b20ed7cb4d91c12754d4d362e45eaade76db8f1e05404cbb4d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putAspectCrop", [value]))

    @jsii.member(jsii_name="putBackgroundColor")
    def put_background_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6ba0b085587b8d720cb6b7df922a7beee1807280f57b19a5b603270cd3146f45)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBackgroundColor", [value]))

    @jsii.member(jsii_name="putBlur")
    def put_blur(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualBlur, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c1323de422a2c16f8e372e0649ce4eb95fc9504797fb15f2289359819484e1c2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBlur", [value]))

    @jsii.member(jsii_name="putChromaKey")
    def put_chroma_key(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualChromaKey, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__54d0094209cbaa8b35c4e93109ab4b7c7121f22bb5beb558095490236b72fdff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putChromaKey", [value]))

    @jsii.member(jsii_name="putComposite")
    def put_composite(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualComposite, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a1fdefc3a44881b32f1e5f8c4988cea875c67c9f73e9aa094d48133b62c5d48)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putComposite", [value]))

    @jsii.member(jsii_name="putCompound")
    def put_compound(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualCompound, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fb7f4b94ef390ee113be083d713ca08f310a6667a1aee30244ce8f19b293a8a8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCompound", [value]))

    @jsii.member(jsii_name="putContrast")
    def put_contrast(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualContrast, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eeaf2ca157c558297a99baaf12e2534563b6771dc8a0e2508dfbefa420119a19)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putContrast", [value]))

    @jsii.member(jsii_name="putCrop")
    def put_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__caff5fe7a24393b7c70aeafd83f6f79bfd0820af9fd40c22e32ee80d8018c08b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCrop", [value]))

    @jsii.member(jsii_name="putFaceCrop")
    def put_face_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualFaceCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4163c6de37dfe3c60ee153b3c1e6315bb1cff114c86ff1a2c8058676334e13f9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFaceCrop", [value]))

    @jsii.member(jsii_name="putFeatureCrop")
    def put_feature_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualFeatureCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9bb7c4bd8a203ae23834e24e25b37eb0992908d3027920fb35334973c624cb48)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFeatureCrop", [value]))

    @jsii.member(jsii_name="putFitAndFill")
    def put_fit_and_fill(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualFitAndFill, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b7062fb15ea3f6f37ab72ab6e4b4268db6f32c49f6162cd9202cf27125be9e4e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFitAndFill", [value]))

    @jsii.member(jsii_name="putGoop")
    def put_goop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualGoop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5848cdee3ba0c7a135d077ad293374135e929bdfdc1d3eabe3f4fc54a66f8f7d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGoop", [value]))

    @jsii.member(jsii_name="putGrayscale")
    def put_grayscale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualGrayscale, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a9cbba68136af047df2044780b749fa2feb5096b018701e8efbf42d21e9bd075)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGrayscale", [value]))

    @jsii.member(jsii_name="putHsl")
    def put_hsl(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualHsl, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ad60a5a00d91b0a96f8b532f0a48eb30ad2f53b675653a5cd52a4a5fd6beb71)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsl", [value]))

    @jsii.member(jsii_name="putHsv")
    def put_hsv(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualHsv, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a80121007df996f7f8e8340a8245c427ebcac143c447ccb0854f1c1217e93106)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsv", [value]))

    @jsii.member(jsii_name="putIfDimension")
    def put_if_dimension(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfDimension, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d0dd9644f824f99f985ebccd6293f51024253a73698756da60a1b7ef41386043)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfDimension", [value]))

    @jsii.member(jsii_name="putIfOrientation")
    def put_if_orientation(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__489dae988b247866abf274d21633db1158119bfe28fe0bb7c4c3dd6ac42fee63)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfOrientation", [value]))

    @jsii.member(jsii_name="putImQuery")
    def put_im_query(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualImQuery, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d7b93149de4f28ac22e3d5eed7171fceb3f5c9983b27a4d074a8f7edcb8b89ba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putImQuery", [value]))

    @jsii.member(jsii_name="putMaxColors")
    def put_max_colors(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualMaxColors, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0009b0fd1294b93e7704b5a3e07fb129778df4f2a94e6fa688c06bd3d85610f8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMaxColors", [value]))

    @jsii.member(jsii_name="putMirror")
    def put_mirror(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualMirror, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0779f0d55537d8239b06cb021fd40547ddb9967b5c5f8b48a15f4cc683e487f1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMirror", [value]))

    @jsii.member(jsii_name="putMonoHue")
    def put_mono_hue(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualMonoHue, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ca72c7edd7bf6373568057a77ebf2ee239d6dab81b3f4c2c01da5dc0e9d16d80)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMonoHue", [value]))

    @jsii.member(jsii_name="putOpacity")
    def put_opacity(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualOpacity, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0761f509d3ae06d2b34f62bd766044bb787d14270e9575b112163e54107c0d63)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putOpacity", [value]))

    @jsii.member(jsii_name="putRegionOfInterestCrop")
    def put_region_of_interest_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualRegionOfInterestCrop", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1bc701b11837a45ef62fc944cae447c3d0fdff40b45648b0c91435a915659805)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRegionOfInterestCrop", [value]))

    @jsii.member(jsii_name="putRelativeCrop")
    def put_relative_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualRelativeCrop", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__73a2307429480f9aff9e06afcca3f7cd41c6321f8d0cfa04b5c147f2d94f7e33)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRelativeCrop", [value]))

    @jsii.member(jsii_name="putRemoveColor")
    def put_remove_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualRemoveColor", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8d7d13bad738b39abcdd316eeb699099b50756ef7c55c56316daf4409044d61b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRemoveColor", [value]))

    @jsii.member(jsii_name="putResize")
    def put_resize(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualResize", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__257b06c6d0c1d775d35e5265c99c4a8f5b4ade896a5fc785b8fc8230658021e4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putResize", [value]))

    @jsii.member(jsii_name="putRotate")
    def put_rotate(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualRotate", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__193dd1292b273f5162137786cf52e5ac6d01dda6f87aa7c41ccbb23c73b66e4f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRotate", [value]))

    @jsii.member(jsii_name="putScale")
    def put_scale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualScale", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__052d47eedf26297e03e503f5a2188582e50d43f948f20e327f6595726bd61419)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putScale", [value]))

    @jsii.member(jsii_name="putShear")
    def put_shear(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualShear", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aed7452702037aa2447d10cdce628bee401b36ef7833f760516d54542d4321aa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putShear", [value]))

    @jsii.member(jsii_name="putTrim")
    def put_trim(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualTrim", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7edc3c0a20fc9011ca68a8177a5c9dd142f4c6f929ad70e8f2b4641b038e0918)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTrim", [value]))

    @jsii.member(jsii_name="putUnsharpMask")
    def put_unsharp_mask(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualUnsharpMask", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0c51b42f950f030bc33890e580faa170b7831a6649b914a7babcd900ce87e986)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putUnsharpMask", [value]))

    @jsii.member(jsii_name="resetAppend")
    def reset_append(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAppend", []))

    @jsii.member(jsii_name="resetAspectCrop")
    def reset_aspect_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspectCrop", []))

    @jsii.member(jsii_name="resetBackgroundColor")
    def reset_background_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBackgroundColor", []))

    @jsii.member(jsii_name="resetBlur")
    def reset_blur(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBlur", []))

    @jsii.member(jsii_name="resetChromaKey")
    def reset_chroma_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChromaKey", []))

    @jsii.member(jsii_name="resetComposite")
    def reset_composite(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetComposite", []))

    @jsii.member(jsii_name="resetCompound")
    def reset_compound(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCompound", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetCrop")
    def reset_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCrop", []))

    @jsii.member(jsii_name="resetFaceCrop")
    def reset_face_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFaceCrop", []))

    @jsii.member(jsii_name="resetFeatureCrop")
    def reset_feature_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureCrop", []))

    @jsii.member(jsii_name="resetFitAndFill")
    def reset_fit_and_fill(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFitAndFill", []))

    @jsii.member(jsii_name="resetGoop")
    def reset_goop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGoop", []))

    @jsii.member(jsii_name="resetGrayscale")
    def reset_grayscale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGrayscale", []))

    @jsii.member(jsii_name="resetHsl")
    def reset_hsl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsl", []))

    @jsii.member(jsii_name="resetHsv")
    def reset_hsv(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsv", []))

    @jsii.member(jsii_name="resetIfDimension")
    def reset_if_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfDimension", []))

    @jsii.member(jsii_name="resetIfOrientation")
    def reset_if_orientation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfOrientation", []))

    @jsii.member(jsii_name="resetImQuery")
    def reset_im_query(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetImQuery", []))

    @jsii.member(jsii_name="resetMaxColors")
    def reset_max_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxColors", []))

    @jsii.member(jsii_name="resetMirror")
    def reset_mirror(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMirror", []))

    @jsii.member(jsii_name="resetMonoHue")
    def reset_mono_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonoHue", []))

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetRegionOfInterestCrop")
    def reset_region_of_interest_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRegionOfInterestCrop", []))

    @jsii.member(jsii_name="resetRelativeCrop")
    def reset_relative_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRelativeCrop", []))

    @jsii.member(jsii_name="resetRemoveColor")
    def reset_remove_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRemoveColor", []))

    @jsii.member(jsii_name="resetResize")
    def reset_resize(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetResize", []))

    @jsii.member(jsii_name="resetRotate")
    def reset_rotate(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRotate", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetShear")
    def reset_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetShear", []))

    @jsii.member(jsii_name="resetTrim")
    def reset_trim(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTrim", []))

    @jsii.member(jsii_name="resetUnsharpMask")
    def reset_unsharp_mask(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUnsharpMask", []))

    @builtins.property
    @jsii.member(jsii_name="append")
    def append(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualAppendList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualAppendList, jsii.get(self, "append"))

    @builtins.property
    @jsii.member(jsii_name="aspectCrop")
    def aspect_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualAspectCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualAspectCropList, jsii.get(self, "aspectCrop"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColor")
    def background_color(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualBackgroundColorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualBackgroundColorList, jsii.get(self, "backgroundColor"))

    @builtins.property
    @jsii.member(jsii_name="blur")
    def blur(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualBlurList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualBlurList, jsii.get(self, "blur"))

    @builtins.property
    @jsii.member(jsii_name="chromaKey")
    def chroma_key(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualChromaKeyList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualChromaKeyList, jsii.get(self, "chromaKey"))

    @builtins.property
    @jsii.member(jsii_name="composite")
    def composite(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualCompositeList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualCompositeList, jsii.get(self, "composite"))

    @builtins.property
    @jsii.member(jsii_name="compound")
    def compound(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualCompoundList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualCompoundList, jsii.get(self, "compound"))

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualContrastList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualContrastList, jsii.get(self, "contrast"))

    @builtins.property
    @jsii.member(jsii_name="crop")
    def crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualCropList, jsii.get(self, "crop"))

    @builtins.property
    @jsii.member(jsii_name="faceCrop")
    def face_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualFaceCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualFaceCropList, jsii.get(self, "faceCrop"))

    @builtins.property
    @jsii.member(jsii_name="featureCrop")
    def feature_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualFeatureCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualFeatureCropList, jsii.get(self, "featureCrop"))

    @builtins.property
    @jsii.member(jsii_name="fitAndFill")
    def fit_and_fill(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualFitAndFillList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualFitAndFillList, jsii.get(self, "fitAndFill"))

    @builtins.property
    @jsii.member(jsii_name="goop")
    def goop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualGoopList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualGoopList, jsii.get(self, "goop"))

    @builtins.property
    @jsii.member(jsii_name="grayscale")
    def grayscale(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualGrayscaleList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualGrayscaleList, jsii.get(self, "grayscale"))

    @builtins.property
    @jsii.member(jsii_name="hsl")
    def hsl(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualHslList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualHslList, jsii.get(self, "hsl"))

    @builtins.property
    @jsii.member(jsii_name="hsv")
    def hsv(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualHsvList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualHsvList, jsii.get(self, "hsv"))

    @builtins.property
    @jsii.member(jsii_name="ifDimension")
    def if_dimension(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfDimensionList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfDimensionList, jsii.get(self, "ifDimension"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientation")
    def if_orientation(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfOrientationList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfOrientationList, jsii.get(self, "ifOrientation"))

    @builtins.property
    @jsii.member(jsii_name="imQuery")
    def im_query(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualImQueryList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualImQueryList, jsii.get(self, "imQuery"))

    @builtins.property
    @jsii.member(jsii_name="maxColors")
    def max_colors(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualMaxColorsList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualMaxColorsList, jsii.get(self, "maxColors"))

    @builtins.property
    @jsii.member(jsii_name="mirror")
    def mirror(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualMirrorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualMirrorList, jsii.get(self, "mirror"))

    @builtins.property
    @jsii.member(jsii_name="monoHue")
    def mono_hue(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualMonoHueList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualMonoHueList, jsii.get(self, "monoHue"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualOpacityList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualOpacityList, jsii.get(self, "opacity"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestCrop")
    def region_of_interest_crop(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualRegionOfInterestCropList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualRegionOfInterestCropList", jsii.get(self, "regionOfInterestCrop"))

    @builtins.property
    @jsii.member(jsii_name="relativeCrop")
    def relative_crop(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualRelativeCropList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualRelativeCropList", jsii.get(self, "relativeCrop"))

    @builtins.property
    @jsii.member(jsii_name="removeColor")
    def remove_color(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualRemoveColorList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualRemoveColorList", jsii.get(self, "removeColor"))

    @builtins.property
    @jsii.member(jsii_name="resize")
    def resize(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualResizeList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualResizeList", jsii.get(self, "resize"))

    @builtins.property
    @jsii.member(jsii_name="rotate")
    def rotate(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualRotateList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualRotateList", jsii.get(self, "rotate"))

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualScaleList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualScaleList", jsii.get(self, "scale"))

    @builtins.property
    @jsii.member(jsii_name="shear")
    def shear(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualShearList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualShearList", jsii.get(self, "shear"))

    @builtins.property
    @jsii.member(jsii_name="trim")
    def trim(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualTrimList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualTrimList", jsii.get(self, "trim"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMask")
    def unsharp_mask(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualUnsharpMaskList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualUnsharpMaskList", jsii.get(self, "unsharpMask"))

    @builtins.property
    @jsii.member(jsii_name="appendInput")
    def append_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualAppend]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualAppend]]], jsii.get(self, "appendInput"))

    @builtins.property
    @jsii.member(jsii_name="aspectCropInput")
    def aspect_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualAspectCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualAspectCrop]]], jsii.get(self, "aspectCropInput"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColorInput")
    def background_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualBackgroundColor]]], jsii.get(self, "backgroundColorInput"))

    @builtins.property
    @jsii.member(jsii_name="blurInput")
    def blur_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualBlur]]], jsii.get(self, "blurInput"))

    @builtins.property
    @jsii.member(jsii_name="chromaKeyInput")
    def chroma_key_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualChromaKey]]], jsii.get(self, "chromaKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="compositeInput")
    def composite_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualComposite]]], jsii.get(self, "compositeInput"))

    @builtins.property
    @jsii.member(jsii_name="compoundInput")
    def compound_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualCompound]]], jsii.get(self, "compoundInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualContrast]]], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="cropInput")
    def crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualCrop]]], jsii.get(self, "cropInput"))

    @builtins.property
    @jsii.member(jsii_name="faceCropInput")
    def face_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualFaceCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualFaceCrop]]], jsii.get(self, "faceCropInput"))

    @builtins.property
    @jsii.member(jsii_name="featureCropInput")
    def feature_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualFeatureCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualFeatureCrop]]], jsii.get(self, "featureCropInput"))

    @builtins.property
    @jsii.member(jsii_name="fitAndFillInput")
    def fit_and_fill_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualFitAndFill]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualFitAndFill]]], jsii.get(self, "fitAndFillInput"))

    @builtins.property
    @jsii.member(jsii_name="goopInput")
    def goop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualGoop]]], jsii.get(self, "goopInput"))

    @builtins.property
    @jsii.member(jsii_name="grayscaleInput")
    def grayscale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualGrayscale]]], jsii.get(self, "grayscaleInput"))

    @builtins.property
    @jsii.member(jsii_name="hslInput")
    def hsl_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualHsl]]], jsii.get(self, "hslInput"))

    @builtins.property
    @jsii.member(jsii_name="hsvInput")
    def hsv_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualHsv]]], jsii.get(self, "hsvInput"))

    @builtins.property
    @jsii.member(jsii_name="ifDimensionInput")
    def if_dimension_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfDimension]]], jsii.get(self, "ifDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientationInput")
    def if_orientation_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfOrientation]]], jsii.get(self, "ifOrientationInput"))

    @builtins.property
    @jsii.member(jsii_name="imQueryInput")
    def im_query_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualImQuery]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualImQuery]]], jsii.get(self, "imQueryInput"))

    @builtins.property
    @jsii.member(jsii_name="maxColorsInput")
    def max_colors_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualMaxColors]]], jsii.get(self, "maxColorsInput"))

    @builtins.property
    @jsii.member(jsii_name="mirrorInput")
    def mirror_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualMirror]]], jsii.get(self, "mirrorInput"))

    @builtins.property
    @jsii.member(jsii_name="monoHueInput")
    def mono_hue_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualMonoHue]]], jsii.get(self, "monoHueInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualOpacity]]], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestCropInput")
    def region_of_interest_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualRegionOfInterestCrop"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualRegionOfInterestCrop"]]], jsii.get(self, "regionOfInterestCropInput"))

    @builtins.property
    @jsii.member(jsii_name="relativeCropInput")
    def relative_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualRelativeCrop"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualRelativeCrop"]]], jsii.get(self, "relativeCropInput"))

    @builtins.property
    @jsii.member(jsii_name="removeColorInput")
    def remove_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualRemoveColor"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualRemoveColor"]]], jsii.get(self, "removeColorInput"))

    @builtins.property
    @jsii.member(jsii_name="resizeInput")
    def resize_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualResize"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualResize"]]], jsii.get(self, "resizeInput"))

    @builtins.property
    @jsii.member(jsii_name="rotateInput")
    def rotate_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualRotate"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualRotate"]]], jsii.get(self, "rotateInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualScale"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualScale"]]], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="shearInput")
    def shear_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualShear"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualShear"]]], jsii.get(self, "shearInput"))

    @builtins.property
    @jsii.member(jsii_name="trimInput")
    def trim_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualTrim"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualTrim"]]], jsii.get(self, "trimInput"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMaskInput")
    def unsharp_mask_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualUnsharpMask"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualUnsharpMask"]]], jsii.get(self, "unsharpMaskInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqual], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqual],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dc5f61743c550f90f35112da24b887cd787cab102ed1882ccab1598f84261527)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualRegionOfInterestCrop",
    jsii_struct_bases=[],
    name_mapping={
        "region_of_interest": "regionOfInterest",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualRegionOfInterestCrop:
    def __init__(
        self,
        *,
        region_of_interest: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualRegionOfInterestCropRegionOfInterest", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param region_of_interest: region_of_interest block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest DataAkamaiImagingPolicyImage#region_of_interest}
        :param gravity: The placement of the crop area relative to the specified area of interest. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: The placement of the crop area relative to the specified area of interest. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param style: Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(region_of_interest, dict):
            region_of_interest = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualRegionOfInterestCropRegionOfInterest(**region_of_interest)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a66176fd4f1324b0a4c59def1b11aaf3e17e64ebf1aaab2d6ebef701c5e2420)
            check_type(argname="argument region_of_interest", value=region_of_interest, expected_type=type_hints["region_of_interest"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "region_of_interest": region_of_interest,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def region_of_interest(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualRegionOfInterestCropRegionOfInterest":
        '''region_of_interest block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest DataAkamaiImagingPolicyImage#region_of_interest}
        '''
        result = self._values.get("region_of_interest")
        assert result is not None, "Required property 'region_of_interest' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualRegionOfInterestCropRegionOfInterest", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''The placement of the crop area relative to the specified area of interest.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''The placement of the crop area relative to the specified area of interest.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualRegionOfInterestCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualRegionOfInterestCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualRegionOfInterestCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0dbcb9e8b087bd674734c5accc023e9c396acfd4f5a7b13da512875d43a5ecf1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualRegionOfInterestCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__938bf96e685b5cf64744da3f521906fa752a4666dacdc4342489f7e0782730dd)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualRegionOfInterestCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__92fe3b520afe8cfad941aeb69d24035d57e47bdb09f15fb05f78398223f34006)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bfe248b60f2d2b6c127eb2da50d7d12334927a8f3d87f66daee041d830e59a95)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__80074bf1902411f201b0b51f0c959d5002b6fc150abcefa5d984477f1dd15f01)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualRegionOfInterestCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualRegionOfInterestCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualRegionOfInterestCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0f52f3d8cc2148c04dd09313464b658e480fbfa344ebf7fb87acb43f6deeb30b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualRegionOfInterestCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualRegionOfInterestCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7a50eb23784d09e1539b614c63857aa844496d44bbeaddc540dbd8eea16ed551)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putRegionOfInterest")
    def put_region_of_interest(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualRegionOfInterestCropRegionOfInterest()

        return typing.cast(None, jsii.invoke(self, "putRegionOfInterest", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterest")
    def region_of_interest(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualRegionOfInterestCropRegionOfInterestOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualRegionOfInterestCropRegionOfInterestOutputReference", jsii.get(self, "regionOfInterest"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestInput")
    def region_of_interest_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualRegionOfInterestCropRegionOfInterest"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualRegionOfInterestCropRegionOfInterest"], jsii.get(self, "regionOfInterestInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2e1c511b8a55b92f983316fc8fa60209322cbab97cb05e63e6eca20805c11f92)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6ac5ac57bcddfac72fa7045a91bc1a157f204518b51864f8621dadc49c7cbc2e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0b998872e6afb75bbadfbed7490a929f94f95deb119e6b5a6217afd0a0ba7523)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a19721673873b74012a3a6f0ab075ec9cabce56359ce65609bf435b1280e7988)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__908349f6f820889c7275a06b6c018ff6ecd28c3dc718d30f1cd5d0201d1d5d44)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2aa7b44c2bb3522b03f2bd01c6d839173a635f3ec0380f367f0e1b17292bb6a9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__55298060f6bd12ce902e1b2d039407c1cb2b85f1f19f28ddce9174122ed48f64)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8d1de00abe80e93a30f8b68ecce401bd6383f513256703637c45bc8bd0a462d9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualRegionOfInterestCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualRegionOfInterestCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualRegionOfInterestCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__84b5b14a819ac1287f0a375a122463bf3f2ed06b06b95a0d5aefd68eb60c8aa9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualRegionOfInterestCropRegionOfInterest",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualRegionOfInterestCropRegionOfInterest:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualRegionOfInterestCropRegionOfInterest(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualRegionOfInterestCropRegionOfInterestOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualRegionOfInterestCropRegionOfInterestOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7110724bf5da3c123d626b8a35ea07042a0a33c1d30f46d498d6104d994b8f52)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualRegionOfInterestCropRegionOfInterest]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualRegionOfInterestCropRegionOfInterest], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualRegionOfInterestCropRegionOfInterest],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4dce4017915d35c7e37c0aa522d61af80ccd7ac61cefa84c27868e5f49025586)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualRelativeCrop",
    jsii_struct_bases=[],
    name_mapping={
        "east": "east",
        "east_var": "eastVar",
        "north": "north",
        "north_var": "northVar",
        "south": "south",
        "south_var": "southVar",
        "west": "west",
        "west_var": "westVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualRelativeCrop:
    def __init__(
        self,
        *,
        east: typing.Optional[builtins.str] = None,
        east_var: typing.Optional[builtins.str] = None,
        north: typing.Optional[builtins.str] = None,
        north_var: typing.Optional[builtins.str] = None,
        south: typing.Optional[builtins.str] = None,
        south_var: typing.Optional[builtins.str] = None,
        west: typing.Optional[builtins.str] = None,
        west_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param east: The number of pixels to shrink or expand the right side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east DataAkamaiImagingPolicyImage#east}
        :param east_var: The number of pixels to shrink or expand the right side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east_var DataAkamaiImagingPolicyImage#east_var}
        :param north: The number of pixels to shrink or expand the top side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north DataAkamaiImagingPolicyImage#north}
        :param north_var: The number of pixels to shrink or expand the top side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north_var DataAkamaiImagingPolicyImage#north_var}
        :param south: The number of pixels to shrink or expand the bottom side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south DataAkamaiImagingPolicyImage#south}
        :param south_var: The number of pixels to shrink or expand the bottom side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south_var DataAkamaiImagingPolicyImage#south_var}
        :param west: The number of pixels to shrink or expand the left side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west DataAkamaiImagingPolicyImage#west}
        :param west_var: The number of pixels to shrink or expand the left side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west_var DataAkamaiImagingPolicyImage#west_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7ef5830ddbdf18718889d959a20d56d0ad7d41de0a3c8cf5ba0788f834791ccb)
            check_type(argname="argument east", value=east, expected_type=type_hints["east"])
            check_type(argname="argument east_var", value=east_var, expected_type=type_hints["east_var"])
            check_type(argname="argument north", value=north, expected_type=type_hints["north"])
            check_type(argname="argument north_var", value=north_var, expected_type=type_hints["north_var"])
            check_type(argname="argument south", value=south, expected_type=type_hints["south"])
            check_type(argname="argument south_var", value=south_var, expected_type=type_hints["south_var"])
            check_type(argname="argument west", value=west, expected_type=type_hints["west"])
            check_type(argname="argument west_var", value=west_var, expected_type=type_hints["west_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if east is not None:
            self._values["east"] = east
        if east_var is not None:
            self._values["east_var"] = east_var
        if north is not None:
            self._values["north"] = north
        if north_var is not None:
            self._values["north_var"] = north_var
        if south is not None:
            self._values["south"] = south
        if south_var is not None:
            self._values["south_var"] = south_var
        if west is not None:
            self._values["west"] = west
        if west_var is not None:
            self._values["west_var"] = west_var

    @builtins.property
    def east(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the right side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east DataAkamaiImagingPolicyImage#east}
        '''
        result = self._values.get("east")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def east_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the right side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east_var DataAkamaiImagingPolicyImage#east_var}
        '''
        result = self._values.get("east_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def north(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the top side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north DataAkamaiImagingPolicyImage#north}
        '''
        result = self._values.get("north")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def north_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the top side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north_var DataAkamaiImagingPolicyImage#north_var}
        '''
        result = self._values.get("north_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def south(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the bottom side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south DataAkamaiImagingPolicyImage#south}
        '''
        result = self._values.get("south")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def south_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the bottom side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south_var DataAkamaiImagingPolicyImage#south_var}
        '''
        result = self._values.get("south_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def west(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the left side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west DataAkamaiImagingPolicyImage#west}
        '''
        result = self._values.get("west")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def west_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the left side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west_var DataAkamaiImagingPolicyImage#west_var}
        '''
        result = self._values.get("west_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualRelativeCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualRelativeCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualRelativeCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__83b37a09cc19ee110e128dfb117743d8ad593a6af26b2b21b989c2f254e01bf8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualRelativeCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__88763d670328118d453dd64308a737a4837867737a2e93dd364144adfbf7b1d8)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualRelativeCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__18bb6e0a1f3af65d06c38a31a110be955a0e33549135d73e6738e207c3e7a85b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b6c995fad9ed4041a7e35db9545279505438673942aaa1cdb24bd1d289faa70e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__42961d76f3232294266194e2ada39982c464b8438ef9400ea16c9c7d5187121c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualRelativeCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualRelativeCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualRelativeCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ac5c24fcd2fa878a4fc18f1965b85a9d22dd7819a68b154a7205df17b579aae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualRelativeCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualRelativeCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3988b991fe673892259393273de1c0d072a95d7e16872e56926a63bd614239ab)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetEast")
    def reset_east(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEast", []))

    @jsii.member(jsii_name="resetEastVar")
    def reset_east_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEastVar", []))

    @jsii.member(jsii_name="resetNorth")
    def reset_north(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNorth", []))

    @jsii.member(jsii_name="resetNorthVar")
    def reset_north_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNorthVar", []))

    @jsii.member(jsii_name="resetSouth")
    def reset_south(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSouth", []))

    @jsii.member(jsii_name="resetSouthVar")
    def reset_south_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSouthVar", []))

    @jsii.member(jsii_name="resetWest")
    def reset_west(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWest", []))

    @jsii.member(jsii_name="resetWestVar")
    def reset_west_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWestVar", []))

    @builtins.property
    @jsii.member(jsii_name="eastInput")
    def east_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "eastInput"))

    @builtins.property
    @jsii.member(jsii_name="eastVarInput")
    def east_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "eastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="northInput")
    def north_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "northInput"))

    @builtins.property
    @jsii.member(jsii_name="northVarInput")
    def north_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "northVarInput"))

    @builtins.property
    @jsii.member(jsii_name="southInput")
    def south_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "southInput"))

    @builtins.property
    @jsii.member(jsii_name="southVarInput")
    def south_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "southVarInput"))

    @builtins.property
    @jsii.member(jsii_name="westInput")
    def west_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "westInput"))

    @builtins.property
    @jsii.member(jsii_name="westVarInput")
    def west_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "westVarInput"))

    @builtins.property
    @jsii.member(jsii_name="east")
    def east(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "east"))

    @east.setter
    def east(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cebcffd71a7ac1f2dd67b414e10a054966b117dfb2e9cb2f82346a909f7aaa0e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "east", value)

    @builtins.property
    @jsii.member(jsii_name="eastVar")
    def east_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "eastVar"))

    @east_var.setter
    def east_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3e09cbbdfb3922f254b4ddda7c23718385f3ede585a9a38ae3b5390f78288740)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "eastVar", value)

    @builtins.property
    @jsii.member(jsii_name="north")
    def north(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "north"))

    @north.setter
    def north(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab782b99be983de338883ac79da2f7611fa4929703ec487a5968c8e908858a92)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "north", value)

    @builtins.property
    @jsii.member(jsii_name="northVar")
    def north_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "northVar"))

    @north_var.setter
    def north_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__340f7113a696a303cbac57cc768e963bf08d73c9600d6990898227d5eb303c2a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "northVar", value)

    @builtins.property
    @jsii.member(jsii_name="south")
    def south(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "south"))

    @south.setter
    def south(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__242e671f68e613d3ee06b2eb2fdc75b2f9d737803dace48069a1bbee2cfb5045)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "south", value)

    @builtins.property
    @jsii.member(jsii_name="southVar")
    def south_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "southVar"))

    @south_var.setter
    def south_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2470d0051b2da447bed8b03bf132068f7526c88f25d9cbc89aff4d4d1232cc77)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "southVar", value)

    @builtins.property
    @jsii.member(jsii_name="west")
    def west(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "west"))

    @west.setter
    def west(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__10bfe7cb394a8b53e316d98e7f4dc01f3712f31d3e7278dd3a958348c1d972ba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "west", value)

    @builtins.property
    @jsii.member(jsii_name="westVar")
    def west_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "westVar"))

    @west_var.setter
    def west_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab81f16fbe8c3df330346a918e42cb1ad456d1b0920e459b4d7bd9761b059c98)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "westVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualRelativeCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualRelativeCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualRelativeCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7c1be74b4593dab1aba69539d0c73867b1dfdb2dc9b00267653e342d5d22744c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualRemoveColor",
    jsii_struct_bases=[],
    name_mapping={
        "color": "color",
        "color_var": "colorVar",
        "feather": "feather",
        "feather_var": "featherVar",
        "tolerance": "tolerance",
        "tolerance_var": "toleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualRemoveColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
        feather: typing.Optional[builtins.str] = None,
        feather_var: typing.Optional[builtins.str] = None,
        tolerance: typing.Optional[builtins.str] = None,
        tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        :param feather: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        :param feather_var: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        :param tolerance: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        :param tolerance_var: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__846864c6347f06e47263667ef93656dab489647efcaffe1f19ccb20a387b47e4)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
            check_type(argname="argument feather", value=feather, expected_type=type_hints["feather"])
            check_type(argname="argument feather_var", value=feather_var, expected_type=type_hints["feather_var"])
            check_type(argname="argument tolerance", value=tolerance, expected_type=type_hints["tolerance"])
            check_type(argname="argument tolerance_var", value=tolerance_var, expected_type=type_hints["tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var
        if feather is not None:
            self._values["feather"] = feather
        if feather_var is not None:
            self._values["feather_var"] = feather_var
        if tolerance is not None:
            self._values["tolerance"] = tolerance
        if tolerance_var is not None:
            self._values["tolerance_var"] = tolerance_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        '''
        result = self._values.get("feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather_var(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        '''
        result = self._values.get("feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        '''
        result = self._values.get("tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance_var(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        result = self._values.get("tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualRemoveColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualRemoveColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualRemoveColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__35d1944268f94661e28b46bd8452811485909c073a2a2a57d82733b68e6dfe0e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualRemoveColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__deecea2c09150d530fc67c3e1a1d8d276abaa79d53b3f8f517fe0e80662217bf)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualRemoveColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b306fab99998b5509d7d73ff1308c28f3664209c760773a32c06d567a3ac6f2c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__125a43a60ab4523a31ffc87282970eb63bf530f8151abdeca6684a64488326db)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2bd93cabd74aba608b2ef7cc19a8c81c6d2ef9e7569cb7cf3949e9597444d384)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualRemoveColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualRemoveColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualRemoveColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f6f5732947fd95a5882da319887b2283282a4ba23b46875169ba3922c98bf09)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualRemoveColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualRemoveColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__07124551b921c13e74df6f3d46f0f4f5b1ebc659342c3909efa63712b2bfced2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @jsii.member(jsii_name="resetFeather")
    def reset_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeather", []))

    @jsii.member(jsii_name="resetFeatherVar")
    def reset_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatherVar", []))

    @jsii.member(jsii_name="resetTolerance")
    def reset_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTolerance", []))

    @jsii.member(jsii_name="resetToleranceVar")
    def reset_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featherInput")
    def feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherInput"))

    @builtins.property
    @jsii.member(jsii_name="featherVarInput")
    def feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceInput")
    def tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceVarInput")
    def tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4860aaf9c82d6aba85eefce0d063efd7730f52e0c10ee35809454dd5ddc22b0b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a342ac8ab032dffe77a06d796a3fbb25af2682edae5363bbf6c7fce43f636592)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="feather")
    def feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "feather"))

    @feather.setter
    def feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a6ef3c55b57de8c7e7008276372e54d38ba58b6334f750e65e788898db19e250)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "feather", value)

    @builtins.property
    @jsii.member(jsii_name="featherVar")
    def feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featherVar"))

    @feather_var.setter
    def feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5b8f30a27d5b6c7eb57d1caf9f359fbcb856eef83a905d2be617e3d3917dee6d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featherVar", value)

    @builtins.property
    @jsii.member(jsii_name="tolerance")
    def tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tolerance"))

    @tolerance.setter
    def tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4171e90f865e984616218485ee67f58af586726619765a841d4593f0bfe516bf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tolerance", value)

    @builtins.property
    @jsii.member(jsii_name="toleranceVar")
    def tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "toleranceVar"))

    @tolerance_var.setter
    def tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__01f5b67fa47dbcd17525dfae5b0004f025d813bfe46b97f8f15f5bafd915beb3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "toleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualRemoveColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualRemoveColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualRemoveColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__98bde57c4dd0eb8b13b9ff86089f338f267f9461ec9be416150d1872db1a7f08)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualResize",
    jsii_struct_bases=[],
    name_mapping={
        "aspect": "aspect",
        "aspect_var": "aspectVar",
        "height": "height",
        "height_var": "heightVar",
        "type": "type",
        "type_var": "typeVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualResize:
    def __init__(
        self,
        *,
        aspect: typing.Optional[builtins.str] = None,
        aspect_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param aspect: Preserves the aspect ratio. Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect DataAkamaiImagingPolicyImage#aspect}
        :param aspect_var: Preserves the aspect ratio. Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_var DataAkamaiImagingPolicyImage#aspect_var}
        :param height: The height to resize the source image to. Must be set if height is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height to resize the source image to. Must be set if height is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param type: Sets constraints for the image resize. Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: Sets constraints for the image resize. Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        :param width: The width to resize the source image to. Must be set if width is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width to resize the source image to. Must be set if width is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__96c2a721230c937a289a6b2735481f5308757b3012f4bac1c193f2db0a2d093d)
            check_type(argname="argument aspect", value=aspect, expected_type=type_hints["aspect"])
            check_type(argname="argument aspect_var", value=aspect_var, expected_type=type_hints["aspect_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if aspect is not None:
            self._values["aspect"] = aspect
        if aspect_var is not None:
            self._values["aspect_var"] = aspect_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def aspect(self) -> typing.Optional[builtins.str]:
        '''Preserves the aspect ratio.

        Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect DataAkamaiImagingPolicyImage#aspect}
        '''
        result = self._values.get("aspect")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def aspect_var(self) -> typing.Optional[builtins.str]:
        '''Preserves the aspect ratio.

        Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_var DataAkamaiImagingPolicyImage#aspect_var}
        '''
        result = self._values.get("aspect_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height to resize the source image to. Must be set if height is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height to resize the source image to. Must be set if height is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''Sets constraints for the image resize.

        Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''Sets constraints for the image resize.

        Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width to resize the source image to. Must be set if width is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width to resize the source image to. Must be set if width is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualResize(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualResizeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualResizeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5de8aab45049adaff6f044d94df2cb733e1be62940c910827a6f9e0baba0e25c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualResizeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a072b6784484b11376fc4cf79959905cf783d4cbb5a5b11c2a98d1fe2bd707bb)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualResizeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5e732ab0cfb168b7ebd005c3b04b331014a88ed89cd688ffd071cd3fa4435975)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab3a1ffaecfabd0bcc8c26b108b90fd84755b37f517fcf1726f2bf8d4ed3427b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6619a02ddbe5b1b698e53cd5b26fc96328b8f6cf6165846292e828a22ad52cd9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualResize]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualResize]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualResize]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__545ad5fd55f7feb9602fe4ab0be6dc828717be217f26f6afb3e7a6a15d12f6a9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualResizeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualResizeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f9efd3eba6033c4240a203d29249a12c1454664551c3b3653f346c64a6997b2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAspect")
    def reset_aspect(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspect", []))

    @jsii.member(jsii_name="resetAspectVar")
    def reset_aspect_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspectVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="aspectInput")
    def aspect_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "aspectInput"))

    @builtins.property
    @jsii.member(jsii_name="aspectVarInput")
    def aspect_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "aspectVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="aspect")
    def aspect(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "aspect"))

    @aspect.setter
    def aspect(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__64419f8a033fb3bc1f6ae88e080ffd029220f664dcdc33a34bff8c7ae25ba400)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "aspect", value)

    @builtins.property
    @jsii.member(jsii_name="aspectVar")
    def aspect_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "aspectVar"))

    @aspect_var.setter
    def aspect_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__73273fa4ddb37ce2f109e93824f3bfef0539bde198cbc5b89fd369d70ffaff98)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "aspectVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0152eb6a487d6b3ebeaecb9fc19f6377a7935724ed2eacf21d2d01de56810701)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1dbfdcc933df4be89abdda88a386b9d9ccfe0a36c481cb0ee43b7dda4aec66ab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__90476ee6888d0501e5b9f059f78cc709603237e94edca7d4fc109331e7e78b27)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f888518815c79ff334a0e3b5b90dd7829284ef700943e9a73e74ec120e1cbc44)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__accc79b571d20687dffa13badfafeea60d1e98019cbe09834fa7b1d420662c29)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8c386a011f79a949f85ab35efd155534b696e51d11682e900702985ca0eb1c7f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualResize]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualResize]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualResize]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab6250ae7ecbaec9f2ca16ded7a207c081d0933a7f2211f7225d30cb12d96e82)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualRotate",
    jsii_struct_bases=[],
    name_mapping={"degrees": "degrees", "degrees_var": "degreesVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualRotate:
    def __init__(
        self,
        *,
        degrees: typing.Optional[builtins.str] = None,
        degrees_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param degrees: The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees DataAkamaiImagingPolicyImage#degrees}
        :param degrees_var: The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees_var DataAkamaiImagingPolicyImage#degrees_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__48a6a85b569c4407b4ae811e703e3c8a979c0b332d7abdc69952c453ba8bf859)
            check_type(argname="argument degrees", value=degrees, expected_type=type_hints["degrees"])
            check_type(argname="argument degrees_var", value=degrees_var, expected_type=type_hints["degrees_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if degrees is not None:
            self._values["degrees"] = degrees
        if degrees_var is not None:
            self._values["degrees_var"] = degrees_var

    @builtins.property
    def degrees(self) -> typing.Optional[builtins.str]:
        '''The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees DataAkamaiImagingPolicyImage#degrees}
        '''
        result = self._values.get("degrees")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def degrees_var(self) -> typing.Optional[builtins.str]:
        '''The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees_var DataAkamaiImagingPolicyImage#degrees_var}
        '''
        result = self._values.get("degrees_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualRotate(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualRotateList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualRotateList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0cf631a6949d5269730a888e5ca466c338405c39701c67478b52f2f3a2125608)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualRotateOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__327ea37bf578f21d768a738e07de1ac6671e550add2c6f97a65d0260ff656327)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualRotateOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b399e462f14f9d94f9fc6a5f47024554b850c8884f006eaa6477fa28d374f7b1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__41c8d02d9c8c2168350180c3828a711df2fb7b425829858a44180b2c811cfc7d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__19f9a493ece9a5c91c1f6b4c6d5e75e6519a4185669c6563409ceb5a313b54f5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualRotate]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualRotate]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualRotate]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__39d40628babf7a1894d813c03708c3f3d102f08aea413dd038672628d71c9c48)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualRotateOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualRotateOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e42ccae32ae5ccea6d601f608b121cdda0d56fae1e7de6a4fdad865f1c7c553c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetDegrees")
    def reset_degrees(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDegrees", []))

    @jsii.member(jsii_name="resetDegreesVar")
    def reset_degrees_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDegreesVar", []))

    @builtins.property
    @jsii.member(jsii_name="degreesInput")
    def degrees_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "degreesInput"))

    @builtins.property
    @jsii.member(jsii_name="degreesVarInput")
    def degrees_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "degreesVarInput"))

    @builtins.property
    @jsii.member(jsii_name="degrees")
    def degrees(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "degrees"))

    @degrees.setter
    def degrees(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e9637b819ea389b5df79f9f7c4c87f1e384778fecc2ef83ec465107923c27102)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "degrees", value)

    @builtins.property
    @jsii.member(jsii_name="degreesVar")
    def degrees_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "degreesVar"))

    @degrees_var.setter
    def degrees_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3bc576bafaa8347e7d1b6e3d33c78b8f91996c1c1dae25ef2bf8301b0af3d2ea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "degreesVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualRotate]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualRotate]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualRotate]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8f84bb87acf81342a78c4ec787a6b7794f2a5f7dd83ecee5070bbfaf65e4e63d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualScale",
    jsii_struct_bases=[],
    name_mapping={
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualScale:
    def __init__(
        self,
        *,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param height: Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged. Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged. Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a3185cd713f23c8cc3557c87ed21b328c2391ea5b3a8d1f11c1df5d7922ef622)
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size.

        Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size.

        Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged.

        Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged.

        Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualScale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualScaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualScaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__52308f90a7c858775d356b75e4e92a0871aa6d9287990ade1612de60bde1638b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualScaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__364965eb3c8584d9e25da4755c51091c0b772d123798ae781fdf059119896d7b)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualScaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e5dbfb1bf1fd98ba9e8a6d6c97fe078f9ee7e838cc9e64e584e93ad2b1668892)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7977e288c24b73cdb1de6284167005441365224fcd28da5773dd29c4456c5db5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ebcda843a1ca328901d6e59feba4d62d634972c2673e2555bbfdd9918ce5896d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualScale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualScale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualScale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ebac0603747e1a4c1346941f150a4f4196dd93eeddc4782d9df09dda3ad37081)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualScaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualScaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9f288034d57dd0bb5c6922ab8bebeea899400319e384a007fe0df37ac9bfe607)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__20203cfeb7429d03446a7cc2edd733c9edbd270ce4deabc630372b203ac407db)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2442831a8cf42a2815d5f7425ee45d28d556d2b3aec332f6e379adfb558e9eab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a002bffce01691370c1d420fff95252c3e75e1c5c9a3904e8f8c81376e590c15)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__946b122c2304c5d1722e6e61c6e8f0d858c8b37915fce44e4222c5237d80e555)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualScale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualScale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualScale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fb7d5244e6fef2506d0c0e5ecfce173618f58d7663368547d1c674f75e9b35e3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualShear",
    jsii_struct_bases=[],
    name_mapping={
        "x_shear": "xShear",
        "x_shear_var": "xShearVar",
        "y_shear": "yShear",
        "y_shear_var": "yShearVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualShear:
    def __init__(
        self,
        *,
        x_shear: typing.Optional[builtins.str] = None,
        x_shear_var: typing.Optional[builtins.str] = None,
        y_shear: typing.Optional[builtins.str] = None,
        y_shear_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param x_shear: The amount to shear along the x-axis, measured in multiples of the image's width. Must be set if yShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear DataAkamaiImagingPolicyImage#x_shear}
        :param x_shear_var: The amount to shear along the x-axis, measured in multiples of the image's width. Must be set if yShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear_var DataAkamaiImagingPolicyImage#x_shear_var}
        :param y_shear: The amount to shear along the y-axis, measured in multiples of the image's height. Must be set if xShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear DataAkamaiImagingPolicyImage#y_shear}
        :param y_shear_var: The amount to shear along the y-axis, measured in multiples of the image's height. Must be set if xShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear_var DataAkamaiImagingPolicyImage#y_shear_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__96e3fca9d55ca0fa67a085bd091d19a7c946c2adce7d195b68a26e511f038888)
            check_type(argname="argument x_shear", value=x_shear, expected_type=type_hints["x_shear"])
            check_type(argname="argument x_shear_var", value=x_shear_var, expected_type=type_hints["x_shear_var"])
            check_type(argname="argument y_shear", value=y_shear, expected_type=type_hints["y_shear"])
            check_type(argname="argument y_shear_var", value=y_shear_var, expected_type=type_hints["y_shear_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if x_shear is not None:
            self._values["x_shear"] = x_shear
        if x_shear_var is not None:
            self._values["x_shear_var"] = x_shear_var
        if y_shear is not None:
            self._values["y_shear"] = y_shear
        if y_shear_var is not None:
            self._values["y_shear_var"] = y_shear_var

    @builtins.property
    def x_shear(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the x-axis, measured in multiples of the image's width.

        Must be set if yShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear DataAkamaiImagingPolicyImage#x_shear}
        '''
        result = self._values.get("x_shear")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_shear_var(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the x-axis, measured in multiples of the image's width.

        Must be set if yShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear_var DataAkamaiImagingPolicyImage#x_shear_var}
        '''
        result = self._values.get("x_shear_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_shear(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the y-axis, measured in multiples of the image's height.

        Must be set if xShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear DataAkamaiImagingPolicyImage#y_shear}
        '''
        result = self._values.get("y_shear")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_shear_var(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the y-axis, measured in multiples of the image's height.

        Must be set if xShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear_var DataAkamaiImagingPolicyImage#y_shear_var}
        '''
        result = self._values.get("y_shear_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualShear(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualShearList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualShearList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__75c1bf9c6752999b3cb87d1302b0a5699d42974ef5342d7295f3007528063eb7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualShearOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__18cecd9f6bbe78705255e2e19940622839f047192db1b3df0e749dc492981ad7)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualShearOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6c1ceb83599becf5ec1d2b7ba77d3b39f91679216dd871f272a8f5895dc42c61)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__58a9701ec5b331e234ecf5ecaaa60a223dd3d636bb99cc54625ccaef28288bb2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__14a95d40954758b2bd6c1ee25dd2592f9119a10d685c753efabec05b0d71b209)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualShear]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualShear]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualShear]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__858d2c4ce9f5b5a11f264f99051fdae93a37312e6acdaa142f40a6788de8563f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualShearOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualShearOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__909477a3f35c3132206801deee79addcbbb9cadc4975675e1ed71eda93814b05)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetXShear")
    def reset_x_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXShear", []))

    @jsii.member(jsii_name="resetXShearVar")
    def reset_x_shear_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXShearVar", []))

    @jsii.member(jsii_name="resetYShear")
    def reset_y_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYShear", []))

    @jsii.member(jsii_name="resetYShearVar")
    def reset_y_shear_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYShearVar", []))

    @builtins.property
    @jsii.member(jsii_name="xShearInput")
    def x_shear_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xShearInput"))

    @builtins.property
    @jsii.member(jsii_name="xShearVarInput")
    def x_shear_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xShearVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yShearInput")
    def y_shear_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yShearInput"))

    @builtins.property
    @jsii.member(jsii_name="yShearVarInput")
    def y_shear_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yShearVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xShear")
    def x_shear(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xShear"))

    @x_shear.setter
    def x_shear(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a131a0e0db8f0d6c3556f21e5a59ab88c2653659272c05c92114182e9b1e987)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xShear", value)

    @builtins.property
    @jsii.member(jsii_name="xShearVar")
    def x_shear_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xShearVar"))

    @x_shear_var.setter
    def x_shear_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ade812e708820914739fed3f0d8aecc4faa2f10aca91456f251977d3612b8a5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xShearVar", value)

    @builtins.property
    @jsii.member(jsii_name="yShear")
    def y_shear(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yShear"))

    @y_shear.setter
    def y_shear(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__169f415db9d63965d0481ad9716ce15983fd16f77adec88a01da22635695c307)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yShear", value)

    @builtins.property
    @jsii.member(jsii_name="yShearVar")
    def y_shear_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yShearVar"))

    @y_shear_var.setter
    def y_shear_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__43cd6b834607f33f48388eabcdf37f52cd74efaaf45e9aaab9b3b3af86b8f3f4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yShearVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualShear]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualShear]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualShear]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7641ab22748707e16c741892affcfe6f943dbe7eb7d88ac93c6dde7beee5e9e7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualTrim",
    jsii_struct_bases=[],
    name_mapping={
        "fuzz": "fuzz",
        "fuzz_var": "fuzzVar",
        "padding": "padding",
        "padding_var": "paddingVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualTrim:
    def __init__(
        self,
        *,
        fuzz: typing.Optional[builtins.str] = None,
        fuzz_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fuzz: The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz DataAkamaiImagingPolicyImage#fuzz}
        :param fuzz_var: The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz_var DataAkamaiImagingPolicyImage#fuzz_var}
        :param padding: The amount of padding in pixels to add to the trimmed image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: The amount of padding in pixels to add to the trimmed image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d2ebd0adf577240675f04a8acea2999db704943e92e1927a1f48353e3b2b5453)
            check_type(argname="argument fuzz", value=fuzz, expected_type=type_hints["fuzz"])
            check_type(argname="argument fuzz_var", value=fuzz_var, expected_type=type_hints["fuzz_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fuzz is not None:
            self._values["fuzz"] = fuzz
        if fuzz_var is not None:
            self._values["fuzz_var"] = fuzz_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var

    @builtins.property
    def fuzz(self) -> typing.Optional[builtins.str]:
        '''The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz DataAkamaiImagingPolicyImage#fuzz}
        '''
        result = self._values.get("fuzz")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fuzz_var(self) -> typing.Optional[builtins.str]:
        '''The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz_var DataAkamaiImagingPolicyImage#fuzz_var}
        '''
        result = self._values.get("fuzz_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''The amount of padding in pixels to add to the trimmed image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''The amount of padding in pixels to add to the trimmed image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualTrim(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualTrimList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualTrimList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fc91aeffebd8d457c300cff32590378777afc9e7fe7ce97393bf0288b702dcda)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualTrimOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__29cbbc268c1d6f95142913327713a292f8a590d9791dd0b168ba72e2ee3c7084)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualTrimOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6edfbe2cdabf85f1bd17c55bf3f8355377ae692cc1c972832bb22cea6511ab03)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c99a1a59b7fd42ede9f2a4c85d5aa70bef51f3e8e940f7afbd342c8909dd0b4c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__15e5a8883744fbb30329b5930cd0a920208bb88ab1b0aa0efa6382dd848c9e1f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualTrim]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualTrim]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualTrim]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0797952251ede46180fc862be75f3dc6bf75a5f310d4258c4c80301b26d6abce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualTrimOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualTrimOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__725cad7477638f14d042ada75b8878c7664c14b19e8b4d08f3058344ad341532)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetFuzz")
    def reset_fuzz(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFuzz", []))

    @jsii.member(jsii_name="resetFuzzVar")
    def reset_fuzz_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFuzzVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @builtins.property
    @jsii.member(jsii_name="fuzzInput")
    def fuzz_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fuzzInput"))

    @builtins.property
    @jsii.member(jsii_name="fuzzVarInput")
    def fuzz_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fuzzVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="fuzz")
    def fuzz(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fuzz"))

    @fuzz.setter
    def fuzz(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__35ae5710eb4fd8da8e90175eb8079332b59be2f57d6f91831425d762cd364de7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fuzz", value)

    @builtins.property
    @jsii.member(jsii_name="fuzzVar")
    def fuzz_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fuzzVar"))

    @fuzz_var.setter
    def fuzz_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__16d6bbab46035426411d6e213aee422212aa20d12676a37977ca750ce66aa3cd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fuzzVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__086ad9aaa0e9bb54bde389d507bcb3696354223b1faed5f98f547c3125550643)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__871b27dd4136c46caf0cee0f5bf0ba73bff0f5af33bbeb8aca2533054e68c53c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualTrim]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualTrim]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualTrim]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__109078ee7b49a986a2a9f41bd29594f20f443262a3a94fd9df92c6d8cd3c7a13)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualUnsharpMask",
    jsii_struct_bases=[],
    name_mapping={
        "gain": "gain",
        "gain_var": "gainVar",
        "sigma": "sigma",
        "sigma_var": "sigmaVar",
        "threshold": "threshold",
        "threshold_var": "thresholdVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualUnsharpMask:
    def __init__(
        self,
        *,
        gain: typing.Optional[builtins.str] = None,
        gain_var: typing.Optional[builtins.str] = None,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
        threshold: typing.Optional[builtins.str] = None,
        threshold_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param gain: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        :param gain_var: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        :param sigma: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        :param threshold: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        :param threshold_var: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f7f325c29d188940a27a9da0995212701cf146da44b19f3bebdc17732ac51484)
            check_type(argname="argument gain", value=gain, expected_type=type_hints["gain"])
            check_type(argname="argument gain_var", value=gain_var, expected_type=type_hints["gain_var"])
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
            check_type(argname="argument threshold", value=threshold, expected_type=type_hints["threshold"])
            check_type(argname="argument threshold_var", value=threshold_var, expected_type=type_hints["threshold_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if gain is not None:
            self._values["gain"] = gain
        if gain_var is not None:
            self._values["gain_var"] = gain_var
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var
        if threshold is not None:
            self._values["threshold"] = threshold
        if threshold_var is not None:
            self._values["threshold_var"] = threshold_var

    @builtins.property
    def gain(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        '''
        result = self._values.get("gain")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gain_var(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        '''
        result = self._values.get("gain_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        '''
        result = self._values.get("threshold")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold_var(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        result = self._values.get("threshold_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualUnsharpMask(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualUnsharpMaskList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualUnsharpMaskList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__394c44efa685d0b727863be90b86672ce9bdfd883e106361f418980a1c60a86b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualUnsharpMaskOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__abc7ce8862391dc41ae9486584164a72a9be1652ebe8d6814850a62fd471b039)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualUnsharpMaskOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__19488313d6c3cb3f2cae5517cf1a276e971188e7c627b015983d44cbfb78db2f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8bdcd9e15573af25b3ac29b3e757d200b501180ac6210976e6614244264cfd14)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__390b2669d5f2c151a86c6d08e5802910bd3f68176bddfb65a90d97079c861041)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualUnsharpMask]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualUnsharpMask]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualUnsharpMask]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__facf4099d74a32f3fc7ed4f86c0d4bb6da5edb14de4e7992d34753db3b437d28)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualUnsharpMaskOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualUnsharpMaskOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__23a1864e6f60d19b6e59f9ebc6860062798fd546607c1e31f95cd74be61b732e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetGain")
    def reset_gain(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGain", []))

    @jsii.member(jsii_name="resetGainVar")
    def reset_gain_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGainVar", []))

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @jsii.member(jsii_name="resetThreshold")
    def reset_threshold(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThreshold", []))

    @jsii.member(jsii_name="resetThresholdVar")
    def reset_threshold_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThresholdVar", []))

    @builtins.property
    @jsii.member(jsii_name="gainInput")
    def gain_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainInput"))

    @builtins.property
    @jsii.member(jsii_name="gainVarInput")
    def gain_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdInput")
    def threshold_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdVarInput")
    def threshold_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gain")
    def gain(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gain"))

    @gain.setter
    def gain(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a43ab91af561775dde0abdeeb3c0ca0082a4bf719bb94e47760e747757e1992)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gain", value)

    @builtins.property
    @jsii.member(jsii_name="gainVar")
    def gain_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gainVar"))

    @gain_var.setter
    def gain_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2abb7877247ee5ed490d3f4fb7fee351d398bf7009142b41cb9507b455dca201)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gainVar", value)

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2c48b276fcc0361742eb679a4ef66526ee69e5d166276539009c5d4f880a5129)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__86549e45b5e149f20e4cade715914cdf0349d83935adc0c1a309a52d84e5f5e3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="threshold")
    def threshold(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "threshold"))

    @threshold.setter
    def threshold(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1c086953e4c519e94988668371c930a0ef95fd563d2a856305edb1100b84e576)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "threshold", value)

    @builtins.property
    @jsii.member(jsii_name="thresholdVar")
    def threshold_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "thresholdVar"))

    @threshold_var.setter
    def threshold_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4261ba1ec4d4cf73f612d8f634bb65e776b3abd3128f6c37213f692cf5be8881)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "thresholdVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualUnsharpMask]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualUnsharpMask]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualUnsharpMask]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__06c210de9925939943f4be59b60d275c4ca5b4ed07ddcf6b39f25ffe1f0326b5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThan",
    jsii_struct_bases=[],
    name_mapping={
        "append": "append",
        "aspect_crop": "aspectCrop",
        "background_color": "backgroundColor",
        "blur": "blur",
        "chroma_key": "chromaKey",
        "composite": "composite",
        "compound": "compound",
        "contrast": "contrast",
        "crop": "crop",
        "face_crop": "faceCrop",
        "feature_crop": "featureCrop",
        "fit_and_fill": "fitAndFill",
        "goop": "goop",
        "grayscale": "grayscale",
        "hsl": "hsl",
        "hsv": "hsv",
        "if_dimension": "ifDimension",
        "if_orientation": "ifOrientation",
        "im_query": "imQuery",
        "max_colors": "maxColors",
        "mirror": "mirror",
        "mono_hue": "monoHue",
        "opacity": "opacity",
        "region_of_interest_crop": "regionOfInterestCrop",
        "relative_crop": "relativeCrop",
        "remove_color": "removeColor",
        "resize": "resize",
        "rotate": "rotate",
        "scale": "scale",
        "shear": "shear",
        "trim": "trim",
        "unsharp_mask": "unsharpMask",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThan:
    def __init__(
        self,
        *,
        append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanAppend", typing.Dict[builtins.str, typing.Any]]]]] = None,
        aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanAspectCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanBackgroundColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanBlur", typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanChromaKey", typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanComposite", typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanCompound", typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanContrast", typing.Dict[builtins.str, typing.Any]]]]] = None,
        crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanFaceCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanFeatureCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanFitAndFill", typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanGoop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanGrayscale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanHsl", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanHsv", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfDimension", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfOrientation", typing.Dict[builtins.str, typing.Any]]]]] = None,
        im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanImQuery", typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanMaxColors", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanMirror", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanMonoHue", typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanOpacity", typing.Dict[builtins.str, typing.Any]]]]] = None,
        region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanRegionOfInterestCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanRelativeCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanRemoveColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanResize", typing.Dict[builtins.str, typing.Any]]]]] = None,
        rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanRotate", typing.Dict[builtins.str, typing.Any]]]]] = None,
        scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanScale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanShear", typing.Dict[builtins.str, typing.Any]]]]] = None,
        trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanTrim", typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanUnsharpMask", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param append: append block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        :param aspect_crop: aspect_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param crop: crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        :param face_crop: face_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        :param feature_crop: feature_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        :param fit_and_fill: fit_and_fill block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param im_query: im_query block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param region_of_interest_crop: region_of_interest_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        :param relative_crop: relative_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param resize: resize block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        :param rotate: rotate block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        :param scale: scale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param shear: shear block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        :param trim: trim block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b94307905fec899e0a57381f9207da840c54795e30e6bd5fef227f9c96869b0e)
            check_type(argname="argument append", value=append, expected_type=type_hints["append"])
            check_type(argname="argument aspect_crop", value=aspect_crop, expected_type=type_hints["aspect_crop"])
            check_type(argname="argument background_color", value=background_color, expected_type=type_hints["background_color"])
            check_type(argname="argument blur", value=blur, expected_type=type_hints["blur"])
            check_type(argname="argument chroma_key", value=chroma_key, expected_type=type_hints["chroma_key"])
            check_type(argname="argument composite", value=composite, expected_type=type_hints["composite"])
            check_type(argname="argument compound", value=compound, expected_type=type_hints["compound"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument crop", value=crop, expected_type=type_hints["crop"])
            check_type(argname="argument face_crop", value=face_crop, expected_type=type_hints["face_crop"])
            check_type(argname="argument feature_crop", value=feature_crop, expected_type=type_hints["feature_crop"])
            check_type(argname="argument fit_and_fill", value=fit_and_fill, expected_type=type_hints["fit_and_fill"])
            check_type(argname="argument goop", value=goop, expected_type=type_hints["goop"])
            check_type(argname="argument grayscale", value=grayscale, expected_type=type_hints["grayscale"])
            check_type(argname="argument hsl", value=hsl, expected_type=type_hints["hsl"])
            check_type(argname="argument hsv", value=hsv, expected_type=type_hints["hsv"])
            check_type(argname="argument if_dimension", value=if_dimension, expected_type=type_hints["if_dimension"])
            check_type(argname="argument if_orientation", value=if_orientation, expected_type=type_hints["if_orientation"])
            check_type(argname="argument im_query", value=im_query, expected_type=type_hints["im_query"])
            check_type(argname="argument max_colors", value=max_colors, expected_type=type_hints["max_colors"])
            check_type(argname="argument mirror", value=mirror, expected_type=type_hints["mirror"])
            check_type(argname="argument mono_hue", value=mono_hue, expected_type=type_hints["mono_hue"])
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument region_of_interest_crop", value=region_of_interest_crop, expected_type=type_hints["region_of_interest_crop"])
            check_type(argname="argument relative_crop", value=relative_crop, expected_type=type_hints["relative_crop"])
            check_type(argname="argument remove_color", value=remove_color, expected_type=type_hints["remove_color"])
            check_type(argname="argument resize", value=resize, expected_type=type_hints["resize"])
            check_type(argname="argument rotate", value=rotate, expected_type=type_hints["rotate"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument shear", value=shear, expected_type=type_hints["shear"])
            check_type(argname="argument trim", value=trim, expected_type=type_hints["trim"])
            check_type(argname="argument unsharp_mask", value=unsharp_mask, expected_type=type_hints["unsharp_mask"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if append is not None:
            self._values["append"] = append
        if aspect_crop is not None:
            self._values["aspect_crop"] = aspect_crop
        if background_color is not None:
            self._values["background_color"] = background_color
        if blur is not None:
            self._values["blur"] = blur
        if chroma_key is not None:
            self._values["chroma_key"] = chroma_key
        if composite is not None:
            self._values["composite"] = composite
        if compound is not None:
            self._values["compound"] = compound
        if contrast is not None:
            self._values["contrast"] = contrast
        if crop is not None:
            self._values["crop"] = crop
        if face_crop is not None:
            self._values["face_crop"] = face_crop
        if feature_crop is not None:
            self._values["feature_crop"] = feature_crop
        if fit_and_fill is not None:
            self._values["fit_and_fill"] = fit_and_fill
        if goop is not None:
            self._values["goop"] = goop
        if grayscale is not None:
            self._values["grayscale"] = grayscale
        if hsl is not None:
            self._values["hsl"] = hsl
        if hsv is not None:
            self._values["hsv"] = hsv
        if if_dimension is not None:
            self._values["if_dimension"] = if_dimension
        if if_orientation is not None:
            self._values["if_orientation"] = if_orientation
        if im_query is not None:
            self._values["im_query"] = im_query
        if max_colors is not None:
            self._values["max_colors"] = max_colors
        if mirror is not None:
            self._values["mirror"] = mirror
        if mono_hue is not None:
            self._values["mono_hue"] = mono_hue
        if opacity is not None:
            self._values["opacity"] = opacity
        if region_of_interest_crop is not None:
            self._values["region_of_interest_crop"] = region_of_interest_crop
        if relative_crop is not None:
            self._values["relative_crop"] = relative_crop
        if remove_color is not None:
            self._values["remove_color"] = remove_color
        if resize is not None:
            self._values["resize"] = resize
        if rotate is not None:
            self._values["rotate"] = rotate
        if scale is not None:
            self._values["scale"] = scale
        if shear is not None:
            self._values["shear"] = shear
        if trim is not None:
            self._values["trim"] = trim
        if unsharp_mask is not None:
            self._values["unsharp_mask"] = unsharp_mask

    @builtins.property
    def append(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanAppend"]]]:
        '''append block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        '''
        result = self._values.get("append")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanAppend"]]], result)

    @builtins.property
    def aspect_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanAspectCrop"]]]:
        '''aspect_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        '''
        result = self._values.get("aspect_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanAspectCrop"]]], result)

    @builtins.property
    def background_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanBackgroundColor"]]]:
        '''background_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        '''
        result = self._values.get("background_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanBackgroundColor"]]], result)

    @builtins.property
    def blur(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanBlur"]]]:
        '''blur block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        '''
        result = self._values.get("blur")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanBlur"]]], result)

    @builtins.property
    def chroma_key(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanChromaKey"]]]:
        '''chroma_key block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        '''
        result = self._values.get("chroma_key")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanChromaKey"]]], result)

    @builtins.property
    def composite(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanComposite"]]]:
        '''composite block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        '''
        result = self._values.get("composite")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanComposite"]]], result)

    @builtins.property
    def compound(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanCompound"]]]:
        '''compound block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        '''
        result = self._values.get("compound")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanCompound"]]], result)

    @builtins.property
    def contrast(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanContrast"]]]:
        '''contrast block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanContrast"]]], result)

    @builtins.property
    def crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanCrop"]]]:
        '''crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        '''
        result = self._values.get("crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanCrop"]]], result)

    @builtins.property
    def face_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanFaceCrop"]]]:
        '''face_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        '''
        result = self._values.get("face_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanFaceCrop"]]], result)

    @builtins.property
    def feature_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanFeatureCrop"]]]:
        '''feature_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        '''
        result = self._values.get("feature_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanFeatureCrop"]]], result)

    @builtins.property
    def fit_and_fill(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanFitAndFill"]]]:
        '''fit_and_fill block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        '''
        result = self._values.get("fit_and_fill")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanFitAndFill"]]], result)

    @builtins.property
    def goop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanGoop"]]]:
        '''goop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        '''
        result = self._values.get("goop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanGoop"]]], result)

    @builtins.property
    def grayscale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanGrayscale"]]]:
        '''grayscale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        '''
        result = self._values.get("grayscale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanGrayscale"]]], result)

    @builtins.property
    def hsl(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanHsl"]]]:
        '''hsl block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        '''
        result = self._values.get("hsl")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanHsl"]]], result)

    @builtins.property
    def hsv(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanHsv"]]]:
        '''hsv block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        '''
        result = self._values.get("hsv")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanHsv"]]], result)

    @builtins.property
    def if_dimension(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfDimension"]]]:
        '''if_dimension block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        '''
        result = self._values.get("if_dimension")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfDimension"]]], result)

    @builtins.property
    def if_orientation(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfOrientation"]]]:
        '''if_orientation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        '''
        result = self._values.get("if_orientation")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfOrientation"]]], result)

    @builtins.property
    def im_query(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanImQuery"]]]:
        '''im_query block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        '''
        result = self._values.get("im_query")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanImQuery"]]], result)

    @builtins.property
    def max_colors(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanMaxColors"]]]:
        '''max_colors block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        '''
        result = self._values.get("max_colors")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanMaxColors"]]], result)

    @builtins.property
    def mirror(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanMirror"]]]:
        '''mirror block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        '''
        result = self._values.get("mirror")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanMirror"]]], result)

    @builtins.property
    def mono_hue(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanMonoHue"]]]:
        '''mono_hue block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        '''
        result = self._values.get("mono_hue")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanMonoHue"]]], result)

    @builtins.property
    def opacity(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanOpacity"]]]:
        '''opacity block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanOpacity"]]], result)

    @builtins.property
    def region_of_interest_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanRegionOfInterestCrop"]]]:
        '''region_of_interest_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        '''
        result = self._values.get("region_of_interest_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanRegionOfInterestCrop"]]], result)

    @builtins.property
    def relative_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanRelativeCrop"]]]:
        '''relative_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        '''
        result = self._values.get("relative_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanRelativeCrop"]]], result)

    @builtins.property
    def remove_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanRemoveColor"]]]:
        '''remove_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        '''
        result = self._values.get("remove_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanRemoveColor"]]], result)

    @builtins.property
    def resize(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanResize"]]]:
        '''resize block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        '''
        result = self._values.get("resize")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanResize"]]], result)

    @builtins.property
    def rotate(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanRotate"]]]:
        '''rotate block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        '''
        result = self._values.get("rotate")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanRotate"]]], result)

    @builtins.property
    def scale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanScale"]]]:
        '''scale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanScale"]]], result)

    @builtins.property
    def shear(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanShear"]]]:
        '''shear block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        '''
        result = self._values.get("shear")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanShear"]]], result)

    @builtins.property
    def trim(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanTrim"]]]:
        '''trim block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        '''
        result = self._values.get("trim")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanTrim"]]], result)

    @builtins.property
    def unsharp_mask(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanUnsharpMask"]]]:
        '''unsharp_mask block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        result = self._values.get("unsharp_mask")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanUnsharpMask"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanAppend",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_priority": "gravityPriority",
        "gravity_priority_var": "gravityPriorityVar",
        "gravity_var": "gravityVar",
        "preserve_minor_dimension": "preserveMinorDimension",
        "preserve_minor_dimension_var": "preserveMinorDimensionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanAppend:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanAppendImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_priority: typing.Optional[builtins.str] = None,
        gravity_priority_var: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        preserve_minor_dimension: typing.Optional[builtins.str] = None,
        preserve_minor_dimension_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Specifies where to place the ``image`` relative to the source image. The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_priority: Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal. The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority DataAkamaiImagingPolicyImage#gravity_priority}
        :param gravity_priority_var: Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal. The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority_var DataAkamaiImagingPolicyImage#gravity_priority_var}
        :param gravity_var: Specifies where to place the ``image`` relative to the source image. The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param preserve_minor_dimension: Whether to preserve the source image's minor dimension, ``false`` by default. The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension DataAkamaiImagingPolicyImage#preserve_minor_dimension}
        :param preserve_minor_dimension_var: Whether to preserve the source image's minor dimension, ``false`` by default. The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension_var DataAkamaiImagingPolicyImage#preserve_minor_dimension_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanAppendImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__880841aed7e79876cdf497114d61b53a563a77748eaf75cedc597b3fbee545db)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_priority", value=gravity_priority, expected_type=type_hints["gravity_priority"])
            check_type(argname="argument gravity_priority_var", value=gravity_priority_var, expected_type=type_hints["gravity_priority_var"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument preserve_minor_dimension", value=preserve_minor_dimension, expected_type=type_hints["preserve_minor_dimension"])
            check_type(argname="argument preserve_minor_dimension_var", value=preserve_minor_dimension_var, expected_type=type_hints["preserve_minor_dimension_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_priority is not None:
            self._values["gravity_priority"] = gravity_priority
        if gravity_priority_var is not None:
            self._values["gravity_priority_var"] = gravity_priority_var
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if preserve_minor_dimension is not None:
            self._values["preserve_minor_dimension"] = preserve_minor_dimension
        if preserve_minor_dimension_var is not None:
            self._values["preserve_minor_dimension_var"] = preserve_minor_dimension_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanAppendImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanAppendImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Specifies where to place the ``image`` relative to the source image.

        The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_priority(self) -> typing.Optional[builtins.str]:
        '''Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal.

        The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority DataAkamaiImagingPolicyImage#gravity_priority}
        '''
        result = self._values.get("gravity_priority")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_priority_var(self) -> typing.Optional[builtins.str]:
        '''Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal.

        The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority_var DataAkamaiImagingPolicyImage#gravity_priority_var}
        '''
        result = self._values.get("gravity_priority_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Specifies where to place the ``image`` relative to the source image.

        The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def preserve_minor_dimension(self) -> typing.Optional[builtins.str]:
        '''Whether to preserve the source image's minor dimension, ``false`` by default.

        The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension DataAkamaiImagingPolicyImage#preserve_minor_dimension}
        '''
        result = self._values.get("preserve_minor_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def preserve_minor_dimension_var(self) -> typing.Optional[builtins.str]:
        '''Whether to preserve the source image's minor dimension, ``false`` by default.

        The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension_var DataAkamaiImagingPolicyImage#preserve_minor_dimension_var}
        '''
        result = self._values.get("preserve_minor_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanAppend(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanAppendImage",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanAppendImage:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanAppendImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanAppendImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanAppendImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c76a449d6f267ca1b139e3d2cf4c6726a29ced5e477dd9ff8811c94bd45fa801)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanAppendImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanAppendImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanAppendImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__53356d57d413c5b8b21b154ff33e1f64a88f491d83c62296837466c68334968e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanAppendList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanAppendList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4639d7e780206024a972659901ff503c2229360cfa3d923cac6ba40736d9ea4d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanAppendOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__604641e372af3edde61f3b605006b5dea180dd90d26387022bdbd36a357af263)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanAppendOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5143f30b425067a480e99190fb7af0bf22ead3668d03d7d6f7df21a5ccf4cbb1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c587262af6b2bd216debf805f3bb2b3acb46292a8ef82c124acd794b77952c16)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a12289f1fd1ec1d2d4ee861fba01a4b2a649a0ac7a8b4e29e07c9e72a6f6c7c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanAppend]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanAppend]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanAppend]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__385c711136d79628d66aa8b676cc1eeec90b333bb28afbed5c827208d77c9223)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanAppendOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanAppendOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__426f6ace2ff34cc538707d5c2d09f0f0eff000fd9d64408cd5a4e24b39892057)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanAppendImage()

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityPriority")
    def reset_gravity_priority(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityPriority", []))

    @jsii.member(jsii_name="resetGravityPriorityVar")
    def reset_gravity_priority_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityPriorityVar", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPreserveMinorDimension")
    def reset_preserve_minor_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPreserveMinorDimension", []))

    @jsii.member(jsii_name="resetPreserveMinorDimensionVar")
    def reset_preserve_minor_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPreserveMinorDimensionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanAppendImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanAppendImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityInput")
    def gravity_priority_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityPriorityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityVarInput")
    def gravity_priority_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityPriorityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanAppendImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanAppendImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionInput")
    def preserve_minor_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "preserveMinorDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionVarInput")
    def preserve_minor_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "preserveMinorDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c3b859b5e7752bfc9af943921eacd25f3a9a4511b3bd0c3836ebf832ee554cd7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityPriority")
    def gravity_priority(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityPriority"))

    @gravity_priority.setter
    def gravity_priority(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e96117e455f20af6cc695ff5636bb61a17d136aea78a8cbb8361ddeaed241424)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityPriority", value)

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityVar")
    def gravity_priority_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityPriorityVar"))

    @gravity_priority_var.setter
    def gravity_priority_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5c8b6ac88e25628c3bd56f4060102b8e1dfb28e29fd0b6e9a8ebebf3f590c66d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityPriorityVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__268385e759a2477fb42d49c9f3bab17b6d5b0a31d50d4d13399712a30b3067ed)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimension")
    def preserve_minor_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "preserveMinorDimension"))

    @preserve_minor_dimension.setter
    def preserve_minor_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3314f6ebea4efa4b5eac4bec6de53b0e89adb2e9391092f5448d4e08fe86cf11)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "preserveMinorDimension", value)

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionVar")
    def preserve_minor_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "preserveMinorDimensionVar"))

    @preserve_minor_dimension_var.setter
    def preserve_minor_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b103ec7088bc3aede5de7eb8079963c5a75c9cbf676d7015fe7bd434ed2ece72)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "preserveMinorDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanAppend]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanAppend]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanAppend]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5bfa85dea4aa5005243c0853ddf49c911bc7e9f1b99df436fc50df7ab686baf7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanAspectCrop",
    jsii_struct_bases=[],
    name_mapping={
        "allow_expansion": "allowExpansion",
        "allow_expansion_var": "allowExpansionVar",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanAspectCrop:
    def __init__(
        self,
        *,
        allow_expansion: typing.Optional[builtins.str] = None,
        allow_expansion_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_expansion: Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image. Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        :param allow_expansion_var: Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image. Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        :param height: The height term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The width term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        :param x_position: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac1be89cee83e0c67d42efa085fe04528dfee623535cd5e8b17cd1194acacdf7)
            check_type(argname="argument allow_expansion", value=allow_expansion, expected_type=type_hints["allow_expansion"])
            check_type(argname="argument allow_expansion_var", value=allow_expansion_var, expected_type=type_hints["allow_expansion_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if allow_expansion is not None:
            self._values["allow_expansion"] = allow_expansion
        if allow_expansion_var is not None:
            self._values["allow_expansion_var"] = allow_expansion_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def allow_expansion(self) -> typing.Optional[builtins.str]:
        '''Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image.

        Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        '''
        result = self._values.get("allow_expansion")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def allow_expansion_var(self) -> typing.Optional[builtins.str]:
        '''Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image.

        Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        '''
        result = self._values.get("allow_expansion_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanAspectCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanAspectCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanAspectCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4b3c21ec8b1d9844d906906c1691348fa8c61b28c9c06ed4f8072a9318f86415)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanAspectCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d3a575454669482727c50b93fac5e9c160739f09f589e067a3a5ff1a42b42c12)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanAspectCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2e8b7c91f31564c21814d9e7e27496adc3cb3a86efa57ea57fd6ddb2ef1613b2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__36c94d3c0c1e29e1af5cdff1de889124baca44e02a92b58e783025fe82afbb8a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e060a029cce3d716c3dab235826761f8a45ee3c874f2c8131d40744d1e3d9601)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanAspectCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanAspectCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanAspectCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1cad3f4172570d02942eb7cba473a7f93e97f14f742b86d0b128ebfdfed1a923)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanAspectCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanAspectCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7b738e3cf86cf07606737ec5cc8922faea6ce3828757c39262c5acfcf4e1c5b8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAllowExpansion")
    def reset_allow_expansion(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansion", []))

    @jsii.member(jsii_name="resetAllowExpansionVar")
    def reset_allow_expansion_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansionVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionInput")
    def allow_expansion_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVarInput")
    def allow_expansion_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansion")
    def allow_expansion(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansion"))

    @allow_expansion.setter
    def allow_expansion(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8fc223a44bde05ed1421c32565443e8bc90ff054209aec2d7082732e3e0a514b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansion", value)

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVar")
    def allow_expansion_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansionVar"))

    @allow_expansion_var.setter
    def allow_expansion_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__82413eaee0b56e718cdf8cc13218f4a9fb2ed629a84e656c8afe72c604293761)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansionVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e5bf590dc6d3d8fdf323aaab929153cbe7411d77d3cdd59592258aa2a762a773)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b09324750bd5f70725a36875520f5351b26c45c3326db24c09c8a12187b00967)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a96044121a50260effa91af4f3f38c3b8071e2b687f7e964432ee66679a28ffc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9c36a70f5514d61c5e017d805567fdb186d3fc0ff6fe084da4f69b5db95414d9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__47da6964347e684dcead78dd519897293547a0f82ef66ecc3e7f5800a145e38f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3c872a6a0181c0ba5ca4dcd2654a87d5da5c25492eadb715f12ff47f01dc357e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f93c23d4ae54d7844f9f5e07ad556f989ec76c169339c5394606643e42cac67)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__61886ccd54f5231b990f4068cc38fef03265dd60a3156fc8d762443123d6e739)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanAspectCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanAspectCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanAspectCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__42faf9d57b4e38630f5f5bd06b96ab41180e9e1264ec074f65719bd3919285b4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanBackgroundColor",
    jsii_struct_bases=[],
    name_mapping={"color": "color", "color_var": "colorVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanBackgroundColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5c25a0f0a6b884ca4dfc209f46e8cce312b0f94f17f7355487825b4cce3013e1)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanBackgroundColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanBackgroundColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanBackgroundColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__53c1332c6f548c31c575d70343e62e6971583842643d57fcd7cb486dd2dde4b8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanBackgroundColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5a61b62d6569bc40890cabfcac30b55ec563b41bc79bcc04b3b3dec80de2a7cc)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanBackgroundColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__28e833f9d03b809ae98ba60cc920a7cc737d89390bb4391a5cba96de46422b8e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ca793bd58a294261595d84a761d394fb5be2af0076b10a9cadc17af1a6ed1ca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0c95ca6c5820e3cc3116c27492e4e84e07262ba0760333b2afb31a48301c45a9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanBackgroundColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanBackgroundColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d02d97fdf9201ee3c1a72f01d89c493b9937ad37ffdc4dc91cf30dfe51b53cc6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanBackgroundColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanBackgroundColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__871792e44d7d1d325b778bd7e16d2830b55c2c0e1dc196ab3cecd1a442a0c69d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5059ae992b426753db6fe9f441d5f4f1eae656f0148034ca19d0e63176f6f16c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__896c8d84dc0663147b969ef71572d457942071489677104721637b137066b79f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanBackgroundColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanBackgroundColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanBackgroundColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b3821f8d9443ccf091b25b95542e9b2031c1bb450c8743c85c360637088d4945)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanBlur",
    jsii_struct_bases=[],
    name_mapping={"sigma": "sigma", "sigma_var": "sigmaVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanBlur:
    def __init__(
        self,
        *,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param sigma: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f92b7653821668292f983993f47d8816631082455bfb492773cc2619f962dee4)
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanBlur(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanBlurList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanBlurList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5e99f68e1a3c1f5d80459194cc26ba04652e006ee9b10e1f3281c0abe1e834a3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanBlurOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__32808e089641d7ddb471d75638faca2fe4722efdf939eff2a40b01b6490c560c)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanBlurOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__199faa0be8c93c5335c2d090a492815c4172004549ee42034905621e561051d9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__97f336f6996052ca2f766df2a0c52e91c295e93338163b830588eb4872e92e50)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bcd03efab3b689a84eddcaaf1ea04ed44618256e0c127b2d112c76dd1b693e37)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanBlur]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanBlur]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5e93927ce3fb49922ad4688880c9ab0ea24296059e895b28e28c90881b89a4e9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanBlurOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanBlurOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d003e6a77b273fb743cac574369095b90e019d2743ec7247d31381d81e560cbb)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__588ed85ed0c2e6380bc1301a813ba517fb6dd1146569e741735e30ea5fec5193)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4cfe74d2d2452cf340c43bbde30ef7aec7ba867c0d4fa9816c834d0f95e6c875)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanBlur]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanBlur]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanBlur]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__811b1b658f6e8ef124add96a7575a7ff3420573fa22a66339d49d56fc60ca6a2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanChromaKey",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_feather": "hueFeather",
        "hue_feather_var": "hueFeatherVar",
        "hue_tolerance": "hueTolerance",
        "hue_tolerance_var": "hueToleranceVar",
        "hue_var": "hueVar",
        "lightness_feather": "lightnessFeather",
        "lightness_feather_var": "lightnessFeatherVar",
        "lightness_tolerance": "lightnessTolerance",
        "lightness_tolerance_var": "lightnessToleranceVar",
        "saturation_feather": "saturationFeather",
        "saturation_feather_var": "saturationFeatherVar",
        "saturation_tolerance": "saturationTolerance",
        "saturation_tolerance_var": "saturationToleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanChromaKey:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_feather: typing.Optional[builtins.str] = None,
        hue_feather_var: typing.Optional[builtins.str] = None,
        hue_tolerance: typing.Optional[builtins.str] = None,
        hue_tolerance_var: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness_feather: typing.Optional[builtins.str] = None,
        lightness_feather_var: typing.Optional[builtins.str] = None,
        lightness_tolerance: typing.Optional[builtins.str] = None,
        lightness_tolerance_var: typing.Optional[builtins.str] = None,
        saturation_feather: typing.Optional[builtins.str] = None,
        saturation_feather_var: typing.Optional[builtins.str] = None,
        saturation_tolerance: typing.Optional[builtins.str] = None,
        saturation_tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_feather: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        :param hue_feather_var: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        :param hue_tolerance: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        :param hue_tolerance_var: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        :param hue_var: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness_feather: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        :param lightness_feather_var: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        :param lightness_tolerance: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        :param lightness_tolerance_var: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        :param saturation_feather: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        :param saturation_feather_var: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        :param saturation_tolerance: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        :param saturation_tolerance_var: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f7eeb2e7621b9509f372b3053d393d970f69a12629404a2d0337cb3add1b9fb9)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_feather", value=hue_feather, expected_type=type_hints["hue_feather"])
            check_type(argname="argument hue_feather_var", value=hue_feather_var, expected_type=type_hints["hue_feather_var"])
            check_type(argname="argument hue_tolerance", value=hue_tolerance, expected_type=type_hints["hue_tolerance"])
            check_type(argname="argument hue_tolerance_var", value=hue_tolerance_var, expected_type=type_hints["hue_tolerance_var"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness_feather", value=lightness_feather, expected_type=type_hints["lightness_feather"])
            check_type(argname="argument lightness_feather_var", value=lightness_feather_var, expected_type=type_hints["lightness_feather_var"])
            check_type(argname="argument lightness_tolerance", value=lightness_tolerance, expected_type=type_hints["lightness_tolerance"])
            check_type(argname="argument lightness_tolerance_var", value=lightness_tolerance_var, expected_type=type_hints["lightness_tolerance_var"])
            check_type(argname="argument saturation_feather", value=saturation_feather, expected_type=type_hints["saturation_feather"])
            check_type(argname="argument saturation_feather_var", value=saturation_feather_var, expected_type=type_hints["saturation_feather_var"])
            check_type(argname="argument saturation_tolerance", value=saturation_tolerance, expected_type=type_hints["saturation_tolerance"])
            check_type(argname="argument saturation_tolerance_var", value=saturation_tolerance_var, expected_type=type_hints["saturation_tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_feather is not None:
            self._values["hue_feather"] = hue_feather
        if hue_feather_var is not None:
            self._values["hue_feather_var"] = hue_feather_var
        if hue_tolerance is not None:
            self._values["hue_tolerance"] = hue_tolerance
        if hue_tolerance_var is not None:
            self._values["hue_tolerance_var"] = hue_tolerance_var
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness_feather is not None:
            self._values["lightness_feather"] = lightness_feather
        if lightness_feather_var is not None:
            self._values["lightness_feather_var"] = lightness_feather_var
        if lightness_tolerance is not None:
            self._values["lightness_tolerance"] = lightness_tolerance
        if lightness_tolerance_var is not None:
            self._values["lightness_tolerance_var"] = lightness_tolerance_var
        if saturation_feather is not None:
            self._values["saturation_feather"] = saturation_feather
        if saturation_feather_var is not None:
            self._values["saturation_feather_var"] = saturation_feather_var
        if saturation_tolerance is not None:
            self._values["saturation_tolerance"] = saturation_tolerance
        if saturation_tolerance_var is not None:
            self._values["saturation_tolerance_var"] = saturation_tolerance_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        '''
        result = self._values.get("hue_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        '''
        result = self._values.get("hue_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        '''
        result = self._values.get("hue_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        '''
        result = self._values.get("hue_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        '''
        result = self._values.get("lightness_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        '''
        result = self._values.get("lightness_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        '''
        result = self._values.get("lightness_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        '''
        result = self._values.get("lightness_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        '''
        result = self._values.get("saturation_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        '''
        result = self._values.get("saturation_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        '''
        result = self._values.get("saturation_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        result = self._values.get("saturation_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanChromaKey(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanChromaKeyList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanChromaKeyList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb6a5b85aaebc9ea20d0f21846405b5a0073d5b16528e02d791ab3fd324c5a58)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanChromaKeyOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__972d8e344c6ae19be228626518c3864bc1021e7d5f1be5428a4a1a7e06f4c3ff)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanChromaKeyOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__480fba2bf3b5af54aef01c09e9ed3d686820348d086d1f1368ad4925eb08ad4a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a2396155c32ad3c19d75838c8efb9dcefd2c8d87a3249d0c4d8cc8ac5c774999)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d48425263825ddf01268ff212fea8fd5f5c0a01f617aab4d818ee2ac19297d2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanChromaKey]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanChromaKey]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__47ea2f78ce9215d40c259d8470fbe695d72b359f6b0a6b415cb4d60cddbbe24c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanChromaKeyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanChromaKeyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__87470d2c912824320ef83c3a2ca10937209b35ff9c57fef8c8cf77a05d22586d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueFeather")
    def reset_hue_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeather", []))

    @jsii.member(jsii_name="resetHueFeatherVar")
    def reset_hue_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeatherVar", []))

    @jsii.member(jsii_name="resetHueTolerance")
    def reset_hue_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueTolerance", []))

    @jsii.member(jsii_name="resetHueToleranceVar")
    def reset_hue_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueToleranceVar", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightnessFeather")
    def reset_lightness_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeather", []))

    @jsii.member(jsii_name="resetLightnessFeatherVar")
    def reset_lightness_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeatherVar", []))

    @jsii.member(jsii_name="resetLightnessTolerance")
    def reset_lightness_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessTolerance", []))

    @jsii.member(jsii_name="resetLightnessToleranceVar")
    def reset_lightness_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessToleranceVar", []))

    @jsii.member(jsii_name="resetSaturationFeather")
    def reset_saturation_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeather", []))

    @jsii.member(jsii_name="resetSaturationFeatherVar")
    def reset_saturation_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeatherVar", []))

    @jsii.member(jsii_name="resetSaturationTolerance")
    def reset_saturation_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationTolerance", []))

    @jsii.member(jsii_name="resetSaturationToleranceVar")
    def reset_saturation_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherInput")
    def hue_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVarInput")
    def hue_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceInput")
    def hue_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVarInput")
    def hue_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherInput")
    def lightness_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVarInput")
    def lightness_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceInput")
    def lightness_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVarInput")
    def lightness_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherInput")
    def saturation_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVarInput")
    def saturation_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceInput")
    def saturation_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVarInput")
    def saturation_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__92f680adea12225ea6c267d86a99740ab5cea720bd17e2223244543ee316fe69)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeather")
    def hue_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeather"))

    @hue_feather.setter
    def hue_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3de5b80e40cf6c45f95a9a608243af869724347802368c7104eb22a5404c7721)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeather", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVar")
    def hue_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeatherVar"))

    @hue_feather_var.setter
    def hue_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__97686d07b326d03313ed266eea49ee8ee225e6e761bf5a79f71d4c58b38999b0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueTolerance")
    def hue_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueTolerance"))

    @hue_tolerance.setter
    def hue_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d0f1991c40842f0b60a6a0d77c2b34cdb1814ff6e724ceddb3ef132f0b133da0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVar")
    def hue_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueToleranceVar"))

    @hue_tolerance_var.setter
    def hue_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__33c81cd87fa6f2de799b6fbd56dd479f47316fd23a56fb90337b63e3cc6c495e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b99123e770acc706be35796be165b68ac1029739ae7c6e628ae2026e4ff2c1af)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeather")
    def lightness_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeather"))

    @lightness_feather.setter
    def lightness_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0aa731c40a7299930f028c527e8624828b4eebc643e9994c130f7cd1889ce213)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeather", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVar")
    def lightness_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeatherVar"))

    @lightness_feather_var.setter
    def lightness_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6ca5640fa6c1b13eb0912ed77e31d9ab0d488449ea29c4fcf54f360cfe3951d2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessTolerance")
    def lightness_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessTolerance"))

    @lightness_tolerance.setter
    def lightness_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0880c8fc463a41a6e0b56bcae00c4383c6fe63fa564044061d352f0ef84139be)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVar")
    def lightness_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessToleranceVar"))

    @lightness_tolerance_var.setter
    def lightness_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e1201c69f4007d599bc14ef628ec29768aba2c9dc5cf9c687ac969b77e06bf78)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeather")
    def saturation_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeather"))

    @saturation_feather.setter
    def saturation_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__50fb77995f56846ee6d65146481ebcc77d8c8d89962be65a3000891137c30675)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeather", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVar")
    def saturation_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeatherVar"))

    @saturation_feather_var.setter
    def saturation_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aff701815190145804c279641179960bd8e1761ec7f0303073c47ad92c5bac09)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationTolerance")
    def saturation_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationTolerance"))

    @saturation_tolerance.setter
    def saturation_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__126b50945348ba8d4ef76db09beebeb27f28e175bba59888fdd207f0ef5c5180)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVar")
    def saturation_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationToleranceVar"))

    @saturation_tolerance_var.setter
    def saturation_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fb9af95b151fb12d21cf6ea07266f3060ec10e662c7e452541ec768f5b506ec2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanChromaKey]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanChromaKey]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanChromaKey]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a39f9330ec1fdcd0d64722616f14eb2b5b5fb4d9270023f0fa4e73ce4f43c29)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanComposite",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "placement": "placement",
        "placement_var": "placementVar",
        "scale": "scale",
        "scale_dimension": "scaleDimension",
        "scale_dimension_var": "scaleDimensionVar",
        "scale_var": "scaleVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanComposite:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanCompositeImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        placement: typing.Optional[builtins.str] = None,
        placement_var: typing.Optional[builtins.str] = None,
        scale: typing.Optional[builtins.str] = None,
        scale_dimension: typing.Optional[builtins.str] = None,
        scale_dimension_var: typing.Optional[builtins.str] = None,
        scale_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param placement: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        :param placement_var: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        :param scale: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param scale_dimension: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        :param scale_dimension_var: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        :param scale_var: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        :param x_position: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanCompositeImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a5bcbc58286b7e2b898cb15aa39cdeff1bb5269d7f2e33021fb1f0cdd1af953)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument placement", value=placement, expected_type=type_hints["placement"])
            check_type(argname="argument placement_var", value=placement_var, expected_type=type_hints["placement_var"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument scale_dimension", value=scale_dimension, expected_type=type_hints["scale_dimension"])
            check_type(argname="argument scale_dimension_var", value=scale_dimension_var, expected_type=type_hints["scale_dimension_var"])
            check_type(argname="argument scale_var", value=scale_var, expected_type=type_hints["scale_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if placement is not None:
            self._values["placement"] = placement
        if placement_var is not None:
            self._values["placement_var"] = placement_var
        if scale is not None:
            self._values["scale"] = scale
        if scale_dimension is not None:
            self._values["scale_dimension"] = scale_dimension
        if scale_dimension_var is not None:
            self._values["scale_dimension_var"] = scale_dimension_var
        if scale_var is not None:
            self._values["scale_var"] = scale_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanCompositeImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanCompositeImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        '''
        result = self._values.get("placement")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement_var(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        '''
        result = self._values.get("placement_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        '''
        result = self._values.get("scale_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        '''
        result = self._values.get("scale_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        '''
        result = self._values.get("scale_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanComposite(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanCompositeImage",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanCompositeImage:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanCompositeImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanCompositeImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanCompositeImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a329e1bd55f5faa64433f45f328f09bdad756ca4e2cf57c3f45dde2b7ed9bb3a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanCompositeImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanCompositeImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3901f2f995b05b4f4f6e9c93a2799c932acdfaa2817d4cff78e9ea157c89d4de)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanCompositeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanCompositeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d83daca631ede2936e51730d48cd01d60ca70cf950c21f8de0027c6575a8bcb5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanCompositeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7feec19a53ee9452e1326dcd324e1aaffb7457635a0dd5ece6a0861bd4229848)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanCompositeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6c116384352ffde0091f8cb5ee45ddae82025aa30233280f2771c0aa8c6e0e5b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b1e59bfdd394a649d049d921d03b77fef785408f2f0558a6c8337626147dfb3a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af82ccfb19049e1b9e6aa6f8da6ec4613ee9f935e8f1d3c56ca6711e2d86dc0a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanComposite]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanComposite]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8270d100bc77a70a1d1d516758b949c32d44ef9ed77ba1a11b8028c7be87349c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanCompositeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanCompositeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a8bcccb313742f907d6da11866683de66a5d6394b0e4bf110f5580f559d5eba)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanCompositeImage()

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPlacement")
    def reset_placement(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacement", []))

    @jsii.member(jsii_name="resetPlacementVar")
    def reset_placement_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacementVar", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetScaleDimension")
    def reset_scale_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimension", []))

    @jsii.member(jsii_name="resetScaleDimensionVar")
    def reset_scale_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimensionVar", []))

    @jsii.member(jsii_name="resetScaleVar")
    def reset_scale_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanCompositeImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanCompositeImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanCompositeImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="placementInput")
    def placement_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementInput"))

    @builtins.property
    @jsii.member(jsii_name="placementVarInput")
    def placement_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionInput")
    def scale_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVarInput")
    def scale_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleVarInput")
    def scale_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__612814320d0dbb8d552d25a829070ccf41e55d031be54f2e80f8302bfc899dbb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a7282b64efc0b35a4d74d7e71881448a4d3fa14e66ab7fa87b23e87b13f7914)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="placement")
    def placement(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placement"))

    @placement.setter
    def placement(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__289ceec929853bb6fa44b23d29a890a6a7aeac896da8b09c4ef724170350e87b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placement", value)

    @builtins.property
    @jsii.member(jsii_name="placementVar")
    def placement_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placementVar"))

    @placement_var.setter
    def placement_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a66defc0226f52541c59290b86bd658be59501d0632251365940cdf7eb2cd6f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placementVar", value)

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scale"))

    @scale.setter
    def scale(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e3f29a004b2b77a6a0cb3d000312ef04a26e4e8957e5c27a0f023d48941ed710)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scale", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimension")
    def scale_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimension"))

    @scale_dimension.setter
    def scale_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f202ea5e0db9038fb66d16099e07c5b1676c96c96ac4903adb8637c92e5b5435)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimension", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVar")
    def scale_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimensionVar"))

    @scale_dimension_var.setter
    def scale_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ca00d586b4f5effd6fc3aebc37bdbb8f2dd531ac941ef46567ecde2b47a91e9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="scaleVar")
    def scale_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleVar"))

    @scale_var.setter
    def scale_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__33076a8407834004082a4c2b12fc17c7735697cc548a566adf2ded0bdd76d854)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__407910acd1a2c869c624f9f416475397e49ddbf660159857c127de2fa057c60f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ae925f144e2f2402154c3e7c7d88b89e44f00f435b664487362a49b6d5cbf880)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5a8ef2ead93b5b912afa68a8093f6be54524826c3de6e46effca96d0a55c97a7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2b06516c07df1ee8776fab74551547273cda2a533b5d09ad169e6382f71ff241)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanComposite]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanComposite]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanComposite]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7391f76ea4205bd32ff3f4b5fa37a0e43fc7f4eb131ff8da3386534281abbc98)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanCompound",
    jsii_struct_bases=[],
    name_mapping={"transformations": "transformations"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanCompound:
    def __init__(
        self,
        *,
        transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param transformations: transformations block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__83c284dd66cc735ff2e059973cabd12d0b241daa7bee148d1c3648443bf5a7a9)
            check_type(argname="argument transformations", value=transformations, expected_type=type_hints["transformations"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if transformations is not None:
            self._values["transformations"] = transformations

    @builtins.property
    def transformations(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanCompoundTransformations"]]]:
        '''transformations block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        result = self._values.get("transformations")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanCompoundTransformations"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanCompound(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanCompoundList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanCompoundList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ad5b94ad6bcaf120383ba3df7e5f4778c9e74aa9a84d1b6dbb243e1634458a2a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanCompoundOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c7fe2a6f0f217385ab999d9ba6ecb4a882c2e752083264b051652df4e1735252)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanCompoundOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__71d23fc7ffd09eeae0f6a3930efb74d9d691ecb5bd0af9f912d48819a68ff411)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__887073d118a11fe282a84b31f6e128b7c2aa256fc5932d2f00f5017f96dc99db)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f3bda9262b8a4f1ac7095e11820cca620e8020714eac10dae12de26cea9dbe2d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanCompound]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanCompound]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__86b764fab3bf680c2c87eb37ad2fb58b9e8f3be3a29f2a86f86cc816c58b7f60)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanCompoundOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanCompoundOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a90cd7b1fb4217b3285a2ff6468f90b7650ef4c09eae375e30055dc75bd5580f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformations")
    def put_transformations(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1c861abf98bc377c877cd178ecad0ec4ccc718549cb28671abe4c3981fbdbb39)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTransformations", [value]))

    @jsii.member(jsii_name="resetTransformations")
    def reset_transformations(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformations", []))

    @builtins.property
    @jsii.member(jsii_name="transformations")
    def transformations(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanCompoundTransformationsList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanCompoundTransformationsList", jsii.get(self, "transformations"))

    @builtins.property
    @jsii.member(jsii_name="transformationsInput")
    def transformations_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanCompoundTransformations"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanCompoundTransformations"]]], jsii.get(self, "transformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanCompound]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanCompound]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanCompound]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__17a9d63102b1a188cdaf8f0bf01754f63ced7cbd0959880aec89eccc291d7989)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanCompoundTransformations",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanCompoundTransformations:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanCompoundTransformations(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanCompoundTransformationsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanCompoundTransformationsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1bed20ffc0d9f35547ca8d1ce321d47b1268d395bc368437eed9dbd9bf1c46ff)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanCompoundTransformationsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__21d571760ae5a928f656877203203b541bffc5844bacaee95aaa16d9fa47bd80)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanCompoundTransformationsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f055f3d5347e27898c40fd898b65730070f692b2116347e982209569350920a2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__68d1892e197da0c501d151608e97340691caea04dd759a2d2cae0e2cb46326ea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1a9d9e75656af01494d98461ad3e7005db74d67919bee9f4f482e7e1443c8978)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanCompoundTransformations]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanCompoundTransformations]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanCompoundTransformations]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4b2694212ea2a45005d5c96bfeccbaec80fe9d27f87fd073cd4874056c9c3cec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanCompoundTransformationsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanCompoundTransformationsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d8bb6b7d6e20be53d0a69f8dc365b6825aab00b088eb21cfe6a8dd6bf2c34497)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanCompoundTransformations]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanCompoundTransformations]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanCompoundTransformations]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__88a9f1407463fcd4ce46028b0156b6bffc0cabae8a397a34b4a48aa5902d81fb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanContrast",
    jsii_struct_bases=[],
    name_mapping={
        "brightness": "brightness",
        "brightness_var": "brightnessVar",
        "contrast": "contrast",
        "contrast_var": "contrastVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanContrast:
    def __init__(
        self,
        *,
        brightness: typing.Optional[builtins.str] = None,
        brightness_var: typing.Optional[builtins.str] = None,
        contrast: typing.Optional[builtins.str] = None,
        contrast_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param brightness: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        :param brightness_var: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        :param contrast: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param contrast_var: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__56e7b478663fda087456d53103bd0bb8c574d742ac10be67db81d5c27b8d67b0)
            check_type(argname="argument brightness", value=brightness, expected_type=type_hints["brightness"])
            check_type(argname="argument brightness_var", value=brightness_var, expected_type=type_hints["brightness_var"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument contrast_var", value=contrast_var, expected_type=type_hints["contrast_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if brightness is not None:
            self._values["brightness"] = brightness
        if brightness_var is not None:
            self._values["brightness_var"] = brightness_var
        if contrast is not None:
            self._values["contrast"] = contrast
        if contrast_var is not None:
            self._values["contrast_var"] = contrast_var

    @builtins.property
    def brightness(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        '''
        result = self._values.get("brightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def brightness_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        '''
        result = self._values.get("brightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        result = self._values.get("contrast_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanContrast(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanContrastList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanContrastList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__61ec8b139dd0d882494574cde54049e4076189ff3b54de532ff35f99546b12c0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanContrastOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3af1960530e7bf303c8c6b183014fd2e6280a86eec3f91c16e54d2546260c5fb)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanContrastOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b0f0c176d618801672d5d92f95e99b98a7b7abf078f1e9989eda6855a8d38f77)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c0a38d4a7909393ee209976a37463646e179a06e5c63748e8ef0b590a23e771e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__831944b61f3d6bad525e6791ff7bc2cd4c2fe497392f156a356c8cbf8da85d2b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanContrast]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanContrast]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3209bee96ad21ca461c2e560bde1f89905e3a15c75d0b0be08aef1b5ffe2da6e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanContrastOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanContrastOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1248a2240415f5f8d0da6eb5bb76a6c5b8f2578df889d66e83e5dcde2f4e0299)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetBrightness")
    def reset_brightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightness", []))

    @jsii.member(jsii_name="resetBrightnessVar")
    def reset_brightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightnessVar", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetContrastVar")
    def reset_contrast_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrastVar", []))

    @builtins.property
    @jsii.member(jsii_name="brightnessInput")
    def brightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="brightnessVarInput")
    def brightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastVarInput")
    def contrast_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="brightness")
    def brightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightness"))

    @brightness.setter
    def brightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__19932de95cb2f0c783b541657ddf297634c8546f35c7695a94b511e15a870cc4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightness", value)

    @builtins.property
    @jsii.member(jsii_name="brightnessVar")
    def brightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightnessVar"))

    @brightness_var.setter
    def brightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__948cfa161017d105a36cd7a0a632549e488781a6725c193716560a78060bd177)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrast"))

    @contrast.setter
    def contrast(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0e6ad8583d39e45708dd5e02e2e5b7b6ea952ca2874d0485655709d148c4d09c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrast", value)

    @builtins.property
    @jsii.member(jsii_name="contrastVar")
    def contrast_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrastVar"))

    @contrast_var.setter
    def contrast_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2b325fb5301c496752db0a3af758f2256fbe915a2da0ebf32113218508319ed7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrastVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanContrast]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanContrast]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanContrast]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__653ffdbc93807818df06d6d172e7b6e354ca048fff50d41b5bc5ad6eb69a883e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanCrop",
    jsii_struct_bases=[],
    name_mapping={
        "allow_expansion": "allowExpansion",
        "allow_expansion_var": "allowExpansionVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanCrop:
    def __init__(
        self,
        *,
        allow_expansion: typing.Optional[builtins.str] = None,
        allow_expansion_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_expansion: If cropping an area outside of the existing canvas, expands the image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        :param allow_expansion_var: If cropping an area outside of the existing canvas, expands the image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        :param gravity: Frame of reference for X and Y Positions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Frame of reference for X and Y Positions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The number of pixels to crop along the y-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The number of pixels to crop along the y-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The number of pixels to crop along the x-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The number of pixels to crop along the x-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        :param x_position: The x-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__61ebb9adeed6847f63a73d6a7c3c5eb44731d66d4f9e3a89504840d4ac40dbfc)
            check_type(argname="argument allow_expansion", value=allow_expansion, expected_type=type_hints["allow_expansion"])
            check_type(argname="argument allow_expansion_var", value=allow_expansion_var, expected_type=type_hints["allow_expansion_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if allow_expansion is not None:
            self._values["allow_expansion"] = allow_expansion
        if allow_expansion_var is not None:
            self._values["allow_expansion_var"] = allow_expansion_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def allow_expansion(self) -> typing.Optional[builtins.str]:
        '''If cropping an area outside of the existing canvas, expands the image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        '''
        result = self._values.get("allow_expansion")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def allow_expansion_var(self) -> typing.Optional[builtins.str]:
        '''If cropping an area outside of the existing canvas, expands the image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        '''
        result = self._values.get("allow_expansion_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Frame of reference for X and Y Positions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Frame of reference for X and Y Positions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the y-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the y-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the x-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the x-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b70e40197eeffa56db0e0133e647dbccdb536b920d7cade295f50b34523778cd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__feed7b0bc05f9df93179837dfb0f7ac7de806ad579a50ee166285ed626ca47df)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6bfb6bd5002061f99211d47d3c5700da1d3c3b6539af7321463401d6bd249a09)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5afe865318b46c946a8238de8d17c7cc366daf43461a9c8eb0e7cf874e6393f5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__67e75076ee04ec181f9decf820433303bd8220f7ce14df9e95963555d57418e1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8b55fc20ba55c52056a0ba7a8dbc95fa8dded0958ed049a7779170f06c895e7c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__76c7210e3177922cab4bdbb1f2152bff599ecc8d043388822a5a78e73307d181)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAllowExpansion")
    def reset_allow_expansion(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansion", []))

    @jsii.member(jsii_name="resetAllowExpansionVar")
    def reset_allow_expansion_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansionVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionInput")
    def allow_expansion_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVarInput")
    def allow_expansion_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansion")
    def allow_expansion(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansion"))

    @allow_expansion.setter
    def allow_expansion(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1391a953540a7b4a5bcd5abd5d1fb1a755ffa29207cba83102c510e1b42a90ad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansion", value)

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVar")
    def allow_expansion_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansionVar"))

    @allow_expansion_var.setter
    def allow_expansion_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__40decb4e42eadcea79a59fef342251601f16421d21f82edb742c9764cd39cf1c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansionVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9e4ed1e664b3f9d9f7cbaed2e7c8fc14df516dc07e7c6e214ccf94babdd9cabd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a4c3dc2538e34a447efef2cc9fd4072f1e6c0a34686bae92df5213708eda2bef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d5e80441a2566b9dcb4e9eccea28ac6ce6b5ed662605b6a55ec09dcabdd40ab9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cb9b2667debe978541492431dd5851c956fc98cc5d2712771bcbc003232e0cd5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ed01c3dbb934df772c2ae7e6f8292e5c2fff2b1296d39569320f44fdd5931d65)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__50d3c86acba95118b15d633fd3adcdcb104d225ef232239e24c389155d2fed77)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__180b8a69ee618b4f8795e278a740f612b7d0a842e1198ecf5cf7200a7b9c31a4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e664f601838841bbc5c92f99ef5b2ee3256661f462d17d8025bfcfd63cd0c2ae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2881380c62da6d1905c996712692d60cd97a2326d4bcc3abae0c8120e4c29ea5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f179b4109131b39902da6d0271898f29ad69f5c331cb7a4acc3918a917c7bbd5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ca96a48af497caf48c0b3d3221baa556328ddbe557a0f203fb39bc46a536242f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanFaceCrop",
    jsii_struct_bases=[],
    name_mapping={
        "algorithm": "algorithm",
        "algorithm_var": "algorithmVar",
        "confidence": "confidence",
        "confidence_var": "confidenceVar",
        "fail_gravity": "failGravity",
        "fail_gravity_var": "failGravityVar",
        "focus": "focus",
        "focus_var": "focusVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "padding": "padding",
        "padding_var": "paddingVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanFaceCrop:
    def __init__(
        self,
        *,
        algorithm: typing.Optional[builtins.str] = None,
        algorithm_var: typing.Optional[builtins.str] = None,
        confidence: typing.Optional[builtins.str] = None,
        confidence_var: typing.Optional[builtins.str] = None,
        fail_gravity: typing.Optional[builtins.str] = None,
        fail_gravity_var: typing.Optional[builtins.str] = None,
        focus: typing.Optional[builtins.str] = None,
        focus_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param algorithm: Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm DataAkamaiImagingPolicyImage#algorithm}
        :param algorithm_var: Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm_var DataAkamaiImagingPolicyImage#algorithm_var}
        :param confidence: With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image. Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence DataAkamaiImagingPolicyImage#confidence}
        :param confidence_var: With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image. Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence_var DataAkamaiImagingPolicyImage#confidence_var}
        :param fail_gravity: Controls placement of the crop if Image and Video Manager does not detect any faces in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        :param fail_gravity_var: Controls placement of the crop if Image and Video Manager does not detect any faces in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        :param focus: Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus DataAkamaiImagingPolicyImage#focus}
        :param focus_var: Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus_var DataAkamaiImagingPolicyImage#focus_var}
        :param gravity: Controls placement of the crop. Directions are relative to the face(s) plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Controls placement of the crop. Directions are relative to the face(s) plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param padding: The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        :param style: Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__63e311b8cfc78ca375f7a8ac197b8b434cea97024480df05948415f298f9be8d)
            check_type(argname="argument algorithm", value=algorithm, expected_type=type_hints["algorithm"])
            check_type(argname="argument algorithm_var", value=algorithm_var, expected_type=type_hints["algorithm_var"])
            check_type(argname="argument confidence", value=confidence, expected_type=type_hints["confidence"])
            check_type(argname="argument confidence_var", value=confidence_var, expected_type=type_hints["confidence_var"])
            check_type(argname="argument fail_gravity", value=fail_gravity, expected_type=type_hints["fail_gravity"])
            check_type(argname="argument fail_gravity_var", value=fail_gravity_var, expected_type=type_hints["fail_gravity_var"])
            check_type(argname="argument focus", value=focus, expected_type=type_hints["focus"])
            check_type(argname="argument focus_var", value=focus_var, expected_type=type_hints["focus_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if algorithm is not None:
            self._values["algorithm"] = algorithm
        if algorithm_var is not None:
            self._values["algorithm_var"] = algorithm_var
        if confidence is not None:
            self._values["confidence"] = confidence
        if confidence_var is not None:
            self._values["confidence_var"] = confidence_var
        if fail_gravity is not None:
            self._values["fail_gravity"] = fail_gravity
        if fail_gravity_var is not None:
            self._values["fail_gravity_var"] = fail_gravity_var
        if focus is not None:
            self._values["focus"] = focus
        if focus_var is not None:
            self._values["focus_var"] = focus_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def algorithm(self) -> typing.Optional[builtins.str]:
        '''Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm DataAkamaiImagingPolicyImage#algorithm}
        '''
        result = self._values.get("algorithm")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def algorithm_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm_var DataAkamaiImagingPolicyImage#algorithm_var}
        '''
        result = self._values.get("algorithm_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def confidence(self) -> typing.Optional[builtins.str]:
        '''With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image.

        Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence DataAkamaiImagingPolicyImage#confidence}
        '''
        result = self._values.get("confidence")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def confidence_var(self) -> typing.Optional[builtins.str]:
        '''With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image.

        Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence_var DataAkamaiImagingPolicyImage#confidence_var}
        '''
        result = self._values.get("confidence_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any faces in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        '''
        result = self._values.get("fail_gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any faces in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        '''
        result = self._values.get("fail_gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def focus(self) -> typing.Optional[builtins.str]:
        '''Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus DataAkamaiImagingPolicyImage#focus}
        '''
        result = self._values.get("focus")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def focus_var(self) -> typing.Optional[builtins.str]:
        '''Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus_var DataAkamaiImagingPolicyImage#focus_var}
        '''
        result = self._values.get("focus_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the face(s) plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the face(s) plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanFaceCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanFaceCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanFaceCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ef6df1ec1caf16a11f2aa36c70363df28e3db41e52fc5de46d927956433d6004)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanFaceCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c72066f16e44367681a90b829c8403b20d40e4955f927237b97ef5ce51d1362b)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanFaceCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8af512fac57e834ccf5add3a1e9f65d686021bc85f67a63bf442c21d649246f9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__89e3e6e96ce3dd59057463eaed3e1aa8df95e726eb11816ba1f0db7e58c79224)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6316d39d2b894f3baee4085169763c52fb4a45e4c884c00c0e573116b02714fd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanFaceCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanFaceCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanFaceCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__64c61a842296bb9af3a5286841119b837e0212f458954536205b2fabb9e435ce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanFaceCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanFaceCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fc1230a464eaf58ff628c3d6c555ad4e66904942db58577d18939a644f2a8e06)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAlgorithm")
    def reset_algorithm(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAlgorithm", []))

    @jsii.member(jsii_name="resetAlgorithmVar")
    def reset_algorithm_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAlgorithmVar", []))

    @jsii.member(jsii_name="resetConfidence")
    def reset_confidence(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetConfidence", []))

    @jsii.member(jsii_name="resetConfidenceVar")
    def reset_confidence_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetConfidenceVar", []))

    @jsii.member(jsii_name="resetFailGravity")
    def reset_fail_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravity", []))

    @jsii.member(jsii_name="resetFailGravityVar")
    def reset_fail_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravityVar", []))

    @jsii.member(jsii_name="resetFocus")
    def reset_focus(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFocus", []))

    @jsii.member(jsii_name="resetFocusVar")
    def reset_focus_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFocusVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="algorithmInput")
    def algorithm_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "algorithmInput"))

    @builtins.property
    @jsii.member(jsii_name="algorithmVarInput")
    def algorithm_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "algorithmVarInput"))

    @builtins.property
    @jsii.member(jsii_name="confidenceInput")
    def confidence_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "confidenceInput"))

    @builtins.property
    @jsii.member(jsii_name="confidenceVarInput")
    def confidence_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "confidenceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityInput")
    def fail_gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityVarInput")
    def fail_gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="focusInput")
    def focus_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "focusInput"))

    @builtins.property
    @jsii.member(jsii_name="focusVarInput")
    def focus_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "focusVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="algorithm")
    def algorithm(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "algorithm"))

    @algorithm.setter
    def algorithm(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6a4f37a54be1fd4cdf68e611821e97fba751470aed2c978269bcabc8bac7221d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "algorithm", value)

    @builtins.property
    @jsii.member(jsii_name="algorithmVar")
    def algorithm_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "algorithmVar"))

    @algorithm_var.setter
    def algorithm_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__50a5e1dee78278bcee6907c42aa21798009d615eedc62ea0296d7b97cf8d1ef1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "algorithmVar", value)

    @builtins.property
    @jsii.member(jsii_name="confidence")
    def confidence(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "confidence"))

    @confidence.setter
    def confidence(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3413d7b28ad9fe446fa280476d7bf5f3ed2065f0743937ae448fc025cf7b0bf1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "confidence", value)

    @builtins.property
    @jsii.member(jsii_name="confidenceVar")
    def confidence_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "confidenceVar"))

    @confidence_var.setter
    def confidence_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__93dcd8b599abe62c29fe8806cea61fe3c29a47cb56dbfcfdc15929df98528a3e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "confidenceVar", value)

    @builtins.property
    @jsii.member(jsii_name="failGravity")
    def fail_gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravity"))

    @fail_gravity.setter
    def fail_gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__78c4eccede132064f10e40fc1d70d6c45607494e5c012b3c6877380c217cb710)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravity", value)

    @builtins.property
    @jsii.member(jsii_name="failGravityVar")
    def fail_gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravityVar"))

    @fail_gravity_var.setter
    def fail_gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f35f9c3bf6aff84f284bcd07c10ff768d5e38c8992002888ab5502e442b9e23)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="focus")
    def focus(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "focus"))

    @focus.setter
    def focus(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__52641f3b319b45ca4f13a19878e4f59e36796ca0b21720873d706e5de7c2270d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "focus", value)

    @builtins.property
    @jsii.member(jsii_name="focusVar")
    def focus_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "focusVar"))

    @focus_var.setter
    def focus_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a2fdba64efd8ff45dc933027ae4738b13e314bc6a5c9a69f78431072f099275)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "focusVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__56757ad692cbac48a5b3513de7fcebdbc82c1c7250c8a4e790f7ed219c6be060)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c840cd4176b36fea86e21667ee9827242f16ef9b3cc19583a84b40696a7c16f4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dd32e98be4b4547696e1084f226029a0e9374c6b6d47647e7719ad3478137bab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__15828a7ce198104f641d9bd81090e50ca1c76f88ae7dcd66484e3ad0d7c2d38d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1c89c4ec64dc91eb1bd42459e05933d2035cd5d757e1b258854aa35dc14385f8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d23b75afeef5aaba670ae5dfd21ecd5a9ab3758aae0c41d6124e5a41225c361c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5038b865a113d0d1a72657303199875111a76de120442ddc6ca0dba125e20427)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fc1ad76240622d73c1e44e073af87bbce829345cd343acb64d1696b0e315212a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__379d239497b8ab4744dd690413949a7a5ff54cb4d7a6fe46e0f7776caae8549d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4665a681d7abed0760376b4e67b6708af8b8524df45935cd97c6b29830332269)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanFaceCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanFaceCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanFaceCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fe89f11eae0c776a844c39e10c4f654386874b9fa756dbc93c70808264dcb719)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanFeatureCrop",
    jsii_struct_bases=[],
    name_mapping={
        "fail_gravity": "failGravity",
        "fail_gravity_var": "failGravityVar",
        "feature_radius": "featureRadius",
        "feature_radius_var": "featureRadiusVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "max_features": "maxFeatures",
        "max_features_var": "maxFeaturesVar",
        "min_feature_quality": "minFeatureQuality",
        "min_feature_quality_var": "minFeatureQualityVar",
        "padding": "padding",
        "padding_var": "paddingVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanFeatureCrop:
    def __init__(
        self,
        *,
        fail_gravity: typing.Optional[builtins.str] = None,
        fail_gravity_var: typing.Optional[builtins.str] = None,
        feature_radius: typing.Optional[builtins.str] = None,
        feature_radius_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        max_features: typing.Optional[builtins.str] = None,
        max_features_var: typing.Optional[builtins.str] = None,
        min_feature_quality: typing.Optional[builtins.str] = None,
        min_feature_quality_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fail_gravity: Controls placement of the crop if Image and Video Manager does not detect any features in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        :param fail_gravity_var: Controls placement of the crop if Image and Video Manager does not detect any features in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        :param feature_radius: The size in pixels of the important features to search for. If identified, two features never appear closer together than this value, ``8.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius DataAkamaiImagingPolicyImage#feature_radius}
        :param feature_radius_var: The size in pixels of the important features to search for. If identified, two features never appear closer together than this value, ``8.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius_var DataAkamaiImagingPolicyImage#feature_radius_var}
        :param gravity: Controls placement of the crop. Directions are relative to the region of interest plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Controls placement of the crop. Directions are relative to the region of interest plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param max_features: The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features DataAkamaiImagingPolicyImage#max_features}
        :param max_features_var: The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features_var DataAkamaiImagingPolicyImage#max_features_var}
        :param min_feature_quality: Determines the minimum quality level of the feature identified. To consider a feature important, the feature needs to surpass this value. Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality DataAkamaiImagingPolicyImage#min_feature_quality}
        :param min_feature_quality_var: Determines the minimum quality level of the feature identified. To consider a feature important, the feature needs to surpass this value. Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality_var DataAkamaiImagingPolicyImage#min_feature_quality_var}
        :param padding: Adds space around the region of interest. The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: Adds space around the region of interest. The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        :param style: Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8d43d11ea2f0cc99324244f96820311ba2fb818f9a1ecec329a430a8e842e1bf)
            check_type(argname="argument fail_gravity", value=fail_gravity, expected_type=type_hints["fail_gravity"])
            check_type(argname="argument fail_gravity_var", value=fail_gravity_var, expected_type=type_hints["fail_gravity_var"])
            check_type(argname="argument feature_radius", value=feature_radius, expected_type=type_hints["feature_radius"])
            check_type(argname="argument feature_radius_var", value=feature_radius_var, expected_type=type_hints["feature_radius_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument max_features", value=max_features, expected_type=type_hints["max_features"])
            check_type(argname="argument max_features_var", value=max_features_var, expected_type=type_hints["max_features_var"])
            check_type(argname="argument min_feature_quality", value=min_feature_quality, expected_type=type_hints["min_feature_quality"])
            check_type(argname="argument min_feature_quality_var", value=min_feature_quality_var, expected_type=type_hints["min_feature_quality_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fail_gravity is not None:
            self._values["fail_gravity"] = fail_gravity
        if fail_gravity_var is not None:
            self._values["fail_gravity_var"] = fail_gravity_var
        if feature_radius is not None:
            self._values["feature_radius"] = feature_radius
        if feature_radius_var is not None:
            self._values["feature_radius_var"] = feature_radius_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if max_features is not None:
            self._values["max_features"] = max_features
        if max_features_var is not None:
            self._values["max_features_var"] = max_features_var
        if min_feature_quality is not None:
            self._values["min_feature_quality"] = min_feature_quality
        if min_feature_quality_var is not None:
            self._values["min_feature_quality_var"] = min_feature_quality_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def fail_gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any features in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        '''
        result = self._values.get("fail_gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any features in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        '''
        result = self._values.get("fail_gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feature_radius(self) -> typing.Optional[builtins.str]:
        '''The size in pixels of the important features to search for.

        If identified, two features never appear closer together than this value, ``8.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius DataAkamaiImagingPolicyImage#feature_radius}
        '''
        result = self._values.get("feature_radius")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feature_radius_var(self) -> typing.Optional[builtins.str]:
        '''The size in pixels of the important features to search for.

        If identified, two features never appear closer together than this value, ``8.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius_var DataAkamaiImagingPolicyImage#feature_radius_var}
        '''
        result = self._values.get("feature_radius_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the region of interest plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the region of interest plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def max_features(self) -> typing.Optional[builtins.str]:
        '''The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features DataAkamaiImagingPolicyImage#max_features}
        '''
        result = self._values.get("max_features")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def max_features_var(self) -> typing.Optional[builtins.str]:
        '''The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features_var DataAkamaiImagingPolicyImage#max_features_var}
        '''
        result = self._values.get("max_features_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def min_feature_quality(self) -> typing.Optional[builtins.str]:
        '''Determines the minimum quality level of the feature identified.

        To consider a feature important, the feature needs to surpass this value.  Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality DataAkamaiImagingPolicyImage#min_feature_quality}
        '''
        result = self._values.get("min_feature_quality")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def min_feature_quality_var(self) -> typing.Optional[builtins.str]:
        '''Determines the minimum quality level of the feature identified.

        To consider a feature important, the feature needs to surpass this value.  Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality_var DataAkamaiImagingPolicyImage#min_feature_quality_var}
        '''
        result = self._values.get("min_feature_quality_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''Adds space around the region of interest.

        The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''Adds space around the region of interest.

        The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanFeatureCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanFeatureCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanFeatureCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c92e257278eb4a60123a60f3d379df5ba4f879447b68b5a2e5544800e72ed386)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanFeatureCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d46b27231152bb093ff6a6431dafc67e874bd3e9faf40c110036e05b0f2b356b)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanFeatureCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__381ce315377210b40228a1c913225e3b4e5aac16d46e4a1a0a84db0ddafc5d5a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9b98e4942072aab57466c683947e647d5b25a555e4095f37c24327ba3318f534)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b949c94a284ba209d35e90c88de93dceaddef490f3f8ea4aaf14d330cede2293)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanFeatureCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanFeatureCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanFeatureCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5b1a09a161340cf4214a8d89bab14061b7dd5a3acaffbcab41de9e3ca739a77c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanFeatureCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanFeatureCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c6f2e5569188bb65517d36aadae3c93b9c89449b682b9c7e5f8abd9f115b9671)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetFailGravity")
    def reset_fail_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravity", []))

    @jsii.member(jsii_name="resetFailGravityVar")
    def reset_fail_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravityVar", []))

    @jsii.member(jsii_name="resetFeatureRadius")
    def reset_feature_radius(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureRadius", []))

    @jsii.member(jsii_name="resetFeatureRadiusVar")
    def reset_feature_radius_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureRadiusVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetMaxFeatures")
    def reset_max_features(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxFeatures", []))

    @jsii.member(jsii_name="resetMaxFeaturesVar")
    def reset_max_features_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxFeaturesVar", []))

    @jsii.member(jsii_name="resetMinFeatureQuality")
    def reset_min_feature_quality(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMinFeatureQuality", []))

    @jsii.member(jsii_name="resetMinFeatureQualityVar")
    def reset_min_feature_quality_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMinFeatureQualityVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="failGravityInput")
    def fail_gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityVarInput")
    def fail_gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featureRadiusInput")
    def feature_radius_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featureRadiusInput"))

    @builtins.property
    @jsii.member(jsii_name="featureRadiusVarInput")
    def feature_radius_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featureRadiusVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesInput")
    def max_features_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "maxFeaturesInput"))

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesVarInput")
    def max_features_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "maxFeaturesVarInput"))

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityInput")
    def min_feature_quality_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "minFeatureQualityInput"))

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityVarInput")
    def min_feature_quality_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "minFeatureQualityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravity")
    def fail_gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravity"))

    @fail_gravity.setter
    def fail_gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3f4c1f35be64df07e31ed01f560dd8b619be975be50967b0942671508075ed1a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravity", value)

    @builtins.property
    @jsii.member(jsii_name="failGravityVar")
    def fail_gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravityVar"))

    @fail_gravity_var.setter
    def fail_gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8b5266ae2ca5fc7d9a65536306aa2fe1fda1e14ff784d7b3c0c36b751203f766)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="featureRadius")
    def feature_radius(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featureRadius"))

    @feature_radius.setter
    def feature_radius(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dfcf4dae153c6552d3965b221281b567f60480de887842e29cf1ed4413338c63)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featureRadius", value)

    @builtins.property
    @jsii.member(jsii_name="featureRadiusVar")
    def feature_radius_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featureRadiusVar"))

    @feature_radius_var.setter
    def feature_radius_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac0dcb7ef39c8041769717fd6dd127263a7be6f8896438aa4e01362edf1ea8ed)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featureRadiusVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__02e42ed0bd200ef31fbbee7d455ee65f99312499519785fecacd4f9bea4aa188)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__94ab2a37152d05c0654d184f3527cc744df3ae0e19d49df2962bf1d82761a852)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b113a1e02f12d1f14ee241d6de29c9a626b1145b8a287b3caae19ce0a14400b6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e0841aaeaf90a3b10499856151578d3eafba26cc5ac19d1b68fcbeb3df93d375)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="maxFeatures")
    def max_features(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "maxFeatures"))

    @max_features.setter
    def max_features(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__89dac6dd1d7628ec8a8122972e018d7239f154a609b977e48164d0ad705bd4d6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "maxFeatures", value)

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesVar")
    def max_features_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "maxFeaturesVar"))

    @max_features_var.setter
    def max_features_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e5d160987caee2a3054ec5ba7bec1a8b8a133aba4adec36742ff008d8f8a870e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "maxFeaturesVar", value)

    @builtins.property
    @jsii.member(jsii_name="minFeatureQuality")
    def min_feature_quality(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "minFeatureQuality"))

    @min_feature_quality.setter
    def min_feature_quality(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d4a2784f2901ec0c8c4f0f4e81ad690ce78dd2953631662529ae39cfdb3dfeec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "minFeatureQuality", value)

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityVar")
    def min_feature_quality_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "minFeatureQualityVar"))

    @min_feature_quality_var.setter
    def min_feature_quality_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7173278e6cef2491b3a7e3815bea7c61fe5dfb5c70eff8f2a4b66d71cb9f97fe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "minFeatureQualityVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__68ee09535f6c156dc35f0167a6665839204348e45ddf9038fd0d3ad2d2874ed9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f2cc51a25b5dface32e4e58d0ef7707905fef475fdcab407efb756f3959fe93c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__398acb9740a5d0dfb63a80661c4a2fbcab78cf4a56b6184a2c1f6c2369ff55d5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d39eb2898ea44405430ba30b4ed55a583dfe94cee8e3ee1faa306950c0c720d5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4c917d2f6e68dfbde57de0adff869d80212650334bcfe4b9b77ea4876fe97a39)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__00486384f40e756f3cc0b1789b9fe014b72b565d60fdbe3210b906dd5993d54c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanFeatureCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanFeatureCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanFeatureCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a9498548d33044a565dcb64ed30bce4f78bfaecc513ebf6cf83dd5cabc539804)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanFitAndFill",
    jsii_struct_bases=[],
    name_mapping={
        "fill_transformation": "fillTransformation",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanFitAndFill:
    def __init__(
        self,
        *,
        fill_transformation: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanFitAndFillFillTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fill_transformation: fill_transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_transformation DataAkamaiImagingPolicyImage#fill_transformation}
        :param height: The height value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The width value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(fill_transformation, dict):
            fill_transformation = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanFitAndFillFillTransformation(**fill_transformation)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5a1e203153099bb532572dbdf5a2d62401fa3a95441b88d229d19486c7863da4)
            check_type(argname="argument fill_transformation", value=fill_transformation, expected_type=type_hints["fill_transformation"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fill_transformation is not None:
            self._values["fill_transformation"] = fill_transformation
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def fill_transformation(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanFitAndFillFillTransformation"]:
        '''fill_transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_transformation DataAkamaiImagingPolicyImage#fill_transformation}
        '''
        result = self._values.get("fill_transformation")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanFitAndFillFillTransformation"], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanFitAndFill(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanFitAndFillFillTransformation",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanFitAndFillFillTransformation:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanFitAndFillFillTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanFitAndFillFillTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanFitAndFillFillTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fd01183664a21bf5793db805906fa985919e64fa77095572ff64bcb928604c09)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanFitAndFillFillTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanFitAndFillFillTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanFitAndFillFillTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d20bd3e5d3a47804b21fb4b36055df50a5da16763fdc728295388a030ff53866)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanFitAndFillList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanFitAndFillList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8f7db1bf5e356d7cce49c2a95510967a4b0fb524e638647b1a1ff9c0aa452378)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanFitAndFillOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__596d67588cf696ca5a1be8c13aaba4614b330c887774723d0f02545f55514408)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanFitAndFillOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f7d45a75fd0bced4de573b65063644da2aa2b5d6e546b24fcf44de2918020002)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c7d1561b2b4ac82efe122323d015b039a0ec1d2119b75cbc15d3820204d9e3c6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__821514b8fa95b07170a2639307e053297ebc984bc50c1f6ae722571af0c50bed)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanFitAndFill]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanFitAndFill]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanFitAndFill]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__513cfdc95b4bf248713058aaa496add4c3eee02eb938a1017dcbdd2dc58467b2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanFitAndFillOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanFitAndFillOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c6b19f2e79a1a8f4e5deacc9e3ac6eadccbc27883a582991cd942d53ba64e130)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putFillTransformation")
    def put_fill_transformation(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanFitAndFillFillTransformation()

        return typing.cast(None, jsii.invoke(self, "putFillTransformation", [value]))

    @jsii.member(jsii_name="resetFillTransformation")
    def reset_fill_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFillTransformation", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="fillTransformation")
    def fill_transformation(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanFitAndFillFillTransformationOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanFitAndFillFillTransformationOutputReference, jsii.get(self, "fillTransformation"))

    @builtins.property
    @jsii.member(jsii_name="fillTransformationInput")
    def fill_transformation_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanFitAndFillFillTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanFitAndFillFillTransformation], jsii.get(self, "fillTransformationInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d79f54cd80a7b1abc8503bd09fb51de2e8f62678dec425b92e0851516e9c4dd8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e1f5061316f1a418659ed6ff2c877f22909e46da5aa52c7d0de27280502f41c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f61bdb0d3171620dfa9302ac4279805d842aed441c3b35b738fe467cc32092dd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__66f0d6e353a945b2b9eac2d61c14cd844337ab654ad9fb580e073d37ce6ca7fb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanFitAndFill]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanFitAndFill]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanFitAndFill]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ecd99372073fbd152cef1ef5110a8a26ae3ae31fc6d26d8ef44a305573caff75)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanGoop",
    jsii_struct_bases=[],
    name_mapping={
        "chaos": "chaos",
        "chaos_var": "chaosVar",
        "density": "density",
        "density_var": "densityVar",
        "power": "power",
        "power_var": "powerVar",
        "seed": "seed",
        "seed_var": "seedVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanGoop:
    def __init__(
        self,
        *,
        chaos: typing.Optional[builtins.str] = None,
        chaos_var: typing.Optional[builtins.str] = None,
        density: typing.Optional[builtins.str] = None,
        density_var: typing.Optional[builtins.str] = None,
        power: typing.Optional[builtins.str] = None,
        power_var: typing.Optional[builtins.str] = None,
        seed: typing.Optional[builtins.str] = None,
        seed_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param chaos: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        :param chaos_var: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        :param density: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        :param density_var: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        :param power: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        :param power_var: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        :param seed: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        :param seed_var: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d2dbe9d6edacf7b3e5381b406b041025f0c83b99f6306efe893cf17998ee05b)
            check_type(argname="argument chaos", value=chaos, expected_type=type_hints["chaos"])
            check_type(argname="argument chaos_var", value=chaos_var, expected_type=type_hints["chaos_var"])
            check_type(argname="argument density", value=density, expected_type=type_hints["density"])
            check_type(argname="argument density_var", value=density_var, expected_type=type_hints["density_var"])
            check_type(argname="argument power", value=power, expected_type=type_hints["power"])
            check_type(argname="argument power_var", value=power_var, expected_type=type_hints["power_var"])
            check_type(argname="argument seed", value=seed, expected_type=type_hints["seed"])
            check_type(argname="argument seed_var", value=seed_var, expected_type=type_hints["seed_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if chaos is not None:
            self._values["chaos"] = chaos
        if chaos_var is not None:
            self._values["chaos_var"] = chaos_var
        if density is not None:
            self._values["density"] = density
        if density_var is not None:
            self._values["density_var"] = density_var
        if power is not None:
            self._values["power"] = power
        if power_var is not None:
            self._values["power_var"] = power_var
        if seed is not None:
            self._values["seed"] = seed
        if seed_var is not None:
            self._values["seed_var"] = seed_var

    @builtins.property
    def chaos(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        '''
        result = self._values.get("chaos")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def chaos_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        '''
        result = self._values.get("chaos_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        '''
        result = self._values.get("density")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density_var(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        '''
        result = self._values.get("density_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        '''
        result = self._values.get("power")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power_var(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        '''
        result = self._values.get("power_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        '''
        result = self._values.get("seed")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed_var(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        result = self._values.get("seed_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanGoop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanGoopList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanGoopList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__98322537515961d62c89e53c36089c40914db02f4efc86fcfb892ec178d6a93d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanGoopOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b35dcbf7b0acd0cef28b0293706ba81ddec2b25e68ca16af72c7ba6f3ce58a3c)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanGoopOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1e8973d47bad9310073021f19499b126c88630092e02a3949913079edfeec7b0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__528f70f152805d38aa6bb598edc2c5e0020d72cb035fd941ec4669f1de70f029)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4e2e1b5d79b1afe7c880352b5b2b2107bb60179fa4bcfb9c0f58054be4363bff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanGoop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanGoop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3972bf956142fedbfad81157540f6b5b468ff908d67d1a74aa87535fa6e0f58e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanGoopOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanGoopOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ab9bc5021c3478a545173bd54ab7dd78c8fa1fb3ef295d93ad216ad34eff2d9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetChaos")
    def reset_chaos(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaos", []))

    @jsii.member(jsii_name="resetChaosVar")
    def reset_chaos_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaosVar", []))

    @jsii.member(jsii_name="resetDensity")
    def reset_density(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensity", []))

    @jsii.member(jsii_name="resetDensityVar")
    def reset_density_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensityVar", []))

    @jsii.member(jsii_name="resetPower")
    def reset_power(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPower", []))

    @jsii.member(jsii_name="resetPowerVar")
    def reset_power_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPowerVar", []))

    @jsii.member(jsii_name="resetSeed")
    def reset_seed(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeed", []))

    @jsii.member(jsii_name="resetSeedVar")
    def reset_seed_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeedVar", []))

    @builtins.property
    @jsii.member(jsii_name="chaosInput")
    def chaos_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosInput"))

    @builtins.property
    @jsii.member(jsii_name="chaosVarInput")
    def chaos_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosVarInput"))

    @builtins.property
    @jsii.member(jsii_name="densityInput")
    def density_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityInput"))

    @builtins.property
    @jsii.member(jsii_name="densityVarInput")
    def density_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="powerInput")
    def power_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerInput"))

    @builtins.property
    @jsii.member(jsii_name="powerVarInput")
    def power_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerVarInput"))

    @builtins.property
    @jsii.member(jsii_name="seedInput")
    def seed_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedInput"))

    @builtins.property
    @jsii.member(jsii_name="seedVarInput")
    def seed_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedVarInput"))

    @builtins.property
    @jsii.member(jsii_name="chaos")
    def chaos(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaos"))

    @chaos.setter
    def chaos(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3b4aa73dcca497aa08a01164d4386bd6d60a602e94c047e8d8965de9edc5ecd1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaos", value)

    @builtins.property
    @jsii.member(jsii_name="chaosVar")
    def chaos_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaosVar"))

    @chaos_var.setter
    def chaos_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fabfde7d6c3e388c3fbfc388ab34720038c797c0f6544d2dfe16a0b8de42d31b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaosVar", value)

    @builtins.property
    @jsii.member(jsii_name="density")
    def density(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "density"))

    @density.setter
    def density(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__774b761e39438d4ce4ea4b9ea7fe24af8a7ab34f92c29f3efa522e97359bc61f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "density", value)

    @builtins.property
    @jsii.member(jsii_name="densityVar")
    def density_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "densityVar"))

    @density_var.setter
    def density_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7f36b5a99af6ecf1b23a72326c4f853a0588c3e657d4d70624c4de3a545071d2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "densityVar", value)

    @builtins.property
    @jsii.member(jsii_name="power")
    def power(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "power"))

    @power.setter
    def power(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__466097365aa2d20abf40de811e10ea144f07abedbda78d801f85139565dd4e21)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "power", value)

    @builtins.property
    @jsii.member(jsii_name="powerVar")
    def power_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "powerVar"))

    @power_var.setter
    def power_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0eac9784bd782b11fbfaf74e71523851b820d4f1e1984b633182fd06c1b06b96)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "powerVar", value)

    @builtins.property
    @jsii.member(jsii_name="seed")
    def seed(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seed"))

    @seed.setter
    def seed(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d5500cefe8cb288a6a32bbd3721f915acdb66bb21d33eede10adbb527175be96)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seed", value)

    @builtins.property
    @jsii.member(jsii_name="seedVar")
    def seed_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seedVar"))

    @seed_var.setter
    def seed_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__424e25bc43b23ddc8c3fd10414d41e808a9b3c1c7eec49183eb7460430ab1935)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seedVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanGoop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanGoop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanGoop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4955ca123f979a6d01b6b1cddbf8b47ad22c5d692fd86ef0a5d4bb8e22c3fd70)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanGrayscale",
    jsii_struct_bases=[],
    name_mapping={"type": "type", "type_var": "typeVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanGrayscale:
    def __init__(
        self,
        *,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param type: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a49335cc7c506da5436649b6076f3381722d4bf52f517fef3f932844d26d6da7)
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanGrayscale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanGrayscaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanGrayscaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__04f44b7ac3a29378585a7e5b9a2229097b60d979ccc874fa8bbb1e692dc116fa)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanGrayscaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9aee13648d21cd8954c2aea609fc7ef94ba0e3e2c5e159b5e749c9f848a17b59)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanGrayscaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2e1c1cac2b3dba2f56acaa86e5b177025d1541ce48471808f101e4770da98c39)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9cf1a6979b4087214365388c2d7082cb921b928954d2955d41cba13958ba08a0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ae3f9e51ab322893729fe8315cc93077e9f1590160eb681b75705778659616d4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanGrayscale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanGrayscale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b8077dba452a2bd398923e6826f4103a3335d35d26ff97bf11462a055c97ff53)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanGrayscaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanGrayscaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a353012fb6386b66e2e7c11fb2b58a118e35678afd77522d5d6d49091a8d4692)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f0b41007697b8d80fd92bb2b528babb0d87e92f3a11f04c35371756e174af4ab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa57023c24a8ec1ac60b9af1e890519fe519b7a392933f63c8720d5dba4cdb36)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanGrayscale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanGrayscale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanGrayscale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5b53061aadc6f3f7f676ac67c5b209d9b4c8b577d03414506ad62b6a22dd6cea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanHsl",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "lightness": "lightness",
        "lightness_var": "lightnessVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanHsl:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness: typing.Optional[builtins.str] = None,
        lightness_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        :param lightness_var: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__179c580772f34023ead79af5dd449fadf6c8145bd87c7144829bd1fbf826e1d2)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness", value=lightness, expected_type=type_hints["lightness"])
            check_type(argname="argument lightness_var", value=lightness_var, expected_type=type_hints["lightness_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness is not None:
            self._values["lightness"] = lightness
        if lightness_var is not None:
            self._values["lightness_var"] = lightness_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        '''
        result = self._values.get("lightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        '''
        result = self._values.get("lightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanHsl(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanHslList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanHslList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b9ecd325b5ac1c0178adee7a3a6de9c54fdc489778be76c8250ae5ef430b2bde)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanHslOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f44ddcc9a2cbce7f6c18cdfc3a7ed88cd6208921de9a28479630d705ed2523d3)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanHslOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8e124a317d4c5350736e429b5b811d17924fcba24244481f24a24f44f0fda78f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__132f3235a7b7803809e9b6acf83b4d578fb27599c2276c0401b74415b63fe186)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2002cea6713414baa96d651af0d96ec8f767811c92eb372e995b94e9fd8c6019)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanHsl]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanHsl]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9bb6c78eba50c2f7d636d1f87446c25b81bb996aa5d1e1fe0e9a7eb583fa3efa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanHslOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanHslOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__28e2e59552ea51b68e7fc0cca800c2ac084b9ee593517463658f0da78203374b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightness")
    def reset_lightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightness", []))

    @jsii.member(jsii_name="resetLightnessVar")
    def reset_lightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessInput")
    def lightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessVarInput")
    def lightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a4f6db2e18a0a110a747d9d327138b0e740202370dda2f472505f4edcb9a7fd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7f4b8c3a91502ec5bc83e0f2e6b3e27e4d0fb90ecca1be887b15ece2d88f1b3a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightness")
    def lightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightness"))

    @lightness.setter
    def lightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__049a08b8412c566a2081681efcb24d045bc3f64fcb30b8d562190de3afa1a0cb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightness", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessVar")
    def lightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessVar"))

    @lightness_var.setter
    def lightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__58c52cfec416c79906a56227770a4573c745259e90910aa1edc51d3b3e18fdd2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b9ac5e6e687461104b97f017cbc92ed373586d19e40006724e3ca8c6a1c593b4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d8058950acac4566ea523162218cc2f4b91c30545b8c4071b96745a96d3b680c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanHsl]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanHsl]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanHsl]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5d1968b2b0857e1b29e1859c1fa5d24ea98583e3488b89d2c3b1c0ec24a41f0f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanHsv",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanHsv:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        :param value: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e3339a34640da3bcbe34d924ac07a76b32001d8e3e981a20597fc7cac29bb2a4)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanHsv(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanHsvList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanHsvList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9c6ab0ef9836b9a5a2a02eec3fef3dbea19ae379450d48464f7d1d6cc00e3f9a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanHsvOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5308a5b11891cd745d01a82b78d91d56766c6cb7e7e528b67497991b85abe5db)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanHsvOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e48660a067c97a19078a1083046d6b97e74e7d5eb0a38467dbc6d260b818d81a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__14eaf6dcaefe552f0654414b83be832761de927d3fd6ac5075396b9a94b3a637)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__04c598f436643b8eca9401e7a8a28a508fe740da6cd050eeed07685c4f6bd7cc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanHsv]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanHsv]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__27aa4e297e158ad4806d6d7f8e499a915803d786df9fc5d817d576d1ff25e771)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanHsvOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanHsvOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0534f92303a095fbb1c4cbbd46c5da7c9e18ba73028126906d113ddc80e50b40)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e2e7fafdb830fdaf063602e5d6da891917a7ae842c3c81dbe1b04d6cd5ca01f8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f44538069b04f23596c91274579cb8fc5fd5a534cc7ea2594d84cfe4695aa118)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__54ed402b119616a554f7de0e3e29d99b3c516d9fdf574d0116120e2af3f9cbd5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__518557e3a1f51054e09b274927dd1dcc869f1078f6bf48a6ce247b6b29c78fe7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a616dfaa01c8263c2242be94aef5fcc0eeeda47f93206073a77424d064a20a3a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac3182fd13cbf3f24665634232735aa03e445b84ed33d905f0d9d829cfc4bdcc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanHsv]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanHsv]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanHsv]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2f5e9b900bbf7d545e5031070c0fba4ce821d30e4f8755a5fb1d7fa95c28da8b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfDimension",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "dimension": "dimension",
        "dimension_var": "dimensionVar",
        "equal": "equal",
        "greater_than": "greaterThan",
        "less_than": "lessThan",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfDimension:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfDimensionDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        dimension: typing.Optional[builtins.str] = None,
        dimension_var: typing.Optional[builtins.str] = None,
        equal: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfDimensionEqual", typing.Dict[builtins.str, typing.Any]]] = None,
        greater_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfDimensionGreaterThan", typing.Dict[builtins.str, typing.Any]]] = None,
        less_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfDimensionLessThan", typing.Dict[builtins.str, typing.Any]]] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param dimension: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        :param dimension_var: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        :param equal: equal block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        :param greater_than: greater_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        :param less_than: less_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        :param value: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfDimensionDefault(**default)
        if isinstance(equal, dict):
            equal = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfDimensionEqual(**equal)
        if isinstance(greater_than, dict):
            greater_than = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfDimensionGreaterThan(**greater_than)
        if isinstance(less_than, dict):
            less_than = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfDimensionLessThan(**less_than)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__94d82af3719a876ab6394b91130a6a33ef2ccce5191730a593ffd7280ad05b7e)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument dimension", value=dimension, expected_type=type_hints["dimension"])
            check_type(argname="argument dimension_var", value=dimension_var, expected_type=type_hints["dimension_var"])
            check_type(argname="argument equal", value=equal, expected_type=type_hints["equal"])
            check_type(argname="argument greater_than", value=greater_than, expected_type=type_hints["greater_than"])
            check_type(argname="argument less_than", value=less_than, expected_type=type_hints["less_than"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if dimension is not None:
            self._values["dimension"] = dimension
        if dimension_var is not None:
            self._values["dimension_var"] = dimension_var
        if equal is not None:
            self._values["equal"] = equal
        if greater_than is not None:
            self._values["greater_than"] = greater_than
        if less_than is not None:
            self._values["less_than"] = less_than
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfDimensionDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfDimensionDefault"], result)

    @builtins.property
    def dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        '''
        result = self._values.get("dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        '''
        result = self._values.get("dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def equal(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfDimensionEqual"]:
        '''equal block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        '''
        result = self._values.get("equal")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfDimensionEqual"], result)

    @builtins.property
    def greater_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfDimensionGreaterThan"]:
        '''greater_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        '''
        result = self._values.get("greater_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfDimensionGreaterThan"], result)

    @builtins.property
    def less_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfDimensionLessThan"]:
        '''less_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        '''
        result = self._values.get("less_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfDimensionLessThan"], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfDimension(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfDimensionDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfDimensionDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfDimensionDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfDimensionDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfDimensionDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5c095b1843af3e572e1a58166d1559e83ee62c54a00f3a6e91c785dd2818cceb)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfDimensionDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfDimensionDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__91ff7f1fb27811cadadabbfc1eb3542875a0547f29c1b65bb82eaa20d65375d1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfDimensionEqual",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfDimensionEqual:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfDimensionEqual(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfDimensionEqualOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfDimensionEqualOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c31aa6c44538a58f89d5c63229ffce80a96c39003c65ab272dc4f68fbbc8875f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfDimensionEqual], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfDimensionEqual],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9841acae3fa986887a3dc2baba046cee91062ce8817dece366ae3c396aa71e3c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfDimensionGreaterThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfDimensionGreaterThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfDimensionGreaterThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfDimensionGreaterThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfDimensionGreaterThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fbc28f34661b48432b24e02bab44102430f76a0a4d1edaddbe83030b6f75b8b9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfDimensionGreaterThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfDimensionGreaterThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6554540f1b495470fb2dceeefbe68fd5aab0ef94cb1c8b896dfca8f75b9e2e00)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfDimensionLessThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfDimensionLessThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfDimensionLessThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfDimensionLessThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfDimensionLessThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e413b432e1715c359707bc9ec9a67f682093f9d6a2463d6edc51bdf5ba23352b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfDimensionLessThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfDimensionLessThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ed63a51f3499bc81c03c771573cd3e2e0ff63282d6feae54d032a26a3c1e04cd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfDimensionList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfDimensionList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ded44137981db8d1534643af6aceb8dade2900c97ead6ba96e388ec3d3fee19)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfDimensionOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be798fe7f4473ec2e0b051f29031e6897f7a452198b841ae13a59f0855f932a0)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfDimensionOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4b33905b21b44e9ef74397ed96d8d06439dea189750bfda26bbe6346739e43ea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__816fee3551a8dd3c4ca07679a4be3435ae170cefc866ee98347feaf0447a928c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3462020d4194a9cb7a671abc31b35898f32b8f45bad4e21f4dc28d034bc39de6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfDimension]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfDimension]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f4d55320cb464219bb3287934c7027c04be02327c674c8b772e3fecda38be5e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfDimensionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfDimensionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3d3899a3699498c28be961cf3a0d26790e544413616a8ef20c7032bdb6a0f5bb)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfDimensionDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putEqual")
    def put_equal(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfDimensionEqual()

        return typing.cast(None, jsii.invoke(self, "putEqual", [value]))

    @jsii.member(jsii_name="putGreaterThan")
    def put_greater_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfDimensionGreaterThan()

        return typing.cast(None, jsii.invoke(self, "putGreaterThan", [value]))

    @jsii.member(jsii_name="putLessThan")
    def put_less_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfDimensionLessThan()

        return typing.cast(None, jsii.invoke(self, "putLessThan", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetDimension")
    def reset_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimension", []))

    @jsii.member(jsii_name="resetDimensionVar")
    def reset_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimensionVar", []))

    @jsii.member(jsii_name="resetEqual")
    def reset_equal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEqual", []))

    @jsii.member(jsii_name="resetGreaterThan")
    def reset_greater_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGreaterThan", []))

    @jsii.member(jsii_name="resetLessThan")
    def reset_less_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLessThan", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfDimensionDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfDimensionDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="equal")
    def equal(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfDimensionEqualOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfDimensionEqualOutputReference, jsii.get(self, "equal"))

    @builtins.property
    @jsii.member(jsii_name="greaterThan")
    def greater_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfDimensionGreaterThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfDimensionGreaterThanOutputReference, jsii.get(self, "greaterThan"))

    @builtins.property
    @jsii.member(jsii_name="lessThan")
    def less_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfDimensionLessThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfDimensionLessThanOutputReference, jsii.get(self, "lessThan"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfDimensionDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionInput")
    def dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionVarInput")
    def dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="equalInput")
    def equal_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfDimensionEqual], jsii.get(self, "equalInput"))

    @builtins.property
    @jsii.member(jsii_name="greaterThanInput")
    def greater_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfDimensionGreaterThan], jsii.get(self, "greaterThanInput"))

    @builtins.property
    @jsii.member(jsii_name="lessThanInput")
    def less_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfDimensionLessThan], jsii.get(self, "lessThanInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="dimension")
    def dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimension"))

    @dimension.setter
    def dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cf2bf8972d9cec20f84424310c3d464f45cf40fb4dbb805c0a164ec007e2b75d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimension", value)

    @builtins.property
    @jsii.member(jsii_name="dimensionVar")
    def dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimensionVar"))

    @dimension_var.setter
    def dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f9197de80342e9f71aec40e99bfba34bd35ed683b3e3c91b8652f77ddb05fb13)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a35c3657b6797b19595fa7d461eb4ac5bd65b9198dbda2807beee7b88629f23c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c64767de96605b0fe611e2a22c95b52b5c247afbaa3850fa1de48056763c22c9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfDimension]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfDimension]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfDimension]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a4f5293359e7ceb0e3b5e22d84a83f946f5e8f2eede260d0012c8b762e7793bd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfOrientation",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "landscape": "landscape",
        "portrait": "portrait",
        "square": "square",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfOrientation:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfOrientationDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        landscape: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfOrientationLandscape", typing.Dict[builtins.str, typing.Any]]] = None,
        portrait: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfOrientationPortrait", typing.Dict[builtins.str, typing.Any]]] = None,
        square: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfOrientationSquare", typing.Dict[builtins.str, typing.Any]]] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param landscape: landscape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        :param portrait: portrait block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        :param square: square block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfOrientationDefault(**default)
        if isinstance(landscape, dict):
            landscape = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfOrientationLandscape(**landscape)
        if isinstance(portrait, dict):
            portrait = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfOrientationPortrait(**portrait)
        if isinstance(square, dict):
            square = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfOrientationSquare(**square)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__00b67c8fa9d913974f6fae48d66d02d0a188599eef5feaabcda8c6462aec4788)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument landscape", value=landscape, expected_type=type_hints["landscape"])
            check_type(argname="argument portrait", value=portrait, expected_type=type_hints["portrait"])
            check_type(argname="argument square", value=square, expected_type=type_hints["square"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if landscape is not None:
            self._values["landscape"] = landscape
        if portrait is not None:
            self._values["portrait"] = portrait
        if square is not None:
            self._values["square"] = square

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfOrientationDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfOrientationDefault"], result)

    @builtins.property
    def landscape(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfOrientationLandscape"]:
        '''landscape block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        '''
        result = self._values.get("landscape")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfOrientationLandscape"], result)

    @builtins.property
    def portrait(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfOrientationPortrait"]:
        '''portrait block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        '''
        result = self._values.get("portrait")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfOrientationPortrait"], result)

    @builtins.property
    def square(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfOrientationSquare"]:
        '''square block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        result = self._values.get("square")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfOrientationSquare"], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfOrientation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfOrientationDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfOrientationDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfOrientationDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfOrientationDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfOrientationDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a271d96670e17f9ed035373d0d71b19f5990d01ba011eb2689bc06a3e3a6e56b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfOrientationDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfOrientationDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e050da7f28e82f18836b33de05ed21767e6e5ef0b0150275bf8bd01bfb07e4ab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfOrientationLandscape",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfOrientationLandscape:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfOrientationLandscape(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfOrientationLandscapeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfOrientationLandscapeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1e5ab9b02d7096c956edcd0ea19068e3602d5e61843c9bc9baf93a8df34d01e9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfOrientationLandscape], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfOrientationLandscape],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__85b740e6bb8065b3874f9757d70bdcfeb9043aae6a5a322a3931f9f46f7cbbb5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfOrientationList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfOrientationList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__07a7f84a56ef4a1901c82373fe89ac8b93144fa771932fb6d393f22404aa6b40)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfOrientationOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__686dd3669695877fad1d525a1b28cb8f92d98f4c0d9d6c2c806dc564b770fee7)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfOrientationOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ff6402b8dc643006f287b0c173cdc73a5e661e1d791b2efb0bd212f4688c084)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e82658a070f5bcf71e25c70b8838365ac1c84dae4846d0c730387933e37184c9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f7ac8a0ca381620ebf4d37b4b342366adba0db5e42d71663673c98b2829cad38)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfOrientation]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfOrientation]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4826adc7c7cf24b4660b11a7e7e0fe7e7610c4c3f60e136c39cb3bce8d706608)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfOrientationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfOrientationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__323295debf3bbb9dcfd7a3c463648248c7cbbbc2baa757187da50f96db66d2cc)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfOrientationDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putLandscape")
    def put_landscape(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfOrientationLandscape()

        return typing.cast(None, jsii.invoke(self, "putLandscape", [value]))

    @jsii.member(jsii_name="putPortrait")
    def put_portrait(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfOrientationPortrait()

        return typing.cast(None, jsii.invoke(self, "putPortrait", [value]))

    @jsii.member(jsii_name="putSquare")
    def put_square(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfOrientationSquare()

        return typing.cast(None, jsii.invoke(self, "putSquare", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetLandscape")
    def reset_landscape(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLandscape", []))

    @jsii.member(jsii_name="resetPortrait")
    def reset_portrait(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPortrait", []))

    @jsii.member(jsii_name="resetSquare")
    def reset_square(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSquare", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfOrientationDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfOrientationDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="landscape")
    def landscape(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfOrientationLandscapeOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfOrientationLandscapeOutputReference, jsii.get(self, "landscape"))

    @builtins.property
    @jsii.member(jsii_name="portrait")
    def portrait(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfOrientationPortraitOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfOrientationPortraitOutputReference", jsii.get(self, "portrait"))

    @builtins.property
    @jsii.member(jsii_name="square")
    def square(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfOrientationSquareOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfOrientationSquareOutputReference", jsii.get(self, "square"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfOrientationDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="landscapeInput")
    def landscape_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfOrientationLandscape], jsii.get(self, "landscapeInput"))

    @builtins.property
    @jsii.member(jsii_name="portraitInput")
    def portrait_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfOrientationPortrait"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfOrientationPortrait"], jsii.get(self, "portraitInput"))

    @builtins.property
    @jsii.member(jsii_name="squareInput")
    def square_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfOrientationSquare"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfOrientationSquare"], jsii.get(self, "squareInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfOrientation]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfOrientation]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfOrientation]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8583e944a2ca9cd2dddd1305596e3d7d7b24fd8e945700988f389903960b8d8a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfOrientationPortrait",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfOrientationPortrait:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfOrientationPortrait(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfOrientationPortraitOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfOrientationPortraitOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__70d619b6a49a4673bc2799011682ee1cf701e3cba03fefe4d8dea98fa3eaecef)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfOrientationPortrait]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfOrientationPortrait], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfOrientationPortrait],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6cac9e0efcf7e9ce22231ac96c0c8bd7fe4283f7bb0a5976073ab26caeefb084)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfOrientationSquare",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfOrientationSquare:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfOrientationSquare(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfOrientationSquareOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfOrientationSquareOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c6721d82e6403a9e600bf719dfd161a0562a4c437901ad382cd3eb5c3801e30a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfOrientationSquare]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfOrientationSquare], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfOrientationSquare],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f8fcda6e590e9e9b2ccc6866c40b255a5c9c05c8ded8a77d56aeef1f20745fe2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanImQuery",
    jsii_struct_bases=[],
    name_mapping={
        "allowed_transformations": "allowedTransformations",
        "query_var": "queryVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanImQuery:
    def __init__(
        self,
        *,
        allowed_transformations: typing.Sequence[builtins.str],
        query_var: builtins.str,
    ) -> None:
        '''
        :param allowed_transformations: Specifies the transformations that can be applied using the query string parameter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allowed_transformations DataAkamaiImagingPolicyImage#allowed_transformations}
        :param query_var: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#query_var DataAkamaiImagingPolicyImage#query_var}.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__809bfe774d62482e4d5f80b72d8c58f8736a72f47d67cfdcf1bc609ee8c7e39a)
            check_type(argname="argument allowed_transformations", value=allowed_transformations, expected_type=type_hints["allowed_transformations"])
            check_type(argname="argument query_var", value=query_var, expected_type=type_hints["query_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "allowed_transformations": allowed_transformations,
            "query_var": query_var,
        }

    @builtins.property
    def allowed_transformations(self) -> typing.List[builtins.str]:
        '''Specifies the transformations that can be applied using the query string parameter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allowed_transformations DataAkamaiImagingPolicyImage#allowed_transformations}
        '''
        result = self._values.get("allowed_transformations")
        assert result is not None, "Required property 'allowed_transformations' is missing"
        return typing.cast(typing.List[builtins.str], result)

    @builtins.property
    def query_var(self) -> builtins.str:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#query_var DataAkamaiImagingPolicyImage#query_var}.'''
        result = self._values.get("query_var")
        assert result is not None, "Required property 'query_var' is missing"
        return typing.cast(builtins.str, result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanImQuery(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanImQueryList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanImQueryList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__11ed00f7aec2942633fe86020cce703c13093c5f48953e93ce30e2f48afdee68)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanImQueryOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__137318c70440d4a8461d0c215b0600602ec7dc27a096d272fa15f0900f9fcab0)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanImQueryOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__40dbbd3e0087cb1dcd2eda6fc7e96bd6c2a7667dbc60b8260b943fe33068c3d6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4951bf2755e8fc6ec3548c51259a8930b1119471beb89f1d35edd2b9fd71b57f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__64bf00e3e78234f451a4c599741d59142c6a7323b60029555bfd02edcab17798)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanImQuery]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanImQuery]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanImQuery]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__600af1af2cc1bda115d9e20579af2840a525b138b6ceb5e3bcfb5690124c2862)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanImQueryOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanImQueryOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eb9f6b272af46f4f433de6455479cd3f726415203c5a0c8acf1c69531b9e356d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @builtins.property
    @jsii.member(jsii_name="allowedTransformationsInput")
    def allowed_transformations_input(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "allowedTransformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="queryVarInput")
    def query_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "queryVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowedTransformations")
    def allowed_transformations(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "allowedTransformations"))

    @allowed_transformations.setter
    def allowed_transformations(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__10a0048335bafc9284b183c80d28fe48c0a249fbaaed6c6605da13bff76890d3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowedTransformations", value)

    @builtins.property
    @jsii.member(jsii_name="queryVar")
    def query_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "queryVar"))

    @query_var.setter
    def query_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8d7b577fdc34fb7fe25f4075f08b3b203fdd372a5a8e9cf6215fce06439fb3df)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "queryVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanImQuery]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanImQuery]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanImQuery]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e449bd7d4d2e9fc159d04731eb331231f232da19b5f193f6bba26abe830e87be)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanMaxColors",
    jsii_struct_bases=[],
    name_mapping={"colors": "colors", "colors_var": "colorsVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanMaxColors:
    def __init__(
        self,
        *,
        colors: typing.Optional[builtins.str] = None,
        colors_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param colors: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        :param colors_var: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8c6df07785314338d45c01315f2059913d3305388801df281abe7335d59b334c)
            check_type(argname="argument colors", value=colors, expected_type=type_hints["colors"])
            check_type(argname="argument colors_var", value=colors_var, expected_type=type_hints["colors_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if colors is not None:
            self._values["colors"] = colors
        if colors_var is not None:
            self._values["colors_var"] = colors_var

    @builtins.property
    def colors(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        '''
        result = self._values.get("colors")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def colors_var(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        result = self._values.get("colors_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanMaxColors(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanMaxColorsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanMaxColorsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3931dcd3fa65e1462cfe878c3a1d57aa1a0f19092c4f9c5464ab1c0f86712134)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanMaxColorsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4f59d51f1df61b281cb7e7c2eec46bf8d567a2488cdfe127ab18403b99b23ec3)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanMaxColorsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5eda68ac5a364c75475c23b8101c773f9b866ea7d728b5adc528c19924dfa9ae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__18f6f0b83a1f00287e2d916c8a2e3addb55bee080b3f25a0b0ae3047aa15d7a7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__02c15ea6078cd309642a13930a8b8c1887dfcc24c20af135db337481e7a968a4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanMaxColors]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanMaxColors]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8af322de2c557d390c5bdc3a809e6466f2afca58d08da1ae33e5a3f8546c9b08)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanMaxColorsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanMaxColorsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__efd460b1366e1c91c75bd967a2100b671153afb65b046a53b8ca0e16b62403c0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColors")
    def reset_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColors", []))

    @jsii.member(jsii_name="resetColorsVar")
    def reset_colors_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorsVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorsInput")
    def colors_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsInput"))

    @builtins.property
    @jsii.member(jsii_name="colorsVarInput")
    def colors_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsVarInput"))

    @builtins.property
    @jsii.member(jsii_name="colors")
    def colors(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colors"))

    @colors.setter
    def colors(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5e765227e5ae3a724c6e4817c4bede05eb5b2756992ead467890a7cf029d2281)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colors", value)

    @builtins.property
    @jsii.member(jsii_name="colorsVar")
    def colors_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorsVar"))

    @colors_var.setter
    def colors_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8e56354ffd0546761516ab6ef4a07d8677672921e7f2979f4df8334f1482dd70)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorsVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanMaxColors]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanMaxColors]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanMaxColors]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9fac3a154243f32363faf0f7a5bc9507ca0664a8c1e66e85ffd815cab9b31117)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanMirror",
    jsii_struct_bases=[],
    name_mapping={
        "horizontal": "horizontal",
        "horizontal_var": "horizontalVar",
        "vertical": "vertical",
        "vertical_var": "verticalVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanMirror:
    def __init__(
        self,
        *,
        horizontal: typing.Optional[builtins.str] = None,
        horizontal_var: typing.Optional[builtins.str] = None,
        vertical: typing.Optional[builtins.str] = None,
        vertical_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param horizontal: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        :param horizontal_var: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        :param vertical: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        :param vertical_var: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a7e53e8f6fbbf97186adba0209fbb10bb38807416a7ae9b0e75d8cdb25d2d25e)
            check_type(argname="argument horizontal", value=horizontal, expected_type=type_hints["horizontal"])
            check_type(argname="argument horizontal_var", value=horizontal_var, expected_type=type_hints["horizontal_var"])
            check_type(argname="argument vertical", value=vertical, expected_type=type_hints["vertical"])
            check_type(argname="argument vertical_var", value=vertical_var, expected_type=type_hints["vertical_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if horizontal is not None:
            self._values["horizontal"] = horizontal
        if horizontal_var is not None:
            self._values["horizontal_var"] = horizontal_var
        if vertical is not None:
            self._values["vertical"] = vertical
        if vertical_var is not None:
            self._values["vertical_var"] = vertical_var

    @builtins.property
    def horizontal(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        '''
        result = self._values.get("horizontal")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def horizontal_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        '''
        result = self._values.get("horizontal_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        '''
        result = self._values.get("vertical")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        result = self._values.get("vertical_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanMirror(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanMirrorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanMirrorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ae398e6cf89f00fcf3f5780762c8147d4bcf9d11178dae3aa92cc22126f45479)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanMirrorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__acf294487cc1961fd29276386aed2a98a87a2a02843d0aa5ad4e7d501175c53a)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanMirrorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9c1153d808de6c8ec808c4594d9ba56762f017b43938d635ea075254e50db74d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8c07dd7738f18603048efed1c3ce690fc7a36aba9c42d50c6057b5b594632730)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__493f44f745c5df9b2d6ecffa66dde992fc7c90bd1577f6693d77820364b15006)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanMirror]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanMirror]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2114ef8fe06b37a69f9952952d9210f843b19ac2dde94b8f3501c80080ed285a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanMirrorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanMirrorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5bab061ca1c85af05cb118bf99f5a4999f89c6ca417a33d9db8ed493e64e2e2d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHorizontal")
    def reset_horizontal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontal", []))

    @jsii.member(jsii_name="resetHorizontalVar")
    def reset_horizontal_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontalVar", []))

    @jsii.member(jsii_name="resetVertical")
    def reset_vertical(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVertical", []))

    @jsii.member(jsii_name="resetVerticalVar")
    def reset_vertical_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVerticalVar", []))

    @builtins.property
    @jsii.member(jsii_name="horizontalInput")
    def horizontal_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontalVarInput")
    def horizontal_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalInput")
    def vertical_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalVarInput")
    def vertical_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontal")
    def horizontal(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontal"))

    @horizontal.setter
    def horizontal(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__10d7e598f5cba98a51fbaf64a5a5d18a3ff35688d70e41a19a92b052ae3d07af)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontal", value)

    @builtins.property
    @jsii.member(jsii_name="horizontalVar")
    def horizontal_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontalVar"))

    @horizontal_var.setter
    def horizontal_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__90a848dc1f69d0d82c8518fee3d173def660016b003c94ba4667ef9dd1265648)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontalVar", value)

    @builtins.property
    @jsii.member(jsii_name="vertical")
    def vertical(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "vertical"))

    @vertical.setter
    def vertical(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3da9e1c602db660e25c4200f3b9bf3175cd074ce0e4e1812f8f928d6c73057b5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "vertical", value)

    @builtins.property
    @jsii.member(jsii_name="verticalVar")
    def vertical_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "verticalVar"))

    @vertical_var.setter
    def vertical_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b311b2c8838ca9e73033e51d6336ad961ec9e498f8917b0ebb1fe5aaad06ae7a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "verticalVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanMirror]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanMirror]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanMirror]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__748afe4e5c7153e7d4155005bc64428219b06b32b1ac48c0c39ddee18839f6b3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanMonoHue",
    jsii_struct_bases=[],
    name_mapping={"hue": "hue", "hue_var": "hueVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanMonoHue:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cf5cb0f105026c5f8a1218a073b9f063d91fb3d61387d865795592da9e1cb251)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanMonoHue(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanMonoHueList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanMonoHueList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3211ac1532ebb2c928d3942ddf29e66f7be0d61f5a64b366f58a3558f6f25914)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanMonoHueOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cea6e2120494d50fd0d637412f102a603d703bfe539a66a4a0365d1ce78c729e)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanMonoHueOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2bacf3516b76e00e9181d55c770f4c0b9a973d567c652d7536131f2963f3b850)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__858402623030602973c50b9606007b29c6ae089cec8e0b9c625c984675f84dd3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e99bf4d040ab44eb53129f98653081c6258bd30351285714c86803135b2e7b8d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanMonoHue]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanMonoHue]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7bce5340c5b33b7101278f713624bedc302f47e1fdac4fd9d1e784042682a3be)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanMonoHueOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanMonoHueOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__68cc04309c2bc734b200689e37bf739f3dd79b03f382a0842f87fdb58b27c75b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d9852b159030ed2fd344a20d89e8212910927c7db7cf10275011f42708033ed5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d20b6c5c3b3afeb1670f01599541ff48ae205b5b3a55239af0c14b06c0718be2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanMonoHue]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanMonoHue]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanMonoHue]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bf170f0eb1d0d6dc0bf5c29d8b060bf1ee06832ed4d5fe141220ed1b4208c7d0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanOpacity",
    jsii_struct_bases=[],
    name_mapping={"opacity": "opacity", "opacity_var": "opacityVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanOpacity:
    def __init__(
        self,
        *,
        opacity: typing.Optional[builtins.str] = None,
        opacity_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param opacity: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param opacity_var: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__54bc88899509a4d1704c504b9937ca5b9a3465bad657db05a06e13d70ea1c37c)
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument opacity_var", value=opacity_var, expected_type=type_hints["opacity_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if opacity is not None:
            self._values["opacity"] = opacity
        if opacity_var is not None:
            self._values["opacity_var"] = opacity_var

    @builtins.property
    def opacity(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def opacity_var(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        result = self._values.get("opacity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanOpacity(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanOpacityList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanOpacityList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6b30e1a9c0e639ac3aecc69658dc3776c99b37134ea52121b4f691a47594a8b1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanOpacityOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__36f32f8bee0c3f9ed0cde4ab95cb6166815da689bbaecda6ae93146c4e4d6b98)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanOpacityOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0b0c2a28aaa6ed279708c72e04077ad5071a467e775a5e921cf3b0d9eb9bde7d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d7ac5bf549e24cfc7b7c0a9f17c8e084715decf0107cbeff78df7f66ff850844)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ff83d7a66f0c137f4a5424fbfbd706d0bca9766d7f13da3286ef08a8316260b4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanOpacity]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanOpacity]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d8dd05a4aec35d3734a7396d98c78f2275e407cc8d8d4098a9d9c0f541e64630)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanOpacityOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanOpacityOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__80285658cdb3d43e3a7f7dbc6193d4495fe53ba753e06788ad67c86c97b2b981)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetOpacityVar")
    def reset_opacity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacityVar", []))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityVarInput")
    def opacity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacity"))

    @opacity.setter
    def opacity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a79492f2500bbc51d593516b903bec6d040273d7c8aaf11ff0375433ba8dd6f9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacity", value)

    @builtins.property
    @jsii.member(jsii_name="opacityVar")
    def opacity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacityVar"))

    @opacity_var.setter
    def opacity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ee42d2a04bc2e67dcc06da700337f55cedf40aa7662b0057447c2621dab60d04)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacityVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanOpacity]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanOpacity]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanOpacity]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__936d4370497a5a8a7ecf637b253af0aabcfeacf14dce2c8c76128b974ae1b171)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1547cd85b221c9b61ad8d61a50e4944d03e8ba625a9aa4979ccbb5f4a44fe488)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putAppend")
    def put_append(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanAppend, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__85ea5f20fcf71f33cb990cdc0a979cd97e010e13b026b484d4df5d4d87a734ba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putAppend", [value]))

    @jsii.member(jsii_name="putAspectCrop")
    def put_aspect_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanAspectCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6d0b3064e369cedbd43be33318639fbd8610bf456e50dcadfcba2eb38604c092)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putAspectCrop", [value]))

    @jsii.member(jsii_name="putBackgroundColor")
    def put_background_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f5942286c95de5a615db5d4d854e11f5127ffc5022f71b68f67edc1e7b1ee30e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBackgroundColor", [value]))

    @jsii.member(jsii_name="putBlur")
    def put_blur(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanBlur, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ce73e22be0a7a431ed4d6cc56d21b6217365bc36a8f4503709a9aa8c34d0078d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBlur", [value]))

    @jsii.member(jsii_name="putChromaKey")
    def put_chroma_key(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanChromaKey, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__882373b1192efea5e82f2cac9f1d7505d46417c8e127dbd51aa0d6f502132e1c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putChromaKey", [value]))

    @jsii.member(jsii_name="putComposite")
    def put_composite(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanComposite, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__604267032ff7a3a38c3a5e3a78aacf0189e441c78012aedc41d6bcd3efa138e1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putComposite", [value]))

    @jsii.member(jsii_name="putCompound")
    def put_compound(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanCompound, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__322305acfc73a3eb8dc5f47f3731bff3fccafdd34a0fbea0cb717b8e2f4bc43e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCompound", [value]))

    @jsii.member(jsii_name="putContrast")
    def put_contrast(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanContrast, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__14c4e4ae93fd750f9864b17ac770f409529be848547c1dc092cc71159026b321)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putContrast", [value]))

    @jsii.member(jsii_name="putCrop")
    def put_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__226394661790ca12c1df8de6b2d2eeb0b8e777df71216d09a80d93eae2a9173f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCrop", [value]))

    @jsii.member(jsii_name="putFaceCrop")
    def put_face_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanFaceCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dfbcd0894a8e27dd07bcf0e873008078bc50098420dc816053fb0d036ea6aeaa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFaceCrop", [value]))

    @jsii.member(jsii_name="putFeatureCrop")
    def put_feature_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanFeatureCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5fc3f625d860306c746512534fabf679d77283bb610e313b09b63c6241545fac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFeatureCrop", [value]))

    @jsii.member(jsii_name="putFitAndFill")
    def put_fit_and_fill(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanFitAndFill, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d11e247f3171139c3475ec868c31848b78232391d7a047bf4546b787c50e8cf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFitAndFill", [value]))

    @jsii.member(jsii_name="putGoop")
    def put_goop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanGoop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a3da1600ae8677d2bb3b73ee74a9a33fccbeff49a57d480116559cee1a67645d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGoop", [value]))

    @jsii.member(jsii_name="putGrayscale")
    def put_grayscale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanGrayscale, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__52b7d13031a5e4d4d7d303ee7a86b27b969c8b33210a96eb426e6fb6dfa2070b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGrayscale", [value]))

    @jsii.member(jsii_name="putHsl")
    def put_hsl(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanHsl, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__991c01992bbe3542ba33243659814cb7b87e3d42b39f60d112d80e6a73f06952)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsl", [value]))

    @jsii.member(jsii_name="putHsv")
    def put_hsv(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanHsv, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ce3c7f70d17b176086a4394b5a6f3f6d9d5652ca056cbb9c77cfa6d5d457e6f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsv", [value]))

    @jsii.member(jsii_name="putIfDimension")
    def put_if_dimension(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfDimension, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b510bd0c816b326142a01178bb027a01c7d03516265db39f43c062bf01ddef93)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfDimension", [value]))

    @jsii.member(jsii_name="putIfOrientation")
    def put_if_orientation(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a88bac6a7a36afae0dd751de8f67762261b2d83147bbe5643b659a882fe746f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfOrientation", [value]))

    @jsii.member(jsii_name="putImQuery")
    def put_im_query(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanImQuery, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1119f891785488537e1680a723efe0df3e117b4053579a379723935759c56a16)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putImQuery", [value]))

    @jsii.member(jsii_name="putMaxColors")
    def put_max_colors(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanMaxColors, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b2aca42887796b54dd9badd6cef0f3a4dc31d88b04a2e21cdfa9424933ae493f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMaxColors", [value]))

    @jsii.member(jsii_name="putMirror")
    def put_mirror(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanMirror, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cba0d49c5f63ada1a783012acf4202748b74f11b285d299163abfda8febed47d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMirror", [value]))

    @jsii.member(jsii_name="putMonoHue")
    def put_mono_hue(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanMonoHue, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__838c04c2ca474a057f7b82234e7bbe8f6ec710a1fcca56a659f4136b81241689)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMonoHue", [value]))

    @jsii.member(jsii_name="putOpacity")
    def put_opacity(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanOpacity, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ecf164aceda5e900bcc0cd2556807de492b92f4509d3fcb7890f4ff2ee57b6fb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putOpacity", [value]))

    @jsii.member(jsii_name="putRegionOfInterestCrop")
    def put_region_of_interest_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanRegionOfInterestCrop", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__785a8bd459a893d403bf1410857d196de81806b61d3b0addfd1f626d3b83ee21)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRegionOfInterestCrop", [value]))

    @jsii.member(jsii_name="putRelativeCrop")
    def put_relative_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanRelativeCrop", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7adc80e826faa0f59bffc36a120e78d5719e554b451092fe63fffe92d913080b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRelativeCrop", [value]))

    @jsii.member(jsii_name="putRemoveColor")
    def put_remove_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanRemoveColor", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__20bc34ba53833217b204073abba3c13d78ea463e3af157209fb41c1e7edcdd8a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRemoveColor", [value]))

    @jsii.member(jsii_name="putResize")
    def put_resize(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanResize", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2e4effcc101a9bfca1462421f21d4b6c39f2f629209a40ef544ae21962d6c645)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putResize", [value]))

    @jsii.member(jsii_name="putRotate")
    def put_rotate(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanRotate", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__80ff1240503bfcdd24a0e0a66d3fbb8957a0da9e768a90d19e23f36f7facfb9e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRotate", [value]))

    @jsii.member(jsii_name="putScale")
    def put_scale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanScale", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e1577e015fc07626e963733675c919d4422c7cb664e8c5617e5fad24235f57bb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putScale", [value]))

    @jsii.member(jsii_name="putShear")
    def put_shear(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanShear", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6861ffa031805828b2674c5d0e995b0f2321197590fa8e558507980929d3ff3b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putShear", [value]))

    @jsii.member(jsii_name="putTrim")
    def put_trim(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanTrim", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aad489267328aa6e880fbd8467bdbf182e6f79b342654ffaccc5d1a3dafa1c5e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTrim", [value]))

    @jsii.member(jsii_name="putUnsharpMask")
    def put_unsharp_mask(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanUnsharpMask", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__772d556bd3d16cecc5da4f147e2a4e2f9d6524bf1da9bc34ebc32a313a38e6c9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putUnsharpMask", [value]))

    @jsii.member(jsii_name="resetAppend")
    def reset_append(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAppend", []))

    @jsii.member(jsii_name="resetAspectCrop")
    def reset_aspect_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspectCrop", []))

    @jsii.member(jsii_name="resetBackgroundColor")
    def reset_background_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBackgroundColor", []))

    @jsii.member(jsii_name="resetBlur")
    def reset_blur(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBlur", []))

    @jsii.member(jsii_name="resetChromaKey")
    def reset_chroma_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChromaKey", []))

    @jsii.member(jsii_name="resetComposite")
    def reset_composite(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetComposite", []))

    @jsii.member(jsii_name="resetCompound")
    def reset_compound(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCompound", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetCrop")
    def reset_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCrop", []))

    @jsii.member(jsii_name="resetFaceCrop")
    def reset_face_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFaceCrop", []))

    @jsii.member(jsii_name="resetFeatureCrop")
    def reset_feature_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureCrop", []))

    @jsii.member(jsii_name="resetFitAndFill")
    def reset_fit_and_fill(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFitAndFill", []))

    @jsii.member(jsii_name="resetGoop")
    def reset_goop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGoop", []))

    @jsii.member(jsii_name="resetGrayscale")
    def reset_grayscale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGrayscale", []))

    @jsii.member(jsii_name="resetHsl")
    def reset_hsl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsl", []))

    @jsii.member(jsii_name="resetHsv")
    def reset_hsv(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsv", []))

    @jsii.member(jsii_name="resetIfDimension")
    def reset_if_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfDimension", []))

    @jsii.member(jsii_name="resetIfOrientation")
    def reset_if_orientation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfOrientation", []))

    @jsii.member(jsii_name="resetImQuery")
    def reset_im_query(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetImQuery", []))

    @jsii.member(jsii_name="resetMaxColors")
    def reset_max_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxColors", []))

    @jsii.member(jsii_name="resetMirror")
    def reset_mirror(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMirror", []))

    @jsii.member(jsii_name="resetMonoHue")
    def reset_mono_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonoHue", []))

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetRegionOfInterestCrop")
    def reset_region_of_interest_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRegionOfInterestCrop", []))

    @jsii.member(jsii_name="resetRelativeCrop")
    def reset_relative_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRelativeCrop", []))

    @jsii.member(jsii_name="resetRemoveColor")
    def reset_remove_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRemoveColor", []))

    @jsii.member(jsii_name="resetResize")
    def reset_resize(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetResize", []))

    @jsii.member(jsii_name="resetRotate")
    def reset_rotate(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRotate", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetShear")
    def reset_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetShear", []))

    @jsii.member(jsii_name="resetTrim")
    def reset_trim(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTrim", []))

    @jsii.member(jsii_name="resetUnsharpMask")
    def reset_unsharp_mask(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUnsharpMask", []))

    @builtins.property
    @jsii.member(jsii_name="append")
    def append(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanAppendList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanAppendList, jsii.get(self, "append"))

    @builtins.property
    @jsii.member(jsii_name="aspectCrop")
    def aspect_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanAspectCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanAspectCropList, jsii.get(self, "aspectCrop"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColor")
    def background_color(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanBackgroundColorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanBackgroundColorList, jsii.get(self, "backgroundColor"))

    @builtins.property
    @jsii.member(jsii_name="blur")
    def blur(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanBlurList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanBlurList, jsii.get(self, "blur"))

    @builtins.property
    @jsii.member(jsii_name="chromaKey")
    def chroma_key(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanChromaKeyList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanChromaKeyList, jsii.get(self, "chromaKey"))

    @builtins.property
    @jsii.member(jsii_name="composite")
    def composite(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanCompositeList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanCompositeList, jsii.get(self, "composite"))

    @builtins.property
    @jsii.member(jsii_name="compound")
    def compound(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanCompoundList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanCompoundList, jsii.get(self, "compound"))

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanContrastList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanContrastList, jsii.get(self, "contrast"))

    @builtins.property
    @jsii.member(jsii_name="crop")
    def crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanCropList, jsii.get(self, "crop"))

    @builtins.property
    @jsii.member(jsii_name="faceCrop")
    def face_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanFaceCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanFaceCropList, jsii.get(self, "faceCrop"))

    @builtins.property
    @jsii.member(jsii_name="featureCrop")
    def feature_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanFeatureCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanFeatureCropList, jsii.get(self, "featureCrop"))

    @builtins.property
    @jsii.member(jsii_name="fitAndFill")
    def fit_and_fill(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanFitAndFillList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanFitAndFillList, jsii.get(self, "fitAndFill"))

    @builtins.property
    @jsii.member(jsii_name="goop")
    def goop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanGoopList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanGoopList, jsii.get(self, "goop"))

    @builtins.property
    @jsii.member(jsii_name="grayscale")
    def grayscale(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanGrayscaleList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanGrayscaleList, jsii.get(self, "grayscale"))

    @builtins.property
    @jsii.member(jsii_name="hsl")
    def hsl(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanHslList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanHslList, jsii.get(self, "hsl"))

    @builtins.property
    @jsii.member(jsii_name="hsv")
    def hsv(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanHsvList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanHsvList, jsii.get(self, "hsv"))

    @builtins.property
    @jsii.member(jsii_name="ifDimension")
    def if_dimension(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfDimensionList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfDimensionList, jsii.get(self, "ifDimension"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientation")
    def if_orientation(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfOrientationList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfOrientationList, jsii.get(self, "ifOrientation"))

    @builtins.property
    @jsii.member(jsii_name="imQuery")
    def im_query(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanImQueryList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanImQueryList, jsii.get(self, "imQuery"))

    @builtins.property
    @jsii.member(jsii_name="maxColors")
    def max_colors(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanMaxColorsList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanMaxColorsList, jsii.get(self, "maxColors"))

    @builtins.property
    @jsii.member(jsii_name="mirror")
    def mirror(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanMirrorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanMirrorList, jsii.get(self, "mirror"))

    @builtins.property
    @jsii.member(jsii_name="monoHue")
    def mono_hue(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanMonoHueList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanMonoHueList, jsii.get(self, "monoHue"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanOpacityList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanOpacityList, jsii.get(self, "opacity"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestCrop")
    def region_of_interest_crop(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanRegionOfInterestCropList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanRegionOfInterestCropList", jsii.get(self, "regionOfInterestCrop"))

    @builtins.property
    @jsii.member(jsii_name="relativeCrop")
    def relative_crop(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanRelativeCropList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanRelativeCropList", jsii.get(self, "relativeCrop"))

    @builtins.property
    @jsii.member(jsii_name="removeColor")
    def remove_color(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanRemoveColorList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanRemoveColorList", jsii.get(self, "removeColor"))

    @builtins.property
    @jsii.member(jsii_name="resize")
    def resize(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanResizeList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanResizeList", jsii.get(self, "resize"))

    @builtins.property
    @jsii.member(jsii_name="rotate")
    def rotate(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanRotateList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanRotateList", jsii.get(self, "rotate"))

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanScaleList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanScaleList", jsii.get(self, "scale"))

    @builtins.property
    @jsii.member(jsii_name="shear")
    def shear(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanShearList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanShearList", jsii.get(self, "shear"))

    @builtins.property
    @jsii.member(jsii_name="trim")
    def trim(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanTrimList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanTrimList", jsii.get(self, "trim"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMask")
    def unsharp_mask(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanUnsharpMaskList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanUnsharpMaskList", jsii.get(self, "unsharpMask"))

    @builtins.property
    @jsii.member(jsii_name="appendInput")
    def append_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanAppend]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanAppend]]], jsii.get(self, "appendInput"))

    @builtins.property
    @jsii.member(jsii_name="aspectCropInput")
    def aspect_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanAspectCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanAspectCrop]]], jsii.get(self, "aspectCropInput"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColorInput")
    def background_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanBackgroundColor]]], jsii.get(self, "backgroundColorInput"))

    @builtins.property
    @jsii.member(jsii_name="blurInput")
    def blur_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanBlur]]], jsii.get(self, "blurInput"))

    @builtins.property
    @jsii.member(jsii_name="chromaKeyInput")
    def chroma_key_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanChromaKey]]], jsii.get(self, "chromaKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="compositeInput")
    def composite_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanComposite]]], jsii.get(self, "compositeInput"))

    @builtins.property
    @jsii.member(jsii_name="compoundInput")
    def compound_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanCompound]]], jsii.get(self, "compoundInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanContrast]]], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="cropInput")
    def crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanCrop]]], jsii.get(self, "cropInput"))

    @builtins.property
    @jsii.member(jsii_name="faceCropInput")
    def face_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanFaceCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanFaceCrop]]], jsii.get(self, "faceCropInput"))

    @builtins.property
    @jsii.member(jsii_name="featureCropInput")
    def feature_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanFeatureCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanFeatureCrop]]], jsii.get(self, "featureCropInput"))

    @builtins.property
    @jsii.member(jsii_name="fitAndFillInput")
    def fit_and_fill_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanFitAndFill]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanFitAndFill]]], jsii.get(self, "fitAndFillInput"))

    @builtins.property
    @jsii.member(jsii_name="goopInput")
    def goop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanGoop]]], jsii.get(self, "goopInput"))

    @builtins.property
    @jsii.member(jsii_name="grayscaleInput")
    def grayscale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanGrayscale]]], jsii.get(self, "grayscaleInput"))

    @builtins.property
    @jsii.member(jsii_name="hslInput")
    def hsl_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanHsl]]], jsii.get(self, "hslInput"))

    @builtins.property
    @jsii.member(jsii_name="hsvInput")
    def hsv_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanHsv]]], jsii.get(self, "hsvInput"))

    @builtins.property
    @jsii.member(jsii_name="ifDimensionInput")
    def if_dimension_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfDimension]]], jsii.get(self, "ifDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientationInput")
    def if_orientation_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfOrientation]]], jsii.get(self, "ifOrientationInput"))

    @builtins.property
    @jsii.member(jsii_name="imQueryInput")
    def im_query_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanImQuery]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanImQuery]]], jsii.get(self, "imQueryInput"))

    @builtins.property
    @jsii.member(jsii_name="maxColorsInput")
    def max_colors_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanMaxColors]]], jsii.get(self, "maxColorsInput"))

    @builtins.property
    @jsii.member(jsii_name="mirrorInput")
    def mirror_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanMirror]]], jsii.get(self, "mirrorInput"))

    @builtins.property
    @jsii.member(jsii_name="monoHueInput")
    def mono_hue_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanMonoHue]]], jsii.get(self, "monoHueInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanOpacity]]], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestCropInput")
    def region_of_interest_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanRegionOfInterestCrop"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanRegionOfInterestCrop"]]], jsii.get(self, "regionOfInterestCropInput"))

    @builtins.property
    @jsii.member(jsii_name="relativeCropInput")
    def relative_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanRelativeCrop"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanRelativeCrop"]]], jsii.get(self, "relativeCropInput"))

    @builtins.property
    @jsii.member(jsii_name="removeColorInput")
    def remove_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanRemoveColor"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanRemoveColor"]]], jsii.get(self, "removeColorInput"))

    @builtins.property
    @jsii.member(jsii_name="resizeInput")
    def resize_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanResize"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanResize"]]], jsii.get(self, "resizeInput"))

    @builtins.property
    @jsii.member(jsii_name="rotateInput")
    def rotate_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanRotate"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanRotate"]]], jsii.get(self, "rotateInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanScale"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanScale"]]], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="shearInput")
    def shear_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanShear"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanShear"]]], jsii.get(self, "shearInput"))

    @builtins.property
    @jsii.member(jsii_name="trimInput")
    def trim_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanTrim"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanTrim"]]], jsii.get(self, "trimInput"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMaskInput")
    def unsharp_mask_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanUnsharpMask"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanUnsharpMask"]]], jsii.get(self, "unsharpMaskInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a3e1b27df119d34b078bfd86b27b4bdea864c08c9311d9d0f75dadf716fedb1b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanRegionOfInterestCrop",
    jsii_struct_bases=[],
    name_mapping={
        "region_of_interest": "regionOfInterest",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanRegionOfInterestCrop:
    def __init__(
        self,
        *,
        region_of_interest: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanRegionOfInterestCropRegionOfInterest", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param region_of_interest: region_of_interest block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest DataAkamaiImagingPolicyImage#region_of_interest}
        :param gravity: The placement of the crop area relative to the specified area of interest. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: The placement of the crop area relative to the specified area of interest. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param style: Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(region_of_interest, dict):
            region_of_interest = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanRegionOfInterestCropRegionOfInterest(**region_of_interest)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__19636ac39c7cf2aff16af3d745260eb2a071e9ad1d13330d43de684d67470b30)
            check_type(argname="argument region_of_interest", value=region_of_interest, expected_type=type_hints["region_of_interest"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "region_of_interest": region_of_interest,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def region_of_interest(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanRegionOfInterestCropRegionOfInterest":
        '''region_of_interest block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest DataAkamaiImagingPolicyImage#region_of_interest}
        '''
        result = self._values.get("region_of_interest")
        assert result is not None, "Required property 'region_of_interest' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanRegionOfInterestCropRegionOfInterest", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''The placement of the crop area relative to the specified area of interest.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''The placement of the crop area relative to the specified area of interest.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanRegionOfInterestCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanRegionOfInterestCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanRegionOfInterestCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7cd14a2f4f5ee0252c7e84af1b854357b339bec2cf06680757c4c54c79f275cc)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanRegionOfInterestCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d6a22dcce48dba3ea1dc38d2163419ddbe4ed91ddfe14493f30ab6ec5d92a487)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanRegionOfInterestCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__529601bdc082c01f5670018db8bc14d1a3200cd492441f22fb0a282397185812)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e28371cc0e301dbc83dc77e826572142351d2b4be18ca0aa4188f93374b00add)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6aff3f318c5396ce679eaa054e4996008dd9ffcf2c9607d2e1b3e64771e71d4f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanRegionOfInterestCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanRegionOfInterestCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanRegionOfInterestCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a453bbf1cd02326fcf3da1063fd2da3980c1b88feda1e2045ac6ca580874fa8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanRegionOfInterestCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanRegionOfInterestCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9053592579e67e20977183dbda08c4f980d9a790293370283c12cbbdd9644006)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putRegionOfInterest")
    def put_region_of_interest(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanRegionOfInterestCropRegionOfInterest()

        return typing.cast(None, jsii.invoke(self, "putRegionOfInterest", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterest")
    def region_of_interest(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestOutputReference", jsii.get(self, "regionOfInterest"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestInput")
    def region_of_interest_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanRegionOfInterestCropRegionOfInterest"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanRegionOfInterestCropRegionOfInterest"], jsii.get(self, "regionOfInterestInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac63bae213b6446b1b204165aa9ade9f2569aa37c5fa8881e16f8b02ff453170)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a04055439cdc582b0a06184a0f4eab9ec26fcb6af3ed7875b23dc61b358924d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f66329e4308c3560e791eb534027c3120ee0b20887db34533fc7d66ebe2c386a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9cd257589a533af26ccc9af646b632e22f8066b0de718cc1a18d01bb42ddbcc9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d706ba37d5738b97a27677736c692c1fa2a91b8a758f2e2ce0d9fb8dadafda80)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8e23f177ed82c852a6c8f637f1d7d7126791429f05e5c857dd9217572309a056)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__311128e627f9b8cbc3a5f0cea95a8bab3b356c2c0494d61926d718a7dddcf56c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1058406f065432874604ef188b375b3ad49a7ccc6b6f2765f85c9762a2790de4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanRegionOfInterestCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanRegionOfInterestCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanRegionOfInterestCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__699c98a0387fc6faab520728c296bbc226ef321503153c23029bd4313d2953ac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanRegionOfInterestCropRegionOfInterest",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanRegionOfInterestCropRegionOfInterest:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanRegionOfInterestCropRegionOfInterest(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__93e064806cbf66866de02c7373d870bff257286306274d7ba71caf179f4762e7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanRegionOfInterestCropRegionOfInterest]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanRegionOfInterestCropRegionOfInterest], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanRegionOfInterestCropRegionOfInterest],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__52bf54a9e26a8d2123ea8ff5d540b6889fedfbd0e4aefd36db4c323e162330d3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanRelativeCrop",
    jsii_struct_bases=[],
    name_mapping={
        "east": "east",
        "east_var": "eastVar",
        "north": "north",
        "north_var": "northVar",
        "south": "south",
        "south_var": "southVar",
        "west": "west",
        "west_var": "westVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanRelativeCrop:
    def __init__(
        self,
        *,
        east: typing.Optional[builtins.str] = None,
        east_var: typing.Optional[builtins.str] = None,
        north: typing.Optional[builtins.str] = None,
        north_var: typing.Optional[builtins.str] = None,
        south: typing.Optional[builtins.str] = None,
        south_var: typing.Optional[builtins.str] = None,
        west: typing.Optional[builtins.str] = None,
        west_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param east: The number of pixels to shrink or expand the right side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east DataAkamaiImagingPolicyImage#east}
        :param east_var: The number of pixels to shrink or expand the right side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east_var DataAkamaiImagingPolicyImage#east_var}
        :param north: The number of pixels to shrink or expand the top side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north DataAkamaiImagingPolicyImage#north}
        :param north_var: The number of pixels to shrink or expand the top side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north_var DataAkamaiImagingPolicyImage#north_var}
        :param south: The number of pixels to shrink or expand the bottom side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south DataAkamaiImagingPolicyImage#south}
        :param south_var: The number of pixels to shrink or expand the bottom side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south_var DataAkamaiImagingPolicyImage#south_var}
        :param west: The number of pixels to shrink or expand the left side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west DataAkamaiImagingPolicyImage#west}
        :param west_var: The number of pixels to shrink or expand the left side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west_var DataAkamaiImagingPolicyImage#west_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__170d4ccd793dcbb400fde1b27270bebea248d5fe985becb34641f733fd6cc37e)
            check_type(argname="argument east", value=east, expected_type=type_hints["east"])
            check_type(argname="argument east_var", value=east_var, expected_type=type_hints["east_var"])
            check_type(argname="argument north", value=north, expected_type=type_hints["north"])
            check_type(argname="argument north_var", value=north_var, expected_type=type_hints["north_var"])
            check_type(argname="argument south", value=south, expected_type=type_hints["south"])
            check_type(argname="argument south_var", value=south_var, expected_type=type_hints["south_var"])
            check_type(argname="argument west", value=west, expected_type=type_hints["west"])
            check_type(argname="argument west_var", value=west_var, expected_type=type_hints["west_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if east is not None:
            self._values["east"] = east
        if east_var is not None:
            self._values["east_var"] = east_var
        if north is not None:
            self._values["north"] = north
        if north_var is not None:
            self._values["north_var"] = north_var
        if south is not None:
            self._values["south"] = south
        if south_var is not None:
            self._values["south_var"] = south_var
        if west is not None:
            self._values["west"] = west
        if west_var is not None:
            self._values["west_var"] = west_var

    @builtins.property
    def east(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the right side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east DataAkamaiImagingPolicyImage#east}
        '''
        result = self._values.get("east")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def east_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the right side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east_var DataAkamaiImagingPolicyImage#east_var}
        '''
        result = self._values.get("east_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def north(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the top side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north DataAkamaiImagingPolicyImage#north}
        '''
        result = self._values.get("north")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def north_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the top side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north_var DataAkamaiImagingPolicyImage#north_var}
        '''
        result = self._values.get("north_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def south(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the bottom side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south DataAkamaiImagingPolicyImage#south}
        '''
        result = self._values.get("south")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def south_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the bottom side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south_var DataAkamaiImagingPolicyImage#south_var}
        '''
        result = self._values.get("south_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def west(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the left side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west DataAkamaiImagingPolicyImage#west}
        '''
        result = self._values.get("west")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def west_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the left side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west_var DataAkamaiImagingPolicyImage#west_var}
        '''
        result = self._values.get("west_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanRelativeCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanRelativeCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanRelativeCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8e37dfe0c1dddb5fc2b079bfe649f6c71b03bd4ccc39fe99c569b9ef4b4b377d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanRelativeCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b49f8eb00cc78bf3b3ec89e50fca2231d655ef5b37714e1a05728bdd1a042074)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanRelativeCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fe6c32018578deea1a3795364685984a46bcba6f51da8df1f4189bb5f8d11536)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__204bc8697ad8fd08dcc68b7c9e2000ad97d5214ae9a7b59a2534e138c9214475)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8e9e95beb668f46be377909389b9d7bec7401cfb6d46beb53ecd691f1bf17feb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanRelativeCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanRelativeCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanRelativeCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f3267e81240f7da1f25f48bce480ab563fd7579dd080053d7568214c0fdf71d3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanRelativeCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanRelativeCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2b157889c0f779b5564aa90df94e7c9cc3ccfe1bf3ab444d4fee3ff16c59c0a9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetEast")
    def reset_east(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEast", []))

    @jsii.member(jsii_name="resetEastVar")
    def reset_east_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEastVar", []))

    @jsii.member(jsii_name="resetNorth")
    def reset_north(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNorth", []))

    @jsii.member(jsii_name="resetNorthVar")
    def reset_north_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNorthVar", []))

    @jsii.member(jsii_name="resetSouth")
    def reset_south(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSouth", []))

    @jsii.member(jsii_name="resetSouthVar")
    def reset_south_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSouthVar", []))

    @jsii.member(jsii_name="resetWest")
    def reset_west(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWest", []))

    @jsii.member(jsii_name="resetWestVar")
    def reset_west_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWestVar", []))

    @builtins.property
    @jsii.member(jsii_name="eastInput")
    def east_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "eastInput"))

    @builtins.property
    @jsii.member(jsii_name="eastVarInput")
    def east_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "eastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="northInput")
    def north_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "northInput"))

    @builtins.property
    @jsii.member(jsii_name="northVarInput")
    def north_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "northVarInput"))

    @builtins.property
    @jsii.member(jsii_name="southInput")
    def south_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "southInput"))

    @builtins.property
    @jsii.member(jsii_name="southVarInput")
    def south_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "southVarInput"))

    @builtins.property
    @jsii.member(jsii_name="westInput")
    def west_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "westInput"))

    @builtins.property
    @jsii.member(jsii_name="westVarInput")
    def west_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "westVarInput"))

    @builtins.property
    @jsii.member(jsii_name="east")
    def east(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "east"))

    @east.setter
    def east(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5c5a6db39fc667cc1875917089891ee7d30ca56f58abd9d056c1c9dfb68309f3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "east", value)

    @builtins.property
    @jsii.member(jsii_name="eastVar")
    def east_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "eastVar"))

    @east_var.setter
    def east_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__376b6d8f8e0f0f23456999433317ab40301234d30a5557c93d54bb01af31dbe5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "eastVar", value)

    @builtins.property
    @jsii.member(jsii_name="north")
    def north(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "north"))

    @north.setter
    def north(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__284b4c74340c253d70c58b4c13b7ed9961bb3295ae79f42020750e3469da3f59)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "north", value)

    @builtins.property
    @jsii.member(jsii_name="northVar")
    def north_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "northVar"))

    @north_var.setter
    def north_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2efd3bd99a402a0b807e085c9cf17b06c64a2ffa1f008d4dabfea43f11c8c441)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "northVar", value)

    @builtins.property
    @jsii.member(jsii_name="south")
    def south(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "south"))

    @south.setter
    def south(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d452340bc6e5cb6480a9f1c2862b547877ac4214afedbd443753b9a48f9bdbd2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "south", value)

    @builtins.property
    @jsii.member(jsii_name="southVar")
    def south_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "southVar"))

    @south_var.setter
    def south_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__599be3713467c7ecd0994de74e0987329fb08a0bcd5fdce59db92469b2c35b9d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "southVar", value)

    @builtins.property
    @jsii.member(jsii_name="west")
    def west(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "west"))

    @west.setter
    def west(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__36c5ea519a04d514bab20842e4c67ebe8142399480094f8dc6455305c0b735a9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "west", value)

    @builtins.property
    @jsii.member(jsii_name="westVar")
    def west_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "westVar"))

    @west_var.setter
    def west_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5b26290663680e496cad4f3e44e4d5be68aa44eccd469578befbbceca317f817)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "westVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanRelativeCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanRelativeCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanRelativeCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8f4ec9f05aaad6e752ae2f07cbaa0562eee3f76e96d65700e8cd25b722317af3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanRemoveColor",
    jsii_struct_bases=[],
    name_mapping={
        "color": "color",
        "color_var": "colorVar",
        "feather": "feather",
        "feather_var": "featherVar",
        "tolerance": "tolerance",
        "tolerance_var": "toleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanRemoveColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
        feather: typing.Optional[builtins.str] = None,
        feather_var: typing.Optional[builtins.str] = None,
        tolerance: typing.Optional[builtins.str] = None,
        tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        :param feather: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        :param feather_var: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        :param tolerance: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        :param tolerance_var: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6b1a9426631643dda9a81906c61f66adc91a2a18fbbb0b4c2b0d56f1bd136bd4)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
            check_type(argname="argument feather", value=feather, expected_type=type_hints["feather"])
            check_type(argname="argument feather_var", value=feather_var, expected_type=type_hints["feather_var"])
            check_type(argname="argument tolerance", value=tolerance, expected_type=type_hints["tolerance"])
            check_type(argname="argument tolerance_var", value=tolerance_var, expected_type=type_hints["tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var
        if feather is not None:
            self._values["feather"] = feather
        if feather_var is not None:
            self._values["feather_var"] = feather_var
        if tolerance is not None:
            self._values["tolerance"] = tolerance
        if tolerance_var is not None:
            self._values["tolerance_var"] = tolerance_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        '''
        result = self._values.get("feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather_var(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        '''
        result = self._values.get("feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        '''
        result = self._values.get("tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance_var(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        result = self._values.get("tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanRemoveColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanRemoveColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanRemoveColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__32f89cd69fdbc7ab255d6adf2f8e59a02f5ac44d748c8588d543ace94b148663)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanRemoveColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4d928777dac0b96cf8c25fb20f2539d0112d329132af32a098c2c5c33b2bb814)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanRemoveColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1662195a1bf29cbeebff274cb68cbf94d9622ba90c3cbfee95d21ddeb7613d5b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f7668c0d8566c28fd3854d89772778029dba62c7ac552fb045289737e1655f30)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1254153b50e727cf23b372ffce66526e060d490ec397ce213c7025c6c31024b4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanRemoveColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanRemoveColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanRemoveColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7bbe563b4ddabce15b0d43d7f6119f0b089de4a8bb953e55a12631ed60bfe461)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanRemoveColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanRemoveColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__58686aff50972269aa9cd9cf097e3e60487d051d051fda033405f72cb43909a9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @jsii.member(jsii_name="resetFeather")
    def reset_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeather", []))

    @jsii.member(jsii_name="resetFeatherVar")
    def reset_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatherVar", []))

    @jsii.member(jsii_name="resetTolerance")
    def reset_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTolerance", []))

    @jsii.member(jsii_name="resetToleranceVar")
    def reset_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featherInput")
    def feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherInput"))

    @builtins.property
    @jsii.member(jsii_name="featherVarInput")
    def feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceInput")
    def tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceVarInput")
    def tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7cdd6873fee2866557394f0f1bfdde21113c74704456b11447aac8d0986cd895)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b512b8c47088bb1333c37f377c818fcf428409ccbbf89ce4548b2062d0eaba43)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="feather")
    def feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "feather"))

    @feather.setter
    def feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ffa2ab7e75def65eaf0b63996107cbc0816094c1aa89f5f048dd09780705cd7a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "feather", value)

    @builtins.property
    @jsii.member(jsii_name="featherVar")
    def feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featherVar"))

    @feather_var.setter
    def feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__52eb89b35753125c1487552c49a248c85302b04ff39bea640ee74b136f035343)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featherVar", value)

    @builtins.property
    @jsii.member(jsii_name="tolerance")
    def tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tolerance"))

    @tolerance.setter
    def tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f95b7331e40f6ec55ce5cf106bc4eb53ed704ab59575f999ba02d01c8f6ffcb3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tolerance", value)

    @builtins.property
    @jsii.member(jsii_name="toleranceVar")
    def tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "toleranceVar"))

    @tolerance_var.setter
    def tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3b2001d4043613bdb5ee7f09c02737cb1106178260e2b64c7a5f53eab737e77f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "toleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanRemoveColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanRemoveColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanRemoveColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e1dc847e107a787461863ff6c071b24414a71c8d112be5e886ee9f81347ae714)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanResize",
    jsii_struct_bases=[],
    name_mapping={
        "aspect": "aspect",
        "aspect_var": "aspectVar",
        "height": "height",
        "height_var": "heightVar",
        "type": "type",
        "type_var": "typeVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanResize:
    def __init__(
        self,
        *,
        aspect: typing.Optional[builtins.str] = None,
        aspect_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param aspect: Preserves the aspect ratio. Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect DataAkamaiImagingPolicyImage#aspect}
        :param aspect_var: Preserves the aspect ratio. Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_var DataAkamaiImagingPolicyImage#aspect_var}
        :param height: The height to resize the source image to. Must be set if height is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height to resize the source image to. Must be set if height is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param type: Sets constraints for the image resize. Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: Sets constraints for the image resize. Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        :param width: The width to resize the source image to. Must be set if width is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width to resize the source image to. Must be set if width is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__209aef9e4dce9bdda79602c107103b2a8f0a378222446b4cf39e3240e008b4ae)
            check_type(argname="argument aspect", value=aspect, expected_type=type_hints["aspect"])
            check_type(argname="argument aspect_var", value=aspect_var, expected_type=type_hints["aspect_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if aspect is not None:
            self._values["aspect"] = aspect
        if aspect_var is not None:
            self._values["aspect_var"] = aspect_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def aspect(self) -> typing.Optional[builtins.str]:
        '''Preserves the aspect ratio.

        Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect DataAkamaiImagingPolicyImage#aspect}
        '''
        result = self._values.get("aspect")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def aspect_var(self) -> typing.Optional[builtins.str]:
        '''Preserves the aspect ratio.

        Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_var DataAkamaiImagingPolicyImage#aspect_var}
        '''
        result = self._values.get("aspect_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height to resize the source image to. Must be set if height is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height to resize the source image to. Must be set if height is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''Sets constraints for the image resize.

        Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''Sets constraints for the image resize.

        Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width to resize the source image to. Must be set if width is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width to resize the source image to. Must be set if width is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanResize(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanResizeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanResizeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__854714ae0a7719c9c17f5a4b535fafea2045e8b0c86926f78485985feea88bb5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanResizeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6fa5307e1d982853ebc1f7331da4aeb55ff465599f7ff12c3d0e1e2560dc89f6)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanResizeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f0c63cc168a6e59d102efe72cadd9afb85f5a24200be2214ee6b8d486182834d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0e8d9cf4c586bb07c313936e9dfebc2b4224381639bd720781286bd8c9fb7684)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fafdc58ab26dd50fcd8c022b0472b39a60332267710e2ba585f89b8e6a62befd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanResize]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanResize]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanResize]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__18db3718b9c4e4bf86fbcd204830db73ebeb81dad29308e2a3cd84229984aeac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanResizeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanResizeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__355621f60a560c522d424eb189e32cc1fbc8d3690a552540684cdd0400cc117f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAspect")
    def reset_aspect(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspect", []))

    @jsii.member(jsii_name="resetAspectVar")
    def reset_aspect_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspectVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="aspectInput")
    def aspect_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "aspectInput"))

    @builtins.property
    @jsii.member(jsii_name="aspectVarInput")
    def aspect_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "aspectVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="aspect")
    def aspect(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "aspect"))

    @aspect.setter
    def aspect(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c610ddebb7f8422c4657f6eca6528b1cc2f546d94eab472ab41b2a3f3f0fc5f8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "aspect", value)

    @builtins.property
    @jsii.member(jsii_name="aspectVar")
    def aspect_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "aspectVar"))

    @aspect_var.setter
    def aspect_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3c5b421846e38b33d97620616ed85111ff1a3d6c70839b969e19a76204d4c7a0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "aspectVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3903994d29b78b53c0a996923b0822839e6ccc388f5fb4093ebb2f8e1715e345)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ea51ff4c9b5dbff9cfcc94dbeb8f0e7f3e6da2cc07091729b0a6a78ae0d3cd0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__efded6239bde3c0fa79e8694d47e569d6fc20099494e27b8d77081640eccbd61)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bddf725f0d414e30ba8effa9a04b23ce465d3650dc4cad43a6a2ab146dcbbb43)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9cb26c475662c3031d6a8f3db4b12f84af9171087e829a19fcba889bf851beeb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d7673c15cf14cf69537b6c8a8678719c5852ea4abd5ba5bd8cea03eb230721ff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanResize]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanResize]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanResize]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d197d4f575503b7c49ac002f0ecb7afcb9188f8215ebf60ef7a8baae47df23cd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanRotate",
    jsii_struct_bases=[],
    name_mapping={"degrees": "degrees", "degrees_var": "degreesVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanRotate:
    def __init__(
        self,
        *,
        degrees: typing.Optional[builtins.str] = None,
        degrees_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param degrees: The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees DataAkamaiImagingPolicyImage#degrees}
        :param degrees_var: The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees_var DataAkamaiImagingPolicyImage#degrees_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3055f124c86066ea6cc3bfef62d0daa9cd581637c985280dd85bd320a44c5568)
            check_type(argname="argument degrees", value=degrees, expected_type=type_hints["degrees"])
            check_type(argname="argument degrees_var", value=degrees_var, expected_type=type_hints["degrees_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if degrees is not None:
            self._values["degrees"] = degrees
        if degrees_var is not None:
            self._values["degrees_var"] = degrees_var

    @builtins.property
    def degrees(self) -> typing.Optional[builtins.str]:
        '''The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees DataAkamaiImagingPolicyImage#degrees}
        '''
        result = self._values.get("degrees")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def degrees_var(self) -> typing.Optional[builtins.str]:
        '''The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees_var DataAkamaiImagingPolicyImage#degrees_var}
        '''
        result = self._values.get("degrees_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanRotate(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanRotateList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanRotateList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5e069eff8d0f37b172131e4121fe1e477291c087197f2faf62507db2afda849a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanRotateOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5a2906df8be868ebeb2b06e3c739a8975ee2036d834289f9c49f2fd0d2fda458)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanRotateOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__38d057bd9c4357fc41fe193a5a8e0732e8a43b85f9cc3bbff9277f9fbc479e71)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fdc21a0b462717b6c599b8b64c60e82638980e6dc7ecc6da63f5a07232a88c5c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1ba960d79cfe01b850b99ca88a4f7972a64d4709f6af0c0b15d913bdc7f6c352)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanRotate]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanRotate]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanRotate]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a08e3b47750e1d7166b63edc34056661f34e2c3ff1b3efe1b0cbc7474fb0fcba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanRotateOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanRotateOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ab68ce7e4b4f354016097d8a6274beed327ec8b799491dc5428bcd8b73b0120)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetDegrees")
    def reset_degrees(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDegrees", []))

    @jsii.member(jsii_name="resetDegreesVar")
    def reset_degrees_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDegreesVar", []))

    @builtins.property
    @jsii.member(jsii_name="degreesInput")
    def degrees_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "degreesInput"))

    @builtins.property
    @jsii.member(jsii_name="degreesVarInput")
    def degrees_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "degreesVarInput"))

    @builtins.property
    @jsii.member(jsii_name="degrees")
    def degrees(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "degrees"))

    @degrees.setter
    def degrees(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__69838169e67116686fe1a788663e7d5466a671cb15876e84f01fc10c30f6b2fc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "degrees", value)

    @builtins.property
    @jsii.member(jsii_name="degreesVar")
    def degrees_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "degreesVar"))

    @degrees_var.setter
    def degrees_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8af4800dcd18ca57157276db417ff62abbd412af12ccec62c22faa50817d05a8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "degreesVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanRotate]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanRotate]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanRotate]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5e7c8137b3a71809342c20bc1cee850adba7ff81b9734d221472d8d034dac00d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanScale",
    jsii_struct_bases=[],
    name_mapping={
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanScale:
    def __init__(
        self,
        *,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param height: Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged. Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged. Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2b26b66c8d5fdf9672d758b8da7715d502b3393d7c79af789fba1f4b8e776540)
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size.

        Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size.

        Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged.

        Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged.

        Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanScale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanScaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanScaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1ea68ce746e8debcae62ba7a3e350e03d7525d97d87b5f73cfe7c86f0b37e03c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanScaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__38e20ce73dd9ee68fff5c2c08e0d531f2e0a5ac93beacc7d944693ac6125f7fc)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanScaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__31395265a27fe3dc0f3d42083486d792125061f4c5a09cd4c304377a0c13d4e7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f06ac53d79f0ee9ecd455c19eaf7fec641e2784b82333445f6a2e23d65f18e2c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c092eed951ab2b75d6774b4fc24758f5785d26798622ed4f247f64a6e2efe7ef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanScale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanScale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanScale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__57b1efeed869fe863afc03617c09ebdcb41ff736cd94da5efcc8a8cdcc4d52ed)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanScaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanScaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d32b88ccc00da6b332c1d120ceb0491e1c6316af458f0e83a20bb02b0ef9fc7b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2967fecde985a5dda1ec843ce6c69ea16c951ee2328f1bed636cef57e8367e97)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4081c97dcb44897585f5f5f661de550d0189ea7e6de8d275ac72039fdc61735a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c84fcdd674542cadc936db338252f2a37aa9c23a5cff7bb486ed32c8388a6d0d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c8baa7925d47314123ebd72ba1cbd85d9c82046849ff300f050a76beb787be40)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanScale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanScale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanScale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e0cafd3368cabf141a65eae978d36c3e2559a3541beaa7bf162de286dae5f576)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanShear",
    jsii_struct_bases=[],
    name_mapping={
        "x_shear": "xShear",
        "x_shear_var": "xShearVar",
        "y_shear": "yShear",
        "y_shear_var": "yShearVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanShear:
    def __init__(
        self,
        *,
        x_shear: typing.Optional[builtins.str] = None,
        x_shear_var: typing.Optional[builtins.str] = None,
        y_shear: typing.Optional[builtins.str] = None,
        y_shear_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param x_shear: The amount to shear along the x-axis, measured in multiples of the image's width. Must be set if yShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear DataAkamaiImagingPolicyImage#x_shear}
        :param x_shear_var: The amount to shear along the x-axis, measured in multiples of the image's width. Must be set if yShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear_var DataAkamaiImagingPolicyImage#x_shear_var}
        :param y_shear: The amount to shear along the y-axis, measured in multiples of the image's height. Must be set if xShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear DataAkamaiImagingPolicyImage#y_shear}
        :param y_shear_var: The amount to shear along the y-axis, measured in multiples of the image's height. Must be set if xShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear_var DataAkamaiImagingPolicyImage#y_shear_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__db2630101d3ff5911931cbf41ff4704a05a76c9f7c201ff82b475099d80e00dc)
            check_type(argname="argument x_shear", value=x_shear, expected_type=type_hints["x_shear"])
            check_type(argname="argument x_shear_var", value=x_shear_var, expected_type=type_hints["x_shear_var"])
            check_type(argname="argument y_shear", value=y_shear, expected_type=type_hints["y_shear"])
            check_type(argname="argument y_shear_var", value=y_shear_var, expected_type=type_hints["y_shear_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if x_shear is not None:
            self._values["x_shear"] = x_shear
        if x_shear_var is not None:
            self._values["x_shear_var"] = x_shear_var
        if y_shear is not None:
            self._values["y_shear"] = y_shear
        if y_shear_var is not None:
            self._values["y_shear_var"] = y_shear_var

    @builtins.property
    def x_shear(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the x-axis, measured in multiples of the image's width.

        Must be set if yShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear DataAkamaiImagingPolicyImage#x_shear}
        '''
        result = self._values.get("x_shear")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_shear_var(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the x-axis, measured in multiples of the image's width.

        Must be set if yShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear_var DataAkamaiImagingPolicyImage#x_shear_var}
        '''
        result = self._values.get("x_shear_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_shear(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the y-axis, measured in multiples of the image's height.

        Must be set if xShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear DataAkamaiImagingPolicyImage#y_shear}
        '''
        result = self._values.get("y_shear")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_shear_var(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the y-axis, measured in multiples of the image's height.

        Must be set if xShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear_var DataAkamaiImagingPolicyImage#y_shear_var}
        '''
        result = self._values.get("y_shear_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanShear(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanShearList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanShearList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a319636373b3de5812704ae27d2451efe32007bc1e52ea76108b5fffa370ada3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanShearOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__240abd3e041cfbcf3f5f3bd32f758544957acac9e440d2ec165a6355ad78651a)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanShearOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d4462ad63bc9549d9eb3ba359c7041bd8cc32b5aeaf9b5d8938fe303d216a2ff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__31158eb21e5de95a395afab6530eed3585ac737d42cabc435936775f110ee6d0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a68348257e675a76c8ff99e7737a55db0be981b5003a1af3cb8e46f3dc30804e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanShear]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanShear]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanShear]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b17823f7aff4a6e912755cae3d0332905d2a0901822e43f47797eae7aa7a9014)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanShearOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanShearOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b09861c4b3c35bf72ede24dddcd284f545bfa38c60e662eef22213b1c6a4e0ad)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetXShear")
    def reset_x_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXShear", []))

    @jsii.member(jsii_name="resetXShearVar")
    def reset_x_shear_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXShearVar", []))

    @jsii.member(jsii_name="resetYShear")
    def reset_y_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYShear", []))

    @jsii.member(jsii_name="resetYShearVar")
    def reset_y_shear_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYShearVar", []))

    @builtins.property
    @jsii.member(jsii_name="xShearInput")
    def x_shear_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xShearInput"))

    @builtins.property
    @jsii.member(jsii_name="xShearVarInput")
    def x_shear_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xShearVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yShearInput")
    def y_shear_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yShearInput"))

    @builtins.property
    @jsii.member(jsii_name="yShearVarInput")
    def y_shear_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yShearVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xShear")
    def x_shear(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xShear"))

    @x_shear.setter
    def x_shear(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__23c71a195bae354fbc45649740bd3b2b9a5c5f91a7aed9300fc4c8d8e3436a2b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xShear", value)

    @builtins.property
    @jsii.member(jsii_name="xShearVar")
    def x_shear_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xShearVar"))

    @x_shear_var.setter
    def x_shear_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__52a91cee5997035562df5a093d0f423d6430a20d1c902a82201d4d3399fef84d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xShearVar", value)

    @builtins.property
    @jsii.member(jsii_name="yShear")
    def y_shear(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yShear"))

    @y_shear.setter
    def y_shear(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7afacb4e8c2161b278def81f64753c236d6ae16c3711276137e1e2b470fb2819)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yShear", value)

    @builtins.property
    @jsii.member(jsii_name="yShearVar")
    def y_shear_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yShearVar"))

    @y_shear_var.setter
    def y_shear_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a0f8fc5330c7549009b4f73c82e90a53e38629c20ecc56062408855f83e3d555)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yShearVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanShear]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanShear]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanShear]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__886813e43cdb4b50e21aef1193ee92130ee8a63c486a682fb871f355ff86a3b3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanTrim",
    jsii_struct_bases=[],
    name_mapping={
        "fuzz": "fuzz",
        "fuzz_var": "fuzzVar",
        "padding": "padding",
        "padding_var": "paddingVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanTrim:
    def __init__(
        self,
        *,
        fuzz: typing.Optional[builtins.str] = None,
        fuzz_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fuzz: The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz DataAkamaiImagingPolicyImage#fuzz}
        :param fuzz_var: The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz_var DataAkamaiImagingPolicyImage#fuzz_var}
        :param padding: The amount of padding in pixels to add to the trimmed image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: The amount of padding in pixels to add to the trimmed image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__708caaccc7577eb46b53b7053f2daad1b0a14ee1f491b60a63003eb08a034af0)
            check_type(argname="argument fuzz", value=fuzz, expected_type=type_hints["fuzz"])
            check_type(argname="argument fuzz_var", value=fuzz_var, expected_type=type_hints["fuzz_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fuzz is not None:
            self._values["fuzz"] = fuzz
        if fuzz_var is not None:
            self._values["fuzz_var"] = fuzz_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var

    @builtins.property
    def fuzz(self) -> typing.Optional[builtins.str]:
        '''The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz DataAkamaiImagingPolicyImage#fuzz}
        '''
        result = self._values.get("fuzz")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fuzz_var(self) -> typing.Optional[builtins.str]:
        '''The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz_var DataAkamaiImagingPolicyImage#fuzz_var}
        '''
        result = self._values.get("fuzz_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''The amount of padding in pixels to add to the trimmed image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''The amount of padding in pixels to add to the trimmed image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanTrim(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanTrimList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanTrimList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c8be44a9608d111e04dc70f6a28ca9414d9e5f459f5d432ab3831b1818d45c67)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanTrimOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__685490de54e613934065385fbaf4374dbcf87e93bfdecf80514d4487abb86043)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanTrimOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a9d2a7ef6bcdcc5d83ce285e5a02cbd2dde4103eb575f3566ca25980f07c7ffc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ddedf345e25c54630de00527f6e5cc798fbbb1d2f3cbcb3b0e20861ddcab9530)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cb7892db6c052a6d0e6b7f21256acfdb7e45cd48c5eb7fa90992121797832d2b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanTrim]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanTrim]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanTrim]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__27cef59dc5f4d3681b8a71ccb8a77e831abe8046d216e6d823a3616640bb3edc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanTrimOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanTrimOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9e35b1a20a8a5bd06d5ef98f056922d9ea4c2d774d072b57a10ede92a073e318)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetFuzz")
    def reset_fuzz(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFuzz", []))

    @jsii.member(jsii_name="resetFuzzVar")
    def reset_fuzz_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFuzzVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @builtins.property
    @jsii.member(jsii_name="fuzzInput")
    def fuzz_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fuzzInput"))

    @builtins.property
    @jsii.member(jsii_name="fuzzVarInput")
    def fuzz_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fuzzVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="fuzz")
    def fuzz(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fuzz"))

    @fuzz.setter
    def fuzz(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d0ae625b8baa46f2e313993f8a3d7fcc682be707d9f7d22907a3e6e3ff708e99)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fuzz", value)

    @builtins.property
    @jsii.member(jsii_name="fuzzVar")
    def fuzz_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fuzzVar"))

    @fuzz_var.setter
    def fuzz_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a260e7a3bd8826ee88482c8d7d2dcaa31600089733b81849fcc73f1226b2de44)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fuzzVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac4438c7f666f67a7331571f6b10d512c2ad8534d2f7f996d9e2d57ad4acc075)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f7138d336650aca1fb30ca613065e5e0b5243a9296dcc181ea20c3e2d5e58881)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanTrim]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanTrim]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanTrim]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__30bd225893776a2ce9c3ef99f2e4934fe946306e63838caa5fc2ed24a742d1ac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanUnsharpMask",
    jsii_struct_bases=[],
    name_mapping={
        "gain": "gain",
        "gain_var": "gainVar",
        "sigma": "sigma",
        "sigma_var": "sigmaVar",
        "threshold": "threshold",
        "threshold_var": "thresholdVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanUnsharpMask:
    def __init__(
        self,
        *,
        gain: typing.Optional[builtins.str] = None,
        gain_var: typing.Optional[builtins.str] = None,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
        threshold: typing.Optional[builtins.str] = None,
        threshold_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param gain: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        :param gain_var: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        :param sigma: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        :param threshold: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        :param threshold_var: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1e3e2500b73bcbee904eaacc0cac468e54cea7915effd273619b0a65f0e45b6c)
            check_type(argname="argument gain", value=gain, expected_type=type_hints["gain"])
            check_type(argname="argument gain_var", value=gain_var, expected_type=type_hints["gain_var"])
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
            check_type(argname="argument threshold", value=threshold, expected_type=type_hints["threshold"])
            check_type(argname="argument threshold_var", value=threshold_var, expected_type=type_hints["threshold_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if gain is not None:
            self._values["gain"] = gain
        if gain_var is not None:
            self._values["gain_var"] = gain_var
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var
        if threshold is not None:
            self._values["threshold"] = threshold
        if threshold_var is not None:
            self._values["threshold_var"] = threshold_var

    @builtins.property
    def gain(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        '''
        result = self._values.get("gain")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gain_var(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        '''
        result = self._values.get("gain_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        '''
        result = self._values.get("threshold")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold_var(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        result = self._values.get("threshold_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanUnsharpMask(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanUnsharpMaskList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanUnsharpMaskList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__248d30eec28d4c47a49b191e0690049ebb195258b4f40ad46a22276cb60df4bb)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanUnsharpMaskOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__37bb8e67fae9be9e67218b295d5be4bf8b97ca75a56cd4f382b4336dba6e7b20)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanUnsharpMaskOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__173d6eda003ecaef13a99149fc729542dc63680a377a190e9cfb33bbe4f9e2d7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a2689c2e958b1ddd4b0e40b64d9599e3253fa25605424138b628b019b10c4d69)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a6431aaada434f80b45786dd2064b8a80acae3cc3170f14d8c1d3fee661d0650)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanUnsharpMask]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanUnsharpMask]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanUnsharpMask]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0b2e00a27f2e221ec42ea22cbbc17ef6d152520cccb8e9cb720688789a1df73a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanUnsharpMaskOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanUnsharpMaskOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ded4e2d0c1c894edd6c4aa39d3cde7812dddfb8aa588b362eef898b0c75d33e7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetGain")
    def reset_gain(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGain", []))

    @jsii.member(jsii_name="resetGainVar")
    def reset_gain_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGainVar", []))

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @jsii.member(jsii_name="resetThreshold")
    def reset_threshold(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThreshold", []))

    @jsii.member(jsii_name="resetThresholdVar")
    def reset_threshold_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThresholdVar", []))

    @builtins.property
    @jsii.member(jsii_name="gainInput")
    def gain_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainInput"))

    @builtins.property
    @jsii.member(jsii_name="gainVarInput")
    def gain_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdInput")
    def threshold_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdVarInput")
    def threshold_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gain")
    def gain(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gain"))

    @gain.setter
    def gain(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__55533cf56e8ab554f4b2ac4e55b7f067c4d4ece5184b64f8741c1e6124a5368d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gain", value)

    @builtins.property
    @jsii.member(jsii_name="gainVar")
    def gain_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gainVar"))

    @gain_var.setter
    def gain_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__55789cd7c95dbeaf2332246f652cd0b6be124fd71c8ec82ba29d0d0e2df0ac04)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gainVar", value)

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7af811e770648589bc920782857063ec7845248a431b51ca8696b13ac457ef18)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3f774eadeb8a4382cd6185024567effcad281050c71dc51e5bdafd42a4eefd8d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="threshold")
    def threshold(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "threshold"))

    @threshold.setter
    def threshold(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__23c4242746bd1bb66f9384e71e8e2c39c6d19b378cb89b5b69cdb60cb4edfa7a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "threshold", value)

    @builtins.property
    @jsii.member(jsii_name="thresholdVar")
    def threshold_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "thresholdVar"))

    @threshold_var.setter
    def threshold_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f37e0719fa48ce3bdb99e25fece2067a0a7a55e6fc90376d114d01fff83c2bbb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "thresholdVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanUnsharpMask]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanUnsharpMask]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanUnsharpMask]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b7cffd4989e585d3f001e06094457c88a538ad496b4fa64b2aa5b59d31ee50e6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThan",
    jsii_struct_bases=[],
    name_mapping={
        "append": "append",
        "aspect_crop": "aspectCrop",
        "background_color": "backgroundColor",
        "blur": "blur",
        "chroma_key": "chromaKey",
        "composite": "composite",
        "compound": "compound",
        "contrast": "contrast",
        "crop": "crop",
        "face_crop": "faceCrop",
        "feature_crop": "featureCrop",
        "fit_and_fill": "fitAndFill",
        "goop": "goop",
        "grayscale": "grayscale",
        "hsl": "hsl",
        "hsv": "hsv",
        "if_dimension": "ifDimension",
        "if_orientation": "ifOrientation",
        "im_query": "imQuery",
        "max_colors": "maxColors",
        "mirror": "mirror",
        "mono_hue": "monoHue",
        "opacity": "opacity",
        "region_of_interest_crop": "regionOfInterestCrop",
        "relative_crop": "relativeCrop",
        "remove_color": "removeColor",
        "resize": "resize",
        "rotate": "rotate",
        "scale": "scale",
        "shear": "shear",
        "trim": "trim",
        "unsharp_mask": "unsharpMask",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThan:
    def __init__(
        self,
        *,
        append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanAppend", typing.Dict[builtins.str, typing.Any]]]]] = None,
        aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanAspectCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanBackgroundColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanBlur", typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanChromaKey", typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanComposite", typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanCompound", typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanContrast", typing.Dict[builtins.str, typing.Any]]]]] = None,
        crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanFaceCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanFeatureCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanFitAndFill", typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanGoop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanGrayscale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanHsl", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanHsv", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfDimension", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfOrientation", typing.Dict[builtins.str, typing.Any]]]]] = None,
        im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanImQuery", typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanMaxColors", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanMirror", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanMonoHue", typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanOpacity", typing.Dict[builtins.str, typing.Any]]]]] = None,
        region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanRegionOfInterestCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanRelativeCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanRemoveColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanResize", typing.Dict[builtins.str, typing.Any]]]]] = None,
        rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanRotate", typing.Dict[builtins.str, typing.Any]]]]] = None,
        scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanScale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanShear", typing.Dict[builtins.str, typing.Any]]]]] = None,
        trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanTrim", typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanUnsharpMask", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param append: append block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        :param aspect_crop: aspect_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param crop: crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        :param face_crop: face_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        :param feature_crop: feature_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        :param fit_and_fill: fit_and_fill block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param im_query: im_query block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param region_of_interest_crop: region_of_interest_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        :param relative_crop: relative_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param resize: resize block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        :param rotate: rotate block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        :param scale: scale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param shear: shear block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        :param trim: trim block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__98e5c1d13386537c87cd8d88efa80bc9b8aca6f00f319a400c96c919a80e98ab)
            check_type(argname="argument append", value=append, expected_type=type_hints["append"])
            check_type(argname="argument aspect_crop", value=aspect_crop, expected_type=type_hints["aspect_crop"])
            check_type(argname="argument background_color", value=background_color, expected_type=type_hints["background_color"])
            check_type(argname="argument blur", value=blur, expected_type=type_hints["blur"])
            check_type(argname="argument chroma_key", value=chroma_key, expected_type=type_hints["chroma_key"])
            check_type(argname="argument composite", value=composite, expected_type=type_hints["composite"])
            check_type(argname="argument compound", value=compound, expected_type=type_hints["compound"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument crop", value=crop, expected_type=type_hints["crop"])
            check_type(argname="argument face_crop", value=face_crop, expected_type=type_hints["face_crop"])
            check_type(argname="argument feature_crop", value=feature_crop, expected_type=type_hints["feature_crop"])
            check_type(argname="argument fit_and_fill", value=fit_and_fill, expected_type=type_hints["fit_and_fill"])
            check_type(argname="argument goop", value=goop, expected_type=type_hints["goop"])
            check_type(argname="argument grayscale", value=grayscale, expected_type=type_hints["grayscale"])
            check_type(argname="argument hsl", value=hsl, expected_type=type_hints["hsl"])
            check_type(argname="argument hsv", value=hsv, expected_type=type_hints["hsv"])
            check_type(argname="argument if_dimension", value=if_dimension, expected_type=type_hints["if_dimension"])
            check_type(argname="argument if_orientation", value=if_orientation, expected_type=type_hints["if_orientation"])
            check_type(argname="argument im_query", value=im_query, expected_type=type_hints["im_query"])
            check_type(argname="argument max_colors", value=max_colors, expected_type=type_hints["max_colors"])
            check_type(argname="argument mirror", value=mirror, expected_type=type_hints["mirror"])
            check_type(argname="argument mono_hue", value=mono_hue, expected_type=type_hints["mono_hue"])
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument region_of_interest_crop", value=region_of_interest_crop, expected_type=type_hints["region_of_interest_crop"])
            check_type(argname="argument relative_crop", value=relative_crop, expected_type=type_hints["relative_crop"])
            check_type(argname="argument remove_color", value=remove_color, expected_type=type_hints["remove_color"])
            check_type(argname="argument resize", value=resize, expected_type=type_hints["resize"])
            check_type(argname="argument rotate", value=rotate, expected_type=type_hints["rotate"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument shear", value=shear, expected_type=type_hints["shear"])
            check_type(argname="argument trim", value=trim, expected_type=type_hints["trim"])
            check_type(argname="argument unsharp_mask", value=unsharp_mask, expected_type=type_hints["unsharp_mask"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if append is not None:
            self._values["append"] = append
        if aspect_crop is not None:
            self._values["aspect_crop"] = aspect_crop
        if background_color is not None:
            self._values["background_color"] = background_color
        if blur is not None:
            self._values["blur"] = blur
        if chroma_key is not None:
            self._values["chroma_key"] = chroma_key
        if composite is not None:
            self._values["composite"] = composite
        if compound is not None:
            self._values["compound"] = compound
        if contrast is not None:
            self._values["contrast"] = contrast
        if crop is not None:
            self._values["crop"] = crop
        if face_crop is not None:
            self._values["face_crop"] = face_crop
        if feature_crop is not None:
            self._values["feature_crop"] = feature_crop
        if fit_and_fill is not None:
            self._values["fit_and_fill"] = fit_and_fill
        if goop is not None:
            self._values["goop"] = goop
        if grayscale is not None:
            self._values["grayscale"] = grayscale
        if hsl is not None:
            self._values["hsl"] = hsl
        if hsv is not None:
            self._values["hsv"] = hsv
        if if_dimension is not None:
            self._values["if_dimension"] = if_dimension
        if if_orientation is not None:
            self._values["if_orientation"] = if_orientation
        if im_query is not None:
            self._values["im_query"] = im_query
        if max_colors is not None:
            self._values["max_colors"] = max_colors
        if mirror is not None:
            self._values["mirror"] = mirror
        if mono_hue is not None:
            self._values["mono_hue"] = mono_hue
        if opacity is not None:
            self._values["opacity"] = opacity
        if region_of_interest_crop is not None:
            self._values["region_of_interest_crop"] = region_of_interest_crop
        if relative_crop is not None:
            self._values["relative_crop"] = relative_crop
        if remove_color is not None:
            self._values["remove_color"] = remove_color
        if resize is not None:
            self._values["resize"] = resize
        if rotate is not None:
            self._values["rotate"] = rotate
        if scale is not None:
            self._values["scale"] = scale
        if shear is not None:
            self._values["shear"] = shear
        if trim is not None:
            self._values["trim"] = trim
        if unsharp_mask is not None:
            self._values["unsharp_mask"] = unsharp_mask

    @builtins.property
    def append(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanAppend"]]]:
        '''append block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        '''
        result = self._values.get("append")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanAppend"]]], result)

    @builtins.property
    def aspect_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanAspectCrop"]]]:
        '''aspect_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        '''
        result = self._values.get("aspect_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanAspectCrop"]]], result)

    @builtins.property
    def background_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanBackgroundColor"]]]:
        '''background_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        '''
        result = self._values.get("background_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanBackgroundColor"]]], result)

    @builtins.property
    def blur(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanBlur"]]]:
        '''blur block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        '''
        result = self._values.get("blur")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanBlur"]]], result)

    @builtins.property
    def chroma_key(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanChromaKey"]]]:
        '''chroma_key block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        '''
        result = self._values.get("chroma_key")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanChromaKey"]]], result)

    @builtins.property
    def composite(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanComposite"]]]:
        '''composite block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        '''
        result = self._values.get("composite")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanComposite"]]], result)

    @builtins.property
    def compound(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanCompound"]]]:
        '''compound block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        '''
        result = self._values.get("compound")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanCompound"]]], result)

    @builtins.property
    def contrast(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanContrast"]]]:
        '''contrast block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanContrast"]]], result)

    @builtins.property
    def crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanCrop"]]]:
        '''crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        '''
        result = self._values.get("crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanCrop"]]], result)

    @builtins.property
    def face_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanFaceCrop"]]]:
        '''face_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        '''
        result = self._values.get("face_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanFaceCrop"]]], result)

    @builtins.property
    def feature_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanFeatureCrop"]]]:
        '''feature_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        '''
        result = self._values.get("feature_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanFeatureCrop"]]], result)

    @builtins.property
    def fit_and_fill(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanFitAndFill"]]]:
        '''fit_and_fill block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        '''
        result = self._values.get("fit_and_fill")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanFitAndFill"]]], result)

    @builtins.property
    def goop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanGoop"]]]:
        '''goop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        '''
        result = self._values.get("goop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanGoop"]]], result)

    @builtins.property
    def grayscale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanGrayscale"]]]:
        '''grayscale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        '''
        result = self._values.get("grayscale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanGrayscale"]]], result)

    @builtins.property
    def hsl(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanHsl"]]]:
        '''hsl block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        '''
        result = self._values.get("hsl")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanHsl"]]], result)

    @builtins.property
    def hsv(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanHsv"]]]:
        '''hsv block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        '''
        result = self._values.get("hsv")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanHsv"]]], result)

    @builtins.property
    def if_dimension(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfDimension"]]]:
        '''if_dimension block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        '''
        result = self._values.get("if_dimension")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfDimension"]]], result)

    @builtins.property
    def if_orientation(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfOrientation"]]]:
        '''if_orientation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        '''
        result = self._values.get("if_orientation")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfOrientation"]]], result)

    @builtins.property
    def im_query(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanImQuery"]]]:
        '''im_query block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        '''
        result = self._values.get("im_query")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanImQuery"]]], result)

    @builtins.property
    def max_colors(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanMaxColors"]]]:
        '''max_colors block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        '''
        result = self._values.get("max_colors")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanMaxColors"]]], result)

    @builtins.property
    def mirror(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanMirror"]]]:
        '''mirror block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        '''
        result = self._values.get("mirror")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanMirror"]]], result)

    @builtins.property
    def mono_hue(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanMonoHue"]]]:
        '''mono_hue block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        '''
        result = self._values.get("mono_hue")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanMonoHue"]]], result)

    @builtins.property
    def opacity(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanOpacity"]]]:
        '''opacity block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanOpacity"]]], result)

    @builtins.property
    def region_of_interest_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanRegionOfInterestCrop"]]]:
        '''region_of_interest_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        '''
        result = self._values.get("region_of_interest_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanRegionOfInterestCrop"]]], result)

    @builtins.property
    def relative_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanRelativeCrop"]]]:
        '''relative_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        '''
        result = self._values.get("relative_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanRelativeCrop"]]], result)

    @builtins.property
    def remove_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanRemoveColor"]]]:
        '''remove_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        '''
        result = self._values.get("remove_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanRemoveColor"]]], result)

    @builtins.property
    def resize(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanResize"]]]:
        '''resize block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        '''
        result = self._values.get("resize")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanResize"]]], result)

    @builtins.property
    def rotate(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanRotate"]]]:
        '''rotate block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        '''
        result = self._values.get("rotate")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanRotate"]]], result)

    @builtins.property
    def scale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanScale"]]]:
        '''scale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanScale"]]], result)

    @builtins.property
    def shear(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanShear"]]]:
        '''shear block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        '''
        result = self._values.get("shear")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanShear"]]], result)

    @builtins.property
    def trim(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanTrim"]]]:
        '''trim block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        '''
        result = self._values.get("trim")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanTrim"]]], result)

    @builtins.property
    def unsharp_mask(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanUnsharpMask"]]]:
        '''unsharp_mask block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        result = self._values.get("unsharp_mask")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanUnsharpMask"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanAppend",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_priority": "gravityPriority",
        "gravity_priority_var": "gravityPriorityVar",
        "gravity_var": "gravityVar",
        "preserve_minor_dimension": "preserveMinorDimension",
        "preserve_minor_dimension_var": "preserveMinorDimensionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanAppend:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanAppendImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_priority: typing.Optional[builtins.str] = None,
        gravity_priority_var: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        preserve_minor_dimension: typing.Optional[builtins.str] = None,
        preserve_minor_dimension_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Specifies where to place the ``image`` relative to the source image. The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_priority: Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal. The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority DataAkamaiImagingPolicyImage#gravity_priority}
        :param gravity_priority_var: Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal. The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority_var DataAkamaiImagingPolicyImage#gravity_priority_var}
        :param gravity_var: Specifies where to place the ``image`` relative to the source image. The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param preserve_minor_dimension: Whether to preserve the source image's minor dimension, ``false`` by default. The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension DataAkamaiImagingPolicyImage#preserve_minor_dimension}
        :param preserve_minor_dimension_var: Whether to preserve the source image's minor dimension, ``false`` by default. The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension_var DataAkamaiImagingPolicyImage#preserve_minor_dimension_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanAppendImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__99ab75b084c4b9676f1e5d212033581deac253d5fa1ed87c1e0e1811475babb5)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_priority", value=gravity_priority, expected_type=type_hints["gravity_priority"])
            check_type(argname="argument gravity_priority_var", value=gravity_priority_var, expected_type=type_hints["gravity_priority_var"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument preserve_minor_dimension", value=preserve_minor_dimension, expected_type=type_hints["preserve_minor_dimension"])
            check_type(argname="argument preserve_minor_dimension_var", value=preserve_minor_dimension_var, expected_type=type_hints["preserve_minor_dimension_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_priority is not None:
            self._values["gravity_priority"] = gravity_priority
        if gravity_priority_var is not None:
            self._values["gravity_priority_var"] = gravity_priority_var
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if preserve_minor_dimension is not None:
            self._values["preserve_minor_dimension"] = preserve_minor_dimension
        if preserve_minor_dimension_var is not None:
            self._values["preserve_minor_dimension_var"] = preserve_minor_dimension_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanAppendImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanAppendImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Specifies where to place the ``image`` relative to the source image.

        The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_priority(self) -> typing.Optional[builtins.str]:
        '''Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal.

        The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority DataAkamaiImagingPolicyImage#gravity_priority}
        '''
        result = self._values.get("gravity_priority")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_priority_var(self) -> typing.Optional[builtins.str]:
        '''Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal.

        The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority_var DataAkamaiImagingPolicyImage#gravity_priority_var}
        '''
        result = self._values.get("gravity_priority_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Specifies where to place the ``image`` relative to the source image.

        The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def preserve_minor_dimension(self) -> typing.Optional[builtins.str]:
        '''Whether to preserve the source image's minor dimension, ``false`` by default.

        The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension DataAkamaiImagingPolicyImage#preserve_minor_dimension}
        '''
        result = self._values.get("preserve_minor_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def preserve_minor_dimension_var(self) -> typing.Optional[builtins.str]:
        '''Whether to preserve the source image's minor dimension, ``false`` by default.

        The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension_var DataAkamaiImagingPolicyImage#preserve_minor_dimension_var}
        '''
        result = self._values.get("preserve_minor_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanAppend(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanAppendImage",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanAppendImage:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanAppendImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanAppendImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanAppendImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1e2a622aab3ce0d21de257178cdca35644ab583f080a3fbb6ec8748046722027)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanAppendImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanAppendImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanAppendImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b0581b91a65400913e64dc0ae859fce51270a8cdea1644a9065f66aa1fccac6c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanAppendList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanAppendList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__16b9752ad6595c76ab00444717ae2faa65f4852d4e0ff3c7029ef96ca760c15c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanAppendOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f41206e9786f9dcc44809e6886605270816b1f405baef72e72c18875d5dc842c)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanAppendOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2430d2221d481d07676a7ee2d7e760efefa34c5e08619a7c20a198a9d10e74f1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ff23d91f1b55647d13259852dbafc48edaa8d217617ac51de97ee7650d6ae649)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ce6dbb092a9ef4bcdc14f07a9b7358f1ba4894103a496cd53e31a2f5126bde96)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanAppend]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanAppend]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanAppend]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__173ca8fb4095fcd63aac7e1a0711e5e3657754d45de19cff21a68c9d77989db8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanAppendOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanAppendOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a6e13c8a9a9cebddcdc5fd1eff46d44527e7a7b957405f62877531c3c104d42d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanAppendImage()

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityPriority")
    def reset_gravity_priority(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityPriority", []))

    @jsii.member(jsii_name="resetGravityPriorityVar")
    def reset_gravity_priority_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityPriorityVar", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPreserveMinorDimension")
    def reset_preserve_minor_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPreserveMinorDimension", []))

    @jsii.member(jsii_name="resetPreserveMinorDimensionVar")
    def reset_preserve_minor_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPreserveMinorDimensionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanAppendImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanAppendImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityInput")
    def gravity_priority_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityPriorityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityVarInput")
    def gravity_priority_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityPriorityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanAppendImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanAppendImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionInput")
    def preserve_minor_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "preserveMinorDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionVarInput")
    def preserve_minor_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "preserveMinorDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__01cb4247f5cc9cb509741160fe70cef63ddd3f5895c5f75f68bb893837e34cc9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityPriority")
    def gravity_priority(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityPriority"))

    @gravity_priority.setter
    def gravity_priority(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9dd0882f8302ddb85f8775dd5d45eec81a9e5b1928414beb17ba012d4d034d35)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityPriority", value)

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityVar")
    def gravity_priority_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityPriorityVar"))

    @gravity_priority_var.setter
    def gravity_priority_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__53bc7b08f51ed6403238b9a017985a6a23abbff54750d9e41e23405cfe8d9d59)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityPriorityVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b36d15ab5d918ef66d8cd24ea96f1799bc5aa79d142e7c77401d2978cb603d46)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimension")
    def preserve_minor_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "preserveMinorDimension"))

    @preserve_minor_dimension.setter
    def preserve_minor_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__29751536f9f179984abe177102998a0b45aa15b5ffc575d856ab342e30e227d3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "preserveMinorDimension", value)

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionVar")
    def preserve_minor_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "preserveMinorDimensionVar"))

    @preserve_minor_dimension_var.setter
    def preserve_minor_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1d379fa74e52de1a2e495bf7698fcd5e2b5773175211b06d3285d2f3dcf05e31)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "preserveMinorDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanAppend]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanAppend]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanAppend]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ba0471f31ddde51124c6056a0417d1c85f7a090e08db0c53579a85cf9b60411)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanAspectCrop",
    jsii_struct_bases=[],
    name_mapping={
        "allow_expansion": "allowExpansion",
        "allow_expansion_var": "allowExpansionVar",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanAspectCrop:
    def __init__(
        self,
        *,
        allow_expansion: typing.Optional[builtins.str] = None,
        allow_expansion_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_expansion: Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image. Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        :param allow_expansion_var: Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image. Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        :param height: The height term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The width term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        :param x_position: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1d84b3d472c52a2f7f5be6b9b095e6344f8019b66621f23657ae37804993e090)
            check_type(argname="argument allow_expansion", value=allow_expansion, expected_type=type_hints["allow_expansion"])
            check_type(argname="argument allow_expansion_var", value=allow_expansion_var, expected_type=type_hints["allow_expansion_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if allow_expansion is not None:
            self._values["allow_expansion"] = allow_expansion
        if allow_expansion_var is not None:
            self._values["allow_expansion_var"] = allow_expansion_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def allow_expansion(self) -> typing.Optional[builtins.str]:
        '''Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image.

        Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        '''
        result = self._values.get("allow_expansion")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def allow_expansion_var(self) -> typing.Optional[builtins.str]:
        '''Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image.

        Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        '''
        result = self._values.get("allow_expansion_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanAspectCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanAspectCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanAspectCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a10ce806bcfa03fc5faa47ae0ef90af8db4cb8ff320070f01157bb0675f3ddd3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanAspectCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cee0a0ecbb0691be551ca0e5b8424516cc143f12225944b8ebbd49882bd248ab)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanAspectCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4b3892b6957c1910f7e521b891085ec70c493fec9aeef95a79e3b72c455fbdd6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0fbf3d4a795bd04375e565abfce6f0dd12d29086ba4cdf0c23507ff0d836c717)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__575d3169a87047fb0a1786a9e6c261e4043d0f6dea2461fd6ef3d08536e99a1c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanAspectCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanAspectCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanAspectCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b261e698baa990363f869d90d70f8a5b5df92b412e54e88b02b93acf12b3a0a3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanAspectCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanAspectCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f13df88caf4d8322aacddcf3718d559ffcb6601296b399daf5ea8d8636ca03c2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAllowExpansion")
    def reset_allow_expansion(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansion", []))

    @jsii.member(jsii_name="resetAllowExpansionVar")
    def reset_allow_expansion_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansionVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionInput")
    def allow_expansion_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVarInput")
    def allow_expansion_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansion")
    def allow_expansion(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansion"))

    @allow_expansion.setter
    def allow_expansion(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a5ddb38116f6d91d14f831253bb2a2a3a27c323ac63052305d1a85d96c898a12)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansion", value)

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVar")
    def allow_expansion_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansionVar"))

    @allow_expansion_var.setter
    def allow_expansion_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7ab3af35fcc8d108c3886e87cc4e3370f27e7fe1c873458c17d6ddb080113975)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansionVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f926bd8d74309a11357e89f95565a726e8f1f7b454a835a6c1431fdf51e8669c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__986113b2274732942a6e00d062101de7b644cc4645feb844b5722edfb3f8790d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a25b3bc6f0c59e6af43e2337ec22dad2b0729584da6e24951dc845a2dd36d7ac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3eb4d4a68ea07c97e24c6eff67babcf3fcadfe6fd9bf08c5ba7f89aa0c59c518)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__41fb253ea177827d6d53b4810f1aee398810f2cd45c751b0a60dbd61046ce6b8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e671b4587dbc0f6582b4c36afae176b456c681405182e0e70b4a1bf0f8164ec0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b1c4d970eb205557c230dd6625a7b7c3ae1ec4da2a036efca1ee7409490665bc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__81136081ff93cc5dfe5053b2694aaf8f96d0aa83337ba7a8808acea7cfb5f8d3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanAspectCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanAspectCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanAspectCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__acc9a8a3e6bfb099ed5bcb0498580197599fd776ad56571c60f23645a235ce83)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanBackgroundColor",
    jsii_struct_bases=[],
    name_mapping={"color": "color", "color_var": "colorVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanBackgroundColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e3264a5cd0f518882e464bb3203f9666fffd9da46fc3e59facbe716e948f20fb)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanBackgroundColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanBackgroundColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanBackgroundColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2be6c98d193b42da3437299f52b47f12e1a0c35bf942e52e782d2fc851b25e73)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanBackgroundColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bf2e11f44a3cbe6481089cc30499bfce84af91e75f1720a2665a849c7b1fee93)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanBackgroundColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6b4c7ce8eae9e011ca5c44926194b8cccd61ae70a6256d00d11119eb8e91fce2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c2196e18a47b3317ca63a98c1e96eb1a30c96fbefdf44915038c6f051da49c86)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0bb5c5b0e5cb3f656e2700eba29663235a3ca046c9fa49067852202d47f66956)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanBackgroundColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanBackgroundColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__49eda4fcc0d47784ca7476b12d5f7e1b37ce5f5ec98475533a7ccf950ca58308)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanBackgroundColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanBackgroundColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__23ef91cae0de4f0d489b7d9d7792f0e8ac910eb8289000c122e5fff6962656bd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5c3bec05190bc3c423b83b0ab6d039bced96d6ed9b9e79120a286f7d2e1ecb4b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__76c6be8203b81e53dd0e18a82e5f886926da12ea7ff796454e753e9d547681dc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanBackgroundColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanBackgroundColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanBackgroundColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1b8d896ae25311d9aac6f65b6c567478d581fc79f1581d6bba51ca31dc383fa1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanBlur",
    jsii_struct_bases=[],
    name_mapping={"sigma": "sigma", "sigma_var": "sigmaVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanBlur:
    def __init__(
        self,
        *,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param sigma: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__915f1d5a7af2f09f57c5167e62d799543753b1565b6648f8ce2c57490b3fb417)
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanBlur(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanBlurList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanBlurList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__30d5673563c84fa83ff47275a1dbf15fc311c9a8f4c860b8c756bda6d99ab9b3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanBlurOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__895f2f1673e684ad253245ba9f784e7a96d5c64e05e369decd63237b2765b3b3)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanBlurOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__92f4b04950ba39ced9c606932712022ac03c39048cc03c4cde9eaa9eaa0466da)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bda5cb65e5d6bf425f75ceb82b5d4d6d280c4e36d31ff8b0c1a06549883e41fe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0977e44d7f75cf0ccdbb3fb7d39f8661e1bb577850e4f8c4c52df94592e9b44d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanBlur]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanBlur]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6c3dcd679b0cd38de35e4b0a1c8ae73e9c9aa7c8804e88ca66619afc8a33cd53)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanBlurOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanBlurOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__77cdef2350ef2a63a3268fcbb5c477ea34fa986ab9280e959a641bb1a2409cd6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5230af26f5f1a0115b27d53495449b11b6a648026a081e3d2f1a95edb19257d9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__78bd6688d5babfa9237faf64a85c19cc162a05637a0dc5a62c69381890ec6089)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanBlur]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanBlur]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanBlur]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__818fb2f068edea55967be59b9fc07e3a1bd92f34bbfae983cb77f5bce27cf1e2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanChromaKey",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_feather": "hueFeather",
        "hue_feather_var": "hueFeatherVar",
        "hue_tolerance": "hueTolerance",
        "hue_tolerance_var": "hueToleranceVar",
        "hue_var": "hueVar",
        "lightness_feather": "lightnessFeather",
        "lightness_feather_var": "lightnessFeatherVar",
        "lightness_tolerance": "lightnessTolerance",
        "lightness_tolerance_var": "lightnessToleranceVar",
        "saturation_feather": "saturationFeather",
        "saturation_feather_var": "saturationFeatherVar",
        "saturation_tolerance": "saturationTolerance",
        "saturation_tolerance_var": "saturationToleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanChromaKey:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_feather: typing.Optional[builtins.str] = None,
        hue_feather_var: typing.Optional[builtins.str] = None,
        hue_tolerance: typing.Optional[builtins.str] = None,
        hue_tolerance_var: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness_feather: typing.Optional[builtins.str] = None,
        lightness_feather_var: typing.Optional[builtins.str] = None,
        lightness_tolerance: typing.Optional[builtins.str] = None,
        lightness_tolerance_var: typing.Optional[builtins.str] = None,
        saturation_feather: typing.Optional[builtins.str] = None,
        saturation_feather_var: typing.Optional[builtins.str] = None,
        saturation_tolerance: typing.Optional[builtins.str] = None,
        saturation_tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_feather: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        :param hue_feather_var: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        :param hue_tolerance: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        :param hue_tolerance_var: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        :param hue_var: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness_feather: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        :param lightness_feather_var: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        :param lightness_tolerance: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        :param lightness_tolerance_var: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        :param saturation_feather: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        :param saturation_feather_var: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        :param saturation_tolerance: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        :param saturation_tolerance_var: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ea2839e6e12827f66040e2dd23dd01a1cefafa9ca040119b88b0fe4be0849ca)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_feather", value=hue_feather, expected_type=type_hints["hue_feather"])
            check_type(argname="argument hue_feather_var", value=hue_feather_var, expected_type=type_hints["hue_feather_var"])
            check_type(argname="argument hue_tolerance", value=hue_tolerance, expected_type=type_hints["hue_tolerance"])
            check_type(argname="argument hue_tolerance_var", value=hue_tolerance_var, expected_type=type_hints["hue_tolerance_var"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness_feather", value=lightness_feather, expected_type=type_hints["lightness_feather"])
            check_type(argname="argument lightness_feather_var", value=lightness_feather_var, expected_type=type_hints["lightness_feather_var"])
            check_type(argname="argument lightness_tolerance", value=lightness_tolerance, expected_type=type_hints["lightness_tolerance"])
            check_type(argname="argument lightness_tolerance_var", value=lightness_tolerance_var, expected_type=type_hints["lightness_tolerance_var"])
            check_type(argname="argument saturation_feather", value=saturation_feather, expected_type=type_hints["saturation_feather"])
            check_type(argname="argument saturation_feather_var", value=saturation_feather_var, expected_type=type_hints["saturation_feather_var"])
            check_type(argname="argument saturation_tolerance", value=saturation_tolerance, expected_type=type_hints["saturation_tolerance"])
            check_type(argname="argument saturation_tolerance_var", value=saturation_tolerance_var, expected_type=type_hints["saturation_tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_feather is not None:
            self._values["hue_feather"] = hue_feather
        if hue_feather_var is not None:
            self._values["hue_feather_var"] = hue_feather_var
        if hue_tolerance is not None:
            self._values["hue_tolerance"] = hue_tolerance
        if hue_tolerance_var is not None:
            self._values["hue_tolerance_var"] = hue_tolerance_var
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness_feather is not None:
            self._values["lightness_feather"] = lightness_feather
        if lightness_feather_var is not None:
            self._values["lightness_feather_var"] = lightness_feather_var
        if lightness_tolerance is not None:
            self._values["lightness_tolerance"] = lightness_tolerance
        if lightness_tolerance_var is not None:
            self._values["lightness_tolerance_var"] = lightness_tolerance_var
        if saturation_feather is not None:
            self._values["saturation_feather"] = saturation_feather
        if saturation_feather_var is not None:
            self._values["saturation_feather_var"] = saturation_feather_var
        if saturation_tolerance is not None:
            self._values["saturation_tolerance"] = saturation_tolerance
        if saturation_tolerance_var is not None:
            self._values["saturation_tolerance_var"] = saturation_tolerance_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        '''
        result = self._values.get("hue_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        '''
        result = self._values.get("hue_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        '''
        result = self._values.get("hue_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        '''
        result = self._values.get("hue_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        '''
        result = self._values.get("lightness_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        '''
        result = self._values.get("lightness_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        '''
        result = self._values.get("lightness_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        '''
        result = self._values.get("lightness_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        '''
        result = self._values.get("saturation_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        '''
        result = self._values.get("saturation_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        '''
        result = self._values.get("saturation_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        result = self._values.get("saturation_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanChromaKey(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanChromaKeyList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanChromaKeyList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8ca7ad5addf32886f5bd6cbbf5f20ee05a9cd95b64ba15ad45d17de046c0ccde)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanChromaKeyOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__15739d65a092914affeb5885704d5c67ed9aff34d6f0a9544d250810b1633f45)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanChromaKeyOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7ba3e0af6389bbd5d90f84c7de47df37c419f960e2e8736556ae4b182164bcd2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__445a017598c73b15a7f64e6df523b753e8c9e539ac3494f987f35abf13b11975)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6d87b834f7a159d2a60a66dcf9e06df249d8d8934a4da7634754b466276790a1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanChromaKey]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanChromaKey]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__08a8221030f74c36e87370d862eba0a1b5ab7c77c8068a296b645bf6b7454e99)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanChromaKeyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanChromaKeyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__16e995ff78d006d3e804a285e6d4102e8e54884dcf1ce21977acf49cdf1f83f5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueFeather")
    def reset_hue_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeather", []))

    @jsii.member(jsii_name="resetHueFeatherVar")
    def reset_hue_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeatherVar", []))

    @jsii.member(jsii_name="resetHueTolerance")
    def reset_hue_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueTolerance", []))

    @jsii.member(jsii_name="resetHueToleranceVar")
    def reset_hue_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueToleranceVar", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightnessFeather")
    def reset_lightness_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeather", []))

    @jsii.member(jsii_name="resetLightnessFeatherVar")
    def reset_lightness_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeatherVar", []))

    @jsii.member(jsii_name="resetLightnessTolerance")
    def reset_lightness_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessTolerance", []))

    @jsii.member(jsii_name="resetLightnessToleranceVar")
    def reset_lightness_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessToleranceVar", []))

    @jsii.member(jsii_name="resetSaturationFeather")
    def reset_saturation_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeather", []))

    @jsii.member(jsii_name="resetSaturationFeatherVar")
    def reset_saturation_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeatherVar", []))

    @jsii.member(jsii_name="resetSaturationTolerance")
    def reset_saturation_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationTolerance", []))

    @jsii.member(jsii_name="resetSaturationToleranceVar")
    def reset_saturation_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherInput")
    def hue_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVarInput")
    def hue_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceInput")
    def hue_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVarInput")
    def hue_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherInput")
    def lightness_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVarInput")
    def lightness_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceInput")
    def lightness_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVarInput")
    def lightness_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherInput")
    def saturation_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVarInput")
    def saturation_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceInput")
    def saturation_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVarInput")
    def saturation_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__adca1e427d948876ce6030fde3dd8ed60790f1514f194c4506b1c291a27f83fa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeather")
    def hue_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeather"))

    @hue_feather.setter
    def hue_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8b4adb6dfbdf733bb11601327182439eda3832c75820c38eb1fa196926a6fef7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeather", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVar")
    def hue_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeatherVar"))

    @hue_feather_var.setter
    def hue_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eb31b68d212f2a4a195ae35739560a45c3642a6de4df6a8d54f1421e0e0621a8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueTolerance")
    def hue_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueTolerance"))

    @hue_tolerance.setter
    def hue_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__456c56bbdc20bddef358c544ad6f5a3f43975a3d2f4b41568a38c87ebe9c8cb2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVar")
    def hue_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueToleranceVar"))

    @hue_tolerance_var.setter
    def hue_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__26fc9ccb3ffeade3e4f1bdd86c90a9d6a336ccff2e263c2be368b4beb20030e5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c931c44ba73c0c5b74d69442867c49a8654a274a006b8af76af91468c514745e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeather")
    def lightness_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeather"))

    @lightness_feather.setter
    def lightness_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5c7a29616238374956bb2ff30000aaa109821757579ab4a9f14a1db90df06a6d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeather", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVar")
    def lightness_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeatherVar"))

    @lightness_feather_var.setter
    def lightness_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bfcad7fd17ae166d42825446fd98e8dbd9bff1f79dfd209c8708b85c9820eb56)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessTolerance")
    def lightness_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessTolerance"))

    @lightness_tolerance.setter
    def lightness_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9c7c3f3c1efb5c073aa672b5668e5212c7c3f0eb78ffc5dc6e3f8385bc5732b8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVar")
    def lightness_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessToleranceVar"))

    @lightness_tolerance_var.setter
    def lightness_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__08e0228e08de21e4f586900c4987e654c994748bb4cbf465756b3f045871cbe4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeather")
    def saturation_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeather"))

    @saturation_feather.setter
    def saturation_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__49803f736aafaefb76c4a9d385fceb5351b0af48057e1ef6cf46635ec8800d2b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeather", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVar")
    def saturation_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeatherVar"))

    @saturation_feather_var.setter
    def saturation_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b6d48e917d3fbc26e2b79738d79529bbfa991aa4e01159c32b2cebc795cbb3ce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationTolerance")
    def saturation_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationTolerance"))

    @saturation_tolerance.setter
    def saturation_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cfa75a9005a906bbcbbad4fcce8a7b22616f7f5a46c4c915024441e003c2e973)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVar")
    def saturation_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationToleranceVar"))

    @saturation_tolerance_var.setter
    def saturation_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f6150683b34e8f730b39c3ed64afb9483e54ddb514eca8388f06da3775ef75b8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanChromaKey]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanChromaKey]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanChromaKey]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__88de27fc19f591d179bbf4af7265fc4b01af2c0b9ee705e78b2eaeb5bb4b965e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanComposite",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "placement": "placement",
        "placement_var": "placementVar",
        "scale": "scale",
        "scale_dimension": "scaleDimension",
        "scale_dimension_var": "scaleDimensionVar",
        "scale_var": "scaleVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanComposite:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanCompositeImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        placement: typing.Optional[builtins.str] = None,
        placement_var: typing.Optional[builtins.str] = None,
        scale: typing.Optional[builtins.str] = None,
        scale_dimension: typing.Optional[builtins.str] = None,
        scale_dimension_var: typing.Optional[builtins.str] = None,
        scale_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param placement: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        :param placement_var: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        :param scale: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param scale_dimension: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        :param scale_dimension_var: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        :param scale_var: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        :param x_position: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanCompositeImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d8f7beb9c2bc76ed23c5e0fa94e5c4381255642ba6ed0944b0a6c92a79c4cbe0)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument placement", value=placement, expected_type=type_hints["placement"])
            check_type(argname="argument placement_var", value=placement_var, expected_type=type_hints["placement_var"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument scale_dimension", value=scale_dimension, expected_type=type_hints["scale_dimension"])
            check_type(argname="argument scale_dimension_var", value=scale_dimension_var, expected_type=type_hints["scale_dimension_var"])
            check_type(argname="argument scale_var", value=scale_var, expected_type=type_hints["scale_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if placement is not None:
            self._values["placement"] = placement
        if placement_var is not None:
            self._values["placement_var"] = placement_var
        if scale is not None:
            self._values["scale"] = scale
        if scale_dimension is not None:
            self._values["scale_dimension"] = scale_dimension
        if scale_dimension_var is not None:
            self._values["scale_dimension_var"] = scale_dimension_var
        if scale_var is not None:
            self._values["scale_var"] = scale_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanCompositeImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanCompositeImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        '''
        result = self._values.get("placement")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement_var(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        '''
        result = self._values.get("placement_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        '''
        result = self._values.get("scale_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        '''
        result = self._values.get("scale_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        '''
        result = self._values.get("scale_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanComposite(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanCompositeImage",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanCompositeImage:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanCompositeImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanCompositeImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanCompositeImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4812885caeff7088bebb0f34a90274f1c5122c9aa8eae4c24468beb4e2331cbd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanCompositeImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanCompositeImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0578a5c61b38f8130bd4efc4f604239d4e1366939a0491c882b1e2efc80be444)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanCompositeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanCompositeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ace84569f277430fc6a7d55e2a647bd7f807c1a0927910748722ea07dc1b66d6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanCompositeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__47d43887526cc8072bc563de918a93fce675739aa6577ac2048507d5d39cc4f4)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanCompositeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fc597665ee1ac1feb85003900a1b8bbf3df8986164df1fd68577fe2b472fff0e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__79963a8d3e0a4f5a6beb28ab7f6cee635038ce96208b20c19f78c1ae1b806aec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__639ad7a3a150007a24438503dd8e5543164fb98e727933f6b6640fd98af2fb49)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanComposite]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanComposite]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d42887c9ccdedfbffdd379fe6b9a8340260f30833954baec19512f11308276f4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanCompositeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanCompositeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bbb0608ddc10841227a1e1e7dcc8558a50f03c1083b7ac213b52bada253a4a78)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanCompositeImage()

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPlacement")
    def reset_placement(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacement", []))

    @jsii.member(jsii_name="resetPlacementVar")
    def reset_placement_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacementVar", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetScaleDimension")
    def reset_scale_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimension", []))

    @jsii.member(jsii_name="resetScaleDimensionVar")
    def reset_scale_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimensionVar", []))

    @jsii.member(jsii_name="resetScaleVar")
    def reset_scale_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanCompositeImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanCompositeImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanCompositeImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="placementInput")
    def placement_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementInput"))

    @builtins.property
    @jsii.member(jsii_name="placementVarInput")
    def placement_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionInput")
    def scale_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVarInput")
    def scale_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleVarInput")
    def scale_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cdc395bd23ac21f661ec3e367dfa827a8a1119f37720a879d3abda15f5ef65b7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f2a62fc61e5b506ae0446f8d0582276bba024c1fa912c3b48f6552bf01b40787)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="placement")
    def placement(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placement"))

    @placement.setter
    def placement(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4e32c8d73ea2109b72cbd20c7897c1880a296540265ccf7bc9553c8c742f973d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placement", value)

    @builtins.property
    @jsii.member(jsii_name="placementVar")
    def placement_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placementVar"))

    @placement_var.setter
    def placement_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eec1955b6d7d5247206089945fd94945a2c3b15a4472fc17b0a95c4f8db48968)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placementVar", value)

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scale"))

    @scale.setter
    def scale(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__34ae6dbac3b0ea43fa29ecc8668cdf8971e3b7463f43ee631815d0bb02fb3a48)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scale", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimension")
    def scale_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimension"))

    @scale_dimension.setter
    def scale_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bd171e77d477fc651f453f390dc3233223872e470511fae4d4869a8f7d7c50a6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimension", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVar")
    def scale_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimensionVar"))

    @scale_dimension_var.setter
    def scale_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b73cbb2d07a7adff348c2659f03e9e82ed5f400090ea91b3371c1c18bc2b6bb0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="scaleVar")
    def scale_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleVar"))

    @scale_var.setter
    def scale_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5538c18160e807e3dd660b3869d299254fd3707e52ab2080ead84bc52b94fef7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be67cceb1f5340090e6a0eee4f49c93d4ff01533ed02223948234cc1502c149c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__74a997a26aac2dedbea530cea3aa6f22287eabc387548e3dded033808a7aa1cb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__75e3ea80dc3284922fdb70289401d05c406d084029b333b4015c08b4111e9760)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__597417cfae44fe2760b0a4e6a95c081566420627f27ce032198689895de6ad6f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanComposite]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanComposite]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanComposite]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f1a260315baf6f317c8bee05e96f3a65bf679abedbfd477aebbb30f759e1fc2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanCompound",
    jsii_struct_bases=[],
    name_mapping={"transformations": "transformations"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanCompound:
    def __init__(
        self,
        *,
        transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param transformations: transformations block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f77caad42dff3a51cff7c5c6052ca4351a2381b8637b2bf5f8fe65273b5b52e0)
            check_type(argname="argument transformations", value=transformations, expected_type=type_hints["transformations"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if transformations is not None:
            self._values["transformations"] = transformations

    @builtins.property
    def transformations(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanCompoundTransformations"]]]:
        '''transformations block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        result = self._values.get("transformations")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanCompoundTransformations"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanCompound(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanCompoundList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanCompoundList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c65f13146f44cac3c46b1ca9f6bd69ad3354a4a0d899eb41b70e6319ea31ca4e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanCompoundOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bcc32943ec8b6994834aec16612627ea2829289a6df891145d22e0ccb4e53aea)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanCompoundOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__baafd2640ba29b2105b2683b369dd98ee38f0da012ae9bcacac6048e5de37f98)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__68c7c3020f6e5c0a9ef3934ec6075483fbc63754941b9e00fb55919682d2bbf1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e5ea1ecae0e5d4a8e51bee63ac8df4e4d572523847d991a812db4d785b4975fc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanCompound]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanCompound]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a29159134c856a95481413dbedad021d6a7c66bb90071cfce70f2f2b3edf5612)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanCompoundOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanCompoundOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__83bd91a77fec463f55b4be1abae6487f47ec77cd1c86a97a70bc1d5d6a9980c6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformations")
    def put_transformations(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bf83d1fde35cf5387ab499a7b490f06146b31a0c863457c5e235d0c212d061d9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTransformations", [value]))

    @jsii.member(jsii_name="resetTransformations")
    def reset_transformations(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformations", []))

    @builtins.property
    @jsii.member(jsii_name="transformations")
    def transformations(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanCompoundTransformationsList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanCompoundTransformationsList", jsii.get(self, "transformations"))

    @builtins.property
    @jsii.member(jsii_name="transformationsInput")
    def transformations_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanCompoundTransformations"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanCompoundTransformations"]]], jsii.get(self, "transformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanCompound]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanCompound]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanCompound]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__87da6388bc95be25fdc90e09534068b833ea534202d0ff0f7b9c466c2f38eeaf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanCompoundTransformations",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanCompoundTransformations:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanCompoundTransformations(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanCompoundTransformationsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanCompoundTransformationsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d26f556688b4b3abaf0619e4385eb544ff85c764ed1e1fce90c88141165dbca5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanCompoundTransformationsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__57742b0c57fff35e41a2ccf8748324e49efaa2688589f79b98b3cb482da8b1e0)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanCompoundTransformationsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__19eb6ef7231f229c003a58a0a732559017b5052110053511a26e8c4eb2fcad60)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ba3eb016b2c0332da23a3b5c7f7172fb1a216661ee2e9ad3d398a09a94f3772e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7aa11a33fcf7925d4d365a669fda3081b4864ab12a3d5a7bd681013f661594b0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanCompoundTransformations]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanCompoundTransformations]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanCompoundTransformations]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__facc73a106fad56eb395c4e7effdf7e3773e37ea30759f2f684fdaf7354ea0ed)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanCompoundTransformationsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanCompoundTransformationsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__656933a7573767ca3dd433817a37694f7f97272621b468a5212c42f8d5b80114)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanCompoundTransformations]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanCompoundTransformations]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanCompoundTransformations]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__27856ab17208bb6cbbda3ff8a766e142764a3a14249d452feee5ca92bc745b04)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanContrast",
    jsii_struct_bases=[],
    name_mapping={
        "brightness": "brightness",
        "brightness_var": "brightnessVar",
        "contrast": "contrast",
        "contrast_var": "contrastVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanContrast:
    def __init__(
        self,
        *,
        brightness: typing.Optional[builtins.str] = None,
        brightness_var: typing.Optional[builtins.str] = None,
        contrast: typing.Optional[builtins.str] = None,
        contrast_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param brightness: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        :param brightness_var: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        :param contrast: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param contrast_var: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b117fb055817daa6c8d8fd545a38c672511f534e21103232101f9df3494d6b3b)
            check_type(argname="argument brightness", value=brightness, expected_type=type_hints["brightness"])
            check_type(argname="argument brightness_var", value=brightness_var, expected_type=type_hints["brightness_var"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument contrast_var", value=contrast_var, expected_type=type_hints["contrast_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if brightness is not None:
            self._values["brightness"] = brightness
        if brightness_var is not None:
            self._values["brightness_var"] = brightness_var
        if contrast is not None:
            self._values["contrast"] = contrast
        if contrast_var is not None:
            self._values["contrast_var"] = contrast_var

    @builtins.property
    def brightness(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        '''
        result = self._values.get("brightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def brightness_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        '''
        result = self._values.get("brightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        result = self._values.get("contrast_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanContrast(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanContrastList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanContrastList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a40df0366339b22725b1d785e47aed11861a17c45d1db933615ba7c33e404edb)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanContrastOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__299b643e97605c666f7b46625a32bf868b2566dfc8d6173e3ae002b1de46cd2b)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanContrastOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d167dcaa74c6e7919f1f84e787d39916d1c4a123e366a358e30ed3702127e99d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ccca5b2899a9635f76b3856f17685b9e4fc973f00deeaea20b215f5a1978bbf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eb27f5aebe8b42a2e08e1440f07207b51dfa6abe9d68c8344c6a2e72b4ab09cd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanContrast]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanContrast]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2811fc9b7a069e96045745744ccf7b834e53dd9de235179aefb67b8fb8761e35)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanContrastOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanContrastOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6cf6f7cc689769ceaff5e6300f8c91b232afb5dd3f1ff27238839afbfca3da8e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetBrightness")
    def reset_brightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightness", []))

    @jsii.member(jsii_name="resetBrightnessVar")
    def reset_brightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightnessVar", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetContrastVar")
    def reset_contrast_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrastVar", []))

    @builtins.property
    @jsii.member(jsii_name="brightnessInput")
    def brightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="brightnessVarInput")
    def brightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastVarInput")
    def contrast_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="brightness")
    def brightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightness"))

    @brightness.setter
    def brightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ec74287f85f5a892f2055c7a977cf3447e2ed6497c536de235150676a16874d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightness", value)

    @builtins.property
    @jsii.member(jsii_name="brightnessVar")
    def brightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightnessVar"))

    @brightness_var.setter
    def brightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1db0901a5f47434093f48fdc75a99fae8e4fd893513a94b58c263ef9848917e4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrast"))

    @contrast.setter
    def contrast(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c224be2886012e0271fc6649be865612774b0b2a6a59fa817e60b2d58273af11)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrast", value)

    @builtins.property
    @jsii.member(jsii_name="contrastVar")
    def contrast_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrastVar"))

    @contrast_var.setter
    def contrast_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5a91667f8c662f868bb2337f42565a7731caac0aebc927f07d42056283bafa5d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrastVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanContrast]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanContrast]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanContrast]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e5b3824cd1cadde54556161f891e3a47c15305c9c460d499be9fa31939a11cae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanCrop",
    jsii_struct_bases=[],
    name_mapping={
        "allow_expansion": "allowExpansion",
        "allow_expansion_var": "allowExpansionVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanCrop:
    def __init__(
        self,
        *,
        allow_expansion: typing.Optional[builtins.str] = None,
        allow_expansion_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_expansion: If cropping an area outside of the existing canvas, expands the image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        :param allow_expansion_var: If cropping an area outside of the existing canvas, expands the image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        :param gravity: Frame of reference for X and Y Positions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Frame of reference for X and Y Positions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The number of pixels to crop along the y-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The number of pixels to crop along the y-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The number of pixels to crop along the x-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The number of pixels to crop along the x-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        :param x_position: The x-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__691227af568b49322bac910d7b36522735211e8e69d71af3d48771ac3056ffd8)
            check_type(argname="argument allow_expansion", value=allow_expansion, expected_type=type_hints["allow_expansion"])
            check_type(argname="argument allow_expansion_var", value=allow_expansion_var, expected_type=type_hints["allow_expansion_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if allow_expansion is not None:
            self._values["allow_expansion"] = allow_expansion
        if allow_expansion_var is not None:
            self._values["allow_expansion_var"] = allow_expansion_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def allow_expansion(self) -> typing.Optional[builtins.str]:
        '''If cropping an area outside of the existing canvas, expands the image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        '''
        result = self._values.get("allow_expansion")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def allow_expansion_var(self) -> typing.Optional[builtins.str]:
        '''If cropping an area outside of the existing canvas, expands the image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        '''
        result = self._values.get("allow_expansion_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Frame of reference for X and Y Positions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Frame of reference for X and Y Positions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the y-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the y-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the x-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the x-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7f8bca07170d1c94a1703bc9844d9c475588d1c0030c2613e1e612e3a53e50da)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9dc49a96fc8672be051f9ccf8b45e569ba0cce50a3875034896afe52cf87aa19)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f25587112294cd4c49caee32bf87ab078137755a8f47038b94b35de38f447e45)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ecabc10f257e7ba7fe2e885622cb577fa3ecd6a84b01eec52d8cbb558220ed31)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0c3b970a65658f1675efa0bd7270c4983d81a743771fd3d646453ddb2f17a565)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bfeda73b8ddb822fd816be6a994182a4f24d0f27f1c9b099931ee6b643b9f458)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__861c1e7e06944ea74bc813208eefc194bd9b9857e661a6327908e8889d918f37)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAllowExpansion")
    def reset_allow_expansion(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansion", []))

    @jsii.member(jsii_name="resetAllowExpansionVar")
    def reset_allow_expansion_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansionVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionInput")
    def allow_expansion_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVarInput")
    def allow_expansion_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansion")
    def allow_expansion(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansion"))

    @allow_expansion.setter
    def allow_expansion(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__710a0b042d584e4c5c102b857f4fd873581edbed7e6a0f3a4a36b8f904800f37)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansion", value)

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVar")
    def allow_expansion_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansionVar"))

    @allow_expansion_var.setter
    def allow_expansion_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6165e052e2f31397a6a8676c3b6f6954d59053fca613229d45f9a6057b43e22b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansionVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__23e963b0e3ae889352bd56cc05e4b107843de659bb83f6d1837fe1d76ec641b9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__121cd91574490f4d72cd6820bc174b6b2faf3c1fd935f3a7b668a8a84c1ad7cb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bd543670baa9516c997b3c27a8c02bf996a9504ca6ca39c3db8d9b8c09c589c9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fcb1e339c6a90c779f7d3a7ea4a6a0e96bcb425319d4ca6d58f3b4ff13add7aa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__225dd143095b943be8f4fc7cbf297aa82a30461fbe1be70cb3c07fda67b5f060)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c41a4703bceb86963ea2fc3aad80620b80a5a2a6e83dd3e7a5c4c840911be989)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0f702dc059a92f1dd02b713f3ea36f44be789ad70765f7f4a1b896f7bb8bea76)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__99c8a481fdd70543fe61494d577217bf493fc33bcc0b8e273f2afd38b6244d2b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3c139af8fe97e0064f7876f96dc9f3502c955683fe880f7cd2b69784b2c93da0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__534f794a2bb7415a1e896a739661752560859811d800473914059070fb0ae857)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3f2dfe9f8a064a28c05253bfe6373a8b70d576faddaa9576bfe938322a30d29c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanFaceCrop",
    jsii_struct_bases=[],
    name_mapping={
        "algorithm": "algorithm",
        "algorithm_var": "algorithmVar",
        "confidence": "confidence",
        "confidence_var": "confidenceVar",
        "fail_gravity": "failGravity",
        "fail_gravity_var": "failGravityVar",
        "focus": "focus",
        "focus_var": "focusVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "padding": "padding",
        "padding_var": "paddingVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanFaceCrop:
    def __init__(
        self,
        *,
        algorithm: typing.Optional[builtins.str] = None,
        algorithm_var: typing.Optional[builtins.str] = None,
        confidence: typing.Optional[builtins.str] = None,
        confidence_var: typing.Optional[builtins.str] = None,
        fail_gravity: typing.Optional[builtins.str] = None,
        fail_gravity_var: typing.Optional[builtins.str] = None,
        focus: typing.Optional[builtins.str] = None,
        focus_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param algorithm: Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm DataAkamaiImagingPolicyImage#algorithm}
        :param algorithm_var: Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm_var DataAkamaiImagingPolicyImage#algorithm_var}
        :param confidence: With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image. Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence DataAkamaiImagingPolicyImage#confidence}
        :param confidence_var: With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image. Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence_var DataAkamaiImagingPolicyImage#confidence_var}
        :param fail_gravity: Controls placement of the crop if Image and Video Manager does not detect any faces in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        :param fail_gravity_var: Controls placement of the crop if Image and Video Manager does not detect any faces in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        :param focus: Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus DataAkamaiImagingPolicyImage#focus}
        :param focus_var: Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus_var DataAkamaiImagingPolicyImage#focus_var}
        :param gravity: Controls placement of the crop. Directions are relative to the face(s) plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Controls placement of the crop. Directions are relative to the face(s) plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param padding: The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        :param style: Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__28d5a46e2047c8d85e2b225c99c2982366c486b28b760ed77253ac93cb781b00)
            check_type(argname="argument algorithm", value=algorithm, expected_type=type_hints["algorithm"])
            check_type(argname="argument algorithm_var", value=algorithm_var, expected_type=type_hints["algorithm_var"])
            check_type(argname="argument confidence", value=confidence, expected_type=type_hints["confidence"])
            check_type(argname="argument confidence_var", value=confidence_var, expected_type=type_hints["confidence_var"])
            check_type(argname="argument fail_gravity", value=fail_gravity, expected_type=type_hints["fail_gravity"])
            check_type(argname="argument fail_gravity_var", value=fail_gravity_var, expected_type=type_hints["fail_gravity_var"])
            check_type(argname="argument focus", value=focus, expected_type=type_hints["focus"])
            check_type(argname="argument focus_var", value=focus_var, expected_type=type_hints["focus_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if algorithm is not None:
            self._values["algorithm"] = algorithm
        if algorithm_var is not None:
            self._values["algorithm_var"] = algorithm_var
        if confidence is not None:
            self._values["confidence"] = confidence
        if confidence_var is not None:
            self._values["confidence_var"] = confidence_var
        if fail_gravity is not None:
            self._values["fail_gravity"] = fail_gravity
        if fail_gravity_var is not None:
            self._values["fail_gravity_var"] = fail_gravity_var
        if focus is not None:
            self._values["focus"] = focus
        if focus_var is not None:
            self._values["focus_var"] = focus_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def algorithm(self) -> typing.Optional[builtins.str]:
        '''Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm DataAkamaiImagingPolicyImage#algorithm}
        '''
        result = self._values.get("algorithm")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def algorithm_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm_var DataAkamaiImagingPolicyImage#algorithm_var}
        '''
        result = self._values.get("algorithm_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def confidence(self) -> typing.Optional[builtins.str]:
        '''With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image.

        Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence DataAkamaiImagingPolicyImage#confidence}
        '''
        result = self._values.get("confidence")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def confidence_var(self) -> typing.Optional[builtins.str]:
        '''With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image.

        Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence_var DataAkamaiImagingPolicyImage#confidence_var}
        '''
        result = self._values.get("confidence_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any faces in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        '''
        result = self._values.get("fail_gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any faces in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        '''
        result = self._values.get("fail_gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def focus(self) -> typing.Optional[builtins.str]:
        '''Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus DataAkamaiImagingPolicyImage#focus}
        '''
        result = self._values.get("focus")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def focus_var(self) -> typing.Optional[builtins.str]:
        '''Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus_var DataAkamaiImagingPolicyImage#focus_var}
        '''
        result = self._values.get("focus_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the face(s) plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the face(s) plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanFaceCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanFaceCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanFaceCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__60444871155754341fa9bac9b77215d12ab577f24ca1ad4ab94b60e2a983d565)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanFaceCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1629d2046d939ad473bba49e1183da3e604c7fc4233891f3e998aadd3276bd8e)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanFaceCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__38d69d5891c616fcd43d4be6c2450025fe55d4be8d81356706b6eedaabd73983)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f433e1ef94479dc9c5fee67bc2ecd942eb8a8c1ae34cb8a2f8945d5473b69cb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cfa256144b52e49b33a1825ef884919bd1e78dbfa6dd91993f6bb9d42ec2e1d4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanFaceCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanFaceCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanFaceCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dec4162cd326c7400632a68e1ccb8397d6ff46f58685948ae4b5a0816a1a2e60)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanFaceCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanFaceCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3b5b2b000ce117cf2b3aeccc1c78bf5b23c5ba468342971e910fefffa5e41a03)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAlgorithm")
    def reset_algorithm(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAlgorithm", []))

    @jsii.member(jsii_name="resetAlgorithmVar")
    def reset_algorithm_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAlgorithmVar", []))

    @jsii.member(jsii_name="resetConfidence")
    def reset_confidence(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetConfidence", []))

    @jsii.member(jsii_name="resetConfidenceVar")
    def reset_confidence_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetConfidenceVar", []))

    @jsii.member(jsii_name="resetFailGravity")
    def reset_fail_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravity", []))

    @jsii.member(jsii_name="resetFailGravityVar")
    def reset_fail_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravityVar", []))

    @jsii.member(jsii_name="resetFocus")
    def reset_focus(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFocus", []))

    @jsii.member(jsii_name="resetFocusVar")
    def reset_focus_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFocusVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="algorithmInput")
    def algorithm_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "algorithmInput"))

    @builtins.property
    @jsii.member(jsii_name="algorithmVarInput")
    def algorithm_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "algorithmVarInput"))

    @builtins.property
    @jsii.member(jsii_name="confidenceInput")
    def confidence_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "confidenceInput"))

    @builtins.property
    @jsii.member(jsii_name="confidenceVarInput")
    def confidence_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "confidenceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityInput")
    def fail_gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityVarInput")
    def fail_gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="focusInput")
    def focus_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "focusInput"))

    @builtins.property
    @jsii.member(jsii_name="focusVarInput")
    def focus_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "focusVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="algorithm")
    def algorithm(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "algorithm"))

    @algorithm.setter
    def algorithm(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__85102e30d86eb8377c130c1e7c003940e12d68a55f984c539970e26f384c09bc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "algorithm", value)

    @builtins.property
    @jsii.member(jsii_name="algorithmVar")
    def algorithm_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "algorithmVar"))

    @algorithm_var.setter
    def algorithm_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d3beaaeb88844f0976da1203cefcac3731ba52cf7959f2fd79d479925af2eb3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "algorithmVar", value)

    @builtins.property
    @jsii.member(jsii_name="confidence")
    def confidence(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "confidence"))

    @confidence.setter
    def confidence(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aeb17b76ffa5d6318a44b60b2993deb7f5f6fa302f9d42a0607e866317fe3faf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "confidence", value)

    @builtins.property
    @jsii.member(jsii_name="confidenceVar")
    def confidence_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "confidenceVar"))

    @confidence_var.setter
    def confidence_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__94e66716a7ec553ce8e5b989c23aacc578081f79fbfe4c5e23ebe61dc35d5119)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "confidenceVar", value)

    @builtins.property
    @jsii.member(jsii_name="failGravity")
    def fail_gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravity"))

    @fail_gravity.setter
    def fail_gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1978d453f1d387f6c8acfdbb6eaa2b8ea493d11b0c00f83b28cfeb2a926685eb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravity", value)

    @builtins.property
    @jsii.member(jsii_name="failGravityVar")
    def fail_gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravityVar"))

    @fail_gravity_var.setter
    def fail_gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb52de3d067a1736ee8a23a170b52e6d2021578e66671b67f81fd51f0105f88c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="focus")
    def focus(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "focus"))

    @focus.setter
    def focus(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b7c7cf85c0c5de95568f1041e13a4fa6f3c50f3bfcef8e89fd8e541e50d8130f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "focus", value)

    @builtins.property
    @jsii.member(jsii_name="focusVar")
    def focus_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "focusVar"))

    @focus_var.setter
    def focus_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c5b93427cffe9248521be4448d59ab32f9e0966b88fbd7710c9382de7bc77a15)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "focusVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6eeafd29a10961d80bdbb8801efe026c82fa47cc137804c0149bc25db16d06ce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__90a44efaae612e5594c0eeac77175c79d030dbf253f1a73b541f5dd7fc510d90)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__30ef44453c677a3cf99e708f0fdeef0782b8bdeb0ee967b7ac4d920e2ccb4fb5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__48a6d7eae0d83b6543c7393c937e68e6522c3b3d08070988da3a62234e9bab99)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__56e238253c1a472397235a399502775598e50528c980941613b7f5fbc21fe879)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ffe10a89e028d9cd49c0423ed7c6afda2f0f845e1ab6c14a07c73bebaf826cad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5d733590ea1f28248db1a58655186aea02aa4a66a655aa4a5f95a865c03070e4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5c968a655f652bd7f0435f00f448dca000200c315b45decadfe49c954e707322)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab0b919dfbd306036c942a2cd0f8722bf31798823f118c7c7bd19f44a165ebb1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0006a3e273e8d714bd1cb9ae2340e797b7e7d393f43b0cdf65a99c37af79ae9c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanFaceCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanFaceCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanFaceCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b687eacb8a06762697a4ac5cde820b248efee5277edfd3021f5ebadd9ae3a16c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanFeatureCrop",
    jsii_struct_bases=[],
    name_mapping={
        "fail_gravity": "failGravity",
        "fail_gravity_var": "failGravityVar",
        "feature_radius": "featureRadius",
        "feature_radius_var": "featureRadiusVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "max_features": "maxFeatures",
        "max_features_var": "maxFeaturesVar",
        "min_feature_quality": "minFeatureQuality",
        "min_feature_quality_var": "minFeatureQualityVar",
        "padding": "padding",
        "padding_var": "paddingVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanFeatureCrop:
    def __init__(
        self,
        *,
        fail_gravity: typing.Optional[builtins.str] = None,
        fail_gravity_var: typing.Optional[builtins.str] = None,
        feature_radius: typing.Optional[builtins.str] = None,
        feature_radius_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        max_features: typing.Optional[builtins.str] = None,
        max_features_var: typing.Optional[builtins.str] = None,
        min_feature_quality: typing.Optional[builtins.str] = None,
        min_feature_quality_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fail_gravity: Controls placement of the crop if Image and Video Manager does not detect any features in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        :param fail_gravity_var: Controls placement of the crop if Image and Video Manager does not detect any features in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        :param feature_radius: The size in pixels of the important features to search for. If identified, two features never appear closer together than this value, ``8.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius DataAkamaiImagingPolicyImage#feature_radius}
        :param feature_radius_var: The size in pixels of the important features to search for. If identified, two features never appear closer together than this value, ``8.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius_var DataAkamaiImagingPolicyImage#feature_radius_var}
        :param gravity: Controls placement of the crop. Directions are relative to the region of interest plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Controls placement of the crop. Directions are relative to the region of interest plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param max_features: The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features DataAkamaiImagingPolicyImage#max_features}
        :param max_features_var: The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features_var DataAkamaiImagingPolicyImage#max_features_var}
        :param min_feature_quality: Determines the minimum quality level of the feature identified. To consider a feature important, the feature needs to surpass this value. Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality DataAkamaiImagingPolicyImage#min_feature_quality}
        :param min_feature_quality_var: Determines the minimum quality level of the feature identified. To consider a feature important, the feature needs to surpass this value. Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality_var DataAkamaiImagingPolicyImage#min_feature_quality_var}
        :param padding: Adds space around the region of interest. The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: Adds space around the region of interest. The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        :param style: Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9032e005d8f9dd90a67550370f443de81bcce850bf86bd06f5e65ef641e010aa)
            check_type(argname="argument fail_gravity", value=fail_gravity, expected_type=type_hints["fail_gravity"])
            check_type(argname="argument fail_gravity_var", value=fail_gravity_var, expected_type=type_hints["fail_gravity_var"])
            check_type(argname="argument feature_radius", value=feature_radius, expected_type=type_hints["feature_radius"])
            check_type(argname="argument feature_radius_var", value=feature_radius_var, expected_type=type_hints["feature_radius_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument max_features", value=max_features, expected_type=type_hints["max_features"])
            check_type(argname="argument max_features_var", value=max_features_var, expected_type=type_hints["max_features_var"])
            check_type(argname="argument min_feature_quality", value=min_feature_quality, expected_type=type_hints["min_feature_quality"])
            check_type(argname="argument min_feature_quality_var", value=min_feature_quality_var, expected_type=type_hints["min_feature_quality_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fail_gravity is not None:
            self._values["fail_gravity"] = fail_gravity
        if fail_gravity_var is not None:
            self._values["fail_gravity_var"] = fail_gravity_var
        if feature_radius is not None:
            self._values["feature_radius"] = feature_radius
        if feature_radius_var is not None:
            self._values["feature_radius_var"] = feature_radius_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if max_features is not None:
            self._values["max_features"] = max_features
        if max_features_var is not None:
            self._values["max_features_var"] = max_features_var
        if min_feature_quality is not None:
            self._values["min_feature_quality"] = min_feature_quality
        if min_feature_quality_var is not None:
            self._values["min_feature_quality_var"] = min_feature_quality_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def fail_gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any features in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        '''
        result = self._values.get("fail_gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any features in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        '''
        result = self._values.get("fail_gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feature_radius(self) -> typing.Optional[builtins.str]:
        '''The size in pixels of the important features to search for.

        If identified, two features never appear closer together than this value, ``8.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius DataAkamaiImagingPolicyImage#feature_radius}
        '''
        result = self._values.get("feature_radius")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feature_radius_var(self) -> typing.Optional[builtins.str]:
        '''The size in pixels of the important features to search for.

        If identified, two features never appear closer together than this value, ``8.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius_var DataAkamaiImagingPolicyImage#feature_radius_var}
        '''
        result = self._values.get("feature_radius_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the region of interest plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the region of interest plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def max_features(self) -> typing.Optional[builtins.str]:
        '''The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features DataAkamaiImagingPolicyImage#max_features}
        '''
        result = self._values.get("max_features")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def max_features_var(self) -> typing.Optional[builtins.str]:
        '''The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features_var DataAkamaiImagingPolicyImage#max_features_var}
        '''
        result = self._values.get("max_features_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def min_feature_quality(self) -> typing.Optional[builtins.str]:
        '''Determines the minimum quality level of the feature identified.

        To consider a feature important, the feature needs to surpass this value.  Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality DataAkamaiImagingPolicyImage#min_feature_quality}
        '''
        result = self._values.get("min_feature_quality")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def min_feature_quality_var(self) -> typing.Optional[builtins.str]:
        '''Determines the minimum quality level of the feature identified.

        To consider a feature important, the feature needs to surpass this value.  Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality_var DataAkamaiImagingPolicyImage#min_feature_quality_var}
        '''
        result = self._values.get("min_feature_quality_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''Adds space around the region of interest.

        The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''Adds space around the region of interest.

        The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanFeatureCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanFeatureCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanFeatureCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3126ab08eb09e3247a4f98eaeb8966d4e29db55f80795e58bee228e729f16d03)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanFeatureCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cf2309448d290bae448d798b2fa0b431592cc60e20bfd23523b6aac1dbe6dc7c)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanFeatureCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__04516d43ac3e29eb955279732a1f3b19c482c5527ebb409275201785d637e3de)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__77d6d86ffb93d50b88aac1f4ef4c0dfd4ec2be813e710a9411d36b66e0f6bc57)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7ad8b32ffeb302ec75210abfe4de106cbafddf3802118050cc75cfc63d1add7d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanFeatureCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanFeatureCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanFeatureCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac43bf666d34ed0a0ea69d502c1151c79ca952f22b228ba0439c613f23fe41d3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanFeatureCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanFeatureCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1ca91badc730089a6855488ca37b22790047e650d1c1f0f84d3c5ec0d83cf183)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetFailGravity")
    def reset_fail_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravity", []))

    @jsii.member(jsii_name="resetFailGravityVar")
    def reset_fail_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravityVar", []))

    @jsii.member(jsii_name="resetFeatureRadius")
    def reset_feature_radius(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureRadius", []))

    @jsii.member(jsii_name="resetFeatureRadiusVar")
    def reset_feature_radius_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureRadiusVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetMaxFeatures")
    def reset_max_features(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxFeatures", []))

    @jsii.member(jsii_name="resetMaxFeaturesVar")
    def reset_max_features_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxFeaturesVar", []))

    @jsii.member(jsii_name="resetMinFeatureQuality")
    def reset_min_feature_quality(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMinFeatureQuality", []))

    @jsii.member(jsii_name="resetMinFeatureQualityVar")
    def reset_min_feature_quality_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMinFeatureQualityVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="failGravityInput")
    def fail_gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityVarInput")
    def fail_gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featureRadiusInput")
    def feature_radius_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featureRadiusInput"))

    @builtins.property
    @jsii.member(jsii_name="featureRadiusVarInput")
    def feature_radius_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featureRadiusVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesInput")
    def max_features_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "maxFeaturesInput"))

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesVarInput")
    def max_features_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "maxFeaturesVarInput"))

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityInput")
    def min_feature_quality_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "minFeatureQualityInput"))

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityVarInput")
    def min_feature_quality_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "minFeatureQualityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravity")
    def fail_gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravity"))

    @fail_gravity.setter
    def fail_gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4e380e301045f83c354bf19c5fce64b32994f54a0c697d6101eef5d0e7fbdfe3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravity", value)

    @builtins.property
    @jsii.member(jsii_name="failGravityVar")
    def fail_gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravityVar"))

    @fail_gravity_var.setter
    def fail_gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a646b71bda7e7815b8b69d904bb5847f2013f05be86c8989e67b5284c0e1aed8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="featureRadius")
    def feature_radius(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featureRadius"))

    @feature_radius.setter
    def feature_radius(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__90895fea3a64305d1810976ed44edd1bc2f33fc30fca2c6e8db63109df28b5be)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featureRadius", value)

    @builtins.property
    @jsii.member(jsii_name="featureRadiusVar")
    def feature_radius_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featureRadiusVar"))

    @feature_radius_var.setter
    def feature_radius_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__42269ec345d7428bcfc71ae4fc0482e753072da6f8b7c8eea70345588a6d796d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featureRadiusVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1c8aa7228571016974aff70c84ae52e92b308a30a696874abadc430d651e9897)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__29a1b0d99a51e0fef26437474ee3f51b5d9c9d29e6647bb06f2fe4ccf8bed386)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e36495cc99a3974442146518bf75caac1f391312ee54da11a8a9d636336ed4e5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__08acb0a520c66641c3d9f9b832deea73c82d5cd219831b2909ece25a9c404fc0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="maxFeatures")
    def max_features(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "maxFeatures"))

    @max_features.setter
    def max_features(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8db31017ff5247c1b63f0e7d1241c507196c24af2df59b4014b3a1365534ff24)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "maxFeatures", value)

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesVar")
    def max_features_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "maxFeaturesVar"))

    @max_features_var.setter
    def max_features_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8b012b79cd97b7c67b80519eb390d825bb35ceedd16e839955e3d00e3fac8765)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "maxFeaturesVar", value)

    @builtins.property
    @jsii.member(jsii_name="minFeatureQuality")
    def min_feature_quality(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "minFeatureQuality"))

    @min_feature_quality.setter
    def min_feature_quality(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7fc6a5ff78e343a50e00c24b513941d67497d61766197ba8c636ca8b47bab20b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "minFeatureQuality", value)

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityVar")
    def min_feature_quality_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "minFeatureQualityVar"))

    @min_feature_quality_var.setter
    def min_feature_quality_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__749df914645c70917751c6857e2e382f1349288457c00459d0072bc5ae076627)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "minFeatureQualityVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__988e095bddf5a2eb4394d5138f65738cf551403a4046e37005a17728dcb9e97a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__58d7b8d71562d2dcf4ff073cf50314273fbd2b94e56a2f8d04439c7d3c3274bf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6370836a4eee2a2b9dc3cda4677fca107cb314456893c694bf2d69a53200019f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8eb20e908b8030f958d21689ef742a5ee919a288e92a67f57fffee9772b862b4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ac1c042272adc22bdedbd17f7d7482fc32d732c96c367679d461eec93c737fa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2cec1aafa72631d0daa5a11d3b763a05ace48514b715871ef52ffffe68ef5ca9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanFeatureCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanFeatureCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanFeatureCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4692b2335e687199b11c17aff58c693c74e1e0a852b04515e6b29e9f0961d1d7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanFitAndFill",
    jsii_struct_bases=[],
    name_mapping={
        "fill_transformation": "fillTransformation",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanFitAndFill:
    def __init__(
        self,
        *,
        fill_transformation: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanFitAndFillFillTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fill_transformation: fill_transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_transformation DataAkamaiImagingPolicyImage#fill_transformation}
        :param height: The height value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The width value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(fill_transformation, dict):
            fill_transformation = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanFitAndFillFillTransformation(**fill_transformation)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3246681e2b15c5584764c90756da504876bf99da02071f6ef0fa16fef17b899e)
            check_type(argname="argument fill_transformation", value=fill_transformation, expected_type=type_hints["fill_transformation"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fill_transformation is not None:
            self._values["fill_transformation"] = fill_transformation
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def fill_transformation(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanFitAndFillFillTransformation"]:
        '''fill_transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_transformation DataAkamaiImagingPolicyImage#fill_transformation}
        '''
        result = self._values.get("fill_transformation")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanFitAndFillFillTransformation"], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanFitAndFill(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanFitAndFillFillTransformation",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanFitAndFillFillTransformation:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanFitAndFillFillTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanFitAndFillFillTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanFitAndFillFillTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3acc20e694c5b3a6a3bd42ae4c8cbb9e6201c9f6d1721c13c54cbf8a0eb707c8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanFitAndFillFillTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanFitAndFillFillTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanFitAndFillFillTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bbd4dcbf17900fd438a24e529a4c65836cdd6d839a11bd0ed97445d336f65838)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanFitAndFillList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanFitAndFillList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__80d86f8138faf6ba55704f669d2b3c8d272c39eab9996aa0fb524898e305ba13)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanFitAndFillOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__40daf404ab98dd839309c6651ff696c00675c8d9fb884aad7c247436f3d899fc)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanFitAndFillOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a1617c3727dd79bdc09667fea349b868253d5c11c585ec846426bbfe6a7b4237)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__14acb95c21d93df0fa0ca30cf3322c6b3072cf4fe12ad41208c6218270fcf9cd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__374ad413b76a2d6a8e44140ce7a7f5bf03663b7d90d6c22b6b3a4e7da58d2bd7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanFitAndFill]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanFitAndFill]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanFitAndFill]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9eeb5e6093f92cd5c2ee675923660b709a5aec21a427cd7d38a92aed2453ca6c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanFitAndFillOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanFitAndFillOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__77150e2279f73eb5f5733c8a69d564c35651c3bfc945998b9f5794cf434eb6e8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putFillTransformation")
    def put_fill_transformation(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanFitAndFillFillTransformation()

        return typing.cast(None, jsii.invoke(self, "putFillTransformation", [value]))

    @jsii.member(jsii_name="resetFillTransformation")
    def reset_fill_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFillTransformation", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="fillTransformation")
    def fill_transformation(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanFitAndFillFillTransformationOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanFitAndFillFillTransformationOutputReference, jsii.get(self, "fillTransformation"))

    @builtins.property
    @jsii.member(jsii_name="fillTransformationInput")
    def fill_transformation_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanFitAndFillFillTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanFitAndFillFillTransformation], jsii.get(self, "fillTransformationInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__90c2599b7327f5da54ad873d0ba77b9e5975c0c597c5d46c65b5099c86327bd7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ad5d3b088f424bdd25f97e4883ee7ebe3473fda73cbfd320dcbdf274b1d12233)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__54990c1172bac412bf2970d6ecf73e26a99af88d1a10a8dc382f02f6edf48c27)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be46741c5a131e285210da76ea9904ccdc86c3e2777656d1525ef16359455818)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanFitAndFill]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanFitAndFill]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanFitAndFill]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__77cf1f36d05cfbfc7bf99e4618e7fe403b58ac723de8ca9fb526e36a9c24c71e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanGoop",
    jsii_struct_bases=[],
    name_mapping={
        "chaos": "chaos",
        "chaos_var": "chaosVar",
        "density": "density",
        "density_var": "densityVar",
        "power": "power",
        "power_var": "powerVar",
        "seed": "seed",
        "seed_var": "seedVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanGoop:
    def __init__(
        self,
        *,
        chaos: typing.Optional[builtins.str] = None,
        chaos_var: typing.Optional[builtins.str] = None,
        density: typing.Optional[builtins.str] = None,
        density_var: typing.Optional[builtins.str] = None,
        power: typing.Optional[builtins.str] = None,
        power_var: typing.Optional[builtins.str] = None,
        seed: typing.Optional[builtins.str] = None,
        seed_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param chaos: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        :param chaos_var: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        :param density: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        :param density_var: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        :param power: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        :param power_var: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        :param seed: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        :param seed_var: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7b9a758884c949781397a66f102213f030540574c9f13f572f5102687711b4b8)
            check_type(argname="argument chaos", value=chaos, expected_type=type_hints["chaos"])
            check_type(argname="argument chaos_var", value=chaos_var, expected_type=type_hints["chaos_var"])
            check_type(argname="argument density", value=density, expected_type=type_hints["density"])
            check_type(argname="argument density_var", value=density_var, expected_type=type_hints["density_var"])
            check_type(argname="argument power", value=power, expected_type=type_hints["power"])
            check_type(argname="argument power_var", value=power_var, expected_type=type_hints["power_var"])
            check_type(argname="argument seed", value=seed, expected_type=type_hints["seed"])
            check_type(argname="argument seed_var", value=seed_var, expected_type=type_hints["seed_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if chaos is not None:
            self._values["chaos"] = chaos
        if chaos_var is not None:
            self._values["chaos_var"] = chaos_var
        if density is not None:
            self._values["density"] = density
        if density_var is not None:
            self._values["density_var"] = density_var
        if power is not None:
            self._values["power"] = power
        if power_var is not None:
            self._values["power_var"] = power_var
        if seed is not None:
            self._values["seed"] = seed
        if seed_var is not None:
            self._values["seed_var"] = seed_var

    @builtins.property
    def chaos(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        '''
        result = self._values.get("chaos")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def chaos_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        '''
        result = self._values.get("chaos_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        '''
        result = self._values.get("density")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density_var(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        '''
        result = self._values.get("density_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        '''
        result = self._values.get("power")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power_var(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        '''
        result = self._values.get("power_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        '''
        result = self._values.get("seed")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed_var(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        result = self._values.get("seed_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanGoop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanGoopList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanGoopList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9bf3cdcc4091b3867c595c1155f3157d55b2631f229276d6d1f765c901bc1fec)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanGoopOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a00fa754545286ebd79c99fce27c3ec219e13b12dfb17f8a56d815e82eed9db8)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanGoopOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b4dcc019899be805ab050666c5fb37d211d6e68eb0f12cb7c8882b33379a3f9e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1eedce9a028d303b2ac2b53ff70b1bacf71d05b0a0ad5eb8958786988d8b0c60)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__81ce840fe03a45ae672b5d4dda7a9bd30bd3fa44bbc257747ee4adff9adf3156)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanGoop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanGoop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e147b7005508de5651f78e4b354d49eb54a20a4c7f7ccc8c5cd31ccd2c14099f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanGoopOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanGoopOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6dd69599c9dc980073126195087ca2d8cca981b65a773660c6219d690d0b89a8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetChaos")
    def reset_chaos(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaos", []))

    @jsii.member(jsii_name="resetChaosVar")
    def reset_chaos_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaosVar", []))

    @jsii.member(jsii_name="resetDensity")
    def reset_density(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensity", []))

    @jsii.member(jsii_name="resetDensityVar")
    def reset_density_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensityVar", []))

    @jsii.member(jsii_name="resetPower")
    def reset_power(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPower", []))

    @jsii.member(jsii_name="resetPowerVar")
    def reset_power_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPowerVar", []))

    @jsii.member(jsii_name="resetSeed")
    def reset_seed(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeed", []))

    @jsii.member(jsii_name="resetSeedVar")
    def reset_seed_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeedVar", []))

    @builtins.property
    @jsii.member(jsii_name="chaosInput")
    def chaos_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosInput"))

    @builtins.property
    @jsii.member(jsii_name="chaosVarInput")
    def chaos_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosVarInput"))

    @builtins.property
    @jsii.member(jsii_name="densityInput")
    def density_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityInput"))

    @builtins.property
    @jsii.member(jsii_name="densityVarInput")
    def density_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="powerInput")
    def power_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerInput"))

    @builtins.property
    @jsii.member(jsii_name="powerVarInput")
    def power_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerVarInput"))

    @builtins.property
    @jsii.member(jsii_name="seedInput")
    def seed_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedInput"))

    @builtins.property
    @jsii.member(jsii_name="seedVarInput")
    def seed_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedVarInput"))

    @builtins.property
    @jsii.member(jsii_name="chaos")
    def chaos(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaos"))

    @chaos.setter
    def chaos(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ecd3e5d232fdc7848a7c9668ae85b1024c3c232338e5e571e27a2dc16ca1336e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaos", value)

    @builtins.property
    @jsii.member(jsii_name="chaosVar")
    def chaos_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaosVar"))

    @chaos_var.setter
    def chaos_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fd3e9e3e812aa0aa2daa44e2c502d6549f892e7d82027bbe2f6801ca07fb0562)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaosVar", value)

    @builtins.property
    @jsii.member(jsii_name="density")
    def density(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "density"))

    @density.setter
    def density(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__497f68985f814b2551842a049688b659b024eb9d79a79dd954a6ba53491d9242)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "density", value)

    @builtins.property
    @jsii.member(jsii_name="densityVar")
    def density_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "densityVar"))

    @density_var.setter
    def density_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__026888490ce42b0dc037515eaf02a0356057d94a0215530f20f673fb04809341)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "densityVar", value)

    @builtins.property
    @jsii.member(jsii_name="power")
    def power(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "power"))

    @power.setter
    def power(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ee07ef49e292269e9fd59cfdcaef8b4d36a8a788c96f3ac45877ac3b891ab73)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "power", value)

    @builtins.property
    @jsii.member(jsii_name="powerVar")
    def power_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "powerVar"))

    @power_var.setter
    def power_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b06489297165b206a7bf0969938608b83adfeabc267012f2f1e2549a17709138)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "powerVar", value)

    @builtins.property
    @jsii.member(jsii_name="seed")
    def seed(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seed"))

    @seed.setter
    def seed(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5967e4f63e1fee12bb8895091f4a14daca4c215eb6a73c5ab1356ef7a3941f76)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seed", value)

    @builtins.property
    @jsii.member(jsii_name="seedVar")
    def seed_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seedVar"))

    @seed_var.setter
    def seed_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__faa56b985b9a279a4c784b7ae5ad28b2bb3688bb7cc4ab5407cf2c451adeaa5c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seedVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanGoop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanGoop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanGoop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__48be7a2e607be75561ae47dde763519049c3247bf089aba47d34168b2d470232)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanGrayscale",
    jsii_struct_bases=[],
    name_mapping={"type": "type", "type_var": "typeVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanGrayscale:
    def __init__(
        self,
        *,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param type: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__12c139ea391b0651d9922b5a1aa142402e2befc8d619d61077185e03c4b689c5)
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanGrayscale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanGrayscaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanGrayscaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e4ae5df3c4209027edea1beb762194b9a27696f27a71af885ff5673ce1353194)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanGrayscaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__06428eb2ad5484f826892c4595905da93ff786fa8698a3a59464f280459ad4cb)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanGrayscaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0b4b688cd9f513fbcbd9d0f7a6a0547ef9ef36845bab1edcda3d7003731d483d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2109a6a23d14da822cf9ebc458d13c96970886d54efd44a8cf09844537274580)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c452c94f84d577be7900deee890c1ed7c69d3f6aab7d47d81d337569758dc793)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanGrayscale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanGrayscale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bbc3b2e407bba05db7cc57e1f8aeb298b9a55dd52ffa28042f94c92fefd2464f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanGrayscaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanGrayscaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1258671fabeab20084207f1e9916c7ebdd8a730e963a5a34d460d2d98a9fed46)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eeb8b7bf7b6f97dcc11faf8e946803f3e1afc24b0e8250655b2127fcea05478a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8b6749387458bea8241844c87ec4111beb6ac87e03abfcbfec94ae9de3f012cf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanGrayscale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanGrayscale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanGrayscale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__872c58fda3d90a262e5c1d8f4d05075546f44fe77bf1ab3b527ea36c0a584079)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanHsl",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "lightness": "lightness",
        "lightness_var": "lightnessVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanHsl:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness: typing.Optional[builtins.str] = None,
        lightness_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        :param lightness_var: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c16023b07cef806fd52e742195fb88823060130fbc0a1fdda137e21d3178bd0e)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness", value=lightness, expected_type=type_hints["lightness"])
            check_type(argname="argument lightness_var", value=lightness_var, expected_type=type_hints["lightness_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness is not None:
            self._values["lightness"] = lightness
        if lightness_var is not None:
            self._values["lightness_var"] = lightness_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        '''
        result = self._values.get("lightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        '''
        result = self._values.get("lightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanHsl(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanHslList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanHslList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ab923583894c142f9a65521fb95beb78bc661a81d7a0d01ad7a5e3d354c740d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanHslOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__87ab4bcb656757523128fadee7a56526168e3e79814664735dada65b8bf45809)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanHslOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__14dd6a81d3527e9c7f31a058061927dfa8269f3646827ac95e7fcc4ac4498950)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bd2db8d5ce04ceef059a17c598e9b47d1c1cb0bdc4e455ad00012c0635359c35)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__349bfabe25bbd6f39b763a1cea50328dc43cd1bb8ccb9cd95b96d7fa15737b5f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanHsl]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanHsl]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b65f49f3214213c0c6bd1e575ce12b214b3cb85165c2bcf9fc4f250b5a395efe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanHslOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanHslOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__19ce9871b39ac57398a1ab1881ec94884d2d7cdea33d7e7d09b7390fb067c303)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightness")
    def reset_lightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightness", []))

    @jsii.member(jsii_name="resetLightnessVar")
    def reset_lightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessInput")
    def lightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessVarInput")
    def lightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6aa16f0d7492a5b067d7376ceb0350708ddb7accfc6129d25b4cceb74fa9a4f3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__99ac1e6a4d25f86eda3043121902e956276c4ee72992639dba69f5e2b6e7a3b0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightness")
    def lightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightness"))

    @lightness.setter
    def lightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d53aace6e95c94128fc7ecd17469a4ab8fb4b291b0e285b1f466fc3629ff339b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightness", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessVar")
    def lightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessVar"))

    @lightness_var.setter
    def lightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__37c6de769d90175a74cf558593ca25bdca553e27f9a036a8eaabedaa30d97eea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c55c4bac29df13c872a2073e93d261806f385b45e66af399386bf54da2799603)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__91e87bcd9bae34912cf76ff174d0839e71985e869e6524c689f2685126384c92)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanHsl]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanHsl]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanHsl]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__57cc50078d2e8938342cbf7026e90b7ea8b90480a5bca42cdc47a3d48a385dcb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanHsv",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanHsv:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        :param value: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0a020bc6dc57c1a85835117acadd0d342c6234c35c0af141ecfd81adc8fa671f)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanHsv(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanHsvList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanHsvList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6be46a5c4afa5be6737aa9e8713ab0d3f26b1cefac131e41bd1111eb487ab999)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanHsvOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6b0ec0b3e1119fb4079bac32114256be84975f2087daf7e37cb61192cd421a15)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanHsvOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4e242fa28fdb5842a4f657dc53186b3a4c08862b717ba11ccf08ad710d064966)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__595d354c4ab93842410e852f8d3b532c35bf20a089a7477df4a35bc6a7b4bb76)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3adcb036fcca7a56e21d8d9b422ef01f4df029a55dbd7b9f6bf05132f7590ef8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanHsv]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanHsv]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cf3bdd78ae8e6288b3c675cb9a5617e38ef6ee1ec7ef98c1b5ae7ca96f287eec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanHsvOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanHsvOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__65132c3c1196d5d901c82ef6d36fa5eb93bfb49101ab9237b959e476b8f3b375)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__90720ae8a0edb4b9c4c5823a8e398562cfb933841a9fd3fff68b84d52cc06649)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a18d8438f85acf5185ca72cc1a3373c688bc41ce9706bfeed400b4b94121b6fb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c19f26a84a3d12b7b2cca8188ab83d2cce119a48828bdc524348acfbbd1bce1a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b4e3808c2329c8c08031516bf4980e513bf06946df6584d1ed1aed8c7faf8603)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a01def105b7ca35f38030d3cbe23690b71f282039a9a42b0c1e86e83815bcd52)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ff378e3505428cdc6c13a06375a8b13cb104bd8422bd2a2888985442be976d4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanHsv]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanHsv]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanHsv]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__99788f4410e297aa4ec9fdc6285117979ad584a10f3ce0a5a4bef9414aca4180)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfDimension",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "dimension": "dimension",
        "dimension_var": "dimensionVar",
        "equal": "equal",
        "greater_than": "greaterThan",
        "less_than": "lessThan",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfDimension:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfDimensionDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        dimension: typing.Optional[builtins.str] = None,
        dimension_var: typing.Optional[builtins.str] = None,
        equal: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfDimensionEqual", typing.Dict[builtins.str, typing.Any]]] = None,
        greater_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfDimensionGreaterThan", typing.Dict[builtins.str, typing.Any]]] = None,
        less_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfDimensionLessThan", typing.Dict[builtins.str, typing.Any]]] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param dimension: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        :param dimension_var: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        :param equal: equal block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        :param greater_than: greater_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        :param less_than: less_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        :param value: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfDimensionDefault(**default)
        if isinstance(equal, dict):
            equal = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfDimensionEqual(**equal)
        if isinstance(greater_than, dict):
            greater_than = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfDimensionGreaterThan(**greater_than)
        if isinstance(less_than, dict):
            less_than = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfDimensionLessThan(**less_than)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2e7a7afe0ccc0ec4eeaa5f6e78a27d6ef89cbd0fbde532779aeacbbf52078170)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument dimension", value=dimension, expected_type=type_hints["dimension"])
            check_type(argname="argument dimension_var", value=dimension_var, expected_type=type_hints["dimension_var"])
            check_type(argname="argument equal", value=equal, expected_type=type_hints["equal"])
            check_type(argname="argument greater_than", value=greater_than, expected_type=type_hints["greater_than"])
            check_type(argname="argument less_than", value=less_than, expected_type=type_hints["less_than"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if dimension is not None:
            self._values["dimension"] = dimension
        if dimension_var is not None:
            self._values["dimension_var"] = dimension_var
        if equal is not None:
            self._values["equal"] = equal
        if greater_than is not None:
            self._values["greater_than"] = greater_than
        if less_than is not None:
            self._values["less_than"] = less_than
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfDimensionDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfDimensionDefault"], result)

    @builtins.property
    def dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        '''
        result = self._values.get("dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        '''
        result = self._values.get("dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def equal(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfDimensionEqual"]:
        '''equal block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        '''
        result = self._values.get("equal")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfDimensionEqual"], result)

    @builtins.property
    def greater_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfDimensionGreaterThan"]:
        '''greater_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        '''
        result = self._values.get("greater_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfDimensionGreaterThan"], result)

    @builtins.property
    def less_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfDimensionLessThan"]:
        '''less_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        '''
        result = self._values.get("less_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfDimensionLessThan"], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfDimension(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfDimensionDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfDimensionDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfDimensionDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfDimensionDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfDimensionDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f5a9b88b3bd1c5537021bce131437b85f5e61be225fc786ba4b964b5d768be15)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfDimensionDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfDimensionDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b021e13b941f25c7473954d7f6525109a604b7827feaa8468748539a0c4a5788)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfDimensionEqual",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfDimensionEqual:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfDimensionEqual(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfDimensionEqualOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfDimensionEqualOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dad1ff931c25738d382710902e74dbe1c915d97daf00e4e2960cd36c8caf39ca)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfDimensionEqual], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfDimensionEqual],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c2343710b51630ed7c2cb2056f24adc808c01e15ad31a9484782beba7918f3d2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfDimensionGreaterThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfDimensionGreaterThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfDimensionGreaterThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfDimensionGreaterThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfDimensionGreaterThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ce9e8a470b2dd6a259d39b2cd75659757c728b7427a6b11484ba9a1e056afe7b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfDimensionGreaterThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfDimensionGreaterThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1e571efdb43bd84be5088f5d538ddb4835f52af169cc2ecdfcfeeb3bef0facc5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfDimensionLessThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfDimensionLessThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfDimensionLessThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfDimensionLessThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfDimensionLessThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__65ce9fdc49f36794a5404d8a31f375ab31969bf0988e8ac710234482da73a366)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfDimensionLessThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfDimensionLessThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8e5bc89c339d7febd2115cc23878a6c5d0d99a0df903ef338c4ab414a9d7ed48)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfDimensionList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfDimensionList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__78ae8f9761d12386dc93aea718b2cbe01e03adf0574c8a056f2d7b5fee5191c3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfDimensionOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8b1ac2337ce23e9d1b0bc5fb4da4e9ba5b4efcd07a19ddd91563aa48b103ae66)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfDimensionOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__963799f5b9eafe0c9099f4d1187e52c48a7a752ceb4435406cde1e3f9a95da68)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d03333af2fd559e7146a4f41735e12ba0acf26e6c732625d2adb8b56f5da5f7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__da474558728de7f43e826ebcac0eebc571757ff11f3be9d77accf1fb4935eb28)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfDimension]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfDimension]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__94032105bccb7c418a48fa79b7bc4e0a842405b163dc9c50451b685c2d835ddf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfDimensionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfDimensionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a497a8d4ab13696f3aa8eac303098abbc97f84797b7120b66e2b840a2717df20)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfDimensionDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putEqual")
    def put_equal(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfDimensionEqual()

        return typing.cast(None, jsii.invoke(self, "putEqual", [value]))

    @jsii.member(jsii_name="putGreaterThan")
    def put_greater_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfDimensionGreaterThan()

        return typing.cast(None, jsii.invoke(self, "putGreaterThan", [value]))

    @jsii.member(jsii_name="putLessThan")
    def put_less_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfDimensionLessThan()

        return typing.cast(None, jsii.invoke(self, "putLessThan", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetDimension")
    def reset_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimension", []))

    @jsii.member(jsii_name="resetDimensionVar")
    def reset_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimensionVar", []))

    @jsii.member(jsii_name="resetEqual")
    def reset_equal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEqual", []))

    @jsii.member(jsii_name="resetGreaterThan")
    def reset_greater_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGreaterThan", []))

    @jsii.member(jsii_name="resetLessThan")
    def reset_less_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLessThan", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfDimensionDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfDimensionDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="equal")
    def equal(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfDimensionEqualOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfDimensionEqualOutputReference, jsii.get(self, "equal"))

    @builtins.property
    @jsii.member(jsii_name="greaterThan")
    def greater_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfDimensionGreaterThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfDimensionGreaterThanOutputReference, jsii.get(self, "greaterThan"))

    @builtins.property
    @jsii.member(jsii_name="lessThan")
    def less_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfDimensionLessThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfDimensionLessThanOutputReference, jsii.get(self, "lessThan"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfDimensionDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionInput")
    def dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionVarInput")
    def dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="equalInput")
    def equal_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfDimensionEqual], jsii.get(self, "equalInput"))

    @builtins.property
    @jsii.member(jsii_name="greaterThanInput")
    def greater_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfDimensionGreaterThan], jsii.get(self, "greaterThanInput"))

    @builtins.property
    @jsii.member(jsii_name="lessThanInput")
    def less_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfDimensionLessThan], jsii.get(self, "lessThanInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="dimension")
    def dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimension"))

    @dimension.setter
    def dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eccb6d31b2def405c44fd0110247a65c426ecbd03a8d89eeb80ada72c6cb48cf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimension", value)

    @builtins.property
    @jsii.member(jsii_name="dimensionVar")
    def dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimensionVar"))

    @dimension_var.setter
    def dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0270dfaea0c37e0e78bcfc680ee8f915d828460bf1ab026fec37abb31e34c101)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8c8f9f22045f384abba80dbfe21d14c13d9de722d0421875d7c9a732beb3aab3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7994343c2028aa6c5782b8df8b43c7cf931961963c277fd2fcd9a47fda630d7c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfDimension]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfDimension]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfDimension]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__93b7db16e51d45c200a003ddc8fd07a51f8226fd0ede98c50238a956c81c5274)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfOrientation",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "landscape": "landscape",
        "portrait": "portrait",
        "square": "square",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfOrientation:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfOrientationDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        landscape: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfOrientationLandscape", typing.Dict[builtins.str, typing.Any]]] = None,
        portrait: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfOrientationPortrait", typing.Dict[builtins.str, typing.Any]]] = None,
        square: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfOrientationSquare", typing.Dict[builtins.str, typing.Any]]] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param landscape: landscape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        :param portrait: portrait block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        :param square: square block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfOrientationDefault(**default)
        if isinstance(landscape, dict):
            landscape = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfOrientationLandscape(**landscape)
        if isinstance(portrait, dict):
            portrait = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfOrientationPortrait(**portrait)
        if isinstance(square, dict):
            square = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfOrientationSquare(**square)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__14f90e4d9f75d851b3c94fa281ea543450a46237f59977c8e3cecf4d0768d659)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument landscape", value=landscape, expected_type=type_hints["landscape"])
            check_type(argname="argument portrait", value=portrait, expected_type=type_hints["portrait"])
            check_type(argname="argument square", value=square, expected_type=type_hints["square"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if landscape is not None:
            self._values["landscape"] = landscape
        if portrait is not None:
            self._values["portrait"] = portrait
        if square is not None:
            self._values["square"] = square

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfOrientationDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfOrientationDefault"], result)

    @builtins.property
    def landscape(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfOrientationLandscape"]:
        '''landscape block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        '''
        result = self._values.get("landscape")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfOrientationLandscape"], result)

    @builtins.property
    def portrait(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfOrientationPortrait"]:
        '''portrait block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        '''
        result = self._values.get("portrait")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfOrientationPortrait"], result)

    @builtins.property
    def square(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfOrientationSquare"]:
        '''square block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        result = self._values.get("square")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfOrientationSquare"], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfOrientation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfOrientationDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfOrientationDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfOrientationDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfOrientationDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfOrientationDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__69ac46b3618076645d5ebd69002dc726e2545b082d2b803ea5386bedbe120889)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfOrientationDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfOrientationDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1085483f7e287ec791492542c1d0cb8dc7ec791e013bc90f372dc921be6da346)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfOrientationLandscape",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfOrientationLandscape:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfOrientationLandscape(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfOrientationLandscapeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfOrientationLandscapeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__67cbe6e77b49928ae1e418da8507bc2215f73d453531f6138a4c564129bfdc7a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfOrientationLandscape], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfOrientationLandscape],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0867afc3a12523a16771383d29f5c55471578adf694531d8531dfe7e09ee2ad1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfOrientationList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfOrientationList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f95db5bc5939fdd3ebf678e08354caa9d0c0c052d7f147b44b3371c57ad8114b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfOrientationOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d03cd5dcc2639b46af708bb731a38f7b7d9b45669f375355c363a330d9237f1b)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfOrientationOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f8c8b9a18f3f05c8f11a9b7cd1f102f1f3235802687877c2597db23021d0834a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6df316c5cb51f9f1758eeaff57c9fa2afd8c012f7ffb1373e8bfaa6d2c8c8686)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8658a19631c07bbf488e0f49fa82ecacbcbe8ba70316568c62bd07028a62ac86)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfOrientation]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfOrientation]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__21f1e8240b701fa66db670bcbb181dfe96a88fc57ddb94fbbdc1864b975e91f7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfOrientationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfOrientationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__12fe74b8a7f73fcc542d8bf444c054c144773624fc41606413af2b7884c310af)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfOrientationDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putLandscape")
    def put_landscape(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfOrientationLandscape()

        return typing.cast(None, jsii.invoke(self, "putLandscape", [value]))

    @jsii.member(jsii_name="putPortrait")
    def put_portrait(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfOrientationPortrait()

        return typing.cast(None, jsii.invoke(self, "putPortrait", [value]))

    @jsii.member(jsii_name="putSquare")
    def put_square(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfOrientationSquare()

        return typing.cast(None, jsii.invoke(self, "putSquare", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetLandscape")
    def reset_landscape(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLandscape", []))

    @jsii.member(jsii_name="resetPortrait")
    def reset_portrait(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPortrait", []))

    @jsii.member(jsii_name="resetSquare")
    def reset_square(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSquare", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfOrientationDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfOrientationDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="landscape")
    def landscape(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfOrientationLandscapeOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfOrientationLandscapeOutputReference, jsii.get(self, "landscape"))

    @builtins.property
    @jsii.member(jsii_name="portrait")
    def portrait(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfOrientationPortraitOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfOrientationPortraitOutputReference", jsii.get(self, "portrait"))

    @builtins.property
    @jsii.member(jsii_name="square")
    def square(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfOrientationSquareOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfOrientationSquareOutputReference", jsii.get(self, "square"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfOrientationDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="landscapeInput")
    def landscape_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfOrientationLandscape], jsii.get(self, "landscapeInput"))

    @builtins.property
    @jsii.member(jsii_name="portraitInput")
    def portrait_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfOrientationPortrait"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfOrientationPortrait"], jsii.get(self, "portraitInput"))

    @builtins.property
    @jsii.member(jsii_name="squareInput")
    def square_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfOrientationSquare"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfOrientationSquare"], jsii.get(self, "squareInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfOrientation]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfOrientation]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfOrientation]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8f6f8cbc327ee0b3b4c66ba8977d03a567c58016a3e5658f45084ba558c97249)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfOrientationPortrait",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfOrientationPortrait:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfOrientationPortrait(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfOrientationPortraitOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfOrientationPortraitOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f79d6e204c192b94e6fe99520245cd3fa39e0ab8a80502c8e009ca598eff9082)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfOrientationPortrait]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfOrientationPortrait], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfOrientationPortrait],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cbfaf2cb01717833582fe8d012ad99551c6807cf988317477c80f00870937b87)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfOrientationSquare",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfOrientationSquare:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfOrientationSquare(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfOrientationSquareOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfOrientationSquareOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__367fb6fd0a761c08b081b96a054045686f04a64b09636a3977fc07989329ddef)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfOrientationSquare]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfOrientationSquare], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfOrientationSquare],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd2cf9eb8b21861d193497b5df77df24b2dfe84604a0456fa8423df48c43f44b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanImQuery",
    jsii_struct_bases=[],
    name_mapping={
        "allowed_transformations": "allowedTransformations",
        "query_var": "queryVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanImQuery:
    def __init__(
        self,
        *,
        allowed_transformations: typing.Sequence[builtins.str],
        query_var: builtins.str,
    ) -> None:
        '''
        :param allowed_transformations: Specifies the transformations that can be applied using the query string parameter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allowed_transformations DataAkamaiImagingPolicyImage#allowed_transformations}
        :param query_var: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#query_var DataAkamaiImagingPolicyImage#query_var}.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__67eed6e19818afd7c64e74129395d6d47a86f6a00dd277310385dd915b2df305)
            check_type(argname="argument allowed_transformations", value=allowed_transformations, expected_type=type_hints["allowed_transformations"])
            check_type(argname="argument query_var", value=query_var, expected_type=type_hints["query_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "allowed_transformations": allowed_transformations,
            "query_var": query_var,
        }

    @builtins.property
    def allowed_transformations(self) -> typing.List[builtins.str]:
        '''Specifies the transformations that can be applied using the query string parameter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allowed_transformations DataAkamaiImagingPolicyImage#allowed_transformations}
        '''
        result = self._values.get("allowed_transformations")
        assert result is not None, "Required property 'allowed_transformations' is missing"
        return typing.cast(typing.List[builtins.str], result)

    @builtins.property
    def query_var(self) -> builtins.str:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#query_var DataAkamaiImagingPolicyImage#query_var}.'''
        result = self._values.get("query_var")
        assert result is not None, "Required property 'query_var' is missing"
        return typing.cast(builtins.str, result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanImQuery(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanImQueryList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanImQueryList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0456870a1b78c2bdbf28211d216a95c2b0c2ade5a853a18cc4d2116132b1fad7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanImQueryOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4d13ea839170b708dd828e6151692be961d79f7e8251b19aa3ad0b5c184e8fd9)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanImQueryOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__edd6a9b587f662eb62d13ab206a8b2f4a9c070a02460992b669f104a624100b3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4d767429c8405159216ac4e1358a4f3cca38488eb63cf534f5c07b516af657bf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f5c5f7d63aaf7872b0788f2f200a92c56cc7fd5716ca5c0026d5254f31f2e850)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanImQuery]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanImQuery]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanImQuery]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ae02bc899d89c32959e925348d8c3ab95d9aa9eca0957c7aa3f9f81465495d1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanImQueryOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanImQueryOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af7dde8672a4ea24c8b0c67ca3b9918986ba4106ecfdefdc476b2f864ba5d6ab)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @builtins.property
    @jsii.member(jsii_name="allowedTransformationsInput")
    def allowed_transformations_input(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "allowedTransformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="queryVarInput")
    def query_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "queryVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowedTransformations")
    def allowed_transformations(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "allowedTransformations"))

    @allowed_transformations.setter
    def allowed_transformations(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__77b009d2ce9e9c1fd9bc8f02d5b762f41ff6364ef12f2ddeadb85e2d3047b085)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowedTransformations", value)

    @builtins.property
    @jsii.member(jsii_name="queryVar")
    def query_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "queryVar"))

    @query_var.setter
    def query_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__819d5f59db8a3af847d7bb1cd9ff83b26156cfc1b34ed1e71b0f193f9ab256d8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "queryVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanImQuery]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanImQuery]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanImQuery]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ee266953a84df57522840ecb62841c136e80893eb19e4d37d97d96d157ee68c0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanMaxColors",
    jsii_struct_bases=[],
    name_mapping={"colors": "colors", "colors_var": "colorsVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanMaxColors:
    def __init__(
        self,
        *,
        colors: typing.Optional[builtins.str] = None,
        colors_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param colors: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        :param colors_var: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1704aeb6dcda6e4b31c0ea22ccb798f30e4dec03a395586acd79422cd8d6e6cd)
            check_type(argname="argument colors", value=colors, expected_type=type_hints["colors"])
            check_type(argname="argument colors_var", value=colors_var, expected_type=type_hints["colors_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if colors is not None:
            self._values["colors"] = colors
        if colors_var is not None:
            self._values["colors_var"] = colors_var

    @builtins.property
    def colors(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        '''
        result = self._values.get("colors")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def colors_var(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        result = self._values.get("colors_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanMaxColors(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanMaxColorsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanMaxColorsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cffa0bcd4dbdc3911aa97917e82d4b062a2981e9a62234e4ee9b99b424f4ac3f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanMaxColorsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__21c660d40be2614d50e2928714160c40354977b838b2aca69e1c740cc2f27339)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanMaxColorsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9880b2877193b3757e6e250c5c6c552efc86a0ccbd9e8999522921c8dc5d8d02)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f9f33a122bbf3b7695625890a0ec78375dba9b713b935d427c590632ad32d648)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__226613f97031044947f27c21ed410baeed937265de70cb88db0abbeb060e33c9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanMaxColors]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanMaxColors]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea49e6c9c9699d7473b23e35cab509c5c531a412b8c74041106553fed7276df1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanMaxColorsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanMaxColorsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c6e722ff5be583199178ca66866df57a12a01170b51ca76e175e6e469e5d318f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColors")
    def reset_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColors", []))

    @jsii.member(jsii_name="resetColorsVar")
    def reset_colors_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorsVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorsInput")
    def colors_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsInput"))

    @builtins.property
    @jsii.member(jsii_name="colorsVarInput")
    def colors_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsVarInput"))

    @builtins.property
    @jsii.member(jsii_name="colors")
    def colors(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colors"))

    @colors.setter
    def colors(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3d25e6f389bef04ac60a79f4f29d1773c1d52a9c979ecf4967164e81dab3f263)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colors", value)

    @builtins.property
    @jsii.member(jsii_name="colorsVar")
    def colors_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorsVar"))

    @colors_var.setter
    def colors_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6dd206f4ca4154c385ba1b64e890e4e9a423cd9c3edbeb706517e12e9682b2e8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorsVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanMaxColors]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanMaxColors]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanMaxColors]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a561699922e14a1b63143db8d627f3c27b234ff5d45c68a5af42395eb533376b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanMirror",
    jsii_struct_bases=[],
    name_mapping={
        "horizontal": "horizontal",
        "horizontal_var": "horizontalVar",
        "vertical": "vertical",
        "vertical_var": "verticalVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanMirror:
    def __init__(
        self,
        *,
        horizontal: typing.Optional[builtins.str] = None,
        horizontal_var: typing.Optional[builtins.str] = None,
        vertical: typing.Optional[builtins.str] = None,
        vertical_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param horizontal: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        :param horizontal_var: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        :param vertical: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        :param vertical_var: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d4009b91b91da128d69c770bbe7b64412e3dd57c31f3a62026ff1c1f9a938a43)
            check_type(argname="argument horizontal", value=horizontal, expected_type=type_hints["horizontal"])
            check_type(argname="argument horizontal_var", value=horizontal_var, expected_type=type_hints["horizontal_var"])
            check_type(argname="argument vertical", value=vertical, expected_type=type_hints["vertical"])
            check_type(argname="argument vertical_var", value=vertical_var, expected_type=type_hints["vertical_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if horizontal is not None:
            self._values["horizontal"] = horizontal
        if horizontal_var is not None:
            self._values["horizontal_var"] = horizontal_var
        if vertical is not None:
            self._values["vertical"] = vertical
        if vertical_var is not None:
            self._values["vertical_var"] = vertical_var

    @builtins.property
    def horizontal(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        '''
        result = self._values.get("horizontal")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def horizontal_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        '''
        result = self._values.get("horizontal_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        '''
        result = self._values.get("vertical")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        result = self._values.get("vertical_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanMirror(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanMirrorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanMirrorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__67a064a178bfc08856130c7165c998e807458501cf529aaec408b2942b320489)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanMirrorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__03c7462e414b0bf13050718d5028c1d8ea48278a30692384531095013693fb52)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanMirrorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dd4f0df75511f7ee5867004e41d1c8bcefae3a9cdf83410fa690e9e4937f13ba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9b39729df5c7b337d6a2853be6a6ac54fcef3d2f5fccb7fab5e1c54d85e41a14)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cac01a855116efc308ef57a3513d10e0ba5e2db129dcf82fec5b4b1a6e25daf5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanMirror]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanMirror]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e3504be416718ff0ffb5d7ddd41416bede0e22d7af48e55bdb6a1e730495647f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanMirrorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanMirrorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b1afa0329d31d6b4fc37f8bc6b2ab9fb0a2351d0949a617dbfbfd71ace2dafc5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHorizontal")
    def reset_horizontal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontal", []))

    @jsii.member(jsii_name="resetHorizontalVar")
    def reset_horizontal_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontalVar", []))

    @jsii.member(jsii_name="resetVertical")
    def reset_vertical(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVertical", []))

    @jsii.member(jsii_name="resetVerticalVar")
    def reset_vertical_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVerticalVar", []))

    @builtins.property
    @jsii.member(jsii_name="horizontalInput")
    def horizontal_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontalVarInput")
    def horizontal_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalInput")
    def vertical_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalVarInput")
    def vertical_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontal")
    def horizontal(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontal"))

    @horizontal.setter
    def horizontal(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d8ac136079bd29892498d625a08c1567128867b359e9a4e481037c2e4a12d240)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontal", value)

    @builtins.property
    @jsii.member(jsii_name="horizontalVar")
    def horizontal_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontalVar"))

    @horizontal_var.setter
    def horizontal_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__44d48ccb3eec2a6c8b53b9479e1255501b77dc2534e4fb6647df4129b6e11a05)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontalVar", value)

    @builtins.property
    @jsii.member(jsii_name="vertical")
    def vertical(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "vertical"))

    @vertical.setter
    def vertical(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6d60778ee8d0ea61b4c055fe56e31e52751ff1f825528d352dbce9421123a1f8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "vertical", value)

    @builtins.property
    @jsii.member(jsii_name="verticalVar")
    def vertical_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "verticalVar"))

    @vertical_var.setter
    def vertical_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__25adc4126209cdb07592931d13c01c15733d1043ff9826be5965aff5ce03a7ca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "verticalVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanMirror]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanMirror]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanMirror]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__66dd47d48137872b8207d1cb8ebc4b47fc790cf174d5c3c6a08d4eabadd55c59)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanMonoHue",
    jsii_struct_bases=[],
    name_mapping={"hue": "hue", "hue_var": "hueVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanMonoHue:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c16c0accd5f275c32e85a61e6f4af2212a6f17094873279be0da319cba3fa382)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanMonoHue(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanMonoHueList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanMonoHueList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__896bb3cdf80b09a2ccb6196654c3a66c8b58a538f2d12fca261093d4c50e1b2c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanMonoHueOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fe8684e36410655129af9f64478c2bb7c1c1340d2ffc1d4c1096779ed8270472)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanMonoHueOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1af021b8657460996293601e8a75e988a2d1f7e384d0c890e1a556ba4ee8e9f1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3fcf3fd33629e05e016f1b8e6c2dbeba63630df02c81878c1a01b78d2a4d7faf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab4c85da2006d12b22780503297073dd911f836318826e4f48cf8af2ac80bfb4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanMonoHue]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanMonoHue]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f56cfcb3f3029a10c2953feb8436d01c7061d7ad54fcf44bf5e513807346bec9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanMonoHueOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanMonoHueOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8caf6c314fa4c92aefb8f3f43b057819f27d7a05dc5f012b50928f664d00d3dd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e260c3e028747047458517682aca0559151ec69d5eb226773974c3efcdf20e23)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c50b671914b60b7b336a893e2b76ce47cb8743d879a0723f6f25d72322f4d876)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanMonoHue]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanMonoHue]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanMonoHue]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__467a65af2d4c6b0e8a597138c50e0c90d044dca60ecde0cda9118fd60cdbd330)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanOpacity",
    jsii_struct_bases=[],
    name_mapping={"opacity": "opacity", "opacity_var": "opacityVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanOpacity:
    def __init__(
        self,
        *,
        opacity: typing.Optional[builtins.str] = None,
        opacity_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param opacity: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param opacity_var: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d81f3d9490ac6f70a333a171fedb7e21debb55cb17b9a6e94c7f1c8aa72362c)
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument opacity_var", value=opacity_var, expected_type=type_hints["opacity_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if opacity is not None:
            self._values["opacity"] = opacity
        if opacity_var is not None:
            self._values["opacity_var"] = opacity_var

    @builtins.property
    def opacity(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def opacity_var(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        result = self._values.get("opacity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanOpacity(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanOpacityList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanOpacityList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b612fc9d6ec3be8fd3cbef6f80a5cdba8042610d51e128a1eec29b846c62482c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanOpacityOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d12aec85595dd340e15ba206841e929dd2f83ea783a169c622f1e198c7267ddd)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanOpacityOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8fed159c9a766e4aa98867753adcdfd02163fd60982273545fe0cfc8e550209a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1ec4252b1bbc7cf962de99fe08d3e9dd69eee7c26bf9c3b06eecbd650a3c290c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f656aceeff3f47d344193051748c61cd1d95a9d8149b079dc0194fb77fa5ef31)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanOpacity]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanOpacity]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__65b2e749e7dad047e834d569eec4f33e7af3c71b80bce721b44ce195f1db6a45)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanOpacityOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanOpacityOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__772aa4bb459f8bbc6c767e437ee7a3d2795309ee949743a3382c0fb722d2bfe1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetOpacityVar")
    def reset_opacity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacityVar", []))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityVarInput")
    def opacity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacity"))

    @opacity.setter
    def opacity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__78744e2e99bce67bf00c552c2799ca83358a7c8b3e8dd81eab3a32980b7b88fe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacity", value)

    @builtins.property
    @jsii.member(jsii_name="opacityVar")
    def opacity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacityVar"))

    @opacity_var.setter
    def opacity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a7a99265c0155b2a108224e5d201397ba29fd44233350cf8dbfcbb2e9311cb8f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacityVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanOpacity]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanOpacity]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanOpacity]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__de990d84f36ec567c759e1b00816732755feed73acdbca64d478f127ea027d7d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c6a3b75a32517a616ce553a93ef8f0d9112c3ce160f8a7069b96085be6ad00fa)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putAppend")
    def put_append(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanAppend, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cf2b6628fa084727537bb134bda6bcbad1c00c0a1f784c81b6d212db5af95a0d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putAppend", [value]))

    @jsii.member(jsii_name="putAspectCrop")
    def put_aspect_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanAspectCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__54d4ed1b65217005a199351e540838becfb75e71bc986698b166cbec92138b96)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putAspectCrop", [value]))

    @jsii.member(jsii_name="putBackgroundColor")
    def put_background_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eb09a590aa25d1c2fabfa042becbf166b8ada20d44df867f9921b3f6443f3d11)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBackgroundColor", [value]))

    @jsii.member(jsii_name="putBlur")
    def put_blur(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanBlur, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9277994a85ee5e149d34bdc8a4899ca0c3234a97cdbee42ab0a26905b4677ca1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBlur", [value]))

    @jsii.member(jsii_name="putChromaKey")
    def put_chroma_key(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanChromaKey, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ddb2daaf84c6b56d8196bc6e6e56daf6320fd12b4310062ed40cd90b2bbcd74)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putChromaKey", [value]))

    @jsii.member(jsii_name="putComposite")
    def put_composite(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanComposite, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ad284ae52b75956cb64dff64f4ef216abb8b379821b3b1b98f30ba0272e1b8cb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putComposite", [value]))

    @jsii.member(jsii_name="putCompound")
    def put_compound(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanCompound, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dd6b51cedfc00c6640b89f95020e355d2635a468a534f88053ae3bc2d111839d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCompound", [value]))

    @jsii.member(jsii_name="putContrast")
    def put_contrast(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanContrast, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__30441a58c7c8d3ca21183905464bc9714997c77ae6288179b24c0f3586c09b18)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putContrast", [value]))

    @jsii.member(jsii_name="putCrop")
    def put_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b01c3eb73fa30adbffc7b44fd62dbfdaf06fec6d9d2d42c43f3c7721f922010f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCrop", [value]))

    @jsii.member(jsii_name="putFaceCrop")
    def put_face_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanFaceCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__da948ea8ede16eac3bf5b8f48e8ee8b761bd305b1427cce4a3888defa2e2662d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFaceCrop", [value]))

    @jsii.member(jsii_name="putFeatureCrop")
    def put_feature_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanFeatureCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__740c1ae5566df5e6c2e98918e5ad140c63b4bce2f6f21ad5e1bbc9ba86f2ecaf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFeatureCrop", [value]))

    @jsii.member(jsii_name="putFitAndFill")
    def put_fit_and_fill(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanFitAndFill, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7e35e4d634fbe9933d47fefefe6b01fdd30a94be05eacb2a083d78fcdd7131d7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFitAndFill", [value]))

    @jsii.member(jsii_name="putGoop")
    def put_goop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanGoop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ffbc06f4a1584af0b784b2d4c0baca6183202ad321bb178461704633c1411f25)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGoop", [value]))

    @jsii.member(jsii_name="putGrayscale")
    def put_grayscale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanGrayscale, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__acec96e8a8deacf66d7648c9be14a86772be2e564856d06e6537a98b724676bf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGrayscale", [value]))

    @jsii.member(jsii_name="putHsl")
    def put_hsl(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanHsl, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e6b1a385eef2e534091b779b9433e670c8729a18aab03058fa95976a82ba3b67)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsl", [value]))

    @jsii.member(jsii_name="putHsv")
    def put_hsv(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanHsv, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__00d9001af373cb7c5291077d4b38d315ee2a428675a9c818b2000df8eb190b04)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsv", [value]))

    @jsii.member(jsii_name="putIfDimension")
    def put_if_dimension(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfDimension, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__27c441c5dc8c9ed5f220af0807b3fc937e64130a1a41a7805cd3a2df2b4b547a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfDimension", [value]))

    @jsii.member(jsii_name="putIfOrientation")
    def put_if_orientation(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__901dd1b8c62264791c6f7d4d9457084dc80df8e3b80641c9718d0af90ac9b7ba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfOrientation", [value]))

    @jsii.member(jsii_name="putImQuery")
    def put_im_query(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanImQuery, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__193aba2f181da7d27c7db2109fd3b52170d21c1a046a20c0f5c94de6d9a689c6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putImQuery", [value]))

    @jsii.member(jsii_name="putMaxColors")
    def put_max_colors(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanMaxColors, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__56f6fe51f136864e365b757d9e1c853cd8fa25534f594b8e60f365f8b4b6dc10)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMaxColors", [value]))

    @jsii.member(jsii_name="putMirror")
    def put_mirror(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanMirror, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cf8c57d5a7607b446f22690ba0b22d73a0c081bfadeb1844401f89e8fcb917ad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMirror", [value]))

    @jsii.member(jsii_name="putMonoHue")
    def put_mono_hue(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanMonoHue, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d8fc45beea0a008a2aaa8ac8b0374425ca0cefef88a2ec84ca24cfd54f492d46)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMonoHue", [value]))

    @jsii.member(jsii_name="putOpacity")
    def put_opacity(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanOpacity, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be278e021c5ab216c4d6f44dc930c8f4ed2ba11267f9819c9135f98f1a8b79f8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putOpacity", [value]))

    @jsii.member(jsii_name="putRegionOfInterestCrop")
    def put_region_of_interest_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanRegionOfInterestCrop", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ddba36064a60f442ea397f0d3809c811f7ee68a03c5baf23ad3c242167ec27bf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRegionOfInterestCrop", [value]))

    @jsii.member(jsii_name="putRelativeCrop")
    def put_relative_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanRelativeCrop", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__44b37bdfd7b76ecb5aa42e16571093b5ebe964bec3ae3e20952366285854b4e7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRelativeCrop", [value]))

    @jsii.member(jsii_name="putRemoveColor")
    def put_remove_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanRemoveColor", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9f4cf77ab15095e953f2a19d01a0075e00e684d455b255d8885ad7e894d55acf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRemoveColor", [value]))

    @jsii.member(jsii_name="putResize")
    def put_resize(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanResize", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8ecb3d939816f0a7898cf1d95345058135641a44bfcb8587b7718a7aee3987e0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putResize", [value]))

    @jsii.member(jsii_name="putRotate")
    def put_rotate(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanRotate", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__33f003d2e42423bf27b63d431c0162f32d324e40cf1e6304328c514e107e5960)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRotate", [value]))

    @jsii.member(jsii_name="putScale")
    def put_scale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanScale", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9af0ac6a1578456b2d01ebd8abb5bce9d5914ac13938e8ca23ae5516464e6f15)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putScale", [value]))

    @jsii.member(jsii_name="putShear")
    def put_shear(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanShear", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__92f87ac7de159cdcdfd7a6d5b82c5e2c79f749b0f93f8abc0b4899755aa2ea11)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putShear", [value]))

    @jsii.member(jsii_name="putTrim")
    def put_trim(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanTrim", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8acb916cb0eb123c7137db80323848e95d54bb9d58415eca3ba0d8389199703a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTrim", [value]))

    @jsii.member(jsii_name="putUnsharpMask")
    def put_unsharp_mask(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanUnsharpMask", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__647647a0d4b70f7d7412ee38b3df4bfc5c78a5de29dfe123ee17c96833e68870)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putUnsharpMask", [value]))

    @jsii.member(jsii_name="resetAppend")
    def reset_append(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAppend", []))

    @jsii.member(jsii_name="resetAspectCrop")
    def reset_aspect_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspectCrop", []))

    @jsii.member(jsii_name="resetBackgroundColor")
    def reset_background_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBackgroundColor", []))

    @jsii.member(jsii_name="resetBlur")
    def reset_blur(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBlur", []))

    @jsii.member(jsii_name="resetChromaKey")
    def reset_chroma_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChromaKey", []))

    @jsii.member(jsii_name="resetComposite")
    def reset_composite(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetComposite", []))

    @jsii.member(jsii_name="resetCompound")
    def reset_compound(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCompound", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetCrop")
    def reset_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCrop", []))

    @jsii.member(jsii_name="resetFaceCrop")
    def reset_face_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFaceCrop", []))

    @jsii.member(jsii_name="resetFeatureCrop")
    def reset_feature_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureCrop", []))

    @jsii.member(jsii_name="resetFitAndFill")
    def reset_fit_and_fill(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFitAndFill", []))

    @jsii.member(jsii_name="resetGoop")
    def reset_goop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGoop", []))

    @jsii.member(jsii_name="resetGrayscale")
    def reset_grayscale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGrayscale", []))

    @jsii.member(jsii_name="resetHsl")
    def reset_hsl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsl", []))

    @jsii.member(jsii_name="resetHsv")
    def reset_hsv(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsv", []))

    @jsii.member(jsii_name="resetIfDimension")
    def reset_if_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfDimension", []))

    @jsii.member(jsii_name="resetIfOrientation")
    def reset_if_orientation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfOrientation", []))

    @jsii.member(jsii_name="resetImQuery")
    def reset_im_query(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetImQuery", []))

    @jsii.member(jsii_name="resetMaxColors")
    def reset_max_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxColors", []))

    @jsii.member(jsii_name="resetMirror")
    def reset_mirror(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMirror", []))

    @jsii.member(jsii_name="resetMonoHue")
    def reset_mono_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonoHue", []))

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetRegionOfInterestCrop")
    def reset_region_of_interest_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRegionOfInterestCrop", []))

    @jsii.member(jsii_name="resetRelativeCrop")
    def reset_relative_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRelativeCrop", []))

    @jsii.member(jsii_name="resetRemoveColor")
    def reset_remove_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRemoveColor", []))

    @jsii.member(jsii_name="resetResize")
    def reset_resize(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetResize", []))

    @jsii.member(jsii_name="resetRotate")
    def reset_rotate(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRotate", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetShear")
    def reset_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetShear", []))

    @jsii.member(jsii_name="resetTrim")
    def reset_trim(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTrim", []))

    @jsii.member(jsii_name="resetUnsharpMask")
    def reset_unsharp_mask(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUnsharpMask", []))

    @builtins.property
    @jsii.member(jsii_name="append")
    def append(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanAppendList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanAppendList, jsii.get(self, "append"))

    @builtins.property
    @jsii.member(jsii_name="aspectCrop")
    def aspect_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanAspectCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanAspectCropList, jsii.get(self, "aspectCrop"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColor")
    def background_color(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanBackgroundColorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanBackgroundColorList, jsii.get(self, "backgroundColor"))

    @builtins.property
    @jsii.member(jsii_name="blur")
    def blur(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanBlurList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanBlurList, jsii.get(self, "blur"))

    @builtins.property
    @jsii.member(jsii_name="chromaKey")
    def chroma_key(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanChromaKeyList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanChromaKeyList, jsii.get(self, "chromaKey"))

    @builtins.property
    @jsii.member(jsii_name="composite")
    def composite(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanCompositeList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanCompositeList, jsii.get(self, "composite"))

    @builtins.property
    @jsii.member(jsii_name="compound")
    def compound(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanCompoundList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanCompoundList, jsii.get(self, "compound"))

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanContrastList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanContrastList, jsii.get(self, "contrast"))

    @builtins.property
    @jsii.member(jsii_name="crop")
    def crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanCropList, jsii.get(self, "crop"))

    @builtins.property
    @jsii.member(jsii_name="faceCrop")
    def face_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanFaceCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanFaceCropList, jsii.get(self, "faceCrop"))

    @builtins.property
    @jsii.member(jsii_name="featureCrop")
    def feature_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanFeatureCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanFeatureCropList, jsii.get(self, "featureCrop"))

    @builtins.property
    @jsii.member(jsii_name="fitAndFill")
    def fit_and_fill(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanFitAndFillList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanFitAndFillList, jsii.get(self, "fitAndFill"))

    @builtins.property
    @jsii.member(jsii_name="goop")
    def goop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanGoopList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanGoopList, jsii.get(self, "goop"))

    @builtins.property
    @jsii.member(jsii_name="grayscale")
    def grayscale(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanGrayscaleList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanGrayscaleList, jsii.get(self, "grayscale"))

    @builtins.property
    @jsii.member(jsii_name="hsl")
    def hsl(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanHslList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanHslList, jsii.get(self, "hsl"))

    @builtins.property
    @jsii.member(jsii_name="hsv")
    def hsv(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanHsvList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanHsvList, jsii.get(self, "hsv"))

    @builtins.property
    @jsii.member(jsii_name="ifDimension")
    def if_dimension(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfDimensionList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfDimensionList, jsii.get(self, "ifDimension"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientation")
    def if_orientation(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfOrientationList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfOrientationList, jsii.get(self, "ifOrientation"))

    @builtins.property
    @jsii.member(jsii_name="imQuery")
    def im_query(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanImQueryList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanImQueryList, jsii.get(self, "imQuery"))

    @builtins.property
    @jsii.member(jsii_name="maxColors")
    def max_colors(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanMaxColorsList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanMaxColorsList, jsii.get(self, "maxColors"))

    @builtins.property
    @jsii.member(jsii_name="mirror")
    def mirror(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanMirrorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanMirrorList, jsii.get(self, "mirror"))

    @builtins.property
    @jsii.member(jsii_name="monoHue")
    def mono_hue(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanMonoHueList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanMonoHueList, jsii.get(self, "monoHue"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanOpacityList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanOpacityList, jsii.get(self, "opacity"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestCrop")
    def region_of_interest_crop(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanRegionOfInterestCropList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanRegionOfInterestCropList", jsii.get(self, "regionOfInterestCrop"))

    @builtins.property
    @jsii.member(jsii_name="relativeCrop")
    def relative_crop(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanRelativeCropList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanRelativeCropList", jsii.get(self, "relativeCrop"))

    @builtins.property
    @jsii.member(jsii_name="removeColor")
    def remove_color(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanRemoveColorList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanRemoveColorList", jsii.get(self, "removeColor"))

    @builtins.property
    @jsii.member(jsii_name="resize")
    def resize(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanResizeList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanResizeList", jsii.get(self, "resize"))

    @builtins.property
    @jsii.member(jsii_name="rotate")
    def rotate(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanRotateList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanRotateList", jsii.get(self, "rotate"))

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanScaleList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanScaleList", jsii.get(self, "scale"))

    @builtins.property
    @jsii.member(jsii_name="shear")
    def shear(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanShearList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanShearList", jsii.get(self, "shear"))

    @builtins.property
    @jsii.member(jsii_name="trim")
    def trim(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanTrimList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanTrimList", jsii.get(self, "trim"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMask")
    def unsharp_mask(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanUnsharpMaskList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanUnsharpMaskList", jsii.get(self, "unsharpMask"))

    @builtins.property
    @jsii.member(jsii_name="appendInput")
    def append_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanAppend]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanAppend]]], jsii.get(self, "appendInput"))

    @builtins.property
    @jsii.member(jsii_name="aspectCropInput")
    def aspect_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanAspectCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanAspectCrop]]], jsii.get(self, "aspectCropInput"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColorInput")
    def background_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanBackgroundColor]]], jsii.get(self, "backgroundColorInput"))

    @builtins.property
    @jsii.member(jsii_name="blurInput")
    def blur_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanBlur]]], jsii.get(self, "blurInput"))

    @builtins.property
    @jsii.member(jsii_name="chromaKeyInput")
    def chroma_key_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanChromaKey]]], jsii.get(self, "chromaKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="compositeInput")
    def composite_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanComposite]]], jsii.get(self, "compositeInput"))

    @builtins.property
    @jsii.member(jsii_name="compoundInput")
    def compound_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanCompound]]], jsii.get(self, "compoundInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanContrast]]], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="cropInput")
    def crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanCrop]]], jsii.get(self, "cropInput"))

    @builtins.property
    @jsii.member(jsii_name="faceCropInput")
    def face_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanFaceCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanFaceCrop]]], jsii.get(self, "faceCropInput"))

    @builtins.property
    @jsii.member(jsii_name="featureCropInput")
    def feature_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanFeatureCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanFeatureCrop]]], jsii.get(self, "featureCropInput"))

    @builtins.property
    @jsii.member(jsii_name="fitAndFillInput")
    def fit_and_fill_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanFitAndFill]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanFitAndFill]]], jsii.get(self, "fitAndFillInput"))

    @builtins.property
    @jsii.member(jsii_name="goopInput")
    def goop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanGoop]]], jsii.get(self, "goopInput"))

    @builtins.property
    @jsii.member(jsii_name="grayscaleInput")
    def grayscale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanGrayscale]]], jsii.get(self, "grayscaleInput"))

    @builtins.property
    @jsii.member(jsii_name="hslInput")
    def hsl_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanHsl]]], jsii.get(self, "hslInput"))

    @builtins.property
    @jsii.member(jsii_name="hsvInput")
    def hsv_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanHsv]]], jsii.get(self, "hsvInput"))

    @builtins.property
    @jsii.member(jsii_name="ifDimensionInput")
    def if_dimension_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfDimension]]], jsii.get(self, "ifDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientationInput")
    def if_orientation_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfOrientation]]], jsii.get(self, "ifOrientationInput"))

    @builtins.property
    @jsii.member(jsii_name="imQueryInput")
    def im_query_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanImQuery]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanImQuery]]], jsii.get(self, "imQueryInput"))

    @builtins.property
    @jsii.member(jsii_name="maxColorsInput")
    def max_colors_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanMaxColors]]], jsii.get(self, "maxColorsInput"))

    @builtins.property
    @jsii.member(jsii_name="mirrorInput")
    def mirror_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanMirror]]], jsii.get(self, "mirrorInput"))

    @builtins.property
    @jsii.member(jsii_name="monoHueInput")
    def mono_hue_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanMonoHue]]], jsii.get(self, "monoHueInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanOpacity]]], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestCropInput")
    def region_of_interest_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanRegionOfInterestCrop"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanRegionOfInterestCrop"]]], jsii.get(self, "regionOfInterestCropInput"))

    @builtins.property
    @jsii.member(jsii_name="relativeCropInput")
    def relative_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanRelativeCrop"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanRelativeCrop"]]], jsii.get(self, "relativeCropInput"))

    @builtins.property
    @jsii.member(jsii_name="removeColorInput")
    def remove_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanRemoveColor"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanRemoveColor"]]], jsii.get(self, "removeColorInput"))

    @builtins.property
    @jsii.member(jsii_name="resizeInput")
    def resize_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanResize"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanResize"]]], jsii.get(self, "resizeInput"))

    @builtins.property
    @jsii.member(jsii_name="rotateInput")
    def rotate_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanRotate"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanRotate"]]], jsii.get(self, "rotateInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanScale"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanScale"]]], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="shearInput")
    def shear_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanShear"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanShear"]]], jsii.get(self, "shearInput"))

    @builtins.property
    @jsii.member(jsii_name="trimInput")
    def trim_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanTrim"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanTrim"]]], jsii.get(self, "trimInput"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMaskInput")
    def unsharp_mask_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanUnsharpMask"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanUnsharpMask"]]], jsii.get(self, "unsharpMaskInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__33af0dd44dd8e241aa33a6151795dce46fda2968eff918f15cb3ec64f15c05eb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanRegionOfInterestCrop",
    jsii_struct_bases=[],
    name_mapping={
        "region_of_interest": "regionOfInterest",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanRegionOfInterestCrop:
    def __init__(
        self,
        *,
        region_of_interest: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanRegionOfInterestCropRegionOfInterest", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param region_of_interest: region_of_interest block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest DataAkamaiImagingPolicyImage#region_of_interest}
        :param gravity: The placement of the crop area relative to the specified area of interest. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: The placement of the crop area relative to the specified area of interest. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param style: Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(region_of_interest, dict):
            region_of_interest = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanRegionOfInterestCropRegionOfInterest(**region_of_interest)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__361c6b782885748a0d031ed6e7771997d6c3baf5283eca0c8f87135aa52d1c05)
            check_type(argname="argument region_of_interest", value=region_of_interest, expected_type=type_hints["region_of_interest"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "region_of_interest": region_of_interest,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def region_of_interest(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanRegionOfInterestCropRegionOfInterest":
        '''region_of_interest block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest DataAkamaiImagingPolicyImage#region_of_interest}
        '''
        result = self._values.get("region_of_interest")
        assert result is not None, "Required property 'region_of_interest' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanRegionOfInterestCropRegionOfInterest", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''The placement of the crop area relative to the specified area of interest.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''The placement of the crop area relative to the specified area of interest.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanRegionOfInterestCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanRegionOfInterestCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanRegionOfInterestCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c50d52a9a913ffd3dda9518b77b3c8ab6be1271128af855dff9f0bd3c3a1e007)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanRegionOfInterestCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__54365f06463d4aca02bc964a9987ce124ba68a9eb835aafaa171cd96d0acb8d6)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanRegionOfInterestCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0c071193403ccf8bb228357b3ee14dc3e21aa37e2910bdd94e0a7d8de57456df)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__15c94c0a22aaf5e087f2af74f0621e97589a47f99708eb55a342966cc4e9cefe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e6114267ede7e5cf1d691da05dd41d5c43417d23849daf322c4d0b8948bafb8a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanRegionOfInterestCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanRegionOfInterestCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanRegionOfInterestCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6811fa12d86aa854efbcfa05bcca2d626252399b4c36f8501ebdd6f851c46eb8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanRegionOfInterestCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanRegionOfInterestCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__519288de18be8ab67e6e590a99b0f4074df2d7f37fcfec79f627d04fead63c19)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putRegionOfInterest")
    def put_region_of_interest(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanRegionOfInterestCropRegionOfInterest()

        return typing.cast(None, jsii.invoke(self, "putRegionOfInterest", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterest")
    def region_of_interest(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanRegionOfInterestCropRegionOfInterestOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanRegionOfInterestCropRegionOfInterestOutputReference", jsii.get(self, "regionOfInterest"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestInput")
    def region_of_interest_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanRegionOfInterestCropRegionOfInterest"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanRegionOfInterestCropRegionOfInterest"], jsii.get(self, "regionOfInterestInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2afde622c7a6e1af6f06ca12b0f9c58f723223200a3754c164381da91d53b91c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9f72a7009339bd364e6259b94380e462853c28f868aa7598c1d13ad3e392f68c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5e97b7747272b008071b6da23324301614f84f300f5ff59d320ee76e92e8d802)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__37d2080fc4599be4881304e79298c4e55dba5bdc9099cb7ba65f96921b95db1e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aaed7fd7487863bdd10265a13d50d3c6c87c2f60b82058a118ba916e10a6ec53)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e11e9a92313370509e7c02ccaf8a7c093c44ea9a3c8a6dd58770209af2be06b8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c8e474fda5ab97ea0d7047987686ef89dfe79e3b0db4a724789243e252515940)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5218493419289e40226354203ddc9214495ad9894f1d662df307d4cc95543812)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanRegionOfInterestCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanRegionOfInterestCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanRegionOfInterestCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d5cbef2090da6ddd354d371f7fccc9b8b12b927041d60e7c1c58578952bb3b41)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanRegionOfInterestCropRegionOfInterest",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanRegionOfInterestCropRegionOfInterest:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanRegionOfInterestCropRegionOfInterest(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanRegionOfInterestCropRegionOfInterestOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanRegionOfInterestCropRegionOfInterestOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e8f93783cdd8c2ecb602d1675944346236dca437ef37928768a5835003d3020d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanRegionOfInterestCropRegionOfInterest]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanRegionOfInterestCropRegionOfInterest], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanRegionOfInterestCropRegionOfInterest],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d08b272b783fd448b8a9e2e557833aad23f43a33961fc64e51d845d08a7758d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanRelativeCrop",
    jsii_struct_bases=[],
    name_mapping={
        "east": "east",
        "east_var": "eastVar",
        "north": "north",
        "north_var": "northVar",
        "south": "south",
        "south_var": "southVar",
        "west": "west",
        "west_var": "westVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanRelativeCrop:
    def __init__(
        self,
        *,
        east: typing.Optional[builtins.str] = None,
        east_var: typing.Optional[builtins.str] = None,
        north: typing.Optional[builtins.str] = None,
        north_var: typing.Optional[builtins.str] = None,
        south: typing.Optional[builtins.str] = None,
        south_var: typing.Optional[builtins.str] = None,
        west: typing.Optional[builtins.str] = None,
        west_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param east: The number of pixels to shrink or expand the right side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east DataAkamaiImagingPolicyImage#east}
        :param east_var: The number of pixels to shrink or expand the right side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east_var DataAkamaiImagingPolicyImage#east_var}
        :param north: The number of pixels to shrink or expand the top side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north DataAkamaiImagingPolicyImage#north}
        :param north_var: The number of pixels to shrink or expand the top side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north_var DataAkamaiImagingPolicyImage#north_var}
        :param south: The number of pixels to shrink or expand the bottom side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south DataAkamaiImagingPolicyImage#south}
        :param south_var: The number of pixels to shrink or expand the bottom side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south_var DataAkamaiImagingPolicyImage#south_var}
        :param west: The number of pixels to shrink or expand the left side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west DataAkamaiImagingPolicyImage#west}
        :param west_var: The number of pixels to shrink or expand the left side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west_var DataAkamaiImagingPolicyImage#west_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0dabb5a0534ffc728f6344c73d407e0ce971ed8085f1ce240de058d1d1491684)
            check_type(argname="argument east", value=east, expected_type=type_hints["east"])
            check_type(argname="argument east_var", value=east_var, expected_type=type_hints["east_var"])
            check_type(argname="argument north", value=north, expected_type=type_hints["north"])
            check_type(argname="argument north_var", value=north_var, expected_type=type_hints["north_var"])
            check_type(argname="argument south", value=south, expected_type=type_hints["south"])
            check_type(argname="argument south_var", value=south_var, expected_type=type_hints["south_var"])
            check_type(argname="argument west", value=west, expected_type=type_hints["west"])
            check_type(argname="argument west_var", value=west_var, expected_type=type_hints["west_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if east is not None:
            self._values["east"] = east
        if east_var is not None:
            self._values["east_var"] = east_var
        if north is not None:
            self._values["north"] = north
        if north_var is not None:
            self._values["north_var"] = north_var
        if south is not None:
            self._values["south"] = south
        if south_var is not None:
            self._values["south_var"] = south_var
        if west is not None:
            self._values["west"] = west
        if west_var is not None:
            self._values["west_var"] = west_var

    @builtins.property
    def east(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the right side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east DataAkamaiImagingPolicyImage#east}
        '''
        result = self._values.get("east")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def east_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the right side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east_var DataAkamaiImagingPolicyImage#east_var}
        '''
        result = self._values.get("east_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def north(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the top side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north DataAkamaiImagingPolicyImage#north}
        '''
        result = self._values.get("north")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def north_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the top side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north_var DataAkamaiImagingPolicyImage#north_var}
        '''
        result = self._values.get("north_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def south(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the bottom side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south DataAkamaiImagingPolicyImage#south}
        '''
        result = self._values.get("south")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def south_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the bottom side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south_var DataAkamaiImagingPolicyImage#south_var}
        '''
        result = self._values.get("south_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def west(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the left side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west DataAkamaiImagingPolicyImage#west}
        '''
        result = self._values.get("west")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def west_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the left side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west_var DataAkamaiImagingPolicyImage#west_var}
        '''
        result = self._values.get("west_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanRelativeCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanRelativeCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanRelativeCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fe8115c1f7ec95f4c81c131525ade24f5dfaa30187dd492d910903deb119661b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanRelativeCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__045c169c04a61912ee64243df0cb087c8218565441de7d09fc9eb33acdee37b1)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanRelativeCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ffa53fc76d81af7e2408c1659028dd6ede5079b5d8fd388115a7200dba11634f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__905e17801d8cdab6743c1b017acf7e29bf298b20a015a307f4c87db8d4998f0e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b749e2651332f5e6221f50ba6a3146678375cbf221c5cda2a29494b5e812ecfa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanRelativeCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanRelativeCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanRelativeCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__900a23e99534758459baa6de4d0990525afefbf690bd27edacec615c271b55f3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanRelativeCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanRelativeCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a4ddb02700389bc7981c23350d8aee1623552aeb5a5563ea7e155330fd0b5d93)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetEast")
    def reset_east(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEast", []))

    @jsii.member(jsii_name="resetEastVar")
    def reset_east_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEastVar", []))

    @jsii.member(jsii_name="resetNorth")
    def reset_north(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNorth", []))

    @jsii.member(jsii_name="resetNorthVar")
    def reset_north_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNorthVar", []))

    @jsii.member(jsii_name="resetSouth")
    def reset_south(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSouth", []))

    @jsii.member(jsii_name="resetSouthVar")
    def reset_south_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSouthVar", []))

    @jsii.member(jsii_name="resetWest")
    def reset_west(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWest", []))

    @jsii.member(jsii_name="resetWestVar")
    def reset_west_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWestVar", []))

    @builtins.property
    @jsii.member(jsii_name="eastInput")
    def east_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "eastInput"))

    @builtins.property
    @jsii.member(jsii_name="eastVarInput")
    def east_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "eastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="northInput")
    def north_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "northInput"))

    @builtins.property
    @jsii.member(jsii_name="northVarInput")
    def north_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "northVarInput"))

    @builtins.property
    @jsii.member(jsii_name="southInput")
    def south_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "southInput"))

    @builtins.property
    @jsii.member(jsii_name="southVarInput")
    def south_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "southVarInput"))

    @builtins.property
    @jsii.member(jsii_name="westInput")
    def west_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "westInput"))

    @builtins.property
    @jsii.member(jsii_name="westVarInput")
    def west_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "westVarInput"))

    @builtins.property
    @jsii.member(jsii_name="east")
    def east(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "east"))

    @east.setter
    def east(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1398ef23db83193509942cf2651668ed370f521f0ea060410f984c2c32602001)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "east", value)

    @builtins.property
    @jsii.member(jsii_name="eastVar")
    def east_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "eastVar"))

    @east_var.setter
    def east_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__339980b383d30f16c25564c5d1546cd04757e97b94aac9ec08316b751d1475ad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "eastVar", value)

    @builtins.property
    @jsii.member(jsii_name="north")
    def north(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "north"))

    @north.setter
    def north(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__06cde8c9a77041cbdcf851bbf323614c62ad3b9136dea27a4e344eef2158cc36)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "north", value)

    @builtins.property
    @jsii.member(jsii_name="northVar")
    def north_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "northVar"))

    @north_var.setter
    def north_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__719e6899f158c32020cffcc10601560b07b88799c7c7fc2f7b7d969bf6d65d06)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "northVar", value)

    @builtins.property
    @jsii.member(jsii_name="south")
    def south(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "south"))

    @south.setter
    def south(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__97aa4468bba3297c4654a380d45c4bf9e27095cdadf643c2a0612323e6ddd5a2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "south", value)

    @builtins.property
    @jsii.member(jsii_name="southVar")
    def south_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "southVar"))

    @south_var.setter
    def south_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1a8e5b0fa5dc901e958ed19ad579a691de3b98b240a869b113fc8e6d9e4ae8bc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "southVar", value)

    @builtins.property
    @jsii.member(jsii_name="west")
    def west(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "west"))

    @west.setter
    def west(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d95bf96ce1ea9dcac94cd2907c30ac51d80998a4618f017426fd662ebc1856fe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "west", value)

    @builtins.property
    @jsii.member(jsii_name="westVar")
    def west_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "westVar"))

    @west_var.setter
    def west_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f4f2ec70877e61f1fdda6e128fe755922191923c5e3f486920c1735d4912bef4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "westVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanRelativeCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanRelativeCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanRelativeCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4855239f7e57ee494d3b4827d5e5447a232f4f2073aa455c0dc964b8716d4560)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanRemoveColor",
    jsii_struct_bases=[],
    name_mapping={
        "color": "color",
        "color_var": "colorVar",
        "feather": "feather",
        "feather_var": "featherVar",
        "tolerance": "tolerance",
        "tolerance_var": "toleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanRemoveColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
        feather: typing.Optional[builtins.str] = None,
        feather_var: typing.Optional[builtins.str] = None,
        tolerance: typing.Optional[builtins.str] = None,
        tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        :param feather: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        :param feather_var: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        :param tolerance: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        :param tolerance_var: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e6ac1cfd5672608c0cbcca78864fb38b89bf73d0bc8df61e3a9fcd07fd3fb55e)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
            check_type(argname="argument feather", value=feather, expected_type=type_hints["feather"])
            check_type(argname="argument feather_var", value=feather_var, expected_type=type_hints["feather_var"])
            check_type(argname="argument tolerance", value=tolerance, expected_type=type_hints["tolerance"])
            check_type(argname="argument tolerance_var", value=tolerance_var, expected_type=type_hints["tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var
        if feather is not None:
            self._values["feather"] = feather
        if feather_var is not None:
            self._values["feather_var"] = feather_var
        if tolerance is not None:
            self._values["tolerance"] = tolerance
        if tolerance_var is not None:
            self._values["tolerance_var"] = tolerance_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        '''
        result = self._values.get("feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather_var(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        '''
        result = self._values.get("feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        '''
        result = self._values.get("tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance_var(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        result = self._values.get("tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanRemoveColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanRemoveColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanRemoveColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fbd746d59b95713d82be07bdef1e140a069fe46c9b8feea7239d3752cda32fde)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanRemoveColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__050f8832b082499e2e47d81ed3123902db93d14da4573832bf35b39e75128dc3)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanRemoveColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2dd4369238ca48fba855c1907a523f26e749fe253c5d7ad6b7f733d19f10ab00)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__218170a7cc9962cf3a3befc5fa240831e018e63d473b2876f5aa84c3972cd23a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__51df636b5229dcbcd8b660b0f870a8bf6b806487ccb950b54b05a0ac7611a0a3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanRemoveColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanRemoveColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanRemoveColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d5b0295a61a41c6b4495f821009d3be57e8f175d5cd83ba2741c477367ae06cd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanRemoveColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanRemoveColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c3463e3213b437b0b5d362b88db00adf5f281cf60651fc605f2bacaae977cb77)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @jsii.member(jsii_name="resetFeather")
    def reset_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeather", []))

    @jsii.member(jsii_name="resetFeatherVar")
    def reset_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatherVar", []))

    @jsii.member(jsii_name="resetTolerance")
    def reset_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTolerance", []))

    @jsii.member(jsii_name="resetToleranceVar")
    def reset_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featherInput")
    def feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherInput"))

    @builtins.property
    @jsii.member(jsii_name="featherVarInput")
    def feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceInput")
    def tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceVarInput")
    def tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__afd9d9b4dc7c5c97dcf161c6a74b59e4bdb390ee896aa9436769efaee6212382)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2db8f4db7cdba07243cfc9c8e292c5156cc2222fe60b63a9197c9855d661cdfa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="feather")
    def feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "feather"))

    @feather.setter
    def feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8b1b2fb36aeb4d0a1d1d08826709a3a844ec2898f30031e1e8125f899f14d2b8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "feather", value)

    @builtins.property
    @jsii.member(jsii_name="featherVar")
    def feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featherVar"))

    @feather_var.setter
    def feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f04115752c16956239a4c459c408879944f0dda4c90d954088a0a03409e79419)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featherVar", value)

    @builtins.property
    @jsii.member(jsii_name="tolerance")
    def tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tolerance"))

    @tolerance.setter
    def tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5029c07a96d1f1db27e91a6226f798f5860a0981a50dfc17a83a2b48f86a218a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tolerance", value)

    @builtins.property
    @jsii.member(jsii_name="toleranceVar")
    def tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "toleranceVar"))

    @tolerance_var.setter
    def tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f722eec0508c9d0e25343cb6aec34b7e83cc74b5787654138886db45a72e24b4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "toleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanRemoveColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanRemoveColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanRemoveColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4e026c694fc67ceb8ed21396e19f61f4637da47cc8075f492aa67fb9c3204f08)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanResize",
    jsii_struct_bases=[],
    name_mapping={
        "aspect": "aspect",
        "aspect_var": "aspectVar",
        "height": "height",
        "height_var": "heightVar",
        "type": "type",
        "type_var": "typeVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanResize:
    def __init__(
        self,
        *,
        aspect: typing.Optional[builtins.str] = None,
        aspect_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param aspect: Preserves the aspect ratio. Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect DataAkamaiImagingPolicyImage#aspect}
        :param aspect_var: Preserves the aspect ratio. Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_var DataAkamaiImagingPolicyImage#aspect_var}
        :param height: The height to resize the source image to. Must be set if height is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height to resize the source image to. Must be set if height is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param type: Sets constraints for the image resize. Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: Sets constraints for the image resize. Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        :param width: The width to resize the source image to. Must be set if width is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width to resize the source image to. Must be set if width is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e4feea36482668226f5fd0412cad4f6bb4b059f4ec82ae9a4ea961bada4089dc)
            check_type(argname="argument aspect", value=aspect, expected_type=type_hints["aspect"])
            check_type(argname="argument aspect_var", value=aspect_var, expected_type=type_hints["aspect_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if aspect is not None:
            self._values["aspect"] = aspect
        if aspect_var is not None:
            self._values["aspect_var"] = aspect_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def aspect(self) -> typing.Optional[builtins.str]:
        '''Preserves the aspect ratio.

        Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect DataAkamaiImagingPolicyImage#aspect}
        '''
        result = self._values.get("aspect")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def aspect_var(self) -> typing.Optional[builtins.str]:
        '''Preserves the aspect ratio.

        Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_var DataAkamaiImagingPolicyImage#aspect_var}
        '''
        result = self._values.get("aspect_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height to resize the source image to. Must be set if height is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height to resize the source image to. Must be set if height is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''Sets constraints for the image resize.

        Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''Sets constraints for the image resize.

        Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width to resize the source image to. Must be set if width is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width to resize the source image to. Must be set if width is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanResize(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanResizeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanResizeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4782aa59791df177e9ca32d9ef21bfb9899129065b1ba856a9c9494d2b3daff6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanResizeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3033784b9e1874093025050f41fc7b4896ddb1f9e08f904a21afc95e7dce3ab9)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanResizeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e7280fadbc3c67f466291b229654bb07a42b256bfe2b0b8bf22c6cc157804ce0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__30a3c2676514fea5d580c241a1d0a6e054f1efc33b56283ccacc6c8a8ed246b0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b9773d6a9fd204a39f90f890bc5c727ab2b4ff0f5d206b8d6f4b91515b8b90c9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanResize]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanResize]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanResize]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__24a9f01b1f554e14c30ee4b431de8d16e2391c2d848c0ea0f04632ae75cb2889)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanResizeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanResizeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5638fc5be1f8797784571fa01e8bd8be16b3b3de677070131402555f815add4e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAspect")
    def reset_aspect(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspect", []))

    @jsii.member(jsii_name="resetAspectVar")
    def reset_aspect_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspectVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="aspectInput")
    def aspect_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "aspectInput"))

    @builtins.property
    @jsii.member(jsii_name="aspectVarInput")
    def aspect_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "aspectVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="aspect")
    def aspect(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "aspect"))

    @aspect.setter
    def aspect(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c8941cc849a31ff57bd46aac1002ed6c3a14ed8d062ea4d757ab43ba7a9e29ec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "aspect", value)

    @builtins.property
    @jsii.member(jsii_name="aspectVar")
    def aspect_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "aspectVar"))

    @aspect_var.setter
    def aspect_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bd287bf6fb594fffcfbc67c8e6a3f1038c00eb59f5a4a49c9a2280c401cf4740)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "aspectVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__81c2414fac5f3bb1bf37378046aeac6cd054d9e3d089e699658dd3b86129765a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__62b3f3ec0d5034df14857aa273851bae5708c37a6ba2347dc2cf6cc3b072421c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2df172159cd0ade8667dee1555c163842fc95e4e71c2484465f298e245b86737)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4eae2db482cb7a01d8adfcdf54629ef334d67632825a18bf5573ab23d6082ac8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b048bc06a5b92d514325a108d17e03b65086a94d438475da721fe6cb115ca64d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__148f495e411cc4673395b3612dac023d64c15a5de1e9e56c5392b428926b2d52)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanResize]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanResize]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanResize]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5d46c94ab25dac0b9362e08d22db7cdb4075c6f35e485b06e4587ea31d792c2b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanRotate",
    jsii_struct_bases=[],
    name_mapping={"degrees": "degrees", "degrees_var": "degreesVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanRotate:
    def __init__(
        self,
        *,
        degrees: typing.Optional[builtins.str] = None,
        degrees_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param degrees: The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees DataAkamaiImagingPolicyImage#degrees}
        :param degrees_var: The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees_var DataAkamaiImagingPolicyImage#degrees_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__55f45aa1dacf56d50ae3545c6469239016ab2ff5a3902ab149dfa759044483b1)
            check_type(argname="argument degrees", value=degrees, expected_type=type_hints["degrees"])
            check_type(argname="argument degrees_var", value=degrees_var, expected_type=type_hints["degrees_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if degrees is not None:
            self._values["degrees"] = degrees
        if degrees_var is not None:
            self._values["degrees_var"] = degrees_var

    @builtins.property
    def degrees(self) -> typing.Optional[builtins.str]:
        '''The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees DataAkamaiImagingPolicyImage#degrees}
        '''
        result = self._values.get("degrees")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def degrees_var(self) -> typing.Optional[builtins.str]:
        '''The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees_var DataAkamaiImagingPolicyImage#degrees_var}
        '''
        result = self._values.get("degrees_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanRotate(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanRotateList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanRotateList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d46c4e37686b4a375b03d9adc8ab6f09e69327e204ea81415eda6367f2d97899)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanRotateOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ee68940a7174600e7151bd9b4806c901e0c8f9a087511328472b00f229f88b0)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanRotateOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9c735beb40268de3f591e0a5fcf43699d8684f27fe2c739cac7f3ba3736ce4ea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1e618ef25aee19ac5de1c9cec69921bb7cdbbb553973d3f86b609078be3c9387)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__771313f8eddb1e2854a0d649376e17d6b71dd7e73225bc66775771f341219635)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanRotate]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanRotate]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanRotate]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__198e1572f7ba281443eda902b38b0f7d99e7c3a7eac5dd4a757ff1135b813819)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanRotateOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanRotateOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f6cf104051e7bd48af59148239937a5dec6be1271459a81b9d7d6d146203af5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetDegrees")
    def reset_degrees(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDegrees", []))

    @jsii.member(jsii_name="resetDegreesVar")
    def reset_degrees_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDegreesVar", []))

    @builtins.property
    @jsii.member(jsii_name="degreesInput")
    def degrees_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "degreesInput"))

    @builtins.property
    @jsii.member(jsii_name="degreesVarInput")
    def degrees_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "degreesVarInput"))

    @builtins.property
    @jsii.member(jsii_name="degrees")
    def degrees(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "degrees"))

    @degrees.setter
    def degrees(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e9400f5079e17c1ef5e96fcdc14fa598eb1da044732ce0b43dab0842726dc1c0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "degrees", value)

    @builtins.property
    @jsii.member(jsii_name="degreesVar")
    def degrees_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "degreesVar"))

    @degrees_var.setter
    def degrees_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__702671797aa06af7c765360da8205af0cddaed7d7a4999c0929b0352d8272226)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "degreesVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanRotate]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanRotate]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanRotate]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c74122de9bc3096cfb1336b96263f30ba57f4cc10acbb8627cd7b13739959af2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanScale",
    jsii_struct_bases=[],
    name_mapping={
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanScale:
    def __init__(
        self,
        *,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param height: Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged. Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged. Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a58c4b79fd68f66716359ddb1402ac65ce0c5868f432edc09cebe773abd8c22)
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size.

        Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size.

        Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged.

        Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged.

        Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanScale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanScaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanScaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__80d628024f5003422bc47b892881020600e17eb32be728bbbc4290011a803f0f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanScaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c54a3ab22da014f4bedf203ad0d62245850f7bd4c44970b09782148441238218)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanScaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a492e99951aa29e9f4d5c0f06824bf2dbbdeab3e129c4754d589ef84fe8195b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d7425962c232b3363eacfb481eaaf5f8f7c363d0abd74a2b388fe939706f054)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__62e3a47d0339184ff06bb7451816cf1dd4ecb9caba91ef28fd0c86165f0d3089)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanScale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanScale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanScale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__09a267860fc02f7b1e10bddae1f34dc2186135fa2ec820a414366ebbb0f440b6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanScaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanScaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7839eab6fe081537e5f2a799987c7ad15428a54d12d259fc130fac349ac988d5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__425e608871e044077f3140b2f4737209fca595426941080a5cbd7b237000c66d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f49fd3ea13a685ed942d7671b7978dd0b2175e2df9e4f26ffcf65f7761655773)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__508ddc6bb69f9521d11b619a841449b1de6daa408f3301d7019e1b6f34593d1a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d67a02f961ab046a9c99ab19f6e97b233b3eec4369fbcaa13930e4e6e16031aa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanScale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanScale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanScale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be1a2df60519b9cb8d670dbfe62e6b9282fe639ba2e7f569c4231e51e5c89c58)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanShear",
    jsii_struct_bases=[],
    name_mapping={
        "x_shear": "xShear",
        "x_shear_var": "xShearVar",
        "y_shear": "yShear",
        "y_shear_var": "yShearVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanShear:
    def __init__(
        self,
        *,
        x_shear: typing.Optional[builtins.str] = None,
        x_shear_var: typing.Optional[builtins.str] = None,
        y_shear: typing.Optional[builtins.str] = None,
        y_shear_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param x_shear: The amount to shear along the x-axis, measured in multiples of the image's width. Must be set if yShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear DataAkamaiImagingPolicyImage#x_shear}
        :param x_shear_var: The amount to shear along the x-axis, measured in multiples of the image's width. Must be set if yShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear_var DataAkamaiImagingPolicyImage#x_shear_var}
        :param y_shear: The amount to shear along the y-axis, measured in multiples of the image's height. Must be set if xShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear DataAkamaiImagingPolicyImage#y_shear}
        :param y_shear_var: The amount to shear along the y-axis, measured in multiples of the image's height. Must be set if xShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear_var DataAkamaiImagingPolicyImage#y_shear_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d19f91f492b9f7d700af03f38e4d804f6ed45966f24fcc40cc7852cdcb02d034)
            check_type(argname="argument x_shear", value=x_shear, expected_type=type_hints["x_shear"])
            check_type(argname="argument x_shear_var", value=x_shear_var, expected_type=type_hints["x_shear_var"])
            check_type(argname="argument y_shear", value=y_shear, expected_type=type_hints["y_shear"])
            check_type(argname="argument y_shear_var", value=y_shear_var, expected_type=type_hints["y_shear_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if x_shear is not None:
            self._values["x_shear"] = x_shear
        if x_shear_var is not None:
            self._values["x_shear_var"] = x_shear_var
        if y_shear is not None:
            self._values["y_shear"] = y_shear
        if y_shear_var is not None:
            self._values["y_shear_var"] = y_shear_var

    @builtins.property
    def x_shear(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the x-axis, measured in multiples of the image's width.

        Must be set if yShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear DataAkamaiImagingPolicyImage#x_shear}
        '''
        result = self._values.get("x_shear")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_shear_var(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the x-axis, measured in multiples of the image's width.

        Must be set if yShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear_var DataAkamaiImagingPolicyImage#x_shear_var}
        '''
        result = self._values.get("x_shear_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_shear(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the y-axis, measured in multiples of the image's height.

        Must be set if xShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear DataAkamaiImagingPolicyImage#y_shear}
        '''
        result = self._values.get("y_shear")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_shear_var(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the y-axis, measured in multiples of the image's height.

        Must be set if xShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear_var DataAkamaiImagingPolicyImage#y_shear_var}
        '''
        result = self._values.get("y_shear_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanShear(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanShearList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanShearList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__efc1d3c3193a4cd1c30aae8c78646d700be1f893009ed13103ef523fad28403d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanShearOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__758587acb0633b0cc24ca5fea192e50bb264f78d9ebd3e988f2e4781e664c065)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanShearOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e1f11528c63e94b80ef0e66cd3eb4a734a60aff390e315c5a4d94fac363eaff5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__031741f42390efa00b83c4ec6a856a0315b40f53120320278e894b7cf00c7493)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c97dabee9ec7eefa9b429be5aa14a41c76c872f2092a2b13dce2dbf24cd029d3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanShear]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanShear]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanShear]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df158ed14837ebb7f5b2ac80a632e39ddf5e9a2a1521a2dc865ab5b11a5f3d88)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanShearOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanShearOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__679a96f952e99c9e34a2f43a0822beaea0484ad31976fa59a292dc00b5d8041c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetXShear")
    def reset_x_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXShear", []))

    @jsii.member(jsii_name="resetXShearVar")
    def reset_x_shear_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXShearVar", []))

    @jsii.member(jsii_name="resetYShear")
    def reset_y_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYShear", []))

    @jsii.member(jsii_name="resetYShearVar")
    def reset_y_shear_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYShearVar", []))

    @builtins.property
    @jsii.member(jsii_name="xShearInput")
    def x_shear_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xShearInput"))

    @builtins.property
    @jsii.member(jsii_name="xShearVarInput")
    def x_shear_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xShearVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yShearInput")
    def y_shear_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yShearInput"))

    @builtins.property
    @jsii.member(jsii_name="yShearVarInput")
    def y_shear_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yShearVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xShear")
    def x_shear(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xShear"))

    @x_shear.setter
    def x_shear(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f2342eb9c8bd73b528bced3b8ebdbf0be812f4a8b5d835417ba4b3fe5f928777)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xShear", value)

    @builtins.property
    @jsii.member(jsii_name="xShearVar")
    def x_shear_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xShearVar"))

    @x_shear_var.setter
    def x_shear_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5b008520b85e4a2ede6fb70f67750abbeba27d47d332a75b901166638d574e58)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xShearVar", value)

    @builtins.property
    @jsii.member(jsii_name="yShear")
    def y_shear(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yShear"))

    @y_shear.setter
    def y_shear(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5b2a5d0c8804177d706ce888bde996220243752bc363b92dac83f4639ce22dcc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yShear", value)

    @builtins.property
    @jsii.member(jsii_name="yShearVar")
    def y_shear_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yShearVar"))

    @y_shear_var.setter
    def y_shear_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a8990c5d6758a9c05fe5362c0c1ea339a7daa0a450d22b85bc25fb0b85bfc1a3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yShearVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanShear]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanShear]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanShear]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ccdfc9c7ccebcecceb8588b4f36c05634b493b18b5e64ea30483330d94e2ea72)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanTrim",
    jsii_struct_bases=[],
    name_mapping={
        "fuzz": "fuzz",
        "fuzz_var": "fuzzVar",
        "padding": "padding",
        "padding_var": "paddingVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanTrim:
    def __init__(
        self,
        *,
        fuzz: typing.Optional[builtins.str] = None,
        fuzz_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fuzz: The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz DataAkamaiImagingPolicyImage#fuzz}
        :param fuzz_var: The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz_var DataAkamaiImagingPolicyImage#fuzz_var}
        :param padding: The amount of padding in pixels to add to the trimmed image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: The amount of padding in pixels to add to the trimmed image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f05ae525a42634be59118adac8b15830a5bceb9945c856742134210b3616f03)
            check_type(argname="argument fuzz", value=fuzz, expected_type=type_hints["fuzz"])
            check_type(argname="argument fuzz_var", value=fuzz_var, expected_type=type_hints["fuzz_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fuzz is not None:
            self._values["fuzz"] = fuzz
        if fuzz_var is not None:
            self._values["fuzz_var"] = fuzz_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var

    @builtins.property
    def fuzz(self) -> typing.Optional[builtins.str]:
        '''The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz DataAkamaiImagingPolicyImage#fuzz}
        '''
        result = self._values.get("fuzz")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fuzz_var(self) -> typing.Optional[builtins.str]:
        '''The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz_var DataAkamaiImagingPolicyImage#fuzz_var}
        '''
        result = self._values.get("fuzz_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''The amount of padding in pixels to add to the trimmed image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''The amount of padding in pixels to add to the trimmed image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanTrim(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanTrimList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanTrimList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__32241e43b34392a25cb9134138e71882954f87adc262a9fee372f33717c2a689)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanTrimOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__82d508f82051c9d493d48da132f8c2d876085206a0d8a632954d537dcea97930)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanTrimOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4bbb13fd96fa7b8e221ec46841695ef5662b316dbfc6126b500c6c8edea3c36c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af610ad5b803911721b584fb6cc62780aa09be2af61cf0b93af82f2ea6c84464)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__98ce0d9e078913d66a4ebac5aa9077f525e0bf2d99a2875dad9c879cd3527c00)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanTrim]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanTrim]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanTrim]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__343fd77bd9cea0abf52d9afd3b014fe8e11dce38bd823b7eaf3732630150b37f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanTrimOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanTrimOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7023ab4844e979bbfdd91df049ef25de2c229064ddab9ebce6a01396c7ada954)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetFuzz")
    def reset_fuzz(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFuzz", []))

    @jsii.member(jsii_name="resetFuzzVar")
    def reset_fuzz_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFuzzVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @builtins.property
    @jsii.member(jsii_name="fuzzInput")
    def fuzz_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fuzzInput"))

    @builtins.property
    @jsii.member(jsii_name="fuzzVarInput")
    def fuzz_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fuzzVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="fuzz")
    def fuzz(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fuzz"))

    @fuzz.setter
    def fuzz(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__86d81ce3f9e89352f8befe47308b3bd7847622ab5eae75609114fe7530b07b58)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fuzz", value)

    @builtins.property
    @jsii.member(jsii_name="fuzzVar")
    def fuzz_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fuzzVar"))

    @fuzz_var.setter
    def fuzz_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7ce6a70ed7d4a39f780eab511e838b77c689c30a548bd707a79c4bfe44340ade)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fuzzVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c7f2bad1c03db43d0a7b700890ccab814f9fb2c45a2f7296890c7ff5781931d7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fb748fbadfd42868e174d83f7835eccd1432a185fadb41aa3e2e157657fe1ecb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanTrim]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanTrim]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanTrim]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__36d75313e62ff6d0f84e2cd767dd2bd724a8d5d4773505203c8ebe9f40f182f0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanUnsharpMask",
    jsii_struct_bases=[],
    name_mapping={
        "gain": "gain",
        "gain_var": "gainVar",
        "sigma": "sigma",
        "sigma_var": "sigmaVar",
        "threshold": "threshold",
        "threshold_var": "thresholdVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanUnsharpMask:
    def __init__(
        self,
        *,
        gain: typing.Optional[builtins.str] = None,
        gain_var: typing.Optional[builtins.str] = None,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
        threshold: typing.Optional[builtins.str] = None,
        threshold_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param gain: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        :param gain_var: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        :param sigma: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        :param threshold: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        :param threshold_var: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ea94c02933a2bdfd26085f0277ee265eae69f636047d9283af0d81065791644)
            check_type(argname="argument gain", value=gain, expected_type=type_hints["gain"])
            check_type(argname="argument gain_var", value=gain_var, expected_type=type_hints["gain_var"])
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
            check_type(argname="argument threshold", value=threshold, expected_type=type_hints["threshold"])
            check_type(argname="argument threshold_var", value=threshold_var, expected_type=type_hints["threshold_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if gain is not None:
            self._values["gain"] = gain
        if gain_var is not None:
            self._values["gain_var"] = gain_var
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var
        if threshold is not None:
            self._values["threshold"] = threshold
        if threshold_var is not None:
            self._values["threshold_var"] = threshold_var

    @builtins.property
    def gain(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        '''
        result = self._values.get("gain")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gain_var(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        '''
        result = self._values.get("gain_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        '''
        result = self._values.get("threshold")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold_var(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        result = self._values.get("threshold_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanUnsharpMask(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanUnsharpMaskList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanUnsharpMaskList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a32e56d4b8f6e6fb869884ac66b04d4d344b713d3b2fb8858f27be5f61529841)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanUnsharpMaskOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a9d1f4483625683015e9d7a753dbb597db12f1c8e94f34e5fa9ae834d0db0f4d)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanUnsharpMaskOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__937bd63622e92f05b385435196e9e45bf052865bb386125688862f388e272361)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__53f985419b7102efbefaa8fcb48ec0e7570758f14cb789948f82bfecc522af4a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eda1de42c15bce13ef92ef41f4c2157359031a7db9908a596f0571a746d0c113)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanUnsharpMask]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanUnsharpMask]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanUnsharpMask]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__976e125cf664e1d544e8b249bc83f90861cd33a6ec86034d8c00096c758cb922)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanUnsharpMaskOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanUnsharpMaskOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__56e83d8e815ef7df1e615a76032cc323c2093087f07d0a44878f09112f8d5d79)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetGain")
    def reset_gain(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGain", []))

    @jsii.member(jsii_name="resetGainVar")
    def reset_gain_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGainVar", []))

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @jsii.member(jsii_name="resetThreshold")
    def reset_threshold(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThreshold", []))

    @jsii.member(jsii_name="resetThresholdVar")
    def reset_threshold_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThresholdVar", []))

    @builtins.property
    @jsii.member(jsii_name="gainInput")
    def gain_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainInput"))

    @builtins.property
    @jsii.member(jsii_name="gainVarInput")
    def gain_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdInput")
    def threshold_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdVarInput")
    def threshold_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gain")
    def gain(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gain"))

    @gain.setter
    def gain(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8d8d3a3e7dbf8e9f35e51e81add8006d2a97428e46f4b1b4821ed6fa57acefbc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gain", value)

    @builtins.property
    @jsii.member(jsii_name="gainVar")
    def gain_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gainVar"))

    @gain_var.setter
    def gain_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8bfde95070624b1ab1f4c0da8bb8f5bbb707e43e2f7a917287ac87480e576f54)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gainVar", value)

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d286a6d21191c431d748243a83ec8abce57ddd5aca4c4872ea5c40dbfd0260b7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2686b692c49117c11f0f4cfd544ab9736e51da046a436a1994160da98c2bf205)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="threshold")
    def threshold(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "threshold"))

    @threshold.setter
    def threshold(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__350aa7710e013209e5e3fda69f26dbf3b4f3c3f18a85fc2d397a25102d62f856)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "threshold", value)

    @builtins.property
    @jsii.member(jsii_name="thresholdVar")
    def threshold_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "thresholdVar"))

    @threshold_var.setter
    def threshold_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1708f18972e109ef4a0c95e39ffd9a1cfc88fa216181c091fe9463a539b5f547)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "thresholdVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanUnsharpMask]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanUnsharpMask]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanUnsharpMask]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b99611c28095f85786c5336fdab38d891c8ed47296f5bebc328583151a34c60f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e638a5c65e26b3b6356c010f37f9be4a04a54c7c8842407344c5fe2daebe0c84)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3e2683a8e622514b078187a9bf74870a807d2ac336036a94ffd9e517176f9f59)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a62b2f3e087028a0c595209daeb6e6ac644630c1240e0668241f9e2512fdc7dd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f0a19064bb9083b40f3384796fc92402e553e415f59f587960d9e7110ad9cae5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__12bb6d2eceafe0c2e0996f752f66959a222e8b85622ed57c43c33113d743c082)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimension]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimension]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1dd8236eb8abefb4910ad900641696aec3338fe9282ece89838d997eab30fa09)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c5550b6eaf99f592e04149781952e2010c3e067c2358fe918209468bed7bcfd9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(
        self,
        *,
        append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultAppend, typing.Dict[builtins.str, typing.Any]]]]] = None,
        aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultAspectCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
        crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultFaceCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultFeatureCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultFitAndFill, typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
        im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultImQuery, typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
        region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultRegionOfInterestCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultRelativeCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
        resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultResize, typing.Dict[builtins.str, typing.Any]]]]] = None,
        rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultRotate, typing.Dict[builtins.str, typing.Any]]]]] = None,
        scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultScale, typing.Dict[builtins.str, typing.Any]]]]] = None,
        shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultShear, typing.Dict[builtins.str, typing.Any]]]]] = None,
        trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultTrim, typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param append: append block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        :param aspect_crop: aspect_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param crop: crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        :param face_crop: face_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        :param feature_crop: feature_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        :param fit_and_fill: fit_and_fill block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param im_query: im_query block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param region_of_interest_crop: region_of_interest_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        :param relative_crop: relative_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param resize: resize block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        :param rotate: rotate block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        :param scale: scale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param shear: shear block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        :param trim: trim block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        value = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefault(
            append=append,
            aspect_crop=aspect_crop,
            background_color=background_color,
            blur=blur,
            chroma_key=chroma_key,
            composite=composite,
            compound=compound,
            contrast=contrast,
            crop=crop,
            face_crop=face_crop,
            feature_crop=feature_crop,
            fit_and_fill=fit_and_fill,
            goop=goop,
            grayscale=grayscale,
            hsl=hsl,
            hsv=hsv,
            if_dimension=if_dimension,
            if_orientation=if_orientation,
            im_query=im_query,
            max_colors=max_colors,
            mirror=mirror,
            mono_hue=mono_hue,
            opacity=opacity,
            region_of_interest_crop=region_of_interest_crop,
            relative_crop=relative_crop,
            remove_color=remove_color,
            resize=resize,
            rotate=rotate,
            scale=scale,
            shear=shear,
            trim=trim,
            unsharp_mask=unsharp_mask,
        )

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putEqual")
    def put_equal(
        self,
        *,
        append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualAppend, typing.Dict[builtins.str, typing.Any]]]]] = None,
        aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualAspectCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
        crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualFaceCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualFeatureCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualFitAndFill, typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
        im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualImQuery, typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
        region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualRegionOfInterestCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualRelativeCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
        resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualResize, typing.Dict[builtins.str, typing.Any]]]]] = None,
        rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualRotate, typing.Dict[builtins.str, typing.Any]]]]] = None,
        scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualScale, typing.Dict[builtins.str, typing.Any]]]]] = None,
        shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualShear, typing.Dict[builtins.str, typing.Any]]]]] = None,
        trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualTrim, typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param append: append block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        :param aspect_crop: aspect_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param crop: crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        :param face_crop: face_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        :param feature_crop: feature_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        :param fit_and_fill: fit_and_fill block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param im_query: im_query block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param region_of_interest_crop: region_of_interest_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        :param relative_crop: relative_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param resize: resize block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        :param rotate: rotate block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        :param scale: scale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param shear: shear block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        :param trim: trim block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        value = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqual(
            append=append,
            aspect_crop=aspect_crop,
            background_color=background_color,
            blur=blur,
            chroma_key=chroma_key,
            composite=composite,
            compound=compound,
            contrast=contrast,
            crop=crop,
            face_crop=face_crop,
            feature_crop=feature_crop,
            fit_and_fill=fit_and_fill,
            goop=goop,
            grayscale=grayscale,
            hsl=hsl,
            hsv=hsv,
            if_dimension=if_dimension,
            if_orientation=if_orientation,
            im_query=im_query,
            max_colors=max_colors,
            mirror=mirror,
            mono_hue=mono_hue,
            opacity=opacity,
            region_of_interest_crop=region_of_interest_crop,
            relative_crop=relative_crop,
            remove_color=remove_color,
            resize=resize,
            rotate=rotate,
            scale=scale,
            shear=shear,
            trim=trim,
            unsharp_mask=unsharp_mask,
        )

        return typing.cast(None, jsii.invoke(self, "putEqual", [value]))

    @jsii.member(jsii_name="putGreaterThan")
    def put_greater_than(
        self,
        *,
        append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanAppend, typing.Dict[builtins.str, typing.Any]]]]] = None,
        aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanAspectCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
        crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanFaceCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanFeatureCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanFitAndFill, typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
        im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanImQuery, typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
        region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanRegionOfInterestCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanRelativeCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
        resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanResize, typing.Dict[builtins.str, typing.Any]]]]] = None,
        rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanRotate, typing.Dict[builtins.str, typing.Any]]]]] = None,
        scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanScale, typing.Dict[builtins.str, typing.Any]]]]] = None,
        shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanShear, typing.Dict[builtins.str, typing.Any]]]]] = None,
        trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanTrim, typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param append: append block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        :param aspect_crop: aspect_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param crop: crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        :param face_crop: face_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        :param feature_crop: feature_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        :param fit_and_fill: fit_and_fill block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param im_query: im_query block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param region_of_interest_crop: region_of_interest_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        :param relative_crop: relative_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param resize: resize block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        :param rotate: rotate block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        :param scale: scale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param shear: shear block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        :param trim: trim block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        value = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThan(
            append=append,
            aspect_crop=aspect_crop,
            background_color=background_color,
            blur=blur,
            chroma_key=chroma_key,
            composite=composite,
            compound=compound,
            contrast=contrast,
            crop=crop,
            face_crop=face_crop,
            feature_crop=feature_crop,
            fit_and_fill=fit_and_fill,
            goop=goop,
            grayscale=grayscale,
            hsl=hsl,
            hsv=hsv,
            if_dimension=if_dimension,
            if_orientation=if_orientation,
            im_query=im_query,
            max_colors=max_colors,
            mirror=mirror,
            mono_hue=mono_hue,
            opacity=opacity,
            region_of_interest_crop=region_of_interest_crop,
            relative_crop=relative_crop,
            remove_color=remove_color,
            resize=resize,
            rotate=rotate,
            scale=scale,
            shear=shear,
            trim=trim,
            unsharp_mask=unsharp_mask,
        )

        return typing.cast(None, jsii.invoke(self, "putGreaterThan", [value]))

    @jsii.member(jsii_name="putLessThan")
    def put_less_than(
        self,
        *,
        append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanAppend, typing.Dict[builtins.str, typing.Any]]]]] = None,
        aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanAspectCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
        crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanFaceCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanFeatureCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanFitAndFill, typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
        im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanImQuery, typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
        region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanRegionOfInterestCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanRelativeCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
        resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanResize, typing.Dict[builtins.str, typing.Any]]]]] = None,
        rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanRotate, typing.Dict[builtins.str, typing.Any]]]]] = None,
        scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanScale, typing.Dict[builtins.str, typing.Any]]]]] = None,
        shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanShear, typing.Dict[builtins.str, typing.Any]]]]] = None,
        trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanTrim, typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param append: append block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        :param aspect_crop: aspect_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param crop: crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        :param face_crop: face_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        :param feature_crop: feature_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        :param fit_and_fill: fit_and_fill block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param im_query: im_query block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param region_of_interest_crop: region_of_interest_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        :param relative_crop: relative_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param resize: resize block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        :param rotate: rotate block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        :param scale: scale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param shear: shear block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        :param trim: trim block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        value = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThan(
            append=append,
            aspect_crop=aspect_crop,
            background_color=background_color,
            blur=blur,
            chroma_key=chroma_key,
            composite=composite,
            compound=compound,
            contrast=contrast,
            crop=crop,
            face_crop=face_crop,
            feature_crop=feature_crop,
            fit_and_fill=fit_and_fill,
            goop=goop,
            grayscale=grayscale,
            hsl=hsl,
            hsv=hsv,
            if_dimension=if_dimension,
            if_orientation=if_orientation,
            im_query=im_query,
            max_colors=max_colors,
            mirror=mirror,
            mono_hue=mono_hue,
            opacity=opacity,
            region_of_interest_crop=region_of_interest_crop,
            relative_crop=relative_crop,
            remove_color=remove_color,
            resize=resize,
            rotate=rotate,
            scale=scale,
            shear=shear,
            trim=trim,
            unsharp_mask=unsharp_mask,
        )

        return typing.cast(None, jsii.invoke(self, "putLessThan", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetDimension")
    def reset_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimension", []))

    @jsii.member(jsii_name="resetDimensionVar")
    def reset_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimensionVar", []))

    @jsii.member(jsii_name="resetEqual")
    def reset_equal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEqual", []))

    @jsii.member(jsii_name="resetGreaterThan")
    def reset_greater_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGreaterThan", []))

    @jsii.member(jsii_name="resetLessThan")
    def reset_less_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLessThan", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="equal")
    def equal(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualOutputReference, jsii.get(self, "equal"))

    @builtins.property
    @jsii.member(jsii_name="greaterThan")
    def greater_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanOutputReference, jsii.get(self, "greaterThan"))

    @builtins.property
    @jsii.member(jsii_name="lessThan")
    def less_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanOutputReference, jsii.get(self, "lessThan"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionInput")
    def dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionVarInput")
    def dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="equalInput")
    def equal_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqual], jsii.get(self, "equalInput"))

    @builtins.property
    @jsii.member(jsii_name="greaterThanInput")
    def greater_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThan], jsii.get(self, "greaterThanInput"))

    @builtins.property
    @jsii.member(jsii_name="lessThanInput")
    def less_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThan], jsii.get(self, "lessThanInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="dimension")
    def dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimension"))

    @dimension.setter
    def dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7954b959c378c42bf02101c6c818635f0425cc32ded46bbb64c1bfd2932317ce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimension", value)

    @builtins.property
    @jsii.member(jsii_name="dimensionVar")
    def dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimensionVar"))

    @dimension_var.setter
    def dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__775e1372422e62fcafa7ddab8d46384580be1ccaa71665bb06a1e3767e568547)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__396aec07e1a275d11b8f064150b897f25ec57290418e7edffa0df1c97ef6cf71)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f93a29a87bbadd5a40db90d4d2453c1d9a99f674b26ce6a3e3b8a7c3c9b388da)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimension]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimension]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimension]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dd1b5fc16a6fe67890bcfbe19dae9e3ab91bd782b0ad35f49f2fcd447a207691)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientation",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "landscape": "landscape",
        "portrait": "portrait",
        "square": "square",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientation:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        landscape: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscape", typing.Dict[builtins.str, typing.Any]]] = None,
        portrait: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortrait", typing.Dict[builtins.str, typing.Any]]] = None,
        square: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquare", typing.Dict[builtins.str, typing.Any]]] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param landscape: landscape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        :param portrait: portrait block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        :param square: square block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefault(**default)
        if isinstance(landscape, dict):
            landscape = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscape(**landscape)
        if isinstance(portrait, dict):
            portrait = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortrait(**portrait)
        if isinstance(square, dict):
            square = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquare(**square)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__247aaa4471015b42bfc150bdecb0c4109e5bffa6b51cc679cdc8bd84c092a11a)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument landscape", value=landscape, expected_type=type_hints["landscape"])
            check_type(argname="argument portrait", value=portrait, expected_type=type_hints["portrait"])
            check_type(argname="argument square", value=square, expected_type=type_hints["square"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if landscape is not None:
            self._values["landscape"] = landscape
        if portrait is not None:
            self._values["portrait"] = portrait
        if square is not None:
            self._values["square"] = square

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefault"], result)

    @builtins.property
    def landscape(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscape"]:
        '''landscape block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        '''
        result = self._values.get("landscape")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscape"], result)

    @builtins.property
    def portrait(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortrait"]:
        '''portrait block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        '''
        result = self._values.get("portrait")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortrait"], result)

    @builtins.property
    def square(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquare"]:
        '''square block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        result = self._values.get("square")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquare"], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefault",
    jsii_struct_bases=[],
    name_mapping={
        "append": "append",
        "aspect_crop": "aspectCrop",
        "background_color": "backgroundColor",
        "blur": "blur",
        "chroma_key": "chromaKey",
        "composite": "composite",
        "compound": "compound",
        "contrast": "contrast",
        "crop": "crop",
        "face_crop": "faceCrop",
        "feature_crop": "featureCrop",
        "fit_and_fill": "fitAndFill",
        "goop": "goop",
        "grayscale": "grayscale",
        "hsl": "hsl",
        "hsv": "hsv",
        "if_dimension": "ifDimension",
        "if_orientation": "ifOrientation",
        "im_query": "imQuery",
        "max_colors": "maxColors",
        "mirror": "mirror",
        "mono_hue": "monoHue",
        "opacity": "opacity",
        "region_of_interest_crop": "regionOfInterestCrop",
        "relative_crop": "relativeCrop",
        "remove_color": "removeColor",
        "resize": "resize",
        "rotate": "rotate",
        "scale": "scale",
        "shear": "shear",
        "trim": "trim",
        "unsharp_mask": "unsharpMask",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefault:
    def __init__(
        self,
        *,
        append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultAppend", typing.Dict[builtins.str, typing.Any]]]]] = None,
        aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultAspectCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultBackgroundColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultBlur", typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultChromaKey", typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultComposite", typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultCompound", typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultContrast", typing.Dict[builtins.str, typing.Any]]]]] = None,
        crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultFaceCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultFeatureCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultFitAndFill", typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultGoop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultGrayscale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultHsl", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultHsv", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfDimension", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfOrientation", typing.Dict[builtins.str, typing.Any]]]]] = None,
        im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultImQuery", typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultMaxColors", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultMirror", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultMonoHue", typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultOpacity", typing.Dict[builtins.str, typing.Any]]]]] = None,
        region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultRegionOfInterestCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultRelativeCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultRemoveColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultResize", typing.Dict[builtins.str, typing.Any]]]]] = None,
        rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultRotate", typing.Dict[builtins.str, typing.Any]]]]] = None,
        scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultScale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultShear", typing.Dict[builtins.str, typing.Any]]]]] = None,
        trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultTrim", typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultUnsharpMask", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param append: append block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        :param aspect_crop: aspect_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param crop: crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        :param face_crop: face_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        :param feature_crop: feature_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        :param fit_and_fill: fit_and_fill block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param im_query: im_query block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param region_of_interest_crop: region_of_interest_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        :param relative_crop: relative_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param resize: resize block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        :param rotate: rotate block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        :param scale: scale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param shear: shear block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        :param trim: trim block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__89b322eebbf4fc93c0dedcde8ac8d11ac7c152f37e936d07cb6a04d0ab892fa1)
            check_type(argname="argument append", value=append, expected_type=type_hints["append"])
            check_type(argname="argument aspect_crop", value=aspect_crop, expected_type=type_hints["aspect_crop"])
            check_type(argname="argument background_color", value=background_color, expected_type=type_hints["background_color"])
            check_type(argname="argument blur", value=blur, expected_type=type_hints["blur"])
            check_type(argname="argument chroma_key", value=chroma_key, expected_type=type_hints["chroma_key"])
            check_type(argname="argument composite", value=composite, expected_type=type_hints["composite"])
            check_type(argname="argument compound", value=compound, expected_type=type_hints["compound"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument crop", value=crop, expected_type=type_hints["crop"])
            check_type(argname="argument face_crop", value=face_crop, expected_type=type_hints["face_crop"])
            check_type(argname="argument feature_crop", value=feature_crop, expected_type=type_hints["feature_crop"])
            check_type(argname="argument fit_and_fill", value=fit_and_fill, expected_type=type_hints["fit_and_fill"])
            check_type(argname="argument goop", value=goop, expected_type=type_hints["goop"])
            check_type(argname="argument grayscale", value=grayscale, expected_type=type_hints["grayscale"])
            check_type(argname="argument hsl", value=hsl, expected_type=type_hints["hsl"])
            check_type(argname="argument hsv", value=hsv, expected_type=type_hints["hsv"])
            check_type(argname="argument if_dimension", value=if_dimension, expected_type=type_hints["if_dimension"])
            check_type(argname="argument if_orientation", value=if_orientation, expected_type=type_hints["if_orientation"])
            check_type(argname="argument im_query", value=im_query, expected_type=type_hints["im_query"])
            check_type(argname="argument max_colors", value=max_colors, expected_type=type_hints["max_colors"])
            check_type(argname="argument mirror", value=mirror, expected_type=type_hints["mirror"])
            check_type(argname="argument mono_hue", value=mono_hue, expected_type=type_hints["mono_hue"])
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument region_of_interest_crop", value=region_of_interest_crop, expected_type=type_hints["region_of_interest_crop"])
            check_type(argname="argument relative_crop", value=relative_crop, expected_type=type_hints["relative_crop"])
            check_type(argname="argument remove_color", value=remove_color, expected_type=type_hints["remove_color"])
            check_type(argname="argument resize", value=resize, expected_type=type_hints["resize"])
            check_type(argname="argument rotate", value=rotate, expected_type=type_hints["rotate"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument shear", value=shear, expected_type=type_hints["shear"])
            check_type(argname="argument trim", value=trim, expected_type=type_hints["trim"])
            check_type(argname="argument unsharp_mask", value=unsharp_mask, expected_type=type_hints["unsharp_mask"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if append is not None:
            self._values["append"] = append
        if aspect_crop is not None:
            self._values["aspect_crop"] = aspect_crop
        if background_color is not None:
            self._values["background_color"] = background_color
        if blur is not None:
            self._values["blur"] = blur
        if chroma_key is not None:
            self._values["chroma_key"] = chroma_key
        if composite is not None:
            self._values["composite"] = composite
        if compound is not None:
            self._values["compound"] = compound
        if contrast is not None:
            self._values["contrast"] = contrast
        if crop is not None:
            self._values["crop"] = crop
        if face_crop is not None:
            self._values["face_crop"] = face_crop
        if feature_crop is not None:
            self._values["feature_crop"] = feature_crop
        if fit_and_fill is not None:
            self._values["fit_and_fill"] = fit_and_fill
        if goop is not None:
            self._values["goop"] = goop
        if grayscale is not None:
            self._values["grayscale"] = grayscale
        if hsl is not None:
            self._values["hsl"] = hsl
        if hsv is not None:
            self._values["hsv"] = hsv
        if if_dimension is not None:
            self._values["if_dimension"] = if_dimension
        if if_orientation is not None:
            self._values["if_orientation"] = if_orientation
        if im_query is not None:
            self._values["im_query"] = im_query
        if max_colors is not None:
            self._values["max_colors"] = max_colors
        if mirror is not None:
            self._values["mirror"] = mirror
        if mono_hue is not None:
            self._values["mono_hue"] = mono_hue
        if opacity is not None:
            self._values["opacity"] = opacity
        if region_of_interest_crop is not None:
            self._values["region_of_interest_crop"] = region_of_interest_crop
        if relative_crop is not None:
            self._values["relative_crop"] = relative_crop
        if remove_color is not None:
            self._values["remove_color"] = remove_color
        if resize is not None:
            self._values["resize"] = resize
        if rotate is not None:
            self._values["rotate"] = rotate
        if scale is not None:
            self._values["scale"] = scale
        if shear is not None:
            self._values["shear"] = shear
        if trim is not None:
            self._values["trim"] = trim
        if unsharp_mask is not None:
            self._values["unsharp_mask"] = unsharp_mask

    @builtins.property
    def append(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultAppend"]]]:
        '''append block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        '''
        result = self._values.get("append")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultAppend"]]], result)

    @builtins.property
    def aspect_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultAspectCrop"]]]:
        '''aspect_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        '''
        result = self._values.get("aspect_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultAspectCrop"]]], result)

    @builtins.property
    def background_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultBackgroundColor"]]]:
        '''background_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        '''
        result = self._values.get("background_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultBackgroundColor"]]], result)

    @builtins.property
    def blur(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultBlur"]]]:
        '''blur block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        '''
        result = self._values.get("blur")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultBlur"]]], result)

    @builtins.property
    def chroma_key(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultChromaKey"]]]:
        '''chroma_key block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        '''
        result = self._values.get("chroma_key")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultChromaKey"]]], result)

    @builtins.property
    def composite(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultComposite"]]]:
        '''composite block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        '''
        result = self._values.get("composite")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultComposite"]]], result)

    @builtins.property
    def compound(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultCompound"]]]:
        '''compound block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        '''
        result = self._values.get("compound")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultCompound"]]], result)

    @builtins.property
    def contrast(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultContrast"]]]:
        '''contrast block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultContrast"]]], result)

    @builtins.property
    def crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultCrop"]]]:
        '''crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        '''
        result = self._values.get("crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultCrop"]]], result)

    @builtins.property
    def face_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultFaceCrop"]]]:
        '''face_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        '''
        result = self._values.get("face_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultFaceCrop"]]], result)

    @builtins.property
    def feature_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultFeatureCrop"]]]:
        '''feature_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        '''
        result = self._values.get("feature_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultFeatureCrop"]]], result)

    @builtins.property
    def fit_and_fill(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultFitAndFill"]]]:
        '''fit_and_fill block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        '''
        result = self._values.get("fit_and_fill")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultFitAndFill"]]], result)

    @builtins.property
    def goop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultGoop"]]]:
        '''goop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        '''
        result = self._values.get("goop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultGoop"]]], result)

    @builtins.property
    def grayscale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultGrayscale"]]]:
        '''grayscale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        '''
        result = self._values.get("grayscale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultGrayscale"]]], result)

    @builtins.property
    def hsl(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultHsl"]]]:
        '''hsl block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        '''
        result = self._values.get("hsl")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultHsl"]]], result)

    @builtins.property
    def hsv(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultHsv"]]]:
        '''hsv block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        '''
        result = self._values.get("hsv")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultHsv"]]], result)

    @builtins.property
    def if_dimension(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfDimension"]]]:
        '''if_dimension block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        '''
        result = self._values.get("if_dimension")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfDimension"]]], result)

    @builtins.property
    def if_orientation(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfOrientation"]]]:
        '''if_orientation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        '''
        result = self._values.get("if_orientation")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfOrientation"]]], result)

    @builtins.property
    def im_query(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultImQuery"]]]:
        '''im_query block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        '''
        result = self._values.get("im_query")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultImQuery"]]], result)

    @builtins.property
    def max_colors(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultMaxColors"]]]:
        '''max_colors block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        '''
        result = self._values.get("max_colors")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultMaxColors"]]], result)

    @builtins.property
    def mirror(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultMirror"]]]:
        '''mirror block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        '''
        result = self._values.get("mirror")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultMirror"]]], result)

    @builtins.property
    def mono_hue(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultMonoHue"]]]:
        '''mono_hue block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        '''
        result = self._values.get("mono_hue")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultMonoHue"]]], result)

    @builtins.property
    def opacity(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultOpacity"]]]:
        '''opacity block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultOpacity"]]], result)

    @builtins.property
    def region_of_interest_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultRegionOfInterestCrop"]]]:
        '''region_of_interest_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        '''
        result = self._values.get("region_of_interest_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultRegionOfInterestCrop"]]], result)

    @builtins.property
    def relative_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultRelativeCrop"]]]:
        '''relative_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        '''
        result = self._values.get("relative_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultRelativeCrop"]]], result)

    @builtins.property
    def remove_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultRemoveColor"]]]:
        '''remove_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        '''
        result = self._values.get("remove_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultRemoveColor"]]], result)

    @builtins.property
    def resize(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultResize"]]]:
        '''resize block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        '''
        result = self._values.get("resize")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultResize"]]], result)

    @builtins.property
    def rotate(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultRotate"]]]:
        '''rotate block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        '''
        result = self._values.get("rotate")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultRotate"]]], result)

    @builtins.property
    def scale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultScale"]]]:
        '''scale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultScale"]]], result)

    @builtins.property
    def shear(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultShear"]]]:
        '''shear block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        '''
        result = self._values.get("shear")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultShear"]]], result)

    @builtins.property
    def trim(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultTrim"]]]:
        '''trim block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        '''
        result = self._values.get("trim")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultTrim"]]], result)

    @builtins.property
    def unsharp_mask(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultUnsharpMask"]]]:
        '''unsharp_mask block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        result = self._values.get("unsharp_mask")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultUnsharpMask"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultAppend",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_priority": "gravityPriority",
        "gravity_priority_var": "gravityPriorityVar",
        "gravity_var": "gravityVar",
        "preserve_minor_dimension": "preserveMinorDimension",
        "preserve_minor_dimension_var": "preserveMinorDimensionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultAppend:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultAppendImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_priority: typing.Optional[builtins.str] = None,
        gravity_priority_var: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        preserve_minor_dimension: typing.Optional[builtins.str] = None,
        preserve_minor_dimension_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Specifies where to place the ``image`` relative to the source image. The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_priority: Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal. The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority DataAkamaiImagingPolicyImage#gravity_priority}
        :param gravity_priority_var: Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal. The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority_var DataAkamaiImagingPolicyImage#gravity_priority_var}
        :param gravity_var: Specifies where to place the ``image`` relative to the source image. The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param preserve_minor_dimension: Whether to preserve the source image's minor dimension, ``false`` by default. The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension DataAkamaiImagingPolicyImage#preserve_minor_dimension}
        :param preserve_minor_dimension_var: Whether to preserve the source image's minor dimension, ``false`` by default. The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension_var DataAkamaiImagingPolicyImage#preserve_minor_dimension_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultAppendImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c4d1524418710e6528def4d8e88adb7eae0dd6d83c5ba457eed4f9ad22c5b69d)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_priority", value=gravity_priority, expected_type=type_hints["gravity_priority"])
            check_type(argname="argument gravity_priority_var", value=gravity_priority_var, expected_type=type_hints["gravity_priority_var"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument preserve_minor_dimension", value=preserve_minor_dimension, expected_type=type_hints["preserve_minor_dimension"])
            check_type(argname="argument preserve_minor_dimension_var", value=preserve_minor_dimension_var, expected_type=type_hints["preserve_minor_dimension_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_priority is not None:
            self._values["gravity_priority"] = gravity_priority
        if gravity_priority_var is not None:
            self._values["gravity_priority_var"] = gravity_priority_var
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if preserve_minor_dimension is not None:
            self._values["preserve_minor_dimension"] = preserve_minor_dimension
        if preserve_minor_dimension_var is not None:
            self._values["preserve_minor_dimension_var"] = preserve_minor_dimension_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultAppendImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultAppendImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Specifies where to place the ``image`` relative to the source image.

        The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_priority(self) -> typing.Optional[builtins.str]:
        '''Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal.

        The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority DataAkamaiImagingPolicyImage#gravity_priority}
        '''
        result = self._values.get("gravity_priority")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_priority_var(self) -> typing.Optional[builtins.str]:
        '''Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal.

        The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority_var DataAkamaiImagingPolicyImage#gravity_priority_var}
        '''
        result = self._values.get("gravity_priority_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Specifies where to place the ``image`` relative to the source image.

        The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def preserve_minor_dimension(self) -> typing.Optional[builtins.str]:
        '''Whether to preserve the source image's minor dimension, ``false`` by default.

        The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension DataAkamaiImagingPolicyImage#preserve_minor_dimension}
        '''
        result = self._values.get("preserve_minor_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def preserve_minor_dimension_var(self) -> typing.Optional[builtins.str]:
        '''Whether to preserve the source image's minor dimension, ``false`` by default.

        The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension_var DataAkamaiImagingPolicyImage#preserve_minor_dimension_var}
        '''
        result = self._values.get("preserve_minor_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultAppend(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultAppendImage",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultAppendImage:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultAppendImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultAppendImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultAppendImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__32eaa916725d4f06372b9606127ff451d2f1117ba9073e74743fd9150acbc6df)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultAppendImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultAppendImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultAppendImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f500b7cb8e271823855210bcaa916d4ca93c59bbf24622f44b3c01916891e143)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultAppendList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultAppendList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__301e18ce31bc21fadf493dbfb5a36cf7e9ca261fc4854b85e8d6aded1bd0a414)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultAppendOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__188f4c6e4baf0e231fff85ab8cb83ecb5c72ed0ed26a9d78b91f9493601b5a3c)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultAppendOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dd4d87ce02bba3c5fd498b8efbe1e84636514fa6d1f028781e07c2f50a9f6335)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__28c1c4d9806e20fc81134dbf3c1d4cf0d2aba2254a50dd3e7a979e5abe1f18b0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__45417a80a1a8ad0abb26087f8acd500e079639481353099487e6ce4d470d5583)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultAppend]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultAppend]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultAppend]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be62c9650999f7135c6be807ec4500c8f722e86fc3e984ba8e2a511a1f5ec091)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultAppendOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultAppendOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a4e8e732a309bd76a8c6c8fc25bdd77d7d627717e478065606105b3e2eb36483)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultAppendImage()

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityPriority")
    def reset_gravity_priority(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityPriority", []))

    @jsii.member(jsii_name="resetGravityPriorityVar")
    def reset_gravity_priority_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityPriorityVar", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPreserveMinorDimension")
    def reset_preserve_minor_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPreserveMinorDimension", []))

    @jsii.member(jsii_name="resetPreserveMinorDimensionVar")
    def reset_preserve_minor_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPreserveMinorDimensionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultAppendImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultAppendImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityInput")
    def gravity_priority_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityPriorityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityVarInput")
    def gravity_priority_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityPriorityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultAppendImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultAppendImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionInput")
    def preserve_minor_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "preserveMinorDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionVarInput")
    def preserve_minor_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "preserveMinorDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8f3fae59ea8fb943f6535da813fb766e27dc51264c75c795ff8a3e9e9c227e04)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityPriority")
    def gravity_priority(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityPriority"))

    @gravity_priority.setter
    def gravity_priority(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__84567ef0b769af063d2be9afecbdba72d790338384d0d42abdf13d018221cb76)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityPriority", value)

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityVar")
    def gravity_priority_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityPriorityVar"))

    @gravity_priority_var.setter
    def gravity_priority_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eaea1db1b14398c327e588b8f010417b965ac1fd3c892ce6eedcd5f312171aba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityPriorityVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ff5b19ebfec617b313a3baba5726cfc45e47c06126fc3a990aa2d688c3e2ed34)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimension")
    def preserve_minor_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "preserveMinorDimension"))

    @preserve_minor_dimension.setter
    def preserve_minor_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__829acfb5ca7879d9da34e26322427dfdcfe88b41e11df19ef230aa32e2323548)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "preserveMinorDimension", value)

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionVar")
    def preserve_minor_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "preserveMinorDimensionVar"))

    @preserve_minor_dimension_var.setter
    def preserve_minor_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8db65103046842f7f531c8d03851b17abb905a232f15b6c111867e9c3a2a4d12)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "preserveMinorDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultAppend]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultAppend]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultAppend]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8bef3b09bee15621ed46377e53c7d9523f529ab91f2a0b2b402298d18bab848f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultAspectCrop",
    jsii_struct_bases=[],
    name_mapping={
        "allow_expansion": "allowExpansion",
        "allow_expansion_var": "allowExpansionVar",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultAspectCrop:
    def __init__(
        self,
        *,
        allow_expansion: typing.Optional[builtins.str] = None,
        allow_expansion_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_expansion: Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image. Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        :param allow_expansion_var: Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image. Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        :param height: The height term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The width term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        :param x_position: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7f5669bb07179247b67c81398128fc459b5031736e32070ac05c975de2495f9d)
            check_type(argname="argument allow_expansion", value=allow_expansion, expected_type=type_hints["allow_expansion"])
            check_type(argname="argument allow_expansion_var", value=allow_expansion_var, expected_type=type_hints["allow_expansion_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if allow_expansion is not None:
            self._values["allow_expansion"] = allow_expansion
        if allow_expansion_var is not None:
            self._values["allow_expansion_var"] = allow_expansion_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def allow_expansion(self) -> typing.Optional[builtins.str]:
        '''Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image.

        Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        '''
        result = self._values.get("allow_expansion")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def allow_expansion_var(self) -> typing.Optional[builtins.str]:
        '''Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image.

        Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        '''
        result = self._values.get("allow_expansion_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultAspectCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultAspectCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultAspectCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a0402109fe6330d31035d5dfea062ce2c7f6a8a916a983f0547f11d52555de84)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultAspectCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f1aefd048aaf0b9531a63eb13620814deacc32cf538468ed4779ecb0a50f91d2)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultAspectCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c120ff5c18a4b2e97dae62168d00c7f59ac85858005ea6a6f58556eeb28d0ebf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ad9a9f7586b99a7298422c6c86dfda9f876c5d58bca6303db2a343adb98820f5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c963f6b3f024e29c0dccc83d5078b6e89c3d51c7b2b949952ed083490d0c3def)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultAspectCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultAspectCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultAspectCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9fe874dbc45604a4b635289463b7a903f07822e6c73073138769f8e7a847f790)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultAspectCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultAspectCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4f5db3fceea05141c74299cc927d9c68de3770d6a48af8d1d2934f322284233b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAllowExpansion")
    def reset_allow_expansion(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansion", []))

    @jsii.member(jsii_name="resetAllowExpansionVar")
    def reset_allow_expansion_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansionVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionInput")
    def allow_expansion_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVarInput")
    def allow_expansion_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansion")
    def allow_expansion(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansion"))

    @allow_expansion.setter
    def allow_expansion(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4654cd7afc237e5d885b1c67fb04b2a4aa3033401fd57b6afb684539362822c8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansion", value)

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVar")
    def allow_expansion_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansionVar"))

    @allow_expansion_var.setter
    def allow_expansion_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a07ff35cb586362bd5dd08d4ec109a5f42320ef5da010783e69379479476cdf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansionVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f3ba2a741b60e4fce4845067618b3a30b5e914425cc064c6af1ace817e2ffb75)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c7455d48824e9ba76b0d8e187592cd59929aa08d982bc7c36f68f43923e8998e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4974944555367ce555521a2916637c540eba9de34974892f93c5fb527350300e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c24b73fde1624db92e6d71d33aba5e0900e4c7b23d9d7092e736aeec7913b314)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e0f425bb66f7548cbe8c6f9b0ae04d5faa84df64aa77f1c37b326336a2c7a0e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d1aedb5bff9298c25d4c96f829bff99f8e7280efa9853d414df344eae1561f00)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dfaf4ecfada6a1c898a76784ffd4e2c186a4df863184196cb598cb8fce341f9d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9b1982dc4acdb4d15cc82f1b41b9e9b0202f70f469aa46561bff2a88eaae6f7b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultAspectCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultAspectCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultAspectCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__35ac24386e2ac1d756a666c2142474a2060f5dbadb1b945b90591198f889476a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultBackgroundColor",
    jsii_struct_bases=[],
    name_mapping={"color": "color", "color_var": "colorVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultBackgroundColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__45f76b87d457af49c69c40c309bd939757c0d5ddade555bdab5eaa5ff7034fb0)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultBackgroundColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultBackgroundColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultBackgroundColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1b4f43c70a52f919d4c5681e3f2c1ef9c5ac5af95f80a2e655912c607e3b6da0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultBackgroundColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__53fcaf855c6d88f9c30ced50efeed9ef0a7698354bbdf7c1b60a5ca65a5a302d)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultBackgroundColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3b4e174198965b544ce16a7ca4a9a48f17d027b6404c8ed94aa06bc350abf01f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__50fbcc3e3c48939ed23763813fa86ece4ae528b9c032cda5729c7c967f2bd87b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f6e0b0380352160caea5fdb7ccd19aec2c0ffbe324bc21e7ea7921474032779a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultBackgroundColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultBackgroundColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3710e49c8ed34d1c8decef8d95f6a78c2f0ce17565e5c33da3c28e9b456f0a0b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultBackgroundColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultBackgroundColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c15da3f2afb266bc2ea7d2141eecac3253fcd9dc7cefe8a33c792a09cf2dbc06)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__159fade000b33128aaf8a352daee4901cc63ad8eb4b110c644b297a77ed50904)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__98b4ef468e93774cc1613f9e2f8e29264fef2dc00344b1fc56ebf72c3022e24e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultBackgroundColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultBackgroundColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultBackgroundColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a55d43f1c5b50ff9e7e5fc1a10751f0ceb0203ca5c7ee4b91e2ae98d723848bf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultBlur",
    jsii_struct_bases=[],
    name_mapping={"sigma": "sigma", "sigma_var": "sigmaVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultBlur:
    def __init__(
        self,
        *,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param sigma: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8589a4ba9d78a81b1e6c9f888d3620223e98198a3e9c55662f287bab18b2ffaa)
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultBlur(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultBlurList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultBlurList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af06384c34b0279f810a2c71652e27b42e110155b814f6fcd2bc98a45aceaa41)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultBlurOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4d3674d91bb9fb2b121e974606f39828e7f83f7230334e7a8c4260f320aa7b44)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultBlurOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__67ad06da2e32eee51aca03272836f98491d3a5b1da48d7ece7ce599f261d0159)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__00207aa6c78acb78d89e828a2c7f94cacf60bde14b03a75ca1a15ef9fc2dc361)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__34683ed52a6e4d47dcf0fc7daec6b4f43d1cdf2297de1dcf93fd513a18b413d5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultBlur]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultBlur]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a58c2e44abe775b5effd8d23b85866197dd58ae8c39fb0f72aced8790c019a48)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultBlurOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultBlurOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1fc4394380bafa94b0b631279c85a19bb56d6762e5ae75c8d3742d424537f339)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__44314114ea9915e7006391ec91fa502df200b1f1b6e40396ef5fda0764512d53)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__34ef1efc95c444d37f84dc5b33d813677b44d2a196785ff7506d8f1355e9df43)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultBlur]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultBlur]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultBlur]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac4e76c42f6468a67577beb8408d3aa01e52074badd3b84a3bfb668b1c268070)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultChromaKey",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_feather": "hueFeather",
        "hue_feather_var": "hueFeatherVar",
        "hue_tolerance": "hueTolerance",
        "hue_tolerance_var": "hueToleranceVar",
        "hue_var": "hueVar",
        "lightness_feather": "lightnessFeather",
        "lightness_feather_var": "lightnessFeatherVar",
        "lightness_tolerance": "lightnessTolerance",
        "lightness_tolerance_var": "lightnessToleranceVar",
        "saturation_feather": "saturationFeather",
        "saturation_feather_var": "saturationFeatherVar",
        "saturation_tolerance": "saturationTolerance",
        "saturation_tolerance_var": "saturationToleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultChromaKey:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_feather: typing.Optional[builtins.str] = None,
        hue_feather_var: typing.Optional[builtins.str] = None,
        hue_tolerance: typing.Optional[builtins.str] = None,
        hue_tolerance_var: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness_feather: typing.Optional[builtins.str] = None,
        lightness_feather_var: typing.Optional[builtins.str] = None,
        lightness_tolerance: typing.Optional[builtins.str] = None,
        lightness_tolerance_var: typing.Optional[builtins.str] = None,
        saturation_feather: typing.Optional[builtins.str] = None,
        saturation_feather_var: typing.Optional[builtins.str] = None,
        saturation_tolerance: typing.Optional[builtins.str] = None,
        saturation_tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_feather: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        :param hue_feather_var: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        :param hue_tolerance: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        :param hue_tolerance_var: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        :param hue_var: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness_feather: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        :param lightness_feather_var: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        :param lightness_tolerance: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        :param lightness_tolerance_var: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        :param saturation_feather: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        :param saturation_feather_var: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        :param saturation_tolerance: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        :param saturation_tolerance_var: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3088269e92c982a821639c92605dfa4bc00df0776ec6089699807501a061d8f5)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_feather", value=hue_feather, expected_type=type_hints["hue_feather"])
            check_type(argname="argument hue_feather_var", value=hue_feather_var, expected_type=type_hints["hue_feather_var"])
            check_type(argname="argument hue_tolerance", value=hue_tolerance, expected_type=type_hints["hue_tolerance"])
            check_type(argname="argument hue_tolerance_var", value=hue_tolerance_var, expected_type=type_hints["hue_tolerance_var"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness_feather", value=lightness_feather, expected_type=type_hints["lightness_feather"])
            check_type(argname="argument lightness_feather_var", value=lightness_feather_var, expected_type=type_hints["lightness_feather_var"])
            check_type(argname="argument lightness_tolerance", value=lightness_tolerance, expected_type=type_hints["lightness_tolerance"])
            check_type(argname="argument lightness_tolerance_var", value=lightness_tolerance_var, expected_type=type_hints["lightness_tolerance_var"])
            check_type(argname="argument saturation_feather", value=saturation_feather, expected_type=type_hints["saturation_feather"])
            check_type(argname="argument saturation_feather_var", value=saturation_feather_var, expected_type=type_hints["saturation_feather_var"])
            check_type(argname="argument saturation_tolerance", value=saturation_tolerance, expected_type=type_hints["saturation_tolerance"])
            check_type(argname="argument saturation_tolerance_var", value=saturation_tolerance_var, expected_type=type_hints["saturation_tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_feather is not None:
            self._values["hue_feather"] = hue_feather
        if hue_feather_var is not None:
            self._values["hue_feather_var"] = hue_feather_var
        if hue_tolerance is not None:
            self._values["hue_tolerance"] = hue_tolerance
        if hue_tolerance_var is not None:
            self._values["hue_tolerance_var"] = hue_tolerance_var
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness_feather is not None:
            self._values["lightness_feather"] = lightness_feather
        if lightness_feather_var is not None:
            self._values["lightness_feather_var"] = lightness_feather_var
        if lightness_tolerance is not None:
            self._values["lightness_tolerance"] = lightness_tolerance
        if lightness_tolerance_var is not None:
            self._values["lightness_tolerance_var"] = lightness_tolerance_var
        if saturation_feather is not None:
            self._values["saturation_feather"] = saturation_feather
        if saturation_feather_var is not None:
            self._values["saturation_feather_var"] = saturation_feather_var
        if saturation_tolerance is not None:
            self._values["saturation_tolerance"] = saturation_tolerance
        if saturation_tolerance_var is not None:
            self._values["saturation_tolerance_var"] = saturation_tolerance_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        '''
        result = self._values.get("hue_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        '''
        result = self._values.get("hue_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        '''
        result = self._values.get("hue_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        '''
        result = self._values.get("hue_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        '''
        result = self._values.get("lightness_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        '''
        result = self._values.get("lightness_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        '''
        result = self._values.get("lightness_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        '''
        result = self._values.get("lightness_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        '''
        result = self._values.get("saturation_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        '''
        result = self._values.get("saturation_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        '''
        result = self._values.get("saturation_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        result = self._values.get("saturation_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultChromaKey(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultChromaKeyList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultChromaKeyList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a8e7c82f75ad0cb94d137c40703411f9a49987b93632d439cc421edfdd8a319)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultChromaKeyOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e46375bc076e1dcbe77b943e2a6bfe1a3a5d443d75eb63db97b7dd5000b87a7b)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultChromaKeyOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac57ce4bd999df9d7261754f2a231302b3d36128be8c8cb21d5999708e6e43ed)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__80f24866c2db3afd4e395cdffe09fdc0b0ef9811721372e1321d9fb484c6a6c6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f194b2cc60a26fb7361dc18e1c6d28b23f6be63944a6c0aa465dbbd67c5a04a2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultChromaKey]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultChromaKey]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__97e6d2bda4dcfa20b82e4e3a6f1ed02fa6d448654b29d77049fea653a05a8e24)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultChromaKeyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultChromaKeyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6bd40e0ecaa972a8aa884ebb0a47dc2da5ddf7fe265b5bd5dc0184e0ead2c277)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueFeather")
    def reset_hue_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeather", []))

    @jsii.member(jsii_name="resetHueFeatherVar")
    def reset_hue_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeatherVar", []))

    @jsii.member(jsii_name="resetHueTolerance")
    def reset_hue_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueTolerance", []))

    @jsii.member(jsii_name="resetHueToleranceVar")
    def reset_hue_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueToleranceVar", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightnessFeather")
    def reset_lightness_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeather", []))

    @jsii.member(jsii_name="resetLightnessFeatherVar")
    def reset_lightness_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeatherVar", []))

    @jsii.member(jsii_name="resetLightnessTolerance")
    def reset_lightness_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessTolerance", []))

    @jsii.member(jsii_name="resetLightnessToleranceVar")
    def reset_lightness_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessToleranceVar", []))

    @jsii.member(jsii_name="resetSaturationFeather")
    def reset_saturation_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeather", []))

    @jsii.member(jsii_name="resetSaturationFeatherVar")
    def reset_saturation_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeatherVar", []))

    @jsii.member(jsii_name="resetSaturationTolerance")
    def reset_saturation_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationTolerance", []))

    @jsii.member(jsii_name="resetSaturationToleranceVar")
    def reset_saturation_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherInput")
    def hue_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVarInput")
    def hue_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceInput")
    def hue_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVarInput")
    def hue_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherInput")
    def lightness_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVarInput")
    def lightness_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceInput")
    def lightness_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVarInput")
    def lightness_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherInput")
    def saturation_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVarInput")
    def saturation_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceInput")
    def saturation_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVarInput")
    def saturation_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a684ed0e5e2b6e64c8eaf7190da3fe92794f189189f7eccf1b6e36c17bc69e3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeather")
    def hue_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeather"))

    @hue_feather.setter
    def hue_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5db342f555742a5e5d1e064101d6bca857d8952665a5ac1feec049a70b4e74a2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeather", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVar")
    def hue_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeatherVar"))

    @hue_feather_var.setter
    def hue_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d92b3cc5bf1bb5b4ff7f9fa35491bd7bee39ee1dcb31778404ab757f77a87d73)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueTolerance")
    def hue_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueTolerance"))

    @hue_tolerance.setter
    def hue_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d973f9d491596abe21c16209ba891595f05f805e6c5444cacb4371b2d4f23d34)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVar")
    def hue_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueToleranceVar"))

    @hue_tolerance_var.setter
    def hue_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__472fe995e1c6dfae67954c529d6dfd2f51980b3306c7eec6372c53177c703727)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c9c40766d78149098e67299bdb93f1d7a2a002a223dabfb121164dcb8bf74f05)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeather")
    def lightness_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeather"))

    @lightness_feather.setter
    def lightness_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__600d23742f2775f86eb842d612cdc352e0e31c7d0d44ac50c8e491a98bbb5099)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeather", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVar")
    def lightness_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeatherVar"))

    @lightness_feather_var.setter
    def lightness_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9e018e1c7584d53f28dc6a444c5a12a91f962b044706acc6644304ccaa41eba1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessTolerance")
    def lightness_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessTolerance"))

    @lightness_tolerance.setter
    def lightness_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b68e47175df7b68c82b1787a7118860ae5dcc572c03f5bcab9dfef85c47107ac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVar")
    def lightness_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessToleranceVar"))

    @lightness_tolerance_var.setter
    def lightness_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3d65e2bf4f441df13cff05283aa94d077c4070e664cc6b923bd174b2e34a9de2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeather")
    def saturation_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeather"))

    @saturation_feather.setter
    def saturation_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f371dbdb7d87c53c2cee11e5034fa8119c71a2b0580e3071231224c8473ed98a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeather", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVar")
    def saturation_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeatherVar"))

    @saturation_feather_var.setter
    def saturation_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0424ed2218470e53c483f1c8f7d7ce8c28d8ae961087456493cf3e21abf6791e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationTolerance")
    def saturation_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationTolerance"))

    @saturation_tolerance.setter
    def saturation_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__48d6d4b4ee0cd2161e5968e1db5c2d2c6c5c1fadd23047f883df995cc1e12e9c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVar")
    def saturation_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationToleranceVar"))

    @saturation_tolerance_var.setter
    def saturation_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e67f23696d46a7125f7a83be7334b9216d606ca8c48079d4d9f1ef0c447b6a90)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultChromaKey]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultChromaKey]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultChromaKey]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bea90b7f727e2e6722ac09b7836d2ae0cfeb30c53ee0ea9b98f883bf950ad185)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultComposite",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "placement": "placement",
        "placement_var": "placementVar",
        "scale": "scale",
        "scale_dimension": "scaleDimension",
        "scale_dimension_var": "scaleDimensionVar",
        "scale_var": "scaleVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultComposite:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultCompositeImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        placement: typing.Optional[builtins.str] = None,
        placement_var: typing.Optional[builtins.str] = None,
        scale: typing.Optional[builtins.str] = None,
        scale_dimension: typing.Optional[builtins.str] = None,
        scale_dimension_var: typing.Optional[builtins.str] = None,
        scale_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param placement: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        :param placement_var: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        :param scale: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param scale_dimension: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        :param scale_dimension_var: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        :param scale_var: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        :param x_position: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultCompositeImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5bd53b63bf9a109ebe46717bba98f6d53033f7aeb4a1f57aa6a80fdff4557b72)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument placement", value=placement, expected_type=type_hints["placement"])
            check_type(argname="argument placement_var", value=placement_var, expected_type=type_hints["placement_var"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument scale_dimension", value=scale_dimension, expected_type=type_hints["scale_dimension"])
            check_type(argname="argument scale_dimension_var", value=scale_dimension_var, expected_type=type_hints["scale_dimension_var"])
            check_type(argname="argument scale_var", value=scale_var, expected_type=type_hints["scale_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if placement is not None:
            self._values["placement"] = placement
        if placement_var is not None:
            self._values["placement_var"] = placement_var
        if scale is not None:
            self._values["scale"] = scale
        if scale_dimension is not None:
            self._values["scale_dimension"] = scale_dimension
        if scale_dimension_var is not None:
            self._values["scale_dimension_var"] = scale_dimension_var
        if scale_var is not None:
            self._values["scale_var"] = scale_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultCompositeImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultCompositeImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        '''
        result = self._values.get("placement")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement_var(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        '''
        result = self._values.get("placement_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        '''
        result = self._values.get("scale_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        '''
        result = self._values.get("scale_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        '''
        result = self._values.get("scale_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultComposite(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultCompositeImage",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultCompositeImage:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultCompositeImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultCompositeImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultCompositeImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7cc54df1f67132fe9abe345a5ca8c452306d97899973fc44c96531d5f481181a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultCompositeImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultCompositeImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__71d4c24eeaef94ba3f612b06c2a2c07aae8bdfedefe1a25391f35ccd52fdf95f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultCompositeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultCompositeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__188e86555551d57cf5caca14d2640c8b01ba61fedca48a36c18805401dd489e0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultCompositeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__56c880f19f918022d16392b3325cf866c51693eb98ba3fdf650f150bcc2a5869)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultCompositeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c785f4776da601e3a254f8b3c34525277e9ca231e00069729cb277be73381adf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__db13f205921c9b87ac2cd5a3d584008c75acf3da452db49e36885e27fa9d3480)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__589b49543be8694b989be833654ae5fc58fbd54b6df923da85dbbd97e2d6acd6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultComposite]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultComposite]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ff026a634accfe71d25c45f645dbc07dbca7f20779e9f39667081a5bea2680da)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultCompositeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultCompositeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5971f5998b9aba7c8e8a6e036b6b01cebbeb243e820a79afe000ca604c8930da)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultCompositeImage()

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPlacement")
    def reset_placement(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacement", []))

    @jsii.member(jsii_name="resetPlacementVar")
    def reset_placement_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacementVar", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetScaleDimension")
    def reset_scale_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimension", []))

    @jsii.member(jsii_name="resetScaleDimensionVar")
    def reset_scale_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimensionVar", []))

    @jsii.member(jsii_name="resetScaleVar")
    def reset_scale_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultCompositeImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultCompositeImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultCompositeImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="placementInput")
    def placement_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementInput"))

    @builtins.property
    @jsii.member(jsii_name="placementVarInput")
    def placement_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionInput")
    def scale_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVarInput")
    def scale_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleVarInput")
    def scale_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c5320638246d676bc4bae67d45370eb161ec7dc7c87f44399572387391f770c0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ad5044e669b81935dfcbb8c2087449f79134f01f339ec56ac2bd71392cd65681)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="placement")
    def placement(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placement"))

    @placement.setter
    def placement(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5dbb115cedad25086de2bb13a75e4cb87293301f74426b5b373446111cfe2ced)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placement", value)

    @builtins.property
    @jsii.member(jsii_name="placementVar")
    def placement_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placementVar"))

    @placement_var.setter
    def placement_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__15304b23ccc6840bcb7196c0efc1e1179b799377955e7c0312a2aa1f0837fc29)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placementVar", value)

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scale"))

    @scale.setter
    def scale(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ee5ea4abb1374c29b56a298f608a096644ec63eb1a9d502508bb3f536aef8d4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scale", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimension")
    def scale_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimension"))

    @scale_dimension.setter
    def scale_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9162a102327e98d7d8bf1ccf8492ed4587f98087e019f3a8d8938f87fb1b40fe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimension", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVar")
    def scale_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimensionVar"))

    @scale_dimension_var.setter
    def scale_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__90135b3423fb58d1881ca7d971565995345798b40c0d2b7d5f28175ae61ab730)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="scaleVar")
    def scale_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleVar"))

    @scale_var.setter
    def scale_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a19936b6905888a7d7ada413fd8d94a32a81f23e8ab6fda4e5db0a7a86cfc92)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ba5e34d194d35c4d8bc57acca53c58fd4692952ef5ec3dbc7ced103d13aad976)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e78a1662a31c32fb0af7d643525a588b8398bd7875e10f5eb473b83ba4cb98df)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__89e5663d7d6e00a07a6c9730c9eee602d184ea5789a4863a8239795e83105eb3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af7e0c2e90910750407f83b06f6897bf50041cee0ae900d8d77e9a5e9401b2a9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultComposite]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultComposite]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultComposite]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d9a3bb2a7a3a16206f7b25dc23006b0771c4fdb698d2cd553778a82b538bc6d8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultCompound",
    jsii_struct_bases=[],
    name_mapping={"transformations": "transformations"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultCompound:
    def __init__(
        self,
        *,
        transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param transformations: transformations block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ff2af1338023b329d642240db1b2eb8005138809a8d74e9cd6c385c56ba76c6)
            check_type(argname="argument transformations", value=transformations, expected_type=type_hints["transformations"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if transformations is not None:
            self._values["transformations"] = transformations

    @builtins.property
    def transformations(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultCompoundTransformations"]]]:
        '''transformations block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        result = self._values.get("transformations")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultCompoundTransformations"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultCompound(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultCompoundList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultCompoundList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__31f7288057f700c213e9cd06c2c3cc2f1acbb64ae73d9ffa9c58d36f97d31cce)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultCompoundOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f72cdf1aa097637962b670c073ce75d51194f467ab35769a703f1229331fb8f0)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultCompoundOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0f76c28f4378a71b8ab700531f52b60bf89b8732d2cd5a6c6a49bca6ac8f13d4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cee63a8c640670aa378dc2a1710cfd6d496ce6e9d46fc05091ffe7f2125a79a2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ae0f7011c7e2be5a1ae588d7f519bd86059cf628bde3b5dfa9226ef8b94860e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultCompound]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultCompound]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fdc6a3242790dbcddef0c513ea795dde384925a80e16a8649debe088ef3cd00c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultCompoundOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultCompoundOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ae7347ebf389cfc03e3a342ae475f436b672052d3ff1d1fc38fd92e02a6bbcb7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformations")
    def put_transformations(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__45307c0c8308283859f063483fe3958b3235ad493fc43692f28b112da8df2c97)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTransformations", [value]))

    @jsii.member(jsii_name="resetTransformations")
    def reset_transformations(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformations", []))

    @builtins.property
    @jsii.member(jsii_name="transformations")
    def transformations(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultCompoundTransformationsList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultCompoundTransformationsList", jsii.get(self, "transformations"))

    @builtins.property
    @jsii.member(jsii_name="transformationsInput")
    def transformations_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultCompoundTransformations"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultCompoundTransformations"]]], jsii.get(self, "transformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultCompound]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultCompound]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultCompound]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5b5b182e93bcbde75df68402d5e77ed92e40319a13a15274ed17225eb553e0dc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultCompoundTransformations",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultCompoundTransformations:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultCompoundTransformations(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultCompoundTransformationsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultCompoundTransformationsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ca60e5497cf24d43219ebea9fda4d63ff84f0dfbeb93502c5ff343eceb6f2871)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultCompoundTransformationsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__55c485228a3ab26fdc88656c3763deeafd808f9353933b7f80af3acd2278df5a)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultCompoundTransformationsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__877c6ddefa4280dc01a789471c653b31959637e4e8650316d424ee479fe52ef5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4024fae4920be5f0c8814b6fd3cfe8b9d39ad25476b5313ef5e3790eb11e4432)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c7ffc621104a53789fdb14e30a43afbdf2d82ea9aedb147c632b5ac82c015428)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultCompoundTransformations]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultCompoundTransformations]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultCompoundTransformations]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e724279026b39d9dd2b581c55ad92629e64d4eef84c0286b5f1318e124c53386)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultCompoundTransformationsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultCompoundTransformationsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f8b85860d35a5765d085b18665c2c7c1a3183a0ada1b13a2a2506c2f9123a91)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultCompoundTransformations]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultCompoundTransformations]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultCompoundTransformations]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f7cbb551207f4e2b9a83b13b7ad72312366ebec7f1718e9caa4c113d2065437)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultContrast",
    jsii_struct_bases=[],
    name_mapping={
        "brightness": "brightness",
        "brightness_var": "brightnessVar",
        "contrast": "contrast",
        "contrast_var": "contrastVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultContrast:
    def __init__(
        self,
        *,
        brightness: typing.Optional[builtins.str] = None,
        brightness_var: typing.Optional[builtins.str] = None,
        contrast: typing.Optional[builtins.str] = None,
        contrast_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param brightness: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        :param brightness_var: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        :param contrast: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param contrast_var: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3cb5380c4ccab7fa75814239c8e80a3adc0615039f21d612c0f917e0df6ac03b)
            check_type(argname="argument brightness", value=brightness, expected_type=type_hints["brightness"])
            check_type(argname="argument brightness_var", value=brightness_var, expected_type=type_hints["brightness_var"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument contrast_var", value=contrast_var, expected_type=type_hints["contrast_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if brightness is not None:
            self._values["brightness"] = brightness
        if brightness_var is not None:
            self._values["brightness_var"] = brightness_var
        if contrast is not None:
            self._values["contrast"] = contrast
        if contrast_var is not None:
            self._values["contrast_var"] = contrast_var

    @builtins.property
    def brightness(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        '''
        result = self._values.get("brightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def brightness_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        '''
        result = self._values.get("brightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        result = self._values.get("contrast_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultContrast(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultContrastList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultContrastList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d6e567c1189bb76b26e2c77744a9910bc7234a5d6fd8e9fd7d8915b7c1040b3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultContrastOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0449be4d63b315cf4fc5ffe56dd10a63de7c6d7451e9ffe5a0eb2a6bde4d05d9)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultContrastOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cefe8e598866b38e4a9132b568161170fed1faf78fbf62577f62ed927643a146)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a1db105482d341975858f6c55bac65bdb1db2ee89ce2b4cd672c0bd590663a75)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__28a80513d54e1c15c3bb4bbf75e194382e84de84ce4c9e80b5a3cb68c52a5123)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultContrast]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultContrast]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9010ee42da0c4a1f999a6a9fdb65d39b771fa7a19ba2dee65a74574e177c18b3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultContrastOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultContrastOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0dd28d3183380ed4718c3f68770e40309530dad48b472f46d679245b85568efb)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetBrightness")
    def reset_brightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightness", []))

    @jsii.member(jsii_name="resetBrightnessVar")
    def reset_brightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightnessVar", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetContrastVar")
    def reset_contrast_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrastVar", []))

    @builtins.property
    @jsii.member(jsii_name="brightnessInput")
    def brightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="brightnessVarInput")
    def brightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastVarInput")
    def contrast_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="brightness")
    def brightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightness"))

    @brightness.setter
    def brightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__77db00e153652aeea351c24ace8ed4825a2215a837371d86c6a5108dfe2114b7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightness", value)

    @builtins.property
    @jsii.member(jsii_name="brightnessVar")
    def brightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightnessVar"))

    @brightness_var.setter
    def brightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f1873b9bc6faefb8953e9460d6c74a75955d68c0fb228e469d156a3e91c8f6c9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrast"))

    @contrast.setter
    def contrast(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__35ea16cca9440fb5a6f190d7cb9ab4ce4a4b0187c35852ab1887f6a5e2c12971)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrast", value)

    @builtins.property
    @jsii.member(jsii_name="contrastVar")
    def contrast_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrastVar"))

    @contrast_var.setter
    def contrast_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__02821890bbcf41b3a5b45cf5b44267772179ca4f1883d9e76ab97e5f6e51bb97)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrastVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultContrast]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultContrast]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultContrast]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fe7060a9c10b47592c4a6c87fdb2d4222792965d639db849004db1e8997ffff9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultCrop",
    jsii_struct_bases=[],
    name_mapping={
        "allow_expansion": "allowExpansion",
        "allow_expansion_var": "allowExpansionVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultCrop:
    def __init__(
        self,
        *,
        allow_expansion: typing.Optional[builtins.str] = None,
        allow_expansion_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_expansion: If cropping an area outside of the existing canvas, expands the image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        :param allow_expansion_var: If cropping an area outside of the existing canvas, expands the image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        :param gravity: Frame of reference for X and Y Positions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Frame of reference for X and Y Positions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The number of pixels to crop along the y-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The number of pixels to crop along the y-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The number of pixels to crop along the x-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The number of pixels to crop along the x-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        :param x_position: The x-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__03b65face867b45552b20f144343929fa03ade2eb3509e470ac051068bbcb915)
            check_type(argname="argument allow_expansion", value=allow_expansion, expected_type=type_hints["allow_expansion"])
            check_type(argname="argument allow_expansion_var", value=allow_expansion_var, expected_type=type_hints["allow_expansion_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if allow_expansion is not None:
            self._values["allow_expansion"] = allow_expansion
        if allow_expansion_var is not None:
            self._values["allow_expansion_var"] = allow_expansion_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def allow_expansion(self) -> typing.Optional[builtins.str]:
        '''If cropping an area outside of the existing canvas, expands the image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        '''
        result = self._values.get("allow_expansion")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def allow_expansion_var(self) -> typing.Optional[builtins.str]:
        '''If cropping an area outside of the existing canvas, expands the image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        '''
        result = self._values.get("allow_expansion_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Frame of reference for X and Y Positions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Frame of reference for X and Y Positions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the y-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the y-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the x-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the x-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__35811263b6af6ec602bb066589b28d29e207a367de619c94fb9d81b3c1ffa6cf)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac464dea9e2ca3bd4aab391f3b8ad5cf26b9153fa9778f884780e52f8b7ee222)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__35ac9c0cac69654b5b94dfc036ff7623623819e8e928e42650c68870f5dc534c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d63dd6ae57378b3a9fe35c3de0047125f9273899c6d63ba488d85b8f22d4788d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__83232e8cc8266c5a7298db790d1a445ad1d647415f5197c6962c3f1a7a64a6c8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a40dee5c0ee877698d2b17ef2f44073c259e624025919aa8cf06ac8e97c3259)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5cca3c4118768af22a19d602510caff2bed60f3af6f728debb3904abf0694563)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAllowExpansion")
    def reset_allow_expansion(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansion", []))

    @jsii.member(jsii_name="resetAllowExpansionVar")
    def reset_allow_expansion_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansionVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionInput")
    def allow_expansion_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVarInput")
    def allow_expansion_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansion")
    def allow_expansion(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansion"))

    @allow_expansion.setter
    def allow_expansion(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4da7a06bccf896ebc91fcd282cdae93d69ffca1e26d1dbb4f9eb4d04579fb6e2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansion", value)

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVar")
    def allow_expansion_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansionVar"))

    @allow_expansion_var.setter
    def allow_expansion_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__03a980c5cb12c5e987c80c6ee4b63906311959e38b15dec2e84dfde3d5949f2f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansionVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__348b4bf3115f77e4649a91cb51363569eb96a792af7a72c58b44d603e21865d0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8da345499214af3bef4d984e1c0c3e52867f85cae9b89bf7ea45c3c749a0c4d3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__24bbe7c4f24cbb337b526b8578c74619f3be5db649a661a6d9c6ea8bd070880f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc8fec0eca07c41ad8d22b17a002879bc3173f4012e11415d46651363c3a7ee0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac421e952b40e1f4dbcce742ba9df7a36c31cc0c8ce111b2f387c78397109da1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8631f1c963776589b9813074558bc2f6f17ee7301e76fdf99023929e749df4e5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f036a0c77b507f5dd6cc3acc87c1449d0bcfa343f34fa5bd738fd4db3903d4f0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f2dc0ffc60cf02d418aecd95b57f05ba2f260f480f9a79834aa4c7f7bdadfff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__080182c3b53496350d36641ac309d89dc526bc43c4804cdb22ea19bc6b02376c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a8d705f1d1f3dc2ecd819f0b0167357a0a2b95b4251595d6e41aa1fe5655715e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__517002caae9009d98badc5f96f0619531a2b86100a07e9c65eeea74c8b76f900)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultFaceCrop",
    jsii_struct_bases=[],
    name_mapping={
        "algorithm": "algorithm",
        "algorithm_var": "algorithmVar",
        "confidence": "confidence",
        "confidence_var": "confidenceVar",
        "fail_gravity": "failGravity",
        "fail_gravity_var": "failGravityVar",
        "focus": "focus",
        "focus_var": "focusVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "padding": "padding",
        "padding_var": "paddingVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultFaceCrop:
    def __init__(
        self,
        *,
        algorithm: typing.Optional[builtins.str] = None,
        algorithm_var: typing.Optional[builtins.str] = None,
        confidence: typing.Optional[builtins.str] = None,
        confidence_var: typing.Optional[builtins.str] = None,
        fail_gravity: typing.Optional[builtins.str] = None,
        fail_gravity_var: typing.Optional[builtins.str] = None,
        focus: typing.Optional[builtins.str] = None,
        focus_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param algorithm: Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm DataAkamaiImagingPolicyImage#algorithm}
        :param algorithm_var: Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm_var DataAkamaiImagingPolicyImage#algorithm_var}
        :param confidence: With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image. Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence DataAkamaiImagingPolicyImage#confidence}
        :param confidence_var: With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image. Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence_var DataAkamaiImagingPolicyImage#confidence_var}
        :param fail_gravity: Controls placement of the crop if Image and Video Manager does not detect any faces in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        :param fail_gravity_var: Controls placement of the crop if Image and Video Manager does not detect any faces in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        :param focus: Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus DataAkamaiImagingPolicyImage#focus}
        :param focus_var: Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus_var DataAkamaiImagingPolicyImage#focus_var}
        :param gravity: Controls placement of the crop. Directions are relative to the face(s) plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Controls placement of the crop. Directions are relative to the face(s) plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param padding: The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        :param style: Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__26d68b6c9d4f689294568c3865591a105c82ee3f68efb0c3ffef2d7733c87490)
            check_type(argname="argument algorithm", value=algorithm, expected_type=type_hints["algorithm"])
            check_type(argname="argument algorithm_var", value=algorithm_var, expected_type=type_hints["algorithm_var"])
            check_type(argname="argument confidence", value=confidence, expected_type=type_hints["confidence"])
            check_type(argname="argument confidence_var", value=confidence_var, expected_type=type_hints["confidence_var"])
            check_type(argname="argument fail_gravity", value=fail_gravity, expected_type=type_hints["fail_gravity"])
            check_type(argname="argument fail_gravity_var", value=fail_gravity_var, expected_type=type_hints["fail_gravity_var"])
            check_type(argname="argument focus", value=focus, expected_type=type_hints["focus"])
            check_type(argname="argument focus_var", value=focus_var, expected_type=type_hints["focus_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if algorithm is not None:
            self._values["algorithm"] = algorithm
        if algorithm_var is not None:
            self._values["algorithm_var"] = algorithm_var
        if confidence is not None:
            self._values["confidence"] = confidence
        if confidence_var is not None:
            self._values["confidence_var"] = confidence_var
        if fail_gravity is not None:
            self._values["fail_gravity"] = fail_gravity
        if fail_gravity_var is not None:
            self._values["fail_gravity_var"] = fail_gravity_var
        if focus is not None:
            self._values["focus"] = focus
        if focus_var is not None:
            self._values["focus_var"] = focus_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def algorithm(self) -> typing.Optional[builtins.str]:
        '''Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm DataAkamaiImagingPolicyImage#algorithm}
        '''
        result = self._values.get("algorithm")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def algorithm_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm_var DataAkamaiImagingPolicyImage#algorithm_var}
        '''
        result = self._values.get("algorithm_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def confidence(self) -> typing.Optional[builtins.str]:
        '''With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image.

        Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence DataAkamaiImagingPolicyImage#confidence}
        '''
        result = self._values.get("confidence")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def confidence_var(self) -> typing.Optional[builtins.str]:
        '''With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image.

        Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence_var DataAkamaiImagingPolicyImage#confidence_var}
        '''
        result = self._values.get("confidence_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any faces in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        '''
        result = self._values.get("fail_gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any faces in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        '''
        result = self._values.get("fail_gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def focus(self) -> typing.Optional[builtins.str]:
        '''Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus DataAkamaiImagingPolicyImage#focus}
        '''
        result = self._values.get("focus")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def focus_var(self) -> typing.Optional[builtins.str]:
        '''Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus_var DataAkamaiImagingPolicyImage#focus_var}
        '''
        result = self._values.get("focus_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the face(s) plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the face(s) plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultFaceCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultFaceCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultFaceCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a2d26eab299c361cef35cef6f91bedae84827094dad7b286e297431ab0640382)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultFaceCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7ea454a6e5c824105e9a22d2c91361fe797d420e686ef436afc34a661157cc4f)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultFaceCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab8b8269b61006303dbf475472f86750d66e511868c9ca668141d7aa268b4e9d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fb514e2a5b9d66644622be3a569cf568261d64a9ca7abed31fd14c19eb19a3bb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8dd8aa6ccc4559d1e0cefea803874545e362ac7fd8500a836f769d4bc93e9b82)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultFaceCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultFaceCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultFaceCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__501996500b7e88250fd17e08418f8bea6acb08e79e5e2c3d1878e89575050ed5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultFaceCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultFaceCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__05d163a5c5769582c7532ec76c75c9872796289fcd1b9879178047f609ab2fa3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAlgorithm")
    def reset_algorithm(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAlgorithm", []))

    @jsii.member(jsii_name="resetAlgorithmVar")
    def reset_algorithm_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAlgorithmVar", []))

    @jsii.member(jsii_name="resetConfidence")
    def reset_confidence(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetConfidence", []))

    @jsii.member(jsii_name="resetConfidenceVar")
    def reset_confidence_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetConfidenceVar", []))

    @jsii.member(jsii_name="resetFailGravity")
    def reset_fail_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravity", []))

    @jsii.member(jsii_name="resetFailGravityVar")
    def reset_fail_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravityVar", []))

    @jsii.member(jsii_name="resetFocus")
    def reset_focus(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFocus", []))

    @jsii.member(jsii_name="resetFocusVar")
    def reset_focus_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFocusVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="algorithmInput")
    def algorithm_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "algorithmInput"))

    @builtins.property
    @jsii.member(jsii_name="algorithmVarInput")
    def algorithm_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "algorithmVarInput"))

    @builtins.property
    @jsii.member(jsii_name="confidenceInput")
    def confidence_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "confidenceInput"))

    @builtins.property
    @jsii.member(jsii_name="confidenceVarInput")
    def confidence_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "confidenceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityInput")
    def fail_gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityVarInput")
    def fail_gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="focusInput")
    def focus_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "focusInput"))

    @builtins.property
    @jsii.member(jsii_name="focusVarInput")
    def focus_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "focusVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="algorithm")
    def algorithm(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "algorithm"))

    @algorithm.setter
    def algorithm(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__11313ba58bfac992b0ef7bc16c8bbcc3bfb90cab94c057162c16ec7dda99537c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "algorithm", value)

    @builtins.property
    @jsii.member(jsii_name="algorithmVar")
    def algorithm_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "algorithmVar"))

    @algorithm_var.setter
    def algorithm_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e96d52c17a4fc6f7d6d02f954ca6496fea18934a583f84a9662865ebe6289e55)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "algorithmVar", value)

    @builtins.property
    @jsii.member(jsii_name="confidence")
    def confidence(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "confidence"))

    @confidence.setter
    def confidence(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bae78f61c18fcd33bd469e9351c353a689e94c28354df14e778a64ba885c51cb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "confidence", value)

    @builtins.property
    @jsii.member(jsii_name="confidenceVar")
    def confidence_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "confidenceVar"))

    @confidence_var.setter
    def confidence_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f122f7ae05e616f21b36605196089caea4760ba951118304b23d81899ebe3283)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "confidenceVar", value)

    @builtins.property
    @jsii.member(jsii_name="failGravity")
    def fail_gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravity"))

    @fail_gravity.setter
    def fail_gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c2b7a66be00c5c2540b9dc22d7dbf3cd4f244f5835d23f178f18359b44261158)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravity", value)

    @builtins.property
    @jsii.member(jsii_name="failGravityVar")
    def fail_gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravityVar"))

    @fail_gravity_var.setter
    def fail_gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af411be1e28973ea22d409323ea0369ad661e6b30e6e95709dcba081c5a25601)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="focus")
    def focus(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "focus"))

    @focus.setter
    def focus(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1cdd864eb4bf9bd8fa2aef93cb61bd64f11ec87475693861d5363e512d1feb5c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "focus", value)

    @builtins.property
    @jsii.member(jsii_name="focusVar")
    def focus_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "focusVar"))

    @focus_var.setter
    def focus_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__de567eb919f6d386a27c53b2de04b3b41c342e9eabfc81fec8bc4f3425c8962f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "focusVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__89d2027d57a91a837bc82ab2594adf82666456a2d775f658b50c9c1cf25c3681)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__734838013c0af18ac24f77216827b925d0d12a91d49e5c88f6f62e683a8a1386)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a502afa0348abf0a87bbbacca24256908d15f1e0459af098c898fe962e4756c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__89baa7663e43a9894032fae3a7093ad3100ee00655ec575d0829d23795cc0943)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__551b5bef632a8a06c46d891ee4555672cb2cf6abcccef7b19ccddf1f33d44722)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1db6b31d67a9f6a37a9998f192f47800449ff97a25a85384b268204a91be4f99)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4e7a346587177ebe4c8390bad8db76c3f4789a5d90a356e5726b61811cf881e2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a9dc5a7aa70a34c7666ab5cb69434d77c46e681a43355ca275da2a1dd57abba5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__76597cf2714d9f8cb48bd268b6171402840489ef8e50b1c06ebace1bfd10ad43)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea3a59d13c9a9c8d016ebf6c13acf9a7b7a17246da8d56ae25b72062b7e7c022)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultFaceCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultFaceCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultFaceCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__972b9eaab2f899e190c5fbe614ffceaa39bd055965f47cb608721fe3b58f81f4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultFeatureCrop",
    jsii_struct_bases=[],
    name_mapping={
        "fail_gravity": "failGravity",
        "fail_gravity_var": "failGravityVar",
        "feature_radius": "featureRadius",
        "feature_radius_var": "featureRadiusVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "max_features": "maxFeatures",
        "max_features_var": "maxFeaturesVar",
        "min_feature_quality": "minFeatureQuality",
        "min_feature_quality_var": "minFeatureQualityVar",
        "padding": "padding",
        "padding_var": "paddingVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultFeatureCrop:
    def __init__(
        self,
        *,
        fail_gravity: typing.Optional[builtins.str] = None,
        fail_gravity_var: typing.Optional[builtins.str] = None,
        feature_radius: typing.Optional[builtins.str] = None,
        feature_radius_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        max_features: typing.Optional[builtins.str] = None,
        max_features_var: typing.Optional[builtins.str] = None,
        min_feature_quality: typing.Optional[builtins.str] = None,
        min_feature_quality_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fail_gravity: Controls placement of the crop if Image and Video Manager does not detect any features in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        :param fail_gravity_var: Controls placement of the crop if Image and Video Manager does not detect any features in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        :param feature_radius: The size in pixels of the important features to search for. If identified, two features never appear closer together than this value, ``8.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius DataAkamaiImagingPolicyImage#feature_radius}
        :param feature_radius_var: The size in pixels of the important features to search for. If identified, two features never appear closer together than this value, ``8.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius_var DataAkamaiImagingPolicyImage#feature_radius_var}
        :param gravity: Controls placement of the crop. Directions are relative to the region of interest plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Controls placement of the crop. Directions are relative to the region of interest plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param max_features: The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features DataAkamaiImagingPolicyImage#max_features}
        :param max_features_var: The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features_var DataAkamaiImagingPolicyImage#max_features_var}
        :param min_feature_quality: Determines the minimum quality level of the feature identified. To consider a feature important, the feature needs to surpass this value. Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality DataAkamaiImagingPolicyImage#min_feature_quality}
        :param min_feature_quality_var: Determines the minimum quality level of the feature identified. To consider a feature important, the feature needs to surpass this value. Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality_var DataAkamaiImagingPolicyImage#min_feature_quality_var}
        :param padding: Adds space around the region of interest. The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: Adds space around the region of interest. The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        :param style: Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__50484cf46b0bed9e4edfcbfaeb7cd1b2739b126de98e784f313c2210893316c2)
            check_type(argname="argument fail_gravity", value=fail_gravity, expected_type=type_hints["fail_gravity"])
            check_type(argname="argument fail_gravity_var", value=fail_gravity_var, expected_type=type_hints["fail_gravity_var"])
            check_type(argname="argument feature_radius", value=feature_radius, expected_type=type_hints["feature_radius"])
            check_type(argname="argument feature_radius_var", value=feature_radius_var, expected_type=type_hints["feature_radius_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument max_features", value=max_features, expected_type=type_hints["max_features"])
            check_type(argname="argument max_features_var", value=max_features_var, expected_type=type_hints["max_features_var"])
            check_type(argname="argument min_feature_quality", value=min_feature_quality, expected_type=type_hints["min_feature_quality"])
            check_type(argname="argument min_feature_quality_var", value=min_feature_quality_var, expected_type=type_hints["min_feature_quality_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fail_gravity is not None:
            self._values["fail_gravity"] = fail_gravity
        if fail_gravity_var is not None:
            self._values["fail_gravity_var"] = fail_gravity_var
        if feature_radius is not None:
            self._values["feature_radius"] = feature_radius
        if feature_radius_var is not None:
            self._values["feature_radius_var"] = feature_radius_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if max_features is not None:
            self._values["max_features"] = max_features
        if max_features_var is not None:
            self._values["max_features_var"] = max_features_var
        if min_feature_quality is not None:
            self._values["min_feature_quality"] = min_feature_quality
        if min_feature_quality_var is not None:
            self._values["min_feature_quality_var"] = min_feature_quality_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def fail_gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any features in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        '''
        result = self._values.get("fail_gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any features in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        '''
        result = self._values.get("fail_gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feature_radius(self) -> typing.Optional[builtins.str]:
        '''The size in pixels of the important features to search for.

        If identified, two features never appear closer together than this value, ``8.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius DataAkamaiImagingPolicyImage#feature_radius}
        '''
        result = self._values.get("feature_radius")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feature_radius_var(self) -> typing.Optional[builtins.str]:
        '''The size in pixels of the important features to search for.

        If identified, two features never appear closer together than this value, ``8.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius_var DataAkamaiImagingPolicyImage#feature_radius_var}
        '''
        result = self._values.get("feature_radius_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the region of interest plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the region of interest plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def max_features(self) -> typing.Optional[builtins.str]:
        '''The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features DataAkamaiImagingPolicyImage#max_features}
        '''
        result = self._values.get("max_features")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def max_features_var(self) -> typing.Optional[builtins.str]:
        '''The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features_var DataAkamaiImagingPolicyImage#max_features_var}
        '''
        result = self._values.get("max_features_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def min_feature_quality(self) -> typing.Optional[builtins.str]:
        '''Determines the minimum quality level of the feature identified.

        To consider a feature important, the feature needs to surpass this value.  Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality DataAkamaiImagingPolicyImage#min_feature_quality}
        '''
        result = self._values.get("min_feature_quality")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def min_feature_quality_var(self) -> typing.Optional[builtins.str]:
        '''Determines the minimum quality level of the feature identified.

        To consider a feature important, the feature needs to surpass this value.  Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality_var DataAkamaiImagingPolicyImage#min_feature_quality_var}
        '''
        result = self._values.get("min_feature_quality_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''Adds space around the region of interest.

        The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''Adds space around the region of interest.

        The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultFeatureCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultFeatureCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultFeatureCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__505fb0a9b5030970fa67a66657b3b4764a5e076b59064a536cbfb6f7660c7d3c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultFeatureCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e101ebba0190b366c9264e27ef65d00884195cb617da791fd67012da7cdffb6b)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultFeatureCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__510f2edcf9271d2d06e30e905b5cdac7eaf24350e0c2b3c78e1cb7ddf0354ae9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a58febb3a2814f0aef5bb3760f3b1692c46acacb381b6a512e9f9f677d8353b4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a13a106b16ed7d3cdfcf73a1c9b1817e3473f92cc6ea9b97c7e7899d9fe9c4d3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultFeatureCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultFeatureCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultFeatureCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8039fe3af822b2d05cbc90acf77e26a1a013192e533b13e5e4d9a64addc93a81)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultFeatureCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultFeatureCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__53d6e7a8f0577d85da1aff265adecd233532be47d102bb0299567e4d2a310386)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetFailGravity")
    def reset_fail_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravity", []))

    @jsii.member(jsii_name="resetFailGravityVar")
    def reset_fail_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravityVar", []))

    @jsii.member(jsii_name="resetFeatureRadius")
    def reset_feature_radius(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureRadius", []))

    @jsii.member(jsii_name="resetFeatureRadiusVar")
    def reset_feature_radius_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureRadiusVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetMaxFeatures")
    def reset_max_features(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxFeatures", []))

    @jsii.member(jsii_name="resetMaxFeaturesVar")
    def reset_max_features_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxFeaturesVar", []))

    @jsii.member(jsii_name="resetMinFeatureQuality")
    def reset_min_feature_quality(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMinFeatureQuality", []))

    @jsii.member(jsii_name="resetMinFeatureQualityVar")
    def reset_min_feature_quality_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMinFeatureQualityVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="failGravityInput")
    def fail_gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityVarInput")
    def fail_gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featureRadiusInput")
    def feature_radius_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featureRadiusInput"))

    @builtins.property
    @jsii.member(jsii_name="featureRadiusVarInput")
    def feature_radius_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featureRadiusVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesInput")
    def max_features_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "maxFeaturesInput"))

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesVarInput")
    def max_features_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "maxFeaturesVarInput"))

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityInput")
    def min_feature_quality_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "minFeatureQualityInput"))

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityVarInput")
    def min_feature_quality_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "minFeatureQualityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravity")
    def fail_gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravity"))

    @fail_gravity.setter
    def fail_gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dd6136593b60348e51fbcf8f0d9c64e2bf78bcae853f1b0612a2f135cab9e246)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravity", value)

    @builtins.property
    @jsii.member(jsii_name="failGravityVar")
    def fail_gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravityVar"))

    @fail_gravity_var.setter
    def fail_gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fdfaa067a88ac28f867f8ecd04fce5a401672a06b2154d207373a53fea6e1728)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="featureRadius")
    def feature_radius(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featureRadius"))

    @feature_radius.setter
    def feature_radius(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__86c2ced9fb9faf2e2d546504b6abd18f98d6e9b9d94e02d29878dbcf86a1897c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featureRadius", value)

    @builtins.property
    @jsii.member(jsii_name="featureRadiusVar")
    def feature_radius_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featureRadiusVar"))

    @feature_radius_var.setter
    def feature_radius_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2631ed290fccd60b4d412ef0f8840d0ff50612fd6402aaf82db894c103018fde)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featureRadiusVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__64bb52579feae80966f9e20cc4c27ab31b07ec8c50cc326063742c2e9a0eba6d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c202cff3a31eba690317effcc9e2123dc16f30d5dedddbbccb414957f338829b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4bf978c38805cd6d848c2c0ddc0997ee262fc42dff3f2baccac00e6ac2dfa6af)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7446fc1f49d73170bbca3a69942c391d4b3f61edee21121dcf65d261ef5370f4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="maxFeatures")
    def max_features(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "maxFeatures"))

    @max_features.setter
    def max_features(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6aab5da5ee5bb5924a1ccc6c7725037b896b20fefedbbf183c22f7481e6dd04d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "maxFeatures", value)

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesVar")
    def max_features_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "maxFeaturesVar"))

    @max_features_var.setter
    def max_features_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b69ac096f3906cb6ecc98312d10563460736eb30ce6d1159ac131a32890c5881)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "maxFeaturesVar", value)

    @builtins.property
    @jsii.member(jsii_name="minFeatureQuality")
    def min_feature_quality(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "minFeatureQuality"))

    @min_feature_quality.setter
    def min_feature_quality(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5d800468b177e4d7e83c914526b6ee6a4cde165f558b83477a4e4ff6aef590a7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "minFeatureQuality", value)

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityVar")
    def min_feature_quality_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "minFeatureQualityVar"))

    @min_feature_quality_var.setter
    def min_feature_quality_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__55257249a166d9fe0739231b285124f0b22353521f61744797a1e6365e5e3940)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "minFeatureQualityVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fd1dbafeb1e75637fc27c7ef936de89f9a377cff4f6414a25206f132bfc7c2d3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e83ce9b63d8f3ac0129b77ba4353d58786232adcd8b68d885f08bab003425b9f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bba115add5a6c90b2a86eb4d3c95e967917b459e0a83d5ad2aa51ba8de2496b0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ae28704d66c63d385114c6ea15e87ac5254a06c4d4d2d53aa2e6c87fc641c66)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4312f8435c6efb5f5c33f2e894134fdeeb1a17a7bc8988ae28ff51b679cd07da)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6fbfb7499e1e056500dea0fa088c755107bbcdebe5e8c59b1f45cd0ca393d73e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultFeatureCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultFeatureCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultFeatureCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b4b7db630b37f77f89f831daee5563385bfce37eab137160f5e1f5815c140c14)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultFitAndFill",
    jsii_struct_bases=[],
    name_mapping={
        "fill_transformation": "fillTransformation",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultFitAndFill:
    def __init__(
        self,
        *,
        fill_transformation: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultFitAndFillFillTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fill_transformation: fill_transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_transformation DataAkamaiImagingPolicyImage#fill_transformation}
        :param height: The height value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The width value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(fill_transformation, dict):
            fill_transformation = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultFitAndFillFillTransformation(**fill_transformation)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa5b6d6241c2dd06f246041c1f45a9a56b00e039371c254f19426cf053bb7a5c)
            check_type(argname="argument fill_transformation", value=fill_transformation, expected_type=type_hints["fill_transformation"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fill_transformation is not None:
            self._values["fill_transformation"] = fill_transformation
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def fill_transformation(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultFitAndFillFillTransformation"]:
        '''fill_transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_transformation DataAkamaiImagingPolicyImage#fill_transformation}
        '''
        result = self._values.get("fill_transformation")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultFitAndFillFillTransformation"], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultFitAndFill(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultFitAndFillFillTransformation",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultFitAndFillFillTransformation:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultFitAndFillFillTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultFitAndFillFillTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultFitAndFillFillTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__707f87b3e36536fdd00b9b277e98f34ee9c7873d3f08a8a6737aa33c69bc6494)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultFitAndFillFillTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultFitAndFillFillTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultFitAndFillFillTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3872d89be5c3eeda16317c3659ccaca39afe8d33f18cfd083f9f9a67dbc3ca16)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultFitAndFillList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultFitAndFillList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__807ee7a83cce9ea13dbf856435ad953a2e730a17555373fd8e6fc8d0c622dde2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultFitAndFillOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9c7a43e453ad05fdce0981a33e279663b87d6c6863c85c53610ff4b2978d336a)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultFitAndFillOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d1fe3685029e23579946da728480f5d842114e847d722f217b2804c463a10ae6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__19a6dc467f90d1699c7a583cca9973fefe6a3c5071a4072badd0536ab911d79e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d8e4ac2026d9dbf9b643b101cf2c5450aac462d026eccd9e2222d33192dfd6a0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultFitAndFill]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultFitAndFill]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultFitAndFill]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f6bebc8ff1708aaed4f1cb031dc980c72e06a620af796976975d54f8c841d4d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultFitAndFillOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultFitAndFillOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fb1fde279da872f0bca0394f8c2c0f40fd013c85281493943990a77be1257956)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putFillTransformation")
    def put_fill_transformation(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultFitAndFillFillTransformation()

        return typing.cast(None, jsii.invoke(self, "putFillTransformation", [value]))

    @jsii.member(jsii_name="resetFillTransformation")
    def reset_fill_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFillTransformation", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="fillTransformation")
    def fill_transformation(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultFitAndFillFillTransformationOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultFitAndFillFillTransformationOutputReference, jsii.get(self, "fillTransformation"))

    @builtins.property
    @jsii.member(jsii_name="fillTransformationInput")
    def fill_transformation_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultFitAndFillFillTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultFitAndFillFillTransformation], jsii.get(self, "fillTransformationInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0bfa45ce4cd1c8f98a6e6c8a35fb3325303d80fa1e265f575bdc6647e7ec9f02)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__31e0850d46ffe2aab699e36e12b5a35e9a1ecd3f8415281fb0747721fb89e15a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__158d65f7b96f5382ee3516ccaf0ea4b1dd623888fb234eac4a51369376c1b1e7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7c5ddc271bd6e7a52c0cbc7dac272e343976757b02fb246674c7eafe8734ae80)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultFitAndFill]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultFitAndFill]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultFitAndFill]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1ef644b00ade959f4f9b31f4212c92a690a41f1df26bdaff3e80ab480a1acd39)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultGoop",
    jsii_struct_bases=[],
    name_mapping={
        "chaos": "chaos",
        "chaos_var": "chaosVar",
        "density": "density",
        "density_var": "densityVar",
        "power": "power",
        "power_var": "powerVar",
        "seed": "seed",
        "seed_var": "seedVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultGoop:
    def __init__(
        self,
        *,
        chaos: typing.Optional[builtins.str] = None,
        chaos_var: typing.Optional[builtins.str] = None,
        density: typing.Optional[builtins.str] = None,
        density_var: typing.Optional[builtins.str] = None,
        power: typing.Optional[builtins.str] = None,
        power_var: typing.Optional[builtins.str] = None,
        seed: typing.Optional[builtins.str] = None,
        seed_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param chaos: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        :param chaos_var: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        :param density: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        :param density_var: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        :param power: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        :param power_var: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        :param seed: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        :param seed_var: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__785c4e53feeaacd3622dcceac15453b16245c16000da55a099d7dab2cce89a0c)
            check_type(argname="argument chaos", value=chaos, expected_type=type_hints["chaos"])
            check_type(argname="argument chaos_var", value=chaos_var, expected_type=type_hints["chaos_var"])
            check_type(argname="argument density", value=density, expected_type=type_hints["density"])
            check_type(argname="argument density_var", value=density_var, expected_type=type_hints["density_var"])
            check_type(argname="argument power", value=power, expected_type=type_hints["power"])
            check_type(argname="argument power_var", value=power_var, expected_type=type_hints["power_var"])
            check_type(argname="argument seed", value=seed, expected_type=type_hints["seed"])
            check_type(argname="argument seed_var", value=seed_var, expected_type=type_hints["seed_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if chaos is not None:
            self._values["chaos"] = chaos
        if chaos_var is not None:
            self._values["chaos_var"] = chaos_var
        if density is not None:
            self._values["density"] = density
        if density_var is not None:
            self._values["density_var"] = density_var
        if power is not None:
            self._values["power"] = power
        if power_var is not None:
            self._values["power_var"] = power_var
        if seed is not None:
            self._values["seed"] = seed
        if seed_var is not None:
            self._values["seed_var"] = seed_var

    @builtins.property
    def chaos(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        '''
        result = self._values.get("chaos")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def chaos_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        '''
        result = self._values.get("chaos_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        '''
        result = self._values.get("density")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density_var(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        '''
        result = self._values.get("density_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        '''
        result = self._values.get("power")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power_var(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        '''
        result = self._values.get("power_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        '''
        result = self._values.get("seed")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed_var(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        result = self._values.get("seed_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultGoop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultGoopList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultGoopList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__27779c030ccda607e3b481bdb9a7c89dee5f81eb398d37b14c1d0916f42b5909)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultGoopOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c68ebd30a62a522eeff4ef82ab3b291feaaa4e08dea72f6051f35ad93a6cda1d)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultGoopOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__46ef72b8feff784dabf9bc9dc22e26a1ab48776311a484b596976d8a9cfa647e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b7980a57288cdc4fda24822ff318ebe5202a1c508cee2c1333767f4ccdcff795)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__651ce0f381161cd56be1890281aa31a7a1ce1d251aedac4301a277a3676b7389)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultGoop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultGoop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__529a3f7b1fcd4c2a069da0533d251e34a002168148efe3976599e4dd3ba6a622)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultGoopOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultGoopOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d29f93ea43ddafffc2d2c5b954b30a492d929e969fcf878e62e0375f28d28f4d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetChaos")
    def reset_chaos(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaos", []))

    @jsii.member(jsii_name="resetChaosVar")
    def reset_chaos_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaosVar", []))

    @jsii.member(jsii_name="resetDensity")
    def reset_density(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensity", []))

    @jsii.member(jsii_name="resetDensityVar")
    def reset_density_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensityVar", []))

    @jsii.member(jsii_name="resetPower")
    def reset_power(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPower", []))

    @jsii.member(jsii_name="resetPowerVar")
    def reset_power_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPowerVar", []))

    @jsii.member(jsii_name="resetSeed")
    def reset_seed(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeed", []))

    @jsii.member(jsii_name="resetSeedVar")
    def reset_seed_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeedVar", []))

    @builtins.property
    @jsii.member(jsii_name="chaosInput")
    def chaos_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosInput"))

    @builtins.property
    @jsii.member(jsii_name="chaosVarInput")
    def chaos_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosVarInput"))

    @builtins.property
    @jsii.member(jsii_name="densityInput")
    def density_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityInput"))

    @builtins.property
    @jsii.member(jsii_name="densityVarInput")
    def density_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="powerInput")
    def power_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerInput"))

    @builtins.property
    @jsii.member(jsii_name="powerVarInput")
    def power_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerVarInput"))

    @builtins.property
    @jsii.member(jsii_name="seedInput")
    def seed_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedInput"))

    @builtins.property
    @jsii.member(jsii_name="seedVarInput")
    def seed_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedVarInput"))

    @builtins.property
    @jsii.member(jsii_name="chaos")
    def chaos(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaos"))

    @chaos.setter
    def chaos(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__619b72ef9d933915ee86a68da0c07d8345c4eb4b57eb0777f16e63e4d732281d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaos", value)

    @builtins.property
    @jsii.member(jsii_name="chaosVar")
    def chaos_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaosVar"))

    @chaos_var.setter
    def chaos_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b5fad2ae15eb44e76a7acd1671d31a49f49fbfc8ad3cd6fda9829cf939dd4538)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaosVar", value)

    @builtins.property
    @jsii.member(jsii_name="density")
    def density(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "density"))

    @density.setter
    def density(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d68ef7fe1eb931b32ec81fc1ff24e0f23e945f7ae7678e7bbe0a4db01b742a0a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "density", value)

    @builtins.property
    @jsii.member(jsii_name="densityVar")
    def density_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "densityVar"))

    @density_var.setter
    def density_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__224b04f667c99b4aaf7fd16d32263ede34ef66c4cd710b18bed0ffce1339824f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "densityVar", value)

    @builtins.property
    @jsii.member(jsii_name="power")
    def power(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "power"))

    @power.setter
    def power(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d83abe28b0846502e95a5d0fe534748fa18c9414c9b8b865d357510e2845670)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "power", value)

    @builtins.property
    @jsii.member(jsii_name="powerVar")
    def power_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "powerVar"))

    @power_var.setter
    def power_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f50142a2c83206d0e893064435df78999c6dd99e5497c672fdfa09054bafe932)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "powerVar", value)

    @builtins.property
    @jsii.member(jsii_name="seed")
    def seed(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seed"))

    @seed.setter
    def seed(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c0105d886ace44fcbc31fe7e955325f3251a966212a2bc2bba2e13f7005030e5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seed", value)

    @builtins.property
    @jsii.member(jsii_name="seedVar")
    def seed_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seedVar"))

    @seed_var.setter
    def seed_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f9985ce95ec3e4689ec6231e6633a64bc3f8bda51515c0fdb31590cc8595ee2f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seedVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultGoop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultGoop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultGoop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c8362524f397b99f5a56d0f0e1066179b8fa7537908450d705ba98f03b1ef553)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultGrayscale",
    jsii_struct_bases=[],
    name_mapping={"type": "type", "type_var": "typeVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultGrayscale:
    def __init__(
        self,
        *,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param type: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__61aeb1e006ffe3474d01297cfbf45628a3c983e5870eb8725acb4547cea2616a)
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultGrayscale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultGrayscaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultGrayscaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e60c534524b106bb0cde63ba97a44c698bd4eb8bb2fe572f704111d9536b2db9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultGrayscaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__980f9ef9bbea1d66a4a62b3be366a1b384f89e0a1586dd469517cdfde16da8eb)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultGrayscaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dc48f4ae7aafee3574f2f25d3931f0bc7660cec23c74a8bbdb9d23a28ab10193)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c90bb7c32be51b400ae682610ab5b90177277a83963444beee47b1b5d4c3abb9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d8d43ed7495cf493c58fc422e7d66f7addde43ad7dbb18e84af579ec35a16b82)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultGrayscale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultGrayscale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0bdc03e5f91ca745140bf9c8a409a5decb152cfcf2a1a91162e7c733d11b81b1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultGrayscaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultGrayscaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__68aa362bea81a21454ae23421d1bdc5891797b91cb4d470ff1c0ba54b7b5fc6d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4032b5c1d71b32472ded46546ddeb221d899e523f56ca230ed81d3cdd2841f2b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__97faf400df366cf629bbefd5f0b1b2aa47441f418dbd7cd9f942e155ae2eb97e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultGrayscale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultGrayscale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultGrayscale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__71a4b5533751864417aedfde670a5264f6be07cf7b7d23201fc509db7537f30b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultHsl",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "lightness": "lightness",
        "lightness_var": "lightnessVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultHsl:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness: typing.Optional[builtins.str] = None,
        lightness_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        :param lightness_var: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__628749abc3daf20e523f4952cee5e4093026a1be712884750bffd489cc431968)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness", value=lightness, expected_type=type_hints["lightness"])
            check_type(argname="argument lightness_var", value=lightness_var, expected_type=type_hints["lightness_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness is not None:
            self._values["lightness"] = lightness
        if lightness_var is not None:
            self._values["lightness_var"] = lightness_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        '''
        result = self._values.get("lightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        '''
        result = self._values.get("lightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultHsl(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultHslList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultHslList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__80779b4677652fc01b064e0e89d26d23e4ea427e81058e3ac47b71e9cabd0248)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultHslOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a6836cd9584e92f10ac3be1d15f96a1fb85393ce3727ec32d4a85b2fd771ad05)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultHslOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__10b4bf8f3b264b40f4d2c84ccbad55b7582edda72dc1cc1e287218e6eede3049)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__887b9d728750869c2aee18c087116879ee7dbeec70fb7388e28b60473c274919)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a25d712606eefef8fc5f33fc7200152c75f46b8b94302f53db7568b093d0df9c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultHsl]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultHsl]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6028658ab5743df4b180ad59c734b853f2825f754f23fd047a45b63a780ebb5b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultHslOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultHslOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ed341e46341c81d856368acb337631cf3b324c1af7fb8ee3f9c763fdfe0f4961)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightness")
    def reset_lightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightness", []))

    @jsii.member(jsii_name="resetLightnessVar")
    def reset_lightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessInput")
    def lightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessVarInput")
    def lightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__14130315c4f10fab56da9fb032566be501d178ee90959edef567192a43a987d9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a3e67ebbaca9ff1fc3fc1813a29efeb8b9a2ddbeaf5f7b279fb3a63d3d1e2780)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightness")
    def lightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightness"))

    @lightness.setter
    def lightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d2c3ee2dd933a43fe0d0942b231281c1a5a4ca7a450ef58afd1c3f70aaebeaa6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightness", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessVar")
    def lightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessVar"))

    @lightness_var.setter
    def lightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bff2b064b7100c431594deb07d4b9d43b1c6d29c0e73a49c4a6eb05616dcd508)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6c57f282659a84b0df278480a4cacdb8f83c4e3e7bd4d09e24ca8c2eb3a51a98)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__42e32eb9c6afe3abb31868f4cd7f2ef117b0c695a226ecee317f3041c4b0902a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultHsl]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultHsl]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultHsl]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__93aaf829baef7f18d8cb5c7455bb04d4b3ddf75d67be36996f54d3d61c86a434)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultHsv",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultHsv:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        :param value: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__29f48d85524dbef53d121b585e89288067e1d0ba834cf6313c012a036d025c27)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultHsv(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultHsvList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultHsvList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bdb5b681d033d576e2fcc1bb5298935f5dfbb04cc84db8c8bb1f6757d3966707)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultHsvOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3bd3441e2a2b66cb3ba8a0e7b81b4d986334b708301ed4e4a24f4deea51f1093)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultHsvOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a16ce8df42278b1a7d92aaa1d5849dae543f698666a88822ba7cf19a9e40c9de)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d3acd6b3bebfd7db5e87d073edb660478cf1075c8d1d3aac6ef6f0695abe3260)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e9c1f092a808be600abc4bb05f91df8da356a18b12d8cb0a44c65b3f4617902)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultHsv]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultHsv]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a8f0f06b29d57b8010212a5b1906a46e66ecc72ca2cbe76ffef612028677b23e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultHsvOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultHsvOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6a5e4a2a6aa8e124d1130400749cd7e831cab0a341410b75f033c4b7684772f2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4539f8fbcf6039a473a2ad06417a220b73c79be0ac8051142854cfd3140e6fbb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__963337c295494be1640234bd4a6cb7bbe919703380707f26bceccd561faa7f97)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ef96118045328d87feb306cda6b45ebfaa998ac42c0932965745b389cdb59574)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7a84f1ed8fbbff3928c972e5a89d3f05596746d2ed29c176a2336b9c415cc31a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a74783e200e784b0ddc6d727eec1580f644b3fc3476d0826d5dbf724743b855)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f5b53ce2345bf251d72c05c02a536c12ec3ef6930464ea6bf0dce422d3394676)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultHsv]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultHsv]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultHsv]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0b79f1cdd879b55b071fbc25d60b197cdfcd5c9aa8a7eeefb86e9a7318bc9664)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfDimension",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "dimension": "dimension",
        "dimension_var": "dimensionVar",
        "equal": "equal",
        "greater_than": "greaterThan",
        "less_than": "lessThan",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfDimension:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfDimensionDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        dimension: typing.Optional[builtins.str] = None,
        dimension_var: typing.Optional[builtins.str] = None,
        equal: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfDimensionEqual", typing.Dict[builtins.str, typing.Any]]] = None,
        greater_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfDimensionGreaterThan", typing.Dict[builtins.str, typing.Any]]] = None,
        less_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfDimensionLessThan", typing.Dict[builtins.str, typing.Any]]] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param dimension: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        :param dimension_var: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        :param equal: equal block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        :param greater_than: greater_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        :param less_than: less_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        :param value: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfDimensionDefault(**default)
        if isinstance(equal, dict):
            equal = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfDimensionEqual(**equal)
        if isinstance(greater_than, dict):
            greater_than = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfDimensionGreaterThan(**greater_than)
        if isinstance(less_than, dict):
            less_than = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfDimensionLessThan(**less_than)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__33fe52d70752278e78cdc6660cf6d8d16d8ab735985824df81a1584629649644)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument dimension", value=dimension, expected_type=type_hints["dimension"])
            check_type(argname="argument dimension_var", value=dimension_var, expected_type=type_hints["dimension_var"])
            check_type(argname="argument equal", value=equal, expected_type=type_hints["equal"])
            check_type(argname="argument greater_than", value=greater_than, expected_type=type_hints["greater_than"])
            check_type(argname="argument less_than", value=less_than, expected_type=type_hints["less_than"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if dimension is not None:
            self._values["dimension"] = dimension
        if dimension_var is not None:
            self._values["dimension_var"] = dimension_var
        if equal is not None:
            self._values["equal"] = equal
        if greater_than is not None:
            self._values["greater_than"] = greater_than
        if less_than is not None:
            self._values["less_than"] = less_than
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfDimensionDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfDimensionDefault"], result)

    @builtins.property
    def dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        '''
        result = self._values.get("dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        '''
        result = self._values.get("dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def equal(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfDimensionEqual"]:
        '''equal block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        '''
        result = self._values.get("equal")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfDimensionEqual"], result)

    @builtins.property
    def greater_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfDimensionGreaterThan"]:
        '''greater_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        '''
        result = self._values.get("greater_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfDimensionGreaterThan"], result)

    @builtins.property
    def less_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfDimensionLessThan"]:
        '''less_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        '''
        result = self._values.get("less_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfDimensionLessThan"], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfDimension(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfDimensionDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfDimensionDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfDimensionDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfDimensionDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfDimensionDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d05b4f19b0ad9c32e4ecaf6b700580f029eb0db2f095e2bf750480ee95ab3670)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfDimensionDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfDimensionDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__26c2e739f4565dfb5f70a630956c7374c01b913534906fa8fb8f2f8b195cd4d8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfDimensionEqual",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfDimensionEqual:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfDimensionEqual(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfDimensionEqualOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfDimensionEqualOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__acddf3b8a497fe620322b6bad24d749ae4e5e7d0996d15e4a1b69a04eb6dfe5d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfDimensionEqual], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfDimensionEqual],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__74ab9e3f001259d64fcd053fe26c94ac495bf37190ee79468e0794ff0f14da9a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfDimensionGreaterThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfDimensionGreaterThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfDimensionGreaterThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfDimensionGreaterThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfDimensionGreaterThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c8bcf15771c1be811feafce167a5dd4054fb5fa79710af1df2a944e6064857e0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfDimensionGreaterThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfDimensionGreaterThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5b077e11d7d6af0f97074913c958846f5f5864c900d74a662c83586551f8b23b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfDimensionLessThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfDimensionLessThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfDimensionLessThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfDimensionLessThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfDimensionLessThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6a03d81e8a0729faf7c36e1133401156ca151caa5d3c1c33ede3d8dfdff0778c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfDimensionLessThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfDimensionLessThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dc1666a2ec02b90f98c341873cb09c0536ff5af8cfe35210a41ea7a9f674f62a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfDimensionList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfDimensionList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa8fb79151463483eddb37dab174d02854267179330483eb35a044987ce6029c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfDimensionOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2f60f3df87bb429b74788ee8e00bb707232d918ed154d8a64cdc7884c8c1fd4f)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfDimensionOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ad6b385f24e1560fe1e29e795c9a76e0c5e7f0a778aa6c05a16235e624c8d70c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__620d5a1373a27ebede27c898c11ff463d3632258c401926f5a87f63e99bb7653)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__01525028307ed1a9661dbd3bdf8b2604bf7572d665946d0da5daf877e45026b4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfDimension]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfDimension]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__44b5728a9e372598db8ebffc3106b3c728e00beab40378aa2f987e8c5f14a0ea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfDimensionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfDimensionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__97dc823dfd465bce54d0685076d6a6748f0aee00445c138741c51eb2e71211ee)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfDimensionDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putEqual")
    def put_equal(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfDimensionEqual()

        return typing.cast(None, jsii.invoke(self, "putEqual", [value]))

    @jsii.member(jsii_name="putGreaterThan")
    def put_greater_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfDimensionGreaterThan()

        return typing.cast(None, jsii.invoke(self, "putGreaterThan", [value]))

    @jsii.member(jsii_name="putLessThan")
    def put_less_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfDimensionLessThan()

        return typing.cast(None, jsii.invoke(self, "putLessThan", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetDimension")
    def reset_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimension", []))

    @jsii.member(jsii_name="resetDimensionVar")
    def reset_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimensionVar", []))

    @jsii.member(jsii_name="resetEqual")
    def reset_equal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEqual", []))

    @jsii.member(jsii_name="resetGreaterThan")
    def reset_greater_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGreaterThan", []))

    @jsii.member(jsii_name="resetLessThan")
    def reset_less_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLessThan", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfDimensionDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfDimensionDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="equal")
    def equal(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfDimensionEqualOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfDimensionEqualOutputReference, jsii.get(self, "equal"))

    @builtins.property
    @jsii.member(jsii_name="greaterThan")
    def greater_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfDimensionGreaterThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfDimensionGreaterThanOutputReference, jsii.get(self, "greaterThan"))

    @builtins.property
    @jsii.member(jsii_name="lessThan")
    def less_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfDimensionLessThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfDimensionLessThanOutputReference, jsii.get(self, "lessThan"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfDimensionDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionInput")
    def dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionVarInput")
    def dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="equalInput")
    def equal_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfDimensionEqual], jsii.get(self, "equalInput"))

    @builtins.property
    @jsii.member(jsii_name="greaterThanInput")
    def greater_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfDimensionGreaterThan], jsii.get(self, "greaterThanInput"))

    @builtins.property
    @jsii.member(jsii_name="lessThanInput")
    def less_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfDimensionLessThan], jsii.get(self, "lessThanInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="dimension")
    def dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimension"))

    @dimension.setter
    def dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3c384e797a3f96a12bc3dbe10c5283e8f900943980b6e737fe1c42dc36359b3e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimension", value)

    @builtins.property
    @jsii.member(jsii_name="dimensionVar")
    def dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimensionVar"))

    @dimension_var.setter
    def dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f15d33cace59c74c345df62e3beb83aaedd450f9aa8d8e87432fba4d0dd37e0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ad5819321c321a70091379803d2cdfa25aa37b3a52a634ec53125a198787448f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__33e7e7f3ea26d1ec8f4d3d97d5bfea1f47bed642a6259097682a73fd1c411a33)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfDimension]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfDimension]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfDimension]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__31045d354dbb9bf1658dbf3245e17557395e2ef3fc427bc38b9fb3220ad17d42)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfOrientation",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "landscape": "landscape",
        "portrait": "portrait",
        "square": "square",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfOrientation:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfOrientationDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        landscape: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfOrientationLandscape", typing.Dict[builtins.str, typing.Any]]] = None,
        portrait: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfOrientationPortrait", typing.Dict[builtins.str, typing.Any]]] = None,
        square: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfOrientationSquare", typing.Dict[builtins.str, typing.Any]]] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param landscape: landscape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        :param portrait: portrait block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        :param square: square block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfOrientationDefault(**default)
        if isinstance(landscape, dict):
            landscape = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfOrientationLandscape(**landscape)
        if isinstance(portrait, dict):
            portrait = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfOrientationPortrait(**portrait)
        if isinstance(square, dict):
            square = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfOrientationSquare(**square)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f1c828a3a1cd3c2b4ad8b4376c54b27d069bc185228a725e0a745fc6545d8cfa)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument landscape", value=landscape, expected_type=type_hints["landscape"])
            check_type(argname="argument portrait", value=portrait, expected_type=type_hints["portrait"])
            check_type(argname="argument square", value=square, expected_type=type_hints["square"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if landscape is not None:
            self._values["landscape"] = landscape
        if portrait is not None:
            self._values["portrait"] = portrait
        if square is not None:
            self._values["square"] = square

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfOrientationDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfOrientationDefault"], result)

    @builtins.property
    def landscape(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfOrientationLandscape"]:
        '''landscape block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        '''
        result = self._values.get("landscape")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfOrientationLandscape"], result)

    @builtins.property
    def portrait(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfOrientationPortrait"]:
        '''portrait block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        '''
        result = self._values.get("portrait")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfOrientationPortrait"], result)

    @builtins.property
    def square(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfOrientationSquare"]:
        '''square block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        result = self._values.get("square")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfOrientationSquare"], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfOrientation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfOrientationDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfOrientationDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfOrientationDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfOrientationDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfOrientationDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1b3579c503612272b14bc349b440aaea2722c9b3e94bd6cf915a6fa8c0842561)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfOrientationDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfOrientationDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f61746a6618fcd9039263b5b5f6063eca9c917adf2037ca143edca839c5c0628)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfOrientationLandscape",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfOrientationLandscape:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfOrientationLandscape(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfOrientationLandscapeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfOrientationLandscapeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b4389cbcee4ee6329d6bf24e3b5826170ca60ea9cd6082619b9464ac30faffac)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfOrientationLandscape], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfOrientationLandscape],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__67ab1c4cb1d5e563b56482634c64ff46b41d343ec09cfb91f03e948232494bd7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfOrientationList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfOrientationList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c2496510ccc640c018d2907d8cae588e6dd94ba22d828510cc88ed26d36c5aeb)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfOrientationOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2f279a850906022fa8dc2ec34ee430c065216949826882e45a86c2d612263f08)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfOrientationOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dc65dff9455147bf5470288f4de71145a0dfb86c7920561915ae5c60f3f37eaf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__49485669283f9ed77baa1770a12e7c4931c257567f741f4514be3ff8782dda48)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c89055a7c6b008cdb8038293d89e57067604379f7aebbdc8e5eb3b65f1b186a3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfOrientation]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfOrientation]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3628be35e9af2d42f921eaab8f106aa3777fc80174117e2ef8700e305a5656d1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfOrientationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfOrientationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__74fe0ddefc7ec9fe5da43bb66c57aa2052e9a226379ac01e875b8fdfb8fa0caf)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfOrientationDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putLandscape")
    def put_landscape(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfOrientationLandscape()

        return typing.cast(None, jsii.invoke(self, "putLandscape", [value]))

    @jsii.member(jsii_name="putPortrait")
    def put_portrait(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfOrientationPortrait()

        return typing.cast(None, jsii.invoke(self, "putPortrait", [value]))

    @jsii.member(jsii_name="putSquare")
    def put_square(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfOrientationSquare()

        return typing.cast(None, jsii.invoke(self, "putSquare", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetLandscape")
    def reset_landscape(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLandscape", []))

    @jsii.member(jsii_name="resetPortrait")
    def reset_portrait(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPortrait", []))

    @jsii.member(jsii_name="resetSquare")
    def reset_square(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSquare", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfOrientationDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfOrientationDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="landscape")
    def landscape(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfOrientationLandscapeOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfOrientationLandscapeOutputReference, jsii.get(self, "landscape"))

    @builtins.property
    @jsii.member(jsii_name="portrait")
    def portrait(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfOrientationPortraitOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfOrientationPortraitOutputReference", jsii.get(self, "portrait"))

    @builtins.property
    @jsii.member(jsii_name="square")
    def square(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfOrientationSquareOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfOrientationSquareOutputReference", jsii.get(self, "square"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfOrientationDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="landscapeInput")
    def landscape_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfOrientationLandscape], jsii.get(self, "landscapeInput"))

    @builtins.property
    @jsii.member(jsii_name="portraitInput")
    def portrait_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfOrientationPortrait"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfOrientationPortrait"], jsii.get(self, "portraitInput"))

    @builtins.property
    @jsii.member(jsii_name="squareInput")
    def square_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfOrientationSquare"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfOrientationSquare"], jsii.get(self, "squareInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfOrientation]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfOrientation]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfOrientation]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4bc571c31f25518869b05d67a9eaaddf290c5c74c05750c860cc40f60fb44938)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfOrientationPortrait",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfOrientationPortrait:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfOrientationPortrait(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfOrientationPortraitOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfOrientationPortraitOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4906a6f76bff715c02920639c3e7c77bf9b990bfd2f33242dd7107dbba9a520a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfOrientationPortrait]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfOrientationPortrait], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfOrientationPortrait],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd34ebab1cefe99f31fa143b477562844d76bed32e3b0643e0a6474f54be1050)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfOrientationSquare",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfOrientationSquare:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfOrientationSquare(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfOrientationSquareOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfOrientationSquareOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6c3978fe4fa5076e941abb0e28e3661afa73e4e7b700ea94b88ff38754ce5c3c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfOrientationSquare]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfOrientationSquare], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfOrientationSquare],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d94c320df3f6a28809bc52ece13d6fc84ccfb9ea7812d072cf28151ad93c63f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultImQuery",
    jsii_struct_bases=[],
    name_mapping={
        "allowed_transformations": "allowedTransformations",
        "query_var": "queryVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultImQuery:
    def __init__(
        self,
        *,
        allowed_transformations: typing.Sequence[builtins.str],
        query_var: builtins.str,
    ) -> None:
        '''
        :param allowed_transformations: Specifies the transformations that can be applied using the query string parameter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allowed_transformations DataAkamaiImagingPolicyImage#allowed_transformations}
        :param query_var: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#query_var DataAkamaiImagingPolicyImage#query_var}.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e7e9101ae74de7a82710762025575b84b1af6d5fe431208a54b9fbd0580f9c00)
            check_type(argname="argument allowed_transformations", value=allowed_transformations, expected_type=type_hints["allowed_transformations"])
            check_type(argname="argument query_var", value=query_var, expected_type=type_hints["query_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "allowed_transformations": allowed_transformations,
            "query_var": query_var,
        }

    @builtins.property
    def allowed_transformations(self) -> typing.List[builtins.str]:
        '''Specifies the transformations that can be applied using the query string parameter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allowed_transformations DataAkamaiImagingPolicyImage#allowed_transformations}
        '''
        result = self._values.get("allowed_transformations")
        assert result is not None, "Required property 'allowed_transformations' is missing"
        return typing.cast(typing.List[builtins.str], result)

    @builtins.property
    def query_var(self) -> builtins.str:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#query_var DataAkamaiImagingPolicyImage#query_var}.'''
        result = self._values.get("query_var")
        assert result is not None, "Required property 'query_var' is missing"
        return typing.cast(builtins.str, result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultImQuery(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultImQueryList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultImQueryList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__45ee9296a206122c80e74f276d4f784ae0eaeb15638c336a35b3e603fc5a39ed)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultImQueryOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f71d15b0dc764b7b2413295e4180bd48f9ae0f828256780b99c4b5879286e6f7)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultImQueryOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eab8985e155181fbd7f949ed7bdddd85214eb8b0ec785fe846d6e2998d92c294)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__434931066ff256de59990c786530b579e07e6f13bf1d981fe8bc92ec9a67d4ca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ff21d7f22d1d53c36f0dedd23cabf3b227436b7ddcd3b237004366ce55e7b9ee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultImQuery]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultImQuery]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultImQuery]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a2b6725667e5200d69301170d864ec0646cea0537b8f27a04ce3aa12b4b40ce0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultImQueryOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultImQueryOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__38f04ba3ef4e4e7e8a9e5fcc89890b51017fb05952eba4f1cc6b58bfa917290a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @builtins.property
    @jsii.member(jsii_name="allowedTransformationsInput")
    def allowed_transformations_input(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "allowedTransformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="queryVarInput")
    def query_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "queryVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowedTransformations")
    def allowed_transformations(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "allowedTransformations"))

    @allowed_transformations.setter
    def allowed_transformations(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__87a415d19b246e63c77e409eb291c7943d0975df20346c95d5b9207d4675866f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowedTransformations", value)

    @builtins.property
    @jsii.member(jsii_name="queryVar")
    def query_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "queryVar"))

    @query_var.setter
    def query_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__62542ab4796448d9b7a79aab4778e23405328cfcb771452e9e3af03abf734b4b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "queryVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultImQuery]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultImQuery]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultImQuery]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a77141345696789625a59526b127e216865fe646fd61fa2bfe90d5a2d621934c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultMaxColors",
    jsii_struct_bases=[],
    name_mapping={"colors": "colors", "colors_var": "colorsVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultMaxColors:
    def __init__(
        self,
        *,
        colors: typing.Optional[builtins.str] = None,
        colors_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param colors: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        :param colors_var: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ad27fdf0542dacbf902a0a18df104a24466d95b8c0c3e3a49c812b664ae190bc)
            check_type(argname="argument colors", value=colors, expected_type=type_hints["colors"])
            check_type(argname="argument colors_var", value=colors_var, expected_type=type_hints["colors_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if colors is not None:
            self._values["colors"] = colors
        if colors_var is not None:
            self._values["colors_var"] = colors_var

    @builtins.property
    def colors(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        '''
        result = self._values.get("colors")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def colors_var(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        result = self._values.get("colors_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultMaxColors(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultMaxColorsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultMaxColorsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__19639babba45bcae311b4f94aa9a63f1f8ded066e9b607842dd8d66b3fe4d849)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultMaxColorsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f0077fb4c659e019dc0a26f2f2aeaeff344f20e43cda4b68135af4e3f6f01643)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultMaxColorsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__387712735d2e5b726adfbf11a32487f36eb6ef4f3b19654f49b3277714acbf83)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__14d8a17682d3780d50394ec0e89e5b6fe9575e0ba022a126c7b58f810f5552e0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e5a55de527f28a3b675020ec2cf5c460d029e97a32078d12b748673c2d1bdd9f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultMaxColors]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultMaxColors]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e5d785f8d23dcbd1bd178628a71d796afc98dd90fa8853d7bb78b9b0e35c1b42)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultMaxColorsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultMaxColorsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__846c1dbef0beb439ecc6f2a9215df732bdc26cdb54ed17965a1a197a2589fa95)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColors")
    def reset_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColors", []))

    @jsii.member(jsii_name="resetColorsVar")
    def reset_colors_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorsVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorsInput")
    def colors_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsInput"))

    @builtins.property
    @jsii.member(jsii_name="colorsVarInput")
    def colors_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsVarInput"))

    @builtins.property
    @jsii.member(jsii_name="colors")
    def colors(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colors"))

    @colors.setter
    def colors(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d5a6ac0e141afb77a7a3cbdc83feed7fcbfce609adcd2482606c60918812a408)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colors", value)

    @builtins.property
    @jsii.member(jsii_name="colorsVar")
    def colors_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorsVar"))

    @colors_var.setter
    def colors_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__de146806a806a6cad225d7a397125a7068d3dbf90243b624a8265611726422cf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorsVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultMaxColors]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultMaxColors]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultMaxColors]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__226873bf3bdeef5cdc8fe6219644c97416e7a8b91a7b55966653c8072a4ef3d7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultMirror",
    jsii_struct_bases=[],
    name_mapping={
        "horizontal": "horizontal",
        "horizontal_var": "horizontalVar",
        "vertical": "vertical",
        "vertical_var": "verticalVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultMirror:
    def __init__(
        self,
        *,
        horizontal: typing.Optional[builtins.str] = None,
        horizontal_var: typing.Optional[builtins.str] = None,
        vertical: typing.Optional[builtins.str] = None,
        vertical_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param horizontal: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        :param horizontal_var: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        :param vertical: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        :param vertical_var: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8efac7265669889c1655ae65b69630eab4746e17b2a38fc8751b2c3a96fb482d)
            check_type(argname="argument horizontal", value=horizontal, expected_type=type_hints["horizontal"])
            check_type(argname="argument horizontal_var", value=horizontal_var, expected_type=type_hints["horizontal_var"])
            check_type(argname="argument vertical", value=vertical, expected_type=type_hints["vertical"])
            check_type(argname="argument vertical_var", value=vertical_var, expected_type=type_hints["vertical_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if horizontal is not None:
            self._values["horizontal"] = horizontal
        if horizontal_var is not None:
            self._values["horizontal_var"] = horizontal_var
        if vertical is not None:
            self._values["vertical"] = vertical
        if vertical_var is not None:
            self._values["vertical_var"] = vertical_var

    @builtins.property
    def horizontal(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        '''
        result = self._values.get("horizontal")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def horizontal_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        '''
        result = self._values.get("horizontal_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        '''
        result = self._values.get("vertical")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        result = self._values.get("vertical_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultMirror(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultMirrorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultMirrorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__85955ad6098e7aa7946ad0d88e468dc630f6e07f09f46a9871879af09bf74fff)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultMirrorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f3ee10ef40b251c1452640598628f694f4496ef16f91ef3d0a36a15fe2aa0a78)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultMirrorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7c94c7e033d1182a0ad48c45dfde57893498139704266c024252521672719379)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b979e37afcaa8b771065f857db5d57626f79d1cd55233a35ac5dea9b7c1ea2cb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__80259ec7c442dc45b84dc5e01937895842edbc32a67d7f76180ce6faef7f1b7d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultMirror]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultMirror]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b6f83963b9041f5de7dc08305c877d77db2209d6f49c4d914de963a3aa6179e1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultMirrorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultMirrorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__44ab24cfe1272ca26448611ddbafc184c7a88e78907d79e19591da9442e1aede)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHorizontal")
    def reset_horizontal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontal", []))

    @jsii.member(jsii_name="resetHorizontalVar")
    def reset_horizontal_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontalVar", []))

    @jsii.member(jsii_name="resetVertical")
    def reset_vertical(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVertical", []))

    @jsii.member(jsii_name="resetVerticalVar")
    def reset_vertical_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVerticalVar", []))

    @builtins.property
    @jsii.member(jsii_name="horizontalInput")
    def horizontal_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontalVarInput")
    def horizontal_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalInput")
    def vertical_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalVarInput")
    def vertical_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontal")
    def horizontal(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontal"))

    @horizontal.setter
    def horizontal(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f5944b152550efc82c105447bb739d9ed499b4c31158105b965742faa8d6187)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontal", value)

    @builtins.property
    @jsii.member(jsii_name="horizontalVar")
    def horizontal_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontalVar"))

    @horizontal_var.setter
    def horizontal_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__659cf4b8ac70feabcd48964379c5f1f7ee14dd932c243f3c96a63e25169405c0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontalVar", value)

    @builtins.property
    @jsii.member(jsii_name="vertical")
    def vertical(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "vertical"))

    @vertical.setter
    def vertical(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0925e37c2efee2c0cd8c36516db916cdd658b264a0bab8c831bff0cc67c8abea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "vertical", value)

    @builtins.property
    @jsii.member(jsii_name="verticalVar")
    def vertical_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "verticalVar"))

    @vertical_var.setter
    def vertical_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ec39c86dd0c82b388549da5066906bfd9a5c08d064985de3af937cd5e3b2a70)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "verticalVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultMirror]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultMirror]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultMirror]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__426d05a87ffb1c245e9fd73c97a9e8b3a35b89be8421b3f067dc66e6064a650d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultMonoHue",
    jsii_struct_bases=[],
    name_mapping={"hue": "hue", "hue_var": "hueVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultMonoHue:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a8cf50c0e5162d4ad5d7a4354bd1db5c5d8e6d93ec3283f66271cf037309d5bc)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultMonoHue(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultMonoHueList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultMonoHueList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3710d10506cd3f045415af816b75bc94da9861529e27f420776c88d90a0e2736)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultMonoHueOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d2fe5a074c0d37cefe0582ef346e93edda33856ccd43a069a9e22cabbb203f4c)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultMonoHueOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a2e824d8a4f69407ea6ffd9e18706efd5c3993981ae3be6f4c78d89287c5448b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5265a7b6221237638de946f8631585239fbbde14cd7a88e8e6922d474775152f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__244f2411c102ef4ffb1810b4f47afc5eb4c250bf80608af47e43fdfbe0150951)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultMonoHue]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultMonoHue]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0adf0434e3256d4508d14c1b1bcd139edb3b131eec6fd26f6d6a9a51c259c073)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultMonoHueOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultMonoHueOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4cb901abcf9bdb2337df1decbec7f08ffc401a9072a21c4442b0e85aa66f4361)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__26d25daed1a4dc0178b1e4c8b60df485b22fa6ffba79e2c54c876005b3f26f05)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ab4e0a10f1f43d18f53f704c283c7e8d3668bc9caa3a4d250c0f4086909b2fd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultMonoHue]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultMonoHue]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultMonoHue]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__02f756c1b6e400246c3973a3936382cfe299bd1534b64dfd54feee3aa84cefc2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultOpacity",
    jsii_struct_bases=[],
    name_mapping={"opacity": "opacity", "opacity_var": "opacityVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultOpacity:
    def __init__(
        self,
        *,
        opacity: typing.Optional[builtins.str] = None,
        opacity_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param opacity: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param opacity_var: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__50bc575a74f3e85ce69a214c853ea2785ed494a140c42e511aafa4f58544a285)
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument opacity_var", value=opacity_var, expected_type=type_hints["opacity_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if opacity is not None:
            self._values["opacity"] = opacity
        if opacity_var is not None:
            self._values["opacity_var"] = opacity_var

    @builtins.property
    def opacity(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def opacity_var(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        result = self._values.get("opacity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultOpacity(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultOpacityList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultOpacityList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1116917db000ac8429eb8c50de037831fc48bb68a553b2041e89bf1e64c3c16b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultOpacityOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ef83d51f27410e5a82a4eb24a823008a3d3837a0e39964d996dda6a1af5b8c0)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultOpacityOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__17d3720334e3777f15f1e9a0ce8527ee5ac9f79293d8c8e75df259532e96db37)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__85a74bef157341878a9a2e1683ce1a6c54c7cfa63e78d5448bd56a4587ca5795)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__de956d873b1e69c12700a3bd6ac8f7b27099a782a8d8569c10855dc59c93772f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultOpacity]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultOpacity]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0537663e1c6dae11d67cc273c6d53f8efc2fde03ee5d6f96b8d462600bbe3e02)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultOpacityOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultOpacityOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4b8ca56e7b6799cfe827decd38272eebdbfc2c685da6c57b1e379a6ef7e93567)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetOpacityVar")
    def reset_opacity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacityVar", []))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityVarInput")
    def opacity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacity"))

    @opacity.setter
    def opacity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fde4cc661e350d14a7c68fbf3283c24ab1489f58c68ede82fdbec47ce746afbd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacity", value)

    @builtins.property
    @jsii.member(jsii_name="opacityVar")
    def opacity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacityVar"))

    @opacity_var.setter
    def opacity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__97c27f09092ffb384c78e6f841519d99af300e55a0e2f6d494950bb712f24044)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacityVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultOpacity]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultOpacity]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultOpacity]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ee87e94c9a91ae8c6309dd54ed776212bc25d4b9ce8f9248d71914ec6a43fcbc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ef48d578862d9c33c584e8ca3273f3195ea9a826741301b6e13c6637fc598665)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putAppend")
    def put_append(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultAppend, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__654f55ff8fc177b5ff3831ecf04cdadfe49eec1a269592f733f305abacb05cd7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putAppend", [value]))

    @jsii.member(jsii_name="putAspectCrop")
    def put_aspect_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultAspectCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eecf2f2a3b6cc70494b61f5725106bbc74f22690c91cc6080bbd9be3f59f1c85)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putAspectCrop", [value]))

    @jsii.member(jsii_name="putBackgroundColor")
    def put_background_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c8dd84933f670ad691597fc93a497d98573af1e87a3d52d89db6cf5e130c6dec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBackgroundColor", [value]))

    @jsii.member(jsii_name="putBlur")
    def put_blur(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultBlur, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4c2011f5059242266d1cf197aa90cf86867c49ba549bf199521e05e1dcecb012)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBlur", [value]))

    @jsii.member(jsii_name="putChromaKey")
    def put_chroma_key(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultChromaKey, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__01a0b685c7eeed004e70121c827937a141f41bb9d92b6ef95efaf51eea3e0f4b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putChromaKey", [value]))

    @jsii.member(jsii_name="putComposite")
    def put_composite(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultComposite, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ffd30eadbbff4c46c51843f3f44246381ffafe9565bc7a90f324433d5ea1efc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putComposite", [value]))

    @jsii.member(jsii_name="putCompound")
    def put_compound(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultCompound, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__06624b8a17e838e98709576580cfa8350a5c90d9d35e249b9b2cf8848ea2de00)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCompound", [value]))

    @jsii.member(jsii_name="putContrast")
    def put_contrast(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultContrast, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c88b85f4c6aac7884507867c3c462713ba5d3fe12a1814c6cfa602b6ebc73aaa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putContrast", [value]))

    @jsii.member(jsii_name="putCrop")
    def put_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__98b45ce23a2198995fcfcc908d1a68a120b0233ab40aa7ed9312cd37dadcd579)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCrop", [value]))

    @jsii.member(jsii_name="putFaceCrop")
    def put_face_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultFaceCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a7601c8b58652dbcd318cc36a51384e09a6fc07a3f294f75768d89b1ace1bb49)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFaceCrop", [value]))

    @jsii.member(jsii_name="putFeatureCrop")
    def put_feature_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultFeatureCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__62e64619c64790abc7671a9a80a5d45672115007a12528e7be007daa37c84a3e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFeatureCrop", [value]))

    @jsii.member(jsii_name="putFitAndFill")
    def put_fit_and_fill(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultFitAndFill, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f7ca78b84af73f1315e87352177da2e54b0528e2c54aac15f5c3864a3762c477)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFitAndFill", [value]))

    @jsii.member(jsii_name="putGoop")
    def put_goop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultGoop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8b09586fc42f2bb0a488c5fe044e03142864330edf97dafc7640c0f102a77ba8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGoop", [value]))

    @jsii.member(jsii_name="putGrayscale")
    def put_grayscale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultGrayscale, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a861f6d3d2ec918cf639b2894173b3cc5d470442239e5f99ca98c5871eb30634)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGrayscale", [value]))

    @jsii.member(jsii_name="putHsl")
    def put_hsl(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultHsl, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__88579963db142bfd642803389dd93e87378769a23f9974085bcb733a56a1506a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsl", [value]))

    @jsii.member(jsii_name="putHsv")
    def put_hsv(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultHsv, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cae8c4ba9abadae91c0ebdb1edde4d2cec9d13181e70f2b096ceff80d4f07138)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsv", [value]))

    @jsii.member(jsii_name="putIfDimension")
    def put_if_dimension(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfDimension, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be545b770c70a4b8f00a717cecab6fe49f5581d8b1ede458306130f7cd881df4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfDimension", [value]))

    @jsii.member(jsii_name="putIfOrientation")
    def put_if_orientation(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aa136f4ada3a35b7f2fa0e77d49e929874d0b44c91305d00678ac0ca7713f244)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfOrientation", [value]))

    @jsii.member(jsii_name="putImQuery")
    def put_im_query(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultImQuery, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__71a93fdd22c72791775ce0ccde1381d6c1c34fe066960254fc60554aa84e340b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putImQuery", [value]))

    @jsii.member(jsii_name="putMaxColors")
    def put_max_colors(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultMaxColors, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dd5ffbcd28dac06441fd957147886725c61e05c452d79d9ea0529df99dafcbe6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMaxColors", [value]))

    @jsii.member(jsii_name="putMirror")
    def put_mirror(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultMirror, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d3cdcddc7acaf2992fe02e2af5c84f63909981020314190b75ce657dfda93cc1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMirror", [value]))

    @jsii.member(jsii_name="putMonoHue")
    def put_mono_hue(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultMonoHue, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d2d95a9440ecf873a4d59f119801fe92ae6a7a298ff56f992f94bce0350799bf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMonoHue", [value]))

    @jsii.member(jsii_name="putOpacity")
    def put_opacity(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultOpacity, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ccd31126389a026dd4d9a76f24b3d88189df5f6402e55091bc5e02d47ffa3ca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putOpacity", [value]))

    @jsii.member(jsii_name="putRegionOfInterestCrop")
    def put_region_of_interest_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultRegionOfInterestCrop", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d256de68087dc2d346640fdcec4e1d2d82147f9fafb9cf6a1a7ae15886b957b5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRegionOfInterestCrop", [value]))

    @jsii.member(jsii_name="putRelativeCrop")
    def put_relative_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultRelativeCrop", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__71d4fb675ff35ff32cefd4bb15feff47c9954152c27db2e75782b9a09305d55d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRelativeCrop", [value]))

    @jsii.member(jsii_name="putRemoveColor")
    def put_remove_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultRemoveColor", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5276d71a89742880e24fa15320bd69211a086d6e1cec2fd798096e68553a85cf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRemoveColor", [value]))

    @jsii.member(jsii_name="putResize")
    def put_resize(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultResize", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8fea1814b85a78008fb015321cfc4f997baaa25b77cae9b96e50eedc14d13eb1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putResize", [value]))

    @jsii.member(jsii_name="putRotate")
    def put_rotate(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultRotate", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f84609253315845d75d922712dcebf4c1337d6b643923cb382c5556cd38d6429)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRotate", [value]))

    @jsii.member(jsii_name="putScale")
    def put_scale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultScale", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9b40e6609ebd200cde17b07cf0b9e2a072a9da56cfc9a21784ee0279988e7447)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putScale", [value]))

    @jsii.member(jsii_name="putShear")
    def put_shear(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultShear", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9af14c43008dd793b9e33c6eb94907b352673861bf8486ca2515311a3202b607)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putShear", [value]))

    @jsii.member(jsii_name="putTrim")
    def put_trim(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultTrim", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e3d4514f69515c2e22e9cf4dd0e5e97dee17676f5a2c701c95340e2cd14ad438)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTrim", [value]))

    @jsii.member(jsii_name="putUnsharpMask")
    def put_unsharp_mask(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultUnsharpMask", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a227b1aec01665fa2b445d66049ca50c7bbff7cc3c06bfcb98b1451be68ddb64)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putUnsharpMask", [value]))

    @jsii.member(jsii_name="resetAppend")
    def reset_append(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAppend", []))

    @jsii.member(jsii_name="resetAspectCrop")
    def reset_aspect_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspectCrop", []))

    @jsii.member(jsii_name="resetBackgroundColor")
    def reset_background_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBackgroundColor", []))

    @jsii.member(jsii_name="resetBlur")
    def reset_blur(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBlur", []))

    @jsii.member(jsii_name="resetChromaKey")
    def reset_chroma_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChromaKey", []))

    @jsii.member(jsii_name="resetComposite")
    def reset_composite(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetComposite", []))

    @jsii.member(jsii_name="resetCompound")
    def reset_compound(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCompound", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetCrop")
    def reset_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCrop", []))

    @jsii.member(jsii_name="resetFaceCrop")
    def reset_face_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFaceCrop", []))

    @jsii.member(jsii_name="resetFeatureCrop")
    def reset_feature_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureCrop", []))

    @jsii.member(jsii_name="resetFitAndFill")
    def reset_fit_and_fill(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFitAndFill", []))

    @jsii.member(jsii_name="resetGoop")
    def reset_goop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGoop", []))

    @jsii.member(jsii_name="resetGrayscale")
    def reset_grayscale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGrayscale", []))

    @jsii.member(jsii_name="resetHsl")
    def reset_hsl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsl", []))

    @jsii.member(jsii_name="resetHsv")
    def reset_hsv(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsv", []))

    @jsii.member(jsii_name="resetIfDimension")
    def reset_if_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfDimension", []))

    @jsii.member(jsii_name="resetIfOrientation")
    def reset_if_orientation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfOrientation", []))

    @jsii.member(jsii_name="resetImQuery")
    def reset_im_query(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetImQuery", []))

    @jsii.member(jsii_name="resetMaxColors")
    def reset_max_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxColors", []))

    @jsii.member(jsii_name="resetMirror")
    def reset_mirror(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMirror", []))

    @jsii.member(jsii_name="resetMonoHue")
    def reset_mono_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonoHue", []))

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetRegionOfInterestCrop")
    def reset_region_of_interest_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRegionOfInterestCrop", []))

    @jsii.member(jsii_name="resetRelativeCrop")
    def reset_relative_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRelativeCrop", []))

    @jsii.member(jsii_name="resetRemoveColor")
    def reset_remove_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRemoveColor", []))

    @jsii.member(jsii_name="resetResize")
    def reset_resize(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetResize", []))

    @jsii.member(jsii_name="resetRotate")
    def reset_rotate(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRotate", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetShear")
    def reset_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetShear", []))

    @jsii.member(jsii_name="resetTrim")
    def reset_trim(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTrim", []))

    @jsii.member(jsii_name="resetUnsharpMask")
    def reset_unsharp_mask(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUnsharpMask", []))

    @builtins.property
    @jsii.member(jsii_name="append")
    def append(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultAppendList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultAppendList, jsii.get(self, "append"))

    @builtins.property
    @jsii.member(jsii_name="aspectCrop")
    def aspect_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultAspectCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultAspectCropList, jsii.get(self, "aspectCrop"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColor")
    def background_color(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultBackgroundColorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultBackgroundColorList, jsii.get(self, "backgroundColor"))

    @builtins.property
    @jsii.member(jsii_name="blur")
    def blur(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultBlurList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultBlurList, jsii.get(self, "blur"))

    @builtins.property
    @jsii.member(jsii_name="chromaKey")
    def chroma_key(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultChromaKeyList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultChromaKeyList, jsii.get(self, "chromaKey"))

    @builtins.property
    @jsii.member(jsii_name="composite")
    def composite(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultCompositeList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultCompositeList, jsii.get(self, "composite"))

    @builtins.property
    @jsii.member(jsii_name="compound")
    def compound(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultCompoundList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultCompoundList, jsii.get(self, "compound"))

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultContrastList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultContrastList, jsii.get(self, "contrast"))

    @builtins.property
    @jsii.member(jsii_name="crop")
    def crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultCropList, jsii.get(self, "crop"))

    @builtins.property
    @jsii.member(jsii_name="faceCrop")
    def face_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultFaceCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultFaceCropList, jsii.get(self, "faceCrop"))

    @builtins.property
    @jsii.member(jsii_name="featureCrop")
    def feature_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultFeatureCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultFeatureCropList, jsii.get(self, "featureCrop"))

    @builtins.property
    @jsii.member(jsii_name="fitAndFill")
    def fit_and_fill(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultFitAndFillList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultFitAndFillList, jsii.get(self, "fitAndFill"))

    @builtins.property
    @jsii.member(jsii_name="goop")
    def goop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultGoopList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultGoopList, jsii.get(self, "goop"))

    @builtins.property
    @jsii.member(jsii_name="grayscale")
    def grayscale(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultGrayscaleList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultGrayscaleList, jsii.get(self, "grayscale"))

    @builtins.property
    @jsii.member(jsii_name="hsl")
    def hsl(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultHslList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultHslList, jsii.get(self, "hsl"))

    @builtins.property
    @jsii.member(jsii_name="hsv")
    def hsv(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultHsvList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultHsvList, jsii.get(self, "hsv"))

    @builtins.property
    @jsii.member(jsii_name="ifDimension")
    def if_dimension(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfDimensionList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfDimensionList, jsii.get(self, "ifDimension"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientation")
    def if_orientation(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfOrientationList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfOrientationList, jsii.get(self, "ifOrientation"))

    @builtins.property
    @jsii.member(jsii_name="imQuery")
    def im_query(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultImQueryList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultImQueryList, jsii.get(self, "imQuery"))

    @builtins.property
    @jsii.member(jsii_name="maxColors")
    def max_colors(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultMaxColorsList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultMaxColorsList, jsii.get(self, "maxColors"))

    @builtins.property
    @jsii.member(jsii_name="mirror")
    def mirror(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultMirrorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultMirrorList, jsii.get(self, "mirror"))

    @builtins.property
    @jsii.member(jsii_name="monoHue")
    def mono_hue(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultMonoHueList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultMonoHueList, jsii.get(self, "monoHue"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultOpacityList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultOpacityList, jsii.get(self, "opacity"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestCrop")
    def region_of_interest_crop(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultRegionOfInterestCropList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultRegionOfInterestCropList", jsii.get(self, "regionOfInterestCrop"))

    @builtins.property
    @jsii.member(jsii_name="relativeCrop")
    def relative_crop(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultRelativeCropList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultRelativeCropList", jsii.get(self, "relativeCrop"))

    @builtins.property
    @jsii.member(jsii_name="removeColor")
    def remove_color(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultRemoveColorList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultRemoveColorList", jsii.get(self, "removeColor"))

    @builtins.property
    @jsii.member(jsii_name="resize")
    def resize(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultResizeList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultResizeList", jsii.get(self, "resize"))

    @builtins.property
    @jsii.member(jsii_name="rotate")
    def rotate(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultRotateList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultRotateList", jsii.get(self, "rotate"))

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultScaleList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultScaleList", jsii.get(self, "scale"))

    @builtins.property
    @jsii.member(jsii_name="shear")
    def shear(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultShearList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultShearList", jsii.get(self, "shear"))

    @builtins.property
    @jsii.member(jsii_name="trim")
    def trim(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultTrimList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultTrimList", jsii.get(self, "trim"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMask")
    def unsharp_mask(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultUnsharpMaskList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultUnsharpMaskList", jsii.get(self, "unsharpMask"))

    @builtins.property
    @jsii.member(jsii_name="appendInput")
    def append_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultAppend]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultAppend]]], jsii.get(self, "appendInput"))

    @builtins.property
    @jsii.member(jsii_name="aspectCropInput")
    def aspect_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultAspectCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultAspectCrop]]], jsii.get(self, "aspectCropInput"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColorInput")
    def background_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultBackgroundColor]]], jsii.get(self, "backgroundColorInput"))

    @builtins.property
    @jsii.member(jsii_name="blurInput")
    def blur_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultBlur]]], jsii.get(self, "blurInput"))

    @builtins.property
    @jsii.member(jsii_name="chromaKeyInput")
    def chroma_key_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultChromaKey]]], jsii.get(self, "chromaKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="compositeInput")
    def composite_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultComposite]]], jsii.get(self, "compositeInput"))

    @builtins.property
    @jsii.member(jsii_name="compoundInput")
    def compound_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultCompound]]], jsii.get(self, "compoundInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultContrast]]], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="cropInput")
    def crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultCrop]]], jsii.get(self, "cropInput"))

    @builtins.property
    @jsii.member(jsii_name="faceCropInput")
    def face_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultFaceCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultFaceCrop]]], jsii.get(self, "faceCropInput"))

    @builtins.property
    @jsii.member(jsii_name="featureCropInput")
    def feature_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultFeatureCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultFeatureCrop]]], jsii.get(self, "featureCropInput"))

    @builtins.property
    @jsii.member(jsii_name="fitAndFillInput")
    def fit_and_fill_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultFitAndFill]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultFitAndFill]]], jsii.get(self, "fitAndFillInput"))

    @builtins.property
    @jsii.member(jsii_name="goopInput")
    def goop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultGoop]]], jsii.get(self, "goopInput"))

    @builtins.property
    @jsii.member(jsii_name="grayscaleInput")
    def grayscale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultGrayscale]]], jsii.get(self, "grayscaleInput"))

    @builtins.property
    @jsii.member(jsii_name="hslInput")
    def hsl_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultHsl]]], jsii.get(self, "hslInput"))

    @builtins.property
    @jsii.member(jsii_name="hsvInput")
    def hsv_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultHsv]]], jsii.get(self, "hsvInput"))

    @builtins.property
    @jsii.member(jsii_name="ifDimensionInput")
    def if_dimension_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfDimension]]], jsii.get(self, "ifDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientationInput")
    def if_orientation_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfOrientation]]], jsii.get(self, "ifOrientationInput"))

    @builtins.property
    @jsii.member(jsii_name="imQueryInput")
    def im_query_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultImQuery]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultImQuery]]], jsii.get(self, "imQueryInput"))

    @builtins.property
    @jsii.member(jsii_name="maxColorsInput")
    def max_colors_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultMaxColors]]], jsii.get(self, "maxColorsInput"))

    @builtins.property
    @jsii.member(jsii_name="mirrorInput")
    def mirror_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultMirror]]], jsii.get(self, "mirrorInput"))

    @builtins.property
    @jsii.member(jsii_name="monoHueInput")
    def mono_hue_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultMonoHue]]], jsii.get(self, "monoHueInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultOpacity]]], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestCropInput")
    def region_of_interest_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultRegionOfInterestCrop"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultRegionOfInterestCrop"]]], jsii.get(self, "regionOfInterestCropInput"))

    @builtins.property
    @jsii.member(jsii_name="relativeCropInput")
    def relative_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultRelativeCrop"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultRelativeCrop"]]], jsii.get(self, "relativeCropInput"))

    @builtins.property
    @jsii.member(jsii_name="removeColorInput")
    def remove_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultRemoveColor"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultRemoveColor"]]], jsii.get(self, "removeColorInput"))

    @builtins.property
    @jsii.member(jsii_name="resizeInput")
    def resize_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultResize"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultResize"]]], jsii.get(self, "resizeInput"))

    @builtins.property
    @jsii.member(jsii_name="rotateInput")
    def rotate_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultRotate"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultRotate"]]], jsii.get(self, "rotateInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultScale"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultScale"]]], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="shearInput")
    def shear_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultShear"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultShear"]]], jsii.get(self, "shearInput"))

    @builtins.property
    @jsii.member(jsii_name="trimInput")
    def trim_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultTrim"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultTrim"]]], jsii.get(self, "trimInput"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMaskInput")
    def unsharp_mask_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultUnsharpMask"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultUnsharpMask"]]], jsii.get(self, "unsharpMaskInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1bbfb31392d833cc13426cfd76468acaed021bac3d21ebd1fdb5ed122541a8b4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultRegionOfInterestCrop",
    jsii_struct_bases=[],
    name_mapping={
        "region_of_interest": "regionOfInterest",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultRegionOfInterestCrop:
    def __init__(
        self,
        *,
        region_of_interest: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultRegionOfInterestCropRegionOfInterest", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param region_of_interest: region_of_interest block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest DataAkamaiImagingPolicyImage#region_of_interest}
        :param gravity: The placement of the crop area relative to the specified area of interest. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: The placement of the crop area relative to the specified area of interest. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param style: Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(region_of_interest, dict):
            region_of_interest = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultRegionOfInterestCropRegionOfInterest(**region_of_interest)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2881f07cc6cfa41e1587b9fe8e7a5f98fda7f50b8ad397ee21312d221fc46868)
            check_type(argname="argument region_of_interest", value=region_of_interest, expected_type=type_hints["region_of_interest"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "region_of_interest": region_of_interest,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def region_of_interest(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultRegionOfInterestCropRegionOfInterest":
        '''region_of_interest block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest DataAkamaiImagingPolicyImage#region_of_interest}
        '''
        result = self._values.get("region_of_interest")
        assert result is not None, "Required property 'region_of_interest' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultRegionOfInterestCropRegionOfInterest", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''The placement of the crop area relative to the specified area of interest.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''The placement of the crop area relative to the specified area of interest.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultRegionOfInterestCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultRegionOfInterestCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultRegionOfInterestCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ca58a59ad27e3af4f7d49d8cb0933a35f56f3e4065d4c6157603eb596980f01)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultRegionOfInterestCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b3feafb4212f86486d4f16834fbcfd55431cefa8f0b75a75194c5c7b03539ac9)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultRegionOfInterestCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__97279a86eaa2a51683cbc98b620ffb0467c445a71f72a1f14d91c77dc9cac9db)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__23e6c0fb9c795a9fee5bea623d68572b7e7c8a603b6390e46ed6c3cef86e4a46)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fac7b7f836c6adb3ac3d38320d9c726e848bd286392776218475cbb0fa5a6144)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultRegionOfInterestCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultRegionOfInterestCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultRegionOfInterestCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ee028b9a2cbbcfef7b61a70d03385ebbd5ba3332cc0fad89811a3038616d4ece)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultRegionOfInterestCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultRegionOfInterestCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b9b410563754962439d3dc8ea4fb73bbc2284f9734c97c46cbab935dc9a035c5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putRegionOfInterest")
    def put_region_of_interest(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultRegionOfInterestCropRegionOfInterest()

        return typing.cast(None, jsii.invoke(self, "putRegionOfInterest", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterest")
    def region_of_interest(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultRegionOfInterestCropRegionOfInterestOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultRegionOfInterestCropRegionOfInterestOutputReference", jsii.get(self, "regionOfInterest"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestInput")
    def region_of_interest_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultRegionOfInterestCropRegionOfInterest"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultRegionOfInterestCropRegionOfInterest"], jsii.get(self, "regionOfInterestInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__69bce1901d0dbcdcd7b552795abb52a5cf1fe7da9ef9973530986b70a2dc1a11)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c6e46a450ae1a533dbe60931ade7847b652a720341713ec53d01ab0f42c30ef3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a7e105b8b2a211bf7550e0911a715ea6e7fff5f3950590360751803425780eb7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d915ea8b1c32af1f9df55d7c04b5144b2b74021a3dedd58ce4b6f91f217a54cc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__44a8d9c2c4037b49829deac88c805bc116bd06422f5eb1eec7fbb91ac292fc7e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ee721e766416a1bfbfe15aa9010fecf9ac5f34115e94ad74aa41f7eb9f547f6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac7d66b23bda6bfd74f0a9de1c487825f8806449cff9abcfdf17a7e244913aaf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9aadf9d90b512ffbe4f82d276286acff46a3be3785c6257c610966b2ac9af42d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultRegionOfInterestCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultRegionOfInterestCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultRegionOfInterestCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9021346369ece907de4a7a998c8343359e41c7c4965f4abcd21d8c443d8f0851)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultRegionOfInterestCropRegionOfInterest",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultRegionOfInterestCropRegionOfInterest:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultRegionOfInterestCropRegionOfInterest(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultRegionOfInterestCropRegionOfInterestOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultRegionOfInterestCropRegionOfInterestOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__47d701a1014d29c167f4a82ff3787b92acb0d98065a06f622bb934d53a2dc7d9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultRegionOfInterestCropRegionOfInterest]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultRegionOfInterestCropRegionOfInterest], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultRegionOfInterestCropRegionOfInterest],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e598607b63ea018c5a10d07357d95edef292b8ce051b2536fd025f058c82f280)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultRelativeCrop",
    jsii_struct_bases=[],
    name_mapping={
        "east": "east",
        "east_var": "eastVar",
        "north": "north",
        "north_var": "northVar",
        "south": "south",
        "south_var": "southVar",
        "west": "west",
        "west_var": "westVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultRelativeCrop:
    def __init__(
        self,
        *,
        east: typing.Optional[builtins.str] = None,
        east_var: typing.Optional[builtins.str] = None,
        north: typing.Optional[builtins.str] = None,
        north_var: typing.Optional[builtins.str] = None,
        south: typing.Optional[builtins.str] = None,
        south_var: typing.Optional[builtins.str] = None,
        west: typing.Optional[builtins.str] = None,
        west_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param east: The number of pixels to shrink or expand the right side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east DataAkamaiImagingPolicyImage#east}
        :param east_var: The number of pixels to shrink or expand the right side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east_var DataAkamaiImagingPolicyImage#east_var}
        :param north: The number of pixels to shrink or expand the top side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north DataAkamaiImagingPolicyImage#north}
        :param north_var: The number of pixels to shrink or expand the top side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north_var DataAkamaiImagingPolicyImage#north_var}
        :param south: The number of pixels to shrink or expand the bottom side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south DataAkamaiImagingPolicyImage#south}
        :param south_var: The number of pixels to shrink or expand the bottom side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south_var DataAkamaiImagingPolicyImage#south_var}
        :param west: The number of pixels to shrink or expand the left side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west DataAkamaiImagingPolicyImage#west}
        :param west_var: The number of pixels to shrink or expand the left side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west_var DataAkamaiImagingPolicyImage#west_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__82747500fa48070fa1b421d3df2f982f9a98ef5c756b4c8548ca1e42d845c000)
            check_type(argname="argument east", value=east, expected_type=type_hints["east"])
            check_type(argname="argument east_var", value=east_var, expected_type=type_hints["east_var"])
            check_type(argname="argument north", value=north, expected_type=type_hints["north"])
            check_type(argname="argument north_var", value=north_var, expected_type=type_hints["north_var"])
            check_type(argname="argument south", value=south, expected_type=type_hints["south"])
            check_type(argname="argument south_var", value=south_var, expected_type=type_hints["south_var"])
            check_type(argname="argument west", value=west, expected_type=type_hints["west"])
            check_type(argname="argument west_var", value=west_var, expected_type=type_hints["west_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if east is not None:
            self._values["east"] = east
        if east_var is not None:
            self._values["east_var"] = east_var
        if north is not None:
            self._values["north"] = north
        if north_var is not None:
            self._values["north_var"] = north_var
        if south is not None:
            self._values["south"] = south
        if south_var is not None:
            self._values["south_var"] = south_var
        if west is not None:
            self._values["west"] = west
        if west_var is not None:
            self._values["west_var"] = west_var

    @builtins.property
    def east(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the right side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east DataAkamaiImagingPolicyImage#east}
        '''
        result = self._values.get("east")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def east_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the right side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east_var DataAkamaiImagingPolicyImage#east_var}
        '''
        result = self._values.get("east_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def north(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the top side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north DataAkamaiImagingPolicyImage#north}
        '''
        result = self._values.get("north")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def north_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the top side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north_var DataAkamaiImagingPolicyImage#north_var}
        '''
        result = self._values.get("north_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def south(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the bottom side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south DataAkamaiImagingPolicyImage#south}
        '''
        result = self._values.get("south")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def south_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the bottom side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south_var DataAkamaiImagingPolicyImage#south_var}
        '''
        result = self._values.get("south_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def west(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the left side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west DataAkamaiImagingPolicyImage#west}
        '''
        result = self._values.get("west")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def west_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the left side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west_var DataAkamaiImagingPolicyImage#west_var}
        '''
        result = self._values.get("west_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultRelativeCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultRelativeCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultRelativeCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b8aa63f638d81a19082b7854b73c6cc692c21984b150c5e21a7fbc8cf31b28f6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultRelativeCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a33e7d4b61902155e6d763a775163da4dd9097b07ad58c490bd265c0f7692e4)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultRelativeCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d984343567dc4e2c07f3e79f700fecee412d9b5729f71d974d45e7291babe20)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__532ccec0d4f3f12425491cc749cc09b6db1428ad91b28adf92cc47503fafa979)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__69be24a41c882a8f17f91ac956d62ab3835a4067ecb4e035e6d6a8b5c18ebb22)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultRelativeCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultRelativeCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultRelativeCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ba385c9bb6152875d3c48a086728cc934aa36868a5dde898c40758bbbbcd5f6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultRelativeCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultRelativeCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a6302df0a32bcb3e23d2a8eefc02766a59bdebffe082c35fe7755fe6bc0e1cd8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetEast")
    def reset_east(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEast", []))

    @jsii.member(jsii_name="resetEastVar")
    def reset_east_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEastVar", []))

    @jsii.member(jsii_name="resetNorth")
    def reset_north(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNorth", []))

    @jsii.member(jsii_name="resetNorthVar")
    def reset_north_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNorthVar", []))

    @jsii.member(jsii_name="resetSouth")
    def reset_south(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSouth", []))

    @jsii.member(jsii_name="resetSouthVar")
    def reset_south_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSouthVar", []))

    @jsii.member(jsii_name="resetWest")
    def reset_west(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWest", []))

    @jsii.member(jsii_name="resetWestVar")
    def reset_west_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWestVar", []))

    @builtins.property
    @jsii.member(jsii_name="eastInput")
    def east_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "eastInput"))

    @builtins.property
    @jsii.member(jsii_name="eastVarInput")
    def east_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "eastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="northInput")
    def north_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "northInput"))

    @builtins.property
    @jsii.member(jsii_name="northVarInput")
    def north_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "northVarInput"))

    @builtins.property
    @jsii.member(jsii_name="southInput")
    def south_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "southInput"))

    @builtins.property
    @jsii.member(jsii_name="southVarInput")
    def south_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "southVarInput"))

    @builtins.property
    @jsii.member(jsii_name="westInput")
    def west_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "westInput"))

    @builtins.property
    @jsii.member(jsii_name="westVarInput")
    def west_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "westVarInput"))

    @builtins.property
    @jsii.member(jsii_name="east")
    def east(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "east"))

    @east.setter
    def east(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8cbcc94cfbd55d37b40476dd37cff98264d4828bec102c15d22b65229427f2cc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "east", value)

    @builtins.property
    @jsii.member(jsii_name="eastVar")
    def east_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "eastVar"))

    @east_var.setter
    def east_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a83be78293fcc3c0bb117988368c762f8faaba588a79c81d290173756d5fffdf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "eastVar", value)

    @builtins.property
    @jsii.member(jsii_name="north")
    def north(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "north"))

    @north.setter
    def north(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1dfedb4e5b51e3cdb2ab448f2a85b6716da61ebe87027859929772e98fb5463a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "north", value)

    @builtins.property
    @jsii.member(jsii_name="northVar")
    def north_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "northVar"))

    @north_var.setter
    def north_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e0d454fcc8a50c78e7f45a62347c02313b69277c27fd9fdc1863407ec5b77a9b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "northVar", value)

    @builtins.property
    @jsii.member(jsii_name="south")
    def south(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "south"))

    @south.setter
    def south(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__20bd950f73c371d1c60e112a8ae6ee5a763aab344e80f5a5c262eee2451330ed)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "south", value)

    @builtins.property
    @jsii.member(jsii_name="southVar")
    def south_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "southVar"))

    @south_var.setter
    def south_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bd8ff20b377ed27646ce3730f5c1a9da45b08bbaa004555c504f94e5e7afd611)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "southVar", value)

    @builtins.property
    @jsii.member(jsii_name="west")
    def west(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "west"))

    @west.setter
    def west(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__92fa41cdcc61dce2eb19740578e3edc267ea9c642027b731d62ad010939ace33)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "west", value)

    @builtins.property
    @jsii.member(jsii_name="westVar")
    def west_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "westVar"))

    @west_var.setter
    def west_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f15db1f70153f20e07bb2dd04914eed7a178ca95a12f3cc627f32d777a4f0661)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "westVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultRelativeCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultRelativeCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultRelativeCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__27e3ca67c1f097266d27ca6bfb1cdf4c627994fa7fac969e3e58321718ab3cfe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultRemoveColor",
    jsii_struct_bases=[],
    name_mapping={
        "color": "color",
        "color_var": "colorVar",
        "feather": "feather",
        "feather_var": "featherVar",
        "tolerance": "tolerance",
        "tolerance_var": "toleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultRemoveColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
        feather: typing.Optional[builtins.str] = None,
        feather_var: typing.Optional[builtins.str] = None,
        tolerance: typing.Optional[builtins.str] = None,
        tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        :param feather: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        :param feather_var: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        :param tolerance: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        :param tolerance_var: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a9fa533ecc3bec94a00ad2888607629bf69e31111b9b96833943051b9d065b10)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
            check_type(argname="argument feather", value=feather, expected_type=type_hints["feather"])
            check_type(argname="argument feather_var", value=feather_var, expected_type=type_hints["feather_var"])
            check_type(argname="argument tolerance", value=tolerance, expected_type=type_hints["tolerance"])
            check_type(argname="argument tolerance_var", value=tolerance_var, expected_type=type_hints["tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var
        if feather is not None:
            self._values["feather"] = feather
        if feather_var is not None:
            self._values["feather_var"] = feather_var
        if tolerance is not None:
            self._values["tolerance"] = tolerance
        if tolerance_var is not None:
            self._values["tolerance_var"] = tolerance_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        '''
        result = self._values.get("feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather_var(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        '''
        result = self._values.get("feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        '''
        result = self._values.get("tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance_var(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        result = self._values.get("tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultRemoveColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultRemoveColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultRemoveColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__92803b535b810feb3dfe05afd95eacdb02a0285fcf633695a35f7966aff149f0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultRemoveColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7a659d894493a3b91717db8b36f126078ffbbde503801267ec4389873f5cad93)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultRemoveColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7694de2f9f9e9d075288d23b1d47641d8d47461ea923b0a7658502158f172943)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a242425202c7fdd1c0aa78c194e3630a72840dde4c67e31b3c184acea8e231ed)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c253dc6af365e9a73b79d7618a21ac8d27df317bdeb54b255ea9871f8d722826)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultRemoveColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultRemoveColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultRemoveColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8298f1eaa71ae6c96c41935df84d97364fdfce2806c600f5b657686f5b7ae90a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultRemoveColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultRemoveColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__08559a08d5bd75eeb5001c696ae6643b25ca4fd0c83f750f6fce9a3a19e98c01)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @jsii.member(jsii_name="resetFeather")
    def reset_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeather", []))

    @jsii.member(jsii_name="resetFeatherVar")
    def reset_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatherVar", []))

    @jsii.member(jsii_name="resetTolerance")
    def reset_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTolerance", []))

    @jsii.member(jsii_name="resetToleranceVar")
    def reset_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featherInput")
    def feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherInput"))

    @builtins.property
    @jsii.member(jsii_name="featherVarInput")
    def feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceInput")
    def tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceVarInput")
    def tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7c37b9f3e952988e38c8a2083e1d48d9dca29dd44f66b7ced47d05b5fe92b6f7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9da20dcb9e51b304e51116bde1bb4eba774057b5d470a6e43a540f99e98acd87)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="feather")
    def feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "feather"))

    @feather.setter
    def feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5e685e2eab819922e462c952d588747c37e44909389b5c61f8feeab8fe921bee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "feather", value)

    @builtins.property
    @jsii.member(jsii_name="featherVar")
    def feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featherVar"))

    @feather_var.setter
    def feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__565cb9e4aab1b0bc45bd1a3c7d702955ba4e7c72a1bad7553c251810b8105ccf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featherVar", value)

    @builtins.property
    @jsii.member(jsii_name="tolerance")
    def tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tolerance"))

    @tolerance.setter
    def tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__58460978c538c577bed3efa581832e6ac67eb23f3bfea5b68f69a2a488e159af)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tolerance", value)

    @builtins.property
    @jsii.member(jsii_name="toleranceVar")
    def tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "toleranceVar"))

    @tolerance_var.setter
    def tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cda1ac80542f70c676a7339b757e15ca19e888294c5937b0896e5fea774b7053)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "toleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultRemoveColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultRemoveColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultRemoveColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa583c9bd67383434899c8300b1065cfe5a7d6fb0760ae6a592c5eb1eb25d4f3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultResize",
    jsii_struct_bases=[],
    name_mapping={
        "aspect": "aspect",
        "aspect_var": "aspectVar",
        "height": "height",
        "height_var": "heightVar",
        "type": "type",
        "type_var": "typeVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultResize:
    def __init__(
        self,
        *,
        aspect: typing.Optional[builtins.str] = None,
        aspect_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param aspect: Preserves the aspect ratio. Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect DataAkamaiImagingPolicyImage#aspect}
        :param aspect_var: Preserves the aspect ratio. Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_var DataAkamaiImagingPolicyImage#aspect_var}
        :param height: The height to resize the source image to. Must be set if height is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height to resize the source image to. Must be set if height is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param type: Sets constraints for the image resize. Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: Sets constraints for the image resize. Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        :param width: The width to resize the source image to. Must be set if width is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width to resize the source image to. Must be set if width is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b0ab3d436b73e120d88b18828566cefdafc822398aaf9feac85cce8f0c64286a)
            check_type(argname="argument aspect", value=aspect, expected_type=type_hints["aspect"])
            check_type(argname="argument aspect_var", value=aspect_var, expected_type=type_hints["aspect_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if aspect is not None:
            self._values["aspect"] = aspect
        if aspect_var is not None:
            self._values["aspect_var"] = aspect_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def aspect(self) -> typing.Optional[builtins.str]:
        '''Preserves the aspect ratio.

        Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect DataAkamaiImagingPolicyImage#aspect}
        '''
        result = self._values.get("aspect")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def aspect_var(self) -> typing.Optional[builtins.str]:
        '''Preserves the aspect ratio.

        Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_var DataAkamaiImagingPolicyImage#aspect_var}
        '''
        result = self._values.get("aspect_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height to resize the source image to. Must be set if height is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height to resize the source image to. Must be set if height is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''Sets constraints for the image resize.

        Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''Sets constraints for the image resize.

        Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width to resize the source image to. Must be set if width is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width to resize the source image to. Must be set if width is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultResize(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultResizeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultResizeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bdf09660809d7485f601b311939fd9b25de712ff222a7e9346b3bade9616ff2a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultResizeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__81f309f3de8485471dd5600c94727a3b1b068281990cf5499aaa59c7aebcd304)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultResizeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__26bdb2614bd12c13bf0f1268c3be08e4545101d926847325239fe9fcd3f5f6ce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ca82ec47df834cf518b32b317b1f62d21e0b13d0e0c7df8c990500deb06ac2b8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6922a71ee2f7145ad4da2271dcd33c82e926eee5f6bb8ac20282e600250c21d3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultResize]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultResize]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultResize]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__658c04865cdea3030617de268985ddbc58f994a4bddf4d9b231f900003c95459)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultResizeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultResizeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f09b43f9df0f833b671b421dcbc9ef7d1f3242cb81d5284ece14808dc585e4ce)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAspect")
    def reset_aspect(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspect", []))

    @jsii.member(jsii_name="resetAspectVar")
    def reset_aspect_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspectVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="aspectInput")
    def aspect_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "aspectInput"))

    @builtins.property
    @jsii.member(jsii_name="aspectVarInput")
    def aspect_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "aspectVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="aspect")
    def aspect(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "aspect"))

    @aspect.setter
    def aspect(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bed5e31f3cc62c6507491a35ca0f4c8f7d212c1a911a432bd4c396e7c2b4e66c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "aspect", value)

    @builtins.property
    @jsii.member(jsii_name="aspectVar")
    def aspect_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "aspectVar"))

    @aspect_var.setter
    def aspect_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c08c43302ae67a2a81838eb04072b7266d7106f4482cc804d87301bdc9ca7529)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "aspectVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f8b1d1a1169bbc92872c51bd8770b7396c9eb5b94c21e0d557a4da1ad9e6622e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__35721d8608b414eb63ec593583922cf0c051d00edb5512f7a7dc42fc8ada9dbd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__76d46a2b0fd15462a01e3c161024740cb81ebcccbf4643116cdee4299800d274)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__00f00642cd9e0f103aba0fa7ce45421426c5e31a7dceeefa571e3eee7279c55a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__abea4a59d96d83d0ab0adee0fdb2c3d055083db05f91cb77adf6198aea5459df)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9e8f594889f45817ea0f1e959a95516893e91170494df621cfc28e276db27171)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultResize]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultResize]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultResize]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__75264e2d08b7ed907130062fa1d205bc7c9c852d0d91bb0afea619f2153f1a5a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultRotate",
    jsii_struct_bases=[],
    name_mapping={"degrees": "degrees", "degrees_var": "degreesVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultRotate:
    def __init__(
        self,
        *,
        degrees: typing.Optional[builtins.str] = None,
        degrees_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param degrees: The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees DataAkamaiImagingPolicyImage#degrees}
        :param degrees_var: The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees_var DataAkamaiImagingPolicyImage#degrees_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__deb22fba228ca1c06e9b38d7324bb88b934c9ceb8328f6cc08da1e25c40ecc8f)
            check_type(argname="argument degrees", value=degrees, expected_type=type_hints["degrees"])
            check_type(argname="argument degrees_var", value=degrees_var, expected_type=type_hints["degrees_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if degrees is not None:
            self._values["degrees"] = degrees
        if degrees_var is not None:
            self._values["degrees_var"] = degrees_var

    @builtins.property
    def degrees(self) -> typing.Optional[builtins.str]:
        '''The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees DataAkamaiImagingPolicyImage#degrees}
        '''
        result = self._values.get("degrees")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def degrees_var(self) -> typing.Optional[builtins.str]:
        '''The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees_var DataAkamaiImagingPolicyImage#degrees_var}
        '''
        result = self._values.get("degrees_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultRotate(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultRotateList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultRotateList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__98e127ed4bc3ef332d361e47837db63bfdc5f31444c6263d952ce61cfd6ce083)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultRotateOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__02598557e03b7ad1c87a741c7ebb61bfbc1ac2e54e9e5c550e2be2e615c97b09)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultRotateOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ecfb2761bd45fc7c0279d1fe0a06f78b855e0c9a179cb0fa3584230c9cd9d3d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__347230e50e164e907aa57ad8acf3a90932eeefad5f92e13ce759789c79fa29b1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a619b8d986dd0f4af58aecf878c6684381fd4460409aa1100c85707f30b60016)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultRotate]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultRotate]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultRotate]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c7998b14d50597334cb304ab2892387c105ffbcf22d721867761827935596a76)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultRotateOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultRotateOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__29914b4ccd3f3239bf52a3d8969cecccab28796d1f5c142963a5b912cfa7ad15)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetDegrees")
    def reset_degrees(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDegrees", []))

    @jsii.member(jsii_name="resetDegreesVar")
    def reset_degrees_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDegreesVar", []))

    @builtins.property
    @jsii.member(jsii_name="degreesInput")
    def degrees_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "degreesInput"))

    @builtins.property
    @jsii.member(jsii_name="degreesVarInput")
    def degrees_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "degreesVarInput"))

    @builtins.property
    @jsii.member(jsii_name="degrees")
    def degrees(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "degrees"))

    @degrees.setter
    def degrees(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a6ab4210169d0ad69156455b8a35ae8c021ff13d5962517db701fa36398873e6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "degrees", value)

    @builtins.property
    @jsii.member(jsii_name="degreesVar")
    def degrees_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "degreesVar"))

    @degrees_var.setter
    def degrees_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a63af70e65576dcec77b45933715ae7e140e4f649bac867323d36511d805747)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "degreesVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultRotate]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultRotate]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultRotate]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b62756eeef7a15ace3cadab622c2352a8c0f791b08c66881fdafe698eb16e274)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultScale",
    jsii_struct_bases=[],
    name_mapping={
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultScale:
    def __init__(
        self,
        *,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param height: Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged. Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged. Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e78aeaace3bf3a0e10d06ad69fd9e658d9add373a149c1be19f6b6301f01f6f6)
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size.

        Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size.

        Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged.

        Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged.

        Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultScale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultScaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultScaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7aa937b0f8cbe6192420ddc7623a26b38d7dcc479a0d161b28df3967620d796b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultScaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__107bd15ae73d808b75f9b304ac89a87c57d01a71313e61ff9d71d60f0946c238)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultScaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c93c03925333b57c8b22b094fb3f8c422b80a7be17e8cca794abd566335e6507)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d45b077f2a0701fb4105226ea9500c778c504959c9e4bed8cf371adb596a581c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d2103fd740fbb9c9a074197397cbac92d83936e88850e2a28285abdb8b3f9bf3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultScale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultScale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultScale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c05fb55798ca90dc9cfc866f467f7bcad3e8c97fc7bd924cc352ba070cda2eac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultScaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultScaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__076f7b381b26869e567a7d481da1b2f3f602e4b17e57068e1900e05f7328fe2c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__993dda67dba8e12768aca2121904663b32e51883f83dcc885d93143dbcc5b38e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ae53d74a392c5ef58d9772a9e3198b4c2d2542c65efc302c748a37d0681dd3ec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8b837dd6418281fef92c357ecb721ab0f0f90237531b06fcfcc82e58a5fe59a5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ca24186c0a076610eaa8c250c7cc7709c7bfa43c644b96acf29b8799a028ee4e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultScale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultScale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultScale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b61732ca79536effcf145d108f7c186e7ff8a0cf87b16018df64e80ec4250571)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultShear",
    jsii_struct_bases=[],
    name_mapping={
        "x_shear": "xShear",
        "x_shear_var": "xShearVar",
        "y_shear": "yShear",
        "y_shear_var": "yShearVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultShear:
    def __init__(
        self,
        *,
        x_shear: typing.Optional[builtins.str] = None,
        x_shear_var: typing.Optional[builtins.str] = None,
        y_shear: typing.Optional[builtins.str] = None,
        y_shear_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param x_shear: The amount to shear along the x-axis, measured in multiples of the image's width. Must be set if yShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear DataAkamaiImagingPolicyImage#x_shear}
        :param x_shear_var: The amount to shear along the x-axis, measured in multiples of the image's width. Must be set if yShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear_var DataAkamaiImagingPolicyImage#x_shear_var}
        :param y_shear: The amount to shear along the y-axis, measured in multiples of the image's height. Must be set if xShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear DataAkamaiImagingPolicyImage#y_shear}
        :param y_shear_var: The amount to shear along the y-axis, measured in multiples of the image's height. Must be set if xShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear_var DataAkamaiImagingPolicyImage#y_shear_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__521316b675de66a9329703ab5d2d5a19a078030d754dcd5790880031ca67a3d6)
            check_type(argname="argument x_shear", value=x_shear, expected_type=type_hints["x_shear"])
            check_type(argname="argument x_shear_var", value=x_shear_var, expected_type=type_hints["x_shear_var"])
            check_type(argname="argument y_shear", value=y_shear, expected_type=type_hints["y_shear"])
            check_type(argname="argument y_shear_var", value=y_shear_var, expected_type=type_hints["y_shear_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if x_shear is not None:
            self._values["x_shear"] = x_shear
        if x_shear_var is not None:
            self._values["x_shear_var"] = x_shear_var
        if y_shear is not None:
            self._values["y_shear"] = y_shear
        if y_shear_var is not None:
            self._values["y_shear_var"] = y_shear_var

    @builtins.property
    def x_shear(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the x-axis, measured in multiples of the image's width.

        Must be set if yShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear DataAkamaiImagingPolicyImage#x_shear}
        '''
        result = self._values.get("x_shear")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_shear_var(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the x-axis, measured in multiples of the image's width.

        Must be set if yShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear_var DataAkamaiImagingPolicyImage#x_shear_var}
        '''
        result = self._values.get("x_shear_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_shear(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the y-axis, measured in multiples of the image's height.

        Must be set if xShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear DataAkamaiImagingPolicyImage#y_shear}
        '''
        result = self._values.get("y_shear")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_shear_var(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the y-axis, measured in multiples of the image's height.

        Must be set if xShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear_var DataAkamaiImagingPolicyImage#y_shear_var}
        '''
        result = self._values.get("y_shear_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultShear(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultShearList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultShearList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__020e0d1cfcfe199753c94e6fa55a090a0e08b37b8148e80810e289aa6f8e5526)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultShearOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9c0f37ee65a5b25c49f0f588d71e2e1eb862a8d5da4daa112321381e28ab269c)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultShearOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2327f82b16fe2e77ae206b298a826871b4996885b790b13e0d6154e3de61422e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a29b9590a79091e5cf3c22fcad2fe58936c66ed454d32f184fee109c77c2c572)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8b2b90f130e59f6f819c8990cf845076e362462399e0b093e4493eeae4fb021b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultShear]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultShear]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultShear]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a87fe6d0f4a4487e2fb9e387f8bb2d6d596dc440603556798c45a97437cd9340)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultShearOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultShearOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3029dda40f59373295c143b0d019867a6f16094fe7aba1c2e3525a23983bf6c3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetXShear")
    def reset_x_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXShear", []))

    @jsii.member(jsii_name="resetXShearVar")
    def reset_x_shear_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXShearVar", []))

    @jsii.member(jsii_name="resetYShear")
    def reset_y_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYShear", []))

    @jsii.member(jsii_name="resetYShearVar")
    def reset_y_shear_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYShearVar", []))

    @builtins.property
    @jsii.member(jsii_name="xShearInput")
    def x_shear_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xShearInput"))

    @builtins.property
    @jsii.member(jsii_name="xShearVarInput")
    def x_shear_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xShearVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yShearInput")
    def y_shear_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yShearInput"))

    @builtins.property
    @jsii.member(jsii_name="yShearVarInput")
    def y_shear_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yShearVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xShear")
    def x_shear(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xShear"))

    @x_shear.setter
    def x_shear(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e0688b172946ebac9049dbd5ee39ea1eb5e92bff7007f0db340253962386ece4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xShear", value)

    @builtins.property
    @jsii.member(jsii_name="xShearVar")
    def x_shear_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xShearVar"))

    @x_shear_var.setter
    def x_shear_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9710ce40a7151e635bfe4ce5694b4699b28bdc0693508aaf50de9be786a48c69)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xShearVar", value)

    @builtins.property
    @jsii.member(jsii_name="yShear")
    def y_shear(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yShear"))

    @y_shear.setter
    def y_shear(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f4cdeb45795e81d89680e1366bf707610cfec562e4b996bcb46dc793e17e77d6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yShear", value)

    @builtins.property
    @jsii.member(jsii_name="yShearVar")
    def y_shear_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yShearVar"))

    @y_shear_var.setter
    def y_shear_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__42a086be156630b6c9bd00322a7b574587f0b01f2d9deb3e6825570946e668b2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yShearVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultShear]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultShear]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultShear]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__45da983e388c762b430009d5d91ebaf2364a0f31535a9d7ada74b5c7518a0397)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultTrim",
    jsii_struct_bases=[],
    name_mapping={
        "fuzz": "fuzz",
        "fuzz_var": "fuzzVar",
        "padding": "padding",
        "padding_var": "paddingVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultTrim:
    def __init__(
        self,
        *,
        fuzz: typing.Optional[builtins.str] = None,
        fuzz_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fuzz: The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz DataAkamaiImagingPolicyImage#fuzz}
        :param fuzz_var: The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz_var DataAkamaiImagingPolicyImage#fuzz_var}
        :param padding: The amount of padding in pixels to add to the trimmed image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: The amount of padding in pixels to add to the trimmed image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a1bcbc9c96cfa678be389a9b7d50c4b2b4a0eaa1d420cf2bcb4268de726cbf6e)
            check_type(argname="argument fuzz", value=fuzz, expected_type=type_hints["fuzz"])
            check_type(argname="argument fuzz_var", value=fuzz_var, expected_type=type_hints["fuzz_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fuzz is not None:
            self._values["fuzz"] = fuzz
        if fuzz_var is not None:
            self._values["fuzz_var"] = fuzz_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var

    @builtins.property
    def fuzz(self) -> typing.Optional[builtins.str]:
        '''The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz DataAkamaiImagingPolicyImage#fuzz}
        '''
        result = self._values.get("fuzz")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fuzz_var(self) -> typing.Optional[builtins.str]:
        '''The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz_var DataAkamaiImagingPolicyImage#fuzz_var}
        '''
        result = self._values.get("fuzz_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''The amount of padding in pixels to add to the trimmed image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''The amount of padding in pixels to add to the trimmed image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultTrim(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultTrimList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultTrimList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7e591348f0b91f9f3a59e061a36a7d8598c7cd4009551015cb42e4d8d37e4fee)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultTrimOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__29a6f8dddb20c5bd99c4ce3560658a39a08b21e8de2030751704fa117478c564)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultTrimOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dc6eb62c4c70953d7b9083b56f4e80bb1dfdcca19288cde1509f066d4461f01c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d01789ed68bff71929005b210e4ee7aee07dd176c48baeaf487e2eed1def4ca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__31fcb1b25e96ac5bf0750a3965c11fb05fab0a16a53dfe5a1da06fd8bf45dd59)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultTrim]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultTrim]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultTrim]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4bc8fb51ed6bb6ace1c5cc20ac973c345af436bf49e068f3cebaeea8be1d6528)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultTrimOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultTrimOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e880cda11ce4e9bb3f69ddbe77c9c2ed56193bc05f1d6d2205e437954180e1b2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetFuzz")
    def reset_fuzz(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFuzz", []))

    @jsii.member(jsii_name="resetFuzzVar")
    def reset_fuzz_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFuzzVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @builtins.property
    @jsii.member(jsii_name="fuzzInput")
    def fuzz_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fuzzInput"))

    @builtins.property
    @jsii.member(jsii_name="fuzzVarInput")
    def fuzz_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fuzzVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="fuzz")
    def fuzz(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fuzz"))

    @fuzz.setter
    def fuzz(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c4c2a61894e1c21721a782b92ada411039528cfda21beebc243ff2d78b81c9f2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fuzz", value)

    @builtins.property
    @jsii.member(jsii_name="fuzzVar")
    def fuzz_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fuzzVar"))

    @fuzz_var.setter
    def fuzz_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7f27a8e3caf6e095c011262ebcf712b6604ff50b35d7ed2751b72f6e78093566)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fuzzVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e39237ddccc84ee457dd08a14e58413b17c7957e0855548ecac8923ba380f92e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c69cafd53de2da738980357663c74ad8fddd007bade7ef790e201f1848b753d3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultTrim]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultTrim]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultTrim]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e77c3be69378edebd6e4e66f467dad71438e9a605e05e690cb9961e9c387576b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultUnsharpMask",
    jsii_struct_bases=[],
    name_mapping={
        "gain": "gain",
        "gain_var": "gainVar",
        "sigma": "sigma",
        "sigma_var": "sigmaVar",
        "threshold": "threshold",
        "threshold_var": "thresholdVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultUnsharpMask:
    def __init__(
        self,
        *,
        gain: typing.Optional[builtins.str] = None,
        gain_var: typing.Optional[builtins.str] = None,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
        threshold: typing.Optional[builtins.str] = None,
        threshold_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param gain: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        :param gain_var: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        :param sigma: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        :param threshold: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        :param threshold_var: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc5b10827fc173cf71f80cbe2b0d5724bb809923d4cb2754187d2ffa700b88d9)
            check_type(argname="argument gain", value=gain, expected_type=type_hints["gain"])
            check_type(argname="argument gain_var", value=gain_var, expected_type=type_hints["gain_var"])
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
            check_type(argname="argument threshold", value=threshold, expected_type=type_hints["threshold"])
            check_type(argname="argument threshold_var", value=threshold_var, expected_type=type_hints["threshold_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if gain is not None:
            self._values["gain"] = gain
        if gain_var is not None:
            self._values["gain_var"] = gain_var
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var
        if threshold is not None:
            self._values["threshold"] = threshold
        if threshold_var is not None:
            self._values["threshold_var"] = threshold_var

    @builtins.property
    def gain(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        '''
        result = self._values.get("gain")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gain_var(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        '''
        result = self._values.get("gain_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        '''
        result = self._values.get("threshold")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold_var(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        result = self._values.get("threshold_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultUnsharpMask(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultUnsharpMaskList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultUnsharpMaskList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6331cfcddf2b41257a5bbe4e56695fb8ec9f6bbf23cec18233a6f4cd8a9a71b0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultUnsharpMaskOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9e2fa013a525e213f0690b6eb0f04de7affd62bb031b78e595cd55c5dcc2ba1b)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultUnsharpMaskOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8cf46cb455304179af0d29183eb759e4b4aae48edc31f374950869fa0a755744)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__10fccf99114c728a3e3fe932786db2330fd0b17be21722c5b277332b5e2e4413)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ad612bea51636b384cb13cc3971f5ebf90d7e593e149c07e63b52ac45800bb02)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultUnsharpMask]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultUnsharpMask]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultUnsharpMask]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f9b15c2eb9766444a277455aac3ab801250746288af853dfa1122ff04d157613)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultUnsharpMaskOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultUnsharpMaskOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cac602bab35203b5de5cd6dac96ad2d286117c72984cb122201600d3461bc5ee)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetGain")
    def reset_gain(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGain", []))

    @jsii.member(jsii_name="resetGainVar")
    def reset_gain_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGainVar", []))

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @jsii.member(jsii_name="resetThreshold")
    def reset_threshold(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThreshold", []))

    @jsii.member(jsii_name="resetThresholdVar")
    def reset_threshold_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThresholdVar", []))

    @builtins.property
    @jsii.member(jsii_name="gainInput")
    def gain_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainInput"))

    @builtins.property
    @jsii.member(jsii_name="gainVarInput")
    def gain_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdInput")
    def threshold_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdVarInput")
    def threshold_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gain")
    def gain(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gain"))

    @gain.setter
    def gain(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3418def8fab98ba8a8660823035e1d0977a0240f377d9611309f0fe33a810bd0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gain", value)

    @builtins.property
    @jsii.member(jsii_name="gainVar")
    def gain_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gainVar"))

    @gain_var.setter
    def gain_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f6fca20e1bb3d049e1fb09646ab09ca988e66435c3aa7ccd1bb2c45da9bf1d7c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gainVar", value)

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__85e427ddcffccfb053132eead5da5ceca6819aea1e4673a797976a8b8fea0109)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__86bf3203b29aaebd2aadeb5c816a6763bfbe034733d480f5abfd142a360429ab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="threshold")
    def threshold(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "threshold"))

    @threshold.setter
    def threshold(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7e08c60be393f0a8357e413a833817189b97fd9fdc5e75780a1d1d3a37dd68ce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "threshold", value)

    @builtins.property
    @jsii.member(jsii_name="thresholdVar")
    def threshold_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "thresholdVar"))

    @threshold_var.setter
    def threshold_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__db5fc19d3c247f7aedb6619a751b0331e27cdcd8d10a7d4d5eab75ace2aa8635)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "thresholdVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultUnsharpMask]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultUnsharpMask]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultUnsharpMask]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ca34f5bba7563c9e9393bcc824623a4eeda55822c342c44b76640b8d60221165)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscape",
    jsii_struct_bases=[],
    name_mapping={
        "append": "append",
        "aspect_crop": "aspectCrop",
        "background_color": "backgroundColor",
        "blur": "blur",
        "chroma_key": "chromaKey",
        "composite": "composite",
        "compound": "compound",
        "contrast": "contrast",
        "crop": "crop",
        "face_crop": "faceCrop",
        "feature_crop": "featureCrop",
        "fit_and_fill": "fitAndFill",
        "goop": "goop",
        "grayscale": "grayscale",
        "hsl": "hsl",
        "hsv": "hsv",
        "if_dimension": "ifDimension",
        "if_orientation": "ifOrientation",
        "im_query": "imQuery",
        "max_colors": "maxColors",
        "mirror": "mirror",
        "mono_hue": "monoHue",
        "opacity": "opacity",
        "region_of_interest_crop": "regionOfInterestCrop",
        "relative_crop": "relativeCrop",
        "remove_color": "removeColor",
        "resize": "resize",
        "rotate": "rotate",
        "scale": "scale",
        "shear": "shear",
        "trim": "trim",
        "unsharp_mask": "unsharpMask",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscape:
    def __init__(
        self,
        *,
        append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeAppend", typing.Dict[builtins.str, typing.Any]]]]] = None,
        aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeAspectCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeBackgroundColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeBlur", typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeChromaKey", typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeComposite", typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCompound", typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeContrast", typing.Dict[builtins.str, typing.Any]]]]] = None,
        crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeFaceCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeFeatureCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeFitAndFill", typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeGoop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeGrayscale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeHsl", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeHsv", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimension", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientation", typing.Dict[builtins.str, typing.Any]]]]] = None,
        im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeImQuery", typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeMaxColors", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeMirror", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeMonoHue", typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeOpacity", typing.Dict[builtins.str, typing.Any]]]]] = None,
        region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRegionOfInterestCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRelativeCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRemoveColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeResize", typing.Dict[builtins.str, typing.Any]]]]] = None,
        rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRotate", typing.Dict[builtins.str, typing.Any]]]]] = None,
        scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeScale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeShear", typing.Dict[builtins.str, typing.Any]]]]] = None,
        trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeTrim", typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeUnsharpMask", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param append: append block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        :param aspect_crop: aspect_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param crop: crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        :param face_crop: face_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        :param feature_crop: feature_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        :param fit_and_fill: fit_and_fill block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param im_query: im_query block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param region_of_interest_crop: region_of_interest_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        :param relative_crop: relative_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param resize: resize block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        :param rotate: rotate block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        :param scale: scale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param shear: shear block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        :param trim: trim block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fcb8260a82724bd47c058010b32c175199e023abf8b0f49cf7c109e149477850)
            check_type(argname="argument append", value=append, expected_type=type_hints["append"])
            check_type(argname="argument aspect_crop", value=aspect_crop, expected_type=type_hints["aspect_crop"])
            check_type(argname="argument background_color", value=background_color, expected_type=type_hints["background_color"])
            check_type(argname="argument blur", value=blur, expected_type=type_hints["blur"])
            check_type(argname="argument chroma_key", value=chroma_key, expected_type=type_hints["chroma_key"])
            check_type(argname="argument composite", value=composite, expected_type=type_hints["composite"])
            check_type(argname="argument compound", value=compound, expected_type=type_hints["compound"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument crop", value=crop, expected_type=type_hints["crop"])
            check_type(argname="argument face_crop", value=face_crop, expected_type=type_hints["face_crop"])
            check_type(argname="argument feature_crop", value=feature_crop, expected_type=type_hints["feature_crop"])
            check_type(argname="argument fit_and_fill", value=fit_and_fill, expected_type=type_hints["fit_and_fill"])
            check_type(argname="argument goop", value=goop, expected_type=type_hints["goop"])
            check_type(argname="argument grayscale", value=grayscale, expected_type=type_hints["grayscale"])
            check_type(argname="argument hsl", value=hsl, expected_type=type_hints["hsl"])
            check_type(argname="argument hsv", value=hsv, expected_type=type_hints["hsv"])
            check_type(argname="argument if_dimension", value=if_dimension, expected_type=type_hints["if_dimension"])
            check_type(argname="argument if_orientation", value=if_orientation, expected_type=type_hints["if_orientation"])
            check_type(argname="argument im_query", value=im_query, expected_type=type_hints["im_query"])
            check_type(argname="argument max_colors", value=max_colors, expected_type=type_hints["max_colors"])
            check_type(argname="argument mirror", value=mirror, expected_type=type_hints["mirror"])
            check_type(argname="argument mono_hue", value=mono_hue, expected_type=type_hints["mono_hue"])
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument region_of_interest_crop", value=region_of_interest_crop, expected_type=type_hints["region_of_interest_crop"])
            check_type(argname="argument relative_crop", value=relative_crop, expected_type=type_hints["relative_crop"])
            check_type(argname="argument remove_color", value=remove_color, expected_type=type_hints["remove_color"])
            check_type(argname="argument resize", value=resize, expected_type=type_hints["resize"])
            check_type(argname="argument rotate", value=rotate, expected_type=type_hints["rotate"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument shear", value=shear, expected_type=type_hints["shear"])
            check_type(argname="argument trim", value=trim, expected_type=type_hints["trim"])
            check_type(argname="argument unsharp_mask", value=unsharp_mask, expected_type=type_hints["unsharp_mask"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if append is not None:
            self._values["append"] = append
        if aspect_crop is not None:
            self._values["aspect_crop"] = aspect_crop
        if background_color is not None:
            self._values["background_color"] = background_color
        if blur is not None:
            self._values["blur"] = blur
        if chroma_key is not None:
            self._values["chroma_key"] = chroma_key
        if composite is not None:
            self._values["composite"] = composite
        if compound is not None:
            self._values["compound"] = compound
        if contrast is not None:
            self._values["contrast"] = contrast
        if crop is not None:
            self._values["crop"] = crop
        if face_crop is not None:
            self._values["face_crop"] = face_crop
        if feature_crop is not None:
            self._values["feature_crop"] = feature_crop
        if fit_and_fill is not None:
            self._values["fit_and_fill"] = fit_and_fill
        if goop is not None:
            self._values["goop"] = goop
        if grayscale is not None:
            self._values["grayscale"] = grayscale
        if hsl is not None:
            self._values["hsl"] = hsl
        if hsv is not None:
            self._values["hsv"] = hsv
        if if_dimension is not None:
            self._values["if_dimension"] = if_dimension
        if if_orientation is not None:
            self._values["if_orientation"] = if_orientation
        if im_query is not None:
            self._values["im_query"] = im_query
        if max_colors is not None:
            self._values["max_colors"] = max_colors
        if mirror is not None:
            self._values["mirror"] = mirror
        if mono_hue is not None:
            self._values["mono_hue"] = mono_hue
        if opacity is not None:
            self._values["opacity"] = opacity
        if region_of_interest_crop is not None:
            self._values["region_of_interest_crop"] = region_of_interest_crop
        if relative_crop is not None:
            self._values["relative_crop"] = relative_crop
        if remove_color is not None:
            self._values["remove_color"] = remove_color
        if resize is not None:
            self._values["resize"] = resize
        if rotate is not None:
            self._values["rotate"] = rotate
        if scale is not None:
            self._values["scale"] = scale
        if shear is not None:
            self._values["shear"] = shear
        if trim is not None:
            self._values["trim"] = trim
        if unsharp_mask is not None:
            self._values["unsharp_mask"] = unsharp_mask

    @builtins.property
    def append(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeAppend"]]]:
        '''append block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        '''
        result = self._values.get("append")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeAppend"]]], result)

    @builtins.property
    def aspect_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeAspectCrop"]]]:
        '''aspect_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        '''
        result = self._values.get("aspect_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeAspectCrop"]]], result)

    @builtins.property
    def background_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeBackgroundColor"]]]:
        '''background_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        '''
        result = self._values.get("background_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeBackgroundColor"]]], result)

    @builtins.property
    def blur(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeBlur"]]]:
        '''blur block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        '''
        result = self._values.get("blur")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeBlur"]]], result)

    @builtins.property
    def chroma_key(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeChromaKey"]]]:
        '''chroma_key block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        '''
        result = self._values.get("chroma_key")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeChromaKey"]]], result)

    @builtins.property
    def composite(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeComposite"]]]:
        '''composite block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        '''
        result = self._values.get("composite")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeComposite"]]], result)

    @builtins.property
    def compound(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCompound"]]]:
        '''compound block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        '''
        result = self._values.get("compound")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCompound"]]], result)

    @builtins.property
    def contrast(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeContrast"]]]:
        '''contrast block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeContrast"]]], result)

    @builtins.property
    def crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCrop"]]]:
        '''crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        '''
        result = self._values.get("crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCrop"]]], result)

    @builtins.property
    def face_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeFaceCrop"]]]:
        '''face_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        '''
        result = self._values.get("face_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeFaceCrop"]]], result)

    @builtins.property
    def feature_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeFeatureCrop"]]]:
        '''feature_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        '''
        result = self._values.get("feature_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeFeatureCrop"]]], result)

    @builtins.property
    def fit_and_fill(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeFitAndFill"]]]:
        '''fit_and_fill block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        '''
        result = self._values.get("fit_and_fill")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeFitAndFill"]]], result)

    @builtins.property
    def goop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeGoop"]]]:
        '''goop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        '''
        result = self._values.get("goop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeGoop"]]], result)

    @builtins.property
    def grayscale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeGrayscale"]]]:
        '''grayscale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        '''
        result = self._values.get("grayscale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeGrayscale"]]], result)

    @builtins.property
    def hsl(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeHsl"]]]:
        '''hsl block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        '''
        result = self._values.get("hsl")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeHsl"]]], result)

    @builtins.property
    def hsv(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeHsv"]]]:
        '''hsv block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        '''
        result = self._values.get("hsv")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeHsv"]]], result)

    @builtins.property
    def if_dimension(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimension"]]]:
        '''if_dimension block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        '''
        result = self._values.get("if_dimension")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimension"]]], result)

    @builtins.property
    def if_orientation(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientation"]]]:
        '''if_orientation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        '''
        result = self._values.get("if_orientation")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientation"]]], result)

    @builtins.property
    def im_query(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeImQuery"]]]:
        '''im_query block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        '''
        result = self._values.get("im_query")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeImQuery"]]], result)

    @builtins.property
    def max_colors(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeMaxColors"]]]:
        '''max_colors block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        '''
        result = self._values.get("max_colors")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeMaxColors"]]], result)

    @builtins.property
    def mirror(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeMirror"]]]:
        '''mirror block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        '''
        result = self._values.get("mirror")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeMirror"]]], result)

    @builtins.property
    def mono_hue(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeMonoHue"]]]:
        '''mono_hue block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        '''
        result = self._values.get("mono_hue")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeMonoHue"]]], result)

    @builtins.property
    def opacity(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeOpacity"]]]:
        '''opacity block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeOpacity"]]], result)

    @builtins.property
    def region_of_interest_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRegionOfInterestCrop"]]]:
        '''region_of_interest_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        '''
        result = self._values.get("region_of_interest_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRegionOfInterestCrop"]]], result)

    @builtins.property
    def relative_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRelativeCrop"]]]:
        '''relative_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        '''
        result = self._values.get("relative_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRelativeCrop"]]], result)

    @builtins.property
    def remove_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRemoveColor"]]]:
        '''remove_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        '''
        result = self._values.get("remove_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRemoveColor"]]], result)

    @builtins.property
    def resize(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeResize"]]]:
        '''resize block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        '''
        result = self._values.get("resize")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeResize"]]], result)

    @builtins.property
    def rotate(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRotate"]]]:
        '''rotate block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        '''
        result = self._values.get("rotate")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRotate"]]], result)

    @builtins.property
    def scale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeScale"]]]:
        '''scale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeScale"]]], result)

    @builtins.property
    def shear(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeShear"]]]:
        '''shear block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        '''
        result = self._values.get("shear")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeShear"]]], result)

    @builtins.property
    def trim(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeTrim"]]]:
        '''trim block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        '''
        result = self._values.get("trim")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeTrim"]]], result)

    @builtins.property
    def unsharp_mask(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeUnsharpMask"]]]:
        '''unsharp_mask block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        result = self._values.get("unsharp_mask")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeUnsharpMask"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscape(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeAppend",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_priority": "gravityPriority",
        "gravity_priority_var": "gravityPriorityVar",
        "gravity_var": "gravityVar",
        "preserve_minor_dimension": "preserveMinorDimension",
        "preserve_minor_dimension_var": "preserveMinorDimensionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeAppend:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeAppendImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_priority: typing.Optional[builtins.str] = None,
        gravity_priority_var: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        preserve_minor_dimension: typing.Optional[builtins.str] = None,
        preserve_minor_dimension_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Specifies where to place the ``image`` relative to the source image. The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_priority: Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal. The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority DataAkamaiImagingPolicyImage#gravity_priority}
        :param gravity_priority_var: Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal. The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority_var DataAkamaiImagingPolicyImage#gravity_priority_var}
        :param gravity_var: Specifies where to place the ``image`` relative to the source image. The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param preserve_minor_dimension: Whether to preserve the source image's minor dimension, ``false`` by default. The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension DataAkamaiImagingPolicyImage#preserve_minor_dimension}
        :param preserve_minor_dimension_var: Whether to preserve the source image's minor dimension, ``false`` by default. The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension_var DataAkamaiImagingPolicyImage#preserve_minor_dimension_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeAppendImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__17487d4b1ae5f849d235c865bd9034aff0d8607d04ec668876584cf7cd660328)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_priority", value=gravity_priority, expected_type=type_hints["gravity_priority"])
            check_type(argname="argument gravity_priority_var", value=gravity_priority_var, expected_type=type_hints["gravity_priority_var"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument preserve_minor_dimension", value=preserve_minor_dimension, expected_type=type_hints["preserve_minor_dimension"])
            check_type(argname="argument preserve_minor_dimension_var", value=preserve_minor_dimension_var, expected_type=type_hints["preserve_minor_dimension_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_priority is not None:
            self._values["gravity_priority"] = gravity_priority
        if gravity_priority_var is not None:
            self._values["gravity_priority_var"] = gravity_priority_var
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if preserve_minor_dimension is not None:
            self._values["preserve_minor_dimension"] = preserve_minor_dimension
        if preserve_minor_dimension_var is not None:
            self._values["preserve_minor_dimension_var"] = preserve_minor_dimension_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeAppendImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeAppendImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Specifies where to place the ``image`` relative to the source image.

        The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_priority(self) -> typing.Optional[builtins.str]:
        '''Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal.

        The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority DataAkamaiImagingPolicyImage#gravity_priority}
        '''
        result = self._values.get("gravity_priority")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_priority_var(self) -> typing.Optional[builtins.str]:
        '''Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal.

        The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority_var DataAkamaiImagingPolicyImage#gravity_priority_var}
        '''
        result = self._values.get("gravity_priority_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Specifies where to place the ``image`` relative to the source image.

        The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def preserve_minor_dimension(self) -> typing.Optional[builtins.str]:
        '''Whether to preserve the source image's minor dimension, ``false`` by default.

        The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension DataAkamaiImagingPolicyImage#preserve_minor_dimension}
        '''
        result = self._values.get("preserve_minor_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def preserve_minor_dimension_var(self) -> typing.Optional[builtins.str]:
        '''Whether to preserve the source image's minor dimension, ``false`` by default.

        The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension_var DataAkamaiImagingPolicyImage#preserve_minor_dimension_var}
        '''
        result = self._values.get("preserve_minor_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeAppend(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeAppendImage",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeAppendImage:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeAppendImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeAppendImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeAppendImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac12b782d9351e328851263907cfd4282dbc6ed8800365ad5b7b694fe1838cb7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeAppendImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeAppendImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeAppendImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__69c8446e64f1ccb66dd9d723de9856eedbbb0610f679ebae7700e0b6b0d2d167)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeAppendList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeAppendList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a8de52dc1add7c502ab8289e766b00dc20794efb5ad2bb6059737c6358426a79)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeAppendOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ac6e405b15763a582274240ff1a119713e14108c8346ab58fec4c1f1176c029)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeAppendOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ead7b544e4c0d2489deebb8e16ce53f223502e841ccbc6ecb927dcf56545967b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__37d565ec20af953f5ccce09091f5c7a86bef314f7a52795da226cc222bde1a6f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__517ade0c23c39858b8abe09ea3483b7ba5651983fd1d58e18e06b92978a473d3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeAppend]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeAppend]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeAppend]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__49f6134ad8780130f08919e85ded5da9cd2b00af39dbf21d3e8986912ba848a3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeAppendOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeAppendOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eda6c03805f853bfaa4fc35dbd4bea5427561e34ff3b904b0ed87d03258e7908)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeAppendImage()

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityPriority")
    def reset_gravity_priority(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityPriority", []))

    @jsii.member(jsii_name="resetGravityPriorityVar")
    def reset_gravity_priority_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityPriorityVar", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPreserveMinorDimension")
    def reset_preserve_minor_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPreserveMinorDimension", []))

    @jsii.member(jsii_name="resetPreserveMinorDimensionVar")
    def reset_preserve_minor_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPreserveMinorDimensionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeAppendImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeAppendImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityInput")
    def gravity_priority_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityPriorityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityVarInput")
    def gravity_priority_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityPriorityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeAppendImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeAppendImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionInput")
    def preserve_minor_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "preserveMinorDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionVarInput")
    def preserve_minor_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "preserveMinorDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__12f1ec347fb79fc29cdbd7ed021d20dc838cea9d36cd8a4a40d014755220f3ec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityPriority")
    def gravity_priority(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityPriority"))

    @gravity_priority.setter
    def gravity_priority(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d1e78ea0554366c54a1ad237e0bf5143c6d79fa137ccd704ba67bab438e1fb09)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityPriority", value)

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityVar")
    def gravity_priority_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityPriorityVar"))

    @gravity_priority_var.setter
    def gravity_priority_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__59485cf2dee4465dc031b226c44f357a550eba958dad2246176e01c7fe31ef27)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityPriorityVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__989c01cd88db379007a0d9a36acf5552f1db529c23f3a6ba9b426638c6875e47)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimension")
    def preserve_minor_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "preserveMinorDimension"))

    @preserve_minor_dimension.setter
    def preserve_minor_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1e42638ef7382fc80c54f2422fad5922d1ed57822b9848e93c0cc793bc86c03d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "preserveMinorDimension", value)

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionVar")
    def preserve_minor_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "preserveMinorDimensionVar"))

    @preserve_minor_dimension_var.setter
    def preserve_minor_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c80d66a7ff5af34f2146fcd4558b99f8dc519890176cf1179d47cee06848c2bb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "preserveMinorDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeAppend]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeAppend]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeAppend]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f03c4b416b93368b1c8bcbff4b0beddfefc04befbdb8d1b6d1e9eaf0a2d86a43)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeAspectCrop",
    jsii_struct_bases=[],
    name_mapping={
        "allow_expansion": "allowExpansion",
        "allow_expansion_var": "allowExpansionVar",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeAspectCrop:
    def __init__(
        self,
        *,
        allow_expansion: typing.Optional[builtins.str] = None,
        allow_expansion_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_expansion: Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image. Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        :param allow_expansion_var: Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image. Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        :param height: The height term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The width term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        :param x_position: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9791d2e34f00e09143d9a6f76fdafcde651299816fdb00d0baf4afbaa8d6b235)
            check_type(argname="argument allow_expansion", value=allow_expansion, expected_type=type_hints["allow_expansion"])
            check_type(argname="argument allow_expansion_var", value=allow_expansion_var, expected_type=type_hints["allow_expansion_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if allow_expansion is not None:
            self._values["allow_expansion"] = allow_expansion
        if allow_expansion_var is not None:
            self._values["allow_expansion_var"] = allow_expansion_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def allow_expansion(self) -> typing.Optional[builtins.str]:
        '''Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image.

        Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        '''
        result = self._values.get("allow_expansion")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def allow_expansion_var(self) -> typing.Optional[builtins.str]:
        '''Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image.

        Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        '''
        result = self._values.get("allow_expansion_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeAspectCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeAspectCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeAspectCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a3023a9b311aed8f85aad8d22f61006f6a74cd2bb0e1f2da604ca5327146d8c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeAspectCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1557ce50cbcbbbf48b08c61dfdb81ed9581a512f3be7e3b57454d7d95bcabd80)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeAspectCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a65369d8eee766b79e6c5f790c0d587c2290c6a26b8df1be8b6f2b3ae897487c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e5726bd4e48076e9ddf3975d2ee3839fa8ffa15e9abdd81e93f002c5abb64663)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__737f73c4e1fe45d73ae5dfbe930b8dc863d6151e0547f4c38fe2655aec5a71ea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeAspectCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeAspectCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeAspectCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dd21f5c8055cd9e7a38119098a2ca2b4c3266217fe5e7dc6f64022645519e470)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeAspectCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeAspectCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cee69e4db02b2a8fe1cb0484a62dcb10433b62f38d6a937bde12fc904ce4cfec)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAllowExpansion")
    def reset_allow_expansion(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansion", []))

    @jsii.member(jsii_name="resetAllowExpansionVar")
    def reset_allow_expansion_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansionVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionInput")
    def allow_expansion_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVarInput")
    def allow_expansion_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansion")
    def allow_expansion(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansion"))

    @allow_expansion.setter
    def allow_expansion(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__639dc177f95da7c1d7118f1e943925eb163fc8a51f916bfdc497c90c3aadefb9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansion", value)

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVar")
    def allow_expansion_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansionVar"))

    @allow_expansion_var.setter
    def allow_expansion_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__efd902a1dd2a1c1974c77eb618f081935f548a526eb60c6522c5218b66569ebb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansionVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e633477095fdb08d0107909cb2c27ab3d83ff52f274433e77ba90385449560de)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f7d8b19baf5fbfcc5cdebd75d34799a6d6afd5773f7505f69aeef84d525a40e5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d698224cdfa0c1496e8dafd27e0c627e262631ff082f757fccfb0babb39bb6f2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__20e4a1bbb05c5a3bc6f572646a2c832cc0e04f204dede2c3f046df5d7e0adf21)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3261d4d3b14f8c2cf0435b97237b06b72daddcee4b5abb7c1ad05e8b5a6f2f79)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c725ffe9864e5e27847b6551d5abb2112c864b7dffdfd4a850cbca915c6f6694)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__afd070706b28de687c7566138733f1a08b093007b5ee98f252ee107371acc9e3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d73b976da79a70332f3861818b1be0428eae90ba083cc7b55f298fef09218657)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeAspectCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeAspectCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeAspectCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__49bc9258d4c48759990c62c6820b3627b2e1aef42680ea47559fc14047d96fa0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeBackgroundColor",
    jsii_struct_bases=[],
    name_mapping={"color": "color", "color_var": "colorVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeBackgroundColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8790fc31fb899658b3f3782429987edf6602cc46d5648b92c26882ecbcdcb41f)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeBackgroundColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeBackgroundColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeBackgroundColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__beb14f018ec9735b67c5d633ff1dd28efd493cb93c28eb57bdec20eed88ce9ac)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeBackgroundColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df2ee7f5d13085cb36b2c89d83c8fbc8988f49f29d8fb1957641f4c37dc8925c)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeBackgroundColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3f33cad1d0c65b0db21c95a354cd385ea5f0a04be257b5348fa04e5288014051)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dcd7370157de255ceffab0190b03ee9bfd38980c1856f842bceec88c689aa839)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8d786d6ad0c4e723a40a2deb040d8fad3434a5825f2a7f70be0ca13f1ca8702a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeBackgroundColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeBackgroundColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__00e0a924761c155d2ad82125144673e2afaa950a2ef222e21dbfa26982d63eab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeBackgroundColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeBackgroundColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ec50e39fb0318386c1bc8d6f928240800912f02eb78e60b69127c9934b66aed)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dade1b19e2c5bbf9c5b2f7830d8ccc1a86ad6fd79a3978346c4a5c2a8c3aa4eb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__36f8f006348760442bcb39e450eae84c3534a6eedbafa69eec347d7fc6b97c24)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeBackgroundColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeBackgroundColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeBackgroundColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b29a97d093bfe9ab90fcb7571448511fe1cfc004b2c9ece335460fb25130feb8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeBlur",
    jsii_struct_bases=[],
    name_mapping={"sigma": "sigma", "sigma_var": "sigmaVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeBlur:
    def __init__(
        self,
        *,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param sigma: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__328b52136053af9e57d81477754cec6e94a95b65050ea0b943f824f2c5a86c44)
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeBlur(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeBlurList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeBlurList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7920bfa1734a38067d8a78079112d3473b506fd3b372d2305b7df6eb3013d046)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeBlurOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ff0aeff4e43adaee3f2921f16bb40deca4a2758ea8dcf6c08e89f628c4713826)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeBlurOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9cdd28f0f89bf56c74ddc9bdf4d873bae1548e016c950775383a55b3bd226a4c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b725666a26bae24635cf939433b229acc1ff1f1529b3bde53c7bcc1a56834922)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__643f5fd3b15047bd103f175517bee46c5c7a2574ea2b4dac26bd5db6b28c4cea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeBlur]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeBlur]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b487258cd5c195dfe5ebf4c2b3e33edbcb46f3c85b6520e38ec2632ae57630d6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeBlurOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeBlurOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__373b36ab632d8afbfcffbdfd1dc350603e0a47a1d29e4929e8cc47fe3a73b9f8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__24f10ef789bca1aa23d59fe038ef14b75a9f187542d42c4e6927837d0c09d8a2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9f4106c91a1903365bbab3d7bd5ab80ff0be0835534de7e7e7f40397c6805744)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeBlur]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeBlur]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeBlur]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__634b627e6530e7b88334f2349c557ac5ab2aa2475c2733f7a67baa3d221b1a04)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeChromaKey",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_feather": "hueFeather",
        "hue_feather_var": "hueFeatherVar",
        "hue_tolerance": "hueTolerance",
        "hue_tolerance_var": "hueToleranceVar",
        "hue_var": "hueVar",
        "lightness_feather": "lightnessFeather",
        "lightness_feather_var": "lightnessFeatherVar",
        "lightness_tolerance": "lightnessTolerance",
        "lightness_tolerance_var": "lightnessToleranceVar",
        "saturation_feather": "saturationFeather",
        "saturation_feather_var": "saturationFeatherVar",
        "saturation_tolerance": "saturationTolerance",
        "saturation_tolerance_var": "saturationToleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeChromaKey:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_feather: typing.Optional[builtins.str] = None,
        hue_feather_var: typing.Optional[builtins.str] = None,
        hue_tolerance: typing.Optional[builtins.str] = None,
        hue_tolerance_var: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness_feather: typing.Optional[builtins.str] = None,
        lightness_feather_var: typing.Optional[builtins.str] = None,
        lightness_tolerance: typing.Optional[builtins.str] = None,
        lightness_tolerance_var: typing.Optional[builtins.str] = None,
        saturation_feather: typing.Optional[builtins.str] = None,
        saturation_feather_var: typing.Optional[builtins.str] = None,
        saturation_tolerance: typing.Optional[builtins.str] = None,
        saturation_tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_feather: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        :param hue_feather_var: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        :param hue_tolerance: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        :param hue_tolerance_var: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        :param hue_var: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness_feather: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        :param lightness_feather_var: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        :param lightness_tolerance: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        :param lightness_tolerance_var: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        :param saturation_feather: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        :param saturation_feather_var: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        :param saturation_tolerance: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        :param saturation_tolerance_var: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4536934f42bda2237e6e7ea5c4226da5abad9c20a9565003c34906854e93888c)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_feather", value=hue_feather, expected_type=type_hints["hue_feather"])
            check_type(argname="argument hue_feather_var", value=hue_feather_var, expected_type=type_hints["hue_feather_var"])
            check_type(argname="argument hue_tolerance", value=hue_tolerance, expected_type=type_hints["hue_tolerance"])
            check_type(argname="argument hue_tolerance_var", value=hue_tolerance_var, expected_type=type_hints["hue_tolerance_var"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness_feather", value=lightness_feather, expected_type=type_hints["lightness_feather"])
            check_type(argname="argument lightness_feather_var", value=lightness_feather_var, expected_type=type_hints["lightness_feather_var"])
            check_type(argname="argument lightness_tolerance", value=lightness_tolerance, expected_type=type_hints["lightness_tolerance"])
            check_type(argname="argument lightness_tolerance_var", value=lightness_tolerance_var, expected_type=type_hints["lightness_tolerance_var"])
            check_type(argname="argument saturation_feather", value=saturation_feather, expected_type=type_hints["saturation_feather"])
            check_type(argname="argument saturation_feather_var", value=saturation_feather_var, expected_type=type_hints["saturation_feather_var"])
            check_type(argname="argument saturation_tolerance", value=saturation_tolerance, expected_type=type_hints["saturation_tolerance"])
            check_type(argname="argument saturation_tolerance_var", value=saturation_tolerance_var, expected_type=type_hints["saturation_tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_feather is not None:
            self._values["hue_feather"] = hue_feather
        if hue_feather_var is not None:
            self._values["hue_feather_var"] = hue_feather_var
        if hue_tolerance is not None:
            self._values["hue_tolerance"] = hue_tolerance
        if hue_tolerance_var is not None:
            self._values["hue_tolerance_var"] = hue_tolerance_var
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness_feather is not None:
            self._values["lightness_feather"] = lightness_feather
        if lightness_feather_var is not None:
            self._values["lightness_feather_var"] = lightness_feather_var
        if lightness_tolerance is not None:
            self._values["lightness_tolerance"] = lightness_tolerance
        if lightness_tolerance_var is not None:
            self._values["lightness_tolerance_var"] = lightness_tolerance_var
        if saturation_feather is not None:
            self._values["saturation_feather"] = saturation_feather
        if saturation_feather_var is not None:
            self._values["saturation_feather_var"] = saturation_feather_var
        if saturation_tolerance is not None:
            self._values["saturation_tolerance"] = saturation_tolerance
        if saturation_tolerance_var is not None:
            self._values["saturation_tolerance_var"] = saturation_tolerance_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        '''
        result = self._values.get("hue_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        '''
        result = self._values.get("hue_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        '''
        result = self._values.get("hue_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        '''
        result = self._values.get("hue_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        '''
        result = self._values.get("lightness_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        '''
        result = self._values.get("lightness_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        '''
        result = self._values.get("lightness_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        '''
        result = self._values.get("lightness_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        '''
        result = self._values.get("saturation_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        '''
        result = self._values.get("saturation_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        '''
        result = self._values.get("saturation_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        result = self._values.get("saturation_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeChromaKey(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeChromaKeyList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeChromaKeyList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2f3fe073c776e86648b79631cf8e53a739acb837d0ff3178c2321df96179b185)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeChromaKeyOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0565263880080f6a2b6ae66bd64ad963cac50da182a26db3b5f47f8dcbdaa8f4)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeChromaKeyOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2599de37f5d0597539e4cc0c458a70b2bc2750d22e2c30592bea7527664e6eb1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__56aa35a4ddc5384181c9442d43c0ff7f5a0b30858227d79135b5ec52d726896a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__709e0d010e9e474a4c6f1ed64629d14dcd468e9e2a7c03ab2c9bc37f213dfb0b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeChromaKey]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeChromaKey]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e4b6d0f02efa327443201d49d1b9a3cfca065857375135540b16d68ea5725e7a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeChromaKeyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeChromaKeyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5641f5e6ad9f8b50b0cc7622e5f598212adaebdb7abf0f98d5a736aa81a2fe00)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueFeather")
    def reset_hue_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeather", []))

    @jsii.member(jsii_name="resetHueFeatherVar")
    def reset_hue_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeatherVar", []))

    @jsii.member(jsii_name="resetHueTolerance")
    def reset_hue_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueTolerance", []))

    @jsii.member(jsii_name="resetHueToleranceVar")
    def reset_hue_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueToleranceVar", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightnessFeather")
    def reset_lightness_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeather", []))

    @jsii.member(jsii_name="resetLightnessFeatherVar")
    def reset_lightness_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeatherVar", []))

    @jsii.member(jsii_name="resetLightnessTolerance")
    def reset_lightness_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessTolerance", []))

    @jsii.member(jsii_name="resetLightnessToleranceVar")
    def reset_lightness_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessToleranceVar", []))

    @jsii.member(jsii_name="resetSaturationFeather")
    def reset_saturation_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeather", []))

    @jsii.member(jsii_name="resetSaturationFeatherVar")
    def reset_saturation_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeatherVar", []))

    @jsii.member(jsii_name="resetSaturationTolerance")
    def reset_saturation_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationTolerance", []))

    @jsii.member(jsii_name="resetSaturationToleranceVar")
    def reset_saturation_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherInput")
    def hue_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVarInput")
    def hue_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceInput")
    def hue_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVarInput")
    def hue_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherInput")
    def lightness_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVarInput")
    def lightness_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceInput")
    def lightness_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVarInput")
    def lightness_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherInput")
    def saturation_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVarInput")
    def saturation_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceInput")
    def saturation_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVarInput")
    def saturation_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1694afa3d60352e7ca06f5989728261637d961470d507fa996b0bac46659ffcd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeather")
    def hue_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeather"))

    @hue_feather.setter
    def hue_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__84171b45dfc7944c08ce1a68c546e4fd984c67b0b35910d96f05d236e3fb1589)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeather", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVar")
    def hue_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeatherVar"))

    @hue_feather_var.setter
    def hue_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7459b607a1119561fa9301f5f7a1ad5140573f216ff38aad928f510c86931747)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueTolerance")
    def hue_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueTolerance"))

    @hue_tolerance.setter
    def hue_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__16455fb4c6ca345613fb045a57af9f710c303a7e0bd10fa9dc10923946bbf6a2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVar")
    def hue_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueToleranceVar"))

    @hue_tolerance_var.setter
    def hue_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bf59cd8e181f710f5c3f89f5f183ba8b5e6c0b221490fd78209f24f78a79335a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a5d44936a9b1aac9252178e9b5a8615d2209b3b9ebd89873a97989c18b423d1f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeather")
    def lightness_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeather"))

    @lightness_feather.setter
    def lightness_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__28270a2a38dd7a3a363e80233ce8ec53aa4038f4291d1fd3cd903e8878b2b940)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeather", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVar")
    def lightness_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeatherVar"))

    @lightness_feather_var.setter
    def lightness_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__30e48f48ab700b75b87a6a35dee498da7a73c22d37ece0b0f93014cd5fca4d11)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessTolerance")
    def lightness_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessTolerance"))

    @lightness_tolerance.setter
    def lightness_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e354a71c99a6114e3b3b076f2865c136a06ae7f98f1b9aeae6a3ddd98894ef0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVar")
    def lightness_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessToleranceVar"))

    @lightness_tolerance_var.setter
    def lightness_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6b084aef4c92e553a53b55644ae0b299a5588260f68efa4305daafc5d352cb48)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeather")
    def saturation_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeather"))

    @saturation_feather.setter
    def saturation_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1804437f35c99f87b243383942ca404a75d148b2ee85f8f894f4a23f9c123ef9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeather", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVar")
    def saturation_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeatherVar"))

    @saturation_feather_var.setter
    def saturation_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1621cdc979c24ae4e80a35bb2f18e28c164272c059a97901e8a44fe79a53da01)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationTolerance")
    def saturation_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationTolerance"))

    @saturation_tolerance.setter
    def saturation_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__48aa5d27796c72860bfcf60479d07baa3a24d1ba73302355a6b4c1c9b06396fd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVar")
    def saturation_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationToleranceVar"))

    @saturation_tolerance_var.setter
    def saturation_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a75e2b1560a92f39984da0c9bfd50ad6968fd050c2ec867b08e8b54b5d6dafc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeChromaKey]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeChromaKey]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeChromaKey]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7a9cf3e3f97c8792bcc0efd9c30df362dfb59315f133cdaf54331bc4ee58c9d6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeComposite",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "placement": "placement",
        "placement_var": "placementVar",
        "scale": "scale",
        "scale_dimension": "scaleDimension",
        "scale_dimension_var": "scaleDimensionVar",
        "scale_var": "scaleVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeComposite:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCompositeImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        placement: typing.Optional[builtins.str] = None,
        placement_var: typing.Optional[builtins.str] = None,
        scale: typing.Optional[builtins.str] = None,
        scale_dimension: typing.Optional[builtins.str] = None,
        scale_dimension_var: typing.Optional[builtins.str] = None,
        scale_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param placement: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        :param placement_var: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        :param scale: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param scale_dimension: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        :param scale_dimension_var: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        :param scale_var: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        :param x_position: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCompositeImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__01e0ce41557d5dac481af55ab16d59742153e6581f46e587caaf2af5b0e332e8)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument placement", value=placement, expected_type=type_hints["placement"])
            check_type(argname="argument placement_var", value=placement_var, expected_type=type_hints["placement_var"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument scale_dimension", value=scale_dimension, expected_type=type_hints["scale_dimension"])
            check_type(argname="argument scale_dimension_var", value=scale_dimension_var, expected_type=type_hints["scale_dimension_var"])
            check_type(argname="argument scale_var", value=scale_var, expected_type=type_hints["scale_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if placement is not None:
            self._values["placement"] = placement
        if placement_var is not None:
            self._values["placement_var"] = placement_var
        if scale is not None:
            self._values["scale"] = scale
        if scale_dimension is not None:
            self._values["scale_dimension"] = scale_dimension
        if scale_dimension_var is not None:
            self._values["scale_dimension_var"] = scale_dimension_var
        if scale_var is not None:
            self._values["scale_var"] = scale_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCompositeImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCompositeImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        '''
        result = self._values.get("placement")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement_var(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        '''
        result = self._values.get("placement_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        '''
        result = self._values.get("scale_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        '''
        result = self._values.get("scale_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        '''
        result = self._values.get("scale_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeComposite(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCompositeImage",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCompositeImage:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCompositeImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCompositeImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCompositeImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d5321d47684257dc8017b1b8e780d098432a3480abada2a885e0c9349608535c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCompositeImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCompositeImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d1376034f52e76e495097e42286ad58bb4c3082a91a715bce12a3e6190703989)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCompositeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCompositeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5383c707ee0d54463986e9550ac46fef0f73dafaccf61bd50a98f58bdefc71dd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCompositeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__64ba72df3dd89a2fd6722460080cf625cfc14f1c664993d3b63e2e7fdf54ed1f)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCompositeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__db0a171f527ffa2107dbdaed2880875a812c9127ffa313a675e5b512c0080825)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7c1328cfccfd4116bed357cd63184234724ddb1646a97f8f8cd1d9b8752f77ee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__49dbd561a8fe51a553e3267128cec1efc742d9e05cf35b60edd8de3132cd8978)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeComposite]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeComposite]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ff7fd94b4f8f9480dd38b693541da3f82893e9405bb20c306c35f3d02d6753fa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCompositeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCompositeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__761e3d3f12966638d6112e57da806471cbd58e575cba224b44e0994a2cfd7deb)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCompositeImage()

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPlacement")
    def reset_placement(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacement", []))

    @jsii.member(jsii_name="resetPlacementVar")
    def reset_placement_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacementVar", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetScaleDimension")
    def reset_scale_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimension", []))

    @jsii.member(jsii_name="resetScaleDimensionVar")
    def reset_scale_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimensionVar", []))

    @jsii.member(jsii_name="resetScaleVar")
    def reset_scale_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCompositeImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCompositeImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCompositeImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="placementInput")
    def placement_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementInput"))

    @builtins.property
    @jsii.member(jsii_name="placementVarInput")
    def placement_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionInput")
    def scale_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVarInput")
    def scale_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleVarInput")
    def scale_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__21f4b543e836fcc367ec961dfe9b990af439b008917b0c387e639d88dac12d78)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4fd2e285d30593d178172a7d099dbb432545bf9ac8e89d7e790d9c52cd3e45ef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="placement")
    def placement(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placement"))

    @placement.setter
    def placement(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__080f19ca0e24817d2d3a5df6f71afc86335a9156a4ccfbb46c6944ab0f958b7b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placement", value)

    @builtins.property
    @jsii.member(jsii_name="placementVar")
    def placement_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placementVar"))

    @placement_var.setter
    def placement_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a263538ce45accd960dc60501693831df548c21ac50fe08bdb9f84d81da98683)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placementVar", value)

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scale"))

    @scale.setter
    def scale(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d19265e5d0828104afb736b36cab2a513cf39e2f511c8cb1b53cddfca748c646)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scale", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimension")
    def scale_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimension"))

    @scale_dimension.setter
    def scale_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0bca2a81f5d5eefd1c3f7f4c415d4b5b31cbb5b45fe841d9ba5947c4ce2f99f1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimension", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVar")
    def scale_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimensionVar"))

    @scale_dimension_var.setter
    def scale_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4325829327d824f205ef146b119a6bd9e72307e8f0854011ef26e1dcf0b6b96a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="scaleVar")
    def scale_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleVar"))

    @scale_var.setter
    def scale_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__41713d2d3e1ae901ea0f4e6d6ce1fa3cef8613b164aa1a708df52199eb6e2a58)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7e336a53d00cb588027203ebf03d4de0b6d77d97db6d9c994468f7470bce9525)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d7b4e5d07abb33858da4a2eece54ce24d4c114f0408a5ad11025f9ecf949e00a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ff3f85752f7223918320ebb867870b8cdce81b96850dbc9f9cb5a742b4dc6a8d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4636563da2fa42dea9210862811f8e5e62ed80c508120fc2289d82bb3def2775)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeComposite]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeComposite]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeComposite]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bd8683af466bda8edeb92e097768a4c93c1ab8c8a40b869a37b91042436ae761)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCompound",
    jsii_struct_bases=[],
    name_mapping={"transformations": "transformations"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCompound:
    def __init__(
        self,
        *,
        transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param transformations: transformations block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__00cab12103a95c8648e77628c2f82d8b54bafec19a0943e2a5875d47595a0c4c)
            check_type(argname="argument transformations", value=transformations, expected_type=type_hints["transformations"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if transformations is not None:
            self._values["transformations"] = transformations

    @builtins.property
    def transformations(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCompoundTransformations"]]]:
        '''transformations block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        result = self._values.get("transformations")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCompoundTransformations"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCompound(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCompoundList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCompoundList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ada3ec8662097137e9fa35d4d8ebddeaed89d5f3699240d10177d0988fd84e8d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCompoundOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__86b7a5f16c039958463036dc6ba9893dfff4114b84c44671980e9f88c705fa09)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCompoundOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d68d512ce03b1878b15065e392b3815d87349c92a5c0502f87a6a0184fe5d16b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c3da986b2aa48c2e9281f46b776bd8af88fe077b7285669997692d9aa9594b9f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6b6c97e6060366872dd3d375020b8d832ed9f643a8e30951af5db6b955e664b3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCompound]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCompound]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__677ed27463be649c86f0c3a1a0bca7c0ada6b01b4108cef9f797e57d21cc4537)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCompoundOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCompoundOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0eabf5b2ba47b9771a97d75191d801a4672273895e52af79499147a68b7c025b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformations")
    def put_transformations(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4383b7708e2cd460cf9cf837e86867b8254a365c913cd44d373b3bb5fb8ac775)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTransformations", [value]))

    @jsii.member(jsii_name="resetTransformations")
    def reset_transformations(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformations", []))

    @builtins.property
    @jsii.member(jsii_name="transformations")
    def transformations(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCompoundTransformationsList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCompoundTransformationsList", jsii.get(self, "transformations"))

    @builtins.property
    @jsii.member(jsii_name="transformationsInput")
    def transformations_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCompoundTransformations"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCompoundTransformations"]]], jsii.get(self, "transformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCompound]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCompound]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCompound]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c721b394c64dfb1a651fd2c582c4838a4f4de3f796f3e3b22f0fc278e34225d7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCompoundTransformations",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCompoundTransformations:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCompoundTransformations(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCompoundTransformationsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCompoundTransformationsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d36cbf9d122423c40fbad337f4567958431ee5c3ce6840f97f95f66b9b8c497b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCompoundTransformationsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc13759f6c5ddf6e0cd21fb5e5ef609e82ff2bcd238da29ee0aabd0dfb54d60c)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCompoundTransformationsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6330dfeb6b8d5ce57713611b8972ab50ad2a5267b57b8826f577c4e7f051a245)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__547beca1f96d84b2ffe2fc0e58bf7532d88dbc2f26bed2bb696c77e939fb4833)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__19f54ff35fb7d7998c5d8fa97feb1b503fd4f844b81d9b843c8ed977d94b9de3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCompoundTransformations]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCompoundTransformations]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCompoundTransformations]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d7e5eddb9ae29ae5fda7ab1e291af9df3a0049334d8f05a557c4b69e6dd3564)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCompoundTransformationsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCompoundTransformationsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e1ba2a0a03c3ae36916cefd988a9e05b7e2fb3d968910f35d71d97f0757b671e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCompoundTransformations]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCompoundTransformations]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCompoundTransformations]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aec23a6c12f4d9d43737cee109751cd73eb450766b4621ed702ec96d6444edb9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeContrast",
    jsii_struct_bases=[],
    name_mapping={
        "brightness": "brightness",
        "brightness_var": "brightnessVar",
        "contrast": "contrast",
        "contrast_var": "contrastVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeContrast:
    def __init__(
        self,
        *,
        brightness: typing.Optional[builtins.str] = None,
        brightness_var: typing.Optional[builtins.str] = None,
        contrast: typing.Optional[builtins.str] = None,
        contrast_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param brightness: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        :param brightness_var: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        :param contrast: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param contrast_var: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dfdd896997c2f1280b1a2b77dde5000b5b75a0d287c1421b140615e9d4b680bb)
            check_type(argname="argument brightness", value=brightness, expected_type=type_hints["brightness"])
            check_type(argname="argument brightness_var", value=brightness_var, expected_type=type_hints["brightness_var"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument contrast_var", value=contrast_var, expected_type=type_hints["contrast_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if brightness is not None:
            self._values["brightness"] = brightness
        if brightness_var is not None:
            self._values["brightness_var"] = brightness_var
        if contrast is not None:
            self._values["contrast"] = contrast
        if contrast_var is not None:
            self._values["contrast_var"] = contrast_var

    @builtins.property
    def brightness(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        '''
        result = self._values.get("brightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def brightness_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        '''
        result = self._values.get("brightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        result = self._values.get("contrast_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeContrast(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeContrastList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeContrastList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7ec04de4c29ee153c4c486daf10636e9ba9e1684aa426253a3fdcf16e013c30a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeContrastOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__514e58c24f7b4e67c4a5f8314199d26d26e7db83c1a12cba49ec6eb7a386b0f7)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeContrastOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__08338394c39405c2f3cd5ae44454c0f67ed03b9e2e5380ec604954cef598bdcc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e462b734fd79603dd0da6cbb25f4f0dece25a6e23069bc25877e1e476573997e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__18a334594f7bb9b6c8b5be0cb55094539e3dda0ee1afa6a6240013cdf6758730)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeContrast]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeContrast]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__304029732589d0f02e9fe4a080f88a7116703ea9ecadcaa4c543858327718c59)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeContrastOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeContrastOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__65ce7c19d5cb5e61a817f2432354aca3d706dc1f0831d69aa05ec4c7b5cff0b9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetBrightness")
    def reset_brightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightness", []))

    @jsii.member(jsii_name="resetBrightnessVar")
    def reset_brightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightnessVar", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetContrastVar")
    def reset_contrast_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrastVar", []))

    @builtins.property
    @jsii.member(jsii_name="brightnessInput")
    def brightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="brightnessVarInput")
    def brightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastVarInput")
    def contrast_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="brightness")
    def brightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightness"))

    @brightness.setter
    def brightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1cadf328d277975cc4b339b2db58024922b40e1f6f6d6c6bb335639e075e15d4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightness", value)

    @builtins.property
    @jsii.member(jsii_name="brightnessVar")
    def brightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightnessVar"))

    @brightness_var.setter
    def brightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__88c0fa802ae30dfdde252333623274b69e04978c4fff8a7927df6fc8179ba357)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrast"))

    @contrast.setter
    def contrast(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__202627c1fd9861e0d58af2ae1db444100041fc8c33ce9a1e1204ec2cb3d92012)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrast", value)

    @builtins.property
    @jsii.member(jsii_name="contrastVar")
    def contrast_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrastVar"))

    @contrast_var.setter
    def contrast_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__48bbe58671ca2d01d57bf034a94b9ba6c953de6d200d6682170df6b39df15ed4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrastVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeContrast]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeContrast]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeContrast]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__234bb003f94e13b54d73af6e84b0455d21477ca6efbd6699b72fea2b803b4507)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCrop",
    jsii_struct_bases=[],
    name_mapping={
        "allow_expansion": "allowExpansion",
        "allow_expansion_var": "allowExpansionVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCrop:
    def __init__(
        self,
        *,
        allow_expansion: typing.Optional[builtins.str] = None,
        allow_expansion_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_expansion: If cropping an area outside of the existing canvas, expands the image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        :param allow_expansion_var: If cropping an area outside of the existing canvas, expands the image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        :param gravity: Frame of reference for X and Y Positions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Frame of reference for X and Y Positions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The number of pixels to crop along the y-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The number of pixels to crop along the y-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The number of pixels to crop along the x-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The number of pixels to crop along the x-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        :param x_position: The x-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c7d71929948367499a5a5d7c9773962b860490cedaf9ce071e19ebd5d00dbca9)
            check_type(argname="argument allow_expansion", value=allow_expansion, expected_type=type_hints["allow_expansion"])
            check_type(argname="argument allow_expansion_var", value=allow_expansion_var, expected_type=type_hints["allow_expansion_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if allow_expansion is not None:
            self._values["allow_expansion"] = allow_expansion
        if allow_expansion_var is not None:
            self._values["allow_expansion_var"] = allow_expansion_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def allow_expansion(self) -> typing.Optional[builtins.str]:
        '''If cropping an area outside of the existing canvas, expands the image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        '''
        result = self._values.get("allow_expansion")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def allow_expansion_var(self) -> typing.Optional[builtins.str]:
        '''If cropping an area outside of the existing canvas, expands the image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        '''
        result = self._values.get("allow_expansion_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Frame of reference for X and Y Positions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Frame of reference for X and Y Positions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the y-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the y-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the x-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the x-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3f11efbb44d26b1d104929350a7389d748920110e4bb50e0c57b0051670e353b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1a2aec5d7d6d807902ff69e3e2f283ac57908eec3ebfebd467bb28b8ce6bf03c)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a80912d34539defbcae86c67cd0ee31ce92e979ed6797c87c45133eb5cd8cc9f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d1497c01e4552e096cbd1cc10c141fdac20eea2a34326e73afafa8e226a8ee3d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__900f1a7e3a4d9463765af2c676a485f35ce4303fe54edb2ba189d8cefd1ee997)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8bb7316b2e9255f22a507478234ba71afe0f947ce05deb7b9bb97e179ae1441c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ac19ad16a34fbf1e4f202174fcb5eb9122a2dda385f8092f09d127c3ebab935)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAllowExpansion")
    def reset_allow_expansion(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansion", []))

    @jsii.member(jsii_name="resetAllowExpansionVar")
    def reset_allow_expansion_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansionVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionInput")
    def allow_expansion_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVarInput")
    def allow_expansion_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansion")
    def allow_expansion(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansion"))

    @allow_expansion.setter
    def allow_expansion(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fc0e7a9f778430edc9b5f27075855ba1ca908f32448cd952bbb5291bded66105)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansion", value)

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVar")
    def allow_expansion_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansionVar"))

    @allow_expansion_var.setter
    def allow_expansion_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bafa69bda6d2246f51616332b3ce8e673eba75528197e298bfc9ffb5fa6f1b21)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansionVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7306e21c0f8bb5e37f7e3df465f297d3ca15c94586e5585f4359e06f263fe251)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9f40ccab7910d9975e4d324055ae4db958ace7f20168b63a87ec563ff4edff32)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ce11c640dd30e0e94f93b146fad2f00d2c344ec35959615ec3459a856640b7a2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__657362163ca72242c56493334b045df4fae5ba898f0edf84c90d003bcefcb98e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bdf7b84888f7cb4877a92fc8ace9883a038f0cd991e5f1cd0cb90c89c420bdf4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__91d8eeb0e499c894e89641399282c83e916fef3dead304d3b8dfad74b12f63c9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a6793383914930684376f748eff6cfaab0b916131b7b84ef521ecb15de3e8c9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9b5c1689181943c4d58b484bcb480b5c18cb1216602f9c3e4755279f24d1f16c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0bf5552e19644069d01749cd23dda78f1ec1e08956b7c41104e89a9030cbc064)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6677759ea2d47d62aa2dd21607dde6eeed05df1631f4aa1baf174d2ca8753c31)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d0e5d889d4918f655cd6a6c81f3ac650f04da2961f3202122a02b3d217ed2caf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeFaceCrop",
    jsii_struct_bases=[],
    name_mapping={
        "algorithm": "algorithm",
        "algorithm_var": "algorithmVar",
        "confidence": "confidence",
        "confidence_var": "confidenceVar",
        "fail_gravity": "failGravity",
        "fail_gravity_var": "failGravityVar",
        "focus": "focus",
        "focus_var": "focusVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "padding": "padding",
        "padding_var": "paddingVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeFaceCrop:
    def __init__(
        self,
        *,
        algorithm: typing.Optional[builtins.str] = None,
        algorithm_var: typing.Optional[builtins.str] = None,
        confidence: typing.Optional[builtins.str] = None,
        confidence_var: typing.Optional[builtins.str] = None,
        fail_gravity: typing.Optional[builtins.str] = None,
        fail_gravity_var: typing.Optional[builtins.str] = None,
        focus: typing.Optional[builtins.str] = None,
        focus_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param algorithm: Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm DataAkamaiImagingPolicyImage#algorithm}
        :param algorithm_var: Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm_var DataAkamaiImagingPolicyImage#algorithm_var}
        :param confidence: With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image. Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence DataAkamaiImagingPolicyImage#confidence}
        :param confidence_var: With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image. Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence_var DataAkamaiImagingPolicyImage#confidence_var}
        :param fail_gravity: Controls placement of the crop if Image and Video Manager does not detect any faces in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        :param fail_gravity_var: Controls placement of the crop if Image and Video Manager does not detect any faces in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        :param focus: Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus DataAkamaiImagingPolicyImage#focus}
        :param focus_var: Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus_var DataAkamaiImagingPolicyImage#focus_var}
        :param gravity: Controls placement of the crop. Directions are relative to the face(s) plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Controls placement of the crop. Directions are relative to the face(s) plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param padding: The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        :param style: Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9867ad305222e070c97c80a7601f3baf9b9bf6e721a4fd25101ab9c69e21d7ec)
            check_type(argname="argument algorithm", value=algorithm, expected_type=type_hints["algorithm"])
            check_type(argname="argument algorithm_var", value=algorithm_var, expected_type=type_hints["algorithm_var"])
            check_type(argname="argument confidence", value=confidence, expected_type=type_hints["confidence"])
            check_type(argname="argument confidence_var", value=confidence_var, expected_type=type_hints["confidence_var"])
            check_type(argname="argument fail_gravity", value=fail_gravity, expected_type=type_hints["fail_gravity"])
            check_type(argname="argument fail_gravity_var", value=fail_gravity_var, expected_type=type_hints["fail_gravity_var"])
            check_type(argname="argument focus", value=focus, expected_type=type_hints["focus"])
            check_type(argname="argument focus_var", value=focus_var, expected_type=type_hints["focus_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if algorithm is not None:
            self._values["algorithm"] = algorithm
        if algorithm_var is not None:
            self._values["algorithm_var"] = algorithm_var
        if confidence is not None:
            self._values["confidence"] = confidence
        if confidence_var is not None:
            self._values["confidence_var"] = confidence_var
        if fail_gravity is not None:
            self._values["fail_gravity"] = fail_gravity
        if fail_gravity_var is not None:
            self._values["fail_gravity_var"] = fail_gravity_var
        if focus is not None:
            self._values["focus"] = focus
        if focus_var is not None:
            self._values["focus_var"] = focus_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def algorithm(self) -> typing.Optional[builtins.str]:
        '''Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm DataAkamaiImagingPolicyImage#algorithm}
        '''
        result = self._values.get("algorithm")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def algorithm_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm_var DataAkamaiImagingPolicyImage#algorithm_var}
        '''
        result = self._values.get("algorithm_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def confidence(self) -> typing.Optional[builtins.str]:
        '''With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image.

        Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence DataAkamaiImagingPolicyImage#confidence}
        '''
        result = self._values.get("confidence")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def confidence_var(self) -> typing.Optional[builtins.str]:
        '''With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image.

        Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence_var DataAkamaiImagingPolicyImage#confidence_var}
        '''
        result = self._values.get("confidence_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any faces in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        '''
        result = self._values.get("fail_gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any faces in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        '''
        result = self._values.get("fail_gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def focus(self) -> typing.Optional[builtins.str]:
        '''Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus DataAkamaiImagingPolicyImage#focus}
        '''
        result = self._values.get("focus")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def focus_var(self) -> typing.Optional[builtins.str]:
        '''Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus_var DataAkamaiImagingPolicyImage#focus_var}
        '''
        result = self._values.get("focus_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the face(s) plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the face(s) plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeFaceCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeFaceCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeFaceCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cfb6bf644c7b65da3e77b0c54efc10fdb0fb6fe9b05fcb11c27516ef472fc678)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeFaceCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b8ea868e5b43f40370b2275546352a96944c092bf3d31aa605abe726164282a5)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeFaceCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__099f4dce34dea297ca7615f28407252dca954b046424f546258eb9c1320744f5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4d3cec1a340b7f6c3237fb511a94a3abcf7f1b6e3f5c1781dc6590c2a370fb2a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cc84e7279167639c6e63c996ef0a028773f2309295e3b30649379c13342fb372)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeFaceCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeFaceCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeFaceCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c60191d96faaec79b235c488df4f2a22a36494ad5fb03e179d2bff68cbd6586d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeFaceCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeFaceCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__942b8533144172d77a2fc7ba085231169280dfda3b7a2e9f98e138652fe19f11)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAlgorithm")
    def reset_algorithm(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAlgorithm", []))

    @jsii.member(jsii_name="resetAlgorithmVar")
    def reset_algorithm_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAlgorithmVar", []))

    @jsii.member(jsii_name="resetConfidence")
    def reset_confidence(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetConfidence", []))

    @jsii.member(jsii_name="resetConfidenceVar")
    def reset_confidence_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetConfidenceVar", []))

    @jsii.member(jsii_name="resetFailGravity")
    def reset_fail_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravity", []))

    @jsii.member(jsii_name="resetFailGravityVar")
    def reset_fail_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravityVar", []))

    @jsii.member(jsii_name="resetFocus")
    def reset_focus(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFocus", []))

    @jsii.member(jsii_name="resetFocusVar")
    def reset_focus_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFocusVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="algorithmInput")
    def algorithm_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "algorithmInput"))

    @builtins.property
    @jsii.member(jsii_name="algorithmVarInput")
    def algorithm_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "algorithmVarInput"))

    @builtins.property
    @jsii.member(jsii_name="confidenceInput")
    def confidence_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "confidenceInput"))

    @builtins.property
    @jsii.member(jsii_name="confidenceVarInput")
    def confidence_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "confidenceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityInput")
    def fail_gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityVarInput")
    def fail_gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="focusInput")
    def focus_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "focusInput"))

    @builtins.property
    @jsii.member(jsii_name="focusVarInput")
    def focus_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "focusVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="algorithm")
    def algorithm(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "algorithm"))

    @algorithm.setter
    def algorithm(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a2e2fcbadde5d3bd2fe7afcbc7d58a82a16d923b87b868de8abc35f5f3eb3f0b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "algorithm", value)

    @builtins.property
    @jsii.member(jsii_name="algorithmVar")
    def algorithm_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "algorithmVar"))

    @algorithm_var.setter
    def algorithm_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c87db07b0d85087e6efa3ee1a07b4c2e51ca7ace558a0f7b17fda841548faa82)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "algorithmVar", value)

    @builtins.property
    @jsii.member(jsii_name="confidence")
    def confidence(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "confidence"))

    @confidence.setter
    def confidence(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1c341f32cd97660d6b674f548829fde61c341adbaaef888c1cc54cf93664a62d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "confidence", value)

    @builtins.property
    @jsii.member(jsii_name="confidenceVar")
    def confidence_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "confidenceVar"))

    @confidence_var.setter
    def confidence_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a1afcdc13a041b9f110694e1971e701ae5a5c7b4944a05232b081b4c78bf27b8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "confidenceVar", value)

    @builtins.property
    @jsii.member(jsii_name="failGravity")
    def fail_gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravity"))

    @fail_gravity.setter
    def fail_gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b06779a88edd9befba8f37514e6a898906e0788bc2e649a247df548bf4f757ce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravity", value)

    @builtins.property
    @jsii.member(jsii_name="failGravityVar")
    def fail_gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravityVar"))

    @fail_gravity_var.setter
    def fail_gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__efcdd5a65216e47148d9516f3b8eb27225a42c650ef5c02da89168325f74d234)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="focus")
    def focus(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "focus"))

    @focus.setter
    def focus(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f42d19ef1c2bef1639c0ba7ac978ce9f947a4e84100fa0b274596ad060a1921e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "focus", value)

    @builtins.property
    @jsii.member(jsii_name="focusVar")
    def focus_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "focusVar"))

    @focus_var.setter
    def focus_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c6f523285b8bee0c9152addf354338daded2ecd4f48dc6cb654002ba2d3b873b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "focusVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__14f51312f74b5ba14ad5c47343bb7d2d0f46019ce0b423169d3a46a123bd6548)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cb24f55c252fa16fe631e967431151d0e63ff735010a89eeec44dd8744f95c77)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3912996339ae7d24376ae9af5e33c1341612a9cafa13f6b315ba674ea66d883f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__260cf5e7ebba3677a89d1c9441a373ca6de1f3d8a84f20cd4c8cf041f36d2ef8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8f312492e7cabd076782c97856e35eb838a20bfb0798e7e10eb8258e3701f71d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3420536baf879ae3ad594fb8b89e2fea8a3d8a60b73fe5623672f3910376a893)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__459429201103d1f730c0835cba6f7ecac06a22d91c416923e23d0dc50a6f793b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ff59a7b217c5623fd65a38ec3475984ee0c66f6b4a39f499855a14c3bb3de742)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8ce787eb36d46abb69c1e28654d133d96f3694c4896fde2f54d2f44cdf5d8432)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9f50cef8b13ccb9d636fe1ad678e2f7645e14ba03f8c04ebabbc199e39d3d79d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeFaceCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeFaceCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeFaceCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c0b347b18fb3904eb1300b45a7b26602bac0f161b01fb0a0089625486f9d5093)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeFeatureCrop",
    jsii_struct_bases=[],
    name_mapping={
        "fail_gravity": "failGravity",
        "fail_gravity_var": "failGravityVar",
        "feature_radius": "featureRadius",
        "feature_radius_var": "featureRadiusVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "max_features": "maxFeatures",
        "max_features_var": "maxFeaturesVar",
        "min_feature_quality": "minFeatureQuality",
        "min_feature_quality_var": "minFeatureQualityVar",
        "padding": "padding",
        "padding_var": "paddingVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeFeatureCrop:
    def __init__(
        self,
        *,
        fail_gravity: typing.Optional[builtins.str] = None,
        fail_gravity_var: typing.Optional[builtins.str] = None,
        feature_radius: typing.Optional[builtins.str] = None,
        feature_radius_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        max_features: typing.Optional[builtins.str] = None,
        max_features_var: typing.Optional[builtins.str] = None,
        min_feature_quality: typing.Optional[builtins.str] = None,
        min_feature_quality_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fail_gravity: Controls placement of the crop if Image and Video Manager does not detect any features in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        :param fail_gravity_var: Controls placement of the crop if Image and Video Manager does not detect any features in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        :param feature_radius: The size in pixels of the important features to search for. If identified, two features never appear closer together than this value, ``8.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius DataAkamaiImagingPolicyImage#feature_radius}
        :param feature_radius_var: The size in pixels of the important features to search for. If identified, two features never appear closer together than this value, ``8.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius_var DataAkamaiImagingPolicyImage#feature_radius_var}
        :param gravity: Controls placement of the crop. Directions are relative to the region of interest plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Controls placement of the crop. Directions are relative to the region of interest plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param max_features: The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features DataAkamaiImagingPolicyImage#max_features}
        :param max_features_var: The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features_var DataAkamaiImagingPolicyImage#max_features_var}
        :param min_feature_quality: Determines the minimum quality level of the feature identified. To consider a feature important, the feature needs to surpass this value. Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality DataAkamaiImagingPolicyImage#min_feature_quality}
        :param min_feature_quality_var: Determines the minimum quality level of the feature identified. To consider a feature important, the feature needs to surpass this value. Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality_var DataAkamaiImagingPolicyImage#min_feature_quality_var}
        :param padding: Adds space around the region of interest. The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: Adds space around the region of interest. The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        :param style: Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__70a07f780ef630d5e60a8b6f7f36a4d675aa5e98c2948652195806a628b9d45d)
            check_type(argname="argument fail_gravity", value=fail_gravity, expected_type=type_hints["fail_gravity"])
            check_type(argname="argument fail_gravity_var", value=fail_gravity_var, expected_type=type_hints["fail_gravity_var"])
            check_type(argname="argument feature_radius", value=feature_radius, expected_type=type_hints["feature_radius"])
            check_type(argname="argument feature_radius_var", value=feature_radius_var, expected_type=type_hints["feature_radius_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument max_features", value=max_features, expected_type=type_hints["max_features"])
            check_type(argname="argument max_features_var", value=max_features_var, expected_type=type_hints["max_features_var"])
            check_type(argname="argument min_feature_quality", value=min_feature_quality, expected_type=type_hints["min_feature_quality"])
            check_type(argname="argument min_feature_quality_var", value=min_feature_quality_var, expected_type=type_hints["min_feature_quality_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fail_gravity is not None:
            self._values["fail_gravity"] = fail_gravity
        if fail_gravity_var is not None:
            self._values["fail_gravity_var"] = fail_gravity_var
        if feature_radius is not None:
            self._values["feature_radius"] = feature_radius
        if feature_radius_var is not None:
            self._values["feature_radius_var"] = feature_radius_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if max_features is not None:
            self._values["max_features"] = max_features
        if max_features_var is not None:
            self._values["max_features_var"] = max_features_var
        if min_feature_quality is not None:
            self._values["min_feature_quality"] = min_feature_quality
        if min_feature_quality_var is not None:
            self._values["min_feature_quality_var"] = min_feature_quality_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def fail_gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any features in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        '''
        result = self._values.get("fail_gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any features in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        '''
        result = self._values.get("fail_gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feature_radius(self) -> typing.Optional[builtins.str]:
        '''The size in pixels of the important features to search for.

        If identified, two features never appear closer together than this value, ``8.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius DataAkamaiImagingPolicyImage#feature_radius}
        '''
        result = self._values.get("feature_radius")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feature_radius_var(self) -> typing.Optional[builtins.str]:
        '''The size in pixels of the important features to search for.

        If identified, two features never appear closer together than this value, ``8.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius_var DataAkamaiImagingPolicyImage#feature_radius_var}
        '''
        result = self._values.get("feature_radius_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the region of interest plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the region of interest plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def max_features(self) -> typing.Optional[builtins.str]:
        '''The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features DataAkamaiImagingPolicyImage#max_features}
        '''
        result = self._values.get("max_features")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def max_features_var(self) -> typing.Optional[builtins.str]:
        '''The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features_var DataAkamaiImagingPolicyImage#max_features_var}
        '''
        result = self._values.get("max_features_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def min_feature_quality(self) -> typing.Optional[builtins.str]:
        '''Determines the minimum quality level of the feature identified.

        To consider a feature important, the feature needs to surpass this value.  Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality DataAkamaiImagingPolicyImage#min_feature_quality}
        '''
        result = self._values.get("min_feature_quality")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def min_feature_quality_var(self) -> typing.Optional[builtins.str]:
        '''Determines the minimum quality level of the feature identified.

        To consider a feature important, the feature needs to surpass this value.  Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality_var DataAkamaiImagingPolicyImage#min_feature_quality_var}
        '''
        result = self._values.get("min_feature_quality_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''Adds space around the region of interest.

        The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''Adds space around the region of interest.

        The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeFeatureCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeFeatureCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeFeatureCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7befc87ccbfe006b78664577067001f8b8c1c424c48a3c5f3e1d1656bb04b3ec)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeFeatureCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1b2aabdadd0926a01ed7080cdd560fb4345a4839a1de5ba7993a0c591a1acd78)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeFeatureCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b6483fb7651bf89d4cb02b0c8acd3fdd74ee5c79f191c1c825bcf4b60a5247bb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__210fedde525a1827b4f2c7a06ee16f5401727b8a14a366e2daf5258948201c30)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__031229299311cc5c8bb8f59bbe4b5909033f815fbe66a1a8fc5025556e8f4807)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeFeatureCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeFeatureCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeFeatureCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e432ae8320825689965dc9dd2cf006c7d4f021d5a0521a7c55b9dfaa219fce10)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeFeatureCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeFeatureCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__04abc29602403e354588835b6f519d0eae2e5e9f8c66dae30ed9e67d4beb03db)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetFailGravity")
    def reset_fail_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravity", []))

    @jsii.member(jsii_name="resetFailGravityVar")
    def reset_fail_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravityVar", []))

    @jsii.member(jsii_name="resetFeatureRadius")
    def reset_feature_radius(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureRadius", []))

    @jsii.member(jsii_name="resetFeatureRadiusVar")
    def reset_feature_radius_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureRadiusVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetMaxFeatures")
    def reset_max_features(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxFeatures", []))

    @jsii.member(jsii_name="resetMaxFeaturesVar")
    def reset_max_features_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxFeaturesVar", []))

    @jsii.member(jsii_name="resetMinFeatureQuality")
    def reset_min_feature_quality(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMinFeatureQuality", []))

    @jsii.member(jsii_name="resetMinFeatureQualityVar")
    def reset_min_feature_quality_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMinFeatureQualityVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="failGravityInput")
    def fail_gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityVarInput")
    def fail_gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featureRadiusInput")
    def feature_radius_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featureRadiusInput"))

    @builtins.property
    @jsii.member(jsii_name="featureRadiusVarInput")
    def feature_radius_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featureRadiusVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesInput")
    def max_features_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "maxFeaturesInput"))

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesVarInput")
    def max_features_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "maxFeaturesVarInput"))

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityInput")
    def min_feature_quality_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "minFeatureQualityInput"))

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityVarInput")
    def min_feature_quality_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "minFeatureQualityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravity")
    def fail_gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravity"))

    @fail_gravity.setter
    def fail_gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2eeb73810fac43f2f9d304dc15c8b0002912cc418d83a3bcd6c12d1474788f4d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravity", value)

    @builtins.property
    @jsii.member(jsii_name="failGravityVar")
    def fail_gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravityVar"))

    @fail_gravity_var.setter
    def fail_gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__878cecceef05e8ec4112b0d19c67c4e461b2d2ce2c352c6da850aece398dc909)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="featureRadius")
    def feature_radius(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featureRadius"))

    @feature_radius.setter
    def feature_radius(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bf24d7dc6c5129079173cf21122f7fce8148b31335ac3b04a07155bbf7384a67)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featureRadius", value)

    @builtins.property
    @jsii.member(jsii_name="featureRadiusVar")
    def feature_radius_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featureRadiusVar"))

    @feature_radius_var.setter
    def feature_radius_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__daccc70d68917c01114367fde2a9436610da18a1392dc46f569fe3ac7b94bb90)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featureRadiusVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8e3ed309ba05bb4a41434168890827c514ca9c264e93f283750acbefe9df1f21)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f39ad1648580720cf37462159c8f7b1795b0255ffc314855763104eb6ff0abc1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__54ec37a6217b3c3cc4b744ded69dba3bade06d2985a13c95e845fcb9d2235363)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__95519f47a70a228d0d3da2e519166840cd8f89960b509e638e9162a8e26f0705)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="maxFeatures")
    def max_features(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "maxFeatures"))

    @max_features.setter
    def max_features(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__43bbd65e61584b2d34c3d20ef3480cd8021d24ee084fdc445a8ea6c7305dcdb8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "maxFeatures", value)

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesVar")
    def max_features_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "maxFeaturesVar"))

    @max_features_var.setter
    def max_features_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b5a4d53ecc69aa20c011b5ef1bb79b5126f9e3742345d79719c20333b6c0106b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "maxFeaturesVar", value)

    @builtins.property
    @jsii.member(jsii_name="minFeatureQuality")
    def min_feature_quality(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "minFeatureQuality"))

    @min_feature_quality.setter
    def min_feature_quality(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__83f4aa848dd61a8a79fcdb288e8f4c3276cab5c9d30081a304e437ef6acd8479)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "minFeatureQuality", value)

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityVar")
    def min_feature_quality_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "minFeatureQualityVar"))

    @min_feature_quality_var.setter
    def min_feature_quality_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__866d3f26a56e3c3e0e9287f5ae9c461b0e4a50aa4bdc05c745b6da46a8be6914)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "minFeatureQualityVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be4c0893b772cdaf41e74fa414b596097ef8260868b06f001f54024616b1571b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e8d14e68ba69f4d7ddc3438196579a73ac2c3ce1eb9a70e718ca29d8bbd8c9a9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f0b91b0fc987888e20b672dd91aaf787689b70717e55a8f7477f4319572e5967)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__05a974f2c16aa0aab932042540737b5d8a559917b31fac668992830d0b7cf3d9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__10394681cc18f9600eabfe0aff55f4e171298d6d11393e51f16aa8065e2fee7c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ba0bed608ee7f10e3c63d846ee726ad606b79bb4572d341b7acbd5a89c050e91)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeFeatureCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeFeatureCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeFeatureCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d15a4461547e74bc6f1857638bf43191ebf91cea08f3577c68b73253d75e45ef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeFitAndFill",
    jsii_struct_bases=[],
    name_mapping={
        "fill_transformation": "fillTransformation",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeFitAndFill:
    def __init__(
        self,
        *,
        fill_transformation: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeFitAndFillFillTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fill_transformation: fill_transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_transformation DataAkamaiImagingPolicyImage#fill_transformation}
        :param height: The height value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The width value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(fill_transformation, dict):
            fill_transformation = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeFitAndFillFillTransformation(**fill_transformation)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a14f57c2d17e6ee85504b7ac39ca9c09d0b9627f9129b8a27c10a1f2592a9e7a)
            check_type(argname="argument fill_transformation", value=fill_transformation, expected_type=type_hints["fill_transformation"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fill_transformation is not None:
            self._values["fill_transformation"] = fill_transformation
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def fill_transformation(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeFitAndFillFillTransformation"]:
        '''fill_transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_transformation DataAkamaiImagingPolicyImage#fill_transformation}
        '''
        result = self._values.get("fill_transformation")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeFitAndFillFillTransformation"], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeFitAndFill(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeFitAndFillFillTransformation",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeFitAndFillFillTransformation:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeFitAndFillFillTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeFitAndFillFillTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeFitAndFillFillTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7773138e31d1a679e568547ee00545cf1b371a3dd17c8d5e23818269cac604e1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeFitAndFillFillTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeFitAndFillFillTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeFitAndFillFillTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc9fc5f820e03b78a4bdebefad3ccd7d2a33a44ef704ba1c27f5c87286bf6456)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeFitAndFillList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeFitAndFillList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5d25102169153fc3b935c49c6ebd6bce5623ef431da7b2f90ef95138cd6b7419)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeFitAndFillOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__22f72f6a87177731ab34afcc348fc99259d40cb266de81a9ce6b168053f4fab1)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeFitAndFillOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__21af6e17536431429a99c3213147acc38eb6334b98dc57778d2428a512a2e573)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c749882b1be10a55f02b4f038e513c2d32ce8c6fdbaca8f2c5c9b6b2659b1f7c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f529de96ecb515bf212f07b45c7d080b4adc34723311ccccba7e7a11bea2d633)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeFitAndFill]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeFitAndFill]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeFitAndFill]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__865afe1aa980c4070b3e57da0390f2e85bfae5bf2f3096e3d1a1190a8cb53a8e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeFitAndFillOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeFitAndFillOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8bc97a3197f112639bb127af36b90746e25f63ef5fff7edf888849155b26c07f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putFillTransformation")
    def put_fill_transformation(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeFitAndFillFillTransformation()

        return typing.cast(None, jsii.invoke(self, "putFillTransformation", [value]))

    @jsii.member(jsii_name="resetFillTransformation")
    def reset_fill_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFillTransformation", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="fillTransformation")
    def fill_transformation(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeFitAndFillFillTransformationOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeFitAndFillFillTransformationOutputReference, jsii.get(self, "fillTransformation"))

    @builtins.property
    @jsii.member(jsii_name="fillTransformationInput")
    def fill_transformation_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeFitAndFillFillTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeFitAndFillFillTransformation], jsii.get(self, "fillTransformationInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__37c2980a14cccbcc56f5c1b776ea90933a73452c559bec2b87f40cc5831f833f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__29bc538a57a4644f71ef285ecb663c3efd73538a2171666348050716bc706cd8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a4629a36e5ff01bfec98cdbd076db068f97fb33d47df9e5d9f2e623e1561fe61)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dea2c968739b4317ccb84424b3c0e19fb77215f8b95b4de690886ff6d1ba1617)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeFitAndFill]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeFitAndFill]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeFitAndFill]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__90ff96a1584ffb3b1400db4445255bdd0f12315212ebb49b91ef09c7b76e0ba1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeGoop",
    jsii_struct_bases=[],
    name_mapping={
        "chaos": "chaos",
        "chaos_var": "chaosVar",
        "density": "density",
        "density_var": "densityVar",
        "power": "power",
        "power_var": "powerVar",
        "seed": "seed",
        "seed_var": "seedVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeGoop:
    def __init__(
        self,
        *,
        chaos: typing.Optional[builtins.str] = None,
        chaos_var: typing.Optional[builtins.str] = None,
        density: typing.Optional[builtins.str] = None,
        density_var: typing.Optional[builtins.str] = None,
        power: typing.Optional[builtins.str] = None,
        power_var: typing.Optional[builtins.str] = None,
        seed: typing.Optional[builtins.str] = None,
        seed_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param chaos: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        :param chaos_var: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        :param density: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        :param density_var: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        :param power: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        :param power_var: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        :param seed: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        :param seed_var: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7b38605ff1afd9d27af95a3e289269db239a3a9d23ff337367903f3bf6b32060)
            check_type(argname="argument chaos", value=chaos, expected_type=type_hints["chaos"])
            check_type(argname="argument chaos_var", value=chaos_var, expected_type=type_hints["chaos_var"])
            check_type(argname="argument density", value=density, expected_type=type_hints["density"])
            check_type(argname="argument density_var", value=density_var, expected_type=type_hints["density_var"])
            check_type(argname="argument power", value=power, expected_type=type_hints["power"])
            check_type(argname="argument power_var", value=power_var, expected_type=type_hints["power_var"])
            check_type(argname="argument seed", value=seed, expected_type=type_hints["seed"])
            check_type(argname="argument seed_var", value=seed_var, expected_type=type_hints["seed_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if chaos is not None:
            self._values["chaos"] = chaos
        if chaos_var is not None:
            self._values["chaos_var"] = chaos_var
        if density is not None:
            self._values["density"] = density
        if density_var is not None:
            self._values["density_var"] = density_var
        if power is not None:
            self._values["power"] = power
        if power_var is not None:
            self._values["power_var"] = power_var
        if seed is not None:
            self._values["seed"] = seed
        if seed_var is not None:
            self._values["seed_var"] = seed_var

    @builtins.property
    def chaos(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        '''
        result = self._values.get("chaos")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def chaos_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        '''
        result = self._values.get("chaos_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        '''
        result = self._values.get("density")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density_var(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        '''
        result = self._values.get("density_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        '''
        result = self._values.get("power")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power_var(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        '''
        result = self._values.get("power_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        '''
        result = self._values.get("seed")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed_var(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        result = self._values.get("seed_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeGoop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeGoopList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeGoopList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5466ab79312563c74733b90456b56e7c3c5b2d2fedbc7601a709b759e06278fc)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeGoopOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c40ac4bee13d4dc7acb11a4e22a4245f5dc30879126e01ff5f2a6e71097244db)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeGoopOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__85787e6e56ce97ff6cbbffec64e0a635fcc8a4073eed0c12f6321b92f2d27bcb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb585e369d399fc3be41bb4ed82ff787eadbb32b15076e72b4cbfeb38ee28bb6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__64534272d824a8db1f60fe982924245d7f6b5239903516e6e9952ac5246bd65f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeGoop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeGoop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__79a266c64fc8c695e436c782131700842427beb8fc351c8d3a83823a6aa41edc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeGoopOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeGoopOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__131701bde0a8a5f2bed2e26e7cc55aafa0d6a3e3176a4087043b56bb5f847aa8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetChaos")
    def reset_chaos(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaos", []))

    @jsii.member(jsii_name="resetChaosVar")
    def reset_chaos_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaosVar", []))

    @jsii.member(jsii_name="resetDensity")
    def reset_density(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensity", []))

    @jsii.member(jsii_name="resetDensityVar")
    def reset_density_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensityVar", []))

    @jsii.member(jsii_name="resetPower")
    def reset_power(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPower", []))

    @jsii.member(jsii_name="resetPowerVar")
    def reset_power_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPowerVar", []))

    @jsii.member(jsii_name="resetSeed")
    def reset_seed(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeed", []))

    @jsii.member(jsii_name="resetSeedVar")
    def reset_seed_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeedVar", []))

    @builtins.property
    @jsii.member(jsii_name="chaosInput")
    def chaos_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosInput"))

    @builtins.property
    @jsii.member(jsii_name="chaosVarInput")
    def chaos_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosVarInput"))

    @builtins.property
    @jsii.member(jsii_name="densityInput")
    def density_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityInput"))

    @builtins.property
    @jsii.member(jsii_name="densityVarInput")
    def density_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="powerInput")
    def power_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerInput"))

    @builtins.property
    @jsii.member(jsii_name="powerVarInput")
    def power_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerVarInput"))

    @builtins.property
    @jsii.member(jsii_name="seedInput")
    def seed_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedInput"))

    @builtins.property
    @jsii.member(jsii_name="seedVarInput")
    def seed_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedVarInput"))

    @builtins.property
    @jsii.member(jsii_name="chaos")
    def chaos(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaos"))

    @chaos.setter
    def chaos(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8e76e2a2a6c8479e75f41b35e16a8790634402ab7d7c73c911ac7b11d7bee7a2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaos", value)

    @builtins.property
    @jsii.member(jsii_name="chaosVar")
    def chaos_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaosVar"))

    @chaos_var.setter
    def chaos_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8c1eaa92b58469c479efefeeea8290a6d776df9af7c1923df3ec0c183f1e28bb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaosVar", value)

    @builtins.property
    @jsii.member(jsii_name="density")
    def density(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "density"))

    @density.setter
    def density(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__97f815e0b0146f8252d4581083e0864e516860f1186c61d3ffc1a119406c3465)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "density", value)

    @builtins.property
    @jsii.member(jsii_name="densityVar")
    def density_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "densityVar"))

    @density_var.setter
    def density_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__04b13bbabbc260a61033079f1a7aff3bb5b20bfbf699c03b6dcff8ece1bf40d5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "densityVar", value)

    @builtins.property
    @jsii.member(jsii_name="power")
    def power(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "power"))

    @power.setter
    def power(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__89681f154fbe4c0c5bca36ffc17ac6e01751ffd22d8d04fd90c08d713b87799f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "power", value)

    @builtins.property
    @jsii.member(jsii_name="powerVar")
    def power_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "powerVar"))

    @power_var.setter
    def power_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__23c4dffcff9649a188497325c5e40302d288ca7c6f081dc579897c3300ebb96c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "powerVar", value)

    @builtins.property
    @jsii.member(jsii_name="seed")
    def seed(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seed"))

    @seed.setter
    def seed(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__25b19443d95a5c1230405d41bba0496e576d6827ef82571f08bca2ac4a869d0b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seed", value)

    @builtins.property
    @jsii.member(jsii_name="seedVar")
    def seed_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seedVar"))

    @seed_var.setter
    def seed_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__de8051ca308ed6b0624b395e342277baeb3b4b74126aa9fd8a1487a808704dd5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seedVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeGoop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeGoop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeGoop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__07b5d64edbbf36f505137eb82bd969a36646eab6c48b22a0276f34d2777efb34)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeGrayscale",
    jsii_struct_bases=[],
    name_mapping={"type": "type", "type_var": "typeVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeGrayscale:
    def __init__(
        self,
        *,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param type: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__deba26bce4c6b703d202e0c1df8c1fc0a2c04ae80e8459b88814fe134a8b3f55)
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeGrayscale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeGrayscaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeGrayscaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e40f9814d643439f4694320a4d9a448043a566d8eac30676f990fa3758fc6ff3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeGrayscaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__53844f259f2fc949b3b5c21673a88bb1cf0c76a0cb050e157cd188e7e257b179)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeGrayscaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d8ddaffb67e03e24b730514b631f30d15146b9f03712772c9e7ef0312d70358)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__481a0367978c92fdf609bab42ac3680a6bdd4102deb310968b2d4f8aca581674)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3acf4dd9a7578d986433c9c2b9e27aae5f0742e720ac330a13a77f9a92fe4223)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeGrayscale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeGrayscale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ca4a0bd184fff7f3ff18d4fd5cdc72e37b8140e11624bf4b7d0084b726887e35)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeGrayscaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeGrayscaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e6f68bb69e47874974b1fa4b892b45cb754da816264bd789b74a7f5bf92a4e96)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e605f3f3ad1e5e12d37c0a2253d4928cad36c178df14b5895f78ad1b02c6245f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8ccbfe45895a69d1f0c732c2b74ccf56b8d79876b570ad0fad18258f8e559cf2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeGrayscale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeGrayscale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeGrayscale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0612f6940e9c1b84565e9cafd2de3c8e43dec5451be5f1abd9f397316bd9c881)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeHsl",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "lightness": "lightness",
        "lightness_var": "lightnessVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeHsl:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness: typing.Optional[builtins.str] = None,
        lightness_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        :param lightness_var: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3e4a762a987eca321416d1d3375c3313c5bd67481a4b6db737c384fe1b8c81f9)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness", value=lightness, expected_type=type_hints["lightness"])
            check_type(argname="argument lightness_var", value=lightness_var, expected_type=type_hints["lightness_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness is not None:
            self._values["lightness"] = lightness
        if lightness_var is not None:
            self._values["lightness_var"] = lightness_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        '''
        result = self._values.get("lightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        '''
        result = self._values.get("lightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeHsl(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeHslList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeHslList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b707ebdeb7e4c7a652a6e72fc68d3e2c6d5a2a1b192efdc3c9f608a92a6c68bc)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeHslOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2faf226a626e7ab1189001e54bcd21658d727c2fee9bb72f4f5b6362c220e08c)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeHslOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__189646fa621c3885b09ddfc2745d045e095ea6acc80835da8830369a00b075a6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4b18b8e1783127c06c34c7815fdacf39a6519afbacd20893d146e178180f03d5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b54725a956da5250aae21da7b9a20445b32794c143551b5b49c0250240af9ff0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeHsl]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeHsl]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__728789ae46b3cd6637a98f5bed0cc81f398c4fa4f26310085c862bb01afa8d6b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeHslOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeHslOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d7424226a98cd45798601158f8a2800367982df3b2813660f87b4ca29ac0517e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightness")
    def reset_lightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightness", []))

    @jsii.member(jsii_name="resetLightnessVar")
    def reset_lightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessInput")
    def lightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessVarInput")
    def lightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fe4265775864d8372e3f812f6bf1ccd729154f36c4da7080ee60a781e1ab9572)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6aeee33c72dbe5040dff1c121b40b5bbe1ade20814815dd906cfd4653760239c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightness")
    def lightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightness"))

    @lightness.setter
    def lightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fbde1c293006e102914c3a78b3ff46852e951b4b406245623a7ff708a1c2b351)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightness", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessVar")
    def lightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessVar"))

    @lightness_var.setter
    def lightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dbc034a5cbbd3453265ba3ed933483fbd07d94ddd2fdc2d0b4ef9b21b70efc7d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f5633a3214ccad8f521525da548df728273fc5ff96f054b3eacd23369fd6f6ca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b977bb5f44dc169859fcd758e000feacfa039c02c5da05f359c0e13a5d261d7a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeHsl]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeHsl]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeHsl]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__63bcf39a2efd4703f8f6d9e4e3e99e3f50f8bfce2fdd7f51a6f71b5679360291)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeHsv",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeHsv:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        :param value: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f8bb614bd9f6cb390dcca1e7af79c54c85300e23b6a67201a15539404664f70a)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeHsv(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeHsvList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeHsvList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a02490eaba751961bd95c96a57be0cab014c1fba275b56b9700425e900226ee1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeHsvOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b828e639aa3733054863e4a5d20b57ffe25964bf495c4b2649d9dce441e7b6dc)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeHsvOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e128ccd26fdd4287f545d9cfa6fd3506109ca6837999ff0e1537a6d55978a21b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__574f38113fca0dfee009b4d93065a01df7ef8558a1d9625d3dc7d0f18a1af898)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bea2f6d086f65162f37c3c20abb09ffd5aa422b6558b7acce55215451f302212)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeHsv]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeHsv]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__849f6e264ebee0febb7ea8e3d77fad1c035c9e6fb722914932e5783e8318efdd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeHsvOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeHsvOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__944f50dff9f9adc18a68390f77394d682d2676e0eb769ad587c8533c6289f7e3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__855dcc1b3944495d669f0941c9a8725e28f59e0039c92b94dd0ea0ff99888a43)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__72fff8a0a572fc96aa9a5d4ffee10be9002ba5e77d97aa8c5453efac89b4e5c9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f3bfbd5a10b2e1fed7c23b5949b8eec2cabd57d792ba6461bbc92b1f048cb36b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5a0b319c14956dde4e9e219a79d9ee7b1c3c63476f41090f55ac2a5f9233780e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e2bba6dfa8d37e4f0f18ff9f5999f3225cfa1cd9f043d6766d1058cbe54445ac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e1c6e23b03e698ce0dbcf6d9ccba9a3c6d56a4f5b0cd5a4e33e4c9ae3091e8c6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeHsv]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeHsv]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeHsv]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2f8cdbccb08ab157e7eb8dd20f86a4ad0aaae1da30b2647c2134012099c2cfc7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimension",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "dimension": "dimension",
        "dimension_var": "dimensionVar",
        "equal": "equal",
        "greater_than": "greaterThan",
        "less_than": "lessThan",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimension:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimensionDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        dimension: typing.Optional[builtins.str] = None,
        dimension_var: typing.Optional[builtins.str] = None,
        equal: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimensionEqual", typing.Dict[builtins.str, typing.Any]]] = None,
        greater_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimensionGreaterThan", typing.Dict[builtins.str, typing.Any]]] = None,
        less_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimensionLessThan", typing.Dict[builtins.str, typing.Any]]] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param dimension: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        :param dimension_var: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        :param equal: equal block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        :param greater_than: greater_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        :param less_than: less_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        :param value: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimensionDefault(**default)
        if isinstance(equal, dict):
            equal = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimensionEqual(**equal)
        if isinstance(greater_than, dict):
            greater_than = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimensionGreaterThan(**greater_than)
        if isinstance(less_than, dict):
            less_than = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimensionLessThan(**less_than)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__39f9fbff2bc41621fb174a6a0bab94044344e538f81c0608935f826b18d5456f)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument dimension", value=dimension, expected_type=type_hints["dimension"])
            check_type(argname="argument dimension_var", value=dimension_var, expected_type=type_hints["dimension_var"])
            check_type(argname="argument equal", value=equal, expected_type=type_hints["equal"])
            check_type(argname="argument greater_than", value=greater_than, expected_type=type_hints["greater_than"])
            check_type(argname="argument less_than", value=less_than, expected_type=type_hints["less_than"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if dimension is not None:
            self._values["dimension"] = dimension
        if dimension_var is not None:
            self._values["dimension_var"] = dimension_var
        if equal is not None:
            self._values["equal"] = equal
        if greater_than is not None:
            self._values["greater_than"] = greater_than
        if less_than is not None:
            self._values["less_than"] = less_than
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimensionDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimensionDefault"], result)

    @builtins.property
    def dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        '''
        result = self._values.get("dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        '''
        result = self._values.get("dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def equal(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimensionEqual"]:
        '''equal block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        '''
        result = self._values.get("equal")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimensionEqual"], result)

    @builtins.property
    def greater_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimensionGreaterThan"]:
        '''greater_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        '''
        result = self._values.get("greater_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimensionGreaterThan"], result)

    @builtins.property
    def less_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimensionLessThan"]:
        '''less_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        '''
        result = self._values.get("less_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimensionLessThan"], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimension(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimensionDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimensionDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimensionDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimensionDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimensionDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3779ee6ad4f4831a5333cbb23e97fca1b3dc596ad57928c91e338988cd7b0782)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimensionDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimensionDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8e41dea9a75e87b45750d615564fae5617cb101f0a05905dadcd7b56580f9fa2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimensionEqual",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimensionEqual:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimensionEqual(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimensionEqualOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimensionEqualOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b3e4758809c5f4d57d88460522177c09cc1f64d124d39af0e502e197d4c3a043)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimensionEqual], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimensionEqual],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b9980003715d749fe6f4623a76337e904026b42af2b072394cfe316b07464acb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimensionGreaterThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimensionGreaterThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimensionGreaterThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimensionGreaterThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimensionGreaterThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c6c7ca3dc75a13d4cb26964796195693fec42582e55ef0598332669222e8e8a8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimensionGreaterThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimensionGreaterThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__64b0fd5811de919937ad7f8d79c5b5894b1756647dae6cbf5a217743496065c0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimensionLessThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimensionLessThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimensionLessThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimensionLessThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimensionLessThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6457ba2fdb05a35db499b4891ceb8652b533ded3abc37a8af45149bee15279bc)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimensionLessThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimensionLessThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f49a5354ab740f9cdd06f2c83b9c50d8b189df4f4e2517d20ce15677de409d19)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimensionList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimensionList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f1609c537966136d26c1afe3456e076a5db734c8a0b3e4ec03beedc16a28e47)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimensionOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e0cf4fd8de933337875c4f000e67cbba79bdf0faf4b675732f36c45438b77c6f)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimensionOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fbbd2273a88e9eff8498b092729475e64e00c685d1d16320bad66a153f908b33)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4da0c2f95a88d6d55c8a03a3bdf911631c47529975c1dccc5e4f4a300a5ffea3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ddb396a20c5c3a8da2f022fb2671db9a0f656302dc32c63155836264c0c58e08)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimension]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimension]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b866a63c256240ffec7c9d006695dccf5ae6dfe58e39ff9396ae4a379dc44470)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimensionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimensionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a2b43039ae087de53b1ac5d8dcfccdc7ec653476a0709a5c6b3ef24e864801f8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimensionDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putEqual")
    def put_equal(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimensionEqual()

        return typing.cast(None, jsii.invoke(self, "putEqual", [value]))

    @jsii.member(jsii_name="putGreaterThan")
    def put_greater_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimensionGreaterThan()

        return typing.cast(None, jsii.invoke(self, "putGreaterThan", [value]))

    @jsii.member(jsii_name="putLessThan")
    def put_less_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimensionLessThan()

        return typing.cast(None, jsii.invoke(self, "putLessThan", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetDimension")
    def reset_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimension", []))

    @jsii.member(jsii_name="resetDimensionVar")
    def reset_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimensionVar", []))

    @jsii.member(jsii_name="resetEqual")
    def reset_equal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEqual", []))

    @jsii.member(jsii_name="resetGreaterThan")
    def reset_greater_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGreaterThan", []))

    @jsii.member(jsii_name="resetLessThan")
    def reset_less_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLessThan", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimensionDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimensionDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="equal")
    def equal(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimensionEqualOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimensionEqualOutputReference, jsii.get(self, "equal"))

    @builtins.property
    @jsii.member(jsii_name="greaterThan")
    def greater_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimensionGreaterThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimensionGreaterThanOutputReference, jsii.get(self, "greaterThan"))

    @builtins.property
    @jsii.member(jsii_name="lessThan")
    def less_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimensionLessThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimensionLessThanOutputReference, jsii.get(self, "lessThan"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimensionDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionInput")
    def dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionVarInput")
    def dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="equalInput")
    def equal_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimensionEqual], jsii.get(self, "equalInput"))

    @builtins.property
    @jsii.member(jsii_name="greaterThanInput")
    def greater_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimensionGreaterThan], jsii.get(self, "greaterThanInput"))

    @builtins.property
    @jsii.member(jsii_name="lessThanInput")
    def less_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimensionLessThan], jsii.get(self, "lessThanInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="dimension")
    def dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimension"))

    @dimension.setter
    def dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c1489834564ffde1055e9ec2b92f2d2bbbf3ad8931260a4faa4ac19352b3da04)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimension", value)

    @builtins.property
    @jsii.member(jsii_name="dimensionVar")
    def dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimensionVar"))

    @dimension_var.setter
    def dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__db275410a504345d7cb01192faeedcd817b7876b5ac4142cab657956d28cfc05)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f93835472dd4e8d4ba58970cfd18af4df5a23354b936a91fa6cade6916d56e85)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__91760db8a4939ef1c458d7a91444651f26dc15eb50575719f968ea8f5d44661f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimension]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimension]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimension]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be1d6aa981da10fe8096052b20661c1e5fcd9f5850e7d6c61d2be7a7d7363199)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientation",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "landscape": "landscape",
        "portrait": "portrait",
        "square": "square",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientation:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientationDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        landscape: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientationLandscape", typing.Dict[builtins.str, typing.Any]]] = None,
        portrait: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientationPortrait", typing.Dict[builtins.str, typing.Any]]] = None,
        square: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientationSquare", typing.Dict[builtins.str, typing.Any]]] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param landscape: landscape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        :param portrait: portrait block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        :param square: square block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientationDefault(**default)
        if isinstance(landscape, dict):
            landscape = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientationLandscape(**landscape)
        if isinstance(portrait, dict):
            portrait = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientationPortrait(**portrait)
        if isinstance(square, dict):
            square = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientationSquare(**square)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3efc12582cdf0f5ce29ff2d2df7124fa8266c19b53c9aeb89d9a6d618478b4d8)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument landscape", value=landscape, expected_type=type_hints["landscape"])
            check_type(argname="argument portrait", value=portrait, expected_type=type_hints["portrait"])
            check_type(argname="argument square", value=square, expected_type=type_hints["square"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if landscape is not None:
            self._values["landscape"] = landscape
        if portrait is not None:
            self._values["portrait"] = portrait
        if square is not None:
            self._values["square"] = square

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientationDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientationDefault"], result)

    @builtins.property
    def landscape(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientationLandscape"]:
        '''landscape block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        '''
        result = self._values.get("landscape")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientationLandscape"], result)

    @builtins.property
    def portrait(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientationPortrait"]:
        '''portrait block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        '''
        result = self._values.get("portrait")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientationPortrait"], result)

    @builtins.property
    def square(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientationSquare"]:
        '''square block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        result = self._values.get("square")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientationSquare"], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientationDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientationDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientationDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientationDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientationDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c62f2f11b66c1678f7a8592ca06bc0c37a54faa84ef5662aefbfe7cf313d6663)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientationDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientationDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2102c39dacc2886656df765faa8579623b63802925aaa11b20287c588baade5b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientationLandscape",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientationLandscape:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientationLandscape(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientationLandscapeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientationLandscapeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ac49cf1b5912bf7b58a6841de96254c83c3bf6618950d55e3769e823ea3d7e5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientationLandscape], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientationLandscape],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd9c203b0a760ddcc9d6ded0edaaf5c772d8bca0ec64bbd9256a4fbc3c6b34b4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientationList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientationList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f066f56d9cecd1b93b28da9b8b226666bdc68c7aefde349cfe791bcce93a1aa6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientationOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__06615c13896b016f1b22c87ce5176a30f178fedeed1da6d4964ff302cbae631b)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientationOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__80c7bc6009a070c8f4c76ff56315ca507f2a05a1690915aba3b7edc7c889e169)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7415bc0c8ce90b7e900456525958fcbce47792094ca401a9c4c0c9cf9bd18c29)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__73f3041f5ed8aaffd8449f912e4ab90132a8083c131551964dc16649620f4547)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientation]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientation]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6eb453c78d1e0e0722786ad4a312a391ebabdd3ecb608a7b0a8cc43a7446f2ce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__71fd4ac3af7696f4295cea9201de7d9637808a2778df5b551a0c39f3645c98c2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientationDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putLandscape")
    def put_landscape(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientationLandscape()

        return typing.cast(None, jsii.invoke(self, "putLandscape", [value]))

    @jsii.member(jsii_name="putPortrait")
    def put_portrait(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientationPortrait()

        return typing.cast(None, jsii.invoke(self, "putPortrait", [value]))

    @jsii.member(jsii_name="putSquare")
    def put_square(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientationSquare()

        return typing.cast(None, jsii.invoke(self, "putSquare", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetLandscape")
    def reset_landscape(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLandscape", []))

    @jsii.member(jsii_name="resetPortrait")
    def reset_portrait(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPortrait", []))

    @jsii.member(jsii_name="resetSquare")
    def reset_square(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSquare", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientationDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientationDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="landscape")
    def landscape(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientationLandscapeOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientationLandscapeOutputReference, jsii.get(self, "landscape"))

    @builtins.property
    @jsii.member(jsii_name="portrait")
    def portrait(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientationPortraitOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientationPortraitOutputReference", jsii.get(self, "portrait"))

    @builtins.property
    @jsii.member(jsii_name="square")
    def square(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientationSquareOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientationSquareOutputReference", jsii.get(self, "square"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientationDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="landscapeInput")
    def landscape_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientationLandscape], jsii.get(self, "landscapeInput"))

    @builtins.property
    @jsii.member(jsii_name="portraitInput")
    def portrait_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientationPortrait"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientationPortrait"], jsii.get(self, "portraitInput"))

    @builtins.property
    @jsii.member(jsii_name="squareInput")
    def square_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientationSquare"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientationSquare"], jsii.get(self, "squareInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientation]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientation]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientation]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac6887f9f7439defc96900f96ee4992d3e0b2801c1131ff5b8eb1b1f2ce0b9c1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientationPortrait",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientationPortrait:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientationPortrait(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientationPortraitOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientationPortraitOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fb298353fc2de9beb4209508fcec2f3d9fa72a4fb660cd87585b00605da9e89a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientationPortrait]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientationPortrait], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientationPortrait],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d49f6e088a84355a227f824bc9860621c11d8ce22ca6fecfe9dec7f78e635eb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientationSquare",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientationSquare:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientationSquare(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientationSquareOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientationSquareOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f3441fb6930cda6fbbaa1afbc1a40a1c8adf3612b46ff7acfadc5f6ba3d7390a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientationSquare]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientationSquare], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientationSquare],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0f857e231e7930e3a4b12b647046f5ee2723d2490f70446d8bca98443c498b99)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeImQuery",
    jsii_struct_bases=[],
    name_mapping={
        "allowed_transformations": "allowedTransformations",
        "query_var": "queryVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeImQuery:
    def __init__(
        self,
        *,
        allowed_transformations: typing.Sequence[builtins.str],
        query_var: builtins.str,
    ) -> None:
        '''
        :param allowed_transformations: Specifies the transformations that can be applied using the query string parameter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allowed_transformations DataAkamaiImagingPolicyImage#allowed_transformations}
        :param query_var: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#query_var DataAkamaiImagingPolicyImage#query_var}.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1b5318ea512fc7b5fa76bf56535cda63d8d2e805d28ebe5574f21aa7d977b7b6)
            check_type(argname="argument allowed_transformations", value=allowed_transformations, expected_type=type_hints["allowed_transformations"])
            check_type(argname="argument query_var", value=query_var, expected_type=type_hints["query_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "allowed_transformations": allowed_transformations,
            "query_var": query_var,
        }

    @builtins.property
    def allowed_transformations(self) -> typing.List[builtins.str]:
        '''Specifies the transformations that can be applied using the query string parameter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allowed_transformations DataAkamaiImagingPolicyImage#allowed_transformations}
        '''
        result = self._values.get("allowed_transformations")
        assert result is not None, "Required property 'allowed_transformations' is missing"
        return typing.cast(typing.List[builtins.str], result)

    @builtins.property
    def query_var(self) -> builtins.str:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#query_var DataAkamaiImagingPolicyImage#query_var}.'''
        result = self._values.get("query_var")
        assert result is not None, "Required property 'query_var' is missing"
        return typing.cast(builtins.str, result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeImQuery(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeImQueryList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeImQueryList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ba27d7189140277e4e9b030e3c57d4e7459075d549ab090beb186486c56d1ab9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeImQueryOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__408efc524abc26940f45aa4b21a17932fd35a645121c0eaa45441718adf9209a)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeImQueryOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f47420ce29a3ab74a0a1c615a4d36c1ade632a3899caad0a093872c7671113a2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__768554ce133be54b8f62f81e9326e4ab4dbea42ea47dfc3980243db5be7c4f1c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2024bc593726845b4fd0edcafe4940bddd28b2edcf319b2ba284c54688e7bcd5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeImQuery]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeImQuery]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeImQuery]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__652574fa0d7acbbdcb1f2011459022d136b54234593558be274a5a7a66b34f81)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeImQueryOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeImQueryOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a4f507ed2579b330efdc15f88e568f5a0276652fd42323cf940d0eb49e9b7d64)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @builtins.property
    @jsii.member(jsii_name="allowedTransformationsInput")
    def allowed_transformations_input(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "allowedTransformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="queryVarInput")
    def query_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "queryVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowedTransformations")
    def allowed_transformations(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "allowedTransformations"))

    @allowed_transformations.setter
    def allowed_transformations(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7761c26ad56ffe33f314acfbdfb26762655ce90e5421ae8f8efa7006188408ab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowedTransformations", value)

    @builtins.property
    @jsii.member(jsii_name="queryVar")
    def query_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "queryVar"))

    @query_var.setter
    def query_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5b83d521825a4cf24d6de56bdf4091ef0fe8c5762b08cee5a9ac9f64d242ceae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "queryVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeImQuery]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeImQuery]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeImQuery]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ab9db9216335465e8d06543b93a844c6a73883befd16ffaa1c6c62ac31117a6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeMaxColors",
    jsii_struct_bases=[],
    name_mapping={"colors": "colors", "colors_var": "colorsVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeMaxColors:
    def __init__(
        self,
        *,
        colors: typing.Optional[builtins.str] = None,
        colors_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param colors: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        :param colors_var: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aa2bddb1b7796c6ec8caad46480ca82fa3e6db7becf817f661365706e5b2e3f0)
            check_type(argname="argument colors", value=colors, expected_type=type_hints["colors"])
            check_type(argname="argument colors_var", value=colors_var, expected_type=type_hints["colors_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if colors is not None:
            self._values["colors"] = colors
        if colors_var is not None:
            self._values["colors_var"] = colors_var

    @builtins.property
    def colors(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        '''
        result = self._values.get("colors")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def colors_var(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        result = self._values.get("colors_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeMaxColors(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeMaxColorsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeMaxColorsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bec9da0dbf93c2d481b923172e297faaa351709c2ac1e04ed942337120e03bcd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeMaxColorsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cdbc342616a58729fd21103df8e3d536828662f4e49ba4e2fb5a4c4321b9015a)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeMaxColorsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__93fea4a836069b6cde2c87399f176859e70f9842e3c067867dc05edad302be6a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0275b130297dd4ace9c8a559f8ef93eb2a4c7ec16ae388719542a35a8cb4c295)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d7d41b9f163edf9af5305a18d478805e434a18adb43b21d25d6b7dde91d3c6fa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeMaxColors]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeMaxColors]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a381efdb74df567487441862df27922b66b46e504a294fcc9e2642bde697cd4b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeMaxColorsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeMaxColorsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__55ef188c1be5c56bc067657a82d47f9251b0198f37d4a3f3de62e4344e5d02dd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColors")
    def reset_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColors", []))

    @jsii.member(jsii_name="resetColorsVar")
    def reset_colors_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorsVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorsInput")
    def colors_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsInput"))

    @builtins.property
    @jsii.member(jsii_name="colorsVarInput")
    def colors_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsVarInput"))

    @builtins.property
    @jsii.member(jsii_name="colors")
    def colors(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colors"))

    @colors.setter
    def colors(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f3937e02b1add592d5758cf088b411de37ad48e51e4d9b43ba48b0f824a3d83c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colors", value)

    @builtins.property
    @jsii.member(jsii_name="colorsVar")
    def colors_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorsVar"))

    @colors_var.setter
    def colors_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__218a4a33d120017c3c4a13a23c6a27b3b20bdf1423a5ca747df5ebe4990883fc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorsVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeMaxColors]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeMaxColors]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeMaxColors]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__27565ba38816c5cc2aad28d52890aae155a6e23c44bf5d9b902c2e943043c5a1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeMirror",
    jsii_struct_bases=[],
    name_mapping={
        "horizontal": "horizontal",
        "horizontal_var": "horizontalVar",
        "vertical": "vertical",
        "vertical_var": "verticalVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeMirror:
    def __init__(
        self,
        *,
        horizontal: typing.Optional[builtins.str] = None,
        horizontal_var: typing.Optional[builtins.str] = None,
        vertical: typing.Optional[builtins.str] = None,
        vertical_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param horizontal: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        :param horizontal_var: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        :param vertical: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        :param vertical_var: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__40f5018a46c17612ef31c8f0363f84e491b1614060ac95560402525edd20e4d5)
            check_type(argname="argument horizontal", value=horizontal, expected_type=type_hints["horizontal"])
            check_type(argname="argument horizontal_var", value=horizontal_var, expected_type=type_hints["horizontal_var"])
            check_type(argname="argument vertical", value=vertical, expected_type=type_hints["vertical"])
            check_type(argname="argument vertical_var", value=vertical_var, expected_type=type_hints["vertical_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if horizontal is not None:
            self._values["horizontal"] = horizontal
        if horizontal_var is not None:
            self._values["horizontal_var"] = horizontal_var
        if vertical is not None:
            self._values["vertical"] = vertical
        if vertical_var is not None:
            self._values["vertical_var"] = vertical_var

    @builtins.property
    def horizontal(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        '''
        result = self._values.get("horizontal")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def horizontal_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        '''
        result = self._values.get("horizontal_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        '''
        result = self._values.get("vertical")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        result = self._values.get("vertical_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeMirror(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeMirrorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeMirrorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__25ec9b597237c4b682a2e538a545791b2e7a8e12343803386d8823a34e9a16a0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeMirrorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__261606b3bd74b35e9e18ff0e41ef8a2b04baa4c54c7cf1432205973d8a7bb1c1)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeMirrorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d6e6efd7aef8cb7b0893006e66da521bfe0a8e4c2b4441d3600e18bd2d6caa9d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__38453f195ffcbb95281c5db55817dc82f7238744c2135b9a318d1af42b3c40c6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f9feb234451d4c64b4655e5c75cf6a225d7f3fe070c81a96f7f0fe7f204fef27)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeMirror]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeMirror]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4e51e05ff5691a029904036fde861ccc8faab37a16b2fa1ffb6f38418611a5e2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeMirrorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeMirrorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__094a8167f4e6e0a3605fe1fdde159a1d746785457e554525ff33fc0850ec372a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHorizontal")
    def reset_horizontal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontal", []))

    @jsii.member(jsii_name="resetHorizontalVar")
    def reset_horizontal_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontalVar", []))

    @jsii.member(jsii_name="resetVertical")
    def reset_vertical(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVertical", []))

    @jsii.member(jsii_name="resetVerticalVar")
    def reset_vertical_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVerticalVar", []))

    @builtins.property
    @jsii.member(jsii_name="horizontalInput")
    def horizontal_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontalVarInput")
    def horizontal_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalInput")
    def vertical_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalVarInput")
    def vertical_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontal")
    def horizontal(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontal"))

    @horizontal.setter
    def horizontal(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f1ec3324c061ce03ab55721fe4c6e39667e888e83bc3228ea4f9681e309321aa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontal", value)

    @builtins.property
    @jsii.member(jsii_name="horizontalVar")
    def horizontal_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontalVar"))

    @horizontal_var.setter
    def horizontal_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d99160424cd7125618658b6788b9ba76d139fb5688f654bd456a445c72f8dca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontalVar", value)

    @builtins.property
    @jsii.member(jsii_name="vertical")
    def vertical(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "vertical"))

    @vertical.setter
    def vertical(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__296de67c50e506cc799fb8d684bbbf913ee15ce7e929117be395ae7a29d2abb0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "vertical", value)

    @builtins.property
    @jsii.member(jsii_name="verticalVar")
    def vertical_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "verticalVar"))

    @vertical_var.setter
    def vertical_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df4a7cccd1d8ff414e6e80a10f468794567169436cbbf9f49b235b098ed5bca6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "verticalVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeMirror]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeMirror]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeMirror]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a5a33745e1f38b46483984329af49b7199f10cdae925d62aa0d5b25525d8cf0b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeMonoHue",
    jsii_struct_bases=[],
    name_mapping={"hue": "hue", "hue_var": "hueVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeMonoHue:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__acc05bed85e427a1f243c2f2f1338bee9b27ba974b3a59a33e9af1575d2dd0e5)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeMonoHue(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeMonoHueList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeMonoHueList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__90ee953b8d4878dad2cfaae9724c3cb5227efb1aa96546277b64567a974dd8cd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeMonoHueOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__261af48b0e0cebd2c995b27457cbd119f2b8cb0c7e86da064c30b73ca5e18da9)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeMonoHueOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5455a896ecb6860ea661337e8670ea7d16f2d95813853f2ffdb57319de514439)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__48d1d7633ebb3f8de27e4f77730b406d06ed6e41e679ebc0327b33dcd385dd07)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0572781974c20b6698b9a56f5848457c7172dd2e816f4f49d6b161285d5638d4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeMonoHue]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeMonoHue]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f70bbbf36a1cf428e6a237de7a156168df990d6afe85882ae3aedb0ef9654767)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeMonoHueOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeMonoHueOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e5825c430b317bc6e41fe694b6ba81c302f5d345c2ba4e4c3540a8570568d0df)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d1f4d5a8dad1dafcbf6dbdbfb1dd12de0e1a4658ba74b612f1f98e5c35b0c6e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a39f1c48971b838187674eca3025aea4b4ccf99f87ebe649603d9cea32e942f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeMonoHue]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeMonoHue]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeMonoHue]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5068bdbd0c3087973cd5d7538d12fda970d360f2f42983eeded55dfaa068a7b5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeOpacity",
    jsii_struct_bases=[],
    name_mapping={"opacity": "opacity", "opacity_var": "opacityVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeOpacity:
    def __init__(
        self,
        *,
        opacity: typing.Optional[builtins.str] = None,
        opacity_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param opacity: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param opacity_var: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e5af81d7b975c55c15ea9cf033365f7e7317ebbf2e6eb5db9dba38c19fa94290)
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument opacity_var", value=opacity_var, expected_type=type_hints["opacity_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if opacity is not None:
            self._values["opacity"] = opacity
        if opacity_var is not None:
            self._values["opacity_var"] = opacity_var

    @builtins.property
    def opacity(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def opacity_var(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        result = self._values.get("opacity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeOpacity(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeOpacityList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeOpacityList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__66c70981df4d798d5899e565db210d5b3079043b55ee4e70f3b20fb0156ae775)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeOpacityOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9920b522aaa1db95cf86d08205a56ba568b776f237690f47685bcfe25525dad4)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeOpacityOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f9966d1d24877579c28e5628f12c6675a02d7b5387f50d59d2de4de4a0111f8a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__362b3fc18792071076b91634c54d98800f6a3902331407d598dccd1d120d2a81)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1d3cf4c6a16575766d469f8d5ccb043737dd4cc3117528bb0c18d84f9d9ed7ea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeOpacity]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeOpacity]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a4dedb41927a724f73a340173ffe41ce5c10200766fee962b9e2b2ff941f9edb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeOpacityOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeOpacityOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f9cbfe0768a03048557d96a85cfdc4a838442b0e47dfb61a1beacc4c5c64ea85)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetOpacityVar")
    def reset_opacity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacityVar", []))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityVarInput")
    def opacity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacity"))

    @opacity.setter
    def opacity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__935dd3b8691f3d1d7d346ab6bc4d0debeebfb560f6eca32ac55d3ddeffe87b41)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacity", value)

    @builtins.property
    @jsii.member(jsii_name="opacityVar")
    def opacity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacityVar"))

    @opacity_var.setter
    def opacity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b96616763e474ee97d7ab5a069bec3f6ae831c108b0d85a2b7d48db59842ffab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacityVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeOpacity]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeOpacity]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeOpacity]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a3102315f9d13b7d815b8765131008fc7e4e07a6939336a656a91c11de1a3a3d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f5be480cdd8d4ee970ec64dd27c05e581b326be798c5cc76c7f18850a5bde21d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putAppend")
    def put_append(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeAppend, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__32f8e463f36898d5b3878b6ef96eb32086a1e5ea27194ea741acbb17f8c55436)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putAppend", [value]))

    @jsii.member(jsii_name="putAspectCrop")
    def put_aspect_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeAspectCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5bdae1710fd0df5591e4e1d7a5bc654269a07cddc0d906580a1ed0d714bb0f6f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putAspectCrop", [value]))

    @jsii.member(jsii_name="putBackgroundColor")
    def put_background_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6b98e6b55805453b44d98a5f548a0cd3ae477c3c3952fc90bc9d03fc60c6ed40)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBackgroundColor", [value]))

    @jsii.member(jsii_name="putBlur")
    def put_blur(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeBlur, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__db349ab04b9defc9fe900465b333bdb7eeef01ab39dec037866d547f9c104435)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBlur", [value]))

    @jsii.member(jsii_name="putChromaKey")
    def put_chroma_key(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeChromaKey, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5e9c1e870dbadde11693f8b0e56ea4168d58dd7732c76554390f82d73a90aac7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putChromaKey", [value]))

    @jsii.member(jsii_name="putComposite")
    def put_composite(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeComposite, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c9ae48b1baeca46d16fa36b33b11decd41d6d54df831df75350e969578248963)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putComposite", [value]))

    @jsii.member(jsii_name="putCompound")
    def put_compound(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCompound, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__65deb593270283425f88301582bf1988305839f4dc890beeadeedd90cedeb25f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCompound", [value]))

    @jsii.member(jsii_name="putContrast")
    def put_contrast(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeContrast, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0b729ec7a63b154282fbe339196099b9537fea5f9df2a165923c18ff2444978a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putContrast", [value]))

    @jsii.member(jsii_name="putCrop")
    def put_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c37abfbe9c2fa83e23d9989dfd0ad02e3d3ed6d0cd55880cb0da0a4f9fb46619)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCrop", [value]))

    @jsii.member(jsii_name="putFaceCrop")
    def put_face_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeFaceCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cec3e3685fa9389e17686e05cfdf250d3632ba92769fa7085578ac09343dcf61)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFaceCrop", [value]))

    @jsii.member(jsii_name="putFeatureCrop")
    def put_feature_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeFeatureCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3fd0e61de743f0a0f6507b956eed12eaa559cd705f6990effe49ef20fd7f6880)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFeatureCrop", [value]))

    @jsii.member(jsii_name="putFitAndFill")
    def put_fit_and_fill(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeFitAndFill, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c3c7f2f1a3f55cdd28da65a6de918afeb1620db6585038dbb42bd833404a6267)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFitAndFill", [value]))

    @jsii.member(jsii_name="putGoop")
    def put_goop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeGoop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8b00b8b6cf182e0fc82a7b151dfb600bde2766b1b3a7b0442a1ba6c9a8ecee82)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGoop", [value]))

    @jsii.member(jsii_name="putGrayscale")
    def put_grayscale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeGrayscale, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7370ac6b0087149d34b42e7aa0f5e0783476d4e47e1e7959092d95d9bc5caa2a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGrayscale", [value]))

    @jsii.member(jsii_name="putHsl")
    def put_hsl(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeHsl, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__869619be5b91b2d36e964d69cab79beb1a5e2da1aec279387a9c1d61e4144bbd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsl", [value]))

    @jsii.member(jsii_name="putHsv")
    def put_hsv(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeHsv, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b5429ee223ec88b7a7b2a70f328d57db9a10a8c8573ec15d6b37b9a7a613491a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsv", [value]))

    @jsii.member(jsii_name="putIfDimension")
    def put_if_dimension(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimension, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__776b1d6e49c730c0891d2e2de74d01927137905f15eb5e8b04866eee39fcf5b1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfDimension", [value]))

    @jsii.member(jsii_name="putIfOrientation")
    def put_if_orientation(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6600034ecfee7dffd2ecd2f60ebbd93f0cfbab7c5474326a870f76477cb518d2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfOrientation", [value]))

    @jsii.member(jsii_name="putImQuery")
    def put_im_query(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeImQuery, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__757534dc729588718adef0722c9b2c59db4ac6927fa7f803b2a991a075bbe644)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putImQuery", [value]))

    @jsii.member(jsii_name="putMaxColors")
    def put_max_colors(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeMaxColors, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__101044b01bb4c8e9e27a6787d332b82d276d82e684c27dbb373db99add596575)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMaxColors", [value]))

    @jsii.member(jsii_name="putMirror")
    def put_mirror(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeMirror, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__73ad51802dd2a4def524ff11a8d4e9af169041e8490d2022f7db525a4e3ae4a1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMirror", [value]))

    @jsii.member(jsii_name="putMonoHue")
    def put_mono_hue(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeMonoHue, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5d8fe57a6b4de20d3034420f0cecc8c268b0bc467f1a1693c1ecd9c89cee8eb3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMonoHue", [value]))

    @jsii.member(jsii_name="putOpacity")
    def put_opacity(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeOpacity, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ccc07ccdfa64253f846f10a0e662d763062205fd544de95a4d47c5e568ba2676)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putOpacity", [value]))

    @jsii.member(jsii_name="putRegionOfInterestCrop")
    def put_region_of_interest_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRegionOfInterestCrop", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7e3bd988a2570b819d2b7f9b58e6cbd35e2ca82406b861b479901fe6479c8b9e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRegionOfInterestCrop", [value]))

    @jsii.member(jsii_name="putRelativeCrop")
    def put_relative_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRelativeCrop", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__67f58fa69042efcfcff18ca2a4dd3ee519c68866130525015927f3a25b8b25e2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRelativeCrop", [value]))

    @jsii.member(jsii_name="putRemoveColor")
    def put_remove_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRemoveColor", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__46582a20f8490aa8f7afc5f65aa739b81e438b24ce7f04e1002f1612e2003f91)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRemoveColor", [value]))

    @jsii.member(jsii_name="putResize")
    def put_resize(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeResize", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7859a1c5c32698c4f9513197ee09a1bfe95b5665a8885d8e7ac5bbd36f61107a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putResize", [value]))

    @jsii.member(jsii_name="putRotate")
    def put_rotate(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRotate", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__02c10881910e56628b170818c784bfc69cc3a7b8576ed5591c0dca3fefcf6aa6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRotate", [value]))

    @jsii.member(jsii_name="putScale")
    def put_scale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeScale", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1897cad3366eb8167639c398fdf9f02e7a837cf4d252d98b80a4ed9061250451)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putScale", [value]))

    @jsii.member(jsii_name="putShear")
    def put_shear(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeShear", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__01a37230ad00e3efea4863b0283a28910cb7f980dd0fe25ffc00edba3a5413f3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putShear", [value]))

    @jsii.member(jsii_name="putTrim")
    def put_trim(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeTrim", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8405661b2ab9491c4416abd1f3367fbb891aa5ee7564439291a33e4a4ea8804c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTrim", [value]))

    @jsii.member(jsii_name="putUnsharpMask")
    def put_unsharp_mask(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeUnsharpMask", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a5d7363d9172c8cc213bc43f0f76a9d91cb2b759b643918783340e54656bdbf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putUnsharpMask", [value]))

    @jsii.member(jsii_name="resetAppend")
    def reset_append(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAppend", []))

    @jsii.member(jsii_name="resetAspectCrop")
    def reset_aspect_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspectCrop", []))

    @jsii.member(jsii_name="resetBackgroundColor")
    def reset_background_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBackgroundColor", []))

    @jsii.member(jsii_name="resetBlur")
    def reset_blur(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBlur", []))

    @jsii.member(jsii_name="resetChromaKey")
    def reset_chroma_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChromaKey", []))

    @jsii.member(jsii_name="resetComposite")
    def reset_composite(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetComposite", []))

    @jsii.member(jsii_name="resetCompound")
    def reset_compound(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCompound", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetCrop")
    def reset_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCrop", []))

    @jsii.member(jsii_name="resetFaceCrop")
    def reset_face_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFaceCrop", []))

    @jsii.member(jsii_name="resetFeatureCrop")
    def reset_feature_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureCrop", []))

    @jsii.member(jsii_name="resetFitAndFill")
    def reset_fit_and_fill(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFitAndFill", []))

    @jsii.member(jsii_name="resetGoop")
    def reset_goop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGoop", []))

    @jsii.member(jsii_name="resetGrayscale")
    def reset_grayscale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGrayscale", []))

    @jsii.member(jsii_name="resetHsl")
    def reset_hsl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsl", []))

    @jsii.member(jsii_name="resetHsv")
    def reset_hsv(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsv", []))

    @jsii.member(jsii_name="resetIfDimension")
    def reset_if_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfDimension", []))

    @jsii.member(jsii_name="resetIfOrientation")
    def reset_if_orientation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfOrientation", []))

    @jsii.member(jsii_name="resetImQuery")
    def reset_im_query(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetImQuery", []))

    @jsii.member(jsii_name="resetMaxColors")
    def reset_max_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxColors", []))

    @jsii.member(jsii_name="resetMirror")
    def reset_mirror(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMirror", []))

    @jsii.member(jsii_name="resetMonoHue")
    def reset_mono_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonoHue", []))

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetRegionOfInterestCrop")
    def reset_region_of_interest_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRegionOfInterestCrop", []))

    @jsii.member(jsii_name="resetRelativeCrop")
    def reset_relative_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRelativeCrop", []))

    @jsii.member(jsii_name="resetRemoveColor")
    def reset_remove_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRemoveColor", []))

    @jsii.member(jsii_name="resetResize")
    def reset_resize(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetResize", []))

    @jsii.member(jsii_name="resetRotate")
    def reset_rotate(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRotate", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetShear")
    def reset_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetShear", []))

    @jsii.member(jsii_name="resetTrim")
    def reset_trim(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTrim", []))

    @jsii.member(jsii_name="resetUnsharpMask")
    def reset_unsharp_mask(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUnsharpMask", []))

    @builtins.property
    @jsii.member(jsii_name="append")
    def append(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeAppendList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeAppendList, jsii.get(self, "append"))

    @builtins.property
    @jsii.member(jsii_name="aspectCrop")
    def aspect_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeAspectCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeAspectCropList, jsii.get(self, "aspectCrop"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColor")
    def background_color(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeBackgroundColorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeBackgroundColorList, jsii.get(self, "backgroundColor"))

    @builtins.property
    @jsii.member(jsii_name="blur")
    def blur(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeBlurList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeBlurList, jsii.get(self, "blur"))

    @builtins.property
    @jsii.member(jsii_name="chromaKey")
    def chroma_key(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeChromaKeyList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeChromaKeyList, jsii.get(self, "chromaKey"))

    @builtins.property
    @jsii.member(jsii_name="composite")
    def composite(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCompositeList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCompositeList, jsii.get(self, "composite"))

    @builtins.property
    @jsii.member(jsii_name="compound")
    def compound(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCompoundList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCompoundList, jsii.get(self, "compound"))

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeContrastList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeContrastList, jsii.get(self, "contrast"))

    @builtins.property
    @jsii.member(jsii_name="crop")
    def crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCropList, jsii.get(self, "crop"))

    @builtins.property
    @jsii.member(jsii_name="faceCrop")
    def face_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeFaceCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeFaceCropList, jsii.get(self, "faceCrop"))

    @builtins.property
    @jsii.member(jsii_name="featureCrop")
    def feature_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeFeatureCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeFeatureCropList, jsii.get(self, "featureCrop"))

    @builtins.property
    @jsii.member(jsii_name="fitAndFill")
    def fit_and_fill(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeFitAndFillList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeFitAndFillList, jsii.get(self, "fitAndFill"))

    @builtins.property
    @jsii.member(jsii_name="goop")
    def goop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeGoopList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeGoopList, jsii.get(self, "goop"))

    @builtins.property
    @jsii.member(jsii_name="grayscale")
    def grayscale(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeGrayscaleList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeGrayscaleList, jsii.get(self, "grayscale"))

    @builtins.property
    @jsii.member(jsii_name="hsl")
    def hsl(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeHslList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeHslList, jsii.get(self, "hsl"))

    @builtins.property
    @jsii.member(jsii_name="hsv")
    def hsv(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeHsvList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeHsvList, jsii.get(self, "hsv"))

    @builtins.property
    @jsii.member(jsii_name="ifDimension")
    def if_dimension(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimensionList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimensionList, jsii.get(self, "ifDimension"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientation")
    def if_orientation(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientationList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientationList, jsii.get(self, "ifOrientation"))

    @builtins.property
    @jsii.member(jsii_name="imQuery")
    def im_query(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeImQueryList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeImQueryList, jsii.get(self, "imQuery"))

    @builtins.property
    @jsii.member(jsii_name="maxColors")
    def max_colors(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeMaxColorsList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeMaxColorsList, jsii.get(self, "maxColors"))

    @builtins.property
    @jsii.member(jsii_name="mirror")
    def mirror(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeMirrorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeMirrorList, jsii.get(self, "mirror"))

    @builtins.property
    @jsii.member(jsii_name="monoHue")
    def mono_hue(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeMonoHueList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeMonoHueList, jsii.get(self, "monoHue"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeOpacityList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeOpacityList, jsii.get(self, "opacity"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestCrop")
    def region_of_interest_crop(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRegionOfInterestCropList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRegionOfInterestCropList", jsii.get(self, "regionOfInterestCrop"))

    @builtins.property
    @jsii.member(jsii_name="relativeCrop")
    def relative_crop(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRelativeCropList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRelativeCropList", jsii.get(self, "relativeCrop"))

    @builtins.property
    @jsii.member(jsii_name="removeColor")
    def remove_color(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRemoveColorList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRemoveColorList", jsii.get(self, "removeColor"))

    @builtins.property
    @jsii.member(jsii_name="resize")
    def resize(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeResizeList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeResizeList", jsii.get(self, "resize"))

    @builtins.property
    @jsii.member(jsii_name="rotate")
    def rotate(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRotateList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRotateList", jsii.get(self, "rotate"))

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeScaleList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeScaleList", jsii.get(self, "scale"))

    @builtins.property
    @jsii.member(jsii_name="shear")
    def shear(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeShearList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeShearList", jsii.get(self, "shear"))

    @builtins.property
    @jsii.member(jsii_name="trim")
    def trim(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeTrimList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeTrimList", jsii.get(self, "trim"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMask")
    def unsharp_mask(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeUnsharpMaskList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeUnsharpMaskList", jsii.get(self, "unsharpMask"))

    @builtins.property
    @jsii.member(jsii_name="appendInput")
    def append_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeAppend]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeAppend]]], jsii.get(self, "appendInput"))

    @builtins.property
    @jsii.member(jsii_name="aspectCropInput")
    def aspect_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeAspectCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeAspectCrop]]], jsii.get(self, "aspectCropInput"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColorInput")
    def background_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeBackgroundColor]]], jsii.get(self, "backgroundColorInput"))

    @builtins.property
    @jsii.member(jsii_name="blurInput")
    def blur_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeBlur]]], jsii.get(self, "blurInput"))

    @builtins.property
    @jsii.member(jsii_name="chromaKeyInput")
    def chroma_key_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeChromaKey]]], jsii.get(self, "chromaKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="compositeInput")
    def composite_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeComposite]]], jsii.get(self, "compositeInput"))

    @builtins.property
    @jsii.member(jsii_name="compoundInput")
    def compound_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCompound]]], jsii.get(self, "compoundInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeContrast]]], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="cropInput")
    def crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCrop]]], jsii.get(self, "cropInput"))

    @builtins.property
    @jsii.member(jsii_name="faceCropInput")
    def face_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeFaceCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeFaceCrop]]], jsii.get(self, "faceCropInput"))

    @builtins.property
    @jsii.member(jsii_name="featureCropInput")
    def feature_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeFeatureCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeFeatureCrop]]], jsii.get(self, "featureCropInput"))

    @builtins.property
    @jsii.member(jsii_name="fitAndFillInput")
    def fit_and_fill_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeFitAndFill]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeFitAndFill]]], jsii.get(self, "fitAndFillInput"))

    @builtins.property
    @jsii.member(jsii_name="goopInput")
    def goop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeGoop]]], jsii.get(self, "goopInput"))

    @builtins.property
    @jsii.member(jsii_name="grayscaleInput")
    def grayscale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeGrayscale]]], jsii.get(self, "grayscaleInput"))

    @builtins.property
    @jsii.member(jsii_name="hslInput")
    def hsl_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeHsl]]], jsii.get(self, "hslInput"))

    @builtins.property
    @jsii.member(jsii_name="hsvInput")
    def hsv_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeHsv]]], jsii.get(self, "hsvInput"))

    @builtins.property
    @jsii.member(jsii_name="ifDimensionInput")
    def if_dimension_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimension]]], jsii.get(self, "ifDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientationInput")
    def if_orientation_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientation]]], jsii.get(self, "ifOrientationInput"))

    @builtins.property
    @jsii.member(jsii_name="imQueryInput")
    def im_query_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeImQuery]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeImQuery]]], jsii.get(self, "imQueryInput"))

    @builtins.property
    @jsii.member(jsii_name="maxColorsInput")
    def max_colors_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeMaxColors]]], jsii.get(self, "maxColorsInput"))

    @builtins.property
    @jsii.member(jsii_name="mirrorInput")
    def mirror_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeMirror]]], jsii.get(self, "mirrorInput"))

    @builtins.property
    @jsii.member(jsii_name="monoHueInput")
    def mono_hue_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeMonoHue]]], jsii.get(self, "monoHueInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeOpacity]]], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestCropInput")
    def region_of_interest_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRegionOfInterestCrop"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRegionOfInterestCrop"]]], jsii.get(self, "regionOfInterestCropInput"))

    @builtins.property
    @jsii.member(jsii_name="relativeCropInput")
    def relative_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRelativeCrop"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRelativeCrop"]]], jsii.get(self, "relativeCropInput"))

    @builtins.property
    @jsii.member(jsii_name="removeColorInput")
    def remove_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRemoveColor"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRemoveColor"]]], jsii.get(self, "removeColorInput"))

    @builtins.property
    @jsii.member(jsii_name="resizeInput")
    def resize_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeResize"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeResize"]]], jsii.get(self, "resizeInput"))

    @builtins.property
    @jsii.member(jsii_name="rotateInput")
    def rotate_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRotate"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRotate"]]], jsii.get(self, "rotateInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeScale"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeScale"]]], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="shearInput")
    def shear_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeShear"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeShear"]]], jsii.get(self, "shearInput"))

    @builtins.property
    @jsii.member(jsii_name="trimInput")
    def trim_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeTrim"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeTrim"]]], jsii.get(self, "trimInput"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMaskInput")
    def unsharp_mask_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeUnsharpMask"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeUnsharpMask"]]], jsii.get(self, "unsharpMaskInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscape], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscape],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__16c17c66c2d34acfa8a67e920c34bb01a54928d44718eaf2186a3beb15acc35e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRegionOfInterestCrop",
    jsii_struct_bases=[],
    name_mapping={
        "region_of_interest": "regionOfInterest",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRegionOfInterestCrop:
    def __init__(
        self,
        *,
        region_of_interest: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRegionOfInterestCropRegionOfInterest", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param region_of_interest: region_of_interest block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest DataAkamaiImagingPolicyImage#region_of_interest}
        :param gravity: The placement of the crop area relative to the specified area of interest. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: The placement of the crop area relative to the specified area of interest. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param style: Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(region_of_interest, dict):
            region_of_interest = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRegionOfInterestCropRegionOfInterest(**region_of_interest)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__42ea124cadb7faf409503439c02fa80ef9203d4a7342495276bf950fc7ecc693)
            check_type(argname="argument region_of_interest", value=region_of_interest, expected_type=type_hints["region_of_interest"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "region_of_interest": region_of_interest,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def region_of_interest(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRegionOfInterestCropRegionOfInterest":
        '''region_of_interest block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest DataAkamaiImagingPolicyImage#region_of_interest}
        '''
        result = self._values.get("region_of_interest")
        assert result is not None, "Required property 'region_of_interest' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRegionOfInterestCropRegionOfInterest", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''The placement of the crop area relative to the specified area of interest.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''The placement of the crop area relative to the specified area of interest.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRegionOfInterestCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRegionOfInterestCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRegionOfInterestCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1fbf58ed1a9292c2fed300efb72aa3ec2d055896286ba4616eccd197252e2346)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRegionOfInterestCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__21ecbe1094c0de829a8b34c1601f1a817c09b7b70de8c0c029b0ad965225108c)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRegionOfInterestCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a864965134179ac83377eb4ebc29b10466d5616393926eafd1c6ab31f5a8206f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc23dd82a4bf38c880bb3e957698f2c3f09a4ed2fbbed5b67007b290444b186d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e989a1706a3e6c0a85f4dc04d3e2cc5b9cd1da0dd2dba324dbbfcd9f0d55e359)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRegionOfInterestCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRegionOfInterestCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRegionOfInterestCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0a536cdc6204dff1ca149af7c0e3b3097db4122d3af7a98263eec61373e51863)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRegionOfInterestCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRegionOfInterestCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__126bc7c3df0cca8234b69fd78ba518676dc232bfc05294f3852f0fa75b449e5d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putRegionOfInterest")
    def put_region_of_interest(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRegionOfInterestCropRegionOfInterest()

        return typing.cast(None, jsii.invoke(self, "putRegionOfInterest", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterest")
    def region_of_interest(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRegionOfInterestCropRegionOfInterestOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRegionOfInterestCropRegionOfInterestOutputReference", jsii.get(self, "regionOfInterest"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestInput")
    def region_of_interest_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRegionOfInterestCropRegionOfInterest"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRegionOfInterestCropRegionOfInterest"], jsii.get(self, "regionOfInterestInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1ff6a5b2e95cdacac177c9a11d3eeb705d9ce3029e3767c1039e3e5a852feb66)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8346a6f32c01a04473a23be2427c492920e07f996e8ec3f0f7b73eb8567525e9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c285413acb71f53a3dd2af1b6f9192b0f5fbf0dc64bf4a0c7ecb39d0a01286ee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2dafda5efe988004d7f4329196074174b0526c8a68dc9a68e2466d2e572949b0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e8e98543ad92c1a5b83b1e4ee9ee7c1e4659d51259aca28ef3418dcc84a61f6d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c9e4d535260c0367707b7586a9ec10b4dfefd16e3bf9fe5fae7506e7732cb658)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4384c9ee6e510b43c6f6a4bbf55c11ebef7a71574cfdceb8cdf28442aecc1810)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cc96ebea4c406e4279a36e500bcc5dc7a9903c5b1eb64baf627ade0abf35a88a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRegionOfInterestCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRegionOfInterestCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRegionOfInterestCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c460c471bbbdf4f8359eea34efeb5236013f069c0e9554e35745e588e181b4a5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRegionOfInterestCropRegionOfInterest",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRegionOfInterestCropRegionOfInterest:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRegionOfInterestCropRegionOfInterest(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRegionOfInterestCropRegionOfInterestOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRegionOfInterestCropRegionOfInterestOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__906fc98f1e7b9ec0853bc2eca0c95bac36e4d668faf33292762de5e77a6f41d9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRegionOfInterestCropRegionOfInterest]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRegionOfInterestCropRegionOfInterest], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRegionOfInterestCropRegionOfInterest],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__39c13bc8f4cd3b8c4799ed713e5e5195e40f648823d47075b96bb0d1824098a6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRelativeCrop",
    jsii_struct_bases=[],
    name_mapping={
        "east": "east",
        "east_var": "eastVar",
        "north": "north",
        "north_var": "northVar",
        "south": "south",
        "south_var": "southVar",
        "west": "west",
        "west_var": "westVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRelativeCrop:
    def __init__(
        self,
        *,
        east: typing.Optional[builtins.str] = None,
        east_var: typing.Optional[builtins.str] = None,
        north: typing.Optional[builtins.str] = None,
        north_var: typing.Optional[builtins.str] = None,
        south: typing.Optional[builtins.str] = None,
        south_var: typing.Optional[builtins.str] = None,
        west: typing.Optional[builtins.str] = None,
        west_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param east: The number of pixels to shrink or expand the right side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east DataAkamaiImagingPolicyImage#east}
        :param east_var: The number of pixels to shrink or expand the right side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east_var DataAkamaiImagingPolicyImage#east_var}
        :param north: The number of pixels to shrink or expand the top side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north DataAkamaiImagingPolicyImage#north}
        :param north_var: The number of pixels to shrink or expand the top side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north_var DataAkamaiImagingPolicyImage#north_var}
        :param south: The number of pixels to shrink or expand the bottom side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south DataAkamaiImagingPolicyImage#south}
        :param south_var: The number of pixels to shrink or expand the bottom side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south_var DataAkamaiImagingPolicyImage#south_var}
        :param west: The number of pixels to shrink or expand the left side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west DataAkamaiImagingPolicyImage#west}
        :param west_var: The number of pixels to shrink or expand the left side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west_var DataAkamaiImagingPolicyImage#west_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__92a19994b97cbf410d0ef790769095991f42561da144b5e684add94ee5b8452d)
            check_type(argname="argument east", value=east, expected_type=type_hints["east"])
            check_type(argname="argument east_var", value=east_var, expected_type=type_hints["east_var"])
            check_type(argname="argument north", value=north, expected_type=type_hints["north"])
            check_type(argname="argument north_var", value=north_var, expected_type=type_hints["north_var"])
            check_type(argname="argument south", value=south, expected_type=type_hints["south"])
            check_type(argname="argument south_var", value=south_var, expected_type=type_hints["south_var"])
            check_type(argname="argument west", value=west, expected_type=type_hints["west"])
            check_type(argname="argument west_var", value=west_var, expected_type=type_hints["west_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if east is not None:
            self._values["east"] = east
        if east_var is not None:
            self._values["east_var"] = east_var
        if north is not None:
            self._values["north"] = north
        if north_var is not None:
            self._values["north_var"] = north_var
        if south is not None:
            self._values["south"] = south
        if south_var is not None:
            self._values["south_var"] = south_var
        if west is not None:
            self._values["west"] = west
        if west_var is not None:
            self._values["west_var"] = west_var

    @builtins.property
    def east(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the right side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east DataAkamaiImagingPolicyImage#east}
        '''
        result = self._values.get("east")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def east_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the right side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east_var DataAkamaiImagingPolicyImage#east_var}
        '''
        result = self._values.get("east_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def north(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the top side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north DataAkamaiImagingPolicyImage#north}
        '''
        result = self._values.get("north")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def north_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the top side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north_var DataAkamaiImagingPolicyImage#north_var}
        '''
        result = self._values.get("north_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def south(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the bottom side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south DataAkamaiImagingPolicyImage#south}
        '''
        result = self._values.get("south")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def south_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the bottom side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south_var DataAkamaiImagingPolicyImage#south_var}
        '''
        result = self._values.get("south_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def west(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the left side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west DataAkamaiImagingPolicyImage#west}
        '''
        result = self._values.get("west")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def west_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the left side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west_var DataAkamaiImagingPolicyImage#west_var}
        '''
        result = self._values.get("west_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRelativeCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRelativeCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRelativeCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f7473dfd8566bb3a71abc03b1c79a840979c5c539eee9f337f0c2203548f5016)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRelativeCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__04289ef9b40b724b9e401f7b799acd5e09c1fcf7abf9f63252801b49bfdef748)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRelativeCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fb09e99c03aba1f37f5a924b535328ba31b07e3f4353088514a9e2bac461ef00)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__36e3baa2fe1f062c17a17167b7033596fb7978d691503724a04529ed6f6a57d3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1d82988e3b4c037e31d94405b0e2b103ec843db5404138b77c0bc9956034dede)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRelativeCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRelativeCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRelativeCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b3d1f49a8dd10c29bda52516bd196cb3d5c839e2331842f4e9fb32ba6f06e878)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRelativeCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRelativeCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__669e54efa8d478fe25de7abdf47190fc521d02e183e7903e2a33a4b857aa0e30)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetEast")
    def reset_east(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEast", []))

    @jsii.member(jsii_name="resetEastVar")
    def reset_east_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEastVar", []))

    @jsii.member(jsii_name="resetNorth")
    def reset_north(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNorth", []))

    @jsii.member(jsii_name="resetNorthVar")
    def reset_north_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNorthVar", []))

    @jsii.member(jsii_name="resetSouth")
    def reset_south(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSouth", []))

    @jsii.member(jsii_name="resetSouthVar")
    def reset_south_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSouthVar", []))

    @jsii.member(jsii_name="resetWest")
    def reset_west(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWest", []))

    @jsii.member(jsii_name="resetWestVar")
    def reset_west_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWestVar", []))

    @builtins.property
    @jsii.member(jsii_name="eastInput")
    def east_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "eastInput"))

    @builtins.property
    @jsii.member(jsii_name="eastVarInput")
    def east_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "eastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="northInput")
    def north_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "northInput"))

    @builtins.property
    @jsii.member(jsii_name="northVarInput")
    def north_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "northVarInput"))

    @builtins.property
    @jsii.member(jsii_name="southInput")
    def south_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "southInput"))

    @builtins.property
    @jsii.member(jsii_name="southVarInput")
    def south_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "southVarInput"))

    @builtins.property
    @jsii.member(jsii_name="westInput")
    def west_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "westInput"))

    @builtins.property
    @jsii.member(jsii_name="westVarInput")
    def west_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "westVarInput"))

    @builtins.property
    @jsii.member(jsii_name="east")
    def east(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "east"))

    @east.setter
    def east(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b8e32c35cb9407adbdb321402d8be08fd0c28af4311095b972d3e0392cef85db)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "east", value)

    @builtins.property
    @jsii.member(jsii_name="eastVar")
    def east_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "eastVar"))

    @east_var.setter
    def east_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d3aea1c94660c13c2dc6f6242d0e6f135698d10e69983f44d4ec7ca44a17f46b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "eastVar", value)

    @builtins.property
    @jsii.member(jsii_name="north")
    def north(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "north"))

    @north.setter
    def north(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6d84f75ee32499616ae87c29cd67c00ef3835a22e05708a44c11d2b5a5c516fe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "north", value)

    @builtins.property
    @jsii.member(jsii_name="northVar")
    def north_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "northVar"))

    @north_var.setter
    def north_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bf726eeaffed3ee50fe063c4d0315b1bf6309f31a28092f0cc2b4f3195f60288)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "northVar", value)

    @builtins.property
    @jsii.member(jsii_name="south")
    def south(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "south"))

    @south.setter
    def south(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cb5bf6429d652cd4819868c0f78d3ed85036fdea21cff35b1a1e0f56880663c2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "south", value)

    @builtins.property
    @jsii.member(jsii_name="southVar")
    def south_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "southVar"))

    @south_var.setter
    def south_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4cd3cb5b8315fea54eaa6b8d3e4fd783a6912f418739c23dfd4da27cc2f30ce8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "southVar", value)

    @builtins.property
    @jsii.member(jsii_name="west")
    def west(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "west"))

    @west.setter
    def west(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__40f9ced75535b2a5a4103b1d3caa0db0f8be7e95b529689d2579a067cd631659)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "west", value)

    @builtins.property
    @jsii.member(jsii_name="westVar")
    def west_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "westVar"))

    @west_var.setter
    def west_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fee242e76e19e27fddcfb80265701f6b55b53ba3506412ebe264490f3981c224)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "westVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRelativeCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRelativeCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRelativeCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a678a87a916e9cd6868b057576627d12033c1cc8d9701ffc67a9cba62ee3c932)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRemoveColor",
    jsii_struct_bases=[],
    name_mapping={
        "color": "color",
        "color_var": "colorVar",
        "feather": "feather",
        "feather_var": "featherVar",
        "tolerance": "tolerance",
        "tolerance_var": "toleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRemoveColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
        feather: typing.Optional[builtins.str] = None,
        feather_var: typing.Optional[builtins.str] = None,
        tolerance: typing.Optional[builtins.str] = None,
        tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        :param feather: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        :param feather_var: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        :param tolerance: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        :param tolerance_var: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__638d1b8faba0765f7fd3fb3a4c0e59f28a16357fd7a5c92d0ec3c9946180ee90)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
            check_type(argname="argument feather", value=feather, expected_type=type_hints["feather"])
            check_type(argname="argument feather_var", value=feather_var, expected_type=type_hints["feather_var"])
            check_type(argname="argument tolerance", value=tolerance, expected_type=type_hints["tolerance"])
            check_type(argname="argument tolerance_var", value=tolerance_var, expected_type=type_hints["tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var
        if feather is not None:
            self._values["feather"] = feather
        if feather_var is not None:
            self._values["feather_var"] = feather_var
        if tolerance is not None:
            self._values["tolerance"] = tolerance
        if tolerance_var is not None:
            self._values["tolerance_var"] = tolerance_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        '''
        result = self._values.get("feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather_var(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        '''
        result = self._values.get("feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        '''
        result = self._values.get("tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance_var(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        result = self._values.get("tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRemoveColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRemoveColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRemoveColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__49ac8b0e921f97e2a76f88443cef64ebd1df69b8ee6459e20b51d33accc3509f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRemoveColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__65b489b435123c3b2a09bd3574154fb2fa09707d086eb46db9b2f6f4f9d36753)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRemoveColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5cc9d47fca4463f9b69c10548ff68bc1ee552ba4db3fc359c704d4326a601df4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a77f035c066f867ac0d975888152aeafecc84af26266feb786df78dec49b4c01)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0eeb4d0d213f5fb02cf91aad9ea2440c71fa939dc719eda392616ddaf480ee54)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRemoveColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRemoveColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRemoveColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__00185236f7f31125f8660265e5c723461492033e7c8be0162ab6b0be8804d386)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRemoveColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRemoveColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__623fb407805ddc3ab497d1b9ec58a008808af3494a7d2501b351ceb9828bfc73)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @jsii.member(jsii_name="resetFeather")
    def reset_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeather", []))

    @jsii.member(jsii_name="resetFeatherVar")
    def reset_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatherVar", []))

    @jsii.member(jsii_name="resetTolerance")
    def reset_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTolerance", []))

    @jsii.member(jsii_name="resetToleranceVar")
    def reset_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featherInput")
    def feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherInput"))

    @builtins.property
    @jsii.member(jsii_name="featherVarInput")
    def feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceInput")
    def tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceVarInput")
    def tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c046ef197ca7c5308805450f7a16febc0780670718d07802de0ed4e117dc0a52)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__419650320df02b4c95bc3f219c3a904c7f5163067f8c3fa29ca0697a0944a661)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="feather")
    def feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "feather"))

    @feather.setter
    def feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6045a69b3371d12d0b6ca682883d14f602089315b3436165074c5ca8b1f3ca04)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "feather", value)

    @builtins.property
    @jsii.member(jsii_name="featherVar")
    def feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featherVar"))

    @feather_var.setter
    def feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f9f783d442d8bd13612d3ca4a8695fe82bfd33471936480c3f7cee511c702797)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featherVar", value)

    @builtins.property
    @jsii.member(jsii_name="tolerance")
    def tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tolerance"))

    @tolerance.setter
    def tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8555279371fb307a1a3572547f92451c14f0c628a07260ce68a8986e7f000dec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tolerance", value)

    @builtins.property
    @jsii.member(jsii_name="toleranceVar")
    def tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "toleranceVar"))

    @tolerance_var.setter
    def tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f4b6bf5dcc499fecca7d8b3e78275c857da3d8ed064455ad2e23a155a28ace5e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "toleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRemoveColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRemoveColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRemoveColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b0fb8e28ff9a1a3f1be70bbab71afa62588e171aff308787e6656d0aac0a43d4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeResize",
    jsii_struct_bases=[],
    name_mapping={
        "aspect": "aspect",
        "aspect_var": "aspectVar",
        "height": "height",
        "height_var": "heightVar",
        "type": "type",
        "type_var": "typeVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeResize:
    def __init__(
        self,
        *,
        aspect: typing.Optional[builtins.str] = None,
        aspect_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param aspect: Preserves the aspect ratio. Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect DataAkamaiImagingPolicyImage#aspect}
        :param aspect_var: Preserves the aspect ratio. Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_var DataAkamaiImagingPolicyImage#aspect_var}
        :param height: The height to resize the source image to. Must be set if height is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height to resize the source image to. Must be set if height is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param type: Sets constraints for the image resize. Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: Sets constraints for the image resize. Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        :param width: The width to resize the source image to. Must be set if width is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width to resize the source image to. Must be set if width is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ef1314a9d123b4b43e877f0bb34b37112a200078c6254786473344ca22811d01)
            check_type(argname="argument aspect", value=aspect, expected_type=type_hints["aspect"])
            check_type(argname="argument aspect_var", value=aspect_var, expected_type=type_hints["aspect_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if aspect is not None:
            self._values["aspect"] = aspect
        if aspect_var is not None:
            self._values["aspect_var"] = aspect_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def aspect(self) -> typing.Optional[builtins.str]:
        '''Preserves the aspect ratio.

        Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect DataAkamaiImagingPolicyImage#aspect}
        '''
        result = self._values.get("aspect")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def aspect_var(self) -> typing.Optional[builtins.str]:
        '''Preserves the aspect ratio.

        Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_var DataAkamaiImagingPolicyImage#aspect_var}
        '''
        result = self._values.get("aspect_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height to resize the source image to. Must be set if height is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height to resize the source image to. Must be set if height is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''Sets constraints for the image resize.

        Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''Sets constraints for the image resize.

        Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width to resize the source image to. Must be set if width is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width to resize the source image to. Must be set if width is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeResize(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeResizeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeResizeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d60fbb480ee9cf71b99f0ead5e31f65025b0e85e8c31b7493a835ee15cf57753)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeResizeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e1e597114fedb1bad288bc94036feaa6c286684739fbf9e82a0bedb938f8d279)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeResizeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__db46ec4b7f9a3be2595107256a042e8597bece7ba8eb2a5218fa548b77dc2050)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ee1424604ba299812024f299e7dd7476a4699246c26326ab74679ea99e0b7f5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0e56d5781966a553ee99e80f0cd1b153cd5dee1130e7ae5e640ebf972efc46be)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeResize]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeResize]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeResize]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dc2bd8c19c20ccdfdf036f341f8a5e9fb9253b9faedd1f65d96e448f8d4b9ea3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeResizeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeResizeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ecbf9cc24d9b75a0e130e87b8b12fc17916c9a0dd157dbbc1b9895feecc5c63c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAspect")
    def reset_aspect(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspect", []))

    @jsii.member(jsii_name="resetAspectVar")
    def reset_aspect_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspectVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="aspectInput")
    def aspect_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "aspectInput"))

    @builtins.property
    @jsii.member(jsii_name="aspectVarInput")
    def aspect_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "aspectVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="aspect")
    def aspect(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "aspect"))

    @aspect.setter
    def aspect(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__36cdf59c3d8ec71f914eb96e634ca9ccbaec5e5832f8e390d766934fc8c672d0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "aspect", value)

    @builtins.property
    @jsii.member(jsii_name="aspectVar")
    def aspect_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "aspectVar"))

    @aspect_var.setter
    def aspect_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d7c9cb6161f50017685a1fba7fe998b34fd0e834516b3e843d58d4afcec8e16)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "aspectVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__969a539e426f3ce4653b80f5bd02f853eef89e495a9fec33634fc9b0b24646b9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fb80db50b420c1274cfc90154aaf735472f3a856ad116effff12c8539e06049d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fb2fd428d07706dd7583485218d7f183b38d15d006641698e0d59aa8d94d1646)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__704aaca82c43e77f710fe24e9343f3c6621dc79d7199e286042b654e08744031)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b45299275fa3c6ef8a8b62097059b2177a46372195d8044c5435e822a1da1807)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e8ce09174e3415e3ec38c6d3bfcd5045e0142e90fde311bb11dceb987b6d61e8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeResize]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeResize]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeResize]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f7d208099cdd20e828ce52277d09a91196e446361674c9fffb45e915d2c3d03e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRotate",
    jsii_struct_bases=[],
    name_mapping={"degrees": "degrees", "degrees_var": "degreesVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRotate:
    def __init__(
        self,
        *,
        degrees: typing.Optional[builtins.str] = None,
        degrees_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param degrees: The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees DataAkamaiImagingPolicyImage#degrees}
        :param degrees_var: The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees_var DataAkamaiImagingPolicyImage#degrees_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__16cbaf78d358f43d530fb70a886335907532a2161504c79dc020198d5816a746)
            check_type(argname="argument degrees", value=degrees, expected_type=type_hints["degrees"])
            check_type(argname="argument degrees_var", value=degrees_var, expected_type=type_hints["degrees_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if degrees is not None:
            self._values["degrees"] = degrees
        if degrees_var is not None:
            self._values["degrees_var"] = degrees_var

    @builtins.property
    def degrees(self) -> typing.Optional[builtins.str]:
        '''The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees DataAkamaiImagingPolicyImage#degrees}
        '''
        result = self._values.get("degrees")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def degrees_var(self) -> typing.Optional[builtins.str]:
        '''The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees_var DataAkamaiImagingPolicyImage#degrees_var}
        '''
        result = self._values.get("degrees_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRotate(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRotateList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRotateList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b4df12227dda09b9113cee6c4486dad532f6d9e835d670d613df69cfbb45587b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRotateOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__752f5b3348fbb0267867ad62dc9d37d8535f9f1115a2b80788c9f714429a8a2a)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRotateOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__80b535fb2df4a25029efe93e965605d4f6280ec2dbd6d1923274ebb711c4044d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ed9854962b9f11c4dfa9606f731fcbcdbd61f16e354dd050f74909021ff3375c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9f94dda35232e7c7e6caa3b9d8d3a48bb4a3652b19170116e7d638633c8bd063)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRotate]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRotate]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRotate]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a1e4cb8395ebf050d01084c968497314a66b7824c76c24dcc780ec9c524bd5af)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRotateOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRotateOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__075295b55cff3bed9d8c669b8d4031f0a306d0c9100dd0c52f07dc33f750d70a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetDegrees")
    def reset_degrees(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDegrees", []))

    @jsii.member(jsii_name="resetDegreesVar")
    def reset_degrees_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDegreesVar", []))

    @builtins.property
    @jsii.member(jsii_name="degreesInput")
    def degrees_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "degreesInput"))

    @builtins.property
    @jsii.member(jsii_name="degreesVarInput")
    def degrees_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "degreesVarInput"))

    @builtins.property
    @jsii.member(jsii_name="degrees")
    def degrees(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "degrees"))

    @degrees.setter
    def degrees(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d4e6066d75dab64b2f6f19ca382d51ce139771f48383103e156a36a6a4ed16d9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "degrees", value)

    @builtins.property
    @jsii.member(jsii_name="degreesVar")
    def degrees_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "degreesVar"))

    @degrees_var.setter
    def degrees_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__46a61361828b56b032105f88be1c26dad3e11c979ee2d7a083af3558939b6a35)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "degreesVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRotate]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRotate]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRotate]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dc14aca690553f7322defc62144fe2592cdf81467c613909f0ea4f7082099334)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeScale",
    jsii_struct_bases=[],
    name_mapping={
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeScale:
    def __init__(
        self,
        *,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param height: Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged. Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged. Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9e59e7e57dc20c17a37108981b07314af9196d1390cec4fcc11652d3d03a8126)
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size.

        Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size.

        Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged.

        Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged.

        Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeScale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeScaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeScaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8eb3c72448ac9f646048c50753a47b66769463c88f3698703321ed812551c4a0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeScaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0a9371dd8bcaa66840d63a23facc090c6c40b94724a9f6774f080e12ba5e8f9d)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeScaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ba36b5909cb5cb32c49794a36bf4bf8fbf7481961e71ec2a2d7efd5e7d32afbe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f0c5ee40dd9f9d02f45ab1969090dc7d1f9a8e6058b17e3e05213b9f41ddac7b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2c457dfebd978d25d60f9627d91e521dc18408f64629a1f40611142ed1b7cc52)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeScale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeScale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeScale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b4c737d8a6b9f27ce6cc06009ee6381d584832797c3401112cc182471d626433)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeScaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeScaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fd097ca807c785d2135268de29db4ef8f93653ac8e3dd9ade376b3938656a4f1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c9a8af865fbc31a527f6dca35c0c104a0e2428f7fd900a827a560a6231fcda43)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dc15541bb3f2d3454bdf151085eefaf60451fa4d9f382baf8a147b2955670078)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dbfbfe336838b7feb7323cdff89fdf54c8654da8120f3d6585b815fa5664e606)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df7ae701fb2a37f6117c73933c5c55182744a230af530c0360195d77ffc0b19e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeScale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeScale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeScale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fbc1a4124c073b4ec125e4042e425af7a075a027a6168e32663fa39018c1d078)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeShear",
    jsii_struct_bases=[],
    name_mapping={
        "x_shear": "xShear",
        "x_shear_var": "xShearVar",
        "y_shear": "yShear",
        "y_shear_var": "yShearVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeShear:
    def __init__(
        self,
        *,
        x_shear: typing.Optional[builtins.str] = None,
        x_shear_var: typing.Optional[builtins.str] = None,
        y_shear: typing.Optional[builtins.str] = None,
        y_shear_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param x_shear: The amount to shear along the x-axis, measured in multiples of the image's width. Must be set if yShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear DataAkamaiImagingPolicyImage#x_shear}
        :param x_shear_var: The amount to shear along the x-axis, measured in multiples of the image's width. Must be set if yShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear_var DataAkamaiImagingPolicyImage#x_shear_var}
        :param y_shear: The amount to shear along the y-axis, measured in multiples of the image's height. Must be set if xShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear DataAkamaiImagingPolicyImage#y_shear}
        :param y_shear_var: The amount to shear along the y-axis, measured in multiples of the image's height. Must be set if xShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear_var DataAkamaiImagingPolicyImage#y_shear_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__48a1f98b3f109d218519ce91e8ffe206158b5667bb1e2133c62c4757cded304b)
            check_type(argname="argument x_shear", value=x_shear, expected_type=type_hints["x_shear"])
            check_type(argname="argument x_shear_var", value=x_shear_var, expected_type=type_hints["x_shear_var"])
            check_type(argname="argument y_shear", value=y_shear, expected_type=type_hints["y_shear"])
            check_type(argname="argument y_shear_var", value=y_shear_var, expected_type=type_hints["y_shear_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if x_shear is not None:
            self._values["x_shear"] = x_shear
        if x_shear_var is not None:
            self._values["x_shear_var"] = x_shear_var
        if y_shear is not None:
            self._values["y_shear"] = y_shear
        if y_shear_var is not None:
            self._values["y_shear_var"] = y_shear_var

    @builtins.property
    def x_shear(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the x-axis, measured in multiples of the image's width.

        Must be set if yShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear DataAkamaiImagingPolicyImage#x_shear}
        '''
        result = self._values.get("x_shear")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_shear_var(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the x-axis, measured in multiples of the image's width.

        Must be set if yShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear_var DataAkamaiImagingPolicyImage#x_shear_var}
        '''
        result = self._values.get("x_shear_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_shear(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the y-axis, measured in multiples of the image's height.

        Must be set if xShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear DataAkamaiImagingPolicyImage#y_shear}
        '''
        result = self._values.get("y_shear")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_shear_var(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the y-axis, measured in multiples of the image's height.

        Must be set if xShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear_var DataAkamaiImagingPolicyImage#y_shear_var}
        '''
        result = self._values.get("y_shear_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeShear(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeShearList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeShearList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2558b39561f88cb553836d28853f36507d0fa633f7b68b4dcb2eebb0fc6594b0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeShearOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3339b50fda44e49c1f2030754c36f2e7f9643b5b400040939e4e1f4b62e7a577)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeShearOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__178a19df537200a6d7fbb5fe05e0a801b1e51ca479bb410d477e68d8e4cbc02b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cdb30e37707f3f8600cc1d50fc05994f2c2b2d0aa5c42b75b10999fd668416f3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__584462ef6e505de31d6b71fc060eefdbc933100b32744502581542013673588d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeShear]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeShear]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeShear]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d0d5f66ea0915fa7d9c5a8c23f33031195f3d07d3fa2a0cdbd079171a34aa02)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeShearOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeShearOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__09ebab6da4d8613cae8701db38f496fd2cb734c0c03347178e9dc2ec42ddaafc)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetXShear")
    def reset_x_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXShear", []))

    @jsii.member(jsii_name="resetXShearVar")
    def reset_x_shear_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXShearVar", []))

    @jsii.member(jsii_name="resetYShear")
    def reset_y_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYShear", []))

    @jsii.member(jsii_name="resetYShearVar")
    def reset_y_shear_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYShearVar", []))

    @builtins.property
    @jsii.member(jsii_name="xShearInput")
    def x_shear_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xShearInput"))

    @builtins.property
    @jsii.member(jsii_name="xShearVarInput")
    def x_shear_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xShearVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yShearInput")
    def y_shear_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yShearInput"))

    @builtins.property
    @jsii.member(jsii_name="yShearVarInput")
    def y_shear_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yShearVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xShear")
    def x_shear(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xShear"))

    @x_shear.setter
    def x_shear(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__677afb9e73f07fef409f0aa04ae73ceea130c735acac7141d9d0e6ae4dd0b23e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xShear", value)

    @builtins.property
    @jsii.member(jsii_name="xShearVar")
    def x_shear_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xShearVar"))

    @x_shear_var.setter
    def x_shear_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fbccd1804addff3e3c9474ac80fdaa19ae30117b1444565f9a410d73ba3ece1c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xShearVar", value)

    @builtins.property
    @jsii.member(jsii_name="yShear")
    def y_shear(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yShear"))

    @y_shear.setter
    def y_shear(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d821f09374886e132694105945a3a24c756364cb71179533d705f60131da19d3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yShear", value)

    @builtins.property
    @jsii.member(jsii_name="yShearVar")
    def y_shear_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yShearVar"))

    @y_shear_var.setter
    def y_shear_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f92509e51988173248c75b229535ac7e30f62a7894b6333b5e50092ad80fb51c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yShearVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeShear]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeShear]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeShear]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a89f21959f20b53712f118f5b751cebb3beb8aa81133d30f8ffafc419188e10c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeTrim",
    jsii_struct_bases=[],
    name_mapping={
        "fuzz": "fuzz",
        "fuzz_var": "fuzzVar",
        "padding": "padding",
        "padding_var": "paddingVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeTrim:
    def __init__(
        self,
        *,
        fuzz: typing.Optional[builtins.str] = None,
        fuzz_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fuzz: The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz DataAkamaiImagingPolicyImage#fuzz}
        :param fuzz_var: The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz_var DataAkamaiImagingPolicyImage#fuzz_var}
        :param padding: The amount of padding in pixels to add to the trimmed image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: The amount of padding in pixels to add to the trimmed image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ebf172805a99b6f5bca1c0825c9439bb7880bd9b3a54fe01c9a71a87225ecdf5)
            check_type(argname="argument fuzz", value=fuzz, expected_type=type_hints["fuzz"])
            check_type(argname="argument fuzz_var", value=fuzz_var, expected_type=type_hints["fuzz_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fuzz is not None:
            self._values["fuzz"] = fuzz
        if fuzz_var is not None:
            self._values["fuzz_var"] = fuzz_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var

    @builtins.property
    def fuzz(self) -> typing.Optional[builtins.str]:
        '''The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz DataAkamaiImagingPolicyImage#fuzz}
        '''
        result = self._values.get("fuzz")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fuzz_var(self) -> typing.Optional[builtins.str]:
        '''The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz_var DataAkamaiImagingPolicyImage#fuzz_var}
        '''
        result = self._values.get("fuzz_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''The amount of padding in pixels to add to the trimmed image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''The amount of padding in pixels to add to the trimmed image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeTrim(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeTrimList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeTrimList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f4240e33920297708e44097bf7b90e9418a1109ded93849e4a33bb73dcf24635)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeTrimOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fb05376652bfba01f018fb5f6cb0f80eab6fd58ce0e4141e6dd33ae5906c2f4a)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeTrimOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7be284246116d32337b24762bbc8ed6767903d40d2f9e1c5271fe3bd8e6a4d0e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__171edf5454e2c27f63b39d253bc3e1d4e53848aa675a154cae575a4609e5198f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ed73d9a698aee7f4976383a518c3f5a7f5eea0d1864c5f7c9733d16d72769db1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeTrim]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeTrim]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeTrim]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eddfe48d706b8939901ecb165cf868bcc9494f8325801d47d98875162468880d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeTrimOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeTrimOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e4dc8fa5a17a3ccb0fe440a8d2cb440e18652e9395172c7dbdf42c51ea08978a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetFuzz")
    def reset_fuzz(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFuzz", []))

    @jsii.member(jsii_name="resetFuzzVar")
    def reset_fuzz_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFuzzVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @builtins.property
    @jsii.member(jsii_name="fuzzInput")
    def fuzz_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fuzzInput"))

    @builtins.property
    @jsii.member(jsii_name="fuzzVarInput")
    def fuzz_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fuzzVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="fuzz")
    def fuzz(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fuzz"))

    @fuzz.setter
    def fuzz(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ae7132e7639c17cfbf50db9ff11a6ee271798efbdc422fd8c78c8ea09be120e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fuzz", value)

    @builtins.property
    @jsii.member(jsii_name="fuzzVar")
    def fuzz_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fuzzVar"))

    @fuzz_var.setter
    def fuzz_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7e02c931c30482b1f8e5c53f9eeedb78e8eefd13cfc989e262095d69bc7ba48b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fuzzVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0d97ece390a0aec9a2a7e91587be711a4cec2a6f1c44c86e16fa34d50f32e723)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b3211281db7c2f698ff60416fec5f3001920599822a3b2f2f488498826a0bf6a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeTrim]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeTrim]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeTrim]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ced1f1efc1a9337d2e01596c02e223af55f7c981ffce38ff12b5b286a6694adf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeUnsharpMask",
    jsii_struct_bases=[],
    name_mapping={
        "gain": "gain",
        "gain_var": "gainVar",
        "sigma": "sigma",
        "sigma_var": "sigmaVar",
        "threshold": "threshold",
        "threshold_var": "thresholdVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeUnsharpMask:
    def __init__(
        self,
        *,
        gain: typing.Optional[builtins.str] = None,
        gain_var: typing.Optional[builtins.str] = None,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
        threshold: typing.Optional[builtins.str] = None,
        threshold_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param gain: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        :param gain_var: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        :param sigma: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        :param threshold: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        :param threshold_var: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__38a5e6eac14fbbe57239e7b757918fc90a597194b1a4c9112a4e7d9d67fcf2e5)
            check_type(argname="argument gain", value=gain, expected_type=type_hints["gain"])
            check_type(argname="argument gain_var", value=gain_var, expected_type=type_hints["gain_var"])
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
            check_type(argname="argument threshold", value=threshold, expected_type=type_hints["threshold"])
            check_type(argname="argument threshold_var", value=threshold_var, expected_type=type_hints["threshold_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if gain is not None:
            self._values["gain"] = gain
        if gain_var is not None:
            self._values["gain_var"] = gain_var
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var
        if threshold is not None:
            self._values["threshold"] = threshold
        if threshold_var is not None:
            self._values["threshold_var"] = threshold_var

    @builtins.property
    def gain(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        '''
        result = self._values.get("gain")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gain_var(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        '''
        result = self._values.get("gain_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        '''
        result = self._values.get("threshold")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold_var(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        result = self._values.get("threshold_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeUnsharpMask(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeUnsharpMaskList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeUnsharpMaskList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ddc5b4cd0056d9b1c9b5276588d964e0cd5d6ce4a32669ed3ce6e312a88272f4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeUnsharpMaskOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__746333a26550ecd876777bd5b0658ad09cc3174bbdb6244522460dacd3b346b3)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeUnsharpMaskOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__926420af5ca86a0055b3815e60db676f9848222ec4e5ce34866dce456ae3b08a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9010eeb77aa8a1f379f085068bb1dec5ad0a1a6a8f32e23fd2f3499dfd2fd4c8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4564e994cbabcc20c278ecbf588f4f415139cde0446d2266432a4c002c9c6597)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeUnsharpMask]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeUnsharpMask]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeUnsharpMask]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__075ec9fe08527448c543f58b2acaec4825897a4d340728577a6e5a28d7e3230b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeUnsharpMaskOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeUnsharpMaskOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fca0b4f82c37b2ed0f410660bb5bd5121ad8e556bf2ea2d6584573bb1fa77ab0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetGain")
    def reset_gain(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGain", []))

    @jsii.member(jsii_name="resetGainVar")
    def reset_gain_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGainVar", []))

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @jsii.member(jsii_name="resetThreshold")
    def reset_threshold(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThreshold", []))

    @jsii.member(jsii_name="resetThresholdVar")
    def reset_threshold_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThresholdVar", []))

    @builtins.property
    @jsii.member(jsii_name="gainInput")
    def gain_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainInput"))

    @builtins.property
    @jsii.member(jsii_name="gainVarInput")
    def gain_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdInput")
    def threshold_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdVarInput")
    def threshold_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gain")
    def gain(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gain"))

    @gain.setter
    def gain(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5c89a804ee3bc696bc43d6a295931b076de64440ce40c98e16b6f151189581f4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gain", value)

    @builtins.property
    @jsii.member(jsii_name="gainVar")
    def gain_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gainVar"))

    @gain_var.setter
    def gain_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2fc78996e9c114266736940a46c3d52c86991c0863002998e07d8db05ffe8186)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gainVar", value)

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4773b96004f559bdea82ae825fc5244ac4e69f48e7f932be5b796ade5f4acec5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__192c014e50d04d841a5d864f08113ecde6be4a5f28803c2460a17d6226e8097f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="threshold")
    def threshold(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "threshold"))

    @threshold.setter
    def threshold(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8c9057a6ace1e97f46348bbcf367cb8a1f78e9b9888974f0c7c0321b15f49855)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "threshold", value)

    @builtins.property
    @jsii.member(jsii_name="thresholdVar")
    def threshold_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "thresholdVar"))

    @threshold_var.setter
    def threshold_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c70ba1b1c1a56d80c14ad1e59b4a1feecfe0fd8bc19b009a6f130d8c91458425)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "thresholdVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeUnsharpMask]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeUnsharpMask]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeUnsharpMask]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__050884423399debd8390094a8599c3076c376917fe1b52f2f2125c5170d2c0cc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a1f546629545a8825ee8f377380b5fdde662d677352f3a358ab72e512863a61)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a773caf89457d82cf7d00b7e77bc05d0127e317227d5b21e9b930ba119135fad)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__53d65a022cef27834003373658bfdbfd9ea21317826729c7123ba7863cddb4ee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__261f87b679028c4c48f6c4071af99b44a593c8c7ca39c756aad999aee84dba18)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4b9a9b5504a7b6891c3ab5e85e7fc15f6f01c60230e5ff233dac14d41b70a4d5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientation]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientation]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__05f633253cc0b8cbcfc707ddb08e5eefa06b5bdb1096744a3567146db33bdaa3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__92c829e446e3d9889efc29e025945943c0420a0c68d818dbb11c03d2326031a0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(
        self,
        *,
        append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultAppend, typing.Dict[builtins.str, typing.Any]]]]] = None,
        aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultAspectCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
        crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultFaceCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultFeatureCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultFitAndFill, typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
        im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultImQuery, typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
        region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultRegionOfInterestCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultRelativeCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
        resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultResize, typing.Dict[builtins.str, typing.Any]]]]] = None,
        rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultRotate, typing.Dict[builtins.str, typing.Any]]]]] = None,
        scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultScale, typing.Dict[builtins.str, typing.Any]]]]] = None,
        shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultShear, typing.Dict[builtins.str, typing.Any]]]]] = None,
        trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultTrim, typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param append: append block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        :param aspect_crop: aspect_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param crop: crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        :param face_crop: face_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        :param feature_crop: feature_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        :param fit_and_fill: fit_and_fill block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param im_query: im_query block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param region_of_interest_crop: region_of_interest_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        :param relative_crop: relative_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param resize: resize block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        :param rotate: rotate block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        :param scale: scale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param shear: shear block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        :param trim: trim block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        value = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefault(
            append=append,
            aspect_crop=aspect_crop,
            background_color=background_color,
            blur=blur,
            chroma_key=chroma_key,
            composite=composite,
            compound=compound,
            contrast=contrast,
            crop=crop,
            face_crop=face_crop,
            feature_crop=feature_crop,
            fit_and_fill=fit_and_fill,
            goop=goop,
            grayscale=grayscale,
            hsl=hsl,
            hsv=hsv,
            if_dimension=if_dimension,
            if_orientation=if_orientation,
            im_query=im_query,
            max_colors=max_colors,
            mirror=mirror,
            mono_hue=mono_hue,
            opacity=opacity,
            region_of_interest_crop=region_of_interest_crop,
            relative_crop=relative_crop,
            remove_color=remove_color,
            resize=resize,
            rotate=rotate,
            scale=scale,
            shear=shear,
            trim=trim,
            unsharp_mask=unsharp_mask,
        )

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putLandscape")
    def put_landscape(
        self,
        *,
        append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeAppend, typing.Dict[builtins.str, typing.Any]]]]] = None,
        aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeAspectCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
        crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeFaceCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeFeatureCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeFitAndFill, typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
        im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeImQuery, typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
        region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRegionOfInterestCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRelativeCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
        resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeResize, typing.Dict[builtins.str, typing.Any]]]]] = None,
        rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRotate, typing.Dict[builtins.str, typing.Any]]]]] = None,
        scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeScale, typing.Dict[builtins.str, typing.Any]]]]] = None,
        shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeShear, typing.Dict[builtins.str, typing.Any]]]]] = None,
        trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeTrim, typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param append: append block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        :param aspect_crop: aspect_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param crop: crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        :param face_crop: face_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        :param feature_crop: feature_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        :param fit_and_fill: fit_and_fill block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param im_query: im_query block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param region_of_interest_crop: region_of_interest_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        :param relative_crop: relative_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param resize: resize block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        :param rotate: rotate block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        :param scale: scale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param shear: shear block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        :param trim: trim block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        value = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscape(
            append=append,
            aspect_crop=aspect_crop,
            background_color=background_color,
            blur=blur,
            chroma_key=chroma_key,
            composite=composite,
            compound=compound,
            contrast=contrast,
            crop=crop,
            face_crop=face_crop,
            feature_crop=feature_crop,
            fit_and_fill=fit_and_fill,
            goop=goop,
            grayscale=grayscale,
            hsl=hsl,
            hsv=hsv,
            if_dimension=if_dimension,
            if_orientation=if_orientation,
            im_query=im_query,
            max_colors=max_colors,
            mirror=mirror,
            mono_hue=mono_hue,
            opacity=opacity,
            region_of_interest_crop=region_of_interest_crop,
            relative_crop=relative_crop,
            remove_color=remove_color,
            resize=resize,
            rotate=rotate,
            scale=scale,
            shear=shear,
            trim=trim,
            unsharp_mask=unsharp_mask,
        )

        return typing.cast(None, jsii.invoke(self, "putLandscape", [value]))

    @jsii.member(jsii_name="putPortrait")
    def put_portrait(
        self,
        *,
        append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitAppend", typing.Dict[builtins.str, typing.Any]]]]] = None,
        aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitAspectCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitBackgroundColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitBlur", typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitChromaKey", typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitComposite", typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCompound", typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitContrast", typing.Dict[builtins.str, typing.Any]]]]] = None,
        crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitFaceCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitFeatureCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitFitAndFill", typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitGoop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitGrayscale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitHsl", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitHsv", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimension", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientation", typing.Dict[builtins.str, typing.Any]]]]] = None,
        im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitImQuery", typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitMaxColors", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitMirror", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitMonoHue", typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitOpacity", typing.Dict[builtins.str, typing.Any]]]]] = None,
        region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRegionOfInterestCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRelativeCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRemoveColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitResize", typing.Dict[builtins.str, typing.Any]]]]] = None,
        rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRotate", typing.Dict[builtins.str, typing.Any]]]]] = None,
        scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitScale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitShear", typing.Dict[builtins.str, typing.Any]]]]] = None,
        trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitTrim", typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitUnsharpMask", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param append: append block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        :param aspect_crop: aspect_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param crop: crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        :param face_crop: face_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        :param feature_crop: feature_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        :param fit_and_fill: fit_and_fill block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param im_query: im_query block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param region_of_interest_crop: region_of_interest_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        :param relative_crop: relative_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param resize: resize block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        :param rotate: rotate block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        :param scale: scale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param shear: shear block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        :param trim: trim block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        value = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortrait(
            append=append,
            aspect_crop=aspect_crop,
            background_color=background_color,
            blur=blur,
            chroma_key=chroma_key,
            composite=composite,
            compound=compound,
            contrast=contrast,
            crop=crop,
            face_crop=face_crop,
            feature_crop=feature_crop,
            fit_and_fill=fit_and_fill,
            goop=goop,
            grayscale=grayscale,
            hsl=hsl,
            hsv=hsv,
            if_dimension=if_dimension,
            if_orientation=if_orientation,
            im_query=im_query,
            max_colors=max_colors,
            mirror=mirror,
            mono_hue=mono_hue,
            opacity=opacity,
            region_of_interest_crop=region_of_interest_crop,
            relative_crop=relative_crop,
            remove_color=remove_color,
            resize=resize,
            rotate=rotate,
            scale=scale,
            shear=shear,
            trim=trim,
            unsharp_mask=unsharp_mask,
        )

        return typing.cast(None, jsii.invoke(self, "putPortrait", [value]))

    @jsii.member(jsii_name="putSquare")
    def put_square(
        self,
        *,
        append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareAppend", typing.Dict[builtins.str, typing.Any]]]]] = None,
        aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareAspectCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareBackgroundColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareBlur", typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareChromaKey", typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareComposite", typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareCompound", typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareContrast", typing.Dict[builtins.str, typing.Any]]]]] = None,
        crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareFaceCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareFeatureCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareFitAndFill", typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareGoop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareGrayscale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareHsl", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareHsv", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfDimension", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfOrientation", typing.Dict[builtins.str, typing.Any]]]]] = None,
        im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareImQuery", typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareMaxColors", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareMirror", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareMonoHue", typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareOpacity", typing.Dict[builtins.str, typing.Any]]]]] = None,
        region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareRegionOfInterestCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareRelativeCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareRemoveColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareResize", typing.Dict[builtins.str, typing.Any]]]]] = None,
        rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareRotate", typing.Dict[builtins.str, typing.Any]]]]] = None,
        scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareScale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareShear", typing.Dict[builtins.str, typing.Any]]]]] = None,
        trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareTrim", typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareUnsharpMask", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param append: append block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        :param aspect_crop: aspect_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param crop: crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        :param face_crop: face_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        :param feature_crop: feature_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        :param fit_and_fill: fit_and_fill block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param im_query: im_query block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param region_of_interest_crop: region_of_interest_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        :param relative_crop: relative_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param resize: resize block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        :param rotate: rotate block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        :param scale: scale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param shear: shear block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        :param trim: trim block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        value = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquare(
            append=append,
            aspect_crop=aspect_crop,
            background_color=background_color,
            blur=blur,
            chroma_key=chroma_key,
            composite=composite,
            compound=compound,
            contrast=contrast,
            crop=crop,
            face_crop=face_crop,
            feature_crop=feature_crop,
            fit_and_fill=fit_and_fill,
            goop=goop,
            grayscale=grayscale,
            hsl=hsl,
            hsv=hsv,
            if_dimension=if_dimension,
            if_orientation=if_orientation,
            im_query=im_query,
            max_colors=max_colors,
            mirror=mirror,
            mono_hue=mono_hue,
            opacity=opacity,
            region_of_interest_crop=region_of_interest_crop,
            relative_crop=relative_crop,
            remove_color=remove_color,
            resize=resize,
            rotate=rotate,
            scale=scale,
            shear=shear,
            trim=trim,
            unsharp_mask=unsharp_mask,
        )

        return typing.cast(None, jsii.invoke(self, "putSquare", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetLandscape")
    def reset_landscape(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLandscape", []))

    @jsii.member(jsii_name="resetPortrait")
    def reset_portrait(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPortrait", []))

    @jsii.member(jsii_name="resetSquare")
    def reset_square(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSquare", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="landscape")
    def landscape(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeOutputReference, jsii.get(self, "landscape"))

    @builtins.property
    @jsii.member(jsii_name="portrait")
    def portrait(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitOutputReference", jsii.get(self, "portrait"))

    @builtins.property
    @jsii.member(jsii_name="square")
    def square(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareOutputReference", jsii.get(self, "square"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="landscapeInput")
    def landscape_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscape], jsii.get(self, "landscapeInput"))

    @builtins.property
    @jsii.member(jsii_name="portraitInput")
    def portrait_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortrait"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortrait"], jsii.get(self, "portraitInput"))

    @builtins.property
    @jsii.member(jsii_name="squareInput")
    def square_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquare"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquare"], jsii.get(self, "squareInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientation]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientation]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientation]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cecf799279fea3e5fc4a44e29f49e08bc1d7a222516a254c8c6c552ba595a25d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortrait",
    jsii_struct_bases=[],
    name_mapping={
        "append": "append",
        "aspect_crop": "aspectCrop",
        "background_color": "backgroundColor",
        "blur": "blur",
        "chroma_key": "chromaKey",
        "composite": "composite",
        "compound": "compound",
        "contrast": "contrast",
        "crop": "crop",
        "face_crop": "faceCrop",
        "feature_crop": "featureCrop",
        "fit_and_fill": "fitAndFill",
        "goop": "goop",
        "grayscale": "grayscale",
        "hsl": "hsl",
        "hsv": "hsv",
        "if_dimension": "ifDimension",
        "if_orientation": "ifOrientation",
        "im_query": "imQuery",
        "max_colors": "maxColors",
        "mirror": "mirror",
        "mono_hue": "monoHue",
        "opacity": "opacity",
        "region_of_interest_crop": "regionOfInterestCrop",
        "relative_crop": "relativeCrop",
        "remove_color": "removeColor",
        "resize": "resize",
        "rotate": "rotate",
        "scale": "scale",
        "shear": "shear",
        "trim": "trim",
        "unsharp_mask": "unsharpMask",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortrait:
    def __init__(
        self,
        *,
        append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitAppend", typing.Dict[builtins.str, typing.Any]]]]] = None,
        aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitAspectCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitBackgroundColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitBlur", typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitChromaKey", typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitComposite", typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCompound", typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitContrast", typing.Dict[builtins.str, typing.Any]]]]] = None,
        crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitFaceCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitFeatureCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitFitAndFill", typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitGoop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitGrayscale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitHsl", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitHsv", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimension", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientation", typing.Dict[builtins.str, typing.Any]]]]] = None,
        im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitImQuery", typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitMaxColors", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitMirror", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitMonoHue", typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitOpacity", typing.Dict[builtins.str, typing.Any]]]]] = None,
        region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRegionOfInterestCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRelativeCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRemoveColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitResize", typing.Dict[builtins.str, typing.Any]]]]] = None,
        rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRotate", typing.Dict[builtins.str, typing.Any]]]]] = None,
        scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitScale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitShear", typing.Dict[builtins.str, typing.Any]]]]] = None,
        trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitTrim", typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitUnsharpMask", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param append: append block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        :param aspect_crop: aspect_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param crop: crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        :param face_crop: face_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        :param feature_crop: feature_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        :param fit_and_fill: fit_and_fill block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param im_query: im_query block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param region_of_interest_crop: region_of_interest_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        :param relative_crop: relative_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param resize: resize block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        :param rotate: rotate block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        :param scale: scale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param shear: shear block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        :param trim: trim block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__742f0151bb21892a108b6612c16ff154bbd2ff6782e1e43f9dfeb1f82a0c7674)
            check_type(argname="argument append", value=append, expected_type=type_hints["append"])
            check_type(argname="argument aspect_crop", value=aspect_crop, expected_type=type_hints["aspect_crop"])
            check_type(argname="argument background_color", value=background_color, expected_type=type_hints["background_color"])
            check_type(argname="argument blur", value=blur, expected_type=type_hints["blur"])
            check_type(argname="argument chroma_key", value=chroma_key, expected_type=type_hints["chroma_key"])
            check_type(argname="argument composite", value=composite, expected_type=type_hints["composite"])
            check_type(argname="argument compound", value=compound, expected_type=type_hints["compound"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument crop", value=crop, expected_type=type_hints["crop"])
            check_type(argname="argument face_crop", value=face_crop, expected_type=type_hints["face_crop"])
            check_type(argname="argument feature_crop", value=feature_crop, expected_type=type_hints["feature_crop"])
            check_type(argname="argument fit_and_fill", value=fit_and_fill, expected_type=type_hints["fit_and_fill"])
            check_type(argname="argument goop", value=goop, expected_type=type_hints["goop"])
            check_type(argname="argument grayscale", value=grayscale, expected_type=type_hints["grayscale"])
            check_type(argname="argument hsl", value=hsl, expected_type=type_hints["hsl"])
            check_type(argname="argument hsv", value=hsv, expected_type=type_hints["hsv"])
            check_type(argname="argument if_dimension", value=if_dimension, expected_type=type_hints["if_dimension"])
            check_type(argname="argument if_orientation", value=if_orientation, expected_type=type_hints["if_orientation"])
            check_type(argname="argument im_query", value=im_query, expected_type=type_hints["im_query"])
            check_type(argname="argument max_colors", value=max_colors, expected_type=type_hints["max_colors"])
            check_type(argname="argument mirror", value=mirror, expected_type=type_hints["mirror"])
            check_type(argname="argument mono_hue", value=mono_hue, expected_type=type_hints["mono_hue"])
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument region_of_interest_crop", value=region_of_interest_crop, expected_type=type_hints["region_of_interest_crop"])
            check_type(argname="argument relative_crop", value=relative_crop, expected_type=type_hints["relative_crop"])
            check_type(argname="argument remove_color", value=remove_color, expected_type=type_hints["remove_color"])
            check_type(argname="argument resize", value=resize, expected_type=type_hints["resize"])
            check_type(argname="argument rotate", value=rotate, expected_type=type_hints["rotate"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument shear", value=shear, expected_type=type_hints["shear"])
            check_type(argname="argument trim", value=trim, expected_type=type_hints["trim"])
            check_type(argname="argument unsharp_mask", value=unsharp_mask, expected_type=type_hints["unsharp_mask"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if append is not None:
            self._values["append"] = append
        if aspect_crop is not None:
            self._values["aspect_crop"] = aspect_crop
        if background_color is not None:
            self._values["background_color"] = background_color
        if blur is not None:
            self._values["blur"] = blur
        if chroma_key is not None:
            self._values["chroma_key"] = chroma_key
        if composite is not None:
            self._values["composite"] = composite
        if compound is not None:
            self._values["compound"] = compound
        if contrast is not None:
            self._values["contrast"] = contrast
        if crop is not None:
            self._values["crop"] = crop
        if face_crop is not None:
            self._values["face_crop"] = face_crop
        if feature_crop is not None:
            self._values["feature_crop"] = feature_crop
        if fit_and_fill is not None:
            self._values["fit_and_fill"] = fit_and_fill
        if goop is not None:
            self._values["goop"] = goop
        if grayscale is not None:
            self._values["grayscale"] = grayscale
        if hsl is not None:
            self._values["hsl"] = hsl
        if hsv is not None:
            self._values["hsv"] = hsv
        if if_dimension is not None:
            self._values["if_dimension"] = if_dimension
        if if_orientation is not None:
            self._values["if_orientation"] = if_orientation
        if im_query is not None:
            self._values["im_query"] = im_query
        if max_colors is not None:
            self._values["max_colors"] = max_colors
        if mirror is not None:
            self._values["mirror"] = mirror
        if mono_hue is not None:
            self._values["mono_hue"] = mono_hue
        if opacity is not None:
            self._values["opacity"] = opacity
        if region_of_interest_crop is not None:
            self._values["region_of_interest_crop"] = region_of_interest_crop
        if relative_crop is not None:
            self._values["relative_crop"] = relative_crop
        if remove_color is not None:
            self._values["remove_color"] = remove_color
        if resize is not None:
            self._values["resize"] = resize
        if rotate is not None:
            self._values["rotate"] = rotate
        if scale is not None:
            self._values["scale"] = scale
        if shear is not None:
            self._values["shear"] = shear
        if trim is not None:
            self._values["trim"] = trim
        if unsharp_mask is not None:
            self._values["unsharp_mask"] = unsharp_mask

    @builtins.property
    def append(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitAppend"]]]:
        '''append block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        '''
        result = self._values.get("append")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitAppend"]]], result)

    @builtins.property
    def aspect_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitAspectCrop"]]]:
        '''aspect_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        '''
        result = self._values.get("aspect_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitAspectCrop"]]], result)

    @builtins.property
    def background_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitBackgroundColor"]]]:
        '''background_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        '''
        result = self._values.get("background_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitBackgroundColor"]]], result)

    @builtins.property
    def blur(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitBlur"]]]:
        '''blur block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        '''
        result = self._values.get("blur")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitBlur"]]], result)

    @builtins.property
    def chroma_key(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitChromaKey"]]]:
        '''chroma_key block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        '''
        result = self._values.get("chroma_key")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitChromaKey"]]], result)

    @builtins.property
    def composite(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitComposite"]]]:
        '''composite block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        '''
        result = self._values.get("composite")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitComposite"]]], result)

    @builtins.property
    def compound(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCompound"]]]:
        '''compound block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        '''
        result = self._values.get("compound")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCompound"]]], result)

    @builtins.property
    def contrast(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitContrast"]]]:
        '''contrast block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitContrast"]]], result)

    @builtins.property
    def crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCrop"]]]:
        '''crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        '''
        result = self._values.get("crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCrop"]]], result)

    @builtins.property
    def face_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitFaceCrop"]]]:
        '''face_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        '''
        result = self._values.get("face_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitFaceCrop"]]], result)

    @builtins.property
    def feature_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitFeatureCrop"]]]:
        '''feature_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        '''
        result = self._values.get("feature_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitFeatureCrop"]]], result)

    @builtins.property
    def fit_and_fill(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitFitAndFill"]]]:
        '''fit_and_fill block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        '''
        result = self._values.get("fit_and_fill")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitFitAndFill"]]], result)

    @builtins.property
    def goop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitGoop"]]]:
        '''goop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        '''
        result = self._values.get("goop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitGoop"]]], result)

    @builtins.property
    def grayscale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitGrayscale"]]]:
        '''grayscale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        '''
        result = self._values.get("grayscale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitGrayscale"]]], result)

    @builtins.property
    def hsl(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitHsl"]]]:
        '''hsl block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        '''
        result = self._values.get("hsl")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitHsl"]]], result)

    @builtins.property
    def hsv(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitHsv"]]]:
        '''hsv block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        '''
        result = self._values.get("hsv")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitHsv"]]], result)

    @builtins.property
    def if_dimension(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimension"]]]:
        '''if_dimension block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        '''
        result = self._values.get("if_dimension")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimension"]]], result)

    @builtins.property
    def if_orientation(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientation"]]]:
        '''if_orientation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        '''
        result = self._values.get("if_orientation")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientation"]]], result)

    @builtins.property
    def im_query(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitImQuery"]]]:
        '''im_query block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        '''
        result = self._values.get("im_query")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitImQuery"]]], result)

    @builtins.property
    def max_colors(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitMaxColors"]]]:
        '''max_colors block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        '''
        result = self._values.get("max_colors")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitMaxColors"]]], result)

    @builtins.property
    def mirror(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitMirror"]]]:
        '''mirror block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        '''
        result = self._values.get("mirror")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitMirror"]]], result)

    @builtins.property
    def mono_hue(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitMonoHue"]]]:
        '''mono_hue block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        '''
        result = self._values.get("mono_hue")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitMonoHue"]]], result)

    @builtins.property
    def opacity(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitOpacity"]]]:
        '''opacity block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitOpacity"]]], result)

    @builtins.property
    def region_of_interest_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRegionOfInterestCrop"]]]:
        '''region_of_interest_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        '''
        result = self._values.get("region_of_interest_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRegionOfInterestCrop"]]], result)

    @builtins.property
    def relative_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRelativeCrop"]]]:
        '''relative_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        '''
        result = self._values.get("relative_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRelativeCrop"]]], result)

    @builtins.property
    def remove_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRemoveColor"]]]:
        '''remove_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        '''
        result = self._values.get("remove_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRemoveColor"]]], result)

    @builtins.property
    def resize(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitResize"]]]:
        '''resize block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        '''
        result = self._values.get("resize")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitResize"]]], result)

    @builtins.property
    def rotate(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRotate"]]]:
        '''rotate block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        '''
        result = self._values.get("rotate")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRotate"]]], result)

    @builtins.property
    def scale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitScale"]]]:
        '''scale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitScale"]]], result)

    @builtins.property
    def shear(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitShear"]]]:
        '''shear block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        '''
        result = self._values.get("shear")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitShear"]]], result)

    @builtins.property
    def trim(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitTrim"]]]:
        '''trim block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        '''
        result = self._values.get("trim")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitTrim"]]], result)

    @builtins.property
    def unsharp_mask(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitUnsharpMask"]]]:
        '''unsharp_mask block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        result = self._values.get("unsharp_mask")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitUnsharpMask"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortrait(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitAppend",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_priority": "gravityPriority",
        "gravity_priority_var": "gravityPriorityVar",
        "gravity_var": "gravityVar",
        "preserve_minor_dimension": "preserveMinorDimension",
        "preserve_minor_dimension_var": "preserveMinorDimensionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitAppend:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitAppendImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_priority: typing.Optional[builtins.str] = None,
        gravity_priority_var: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        preserve_minor_dimension: typing.Optional[builtins.str] = None,
        preserve_minor_dimension_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Specifies where to place the ``image`` relative to the source image. The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_priority: Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal. The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority DataAkamaiImagingPolicyImage#gravity_priority}
        :param gravity_priority_var: Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal. The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority_var DataAkamaiImagingPolicyImage#gravity_priority_var}
        :param gravity_var: Specifies where to place the ``image`` relative to the source image. The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param preserve_minor_dimension: Whether to preserve the source image's minor dimension, ``false`` by default. The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension DataAkamaiImagingPolicyImage#preserve_minor_dimension}
        :param preserve_minor_dimension_var: Whether to preserve the source image's minor dimension, ``false`` by default. The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension_var DataAkamaiImagingPolicyImage#preserve_minor_dimension_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitAppendImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8e65708ea253dd380eb810ece28d322ea5f9a83de711002ac62fb07192b238fe)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_priority", value=gravity_priority, expected_type=type_hints["gravity_priority"])
            check_type(argname="argument gravity_priority_var", value=gravity_priority_var, expected_type=type_hints["gravity_priority_var"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument preserve_minor_dimension", value=preserve_minor_dimension, expected_type=type_hints["preserve_minor_dimension"])
            check_type(argname="argument preserve_minor_dimension_var", value=preserve_minor_dimension_var, expected_type=type_hints["preserve_minor_dimension_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_priority is not None:
            self._values["gravity_priority"] = gravity_priority
        if gravity_priority_var is not None:
            self._values["gravity_priority_var"] = gravity_priority_var
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if preserve_minor_dimension is not None:
            self._values["preserve_minor_dimension"] = preserve_minor_dimension
        if preserve_minor_dimension_var is not None:
            self._values["preserve_minor_dimension_var"] = preserve_minor_dimension_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitAppendImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitAppendImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Specifies where to place the ``image`` relative to the source image.

        The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_priority(self) -> typing.Optional[builtins.str]:
        '''Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal.

        The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority DataAkamaiImagingPolicyImage#gravity_priority}
        '''
        result = self._values.get("gravity_priority")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_priority_var(self) -> typing.Optional[builtins.str]:
        '''Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal.

        The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority_var DataAkamaiImagingPolicyImage#gravity_priority_var}
        '''
        result = self._values.get("gravity_priority_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Specifies where to place the ``image`` relative to the source image.

        The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def preserve_minor_dimension(self) -> typing.Optional[builtins.str]:
        '''Whether to preserve the source image's minor dimension, ``false`` by default.

        The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension DataAkamaiImagingPolicyImage#preserve_minor_dimension}
        '''
        result = self._values.get("preserve_minor_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def preserve_minor_dimension_var(self) -> typing.Optional[builtins.str]:
        '''Whether to preserve the source image's minor dimension, ``false`` by default.

        The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension_var DataAkamaiImagingPolicyImage#preserve_minor_dimension_var}
        '''
        result = self._values.get("preserve_minor_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitAppend(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitAppendImage",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitAppendImage:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitAppendImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitAppendImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitAppendImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__08a79f8d4157ee0767846847ee9b9ff768d47bb4f30285709ad0d6c36f8f0a7a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitAppendImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitAppendImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitAppendImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5dcf0754db5c83d3f3b1c8fb47462beca4202c417a7a78213f0d4c4e28e76b1f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitAppendList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitAppendList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5781daf3eae67e84d26576db13e24d5152b18021b6d928364a78220ea606a648)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitAppendOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__857200427bc0ce950d3985eefaa4f9e14dab4eca0bd249b4be795e54fea9a7a9)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitAppendOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4b1e0a2dfae2c3d0b292bcac338be924af4ed9414f63a79fdf36fb63b87c6884)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a09cdd3e7204cfe2b204cbb202c6fcedb6148cb0379acccd8be3f7d66c0d9c3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__075ec15c5bd4fd8689740cd5052d40dcd06f8c974acacd846f2daff9dd1f8b46)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitAppend]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitAppend]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitAppend]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0909556f0df0ceac4ff4c42f67b3ae64252b8b4390151ba6335679ffbce4f7d8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitAppendOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitAppendOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__64713a727f3cb2e634479a5766eb103795077efb86ec371a93aca94e565f22a0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitAppendImage()

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityPriority")
    def reset_gravity_priority(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityPriority", []))

    @jsii.member(jsii_name="resetGravityPriorityVar")
    def reset_gravity_priority_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityPriorityVar", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPreserveMinorDimension")
    def reset_preserve_minor_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPreserveMinorDimension", []))

    @jsii.member(jsii_name="resetPreserveMinorDimensionVar")
    def reset_preserve_minor_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPreserveMinorDimensionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitAppendImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitAppendImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityInput")
    def gravity_priority_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityPriorityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityVarInput")
    def gravity_priority_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityPriorityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitAppendImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitAppendImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionInput")
    def preserve_minor_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "preserveMinorDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionVarInput")
    def preserve_minor_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "preserveMinorDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3369e649100b226e91c15343f9c479a5f88790a661a864b08a2e8441faa00cd7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityPriority")
    def gravity_priority(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityPriority"))

    @gravity_priority.setter
    def gravity_priority(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__91f73508b8286e0f630b39a662a0043da92c010eebd8ccd4a1053c98ab6a8e31)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityPriority", value)

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityVar")
    def gravity_priority_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityPriorityVar"))

    @gravity_priority_var.setter
    def gravity_priority_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eaf3399ea1371d4839acbcb8d15b76fd207ffb664de663b0c5140159b3d7b71c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityPriorityVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__34523311a1e2d6357223e45c1e11155573882a75c6b5d91f5f350493bbf740b4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimension")
    def preserve_minor_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "preserveMinorDimension"))

    @preserve_minor_dimension.setter
    def preserve_minor_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__54fb9daf5e1feb24f53c4c578b1a96d03bc9f17c9f080d57868c29155959058f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "preserveMinorDimension", value)

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionVar")
    def preserve_minor_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "preserveMinorDimensionVar"))

    @preserve_minor_dimension_var.setter
    def preserve_minor_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6c93044df46424f0204f00a341311dd9e343c55074694137287644811ad876f9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "preserveMinorDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitAppend]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitAppend]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitAppend]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6d8cb23ec07909b46cf2922d57a3515df72a13b1c57b69e29e5334aa605d78e4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitAspectCrop",
    jsii_struct_bases=[],
    name_mapping={
        "allow_expansion": "allowExpansion",
        "allow_expansion_var": "allowExpansionVar",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitAspectCrop:
    def __init__(
        self,
        *,
        allow_expansion: typing.Optional[builtins.str] = None,
        allow_expansion_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_expansion: Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image. Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        :param allow_expansion_var: Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image. Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        :param height: The height term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The width term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        :param x_position: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2fb4a065183719209f64fcad19803d82a4fe58b8347208e8de5f66d5953d2cbe)
            check_type(argname="argument allow_expansion", value=allow_expansion, expected_type=type_hints["allow_expansion"])
            check_type(argname="argument allow_expansion_var", value=allow_expansion_var, expected_type=type_hints["allow_expansion_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if allow_expansion is not None:
            self._values["allow_expansion"] = allow_expansion
        if allow_expansion_var is not None:
            self._values["allow_expansion_var"] = allow_expansion_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def allow_expansion(self) -> typing.Optional[builtins.str]:
        '''Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image.

        Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        '''
        result = self._values.get("allow_expansion")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def allow_expansion_var(self) -> typing.Optional[builtins.str]:
        '''Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image.

        Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        '''
        result = self._values.get("allow_expansion_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitAspectCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitAspectCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitAspectCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2659ef4dc1ef246b9aba44bc3fcf6aea831f1bd73489e82f13a9d3466f5aab13)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitAspectCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e81bbfcbba888a18a5c8d85e4df225fd1a140b39b5b12b8ce76b1fb2f5c04482)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitAspectCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c28e92c7aeff226858d847e779def3f3039d1833ffe523bfbb5982eb98cd7f2d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__217c4d6804a602cb89580bc904fb4b230e2db7a3e19f33d1943ff6f64c82209b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f35fc0fbafcccd8dafc28319c1b41b94061bdfbbcd56f3badf7bcf8fe9ba585b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitAspectCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitAspectCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitAspectCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__346022acad8629fd6a37f4687987de83d0ff8b9d0433680ab262d1eb5058ddca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitAspectCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitAspectCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__62fe6aa6711866bd68cdf8b13fd1260a5c602c8710d3a17d463f554616998325)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAllowExpansion")
    def reset_allow_expansion(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansion", []))

    @jsii.member(jsii_name="resetAllowExpansionVar")
    def reset_allow_expansion_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansionVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionInput")
    def allow_expansion_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVarInput")
    def allow_expansion_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansion")
    def allow_expansion(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansion"))

    @allow_expansion.setter
    def allow_expansion(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__afa15469089426aaada8e74bc26bf2f6b095792e8fbfd5a1843be49b2d6dd8fd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansion", value)

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVar")
    def allow_expansion_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansionVar"))

    @allow_expansion_var.setter
    def allow_expansion_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6bb29f6a133f876d42366a4d1e1cdb1fb2d5ff7cbaeae9d57a573b02ae62ce37)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansionVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__456f0ff9c375e252203460595df214980557603d7ba1a5300fb84bec62cfaae4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__efdb2ac6d00c0ce93d3844423062146f8a36741dc5407fe322d398d7d7bfdc6e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__943d3b1d96e59dcd13109023e0b83d2ef36b261118351f7ec4bc189686cfa13b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa0ef04270c1aec2edc6b6ba507045bbfa19c0ff11d18a0b6a872cf40b062c31)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2fd7d61f268d1158ad28a5993ab20082160f9eb89d2d01953011b3da111fb617)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a2757a794bc580d13668add5d1d0d6334225cbbe7caba67a220ccef1ee7f8d99)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c76814dc2b53effde786ab8467180d737a10cc863ca000a82e094600f3318da2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__11a8a78e4b2f48efe3fd1e0903434a77273e2a1596c4f84c91d45bcf4b461059)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitAspectCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitAspectCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitAspectCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__52629ea4ca8934afbe354ece7c78c218b7154f9604920824f4d256d4edfdd01d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitBackgroundColor",
    jsii_struct_bases=[],
    name_mapping={"color": "color", "color_var": "colorVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitBackgroundColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c00ffd029f1c126fa28d009f22cb0de33e9ef53e8f0f3bff9fd119f11349a457)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitBackgroundColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitBackgroundColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitBackgroundColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__77d06ba416966f522a3a049f55d17840c0389f649325f4adac7df8e858910a04)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitBackgroundColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ce8257d7cafb912782382be5625714e88009416ebda923ea07b588c84efff090)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitBackgroundColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3252d8d3513703da780084456839cd1161efeb7af39615dad9bfdbbc57525e4e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f6cf6fcff69e5bc66fb4370b7d97b4d0286185740daca6f40f0336e129f93150)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b076529c98cbfb7be7964c202eed79a2fb54abebf5c67d6d12a098fc9e82f0e7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitBackgroundColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitBackgroundColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ef62f936c6793e222b5db4eb2857a3d90cd03397d05fcd8c676654fc41c9ef1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitBackgroundColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitBackgroundColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1a2f4707bb4260de906cc70132afa65a3e449cdd683fa28f3b8c41252c8b58f4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e519aa0a11c05a5bef22f9f7457e9093d0c6e405c7d29a0006393ad70bdaaa4d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b0b6bd0f9a4faeeddbba7fa896ab1577a0045c775694f3cb464c369933b7195e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitBackgroundColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitBackgroundColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitBackgroundColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__90950257f175766c2c7f2faf0b87dbb91b13c52e6d358c23502720a568702e7e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitBlur",
    jsii_struct_bases=[],
    name_mapping={"sigma": "sigma", "sigma_var": "sigmaVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitBlur:
    def __init__(
        self,
        *,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param sigma: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6bb96f4119b029f2d344397e378f18685fbe15968fc0a4b4346c665953c3ea85)
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitBlur(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitBlurList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitBlurList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__abcf04495d9c52bf4e092bdcd204f0f61bdf975f88b3a1f72e734a192a634057)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitBlurOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d080c3ba77e105531d33924ec0e1e575f88874546007baa8137137b34969d254)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitBlurOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f80a894781ae9d1f81d30f9ce3438a8601099e35f977b185acf4b472e9448232)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__56c9e7681c351e204ee0b71b7fdc37dace62b3976153141bdb71b0cae0013624)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d76cf0c80a204ee3305011599063c1dc4a066f5adf1416c822cf762f322dd8be)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitBlur]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitBlur]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f5ababd67634cd3f75e31c9e7b730912996ef65b014ca907de6910d62ed6201e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitBlurOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitBlurOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1878c2ceecb002264c1c424a58441e73d4eec19b9d4455395b3b73e0a50a5102)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9964a2f1905f07994b5daa0339cb5dddac3e5415acd386920b898f1528203aed)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2eb95b5c4c18b0f2f0f35212ce83d4f5b9b3f3d01c9d660ef77272a7559a05a8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitBlur]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitBlur]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitBlur]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e91a65e217194d6d12915061f20bfc78f94d50272190b8439a946d96c3421c74)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitChromaKey",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_feather": "hueFeather",
        "hue_feather_var": "hueFeatherVar",
        "hue_tolerance": "hueTolerance",
        "hue_tolerance_var": "hueToleranceVar",
        "hue_var": "hueVar",
        "lightness_feather": "lightnessFeather",
        "lightness_feather_var": "lightnessFeatherVar",
        "lightness_tolerance": "lightnessTolerance",
        "lightness_tolerance_var": "lightnessToleranceVar",
        "saturation_feather": "saturationFeather",
        "saturation_feather_var": "saturationFeatherVar",
        "saturation_tolerance": "saturationTolerance",
        "saturation_tolerance_var": "saturationToleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitChromaKey:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_feather: typing.Optional[builtins.str] = None,
        hue_feather_var: typing.Optional[builtins.str] = None,
        hue_tolerance: typing.Optional[builtins.str] = None,
        hue_tolerance_var: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness_feather: typing.Optional[builtins.str] = None,
        lightness_feather_var: typing.Optional[builtins.str] = None,
        lightness_tolerance: typing.Optional[builtins.str] = None,
        lightness_tolerance_var: typing.Optional[builtins.str] = None,
        saturation_feather: typing.Optional[builtins.str] = None,
        saturation_feather_var: typing.Optional[builtins.str] = None,
        saturation_tolerance: typing.Optional[builtins.str] = None,
        saturation_tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_feather: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        :param hue_feather_var: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        :param hue_tolerance: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        :param hue_tolerance_var: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        :param hue_var: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness_feather: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        :param lightness_feather_var: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        :param lightness_tolerance: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        :param lightness_tolerance_var: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        :param saturation_feather: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        :param saturation_feather_var: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        :param saturation_tolerance: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        :param saturation_tolerance_var: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__81519f45650e62cb89854959f580b39674417b8d66afd9b2a9299f9a48661e25)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_feather", value=hue_feather, expected_type=type_hints["hue_feather"])
            check_type(argname="argument hue_feather_var", value=hue_feather_var, expected_type=type_hints["hue_feather_var"])
            check_type(argname="argument hue_tolerance", value=hue_tolerance, expected_type=type_hints["hue_tolerance"])
            check_type(argname="argument hue_tolerance_var", value=hue_tolerance_var, expected_type=type_hints["hue_tolerance_var"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness_feather", value=lightness_feather, expected_type=type_hints["lightness_feather"])
            check_type(argname="argument lightness_feather_var", value=lightness_feather_var, expected_type=type_hints["lightness_feather_var"])
            check_type(argname="argument lightness_tolerance", value=lightness_tolerance, expected_type=type_hints["lightness_tolerance"])
            check_type(argname="argument lightness_tolerance_var", value=lightness_tolerance_var, expected_type=type_hints["lightness_tolerance_var"])
            check_type(argname="argument saturation_feather", value=saturation_feather, expected_type=type_hints["saturation_feather"])
            check_type(argname="argument saturation_feather_var", value=saturation_feather_var, expected_type=type_hints["saturation_feather_var"])
            check_type(argname="argument saturation_tolerance", value=saturation_tolerance, expected_type=type_hints["saturation_tolerance"])
            check_type(argname="argument saturation_tolerance_var", value=saturation_tolerance_var, expected_type=type_hints["saturation_tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_feather is not None:
            self._values["hue_feather"] = hue_feather
        if hue_feather_var is not None:
            self._values["hue_feather_var"] = hue_feather_var
        if hue_tolerance is not None:
            self._values["hue_tolerance"] = hue_tolerance
        if hue_tolerance_var is not None:
            self._values["hue_tolerance_var"] = hue_tolerance_var
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness_feather is not None:
            self._values["lightness_feather"] = lightness_feather
        if lightness_feather_var is not None:
            self._values["lightness_feather_var"] = lightness_feather_var
        if lightness_tolerance is not None:
            self._values["lightness_tolerance"] = lightness_tolerance
        if lightness_tolerance_var is not None:
            self._values["lightness_tolerance_var"] = lightness_tolerance_var
        if saturation_feather is not None:
            self._values["saturation_feather"] = saturation_feather
        if saturation_feather_var is not None:
            self._values["saturation_feather_var"] = saturation_feather_var
        if saturation_tolerance is not None:
            self._values["saturation_tolerance"] = saturation_tolerance
        if saturation_tolerance_var is not None:
            self._values["saturation_tolerance_var"] = saturation_tolerance_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        '''
        result = self._values.get("hue_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        '''
        result = self._values.get("hue_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        '''
        result = self._values.get("hue_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        '''
        result = self._values.get("hue_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        '''
        result = self._values.get("lightness_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        '''
        result = self._values.get("lightness_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        '''
        result = self._values.get("lightness_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        '''
        result = self._values.get("lightness_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        '''
        result = self._values.get("saturation_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        '''
        result = self._values.get("saturation_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        '''
        result = self._values.get("saturation_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        result = self._values.get("saturation_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitChromaKey(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitChromaKeyList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitChromaKeyList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__67594da5da6b46567b80882ff47ba12a27910c178cdbdd60d6893e969df5f956)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitChromaKeyOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bbf7f22b3cee9e9c0bd9daf1db661b2c04a471dd1e4e3a940df299d24620f509)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitChromaKeyOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__24459d42a085b7f4523cb9c0c510e638e1b62f6f00c68aa2e91eb5b21f4b0a4f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f311d5b80d740ec79f38f2ad9b7fec0bbc8d162d06657cd878d1208607980f4b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5fcdd541922afc5a3ae48adf69192e96dc710cb9db802f624c983cdbbbe5b927)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitChromaKey]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitChromaKey]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__27a7b2a3aa59a7f920e1283b3a514e6cbc533cc187dda13531e9f87b53fe1de1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitChromaKeyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitChromaKeyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ed8fca68e3176c17fbee145539166bc4af731fa5256b54632c38fca78c1df44)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueFeather")
    def reset_hue_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeather", []))

    @jsii.member(jsii_name="resetHueFeatherVar")
    def reset_hue_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeatherVar", []))

    @jsii.member(jsii_name="resetHueTolerance")
    def reset_hue_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueTolerance", []))

    @jsii.member(jsii_name="resetHueToleranceVar")
    def reset_hue_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueToleranceVar", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightnessFeather")
    def reset_lightness_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeather", []))

    @jsii.member(jsii_name="resetLightnessFeatherVar")
    def reset_lightness_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeatherVar", []))

    @jsii.member(jsii_name="resetLightnessTolerance")
    def reset_lightness_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessTolerance", []))

    @jsii.member(jsii_name="resetLightnessToleranceVar")
    def reset_lightness_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessToleranceVar", []))

    @jsii.member(jsii_name="resetSaturationFeather")
    def reset_saturation_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeather", []))

    @jsii.member(jsii_name="resetSaturationFeatherVar")
    def reset_saturation_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeatherVar", []))

    @jsii.member(jsii_name="resetSaturationTolerance")
    def reset_saturation_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationTolerance", []))

    @jsii.member(jsii_name="resetSaturationToleranceVar")
    def reset_saturation_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherInput")
    def hue_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVarInput")
    def hue_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceInput")
    def hue_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVarInput")
    def hue_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherInput")
    def lightness_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVarInput")
    def lightness_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceInput")
    def lightness_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVarInput")
    def lightness_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherInput")
    def saturation_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVarInput")
    def saturation_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceInput")
    def saturation_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVarInput")
    def saturation_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d98e27204a2a538ea25ec83cf581705b18acae8fe1496d41f4f11069fd1e9bdd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeather")
    def hue_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeather"))

    @hue_feather.setter
    def hue_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8eb7e57bd41a00690617b6e38d100a46702870ed388180abeecd8ff87c4b8934)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeather", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVar")
    def hue_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeatherVar"))

    @hue_feather_var.setter
    def hue_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__313a77b09d9a58591b0c1e0b8f2f905c44341b12abeef882dd3d7fd8ca43fc09)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueTolerance")
    def hue_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueTolerance"))

    @hue_tolerance.setter
    def hue_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__617c7782509b4dda01f33eba37229e4f192e70c90a0172aafeea5faa9527031a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVar")
    def hue_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueToleranceVar"))

    @hue_tolerance_var.setter
    def hue_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__60e626455b405ae3d5d60cdac38b8cc92809ad9b2e928548ebe5cd35ef504939)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c8146bb5710a0e221b6e4c89927aad035c40a54ecbd979f473eee4f0e046c2c1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeather")
    def lightness_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeather"))

    @lightness_feather.setter
    def lightness_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fd117a2635ed6258db7c94640f4378f4f016ba9de789454caa3ad0c1c0cd5cc7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeather", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVar")
    def lightness_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeatherVar"))

    @lightness_feather_var.setter
    def lightness_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__70b685722485968dc19d16cc965bb4d912df0cec4b12f299b5e642ac05d743dd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessTolerance")
    def lightness_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessTolerance"))

    @lightness_tolerance.setter
    def lightness_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__afc8ee8a6d39cf6ff60d555399faccac92c6832924b23fb457b8f826ff8636f3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVar")
    def lightness_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessToleranceVar"))

    @lightness_tolerance_var.setter
    def lightness_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cee9361970eba2821e10d52bceb8a6adf6cb7f5b5ba0895aa66a3aacdd06caa2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeather")
    def saturation_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeather"))

    @saturation_feather.setter
    def saturation_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__180dbe3eaa13136a9a1efb9b7e4536f72118d9a89416a11f2ca90830b7a61a5c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeather", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVar")
    def saturation_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeatherVar"))

    @saturation_feather_var.setter
    def saturation_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f81d3f3d07c311315b13eaf768527f383b1cb2aa1f92b2dee8e8bda19e930318)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationTolerance")
    def saturation_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationTolerance"))

    @saturation_tolerance.setter
    def saturation_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7c7e8e8f6c816ac19d4655d97e3fbc281b1535217bc0bbf61d9fb45d19082888)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVar")
    def saturation_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationToleranceVar"))

    @saturation_tolerance_var.setter
    def saturation_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__45fca476420597e1a92a8610f375349874f7bb1560bdaaf970a0e4190f5f1293)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitChromaKey]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitChromaKey]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitChromaKey]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__439dd6e8fa7fac2d333215ceff3e4091feada210b2a5b8bd8720d7de12bd8b94)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitComposite",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "placement": "placement",
        "placement_var": "placementVar",
        "scale": "scale",
        "scale_dimension": "scaleDimension",
        "scale_dimension_var": "scaleDimensionVar",
        "scale_var": "scaleVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitComposite:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCompositeImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        placement: typing.Optional[builtins.str] = None,
        placement_var: typing.Optional[builtins.str] = None,
        scale: typing.Optional[builtins.str] = None,
        scale_dimension: typing.Optional[builtins.str] = None,
        scale_dimension_var: typing.Optional[builtins.str] = None,
        scale_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param placement: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        :param placement_var: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        :param scale: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param scale_dimension: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        :param scale_dimension_var: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        :param scale_var: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        :param x_position: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCompositeImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cfae40bd82cff3700bfecdf72f15b7da7a1fe62ce0b570395c91006f66b13af2)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument placement", value=placement, expected_type=type_hints["placement"])
            check_type(argname="argument placement_var", value=placement_var, expected_type=type_hints["placement_var"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument scale_dimension", value=scale_dimension, expected_type=type_hints["scale_dimension"])
            check_type(argname="argument scale_dimension_var", value=scale_dimension_var, expected_type=type_hints["scale_dimension_var"])
            check_type(argname="argument scale_var", value=scale_var, expected_type=type_hints["scale_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if placement is not None:
            self._values["placement"] = placement
        if placement_var is not None:
            self._values["placement_var"] = placement_var
        if scale is not None:
            self._values["scale"] = scale
        if scale_dimension is not None:
            self._values["scale_dimension"] = scale_dimension
        if scale_dimension_var is not None:
            self._values["scale_dimension_var"] = scale_dimension_var
        if scale_var is not None:
            self._values["scale_var"] = scale_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCompositeImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCompositeImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        '''
        result = self._values.get("placement")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement_var(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        '''
        result = self._values.get("placement_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        '''
        result = self._values.get("scale_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        '''
        result = self._values.get("scale_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        '''
        result = self._values.get("scale_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitComposite(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCompositeImage",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCompositeImage:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCompositeImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCompositeImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCompositeImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c907829dda57d942d14d2ce7825434c5a11a792acddaee5af2c3d3f0c7daaad9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCompositeImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCompositeImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6b7d51440b8df80206c2d1369dff17a462e3e6a9a9c139c4a7be4ab8a0d09d03)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCompositeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCompositeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__76bec73906aa7ba5941b785c0d7ecce534cc7277e488907135238b8d6f57e5fb)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCompositeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__70c3e100f95a004968f677d7da71c64ab9c573a2b8cdc45af1f5524134ccb88f)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCompositeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eb60d1eaa6574384e81c259e14c2db6c1aedc1f819b2edb0e388442fb9eefc2a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ba1f3b3f70b453b3c37b1490d9fe5365641de3e865a413258a96a39effaf5637)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5e628a6ff4ba6ac19d332bd093feb2c59cf237fbbbe98a7308474d3a49b750da)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitComposite]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitComposite]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__53b06272f6ea9c9bdb576ff9639fc12a881792ebcc3e4992d618c47f4be7953d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCompositeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCompositeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2237e78bed385675593d6e846ad437528a4521db501d45eefae3a405458e811c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCompositeImage()

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPlacement")
    def reset_placement(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacement", []))

    @jsii.member(jsii_name="resetPlacementVar")
    def reset_placement_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacementVar", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetScaleDimension")
    def reset_scale_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimension", []))

    @jsii.member(jsii_name="resetScaleDimensionVar")
    def reset_scale_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimensionVar", []))

    @jsii.member(jsii_name="resetScaleVar")
    def reset_scale_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCompositeImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCompositeImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCompositeImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="placementInput")
    def placement_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementInput"))

    @builtins.property
    @jsii.member(jsii_name="placementVarInput")
    def placement_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionInput")
    def scale_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVarInput")
    def scale_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleVarInput")
    def scale_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__16bc36fad29acba2229e0f7777d44451442937de29aa7898d4952572ef1e6f94)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e09718a2b6b636426850fdde9cd6ac9c822b09f3b618ca396362685b1f1a69b1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="placement")
    def placement(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placement"))

    @placement.setter
    def placement(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ef59f0d74af2011e0b918137e9933d4498853fe60dfd0c3f50cbc415436b404a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placement", value)

    @builtins.property
    @jsii.member(jsii_name="placementVar")
    def placement_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placementVar"))

    @placement_var.setter
    def placement_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1535ecb9b3dcb044fd5052400c5e898d902b54f0a607ae251ad6822cdbf07f25)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placementVar", value)

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scale"))

    @scale.setter
    def scale(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1cddb8f6f36fd3bd34006ba539d56718fad388ffa8288f43a4fa307746833bb9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scale", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimension")
    def scale_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimension"))

    @scale_dimension.setter
    def scale_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a2e71934299a71e8505da735b4f97d4c0b6930ef66b546d831096b262504627)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimension", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVar")
    def scale_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimensionVar"))

    @scale_dimension_var.setter
    def scale_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b1de36fefff751292dfa067703a39493d854095347c8f262179acf7a30b46e98)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="scaleVar")
    def scale_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleVar"))

    @scale_var.setter
    def scale_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__48ebc7cc427c9dbe587d528a7580897fa7d06e934ba1273026730bf4c99a28bb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8859497362369099b77415adc83bcefdef78447b0b2e59c1883d07d6031f40bd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e352fb3b5695126e1d7ed264856254016cf95299cef98d39496d7f0bd71ae73d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7e9b8fdc9338725aab1ac114e8d86b83355eebebd0426afbd2cbb2d13f0ffc93)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__230ae556250b4f7c13162a2b5f0c57d51ec1fbd09adfe24c7c46c91bd376da9c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitComposite]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitComposite]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitComposite]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1fbf8fb6ff7cc30d2cddb75f181aa4ed8617bfbb99431d0e73da562a6ceb0563)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCompound",
    jsii_struct_bases=[],
    name_mapping={"transformations": "transformations"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCompound:
    def __init__(
        self,
        *,
        transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param transformations: transformations block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6000e1c439d1364df0e28be9577d888b2d37ab3138a825f9cb76dc443ad4f05d)
            check_type(argname="argument transformations", value=transformations, expected_type=type_hints["transformations"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if transformations is not None:
            self._values["transformations"] = transformations

    @builtins.property
    def transformations(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCompoundTransformations"]]]:
        '''transformations block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        result = self._values.get("transformations")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCompoundTransformations"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCompound(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCompoundList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCompoundList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dc4208301eaf681d07c2b8c46e805fbd2d9d60b9c51e15eb3e5df6cc20ff3bf2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCompoundOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bbddf12513e396cdbdb5e680d2d117c819a41269d1f4726daf15ca0d72307dd7)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCompoundOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a519db81cc287d33edd0d7bd62603169e90f8694512249066e34f2885071522)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__995769308c936b6f309b8188fa66435b694084aad420e9bd5744478ad7d194dd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fb7f91eba40833352d235e59d708b7313a2b129c163fd597b8cc50bcaa31b95e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCompound]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCompound]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ef0f48bb8c8dc8debf3cf431da3bd4a9af9caa024cd67f571ecb1d070db5838c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCompoundOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCompoundOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1e010423fc93a416e203235a16d16d5f61d4fa8196ef7cd811e771ad42b2c4d0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformations")
    def put_transformations(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f0e50d1fcd3b790ff4e3fb16ee845e19c05c5ebf555709216f459c9bb99a2a03)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTransformations", [value]))

    @jsii.member(jsii_name="resetTransformations")
    def reset_transformations(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformations", []))

    @builtins.property
    @jsii.member(jsii_name="transformations")
    def transformations(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCompoundTransformationsList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCompoundTransformationsList", jsii.get(self, "transformations"))

    @builtins.property
    @jsii.member(jsii_name="transformationsInput")
    def transformations_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCompoundTransformations"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCompoundTransformations"]]], jsii.get(self, "transformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCompound]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCompound]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCompound]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5a15b4fcfbc98d2d337172dbe235396957bd8ec2d22248c27bdd6bd2433e5977)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCompoundTransformations",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCompoundTransformations:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCompoundTransformations(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCompoundTransformationsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCompoundTransformationsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__899755671ab39a327cb5bea06e619daf7f644dbe2295b34da450427bc4f46c8f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCompoundTransformationsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af07c27dcdf5957159375538a9f43dc903aac9d7baccc27c1af46ebf62a12ec1)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCompoundTransformationsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f3e0183d446ad6ede2a05f7799dad251c2b744ba3e4774cdfe06d09ede9245a0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bbbc8119a83b4330d28acfb622cad505c473fd1a61efd630fb0a867ceecebbc9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4038bc66875ad6c564d98f80c240cf1caf1e5cfae2b5f4f73296c12a3504a607)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCompoundTransformations]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCompoundTransformations]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCompoundTransformations]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__540648693810cb0bb0535cc2bd5308e3fa385f80439ac70818e73660acb46a1f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCompoundTransformationsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCompoundTransformationsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3cb4cc17e8d310b794d78b711f4d9efc1129d49c86e6c9aae52b13b26beec8aa)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCompoundTransformations]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCompoundTransformations]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCompoundTransformations]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ff47bf01416dced8511d2ae78e3588afc88080115f5a84aacb548d507594415d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitContrast",
    jsii_struct_bases=[],
    name_mapping={
        "brightness": "brightness",
        "brightness_var": "brightnessVar",
        "contrast": "contrast",
        "contrast_var": "contrastVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitContrast:
    def __init__(
        self,
        *,
        brightness: typing.Optional[builtins.str] = None,
        brightness_var: typing.Optional[builtins.str] = None,
        contrast: typing.Optional[builtins.str] = None,
        contrast_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param brightness: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        :param brightness_var: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        :param contrast: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param contrast_var: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f0233f5463239d853e82e6a9157f6053ff0488a4e1cc6c0d421df5439e6e86e6)
            check_type(argname="argument brightness", value=brightness, expected_type=type_hints["brightness"])
            check_type(argname="argument brightness_var", value=brightness_var, expected_type=type_hints["brightness_var"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument contrast_var", value=contrast_var, expected_type=type_hints["contrast_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if brightness is not None:
            self._values["brightness"] = brightness
        if brightness_var is not None:
            self._values["brightness_var"] = brightness_var
        if contrast is not None:
            self._values["contrast"] = contrast
        if contrast_var is not None:
            self._values["contrast_var"] = contrast_var

    @builtins.property
    def brightness(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        '''
        result = self._values.get("brightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def brightness_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        '''
        result = self._values.get("brightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        result = self._values.get("contrast_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitContrast(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitContrastList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitContrastList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3d0846e2fb401f1ecf1c7a7ab1641f389b91a25a0349e15f855c1186a42eeb2a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitContrastOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__93acfec64743efd63f95875b4cf388bce48855d1c2f0cd005796fc286a7689ad)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitContrastOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__210d8eabb2435686dc24a783156dee200613298d2edbe1158aaec466c9c1deec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9455e456acb8fb02c29cd9e939a1e16eacc42f138a28804a508f7d80a73130e7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e48f0043c9930aac68da2aefb9dd07e8021fa2868fbd707070a71ca0fa3207a7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitContrast]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitContrast]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__217ffb38882618b845ed92edc378d09185a6b18db153f90c94aa461d9ed8549b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitContrastOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitContrastOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1b3fc65145d35dce68752358864b2e854544d38077c2b0b595cbaaa1adfc0331)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetBrightness")
    def reset_brightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightness", []))

    @jsii.member(jsii_name="resetBrightnessVar")
    def reset_brightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightnessVar", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetContrastVar")
    def reset_contrast_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrastVar", []))

    @builtins.property
    @jsii.member(jsii_name="brightnessInput")
    def brightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="brightnessVarInput")
    def brightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastVarInput")
    def contrast_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="brightness")
    def brightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightness"))

    @brightness.setter
    def brightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c829329e850818b33e4948a41c70f640913dbaf5a796fd944629fda015eb4c57)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightness", value)

    @builtins.property
    @jsii.member(jsii_name="brightnessVar")
    def brightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightnessVar"))

    @brightness_var.setter
    def brightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__efddcf16d53fb050f4afdae04f4e3fd46ea9f05498440364802c004e116e209b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrast"))

    @contrast.setter
    def contrast(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__269a138ea540153c7b2e3c2be67ef36dde8e2e2f68ea34496f9b02b0b22b6109)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrast", value)

    @builtins.property
    @jsii.member(jsii_name="contrastVar")
    def contrast_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrastVar"))

    @contrast_var.setter
    def contrast_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2501e030261e1f32fc3abf68db9ac2d7d80fbc1db64c5bdf29529750726a2c96)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrastVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitContrast]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitContrast]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitContrast]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab326929203d934f71b70641e8287b574b25df6f2901ba3ec63c9dd4ca88e8db)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCrop",
    jsii_struct_bases=[],
    name_mapping={
        "allow_expansion": "allowExpansion",
        "allow_expansion_var": "allowExpansionVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCrop:
    def __init__(
        self,
        *,
        allow_expansion: typing.Optional[builtins.str] = None,
        allow_expansion_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_expansion: If cropping an area outside of the existing canvas, expands the image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        :param allow_expansion_var: If cropping an area outside of the existing canvas, expands the image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        :param gravity: Frame of reference for X and Y Positions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Frame of reference for X and Y Positions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The number of pixels to crop along the y-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The number of pixels to crop along the y-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The number of pixels to crop along the x-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The number of pixels to crop along the x-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        :param x_position: The x-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2efd71023d9118cc4e650cfeb820549e2cbd2ef6cde8a180d135cbc563bd1779)
            check_type(argname="argument allow_expansion", value=allow_expansion, expected_type=type_hints["allow_expansion"])
            check_type(argname="argument allow_expansion_var", value=allow_expansion_var, expected_type=type_hints["allow_expansion_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if allow_expansion is not None:
            self._values["allow_expansion"] = allow_expansion
        if allow_expansion_var is not None:
            self._values["allow_expansion_var"] = allow_expansion_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def allow_expansion(self) -> typing.Optional[builtins.str]:
        '''If cropping an area outside of the existing canvas, expands the image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        '''
        result = self._values.get("allow_expansion")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def allow_expansion_var(self) -> typing.Optional[builtins.str]:
        '''If cropping an area outside of the existing canvas, expands the image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        '''
        result = self._values.get("allow_expansion_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Frame of reference for X and Y Positions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Frame of reference for X and Y Positions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the y-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the y-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the x-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the x-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1468c6ab8a96de834760bcd9133ba72b459eea9542154565f7ebd100f325a6fb)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb5c2631ac11066009761fc78d4e10997ed198becbbd0326cde20269dbfe7c29)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__99897eaafa03f70884b53f1724a34c64938955995052022b23fb4853f94e7dad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c4fd99889c34fff60cb8789c8c75cae8767c7f7120a4d7e4aec649356ce830cc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1948b227e46e42e6c4e879ace75c9c1d7d592130a60616e4b56db980fb1db1e5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ff99c7e442862c35d92c5f1b5b498b2a993f232da87be6dfa85021ba2e30d5f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d01f9b33b033f4cd738bc62665f77b9ac0e7fa0f15ae1bb881f1e68cf27377a0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAllowExpansion")
    def reset_allow_expansion(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansion", []))

    @jsii.member(jsii_name="resetAllowExpansionVar")
    def reset_allow_expansion_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansionVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionInput")
    def allow_expansion_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVarInput")
    def allow_expansion_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansion")
    def allow_expansion(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansion"))

    @allow_expansion.setter
    def allow_expansion(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fd0a17c72b03747ab6e8371cee4a68c8d334de85e3630f69ae2598b2afb41992)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansion", value)

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVar")
    def allow_expansion_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansionVar"))

    @allow_expansion_var.setter
    def allow_expansion_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f744e95fb01aeb9f513596051758c9125b884f5e079538f9cb002a9d74f53da8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansionVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c40a285ff2e90c48d47b87b1bb324d1fae63c791dedb2bd01460e44d07c8e25a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b61703e8a51086a67a3868ae659d799b0c02a5da6a806142c3ff0cb8129d3ab3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3bdfece371d5682209f3ea6eb3d5b088653c84936ed1f3824cbb19ae001d868b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__74818c2ec1adfc899ee587fafcdc58f1618b7813ee9922dbea1d4402af1828a3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b109deb56efbd0fffe5c012ddc05f4d09c9632ad7f0799bc7400e425047b20b5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__90bbaa8fd0054abeb855a431f1e6bf4cd6e54ac6a991cb2498f3be3bab8dbd1b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__15926fa5b0186f86d02ec67511e1cca99898fa31c546604b841eb567fa6c0e4d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c2d133764651a3a394957dde27b3ef2b91e241c88769075355687342a19ba8d8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0bbb352dd06466e8176f5c494bca75c2017ac856a8ac824d1969a16c90056d98)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__53eb05e339c71f475d8ccbfef6e72930af3c45bc4495d2d7a58a8d0bc123a83b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__346ed1117915143e981feb2aeb0584cfe09446917e2feef5c35d77465ce19a7d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitFaceCrop",
    jsii_struct_bases=[],
    name_mapping={
        "algorithm": "algorithm",
        "algorithm_var": "algorithmVar",
        "confidence": "confidence",
        "confidence_var": "confidenceVar",
        "fail_gravity": "failGravity",
        "fail_gravity_var": "failGravityVar",
        "focus": "focus",
        "focus_var": "focusVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "padding": "padding",
        "padding_var": "paddingVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitFaceCrop:
    def __init__(
        self,
        *,
        algorithm: typing.Optional[builtins.str] = None,
        algorithm_var: typing.Optional[builtins.str] = None,
        confidence: typing.Optional[builtins.str] = None,
        confidence_var: typing.Optional[builtins.str] = None,
        fail_gravity: typing.Optional[builtins.str] = None,
        fail_gravity_var: typing.Optional[builtins.str] = None,
        focus: typing.Optional[builtins.str] = None,
        focus_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param algorithm: Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm DataAkamaiImagingPolicyImage#algorithm}
        :param algorithm_var: Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm_var DataAkamaiImagingPolicyImage#algorithm_var}
        :param confidence: With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image. Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence DataAkamaiImagingPolicyImage#confidence}
        :param confidence_var: With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image. Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence_var DataAkamaiImagingPolicyImage#confidence_var}
        :param fail_gravity: Controls placement of the crop if Image and Video Manager does not detect any faces in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        :param fail_gravity_var: Controls placement of the crop if Image and Video Manager does not detect any faces in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        :param focus: Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus DataAkamaiImagingPolicyImage#focus}
        :param focus_var: Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus_var DataAkamaiImagingPolicyImage#focus_var}
        :param gravity: Controls placement of the crop. Directions are relative to the face(s) plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Controls placement of the crop. Directions are relative to the face(s) plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param padding: The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        :param style: Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__edbd8395d6de03433187477ba6ef76f40f73cd1785024de1c55bd21f7193d559)
            check_type(argname="argument algorithm", value=algorithm, expected_type=type_hints["algorithm"])
            check_type(argname="argument algorithm_var", value=algorithm_var, expected_type=type_hints["algorithm_var"])
            check_type(argname="argument confidence", value=confidence, expected_type=type_hints["confidence"])
            check_type(argname="argument confidence_var", value=confidence_var, expected_type=type_hints["confidence_var"])
            check_type(argname="argument fail_gravity", value=fail_gravity, expected_type=type_hints["fail_gravity"])
            check_type(argname="argument fail_gravity_var", value=fail_gravity_var, expected_type=type_hints["fail_gravity_var"])
            check_type(argname="argument focus", value=focus, expected_type=type_hints["focus"])
            check_type(argname="argument focus_var", value=focus_var, expected_type=type_hints["focus_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if algorithm is not None:
            self._values["algorithm"] = algorithm
        if algorithm_var is not None:
            self._values["algorithm_var"] = algorithm_var
        if confidence is not None:
            self._values["confidence"] = confidence
        if confidence_var is not None:
            self._values["confidence_var"] = confidence_var
        if fail_gravity is not None:
            self._values["fail_gravity"] = fail_gravity
        if fail_gravity_var is not None:
            self._values["fail_gravity_var"] = fail_gravity_var
        if focus is not None:
            self._values["focus"] = focus
        if focus_var is not None:
            self._values["focus_var"] = focus_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def algorithm(self) -> typing.Optional[builtins.str]:
        '''Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm DataAkamaiImagingPolicyImage#algorithm}
        '''
        result = self._values.get("algorithm")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def algorithm_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm_var DataAkamaiImagingPolicyImage#algorithm_var}
        '''
        result = self._values.get("algorithm_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def confidence(self) -> typing.Optional[builtins.str]:
        '''With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image.

        Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence DataAkamaiImagingPolicyImage#confidence}
        '''
        result = self._values.get("confidence")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def confidence_var(self) -> typing.Optional[builtins.str]:
        '''With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image.

        Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence_var DataAkamaiImagingPolicyImage#confidence_var}
        '''
        result = self._values.get("confidence_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any faces in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        '''
        result = self._values.get("fail_gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any faces in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        '''
        result = self._values.get("fail_gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def focus(self) -> typing.Optional[builtins.str]:
        '''Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus DataAkamaiImagingPolicyImage#focus}
        '''
        result = self._values.get("focus")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def focus_var(self) -> typing.Optional[builtins.str]:
        '''Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus_var DataAkamaiImagingPolicyImage#focus_var}
        '''
        result = self._values.get("focus_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the face(s) plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the face(s) plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitFaceCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitFaceCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitFaceCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e6b38fb7b7302a32cc71c7a8d4ddffed62fa2e78180dc2d08f8db10d1d9df72e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitFaceCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ae5b1dc5bb79eb9a9c8434c618d288e8bda5b1bdbc7080e6c36590e2dd3037ba)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitFaceCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9dee026189ffd5057667fe16273d9615fcfc4c44f1cecf7ccc8c74681b3b4826)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__59ad060bfcd58ecd2c4c4985d5e718a5f3c044061cc270345fd9e965c8b3b799)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cef223b4ecc7d6508ff7bfb3c870ce3d2da57d3d75ad890c5f1a73e5ef7d96ad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitFaceCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitFaceCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitFaceCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__491182818768268f8c9655dd3f444261079ccfe5ee7f0a1205d6dead16fdf7ae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitFaceCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitFaceCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8677b95aa693d5bfafaae537ce755e39f20d2d8febb20f4392cbcadd22a1c297)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAlgorithm")
    def reset_algorithm(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAlgorithm", []))

    @jsii.member(jsii_name="resetAlgorithmVar")
    def reset_algorithm_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAlgorithmVar", []))

    @jsii.member(jsii_name="resetConfidence")
    def reset_confidence(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetConfidence", []))

    @jsii.member(jsii_name="resetConfidenceVar")
    def reset_confidence_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetConfidenceVar", []))

    @jsii.member(jsii_name="resetFailGravity")
    def reset_fail_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravity", []))

    @jsii.member(jsii_name="resetFailGravityVar")
    def reset_fail_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravityVar", []))

    @jsii.member(jsii_name="resetFocus")
    def reset_focus(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFocus", []))

    @jsii.member(jsii_name="resetFocusVar")
    def reset_focus_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFocusVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="algorithmInput")
    def algorithm_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "algorithmInput"))

    @builtins.property
    @jsii.member(jsii_name="algorithmVarInput")
    def algorithm_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "algorithmVarInput"))

    @builtins.property
    @jsii.member(jsii_name="confidenceInput")
    def confidence_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "confidenceInput"))

    @builtins.property
    @jsii.member(jsii_name="confidenceVarInput")
    def confidence_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "confidenceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityInput")
    def fail_gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityVarInput")
    def fail_gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="focusInput")
    def focus_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "focusInput"))

    @builtins.property
    @jsii.member(jsii_name="focusVarInput")
    def focus_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "focusVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="algorithm")
    def algorithm(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "algorithm"))

    @algorithm.setter
    def algorithm(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__498c36308333f7d2f26e3f78325fe1f8ffab1623272960fd30543b5d6cdfaacd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "algorithm", value)

    @builtins.property
    @jsii.member(jsii_name="algorithmVar")
    def algorithm_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "algorithmVar"))

    @algorithm_var.setter
    def algorithm_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f56af37c313fc5b1a4bab71d400babe328bad8d16c5ebef33f14224edabf6d58)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "algorithmVar", value)

    @builtins.property
    @jsii.member(jsii_name="confidence")
    def confidence(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "confidence"))

    @confidence.setter
    def confidence(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a8fa5bee160256c31cd59ade40c98332297db1d35a3854d30257b01c0609d902)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "confidence", value)

    @builtins.property
    @jsii.member(jsii_name="confidenceVar")
    def confidence_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "confidenceVar"))

    @confidence_var.setter
    def confidence_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b11747209e7d7149e27b5b4a37159538057c56655ae15029b03b591b9361a31a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "confidenceVar", value)

    @builtins.property
    @jsii.member(jsii_name="failGravity")
    def fail_gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravity"))

    @fail_gravity.setter
    def fail_gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1a2af1f2b23d4bbb01f5c051b2b1a33d7ee603bbcb9a1cc395cd75e395163995)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravity", value)

    @builtins.property
    @jsii.member(jsii_name="failGravityVar")
    def fail_gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravityVar"))

    @fail_gravity_var.setter
    def fail_gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d149e26d6d4c281b73824efab732de8fee795ef372924a7918883589e8aa62d4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="focus")
    def focus(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "focus"))

    @focus.setter
    def focus(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a3a17a4b5d501bce4d19a4404b2f40a72a3aea1a4bead18cb5c1c346d7b70faf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "focus", value)

    @builtins.property
    @jsii.member(jsii_name="focusVar")
    def focus_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "focusVar"))

    @focus_var.setter
    def focus_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__71e6c4458baff37025fd75f83297d20685ec23cde2c8a11c4332358bd773bd77)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "focusVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a0c409cf8764c628a1195820d9a083d8e3a206ed4134027314a4edeff27e7d46)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__86983999f8cd2b973d363b69dade14936b2fb427eef234a5a9d24bb2e5b8b56c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2f25ea7678e9fbd035cb29ed5bdeb89b73c602006ade62a5508321cff405978c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3d79384589510968ab6def4bd036686ff9693dbc39557d6ed0e51e97243ff1d5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6d17cde3996a36da8572bf35a6069ae0a29d4ddaf60b405261b6a18527b4dfef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c09eb55823ad75d61208cba4cfd576832603740ce79eb559ca964c2de5a4c134)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c11a36f8eef306456b842ddf0fb2500c19b9599f653bfabb50d81869825cc38c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e4efe2d2abc2a65e64b79f32d203f00a556a575955c4bb8ae5aed4392ef59188)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c0f3d0537893130ff3e8567864000a85907d83410c574a1ee7b024faa65da056)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4cfa7815380042dcf6d3493e7b7e9275147f6f4a58f3f158dbe1a13ad14c772c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitFaceCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitFaceCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitFaceCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__769bdbcb930460f44086c0351bcf4daa82a825a955280c9200a03a76390fc9f8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitFeatureCrop",
    jsii_struct_bases=[],
    name_mapping={
        "fail_gravity": "failGravity",
        "fail_gravity_var": "failGravityVar",
        "feature_radius": "featureRadius",
        "feature_radius_var": "featureRadiusVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "max_features": "maxFeatures",
        "max_features_var": "maxFeaturesVar",
        "min_feature_quality": "minFeatureQuality",
        "min_feature_quality_var": "minFeatureQualityVar",
        "padding": "padding",
        "padding_var": "paddingVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitFeatureCrop:
    def __init__(
        self,
        *,
        fail_gravity: typing.Optional[builtins.str] = None,
        fail_gravity_var: typing.Optional[builtins.str] = None,
        feature_radius: typing.Optional[builtins.str] = None,
        feature_radius_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        max_features: typing.Optional[builtins.str] = None,
        max_features_var: typing.Optional[builtins.str] = None,
        min_feature_quality: typing.Optional[builtins.str] = None,
        min_feature_quality_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fail_gravity: Controls placement of the crop if Image and Video Manager does not detect any features in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        :param fail_gravity_var: Controls placement of the crop if Image and Video Manager does not detect any features in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        :param feature_radius: The size in pixels of the important features to search for. If identified, two features never appear closer together than this value, ``8.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius DataAkamaiImagingPolicyImage#feature_radius}
        :param feature_radius_var: The size in pixels of the important features to search for. If identified, two features never appear closer together than this value, ``8.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius_var DataAkamaiImagingPolicyImage#feature_radius_var}
        :param gravity: Controls placement of the crop. Directions are relative to the region of interest plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Controls placement of the crop. Directions are relative to the region of interest plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param max_features: The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features DataAkamaiImagingPolicyImage#max_features}
        :param max_features_var: The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features_var DataAkamaiImagingPolicyImage#max_features_var}
        :param min_feature_quality: Determines the minimum quality level of the feature identified. To consider a feature important, the feature needs to surpass this value. Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality DataAkamaiImagingPolicyImage#min_feature_quality}
        :param min_feature_quality_var: Determines the minimum quality level of the feature identified. To consider a feature important, the feature needs to surpass this value. Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality_var DataAkamaiImagingPolicyImage#min_feature_quality_var}
        :param padding: Adds space around the region of interest. The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: Adds space around the region of interest. The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        :param style: Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac7769e228280ba7302a008b74af1e19e3ffe9f6ded11a364517691c367a04ac)
            check_type(argname="argument fail_gravity", value=fail_gravity, expected_type=type_hints["fail_gravity"])
            check_type(argname="argument fail_gravity_var", value=fail_gravity_var, expected_type=type_hints["fail_gravity_var"])
            check_type(argname="argument feature_radius", value=feature_radius, expected_type=type_hints["feature_radius"])
            check_type(argname="argument feature_radius_var", value=feature_radius_var, expected_type=type_hints["feature_radius_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument max_features", value=max_features, expected_type=type_hints["max_features"])
            check_type(argname="argument max_features_var", value=max_features_var, expected_type=type_hints["max_features_var"])
            check_type(argname="argument min_feature_quality", value=min_feature_quality, expected_type=type_hints["min_feature_quality"])
            check_type(argname="argument min_feature_quality_var", value=min_feature_quality_var, expected_type=type_hints["min_feature_quality_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fail_gravity is not None:
            self._values["fail_gravity"] = fail_gravity
        if fail_gravity_var is not None:
            self._values["fail_gravity_var"] = fail_gravity_var
        if feature_radius is not None:
            self._values["feature_radius"] = feature_radius
        if feature_radius_var is not None:
            self._values["feature_radius_var"] = feature_radius_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if max_features is not None:
            self._values["max_features"] = max_features
        if max_features_var is not None:
            self._values["max_features_var"] = max_features_var
        if min_feature_quality is not None:
            self._values["min_feature_quality"] = min_feature_quality
        if min_feature_quality_var is not None:
            self._values["min_feature_quality_var"] = min_feature_quality_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def fail_gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any features in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        '''
        result = self._values.get("fail_gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any features in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        '''
        result = self._values.get("fail_gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feature_radius(self) -> typing.Optional[builtins.str]:
        '''The size in pixels of the important features to search for.

        If identified, two features never appear closer together than this value, ``8.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius DataAkamaiImagingPolicyImage#feature_radius}
        '''
        result = self._values.get("feature_radius")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feature_radius_var(self) -> typing.Optional[builtins.str]:
        '''The size in pixels of the important features to search for.

        If identified, two features never appear closer together than this value, ``8.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius_var DataAkamaiImagingPolicyImage#feature_radius_var}
        '''
        result = self._values.get("feature_radius_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the region of interest plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the region of interest plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def max_features(self) -> typing.Optional[builtins.str]:
        '''The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features DataAkamaiImagingPolicyImage#max_features}
        '''
        result = self._values.get("max_features")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def max_features_var(self) -> typing.Optional[builtins.str]:
        '''The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features_var DataAkamaiImagingPolicyImage#max_features_var}
        '''
        result = self._values.get("max_features_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def min_feature_quality(self) -> typing.Optional[builtins.str]:
        '''Determines the minimum quality level of the feature identified.

        To consider a feature important, the feature needs to surpass this value.  Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality DataAkamaiImagingPolicyImage#min_feature_quality}
        '''
        result = self._values.get("min_feature_quality")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def min_feature_quality_var(self) -> typing.Optional[builtins.str]:
        '''Determines the minimum quality level of the feature identified.

        To consider a feature important, the feature needs to surpass this value.  Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality_var DataAkamaiImagingPolicyImage#min_feature_quality_var}
        '''
        result = self._values.get("min_feature_quality_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''Adds space around the region of interest.

        The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''Adds space around the region of interest.

        The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitFeatureCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitFeatureCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitFeatureCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__32c6f09225491cef0a195785c1f7c232f60fca270d3a236b0f1ba8cf94a30232)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitFeatureCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0f92d65af53549f995dd5daa60250c2ab516c07831c559bfa4da80a8fc239f2a)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitFeatureCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dc0bddd294f4f8dc21e1aca3c3b15de3eedf9c64c0508c8d0ed5303e837f9f89)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__19309facc6e56fe1470b7658867955dd5c894efbacb752bc8d3b082c22a01b4b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3d2dfdc5d7cae9d65c388c6823323b2fb7376a9d8d75c0b5f6a8bc73505809d9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitFeatureCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitFeatureCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitFeatureCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f77e05ee791a286df57c6b6cb853eb61057f78b633c08aded482c4d47a2cf635)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitFeatureCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitFeatureCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__203796d0b23f955fff6ec6c1a8801e4e58d72a4f78f4a7e80468930723650148)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetFailGravity")
    def reset_fail_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravity", []))

    @jsii.member(jsii_name="resetFailGravityVar")
    def reset_fail_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravityVar", []))

    @jsii.member(jsii_name="resetFeatureRadius")
    def reset_feature_radius(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureRadius", []))

    @jsii.member(jsii_name="resetFeatureRadiusVar")
    def reset_feature_radius_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureRadiusVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetMaxFeatures")
    def reset_max_features(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxFeatures", []))

    @jsii.member(jsii_name="resetMaxFeaturesVar")
    def reset_max_features_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxFeaturesVar", []))

    @jsii.member(jsii_name="resetMinFeatureQuality")
    def reset_min_feature_quality(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMinFeatureQuality", []))

    @jsii.member(jsii_name="resetMinFeatureQualityVar")
    def reset_min_feature_quality_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMinFeatureQualityVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="failGravityInput")
    def fail_gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityVarInput")
    def fail_gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featureRadiusInput")
    def feature_radius_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featureRadiusInput"))

    @builtins.property
    @jsii.member(jsii_name="featureRadiusVarInput")
    def feature_radius_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featureRadiusVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesInput")
    def max_features_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "maxFeaturesInput"))

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesVarInput")
    def max_features_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "maxFeaturesVarInput"))

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityInput")
    def min_feature_quality_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "minFeatureQualityInput"))

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityVarInput")
    def min_feature_quality_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "minFeatureQualityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravity")
    def fail_gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravity"))

    @fail_gravity.setter
    def fail_gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ffef547ae19d1513df7bc934d88aa74644a08ba0b6fd1fd609d74561e25f07cc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravity", value)

    @builtins.property
    @jsii.member(jsii_name="failGravityVar")
    def fail_gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravityVar"))

    @fail_gravity_var.setter
    def fail_gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8bc2829bb52908f98c463304b5a35dd2fbecb4cc6a92b8fcbc7a9b1437b6e402)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="featureRadius")
    def feature_radius(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featureRadius"))

    @feature_radius.setter
    def feature_radius(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__03178d174ba2513400348c3d059aff8920ae8359d8601604c5ce830fb8edfb3b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featureRadius", value)

    @builtins.property
    @jsii.member(jsii_name="featureRadiusVar")
    def feature_radius_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featureRadiusVar"))

    @feature_radius_var.setter
    def feature_radius_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__84869ec5a2cdf3aa895ad99de68b1a6f0317a4898a29fc42d7b20dca9182b9df)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featureRadiusVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a5fc6ec4e50ff64fc50c398dc184b656d57f5c9871df0ac38d90555e750c6317)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6d0ee7a06ba586acb85e043b79b0996cd8bbfbd20743c2e5ca01186eecba2ad2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0f2eef715d920579a5abefb471c5a2809b138d064aa4df3730ca3381dda76552)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4b648c5d8a05d83321097a4f62d92a8f8079cacb109be10fa74353ee6004d68d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="maxFeatures")
    def max_features(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "maxFeatures"))

    @max_features.setter
    def max_features(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c8fd022734bd1941752a9d559c71cc9ae9ee29de3a57df1db52049720f9e7dc6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "maxFeatures", value)

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesVar")
    def max_features_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "maxFeaturesVar"))

    @max_features_var.setter
    def max_features_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8e7f989ea08437b918c196bf04f1f346ad85574b0bb8ab577fa66228dfab752b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "maxFeaturesVar", value)

    @builtins.property
    @jsii.member(jsii_name="minFeatureQuality")
    def min_feature_quality(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "minFeatureQuality"))

    @min_feature_quality.setter
    def min_feature_quality(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__58fbaf1b559579515465e9b5ad26557125ac7e14ad493d8f98fa9ba3c4cb4ec6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "minFeatureQuality", value)

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityVar")
    def min_feature_quality_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "minFeatureQualityVar"))

    @min_feature_quality_var.setter
    def min_feature_quality_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__33ab5aa5f9367b840da18615695bbb6fc4fd948a3f758235a83e80d3fa22869f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "minFeatureQualityVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__60d2c615078cf18b7668fe86e24ec51380bd76156813fac9dbfa6d1c40bb1ca5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d9238cd0eb5a12e3b2fab663355deec9b7acd71b0b2ddb7e6884c29597a72474)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0c94084a8797186597d4d1fd2fbe91bfbbbfb21542fd2fa77f709a2fe73a7b14)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__728da9820d59b1a9423a71d92dfa8fd2572d8c7a3fe89a501092b16a875a7efa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__54d3a3830fc4aba8c6dffa016d83dff81514d9db78fc8710237af47abf6edcdc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2245c9c971b2dc62201a22caf40e6c0484e441358ccb46a28a1049369f63b896)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitFeatureCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitFeatureCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitFeatureCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a6ff2d22b6edea02311e902e1afe78b3c0c75423282fca6dd80173a4d2a6513)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitFitAndFill",
    jsii_struct_bases=[],
    name_mapping={
        "fill_transformation": "fillTransformation",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitFitAndFill:
    def __init__(
        self,
        *,
        fill_transformation: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitFitAndFillFillTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fill_transformation: fill_transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_transformation DataAkamaiImagingPolicyImage#fill_transformation}
        :param height: The height value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The width value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(fill_transformation, dict):
            fill_transformation = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitFitAndFillFillTransformation(**fill_transformation)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f59ecb4933fe1f0f6a3f0ce143f5b74ccf3c148254bfe032c767687581f4f1d)
            check_type(argname="argument fill_transformation", value=fill_transformation, expected_type=type_hints["fill_transformation"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fill_transformation is not None:
            self._values["fill_transformation"] = fill_transformation
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def fill_transformation(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitFitAndFillFillTransformation"]:
        '''fill_transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_transformation DataAkamaiImagingPolicyImage#fill_transformation}
        '''
        result = self._values.get("fill_transformation")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitFitAndFillFillTransformation"], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitFitAndFill(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitFitAndFillFillTransformation",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitFitAndFillFillTransformation:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitFitAndFillFillTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitFitAndFillFillTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitFitAndFillFillTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb6a82a1ecdf09f3f56238be5a71a687e6966170f0797cfffdd717841e42013d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitFitAndFillFillTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitFitAndFillFillTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitFitAndFillFillTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__961a252b764d63b44619c243eeb8d595325d58fae0fb7df68bb9fa2eb205ac48)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitFitAndFillList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitFitAndFillList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__536750b7b99b65e6e22d4c3141ec319b976a0806d46e6e65dbd50255c602d11f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitFitAndFillOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bd567beae22bd9eabb563fca288b5be790a45713182ea0a3ccaad5c12d8a2f9b)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitFitAndFillOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af06307618c29c30e2a3c62cb695e33663e7401162f7785efb457130640bafd2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__34b361289f12265d0f30754f014372add24357390177c55288a44e1837ec9bc4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__48d050689924b6668e18e87a042e9a0fd28fa247d9711a50b771554c56ebfd12)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitFitAndFill]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitFitAndFill]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitFitAndFill]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__193f9fc53b3ea7433532b5b2a235bbe37aa727edae016123a85657f3b25a0389)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitFitAndFillOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitFitAndFillOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0dd1de686743c05e76fcc8b22f2dd76e9b24c8d2bb304d500ca10026908d81ba)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putFillTransformation")
    def put_fill_transformation(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitFitAndFillFillTransformation()

        return typing.cast(None, jsii.invoke(self, "putFillTransformation", [value]))

    @jsii.member(jsii_name="resetFillTransformation")
    def reset_fill_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFillTransformation", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="fillTransformation")
    def fill_transformation(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitFitAndFillFillTransformationOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitFitAndFillFillTransformationOutputReference, jsii.get(self, "fillTransformation"))

    @builtins.property
    @jsii.member(jsii_name="fillTransformationInput")
    def fill_transformation_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitFitAndFillFillTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitFitAndFillFillTransformation], jsii.get(self, "fillTransformationInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c9d53dca32f260d421dd4cae30918881bc911cacb09b579540b256658bcff1cd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c17cd3f0782d5096c65eb9c578f51c9f8d963915890150d7eaaefcff6aced5fc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ff142818c62dbf99befd92be15766eb381e8beeef62b2201828f88dc45f9b571)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__523cba84665b7fd1f7f407894645e4d64fe33b61a11fb561a7eb5a12f3d51e97)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitFitAndFill]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitFitAndFill]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitFitAndFill]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__34a3814899cf76c08a639270e752246f0c6856c21c3bdb48ad68ff6c24d21758)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitGoop",
    jsii_struct_bases=[],
    name_mapping={
        "chaos": "chaos",
        "chaos_var": "chaosVar",
        "density": "density",
        "density_var": "densityVar",
        "power": "power",
        "power_var": "powerVar",
        "seed": "seed",
        "seed_var": "seedVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitGoop:
    def __init__(
        self,
        *,
        chaos: typing.Optional[builtins.str] = None,
        chaos_var: typing.Optional[builtins.str] = None,
        density: typing.Optional[builtins.str] = None,
        density_var: typing.Optional[builtins.str] = None,
        power: typing.Optional[builtins.str] = None,
        power_var: typing.Optional[builtins.str] = None,
        seed: typing.Optional[builtins.str] = None,
        seed_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param chaos: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        :param chaos_var: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        :param density: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        :param density_var: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        :param power: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        :param power_var: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        :param seed: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        :param seed_var: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__181022063b1c8da07af9f66d7a06275a73e120236301435f66cf046ce4ebc72f)
            check_type(argname="argument chaos", value=chaos, expected_type=type_hints["chaos"])
            check_type(argname="argument chaos_var", value=chaos_var, expected_type=type_hints["chaos_var"])
            check_type(argname="argument density", value=density, expected_type=type_hints["density"])
            check_type(argname="argument density_var", value=density_var, expected_type=type_hints["density_var"])
            check_type(argname="argument power", value=power, expected_type=type_hints["power"])
            check_type(argname="argument power_var", value=power_var, expected_type=type_hints["power_var"])
            check_type(argname="argument seed", value=seed, expected_type=type_hints["seed"])
            check_type(argname="argument seed_var", value=seed_var, expected_type=type_hints["seed_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if chaos is not None:
            self._values["chaos"] = chaos
        if chaos_var is not None:
            self._values["chaos_var"] = chaos_var
        if density is not None:
            self._values["density"] = density
        if density_var is not None:
            self._values["density_var"] = density_var
        if power is not None:
            self._values["power"] = power
        if power_var is not None:
            self._values["power_var"] = power_var
        if seed is not None:
            self._values["seed"] = seed
        if seed_var is not None:
            self._values["seed_var"] = seed_var

    @builtins.property
    def chaos(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        '''
        result = self._values.get("chaos")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def chaos_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        '''
        result = self._values.get("chaos_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        '''
        result = self._values.get("density")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density_var(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        '''
        result = self._values.get("density_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        '''
        result = self._values.get("power")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power_var(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        '''
        result = self._values.get("power_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        '''
        result = self._values.get("seed")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed_var(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        result = self._values.get("seed_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitGoop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitGoopList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitGoopList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__656b6e74665dae0f3268c3655c4a273a263145b48958abd53c5fa1b63931e930)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitGoopOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__31c7573097d9a6c66ef0f3706ce1bfd1c733cbbca5414ff3be526a8a3bb572e8)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitGoopOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__efe50544f988b2941f541a2dff2044a18b02855af5522c126e49f5fec2284d0f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b1095989c027ef1d5585795bc0d644991b92fc36bf789cfc4f758169026e2343)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8fc62f9b1b1567f9eea992df5036ffa2c1de669161577dc748fefc37fd3e6c85)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitGoop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitGoop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__089854f949932e866d48e945fe652978d84a63c41910ff16ff48620988e10f22)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitGoopOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitGoopOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9994a3ba0417ac5b174b5e15c6f72c6f0b1fc558afd7b8450e5fd8c1704ebb36)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetChaos")
    def reset_chaos(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaos", []))

    @jsii.member(jsii_name="resetChaosVar")
    def reset_chaos_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaosVar", []))

    @jsii.member(jsii_name="resetDensity")
    def reset_density(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensity", []))

    @jsii.member(jsii_name="resetDensityVar")
    def reset_density_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensityVar", []))

    @jsii.member(jsii_name="resetPower")
    def reset_power(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPower", []))

    @jsii.member(jsii_name="resetPowerVar")
    def reset_power_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPowerVar", []))

    @jsii.member(jsii_name="resetSeed")
    def reset_seed(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeed", []))

    @jsii.member(jsii_name="resetSeedVar")
    def reset_seed_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeedVar", []))

    @builtins.property
    @jsii.member(jsii_name="chaosInput")
    def chaos_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosInput"))

    @builtins.property
    @jsii.member(jsii_name="chaosVarInput")
    def chaos_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosVarInput"))

    @builtins.property
    @jsii.member(jsii_name="densityInput")
    def density_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityInput"))

    @builtins.property
    @jsii.member(jsii_name="densityVarInput")
    def density_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="powerInput")
    def power_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerInput"))

    @builtins.property
    @jsii.member(jsii_name="powerVarInput")
    def power_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerVarInput"))

    @builtins.property
    @jsii.member(jsii_name="seedInput")
    def seed_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedInput"))

    @builtins.property
    @jsii.member(jsii_name="seedVarInput")
    def seed_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedVarInput"))

    @builtins.property
    @jsii.member(jsii_name="chaos")
    def chaos(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaos"))

    @chaos.setter
    def chaos(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__12ec0242e87f6adbfe53699b9c89b9a596741e573afe7d70de18b9c4f563393a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaos", value)

    @builtins.property
    @jsii.member(jsii_name="chaosVar")
    def chaos_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaosVar"))

    @chaos_var.setter
    def chaos_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cde0df3181f7574c1ba53c5b65c4b1f6c59da72f24f6079266e5e3aaf753429e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaosVar", value)

    @builtins.property
    @jsii.member(jsii_name="density")
    def density(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "density"))

    @density.setter
    def density(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e523595775250990206a4624fd619c5cca3d3fbe87a022d8be89aa879c83ea86)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "density", value)

    @builtins.property
    @jsii.member(jsii_name="densityVar")
    def density_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "densityVar"))

    @density_var.setter
    def density_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ba779d1d0ebea5738ba321b1e3e075963dd76c78fffb68ee09f9348294f1dfa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "densityVar", value)

    @builtins.property
    @jsii.member(jsii_name="power")
    def power(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "power"))

    @power.setter
    def power(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cde0716c09c97e2bb7d89d3c1c98484c8698e0c8069230bdf7088ae959fade71)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "power", value)

    @builtins.property
    @jsii.member(jsii_name="powerVar")
    def power_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "powerVar"))

    @power_var.setter
    def power_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__46e5f1dcfbb4277728e38272a0dfa38c3e05093bfab3cd43fa80ae1980decff0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "powerVar", value)

    @builtins.property
    @jsii.member(jsii_name="seed")
    def seed(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seed"))

    @seed.setter
    def seed(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9851b2b17759bbab9f29bef1a7737780e2cdb7e7e70facc0e12fd2a35988bbc4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seed", value)

    @builtins.property
    @jsii.member(jsii_name="seedVar")
    def seed_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seedVar"))

    @seed_var.setter
    def seed_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7dee1d6b8e5fc4b3cbf0e3594e2789d28c9fae8b2785bdf366a14f11866f9623)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seedVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitGoop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitGoop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitGoop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2109b2900025b1590e1ef51e419b49f34f2a64cb43d65b641e62f0afc04d318b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitGrayscale",
    jsii_struct_bases=[],
    name_mapping={"type": "type", "type_var": "typeVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitGrayscale:
    def __init__(
        self,
        *,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param type: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c72a81aab4c04d450a12d68f01e6a5aeeb4b51eb78561df7c00a395086a1a9a0)
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitGrayscale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitGrayscaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitGrayscaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__431887b9cb904c3e98c9be3ea5c9673ac0eb1af04e7248d83abcffbd9ab2e31d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitGrayscaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3fc1c3928b096edaaac6dc945bdc51972635653279ba927dd85e176745858dce)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitGrayscaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b557fc827c320129f033ea3a9b6769f0d7bd598a08156c90f58e15d9c5a49baf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d1a741ff990812ff61ec7c03cccc7ae9db8c7d43bf0631695c2792e21ec4918)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__554838a3445b2f9a3914063c486287f1eee714a829da52e81f2f8147a600e27e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitGrayscale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitGrayscale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f3949154196933cca005b8fd32387286d594c27bdd1f75c54c50a26b989302b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitGrayscaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitGrayscaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6960319abfc9f183e98246525148146d9b79897bb1cbcf711f5315e9167d114c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1ec3f23955d6587824318f70bf232bec06e86fed8fbdea969d18f0ffa460cfef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c3c93e6297fce6b1fd482ea04bb884a5029a8d25b8cc81ca6a6d817aee4c41a4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitGrayscale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitGrayscale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitGrayscale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7bcb568926629c215081d193d98c07f64ab7e2cc07032304520983a64226316d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitHsl",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "lightness": "lightness",
        "lightness_var": "lightnessVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitHsl:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness: typing.Optional[builtins.str] = None,
        lightness_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        :param lightness_var: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2da70d729049678eac2626fb52f98d8561d009befe44b3d74fd4928f28c32c22)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness", value=lightness, expected_type=type_hints["lightness"])
            check_type(argname="argument lightness_var", value=lightness_var, expected_type=type_hints["lightness_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness is not None:
            self._values["lightness"] = lightness
        if lightness_var is not None:
            self._values["lightness_var"] = lightness_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        '''
        result = self._values.get("lightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        '''
        result = self._values.get("lightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitHsl(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitHslList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitHslList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a19624c668424e60d88b39f084d12d2c33d679c83956067d2ce1b5c8f0ad63a8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitHslOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__67a0c64df81b24e86d4528ddfdde133d57e8581e38a5482f95c74bf9efd4a7de)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitHslOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0f4cc32b1138aaaa2df3fc24b36934cefe839042b3807a4909c540bdc7fde7ee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5bcd7e37620d2ca303fa98290476268db480e7bb553558d036e59ec9668e3b0e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aa7c1711e496b1c54d8b8fbfad933fd873b7338fd4b5490c0a4d206379fc983e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitHsl]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitHsl]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__55638951ac827be06d2b072918eaa66b5a5af50b9eb4a46b5d3532f1faa1e046)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitHslOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitHslOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3357a819a614842032ac2a0094a05de4178c97853bf8b59c4779634f7f945609)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightness")
    def reset_lightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightness", []))

    @jsii.member(jsii_name="resetLightnessVar")
    def reset_lightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessInput")
    def lightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessVarInput")
    def lightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fe275783e9557b6e85d377408ba1d15f12c26b7dc3e4ae83d700dcc425d9006d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5532d5fd0d9cc3a0bfe92b77d38c30770c883fa36d2b8c11cfe5d846fefeceed)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightness")
    def lightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightness"))

    @lightness.setter
    def lightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f0f1e53d8355468a5280d2b66a99522fcaa6f8438eafbcd0cb487eaf932c3f51)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightness", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessVar")
    def lightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessVar"))

    @lightness_var.setter
    def lightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0f9c2a157843f24edc5daa24116b7a9112871f91bd136abaf5443ac4064fe40e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5b282dd7b4557b3eb5fd43f15a273f28b4bfe826df25dd852bc0afc960eeedd4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f954d17279eb5dcb9f9a1e7b0f2019bb31747c4a6802fca8ec3bb949e53b2e1d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitHsl]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitHsl]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitHsl]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__da6a516ee7e129bf21e8c2a974a081d5d14b9fae3860aba3a6e7bc762b0fbb5b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitHsv",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitHsv:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        :param value: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a851ddd29660f0f36b6cc8c7539069e84b02b1a4100e9059f9e9eb8e4fe11ba0)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitHsv(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitHsvList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitHsvList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bf403f6544d761a67bf76bbb550bc468a6a69ba39f3c66a49b059ac6a8d6a8e6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitHsvOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__243a07dd8b357dc85462d3e9b390f045765d5b223154dce12a9bee212fcded5a)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitHsvOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d1fdbf3df9e3d98317405e1e5befb1a7a3d3813490aebbed2779b454609d5c63)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__096550e009871d3ce0e4592e3e2df4af8ffd1feee8202981ce3e51c9747b877f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ca3cbcc435990fc31d87b62a1f1d8d11c51e634925a00582077e236d3cb185d1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitHsv]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitHsv]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f67da8262c0e6d6d3a78beb720bf321ff2a88af249917ccfd975f9aa62fc39e5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitHsvOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitHsvOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a7fd2f8682cf53afc2eec6dbcf55c9fb013f65feda24f95d0eb15f199f36e9c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ed9334804d65258adc3dea5f1dc50840142fad94d6819e203d3d86ce96cebdc7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b2cb9d65422fa980a7de0b3c4d91e1c3b6dfb52b21a49ade9f9eabeee32ffe91)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__93ec4cb4b3e0e23cdd5243333dad53a3c39ad6f0281149c9bd4d3c5edcbda72b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7b68c41899d36104b0fc85255ab5d0bce99b18c8d011a42f97a63261369af882)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__444a209bbbcb32cc886d28f34a21f2bd2b0a88744dd77860fa07ad88954de75e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b0058bfa9476b562efb079618373715bd9144a44b4e7389f8ee8a437dbc133ce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitHsv]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitHsv]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitHsv]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3cb882aa94ec15cad9450343da8a2f5c65744fbe6ee4279cfe45aff0a1df19c7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimension",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "dimension": "dimension",
        "dimension_var": "dimensionVar",
        "equal": "equal",
        "greater_than": "greaterThan",
        "less_than": "lessThan",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimension:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimensionDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        dimension: typing.Optional[builtins.str] = None,
        dimension_var: typing.Optional[builtins.str] = None,
        equal: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimensionEqual", typing.Dict[builtins.str, typing.Any]]] = None,
        greater_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimensionGreaterThan", typing.Dict[builtins.str, typing.Any]]] = None,
        less_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimensionLessThan", typing.Dict[builtins.str, typing.Any]]] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param dimension: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        :param dimension_var: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        :param equal: equal block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        :param greater_than: greater_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        :param less_than: less_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        :param value: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimensionDefault(**default)
        if isinstance(equal, dict):
            equal = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimensionEqual(**equal)
        if isinstance(greater_than, dict):
            greater_than = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimensionGreaterThan(**greater_than)
        if isinstance(less_than, dict):
            less_than = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimensionLessThan(**less_than)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__69cc65dc3a72637835af8e69ba3393ed57509d765b0b2b520e48197f0c67f67e)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument dimension", value=dimension, expected_type=type_hints["dimension"])
            check_type(argname="argument dimension_var", value=dimension_var, expected_type=type_hints["dimension_var"])
            check_type(argname="argument equal", value=equal, expected_type=type_hints["equal"])
            check_type(argname="argument greater_than", value=greater_than, expected_type=type_hints["greater_than"])
            check_type(argname="argument less_than", value=less_than, expected_type=type_hints["less_than"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if dimension is not None:
            self._values["dimension"] = dimension
        if dimension_var is not None:
            self._values["dimension_var"] = dimension_var
        if equal is not None:
            self._values["equal"] = equal
        if greater_than is not None:
            self._values["greater_than"] = greater_than
        if less_than is not None:
            self._values["less_than"] = less_than
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimensionDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimensionDefault"], result)

    @builtins.property
    def dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        '''
        result = self._values.get("dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        '''
        result = self._values.get("dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def equal(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimensionEqual"]:
        '''equal block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        '''
        result = self._values.get("equal")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimensionEqual"], result)

    @builtins.property
    def greater_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimensionGreaterThan"]:
        '''greater_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        '''
        result = self._values.get("greater_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimensionGreaterThan"], result)

    @builtins.property
    def less_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimensionLessThan"]:
        '''less_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        '''
        result = self._values.get("less_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimensionLessThan"], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimension(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimensionDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimensionDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimensionDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimensionDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimensionDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4951ed8291bc936b7ec362aa6edbd92f7987af7a289ca7232fa86163375a4e37)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimensionDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimensionDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac5c75c320213e45e16b18d7817d034596845cf20a9966fb60d5f5898d18ed78)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimensionEqual",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimensionEqual:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimensionEqual(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimensionEqualOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimensionEqualOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dd9a4e0704e17e2c69522b2acf89b770f2a41866d3e4f683d93943b0564c3db6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimensionEqual], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimensionEqual],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5a6f9787251ecfa41b03ae100c854b733a9ff4688d5967bd107b3812cb59815d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimensionGreaterThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimensionGreaterThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimensionGreaterThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimensionGreaterThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimensionGreaterThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cf210898b98c3744b7f753ae187e35430209a8e31fe64169c0b71afffef2ac10)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimensionGreaterThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimensionGreaterThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__865c8f1d0a212fa2ac5bfa5746fdd0f6b142f213d4517797d069c8681343958c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimensionLessThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimensionLessThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimensionLessThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimensionLessThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimensionLessThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1d5de072c305ab46b054ddc5e8f8a887217e2dec44c92dbbb258a9f06828a5fb)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimensionLessThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimensionLessThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1a8501575582f06bca9b67d6d1d45a24284033d2a958a75b8794bb9d276037d4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimensionList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimensionList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c2c7db7100894cc97ee55a5ceef983978efd56bd3c7e046ceda07ba47af45c4f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimensionOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__58f6e419699da1611c9b0869d71d0e83f09003fd734efd71a1e3463a5b836fda)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimensionOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1b76a3de4026b9e19305545de3eedc97cc1bb13b91a2c62c6167c6fd5a818530)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cdafda4774e386ba481b7595087f32b88e44e0c83b28b52cfa2f7e2092eb9be5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__984a79d24cbf3c65ea1ef4f434ac78065664971e8bd2be228e0658ffde63709c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimension]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimension]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__639cc56a19ccbc6617376b1d2e958092344805d60650e5b59a2fb744ebca22da)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimensionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimensionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__242b51e8445e5806c6bac2ad364bde79e76dfd357a03bac740c6fbf457fec266)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimensionDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putEqual")
    def put_equal(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimensionEqual()

        return typing.cast(None, jsii.invoke(self, "putEqual", [value]))

    @jsii.member(jsii_name="putGreaterThan")
    def put_greater_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimensionGreaterThan()

        return typing.cast(None, jsii.invoke(self, "putGreaterThan", [value]))

    @jsii.member(jsii_name="putLessThan")
    def put_less_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimensionLessThan()

        return typing.cast(None, jsii.invoke(self, "putLessThan", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetDimension")
    def reset_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimension", []))

    @jsii.member(jsii_name="resetDimensionVar")
    def reset_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimensionVar", []))

    @jsii.member(jsii_name="resetEqual")
    def reset_equal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEqual", []))

    @jsii.member(jsii_name="resetGreaterThan")
    def reset_greater_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGreaterThan", []))

    @jsii.member(jsii_name="resetLessThan")
    def reset_less_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLessThan", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimensionDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimensionDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="equal")
    def equal(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimensionEqualOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimensionEqualOutputReference, jsii.get(self, "equal"))

    @builtins.property
    @jsii.member(jsii_name="greaterThan")
    def greater_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimensionGreaterThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimensionGreaterThanOutputReference, jsii.get(self, "greaterThan"))

    @builtins.property
    @jsii.member(jsii_name="lessThan")
    def less_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimensionLessThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimensionLessThanOutputReference, jsii.get(self, "lessThan"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimensionDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionInput")
    def dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionVarInput")
    def dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="equalInput")
    def equal_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimensionEqual], jsii.get(self, "equalInput"))

    @builtins.property
    @jsii.member(jsii_name="greaterThanInput")
    def greater_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimensionGreaterThan], jsii.get(self, "greaterThanInput"))

    @builtins.property
    @jsii.member(jsii_name="lessThanInput")
    def less_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimensionLessThan], jsii.get(self, "lessThanInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="dimension")
    def dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimension"))

    @dimension.setter
    def dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__276507b1a3f3d6f8d57a271bac2e21a4403bcdd10cf49063ae41ab180500ec2c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimension", value)

    @builtins.property
    @jsii.member(jsii_name="dimensionVar")
    def dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimensionVar"))

    @dimension_var.setter
    def dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6cd1f2da27caa4f85e0f520895ae2ad11f8ea7f4495ac1e21194868eda7ad553)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b44c0a8e2599bcd95641039245fa6dac9257fef208d208252cdb69b8b1c8670d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1dabe34b9a2488832eea3942253f4ed9e0365eb197c596a718236baf87781d37)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimension]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimension]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimension]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__95a6bea1257db38688155c0bb5f8eeb9e3ffaaf5ac1b1cf13d19ed4ebf918cd6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientation",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "landscape": "landscape",
        "portrait": "portrait",
        "square": "square",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientation:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientationDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        landscape: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientationLandscape", typing.Dict[builtins.str, typing.Any]]] = None,
        portrait: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientationPortrait", typing.Dict[builtins.str, typing.Any]]] = None,
        square: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientationSquare", typing.Dict[builtins.str, typing.Any]]] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param landscape: landscape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        :param portrait: portrait block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        :param square: square block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientationDefault(**default)
        if isinstance(landscape, dict):
            landscape = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientationLandscape(**landscape)
        if isinstance(portrait, dict):
            portrait = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientationPortrait(**portrait)
        if isinstance(square, dict):
            square = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientationSquare(**square)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__caa7d5e4e4320f98f57516ed757f25062789abacc3808ca3954def6716fe930a)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument landscape", value=landscape, expected_type=type_hints["landscape"])
            check_type(argname="argument portrait", value=portrait, expected_type=type_hints["portrait"])
            check_type(argname="argument square", value=square, expected_type=type_hints["square"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if landscape is not None:
            self._values["landscape"] = landscape
        if portrait is not None:
            self._values["portrait"] = portrait
        if square is not None:
            self._values["square"] = square

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientationDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientationDefault"], result)

    @builtins.property
    def landscape(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientationLandscape"]:
        '''landscape block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        '''
        result = self._values.get("landscape")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientationLandscape"], result)

    @builtins.property
    def portrait(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientationPortrait"]:
        '''portrait block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        '''
        result = self._values.get("portrait")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientationPortrait"], result)

    @builtins.property
    def square(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientationSquare"]:
        '''square block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        result = self._values.get("square")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientationSquare"], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientationDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientationDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientationDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientationDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientationDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bdf497fc50b0b9c744d5996ded1188181cd58abddbda589a2c8192b8d64409b7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientationDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientationDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a48f06839d23942cf514696efe03fb06725c15707d8babdf5860ab76c55164c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientationLandscape",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientationLandscape:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientationLandscape(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientationLandscapeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientationLandscapeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ea804aa4e6191ecbdbfee88068bf39265b999692fd8b26f9c9294158002d363)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientationLandscape], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientationLandscape],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4fd8177d83ef0b81c8421dad7abd6f7e5d64ba63451e904f4f13410086ddbf99)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientationList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientationList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__99d19b303fa3965450c9efa5871a59df31e7558f4df7129184e98a431a1cc161)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientationOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dfed3d7d1ec64e01a5aa3fbfff67aeb3a0703121c2fa7eb22b996dd65f7699d0)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientationOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__23285de4da4607717a46d4be4c9e5bf1269aaff99bb108e945aa682b55ce0962)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3c2b47078c44227b009822e23777687bc8c7e0e150cfa9da90ad5fcc13330e9d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__073899d9f0f1a44911a0c5d680d1243c9949425f42f3edb08a5847ff918b57f7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientation]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientation]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7a75d5f6b0d3dd2845d94a5f34c14a6e5b2b695860adcda03ef35dc753e49a6e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0b6f9e07797c54f7dad665bf69932d620fbb818bbe7eb81319b6f2da85b7e9e8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientationDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putLandscape")
    def put_landscape(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientationLandscape()

        return typing.cast(None, jsii.invoke(self, "putLandscape", [value]))

    @jsii.member(jsii_name="putPortrait")
    def put_portrait(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientationPortrait()

        return typing.cast(None, jsii.invoke(self, "putPortrait", [value]))

    @jsii.member(jsii_name="putSquare")
    def put_square(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientationSquare()

        return typing.cast(None, jsii.invoke(self, "putSquare", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetLandscape")
    def reset_landscape(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLandscape", []))

    @jsii.member(jsii_name="resetPortrait")
    def reset_portrait(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPortrait", []))

    @jsii.member(jsii_name="resetSquare")
    def reset_square(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSquare", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientationDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientationDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="landscape")
    def landscape(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientationLandscapeOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientationLandscapeOutputReference, jsii.get(self, "landscape"))

    @builtins.property
    @jsii.member(jsii_name="portrait")
    def portrait(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientationPortraitOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientationPortraitOutputReference", jsii.get(self, "portrait"))

    @builtins.property
    @jsii.member(jsii_name="square")
    def square(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientationSquareOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientationSquareOutputReference", jsii.get(self, "square"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientationDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="landscapeInput")
    def landscape_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientationLandscape], jsii.get(self, "landscapeInput"))

    @builtins.property
    @jsii.member(jsii_name="portraitInput")
    def portrait_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientationPortrait"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientationPortrait"], jsii.get(self, "portraitInput"))

    @builtins.property
    @jsii.member(jsii_name="squareInput")
    def square_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientationSquare"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientationSquare"], jsii.get(self, "squareInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientation]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientation]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientation]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dfbae0eed8c320108f4f37378097ba1b053459ed8dbd2d89709b8880f3b0a720)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientationPortrait",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientationPortrait:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientationPortrait(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientationPortraitOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientationPortraitOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8e222eba8d0f0b51c1cae7b796f6b3e97cf204bf68ad9323465b02c71c30ccc3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientationPortrait]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientationPortrait], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientationPortrait],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3281dd69bb11630bf2ae192d93f0376c789ab72eefe83e97aaffcac92eebb634)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientationSquare",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientationSquare:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientationSquare(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientationSquareOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientationSquareOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8e599cc3e1cd7fff5db45ff866cf394e619e740f7003befdd6f69d02ae2e205f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientationSquare]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientationSquare], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientationSquare],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__10b5749456419e33c4f8e70f5856166f5dfe694d7a4e8fcb266492734bc57a4f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitImQuery",
    jsii_struct_bases=[],
    name_mapping={
        "allowed_transformations": "allowedTransformations",
        "query_var": "queryVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitImQuery:
    def __init__(
        self,
        *,
        allowed_transformations: typing.Sequence[builtins.str],
        query_var: builtins.str,
    ) -> None:
        '''
        :param allowed_transformations: Specifies the transformations that can be applied using the query string parameter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allowed_transformations DataAkamaiImagingPolicyImage#allowed_transformations}
        :param query_var: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#query_var DataAkamaiImagingPolicyImage#query_var}.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e09171b3a0f928e409bdca388da3b6d1ae8b1d34289b16bd8ece0a0562c5b0bb)
            check_type(argname="argument allowed_transformations", value=allowed_transformations, expected_type=type_hints["allowed_transformations"])
            check_type(argname="argument query_var", value=query_var, expected_type=type_hints["query_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "allowed_transformations": allowed_transformations,
            "query_var": query_var,
        }

    @builtins.property
    def allowed_transformations(self) -> typing.List[builtins.str]:
        '''Specifies the transformations that can be applied using the query string parameter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allowed_transformations DataAkamaiImagingPolicyImage#allowed_transformations}
        '''
        result = self._values.get("allowed_transformations")
        assert result is not None, "Required property 'allowed_transformations' is missing"
        return typing.cast(typing.List[builtins.str], result)

    @builtins.property
    def query_var(self) -> builtins.str:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#query_var DataAkamaiImagingPolicyImage#query_var}.'''
        result = self._values.get("query_var")
        assert result is not None, "Required property 'query_var' is missing"
        return typing.cast(builtins.str, result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitImQuery(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitImQueryList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitImQueryList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__668b434aa40194bcdf0dca4d2f0b127be389f2c1e56c372a407016de51fad937)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitImQueryOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c1daa7bcc52dd6b81e3daab472fedbfc397cdd6ba0a652f8920e7ff118ba8db6)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitImQueryOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__68e2c36962ec0fe9d947c5b0a3a76a313457f002f210db7e1d648ea86f9d9d1e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a13d093c2f272b1cdde27745c195374968650627eb2018d994af93c71ad1f2b0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c0468b9f48808c1d7202588976876a3357d8fc01bb83063c132bdc249c8df71b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitImQuery]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitImQuery]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitImQuery]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__55268848d99e4ac6bfcd7d7a113ea07c273833e0201ed8a180883f4e153687c4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitImQueryOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitImQueryOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8988638ed1e15834a5aebcbd0465daf540ed68a224d2f2edb8f454bb32f1cba2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @builtins.property
    @jsii.member(jsii_name="allowedTransformationsInput")
    def allowed_transformations_input(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "allowedTransformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="queryVarInput")
    def query_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "queryVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowedTransformations")
    def allowed_transformations(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "allowedTransformations"))

    @allowed_transformations.setter
    def allowed_transformations(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fe057d9c8f28f88125d8408f177c98019df421877979736312bcf402242fcb6e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowedTransformations", value)

    @builtins.property
    @jsii.member(jsii_name="queryVar")
    def query_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "queryVar"))

    @query_var.setter
    def query_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__de7107d82786c6fb220a9bcc941b6809eebb1a6897a1fae039e798dd3a6a27f4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "queryVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitImQuery]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitImQuery]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitImQuery]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dddd13081201203f770812448414b635335001ccc9747ca2448dc85a493c7772)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitMaxColors",
    jsii_struct_bases=[],
    name_mapping={"colors": "colors", "colors_var": "colorsVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitMaxColors:
    def __init__(
        self,
        *,
        colors: typing.Optional[builtins.str] = None,
        colors_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param colors: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        :param colors_var: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a838e62f018d8a4d6b14009f15624fb0a0a3e2e0f6dd5a87eaa947324b8f513)
            check_type(argname="argument colors", value=colors, expected_type=type_hints["colors"])
            check_type(argname="argument colors_var", value=colors_var, expected_type=type_hints["colors_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if colors is not None:
            self._values["colors"] = colors
        if colors_var is not None:
            self._values["colors_var"] = colors_var

    @builtins.property
    def colors(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        '''
        result = self._values.get("colors")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def colors_var(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        result = self._values.get("colors_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitMaxColors(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitMaxColorsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitMaxColorsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e1e7254c0b6137fa4e3b8f4526ea5dfe54d351c1009e3c2159833aed4c170afe)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitMaxColorsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e54fe01390315fb13d07dac23d5392bbfba3d02c4ed70948959705938fcc34fd)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitMaxColorsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__afc473efc9f4e7070e34998e11e96d7aabddda6a26eabfa3f8b638945098214b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__baf6905eb7aa671a096535791cb3fbd647c87b6cf78728d01048b6041eab7f99)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__87634ed882169a92f99d65412348b078f8f7232969a8a94d7d61b94ea73f4805)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitMaxColors]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitMaxColors]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ddcdfb63b70935ef9247a0a9a58278e55bcd825aa974deb3cabb771d9abeddd7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitMaxColorsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitMaxColorsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__423a7da811f76ba0737e7ab6a790f0b7cefa0bc0b2476ea0e3ef3de2430c5f04)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColors")
    def reset_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColors", []))

    @jsii.member(jsii_name="resetColorsVar")
    def reset_colors_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorsVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorsInput")
    def colors_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsInput"))

    @builtins.property
    @jsii.member(jsii_name="colorsVarInput")
    def colors_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsVarInput"))

    @builtins.property
    @jsii.member(jsii_name="colors")
    def colors(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colors"))

    @colors.setter
    def colors(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__49ecb24e76acc485a843035fc9d72675f0e062b056241f0e09b2c0936d288a80)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colors", value)

    @builtins.property
    @jsii.member(jsii_name="colorsVar")
    def colors_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorsVar"))

    @colors_var.setter
    def colors_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__450fd722ac6ddc99928181639ca319b813825162c6639af9a3c2da51adc7bee6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorsVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitMaxColors]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitMaxColors]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitMaxColors]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__65ebaab1a420a9ceee5d309981651496cc6a06a0873f772b0c8dbfb0ea98630b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitMirror",
    jsii_struct_bases=[],
    name_mapping={
        "horizontal": "horizontal",
        "horizontal_var": "horizontalVar",
        "vertical": "vertical",
        "vertical_var": "verticalVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitMirror:
    def __init__(
        self,
        *,
        horizontal: typing.Optional[builtins.str] = None,
        horizontal_var: typing.Optional[builtins.str] = None,
        vertical: typing.Optional[builtins.str] = None,
        vertical_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param horizontal: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        :param horizontal_var: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        :param vertical: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        :param vertical_var: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a514b085beea7be9077c0169c77616986d3bc08998968bbe2ad4e55257a0dcad)
            check_type(argname="argument horizontal", value=horizontal, expected_type=type_hints["horizontal"])
            check_type(argname="argument horizontal_var", value=horizontal_var, expected_type=type_hints["horizontal_var"])
            check_type(argname="argument vertical", value=vertical, expected_type=type_hints["vertical"])
            check_type(argname="argument vertical_var", value=vertical_var, expected_type=type_hints["vertical_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if horizontal is not None:
            self._values["horizontal"] = horizontal
        if horizontal_var is not None:
            self._values["horizontal_var"] = horizontal_var
        if vertical is not None:
            self._values["vertical"] = vertical
        if vertical_var is not None:
            self._values["vertical_var"] = vertical_var

    @builtins.property
    def horizontal(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        '''
        result = self._values.get("horizontal")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def horizontal_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        '''
        result = self._values.get("horizontal_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        '''
        result = self._values.get("vertical")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        result = self._values.get("vertical_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitMirror(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitMirrorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitMirrorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6da0b5bf56841fed3dc50e1b6e0fef62e06939a90e870a58951fd494a4a87a5d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitMirrorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__985e85a165991233f61e2e611ebd15f1b4f9cd74c2fb9ce93704ef85fb2cb491)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitMirrorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__714202ad083ff56fd50b3d7c4e54582852d6ecc52ae7738c62b08ed86d94479b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a19d31f47c54cca57f61a3497637552cf260795272e48bdca13930747f038701)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__25d92cf3a5c63159a4fe6dfeab856e32ee8be49de65169d30709a82a103376b8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitMirror]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitMirror]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bed598eb146ed5c3b7b39bbd76bc93c90a3a383b592d71020b1815234780da3b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitMirrorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitMirrorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fb65e9b9c014adab680273d00abf178af1a0deefa746b2407864b3faaf4c9b7e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHorizontal")
    def reset_horizontal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontal", []))

    @jsii.member(jsii_name="resetHorizontalVar")
    def reset_horizontal_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontalVar", []))

    @jsii.member(jsii_name="resetVertical")
    def reset_vertical(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVertical", []))

    @jsii.member(jsii_name="resetVerticalVar")
    def reset_vertical_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVerticalVar", []))

    @builtins.property
    @jsii.member(jsii_name="horizontalInput")
    def horizontal_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontalVarInput")
    def horizontal_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalInput")
    def vertical_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalVarInput")
    def vertical_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontal")
    def horizontal(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontal"))

    @horizontal.setter
    def horizontal(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1289a20d4d4d8c9b5405cc07fc9c0313e8e3fce04234e9aa33b755881c3b57b6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontal", value)

    @builtins.property
    @jsii.member(jsii_name="horizontalVar")
    def horizontal_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontalVar"))

    @horizontal_var.setter
    def horizontal_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6d5d6a490037c87c0f645bcb14d86db2a49c269ec5676dfd2657e01edbde1fd2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontalVar", value)

    @builtins.property
    @jsii.member(jsii_name="vertical")
    def vertical(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "vertical"))

    @vertical.setter
    def vertical(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__415c72714b296b33b11bae7e9d587d69d32481730d647078d2455c3cf2e976ec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "vertical", value)

    @builtins.property
    @jsii.member(jsii_name="verticalVar")
    def vertical_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "verticalVar"))

    @vertical_var.setter
    def vertical_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d76ba8418368da4575faf0964882ab2b208363dc3c1ebe55e9b221597fcbb61b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "verticalVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitMirror]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitMirror]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitMirror]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d3f945ae71bca6d1d18b57d55298d2f7c77c2a541a2a851696cea50548012f4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitMonoHue",
    jsii_struct_bases=[],
    name_mapping={"hue": "hue", "hue_var": "hueVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitMonoHue:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__262cdbed844992343dad320a37de33d271af448b534efab7750dab820885e9c7)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitMonoHue(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitMonoHueList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitMonoHueList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1e8100bb8a29e8291e3b4742908c8260afbbaf7a974de3e612f49e6f8f405f51)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitMonoHueOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bccf2ec7182e7275949fc4ccc16589fcc3868fe8a90a148db5221a52749dffb5)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitMonoHueOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b45f8bd1bfd1c91bab90f9587e2e05a7f22c49ff277b85dd90293b7153962a7d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d6ce3dce2e6596335e83050e819c262980e548ef99e982fd1ea2b489c380d737)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cab202fc107186b71b4709315259e32881e6cb2ac30e6e658c127891136181ff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitMonoHue]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitMonoHue]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df5a13e5ff8d842183623165d2dde6073a6c8daea909f377630a1fde21604e1e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitMonoHueOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitMonoHueOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cf49f9696ca9ff3069f7cc01f565bdbca2870586aafaf333e24fde7dbb8b846b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac8760c6aba778d1b2f478b475a460a5328376535a9977af1aead0818611c82b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3148d6c6b8a23aa3e62658d5ee78b2c18d7d077008112c6e488cc05f5a6e7189)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitMonoHue]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitMonoHue]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitMonoHue]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__700a7df8a51b7094713c030f1dc64ce6cefe6d1492d0c17d12dd17df28f249e1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitOpacity",
    jsii_struct_bases=[],
    name_mapping={"opacity": "opacity", "opacity_var": "opacityVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitOpacity:
    def __init__(
        self,
        *,
        opacity: typing.Optional[builtins.str] = None,
        opacity_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param opacity: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param opacity_var: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ff55729e1e9980f2b4a6f9185c4d27789cef7226ce42da2c99cd13b0561ff6d6)
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument opacity_var", value=opacity_var, expected_type=type_hints["opacity_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if opacity is not None:
            self._values["opacity"] = opacity
        if opacity_var is not None:
            self._values["opacity_var"] = opacity_var

    @builtins.property
    def opacity(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def opacity_var(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        result = self._values.get("opacity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitOpacity(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitOpacityList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitOpacityList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__174b3bb93c83f899f74496af71d9a8ed256909ec1e76e4b7efc837becea9f583)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitOpacityOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a614360d8cd3d1ae0c41cc19312049edd67522cb4b78015a143a4df2d90422fb)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitOpacityOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a38a9124ac2c12e85aae978a7c5935351360e6d62c703fa9447d6d1f4e9bbe48)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8d31c80179141331a5eb1a0ad2a71973f6283a06228bfa04dea95db3f27955f4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7e1af09fd9c98a61a74441ff144fae2542cbb32f52630e24dfeb42177eb2646e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitOpacity]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitOpacity]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__681e19be0864321f24063aeb5f998a4b9a3694b339d560c9908565b0ed4b6f1c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitOpacityOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitOpacityOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__042f88c378ff3df144a3a64318915499637e00149415fce5f9c92ef4796dc5e2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetOpacityVar")
    def reset_opacity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacityVar", []))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityVarInput")
    def opacity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacity"))

    @opacity.setter
    def opacity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8e0c6ffb42f0be114fcc8cd323ad2504d5d2970138d65072ead1812a0e401e14)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacity", value)

    @builtins.property
    @jsii.member(jsii_name="opacityVar")
    def opacity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacityVar"))

    @opacity_var.setter
    def opacity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__014f95ed4af622670f95f84d4ddeb88a6a3a3205339224de0cd745184f623659)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacityVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitOpacity]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitOpacity]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitOpacity]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b98110f273734a2316cc0269af5d5591a215e607305ad703ffa4a14832122682)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0255c532a984dfc1d4bb7c73aad88c1377ce3569f40b3043e639a6a68f1cc0d5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putAppend")
    def put_append(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitAppend, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bef1b275a2175a451623f909ef5072b2db6d92a6fcc573cb29cbf58dd6c035a5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putAppend", [value]))

    @jsii.member(jsii_name="putAspectCrop")
    def put_aspect_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitAspectCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a0269f201d36c013a4828f8b75d37c6b511fa196a351a42826239676b0c035ed)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putAspectCrop", [value]))

    @jsii.member(jsii_name="putBackgroundColor")
    def put_background_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e4bcc8d0af0f726555188d00795d471b9cf362239b16f152662670ca6fb1f34b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBackgroundColor", [value]))

    @jsii.member(jsii_name="putBlur")
    def put_blur(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitBlur, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0cf9a81425ca3363d6abb819ee994f065ed4ed910d8fc00c6a0e5a0cf23a1299)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBlur", [value]))

    @jsii.member(jsii_name="putChromaKey")
    def put_chroma_key(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitChromaKey, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e91d9a65979b768f21f14ead49b403654d67bebdbf72448de4de6718c0948c7a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putChromaKey", [value]))

    @jsii.member(jsii_name="putComposite")
    def put_composite(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitComposite, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0b17c7b9268fe3e36f74436718381e9eb0a090ffd52426b6b339ac7c3f3345c4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putComposite", [value]))

    @jsii.member(jsii_name="putCompound")
    def put_compound(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCompound, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d3b2bae73ba3a95bd9e2f6a86068d76a62793d3bae34dcce923120b6db080217)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCompound", [value]))

    @jsii.member(jsii_name="putContrast")
    def put_contrast(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitContrast, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7b58648b8218989fd1ee72f1aff83777155c8af00c4fd6da6fe61a2b59728e92)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putContrast", [value]))

    @jsii.member(jsii_name="putCrop")
    def put_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__080c13ac7f4840d0d5be5e44635c7651b7a48e8612c94523fa91fd5ead989938)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCrop", [value]))

    @jsii.member(jsii_name="putFaceCrop")
    def put_face_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitFaceCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fff0ec5810f3b7b5a50d63533533636426fed09435368f0677b4feb51ab7559d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFaceCrop", [value]))

    @jsii.member(jsii_name="putFeatureCrop")
    def put_feature_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitFeatureCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5d1cdb5a5485948acf611adda7da4a2f93cae9bbc3508c3bb5c398f18d0992a5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFeatureCrop", [value]))

    @jsii.member(jsii_name="putFitAndFill")
    def put_fit_and_fill(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitFitAndFill, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a125efcad3096548fa073ebdfd30d8bd71a5e47f3188f494dc961867da626e9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFitAndFill", [value]))

    @jsii.member(jsii_name="putGoop")
    def put_goop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitGoop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6322af4023ebcbdef8d890b86c856f4d56ea47e13f38a338b6f5a7fefc8b16c2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGoop", [value]))

    @jsii.member(jsii_name="putGrayscale")
    def put_grayscale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitGrayscale, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__92a2c1648fa323cbdb7f46d267acf133ae445f5f5111e21d4bd4da4047fc0e90)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGrayscale", [value]))

    @jsii.member(jsii_name="putHsl")
    def put_hsl(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitHsl, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c407856ec26800b1cebf46d70a3539320b4e3698009890f0e42515828da7faf0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsl", [value]))

    @jsii.member(jsii_name="putHsv")
    def put_hsv(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitHsv, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1657679af153df11b591b9ac2b69a843b1ed0ca23659ecd95530c0f64c891269)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsv", [value]))

    @jsii.member(jsii_name="putIfDimension")
    def put_if_dimension(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimension, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f8420a974162869cc3d6cfa3c0a33fe7c0793cd5a1ae820a4d2a5a36481e164)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfDimension", [value]))

    @jsii.member(jsii_name="putIfOrientation")
    def put_if_orientation(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c21b53904a80187e41a52d7756df789e7a56e4d57caaf53966ad024d341410a9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfOrientation", [value]))

    @jsii.member(jsii_name="putImQuery")
    def put_im_query(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitImQuery, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fea8cb63f0ad4377a312abe9bebfc5cbbd44f8d6d4631d3d0b0dc5aa30fdb20f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putImQuery", [value]))

    @jsii.member(jsii_name="putMaxColors")
    def put_max_colors(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitMaxColors, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__92c6b624973f5dd96164fc9574335a1d528c8c4a1f0e201e351cbbab28ed90fc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMaxColors", [value]))

    @jsii.member(jsii_name="putMirror")
    def put_mirror(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitMirror, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__30341379dcb9465340e11057dd28df36110969ecea7cbec42010be862d2ed819)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMirror", [value]))

    @jsii.member(jsii_name="putMonoHue")
    def put_mono_hue(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitMonoHue, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0fd60dab1a31c4b3bc52bf83a7f173b3b6a7f6db2a55139178e052bdf3932dda)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMonoHue", [value]))

    @jsii.member(jsii_name="putOpacity")
    def put_opacity(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitOpacity, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__078cc4925242b0e6e4afc6e8978ab199896c3de1fde554a79ba9f98f478e5d69)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putOpacity", [value]))

    @jsii.member(jsii_name="putRegionOfInterestCrop")
    def put_region_of_interest_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRegionOfInterestCrop", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__088d7e876974c1463736435928c8c515c6a2b0c92be3265e5f9aba7a07fdf31a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRegionOfInterestCrop", [value]))

    @jsii.member(jsii_name="putRelativeCrop")
    def put_relative_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRelativeCrop", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__60559d0a2834d9c6f2d540111ccc1585876a52a2341b2558606f1fc21041bf42)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRelativeCrop", [value]))

    @jsii.member(jsii_name="putRemoveColor")
    def put_remove_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRemoveColor", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b5ba926fde7e4ab208b57dd9f7ff67f5f55c9908efe8d737a0f2374c0f756e6a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRemoveColor", [value]))

    @jsii.member(jsii_name="putResize")
    def put_resize(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitResize", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4bd3a161c2f816a0118010d750ffcf5904471de7192a29c4accf383ac3613d82)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putResize", [value]))

    @jsii.member(jsii_name="putRotate")
    def put_rotate(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRotate", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ff26c86a837fc4edea38f713a1cbf24bf72eb6a4d9a6613c93132489b818d7d4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRotate", [value]))

    @jsii.member(jsii_name="putScale")
    def put_scale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitScale", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5560c224d22296100b308514cc94d78969d01a87f73f3747cdf0d161b902a413)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putScale", [value]))

    @jsii.member(jsii_name="putShear")
    def put_shear(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitShear", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__09706fcd948c66a6162718f1c4daaf0ce655ed76163426162d58f4a1e7598617)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putShear", [value]))

    @jsii.member(jsii_name="putTrim")
    def put_trim(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitTrim", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e617a0bc794da84b0132b4a217f095c3672fe07a8203953819edc6b44326ac91)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTrim", [value]))

    @jsii.member(jsii_name="putUnsharpMask")
    def put_unsharp_mask(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitUnsharpMask", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7268afb982fa6f89e0c653e8bbf340f3ac047b62b25ec051fbca0d097a6902a3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putUnsharpMask", [value]))

    @jsii.member(jsii_name="resetAppend")
    def reset_append(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAppend", []))

    @jsii.member(jsii_name="resetAspectCrop")
    def reset_aspect_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspectCrop", []))

    @jsii.member(jsii_name="resetBackgroundColor")
    def reset_background_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBackgroundColor", []))

    @jsii.member(jsii_name="resetBlur")
    def reset_blur(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBlur", []))

    @jsii.member(jsii_name="resetChromaKey")
    def reset_chroma_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChromaKey", []))

    @jsii.member(jsii_name="resetComposite")
    def reset_composite(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetComposite", []))

    @jsii.member(jsii_name="resetCompound")
    def reset_compound(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCompound", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetCrop")
    def reset_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCrop", []))

    @jsii.member(jsii_name="resetFaceCrop")
    def reset_face_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFaceCrop", []))

    @jsii.member(jsii_name="resetFeatureCrop")
    def reset_feature_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureCrop", []))

    @jsii.member(jsii_name="resetFitAndFill")
    def reset_fit_and_fill(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFitAndFill", []))

    @jsii.member(jsii_name="resetGoop")
    def reset_goop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGoop", []))

    @jsii.member(jsii_name="resetGrayscale")
    def reset_grayscale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGrayscale", []))

    @jsii.member(jsii_name="resetHsl")
    def reset_hsl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsl", []))

    @jsii.member(jsii_name="resetHsv")
    def reset_hsv(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsv", []))

    @jsii.member(jsii_name="resetIfDimension")
    def reset_if_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfDimension", []))

    @jsii.member(jsii_name="resetIfOrientation")
    def reset_if_orientation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfOrientation", []))

    @jsii.member(jsii_name="resetImQuery")
    def reset_im_query(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetImQuery", []))

    @jsii.member(jsii_name="resetMaxColors")
    def reset_max_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxColors", []))

    @jsii.member(jsii_name="resetMirror")
    def reset_mirror(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMirror", []))

    @jsii.member(jsii_name="resetMonoHue")
    def reset_mono_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonoHue", []))

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetRegionOfInterestCrop")
    def reset_region_of_interest_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRegionOfInterestCrop", []))

    @jsii.member(jsii_name="resetRelativeCrop")
    def reset_relative_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRelativeCrop", []))

    @jsii.member(jsii_name="resetRemoveColor")
    def reset_remove_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRemoveColor", []))

    @jsii.member(jsii_name="resetResize")
    def reset_resize(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetResize", []))

    @jsii.member(jsii_name="resetRotate")
    def reset_rotate(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRotate", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetShear")
    def reset_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetShear", []))

    @jsii.member(jsii_name="resetTrim")
    def reset_trim(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTrim", []))

    @jsii.member(jsii_name="resetUnsharpMask")
    def reset_unsharp_mask(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUnsharpMask", []))

    @builtins.property
    @jsii.member(jsii_name="append")
    def append(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitAppendList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitAppendList, jsii.get(self, "append"))

    @builtins.property
    @jsii.member(jsii_name="aspectCrop")
    def aspect_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitAspectCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitAspectCropList, jsii.get(self, "aspectCrop"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColor")
    def background_color(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitBackgroundColorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitBackgroundColorList, jsii.get(self, "backgroundColor"))

    @builtins.property
    @jsii.member(jsii_name="blur")
    def blur(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitBlurList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitBlurList, jsii.get(self, "blur"))

    @builtins.property
    @jsii.member(jsii_name="chromaKey")
    def chroma_key(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitChromaKeyList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitChromaKeyList, jsii.get(self, "chromaKey"))

    @builtins.property
    @jsii.member(jsii_name="composite")
    def composite(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCompositeList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCompositeList, jsii.get(self, "composite"))

    @builtins.property
    @jsii.member(jsii_name="compound")
    def compound(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCompoundList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCompoundList, jsii.get(self, "compound"))

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitContrastList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitContrastList, jsii.get(self, "contrast"))

    @builtins.property
    @jsii.member(jsii_name="crop")
    def crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCropList, jsii.get(self, "crop"))

    @builtins.property
    @jsii.member(jsii_name="faceCrop")
    def face_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitFaceCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitFaceCropList, jsii.get(self, "faceCrop"))

    @builtins.property
    @jsii.member(jsii_name="featureCrop")
    def feature_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitFeatureCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitFeatureCropList, jsii.get(self, "featureCrop"))

    @builtins.property
    @jsii.member(jsii_name="fitAndFill")
    def fit_and_fill(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitFitAndFillList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitFitAndFillList, jsii.get(self, "fitAndFill"))

    @builtins.property
    @jsii.member(jsii_name="goop")
    def goop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitGoopList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitGoopList, jsii.get(self, "goop"))

    @builtins.property
    @jsii.member(jsii_name="grayscale")
    def grayscale(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitGrayscaleList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitGrayscaleList, jsii.get(self, "grayscale"))

    @builtins.property
    @jsii.member(jsii_name="hsl")
    def hsl(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitHslList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitHslList, jsii.get(self, "hsl"))

    @builtins.property
    @jsii.member(jsii_name="hsv")
    def hsv(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitHsvList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitHsvList, jsii.get(self, "hsv"))

    @builtins.property
    @jsii.member(jsii_name="ifDimension")
    def if_dimension(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimensionList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimensionList, jsii.get(self, "ifDimension"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientation")
    def if_orientation(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientationList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientationList, jsii.get(self, "ifOrientation"))

    @builtins.property
    @jsii.member(jsii_name="imQuery")
    def im_query(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitImQueryList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitImQueryList, jsii.get(self, "imQuery"))

    @builtins.property
    @jsii.member(jsii_name="maxColors")
    def max_colors(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitMaxColorsList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitMaxColorsList, jsii.get(self, "maxColors"))

    @builtins.property
    @jsii.member(jsii_name="mirror")
    def mirror(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitMirrorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitMirrorList, jsii.get(self, "mirror"))

    @builtins.property
    @jsii.member(jsii_name="monoHue")
    def mono_hue(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitMonoHueList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitMonoHueList, jsii.get(self, "monoHue"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitOpacityList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitOpacityList, jsii.get(self, "opacity"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestCrop")
    def region_of_interest_crop(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRegionOfInterestCropList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRegionOfInterestCropList", jsii.get(self, "regionOfInterestCrop"))

    @builtins.property
    @jsii.member(jsii_name="relativeCrop")
    def relative_crop(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRelativeCropList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRelativeCropList", jsii.get(self, "relativeCrop"))

    @builtins.property
    @jsii.member(jsii_name="removeColor")
    def remove_color(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRemoveColorList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRemoveColorList", jsii.get(self, "removeColor"))

    @builtins.property
    @jsii.member(jsii_name="resize")
    def resize(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitResizeList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitResizeList", jsii.get(self, "resize"))

    @builtins.property
    @jsii.member(jsii_name="rotate")
    def rotate(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRotateList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRotateList", jsii.get(self, "rotate"))

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitScaleList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitScaleList", jsii.get(self, "scale"))

    @builtins.property
    @jsii.member(jsii_name="shear")
    def shear(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitShearList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitShearList", jsii.get(self, "shear"))

    @builtins.property
    @jsii.member(jsii_name="trim")
    def trim(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitTrimList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitTrimList", jsii.get(self, "trim"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMask")
    def unsharp_mask(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitUnsharpMaskList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitUnsharpMaskList", jsii.get(self, "unsharpMask"))

    @builtins.property
    @jsii.member(jsii_name="appendInput")
    def append_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitAppend]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitAppend]]], jsii.get(self, "appendInput"))

    @builtins.property
    @jsii.member(jsii_name="aspectCropInput")
    def aspect_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitAspectCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitAspectCrop]]], jsii.get(self, "aspectCropInput"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColorInput")
    def background_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitBackgroundColor]]], jsii.get(self, "backgroundColorInput"))

    @builtins.property
    @jsii.member(jsii_name="blurInput")
    def blur_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitBlur]]], jsii.get(self, "blurInput"))

    @builtins.property
    @jsii.member(jsii_name="chromaKeyInput")
    def chroma_key_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitChromaKey]]], jsii.get(self, "chromaKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="compositeInput")
    def composite_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitComposite]]], jsii.get(self, "compositeInput"))

    @builtins.property
    @jsii.member(jsii_name="compoundInput")
    def compound_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCompound]]], jsii.get(self, "compoundInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitContrast]]], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="cropInput")
    def crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCrop]]], jsii.get(self, "cropInput"))

    @builtins.property
    @jsii.member(jsii_name="faceCropInput")
    def face_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitFaceCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitFaceCrop]]], jsii.get(self, "faceCropInput"))

    @builtins.property
    @jsii.member(jsii_name="featureCropInput")
    def feature_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitFeatureCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitFeatureCrop]]], jsii.get(self, "featureCropInput"))

    @builtins.property
    @jsii.member(jsii_name="fitAndFillInput")
    def fit_and_fill_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitFitAndFill]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitFitAndFill]]], jsii.get(self, "fitAndFillInput"))

    @builtins.property
    @jsii.member(jsii_name="goopInput")
    def goop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitGoop]]], jsii.get(self, "goopInput"))

    @builtins.property
    @jsii.member(jsii_name="grayscaleInput")
    def grayscale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitGrayscale]]], jsii.get(self, "grayscaleInput"))

    @builtins.property
    @jsii.member(jsii_name="hslInput")
    def hsl_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitHsl]]], jsii.get(self, "hslInput"))

    @builtins.property
    @jsii.member(jsii_name="hsvInput")
    def hsv_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitHsv]]], jsii.get(self, "hsvInput"))

    @builtins.property
    @jsii.member(jsii_name="ifDimensionInput")
    def if_dimension_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimension]]], jsii.get(self, "ifDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientationInput")
    def if_orientation_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientation]]], jsii.get(self, "ifOrientationInput"))

    @builtins.property
    @jsii.member(jsii_name="imQueryInput")
    def im_query_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitImQuery]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitImQuery]]], jsii.get(self, "imQueryInput"))

    @builtins.property
    @jsii.member(jsii_name="maxColorsInput")
    def max_colors_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitMaxColors]]], jsii.get(self, "maxColorsInput"))

    @builtins.property
    @jsii.member(jsii_name="mirrorInput")
    def mirror_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitMirror]]], jsii.get(self, "mirrorInput"))

    @builtins.property
    @jsii.member(jsii_name="monoHueInput")
    def mono_hue_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitMonoHue]]], jsii.get(self, "monoHueInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitOpacity]]], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestCropInput")
    def region_of_interest_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRegionOfInterestCrop"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRegionOfInterestCrop"]]], jsii.get(self, "regionOfInterestCropInput"))

    @builtins.property
    @jsii.member(jsii_name="relativeCropInput")
    def relative_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRelativeCrop"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRelativeCrop"]]], jsii.get(self, "relativeCropInput"))

    @builtins.property
    @jsii.member(jsii_name="removeColorInput")
    def remove_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRemoveColor"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRemoveColor"]]], jsii.get(self, "removeColorInput"))

    @builtins.property
    @jsii.member(jsii_name="resizeInput")
    def resize_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitResize"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitResize"]]], jsii.get(self, "resizeInput"))

    @builtins.property
    @jsii.member(jsii_name="rotateInput")
    def rotate_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRotate"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRotate"]]], jsii.get(self, "rotateInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitScale"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitScale"]]], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="shearInput")
    def shear_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitShear"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitShear"]]], jsii.get(self, "shearInput"))

    @builtins.property
    @jsii.member(jsii_name="trimInput")
    def trim_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitTrim"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitTrim"]]], jsii.get(self, "trimInput"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMaskInput")
    def unsharp_mask_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitUnsharpMask"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitUnsharpMask"]]], jsii.get(self, "unsharpMaskInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortrait]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortrait], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortrait],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c5c551ea04ebec37c5f525fdf7468d40783d17a68545625a5a585aaf6ec0ae05)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRegionOfInterestCrop",
    jsii_struct_bases=[],
    name_mapping={
        "region_of_interest": "regionOfInterest",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRegionOfInterestCrop:
    def __init__(
        self,
        *,
        region_of_interest: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRegionOfInterestCropRegionOfInterest", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param region_of_interest: region_of_interest block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest DataAkamaiImagingPolicyImage#region_of_interest}
        :param gravity: The placement of the crop area relative to the specified area of interest. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: The placement of the crop area relative to the specified area of interest. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param style: Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(region_of_interest, dict):
            region_of_interest = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRegionOfInterestCropRegionOfInterest(**region_of_interest)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__612acd9e79eec1aa1fe1039da7cc89c3a13f8020121ef5136d07ffe71a3af65b)
            check_type(argname="argument region_of_interest", value=region_of_interest, expected_type=type_hints["region_of_interest"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "region_of_interest": region_of_interest,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def region_of_interest(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRegionOfInterestCropRegionOfInterest":
        '''region_of_interest block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest DataAkamaiImagingPolicyImage#region_of_interest}
        '''
        result = self._values.get("region_of_interest")
        assert result is not None, "Required property 'region_of_interest' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRegionOfInterestCropRegionOfInterest", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''The placement of the crop area relative to the specified area of interest.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''The placement of the crop area relative to the specified area of interest.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRegionOfInterestCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRegionOfInterestCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRegionOfInterestCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7f839c3787d2d9aee9ea9c02dbac87427223b93a7314d80769128db3795c3feb)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRegionOfInterestCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d193362c15d0808daa7de34193147e6f7403a0ba5ef072c04383691208b3475c)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRegionOfInterestCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__febf5391983e2d9c9fa5d78292b9a7073073e9fb2689ed45f79bcb26c5a6ec3c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2eaef5bd1d443d02f81c1507e7d7f0766ccf2bd29bd6e7ec3148a7bd061afb92)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5c4561dde7b8cccdaf0e18d22ce560d2388078a7a0fa489e57095d04ff2c33a3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRegionOfInterestCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRegionOfInterestCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRegionOfInterestCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e3fd006d0499722a7deb48975dfdc49e54ca7530643539c7e86e2ca6ecd8210)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRegionOfInterestCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRegionOfInterestCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__844437ee405dc04df58a58b679efb36467f6abfb688eb6f3ca4af2f76cb8d8b9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putRegionOfInterest")
    def put_region_of_interest(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRegionOfInterestCropRegionOfInterest()

        return typing.cast(None, jsii.invoke(self, "putRegionOfInterest", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterest")
    def region_of_interest(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRegionOfInterestCropRegionOfInterestOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRegionOfInterestCropRegionOfInterestOutputReference", jsii.get(self, "regionOfInterest"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestInput")
    def region_of_interest_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRegionOfInterestCropRegionOfInterest"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRegionOfInterestCropRegionOfInterest"], jsii.get(self, "regionOfInterestInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cb464e69e3027ccae4e5a072cbc9b2f0a8cf74e4324c77e717877ecb6cbc1c3d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__86d8b9939218949833c63679b705457460dbf9c032a331ca7c68471746d19090)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6464044b6056d50a62ede7355d06e06a14a4ab9d22bdc6deba7fa9d37821ba37)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eadfbd4492ee4d4c4ff5fede444e5937716c690f332e3c676e418cf5387705b5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ea334ed917c66a29312e81d8c5bfd4f7e9f371fb1b91885bdfaddd3cb710eba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dec8bbfc1d8aee8c32cc0e90b2c730e5dbb216483575adc10491eb81f4baf3bc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7528b7039ccf798c1068f9ecf73c944be603ad29226788aa82411a69bfebbd69)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c045e04ba16226fe96c09e88072155c15125d8d54ea1f9e28df0398e13fa990a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRegionOfInterestCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRegionOfInterestCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRegionOfInterestCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__901f8d75e2889a62ea0402b4fcc2e6e1cf299c0d512cf82383ac19e65695083f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRegionOfInterestCropRegionOfInterest",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRegionOfInterestCropRegionOfInterest:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRegionOfInterestCropRegionOfInterest(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRegionOfInterestCropRegionOfInterestOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRegionOfInterestCropRegionOfInterestOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ef7741fd69f2f32ca436bf715c73b67b94df98a5e7bc39f33275c5195996387)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRegionOfInterestCropRegionOfInterest]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRegionOfInterestCropRegionOfInterest], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRegionOfInterestCropRegionOfInterest],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__167e44cb2ae9d1b5a3eb6a5dd0c6d38531ff7de7d90e824cf06ac240595f1677)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRelativeCrop",
    jsii_struct_bases=[],
    name_mapping={
        "east": "east",
        "east_var": "eastVar",
        "north": "north",
        "north_var": "northVar",
        "south": "south",
        "south_var": "southVar",
        "west": "west",
        "west_var": "westVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRelativeCrop:
    def __init__(
        self,
        *,
        east: typing.Optional[builtins.str] = None,
        east_var: typing.Optional[builtins.str] = None,
        north: typing.Optional[builtins.str] = None,
        north_var: typing.Optional[builtins.str] = None,
        south: typing.Optional[builtins.str] = None,
        south_var: typing.Optional[builtins.str] = None,
        west: typing.Optional[builtins.str] = None,
        west_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param east: The number of pixels to shrink or expand the right side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east DataAkamaiImagingPolicyImage#east}
        :param east_var: The number of pixels to shrink or expand the right side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east_var DataAkamaiImagingPolicyImage#east_var}
        :param north: The number of pixels to shrink or expand the top side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north DataAkamaiImagingPolicyImage#north}
        :param north_var: The number of pixels to shrink or expand the top side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north_var DataAkamaiImagingPolicyImage#north_var}
        :param south: The number of pixels to shrink or expand the bottom side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south DataAkamaiImagingPolicyImage#south}
        :param south_var: The number of pixels to shrink or expand the bottom side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south_var DataAkamaiImagingPolicyImage#south_var}
        :param west: The number of pixels to shrink or expand the left side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west DataAkamaiImagingPolicyImage#west}
        :param west_var: The number of pixels to shrink or expand the left side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west_var DataAkamaiImagingPolicyImage#west_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d4268d36f16cce9cbac250b39b344a1af22ecd586c4720e88c36a056cd9f60f5)
            check_type(argname="argument east", value=east, expected_type=type_hints["east"])
            check_type(argname="argument east_var", value=east_var, expected_type=type_hints["east_var"])
            check_type(argname="argument north", value=north, expected_type=type_hints["north"])
            check_type(argname="argument north_var", value=north_var, expected_type=type_hints["north_var"])
            check_type(argname="argument south", value=south, expected_type=type_hints["south"])
            check_type(argname="argument south_var", value=south_var, expected_type=type_hints["south_var"])
            check_type(argname="argument west", value=west, expected_type=type_hints["west"])
            check_type(argname="argument west_var", value=west_var, expected_type=type_hints["west_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if east is not None:
            self._values["east"] = east
        if east_var is not None:
            self._values["east_var"] = east_var
        if north is not None:
            self._values["north"] = north
        if north_var is not None:
            self._values["north_var"] = north_var
        if south is not None:
            self._values["south"] = south
        if south_var is not None:
            self._values["south_var"] = south_var
        if west is not None:
            self._values["west"] = west
        if west_var is not None:
            self._values["west_var"] = west_var

    @builtins.property
    def east(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the right side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east DataAkamaiImagingPolicyImage#east}
        '''
        result = self._values.get("east")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def east_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the right side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east_var DataAkamaiImagingPolicyImage#east_var}
        '''
        result = self._values.get("east_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def north(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the top side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north DataAkamaiImagingPolicyImage#north}
        '''
        result = self._values.get("north")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def north_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the top side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north_var DataAkamaiImagingPolicyImage#north_var}
        '''
        result = self._values.get("north_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def south(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the bottom side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south DataAkamaiImagingPolicyImage#south}
        '''
        result = self._values.get("south")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def south_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the bottom side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south_var DataAkamaiImagingPolicyImage#south_var}
        '''
        result = self._values.get("south_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def west(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the left side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west DataAkamaiImagingPolicyImage#west}
        '''
        result = self._values.get("west")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def west_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the left side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west_var DataAkamaiImagingPolicyImage#west_var}
        '''
        result = self._values.get("west_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRelativeCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRelativeCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRelativeCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8431a20b4ead3c59f29fc63b528bf92e21864c3f4c7d9ce4531fbb51709ebdf6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRelativeCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b0e7ac7e6543787294ac12c7bcee072b9e9c513a4ed3abe75f72cb38afc950b6)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRelativeCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4e70e5e6eefd65f8933475c3f8092661099e80e28590d3b264e449dacea8ff35)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__46fa8f7d3191eed0438eccfc53c259ec5e8d572d901221034287f44b8efefba4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dce4b32f0dd504c6117e6029ae952bb2e17337c065cf18ccea6fd36294d51091)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRelativeCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRelativeCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRelativeCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__62c828e9d2ea68738613da4ff5acf0e54d6b198c6057263de3e73d37e05bba44)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRelativeCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRelativeCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7e9a7042e929d070ba39483017c1d0761eb38157c7231f622817c394699fb19b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetEast")
    def reset_east(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEast", []))

    @jsii.member(jsii_name="resetEastVar")
    def reset_east_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEastVar", []))

    @jsii.member(jsii_name="resetNorth")
    def reset_north(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNorth", []))

    @jsii.member(jsii_name="resetNorthVar")
    def reset_north_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNorthVar", []))

    @jsii.member(jsii_name="resetSouth")
    def reset_south(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSouth", []))

    @jsii.member(jsii_name="resetSouthVar")
    def reset_south_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSouthVar", []))

    @jsii.member(jsii_name="resetWest")
    def reset_west(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWest", []))

    @jsii.member(jsii_name="resetWestVar")
    def reset_west_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWestVar", []))

    @builtins.property
    @jsii.member(jsii_name="eastInput")
    def east_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "eastInput"))

    @builtins.property
    @jsii.member(jsii_name="eastVarInput")
    def east_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "eastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="northInput")
    def north_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "northInput"))

    @builtins.property
    @jsii.member(jsii_name="northVarInput")
    def north_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "northVarInput"))

    @builtins.property
    @jsii.member(jsii_name="southInput")
    def south_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "southInput"))

    @builtins.property
    @jsii.member(jsii_name="southVarInput")
    def south_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "southVarInput"))

    @builtins.property
    @jsii.member(jsii_name="westInput")
    def west_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "westInput"))

    @builtins.property
    @jsii.member(jsii_name="westVarInput")
    def west_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "westVarInput"))

    @builtins.property
    @jsii.member(jsii_name="east")
    def east(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "east"))

    @east.setter
    def east(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__11184f7231ad109e6ef9d72973666089ae8519ee8efd04b0551205ee5118c60e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "east", value)

    @builtins.property
    @jsii.member(jsii_name="eastVar")
    def east_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "eastVar"))

    @east_var.setter
    def east_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bfecbee41807d945332ab4b10a3a3b9d1ea9275d0ffce23a650d0502e904caad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "eastVar", value)

    @builtins.property
    @jsii.member(jsii_name="north")
    def north(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "north"))

    @north.setter
    def north(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__28b7537dcbb28a05033a8c6831d7ad374858092c0edc756971589f495763c905)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "north", value)

    @builtins.property
    @jsii.member(jsii_name="northVar")
    def north_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "northVar"))

    @north_var.setter
    def north_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__42e17a84596f83c5378bb5dd9c106763fe0542810bc997fd67cb5f3bfb347154)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "northVar", value)

    @builtins.property
    @jsii.member(jsii_name="south")
    def south(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "south"))

    @south.setter
    def south(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__caa13bdc8d3de35e6d397e62dc644312202d100d7e912ccd87a10c5a224659fc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "south", value)

    @builtins.property
    @jsii.member(jsii_name="southVar")
    def south_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "southVar"))

    @south_var.setter
    def south_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f97534a9cffcdace9608a5f9213710574d5887ac23d68e9504aaeef8f991477c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "southVar", value)

    @builtins.property
    @jsii.member(jsii_name="west")
    def west(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "west"))

    @west.setter
    def west(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cfdb9d56330ce9f31e015030143d615322b5faa88c89b8177c1ab5c625d406bf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "west", value)

    @builtins.property
    @jsii.member(jsii_name="westVar")
    def west_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "westVar"))

    @west_var.setter
    def west_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__07b428b96b5800e68fa13d2cabc6104d69139d8813fb4bc541faecba363ab638)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "westVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRelativeCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRelativeCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRelativeCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f0e6fae35bd84a1ff18e03e4c13f37621538bca0100b091eab3093b82f778979)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRemoveColor",
    jsii_struct_bases=[],
    name_mapping={
        "color": "color",
        "color_var": "colorVar",
        "feather": "feather",
        "feather_var": "featherVar",
        "tolerance": "tolerance",
        "tolerance_var": "toleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRemoveColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
        feather: typing.Optional[builtins.str] = None,
        feather_var: typing.Optional[builtins.str] = None,
        tolerance: typing.Optional[builtins.str] = None,
        tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        :param feather: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        :param feather_var: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        :param tolerance: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        :param tolerance_var: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ea77cef62741a0e748ba6784a1a7bdb9c97d5f6b7424dcfd66af7b097f9bba1)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
            check_type(argname="argument feather", value=feather, expected_type=type_hints["feather"])
            check_type(argname="argument feather_var", value=feather_var, expected_type=type_hints["feather_var"])
            check_type(argname="argument tolerance", value=tolerance, expected_type=type_hints["tolerance"])
            check_type(argname="argument tolerance_var", value=tolerance_var, expected_type=type_hints["tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var
        if feather is not None:
            self._values["feather"] = feather
        if feather_var is not None:
            self._values["feather_var"] = feather_var
        if tolerance is not None:
            self._values["tolerance"] = tolerance
        if tolerance_var is not None:
            self._values["tolerance_var"] = tolerance_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        '''
        result = self._values.get("feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather_var(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        '''
        result = self._values.get("feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        '''
        result = self._values.get("tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance_var(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        result = self._values.get("tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRemoveColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRemoveColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRemoveColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__91bb77758cf47006d7127939b070e6f84a0843e13714bd690e59879104473987)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRemoveColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__393ff69f77b9808a0516eb7644208593772d4c8c4dbe958b0b8723885ab53d5e)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRemoveColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1fd4a29fd1c9c392cdbb40795ebc7a1c3e0cc8ce5a4301bca1bbfd4752c2b601)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6301996a8bb8393fcc66b4e42be8fd5f9ec55fa3b8151d00bb7fbf242885239b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f2224527fa5a1677479720f9eb7526a0670dceafa2a18334585ec4b64b9b6b21)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRemoveColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRemoveColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRemoveColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ccdd0fc97c5ec4ac8f6d611bf1ab8a3c21f2bd9566459a0100ff7cceb3f911e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRemoveColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRemoveColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dcfb1ccda68fd3c2c2f1a3e01c0d543fa5659af11d29428efba3960fdc2a6dd5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @jsii.member(jsii_name="resetFeather")
    def reset_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeather", []))

    @jsii.member(jsii_name="resetFeatherVar")
    def reset_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatherVar", []))

    @jsii.member(jsii_name="resetTolerance")
    def reset_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTolerance", []))

    @jsii.member(jsii_name="resetToleranceVar")
    def reset_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featherInput")
    def feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherInput"))

    @builtins.property
    @jsii.member(jsii_name="featherVarInput")
    def feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceInput")
    def tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceVarInput")
    def tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2508809e899d550a6ab69318615609eedbb50243a8b6c43ecb3e4205ad29188a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__80f749868ee933427ed3276238d084408f86d34dc8953f707e3208a555ab6cef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="feather")
    def feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "feather"))

    @feather.setter
    def feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__17e0b5c5036cd193f6d2a3e135c48fa9901ab45527a64de0b0be3d7b75058337)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "feather", value)

    @builtins.property
    @jsii.member(jsii_name="featherVar")
    def feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featherVar"))

    @feather_var.setter
    def feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__00c7112b00710e655a55344af9aacb089230dff5e54cb65f14f38b2a6efb3aca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featherVar", value)

    @builtins.property
    @jsii.member(jsii_name="tolerance")
    def tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tolerance"))

    @tolerance.setter
    def tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__56f77e30e496ff70e031b1cb0962846e00b9b7af1bfb01f6445343442595b2e6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tolerance", value)

    @builtins.property
    @jsii.member(jsii_name="toleranceVar")
    def tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "toleranceVar"))

    @tolerance_var.setter
    def tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__47dbdbe154056a0ff2f636d7b2558151dff2c80abbb91b52a32cb70cd6b6f945)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "toleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRemoveColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRemoveColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRemoveColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__23026570c9405a00abe17b4961fb53f8d5010074e7342486634fb0b6395a7341)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitResize",
    jsii_struct_bases=[],
    name_mapping={
        "aspect": "aspect",
        "aspect_var": "aspectVar",
        "height": "height",
        "height_var": "heightVar",
        "type": "type",
        "type_var": "typeVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitResize:
    def __init__(
        self,
        *,
        aspect: typing.Optional[builtins.str] = None,
        aspect_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param aspect: Preserves the aspect ratio. Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect DataAkamaiImagingPolicyImage#aspect}
        :param aspect_var: Preserves the aspect ratio. Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_var DataAkamaiImagingPolicyImage#aspect_var}
        :param height: The height to resize the source image to. Must be set if height is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height to resize the source image to. Must be set if height is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param type: Sets constraints for the image resize. Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: Sets constraints for the image resize. Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        :param width: The width to resize the source image to. Must be set if width is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width to resize the source image to. Must be set if width is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f933542d17b815ae3e6bfc567bf448558510c14bee50dd9049ab1b46174c18a2)
            check_type(argname="argument aspect", value=aspect, expected_type=type_hints["aspect"])
            check_type(argname="argument aspect_var", value=aspect_var, expected_type=type_hints["aspect_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if aspect is not None:
            self._values["aspect"] = aspect
        if aspect_var is not None:
            self._values["aspect_var"] = aspect_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def aspect(self) -> typing.Optional[builtins.str]:
        '''Preserves the aspect ratio.

        Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect DataAkamaiImagingPolicyImage#aspect}
        '''
        result = self._values.get("aspect")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def aspect_var(self) -> typing.Optional[builtins.str]:
        '''Preserves the aspect ratio.

        Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_var DataAkamaiImagingPolicyImage#aspect_var}
        '''
        result = self._values.get("aspect_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height to resize the source image to. Must be set if height is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height to resize the source image to. Must be set if height is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''Sets constraints for the image resize.

        Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''Sets constraints for the image resize.

        Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width to resize the source image to. Must be set if width is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width to resize the source image to. Must be set if width is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitResize(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitResizeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitResizeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d77b076acfa964c08a165d6f997d0a3045b8bf56a295ea27309942393ab0e71a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitResizeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0736ca9a073439a266c1393ffffe1e89ed11d8d156cdd218a7399acefb7f426c)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitResizeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3eb605042d816425785bb7c6555ba8fe55b71a845c2ce5ad7a3b1276df93e1c0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__161ff3763f615f43ae0765a6cfc594367597f30861cef9693dac616d94de9418)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e22661dde0c08e0a9110712483d6c205cfe25b851b00bb7de8135a78cec022c8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitResize]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitResize]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitResize]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e47c6e8e8d645c34c57a7ad9c90b09c4ce0d34f16e3b7afb4577a0620fa18233)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitResizeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitResizeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__81fa2ea0eef072a0de3fb819cb4910d467abb663e8dc224f42691ecf3f73c3d0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAspect")
    def reset_aspect(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspect", []))

    @jsii.member(jsii_name="resetAspectVar")
    def reset_aspect_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspectVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="aspectInput")
    def aspect_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "aspectInput"))

    @builtins.property
    @jsii.member(jsii_name="aspectVarInput")
    def aspect_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "aspectVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="aspect")
    def aspect(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "aspect"))

    @aspect.setter
    def aspect(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__97660078cb0c6de5b0a2d6ec957da8f5afc3ac2c3d30be345a25a865a28ebe73)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "aspect", value)

    @builtins.property
    @jsii.member(jsii_name="aspectVar")
    def aspect_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "aspectVar"))

    @aspect_var.setter
    def aspect_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f9d9927e8655aa843164a57904aeae5dfb1e352023e1e50ba05525a2ecf30d3f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "aspectVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7cbc4fd599a8c4b1063f2262a02adbfa2801f3ec4c58bdb28f37d5aab303850d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aabfdd1aa16f7789c90e530a7af28dfa0272f2da9df5209f9e33fa8de2b050a7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9246d833e6897b378842432d84d31cb33a2b95839e7a3aa0efa37bc806209f93)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3fe3c6d3fb6a4d02833eb5630daab0e81e94f45a3143aa3952ce2232cba72302)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af77e6b2c3097517641b641efa4d02dccda31d19e79c566fe4db9702b9a4219e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__89ce3ca326cc998892861bef01a2b784767e9b899528bc3e97b5bef61d355bf2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitResize]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitResize]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitResize]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__776baf1728a0740f63ac693ff4ae71868b66b142672fe30f6e03d7769df9c337)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRotate",
    jsii_struct_bases=[],
    name_mapping={"degrees": "degrees", "degrees_var": "degreesVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRotate:
    def __init__(
        self,
        *,
        degrees: typing.Optional[builtins.str] = None,
        degrees_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param degrees: The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees DataAkamaiImagingPolicyImage#degrees}
        :param degrees_var: The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees_var DataAkamaiImagingPolicyImage#degrees_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__300a0b6a0c9b15515b75562c884b743052747dcd02ee9fe14b9ae0637ce374b7)
            check_type(argname="argument degrees", value=degrees, expected_type=type_hints["degrees"])
            check_type(argname="argument degrees_var", value=degrees_var, expected_type=type_hints["degrees_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if degrees is not None:
            self._values["degrees"] = degrees
        if degrees_var is not None:
            self._values["degrees_var"] = degrees_var

    @builtins.property
    def degrees(self) -> typing.Optional[builtins.str]:
        '''The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees DataAkamaiImagingPolicyImage#degrees}
        '''
        result = self._values.get("degrees")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def degrees_var(self) -> typing.Optional[builtins.str]:
        '''The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees_var DataAkamaiImagingPolicyImage#degrees_var}
        '''
        result = self._values.get("degrees_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRotate(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRotateList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRotateList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a2455a35bf41cf6903aba8dec7ef18f4e71691c36b58fee292befaf3837ea292)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRotateOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6798fe6227e96b97640b67d51422ab9c05abd0e543936bdc8da90146065860a2)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRotateOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e8f90af089c57e90ccc852f2c8e77820cf47fe3243b7093fd36bfb6c52006fd0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0de14afcafe0cb5ef0db655460cfd7ff75d9e8a801383908a9aa3d0eceae3785)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d1fa525ca37010789c680a94430bf184169a75bd73ad049cad423b1b205733de)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRotate]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRotate]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRotate]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__45fb0420a274d354582624c5465efdd6abc045850e0f8c7380ef5ce70cf01d01)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRotateOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRotateOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9276ea4b37683ba2cdb47281be4b5e97979c209d57600201e910d7288decf712)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetDegrees")
    def reset_degrees(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDegrees", []))

    @jsii.member(jsii_name="resetDegreesVar")
    def reset_degrees_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDegreesVar", []))

    @builtins.property
    @jsii.member(jsii_name="degreesInput")
    def degrees_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "degreesInput"))

    @builtins.property
    @jsii.member(jsii_name="degreesVarInput")
    def degrees_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "degreesVarInput"))

    @builtins.property
    @jsii.member(jsii_name="degrees")
    def degrees(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "degrees"))

    @degrees.setter
    def degrees(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ebe5d8bd719f0646f6e64490c04d27a56eeee58f9588350622fbff079d8096f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "degrees", value)

    @builtins.property
    @jsii.member(jsii_name="degreesVar")
    def degrees_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "degreesVar"))

    @degrees_var.setter
    def degrees_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__765d1fc45a25a376c280d2d24bfff06eadb5c4ad861fc6c03023e7b94493a67d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "degreesVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRotate]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRotate]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRotate]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1547e2bbf993997ac443ea0ff6964b8dace1d61011ae20dc161a2ccd64da8be1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitScale",
    jsii_struct_bases=[],
    name_mapping={
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitScale:
    def __init__(
        self,
        *,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param height: Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged. Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged. Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d52b989ceb52ea00ed0edf0ec7433bcc9643441b699b05006618af18f7e43cd9)
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size.

        Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size.

        Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged.

        Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged.

        Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitScale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitScaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitScaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ced69a7ed0b1b1b257c80644c33cc28ea698c5e64d26ef8e05062b02da0509e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitScaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ecce2d298aff8be3162ae3ea044d060a1b9e4129f80c584a15d625ee123e37f)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitScaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1fa247443fd76fc06dbb07b0c2fe6f3baf95856316601a233070aa1c035df973)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a4d1a520afe05191a27eac9f80090119a14ae8644a0e6cf3c856611995f0a38)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__30335bfb00a181c3cde9ff099c963bfd769b3e24cc6f769311b18c8324d5a229)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitScale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitScale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitScale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__00beab7e1806ca5669ef80ae2e0e0878a6e71c64045df02a8e3d2d1488f4ae9f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitScaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitScaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__703c8702787f3ca5b7937c0f2394210717fffc5ea44884a407739bfe77762cb5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b34307fb8197d5a0eeae105cb5097f8acbec22bbbaf643cd2708d9e23f31ab7d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3d4b55492be21fc32dbc5dc6f309e3c9bf37e286d674a134f28b1cf3c07da469)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__db14161e53ade6f2ecda8183a87664448a4bcb1effe9b3425b68e5688c4da8a0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4cc56176b18f764a5651ddff9f7ca6a59e6ec2f016489f3fbd7bf366ef127610)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitScale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitScale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitScale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__951ddeca19a1b5a5e74b0133e2171168807de41bf0c4c1d477681f382c8f600c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitShear",
    jsii_struct_bases=[],
    name_mapping={
        "x_shear": "xShear",
        "x_shear_var": "xShearVar",
        "y_shear": "yShear",
        "y_shear_var": "yShearVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitShear:
    def __init__(
        self,
        *,
        x_shear: typing.Optional[builtins.str] = None,
        x_shear_var: typing.Optional[builtins.str] = None,
        y_shear: typing.Optional[builtins.str] = None,
        y_shear_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param x_shear: The amount to shear along the x-axis, measured in multiples of the image's width. Must be set if yShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear DataAkamaiImagingPolicyImage#x_shear}
        :param x_shear_var: The amount to shear along the x-axis, measured in multiples of the image's width. Must be set if yShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear_var DataAkamaiImagingPolicyImage#x_shear_var}
        :param y_shear: The amount to shear along the y-axis, measured in multiples of the image's height. Must be set if xShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear DataAkamaiImagingPolicyImage#y_shear}
        :param y_shear_var: The amount to shear along the y-axis, measured in multiples of the image's height. Must be set if xShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear_var DataAkamaiImagingPolicyImage#y_shear_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__99c6efc8ce8f4c9a193331b3b9782bde35fccf0406f0de2f6b66568843d88b73)
            check_type(argname="argument x_shear", value=x_shear, expected_type=type_hints["x_shear"])
            check_type(argname="argument x_shear_var", value=x_shear_var, expected_type=type_hints["x_shear_var"])
            check_type(argname="argument y_shear", value=y_shear, expected_type=type_hints["y_shear"])
            check_type(argname="argument y_shear_var", value=y_shear_var, expected_type=type_hints["y_shear_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if x_shear is not None:
            self._values["x_shear"] = x_shear
        if x_shear_var is not None:
            self._values["x_shear_var"] = x_shear_var
        if y_shear is not None:
            self._values["y_shear"] = y_shear
        if y_shear_var is not None:
            self._values["y_shear_var"] = y_shear_var

    @builtins.property
    def x_shear(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the x-axis, measured in multiples of the image's width.

        Must be set if yShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear DataAkamaiImagingPolicyImage#x_shear}
        '''
        result = self._values.get("x_shear")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_shear_var(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the x-axis, measured in multiples of the image's width.

        Must be set if yShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear_var DataAkamaiImagingPolicyImage#x_shear_var}
        '''
        result = self._values.get("x_shear_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_shear(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the y-axis, measured in multiples of the image's height.

        Must be set if xShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear DataAkamaiImagingPolicyImage#y_shear}
        '''
        result = self._values.get("y_shear")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_shear_var(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the y-axis, measured in multiples of the image's height.

        Must be set if xShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear_var DataAkamaiImagingPolicyImage#y_shear_var}
        '''
        result = self._values.get("y_shear_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitShear(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitShearList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitShearList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__145a110366c53b02d4d1e6f3132a643ba581a693a886242bfceeeb50206f7c10)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitShearOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3040986e3f977c3188b0ea2524ae6dbce8af09ce19db5cb9e5449787a8d9e2f1)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitShearOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ff83e84b04ef597be42801fb8f0101dc9268ef84868f1658eaef149306b431e1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__db1e6db0f0b1cb9e99cff6b11b0d3db6f0ca5c71101b5eff4bd3a74fface0505)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d0ae9d031c80005d04cd5f8d0553e2a6fd3804023ffac02294059bd3a616547e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitShear]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitShear]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitShear]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__17aff4832f06454164995a1475ce5980e1634544a76c399a22aee21d80cc9227)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitShearOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitShearOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0cf39e29ebd2bf5b7a90e82d88081da903f67545e56af5f330627831404f3d97)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetXShear")
    def reset_x_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXShear", []))

    @jsii.member(jsii_name="resetXShearVar")
    def reset_x_shear_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXShearVar", []))

    @jsii.member(jsii_name="resetYShear")
    def reset_y_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYShear", []))

    @jsii.member(jsii_name="resetYShearVar")
    def reset_y_shear_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYShearVar", []))

    @builtins.property
    @jsii.member(jsii_name="xShearInput")
    def x_shear_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xShearInput"))

    @builtins.property
    @jsii.member(jsii_name="xShearVarInput")
    def x_shear_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xShearVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yShearInput")
    def y_shear_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yShearInput"))

    @builtins.property
    @jsii.member(jsii_name="yShearVarInput")
    def y_shear_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yShearVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xShear")
    def x_shear(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xShear"))

    @x_shear.setter
    def x_shear(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__32f28b885b699d18d947dd00296267830a5a14cafad1d0c41f4bb13c0dff2531)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xShear", value)

    @builtins.property
    @jsii.member(jsii_name="xShearVar")
    def x_shear_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xShearVar"))

    @x_shear_var.setter
    def x_shear_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e84ae3500a0283c9dc724ff04abac8502378f560984fcc7f0c59b7146c0610f3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xShearVar", value)

    @builtins.property
    @jsii.member(jsii_name="yShear")
    def y_shear(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yShear"))

    @y_shear.setter
    def y_shear(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b9be164cde162c6b16ce0c7fea36ae6b9775fc553b395d4f0f2de219581fc883)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yShear", value)

    @builtins.property
    @jsii.member(jsii_name="yShearVar")
    def y_shear_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yShearVar"))

    @y_shear_var.setter
    def y_shear_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a23f16730ffa9579ba3072dd98db7c44491aad405172655dfa0b40b33504cde1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yShearVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitShear]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitShear]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitShear]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4b163cc32209857bed7a785aa5263bde18a6238fe06124fe55f2755b0bbe7034)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitTrim",
    jsii_struct_bases=[],
    name_mapping={
        "fuzz": "fuzz",
        "fuzz_var": "fuzzVar",
        "padding": "padding",
        "padding_var": "paddingVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitTrim:
    def __init__(
        self,
        *,
        fuzz: typing.Optional[builtins.str] = None,
        fuzz_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fuzz: The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz DataAkamaiImagingPolicyImage#fuzz}
        :param fuzz_var: The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz_var DataAkamaiImagingPolicyImage#fuzz_var}
        :param padding: The amount of padding in pixels to add to the trimmed image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: The amount of padding in pixels to add to the trimmed image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4d407c22fa81430e5f9bd0c7b84cb662fa3bb3bc8b1b79f1440bb342243d564e)
            check_type(argname="argument fuzz", value=fuzz, expected_type=type_hints["fuzz"])
            check_type(argname="argument fuzz_var", value=fuzz_var, expected_type=type_hints["fuzz_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fuzz is not None:
            self._values["fuzz"] = fuzz
        if fuzz_var is not None:
            self._values["fuzz_var"] = fuzz_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var

    @builtins.property
    def fuzz(self) -> typing.Optional[builtins.str]:
        '''The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz DataAkamaiImagingPolicyImage#fuzz}
        '''
        result = self._values.get("fuzz")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fuzz_var(self) -> typing.Optional[builtins.str]:
        '''The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz_var DataAkamaiImagingPolicyImage#fuzz_var}
        '''
        result = self._values.get("fuzz_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''The amount of padding in pixels to add to the trimmed image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''The amount of padding in pixels to add to the trimmed image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitTrim(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitTrimList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitTrimList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b3976af3fbd6c456861be9f8db95232e956b5e243c86d5ca49c88296ad2303b1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitTrimOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c181f24db32e2b9f1a131b047d3da7110b1ce32dc82f66fc7ac19be7adda4492)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitTrimOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5274930c3077e0e53c2c8b9f093019a64b945814a2c18545a291aceb6fa037b0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a83135eb93750706bb9b2c6590a60aee927b5599fd1c977107cd3969a57087f5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__db6dd8079bbf0e7fda5c8802bd9a24bfb0d657ec95864006fd46bab3d1dcab81)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitTrim]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitTrim]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitTrim]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__21c6919eabd52dff7886ddedee1cff97ae5d3b7a824443551d48b179a9cc557e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitTrimOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitTrimOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e77ca581a7f432baa81fc97f9de7b4f17353630e805825e1dfee147d52c1d3be)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetFuzz")
    def reset_fuzz(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFuzz", []))

    @jsii.member(jsii_name="resetFuzzVar")
    def reset_fuzz_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFuzzVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @builtins.property
    @jsii.member(jsii_name="fuzzInput")
    def fuzz_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fuzzInput"))

    @builtins.property
    @jsii.member(jsii_name="fuzzVarInput")
    def fuzz_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fuzzVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="fuzz")
    def fuzz(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fuzz"))

    @fuzz.setter
    def fuzz(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__071ffae7f677bdaf162d50cd47046fecbbc45f1bc5bf2797737549003764c1e0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fuzz", value)

    @builtins.property
    @jsii.member(jsii_name="fuzzVar")
    def fuzz_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fuzzVar"))

    @fuzz_var.setter
    def fuzz_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f4ca696983c001416b71b5851814077b353d320c0d8e6732e5980c6dc44f38c8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fuzzVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f39c79efe40fd23a9ae2d07ca811ce5fd14dcc0d507142a83fb0d4e9b9c59ab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__89bb6e041d4d9d69227966c367e1fd8a7fe5b983d14242b189bb77bc151c551c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitTrim]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitTrim]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitTrim]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__55994da4ecbeedc9e9fe986b0f44988ef395d83444fe697918f75fd61dd9721a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitUnsharpMask",
    jsii_struct_bases=[],
    name_mapping={
        "gain": "gain",
        "gain_var": "gainVar",
        "sigma": "sigma",
        "sigma_var": "sigmaVar",
        "threshold": "threshold",
        "threshold_var": "thresholdVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitUnsharpMask:
    def __init__(
        self,
        *,
        gain: typing.Optional[builtins.str] = None,
        gain_var: typing.Optional[builtins.str] = None,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
        threshold: typing.Optional[builtins.str] = None,
        threshold_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param gain: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        :param gain_var: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        :param sigma: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        :param threshold: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        :param threshold_var: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b30bcc9c9cfb6dd4394dabc01804ba2d8b25f38a31f06c319c0e7f86d2bf1396)
            check_type(argname="argument gain", value=gain, expected_type=type_hints["gain"])
            check_type(argname="argument gain_var", value=gain_var, expected_type=type_hints["gain_var"])
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
            check_type(argname="argument threshold", value=threshold, expected_type=type_hints["threshold"])
            check_type(argname="argument threshold_var", value=threshold_var, expected_type=type_hints["threshold_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if gain is not None:
            self._values["gain"] = gain
        if gain_var is not None:
            self._values["gain_var"] = gain_var
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var
        if threshold is not None:
            self._values["threshold"] = threshold
        if threshold_var is not None:
            self._values["threshold_var"] = threshold_var

    @builtins.property
    def gain(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        '''
        result = self._values.get("gain")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gain_var(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        '''
        result = self._values.get("gain_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        '''
        result = self._values.get("threshold")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold_var(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        result = self._values.get("threshold_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitUnsharpMask(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitUnsharpMaskList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitUnsharpMaskList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__73d9656449c1f3f820372ee96087b3cedf5b68d4b044d61b5c059960c6f11300)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitUnsharpMaskOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5fa6dc06ca6782e7ccf8476c6fb4fee0d549a36829f6aee310aee4f61259190c)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitUnsharpMaskOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__baa46f9e3e021d36dba024c53f46429dfb1ff559e23f2730ef0259a377c43c01)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6cfe3a95b3cbed4bcc3d0d4a926199466d97bdfa75a12efe95b690a1a156ed0b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9b3864d3c2ce56c22c59eb7d9c7f44328be963516f78b71c8d433db4f7ef000f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitUnsharpMask]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitUnsharpMask]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitUnsharpMask]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b22be102443636b72129a1bef781c88f9b7d074550d81c0fd27d1138feac46c3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitUnsharpMaskOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitUnsharpMaskOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__02513e99d562fe87a3641fb5b1b6ed4efa1eecb1a03ffc7c0b31fb962701ec2f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetGain")
    def reset_gain(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGain", []))

    @jsii.member(jsii_name="resetGainVar")
    def reset_gain_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGainVar", []))

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @jsii.member(jsii_name="resetThreshold")
    def reset_threshold(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThreshold", []))

    @jsii.member(jsii_name="resetThresholdVar")
    def reset_threshold_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThresholdVar", []))

    @builtins.property
    @jsii.member(jsii_name="gainInput")
    def gain_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainInput"))

    @builtins.property
    @jsii.member(jsii_name="gainVarInput")
    def gain_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdInput")
    def threshold_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdVarInput")
    def threshold_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gain")
    def gain(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gain"))

    @gain.setter
    def gain(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0d188c1e913a05a9e29706409a3b27868599f299e3c943d9c984f9545ae287ba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gain", value)

    @builtins.property
    @jsii.member(jsii_name="gainVar")
    def gain_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gainVar"))

    @gain_var.setter
    def gain_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d7b14067d2e72d255125c99e8a7a2ff93efe43a7a9ae7e5e80f34fe79b9ac9b4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gainVar", value)

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ed88195409ea4e4fb89610e3415a5eeacea151c5564620e4a95333eb5f1bf620)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8edcd419fc0be344abb0234dc43e2793f4cee3790a2ba64bcc522cdcd06ab4d3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="threshold")
    def threshold(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "threshold"))

    @threshold.setter
    def threshold(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b4c42f67d4d09bc8fe859339edebb46c6fc12b964bdc03db13f8f34d04c14672)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "threshold", value)

    @builtins.property
    @jsii.member(jsii_name="thresholdVar")
    def threshold_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "thresholdVar"))

    @threshold_var.setter
    def threshold_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__32a928177b149b9762247a1e7ed22804b79deafa5f314d8eba7b61335779d300)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "thresholdVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitUnsharpMask]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitUnsharpMask]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitUnsharpMask]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__52a333b641a47755499085abd4a75e5ca3c606e103dc3431473a589285b5757e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquare",
    jsii_struct_bases=[],
    name_mapping={
        "append": "append",
        "aspect_crop": "aspectCrop",
        "background_color": "backgroundColor",
        "blur": "blur",
        "chroma_key": "chromaKey",
        "composite": "composite",
        "compound": "compound",
        "contrast": "contrast",
        "crop": "crop",
        "face_crop": "faceCrop",
        "feature_crop": "featureCrop",
        "fit_and_fill": "fitAndFill",
        "goop": "goop",
        "grayscale": "grayscale",
        "hsl": "hsl",
        "hsv": "hsv",
        "if_dimension": "ifDimension",
        "if_orientation": "ifOrientation",
        "im_query": "imQuery",
        "max_colors": "maxColors",
        "mirror": "mirror",
        "mono_hue": "monoHue",
        "opacity": "opacity",
        "region_of_interest_crop": "regionOfInterestCrop",
        "relative_crop": "relativeCrop",
        "remove_color": "removeColor",
        "resize": "resize",
        "rotate": "rotate",
        "scale": "scale",
        "shear": "shear",
        "trim": "trim",
        "unsharp_mask": "unsharpMask",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquare:
    def __init__(
        self,
        *,
        append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareAppend", typing.Dict[builtins.str, typing.Any]]]]] = None,
        aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareAspectCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareBackgroundColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareBlur", typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareChromaKey", typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareComposite", typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareCompound", typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareContrast", typing.Dict[builtins.str, typing.Any]]]]] = None,
        crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareFaceCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareFeatureCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareFitAndFill", typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareGoop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareGrayscale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareHsl", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareHsv", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfDimension", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfOrientation", typing.Dict[builtins.str, typing.Any]]]]] = None,
        im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareImQuery", typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareMaxColors", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareMirror", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareMonoHue", typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareOpacity", typing.Dict[builtins.str, typing.Any]]]]] = None,
        region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareRegionOfInterestCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareRelativeCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareRemoveColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareResize", typing.Dict[builtins.str, typing.Any]]]]] = None,
        rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareRotate", typing.Dict[builtins.str, typing.Any]]]]] = None,
        scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareScale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareShear", typing.Dict[builtins.str, typing.Any]]]]] = None,
        trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareTrim", typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareUnsharpMask", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param append: append block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        :param aspect_crop: aspect_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param crop: crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        :param face_crop: face_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        :param feature_crop: feature_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        :param fit_and_fill: fit_and_fill block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param im_query: im_query block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param region_of_interest_crop: region_of_interest_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        :param relative_crop: relative_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param resize: resize block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        :param rotate: rotate block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        :param scale: scale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param shear: shear block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        :param trim: trim block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7dc4f2587ea0fcd40a9db68f82297e3da715b968a66d74fa39c12adb4a1d1968)
            check_type(argname="argument append", value=append, expected_type=type_hints["append"])
            check_type(argname="argument aspect_crop", value=aspect_crop, expected_type=type_hints["aspect_crop"])
            check_type(argname="argument background_color", value=background_color, expected_type=type_hints["background_color"])
            check_type(argname="argument blur", value=blur, expected_type=type_hints["blur"])
            check_type(argname="argument chroma_key", value=chroma_key, expected_type=type_hints["chroma_key"])
            check_type(argname="argument composite", value=composite, expected_type=type_hints["composite"])
            check_type(argname="argument compound", value=compound, expected_type=type_hints["compound"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument crop", value=crop, expected_type=type_hints["crop"])
            check_type(argname="argument face_crop", value=face_crop, expected_type=type_hints["face_crop"])
            check_type(argname="argument feature_crop", value=feature_crop, expected_type=type_hints["feature_crop"])
            check_type(argname="argument fit_and_fill", value=fit_and_fill, expected_type=type_hints["fit_and_fill"])
            check_type(argname="argument goop", value=goop, expected_type=type_hints["goop"])
            check_type(argname="argument grayscale", value=grayscale, expected_type=type_hints["grayscale"])
            check_type(argname="argument hsl", value=hsl, expected_type=type_hints["hsl"])
            check_type(argname="argument hsv", value=hsv, expected_type=type_hints["hsv"])
            check_type(argname="argument if_dimension", value=if_dimension, expected_type=type_hints["if_dimension"])
            check_type(argname="argument if_orientation", value=if_orientation, expected_type=type_hints["if_orientation"])
            check_type(argname="argument im_query", value=im_query, expected_type=type_hints["im_query"])
            check_type(argname="argument max_colors", value=max_colors, expected_type=type_hints["max_colors"])
            check_type(argname="argument mirror", value=mirror, expected_type=type_hints["mirror"])
            check_type(argname="argument mono_hue", value=mono_hue, expected_type=type_hints["mono_hue"])
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument region_of_interest_crop", value=region_of_interest_crop, expected_type=type_hints["region_of_interest_crop"])
            check_type(argname="argument relative_crop", value=relative_crop, expected_type=type_hints["relative_crop"])
            check_type(argname="argument remove_color", value=remove_color, expected_type=type_hints["remove_color"])
            check_type(argname="argument resize", value=resize, expected_type=type_hints["resize"])
            check_type(argname="argument rotate", value=rotate, expected_type=type_hints["rotate"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument shear", value=shear, expected_type=type_hints["shear"])
            check_type(argname="argument trim", value=trim, expected_type=type_hints["trim"])
            check_type(argname="argument unsharp_mask", value=unsharp_mask, expected_type=type_hints["unsharp_mask"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if append is not None:
            self._values["append"] = append
        if aspect_crop is not None:
            self._values["aspect_crop"] = aspect_crop
        if background_color is not None:
            self._values["background_color"] = background_color
        if blur is not None:
            self._values["blur"] = blur
        if chroma_key is not None:
            self._values["chroma_key"] = chroma_key
        if composite is not None:
            self._values["composite"] = composite
        if compound is not None:
            self._values["compound"] = compound
        if contrast is not None:
            self._values["contrast"] = contrast
        if crop is not None:
            self._values["crop"] = crop
        if face_crop is not None:
            self._values["face_crop"] = face_crop
        if feature_crop is not None:
            self._values["feature_crop"] = feature_crop
        if fit_and_fill is not None:
            self._values["fit_and_fill"] = fit_and_fill
        if goop is not None:
            self._values["goop"] = goop
        if grayscale is not None:
            self._values["grayscale"] = grayscale
        if hsl is not None:
            self._values["hsl"] = hsl
        if hsv is not None:
            self._values["hsv"] = hsv
        if if_dimension is not None:
            self._values["if_dimension"] = if_dimension
        if if_orientation is not None:
            self._values["if_orientation"] = if_orientation
        if im_query is not None:
            self._values["im_query"] = im_query
        if max_colors is not None:
            self._values["max_colors"] = max_colors
        if mirror is not None:
            self._values["mirror"] = mirror
        if mono_hue is not None:
            self._values["mono_hue"] = mono_hue
        if opacity is not None:
            self._values["opacity"] = opacity
        if region_of_interest_crop is not None:
            self._values["region_of_interest_crop"] = region_of_interest_crop
        if relative_crop is not None:
            self._values["relative_crop"] = relative_crop
        if remove_color is not None:
            self._values["remove_color"] = remove_color
        if resize is not None:
            self._values["resize"] = resize
        if rotate is not None:
            self._values["rotate"] = rotate
        if scale is not None:
            self._values["scale"] = scale
        if shear is not None:
            self._values["shear"] = shear
        if trim is not None:
            self._values["trim"] = trim
        if unsharp_mask is not None:
            self._values["unsharp_mask"] = unsharp_mask

    @builtins.property
    def append(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareAppend"]]]:
        '''append block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        '''
        result = self._values.get("append")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareAppend"]]], result)

    @builtins.property
    def aspect_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareAspectCrop"]]]:
        '''aspect_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        '''
        result = self._values.get("aspect_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareAspectCrop"]]], result)

    @builtins.property
    def background_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareBackgroundColor"]]]:
        '''background_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        '''
        result = self._values.get("background_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareBackgroundColor"]]], result)

    @builtins.property
    def blur(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareBlur"]]]:
        '''blur block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        '''
        result = self._values.get("blur")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareBlur"]]], result)

    @builtins.property
    def chroma_key(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareChromaKey"]]]:
        '''chroma_key block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        '''
        result = self._values.get("chroma_key")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareChromaKey"]]], result)

    @builtins.property
    def composite(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareComposite"]]]:
        '''composite block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        '''
        result = self._values.get("composite")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareComposite"]]], result)

    @builtins.property
    def compound(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareCompound"]]]:
        '''compound block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        '''
        result = self._values.get("compound")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareCompound"]]], result)

    @builtins.property
    def contrast(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareContrast"]]]:
        '''contrast block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareContrast"]]], result)

    @builtins.property
    def crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareCrop"]]]:
        '''crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        '''
        result = self._values.get("crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareCrop"]]], result)

    @builtins.property
    def face_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareFaceCrop"]]]:
        '''face_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        '''
        result = self._values.get("face_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareFaceCrop"]]], result)

    @builtins.property
    def feature_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareFeatureCrop"]]]:
        '''feature_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        '''
        result = self._values.get("feature_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareFeatureCrop"]]], result)

    @builtins.property
    def fit_and_fill(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareFitAndFill"]]]:
        '''fit_and_fill block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        '''
        result = self._values.get("fit_and_fill")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareFitAndFill"]]], result)

    @builtins.property
    def goop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareGoop"]]]:
        '''goop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        '''
        result = self._values.get("goop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareGoop"]]], result)

    @builtins.property
    def grayscale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareGrayscale"]]]:
        '''grayscale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        '''
        result = self._values.get("grayscale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareGrayscale"]]], result)

    @builtins.property
    def hsl(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareHsl"]]]:
        '''hsl block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        '''
        result = self._values.get("hsl")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareHsl"]]], result)

    @builtins.property
    def hsv(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareHsv"]]]:
        '''hsv block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        '''
        result = self._values.get("hsv")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareHsv"]]], result)

    @builtins.property
    def if_dimension(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfDimension"]]]:
        '''if_dimension block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        '''
        result = self._values.get("if_dimension")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfDimension"]]], result)

    @builtins.property
    def if_orientation(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfOrientation"]]]:
        '''if_orientation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        '''
        result = self._values.get("if_orientation")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfOrientation"]]], result)

    @builtins.property
    def im_query(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareImQuery"]]]:
        '''im_query block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        '''
        result = self._values.get("im_query")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareImQuery"]]], result)

    @builtins.property
    def max_colors(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareMaxColors"]]]:
        '''max_colors block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        '''
        result = self._values.get("max_colors")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareMaxColors"]]], result)

    @builtins.property
    def mirror(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareMirror"]]]:
        '''mirror block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        '''
        result = self._values.get("mirror")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareMirror"]]], result)

    @builtins.property
    def mono_hue(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareMonoHue"]]]:
        '''mono_hue block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        '''
        result = self._values.get("mono_hue")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareMonoHue"]]], result)

    @builtins.property
    def opacity(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareOpacity"]]]:
        '''opacity block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareOpacity"]]], result)

    @builtins.property
    def region_of_interest_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareRegionOfInterestCrop"]]]:
        '''region_of_interest_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        '''
        result = self._values.get("region_of_interest_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareRegionOfInterestCrop"]]], result)

    @builtins.property
    def relative_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareRelativeCrop"]]]:
        '''relative_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        '''
        result = self._values.get("relative_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareRelativeCrop"]]], result)

    @builtins.property
    def remove_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareRemoveColor"]]]:
        '''remove_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        '''
        result = self._values.get("remove_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareRemoveColor"]]], result)

    @builtins.property
    def resize(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareResize"]]]:
        '''resize block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        '''
        result = self._values.get("resize")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareResize"]]], result)

    @builtins.property
    def rotate(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareRotate"]]]:
        '''rotate block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        '''
        result = self._values.get("rotate")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareRotate"]]], result)

    @builtins.property
    def scale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareScale"]]]:
        '''scale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareScale"]]], result)

    @builtins.property
    def shear(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareShear"]]]:
        '''shear block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        '''
        result = self._values.get("shear")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareShear"]]], result)

    @builtins.property
    def trim(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareTrim"]]]:
        '''trim block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        '''
        result = self._values.get("trim")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareTrim"]]], result)

    @builtins.property
    def unsharp_mask(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareUnsharpMask"]]]:
        '''unsharp_mask block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        result = self._values.get("unsharp_mask")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareUnsharpMask"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquare(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareAppend",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_priority": "gravityPriority",
        "gravity_priority_var": "gravityPriorityVar",
        "gravity_var": "gravityVar",
        "preserve_minor_dimension": "preserveMinorDimension",
        "preserve_minor_dimension_var": "preserveMinorDimensionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareAppend:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareAppendImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_priority: typing.Optional[builtins.str] = None,
        gravity_priority_var: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        preserve_minor_dimension: typing.Optional[builtins.str] = None,
        preserve_minor_dimension_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Specifies where to place the ``image`` relative to the source image. The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_priority: Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal. The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority DataAkamaiImagingPolicyImage#gravity_priority}
        :param gravity_priority_var: Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal. The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority_var DataAkamaiImagingPolicyImage#gravity_priority_var}
        :param gravity_var: Specifies where to place the ``image`` relative to the source image. The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param preserve_minor_dimension: Whether to preserve the source image's minor dimension, ``false`` by default. The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension DataAkamaiImagingPolicyImage#preserve_minor_dimension}
        :param preserve_minor_dimension_var: Whether to preserve the source image's minor dimension, ``false`` by default. The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension_var DataAkamaiImagingPolicyImage#preserve_minor_dimension_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareAppendImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d49387d2a4f8d5e279d96967365f44063a8ff94ddbafe15428098261d9ab2e12)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_priority", value=gravity_priority, expected_type=type_hints["gravity_priority"])
            check_type(argname="argument gravity_priority_var", value=gravity_priority_var, expected_type=type_hints["gravity_priority_var"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument preserve_minor_dimension", value=preserve_minor_dimension, expected_type=type_hints["preserve_minor_dimension"])
            check_type(argname="argument preserve_minor_dimension_var", value=preserve_minor_dimension_var, expected_type=type_hints["preserve_minor_dimension_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_priority is not None:
            self._values["gravity_priority"] = gravity_priority
        if gravity_priority_var is not None:
            self._values["gravity_priority_var"] = gravity_priority_var
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if preserve_minor_dimension is not None:
            self._values["preserve_minor_dimension"] = preserve_minor_dimension
        if preserve_minor_dimension_var is not None:
            self._values["preserve_minor_dimension_var"] = preserve_minor_dimension_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareAppendImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareAppendImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Specifies where to place the ``image`` relative to the source image.

        The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_priority(self) -> typing.Optional[builtins.str]:
        '''Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal.

        The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority DataAkamaiImagingPolicyImage#gravity_priority}
        '''
        result = self._values.get("gravity_priority")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_priority_var(self) -> typing.Optional[builtins.str]:
        '''Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal.

        The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority_var DataAkamaiImagingPolicyImage#gravity_priority_var}
        '''
        result = self._values.get("gravity_priority_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Specifies where to place the ``image`` relative to the source image.

        The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def preserve_minor_dimension(self) -> typing.Optional[builtins.str]:
        '''Whether to preserve the source image's minor dimension, ``false`` by default.

        The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension DataAkamaiImagingPolicyImage#preserve_minor_dimension}
        '''
        result = self._values.get("preserve_minor_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def preserve_minor_dimension_var(self) -> typing.Optional[builtins.str]:
        '''Whether to preserve the source image's minor dimension, ``false`` by default.

        The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension_var DataAkamaiImagingPolicyImage#preserve_minor_dimension_var}
        '''
        result = self._values.get("preserve_minor_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareAppend(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareAppendImage",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareAppendImage:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareAppendImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareAppendImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareAppendImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__75c41ce725b13267d790bb2278b1422e0335caf7863a923f533fcb9c432adf39)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareAppendImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareAppendImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareAppendImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__15d81bb1656afdd3ac056bd88bc03c960ab450b8e10d7821d0092360457dcc1a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareAppendList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareAppendList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c3706ec548bd499e8dc9248faab1c4189ba24ab72a0bd23b2dbd55d5e7b04b28)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareAppendOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__380b4143209c518a68ad7f6b42b35eed5e2d8260b15a386dfefb5e096ec3dc97)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareAppendOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e61b1fe4e2bb2b0dccabfdf211af2c481c0da4f130dd4619073f72af5f8dee96)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2f86de2d59ef2b87069e01d5c3536b54558977767035591b3eefb21b22dfa4ab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f93448f25f3b1b8816d1e777f3e600691d5e57ac79e0faaf4fc8473bb038570e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareAppend]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareAppend]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareAppend]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__efedd937891437c6b2fe2ac4f56b86666c68b1402ba344676c9ab2e2ff0e0263)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareAppendOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareAppendOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ff73aaf303aa2c7ab2d3e1d6efc2c31888ee8e902040d8f95ef651f0c0eb443)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareAppendImage()

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityPriority")
    def reset_gravity_priority(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityPriority", []))

    @jsii.member(jsii_name="resetGravityPriorityVar")
    def reset_gravity_priority_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityPriorityVar", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPreserveMinorDimension")
    def reset_preserve_minor_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPreserveMinorDimension", []))

    @jsii.member(jsii_name="resetPreserveMinorDimensionVar")
    def reset_preserve_minor_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPreserveMinorDimensionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareAppendImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareAppendImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityInput")
    def gravity_priority_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityPriorityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityVarInput")
    def gravity_priority_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityPriorityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareAppendImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareAppendImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionInput")
    def preserve_minor_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "preserveMinorDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionVarInput")
    def preserve_minor_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "preserveMinorDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a60b647ea8e6670f370e800abfb91c1cb65b5da0ccde0e9684352dede2bba9ac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityPriority")
    def gravity_priority(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityPriority"))

    @gravity_priority.setter
    def gravity_priority(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d3ba57090b674ba86807130b63343d7e0eb0901e5cea44a2920de92cb8b809c4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityPriority", value)

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityVar")
    def gravity_priority_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityPriorityVar"))

    @gravity_priority_var.setter
    def gravity_priority_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__66aa11af1b862de1a40a9b84e7aeb1272499a034625d1622024325c0c598ad55)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityPriorityVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__023ed9ab3be6c609fd2dcc0663f7e69d1e5f4049e3d4ce18ca551febfa525bd7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimension")
    def preserve_minor_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "preserveMinorDimension"))

    @preserve_minor_dimension.setter
    def preserve_minor_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__693e22a7ad9cc8446eb525cc9a1ce8527002c3227816adeb597a7bed22e2895e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "preserveMinorDimension", value)

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionVar")
    def preserve_minor_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "preserveMinorDimensionVar"))

    @preserve_minor_dimension_var.setter
    def preserve_minor_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__668305729dfff406c8ca9c35359093e4dbe9a272179b505694a1357d884f768f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "preserveMinorDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareAppend]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareAppend]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareAppend]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dbdcbfca97003bc6fb6e99506d33b125a95b49828c9844882fcdf0a008440183)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareAspectCrop",
    jsii_struct_bases=[],
    name_mapping={
        "allow_expansion": "allowExpansion",
        "allow_expansion_var": "allowExpansionVar",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareAspectCrop:
    def __init__(
        self,
        *,
        allow_expansion: typing.Optional[builtins.str] = None,
        allow_expansion_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_expansion: Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image. Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        :param allow_expansion_var: Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image. Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        :param height: The height term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The width term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        :param x_position: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bdf694a26f6ef8a78a344327c0b2916b5b69e3258b8bbb996ce15830a1f1fbaf)
            check_type(argname="argument allow_expansion", value=allow_expansion, expected_type=type_hints["allow_expansion"])
            check_type(argname="argument allow_expansion_var", value=allow_expansion_var, expected_type=type_hints["allow_expansion_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if allow_expansion is not None:
            self._values["allow_expansion"] = allow_expansion
        if allow_expansion_var is not None:
            self._values["allow_expansion_var"] = allow_expansion_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def allow_expansion(self) -> typing.Optional[builtins.str]:
        '''Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image.

        Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        '''
        result = self._values.get("allow_expansion")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def allow_expansion_var(self) -> typing.Optional[builtins.str]:
        '''Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image.

        Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        '''
        result = self._values.get("allow_expansion_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareAspectCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareAspectCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareAspectCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__17f076b0c7f659ede53a074550746490dc8d862522d7e7ff07386b3314e21e55)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareAspectCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__77bbb4e3812584a7d16ecb8f9c9d41bc54555e900002bb514b266e18cffad828)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareAspectCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc4939e63f29cbeebfdc28b567eac8dc5b3d093627cdf6a5b4a9b99c880b3af8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__65a3b4ec45d5c915d0277bbda831c6ec32f807f6f932118a1c75c87984ec9db9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bfae74a74985a7f73efd2b07f81a76f7c10e5c52c913c54ab39b2d9a4b7383e4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareAspectCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareAspectCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareAspectCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5636d6b7235c30a949d1aafccfad697528ea656cee7801d53d833bf783079165)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareAspectCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareAspectCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2c3bacb278a233a7512cbf2bfc716e1f59b0e0492accdae618eecff9009d8585)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAllowExpansion")
    def reset_allow_expansion(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansion", []))

    @jsii.member(jsii_name="resetAllowExpansionVar")
    def reset_allow_expansion_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansionVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionInput")
    def allow_expansion_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVarInput")
    def allow_expansion_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansion")
    def allow_expansion(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansion"))

    @allow_expansion.setter
    def allow_expansion(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__69295d6de22fb94c4c99eb68d7cb9c6d3a458a64e17814ceb26fd5f57f08abbc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansion", value)

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVar")
    def allow_expansion_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansionVar"))

    @allow_expansion_var.setter
    def allow_expansion_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dcb4efca518f094ba8841cd14e92e15e5c61de7aa8ee46e6c22edfdb578f1a51)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansionVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8d072b8a348160151ce038b8038871a608d1d0959dc86c46b59cb64b4e660643)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__898097fdc982f6e7e2368ed073efb4082bb080389516f97282ebea577b5c3764)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__56d5ef940cbb1d2caca0bcf6891ea94efaeed8076a9001c813862dd0326d756c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__850ae57cc459fb2f35d5428402b0bdfb5281b21937203c2c4a6b15468f2a8d0a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ae8e3e1ebe3125c219ba7c9c8150cedf55f08bf1dfb383d5593484f713f39427)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4e01892ded3e51a9d6145d1ed67fd452b64bd9facd03a8c98c3c97ce7ee2bc90)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__346945973b8ecbcd8eb580fc41ece4dfabf5ca08d25e95ecc55026f76bad3afb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2453fed01ef5ef86fca7dde0002cc74e305ea86fb0c1717954a2723c65ef39a1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareAspectCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareAspectCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareAspectCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__48da0d2dabe3ad64ac32e975788b227ed882894b124a80f2f7fd343c42e10bc4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareBackgroundColor",
    jsii_struct_bases=[],
    name_mapping={"color": "color", "color_var": "colorVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareBackgroundColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__52f6e6dc216f823a69d17d3611278e1217210305f99f8e43bb518e971cd59656)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareBackgroundColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareBackgroundColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareBackgroundColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cf293765666c503610e49b19c0a1660e6c82bbdb2d1e503a6c8cfb1fd8428bf6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareBackgroundColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa0248f64fd1a565a10d7cf7d7b04fde588e8c9ea7322a3b4aceec110e816373)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareBackgroundColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d41afbec871187e5904d1c70395066566f2508c27829630ebedfdc001a87d41)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__71f7faf8c0944efac3cb87ad7dc91bf0b7cd41e6b11a4c02b0011219953dd197)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f5489baea6e7ea279449818c2f68802822751adf44fed95d61d2cb974a43b18b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareBackgroundColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareBackgroundColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__08490db2003a9417ac2210e4936847e03ef90e880259c7dcfd7327aed98fd08d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareBackgroundColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareBackgroundColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__67a58a066a901cbf51125e083d050e1db9ad82a84b8a7b61fb42840919396774)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e4e7cdf84fda1ad51eebd75215cc68fc8dfc11b96b0315a0c4afc249408325cf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__893b1e9a40b600f0eb5fb97300cb837c7ecdf731ecf6ef830189f6dc8451b53b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareBackgroundColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareBackgroundColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareBackgroundColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3286c5cc7fe820f81049e37c72f596cef3da169a4c7d2bcd42514c7dc4aa08db)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareBlur",
    jsii_struct_bases=[],
    name_mapping={"sigma": "sigma", "sigma_var": "sigmaVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareBlur:
    def __init__(
        self,
        *,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param sigma: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__925615a5abb47968a1340ae602c73eb9e4460f44ac4c661793a056fedc1d9d60)
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareBlur(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareBlurList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareBlurList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c98775ba88f8803b81f9c01f3313dbd1d7bfca9af0b10476f3f23d307e903d66)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareBlurOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__580723b240232c7a3530819b5250f85b2fc8443470a4ecaea9462cb5f2f74e97)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareBlurOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__186d7e658a66fa4c9270f597b3823bda2703449603f93affe6f0f7a5970a4a06)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__70386ca54b8ac38474f72cfb73d5acd8edd54200d092b1a218d8271f88e31a25)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__acb6d91ef785fbaa0ef1d48a8ecd2c3964e26126ffcd463b35e5787d68c80fd2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareBlur]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareBlur]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__68be6085a5154cf681e14872716b563b6e89a9d204c5b3f2effd240d8efcacf2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareBlurOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareBlurOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b03bc7026bf64f3c1d0f28ed8b54939f017cd3f946c42d73791b32b0866fef50)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5669f366ebf0a6dc6e357205aee57249bd460fbc829861acf289c252566a106b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e57a96881d211eaf1aeca90983d70c5cd98f1981c34d8f4c77943d880840388d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareBlur]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareBlur]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareBlur]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7baae02f4a0f250cdcb45715e3ef5f140b2b4ad769cd54e4e86d23a724d0df66)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareChromaKey",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_feather": "hueFeather",
        "hue_feather_var": "hueFeatherVar",
        "hue_tolerance": "hueTolerance",
        "hue_tolerance_var": "hueToleranceVar",
        "hue_var": "hueVar",
        "lightness_feather": "lightnessFeather",
        "lightness_feather_var": "lightnessFeatherVar",
        "lightness_tolerance": "lightnessTolerance",
        "lightness_tolerance_var": "lightnessToleranceVar",
        "saturation_feather": "saturationFeather",
        "saturation_feather_var": "saturationFeatherVar",
        "saturation_tolerance": "saturationTolerance",
        "saturation_tolerance_var": "saturationToleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareChromaKey:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_feather: typing.Optional[builtins.str] = None,
        hue_feather_var: typing.Optional[builtins.str] = None,
        hue_tolerance: typing.Optional[builtins.str] = None,
        hue_tolerance_var: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness_feather: typing.Optional[builtins.str] = None,
        lightness_feather_var: typing.Optional[builtins.str] = None,
        lightness_tolerance: typing.Optional[builtins.str] = None,
        lightness_tolerance_var: typing.Optional[builtins.str] = None,
        saturation_feather: typing.Optional[builtins.str] = None,
        saturation_feather_var: typing.Optional[builtins.str] = None,
        saturation_tolerance: typing.Optional[builtins.str] = None,
        saturation_tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_feather: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        :param hue_feather_var: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        :param hue_tolerance: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        :param hue_tolerance_var: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        :param hue_var: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness_feather: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        :param lightness_feather_var: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        :param lightness_tolerance: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        :param lightness_tolerance_var: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        :param saturation_feather: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        :param saturation_feather_var: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        :param saturation_tolerance: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        :param saturation_tolerance_var: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5b579f88f76370f768724c26ddd5a8de7598198e9edba53903c6dc998909d179)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_feather", value=hue_feather, expected_type=type_hints["hue_feather"])
            check_type(argname="argument hue_feather_var", value=hue_feather_var, expected_type=type_hints["hue_feather_var"])
            check_type(argname="argument hue_tolerance", value=hue_tolerance, expected_type=type_hints["hue_tolerance"])
            check_type(argname="argument hue_tolerance_var", value=hue_tolerance_var, expected_type=type_hints["hue_tolerance_var"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness_feather", value=lightness_feather, expected_type=type_hints["lightness_feather"])
            check_type(argname="argument lightness_feather_var", value=lightness_feather_var, expected_type=type_hints["lightness_feather_var"])
            check_type(argname="argument lightness_tolerance", value=lightness_tolerance, expected_type=type_hints["lightness_tolerance"])
            check_type(argname="argument lightness_tolerance_var", value=lightness_tolerance_var, expected_type=type_hints["lightness_tolerance_var"])
            check_type(argname="argument saturation_feather", value=saturation_feather, expected_type=type_hints["saturation_feather"])
            check_type(argname="argument saturation_feather_var", value=saturation_feather_var, expected_type=type_hints["saturation_feather_var"])
            check_type(argname="argument saturation_tolerance", value=saturation_tolerance, expected_type=type_hints["saturation_tolerance"])
            check_type(argname="argument saturation_tolerance_var", value=saturation_tolerance_var, expected_type=type_hints["saturation_tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_feather is not None:
            self._values["hue_feather"] = hue_feather
        if hue_feather_var is not None:
            self._values["hue_feather_var"] = hue_feather_var
        if hue_tolerance is not None:
            self._values["hue_tolerance"] = hue_tolerance
        if hue_tolerance_var is not None:
            self._values["hue_tolerance_var"] = hue_tolerance_var
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness_feather is not None:
            self._values["lightness_feather"] = lightness_feather
        if lightness_feather_var is not None:
            self._values["lightness_feather_var"] = lightness_feather_var
        if lightness_tolerance is not None:
            self._values["lightness_tolerance"] = lightness_tolerance
        if lightness_tolerance_var is not None:
            self._values["lightness_tolerance_var"] = lightness_tolerance_var
        if saturation_feather is not None:
            self._values["saturation_feather"] = saturation_feather
        if saturation_feather_var is not None:
            self._values["saturation_feather_var"] = saturation_feather_var
        if saturation_tolerance is not None:
            self._values["saturation_tolerance"] = saturation_tolerance
        if saturation_tolerance_var is not None:
            self._values["saturation_tolerance_var"] = saturation_tolerance_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        '''
        result = self._values.get("hue_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        '''
        result = self._values.get("hue_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        '''
        result = self._values.get("hue_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        '''
        result = self._values.get("hue_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        '''
        result = self._values.get("lightness_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        '''
        result = self._values.get("lightness_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        '''
        result = self._values.get("lightness_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        '''
        result = self._values.get("lightness_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        '''
        result = self._values.get("saturation_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        '''
        result = self._values.get("saturation_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        '''
        result = self._values.get("saturation_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        result = self._values.get("saturation_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareChromaKey(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareChromaKeyList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareChromaKeyList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c281f5433d0eeeabb6760bf692494f38d5e9d55adde1219fdbd5cf5d6ed68c58)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareChromaKeyOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b1451f67ffc836982beae9dce0cce3728749febb3a9d26a07ed113a753bcfa8e)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareChromaKeyOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ccafa643350660dae5d04993fee708ef4e976493864d7262cfc00b0fda9fe6f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__13d97bf6261faa7bf9b1b059d5fb7e307274f77fa48c7922be562b63cfe99763)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__777e4b0fc48959e840bbf0051bea49ce4e5bd09e53d322dcbc44718b7cbcb58a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareChromaKey]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareChromaKey]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__71c84a147c657e3519cdc57c4631e493b42026cd896f7db42d2b182d5e804cd9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareChromaKeyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareChromaKeyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ebe84a7d677f3dbb913294e949f36e5669a9ba727f9cff5ecd431f6969c92bfe)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueFeather")
    def reset_hue_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeather", []))

    @jsii.member(jsii_name="resetHueFeatherVar")
    def reset_hue_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeatherVar", []))

    @jsii.member(jsii_name="resetHueTolerance")
    def reset_hue_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueTolerance", []))

    @jsii.member(jsii_name="resetHueToleranceVar")
    def reset_hue_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueToleranceVar", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightnessFeather")
    def reset_lightness_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeather", []))

    @jsii.member(jsii_name="resetLightnessFeatherVar")
    def reset_lightness_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeatherVar", []))

    @jsii.member(jsii_name="resetLightnessTolerance")
    def reset_lightness_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessTolerance", []))

    @jsii.member(jsii_name="resetLightnessToleranceVar")
    def reset_lightness_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessToleranceVar", []))

    @jsii.member(jsii_name="resetSaturationFeather")
    def reset_saturation_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeather", []))

    @jsii.member(jsii_name="resetSaturationFeatherVar")
    def reset_saturation_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeatherVar", []))

    @jsii.member(jsii_name="resetSaturationTolerance")
    def reset_saturation_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationTolerance", []))

    @jsii.member(jsii_name="resetSaturationToleranceVar")
    def reset_saturation_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherInput")
    def hue_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVarInput")
    def hue_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceInput")
    def hue_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVarInput")
    def hue_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherInput")
    def lightness_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVarInput")
    def lightness_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceInput")
    def lightness_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVarInput")
    def lightness_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherInput")
    def saturation_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVarInput")
    def saturation_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceInput")
    def saturation_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVarInput")
    def saturation_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2af4e6b10ba2ca22cad8951f45bd9f243b7059d3405ef74a3cc7b85e27e7232f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeather")
    def hue_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeather"))

    @hue_feather.setter
    def hue_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__edac82432125a54363a1e062bfcaeac8d300ed45b7b6127889143932688213de)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeather", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVar")
    def hue_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeatherVar"))

    @hue_feather_var.setter
    def hue_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__313579a603fd473a13a964762770d48d9a462e3fd273bd2e2007a6d1ec9d58f5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueTolerance")
    def hue_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueTolerance"))

    @hue_tolerance.setter
    def hue_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ac2c7d4908d72ba5be62ca93b04870e8fd218070e332bb9f18501702aa852c3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVar")
    def hue_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueToleranceVar"))

    @hue_tolerance_var.setter
    def hue_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__884aa47d8e7ee3f7347a08ba4dc85ea5973d3609a405a1f200900534a2b4b60b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e3472d9f6935ca496481e7af432e86ca94d4b1c0f94f30d252d7eb511ccc411f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeather")
    def lightness_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeather"))

    @lightness_feather.setter
    def lightness_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__54e2c766abac9080a4324a508d81438eaa3a6e2c4b50f3e48f92210afbccd65b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeather", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVar")
    def lightness_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeatherVar"))

    @lightness_feather_var.setter
    def lightness_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df86b9ff2c3755a38d685ed7a258975df6126c37187e32d97070345498faafc7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessTolerance")
    def lightness_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessTolerance"))

    @lightness_tolerance.setter
    def lightness_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__09c68048e8cd42beaa2e897e542514eea53e3f22ffb2e7e29f05e15d38376862)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVar")
    def lightness_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessToleranceVar"))

    @lightness_tolerance_var.setter
    def lightness_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0350b882d975279ffdf4b72c443783f6e5bb8ba3ec0b76c94745f431a323fb05)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeather")
    def saturation_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeather"))

    @saturation_feather.setter
    def saturation_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__014270e51fe0b4d27a5bbd7c1e98dcd281a31014d7f493b204f867082f469f9a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeather", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVar")
    def saturation_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeatherVar"))

    @saturation_feather_var.setter
    def saturation_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cbb228b9ef49887bf1918420d3c132b9c033133a310b3f5e94308719f46ea498)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationTolerance")
    def saturation_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationTolerance"))

    @saturation_tolerance.setter
    def saturation_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__80bb182b0428fe36a5fe16c0e2dc9aae5410dfad9acfd2fafd8ac4d7d76f0d31)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVar")
    def saturation_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationToleranceVar"))

    @saturation_tolerance_var.setter
    def saturation_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f7bfb736f7da1904774504731f1938dbf43720020b8c1fd560e3b276d24c811a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareChromaKey]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareChromaKey]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareChromaKey]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__09b83401f6931111920523235abee92bce4046820af353494ae1992a7dc191b0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareComposite",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "placement": "placement",
        "placement_var": "placementVar",
        "scale": "scale",
        "scale_dimension": "scaleDimension",
        "scale_dimension_var": "scaleDimensionVar",
        "scale_var": "scaleVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareComposite:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareCompositeImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        placement: typing.Optional[builtins.str] = None,
        placement_var: typing.Optional[builtins.str] = None,
        scale: typing.Optional[builtins.str] = None,
        scale_dimension: typing.Optional[builtins.str] = None,
        scale_dimension_var: typing.Optional[builtins.str] = None,
        scale_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param placement: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        :param placement_var: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        :param scale: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param scale_dimension: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        :param scale_dimension_var: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        :param scale_var: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        :param x_position: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareCompositeImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b5649053e1dc822b44660e983f5ae33f76dee6dc52eb3b944693b9a3e8a12685)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument placement", value=placement, expected_type=type_hints["placement"])
            check_type(argname="argument placement_var", value=placement_var, expected_type=type_hints["placement_var"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument scale_dimension", value=scale_dimension, expected_type=type_hints["scale_dimension"])
            check_type(argname="argument scale_dimension_var", value=scale_dimension_var, expected_type=type_hints["scale_dimension_var"])
            check_type(argname="argument scale_var", value=scale_var, expected_type=type_hints["scale_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if placement is not None:
            self._values["placement"] = placement
        if placement_var is not None:
            self._values["placement_var"] = placement_var
        if scale is not None:
            self._values["scale"] = scale
        if scale_dimension is not None:
            self._values["scale_dimension"] = scale_dimension
        if scale_dimension_var is not None:
            self._values["scale_dimension_var"] = scale_dimension_var
        if scale_var is not None:
            self._values["scale_var"] = scale_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareCompositeImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareCompositeImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        '''
        result = self._values.get("placement")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement_var(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        '''
        result = self._values.get("placement_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        '''
        result = self._values.get("scale_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        '''
        result = self._values.get("scale_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        '''
        result = self._values.get("scale_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareComposite(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareCompositeImage",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareCompositeImage:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareCompositeImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareCompositeImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareCompositeImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f999fcfb259ed9227706f0c6cf55ace7f2829adf9f7149858712d60438b61a5e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareCompositeImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareCompositeImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2416b932b79b3439a7c90fc2522382398ba042279245407d43db79ca9dcebfdf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareCompositeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareCompositeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aee417d805a786263a7014f60a0de84649ccd6df832c7e381d97f2e9b0083234)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareCompositeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__254d4198bc41cdb13d582c6cbd7d42608db3958e7275bed6d0f6c3114dc43d15)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareCompositeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e8f70b8770715b6f16ff9c247a328030e08546cc76172c5fbc6cc7347616b014)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b1187d196f49d3cdfd4cce4f977f1cdd59e92dab6edb070be429e7f0b6339d7c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eb6420c44f3b8ffdfb5b985f3b530d135b5113edc2abff8094ef9463bd274a15)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareComposite]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareComposite]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__513bce2fb0535c5f2ac0c0cec84afaebfc5fc652582bfc01e06413bf0ffcaa1f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareCompositeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareCompositeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__81ac2f16cfa7d788ca44d58c20e37bcbb631dee5a73793a943463a083f01d27e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareCompositeImage()

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPlacement")
    def reset_placement(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacement", []))

    @jsii.member(jsii_name="resetPlacementVar")
    def reset_placement_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacementVar", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetScaleDimension")
    def reset_scale_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimension", []))

    @jsii.member(jsii_name="resetScaleDimensionVar")
    def reset_scale_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimensionVar", []))

    @jsii.member(jsii_name="resetScaleVar")
    def reset_scale_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareCompositeImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareCompositeImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareCompositeImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="placementInput")
    def placement_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementInput"))

    @builtins.property
    @jsii.member(jsii_name="placementVarInput")
    def placement_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionInput")
    def scale_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVarInput")
    def scale_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleVarInput")
    def scale_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b4fa94231eb7035f7515e9ba0a4edf1a6468e9a41f625d696659740629331290)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__406ad996958b307885b6bda73df90a6dea65c3fe64378f9d6e20f8b34aef3de4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="placement")
    def placement(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placement"))

    @placement.setter
    def placement(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f16c40ac9630833a0c631f3e2fdb605979121ad466744f5744ad7f0154699830)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placement", value)

    @builtins.property
    @jsii.member(jsii_name="placementVar")
    def placement_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placementVar"))

    @placement_var.setter
    def placement_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b22566580f65a41821c2ee0ec567a5f8f87932b20bb781f5947d701323fac327)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placementVar", value)

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scale"))

    @scale.setter
    def scale(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__89ab564f01f964ab73e983a657d964be7f6e1ac08e86dee489d00d54033183fa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scale", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimension")
    def scale_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimension"))

    @scale_dimension.setter
    def scale_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7fa08010bdbc5d918e46d3950b94b2a1b842fcf96776b329a0a69742d14bd5ad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimension", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVar")
    def scale_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimensionVar"))

    @scale_dimension_var.setter
    def scale_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4c17ff8dac1294e96fe22c2d6ed25827f165f1e022890602cfbe1ed2b54429a2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="scaleVar")
    def scale_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleVar"))

    @scale_var.setter
    def scale_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7136c6f6023b7feefef88e8cbf28d8e9526de9e6da8e54002f5e08aef504abd0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1ab6e41a7d41cbae1a8451f32b466c05c8b9a72f489679bdd4b75d251c67a5a4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__563c0cdae50da5225be9fc7af884efc8e105df4e7e8c99feab8abb9a9f26da0c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9cfa4dff78f594c7e6404329afbb52daf29efa57e16e0c046127133605dd7f8e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7abb78935f229e450425bf9ac4be5b34024d7d221b96f28b1a71724a85ef7e1c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareComposite]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareComposite]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareComposite]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__99827f4233578659caa32683590a88afa2c7a75ec444124bc899f1aefe1489b6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareCompound",
    jsii_struct_bases=[],
    name_mapping={"transformations": "transformations"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareCompound:
    def __init__(
        self,
        *,
        transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param transformations: transformations block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__62ac70e0539fd9605cf13f30d90b87640289f2a0756a41905fb7ea26f5a426f8)
            check_type(argname="argument transformations", value=transformations, expected_type=type_hints["transformations"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if transformations is not None:
            self._values["transformations"] = transformations

    @builtins.property
    def transformations(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareCompoundTransformations"]]]:
        '''transformations block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        result = self._values.get("transformations")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareCompoundTransformations"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareCompound(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareCompoundList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareCompoundList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__21ebf84077423610b1e900de23e6dbac1fd899780ebc35efa68e8e53c04fe8ae)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareCompoundOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aaec468bd705da1a63d858e0c98e6941207bd0e8083b5b90fbd597b8c324fe37)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareCompoundOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d5064c2aa1550b91bf0149d4803940783cbb275220cfbe0148fea93fb2103ee3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bd452547b2dd82f08393e52e2cf6cf300eb27e2e38fd40d136a86021551847d7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e85f73680bd6456175454e75f4ac691504d20bc9dad3bb07e082598a479e943d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareCompound]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareCompound]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__02fe75b29ebee61892010070c459d333c777ffd705e01e19fd1692dabe67c8e6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareCompoundOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareCompoundOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d52e62d0ac95454f497ece9c961fc423631aade1cdde12782e50ca3f3e40693d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformations")
    def put_transformations(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0384009c8590d78f023dfcd034ac8483d9f6f542d1cde5fe30f3cca0f8d5ea77)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTransformations", [value]))

    @jsii.member(jsii_name="resetTransformations")
    def reset_transformations(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformations", []))

    @builtins.property
    @jsii.member(jsii_name="transformations")
    def transformations(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareCompoundTransformationsList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareCompoundTransformationsList", jsii.get(self, "transformations"))

    @builtins.property
    @jsii.member(jsii_name="transformationsInput")
    def transformations_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareCompoundTransformations"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareCompoundTransformations"]]], jsii.get(self, "transformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareCompound]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareCompound]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareCompound]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__828b3f4afa3cdfce6054cfac055856d06b4ce077037d8a56ad9c15e5668b6cee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareCompoundTransformations",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareCompoundTransformations:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareCompoundTransformations(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareCompoundTransformationsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareCompoundTransformationsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0b4f146c950b96ab57bef1455245f372bc72baededc1ec62b16744430c4d7888)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareCompoundTransformationsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c50621a88c3e85af506f6a55d80ce678ffd79cbe75e101cdbd502f0f12baf896)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareCompoundTransformationsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__648aac43596e09054ff959a79b7cc391538ba9f366157b7bd6f9223facba36a3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d156b721e54a724c8f10dede46f076a2ac589baedb676627c4d84e9a3bc8bc8d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__45655898027f89afb0fa2b7f7777a8f5077b4e2abd16f06f977dbdb58cb2f7b8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareCompoundTransformations]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareCompoundTransformations]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareCompoundTransformations]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5cc965970a340aa17503dd0af9692e7e9e0ee85f5bab12c7ece7c7b8768d8361)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareCompoundTransformationsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareCompoundTransformationsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0cc66898158dfb287978072af1531d391f1161cbf6f0ff8a535286bb6a690012)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareCompoundTransformations]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareCompoundTransformations]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareCompoundTransformations]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ee499e9b49c30bb085de60ae42de51b47fceaac23ca99c3aea509167578a474c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareContrast",
    jsii_struct_bases=[],
    name_mapping={
        "brightness": "brightness",
        "brightness_var": "brightnessVar",
        "contrast": "contrast",
        "contrast_var": "contrastVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareContrast:
    def __init__(
        self,
        *,
        brightness: typing.Optional[builtins.str] = None,
        brightness_var: typing.Optional[builtins.str] = None,
        contrast: typing.Optional[builtins.str] = None,
        contrast_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param brightness: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        :param brightness_var: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        :param contrast: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param contrast_var: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1068895cbd39a026d3133abb00f58c9c493630d925091880cd3c8428b754015e)
            check_type(argname="argument brightness", value=brightness, expected_type=type_hints["brightness"])
            check_type(argname="argument brightness_var", value=brightness_var, expected_type=type_hints["brightness_var"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument contrast_var", value=contrast_var, expected_type=type_hints["contrast_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if brightness is not None:
            self._values["brightness"] = brightness
        if brightness_var is not None:
            self._values["brightness_var"] = brightness_var
        if contrast is not None:
            self._values["contrast"] = contrast
        if contrast_var is not None:
            self._values["contrast_var"] = contrast_var

    @builtins.property
    def brightness(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        '''
        result = self._values.get("brightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def brightness_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        '''
        result = self._values.get("brightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        result = self._values.get("contrast_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareContrast(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareContrastList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareContrastList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8abc5a5d76046c0d84c6fb80ed5db28b74ba07446bca8326a0606ea0917bfc5b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareContrastOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6b1138564e885ec00195491864284e22c7801f42efab05092c3deb3d08d5effb)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareContrastOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b0cc5080f75df341744668eb171de8e8ea344688a7c2d606c4aa28b502659939)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e98a84612225f69ef50a1898bd9da66c7960fcf174aed09ed397ead7ae738446)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b813a766f5c6f6c82c6dd0bedc2ac41804e7469604738fef2cc3e34dd3f01bf4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareContrast]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareContrast]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__90a682567b6a4d47ea29a352ac167d99ce19bde07a7fc1dc56991c7d0671fadd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareContrastOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareContrastOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b2fc7e571a92e4301bb7e8656067f13b9c5c213a6c412a8eb46436be075c614d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetBrightness")
    def reset_brightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightness", []))

    @jsii.member(jsii_name="resetBrightnessVar")
    def reset_brightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightnessVar", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetContrastVar")
    def reset_contrast_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrastVar", []))

    @builtins.property
    @jsii.member(jsii_name="brightnessInput")
    def brightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="brightnessVarInput")
    def brightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastVarInput")
    def contrast_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="brightness")
    def brightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightness"))

    @brightness.setter
    def brightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__16215cb1c6d110b92dfb02be79eb0c2db0c2946b3060a9211cd5a99bc57d79b1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightness", value)

    @builtins.property
    @jsii.member(jsii_name="brightnessVar")
    def brightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightnessVar"))

    @brightness_var.setter
    def brightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__222729e5b3df5ff55c86a90ecd4dee55ab8f0003291320ac9c048f7fd251e5d7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrast"))

    @contrast.setter
    def contrast(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__355eb4141d0ff38489eaef97607d865d5db2aea1fb53df4679e33a76d361b4ef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrast", value)

    @builtins.property
    @jsii.member(jsii_name="contrastVar")
    def contrast_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrastVar"))

    @contrast_var.setter
    def contrast_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__908cebc61dd974f3c7d44e1da979b24c7d99d155b306e02b9585ab333d946ceb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrastVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareContrast]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareContrast]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareContrast]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be2cdf9b178580d4a0f2960f03d982c6fbcff13814ee1e27f8b3c3560049c6cc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareCrop",
    jsii_struct_bases=[],
    name_mapping={
        "allow_expansion": "allowExpansion",
        "allow_expansion_var": "allowExpansionVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareCrop:
    def __init__(
        self,
        *,
        allow_expansion: typing.Optional[builtins.str] = None,
        allow_expansion_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_expansion: If cropping an area outside of the existing canvas, expands the image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        :param allow_expansion_var: If cropping an area outside of the existing canvas, expands the image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        :param gravity: Frame of reference for X and Y Positions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Frame of reference for X and Y Positions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The number of pixels to crop along the y-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The number of pixels to crop along the y-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The number of pixels to crop along the x-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The number of pixels to crop along the x-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        :param x_position: The x-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c3ee88be39bdbc16197727e6b8f6da52e04e575c525e1b4a661e6ac853f3e8db)
            check_type(argname="argument allow_expansion", value=allow_expansion, expected_type=type_hints["allow_expansion"])
            check_type(argname="argument allow_expansion_var", value=allow_expansion_var, expected_type=type_hints["allow_expansion_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if allow_expansion is not None:
            self._values["allow_expansion"] = allow_expansion
        if allow_expansion_var is not None:
            self._values["allow_expansion_var"] = allow_expansion_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def allow_expansion(self) -> typing.Optional[builtins.str]:
        '''If cropping an area outside of the existing canvas, expands the image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        '''
        result = self._values.get("allow_expansion")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def allow_expansion_var(self) -> typing.Optional[builtins.str]:
        '''If cropping an area outside of the existing canvas, expands the image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        '''
        result = self._values.get("allow_expansion_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Frame of reference for X and Y Positions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Frame of reference for X and Y Positions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the y-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the y-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the x-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the x-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1b039115e680ad7468e1335af3eaa3b6b2e5f844e5f4eb904dd6252bac6955fc)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__812f3bea4ad3e66367914a5992518c8646c607bba4174294c745dcc75d0b0420)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7eed2e81289484002b5e5c1d63f0e783791df9044e96ee598797ea1d76de1192)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fbc3019120a40dc9af2a67203e0db15a7cf88bb507d6ef621b5f2acfcbfc77b8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ce3d5af7c54b73427a2490005a81b0bc3870c374cc438916266bed855e81bdba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3779103764e182cbb5ca2a5a045599ceed09cbb99164e571cbb00a3548c23a3a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fabe284f71d3a3c7c514b83d88be1083836ba2c22b7a64175c4145d2f530f500)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAllowExpansion")
    def reset_allow_expansion(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansion", []))

    @jsii.member(jsii_name="resetAllowExpansionVar")
    def reset_allow_expansion_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansionVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionInput")
    def allow_expansion_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVarInput")
    def allow_expansion_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansion")
    def allow_expansion(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansion"))

    @allow_expansion.setter
    def allow_expansion(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d8c27ec2e0072403aacb5faf43896cad2b69b24d3ca54d51f0309bbceb0cfcce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansion", value)

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVar")
    def allow_expansion_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansionVar"))

    @allow_expansion_var.setter
    def allow_expansion_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__26df3bfc3c6ca58ad7a67f33f2b1edc1bb73cdad551dbe7066cfbfef60fa0bc9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansionVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e8d9bfeb4b526851c7abd5fbdfc946fd3bff27aab566aacfae06fff047e238cc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1a3b04440e3bba0daecf3bda08cf3048076e0f9864657751369522969312f465)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e5f9600d13f7a534e684c41c889bf450f0732c479d8b001e2f9dd1d9cda064e0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__571bd95446f4d676f6db711c608af4f7b8ceeb09a79ca177149c6d403f5b249c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e7ffd2ef1387022a88c71d1ec5345e7ec0ab1de78427ff2066d6b26eeb454c88)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb364ae6a899f07231158a5f9b9cebefc14c5a3da04a9b89a0f4182f04343945)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__824f43bbacd0b108d2c5f8a1dc324c99c7071c43033e359c7a76d26e7c860bcb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a000f91d85634ac2fe75faa88372b71507af5c989dde196f68a9a5d8d1cca5d5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8b628c495d927fcf5bf29fba63c37b5ac953b0cb91243099915c3bb40c1045b5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__45f9880bef6308fbea9054c14d85a166a73376b02efbdb0a1f2e928061c38dbe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f27aee93f4733f9442469ba511423b5fe7d9f41f1bb3027f88b1fa2281bb7a02)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareFaceCrop",
    jsii_struct_bases=[],
    name_mapping={
        "algorithm": "algorithm",
        "algorithm_var": "algorithmVar",
        "confidence": "confidence",
        "confidence_var": "confidenceVar",
        "fail_gravity": "failGravity",
        "fail_gravity_var": "failGravityVar",
        "focus": "focus",
        "focus_var": "focusVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "padding": "padding",
        "padding_var": "paddingVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareFaceCrop:
    def __init__(
        self,
        *,
        algorithm: typing.Optional[builtins.str] = None,
        algorithm_var: typing.Optional[builtins.str] = None,
        confidence: typing.Optional[builtins.str] = None,
        confidence_var: typing.Optional[builtins.str] = None,
        fail_gravity: typing.Optional[builtins.str] = None,
        fail_gravity_var: typing.Optional[builtins.str] = None,
        focus: typing.Optional[builtins.str] = None,
        focus_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param algorithm: Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm DataAkamaiImagingPolicyImage#algorithm}
        :param algorithm_var: Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm_var DataAkamaiImagingPolicyImage#algorithm_var}
        :param confidence: With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image. Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence DataAkamaiImagingPolicyImage#confidence}
        :param confidence_var: With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image. Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence_var DataAkamaiImagingPolicyImage#confidence_var}
        :param fail_gravity: Controls placement of the crop if Image and Video Manager does not detect any faces in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        :param fail_gravity_var: Controls placement of the crop if Image and Video Manager does not detect any faces in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        :param focus: Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus DataAkamaiImagingPolicyImage#focus}
        :param focus_var: Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus_var DataAkamaiImagingPolicyImage#focus_var}
        :param gravity: Controls placement of the crop. Directions are relative to the face(s) plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Controls placement of the crop. Directions are relative to the face(s) plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param padding: The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        :param style: Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a0007d4e21bb2deb724f78b3a5268f444d6a44e64a018febc5672c957418fdf8)
            check_type(argname="argument algorithm", value=algorithm, expected_type=type_hints["algorithm"])
            check_type(argname="argument algorithm_var", value=algorithm_var, expected_type=type_hints["algorithm_var"])
            check_type(argname="argument confidence", value=confidence, expected_type=type_hints["confidence"])
            check_type(argname="argument confidence_var", value=confidence_var, expected_type=type_hints["confidence_var"])
            check_type(argname="argument fail_gravity", value=fail_gravity, expected_type=type_hints["fail_gravity"])
            check_type(argname="argument fail_gravity_var", value=fail_gravity_var, expected_type=type_hints["fail_gravity_var"])
            check_type(argname="argument focus", value=focus, expected_type=type_hints["focus"])
            check_type(argname="argument focus_var", value=focus_var, expected_type=type_hints["focus_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if algorithm is not None:
            self._values["algorithm"] = algorithm
        if algorithm_var is not None:
            self._values["algorithm_var"] = algorithm_var
        if confidence is not None:
            self._values["confidence"] = confidence
        if confidence_var is not None:
            self._values["confidence_var"] = confidence_var
        if fail_gravity is not None:
            self._values["fail_gravity"] = fail_gravity
        if fail_gravity_var is not None:
            self._values["fail_gravity_var"] = fail_gravity_var
        if focus is not None:
            self._values["focus"] = focus
        if focus_var is not None:
            self._values["focus_var"] = focus_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def algorithm(self) -> typing.Optional[builtins.str]:
        '''Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm DataAkamaiImagingPolicyImage#algorithm}
        '''
        result = self._values.get("algorithm")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def algorithm_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm_var DataAkamaiImagingPolicyImage#algorithm_var}
        '''
        result = self._values.get("algorithm_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def confidence(self) -> typing.Optional[builtins.str]:
        '''With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image.

        Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence DataAkamaiImagingPolicyImage#confidence}
        '''
        result = self._values.get("confidence")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def confidence_var(self) -> typing.Optional[builtins.str]:
        '''With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image.

        Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence_var DataAkamaiImagingPolicyImage#confidence_var}
        '''
        result = self._values.get("confidence_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any faces in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        '''
        result = self._values.get("fail_gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any faces in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        '''
        result = self._values.get("fail_gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def focus(self) -> typing.Optional[builtins.str]:
        '''Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus DataAkamaiImagingPolicyImage#focus}
        '''
        result = self._values.get("focus")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def focus_var(self) -> typing.Optional[builtins.str]:
        '''Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus_var DataAkamaiImagingPolicyImage#focus_var}
        '''
        result = self._values.get("focus_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the face(s) plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the face(s) plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareFaceCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareFaceCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareFaceCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__da6560ba333a72c4b283caa365577cc73f1b21fce5f859e6f8b38ffcfad52ac8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareFaceCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5b101e885fe9562db737b776476f2288159edbfa01b47964c336899fe628e01d)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareFaceCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__151fa32b284ca7aa0b589d20caec9df9e3e01e1be5ac87ffa0b635efdf9cef7d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af37c1c37eba04da47236b0355c0cd0a38f0cc880830d3400694a829211f03ca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e3e2ca2db9f5322e6d44856ff27c8160afdf296d92a796a9baa4a11ad097458a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareFaceCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareFaceCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareFaceCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__faffd2686c4a3f2edf9d37784b4bbf97b9e8bd33e503fc8321fd3f38fcee0064)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareFaceCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareFaceCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7f5765853eb177dc6aa783c01482685340209826d68c5a9de75f69ebe9542761)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAlgorithm")
    def reset_algorithm(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAlgorithm", []))

    @jsii.member(jsii_name="resetAlgorithmVar")
    def reset_algorithm_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAlgorithmVar", []))

    @jsii.member(jsii_name="resetConfidence")
    def reset_confidence(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetConfidence", []))

    @jsii.member(jsii_name="resetConfidenceVar")
    def reset_confidence_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetConfidenceVar", []))

    @jsii.member(jsii_name="resetFailGravity")
    def reset_fail_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravity", []))

    @jsii.member(jsii_name="resetFailGravityVar")
    def reset_fail_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravityVar", []))

    @jsii.member(jsii_name="resetFocus")
    def reset_focus(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFocus", []))

    @jsii.member(jsii_name="resetFocusVar")
    def reset_focus_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFocusVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="algorithmInput")
    def algorithm_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "algorithmInput"))

    @builtins.property
    @jsii.member(jsii_name="algorithmVarInput")
    def algorithm_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "algorithmVarInput"))

    @builtins.property
    @jsii.member(jsii_name="confidenceInput")
    def confidence_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "confidenceInput"))

    @builtins.property
    @jsii.member(jsii_name="confidenceVarInput")
    def confidence_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "confidenceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityInput")
    def fail_gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityVarInput")
    def fail_gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="focusInput")
    def focus_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "focusInput"))

    @builtins.property
    @jsii.member(jsii_name="focusVarInput")
    def focus_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "focusVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="algorithm")
    def algorithm(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "algorithm"))

    @algorithm.setter
    def algorithm(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5a45ce9911296de225758dd04bfadd2e287b1e3652f7db97bc36a47c1d20b720)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "algorithm", value)

    @builtins.property
    @jsii.member(jsii_name="algorithmVar")
    def algorithm_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "algorithmVar"))

    @algorithm_var.setter
    def algorithm_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ebafb31a491e29ee56eecea0b5f0ec5f67419835d6b1828278ba83a2bce0cb7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "algorithmVar", value)

    @builtins.property
    @jsii.member(jsii_name="confidence")
    def confidence(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "confidence"))

    @confidence.setter
    def confidence(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c6711b4afda257d1f9728449388fbbf0ea3f5e36be72c909cb2659c451ff8d94)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "confidence", value)

    @builtins.property
    @jsii.member(jsii_name="confidenceVar")
    def confidence_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "confidenceVar"))

    @confidence_var.setter
    def confidence_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d79b094207398e3c34295ba509f9aa1d9a31728061d3504b90670a34381b37b8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "confidenceVar", value)

    @builtins.property
    @jsii.member(jsii_name="failGravity")
    def fail_gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravity"))

    @fail_gravity.setter
    def fail_gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__09679717438a64220fb91f74607f205a9cc86d69f73ae0724a571b2cf045dffe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravity", value)

    @builtins.property
    @jsii.member(jsii_name="failGravityVar")
    def fail_gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravityVar"))

    @fail_gravity_var.setter
    def fail_gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__58c9c63f8d7333940bc18e199def0ada52574a4908e72294d9616a55ec5403e2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="focus")
    def focus(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "focus"))

    @focus.setter
    def focus(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c0beea2bed393e3d591964e6d0fd2ac8db27ca2ed9d0c46e99a980a231bb5703)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "focus", value)

    @builtins.property
    @jsii.member(jsii_name="focusVar")
    def focus_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "focusVar"))

    @focus_var.setter
    def focus_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__10b6c01fc6a9504fd114e823703ca3667d8274b7a36afe62e68e3d2a4d3eba36)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "focusVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__95965b5d11fa70bd8eebfea5d2a9762bea14eee4344e6712a895651894b5f954)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__85334a592eecad8171393e693926e83aa319ef6967be74731f968454bb31a1a6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6045576257e4a56df5b620563229557a9b99b32dac247a22abda7a670dc1b76c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0a9e2805909e1b6d43d7c61dc506c22d430ca259f549c0aeb7e652d228dd2bae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4f24acd39266a0d43da10ca09542fb05bcb79475e8cfa636a693f82534cefbce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f15ad3edf5f3c3fc5c7bd36ee2cbe982b9e010d5b9c672ff16f4b253f63b107)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cc96759b875d8be148f01dfce60d68eadbb3dc99aa7cbcd55510c90a83e8a7fa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bff4ad9983579b809a9087e2b2f7c6f2f7e07938ba0f0c6b7f9e890002409c69)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ce34c658fa3c554389faf07d13940b0682ee0ef638aa1368dc19286beb6e81f8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__714cf866d3c1e7c90a11db11d4c3eba7948a1f902f520c3bdfa6a5d304b0fb2e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareFaceCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareFaceCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareFaceCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__62ff89b065b0d743605264b85466a73da346bfab064ebee368b7be3cee09dbb8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareFeatureCrop",
    jsii_struct_bases=[],
    name_mapping={
        "fail_gravity": "failGravity",
        "fail_gravity_var": "failGravityVar",
        "feature_radius": "featureRadius",
        "feature_radius_var": "featureRadiusVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "max_features": "maxFeatures",
        "max_features_var": "maxFeaturesVar",
        "min_feature_quality": "minFeatureQuality",
        "min_feature_quality_var": "minFeatureQualityVar",
        "padding": "padding",
        "padding_var": "paddingVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareFeatureCrop:
    def __init__(
        self,
        *,
        fail_gravity: typing.Optional[builtins.str] = None,
        fail_gravity_var: typing.Optional[builtins.str] = None,
        feature_radius: typing.Optional[builtins.str] = None,
        feature_radius_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        max_features: typing.Optional[builtins.str] = None,
        max_features_var: typing.Optional[builtins.str] = None,
        min_feature_quality: typing.Optional[builtins.str] = None,
        min_feature_quality_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fail_gravity: Controls placement of the crop if Image and Video Manager does not detect any features in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        :param fail_gravity_var: Controls placement of the crop if Image and Video Manager does not detect any features in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        :param feature_radius: The size in pixels of the important features to search for. If identified, two features never appear closer together than this value, ``8.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius DataAkamaiImagingPolicyImage#feature_radius}
        :param feature_radius_var: The size in pixels of the important features to search for. If identified, two features never appear closer together than this value, ``8.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius_var DataAkamaiImagingPolicyImage#feature_radius_var}
        :param gravity: Controls placement of the crop. Directions are relative to the region of interest plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Controls placement of the crop. Directions are relative to the region of interest plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param max_features: The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features DataAkamaiImagingPolicyImage#max_features}
        :param max_features_var: The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features_var DataAkamaiImagingPolicyImage#max_features_var}
        :param min_feature_quality: Determines the minimum quality level of the feature identified. To consider a feature important, the feature needs to surpass this value. Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality DataAkamaiImagingPolicyImage#min_feature_quality}
        :param min_feature_quality_var: Determines the minimum quality level of the feature identified. To consider a feature important, the feature needs to surpass this value. Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality_var DataAkamaiImagingPolicyImage#min_feature_quality_var}
        :param padding: Adds space around the region of interest. The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: Adds space around the region of interest. The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        :param style: Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3018731bc51f53e250effc2ac7c8ab5406f218d05fa3bc8daa0f65c5eba749e7)
            check_type(argname="argument fail_gravity", value=fail_gravity, expected_type=type_hints["fail_gravity"])
            check_type(argname="argument fail_gravity_var", value=fail_gravity_var, expected_type=type_hints["fail_gravity_var"])
            check_type(argname="argument feature_radius", value=feature_radius, expected_type=type_hints["feature_radius"])
            check_type(argname="argument feature_radius_var", value=feature_radius_var, expected_type=type_hints["feature_radius_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument max_features", value=max_features, expected_type=type_hints["max_features"])
            check_type(argname="argument max_features_var", value=max_features_var, expected_type=type_hints["max_features_var"])
            check_type(argname="argument min_feature_quality", value=min_feature_quality, expected_type=type_hints["min_feature_quality"])
            check_type(argname="argument min_feature_quality_var", value=min_feature_quality_var, expected_type=type_hints["min_feature_quality_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fail_gravity is not None:
            self._values["fail_gravity"] = fail_gravity
        if fail_gravity_var is not None:
            self._values["fail_gravity_var"] = fail_gravity_var
        if feature_radius is not None:
            self._values["feature_radius"] = feature_radius
        if feature_radius_var is not None:
            self._values["feature_radius_var"] = feature_radius_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if max_features is not None:
            self._values["max_features"] = max_features
        if max_features_var is not None:
            self._values["max_features_var"] = max_features_var
        if min_feature_quality is not None:
            self._values["min_feature_quality"] = min_feature_quality
        if min_feature_quality_var is not None:
            self._values["min_feature_quality_var"] = min_feature_quality_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def fail_gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any features in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        '''
        result = self._values.get("fail_gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any features in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        '''
        result = self._values.get("fail_gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feature_radius(self) -> typing.Optional[builtins.str]:
        '''The size in pixels of the important features to search for.

        If identified, two features never appear closer together than this value, ``8.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius DataAkamaiImagingPolicyImage#feature_radius}
        '''
        result = self._values.get("feature_radius")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feature_radius_var(self) -> typing.Optional[builtins.str]:
        '''The size in pixels of the important features to search for.

        If identified, two features never appear closer together than this value, ``8.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius_var DataAkamaiImagingPolicyImage#feature_radius_var}
        '''
        result = self._values.get("feature_radius_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the region of interest plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the region of interest plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def max_features(self) -> typing.Optional[builtins.str]:
        '''The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features DataAkamaiImagingPolicyImage#max_features}
        '''
        result = self._values.get("max_features")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def max_features_var(self) -> typing.Optional[builtins.str]:
        '''The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features_var DataAkamaiImagingPolicyImage#max_features_var}
        '''
        result = self._values.get("max_features_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def min_feature_quality(self) -> typing.Optional[builtins.str]:
        '''Determines the minimum quality level of the feature identified.

        To consider a feature important, the feature needs to surpass this value.  Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality DataAkamaiImagingPolicyImage#min_feature_quality}
        '''
        result = self._values.get("min_feature_quality")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def min_feature_quality_var(self) -> typing.Optional[builtins.str]:
        '''Determines the minimum quality level of the feature identified.

        To consider a feature important, the feature needs to surpass this value.  Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality_var DataAkamaiImagingPolicyImage#min_feature_quality_var}
        '''
        result = self._values.get("min_feature_quality_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''Adds space around the region of interest.

        The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''Adds space around the region of interest.

        The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareFeatureCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareFeatureCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareFeatureCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3e0fce7d80f4aee3e83e0737b603b6719296f18bee314c43ce69ba00607cf429)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareFeatureCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__090c6890442d27f88200a923d39f34cfba7065aefe529ec89b458ab84c8ff485)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareFeatureCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__13b0e0ec3e45dbfe1432bdf272453367b30d0b250be04d1912a7380217ad7898)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c8211b31e761b151c1359dc59673fdd6a26724a38a06bb2a69add92ec2c27c3e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ed411f72c760459665154a8dbb7fb16f673516ff63c88164841d707ab7cea5b3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareFeatureCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareFeatureCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareFeatureCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c939042c2a168c1df91e099b382b997195655deb1f86fa5b8fa74d3fc501b38c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareFeatureCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareFeatureCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__05cca48afe3545b0bd597fea09d4137e2b8a05b997ec395cfec3e182644405dd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetFailGravity")
    def reset_fail_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravity", []))

    @jsii.member(jsii_name="resetFailGravityVar")
    def reset_fail_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravityVar", []))

    @jsii.member(jsii_name="resetFeatureRadius")
    def reset_feature_radius(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureRadius", []))

    @jsii.member(jsii_name="resetFeatureRadiusVar")
    def reset_feature_radius_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureRadiusVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetMaxFeatures")
    def reset_max_features(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxFeatures", []))

    @jsii.member(jsii_name="resetMaxFeaturesVar")
    def reset_max_features_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxFeaturesVar", []))

    @jsii.member(jsii_name="resetMinFeatureQuality")
    def reset_min_feature_quality(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMinFeatureQuality", []))

    @jsii.member(jsii_name="resetMinFeatureQualityVar")
    def reset_min_feature_quality_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMinFeatureQualityVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="failGravityInput")
    def fail_gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityVarInput")
    def fail_gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featureRadiusInput")
    def feature_radius_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featureRadiusInput"))

    @builtins.property
    @jsii.member(jsii_name="featureRadiusVarInput")
    def feature_radius_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featureRadiusVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesInput")
    def max_features_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "maxFeaturesInput"))

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesVarInput")
    def max_features_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "maxFeaturesVarInput"))

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityInput")
    def min_feature_quality_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "minFeatureQualityInput"))

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityVarInput")
    def min_feature_quality_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "minFeatureQualityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravity")
    def fail_gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravity"))

    @fail_gravity.setter
    def fail_gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__85c466dbd8ab672e7a5bbc938b52c123939ea00e0743578c523f3c2a1fdb9512)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravity", value)

    @builtins.property
    @jsii.member(jsii_name="failGravityVar")
    def fail_gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravityVar"))

    @fail_gravity_var.setter
    def fail_gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9b1de5204e5961831c9a8169e91e69955ae58f5ee93ad88385863364d166834b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="featureRadius")
    def feature_radius(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featureRadius"))

    @feature_radius.setter
    def feature_radius(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c28a286af4eb4e202b0d3c337e321bbd0c51e789e803b5bb041b7ab70668f427)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featureRadius", value)

    @builtins.property
    @jsii.member(jsii_name="featureRadiusVar")
    def feature_radius_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featureRadiusVar"))

    @feature_radius_var.setter
    def feature_radius_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__696d9881fd2b57d81f8bd2688d5ea853b73cb2779ad411d1b4823b699e9d8039)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featureRadiusVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6fc4993e68c933b520e1b44d60ca59231d82676f0f1cf50ba6d67f1a8f9ad115)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6bfaef0582bf6047d692bb7a870a36b1290956373d5bf51b5fc094dc9cdd3b2b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0d8743eb29ed42385ca6f463d335af5699fb5c0418afbdf13ab3478945de4d47)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bf746a831625a690500573c76535d61abb9eb5693604d043072c89f94a5431a0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="maxFeatures")
    def max_features(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "maxFeatures"))

    @max_features.setter
    def max_features(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aeef9f1da8a98af67d6637617b1fe652ae59e08be4f29aa1a539d6c0252d165b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "maxFeatures", value)

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesVar")
    def max_features_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "maxFeaturesVar"))

    @max_features_var.setter
    def max_features_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4d8e7f7bf61709617caf124e4d0ad6fb14d5926ad8c91014bcbb87b1b53dc8f2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "maxFeaturesVar", value)

    @builtins.property
    @jsii.member(jsii_name="minFeatureQuality")
    def min_feature_quality(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "minFeatureQuality"))

    @min_feature_quality.setter
    def min_feature_quality(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1da32c195fdabb240bba073b80b69937c1376896f985f847979937eedd0277ef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "minFeatureQuality", value)

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityVar")
    def min_feature_quality_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "minFeatureQualityVar"))

    @min_feature_quality_var.setter
    def min_feature_quality_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0eeef0cb7d2bdd9697b58c00843f16a270e727e0f85ee70348c99606d5917e58)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "minFeatureQualityVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4f810b2b68dcff2ef90f96f6ceea21e640f376f628364667d4c473646d446371)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ba0f19122cd6570fb1b6352e0155b0c578f87b4c1e36c8eed6a9667ec2305eb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0f982e6b9e2acba0941c77734eea9253ead89ce66660999730fcdf1a78c3cf6c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2cb89709c8c86534a9749c0cb32064b4c7213e56de54bd0915a640a2da82f0aa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8bca14aa91e9b3898c08e8dd0b4f5cdd97634dd60f64a8150deca5252a6bfb51)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fcfb80bfa984aa3eef54ca4abe31df0a49e16d2847422069cf5ca48567734098)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareFeatureCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareFeatureCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareFeatureCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__916eeafd56d85a05983f89723d853e7296fe6c5ff687e36a354fc291e99c8b50)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareFitAndFill",
    jsii_struct_bases=[],
    name_mapping={
        "fill_transformation": "fillTransformation",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareFitAndFill:
    def __init__(
        self,
        *,
        fill_transformation: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareFitAndFillFillTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fill_transformation: fill_transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_transformation DataAkamaiImagingPolicyImage#fill_transformation}
        :param height: The height value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The width value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(fill_transformation, dict):
            fill_transformation = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareFitAndFillFillTransformation(**fill_transformation)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aeb8d3bb8581baa1f6ae0b63d5e11cb44e0b5490530fb891536e463208d7fe63)
            check_type(argname="argument fill_transformation", value=fill_transformation, expected_type=type_hints["fill_transformation"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fill_transformation is not None:
            self._values["fill_transformation"] = fill_transformation
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def fill_transformation(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareFitAndFillFillTransformation"]:
        '''fill_transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_transformation DataAkamaiImagingPolicyImage#fill_transformation}
        '''
        result = self._values.get("fill_transformation")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareFitAndFillFillTransformation"], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareFitAndFill(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareFitAndFillFillTransformation",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareFitAndFillFillTransformation:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareFitAndFillFillTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareFitAndFillFillTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareFitAndFillFillTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__72f25cc9561a132dc04073332390ae37c32d43d600373e39542d8070d4947e9e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareFitAndFillFillTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareFitAndFillFillTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareFitAndFillFillTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__62e1e128733475e1bcedd13750cec961d4e88f87cf0d7f4e3ec888519160eaa0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareFitAndFillList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareFitAndFillList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__19dc9808cac1b551836d7c865e4cecb3e220013cbbe3ebd141709cd2facb3637)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareFitAndFillOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__815dfcd70ce00ed3ad89ddb039fa1a75d2c9de4166024ec8c0ec89aa87ab3663)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareFitAndFillOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0dd3ef43180a3583a4f7b46b31fa10032ebe11584ca1a56852e657f5f56c2a5c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__53d55c7a29a5aa43ffda95e687d117a24f443ef43b0a915fcc5a79f66ee5e53c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__15f2045e9753bd2b1b4769146db6d5e22830ddbd3e1b73e3a43c2a1224db892b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareFitAndFill]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareFitAndFill]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareFitAndFill]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__75d533ca6fd4b6588e1c1e97ea535914b11181ab3fcfc890953fecb365efcedd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareFitAndFillOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareFitAndFillOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b36b899d4fb8996482de2b638911b52cf0c8c9bf43cbebcfbe3c6712f725d148)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putFillTransformation")
    def put_fill_transformation(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareFitAndFillFillTransformation()

        return typing.cast(None, jsii.invoke(self, "putFillTransformation", [value]))

    @jsii.member(jsii_name="resetFillTransformation")
    def reset_fill_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFillTransformation", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="fillTransformation")
    def fill_transformation(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareFitAndFillFillTransformationOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareFitAndFillFillTransformationOutputReference, jsii.get(self, "fillTransformation"))

    @builtins.property
    @jsii.member(jsii_name="fillTransformationInput")
    def fill_transformation_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareFitAndFillFillTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareFitAndFillFillTransformation], jsii.get(self, "fillTransformationInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a0e1c7198ab9784e3d8547d5bbabea43bc4c1720b2950478156e76e74330ef21)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bf5c04b814fe17b16de2fc6864a64c10eaa45c7c860d808865954b1f7e6df642)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__60321a252b357e85c3677815a972060251a9324ce05723f9853c48f7baccec60)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__350900228546de6ccf6f323033eec9e2653a0afe003f7890ac7dab3f6fc501c1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareFitAndFill]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareFitAndFill]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareFitAndFill]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b90ee610927056efb6b698dbea30514f67591cc14a85d6ecfe7ecb2d2028d918)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareGoop",
    jsii_struct_bases=[],
    name_mapping={
        "chaos": "chaos",
        "chaos_var": "chaosVar",
        "density": "density",
        "density_var": "densityVar",
        "power": "power",
        "power_var": "powerVar",
        "seed": "seed",
        "seed_var": "seedVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareGoop:
    def __init__(
        self,
        *,
        chaos: typing.Optional[builtins.str] = None,
        chaos_var: typing.Optional[builtins.str] = None,
        density: typing.Optional[builtins.str] = None,
        density_var: typing.Optional[builtins.str] = None,
        power: typing.Optional[builtins.str] = None,
        power_var: typing.Optional[builtins.str] = None,
        seed: typing.Optional[builtins.str] = None,
        seed_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param chaos: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        :param chaos_var: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        :param density: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        :param density_var: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        :param power: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        :param power_var: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        :param seed: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        :param seed_var: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a96c699833db68bfa49989b52d325e28a273197263d7697fea7a8efa37d5cf5)
            check_type(argname="argument chaos", value=chaos, expected_type=type_hints["chaos"])
            check_type(argname="argument chaos_var", value=chaos_var, expected_type=type_hints["chaos_var"])
            check_type(argname="argument density", value=density, expected_type=type_hints["density"])
            check_type(argname="argument density_var", value=density_var, expected_type=type_hints["density_var"])
            check_type(argname="argument power", value=power, expected_type=type_hints["power"])
            check_type(argname="argument power_var", value=power_var, expected_type=type_hints["power_var"])
            check_type(argname="argument seed", value=seed, expected_type=type_hints["seed"])
            check_type(argname="argument seed_var", value=seed_var, expected_type=type_hints["seed_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if chaos is not None:
            self._values["chaos"] = chaos
        if chaos_var is not None:
            self._values["chaos_var"] = chaos_var
        if density is not None:
            self._values["density"] = density
        if density_var is not None:
            self._values["density_var"] = density_var
        if power is not None:
            self._values["power"] = power
        if power_var is not None:
            self._values["power_var"] = power_var
        if seed is not None:
            self._values["seed"] = seed
        if seed_var is not None:
            self._values["seed_var"] = seed_var

    @builtins.property
    def chaos(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        '''
        result = self._values.get("chaos")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def chaos_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        '''
        result = self._values.get("chaos_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        '''
        result = self._values.get("density")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density_var(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        '''
        result = self._values.get("density_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        '''
        result = self._values.get("power")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power_var(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        '''
        result = self._values.get("power_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        '''
        result = self._values.get("seed")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed_var(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        result = self._values.get("seed_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareGoop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareGoopList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareGoopList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0b70f7d95168ac6dd4e99c7b88a3fd6f58357b195a6a03bf2f080292a64bef2b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareGoopOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__90c04b51691db159a7b00fb098a3301a0d44cd9808df59e71a366f7958bb3a7d)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareGoopOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5664b708f68e3d1ded13f4e43d676dab6b06271ff9800b40ef26842803d62f3c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__02e52fc4b07208fed8fcf9e565825b8b6bb873b6b423c91008a4e072f0e8f2d6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4cefe2086f71c81b09b75c3ffd8c0a707d7298de720207d5f0c1c8ca433db07e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareGoop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareGoop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__49c65879c72c44e8a8a94b498f29ddceb30f3041101b1f5ca0572254f685c3dc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareGoopOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareGoopOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0a8b43ad0b178cf940bb070bc51429667cdeeeff05d0646b7e7f6678b100edaa)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetChaos")
    def reset_chaos(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaos", []))

    @jsii.member(jsii_name="resetChaosVar")
    def reset_chaos_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaosVar", []))

    @jsii.member(jsii_name="resetDensity")
    def reset_density(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensity", []))

    @jsii.member(jsii_name="resetDensityVar")
    def reset_density_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensityVar", []))

    @jsii.member(jsii_name="resetPower")
    def reset_power(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPower", []))

    @jsii.member(jsii_name="resetPowerVar")
    def reset_power_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPowerVar", []))

    @jsii.member(jsii_name="resetSeed")
    def reset_seed(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeed", []))

    @jsii.member(jsii_name="resetSeedVar")
    def reset_seed_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeedVar", []))

    @builtins.property
    @jsii.member(jsii_name="chaosInput")
    def chaos_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosInput"))

    @builtins.property
    @jsii.member(jsii_name="chaosVarInput")
    def chaos_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosVarInput"))

    @builtins.property
    @jsii.member(jsii_name="densityInput")
    def density_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityInput"))

    @builtins.property
    @jsii.member(jsii_name="densityVarInput")
    def density_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="powerInput")
    def power_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerInput"))

    @builtins.property
    @jsii.member(jsii_name="powerVarInput")
    def power_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerVarInput"))

    @builtins.property
    @jsii.member(jsii_name="seedInput")
    def seed_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedInput"))

    @builtins.property
    @jsii.member(jsii_name="seedVarInput")
    def seed_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedVarInput"))

    @builtins.property
    @jsii.member(jsii_name="chaos")
    def chaos(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaos"))

    @chaos.setter
    def chaos(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fdcad866e8a0b08c696028f6d0769d99e0785996204ec3a9d34a2f36551763bc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaos", value)

    @builtins.property
    @jsii.member(jsii_name="chaosVar")
    def chaos_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaosVar"))

    @chaos_var.setter
    def chaos_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2752e08d56a4dfa22b70ba3ba1bce0d211788c23ff70948d95f8df04fd0adf6f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaosVar", value)

    @builtins.property
    @jsii.member(jsii_name="density")
    def density(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "density"))

    @density.setter
    def density(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1d8bfa9bae19933a211580394eab247344e47a446e5ef7e6cb3b4af5c3dd4f2b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "density", value)

    @builtins.property
    @jsii.member(jsii_name="densityVar")
    def density_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "densityVar"))

    @density_var.setter
    def density_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6511962e8dc12466c692adbdb88d34bf764cb61f79e19e7e7866e632b31eef43)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "densityVar", value)

    @builtins.property
    @jsii.member(jsii_name="power")
    def power(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "power"))

    @power.setter
    def power(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__56af2e361a6cb13d4ccb1320e998724fb5f5aa7c393a2db0e499e1b0a5aaea8a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "power", value)

    @builtins.property
    @jsii.member(jsii_name="powerVar")
    def power_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "powerVar"))

    @power_var.setter
    def power_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__58cd10da8225a69739852cca751ef3107b383bda548b7d5a685a868d84739ab7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "powerVar", value)

    @builtins.property
    @jsii.member(jsii_name="seed")
    def seed(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seed"))

    @seed.setter
    def seed(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dbfc9b1c6110b58f621c2eddf249e1ca3db00fe49cc9127387ef11c50d15f50e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seed", value)

    @builtins.property
    @jsii.member(jsii_name="seedVar")
    def seed_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seedVar"))

    @seed_var.setter
    def seed_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ee5f589d37e16c8426672beaf85214589303fcd74bd30fc195aceeac22809bbb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seedVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareGoop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareGoop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareGoop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__127da5ad8cef38cad48243fda08a2912f5e163bcfc7b8f7e0ce2a41abeb37ada)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareGrayscale",
    jsii_struct_bases=[],
    name_mapping={"type": "type", "type_var": "typeVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareGrayscale:
    def __init__(
        self,
        *,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param type: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b0474aa87430b5ccf49b4fca540c323ade4540f3849889d20b24a42ec478241e)
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareGrayscale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareGrayscaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareGrayscaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__24bd5c32a89c5e35f53382c4042a5195bcbcc733b45ce3d4154f42d48a4d93bb)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareGrayscaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b82811e180c637d08e0de2fe8b03a4049b8f513a02ef3312509f5d98f4c1c23c)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareGrayscaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ec28ef63e26f1e02de26e2c48026764d37bd28d48f6d1bafbb1b01bddbdfff1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3702cbc5606ecd24c79c148c06e0eca1ac5680d1a8a230378270ed868ca5038e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__203390c9513744a85a60448d3b2f7a639d20cd44cfa44f40f8bfd495c2c648df)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareGrayscale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareGrayscale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ea01dc6333abadfde18621ee588de4b12cfdee37e1ec0dd8068ffd764acfa83)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareGrayscaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareGrayscaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7e396c69d3c9e77fe1672d7d5881ece69c59f22cfbd3dff15a6827b602e514fc)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7714cd9acaa44c7edaec6f9354cb7ba9f5cc71af798d8dc19303b9b552239fbf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__78d220c36f04b8bc5e91d7830e2e7cbfa7f007374d9c47687085d7c444dad1a2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareGrayscale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareGrayscale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareGrayscale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9e173ae8fb0ca720f9a8da9e19d54d45e0780e9fd0d093cca0179fdee0600d81)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareHsl",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "lightness": "lightness",
        "lightness_var": "lightnessVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareHsl:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness: typing.Optional[builtins.str] = None,
        lightness_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        :param lightness_var: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__698d173474971b49b5e1ae5299bdbe2910cb73094b000f884b77052f4e4f726c)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness", value=lightness, expected_type=type_hints["lightness"])
            check_type(argname="argument lightness_var", value=lightness_var, expected_type=type_hints["lightness_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness is not None:
            self._values["lightness"] = lightness
        if lightness_var is not None:
            self._values["lightness_var"] = lightness_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        '''
        result = self._values.get("lightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        '''
        result = self._values.get("lightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareHsl(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareHslList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareHslList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__68c3a3cd93643e766180188f2ed2a7ba9bee085ae3e9afb57dd46e5102db93ca)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareHslOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4af719efa0463f1f4aa414319fe4e60953b003de9148c13e0199b77da446a291)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareHslOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ae6bf7b1d0ed95dc742b3f66819bdf8fa65ac5991b2f856d67409c48a962038)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__57170bb7f053c72952655e5e0e9382fb17e992198ed76247c0316d076764d1e8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7e23e514ade784267057b2789f669631d1a6d35547e3bdaffc1bc3de77647906)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareHsl]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareHsl]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a7f3d90ce61e7eb68c30092ee2d237bac521f6b5453d5aa662549e972cd8d501)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareHslOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareHslOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b18f7a1fecc51f216f2913c6579bcac467d31f21b85eff6b22cb903a5c4f99a4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightness")
    def reset_lightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightness", []))

    @jsii.member(jsii_name="resetLightnessVar")
    def reset_lightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessInput")
    def lightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessVarInput")
    def lightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6778a5e2fb7e1ca8376b9cf0abc85648e301f7f7511364a5bc771816bcac55f5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ed73015c704d69a6f8cd2940d277c6e89926dcd2d25005ed0f850b72a6195273)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightness")
    def lightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightness"))

    @lightness.setter
    def lightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ecc10951828dce62e03077efef2b92671e595791885123ff3079ad562c4da67a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightness", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessVar")
    def lightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessVar"))

    @lightness_var.setter
    def lightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f8fd42ae39111e40dd0056b8441163b702012729bd8d2c8f59cf870298363908)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4147db5b1f82021ca7eff0858687a3934464fa0126fd5ace6e9c9eabf8f58c60)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__71a51ecf7e10e8fab74b47ef9002190305d292ad24c14c5069b4863d28975baf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareHsl]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareHsl]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareHsl]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__89771dd0279e4747d1438f9f35f2b1ef3cd1980e983b272f2f0d45df402edef1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareHsv",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareHsv:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        :param value: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5accab57533c08f200408ca804259b3aec7509be35774b51dc5054cbfb99d737)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareHsv(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareHsvList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareHsvList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1703a36db02214244973e92b96e2783f92af0e04da8f0d33f0f20b361947091d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareHsvOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e3a1b5b6103d131eb11cf29b0b86a717e1a478066b3fdd23db05a1b2dee7259b)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareHsvOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6a8a01aa73417f178789725b240a51d8c35c88ea54f72f14a9a37b731dd2dd8e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__faace64ff363141abf5e2c60c42b0054601b73c8b55ee849df156a28646cff13)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f7fac4c42dd96521b9f4cbd835e83978262dcb2d42e3688196403432772b0fc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareHsv]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareHsv]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0cc277a89655cd701dbd8fb1c0b75746f90f023458b7871282abf8fc7a95aeeb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareHsvOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareHsvOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__160108d0b2afdce9f7bfed7a66d0b7b32e0c758e3c51c80d4196f7c59d888b3b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bce38c4c3fb6221778677d067367cba54a2d926ef29ae374e82eba82b7288823)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8d3bf19872a329c79a0609bee3d904fc132046b698df86c44c291e9806f589f7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__12d5152f206aa50d57a3f827615425003518f7944a5c389f1b8c69b276838636)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a01149e14d2ac7b204907d184fb80840b48ae5fc77bcc2aa412c4b5aa0fa460e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0920bfecd284bb82c4894fb61b91348f23d2ce968c7ab3657f0471cc612d833e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d0a2663c60058ada77b0b476df121b256c52dae132d068c11c34415b301817c6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareHsv]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareHsv]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareHsv]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c57bedbc90fff891eac14298b0877b72ca4cb41b550a21b7529837ce3a38853f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfDimension",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "dimension": "dimension",
        "dimension_var": "dimensionVar",
        "equal": "equal",
        "greater_than": "greaterThan",
        "less_than": "lessThan",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfDimension:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfDimensionDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        dimension: typing.Optional[builtins.str] = None,
        dimension_var: typing.Optional[builtins.str] = None,
        equal: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfDimensionEqual", typing.Dict[builtins.str, typing.Any]]] = None,
        greater_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfDimensionGreaterThan", typing.Dict[builtins.str, typing.Any]]] = None,
        less_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfDimensionLessThan", typing.Dict[builtins.str, typing.Any]]] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param dimension: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        :param dimension_var: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        :param equal: equal block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        :param greater_than: greater_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        :param less_than: less_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        :param value: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfDimensionDefault(**default)
        if isinstance(equal, dict):
            equal = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfDimensionEqual(**equal)
        if isinstance(greater_than, dict):
            greater_than = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfDimensionGreaterThan(**greater_than)
        if isinstance(less_than, dict):
            less_than = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfDimensionLessThan(**less_than)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ebbbbef167625001e771d2170d12045b71321c0f91f52fbc2f36f6fc55372a13)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument dimension", value=dimension, expected_type=type_hints["dimension"])
            check_type(argname="argument dimension_var", value=dimension_var, expected_type=type_hints["dimension_var"])
            check_type(argname="argument equal", value=equal, expected_type=type_hints["equal"])
            check_type(argname="argument greater_than", value=greater_than, expected_type=type_hints["greater_than"])
            check_type(argname="argument less_than", value=less_than, expected_type=type_hints["less_than"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if dimension is not None:
            self._values["dimension"] = dimension
        if dimension_var is not None:
            self._values["dimension_var"] = dimension_var
        if equal is not None:
            self._values["equal"] = equal
        if greater_than is not None:
            self._values["greater_than"] = greater_than
        if less_than is not None:
            self._values["less_than"] = less_than
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfDimensionDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfDimensionDefault"], result)

    @builtins.property
    def dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        '''
        result = self._values.get("dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        '''
        result = self._values.get("dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def equal(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfDimensionEqual"]:
        '''equal block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        '''
        result = self._values.get("equal")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfDimensionEqual"], result)

    @builtins.property
    def greater_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfDimensionGreaterThan"]:
        '''greater_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        '''
        result = self._values.get("greater_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfDimensionGreaterThan"], result)

    @builtins.property
    def less_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfDimensionLessThan"]:
        '''less_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        '''
        result = self._values.get("less_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfDimensionLessThan"], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfDimension(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfDimensionDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfDimensionDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfDimensionDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfDimensionDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfDimensionDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3daf2045315732633d2cecc7efe271c332ee13a50e7f690123d32d21047f3a3d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfDimensionDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfDimensionDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__34193cdc0d3b25b7faa51478a4fa6f60d0cc77e97352d7ad4948c4150ae7bb20)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfDimensionEqual",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfDimensionEqual:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfDimensionEqual(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfDimensionEqualOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfDimensionEqualOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dfff1184984ddd0d26d7cff491187b1524d089825e8b1c674c8477d1b6091afd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfDimensionEqual], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfDimensionEqual],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__740388f862eb523b21bb800080338b1c882b557d13e0ad480e71bdc5c63a9f69)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfDimensionGreaterThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfDimensionGreaterThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfDimensionGreaterThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfDimensionGreaterThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfDimensionGreaterThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2835ddaed04ad90067e2beb7bb72562de3ae303605bfd31b8d2bd6f064d2a4fe)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfDimensionGreaterThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfDimensionGreaterThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b8169287fcffc2f88ce1135b17a095280a234bd5eb8765920432355f49bc858d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfDimensionLessThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfDimensionLessThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfDimensionLessThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfDimensionLessThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfDimensionLessThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ec30d756c45ae948e38619899671dba7f6299a11db986e4aca6cbae6166c2e0c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfDimensionLessThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfDimensionLessThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__204bf3334751173cf8a789a92b914b16c28a6cc3a3077f83e59954270cd7c231)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfDimensionList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfDimensionList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1612ac2d9185537f8c98bc5658eee3d27a1cc2076d6d93c72c95b6965120fe99)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfDimensionOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7a693bd23d0586c16001c4a9eeb4e5cb00e3a8e8478dac2bafa9f658781f1774)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfDimensionOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3e337671496a3b2d6aa4a84378e5bf5d49bd422fc7321e7dc15f62d0eeff21e6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7447fc60235efc719f36e7e47de54a704f6b77a777312c1cbca460a2cb77f05e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fe37237c1149bf3e00d4bb99ecd7715ebd29706aef29f8ca29b5487de946365c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfDimension]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfDimension]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d038fad15f8d3dd8f17f5a5195de4651176131cbfa52e75353a0e16ba77eab9f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfDimensionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfDimensionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c16020fd143a61208a5fc6f6b1560e562243e3d730aa1aab981d5e16e9d0fcf5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfDimensionDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putEqual")
    def put_equal(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfDimensionEqual()

        return typing.cast(None, jsii.invoke(self, "putEqual", [value]))

    @jsii.member(jsii_name="putGreaterThan")
    def put_greater_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfDimensionGreaterThan()

        return typing.cast(None, jsii.invoke(self, "putGreaterThan", [value]))

    @jsii.member(jsii_name="putLessThan")
    def put_less_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfDimensionLessThan()

        return typing.cast(None, jsii.invoke(self, "putLessThan", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetDimension")
    def reset_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimension", []))

    @jsii.member(jsii_name="resetDimensionVar")
    def reset_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimensionVar", []))

    @jsii.member(jsii_name="resetEqual")
    def reset_equal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEqual", []))

    @jsii.member(jsii_name="resetGreaterThan")
    def reset_greater_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGreaterThan", []))

    @jsii.member(jsii_name="resetLessThan")
    def reset_less_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLessThan", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfDimensionDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfDimensionDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="equal")
    def equal(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfDimensionEqualOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfDimensionEqualOutputReference, jsii.get(self, "equal"))

    @builtins.property
    @jsii.member(jsii_name="greaterThan")
    def greater_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfDimensionGreaterThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfDimensionGreaterThanOutputReference, jsii.get(self, "greaterThan"))

    @builtins.property
    @jsii.member(jsii_name="lessThan")
    def less_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfDimensionLessThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfDimensionLessThanOutputReference, jsii.get(self, "lessThan"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfDimensionDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionInput")
    def dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionVarInput")
    def dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="equalInput")
    def equal_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfDimensionEqual], jsii.get(self, "equalInput"))

    @builtins.property
    @jsii.member(jsii_name="greaterThanInput")
    def greater_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfDimensionGreaterThan], jsii.get(self, "greaterThanInput"))

    @builtins.property
    @jsii.member(jsii_name="lessThanInput")
    def less_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfDimensionLessThan], jsii.get(self, "lessThanInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="dimension")
    def dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimension"))

    @dimension.setter
    def dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__acf3309fb6b64aedcfdc1643ee32247ac2229cf7e91c4115d4cf1d8738acd039)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimension", value)

    @builtins.property
    @jsii.member(jsii_name="dimensionVar")
    def dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimensionVar"))

    @dimension_var.setter
    def dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6edf7fe273b649181072ef127fb059ed7a7750fbba23cfded19387b02af4245e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2c3f6e9c26887e4ef257caa3315abda1478250c96d2a6a408f94b437f8521e5e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d7723eba47740018528f6395b96663298f8c83441252e9ea0852437b4ab4090d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfDimension]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfDimension]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfDimension]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1051c5caa570bdd9a2a45ee44ac58f495ab0330f5afe7f716ee5d11e1ede093e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfOrientation",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "landscape": "landscape",
        "portrait": "portrait",
        "square": "square",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfOrientation:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfOrientationDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        landscape: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfOrientationLandscape", typing.Dict[builtins.str, typing.Any]]] = None,
        portrait: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfOrientationPortrait", typing.Dict[builtins.str, typing.Any]]] = None,
        square: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfOrientationSquare", typing.Dict[builtins.str, typing.Any]]] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param landscape: landscape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        :param portrait: portrait block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        :param square: square block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfOrientationDefault(**default)
        if isinstance(landscape, dict):
            landscape = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfOrientationLandscape(**landscape)
        if isinstance(portrait, dict):
            portrait = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfOrientationPortrait(**portrait)
        if isinstance(square, dict):
            square = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfOrientationSquare(**square)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3974cbe4d114b6ea78b1e3bd32a59d4722cfed1b8914b8b2a778f55a075bdbed)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument landscape", value=landscape, expected_type=type_hints["landscape"])
            check_type(argname="argument portrait", value=portrait, expected_type=type_hints["portrait"])
            check_type(argname="argument square", value=square, expected_type=type_hints["square"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if landscape is not None:
            self._values["landscape"] = landscape
        if portrait is not None:
            self._values["portrait"] = portrait
        if square is not None:
            self._values["square"] = square

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfOrientationDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfOrientationDefault"], result)

    @builtins.property
    def landscape(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfOrientationLandscape"]:
        '''landscape block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        '''
        result = self._values.get("landscape")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfOrientationLandscape"], result)

    @builtins.property
    def portrait(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfOrientationPortrait"]:
        '''portrait block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        '''
        result = self._values.get("portrait")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfOrientationPortrait"], result)

    @builtins.property
    def square(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfOrientationSquare"]:
        '''square block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        result = self._values.get("square")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfOrientationSquare"], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfOrientation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfOrientationDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfOrientationDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfOrientationDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfOrientationDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfOrientationDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__db57165d74627d570a12059f07721353c2b19f97cce10d6403e697af3bb475fd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfOrientationDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfOrientationDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0973eb878f8dd64a1511dc80ed038a12810e6a46bc85007106fe7c21a901a16e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfOrientationLandscape",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfOrientationLandscape:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfOrientationLandscape(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfOrientationLandscapeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfOrientationLandscapeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1d1f1ce08d235e733571a2e54dc27f95a7eb573843d13e46da9730f20b549c13)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfOrientationLandscape], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfOrientationLandscape],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c32a01713e38070cf7f33f0eac091c9bbbb39414b9d4ad3b8ea1db40c1f55490)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfOrientationList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfOrientationList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df6ffad39488561ca20a560ddbf730743a8dfaafa1bf5e3be11af07c4c2004e8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfOrientationOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__11d87a11f0ea43b3bd4cba7422a453f922d5b54c105480fb6c2e95d8709f1161)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfOrientationOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__92119a088ab6ccdf42a5e78505eef3066fbdb98b365f93b480f9c93f74039db3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fb8e377180c129b3e391db21a410f4a8f94d0c085e1ad098a2fc07829b9f2ce2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2aba47c3540a26b09e2b4c5edae7139941c7da001a021f6e2c0f66ba9784ccdd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfOrientation]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfOrientation]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1319a0a16df8b2e0dec237ecc95c22e23048c6805600e40b299cf76b73604646)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfOrientationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfOrientationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__04d6a62152e0a46dc6bb052f7d3a2e6ae4efd99ad440e5174d6e1ff0af4d6454)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfOrientationDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putLandscape")
    def put_landscape(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfOrientationLandscape()

        return typing.cast(None, jsii.invoke(self, "putLandscape", [value]))

    @jsii.member(jsii_name="putPortrait")
    def put_portrait(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfOrientationPortrait()

        return typing.cast(None, jsii.invoke(self, "putPortrait", [value]))

    @jsii.member(jsii_name="putSquare")
    def put_square(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfOrientationSquare()

        return typing.cast(None, jsii.invoke(self, "putSquare", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetLandscape")
    def reset_landscape(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLandscape", []))

    @jsii.member(jsii_name="resetPortrait")
    def reset_portrait(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPortrait", []))

    @jsii.member(jsii_name="resetSquare")
    def reset_square(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSquare", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfOrientationDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfOrientationDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="landscape")
    def landscape(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfOrientationLandscapeOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfOrientationLandscapeOutputReference, jsii.get(self, "landscape"))

    @builtins.property
    @jsii.member(jsii_name="portrait")
    def portrait(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfOrientationPortraitOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfOrientationPortraitOutputReference", jsii.get(self, "portrait"))

    @builtins.property
    @jsii.member(jsii_name="square")
    def square(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfOrientationSquareOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfOrientationSquareOutputReference", jsii.get(self, "square"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfOrientationDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="landscapeInput")
    def landscape_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfOrientationLandscape], jsii.get(self, "landscapeInput"))

    @builtins.property
    @jsii.member(jsii_name="portraitInput")
    def portrait_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfOrientationPortrait"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfOrientationPortrait"], jsii.get(self, "portraitInput"))

    @builtins.property
    @jsii.member(jsii_name="squareInput")
    def square_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfOrientationSquare"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfOrientationSquare"], jsii.get(self, "squareInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfOrientation]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfOrientation]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfOrientation]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6cf8c8902f1be9c972c065fd5d385cffd2e51236bd15d36a893cb88be77fa6f2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfOrientationPortrait",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfOrientationPortrait:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfOrientationPortrait(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfOrientationPortraitOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfOrientationPortraitOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0b9f95d1143f3b74b8bfb4d55f57b2fb86d831fec734340b9dccf3e65981a41c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfOrientationPortrait]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfOrientationPortrait], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfOrientationPortrait],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0dae74a406f925b87199efbdb1760387f77e4bec917d8830ab8013602212feaa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfOrientationSquare",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfOrientationSquare:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfOrientationSquare(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfOrientationSquareOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfOrientationSquareOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__91be1f0e9added5cb0d3c832ede9e533246fa76793f86016f8dd5331be262f82)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfOrientationSquare]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfOrientationSquare], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfOrientationSquare],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f7a4e924c2c554ab4d558217383d1b98ae28cdb2f3e9b574a0157928e209d459)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareImQuery",
    jsii_struct_bases=[],
    name_mapping={
        "allowed_transformations": "allowedTransformations",
        "query_var": "queryVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareImQuery:
    def __init__(
        self,
        *,
        allowed_transformations: typing.Sequence[builtins.str],
        query_var: builtins.str,
    ) -> None:
        '''
        :param allowed_transformations: Specifies the transformations that can be applied using the query string parameter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allowed_transformations DataAkamaiImagingPolicyImage#allowed_transformations}
        :param query_var: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#query_var DataAkamaiImagingPolicyImage#query_var}.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__46e513955aa1d21fc3b505fb221707d97aa8acf1c0a908f3be9b04fe6f138ea9)
            check_type(argname="argument allowed_transformations", value=allowed_transformations, expected_type=type_hints["allowed_transformations"])
            check_type(argname="argument query_var", value=query_var, expected_type=type_hints["query_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "allowed_transformations": allowed_transformations,
            "query_var": query_var,
        }

    @builtins.property
    def allowed_transformations(self) -> typing.List[builtins.str]:
        '''Specifies the transformations that can be applied using the query string parameter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allowed_transformations DataAkamaiImagingPolicyImage#allowed_transformations}
        '''
        result = self._values.get("allowed_transformations")
        assert result is not None, "Required property 'allowed_transformations' is missing"
        return typing.cast(typing.List[builtins.str], result)

    @builtins.property
    def query_var(self) -> builtins.str:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#query_var DataAkamaiImagingPolicyImage#query_var}.'''
        result = self._values.get("query_var")
        assert result is not None, "Required property 'query_var' is missing"
        return typing.cast(builtins.str, result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareImQuery(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareImQueryList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareImQueryList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d43b0f28245889d56977d2c94c0163a0e6f98286630d9f6e77601e9646b4dd7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareImQueryOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3641eb2d1846fbd8bd2fa3373ef08a5e6ebb2faf9da1a3cc6094428822364e93)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareImQueryOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6b1a5da55ddca53dd413a0f735705b3bafb6646991f656b62b6f2fcfe4278f5c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9bd8bea57d71a4712dc9b2a31950e7779734b0fa3ff7a3fe16e63b8127de1dbc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aba1645ac6bbd65f6f8f32954b4484f06f4ecacb9867a7d666f1a3c9de202b46)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareImQuery]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareImQuery]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareImQuery]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9dd5ff5bd819aeb246d89c19ebac32bd713ab804f3bfe0c30ff6e5c2e0f4c1cc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareImQueryOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareImQueryOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__28f74fd720bf5cc710d3ca0f5cc13cb210dc89206d11a9d62f9824224caeaaae)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @builtins.property
    @jsii.member(jsii_name="allowedTransformationsInput")
    def allowed_transformations_input(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "allowedTransformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="queryVarInput")
    def query_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "queryVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowedTransformations")
    def allowed_transformations(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "allowedTransformations"))

    @allowed_transformations.setter
    def allowed_transformations(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3c1286eed790542c9b0e329b5b035fadf008aa85e5ab2ae9453a3333fba6609b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowedTransformations", value)

    @builtins.property
    @jsii.member(jsii_name="queryVar")
    def query_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "queryVar"))

    @query_var.setter
    def query_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9e0d7f7f546ca83f11a98af972f7e83529cd275450b64efbb2d0ab714649e649)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "queryVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareImQuery]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareImQuery]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareImQuery]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__333ee9ce411821911e5bf8ec3096cc7f2b6fa3c41830c348a7da2b5ec2682f6b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareMaxColors",
    jsii_struct_bases=[],
    name_mapping={"colors": "colors", "colors_var": "colorsVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareMaxColors:
    def __init__(
        self,
        *,
        colors: typing.Optional[builtins.str] = None,
        colors_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param colors: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        :param colors_var: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__76d01cea4c5b6346f49af85cdc42dffd8c4a0adfb34eab19151e05caba51054f)
            check_type(argname="argument colors", value=colors, expected_type=type_hints["colors"])
            check_type(argname="argument colors_var", value=colors_var, expected_type=type_hints["colors_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if colors is not None:
            self._values["colors"] = colors
        if colors_var is not None:
            self._values["colors_var"] = colors_var

    @builtins.property
    def colors(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        '''
        result = self._values.get("colors")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def colors_var(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        result = self._values.get("colors_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareMaxColors(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareMaxColorsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareMaxColorsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__420346fcf340212963a1879670e306847c55d3783727f09cae0f1be0530aa2ac)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareMaxColorsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7743a7c42693f43e3675f8693c21f6faeb0380ae32ed1f42699cbd95a144fccf)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareMaxColorsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__60a996febc073c6ccc8425012e019383ab807b1b031a56506f9c5733af07d66d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f7b856119bff104f158d0fbce6fb398cb7b77e87525fd2c0cc7f758d9cd254d1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa8854e1cc2f0de6143ae3694c0a2db5ab36848633b0b94d96072bc146051a17)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareMaxColors]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareMaxColors]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ec3a397dbea439ac7ae38878d0715dd8be4a9df2bd68673f8c5a56f1eda27c6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareMaxColorsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareMaxColorsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__461a88d543a57a15f6494ead9e09d5ce89d85f4f392ece282768a643b4f3b522)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColors")
    def reset_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColors", []))

    @jsii.member(jsii_name="resetColorsVar")
    def reset_colors_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorsVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorsInput")
    def colors_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsInput"))

    @builtins.property
    @jsii.member(jsii_name="colorsVarInput")
    def colors_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsVarInput"))

    @builtins.property
    @jsii.member(jsii_name="colors")
    def colors(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colors"))

    @colors.setter
    def colors(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5551677c8a515d02c55e4ba72114e96630d22f2a9e1c8d48bf10e9d7c8f5aa88)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colors", value)

    @builtins.property
    @jsii.member(jsii_name="colorsVar")
    def colors_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorsVar"))

    @colors_var.setter
    def colors_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ec054c8c589bb43de29276768662a5b58e6799881e0e967bedde111c8707afc7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorsVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareMaxColors]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareMaxColors]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareMaxColors]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__330dcb39f6c9d60aa21c3ae36ed7e7de5fdf5eae93e3826b3c1119dcc9d75408)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareMirror",
    jsii_struct_bases=[],
    name_mapping={
        "horizontal": "horizontal",
        "horizontal_var": "horizontalVar",
        "vertical": "vertical",
        "vertical_var": "verticalVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareMirror:
    def __init__(
        self,
        *,
        horizontal: typing.Optional[builtins.str] = None,
        horizontal_var: typing.Optional[builtins.str] = None,
        vertical: typing.Optional[builtins.str] = None,
        vertical_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param horizontal: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        :param horizontal_var: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        :param vertical: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        :param vertical_var: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__06e3e606cecf84d3ecc19af4594d9d19f568be73d88d9b7c1ab5e4104606b017)
            check_type(argname="argument horizontal", value=horizontal, expected_type=type_hints["horizontal"])
            check_type(argname="argument horizontal_var", value=horizontal_var, expected_type=type_hints["horizontal_var"])
            check_type(argname="argument vertical", value=vertical, expected_type=type_hints["vertical"])
            check_type(argname="argument vertical_var", value=vertical_var, expected_type=type_hints["vertical_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if horizontal is not None:
            self._values["horizontal"] = horizontal
        if horizontal_var is not None:
            self._values["horizontal_var"] = horizontal_var
        if vertical is not None:
            self._values["vertical"] = vertical
        if vertical_var is not None:
            self._values["vertical_var"] = vertical_var

    @builtins.property
    def horizontal(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        '''
        result = self._values.get("horizontal")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def horizontal_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        '''
        result = self._values.get("horizontal_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        '''
        result = self._values.get("vertical")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        result = self._values.get("vertical_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareMirror(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareMirrorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareMirrorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dbe09c7e69885d38ff90057b2946121ef2a28abdedb01cf283c9b9b0d86b3757)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareMirrorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eeac7da84ec49efa7c8a3f4944d7f379d649c8cb526d31f1645e5f6190e9ef9d)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareMirrorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a02f84b9ca9e9ccd9263c0f8b7a69bad0c4bc489d3ec7d734c323cc7bb91ebd6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__717dd2dd51e7bb0ef1d1e4f10ee941a8fee3dfc001988fa4e79919da796726d2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a2815fa2f4d4d80875603082976f478fa0a3610ffdc368a7b39fd7435dc5c828)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareMirror]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareMirror]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__819405c971a8a57c416c5e58b8247abcd550be6b5ec3bf45146a9099bd53f73d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareMirrorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareMirrorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eb00e3db40eca7d393bf0efa5b2b872bad6105c83b8700b2e8a67f996c1feb03)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHorizontal")
    def reset_horizontal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontal", []))

    @jsii.member(jsii_name="resetHorizontalVar")
    def reset_horizontal_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontalVar", []))

    @jsii.member(jsii_name="resetVertical")
    def reset_vertical(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVertical", []))

    @jsii.member(jsii_name="resetVerticalVar")
    def reset_vertical_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVerticalVar", []))

    @builtins.property
    @jsii.member(jsii_name="horizontalInput")
    def horizontal_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontalVarInput")
    def horizontal_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalInput")
    def vertical_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalVarInput")
    def vertical_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontal")
    def horizontal(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontal"))

    @horizontal.setter
    def horizontal(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__56dde5f5b6cbe7889bcff2696d06fa90d34776cac20739869f793598a1e32823)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontal", value)

    @builtins.property
    @jsii.member(jsii_name="horizontalVar")
    def horizontal_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontalVar"))

    @horizontal_var.setter
    def horizontal_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__186462bda4a0f253a849f10b2b7866ac61d8980cd13ea7e5afbd267daa7ee180)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontalVar", value)

    @builtins.property
    @jsii.member(jsii_name="vertical")
    def vertical(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "vertical"))

    @vertical.setter
    def vertical(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__65583f723290ddfa95f46bc81a1f44d4653858e80d2573dd36b8ad9ab75f8d25)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "vertical", value)

    @builtins.property
    @jsii.member(jsii_name="verticalVar")
    def vertical_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "verticalVar"))

    @vertical_var.setter
    def vertical_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bab1cefef9a658c35134c531d965854bf7828818dd6f1be185138008576fc5a3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "verticalVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareMirror]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareMirror]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareMirror]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cae84b8289e78d26c5a182b0b7d131752defdbeda27dfdd87435935c1d27d001)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareMonoHue",
    jsii_struct_bases=[],
    name_mapping={"hue": "hue", "hue_var": "hueVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareMonoHue:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__45ba9a6801819c004a61a5833770ea92c05dc00df7ceaed95e6eba8fab94857f)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareMonoHue(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareMonoHueList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareMonoHueList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__840d54fc3effa5b20df1d2376eaa2fdbff74ca638cdb472e6a127cf1d1d211cf)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareMonoHueOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b0b130425cd329e4b53688495ebfbc9fd8f36c61fd10a15a26d70f87275b641e)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareMonoHueOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4440f7c0f07c2c196d334aa66ce2b13fd2f70ac03b797bff065ef0870f4c929f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ef4b53ada8edc6bd9b12e015892fd95ea91b7214354ff8f34c5486c67f5bf47d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2470e84e2a6e937f1562207db1635671166ce68e72da7c525dbddf9d378dc5b6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareMonoHue]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareMonoHue]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b6b083c42065e8fc747595621fbd00c181dcd500d1977538653aa7238dcffd32)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareMonoHueOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareMonoHueOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__627887839233b6410b1613ad0ec1474a7ab5d82e66bf1f30baa2027fc8eae9c6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__73217e79114de6dca64bacb2d5a7f87e148b942e8ebf96040bd8cebc53ed4fd5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__adcd7c0f3a88fd50d648c3bc6b285034e42f8e9a08434eda6119aaf39b952f35)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareMonoHue]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareMonoHue]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareMonoHue]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aecec711672ea2548bca0d37b4aaabd9dc1e28a91b7e1bdea28eca922b0f5c89)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareOpacity",
    jsii_struct_bases=[],
    name_mapping={"opacity": "opacity", "opacity_var": "opacityVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareOpacity:
    def __init__(
        self,
        *,
        opacity: typing.Optional[builtins.str] = None,
        opacity_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param opacity: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param opacity_var: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f8bb86fcd18d84b1cac1359c153905f6645f007f7262aac9a11117d92d31db74)
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument opacity_var", value=opacity_var, expected_type=type_hints["opacity_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if opacity is not None:
            self._values["opacity"] = opacity
        if opacity_var is not None:
            self._values["opacity_var"] = opacity_var

    @builtins.property
    def opacity(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def opacity_var(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        result = self._values.get("opacity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareOpacity(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareOpacityList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareOpacityList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__81244f2f5973e06c558d2c64f2e814493320dff911a7a0d497d1e4c47b6243a2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareOpacityOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__895c88402b0d7ee8359229a0b9bc8568ca100bbf50e0d36d45c924d5289963bb)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareOpacityOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aacf2ff10b31331d9522d7b278fc83ad915b08e765ce92c7182a99b06d9841b1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ccbc2e9ef35dffaab54cfd5894f461e67edcb4d604a1cac13bb39aa7df2cf99)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ff025192d5f8ffe8f6127ad4a41fce7eabb733ec45d3b176550aa02dd1d2a961)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareOpacity]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareOpacity]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b749ad537713fc574bcc64a4339969e60d6856d2c39866ff4ccf0a2308926817)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareOpacityOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareOpacityOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6a7339f6ff49d9ff686efdabc070513c5a48b94ef0d4cedbba90020c386167ee)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetOpacityVar")
    def reset_opacity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacityVar", []))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityVarInput")
    def opacity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacity"))

    @opacity.setter
    def opacity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4c0c230350532e8c2dc037d1ad139c48ce46d0158ebb926589648d24385a9d63)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacity", value)

    @builtins.property
    @jsii.member(jsii_name="opacityVar")
    def opacity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacityVar"))

    @opacity_var.setter
    def opacity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d355760d77e1445b0e122f71621919b54159111f8b845d47db530c2dcc837c6a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacityVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareOpacity]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareOpacity]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareOpacity]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8e2d151cde368e371b2b7a96c80928678ea29a9d15379bdd58ce668da6280bdd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6d8ae5384d220570ae0d9bdf1612540a33792b194f33b5579ed0232ff85a9c60)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putAppend")
    def put_append(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareAppend, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df55e4cec038ccb5455c66e1d2ec37a8e290273c4e230d8d4a4524830d4a2c2d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putAppend", [value]))

    @jsii.member(jsii_name="putAspectCrop")
    def put_aspect_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareAspectCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8e123e09088422923f67e79c2c6bdeaf2995d89e8270dc45ec82e59a5df635a6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putAspectCrop", [value]))

    @jsii.member(jsii_name="putBackgroundColor")
    def put_background_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d634d7d27f495404e4e4ad057c3495590bf9c600e728cef1ae4f63d7a314bfbe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBackgroundColor", [value]))

    @jsii.member(jsii_name="putBlur")
    def put_blur(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareBlur, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6ebdd9fb2e008b129499111f54678891134376dc1d93178908783cc9ad3f3079)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBlur", [value]))

    @jsii.member(jsii_name="putChromaKey")
    def put_chroma_key(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareChromaKey, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5065f718c2b3ddf9a5defe942369282721cc0782231d695a0dcda488605bc03a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putChromaKey", [value]))

    @jsii.member(jsii_name="putComposite")
    def put_composite(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareComposite, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f81df579ab931e879bfb6d0f33fb467a5dfa0de6f11bb45045c84f1dab2597fe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putComposite", [value]))

    @jsii.member(jsii_name="putCompound")
    def put_compound(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareCompound, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9f56f22c98cb1d8c291f009eb44e1f78d43241f3d290878e37ba8bdb32b5dc70)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCompound", [value]))

    @jsii.member(jsii_name="putContrast")
    def put_contrast(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareContrast, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a52b515f7ff99474584d9d27d46714b2073c17ac4c8086e672b180b972cc755)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putContrast", [value]))

    @jsii.member(jsii_name="putCrop")
    def put_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3caef763ea55b16c81f1693599c63e9ea44fe706341e5de0a4f03d7a6293b46f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCrop", [value]))

    @jsii.member(jsii_name="putFaceCrop")
    def put_face_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareFaceCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e0fae8a0879e15aac0b7f09b623170066076078e0c604f455553abfb7ea4bf56)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFaceCrop", [value]))

    @jsii.member(jsii_name="putFeatureCrop")
    def put_feature_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareFeatureCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f9b23b92219d6c12f2727e58e062bc35670169af022aff5a6acce309acd9a2d6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFeatureCrop", [value]))

    @jsii.member(jsii_name="putFitAndFill")
    def put_fit_and_fill(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareFitAndFill, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f738a0c0f4bd45afbc6e21ce6f997e369a6dae07ac829e2165927e1d8be2594)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFitAndFill", [value]))

    @jsii.member(jsii_name="putGoop")
    def put_goop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareGoop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a6b0416df71061ddb07cb7d18d21442ffac5cbf90a5841b18218c9f7efee98ef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGoop", [value]))

    @jsii.member(jsii_name="putGrayscale")
    def put_grayscale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareGrayscale, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0f240cbb2c90e68c1444484875511b2db238d28d6d989bc4154dd6fd2fb110db)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGrayscale", [value]))

    @jsii.member(jsii_name="putHsl")
    def put_hsl(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareHsl, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5bfe61ab9526f97dea88dee87e343367bda370d212f4066037dfa4fc739f0e97)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsl", [value]))

    @jsii.member(jsii_name="putHsv")
    def put_hsv(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareHsv, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__28ba55b2dfac684cef27d8b5bc020f25451d0daa43c283e75e3c5953ce8a4afe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsv", [value]))

    @jsii.member(jsii_name="putIfDimension")
    def put_if_dimension(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfDimension, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f0196f72c3afdd29020c9f098a398af4e0c471020897dd54e72e21f730d8a903)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfDimension", [value]))

    @jsii.member(jsii_name="putIfOrientation")
    def put_if_orientation(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__004f561aa39ef5bc954557505b9f2713a3db01436292da5a62ec77a17453d677)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfOrientation", [value]))

    @jsii.member(jsii_name="putImQuery")
    def put_im_query(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareImQuery, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bd381f3b5628fb88ade6b488446673610faae86d044d3ffcdf5779def337588c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putImQuery", [value]))

    @jsii.member(jsii_name="putMaxColors")
    def put_max_colors(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareMaxColors, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__47e3e26756cdea416b771523687ee6e05be7098068bc71b37a554716e0844eec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMaxColors", [value]))

    @jsii.member(jsii_name="putMirror")
    def put_mirror(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareMirror, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d8e8021704a7bb199ddb1a298e78662e3fe6857db44522e69c75f11e0d3f44e1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMirror", [value]))

    @jsii.member(jsii_name="putMonoHue")
    def put_mono_hue(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareMonoHue, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__032f75d94fec8cce6ff7655eae9697bf1851fc895d534d9aabbefb265117a243)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMonoHue", [value]))

    @jsii.member(jsii_name="putOpacity")
    def put_opacity(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareOpacity, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__353adba1732e7227988dbcfeb81ee09904a37cb0b6c605bde2758085143974c0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putOpacity", [value]))

    @jsii.member(jsii_name="putRegionOfInterestCrop")
    def put_region_of_interest_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareRegionOfInterestCrop", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ca67bbc49986ad65911a3401d673009a0408e597921c8b6c9ed0bf242cb2e8a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRegionOfInterestCrop", [value]))

    @jsii.member(jsii_name="putRelativeCrop")
    def put_relative_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareRelativeCrop", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5a101661e57692c1cd46903fb42727385c82ab1451f983c284dc65941c774963)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRelativeCrop", [value]))

    @jsii.member(jsii_name="putRemoveColor")
    def put_remove_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareRemoveColor", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__adcfd7cd86b942b32baa20a30c0db9c8eff6bbe08e9bf4e39d842feb61f29042)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRemoveColor", [value]))

    @jsii.member(jsii_name="putResize")
    def put_resize(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareResize", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a537195f8465ee050836eea548bfa8b5990c2e93b4a6eed9fdd407556ab714cd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putResize", [value]))

    @jsii.member(jsii_name="putRotate")
    def put_rotate(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareRotate", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f79962caf2e0caae826fa479bbff03afa0aa40835124c7af56dae12c05a061a9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRotate", [value]))

    @jsii.member(jsii_name="putScale")
    def put_scale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareScale", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__188677800de4ca18a650efb352e67c36fc3a95f826ca88cd9bda42ab5e41e678)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putScale", [value]))

    @jsii.member(jsii_name="putShear")
    def put_shear(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareShear", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__328765511c74902c7592b599de36d4fe829589e7af40e7195d8abfdec4137dfc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putShear", [value]))

    @jsii.member(jsii_name="putTrim")
    def put_trim(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareTrim", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__718207e230607cb4d9b5ab5dce1eaf98660ed8d287e983cc7fe24ecaf3b018ab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTrim", [value]))

    @jsii.member(jsii_name="putUnsharpMask")
    def put_unsharp_mask(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareUnsharpMask", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__212ef68474b74e7d759b53b9e981fde333911991f1dcb15ec68dc6c62c1d01ae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putUnsharpMask", [value]))

    @jsii.member(jsii_name="resetAppend")
    def reset_append(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAppend", []))

    @jsii.member(jsii_name="resetAspectCrop")
    def reset_aspect_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspectCrop", []))

    @jsii.member(jsii_name="resetBackgroundColor")
    def reset_background_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBackgroundColor", []))

    @jsii.member(jsii_name="resetBlur")
    def reset_blur(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBlur", []))

    @jsii.member(jsii_name="resetChromaKey")
    def reset_chroma_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChromaKey", []))

    @jsii.member(jsii_name="resetComposite")
    def reset_composite(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetComposite", []))

    @jsii.member(jsii_name="resetCompound")
    def reset_compound(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCompound", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetCrop")
    def reset_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCrop", []))

    @jsii.member(jsii_name="resetFaceCrop")
    def reset_face_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFaceCrop", []))

    @jsii.member(jsii_name="resetFeatureCrop")
    def reset_feature_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureCrop", []))

    @jsii.member(jsii_name="resetFitAndFill")
    def reset_fit_and_fill(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFitAndFill", []))

    @jsii.member(jsii_name="resetGoop")
    def reset_goop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGoop", []))

    @jsii.member(jsii_name="resetGrayscale")
    def reset_grayscale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGrayscale", []))

    @jsii.member(jsii_name="resetHsl")
    def reset_hsl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsl", []))

    @jsii.member(jsii_name="resetHsv")
    def reset_hsv(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsv", []))

    @jsii.member(jsii_name="resetIfDimension")
    def reset_if_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfDimension", []))

    @jsii.member(jsii_name="resetIfOrientation")
    def reset_if_orientation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfOrientation", []))

    @jsii.member(jsii_name="resetImQuery")
    def reset_im_query(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetImQuery", []))

    @jsii.member(jsii_name="resetMaxColors")
    def reset_max_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxColors", []))

    @jsii.member(jsii_name="resetMirror")
    def reset_mirror(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMirror", []))

    @jsii.member(jsii_name="resetMonoHue")
    def reset_mono_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonoHue", []))

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetRegionOfInterestCrop")
    def reset_region_of_interest_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRegionOfInterestCrop", []))

    @jsii.member(jsii_name="resetRelativeCrop")
    def reset_relative_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRelativeCrop", []))

    @jsii.member(jsii_name="resetRemoveColor")
    def reset_remove_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRemoveColor", []))

    @jsii.member(jsii_name="resetResize")
    def reset_resize(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetResize", []))

    @jsii.member(jsii_name="resetRotate")
    def reset_rotate(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRotate", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetShear")
    def reset_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetShear", []))

    @jsii.member(jsii_name="resetTrim")
    def reset_trim(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTrim", []))

    @jsii.member(jsii_name="resetUnsharpMask")
    def reset_unsharp_mask(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUnsharpMask", []))

    @builtins.property
    @jsii.member(jsii_name="append")
    def append(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareAppendList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareAppendList, jsii.get(self, "append"))

    @builtins.property
    @jsii.member(jsii_name="aspectCrop")
    def aspect_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareAspectCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareAspectCropList, jsii.get(self, "aspectCrop"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColor")
    def background_color(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareBackgroundColorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareBackgroundColorList, jsii.get(self, "backgroundColor"))

    @builtins.property
    @jsii.member(jsii_name="blur")
    def blur(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareBlurList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareBlurList, jsii.get(self, "blur"))

    @builtins.property
    @jsii.member(jsii_name="chromaKey")
    def chroma_key(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareChromaKeyList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareChromaKeyList, jsii.get(self, "chromaKey"))

    @builtins.property
    @jsii.member(jsii_name="composite")
    def composite(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareCompositeList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareCompositeList, jsii.get(self, "composite"))

    @builtins.property
    @jsii.member(jsii_name="compound")
    def compound(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareCompoundList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareCompoundList, jsii.get(self, "compound"))

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareContrastList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareContrastList, jsii.get(self, "contrast"))

    @builtins.property
    @jsii.member(jsii_name="crop")
    def crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareCropList, jsii.get(self, "crop"))

    @builtins.property
    @jsii.member(jsii_name="faceCrop")
    def face_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareFaceCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareFaceCropList, jsii.get(self, "faceCrop"))

    @builtins.property
    @jsii.member(jsii_name="featureCrop")
    def feature_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareFeatureCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareFeatureCropList, jsii.get(self, "featureCrop"))

    @builtins.property
    @jsii.member(jsii_name="fitAndFill")
    def fit_and_fill(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareFitAndFillList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareFitAndFillList, jsii.get(self, "fitAndFill"))

    @builtins.property
    @jsii.member(jsii_name="goop")
    def goop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareGoopList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareGoopList, jsii.get(self, "goop"))

    @builtins.property
    @jsii.member(jsii_name="grayscale")
    def grayscale(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareGrayscaleList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareGrayscaleList, jsii.get(self, "grayscale"))

    @builtins.property
    @jsii.member(jsii_name="hsl")
    def hsl(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareHslList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareHslList, jsii.get(self, "hsl"))

    @builtins.property
    @jsii.member(jsii_name="hsv")
    def hsv(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareHsvList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareHsvList, jsii.get(self, "hsv"))

    @builtins.property
    @jsii.member(jsii_name="ifDimension")
    def if_dimension(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfDimensionList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfDimensionList, jsii.get(self, "ifDimension"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientation")
    def if_orientation(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfOrientationList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfOrientationList, jsii.get(self, "ifOrientation"))

    @builtins.property
    @jsii.member(jsii_name="imQuery")
    def im_query(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareImQueryList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareImQueryList, jsii.get(self, "imQuery"))

    @builtins.property
    @jsii.member(jsii_name="maxColors")
    def max_colors(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareMaxColorsList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareMaxColorsList, jsii.get(self, "maxColors"))

    @builtins.property
    @jsii.member(jsii_name="mirror")
    def mirror(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareMirrorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareMirrorList, jsii.get(self, "mirror"))

    @builtins.property
    @jsii.member(jsii_name="monoHue")
    def mono_hue(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareMonoHueList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareMonoHueList, jsii.get(self, "monoHue"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareOpacityList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareOpacityList, jsii.get(self, "opacity"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestCrop")
    def region_of_interest_crop(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareRegionOfInterestCropList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareRegionOfInterestCropList", jsii.get(self, "regionOfInterestCrop"))

    @builtins.property
    @jsii.member(jsii_name="relativeCrop")
    def relative_crop(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareRelativeCropList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareRelativeCropList", jsii.get(self, "relativeCrop"))

    @builtins.property
    @jsii.member(jsii_name="removeColor")
    def remove_color(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareRemoveColorList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareRemoveColorList", jsii.get(self, "removeColor"))

    @builtins.property
    @jsii.member(jsii_name="resize")
    def resize(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareResizeList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareResizeList", jsii.get(self, "resize"))

    @builtins.property
    @jsii.member(jsii_name="rotate")
    def rotate(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareRotateList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareRotateList", jsii.get(self, "rotate"))

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareScaleList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareScaleList", jsii.get(self, "scale"))

    @builtins.property
    @jsii.member(jsii_name="shear")
    def shear(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareShearList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareShearList", jsii.get(self, "shear"))

    @builtins.property
    @jsii.member(jsii_name="trim")
    def trim(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareTrimList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareTrimList", jsii.get(self, "trim"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMask")
    def unsharp_mask(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareUnsharpMaskList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareUnsharpMaskList", jsii.get(self, "unsharpMask"))

    @builtins.property
    @jsii.member(jsii_name="appendInput")
    def append_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareAppend]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareAppend]]], jsii.get(self, "appendInput"))

    @builtins.property
    @jsii.member(jsii_name="aspectCropInput")
    def aspect_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareAspectCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareAspectCrop]]], jsii.get(self, "aspectCropInput"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColorInput")
    def background_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareBackgroundColor]]], jsii.get(self, "backgroundColorInput"))

    @builtins.property
    @jsii.member(jsii_name="blurInput")
    def blur_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareBlur]]], jsii.get(self, "blurInput"))

    @builtins.property
    @jsii.member(jsii_name="chromaKeyInput")
    def chroma_key_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareChromaKey]]], jsii.get(self, "chromaKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="compositeInput")
    def composite_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareComposite]]], jsii.get(self, "compositeInput"))

    @builtins.property
    @jsii.member(jsii_name="compoundInput")
    def compound_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareCompound]]], jsii.get(self, "compoundInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareContrast]]], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="cropInput")
    def crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareCrop]]], jsii.get(self, "cropInput"))

    @builtins.property
    @jsii.member(jsii_name="faceCropInput")
    def face_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareFaceCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareFaceCrop]]], jsii.get(self, "faceCropInput"))

    @builtins.property
    @jsii.member(jsii_name="featureCropInput")
    def feature_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareFeatureCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareFeatureCrop]]], jsii.get(self, "featureCropInput"))

    @builtins.property
    @jsii.member(jsii_name="fitAndFillInput")
    def fit_and_fill_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareFitAndFill]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareFitAndFill]]], jsii.get(self, "fitAndFillInput"))

    @builtins.property
    @jsii.member(jsii_name="goopInput")
    def goop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareGoop]]], jsii.get(self, "goopInput"))

    @builtins.property
    @jsii.member(jsii_name="grayscaleInput")
    def grayscale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareGrayscale]]], jsii.get(self, "grayscaleInput"))

    @builtins.property
    @jsii.member(jsii_name="hslInput")
    def hsl_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareHsl]]], jsii.get(self, "hslInput"))

    @builtins.property
    @jsii.member(jsii_name="hsvInput")
    def hsv_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareHsv]]], jsii.get(self, "hsvInput"))

    @builtins.property
    @jsii.member(jsii_name="ifDimensionInput")
    def if_dimension_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfDimension]]], jsii.get(self, "ifDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientationInput")
    def if_orientation_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfOrientation]]], jsii.get(self, "ifOrientationInput"))

    @builtins.property
    @jsii.member(jsii_name="imQueryInput")
    def im_query_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareImQuery]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareImQuery]]], jsii.get(self, "imQueryInput"))

    @builtins.property
    @jsii.member(jsii_name="maxColorsInput")
    def max_colors_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareMaxColors]]], jsii.get(self, "maxColorsInput"))

    @builtins.property
    @jsii.member(jsii_name="mirrorInput")
    def mirror_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareMirror]]], jsii.get(self, "mirrorInput"))

    @builtins.property
    @jsii.member(jsii_name="monoHueInput")
    def mono_hue_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareMonoHue]]], jsii.get(self, "monoHueInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareOpacity]]], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestCropInput")
    def region_of_interest_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareRegionOfInterestCrop"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareRegionOfInterestCrop"]]], jsii.get(self, "regionOfInterestCropInput"))

    @builtins.property
    @jsii.member(jsii_name="relativeCropInput")
    def relative_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareRelativeCrop"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareRelativeCrop"]]], jsii.get(self, "relativeCropInput"))

    @builtins.property
    @jsii.member(jsii_name="removeColorInput")
    def remove_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareRemoveColor"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareRemoveColor"]]], jsii.get(self, "removeColorInput"))

    @builtins.property
    @jsii.member(jsii_name="resizeInput")
    def resize_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareResize"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareResize"]]], jsii.get(self, "resizeInput"))

    @builtins.property
    @jsii.member(jsii_name="rotateInput")
    def rotate_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareRotate"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareRotate"]]], jsii.get(self, "rotateInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareScale"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareScale"]]], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="shearInput")
    def shear_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareShear"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareShear"]]], jsii.get(self, "shearInput"))

    @builtins.property
    @jsii.member(jsii_name="trimInput")
    def trim_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareTrim"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareTrim"]]], jsii.get(self, "trimInput"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMaskInput")
    def unsharp_mask_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareUnsharpMask"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareUnsharpMask"]]], jsii.get(self, "unsharpMaskInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquare]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquare], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquare],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b5eb6113d753e522573e415e45802dc6b9536e013ea6d35ef21896d5ff1a8251)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareRegionOfInterestCrop",
    jsii_struct_bases=[],
    name_mapping={
        "region_of_interest": "regionOfInterest",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareRegionOfInterestCrop:
    def __init__(
        self,
        *,
        region_of_interest: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareRegionOfInterestCropRegionOfInterest", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param region_of_interest: region_of_interest block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest DataAkamaiImagingPolicyImage#region_of_interest}
        :param gravity: The placement of the crop area relative to the specified area of interest. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: The placement of the crop area relative to the specified area of interest. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param style: Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(region_of_interest, dict):
            region_of_interest = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareRegionOfInterestCropRegionOfInterest(**region_of_interest)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9361d6cb10506e146587199dabff1b8cc2e6865d383e6b87c837bf0a1479ebd8)
            check_type(argname="argument region_of_interest", value=region_of_interest, expected_type=type_hints["region_of_interest"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "region_of_interest": region_of_interest,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def region_of_interest(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareRegionOfInterestCropRegionOfInterest":
        '''region_of_interest block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest DataAkamaiImagingPolicyImage#region_of_interest}
        '''
        result = self._values.get("region_of_interest")
        assert result is not None, "Required property 'region_of_interest' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareRegionOfInterestCropRegionOfInterest", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''The placement of the crop area relative to the specified area of interest.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''The placement of the crop area relative to the specified area of interest.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareRegionOfInterestCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareRegionOfInterestCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareRegionOfInterestCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__91d0b155e2d03776b03a678ccf63c4fabc470e32b92948332dc400a6ae4b8132)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareRegionOfInterestCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__61671386014fa425b55e02ea2459eca1575c4d9ec615a0d2bb9aaf8235c72d9b)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareRegionOfInterestCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f748a6468edb4e694e499c7ec072bfe2e8d1fbb88cac5142fee18498c983e013)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0020a055517f68f67493da11f6e6f325f2afd132fab50ea88b590d6bcb6bf0f6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__164764e3478e582a8c4f4bd8b8acd6f6f988f733df3431fcdaaf64987b2225be)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareRegionOfInterestCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareRegionOfInterestCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareRegionOfInterestCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__38df92e4ce2152354cae6c78141ebf7ae4b913e4deaa4e7fb85257ab29b0cbda)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareRegionOfInterestCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareRegionOfInterestCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fadfc929c3208243b47c681c97c67375295ac1c34411e34270e48614f5adde6e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putRegionOfInterest")
    def put_region_of_interest(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareRegionOfInterestCropRegionOfInterest()

        return typing.cast(None, jsii.invoke(self, "putRegionOfInterest", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterest")
    def region_of_interest(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareRegionOfInterestCropRegionOfInterestOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareRegionOfInterestCropRegionOfInterestOutputReference", jsii.get(self, "regionOfInterest"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestInput")
    def region_of_interest_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareRegionOfInterestCropRegionOfInterest"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareRegionOfInterestCropRegionOfInterest"], jsii.get(self, "regionOfInterestInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2833ed19de334cee0250907988b1a3420a32361f014d5b3e6f6b93fa126d3ab9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5fdc3abd5e04f9bcdfd2ba2a81f0d65a929708bcfa8db43695ed6f23572d9982)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__01e07d7797017f42542b5d52c3a51fce5917ad0d024492224d9ff5726aa5be28)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5da7e07ae2f5fa4bc17da80b5947310abb91186e61cfade8af5a1c27b2db9c06)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a5667cfb4b8986344712e2e230af886e95ddd6c145add77425a7350693b8888)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__69fbeb562cbb1209c39ce412ccfda73be0c29f72fec7d00352c4e9da9e063f18)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__77d5192c456cc31b4a57d9e0151a5efa71615d9ecf6f5fadb986c577af4e4fdc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a071e780735f2f30db4143b60701d04816fdce4cb0641ee924781e984a9f10d3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareRegionOfInterestCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareRegionOfInterestCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareRegionOfInterestCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c6d11f05ea815e0ad76be393a1ba9df2889a9ffbfa0a3086e2e346b5beb69833)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareRegionOfInterestCropRegionOfInterest",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareRegionOfInterestCropRegionOfInterest:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareRegionOfInterestCropRegionOfInterest(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareRegionOfInterestCropRegionOfInterestOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareRegionOfInterestCropRegionOfInterestOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c817dc62d8bf9663e527759f20e9cf10737888e8d5861dbaf43353a2865e549b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareRegionOfInterestCropRegionOfInterest]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareRegionOfInterestCropRegionOfInterest], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareRegionOfInterestCropRegionOfInterest],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa6dc1421c14a640a1c4a3fb2d9b197703ba3077e4e403e94cbb67ba8364a87b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareRelativeCrop",
    jsii_struct_bases=[],
    name_mapping={
        "east": "east",
        "east_var": "eastVar",
        "north": "north",
        "north_var": "northVar",
        "south": "south",
        "south_var": "southVar",
        "west": "west",
        "west_var": "westVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareRelativeCrop:
    def __init__(
        self,
        *,
        east: typing.Optional[builtins.str] = None,
        east_var: typing.Optional[builtins.str] = None,
        north: typing.Optional[builtins.str] = None,
        north_var: typing.Optional[builtins.str] = None,
        south: typing.Optional[builtins.str] = None,
        south_var: typing.Optional[builtins.str] = None,
        west: typing.Optional[builtins.str] = None,
        west_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param east: The number of pixels to shrink or expand the right side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east DataAkamaiImagingPolicyImage#east}
        :param east_var: The number of pixels to shrink or expand the right side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east_var DataAkamaiImagingPolicyImage#east_var}
        :param north: The number of pixels to shrink or expand the top side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north DataAkamaiImagingPolicyImage#north}
        :param north_var: The number of pixels to shrink or expand the top side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north_var DataAkamaiImagingPolicyImage#north_var}
        :param south: The number of pixels to shrink or expand the bottom side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south DataAkamaiImagingPolicyImage#south}
        :param south_var: The number of pixels to shrink or expand the bottom side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south_var DataAkamaiImagingPolicyImage#south_var}
        :param west: The number of pixels to shrink or expand the left side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west DataAkamaiImagingPolicyImage#west}
        :param west_var: The number of pixels to shrink or expand the left side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west_var DataAkamaiImagingPolicyImage#west_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4e9e9ccc1efe59942c713ba8d365b7408004e107ad603a917cd23edd02e455c0)
            check_type(argname="argument east", value=east, expected_type=type_hints["east"])
            check_type(argname="argument east_var", value=east_var, expected_type=type_hints["east_var"])
            check_type(argname="argument north", value=north, expected_type=type_hints["north"])
            check_type(argname="argument north_var", value=north_var, expected_type=type_hints["north_var"])
            check_type(argname="argument south", value=south, expected_type=type_hints["south"])
            check_type(argname="argument south_var", value=south_var, expected_type=type_hints["south_var"])
            check_type(argname="argument west", value=west, expected_type=type_hints["west"])
            check_type(argname="argument west_var", value=west_var, expected_type=type_hints["west_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if east is not None:
            self._values["east"] = east
        if east_var is not None:
            self._values["east_var"] = east_var
        if north is not None:
            self._values["north"] = north
        if north_var is not None:
            self._values["north_var"] = north_var
        if south is not None:
            self._values["south"] = south
        if south_var is not None:
            self._values["south_var"] = south_var
        if west is not None:
            self._values["west"] = west
        if west_var is not None:
            self._values["west_var"] = west_var

    @builtins.property
    def east(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the right side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east DataAkamaiImagingPolicyImage#east}
        '''
        result = self._values.get("east")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def east_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the right side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east_var DataAkamaiImagingPolicyImage#east_var}
        '''
        result = self._values.get("east_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def north(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the top side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north DataAkamaiImagingPolicyImage#north}
        '''
        result = self._values.get("north")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def north_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the top side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north_var DataAkamaiImagingPolicyImage#north_var}
        '''
        result = self._values.get("north_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def south(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the bottom side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south DataAkamaiImagingPolicyImage#south}
        '''
        result = self._values.get("south")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def south_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the bottom side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south_var DataAkamaiImagingPolicyImage#south_var}
        '''
        result = self._values.get("south_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def west(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the left side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west DataAkamaiImagingPolicyImage#west}
        '''
        result = self._values.get("west")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def west_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the left side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west_var DataAkamaiImagingPolicyImage#west_var}
        '''
        result = self._values.get("west_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareRelativeCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareRelativeCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareRelativeCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6cdbc79fde63aa2af5dc6f32c449d41f1cf74dbbb97535f13ca91d3456eea9e7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareRelativeCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9cf5f5e29a44362ba459eb1adc1fed998b063cb51caf62a66d01175d71a302b3)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareRelativeCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5268980ea62177c1972b05e4844de20e349d88d44dea507c0cd678b4ffafdcfe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a4cb0c695715378170c9667eda6bb08c06951647ae24d4505c6fe6bae2e3fa4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__33973d072a0177e912e72ec41ef753d222b6257ddfe85bf49dd60dafa18824b5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareRelativeCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareRelativeCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareRelativeCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__68ee734687451315b2ea49d2db890a27ea47e28cc432631515c93f56ba2f5c2c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareRelativeCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareRelativeCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__612becf620b7a2bfefa5b3722a1b68bacff990e44e355322b80904cac231200a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetEast")
    def reset_east(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEast", []))

    @jsii.member(jsii_name="resetEastVar")
    def reset_east_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEastVar", []))

    @jsii.member(jsii_name="resetNorth")
    def reset_north(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNorth", []))

    @jsii.member(jsii_name="resetNorthVar")
    def reset_north_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNorthVar", []))

    @jsii.member(jsii_name="resetSouth")
    def reset_south(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSouth", []))

    @jsii.member(jsii_name="resetSouthVar")
    def reset_south_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSouthVar", []))

    @jsii.member(jsii_name="resetWest")
    def reset_west(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWest", []))

    @jsii.member(jsii_name="resetWestVar")
    def reset_west_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWestVar", []))

    @builtins.property
    @jsii.member(jsii_name="eastInput")
    def east_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "eastInput"))

    @builtins.property
    @jsii.member(jsii_name="eastVarInput")
    def east_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "eastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="northInput")
    def north_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "northInput"))

    @builtins.property
    @jsii.member(jsii_name="northVarInput")
    def north_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "northVarInput"))

    @builtins.property
    @jsii.member(jsii_name="southInput")
    def south_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "southInput"))

    @builtins.property
    @jsii.member(jsii_name="southVarInput")
    def south_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "southVarInput"))

    @builtins.property
    @jsii.member(jsii_name="westInput")
    def west_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "westInput"))

    @builtins.property
    @jsii.member(jsii_name="westVarInput")
    def west_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "westVarInput"))

    @builtins.property
    @jsii.member(jsii_name="east")
    def east(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "east"))

    @east.setter
    def east(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f4cd9db5e9e638198bf2f1f50dbade0b33fb919cc88e80a294cfa2d8ac4747c2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "east", value)

    @builtins.property
    @jsii.member(jsii_name="eastVar")
    def east_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "eastVar"))

    @east_var.setter
    def east_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__192a058cc52de230ca35c1fd7e8b3381245e45eff33c61c49b942d69bc8b8f4d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "eastVar", value)

    @builtins.property
    @jsii.member(jsii_name="north")
    def north(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "north"))

    @north.setter
    def north(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0469e71892eac00a0b034c9f3e4c98ba58ac04e5b990ab90a777f8185f91a002)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "north", value)

    @builtins.property
    @jsii.member(jsii_name="northVar")
    def north_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "northVar"))

    @north_var.setter
    def north_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d29c26cec0dccfa283f074eb46d27267dbe74ab1e541d4c21a8de056638714a6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "northVar", value)

    @builtins.property
    @jsii.member(jsii_name="south")
    def south(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "south"))

    @south.setter
    def south(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7a06e63474d7a68c261c446faafd25a5c4cd08bd1e83122df52f156fa1cdb649)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "south", value)

    @builtins.property
    @jsii.member(jsii_name="southVar")
    def south_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "southVar"))

    @south_var.setter
    def south_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3d700e86762fe108c086dec7ecff3f5cc571412186f5da3e990187c751e26ee9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "southVar", value)

    @builtins.property
    @jsii.member(jsii_name="west")
    def west(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "west"))

    @west.setter
    def west(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__17cea7158f9337ba86ea1e58027bbc72b0da0720df873b6fd7111374eaed439c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "west", value)

    @builtins.property
    @jsii.member(jsii_name="westVar")
    def west_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "westVar"))

    @west_var.setter
    def west_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a183c7984cc5f33efddaa0d58b432b914df9f3d35221245c710f150592a26f64)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "westVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareRelativeCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareRelativeCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareRelativeCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0301da8b709ff4a567b974b66fe750178e5c9bfaf0ef266a95fb3fa5a06516b2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareRemoveColor",
    jsii_struct_bases=[],
    name_mapping={
        "color": "color",
        "color_var": "colorVar",
        "feather": "feather",
        "feather_var": "featherVar",
        "tolerance": "tolerance",
        "tolerance_var": "toleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareRemoveColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
        feather: typing.Optional[builtins.str] = None,
        feather_var: typing.Optional[builtins.str] = None,
        tolerance: typing.Optional[builtins.str] = None,
        tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        :param feather: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        :param feather_var: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        :param tolerance: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        :param tolerance_var: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7c725b18984f9db83b1b0a1360884423af436fb840f09e6e5ed2f22f5dbdd587)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
            check_type(argname="argument feather", value=feather, expected_type=type_hints["feather"])
            check_type(argname="argument feather_var", value=feather_var, expected_type=type_hints["feather_var"])
            check_type(argname="argument tolerance", value=tolerance, expected_type=type_hints["tolerance"])
            check_type(argname="argument tolerance_var", value=tolerance_var, expected_type=type_hints["tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var
        if feather is not None:
            self._values["feather"] = feather
        if feather_var is not None:
            self._values["feather_var"] = feather_var
        if tolerance is not None:
            self._values["tolerance"] = tolerance
        if tolerance_var is not None:
            self._values["tolerance_var"] = tolerance_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        '''
        result = self._values.get("feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather_var(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        '''
        result = self._values.get("feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        '''
        result = self._values.get("tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance_var(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        result = self._values.get("tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareRemoveColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareRemoveColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareRemoveColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be5f727e135886add37cf9ff4e9f5fa605ec20381030f08656e9271699bb50c2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareRemoveColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a17d937b90330735d870435bdb61152d60e067e577660a2d2191a93dd5e2068)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareRemoveColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c309bd39daf13cc9f7f5ed9d2228bd7d559e71065bdc7f4d46fa428858c434e2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__582124dde6a204368e567a74fe6161462337ac3373aa0e1c91152bb169528098)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__25dad1cc47a7219c4520bc5780ca51ebb3c0183d4c6051de22f2725eb7309631)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareRemoveColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareRemoveColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareRemoveColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ebb212634dfb54b4c5ad3de27026555085381b441bcf42ad32311a08696bf55)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareRemoveColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareRemoveColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8739f62bf78e0725c161a6a1ca5e0d216d1fb0f9dfa735c488f8b9767092cfa3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @jsii.member(jsii_name="resetFeather")
    def reset_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeather", []))

    @jsii.member(jsii_name="resetFeatherVar")
    def reset_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatherVar", []))

    @jsii.member(jsii_name="resetTolerance")
    def reset_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTolerance", []))

    @jsii.member(jsii_name="resetToleranceVar")
    def reset_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featherInput")
    def feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherInput"))

    @builtins.property
    @jsii.member(jsii_name="featherVarInput")
    def feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceInput")
    def tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceVarInput")
    def tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a6e3cc822ef7444476922f20c597420d4aa1c07563be023a1bba2e942bab7667)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a6cd468659308164e281e2d618207b766940b9cba63de7df9a187399b314e4a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="feather")
    def feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "feather"))

    @feather.setter
    def feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__63f7c62221fef60c83bb79d7f6de75a6d7946479760c7c7db1255e5ee8243564)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "feather", value)

    @builtins.property
    @jsii.member(jsii_name="featherVar")
    def feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featherVar"))

    @feather_var.setter
    def feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__48ec613c0859ca2f538fea871f86fbd84ad5339e0de61b8128a283a0668c4004)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featherVar", value)

    @builtins.property
    @jsii.member(jsii_name="tolerance")
    def tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tolerance"))

    @tolerance.setter
    def tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5629eebf4dc0d70290faccaf456524db2ce9ee74fc1be8fd3ca863898b40468a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tolerance", value)

    @builtins.property
    @jsii.member(jsii_name="toleranceVar")
    def tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "toleranceVar"))

    @tolerance_var.setter
    def tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7eba0d04ddff7f1385e57ab006927e348e8df5ab6bd977ca7b1cf2f48abc426c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "toleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareRemoveColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareRemoveColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareRemoveColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__75d776d20f00b3000793fc4105dcf7088ee00a6dc7b1bd3f7f92bcd8aac4f674)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareResize",
    jsii_struct_bases=[],
    name_mapping={
        "aspect": "aspect",
        "aspect_var": "aspectVar",
        "height": "height",
        "height_var": "heightVar",
        "type": "type",
        "type_var": "typeVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareResize:
    def __init__(
        self,
        *,
        aspect: typing.Optional[builtins.str] = None,
        aspect_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param aspect: Preserves the aspect ratio. Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect DataAkamaiImagingPolicyImage#aspect}
        :param aspect_var: Preserves the aspect ratio. Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_var DataAkamaiImagingPolicyImage#aspect_var}
        :param height: The height to resize the source image to. Must be set if height is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height to resize the source image to. Must be set if height is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param type: Sets constraints for the image resize. Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: Sets constraints for the image resize. Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        :param width: The width to resize the source image to. Must be set if width is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width to resize the source image to. Must be set if width is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b6b877942d60d6e5bca3ac036380488f59acfa18506719db46ab9de99980e4f2)
            check_type(argname="argument aspect", value=aspect, expected_type=type_hints["aspect"])
            check_type(argname="argument aspect_var", value=aspect_var, expected_type=type_hints["aspect_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if aspect is not None:
            self._values["aspect"] = aspect
        if aspect_var is not None:
            self._values["aspect_var"] = aspect_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def aspect(self) -> typing.Optional[builtins.str]:
        '''Preserves the aspect ratio.

        Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect DataAkamaiImagingPolicyImage#aspect}
        '''
        result = self._values.get("aspect")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def aspect_var(self) -> typing.Optional[builtins.str]:
        '''Preserves the aspect ratio.

        Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_var DataAkamaiImagingPolicyImage#aspect_var}
        '''
        result = self._values.get("aspect_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height to resize the source image to. Must be set if height is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height to resize the source image to. Must be set if height is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''Sets constraints for the image resize.

        Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''Sets constraints for the image resize.

        Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width to resize the source image to. Must be set if width is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width to resize the source image to. Must be set if width is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareResize(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareResizeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareResizeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__98644f222d63ce1545ef28a9c6b77cafc31bbc546549c0c277930f1693506934)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareResizeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c7d4107056250db1c10e1b53c979819b3b6df08f278a7d23dc0a7e0f1364b082)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareResizeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bdb887a068a92fe87a67b7baffc1cd6bc9ab59c0bd0fc263dbb5a45bf7dfc2b0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab810a6840963cc727ae000bb55117ab238705b6cc366fe5d79195fac0b98517)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__64c951585c1a556adb2ed13d07457dafe1ac10b2344454a6635bf3a574bdc001)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareResize]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareResize]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareResize]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__57370e8b1edbc04993f7a79cd7501c39befc18eb68284b726b97a4a54ae64c76)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareResizeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareResizeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f3fb5427e9f5565a8e9038ea734e5f54ed97948e33155d891628a90ea31b879)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAspect")
    def reset_aspect(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspect", []))

    @jsii.member(jsii_name="resetAspectVar")
    def reset_aspect_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspectVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="aspectInput")
    def aspect_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "aspectInput"))

    @builtins.property
    @jsii.member(jsii_name="aspectVarInput")
    def aspect_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "aspectVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="aspect")
    def aspect(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "aspect"))

    @aspect.setter
    def aspect(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ba274bd110ed79a112630f9388f6cf085ef992e3b05c5f4a10d443021ce99b3a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "aspect", value)

    @builtins.property
    @jsii.member(jsii_name="aspectVar")
    def aspect_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "aspectVar"))

    @aspect_var.setter
    def aspect_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd1f38abbed9d49ecdb02f4ad6eb52b8ed47038d69aa2913be276c5e886db188)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "aspectVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__09cb6307109472f43f38dbcaa76c8f236c51a37cf94e7927cab656581c9285c5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6b2fd277edea5cd3b21a21190bfb41767185c7bb4f5e22723e8404e30f8ef9ea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c68f4a31b9e255e2e772761b52b0b79ccfe266b270355bfcb25c3b35cace8586)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e7db67acd832e625ce3e4ff6cf08ac4f8646bbd12d61d7ead974d747966a56f8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a38a9d01fb6cfc0f19e1c4ee0a9e61103b2714fac76250ce298db6b37c91f916)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a2bbf082f08401fa9977f44c51ac7592693181ce59d862c322373f7c1456b578)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareResize]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareResize]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareResize]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__adc3213c334fa00b7a0a06dcd183f0272f26f867a67079377a94f7c80c7fc40b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareRotate",
    jsii_struct_bases=[],
    name_mapping={"degrees": "degrees", "degrees_var": "degreesVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareRotate:
    def __init__(
        self,
        *,
        degrees: typing.Optional[builtins.str] = None,
        degrees_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param degrees: The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees DataAkamaiImagingPolicyImage#degrees}
        :param degrees_var: The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees_var DataAkamaiImagingPolicyImage#degrees_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc5384904a3479ff1b3f1e355978010f73e9c75e7e94ebc80325cc214c2899bc)
            check_type(argname="argument degrees", value=degrees, expected_type=type_hints["degrees"])
            check_type(argname="argument degrees_var", value=degrees_var, expected_type=type_hints["degrees_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if degrees is not None:
            self._values["degrees"] = degrees
        if degrees_var is not None:
            self._values["degrees_var"] = degrees_var

    @builtins.property
    def degrees(self) -> typing.Optional[builtins.str]:
        '''The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees DataAkamaiImagingPolicyImage#degrees}
        '''
        result = self._values.get("degrees")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def degrees_var(self) -> typing.Optional[builtins.str]:
        '''The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees_var DataAkamaiImagingPolicyImage#degrees_var}
        '''
        result = self._values.get("degrees_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareRotate(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareRotateList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareRotateList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3c57fdb69d3cbcf76ffddfcdcbf8ccd90f212abf3c61126f7ee507c287db46e9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareRotateOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4164dbbfafb2f3a79f36da889aac10f2f5c9500e6b97a05132dfa0ae454ab78b)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareRotateOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__40bd08e8dc08ad92d3f6929930fd54a422807a71b2ff512eb9d591bb112c57b8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bd4efa04058db0a64c1483ea1e1bef052a6eed83e8743c0595a847597f3289b9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__31d8a41fe24ff3a9f61b0f0db785cc7f6d6c11a03da2fbb599b127b321b4ec49)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareRotate]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareRotate]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareRotate]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__615b2e4ca70243646310f2f2d687f0d8d5372c4c4bc7931ac9541f51fffe1dbe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareRotateOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareRotateOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f44214c3571f9649ed89c2f0dab3acd1b3f3d6a09d7ce2e3e36f9ac154961e2d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetDegrees")
    def reset_degrees(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDegrees", []))

    @jsii.member(jsii_name="resetDegreesVar")
    def reset_degrees_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDegreesVar", []))

    @builtins.property
    @jsii.member(jsii_name="degreesInput")
    def degrees_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "degreesInput"))

    @builtins.property
    @jsii.member(jsii_name="degreesVarInput")
    def degrees_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "degreesVarInput"))

    @builtins.property
    @jsii.member(jsii_name="degrees")
    def degrees(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "degrees"))

    @degrees.setter
    def degrees(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2028278db8d98ee61840806ee0ac862d1fae9854dd1f5df90646ae1250988044)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "degrees", value)

    @builtins.property
    @jsii.member(jsii_name="degreesVar")
    def degrees_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "degreesVar"))

    @degrees_var.setter
    def degrees_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__704aed1680e573bf064d12052fcacdc4dc20a30b1c73affa11e4ea80d72f51d8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "degreesVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareRotate]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareRotate]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareRotate]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a00267b54065ddb7edbed45367dac3fa04f56409b6917aec3584f56eed6be0c5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareScale",
    jsii_struct_bases=[],
    name_mapping={
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareScale:
    def __init__(
        self,
        *,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param height: Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged. Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged. Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c47f16f806f3ccac1d576fb0192e7acef15fc28fb322dcae4546e0be6774a0df)
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size.

        Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size.

        Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged.

        Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged.

        Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareScale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareScaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareScaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__add3d3e7657092be96742af57c34b24781b082e4c3d5af6deaff3b57b3194dac)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareScaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fde576425addc8fa2569e1cfa911840032d2e3ecbfe6db0a6cfc7ba2d157f95b)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareScaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__531037838b8b0f7b3312695d15eb94d3c58f4df862e384f7bf779eec6e015353)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c4b501e1a6f7eb3a23ca7c7248354352632d7a86eb5277aaa6e0249e49e59440)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7aa31cdd4631cf8b75e843c46cc44cb7eab4f2e35d5580212b56694046927426)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareScale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareScale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareScale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f3b6010cf1e55efbdc987e2d668d89e9ea610ab891bf37e04ef352e3bd48c6a9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareScaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareScaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__70e1a71ae1137c02b5c7b6acec5f5cb39208d64541ddeadb2bc9d49c73153e89)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5c675c01a52f3b6150b4ccffa21962e5a93a65f5f8b51840176b8eaf7e641644)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ecf4ce37d7808284554cab96a5964e9c07585689700c1a071c56ddea8228e9c2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__942fa9bbcbf94c68018a8acc85cf3e9718946a7f3d1258757a97160490c01578)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__287ba72095a7d2ac890e23a0e61fd20bdd97193aec72d6262e64eab128123811)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareScale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareScale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareScale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ad7cb324ecb9b52da5942ed78550fcf22a02d809dc7e23eb08f31df10f028a44)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareShear",
    jsii_struct_bases=[],
    name_mapping={
        "x_shear": "xShear",
        "x_shear_var": "xShearVar",
        "y_shear": "yShear",
        "y_shear_var": "yShearVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareShear:
    def __init__(
        self,
        *,
        x_shear: typing.Optional[builtins.str] = None,
        x_shear_var: typing.Optional[builtins.str] = None,
        y_shear: typing.Optional[builtins.str] = None,
        y_shear_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param x_shear: The amount to shear along the x-axis, measured in multiples of the image's width. Must be set if yShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear DataAkamaiImagingPolicyImage#x_shear}
        :param x_shear_var: The amount to shear along the x-axis, measured in multiples of the image's width. Must be set if yShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear_var DataAkamaiImagingPolicyImage#x_shear_var}
        :param y_shear: The amount to shear along the y-axis, measured in multiples of the image's height. Must be set if xShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear DataAkamaiImagingPolicyImage#y_shear}
        :param y_shear_var: The amount to shear along the y-axis, measured in multiples of the image's height. Must be set if xShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear_var DataAkamaiImagingPolicyImage#y_shear_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__305d3a55b9be062a60cf37bba76ad348b54d79f78699ff2c767b31424c21d9d6)
            check_type(argname="argument x_shear", value=x_shear, expected_type=type_hints["x_shear"])
            check_type(argname="argument x_shear_var", value=x_shear_var, expected_type=type_hints["x_shear_var"])
            check_type(argname="argument y_shear", value=y_shear, expected_type=type_hints["y_shear"])
            check_type(argname="argument y_shear_var", value=y_shear_var, expected_type=type_hints["y_shear_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if x_shear is not None:
            self._values["x_shear"] = x_shear
        if x_shear_var is not None:
            self._values["x_shear_var"] = x_shear_var
        if y_shear is not None:
            self._values["y_shear"] = y_shear
        if y_shear_var is not None:
            self._values["y_shear_var"] = y_shear_var

    @builtins.property
    def x_shear(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the x-axis, measured in multiples of the image's width.

        Must be set if yShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear DataAkamaiImagingPolicyImage#x_shear}
        '''
        result = self._values.get("x_shear")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_shear_var(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the x-axis, measured in multiples of the image's width.

        Must be set if yShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear_var DataAkamaiImagingPolicyImage#x_shear_var}
        '''
        result = self._values.get("x_shear_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_shear(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the y-axis, measured in multiples of the image's height.

        Must be set if xShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear DataAkamaiImagingPolicyImage#y_shear}
        '''
        result = self._values.get("y_shear")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_shear_var(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the y-axis, measured in multiples of the image's height.

        Must be set if xShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear_var DataAkamaiImagingPolicyImage#y_shear_var}
        '''
        result = self._values.get("y_shear_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareShear(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareShearList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareShearList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__059013629351badcb095c20db7af15e8382e6d353c7fe1547c3790aade69ae21)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareShearOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0c9899870e329f2afa6a1d3fdaa5b4aa6e1f6e02e0c90feeac7a77cba4a8938c)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareShearOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d7d7a6833b015ea2bd90293f07df9b3363af0399f1b9eb2d9a09c1c3a0de8785)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b66b9d67a18a481f6f884be09d718626175963b012433ce24f9ad9c1425b042d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__81f46689f7ee552df6d377b84ff4805f3a5418fb7c46ef439e5f21cba5eeec68)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareShear]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareShear]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareShear]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__15f69400efa88e04b24b230955048471c6d7d68db5857361998814a96cabdf79)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareShearOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareShearOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__12666b6a747148a32aece5df8d932fe8898ad6ecf6a22b3250a5c01f40b687cb)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetXShear")
    def reset_x_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXShear", []))

    @jsii.member(jsii_name="resetXShearVar")
    def reset_x_shear_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXShearVar", []))

    @jsii.member(jsii_name="resetYShear")
    def reset_y_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYShear", []))

    @jsii.member(jsii_name="resetYShearVar")
    def reset_y_shear_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYShearVar", []))

    @builtins.property
    @jsii.member(jsii_name="xShearInput")
    def x_shear_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xShearInput"))

    @builtins.property
    @jsii.member(jsii_name="xShearVarInput")
    def x_shear_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xShearVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yShearInput")
    def y_shear_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yShearInput"))

    @builtins.property
    @jsii.member(jsii_name="yShearVarInput")
    def y_shear_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yShearVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xShear")
    def x_shear(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xShear"))

    @x_shear.setter
    def x_shear(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9850e837f1352db9c1617386b7fcf67d5ef3d6bc17a96f2159874e9340183f69)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xShear", value)

    @builtins.property
    @jsii.member(jsii_name="xShearVar")
    def x_shear_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xShearVar"))

    @x_shear_var.setter
    def x_shear_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6c18d2639e259fed2e1127ca3a98fca33efc2f8e146aa6fb4b59927c3c0d46c9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xShearVar", value)

    @builtins.property
    @jsii.member(jsii_name="yShear")
    def y_shear(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yShear"))

    @y_shear.setter
    def y_shear(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0f2995c9950e7330c9187ea4ebbb67f99b8bbbfa5b69d1959bde1d5d28c378a8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yShear", value)

    @builtins.property
    @jsii.member(jsii_name="yShearVar")
    def y_shear_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yShearVar"))

    @y_shear_var.setter
    def y_shear_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__00e00ad85e1029e75fd06979ab748ddbec1717b41d2387ae6620b16e3384a26e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yShearVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareShear]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareShear]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareShear]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f50ad77012ab1b4ce4204b1c5969da9b9327cc0316f727e3874790aa98f63553)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareTrim",
    jsii_struct_bases=[],
    name_mapping={
        "fuzz": "fuzz",
        "fuzz_var": "fuzzVar",
        "padding": "padding",
        "padding_var": "paddingVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareTrim:
    def __init__(
        self,
        *,
        fuzz: typing.Optional[builtins.str] = None,
        fuzz_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fuzz: The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz DataAkamaiImagingPolicyImage#fuzz}
        :param fuzz_var: The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz_var DataAkamaiImagingPolicyImage#fuzz_var}
        :param padding: The amount of padding in pixels to add to the trimmed image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: The amount of padding in pixels to add to the trimmed image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f0c5be9caac310a282524bb24ca22ae8c746c3a93ce55bca160c8e9b0e28c969)
            check_type(argname="argument fuzz", value=fuzz, expected_type=type_hints["fuzz"])
            check_type(argname="argument fuzz_var", value=fuzz_var, expected_type=type_hints["fuzz_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fuzz is not None:
            self._values["fuzz"] = fuzz
        if fuzz_var is not None:
            self._values["fuzz_var"] = fuzz_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var

    @builtins.property
    def fuzz(self) -> typing.Optional[builtins.str]:
        '''The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz DataAkamaiImagingPolicyImage#fuzz}
        '''
        result = self._values.get("fuzz")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fuzz_var(self) -> typing.Optional[builtins.str]:
        '''The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz_var DataAkamaiImagingPolicyImage#fuzz_var}
        '''
        result = self._values.get("fuzz_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''The amount of padding in pixels to add to the trimmed image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''The amount of padding in pixels to add to the trimmed image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareTrim(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareTrimList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareTrimList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4272133e82e8be1a592f12e97a7db087e583ace6e132d7a253859ba769028282)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareTrimOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3b48958da1e5223eb72ef904e7d04034bfe4b79e687ebcdde317cc54b51183d1)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareTrimOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__883217b7ec62bc4abda9e63cf44d16881206dcebefa1cd86ee47342e9db66491)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__21a9106d24fed2bf208983dc14c40d479aa2083e2f1bee09235d6159cf643284)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5c932a9e268930d39d8b12b56bd75fb5e2dd65341f458a9692fca2ef33ed5035)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareTrim]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareTrim]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareTrim]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e760e15d3a1c919a97bb338bcf6d34c376e318354b3b32afbedbc8285d35209f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareTrimOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareTrimOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__61ca013e4a8139b3bbec38d591975af56e31a7b8814d8d7ca2aaf5e4bd198a56)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetFuzz")
    def reset_fuzz(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFuzz", []))

    @jsii.member(jsii_name="resetFuzzVar")
    def reset_fuzz_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFuzzVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @builtins.property
    @jsii.member(jsii_name="fuzzInput")
    def fuzz_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fuzzInput"))

    @builtins.property
    @jsii.member(jsii_name="fuzzVarInput")
    def fuzz_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fuzzVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="fuzz")
    def fuzz(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fuzz"))

    @fuzz.setter
    def fuzz(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__43944d4cb601e575b3c980f83efddd4604893f44bcf5183e631dff150d7819dd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fuzz", value)

    @builtins.property
    @jsii.member(jsii_name="fuzzVar")
    def fuzz_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fuzzVar"))

    @fuzz_var.setter
    def fuzz_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c427a872df29f53e229473d4dbab22ab811f317203c0308636c31ac0c45eff3e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fuzzVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a15d482e9055831af58dc61a7092df8d7aadf5bd4bb2845d8aea716fef496e11)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a096d371d745ad9c7d95820c438f16250df43c21a40aa79a7ef77af5de7cd7b9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareTrim]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareTrim]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareTrim]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__903d8adb452772f1df6aa0041d7799b51e9ed8d4c14ec99a9f287f5d5fdafb81)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareUnsharpMask",
    jsii_struct_bases=[],
    name_mapping={
        "gain": "gain",
        "gain_var": "gainVar",
        "sigma": "sigma",
        "sigma_var": "sigmaVar",
        "threshold": "threshold",
        "threshold_var": "thresholdVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareUnsharpMask:
    def __init__(
        self,
        *,
        gain: typing.Optional[builtins.str] = None,
        gain_var: typing.Optional[builtins.str] = None,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
        threshold: typing.Optional[builtins.str] = None,
        threshold_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param gain: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        :param gain_var: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        :param sigma: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        :param threshold: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        :param threshold_var: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__350390d9a0584be032b1e23fff153a6f0927a48849f28d50150662eafa31ea85)
            check_type(argname="argument gain", value=gain, expected_type=type_hints["gain"])
            check_type(argname="argument gain_var", value=gain_var, expected_type=type_hints["gain_var"])
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
            check_type(argname="argument threshold", value=threshold, expected_type=type_hints["threshold"])
            check_type(argname="argument threshold_var", value=threshold_var, expected_type=type_hints["threshold_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if gain is not None:
            self._values["gain"] = gain
        if gain_var is not None:
            self._values["gain_var"] = gain_var
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var
        if threshold is not None:
            self._values["threshold"] = threshold
        if threshold_var is not None:
            self._values["threshold_var"] = threshold_var

    @builtins.property
    def gain(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        '''
        result = self._values.get("gain")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gain_var(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        '''
        result = self._values.get("gain_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        '''
        result = self._values.get("threshold")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold_var(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        result = self._values.get("threshold_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareUnsharpMask(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareUnsharpMaskList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareUnsharpMaskList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2f52d478fc0f0e6ca8e7dd7a4b6d5ba7cad65b9047b7e2ba03b0e0b6d5c6ea65)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareUnsharpMaskOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__81009f4a4c93f57fcc4cfaf3c6217c1d2b2e4b04e66e61279f1ccce1389b9db1)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareUnsharpMaskOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f0c4bc68f62a90b93255cd5ace3d99f7d4ed819ae8b9ec6c5713752f9aefa6de)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6ca6ae6fc211ace9dae01f50f10a398b1cdf379160675b4baee40cba48ec5c95)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b020d173ccf2ad12e98c5a23666b6cb255d2d78424ba1f0e7435619dcf2aab5a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareUnsharpMask]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareUnsharpMask]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareUnsharpMask]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__26e9d0100087e331fec394b4bb9b6d573d1e4b87e94412d41439ef39243f4531)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareUnsharpMaskOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareUnsharpMaskOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__441019c3cfa023e22a63b6a973cffc246981d6d5090f727479864a193f4dee59)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetGain")
    def reset_gain(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGain", []))

    @jsii.member(jsii_name="resetGainVar")
    def reset_gain_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGainVar", []))

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @jsii.member(jsii_name="resetThreshold")
    def reset_threshold(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThreshold", []))

    @jsii.member(jsii_name="resetThresholdVar")
    def reset_threshold_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThresholdVar", []))

    @builtins.property
    @jsii.member(jsii_name="gainInput")
    def gain_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainInput"))

    @builtins.property
    @jsii.member(jsii_name="gainVarInput")
    def gain_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdInput")
    def threshold_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdVarInput")
    def threshold_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gain")
    def gain(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gain"))

    @gain.setter
    def gain(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ad4565b763861c6f4478976c0e2597fedc96d4e9fb18f607ef6a298ccc3c500f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gain", value)

    @builtins.property
    @jsii.member(jsii_name="gainVar")
    def gain_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gainVar"))

    @gain_var.setter
    def gain_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a9545c4e78cf601343f5d381c0859578ba1e9080024ca8ecde493b012971b4b0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gainVar", value)

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c04fb63c43bfbecd81f335928ae0832b52e70e4c70815b2fff23c9c88c88866a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__13e46eb8266f5977301f1877ac361971b8f0ab4fb1c26bb72ec60b18af4bfa78)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="threshold")
    def threshold(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "threshold"))

    @threshold.setter
    def threshold(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__60fbb2e124104b8420ef13b9e5255dd404dff0bf5b3314f6d15fbdb46e4449c4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "threshold", value)

    @builtins.property
    @jsii.member(jsii_name="thresholdVar")
    def threshold_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "thresholdVar"))

    @threshold_var.setter
    def threshold_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2e4eeddcf87319896a3056ed15d3b415d6b3d0204ad3901688d3d269eaf0527f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "thresholdVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareUnsharpMask]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareUnsharpMask]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareUnsharpMask]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__91e9f3772bd81f2e5bbb973974f9bfd7ff93cd724470b4bae419d37172abefcf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationImQuery",
    jsii_struct_bases=[],
    name_mapping={
        "allowed_transformations": "allowedTransformations",
        "query_var": "queryVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationImQuery:
    def __init__(
        self,
        *,
        allowed_transformations: typing.Sequence[builtins.str],
        query_var: builtins.str,
    ) -> None:
        '''
        :param allowed_transformations: Specifies the transformations that can be applied using the query string parameter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allowed_transformations DataAkamaiImagingPolicyImage#allowed_transformations}
        :param query_var: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#query_var DataAkamaiImagingPolicyImage#query_var}.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bf31ffa73875dfd47174b8d9707d70ee0f7b0497102be19367b0be8a0bf5fac4)
            check_type(argname="argument allowed_transformations", value=allowed_transformations, expected_type=type_hints["allowed_transformations"])
            check_type(argname="argument query_var", value=query_var, expected_type=type_hints["query_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "allowed_transformations": allowed_transformations,
            "query_var": query_var,
        }

    @builtins.property
    def allowed_transformations(self) -> typing.List[builtins.str]:
        '''Specifies the transformations that can be applied using the query string parameter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allowed_transformations DataAkamaiImagingPolicyImage#allowed_transformations}
        '''
        result = self._values.get("allowed_transformations")
        assert result is not None, "Required property 'allowed_transformations' is missing"
        return typing.cast(typing.List[builtins.str], result)

    @builtins.property
    def query_var(self) -> builtins.str:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#query_var DataAkamaiImagingPolicyImage#query_var}.'''
        result = self._values.get("query_var")
        assert result is not None, "Required property 'query_var' is missing"
        return typing.cast(builtins.str, result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationImQuery(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationImQueryList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationImQueryList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3268657f566ebbcb1187dec7b7cca816c80810865018e455b586734ea068421b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationImQueryOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a1d39dff11bc72669010608324ceaec9e4c8ed2df353d9b6a4f5ef6bdc96af3)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationImQueryOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__789571554534475c7abfa7ae30a5967afe2d906d1c6d35034ccced45b4d6d577)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0f22ccf0838667b96ad636b1f3c0e4b935c20f4b12ffaf98bf77ec027ca559f7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__22d888cb0791059e454d59d783a3008bb3300af4a262867396f41d275734a189)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationImQuery]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationImQuery]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationImQuery]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8e0b13e02e88c01e5a0920e0a6caaec7cb9fbbbe75051fb434b2f48d1977af59)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationImQueryOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationImQueryOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__58a4257ded635fbb1c44d66f85f29cafc3d8b702aa9cd510945205006c3b6398)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @builtins.property
    @jsii.member(jsii_name="allowedTransformationsInput")
    def allowed_transformations_input(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "allowedTransformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="queryVarInput")
    def query_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "queryVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowedTransformations")
    def allowed_transformations(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "allowedTransformations"))

    @allowed_transformations.setter
    def allowed_transformations(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7fcb77644df0464567e1277641ccf8efb82153f9645f10f5ef30877f26447229)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowedTransformations", value)

    @builtins.property
    @jsii.member(jsii_name="queryVar")
    def query_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "queryVar"))

    @query_var.setter
    def query_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__329ee7b0063fe89ab297808eee135bbef45f2cb3181671bc6faa3dcbf9a3b56f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "queryVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationImQuery]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationImQuery]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationImQuery]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ef5dfa2c7957635c093045ded809cccb66628652324f81ee6a166fba19b6b76)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationMaxColors",
    jsii_struct_bases=[],
    name_mapping={"colors": "colors", "colors_var": "colorsVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationMaxColors:
    def __init__(
        self,
        *,
        colors: typing.Optional[builtins.str] = None,
        colors_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param colors: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        :param colors_var: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6270509249ebf33c93f88d74156e277be143f0f8d8f4db4254495dc39981bef4)
            check_type(argname="argument colors", value=colors, expected_type=type_hints["colors"])
            check_type(argname="argument colors_var", value=colors_var, expected_type=type_hints["colors_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if colors is not None:
            self._values["colors"] = colors
        if colors_var is not None:
            self._values["colors_var"] = colors_var

    @builtins.property
    def colors(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        '''
        result = self._values.get("colors")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def colors_var(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        result = self._values.get("colors_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationMaxColors(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationMaxColorsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationMaxColorsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e08bd7c39f816d6aabb531f3b27326441f9b164a817db295223a3271d88295d4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationMaxColorsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f45a64412670f151a085a734607453ce97481193b9775089f694f9239e6c14e)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationMaxColorsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6d05d0c90891cef8e06f89c346bd22db30f9165a8f8784086befab55592e24ac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__52a7711272509fe111617587f83d1006b9cbe3f8fe65d758f034742967a4a9a8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__783c97d9929fba003acd67385770b706ebe352e72985db5d2a645d2759985406)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationMaxColors]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationMaxColors]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ff4e0b3396f73840b329607a6673e9d33de9bffb6d59743b8b9363f0b4c2af69)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationMaxColorsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationMaxColorsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1232f53844faf96a07c2729943a266ac3ded8007bd4d78e8408ad64385f51393)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColors")
    def reset_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColors", []))

    @jsii.member(jsii_name="resetColorsVar")
    def reset_colors_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorsVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorsInput")
    def colors_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsInput"))

    @builtins.property
    @jsii.member(jsii_name="colorsVarInput")
    def colors_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsVarInput"))

    @builtins.property
    @jsii.member(jsii_name="colors")
    def colors(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colors"))

    @colors.setter
    def colors(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7967a7cfc4dfd862c8f2dbcb0b800adf946d3c79634793054ac4ee8b3899276b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colors", value)

    @builtins.property
    @jsii.member(jsii_name="colorsVar")
    def colors_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorsVar"))

    @colors_var.setter
    def colors_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f5bdb0c472aeb428a1c673e48c9d496095c0d26cc6cd5159bc5940d26faab496)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorsVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationMaxColors]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationMaxColors]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationMaxColors]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d78587ab6281d6783ecc5c61071478fc299a02ade4e649a66de1902c01d0bd24)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationMirror",
    jsii_struct_bases=[],
    name_mapping={
        "horizontal": "horizontal",
        "horizontal_var": "horizontalVar",
        "vertical": "vertical",
        "vertical_var": "verticalVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationMirror:
    def __init__(
        self,
        *,
        horizontal: typing.Optional[builtins.str] = None,
        horizontal_var: typing.Optional[builtins.str] = None,
        vertical: typing.Optional[builtins.str] = None,
        vertical_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param horizontal: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        :param horizontal_var: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        :param vertical: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        :param vertical_var: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ca5645531b7ed8b61494189e620c49d02aa14796249ceba950bd0982e2cf5b5)
            check_type(argname="argument horizontal", value=horizontal, expected_type=type_hints["horizontal"])
            check_type(argname="argument horizontal_var", value=horizontal_var, expected_type=type_hints["horizontal_var"])
            check_type(argname="argument vertical", value=vertical, expected_type=type_hints["vertical"])
            check_type(argname="argument vertical_var", value=vertical_var, expected_type=type_hints["vertical_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if horizontal is not None:
            self._values["horizontal"] = horizontal
        if horizontal_var is not None:
            self._values["horizontal_var"] = horizontal_var
        if vertical is not None:
            self._values["vertical"] = vertical
        if vertical_var is not None:
            self._values["vertical_var"] = vertical_var

    @builtins.property
    def horizontal(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        '''
        result = self._values.get("horizontal")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def horizontal_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        '''
        result = self._values.get("horizontal_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        '''
        result = self._values.get("vertical")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        result = self._values.get("vertical_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationMirror(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationMirrorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationMirrorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8feadf6a0cb781c3349a74273e53d43d8bc3f8ca3a2c02ba7fff581cb5ad4ee4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationMirrorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eabc76584dd904c500b7ec78195624e1b215b3fb9f4ee4dbaae4b14f1f93fc72)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationMirrorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a8097947a178c4ae19bf1e34b576e8176fcbf7c7f20ab90b4e59a90d4536293)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3950ac934524de9407a1861120fcb496210c35495c9e54ae54a0c2827f24f338)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__835e5ff0f4bbed58fee02388eda77962a38a455a075b264f4d14bde4e2e64259)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationMirror]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationMirror]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b06efe94e403afd37b330dd98f8bdb70c4f592acedb8e2f89f9790ab32f80a99)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationMirrorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationMirrorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a127a1297a049b2410389351887043d46f2ef665e0204d35323a6a72f9653d12)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHorizontal")
    def reset_horizontal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontal", []))

    @jsii.member(jsii_name="resetHorizontalVar")
    def reset_horizontal_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontalVar", []))

    @jsii.member(jsii_name="resetVertical")
    def reset_vertical(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVertical", []))

    @jsii.member(jsii_name="resetVerticalVar")
    def reset_vertical_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVerticalVar", []))

    @builtins.property
    @jsii.member(jsii_name="horizontalInput")
    def horizontal_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontalVarInput")
    def horizontal_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalInput")
    def vertical_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalVarInput")
    def vertical_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontal")
    def horizontal(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontal"))

    @horizontal.setter
    def horizontal(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__13385d3019f386f134e3a15fc9006f0f612fe263477894a35dad500e682ed058)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontal", value)

    @builtins.property
    @jsii.member(jsii_name="horizontalVar")
    def horizontal_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontalVar"))

    @horizontal_var.setter
    def horizontal_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cc957670378e4583ec6e7bf87cce86e7de5e6d27de34252e9662956790ca42e6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontalVar", value)

    @builtins.property
    @jsii.member(jsii_name="vertical")
    def vertical(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "vertical"))

    @vertical.setter
    def vertical(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0f6ba4bd52c8824e304bc69b5836c8f01a036e077de0f89adf731dcc312c9bb1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "vertical", value)

    @builtins.property
    @jsii.member(jsii_name="verticalVar")
    def vertical_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "verticalVar"))

    @vertical_var.setter
    def vertical_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__61448a3163c5d680f64eb81adc645cff4c35802ec9697e7c6780d155245c7af6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "verticalVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationMirror]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationMirror]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationMirror]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4dadfc33e9e8d4aedbc27fa5125dde2535af28ed8019e02c39d69beee3baf096)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationMonoHue",
    jsii_struct_bases=[],
    name_mapping={"hue": "hue", "hue_var": "hueVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationMonoHue:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c9b4607160988739353828459d28d3fb33faed99a25df8b7b1faac64872b4290)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationMonoHue(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationMonoHueList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationMonoHueList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6950e3330b3cbcc1e9a64df009c6d520bb3859bc8fd84725b777dcd4250dde8d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationMonoHueOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__86eae0d83ca10736609f2bc9012fbfae4b8dc16032e68bddfdf22df54ab5d833)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationMonoHueOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9292cc1ff345c8b895bfec770db1467d59895e3008deec29849745b54c75c506)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e0da9361c9ffd353477be726b65413ca719de4d4a96bdac3a5f65aa014732a8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a1f1fd35e95799d9b5e5cdeed455922bcc1c669501a0ae5b5439f6e915717a21)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationMonoHue]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationMonoHue]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8721159632c9fac7c65e1c329f5adb56a6e6b9cdbd6fb3c050746203363870b5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationMonoHueOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationMonoHueOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__642c4cc6581c12f7a8fa6d1d2b58ff565fa56ce0b08fa16862f4672f37bd8a5c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ad4c3698e5753b1a8cb7ba0b069354fbbe2586cb5964a648ba6a76bbb3bdf05)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__202279b80986ec2ece6ba5fd3b5f29984cf3c429a90d427c23918ce07e51e493)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationMonoHue]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationMonoHue]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationMonoHue]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c601906fa743b9745bc0e070a8cf37658db0ecc51c0f19ac55b9a76d64c835ba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationOpacity",
    jsii_struct_bases=[],
    name_mapping={"opacity": "opacity", "opacity_var": "opacityVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationOpacity:
    def __init__(
        self,
        *,
        opacity: typing.Optional[builtins.str] = None,
        opacity_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param opacity: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param opacity_var: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__708164c236ac8851567c1b6f208dc08bb2a039e878b69e4f2a7094c4da311bbe)
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument opacity_var", value=opacity_var, expected_type=type_hints["opacity_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if opacity is not None:
            self._values["opacity"] = opacity
        if opacity_var is not None:
            self._values["opacity_var"] = opacity_var

    @builtins.property
    def opacity(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def opacity_var(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        result = self._values.get("opacity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationOpacity(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationOpacityList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationOpacityList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__132139897589af662bf7a6255fe4dc848dee172be10789a512d44508d518f5a9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationOpacityOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5070de91fb9317d1b2804c9020a7369e75a9846e619b53283dd8c0023da54889)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationOpacityOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a76849744a138f9dc92793765916e59e5beb6e0a8bb6d2510317f0f9f6ef7fa2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1d1a9c0827fb633c9f6497aef91543847b44f4b54429161260512159a844df7f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6783edb955229df0248254b100efb166230f526f1ce59f821a1a9712ba941489)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationOpacity]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationOpacity]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__da107cf46f4562ad68331416cc5447c68191cbb04efa9b528f03c3599a812392)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationOpacityOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationOpacityOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0f539e44f259874b82e59686b9f35240f14dafe4baa8d405d3c53d1ca11c0dde)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetOpacityVar")
    def reset_opacity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacityVar", []))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityVarInput")
    def opacity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacity"))

    @opacity.setter
    def opacity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7c8a53e1467b8b03b82e0347747e610c9ea0d7caaf5b03f8a585cafb84c8d15f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacity", value)

    @builtins.property
    @jsii.member(jsii_name="opacityVar")
    def opacity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacityVar"))

    @opacity_var.setter
    def opacity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5a0c0c924afaa4f53de7310976a08c6bac7550c204ed5f44d4b6829a80d58ff2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacityVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationOpacity]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationOpacity]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationOpacity]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eaf45c1320ea53d895a67bcedf24164924a6cf61ebd7e995b9fe6580f84d3cab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e648127a47ffb5f7cb7fd314e909775a7b25a4bc451b3f1c4a4f821036181c07)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putAppend")
    def put_append(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppend, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a50e0b2480710fc5d1ea12a8e8f5d6b9c81d65f30a2d68fd52f84678acf9855a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putAppend", [value]))

    @jsii.member(jsii_name="putAspectCrop")
    def put_aspect_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAspectCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a83a2e2c1a42634f25bde9019ea71ceadbee2aa77bd4dbe50d15b2158153103)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putAspectCrop", [value]))

    @jsii.member(jsii_name="putBackgroundColor")
    def put_background_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__46655e937a09b9d4e9c180cb23c9f2bbfc9924ba8caf0ea8d6d73f0e7066f065)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBackgroundColor", [value]))

    @jsii.member(jsii_name="putBlur")
    def put_blur(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationBlur, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3e815b5fb88f72d1d4bd73e6dcfc86f4c414d342e1f814a713c01494059531c1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBlur", [value]))

    @jsii.member(jsii_name="putChromaKey")
    def put_chroma_key(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationChromaKey, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fbe97d45d94a09d0aac0024d3299b550278dc123631fc13c7885bab8d8ac3b04)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putChromaKey", [value]))

    @jsii.member(jsii_name="putComposite")
    def put_composite(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationComposite, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6d5dba7c0519881a4bdfaba44c54d875921c9d57ba567479823bdc89077c3897)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putComposite", [value]))

    @jsii.member(jsii_name="putCompound")
    def put_compound(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompound, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a45def051af62ac8b3ac1c4b93280f6336646884ce1ffa8e7868609e3af73ab4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCompound", [value]))

    @jsii.member(jsii_name="putContrast")
    def put_contrast(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationContrast, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__16a0396fb2e03837cd01c659255909fa07763c70c0bf25d51f78f9cc62444d5f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putContrast", [value]))

    @jsii.member(jsii_name="putCrop")
    def put_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a5d771902cc6278371ed3342909fef8190dcb5d43a22e3c48431888bb6e65fca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCrop", [value]))

    @jsii.member(jsii_name="putFaceCrop")
    def put_face_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationFaceCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a87a85e1a6d5cb926fed3675211d9142930a33ca413760708f8aa5549fb5e1e7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFaceCrop", [value]))

    @jsii.member(jsii_name="putFeatureCrop")
    def put_feature_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationFeatureCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2af68cb3bf1327bcf2411cd06444b7f96e7163125c940f7e3b448113e3e0aa91)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFeatureCrop", [value]))

    @jsii.member(jsii_name="putFitAndFill")
    def put_fit_and_fill(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFill, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9164cccecda036b834df163270b00c2cb5f2d700e7869fc079616800b18639a0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFitAndFill", [value]))

    @jsii.member(jsii_name="putGoop")
    def put_goop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationGoop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__52337ea8c15da4e51d998eef334cb62aa39dc6be0ecb9782e97b60da396c1304)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGoop", [value]))

    @jsii.member(jsii_name="putGrayscale")
    def put_grayscale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationGrayscale, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__98c80ffcd780c616a8e601b23fac9564518df068182c91030e5cc7f96340fd0d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGrayscale", [value]))

    @jsii.member(jsii_name="putHsl")
    def put_hsl(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationHsl, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8d0ee02302a59f83744f0e74d6e8ff84e0f0095ad0223b5f81ac405f66fae37e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsl", [value]))

    @jsii.member(jsii_name="putHsv")
    def put_hsv(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationHsv, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b693fb69bb2ab7a87d45749805d0261b620c7279177121d72b0ce2e84e6cfda6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsv", [value]))

    @jsii.member(jsii_name="putIfDimension")
    def put_if_dimension(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimension, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd53244207a7a3f737d321a41e6033c678f8935a842bee0b58fd214fc082a933)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfDimension", [value]))

    @jsii.member(jsii_name="putIfOrientation")
    def put_if_orientation(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__823ec67bf2e422f4dbf54cd85541715fa88c38705695c4cf426187e39ad5da30)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfOrientation", [value]))

    @jsii.member(jsii_name="putImQuery")
    def put_im_query(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationImQuery, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5106e9e38d0835dce500add17e16ce48c11380c14b7d09c6f1a9d2d77e9f069b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putImQuery", [value]))

    @jsii.member(jsii_name="putMaxColors")
    def put_max_colors(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationMaxColors, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f5d64be0f9fa9c254d4124ee17b55bcfa88bbe3ebb80023cdbd4938e62c0fa9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMaxColors", [value]))

    @jsii.member(jsii_name="putMirror")
    def put_mirror(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationMirror, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ca61e31fcde40dd46e78ef10ddec1ed587b453bcba1dbe339feb8bbb66ac48b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMirror", [value]))

    @jsii.member(jsii_name="putMonoHue")
    def put_mono_hue(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationMonoHue, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ecc5b2be66a20858b4691483276dc90cda138c89e8f3dcd51ce35335a9ddf29c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMonoHue", [value]))

    @jsii.member(jsii_name="putOpacity")
    def put_opacity(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationOpacity, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5a8568ae7857e0c77335823b0ede91af6052a08b0fcb705c6c574325b19a0051)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putOpacity", [value]))

    @jsii.member(jsii_name="putRegionOfInterestCrop")
    def put_region_of_interest_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCrop", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__51756e1b765f8555affb417aeff1a9f2fcd5d092bf7b68caf4d1ac38eaac3b1f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRegionOfInterestCrop", [value]))

    @jsii.member(jsii_name="putRelativeCrop")
    def put_relative_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRelativeCrop", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__50f124296a828005a330dd872a31b000020a886c0dae09e0491ad9ba5e996d94)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRelativeCrop", [value]))

    @jsii.member(jsii_name="putRemoveColor")
    def put_remove_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRemoveColor", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ef34f5150e73404ff920a002a2e9eff98865c319ceeee95f07dc528f7ead806c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRemoveColor", [value]))

    @jsii.member(jsii_name="putResize")
    def put_resize(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationResize", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0642053752c35ee80bc3040c7797720fc0912fed5be5d8dae91c64372b233cbe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putResize", [value]))

    @jsii.member(jsii_name="putRotate")
    def put_rotate(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRotate", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8edcfd719a4bcbbd1ee0d5854996e2bc5afb30807c4c6e933db86915de35fe02)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRotate", [value]))

    @jsii.member(jsii_name="putScale")
    def put_scale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationScale", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ad7aeb81e7505c6c7b545e9ea6df750bbb013ea01b6cb9c26ff20aec067862d4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putScale", [value]))

    @jsii.member(jsii_name="putShear")
    def put_shear(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationShear", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c5c46635d2f6b3d2527e7ac148d6d0ea4986277abce4121ca138a21d88bc0faf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putShear", [value]))

    @jsii.member(jsii_name="putTrim")
    def put_trim(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationTrim", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ff5e43d4c489e27532d43afe04fbc05b5f3f8bcfb8dd8c5205307edbec491c97)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTrim", [value]))

    @jsii.member(jsii_name="putUnsharpMask")
    def put_unsharp_mask(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationUnsharpMask", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ad0617aac22826ad5eb78d596064a857b7f1f353e8f3d544b0317164b51bfe1e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putUnsharpMask", [value]))

    @jsii.member(jsii_name="resetAppend")
    def reset_append(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAppend", []))

    @jsii.member(jsii_name="resetAspectCrop")
    def reset_aspect_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspectCrop", []))

    @jsii.member(jsii_name="resetBackgroundColor")
    def reset_background_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBackgroundColor", []))

    @jsii.member(jsii_name="resetBlur")
    def reset_blur(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBlur", []))

    @jsii.member(jsii_name="resetChromaKey")
    def reset_chroma_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChromaKey", []))

    @jsii.member(jsii_name="resetComposite")
    def reset_composite(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetComposite", []))

    @jsii.member(jsii_name="resetCompound")
    def reset_compound(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCompound", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetCrop")
    def reset_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCrop", []))

    @jsii.member(jsii_name="resetFaceCrop")
    def reset_face_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFaceCrop", []))

    @jsii.member(jsii_name="resetFeatureCrop")
    def reset_feature_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureCrop", []))

    @jsii.member(jsii_name="resetFitAndFill")
    def reset_fit_and_fill(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFitAndFill", []))

    @jsii.member(jsii_name="resetGoop")
    def reset_goop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGoop", []))

    @jsii.member(jsii_name="resetGrayscale")
    def reset_grayscale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGrayscale", []))

    @jsii.member(jsii_name="resetHsl")
    def reset_hsl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsl", []))

    @jsii.member(jsii_name="resetHsv")
    def reset_hsv(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsv", []))

    @jsii.member(jsii_name="resetIfDimension")
    def reset_if_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfDimension", []))

    @jsii.member(jsii_name="resetIfOrientation")
    def reset_if_orientation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfOrientation", []))

    @jsii.member(jsii_name="resetImQuery")
    def reset_im_query(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetImQuery", []))

    @jsii.member(jsii_name="resetMaxColors")
    def reset_max_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxColors", []))

    @jsii.member(jsii_name="resetMirror")
    def reset_mirror(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMirror", []))

    @jsii.member(jsii_name="resetMonoHue")
    def reset_mono_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonoHue", []))

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetRegionOfInterestCrop")
    def reset_region_of_interest_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRegionOfInterestCrop", []))

    @jsii.member(jsii_name="resetRelativeCrop")
    def reset_relative_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRelativeCrop", []))

    @jsii.member(jsii_name="resetRemoveColor")
    def reset_remove_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRemoveColor", []))

    @jsii.member(jsii_name="resetResize")
    def reset_resize(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetResize", []))

    @jsii.member(jsii_name="resetRotate")
    def reset_rotate(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRotate", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetShear")
    def reset_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetShear", []))

    @jsii.member(jsii_name="resetTrim")
    def reset_trim(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTrim", []))

    @jsii.member(jsii_name="resetUnsharpMask")
    def reset_unsharp_mask(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUnsharpMask", []))

    @builtins.property
    @jsii.member(jsii_name="append")
    def append(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendList, jsii.get(self, "append"))

    @builtins.property
    @jsii.member(jsii_name="aspectCrop")
    def aspect_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAspectCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAspectCropList, jsii.get(self, "aspectCrop"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColor")
    def background_color(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationBackgroundColorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationBackgroundColorList, jsii.get(self, "backgroundColor"))

    @builtins.property
    @jsii.member(jsii_name="blur")
    def blur(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationBlurList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationBlurList, jsii.get(self, "blur"))

    @builtins.property
    @jsii.member(jsii_name="chromaKey")
    def chroma_key(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationChromaKeyList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationChromaKeyList, jsii.get(self, "chromaKey"))

    @builtins.property
    @jsii.member(jsii_name="composite")
    def composite(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeList, jsii.get(self, "composite"))

    @builtins.property
    @jsii.member(jsii_name="compound")
    def compound(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompoundList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompoundList, jsii.get(self, "compound"))

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationContrastList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationContrastList, jsii.get(self, "contrast"))

    @builtins.property
    @jsii.member(jsii_name="crop")
    def crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCropList, jsii.get(self, "crop"))

    @builtins.property
    @jsii.member(jsii_name="faceCrop")
    def face_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationFaceCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationFaceCropList, jsii.get(self, "faceCrop"))

    @builtins.property
    @jsii.member(jsii_name="featureCrop")
    def feature_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationFeatureCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationFeatureCropList, jsii.get(self, "featureCrop"))

    @builtins.property
    @jsii.member(jsii_name="fitAndFill")
    def fit_and_fill(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillList", jsii.get(self, "fitAndFill"))

    @builtins.property
    @jsii.member(jsii_name="goop")
    def goop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationGoopList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationGoopList, jsii.get(self, "goop"))

    @builtins.property
    @jsii.member(jsii_name="grayscale")
    def grayscale(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationGrayscaleList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationGrayscaleList, jsii.get(self, "grayscale"))

    @builtins.property
    @jsii.member(jsii_name="hsl")
    def hsl(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationHslList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationHslList, jsii.get(self, "hsl"))

    @builtins.property
    @jsii.member(jsii_name="hsv")
    def hsv(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationHsvList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationHsvList, jsii.get(self, "hsv"))

    @builtins.property
    @jsii.member(jsii_name="ifDimension")
    def if_dimension(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionList, jsii.get(self, "ifDimension"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientation")
    def if_orientation(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationList, jsii.get(self, "ifOrientation"))

    @builtins.property
    @jsii.member(jsii_name="imQuery")
    def im_query(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationImQueryList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationImQueryList, jsii.get(self, "imQuery"))

    @builtins.property
    @jsii.member(jsii_name="maxColors")
    def max_colors(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationMaxColorsList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationMaxColorsList, jsii.get(self, "maxColors"))

    @builtins.property
    @jsii.member(jsii_name="mirror")
    def mirror(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationMirrorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationMirrorList, jsii.get(self, "mirror"))

    @builtins.property
    @jsii.member(jsii_name="monoHue")
    def mono_hue(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationMonoHueList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationMonoHueList, jsii.get(self, "monoHue"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationOpacityList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationOpacityList, jsii.get(self, "opacity"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestCrop")
    def region_of_interest_crop(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropList", jsii.get(self, "regionOfInterestCrop"))

    @builtins.property
    @jsii.member(jsii_name="relativeCrop")
    def relative_crop(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRelativeCropList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRelativeCropList", jsii.get(self, "relativeCrop"))

    @builtins.property
    @jsii.member(jsii_name="removeColor")
    def remove_color(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRemoveColorList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRemoveColorList", jsii.get(self, "removeColor"))

    @builtins.property
    @jsii.member(jsii_name="resize")
    def resize(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationResizeList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationResizeList", jsii.get(self, "resize"))

    @builtins.property
    @jsii.member(jsii_name="rotate")
    def rotate(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRotateList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRotateList", jsii.get(self, "rotate"))

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationScaleList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationScaleList", jsii.get(self, "scale"))

    @builtins.property
    @jsii.member(jsii_name="shear")
    def shear(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationShearList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationShearList", jsii.get(self, "shear"))

    @builtins.property
    @jsii.member(jsii_name="trim")
    def trim(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationTrimList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationTrimList", jsii.get(self, "trim"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMask")
    def unsharp_mask(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationUnsharpMaskList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationUnsharpMaskList", jsii.get(self, "unsharpMask"))

    @builtins.property
    @jsii.member(jsii_name="appendInput")
    def append_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppend]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppend]]], jsii.get(self, "appendInput"))

    @builtins.property
    @jsii.member(jsii_name="aspectCropInput")
    def aspect_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAspectCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAspectCrop]]], jsii.get(self, "aspectCropInput"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColorInput")
    def background_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationBackgroundColor]]], jsii.get(self, "backgroundColorInput"))

    @builtins.property
    @jsii.member(jsii_name="blurInput")
    def blur_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationBlur]]], jsii.get(self, "blurInput"))

    @builtins.property
    @jsii.member(jsii_name="chromaKeyInput")
    def chroma_key_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationChromaKey]]], jsii.get(self, "chromaKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="compositeInput")
    def composite_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationComposite]]], jsii.get(self, "compositeInput"))

    @builtins.property
    @jsii.member(jsii_name="compoundInput")
    def compound_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompound]]], jsii.get(self, "compoundInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationContrast]]], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="cropInput")
    def crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCrop]]], jsii.get(self, "cropInput"))

    @builtins.property
    @jsii.member(jsii_name="faceCropInput")
    def face_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationFaceCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationFaceCrop]]], jsii.get(self, "faceCropInput"))

    @builtins.property
    @jsii.member(jsii_name="featureCropInput")
    def feature_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationFeatureCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationFeatureCrop]]], jsii.get(self, "featureCropInput"))

    @builtins.property
    @jsii.member(jsii_name="fitAndFillInput")
    def fit_and_fill_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFill]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFill]]], jsii.get(self, "fitAndFillInput"))

    @builtins.property
    @jsii.member(jsii_name="goopInput")
    def goop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationGoop]]], jsii.get(self, "goopInput"))

    @builtins.property
    @jsii.member(jsii_name="grayscaleInput")
    def grayscale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationGrayscale]]], jsii.get(self, "grayscaleInput"))

    @builtins.property
    @jsii.member(jsii_name="hslInput")
    def hsl_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationHsl]]], jsii.get(self, "hslInput"))

    @builtins.property
    @jsii.member(jsii_name="hsvInput")
    def hsv_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationHsv]]], jsii.get(self, "hsvInput"))

    @builtins.property
    @jsii.member(jsii_name="ifDimensionInput")
    def if_dimension_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimension]]], jsii.get(self, "ifDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientationInput")
    def if_orientation_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientation]]], jsii.get(self, "ifOrientationInput"))

    @builtins.property
    @jsii.member(jsii_name="imQueryInput")
    def im_query_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationImQuery]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationImQuery]]], jsii.get(self, "imQueryInput"))

    @builtins.property
    @jsii.member(jsii_name="maxColorsInput")
    def max_colors_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationMaxColors]]], jsii.get(self, "maxColorsInput"))

    @builtins.property
    @jsii.member(jsii_name="mirrorInput")
    def mirror_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationMirror]]], jsii.get(self, "mirrorInput"))

    @builtins.property
    @jsii.member(jsii_name="monoHueInput")
    def mono_hue_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationMonoHue]]], jsii.get(self, "monoHueInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationOpacity]]], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestCropInput")
    def region_of_interest_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCrop"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCrop"]]], jsii.get(self, "regionOfInterestCropInput"))

    @builtins.property
    @jsii.member(jsii_name="relativeCropInput")
    def relative_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRelativeCrop"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRelativeCrop"]]], jsii.get(self, "relativeCropInput"))

    @builtins.property
    @jsii.member(jsii_name="removeColorInput")
    def remove_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRemoveColor"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRemoveColor"]]], jsii.get(self, "removeColorInput"))

    @builtins.property
    @jsii.member(jsii_name="resizeInput")
    def resize_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationResize"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationResize"]]], jsii.get(self, "resizeInput"))

    @builtins.property
    @jsii.member(jsii_name="rotateInput")
    def rotate_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRotate"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRotate"]]], jsii.get(self, "rotateInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationScale"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationScale"]]], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="shearInput")
    def shear_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationShear"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationShear"]]], jsii.get(self, "shearInput"))

    @builtins.property
    @jsii.member(jsii_name="trimInput")
    def trim_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationTrim"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationTrim"]]], jsii.get(self, "trimInput"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMaskInput")
    def unsharp_mask_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationUnsharpMask"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationUnsharpMask"]]], jsii.get(self, "unsharpMaskInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4facf4ac93a65c1d95ac176d3e7896d651d93bc28ea6084eb04e0d5b30cfc273)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCrop",
    jsii_struct_bases=[],
    name_mapping={
        "region_of_interest": "regionOfInterest",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCrop:
    def __init__(
        self,
        *,
        region_of_interest: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterest", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param region_of_interest: region_of_interest block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest DataAkamaiImagingPolicyImage#region_of_interest}
        :param gravity: The placement of the crop area relative to the specified area of interest. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: The placement of the crop area relative to the specified area of interest. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param style: Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(region_of_interest, dict):
            region_of_interest = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterest(**region_of_interest)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4c0be3cff9f91c2952ef19927085aeec3de0a11a8d45375e08809a8769f42e25)
            check_type(argname="argument region_of_interest", value=region_of_interest, expected_type=type_hints["region_of_interest"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "region_of_interest": region_of_interest,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def region_of_interest(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterest":
        '''region_of_interest block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest DataAkamaiImagingPolicyImage#region_of_interest}
        '''
        result = self._values.get("region_of_interest")
        assert result is not None, "Required property 'region_of_interest' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterest", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''The placement of the crop area relative to the specified area of interest.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''The placement of the crop area relative to the specified area of interest.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8faf448b0bae196b6a82d64bf94f80eff3db38c4b7a76298b27f0dcd55ec7842)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__06a50c1a496822a2c593559dcdedb076cecdfa47d1338f31d6fbcc2c8ba3cbe4)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b8ba3ee346f45a7b117b665811ad416ccfa831cd2df4b47f2f7c95db74f08174)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a7cd8eb2a0fa9f85fcfd878f9ca48ac7abf47623b2207cee03521ac0f140fc03)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ccc8eed5d2724b6bb4c9366281a24b504407ab0f68cb02902a0fa80a1b8b0028)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fb363db36b9fb6e6f9cd595650af97349a188c763fc4a97b1d44562c9b58cb3b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e5c5479048f2dca8c98801ba9b4450d30de6b1d0e4c90f9df4af9707e6ab4bde)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putRegionOfInterest")
    def put_region_of_interest(
        self,
        *,
        circle_shape: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestCircleShape", typing.Dict[builtins.str, typing.Any]]]]] = None,
        point_shape: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestPointShape", typing.Dict[builtins.str, typing.Any]]]]] = None,
        polygon_shape: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestPolygonShape", typing.Dict[builtins.str, typing.Any]]]]] = None,
        rectangle_shape: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestRectangleShape", typing.Dict[builtins.str, typing.Any]]]]] = None,
        union_shape: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestUnionShape", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param circle_shape: circle_shape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#circle_shape DataAkamaiImagingPolicyImage#circle_shape}
        :param point_shape: point_shape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#point_shape DataAkamaiImagingPolicyImage#point_shape}
        :param polygon_shape: polygon_shape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#polygon_shape DataAkamaiImagingPolicyImage#polygon_shape}
        :param rectangle_shape: rectangle_shape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rectangle_shape DataAkamaiImagingPolicyImage#rectangle_shape}
        :param union_shape: union_shape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#union_shape DataAkamaiImagingPolicyImage#union_shape}
        '''
        value = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterest(
            circle_shape=circle_shape,
            point_shape=point_shape,
            polygon_shape=polygon_shape,
            rectangle_shape=rectangle_shape,
            union_shape=union_shape,
        )

        return typing.cast(None, jsii.invoke(self, "putRegionOfInterest", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterest")
    def region_of_interest(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestOutputReference", jsii.get(self, "regionOfInterest"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestInput")
    def region_of_interest_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterest"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterest"], jsii.get(self, "regionOfInterestInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__220684f352c9dbc057e67d683f2c5f288f361fe3737bc8106d4bb4c27ac4ac7c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__982decbbb062da40232398d8fca00fad6fd5155865b5a83610589690d53f13cd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__16563f4da71c57c5b348924cbc8499709e46c6c72ce690f48a8d816b405acf6b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a16a274a0c6bf4db0544bb6711aaf9ab12d61942adda79c717d1509b3167328e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a439edceb7287d65872626eb437410c8a8a179d5ee345187874dfc24f34ea258)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dcd13bd9254ee5c6492d213dcdadce63dd6c3ccf8a5d7d3b49eb23a7b70ed76f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__84c2f71b91b6150c1d544e81afb18257f782ccaff010e9c1deb4875d3b494778)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d437491dff02c6f7f779f3b7d9772f75ff1c3d04e5e1f591183441d1b10e1847)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7094afd81e9b542f01e68a97f2a86507e97615a65c6ccbffaddd1906114bcc70)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterest",
    jsii_struct_bases=[],
    name_mapping={
        "circle_shape": "circleShape",
        "point_shape": "pointShape",
        "polygon_shape": "polygonShape",
        "rectangle_shape": "rectangleShape",
        "union_shape": "unionShape",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterest:
    def __init__(
        self,
        *,
        circle_shape: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestCircleShape", typing.Dict[builtins.str, typing.Any]]]]] = None,
        point_shape: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestPointShape", typing.Dict[builtins.str, typing.Any]]]]] = None,
        polygon_shape: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestPolygonShape", typing.Dict[builtins.str, typing.Any]]]]] = None,
        rectangle_shape: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestRectangleShape", typing.Dict[builtins.str, typing.Any]]]]] = None,
        union_shape: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestUnionShape", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param circle_shape: circle_shape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#circle_shape DataAkamaiImagingPolicyImage#circle_shape}
        :param point_shape: point_shape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#point_shape DataAkamaiImagingPolicyImage#point_shape}
        :param polygon_shape: polygon_shape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#polygon_shape DataAkamaiImagingPolicyImage#polygon_shape}
        :param rectangle_shape: rectangle_shape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rectangle_shape DataAkamaiImagingPolicyImage#rectangle_shape}
        :param union_shape: union_shape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#union_shape DataAkamaiImagingPolicyImage#union_shape}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__119baedfe617e33e44a7fa0760645017e9d736d47c7c9c0469e65ec45e8e726f)
            check_type(argname="argument circle_shape", value=circle_shape, expected_type=type_hints["circle_shape"])
            check_type(argname="argument point_shape", value=point_shape, expected_type=type_hints["point_shape"])
            check_type(argname="argument polygon_shape", value=polygon_shape, expected_type=type_hints["polygon_shape"])
            check_type(argname="argument rectangle_shape", value=rectangle_shape, expected_type=type_hints["rectangle_shape"])
            check_type(argname="argument union_shape", value=union_shape, expected_type=type_hints["union_shape"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if circle_shape is not None:
            self._values["circle_shape"] = circle_shape
        if point_shape is not None:
            self._values["point_shape"] = point_shape
        if polygon_shape is not None:
            self._values["polygon_shape"] = polygon_shape
        if rectangle_shape is not None:
            self._values["rectangle_shape"] = rectangle_shape
        if union_shape is not None:
            self._values["union_shape"] = union_shape

    @builtins.property
    def circle_shape(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestCircleShape"]]]:
        '''circle_shape block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#circle_shape DataAkamaiImagingPolicyImage#circle_shape}
        '''
        result = self._values.get("circle_shape")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestCircleShape"]]], result)

    @builtins.property
    def point_shape(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestPointShape"]]]:
        '''point_shape block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#point_shape DataAkamaiImagingPolicyImage#point_shape}
        '''
        result = self._values.get("point_shape")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestPointShape"]]], result)

    @builtins.property
    def polygon_shape(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestPolygonShape"]]]:
        '''polygon_shape block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#polygon_shape DataAkamaiImagingPolicyImage#polygon_shape}
        '''
        result = self._values.get("polygon_shape")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestPolygonShape"]]], result)

    @builtins.property
    def rectangle_shape(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestRectangleShape"]]]:
        '''rectangle_shape block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rectangle_shape DataAkamaiImagingPolicyImage#rectangle_shape}
        '''
        result = self._values.get("rectangle_shape")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestRectangleShape"]]], result)

    @builtins.property
    def union_shape(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestUnionShape"]]]:
        '''union_shape block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#union_shape DataAkamaiImagingPolicyImage#union_shape}
        '''
        result = self._values.get("union_shape")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestUnionShape"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterest(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestCircleShape",
    jsii_struct_bases=[],
    name_mapping={"center": "center", "radius": "radius", "radius_var": "radiusVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestCircleShape:
    def __init__(
        self,
        *,
        center: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestCircleShapeCenter", typing.Dict[builtins.str, typing.Any]],
        radius: typing.Optional[builtins.str] = None,
        radius_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param center: center block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#center DataAkamaiImagingPolicyImage#center}
        :param radius: The radius of the circle measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#radius DataAkamaiImagingPolicyImage#radius}
        :param radius_var: The radius of the circle measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#radius_var DataAkamaiImagingPolicyImage#radius_var}
        '''
        if isinstance(center, dict):
            center = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestCircleShapeCenter(**center)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b2717fc729c5fffedaeb3a3dc7eb69f7c1490d7585bf4cec3559ecbc61575d6a)
            check_type(argname="argument center", value=center, expected_type=type_hints["center"])
            check_type(argname="argument radius", value=radius, expected_type=type_hints["radius"])
            check_type(argname="argument radius_var", value=radius_var, expected_type=type_hints["radius_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "center": center,
        }
        if radius is not None:
            self._values["radius"] = radius
        if radius_var is not None:
            self._values["radius_var"] = radius_var

    @builtins.property
    def center(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestCircleShapeCenter":
        '''center block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#center DataAkamaiImagingPolicyImage#center}
        '''
        result = self._values.get("center")
        assert result is not None, "Required property 'center' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestCircleShapeCenter", result)

    @builtins.property
    def radius(self) -> typing.Optional[builtins.str]:
        '''The radius of the circle measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#radius DataAkamaiImagingPolicyImage#radius}
        '''
        result = self._values.get("radius")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def radius_var(self) -> typing.Optional[builtins.str]:
        '''The radius of the circle measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#radius_var DataAkamaiImagingPolicyImage#radius_var}
        '''
        result = self._values.get("radius_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestCircleShape(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestCircleShapeCenter",
    jsii_struct_bases=[],
    name_mapping={"x": "x", "x_var": "xVar", "y": "y", "y_var": "yVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestCircleShapeCenter:
    def __init__(
        self,
        *,
        x: typing.Optional[builtins.str] = None,
        x_var: typing.Optional[builtins.str] = None,
        y: typing.Optional[builtins.str] = None,
        y_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param x: The horizontal position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x DataAkamaiImagingPolicyImage#x}
        :param x_var: The horizontal position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_var DataAkamaiImagingPolicyImage#x_var}
        :param y: The vertical position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y DataAkamaiImagingPolicyImage#y}
        :param y_var: The vertical position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_var DataAkamaiImagingPolicyImage#y_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d23bb52c72e7794387c0d6c7cb9db2ae02e2065f0f2686bc3c74e6b1c015d5a9)
            check_type(argname="argument x", value=x, expected_type=type_hints["x"])
            check_type(argname="argument x_var", value=x_var, expected_type=type_hints["x_var"])
            check_type(argname="argument y", value=y, expected_type=type_hints["y"])
            check_type(argname="argument y_var", value=y_var, expected_type=type_hints["y_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if x is not None:
            self._values["x"] = x
        if x_var is not None:
            self._values["x_var"] = x_var
        if y is not None:
            self._values["y"] = y
        if y_var is not None:
            self._values["y_var"] = y_var

    @builtins.property
    def x(self) -> typing.Optional[builtins.str]:
        '''The horizontal position of the point, measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x DataAkamaiImagingPolicyImage#x}
        '''
        result = self._values.get("x")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_var(self) -> typing.Optional[builtins.str]:
        '''The horizontal position of the point, measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_var DataAkamaiImagingPolicyImage#x_var}
        '''
        result = self._values.get("x_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y(self) -> typing.Optional[builtins.str]:
        '''The vertical position of the point, measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y DataAkamaiImagingPolicyImage#y}
        '''
        result = self._values.get("y")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_var(self) -> typing.Optional[builtins.str]:
        '''The vertical position of the point, measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_var DataAkamaiImagingPolicyImage#y_var}
        '''
        result = self._values.get("y_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestCircleShapeCenter(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestCircleShapeCenterOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestCircleShapeCenterOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5dc1e9d8644844314f0aa9cb8554ddb2286a702700e80155c20c79669343dfac)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetX")
    def reset_x(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetX", []))

    @jsii.member(jsii_name="resetXVar")
    def reset_x_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXVar", []))

    @jsii.member(jsii_name="resetY")
    def reset_y(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetY", []))

    @jsii.member(jsii_name="resetYVar")
    def reset_y_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYVar", []))

    @builtins.property
    @jsii.member(jsii_name="xInput")
    def x_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xInput"))

    @builtins.property
    @jsii.member(jsii_name="xVarInput")
    def x_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yInput")
    def y_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yInput"))

    @builtins.property
    @jsii.member(jsii_name="yVarInput")
    def y_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yVarInput"))

    @builtins.property
    @jsii.member(jsii_name="x")
    def x(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "x"))

    @x.setter
    def x(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__94c2ed2820fd70c67c1b7aec9a8240bd407841eeac7133fc3dde10dc5c3d8c4a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "x", value)

    @builtins.property
    @jsii.member(jsii_name="xVar")
    def x_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xVar"))

    @x_var.setter
    def x_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a1746f24fc8ad0d89df5b3a7bf024e2451184fffea38072e0d2ba86b45f14a21)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xVar", value)

    @builtins.property
    @jsii.member(jsii_name="y")
    def y(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "y"))

    @y.setter
    def y(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cca81023a3f67f498aa0931205b89c3ac4287479ce3fa62f68906684c0c9f82f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "y", value)

    @builtins.property
    @jsii.member(jsii_name="yVar")
    def y_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yVar"))

    @y_var.setter
    def y_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__477ad77cfcdef964cff132639c6a496ea00f67432db91e3eae248f05d9b603a9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestCircleShapeCenter]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestCircleShapeCenter], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestCircleShapeCenter],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2cc27eeae92e407d32ce9b1199913fbfc5088e95b15924312c4b25a25a569a6d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestCircleShapeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestCircleShapeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7cd51c7bf3a1da981862eaab412bce12fade180437c0593001906f0f7886bfbf)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestCircleShapeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__18dd70970d84f4232d85eb944805d1181954bc4e74a9240adde9ae8d3e841ab2)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestCircleShapeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4cd8d5d2f626ebe5f4f72327552202ee599125b21d3cef584ba1bf0dc7c09345)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac4270166190219dd76c8bac85603e188d58ce1d4ded51cf1bef58cb6d09682e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__14eb871c283c103f143f587fb6edd078bbce5e8f0993b80e7aea6c62bbb8512d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestCircleShape]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestCircleShape]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestCircleShape]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b733e0a89f99dfee1e81afabd37587f1264021a100cd2338f1302b5c1db8398e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestCircleShapeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestCircleShapeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4bd8b5aeda688e0c6589f63b94eeac4e528d64966f6528b9024dd74c30de09e5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putCenter")
    def put_center(
        self,
        *,
        x: typing.Optional[builtins.str] = None,
        x_var: typing.Optional[builtins.str] = None,
        y: typing.Optional[builtins.str] = None,
        y_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param x: The horizontal position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x DataAkamaiImagingPolicyImage#x}
        :param x_var: The horizontal position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_var DataAkamaiImagingPolicyImage#x_var}
        :param y: The vertical position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y DataAkamaiImagingPolicyImage#y}
        :param y_var: The vertical position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_var DataAkamaiImagingPolicyImage#y_var}
        '''
        value = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestCircleShapeCenter(
            x=x, x_var=x_var, y=y, y_var=y_var
        )

        return typing.cast(None, jsii.invoke(self, "putCenter", [value]))

    @jsii.member(jsii_name="resetRadius")
    def reset_radius(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRadius", []))

    @jsii.member(jsii_name="resetRadiusVar")
    def reset_radius_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRadiusVar", []))

    @builtins.property
    @jsii.member(jsii_name="center")
    def center(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestCircleShapeCenterOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestCircleShapeCenterOutputReference, jsii.get(self, "center"))

    @builtins.property
    @jsii.member(jsii_name="centerInput")
    def center_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestCircleShapeCenter]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestCircleShapeCenter], jsii.get(self, "centerInput"))

    @builtins.property
    @jsii.member(jsii_name="radiusInput")
    def radius_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "radiusInput"))

    @builtins.property
    @jsii.member(jsii_name="radiusVarInput")
    def radius_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "radiusVarInput"))

    @builtins.property
    @jsii.member(jsii_name="radius")
    def radius(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "radius"))

    @radius.setter
    def radius(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c3dfc309ce2555bd2802a5827ce4de67b26234ea44f6512d01f5f10b62ee5e46)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "radius", value)

    @builtins.property
    @jsii.member(jsii_name="radiusVar")
    def radius_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "radiusVar"))

    @radius_var.setter
    def radius_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__979710fa5f37bf6dbe4510a0afd4221793ffd26f64970ad19a3cc7554e2c9201)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "radiusVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestCircleShape]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestCircleShape]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestCircleShape]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__150a11d50827a40e1bc2b9143aa01863aa2fe71d8309bf2b46f43aa30f41c33d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__15c52577fb7cb53330f7fdf55c2842b271f6bb5d38104eb8f8792c65d494fac5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putCircleShape")
    def put_circle_shape(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestCircleShape, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d24147204264b82d0c110e8bbf4afea4d57c851f37caf638403b4e8b303f166)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCircleShape", [value]))

    @jsii.member(jsii_name="putPointShape")
    def put_point_shape(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestPointShape", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__78df3913392d175718d61d31084d4e1236fe744739e3b789151f7046fc8612db)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putPointShape", [value]))

    @jsii.member(jsii_name="putPolygonShape")
    def put_polygon_shape(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestPolygonShape", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__112854f4799cbe96f93571c57336593f1f43dd873135ea0abfd7dba5812e4455)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putPolygonShape", [value]))

    @jsii.member(jsii_name="putRectangleShape")
    def put_rectangle_shape(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestRectangleShape", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__12e8c10829d1cfa8de63a079dcc1d14f4f33fc30e1d4393d6eb25cdfe69c1381)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRectangleShape", [value]))

    @jsii.member(jsii_name="putUnionShape")
    def put_union_shape(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestUnionShape", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f6f9a1d1f9ba3e1ac40e7ca1ec3d0797f2557b2fe640730e818b1c6770a0a1cf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putUnionShape", [value]))

    @jsii.member(jsii_name="resetCircleShape")
    def reset_circle_shape(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCircleShape", []))

    @jsii.member(jsii_name="resetPointShape")
    def reset_point_shape(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPointShape", []))

    @jsii.member(jsii_name="resetPolygonShape")
    def reset_polygon_shape(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPolygonShape", []))

    @jsii.member(jsii_name="resetRectangleShape")
    def reset_rectangle_shape(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRectangleShape", []))

    @jsii.member(jsii_name="resetUnionShape")
    def reset_union_shape(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUnionShape", []))

    @builtins.property
    @jsii.member(jsii_name="circleShape")
    def circle_shape(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestCircleShapeList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestCircleShapeList, jsii.get(self, "circleShape"))

    @builtins.property
    @jsii.member(jsii_name="pointShape")
    def point_shape(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestPointShapeList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestPointShapeList", jsii.get(self, "pointShape"))

    @builtins.property
    @jsii.member(jsii_name="polygonShape")
    def polygon_shape(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestPolygonShapeList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestPolygonShapeList", jsii.get(self, "polygonShape"))

    @builtins.property
    @jsii.member(jsii_name="rectangleShape")
    def rectangle_shape(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestRectangleShapeList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestRectangleShapeList", jsii.get(self, "rectangleShape"))

    @builtins.property
    @jsii.member(jsii_name="unionShape")
    def union_shape(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestUnionShapeList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestUnionShapeList", jsii.get(self, "unionShape"))

    @builtins.property
    @jsii.member(jsii_name="circleShapeInput")
    def circle_shape_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestCircleShape]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestCircleShape]]], jsii.get(self, "circleShapeInput"))

    @builtins.property
    @jsii.member(jsii_name="pointShapeInput")
    def point_shape_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestPointShape"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestPointShape"]]], jsii.get(self, "pointShapeInput"))

    @builtins.property
    @jsii.member(jsii_name="polygonShapeInput")
    def polygon_shape_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestPolygonShape"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestPolygonShape"]]], jsii.get(self, "polygonShapeInput"))

    @builtins.property
    @jsii.member(jsii_name="rectangleShapeInput")
    def rectangle_shape_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestRectangleShape"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestRectangleShape"]]], jsii.get(self, "rectangleShapeInput"))

    @builtins.property
    @jsii.member(jsii_name="unionShapeInput")
    def union_shape_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestUnionShape"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestUnionShape"]]], jsii.get(self, "unionShapeInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterest]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterest], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterest],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9090ef4633b4292536657643fe63ddeaae4faf7fba3a521e9b8b60aa558b04c1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestPointShape",
    jsii_struct_bases=[],
    name_mapping={"x": "x", "x_var": "xVar", "y": "y", "y_var": "yVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestPointShape:
    def __init__(
        self,
        *,
        x: typing.Optional[builtins.str] = None,
        x_var: typing.Optional[builtins.str] = None,
        y: typing.Optional[builtins.str] = None,
        y_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param x: The horizontal position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x DataAkamaiImagingPolicyImage#x}
        :param x_var: The horizontal position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_var DataAkamaiImagingPolicyImage#x_var}
        :param y: The vertical position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y DataAkamaiImagingPolicyImage#y}
        :param y_var: The vertical position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_var DataAkamaiImagingPolicyImage#y_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__439af0716a1ffdf1e04cd1f195d66077c8ba682243b9231ee503fd3141515e5e)
            check_type(argname="argument x", value=x, expected_type=type_hints["x"])
            check_type(argname="argument x_var", value=x_var, expected_type=type_hints["x_var"])
            check_type(argname="argument y", value=y, expected_type=type_hints["y"])
            check_type(argname="argument y_var", value=y_var, expected_type=type_hints["y_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if x is not None:
            self._values["x"] = x
        if x_var is not None:
            self._values["x_var"] = x_var
        if y is not None:
            self._values["y"] = y
        if y_var is not None:
            self._values["y_var"] = y_var

    @builtins.property
    def x(self) -> typing.Optional[builtins.str]:
        '''The horizontal position of the point, measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x DataAkamaiImagingPolicyImage#x}
        '''
        result = self._values.get("x")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_var(self) -> typing.Optional[builtins.str]:
        '''The horizontal position of the point, measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_var DataAkamaiImagingPolicyImage#x_var}
        '''
        result = self._values.get("x_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y(self) -> typing.Optional[builtins.str]:
        '''The vertical position of the point, measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y DataAkamaiImagingPolicyImage#y}
        '''
        result = self._values.get("y")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_var(self) -> typing.Optional[builtins.str]:
        '''The vertical position of the point, measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_var DataAkamaiImagingPolicyImage#y_var}
        '''
        result = self._values.get("y_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestPointShape(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestPointShapeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestPointShapeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2da6478692df3342da4a1cd2c957f698619e6697b666ee9d551e268f7b1b7cb7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestPointShapeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__241295580401790a8fa12ae38d2e5b6ca5837237e73889bb0d7adf90abbd535d)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestPointShapeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5c2be4ff83f6fcfc3237f8f6a0ff4981173a6efe362b9742a127f33b15551b31)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aa99d253d2d5e0d3e87ac4ecf5686546333b3111f666a62ee3be18fdf890d5d4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fac4e202a95c0fbceac8f984527ad851a733123af80e722955a7acb6912dfd2f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestPointShape]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestPointShape]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestPointShape]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f07bd417f30e28cc4c109d4aac24c1efcfaf52b09ee82a917e929c8224b6cfd7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestPointShapeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestPointShapeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__612b858e5f9cc078bde381e98ed44a244f510a7d6a2fc2775792261a7a162c64)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetX")
    def reset_x(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetX", []))

    @jsii.member(jsii_name="resetXVar")
    def reset_x_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXVar", []))

    @jsii.member(jsii_name="resetY")
    def reset_y(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetY", []))

    @jsii.member(jsii_name="resetYVar")
    def reset_y_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYVar", []))

    @builtins.property
    @jsii.member(jsii_name="xInput")
    def x_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xInput"))

    @builtins.property
    @jsii.member(jsii_name="xVarInput")
    def x_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yInput")
    def y_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yInput"))

    @builtins.property
    @jsii.member(jsii_name="yVarInput")
    def y_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yVarInput"))

    @builtins.property
    @jsii.member(jsii_name="x")
    def x(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "x"))

    @x.setter
    def x(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b8c0fc1b30358acf71e92abe8338becc35185f0203941c8b3b747b2202a014df)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "x", value)

    @builtins.property
    @jsii.member(jsii_name="xVar")
    def x_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xVar"))

    @x_var.setter
    def x_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d18763f6442020eefe26175889328c6042700f7f32dedd2d971279e2b6d3f9fd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xVar", value)

    @builtins.property
    @jsii.member(jsii_name="y")
    def y(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "y"))

    @y.setter
    def y(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4f251edc362f2e939a67694e71760e046b10475b2cee9fb7b7a214c1dcff92c4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "y", value)

    @builtins.property
    @jsii.member(jsii_name="yVar")
    def y_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yVar"))

    @y_var.setter
    def y_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fd30003a8a8c0caea8946211028fd7496b5e444ed6c3c3e41fa5e3e1360736e4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestPointShape]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestPointShape]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestPointShape]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d08ba549ea0a4bb7228d584d96ca47dba143fd55b43d73375581b9f59b5714fe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestPolygonShape",
    jsii_struct_bases=[],
    name_mapping={"points": "points"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestPolygonShape:
    def __init__(
        self,
        *,
        points: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestPolygonShapePoints", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param points: points block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#points DataAkamaiImagingPolicyImage#points}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cecf1f13252a9ed3d7679fa3ee2b76beece5763daef70f1bae6a41df5680eafa)
            check_type(argname="argument points", value=points, expected_type=type_hints["points"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "points": points,
        }

    @builtins.property
    def points(
        self,
    ) -> typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestPolygonShapePoints"]]:
        '''points block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#points DataAkamaiImagingPolicyImage#points}
        '''
        result = self._values.get("points")
        assert result is not None, "Required property 'points' is missing"
        return typing.cast(typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestPolygonShapePoints"]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestPolygonShape(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestPolygonShapeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestPolygonShapeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a3b62fa26938774a40d00d958b93dd8823d5b2db3111c8847e7ffcc6a7be5730)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestPolygonShapeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fb7a46b71115706192a8370cccaa6ea02e7c34be15ddd9bca43b04cb7382bf63)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestPolygonShapeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2b39f27be8591e0a1d6c1c1de5242f198f7260473b586eafed54a52ad09a8191)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a6b6ebb363c77b485f269f4d8f1f50dbbc6ccf5f89ba690009d2a4e92de04315)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a6844098e5831cba4c682cc615f5018b16446b00084a53ac7bc15b30f9e5087d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestPolygonShape]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestPolygonShape]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestPolygonShape]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6b093c962ea40414026292e823731ac63a087974b52fc4c7dd1c1442bed21353)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestPolygonShapeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestPolygonShapeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3d61df490307636cccb19a347925e83971ec8a90fdcae7c5ff3430201372d727)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putPoints")
    def put_points(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestPolygonShapePoints", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f4107813e3455e0f6a2c85548e2caa124e77247018d4ebc7fe9f376121f960da)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putPoints", [value]))

    @builtins.property
    @jsii.member(jsii_name="points")
    def points(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestPolygonShapePointsList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestPolygonShapePointsList", jsii.get(self, "points"))

    @builtins.property
    @jsii.member(jsii_name="pointsInput")
    def points_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestPolygonShapePoints"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestPolygonShapePoints"]]], jsii.get(self, "pointsInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestPolygonShape]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestPolygonShape]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestPolygonShape]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__beffec9159927bf495416f2306054afbacbd338f5da187d9e42aafb21b31438a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestPolygonShapePoints",
    jsii_struct_bases=[],
    name_mapping={"x": "x", "x_var": "xVar", "y": "y", "y_var": "yVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestPolygonShapePoints:
    def __init__(
        self,
        *,
        x: typing.Optional[builtins.str] = None,
        x_var: typing.Optional[builtins.str] = None,
        y: typing.Optional[builtins.str] = None,
        y_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param x: The horizontal position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x DataAkamaiImagingPolicyImage#x}
        :param x_var: The horizontal position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_var DataAkamaiImagingPolicyImage#x_var}
        :param y: The vertical position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y DataAkamaiImagingPolicyImage#y}
        :param y_var: The vertical position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_var DataAkamaiImagingPolicyImage#y_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b3f30fad3e862e9952a8ca96f40763b7a1fc837d130ec8925bc546d775d474c7)
            check_type(argname="argument x", value=x, expected_type=type_hints["x"])
            check_type(argname="argument x_var", value=x_var, expected_type=type_hints["x_var"])
            check_type(argname="argument y", value=y, expected_type=type_hints["y"])
            check_type(argname="argument y_var", value=y_var, expected_type=type_hints["y_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if x is not None:
            self._values["x"] = x
        if x_var is not None:
            self._values["x_var"] = x_var
        if y is not None:
            self._values["y"] = y
        if y_var is not None:
            self._values["y_var"] = y_var

    @builtins.property
    def x(self) -> typing.Optional[builtins.str]:
        '''The horizontal position of the point, measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x DataAkamaiImagingPolicyImage#x}
        '''
        result = self._values.get("x")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_var(self) -> typing.Optional[builtins.str]:
        '''The horizontal position of the point, measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_var DataAkamaiImagingPolicyImage#x_var}
        '''
        result = self._values.get("x_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y(self) -> typing.Optional[builtins.str]:
        '''The vertical position of the point, measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y DataAkamaiImagingPolicyImage#y}
        '''
        result = self._values.get("y")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_var(self) -> typing.Optional[builtins.str]:
        '''The vertical position of the point, measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_var DataAkamaiImagingPolicyImage#y_var}
        '''
        result = self._values.get("y_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestPolygonShapePoints(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestPolygonShapePointsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestPolygonShapePointsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dc35960eb4860a8eb2ae8941c720ce860d3282f5a9f0ed3dfeea8fe9b3d1ad75)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestPolygonShapePointsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b53c69c6a6557fb1182fca5208640853144194b0f9e0b71db7a70aa6a1efa079)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestPolygonShapePointsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa6f49defae85e6302773aadd2428ad1e2771866cefa6f4b5985ff57a1768bf4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0579440f6f3902e8ad9349159ab60f0926efc5c3d92eec890396dac0236dd475)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df55888ba31a17e547c306bcbe3561c31a197bb29a3384b3114e327b330f13be)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestPolygonShapePoints]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestPolygonShapePoints]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestPolygonShapePoints]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__81c539bc2e283dbf99cddb76fb1d9ce8bc7cbd4e6c76cec6761c455cad939d9b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestPolygonShapePointsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestPolygonShapePointsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dd2f13430d2bc02dfa30c033a008c2da8c4fae90e351f548003ca3c337d9a9fa)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetX")
    def reset_x(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetX", []))

    @jsii.member(jsii_name="resetXVar")
    def reset_x_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXVar", []))

    @jsii.member(jsii_name="resetY")
    def reset_y(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetY", []))

    @jsii.member(jsii_name="resetYVar")
    def reset_y_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYVar", []))

    @builtins.property
    @jsii.member(jsii_name="xInput")
    def x_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xInput"))

    @builtins.property
    @jsii.member(jsii_name="xVarInput")
    def x_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yInput")
    def y_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yInput"))

    @builtins.property
    @jsii.member(jsii_name="yVarInput")
    def y_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yVarInput"))

    @builtins.property
    @jsii.member(jsii_name="x")
    def x(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "x"))

    @x.setter
    def x(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__444014732fa14cde1a4237064575f53325cff0018d09117310f4aa0be147d8b0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "x", value)

    @builtins.property
    @jsii.member(jsii_name="xVar")
    def x_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xVar"))

    @x_var.setter
    def x_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0146199476089e5736e20c1ec7ecc88894994812948f80870605c5baa45cb810)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xVar", value)

    @builtins.property
    @jsii.member(jsii_name="y")
    def y(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "y"))

    @y.setter
    def y(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__26872b97f7df504e582a7921c20954c1c56618857853f5d3d81ad0eaefd66f5b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "y", value)

    @builtins.property
    @jsii.member(jsii_name="yVar")
    def y_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yVar"))

    @y_var.setter
    def y_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e25122df00b4b33939ae5efb246518d4726f280a45e03255d69c70cc7961c6f1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestPolygonShapePoints]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestPolygonShapePoints]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestPolygonShapePoints]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4d3d6d2abccec6dfa366a61e57078269aead7adcfba177924046a90ea52c76dd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestRectangleShape",
    jsii_struct_bases=[],
    name_mapping={
        "anchor": "anchor",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestRectangleShape:
    def __init__(
        self,
        *,
        anchor: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestRectangleShapeAnchor", typing.Dict[builtins.str, typing.Any]],
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param anchor: anchor block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#anchor DataAkamaiImagingPolicyImage#anchor}
        :param height: Extends the rectangle down from the ``anchor`` point. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: Extends the rectangle down from the ``anchor`` point. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: Extends the rectangle right from the ``anchor`` point. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: Extends the rectangle right from the ``anchor`` point. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(anchor, dict):
            anchor = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestRectangleShapeAnchor(**anchor)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__612ea71420f98a158cbadeb92a9821844fa2a5ff8145b23bde8071989d8eb65c)
            check_type(argname="argument anchor", value=anchor, expected_type=type_hints["anchor"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "anchor": anchor,
        }
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def anchor(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestRectangleShapeAnchor":
        '''anchor block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#anchor DataAkamaiImagingPolicyImage#anchor}
        '''
        result = self._values.get("anchor")
        assert result is not None, "Required property 'anchor' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestRectangleShapeAnchor", result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''Extends the rectangle down from the ``anchor`` point.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''Extends the rectangle down from the ``anchor`` point.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''Extends the rectangle right from the ``anchor`` point.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''Extends the rectangle right from the ``anchor`` point.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestRectangleShape(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestRectangleShapeAnchor",
    jsii_struct_bases=[],
    name_mapping={"x": "x", "x_var": "xVar", "y": "y", "y_var": "yVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestRectangleShapeAnchor:
    def __init__(
        self,
        *,
        x: typing.Optional[builtins.str] = None,
        x_var: typing.Optional[builtins.str] = None,
        y: typing.Optional[builtins.str] = None,
        y_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param x: The horizontal position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x DataAkamaiImagingPolicyImage#x}
        :param x_var: The horizontal position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_var DataAkamaiImagingPolicyImage#x_var}
        :param y: The vertical position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y DataAkamaiImagingPolicyImage#y}
        :param y_var: The vertical position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_var DataAkamaiImagingPolicyImage#y_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ebda6bd8d950f5f3604682b20bacd36135399997adf0a5b9eec75e303a08c387)
            check_type(argname="argument x", value=x, expected_type=type_hints["x"])
            check_type(argname="argument x_var", value=x_var, expected_type=type_hints["x_var"])
            check_type(argname="argument y", value=y, expected_type=type_hints["y"])
            check_type(argname="argument y_var", value=y_var, expected_type=type_hints["y_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if x is not None:
            self._values["x"] = x
        if x_var is not None:
            self._values["x_var"] = x_var
        if y is not None:
            self._values["y"] = y
        if y_var is not None:
            self._values["y_var"] = y_var

    @builtins.property
    def x(self) -> typing.Optional[builtins.str]:
        '''The horizontal position of the point, measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x DataAkamaiImagingPolicyImage#x}
        '''
        result = self._values.get("x")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_var(self) -> typing.Optional[builtins.str]:
        '''The horizontal position of the point, measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_var DataAkamaiImagingPolicyImage#x_var}
        '''
        result = self._values.get("x_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y(self) -> typing.Optional[builtins.str]:
        '''The vertical position of the point, measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y DataAkamaiImagingPolicyImage#y}
        '''
        result = self._values.get("y")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_var(self) -> typing.Optional[builtins.str]:
        '''The vertical position of the point, measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_var DataAkamaiImagingPolicyImage#y_var}
        '''
        result = self._values.get("y_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestRectangleShapeAnchor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestRectangleShapeAnchorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestRectangleShapeAnchorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a4d2da7d7e43aa843b759afc9c1bbeb90bc5359b590b218cfa12d4c9b96d7d5e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetX")
    def reset_x(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetX", []))

    @jsii.member(jsii_name="resetXVar")
    def reset_x_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXVar", []))

    @jsii.member(jsii_name="resetY")
    def reset_y(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetY", []))

    @jsii.member(jsii_name="resetYVar")
    def reset_y_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYVar", []))

    @builtins.property
    @jsii.member(jsii_name="xInput")
    def x_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xInput"))

    @builtins.property
    @jsii.member(jsii_name="xVarInput")
    def x_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yInput")
    def y_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yInput"))

    @builtins.property
    @jsii.member(jsii_name="yVarInput")
    def y_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yVarInput"))

    @builtins.property
    @jsii.member(jsii_name="x")
    def x(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "x"))

    @x.setter
    def x(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f629af02e89af35bb32a9aba3dce034c7ad6ffecea2f5196fa7a2d4d8c40063)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "x", value)

    @builtins.property
    @jsii.member(jsii_name="xVar")
    def x_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xVar"))

    @x_var.setter
    def x_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aebd8b7a5a2e5853ab6fb5962cad2cdc0324a71c3dbd990ef0c9dfc2634ecb83)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xVar", value)

    @builtins.property
    @jsii.member(jsii_name="y")
    def y(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "y"))

    @y.setter
    def y(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1daf198a9aee7aa81d5d5877cbbcb584de33e5806aaa3e8e2b987f3f33f7150d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "y", value)

    @builtins.property
    @jsii.member(jsii_name="yVar")
    def y_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yVar"))

    @y_var.setter
    def y_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ebe9e7006e196adab6070ad61766c303bb10b8faa5c51b3eef7a911a6d81b01)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestRectangleShapeAnchor]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestRectangleShapeAnchor], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestRectangleShapeAnchor],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b177f2246ba4999d0b92d84d94ff2d5fcc47861c9afea86dc52ccc7da65a27ac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestRectangleShapeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestRectangleShapeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__51c18d44e450dbf5ef6a2651d33c92f72efc28d0bd45dba2ec9f218f440cc765)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestRectangleShapeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ee208d96a408143416a381eeb92a4aaedaa04ea7b7702eba4547779b89262848)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestRectangleShapeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__59d49462f04e07a5bcfdd120f0680881cf5b400558e282450c20b14a92dacce2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b9ade7abb19d9c2177f360e82640fd79735375c2cc7d307212b0fca1e1da66e4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__de7580fa3473b5ec248e135971911908bab7d5063ea962548c18fdd405276e85)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestRectangleShape]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestRectangleShape]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestRectangleShape]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b3facac74e4719c09b3e3d997cbe97a4ac3640599aea7579a5ba2e6d4d8a66dd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestRectangleShapeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestRectangleShapeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0490aa205e38db99e0f8d3051894802d1febdb9c5f31f1753a9e07170b59a77b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putAnchor")
    def put_anchor(
        self,
        *,
        x: typing.Optional[builtins.str] = None,
        x_var: typing.Optional[builtins.str] = None,
        y: typing.Optional[builtins.str] = None,
        y_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param x: The horizontal position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x DataAkamaiImagingPolicyImage#x}
        :param x_var: The horizontal position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_var DataAkamaiImagingPolicyImage#x_var}
        :param y: The vertical position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y DataAkamaiImagingPolicyImage#y}
        :param y_var: The vertical position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_var DataAkamaiImagingPolicyImage#y_var}
        '''
        value = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestRectangleShapeAnchor(
            x=x, x_var=x_var, y=y, y_var=y_var
        )

        return typing.cast(None, jsii.invoke(self, "putAnchor", [value]))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="anchor")
    def anchor(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestRectangleShapeAnchorOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestRectangleShapeAnchorOutputReference, jsii.get(self, "anchor"))

    @builtins.property
    @jsii.member(jsii_name="anchorInput")
    def anchor_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestRectangleShapeAnchor]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestRectangleShapeAnchor], jsii.get(self, "anchorInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3f16594f9682af22a7f8639744023f99c14fe0667cd6dd7e5820405d462da10e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9e332b68fe1e4a9324f7fe7d2e0004cf5bce6a59d29be33951c8fef306186086)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__75438a2bd922227807385d293638dace84290f550b94d55b7bdc9aa5b411f206)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb20deb1023201d2c4d6d7781bd8bbcddb733eb8bb0f2566cded59560fc402bc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestRectangleShape]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestRectangleShape]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestRectangleShape]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__847a56fb4ae9033b9fcc3397291a4f29120a31f269f7bf46bc8695e38d0044b3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestUnionShape",
    jsii_struct_bases=[],
    name_mapping={"shapes": "shapes"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestUnionShape:
    def __init__(
        self,
        *,
        shapes: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestUnionShapeShapes", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param shapes: shapes block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shapes DataAkamaiImagingPolicyImage#shapes}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__daba4e5cc735145aa91412dcafe5dbe867ff7fbff0d63565dd0c7e377457ba68)
            check_type(argname="argument shapes", value=shapes, expected_type=type_hints["shapes"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "shapes": shapes,
        }

    @builtins.property
    def shapes(
        self,
    ) -> typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestUnionShapeShapes"]]:
        '''shapes block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shapes DataAkamaiImagingPolicyImage#shapes}
        '''
        result = self._values.get("shapes")
        assert result is not None, "Required property 'shapes' is missing"
        return typing.cast(typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestUnionShapeShapes"]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestUnionShape(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestUnionShapeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestUnionShapeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__916739f2e3187e162dec9504a1d27525a27b2d5f5a16f4553514fafd97e83c88)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestUnionShapeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3080fa9b60dd94d309e1187656a45cd4aa292d5130ea72ab9d4abbe91b32c68f)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestUnionShapeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6664cdea50ebfdd97b7904be30a7d52ebf29f2568ebabef8d7d3d8609887629a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6c308846bcae6b953e566e67b72128abadce4109be20ba3472341bd934388a0c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6ab394d981536d91f85a287f79af7099546746cf0adb2a7e22f84d0ac67dba0c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestUnionShape]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestUnionShape]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestUnionShape]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__715f7449852beb27c5359c47e1730c8658d997a8a0c61198650d55cd7fea6a26)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestUnionShapeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestUnionShapeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1999934b4388f0cd93614584b0aafca07e6cf428f409140d4778a2c3ac85d34a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putShapes")
    def put_shapes(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestUnionShapeShapes", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a5b67d9da7bdb3b7f9a3e0b3c27af4c4fc0499ebddeeeea079c3259c4a63a62b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putShapes", [value]))

    @builtins.property
    @jsii.member(jsii_name="shapes")
    def shapes(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestUnionShapeShapesList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestUnionShapeShapesList", jsii.get(self, "shapes"))

    @builtins.property
    @jsii.member(jsii_name="shapesInput")
    def shapes_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestUnionShapeShapes"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestUnionShapeShapes"]]], jsii.get(self, "shapesInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestUnionShape]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestUnionShape]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestUnionShape]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__07c9de023e78112e7a2cb6ef842afb43734a2acb4b041f73fcf3f8c301c0c9bf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestUnionShapeShapes",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestUnionShapeShapes:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestUnionShapeShapes(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestUnionShapeShapesList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestUnionShapeShapesList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af3dd3bf21ddb097eba8f82ceeadd7b052b8c4aefe99db8e3f9f2570281c0b83)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestUnionShapeShapesOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__40f41236b1f22a1fa2f1bcd720e951ed4f7a7e5b24b0bf04042fe0a837f5ec4d)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestUnionShapeShapesOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ec1e53199f1dd653f5e64841d0b01d9b8fb8a645a6562371071b6aa8da299d4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__94170e1e99ea9f2a192352eef78913e3b6bf2ce3a1f8fabdcb798d5bfb6631ef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__452e9a6d75b2b390176a44733fe31f67bab498c8a6427206421dbcccfd83ab92)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestUnionShapeShapes]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestUnionShapeShapes]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestUnionShapeShapes]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__29900922f10f713a885c7462360a965f31a84cbc21eef57dce02475b4dde2131)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestUnionShapeShapesOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestUnionShapeShapesOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ad8f8b79f9ac6abbb03d5ab4453349d41f8d9c5013028b9a385b55917af6f5f1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestUnionShapeShapes]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestUnionShapeShapes]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestUnionShapeShapes]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__50a16cc0da85885f19bb70e5fa84884aceb52d6df8ed1fa9dafc66f37f4e3d6a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRelativeCrop",
    jsii_struct_bases=[],
    name_mapping={
        "east": "east",
        "east_var": "eastVar",
        "north": "north",
        "north_var": "northVar",
        "south": "south",
        "south_var": "southVar",
        "west": "west",
        "west_var": "westVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRelativeCrop:
    def __init__(
        self,
        *,
        east: typing.Optional[builtins.str] = None,
        east_var: typing.Optional[builtins.str] = None,
        north: typing.Optional[builtins.str] = None,
        north_var: typing.Optional[builtins.str] = None,
        south: typing.Optional[builtins.str] = None,
        south_var: typing.Optional[builtins.str] = None,
        west: typing.Optional[builtins.str] = None,
        west_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param east: The number of pixels to shrink or expand the right side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east DataAkamaiImagingPolicyImage#east}
        :param east_var: The number of pixels to shrink or expand the right side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east_var DataAkamaiImagingPolicyImage#east_var}
        :param north: The number of pixels to shrink or expand the top side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north DataAkamaiImagingPolicyImage#north}
        :param north_var: The number of pixels to shrink or expand the top side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north_var DataAkamaiImagingPolicyImage#north_var}
        :param south: The number of pixels to shrink or expand the bottom side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south DataAkamaiImagingPolicyImage#south}
        :param south_var: The number of pixels to shrink or expand the bottom side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south_var DataAkamaiImagingPolicyImage#south_var}
        :param west: The number of pixels to shrink or expand the left side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west DataAkamaiImagingPolicyImage#west}
        :param west_var: The number of pixels to shrink or expand the left side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west_var DataAkamaiImagingPolicyImage#west_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__431a0deecd8099ae40223b03afddf4f50f0b8bc148aa01844819bc35d02da00e)
            check_type(argname="argument east", value=east, expected_type=type_hints["east"])
            check_type(argname="argument east_var", value=east_var, expected_type=type_hints["east_var"])
            check_type(argname="argument north", value=north, expected_type=type_hints["north"])
            check_type(argname="argument north_var", value=north_var, expected_type=type_hints["north_var"])
            check_type(argname="argument south", value=south, expected_type=type_hints["south"])
            check_type(argname="argument south_var", value=south_var, expected_type=type_hints["south_var"])
            check_type(argname="argument west", value=west, expected_type=type_hints["west"])
            check_type(argname="argument west_var", value=west_var, expected_type=type_hints["west_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if east is not None:
            self._values["east"] = east
        if east_var is not None:
            self._values["east_var"] = east_var
        if north is not None:
            self._values["north"] = north
        if north_var is not None:
            self._values["north_var"] = north_var
        if south is not None:
            self._values["south"] = south
        if south_var is not None:
            self._values["south_var"] = south_var
        if west is not None:
            self._values["west"] = west
        if west_var is not None:
            self._values["west_var"] = west_var

    @builtins.property
    def east(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the right side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east DataAkamaiImagingPolicyImage#east}
        '''
        result = self._values.get("east")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def east_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the right side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east_var DataAkamaiImagingPolicyImage#east_var}
        '''
        result = self._values.get("east_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def north(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the top side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north DataAkamaiImagingPolicyImage#north}
        '''
        result = self._values.get("north")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def north_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the top side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north_var DataAkamaiImagingPolicyImage#north_var}
        '''
        result = self._values.get("north_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def south(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the bottom side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south DataAkamaiImagingPolicyImage#south}
        '''
        result = self._values.get("south")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def south_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the bottom side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south_var DataAkamaiImagingPolicyImage#south_var}
        '''
        result = self._values.get("south_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def west(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the left side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west DataAkamaiImagingPolicyImage#west}
        '''
        result = self._values.get("west")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def west_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the left side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west_var DataAkamaiImagingPolicyImage#west_var}
        '''
        result = self._values.get("west_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRelativeCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRelativeCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRelativeCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e56045d23239761a79d6408484feb1485e05b8e05135d782f3d78397e39f588)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRelativeCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a9eeb0eb3ed8b4cf0e5d1e3efc6b807139cafc8a0efa9ee77711b2037d12ccf)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRelativeCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__10bf284378b960784201af08916893948abc37d52675c18096ebc62acb5a925e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8c98f03886acb04e9bbaacd8eeb9be0a4d6521b2cee07be2748f17b62f25cd9d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7f5bef4a69e391c44c30632b1ebd0ba09698144a2d192d909ddadf2ef3118f89)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRelativeCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRelativeCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRelativeCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dba6be429cb55c8a0bb6a5ad76237bd39c71ac66adcc35a0401b19eaf94503ac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRelativeCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRelativeCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6ea75d5d15ef4d21d4c2c5bba3a927c51dcf5edce42360ca50b8b2157825ddd4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetEast")
    def reset_east(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEast", []))

    @jsii.member(jsii_name="resetEastVar")
    def reset_east_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEastVar", []))

    @jsii.member(jsii_name="resetNorth")
    def reset_north(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNorth", []))

    @jsii.member(jsii_name="resetNorthVar")
    def reset_north_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNorthVar", []))

    @jsii.member(jsii_name="resetSouth")
    def reset_south(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSouth", []))

    @jsii.member(jsii_name="resetSouthVar")
    def reset_south_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSouthVar", []))

    @jsii.member(jsii_name="resetWest")
    def reset_west(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWest", []))

    @jsii.member(jsii_name="resetWestVar")
    def reset_west_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWestVar", []))

    @builtins.property
    @jsii.member(jsii_name="eastInput")
    def east_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "eastInput"))

    @builtins.property
    @jsii.member(jsii_name="eastVarInput")
    def east_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "eastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="northInput")
    def north_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "northInput"))

    @builtins.property
    @jsii.member(jsii_name="northVarInput")
    def north_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "northVarInput"))

    @builtins.property
    @jsii.member(jsii_name="southInput")
    def south_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "southInput"))

    @builtins.property
    @jsii.member(jsii_name="southVarInput")
    def south_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "southVarInput"))

    @builtins.property
    @jsii.member(jsii_name="westInput")
    def west_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "westInput"))

    @builtins.property
    @jsii.member(jsii_name="westVarInput")
    def west_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "westVarInput"))

    @builtins.property
    @jsii.member(jsii_name="east")
    def east(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "east"))

    @east.setter
    def east(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3db4d5e45811dce14ddaee6243902cb4ae5637ccd6da2aed04ab820a9e73db61)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "east", value)

    @builtins.property
    @jsii.member(jsii_name="eastVar")
    def east_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "eastVar"))

    @east_var.setter
    def east_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e4ed804cfefcedd3679aa86b468a0553aec18e3f4770809f39efc245ac09971f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "eastVar", value)

    @builtins.property
    @jsii.member(jsii_name="north")
    def north(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "north"))

    @north.setter
    def north(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__41f2d6286f6658879f12eadca70aa6de2039de61076ac3cc04a5e9ef2667e8b1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "north", value)

    @builtins.property
    @jsii.member(jsii_name="northVar")
    def north_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "northVar"))

    @north_var.setter
    def north_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0bab876493ff1a4fa3f77ef40f489246421e522d12a3bbf8f385f6e156b63334)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "northVar", value)

    @builtins.property
    @jsii.member(jsii_name="south")
    def south(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "south"))

    @south.setter
    def south(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bbb659c328283c4974bdaddac595039bc98e18efa541e706fabb58de03a183d3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "south", value)

    @builtins.property
    @jsii.member(jsii_name="southVar")
    def south_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "southVar"))

    @south_var.setter
    def south_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cfc05cf09631fd0e9d7f7852786b2f59b3d365ecba30722339d63d2061af198f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "southVar", value)

    @builtins.property
    @jsii.member(jsii_name="west")
    def west(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "west"))

    @west.setter
    def west(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3c1915aaf58b0af5c2a5b97a63afc7cb1562584f1b7da48fdaf1607012191395)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "west", value)

    @builtins.property
    @jsii.member(jsii_name="westVar")
    def west_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "westVar"))

    @west_var.setter
    def west_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dd641ee54f70fcc7ef09a00aa34418bcf282214df4a1a6112d3338607f97f8ab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "westVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRelativeCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRelativeCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRelativeCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__51525bdbd2944b06e2ae551d4a391c5cb48d183895f27ddd34014ea37b1ed0ed)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRemoveColor",
    jsii_struct_bases=[],
    name_mapping={
        "color": "color",
        "color_var": "colorVar",
        "feather": "feather",
        "feather_var": "featherVar",
        "tolerance": "tolerance",
        "tolerance_var": "toleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRemoveColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
        feather: typing.Optional[builtins.str] = None,
        feather_var: typing.Optional[builtins.str] = None,
        tolerance: typing.Optional[builtins.str] = None,
        tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        :param feather: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        :param feather_var: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        :param tolerance: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        :param tolerance_var: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__71ed4624b399323897ea53284619ec2e13322fe8b27fe6e004ac6e66ffca3625)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
            check_type(argname="argument feather", value=feather, expected_type=type_hints["feather"])
            check_type(argname="argument feather_var", value=feather_var, expected_type=type_hints["feather_var"])
            check_type(argname="argument tolerance", value=tolerance, expected_type=type_hints["tolerance"])
            check_type(argname="argument tolerance_var", value=tolerance_var, expected_type=type_hints["tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var
        if feather is not None:
            self._values["feather"] = feather
        if feather_var is not None:
            self._values["feather_var"] = feather_var
        if tolerance is not None:
            self._values["tolerance"] = tolerance
        if tolerance_var is not None:
            self._values["tolerance_var"] = tolerance_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        '''
        result = self._values.get("feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather_var(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        '''
        result = self._values.get("feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        '''
        result = self._values.get("tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance_var(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        result = self._values.get("tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRemoveColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRemoveColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRemoveColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c454795ce09b1b50eef945032ac5bbcd170c001b660693a6a7735127543af4d7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRemoveColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c07d5772d734aa2a1662f3c1f865f53622a94dd53eaf64a305bac363fb164ca2)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRemoveColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8c9b4d9b6696d1b96ba845e021b00f9804ff52b37d1442432f41870fb8468db9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b4a8bff502241145bd8f9d1f0b661431e1d47b28033a560c1eed39893702acb1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__79bc48a7072a27e8254806efcafe489c10553b905323d5f94b19cc044d037be5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRemoveColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRemoveColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRemoveColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__09c8971465ed8c5be63de808e25c8140646f956c9863c86678b31d5a99c3d708)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRemoveColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRemoveColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__95e46215850a8aeb02bc63e2f7651b87ced0024baf019692486bdfd4b6f2cc54)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @jsii.member(jsii_name="resetFeather")
    def reset_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeather", []))

    @jsii.member(jsii_name="resetFeatherVar")
    def reset_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatherVar", []))

    @jsii.member(jsii_name="resetTolerance")
    def reset_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTolerance", []))

    @jsii.member(jsii_name="resetToleranceVar")
    def reset_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featherInput")
    def feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherInput"))

    @builtins.property
    @jsii.member(jsii_name="featherVarInput")
    def feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceInput")
    def tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceVarInput")
    def tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f32f1f9e19dccc627d1e3378f57ca6d8e143a8b141585154b1a0bf815b3db1c5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d09756e6713c7f547fcbba74dd4c5225b03a994ad4ae3be754bd503b52b8d2c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="feather")
    def feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "feather"))

    @feather.setter
    def feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6ab9ce6c0c0305b4623c0cc7a4249e0049a9ec2e841f9f4b4355c2a56ae8c628)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "feather", value)

    @builtins.property
    @jsii.member(jsii_name="featherVar")
    def feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featherVar"))

    @feather_var.setter
    def feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0aadcb5ddeccc76f027f329ec02de2a07c28161a175e3d4a13fd30fb72e7e6b1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featherVar", value)

    @builtins.property
    @jsii.member(jsii_name="tolerance")
    def tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tolerance"))

    @tolerance.setter
    def tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1e0d9917bc0c7a8b0118d9ecf4638d9a3759ab3b36b4a3e02018d11c572516d2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tolerance", value)

    @builtins.property
    @jsii.member(jsii_name="toleranceVar")
    def tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "toleranceVar"))

    @tolerance_var.setter
    def tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b6534d583ea9c6dfa9c7977190a40843e26de7a977052325f0ee7c704b6d122e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "toleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRemoveColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRemoveColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRemoveColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7476d3cca83ec059a60f6bb751b9dfe08436b86900fc2cd6d8f7a258689526a8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationResize",
    jsii_struct_bases=[],
    name_mapping={
        "aspect": "aspect",
        "aspect_var": "aspectVar",
        "height": "height",
        "height_var": "heightVar",
        "type": "type",
        "type_var": "typeVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationResize:
    def __init__(
        self,
        *,
        aspect: typing.Optional[builtins.str] = None,
        aspect_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param aspect: Preserves the aspect ratio. Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect DataAkamaiImagingPolicyImage#aspect}
        :param aspect_var: Preserves the aspect ratio. Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_var DataAkamaiImagingPolicyImage#aspect_var}
        :param height: The height to resize the source image to. Must be set if height is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height to resize the source image to. Must be set if height is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param type: Sets constraints for the image resize. Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: Sets constraints for the image resize. Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        :param width: The width to resize the source image to. Must be set if width is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width to resize the source image to. Must be set if width is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0c134db870c76fd3055ffdc17765d3a74ad5052aae3ce75cad56fea817dd1e95)
            check_type(argname="argument aspect", value=aspect, expected_type=type_hints["aspect"])
            check_type(argname="argument aspect_var", value=aspect_var, expected_type=type_hints["aspect_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if aspect is not None:
            self._values["aspect"] = aspect
        if aspect_var is not None:
            self._values["aspect_var"] = aspect_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def aspect(self) -> typing.Optional[builtins.str]:
        '''Preserves the aspect ratio.

        Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect DataAkamaiImagingPolicyImage#aspect}
        '''
        result = self._values.get("aspect")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def aspect_var(self) -> typing.Optional[builtins.str]:
        '''Preserves the aspect ratio.

        Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_var DataAkamaiImagingPolicyImage#aspect_var}
        '''
        result = self._values.get("aspect_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height to resize the source image to. Must be set if height is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height to resize the source image to. Must be set if height is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''Sets constraints for the image resize.

        Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''Sets constraints for the image resize.

        Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width to resize the source image to. Must be set if width is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width to resize the source image to. Must be set if width is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationResize(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationResizeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationResizeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fdb4a6917e4fc9ca9772d612b7455acdc1a74a3f24e0e7db26c39cb7f35e3f96)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationResizeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__47dba2466dba7ff7593794255e63d59e3a886f9907f1ac272d3eaac77804af01)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationResizeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c60ef49dc60fe3f05ebffdba9de0cfd7e56bdc04f333507cb6459e622286eb7a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea7d95ca10c0e64c02f572842ef49d7dd71c73a553dd300f67066b3f6da52577)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc1303bde7ea6f7101a003d3d88bb252007a1c745f2ceafa65f7033e200419b2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationResize]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationResize]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationResize]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__31ff4444e4795cc86da0a812df451384fa36a24841eaeb518649ded0ad70f77c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationResizeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationResizeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__204ed070c5aec9e0e0edb8d2676d20a66cc8a8f75b0d52026f2b3ba71baef78c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAspect")
    def reset_aspect(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspect", []))

    @jsii.member(jsii_name="resetAspectVar")
    def reset_aspect_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspectVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="aspectInput")
    def aspect_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "aspectInput"))

    @builtins.property
    @jsii.member(jsii_name="aspectVarInput")
    def aspect_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "aspectVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="aspect")
    def aspect(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "aspect"))

    @aspect.setter
    def aspect(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__85477db25ec170f80596c1fdeb976850cd0070eb0ef715cb22ea82f293fceb8d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "aspect", value)

    @builtins.property
    @jsii.member(jsii_name="aspectVar")
    def aspect_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "aspectVar"))

    @aspect_var.setter
    def aspect_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__faa75776429aff9704b4114cbdfd203342b7f56fbce9ae88e1ce3544b4676e48)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "aspectVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__34e4c270f700932efc5de149f34b54c43da19395cdfed9d211a774137520871c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6d6cb415175361011d8da7f3370c0da76b242d03f37ec8a1fdef925aeb960337)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c0418b401dc2df382d6b95745bca095dc8328626d4b57c39a3f721f682817d9d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6603cf5146730d480d1d72d787d6a712de6cf8c6d1cdafdb3e283c21a0696fe8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__833fce7132fd95afeb2ab3a8edea0161cca96b9a9ecd1b0321466513c0a4a20e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5c658b1cf38d6c0da1d7769ff498d50d17eeaacd4dd88e2f024ab18162974b7c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationResize]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationResize]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationResize]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8be1eb5886e99a1412ace0db201ce54223f32b1ec8e53b5f7545be03b24cf0a9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRotate",
    jsii_struct_bases=[],
    name_mapping={"degrees": "degrees", "degrees_var": "degreesVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRotate:
    def __init__(
        self,
        *,
        degrees: typing.Optional[builtins.str] = None,
        degrees_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param degrees: The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees DataAkamaiImagingPolicyImage#degrees}
        :param degrees_var: The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees_var DataAkamaiImagingPolicyImage#degrees_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cb19e92b38083599d1ebb2586ee3e3befb22c66e2c4fbf15e69c6b1fb909cf0d)
            check_type(argname="argument degrees", value=degrees, expected_type=type_hints["degrees"])
            check_type(argname="argument degrees_var", value=degrees_var, expected_type=type_hints["degrees_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if degrees is not None:
            self._values["degrees"] = degrees
        if degrees_var is not None:
            self._values["degrees_var"] = degrees_var

    @builtins.property
    def degrees(self) -> typing.Optional[builtins.str]:
        '''The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees DataAkamaiImagingPolicyImage#degrees}
        '''
        result = self._values.get("degrees")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def degrees_var(self) -> typing.Optional[builtins.str]:
        '''The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees_var DataAkamaiImagingPolicyImage#degrees_var}
        '''
        result = self._values.get("degrees_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRotate(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRotateList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRotateList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7deece1cec1e562e4a6c9ffb463eb24fbcbec3a5a9116bc931e159a3bebf4c0c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRotateOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__57f05ffe6ae1fc30ec7102964b89aea0de635709416d0e9f42c77ac82356937d)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRotateOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8120b7b5ff8327c46c0450d235d917299c7ecaccec0d38f573be44644d49292b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__59632e511afe62e9e616eb8559d83204d543aea160a22b9bcb2728968d35aa24)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9f792931ee37b5c7139cc72979a8ccd7b4a004519dbee0600c422069b4a6f7fe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRotate]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRotate]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRotate]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__403f22ebc5c03010f9fb7eff2852256cfb2181dabc6ecf136ec7f3861a7f4f15)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRotateOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRotateOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fc6b838e58da5b36f57fa49ba1e6fa98457eb519043f184cf8837e991fe73ac5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetDegrees")
    def reset_degrees(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDegrees", []))

    @jsii.member(jsii_name="resetDegreesVar")
    def reset_degrees_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDegreesVar", []))

    @builtins.property
    @jsii.member(jsii_name="degreesInput")
    def degrees_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "degreesInput"))

    @builtins.property
    @jsii.member(jsii_name="degreesVarInput")
    def degrees_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "degreesVarInput"))

    @builtins.property
    @jsii.member(jsii_name="degrees")
    def degrees(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "degrees"))

    @degrees.setter
    def degrees(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d83519acb42803447b1baf1c52563e8a63145a4159466fdf34e9e0f35c4aac43)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "degrees", value)

    @builtins.property
    @jsii.member(jsii_name="degreesVar")
    def degrees_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "degreesVar"))

    @degrees_var.setter
    def degrees_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d9d4905b068e6bdc09f7b6c39fe660d47cedef878d312a8cfa112251472e8b63)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "degreesVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRotate]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRotate]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRotate]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7f288669488741be195735b872fe801c0fe487ea6fe6903e903b9546f2de7680)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationScale",
    jsii_struct_bases=[],
    name_mapping={
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationScale:
    def __init__(
        self,
        *,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param height: Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged. Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged. Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f1f96c1a361fc4b36f52b84ad79e581d7859f52dbf9d33c740cbbdd6bceb5f24)
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size.

        Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size.

        Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged.

        Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged.

        Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationScale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationScaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationScaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__16231d23fbc8774e8e3d37ab53a1e9be4794a62a75b6c2739110234045ad07e8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationScaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c634dd2778f5ac637e000de156b2f9fa14f26f8d15556d70fbb27b320f058aeb)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationScaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fb2291ff687024df2fc43f2f96e7aaf6036124e6d68dc02e7fa4660270e0a066)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6be5ac4e936c221d98cb5b0f2904aea9963820d7e215526e7cf9a92322a478ec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f4400327b826c16d9439e3b0eda5136fc03559ca39282b32f7dde8afffafe24c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationScale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationScale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationScale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__affaca59428f6073fdb4a8f2991c159b34453117b8f398f23cd5fc4dd5f50ca3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationScaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationScaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bd7de7ba6b9dd34926c15c8b5a05869ae478152b51ec7bdf116c7f683e23993c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab2a7be06389ee57421c4bc2a40ea6891bb12dde949a9a98ad17290157130a60)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e6fe17e580cc685e59389f89b915008990079407893e289356b55fba34bd6ba9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__20a034343a488f2a7d28aa742931c131baf1973b2a4a10932fd063fa236cee27)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__52d905d1de7e4ce659c4761950aa0586a2ddee665093345c37c592bd784af310)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationScale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationScale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationScale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6636d64fb25d48b7f6db3c40cca818348d71e22779b39b710d655c806f981530)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationShear",
    jsii_struct_bases=[],
    name_mapping={
        "x_shear": "xShear",
        "x_shear_var": "xShearVar",
        "y_shear": "yShear",
        "y_shear_var": "yShearVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationShear:
    def __init__(
        self,
        *,
        x_shear: typing.Optional[builtins.str] = None,
        x_shear_var: typing.Optional[builtins.str] = None,
        y_shear: typing.Optional[builtins.str] = None,
        y_shear_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param x_shear: The amount to shear along the x-axis, measured in multiples of the image's width. Must be set if yShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear DataAkamaiImagingPolicyImage#x_shear}
        :param x_shear_var: The amount to shear along the x-axis, measured in multiples of the image's width. Must be set if yShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear_var DataAkamaiImagingPolicyImage#x_shear_var}
        :param y_shear: The amount to shear along the y-axis, measured in multiples of the image's height. Must be set if xShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear DataAkamaiImagingPolicyImage#y_shear}
        :param y_shear_var: The amount to shear along the y-axis, measured in multiples of the image's height. Must be set if xShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear_var DataAkamaiImagingPolicyImage#y_shear_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a6b08cc0542468fb338a333c245f4a83d299fb4960ab5baa097d4cf1d0b98bb)
            check_type(argname="argument x_shear", value=x_shear, expected_type=type_hints["x_shear"])
            check_type(argname="argument x_shear_var", value=x_shear_var, expected_type=type_hints["x_shear_var"])
            check_type(argname="argument y_shear", value=y_shear, expected_type=type_hints["y_shear"])
            check_type(argname="argument y_shear_var", value=y_shear_var, expected_type=type_hints["y_shear_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if x_shear is not None:
            self._values["x_shear"] = x_shear
        if x_shear_var is not None:
            self._values["x_shear_var"] = x_shear_var
        if y_shear is not None:
            self._values["y_shear"] = y_shear
        if y_shear_var is not None:
            self._values["y_shear_var"] = y_shear_var

    @builtins.property
    def x_shear(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the x-axis, measured in multiples of the image's width.

        Must be set if yShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear DataAkamaiImagingPolicyImage#x_shear}
        '''
        result = self._values.get("x_shear")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_shear_var(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the x-axis, measured in multiples of the image's width.

        Must be set if yShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear_var DataAkamaiImagingPolicyImage#x_shear_var}
        '''
        result = self._values.get("x_shear_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_shear(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the y-axis, measured in multiples of the image's height.

        Must be set if xShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear DataAkamaiImagingPolicyImage#y_shear}
        '''
        result = self._values.get("y_shear")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_shear_var(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the y-axis, measured in multiples of the image's height.

        Must be set if xShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear_var DataAkamaiImagingPolicyImage#y_shear_var}
        '''
        result = self._values.get("y_shear_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationShear(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationShearList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationShearList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a176dad0e542b836b72427d8ea353316109a5a144e445e919fb4c4efd6188cfc)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationShearOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__45ccd963fa5bc8f199c54cc9f0eaec0611f5f356db228620bca3a1212138b596)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationShearOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac5716d464039e4f55f63f34ec81cde3c6000e1a16241219c875c44166833341)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__45ee22ac0c158cfdb7b6e7d8e1b77b7cb4e06bf7167fa198354a2b4fec652601)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__31ce204d08ba9328e1e92af7e0888c1b021b20a64f0e122b7a8881b1d440a91a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationShear]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationShear]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationShear]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f4f5ea521d0ed01e953a190ae385ad4f07526a2b384beaddbdf955dfde2e8cbc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationShearOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationShearOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d1c9a4ef50ff3ccb701c812a1aeac201bb03baa6446331baf9b1fe903fe58f59)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetXShear")
    def reset_x_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXShear", []))

    @jsii.member(jsii_name="resetXShearVar")
    def reset_x_shear_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXShearVar", []))

    @jsii.member(jsii_name="resetYShear")
    def reset_y_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYShear", []))

    @jsii.member(jsii_name="resetYShearVar")
    def reset_y_shear_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYShearVar", []))

    @builtins.property
    @jsii.member(jsii_name="xShearInput")
    def x_shear_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xShearInput"))

    @builtins.property
    @jsii.member(jsii_name="xShearVarInput")
    def x_shear_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xShearVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yShearInput")
    def y_shear_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yShearInput"))

    @builtins.property
    @jsii.member(jsii_name="yShearVarInput")
    def y_shear_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yShearVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xShear")
    def x_shear(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xShear"))

    @x_shear.setter
    def x_shear(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__55bd47f906eff623d121b05a82e9aa8ed2017ad3e2d72a54c7ae3f2c04eb336d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xShear", value)

    @builtins.property
    @jsii.member(jsii_name="xShearVar")
    def x_shear_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xShearVar"))

    @x_shear_var.setter
    def x_shear_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f38d4fa49fed75ff4c28d41493bdeac8ad9ba2010e4433d49f78465db57143ec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xShearVar", value)

    @builtins.property
    @jsii.member(jsii_name="yShear")
    def y_shear(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yShear"))

    @y_shear.setter
    def y_shear(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0534c461fcfa61de2c2e0d8f937edc7dc8696ed614c4318f7db24974b2bc1afc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yShear", value)

    @builtins.property
    @jsii.member(jsii_name="yShearVar")
    def y_shear_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yShearVar"))

    @y_shear_var.setter
    def y_shear_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__80d2364d4c4f21cef3bcee1ad833f3a289711404543631228b4851090e7da8d3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yShearVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationShear]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationShear]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationShear]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d191bb3922f5a1a0592d154a6510753c25fc7d5e504d5213c96a3cffcff44607)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationTrim",
    jsii_struct_bases=[],
    name_mapping={
        "fuzz": "fuzz",
        "fuzz_var": "fuzzVar",
        "padding": "padding",
        "padding_var": "paddingVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationTrim:
    def __init__(
        self,
        *,
        fuzz: typing.Optional[builtins.str] = None,
        fuzz_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fuzz: The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz DataAkamaiImagingPolicyImage#fuzz}
        :param fuzz_var: The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz_var DataAkamaiImagingPolicyImage#fuzz_var}
        :param padding: The amount of padding in pixels to add to the trimmed image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: The amount of padding in pixels to add to the trimmed image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__49e006d4b2186db5624f9cf6b316b97748424407be3c1a5fd8fafe24709ab6f3)
            check_type(argname="argument fuzz", value=fuzz, expected_type=type_hints["fuzz"])
            check_type(argname="argument fuzz_var", value=fuzz_var, expected_type=type_hints["fuzz_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fuzz is not None:
            self._values["fuzz"] = fuzz
        if fuzz_var is not None:
            self._values["fuzz_var"] = fuzz_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var

    @builtins.property
    def fuzz(self) -> typing.Optional[builtins.str]:
        '''The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz DataAkamaiImagingPolicyImage#fuzz}
        '''
        result = self._values.get("fuzz")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fuzz_var(self) -> typing.Optional[builtins.str]:
        '''The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz_var DataAkamaiImagingPolicyImage#fuzz_var}
        '''
        result = self._values.get("fuzz_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''The amount of padding in pixels to add to the trimmed image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''The amount of padding in pixels to add to the trimmed image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationTrim(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationTrimList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationTrimList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__92c19c5105949411a48f44315fdb57d69c0b3ac650666ef7aa92de3534754f6e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationTrimOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__78763f2d16018b8984a141f4ec8e1885dcf97103cd5c0e4ebc2d22e6f9b77045)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationTrimOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__39d00fa516977683eea49f31cdb49d181b9d8dad8cdc7108eb71a2cb5f32fb85)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e823ae60ac9b877ba438fd01c05eae96b80e6d3a78e931ea29cf0b722f150f5d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__128496bc90b83bca00aba540b9112535550baf1f24283fe601ee4cddbe318a6c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationTrim]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationTrim]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationTrim]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5576782c3cbb2c67e3a677957ecc6bf29d93c346f0edde4f679b9279c675436a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationTrimOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationTrimOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e078bcbd59a366c71f4250a8c0f0c28095797d10a0ea452b22d0010a0165fb38)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetFuzz")
    def reset_fuzz(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFuzz", []))

    @jsii.member(jsii_name="resetFuzzVar")
    def reset_fuzz_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFuzzVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @builtins.property
    @jsii.member(jsii_name="fuzzInput")
    def fuzz_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fuzzInput"))

    @builtins.property
    @jsii.member(jsii_name="fuzzVarInput")
    def fuzz_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fuzzVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="fuzz")
    def fuzz(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fuzz"))

    @fuzz.setter
    def fuzz(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7af4bfa45b5af06b0b0a7eef57353f3b22632418933283020ec5bfda65b0cc4e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fuzz", value)

    @builtins.property
    @jsii.member(jsii_name="fuzzVar")
    def fuzz_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fuzzVar"))

    @fuzz_var.setter
    def fuzz_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4d1b3791d3289b424603d96fe512cf9d13dbce4f20352636c41f58483c582d8d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fuzzVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a30c8d0283a7b0d70c299d2ba8335c5f0541ac172173d8b1660b16dc1d24f4d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__333b7c565ad20a50d742d53c9c3b2933d1b3b6b2613b711ee739a551763b06fc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationTrim]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationTrim]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationTrim]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__990615a7bd5d9bb52409044ddb5cf07e644b3d49f31265fbf240bb9076b5fa1f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationUnsharpMask",
    jsii_struct_bases=[],
    name_mapping={
        "gain": "gain",
        "gain_var": "gainVar",
        "sigma": "sigma",
        "sigma_var": "sigmaVar",
        "threshold": "threshold",
        "threshold_var": "thresholdVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationUnsharpMask:
    def __init__(
        self,
        *,
        gain: typing.Optional[builtins.str] = None,
        gain_var: typing.Optional[builtins.str] = None,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
        threshold: typing.Optional[builtins.str] = None,
        threshold_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param gain: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        :param gain_var: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        :param sigma: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        :param threshold: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        :param threshold_var: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e2709ed24d3b84091c4a8bd3fab0591105fa048d8da40dd8a155f124cfe3d901)
            check_type(argname="argument gain", value=gain, expected_type=type_hints["gain"])
            check_type(argname="argument gain_var", value=gain_var, expected_type=type_hints["gain_var"])
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
            check_type(argname="argument threshold", value=threshold, expected_type=type_hints["threshold"])
            check_type(argname="argument threshold_var", value=threshold_var, expected_type=type_hints["threshold_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if gain is not None:
            self._values["gain"] = gain
        if gain_var is not None:
            self._values["gain_var"] = gain_var
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var
        if threshold is not None:
            self._values["threshold"] = threshold
        if threshold_var is not None:
            self._values["threshold_var"] = threshold_var

    @builtins.property
    def gain(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        '''
        result = self._values.get("gain")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gain_var(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        '''
        result = self._values.get("gain_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        '''
        result = self._values.get("threshold")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold_var(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        result = self._values.get("threshold_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationUnsharpMask(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationUnsharpMaskList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationUnsharpMaskList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cebb95f34bcde89e2d1ad0c3b8d7fb2ea2775b8d84b5ab3e578646145c5b2d09)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationUnsharpMaskOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__15629047cbccf1a04e234c8257c28f7b6a4c23074debd11f7f034d78aaaafe7c)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationUnsharpMaskOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__53aa323cf84ef390a66abe3fd7dfd616923f3812c8625f87f8820e608260a037)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0c321a4a61716e618f4c6d7dec21de0d163da491b096792bc80d92a56810416e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__80d60751693042418e0566d8b41ab37c2a579d1ff7ebc86ecff7dc13f3c0098d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationUnsharpMask]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationUnsharpMask]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationUnsharpMask]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__24c2b75d5e1448c1b26c4273918feee7d066066f726c9ab297106c12957b81d9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationUnsharpMaskOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationUnsharpMaskOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3f64079948280e18b294393b1de56f5fcaf348aa0011093782b832ad3efc8505)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetGain")
    def reset_gain(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGain", []))

    @jsii.member(jsii_name="resetGainVar")
    def reset_gain_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGainVar", []))

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @jsii.member(jsii_name="resetThreshold")
    def reset_threshold(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThreshold", []))

    @jsii.member(jsii_name="resetThresholdVar")
    def reset_threshold_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThresholdVar", []))

    @builtins.property
    @jsii.member(jsii_name="gainInput")
    def gain_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainInput"))

    @builtins.property
    @jsii.member(jsii_name="gainVarInput")
    def gain_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdInput")
    def threshold_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdVarInput")
    def threshold_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gain")
    def gain(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gain"))

    @gain.setter
    def gain(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b1516c28a76041e8501cac1177cc586a55773ba104d18d5c12f31551e7409ba7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gain", value)

    @builtins.property
    @jsii.member(jsii_name="gainVar")
    def gain_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gainVar"))

    @gain_var.setter
    def gain_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0173cd1afdf7a31c69bfaa0751fbce520b8ea1a0b96e78e6713eb34966f15133)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gainVar", value)

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a1fca0f1509239f98159587c79da344b44efe2c6ae9cf48513aeefca968fdfc5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__33ae78605c2b45946591a1118868970690a90acfeff092c12217ae1a49173fd5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="threshold")
    def threshold(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "threshold"))

    @threshold.setter
    def threshold(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__05986e7f8959f16f660ba41ddde7a96fe3c676d3152164c4329db5bbc89f7aa5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "threshold", value)

    @builtins.property
    @jsii.member(jsii_name="thresholdVar")
    def threshold_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "thresholdVar"))

    @threshold_var.setter
    def threshold_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a28e04fde50af1065a7aa62ba5b33fda618b8052fbd50c6cf97fc91642a7fdcc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "thresholdVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationUnsharpMask]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationUnsharpMask]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationUnsharpMask]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9515faf20156b3724480ba3d67ad5fa3a63c1580b1fdf541d60c43d9a349c11b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b674866246dcf1a07f82ab4aa8fc79b6c2a81fc8cd87a41efe502847e269f48d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e9836b48e5a3c60ee03424636c701577d927220cebeaf81258b939de5813635f)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__963e58687f09b6c46732a876d272d13ff6dc7b0273cff1916e83cfa98649184c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d671400524dca014cf02683d24d88345de1809693f8a5687843c6f104d62ef15)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__06572302cf3c5828a42a58166df31adc0dfb74d2855eb4dd73e4754ba18811d8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFill]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFill]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFill]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__daf64887716c6b10566f56a00246048a984148ac4d38af6165a89845ecba4792)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__521120925f6a4f76d4fa7caf6870651ba2dd841a9c86e99422b81bc47838712b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putFillTransformation")
    def put_fill_transformation(
        self,
        *,
        append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppend, typing.Dict[builtins.str, typing.Any]]]]] = None,
        aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAspectCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
        crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationFaceCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationFeatureCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFill, typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
        im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationImQuery, typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
        region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRelativeCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
        resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationResize, typing.Dict[builtins.str, typing.Any]]]]] = None,
        rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRotate, typing.Dict[builtins.str, typing.Any]]]]] = None,
        scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationScale, typing.Dict[builtins.str, typing.Any]]]]] = None,
        shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationShear, typing.Dict[builtins.str, typing.Any]]]]] = None,
        trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationTrim, typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param append: append block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        :param aspect_crop: aspect_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param crop: crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        :param face_crop: face_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        :param feature_crop: feature_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        :param fit_and_fill: fit_and_fill block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param im_query: im_query block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param region_of_interest_crop: region_of_interest_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        :param relative_crop: relative_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param resize: resize block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        :param rotate: rotate block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        :param scale: scale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param shear: shear block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        :param trim: trim block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        value = DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformation(
            append=append,
            aspect_crop=aspect_crop,
            background_color=background_color,
            blur=blur,
            chroma_key=chroma_key,
            composite=composite,
            compound=compound,
            contrast=contrast,
            crop=crop,
            face_crop=face_crop,
            feature_crop=feature_crop,
            fit_and_fill=fit_and_fill,
            goop=goop,
            grayscale=grayscale,
            hsl=hsl,
            hsv=hsv,
            if_dimension=if_dimension,
            if_orientation=if_orientation,
            im_query=im_query,
            max_colors=max_colors,
            mirror=mirror,
            mono_hue=mono_hue,
            opacity=opacity,
            region_of_interest_crop=region_of_interest_crop,
            relative_crop=relative_crop,
            remove_color=remove_color,
            resize=resize,
            rotate=rotate,
            scale=scale,
            shear=shear,
            trim=trim,
            unsharp_mask=unsharp_mask,
        )

        return typing.cast(None, jsii.invoke(self, "putFillTransformation", [value]))

    @jsii.member(jsii_name="resetFillTransformation")
    def reset_fill_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFillTransformation", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="fillTransformation")
    def fill_transformation(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationOutputReference, jsii.get(self, "fillTransformation"))

    @builtins.property
    @jsii.member(jsii_name="fillTransformationInput")
    def fill_transformation_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformation], jsii.get(self, "fillTransformationInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__79a9cd19d48aa87d1f81b757400855109a2ccac964d5e93acade3cc0da2793b7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f352cdbf7f272634d2da999bfeb3733d461d5df53eb10dbf33c8b66e011382fa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3db05bc7a9e7a41e7e3a7ffbcf50161833e0fe13688a6b8821348bc4f0e4613b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fc7dc96e922078c0ee61a503dc5656de8b184d03fd29ae5b126867e23f470de0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFill]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFill]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFill]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0461c5b47a0e19e356bc9ec7bd4141c48b3b8cfd122b81b073a34252be4c4974)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsGoop",
    jsii_struct_bases=[],
    name_mapping={
        "chaos": "chaos",
        "chaos_var": "chaosVar",
        "density": "density",
        "density_var": "densityVar",
        "power": "power",
        "power_var": "powerVar",
        "seed": "seed",
        "seed_var": "seedVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsGoop:
    def __init__(
        self,
        *,
        chaos: typing.Optional[builtins.str] = None,
        chaos_var: typing.Optional[builtins.str] = None,
        density: typing.Optional[builtins.str] = None,
        density_var: typing.Optional[builtins.str] = None,
        power: typing.Optional[builtins.str] = None,
        power_var: typing.Optional[builtins.str] = None,
        seed: typing.Optional[builtins.str] = None,
        seed_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param chaos: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        :param chaos_var: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        :param density: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        :param density_var: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        :param power: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        :param power_var: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        :param seed: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        :param seed_var: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e55c851464f895d2671a764fb0cccf5e2d459993e59e3b96f75d9023250ce802)
            check_type(argname="argument chaos", value=chaos, expected_type=type_hints["chaos"])
            check_type(argname="argument chaos_var", value=chaos_var, expected_type=type_hints["chaos_var"])
            check_type(argname="argument density", value=density, expected_type=type_hints["density"])
            check_type(argname="argument density_var", value=density_var, expected_type=type_hints["density_var"])
            check_type(argname="argument power", value=power, expected_type=type_hints["power"])
            check_type(argname="argument power_var", value=power_var, expected_type=type_hints["power_var"])
            check_type(argname="argument seed", value=seed, expected_type=type_hints["seed"])
            check_type(argname="argument seed_var", value=seed_var, expected_type=type_hints["seed_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if chaos is not None:
            self._values["chaos"] = chaos
        if chaos_var is not None:
            self._values["chaos_var"] = chaos_var
        if density is not None:
            self._values["density"] = density
        if density_var is not None:
            self._values["density_var"] = density_var
        if power is not None:
            self._values["power"] = power
        if power_var is not None:
            self._values["power_var"] = power_var
        if seed is not None:
            self._values["seed"] = seed
        if seed_var is not None:
            self._values["seed_var"] = seed_var

    @builtins.property
    def chaos(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        '''
        result = self._values.get("chaos")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def chaos_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        '''
        result = self._values.get("chaos_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        '''
        result = self._values.get("density")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density_var(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        '''
        result = self._values.get("density_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        '''
        result = self._values.get("power")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power_var(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        '''
        result = self._values.get("power_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        '''
        result = self._values.get("seed")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed_var(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        result = self._values.get("seed_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsGoop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsGoopList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsGoopList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7bde5629c882de9be77e695782381e73e3f15964fdb3e17000d570a265137e45)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsGoopOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b340ea7ecd64d5d153334aecd1aaba6e07ad0cfa7878f7882605c204fbcd770c)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsGoopOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ade181c6969025543af15200f0c6c19b69567794dbc65ec7ef664d8c093194fe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2f79106261c0f3cc2566608e365ef21e44b8a730e2011cea7277f4ab9122b75a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fbc7e97dbf01db874e31375dd79dca550ae1bde8ef945caecab9f01873dd2a72)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsGoop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsGoop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4367f2f09b55a15d18c88d72a3b583672117c9408444ded4ec6b5b13b0574d08)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsGoopOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsGoopOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__09829387e0fcd44af49a75efeec284a6c078470a0e0f608d1c2ab762908a514a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetChaos")
    def reset_chaos(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaos", []))

    @jsii.member(jsii_name="resetChaosVar")
    def reset_chaos_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaosVar", []))

    @jsii.member(jsii_name="resetDensity")
    def reset_density(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensity", []))

    @jsii.member(jsii_name="resetDensityVar")
    def reset_density_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensityVar", []))

    @jsii.member(jsii_name="resetPower")
    def reset_power(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPower", []))

    @jsii.member(jsii_name="resetPowerVar")
    def reset_power_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPowerVar", []))

    @jsii.member(jsii_name="resetSeed")
    def reset_seed(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeed", []))

    @jsii.member(jsii_name="resetSeedVar")
    def reset_seed_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeedVar", []))

    @builtins.property
    @jsii.member(jsii_name="chaosInput")
    def chaos_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosInput"))

    @builtins.property
    @jsii.member(jsii_name="chaosVarInput")
    def chaos_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosVarInput"))

    @builtins.property
    @jsii.member(jsii_name="densityInput")
    def density_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityInput"))

    @builtins.property
    @jsii.member(jsii_name="densityVarInput")
    def density_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="powerInput")
    def power_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerInput"))

    @builtins.property
    @jsii.member(jsii_name="powerVarInput")
    def power_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerVarInput"))

    @builtins.property
    @jsii.member(jsii_name="seedInput")
    def seed_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedInput"))

    @builtins.property
    @jsii.member(jsii_name="seedVarInput")
    def seed_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedVarInput"))

    @builtins.property
    @jsii.member(jsii_name="chaos")
    def chaos(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaos"))

    @chaos.setter
    def chaos(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__80a8e053bd43f47b0235568ce9b4034ac87666c4f2e215aa04f1d6176f7a0efd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaos", value)

    @builtins.property
    @jsii.member(jsii_name="chaosVar")
    def chaos_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaosVar"))

    @chaos_var.setter
    def chaos_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5c2b255e468acbfd119a4f9227d1b2f70581e20cba510d27d1583e8dcf5500df)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaosVar", value)

    @builtins.property
    @jsii.member(jsii_name="density")
    def density(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "density"))

    @density.setter
    def density(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ceae7c3931ce03edd7b6fc9dee4d3d949c3cc5bb5e4352e204658e5d353b05ab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "density", value)

    @builtins.property
    @jsii.member(jsii_name="densityVar")
    def density_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "densityVar"))

    @density_var.setter
    def density_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df8cbea5a7cf550fd8c151a2eabf8ce70adc53c839dbcec1a1edd947a407d544)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "densityVar", value)

    @builtins.property
    @jsii.member(jsii_name="power")
    def power(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "power"))

    @power.setter
    def power(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1179f82ec40b1efac585da8adcc83fc588a58bd9ddbd055d9e7aa8b11c0fefd3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "power", value)

    @builtins.property
    @jsii.member(jsii_name="powerVar")
    def power_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "powerVar"))

    @power_var.setter
    def power_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d3ebe09d939926c376c2debf2c26f30df14b493e38144125af8b7bbd2c55e72e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "powerVar", value)

    @builtins.property
    @jsii.member(jsii_name="seed")
    def seed(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seed"))

    @seed.setter
    def seed(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__97cbf591b2063fd5d7fa87e50cc8256b792085d09606b8d9dd589efebdc11e78)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seed", value)

    @builtins.property
    @jsii.member(jsii_name="seedVar")
    def seed_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seedVar"))

    @seed_var.setter
    def seed_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__86a7e9d6c1f551c25813f541e0004fbe7fc6daff74da2edea66b718793abd435)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seedVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsGoop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsGoop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsGoop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1494d70b89355325a23d07b202f06e6dfef90cf6978a0ca634151600fc25e46e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsGrayscale",
    jsii_struct_bases=[],
    name_mapping={"type": "type", "type_var": "typeVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsGrayscale:
    def __init__(
        self,
        *,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param type: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e20c5ce2daadf78f51e85196664614497cbe877d82bafc2d4403900c2fb38e5c)
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsGrayscale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsGrayscaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsGrayscaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__75ea107865bb0d6adb8b3f19908fed18d38e86a0f07b19ad0d9cc1989d2db39c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsGrayscaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7dd52d5637ce6a75ec1e1674f33dc2091acd922322b89d775a5da69c13d0eeb7)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsGrayscaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a1bc7cd9dc8ff882a64782975e40282c0e1d3f6dbb0648824bd3a2935871cc05)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b84a6c6c5c253dc79769dbd1fd247355f532290238ccacd14f5a2b279621cf99)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8ebd41e1125d40ca0bcbb7ffc57c20e715285c9d5304151419245ac4021279b1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsGrayscale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsGrayscale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1cbacc1ff2721f841851318b23b22f1c2bcd4d197f75719177ef7a7e57630bb6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsGrayscaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsGrayscaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2f8e3c38a0e77bbd56ba25969c8a9508d24b7a08c70e1fbdfe482c03758a3fe6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__360ff45fefdc64e0f99f8e954ec5cb04a2e29d8622180f612bfee4fe191f4788)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d3b5bc74ce7580e6692fbb43658d96694d16dfe9d1492c46bfbdc3795e12682f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsGrayscale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsGrayscale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsGrayscale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e5c037ca9f0316a4d936f4be9ff17a8cc06054ff2661999e5edc3bb92a113306)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsHsl",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "lightness": "lightness",
        "lightness_var": "lightnessVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsHsl:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness: typing.Optional[builtins.str] = None,
        lightness_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        :param lightness_var: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ac5e7a9485332bf0c626157460db3e26cbd0d13d15fa69dd09531b1716e93a1)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness", value=lightness, expected_type=type_hints["lightness"])
            check_type(argname="argument lightness_var", value=lightness_var, expected_type=type_hints["lightness_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness is not None:
            self._values["lightness"] = lightness
        if lightness_var is not None:
            self._values["lightness_var"] = lightness_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        '''
        result = self._values.get("lightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        '''
        result = self._values.get("lightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsHsl(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsHslList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsHslList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__69e28b3fb296a8eb2a525db8e208842041e693d35374d53e62c66a1fef3938af)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsHslOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d881906a641c1796354b1141e75cba5f60a562be3a7c8e6ddea158ec1b1ac7da)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsHslOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__68f825d42bd8353b520845b0b945f6843339e62532fcfab5bdaf662e88e8b056)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__20b40e2fb42fb8638a27c6377d7635c670e72a9e69e51e800236211ffb32f3ec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a0c7a0281e63ad6f2fd63dd59eefe0b126ddf098392191c5884f4adc793e8386)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsHsl]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsHsl]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__871cf16056c68fac4c22c4ab1455b3d02dee8a5dd621660c160b9bf7d6de3053)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsHslOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsHslOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1743b66665c7157241a4ca684cfc993481f8ec604a0ab16aa07c56f54bcf382e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightness")
    def reset_lightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightness", []))

    @jsii.member(jsii_name="resetLightnessVar")
    def reset_lightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessInput")
    def lightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessVarInput")
    def lightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5c341d13e12157b2220909c113d38d2da5d81e106eed65172e97aea4cfde2d7d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__23e85bd0fe7c0539b03cedbde61c7f3cf1080f735268accecccae388d9f7a914)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightness")
    def lightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightness"))

    @lightness.setter
    def lightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__742ee1b42625504bb79b1bfcf8c8ef743c5d7586b9103d26ab8e00cb4fe510b1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightness", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessVar")
    def lightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessVar"))

    @lightness_var.setter
    def lightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab9717d7b8abc43cf46d0e3851126f4fca9d94db1764c8a3c285a98af9b634d5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dd2ddabbf1237dc0e58951967f4520e64f90fdd9454584b52c6ea69dde585b3f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c086f78eb2d85775c4d71ef46b6178f478dcc6110d58ed224729bcb1e15c44c3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsHsl]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsHsl]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsHsl]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a906deb43041005ad0f8dc0e8b08a1f86a253794079b62e92eb1bb039010ee6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsHsv",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsHsv:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        :param value: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__24a77881591ee966fd51df966b9b8028d9739372c363920f6f0457914ec404ff)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsHsv(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsHsvList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsHsvList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__77ba41ba09a9cbe66262a02e5d278dfd7c5d203664945cd988b93bbcbbd653ed)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsHsvOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__875508e639b600259e063fc983c686b1ffd83460ca9b7a702284d0148b8d4220)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsHsvOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__397f03f7752c179ecac870b3c36e3b798d21db89e0d9d53e4ddf4b9f27262d07)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__292520471b4b238273726c031f8fd3d8167b9d3f42b99554d1be222bf904185b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__400e7cf86ccd2cbd84ae358a21898a6902d78d857a044cf83686e359a39c5adb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsHsv]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsHsv]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e7cb11049f7bc4c5ae4061f5223a7bdd5e89aa36c27fa9abb8f7b9f693782ee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsHsvOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsHsvOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7cc934de27ad12d540ab4866e879d60d4d4e2dccbabb53d07ccf6eff8d2d363f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d2df71b36d088f3a5dc04b30b840d356fd2b8af5410e0d278b76fe0de9282372)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__56f1d4db2ada7c649d745039fbcbbbcadc662eb12f8dc495e29b34af052301cf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__23aec8091e3a9398493417d7e3b51c23a87b4c4c7f0257eebd231110d578d8fb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c9a262c4386a03a951b5e6be718aece70633c0909413047d02b65cb2d258b5c9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__74fef669e188d7abe9b9597f5e0d0f6faaffa946d8f4a36d762bce1b14ef8eeb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f5eda77a1d47cd16727b57b8fcf9416a0ad83d7b73d284d3550af390e5f90641)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsHsv]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsHsv]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsHsv]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c26cc27ec290574a07601cdbe28252f399eb91afdff7d604529754c707a3e723)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimension",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "dimension": "dimension",
        "dimension_var": "dimensionVar",
        "equal": "equal",
        "greater_than": "greaterThan",
        "less_than": "lessThan",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimension:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        dimension: typing.Optional[builtins.str] = None,
        dimension_var: typing.Optional[builtins.str] = None,
        equal: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqual", typing.Dict[builtins.str, typing.Any]]] = None,
        greater_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThan", typing.Dict[builtins.str, typing.Any]]] = None,
        less_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThan", typing.Dict[builtins.str, typing.Any]]] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param dimension: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        :param dimension_var: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        :param equal: equal block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        :param greater_than: greater_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        :param less_than: less_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        :param value: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefault(**default)
        if isinstance(equal, dict):
            equal = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqual(**equal)
        if isinstance(greater_than, dict):
            greater_than = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThan(**greater_than)
        if isinstance(less_than, dict):
            less_than = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThan(**less_than)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__544aca1144c960a653c1ba48b42b135a9d847e6b138098bbd02c1e3e94e9d1ad)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument dimension", value=dimension, expected_type=type_hints["dimension"])
            check_type(argname="argument dimension_var", value=dimension_var, expected_type=type_hints["dimension_var"])
            check_type(argname="argument equal", value=equal, expected_type=type_hints["equal"])
            check_type(argname="argument greater_than", value=greater_than, expected_type=type_hints["greater_than"])
            check_type(argname="argument less_than", value=less_than, expected_type=type_hints["less_than"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if dimension is not None:
            self._values["dimension"] = dimension
        if dimension_var is not None:
            self._values["dimension_var"] = dimension_var
        if equal is not None:
            self._values["equal"] = equal
        if greater_than is not None:
            self._values["greater_than"] = greater_than
        if less_than is not None:
            self._values["less_than"] = less_than
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefault"], result)

    @builtins.property
    def dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        '''
        result = self._values.get("dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        '''
        result = self._values.get("dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def equal(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqual"]:
        '''equal block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        '''
        result = self._values.get("equal")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqual"], result)

    @builtins.property
    def greater_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThan"]:
        '''greater_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        '''
        result = self._values.get("greater_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThan"], result)

    @builtins.property
    def less_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThan"]:
        '''less_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        '''
        result = self._values.get("less_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThan"], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimension(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefault",
    jsii_struct_bases=[],
    name_mapping={
        "append": "append",
        "aspect_crop": "aspectCrop",
        "background_color": "backgroundColor",
        "blur": "blur",
        "chroma_key": "chromaKey",
        "composite": "composite",
        "compound": "compound",
        "contrast": "contrast",
        "crop": "crop",
        "face_crop": "faceCrop",
        "feature_crop": "featureCrop",
        "fit_and_fill": "fitAndFill",
        "goop": "goop",
        "grayscale": "grayscale",
        "hsl": "hsl",
        "hsv": "hsv",
        "if_dimension": "ifDimension",
        "if_orientation": "ifOrientation",
        "im_query": "imQuery",
        "max_colors": "maxColors",
        "mirror": "mirror",
        "mono_hue": "monoHue",
        "opacity": "opacity",
        "region_of_interest_crop": "regionOfInterestCrop",
        "relative_crop": "relativeCrop",
        "remove_color": "removeColor",
        "resize": "resize",
        "rotate": "rotate",
        "scale": "scale",
        "shear": "shear",
        "trim": "trim",
        "unsharp_mask": "unsharpMask",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefault:
    def __init__(
        self,
        *,
        append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppend", typing.Dict[builtins.str, typing.Any]]]]] = None,
        aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAspectCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultBackgroundColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultBlur", typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultChromaKey", typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultComposite", typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompound", typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultContrast", typing.Dict[builtins.str, typing.Any]]]]] = None,
        crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFaceCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFeatureCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFill", typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultGoop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultGrayscale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultHsl", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultHsv", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientation", typing.Dict[builtins.str, typing.Any]]]]] = None,
        im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultImQuery", typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultMaxColors", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultMirror", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultMonoHue", typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultOpacity", typing.Dict[builtins.str, typing.Any]]]]] = None,
        region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRelativeCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRemoveColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultResize", typing.Dict[builtins.str, typing.Any]]]]] = None,
        rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRotate", typing.Dict[builtins.str, typing.Any]]]]] = None,
        scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultScale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultShear", typing.Dict[builtins.str, typing.Any]]]]] = None,
        trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultTrim", typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultUnsharpMask", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param append: append block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        :param aspect_crop: aspect_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param crop: crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        :param face_crop: face_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        :param feature_crop: feature_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        :param fit_and_fill: fit_and_fill block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param im_query: im_query block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param region_of_interest_crop: region_of_interest_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        :param relative_crop: relative_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param resize: resize block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        :param rotate: rotate block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        :param scale: scale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param shear: shear block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        :param trim: trim block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a8f255f62a38927421f5d3f220471da6cbcc3b1d1c35d141e1fcc8532c8398e)
            check_type(argname="argument append", value=append, expected_type=type_hints["append"])
            check_type(argname="argument aspect_crop", value=aspect_crop, expected_type=type_hints["aspect_crop"])
            check_type(argname="argument background_color", value=background_color, expected_type=type_hints["background_color"])
            check_type(argname="argument blur", value=blur, expected_type=type_hints["blur"])
            check_type(argname="argument chroma_key", value=chroma_key, expected_type=type_hints["chroma_key"])
            check_type(argname="argument composite", value=composite, expected_type=type_hints["composite"])
            check_type(argname="argument compound", value=compound, expected_type=type_hints["compound"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument crop", value=crop, expected_type=type_hints["crop"])
            check_type(argname="argument face_crop", value=face_crop, expected_type=type_hints["face_crop"])
            check_type(argname="argument feature_crop", value=feature_crop, expected_type=type_hints["feature_crop"])
            check_type(argname="argument fit_and_fill", value=fit_and_fill, expected_type=type_hints["fit_and_fill"])
            check_type(argname="argument goop", value=goop, expected_type=type_hints["goop"])
            check_type(argname="argument grayscale", value=grayscale, expected_type=type_hints["grayscale"])
            check_type(argname="argument hsl", value=hsl, expected_type=type_hints["hsl"])
            check_type(argname="argument hsv", value=hsv, expected_type=type_hints["hsv"])
            check_type(argname="argument if_dimension", value=if_dimension, expected_type=type_hints["if_dimension"])
            check_type(argname="argument if_orientation", value=if_orientation, expected_type=type_hints["if_orientation"])
            check_type(argname="argument im_query", value=im_query, expected_type=type_hints["im_query"])
            check_type(argname="argument max_colors", value=max_colors, expected_type=type_hints["max_colors"])
            check_type(argname="argument mirror", value=mirror, expected_type=type_hints["mirror"])
            check_type(argname="argument mono_hue", value=mono_hue, expected_type=type_hints["mono_hue"])
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument region_of_interest_crop", value=region_of_interest_crop, expected_type=type_hints["region_of_interest_crop"])
            check_type(argname="argument relative_crop", value=relative_crop, expected_type=type_hints["relative_crop"])
            check_type(argname="argument remove_color", value=remove_color, expected_type=type_hints["remove_color"])
            check_type(argname="argument resize", value=resize, expected_type=type_hints["resize"])
            check_type(argname="argument rotate", value=rotate, expected_type=type_hints["rotate"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument shear", value=shear, expected_type=type_hints["shear"])
            check_type(argname="argument trim", value=trim, expected_type=type_hints["trim"])
            check_type(argname="argument unsharp_mask", value=unsharp_mask, expected_type=type_hints["unsharp_mask"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if append is not None:
            self._values["append"] = append
        if aspect_crop is not None:
            self._values["aspect_crop"] = aspect_crop
        if background_color is not None:
            self._values["background_color"] = background_color
        if blur is not None:
            self._values["blur"] = blur
        if chroma_key is not None:
            self._values["chroma_key"] = chroma_key
        if composite is not None:
            self._values["composite"] = composite
        if compound is not None:
            self._values["compound"] = compound
        if contrast is not None:
            self._values["contrast"] = contrast
        if crop is not None:
            self._values["crop"] = crop
        if face_crop is not None:
            self._values["face_crop"] = face_crop
        if feature_crop is not None:
            self._values["feature_crop"] = feature_crop
        if fit_and_fill is not None:
            self._values["fit_and_fill"] = fit_and_fill
        if goop is not None:
            self._values["goop"] = goop
        if grayscale is not None:
            self._values["grayscale"] = grayscale
        if hsl is not None:
            self._values["hsl"] = hsl
        if hsv is not None:
            self._values["hsv"] = hsv
        if if_dimension is not None:
            self._values["if_dimension"] = if_dimension
        if if_orientation is not None:
            self._values["if_orientation"] = if_orientation
        if im_query is not None:
            self._values["im_query"] = im_query
        if max_colors is not None:
            self._values["max_colors"] = max_colors
        if mirror is not None:
            self._values["mirror"] = mirror
        if mono_hue is not None:
            self._values["mono_hue"] = mono_hue
        if opacity is not None:
            self._values["opacity"] = opacity
        if region_of_interest_crop is not None:
            self._values["region_of_interest_crop"] = region_of_interest_crop
        if relative_crop is not None:
            self._values["relative_crop"] = relative_crop
        if remove_color is not None:
            self._values["remove_color"] = remove_color
        if resize is not None:
            self._values["resize"] = resize
        if rotate is not None:
            self._values["rotate"] = rotate
        if scale is not None:
            self._values["scale"] = scale
        if shear is not None:
            self._values["shear"] = shear
        if trim is not None:
            self._values["trim"] = trim
        if unsharp_mask is not None:
            self._values["unsharp_mask"] = unsharp_mask

    @builtins.property
    def append(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppend"]]]:
        '''append block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        '''
        result = self._values.get("append")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppend"]]], result)

    @builtins.property
    def aspect_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAspectCrop"]]]:
        '''aspect_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        '''
        result = self._values.get("aspect_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAspectCrop"]]], result)

    @builtins.property
    def background_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultBackgroundColor"]]]:
        '''background_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        '''
        result = self._values.get("background_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultBackgroundColor"]]], result)

    @builtins.property
    def blur(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultBlur"]]]:
        '''blur block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        '''
        result = self._values.get("blur")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultBlur"]]], result)

    @builtins.property
    def chroma_key(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultChromaKey"]]]:
        '''chroma_key block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        '''
        result = self._values.get("chroma_key")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultChromaKey"]]], result)

    @builtins.property
    def composite(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultComposite"]]]:
        '''composite block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        '''
        result = self._values.get("composite")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultComposite"]]], result)

    @builtins.property
    def compound(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompound"]]]:
        '''compound block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        '''
        result = self._values.get("compound")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompound"]]], result)

    @builtins.property
    def contrast(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultContrast"]]]:
        '''contrast block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultContrast"]]], result)

    @builtins.property
    def crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCrop"]]]:
        '''crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        '''
        result = self._values.get("crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCrop"]]], result)

    @builtins.property
    def face_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFaceCrop"]]]:
        '''face_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        '''
        result = self._values.get("face_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFaceCrop"]]], result)

    @builtins.property
    def feature_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFeatureCrop"]]]:
        '''feature_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        '''
        result = self._values.get("feature_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFeatureCrop"]]], result)

    @builtins.property
    def fit_and_fill(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFill"]]]:
        '''fit_and_fill block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        '''
        result = self._values.get("fit_and_fill")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFill"]]], result)

    @builtins.property
    def goop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultGoop"]]]:
        '''goop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        '''
        result = self._values.get("goop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultGoop"]]], result)

    @builtins.property
    def grayscale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultGrayscale"]]]:
        '''grayscale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        '''
        result = self._values.get("grayscale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultGrayscale"]]], result)

    @builtins.property
    def hsl(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultHsl"]]]:
        '''hsl block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        '''
        result = self._values.get("hsl")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultHsl"]]], result)

    @builtins.property
    def hsv(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultHsv"]]]:
        '''hsv block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        '''
        result = self._values.get("hsv")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultHsv"]]], result)

    @builtins.property
    def if_dimension(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimension]]]:
        '''if_dimension block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        '''
        result = self._values.get("if_dimension")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimension]]], result)

    @builtins.property
    def if_orientation(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientation"]]]:
        '''if_orientation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        '''
        result = self._values.get("if_orientation")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientation"]]], result)

    @builtins.property
    def im_query(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultImQuery"]]]:
        '''im_query block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        '''
        result = self._values.get("im_query")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultImQuery"]]], result)

    @builtins.property
    def max_colors(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultMaxColors"]]]:
        '''max_colors block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        '''
        result = self._values.get("max_colors")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultMaxColors"]]], result)

    @builtins.property
    def mirror(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultMirror"]]]:
        '''mirror block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        '''
        result = self._values.get("mirror")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultMirror"]]], result)

    @builtins.property
    def mono_hue(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultMonoHue"]]]:
        '''mono_hue block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        '''
        result = self._values.get("mono_hue")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultMonoHue"]]], result)

    @builtins.property
    def opacity(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultOpacity"]]]:
        '''opacity block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultOpacity"]]], result)

    @builtins.property
    def region_of_interest_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCrop"]]]:
        '''region_of_interest_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        '''
        result = self._values.get("region_of_interest_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCrop"]]], result)

    @builtins.property
    def relative_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRelativeCrop"]]]:
        '''relative_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        '''
        result = self._values.get("relative_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRelativeCrop"]]], result)

    @builtins.property
    def remove_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRemoveColor"]]]:
        '''remove_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        '''
        result = self._values.get("remove_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRemoveColor"]]], result)

    @builtins.property
    def resize(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultResize"]]]:
        '''resize block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        '''
        result = self._values.get("resize")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultResize"]]], result)

    @builtins.property
    def rotate(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRotate"]]]:
        '''rotate block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        '''
        result = self._values.get("rotate")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRotate"]]], result)

    @builtins.property
    def scale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultScale"]]]:
        '''scale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultScale"]]], result)

    @builtins.property
    def shear(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultShear"]]]:
        '''shear block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        '''
        result = self._values.get("shear")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultShear"]]], result)

    @builtins.property
    def trim(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultTrim"]]]:
        '''trim block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        '''
        result = self._values.get("trim")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultTrim"]]], result)

    @builtins.property
    def unsharp_mask(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultUnsharpMask"]]]:
        '''unsharp_mask block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        result = self._values.get("unsharp_mask")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultUnsharpMask"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppend",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_priority": "gravityPriority",
        "gravity_priority_var": "gravityPriorityVar",
        "gravity_var": "gravityVar",
        "preserve_minor_dimension": "preserveMinorDimension",
        "preserve_minor_dimension_var": "preserveMinorDimensionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppend:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_priority: typing.Optional[builtins.str] = None,
        gravity_priority_var: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        preserve_minor_dimension: typing.Optional[builtins.str] = None,
        preserve_minor_dimension_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Specifies where to place the ``image`` relative to the source image. The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_priority: Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal. The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority DataAkamaiImagingPolicyImage#gravity_priority}
        :param gravity_priority_var: Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal. The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority_var DataAkamaiImagingPolicyImage#gravity_priority_var}
        :param gravity_var: Specifies where to place the ``image`` relative to the source image. The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param preserve_minor_dimension: Whether to preserve the source image's minor dimension, ``false`` by default. The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension DataAkamaiImagingPolicyImage#preserve_minor_dimension}
        :param preserve_minor_dimension_var: Whether to preserve the source image's minor dimension, ``false`` by default. The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension_var DataAkamaiImagingPolicyImage#preserve_minor_dimension_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7a8ef67a252e1c2de3eccccebc91bdee81ddb79363cdcc81a4782b34c3e94230)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_priority", value=gravity_priority, expected_type=type_hints["gravity_priority"])
            check_type(argname="argument gravity_priority_var", value=gravity_priority_var, expected_type=type_hints["gravity_priority_var"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument preserve_minor_dimension", value=preserve_minor_dimension, expected_type=type_hints["preserve_minor_dimension"])
            check_type(argname="argument preserve_minor_dimension_var", value=preserve_minor_dimension_var, expected_type=type_hints["preserve_minor_dimension_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_priority is not None:
            self._values["gravity_priority"] = gravity_priority
        if gravity_priority_var is not None:
            self._values["gravity_priority_var"] = gravity_priority_var
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if preserve_minor_dimension is not None:
            self._values["preserve_minor_dimension"] = preserve_minor_dimension
        if preserve_minor_dimension_var is not None:
            self._values["preserve_minor_dimension_var"] = preserve_minor_dimension_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Specifies where to place the ``image`` relative to the source image.

        The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_priority(self) -> typing.Optional[builtins.str]:
        '''Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal.

        The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority DataAkamaiImagingPolicyImage#gravity_priority}
        '''
        result = self._values.get("gravity_priority")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_priority_var(self) -> typing.Optional[builtins.str]:
        '''Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal.

        The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority_var DataAkamaiImagingPolicyImage#gravity_priority_var}
        '''
        result = self._values.get("gravity_priority_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Specifies where to place the ``image`` relative to the source image.

        The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def preserve_minor_dimension(self) -> typing.Optional[builtins.str]:
        '''Whether to preserve the source image's minor dimension, ``false`` by default.

        The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension DataAkamaiImagingPolicyImage#preserve_minor_dimension}
        '''
        result = self._values.get("preserve_minor_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def preserve_minor_dimension_var(self) -> typing.Optional[builtins.str]:
        '''Whether to preserve the source image's minor dimension, ``false`` by default.

        The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension_var DataAkamaiImagingPolicyImage#preserve_minor_dimension_var}
        '''
        result = self._values.get("preserve_minor_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppend(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImage",
    jsii_struct_bases=[],
    name_mapping={
        "box_image": "boxImage",
        "circle_image": "circleImage",
        "text_image": "textImage",
        "url_image": "urlImage",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImage:
    def __init__(
        self,
        *,
        box_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageBoxImage", typing.Dict[builtins.str, typing.Any]]]]] = None,
        circle_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageCircleImage", typing.Dict[builtins.str, typing.Any]]]]] = None,
        text_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageTextImage", typing.Dict[builtins.str, typing.Any]]]]] = None,
        url_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageUrlImage", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param box_image: box_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#box_image DataAkamaiImagingPolicyImage#box_image}
        :param circle_image: circle_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#circle_image DataAkamaiImagingPolicyImage#circle_image}
        :param text_image: text_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text_image DataAkamaiImagingPolicyImage#text_image}
        :param url_image: url_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url_image DataAkamaiImagingPolicyImage#url_image}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f3737d94df37a6c223f3ce09f5bf1c74cb20695797c2a7302c9fab98c890f797)
            check_type(argname="argument box_image", value=box_image, expected_type=type_hints["box_image"])
            check_type(argname="argument circle_image", value=circle_image, expected_type=type_hints["circle_image"])
            check_type(argname="argument text_image", value=text_image, expected_type=type_hints["text_image"])
            check_type(argname="argument url_image", value=url_image, expected_type=type_hints["url_image"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if box_image is not None:
            self._values["box_image"] = box_image
        if circle_image is not None:
            self._values["circle_image"] = circle_image
        if text_image is not None:
            self._values["text_image"] = text_image
        if url_image is not None:
            self._values["url_image"] = url_image

    @builtins.property
    def box_image(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageBoxImage"]]]:
        '''box_image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#box_image DataAkamaiImagingPolicyImage#box_image}
        '''
        result = self._values.get("box_image")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageBoxImage"]]], result)

    @builtins.property
    def circle_image(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageCircleImage"]]]:
        '''circle_image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#circle_image DataAkamaiImagingPolicyImage#circle_image}
        '''
        result = self._values.get("circle_image")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageCircleImage"]]], result)

    @builtins.property
    def text_image(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageTextImage"]]]:
        '''text_image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text_image DataAkamaiImagingPolicyImage#text_image}
        '''
        result = self._values.get("text_image")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageTextImage"]]], result)

    @builtins.property
    def url_image(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageUrlImage"]]]:
        '''url_image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url_image DataAkamaiImagingPolicyImage#url_image}
        '''
        result = self._values.get("url_image")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageUrlImage"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageBoxImage",
    jsii_struct_bases=[],
    name_mapping={
        "color": "color",
        "color_var": "colorVar",
        "height": "height",
        "height_var": "heightVar",
        "transformation": "transformation",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageBoxImage:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        transformation: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageBoxImageTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The fill color of the box, not the edge of the box. The API supports hexadecimal representation and CSS hexadecimal color values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The fill color of the box, not the edge of the box. The API supports hexadecimal representation and CSS hexadecimal color values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        :param height: The height of the box in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height of the box in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param transformation: transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        :param width: The width of the box in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width of the box in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(transformation, dict):
            transformation = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageBoxImageTransformation(**transformation)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__86de32da43e4559966cd4bb8d93d9c6e642ef5170273183b7b6230e20bd20669)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument transformation", value=transformation, expected_type=type_hints["transformation"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if transformation is not None:
            self._values["transformation"] = transformation
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The fill color of the box, not the edge of the box.

        The API supports hexadecimal representation and CSS hexadecimal color values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The fill color of the box, not the edge of the box.

        The API supports hexadecimal representation and CSS hexadecimal color values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height of the box in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height of the box in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def transformation(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageBoxImageTransformation"]:
        '''transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        '''
        result = self._values.get("transformation")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageBoxImageTransformation"], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width of the box in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width of the box in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageBoxImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageBoxImageList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageBoxImageList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a2dcf1cbd6f10d0720112393de5d3d862c48024cbf0c0bf86f46e7fbca58d8ad)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageBoxImageOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__73af5a605dc136fecc1b6c241c47dd754137534d5e1af451c9f134814c617a80)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageBoxImageOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__66cd05d3e7ceb5ae7e06fed1a996066f2275009f1be8cdad7c2af680cf786424)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f81aecec9dc13d579dbd2b284ddcdf5dbebe8056a9b4a19c92342f27b510bb90)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8237d93460f567b74e74b1a6fc6924acf3322786d970f49e44638be625e43b9f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageBoxImage]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageBoxImage]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageBoxImage]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2416d861e916fee92f8c1cf7c849cdb9016c0b2f450a008eed9c844b07d6d25f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageBoxImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageBoxImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3f0f335828f3d3df9897fd0248aa78e38d6d65e93000067932fc5d6368bf8fb4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformation")
    def put_transformation(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageBoxImageTransformation()

        return typing.cast(None, jsii.invoke(self, "putTransformation", [value]))

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetTransformation")
    def reset_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformation", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="transformation")
    def transformation(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageBoxImageTransformationOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageBoxImageTransformationOutputReference", jsii.get(self, "transformation"))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="transformationInput")
    def transformation_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageBoxImageTransformation"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageBoxImageTransformation"], jsii.get(self, "transformationInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a024a34a5918bf2c584e51c817c77b6f39ff5940b2daef4a13a7bab4de65177d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a8ed42a97e4b12d8ff2ad15fe4a6c6dc778020b4d469439ea5981fcd9a2762b6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9eec16acf836ced41d2bf23365861c20bd4c74c8bb5b06a4c249984649638833)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3aefd6bde119bced2bec6b210f84d151f632d92cd740c0e8a32d23b7aef3596b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f6cd5749bba10685b44a3e08ec146a51224a664d099baf895227d5f121539963)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e287b613bafc20488754de9e6da63cc39d5823a59909fa94e5599bd6ae756f0e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageBoxImage]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageBoxImage]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageBoxImage]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2bc95dcb8dc358a707ed2e7780f1bb1c3f5e2c83e339df17b50174a5d60a89f7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageBoxImageTransformation",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageBoxImageTransformation:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageBoxImageTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageBoxImageTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageBoxImageTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b70dfa83938c6db4468663439a13984c394a4622d59f806e676b871e71661214)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageBoxImageTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageBoxImageTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageBoxImageTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8b484faf7a166ccbe73d88014a43a72846bbacf4da66fdffbc821b2b72333c53)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageCircleImage",
    jsii_struct_bases=[],
    name_mapping={
        "color": "color",
        "color_var": "colorVar",
        "diameter": "diameter",
        "diameter_var": "diameterVar",
        "transformation": "transformation",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageCircleImage:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
        diameter: typing.Optional[builtins.str] = None,
        diameter_var: typing.Optional[builtins.str] = None,
        transformation: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageCircleImageTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The fill color of the circle. The API supports hexadecimal representation and CSS hexadecimal color values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The fill color of the circle. The API supports hexadecimal representation and CSS hexadecimal color values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        :param diameter: The diameter of the circle. The diameter will be the width and the height of the image in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#diameter DataAkamaiImagingPolicyImage#diameter}
        :param diameter_var: The diameter of the circle. The diameter will be the width and the height of the image in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#diameter_var DataAkamaiImagingPolicyImage#diameter_var}
        :param transformation: transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        :param width: The width of the box in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width of the box in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(transformation, dict):
            transformation = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageCircleImageTransformation(**transformation)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7ea2bec4399a924c9a5e135d3697e01522345ee44162ee3039af65a24b2496c2)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
            check_type(argname="argument diameter", value=diameter, expected_type=type_hints["diameter"])
            check_type(argname="argument diameter_var", value=diameter_var, expected_type=type_hints["diameter_var"])
            check_type(argname="argument transformation", value=transformation, expected_type=type_hints["transformation"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var
        if diameter is not None:
            self._values["diameter"] = diameter
        if diameter_var is not None:
            self._values["diameter_var"] = diameter_var
        if transformation is not None:
            self._values["transformation"] = transformation
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The fill color of the circle. The API supports hexadecimal representation and CSS hexadecimal color values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The fill color of the circle. The API supports hexadecimal representation and CSS hexadecimal color values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def diameter(self) -> typing.Optional[builtins.str]:
        '''The diameter of the circle. The diameter will be the width and the height of the image in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#diameter DataAkamaiImagingPolicyImage#diameter}
        '''
        result = self._values.get("diameter")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def diameter_var(self) -> typing.Optional[builtins.str]:
        '''The diameter of the circle. The diameter will be the width and the height of the image in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#diameter_var DataAkamaiImagingPolicyImage#diameter_var}
        '''
        result = self._values.get("diameter_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def transformation(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageCircleImageTransformation"]:
        '''transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        '''
        result = self._values.get("transformation")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageCircleImageTransformation"], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width of the box in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width of the box in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageCircleImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageCircleImageList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageCircleImageList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__06f2a492cd84a3ce26ca9795b24a91b4107373d14818f2d2a7b79f5e6b86437f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageCircleImageOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__67eb898636c1fd8ce99cbd3abe33af889f17a81523455c0ca6702d32a2571c06)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageCircleImageOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af52f6d54cc89edb23b0aa322a2532601e4a13430857f828214e6013dfed2497)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e3f78ce5bc0617a5bbcae8662f54325173c3de279bbb4a5b6cfed3e0846d84d7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fc293e0255cd4420bc6ed7e553fd73494fb19378f1cb97f60d7ed94c5c49d02d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageCircleImage]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageCircleImage]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageCircleImage]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b9ea577ac6516a9f3b39203fadc0a8e446b0f501ac56ac88540e596200ddef26)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageCircleImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageCircleImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b4c2ef2399244b4ac9dac32dde36a2cd3bc5a7b1b6632259aa7f2b696a5d111d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformation")
    def put_transformation(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageCircleImageTransformation()

        return typing.cast(None, jsii.invoke(self, "putTransformation", [value]))

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @jsii.member(jsii_name="resetDiameter")
    def reset_diameter(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDiameter", []))

    @jsii.member(jsii_name="resetDiameterVar")
    def reset_diameter_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDiameterVar", []))

    @jsii.member(jsii_name="resetTransformation")
    def reset_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformation", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="transformation")
    def transformation(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageCircleImageTransformationOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageCircleImageTransformationOutputReference", jsii.get(self, "transformation"))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="diameterInput")
    def diameter_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "diameterInput"))

    @builtins.property
    @jsii.member(jsii_name="diameterVarInput")
    def diameter_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "diameterVarInput"))

    @builtins.property
    @jsii.member(jsii_name="transformationInput")
    def transformation_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageCircleImageTransformation"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageCircleImageTransformation"], jsii.get(self, "transformationInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea421404db3eecf059116962fb355e4a4de215d3a801a7d8a36969602e4253a2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c783ec9434b9d70e0b6e1ce4e0c0fd459fbb53991c86b94672e584bf9bed0b26)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="diameter")
    def diameter(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "diameter"))

    @diameter.setter
    def diameter(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__07ec3be4c1d719d9841e6f6df2eb64840ad594a92e414e31e1bb0fb8cd38bdf5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "diameter", value)

    @builtins.property
    @jsii.member(jsii_name="diameterVar")
    def diameter_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "diameterVar"))

    @diameter_var.setter
    def diameter_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b21552b1934a5d15e00a9d11351080b07b599232ea0dbede132b65d84846b1ad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "diameterVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3c50c8714c15160be080b808b500a9089995959adfe10b12808e521a2f94308e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__09135470cccf4b1a935a2323c98998a080f73cf1d8dce4c543f40a1775543493)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageCircleImage]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageCircleImage]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageCircleImage]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d8e2c61605ebbbab555389f70183b055ce6fa2c39ba82c3322808a4a00e08ef1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageCircleImageTransformation",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageCircleImageTransformation:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageCircleImageTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageCircleImageTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageCircleImageTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0601e512067458e3768f71784a7dc521c378fa1692f63e1ba5daf37ae6838100)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageCircleImageTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageCircleImageTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageCircleImageTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9407f905b7ee033358a7d0fe380bab0a69fed44f53d46af7a10b76d8e7b3cb19)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2c65a3af37e54950962957f696328edabe47d5977fec9e6a4c4e230937c444fd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putBoxImage")
    def put_box_image(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageBoxImage, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__06d470759e534ee36251a19bf80ed2a02945a7a41050e400b275fe444c788c4b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBoxImage", [value]))

    @jsii.member(jsii_name="putCircleImage")
    def put_circle_image(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageCircleImage, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__17e6665dda37a04be0077d5f4eebc5fd36d700ebfdd7e06a81a27f4f8af3fc9f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCircleImage", [value]))

    @jsii.member(jsii_name="putTextImage")
    def put_text_image(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageTextImage", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__752561fb6002b255d9e7d6fb10b09e29817259bfb2a0e54800e4fbadfdcf0fc5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTextImage", [value]))

    @jsii.member(jsii_name="putUrlImage")
    def put_url_image(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageUrlImage", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e935b717f8351a17f80196f1a2e3ed957bac4fec78ebcc2e3543e0a009a42200)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putUrlImage", [value]))

    @jsii.member(jsii_name="resetBoxImage")
    def reset_box_image(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBoxImage", []))

    @jsii.member(jsii_name="resetCircleImage")
    def reset_circle_image(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCircleImage", []))

    @jsii.member(jsii_name="resetTextImage")
    def reset_text_image(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTextImage", []))

    @jsii.member(jsii_name="resetUrlImage")
    def reset_url_image(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUrlImage", []))

    @builtins.property
    @jsii.member(jsii_name="boxImage")
    def box_image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageBoxImageList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageBoxImageList, jsii.get(self, "boxImage"))

    @builtins.property
    @jsii.member(jsii_name="circleImage")
    def circle_image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageCircleImageList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageCircleImageList, jsii.get(self, "circleImage"))

    @builtins.property
    @jsii.member(jsii_name="textImage")
    def text_image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageTextImageList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageTextImageList", jsii.get(self, "textImage"))

    @builtins.property
    @jsii.member(jsii_name="urlImage")
    def url_image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageUrlImageList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageUrlImageList", jsii.get(self, "urlImage"))

    @builtins.property
    @jsii.member(jsii_name="boxImageInput")
    def box_image_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageBoxImage]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageBoxImage]]], jsii.get(self, "boxImageInput"))

    @builtins.property
    @jsii.member(jsii_name="circleImageInput")
    def circle_image_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageCircleImage]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageCircleImage]]], jsii.get(self, "circleImageInput"))

    @builtins.property
    @jsii.member(jsii_name="textImageInput")
    def text_image_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageTextImage"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageTextImage"]]], jsii.get(self, "textImageInput"))

    @builtins.property
    @jsii.member(jsii_name="urlImageInput")
    def url_image_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageUrlImage"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageUrlImage"]]], jsii.get(self, "urlImageInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__da06fa8877cdbedd9b2eab77dfd37f53be9763bcbf56e7270b0cbab84fe73f6c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageTextImage",
    jsii_struct_bases=[],
    name_mapping={
        "fill": "fill",
        "fill_var": "fillVar",
        "size": "size",
        "size_var": "sizeVar",
        "stroke": "stroke",
        "stroke_size": "strokeSize",
        "stroke_size_var": "strokeSizeVar",
        "stroke_var": "strokeVar",
        "text": "text",
        "text_var": "textVar",
        "transformation": "transformation",
        "typeface": "typeface",
        "typeface_var": "typefaceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageTextImage:
    def __init__(
        self,
        *,
        fill: typing.Optional[builtins.str] = None,
        fill_var: typing.Optional[builtins.str] = None,
        size: typing.Optional[builtins.str] = None,
        size_var: typing.Optional[builtins.str] = None,
        stroke: typing.Optional[builtins.str] = None,
        stroke_size: typing.Optional[builtins.str] = None,
        stroke_size_var: typing.Optional[builtins.str] = None,
        stroke_var: typing.Optional[builtins.str] = None,
        text: typing.Optional[builtins.str] = None,
        text_var: typing.Optional[builtins.str] = None,
        transformation: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageTextImageTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        typeface: typing.Optional[builtins.str] = None,
        typeface_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fill: The main fill color of the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill DataAkamaiImagingPolicyImage#fill}
        :param fill_var: The main fill color of the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_var DataAkamaiImagingPolicyImage#fill_var}
        :param size: The size in pixels to render the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#size DataAkamaiImagingPolicyImage#size}
        :param size_var: The size in pixels to render the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#size_var DataAkamaiImagingPolicyImage#size_var}
        :param stroke: The color for the outline of the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke DataAkamaiImagingPolicyImage#stroke}
        :param stroke_size: The thickness in points for the outline of the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_size DataAkamaiImagingPolicyImage#stroke_size}
        :param stroke_size_var: The thickness in points for the outline of the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_size_var DataAkamaiImagingPolicyImage#stroke_size_var}
        :param stroke_var: The color for the outline of the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_var DataAkamaiImagingPolicyImage#stroke_var}
        :param text: The line of text to render. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text DataAkamaiImagingPolicyImage#text}
        :param text_var: The line of text to render. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text_var DataAkamaiImagingPolicyImage#text_var}
        :param transformation: transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        :param typeface: The font family to apply to the text image. This may be a URL to a TrueType or WOFF (v1) typeface, or a string that refers to one of the standard built-in browser fonts. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#typeface DataAkamaiImagingPolicyImage#typeface}
        :param typeface_var: The font family to apply to the text image. This may be a URL to a TrueType or WOFF (v1) typeface, or a string that refers to one of the standard built-in browser fonts. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#typeface_var DataAkamaiImagingPolicyImage#typeface_var}
        '''
        if isinstance(transformation, dict):
            transformation = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageTextImageTransformation(**transformation)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7727416ff69775bef741e9274809ecc1fba401e1a7b84d4d3b83f27b87a39f89)
            check_type(argname="argument fill", value=fill, expected_type=type_hints["fill"])
            check_type(argname="argument fill_var", value=fill_var, expected_type=type_hints["fill_var"])
            check_type(argname="argument size", value=size, expected_type=type_hints["size"])
            check_type(argname="argument size_var", value=size_var, expected_type=type_hints["size_var"])
            check_type(argname="argument stroke", value=stroke, expected_type=type_hints["stroke"])
            check_type(argname="argument stroke_size", value=stroke_size, expected_type=type_hints["stroke_size"])
            check_type(argname="argument stroke_size_var", value=stroke_size_var, expected_type=type_hints["stroke_size_var"])
            check_type(argname="argument stroke_var", value=stroke_var, expected_type=type_hints["stroke_var"])
            check_type(argname="argument text", value=text, expected_type=type_hints["text"])
            check_type(argname="argument text_var", value=text_var, expected_type=type_hints["text_var"])
            check_type(argname="argument transformation", value=transformation, expected_type=type_hints["transformation"])
            check_type(argname="argument typeface", value=typeface, expected_type=type_hints["typeface"])
            check_type(argname="argument typeface_var", value=typeface_var, expected_type=type_hints["typeface_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fill is not None:
            self._values["fill"] = fill
        if fill_var is not None:
            self._values["fill_var"] = fill_var
        if size is not None:
            self._values["size"] = size
        if size_var is not None:
            self._values["size_var"] = size_var
        if stroke is not None:
            self._values["stroke"] = stroke
        if stroke_size is not None:
            self._values["stroke_size"] = stroke_size
        if stroke_size_var is not None:
            self._values["stroke_size_var"] = stroke_size_var
        if stroke_var is not None:
            self._values["stroke_var"] = stroke_var
        if text is not None:
            self._values["text"] = text
        if text_var is not None:
            self._values["text_var"] = text_var
        if transformation is not None:
            self._values["transformation"] = transformation
        if typeface is not None:
            self._values["typeface"] = typeface
        if typeface_var is not None:
            self._values["typeface_var"] = typeface_var

    @builtins.property
    def fill(self) -> typing.Optional[builtins.str]:
        '''The main fill color of the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill DataAkamaiImagingPolicyImage#fill}
        '''
        result = self._values.get("fill")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fill_var(self) -> typing.Optional[builtins.str]:
        '''The main fill color of the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_var DataAkamaiImagingPolicyImage#fill_var}
        '''
        result = self._values.get("fill_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def size(self) -> typing.Optional[builtins.str]:
        '''The size in pixels to render the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#size DataAkamaiImagingPolicyImage#size}
        '''
        result = self._values.get("size")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def size_var(self) -> typing.Optional[builtins.str]:
        '''The size in pixels to render the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#size_var DataAkamaiImagingPolicyImage#size_var}
        '''
        result = self._values.get("size_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def stroke(self) -> typing.Optional[builtins.str]:
        '''The color for the outline of the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke DataAkamaiImagingPolicyImage#stroke}
        '''
        result = self._values.get("stroke")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def stroke_size(self) -> typing.Optional[builtins.str]:
        '''The thickness in points for the outline of the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_size DataAkamaiImagingPolicyImage#stroke_size}
        '''
        result = self._values.get("stroke_size")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def stroke_size_var(self) -> typing.Optional[builtins.str]:
        '''The thickness in points for the outline of the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_size_var DataAkamaiImagingPolicyImage#stroke_size_var}
        '''
        result = self._values.get("stroke_size_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def stroke_var(self) -> typing.Optional[builtins.str]:
        '''The color for the outline of the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_var DataAkamaiImagingPolicyImage#stroke_var}
        '''
        result = self._values.get("stroke_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def text(self) -> typing.Optional[builtins.str]:
        '''The line of text to render.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text DataAkamaiImagingPolicyImage#text}
        '''
        result = self._values.get("text")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def text_var(self) -> typing.Optional[builtins.str]:
        '''The line of text to render.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text_var DataAkamaiImagingPolicyImage#text_var}
        '''
        result = self._values.get("text_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def transformation(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageTextImageTransformation"]:
        '''transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        '''
        result = self._values.get("transformation")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageTextImageTransformation"], result)

    @builtins.property
    def typeface(self) -> typing.Optional[builtins.str]:
        '''The font family to apply to the text image.

        This may be a URL to a TrueType or WOFF (v1) typeface, or a string that refers to one of the standard built-in browser fonts.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#typeface DataAkamaiImagingPolicyImage#typeface}
        '''
        result = self._values.get("typeface")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def typeface_var(self) -> typing.Optional[builtins.str]:
        '''The font family to apply to the text image.

        This may be a URL to a TrueType or WOFF (v1) typeface, or a string that refers to one of the standard built-in browser fonts.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#typeface_var DataAkamaiImagingPolicyImage#typeface_var}
        '''
        result = self._values.get("typeface_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageTextImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageTextImageList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageTextImageList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0e8aa57ff8cc77af7aba76ceb03748709a0237ec6d414c2bcc15e5fa259b873a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageTextImageOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__703e46403cccb99145879f74ece09106b0d3bf091ccb0c5af83ced25952053db)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageTextImageOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__790dbefcdacaf6190a7390f06a4fd97a431606d38043adde7fae081af65b0e04)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d0b4d293630db55934fc698422d0f025490ce47fdf4d74048487b58320662329)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__76cfb7dc77cb11a71ac65959df73b3ee11ae32e516737bbf7878a8d85e666755)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageTextImage]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageTextImage]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageTextImage]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5c7f35af54ef1ce6c47f6c1bbbefdd2c994dca794aed7e507b1a96af23f60cda)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageTextImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageTextImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b55f647be44f583308aae778c2b1764f1713efdca40b435b16ccfa30f0077315)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformation")
    def put_transformation(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageTextImageTransformation()

        return typing.cast(None, jsii.invoke(self, "putTransformation", [value]))

    @jsii.member(jsii_name="resetFill")
    def reset_fill(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFill", []))

    @jsii.member(jsii_name="resetFillVar")
    def reset_fill_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFillVar", []))

    @jsii.member(jsii_name="resetSize")
    def reset_size(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSize", []))

    @jsii.member(jsii_name="resetSizeVar")
    def reset_size_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSizeVar", []))

    @jsii.member(jsii_name="resetStroke")
    def reset_stroke(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStroke", []))

    @jsii.member(jsii_name="resetStrokeSize")
    def reset_stroke_size(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStrokeSize", []))

    @jsii.member(jsii_name="resetStrokeSizeVar")
    def reset_stroke_size_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStrokeSizeVar", []))

    @jsii.member(jsii_name="resetStrokeVar")
    def reset_stroke_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStrokeVar", []))

    @jsii.member(jsii_name="resetText")
    def reset_text(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetText", []))

    @jsii.member(jsii_name="resetTextVar")
    def reset_text_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTextVar", []))

    @jsii.member(jsii_name="resetTransformation")
    def reset_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformation", []))

    @jsii.member(jsii_name="resetTypeface")
    def reset_typeface(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeface", []))

    @jsii.member(jsii_name="resetTypefaceVar")
    def reset_typeface_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypefaceVar", []))

    @builtins.property
    @jsii.member(jsii_name="transformation")
    def transformation(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageTextImageTransformationOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageTextImageTransformationOutputReference", jsii.get(self, "transformation"))

    @builtins.property
    @jsii.member(jsii_name="fillInput")
    def fill_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fillInput"))

    @builtins.property
    @jsii.member(jsii_name="fillVarInput")
    def fill_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fillVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sizeInput")
    def size_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sizeInput"))

    @builtins.property
    @jsii.member(jsii_name="sizeVarInput")
    def size_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sizeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="strokeInput")
    def stroke_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "strokeInput"))

    @builtins.property
    @jsii.member(jsii_name="strokeSizeInput")
    def stroke_size_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "strokeSizeInput"))

    @builtins.property
    @jsii.member(jsii_name="strokeSizeVarInput")
    def stroke_size_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "strokeSizeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="strokeVarInput")
    def stroke_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "strokeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="textInput")
    def text_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "textInput"))

    @builtins.property
    @jsii.member(jsii_name="textVarInput")
    def text_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "textVarInput"))

    @builtins.property
    @jsii.member(jsii_name="transformationInput")
    def transformation_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageTextImageTransformation"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageTextImageTransformation"], jsii.get(self, "transformationInput"))

    @builtins.property
    @jsii.member(jsii_name="typefaceInput")
    def typeface_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typefaceInput"))

    @builtins.property
    @jsii.member(jsii_name="typefaceVarInput")
    def typeface_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typefaceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="fill")
    def fill(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fill"))

    @fill.setter
    def fill(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__87fe7683a36e4151751c97b4b9d0d1487fe7740fd91941a6b5bd4ecdeaee3c31)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fill", value)

    @builtins.property
    @jsii.member(jsii_name="fillVar")
    def fill_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fillVar"))

    @fill_var.setter
    def fill_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__82e987b30634f7880ceeecb522633ae822f14c774a3bc93f170057da0bdbd6d2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fillVar", value)

    @builtins.property
    @jsii.member(jsii_name="size")
    def size(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "size"))

    @size.setter
    def size(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__83d901057dbd057378e95330841c2b1d7c04fc5d2a55e7c9a0a0ef1d30cea964)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "size", value)

    @builtins.property
    @jsii.member(jsii_name="sizeVar")
    def size_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sizeVar"))

    @size_var.setter
    def size_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__689b14b6e61319d536689f4e7cc2044bc1bb8e31bcbef8e17d08c44861617f3c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sizeVar", value)

    @builtins.property
    @jsii.member(jsii_name="stroke")
    def stroke(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "stroke"))

    @stroke.setter
    def stroke(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ad59f554ef88359f01d3bbc256c75a936a2d387341a49ef29afc24f3bb81c56)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "stroke", value)

    @builtins.property
    @jsii.member(jsii_name="strokeSize")
    def stroke_size(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "strokeSize"))

    @stroke_size.setter
    def stroke_size(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__860a62505c7dfd9d7740c4fef537fe0a1a2b60b3a6ea227a6b444653b95b1d21)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "strokeSize", value)

    @builtins.property
    @jsii.member(jsii_name="strokeSizeVar")
    def stroke_size_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "strokeSizeVar"))

    @stroke_size_var.setter
    def stroke_size_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8234338e3611e8b9ddf2393db4b736aa13054e4c9e968b9b7d9208e5afc5fe21)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "strokeSizeVar", value)

    @builtins.property
    @jsii.member(jsii_name="strokeVar")
    def stroke_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "strokeVar"))

    @stroke_var.setter
    def stroke_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a848f404a47d26b06de8064a170ab1d17bb14dceed91d066925794efb2638caf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "strokeVar", value)

    @builtins.property
    @jsii.member(jsii_name="text")
    def text(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "text"))

    @text.setter
    def text(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__470ebf1f4488fa596d95527fd6a60de5735f03ee372015d6b69cb26381c56e71)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "text", value)

    @builtins.property
    @jsii.member(jsii_name="textVar")
    def text_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "textVar"))

    @text_var.setter
    def text_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d3b85a64389bf1125801dcf47b4944de73f42dca12930f5cbbf4a4cb17527c5b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "textVar", value)

    @builtins.property
    @jsii.member(jsii_name="typeface")
    def typeface(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeface"))

    @typeface.setter
    def typeface(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__58ba26b26982240d4c5983987aa1f0541bf54b9ba33b90e98de35ecc5ef0216b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeface", value)

    @builtins.property
    @jsii.member(jsii_name="typefaceVar")
    def typeface_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typefaceVar"))

    @typeface_var.setter
    def typeface_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dfaaaee5e99c6cd39c489d56dff68e7e6dfff2aeeb81e199895cc3a56d8fda6a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typefaceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageTextImage]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageTextImage]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageTextImage]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__905102004a40c3e3e48a23875b181fc671db2c2f71bf999c3606a256bfed065e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageTextImageTransformation",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageTextImageTransformation:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageTextImageTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageTextImageTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageTextImageTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__49ac7801e494b9ffdfa1e5a3610ae8b067816cb8670d459212de53b80e144399)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageTextImageTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageTextImageTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageTextImageTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6825d9f1f284e035de3744d7ef967ed0ed6aeab6a7fe03e6aaa0c8b79d22e27c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageUrlImage",
    jsii_struct_bases=[],
    name_mapping={
        "transformation": "transformation",
        "url": "url",
        "url_var": "urlVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageUrlImage:
    def __init__(
        self,
        *,
        transformation: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageUrlImageTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        url: typing.Optional[builtins.str] = None,
        url_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param transformation: transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        :param url: The URL of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url DataAkamaiImagingPolicyImage#url}
        :param url_var: The URL of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url_var DataAkamaiImagingPolicyImage#url_var}
        '''
        if isinstance(transformation, dict):
            transformation = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageUrlImageTransformation(**transformation)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fc8f3074fbbafee44a20da231f87288bfc0e89dfdde3232dc1b4eba523b79743)
            check_type(argname="argument transformation", value=transformation, expected_type=type_hints["transformation"])
            check_type(argname="argument url", value=url, expected_type=type_hints["url"])
            check_type(argname="argument url_var", value=url_var, expected_type=type_hints["url_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if transformation is not None:
            self._values["transformation"] = transformation
        if url is not None:
            self._values["url"] = url
        if url_var is not None:
            self._values["url_var"] = url_var

    @builtins.property
    def transformation(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageUrlImageTransformation"]:
        '''transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        '''
        result = self._values.get("transformation")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageUrlImageTransformation"], result)

    @builtins.property
    def url(self) -> typing.Optional[builtins.str]:
        '''The URL of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url DataAkamaiImagingPolicyImage#url}
        '''
        result = self._values.get("url")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def url_var(self) -> typing.Optional[builtins.str]:
        '''The URL of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url_var DataAkamaiImagingPolicyImage#url_var}
        '''
        result = self._values.get("url_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageUrlImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageUrlImageList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageUrlImageList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__425b29b51b72b39722ee2ecd3a1f7ceb8a6918aa2ddb668c66c1eae53f23f8ed)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageUrlImageOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__17c28083cfdcdde907b8a3787b9b68d2be19c1c933344aed757ca2344fa43847)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageUrlImageOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5167096d77b42606dbc6547aacd549f7203cdb2ea1c08092e3e98448aa9a3042)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__048bd55b748f2cf5c231d1f29e8c0dfa2cd23f5deb07968100bb806f5f7a59e8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8cabdaaa9288e6c232954db1caaea8a46cb1c8ac8a6eff8504b633da7cd64b97)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageUrlImage]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageUrlImage]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageUrlImage]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__72fd474a5bbfcf451e7fa72ef1fe73092bf9a8505216422f3b1dcb43493d98f7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageUrlImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageUrlImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4bc6d3e43d0b47f0bddafd664892ebcca79039c7d3e3ba7b75fb54f61d439d5b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformation")
    def put_transformation(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageUrlImageTransformation()

        return typing.cast(None, jsii.invoke(self, "putTransformation", [value]))

    @jsii.member(jsii_name="resetTransformation")
    def reset_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformation", []))

    @jsii.member(jsii_name="resetUrl")
    def reset_url(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUrl", []))

    @jsii.member(jsii_name="resetUrlVar")
    def reset_url_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUrlVar", []))

    @builtins.property
    @jsii.member(jsii_name="transformation")
    def transformation(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageUrlImageTransformationOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageUrlImageTransformationOutputReference", jsii.get(self, "transformation"))

    @builtins.property
    @jsii.member(jsii_name="transformationInput")
    def transformation_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageUrlImageTransformation"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageUrlImageTransformation"], jsii.get(self, "transformationInput"))

    @builtins.property
    @jsii.member(jsii_name="urlInput")
    def url_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "urlInput"))

    @builtins.property
    @jsii.member(jsii_name="urlVarInput")
    def url_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "urlVarInput"))

    @builtins.property
    @jsii.member(jsii_name="url")
    def url(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "url"))

    @url.setter
    def url(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ba21365756524f08bc98de9f835371ab0d31deda524e59e10071494422933a8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "url", value)

    @builtins.property
    @jsii.member(jsii_name="urlVar")
    def url_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "urlVar"))

    @url_var.setter
    def url_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dc7fc90984210978ac3f66e7367a75a95fbeda24d18aed3dcb243923c45cba75)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "urlVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageUrlImage]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageUrlImage]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageUrlImage]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8ca7d67c172ca5a6886e9c24e1e43b3775c4c9d80bd18de42b971f85f95698c4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageUrlImageTransformation",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageUrlImageTransformation:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageUrlImageTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageUrlImageTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageUrlImageTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e45dc7cd87cb91e0e7f958d4d8fb515b23922bcd716a6efa620d503f0d235126)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageUrlImageTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageUrlImageTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageUrlImageTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__928f7aa38310e69f59f9da817b2070f69edce433c53a77560ef76d7b8fdc8515)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c45467f3160b8bc79fb0e6d64d0c3edc84d763ec6397a989d9ea9364a65366be)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a657cca15f4363d19ce77954918818c15f6ffd1c2a15901025b7fc4718006946)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cfd2c0a34851a1a80067cec1d32bd3756aa4c6d721b68dad5929ecd58ddd00f6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1524b45156658b1126fc30b69ce8640e0077f7ca90fa131361613777b1625044)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d7b27635be36d432029e7e1b11d6631c56d17c5aa3cdd22a92280629910fda24)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppend]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppend]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppend]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__794e912b16c28d38403c3c44d2ecec5117bb35d7117191945256c1e4f5b4145e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7e9a8e52c7b3437f5d46006fa532e948307821df1d484011c027083eb4f50f11)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(
        self,
        *,
        box_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageBoxImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
        circle_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageCircleImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
        text_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageTextImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
        url_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageUrlImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param box_image: box_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#box_image DataAkamaiImagingPolicyImage#box_image}
        :param circle_image: circle_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#circle_image DataAkamaiImagingPolicyImage#circle_image}
        :param text_image: text_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text_image DataAkamaiImagingPolicyImage#text_image}
        :param url_image: url_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url_image DataAkamaiImagingPolicyImage#url_image}
        '''
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImage(
            box_image=box_image,
            circle_image=circle_image,
            text_image=text_image,
            url_image=url_image,
        )

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityPriority")
    def reset_gravity_priority(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityPriority", []))

    @jsii.member(jsii_name="resetGravityPriorityVar")
    def reset_gravity_priority_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityPriorityVar", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPreserveMinorDimension")
    def reset_preserve_minor_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPreserveMinorDimension", []))

    @jsii.member(jsii_name="resetPreserveMinorDimensionVar")
    def reset_preserve_minor_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPreserveMinorDimensionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityInput")
    def gravity_priority_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityPriorityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityVarInput")
    def gravity_priority_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityPriorityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionInput")
    def preserve_minor_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "preserveMinorDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionVarInput")
    def preserve_minor_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "preserveMinorDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6faa2a079ed8b5a5b30a346b906c7d99aeac9ea9f13ecb86034d53f668332e32)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityPriority")
    def gravity_priority(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityPriority"))

    @gravity_priority.setter
    def gravity_priority(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ef1ff785722595554cd9467ffcc84043340206383571cabefc19dfd9554ac032)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityPriority", value)

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityVar")
    def gravity_priority_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityPriorityVar"))

    @gravity_priority_var.setter
    def gravity_priority_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__18e4e903cd264c8f38819384372fff681fd18eac883822cc97a16c7dd27221c1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityPriorityVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__39dac0768632984174b1e2078d20b9ad27bda0ddc05f3a31f082854941e2a895)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimension")
    def preserve_minor_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "preserveMinorDimension"))

    @preserve_minor_dimension.setter
    def preserve_minor_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8231c8d3d963df7fe5b62c4eac1a3b4e23e782161e9a25f321f37c5c16a918db)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "preserveMinorDimension", value)

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionVar")
    def preserve_minor_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "preserveMinorDimensionVar"))

    @preserve_minor_dimension_var.setter
    def preserve_minor_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b6c084f314f742c033f64f2e60f3d7c87fbf347c34d04f21e3b711d0e85bbfab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "preserveMinorDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppend]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppend]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppend]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a34ce4ddc51dc7c9b7216308b07d5b14a22d53be9b4c09aeead6794d60b0a28f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAspectCrop",
    jsii_struct_bases=[],
    name_mapping={
        "allow_expansion": "allowExpansion",
        "allow_expansion_var": "allowExpansionVar",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAspectCrop:
    def __init__(
        self,
        *,
        allow_expansion: typing.Optional[builtins.str] = None,
        allow_expansion_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_expansion: Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image. Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        :param allow_expansion_var: Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image. Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        :param height: The height term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The width term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        :param x_position: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__252233160d12023eb844426bc8bbb3348439a7def092ed789c9240688ea5bb94)
            check_type(argname="argument allow_expansion", value=allow_expansion, expected_type=type_hints["allow_expansion"])
            check_type(argname="argument allow_expansion_var", value=allow_expansion_var, expected_type=type_hints["allow_expansion_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if allow_expansion is not None:
            self._values["allow_expansion"] = allow_expansion
        if allow_expansion_var is not None:
            self._values["allow_expansion_var"] = allow_expansion_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def allow_expansion(self) -> typing.Optional[builtins.str]:
        '''Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image.

        Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        '''
        result = self._values.get("allow_expansion")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def allow_expansion_var(self) -> typing.Optional[builtins.str]:
        '''Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image.

        Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        '''
        result = self._values.get("allow_expansion_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAspectCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAspectCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAspectCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3f39b65296659ae1fd32747fe51507e0b8c69767031bd57f18afb97ab184c4ab)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAspectCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__41d5d28451f11557174ba8ec19398fde98c7587a9d48c28da24a9b78ea755419)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAspectCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac33dbe3031aa8fef5def3061ea263fd0f906dc493c5a44c71260694a49ccc9e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__48749387a733f197aabba30e2eb6d9b8b9f8f1982e1d6ae16fb7afde0f66e76b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c8c14586c794227249d727355cc23ea04ed1053fbbb8cd7a83e56edf7415e1d1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAspectCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAspectCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAspectCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__93ba1debab9492dd2efab41a2675f3b6ced908e68634152e30f7e988f0068349)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAspectCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAspectCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1d0a8b93b6df5a35defd72d126419dd131ccc7bd48c3d1e2145f3ce55e4a1878)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAllowExpansion")
    def reset_allow_expansion(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansion", []))

    @jsii.member(jsii_name="resetAllowExpansionVar")
    def reset_allow_expansion_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansionVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionInput")
    def allow_expansion_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVarInput")
    def allow_expansion_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansion")
    def allow_expansion(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansion"))

    @allow_expansion.setter
    def allow_expansion(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7f724ed0b01d45692322822806ddc3305f198b12443394bab23a0efe1509abc9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansion", value)

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVar")
    def allow_expansion_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansionVar"))

    @allow_expansion_var.setter
    def allow_expansion_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__41a8733af1d220fd80962f708e6671fadceea5aca6d9d18623feeb41a994909f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansionVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__73616282452f2d11117d8bbf8495d3b6e67ad96e38ead1164f7051cec53eb59a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5b00aa228e6e1508dc470d7c7b3a52d632e492f902f39a8117ecf029ddb27e50)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__24cdef171add0ad5c317b495857fd0dfb07927fbe37f300731ee35179e8cd5d1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5848bebce829ebc42a36c787667283c4ed1ed684bb9cd90bc1661f742bb6dcee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__99fd169f6ab395312d6c696f6b69c1e91f6753e3f0e49a23f6193e9edfd8e887)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7e64e64518cbb88aac8e7182985fb6d1aabbae4ff07a509878b1f5301b6c7b67)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0bd76b46655ca146f120facd913d5b9b3e6e704c1796d7a8708deb0f048367ed)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab38906043d9b5228c9ef2b0ffdcc5e57d2727c427941007d3f3f61e19302519)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAspectCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAspectCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAspectCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5bedeee4c1633d27218f51aa5119e5a717cfa3051229c88cc137299c307dd58a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultBackgroundColor",
    jsii_struct_bases=[],
    name_mapping={"color": "color", "color_var": "colorVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultBackgroundColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__339b60254dadf299d1a6ca0d9864ee297d5efc5a243ade047ce74eb0f9a9cee7)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultBackgroundColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultBackgroundColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultBackgroundColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__80663ce56607b52b9d30edcf4806b4c18d3bd25647c0e108e1a736c01bc4c978)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultBackgroundColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9842bb2ccbcdb573d39aac86f23fdeeb0d41080c1c9eef69d506796db4387863)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultBackgroundColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6adec3f449154f1c7bd3b0f381b8d6c61e4859187cd2e912712f023064afc25d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ea9783f5f0b814143d0a1e990c59a623981c659514c7dca0682887bb9df3e2d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b61771a4d3a34e360290a43ed7d4ca7e0f7728b0eab706598aead65aeca748ef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultBackgroundColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultBackgroundColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9af2749100c5416aafc875872267ecef901102142886d09f11d72d3cf2fc9a02)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultBackgroundColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultBackgroundColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b5079859fb7d9e86a98a1305ca0001fc2c26b3091281c280801d9ff508d36f56)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a3fcd14740bf7de985e09c26d66919ce1202be392ae6cb489c7b66dd278a014a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__44cc843817fcd8954a7d2518d6e9b2ca7bb6e323cde3e376aa122cce4614112b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultBackgroundColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultBackgroundColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultBackgroundColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ef4ceb634e9b64a71f400496b3fc55cfd51198055c5474a5b07431ce3951400)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultBlur",
    jsii_struct_bases=[],
    name_mapping={"sigma": "sigma", "sigma_var": "sigmaVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultBlur:
    def __init__(
        self,
        *,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param sigma: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f4481da3460ed481711e8dac82b977770c99f2a97bee1c00b847848818274171)
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultBlur(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultBlurList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultBlurList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__040775b89e04e8ac534bb7bf87ac3a99e9126b47f7a4e3587c431af77ff0e823)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultBlurOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__209f22cb69379ad15c11bd060bda851c4d10ef8d40723171f4c044a5ec04e3c0)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultBlurOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__662fd2646ac226cd1be924fc1d4c839e4585d9aa7f28e78a8151c03139714b1b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c6983e0c4301f183c96fa04a5acef7b10eb0630c6c5a71db00702b293827b024)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a07dbc1c511fb035100d773261d748708e5c6d2f4dc50f93676706c627dd9430)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultBlur]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultBlur]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3161c6624538caa67e3f47396f5f712c244d728549751ed774a2b1201e72e6f7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultBlurOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultBlurOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ccd2f295172527decf191fb0ab81f669d4c692cf1465cd5617b865ea7b41859)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8d06ff3da8231fd1fa48efbb7d8df2eaaedacf875c954b0902cd75ecea5f0066)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ac4e8fc34936cf7209e6f538b31491c84375524767e701990492cda80206856)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultBlur]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultBlur]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultBlur]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__55711bbb8543de1f91e129c31a81d4359390cd8744cd733581fad7e5295bd047)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultChromaKey",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_feather": "hueFeather",
        "hue_feather_var": "hueFeatherVar",
        "hue_tolerance": "hueTolerance",
        "hue_tolerance_var": "hueToleranceVar",
        "hue_var": "hueVar",
        "lightness_feather": "lightnessFeather",
        "lightness_feather_var": "lightnessFeatherVar",
        "lightness_tolerance": "lightnessTolerance",
        "lightness_tolerance_var": "lightnessToleranceVar",
        "saturation_feather": "saturationFeather",
        "saturation_feather_var": "saturationFeatherVar",
        "saturation_tolerance": "saturationTolerance",
        "saturation_tolerance_var": "saturationToleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultChromaKey:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_feather: typing.Optional[builtins.str] = None,
        hue_feather_var: typing.Optional[builtins.str] = None,
        hue_tolerance: typing.Optional[builtins.str] = None,
        hue_tolerance_var: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness_feather: typing.Optional[builtins.str] = None,
        lightness_feather_var: typing.Optional[builtins.str] = None,
        lightness_tolerance: typing.Optional[builtins.str] = None,
        lightness_tolerance_var: typing.Optional[builtins.str] = None,
        saturation_feather: typing.Optional[builtins.str] = None,
        saturation_feather_var: typing.Optional[builtins.str] = None,
        saturation_tolerance: typing.Optional[builtins.str] = None,
        saturation_tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_feather: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        :param hue_feather_var: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        :param hue_tolerance: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        :param hue_tolerance_var: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        :param hue_var: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness_feather: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        :param lightness_feather_var: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        :param lightness_tolerance: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        :param lightness_tolerance_var: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        :param saturation_feather: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        :param saturation_feather_var: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        :param saturation_tolerance: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        :param saturation_tolerance_var: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7f07a5b07a593bbb216b53c72dafe46a2938517cd998ef396c30c1f430ba12b7)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_feather", value=hue_feather, expected_type=type_hints["hue_feather"])
            check_type(argname="argument hue_feather_var", value=hue_feather_var, expected_type=type_hints["hue_feather_var"])
            check_type(argname="argument hue_tolerance", value=hue_tolerance, expected_type=type_hints["hue_tolerance"])
            check_type(argname="argument hue_tolerance_var", value=hue_tolerance_var, expected_type=type_hints["hue_tolerance_var"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness_feather", value=lightness_feather, expected_type=type_hints["lightness_feather"])
            check_type(argname="argument lightness_feather_var", value=lightness_feather_var, expected_type=type_hints["lightness_feather_var"])
            check_type(argname="argument lightness_tolerance", value=lightness_tolerance, expected_type=type_hints["lightness_tolerance"])
            check_type(argname="argument lightness_tolerance_var", value=lightness_tolerance_var, expected_type=type_hints["lightness_tolerance_var"])
            check_type(argname="argument saturation_feather", value=saturation_feather, expected_type=type_hints["saturation_feather"])
            check_type(argname="argument saturation_feather_var", value=saturation_feather_var, expected_type=type_hints["saturation_feather_var"])
            check_type(argname="argument saturation_tolerance", value=saturation_tolerance, expected_type=type_hints["saturation_tolerance"])
            check_type(argname="argument saturation_tolerance_var", value=saturation_tolerance_var, expected_type=type_hints["saturation_tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_feather is not None:
            self._values["hue_feather"] = hue_feather
        if hue_feather_var is not None:
            self._values["hue_feather_var"] = hue_feather_var
        if hue_tolerance is not None:
            self._values["hue_tolerance"] = hue_tolerance
        if hue_tolerance_var is not None:
            self._values["hue_tolerance_var"] = hue_tolerance_var
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness_feather is not None:
            self._values["lightness_feather"] = lightness_feather
        if lightness_feather_var is not None:
            self._values["lightness_feather_var"] = lightness_feather_var
        if lightness_tolerance is not None:
            self._values["lightness_tolerance"] = lightness_tolerance
        if lightness_tolerance_var is not None:
            self._values["lightness_tolerance_var"] = lightness_tolerance_var
        if saturation_feather is not None:
            self._values["saturation_feather"] = saturation_feather
        if saturation_feather_var is not None:
            self._values["saturation_feather_var"] = saturation_feather_var
        if saturation_tolerance is not None:
            self._values["saturation_tolerance"] = saturation_tolerance
        if saturation_tolerance_var is not None:
            self._values["saturation_tolerance_var"] = saturation_tolerance_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        '''
        result = self._values.get("hue_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        '''
        result = self._values.get("hue_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        '''
        result = self._values.get("hue_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        '''
        result = self._values.get("hue_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        '''
        result = self._values.get("lightness_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        '''
        result = self._values.get("lightness_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        '''
        result = self._values.get("lightness_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        '''
        result = self._values.get("lightness_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        '''
        result = self._values.get("saturation_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        '''
        result = self._values.get("saturation_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        '''
        result = self._values.get("saturation_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        result = self._values.get("saturation_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultChromaKey(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultChromaKeyList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultChromaKeyList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e0fdc6dfa92f9f9c993b3d1389b2ce57ca7130ae5d0507c10f6198008ded5de9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultChromaKeyOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a505994d46dfe0c58d28c2b2e26d941ffe4f43fce58b656cc9eaa9d4b37be35e)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultChromaKeyOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__efbf2a80b0afa1bbcf5c362ce4a38f9fd46a7b966b58a0540fa33d831b24565b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be42eec25de579983be33bb66a41cbd764ed80003266f57e167175a0cbd58c61)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9707084e5b2acead32dc7e670b5a5dd372ae62335790a12de1107b78975fa3fb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultChromaKey]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultChromaKey]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a3f878a402d1f04985c1477a12cc343c464245e29ac4d3c27f728adce91c365)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultChromaKeyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultChromaKeyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__48a47f18021e35c03a9f167909edfd6aaaa2b4c1b7c187896ffe2f16f7106a03)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueFeather")
    def reset_hue_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeather", []))

    @jsii.member(jsii_name="resetHueFeatherVar")
    def reset_hue_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeatherVar", []))

    @jsii.member(jsii_name="resetHueTolerance")
    def reset_hue_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueTolerance", []))

    @jsii.member(jsii_name="resetHueToleranceVar")
    def reset_hue_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueToleranceVar", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightnessFeather")
    def reset_lightness_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeather", []))

    @jsii.member(jsii_name="resetLightnessFeatherVar")
    def reset_lightness_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeatherVar", []))

    @jsii.member(jsii_name="resetLightnessTolerance")
    def reset_lightness_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessTolerance", []))

    @jsii.member(jsii_name="resetLightnessToleranceVar")
    def reset_lightness_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessToleranceVar", []))

    @jsii.member(jsii_name="resetSaturationFeather")
    def reset_saturation_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeather", []))

    @jsii.member(jsii_name="resetSaturationFeatherVar")
    def reset_saturation_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeatherVar", []))

    @jsii.member(jsii_name="resetSaturationTolerance")
    def reset_saturation_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationTolerance", []))

    @jsii.member(jsii_name="resetSaturationToleranceVar")
    def reset_saturation_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherInput")
    def hue_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVarInput")
    def hue_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceInput")
    def hue_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVarInput")
    def hue_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherInput")
    def lightness_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVarInput")
    def lightness_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceInput")
    def lightness_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVarInput")
    def lightness_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherInput")
    def saturation_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVarInput")
    def saturation_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceInput")
    def saturation_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVarInput")
    def saturation_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__adec7e8f20686150d60f27cd7d4811b5773a0e2f52008fcb8c54c172fa1e9df9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeather")
    def hue_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeather"))

    @hue_feather.setter
    def hue_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c502d1f5877d744d88bcd6fd074ad95f9cf2472b89bc9f95ca0733942561b75a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeather", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVar")
    def hue_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeatherVar"))

    @hue_feather_var.setter
    def hue_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5e685fa33e9a3752d6fe80739b6587445c96e2e6a2735bd3ff4f148fecff1abf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueTolerance")
    def hue_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueTolerance"))

    @hue_tolerance.setter
    def hue_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3fe02cf163e9c2b39addb9170a79337e3c0a371a74846f36671e3f83e4bc7144)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVar")
    def hue_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueToleranceVar"))

    @hue_tolerance_var.setter
    def hue_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cc1a60b56c64d0b156c9539da787dcefaf4fe4ff8f670a487bad28d23d9216b5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b428c1f0df8b4253b8197f21e9ceac5209cc49030e516a78a84ac3fbf64ad406)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeather")
    def lightness_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeather"))

    @lightness_feather.setter
    def lightness_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__64f5cc5f8e19943a7c97bf884bcbb4370a6bbe52906ea40eb28ca7d747cc3ccf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeather", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVar")
    def lightness_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeatherVar"))

    @lightness_feather_var.setter
    def lightness_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6456176c1dcc65b98cebbafa6911a64fe6666ef658de1e43a1c48fad84d0e86b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessTolerance")
    def lightness_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessTolerance"))

    @lightness_tolerance.setter
    def lightness_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a0edfba9c34f1df6a9a8d91f96c2081885e83a7f66c136aaa8dc000421492122)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVar")
    def lightness_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessToleranceVar"))

    @lightness_tolerance_var.setter
    def lightness_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2acedc93b833aa0713ad8c6339c42c3e9b1fa95d3c0a6fc2ada9740612ba8b1c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeather")
    def saturation_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeather"))

    @saturation_feather.setter
    def saturation_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d2b5988aa6e685c56a82c37d87ad6a1032cfcd5d8ea9b5a07cee1e8310772281)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeather", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVar")
    def saturation_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeatherVar"))

    @saturation_feather_var.setter
    def saturation_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__63aa04d8a6ac5cf29ba90e71140202df26ef1d283b70d385c4aeb5676c1ebd2d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationTolerance")
    def saturation_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationTolerance"))

    @saturation_tolerance.setter
    def saturation_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a8bb2fbc46a65119eb9592fceda3f63503a343dbe4c79e33b0d0447deebccc51)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVar")
    def saturation_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationToleranceVar"))

    @saturation_tolerance_var.setter
    def saturation_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f2892c1fd474c4ccfb78fb6d105b924aae023283c992d13671a5316dea4df9f5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultChromaKey]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultChromaKey]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultChromaKey]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8b73bd9b5caba123bfec1da9e24c9fac41ba3e2eeb575331f34da3b0017a8a9f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultComposite",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "placement": "placement",
        "placement_var": "placementVar",
        "scale": "scale",
        "scale_dimension": "scaleDimension",
        "scale_dimension_var": "scaleDimensionVar",
        "scale_var": "scaleVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultComposite:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        placement: typing.Optional[builtins.str] = None,
        placement_var: typing.Optional[builtins.str] = None,
        scale: typing.Optional[builtins.str] = None,
        scale_dimension: typing.Optional[builtins.str] = None,
        scale_dimension_var: typing.Optional[builtins.str] = None,
        scale_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param placement: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        :param placement_var: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        :param scale: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param scale_dimension: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        :param scale_dimension_var: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        :param scale_var: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        :param x_position: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0fd3e721a4797eae77dae6e1a8be432daeabdb533c51f6812b1443207a9fa171)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument placement", value=placement, expected_type=type_hints["placement"])
            check_type(argname="argument placement_var", value=placement_var, expected_type=type_hints["placement_var"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument scale_dimension", value=scale_dimension, expected_type=type_hints["scale_dimension"])
            check_type(argname="argument scale_dimension_var", value=scale_dimension_var, expected_type=type_hints["scale_dimension_var"])
            check_type(argname="argument scale_var", value=scale_var, expected_type=type_hints["scale_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if placement is not None:
            self._values["placement"] = placement
        if placement_var is not None:
            self._values["placement_var"] = placement_var
        if scale is not None:
            self._values["scale"] = scale
        if scale_dimension is not None:
            self._values["scale_dimension"] = scale_dimension
        if scale_dimension_var is not None:
            self._values["scale_dimension_var"] = scale_dimension_var
        if scale_var is not None:
            self._values["scale_var"] = scale_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        '''
        result = self._values.get("placement")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement_var(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        '''
        result = self._values.get("placement_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        '''
        result = self._values.get("scale_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        '''
        result = self._values.get("scale_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        '''
        result = self._values.get("scale_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultComposite(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImage",
    jsii_struct_bases=[],
    name_mapping={
        "box_image": "boxImage",
        "circle_image": "circleImage",
        "text_image": "textImage",
        "url_image": "urlImage",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImage:
    def __init__(
        self,
        *,
        box_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageBoxImage", typing.Dict[builtins.str, typing.Any]]]]] = None,
        circle_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageCircleImage", typing.Dict[builtins.str, typing.Any]]]]] = None,
        text_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageTextImage", typing.Dict[builtins.str, typing.Any]]]]] = None,
        url_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageUrlImage", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param box_image: box_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#box_image DataAkamaiImagingPolicyImage#box_image}
        :param circle_image: circle_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#circle_image DataAkamaiImagingPolicyImage#circle_image}
        :param text_image: text_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text_image DataAkamaiImagingPolicyImage#text_image}
        :param url_image: url_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url_image DataAkamaiImagingPolicyImage#url_image}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b0c7e9fa61c8692795ea90495cec9fac3a07e38be2e8c244a14937070d569f40)
            check_type(argname="argument box_image", value=box_image, expected_type=type_hints["box_image"])
            check_type(argname="argument circle_image", value=circle_image, expected_type=type_hints["circle_image"])
            check_type(argname="argument text_image", value=text_image, expected_type=type_hints["text_image"])
            check_type(argname="argument url_image", value=url_image, expected_type=type_hints["url_image"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if box_image is not None:
            self._values["box_image"] = box_image
        if circle_image is not None:
            self._values["circle_image"] = circle_image
        if text_image is not None:
            self._values["text_image"] = text_image
        if url_image is not None:
            self._values["url_image"] = url_image

    @builtins.property
    def box_image(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageBoxImage"]]]:
        '''box_image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#box_image DataAkamaiImagingPolicyImage#box_image}
        '''
        result = self._values.get("box_image")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageBoxImage"]]], result)

    @builtins.property
    def circle_image(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageCircleImage"]]]:
        '''circle_image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#circle_image DataAkamaiImagingPolicyImage#circle_image}
        '''
        result = self._values.get("circle_image")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageCircleImage"]]], result)

    @builtins.property
    def text_image(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageTextImage"]]]:
        '''text_image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text_image DataAkamaiImagingPolicyImage#text_image}
        '''
        result = self._values.get("text_image")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageTextImage"]]], result)

    @builtins.property
    def url_image(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageUrlImage"]]]:
        '''url_image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url_image DataAkamaiImagingPolicyImage#url_image}
        '''
        result = self._values.get("url_image")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageUrlImage"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageBoxImage",
    jsii_struct_bases=[],
    name_mapping={
        "color": "color",
        "color_var": "colorVar",
        "height": "height",
        "height_var": "heightVar",
        "transformation": "transformation",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageBoxImage:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        transformation: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageBoxImageTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The fill color of the box, not the edge of the box. The API supports hexadecimal representation and CSS hexadecimal color values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The fill color of the box, not the edge of the box. The API supports hexadecimal representation and CSS hexadecimal color values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        :param height: The height of the box in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height of the box in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param transformation: transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        :param width: The width of the box in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width of the box in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(transformation, dict):
            transformation = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageBoxImageTransformation(**transformation)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a82718b0bb5df121f50eba3cf9aad8f8645b9e75a5fd7a7c1e955b0719bfc95f)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument transformation", value=transformation, expected_type=type_hints["transformation"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if transformation is not None:
            self._values["transformation"] = transformation
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The fill color of the box, not the edge of the box.

        The API supports hexadecimal representation and CSS hexadecimal color values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The fill color of the box, not the edge of the box.

        The API supports hexadecimal representation and CSS hexadecimal color values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height of the box in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height of the box in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def transformation(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageBoxImageTransformation"]:
        '''transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        '''
        result = self._values.get("transformation")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageBoxImageTransformation"], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width of the box in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width of the box in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageBoxImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageBoxImageList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageBoxImageList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__03bf897e466a576d39fb4d7d05846d750664f134e28939656cb27497141addf6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageBoxImageOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aa977eece2256dbbbaad1b24928047eea52e43edd7f8ca022c1d8b0a7d51a50e)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageBoxImageOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c5052ce1a2a2d6dc973a7c16e0a6b07888488551112f48e4315e89595603e261)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8e8748215b0937fdfc75c896ae93f80a01eb8045d25c8cc3b3adaddfe35fbc3e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__491a3bf2e6001f38c3ae795784000b113963f0c1f1bf9ff2bbaf887eb7a6b2b9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageBoxImage]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageBoxImage]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageBoxImage]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__108d01045523740c752adef00a4a1a82b51b1a9a9bfac0dad815f4cb263e7878)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageBoxImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageBoxImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ae6991423e8503160e3320cab784f42071743509434c188bb66cc8e4738630b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformation")
    def put_transformation(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageBoxImageTransformation()

        return typing.cast(None, jsii.invoke(self, "putTransformation", [value]))

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetTransformation")
    def reset_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformation", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="transformation")
    def transformation(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageBoxImageTransformationOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageBoxImageTransformationOutputReference", jsii.get(self, "transformation"))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="transformationInput")
    def transformation_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageBoxImageTransformation"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageBoxImageTransformation"], jsii.get(self, "transformationInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab5b836cb7f283f0c375a4a94eb99766cb171c488704e8d11397e14c1a369bd8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a56fc3b0b83a532c7fd72031c6fd94a1f97a939ae1b3d6f130d192ea2dbc78d5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5fd935dc0cea1ee697d42d02cf5dfd34e816eb22943296ae9af9f6436b017cfd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d38a9195f2bbd8a10618b0b1ffad474254f2a6e449865fda56bfc04d0491da0c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7141d15784af29ba3b63626a9994ede3e3803fd1b526d732580c8ce94b8f0fdd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__abaebd55c7fea74cdebd50fddf6a0188e120a8ebd70a4be69ffa8fa0be74867c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageBoxImage]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageBoxImage]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageBoxImage]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0e26dedeaeb915914ceadeda43be333b401c6c429d6ca1d29bc7ea885952f89f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageBoxImageTransformation",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageBoxImageTransformation:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageBoxImageTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageBoxImageTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageBoxImageTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__02612c07a5bfe4be97c83db684753fdff4c771b47780f1a4d1f6efd8fbb1ed52)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageBoxImageTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageBoxImageTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageBoxImageTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d5c62edb083cc404b70473cebbbb09228fa6989f2c1ce985f0bc754e936841c0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageCircleImage",
    jsii_struct_bases=[],
    name_mapping={
        "color": "color",
        "color_var": "colorVar",
        "diameter": "diameter",
        "diameter_var": "diameterVar",
        "transformation": "transformation",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageCircleImage:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
        diameter: typing.Optional[builtins.str] = None,
        diameter_var: typing.Optional[builtins.str] = None,
        transformation: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageCircleImageTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The fill color of the circle. The API supports hexadecimal representation and CSS hexadecimal color values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The fill color of the circle. The API supports hexadecimal representation and CSS hexadecimal color values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        :param diameter: The diameter of the circle. The diameter will be the width and the height of the image in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#diameter DataAkamaiImagingPolicyImage#diameter}
        :param diameter_var: The diameter of the circle. The diameter will be the width and the height of the image in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#diameter_var DataAkamaiImagingPolicyImage#diameter_var}
        :param transformation: transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        :param width: The width of the box in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width of the box in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(transformation, dict):
            transformation = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageCircleImageTransformation(**transformation)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f16cafa44c3da5a46d499df33e70b05936d68fc5c2dc87f7729d480dbe12a4aa)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
            check_type(argname="argument diameter", value=diameter, expected_type=type_hints["diameter"])
            check_type(argname="argument diameter_var", value=diameter_var, expected_type=type_hints["diameter_var"])
            check_type(argname="argument transformation", value=transformation, expected_type=type_hints["transformation"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var
        if diameter is not None:
            self._values["diameter"] = diameter
        if diameter_var is not None:
            self._values["diameter_var"] = diameter_var
        if transformation is not None:
            self._values["transformation"] = transformation
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The fill color of the circle. The API supports hexadecimal representation and CSS hexadecimal color values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The fill color of the circle. The API supports hexadecimal representation and CSS hexadecimal color values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def diameter(self) -> typing.Optional[builtins.str]:
        '''The diameter of the circle. The diameter will be the width and the height of the image in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#diameter DataAkamaiImagingPolicyImage#diameter}
        '''
        result = self._values.get("diameter")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def diameter_var(self) -> typing.Optional[builtins.str]:
        '''The diameter of the circle. The diameter will be the width and the height of the image in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#diameter_var DataAkamaiImagingPolicyImage#diameter_var}
        '''
        result = self._values.get("diameter_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def transformation(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageCircleImageTransformation"]:
        '''transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        '''
        result = self._values.get("transformation")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageCircleImageTransformation"], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width of the box in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width of the box in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageCircleImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageCircleImageList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageCircleImageList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f077fa1c04da033c4a0857d68abfefef1231c5aed1248bc7b59bce8ca9562339)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageCircleImageOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a9a84401affdbc3a0022e205998294586f38b177ce8c022eb66c48137f0130cc)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageCircleImageOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__39e61ced35bbfe8a3a7d2ac2f6706780e15201543b6cacae2cf6fd6ed54e8ee0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6232ee57cb031677d1f8fd2f69f15dcdc65b91762e061a1b6b52a703b1fa1c0f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9723a716ce4737edf80a7fe9d82161f190cb664bb655b10e098ac1d0eb1d94dd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageCircleImage]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageCircleImage]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageCircleImage]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0a3b4febf4536a54217228ec2e7baa8099c0b523f29b7cc5acd1be49d7fa3d19)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageCircleImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageCircleImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__88677a3ad35971650a2442911fd3de15b530274450196cf02fd3a3426f6ddd9e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformation")
    def put_transformation(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageCircleImageTransformation()

        return typing.cast(None, jsii.invoke(self, "putTransformation", [value]))

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @jsii.member(jsii_name="resetDiameter")
    def reset_diameter(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDiameter", []))

    @jsii.member(jsii_name="resetDiameterVar")
    def reset_diameter_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDiameterVar", []))

    @jsii.member(jsii_name="resetTransformation")
    def reset_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformation", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="transformation")
    def transformation(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageCircleImageTransformationOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageCircleImageTransformationOutputReference", jsii.get(self, "transformation"))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="diameterInput")
    def diameter_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "diameterInput"))

    @builtins.property
    @jsii.member(jsii_name="diameterVarInput")
    def diameter_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "diameterVarInput"))

    @builtins.property
    @jsii.member(jsii_name="transformationInput")
    def transformation_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageCircleImageTransformation"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageCircleImageTransformation"], jsii.get(self, "transformationInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0b41ced31ede73b2f3701dee2fb88e6f716e9db117c3f256eaced24bf3d6def5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b5019b6a4a52736765dcd4e5b9edbfccef2517886e4b47bb7aa430515cad28cc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="diameter")
    def diameter(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "diameter"))

    @diameter.setter
    def diameter(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f7af377b07466d29aea58f85c191a5b74300c378a2b41974fa9ced7230d2a8e9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "diameter", value)

    @builtins.property
    @jsii.member(jsii_name="diameterVar")
    def diameter_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "diameterVar"))

    @diameter_var.setter
    def diameter_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6b2f09898a270ac09ac2a1eb2133ea92ea7ecb0cffa3caceb40556be10cb9829)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "diameterVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a49f564d848045f9cd3b23d58d08b44071aa4b78214600f14620bbbc2bf6d6b8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f562b547dca51d7ed38f9b30227db365a9b82f3442a9b717e4628218a4af1ab8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageCircleImage]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageCircleImage]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageCircleImage]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6508d72dc67137c185754e054e2348ed6028e60739622de60318d4baf5b5c028)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageCircleImageTransformation",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageCircleImageTransformation:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageCircleImageTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageCircleImageTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageCircleImageTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__084b895df0190668b1f05eac6f02f7fbf5271754f228dd15691cecbb96aa2b8a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageCircleImageTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageCircleImageTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageCircleImageTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f5a2c236a41623095e17c2b569feef6490280d99680ffc28125cd3721e698139)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a1e55a0e888d310be6b8d6610692837490d03b19b367c7e4ecd0c49138f2cdf)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putBoxImage")
    def put_box_image(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageBoxImage, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__542ce129bc3974092c3f32510c5a4a4176988e9b90dda369f56bc877f2af9c2e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBoxImage", [value]))

    @jsii.member(jsii_name="putCircleImage")
    def put_circle_image(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageCircleImage, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9b74e6893def000ab963c8d89dc94b8cd01a13d675126c9c20c143782ab6d8d6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCircleImage", [value]))

    @jsii.member(jsii_name="putTextImage")
    def put_text_image(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageTextImage", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__61f8802c2e57becb7cedec10abac9f7efd38c47bf1e548a55bc699eaa31253b4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTextImage", [value]))

    @jsii.member(jsii_name="putUrlImage")
    def put_url_image(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageUrlImage", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7a0b34055c60c07f4d400c548d44412dd33902e8d2dffa974166a765761b3b3e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putUrlImage", [value]))

    @jsii.member(jsii_name="resetBoxImage")
    def reset_box_image(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBoxImage", []))

    @jsii.member(jsii_name="resetCircleImage")
    def reset_circle_image(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCircleImage", []))

    @jsii.member(jsii_name="resetTextImage")
    def reset_text_image(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTextImage", []))

    @jsii.member(jsii_name="resetUrlImage")
    def reset_url_image(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUrlImage", []))

    @builtins.property
    @jsii.member(jsii_name="boxImage")
    def box_image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageBoxImageList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageBoxImageList, jsii.get(self, "boxImage"))

    @builtins.property
    @jsii.member(jsii_name="circleImage")
    def circle_image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageCircleImageList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageCircleImageList, jsii.get(self, "circleImage"))

    @builtins.property
    @jsii.member(jsii_name="textImage")
    def text_image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageTextImageList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageTextImageList", jsii.get(self, "textImage"))

    @builtins.property
    @jsii.member(jsii_name="urlImage")
    def url_image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageUrlImageList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageUrlImageList", jsii.get(self, "urlImage"))

    @builtins.property
    @jsii.member(jsii_name="boxImageInput")
    def box_image_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageBoxImage]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageBoxImage]]], jsii.get(self, "boxImageInput"))

    @builtins.property
    @jsii.member(jsii_name="circleImageInput")
    def circle_image_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageCircleImage]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageCircleImage]]], jsii.get(self, "circleImageInput"))

    @builtins.property
    @jsii.member(jsii_name="textImageInput")
    def text_image_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageTextImage"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageTextImage"]]], jsii.get(self, "textImageInput"))

    @builtins.property
    @jsii.member(jsii_name="urlImageInput")
    def url_image_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageUrlImage"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageUrlImage"]]], jsii.get(self, "urlImageInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c893340f63073889225fae1c5298f8dcae8f46d354e3de90f66213e7c87a4010)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageTextImage",
    jsii_struct_bases=[],
    name_mapping={
        "fill": "fill",
        "fill_var": "fillVar",
        "size": "size",
        "size_var": "sizeVar",
        "stroke": "stroke",
        "stroke_size": "strokeSize",
        "stroke_size_var": "strokeSizeVar",
        "stroke_var": "strokeVar",
        "text": "text",
        "text_var": "textVar",
        "transformation": "transformation",
        "typeface": "typeface",
        "typeface_var": "typefaceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageTextImage:
    def __init__(
        self,
        *,
        fill: typing.Optional[builtins.str] = None,
        fill_var: typing.Optional[builtins.str] = None,
        size: typing.Optional[builtins.str] = None,
        size_var: typing.Optional[builtins.str] = None,
        stroke: typing.Optional[builtins.str] = None,
        stroke_size: typing.Optional[builtins.str] = None,
        stroke_size_var: typing.Optional[builtins.str] = None,
        stroke_var: typing.Optional[builtins.str] = None,
        text: typing.Optional[builtins.str] = None,
        text_var: typing.Optional[builtins.str] = None,
        transformation: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageTextImageTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        typeface: typing.Optional[builtins.str] = None,
        typeface_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fill: The main fill color of the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill DataAkamaiImagingPolicyImage#fill}
        :param fill_var: The main fill color of the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_var DataAkamaiImagingPolicyImage#fill_var}
        :param size: The size in pixels to render the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#size DataAkamaiImagingPolicyImage#size}
        :param size_var: The size in pixels to render the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#size_var DataAkamaiImagingPolicyImage#size_var}
        :param stroke: The color for the outline of the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke DataAkamaiImagingPolicyImage#stroke}
        :param stroke_size: The thickness in points for the outline of the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_size DataAkamaiImagingPolicyImage#stroke_size}
        :param stroke_size_var: The thickness in points for the outline of the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_size_var DataAkamaiImagingPolicyImage#stroke_size_var}
        :param stroke_var: The color for the outline of the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_var DataAkamaiImagingPolicyImage#stroke_var}
        :param text: The line of text to render. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text DataAkamaiImagingPolicyImage#text}
        :param text_var: The line of text to render. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text_var DataAkamaiImagingPolicyImage#text_var}
        :param transformation: transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        :param typeface: The font family to apply to the text image. This may be a URL to a TrueType or WOFF (v1) typeface, or a string that refers to one of the standard built-in browser fonts. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#typeface DataAkamaiImagingPolicyImage#typeface}
        :param typeface_var: The font family to apply to the text image. This may be a URL to a TrueType or WOFF (v1) typeface, or a string that refers to one of the standard built-in browser fonts. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#typeface_var DataAkamaiImagingPolicyImage#typeface_var}
        '''
        if isinstance(transformation, dict):
            transformation = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageTextImageTransformation(**transformation)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4cbaa1e7116f84e9a723985895d8002d3864d9ed6f3a2831606b0f33d1983942)
            check_type(argname="argument fill", value=fill, expected_type=type_hints["fill"])
            check_type(argname="argument fill_var", value=fill_var, expected_type=type_hints["fill_var"])
            check_type(argname="argument size", value=size, expected_type=type_hints["size"])
            check_type(argname="argument size_var", value=size_var, expected_type=type_hints["size_var"])
            check_type(argname="argument stroke", value=stroke, expected_type=type_hints["stroke"])
            check_type(argname="argument stroke_size", value=stroke_size, expected_type=type_hints["stroke_size"])
            check_type(argname="argument stroke_size_var", value=stroke_size_var, expected_type=type_hints["stroke_size_var"])
            check_type(argname="argument stroke_var", value=stroke_var, expected_type=type_hints["stroke_var"])
            check_type(argname="argument text", value=text, expected_type=type_hints["text"])
            check_type(argname="argument text_var", value=text_var, expected_type=type_hints["text_var"])
            check_type(argname="argument transformation", value=transformation, expected_type=type_hints["transformation"])
            check_type(argname="argument typeface", value=typeface, expected_type=type_hints["typeface"])
            check_type(argname="argument typeface_var", value=typeface_var, expected_type=type_hints["typeface_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fill is not None:
            self._values["fill"] = fill
        if fill_var is not None:
            self._values["fill_var"] = fill_var
        if size is not None:
            self._values["size"] = size
        if size_var is not None:
            self._values["size_var"] = size_var
        if stroke is not None:
            self._values["stroke"] = stroke
        if stroke_size is not None:
            self._values["stroke_size"] = stroke_size
        if stroke_size_var is not None:
            self._values["stroke_size_var"] = stroke_size_var
        if stroke_var is not None:
            self._values["stroke_var"] = stroke_var
        if text is not None:
            self._values["text"] = text
        if text_var is not None:
            self._values["text_var"] = text_var
        if transformation is not None:
            self._values["transformation"] = transformation
        if typeface is not None:
            self._values["typeface"] = typeface
        if typeface_var is not None:
            self._values["typeface_var"] = typeface_var

    @builtins.property
    def fill(self) -> typing.Optional[builtins.str]:
        '''The main fill color of the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill DataAkamaiImagingPolicyImage#fill}
        '''
        result = self._values.get("fill")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fill_var(self) -> typing.Optional[builtins.str]:
        '''The main fill color of the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_var DataAkamaiImagingPolicyImage#fill_var}
        '''
        result = self._values.get("fill_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def size(self) -> typing.Optional[builtins.str]:
        '''The size in pixels to render the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#size DataAkamaiImagingPolicyImage#size}
        '''
        result = self._values.get("size")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def size_var(self) -> typing.Optional[builtins.str]:
        '''The size in pixels to render the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#size_var DataAkamaiImagingPolicyImage#size_var}
        '''
        result = self._values.get("size_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def stroke(self) -> typing.Optional[builtins.str]:
        '''The color for the outline of the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke DataAkamaiImagingPolicyImage#stroke}
        '''
        result = self._values.get("stroke")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def stroke_size(self) -> typing.Optional[builtins.str]:
        '''The thickness in points for the outline of the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_size DataAkamaiImagingPolicyImage#stroke_size}
        '''
        result = self._values.get("stroke_size")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def stroke_size_var(self) -> typing.Optional[builtins.str]:
        '''The thickness in points for the outline of the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_size_var DataAkamaiImagingPolicyImage#stroke_size_var}
        '''
        result = self._values.get("stroke_size_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def stroke_var(self) -> typing.Optional[builtins.str]:
        '''The color for the outline of the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_var DataAkamaiImagingPolicyImage#stroke_var}
        '''
        result = self._values.get("stroke_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def text(self) -> typing.Optional[builtins.str]:
        '''The line of text to render.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text DataAkamaiImagingPolicyImage#text}
        '''
        result = self._values.get("text")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def text_var(self) -> typing.Optional[builtins.str]:
        '''The line of text to render.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text_var DataAkamaiImagingPolicyImage#text_var}
        '''
        result = self._values.get("text_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def transformation(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageTextImageTransformation"]:
        '''transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        '''
        result = self._values.get("transformation")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageTextImageTransformation"], result)

    @builtins.property
    def typeface(self) -> typing.Optional[builtins.str]:
        '''The font family to apply to the text image.

        This may be a URL to a TrueType or WOFF (v1) typeface, or a string that refers to one of the standard built-in browser fonts.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#typeface DataAkamaiImagingPolicyImage#typeface}
        '''
        result = self._values.get("typeface")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def typeface_var(self) -> typing.Optional[builtins.str]:
        '''The font family to apply to the text image.

        This may be a URL to a TrueType or WOFF (v1) typeface, or a string that refers to one of the standard built-in browser fonts.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#typeface_var DataAkamaiImagingPolicyImage#typeface_var}
        '''
        result = self._values.get("typeface_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageTextImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageTextImageList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageTextImageList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0f130563c2354d4eedeeddce96c95208cecca5145c1a0b03c7b6a3908613976f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageTextImageOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b52489acc10d36c48af738d9e1a524d833271d776b56283d8008d2a880826a74)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageTextImageOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ffbf4b6a39755b39bd9ba180309371d055432d05fabb31f50f4408684c8a651)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3d557139ce10e1730d4771f8c791515a327035708e4fe589709308c5c7b53ad6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a0adfb9b2ea148d8be52d0d36e85879b8c40a3a4fd34fd7d16897430363e299)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageTextImage]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageTextImage]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageTextImage]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__59d9e2773a007a86e54aaedfd02aef36ba2232093167cb2f9a1e4bb7cece0fc1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageTextImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageTextImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__44a767f01fd957d74922f3e670e8c669cf661b8f9dd6e40a07b2322e17fe9256)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformation")
    def put_transformation(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageTextImageTransformation()

        return typing.cast(None, jsii.invoke(self, "putTransformation", [value]))

    @jsii.member(jsii_name="resetFill")
    def reset_fill(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFill", []))

    @jsii.member(jsii_name="resetFillVar")
    def reset_fill_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFillVar", []))

    @jsii.member(jsii_name="resetSize")
    def reset_size(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSize", []))

    @jsii.member(jsii_name="resetSizeVar")
    def reset_size_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSizeVar", []))

    @jsii.member(jsii_name="resetStroke")
    def reset_stroke(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStroke", []))

    @jsii.member(jsii_name="resetStrokeSize")
    def reset_stroke_size(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStrokeSize", []))

    @jsii.member(jsii_name="resetStrokeSizeVar")
    def reset_stroke_size_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStrokeSizeVar", []))

    @jsii.member(jsii_name="resetStrokeVar")
    def reset_stroke_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStrokeVar", []))

    @jsii.member(jsii_name="resetText")
    def reset_text(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetText", []))

    @jsii.member(jsii_name="resetTextVar")
    def reset_text_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTextVar", []))

    @jsii.member(jsii_name="resetTransformation")
    def reset_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformation", []))

    @jsii.member(jsii_name="resetTypeface")
    def reset_typeface(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeface", []))

    @jsii.member(jsii_name="resetTypefaceVar")
    def reset_typeface_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypefaceVar", []))

    @builtins.property
    @jsii.member(jsii_name="transformation")
    def transformation(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageTextImageTransformationOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageTextImageTransformationOutputReference", jsii.get(self, "transformation"))

    @builtins.property
    @jsii.member(jsii_name="fillInput")
    def fill_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fillInput"))

    @builtins.property
    @jsii.member(jsii_name="fillVarInput")
    def fill_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fillVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sizeInput")
    def size_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sizeInput"))

    @builtins.property
    @jsii.member(jsii_name="sizeVarInput")
    def size_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sizeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="strokeInput")
    def stroke_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "strokeInput"))

    @builtins.property
    @jsii.member(jsii_name="strokeSizeInput")
    def stroke_size_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "strokeSizeInput"))

    @builtins.property
    @jsii.member(jsii_name="strokeSizeVarInput")
    def stroke_size_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "strokeSizeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="strokeVarInput")
    def stroke_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "strokeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="textInput")
    def text_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "textInput"))

    @builtins.property
    @jsii.member(jsii_name="textVarInput")
    def text_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "textVarInput"))

    @builtins.property
    @jsii.member(jsii_name="transformationInput")
    def transformation_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageTextImageTransformation"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageTextImageTransformation"], jsii.get(self, "transformationInput"))

    @builtins.property
    @jsii.member(jsii_name="typefaceInput")
    def typeface_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typefaceInput"))

    @builtins.property
    @jsii.member(jsii_name="typefaceVarInput")
    def typeface_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typefaceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="fill")
    def fill(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fill"))

    @fill.setter
    def fill(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6725de368198eb9173c3e31025989c939fa8dc2cf189d3faa3814713268204cb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fill", value)

    @builtins.property
    @jsii.member(jsii_name="fillVar")
    def fill_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fillVar"))

    @fill_var.setter
    def fill_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8762cc6cc9c1ac295e70ebc245405d4503d25d93ec3e1134ffd83f6a713b4754)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fillVar", value)

    @builtins.property
    @jsii.member(jsii_name="size")
    def size(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "size"))

    @size.setter
    def size(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9f9a0bd879c125503a9b70496c16a49f45406f946b0163dc58f3e6fbc3ab1563)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "size", value)

    @builtins.property
    @jsii.member(jsii_name="sizeVar")
    def size_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sizeVar"))

    @size_var.setter
    def size_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__20e475144d36e792bf95eb6d747f850779acb53f5a7e9345850e188e08c1bc05)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sizeVar", value)

    @builtins.property
    @jsii.member(jsii_name="stroke")
    def stroke(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "stroke"))

    @stroke.setter
    def stroke(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2b7264865cfa0cbb7cc802e098b66247ac92405c528a0800b287f7116e34b979)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "stroke", value)

    @builtins.property
    @jsii.member(jsii_name="strokeSize")
    def stroke_size(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "strokeSize"))

    @stroke_size.setter
    def stroke_size(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ed245440dfdb14478363830b3adbb1a6ef2b4555179a06b33ccdd1cc72ae0a73)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "strokeSize", value)

    @builtins.property
    @jsii.member(jsii_name="strokeSizeVar")
    def stroke_size_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "strokeSizeVar"))

    @stroke_size_var.setter
    def stroke_size_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__99ce619150dff5861c5932b85b0c9a5803ff47711b4d8805023cdd467029cd84)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "strokeSizeVar", value)

    @builtins.property
    @jsii.member(jsii_name="strokeVar")
    def stroke_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "strokeVar"))

    @stroke_var.setter
    def stroke_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a9b434943aa7aefb413b90d4f10e48fbf3f51ee33c39477c47e1101ed9100536)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "strokeVar", value)

    @builtins.property
    @jsii.member(jsii_name="text")
    def text(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "text"))

    @text.setter
    def text(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__71df03848677b9538bcd08f17efa3a72b7622e76818ad81f1902e0b5e148f17d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "text", value)

    @builtins.property
    @jsii.member(jsii_name="textVar")
    def text_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "textVar"))

    @text_var.setter
    def text_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8d1c823575ef46dcdd62444423fe1c6b94c8461be65e3acbb3e36ee4d5a48825)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "textVar", value)

    @builtins.property
    @jsii.member(jsii_name="typeface")
    def typeface(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeface"))

    @typeface.setter
    def typeface(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__95de174178f59ebae23374c356bb7e62176a0f2bf14f49db8da80bc6149b6e24)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeface", value)

    @builtins.property
    @jsii.member(jsii_name="typefaceVar")
    def typeface_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typefaceVar"))

    @typeface_var.setter
    def typeface_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1e275da6e3283772e8ddb48dbc2cebe9ec9e6b370cc3a6ea86a1b6310eb4fcf9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typefaceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageTextImage]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageTextImage]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageTextImage]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__91b5352817d72f0347fb45b803cf68780e8a163aaf55938060acd6273b26c118)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageTextImageTransformation",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageTextImageTransformation:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageTextImageTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageTextImageTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageTextImageTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb793e17e10af42c988f249e2e9364aaa8b3b2ab9bc40f3e00db7e3e3db8dc8e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageTextImageTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageTextImageTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageTextImageTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__82467be16c72e0eaecdca8cb4bffb4f5f4deba6151484163a50665b0a138c944)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageUrlImage",
    jsii_struct_bases=[],
    name_mapping={
        "transformation": "transformation",
        "url": "url",
        "url_var": "urlVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageUrlImage:
    def __init__(
        self,
        *,
        transformation: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageUrlImageTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        url: typing.Optional[builtins.str] = None,
        url_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param transformation: transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        :param url: The URL of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url DataAkamaiImagingPolicyImage#url}
        :param url_var: The URL of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url_var DataAkamaiImagingPolicyImage#url_var}
        '''
        if isinstance(transformation, dict):
            transformation = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageUrlImageTransformation(**transformation)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fc147c4adcdc9d2f6813fba00297c14f36e5e7a0da9979c2944f72eae498c78a)
            check_type(argname="argument transformation", value=transformation, expected_type=type_hints["transformation"])
            check_type(argname="argument url", value=url, expected_type=type_hints["url"])
            check_type(argname="argument url_var", value=url_var, expected_type=type_hints["url_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if transformation is not None:
            self._values["transformation"] = transformation
        if url is not None:
            self._values["url"] = url
        if url_var is not None:
            self._values["url_var"] = url_var

    @builtins.property
    def transformation(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageUrlImageTransformation"]:
        '''transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        '''
        result = self._values.get("transformation")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageUrlImageTransformation"], result)

    @builtins.property
    def url(self) -> typing.Optional[builtins.str]:
        '''The URL of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url DataAkamaiImagingPolicyImage#url}
        '''
        result = self._values.get("url")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def url_var(self) -> typing.Optional[builtins.str]:
        '''The URL of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url_var DataAkamaiImagingPolicyImage#url_var}
        '''
        result = self._values.get("url_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageUrlImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageUrlImageList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageUrlImageList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__573e214a08bf79e04febc3d9d4cef981b9c214f53d8d3322e541972f78f609df)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageUrlImageOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ac8a984bf8fb716a4c84bdccc3609e6dfb998e5065acb1e43106b559d842224)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageUrlImageOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__178d522ff8a1f638a549f2150e30374214f4594a735a251529d642817a5ab2fe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8c6b3b573f12af3361186b228d4064a86b14bbee9aebf635435766bf1c871537)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__44851b23116de36d7ec97cdcdedb3fb8563cb497895d5373b97aad190e5d5fa5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageUrlImage]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageUrlImage]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageUrlImage]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6bbee3dc97816be20ed8a1066782c28684796501db55370d040d72dcfe5b0d26)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageUrlImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageUrlImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__41d9ce714e11e9887f4ecf67935bf274e78af622711128bcef835edb8b735bf0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformation")
    def put_transformation(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageUrlImageTransformation()

        return typing.cast(None, jsii.invoke(self, "putTransformation", [value]))

    @jsii.member(jsii_name="resetTransformation")
    def reset_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformation", []))

    @jsii.member(jsii_name="resetUrl")
    def reset_url(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUrl", []))

    @jsii.member(jsii_name="resetUrlVar")
    def reset_url_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUrlVar", []))

    @builtins.property
    @jsii.member(jsii_name="transformation")
    def transformation(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageUrlImageTransformationOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageUrlImageTransformationOutputReference", jsii.get(self, "transformation"))

    @builtins.property
    @jsii.member(jsii_name="transformationInput")
    def transformation_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageUrlImageTransformation"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageUrlImageTransformation"], jsii.get(self, "transformationInput"))

    @builtins.property
    @jsii.member(jsii_name="urlInput")
    def url_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "urlInput"))

    @builtins.property
    @jsii.member(jsii_name="urlVarInput")
    def url_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "urlVarInput"))

    @builtins.property
    @jsii.member(jsii_name="url")
    def url(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "url"))

    @url.setter
    def url(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ccefa90e6d1bfb57c63ac133a4edc1d87e7d62ad7bf3c9b18974edf1d713b7e9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "url", value)

    @builtins.property
    @jsii.member(jsii_name="urlVar")
    def url_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "urlVar"))

    @url_var.setter
    def url_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2e17effda694574c3b39bde5f11819122b5e70f1106fa99f029581e014d51ccd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "urlVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageUrlImage]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageUrlImage]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageUrlImage]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6ffc68a9015371419061735dc6f4620cb46853d5f3221a5021a005b0b2c1ff21)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageUrlImageTransformation",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageUrlImageTransformation:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageUrlImageTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageUrlImageTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageUrlImageTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__95ea54ac0666dd6302341b72ef4308188c7694582ad3767721aa4d78c30f177c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageUrlImageTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageUrlImageTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageUrlImageTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fc5f5dbe9471f2205ff45cc956d9029d7df6277ed8972c719fe39b556b516f94)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__763daf3866c23153728333d414cd4fc6ce1c18ecc7d87bcd9e2201403ce2a756)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f3d5a2bfe7712c84bd1f648acc5d4cd6daa11386642fb42217d6d954df33f973)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__08ec4101714899e34767e9675471e5db1c04ead5c965db38fdcd9f26bd579666)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f2d0117372007ba615294fef6c22deb421369bef90a930cbd6dc5adb493dea21)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ef06b50db2a75710481213e9191f8a17012b79c009067d0bf5a9920ad33914ba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultComposite]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultComposite]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c4199da4eee376b4a4f3c04b1524c87d4bb96d04ef05956c6bf8107d9e6021e6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea0a3b85cd44c5e5d538acee7f4f0e94a597dd72c6880d347be2930d42465a26)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(
        self,
        *,
        box_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageBoxImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
        circle_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageCircleImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
        text_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageTextImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
        url_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageUrlImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param box_image: box_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#box_image DataAkamaiImagingPolicyImage#box_image}
        :param circle_image: circle_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#circle_image DataAkamaiImagingPolicyImage#circle_image}
        :param text_image: text_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text_image DataAkamaiImagingPolicyImage#text_image}
        :param url_image: url_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url_image DataAkamaiImagingPolicyImage#url_image}
        '''
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImage(
            box_image=box_image,
            circle_image=circle_image,
            text_image=text_image,
            url_image=url_image,
        )

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPlacement")
    def reset_placement(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacement", []))

    @jsii.member(jsii_name="resetPlacementVar")
    def reset_placement_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacementVar", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetScaleDimension")
    def reset_scale_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimension", []))

    @jsii.member(jsii_name="resetScaleDimensionVar")
    def reset_scale_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimensionVar", []))

    @jsii.member(jsii_name="resetScaleVar")
    def reset_scale_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="placementInput")
    def placement_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementInput"))

    @builtins.property
    @jsii.member(jsii_name="placementVarInput")
    def placement_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionInput")
    def scale_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVarInput")
    def scale_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleVarInput")
    def scale_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ff302060d518207773344e62f3fac4f211d3d1fab95fc86c88f03342b02bbb64)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a19cf2363b5c5e66aff593cb8ebf97623ac033d6015dec0a3f1593175fab5e27)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="placement")
    def placement(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placement"))

    @placement.setter
    def placement(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0fa3cc3342b740a157d6d2eebea2d10db309874e11174611a38dbf200cbc136e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placement", value)

    @builtins.property
    @jsii.member(jsii_name="placementVar")
    def placement_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placementVar"))

    @placement_var.setter
    def placement_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6a171a592d1173c993d8c1ad332fe23216ff7d3b448ed8870cb3e1d82491acbd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placementVar", value)

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scale"))

    @scale.setter
    def scale(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__da1477dafa55170d88c648a23809509b888384c0dad3bc7e11478904901dc4ef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scale", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimension")
    def scale_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimension"))

    @scale_dimension.setter
    def scale_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d6dead1eb9dc96b94b5431c76a21aece97356f72262f0818b05772b92d31b55a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimension", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVar")
    def scale_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimensionVar"))

    @scale_dimension_var.setter
    def scale_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__452201747a73f7a1dcf82d9075ba70934c9039362cce3312910e9bc6204970af)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="scaleVar")
    def scale_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleVar"))

    @scale_var.setter
    def scale_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__22cb96d0846873019f3c4b6e6a2fd51e0788dc1781cd6500fdb9fca558736210)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fd0e8c9762e887c3d5be542d6c7589d808432c6ec24d30bccb7b966bc8e9212a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__484853c5becba75d7229a0a9af6cc12a9bfdf7517312dc0c3e76adf1b14443a9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4c0142bb479d0ec4ed861f699819cd8730eb1182191bab5c437821d87702afa4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__17b17b975c78afbe11f46af06a98ad56b37ccdf59b35494e663936c4be33b6df)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultComposite]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultComposite]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultComposite]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e9f06646fee40930ce59b4bfcfa0e627ed00025b29d4d0ade39f13ac349b770)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompound",
    jsii_struct_bases=[],
    name_mapping={"transformations": "transformations"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompound:
    def __init__(
        self,
        *,
        transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformations, typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param transformations: transformations block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fb1ccb2b43631d20d0504674abfb834a2d3fc36cb2ef3d9e4bb53f8c5e9273a9)
            check_type(argname="argument transformations", value=transformations, expected_type=type_hints["transformations"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if transformations is not None:
            self._values["transformations"] = transformations

    @builtins.property
    def transformations(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformations]]]:
        '''transformations block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        result = self._values.get("transformations")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformations]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompound(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompoundList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompoundList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__07b8f30249ac078b9de7981a3d17e412e0ae53e72bd2d1ec84505fddc4b732b7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompoundOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ae8f3278b0dda9ad710c3f62ce3a3c3b35568bef6013d6e1cbe8b4c57738e92d)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompoundOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e3ebb5724c2da1dc81f3ebf99114f28887ffc068107dcf9df2fd3b7d8d22a00e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e47e3710a9a7afd0260818410c792cafeadb341ab78e935bd67cabc4f439069f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__24bd773c1dca7e02ecf9da6b9d0bb86e367547e1bc9630ee0025095fe07a76f8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompound]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompound]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f8986baad514c25a15926e08e62209a0da8fd5d787a7e44f78663f49a03bdb8b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompoundOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompoundOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0adb759aee50dadfd13385d06e186c08ea8a762d11e3eff190ae2db2e15ae594)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformations")
    def put_transformations(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformations, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b04d4b595977c079139ff5465bdf8417440f2ee9072a37521e32b5450871d979)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTransformations", [value]))

    @jsii.member(jsii_name="resetTransformations")
    def reset_transformations(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformations", []))

    @builtins.property
    @jsii.member(jsii_name="transformations")
    def transformations(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsList", jsii.get(self, "transformations"))

    @builtins.property
    @jsii.member(jsii_name="transformationsInput")
    def transformations_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformations]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformations]]], jsii.get(self, "transformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompound]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompound]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompound]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab5cc80dc045c30985571638200b45e877ce59c9d54b22df96803834eaaf5238)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultContrast",
    jsii_struct_bases=[],
    name_mapping={
        "brightness": "brightness",
        "brightness_var": "brightnessVar",
        "contrast": "contrast",
        "contrast_var": "contrastVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultContrast:
    def __init__(
        self,
        *,
        brightness: typing.Optional[builtins.str] = None,
        brightness_var: typing.Optional[builtins.str] = None,
        contrast: typing.Optional[builtins.str] = None,
        contrast_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param brightness: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        :param brightness_var: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        :param contrast: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param contrast_var: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b745637c3e1254d32ff4faf9b4d94269b0e158efa3d9376e41c4cd1f761bd289)
            check_type(argname="argument brightness", value=brightness, expected_type=type_hints["brightness"])
            check_type(argname="argument brightness_var", value=brightness_var, expected_type=type_hints["brightness_var"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument contrast_var", value=contrast_var, expected_type=type_hints["contrast_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if brightness is not None:
            self._values["brightness"] = brightness
        if brightness_var is not None:
            self._values["brightness_var"] = brightness_var
        if contrast is not None:
            self._values["contrast"] = contrast
        if contrast_var is not None:
            self._values["contrast_var"] = contrast_var

    @builtins.property
    def brightness(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        '''
        result = self._values.get("brightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def brightness_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        '''
        result = self._values.get("brightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        result = self._values.get("contrast_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultContrast(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultContrastList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultContrastList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__39c90094ce7fbbbed060ed853f98cdff53b64e95775b7be4b1cc0f5214ff9f0f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultContrastOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f40cce89f3324539036e8e74bada6cb2039040469b3048e5b6e76de42a954eb7)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultContrastOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__70be3cab539a6323cbc6fa87a02751ccd6126d53a80215f90fc0686d7c19e1d6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b114c97c312ab21b61116ba27cb98f6e24214711c694c8202cc74965105abd04)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7e8e5def942750f90e09dbf41189744a3e63ad4e4c6abc267801793dfbb957b7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultContrast]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultContrast]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1523e8739f437b2089d05f67f2413474cbf76ff3612ccaae6568bc086c16af8f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultContrastOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultContrastOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0832c96a873fa40db87e3dc0ff20c2493f3030b2e0c82ffa6dd6a119d5ef2aa1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetBrightness")
    def reset_brightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightness", []))

    @jsii.member(jsii_name="resetBrightnessVar")
    def reset_brightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightnessVar", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetContrastVar")
    def reset_contrast_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrastVar", []))

    @builtins.property
    @jsii.member(jsii_name="brightnessInput")
    def brightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="brightnessVarInput")
    def brightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastVarInput")
    def contrast_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="brightness")
    def brightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightness"))

    @brightness.setter
    def brightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__37ee39ea242dfadb88ebf917ee344d81b6f4872a714bfffdc381f9c802a26e0f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightness", value)

    @builtins.property
    @jsii.member(jsii_name="brightnessVar")
    def brightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightnessVar"))

    @brightness_var.setter
    def brightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ce573e34d42dba328b2be748b1faef826c8422c2efc37165307c7d4d7bb434e3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrast"))

    @contrast.setter
    def contrast(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4e12af92872b6369a6b01d99d2ab978d7e63c6f3c8ae7ce4375e4bb1f0be6bbb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrast", value)

    @builtins.property
    @jsii.member(jsii_name="contrastVar")
    def contrast_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrastVar"))

    @contrast_var.setter
    def contrast_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1137c64d5baf520105984e109c38b80487c4fba6f86e753ef7b5c65d4e341dc4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrastVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultContrast]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultContrast]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultContrast]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__555bf3e8cff40988ec4bd4075206fe9d007f2bd0a806b15f78779e3d68fab23a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCrop",
    jsii_struct_bases=[],
    name_mapping={
        "allow_expansion": "allowExpansion",
        "allow_expansion_var": "allowExpansionVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCrop:
    def __init__(
        self,
        *,
        allow_expansion: typing.Optional[builtins.str] = None,
        allow_expansion_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_expansion: If cropping an area outside of the existing canvas, expands the image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        :param allow_expansion_var: If cropping an area outside of the existing canvas, expands the image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        :param gravity: Frame of reference for X and Y Positions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Frame of reference for X and Y Positions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The number of pixels to crop along the y-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The number of pixels to crop along the y-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The number of pixels to crop along the x-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The number of pixels to crop along the x-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        :param x_position: The x-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c7a72f54e36e515b2c6eb6beeccd2b606bd0ae5277032fd6260c381fe80cc4d6)
            check_type(argname="argument allow_expansion", value=allow_expansion, expected_type=type_hints["allow_expansion"])
            check_type(argname="argument allow_expansion_var", value=allow_expansion_var, expected_type=type_hints["allow_expansion_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if allow_expansion is not None:
            self._values["allow_expansion"] = allow_expansion
        if allow_expansion_var is not None:
            self._values["allow_expansion_var"] = allow_expansion_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def allow_expansion(self) -> typing.Optional[builtins.str]:
        '''If cropping an area outside of the existing canvas, expands the image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        '''
        result = self._values.get("allow_expansion")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def allow_expansion_var(self) -> typing.Optional[builtins.str]:
        '''If cropping an area outside of the existing canvas, expands the image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        '''
        result = self._values.get("allow_expansion_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Frame of reference for X and Y Positions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Frame of reference for X and Y Positions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the y-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the y-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the x-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the x-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3dd68ea4857a7f674a70a092d050f04b9f652b4d896d75c29bc8d79ab6a2767f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__718d3f11b0a7977e27ffeaf0be745d19a2b8a2ed5ca11d1167f57df7836eb59b)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cc5ebf1f896da9a5adfd07ce5ceac1753e46dcbfc40ff6a802a6b414e2417e7f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__592cd472cf05b1ce8fa59be9ff4f0a11128e935c39e3f02b7cd075a6a2d311f4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__353ee7e1af6de80f2bc791e8ef2d9b7445b99f19238c7ac0ab7a7a1df903a4f1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6ad14e05f6823e9ea1ea8c71e63021ebc1e0d4822f3bd0b4f78fe32b8941dad1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__216cf666492d3545d78ed03e08107cbc6d3269e798095f227d3146c5b031446e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAllowExpansion")
    def reset_allow_expansion(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansion", []))

    @jsii.member(jsii_name="resetAllowExpansionVar")
    def reset_allow_expansion_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansionVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionInput")
    def allow_expansion_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVarInput")
    def allow_expansion_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansion")
    def allow_expansion(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansion"))

    @allow_expansion.setter
    def allow_expansion(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__611a13d9f001b95f566afbe3fa3e32259805d352efb1d083b9f760b1440d36b6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansion", value)

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVar")
    def allow_expansion_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansionVar"))

    @allow_expansion_var.setter
    def allow_expansion_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__242c64d3a926f9a4da1773170419176e7f2d6ae1e850418347db4375e6e55b6a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansionVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4d3369a54db8244879ecd2dd0a24bb4d28e3f4f369801a9c5b9575d7d8880608)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7b9a6015a205c3dfa91f15e23d48b49e36db1ec279b59a2ddd28aedf36a1e9d8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a7f254bd9e569f269c509c45d1984886e5bd835ff095aaf32bbc00ebbe2a4bdf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__28c56dffbf222033f1f4b9f7b1a599e2401b9c725933d92756ed27479af6eec9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a86fb00f4f5f53ac67001bbde2671db6ee8524999354acd0421667236f653345)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f63fb5b8848ad81aca9566cd51289bfdc943c3a673fd3ee3fded400cd68b02b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__00676d25f3288d3da1858659fde5cbea0e56f2db79749f3724343def3eeb6b32)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__26c33b87c830284322cffd279e50c2c5ff3427026b490492b73c4a0986da3ba0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af723c57b6e70eba347db6627ecca140b076bb816de356dc8b183c3a933fbb42)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c871fae59a46b903a7d1ecd1843d74177b532fc08f292be80b27a55551cfc3db)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e64a0e938d772a4e71c6210d89acc813dd3942302f2d10bb05d5adb18eed2dae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFaceCrop",
    jsii_struct_bases=[],
    name_mapping={
        "algorithm": "algorithm",
        "algorithm_var": "algorithmVar",
        "confidence": "confidence",
        "confidence_var": "confidenceVar",
        "fail_gravity": "failGravity",
        "fail_gravity_var": "failGravityVar",
        "focus": "focus",
        "focus_var": "focusVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "padding": "padding",
        "padding_var": "paddingVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFaceCrop:
    def __init__(
        self,
        *,
        algorithm: typing.Optional[builtins.str] = None,
        algorithm_var: typing.Optional[builtins.str] = None,
        confidence: typing.Optional[builtins.str] = None,
        confidence_var: typing.Optional[builtins.str] = None,
        fail_gravity: typing.Optional[builtins.str] = None,
        fail_gravity_var: typing.Optional[builtins.str] = None,
        focus: typing.Optional[builtins.str] = None,
        focus_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param algorithm: Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm DataAkamaiImagingPolicyImage#algorithm}
        :param algorithm_var: Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm_var DataAkamaiImagingPolicyImage#algorithm_var}
        :param confidence: With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image. Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence DataAkamaiImagingPolicyImage#confidence}
        :param confidence_var: With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image. Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence_var DataAkamaiImagingPolicyImage#confidence_var}
        :param fail_gravity: Controls placement of the crop if Image and Video Manager does not detect any faces in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        :param fail_gravity_var: Controls placement of the crop if Image and Video Manager does not detect any faces in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        :param focus: Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus DataAkamaiImagingPolicyImage#focus}
        :param focus_var: Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus_var DataAkamaiImagingPolicyImage#focus_var}
        :param gravity: Controls placement of the crop. Directions are relative to the face(s) plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Controls placement of the crop. Directions are relative to the face(s) plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param padding: The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        :param style: Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d799a36bedfaae83573255e19daf5885ed0ed1c1c3bac6b93b8df5535f8d1f32)
            check_type(argname="argument algorithm", value=algorithm, expected_type=type_hints["algorithm"])
            check_type(argname="argument algorithm_var", value=algorithm_var, expected_type=type_hints["algorithm_var"])
            check_type(argname="argument confidence", value=confidence, expected_type=type_hints["confidence"])
            check_type(argname="argument confidence_var", value=confidence_var, expected_type=type_hints["confidence_var"])
            check_type(argname="argument fail_gravity", value=fail_gravity, expected_type=type_hints["fail_gravity"])
            check_type(argname="argument fail_gravity_var", value=fail_gravity_var, expected_type=type_hints["fail_gravity_var"])
            check_type(argname="argument focus", value=focus, expected_type=type_hints["focus"])
            check_type(argname="argument focus_var", value=focus_var, expected_type=type_hints["focus_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if algorithm is not None:
            self._values["algorithm"] = algorithm
        if algorithm_var is not None:
            self._values["algorithm_var"] = algorithm_var
        if confidence is not None:
            self._values["confidence"] = confidence
        if confidence_var is not None:
            self._values["confidence_var"] = confidence_var
        if fail_gravity is not None:
            self._values["fail_gravity"] = fail_gravity
        if fail_gravity_var is not None:
            self._values["fail_gravity_var"] = fail_gravity_var
        if focus is not None:
            self._values["focus"] = focus
        if focus_var is not None:
            self._values["focus_var"] = focus_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def algorithm(self) -> typing.Optional[builtins.str]:
        '''Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm DataAkamaiImagingPolicyImage#algorithm}
        '''
        result = self._values.get("algorithm")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def algorithm_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm_var DataAkamaiImagingPolicyImage#algorithm_var}
        '''
        result = self._values.get("algorithm_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def confidence(self) -> typing.Optional[builtins.str]:
        '''With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image.

        Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence DataAkamaiImagingPolicyImage#confidence}
        '''
        result = self._values.get("confidence")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def confidence_var(self) -> typing.Optional[builtins.str]:
        '''With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image.

        Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence_var DataAkamaiImagingPolicyImage#confidence_var}
        '''
        result = self._values.get("confidence_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any faces in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        '''
        result = self._values.get("fail_gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any faces in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        '''
        result = self._values.get("fail_gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def focus(self) -> typing.Optional[builtins.str]:
        '''Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus DataAkamaiImagingPolicyImage#focus}
        '''
        result = self._values.get("focus")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def focus_var(self) -> typing.Optional[builtins.str]:
        '''Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus_var DataAkamaiImagingPolicyImage#focus_var}
        '''
        result = self._values.get("focus_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the face(s) plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the face(s) plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFaceCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFaceCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFaceCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f72bf4cb1201d9d4f2a96f94751f79040e4f1afa0f1e024eebe9b4ab507d56a4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFaceCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__99e7b18053a584c48737658c98f693a21430d70bfbce9685f83cf2252544f324)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFaceCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__306d0e9c07d726e5e85ddbfda17fd3eef60b150c61335ee513fbd7ded38fed72)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2b2a89eef0753694b0d5cbfbfa083c93201bdda55b1906287b053b5a05a04163)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__861edc15063cb278fdd48bee06c83d616523de411e4f381dcd610cf2a0a4e668)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFaceCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFaceCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFaceCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6ab27d80b94d85f7be9cf08359af3ba6d5919ceb37c5e9193203ebe6565046be)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFaceCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFaceCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2b017a116919af6ef297743cbbcfafca8827a5fe68a3cd729a7c6e987ab0b566)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAlgorithm")
    def reset_algorithm(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAlgorithm", []))

    @jsii.member(jsii_name="resetAlgorithmVar")
    def reset_algorithm_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAlgorithmVar", []))

    @jsii.member(jsii_name="resetConfidence")
    def reset_confidence(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetConfidence", []))

    @jsii.member(jsii_name="resetConfidenceVar")
    def reset_confidence_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetConfidenceVar", []))

    @jsii.member(jsii_name="resetFailGravity")
    def reset_fail_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravity", []))

    @jsii.member(jsii_name="resetFailGravityVar")
    def reset_fail_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravityVar", []))

    @jsii.member(jsii_name="resetFocus")
    def reset_focus(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFocus", []))

    @jsii.member(jsii_name="resetFocusVar")
    def reset_focus_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFocusVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="algorithmInput")
    def algorithm_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "algorithmInput"))

    @builtins.property
    @jsii.member(jsii_name="algorithmVarInput")
    def algorithm_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "algorithmVarInput"))

    @builtins.property
    @jsii.member(jsii_name="confidenceInput")
    def confidence_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "confidenceInput"))

    @builtins.property
    @jsii.member(jsii_name="confidenceVarInput")
    def confidence_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "confidenceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityInput")
    def fail_gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityVarInput")
    def fail_gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="focusInput")
    def focus_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "focusInput"))

    @builtins.property
    @jsii.member(jsii_name="focusVarInput")
    def focus_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "focusVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="algorithm")
    def algorithm(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "algorithm"))

    @algorithm.setter
    def algorithm(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__23e7636f527bdc2e8c4e08ac64a97d511dabb148f3fa3507e82dced73983b5a8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "algorithm", value)

    @builtins.property
    @jsii.member(jsii_name="algorithmVar")
    def algorithm_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "algorithmVar"))

    @algorithm_var.setter
    def algorithm_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ad13766b972a429db880d7e71cb9d3b26675f9b03730055a5f11d35ef3c362f7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "algorithmVar", value)

    @builtins.property
    @jsii.member(jsii_name="confidence")
    def confidence(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "confidence"))

    @confidence.setter
    def confidence(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4547e78bdc95d08b80f5f0e75e15c9c45301ba0e4026ca716c957b246058bff9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "confidence", value)

    @builtins.property
    @jsii.member(jsii_name="confidenceVar")
    def confidence_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "confidenceVar"))

    @confidence_var.setter
    def confidence_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__afe3538ab0a6e4e886c5e8d62eaa909cad0bbffd058b245e9e0e6860967cbe5f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "confidenceVar", value)

    @builtins.property
    @jsii.member(jsii_name="failGravity")
    def fail_gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravity"))

    @fail_gravity.setter
    def fail_gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__28799faf924be538cf5563dfc881b0f574ee0d5605299377883c3e3c0f0b230f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravity", value)

    @builtins.property
    @jsii.member(jsii_name="failGravityVar")
    def fail_gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravityVar"))

    @fail_gravity_var.setter
    def fail_gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4137a380f55a0c78eb51d17cdce5452b02dd823fcd162fbbb1929accb111fe78)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="focus")
    def focus(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "focus"))

    @focus.setter
    def focus(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8f25a1cf18d46cbf0d1d22a1b88102a82953fba5ea643a16a8a349489742b1e6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "focus", value)

    @builtins.property
    @jsii.member(jsii_name="focusVar")
    def focus_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "focusVar"))

    @focus_var.setter
    def focus_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__acbe8ad9539f8d6c010c0189b6f0b909efac129733bd29a1a39cd8fa0c90d0be)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "focusVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d295cf19486b695ef0165fa1d79c75ec46c3fe8f972f8e684f93d9064ab0edb6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__79be10d8d7c38c9f9c95e6a50c21779890c13e5f802c8fc26dddaf6b7d16354f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f9c9f7e18dc8e83a97a63b4f7cb1d5ce975227c2dddb60926c4298c03d8b02e7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__45964f078d6bc2439d90ccb1a0cf31fbc8f634d5b1ebe6d353793f4ebab5b0d0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9bb82b0884e01b87196ca8632f330c063a7bf71b48620397ceb0db9203da9e98)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e618e2ea0db8cbe16130dfda2281681a861bc39e0cbcc69cedc029beedf840c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5889c547c8d5db09dfe4482dd1d26b1ac6ae65341119335debba0cb683853899)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__183b79c7d676f329e94f57ae4e78712c5d9694d5dc9cf693d53d5e9221f4dec8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eba665d096042a5fe7af321b2b2cfb4c01d65191396016d83ba80f3378c27abd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__76acbc224d0b5311ce7abf724e0ad438101afdc6d707fd400f854d5bc65b9b33)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFaceCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFaceCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFaceCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ce9ca2e649a04dc3f1b4e25176285c26d5db8338ac8a34ae05867330490d491)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFeatureCrop",
    jsii_struct_bases=[],
    name_mapping={
        "fail_gravity": "failGravity",
        "fail_gravity_var": "failGravityVar",
        "feature_radius": "featureRadius",
        "feature_radius_var": "featureRadiusVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "max_features": "maxFeatures",
        "max_features_var": "maxFeaturesVar",
        "min_feature_quality": "minFeatureQuality",
        "min_feature_quality_var": "minFeatureQualityVar",
        "padding": "padding",
        "padding_var": "paddingVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFeatureCrop:
    def __init__(
        self,
        *,
        fail_gravity: typing.Optional[builtins.str] = None,
        fail_gravity_var: typing.Optional[builtins.str] = None,
        feature_radius: typing.Optional[builtins.str] = None,
        feature_radius_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        max_features: typing.Optional[builtins.str] = None,
        max_features_var: typing.Optional[builtins.str] = None,
        min_feature_quality: typing.Optional[builtins.str] = None,
        min_feature_quality_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fail_gravity: Controls placement of the crop if Image and Video Manager does not detect any features in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        :param fail_gravity_var: Controls placement of the crop if Image and Video Manager does not detect any features in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        :param feature_radius: The size in pixels of the important features to search for. If identified, two features never appear closer together than this value, ``8.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius DataAkamaiImagingPolicyImage#feature_radius}
        :param feature_radius_var: The size in pixels of the important features to search for. If identified, two features never appear closer together than this value, ``8.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius_var DataAkamaiImagingPolicyImage#feature_radius_var}
        :param gravity: Controls placement of the crop. Directions are relative to the region of interest plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Controls placement of the crop. Directions are relative to the region of interest plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param max_features: The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features DataAkamaiImagingPolicyImage#max_features}
        :param max_features_var: The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features_var DataAkamaiImagingPolicyImage#max_features_var}
        :param min_feature_quality: Determines the minimum quality level of the feature identified. To consider a feature important, the feature needs to surpass this value. Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality DataAkamaiImagingPolicyImage#min_feature_quality}
        :param min_feature_quality_var: Determines the minimum quality level of the feature identified. To consider a feature important, the feature needs to surpass this value. Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality_var DataAkamaiImagingPolicyImage#min_feature_quality_var}
        :param padding: Adds space around the region of interest. The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: Adds space around the region of interest. The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        :param style: Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dc47eae2e713a995a2a045b0b8f932d75e765079a82a4bb218a37ec756229097)
            check_type(argname="argument fail_gravity", value=fail_gravity, expected_type=type_hints["fail_gravity"])
            check_type(argname="argument fail_gravity_var", value=fail_gravity_var, expected_type=type_hints["fail_gravity_var"])
            check_type(argname="argument feature_radius", value=feature_radius, expected_type=type_hints["feature_radius"])
            check_type(argname="argument feature_radius_var", value=feature_radius_var, expected_type=type_hints["feature_radius_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument max_features", value=max_features, expected_type=type_hints["max_features"])
            check_type(argname="argument max_features_var", value=max_features_var, expected_type=type_hints["max_features_var"])
            check_type(argname="argument min_feature_quality", value=min_feature_quality, expected_type=type_hints["min_feature_quality"])
            check_type(argname="argument min_feature_quality_var", value=min_feature_quality_var, expected_type=type_hints["min_feature_quality_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fail_gravity is not None:
            self._values["fail_gravity"] = fail_gravity
        if fail_gravity_var is not None:
            self._values["fail_gravity_var"] = fail_gravity_var
        if feature_radius is not None:
            self._values["feature_radius"] = feature_radius
        if feature_radius_var is not None:
            self._values["feature_radius_var"] = feature_radius_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if max_features is not None:
            self._values["max_features"] = max_features
        if max_features_var is not None:
            self._values["max_features_var"] = max_features_var
        if min_feature_quality is not None:
            self._values["min_feature_quality"] = min_feature_quality
        if min_feature_quality_var is not None:
            self._values["min_feature_quality_var"] = min_feature_quality_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def fail_gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any features in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        '''
        result = self._values.get("fail_gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any features in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        '''
        result = self._values.get("fail_gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feature_radius(self) -> typing.Optional[builtins.str]:
        '''The size in pixels of the important features to search for.

        If identified, two features never appear closer together than this value, ``8.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius DataAkamaiImagingPolicyImage#feature_radius}
        '''
        result = self._values.get("feature_radius")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feature_radius_var(self) -> typing.Optional[builtins.str]:
        '''The size in pixels of the important features to search for.

        If identified, two features never appear closer together than this value, ``8.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius_var DataAkamaiImagingPolicyImage#feature_radius_var}
        '''
        result = self._values.get("feature_radius_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the region of interest plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the region of interest plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def max_features(self) -> typing.Optional[builtins.str]:
        '''The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features DataAkamaiImagingPolicyImage#max_features}
        '''
        result = self._values.get("max_features")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def max_features_var(self) -> typing.Optional[builtins.str]:
        '''The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features_var DataAkamaiImagingPolicyImage#max_features_var}
        '''
        result = self._values.get("max_features_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def min_feature_quality(self) -> typing.Optional[builtins.str]:
        '''Determines the minimum quality level of the feature identified.

        To consider a feature important, the feature needs to surpass this value.  Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality DataAkamaiImagingPolicyImage#min_feature_quality}
        '''
        result = self._values.get("min_feature_quality")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def min_feature_quality_var(self) -> typing.Optional[builtins.str]:
        '''Determines the minimum quality level of the feature identified.

        To consider a feature important, the feature needs to surpass this value.  Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality_var DataAkamaiImagingPolicyImage#min_feature_quality_var}
        '''
        result = self._values.get("min_feature_quality_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''Adds space around the region of interest.

        The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''Adds space around the region of interest.

        The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFeatureCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFeatureCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFeatureCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9930cc91f89abc81f28ca98173f0ad7a1191c5b90a20c36e28bf6c0850b10f5d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFeatureCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a32f2abfe97983f417244ebddc9f59caba763e2a7d61b2e6a90c277880482c04)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFeatureCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__428de4de5b6e084e65d748bcd1a1cda15fa87ba9710dcf746bccc9e98ec26264)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a6500dfd0fe350632da8022e8e09ad78b0b6f693ff35673eefcd857f61877c6c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a0bfe60bc36bc64f9c12059fa42aac44a5e7d1bd95aaf2df8aa1752073c7f158)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFeatureCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFeatureCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFeatureCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f107393d677237ed38b28178191497e80e60700f86bb70da900beccd8b79512)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFeatureCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFeatureCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1ca907d3cd075f1c5ab3a90df9e48a13718799b6a18176e9ed18f0acbe4f4919)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetFailGravity")
    def reset_fail_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravity", []))

    @jsii.member(jsii_name="resetFailGravityVar")
    def reset_fail_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravityVar", []))

    @jsii.member(jsii_name="resetFeatureRadius")
    def reset_feature_radius(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureRadius", []))

    @jsii.member(jsii_name="resetFeatureRadiusVar")
    def reset_feature_radius_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureRadiusVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetMaxFeatures")
    def reset_max_features(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxFeatures", []))

    @jsii.member(jsii_name="resetMaxFeaturesVar")
    def reset_max_features_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxFeaturesVar", []))

    @jsii.member(jsii_name="resetMinFeatureQuality")
    def reset_min_feature_quality(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMinFeatureQuality", []))

    @jsii.member(jsii_name="resetMinFeatureQualityVar")
    def reset_min_feature_quality_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMinFeatureQualityVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="failGravityInput")
    def fail_gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityVarInput")
    def fail_gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featureRadiusInput")
    def feature_radius_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featureRadiusInput"))

    @builtins.property
    @jsii.member(jsii_name="featureRadiusVarInput")
    def feature_radius_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featureRadiusVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesInput")
    def max_features_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "maxFeaturesInput"))

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesVarInput")
    def max_features_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "maxFeaturesVarInput"))

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityInput")
    def min_feature_quality_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "minFeatureQualityInput"))

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityVarInput")
    def min_feature_quality_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "minFeatureQualityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravity")
    def fail_gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravity"))

    @fail_gravity.setter
    def fail_gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ccbbc5885211c1899b813e0bcf87f1bf5b27d0aed240b5f5530f0bfd07d3457c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravity", value)

    @builtins.property
    @jsii.member(jsii_name="failGravityVar")
    def fail_gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravityVar"))

    @fail_gravity_var.setter
    def fail_gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eee9f60467160ada590b2096f55f828c33b448e1dd621d8f1ff353896d7ae267)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="featureRadius")
    def feature_radius(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featureRadius"))

    @feature_radius.setter
    def feature_radius(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5d858e9e6f9ee67d1d2499b1e24499867bf7969d1263c74f57ef9a8f83032aef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featureRadius", value)

    @builtins.property
    @jsii.member(jsii_name="featureRadiusVar")
    def feature_radius_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featureRadiusVar"))

    @feature_radius_var.setter
    def feature_radius_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cdd1560a36f4218cc59c0ae064742a0ded319572ca67dde5bfbd5c66930f29da)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featureRadiusVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ef6073dbc5a02c0186ef174895791932c0dc2eba82aae4b013f6f9420d1611da)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__485fe6faa543574462d7189466b72e1684c3af6eb1e7901a1995f6b6a1b9ccb6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7c9518fbd0b84a80802768b1d0c154af649d4e6b240206ec00f1886abbdf65ba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__68b60af1a77f4b5109300fdfa6f63adf4b7f582f1915c5a47f254f6c00244566)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="maxFeatures")
    def max_features(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "maxFeatures"))

    @max_features.setter
    def max_features(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eb40c7c497c530e84d06f8ce0a6786ded99564f7abf3ddd2eaa131ec11d1ede6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "maxFeatures", value)

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesVar")
    def max_features_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "maxFeaturesVar"))

    @max_features_var.setter
    def max_features_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f986d2b5b8f9a24453917c32ca58c13e6f72e65566ee45bbebd2c91e80a202d5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "maxFeaturesVar", value)

    @builtins.property
    @jsii.member(jsii_name="minFeatureQuality")
    def min_feature_quality(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "minFeatureQuality"))

    @min_feature_quality.setter
    def min_feature_quality(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__28a803864283343f4843172513a683f074ac5eb4f6fed5a6c57431500dfc81ee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "minFeatureQuality", value)

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityVar")
    def min_feature_quality_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "minFeatureQualityVar"))

    @min_feature_quality_var.setter
    def min_feature_quality_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9e1dd9985b3030101f2dbb3a07a0006e5f30e1f072df41164f4f21d3de7b0c03)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "minFeatureQualityVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__704ea133e396c3782793ee461336b8fa65c04326d5e6f500a6e833178daf9cbe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__760c06098718969b40379f4011f5048e0687e41f16a894694c4ccd7e82692ebb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1ad924b0640088790d990068576a703c01c40439098a95af9e19aa66da826442)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__84000cef703a71ddb868f50ae5dda1a8db104e568fd210bd2515511f675475c3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f69bacd99d694ea578eebd59f916f11214efe6c7982ad7397e7ac6f97a82d5ae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__11dd1b4ce7f687d52afa8f8c7b282164823a3af8ca302b51928ddd6e6e18f9a5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFeatureCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFeatureCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFeatureCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__792150ffa87160bde1c3525f91cc57f0685e354e76258a69317201631baa36e7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFill",
    jsii_struct_bases=[],
    name_mapping={
        "fill_transformation": "fillTransformation",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFill:
    def __init__(
        self,
        *,
        fill_transformation: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fill_transformation: fill_transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_transformation DataAkamaiImagingPolicyImage#fill_transformation}
        :param height: The height value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The width value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(fill_transformation, dict):
            fill_transformation = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformation(**fill_transformation)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__558c7eef5c25ab0376d891112e3b251447c4b4ec4303755cf8233d92c1528033)
            check_type(argname="argument fill_transformation", value=fill_transformation, expected_type=type_hints["fill_transformation"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fill_transformation is not None:
            self._values["fill_transformation"] = fill_transformation
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def fill_transformation(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformation"]:
        '''fill_transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_transformation DataAkamaiImagingPolicyImage#fill_transformation}
        '''
        result = self._values.get("fill_transformation")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformation"], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFill(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformation",
    jsii_struct_bases=[],
    name_mapping={
        "append": "append",
        "aspect_crop": "aspectCrop",
        "background_color": "backgroundColor",
        "blur": "blur",
        "chroma_key": "chromaKey",
        "composite": "composite",
        "compound": "compound",
        "contrast": "contrast",
        "crop": "crop",
        "face_crop": "faceCrop",
        "feature_crop": "featureCrop",
        "fit_and_fill": "fitAndFill",
        "goop": "goop",
        "grayscale": "grayscale",
        "hsl": "hsl",
        "hsv": "hsv",
        "if_dimension": "ifDimension",
        "if_orientation": "ifOrientation",
        "im_query": "imQuery",
        "max_colors": "maxColors",
        "mirror": "mirror",
        "mono_hue": "monoHue",
        "opacity": "opacity",
        "region_of_interest_crop": "regionOfInterestCrop",
        "relative_crop": "relativeCrop",
        "remove_color": "removeColor",
        "resize": "resize",
        "rotate": "rotate",
        "scale": "scale",
        "shear": "shear",
        "trim": "trim",
        "unsharp_mask": "unsharpMask",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformation:
    def __init__(
        self,
        *,
        append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationAppend", typing.Dict[builtins.str, typing.Any]]]]] = None,
        aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationAspectCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationBackgroundColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationBlur", typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationChromaKey", typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationComposite", typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationCompound", typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationContrast", typing.Dict[builtins.str, typing.Any]]]]] = None,
        crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationFaceCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationFeatureCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationFitAndFill", typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationGoop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationGrayscale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationHsl", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationHsv", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfDimension", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfOrientation", typing.Dict[builtins.str, typing.Any]]]]] = None,
        im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationImQuery", typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationMaxColors", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationMirror", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationMonoHue", typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationOpacity", typing.Dict[builtins.str, typing.Any]]]]] = None,
        region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationRegionOfInterestCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationRelativeCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationRemoveColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationResize", typing.Dict[builtins.str, typing.Any]]]]] = None,
        rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationRotate", typing.Dict[builtins.str, typing.Any]]]]] = None,
        scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationScale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationShear", typing.Dict[builtins.str, typing.Any]]]]] = None,
        trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationTrim", typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationUnsharpMask", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param append: append block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        :param aspect_crop: aspect_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param crop: crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        :param face_crop: face_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        :param feature_crop: feature_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        :param fit_and_fill: fit_and_fill block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param im_query: im_query block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param region_of_interest_crop: region_of_interest_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        :param relative_crop: relative_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param resize: resize block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        :param rotate: rotate block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        :param scale: scale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param shear: shear block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        :param trim: trim block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__41f71749020a6f028db865c538cfad1b05cbb569f9112c22deacb7de0580e01e)
            check_type(argname="argument append", value=append, expected_type=type_hints["append"])
            check_type(argname="argument aspect_crop", value=aspect_crop, expected_type=type_hints["aspect_crop"])
            check_type(argname="argument background_color", value=background_color, expected_type=type_hints["background_color"])
            check_type(argname="argument blur", value=blur, expected_type=type_hints["blur"])
            check_type(argname="argument chroma_key", value=chroma_key, expected_type=type_hints["chroma_key"])
            check_type(argname="argument composite", value=composite, expected_type=type_hints["composite"])
            check_type(argname="argument compound", value=compound, expected_type=type_hints["compound"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument crop", value=crop, expected_type=type_hints["crop"])
            check_type(argname="argument face_crop", value=face_crop, expected_type=type_hints["face_crop"])
            check_type(argname="argument feature_crop", value=feature_crop, expected_type=type_hints["feature_crop"])
            check_type(argname="argument fit_and_fill", value=fit_and_fill, expected_type=type_hints["fit_and_fill"])
            check_type(argname="argument goop", value=goop, expected_type=type_hints["goop"])
            check_type(argname="argument grayscale", value=grayscale, expected_type=type_hints["grayscale"])
            check_type(argname="argument hsl", value=hsl, expected_type=type_hints["hsl"])
            check_type(argname="argument hsv", value=hsv, expected_type=type_hints["hsv"])
            check_type(argname="argument if_dimension", value=if_dimension, expected_type=type_hints["if_dimension"])
            check_type(argname="argument if_orientation", value=if_orientation, expected_type=type_hints["if_orientation"])
            check_type(argname="argument im_query", value=im_query, expected_type=type_hints["im_query"])
            check_type(argname="argument max_colors", value=max_colors, expected_type=type_hints["max_colors"])
            check_type(argname="argument mirror", value=mirror, expected_type=type_hints["mirror"])
            check_type(argname="argument mono_hue", value=mono_hue, expected_type=type_hints["mono_hue"])
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument region_of_interest_crop", value=region_of_interest_crop, expected_type=type_hints["region_of_interest_crop"])
            check_type(argname="argument relative_crop", value=relative_crop, expected_type=type_hints["relative_crop"])
            check_type(argname="argument remove_color", value=remove_color, expected_type=type_hints["remove_color"])
            check_type(argname="argument resize", value=resize, expected_type=type_hints["resize"])
            check_type(argname="argument rotate", value=rotate, expected_type=type_hints["rotate"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument shear", value=shear, expected_type=type_hints["shear"])
            check_type(argname="argument trim", value=trim, expected_type=type_hints["trim"])
            check_type(argname="argument unsharp_mask", value=unsharp_mask, expected_type=type_hints["unsharp_mask"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if append is not None:
            self._values["append"] = append
        if aspect_crop is not None:
            self._values["aspect_crop"] = aspect_crop
        if background_color is not None:
            self._values["background_color"] = background_color
        if blur is not None:
            self._values["blur"] = blur
        if chroma_key is not None:
            self._values["chroma_key"] = chroma_key
        if composite is not None:
            self._values["composite"] = composite
        if compound is not None:
            self._values["compound"] = compound
        if contrast is not None:
            self._values["contrast"] = contrast
        if crop is not None:
            self._values["crop"] = crop
        if face_crop is not None:
            self._values["face_crop"] = face_crop
        if feature_crop is not None:
            self._values["feature_crop"] = feature_crop
        if fit_and_fill is not None:
            self._values["fit_and_fill"] = fit_and_fill
        if goop is not None:
            self._values["goop"] = goop
        if grayscale is not None:
            self._values["grayscale"] = grayscale
        if hsl is not None:
            self._values["hsl"] = hsl
        if hsv is not None:
            self._values["hsv"] = hsv
        if if_dimension is not None:
            self._values["if_dimension"] = if_dimension
        if if_orientation is not None:
            self._values["if_orientation"] = if_orientation
        if im_query is not None:
            self._values["im_query"] = im_query
        if max_colors is not None:
            self._values["max_colors"] = max_colors
        if mirror is not None:
            self._values["mirror"] = mirror
        if mono_hue is not None:
            self._values["mono_hue"] = mono_hue
        if opacity is not None:
            self._values["opacity"] = opacity
        if region_of_interest_crop is not None:
            self._values["region_of_interest_crop"] = region_of_interest_crop
        if relative_crop is not None:
            self._values["relative_crop"] = relative_crop
        if remove_color is not None:
            self._values["remove_color"] = remove_color
        if resize is not None:
            self._values["resize"] = resize
        if rotate is not None:
            self._values["rotate"] = rotate
        if scale is not None:
            self._values["scale"] = scale
        if shear is not None:
            self._values["shear"] = shear
        if trim is not None:
            self._values["trim"] = trim
        if unsharp_mask is not None:
            self._values["unsharp_mask"] = unsharp_mask

    @builtins.property
    def append(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationAppend"]]]:
        '''append block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        '''
        result = self._values.get("append")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationAppend"]]], result)

    @builtins.property
    def aspect_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationAspectCrop"]]]:
        '''aspect_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        '''
        result = self._values.get("aspect_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationAspectCrop"]]], result)

    @builtins.property
    def background_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationBackgroundColor"]]]:
        '''background_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        '''
        result = self._values.get("background_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationBackgroundColor"]]], result)

    @builtins.property
    def blur(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationBlur"]]]:
        '''blur block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        '''
        result = self._values.get("blur")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationBlur"]]], result)

    @builtins.property
    def chroma_key(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationChromaKey"]]]:
        '''chroma_key block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        '''
        result = self._values.get("chroma_key")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationChromaKey"]]], result)

    @builtins.property
    def composite(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationComposite"]]]:
        '''composite block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        '''
        result = self._values.get("composite")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationComposite"]]], result)

    @builtins.property
    def compound(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationCompound"]]]:
        '''compound block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        '''
        result = self._values.get("compound")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationCompound"]]], result)

    @builtins.property
    def contrast(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationContrast"]]]:
        '''contrast block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationContrast"]]], result)

    @builtins.property
    def crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationCrop"]]]:
        '''crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        '''
        result = self._values.get("crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationCrop"]]], result)

    @builtins.property
    def face_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationFaceCrop"]]]:
        '''face_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        '''
        result = self._values.get("face_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationFaceCrop"]]], result)

    @builtins.property
    def feature_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationFeatureCrop"]]]:
        '''feature_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        '''
        result = self._values.get("feature_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationFeatureCrop"]]], result)

    @builtins.property
    def fit_and_fill(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationFitAndFill"]]]:
        '''fit_and_fill block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        '''
        result = self._values.get("fit_and_fill")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationFitAndFill"]]], result)

    @builtins.property
    def goop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationGoop"]]]:
        '''goop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        '''
        result = self._values.get("goop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationGoop"]]], result)

    @builtins.property
    def grayscale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationGrayscale"]]]:
        '''grayscale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        '''
        result = self._values.get("grayscale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationGrayscale"]]], result)

    @builtins.property
    def hsl(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationHsl"]]]:
        '''hsl block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        '''
        result = self._values.get("hsl")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationHsl"]]], result)

    @builtins.property
    def hsv(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationHsv"]]]:
        '''hsv block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        '''
        result = self._values.get("hsv")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationHsv"]]], result)

    @builtins.property
    def if_dimension(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfDimension"]]]:
        '''if_dimension block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        '''
        result = self._values.get("if_dimension")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfDimension"]]], result)

    @builtins.property
    def if_orientation(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfOrientation"]]]:
        '''if_orientation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        '''
        result = self._values.get("if_orientation")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfOrientation"]]], result)

    @builtins.property
    def im_query(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationImQuery"]]]:
        '''im_query block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        '''
        result = self._values.get("im_query")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationImQuery"]]], result)

    @builtins.property
    def max_colors(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationMaxColors"]]]:
        '''max_colors block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        '''
        result = self._values.get("max_colors")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationMaxColors"]]], result)

    @builtins.property
    def mirror(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationMirror"]]]:
        '''mirror block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        '''
        result = self._values.get("mirror")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationMirror"]]], result)

    @builtins.property
    def mono_hue(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationMonoHue"]]]:
        '''mono_hue block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        '''
        result = self._values.get("mono_hue")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationMonoHue"]]], result)

    @builtins.property
    def opacity(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationOpacity"]]]:
        '''opacity block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationOpacity"]]], result)

    @builtins.property
    def region_of_interest_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationRegionOfInterestCrop"]]]:
        '''region_of_interest_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        '''
        result = self._values.get("region_of_interest_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationRegionOfInterestCrop"]]], result)

    @builtins.property
    def relative_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationRelativeCrop"]]]:
        '''relative_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        '''
        result = self._values.get("relative_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationRelativeCrop"]]], result)

    @builtins.property
    def remove_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationRemoveColor"]]]:
        '''remove_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        '''
        result = self._values.get("remove_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationRemoveColor"]]], result)

    @builtins.property
    def resize(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationResize"]]]:
        '''resize block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        '''
        result = self._values.get("resize")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationResize"]]], result)

    @builtins.property
    def rotate(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationRotate"]]]:
        '''rotate block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        '''
        result = self._values.get("rotate")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationRotate"]]], result)

    @builtins.property
    def scale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationScale"]]]:
        '''scale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationScale"]]], result)

    @builtins.property
    def shear(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationShear"]]]:
        '''shear block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        '''
        result = self._values.get("shear")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationShear"]]], result)

    @builtins.property
    def trim(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationTrim"]]]:
        '''trim block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        '''
        result = self._values.get("trim")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationTrim"]]], result)

    @builtins.property
    def unsharp_mask(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationUnsharpMask"]]]:
        '''unsharp_mask block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        result = self._values.get("unsharp_mask")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationUnsharpMask"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationAppend",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_priority": "gravityPriority",
        "gravity_priority_var": "gravityPriorityVar",
        "gravity_var": "gravityVar",
        "preserve_minor_dimension": "preserveMinorDimension",
        "preserve_minor_dimension_var": "preserveMinorDimensionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationAppend:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationAppendImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_priority: typing.Optional[builtins.str] = None,
        gravity_priority_var: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        preserve_minor_dimension: typing.Optional[builtins.str] = None,
        preserve_minor_dimension_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Specifies where to place the ``image`` relative to the source image. The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_priority: Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal. The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority DataAkamaiImagingPolicyImage#gravity_priority}
        :param gravity_priority_var: Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal. The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority_var DataAkamaiImagingPolicyImage#gravity_priority_var}
        :param gravity_var: Specifies where to place the ``image`` relative to the source image. The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param preserve_minor_dimension: Whether to preserve the source image's minor dimension, ``false`` by default. The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension DataAkamaiImagingPolicyImage#preserve_minor_dimension}
        :param preserve_minor_dimension_var: Whether to preserve the source image's minor dimension, ``false`` by default. The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension_var DataAkamaiImagingPolicyImage#preserve_minor_dimension_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationAppendImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d0a8412bf8e92506fcd2cba002304ef003d56e035daf79df02ac8190d87c8c91)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_priority", value=gravity_priority, expected_type=type_hints["gravity_priority"])
            check_type(argname="argument gravity_priority_var", value=gravity_priority_var, expected_type=type_hints["gravity_priority_var"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument preserve_minor_dimension", value=preserve_minor_dimension, expected_type=type_hints["preserve_minor_dimension"])
            check_type(argname="argument preserve_minor_dimension_var", value=preserve_minor_dimension_var, expected_type=type_hints["preserve_minor_dimension_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_priority is not None:
            self._values["gravity_priority"] = gravity_priority
        if gravity_priority_var is not None:
            self._values["gravity_priority_var"] = gravity_priority_var
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if preserve_minor_dimension is not None:
            self._values["preserve_minor_dimension"] = preserve_minor_dimension
        if preserve_minor_dimension_var is not None:
            self._values["preserve_minor_dimension_var"] = preserve_minor_dimension_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationAppendImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationAppendImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Specifies where to place the ``image`` relative to the source image.

        The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_priority(self) -> typing.Optional[builtins.str]:
        '''Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal.

        The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority DataAkamaiImagingPolicyImage#gravity_priority}
        '''
        result = self._values.get("gravity_priority")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_priority_var(self) -> typing.Optional[builtins.str]:
        '''Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal.

        The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority_var DataAkamaiImagingPolicyImage#gravity_priority_var}
        '''
        result = self._values.get("gravity_priority_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Specifies where to place the ``image`` relative to the source image.

        The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def preserve_minor_dimension(self) -> typing.Optional[builtins.str]:
        '''Whether to preserve the source image's minor dimension, ``false`` by default.

        The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension DataAkamaiImagingPolicyImage#preserve_minor_dimension}
        '''
        result = self._values.get("preserve_minor_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def preserve_minor_dimension_var(self) -> typing.Optional[builtins.str]:
        '''Whether to preserve the source image's minor dimension, ``false`` by default.

        The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension_var DataAkamaiImagingPolicyImage#preserve_minor_dimension_var}
        '''
        result = self._values.get("preserve_minor_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationAppend(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationAppendImage",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationAppendImage:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationAppendImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationAppendImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationAppendImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__022eba26398ba916c60294be23865b1dc1f1570e9f81aa4a1c1ddc13c3289b7b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationAppendImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationAppendImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationAppendImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f8adbecc64f2f6fffb69432f5986dafdf0fa04f5997dba2b8f7adaa267699bb1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationAppendList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationAppendList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0fdf707a9681e944ab6d098cb8ad1954102ef7c6807a64d40c62d3e3614b352c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationAppendOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc4a79fe59340ef06faed46e56913be56e544dc1db55f4ea03e80511cbbb2f19)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationAppendOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__427f3fad7efa9d6277907e4795d8e28c83667009b7cd2d97eb0afe9be8d0be82)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__57c2a77a4e7f4969690d226f8ea6bc6d60143fb63e8c52cc6d0ce4ac13f0cbda)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fbf266c267efe1e952f00a0525d842abfac8bc429cd29803cdcaa8a9647a7d64)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationAppend]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationAppend]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationAppend]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6aa04086c4a59e6b63ae18099c10cb8a22ef7cd4458952c0378aa84fbbaabeae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationAppendOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationAppendOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2e4bc9c53d9307680d5ad14d13158e32492735473a09474c1fe644080bbc06cf)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationAppendImage()

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityPriority")
    def reset_gravity_priority(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityPriority", []))

    @jsii.member(jsii_name="resetGravityPriorityVar")
    def reset_gravity_priority_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityPriorityVar", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPreserveMinorDimension")
    def reset_preserve_minor_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPreserveMinorDimension", []))

    @jsii.member(jsii_name="resetPreserveMinorDimensionVar")
    def reset_preserve_minor_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPreserveMinorDimensionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationAppendImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationAppendImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityInput")
    def gravity_priority_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityPriorityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityVarInput")
    def gravity_priority_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityPriorityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationAppendImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationAppendImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionInput")
    def preserve_minor_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "preserveMinorDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionVarInput")
    def preserve_minor_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "preserveMinorDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab2d342d6943b914bed64992f7c7053bdbf9e92a3b7839c3a0b9cdfd2b378610)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityPriority")
    def gravity_priority(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityPriority"))

    @gravity_priority.setter
    def gravity_priority(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2b9ced7df39158f91d35c98252e9759e8cc2d486555fb40bf793d801506d7bf8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityPriority", value)

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityVar")
    def gravity_priority_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityPriorityVar"))

    @gravity_priority_var.setter
    def gravity_priority_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2da732ae85426385d727eb69bd00ad15747adfbfef9ff91923d07aeffdea5621)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityPriorityVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f798422aa8a43416cbfe23113da96c19933c0ecb4c7784776a838594671565ed)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimension")
    def preserve_minor_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "preserveMinorDimension"))

    @preserve_minor_dimension.setter
    def preserve_minor_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1032e649305af10b7bf089974a1c3338f262baf1d38b98e02f272e568be126ee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "preserveMinorDimension", value)

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionVar")
    def preserve_minor_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "preserveMinorDimensionVar"))

    @preserve_minor_dimension_var.setter
    def preserve_minor_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__88c473ea28fc20195c6ab8fae5b44b6b7ab0953e5d23d757d4d1f5d4dd81301f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "preserveMinorDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationAppend]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationAppend]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationAppend]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__442f155b5bc2742e1cf214b897131f72d20d2fbea561937708c402bcde25b1cf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationAspectCrop",
    jsii_struct_bases=[],
    name_mapping={
        "allow_expansion": "allowExpansion",
        "allow_expansion_var": "allowExpansionVar",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationAspectCrop:
    def __init__(
        self,
        *,
        allow_expansion: typing.Optional[builtins.str] = None,
        allow_expansion_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_expansion: Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image. Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        :param allow_expansion_var: Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image. Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        :param height: The height term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The width term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        :param x_position: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7b3e6355e00fa8f35168abcde91c16954c13c99c3001eda006ac1d254361dedf)
            check_type(argname="argument allow_expansion", value=allow_expansion, expected_type=type_hints["allow_expansion"])
            check_type(argname="argument allow_expansion_var", value=allow_expansion_var, expected_type=type_hints["allow_expansion_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if allow_expansion is not None:
            self._values["allow_expansion"] = allow_expansion
        if allow_expansion_var is not None:
            self._values["allow_expansion_var"] = allow_expansion_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def allow_expansion(self) -> typing.Optional[builtins.str]:
        '''Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image.

        Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        '''
        result = self._values.get("allow_expansion")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def allow_expansion_var(self) -> typing.Optional[builtins.str]:
        '''Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image.

        Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        '''
        result = self._values.get("allow_expansion_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationAspectCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationAspectCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationAspectCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cde96758b3299a23051e2800e0b9055dea147637aba17003e823b65f9f956cfa)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationAspectCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__72d79473c02e5400b396b64b1fccea38ebb1dd3e5e32f1dde587fc96fa06b41e)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationAspectCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a16807520fea0bcb38dcf8428c7b1263b57f25d1bbc57402d927cc2df961a946)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__baaf1be037bcf0c6c2af13a9dd4a2b2f11adbdbfa940a3b0570fb35b6c7f8396)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d3f1b6b6ce320fd1f372338f6de2e1d8b56d982dcd29147895f8fe0494c64b51)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationAspectCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationAspectCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationAspectCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b32fffa1e3bdb726aca18c48a6d57b349a9b81f491981adf3fed4467ef183975)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationAspectCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationAspectCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__72da626d928b59f34fde99b3053b99c9ba57652e226caafc8aa46af46b5ca125)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAllowExpansion")
    def reset_allow_expansion(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansion", []))

    @jsii.member(jsii_name="resetAllowExpansionVar")
    def reset_allow_expansion_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansionVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionInput")
    def allow_expansion_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVarInput")
    def allow_expansion_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansion")
    def allow_expansion(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansion"))

    @allow_expansion.setter
    def allow_expansion(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__14ace99d0a4f65379bbd44f5a376bba4247b04b9d6b2db6dd0372f2baa4d2a57)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansion", value)

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVar")
    def allow_expansion_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansionVar"))

    @allow_expansion_var.setter
    def allow_expansion_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__caab7981e05f86fafe5637f5e488c1566ab44542a7761c0037f9706eb65f6a4b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansionVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__87660be3c4f84089f2217b0362387db711f4149a0194b886736d0f556003f39e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ec5ea61186a71742d533cabb351ff21582d9cb9e39b27a2aa550b18350490d6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ba863fb19f1dc30a816b7a4be538e23466c51159e3f62ca43e0f300aeca96a6c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b1104fad9e31d8628f033d6b30bfc32660c3498b960d7532b20b357c9599fea7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8590ff3009321500c351aa33df521040e84d35f1ddfa515b3a0239240f73741b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f2e58d3665df3638008e45a247cab8f1008c76cb78f87327e5405bdd2312301)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__684c70231fb73518bb4dc1dbc72a1297f550ba5da810189f64e119224c245608)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb17000dc123777180880a64a8202a30d109ce8993fb64a59921eb9676bcede4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationAspectCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationAspectCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationAspectCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b1c5fb81bdbd3e8e95312c38bcaa4505d06ed0da2c925b88ea326b9bc95a0dbb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationBackgroundColor",
    jsii_struct_bases=[],
    name_mapping={"color": "color", "color_var": "colorVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationBackgroundColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__77ecd84882dd4907954bd024b5b526f1f1ba12eeb07e10c5d4912d16930ecc87)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationBackgroundColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationBackgroundColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationBackgroundColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__24d87c45cd1f7fbdba9e55668b9a72c73209cd5c5b3104c4269bf4a9ca84fd26)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationBackgroundColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__72bd3f80a7678f42c653797f9523924f1928d9045642db3b894a185fea5b8dd3)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationBackgroundColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bd34d02f6c5adb602960a6491aa82d45f51bb7faa98b94b0a78f16a3ac351dcb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab967a454492a5116e09feab963de70252d17f4a4dbdae66b1fb65e383461417)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a889335967340e54dbc765111a017a5c98bbecf80824e252da12780f5862912c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationBackgroundColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationBackgroundColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a44321a46a8e7416c53051eec6c5af9d04c6923b0d82da59cd5fdcd1093a59e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationBackgroundColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationBackgroundColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7b75dcf5e4f2fd56c117769cc27606a3536b0b673a32795ed3353b114489eb2d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b4ea3562536719dccffcec7631004b0602cdfcd94a1bfae548d5cb9b24b1868a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0f69da8172976c0c690ce6cec7cadb3258ec07cc95e1c99162041b22fa9404cc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationBackgroundColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationBackgroundColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationBackgroundColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9029173f47f0ec7595b9b1d99b78ec004f5b70e1cad16032ce4d55901d36b078)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationBlur",
    jsii_struct_bases=[],
    name_mapping={"sigma": "sigma", "sigma_var": "sigmaVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationBlur:
    def __init__(
        self,
        *,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param sigma: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__403d3bc9ac2e9f2c8146d7476e1b4b492786d92b8541bbfe37426e159fdd8bf3)
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationBlur(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationBlurList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationBlurList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__54971ca16f34e37bce42ecf4707f7faafa240c77e4cec6021be69ff07f7212f7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationBlurOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1555d70a7437fbccecacae610e42df2b41fa633d13f142ba6ceae63433211b68)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationBlurOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e0e63df688cf4c2cba3137da04079aba16be3235de5fa5afab2dc2330eb453b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__76f34c158bcfe2d63f8fbce26ea3c669ddd8dd369f6e1da24190038a65eb6a31)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__188c133711cbec383527ae14b7ff226e547fe1913c45a1f7db1b8e993c13cfd9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationBlur]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationBlur]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0afd8b37776c65d541c85a653c8c5f733dfb9e200087512c7ce507942c5ce0e2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationBlurOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationBlurOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__29e6dedde78706d74a09135b9b490ccbf3e345aeae2018857959a1fd72d77cfa)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__907e7fd65ada3956b48fb52bd28cbc342830197013cff2cf78e120b5d2673d4e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7ef3589a94afcc1c35d54e2e60a8a4504f524c7744ce6bd41d92513d9d34b357)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationBlur]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationBlur]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationBlur]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7467045d61acbc2d90d34ff68e04e112657584c38606139cbcfad29e6431c64f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationChromaKey",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_feather": "hueFeather",
        "hue_feather_var": "hueFeatherVar",
        "hue_tolerance": "hueTolerance",
        "hue_tolerance_var": "hueToleranceVar",
        "hue_var": "hueVar",
        "lightness_feather": "lightnessFeather",
        "lightness_feather_var": "lightnessFeatherVar",
        "lightness_tolerance": "lightnessTolerance",
        "lightness_tolerance_var": "lightnessToleranceVar",
        "saturation_feather": "saturationFeather",
        "saturation_feather_var": "saturationFeatherVar",
        "saturation_tolerance": "saturationTolerance",
        "saturation_tolerance_var": "saturationToleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationChromaKey:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_feather: typing.Optional[builtins.str] = None,
        hue_feather_var: typing.Optional[builtins.str] = None,
        hue_tolerance: typing.Optional[builtins.str] = None,
        hue_tolerance_var: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness_feather: typing.Optional[builtins.str] = None,
        lightness_feather_var: typing.Optional[builtins.str] = None,
        lightness_tolerance: typing.Optional[builtins.str] = None,
        lightness_tolerance_var: typing.Optional[builtins.str] = None,
        saturation_feather: typing.Optional[builtins.str] = None,
        saturation_feather_var: typing.Optional[builtins.str] = None,
        saturation_tolerance: typing.Optional[builtins.str] = None,
        saturation_tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_feather: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        :param hue_feather_var: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        :param hue_tolerance: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        :param hue_tolerance_var: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        :param hue_var: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness_feather: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        :param lightness_feather_var: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        :param lightness_tolerance: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        :param lightness_tolerance_var: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        :param saturation_feather: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        :param saturation_feather_var: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        :param saturation_tolerance: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        :param saturation_tolerance_var: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__39e8ff0e5a66e275c6c7a75633bf47ffd75e52e27a583f60a6f6d292427c8ed6)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_feather", value=hue_feather, expected_type=type_hints["hue_feather"])
            check_type(argname="argument hue_feather_var", value=hue_feather_var, expected_type=type_hints["hue_feather_var"])
            check_type(argname="argument hue_tolerance", value=hue_tolerance, expected_type=type_hints["hue_tolerance"])
            check_type(argname="argument hue_tolerance_var", value=hue_tolerance_var, expected_type=type_hints["hue_tolerance_var"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness_feather", value=lightness_feather, expected_type=type_hints["lightness_feather"])
            check_type(argname="argument lightness_feather_var", value=lightness_feather_var, expected_type=type_hints["lightness_feather_var"])
            check_type(argname="argument lightness_tolerance", value=lightness_tolerance, expected_type=type_hints["lightness_tolerance"])
            check_type(argname="argument lightness_tolerance_var", value=lightness_tolerance_var, expected_type=type_hints["lightness_tolerance_var"])
            check_type(argname="argument saturation_feather", value=saturation_feather, expected_type=type_hints["saturation_feather"])
            check_type(argname="argument saturation_feather_var", value=saturation_feather_var, expected_type=type_hints["saturation_feather_var"])
            check_type(argname="argument saturation_tolerance", value=saturation_tolerance, expected_type=type_hints["saturation_tolerance"])
            check_type(argname="argument saturation_tolerance_var", value=saturation_tolerance_var, expected_type=type_hints["saturation_tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_feather is not None:
            self._values["hue_feather"] = hue_feather
        if hue_feather_var is not None:
            self._values["hue_feather_var"] = hue_feather_var
        if hue_tolerance is not None:
            self._values["hue_tolerance"] = hue_tolerance
        if hue_tolerance_var is not None:
            self._values["hue_tolerance_var"] = hue_tolerance_var
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness_feather is not None:
            self._values["lightness_feather"] = lightness_feather
        if lightness_feather_var is not None:
            self._values["lightness_feather_var"] = lightness_feather_var
        if lightness_tolerance is not None:
            self._values["lightness_tolerance"] = lightness_tolerance
        if lightness_tolerance_var is not None:
            self._values["lightness_tolerance_var"] = lightness_tolerance_var
        if saturation_feather is not None:
            self._values["saturation_feather"] = saturation_feather
        if saturation_feather_var is not None:
            self._values["saturation_feather_var"] = saturation_feather_var
        if saturation_tolerance is not None:
            self._values["saturation_tolerance"] = saturation_tolerance
        if saturation_tolerance_var is not None:
            self._values["saturation_tolerance_var"] = saturation_tolerance_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        '''
        result = self._values.get("hue_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        '''
        result = self._values.get("hue_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        '''
        result = self._values.get("hue_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        '''
        result = self._values.get("hue_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        '''
        result = self._values.get("lightness_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        '''
        result = self._values.get("lightness_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        '''
        result = self._values.get("lightness_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        '''
        result = self._values.get("lightness_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        '''
        result = self._values.get("saturation_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        '''
        result = self._values.get("saturation_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        '''
        result = self._values.get("saturation_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        result = self._values.get("saturation_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationChromaKey(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationChromaKeyList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationChromaKeyList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c7098a7f6fa97346a07911ab3aa61ada18742da2d203ea43f6c0e82fb2f007c1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationChromaKeyOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb076bd748c8ff4ea9dc624033c54ffa5ceed43ddc375a28ffa0feaf88a21958)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationChromaKeyOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8dc26e21a927ec6024942c6a9d71137cd39c9f4c9714b0a4fcda27dad45950b0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ff7ca31045bef6c530488361571b3a2196a27ec60911e2420885de72eb701217)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__22bf8c8710ea83adddbff06c05a170af075f96880a4e93a95b4d8cb1468495c6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationChromaKey]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationChromaKey]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__46b429486502a9b454479b55c5879359a95783a39e428662a4f25235b23afe1f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationChromaKeyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationChromaKeyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__59ab0ee91ba9851196dd3e3e4a3be45f09b9039b90ed113bbd9e9159f2406b4f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueFeather")
    def reset_hue_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeather", []))

    @jsii.member(jsii_name="resetHueFeatherVar")
    def reset_hue_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeatherVar", []))

    @jsii.member(jsii_name="resetHueTolerance")
    def reset_hue_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueTolerance", []))

    @jsii.member(jsii_name="resetHueToleranceVar")
    def reset_hue_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueToleranceVar", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightnessFeather")
    def reset_lightness_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeather", []))

    @jsii.member(jsii_name="resetLightnessFeatherVar")
    def reset_lightness_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeatherVar", []))

    @jsii.member(jsii_name="resetLightnessTolerance")
    def reset_lightness_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessTolerance", []))

    @jsii.member(jsii_name="resetLightnessToleranceVar")
    def reset_lightness_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessToleranceVar", []))

    @jsii.member(jsii_name="resetSaturationFeather")
    def reset_saturation_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeather", []))

    @jsii.member(jsii_name="resetSaturationFeatherVar")
    def reset_saturation_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeatherVar", []))

    @jsii.member(jsii_name="resetSaturationTolerance")
    def reset_saturation_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationTolerance", []))

    @jsii.member(jsii_name="resetSaturationToleranceVar")
    def reset_saturation_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherInput")
    def hue_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVarInput")
    def hue_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceInput")
    def hue_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVarInput")
    def hue_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherInput")
    def lightness_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVarInput")
    def lightness_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceInput")
    def lightness_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVarInput")
    def lightness_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherInput")
    def saturation_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVarInput")
    def saturation_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceInput")
    def saturation_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVarInput")
    def saturation_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cb9640b70dbefe17bfb300cf84912d3020b589bb2e9a26722f0c8d64a6aca1e6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeather")
    def hue_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeather"))

    @hue_feather.setter
    def hue_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4724c1715a91833aad2a1e32f9817c2258402dcc410083183e06abdaf6f01b8d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeather", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVar")
    def hue_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeatherVar"))

    @hue_feather_var.setter
    def hue_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__104f74d9300d4579d678a7dc2b66f1b708cc623483480ce775c269c2a0d5bdb3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueTolerance")
    def hue_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueTolerance"))

    @hue_tolerance.setter
    def hue_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aeddb3508dcc0253a0cfeab7a316c9e49599d54ceb654fcfb9a566f661c4fcfc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVar")
    def hue_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueToleranceVar"))

    @hue_tolerance_var.setter
    def hue_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f4350112baa7adda70cc9ac4e7de4e1a9f563366b1d392ecbacced502ceb635)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4d8ce85514de2e29bb450405c3da24ae82a66eb937b114f88e5166e4a0f5a904)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeather")
    def lightness_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeather"))

    @lightness_feather.setter
    def lightness_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5a736b64deb2661fb7342260b2f426e1174b1df6b39e2c09562f0e8e140256e9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeather", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVar")
    def lightness_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeatherVar"))

    @lightness_feather_var.setter
    def lightness_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__71acf2ed983ff2bcba304c83a574a3453c2f3b6d73390586986962512d4919f7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessTolerance")
    def lightness_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessTolerance"))

    @lightness_tolerance.setter
    def lightness_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__28f6edeaa89ca96a33d35b0c1e5fa9a9709bc17cc82185ede31a515884d75091)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVar")
    def lightness_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessToleranceVar"))

    @lightness_tolerance_var.setter
    def lightness_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__72451d47c13620c200a0d0fc1446a37a8fc7cb4eb72ed58cdd12be19929e99d4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeather")
    def saturation_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeather"))

    @saturation_feather.setter
    def saturation_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4242d2f7bd235e2ca15633f433a6c686ef43d93c269638f1fdf06f97f9ad6982)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeather", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVar")
    def saturation_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeatherVar"))

    @saturation_feather_var.setter
    def saturation_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a55bf558a346c1f4187c44416573d78f92cbf6718cc6a80a51f152765d4db66c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationTolerance")
    def saturation_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationTolerance"))

    @saturation_tolerance.setter
    def saturation_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1a692e3205980fee0bf07c64994441c0ff72893c840e8159449e05d0cc463eef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVar")
    def saturation_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationToleranceVar"))

    @saturation_tolerance_var.setter
    def saturation_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__723dbdd31e02831b39187a79d2a75471a34a801500c162ded62fdbad7007fbb7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationChromaKey]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationChromaKey]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationChromaKey]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b4e638b55aa342aa963cce3c5bca7a192fea8f9e9a1e1253d1c465a86879e249)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationComposite",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "placement": "placement",
        "placement_var": "placementVar",
        "scale": "scale",
        "scale_dimension": "scaleDimension",
        "scale_dimension_var": "scaleDimensionVar",
        "scale_var": "scaleVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationComposite:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationCompositeImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        placement: typing.Optional[builtins.str] = None,
        placement_var: typing.Optional[builtins.str] = None,
        scale: typing.Optional[builtins.str] = None,
        scale_dimension: typing.Optional[builtins.str] = None,
        scale_dimension_var: typing.Optional[builtins.str] = None,
        scale_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param placement: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        :param placement_var: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        :param scale: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param scale_dimension: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        :param scale_dimension_var: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        :param scale_var: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        :param x_position: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationCompositeImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be62c678296ab498f9e2fec7f171134d5b1b37329eb303e76e9f4792720aef23)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument placement", value=placement, expected_type=type_hints["placement"])
            check_type(argname="argument placement_var", value=placement_var, expected_type=type_hints["placement_var"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument scale_dimension", value=scale_dimension, expected_type=type_hints["scale_dimension"])
            check_type(argname="argument scale_dimension_var", value=scale_dimension_var, expected_type=type_hints["scale_dimension_var"])
            check_type(argname="argument scale_var", value=scale_var, expected_type=type_hints["scale_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if placement is not None:
            self._values["placement"] = placement
        if placement_var is not None:
            self._values["placement_var"] = placement_var
        if scale is not None:
            self._values["scale"] = scale
        if scale_dimension is not None:
            self._values["scale_dimension"] = scale_dimension
        if scale_dimension_var is not None:
            self._values["scale_dimension_var"] = scale_dimension_var
        if scale_var is not None:
            self._values["scale_var"] = scale_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationCompositeImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationCompositeImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        '''
        result = self._values.get("placement")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement_var(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        '''
        result = self._values.get("placement_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        '''
        result = self._values.get("scale_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        '''
        result = self._values.get("scale_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        '''
        result = self._values.get("scale_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationComposite(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationCompositeImage",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationCompositeImage:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationCompositeImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationCompositeImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationCompositeImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e8fbba5131a0840e67ba86932c9076873838add5d8f557eada3318d7d058a359)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationCompositeImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationCompositeImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8dc363d013f80bd96e56f4f2b9aba9ce42ed82b9a54a2fb27e7b11c7ae048172)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationCompositeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationCompositeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c850887299cba5e027a63b6ed1e174f477e318514f666c053077c7ebd37fdc3d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationCompositeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d793cef577b021873dab7e4c3abf91cc0eada42c5ea4acc97781fe25b8a44976)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationCompositeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__71644d205c22ddaf99a10959ccbb203b205e83662c8c534eaf8827875476e764)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c860e22526317414690667207f5e1b6164496d2400584ebdfa8a502297571be9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__621dadc4d414704893fc2dbbeb199afde7725cb0f73ed04f53f23284947e39e1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationComposite]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationComposite]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d11e1d8dc05a7e8c703dc75a32a2554cf1082f725f0c260d815ab7a3eaa03cb6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationCompositeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationCompositeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d63140490e1203f69fa13477e13d801e5a861a123477394c1057ccb7ba99d702)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationCompositeImage()

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPlacement")
    def reset_placement(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacement", []))

    @jsii.member(jsii_name="resetPlacementVar")
    def reset_placement_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacementVar", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetScaleDimension")
    def reset_scale_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimension", []))

    @jsii.member(jsii_name="resetScaleDimensionVar")
    def reset_scale_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimensionVar", []))

    @jsii.member(jsii_name="resetScaleVar")
    def reset_scale_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationCompositeImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationCompositeImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationCompositeImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="placementInput")
    def placement_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementInput"))

    @builtins.property
    @jsii.member(jsii_name="placementVarInput")
    def placement_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionInput")
    def scale_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVarInput")
    def scale_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleVarInput")
    def scale_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__08a1c25318221cf3adce22c0fc57e7ebed76094e13e32ea7efbc8da3e4c9fd6c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4782e16843b837ef7f131fa9bdfe9da9225586411618e4179b98be56693446c5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="placement")
    def placement(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placement"))

    @placement.setter
    def placement(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__54d266c345163e1696870aa175bf6f12cbbb886cb4c4326d1dc08bfca78a8864)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placement", value)

    @builtins.property
    @jsii.member(jsii_name="placementVar")
    def placement_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placementVar"))

    @placement_var.setter
    def placement_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6c4bc9a917eca7fd9d075798e43b4956be9cf60396addcc13e5c85223d750c74)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placementVar", value)

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scale"))

    @scale.setter
    def scale(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7dd52b21b1018988656d0b4b29d408860e7039eed4d83a1d0ee3d3b691ea6fe0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scale", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimension")
    def scale_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimension"))

    @scale_dimension.setter
    def scale_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__169da489aaa8bed11fa3c70170cd303abdb8832ea944fb16ca058682e08f8a88)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimension", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVar")
    def scale_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimensionVar"))

    @scale_dimension_var.setter
    def scale_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dc6f02ddf9d1a75e1f4cf904430f3d9dff25f86a42ce74e7d2f608659f3ebc2d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="scaleVar")
    def scale_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleVar"))

    @scale_var.setter
    def scale_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__afb2937f1d319f94dafe75b57619cd64e87cfe21ab068845533425ab882d0b2f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__297b559a354983cc6e259809b29f19fc33a1672a1dc8bb9be9673457fbffd23f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e4f4e567a97410b0e934587a5a81bf220bf3af729c4feb5fcb4f3c83d0eb27b9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__112168f9461e2dc611babad81b641efd6970211115436beab56500b99bc31863)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__79726e00a810a7153b3fed30ea0b226e9163cf47482636f890ce2b213952b8ea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationComposite]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationComposite]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationComposite]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2498f2b808fbce7297326384c5d0a68e1647497244ea01829b8101e7cb3fb7c4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationCompound",
    jsii_struct_bases=[],
    name_mapping={"transformations": "transformations"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationCompound:
    def __init__(
        self,
        *,
        transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param transformations: transformations block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__12b4c9f28eb83553ceebda7da6ba6f9ee34f26a2d4d416d3c80930fedd21928c)
            check_type(argname="argument transformations", value=transformations, expected_type=type_hints["transformations"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if transformations is not None:
            self._values["transformations"] = transformations

    @builtins.property
    def transformations(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationCompoundTransformations"]]]:
        '''transformations block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        result = self._values.get("transformations")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationCompoundTransformations"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationCompound(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationCompoundList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationCompoundList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ff8b9ca74e15ccd8929143cc5a820d4495084238ff44149f3c9b8dfc732b1535)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationCompoundOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a4468ccc8ecfd0ded364c1589463927885ff2d2ea90b0e02ef0f699f04d026bc)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationCompoundOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0e73b85bb25493176e6838adb6e5e7f01a44e47a91c009878f3f74ad99dbce29)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c333a7b8005f7df65e2127b8038967c7ecff7a2bf006090b211986ce66dae324)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a920bac424fcf097a40e709bf0775fc944999f97f98e5d9b13bf1089f98112a1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationCompound]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationCompound]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c5b870ed6618fe0e1804115073c9fd7e58ce8e2795432e38392c08f2facff21d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationCompoundOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationCompoundOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c4b706cc4967b4e4b4f3cc655f3be40dd06facfc71a9d881df1f47427ad21c6f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformations")
    def put_transformations(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dad4099943e9bd1e4e01b72ddb788fa0080ab09abcf82132a7c237cb655b146f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTransformations", [value]))

    @jsii.member(jsii_name="resetTransformations")
    def reset_transformations(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformations", []))

    @builtins.property
    @jsii.member(jsii_name="transformations")
    def transformations(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationCompoundTransformationsList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationCompoundTransformationsList", jsii.get(self, "transformations"))

    @builtins.property
    @jsii.member(jsii_name="transformationsInput")
    def transformations_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationCompoundTransformations"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationCompoundTransformations"]]], jsii.get(self, "transformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationCompound]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationCompound]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationCompound]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__da0611893c24a462208e3aea62d97d39204bde31e2d0def12d481724c59cfdf5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationCompoundTransformations",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationCompoundTransformations:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationCompoundTransformations(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationCompoundTransformationsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationCompoundTransformationsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__207672023d6bf2bece0cad20c9e04a2e0c2e23c80e895bac0458bec2c394f6d6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationCompoundTransformationsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c40372cf40b9390d6a9e74e625886315d8e71a8e24e2d533a434fe01e90a0351)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationCompoundTransformationsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b71a38c8ae03b131c6cfb501ae4defe5c7e87c84979d0a7e3cf2232cf222ae3f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bf5ff596474ac5634c30f6f8cd6dafac6da239d64147ac42b6cdd64a4cb7678b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__09043ea292972962d6bce56e31608a39ca0bcb92a5f1b13bc3a89a84f936710e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationCompoundTransformations]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationCompoundTransformations]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationCompoundTransformations]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7fe48e2fc9c0311989f4d0e6e0f2121836e9ee5e4150e2ee6c9da12e2f617a0f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationCompoundTransformationsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationCompoundTransformationsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__95631caebddf6938b97fa305ca6ca3e3a78b9228bc42fe369b988e1e2544a378)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationCompoundTransformations]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationCompoundTransformations]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationCompoundTransformations]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e02bac5129a0173db6ccd75f8371383c3c8a37e4eb906f5a848c7605c6a0ed0e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationContrast",
    jsii_struct_bases=[],
    name_mapping={
        "brightness": "brightness",
        "brightness_var": "brightnessVar",
        "contrast": "contrast",
        "contrast_var": "contrastVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationContrast:
    def __init__(
        self,
        *,
        brightness: typing.Optional[builtins.str] = None,
        brightness_var: typing.Optional[builtins.str] = None,
        contrast: typing.Optional[builtins.str] = None,
        contrast_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param brightness: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        :param brightness_var: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        :param contrast: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param contrast_var: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ad63542e4809d23c975bc9f72d67e948907b90f4baec6563982192c4f41c11b)
            check_type(argname="argument brightness", value=brightness, expected_type=type_hints["brightness"])
            check_type(argname="argument brightness_var", value=brightness_var, expected_type=type_hints["brightness_var"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument contrast_var", value=contrast_var, expected_type=type_hints["contrast_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if brightness is not None:
            self._values["brightness"] = brightness
        if brightness_var is not None:
            self._values["brightness_var"] = brightness_var
        if contrast is not None:
            self._values["contrast"] = contrast
        if contrast_var is not None:
            self._values["contrast_var"] = contrast_var

    @builtins.property
    def brightness(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        '''
        result = self._values.get("brightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def brightness_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        '''
        result = self._values.get("brightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        result = self._values.get("contrast_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationContrast(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationContrastList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationContrastList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__38d79a78e0f9d29dc174d65be1fdede7ebaa348bfaf974da9ddda531a33eb68d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationContrastOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7495f0a6a7bac885e4f60635218c403a0d3b75a451b32ec8bc2430c4aec6b367)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationContrastOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b26c73f85ef1105f26bf17ed2ad81f9b33443cd81561ad0736e0b55149042324)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e5322b9ea314f62706bf757340e1d696a97083d659f29cabd1af63a93ae42274)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cbe3de10242c73deae1af920e8ea83ca55a75b78f7aee181865c89ffb01ff481)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationContrast]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationContrast]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7a90f6508d12cb8267126056269d09f546129e520ae6bada7cc0833885944102)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationContrastOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationContrastOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__394effa5988a89f9a7371249e06f850992cc7a93dc7463ec461b98d2f6874a79)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetBrightness")
    def reset_brightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightness", []))

    @jsii.member(jsii_name="resetBrightnessVar")
    def reset_brightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightnessVar", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetContrastVar")
    def reset_contrast_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrastVar", []))

    @builtins.property
    @jsii.member(jsii_name="brightnessInput")
    def brightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="brightnessVarInput")
    def brightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastVarInput")
    def contrast_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="brightness")
    def brightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightness"))

    @brightness.setter
    def brightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b0ebc773718e8b8100ef6b07243e244c348775bc029329075fdaabf704847d7d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightness", value)

    @builtins.property
    @jsii.member(jsii_name="brightnessVar")
    def brightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightnessVar"))

    @brightness_var.setter
    def brightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__976c45f97ec0781cf53bbdc8d06062371143a8cd23c5f8d868b1f26791b7abf4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrast"))

    @contrast.setter
    def contrast(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__549673978eb4335d9ca7759d910fbcb8eec5686bdf97735ebf841a95d8dc01a3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrast", value)

    @builtins.property
    @jsii.member(jsii_name="contrastVar")
    def contrast_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrastVar"))

    @contrast_var.setter
    def contrast_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2b7f73e26875dc7519d70886c86aa3f957487d0371f4961dcce3f9c7ef2bd8cb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrastVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationContrast]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationContrast]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationContrast]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f1e5f9acc145cca225ecd812d579d1ee9aa670efe4396a18926913c3d9b91d67)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationCrop",
    jsii_struct_bases=[],
    name_mapping={
        "allow_expansion": "allowExpansion",
        "allow_expansion_var": "allowExpansionVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationCrop:
    def __init__(
        self,
        *,
        allow_expansion: typing.Optional[builtins.str] = None,
        allow_expansion_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_expansion: If cropping an area outside of the existing canvas, expands the image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        :param allow_expansion_var: If cropping an area outside of the existing canvas, expands the image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        :param gravity: Frame of reference for X and Y Positions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Frame of reference for X and Y Positions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The number of pixels to crop along the y-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The number of pixels to crop along the y-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The number of pixels to crop along the x-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The number of pixels to crop along the x-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        :param x_position: The x-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6a7bcaacf68550aca09ba4dcb1b82a50c194109f4445f4b502953a2ca49a02a3)
            check_type(argname="argument allow_expansion", value=allow_expansion, expected_type=type_hints["allow_expansion"])
            check_type(argname="argument allow_expansion_var", value=allow_expansion_var, expected_type=type_hints["allow_expansion_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if allow_expansion is not None:
            self._values["allow_expansion"] = allow_expansion
        if allow_expansion_var is not None:
            self._values["allow_expansion_var"] = allow_expansion_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def allow_expansion(self) -> typing.Optional[builtins.str]:
        '''If cropping an area outside of the existing canvas, expands the image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        '''
        result = self._values.get("allow_expansion")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def allow_expansion_var(self) -> typing.Optional[builtins.str]:
        '''If cropping an area outside of the existing canvas, expands the image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        '''
        result = self._values.get("allow_expansion_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Frame of reference for X and Y Positions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Frame of reference for X and Y Positions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the y-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the y-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the x-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the x-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__39a3a77a08259e15915bce38bbfb7cfd0f065437ae9fe0d9ab3e3750a153d4cd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1d234b55aa34c2a591d2d35a022247c295b1d23c90b3aef693c8659bd311a7f7)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__43d975ba12a806f520183f1a579575bddd12bfc6a3ee9e296fa59605f8497d2b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__344e611a6bdabe9523041445064c26dc1242f50a25799264cf4029987a94dffb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1b5d41a099fbf999d3f153b2e304da560adad40d8128495c83f52ddfcd2a249e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fde74be4e4043d0c329642fcd386e18b09c0d64e8284cd64ab3a06cb369ea2d6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e143d990b03c2e2a95967011b55bc6ef15927c970f33cabf704e4be9eccff05)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAllowExpansion")
    def reset_allow_expansion(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansion", []))

    @jsii.member(jsii_name="resetAllowExpansionVar")
    def reset_allow_expansion_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansionVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionInput")
    def allow_expansion_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVarInput")
    def allow_expansion_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansion")
    def allow_expansion(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansion"))

    @allow_expansion.setter
    def allow_expansion(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7770477a5b028f09f299555602784a4d362d7d72991bd5e23d6485656662e357)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansion", value)

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVar")
    def allow_expansion_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansionVar"))

    @allow_expansion_var.setter
    def allow_expansion_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0728908147b7bbf9f8567c0d4cb2da306288fd9528dc6950eb64ef2a07444e1a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansionVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__76633b129c8c8d0c7d5e3db88595db029b83942330ccf9f7e8c71dbfa755fb35)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__644366156b43e29b4bdfa45afc2650e9d89e5428503f199693e3e953d6d7b334)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e9cfd5da22519f1397be4ddd8727a78b0363d7bb65e767d2faf6a040be6fefa8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5bbc651f660b8a570723e23bc628b80b108a4bc69041d3771d03f725aec45c44)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2463af713c1beaafb8a3b247dedcd6327404bd0c8df11cf45819a7b7d44e4c6d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__348a7a1bcb0aa5bd7d6fefedfb381521ed4f18cebae0422660d02fef5f93e5f6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__343b17a1f435dcba75acd6d100284ad19ec022934f6418dd023497f088a2d71e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d26e141a047af9376dcbdcc6dfa2e9b5e5aa328004bb74d06a23a6849bee921f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6518e45a10433447afe5e98cc57d5f1f695258a39eef638e04b47bd01436a95f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f6f151133000edfef29b933f2d1567e3b38a39d4fc650ec7d744c215a3327686)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5b03d7805233b5425fc64b46f6ec3ef7a8bc00635c81d9a734f5df00f38c9f67)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationFaceCrop",
    jsii_struct_bases=[],
    name_mapping={
        "algorithm": "algorithm",
        "algorithm_var": "algorithmVar",
        "confidence": "confidence",
        "confidence_var": "confidenceVar",
        "fail_gravity": "failGravity",
        "fail_gravity_var": "failGravityVar",
        "focus": "focus",
        "focus_var": "focusVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "padding": "padding",
        "padding_var": "paddingVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationFaceCrop:
    def __init__(
        self,
        *,
        algorithm: typing.Optional[builtins.str] = None,
        algorithm_var: typing.Optional[builtins.str] = None,
        confidence: typing.Optional[builtins.str] = None,
        confidence_var: typing.Optional[builtins.str] = None,
        fail_gravity: typing.Optional[builtins.str] = None,
        fail_gravity_var: typing.Optional[builtins.str] = None,
        focus: typing.Optional[builtins.str] = None,
        focus_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param algorithm: Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm DataAkamaiImagingPolicyImage#algorithm}
        :param algorithm_var: Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm_var DataAkamaiImagingPolicyImage#algorithm_var}
        :param confidence: With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image. Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence DataAkamaiImagingPolicyImage#confidence}
        :param confidence_var: With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image. Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence_var DataAkamaiImagingPolicyImage#confidence_var}
        :param fail_gravity: Controls placement of the crop if Image and Video Manager does not detect any faces in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        :param fail_gravity_var: Controls placement of the crop if Image and Video Manager does not detect any faces in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        :param focus: Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus DataAkamaiImagingPolicyImage#focus}
        :param focus_var: Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus_var DataAkamaiImagingPolicyImage#focus_var}
        :param gravity: Controls placement of the crop. Directions are relative to the face(s) plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Controls placement of the crop. Directions are relative to the face(s) plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param padding: The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        :param style: Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e83b1858f83a0dca643e862aab72aa120ceb51cfa52081e0f0889715e350f161)
            check_type(argname="argument algorithm", value=algorithm, expected_type=type_hints["algorithm"])
            check_type(argname="argument algorithm_var", value=algorithm_var, expected_type=type_hints["algorithm_var"])
            check_type(argname="argument confidence", value=confidence, expected_type=type_hints["confidence"])
            check_type(argname="argument confidence_var", value=confidence_var, expected_type=type_hints["confidence_var"])
            check_type(argname="argument fail_gravity", value=fail_gravity, expected_type=type_hints["fail_gravity"])
            check_type(argname="argument fail_gravity_var", value=fail_gravity_var, expected_type=type_hints["fail_gravity_var"])
            check_type(argname="argument focus", value=focus, expected_type=type_hints["focus"])
            check_type(argname="argument focus_var", value=focus_var, expected_type=type_hints["focus_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if algorithm is not None:
            self._values["algorithm"] = algorithm
        if algorithm_var is not None:
            self._values["algorithm_var"] = algorithm_var
        if confidence is not None:
            self._values["confidence"] = confidence
        if confidence_var is not None:
            self._values["confidence_var"] = confidence_var
        if fail_gravity is not None:
            self._values["fail_gravity"] = fail_gravity
        if fail_gravity_var is not None:
            self._values["fail_gravity_var"] = fail_gravity_var
        if focus is not None:
            self._values["focus"] = focus
        if focus_var is not None:
            self._values["focus_var"] = focus_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def algorithm(self) -> typing.Optional[builtins.str]:
        '''Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm DataAkamaiImagingPolicyImage#algorithm}
        '''
        result = self._values.get("algorithm")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def algorithm_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm_var DataAkamaiImagingPolicyImage#algorithm_var}
        '''
        result = self._values.get("algorithm_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def confidence(self) -> typing.Optional[builtins.str]:
        '''With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image.

        Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence DataAkamaiImagingPolicyImage#confidence}
        '''
        result = self._values.get("confidence")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def confidence_var(self) -> typing.Optional[builtins.str]:
        '''With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image.

        Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence_var DataAkamaiImagingPolicyImage#confidence_var}
        '''
        result = self._values.get("confidence_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any faces in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        '''
        result = self._values.get("fail_gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any faces in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        '''
        result = self._values.get("fail_gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def focus(self) -> typing.Optional[builtins.str]:
        '''Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus DataAkamaiImagingPolicyImage#focus}
        '''
        result = self._values.get("focus")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def focus_var(self) -> typing.Optional[builtins.str]:
        '''Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus_var DataAkamaiImagingPolicyImage#focus_var}
        '''
        result = self._values.get("focus_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the face(s) plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the face(s) plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationFaceCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationFaceCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationFaceCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__84b6ee9a49c61e207baa22a8c893a2e7ab61e1642b1a45b5645aa33e132ed808)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationFaceCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b14ed069817a822af53585f16d4e01dd0d94d4329dc6d8a5c780a447f96e465a)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationFaceCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c067d033a6a0a12dcf14a9b4cb55e550bfd4d23f47f6d51ee4de530c6e76776b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f8a2848cb379f7b43fd740ac5c10364b0327b5d2a52329b0df84208d72c18b5d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b14eb91633b1a5d2d2f8ef150cd5618bc36eda9d81894c602ae47afb02952004)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationFaceCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationFaceCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationFaceCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a779602589da0d46aebc603951b04e7f6ad68196584f03c1bb75f00087ff74b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationFaceCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationFaceCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3f86254dc01acfb671607c9e867662fadcdf53dc8029dadcccfa65bd9f3a89d1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAlgorithm")
    def reset_algorithm(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAlgorithm", []))

    @jsii.member(jsii_name="resetAlgorithmVar")
    def reset_algorithm_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAlgorithmVar", []))

    @jsii.member(jsii_name="resetConfidence")
    def reset_confidence(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetConfidence", []))

    @jsii.member(jsii_name="resetConfidenceVar")
    def reset_confidence_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetConfidenceVar", []))

    @jsii.member(jsii_name="resetFailGravity")
    def reset_fail_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravity", []))

    @jsii.member(jsii_name="resetFailGravityVar")
    def reset_fail_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravityVar", []))

    @jsii.member(jsii_name="resetFocus")
    def reset_focus(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFocus", []))

    @jsii.member(jsii_name="resetFocusVar")
    def reset_focus_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFocusVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="algorithmInput")
    def algorithm_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "algorithmInput"))

    @builtins.property
    @jsii.member(jsii_name="algorithmVarInput")
    def algorithm_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "algorithmVarInput"))

    @builtins.property
    @jsii.member(jsii_name="confidenceInput")
    def confidence_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "confidenceInput"))

    @builtins.property
    @jsii.member(jsii_name="confidenceVarInput")
    def confidence_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "confidenceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityInput")
    def fail_gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityVarInput")
    def fail_gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="focusInput")
    def focus_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "focusInput"))

    @builtins.property
    @jsii.member(jsii_name="focusVarInput")
    def focus_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "focusVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="algorithm")
    def algorithm(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "algorithm"))

    @algorithm.setter
    def algorithm(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0931d4cfaab51a0a1a3e2189847f899eb29117af148f458da168652d84aaeab7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "algorithm", value)

    @builtins.property
    @jsii.member(jsii_name="algorithmVar")
    def algorithm_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "algorithmVar"))

    @algorithm_var.setter
    def algorithm_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__411804250136761135d3f7d7f3bd22cb13d0ea93306a92092d5df29de1b8e77f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "algorithmVar", value)

    @builtins.property
    @jsii.member(jsii_name="confidence")
    def confidence(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "confidence"))

    @confidence.setter
    def confidence(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd5d20d30cfec35126189e8d0a7fe06e17ecc845230440d1dce0cfcecd31634b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "confidence", value)

    @builtins.property
    @jsii.member(jsii_name="confidenceVar")
    def confidence_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "confidenceVar"))

    @confidence_var.setter
    def confidence_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b44f3a9d330f018b3a69c7d6d4e4f1f6d660d8c7be86394788c0c0a35e259bfc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "confidenceVar", value)

    @builtins.property
    @jsii.member(jsii_name="failGravity")
    def fail_gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravity"))

    @fail_gravity.setter
    def fail_gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7617f39f2c90e2b030b04399b4254bfa0fdd5f9a89d97369c5c9bbace644d097)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravity", value)

    @builtins.property
    @jsii.member(jsii_name="failGravityVar")
    def fail_gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravityVar"))

    @fail_gravity_var.setter
    def fail_gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f75a880b6b0913ce282260a51606cba4d48ccb54f5e15ecf85279d6cd638f986)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="focus")
    def focus(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "focus"))

    @focus.setter
    def focus(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__29f15d52fe639a9eb14c124907db703622b673c856f9fd3e7b3dc2d4c9eb3972)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "focus", value)

    @builtins.property
    @jsii.member(jsii_name="focusVar")
    def focus_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "focusVar"))

    @focus_var.setter
    def focus_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0a404db1443e0feb177383cdb96cd6976816267ac1bd023a509f275532fa4064)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "focusVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__65682e7818993c57c9cf996407239e7894bc10fdbe55ff58e3aa69a7adb7e107)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1d78595849b22f5938b9116a62de52c177b65cbd53044d799d2a169bb07f666f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a6bb77e4a95ba525a07251e5f4a9fd996fb91bd43dea324d8ada5fb13f1fccfb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f5c06ba1cdc175a43a85ed80822e1a6d8b49f57af1c1a5f096eed3a9b44a3a9f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb66607ef1b2fe2ad4ded68205a985e07887d116df61fb7a03d6b4909145a029)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea91e2a3c258707cc95b953e12cd4359e2ea77e550c16bbccb84b24abe0ec26f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d018b9fc890d5aa0f01b6f5658cf8c2736c50e3e5b21b81ce27dbe7ba11ae8e6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__84345ec8a747c5016c6b47a6b828679e773209786d02e04bb3d0678120f5cb23)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cb011513b44017771f781e5c7bbf4236dd8d87a3bc213b2a5845f2052b996d69)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__74f61f891c788122db4a89b00f1fdd9e41d445b25f30e8c9c10b06252b1df1e4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationFaceCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationFaceCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationFaceCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8672b802cb1c6a3dc5ed835ad503a1a89d1dc7184ada568c8655e29957ad8c09)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationFeatureCrop",
    jsii_struct_bases=[],
    name_mapping={
        "fail_gravity": "failGravity",
        "fail_gravity_var": "failGravityVar",
        "feature_radius": "featureRadius",
        "feature_radius_var": "featureRadiusVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "max_features": "maxFeatures",
        "max_features_var": "maxFeaturesVar",
        "min_feature_quality": "minFeatureQuality",
        "min_feature_quality_var": "minFeatureQualityVar",
        "padding": "padding",
        "padding_var": "paddingVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationFeatureCrop:
    def __init__(
        self,
        *,
        fail_gravity: typing.Optional[builtins.str] = None,
        fail_gravity_var: typing.Optional[builtins.str] = None,
        feature_radius: typing.Optional[builtins.str] = None,
        feature_radius_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        max_features: typing.Optional[builtins.str] = None,
        max_features_var: typing.Optional[builtins.str] = None,
        min_feature_quality: typing.Optional[builtins.str] = None,
        min_feature_quality_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fail_gravity: Controls placement of the crop if Image and Video Manager does not detect any features in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        :param fail_gravity_var: Controls placement of the crop if Image and Video Manager does not detect any features in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        :param feature_radius: The size in pixels of the important features to search for. If identified, two features never appear closer together than this value, ``8.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius DataAkamaiImagingPolicyImage#feature_radius}
        :param feature_radius_var: The size in pixels of the important features to search for. If identified, two features never appear closer together than this value, ``8.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius_var DataAkamaiImagingPolicyImage#feature_radius_var}
        :param gravity: Controls placement of the crop. Directions are relative to the region of interest plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Controls placement of the crop. Directions are relative to the region of interest plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param max_features: The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features DataAkamaiImagingPolicyImage#max_features}
        :param max_features_var: The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features_var DataAkamaiImagingPolicyImage#max_features_var}
        :param min_feature_quality: Determines the minimum quality level of the feature identified. To consider a feature important, the feature needs to surpass this value. Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality DataAkamaiImagingPolicyImage#min_feature_quality}
        :param min_feature_quality_var: Determines the minimum quality level of the feature identified. To consider a feature important, the feature needs to surpass this value. Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality_var DataAkamaiImagingPolicyImage#min_feature_quality_var}
        :param padding: Adds space around the region of interest. The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: Adds space around the region of interest. The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        :param style: Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c8fc67a1e7c7e7a71423a656ae6d3bdc4956082447e0440f6d8ffa1bfc4b9c35)
            check_type(argname="argument fail_gravity", value=fail_gravity, expected_type=type_hints["fail_gravity"])
            check_type(argname="argument fail_gravity_var", value=fail_gravity_var, expected_type=type_hints["fail_gravity_var"])
            check_type(argname="argument feature_radius", value=feature_radius, expected_type=type_hints["feature_radius"])
            check_type(argname="argument feature_radius_var", value=feature_radius_var, expected_type=type_hints["feature_radius_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument max_features", value=max_features, expected_type=type_hints["max_features"])
            check_type(argname="argument max_features_var", value=max_features_var, expected_type=type_hints["max_features_var"])
            check_type(argname="argument min_feature_quality", value=min_feature_quality, expected_type=type_hints["min_feature_quality"])
            check_type(argname="argument min_feature_quality_var", value=min_feature_quality_var, expected_type=type_hints["min_feature_quality_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fail_gravity is not None:
            self._values["fail_gravity"] = fail_gravity
        if fail_gravity_var is not None:
            self._values["fail_gravity_var"] = fail_gravity_var
        if feature_radius is not None:
            self._values["feature_radius"] = feature_radius
        if feature_radius_var is not None:
            self._values["feature_radius_var"] = feature_radius_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if max_features is not None:
            self._values["max_features"] = max_features
        if max_features_var is not None:
            self._values["max_features_var"] = max_features_var
        if min_feature_quality is not None:
            self._values["min_feature_quality"] = min_feature_quality
        if min_feature_quality_var is not None:
            self._values["min_feature_quality_var"] = min_feature_quality_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def fail_gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any features in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        '''
        result = self._values.get("fail_gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any features in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        '''
        result = self._values.get("fail_gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feature_radius(self) -> typing.Optional[builtins.str]:
        '''The size in pixels of the important features to search for.

        If identified, two features never appear closer together than this value, ``8.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius DataAkamaiImagingPolicyImage#feature_radius}
        '''
        result = self._values.get("feature_radius")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feature_radius_var(self) -> typing.Optional[builtins.str]:
        '''The size in pixels of the important features to search for.

        If identified, two features never appear closer together than this value, ``8.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius_var DataAkamaiImagingPolicyImage#feature_radius_var}
        '''
        result = self._values.get("feature_radius_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the region of interest plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the region of interest plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def max_features(self) -> typing.Optional[builtins.str]:
        '''The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features DataAkamaiImagingPolicyImage#max_features}
        '''
        result = self._values.get("max_features")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def max_features_var(self) -> typing.Optional[builtins.str]:
        '''The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features_var DataAkamaiImagingPolicyImage#max_features_var}
        '''
        result = self._values.get("max_features_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def min_feature_quality(self) -> typing.Optional[builtins.str]:
        '''Determines the minimum quality level of the feature identified.

        To consider a feature important, the feature needs to surpass this value.  Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality DataAkamaiImagingPolicyImage#min_feature_quality}
        '''
        result = self._values.get("min_feature_quality")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def min_feature_quality_var(self) -> typing.Optional[builtins.str]:
        '''Determines the minimum quality level of the feature identified.

        To consider a feature important, the feature needs to surpass this value.  Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality_var DataAkamaiImagingPolicyImage#min_feature_quality_var}
        '''
        result = self._values.get("min_feature_quality_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''Adds space around the region of interest.

        The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''Adds space around the region of interest.

        The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationFeatureCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationFeatureCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationFeatureCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f8171700d532e529d6e944422a2f15219e8504f94f08e9ecf78a4496adaa781d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationFeatureCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__65c17f35efdc50b463fabfb1baedf63870348f76f3db5dc917f9a277f0e6f197)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationFeatureCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fe5fbf7deb79a51ddfbfaaea83a1fea1694b452f9a39ef9b9b9c44df16ad4a78)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__de7dece79b66820614ad25b1e080c2e0ac480eced78464590fac7a19badfc133)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9bff0d89a7551f7f08e7b3c97ca2ecc8491a5cafdd968bfa4ebc603057329f4b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationFeatureCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationFeatureCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationFeatureCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cf7868f279369e3d8bfc5edec7fb666bc6c26fcba94abedb8a669321d9534093)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationFeatureCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationFeatureCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__056e325675706b5d045a8c8efa40748df716652e6334942bc18c7a19a88c7f19)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetFailGravity")
    def reset_fail_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravity", []))

    @jsii.member(jsii_name="resetFailGravityVar")
    def reset_fail_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravityVar", []))

    @jsii.member(jsii_name="resetFeatureRadius")
    def reset_feature_radius(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureRadius", []))

    @jsii.member(jsii_name="resetFeatureRadiusVar")
    def reset_feature_radius_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureRadiusVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetMaxFeatures")
    def reset_max_features(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxFeatures", []))

    @jsii.member(jsii_name="resetMaxFeaturesVar")
    def reset_max_features_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxFeaturesVar", []))

    @jsii.member(jsii_name="resetMinFeatureQuality")
    def reset_min_feature_quality(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMinFeatureQuality", []))

    @jsii.member(jsii_name="resetMinFeatureQualityVar")
    def reset_min_feature_quality_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMinFeatureQualityVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="failGravityInput")
    def fail_gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityVarInput")
    def fail_gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featureRadiusInput")
    def feature_radius_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featureRadiusInput"))

    @builtins.property
    @jsii.member(jsii_name="featureRadiusVarInput")
    def feature_radius_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featureRadiusVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesInput")
    def max_features_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "maxFeaturesInput"))

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesVarInput")
    def max_features_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "maxFeaturesVarInput"))

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityInput")
    def min_feature_quality_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "minFeatureQualityInput"))

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityVarInput")
    def min_feature_quality_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "minFeatureQualityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravity")
    def fail_gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravity"))

    @fail_gravity.setter
    def fail_gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__029935da01c758654d1c3748635a4915860dcd565ca436340b46b692f6ba6afb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravity", value)

    @builtins.property
    @jsii.member(jsii_name="failGravityVar")
    def fail_gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravityVar"))

    @fail_gravity_var.setter
    def fail_gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__346ea6a5688d14020c165a3bc51af75cb1844d8479f55d78806e93ed91e337d8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="featureRadius")
    def feature_radius(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featureRadius"))

    @feature_radius.setter
    def feature_radius(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ba8b4cb7fc658b3e4e5bf9f53470c79d38d1042451abda611261baff114c3ddc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featureRadius", value)

    @builtins.property
    @jsii.member(jsii_name="featureRadiusVar")
    def feature_radius_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featureRadiusVar"))

    @feature_radius_var.setter
    def feature_radius_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a6cd5debfacc5ee43995b91837aeadf84b91974286f60da14acfdc9e4f2293d1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featureRadiusVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5799b28981cdad01b0f40ddc422612277cb0c967eb93b8ed9ef698812501b532)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c6a4202e221bd2ab008fa8a454accd9e08533aecf426972424cc6f9390b2e0b4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d853941a0914cc96eb8e0bebca4360518d19171f11e055db2fd9626db320f52)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2df09119d552fa4df548414954ee8dadde15e0190934817ca0e3d8140fa4e3d7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="maxFeatures")
    def max_features(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "maxFeatures"))

    @max_features.setter
    def max_features(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8d13d4cd5dac9f86aeb523fb978d2f61796086de26a0348e7b0f136a0b5c6830)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "maxFeatures", value)

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesVar")
    def max_features_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "maxFeaturesVar"))

    @max_features_var.setter
    def max_features_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__14dd59bf9e29c6048982ec1ee52a36a8d2f51858efd3d4b9fc5ac54251f73dda)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "maxFeaturesVar", value)

    @builtins.property
    @jsii.member(jsii_name="minFeatureQuality")
    def min_feature_quality(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "minFeatureQuality"))

    @min_feature_quality.setter
    def min_feature_quality(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5676ccc4cc9237c6b4bdf959353700e0778378758d45171e55aeb0b2f641ef2c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "minFeatureQuality", value)

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityVar")
    def min_feature_quality_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "minFeatureQualityVar"))

    @min_feature_quality_var.setter
    def min_feature_quality_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5997690b8843a4f6a436848368f28d6dd6df9240016c810fae2bcf12d36f8be0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "minFeatureQualityVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__995523b46e4b61bc5936416e99656480e38d2f98bcbf0220fca2cf1ace153d2f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0f83bbdab36cd4979a0ac56279da247c4e163bdb97b91f6437597186a5c2f7b3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__747e8bef019c6affeaefa51533e87d2fac2cf8bdb70e83d0d91407f6a84d644e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__68c662e3f83d0fef20be8d75b7dd28546f39e3dce67bd4f5b653650250b9ea7d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0e031e89f3efd927a16521cef9bbed2e4e907dec213c34f5d48937d8d684f08d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__98dc6ff4b815c54544cd7d85e3b337c4c715c204d8dc2ac967969091ca9d297c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationFeatureCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationFeatureCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationFeatureCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__00141d902b34aa440b25c07d63203fe44e6666b581b71c38dfed038b45338ddc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationFitAndFill",
    jsii_struct_bases=[],
    name_mapping={
        "fill_transformation": "fillTransformation",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationFitAndFill:
    def __init__(
        self,
        *,
        fill_transformation: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationFitAndFillFillTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fill_transformation: fill_transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_transformation DataAkamaiImagingPolicyImage#fill_transformation}
        :param height: The height value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The width value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(fill_transformation, dict):
            fill_transformation = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationFitAndFillFillTransformation(**fill_transformation)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ae9263bc3bff4e4caaa8a72ed3d6c9d1483f9fcbc0d42aa591da6027c6b965a1)
            check_type(argname="argument fill_transformation", value=fill_transformation, expected_type=type_hints["fill_transformation"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fill_transformation is not None:
            self._values["fill_transformation"] = fill_transformation
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def fill_transformation(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationFitAndFillFillTransformation"]:
        '''fill_transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_transformation DataAkamaiImagingPolicyImage#fill_transformation}
        '''
        result = self._values.get("fill_transformation")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationFitAndFillFillTransformation"], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationFitAndFill(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationFitAndFillFillTransformation",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationFitAndFillFillTransformation:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationFitAndFillFillTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationFitAndFillFillTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationFitAndFillFillTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ef73b8e3b9108b1a5b365eb45611aea2f0f2aba05e5f1a4ed9ff57a1952180bf)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationFitAndFillFillTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationFitAndFillFillTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationFitAndFillFillTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a71233eca17d14acdef27235cfcde708a494f71c01e8eb24810de79a045ea55f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationFitAndFillList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationFitAndFillList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f25e725a1ba69c8b5b9e50c9fff298eb35ae7b38955bb10deab9bb4d3993cb4b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationFitAndFillOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a57aadf83a3ab4ec7d4eeda817dfc3658ad821e8293d477e86769e6578835a91)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationFitAndFillOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8e9c82c3a6938e22faf6ad2dddc8525ae96900f401ea0182c72fdf1c1a685e92)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ee17bb493ce1596b7d2f6fb9b49ef49f8e3278591cf667a504c39c6ba63a24a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__22e7f915463faedabf6a8a6e33baf2ff7b314200eb527afe3844e55d36805382)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationFitAndFill]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationFitAndFill]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationFitAndFill]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__411d6d8134f790b7bbb823a69589cd4eb68c87a5533b1fce1e504447d678e68b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationFitAndFillOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationFitAndFillOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a3de01734af749c283bcae0eab3a2745167a6d0a3ad3dfbf035117e07b578398)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putFillTransformation")
    def put_fill_transformation(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationFitAndFillFillTransformation()

        return typing.cast(None, jsii.invoke(self, "putFillTransformation", [value]))

    @jsii.member(jsii_name="resetFillTransformation")
    def reset_fill_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFillTransformation", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="fillTransformation")
    def fill_transformation(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationFitAndFillFillTransformationOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationFitAndFillFillTransformationOutputReference, jsii.get(self, "fillTransformation"))

    @builtins.property
    @jsii.member(jsii_name="fillTransformationInput")
    def fill_transformation_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationFitAndFillFillTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationFitAndFillFillTransformation], jsii.get(self, "fillTransformationInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0740eb6ee9884c963fc297ef972704e5d74771c608f96ae3da81ba9047907ebc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7e80250cb6d7696cb38e39dfdcd16d23a417fed323d5045b1981cae2ad2783b7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0be8e109dac79485cd377c7f81c68acc4d37c342511cad899e4643465c9482c6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3644deaaed7cd7918356c06639fc5fdcd03484886acfaade4fed36a1996be26a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationFitAndFill]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationFitAndFill]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationFitAndFill]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__555dbfee635941ae3ca91f57c364b23b75da25a8e759f79969fe8451f4d0867a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationGoop",
    jsii_struct_bases=[],
    name_mapping={
        "chaos": "chaos",
        "chaos_var": "chaosVar",
        "density": "density",
        "density_var": "densityVar",
        "power": "power",
        "power_var": "powerVar",
        "seed": "seed",
        "seed_var": "seedVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationGoop:
    def __init__(
        self,
        *,
        chaos: typing.Optional[builtins.str] = None,
        chaos_var: typing.Optional[builtins.str] = None,
        density: typing.Optional[builtins.str] = None,
        density_var: typing.Optional[builtins.str] = None,
        power: typing.Optional[builtins.str] = None,
        power_var: typing.Optional[builtins.str] = None,
        seed: typing.Optional[builtins.str] = None,
        seed_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param chaos: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        :param chaos_var: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        :param density: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        :param density_var: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        :param power: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        :param power_var: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        :param seed: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        :param seed_var: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a58665af33a740b7900bca8f9757776f876ca7c963204e261927470a23d2ba11)
            check_type(argname="argument chaos", value=chaos, expected_type=type_hints["chaos"])
            check_type(argname="argument chaos_var", value=chaos_var, expected_type=type_hints["chaos_var"])
            check_type(argname="argument density", value=density, expected_type=type_hints["density"])
            check_type(argname="argument density_var", value=density_var, expected_type=type_hints["density_var"])
            check_type(argname="argument power", value=power, expected_type=type_hints["power"])
            check_type(argname="argument power_var", value=power_var, expected_type=type_hints["power_var"])
            check_type(argname="argument seed", value=seed, expected_type=type_hints["seed"])
            check_type(argname="argument seed_var", value=seed_var, expected_type=type_hints["seed_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if chaos is not None:
            self._values["chaos"] = chaos
        if chaos_var is not None:
            self._values["chaos_var"] = chaos_var
        if density is not None:
            self._values["density"] = density
        if density_var is not None:
            self._values["density_var"] = density_var
        if power is not None:
            self._values["power"] = power
        if power_var is not None:
            self._values["power_var"] = power_var
        if seed is not None:
            self._values["seed"] = seed
        if seed_var is not None:
            self._values["seed_var"] = seed_var

    @builtins.property
    def chaos(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        '''
        result = self._values.get("chaos")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def chaos_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        '''
        result = self._values.get("chaos_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        '''
        result = self._values.get("density")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density_var(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        '''
        result = self._values.get("density_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        '''
        result = self._values.get("power")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power_var(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        '''
        result = self._values.get("power_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        '''
        result = self._values.get("seed")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed_var(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        result = self._values.get("seed_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationGoop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationGoopList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationGoopList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__65651412629ac035b5d10a0c84ee7485b86bf7b02b726cecd325bc61df2cc52b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationGoopOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8ab6099d3a2cc620f633ee306e731baf118316c88f80006791f4c984754b8113)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationGoopOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e2e9a4a84d572a6c3883e86c59f3b65bc68b0caabcc4f4288670a457ca3ed418)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__958c0290d5e02f112f97e2b8afb200efb27f66cb66b00f4319a5925259959c1f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f30d00dfe317d75b406bfa3d861ca2f2f7eedb7e061e76b4a235c5dfd585fd88)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationGoop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationGoop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__24a93fa002f0d389c860b6d1be6db690f77994c436962ae7de13c8727815c0bd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationGoopOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationGoopOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0b8ed4e0769cc3b9b06c1bc9cd6b399ee1f2ab2445b71556cb71887552b13159)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetChaos")
    def reset_chaos(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaos", []))

    @jsii.member(jsii_name="resetChaosVar")
    def reset_chaos_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaosVar", []))

    @jsii.member(jsii_name="resetDensity")
    def reset_density(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensity", []))

    @jsii.member(jsii_name="resetDensityVar")
    def reset_density_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensityVar", []))

    @jsii.member(jsii_name="resetPower")
    def reset_power(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPower", []))

    @jsii.member(jsii_name="resetPowerVar")
    def reset_power_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPowerVar", []))

    @jsii.member(jsii_name="resetSeed")
    def reset_seed(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeed", []))

    @jsii.member(jsii_name="resetSeedVar")
    def reset_seed_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeedVar", []))

    @builtins.property
    @jsii.member(jsii_name="chaosInput")
    def chaos_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosInput"))

    @builtins.property
    @jsii.member(jsii_name="chaosVarInput")
    def chaos_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosVarInput"))

    @builtins.property
    @jsii.member(jsii_name="densityInput")
    def density_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityInput"))

    @builtins.property
    @jsii.member(jsii_name="densityVarInput")
    def density_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="powerInput")
    def power_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerInput"))

    @builtins.property
    @jsii.member(jsii_name="powerVarInput")
    def power_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerVarInput"))

    @builtins.property
    @jsii.member(jsii_name="seedInput")
    def seed_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedInput"))

    @builtins.property
    @jsii.member(jsii_name="seedVarInput")
    def seed_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedVarInput"))

    @builtins.property
    @jsii.member(jsii_name="chaos")
    def chaos(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaos"))

    @chaos.setter
    def chaos(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8915b1b6bd276d48425cc6294fffadc7d625ca1e7df81d7b391831e93a6ba913)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaos", value)

    @builtins.property
    @jsii.member(jsii_name="chaosVar")
    def chaos_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaosVar"))

    @chaos_var.setter
    def chaos_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5afd1684d7ab87d487cad13ab788585018732fce3aa787d9b0e593f099d2122a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaosVar", value)

    @builtins.property
    @jsii.member(jsii_name="density")
    def density(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "density"))

    @density.setter
    def density(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__47680693fe82fb08db66088504b8a48ea06f8cde6244ccc85bad71c4ae032ab8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "density", value)

    @builtins.property
    @jsii.member(jsii_name="densityVar")
    def density_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "densityVar"))

    @density_var.setter
    def density_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ff52d22c40ea7b1daccf90b12486b6e92cb5b176ebb032e2f8d46c8b1109612f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "densityVar", value)

    @builtins.property
    @jsii.member(jsii_name="power")
    def power(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "power"))

    @power.setter
    def power(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aacb4991760ada894fa61d2461dbe1ed49348bd6fec422136ae0781683e9d53b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "power", value)

    @builtins.property
    @jsii.member(jsii_name="powerVar")
    def power_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "powerVar"))

    @power_var.setter
    def power_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__11d36512f08544ea103b816527b2db186555e8275c6bcb66f0dd92c03b7b1eb2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "powerVar", value)

    @builtins.property
    @jsii.member(jsii_name="seed")
    def seed(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seed"))

    @seed.setter
    def seed(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ee192a5a1ae80151b7918ec8d4489b8cc1ecb6479aa9244df8512d2bd794c892)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seed", value)

    @builtins.property
    @jsii.member(jsii_name="seedVar")
    def seed_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seedVar"))

    @seed_var.setter
    def seed_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__de1a556d13c528d862835cb5ac072b9760dfa7eaec2fc0b3e9d874413e0b06c6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seedVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationGoop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationGoop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationGoop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c04af64ef905b33c50d681380165afd7083ec104050ac5d493dfb392cc63b3a3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationGrayscale",
    jsii_struct_bases=[],
    name_mapping={"type": "type", "type_var": "typeVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationGrayscale:
    def __init__(
        self,
        *,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param type: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c7a68f5d564427b28ac60f8fc9469fc432be171ea4b2dfe56ef44e31a4be86e8)
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationGrayscale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationGrayscaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationGrayscaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5aa5939c9e044b17addcdffc961dfffe4602db0318988c4b674aa92640f2ce96)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationGrayscaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8b683fa069df0830c7441ae9562d341368ad76411f38a893ff1cf0b9aac32652)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationGrayscaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__300e1995aaf28ccb604bced57c5e9832003ebd6adb801ac7b974ad6d8d2c36c7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e7b321c3cbb66faa75e4181939196c0e3a2968beb5dad97813df18af566a4705)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4c88fd49c21d27b9e89de4f7560c7d12e2cc92ed9c9015422955a0789a27c2c7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationGrayscale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationGrayscale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ed44ed9dfe5a145b829c4cc6b4521cd04bae7517c845e380c33145f60a874500)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationGrayscaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationGrayscaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cc327e4ee9cf8377a7b1d778e045ec77a1bba3ab3799367f7f1b7b584799d115)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__44f8df728e0c3a0506007eda155ba1413c94e2d15529855d47f7ab9a1f2bae46)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__02d2280779051a5b9258d974e4c0c8fc11964cff8f56466bc4b220e6037add2c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationGrayscale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationGrayscale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationGrayscale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f2dc9c814a2ce4144954fea7681533d7fbb9287aae478f55d057a08bf8c5025f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationHsl",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "lightness": "lightness",
        "lightness_var": "lightnessVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationHsl:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness: typing.Optional[builtins.str] = None,
        lightness_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        :param lightness_var: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__474510534997dc2c8a40978996b975001a614b21b086d7d0eecccc3ae92928d7)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness", value=lightness, expected_type=type_hints["lightness"])
            check_type(argname="argument lightness_var", value=lightness_var, expected_type=type_hints["lightness_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness is not None:
            self._values["lightness"] = lightness
        if lightness_var is not None:
            self._values["lightness_var"] = lightness_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        '''
        result = self._values.get("lightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        '''
        result = self._values.get("lightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationHsl(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationHslList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationHslList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bccb1aeac5aa87273d902997b9992f8fba308230aa7641899217648535dc1ca0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationHslOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__feff69df099056931e909c67dc58c21c5d15d130ae157d46c15d026e2c365345)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationHslOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__49801bd5b47cd524bca04e968632be937a06ea12117621f9e4fcae34553e3dd5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__04f35e2d971afb51f45f7271465f6ac150cf6b856327839160ff80ff9184e454)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__71656c64423fa8af609e9bf92d39719e05cd218a6096a4a6e94fa8d406a633d1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationHsl]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationHsl]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b9fe025f2efcceb9a2e39d5677e049b8e12543c771f0bee8b32dce0b39f92eaa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationHslOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationHslOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5a898cf255ef0d472350faece4fc0a5bde76f446feeaf5948b70b204a458e4be)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightness")
    def reset_lightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightness", []))

    @jsii.member(jsii_name="resetLightnessVar")
    def reset_lightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessInput")
    def lightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessVarInput")
    def lightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dca9248206bbc737a83f9c659c310e8959658136ff39b79264eeb54d6c2c221c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6ac157812f5102036762f1d84e4fd35a28ca66b93092b185e5bf998c3935f69b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightness")
    def lightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightness"))

    @lightness.setter
    def lightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__56ed39c2ce413fa7fb0dc84961abd36d1625ed22620292f814b4b085fd9a5cd7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightness", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessVar")
    def lightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessVar"))

    @lightness_var.setter
    def lightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9f59a224e28640b67f014ce6a1066c4228190572f371ee9835b39506d72681f4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__036dbdeaad8e6b04ec86b69acd2cfc3317eef7686f801c40cdd19085a043f975)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cbcceab3bf4d31b46e489cdf53475cd8bf3b06efdd5a83b4a82017bcbbb9555a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationHsl]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationHsl]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationHsl]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e4b9b40755f6d299d2ac7cd2e0f9d8b1966bd82aa33a394a78497b0bbd258f43)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationHsv",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationHsv:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        :param value: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8365a586ef078f73f5b6ea35f5c54dc3fea30163c9c1c2ae5571d7067a49a369)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationHsv(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationHsvList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationHsvList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d95d30a0257f9794d0b3e354f52ab7bd1f9ee3cd508cf108d34ba2b60c81e4c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationHsvOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6fb6e6178ede644691f728d169d931f93b921445eeb604f3fdd6b8a8f0d2bfca)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationHsvOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__97990f96b1e0b2ca68f5bec176a52a6dfcaa9fd362ca2ab9983f8b8b5e7eb564)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a10031e51e18c4a671784303358526ee3ccff3b31c05149af23c28abe5bc779)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__615568a9977e9b27f06b92a505206fdd958ae58a2f0181d27f2680f8de00fc42)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationHsv]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationHsv]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f8d1c5c2490fe5ea615134f7de918365837742015863022bee59f3374e0fdeb1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationHsvOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationHsvOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__100d368f78716d05fb14578464ba316498fe5d06ad0d6d03808bae03ec6717d7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d097bb8c3ebd6ddd3937e772b3cd0087bd5293c83b8bb8d58a62f93fa595896e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8c620fc3c2ec69e8e8785dceb4d54af9d7a1959c6bf4ce4d61df0c4b57b976bc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__16ebe3078fe1c88f8bc2da3e0c5c84f99b24ce905b717481759c336de634cb49)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd57c22dc20df8e18ce98e211c684e10e9aae4a6f2b1a213513f3ea50171102a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__847d4c16732d050391bc255705d8e65f350902579135480ddd07b1a0b1014e3f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d0abedb36cc33f373f1fe9f968612609bec9a9e2399c5e35f6f0632689b5bad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationHsv]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationHsv]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationHsv]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dfe109b108cc502a8032521eaaca116fe0ac2d89cc92492178786a3913720f16)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfDimension",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "dimension": "dimension",
        "dimension_var": "dimensionVar",
        "equal": "equal",
        "greater_than": "greaterThan",
        "less_than": "lessThan",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfDimension:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfDimensionDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        dimension: typing.Optional[builtins.str] = None,
        dimension_var: typing.Optional[builtins.str] = None,
        equal: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfDimensionEqual", typing.Dict[builtins.str, typing.Any]]] = None,
        greater_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfDimensionGreaterThan", typing.Dict[builtins.str, typing.Any]]] = None,
        less_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfDimensionLessThan", typing.Dict[builtins.str, typing.Any]]] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param dimension: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        :param dimension_var: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        :param equal: equal block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        :param greater_than: greater_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        :param less_than: less_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        :param value: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfDimensionDefault(**default)
        if isinstance(equal, dict):
            equal = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfDimensionEqual(**equal)
        if isinstance(greater_than, dict):
            greater_than = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfDimensionGreaterThan(**greater_than)
        if isinstance(less_than, dict):
            less_than = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfDimensionLessThan(**less_than)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a1c98a9c786e5daaaa05c3098b943562179115bf3ef94ac1203b45431ee6611)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument dimension", value=dimension, expected_type=type_hints["dimension"])
            check_type(argname="argument dimension_var", value=dimension_var, expected_type=type_hints["dimension_var"])
            check_type(argname="argument equal", value=equal, expected_type=type_hints["equal"])
            check_type(argname="argument greater_than", value=greater_than, expected_type=type_hints["greater_than"])
            check_type(argname="argument less_than", value=less_than, expected_type=type_hints["less_than"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if dimension is not None:
            self._values["dimension"] = dimension
        if dimension_var is not None:
            self._values["dimension_var"] = dimension_var
        if equal is not None:
            self._values["equal"] = equal
        if greater_than is not None:
            self._values["greater_than"] = greater_than
        if less_than is not None:
            self._values["less_than"] = less_than
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfDimensionDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfDimensionDefault"], result)

    @builtins.property
    def dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        '''
        result = self._values.get("dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        '''
        result = self._values.get("dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def equal(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfDimensionEqual"]:
        '''equal block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        '''
        result = self._values.get("equal")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfDimensionEqual"], result)

    @builtins.property
    def greater_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfDimensionGreaterThan"]:
        '''greater_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        '''
        result = self._values.get("greater_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfDimensionGreaterThan"], result)

    @builtins.property
    def less_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfDimensionLessThan"]:
        '''less_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        '''
        result = self._values.get("less_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfDimensionLessThan"], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfDimension(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfDimensionDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfDimensionDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfDimensionDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfDimensionDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfDimensionDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bcb36a5e08f2f0429f53da4829ca16ed932fe5a791bfadb019680679a23cbf30)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfDimensionDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfDimensionDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8bcc029da5a2267b91feeb73653070fc0343eb46c07591baee0f18c87bec4935)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfDimensionEqual",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfDimensionEqual:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfDimensionEqual(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfDimensionEqualOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfDimensionEqualOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__35061b9f2b67d4926f3d48ae8dd06e3133e358d182a0bcc560c976fda2284665)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfDimensionEqual], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfDimensionEqual],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__79106d4bc2908fa5998cd6497fb1cc053815903f3401542b066dd0999349272e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfDimensionGreaterThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfDimensionGreaterThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfDimensionGreaterThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfDimensionGreaterThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfDimensionGreaterThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__550f2e26196120d68283fc9410eaaa09665ba2b81b5c800c1fcb03090de11844)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfDimensionGreaterThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfDimensionGreaterThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8fab1abe8894e20f179164a04e2a64bd83c8807403c246f00908a46e83a36590)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfDimensionLessThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfDimensionLessThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfDimensionLessThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfDimensionLessThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfDimensionLessThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4fc143990500536353d050f86eca05cf69e6cb9500af5e318735bef1979b64b8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfDimensionLessThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfDimensionLessThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__211b2d3ee66e9b78fb7b7b82ee3f120ebe1b8f64fb285e5839679cb28dcd7c18)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfDimensionList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfDimensionList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__328d30d9c3143aae7b33d8ef1cac31c395b7c403843ebbc295076b0bd8918e60)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfDimensionOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6638d707cceca1f2e20b8eb2ba216c04a0befddcaef27c9ac511c1188d2ba7e5)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfDimensionOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b2ceb4149f16b374829b017a896166856b5fb2d79633b4a4c08c18e3854221ea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c6897850e60c36111a4458f25b50b0bedc11cc959df663ac967471b510df736a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__61b16a5a25cc452b0577d8212c2a45f16b78ce2148b25ed6fb6f34e1c85e8033)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfDimension]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfDimension]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5a34a08eaff4e2bb4bdcb263f61d4bb8749a8f890bc4581d26eab30e7bddf854)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfDimensionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfDimensionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__091c0f01f88909f701800790327ccde8eaeaf61dbb55e044d68866607b6eb2d5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfDimensionDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putEqual")
    def put_equal(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfDimensionEqual()

        return typing.cast(None, jsii.invoke(self, "putEqual", [value]))

    @jsii.member(jsii_name="putGreaterThan")
    def put_greater_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfDimensionGreaterThan()

        return typing.cast(None, jsii.invoke(self, "putGreaterThan", [value]))

    @jsii.member(jsii_name="putLessThan")
    def put_less_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfDimensionLessThan()

        return typing.cast(None, jsii.invoke(self, "putLessThan", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetDimension")
    def reset_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimension", []))

    @jsii.member(jsii_name="resetDimensionVar")
    def reset_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimensionVar", []))

    @jsii.member(jsii_name="resetEqual")
    def reset_equal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEqual", []))

    @jsii.member(jsii_name="resetGreaterThan")
    def reset_greater_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGreaterThan", []))

    @jsii.member(jsii_name="resetLessThan")
    def reset_less_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLessThan", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfDimensionDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfDimensionDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="equal")
    def equal(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfDimensionEqualOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfDimensionEqualOutputReference, jsii.get(self, "equal"))

    @builtins.property
    @jsii.member(jsii_name="greaterThan")
    def greater_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfDimensionGreaterThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfDimensionGreaterThanOutputReference, jsii.get(self, "greaterThan"))

    @builtins.property
    @jsii.member(jsii_name="lessThan")
    def less_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfDimensionLessThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfDimensionLessThanOutputReference, jsii.get(self, "lessThan"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfDimensionDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionInput")
    def dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionVarInput")
    def dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="equalInput")
    def equal_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfDimensionEqual], jsii.get(self, "equalInput"))

    @builtins.property
    @jsii.member(jsii_name="greaterThanInput")
    def greater_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfDimensionGreaterThan], jsii.get(self, "greaterThanInput"))

    @builtins.property
    @jsii.member(jsii_name="lessThanInput")
    def less_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfDimensionLessThan], jsii.get(self, "lessThanInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="dimension")
    def dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimension"))

    @dimension.setter
    def dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c3d461c321d2231ec2c5043eaeb5ca8cfa387acfb29e9372cb6a787964a127e8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimension", value)

    @builtins.property
    @jsii.member(jsii_name="dimensionVar")
    def dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimensionVar"))

    @dimension_var.setter
    def dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a69915671fc675c97d8a605dfcc03049bdc4874d13766de523f1e8cee397bf3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d26235bba39f89973f32ce9ba9aa0e42cc6be26b130f109e3b04ba5f6c6a0240)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b7c78cad7e82d4811e397b922003c99956e8873e82441e329dee5be3751cbf25)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfDimension]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfDimension]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfDimension]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e78d9f8e327efd9d48926426ea3aa021190642ecfa4c89ddb5003c3eec7935ca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfOrientation",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "landscape": "landscape",
        "portrait": "portrait",
        "square": "square",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfOrientation:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfOrientationDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        landscape: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfOrientationLandscape", typing.Dict[builtins.str, typing.Any]]] = None,
        portrait: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfOrientationPortrait", typing.Dict[builtins.str, typing.Any]]] = None,
        square: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfOrientationSquare", typing.Dict[builtins.str, typing.Any]]] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param landscape: landscape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        :param portrait: portrait block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        :param square: square block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfOrientationDefault(**default)
        if isinstance(landscape, dict):
            landscape = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfOrientationLandscape(**landscape)
        if isinstance(portrait, dict):
            portrait = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfOrientationPortrait(**portrait)
        if isinstance(square, dict):
            square = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfOrientationSquare(**square)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a8d6fac3a640d2fedbf9e9a6c8e8ff6b8ae1679e56ae595272459a75570adc3)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument landscape", value=landscape, expected_type=type_hints["landscape"])
            check_type(argname="argument portrait", value=portrait, expected_type=type_hints["portrait"])
            check_type(argname="argument square", value=square, expected_type=type_hints["square"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if landscape is not None:
            self._values["landscape"] = landscape
        if portrait is not None:
            self._values["portrait"] = portrait
        if square is not None:
            self._values["square"] = square

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfOrientationDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfOrientationDefault"], result)

    @builtins.property
    def landscape(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfOrientationLandscape"]:
        '''landscape block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        '''
        result = self._values.get("landscape")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfOrientationLandscape"], result)

    @builtins.property
    def portrait(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfOrientationPortrait"]:
        '''portrait block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        '''
        result = self._values.get("portrait")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfOrientationPortrait"], result)

    @builtins.property
    def square(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfOrientationSquare"]:
        '''square block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        result = self._values.get("square")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfOrientationSquare"], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfOrientation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfOrientationDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfOrientationDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfOrientationDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfOrientationDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfOrientationDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__67cb12232686f7acaf008377a5c2c8b177a84963ee777464691fc954021b5f68)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfOrientationDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfOrientationDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__16c194f93e2efcaabfd1d55101ae4b5d0ae9ac84c1d162e2e081ef02f2f5ab29)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfOrientationLandscape",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfOrientationLandscape:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfOrientationLandscape(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfOrientationLandscapeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfOrientationLandscapeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__084f4b93499e37a84c7cbed6ae5c27c9cdc24ce75c147323873c80f9b7257056)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfOrientationLandscape], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfOrientationLandscape],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c06de45ae050fb7e03b0af8ff86a6197259e7f08550cc8b8f933ba066315f7e1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfOrientationList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfOrientationList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e6a8dab751a56fad53e2fc455a8e77bd76c8d0177c928d6405f5d41264e8a086)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfOrientationOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bf6588a4ee93afa55d0f23c7d1bb307ddbad7fdfe4eca58fb78037ef95020a49)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfOrientationOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8cf3bcd0cded5fafe93a81b3d35fce1dce110c68fa7e3ed197fd72ff8bcbbf42)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a8015a424df188af628b7c5cf10fe1181252eb926654f344002192b7cdfc0eb3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a640156a89513e7cb9968a3d38774f3b741cf32583aac51174564ccbfc0dfb07)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfOrientation]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfOrientation]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab509527b65e0a980cbb284d36589509b46b8d35dd0c06fd625c527e1dc9de1c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfOrientationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfOrientationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e0c776e1da3dd3dd8cbb2bcf07a005696213adc1b3507956d790aec2180db44b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfOrientationDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putLandscape")
    def put_landscape(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfOrientationLandscape()

        return typing.cast(None, jsii.invoke(self, "putLandscape", [value]))

    @jsii.member(jsii_name="putPortrait")
    def put_portrait(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfOrientationPortrait()

        return typing.cast(None, jsii.invoke(self, "putPortrait", [value]))

    @jsii.member(jsii_name="putSquare")
    def put_square(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfOrientationSquare()

        return typing.cast(None, jsii.invoke(self, "putSquare", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetLandscape")
    def reset_landscape(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLandscape", []))

    @jsii.member(jsii_name="resetPortrait")
    def reset_portrait(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPortrait", []))

    @jsii.member(jsii_name="resetSquare")
    def reset_square(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSquare", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfOrientationDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfOrientationDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="landscape")
    def landscape(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfOrientationLandscapeOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfOrientationLandscapeOutputReference, jsii.get(self, "landscape"))

    @builtins.property
    @jsii.member(jsii_name="portrait")
    def portrait(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfOrientationPortraitOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfOrientationPortraitOutputReference", jsii.get(self, "portrait"))

    @builtins.property
    @jsii.member(jsii_name="square")
    def square(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfOrientationSquareOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfOrientationSquareOutputReference", jsii.get(self, "square"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfOrientationDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="landscapeInput")
    def landscape_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfOrientationLandscape], jsii.get(self, "landscapeInput"))

    @builtins.property
    @jsii.member(jsii_name="portraitInput")
    def portrait_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfOrientationPortrait"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfOrientationPortrait"], jsii.get(self, "portraitInput"))

    @builtins.property
    @jsii.member(jsii_name="squareInput")
    def square_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfOrientationSquare"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfOrientationSquare"], jsii.get(self, "squareInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfOrientation]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfOrientation]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfOrientation]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac7815cd74e163a55e665182cf9aabe70c437852418c5bc89d6348c7f7876b02)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfOrientationPortrait",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfOrientationPortrait:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfOrientationPortrait(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfOrientationPortraitOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfOrientationPortraitOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8f81375984888d84f3285ecca8e1ae127a43836ffa4ef0fa97d85c795d7962df)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfOrientationPortrait]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfOrientationPortrait], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfOrientationPortrait],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cc8fce82d62ca2b3dcf5b3354c949b9ebf3c4eacfab4ff0714917878e9730340)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfOrientationSquare",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfOrientationSquare:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfOrientationSquare(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfOrientationSquareOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfOrientationSquareOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__15d436fb9766cafc3a2de86d85f28dffd32f3c20341180dbff453f99557ad45b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfOrientationSquare]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfOrientationSquare], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfOrientationSquare],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__98c31f393e6106776208d5b2d35abf4612e3061bdcc4d66398ed2d755aa4a6f7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationImQuery",
    jsii_struct_bases=[],
    name_mapping={
        "allowed_transformations": "allowedTransformations",
        "query_var": "queryVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationImQuery:
    def __init__(
        self,
        *,
        allowed_transformations: typing.Sequence[builtins.str],
        query_var: builtins.str,
    ) -> None:
        '''
        :param allowed_transformations: Specifies the transformations that can be applied using the query string parameter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allowed_transformations DataAkamaiImagingPolicyImage#allowed_transformations}
        :param query_var: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#query_var DataAkamaiImagingPolicyImage#query_var}.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__280fce246047e05dd657de5f5e053e43cdbb7153f6883d465015421e436dded3)
            check_type(argname="argument allowed_transformations", value=allowed_transformations, expected_type=type_hints["allowed_transformations"])
            check_type(argname="argument query_var", value=query_var, expected_type=type_hints["query_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "allowed_transformations": allowed_transformations,
            "query_var": query_var,
        }

    @builtins.property
    def allowed_transformations(self) -> typing.List[builtins.str]:
        '''Specifies the transformations that can be applied using the query string parameter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allowed_transformations DataAkamaiImagingPolicyImage#allowed_transformations}
        '''
        result = self._values.get("allowed_transformations")
        assert result is not None, "Required property 'allowed_transformations' is missing"
        return typing.cast(typing.List[builtins.str], result)

    @builtins.property
    def query_var(self) -> builtins.str:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#query_var DataAkamaiImagingPolicyImage#query_var}.'''
        result = self._values.get("query_var")
        assert result is not None, "Required property 'query_var' is missing"
        return typing.cast(builtins.str, result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationImQuery(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationImQueryList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationImQueryList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__73503d12891dd0f28896a9d9f9a6d7bc50f5aa6c65946316ed888a3ef0302555)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationImQueryOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ce4dea899b1f62db26ebb0f35400bfcd31228274a76dfa5c7fd025b2f23270e3)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationImQueryOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e640a057bd064f0b682117980c3792ceb4d6272a207efe8d0b8f1112b8c6ddc9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7ea998aba7407ebaaa8f851630a27f60955b76e504a9e8d3fbef06f17a93440d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d2d94207ce41b57a0602caa15d5a72d819950be77e298b968fc1be9ada54f1d7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationImQuery]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationImQuery]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationImQuery]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__295bb390628f26cec6d5fed63261ced691f09ef76454a3bd829b2787f441c5aa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationImQueryOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationImQueryOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d866bb53679f34aa9406bf3655e140e26aee9146d8b89f1db1b2188a73521d4f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @builtins.property
    @jsii.member(jsii_name="allowedTransformationsInput")
    def allowed_transformations_input(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "allowedTransformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="queryVarInput")
    def query_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "queryVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowedTransformations")
    def allowed_transformations(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "allowedTransformations"))

    @allowed_transformations.setter
    def allowed_transformations(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__777fc6621ad98199b9d847c03a078aa3f65a7b0d3aed8b52af250ccda2fe169f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowedTransformations", value)

    @builtins.property
    @jsii.member(jsii_name="queryVar")
    def query_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "queryVar"))

    @query_var.setter
    def query_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5589a68bac235c864b1a1a2287f837fef8f078cd67d88bb8e1c91fd62076a2f1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "queryVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationImQuery]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationImQuery]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationImQuery]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__729d028f0fb8d813a93cf878caa66803066a0d2491e7a2166e1c46e8dca0e42c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationMaxColors",
    jsii_struct_bases=[],
    name_mapping={"colors": "colors", "colors_var": "colorsVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationMaxColors:
    def __init__(
        self,
        *,
        colors: typing.Optional[builtins.str] = None,
        colors_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param colors: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        :param colors_var: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__97ff82ad50f02a5490d9fd70422d44bf960dac64df734bf576e3fd9659c5e6b9)
            check_type(argname="argument colors", value=colors, expected_type=type_hints["colors"])
            check_type(argname="argument colors_var", value=colors_var, expected_type=type_hints["colors_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if colors is not None:
            self._values["colors"] = colors
        if colors_var is not None:
            self._values["colors_var"] = colors_var

    @builtins.property
    def colors(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        '''
        result = self._values.get("colors")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def colors_var(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        result = self._values.get("colors_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationMaxColors(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationMaxColorsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationMaxColorsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a82b88b86a666ab75bdd2303abda3ac370de259506cc929f8412ef832577ce60)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationMaxColorsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1d81d003e50efa1c8f066073a22b9e9c14236456040b15c7cf21b1438f8ffb37)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationMaxColorsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8e2a24ab1d3a9594b26996a7d185bfe8746401bb73b020eae7b21cb35c8f55ef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea7f5f823734eb0fa6b65a14546b3d5803c9f52c232dc40df4211d360c25482d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__75c31abab213f35e8a9f53b09b67639bdc0663a7a3bb6e69863a8f9a02f196ff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationMaxColors]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationMaxColors]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8653d521959017f10c43d1366426c3aad5508f9e8ecc9fb57ca213f8c84e875a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationMaxColorsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationMaxColorsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eae05cc9ba817b764212dfc2c11b230d11b6c087d5e31c63e4cf46e4129a68fd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColors")
    def reset_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColors", []))

    @jsii.member(jsii_name="resetColorsVar")
    def reset_colors_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorsVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorsInput")
    def colors_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsInput"))

    @builtins.property
    @jsii.member(jsii_name="colorsVarInput")
    def colors_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsVarInput"))

    @builtins.property
    @jsii.member(jsii_name="colors")
    def colors(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colors"))

    @colors.setter
    def colors(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__04772626fb3beda364d99522f3d7b78f11b1f8aa8daf00b1057bb6d213a971b9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colors", value)

    @builtins.property
    @jsii.member(jsii_name="colorsVar")
    def colors_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorsVar"))

    @colors_var.setter
    def colors_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ad31993e14f9479892099f85b69e797db2b33acb1be3d9a4280d948aba206514)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorsVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationMaxColors]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationMaxColors]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationMaxColors]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__591ff59affecd2b4a3663c26a6793ad560db3aa6556ab0434d5675a83d17d0c5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationMirror",
    jsii_struct_bases=[],
    name_mapping={
        "horizontal": "horizontal",
        "horizontal_var": "horizontalVar",
        "vertical": "vertical",
        "vertical_var": "verticalVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationMirror:
    def __init__(
        self,
        *,
        horizontal: typing.Optional[builtins.str] = None,
        horizontal_var: typing.Optional[builtins.str] = None,
        vertical: typing.Optional[builtins.str] = None,
        vertical_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param horizontal: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        :param horizontal_var: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        :param vertical: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        :param vertical_var: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cf7628c2724bf3d43068cb3a72d933f0ad4badd475bb2367040552b99db4cd4a)
            check_type(argname="argument horizontal", value=horizontal, expected_type=type_hints["horizontal"])
            check_type(argname="argument horizontal_var", value=horizontal_var, expected_type=type_hints["horizontal_var"])
            check_type(argname="argument vertical", value=vertical, expected_type=type_hints["vertical"])
            check_type(argname="argument vertical_var", value=vertical_var, expected_type=type_hints["vertical_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if horizontal is not None:
            self._values["horizontal"] = horizontal
        if horizontal_var is not None:
            self._values["horizontal_var"] = horizontal_var
        if vertical is not None:
            self._values["vertical"] = vertical
        if vertical_var is not None:
            self._values["vertical_var"] = vertical_var

    @builtins.property
    def horizontal(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        '''
        result = self._values.get("horizontal")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def horizontal_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        '''
        result = self._values.get("horizontal_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        '''
        result = self._values.get("vertical")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        result = self._values.get("vertical_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationMirror(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationMirrorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationMirrorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bd663614f88987d3782238d31c15a9b537d217551c2bb7461e745bba810b6482)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationMirrorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__885085874e9e858550149ecd72272fca4515a8ff3b3b1e799057aba6f11d1bad)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationMirrorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__19b6753e385cdb9c7b27275b269aef8086c7cbe1eaa9f5df56a17dfd1085bebe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6df4615d698d2efe6add8872769c7bf01d9f1c2f245360ab2e2a8aabbe908b99)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3f0f4f864c3de6e45a61f0ae1d7a8e3ba1f0edb54eb4dbd628e300d5081a51a5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationMirror]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationMirror]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__01527eaf48e5d3e15f70393b3158f5ba09860783a5717884f83d00d35e59a48d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationMirrorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationMirrorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eb985c543ca0799a8cb43264229bbff1cade0771b6a2f5974c180d7ab3aebe69)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHorizontal")
    def reset_horizontal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontal", []))

    @jsii.member(jsii_name="resetHorizontalVar")
    def reset_horizontal_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontalVar", []))

    @jsii.member(jsii_name="resetVertical")
    def reset_vertical(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVertical", []))

    @jsii.member(jsii_name="resetVerticalVar")
    def reset_vertical_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVerticalVar", []))

    @builtins.property
    @jsii.member(jsii_name="horizontalInput")
    def horizontal_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontalVarInput")
    def horizontal_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalInput")
    def vertical_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalVarInput")
    def vertical_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontal")
    def horizontal(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontal"))

    @horizontal.setter
    def horizontal(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f876fbfda975f99c3348d2551b577a308cdaa7f1ea220f3b6d5b3cff63e56ffe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontal", value)

    @builtins.property
    @jsii.member(jsii_name="horizontalVar")
    def horizontal_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontalVar"))

    @horizontal_var.setter
    def horizontal_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ea5bd58ece476319ee6a8d72de4bf7036bd9a6c4097e8008b91fe8ca4151f25)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontalVar", value)

    @builtins.property
    @jsii.member(jsii_name="vertical")
    def vertical(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "vertical"))

    @vertical.setter
    def vertical(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0f0ece7333d441d6c6859a9528d19ed5e6381943c19b187442b0b762f6812bf0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "vertical", value)

    @builtins.property
    @jsii.member(jsii_name="verticalVar")
    def vertical_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "verticalVar"))

    @vertical_var.setter
    def vertical_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b52cafc881b72c51b600ec9c3989463ab8822bd4740a99968c26568eb117a614)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "verticalVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationMirror]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationMirror]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationMirror]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d5561b23cd1a1486cb5819120bb3f5802e6fe77e17809fb547d9aed31ca7fc4d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationMonoHue",
    jsii_struct_bases=[],
    name_mapping={"hue": "hue", "hue_var": "hueVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationMonoHue:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__78301b2d0ae5075ed7cb0f5efd522f49e69e0abde069a5fb2c561743d75c3c67)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationMonoHue(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationMonoHueList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationMonoHueList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c9294a0bbf9289373e5daad1d5a2b7c55f63fed10e7bc0b231bde45e7cd47c98)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationMonoHueOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2e5d96731d71daa1319da8a716f565d19abf692e07dba9f493a81a9defbf9a83)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationMonoHueOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d9ca564b30fff81853eab6a6280077f6b5e62c19254cc2b66dd6b52b67157fde)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__91723e214e40b761b45219144b286639199562f2d1041dfb677f9f95e9575dee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6a811a130001ea61253f17a24acbd7fb8b47ddecbb024ae9a5ec519eaca1871b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationMonoHue]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationMonoHue]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b145dfdaf24f3692bd877eac98110dfc2f0568a6b952bfc8d145676c16e3c141)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationMonoHueOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationMonoHueOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__650962400342f4f06c06cec5fd49acd365a3395264573aa3d2f634a67249d801)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2113e0051eb421f7beb7ed31aa1aa093c908c03f917a696b619aea0a8805b49a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b65038c5e0ae098285530b29b8c94bea9a3806d011bda7ecca9655d6e2db8b8c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationMonoHue]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationMonoHue]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationMonoHue]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b052334230a5614266d04edf53106c37b1edf87fb0cda4bb92470c65aaca03c0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationOpacity",
    jsii_struct_bases=[],
    name_mapping={"opacity": "opacity", "opacity_var": "opacityVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationOpacity:
    def __init__(
        self,
        *,
        opacity: typing.Optional[builtins.str] = None,
        opacity_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param opacity: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param opacity_var: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__13de42a681f48c54becf7e5fc853f92d1e45e30ad63ed2e590b98ff2762f840d)
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument opacity_var", value=opacity_var, expected_type=type_hints["opacity_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if opacity is not None:
            self._values["opacity"] = opacity
        if opacity_var is not None:
            self._values["opacity_var"] = opacity_var

    @builtins.property
    def opacity(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def opacity_var(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        result = self._values.get("opacity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationOpacity(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationOpacityList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationOpacityList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__03ad6a0d76da3d8a8b1f616660da7803d130e29328995da1af520b94a363db4f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationOpacityOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2873d60781d34c1a4450bf47667b8f8f6782ff8f440c009e07459b084f2942dc)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationOpacityOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__981f811a1ce83471f310ac84e75bdb1f98b867c7eb0389cbcaae770436e8d322)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__80f3adf8cddd4d1c9a27b719e81f49644296f081b4d609c4dfbc7ea4e1cfba87)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2c5563b98ecae6b496fb717159315b92643dd4f853d44461d4ddf5528e820854)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationOpacity]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationOpacity]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__74a4ecb4e87df5e6deccfa08fc364c1d49688593717765aa7d484d19bb466a3f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationOpacityOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationOpacityOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ec438a06130e6f01e0d48cee48882fee4e48d16c374370fa4f64969825252e0e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetOpacityVar")
    def reset_opacity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacityVar", []))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityVarInput")
    def opacity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacity"))

    @opacity.setter
    def opacity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ed9273bb8d5b60ea618df0619782ee7a2748fc6a77ab84c35ea2efd3cfb4cbee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacity", value)

    @builtins.property
    @jsii.member(jsii_name="opacityVar")
    def opacity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacityVar"))

    @opacity_var.setter
    def opacity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9514043f0d53b456faccd874963b5334597782ddab29e5837db50bdbfd6ba161)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacityVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationOpacity]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationOpacity]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationOpacity]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__007d6c44f4a3f4503dd3bcf6e114197206c61f5baea2acc6ebed1f6240303570)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__49935bfafaf73e40b52bdb6b1ba4cc15b86c07fbd0fd812796a1878e443a6279)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putAppend")
    def put_append(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationAppend, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f8b435f987cde10473a63a150999739054a6670f7a69a7bd31a61fe53772ee0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putAppend", [value]))

    @jsii.member(jsii_name="putAspectCrop")
    def put_aspect_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationAspectCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cfde137e24dc1fbe647f8c5f0e3e373452f85af4c02987d4860d7919286923d1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putAspectCrop", [value]))

    @jsii.member(jsii_name="putBackgroundColor")
    def put_background_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cfe94015866f79c00ca39cab415a8fd07924903b5b49e8a2b159a4052b407599)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBackgroundColor", [value]))

    @jsii.member(jsii_name="putBlur")
    def put_blur(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationBlur, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a13446053308e7ce3611fefe3b3101575be4af8a0eeb1f1d76c0637328f3ccd9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBlur", [value]))

    @jsii.member(jsii_name="putChromaKey")
    def put_chroma_key(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationChromaKey, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__850beaec64d87e25fb8c12633e9c185981220ef00f3d70f7e8fd59a2348f453c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putChromaKey", [value]))

    @jsii.member(jsii_name="putComposite")
    def put_composite(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationComposite, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__47ff06f453daa45d1c47ef94a82611836246e301f40659c75faea1e71ec03fd2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putComposite", [value]))

    @jsii.member(jsii_name="putCompound")
    def put_compound(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationCompound, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__179e08e82f1cbded566031be040fbd3ff977607349c625ec68d90534468b4f64)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCompound", [value]))

    @jsii.member(jsii_name="putContrast")
    def put_contrast(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationContrast, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f276f2a179abef0a48d359de8cde59522ff2807fffd7866b1a523eb566bae2ec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putContrast", [value]))

    @jsii.member(jsii_name="putCrop")
    def put_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e2af7e224dff0e6e1f2221ef16439ab2614b56e8c122f10dabd01f4e2414eed5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCrop", [value]))

    @jsii.member(jsii_name="putFaceCrop")
    def put_face_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationFaceCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c2df20b72f7cbd1eb3edf9f987c9557371bb490ba4fa653be48994ece47d546f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFaceCrop", [value]))

    @jsii.member(jsii_name="putFeatureCrop")
    def put_feature_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationFeatureCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f341830b59d53f9f6c9a5de912c7bec75b693f1a26b33d9767d4370cf648373f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFeatureCrop", [value]))

    @jsii.member(jsii_name="putFitAndFill")
    def put_fit_and_fill(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationFitAndFill, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__50642ba91ddc4407e776a63a08ebd072847e805c1571d06e90f8ff63e6fef77b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFitAndFill", [value]))

    @jsii.member(jsii_name="putGoop")
    def put_goop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationGoop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__559ee3744c5d104762e426171188d9cf5ff02944e72f3920ec8c05f8a90bd496)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGoop", [value]))

    @jsii.member(jsii_name="putGrayscale")
    def put_grayscale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationGrayscale, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aa4a034df823af266a21916379c44414bb88bbc4d6a56063a0b977555e6cd34c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGrayscale", [value]))

    @jsii.member(jsii_name="putHsl")
    def put_hsl(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationHsl, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8bd80f2361ef8c1f3b3811da5690d6fc07f277633d53d5999542b4f3fd9ee1d6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsl", [value]))

    @jsii.member(jsii_name="putHsv")
    def put_hsv(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationHsv, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9e9733b37a7599f1384b842a79dd03a8d652721547301df0a5d1ab12b0a8790d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsv", [value]))

    @jsii.member(jsii_name="putIfDimension")
    def put_if_dimension(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfDimension, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__06cef5db2a722d4a422492680f690289ceaa53724ad580700ccbc7da3f7c5196)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfDimension", [value]))

    @jsii.member(jsii_name="putIfOrientation")
    def put_if_orientation(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b295f469f47b40d9ce0b00a693db5c086f08ed36c2d1d14243bae1bd2c9856c9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfOrientation", [value]))

    @jsii.member(jsii_name="putImQuery")
    def put_im_query(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationImQuery, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5cede5adf324c7d9513e8daed1661127c43fb5c6c7cb5a834db4f2793a1ec374)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putImQuery", [value]))

    @jsii.member(jsii_name="putMaxColors")
    def put_max_colors(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationMaxColors, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a9b4834f8f1eecbebd14675b122dd690ea6e480b4e6ba32e432efbcf34f39f0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMaxColors", [value]))

    @jsii.member(jsii_name="putMirror")
    def put_mirror(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationMirror, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9525386012742bc83b0e9ac7df1faefd1e83ceab468d0ef367c010c94d8baea3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMirror", [value]))

    @jsii.member(jsii_name="putMonoHue")
    def put_mono_hue(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationMonoHue, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a1c0ca9376bf90890b8b86fa572a513fde79101628493e633bfdbf1c13024540)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMonoHue", [value]))

    @jsii.member(jsii_name="putOpacity")
    def put_opacity(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationOpacity, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4f9d87024ce93a4dd6161a81f73030c9c177a3cede9fc5153d3bd233d50c3c7c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putOpacity", [value]))

    @jsii.member(jsii_name="putRegionOfInterestCrop")
    def put_region_of_interest_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationRegionOfInterestCrop", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b6916f01af1075d7d8dbdff1fe94036f1b6a59cbf5d6506ab5274b699c3efcac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRegionOfInterestCrop", [value]))

    @jsii.member(jsii_name="putRelativeCrop")
    def put_relative_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationRelativeCrop", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0754815b4951eadd749f2620a0982f948e71bd16c6cbc50fe998cceee16c077c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRelativeCrop", [value]))

    @jsii.member(jsii_name="putRemoveColor")
    def put_remove_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationRemoveColor", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__837cf9304594e7513f08d33268f199f0b7849a64589a2e9ce5bfe175b0a4279a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRemoveColor", [value]))

    @jsii.member(jsii_name="putResize")
    def put_resize(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationResize", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__018f64e704d6fc44861777faeca77b235fd3b4a6cd4aa8cbaea8d51b765aa333)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putResize", [value]))

    @jsii.member(jsii_name="putRotate")
    def put_rotate(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationRotate", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3d1d3704a3deeb9b759e662ffb27648ea366295ee09eefc8aaca48350bebc6e2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRotate", [value]))

    @jsii.member(jsii_name="putScale")
    def put_scale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationScale", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aa75b8c036039f0f49550ce193d4647cbd915bf0f983a9edaba82b188f5b7dc0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putScale", [value]))

    @jsii.member(jsii_name="putShear")
    def put_shear(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationShear", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1e69c85314a332a47332e3f177eab94a5839f556d2093d21b0df7019cfb8e6e3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putShear", [value]))

    @jsii.member(jsii_name="putTrim")
    def put_trim(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationTrim", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__498269bf48774608117fd180670e9953195c8bd8551216e869d3abbc7dcb6208)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTrim", [value]))

    @jsii.member(jsii_name="putUnsharpMask")
    def put_unsharp_mask(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationUnsharpMask", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a987b3946a360b9a2dfe6fa16cc39469b2c1acf4c7d78692a51bb8cc4d86754a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putUnsharpMask", [value]))

    @jsii.member(jsii_name="resetAppend")
    def reset_append(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAppend", []))

    @jsii.member(jsii_name="resetAspectCrop")
    def reset_aspect_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspectCrop", []))

    @jsii.member(jsii_name="resetBackgroundColor")
    def reset_background_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBackgroundColor", []))

    @jsii.member(jsii_name="resetBlur")
    def reset_blur(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBlur", []))

    @jsii.member(jsii_name="resetChromaKey")
    def reset_chroma_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChromaKey", []))

    @jsii.member(jsii_name="resetComposite")
    def reset_composite(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetComposite", []))

    @jsii.member(jsii_name="resetCompound")
    def reset_compound(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCompound", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetCrop")
    def reset_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCrop", []))

    @jsii.member(jsii_name="resetFaceCrop")
    def reset_face_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFaceCrop", []))

    @jsii.member(jsii_name="resetFeatureCrop")
    def reset_feature_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureCrop", []))

    @jsii.member(jsii_name="resetFitAndFill")
    def reset_fit_and_fill(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFitAndFill", []))

    @jsii.member(jsii_name="resetGoop")
    def reset_goop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGoop", []))

    @jsii.member(jsii_name="resetGrayscale")
    def reset_grayscale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGrayscale", []))

    @jsii.member(jsii_name="resetHsl")
    def reset_hsl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsl", []))

    @jsii.member(jsii_name="resetHsv")
    def reset_hsv(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsv", []))

    @jsii.member(jsii_name="resetIfDimension")
    def reset_if_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfDimension", []))

    @jsii.member(jsii_name="resetIfOrientation")
    def reset_if_orientation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfOrientation", []))

    @jsii.member(jsii_name="resetImQuery")
    def reset_im_query(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetImQuery", []))

    @jsii.member(jsii_name="resetMaxColors")
    def reset_max_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxColors", []))

    @jsii.member(jsii_name="resetMirror")
    def reset_mirror(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMirror", []))

    @jsii.member(jsii_name="resetMonoHue")
    def reset_mono_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonoHue", []))

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetRegionOfInterestCrop")
    def reset_region_of_interest_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRegionOfInterestCrop", []))

    @jsii.member(jsii_name="resetRelativeCrop")
    def reset_relative_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRelativeCrop", []))

    @jsii.member(jsii_name="resetRemoveColor")
    def reset_remove_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRemoveColor", []))

    @jsii.member(jsii_name="resetResize")
    def reset_resize(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetResize", []))

    @jsii.member(jsii_name="resetRotate")
    def reset_rotate(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRotate", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetShear")
    def reset_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetShear", []))

    @jsii.member(jsii_name="resetTrim")
    def reset_trim(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTrim", []))

    @jsii.member(jsii_name="resetUnsharpMask")
    def reset_unsharp_mask(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUnsharpMask", []))

    @builtins.property
    @jsii.member(jsii_name="append")
    def append(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationAppendList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationAppendList, jsii.get(self, "append"))

    @builtins.property
    @jsii.member(jsii_name="aspectCrop")
    def aspect_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationAspectCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationAspectCropList, jsii.get(self, "aspectCrop"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColor")
    def background_color(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationBackgroundColorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationBackgroundColorList, jsii.get(self, "backgroundColor"))

    @builtins.property
    @jsii.member(jsii_name="blur")
    def blur(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationBlurList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationBlurList, jsii.get(self, "blur"))

    @builtins.property
    @jsii.member(jsii_name="chromaKey")
    def chroma_key(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationChromaKeyList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationChromaKeyList, jsii.get(self, "chromaKey"))

    @builtins.property
    @jsii.member(jsii_name="composite")
    def composite(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationCompositeList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationCompositeList, jsii.get(self, "composite"))

    @builtins.property
    @jsii.member(jsii_name="compound")
    def compound(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationCompoundList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationCompoundList, jsii.get(self, "compound"))

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationContrastList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationContrastList, jsii.get(self, "contrast"))

    @builtins.property
    @jsii.member(jsii_name="crop")
    def crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationCropList, jsii.get(self, "crop"))

    @builtins.property
    @jsii.member(jsii_name="faceCrop")
    def face_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationFaceCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationFaceCropList, jsii.get(self, "faceCrop"))

    @builtins.property
    @jsii.member(jsii_name="featureCrop")
    def feature_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationFeatureCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationFeatureCropList, jsii.get(self, "featureCrop"))

    @builtins.property
    @jsii.member(jsii_name="fitAndFill")
    def fit_and_fill(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationFitAndFillList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationFitAndFillList, jsii.get(self, "fitAndFill"))

    @builtins.property
    @jsii.member(jsii_name="goop")
    def goop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationGoopList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationGoopList, jsii.get(self, "goop"))

    @builtins.property
    @jsii.member(jsii_name="grayscale")
    def grayscale(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationGrayscaleList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationGrayscaleList, jsii.get(self, "grayscale"))

    @builtins.property
    @jsii.member(jsii_name="hsl")
    def hsl(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationHslList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationHslList, jsii.get(self, "hsl"))

    @builtins.property
    @jsii.member(jsii_name="hsv")
    def hsv(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationHsvList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationHsvList, jsii.get(self, "hsv"))

    @builtins.property
    @jsii.member(jsii_name="ifDimension")
    def if_dimension(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfDimensionList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfDimensionList, jsii.get(self, "ifDimension"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientation")
    def if_orientation(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfOrientationList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfOrientationList, jsii.get(self, "ifOrientation"))

    @builtins.property
    @jsii.member(jsii_name="imQuery")
    def im_query(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationImQueryList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationImQueryList, jsii.get(self, "imQuery"))

    @builtins.property
    @jsii.member(jsii_name="maxColors")
    def max_colors(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationMaxColorsList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationMaxColorsList, jsii.get(self, "maxColors"))

    @builtins.property
    @jsii.member(jsii_name="mirror")
    def mirror(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationMirrorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationMirrorList, jsii.get(self, "mirror"))

    @builtins.property
    @jsii.member(jsii_name="monoHue")
    def mono_hue(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationMonoHueList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationMonoHueList, jsii.get(self, "monoHue"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationOpacityList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationOpacityList, jsii.get(self, "opacity"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestCrop")
    def region_of_interest_crop(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationRegionOfInterestCropList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationRegionOfInterestCropList", jsii.get(self, "regionOfInterestCrop"))

    @builtins.property
    @jsii.member(jsii_name="relativeCrop")
    def relative_crop(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationRelativeCropList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationRelativeCropList", jsii.get(self, "relativeCrop"))

    @builtins.property
    @jsii.member(jsii_name="removeColor")
    def remove_color(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationRemoveColorList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationRemoveColorList", jsii.get(self, "removeColor"))

    @builtins.property
    @jsii.member(jsii_name="resize")
    def resize(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationResizeList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationResizeList", jsii.get(self, "resize"))

    @builtins.property
    @jsii.member(jsii_name="rotate")
    def rotate(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationRotateList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationRotateList", jsii.get(self, "rotate"))

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationScaleList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationScaleList", jsii.get(self, "scale"))

    @builtins.property
    @jsii.member(jsii_name="shear")
    def shear(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationShearList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationShearList", jsii.get(self, "shear"))

    @builtins.property
    @jsii.member(jsii_name="trim")
    def trim(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationTrimList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationTrimList", jsii.get(self, "trim"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMask")
    def unsharp_mask(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationUnsharpMaskList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationUnsharpMaskList", jsii.get(self, "unsharpMask"))

    @builtins.property
    @jsii.member(jsii_name="appendInput")
    def append_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationAppend]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationAppend]]], jsii.get(self, "appendInput"))

    @builtins.property
    @jsii.member(jsii_name="aspectCropInput")
    def aspect_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationAspectCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationAspectCrop]]], jsii.get(self, "aspectCropInput"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColorInput")
    def background_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationBackgroundColor]]], jsii.get(self, "backgroundColorInput"))

    @builtins.property
    @jsii.member(jsii_name="blurInput")
    def blur_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationBlur]]], jsii.get(self, "blurInput"))

    @builtins.property
    @jsii.member(jsii_name="chromaKeyInput")
    def chroma_key_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationChromaKey]]], jsii.get(self, "chromaKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="compositeInput")
    def composite_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationComposite]]], jsii.get(self, "compositeInput"))

    @builtins.property
    @jsii.member(jsii_name="compoundInput")
    def compound_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationCompound]]], jsii.get(self, "compoundInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationContrast]]], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="cropInput")
    def crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationCrop]]], jsii.get(self, "cropInput"))

    @builtins.property
    @jsii.member(jsii_name="faceCropInput")
    def face_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationFaceCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationFaceCrop]]], jsii.get(self, "faceCropInput"))

    @builtins.property
    @jsii.member(jsii_name="featureCropInput")
    def feature_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationFeatureCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationFeatureCrop]]], jsii.get(self, "featureCropInput"))

    @builtins.property
    @jsii.member(jsii_name="fitAndFillInput")
    def fit_and_fill_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationFitAndFill]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationFitAndFill]]], jsii.get(self, "fitAndFillInput"))

    @builtins.property
    @jsii.member(jsii_name="goopInput")
    def goop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationGoop]]], jsii.get(self, "goopInput"))

    @builtins.property
    @jsii.member(jsii_name="grayscaleInput")
    def grayscale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationGrayscale]]], jsii.get(self, "grayscaleInput"))

    @builtins.property
    @jsii.member(jsii_name="hslInput")
    def hsl_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationHsl]]], jsii.get(self, "hslInput"))

    @builtins.property
    @jsii.member(jsii_name="hsvInput")
    def hsv_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationHsv]]], jsii.get(self, "hsvInput"))

    @builtins.property
    @jsii.member(jsii_name="ifDimensionInput")
    def if_dimension_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfDimension]]], jsii.get(self, "ifDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientationInput")
    def if_orientation_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfOrientation]]], jsii.get(self, "ifOrientationInput"))

    @builtins.property
    @jsii.member(jsii_name="imQueryInput")
    def im_query_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationImQuery]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationImQuery]]], jsii.get(self, "imQueryInput"))

    @builtins.property
    @jsii.member(jsii_name="maxColorsInput")
    def max_colors_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationMaxColors]]], jsii.get(self, "maxColorsInput"))

    @builtins.property
    @jsii.member(jsii_name="mirrorInput")
    def mirror_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationMirror]]], jsii.get(self, "mirrorInput"))

    @builtins.property
    @jsii.member(jsii_name="monoHueInput")
    def mono_hue_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationMonoHue]]], jsii.get(self, "monoHueInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationOpacity]]], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestCropInput")
    def region_of_interest_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationRegionOfInterestCrop"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationRegionOfInterestCrop"]]], jsii.get(self, "regionOfInterestCropInput"))

    @builtins.property
    @jsii.member(jsii_name="relativeCropInput")
    def relative_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationRelativeCrop"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationRelativeCrop"]]], jsii.get(self, "relativeCropInput"))

    @builtins.property
    @jsii.member(jsii_name="removeColorInput")
    def remove_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationRemoveColor"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationRemoveColor"]]], jsii.get(self, "removeColorInput"))

    @builtins.property
    @jsii.member(jsii_name="resizeInput")
    def resize_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationResize"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationResize"]]], jsii.get(self, "resizeInput"))

    @builtins.property
    @jsii.member(jsii_name="rotateInput")
    def rotate_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationRotate"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationRotate"]]], jsii.get(self, "rotateInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationScale"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationScale"]]], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="shearInput")
    def shear_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationShear"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationShear"]]], jsii.get(self, "shearInput"))

    @builtins.property
    @jsii.member(jsii_name="trimInput")
    def trim_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationTrim"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationTrim"]]], jsii.get(self, "trimInput"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMaskInput")
    def unsharp_mask_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationUnsharpMask"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationUnsharpMask"]]], jsii.get(self, "unsharpMaskInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9c62eb86bfcf4328512ce06e8fbba74d395bf153886ecbe44991ab657415a60a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationRegionOfInterestCrop",
    jsii_struct_bases=[],
    name_mapping={
        "region_of_interest": "regionOfInterest",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationRegionOfInterestCrop:
    def __init__(
        self,
        *,
        region_of_interest: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationRegionOfInterestCropRegionOfInterest", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param region_of_interest: region_of_interest block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest DataAkamaiImagingPolicyImage#region_of_interest}
        :param gravity: The placement of the crop area relative to the specified area of interest. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: The placement of the crop area relative to the specified area of interest. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param style: Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(region_of_interest, dict):
            region_of_interest = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationRegionOfInterestCropRegionOfInterest(**region_of_interest)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c13473f0d5fc32bc66e07288c9ae7274b0ef4eb3314b93c920ff64ae7f1ad781)
            check_type(argname="argument region_of_interest", value=region_of_interest, expected_type=type_hints["region_of_interest"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "region_of_interest": region_of_interest,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def region_of_interest(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationRegionOfInterestCropRegionOfInterest":
        '''region_of_interest block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest DataAkamaiImagingPolicyImage#region_of_interest}
        '''
        result = self._values.get("region_of_interest")
        assert result is not None, "Required property 'region_of_interest' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationRegionOfInterestCropRegionOfInterest", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''The placement of the crop area relative to the specified area of interest.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''The placement of the crop area relative to the specified area of interest.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationRegionOfInterestCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationRegionOfInterestCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationRegionOfInterestCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__224c1c6858ed7dd527ea74bb03a83e72ae3b06d1bfd63b22e7c4953552535c4a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationRegionOfInterestCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__415ed3787ab8981cd484c8056bed6acd234e2dad11d0da52cb966fc83a40333f)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationRegionOfInterestCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__665ab458d6f7350cf957d247d8ca61243b2b74c00670df95e12c4600a4d02417)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d2355b00a707a3ce4c1eeeffc6d0f84e2f364f6a242dc3f329e1249cd553d5f3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__10e7b4f7824c935257cb3309b9349cb9baddb3279e7922a6a30ea9419dfedd03)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationRegionOfInterestCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationRegionOfInterestCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationRegionOfInterestCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f0a0ede54ec8ccdac26754f346cb4000ae546a60efe261c57dcb99a8b8cb9ae0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationRegionOfInterestCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationRegionOfInterestCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__75ab9f25153b943d744d3f19d08f8567bc56dddee8bbeb89fc106ddcd5e50712)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putRegionOfInterest")
    def put_region_of_interest(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationRegionOfInterestCropRegionOfInterest()

        return typing.cast(None, jsii.invoke(self, "putRegionOfInterest", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterest")
    def region_of_interest(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestOutputReference", jsii.get(self, "regionOfInterest"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestInput")
    def region_of_interest_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationRegionOfInterestCropRegionOfInterest"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationRegionOfInterestCropRegionOfInterest"], jsii.get(self, "regionOfInterestInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__33aeafc8c70555339091844b1f3c2fa1c431b3ac09501b33e754902d57ad7031)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e2aa334001b90a2e01b2b4914cdeccccc968af527e827fbd21140127b1184743)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ef404033fbb228e8a587d92b6cf7840782887102e6fe2d7260c8737490ee2150)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__343e209470a2609ccba06948580fe97651afc758947e9a572551e82a2ead8a22)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7dd3fa3d56885dacef636d2542f7b59866435bf9daff789be1621d11d8c75994)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bd65e9602d2abd67a5afa0ab1c0a3258d69396dadac8ebf1851602559064664d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0a22081817e009cd45373133d30d963746a82cf7a954dfa41212e525c23587cc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cfcffa01ad76498655a06e0e6318220ab089dd07e1ab6ffe4624e89926626870)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationRegionOfInterestCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationRegionOfInterestCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationRegionOfInterestCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7569b0f26644d4bbe8bd11fab6c56bc71c800b64b0d5ba74d74611493934d96e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationRegionOfInterestCropRegionOfInterest",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationRegionOfInterestCropRegionOfInterest:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationRegionOfInterestCropRegionOfInterest(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__abea66273660060d2a013952954f2b39d0317e2cf7de01f4142b5660243320d9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationRegionOfInterestCropRegionOfInterest]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationRegionOfInterestCropRegionOfInterest], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationRegionOfInterestCropRegionOfInterest],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9dfffd0164ffe718c48bcbb786c547690a98685d852933eb83b1ea4627b60648)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationRelativeCrop",
    jsii_struct_bases=[],
    name_mapping={
        "east": "east",
        "east_var": "eastVar",
        "north": "north",
        "north_var": "northVar",
        "south": "south",
        "south_var": "southVar",
        "west": "west",
        "west_var": "westVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationRelativeCrop:
    def __init__(
        self,
        *,
        east: typing.Optional[builtins.str] = None,
        east_var: typing.Optional[builtins.str] = None,
        north: typing.Optional[builtins.str] = None,
        north_var: typing.Optional[builtins.str] = None,
        south: typing.Optional[builtins.str] = None,
        south_var: typing.Optional[builtins.str] = None,
        west: typing.Optional[builtins.str] = None,
        west_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param east: The number of pixels to shrink or expand the right side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east DataAkamaiImagingPolicyImage#east}
        :param east_var: The number of pixels to shrink or expand the right side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east_var DataAkamaiImagingPolicyImage#east_var}
        :param north: The number of pixels to shrink or expand the top side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north DataAkamaiImagingPolicyImage#north}
        :param north_var: The number of pixels to shrink or expand the top side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north_var DataAkamaiImagingPolicyImage#north_var}
        :param south: The number of pixels to shrink or expand the bottom side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south DataAkamaiImagingPolicyImage#south}
        :param south_var: The number of pixels to shrink or expand the bottom side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south_var DataAkamaiImagingPolicyImage#south_var}
        :param west: The number of pixels to shrink or expand the left side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west DataAkamaiImagingPolicyImage#west}
        :param west_var: The number of pixels to shrink or expand the left side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west_var DataAkamaiImagingPolicyImage#west_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f91ebadd53ba112d40d232e1dfec3314a5d90db8ed6db203cf4230d6047d5174)
            check_type(argname="argument east", value=east, expected_type=type_hints["east"])
            check_type(argname="argument east_var", value=east_var, expected_type=type_hints["east_var"])
            check_type(argname="argument north", value=north, expected_type=type_hints["north"])
            check_type(argname="argument north_var", value=north_var, expected_type=type_hints["north_var"])
            check_type(argname="argument south", value=south, expected_type=type_hints["south"])
            check_type(argname="argument south_var", value=south_var, expected_type=type_hints["south_var"])
            check_type(argname="argument west", value=west, expected_type=type_hints["west"])
            check_type(argname="argument west_var", value=west_var, expected_type=type_hints["west_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if east is not None:
            self._values["east"] = east
        if east_var is not None:
            self._values["east_var"] = east_var
        if north is not None:
            self._values["north"] = north
        if north_var is not None:
            self._values["north_var"] = north_var
        if south is not None:
            self._values["south"] = south
        if south_var is not None:
            self._values["south_var"] = south_var
        if west is not None:
            self._values["west"] = west
        if west_var is not None:
            self._values["west_var"] = west_var

    @builtins.property
    def east(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the right side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east DataAkamaiImagingPolicyImage#east}
        '''
        result = self._values.get("east")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def east_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the right side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east_var DataAkamaiImagingPolicyImage#east_var}
        '''
        result = self._values.get("east_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def north(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the top side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north DataAkamaiImagingPolicyImage#north}
        '''
        result = self._values.get("north")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def north_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the top side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north_var DataAkamaiImagingPolicyImage#north_var}
        '''
        result = self._values.get("north_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def south(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the bottom side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south DataAkamaiImagingPolicyImage#south}
        '''
        result = self._values.get("south")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def south_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the bottom side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south_var DataAkamaiImagingPolicyImage#south_var}
        '''
        result = self._values.get("south_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def west(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the left side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west DataAkamaiImagingPolicyImage#west}
        '''
        result = self._values.get("west")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def west_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the left side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west_var DataAkamaiImagingPolicyImage#west_var}
        '''
        result = self._values.get("west_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationRelativeCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationRelativeCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationRelativeCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aa0964bede93cf6b6380b7a35081657f7630f9d8a35cf9100541001982c3277c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationRelativeCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9683d958018a5ba252f257e02c07007ce77209678ed9e0df021acb0afac78157)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationRelativeCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__20261b624a2fe65248bbc19decf390cce368bd43224d13ac3c3f201018a672d5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e204c69b31c021009cdaa3ce404ab1ca2b159928db48aaa5657a2faa1d187a94)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4f4699706735caedb9fe43de2c4e53ea8ae6b9a61b5a187f8e55ffccd4f224a4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationRelativeCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationRelativeCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationRelativeCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1df99489da2bb493c993f0d689958ba83f81936da1a2a4f7f00466a62d3cd5fc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationRelativeCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationRelativeCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a57746dfe429f068f71cb45c01f728d641ed0110600f26df19e0b7a999fd7a81)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetEast")
    def reset_east(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEast", []))

    @jsii.member(jsii_name="resetEastVar")
    def reset_east_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEastVar", []))

    @jsii.member(jsii_name="resetNorth")
    def reset_north(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNorth", []))

    @jsii.member(jsii_name="resetNorthVar")
    def reset_north_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNorthVar", []))

    @jsii.member(jsii_name="resetSouth")
    def reset_south(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSouth", []))

    @jsii.member(jsii_name="resetSouthVar")
    def reset_south_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSouthVar", []))

    @jsii.member(jsii_name="resetWest")
    def reset_west(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWest", []))

    @jsii.member(jsii_name="resetWestVar")
    def reset_west_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWestVar", []))

    @builtins.property
    @jsii.member(jsii_name="eastInput")
    def east_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "eastInput"))

    @builtins.property
    @jsii.member(jsii_name="eastVarInput")
    def east_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "eastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="northInput")
    def north_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "northInput"))

    @builtins.property
    @jsii.member(jsii_name="northVarInput")
    def north_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "northVarInput"))

    @builtins.property
    @jsii.member(jsii_name="southInput")
    def south_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "southInput"))

    @builtins.property
    @jsii.member(jsii_name="southVarInput")
    def south_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "southVarInput"))

    @builtins.property
    @jsii.member(jsii_name="westInput")
    def west_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "westInput"))

    @builtins.property
    @jsii.member(jsii_name="westVarInput")
    def west_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "westVarInput"))

    @builtins.property
    @jsii.member(jsii_name="east")
    def east(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "east"))

    @east.setter
    def east(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ee444faa44a79d29c08974a083e7d28f9d96a01758100138b1dc14f7c1f2909)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "east", value)

    @builtins.property
    @jsii.member(jsii_name="eastVar")
    def east_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "eastVar"))

    @east_var.setter
    def east_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__06c0a31403bd3c97242e7a9446100b8f4e9d50c901f0306dae5eaabce1945708)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "eastVar", value)

    @builtins.property
    @jsii.member(jsii_name="north")
    def north(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "north"))

    @north.setter
    def north(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__801fec4591d46a372a8e8eb40da6d885e60c3cbcdcfa0f2bd005dce4f4c1311f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "north", value)

    @builtins.property
    @jsii.member(jsii_name="northVar")
    def north_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "northVar"))

    @north_var.setter
    def north_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__43b006a63eb0f35cdb3a1a02f3b947e516cce4b11a979af100e43b883a0b96ab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "northVar", value)

    @builtins.property
    @jsii.member(jsii_name="south")
    def south(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "south"))

    @south.setter
    def south(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4c5f51ef1e7aaa03208e68c951e4a9546c8e4ac0717c39d5e0a625fc18bcad30)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "south", value)

    @builtins.property
    @jsii.member(jsii_name="southVar")
    def south_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "southVar"))

    @south_var.setter
    def south_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7c7f7ff887be758f460197ced4dacb0e2c16548b83d81487eff498f84e611d14)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "southVar", value)

    @builtins.property
    @jsii.member(jsii_name="west")
    def west(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "west"))

    @west.setter
    def west(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1d4bc24626ef7f36c014d603d4665b018d89a269c94fd60fc1da49d258d35489)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "west", value)

    @builtins.property
    @jsii.member(jsii_name="westVar")
    def west_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "westVar"))

    @west_var.setter
    def west_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4eff2a031ddc50095a1e62478e960e5895df7055ae50b4cbe9867bb0ef6258de)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "westVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationRelativeCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationRelativeCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationRelativeCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b5999aa4bfea2d9c6197ef5c5e48d1ee70b2b39d12ef9fdf2e5f4923e698e5ac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationRemoveColor",
    jsii_struct_bases=[],
    name_mapping={
        "color": "color",
        "color_var": "colorVar",
        "feather": "feather",
        "feather_var": "featherVar",
        "tolerance": "tolerance",
        "tolerance_var": "toleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationRemoveColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
        feather: typing.Optional[builtins.str] = None,
        feather_var: typing.Optional[builtins.str] = None,
        tolerance: typing.Optional[builtins.str] = None,
        tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        :param feather: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        :param feather_var: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        :param tolerance: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        :param tolerance_var: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__da714645fea115fe5e5ec2f0c8659f926701f6d709af5e50ce2db4b00392eace)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
            check_type(argname="argument feather", value=feather, expected_type=type_hints["feather"])
            check_type(argname="argument feather_var", value=feather_var, expected_type=type_hints["feather_var"])
            check_type(argname="argument tolerance", value=tolerance, expected_type=type_hints["tolerance"])
            check_type(argname="argument tolerance_var", value=tolerance_var, expected_type=type_hints["tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var
        if feather is not None:
            self._values["feather"] = feather
        if feather_var is not None:
            self._values["feather_var"] = feather_var
        if tolerance is not None:
            self._values["tolerance"] = tolerance
        if tolerance_var is not None:
            self._values["tolerance_var"] = tolerance_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        '''
        result = self._values.get("feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather_var(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        '''
        result = self._values.get("feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        '''
        result = self._values.get("tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance_var(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        result = self._values.get("tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationRemoveColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationRemoveColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationRemoveColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__28ff7e3c1766e62529e7999f171efe9fb6f3fbf037b7d5450bb2b8455efcb4c2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationRemoveColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__786fb746207d53312b803b2558b9949d06a032e0ade59e25588b070c31b4c17a)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationRemoveColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a05a74308e4f791654a8ee9f7a7447affbba81aad98f5c4c435061af8453ccab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d0a22dfdee88ced5c340b234f2340108e8fa0c6bf0d5cdfb6146ab734abd6ff2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4cf9cc6a0bab12f6f2632d1be273c97a2c5adc4aeb8611d45966f90259ebec88)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationRemoveColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationRemoveColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationRemoveColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8d611eeecd487c21d7c6577df3fac6d1cc1928670adb5fc98a77fc2083ecd32e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationRemoveColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationRemoveColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1e7da463ee0a02b1c2eb4691b3beb70f319710f73afeaf223d2cf3c1daf7d4cd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @jsii.member(jsii_name="resetFeather")
    def reset_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeather", []))

    @jsii.member(jsii_name="resetFeatherVar")
    def reset_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatherVar", []))

    @jsii.member(jsii_name="resetTolerance")
    def reset_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTolerance", []))

    @jsii.member(jsii_name="resetToleranceVar")
    def reset_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featherInput")
    def feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherInput"))

    @builtins.property
    @jsii.member(jsii_name="featherVarInput")
    def feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceInput")
    def tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceVarInput")
    def tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0fd37e190014eb9e5dca56403b8b019a67e3380a1ff7aa478d96b366a3e43386)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a3bc681e41dab12dab0916ed7f8b15b3b5732c0ab8468ae8e71170348278bbba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="feather")
    def feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "feather"))

    @feather.setter
    def feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3db5ee93097470817e571ecacdd99b5a7e273308424003c927640b2951966f43)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "feather", value)

    @builtins.property
    @jsii.member(jsii_name="featherVar")
    def feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featherVar"))

    @feather_var.setter
    def feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df2de05c6a5efc2f52f451d4c71ce4dc38f5aed99848f5c3af3ea4fbf1fe58d9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featherVar", value)

    @builtins.property
    @jsii.member(jsii_name="tolerance")
    def tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tolerance"))

    @tolerance.setter
    def tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8b42f9b026ca89f5a794f2ccf7e1a2513489b0f188f11348f751d3054530bc9c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tolerance", value)

    @builtins.property
    @jsii.member(jsii_name="toleranceVar")
    def tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "toleranceVar"))

    @tolerance_var.setter
    def tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ad177c8fcc4650e34176b1d54469072b0814d77841667d065b4ef29af705bf55)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "toleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationRemoveColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationRemoveColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationRemoveColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a0b2cf460705cd6380add25feacb5144449845ee414cf6ab076a19d28013c424)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationResize",
    jsii_struct_bases=[],
    name_mapping={
        "aspect": "aspect",
        "aspect_var": "aspectVar",
        "height": "height",
        "height_var": "heightVar",
        "type": "type",
        "type_var": "typeVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationResize:
    def __init__(
        self,
        *,
        aspect: typing.Optional[builtins.str] = None,
        aspect_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param aspect: Preserves the aspect ratio. Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect DataAkamaiImagingPolicyImage#aspect}
        :param aspect_var: Preserves the aspect ratio. Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_var DataAkamaiImagingPolicyImage#aspect_var}
        :param height: The height to resize the source image to. Must be set if height is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height to resize the source image to. Must be set if height is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param type: Sets constraints for the image resize. Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: Sets constraints for the image resize. Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        :param width: The width to resize the source image to. Must be set if width is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width to resize the source image to. Must be set if width is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0a828e8a38c35c05f517599e22e05c11ba6e96e49ff1e5274cefe6c89e1ca533)
            check_type(argname="argument aspect", value=aspect, expected_type=type_hints["aspect"])
            check_type(argname="argument aspect_var", value=aspect_var, expected_type=type_hints["aspect_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if aspect is not None:
            self._values["aspect"] = aspect
        if aspect_var is not None:
            self._values["aspect_var"] = aspect_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def aspect(self) -> typing.Optional[builtins.str]:
        '''Preserves the aspect ratio.

        Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect DataAkamaiImagingPolicyImage#aspect}
        '''
        result = self._values.get("aspect")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def aspect_var(self) -> typing.Optional[builtins.str]:
        '''Preserves the aspect ratio.

        Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_var DataAkamaiImagingPolicyImage#aspect_var}
        '''
        result = self._values.get("aspect_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height to resize the source image to. Must be set if height is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height to resize the source image to. Must be set if height is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''Sets constraints for the image resize.

        Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''Sets constraints for the image resize.

        Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width to resize the source image to. Must be set if width is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width to resize the source image to. Must be set if width is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationResize(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationResizeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationResizeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3045fc2970d40da950852a2bc4c326c204ae143bed52b047865707812d681343)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationResizeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__caf7aad9e1e83d57052c4d249e6903d6d5f8e6d0830526363d2bece1b2052a78)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationResizeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__98811a3b8dc7399310bfcd9849d5c0a381fd256c1a1b0a5c2a1bb19c76cfa53a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__127c4c6d4dc741f8ad06e49dac14b24bcdea9402e744d6afe3cb5cac48f513a2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__34c431bd3457038c9887f52897c435e0773fa5bab86f31000d1da169dee3a11d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationResize]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationResize]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationResize]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6b3b01c09900f5e5028300d5b16265d1156394194d999d3814fbd7edda1f8d28)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationResizeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationResizeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__58be5e624403f9d89c51677269defe56ce85924c364a4d43b7450812791256dd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAspect")
    def reset_aspect(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspect", []))

    @jsii.member(jsii_name="resetAspectVar")
    def reset_aspect_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspectVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="aspectInput")
    def aspect_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "aspectInput"))

    @builtins.property
    @jsii.member(jsii_name="aspectVarInput")
    def aspect_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "aspectVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="aspect")
    def aspect(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "aspect"))

    @aspect.setter
    def aspect(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d708a56d2706aaa8e54853d1ada00c0c89f580efe8bcf1058fc43f712a47bad2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "aspect", value)

    @builtins.property
    @jsii.member(jsii_name="aspectVar")
    def aspect_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "aspectVar"))

    @aspect_var.setter
    def aspect_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7055ec0d045e458033e85cccd7e96b1abd23962de6625b759c113c6076481f43)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "aspectVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e943e26df5c76b43020b68f51eddd2d1999c0c01e6eac9ba3367ab2014d21452)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3f29c00b710e9a0fa198d1cd923b79202eef87f43adf7328d38969b0946e8950)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7c0ddbbb985b52f041a8ea1e6f6e3b05835a203f6b51eaf01908857df9d793eb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3e19935f74092d65be1a3fc6a826122fc2a441072484e1bb69453e3b8ff83330)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__15bd4abcf2c1bb186c69ff6cdc3ccdfa221ed818233c69ac2f9c30c668cf4a93)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__646a2ef05a0170a2c7f8786d41a308126cb6ddeee54fdb6ea5af5cf641f3e627)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationResize]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationResize]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationResize]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__965f7e4b82e46913d8f9d3e7f7e9c1fb3959cb4b5ace09e3b31fcb7543150487)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationRotate",
    jsii_struct_bases=[],
    name_mapping={"degrees": "degrees", "degrees_var": "degreesVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationRotate:
    def __init__(
        self,
        *,
        degrees: typing.Optional[builtins.str] = None,
        degrees_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param degrees: The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees DataAkamaiImagingPolicyImage#degrees}
        :param degrees_var: The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees_var DataAkamaiImagingPolicyImage#degrees_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4dbf97089907aae7b634a54032732271716561a0f340c7b1c00fcc616d9a48f6)
            check_type(argname="argument degrees", value=degrees, expected_type=type_hints["degrees"])
            check_type(argname="argument degrees_var", value=degrees_var, expected_type=type_hints["degrees_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if degrees is not None:
            self._values["degrees"] = degrees
        if degrees_var is not None:
            self._values["degrees_var"] = degrees_var

    @builtins.property
    def degrees(self) -> typing.Optional[builtins.str]:
        '''The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees DataAkamaiImagingPolicyImage#degrees}
        '''
        result = self._values.get("degrees")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def degrees_var(self) -> typing.Optional[builtins.str]:
        '''The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees_var DataAkamaiImagingPolicyImage#degrees_var}
        '''
        result = self._values.get("degrees_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationRotate(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationRotateList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationRotateList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ebcc31b64013740871e6566411db2c61c6222c3419ff27cdc1a49eb93d9dfb50)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationRotateOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8c6425124c9883be79d4f7d3133eeb773d4125c9d625b752a17fe1c3d9af2154)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationRotateOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6cb8b5cf4c6ad6afa73ebd44818e6c35fb1afd4a945c7ff1f3ec55dc4b768fd7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9e7b4ec3bafdc67fab270e45035ffab0a1f54623920a9aca3752e2aae8dc8971)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__134ffedc21065afef1df369ceeddee77d88b0b8b89ee3616d9cda61ae5cb1205)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationRotate]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationRotate]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationRotate]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d7f2cc58a9cc6c190eae150b61954a71ad7e800b3a3e326428bed52eaf509356)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationRotateOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationRotateOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bac008b1cb09668d3dfd772b190f65ab98a7f0c778565dbe720483d2294e1371)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetDegrees")
    def reset_degrees(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDegrees", []))

    @jsii.member(jsii_name="resetDegreesVar")
    def reset_degrees_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDegreesVar", []))

    @builtins.property
    @jsii.member(jsii_name="degreesInput")
    def degrees_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "degreesInput"))

    @builtins.property
    @jsii.member(jsii_name="degreesVarInput")
    def degrees_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "degreesVarInput"))

    @builtins.property
    @jsii.member(jsii_name="degrees")
    def degrees(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "degrees"))

    @degrees.setter
    def degrees(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9e333658386d156fc7dd8b906e7194d39be181e166fb40368359c3719dec834f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "degrees", value)

    @builtins.property
    @jsii.member(jsii_name="degreesVar")
    def degrees_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "degreesVar"))

    @degrees_var.setter
    def degrees_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d57a3cfd56dca04a317ddf44638ef8254c6f1b4c6199dfe8475e04618ac1b1c3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "degreesVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationRotate]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationRotate]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationRotate]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f8ceb48b9db91315422e6c721939c5eb22ef26696a341e808a9d0a4fd7e0fe90)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationScale",
    jsii_struct_bases=[],
    name_mapping={
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationScale:
    def __init__(
        self,
        *,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param height: Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged. Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged. Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__936d8ea55411cebe30394e036ae881a3e36596eaba390ff6a05848e7295b21f8)
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size.

        Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size.

        Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged.

        Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged.

        Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationScale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationScaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationScaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__baf5e38bcf05d3fb9966752e262ad3211d2901247220defee9e1dc0d438c905f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationScaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d5be147606ad19a6a34b6663f0490164e84e9f29486e6e74236a52b1c07e28eb)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationScaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__28b92be9658ca558a16ff10b44fa44097d9a33cb32e190a2da349bdb99935130)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d436f2dc162d5f0ba1e169489d2be7b6b420ff5aa162f768eb259806ab83c7b9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f81bce2b557cd193c39da5c1c4ee7a9859424470c0a966e39978693f5ff710b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationScale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationScale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationScale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7803eb5ec0118375cbd2277438385c66fe540b901ca600845c65d9585809ed11)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationScaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationScaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6fab6cb3314bb0b30f1673cc6fad63e71223f1d1066f23926ea5492ad4038d55)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a41da2c6e493db9c04a9349d4ba393d72d2ce6821be2a8bca134b49ed98af2b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c6e1a0c7bec2f35a791afe47fb06b9bf55194e16d69ef2efb77b704e77de6819)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5b018dcccef4b73a233923002a50f9cbb3a0f68a02a895d69793c2919677817e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__19dc2b5255b8beac24b8e42337ba07094e7b40e82f7d13500584474c24d31db1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationScale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationScale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationScale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8cd8d7c7c180e60075792466fdf248c08488367b1c57afa6a5f2bf8b4e17f31f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationShear",
    jsii_struct_bases=[],
    name_mapping={
        "x_shear": "xShear",
        "x_shear_var": "xShearVar",
        "y_shear": "yShear",
        "y_shear_var": "yShearVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationShear:
    def __init__(
        self,
        *,
        x_shear: typing.Optional[builtins.str] = None,
        x_shear_var: typing.Optional[builtins.str] = None,
        y_shear: typing.Optional[builtins.str] = None,
        y_shear_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param x_shear: The amount to shear along the x-axis, measured in multiples of the image's width. Must be set if yShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear DataAkamaiImagingPolicyImage#x_shear}
        :param x_shear_var: The amount to shear along the x-axis, measured in multiples of the image's width. Must be set if yShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear_var DataAkamaiImagingPolicyImage#x_shear_var}
        :param y_shear: The amount to shear along the y-axis, measured in multiples of the image's height. Must be set if xShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear DataAkamaiImagingPolicyImage#y_shear}
        :param y_shear_var: The amount to shear along the y-axis, measured in multiples of the image's height. Must be set if xShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear_var DataAkamaiImagingPolicyImage#y_shear_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__513f3e5e0d55aa33e3b274bc82578c6e83cba733a5fa252c5a199d08a19c5787)
            check_type(argname="argument x_shear", value=x_shear, expected_type=type_hints["x_shear"])
            check_type(argname="argument x_shear_var", value=x_shear_var, expected_type=type_hints["x_shear_var"])
            check_type(argname="argument y_shear", value=y_shear, expected_type=type_hints["y_shear"])
            check_type(argname="argument y_shear_var", value=y_shear_var, expected_type=type_hints["y_shear_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if x_shear is not None:
            self._values["x_shear"] = x_shear
        if x_shear_var is not None:
            self._values["x_shear_var"] = x_shear_var
        if y_shear is not None:
            self._values["y_shear"] = y_shear
        if y_shear_var is not None:
            self._values["y_shear_var"] = y_shear_var

    @builtins.property
    def x_shear(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the x-axis, measured in multiples of the image's width.

        Must be set if yShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear DataAkamaiImagingPolicyImage#x_shear}
        '''
        result = self._values.get("x_shear")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_shear_var(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the x-axis, measured in multiples of the image's width.

        Must be set if yShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear_var DataAkamaiImagingPolicyImage#x_shear_var}
        '''
        result = self._values.get("x_shear_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_shear(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the y-axis, measured in multiples of the image's height.

        Must be set if xShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear DataAkamaiImagingPolicyImage#y_shear}
        '''
        result = self._values.get("y_shear")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_shear_var(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the y-axis, measured in multiples of the image's height.

        Must be set if xShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear_var DataAkamaiImagingPolicyImage#y_shear_var}
        '''
        result = self._values.get("y_shear_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationShear(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationShearList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationShearList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__67b997b2a6cbdaec7c4c9796a26543dd1fb842f846415145c6268af05469eaa5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationShearOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7584ef65f63d0e11b5f8a7cc590fb4b516e3d917f330f893f8a309c95f39be78)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationShearOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c66fb5dc7e648ab0cd9d6aff18bca4eb00bdb863cf229c40fc7688c335a310f8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__22099e64adeca7ad5c04ce96c84215a1c6c7ad98a00d52d77e46c71210558489)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c0b888f39e5d087674c38cb91b17ba5581a02aead157e57e72593a72f75d859e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationShear]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationShear]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationShear]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__75d3bdf6a1565730e19d520848baf38b9643f0374fab4807ae5cf004bc0e0715)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationShearOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationShearOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__70332c0c586ecc9d5923aa4d5a841c40c13cba33bbdd95b93efb794f8ded8fd7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetXShear")
    def reset_x_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXShear", []))

    @jsii.member(jsii_name="resetXShearVar")
    def reset_x_shear_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXShearVar", []))

    @jsii.member(jsii_name="resetYShear")
    def reset_y_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYShear", []))

    @jsii.member(jsii_name="resetYShearVar")
    def reset_y_shear_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYShearVar", []))

    @builtins.property
    @jsii.member(jsii_name="xShearInput")
    def x_shear_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xShearInput"))

    @builtins.property
    @jsii.member(jsii_name="xShearVarInput")
    def x_shear_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xShearVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yShearInput")
    def y_shear_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yShearInput"))

    @builtins.property
    @jsii.member(jsii_name="yShearVarInput")
    def y_shear_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yShearVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xShear")
    def x_shear(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xShear"))

    @x_shear.setter
    def x_shear(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b44340f4383c8956fe74d11f9c1b4e18a2ecf30e4f09671d9ac8bf06326a50ed)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xShear", value)

    @builtins.property
    @jsii.member(jsii_name="xShearVar")
    def x_shear_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xShearVar"))

    @x_shear_var.setter
    def x_shear_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a2f305d322ba62bb1ad0f431b154bd2332600129aa09ca584d18784fff6acdd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xShearVar", value)

    @builtins.property
    @jsii.member(jsii_name="yShear")
    def y_shear(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yShear"))

    @y_shear.setter
    def y_shear(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e3dae35c5fd20d420bd483688da317408419414aa03a0396ddbf48572dbdf4c0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yShear", value)

    @builtins.property
    @jsii.member(jsii_name="yShearVar")
    def y_shear_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yShearVar"))

    @y_shear_var.setter
    def y_shear_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f7ead5448fdb55ba0c65880df4979b9b5a84f1a6c536d53e742687b7edf5e7c8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yShearVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationShear]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationShear]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationShear]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a3361cae8c5154d1c69b48f25fb577fdf4b50db6f9d0d90332a4c218aff63aaa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationTrim",
    jsii_struct_bases=[],
    name_mapping={
        "fuzz": "fuzz",
        "fuzz_var": "fuzzVar",
        "padding": "padding",
        "padding_var": "paddingVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationTrim:
    def __init__(
        self,
        *,
        fuzz: typing.Optional[builtins.str] = None,
        fuzz_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fuzz: The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz DataAkamaiImagingPolicyImage#fuzz}
        :param fuzz_var: The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz_var DataAkamaiImagingPolicyImage#fuzz_var}
        :param padding: The amount of padding in pixels to add to the trimmed image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: The amount of padding in pixels to add to the trimmed image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0b6fa99f23e1c758e4dfd4c4246f5c5b08e74b3566b27ade9464abdb0cca0092)
            check_type(argname="argument fuzz", value=fuzz, expected_type=type_hints["fuzz"])
            check_type(argname="argument fuzz_var", value=fuzz_var, expected_type=type_hints["fuzz_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fuzz is not None:
            self._values["fuzz"] = fuzz
        if fuzz_var is not None:
            self._values["fuzz_var"] = fuzz_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var

    @builtins.property
    def fuzz(self) -> typing.Optional[builtins.str]:
        '''The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz DataAkamaiImagingPolicyImage#fuzz}
        '''
        result = self._values.get("fuzz")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fuzz_var(self) -> typing.Optional[builtins.str]:
        '''The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz_var DataAkamaiImagingPolicyImage#fuzz_var}
        '''
        result = self._values.get("fuzz_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''The amount of padding in pixels to add to the trimmed image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''The amount of padding in pixels to add to the trimmed image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationTrim(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationTrimList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationTrimList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__569c80cb85106347209fe1df54d2d746b1d3c28c4ea40d9b17ca28a49533ffed)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationTrimOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__255e0f56f7121d4973947be775911fb6f022814588e3db5851af41e25f6fdd7e)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationTrimOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ef6b8cdb6c2d40fc62bb11bb6a9f3d662d2900b00fb8e8a9bdb8ec31e7815712)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__969cd545b5b81b77bc58f81f7897e17f959d22faf33ee663130595eb49ce0c9a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__978d449ed23a7b29def4ef8818ed91e2e8fb4e021acd52ec0a390e0fa2f5738a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationTrim]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationTrim]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationTrim]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__09a5f712a2f1a12adb77ab35df2bcd684e9a9c3c793f34e34d88e235e2eafd78)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationTrimOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationTrimOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2b9ef8b50d060b8da87c749fada5167e453e0df4182d91cefdffb90034536b7e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetFuzz")
    def reset_fuzz(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFuzz", []))

    @jsii.member(jsii_name="resetFuzzVar")
    def reset_fuzz_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFuzzVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @builtins.property
    @jsii.member(jsii_name="fuzzInput")
    def fuzz_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fuzzInput"))

    @builtins.property
    @jsii.member(jsii_name="fuzzVarInput")
    def fuzz_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fuzzVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="fuzz")
    def fuzz(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fuzz"))

    @fuzz.setter
    def fuzz(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af3334a0050e9245acd59afd142943fc8ed591b730cbe5f7f5b59462f1c5b63d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fuzz", value)

    @builtins.property
    @jsii.member(jsii_name="fuzzVar")
    def fuzz_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fuzzVar"))

    @fuzz_var.setter
    def fuzz_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7a34402e4a7621535f1f2f9186572b56964250eccc8acb5d5d9e9e9e5728cefd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fuzzVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__45df111b087d810f81cc9391ac5decc6fc16b2915a217629f0236e69773c98b5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__413f94ee68c6df1af2251eb893250a40ba5b39b79bfe02d4ee725aaea49715fe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationTrim]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationTrim]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationTrim]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__188fd83bf17e73eee8c3f6070a099e0a2292fc6410904c3131e039038d8bac56)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationUnsharpMask",
    jsii_struct_bases=[],
    name_mapping={
        "gain": "gain",
        "gain_var": "gainVar",
        "sigma": "sigma",
        "sigma_var": "sigmaVar",
        "threshold": "threshold",
        "threshold_var": "thresholdVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationUnsharpMask:
    def __init__(
        self,
        *,
        gain: typing.Optional[builtins.str] = None,
        gain_var: typing.Optional[builtins.str] = None,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
        threshold: typing.Optional[builtins.str] = None,
        threshold_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param gain: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        :param gain_var: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        :param sigma: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        :param threshold: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        :param threshold_var: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b4226d4a2a9d08cf8373bb59e746ad4ba784dd6ea059fb8c51606fb523da7ec7)
            check_type(argname="argument gain", value=gain, expected_type=type_hints["gain"])
            check_type(argname="argument gain_var", value=gain_var, expected_type=type_hints["gain_var"])
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
            check_type(argname="argument threshold", value=threshold, expected_type=type_hints["threshold"])
            check_type(argname="argument threshold_var", value=threshold_var, expected_type=type_hints["threshold_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if gain is not None:
            self._values["gain"] = gain
        if gain_var is not None:
            self._values["gain_var"] = gain_var
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var
        if threshold is not None:
            self._values["threshold"] = threshold
        if threshold_var is not None:
            self._values["threshold_var"] = threshold_var

    @builtins.property
    def gain(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        '''
        result = self._values.get("gain")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gain_var(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        '''
        result = self._values.get("gain_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        '''
        result = self._values.get("threshold")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold_var(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        result = self._values.get("threshold_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationUnsharpMask(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationUnsharpMaskList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationUnsharpMaskList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__09ff4b1642ca2b08a7ddc1a696f0e8a5ed8a81f9b5646bc665ee2c0cb22ce3a6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationUnsharpMaskOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a5a0a9dec1dfe6f06ed7138a4d63a446cd3ec5fecd7f28ddbb779b6334251492)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationUnsharpMaskOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f1eae13ceaa38201c4d2163fb17e1b868654aed838d1e2d1cd080f8973a74196)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ecb5acbd513e436ba7eb1e3a267cbfc364271277dda568499bdb8040fd1e452)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1a6e6d266e59580246933087e83100c09cc2626c172cb0de0ac4c26ed2f27fbd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationUnsharpMask]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationUnsharpMask]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationUnsharpMask]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6baf23668ef7f5f32c5763ec985fb40a72775ab5fa7a8923be650d509590d1fe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationUnsharpMaskOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationUnsharpMaskOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__062c015e1c11360c0255d5d769eb09b465a9f972ed23b98d5d7976295d446295)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetGain")
    def reset_gain(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGain", []))

    @jsii.member(jsii_name="resetGainVar")
    def reset_gain_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGainVar", []))

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @jsii.member(jsii_name="resetThreshold")
    def reset_threshold(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThreshold", []))

    @jsii.member(jsii_name="resetThresholdVar")
    def reset_threshold_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThresholdVar", []))

    @builtins.property
    @jsii.member(jsii_name="gainInput")
    def gain_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainInput"))

    @builtins.property
    @jsii.member(jsii_name="gainVarInput")
    def gain_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdInput")
    def threshold_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdVarInput")
    def threshold_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gain")
    def gain(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gain"))

    @gain.setter
    def gain(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__806dfe8d2f408dad822acb99962eba5f703cbcb3d9fb3962c51f172a560e85fc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gain", value)

    @builtins.property
    @jsii.member(jsii_name="gainVar")
    def gain_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gainVar"))

    @gain_var.setter
    def gain_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__442403cf3cd4f9d3651f4eec047d5ecf53501456e456da1f54ae76b5a23f59a2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gainVar", value)

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__77b6eed7c21c1bbe8d6a6b7fe0d978da64b3257d772856e64ec0c5fbf050dac5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bded2df90994fe157d84a34f75548df67f548caeda5528eb3be996289782e07c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="threshold")
    def threshold(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "threshold"))

    @threshold.setter
    def threshold(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__523e332ebc653383a448bea1d050d9f24221dad8b40f67908f9fe67f6e2004bd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "threshold", value)

    @builtins.property
    @jsii.member(jsii_name="thresholdVar")
    def threshold_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "thresholdVar"))

    @threshold_var.setter
    def threshold_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fac549b54b9e868508d4d67d107504ec568c9953a00e5476ffe71c702b497244)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "thresholdVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationUnsharpMask]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationUnsharpMask]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationUnsharpMask]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6c0bb6efba68e313e2e1071f42560f009bd233e5312808cacee9e17329b4e883)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fc2d7bb06601a0e0e258f36d62a1ff4ce83641d54e7236309f3158e80c1b45c6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f994042cf77acd3f34cd16f7b794e5f0ccb9299a7128e4afc07693fc2c059bde)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__602fd2962de9ddfa68c9bdece1be5fa0e597ac21be148ef57340172f8bca2518)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ccd1e96c6109df377ac2e707a6cae54675e7f605e9eaa714296381fecd92f6af)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__39d8154eaf122c5d30560b27fbcfef37c41bb453475401550ec664a4e3b7f675)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFill]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFill]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFill]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d74e507ea4ad71c839c3f1aec025e84a7d63863f3afcf6f8c06cae5b39f4c45c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__41b4849dba029947f0a259cab403289f670179a35c6765c05d6ec63fcac8a850)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putFillTransformation")
    def put_fill_transformation(
        self,
        *,
        append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationAppend, typing.Dict[builtins.str, typing.Any]]]]] = None,
        aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationAspectCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
        crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationFaceCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationFeatureCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationFitAndFill, typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
        im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationImQuery, typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
        region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationRegionOfInterestCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationRelativeCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
        resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationResize, typing.Dict[builtins.str, typing.Any]]]]] = None,
        rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationRotate, typing.Dict[builtins.str, typing.Any]]]]] = None,
        scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationScale, typing.Dict[builtins.str, typing.Any]]]]] = None,
        shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationShear, typing.Dict[builtins.str, typing.Any]]]]] = None,
        trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationTrim, typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param append: append block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        :param aspect_crop: aspect_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param crop: crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        :param face_crop: face_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        :param feature_crop: feature_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        :param fit_and_fill: fit_and_fill block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param im_query: im_query block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param region_of_interest_crop: region_of_interest_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        :param relative_crop: relative_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param resize: resize block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        :param rotate: rotate block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        :param scale: scale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param shear: shear block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        :param trim: trim block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformation(
            append=append,
            aspect_crop=aspect_crop,
            background_color=background_color,
            blur=blur,
            chroma_key=chroma_key,
            composite=composite,
            compound=compound,
            contrast=contrast,
            crop=crop,
            face_crop=face_crop,
            feature_crop=feature_crop,
            fit_and_fill=fit_and_fill,
            goop=goop,
            grayscale=grayscale,
            hsl=hsl,
            hsv=hsv,
            if_dimension=if_dimension,
            if_orientation=if_orientation,
            im_query=im_query,
            max_colors=max_colors,
            mirror=mirror,
            mono_hue=mono_hue,
            opacity=opacity,
            region_of_interest_crop=region_of_interest_crop,
            relative_crop=relative_crop,
            remove_color=remove_color,
            resize=resize,
            rotate=rotate,
            scale=scale,
            shear=shear,
            trim=trim,
            unsharp_mask=unsharp_mask,
        )

        return typing.cast(None, jsii.invoke(self, "putFillTransformation", [value]))

    @jsii.member(jsii_name="resetFillTransformation")
    def reset_fill_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFillTransformation", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="fillTransformation")
    def fill_transformation(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationOutputReference, jsii.get(self, "fillTransformation"))

    @builtins.property
    @jsii.member(jsii_name="fillTransformationInput")
    def fill_transformation_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformation], jsii.get(self, "fillTransformationInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7094c5ce59eb181c3dd3f180ea7b84d1a9c69d4cf91f19d2dafe57db468cc8d6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5497c9b868dc8534af55bfe87998a190759c47c7626b66e0d57a9eb4c3bb72d1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__474064c76c85bf97f4f333cd556ac54f22e4fe6d6a42284588c0c3a98da83a07)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c3f6041efa9d0cca3ea368da10db59cb628e64d26a7894b4ab4d1c4e54ca302b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFill]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFill]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFill]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2875d66142adae8f2629091e0c6fd301ab595de4170ce6968744c26533fdbce0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultGoop",
    jsii_struct_bases=[],
    name_mapping={
        "chaos": "chaos",
        "chaos_var": "chaosVar",
        "density": "density",
        "density_var": "densityVar",
        "power": "power",
        "power_var": "powerVar",
        "seed": "seed",
        "seed_var": "seedVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultGoop:
    def __init__(
        self,
        *,
        chaos: typing.Optional[builtins.str] = None,
        chaos_var: typing.Optional[builtins.str] = None,
        density: typing.Optional[builtins.str] = None,
        density_var: typing.Optional[builtins.str] = None,
        power: typing.Optional[builtins.str] = None,
        power_var: typing.Optional[builtins.str] = None,
        seed: typing.Optional[builtins.str] = None,
        seed_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param chaos: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        :param chaos_var: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        :param density: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        :param density_var: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        :param power: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        :param power_var: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        :param seed: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        :param seed_var: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d249df862660bcdf094fa8c33d2ef0684f7bb6d3d5fa118264d37a512c4370e4)
            check_type(argname="argument chaos", value=chaos, expected_type=type_hints["chaos"])
            check_type(argname="argument chaos_var", value=chaos_var, expected_type=type_hints["chaos_var"])
            check_type(argname="argument density", value=density, expected_type=type_hints["density"])
            check_type(argname="argument density_var", value=density_var, expected_type=type_hints["density_var"])
            check_type(argname="argument power", value=power, expected_type=type_hints["power"])
            check_type(argname="argument power_var", value=power_var, expected_type=type_hints["power_var"])
            check_type(argname="argument seed", value=seed, expected_type=type_hints["seed"])
            check_type(argname="argument seed_var", value=seed_var, expected_type=type_hints["seed_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if chaos is not None:
            self._values["chaos"] = chaos
        if chaos_var is not None:
            self._values["chaos_var"] = chaos_var
        if density is not None:
            self._values["density"] = density
        if density_var is not None:
            self._values["density_var"] = density_var
        if power is not None:
            self._values["power"] = power
        if power_var is not None:
            self._values["power_var"] = power_var
        if seed is not None:
            self._values["seed"] = seed
        if seed_var is not None:
            self._values["seed_var"] = seed_var

    @builtins.property
    def chaos(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        '''
        result = self._values.get("chaos")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def chaos_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        '''
        result = self._values.get("chaos_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        '''
        result = self._values.get("density")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density_var(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        '''
        result = self._values.get("density_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        '''
        result = self._values.get("power")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power_var(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        '''
        result = self._values.get("power_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        '''
        result = self._values.get("seed")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed_var(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        result = self._values.get("seed_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultGoop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultGoopList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultGoopList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__97467b2d27fb740734e36ab6e0ca08175f0d8984715e1e8358d775c959ba4631)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultGoopOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__54578cf7379ecc86936c9a5f9cc872e4eda9bab792d0a24aa14ba172f6142845)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultGoopOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5a2a0d5ba46177ce0eaafa42585a60e62545876b014b056d27680ebffb33a80d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a3d7f95bf5d55c48f19f170628dff25d2e2f2e545f23e345815bbe4226fe5e88)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5bf15d2f3eb6adf68c7059ac05f35bdf7ef3168783f170fad68fb0c8c1ff942f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultGoop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultGoop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d0a79058bed4c980a891fc927a54a5511ab9162cfab951c153f48dc8ce7fbcb3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultGoopOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultGoopOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f444d564ea764107442ea50c519172263f95852921dfb71f1bb48f650f50cbea)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetChaos")
    def reset_chaos(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaos", []))

    @jsii.member(jsii_name="resetChaosVar")
    def reset_chaos_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaosVar", []))

    @jsii.member(jsii_name="resetDensity")
    def reset_density(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensity", []))

    @jsii.member(jsii_name="resetDensityVar")
    def reset_density_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensityVar", []))

    @jsii.member(jsii_name="resetPower")
    def reset_power(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPower", []))

    @jsii.member(jsii_name="resetPowerVar")
    def reset_power_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPowerVar", []))

    @jsii.member(jsii_name="resetSeed")
    def reset_seed(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeed", []))

    @jsii.member(jsii_name="resetSeedVar")
    def reset_seed_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeedVar", []))

    @builtins.property
    @jsii.member(jsii_name="chaosInput")
    def chaos_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosInput"))

    @builtins.property
    @jsii.member(jsii_name="chaosVarInput")
    def chaos_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosVarInput"))

    @builtins.property
    @jsii.member(jsii_name="densityInput")
    def density_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityInput"))

    @builtins.property
    @jsii.member(jsii_name="densityVarInput")
    def density_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="powerInput")
    def power_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerInput"))

    @builtins.property
    @jsii.member(jsii_name="powerVarInput")
    def power_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerVarInput"))

    @builtins.property
    @jsii.member(jsii_name="seedInput")
    def seed_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedInput"))

    @builtins.property
    @jsii.member(jsii_name="seedVarInput")
    def seed_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedVarInput"))

    @builtins.property
    @jsii.member(jsii_name="chaos")
    def chaos(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaos"))

    @chaos.setter
    def chaos(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b943a89641a57fb80529e1ec36f4780f85809347609be3307544efee1dc08fbb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaos", value)

    @builtins.property
    @jsii.member(jsii_name="chaosVar")
    def chaos_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaosVar"))

    @chaos_var.setter
    def chaos_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__450be9e2d149685c950f85ab94047d75972edcf19b2eb43992264c2b3eeac67e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaosVar", value)

    @builtins.property
    @jsii.member(jsii_name="density")
    def density(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "density"))

    @density.setter
    def density(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1752c4c43afcb9c73cd800ce42e12e08ba0db468d29fa42bf778de5a38511465)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "density", value)

    @builtins.property
    @jsii.member(jsii_name="densityVar")
    def density_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "densityVar"))

    @density_var.setter
    def density_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6d19edc202f74c8fc083ac026065f9372661f39318d362019f818520fe69c1d2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "densityVar", value)

    @builtins.property
    @jsii.member(jsii_name="power")
    def power(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "power"))

    @power.setter
    def power(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3e583f705aebd742fd0c077f49f52c0dd84a59ed54d2ded163dd00e150cbdb28)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "power", value)

    @builtins.property
    @jsii.member(jsii_name="powerVar")
    def power_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "powerVar"))

    @power_var.setter
    def power_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__09179dd40aff42331bac3e06ab29af2ad1cb8784e53d8e7076754513ce044857)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "powerVar", value)

    @builtins.property
    @jsii.member(jsii_name="seed")
    def seed(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seed"))

    @seed.setter
    def seed(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__355e3ef8a70570962ad9ffc068b72f07aa29072ec3de93e2d9af92b1a8f36cca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seed", value)

    @builtins.property
    @jsii.member(jsii_name="seedVar")
    def seed_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seedVar"))

    @seed_var.setter
    def seed_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e968621ca44b6504d41d6764663d710201208509205242061d40c57a49c5e7f5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seedVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultGoop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultGoop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultGoop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__27547369164a2a89b37bfc633c5ce280ddee65ecbd812a342801695b0f896e7e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultGrayscale",
    jsii_struct_bases=[],
    name_mapping={"type": "type", "type_var": "typeVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultGrayscale:
    def __init__(
        self,
        *,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param type: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d3b719939b832b36eae4973b0b3b3d71541aabf229ed9315a9b4b450cadfbd37)
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultGrayscale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultGrayscaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultGrayscaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fe32e047155b86c7056b7b0eeb3590a2b31194c40dc783f177856af64c055272)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultGrayscaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f22b88b29bdbb199b27ce033d28dffe09a51638c16f421a10a25391c3b0b99f5)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultGrayscaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f4f856e401c39ec73573504ad8578d56cbd6ad1904a4bfd00b555f6c9a6e3878)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6571a28b9cba81be311c649df9d89415ec4088bae4d5066c57d4b4e16081ac43)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea7652ef6d8b2159fc3eb2c61f3daef282c6facaf2abe67907274ef3985c2578)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultGrayscale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultGrayscale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb81d5091a7fddf1a677f76f8efe2603b0046e6853a4d998db7ad2e0c28a6aea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultGrayscaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultGrayscaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c57338ed88701f2ab595aa0241214133ac5374623bb6f8219a05e0d957b190e7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3793f921245c6747004aed17f0ecc5da4f4ae4f82694640fe14a3aac98ccd4d0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__923c014285734d6525ad573b31bd35760996855a71c5bd7718d6b1dd3b5daa99)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultGrayscale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultGrayscale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultGrayscale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a062e88897981ed4ee229980e22a733adf4d0fc75a1cfeca07a25694432e38e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultHsl",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "lightness": "lightness",
        "lightness_var": "lightnessVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultHsl:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness: typing.Optional[builtins.str] = None,
        lightness_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        :param lightness_var: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__db3c59a170a6c6c49cf1326f17cf44420ab40bc1e4d3808775b63a79e8ffe25c)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness", value=lightness, expected_type=type_hints["lightness"])
            check_type(argname="argument lightness_var", value=lightness_var, expected_type=type_hints["lightness_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness is not None:
            self._values["lightness"] = lightness
        if lightness_var is not None:
            self._values["lightness_var"] = lightness_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        '''
        result = self._values.get("lightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        '''
        result = self._values.get("lightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultHsl(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultHslList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultHslList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fc14fc7dde8224d7d84b0f2c3ce1c0c2cfc6acbdb2b6793f593a15479273932b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultHslOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d093bb8b99263ade271f5085b2a9983554b9b591df0d27d54c9b674aaef0aeff)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultHslOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4f7d15818b442978a10f56652bb9fbe563bb77699ef9d0dcdb2eb9324dfc1276)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5392944e38fe4bcdb71ac018add276505c3cb1e171fdc4744e24385e59f958da)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__66ff4790b1f3a0bb161f40e5438134b9726e16e96d5d7836aaeef2c2d151accd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultHsl]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultHsl]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__daaeb934ed867aca07436a69a50eb49c8ead23e9f47ffc9acee8f4625c3bad2d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultHslOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultHslOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6690d11a80b9640612f4f1b3d6cb586a0088ae7e7a29353c4642fd9cebab3f46)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightness")
    def reset_lightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightness", []))

    @jsii.member(jsii_name="resetLightnessVar")
    def reset_lightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessInput")
    def lightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessVarInput")
    def lightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8d1d0ac890ce907a89cec1f27bce70cb57d6b0af0af65d55ba6d012f88bc9ab1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9b52d219bb40b468bb88546c1fcd9957c180ddda00f851e5e0e55f04e7390744)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightness")
    def lightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightness"))

    @lightness.setter
    def lightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eea6bd8a8080c4f6d3a396acc4182c548051385d84683318f92ffa1317c2d450)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightness", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessVar")
    def lightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessVar"))

    @lightness_var.setter
    def lightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__67f3dcb72216ee84be790828c55accb59e40158ce7727dd8b114dbefd90e7a01)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a316ce493d793445f5ece2f782e96d6ea69fa9627bc6cecf0760ffc1f5ffbe9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f735010bfbce684802bf8969a495b367ca5c02294e688e32c6bade4f0ab56ab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultHsl]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultHsl]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultHsl]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a29d04f050d07da5589a43da50a4c7a016e9ccff67e055cc2b0c2cd30df1f68)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultHsv",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultHsv:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        :param value: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0c51d86e919326e4f95d3d4be34efa202ff8a51270181096ad7123692a5eed6a)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultHsv(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultHsvList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultHsvList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__40dca738bdba9ff6bb225632444480e612d3aced6eae309158b507bdab6277a1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultHsvOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7dcd2395cbe515458a01a3f645d9e89fd74bda2853494a6e4ee8b1658bf53d24)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultHsvOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0afe87f9d2455d74d8cf0caebd5ce634ece5f95c616516c0857ab5cff64481e4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c36db6f96ffbdc0500fdcbc24b7d1b30183bc16519b46f6a0ee2353dbffa67e3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b317abb494b0bf18700afd5df30c21f38fa8107f115e77d8761abc6a199b2ad8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultHsv]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultHsv]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b0c37e284279da4325ebb796a7f0cf80ffdbc36728044dfa4bde17d5a9691c5d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultHsvOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultHsvOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a46a901808f13e4362987325a1023cd2da107b7ae8e9c5a956adefe2b06d0640)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__29c0e7c020f0b47a55eff656b788f298419947a0454a33dd46baf1f675b64e28)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6b296e64531445c0f97e15863416ac8870e92a2c2a894117b638e0747fedcd7e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4d08ffa887329145e35e66e344dbdc6b63964beef0d70e889fafd163ad93fd56)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__36ef902fc049b045cc3c9ed1834e93dbcb6ae79c6d9744a8048cb5268e54e585)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__539ea12f794a24f0723c901c8b1f1b2a681998464a6da409ca5eeb045e885ae2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ff89d0c90bd8e8aacbbf471fce95f66b5f5957de132e7b36cc0f3cadb2e732f5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultHsv]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultHsv]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultHsv]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__462e611598f5cb04588c7e68ec53d6760a732d354edb96a5f00802d78cf2f314)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientation",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "landscape": "landscape",
        "portrait": "portrait",
        "square": "square",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientation:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefault, typing.Dict[builtins.str, typing.Any]]] = None,
        landscape: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscape", typing.Dict[builtins.str, typing.Any]]] = None,
        portrait: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortrait", typing.Dict[builtins.str, typing.Any]]] = None,
        square: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquare", typing.Dict[builtins.str, typing.Any]]] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param landscape: landscape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        :param portrait: portrait block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        :param square: square block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefault(**default)
        if isinstance(landscape, dict):
            landscape = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscape(**landscape)
        if isinstance(portrait, dict):
            portrait = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortrait(**portrait)
        if isinstance(square, dict):
            square = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquare(**square)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a02200a25a2817021c1ff0078454637b20d056848eb7bbd3abfd34f32d639532)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument landscape", value=landscape, expected_type=type_hints["landscape"])
            check_type(argname="argument portrait", value=portrait, expected_type=type_hints["portrait"])
            check_type(argname="argument square", value=square, expected_type=type_hints["square"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if landscape is not None:
            self._values["landscape"] = landscape
        if portrait is not None:
            self._values["portrait"] = portrait
        if square is not None:
            self._values["square"] = square

    @builtins.property
    def default(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefault]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefault], result)

    @builtins.property
    def landscape(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscape"]:
        '''landscape block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        '''
        result = self._values.get("landscape")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscape"], result)

    @builtins.property
    def portrait(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortrait"]:
        '''portrait block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        '''
        result = self._values.get("portrait")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortrait"], result)

    @builtins.property
    def square(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquare"]:
        '''square block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        result = self._values.get("square")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquare"], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscape",
    jsii_struct_bases=[],
    name_mapping={
        "append": "append",
        "aspect_crop": "aspectCrop",
        "background_color": "backgroundColor",
        "blur": "blur",
        "chroma_key": "chromaKey",
        "composite": "composite",
        "compound": "compound",
        "contrast": "contrast",
        "crop": "crop",
        "face_crop": "faceCrop",
        "feature_crop": "featureCrop",
        "fit_and_fill": "fitAndFill",
        "goop": "goop",
        "grayscale": "grayscale",
        "hsl": "hsl",
        "hsv": "hsv",
        "if_dimension": "ifDimension",
        "if_orientation": "ifOrientation",
        "im_query": "imQuery",
        "max_colors": "maxColors",
        "mirror": "mirror",
        "mono_hue": "monoHue",
        "opacity": "opacity",
        "region_of_interest_crop": "regionOfInterestCrop",
        "relative_crop": "relativeCrop",
        "remove_color": "removeColor",
        "resize": "resize",
        "rotate": "rotate",
        "scale": "scale",
        "shear": "shear",
        "trim": "trim",
        "unsharp_mask": "unsharpMask",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscape:
    def __init__(
        self,
        *,
        append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeAppend", typing.Dict[builtins.str, typing.Any]]]]] = None,
        aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeAspectCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeBackgroundColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeBlur", typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeChromaKey", typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeComposite", typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeCompound", typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeContrast", typing.Dict[builtins.str, typing.Any]]]]] = None,
        crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeFaceCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeFeatureCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeFitAndFill", typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeGoop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeGrayscale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeHsl", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeHsv", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimension", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientation", typing.Dict[builtins.str, typing.Any]]]]] = None,
        im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeImQuery", typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeMaxColors", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeMirror", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeMonoHue", typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeOpacity", typing.Dict[builtins.str, typing.Any]]]]] = None,
        region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeRegionOfInterestCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeRelativeCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeRemoveColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeResize", typing.Dict[builtins.str, typing.Any]]]]] = None,
        rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeRotate", typing.Dict[builtins.str, typing.Any]]]]] = None,
        scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeScale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeShear", typing.Dict[builtins.str, typing.Any]]]]] = None,
        trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeTrim", typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeUnsharpMask", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param append: append block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        :param aspect_crop: aspect_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param crop: crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        :param face_crop: face_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        :param feature_crop: feature_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        :param fit_and_fill: fit_and_fill block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param im_query: im_query block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param region_of_interest_crop: region_of_interest_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        :param relative_crop: relative_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param resize: resize block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        :param rotate: rotate block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        :param scale: scale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param shear: shear block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        :param trim: trim block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__75765bf535b7e6cfc8ac9485a9539f881152fda882376c985a3bb64f1c512dc7)
            check_type(argname="argument append", value=append, expected_type=type_hints["append"])
            check_type(argname="argument aspect_crop", value=aspect_crop, expected_type=type_hints["aspect_crop"])
            check_type(argname="argument background_color", value=background_color, expected_type=type_hints["background_color"])
            check_type(argname="argument blur", value=blur, expected_type=type_hints["blur"])
            check_type(argname="argument chroma_key", value=chroma_key, expected_type=type_hints["chroma_key"])
            check_type(argname="argument composite", value=composite, expected_type=type_hints["composite"])
            check_type(argname="argument compound", value=compound, expected_type=type_hints["compound"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument crop", value=crop, expected_type=type_hints["crop"])
            check_type(argname="argument face_crop", value=face_crop, expected_type=type_hints["face_crop"])
            check_type(argname="argument feature_crop", value=feature_crop, expected_type=type_hints["feature_crop"])
            check_type(argname="argument fit_and_fill", value=fit_and_fill, expected_type=type_hints["fit_and_fill"])
            check_type(argname="argument goop", value=goop, expected_type=type_hints["goop"])
            check_type(argname="argument grayscale", value=grayscale, expected_type=type_hints["grayscale"])
            check_type(argname="argument hsl", value=hsl, expected_type=type_hints["hsl"])
            check_type(argname="argument hsv", value=hsv, expected_type=type_hints["hsv"])
            check_type(argname="argument if_dimension", value=if_dimension, expected_type=type_hints["if_dimension"])
            check_type(argname="argument if_orientation", value=if_orientation, expected_type=type_hints["if_orientation"])
            check_type(argname="argument im_query", value=im_query, expected_type=type_hints["im_query"])
            check_type(argname="argument max_colors", value=max_colors, expected_type=type_hints["max_colors"])
            check_type(argname="argument mirror", value=mirror, expected_type=type_hints["mirror"])
            check_type(argname="argument mono_hue", value=mono_hue, expected_type=type_hints["mono_hue"])
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument region_of_interest_crop", value=region_of_interest_crop, expected_type=type_hints["region_of_interest_crop"])
            check_type(argname="argument relative_crop", value=relative_crop, expected_type=type_hints["relative_crop"])
            check_type(argname="argument remove_color", value=remove_color, expected_type=type_hints["remove_color"])
            check_type(argname="argument resize", value=resize, expected_type=type_hints["resize"])
            check_type(argname="argument rotate", value=rotate, expected_type=type_hints["rotate"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument shear", value=shear, expected_type=type_hints["shear"])
            check_type(argname="argument trim", value=trim, expected_type=type_hints["trim"])
            check_type(argname="argument unsharp_mask", value=unsharp_mask, expected_type=type_hints["unsharp_mask"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if append is not None:
            self._values["append"] = append
        if aspect_crop is not None:
            self._values["aspect_crop"] = aspect_crop
        if background_color is not None:
            self._values["background_color"] = background_color
        if blur is not None:
            self._values["blur"] = blur
        if chroma_key is not None:
            self._values["chroma_key"] = chroma_key
        if composite is not None:
            self._values["composite"] = composite
        if compound is not None:
            self._values["compound"] = compound
        if contrast is not None:
            self._values["contrast"] = contrast
        if crop is not None:
            self._values["crop"] = crop
        if face_crop is not None:
            self._values["face_crop"] = face_crop
        if feature_crop is not None:
            self._values["feature_crop"] = feature_crop
        if fit_and_fill is not None:
            self._values["fit_and_fill"] = fit_and_fill
        if goop is not None:
            self._values["goop"] = goop
        if grayscale is not None:
            self._values["grayscale"] = grayscale
        if hsl is not None:
            self._values["hsl"] = hsl
        if hsv is not None:
            self._values["hsv"] = hsv
        if if_dimension is not None:
            self._values["if_dimension"] = if_dimension
        if if_orientation is not None:
            self._values["if_orientation"] = if_orientation
        if im_query is not None:
            self._values["im_query"] = im_query
        if max_colors is not None:
            self._values["max_colors"] = max_colors
        if mirror is not None:
            self._values["mirror"] = mirror
        if mono_hue is not None:
            self._values["mono_hue"] = mono_hue
        if opacity is not None:
            self._values["opacity"] = opacity
        if region_of_interest_crop is not None:
            self._values["region_of_interest_crop"] = region_of_interest_crop
        if relative_crop is not None:
            self._values["relative_crop"] = relative_crop
        if remove_color is not None:
            self._values["remove_color"] = remove_color
        if resize is not None:
            self._values["resize"] = resize
        if rotate is not None:
            self._values["rotate"] = rotate
        if scale is not None:
            self._values["scale"] = scale
        if shear is not None:
            self._values["shear"] = shear
        if trim is not None:
            self._values["trim"] = trim
        if unsharp_mask is not None:
            self._values["unsharp_mask"] = unsharp_mask

    @builtins.property
    def append(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeAppend"]]]:
        '''append block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        '''
        result = self._values.get("append")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeAppend"]]], result)

    @builtins.property
    def aspect_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeAspectCrop"]]]:
        '''aspect_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        '''
        result = self._values.get("aspect_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeAspectCrop"]]], result)

    @builtins.property
    def background_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeBackgroundColor"]]]:
        '''background_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        '''
        result = self._values.get("background_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeBackgroundColor"]]], result)

    @builtins.property
    def blur(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeBlur"]]]:
        '''blur block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        '''
        result = self._values.get("blur")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeBlur"]]], result)

    @builtins.property
    def chroma_key(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeChromaKey"]]]:
        '''chroma_key block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        '''
        result = self._values.get("chroma_key")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeChromaKey"]]], result)

    @builtins.property
    def composite(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeComposite"]]]:
        '''composite block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        '''
        result = self._values.get("composite")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeComposite"]]], result)

    @builtins.property
    def compound(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeCompound"]]]:
        '''compound block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        '''
        result = self._values.get("compound")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeCompound"]]], result)

    @builtins.property
    def contrast(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeContrast"]]]:
        '''contrast block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeContrast"]]], result)

    @builtins.property
    def crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeCrop"]]]:
        '''crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        '''
        result = self._values.get("crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeCrop"]]], result)

    @builtins.property
    def face_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeFaceCrop"]]]:
        '''face_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        '''
        result = self._values.get("face_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeFaceCrop"]]], result)

    @builtins.property
    def feature_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeFeatureCrop"]]]:
        '''feature_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        '''
        result = self._values.get("feature_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeFeatureCrop"]]], result)

    @builtins.property
    def fit_and_fill(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeFitAndFill"]]]:
        '''fit_and_fill block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        '''
        result = self._values.get("fit_and_fill")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeFitAndFill"]]], result)

    @builtins.property
    def goop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeGoop"]]]:
        '''goop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        '''
        result = self._values.get("goop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeGoop"]]], result)

    @builtins.property
    def grayscale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeGrayscale"]]]:
        '''grayscale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        '''
        result = self._values.get("grayscale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeGrayscale"]]], result)

    @builtins.property
    def hsl(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeHsl"]]]:
        '''hsl block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        '''
        result = self._values.get("hsl")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeHsl"]]], result)

    @builtins.property
    def hsv(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeHsv"]]]:
        '''hsv block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        '''
        result = self._values.get("hsv")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeHsv"]]], result)

    @builtins.property
    def if_dimension(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimension"]]]:
        '''if_dimension block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        '''
        result = self._values.get("if_dimension")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimension"]]], result)

    @builtins.property
    def if_orientation(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientation"]]]:
        '''if_orientation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        '''
        result = self._values.get("if_orientation")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientation"]]], result)

    @builtins.property
    def im_query(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeImQuery"]]]:
        '''im_query block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        '''
        result = self._values.get("im_query")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeImQuery"]]], result)

    @builtins.property
    def max_colors(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeMaxColors"]]]:
        '''max_colors block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        '''
        result = self._values.get("max_colors")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeMaxColors"]]], result)

    @builtins.property
    def mirror(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeMirror"]]]:
        '''mirror block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        '''
        result = self._values.get("mirror")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeMirror"]]], result)

    @builtins.property
    def mono_hue(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeMonoHue"]]]:
        '''mono_hue block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        '''
        result = self._values.get("mono_hue")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeMonoHue"]]], result)

    @builtins.property
    def opacity(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeOpacity"]]]:
        '''opacity block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeOpacity"]]], result)

    @builtins.property
    def region_of_interest_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeRegionOfInterestCrop"]]]:
        '''region_of_interest_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        '''
        result = self._values.get("region_of_interest_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeRegionOfInterestCrop"]]], result)

    @builtins.property
    def relative_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeRelativeCrop"]]]:
        '''relative_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        '''
        result = self._values.get("relative_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeRelativeCrop"]]], result)

    @builtins.property
    def remove_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeRemoveColor"]]]:
        '''remove_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        '''
        result = self._values.get("remove_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeRemoveColor"]]], result)

    @builtins.property
    def resize(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeResize"]]]:
        '''resize block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        '''
        result = self._values.get("resize")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeResize"]]], result)

    @builtins.property
    def rotate(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeRotate"]]]:
        '''rotate block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        '''
        result = self._values.get("rotate")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeRotate"]]], result)

    @builtins.property
    def scale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeScale"]]]:
        '''scale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeScale"]]], result)

    @builtins.property
    def shear(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeShear"]]]:
        '''shear block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        '''
        result = self._values.get("shear")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeShear"]]], result)

    @builtins.property
    def trim(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeTrim"]]]:
        '''trim block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        '''
        result = self._values.get("trim")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeTrim"]]], result)

    @builtins.property
    def unsharp_mask(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeUnsharpMask"]]]:
        '''unsharp_mask block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        result = self._values.get("unsharp_mask")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeUnsharpMask"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscape(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeAppend",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_priority": "gravityPriority",
        "gravity_priority_var": "gravityPriorityVar",
        "gravity_var": "gravityVar",
        "preserve_minor_dimension": "preserveMinorDimension",
        "preserve_minor_dimension_var": "preserveMinorDimensionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeAppend:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeAppendImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_priority: typing.Optional[builtins.str] = None,
        gravity_priority_var: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        preserve_minor_dimension: typing.Optional[builtins.str] = None,
        preserve_minor_dimension_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Specifies where to place the ``image`` relative to the source image. The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_priority: Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal. The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority DataAkamaiImagingPolicyImage#gravity_priority}
        :param gravity_priority_var: Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal. The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority_var DataAkamaiImagingPolicyImage#gravity_priority_var}
        :param gravity_var: Specifies where to place the ``image`` relative to the source image. The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param preserve_minor_dimension: Whether to preserve the source image's minor dimension, ``false`` by default. The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension DataAkamaiImagingPolicyImage#preserve_minor_dimension}
        :param preserve_minor_dimension_var: Whether to preserve the source image's minor dimension, ``false`` by default. The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension_var DataAkamaiImagingPolicyImage#preserve_minor_dimension_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeAppendImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d4c5a6f0b47abf5298e123e37e39a915a6705386cfbffc2c635196d5c9bba1f6)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_priority", value=gravity_priority, expected_type=type_hints["gravity_priority"])
            check_type(argname="argument gravity_priority_var", value=gravity_priority_var, expected_type=type_hints["gravity_priority_var"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument preserve_minor_dimension", value=preserve_minor_dimension, expected_type=type_hints["preserve_minor_dimension"])
            check_type(argname="argument preserve_minor_dimension_var", value=preserve_minor_dimension_var, expected_type=type_hints["preserve_minor_dimension_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_priority is not None:
            self._values["gravity_priority"] = gravity_priority
        if gravity_priority_var is not None:
            self._values["gravity_priority_var"] = gravity_priority_var
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if preserve_minor_dimension is not None:
            self._values["preserve_minor_dimension"] = preserve_minor_dimension
        if preserve_minor_dimension_var is not None:
            self._values["preserve_minor_dimension_var"] = preserve_minor_dimension_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeAppendImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeAppendImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Specifies where to place the ``image`` relative to the source image.

        The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_priority(self) -> typing.Optional[builtins.str]:
        '''Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal.

        The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority DataAkamaiImagingPolicyImage#gravity_priority}
        '''
        result = self._values.get("gravity_priority")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_priority_var(self) -> typing.Optional[builtins.str]:
        '''Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal.

        The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority_var DataAkamaiImagingPolicyImage#gravity_priority_var}
        '''
        result = self._values.get("gravity_priority_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Specifies where to place the ``image`` relative to the source image.

        The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def preserve_minor_dimension(self) -> typing.Optional[builtins.str]:
        '''Whether to preserve the source image's minor dimension, ``false`` by default.

        The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension DataAkamaiImagingPolicyImage#preserve_minor_dimension}
        '''
        result = self._values.get("preserve_minor_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def preserve_minor_dimension_var(self) -> typing.Optional[builtins.str]:
        '''Whether to preserve the source image's minor dimension, ``false`` by default.

        The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension_var DataAkamaiImagingPolicyImage#preserve_minor_dimension_var}
        '''
        result = self._values.get("preserve_minor_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeAppend(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeAppendImage",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeAppendImage:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeAppendImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeAppendImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeAppendImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__25fd961df1bcae1a79493a4dde76d254cf3495e23cb78bee883f4a11d452d1ab)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeAppendImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeAppendImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeAppendImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c9d50285ec750ce5e927802202f3097eb5b244512e44f97d770ca7b8d343d7f0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeAppendList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeAppendList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a685b49f72346de99120a15ce91f424355440cfd63c2b90859569e8243c7cd2e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeAppendOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8f5287684c7cde9e1ec50b7b7701b7be5fd4ed88fd6397c41ecde09625fd66f8)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeAppendOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d0afd00b0265f1180f37bea814c7e700ccaeadd8bfd27b7d7cae0139122f8b43)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__567d42e01fefb8848a35cee3aca7b839c4fedc933c640c1ff0a61bad7935795c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a238fb27edc85f58baf98ef443ea188c5cced539e7beecd0cee7db69372dd91f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeAppend]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeAppend]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeAppend]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e01b49874b17e0f6e096085e89146027882b5f0e6d2a22638ac22ccfeb36366f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeAppendOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeAppendOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__feeefcf7a62816a07865bc089dea2aec747b0e1deaf474cad38b296ceff2bcb8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeAppendImage()

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityPriority")
    def reset_gravity_priority(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityPriority", []))

    @jsii.member(jsii_name="resetGravityPriorityVar")
    def reset_gravity_priority_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityPriorityVar", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPreserveMinorDimension")
    def reset_preserve_minor_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPreserveMinorDimension", []))

    @jsii.member(jsii_name="resetPreserveMinorDimensionVar")
    def reset_preserve_minor_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPreserveMinorDimensionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeAppendImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeAppendImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityInput")
    def gravity_priority_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityPriorityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityVarInput")
    def gravity_priority_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityPriorityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeAppendImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeAppendImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionInput")
    def preserve_minor_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "preserveMinorDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionVarInput")
    def preserve_minor_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "preserveMinorDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__50cfc7142d0e839c588c13fb00cc329ff66269791085d241d1baa6424c3b4886)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityPriority")
    def gravity_priority(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityPriority"))

    @gravity_priority.setter
    def gravity_priority(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c7734fee20a0cde413541e8de12dbd04b36049f3d497c9a5b5034b054291cdb1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityPriority", value)

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityVar")
    def gravity_priority_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityPriorityVar"))

    @gravity_priority_var.setter
    def gravity_priority_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__71f3f3631c0e419a2ed075c914042c5c0d26c6daa4bef5fc248091432d2a19fe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityPriorityVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab9efadc5b7e1162575da76450f985d136e77cb50d42155122d75b61693decb4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimension")
    def preserve_minor_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "preserveMinorDimension"))

    @preserve_minor_dimension.setter
    def preserve_minor_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fcd7eec6771bbd3a956e6effe4153b23a309475e69fc9b9d0082be49371243b6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "preserveMinorDimension", value)

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionVar")
    def preserve_minor_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "preserveMinorDimensionVar"))

    @preserve_minor_dimension_var.setter
    def preserve_minor_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__25e7a09ed82c501f69044cf0ba30dd9d13a7b8bf3f248b04b14fca3cda144530)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "preserveMinorDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeAppend]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeAppend]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeAppend]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7cca1d64f4a3084be0ac82dbfbd5a4ea604e4e82b712551c2f7fc1cac746e441)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeAspectCrop",
    jsii_struct_bases=[],
    name_mapping={
        "allow_expansion": "allowExpansion",
        "allow_expansion_var": "allowExpansionVar",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeAspectCrop:
    def __init__(
        self,
        *,
        allow_expansion: typing.Optional[builtins.str] = None,
        allow_expansion_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_expansion: Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image. Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        :param allow_expansion_var: Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image. Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        :param height: The height term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The width term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        :param x_position: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__acd4e3fcf026d6be1fa6ab22dbe5645b13b2aa02010911ef30eb902fd96e777a)
            check_type(argname="argument allow_expansion", value=allow_expansion, expected_type=type_hints["allow_expansion"])
            check_type(argname="argument allow_expansion_var", value=allow_expansion_var, expected_type=type_hints["allow_expansion_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if allow_expansion is not None:
            self._values["allow_expansion"] = allow_expansion
        if allow_expansion_var is not None:
            self._values["allow_expansion_var"] = allow_expansion_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def allow_expansion(self) -> typing.Optional[builtins.str]:
        '''Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image.

        Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        '''
        result = self._values.get("allow_expansion")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def allow_expansion_var(self) -> typing.Optional[builtins.str]:
        '''Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image.

        Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        '''
        result = self._values.get("allow_expansion_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeAspectCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeAspectCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeAspectCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a97bc448488ce23b7971636c0679c15d484c70627ceb3e7a909f8c513f65fc5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeAspectCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd86c0b901e5d69a5560d8b2b2f0cb24720d4dc7d58dec2e5fbf46f073534b20)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeAspectCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__988ed8b46e42a0f7407788974127c1882b2693e02376d4b375af91ea9fe72ce0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e7339f1bc8ad07d6420e5e1c6efc37f89711dea224061d3ab15b07e56b446d61)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4797e0ff0ca16795159eaf124843a2ffeb42316fc5484d1b642190742628bf4c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeAspectCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeAspectCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeAspectCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__978bc04e79bbf78a7d9379c2f50130d27e04422f19efeb2e0b9b50b273a8fd0b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeAspectCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeAspectCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f93b39ebede8ffd305617f7bfb134ffc1db481cfec034dade3f6f73d8f4e58e2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAllowExpansion")
    def reset_allow_expansion(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansion", []))

    @jsii.member(jsii_name="resetAllowExpansionVar")
    def reset_allow_expansion_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansionVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionInput")
    def allow_expansion_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVarInput")
    def allow_expansion_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansion")
    def allow_expansion(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansion"))

    @allow_expansion.setter
    def allow_expansion(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__843ef8077498732e78afbe1dcd8f86ba8039c59a796e6b2397381b908d47b726)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansion", value)

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVar")
    def allow_expansion_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansionVar"))

    @allow_expansion_var.setter
    def allow_expansion_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7510307f66e5dce044633cb080c2d1a0414fdd47d03a011fe151ee0f4923c187)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansionVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f868c68e64b04f511d1c1ab7b8a209d37a74940a8cf9b4cb26656f560c3d97b7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__197c36d8e57b6e3665b959bd5483c7dee7ae58886af77556d70c0b5eca0ffb83)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4e04c19a00bd863aa12fb58dee11a7fc0ab74075536d3641ab66d17438cd0521)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ff5d692a2c88bee78ba75c61629f4947b78a83c4d41b7a7ba4c5c41a5a9dddd8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be2e63294992c2a9de434549928b8369d789bfd4bec1a806c3f80cefb14898ba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0f95cdde7ce9a98ce18fc044837f6b68f00be9f3b688fc30212af40f82fecef0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d41f14834c7e0c48ac80a868863cc9e06b25c9cfa4648c15a506d2dbf29a3725)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d527d14b8455724859480c2cc74e90aa88b51d108d6fc6069d580b39fcc2633a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeAspectCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeAspectCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeAspectCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8f82b42cf1060062ea14aed0c8ae9389a1b4d1e21afaaadea39bf62b517ca8ce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeBackgroundColor",
    jsii_struct_bases=[],
    name_mapping={"color": "color", "color_var": "colorVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeBackgroundColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__519c90bda4a4964e74260b171f2fc6b4782296a6265bbae526d918981747bba3)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeBackgroundColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeBackgroundColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeBackgroundColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ebb4f453a680d7c2fd776e8c78edd62043ae42582d9dc904d37ec626571565db)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeBackgroundColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cc60f566a261fa15469a447e271783bbb4b67c4e9c99f78851c3f98b5a8956f1)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeBackgroundColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cce80c029518035a7332cf8325dc9271abd823cb136093f683dceb3e01f96337)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8d1e9c4dba3bf25de30cb076dee71be1ad79f1d989f2ea0e1ce8ae7dad266304)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eaca98a79538e011a6cf6a73a59f56c62cd9e94ec14591f521095d48dba6c62c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeBackgroundColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeBackgroundColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a4bc3f33e18c6a3322d49cb59a3aea8165be684894cde59988218b4f6d4fcb40)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeBackgroundColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeBackgroundColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac3826e65c04e9cc1644b3d790216a7ad407e2be27d22611f5d70b69f56b1c50)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4108078bfd88769280a62a9b981929fe513de1b7fffa52acee112d06370aab04)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a575aa528076e86d7efd56aa03b5e908057b43e1e4fa91041690fbb84cc5b154)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeBackgroundColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeBackgroundColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeBackgroundColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8c07e2467ffb3f1c4a69a802669bace75a45a4063a7fca1a929aef49e18615c0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeBlur",
    jsii_struct_bases=[],
    name_mapping={"sigma": "sigma", "sigma_var": "sigmaVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeBlur:
    def __init__(
        self,
        *,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param sigma: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__63c3a7720e0c74048fc4a42575c5cca3a579723a4594a0b504b9833a0271a2a1)
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeBlur(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeBlurList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeBlurList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__933d230b95b65dc2551629f5781b3ccdc4fd11c55ad7c559306c9e1a15ef5cc0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeBlurOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e7b1427fc8349a993fc10b64e902a1eacc28fa534b97275d761d36954362ba82)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeBlurOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0b8194202108cfccc6baba5a00e47cbdbf8b7d333aa17a6c06bf6590be088bb0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5725b8e042525262dd05e422b3171121ffa5f398f06ae38954906409c789500a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__57e2933debe4c1ea473b35991e97af67ed0de0c20f2f69411acedfca63e74803)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeBlur]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeBlur]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__07f40004ee733018b6dd06de40c3dd2085ecd848c650a0dd0263bd4f22607d81)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeBlurOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeBlurOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c119574610ac7f46a8154a5f39fc0d57073e2c29a316a98b018564ddf23c2c15)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c9fb941eec85a82202754d2bc0f47ab85535ab956c2e4d4bf533afea2baf16b0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__50e9f5417424291a2c7bfa6737d429080443985cba719bcea3e95273985076c8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeBlur]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeBlur]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeBlur]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d48eeb363c7b63461cfa6b7658b300a34285f60d035a687c21592418d9e684ff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeChromaKey",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_feather": "hueFeather",
        "hue_feather_var": "hueFeatherVar",
        "hue_tolerance": "hueTolerance",
        "hue_tolerance_var": "hueToleranceVar",
        "hue_var": "hueVar",
        "lightness_feather": "lightnessFeather",
        "lightness_feather_var": "lightnessFeatherVar",
        "lightness_tolerance": "lightnessTolerance",
        "lightness_tolerance_var": "lightnessToleranceVar",
        "saturation_feather": "saturationFeather",
        "saturation_feather_var": "saturationFeatherVar",
        "saturation_tolerance": "saturationTolerance",
        "saturation_tolerance_var": "saturationToleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeChromaKey:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_feather: typing.Optional[builtins.str] = None,
        hue_feather_var: typing.Optional[builtins.str] = None,
        hue_tolerance: typing.Optional[builtins.str] = None,
        hue_tolerance_var: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness_feather: typing.Optional[builtins.str] = None,
        lightness_feather_var: typing.Optional[builtins.str] = None,
        lightness_tolerance: typing.Optional[builtins.str] = None,
        lightness_tolerance_var: typing.Optional[builtins.str] = None,
        saturation_feather: typing.Optional[builtins.str] = None,
        saturation_feather_var: typing.Optional[builtins.str] = None,
        saturation_tolerance: typing.Optional[builtins.str] = None,
        saturation_tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_feather: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        :param hue_feather_var: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        :param hue_tolerance: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        :param hue_tolerance_var: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        :param hue_var: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness_feather: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        :param lightness_feather_var: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        :param lightness_tolerance: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        :param lightness_tolerance_var: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        :param saturation_feather: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        :param saturation_feather_var: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        :param saturation_tolerance: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        :param saturation_tolerance_var: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a40b488c1bfbbb2aef7ffdfba6675d04f66cd17aefb9e49bf0d658084be4dd88)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_feather", value=hue_feather, expected_type=type_hints["hue_feather"])
            check_type(argname="argument hue_feather_var", value=hue_feather_var, expected_type=type_hints["hue_feather_var"])
            check_type(argname="argument hue_tolerance", value=hue_tolerance, expected_type=type_hints["hue_tolerance"])
            check_type(argname="argument hue_tolerance_var", value=hue_tolerance_var, expected_type=type_hints["hue_tolerance_var"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness_feather", value=lightness_feather, expected_type=type_hints["lightness_feather"])
            check_type(argname="argument lightness_feather_var", value=lightness_feather_var, expected_type=type_hints["lightness_feather_var"])
            check_type(argname="argument lightness_tolerance", value=lightness_tolerance, expected_type=type_hints["lightness_tolerance"])
            check_type(argname="argument lightness_tolerance_var", value=lightness_tolerance_var, expected_type=type_hints["lightness_tolerance_var"])
            check_type(argname="argument saturation_feather", value=saturation_feather, expected_type=type_hints["saturation_feather"])
            check_type(argname="argument saturation_feather_var", value=saturation_feather_var, expected_type=type_hints["saturation_feather_var"])
            check_type(argname="argument saturation_tolerance", value=saturation_tolerance, expected_type=type_hints["saturation_tolerance"])
            check_type(argname="argument saturation_tolerance_var", value=saturation_tolerance_var, expected_type=type_hints["saturation_tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_feather is not None:
            self._values["hue_feather"] = hue_feather
        if hue_feather_var is not None:
            self._values["hue_feather_var"] = hue_feather_var
        if hue_tolerance is not None:
            self._values["hue_tolerance"] = hue_tolerance
        if hue_tolerance_var is not None:
            self._values["hue_tolerance_var"] = hue_tolerance_var
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness_feather is not None:
            self._values["lightness_feather"] = lightness_feather
        if lightness_feather_var is not None:
            self._values["lightness_feather_var"] = lightness_feather_var
        if lightness_tolerance is not None:
            self._values["lightness_tolerance"] = lightness_tolerance
        if lightness_tolerance_var is not None:
            self._values["lightness_tolerance_var"] = lightness_tolerance_var
        if saturation_feather is not None:
            self._values["saturation_feather"] = saturation_feather
        if saturation_feather_var is not None:
            self._values["saturation_feather_var"] = saturation_feather_var
        if saturation_tolerance is not None:
            self._values["saturation_tolerance"] = saturation_tolerance
        if saturation_tolerance_var is not None:
            self._values["saturation_tolerance_var"] = saturation_tolerance_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        '''
        result = self._values.get("hue_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        '''
        result = self._values.get("hue_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        '''
        result = self._values.get("hue_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        '''
        result = self._values.get("hue_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        '''
        result = self._values.get("lightness_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        '''
        result = self._values.get("lightness_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        '''
        result = self._values.get("lightness_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        '''
        result = self._values.get("lightness_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        '''
        result = self._values.get("saturation_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        '''
        result = self._values.get("saturation_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        '''
        result = self._values.get("saturation_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        result = self._values.get("saturation_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeChromaKey(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeChromaKeyList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeChromaKeyList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__29fac342fab48740f2654d3cde78387949570b3c8dbcd1bdaebe389e4c8255e6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeChromaKeyOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d9967c1b45cc4097cc318470fa0b6e67b77a81bf79a247d10137ea6d2c14c021)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeChromaKeyOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6637190408d120ac3d6d88fdc10fa2c5baa9368d89a1036c788fdf08dba065c7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ced0e354c2246b92d43e57bd4b9720e72f434b8bdf814fa01f5a60607a37212b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__19fae943b93a0ec996f0329f1ca40e721a3387d09edf65e0ae536a2a7e09a7f4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeChromaKey]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeChromaKey]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3dc8598e01100924a05817fce76a6cffcbf04a90859689020007d6f25b0d8f9d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeChromaKeyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeChromaKeyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b7b5542a2611f772e103d92aee614dc35d5661a56ddf1dc8ec723c1facf0003b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueFeather")
    def reset_hue_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeather", []))

    @jsii.member(jsii_name="resetHueFeatherVar")
    def reset_hue_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeatherVar", []))

    @jsii.member(jsii_name="resetHueTolerance")
    def reset_hue_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueTolerance", []))

    @jsii.member(jsii_name="resetHueToleranceVar")
    def reset_hue_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueToleranceVar", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightnessFeather")
    def reset_lightness_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeather", []))

    @jsii.member(jsii_name="resetLightnessFeatherVar")
    def reset_lightness_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeatherVar", []))

    @jsii.member(jsii_name="resetLightnessTolerance")
    def reset_lightness_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessTolerance", []))

    @jsii.member(jsii_name="resetLightnessToleranceVar")
    def reset_lightness_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessToleranceVar", []))

    @jsii.member(jsii_name="resetSaturationFeather")
    def reset_saturation_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeather", []))

    @jsii.member(jsii_name="resetSaturationFeatherVar")
    def reset_saturation_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeatherVar", []))

    @jsii.member(jsii_name="resetSaturationTolerance")
    def reset_saturation_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationTolerance", []))

    @jsii.member(jsii_name="resetSaturationToleranceVar")
    def reset_saturation_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherInput")
    def hue_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVarInput")
    def hue_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceInput")
    def hue_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVarInput")
    def hue_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherInput")
    def lightness_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVarInput")
    def lightness_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceInput")
    def lightness_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVarInput")
    def lightness_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherInput")
    def saturation_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVarInput")
    def saturation_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceInput")
    def saturation_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVarInput")
    def saturation_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__895dbb76a04afc819d3255f89a172b7da2ee219d21ceb285fd66141638c85d7b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeather")
    def hue_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeather"))

    @hue_feather.setter
    def hue_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e286e3590982105d1c5860ba188ae9bf7ab1e592450c4c549235c596f0657897)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeather", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVar")
    def hue_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeatherVar"))

    @hue_feather_var.setter
    def hue_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fc5895f1db13d3c11edf61c8d28a7578ff3a478ddeb7cce2633fdbf92494ed3a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueTolerance")
    def hue_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueTolerance"))

    @hue_tolerance.setter
    def hue_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a7e5d04844cb557732107e90b541fe67d942f0a2b447cad739873d32bddb074a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVar")
    def hue_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueToleranceVar"))

    @hue_tolerance_var.setter
    def hue_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__430f8198693ea83bafce2a0c3c3b4a8ccd2194bf90ad6566d4b456d435d884af)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f1498d3b4fad6bedc1b6e146cda91c7439f27f596e23339d44f87469be79038)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeather")
    def lightness_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeather"))

    @lightness_feather.setter
    def lightness_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6be9da019dbdd1853ff173aa4e06c12f25a362bd0d62e1540bd8ff7a33666522)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeather", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVar")
    def lightness_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeatherVar"))

    @lightness_feather_var.setter
    def lightness_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b437f6e21cefdbd923c30eba59f29be515a7de09f32f2ab9d21e8c9e6fce59ef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessTolerance")
    def lightness_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessTolerance"))

    @lightness_tolerance.setter
    def lightness_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a784580f0623e2cbab35e80f1e8145f1a5a929665aacd1ced4509b19cdbd1ece)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVar")
    def lightness_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessToleranceVar"))

    @lightness_tolerance_var.setter
    def lightness_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b301047012bae735d1cee229f6e9e8514ff848e6a48dc69fa9ec7a88b21ec08d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeather")
    def saturation_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeather"))

    @saturation_feather.setter
    def saturation_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a9d2179a1957050c40e44a4cc924748a5a5dd59bdb294bc1afcb6d7f37ae34df)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeather", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVar")
    def saturation_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeatherVar"))

    @saturation_feather_var.setter
    def saturation_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__66983cb11f7de6199f42d6dcaa8929422fd758ad6b59ff070e94b26141dc163d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationTolerance")
    def saturation_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationTolerance"))

    @saturation_tolerance.setter
    def saturation_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ddf00ad207423aea26943e9dc05b41dc2a98d6e44e4273e0650e43d519d91598)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVar")
    def saturation_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationToleranceVar"))

    @saturation_tolerance_var.setter
    def saturation_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2eabd5258eef9eb7f4e19fb792ff9739f5100155a70a5ae74a0aec042de2ec07)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeChromaKey]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeChromaKey]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeChromaKey]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5a4c51a03146a954cd2af6d24a5a10d0977e336d37f7fbcaa69c63e974121569)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeComposite",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "placement": "placement",
        "placement_var": "placementVar",
        "scale": "scale",
        "scale_dimension": "scaleDimension",
        "scale_dimension_var": "scaleDimensionVar",
        "scale_var": "scaleVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeComposite:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeCompositeImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        placement: typing.Optional[builtins.str] = None,
        placement_var: typing.Optional[builtins.str] = None,
        scale: typing.Optional[builtins.str] = None,
        scale_dimension: typing.Optional[builtins.str] = None,
        scale_dimension_var: typing.Optional[builtins.str] = None,
        scale_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param placement: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        :param placement_var: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        :param scale: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param scale_dimension: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        :param scale_dimension_var: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        :param scale_var: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        :param x_position: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeCompositeImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c3fa13c45391b53e2628b176247f0a1191a5b596962a31fe3f6ad8c6d2233e84)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument placement", value=placement, expected_type=type_hints["placement"])
            check_type(argname="argument placement_var", value=placement_var, expected_type=type_hints["placement_var"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument scale_dimension", value=scale_dimension, expected_type=type_hints["scale_dimension"])
            check_type(argname="argument scale_dimension_var", value=scale_dimension_var, expected_type=type_hints["scale_dimension_var"])
            check_type(argname="argument scale_var", value=scale_var, expected_type=type_hints["scale_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if placement is not None:
            self._values["placement"] = placement
        if placement_var is not None:
            self._values["placement_var"] = placement_var
        if scale is not None:
            self._values["scale"] = scale
        if scale_dimension is not None:
            self._values["scale_dimension"] = scale_dimension
        if scale_dimension_var is not None:
            self._values["scale_dimension_var"] = scale_dimension_var
        if scale_var is not None:
            self._values["scale_var"] = scale_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeCompositeImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeCompositeImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        '''
        result = self._values.get("placement")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement_var(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        '''
        result = self._values.get("placement_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        '''
        result = self._values.get("scale_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        '''
        result = self._values.get("scale_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        '''
        result = self._values.get("scale_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeComposite(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeCompositeImage",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeCompositeImage:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeCompositeImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeCompositeImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeCompositeImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c3bed525be9439a68f41a8027454814ae7458d575a4856581100a85b00fce6e1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeCompositeImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeCompositeImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a866c93e00ddff2c3f27232b8c885d7f083aa968da8842012e94d2fd70268aab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeCompositeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeCompositeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__76a9c8546cdfb71c8317dcaa7c8b0edef1563b9c207443e5022399454172e3c8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeCompositeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2004f8bb10513c1b2f14617c877f9fd0d21e369bd5c5c258d4cc19b9b0423a87)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeCompositeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dd575a018e3b753a19dbcb171d95f5bdde526e1766628feb0b48b16ea76024a9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__34d55f3544d2a231beb7d9a0896ff333c026cbad86c6f3a0ddf5983461063162)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__14b3a63c1bf2b3792366be840471845a335eea77b0674b4ddcf352e406e9c2f7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeComposite]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeComposite]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__16f8b14894bc9af9911f13421d7fd873215ac39cf5eec4252b6ba1ddab102625)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeCompositeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeCompositeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__367d04ed6635ee1918811f3fe57acf4f3a0051111b6e72f0001a66187a32cc7f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeCompositeImage()

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPlacement")
    def reset_placement(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacement", []))

    @jsii.member(jsii_name="resetPlacementVar")
    def reset_placement_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacementVar", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetScaleDimension")
    def reset_scale_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimension", []))

    @jsii.member(jsii_name="resetScaleDimensionVar")
    def reset_scale_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimensionVar", []))

    @jsii.member(jsii_name="resetScaleVar")
    def reset_scale_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeCompositeImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeCompositeImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeCompositeImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="placementInput")
    def placement_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementInput"))

    @builtins.property
    @jsii.member(jsii_name="placementVarInput")
    def placement_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionInput")
    def scale_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVarInput")
    def scale_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleVarInput")
    def scale_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8e0077bba8b39c0ddb1e295e91588934755d8312d897f034d7d1bd23166cd581)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f0d91e928c38c176a19ccfc2ad2ee5332c8c0cb33864ae406e2f93a223da0b4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="placement")
    def placement(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placement"))

    @placement.setter
    def placement(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__56f4324e19b1b5c52be909ca82f5e176d2afa2acb05b5fa869fa61807c40ea29)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placement", value)

    @builtins.property
    @jsii.member(jsii_name="placementVar")
    def placement_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placementVar"))

    @placement_var.setter
    def placement_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bf57cec3137ac017667018b76712acea6acc34f0935b19df29e10b311e995875)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placementVar", value)

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scale"))

    @scale.setter
    def scale(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea1e6f8b84f968d99bf59cf1632e29c79e152a104f58b87595c0a4242ee38cbb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scale", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimension")
    def scale_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimension"))

    @scale_dimension.setter
    def scale_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__791b0e47a9c53bb1021ba82a9f48aabd015971e1d100065522a48cd7e18f8edb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimension", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVar")
    def scale_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimensionVar"))

    @scale_dimension_var.setter
    def scale_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b20fa9bf5c9ef23f383edf6edceb909ce0058c46cfde3c172b9b7f995672170e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="scaleVar")
    def scale_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleVar"))

    @scale_var.setter
    def scale_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9471ee2bf4632778976fa6c04776b61ef7d35561cf500b010952df6457e09cac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d904f370daa45de40f69c28198e615720cdb9bc644761b614b72db6e5b07bb62)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__72ac239f665eb16640c6ab634fcd090fdf5ca397cc85d501b3cd4c8628172d4e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d742a2c5069aee0b6913bfca01ac9746630f625f19b2d2e4c3e1938489d60a93)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac8f083f30f6ba93f01e059a8a353f1aca4633f873d20c0e44c77a25d9e2bffc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeComposite]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeComposite]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeComposite]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1ae0e7d7ea5e7f159ae27cb5c48bd6c01e25a64117d1e01d0be408a42160a28b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeCompound",
    jsii_struct_bases=[],
    name_mapping={"transformations": "transformations"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeCompound:
    def __init__(
        self,
        *,
        transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param transformations: transformations block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2147be3369c6c1ac85141c488d207576bb66df92236c7fa78057247075c2296d)
            check_type(argname="argument transformations", value=transformations, expected_type=type_hints["transformations"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if transformations is not None:
            self._values["transformations"] = transformations

    @builtins.property
    def transformations(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeCompoundTransformations"]]]:
        '''transformations block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        result = self._values.get("transformations")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeCompoundTransformations"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeCompound(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeCompoundList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeCompoundList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c2d15117eabb969501382ca1051036fa5dc633337a36681bf774338975398e31)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeCompoundOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a698cef03f9e0d14aeaf55ae504e7404824eaf5a32083672887e82cacf9b3871)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeCompoundOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__57349d0ef9708d8037a1f7e5dbe58d9a5e83698a90642369b65d9433bbc5bf36)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e3a00d2c580e23eb0ff879e47e2ce0129f0f074e656a47d9a2d1cf470ee16bcd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9578f2a0454c961ad5924f1dc6069bc5ea9c1a838f3102fa20594c43685260db)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeCompound]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeCompound]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__04dc51e6577a62bf19a84044057df14314f25b1472936393b88b99ed30cab423)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeCompoundOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeCompoundOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__33b2819de7b55d27b4a121f08d3021c8b47f19f711d1336ba6c7d32e70f243ce)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformations")
    def put_transformations(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d410e9324801debf62033ab3bcf6e4c587cf7b53a8e107870d9d878a3a012727)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTransformations", [value]))

    @jsii.member(jsii_name="resetTransformations")
    def reset_transformations(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformations", []))

    @builtins.property
    @jsii.member(jsii_name="transformations")
    def transformations(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeCompoundTransformationsList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeCompoundTransformationsList", jsii.get(self, "transformations"))

    @builtins.property
    @jsii.member(jsii_name="transformationsInput")
    def transformations_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeCompoundTransformations"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeCompoundTransformations"]]], jsii.get(self, "transformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeCompound]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeCompound]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeCompound]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fdf5fa4123d57a9dd171596e30e9d9918776c4c39b8f81e529cbea522765ff05)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeCompoundTransformations",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeCompoundTransformations:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeCompoundTransformations(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeCompoundTransformationsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeCompoundTransformationsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bfc8fdbe50887435489ca972ecade3eec3c4aa4dfd4f2e6cc3b06d2ba1e9b43a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeCompoundTransformationsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__67f9106c6d346db7af3faa284bd219c11fd8df3af89ca87720634d412e8f0a0a)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeCompoundTransformationsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__73c038477c41ed944a3e66be5b0a758acdcc6101d2259c4a2f7f560f445d0df4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a4b64c0715b2d02d4991f79107465dab6dccc1d0601bb444dd49b526d38d7e15)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aa95ce19203c394dfd36e3524a2a1b8e2feecca6d784001635920556be2ac583)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeCompoundTransformations]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeCompoundTransformations]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeCompoundTransformations]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c9b8dd319f499d31e3ded4ea427cdeeb7a716e293ea517af16c1fc50b6397329)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeCompoundTransformationsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeCompoundTransformationsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4fcc69747c7f8e057891fa1a0ca2fb7c2525af417895283545cf717015e389cd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeCompoundTransformations]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeCompoundTransformations]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeCompoundTransformations]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__987dda651a4a5e9df1a3ce01eaaf553eb04e5c0c75cba7dae816a402bd679e3a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeContrast",
    jsii_struct_bases=[],
    name_mapping={
        "brightness": "brightness",
        "brightness_var": "brightnessVar",
        "contrast": "contrast",
        "contrast_var": "contrastVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeContrast:
    def __init__(
        self,
        *,
        brightness: typing.Optional[builtins.str] = None,
        brightness_var: typing.Optional[builtins.str] = None,
        contrast: typing.Optional[builtins.str] = None,
        contrast_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param brightness: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        :param brightness_var: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        :param contrast: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param contrast_var: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e7cf2387496b560dda4f74e9798929141746f6e0790965ccc68a4d83417e71f0)
            check_type(argname="argument brightness", value=brightness, expected_type=type_hints["brightness"])
            check_type(argname="argument brightness_var", value=brightness_var, expected_type=type_hints["brightness_var"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument contrast_var", value=contrast_var, expected_type=type_hints["contrast_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if brightness is not None:
            self._values["brightness"] = brightness
        if brightness_var is not None:
            self._values["brightness_var"] = brightness_var
        if contrast is not None:
            self._values["contrast"] = contrast
        if contrast_var is not None:
            self._values["contrast_var"] = contrast_var

    @builtins.property
    def brightness(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        '''
        result = self._values.get("brightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def brightness_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        '''
        result = self._values.get("brightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        result = self._values.get("contrast_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeContrast(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeContrastList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeContrastList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0edfd958df7760bd3f3bfe4e3edfe2894e096c6641e992aace0fc4271127da1a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeContrastOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0427e97345be388dfd93385d71e31dae60d5b5ccf08a566fffcc38326518d46f)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeContrastOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3751b5331541ce5577254dfdf0d52fb4375f665d4c8f71fe50951c65c0c76cda)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6718cc5af636c4e2b64248fca4af70f74df760200277c5227cc5ab94428b50a6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a3851d9f56e822ad4a45f76b58b6799dd5ecee8ed5c1e1a836235ae44f450de4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeContrast]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeContrast]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fdefdce32f8d4a59e9677ea9b67c8de308617c2b2bca5881fc2189b55efea49c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeContrastOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeContrastOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__99ac36d67b1d0e623bb6eaa070ff2d753574e0617c40d5d13f261ba31f7ff42a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetBrightness")
    def reset_brightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightness", []))

    @jsii.member(jsii_name="resetBrightnessVar")
    def reset_brightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightnessVar", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetContrastVar")
    def reset_contrast_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrastVar", []))

    @builtins.property
    @jsii.member(jsii_name="brightnessInput")
    def brightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="brightnessVarInput")
    def brightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastVarInput")
    def contrast_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="brightness")
    def brightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightness"))

    @brightness.setter
    def brightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__beebd69685ba1b0847ea0fd355c934dd6ea6ed73b183d73aff545553046b7cd2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightness", value)

    @builtins.property
    @jsii.member(jsii_name="brightnessVar")
    def brightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightnessVar"))

    @brightness_var.setter
    def brightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb4f482a69b1079206a26f215069313b6c32932095510779ddc9c8055717ff37)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrast"))

    @contrast.setter
    def contrast(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3561a783f4897632ed80145e0126bb3a9da85875b196f1b3fee5a846f6f47387)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrast", value)

    @builtins.property
    @jsii.member(jsii_name="contrastVar")
    def contrast_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrastVar"))

    @contrast_var.setter
    def contrast_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__49d0abe3b538c62865fa9482ed0b196bb303677cb8b782264a171edc4474888a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrastVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeContrast]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeContrast]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeContrast]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ef998eaaebe3ef7f63abf041b6715ef6c7bdfaa59e9d3115e6e2dc25e64e0b22)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeCrop",
    jsii_struct_bases=[],
    name_mapping={
        "allow_expansion": "allowExpansion",
        "allow_expansion_var": "allowExpansionVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeCrop:
    def __init__(
        self,
        *,
        allow_expansion: typing.Optional[builtins.str] = None,
        allow_expansion_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_expansion: If cropping an area outside of the existing canvas, expands the image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        :param allow_expansion_var: If cropping an area outside of the existing canvas, expands the image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        :param gravity: Frame of reference for X and Y Positions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Frame of reference for X and Y Positions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The number of pixels to crop along the y-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The number of pixels to crop along the y-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The number of pixels to crop along the x-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The number of pixels to crop along the x-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        :param x_position: The x-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__338587722fde0dfd9d2fafb0b6cd079149d6296e4e9ab404b3700d05bbd849e3)
            check_type(argname="argument allow_expansion", value=allow_expansion, expected_type=type_hints["allow_expansion"])
            check_type(argname="argument allow_expansion_var", value=allow_expansion_var, expected_type=type_hints["allow_expansion_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if allow_expansion is not None:
            self._values["allow_expansion"] = allow_expansion
        if allow_expansion_var is not None:
            self._values["allow_expansion_var"] = allow_expansion_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def allow_expansion(self) -> typing.Optional[builtins.str]:
        '''If cropping an area outside of the existing canvas, expands the image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        '''
        result = self._values.get("allow_expansion")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def allow_expansion_var(self) -> typing.Optional[builtins.str]:
        '''If cropping an area outside of the existing canvas, expands the image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        '''
        result = self._values.get("allow_expansion_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Frame of reference for X and Y Positions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Frame of reference for X and Y Positions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the y-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the y-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the x-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the x-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__76a78b47c45dc8c49067bce274cc8ec2abc8e6151c26b5fcdf29dcebed2f39e6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dcbcd7dbe957651dbce9355c978ea9a811e3858532236fe44abccb97dd32f25d)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fcbf81c35ca5b594db4a02c73571ae2e4abc915587f04c617cb19fcce574956e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a9688acf08d107cb665cde9471a1d06c802b8782a58dfc54952eb8fd1db98f6f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7b53bc2a26a399c47d5ef22dd8b92dce9c38a6a96f8bd24648654ad3820af83d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b2aa8a53a1e6a8d258e309597088ae80d12c81e9064bbca9defece23020d68de)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__83a644935ced925b44b2304dade3e130aeda0613bab3c8593189999ba56bf5fc)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAllowExpansion")
    def reset_allow_expansion(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansion", []))

    @jsii.member(jsii_name="resetAllowExpansionVar")
    def reset_allow_expansion_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansionVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionInput")
    def allow_expansion_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVarInput")
    def allow_expansion_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansion")
    def allow_expansion(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansion"))

    @allow_expansion.setter
    def allow_expansion(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cf8fcd01496b4fe9cb9c2f51363f0386ab5663ff3d2598dbd1d1ee1e4458333a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansion", value)

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVar")
    def allow_expansion_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansionVar"))

    @allow_expansion_var.setter
    def allow_expansion_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__258b8bd1a33e69eea6433ad3807d8f2c02b513bb819250fe73a7a03d0e491b36)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansionVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bafeb8c12059657e8514a0c9847db1427173ae7d8c96c3867aa57fd318a00bd4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__251c9fb340095da5ac4726f088dc33d44d6daf443dca79b2d216a65eacfa267c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b2400fac46eb3fa863df74c16c9f050ef35d42697c39309db830ac3b3a51900c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d43ce4bb974ab5dddee055901c21622186315fc0e690731b3d8ffbbcefaa5c6f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__78b90636224c61c14f2abd53381323ac14753c928e45d9f6806150ccad241cd6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a1fe7685fd8955cd92f444ab815836eb427cbc6bff426b62cb82f2b71b7c1ab3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__54461a9e5569aaef6b60af7cd0a137ddbfaadfe0e1c6983e8bacfcda6ddb189b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1011b8ba4fe03cabada5750fd3572aeeb855f3bfad9c765d9a8daccaa035c0ac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__13718c56e9681d77751b4756cbae3bd3b7c850ed5ad509cfbad9120471cccb6c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eef93e04f7d7a87263d075ce5cee194b6452c933f5ce7f4bca9e014a1b709072)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__603605e79708c6f034b5225531646e7f920f51b1b1a6b5cf4bde82e0506c4a6e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeFaceCrop",
    jsii_struct_bases=[],
    name_mapping={
        "algorithm": "algorithm",
        "algorithm_var": "algorithmVar",
        "confidence": "confidence",
        "confidence_var": "confidenceVar",
        "fail_gravity": "failGravity",
        "fail_gravity_var": "failGravityVar",
        "focus": "focus",
        "focus_var": "focusVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "padding": "padding",
        "padding_var": "paddingVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeFaceCrop:
    def __init__(
        self,
        *,
        algorithm: typing.Optional[builtins.str] = None,
        algorithm_var: typing.Optional[builtins.str] = None,
        confidence: typing.Optional[builtins.str] = None,
        confidence_var: typing.Optional[builtins.str] = None,
        fail_gravity: typing.Optional[builtins.str] = None,
        fail_gravity_var: typing.Optional[builtins.str] = None,
        focus: typing.Optional[builtins.str] = None,
        focus_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param algorithm: Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm DataAkamaiImagingPolicyImage#algorithm}
        :param algorithm_var: Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm_var DataAkamaiImagingPolicyImage#algorithm_var}
        :param confidence: With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image. Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence DataAkamaiImagingPolicyImage#confidence}
        :param confidence_var: With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image. Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence_var DataAkamaiImagingPolicyImage#confidence_var}
        :param fail_gravity: Controls placement of the crop if Image and Video Manager does not detect any faces in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        :param fail_gravity_var: Controls placement of the crop if Image and Video Manager does not detect any faces in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        :param focus: Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus DataAkamaiImagingPolicyImage#focus}
        :param focus_var: Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus_var DataAkamaiImagingPolicyImage#focus_var}
        :param gravity: Controls placement of the crop. Directions are relative to the face(s) plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Controls placement of the crop. Directions are relative to the face(s) plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param padding: The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        :param style: Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ad46789eca460b5d664d499a249d8d89e1e221103dd6bc25188c70c22a4f509f)
            check_type(argname="argument algorithm", value=algorithm, expected_type=type_hints["algorithm"])
            check_type(argname="argument algorithm_var", value=algorithm_var, expected_type=type_hints["algorithm_var"])
            check_type(argname="argument confidence", value=confidence, expected_type=type_hints["confidence"])
            check_type(argname="argument confidence_var", value=confidence_var, expected_type=type_hints["confidence_var"])
            check_type(argname="argument fail_gravity", value=fail_gravity, expected_type=type_hints["fail_gravity"])
            check_type(argname="argument fail_gravity_var", value=fail_gravity_var, expected_type=type_hints["fail_gravity_var"])
            check_type(argname="argument focus", value=focus, expected_type=type_hints["focus"])
            check_type(argname="argument focus_var", value=focus_var, expected_type=type_hints["focus_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if algorithm is not None:
            self._values["algorithm"] = algorithm
        if algorithm_var is not None:
            self._values["algorithm_var"] = algorithm_var
        if confidence is not None:
            self._values["confidence"] = confidence
        if confidence_var is not None:
            self._values["confidence_var"] = confidence_var
        if fail_gravity is not None:
            self._values["fail_gravity"] = fail_gravity
        if fail_gravity_var is not None:
            self._values["fail_gravity_var"] = fail_gravity_var
        if focus is not None:
            self._values["focus"] = focus
        if focus_var is not None:
            self._values["focus_var"] = focus_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def algorithm(self) -> typing.Optional[builtins.str]:
        '''Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm DataAkamaiImagingPolicyImage#algorithm}
        '''
        result = self._values.get("algorithm")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def algorithm_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm_var DataAkamaiImagingPolicyImage#algorithm_var}
        '''
        result = self._values.get("algorithm_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def confidence(self) -> typing.Optional[builtins.str]:
        '''With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image.

        Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence DataAkamaiImagingPolicyImage#confidence}
        '''
        result = self._values.get("confidence")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def confidence_var(self) -> typing.Optional[builtins.str]:
        '''With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image.

        Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence_var DataAkamaiImagingPolicyImage#confidence_var}
        '''
        result = self._values.get("confidence_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any faces in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        '''
        result = self._values.get("fail_gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any faces in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        '''
        result = self._values.get("fail_gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def focus(self) -> typing.Optional[builtins.str]:
        '''Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus DataAkamaiImagingPolicyImage#focus}
        '''
        result = self._values.get("focus")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def focus_var(self) -> typing.Optional[builtins.str]:
        '''Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus_var DataAkamaiImagingPolicyImage#focus_var}
        '''
        result = self._values.get("focus_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the face(s) plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the face(s) plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeFaceCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeFaceCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeFaceCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__811eee1af2ea2643ec360163987f3cd4afd9a7d855ff6e9d37fe026893124fea)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeFaceCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1d3b2d9e06d2ec7675b921a34b1190fbd952d68882d0de0823fa0ec69bf51226)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeFaceCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aad148964ffd6edcf5c2ded8503ac3ffa656d0cdca0265e5367264d7495358ed)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d4588ba4d7ee92d6f46f19c1803f2e3d4405cc1f660664b177d76e0b19e2299f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d8ff4c66ea4a534b7cd15ea14db82d720c1eb9ea7a67004644c49fcc822c1d63)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeFaceCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeFaceCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeFaceCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__27d8a540d547acc641d1c37149640ebebd1f1acae493f50a7d498e8c95c7e8ae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeFaceCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeFaceCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c193d1fad21637fbd5010c589b59bb98ab5cc88a255cc1342912a0b8ccafaf37)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAlgorithm")
    def reset_algorithm(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAlgorithm", []))

    @jsii.member(jsii_name="resetAlgorithmVar")
    def reset_algorithm_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAlgorithmVar", []))

    @jsii.member(jsii_name="resetConfidence")
    def reset_confidence(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetConfidence", []))

    @jsii.member(jsii_name="resetConfidenceVar")
    def reset_confidence_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetConfidenceVar", []))

    @jsii.member(jsii_name="resetFailGravity")
    def reset_fail_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravity", []))

    @jsii.member(jsii_name="resetFailGravityVar")
    def reset_fail_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravityVar", []))

    @jsii.member(jsii_name="resetFocus")
    def reset_focus(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFocus", []))

    @jsii.member(jsii_name="resetFocusVar")
    def reset_focus_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFocusVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="algorithmInput")
    def algorithm_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "algorithmInput"))

    @builtins.property
    @jsii.member(jsii_name="algorithmVarInput")
    def algorithm_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "algorithmVarInput"))

    @builtins.property
    @jsii.member(jsii_name="confidenceInput")
    def confidence_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "confidenceInput"))

    @builtins.property
    @jsii.member(jsii_name="confidenceVarInput")
    def confidence_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "confidenceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityInput")
    def fail_gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityVarInput")
    def fail_gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="focusInput")
    def focus_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "focusInput"))

    @builtins.property
    @jsii.member(jsii_name="focusVarInput")
    def focus_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "focusVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="algorithm")
    def algorithm(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "algorithm"))

    @algorithm.setter
    def algorithm(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d005c6c6add1dd5356c4af94999b480fd7c36571f7e2052968ce3276033b0cbb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "algorithm", value)

    @builtins.property
    @jsii.member(jsii_name="algorithmVar")
    def algorithm_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "algorithmVar"))

    @algorithm_var.setter
    def algorithm_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cdd1061ce48b39b710e4694624abbb2d6ae77c695d6e0b42ce450a5092798c88)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "algorithmVar", value)

    @builtins.property
    @jsii.member(jsii_name="confidence")
    def confidence(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "confidence"))

    @confidence.setter
    def confidence(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b60ff17421cdb0ecba1acbbf404346d9dd3084abbe22f0565379ed4f9f16eda8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "confidence", value)

    @builtins.property
    @jsii.member(jsii_name="confidenceVar")
    def confidence_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "confidenceVar"))

    @confidence_var.setter
    def confidence_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b93a06b5ed3a33e85c742b7fcd5f8bf13e91531b68476fdba2743d3d11fd2123)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "confidenceVar", value)

    @builtins.property
    @jsii.member(jsii_name="failGravity")
    def fail_gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravity"))

    @fail_gravity.setter
    def fail_gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ccd811ae200c8372aa24ac76afb02ddb41cfec23b82650746ec13b57aaea49f3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravity", value)

    @builtins.property
    @jsii.member(jsii_name="failGravityVar")
    def fail_gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravityVar"))

    @fail_gravity_var.setter
    def fail_gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dd89bcfc94baee07c77ae17ab4f2ce5f54191020485b0915b947b3784b2d9abb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="focus")
    def focus(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "focus"))

    @focus.setter
    def focus(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__66d983b0e3c2aa04423b07c77c60ed97e652a2924f757438fd8736535b9ecd06)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "focus", value)

    @builtins.property
    @jsii.member(jsii_name="focusVar")
    def focus_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "focusVar"))

    @focus_var.setter
    def focus_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__85fe23f9088b09d2b2932b771ba97aca5f82df28b8adfc3eb6d256bf38112dea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "focusVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ee7f4252f334ce82548d62d888ea6b0cf74644cac1058872e7efa39570a78187)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__78bc2c64093be13e9e53a8b88a22358270ec0027b877cf8cce8c16c37eaf6b4e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7ab736c3a88d30e8921459037965f11c1f8d90a2c7602ca7dc890fb63bbae3d1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cba4ead7ec9ac3fc6b45c890eb4f4317fdd076c254b76b48fabffda35cd396a7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bab7be984cacba150519d0a62ba221029ca1bdb18bc757597cd7d738960a6fe8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9fff4b2bbf84219a696fbb13c4c3c4a811b2fd13efdc110ff586045901c0b6ff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fdd9a0def2a87ab60477b4b2b66d218a3b0bc3df00d2acef6fc3ed6d169beae1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fe15978faead261a2d1e6c1198d4bdd87464b9d396b44353ff6a5c041a696a6b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3d57014ae5a0ac552a9e053e34bb0ec3eed75513fb7a45e3a6e88ae0bdd5b123)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c4fbfea1d997fff2eec9090cd00aa9af0a0fd68a14fe2e28c88451500d8dfb54)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeFaceCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeFaceCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeFaceCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7c399c129564f8a7ee2101a9d3de1caf66a60f468162b4f35a8dacade3072432)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeFeatureCrop",
    jsii_struct_bases=[],
    name_mapping={
        "fail_gravity": "failGravity",
        "fail_gravity_var": "failGravityVar",
        "feature_radius": "featureRadius",
        "feature_radius_var": "featureRadiusVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "max_features": "maxFeatures",
        "max_features_var": "maxFeaturesVar",
        "min_feature_quality": "minFeatureQuality",
        "min_feature_quality_var": "minFeatureQualityVar",
        "padding": "padding",
        "padding_var": "paddingVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeFeatureCrop:
    def __init__(
        self,
        *,
        fail_gravity: typing.Optional[builtins.str] = None,
        fail_gravity_var: typing.Optional[builtins.str] = None,
        feature_radius: typing.Optional[builtins.str] = None,
        feature_radius_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        max_features: typing.Optional[builtins.str] = None,
        max_features_var: typing.Optional[builtins.str] = None,
        min_feature_quality: typing.Optional[builtins.str] = None,
        min_feature_quality_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fail_gravity: Controls placement of the crop if Image and Video Manager does not detect any features in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        :param fail_gravity_var: Controls placement of the crop if Image and Video Manager does not detect any features in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        :param feature_radius: The size in pixels of the important features to search for. If identified, two features never appear closer together than this value, ``8.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius DataAkamaiImagingPolicyImage#feature_radius}
        :param feature_radius_var: The size in pixels of the important features to search for. If identified, two features never appear closer together than this value, ``8.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius_var DataAkamaiImagingPolicyImage#feature_radius_var}
        :param gravity: Controls placement of the crop. Directions are relative to the region of interest plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Controls placement of the crop. Directions are relative to the region of interest plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param max_features: The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features DataAkamaiImagingPolicyImage#max_features}
        :param max_features_var: The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features_var DataAkamaiImagingPolicyImage#max_features_var}
        :param min_feature_quality: Determines the minimum quality level of the feature identified. To consider a feature important, the feature needs to surpass this value. Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality DataAkamaiImagingPolicyImage#min_feature_quality}
        :param min_feature_quality_var: Determines the minimum quality level of the feature identified. To consider a feature important, the feature needs to surpass this value. Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality_var DataAkamaiImagingPolicyImage#min_feature_quality_var}
        :param padding: Adds space around the region of interest. The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: Adds space around the region of interest. The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        :param style: Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ce8c8419b9c817aea9d17b4eaa33f7020fe0060e04299aaa43f5e8cd7933b5f7)
            check_type(argname="argument fail_gravity", value=fail_gravity, expected_type=type_hints["fail_gravity"])
            check_type(argname="argument fail_gravity_var", value=fail_gravity_var, expected_type=type_hints["fail_gravity_var"])
            check_type(argname="argument feature_radius", value=feature_radius, expected_type=type_hints["feature_radius"])
            check_type(argname="argument feature_radius_var", value=feature_radius_var, expected_type=type_hints["feature_radius_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument max_features", value=max_features, expected_type=type_hints["max_features"])
            check_type(argname="argument max_features_var", value=max_features_var, expected_type=type_hints["max_features_var"])
            check_type(argname="argument min_feature_quality", value=min_feature_quality, expected_type=type_hints["min_feature_quality"])
            check_type(argname="argument min_feature_quality_var", value=min_feature_quality_var, expected_type=type_hints["min_feature_quality_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fail_gravity is not None:
            self._values["fail_gravity"] = fail_gravity
        if fail_gravity_var is not None:
            self._values["fail_gravity_var"] = fail_gravity_var
        if feature_radius is not None:
            self._values["feature_radius"] = feature_radius
        if feature_radius_var is not None:
            self._values["feature_radius_var"] = feature_radius_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if max_features is not None:
            self._values["max_features"] = max_features
        if max_features_var is not None:
            self._values["max_features_var"] = max_features_var
        if min_feature_quality is not None:
            self._values["min_feature_quality"] = min_feature_quality
        if min_feature_quality_var is not None:
            self._values["min_feature_quality_var"] = min_feature_quality_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def fail_gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any features in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        '''
        result = self._values.get("fail_gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any features in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        '''
        result = self._values.get("fail_gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feature_radius(self) -> typing.Optional[builtins.str]:
        '''The size in pixels of the important features to search for.

        If identified, two features never appear closer together than this value, ``8.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius DataAkamaiImagingPolicyImage#feature_radius}
        '''
        result = self._values.get("feature_radius")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feature_radius_var(self) -> typing.Optional[builtins.str]:
        '''The size in pixels of the important features to search for.

        If identified, two features never appear closer together than this value, ``8.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius_var DataAkamaiImagingPolicyImage#feature_radius_var}
        '''
        result = self._values.get("feature_radius_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the region of interest plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the region of interest plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def max_features(self) -> typing.Optional[builtins.str]:
        '''The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features DataAkamaiImagingPolicyImage#max_features}
        '''
        result = self._values.get("max_features")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def max_features_var(self) -> typing.Optional[builtins.str]:
        '''The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features_var DataAkamaiImagingPolicyImage#max_features_var}
        '''
        result = self._values.get("max_features_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def min_feature_quality(self) -> typing.Optional[builtins.str]:
        '''Determines the minimum quality level of the feature identified.

        To consider a feature important, the feature needs to surpass this value.  Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality DataAkamaiImagingPolicyImage#min_feature_quality}
        '''
        result = self._values.get("min_feature_quality")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def min_feature_quality_var(self) -> typing.Optional[builtins.str]:
        '''Determines the minimum quality level of the feature identified.

        To consider a feature important, the feature needs to surpass this value.  Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality_var DataAkamaiImagingPolicyImage#min_feature_quality_var}
        '''
        result = self._values.get("min_feature_quality_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''Adds space around the region of interest.

        The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''Adds space around the region of interest.

        The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeFeatureCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeFeatureCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeFeatureCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b846b9bb40c396b859d29d0d4d851f30af44e2a23b28816294ab72608ce1f420)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeFeatureCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f016c54a21a27dd92b7656590b46bafa450c37cfc36bc78f8603bd678eab3edd)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeFeatureCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4f8d4bdcde30296388c52cb27585796992cc8ca5681d12693462f2daf5bd5da8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bec04d889f0d6254633e446bbc1f3584337ea24cdb0bdc9415b08660994f5a7f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__51044d2f64330bbc7fd889b3e4fca7fb025b9ca04d09eb3790eb24d8c590ec40)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeFeatureCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeFeatureCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeFeatureCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__feccfe104c7bfa3a4ff63da49e6800f432ca6ab551130c6412adc266e8eb61a0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeFeatureCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeFeatureCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3f3bb3f687a7a8d2fc21e2beb7de8d396808c83ad99c3245093448437be34653)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetFailGravity")
    def reset_fail_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravity", []))

    @jsii.member(jsii_name="resetFailGravityVar")
    def reset_fail_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravityVar", []))

    @jsii.member(jsii_name="resetFeatureRadius")
    def reset_feature_radius(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureRadius", []))

    @jsii.member(jsii_name="resetFeatureRadiusVar")
    def reset_feature_radius_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureRadiusVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetMaxFeatures")
    def reset_max_features(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxFeatures", []))

    @jsii.member(jsii_name="resetMaxFeaturesVar")
    def reset_max_features_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxFeaturesVar", []))

    @jsii.member(jsii_name="resetMinFeatureQuality")
    def reset_min_feature_quality(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMinFeatureQuality", []))

    @jsii.member(jsii_name="resetMinFeatureQualityVar")
    def reset_min_feature_quality_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMinFeatureQualityVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="failGravityInput")
    def fail_gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityVarInput")
    def fail_gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featureRadiusInput")
    def feature_radius_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featureRadiusInput"))

    @builtins.property
    @jsii.member(jsii_name="featureRadiusVarInput")
    def feature_radius_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featureRadiusVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesInput")
    def max_features_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "maxFeaturesInput"))

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesVarInput")
    def max_features_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "maxFeaturesVarInput"))

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityInput")
    def min_feature_quality_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "minFeatureQualityInput"))

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityVarInput")
    def min_feature_quality_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "minFeatureQualityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravity")
    def fail_gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravity"))

    @fail_gravity.setter
    def fail_gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df3a557371cd45704319074e8ad3f50aa2eed9db723aa56ccff26d6b24e818cb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravity", value)

    @builtins.property
    @jsii.member(jsii_name="failGravityVar")
    def fail_gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravityVar"))

    @fail_gravity_var.setter
    def fail_gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eaecb5e86a35595a28758dc9646e9490ee0c7e6084d487dfd5e2aee096c2c64a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="featureRadius")
    def feature_radius(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featureRadius"))

    @feature_radius.setter
    def feature_radius(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__409725b20a220b629ca12707baf3ab2a20da81c25a71da6e76b1c2290a78f1b4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featureRadius", value)

    @builtins.property
    @jsii.member(jsii_name="featureRadiusVar")
    def feature_radius_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featureRadiusVar"))

    @feature_radius_var.setter
    def feature_radius_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bedd0af211e27e1d813cb10ee4952c64ca49e4be4ceba3ddcf670a74c911841b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featureRadiusVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a420e90bea1db0e24730db1cbe991e726919ab9d82fb8b925885ef50db6bcd1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ec1bb1076c04421e3dfcd2d4c42e04a7663dbb85a2d6065c85a670e40e40b0f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3fecb8841c9cc1c351cd8e3cd1f14d4ec7082d9d367f2ba5c5300df66ca28ea8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ecaf1a6ba13cd587c3556cd51782137bb35adc66a9ba11b47edc1f3658ee088)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="maxFeatures")
    def max_features(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "maxFeatures"))

    @max_features.setter
    def max_features(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5e99efee7ef681855100fccf3f6104814a693ad7edfecf35efb8895d2424b6ff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "maxFeatures", value)

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesVar")
    def max_features_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "maxFeaturesVar"))

    @max_features_var.setter
    def max_features_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c34a24f3f714e60d735bbf8198d75a031d35e4769bfed1067a56a2c8a53a0826)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "maxFeaturesVar", value)

    @builtins.property
    @jsii.member(jsii_name="minFeatureQuality")
    def min_feature_quality(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "minFeatureQuality"))

    @min_feature_quality.setter
    def min_feature_quality(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5baccfcd6af8c9ca8ce200f4968d9585854eeb820cff0ae36488715fed96ffeb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "minFeatureQuality", value)

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityVar")
    def min_feature_quality_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "minFeatureQualityVar"))

    @min_feature_quality_var.setter
    def min_feature_quality_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__312ac062a7a6f5e137bc5965f5d4cecf7897fdb9431d1325561655c64107b760)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "minFeatureQualityVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6b16b5ce5bb95ecec8be047049534f00131254624c15becb4020ccd513f15cda)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ce79256ead2a6eb8020d623943ae38defe523d5078b039f855931433240b9ca9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c899a007b3b07647174c447956a909e22e81748b0e8b3364db094b633db95040)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac86f082588118921edd698c280bf841ba609496019c9f3282c62c2ff51105cd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9cc82143c602dd8887cec487fea224ada34ad37791ca04987fd714947aabd04e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9e0761e7bc13299de785a21ac421cd1fe3d25c8ae5c00f321e27cf2c42c238e7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeFeatureCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeFeatureCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeFeatureCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ac5c6babbd1428c24913d2796df8f0e514f1b7d4ef29de2a77d4e435129e7f7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeFitAndFill",
    jsii_struct_bases=[],
    name_mapping={
        "fill_transformation": "fillTransformation",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeFitAndFill:
    def __init__(
        self,
        *,
        fill_transformation: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeFitAndFillFillTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fill_transformation: fill_transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_transformation DataAkamaiImagingPolicyImage#fill_transformation}
        :param height: The height value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The width value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(fill_transformation, dict):
            fill_transformation = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeFitAndFillFillTransformation(**fill_transformation)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__780c6c52a9479b6cea2cafa7b03f0470eba75c8391e3cca2fc9aa40120b32972)
            check_type(argname="argument fill_transformation", value=fill_transformation, expected_type=type_hints["fill_transformation"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fill_transformation is not None:
            self._values["fill_transformation"] = fill_transformation
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def fill_transformation(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeFitAndFillFillTransformation"]:
        '''fill_transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_transformation DataAkamaiImagingPolicyImage#fill_transformation}
        '''
        result = self._values.get("fill_transformation")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeFitAndFillFillTransformation"], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeFitAndFill(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeFitAndFillFillTransformation",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeFitAndFillFillTransformation:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeFitAndFillFillTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeFitAndFillFillTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeFitAndFillFillTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4537f1564d2122579e054bc50e74748ee675a609a1c65d60e3f2c8ad1fffb46e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeFitAndFillFillTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeFitAndFillFillTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeFitAndFillFillTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c5d3f6d00b3b35a04474a8451380d1484df84c62d9c648a3f033f2097a619068)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeFitAndFillList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeFitAndFillList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cacfd24f4413f02762cf0a12eb370599d564b0ccde1b34f2b92cb51a56cb2f78)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeFitAndFillOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f325b1b9f54265a709f17e70fadc75349fda6af3017bac4acf2de7194f1eb5f8)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeFitAndFillOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3bec8bccb05717f547a50bebe2beb3c584b621c11583972c225478aabf5bcdc6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c31847207930ba7f8a4ac579177a2774501c16734abd9dc3c5b41ff8adba2351)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__25bf8c24bf24aa00be978779fca86d573abc879aceb0a142eb985a0892b66368)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeFitAndFill]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeFitAndFill]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeFitAndFill]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__65d69086628a36d7964cdff5157c484ffbffdae6d4cc75aac905670326988198)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeFitAndFillOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeFitAndFillOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f80e9066a9bc5bd3680a44024551c415af94d28ea4a9eb5d9b9427cf9a3194dc)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putFillTransformation")
    def put_fill_transformation(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeFitAndFillFillTransformation()

        return typing.cast(None, jsii.invoke(self, "putFillTransformation", [value]))

    @jsii.member(jsii_name="resetFillTransformation")
    def reset_fill_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFillTransformation", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="fillTransformation")
    def fill_transformation(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeFitAndFillFillTransformationOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeFitAndFillFillTransformationOutputReference, jsii.get(self, "fillTransformation"))

    @builtins.property
    @jsii.member(jsii_name="fillTransformationInput")
    def fill_transformation_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeFitAndFillFillTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeFitAndFillFillTransformation], jsii.get(self, "fillTransformationInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1db0f8387c707262eb3659f9b7cd6d1ea1e164ea9ed41c78a02c1728f3a866e3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0cbe060c52ff407beede795d28e949b1e164e79fdee15b95d595868bd10547ad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__86497421fbd0d6afce9225fa6b58fafe53476c9288f536b94b952abde6a20944)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f5f4ad347fcfa623a2ee1c58d14c148b942edda9091b974fdc380bab862e6d50)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeFitAndFill]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeFitAndFill]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeFitAndFill]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__deb2c2d3443fe14077e115bd446929e3f4adbacb0a82a1a4b36dd99b85f9461f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeGoop",
    jsii_struct_bases=[],
    name_mapping={
        "chaos": "chaos",
        "chaos_var": "chaosVar",
        "density": "density",
        "density_var": "densityVar",
        "power": "power",
        "power_var": "powerVar",
        "seed": "seed",
        "seed_var": "seedVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeGoop:
    def __init__(
        self,
        *,
        chaos: typing.Optional[builtins.str] = None,
        chaos_var: typing.Optional[builtins.str] = None,
        density: typing.Optional[builtins.str] = None,
        density_var: typing.Optional[builtins.str] = None,
        power: typing.Optional[builtins.str] = None,
        power_var: typing.Optional[builtins.str] = None,
        seed: typing.Optional[builtins.str] = None,
        seed_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param chaos: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        :param chaos_var: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        :param density: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        :param density_var: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        :param power: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        :param power_var: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        :param seed: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        :param seed_var: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__17823615af8cfeeaf9066f33be397a863001250738d9d629b59360a52a5f2c7c)
            check_type(argname="argument chaos", value=chaos, expected_type=type_hints["chaos"])
            check_type(argname="argument chaos_var", value=chaos_var, expected_type=type_hints["chaos_var"])
            check_type(argname="argument density", value=density, expected_type=type_hints["density"])
            check_type(argname="argument density_var", value=density_var, expected_type=type_hints["density_var"])
            check_type(argname="argument power", value=power, expected_type=type_hints["power"])
            check_type(argname="argument power_var", value=power_var, expected_type=type_hints["power_var"])
            check_type(argname="argument seed", value=seed, expected_type=type_hints["seed"])
            check_type(argname="argument seed_var", value=seed_var, expected_type=type_hints["seed_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if chaos is not None:
            self._values["chaos"] = chaos
        if chaos_var is not None:
            self._values["chaos_var"] = chaos_var
        if density is not None:
            self._values["density"] = density
        if density_var is not None:
            self._values["density_var"] = density_var
        if power is not None:
            self._values["power"] = power
        if power_var is not None:
            self._values["power_var"] = power_var
        if seed is not None:
            self._values["seed"] = seed
        if seed_var is not None:
            self._values["seed_var"] = seed_var

    @builtins.property
    def chaos(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        '''
        result = self._values.get("chaos")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def chaos_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        '''
        result = self._values.get("chaos_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        '''
        result = self._values.get("density")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density_var(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        '''
        result = self._values.get("density_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        '''
        result = self._values.get("power")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power_var(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        '''
        result = self._values.get("power_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        '''
        result = self._values.get("seed")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed_var(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        result = self._values.get("seed_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeGoop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeGoopList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeGoopList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0684b09de4c989cc737d78f967ca05b899fe796ddfb6ae0d72e99adefd8db6a3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeGoopOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7e643a04aaf1fe4c3d973042ee75ce7c7544953908e26dd3b3a221ebc52000f2)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeGoopOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e5232ac6080b49a25a8de8d5888aa54119231e8de8d408476301eddf36e3e7b2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a7d8a379332f25e8d6d4002753648525407b3b07622f05ea0017cd5e6617e9a3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc29e2a15ab02c908c1315bab467c4fdc123506e7d245782f7b5fc91d13703da)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeGoop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeGoop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2620255e5b64266ea1cb734e038cd1bfb9d93483b53760f745a4956811909fe2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeGoopOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeGoopOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b60727c24c510b0777c2e03c9338f593e4f180661719f6be864bd46ab0d9b1ef)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetChaos")
    def reset_chaos(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaos", []))

    @jsii.member(jsii_name="resetChaosVar")
    def reset_chaos_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaosVar", []))

    @jsii.member(jsii_name="resetDensity")
    def reset_density(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensity", []))

    @jsii.member(jsii_name="resetDensityVar")
    def reset_density_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensityVar", []))

    @jsii.member(jsii_name="resetPower")
    def reset_power(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPower", []))

    @jsii.member(jsii_name="resetPowerVar")
    def reset_power_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPowerVar", []))

    @jsii.member(jsii_name="resetSeed")
    def reset_seed(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeed", []))

    @jsii.member(jsii_name="resetSeedVar")
    def reset_seed_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeedVar", []))

    @builtins.property
    @jsii.member(jsii_name="chaosInput")
    def chaos_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosInput"))

    @builtins.property
    @jsii.member(jsii_name="chaosVarInput")
    def chaos_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosVarInput"))

    @builtins.property
    @jsii.member(jsii_name="densityInput")
    def density_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityInput"))

    @builtins.property
    @jsii.member(jsii_name="densityVarInput")
    def density_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="powerInput")
    def power_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerInput"))

    @builtins.property
    @jsii.member(jsii_name="powerVarInput")
    def power_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerVarInput"))

    @builtins.property
    @jsii.member(jsii_name="seedInput")
    def seed_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedInput"))

    @builtins.property
    @jsii.member(jsii_name="seedVarInput")
    def seed_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedVarInput"))

    @builtins.property
    @jsii.member(jsii_name="chaos")
    def chaos(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaos"))

    @chaos.setter
    def chaos(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd2853ad09e97ef028d85315ffb648de832c7f0a0d63ee48a51041cca828468b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaos", value)

    @builtins.property
    @jsii.member(jsii_name="chaosVar")
    def chaos_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaosVar"))

    @chaos_var.setter
    def chaos_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__00cc1f5bd2e03ef65b5519e70ceae5a600fac4dbc8b7e5c9b4b9217d2472667c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaosVar", value)

    @builtins.property
    @jsii.member(jsii_name="density")
    def density(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "density"))

    @density.setter
    def density(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd2d53ef31d1cd951099a1477b57b5302239e397c4eaf5721369abd416f97348)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "density", value)

    @builtins.property
    @jsii.member(jsii_name="densityVar")
    def density_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "densityVar"))

    @density_var.setter
    def density_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3b83732e5fb86de42c2ee1ea762f228f2ffb87e3e8208fde0ccb815fb78f82cf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "densityVar", value)

    @builtins.property
    @jsii.member(jsii_name="power")
    def power(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "power"))

    @power.setter
    def power(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__55083bb1d0a71777317ce23a8fc9eb69538f21f27909f11ed9879a369057c697)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "power", value)

    @builtins.property
    @jsii.member(jsii_name="powerVar")
    def power_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "powerVar"))

    @power_var.setter
    def power_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9576de8dfd2faee7367d18a26096afbb8b6f5a1878a0279ff06673ba8f9e2eff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "powerVar", value)

    @builtins.property
    @jsii.member(jsii_name="seed")
    def seed(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seed"))

    @seed.setter
    def seed(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e1dde2b8c79cc2c8cfbef77eade1e39b5686d71425bc674d279be3bd444e3f4a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seed", value)

    @builtins.property
    @jsii.member(jsii_name="seedVar")
    def seed_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seedVar"))

    @seed_var.setter
    def seed_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a0d43e84f5ab7395d377b72763fc2b8d1ad21faa2f0c951ec911f7c4268ee0b5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seedVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeGoop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeGoop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeGoop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__47ba3398b737d0b8c94fa819fca0be1e0cba41f3b3c055d9c1ab3365ff9e2f5b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeGrayscale",
    jsii_struct_bases=[],
    name_mapping={"type": "type", "type_var": "typeVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeGrayscale:
    def __init__(
        self,
        *,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param type: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__32717e864d59028db7daa1d3eec24193ef1ddeb10b681821f7dd1548928bd03e)
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeGrayscale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeGrayscaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeGrayscaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c067b2bab3e1d84a598baeeca57340aa614c8cf2a07e3d7ad6a649ba181dd95d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeGrayscaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea7609b0bec7a36cea75fff5e5d4bde42fa64a1579a6f6dbeec486ad3ff16974)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeGrayscaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aa1972acf437be81d49d3ba9e222d065acc1f3a125b07b9177186215a5a71802)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__173acb9f4f54d78320dc12a75be33786256268301adc26f1bd2ef12aa20fb180)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a77c918ab18132c1f491998b3883fadfd20388d8697b075902a7084574cd63fd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeGrayscale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeGrayscale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fbb08361bcc6027dc998d27e1d7dc4978ae8dec7414e74f6988ced543b0a3757)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeGrayscaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeGrayscaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a979bf720c8a97c71171c377b9287d06ec0c24aa85abb77f656cc65e592b8fd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d7e001846d0ffa505fce6bdd2efe5fec54d0975bd38153c655dd53bf95c8992)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__00dc844f28e8a4be2128063ef1a68d496d55c5906b605e2764764920b4674da2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeGrayscale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeGrayscale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeGrayscale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cb30a3b5b52ebf75cde0a3a80ca3840df57bb0f41013a522ca780ad85416dc08)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeHsl",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "lightness": "lightness",
        "lightness_var": "lightnessVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeHsl:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness: typing.Optional[builtins.str] = None,
        lightness_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        :param lightness_var: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3eaf43e924bd1547ab3b6237bc3f667ef816cb0c622b17e8915ef74fbb98a515)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness", value=lightness, expected_type=type_hints["lightness"])
            check_type(argname="argument lightness_var", value=lightness_var, expected_type=type_hints["lightness_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness is not None:
            self._values["lightness"] = lightness
        if lightness_var is not None:
            self._values["lightness_var"] = lightness_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        '''
        result = self._values.get("lightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        '''
        result = self._values.get("lightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeHsl(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeHslList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeHslList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__efa67dc60ea4edbdd658cdd4b128beed4b77a72cf17a5f473e6891802f7f697e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeHslOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5e17d30983601132e27dc49930c44816d80e192378a9104601f8de1964552ec9)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeHslOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c63b0be66bab03369170c71a581b9e402b42e92767d6874083ef4d9a7b0d9d15)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f32a43394d6c6a7abf126607b9efa3c48eefc31c5769ab579611156a7f75f5fe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__659c6a6c07918d13b42c9d0dd05774d424032dcb485de80161d52f4fdeaba110)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeHsl]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeHsl]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__70e5d7208e7858a2438d39bd7bd468dfceeb9825b08ffa1cc403f4e03b506701)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeHslOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeHslOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__87fb12777b98a5132eb24474e6e035df0e1124f201c2667f94732561a20e5b52)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightness")
    def reset_lightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightness", []))

    @jsii.member(jsii_name="resetLightnessVar")
    def reset_lightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessInput")
    def lightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessVarInput")
    def lightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8408af544ffc49b278e3bad0f7390767b63aa557a36462d16031bea1edb1ef92)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ae8c32306826f984b511e384ce2ca07cb285df0703f94b138a142f936180f6c1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightness")
    def lightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightness"))

    @lightness.setter
    def lightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__838a961a788f11aab76d1399618bd0ed5db3db68a8b8c12ddc707f2ddda59307)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightness", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessVar")
    def lightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessVar"))

    @lightness_var.setter
    def lightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__50453d3ea9a41aec220d5cf58993f31d8857e823292c8c35b379ea3f7dc44483)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ce364bf156cb1998e05f41cd5e0b803c2f2950e1bc205a4b36b15596b71026f5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dc1baa99c8b7b6dc56ae5b70695c1d7ccfbeca4acc4cd10db7b11b6bb0451850)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeHsl]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeHsl]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeHsl]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__07d7b349698d516b75e3394d57c1ac0cc7624f9bfe5bdd20e1e483790e96878d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeHsv",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeHsv:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        :param value: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c41acf399519f27e8d98af68dee88891d1fa95c2be54367787f41b43ac4f1ea4)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeHsv(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeHsvList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeHsvList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c262a56f638873ef7340dcba469050833abc511fe6092f63fe0c3b11e82f951c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeHsvOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1b6ebd1575939c6c55bfc5b88c41999fb56a856c81b58841c7bea8ddd22fdca7)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeHsvOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e25e488bae6a96d8639988da3e5c98eda5f9f43de11feace668936cecddc31b6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__713bfae9fce79821f08aae675800dd32f68c589fed91d718c65596111c2d5678)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fb6401f2a9299230f7416463bee3067f6e03517de16a44b7848d6d653e785047)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeHsv]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeHsv]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e821ed09e419ce1266fb2c422ad3f7f9fb4eca18f2b285156c54a1e14cc16ebb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeHsvOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeHsvOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0158c65547bfcf8e34a67077ef5c08f49dd23a4ac9afc9d9279b5f4ccfc7fff8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4b497121ed991a319391d36721f3fd25bf1c4d1998696cb031f2689998d5b2a6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bf718092065996306ca4736d1499d14108a1335deec151d8163deafdb3f7fef6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__81d92b4eb2cc108ebb78b0950eae8abf7692cc1ebc0ca84ec48a3ab600e8b868)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__381cbc35b775e4192e6513e45e556ad0ff4d09272b0d1e9aa514951fb9e37869)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bac00b0e6d9b25a71c0f2cb4c85f03b45a29b00ee519db322e8417009ff206a7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8e28f91627ef60f213306ba7c06e3d5f7e17e46ca8af20612058cd6da53b0a06)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeHsv]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeHsv]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeHsv]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5fadb7820db8e2b068f8cb3b39d5d7f1a849931d06eb194b0c691616bfa21b6b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimension",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "dimension": "dimension",
        "dimension_var": "dimensionVar",
        "equal": "equal",
        "greater_than": "greaterThan",
        "less_than": "lessThan",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimension:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        dimension: typing.Optional[builtins.str] = None,
        dimension_var: typing.Optional[builtins.str] = None,
        equal: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionEqual", typing.Dict[builtins.str, typing.Any]]] = None,
        greater_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionGreaterThan", typing.Dict[builtins.str, typing.Any]]] = None,
        less_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionLessThan", typing.Dict[builtins.str, typing.Any]]] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param dimension: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        :param dimension_var: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        :param equal: equal block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        :param greater_than: greater_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        :param less_than: less_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        :param value: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionDefault(**default)
        if isinstance(equal, dict):
            equal = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionEqual(**equal)
        if isinstance(greater_than, dict):
            greater_than = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionGreaterThan(**greater_than)
        if isinstance(less_than, dict):
            less_than = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionLessThan(**less_than)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f0a64b8e4abf1fe9fc91154fd5964c5c11017220574846df8c0fbf30fa30f92c)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument dimension", value=dimension, expected_type=type_hints["dimension"])
            check_type(argname="argument dimension_var", value=dimension_var, expected_type=type_hints["dimension_var"])
            check_type(argname="argument equal", value=equal, expected_type=type_hints["equal"])
            check_type(argname="argument greater_than", value=greater_than, expected_type=type_hints["greater_than"])
            check_type(argname="argument less_than", value=less_than, expected_type=type_hints["less_than"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if dimension is not None:
            self._values["dimension"] = dimension
        if dimension_var is not None:
            self._values["dimension_var"] = dimension_var
        if equal is not None:
            self._values["equal"] = equal
        if greater_than is not None:
            self._values["greater_than"] = greater_than
        if less_than is not None:
            self._values["less_than"] = less_than
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionDefault"], result)

    @builtins.property
    def dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        '''
        result = self._values.get("dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        '''
        result = self._values.get("dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def equal(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionEqual"]:
        '''equal block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        '''
        result = self._values.get("equal")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionEqual"], result)

    @builtins.property
    def greater_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionGreaterThan"]:
        '''greater_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        '''
        result = self._values.get("greater_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionGreaterThan"], result)

    @builtins.property
    def less_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionLessThan"]:
        '''less_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        '''
        result = self._values.get("less_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionLessThan"], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimension(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ea78019997760d84189f35bcde5aabc723f15f44a02b5e5bf834d4445f88549)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__29c6df35997665ae10750b1cf8c6d4bbb9f24aef4468f8f46d3d17ed07f8d8cc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionEqual",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionEqual:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionEqual(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionEqualOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionEqualOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c31b125f7912828183c07219d38ed233c0d5759eb1ba5bc59918a1324436608e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionEqual], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionEqual],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a7e83e4736604357f0dc6009ea16dc1b76ae3901529af23db0e961805218b37)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionGreaterThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionGreaterThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionGreaterThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionGreaterThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionGreaterThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__094e0013b16fe3dbe4e56d0ea360bf09256963849938ace524ee91ba8a2702b0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionGreaterThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionGreaterThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__690168d41e9cdff4d5c36b1be088556809e35191ee69d7dec849ea2dd2eead9b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionLessThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionLessThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionLessThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionLessThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionLessThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f59899474f4ece4e3e6ff9654da6a9ab952f8a48d778ced7f583ceaa2427499f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionLessThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionLessThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7e9de5731dcfca9c2d39c9d5a8682bcaf1101b0336d2d3e3fbec44de6c2a93ec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a8f7ea02c02d47d208ada40ed1fd4788d9643ecc4e303f3c9fc06f4b92719132)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__61130c933bbd2efb3189d30c0ac9c61e33762168318d380f3fcf24e0e3bdcf98)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d379605efb70e99169ed22bf675e96c87cbf14920e4fe897dcc848aef10ac56)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cb20643e0a18aa6c663d60a9c7ce6b9a949dfe34edca924c8af30a985a37cb21)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c92d59fd71b7a0fc39b79d8982068887b449e7d99ac4d5742d5c30d7b41a60dc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimension]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimension]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c5cc6bc4fb94b51f3aa1986786e967a43d265bbd48206a3813a04f6f9afbb2b2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__95c91ace392ba90927026e6bbf001fda3665d4a4a01faf2ad09c9b52e24eaeaf)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putEqual")
    def put_equal(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionEqual()

        return typing.cast(None, jsii.invoke(self, "putEqual", [value]))

    @jsii.member(jsii_name="putGreaterThan")
    def put_greater_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionGreaterThan()

        return typing.cast(None, jsii.invoke(self, "putGreaterThan", [value]))

    @jsii.member(jsii_name="putLessThan")
    def put_less_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionLessThan()

        return typing.cast(None, jsii.invoke(self, "putLessThan", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetDimension")
    def reset_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimension", []))

    @jsii.member(jsii_name="resetDimensionVar")
    def reset_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimensionVar", []))

    @jsii.member(jsii_name="resetEqual")
    def reset_equal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEqual", []))

    @jsii.member(jsii_name="resetGreaterThan")
    def reset_greater_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGreaterThan", []))

    @jsii.member(jsii_name="resetLessThan")
    def reset_less_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLessThan", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="equal")
    def equal(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionEqualOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionEqualOutputReference, jsii.get(self, "equal"))

    @builtins.property
    @jsii.member(jsii_name="greaterThan")
    def greater_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionGreaterThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionGreaterThanOutputReference, jsii.get(self, "greaterThan"))

    @builtins.property
    @jsii.member(jsii_name="lessThan")
    def less_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionLessThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionLessThanOutputReference, jsii.get(self, "lessThan"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionInput")
    def dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionVarInput")
    def dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="equalInput")
    def equal_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionEqual], jsii.get(self, "equalInput"))

    @builtins.property
    @jsii.member(jsii_name="greaterThanInput")
    def greater_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionGreaterThan], jsii.get(self, "greaterThanInput"))

    @builtins.property
    @jsii.member(jsii_name="lessThanInput")
    def less_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionLessThan], jsii.get(self, "lessThanInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="dimension")
    def dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimension"))

    @dimension.setter
    def dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a0a306baaa921ef50d7142043def990642fae01ff31230eba802dba793d076f6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimension", value)

    @builtins.property
    @jsii.member(jsii_name="dimensionVar")
    def dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimensionVar"))

    @dimension_var.setter
    def dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5b8c367004f4ea7dab59cc6fcc5f959f598fe8f8c1074def2c1265db2f1d1977)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d672a4abbcf669cc562de39bffa752ee50e16ef425c7baaac85514741db85957)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__239088724e4b0b06819a3dea1ad466c50c88fc8f809a753ab7ca723d3b1c84ee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimension]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimension]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimension]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bddc424cc9405078f49fafa778e879cbbd8d79aba0f08b9f40f3d89bd2498d4a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientation",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "landscape": "landscape",
        "portrait": "portrait",
        "square": "square",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientation:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        landscape: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationLandscape", typing.Dict[builtins.str, typing.Any]]] = None,
        portrait: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationPortrait", typing.Dict[builtins.str, typing.Any]]] = None,
        square: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationSquare", typing.Dict[builtins.str, typing.Any]]] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param landscape: landscape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        :param portrait: portrait block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        :param square: square block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationDefault(**default)
        if isinstance(landscape, dict):
            landscape = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationLandscape(**landscape)
        if isinstance(portrait, dict):
            portrait = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationPortrait(**portrait)
        if isinstance(square, dict):
            square = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationSquare(**square)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__78ab52f1b4f0d1783dcb2b1b4d02fab8fe31f3b83acb0999e39d22948246758d)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument landscape", value=landscape, expected_type=type_hints["landscape"])
            check_type(argname="argument portrait", value=portrait, expected_type=type_hints["portrait"])
            check_type(argname="argument square", value=square, expected_type=type_hints["square"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if landscape is not None:
            self._values["landscape"] = landscape
        if portrait is not None:
            self._values["portrait"] = portrait
        if square is not None:
            self._values["square"] = square

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationDefault"], result)

    @builtins.property
    def landscape(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationLandscape"]:
        '''landscape block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        '''
        result = self._values.get("landscape")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationLandscape"], result)

    @builtins.property
    def portrait(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationPortrait"]:
        '''portrait block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        '''
        result = self._values.get("portrait")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationPortrait"], result)

    @builtins.property
    def square(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationSquare"]:
        '''square block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        result = self._values.get("square")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationSquare"], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dccb4dddabd59cc50d0097c45204f6284c539553ba3282481514cdc761e75161)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__42aee0da135881327477c607ab1e8449176214736591b4fee8df615ce1d3d467)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationLandscape",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationLandscape:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationLandscape(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationLandscapeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationLandscapeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e36e862ec3b690e76979ceaf4f60677aaeacb368641745d8f527985062a445b6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationLandscape], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationLandscape],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c874decd6c21b83cb72b7863a8da05936d1d5b9375dad8292c0e4b2cd1352308)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__01a007c3ecd8ae886fd6c3539ee946a948df289fb225942fe29346af266ccc78)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8145753129a0d0381023d5d43f602f5cbfb93dddcec617b38acc5734d24d3645)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9f04f81a306af9cbeace9286762b16c2d0468509a6b1f00143b4e57994d4bb40)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8ddfba3486ee71f9da56481b0f3d385564f0f5beab269b613051151e81253f39)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7351569cf3e7634e46e2f125b323ca42b787868b19621257087e3a67edf93a48)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientation]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientation]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b8844a17f8db51560f03212904d3b1542d4320b0a56c14035f98d9f8164a3997)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0209a6c14961c9a4d7cc867068f2f9d45ff03c56a37790e2fa3f73c9da937fcc)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putLandscape")
    def put_landscape(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationLandscape()

        return typing.cast(None, jsii.invoke(self, "putLandscape", [value]))

    @jsii.member(jsii_name="putPortrait")
    def put_portrait(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationPortrait()

        return typing.cast(None, jsii.invoke(self, "putPortrait", [value]))

    @jsii.member(jsii_name="putSquare")
    def put_square(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationSquare()

        return typing.cast(None, jsii.invoke(self, "putSquare", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetLandscape")
    def reset_landscape(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLandscape", []))

    @jsii.member(jsii_name="resetPortrait")
    def reset_portrait(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPortrait", []))

    @jsii.member(jsii_name="resetSquare")
    def reset_square(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSquare", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="landscape")
    def landscape(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationLandscapeOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationLandscapeOutputReference, jsii.get(self, "landscape"))

    @builtins.property
    @jsii.member(jsii_name="portrait")
    def portrait(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationPortraitOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationPortraitOutputReference", jsii.get(self, "portrait"))

    @builtins.property
    @jsii.member(jsii_name="square")
    def square(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationSquareOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationSquareOutputReference", jsii.get(self, "square"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="landscapeInput")
    def landscape_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationLandscape], jsii.get(self, "landscapeInput"))

    @builtins.property
    @jsii.member(jsii_name="portraitInput")
    def portrait_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationPortrait"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationPortrait"], jsii.get(self, "portraitInput"))

    @builtins.property
    @jsii.member(jsii_name="squareInput")
    def square_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationSquare"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationSquare"], jsii.get(self, "squareInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientation]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientation]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientation]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5b2735cbe9a5aaaae426ca0660485de38e8b4dfc891178f9d3a26a46410aefd7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationPortrait",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationPortrait:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationPortrait(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationPortraitOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationPortraitOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7c16024ba2b3f927a861193d7babd4fa9588340afbf12b26ea5cb635aea6f940)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationPortrait]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationPortrait], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationPortrait],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6d7151223683629f78060fbcb94a52cb865ff7cebe80cc61227198b4277b6cb9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationSquare",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationSquare:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationSquare(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationSquareOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationSquareOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__640ae1c48a3f3386de2736770b7fa51f4bb2951320253be1b5710a5a131cc289)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationSquare]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationSquare], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationSquare],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3128c522e2a296b9c73e1d92634439af1833fa85cb40a7331e76dda7ee314d7e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeImQuery",
    jsii_struct_bases=[],
    name_mapping={
        "allowed_transformations": "allowedTransformations",
        "query_var": "queryVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeImQuery:
    def __init__(
        self,
        *,
        allowed_transformations: typing.Sequence[builtins.str],
        query_var: builtins.str,
    ) -> None:
        '''
        :param allowed_transformations: Specifies the transformations that can be applied using the query string parameter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allowed_transformations DataAkamaiImagingPolicyImage#allowed_transformations}
        :param query_var: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#query_var DataAkamaiImagingPolicyImage#query_var}.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__45f2d843228246f4c6bdda65482a1630bf0c99290846b6734eab83c6cd10e1fa)
            check_type(argname="argument allowed_transformations", value=allowed_transformations, expected_type=type_hints["allowed_transformations"])
            check_type(argname="argument query_var", value=query_var, expected_type=type_hints["query_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "allowed_transformations": allowed_transformations,
            "query_var": query_var,
        }

    @builtins.property
    def allowed_transformations(self) -> typing.List[builtins.str]:
        '''Specifies the transformations that can be applied using the query string parameter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allowed_transformations DataAkamaiImagingPolicyImage#allowed_transformations}
        '''
        result = self._values.get("allowed_transformations")
        assert result is not None, "Required property 'allowed_transformations' is missing"
        return typing.cast(typing.List[builtins.str], result)

    @builtins.property
    def query_var(self) -> builtins.str:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#query_var DataAkamaiImagingPolicyImage#query_var}.'''
        result = self._values.get("query_var")
        assert result is not None, "Required property 'query_var' is missing"
        return typing.cast(builtins.str, result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeImQuery(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeImQueryList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeImQueryList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0f3eaf0d49563dec23d71519be751209e6567f87a91c6f9e8c839af206c924f7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeImQueryOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__65e35c95ed18581b070d9b124b00e751a860d44dfc0d9fbe725238bece04737c)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeImQueryOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c8d0c0ff433b80eefecc2a77bb208c8dfcbd7fa96079af126a1f534348e52514)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__572e807746d4690b44c74362a169b637900b7e85683330204bfe728d5aefa9d0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4231587d7ef59cc984541336efb1d11c31175d80d94e7a02a7954622469835bc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeImQuery]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeImQuery]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeImQuery]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4152ba17b022aa2dbf90f320ccf1caa054df75ab7e190a39b982097c384f92aa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeImQueryOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeImQueryOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__44f264a7e14efd3239ed188f10dddf3463ba07708b9234cdaa95f71afcc10218)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @builtins.property
    @jsii.member(jsii_name="allowedTransformationsInput")
    def allowed_transformations_input(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "allowedTransformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="queryVarInput")
    def query_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "queryVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowedTransformations")
    def allowed_transformations(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "allowedTransformations"))

    @allowed_transformations.setter
    def allowed_transformations(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1c3557ad8514bf2c1495446bb1de6a7c5b32088dd043f160161306c768036bdd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowedTransformations", value)

    @builtins.property
    @jsii.member(jsii_name="queryVar")
    def query_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "queryVar"))

    @query_var.setter
    def query_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ad601ef06c96c473fd4ca161923ec052b0f05c34b7cc7030d9119b52b8aad58b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "queryVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeImQuery]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeImQuery]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeImQuery]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__43f127a3271abe0ecd068c90496cadfca921f442a685c4dffa95a1b0567b5a63)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeMaxColors",
    jsii_struct_bases=[],
    name_mapping={"colors": "colors", "colors_var": "colorsVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeMaxColors:
    def __init__(
        self,
        *,
        colors: typing.Optional[builtins.str] = None,
        colors_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param colors: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        :param colors_var: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__52518211d1b167c16a70b6cd21b55d398034f19c8f1c99f5801d39d894b2f414)
            check_type(argname="argument colors", value=colors, expected_type=type_hints["colors"])
            check_type(argname="argument colors_var", value=colors_var, expected_type=type_hints["colors_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if colors is not None:
            self._values["colors"] = colors
        if colors_var is not None:
            self._values["colors_var"] = colors_var

    @builtins.property
    def colors(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        '''
        result = self._values.get("colors")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def colors_var(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        result = self._values.get("colors_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeMaxColors(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeMaxColorsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeMaxColorsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__89b150bd5c8b113d21ba0256b33903e3a7a0e0ac264a35d56f64e391a5a01ad4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeMaxColorsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c8951421ccd71fdc58289e4b756816d50d8fb2fb6788508c085f4899a0c52042)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeMaxColorsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__70605eb62c09ef83fadb9863f98d661dec6f33630791e48385c8dbe13b9932c8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f9535daf93db80a11c0666f3738ed5e0230293a95a919dc13a1d0304aa907090)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__39ee6fe5c41ced693beda99d90238af009a2e47a66253e421009ff19144030ee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeMaxColors]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeMaxColors]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cff293b21fe942e10df1c499eb760b16d23ba6e84f6e0c33cdd4662d7d94e08c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeMaxColorsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeMaxColorsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__753ea3e71cce8720df8fabecbe6af2d287dde2898e3f7d4742ea88cb3c0d2b65)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColors")
    def reset_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColors", []))

    @jsii.member(jsii_name="resetColorsVar")
    def reset_colors_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorsVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorsInput")
    def colors_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsInput"))

    @builtins.property
    @jsii.member(jsii_name="colorsVarInput")
    def colors_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsVarInput"))

    @builtins.property
    @jsii.member(jsii_name="colors")
    def colors(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colors"))

    @colors.setter
    def colors(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0811a5ebbf61dedccceebf6766d28e805daffef53ec6ed2af2a8e7b657ad6def)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colors", value)

    @builtins.property
    @jsii.member(jsii_name="colorsVar")
    def colors_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorsVar"))

    @colors_var.setter
    def colors_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8023e38200ee756eff592b6867e9043fc2842974649c5bf15992109dc83870b7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorsVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeMaxColors]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeMaxColors]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeMaxColors]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__04ef8574c6bf7a7d1f89046b6ec7ebbc0ae0784dc6d895268906d134f182fa1f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeMirror",
    jsii_struct_bases=[],
    name_mapping={
        "horizontal": "horizontal",
        "horizontal_var": "horizontalVar",
        "vertical": "vertical",
        "vertical_var": "verticalVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeMirror:
    def __init__(
        self,
        *,
        horizontal: typing.Optional[builtins.str] = None,
        horizontal_var: typing.Optional[builtins.str] = None,
        vertical: typing.Optional[builtins.str] = None,
        vertical_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param horizontal: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        :param horizontal_var: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        :param vertical: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        :param vertical_var: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd5c4661635a4abdbc39b8b60b07e19f0e3f8e18be614d89c274b9afb148e97b)
            check_type(argname="argument horizontal", value=horizontal, expected_type=type_hints["horizontal"])
            check_type(argname="argument horizontal_var", value=horizontal_var, expected_type=type_hints["horizontal_var"])
            check_type(argname="argument vertical", value=vertical, expected_type=type_hints["vertical"])
            check_type(argname="argument vertical_var", value=vertical_var, expected_type=type_hints["vertical_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if horizontal is not None:
            self._values["horizontal"] = horizontal
        if horizontal_var is not None:
            self._values["horizontal_var"] = horizontal_var
        if vertical is not None:
            self._values["vertical"] = vertical
        if vertical_var is not None:
            self._values["vertical_var"] = vertical_var

    @builtins.property
    def horizontal(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        '''
        result = self._values.get("horizontal")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def horizontal_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        '''
        result = self._values.get("horizontal_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        '''
        result = self._values.get("vertical")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        result = self._values.get("vertical_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeMirror(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeMirrorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeMirrorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ab6f6a864c0bcccc03601c02953b0fbd43fdfc275a61b5be010813477c8d6a6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeMirrorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5a5cb40407ca0c0fa309a20687c69668b301e10c3253b33e9abd6e2eec6775cf)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeMirrorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__28c04c0af6c0dbed2582d754a4a1984b8381d5dc5a8d104bffa422a83c716e59)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cec657bb1edf408242f91a59d43f02ca2f70213196866237b9ff303557fbabb2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2e94b9bc729cd98830fe45ad54e01b24c6ecbd5c0d913ddb8dd576a9e8741c51)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeMirror]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeMirror]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3da5b867cdcc63717c04b96ea3e43f108848fd866cde90ee44efad4ce4389443)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeMirrorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeMirrorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__818cc3535886bbd43c7e610be55629d8bc94f63f6301aa0857eda5cd811720c1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHorizontal")
    def reset_horizontal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontal", []))

    @jsii.member(jsii_name="resetHorizontalVar")
    def reset_horizontal_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontalVar", []))

    @jsii.member(jsii_name="resetVertical")
    def reset_vertical(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVertical", []))

    @jsii.member(jsii_name="resetVerticalVar")
    def reset_vertical_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVerticalVar", []))

    @builtins.property
    @jsii.member(jsii_name="horizontalInput")
    def horizontal_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontalVarInput")
    def horizontal_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalInput")
    def vertical_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalVarInput")
    def vertical_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontal")
    def horizontal(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontal"))

    @horizontal.setter
    def horizontal(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4be9963058c5163e049f443b41ec54d27724a7c03b2714810b55e5d7bb0e51b0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontal", value)

    @builtins.property
    @jsii.member(jsii_name="horizontalVar")
    def horizontal_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontalVar"))

    @horizontal_var.setter
    def horizontal_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1b5d9b2883145c57869900d93680f8d1adbc6e9658beb92c2c3cddd1cd23f032)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontalVar", value)

    @builtins.property
    @jsii.member(jsii_name="vertical")
    def vertical(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "vertical"))

    @vertical.setter
    def vertical(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7a7cc2d45a64e5c8d9cbc63659c62cbc43f5ac10a47060e8c1640c7648e4fcd6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "vertical", value)

    @builtins.property
    @jsii.member(jsii_name="verticalVar")
    def vertical_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "verticalVar"))

    @vertical_var.setter
    def vertical_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__327468cef069e71f505ca0952f6e070c15c1e1ce470796d33db176faf41910f0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "verticalVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeMirror]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeMirror]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeMirror]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a4960881513c55753c923ebc014ff37011c8b1bf37ebf2db647c88d35745e2a6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeMonoHue",
    jsii_struct_bases=[],
    name_mapping={"hue": "hue", "hue_var": "hueVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeMonoHue:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__65378c427987e07c8cb35eba98ab054222a8a3575f2b9812d791dbaf75df26cc)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeMonoHue(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeMonoHueList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeMonoHueList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eec51bf5d50db90ac76692c9f229988aefb9f04b72a8d582dbf7bfeb90b8f41c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeMonoHueOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cac178a255c1a10f61f86fa146a8793208f774bc2d9f9d704a4077a45ad92c2b)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeMonoHueOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b2f39f794b39c9e555ba694c16907eaf931461762f2805a0eaf021326fa3e0a2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__efaa114b4a0f53e03dcdb0ba22962c352bb4f68fc7023ea459672f36473863f3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__10ac4936432c54614324f2694ab109e7d86e1f3cacd14369010e12a78b130ace)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeMonoHue]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeMonoHue]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__81d5395e148d88a0f127a3c9ff4f9fbeb2d067de03cb1e6c6535988327138a1a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeMonoHueOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeMonoHueOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cfa13fd06551d134a885c92962daaeab3f17439eb80b6fe995e143e64879ea0d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d7eb81d2b4f63ae37f9861cd03cd5282c41f0f1fa67a43e1bf33d72dbb585100)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__62beda5e6cadbd5496a37e40a51de4c4f412f23c019a14171ca5db7727e1b44d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeMonoHue]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeMonoHue]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeMonoHue]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ae76786522be645085b0d04249d8eabf00d267a63a01e641751a5eeb79eee3ff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeOpacity",
    jsii_struct_bases=[],
    name_mapping={"opacity": "opacity", "opacity_var": "opacityVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeOpacity:
    def __init__(
        self,
        *,
        opacity: typing.Optional[builtins.str] = None,
        opacity_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param opacity: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param opacity_var: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1df001ff3663f68dd32db989137753190271cf7e45ab0a4430de53ba300b7091)
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument opacity_var", value=opacity_var, expected_type=type_hints["opacity_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if opacity is not None:
            self._values["opacity"] = opacity
        if opacity_var is not None:
            self._values["opacity_var"] = opacity_var

    @builtins.property
    def opacity(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def opacity_var(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        result = self._values.get("opacity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeOpacity(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeOpacityList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeOpacityList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__90f45152d8038a67c4192f0453c9388703e214e4f47c33908e2679972e9011ee)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeOpacityOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e77091d2d810e917c69b7d31d821eb7ccdd8449c69873bfa2321325e4bfa36f7)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeOpacityOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__06b8c137116471813abb6415c4474a9e74a43bcd269e6392dd3ea986b4692da7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a9891c3a629961e11b5309a09781058cd2dfd5ba63e8dad7e7e81a62ce06261)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__96dce1e596abd5bf75cd1ed1abad9859c5560baae0cb607142a4372aa2a50ba1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeOpacity]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeOpacity]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1ce59711a1c42e2c84a6ee27c24fc105d54ef5ae6e2314aac1cbd856968596ee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeOpacityOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeOpacityOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e5f403d6bb466314e1ac3eff2364d7c535a40900b8f9359f1c320f5bc3e15c65)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetOpacityVar")
    def reset_opacity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacityVar", []))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityVarInput")
    def opacity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacity"))

    @opacity.setter
    def opacity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__47ae32e1749fd19d054ada9492e826f4f557ae309b6ca70dad12bb340ab77ace)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacity", value)

    @builtins.property
    @jsii.member(jsii_name="opacityVar")
    def opacity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacityVar"))

    @opacity_var.setter
    def opacity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__121ccf1307195ccc3c46c4578a42ab80f138ae074f96daa108b0c653604df254)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacityVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeOpacity]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeOpacity]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeOpacity]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8af2d2416ef047ae55345ddbef427666e89133f994c6d3c6f7057242db140add)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3edf256d7010275ae5c7b2414f4c60f732148832b96184d5794c8c44c1161b05)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putAppend")
    def put_append(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeAppend, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d17ac64a23698a9775c1864cabd0bddd504c6712e5ab62f471c9cfe159925d34)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putAppend", [value]))

    @jsii.member(jsii_name="putAspectCrop")
    def put_aspect_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeAspectCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ad49ccb56cfd7ed7816042692f210c68147f73d12545080f851623fb0735490c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putAspectCrop", [value]))

    @jsii.member(jsii_name="putBackgroundColor")
    def put_background_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__086a2a632b94c68bf3a73218fa3c274083b0dd2a6b5cbef2c69dc0ca1f016cd4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBackgroundColor", [value]))

    @jsii.member(jsii_name="putBlur")
    def put_blur(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeBlur, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b7ec9c711593b1e0fef3b81f9d7fe822625b9366d89b08b127e324d5cfd18201)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBlur", [value]))

    @jsii.member(jsii_name="putChromaKey")
    def put_chroma_key(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeChromaKey, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e90b924c39cfa76d45d7601241830b3cced46fc122f05532d5c323f72d4f476)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putChromaKey", [value]))

    @jsii.member(jsii_name="putComposite")
    def put_composite(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeComposite, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3282a61a811f94199d07a02b0101a42a6406c87f38e6eac3418198114994aace)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putComposite", [value]))

    @jsii.member(jsii_name="putCompound")
    def put_compound(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeCompound, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aae832f5acaae3159a50a61d6a25b94e9acba398fff18ed00b642ec8ca3cb077)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCompound", [value]))

    @jsii.member(jsii_name="putContrast")
    def put_contrast(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeContrast, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cc76b4a22035cb26404a44c4e35a6469c29b6faeb7f3e85fc95608794b07292a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putContrast", [value]))

    @jsii.member(jsii_name="putCrop")
    def put_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2c1422575a6967b8921327627fbeb4b3e63f893dd0eeafde2cf8e93ccf3249f7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCrop", [value]))

    @jsii.member(jsii_name="putFaceCrop")
    def put_face_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeFaceCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a193d50a82ec7ca4d0a8544c07d4e34dd53b4b24f59d7aeca4354d7cc88a7b6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFaceCrop", [value]))

    @jsii.member(jsii_name="putFeatureCrop")
    def put_feature_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeFeatureCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e6f567808ee1d4b972276c584e95f94d7997a5a8c544a60882e98cf8c8713c0d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFeatureCrop", [value]))

    @jsii.member(jsii_name="putFitAndFill")
    def put_fit_and_fill(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeFitAndFill, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c6adf1106f1189d432c1b6b8f6f9449af58dea55ff759ceb7dd8ff8b1e7c5568)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFitAndFill", [value]))

    @jsii.member(jsii_name="putGoop")
    def put_goop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeGoop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aa2b34647de1db69e1ff8f0f53213d70fb4b085811964d0f8582ae4a608dc812)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGoop", [value]))

    @jsii.member(jsii_name="putGrayscale")
    def put_grayscale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeGrayscale, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b72a09a7489224bae7e8f84c63f2073b4c72e85897a7caff52e3a04e66964444)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGrayscale", [value]))

    @jsii.member(jsii_name="putHsl")
    def put_hsl(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeHsl, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a81a31846ad1f2c89d3112cf97fd25a946a9f7c8b4f15d799c1e53058305d850)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsl", [value]))

    @jsii.member(jsii_name="putHsv")
    def put_hsv(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeHsv, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2c86898f87ad3aaec23ddf9799ad695da84da27d69c350059d9af130f6c24cee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsv", [value]))

    @jsii.member(jsii_name="putIfDimension")
    def put_if_dimension(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimension, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ec36251ac79f8f5a476bfbdbbfaf8f9ee2a00a9ebfb693ab2e2cd3180337028f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfDimension", [value]))

    @jsii.member(jsii_name="putIfOrientation")
    def put_if_orientation(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__72cabe4b6c31a9c3587b1a521c06183aeb7f864e0878e4e3724b6af15e16e469)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfOrientation", [value]))

    @jsii.member(jsii_name="putImQuery")
    def put_im_query(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeImQuery, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a2564d97a4ff59a38d914bfd230ea8874d0b28989845d4702ef35d17528eac9f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putImQuery", [value]))

    @jsii.member(jsii_name="putMaxColors")
    def put_max_colors(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeMaxColors, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a6981be70bb7088cd08024b4aa5d9edd300eb46904b833eac921f12441cf58d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMaxColors", [value]))

    @jsii.member(jsii_name="putMirror")
    def put_mirror(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeMirror, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0a93c4aceded282cfca59c3283dc1bbe422033a8dac96e3e183bbfa43efa510b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMirror", [value]))

    @jsii.member(jsii_name="putMonoHue")
    def put_mono_hue(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeMonoHue, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cf5cfcf82be44f3e118f00be8711cae3c2bc90db641fac6859885ee61edbca25)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMonoHue", [value]))

    @jsii.member(jsii_name="putOpacity")
    def put_opacity(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeOpacity, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dd9956e522c60cd90271985d99688889a1cec80ea822ca7113eafc5ca907c69d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putOpacity", [value]))

    @jsii.member(jsii_name="putRegionOfInterestCrop")
    def put_region_of_interest_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeRegionOfInterestCrop", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8ce348e68dfdf7734a5f0cbcce09feed5fadddef77eaefebd4f59a91b9a0533c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRegionOfInterestCrop", [value]))

    @jsii.member(jsii_name="putRelativeCrop")
    def put_relative_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeRelativeCrop", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af1711e5ac69b09de5d2431257aef7ebd06e45eb857e57c33532303dba59558c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRelativeCrop", [value]))

    @jsii.member(jsii_name="putRemoveColor")
    def put_remove_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeRemoveColor", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__908711e94fdc9ac4c4bcac5363b4c439f97a5d3af6385d8aaa3a2c1aaf143a53)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRemoveColor", [value]))

    @jsii.member(jsii_name="putResize")
    def put_resize(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeResize", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__34d74309fbb3692217e0cb091e2e567c2c20a1bf17e3147eeb0b7c4c435b229c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putResize", [value]))

    @jsii.member(jsii_name="putRotate")
    def put_rotate(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeRotate", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e7d2360d326c5ca3d06d9fd1f0f3875cbde913c04fd1948eccc466dbbb529c74)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRotate", [value]))

    @jsii.member(jsii_name="putScale")
    def put_scale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeScale", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a3cd9b0305a75f5483b0c0e852507e65972d6486a238e493e0a3e1c44233bb6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putScale", [value]))

    @jsii.member(jsii_name="putShear")
    def put_shear(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeShear", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e90d9038f2a2726c0ab856e753afe105d372a89c62fdd004c9f32716fb46e99b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putShear", [value]))

    @jsii.member(jsii_name="putTrim")
    def put_trim(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeTrim", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__064a761d69990e67cb0a3e2a0abd9b527f74c51b1931630d2f1d61587e53d351)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTrim", [value]))

    @jsii.member(jsii_name="putUnsharpMask")
    def put_unsharp_mask(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeUnsharpMask", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f23b4470b109f3f88e591883aa6d6a8f4b539f17060ca3d5682c7623f096fc63)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putUnsharpMask", [value]))

    @jsii.member(jsii_name="resetAppend")
    def reset_append(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAppend", []))

    @jsii.member(jsii_name="resetAspectCrop")
    def reset_aspect_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspectCrop", []))

    @jsii.member(jsii_name="resetBackgroundColor")
    def reset_background_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBackgroundColor", []))

    @jsii.member(jsii_name="resetBlur")
    def reset_blur(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBlur", []))

    @jsii.member(jsii_name="resetChromaKey")
    def reset_chroma_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChromaKey", []))

    @jsii.member(jsii_name="resetComposite")
    def reset_composite(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetComposite", []))

    @jsii.member(jsii_name="resetCompound")
    def reset_compound(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCompound", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetCrop")
    def reset_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCrop", []))

    @jsii.member(jsii_name="resetFaceCrop")
    def reset_face_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFaceCrop", []))

    @jsii.member(jsii_name="resetFeatureCrop")
    def reset_feature_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureCrop", []))

    @jsii.member(jsii_name="resetFitAndFill")
    def reset_fit_and_fill(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFitAndFill", []))

    @jsii.member(jsii_name="resetGoop")
    def reset_goop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGoop", []))

    @jsii.member(jsii_name="resetGrayscale")
    def reset_grayscale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGrayscale", []))

    @jsii.member(jsii_name="resetHsl")
    def reset_hsl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsl", []))

    @jsii.member(jsii_name="resetHsv")
    def reset_hsv(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsv", []))

    @jsii.member(jsii_name="resetIfDimension")
    def reset_if_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfDimension", []))

    @jsii.member(jsii_name="resetIfOrientation")
    def reset_if_orientation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfOrientation", []))

    @jsii.member(jsii_name="resetImQuery")
    def reset_im_query(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetImQuery", []))

    @jsii.member(jsii_name="resetMaxColors")
    def reset_max_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxColors", []))

    @jsii.member(jsii_name="resetMirror")
    def reset_mirror(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMirror", []))

    @jsii.member(jsii_name="resetMonoHue")
    def reset_mono_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonoHue", []))

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetRegionOfInterestCrop")
    def reset_region_of_interest_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRegionOfInterestCrop", []))

    @jsii.member(jsii_name="resetRelativeCrop")
    def reset_relative_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRelativeCrop", []))

    @jsii.member(jsii_name="resetRemoveColor")
    def reset_remove_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRemoveColor", []))

    @jsii.member(jsii_name="resetResize")
    def reset_resize(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetResize", []))

    @jsii.member(jsii_name="resetRotate")
    def reset_rotate(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRotate", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetShear")
    def reset_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetShear", []))

    @jsii.member(jsii_name="resetTrim")
    def reset_trim(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTrim", []))

    @jsii.member(jsii_name="resetUnsharpMask")
    def reset_unsharp_mask(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUnsharpMask", []))

    @builtins.property
    @jsii.member(jsii_name="append")
    def append(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeAppendList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeAppendList, jsii.get(self, "append"))

    @builtins.property
    @jsii.member(jsii_name="aspectCrop")
    def aspect_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeAspectCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeAspectCropList, jsii.get(self, "aspectCrop"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColor")
    def background_color(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeBackgroundColorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeBackgroundColorList, jsii.get(self, "backgroundColor"))

    @builtins.property
    @jsii.member(jsii_name="blur")
    def blur(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeBlurList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeBlurList, jsii.get(self, "blur"))

    @builtins.property
    @jsii.member(jsii_name="chromaKey")
    def chroma_key(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeChromaKeyList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeChromaKeyList, jsii.get(self, "chromaKey"))

    @builtins.property
    @jsii.member(jsii_name="composite")
    def composite(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeCompositeList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeCompositeList, jsii.get(self, "composite"))

    @builtins.property
    @jsii.member(jsii_name="compound")
    def compound(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeCompoundList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeCompoundList, jsii.get(self, "compound"))

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeContrastList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeContrastList, jsii.get(self, "contrast"))

    @builtins.property
    @jsii.member(jsii_name="crop")
    def crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeCropList, jsii.get(self, "crop"))

    @builtins.property
    @jsii.member(jsii_name="faceCrop")
    def face_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeFaceCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeFaceCropList, jsii.get(self, "faceCrop"))

    @builtins.property
    @jsii.member(jsii_name="featureCrop")
    def feature_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeFeatureCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeFeatureCropList, jsii.get(self, "featureCrop"))

    @builtins.property
    @jsii.member(jsii_name="fitAndFill")
    def fit_and_fill(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeFitAndFillList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeFitAndFillList, jsii.get(self, "fitAndFill"))

    @builtins.property
    @jsii.member(jsii_name="goop")
    def goop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeGoopList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeGoopList, jsii.get(self, "goop"))

    @builtins.property
    @jsii.member(jsii_name="grayscale")
    def grayscale(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeGrayscaleList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeGrayscaleList, jsii.get(self, "grayscale"))

    @builtins.property
    @jsii.member(jsii_name="hsl")
    def hsl(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeHslList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeHslList, jsii.get(self, "hsl"))

    @builtins.property
    @jsii.member(jsii_name="hsv")
    def hsv(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeHsvList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeHsvList, jsii.get(self, "hsv"))

    @builtins.property
    @jsii.member(jsii_name="ifDimension")
    def if_dimension(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionList, jsii.get(self, "ifDimension"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientation")
    def if_orientation(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationList, jsii.get(self, "ifOrientation"))

    @builtins.property
    @jsii.member(jsii_name="imQuery")
    def im_query(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeImQueryList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeImQueryList, jsii.get(self, "imQuery"))

    @builtins.property
    @jsii.member(jsii_name="maxColors")
    def max_colors(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeMaxColorsList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeMaxColorsList, jsii.get(self, "maxColors"))

    @builtins.property
    @jsii.member(jsii_name="mirror")
    def mirror(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeMirrorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeMirrorList, jsii.get(self, "mirror"))

    @builtins.property
    @jsii.member(jsii_name="monoHue")
    def mono_hue(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeMonoHueList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeMonoHueList, jsii.get(self, "monoHue"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeOpacityList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeOpacityList, jsii.get(self, "opacity"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestCrop")
    def region_of_interest_crop(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeRegionOfInterestCropList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeRegionOfInterestCropList", jsii.get(self, "regionOfInterestCrop"))

    @builtins.property
    @jsii.member(jsii_name="relativeCrop")
    def relative_crop(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeRelativeCropList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeRelativeCropList", jsii.get(self, "relativeCrop"))

    @builtins.property
    @jsii.member(jsii_name="removeColor")
    def remove_color(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeRemoveColorList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeRemoveColorList", jsii.get(self, "removeColor"))

    @builtins.property
    @jsii.member(jsii_name="resize")
    def resize(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeResizeList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeResizeList", jsii.get(self, "resize"))

    @builtins.property
    @jsii.member(jsii_name="rotate")
    def rotate(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeRotateList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeRotateList", jsii.get(self, "rotate"))

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeScaleList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeScaleList", jsii.get(self, "scale"))

    @builtins.property
    @jsii.member(jsii_name="shear")
    def shear(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeShearList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeShearList", jsii.get(self, "shear"))

    @builtins.property
    @jsii.member(jsii_name="trim")
    def trim(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeTrimList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeTrimList", jsii.get(self, "trim"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMask")
    def unsharp_mask(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeUnsharpMaskList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeUnsharpMaskList", jsii.get(self, "unsharpMask"))

    @builtins.property
    @jsii.member(jsii_name="appendInput")
    def append_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeAppend]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeAppend]]], jsii.get(self, "appendInput"))

    @builtins.property
    @jsii.member(jsii_name="aspectCropInput")
    def aspect_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeAspectCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeAspectCrop]]], jsii.get(self, "aspectCropInput"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColorInput")
    def background_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeBackgroundColor]]], jsii.get(self, "backgroundColorInput"))

    @builtins.property
    @jsii.member(jsii_name="blurInput")
    def blur_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeBlur]]], jsii.get(self, "blurInput"))

    @builtins.property
    @jsii.member(jsii_name="chromaKeyInput")
    def chroma_key_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeChromaKey]]], jsii.get(self, "chromaKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="compositeInput")
    def composite_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeComposite]]], jsii.get(self, "compositeInput"))

    @builtins.property
    @jsii.member(jsii_name="compoundInput")
    def compound_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeCompound]]], jsii.get(self, "compoundInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeContrast]]], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="cropInput")
    def crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeCrop]]], jsii.get(self, "cropInput"))

    @builtins.property
    @jsii.member(jsii_name="faceCropInput")
    def face_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeFaceCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeFaceCrop]]], jsii.get(self, "faceCropInput"))

    @builtins.property
    @jsii.member(jsii_name="featureCropInput")
    def feature_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeFeatureCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeFeatureCrop]]], jsii.get(self, "featureCropInput"))

    @builtins.property
    @jsii.member(jsii_name="fitAndFillInput")
    def fit_and_fill_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeFitAndFill]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeFitAndFill]]], jsii.get(self, "fitAndFillInput"))

    @builtins.property
    @jsii.member(jsii_name="goopInput")
    def goop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeGoop]]], jsii.get(self, "goopInput"))

    @builtins.property
    @jsii.member(jsii_name="grayscaleInput")
    def grayscale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeGrayscale]]], jsii.get(self, "grayscaleInput"))

    @builtins.property
    @jsii.member(jsii_name="hslInput")
    def hsl_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeHsl]]], jsii.get(self, "hslInput"))

    @builtins.property
    @jsii.member(jsii_name="hsvInput")
    def hsv_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeHsv]]], jsii.get(self, "hsvInput"))

    @builtins.property
    @jsii.member(jsii_name="ifDimensionInput")
    def if_dimension_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimension]]], jsii.get(self, "ifDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientationInput")
    def if_orientation_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientation]]], jsii.get(self, "ifOrientationInput"))

    @builtins.property
    @jsii.member(jsii_name="imQueryInput")
    def im_query_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeImQuery]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeImQuery]]], jsii.get(self, "imQueryInput"))

    @builtins.property
    @jsii.member(jsii_name="maxColorsInput")
    def max_colors_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeMaxColors]]], jsii.get(self, "maxColorsInput"))

    @builtins.property
    @jsii.member(jsii_name="mirrorInput")
    def mirror_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeMirror]]], jsii.get(self, "mirrorInput"))

    @builtins.property
    @jsii.member(jsii_name="monoHueInput")
    def mono_hue_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeMonoHue]]], jsii.get(self, "monoHueInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeOpacity]]], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestCropInput")
    def region_of_interest_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeRegionOfInterestCrop"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeRegionOfInterestCrop"]]], jsii.get(self, "regionOfInterestCropInput"))

    @builtins.property
    @jsii.member(jsii_name="relativeCropInput")
    def relative_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeRelativeCrop"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeRelativeCrop"]]], jsii.get(self, "relativeCropInput"))

    @builtins.property
    @jsii.member(jsii_name="removeColorInput")
    def remove_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeRemoveColor"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeRemoveColor"]]], jsii.get(self, "removeColorInput"))

    @builtins.property
    @jsii.member(jsii_name="resizeInput")
    def resize_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeResize"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeResize"]]], jsii.get(self, "resizeInput"))

    @builtins.property
    @jsii.member(jsii_name="rotateInput")
    def rotate_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeRotate"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeRotate"]]], jsii.get(self, "rotateInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeScale"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeScale"]]], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="shearInput")
    def shear_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeShear"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeShear"]]], jsii.get(self, "shearInput"))

    @builtins.property
    @jsii.member(jsii_name="trimInput")
    def trim_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeTrim"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeTrim"]]], jsii.get(self, "trimInput"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMaskInput")
    def unsharp_mask_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeUnsharpMask"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeUnsharpMask"]]], jsii.get(self, "unsharpMaskInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscape], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscape],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__14bfa144486c8cd27de97a5718b457b88a010260c8cd3fe5daac763e264bd861)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeRegionOfInterestCrop",
    jsii_struct_bases=[],
    name_mapping={
        "region_of_interest": "regionOfInterest",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeRegionOfInterestCrop:
    def __init__(
        self,
        *,
        region_of_interest: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeRegionOfInterestCropRegionOfInterest", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param region_of_interest: region_of_interest block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest DataAkamaiImagingPolicyImage#region_of_interest}
        :param gravity: The placement of the crop area relative to the specified area of interest. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: The placement of the crop area relative to the specified area of interest. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param style: Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(region_of_interest, dict):
            region_of_interest = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeRegionOfInterestCropRegionOfInterest(**region_of_interest)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5087e2bc54d312f806df1f54c4e2f8957df6f805f4c05c6810bdcdbb9d893752)
            check_type(argname="argument region_of_interest", value=region_of_interest, expected_type=type_hints["region_of_interest"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "region_of_interest": region_of_interest,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def region_of_interest(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeRegionOfInterestCropRegionOfInterest":
        '''region_of_interest block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest DataAkamaiImagingPolicyImage#region_of_interest}
        '''
        result = self._values.get("region_of_interest")
        assert result is not None, "Required property 'region_of_interest' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeRegionOfInterestCropRegionOfInterest", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''The placement of the crop area relative to the specified area of interest.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''The placement of the crop area relative to the specified area of interest.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeRegionOfInterestCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeRegionOfInterestCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeRegionOfInterestCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ff536b3f83d311ef4335b81b8fdea13247a294ecead9ff35244a6d98fd55b1db)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeRegionOfInterestCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2334e7586f6b4af3e709059ea1e7e0f8fd5eb37be832109068f6fa7a8ffc0477)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeRegionOfInterestCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fcc5ff833bafcd395740adb291dcd5b0c0ebdbe13928e8dd4d46a4e665dd73fa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1fb032439a03588fe0032843851171ab68e331c7f7608e69145ae0f65b6a57ad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f17c6a214cde63b1ce8e8e3023de5d25cc0ae0bcdd4032c0a118e96e0ee078f6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeRegionOfInterestCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeRegionOfInterestCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeRegionOfInterestCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a36e21b61bc9455869350ccc5348091eb7ee86fc5e6c77419770bfbc8cec2f25)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeRegionOfInterestCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeRegionOfInterestCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__60b3b7d67521c02d20db9899f5c699be2c6caef7cdccb5f3698da99ad47605f5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putRegionOfInterest")
    def put_region_of_interest(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeRegionOfInterestCropRegionOfInterest()

        return typing.cast(None, jsii.invoke(self, "putRegionOfInterest", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterest")
    def region_of_interest(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeRegionOfInterestCropRegionOfInterestOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeRegionOfInterestCropRegionOfInterestOutputReference", jsii.get(self, "regionOfInterest"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestInput")
    def region_of_interest_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeRegionOfInterestCropRegionOfInterest"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeRegionOfInterestCropRegionOfInterest"], jsii.get(self, "regionOfInterestInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e906b39c5a0966edc891f022e2801c27e7a2eeca23afe8bc34cae7f197961649)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea77d8f7b8c6af9794f44f3fc694c133f01b8ae6aa33b8045a0130ce434290b1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e933f639c05ab8e0ab9ffabec13f35ea03567b25b87fd1c38204c077f9244570)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0814851c6cc5bbfceb9c05472cb74a7161ffc4f8d75236ab782ac49303622adb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a4e6ff65320b1918d233e6e686ff0843b1cc036e5eb0a0ea6345a289cb82938a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__761afbab7df987431a777c1c75387c0fdc6cab5512ecbb55f8f620ffdfaebec5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__de6a8b72f87d06988374cfaec9ac21e0f81adad0dc796eb619df439c37ec630e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a73f1465e8184a39eb0a5e1b4e0b8bebbfa32bae30e4c74b2c9435a18fc8c921)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeRegionOfInterestCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeRegionOfInterestCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeRegionOfInterestCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6dc887e884951dcab70e63900c28c999f2a626e1a93c3cc169d56c212952a335)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeRegionOfInterestCropRegionOfInterest",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeRegionOfInterestCropRegionOfInterest:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeRegionOfInterestCropRegionOfInterest(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeRegionOfInterestCropRegionOfInterestOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeRegionOfInterestCropRegionOfInterestOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8b08815d136c77fadc02a385edef7997d4956d6367542fa0fd0d253f395cb7ba)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeRegionOfInterestCropRegionOfInterest]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeRegionOfInterestCropRegionOfInterest], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeRegionOfInterestCropRegionOfInterest],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a6c6a4a80191381a6c2c7e3688dd19818f749db4dea4f090cb6d54ef7ae859fb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeRelativeCrop",
    jsii_struct_bases=[],
    name_mapping={
        "east": "east",
        "east_var": "eastVar",
        "north": "north",
        "north_var": "northVar",
        "south": "south",
        "south_var": "southVar",
        "west": "west",
        "west_var": "westVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeRelativeCrop:
    def __init__(
        self,
        *,
        east: typing.Optional[builtins.str] = None,
        east_var: typing.Optional[builtins.str] = None,
        north: typing.Optional[builtins.str] = None,
        north_var: typing.Optional[builtins.str] = None,
        south: typing.Optional[builtins.str] = None,
        south_var: typing.Optional[builtins.str] = None,
        west: typing.Optional[builtins.str] = None,
        west_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param east: The number of pixels to shrink or expand the right side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east DataAkamaiImagingPolicyImage#east}
        :param east_var: The number of pixels to shrink or expand the right side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east_var DataAkamaiImagingPolicyImage#east_var}
        :param north: The number of pixels to shrink or expand the top side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north DataAkamaiImagingPolicyImage#north}
        :param north_var: The number of pixels to shrink or expand the top side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north_var DataAkamaiImagingPolicyImage#north_var}
        :param south: The number of pixels to shrink or expand the bottom side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south DataAkamaiImagingPolicyImage#south}
        :param south_var: The number of pixels to shrink or expand the bottom side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south_var DataAkamaiImagingPolicyImage#south_var}
        :param west: The number of pixels to shrink or expand the left side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west DataAkamaiImagingPolicyImage#west}
        :param west_var: The number of pixels to shrink or expand the left side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west_var DataAkamaiImagingPolicyImage#west_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a4209bc3ec4afb5888698714956ebd080664979b6d8212451315a4a2f6108772)
            check_type(argname="argument east", value=east, expected_type=type_hints["east"])
            check_type(argname="argument east_var", value=east_var, expected_type=type_hints["east_var"])
            check_type(argname="argument north", value=north, expected_type=type_hints["north"])
            check_type(argname="argument north_var", value=north_var, expected_type=type_hints["north_var"])
            check_type(argname="argument south", value=south, expected_type=type_hints["south"])
            check_type(argname="argument south_var", value=south_var, expected_type=type_hints["south_var"])
            check_type(argname="argument west", value=west, expected_type=type_hints["west"])
            check_type(argname="argument west_var", value=west_var, expected_type=type_hints["west_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if east is not None:
            self._values["east"] = east
        if east_var is not None:
            self._values["east_var"] = east_var
        if north is not None:
            self._values["north"] = north
        if north_var is not None:
            self._values["north_var"] = north_var
        if south is not None:
            self._values["south"] = south
        if south_var is not None:
            self._values["south_var"] = south_var
        if west is not None:
            self._values["west"] = west
        if west_var is not None:
            self._values["west_var"] = west_var

    @builtins.property
    def east(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the right side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east DataAkamaiImagingPolicyImage#east}
        '''
        result = self._values.get("east")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def east_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the right side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east_var DataAkamaiImagingPolicyImage#east_var}
        '''
        result = self._values.get("east_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def north(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the top side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north DataAkamaiImagingPolicyImage#north}
        '''
        result = self._values.get("north")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def north_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the top side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north_var DataAkamaiImagingPolicyImage#north_var}
        '''
        result = self._values.get("north_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def south(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the bottom side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south DataAkamaiImagingPolicyImage#south}
        '''
        result = self._values.get("south")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def south_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the bottom side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south_var DataAkamaiImagingPolicyImage#south_var}
        '''
        result = self._values.get("south_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def west(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the left side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west DataAkamaiImagingPolicyImage#west}
        '''
        result = self._values.get("west")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def west_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the left side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west_var DataAkamaiImagingPolicyImage#west_var}
        '''
        result = self._values.get("west_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeRelativeCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeRelativeCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeRelativeCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f9ff4b1378456686d63886a75518666722f6b4e241eb6758dc4a2416d0932243)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeRelativeCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__31d5bf14f8cd3c6d30bd1481c62de17244397b655c872ddf4e7dbe8c84dda35a)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeRelativeCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__89bc381fed44f7dc28a09d90c279021e55a52f2f46fb28a262c5548842c1a1b0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3781e2f24f0c434198aa6edb1750e1e24dabb9b11f3cf14547da73c51d34760a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a2565b57874dd57395956d38345da00fa327ea11204d6542bd10c0acdadedd07)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeRelativeCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeRelativeCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeRelativeCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ce1f96dde4fcf23bc00f10bf5c460bac8d6deaaffe8b7a0d516b8c73c6fe4c11)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeRelativeCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeRelativeCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9c57a601d6929aa57b3ecba0ad53a73866c616807383c2365513378e2e2599ee)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetEast")
    def reset_east(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEast", []))

    @jsii.member(jsii_name="resetEastVar")
    def reset_east_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEastVar", []))

    @jsii.member(jsii_name="resetNorth")
    def reset_north(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNorth", []))

    @jsii.member(jsii_name="resetNorthVar")
    def reset_north_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNorthVar", []))

    @jsii.member(jsii_name="resetSouth")
    def reset_south(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSouth", []))

    @jsii.member(jsii_name="resetSouthVar")
    def reset_south_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSouthVar", []))

    @jsii.member(jsii_name="resetWest")
    def reset_west(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWest", []))

    @jsii.member(jsii_name="resetWestVar")
    def reset_west_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWestVar", []))

    @builtins.property
    @jsii.member(jsii_name="eastInput")
    def east_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "eastInput"))

    @builtins.property
    @jsii.member(jsii_name="eastVarInput")
    def east_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "eastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="northInput")
    def north_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "northInput"))

    @builtins.property
    @jsii.member(jsii_name="northVarInput")
    def north_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "northVarInput"))

    @builtins.property
    @jsii.member(jsii_name="southInput")
    def south_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "southInput"))

    @builtins.property
    @jsii.member(jsii_name="southVarInput")
    def south_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "southVarInput"))

    @builtins.property
    @jsii.member(jsii_name="westInput")
    def west_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "westInput"))

    @builtins.property
    @jsii.member(jsii_name="westVarInput")
    def west_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "westVarInput"))

    @builtins.property
    @jsii.member(jsii_name="east")
    def east(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "east"))

    @east.setter
    def east(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4c9f9e4dafa4068c43ee9d91339cbee6c15c12283f38800a99e8f3d3dd65632a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "east", value)

    @builtins.property
    @jsii.member(jsii_name="eastVar")
    def east_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "eastVar"))

    @east_var.setter
    def east_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__92fcd65e2ea0cf3800e6c506b83ab915c0ca83f2f5d9fe70044876f728ad9bac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "eastVar", value)

    @builtins.property
    @jsii.member(jsii_name="north")
    def north(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "north"))

    @north.setter
    def north(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b96a3e9082658ab269e9d65490850bfa4adc618bae20a6cfecc6eb06c454fd89)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "north", value)

    @builtins.property
    @jsii.member(jsii_name="northVar")
    def north_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "northVar"))

    @north_var.setter
    def north_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9537ef1b736711a2cc293d07ea73025cf285e39ba4c30b5d6ab728f337003985)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "northVar", value)

    @builtins.property
    @jsii.member(jsii_name="south")
    def south(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "south"))

    @south.setter
    def south(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__22f959e7dbccc14f2fae426a4b9da0472aaec3860e4f147c9ad0241943d4a93d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "south", value)

    @builtins.property
    @jsii.member(jsii_name="southVar")
    def south_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "southVar"))

    @south_var.setter
    def south_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__581ae9d83aae88887d32f4451493165ef700550a741187e12831de89c41b2342)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "southVar", value)

    @builtins.property
    @jsii.member(jsii_name="west")
    def west(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "west"))

    @west.setter
    def west(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1a8faa5dc1c66a248d02ad11374ef0ae22807924ed97bcefbd4e238e18b2806d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "west", value)

    @builtins.property
    @jsii.member(jsii_name="westVar")
    def west_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "westVar"))

    @west_var.setter
    def west_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__78d521c7468fa7e2159517b9e6d82d0d81e9031fbafbdaf15f9363a9ede924e3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "westVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeRelativeCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeRelativeCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeRelativeCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9be62bb8d6d3773484f18610c21b0975b89fe636cc67e8ace0d78a6d2e5698c3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeRemoveColor",
    jsii_struct_bases=[],
    name_mapping={
        "color": "color",
        "color_var": "colorVar",
        "feather": "feather",
        "feather_var": "featherVar",
        "tolerance": "tolerance",
        "tolerance_var": "toleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeRemoveColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
        feather: typing.Optional[builtins.str] = None,
        feather_var: typing.Optional[builtins.str] = None,
        tolerance: typing.Optional[builtins.str] = None,
        tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        :param feather: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        :param feather_var: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        :param tolerance: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        :param tolerance_var: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__75f7b51c83cefbd6c9f8b74239f5b5bf9627e15f041ea15b129a80bb4cf5bd13)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
            check_type(argname="argument feather", value=feather, expected_type=type_hints["feather"])
            check_type(argname="argument feather_var", value=feather_var, expected_type=type_hints["feather_var"])
            check_type(argname="argument tolerance", value=tolerance, expected_type=type_hints["tolerance"])
            check_type(argname="argument tolerance_var", value=tolerance_var, expected_type=type_hints["tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var
        if feather is not None:
            self._values["feather"] = feather
        if feather_var is not None:
            self._values["feather_var"] = feather_var
        if tolerance is not None:
            self._values["tolerance"] = tolerance
        if tolerance_var is not None:
            self._values["tolerance_var"] = tolerance_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        '''
        result = self._values.get("feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather_var(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        '''
        result = self._values.get("feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        '''
        result = self._values.get("tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance_var(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        result = self._values.get("tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeRemoveColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeRemoveColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeRemoveColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__abc0cb978933ac758e0fbd98f749795390ef47fb62dcfe27041b796e94dc38cc)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeRemoveColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__31645d2789440cade2c8752f222765c8f4dff594c510b1856df2eeaeea50b174)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeRemoveColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9637782e40e4ac37c24b1fc1908d547a8efa9ec95c12f61908e2a37af3fb1c37)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8c4ec1fa3208fbc40852d7fcada2eae3fb913c30f1634dd4bf8422f7398f8ca2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5de89bc202aa18ac0eeefa2278b27a6aaa28ccd3eb6887e8420a44098349baf3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeRemoveColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeRemoveColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeRemoveColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__afeb861ad06a7c3ff1ba274f1fbf55490ac146f4236734041a03352f5d2edf35)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeRemoveColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeRemoveColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ca03ec3199594a36700a91e2c7a243e6664b128e76b9514e9fc6169a6870c916)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @jsii.member(jsii_name="resetFeather")
    def reset_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeather", []))

    @jsii.member(jsii_name="resetFeatherVar")
    def reset_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatherVar", []))

    @jsii.member(jsii_name="resetTolerance")
    def reset_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTolerance", []))

    @jsii.member(jsii_name="resetToleranceVar")
    def reset_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featherInput")
    def feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherInput"))

    @builtins.property
    @jsii.member(jsii_name="featherVarInput")
    def feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceInput")
    def tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceVarInput")
    def tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a3a7fe1be814e85d921d2291ed83a9a36105753f2bdc6d8f73e4285053d81fd4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__db30bd7d987ce651ef88821ab856cc583bfc08776ef09d042200a09f74232b00)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="feather")
    def feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "feather"))

    @feather.setter
    def feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a6636b9dba750d1e6c9b88ca5ea58ecc3dd2f6ee109ae0dd95dc3cc669434d5d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "feather", value)

    @builtins.property
    @jsii.member(jsii_name="featherVar")
    def feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featherVar"))

    @feather_var.setter
    def feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a566b6f270bc12197fee515bf724e24102abd38b44a8a0a1a1d7d68a303afd6a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featherVar", value)

    @builtins.property
    @jsii.member(jsii_name="tolerance")
    def tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tolerance"))

    @tolerance.setter
    def tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1bc22dc54c4b2575ab39f4bbd8111e0371f3ac1716036d44c36845da00263359)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tolerance", value)

    @builtins.property
    @jsii.member(jsii_name="toleranceVar")
    def tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "toleranceVar"))

    @tolerance_var.setter
    def tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cb25039d5016d726588d4fdc49ae0dd0183564eeb27959dfc8e51a79b471b7e7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "toleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeRemoveColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeRemoveColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeRemoveColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b693a6b7226332e06b5c393058fb5287ae0e0d9f4c095929161fe91859480e09)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeResize",
    jsii_struct_bases=[],
    name_mapping={
        "aspect": "aspect",
        "aspect_var": "aspectVar",
        "height": "height",
        "height_var": "heightVar",
        "type": "type",
        "type_var": "typeVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeResize:
    def __init__(
        self,
        *,
        aspect: typing.Optional[builtins.str] = None,
        aspect_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param aspect: Preserves the aspect ratio. Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect DataAkamaiImagingPolicyImage#aspect}
        :param aspect_var: Preserves the aspect ratio. Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_var DataAkamaiImagingPolicyImage#aspect_var}
        :param height: The height to resize the source image to. Must be set if height is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height to resize the source image to. Must be set if height is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param type: Sets constraints for the image resize. Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: Sets constraints for the image resize. Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        :param width: The width to resize the source image to. Must be set if width is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width to resize the source image to. Must be set if width is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__604add7c4c5bd57186101c3f729ce5ce788d0ea6e0923c8b521c9fbcae396a7e)
            check_type(argname="argument aspect", value=aspect, expected_type=type_hints["aspect"])
            check_type(argname="argument aspect_var", value=aspect_var, expected_type=type_hints["aspect_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if aspect is not None:
            self._values["aspect"] = aspect
        if aspect_var is not None:
            self._values["aspect_var"] = aspect_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def aspect(self) -> typing.Optional[builtins.str]:
        '''Preserves the aspect ratio.

        Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect DataAkamaiImagingPolicyImage#aspect}
        '''
        result = self._values.get("aspect")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def aspect_var(self) -> typing.Optional[builtins.str]:
        '''Preserves the aspect ratio.

        Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_var DataAkamaiImagingPolicyImage#aspect_var}
        '''
        result = self._values.get("aspect_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height to resize the source image to. Must be set if height is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height to resize the source image to. Must be set if height is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''Sets constraints for the image resize.

        Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''Sets constraints for the image resize.

        Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width to resize the source image to. Must be set if width is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width to resize the source image to. Must be set if width is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeResize(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeResizeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeResizeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac531f2b6a1286bdb21f89515012fe2e7ca7a4ef2d8f003d7b06eae8efadc1d1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeResizeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dc2aec0fd2359f860c858fe3426361901fb36c106eaf72c956bb6261d8d8a311)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeResizeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__969950eb169a7699291f10da531cf890463dd88f97e4cdbf01b9485b3c5ee40e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be6d6b9ef1b11d1e4a1fdeae031715fedf0184eff9174910bfd639970d3eb00e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__55fd1c415f7c98cdaba07150334c080e59f1c8d35d7c0474f2079a94e1d85714)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeResize]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeResize]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeResize]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ae39060065760819c57534b86aab113d57fb0acc18323e5cf50d3fb5ebaa9a31)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeResizeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeResizeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__88b04da04088a59f28cdd44be26e11999055498dd9b4d056a306b6ad7e9b83e0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAspect")
    def reset_aspect(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspect", []))

    @jsii.member(jsii_name="resetAspectVar")
    def reset_aspect_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspectVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="aspectInput")
    def aspect_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "aspectInput"))

    @builtins.property
    @jsii.member(jsii_name="aspectVarInput")
    def aspect_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "aspectVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="aspect")
    def aspect(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "aspect"))

    @aspect.setter
    def aspect(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__48a76b1119271609ddfe3dc3d161f5d25088f273b03dddfe2502b0d5def180b9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "aspect", value)

    @builtins.property
    @jsii.member(jsii_name="aspectVar")
    def aspect_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "aspectVar"))

    @aspect_var.setter
    def aspect_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2734eb77fea86794e7757602bda603e96dd2bdff4fe346115975dca51a18ad04)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "aspectVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__02f0ad8254fb4f590f9d4c15626500091b2e0e7b22dd9726596a568ab5cb158b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__143fb4b987ec7868f653706d70a7ea6ae3f0ec03d4b24611a6cce67019634d42)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8825cc4b6073b68140a2c9e1ef59fc1d6238fecf9a9a15d038059ec310e84b3d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0e81fe59629944909a511bf199fed400956d1d729e93e9f621007d1128f7e6f1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e1ea3722283267b952e7120d2702a72fac3e48b7a4ed6a9a99aca488d2aa2958)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4e36fe7931d3ecdda14f8be703106625fa9df31b619f2977106f981159cba5a8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeResize]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeResize]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeResize]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e20884a0427cff14b730bbf62b0ebf37f0e6940b397043a8dd16b631f6d94477)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeRotate",
    jsii_struct_bases=[],
    name_mapping={"degrees": "degrees", "degrees_var": "degreesVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeRotate:
    def __init__(
        self,
        *,
        degrees: typing.Optional[builtins.str] = None,
        degrees_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param degrees: The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees DataAkamaiImagingPolicyImage#degrees}
        :param degrees_var: The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees_var DataAkamaiImagingPolicyImage#degrees_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b0cbbb3fe677c84bd8a68e3ffad0df8bd78ecfda1aeca2bd64a2e304777a64fb)
            check_type(argname="argument degrees", value=degrees, expected_type=type_hints["degrees"])
            check_type(argname="argument degrees_var", value=degrees_var, expected_type=type_hints["degrees_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if degrees is not None:
            self._values["degrees"] = degrees
        if degrees_var is not None:
            self._values["degrees_var"] = degrees_var

    @builtins.property
    def degrees(self) -> typing.Optional[builtins.str]:
        '''The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees DataAkamaiImagingPolicyImage#degrees}
        '''
        result = self._values.get("degrees")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def degrees_var(self) -> typing.Optional[builtins.str]:
        '''The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees_var DataAkamaiImagingPolicyImage#degrees_var}
        '''
        result = self._values.get("degrees_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeRotate(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeRotateList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeRotateList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__226d2c8088fac0e441cea3c81fc46ce8485e245df2d0bd78eb0239364ff79c60)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeRotateOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cbd05b40f3c158921ca4ec824eb2383b4030dd639b813bbf516e93f9b0644360)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeRotateOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6b853aff1b8398f2f63ef27a54d95c478df3fe10896136f5464e09bfb164766e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c70f94d84c34c7ee745958d1567e253dd35d2e7e54b1f6497b3b3c926153ff13)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8ec983802303b302465a4b71255a687e5e1c34b98f8fb9da24510d311fa89cb6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeRotate]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeRotate]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeRotate]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ba4b45688dc9b99b9be51e4774aa8e042ced35783a2b7da2ac8ac4d7c2b4b0d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeRotateOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeRotateOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d8d1318e254ba97f11e1cae4f920ec38460b859dc31cb1a8d43194280aafd2a1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetDegrees")
    def reset_degrees(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDegrees", []))

    @jsii.member(jsii_name="resetDegreesVar")
    def reset_degrees_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDegreesVar", []))

    @builtins.property
    @jsii.member(jsii_name="degreesInput")
    def degrees_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "degreesInput"))

    @builtins.property
    @jsii.member(jsii_name="degreesVarInput")
    def degrees_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "degreesVarInput"))

    @builtins.property
    @jsii.member(jsii_name="degrees")
    def degrees(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "degrees"))

    @degrees.setter
    def degrees(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__740c71b7e8784265e98bfe3664b32469c50ed9eb7de6aea883e198620507327b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "degrees", value)

    @builtins.property
    @jsii.member(jsii_name="degreesVar")
    def degrees_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "degreesVar"))

    @degrees_var.setter
    def degrees_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f2c99eb860e72e58a05b2262dc241a7c5505b4e3a771814957f4f75679595ef5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "degreesVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeRotate]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeRotate]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeRotate]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b37385edccdd400a77fc17bfcfd826c4c08b407d222dad78300f57ec830a532b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeScale",
    jsii_struct_bases=[],
    name_mapping={
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeScale:
    def __init__(
        self,
        *,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param height: Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged. Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged. Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__10053568043ac035908ca5d7255583eadc5acffec9fe5a38b640ad3e86b9a396)
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size.

        Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size.

        Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged.

        Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged.

        Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeScale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeScaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeScaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ca5564a717af3d0b15d11440d98f51e98e748f69e3990b941ea9a063bf92c22d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeScaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5638442d688d46191d8e51e0837448c4ab1071b870d879bc7d828ce5ea51b327)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeScaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1482c6927e5724f979400c23bf1620db4c43fe9cbfbe6786a5375583854f3624)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3921c3669fa63016e83bee4b7490e64930dd92feb584f5a04bb7768064df7138)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__56dfcf7fa3382b0ff81149dad66d96dcea49f6155647f7f64bb3b1340701fce3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeScale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeScale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeScale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c5a8aba07de1e4706a30a92c0094470425f8d046f36b50628aedff5f645873d3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeScaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeScaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__28acc1c569d2555457e7449277c5b3203bea9c2cd387a2c6dfb3bbf1730fedbd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c496505b4043340beaf8786ab5c17d3e037e223faa3376c0099aca72d3fa6caa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8be4e8415951aa82cb1509cf01eddc8ee0854f97f990e761a9fc91ad4dbc191f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__63e161642b510bfd6dde283a234969aff839a7d414b31f6cbd5ad88074b08e20)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__065b2a78da73a71220dc746abe83fea456e5a259afd42f5e5a0150c9777020ea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeScale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeScale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeScale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__60d6978dd49efe8735772acadaf3119f86aec9ae1bd895edad1c7586449b963e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeShear",
    jsii_struct_bases=[],
    name_mapping={
        "x_shear": "xShear",
        "x_shear_var": "xShearVar",
        "y_shear": "yShear",
        "y_shear_var": "yShearVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeShear:
    def __init__(
        self,
        *,
        x_shear: typing.Optional[builtins.str] = None,
        x_shear_var: typing.Optional[builtins.str] = None,
        y_shear: typing.Optional[builtins.str] = None,
        y_shear_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param x_shear: The amount to shear along the x-axis, measured in multiples of the image's width. Must be set if yShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear DataAkamaiImagingPolicyImage#x_shear}
        :param x_shear_var: The amount to shear along the x-axis, measured in multiples of the image's width. Must be set if yShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear_var DataAkamaiImagingPolicyImage#x_shear_var}
        :param y_shear: The amount to shear along the y-axis, measured in multiples of the image's height. Must be set if xShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear DataAkamaiImagingPolicyImage#y_shear}
        :param y_shear_var: The amount to shear along the y-axis, measured in multiples of the image's height. Must be set if xShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear_var DataAkamaiImagingPolicyImage#y_shear_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6bdc2eaa1c2822baee8e259b96c45d020b9fe4d12999173083c7a204c895986d)
            check_type(argname="argument x_shear", value=x_shear, expected_type=type_hints["x_shear"])
            check_type(argname="argument x_shear_var", value=x_shear_var, expected_type=type_hints["x_shear_var"])
            check_type(argname="argument y_shear", value=y_shear, expected_type=type_hints["y_shear"])
            check_type(argname="argument y_shear_var", value=y_shear_var, expected_type=type_hints["y_shear_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if x_shear is not None:
            self._values["x_shear"] = x_shear
        if x_shear_var is not None:
            self._values["x_shear_var"] = x_shear_var
        if y_shear is not None:
            self._values["y_shear"] = y_shear
        if y_shear_var is not None:
            self._values["y_shear_var"] = y_shear_var

    @builtins.property
    def x_shear(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the x-axis, measured in multiples of the image's width.

        Must be set if yShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear DataAkamaiImagingPolicyImage#x_shear}
        '''
        result = self._values.get("x_shear")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_shear_var(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the x-axis, measured in multiples of the image's width.

        Must be set if yShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear_var DataAkamaiImagingPolicyImage#x_shear_var}
        '''
        result = self._values.get("x_shear_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_shear(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the y-axis, measured in multiples of the image's height.

        Must be set if xShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear DataAkamaiImagingPolicyImage#y_shear}
        '''
        result = self._values.get("y_shear")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_shear_var(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the y-axis, measured in multiples of the image's height.

        Must be set if xShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear_var DataAkamaiImagingPolicyImage#y_shear_var}
        '''
        result = self._values.get("y_shear_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeShear(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeShearList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeShearList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__24986ac22f0a946e0f1fe1a2b427dad89e263b575b62ab4ecac2ea1c6eb1cd07)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeShearOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e2464ab0002a94b47b492887f390145f30d2d98f3a51c3ebbfac2991045aa644)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeShearOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7094fb53bae204b2d42f0073b5ac701f7c00f3f31e7248d07b7b8880e9b876f4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5b22876071299627e8a04bd15911be745668109a78e5ae26c0fc270df8174d97)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ce0670c28bbdde7524cf8ccde8a588049653110b37b4c4b2e73b877cd02ebae6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeShear]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeShear]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeShear]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dcaa01ed1499e79be7a8533ef2dfd0a91b5e040f34e3e3ef6e317418da0176ae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeShearOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeShearOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1bda9d4912e8086c46b462aec1f4fbafbe83114e627893236a6f95586e4fd2fb)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetXShear")
    def reset_x_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXShear", []))

    @jsii.member(jsii_name="resetXShearVar")
    def reset_x_shear_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXShearVar", []))

    @jsii.member(jsii_name="resetYShear")
    def reset_y_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYShear", []))

    @jsii.member(jsii_name="resetYShearVar")
    def reset_y_shear_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYShearVar", []))

    @builtins.property
    @jsii.member(jsii_name="xShearInput")
    def x_shear_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xShearInput"))

    @builtins.property
    @jsii.member(jsii_name="xShearVarInput")
    def x_shear_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xShearVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yShearInput")
    def y_shear_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yShearInput"))

    @builtins.property
    @jsii.member(jsii_name="yShearVarInput")
    def y_shear_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yShearVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xShear")
    def x_shear(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xShear"))

    @x_shear.setter
    def x_shear(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f2229a6014858b35ac91da15748a4ecb284e6ec61e3546f8ff78f1ea17d49291)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xShear", value)

    @builtins.property
    @jsii.member(jsii_name="xShearVar")
    def x_shear_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xShearVar"))

    @x_shear_var.setter
    def x_shear_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0d19918501ea06453f963edd417ea2be5abc8d95e6297eb9d29d2eabb11aaf77)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xShearVar", value)

    @builtins.property
    @jsii.member(jsii_name="yShear")
    def y_shear(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yShear"))

    @y_shear.setter
    def y_shear(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__266aad17f6cc1372cd56a2c94b352869837d7a83288c3c1ff3c22128cc1ed695)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yShear", value)

    @builtins.property
    @jsii.member(jsii_name="yShearVar")
    def y_shear_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yShearVar"))

    @y_shear_var.setter
    def y_shear_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7bd02e1f1b50552abb37d56a68144dda0d4df647b9c2794c7f397b942425ca58)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yShearVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeShear]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeShear]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeShear]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a1438265323df3bb1a6bcb37128995f1083557c04f82614d9dd635f6a4eb1be)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeTrim",
    jsii_struct_bases=[],
    name_mapping={
        "fuzz": "fuzz",
        "fuzz_var": "fuzzVar",
        "padding": "padding",
        "padding_var": "paddingVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeTrim:
    def __init__(
        self,
        *,
        fuzz: typing.Optional[builtins.str] = None,
        fuzz_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fuzz: The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz DataAkamaiImagingPolicyImage#fuzz}
        :param fuzz_var: The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz_var DataAkamaiImagingPolicyImage#fuzz_var}
        :param padding: The amount of padding in pixels to add to the trimmed image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: The amount of padding in pixels to add to the trimmed image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__45419d18af70dd74d343fc1e5c282ff2a1cd296564721ab158aed908ff1dbf10)
            check_type(argname="argument fuzz", value=fuzz, expected_type=type_hints["fuzz"])
            check_type(argname="argument fuzz_var", value=fuzz_var, expected_type=type_hints["fuzz_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fuzz is not None:
            self._values["fuzz"] = fuzz
        if fuzz_var is not None:
            self._values["fuzz_var"] = fuzz_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var

    @builtins.property
    def fuzz(self) -> typing.Optional[builtins.str]:
        '''The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz DataAkamaiImagingPolicyImage#fuzz}
        '''
        result = self._values.get("fuzz")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fuzz_var(self) -> typing.Optional[builtins.str]:
        '''The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz_var DataAkamaiImagingPolicyImage#fuzz_var}
        '''
        result = self._values.get("fuzz_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''The amount of padding in pixels to add to the trimmed image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''The amount of padding in pixels to add to the trimmed image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeTrim(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeTrimList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeTrimList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0756d5ce29506d7612ad7c22807a7c98de3b1da49d1213168b7cf1c8dff9c699)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeTrimOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8dd527cabe0e9652114fc0bf36f4a671ac489eda5bf3a6de3b209ec2ed41478a)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeTrimOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ef3426d0aba6097c2b318f8eeb1499c090753275ae459b07266db31e38c32c73)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f129b38d31b78a72528f3d8def991c846f6f3169b17c6510dcfccf7ea27d884)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__49ef1846568ff7f3753bb62503e41ddb04ec7caca9fb70cd0cf5fc5c391679d4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeTrim]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeTrim]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeTrim]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9615621641506a657b523d1052e6daa4008146b924f1be99b0639541dca555bc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeTrimOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeTrimOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__11b515bbb808e9dddfa1f9f5d302caa70a1c38731e8f86d44ae01cb72b34e9b8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetFuzz")
    def reset_fuzz(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFuzz", []))

    @jsii.member(jsii_name="resetFuzzVar")
    def reset_fuzz_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFuzzVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @builtins.property
    @jsii.member(jsii_name="fuzzInput")
    def fuzz_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fuzzInput"))

    @builtins.property
    @jsii.member(jsii_name="fuzzVarInput")
    def fuzz_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fuzzVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="fuzz")
    def fuzz(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fuzz"))

    @fuzz.setter
    def fuzz(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d36611cdd27e8271820d9e19f3dbeb8261ef2b04c54cdd1d575087f968e9da45)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fuzz", value)

    @builtins.property
    @jsii.member(jsii_name="fuzzVar")
    def fuzz_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fuzzVar"))

    @fuzz_var.setter
    def fuzz_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__acd6c43a1ad486ff21523b93fb1633adf4960171659cb595b428acb68249effb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fuzzVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d1c1c568f164b41c64e7d3093ba41983a0af68498d32b8387e54ec737533191)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a8333e755c0220ac1a531bc2e360248cf18b1cec111ab8260d8453c7ed8751c0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeTrim]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeTrim]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeTrim]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__52921bdf66d4fbc175d73a0aad1bb5b20fffb9bb19bd4ab8e065b48a4b65a323)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeUnsharpMask",
    jsii_struct_bases=[],
    name_mapping={
        "gain": "gain",
        "gain_var": "gainVar",
        "sigma": "sigma",
        "sigma_var": "sigmaVar",
        "threshold": "threshold",
        "threshold_var": "thresholdVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeUnsharpMask:
    def __init__(
        self,
        *,
        gain: typing.Optional[builtins.str] = None,
        gain_var: typing.Optional[builtins.str] = None,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
        threshold: typing.Optional[builtins.str] = None,
        threshold_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param gain: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        :param gain_var: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        :param sigma: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        :param threshold: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        :param threshold_var: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e7cba72ce27e2a1a58a0658cdf6681c518eac31966d1a8fa71afde7825f91e2c)
            check_type(argname="argument gain", value=gain, expected_type=type_hints["gain"])
            check_type(argname="argument gain_var", value=gain_var, expected_type=type_hints["gain_var"])
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
            check_type(argname="argument threshold", value=threshold, expected_type=type_hints["threshold"])
            check_type(argname="argument threshold_var", value=threshold_var, expected_type=type_hints["threshold_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if gain is not None:
            self._values["gain"] = gain
        if gain_var is not None:
            self._values["gain_var"] = gain_var
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var
        if threshold is not None:
            self._values["threshold"] = threshold
        if threshold_var is not None:
            self._values["threshold_var"] = threshold_var

    @builtins.property
    def gain(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        '''
        result = self._values.get("gain")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gain_var(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        '''
        result = self._values.get("gain_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        '''
        result = self._values.get("threshold")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold_var(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        result = self._values.get("threshold_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeUnsharpMask(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeUnsharpMaskList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeUnsharpMaskList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__589025b2c7f4d21882801993427403b49e2c99e1fef93a08266bfdb9f1f76a6f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeUnsharpMaskOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8681999ee093e5c929bf041345dedda11b4e761507a6199ebb7d78ec2f061fd0)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeUnsharpMaskOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f8a436205b5b81680bb08e7eccabec4d52ca7613d69c62996eb17b16bdc794d7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__901d6fd1d860361c1e0054abb5791b792a8f752e8e85356d77d2d041a39747e4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e60264b4563eee38e3805021afe1e06cd57e523dc79472901b87ea52010c8038)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeUnsharpMask]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeUnsharpMask]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeUnsharpMask]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b63cbb89ebd8d273d81de18f34b70b28736a88992704cbac7d4122764f94b888)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeUnsharpMaskOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeUnsharpMaskOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__32c05f3b7280490c73e41a28f7cb12f79eca92b916b97da73614e9ae657748f2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetGain")
    def reset_gain(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGain", []))

    @jsii.member(jsii_name="resetGainVar")
    def reset_gain_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGainVar", []))

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @jsii.member(jsii_name="resetThreshold")
    def reset_threshold(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThreshold", []))

    @jsii.member(jsii_name="resetThresholdVar")
    def reset_threshold_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThresholdVar", []))

    @builtins.property
    @jsii.member(jsii_name="gainInput")
    def gain_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainInput"))

    @builtins.property
    @jsii.member(jsii_name="gainVarInput")
    def gain_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdInput")
    def threshold_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdVarInput")
    def threshold_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gain")
    def gain(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gain"))

    @gain.setter
    def gain(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d91254d2287bcc9ef983e5fd4647f261cfa7947cc9c9a040b01a855caf688f79)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gain", value)

    @builtins.property
    @jsii.member(jsii_name="gainVar")
    def gain_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gainVar"))

    @gain_var.setter
    def gain_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__31d3b7ca6aa0aa90131298b4cfe98c74895c6be5dbfcfaa7020992b3761743c9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gainVar", value)

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7897545b48b0f77e3726e5154395575bfc0f4e4aa005e4e156d89620b97c5d46)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__37a5c53d0c3ed40538fda7f0d4fd541a86b25c545b0ea4db3340accd4652ff30)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="threshold")
    def threshold(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "threshold"))

    @threshold.setter
    def threshold(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6a6baad0b14070f54ada7a058869c526103a22832ca3643798cdc906850bf1d7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "threshold", value)

    @builtins.property
    @jsii.member(jsii_name="thresholdVar")
    def threshold_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "thresholdVar"))

    @threshold_var.setter
    def threshold_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c5c250e811cb437aef90a433b831a2b76b4f796685a6f31975f60e91fad99137)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "thresholdVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeUnsharpMask]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeUnsharpMask]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeUnsharpMask]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fb477791d526ea02a89d76e2772bb4b9c9f297bf65216579fc03c06545ba23a8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__969aa8dfaa2c874266f7f04040d24c53166c73e1eb0eaa7cfd7bff617e89e23b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__03d9f37947c4a046f791e4d7b276b08eb7e45318301c6ac0aab15cb0aad2c2d8)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3718060d9305039bf375e22248b1dfbeab8664fcc138afcd536796f323a6669f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__57bcd264ed5f86fc079fd705cff101c0aee48d35e308e17a30d03b9e2ef36292)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d03737e94650198c038c07dfee13c1762d758333ee9583321367e7cef2d467d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientation]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientation]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__66928213590319f8ae06e636e836b9adcd298ef18b48100c34ef111c29bd0c87)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ce3b4b56d96bad836ec7ebef3e1e966ae215f3e82bcbb9bd25cf0873ed898605)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(
        self,
        *,
        append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppend, typing.Dict[builtins.str, typing.Any]]]]] = None,
        aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAspectCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
        crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFaceCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFeatureCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFill, typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
        im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultImQuery", typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultMaxColors", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultMirror", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultMonoHue", typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultOpacity", typing.Dict[builtins.str, typing.Any]]]]] = None,
        region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRelativeCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRemoveColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultResize", typing.Dict[builtins.str, typing.Any]]]]] = None,
        rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRotate", typing.Dict[builtins.str, typing.Any]]]]] = None,
        scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultScale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultShear", typing.Dict[builtins.str, typing.Any]]]]] = None,
        trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultTrim", typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultUnsharpMask", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param append: append block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        :param aspect_crop: aspect_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param crop: crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        :param face_crop: face_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        :param feature_crop: feature_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        :param fit_and_fill: fit_and_fill block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param im_query: im_query block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param region_of_interest_crop: region_of_interest_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        :param relative_crop: relative_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param resize: resize block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        :param rotate: rotate block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        :param scale: scale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param shear: shear block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        :param trim: trim block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefault(
            append=append,
            aspect_crop=aspect_crop,
            background_color=background_color,
            blur=blur,
            chroma_key=chroma_key,
            composite=composite,
            compound=compound,
            contrast=contrast,
            crop=crop,
            face_crop=face_crop,
            feature_crop=feature_crop,
            fit_and_fill=fit_and_fill,
            goop=goop,
            grayscale=grayscale,
            hsl=hsl,
            hsv=hsv,
            if_dimension=if_dimension,
            if_orientation=if_orientation,
            im_query=im_query,
            max_colors=max_colors,
            mirror=mirror,
            mono_hue=mono_hue,
            opacity=opacity,
            region_of_interest_crop=region_of_interest_crop,
            relative_crop=relative_crop,
            remove_color=remove_color,
            resize=resize,
            rotate=rotate,
            scale=scale,
            shear=shear,
            trim=trim,
            unsharp_mask=unsharp_mask,
        )

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putLandscape")
    def put_landscape(
        self,
        *,
        append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeAppend, typing.Dict[builtins.str, typing.Any]]]]] = None,
        aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeAspectCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
        crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeFaceCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeFeatureCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeFitAndFill, typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
        im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeImQuery, typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
        region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeRegionOfInterestCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeRelativeCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
        resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeResize, typing.Dict[builtins.str, typing.Any]]]]] = None,
        rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeRotate, typing.Dict[builtins.str, typing.Any]]]]] = None,
        scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeScale, typing.Dict[builtins.str, typing.Any]]]]] = None,
        shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeShear, typing.Dict[builtins.str, typing.Any]]]]] = None,
        trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeTrim, typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param append: append block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        :param aspect_crop: aspect_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param crop: crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        :param face_crop: face_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        :param feature_crop: feature_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        :param fit_and_fill: fit_and_fill block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param im_query: im_query block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param region_of_interest_crop: region_of_interest_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        :param relative_crop: relative_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param resize: resize block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        :param rotate: rotate block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        :param scale: scale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param shear: shear block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        :param trim: trim block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscape(
            append=append,
            aspect_crop=aspect_crop,
            background_color=background_color,
            blur=blur,
            chroma_key=chroma_key,
            composite=composite,
            compound=compound,
            contrast=contrast,
            crop=crop,
            face_crop=face_crop,
            feature_crop=feature_crop,
            fit_and_fill=fit_and_fill,
            goop=goop,
            grayscale=grayscale,
            hsl=hsl,
            hsv=hsv,
            if_dimension=if_dimension,
            if_orientation=if_orientation,
            im_query=im_query,
            max_colors=max_colors,
            mirror=mirror,
            mono_hue=mono_hue,
            opacity=opacity,
            region_of_interest_crop=region_of_interest_crop,
            relative_crop=relative_crop,
            remove_color=remove_color,
            resize=resize,
            rotate=rotate,
            scale=scale,
            shear=shear,
            trim=trim,
            unsharp_mask=unsharp_mask,
        )

        return typing.cast(None, jsii.invoke(self, "putLandscape", [value]))

    @jsii.member(jsii_name="putPortrait")
    def put_portrait(
        self,
        *,
        append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitAppend", typing.Dict[builtins.str, typing.Any]]]]] = None,
        aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitAspectCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitBackgroundColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitBlur", typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitChromaKey", typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitComposite", typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitCompound", typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitContrast", typing.Dict[builtins.str, typing.Any]]]]] = None,
        crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitFaceCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitFeatureCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitFitAndFill", typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitGoop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitGrayscale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitHsl", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitHsv", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfDimension", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientation", typing.Dict[builtins.str, typing.Any]]]]] = None,
        im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitImQuery", typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitMaxColors", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitMirror", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitMonoHue", typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitOpacity", typing.Dict[builtins.str, typing.Any]]]]] = None,
        region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitRegionOfInterestCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitRelativeCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitRemoveColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitResize", typing.Dict[builtins.str, typing.Any]]]]] = None,
        rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitRotate", typing.Dict[builtins.str, typing.Any]]]]] = None,
        scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitScale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitShear", typing.Dict[builtins.str, typing.Any]]]]] = None,
        trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitTrim", typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitUnsharpMask", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param append: append block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        :param aspect_crop: aspect_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param crop: crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        :param face_crop: face_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        :param feature_crop: feature_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        :param fit_and_fill: fit_and_fill block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param im_query: im_query block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param region_of_interest_crop: region_of_interest_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        :param relative_crop: relative_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param resize: resize block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        :param rotate: rotate block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        :param scale: scale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param shear: shear block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        :param trim: trim block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortrait(
            append=append,
            aspect_crop=aspect_crop,
            background_color=background_color,
            blur=blur,
            chroma_key=chroma_key,
            composite=composite,
            compound=compound,
            contrast=contrast,
            crop=crop,
            face_crop=face_crop,
            feature_crop=feature_crop,
            fit_and_fill=fit_and_fill,
            goop=goop,
            grayscale=grayscale,
            hsl=hsl,
            hsv=hsv,
            if_dimension=if_dimension,
            if_orientation=if_orientation,
            im_query=im_query,
            max_colors=max_colors,
            mirror=mirror,
            mono_hue=mono_hue,
            opacity=opacity,
            region_of_interest_crop=region_of_interest_crop,
            relative_crop=relative_crop,
            remove_color=remove_color,
            resize=resize,
            rotate=rotate,
            scale=scale,
            shear=shear,
            trim=trim,
            unsharp_mask=unsharp_mask,
        )

        return typing.cast(None, jsii.invoke(self, "putPortrait", [value]))

    @jsii.member(jsii_name="putSquare")
    def put_square(
        self,
        *,
        append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareAppend", typing.Dict[builtins.str, typing.Any]]]]] = None,
        aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareAspectCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareBackgroundColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareBlur", typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareChromaKey", typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareComposite", typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareCompound", typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareContrast", typing.Dict[builtins.str, typing.Any]]]]] = None,
        crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareFaceCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareFeatureCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareFitAndFill", typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareGoop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareGrayscale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareHsl", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareHsv", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfDimension", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfOrientation", typing.Dict[builtins.str, typing.Any]]]]] = None,
        im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareImQuery", typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareMaxColors", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareMirror", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareMonoHue", typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareOpacity", typing.Dict[builtins.str, typing.Any]]]]] = None,
        region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareRegionOfInterestCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareRelativeCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareRemoveColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareResize", typing.Dict[builtins.str, typing.Any]]]]] = None,
        rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareRotate", typing.Dict[builtins.str, typing.Any]]]]] = None,
        scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareScale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareShear", typing.Dict[builtins.str, typing.Any]]]]] = None,
        trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareTrim", typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareUnsharpMask", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param append: append block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        :param aspect_crop: aspect_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param crop: crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        :param face_crop: face_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        :param feature_crop: feature_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        :param fit_and_fill: fit_and_fill block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param im_query: im_query block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param region_of_interest_crop: region_of_interest_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        :param relative_crop: relative_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param resize: resize block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        :param rotate: rotate block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        :param scale: scale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param shear: shear block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        :param trim: trim block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquare(
            append=append,
            aspect_crop=aspect_crop,
            background_color=background_color,
            blur=blur,
            chroma_key=chroma_key,
            composite=composite,
            compound=compound,
            contrast=contrast,
            crop=crop,
            face_crop=face_crop,
            feature_crop=feature_crop,
            fit_and_fill=fit_and_fill,
            goop=goop,
            grayscale=grayscale,
            hsl=hsl,
            hsv=hsv,
            if_dimension=if_dimension,
            if_orientation=if_orientation,
            im_query=im_query,
            max_colors=max_colors,
            mirror=mirror,
            mono_hue=mono_hue,
            opacity=opacity,
            region_of_interest_crop=region_of_interest_crop,
            relative_crop=relative_crop,
            remove_color=remove_color,
            resize=resize,
            rotate=rotate,
            scale=scale,
            shear=shear,
            trim=trim,
            unsharp_mask=unsharp_mask,
        )

        return typing.cast(None, jsii.invoke(self, "putSquare", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetLandscape")
    def reset_landscape(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLandscape", []))

    @jsii.member(jsii_name="resetPortrait")
    def reset_portrait(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPortrait", []))

    @jsii.member(jsii_name="resetSquare")
    def reset_square(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSquare", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultOutputReference", jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="landscape")
    def landscape(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeOutputReference, jsii.get(self, "landscape"))

    @builtins.property
    @jsii.member(jsii_name="portrait")
    def portrait(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitOutputReference", jsii.get(self, "portrait"))

    @builtins.property
    @jsii.member(jsii_name="square")
    def square(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareOutputReference", jsii.get(self, "square"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="landscapeInput")
    def landscape_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscape], jsii.get(self, "landscapeInput"))

    @builtins.property
    @jsii.member(jsii_name="portraitInput")
    def portrait_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortrait"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortrait"], jsii.get(self, "portraitInput"))

    @builtins.property
    @jsii.member(jsii_name="squareInput")
    def square_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquare"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquare"], jsii.get(self, "squareInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientation]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientation]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientation]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c0c4903c9e1e625a05e8f2cab505a322acce7565d559eb47d39a602090b58c9a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortrait",
    jsii_struct_bases=[],
    name_mapping={
        "append": "append",
        "aspect_crop": "aspectCrop",
        "background_color": "backgroundColor",
        "blur": "blur",
        "chroma_key": "chromaKey",
        "composite": "composite",
        "compound": "compound",
        "contrast": "contrast",
        "crop": "crop",
        "face_crop": "faceCrop",
        "feature_crop": "featureCrop",
        "fit_and_fill": "fitAndFill",
        "goop": "goop",
        "grayscale": "grayscale",
        "hsl": "hsl",
        "hsv": "hsv",
        "if_dimension": "ifDimension",
        "if_orientation": "ifOrientation",
        "im_query": "imQuery",
        "max_colors": "maxColors",
        "mirror": "mirror",
        "mono_hue": "monoHue",
        "opacity": "opacity",
        "region_of_interest_crop": "regionOfInterestCrop",
        "relative_crop": "relativeCrop",
        "remove_color": "removeColor",
        "resize": "resize",
        "rotate": "rotate",
        "scale": "scale",
        "shear": "shear",
        "trim": "trim",
        "unsharp_mask": "unsharpMask",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortrait:
    def __init__(
        self,
        *,
        append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitAppend", typing.Dict[builtins.str, typing.Any]]]]] = None,
        aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitAspectCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitBackgroundColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitBlur", typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitChromaKey", typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitComposite", typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitCompound", typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitContrast", typing.Dict[builtins.str, typing.Any]]]]] = None,
        crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitFaceCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitFeatureCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitFitAndFill", typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitGoop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitGrayscale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitHsl", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitHsv", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfDimension", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientation", typing.Dict[builtins.str, typing.Any]]]]] = None,
        im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitImQuery", typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitMaxColors", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitMirror", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitMonoHue", typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitOpacity", typing.Dict[builtins.str, typing.Any]]]]] = None,
        region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitRegionOfInterestCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitRelativeCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitRemoveColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitResize", typing.Dict[builtins.str, typing.Any]]]]] = None,
        rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitRotate", typing.Dict[builtins.str, typing.Any]]]]] = None,
        scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitScale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitShear", typing.Dict[builtins.str, typing.Any]]]]] = None,
        trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitTrim", typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitUnsharpMask", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param append: append block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        :param aspect_crop: aspect_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param crop: crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        :param face_crop: face_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        :param feature_crop: feature_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        :param fit_and_fill: fit_and_fill block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param im_query: im_query block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param region_of_interest_crop: region_of_interest_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        :param relative_crop: relative_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param resize: resize block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        :param rotate: rotate block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        :param scale: scale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param shear: shear block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        :param trim: trim block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f58b8df6b1a2e13235f45eca35d738503a4920d6412e3238ae940a867a0a1adf)
            check_type(argname="argument append", value=append, expected_type=type_hints["append"])
            check_type(argname="argument aspect_crop", value=aspect_crop, expected_type=type_hints["aspect_crop"])
            check_type(argname="argument background_color", value=background_color, expected_type=type_hints["background_color"])
            check_type(argname="argument blur", value=blur, expected_type=type_hints["blur"])
            check_type(argname="argument chroma_key", value=chroma_key, expected_type=type_hints["chroma_key"])
            check_type(argname="argument composite", value=composite, expected_type=type_hints["composite"])
            check_type(argname="argument compound", value=compound, expected_type=type_hints["compound"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument crop", value=crop, expected_type=type_hints["crop"])
            check_type(argname="argument face_crop", value=face_crop, expected_type=type_hints["face_crop"])
            check_type(argname="argument feature_crop", value=feature_crop, expected_type=type_hints["feature_crop"])
            check_type(argname="argument fit_and_fill", value=fit_and_fill, expected_type=type_hints["fit_and_fill"])
            check_type(argname="argument goop", value=goop, expected_type=type_hints["goop"])
            check_type(argname="argument grayscale", value=grayscale, expected_type=type_hints["grayscale"])
            check_type(argname="argument hsl", value=hsl, expected_type=type_hints["hsl"])
            check_type(argname="argument hsv", value=hsv, expected_type=type_hints["hsv"])
            check_type(argname="argument if_dimension", value=if_dimension, expected_type=type_hints["if_dimension"])
            check_type(argname="argument if_orientation", value=if_orientation, expected_type=type_hints["if_orientation"])
            check_type(argname="argument im_query", value=im_query, expected_type=type_hints["im_query"])
            check_type(argname="argument max_colors", value=max_colors, expected_type=type_hints["max_colors"])
            check_type(argname="argument mirror", value=mirror, expected_type=type_hints["mirror"])
            check_type(argname="argument mono_hue", value=mono_hue, expected_type=type_hints["mono_hue"])
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument region_of_interest_crop", value=region_of_interest_crop, expected_type=type_hints["region_of_interest_crop"])
            check_type(argname="argument relative_crop", value=relative_crop, expected_type=type_hints["relative_crop"])
            check_type(argname="argument remove_color", value=remove_color, expected_type=type_hints["remove_color"])
            check_type(argname="argument resize", value=resize, expected_type=type_hints["resize"])
            check_type(argname="argument rotate", value=rotate, expected_type=type_hints["rotate"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument shear", value=shear, expected_type=type_hints["shear"])
            check_type(argname="argument trim", value=trim, expected_type=type_hints["trim"])
            check_type(argname="argument unsharp_mask", value=unsharp_mask, expected_type=type_hints["unsharp_mask"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if append is not None:
            self._values["append"] = append
        if aspect_crop is not None:
            self._values["aspect_crop"] = aspect_crop
        if background_color is not None:
            self._values["background_color"] = background_color
        if blur is not None:
            self._values["blur"] = blur
        if chroma_key is not None:
            self._values["chroma_key"] = chroma_key
        if composite is not None:
            self._values["composite"] = composite
        if compound is not None:
            self._values["compound"] = compound
        if contrast is not None:
            self._values["contrast"] = contrast
        if crop is not None:
            self._values["crop"] = crop
        if face_crop is not None:
            self._values["face_crop"] = face_crop
        if feature_crop is not None:
            self._values["feature_crop"] = feature_crop
        if fit_and_fill is not None:
            self._values["fit_and_fill"] = fit_and_fill
        if goop is not None:
            self._values["goop"] = goop
        if grayscale is not None:
            self._values["grayscale"] = grayscale
        if hsl is not None:
            self._values["hsl"] = hsl
        if hsv is not None:
            self._values["hsv"] = hsv
        if if_dimension is not None:
            self._values["if_dimension"] = if_dimension
        if if_orientation is not None:
            self._values["if_orientation"] = if_orientation
        if im_query is not None:
            self._values["im_query"] = im_query
        if max_colors is not None:
            self._values["max_colors"] = max_colors
        if mirror is not None:
            self._values["mirror"] = mirror
        if mono_hue is not None:
            self._values["mono_hue"] = mono_hue
        if opacity is not None:
            self._values["opacity"] = opacity
        if region_of_interest_crop is not None:
            self._values["region_of_interest_crop"] = region_of_interest_crop
        if relative_crop is not None:
            self._values["relative_crop"] = relative_crop
        if remove_color is not None:
            self._values["remove_color"] = remove_color
        if resize is not None:
            self._values["resize"] = resize
        if rotate is not None:
            self._values["rotate"] = rotate
        if scale is not None:
            self._values["scale"] = scale
        if shear is not None:
            self._values["shear"] = shear
        if trim is not None:
            self._values["trim"] = trim
        if unsharp_mask is not None:
            self._values["unsharp_mask"] = unsharp_mask

    @builtins.property
    def append(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitAppend"]]]:
        '''append block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        '''
        result = self._values.get("append")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitAppend"]]], result)

    @builtins.property
    def aspect_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitAspectCrop"]]]:
        '''aspect_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        '''
        result = self._values.get("aspect_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitAspectCrop"]]], result)

    @builtins.property
    def background_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitBackgroundColor"]]]:
        '''background_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        '''
        result = self._values.get("background_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitBackgroundColor"]]], result)

    @builtins.property
    def blur(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitBlur"]]]:
        '''blur block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        '''
        result = self._values.get("blur")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitBlur"]]], result)

    @builtins.property
    def chroma_key(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitChromaKey"]]]:
        '''chroma_key block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        '''
        result = self._values.get("chroma_key")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitChromaKey"]]], result)

    @builtins.property
    def composite(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitComposite"]]]:
        '''composite block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        '''
        result = self._values.get("composite")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitComposite"]]], result)

    @builtins.property
    def compound(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitCompound"]]]:
        '''compound block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        '''
        result = self._values.get("compound")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitCompound"]]], result)

    @builtins.property
    def contrast(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitContrast"]]]:
        '''contrast block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitContrast"]]], result)

    @builtins.property
    def crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitCrop"]]]:
        '''crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        '''
        result = self._values.get("crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitCrop"]]], result)

    @builtins.property
    def face_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitFaceCrop"]]]:
        '''face_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        '''
        result = self._values.get("face_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitFaceCrop"]]], result)

    @builtins.property
    def feature_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitFeatureCrop"]]]:
        '''feature_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        '''
        result = self._values.get("feature_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitFeatureCrop"]]], result)

    @builtins.property
    def fit_and_fill(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitFitAndFill"]]]:
        '''fit_and_fill block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        '''
        result = self._values.get("fit_and_fill")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitFitAndFill"]]], result)

    @builtins.property
    def goop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitGoop"]]]:
        '''goop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        '''
        result = self._values.get("goop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitGoop"]]], result)

    @builtins.property
    def grayscale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitGrayscale"]]]:
        '''grayscale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        '''
        result = self._values.get("grayscale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitGrayscale"]]], result)

    @builtins.property
    def hsl(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitHsl"]]]:
        '''hsl block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        '''
        result = self._values.get("hsl")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitHsl"]]], result)

    @builtins.property
    def hsv(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitHsv"]]]:
        '''hsv block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        '''
        result = self._values.get("hsv")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitHsv"]]], result)

    @builtins.property
    def if_dimension(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfDimension"]]]:
        '''if_dimension block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        '''
        result = self._values.get("if_dimension")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfDimension"]]], result)

    @builtins.property
    def if_orientation(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientation"]]]:
        '''if_orientation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        '''
        result = self._values.get("if_orientation")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientation"]]], result)

    @builtins.property
    def im_query(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitImQuery"]]]:
        '''im_query block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        '''
        result = self._values.get("im_query")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitImQuery"]]], result)

    @builtins.property
    def max_colors(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitMaxColors"]]]:
        '''max_colors block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        '''
        result = self._values.get("max_colors")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitMaxColors"]]], result)

    @builtins.property
    def mirror(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitMirror"]]]:
        '''mirror block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        '''
        result = self._values.get("mirror")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitMirror"]]], result)

    @builtins.property
    def mono_hue(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitMonoHue"]]]:
        '''mono_hue block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        '''
        result = self._values.get("mono_hue")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitMonoHue"]]], result)

    @builtins.property
    def opacity(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitOpacity"]]]:
        '''opacity block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitOpacity"]]], result)

    @builtins.property
    def region_of_interest_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitRegionOfInterestCrop"]]]:
        '''region_of_interest_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        '''
        result = self._values.get("region_of_interest_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitRegionOfInterestCrop"]]], result)

    @builtins.property
    def relative_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitRelativeCrop"]]]:
        '''relative_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        '''
        result = self._values.get("relative_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitRelativeCrop"]]], result)

    @builtins.property
    def remove_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitRemoveColor"]]]:
        '''remove_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        '''
        result = self._values.get("remove_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitRemoveColor"]]], result)

    @builtins.property
    def resize(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitResize"]]]:
        '''resize block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        '''
        result = self._values.get("resize")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitResize"]]], result)

    @builtins.property
    def rotate(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitRotate"]]]:
        '''rotate block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        '''
        result = self._values.get("rotate")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitRotate"]]], result)

    @builtins.property
    def scale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitScale"]]]:
        '''scale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitScale"]]], result)

    @builtins.property
    def shear(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitShear"]]]:
        '''shear block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        '''
        result = self._values.get("shear")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitShear"]]], result)

    @builtins.property
    def trim(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitTrim"]]]:
        '''trim block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        '''
        result = self._values.get("trim")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitTrim"]]], result)

    @builtins.property
    def unsharp_mask(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitUnsharpMask"]]]:
        '''unsharp_mask block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        result = self._values.get("unsharp_mask")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitUnsharpMask"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortrait(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitAppend",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_priority": "gravityPriority",
        "gravity_priority_var": "gravityPriorityVar",
        "gravity_var": "gravityVar",
        "preserve_minor_dimension": "preserveMinorDimension",
        "preserve_minor_dimension_var": "preserveMinorDimensionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitAppend:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitAppendImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_priority: typing.Optional[builtins.str] = None,
        gravity_priority_var: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        preserve_minor_dimension: typing.Optional[builtins.str] = None,
        preserve_minor_dimension_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Specifies where to place the ``image`` relative to the source image. The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_priority: Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal. The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority DataAkamaiImagingPolicyImage#gravity_priority}
        :param gravity_priority_var: Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal. The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority_var DataAkamaiImagingPolicyImage#gravity_priority_var}
        :param gravity_var: Specifies where to place the ``image`` relative to the source image. The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param preserve_minor_dimension: Whether to preserve the source image's minor dimension, ``false`` by default. The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension DataAkamaiImagingPolicyImage#preserve_minor_dimension}
        :param preserve_minor_dimension_var: Whether to preserve the source image's minor dimension, ``false`` by default. The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension_var DataAkamaiImagingPolicyImage#preserve_minor_dimension_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitAppendImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__07b4d538f2e3c95729d37b675c669bacd5b990e9d429156d05c4fdac18fd51a1)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_priority", value=gravity_priority, expected_type=type_hints["gravity_priority"])
            check_type(argname="argument gravity_priority_var", value=gravity_priority_var, expected_type=type_hints["gravity_priority_var"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument preserve_minor_dimension", value=preserve_minor_dimension, expected_type=type_hints["preserve_minor_dimension"])
            check_type(argname="argument preserve_minor_dimension_var", value=preserve_minor_dimension_var, expected_type=type_hints["preserve_minor_dimension_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_priority is not None:
            self._values["gravity_priority"] = gravity_priority
        if gravity_priority_var is not None:
            self._values["gravity_priority_var"] = gravity_priority_var
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if preserve_minor_dimension is not None:
            self._values["preserve_minor_dimension"] = preserve_minor_dimension
        if preserve_minor_dimension_var is not None:
            self._values["preserve_minor_dimension_var"] = preserve_minor_dimension_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitAppendImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitAppendImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Specifies where to place the ``image`` relative to the source image.

        The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_priority(self) -> typing.Optional[builtins.str]:
        '''Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal.

        The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority DataAkamaiImagingPolicyImage#gravity_priority}
        '''
        result = self._values.get("gravity_priority")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_priority_var(self) -> typing.Optional[builtins.str]:
        '''Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal.

        The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority_var DataAkamaiImagingPolicyImage#gravity_priority_var}
        '''
        result = self._values.get("gravity_priority_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Specifies where to place the ``image`` relative to the source image.

        The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def preserve_minor_dimension(self) -> typing.Optional[builtins.str]:
        '''Whether to preserve the source image's minor dimension, ``false`` by default.

        The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension DataAkamaiImagingPolicyImage#preserve_minor_dimension}
        '''
        result = self._values.get("preserve_minor_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def preserve_minor_dimension_var(self) -> typing.Optional[builtins.str]:
        '''Whether to preserve the source image's minor dimension, ``false`` by default.

        The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension_var DataAkamaiImagingPolicyImage#preserve_minor_dimension_var}
        '''
        result = self._values.get("preserve_minor_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitAppend(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitAppendImage",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitAppendImage:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitAppendImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitAppendImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitAppendImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df6b1c2c18c9fa1d40deb1706518ba38b42d7669185f95fd590bede37496981e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitAppendImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitAppendImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitAppendImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3f6e1cd9b61128af5ba9aee29d13472ed8ea2d907347365b98eaca125eabc023)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitAppendList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitAppendList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6ec8ed946289616db87b4fdefea972ed2857d3c2e2ecd3bb1084512c96160ef6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitAppendOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__447606dcda1d88df45e3b07afc2bb8e41b5f4262b9029a8e70f0e3502aec2f6c)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitAppendOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b766a6501345dc324f01ee2a414d365086be676d57e8f008666c10e89dea4f9e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c5283f6ff2a81064ce08efb45c2987ddd76ed5e426ef48262a6961fb28ed55d7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9466d8a5dcf6adaeb21f3d35f621b43f8d75aaa5f675898dbbab145ce3eec37c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitAppend]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitAppend]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitAppend]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__198b9cf0bf16f6566bc9df03caa9fc9a53f1a9015c2395ad3fa7daa0e2c1b57b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitAppendOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitAppendOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4b98d29af5874e35ba99823c839021b1071984b3629245560f0c9d0a0393746f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitAppendImage()

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityPriority")
    def reset_gravity_priority(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityPriority", []))

    @jsii.member(jsii_name="resetGravityPriorityVar")
    def reset_gravity_priority_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityPriorityVar", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPreserveMinorDimension")
    def reset_preserve_minor_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPreserveMinorDimension", []))

    @jsii.member(jsii_name="resetPreserveMinorDimensionVar")
    def reset_preserve_minor_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPreserveMinorDimensionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitAppendImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitAppendImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityInput")
    def gravity_priority_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityPriorityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityVarInput")
    def gravity_priority_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityPriorityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitAppendImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitAppendImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionInput")
    def preserve_minor_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "preserveMinorDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionVarInput")
    def preserve_minor_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "preserveMinorDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ed8cf74a4f45e593e4dc4058fdf362c1017f9cd87f4f53480a8e0e512f23007)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityPriority")
    def gravity_priority(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityPriority"))

    @gravity_priority.setter
    def gravity_priority(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__293cef8bb83b8121a4923e6e91914853bd01042bf8ff378948e27eef867ddd9b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityPriority", value)

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityVar")
    def gravity_priority_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityPriorityVar"))

    @gravity_priority_var.setter
    def gravity_priority_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7146c44898462b2aaf8d977d66dfebd0688122b0801739eedf871154383de3f4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityPriorityVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__393936fd68d9ccbc29c5c9ac0690536f2f5dd99421aca7c9142916ad43ba58a3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimension")
    def preserve_minor_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "preserveMinorDimension"))

    @preserve_minor_dimension.setter
    def preserve_minor_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b4f195f67a0f8633f2a7f3e6674ee670acda2c1a570336d7b1bafde967e497a8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "preserveMinorDimension", value)

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionVar")
    def preserve_minor_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "preserveMinorDimensionVar"))

    @preserve_minor_dimension_var.setter
    def preserve_minor_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__84a021f68d7dbf8e9d7f7eb6a6e3681887bcd832824b2c170db77895e590cd6c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "preserveMinorDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitAppend]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitAppend]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitAppend]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c9ffa0bbc145789ccf56052cb4a6a298a0ac3818201e4a7873691690e0896dc3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitAspectCrop",
    jsii_struct_bases=[],
    name_mapping={
        "allow_expansion": "allowExpansion",
        "allow_expansion_var": "allowExpansionVar",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitAspectCrop:
    def __init__(
        self,
        *,
        allow_expansion: typing.Optional[builtins.str] = None,
        allow_expansion_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_expansion: Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image. Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        :param allow_expansion_var: Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image. Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        :param height: The height term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The width term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        :param x_position: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6aa108dbb4837313c9162b8d6a5b09bf281dac3499c4fd967591c60f15daa105)
            check_type(argname="argument allow_expansion", value=allow_expansion, expected_type=type_hints["allow_expansion"])
            check_type(argname="argument allow_expansion_var", value=allow_expansion_var, expected_type=type_hints["allow_expansion_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if allow_expansion is not None:
            self._values["allow_expansion"] = allow_expansion
        if allow_expansion_var is not None:
            self._values["allow_expansion_var"] = allow_expansion_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def allow_expansion(self) -> typing.Optional[builtins.str]:
        '''Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image.

        Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        '''
        result = self._values.get("allow_expansion")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def allow_expansion_var(self) -> typing.Optional[builtins.str]:
        '''Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image.

        Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        '''
        result = self._values.get("allow_expansion_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitAspectCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitAspectCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitAspectCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c712a6724c2ddc748d900e2921d6a0ed5a79e96dcc3c8f78e3381b4d58b6858c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitAspectCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__85a88fb0664182b98710ba91c1271d1ff7f7c8b3dc9a1dbd0b97f1e8e2b9f045)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitAspectCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__43bf43d12790339405e809686283ce4ac8f48e691e95aaa7acfc7c49a1754b10)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__41c80c548d28065ab5a15cad8dd6b9ec67c9aea27770a9ff6a15cfe1ffe08dda)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1a642975c022b94340c9ca21ee7265486622564b479a813c6e910263d0ae18f2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitAspectCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitAspectCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitAspectCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__427d4395fc1584c679a5c8eda194b9e0660cb4e57f03dcc5597ba13a227eb775)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitAspectCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitAspectCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__33b7f49b03bddd421d60201ed310a7c4e5f34404ab8d7f8a57d4e35fc6bd0e47)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAllowExpansion")
    def reset_allow_expansion(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansion", []))

    @jsii.member(jsii_name="resetAllowExpansionVar")
    def reset_allow_expansion_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansionVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionInput")
    def allow_expansion_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVarInput")
    def allow_expansion_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansion")
    def allow_expansion(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansion"))

    @allow_expansion.setter
    def allow_expansion(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8417f5411466fd9c22d99e3a6dd79b80895f440439f70644fb83f02189ac6b82)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansion", value)

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVar")
    def allow_expansion_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansionVar"))

    @allow_expansion_var.setter
    def allow_expansion_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__00e9c21dab8882ee287cc11c95fe7e0f127a95f0e78c22e63c7cabd822979beb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansionVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e05c08ed553f6be6b4b6db4144a6196349a2b9af53d48745cd02f29db56a2db7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c3efa87463cbbd8a2b43aba7677441d914ef9ba4c0c15618b7b6fc654e5b9476)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2407ec9b49fd3fb2ac199116cff6a836261dcf824b26b9deabb18182adf55b2e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b8965e8009508bf06ddfa3d4d0866f5e5cc03e9b221e1fc037dd568f80e46bb0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eb2ef1c44708e43b695cabf9d506ac400969e1387529df97107e3b211c10fab0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5a3ac1a14e478fe3cd50abc6e0e676b62d1d037586a1e180bcf1aeb92c9a0ec1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b196471cfa6f5493a9715007b7a0b1669246b55e6f75d75e5a7a0a9a5c7c0381)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8f7db7d9e2d7bfe44c5babea0c3e334c887c59fa7a9f38f22987b75a296db080)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitAspectCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitAspectCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitAspectCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3f8043c0fe9e86f7f69d6bdfa9eec63a481764cee09fe14596282dd92a5b2b14)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitBackgroundColor",
    jsii_struct_bases=[],
    name_mapping={"color": "color", "color_var": "colorVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitBackgroundColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__28ac90303b611be819ca73e645d75485e2c3cc13047d9495f25701b1999a12f5)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitBackgroundColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitBackgroundColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitBackgroundColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9831e98964270bd940674ed4fa5db8072fccf9c0e7d0982d735065ca33f49dd3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitBackgroundColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f3ee36c2b869debb4b805fbee53dc331d01f45b5d2674c81b59a482b61d49cdf)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitBackgroundColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__24d2252ed193a8501c83ef854dafedb2ad78af6b3cdfd6fa3fb32bcd1cdf7e71)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__428b5d032ebbcbb482219d62219adc18cb0539f09034ffdcd4a228681956fd58)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__77ead7a762fdd094ab2ad6c12c65f14866d789cea3ae393abef637ecf2963a5c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitBackgroundColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitBackgroundColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af88b812cb1ffa99d6ae22d74bd3196c2fba0713a97a7d18f16698a5663af150)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitBackgroundColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitBackgroundColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f445559fea547f2ccccec4a586c28ff1f671cb4ac8cd14f9ff81ff7e9db1eb61)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a525f7cc837a22863d362f2a3eff6d187cf6191b882475c72b89f8760b932619)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d64fee5c69a7adb379bad943c442769c7c4bd1961eac1aba8382a40af6c24c85)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitBackgroundColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitBackgroundColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitBackgroundColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__807d70a77b2103e78541b5b4c542e0c2173a62e1af98c01265f397607b1694da)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitBlur",
    jsii_struct_bases=[],
    name_mapping={"sigma": "sigma", "sigma_var": "sigmaVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitBlur:
    def __init__(
        self,
        *,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param sigma: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f6d08e353f2546f9f3ed8d5433871a7890e0d6a2de58a4cad6cd6b26f6bb23f2)
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitBlur(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitBlurList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitBlurList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0c3e6e16fa1c3746d284f4f7ce8469c7540aeb9bf323225b5d0eaf06ec85e42b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitBlurOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__55356dbfa74db082549eacc4d7b389618123304079c048461d9676bb969650bf)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitBlurOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__de6c0a9ad51997633381565c60dabeaed7d85cb3a3319b59e97bbd04c46e1a8a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8c56dd9e6185630416b99cf8b78c2bd7f3d30e0e545a6f20b7889ee1a11f5ede)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__686b26a303d93ca0afd9d31ca87c32b4d8650f36af09244fa810c5fedbf3ef44)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitBlur]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitBlur]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5019571f3cbbc5a80aee63ededf661ef2a22b42977d66979ff9a7e03420ac0c1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitBlurOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitBlurOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4722e1c84321d51ed381fa6dc1d617c2c8e27a933ea489cb4c8b7424ffe02795)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aeafb6d622a4782b5994d2bf6f2db0e765af299a1137ad2afbfe08a14b7eda8b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a97679f14bc8690b16033bbad490aa38b6f181bee3df37a272eb4ddf684355ed)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitBlur]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitBlur]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitBlur]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__778d658ce0820477f3067d760fcf3f79efc5822c609f84dd37e7346e1cccb632)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitChromaKey",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_feather": "hueFeather",
        "hue_feather_var": "hueFeatherVar",
        "hue_tolerance": "hueTolerance",
        "hue_tolerance_var": "hueToleranceVar",
        "hue_var": "hueVar",
        "lightness_feather": "lightnessFeather",
        "lightness_feather_var": "lightnessFeatherVar",
        "lightness_tolerance": "lightnessTolerance",
        "lightness_tolerance_var": "lightnessToleranceVar",
        "saturation_feather": "saturationFeather",
        "saturation_feather_var": "saturationFeatherVar",
        "saturation_tolerance": "saturationTolerance",
        "saturation_tolerance_var": "saturationToleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitChromaKey:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_feather: typing.Optional[builtins.str] = None,
        hue_feather_var: typing.Optional[builtins.str] = None,
        hue_tolerance: typing.Optional[builtins.str] = None,
        hue_tolerance_var: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness_feather: typing.Optional[builtins.str] = None,
        lightness_feather_var: typing.Optional[builtins.str] = None,
        lightness_tolerance: typing.Optional[builtins.str] = None,
        lightness_tolerance_var: typing.Optional[builtins.str] = None,
        saturation_feather: typing.Optional[builtins.str] = None,
        saturation_feather_var: typing.Optional[builtins.str] = None,
        saturation_tolerance: typing.Optional[builtins.str] = None,
        saturation_tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_feather: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        :param hue_feather_var: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        :param hue_tolerance: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        :param hue_tolerance_var: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        :param hue_var: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness_feather: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        :param lightness_feather_var: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        :param lightness_tolerance: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        :param lightness_tolerance_var: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        :param saturation_feather: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        :param saturation_feather_var: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        :param saturation_tolerance: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        :param saturation_tolerance_var: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7f5e53331cd7455d09a6ae666bf6b8de4df75dede29382eef9ebcebb776dfad5)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_feather", value=hue_feather, expected_type=type_hints["hue_feather"])
            check_type(argname="argument hue_feather_var", value=hue_feather_var, expected_type=type_hints["hue_feather_var"])
            check_type(argname="argument hue_tolerance", value=hue_tolerance, expected_type=type_hints["hue_tolerance"])
            check_type(argname="argument hue_tolerance_var", value=hue_tolerance_var, expected_type=type_hints["hue_tolerance_var"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness_feather", value=lightness_feather, expected_type=type_hints["lightness_feather"])
            check_type(argname="argument lightness_feather_var", value=lightness_feather_var, expected_type=type_hints["lightness_feather_var"])
            check_type(argname="argument lightness_tolerance", value=lightness_tolerance, expected_type=type_hints["lightness_tolerance"])
            check_type(argname="argument lightness_tolerance_var", value=lightness_tolerance_var, expected_type=type_hints["lightness_tolerance_var"])
            check_type(argname="argument saturation_feather", value=saturation_feather, expected_type=type_hints["saturation_feather"])
            check_type(argname="argument saturation_feather_var", value=saturation_feather_var, expected_type=type_hints["saturation_feather_var"])
            check_type(argname="argument saturation_tolerance", value=saturation_tolerance, expected_type=type_hints["saturation_tolerance"])
            check_type(argname="argument saturation_tolerance_var", value=saturation_tolerance_var, expected_type=type_hints["saturation_tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_feather is not None:
            self._values["hue_feather"] = hue_feather
        if hue_feather_var is not None:
            self._values["hue_feather_var"] = hue_feather_var
        if hue_tolerance is not None:
            self._values["hue_tolerance"] = hue_tolerance
        if hue_tolerance_var is not None:
            self._values["hue_tolerance_var"] = hue_tolerance_var
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness_feather is not None:
            self._values["lightness_feather"] = lightness_feather
        if lightness_feather_var is not None:
            self._values["lightness_feather_var"] = lightness_feather_var
        if lightness_tolerance is not None:
            self._values["lightness_tolerance"] = lightness_tolerance
        if lightness_tolerance_var is not None:
            self._values["lightness_tolerance_var"] = lightness_tolerance_var
        if saturation_feather is not None:
            self._values["saturation_feather"] = saturation_feather
        if saturation_feather_var is not None:
            self._values["saturation_feather_var"] = saturation_feather_var
        if saturation_tolerance is not None:
            self._values["saturation_tolerance"] = saturation_tolerance
        if saturation_tolerance_var is not None:
            self._values["saturation_tolerance_var"] = saturation_tolerance_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        '''
        result = self._values.get("hue_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        '''
        result = self._values.get("hue_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        '''
        result = self._values.get("hue_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        '''
        result = self._values.get("hue_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        '''
        result = self._values.get("lightness_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        '''
        result = self._values.get("lightness_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        '''
        result = self._values.get("lightness_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        '''
        result = self._values.get("lightness_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        '''
        result = self._values.get("saturation_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        '''
        result = self._values.get("saturation_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        '''
        result = self._values.get("saturation_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        result = self._values.get("saturation_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitChromaKey(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitChromaKeyList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitChromaKeyList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__18645ec6a1219f241e2ccbaf141e0b4cdc1e138a13ddc97817c7d59275a84ace)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitChromaKeyOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1d92a63c43948004ed095b52e3bcf5c87f6f49216989fe8ff5ec6e2f048403c8)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitChromaKeyOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__69485887124f1da180a19ce84f8021c88670dc17d06f64d0d899be4ad888b8a6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ce01aa0956cd10768f7ce172de2d08f75cf97138efbad03b1bc6ceb794b05726)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0fb902f30c8b3a138d277d27609d9615c0f0cd63144a8361eda283c058c284fb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitChromaKey]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitChromaKey]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8eed26929326870151e4687f140f84efa3625cef5cf0cb048204e846cbc4973a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitChromaKeyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitChromaKeyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e0f5e8a5f9b5b6cfb79e4e19aa82820e83e66e8fda3f841ccd048f0648ac031d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueFeather")
    def reset_hue_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeather", []))

    @jsii.member(jsii_name="resetHueFeatherVar")
    def reset_hue_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeatherVar", []))

    @jsii.member(jsii_name="resetHueTolerance")
    def reset_hue_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueTolerance", []))

    @jsii.member(jsii_name="resetHueToleranceVar")
    def reset_hue_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueToleranceVar", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightnessFeather")
    def reset_lightness_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeather", []))

    @jsii.member(jsii_name="resetLightnessFeatherVar")
    def reset_lightness_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeatherVar", []))

    @jsii.member(jsii_name="resetLightnessTolerance")
    def reset_lightness_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessTolerance", []))

    @jsii.member(jsii_name="resetLightnessToleranceVar")
    def reset_lightness_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessToleranceVar", []))

    @jsii.member(jsii_name="resetSaturationFeather")
    def reset_saturation_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeather", []))

    @jsii.member(jsii_name="resetSaturationFeatherVar")
    def reset_saturation_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeatherVar", []))

    @jsii.member(jsii_name="resetSaturationTolerance")
    def reset_saturation_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationTolerance", []))

    @jsii.member(jsii_name="resetSaturationToleranceVar")
    def reset_saturation_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherInput")
    def hue_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVarInput")
    def hue_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceInput")
    def hue_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVarInput")
    def hue_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherInput")
    def lightness_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVarInput")
    def lightness_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceInput")
    def lightness_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVarInput")
    def lightness_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherInput")
    def saturation_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVarInput")
    def saturation_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceInput")
    def saturation_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVarInput")
    def saturation_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3e34729072175945477f6c82fa4dabf67bee9e95d85494be1da362bfc8f62f75)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeather")
    def hue_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeather"))

    @hue_feather.setter
    def hue_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d82797d1feb06886d1d2e62d6241835a869b972e0ba79bff2ffaf739c590d03c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeather", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVar")
    def hue_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeatherVar"))

    @hue_feather_var.setter
    def hue_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0b8ee8ba96f952ffeaecc95d04a11ce19a00d7805a1371c592101f413585efc8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueTolerance")
    def hue_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueTolerance"))

    @hue_tolerance.setter
    def hue_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__33d148723e11b27484780cd10fc7698259174b2ef2ce51fca7ff898667f5d306)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVar")
    def hue_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueToleranceVar"))

    @hue_tolerance_var.setter
    def hue_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__37b2657c3f5a40591e1e558846fbbe3fa2002d10aa54568bdf13913fe9ba992d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__852ddba67992956d59fab9d9b04ba037927e9d30b5a756daeffda5f7cb1f45aa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeather")
    def lightness_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeather"))

    @lightness_feather.setter
    def lightness_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5a63402e1f8f476b84b836ff322ef291cfd6709e2bf98fdc86ef8510c9318c8b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeather", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVar")
    def lightness_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeatherVar"))

    @lightness_feather_var.setter
    def lightness_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5703925098862e52f707f4057c8ae1672ad094537833d3a3754d91a60332b4df)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessTolerance")
    def lightness_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessTolerance"))

    @lightness_tolerance.setter
    def lightness_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9f5f73be7f59053f94a9d6a6e1c123e64de743c631ad57389ef8978c45d64b19)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVar")
    def lightness_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessToleranceVar"))

    @lightness_tolerance_var.setter
    def lightness_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e6d1e94bef243194bfd606538ea0cd4f601b2dcc076976b291823cbeb8c28668)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeather")
    def saturation_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeather"))

    @saturation_feather.setter
    def saturation_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d9713bb965c2fdbbce8469ea031b9520452941d46145e9a21caa6a6ec7104970)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeather", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVar")
    def saturation_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeatherVar"))

    @saturation_feather_var.setter
    def saturation_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2620b62cdf44885f1b0625867141666d31e5746ef53ccab45b21f446f20fcaba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationTolerance")
    def saturation_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationTolerance"))

    @saturation_tolerance.setter
    def saturation_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ef8d0a93d785de0cca8ec48eafd1868635754ae436b8bbb50ab5f770bd3af6a8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVar")
    def saturation_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationToleranceVar"))

    @saturation_tolerance_var.setter
    def saturation_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e6275547150aae726bc34f77341847865f864b37452bb6b784f9f9cc83deaa67)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitChromaKey]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitChromaKey]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitChromaKey]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ffdbd7f31fef4fae6352d8af09687ccb8ac50ee765a1a9d624be05e66c732b3a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitComposite",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "placement": "placement",
        "placement_var": "placementVar",
        "scale": "scale",
        "scale_dimension": "scaleDimension",
        "scale_dimension_var": "scaleDimensionVar",
        "scale_var": "scaleVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitComposite:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitCompositeImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        placement: typing.Optional[builtins.str] = None,
        placement_var: typing.Optional[builtins.str] = None,
        scale: typing.Optional[builtins.str] = None,
        scale_dimension: typing.Optional[builtins.str] = None,
        scale_dimension_var: typing.Optional[builtins.str] = None,
        scale_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param placement: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        :param placement_var: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        :param scale: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param scale_dimension: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        :param scale_dimension_var: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        :param scale_var: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        :param x_position: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitCompositeImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__38629ad9459d4d91d46267b41f255355fc19f61aa17c6f5ac81160246374c9f6)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument placement", value=placement, expected_type=type_hints["placement"])
            check_type(argname="argument placement_var", value=placement_var, expected_type=type_hints["placement_var"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument scale_dimension", value=scale_dimension, expected_type=type_hints["scale_dimension"])
            check_type(argname="argument scale_dimension_var", value=scale_dimension_var, expected_type=type_hints["scale_dimension_var"])
            check_type(argname="argument scale_var", value=scale_var, expected_type=type_hints["scale_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if placement is not None:
            self._values["placement"] = placement
        if placement_var is not None:
            self._values["placement_var"] = placement_var
        if scale is not None:
            self._values["scale"] = scale
        if scale_dimension is not None:
            self._values["scale_dimension"] = scale_dimension
        if scale_dimension_var is not None:
            self._values["scale_dimension_var"] = scale_dimension_var
        if scale_var is not None:
            self._values["scale_var"] = scale_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitCompositeImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitCompositeImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        '''
        result = self._values.get("placement")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement_var(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        '''
        result = self._values.get("placement_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        '''
        result = self._values.get("scale_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        '''
        result = self._values.get("scale_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        '''
        result = self._values.get("scale_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitComposite(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitCompositeImage",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitCompositeImage:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitCompositeImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitCompositeImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitCompositeImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e381525b0f721b850db6ce5d90a4d9f46adc7f6e7982c55ce9febc8907edadbe)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitCompositeImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitCompositeImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3522fe9bfecfea3725ed2ba7863e111a96ee776beda1a3b6c9077f7d4efc65ed)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitCompositeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitCompositeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__841791096e0ab5da4435247c8985149d9b240b24e67f7b701f9d35fda1e2caf5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitCompositeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2373e0511a1fda9b0bff5b6bff4b04db51a2fad6a0fc20bac1fa19406f6dd571)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitCompositeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__55957c796acb4932848d200a20ac91e139433ac40ac7e61d7510c1d1bf303c57)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ff6cd0064831babebe62acdec0bf2c53acf9409cb005f8bb333a68bd65cf0ab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ce3d5f54801b71ad2d95ffff4d65c275e2382d0e0dcc0e0065fc3e8eb7d4b7b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitComposite]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitComposite]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__616e82c54093cd42736f28b28b1f58fe85beb46d21dcf44a76b8ef186255c774)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitCompositeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitCompositeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9f9c7c520a6c53ace220018c8769c9b81c4e4f883023cc7f9707cdbb9477b932)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitCompositeImage()

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPlacement")
    def reset_placement(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacement", []))

    @jsii.member(jsii_name="resetPlacementVar")
    def reset_placement_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacementVar", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetScaleDimension")
    def reset_scale_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimension", []))

    @jsii.member(jsii_name="resetScaleDimensionVar")
    def reset_scale_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimensionVar", []))

    @jsii.member(jsii_name="resetScaleVar")
    def reset_scale_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitCompositeImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitCompositeImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitCompositeImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="placementInput")
    def placement_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementInput"))

    @builtins.property
    @jsii.member(jsii_name="placementVarInput")
    def placement_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionInput")
    def scale_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVarInput")
    def scale_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleVarInput")
    def scale_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc39eacd51c2d42de6f09fb0e817ef0f516b4ef03eba4424e3f7ae7d051e5dbd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e9f4d650049c8e4b249abb4279ab5b55c52e786891b8178efecb6b39fd93abc1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="placement")
    def placement(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placement"))

    @placement.setter
    def placement(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0e7504487d03d865e4c6ee00d8211da94c5ab90712fa3b13a936d0c6bf2fd700)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placement", value)

    @builtins.property
    @jsii.member(jsii_name="placementVar")
    def placement_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placementVar"))

    @placement_var.setter
    def placement_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0e2f0428e2b437dbb917cef6feee05a5b54f8c1af1061822656f5f985f2f8648)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placementVar", value)

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scale"))

    @scale.setter
    def scale(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__38279483bb1800716dbf9c6ab83f66f15de35a239a65bd40a97c25eb1aa1eb40)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scale", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimension")
    def scale_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimension"))

    @scale_dimension.setter
    def scale_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__30c4fae8287ff3f9c7ce378fce75d10d369020194583f7cff3ff251d9ad7c479)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimension", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVar")
    def scale_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimensionVar"))

    @scale_dimension_var.setter
    def scale_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4da3830f7ca4bc739fd73dd8d35fc0211a451f31f75e293c76274bac76553ae3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="scaleVar")
    def scale_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleVar"))

    @scale_var.setter
    def scale_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e8bb7b2bf5b9947c4e8c0c4e3e9b6927b7c0ecde4523dd827329bcbe07000910)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d614059533071172304e6004b7a1d496cdc3f3b4c232b7270ae20649ed577c7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f6890c309a8e31bc18e97f035ab44c5bff3323a1fa2a44258e80ea56a51c130)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af521fefb0215f8a247695f699872e5227f3a65e5cb322ff9e758090fe55e221)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3b1547b783f252c4e9c4a1b598feac0f7a4af16e6d4ac2899cc75d6b85389e88)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitComposite]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitComposite]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitComposite]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7e4295759a2c3a4ec5d29bad38dc7fa184720df75e595ad64a151ad971830032)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitCompound",
    jsii_struct_bases=[],
    name_mapping={"transformations": "transformations"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitCompound:
    def __init__(
        self,
        *,
        transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param transformations: transformations block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c34d568eff6be4fd9547b4983d9b4b4bb7042df817cee8ff57119cbfdfe5d287)
            check_type(argname="argument transformations", value=transformations, expected_type=type_hints["transformations"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if transformations is not None:
            self._values["transformations"] = transformations

    @builtins.property
    def transformations(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitCompoundTransformations"]]]:
        '''transformations block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        result = self._values.get("transformations")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitCompoundTransformations"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitCompound(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitCompoundList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitCompoundList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__646ae66d95b641d676c048ef72cb9e843b8d171d8451d5e51179f03933c6cabc)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitCompoundOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__82a250d5e1e60b73776cfd602d14ab63eca80b819ea2c932cd4cd38ac8deb21f)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitCompoundOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2b16906977fbdf9146016690b1eb94176a7d278e5517ed440c6b56563fa575b0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2daaf6768faa95884d2e241d62fcaac4d8988e1883241644b629284887727d9f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa7cfe79c416009a0329ff3df09162682189dd8f059c773c11609355bee0efcb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitCompound]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitCompound]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__78b0588f2c1c2c0daf5c8f92a58a73d1e421a6e6c79a55f529be5544077d5b6b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitCompoundOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitCompoundOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__29f9929202ad9a211f228554f49dad6eeb35130477752c37cc98becbda2d0218)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformations")
    def put_transformations(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7634ce92b57581ee3f80758c7c83b7171fc23e8f2ed693da069eabda2ec01fb1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTransformations", [value]))

    @jsii.member(jsii_name="resetTransformations")
    def reset_transformations(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformations", []))

    @builtins.property
    @jsii.member(jsii_name="transformations")
    def transformations(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitCompoundTransformationsList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitCompoundTransformationsList", jsii.get(self, "transformations"))

    @builtins.property
    @jsii.member(jsii_name="transformationsInput")
    def transformations_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitCompoundTransformations"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitCompoundTransformations"]]], jsii.get(self, "transformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitCompound]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitCompound]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitCompound]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5c40a7a2a2e58a344ff824552f27543c09d85323f17923aaf6660745b6f3c515)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitCompoundTransformations",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitCompoundTransformations:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitCompoundTransformations(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitCompoundTransformationsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitCompoundTransformationsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa60ca7edb036cdf3afa19b7d093a248b33671bf865fd185d44f774fd120d7ac)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitCompoundTransformationsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d8ff8436987932d72cc1d5b6aee51d23629a9418c22a110fb1889f7949c51760)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitCompoundTransformationsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a53922fa2bde919c6e3bfe97c3739520546f86f7e94146579f2fe55b7b09571a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eae7533330274fc0d64883135d5c30e526eb26bd6bcf82d580cfd83c60f61d10)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__44d5ee1c77ecfeb97d0b559284b8190a2c64b069c4a962230fe78d7b4a445913)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitCompoundTransformations]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitCompoundTransformations]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitCompoundTransformations]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b968098385a11dcb9f8112f222761ac6c2c501a7d959c89fce7ef2de64e8bdac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitCompoundTransformationsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitCompoundTransformationsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__709c7b51c57cc63d35333a54a4c1ed6d927690fd394d843b3f100a67af2fa703)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitCompoundTransformations]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitCompoundTransformations]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitCompoundTransformations]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8e30b55b44e62809cb58b443daf923b6a33171eac49f6b6056ad67471202af56)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitContrast",
    jsii_struct_bases=[],
    name_mapping={
        "brightness": "brightness",
        "brightness_var": "brightnessVar",
        "contrast": "contrast",
        "contrast_var": "contrastVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitContrast:
    def __init__(
        self,
        *,
        brightness: typing.Optional[builtins.str] = None,
        brightness_var: typing.Optional[builtins.str] = None,
        contrast: typing.Optional[builtins.str] = None,
        contrast_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param brightness: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        :param brightness_var: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        :param contrast: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param contrast_var: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc6e1066d6e0ce46edde38e4e92229df351a1f93a4f5b667016051259a8a4d5f)
            check_type(argname="argument brightness", value=brightness, expected_type=type_hints["brightness"])
            check_type(argname="argument brightness_var", value=brightness_var, expected_type=type_hints["brightness_var"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument contrast_var", value=contrast_var, expected_type=type_hints["contrast_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if brightness is not None:
            self._values["brightness"] = brightness
        if brightness_var is not None:
            self._values["brightness_var"] = brightness_var
        if contrast is not None:
            self._values["contrast"] = contrast
        if contrast_var is not None:
            self._values["contrast_var"] = contrast_var

    @builtins.property
    def brightness(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        '''
        result = self._values.get("brightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def brightness_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        '''
        result = self._values.get("brightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        result = self._values.get("contrast_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitContrast(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitContrastList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitContrastList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e5b986c3c4df16a1a702bdc2aa254199a747c2c2bfb3fe9c6f66c667ddffe24d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitContrastOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__51eb9a653e106c965381475b577691bf7ac3aeeffdda931bc96b13d7269432ae)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitContrastOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1e0569551a823a61d74a4b425189d5c47930b7b32cd756b941e6009d42f24c50)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bcb28e82b067f528d074bbe2dad519ccd070e51e29dc8edf894ea2eba2b1ec52)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dd6bfbd1894a641a5de1b07bfa548735a1f44f945dd1b7cd9d17d203acfcb85b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitContrast]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitContrast]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4e78d38e233bbdf4d77572b4284a63f524a62aed70bcaf9e76b9e7b78a7656c3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitContrastOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitContrastOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__89bd662ec604af218310febaee481617c729d843b47262f4ace9e47ae5139586)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetBrightness")
    def reset_brightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightness", []))

    @jsii.member(jsii_name="resetBrightnessVar")
    def reset_brightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightnessVar", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetContrastVar")
    def reset_contrast_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrastVar", []))

    @builtins.property
    @jsii.member(jsii_name="brightnessInput")
    def brightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="brightnessVarInput")
    def brightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastVarInput")
    def contrast_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="brightness")
    def brightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightness"))

    @brightness.setter
    def brightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c96be181f75718213b84beed4ac3e723cda3831645265cf32066efeb0b8dd8be)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightness", value)

    @builtins.property
    @jsii.member(jsii_name="brightnessVar")
    def brightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightnessVar"))

    @brightness_var.setter
    def brightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ec9ec56bb82cfe54694bcc93d48de6eabda8e08f81ac486a8c8d332cac8a26ba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrast"))

    @contrast.setter
    def contrast(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__76cd548593d1dcc1c3890ee7494a311434591579a8e1e4f4e237b627149468ae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrast", value)

    @builtins.property
    @jsii.member(jsii_name="contrastVar")
    def contrast_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrastVar"))

    @contrast_var.setter
    def contrast_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6d143561f26b5d99f7bcfb7fd82cdafd97bd24da539692ff19173be9452aed97)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrastVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitContrast]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitContrast]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitContrast]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__59261038a06770dedba08a9bf4c32e86db578cb928fc99b25f6fb2b8106324ea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitCrop",
    jsii_struct_bases=[],
    name_mapping={
        "allow_expansion": "allowExpansion",
        "allow_expansion_var": "allowExpansionVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitCrop:
    def __init__(
        self,
        *,
        allow_expansion: typing.Optional[builtins.str] = None,
        allow_expansion_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_expansion: If cropping an area outside of the existing canvas, expands the image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        :param allow_expansion_var: If cropping an area outside of the existing canvas, expands the image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        :param gravity: Frame of reference for X and Y Positions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Frame of reference for X and Y Positions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The number of pixels to crop along the y-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The number of pixels to crop along the y-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The number of pixels to crop along the x-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The number of pixels to crop along the x-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        :param x_position: The x-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8e71d5039d731654b3cb6b2ae0106e5e9620219311500c301c9ec9c8a8ceb5d4)
            check_type(argname="argument allow_expansion", value=allow_expansion, expected_type=type_hints["allow_expansion"])
            check_type(argname="argument allow_expansion_var", value=allow_expansion_var, expected_type=type_hints["allow_expansion_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if allow_expansion is not None:
            self._values["allow_expansion"] = allow_expansion
        if allow_expansion_var is not None:
            self._values["allow_expansion_var"] = allow_expansion_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def allow_expansion(self) -> typing.Optional[builtins.str]:
        '''If cropping an area outside of the existing canvas, expands the image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        '''
        result = self._values.get("allow_expansion")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def allow_expansion_var(self) -> typing.Optional[builtins.str]:
        '''If cropping an area outside of the existing canvas, expands the image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        '''
        result = self._values.get("allow_expansion_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Frame of reference for X and Y Positions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Frame of reference for X and Y Positions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the y-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the y-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the x-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the x-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8db1c04cc93fd13241393bd7ba2df56f0abeb7d101177014c0c3ff92071e4424)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c50e8f74f7e7407dcd238db5a4b864f34be361a5cdba750afa92f7b681fba3b2)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__162997769c87b0f045c34a397fc425c6d356821ddb0c65da645bb8a2cb1f4dce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cf773b5bb9dbb70d12b4677f058bb5c7b0880ac5da951b96b0009bbd7a31743b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e6f7145c4c673f1d9782c36bbb98e8ca380c783974fda733e64014953e3be987)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__42d223f78010284ada21f8972e6951b49d6e68a8ee0005eb589b161857bf6020)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d64e5145b79d21d68b8e81047f7b4c31dc858ea7c16ee0a23ce12263d0c72af)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAllowExpansion")
    def reset_allow_expansion(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansion", []))

    @jsii.member(jsii_name="resetAllowExpansionVar")
    def reset_allow_expansion_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansionVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionInput")
    def allow_expansion_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVarInput")
    def allow_expansion_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansion")
    def allow_expansion(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansion"))

    @allow_expansion.setter
    def allow_expansion(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6272f0dc2ccd3106a7b7887526187a6b34b023382bad16927f882cf4d4c2e6f7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansion", value)

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVar")
    def allow_expansion_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansionVar"))

    @allow_expansion_var.setter
    def allow_expansion_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0870946d89c9311317729a093066a1a81415f70c510a21108ee194403e1c23c3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansionVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a73580bf4de39fdd76bbe6913869a85000643c70fd69bbf35eb65693a6874bc8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8b453d6a891777483e3d42db83861a82f7fc1c5a9543517cc4eeabbf9b4efef9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0297d91e340dd479a896aeabd166dabd1869424a386231df06303d920868ead4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b8f59d19b234b2f7cf2ee1b3b1792d8e8a20d96d7f53372ed98cae8668a7729b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0fe5e61d905e05d581a0e0419b414f73a9806f1caced84356b4543f14880786d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e0c7c27d410ed9a1631938496f43fc14d248b0d23501b4f1721ecceb374bc9c3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b5497f33621d0ea99427535a2afacf6e9434c0d522209e6da6dbe01dc42f1284)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2b47d67513e46f7014e20af7b26adcfc9f8b9f276405fb7ad8aa568609c4cb5d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7002785ee142953d7494bb1d071873bd8a19a53f22142c0420c24196785bec11)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a8f7bdb34ecdefd049b5c758854f4d0d88ad92e33bba95e68d1cb45f79d435f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a6cb78160bf77ea6b177ff574dff3587b365b6191175f0ca81efdf969b1b9ff0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitFaceCrop",
    jsii_struct_bases=[],
    name_mapping={
        "algorithm": "algorithm",
        "algorithm_var": "algorithmVar",
        "confidence": "confidence",
        "confidence_var": "confidenceVar",
        "fail_gravity": "failGravity",
        "fail_gravity_var": "failGravityVar",
        "focus": "focus",
        "focus_var": "focusVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "padding": "padding",
        "padding_var": "paddingVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitFaceCrop:
    def __init__(
        self,
        *,
        algorithm: typing.Optional[builtins.str] = None,
        algorithm_var: typing.Optional[builtins.str] = None,
        confidence: typing.Optional[builtins.str] = None,
        confidence_var: typing.Optional[builtins.str] = None,
        fail_gravity: typing.Optional[builtins.str] = None,
        fail_gravity_var: typing.Optional[builtins.str] = None,
        focus: typing.Optional[builtins.str] = None,
        focus_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param algorithm: Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm DataAkamaiImagingPolicyImage#algorithm}
        :param algorithm_var: Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm_var DataAkamaiImagingPolicyImage#algorithm_var}
        :param confidence: With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image. Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence DataAkamaiImagingPolicyImage#confidence}
        :param confidence_var: With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image. Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence_var DataAkamaiImagingPolicyImage#confidence_var}
        :param fail_gravity: Controls placement of the crop if Image and Video Manager does not detect any faces in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        :param fail_gravity_var: Controls placement of the crop if Image and Video Manager does not detect any faces in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        :param focus: Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus DataAkamaiImagingPolicyImage#focus}
        :param focus_var: Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus_var DataAkamaiImagingPolicyImage#focus_var}
        :param gravity: Controls placement of the crop. Directions are relative to the face(s) plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Controls placement of the crop. Directions are relative to the face(s) plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param padding: The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        :param style: Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__acfabafd89043c0fed11b43f535db435134f1a8f6df533614a29396a367109ed)
            check_type(argname="argument algorithm", value=algorithm, expected_type=type_hints["algorithm"])
            check_type(argname="argument algorithm_var", value=algorithm_var, expected_type=type_hints["algorithm_var"])
            check_type(argname="argument confidence", value=confidence, expected_type=type_hints["confidence"])
            check_type(argname="argument confidence_var", value=confidence_var, expected_type=type_hints["confidence_var"])
            check_type(argname="argument fail_gravity", value=fail_gravity, expected_type=type_hints["fail_gravity"])
            check_type(argname="argument fail_gravity_var", value=fail_gravity_var, expected_type=type_hints["fail_gravity_var"])
            check_type(argname="argument focus", value=focus, expected_type=type_hints["focus"])
            check_type(argname="argument focus_var", value=focus_var, expected_type=type_hints["focus_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if algorithm is not None:
            self._values["algorithm"] = algorithm
        if algorithm_var is not None:
            self._values["algorithm_var"] = algorithm_var
        if confidence is not None:
            self._values["confidence"] = confidence
        if confidence_var is not None:
            self._values["confidence_var"] = confidence_var
        if fail_gravity is not None:
            self._values["fail_gravity"] = fail_gravity
        if fail_gravity_var is not None:
            self._values["fail_gravity_var"] = fail_gravity_var
        if focus is not None:
            self._values["focus"] = focus
        if focus_var is not None:
            self._values["focus_var"] = focus_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def algorithm(self) -> typing.Optional[builtins.str]:
        '''Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm DataAkamaiImagingPolicyImage#algorithm}
        '''
        result = self._values.get("algorithm")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def algorithm_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm_var DataAkamaiImagingPolicyImage#algorithm_var}
        '''
        result = self._values.get("algorithm_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def confidence(self) -> typing.Optional[builtins.str]:
        '''With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image.

        Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence DataAkamaiImagingPolicyImage#confidence}
        '''
        result = self._values.get("confidence")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def confidence_var(self) -> typing.Optional[builtins.str]:
        '''With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image.

        Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence_var DataAkamaiImagingPolicyImage#confidence_var}
        '''
        result = self._values.get("confidence_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any faces in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        '''
        result = self._values.get("fail_gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any faces in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        '''
        result = self._values.get("fail_gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def focus(self) -> typing.Optional[builtins.str]:
        '''Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus DataAkamaiImagingPolicyImage#focus}
        '''
        result = self._values.get("focus")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def focus_var(self) -> typing.Optional[builtins.str]:
        '''Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus_var DataAkamaiImagingPolicyImage#focus_var}
        '''
        result = self._values.get("focus_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the face(s) plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the face(s) plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitFaceCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitFaceCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitFaceCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__68d05bccf0787a3dd18f7cc12e35740135c54fd50e738b4fc1f13cc360744bfa)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitFaceCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b885fe512fd8a661bce20623ebceb26f79dd56d231b5887c0db241c97451372e)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitFaceCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__de1d20fae44229542685a7bb831f89d53d8d4d873de1ffac3e3a0ab42674b93a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c8626ccf1e064a49a2cbc9816fb463aa4a07c89e7634aaccb0ee7a9bb0890eae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__94346e2a3f6d6c7c81c52a117e571034ac6f752ac779acc157fd1a87b59a0ee2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitFaceCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitFaceCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitFaceCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0c0d72410e01163cef826bd59c41ffde20df33b2958807a1d9bc99907b56a0fb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitFaceCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitFaceCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c37e29022a8e3bc2d448e8ab5c407d782419b6521f7a66751d5678f3b57e1e4e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAlgorithm")
    def reset_algorithm(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAlgorithm", []))

    @jsii.member(jsii_name="resetAlgorithmVar")
    def reset_algorithm_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAlgorithmVar", []))

    @jsii.member(jsii_name="resetConfidence")
    def reset_confidence(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetConfidence", []))

    @jsii.member(jsii_name="resetConfidenceVar")
    def reset_confidence_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetConfidenceVar", []))

    @jsii.member(jsii_name="resetFailGravity")
    def reset_fail_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravity", []))

    @jsii.member(jsii_name="resetFailGravityVar")
    def reset_fail_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravityVar", []))

    @jsii.member(jsii_name="resetFocus")
    def reset_focus(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFocus", []))

    @jsii.member(jsii_name="resetFocusVar")
    def reset_focus_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFocusVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="algorithmInput")
    def algorithm_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "algorithmInput"))

    @builtins.property
    @jsii.member(jsii_name="algorithmVarInput")
    def algorithm_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "algorithmVarInput"))

    @builtins.property
    @jsii.member(jsii_name="confidenceInput")
    def confidence_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "confidenceInput"))

    @builtins.property
    @jsii.member(jsii_name="confidenceVarInput")
    def confidence_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "confidenceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityInput")
    def fail_gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityVarInput")
    def fail_gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="focusInput")
    def focus_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "focusInput"))

    @builtins.property
    @jsii.member(jsii_name="focusVarInput")
    def focus_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "focusVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="algorithm")
    def algorithm(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "algorithm"))

    @algorithm.setter
    def algorithm(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__496c826b7f789b3f23c425daee55c70d845dd6035fcdb457c8a08c253e54269e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "algorithm", value)

    @builtins.property
    @jsii.member(jsii_name="algorithmVar")
    def algorithm_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "algorithmVar"))

    @algorithm_var.setter
    def algorithm_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3d3c3730ff5998b7b317012578894bb23d85bba1edab060173d3591be71ebf17)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "algorithmVar", value)

    @builtins.property
    @jsii.member(jsii_name="confidence")
    def confidence(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "confidence"))

    @confidence.setter
    def confidence(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a925668793a4e647ec98cef3a88802ac6ae290cca420078a03a2627b23b07135)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "confidence", value)

    @builtins.property
    @jsii.member(jsii_name="confidenceVar")
    def confidence_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "confidenceVar"))

    @confidence_var.setter
    def confidence_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__74db0073999b9ecc6242c1f314f993b362611cba552c0e7641bd25030d80bde8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "confidenceVar", value)

    @builtins.property
    @jsii.member(jsii_name="failGravity")
    def fail_gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravity"))

    @fail_gravity.setter
    def fail_gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__45943807ceb213ae6fb420d3dd44ce3e009f8172fc1833b27bd110c0efff7f93)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravity", value)

    @builtins.property
    @jsii.member(jsii_name="failGravityVar")
    def fail_gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravityVar"))

    @fail_gravity_var.setter
    def fail_gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0e67c7b1491b77b18e73bbeed7af6c88337041ac51281ef4665c32bb22e5659d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="focus")
    def focus(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "focus"))

    @focus.setter
    def focus(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5d253c034d9adbf1509d86fedaafbca3e131563efc47f9cebb4eda8f1cde32f2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "focus", value)

    @builtins.property
    @jsii.member(jsii_name="focusVar")
    def focus_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "focusVar"))

    @focus_var.setter
    def focus_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1c2010b3d626a8d0104dffaf9470d392fdfd015ab9af7ee752942f14f9b03e98)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "focusVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__abe74b0c5ddb6a88217df57073bf5db95bb541eb4f3a10d41c98391925b2fdfc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__28e4394360c081517223261bb91236ab1ef7d5789f2869aa457b4c3f8ebe21df)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d3f45c0b5edb4f12f78c39629d1079f96ca7b0e18c9e99d3ee0cc5bf68d047a3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3c92f2e77fa771c22b60b31425d974d551448fee906794c120089a876fd5b0ae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d1524a831a9b0a81a5193670d911d1b295dc00ec1e67e0db2f15c0a53b1a9436)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c702aceea3067e43e1cc53f0a056907e257c4b0828833bad5401ded42cfff8f6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cdddc4fe499476973c0142ebf5ec8c89ca0b449a67fd1dcbc8a75bbdca381988)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c26d787f774e005cd27e0e77925d26aa21bee2cdd6993bdf9fc4f61b5d6c0161)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d58782aea60e4defba3aee41588d50a7e1256f1ba3958840b26ed0303ed9d3b9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e32f134c895dfc40b5e8c91a6dfc28cf2bdf44f98914e3dc3b7a6b78dacfe9bf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitFaceCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitFaceCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitFaceCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__32a998055cc0703fb7561ddc9dcd622cb8ae5b5d805554020a373fa86d3fdf79)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitFeatureCrop",
    jsii_struct_bases=[],
    name_mapping={
        "fail_gravity": "failGravity",
        "fail_gravity_var": "failGravityVar",
        "feature_radius": "featureRadius",
        "feature_radius_var": "featureRadiusVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "max_features": "maxFeatures",
        "max_features_var": "maxFeaturesVar",
        "min_feature_quality": "minFeatureQuality",
        "min_feature_quality_var": "minFeatureQualityVar",
        "padding": "padding",
        "padding_var": "paddingVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitFeatureCrop:
    def __init__(
        self,
        *,
        fail_gravity: typing.Optional[builtins.str] = None,
        fail_gravity_var: typing.Optional[builtins.str] = None,
        feature_radius: typing.Optional[builtins.str] = None,
        feature_radius_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        max_features: typing.Optional[builtins.str] = None,
        max_features_var: typing.Optional[builtins.str] = None,
        min_feature_quality: typing.Optional[builtins.str] = None,
        min_feature_quality_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fail_gravity: Controls placement of the crop if Image and Video Manager does not detect any features in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        :param fail_gravity_var: Controls placement of the crop if Image and Video Manager does not detect any features in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        :param feature_radius: The size in pixels of the important features to search for. If identified, two features never appear closer together than this value, ``8.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius DataAkamaiImagingPolicyImage#feature_radius}
        :param feature_radius_var: The size in pixels of the important features to search for. If identified, two features never appear closer together than this value, ``8.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius_var DataAkamaiImagingPolicyImage#feature_radius_var}
        :param gravity: Controls placement of the crop. Directions are relative to the region of interest plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Controls placement of the crop. Directions are relative to the region of interest plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param max_features: The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features DataAkamaiImagingPolicyImage#max_features}
        :param max_features_var: The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features_var DataAkamaiImagingPolicyImage#max_features_var}
        :param min_feature_quality: Determines the minimum quality level of the feature identified. To consider a feature important, the feature needs to surpass this value. Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality DataAkamaiImagingPolicyImage#min_feature_quality}
        :param min_feature_quality_var: Determines the minimum quality level of the feature identified. To consider a feature important, the feature needs to surpass this value. Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality_var DataAkamaiImagingPolicyImage#min_feature_quality_var}
        :param padding: Adds space around the region of interest. The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: Adds space around the region of interest. The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        :param style: Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b729a7e48c4f343c8bb40175bfa207db5722185cbcf25047430d198d1d678ef2)
            check_type(argname="argument fail_gravity", value=fail_gravity, expected_type=type_hints["fail_gravity"])
            check_type(argname="argument fail_gravity_var", value=fail_gravity_var, expected_type=type_hints["fail_gravity_var"])
            check_type(argname="argument feature_radius", value=feature_radius, expected_type=type_hints["feature_radius"])
            check_type(argname="argument feature_radius_var", value=feature_radius_var, expected_type=type_hints["feature_radius_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument max_features", value=max_features, expected_type=type_hints["max_features"])
            check_type(argname="argument max_features_var", value=max_features_var, expected_type=type_hints["max_features_var"])
            check_type(argname="argument min_feature_quality", value=min_feature_quality, expected_type=type_hints["min_feature_quality"])
            check_type(argname="argument min_feature_quality_var", value=min_feature_quality_var, expected_type=type_hints["min_feature_quality_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fail_gravity is not None:
            self._values["fail_gravity"] = fail_gravity
        if fail_gravity_var is not None:
            self._values["fail_gravity_var"] = fail_gravity_var
        if feature_radius is not None:
            self._values["feature_radius"] = feature_radius
        if feature_radius_var is not None:
            self._values["feature_radius_var"] = feature_radius_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if max_features is not None:
            self._values["max_features"] = max_features
        if max_features_var is not None:
            self._values["max_features_var"] = max_features_var
        if min_feature_quality is not None:
            self._values["min_feature_quality"] = min_feature_quality
        if min_feature_quality_var is not None:
            self._values["min_feature_quality_var"] = min_feature_quality_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def fail_gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any features in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        '''
        result = self._values.get("fail_gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any features in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        '''
        result = self._values.get("fail_gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feature_radius(self) -> typing.Optional[builtins.str]:
        '''The size in pixels of the important features to search for.

        If identified, two features never appear closer together than this value, ``8.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius DataAkamaiImagingPolicyImage#feature_radius}
        '''
        result = self._values.get("feature_radius")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feature_radius_var(self) -> typing.Optional[builtins.str]:
        '''The size in pixels of the important features to search for.

        If identified, two features never appear closer together than this value, ``8.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius_var DataAkamaiImagingPolicyImage#feature_radius_var}
        '''
        result = self._values.get("feature_radius_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the region of interest plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the region of interest plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def max_features(self) -> typing.Optional[builtins.str]:
        '''The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features DataAkamaiImagingPolicyImage#max_features}
        '''
        result = self._values.get("max_features")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def max_features_var(self) -> typing.Optional[builtins.str]:
        '''The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features_var DataAkamaiImagingPolicyImage#max_features_var}
        '''
        result = self._values.get("max_features_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def min_feature_quality(self) -> typing.Optional[builtins.str]:
        '''Determines the minimum quality level of the feature identified.

        To consider a feature important, the feature needs to surpass this value.  Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality DataAkamaiImagingPolicyImage#min_feature_quality}
        '''
        result = self._values.get("min_feature_quality")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def min_feature_quality_var(self) -> typing.Optional[builtins.str]:
        '''Determines the minimum quality level of the feature identified.

        To consider a feature important, the feature needs to surpass this value.  Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality_var DataAkamaiImagingPolicyImage#min_feature_quality_var}
        '''
        result = self._values.get("min_feature_quality_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''Adds space around the region of interest.

        The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''Adds space around the region of interest.

        The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitFeatureCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitFeatureCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitFeatureCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__839212a1a6dee7c12ed1dc9046e2a6e35e0209ea05b0abd8f2aa12e7188805d1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitFeatureCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__21343980614c5595c858a258701f427dffef89b0eab35882fb0f06e8b139ff9c)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitFeatureCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__30e85ead591bafc85f00a60b6de6d14d5a546101f32215d52596ea06e66565dd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c56e13e0126cf4603f59144867fcc7bc259d9cdfa895f76a1c9366bbd9cfc02e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d668d7a15de1c9f2e2201628b97914a9b71725764f393f221af6eb4c0bb3fc6b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitFeatureCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitFeatureCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitFeatureCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3b28e472c6b1ced6bfe7dc2dfae4aaf26e869f8eb5c1aaede37146f91d034312)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitFeatureCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitFeatureCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b441bb355616ac5a81c7c2aa64e3a941cbfe320300b2c2724838c27a66b51039)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetFailGravity")
    def reset_fail_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravity", []))

    @jsii.member(jsii_name="resetFailGravityVar")
    def reset_fail_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravityVar", []))

    @jsii.member(jsii_name="resetFeatureRadius")
    def reset_feature_radius(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureRadius", []))

    @jsii.member(jsii_name="resetFeatureRadiusVar")
    def reset_feature_radius_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureRadiusVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetMaxFeatures")
    def reset_max_features(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxFeatures", []))

    @jsii.member(jsii_name="resetMaxFeaturesVar")
    def reset_max_features_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxFeaturesVar", []))

    @jsii.member(jsii_name="resetMinFeatureQuality")
    def reset_min_feature_quality(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMinFeatureQuality", []))

    @jsii.member(jsii_name="resetMinFeatureQualityVar")
    def reset_min_feature_quality_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMinFeatureQualityVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="failGravityInput")
    def fail_gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityVarInput")
    def fail_gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featureRadiusInput")
    def feature_radius_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featureRadiusInput"))

    @builtins.property
    @jsii.member(jsii_name="featureRadiusVarInput")
    def feature_radius_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featureRadiusVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesInput")
    def max_features_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "maxFeaturesInput"))

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesVarInput")
    def max_features_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "maxFeaturesVarInput"))

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityInput")
    def min_feature_quality_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "minFeatureQualityInput"))

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityVarInput")
    def min_feature_quality_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "minFeatureQualityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravity")
    def fail_gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravity"))

    @fail_gravity.setter
    def fail_gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d825525481494ec8d4e6a069b96692bedf1d25d2727d1fe72da4379f7a32ed75)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravity", value)

    @builtins.property
    @jsii.member(jsii_name="failGravityVar")
    def fail_gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravityVar"))

    @fail_gravity_var.setter
    def fail_gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1783679edc5db5baecfdd5c7cfef913d23010d2b289058ab764ed6652e9fefac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="featureRadius")
    def feature_radius(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featureRadius"))

    @feature_radius.setter
    def feature_radius(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__11cd2172773ee8390ebbfd1663b85168bae16d4893eca1e0c283ad8480213f38)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featureRadius", value)

    @builtins.property
    @jsii.member(jsii_name="featureRadiusVar")
    def feature_radius_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featureRadiusVar"))

    @feature_radius_var.setter
    def feature_radius_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__495096341808d32f0fb484a3af4132ac691150a88afc5fdd842a561e9f836662)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featureRadiusVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__747f22c95a7ae03482e18c3ee06eef0e9c37c7506dab8cca1d5c2affaf902d1b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2178116a82c4f627074df0b2c7b3755ff8ff83d214a28d92cd8e74bc570f1dd0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4c54955303afbdfdd07fce91fe8a6d21d3b05d970468493b62df26857167c4cb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ad9ef3e4a985fc4a3b684e908e91d311686a6faa0488d257dd74423628bd73e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="maxFeatures")
    def max_features(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "maxFeatures"))

    @max_features.setter
    def max_features(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fe1e8b9acefa7ec05835409a9e1a692bc023bb6e61fdd55f8684401f915be3aa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "maxFeatures", value)

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesVar")
    def max_features_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "maxFeaturesVar"))

    @max_features_var.setter
    def max_features_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6160f2e4f176f4634172f363cb1af0bf586a2efb8766984639aea9189ce6b78e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "maxFeaturesVar", value)

    @builtins.property
    @jsii.member(jsii_name="minFeatureQuality")
    def min_feature_quality(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "minFeatureQuality"))

    @min_feature_quality.setter
    def min_feature_quality(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eeaf336aaf50206c769ab093d6de6e948c6786566dd22c89259ee2dd61ab07b5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "minFeatureQuality", value)

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityVar")
    def min_feature_quality_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "minFeatureQualityVar"))

    @min_feature_quality_var.setter
    def min_feature_quality_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f00370386091e3b1f296ca04423969277f6870750528cb02fbee284ffa63e12)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "minFeatureQualityVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c184084d9361f73184d79ca3ce03d32f480c58dea5f31f13694a59488ba2f49d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fcc182947119c70e201d53c735f2501381a726a270e7d22f6a26180c0e284acd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a7b5d96a6d29677896d7f280fbf7b95e20cc81ea2b0236f87a89ee37a3d0d09)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__56b161de8d09ad8d6e5c5a71c287467515c583972e5ac1c0550f55328196fe7c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__000afa6b896d8217997dddb5f6af49229f8af7765053d85eca83952b23d8c774)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b1e9e02c70e6c394adc591983b37fe693112f7c3e6e9c41e944dffe9785e5b18)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitFeatureCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitFeatureCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitFeatureCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0dd240bd5b850f59a0be055f930f9399bcb3d2834be0468b9e824c63f6f95791)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitFitAndFill",
    jsii_struct_bases=[],
    name_mapping={
        "fill_transformation": "fillTransformation",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitFitAndFill:
    def __init__(
        self,
        *,
        fill_transformation: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitFitAndFillFillTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fill_transformation: fill_transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_transformation DataAkamaiImagingPolicyImage#fill_transformation}
        :param height: The height value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The width value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(fill_transformation, dict):
            fill_transformation = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitFitAndFillFillTransformation(**fill_transformation)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2f3df2339a61c2e94a88b153dbc2fc25381bbdb1338ee33f4a8eea836649b9b4)
            check_type(argname="argument fill_transformation", value=fill_transformation, expected_type=type_hints["fill_transformation"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fill_transformation is not None:
            self._values["fill_transformation"] = fill_transformation
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def fill_transformation(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitFitAndFillFillTransformation"]:
        '''fill_transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_transformation DataAkamaiImagingPolicyImage#fill_transformation}
        '''
        result = self._values.get("fill_transformation")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitFitAndFillFillTransformation"], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitFitAndFill(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitFitAndFillFillTransformation",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitFitAndFillFillTransformation:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitFitAndFillFillTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitFitAndFillFillTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitFitAndFillFillTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4e58006366c8101fef9f626dbb7d8c55b93b3c4a2bf3b5a791aad0c76373a86b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitFitAndFillFillTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitFitAndFillFillTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitFitAndFillFillTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e6e3fa5c7e80068b899445f172f3c8774229fe3218463f073468d4b9a83b8e4b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitFitAndFillList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitFitAndFillList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2bf692d664f3276a7a29fd879577a54c35fe87e3dc5f5d923f0ea557b7d629c1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitFitAndFillOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aab2046b66c0369cefa3226ddebdbb73baf1f2eacfbda09450f6034be7f0aa57)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitFitAndFillOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f52e5c80bdfae7893f49c620dff1688eed5429c6b0226a73a838460b4f46cae5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ec71a4da903f53851a6be72f866d472c415289ad63267e96faf490fe5bca28c4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__469bb2856ad197fcbfaf9c06fa7a5d5b52a3cd4ccf3ef17e1b4ec90020fc16ba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitFitAndFill]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitFitAndFill]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitFitAndFill]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__68baf96ef54cb0c06ec99ca3e91c141b5487262e0c58a25a2b523bac98aaf25f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitFitAndFillOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitFitAndFillOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5e7bdeac4f4874dabb017c0c85ae4b343f62d471b024d429651e61a34e683678)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putFillTransformation")
    def put_fill_transformation(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitFitAndFillFillTransformation()

        return typing.cast(None, jsii.invoke(self, "putFillTransformation", [value]))

    @jsii.member(jsii_name="resetFillTransformation")
    def reset_fill_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFillTransformation", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="fillTransformation")
    def fill_transformation(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitFitAndFillFillTransformationOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitFitAndFillFillTransformationOutputReference, jsii.get(self, "fillTransformation"))

    @builtins.property
    @jsii.member(jsii_name="fillTransformationInput")
    def fill_transformation_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitFitAndFillFillTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitFitAndFillFillTransformation], jsii.get(self, "fillTransformationInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6efc353561795341cc70eb075960db5f32ca5dea8861f3f3df9c3f8c05680c18)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f63e208445e37e5912c7590278ce7107fa3c1251f70353be7a48358d9909b8ff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c7de3b7b268cf572704132198ac14988fe69748807f89305a990681492734842)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c1f60859d6e596eab1c41c7e9795ced656f9d389aee8d0ae8aaf62f6c0cf63d0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitFitAndFill]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitFitAndFill]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitFitAndFill]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fb83141e1e9201f071dfd0771e47abd7d8057d62a31deff82ebe2ea4af6125a6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitGoop",
    jsii_struct_bases=[],
    name_mapping={
        "chaos": "chaos",
        "chaos_var": "chaosVar",
        "density": "density",
        "density_var": "densityVar",
        "power": "power",
        "power_var": "powerVar",
        "seed": "seed",
        "seed_var": "seedVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitGoop:
    def __init__(
        self,
        *,
        chaos: typing.Optional[builtins.str] = None,
        chaos_var: typing.Optional[builtins.str] = None,
        density: typing.Optional[builtins.str] = None,
        density_var: typing.Optional[builtins.str] = None,
        power: typing.Optional[builtins.str] = None,
        power_var: typing.Optional[builtins.str] = None,
        seed: typing.Optional[builtins.str] = None,
        seed_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param chaos: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        :param chaos_var: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        :param density: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        :param density_var: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        :param power: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        :param power_var: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        :param seed: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        :param seed_var: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__42c0b8a20f16ed2dbe2d10b77f5ff94cf42ec8dc8091e9c4ca58239368cb9983)
            check_type(argname="argument chaos", value=chaos, expected_type=type_hints["chaos"])
            check_type(argname="argument chaos_var", value=chaos_var, expected_type=type_hints["chaos_var"])
            check_type(argname="argument density", value=density, expected_type=type_hints["density"])
            check_type(argname="argument density_var", value=density_var, expected_type=type_hints["density_var"])
            check_type(argname="argument power", value=power, expected_type=type_hints["power"])
            check_type(argname="argument power_var", value=power_var, expected_type=type_hints["power_var"])
            check_type(argname="argument seed", value=seed, expected_type=type_hints["seed"])
            check_type(argname="argument seed_var", value=seed_var, expected_type=type_hints["seed_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if chaos is not None:
            self._values["chaos"] = chaos
        if chaos_var is not None:
            self._values["chaos_var"] = chaos_var
        if density is not None:
            self._values["density"] = density
        if density_var is not None:
            self._values["density_var"] = density_var
        if power is not None:
            self._values["power"] = power
        if power_var is not None:
            self._values["power_var"] = power_var
        if seed is not None:
            self._values["seed"] = seed
        if seed_var is not None:
            self._values["seed_var"] = seed_var

    @builtins.property
    def chaos(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        '''
        result = self._values.get("chaos")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def chaos_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        '''
        result = self._values.get("chaos_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        '''
        result = self._values.get("density")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density_var(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        '''
        result = self._values.get("density_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        '''
        result = self._values.get("power")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power_var(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        '''
        result = self._values.get("power_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        '''
        result = self._values.get("seed")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed_var(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        result = self._values.get("seed_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitGoop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitGoopList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitGoopList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5613955b15075cbe79f439ac6e98e7a1f06fcd5215df38e366e06186e9971442)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitGoopOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0b3162c17ad8c83fc6d383dd0cc754afa5ef732a7fb2451097df71174f018a25)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitGoopOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fd8c2a7a99e1d21a02a072d4698b5e6b86126cd201d3cfdd86d4e929894f6200)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e0a753357371037b61c1aaf09b1957819c973b9884695789cf5bd705f90ff4b5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__26a8cea8ae1490acf3d40e058a0bd6cf23b2134a4ee682404cebe07319dfdb8d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitGoop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitGoop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7a32b43b5fa9b185a6e688083cda89461d3efcb6ccfd6c757c7e6c1ffe408f90)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitGoopOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitGoopOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__86e5f48838e850af5152bb2a8033df84ee45e4f2c63564ced07468416ab4f15c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetChaos")
    def reset_chaos(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaos", []))

    @jsii.member(jsii_name="resetChaosVar")
    def reset_chaos_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaosVar", []))

    @jsii.member(jsii_name="resetDensity")
    def reset_density(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensity", []))

    @jsii.member(jsii_name="resetDensityVar")
    def reset_density_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensityVar", []))

    @jsii.member(jsii_name="resetPower")
    def reset_power(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPower", []))

    @jsii.member(jsii_name="resetPowerVar")
    def reset_power_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPowerVar", []))

    @jsii.member(jsii_name="resetSeed")
    def reset_seed(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeed", []))

    @jsii.member(jsii_name="resetSeedVar")
    def reset_seed_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeedVar", []))

    @builtins.property
    @jsii.member(jsii_name="chaosInput")
    def chaos_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosInput"))

    @builtins.property
    @jsii.member(jsii_name="chaosVarInput")
    def chaos_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosVarInput"))

    @builtins.property
    @jsii.member(jsii_name="densityInput")
    def density_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityInput"))

    @builtins.property
    @jsii.member(jsii_name="densityVarInput")
    def density_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="powerInput")
    def power_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerInput"))

    @builtins.property
    @jsii.member(jsii_name="powerVarInput")
    def power_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerVarInput"))

    @builtins.property
    @jsii.member(jsii_name="seedInput")
    def seed_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedInput"))

    @builtins.property
    @jsii.member(jsii_name="seedVarInput")
    def seed_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedVarInput"))

    @builtins.property
    @jsii.member(jsii_name="chaos")
    def chaos(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaos"))

    @chaos.setter
    def chaos(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__000c5cdc02a754a7d6c89e5472d6480984de8624ebd32ec48bebf11da18229d0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaos", value)

    @builtins.property
    @jsii.member(jsii_name="chaosVar")
    def chaos_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaosVar"))

    @chaos_var.setter
    def chaos_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0b361d20ba4b07cfab7ca534d97ef9ee2af96c580a24ccf3e1c7f09f0b5786ee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaosVar", value)

    @builtins.property
    @jsii.member(jsii_name="density")
    def density(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "density"))

    @density.setter
    def density(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aa97f0e9fb40c8ae7fb918865a8c07f9f0205c5f7484cd60750c87acd9052e6d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "density", value)

    @builtins.property
    @jsii.member(jsii_name="densityVar")
    def density_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "densityVar"))

    @density_var.setter
    def density_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3da05075b09832c1dee55149ebe1f073ad24c86bbe35fd519be499ee745e5c9b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "densityVar", value)

    @builtins.property
    @jsii.member(jsii_name="power")
    def power(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "power"))

    @power.setter
    def power(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__453b488a2a0fd89da76f510dd2509f714925993b714b40b8ffc0f66d59fbaf59)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "power", value)

    @builtins.property
    @jsii.member(jsii_name="powerVar")
    def power_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "powerVar"))

    @power_var.setter
    def power_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__19cdb59c91cc2966a4bf06a495960ab6b07e66043a2fbdb0c5b95aee3418583f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "powerVar", value)

    @builtins.property
    @jsii.member(jsii_name="seed")
    def seed(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seed"))

    @seed.setter
    def seed(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c8f0e56608a60b7e9835f3f64a86b594f249e6ca5084f34efae02f289add6340)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seed", value)

    @builtins.property
    @jsii.member(jsii_name="seedVar")
    def seed_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seedVar"))

    @seed_var.setter
    def seed_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6c29300b85050e7de0790e51bf85c1394eeb8593d90fef6ce3434d53cfee43cb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seedVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitGoop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitGoop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitGoop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a562d3d7f50021a7381045a602536fdd6448a7fd9e8f8a6cb9bbad09ddfab7de)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitGrayscale",
    jsii_struct_bases=[],
    name_mapping={"type": "type", "type_var": "typeVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitGrayscale:
    def __init__(
        self,
        *,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param type: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__50a530dadd4c862d401939445c0d81ea9cfa617942e8412667cd0429b777013c)
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitGrayscale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitGrayscaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitGrayscaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a85fb24837fcc3fa06c7700d5de979b945317c95e4281e564b56e46b3077bfa)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitGrayscaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__018053d88c274d4385070b9b53163beabb96e0d4ccf2a1542c706d1c614cc2e8)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitGrayscaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__015e280965881d130f0faa840ff20de7ad5044261bb3dde27ca42b07be58bf5e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__612bd353200f22bf27a796524f13aac561ef4f5933ac3ce1f764305e9691af88)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__530f8bb2be6162ae8b506bf03f26c0a19c2005f8ca37cab3b165dccf36e1d4bc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitGrayscale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitGrayscale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__abb8d2f14ad249dfb811b41d46b9688c3fa1cd1740f55175d5c5afb0031c63ae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitGrayscaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitGrayscaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d9d38b311ff61f516904eb5c4c73324642d98aaa13ce73a8d1c19e6a9b484f7b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__444d1db9cf31dad95e4a28775b46bfe8e5d03ac400d36048a110d44d71f9abdd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eb1600cc23645fe9f505c834e67b4019abbfc27c6b0b8964a991a081cf1c1ead)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitGrayscale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitGrayscale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitGrayscale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b2797e57d99f90efc57e2963371221e46f50b17439efb3200a44ac72b35c50a5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitHsl",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "lightness": "lightness",
        "lightness_var": "lightnessVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitHsl:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness: typing.Optional[builtins.str] = None,
        lightness_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        :param lightness_var: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9304ce4e627c9237453a6c410a9217d08a037326c713d3f90ebbc01e98656e50)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness", value=lightness, expected_type=type_hints["lightness"])
            check_type(argname="argument lightness_var", value=lightness_var, expected_type=type_hints["lightness_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness is not None:
            self._values["lightness"] = lightness
        if lightness_var is not None:
            self._values["lightness_var"] = lightness_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        '''
        result = self._values.get("lightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        '''
        result = self._values.get("lightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitHsl(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitHslList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitHslList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a918973e11e7655ae343d6cdb6f95095bef8069e86aa9fa812aacae87dfb9b66)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitHslOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__add1754418730dece2c616a1e10179b208d6b35478a00ac9a08e7dab465ab1ac)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitHslOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ed4fcda57ebddce459e88bfb4d8f83d178814359ee21271a489e2deb48c70f17)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__55780526718ef657724fdb8b6c4ddd15dc1a9f6d7d1bd52617517446f4aad9bd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dce27127f3dbb5671c8492635fb4c4a9470f6653e606b006a198b167a14f14c2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitHsl]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitHsl]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b5d87e4d85880ea74fe787f12486a98a762e815cbf1a307d97e763c62be8e8f3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitHslOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitHslOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__53c612b9e99262eb3e5cf22e16f8b9842a897109c6437495ecc69b90dbc5b388)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightness")
    def reset_lightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightness", []))

    @jsii.member(jsii_name="resetLightnessVar")
    def reset_lightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessInput")
    def lightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessVarInput")
    def lightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0a075101a1f5792db25f3d1966ca23daf85e1ddf0cc53dae405b2123c02549f2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f48a092fa3e1908f49ce229e5151a221a0ae2d921b4b449e4fe07f9d75c9954d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightness")
    def lightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightness"))

    @lightness.setter
    def lightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e0e606777404ba9886ffcd8091302f3b0d14fcf08b1ed7a1a931557a7eba5c10)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightness", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessVar")
    def lightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessVar"))

    @lightness_var.setter
    def lightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5a9326830033668d49fbd0dea771ceee2b2120faaca7c672f1d97ce26b4d3d9a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea99c426a39cb835dc488316867740ae22c4b6cd2cba5bef0a312b2ae45b98c6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f3b265f38c270b7ec3299f6d9b68171aaa3e380850cc27ec8bb7480bf93505db)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitHsl]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitHsl]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitHsl]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7ba89ad5a705a2ecf3c86846ff2b25baa6e723812809225591cc0f8eca7530b5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitHsv",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitHsv:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        :param value: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ea8e899743214bc4ac8085d971cfc8d07d7ddec3e942eb168b92a3c4fd8bb4d)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitHsv(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitHsvList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitHsvList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ceeca928360e0f30f2aea21e59efc3fbb557fb41785f21140827732486b2ee9a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitHsvOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__66c1ebe10c716be96e80e5e09a77082015d663a84a6a93ef77db5a1bec99d711)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitHsvOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__015ad7af6647bea2967d4369993deb7256e25b41bce40fc0c36a4f735122c89b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ec4034ead7f723cecc12edb48b6ba94a0d678f46212464266ec34b1e08147b5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0777485b79ea3cbca942c907013ef07b343bff74813888570389ab4348fe20ac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitHsv]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitHsv]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a7de22f24cbb54fa464048e5270b80266dc6e120fcf4d32e43bbb6e7544d37a5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitHsvOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitHsvOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab0b14b5a1c2bd23d577bc939eea6f7e9ccbfd5a90de8be2ec11c8f9227f5451)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__21cdbb32d9382b0c75278f8302213b25695e0cac985d88df3fb83911acce39fd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ade2104b07223df3edf4566410793a6a08e2ea415d1ca9c46d960622ec6bd194)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e5a65203cd9d8536877d81157fb5c9f89de622ae449c7309b89b6413e9ea988f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d051d1c3abd9ba37fae07ea585e69c213474067e98b8e9c52ab833329297fecc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cadae1dc8ec71a59515fcfd16d5422efe908c62df15f658ce73c518d6c467082)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b48cbbb80d8a87338a336fe6ff139fbd52884eb322ceb22e82a9d792f45f5c2d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitHsv]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitHsv]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitHsv]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ca337f398ee11cd6bfe0ef2204d8d66e2476c4c8a6c8932305fb6c0ed2d18ca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfDimension",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "dimension": "dimension",
        "dimension_var": "dimensionVar",
        "equal": "equal",
        "greater_than": "greaterThan",
        "less_than": "lessThan",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfDimension:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        dimension: typing.Optional[builtins.str] = None,
        dimension_var: typing.Optional[builtins.str] = None,
        equal: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionEqual", typing.Dict[builtins.str, typing.Any]]] = None,
        greater_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionGreaterThan", typing.Dict[builtins.str, typing.Any]]] = None,
        less_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionLessThan", typing.Dict[builtins.str, typing.Any]]] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param dimension: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        :param dimension_var: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        :param equal: equal block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        :param greater_than: greater_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        :param less_than: less_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        :param value: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionDefault(**default)
        if isinstance(equal, dict):
            equal = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionEqual(**equal)
        if isinstance(greater_than, dict):
            greater_than = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionGreaterThan(**greater_than)
        if isinstance(less_than, dict):
            less_than = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionLessThan(**less_than)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__47d575021b467f1624bc61883c129ca0fabb83d8ee20285bda695d21da45e835)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument dimension", value=dimension, expected_type=type_hints["dimension"])
            check_type(argname="argument dimension_var", value=dimension_var, expected_type=type_hints["dimension_var"])
            check_type(argname="argument equal", value=equal, expected_type=type_hints["equal"])
            check_type(argname="argument greater_than", value=greater_than, expected_type=type_hints["greater_than"])
            check_type(argname="argument less_than", value=less_than, expected_type=type_hints["less_than"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if dimension is not None:
            self._values["dimension"] = dimension
        if dimension_var is not None:
            self._values["dimension_var"] = dimension_var
        if equal is not None:
            self._values["equal"] = equal
        if greater_than is not None:
            self._values["greater_than"] = greater_than
        if less_than is not None:
            self._values["less_than"] = less_than
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionDefault"], result)

    @builtins.property
    def dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        '''
        result = self._values.get("dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        '''
        result = self._values.get("dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def equal(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionEqual"]:
        '''equal block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        '''
        result = self._values.get("equal")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionEqual"], result)

    @builtins.property
    def greater_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionGreaterThan"]:
        '''greater_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        '''
        result = self._values.get("greater_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionGreaterThan"], result)

    @builtins.property
    def less_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionLessThan"]:
        '''less_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        '''
        result = self._values.get("less_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionLessThan"], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfDimension(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__08159ecdf5d7340e157e8e999fcbc32fc282e30932cb08e87286bf5bda10da97)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__99318811b98b2e91d676805a7a46a719db303043d9fca3acd7c42b4586f8fe40)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionEqual",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionEqual:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionEqual(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionEqualOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionEqualOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b7ffe881c0bcf4641f29d22706f57568531c0877e85abfadca5c18c9755d0ebe)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionEqual], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionEqual],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__18e07ed366460b799c069b9c7fdbffcdca87aa23fac4d5699d8fe9f8f15ce484)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionGreaterThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionGreaterThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionGreaterThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionGreaterThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionGreaterThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0b89dd4cd02558e11b6c64b7112c94952bdfd1e0ba5339e304dd452419966687)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionGreaterThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionGreaterThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7601937413a607e0451f03f54620f7f811e16898cf161f05a6da5a07c8bfc04c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionLessThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionLessThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionLessThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionLessThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionLessThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__188679332002f0378ab7feb7273930f72df85b1942dcf0405b1965febfbc375f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionLessThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionLessThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cfe8ab0e8b3f10254eb5d5fd9282e9615eb5b97c3effd9a5511d4e3dddbaf268)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0f22e251202265410ea736c7f35ffcc040ed074aecb4ef9bf7d69c04b6c447cc)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bf96d899b7fd575f3f22c7d7057241321d773a5b739de3c4051ef0e7651b46c0)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bcb8e2317bb50f1d86a18944d8afb492f2c0d5b94396c70732afd40395717023)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__964403706890bc514655f7bf2862b7bf258f23a045c6ec84cc10c9d797e7c407)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a1465ef634b8dbf1489a5c17b45373b718fde8eaced34d1c9114911caac59d53)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfDimension]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfDimension]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__86a606365af833c7a3bb61754e54c5fab38edcaaae631b1d36177bb4f8eeee00)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f5d8c4049208ff6be8568a0376cf8240e3e287c97a6e72940dbd5b0bb3e2fb43)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putEqual")
    def put_equal(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionEqual()

        return typing.cast(None, jsii.invoke(self, "putEqual", [value]))

    @jsii.member(jsii_name="putGreaterThan")
    def put_greater_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionGreaterThan()

        return typing.cast(None, jsii.invoke(self, "putGreaterThan", [value]))

    @jsii.member(jsii_name="putLessThan")
    def put_less_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionLessThan()

        return typing.cast(None, jsii.invoke(self, "putLessThan", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetDimension")
    def reset_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimension", []))

    @jsii.member(jsii_name="resetDimensionVar")
    def reset_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimensionVar", []))

    @jsii.member(jsii_name="resetEqual")
    def reset_equal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEqual", []))

    @jsii.member(jsii_name="resetGreaterThan")
    def reset_greater_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGreaterThan", []))

    @jsii.member(jsii_name="resetLessThan")
    def reset_less_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLessThan", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="equal")
    def equal(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionEqualOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionEqualOutputReference, jsii.get(self, "equal"))

    @builtins.property
    @jsii.member(jsii_name="greaterThan")
    def greater_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionGreaterThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionGreaterThanOutputReference, jsii.get(self, "greaterThan"))

    @builtins.property
    @jsii.member(jsii_name="lessThan")
    def less_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionLessThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionLessThanOutputReference, jsii.get(self, "lessThan"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionInput")
    def dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionVarInput")
    def dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="equalInput")
    def equal_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionEqual], jsii.get(self, "equalInput"))

    @builtins.property
    @jsii.member(jsii_name="greaterThanInput")
    def greater_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionGreaterThan], jsii.get(self, "greaterThanInput"))

    @builtins.property
    @jsii.member(jsii_name="lessThanInput")
    def less_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionLessThan], jsii.get(self, "lessThanInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="dimension")
    def dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimension"))

    @dimension.setter
    def dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f90f76c73c218612f7eacbe31379740ef887d98c695bde7aa28897cc578b2552)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimension", value)

    @builtins.property
    @jsii.member(jsii_name="dimensionVar")
    def dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimensionVar"))

    @dimension_var.setter
    def dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5b0065148865e212d7c9595d9117e601f9485456c11fcaf6f2ed7b13202dfa90)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f8b61d6e92b404f9a630a13d1bdabf5a45846641e53ecdd79cddac513d57976e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__772dfe112681b83bf18305f82c05045f0c37a734c16ac73a40b3d30058505668)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfDimension]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfDimension]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfDimension]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0e5c8731c3d4294804c7aa95f985982dfe9bbda3aca0a492ec857790e77e1b7f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientation",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "landscape": "landscape",
        "portrait": "portrait",
        "square": "square",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientation:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        landscape: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationLandscape", typing.Dict[builtins.str, typing.Any]]] = None,
        portrait: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationPortrait", typing.Dict[builtins.str, typing.Any]]] = None,
        square: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationSquare", typing.Dict[builtins.str, typing.Any]]] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param landscape: landscape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        :param portrait: portrait block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        :param square: square block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationDefault(**default)
        if isinstance(landscape, dict):
            landscape = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationLandscape(**landscape)
        if isinstance(portrait, dict):
            portrait = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationPortrait(**portrait)
        if isinstance(square, dict):
            square = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationSquare(**square)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4630a0d51c421653b576046baaf50b2d3d187be9f6918673e289f6e76089cd08)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument landscape", value=landscape, expected_type=type_hints["landscape"])
            check_type(argname="argument portrait", value=portrait, expected_type=type_hints["portrait"])
            check_type(argname="argument square", value=square, expected_type=type_hints["square"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if landscape is not None:
            self._values["landscape"] = landscape
        if portrait is not None:
            self._values["portrait"] = portrait
        if square is not None:
            self._values["square"] = square

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationDefault"], result)

    @builtins.property
    def landscape(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationLandscape"]:
        '''landscape block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        '''
        result = self._values.get("landscape")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationLandscape"], result)

    @builtins.property
    def portrait(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationPortrait"]:
        '''portrait block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        '''
        result = self._values.get("portrait")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationPortrait"], result)

    @builtins.property
    def square(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationSquare"]:
        '''square block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        result = self._values.get("square")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationSquare"], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f6cfe7bddf8aa2f92fbf80a85911a48b7b534facc9ca9b61e226fbb09eb2d5c6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ddafa2167bf0ed978ebbd0a6880ac9a8cda7ac7e6e1524191b9b17a87c53fa32)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationLandscape",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationLandscape:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationLandscape(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationLandscapeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationLandscapeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2cef981e2bd55a19d778f8deac1ef5d953127b3181e53dd607af7b025f011233)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationLandscape], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationLandscape],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a7994cdbcca323c14be47ad69caa11a916edd9c0813b2db3b5723b1cd04939f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__984bc38f5bcd8a8f71ff29e78072fa579cd73ce555175a2a573325c41ed0f62e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9470a45c57d258b1988ca084e65b05478ee39101bfcb3eb496df2d257616bebd)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__449dc0184336598ed31394f5ade3d378400a54e35cfe986be26ac237d5d23163)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e206e80ba45a509fcbd022b6fedbc709d7f792cdbae9be82eeaefdb5ed38034e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__221dc181ea03ca2952e15790109528dfcb0e99a6e8b46fc766b7db490278a404)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientation]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientation]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__95ad79b5748c5d9657bce94314f3f527e905bdd10be7f4dc5573b2f8d81c2f56)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1a538fa79e311f43c3df1ee4718ed4ab15ae61d098228284e14cdf85503d7aca)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putLandscape")
    def put_landscape(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationLandscape()

        return typing.cast(None, jsii.invoke(self, "putLandscape", [value]))

    @jsii.member(jsii_name="putPortrait")
    def put_portrait(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationPortrait()

        return typing.cast(None, jsii.invoke(self, "putPortrait", [value]))

    @jsii.member(jsii_name="putSquare")
    def put_square(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationSquare()

        return typing.cast(None, jsii.invoke(self, "putSquare", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetLandscape")
    def reset_landscape(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLandscape", []))

    @jsii.member(jsii_name="resetPortrait")
    def reset_portrait(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPortrait", []))

    @jsii.member(jsii_name="resetSquare")
    def reset_square(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSquare", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="landscape")
    def landscape(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationLandscapeOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationLandscapeOutputReference, jsii.get(self, "landscape"))

    @builtins.property
    @jsii.member(jsii_name="portrait")
    def portrait(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationPortraitOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationPortraitOutputReference", jsii.get(self, "portrait"))

    @builtins.property
    @jsii.member(jsii_name="square")
    def square(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationSquareOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationSquareOutputReference", jsii.get(self, "square"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="landscapeInput")
    def landscape_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationLandscape], jsii.get(self, "landscapeInput"))

    @builtins.property
    @jsii.member(jsii_name="portraitInput")
    def portrait_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationPortrait"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationPortrait"], jsii.get(self, "portraitInput"))

    @builtins.property
    @jsii.member(jsii_name="squareInput")
    def square_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationSquare"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationSquare"], jsii.get(self, "squareInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientation]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientation]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientation]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__31bef6b3f4438c5fc520a00b2e2ff7fb6359545fe8684328f3ad17ea905d84f8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationPortrait",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationPortrait:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationPortrait(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationPortraitOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationPortraitOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3033c4bcfc84b30d890e11ca15be26f9c1123e29554f8e3e8e2e4f85f6920406)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationPortrait]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationPortrait], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationPortrait],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ae38456ddc87dc16b4f75c37ae3aa93cfc66e0ca3cc99f0564453e455df744f2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationSquare",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationSquare:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationSquare(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationSquareOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationSquareOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8019989af1d6015151a49c38262bb4a6be578e688da90d2642434978e59326ba)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationSquare]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationSquare], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationSquare],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f985aac7a70ee60d8525783190e6f91916a11dfbf1387d3b665509f55933e8c8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitImQuery",
    jsii_struct_bases=[],
    name_mapping={
        "allowed_transformations": "allowedTransformations",
        "query_var": "queryVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitImQuery:
    def __init__(
        self,
        *,
        allowed_transformations: typing.Sequence[builtins.str],
        query_var: builtins.str,
    ) -> None:
        '''
        :param allowed_transformations: Specifies the transformations that can be applied using the query string parameter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allowed_transformations DataAkamaiImagingPolicyImage#allowed_transformations}
        :param query_var: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#query_var DataAkamaiImagingPolicyImage#query_var}.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a4cacc3dddfc398f089ad82a749068d34a385729d904b4643537c98f6dcef06d)
            check_type(argname="argument allowed_transformations", value=allowed_transformations, expected_type=type_hints["allowed_transformations"])
            check_type(argname="argument query_var", value=query_var, expected_type=type_hints["query_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "allowed_transformations": allowed_transformations,
            "query_var": query_var,
        }

    @builtins.property
    def allowed_transformations(self) -> typing.List[builtins.str]:
        '''Specifies the transformations that can be applied using the query string parameter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allowed_transformations DataAkamaiImagingPolicyImage#allowed_transformations}
        '''
        result = self._values.get("allowed_transformations")
        assert result is not None, "Required property 'allowed_transformations' is missing"
        return typing.cast(typing.List[builtins.str], result)

    @builtins.property
    def query_var(self) -> builtins.str:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#query_var DataAkamaiImagingPolicyImage#query_var}.'''
        result = self._values.get("query_var")
        assert result is not None, "Required property 'query_var' is missing"
        return typing.cast(builtins.str, result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitImQuery(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitImQueryList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitImQueryList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__037e6c5f0ca60b2a7601ff6b078dbf16fa79e9f6fda59456c657ffe2a47d098a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitImQueryOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__247c8fd60868f0ff72bc51996db715d1c9602fc23625113c413548d9c0a473a8)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitImQueryOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ecc160875e6d7b6d22634e91b3772b2fee98b93fa23d857c1fe849b247710be6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__502389cdc2b1d635259034d9ee57b3fb1e7031ef84bb4f6c825c3d0313a88ab6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__da67c8691178bd303a55f6af8691d421fea8c7d6323363153d3aef84b86598cc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitImQuery]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitImQuery]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitImQuery]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d7b8b3533806490c286b0ad02b4d6422750eed364bc6d24cb5515e963303a976)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitImQueryOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitImQueryOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fc1afd9c2e29069bd8558452c4e2d5f7f7d411d6333cd6c1484586de7f16643a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @builtins.property
    @jsii.member(jsii_name="allowedTransformationsInput")
    def allowed_transformations_input(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "allowedTransformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="queryVarInput")
    def query_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "queryVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowedTransformations")
    def allowed_transformations(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "allowedTransformations"))

    @allowed_transformations.setter
    def allowed_transformations(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c33a25bf0074a8c621489a731684f13e40246fffa0a8d0325d1e9514045cab8d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowedTransformations", value)

    @builtins.property
    @jsii.member(jsii_name="queryVar")
    def query_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "queryVar"))

    @query_var.setter
    def query_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__975fe63d18946df5a16a9fb8d14bc8454290354db60610379303d75c8e07f4c7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "queryVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitImQuery]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitImQuery]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitImQuery]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__62ddae9bf102c0520fbd741d14e30e77024a9153748b0244735d7b274e688762)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitMaxColors",
    jsii_struct_bases=[],
    name_mapping={"colors": "colors", "colors_var": "colorsVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitMaxColors:
    def __init__(
        self,
        *,
        colors: typing.Optional[builtins.str] = None,
        colors_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param colors: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        :param colors_var: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__30ab17e4577b8a1e86f5464bbf5eef7fbe760c73b30f4418721094eaf6dcdbe2)
            check_type(argname="argument colors", value=colors, expected_type=type_hints["colors"])
            check_type(argname="argument colors_var", value=colors_var, expected_type=type_hints["colors_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if colors is not None:
            self._values["colors"] = colors
        if colors_var is not None:
            self._values["colors_var"] = colors_var

    @builtins.property
    def colors(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        '''
        result = self._values.get("colors")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def colors_var(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        result = self._values.get("colors_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitMaxColors(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitMaxColorsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitMaxColorsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9c2b14865a7a967abe5c8cda7e01ed4efe8c43513de8ebe783cca8377a9f4211)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitMaxColorsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7ae5d3fa4eb6e92a9de3e83509de8480f06a91111278600f747bfeaaf1609033)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitMaxColorsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f27996accb48fd7c4a752e421c5435cae176a3c364c0aef51b6672dba52f2dd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__70f6f11f7c55399fe68b71489f1c784d894bc1b9aef98c4812bf46f7b137357b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fdb77aef4c08913581a19fd9a8b14ef06a856d289a4d0b24be6da7533ba7c79e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitMaxColors]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitMaxColors]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__057cd3190e37a78cecde5113c8223898596b087c5affb2143d20412ddc932ae9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitMaxColorsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitMaxColorsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8d3e4d846771b009ba8ff25f16fa0dd53610396c07a3e3f0044d9ce620d67f41)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColors")
    def reset_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColors", []))

    @jsii.member(jsii_name="resetColorsVar")
    def reset_colors_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorsVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorsInput")
    def colors_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsInput"))

    @builtins.property
    @jsii.member(jsii_name="colorsVarInput")
    def colors_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsVarInput"))

    @builtins.property
    @jsii.member(jsii_name="colors")
    def colors(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colors"))

    @colors.setter
    def colors(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c417d1691c391c8d73a89b456fccf69ad5a12595ae6d69559ce3ba60bbb4111f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colors", value)

    @builtins.property
    @jsii.member(jsii_name="colorsVar")
    def colors_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorsVar"))

    @colors_var.setter
    def colors_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9b0f63b8b053344e56092655562d06018be8949651816cb458f438d945f8729a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorsVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitMaxColors]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitMaxColors]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitMaxColors]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3bebce72547fd6c57249384fe3358adfe499e6c46899b070397951b111fa5335)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitMirror",
    jsii_struct_bases=[],
    name_mapping={
        "horizontal": "horizontal",
        "horizontal_var": "horizontalVar",
        "vertical": "vertical",
        "vertical_var": "verticalVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitMirror:
    def __init__(
        self,
        *,
        horizontal: typing.Optional[builtins.str] = None,
        horizontal_var: typing.Optional[builtins.str] = None,
        vertical: typing.Optional[builtins.str] = None,
        vertical_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param horizontal: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        :param horizontal_var: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        :param vertical: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        :param vertical_var: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f8c8ef072103c2c15a472769dbbcfa20cd4692555a33a3f359712d53eb200704)
            check_type(argname="argument horizontal", value=horizontal, expected_type=type_hints["horizontal"])
            check_type(argname="argument horizontal_var", value=horizontal_var, expected_type=type_hints["horizontal_var"])
            check_type(argname="argument vertical", value=vertical, expected_type=type_hints["vertical"])
            check_type(argname="argument vertical_var", value=vertical_var, expected_type=type_hints["vertical_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if horizontal is not None:
            self._values["horizontal"] = horizontal
        if horizontal_var is not None:
            self._values["horizontal_var"] = horizontal_var
        if vertical is not None:
            self._values["vertical"] = vertical
        if vertical_var is not None:
            self._values["vertical_var"] = vertical_var

    @builtins.property
    def horizontal(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        '''
        result = self._values.get("horizontal")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def horizontal_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        '''
        result = self._values.get("horizontal_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        '''
        result = self._values.get("vertical")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        result = self._values.get("vertical_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitMirror(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitMirrorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitMirrorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8e59d75f5bd291ad5b9000a110bfa1c21a65ac7078303acb6e548857ae4bb641)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitMirrorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aad818e3531f35d410bd7bf13a997a25d31f52f3f94a1316b95e530668b4eaf1)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitMirrorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fcab7e98d02a8846e8ef6cc921fb04ec3a951ff26bc341251ecea74181aff506)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb50c94bc72f329ac2db0eaba4defc53acd7b3b44bdfdb7173681a967ae7670c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__36200845cdf27efdbc9fb0b8ae4529d810ecc1741e077f3b8e166f25594c0501)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitMirror]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitMirror]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f220c92cac9016fa073ca1bb91616c596be77ed29d8964b11036befc8bab05c9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitMirrorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitMirrorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e7807dbe0ee7e360f36cba72bd2f4904f2b46aa8a60096b97c81359b65f5bc8f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHorizontal")
    def reset_horizontal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontal", []))

    @jsii.member(jsii_name="resetHorizontalVar")
    def reset_horizontal_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontalVar", []))

    @jsii.member(jsii_name="resetVertical")
    def reset_vertical(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVertical", []))

    @jsii.member(jsii_name="resetVerticalVar")
    def reset_vertical_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVerticalVar", []))

    @builtins.property
    @jsii.member(jsii_name="horizontalInput")
    def horizontal_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontalVarInput")
    def horizontal_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalInput")
    def vertical_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalVarInput")
    def vertical_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontal")
    def horizontal(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontal"))

    @horizontal.setter
    def horizontal(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f5ff425a6e9273867b2874e18f1ad31d91f0e798abd266c5df9b5f0070b5621a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontal", value)

    @builtins.property
    @jsii.member(jsii_name="horizontalVar")
    def horizontal_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontalVar"))

    @horizontal_var.setter
    def horizontal_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__baac7d898e9756ac01e51072f63e2336c9d7653b8d1e6857487ad6bf7069d972)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontalVar", value)

    @builtins.property
    @jsii.member(jsii_name="vertical")
    def vertical(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "vertical"))

    @vertical.setter
    def vertical(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8fe8363d90da3a439b0974f3bfb1ee9501ff9a976fe3754b8806402b998f9666)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "vertical", value)

    @builtins.property
    @jsii.member(jsii_name="verticalVar")
    def vertical_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "verticalVar"))

    @vertical_var.setter
    def vertical_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4d031d180d0e17fa1f303fa226179d3c8b963cdd8e7edc5e9553647a07d76cc9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "verticalVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitMirror]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitMirror]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitMirror]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__23c09cab824128698a29517e11f70a6ba768aeda1bdfe32481de901a29cd2595)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitMonoHue",
    jsii_struct_bases=[],
    name_mapping={"hue": "hue", "hue_var": "hueVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitMonoHue:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1ed0df59af70639fb6133b6611dd167c8d44c86172b070a73095d115e7bc46a5)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitMonoHue(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitMonoHueList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitMonoHueList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0559925b0743049aee287b4e9186dffdedd515339764fef77a1ee37ee5f03362)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitMonoHueOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__68081ff57dd5e0e93c5033a244f037c41fdee5854e1a4a00bc3a080690354ee0)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitMonoHueOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3b0c787921b10688b5b33237b831550c75dc26963dd93f74a0cd7499db814cab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6c7debd22e171b257e5768e967ecc845a006ca2102312ba4fa107972d5a66503)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c7b6869331dfcdf052898ee08fb9ce2afe0092aec55ce5ac14d192246406a76f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitMonoHue]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitMonoHue]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6d938de3555cc5ecd7e77935204ac5205993a5fc950c9ed5e2f52b0b130c96d4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitMonoHueOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitMonoHueOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8c54f1914ba92cedb0023e7707d8054ba429704493b71ea77e8661b0b6b13754)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5178c03d1e65444651937fdde76afd0ba98b91bb366df728aa2a1d0b1408aba9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e2efae8bf51127dc79223ff100981fbc178e92a0745e7de05fa3dc19c48fcb47)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitMonoHue]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitMonoHue]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitMonoHue]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__51d5cae49cd220b299aab8db41b1b9ca267331f303c53d1eba7ec40e376bcbe0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitOpacity",
    jsii_struct_bases=[],
    name_mapping={"opacity": "opacity", "opacity_var": "opacityVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitOpacity:
    def __init__(
        self,
        *,
        opacity: typing.Optional[builtins.str] = None,
        opacity_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param opacity: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param opacity_var: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1928302c09434accf5c0cc38599bf74b0a7c07d89f6d0b669b054e243a4c102b)
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument opacity_var", value=opacity_var, expected_type=type_hints["opacity_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if opacity is not None:
            self._values["opacity"] = opacity
        if opacity_var is not None:
            self._values["opacity_var"] = opacity_var

    @builtins.property
    def opacity(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def opacity_var(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        result = self._values.get("opacity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitOpacity(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitOpacityList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitOpacityList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f3d98ce7b8f82652e417785eff9c82790b1af07c22c3d45c70a367f6d418a0e1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitOpacityOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aeb01572762561b7cf4f95a5282c599c173fdcf9fb00058486a443ffae391c05)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitOpacityOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e773308fe336558547da082b185b1a7b0f9624406083c433c8e0df88a827df44)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__041743b8782519b5d1d88fee738c67051175dacd8af77e58523610d8eb32fedd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d364204b445bd9f03403a52c29aa119d290edc7205587640cd705b68cd06f0fd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitOpacity]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitOpacity]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__31f8b4d4a873feebe5b786dd9b1e32e9eb2c4c763a2917040d1a9d3765df9acb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitOpacityOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitOpacityOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f7e8cdd09396d8cfbbd477e9c02d3ba10e89d5819374f2e118c4685fea1f2831)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetOpacityVar")
    def reset_opacity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacityVar", []))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityVarInput")
    def opacity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacity"))

    @opacity.setter
    def opacity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__324fba30c5e75c99cd70da73acc1cc4d775f15ba3b8b15a4327c96bfa6bc2140)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacity", value)

    @builtins.property
    @jsii.member(jsii_name="opacityVar")
    def opacity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacityVar"))

    @opacity_var.setter
    def opacity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__39e542313aa504146a75f8dd3c3ea6c5110660fa6c4fae601b6e239d3b692d50)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacityVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitOpacity]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitOpacity]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitOpacity]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fd9dda903174e261d3226c54a209141d34e331a336c04772bf7034d70fe41d28)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a8e9e4a71df9b5eade955e3f59e0298e8f97ff66eb2c8eda10ffdf1662cb2daa)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putAppend")
    def put_append(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitAppend, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b9e97f789929cc80c648de7128e3438bca0c20ef774f9f690e050ba13efd52b1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putAppend", [value]))

    @jsii.member(jsii_name="putAspectCrop")
    def put_aspect_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitAspectCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8eb9207f5f21c628974ed96865b8cbf5abff94d2f16db1e9fdd6b950b877654b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putAspectCrop", [value]))

    @jsii.member(jsii_name="putBackgroundColor")
    def put_background_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a09422d160c31c364d61dd0a40f93ea928736b3a9508e7d039fe62222d29a2df)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBackgroundColor", [value]))

    @jsii.member(jsii_name="putBlur")
    def put_blur(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitBlur, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d9b0f3774f743c460f51647621039a723660108115d58368750e823de45c8b3c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBlur", [value]))

    @jsii.member(jsii_name="putChromaKey")
    def put_chroma_key(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitChromaKey, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__78c1850a039437eb0f6844446a12cfdf7611ce4e2dd7f1498fb7c4f95ca278ee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putChromaKey", [value]))

    @jsii.member(jsii_name="putComposite")
    def put_composite(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitComposite, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__735f8764495b4584775493b8f627cb0b441ab4d8880e870669d483f3a4e1bf66)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putComposite", [value]))

    @jsii.member(jsii_name="putCompound")
    def put_compound(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitCompound, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__258fa8463758088f0c832f37e795a08416e92285bc5441fd1259c3a48cafd093)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCompound", [value]))

    @jsii.member(jsii_name="putContrast")
    def put_contrast(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitContrast, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ea720c99d67df5074fada4b363f9bcae8a4d4fdc340d4b6e84e4ea3f3269c4e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putContrast", [value]))

    @jsii.member(jsii_name="putCrop")
    def put_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5c4935752bc9094f56a22c0743707766b4b4ea7147c1f3ac2c07e92a72f9ce92)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCrop", [value]))

    @jsii.member(jsii_name="putFaceCrop")
    def put_face_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitFaceCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__61634b83e7789e4c29b1453985a839b297bf3d60f0eab20841155f35cb2eec83)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFaceCrop", [value]))

    @jsii.member(jsii_name="putFeatureCrop")
    def put_feature_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitFeatureCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__13079432a10bcdba95d8972bba09b6280761c57332a0df9a0614e61796ad326c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFeatureCrop", [value]))

    @jsii.member(jsii_name="putFitAndFill")
    def put_fit_and_fill(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitFitAndFill, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__397b64f9b4454bed57c540a5db6d8801feaba345b9bab80ea5cde97faf7ca5b2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFitAndFill", [value]))

    @jsii.member(jsii_name="putGoop")
    def put_goop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitGoop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a6d2c731a3a1ed031e56f179c34471981e409a5d795fc428ec904a47fe9e501d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGoop", [value]))

    @jsii.member(jsii_name="putGrayscale")
    def put_grayscale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitGrayscale, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__639ced1b08e2f0522932db44e5064bc38ad24d472df391dbd9123a8f06a4ab0d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGrayscale", [value]))

    @jsii.member(jsii_name="putHsl")
    def put_hsl(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitHsl, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__29d43d4f1f3be9077b7b9daae01ac241e89b75a867854b5b37dbfde7e4dc27d3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsl", [value]))

    @jsii.member(jsii_name="putHsv")
    def put_hsv(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitHsv, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__879df21fde4e8668294aeb62cd23cfcf864fec992eeb62829fa2899b3156f597)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsv", [value]))

    @jsii.member(jsii_name="putIfDimension")
    def put_if_dimension(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfDimension, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5e6a2cca8f7c737ddcbf92ab35059056571d2b87af6973e752fee9fa4812ea3a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfDimension", [value]))

    @jsii.member(jsii_name="putIfOrientation")
    def put_if_orientation(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e9557616193d4551c183cf3c8021de2e02fdff897536fbbfe2d2d4abddce63fe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfOrientation", [value]))

    @jsii.member(jsii_name="putImQuery")
    def put_im_query(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitImQuery, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__31ba4eb27f17ed5c6d0fd9aa1229b2a0efae9316b16839f1a19e623076962f4b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putImQuery", [value]))

    @jsii.member(jsii_name="putMaxColors")
    def put_max_colors(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitMaxColors, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9b242f0ddb1bb9768cce9f849dba1ba9ed2b5474c051e7c8afcaa300720ca02f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMaxColors", [value]))

    @jsii.member(jsii_name="putMirror")
    def put_mirror(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitMirror, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__715ba0db35711fb1690acc07e141b1080c5870640368beaae3317f12866fb8a8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMirror", [value]))

    @jsii.member(jsii_name="putMonoHue")
    def put_mono_hue(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitMonoHue, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d80adc010a3bedd9ca6dfc0a0f0b17ffd1286d804bf31fc1ff9114a30d8a88fc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMonoHue", [value]))

    @jsii.member(jsii_name="putOpacity")
    def put_opacity(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitOpacity, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__738ca1e94076b3c139d40a363834f296e2d0355a8b99281f08be684f64cc46ec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putOpacity", [value]))

    @jsii.member(jsii_name="putRegionOfInterestCrop")
    def put_region_of_interest_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitRegionOfInterestCrop", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__978c80a7363c48c87e0a9467cb9d6e023d417b8940df049fe38632a95f0060ff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRegionOfInterestCrop", [value]))

    @jsii.member(jsii_name="putRelativeCrop")
    def put_relative_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitRelativeCrop", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2fcdf85778a9780679b60665c85139afb622be62ecf7c15eb8f200d09f253bba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRelativeCrop", [value]))

    @jsii.member(jsii_name="putRemoveColor")
    def put_remove_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitRemoveColor", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__059f03d8e9196e74457c0450d27537eda625caf56976d0c2a2184d03d7d7cdf7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRemoveColor", [value]))

    @jsii.member(jsii_name="putResize")
    def put_resize(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitResize", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__529b8265960b03491a9bf25e79d30f96fcee148ba1058fc666d3764ad4820e8a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putResize", [value]))

    @jsii.member(jsii_name="putRotate")
    def put_rotate(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitRotate", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c99147351cff1a96334c46b963d5794de5a3b65efaeaaf9779cb1eff00cdc012)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRotate", [value]))

    @jsii.member(jsii_name="putScale")
    def put_scale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitScale", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__91020473aa1d6d9a98dcdb656b78215b14808af752ca72bdd315a5b4495b399d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putScale", [value]))

    @jsii.member(jsii_name="putShear")
    def put_shear(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitShear", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__73e8fe3b13b4805d47af42a43e085c2cdabc5bf7b7f41ed3d669b21f634c51b2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putShear", [value]))

    @jsii.member(jsii_name="putTrim")
    def put_trim(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitTrim", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__826c85716aebbb7ae92925dfafd13831fb52b47939a322c32be2a015f79d48a1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTrim", [value]))

    @jsii.member(jsii_name="putUnsharpMask")
    def put_unsharp_mask(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitUnsharpMask", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__381dd0291cc86969ba3ee4e0e5e71782a569e0b783e83a8d6612dca5917c12e5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putUnsharpMask", [value]))

    @jsii.member(jsii_name="resetAppend")
    def reset_append(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAppend", []))

    @jsii.member(jsii_name="resetAspectCrop")
    def reset_aspect_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspectCrop", []))

    @jsii.member(jsii_name="resetBackgroundColor")
    def reset_background_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBackgroundColor", []))

    @jsii.member(jsii_name="resetBlur")
    def reset_blur(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBlur", []))

    @jsii.member(jsii_name="resetChromaKey")
    def reset_chroma_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChromaKey", []))

    @jsii.member(jsii_name="resetComposite")
    def reset_composite(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetComposite", []))

    @jsii.member(jsii_name="resetCompound")
    def reset_compound(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCompound", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetCrop")
    def reset_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCrop", []))

    @jsii.member(jsii_name="resetFaceCrop")
    def reset_face_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFaceCrop", []))

    @jsii.member(jsii_name="resetFeatureCrop")
    def reset_feature_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureCrop", []))

    @jsii.member(jsii_name="resetFitAndFill")
    def reset_fit_and_fill(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFitAndFill", []))

    @jsii.member(jsii_name="resetGoop")
    def reset_goop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGoop", []))

    @jsii.member(jsii_name="resetGrayscale")
    def reset_grayscale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGrayscale", []))

    @jsii.member(jsii_name="resetHsl")
    def reset_hsl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsl", []))

    @jsii.member(jsii_name="resetHsv")
    def reset_hsv(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsv", []))

    @jsii.member(jsii_name="resetIfDimension")
    def reset_if_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfDimension", []))

    @jsii.member(jsii_name="resetIfOrientation")
    def reset_if_orientation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfOrientation", []))

    @jsii.member(jsii_name="resetImQuery")
    def reset_im_query(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetImQuery", []))

    @jsii.member(jsii_name="resetMaxColors")
    def reset_max_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxColors", []))

    @jsii.member(jsii_name="resetMirror")
    def reset_mirror(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMirror", []))

    @jsii.member(jsii_name="resetMonoHue")
    def reset_mono_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonoHue", []))

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetRegionOfInterestCrop")
    def reset_region_of_interest_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRegionOfInterestCrop", []))

    @jsii.member(jsii_name="resetRelativeCrop")
    def reset_relative_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRelativeCrop", []))

    @jsii.member(jsii_name="resetRemoveColor")
    def reset_remove_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRemoveColor", []))

    @jsii.member(jsii_name="resetResize")
    def reset_resize(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetResize", []))

    @jsii.member(jsii_name="resetRotate")
    def reset_rotate(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRotate", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetShear")
    def reset_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetShear", []))

    @jsii.member(jsii_name="resetTrim")
    def reset_trim(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTrim", []))

    @jsii.member(jsii_name="resetUnsharpMask")
    def reset_unsharp_mask(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUnsharpMask", []))

    @builtins.property
    @jsii.member(jsii_name="append")
    def append(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitAppendList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitAppendList, jsii.get(self, "append"))

    @builtins.property
    @jsii.member(jsii_name="aspectCrop")
    def aspect_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitAspectCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitAspectCropList, jsii.get(self, "aspectCrop"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColor")
    def background_color(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitBackgroundColorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitBackgroundColorList, jsii.get(self, "backgroundColor"))

    @builtins.property
    @jsii.member(jsii_name="blur")
    def blur(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitBlurList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitBlurList, jsii.get(self, "blur"))

    @builtins.property
    @jsii.member(jsii_name="chromaKey")
    def chroma_key(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitChromaKeyList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitChromaKeyList, jsii.get(self, "chromaKey"))

    @builtins.property
    @jsii.member(jsii_name="composite")
    def composite(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitCompositeList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitCompositeList, jsii.get(self, "composite"))

    @builtins.property
    @jsii.member(jsii_name="compound")
    def compound(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitCompoundList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitCompoundList, jsii.get(self, "compound"))

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitContrastList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitContrastList, jsii.get(self, "contrast"))

    @builtins.property
    @jsii.member(jsii_name="crop")
    def crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitCropList, jsii.get(self, "crop"))

    @builtins.property
    @jsii.member(jsii_name="faceCrop")
    def face_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitFaceCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitFaceCropList, jsii.get(self, "faceCrop"))

    @builtins.property
    @jsii.member(jsii_name="featureCrop")
    def feature_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitFeatureCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitFeatureCropList, jsii.get(self, "featureCrop"))

    @builtins.property
    @jsii.member(jsii_name="fitAndFill")
    def fit_and_fill(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitFitAndFillList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitFitAndFillList, jsii.get(self, "fitAndFill"))

    @builtins.property
    @jsii.member(jsii_name="goop")
    def goop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitGoopList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitGoopList, jsii.get(self, "goop"))

    @builtins.property
    @jsii.member(jsii_name="grayscale")
    def grayscale(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitGrayscaleList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitGrayscaleList, jsii.get(self, "grayscale"))

    @builtins.property
    @jsii.member(jsii_name="hsl")
    def hsl(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitHslList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitHslList, jsii.get(self, "hsl"))

    @builtins.property
    @jsii.member(jsii_name="hsv")
    def hsv(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitHsvList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitHsvList, jsii.get(self, "hsv"))

    @builtins.property
    @jsii.member(jsii_name="ifDimension")
    def if_dimension(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionList, jsii.get(self, "ifDimension"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientation")
    def if_orientation(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationList, jsii.get(self, "ifOrientation"))

    @builtins.property
    @jsii.member(jsii_name="imQuery")
    def im_query(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitImQueryList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitImQueryList, jsii.get(self, "imQuery"))

    @builtins.property
    @jsii.member(jsii_name="maxColors")
    def max_colors(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitMaxColorsList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitMaxColorsList, jsii.get(self, "maxColors"))

    @builtins.property
    @jsii.member(jsii_name="mirror")
    def mirror(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitMirrorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitMirrorList, jsii.get(self, "mirror"))

    @builtins.property
    @jsii.member(jsii_name="monoHue")
    def mono_hue(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitMonoHueList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitMonoHueList, jsii.get(self, "monoHue"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitOpacityList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitOpacityList, jsii.get(self, "opacity"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestCrop")
    def region_of_interest_crop(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitRegionOfInterestCropList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitRegionOfInterestCropList", jsii.get(self, "regionOfInterestCrop"))

    @builtins.property
    @jsii.member(jsii_name="relativeCrop")
    def relative_crop(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitRelativeCropList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitRelativeCropList", jsii.get(self, "relativeCrop"))

    @builtins.property
    @jsii.member(jsii_name="removeColor")
    def remove_color(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitRemoveColorList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitRemoveColorList", jsii.get(self, "removeColor"))

    @builtins.property
    @jsii.member(jsii_name="resize")
    def resize(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitResizeList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitResizeList", jsii.get(self, "resize"))

    @builtins.property
    @jsii.member(jsii_name="rotate")
    def rotate(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitRotateList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitRotateList", jsii.get(self, "rotate"))

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitScaleList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitScaleList", jsii.get(self, "scale"))

    @builtins.property
    @jsii.member(jsii_name="shear")
    def shear(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitShearList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitShearList", jsii.get(self, "shear"))

    @builtins.property
    @jsii.member(jsii_name="trim")
    def trim(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitTrimList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitTrimList", jsii.get(self, "trim"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMask")
    def unsharp_mask(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitUnsharpMaskList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitUnsharpMaskList", jsii.get(self, "unsharpMask"))

    @builtins.property
    @jsii.member(jsii_name="appendInput")
    def append_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitAppend]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitAppend]]], jsii.get(self, "appendInput"))

    @builtins.property
    @jsii.member(jsii_name="aspectCropInput")
    def aspect_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitAspectCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitAspectCrop]]], jsii.get(self, "aspectCropInput"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColorInput")
    def background_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitBackgroundColor]]], jsii.get(self, "backgroundColorInput"))

    @builtins.property
    @jsii.member(jsii_name="blurInput")
    def blur_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitBlur]]], jsii.get(self, "blurInput"))

    @builtins.property
    @jsii.member(jsii_name="chromaKeyInput")
    def chroma_key_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitChromaKey]]], jsii.get(self, "chromaKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="compositeInput")
    def composite_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitComposite]]], jsii.get(self, "compositeInput"))

    @builtins.property
    @jsii.member(jsii_name="compoundInput")
    def compound_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitCompound]]], jsii.get(self, "compoundInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitContrast]]], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="cropInput")
    def crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitCrop]]], jsii.get(self, "cropInput"))

    @builtins.property
    @jsii.member(jsii_name="faceCropInput")
    def face_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitFaceCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitFaceCrop]]], jsii.get(self, "faceCropInput"))

    @builtins.property
    @jsii.member(jsii_name="featureCropInput")
    def feature_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitFeatureCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitFeatureCrop]]], jsii.get(self, "featureCropInput"))

    @builtins.property
    @jsii.member(jsii_name="fitAndFillInput")
    def fit_and_fill_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitFitAndFill]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitFitAndFill]]], jsii.get(self, "fitAndFillInput"))

    @builtins.property
    @jsii.member(jsii_name="goopInput")
    def goop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitGoop]]], jsii.get(self, "goopInput"))

    @builtins.property
    @jsii.member(jsii_name="grayscaleInput")
    def grayscale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitGrayscale]]], jsii.get(self, "grayscaleInput"))

    @builtins.property
    @jsii.member(jsii_name="hslInput")
    def hsl_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitHsl]]], jsii.get(self, "hslInput"))

    @builtins.property
    @jsii.member(jsii_name="hsvInput")
    def hsv_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitHsv]]], jsii.get(self, "hsvInput"))

    @builtins.property
    @jsii.member(jsii_name="ifDimensionInput")
    def if_dimension_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfDimension]]], jsii.get(self, "ifDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientationInput")
    def if_orientation_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientation]]], jsii.get(self, "ifOrientationInput"))

    @builtins.property
    @jsii.member(jsii_name="imQueryInput")
    def im_query_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitImQuery]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitImQuery]]], jsii.get(self, "imQueryInput"))

    @builtins.property
    @jsii.member(jsii_name="maxColorsInput")
    def max_colors_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitMaxColors]]], jsii.get(self, "maxColorsInput"))

    @builtins.property
    @jsii.member(jsii_name="mirrorInput")
    def mirror_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitMirror]]], jsii.get(self, "mirrorInput"))

    @builtins.property
    @jsii.member(jsii_name="monoHueInput")
    def mono_hue_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitMonoHue]]], jsii.get(self, "monoHueInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitOpacity]]], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestCropInput")
    def region_of_interest_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitRegionOfInterestCrop"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitRegionOfInterestCrop"]]], jsii.get(self, "regionOfInterestCropInput"))

    @builtins.property
    @jsii.member(jsii_name="relativeCropInput")
    def relative_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitRelativeCrop"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitRelativeCrop"]]], jsii.get(self, "relativeCropInput"))

    @builtins.property
    @jsii.member(jsii_name="removeColorInput")
    def remove_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitRemoveColor"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitRemoveColor"]]], jsii.get(self, "removeColorInput"))

    @builtins.property
    @jsii.member(jsii_name="resizeInput")
    def resize_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitResize"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitResize"]]], jsii.get(self, "resizeInput"))

    @builtins.property
    @jsii.member(jsii_name="rotateInput")
    def rotate_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitRotate"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitRotate"]]], jsii.get(self, "rotateInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitScale"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitScale"]]], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="shearInput")
    def shear_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitShear"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitShear"]]], jsii.get(self, "shearInput"))

    @builtins.property
    @jsii.member(jsii_name="trimInput")
    def trim_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitTrim"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitTrim"]]], jsii.get(self, "trimInput"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMaskInput")
    def unsharp_mask_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitUnsharpMask"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitUnsharpMask"]]], jsii.get(self, "unsharpMaskInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortrait]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortrait], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortrait],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fe2313fa50d01f921e4c2237e2583e853b3a3b4df2c6ec603fc8213ec00599fa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitRegionOfInterestCrop",
    jsii_struct_bases=[],
    name_mapping={
        "region_of_interest": "regionOfInterest",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitRegionOfInterestCrop:
    def __init__(
        self,
        *,
        region_of_interest: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitRegionOfInterestCropRegionOfInterest", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param region_of_interest: region_of_interest block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest DataAkamaiImagingPolicyImage#region_of_interest}
        :param gravity: The placement of the crop area relative to the specified area of interest. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: The placement of the crop area relative to the specified area of interest. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param style: Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(region_of_interest, dict):
            region_of_interest = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitRegionOfInterestCropRegionOfInterest(**region_of_interest)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d11d7a12b1b6a61beaed348cd1a13e56fca351f4def4a8e6541dc5c6f959f8c5)
            check_type(argname="argument region_of_interest", value=region_of_interest, expected_type=type_hints["region_of_interest"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "region_of_interest": region_of_interest,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def region_of_interest(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitRegionOfInterestCropRegionOfInterest":
        '''region_of_interest block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest DataAkamaiImagingPolicyImage#region_of_interest}
        '''
        result = self._values.get("region_of_interest")
        assert result is not None, "Required property 'region_of_interest' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitRegionOfInterestCropRegionOfInterest", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''The placement of the crop area relative to the specified area of interest.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''The placement of the crop area relative to the specified area of interest.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitRegionOfInterestCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitRegionOfInterestCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitRegionOfInterestCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b4411fdaec0ddfee56344f06e752ff3a072e6bbc410c9b4e817ded3722d37f6f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitRegionOfInterestCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e172a6dc93cb67f1addebc1618aecfb5859883b7bd796c3f6579e4b2385a9947)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitRegionOfInterestCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__51ce24a8dd8dbb1b49c2aaf5138e894da2530d1fbd69720494241b8bb28d3f78)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9bdbbc3ab3fdcbce3eabc62fabee51898d5d3ba26e44d990e8e6bd81c106e0ab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c74ecb5f72008dd85e533ed40fcc1398394479331719ea7d863ae8fa4a2eb365)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitRegionOfInterestCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitRegionOfInterestCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitRegionOfInterestCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4cdfaebeaae94b8ee6c155f250fcfbc0ca32304876dcb0c478959f3025981384)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitRegionOfInterestCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitRegionOfInterestCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d61e0b91794e3c917a9e4d9dff57035c2f42494bd27263894a95c09938add3d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putRegionOfInterest")
    def put_region_of_interest(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitRegionOfInterestCropRegionOfInterest()

        return typing.cast(None, jsii.invoke(self, "putRegionOfInterest", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterest")
    def region_of_interest(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitRegionOfInterestCropRegionOfInterestOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitRegionOfInterestCropRegionOfInterestOutputReference", jsii.get(self, "regionOfInterest"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestInput")
    def region_of_interest_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitRegionOfInterestCropRegionOfInterest"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitRegionOfInterestCropRegionOfInterest"], jsii.get(self, "regionOfInterestInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9cb0753c25d9fd63d187484a60fb4d40fe7218589e9cf57fa389de95f038867b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f1ac218e9fcea9cfca02aac3c05ceb1efd300707792ecbb9a28decca94a64bd9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__798f5052397b7550b9ea25cd910284ad0c45c2b75629bf0b275dc483fd45e51d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb12d91756b8207fb4d5e30b140912019170b28f3f628660079554526ee7d11e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab4ade7ebca896ae6931b49b28ed60670c7aabe0fffb6bc4f1108677aefb36cf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4345eed02385ea902d47023256e87444b062e0dbf9855ac09525a9fccde93464)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a2e8869879831f189f424819368d8c8e8252433520d8090de11423165950eb3c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9350dbf8a24ae724eac777bd901c54e7bcc166af1441f42d2bad84f8f6d9300d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitRegionOfInterestCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitRegionOfInterestCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitRegionOfInterestCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__526c170a1295bcaf0c69d1c084261b166517d86889bdbb0c66c9a6b75a9fc7e5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitRegionOfInterestCropRegionOfInterest",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitRegionOfInterestCropRegionOfInterest:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitRegionOfInterestCropRegionOfInterest(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitRegionOfInterestCropRegionOfInterestOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitRegionOfInterestCropRegionOfInterestOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ff8c7c069ea06673f6ec701de19a0900528379040d52b4a9a3120f183bd5346d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitRegionOfInterestCropRegionOfInterest]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitRegionOfInterestCropRegionOfInterest], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitRegionOfInterestCropRegionOfInterest],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7fe0234aa588f14f052c25e829d58021461c90f8b3008e112d7ffb84c0ca03e8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitRelativeCrop",
    jsii_struct_bases=[],
    name_mapping={
        "east": "east",
        "east_var": "eastVar",
        "north": "north",
        "north_var": "northVar",
        "south": "south",
        "south_var": "southVar",
        "west": "west",
        "west_var": "westVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitRelativeCrop:
    def __init__(
        self,
        *,
        east: typing.Optional[builtins.str] = None,
        east_var: typing.Optional[builtins.str] = None,
        north: typing.Optional[builtins.str] = None,
        north_var: typing.Optional[builtins.str] = None,
        south: typing.Optional[builtins.str] = None,
        south_var: typing.Optional[builtins.str] = None,
        west: typing.Optional[builtins.str] = None,
        west_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param east: The number of pixels to shrink or expand the right side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east DataAkamaiImagingPolicyImage#east}
        :param east_var: The number of pixels to shrink or expand the right side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east_var DataAkamaiImagingPolicyImage#east_var}
        :param north: The number of pixels to shrink or expand the top side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north DataAkamaiImagingPolicyImage#north}
        :param north_var: The number of pixels to shrink or expand the top side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north_var DataAkamaiImagingPolicyImage#north_var}
        :param south: The number of pixels to shrink or expand the bottom side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south DataAkamaiImagingPolicyImage#south}
        :param south_var: The number of pixels to shrink or expand the bottom side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south_var DataAkamaiImagingPolicyImage#south_var}
        :param west: The number of pixels to shrink or expand the left side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west DataAkamaiImagingPolicyImage#west}
        :param west_var: The number of pixels to shrink or expand the left side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west_var DataAkamaiImagingPolicyImage#west_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ecd995c1300c95efe387dc6bfcd5fa62e349e69bd2c6f30010974b30bdba99c9)
            check_type(argname="argument east", value=east, expected_type=type_hints["east"])
            check_type(argname="argument east_var", value=east_var, expected_type=type_hints["east_var"])
            check_type(argname="argument north", value=north, expected_type=type_hints["north"])
            check_type(argname="argument north_var", value=north_var, expected_type=type_hints["north_var"])
            check_type(argname="argument south", value=south, expected_type=type_hints["south"])
            check_type(argname="argument south_var", value=south_var, expected_type=type_hints["south_var"])
            check_type(argname="argument west", value=west, expected_type=type_hints["west"])
            check_type(argname="argument west_var", value=west_var, expected_type=type_hints["west_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if east is not None:
            self._values["east"] = east
        if east_var is not None:
            self._values["east_var"] = east_var
        if north is not None:
            self._values["north"] = north
        if north_var is not None:
            self._values["north_var"] = north_var
        if south is not None:
            self._values["south"] = south
        if south_var is not None:
            self._values["south_var"] = south_var
        if west is not None:
            self._values["west"] = west
        if west_var is not None:
            self._values["west_var"] = west_var

    @builtins.property
    def east(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the right side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east DataAkamaiImagingPolicyImage#east}
        '''
        result = self._values.get("east")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def east_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the right side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east_var DataAkamaiImagingPolicyImage#east_var}
        '''
        result = self._values.get("east_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def north(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the top side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north DataAkamaiImagingPolicyImage#north}
        '''
        result = self._values.get("north")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def north_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the top side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north_var DataAkamaiImagingPolicyImage#north_var}
        '''
        result = self._values.get("north_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def south(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the bottom side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south DataAkamaiImagingPolicyImage#south}
        '''
        result = self._values.get("south")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def south_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the bottom side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south_var DataAkamaiImagingPolicyImage#south_var}
        '''
        result = self._values.get("south_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def west(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the left side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west DataAkamaiImagingPolicyImage#west}
        '''
        result = self._values.get("west")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def west_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the left side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west_var DataAkamaiImagingPolicyImage#west_var}
        '''
        result = self._values.get("west_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitRelativeCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitRelativeCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitRelativeCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8cd2b7475fddde72dfe03e09218eb126b453d3da863fa998140e8fcab6008694)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitRelativeCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2f37ec748a1d0b0aa81dd618f6520dfdde7f98490d9aa01c2de1dde20c049f4b)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitRelativeCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f74e0c311baae7f558d428f3cff00b0af579fe9690981fcad199269d68733f36)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f71c9331a3782e3426aaf4f5eec410acc50e42a01b46b27712f5c3311c414769)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2fbb0cb8d70feedd44566febe07e079e52790c354cb202885c6a798491004b93)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitRelativeCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitRelativeCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitRelativeCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b838066397d47f3412440803638a72445f9c2663518f612659b2bc2bad51c8ef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitRelativeCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitRelativeCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea075c3971012e8244ea08f45de3287a5164f0547881941573f4b8f65854c150)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetEast")
    def reset_east(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEast", []))

    @jsii.member(jsii_name="resetEastVar")
    def reset_east_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEastVar", []))

    @jsii.member(jsii_name="resetNorth")
    def reset_north(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNorth", []))

    @jsii.member(jsii_name="resetNorthVar")
    def reset_north_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNorthVar", []))

    @jsii.member(jsii_name="resetSouth")
    def reset_south(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSouth", []))

    @jsii.member(jsii_name="resetSouthVar")
    def reset_south_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSouthVar", []))

    @jsii.member(jsii_name="resetWest")
    def reset_west(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWest", []))

    @jsii.member(jsii_name="resetWestVar")
    def reset_west_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWestVar", []))

    @builtins.property
    @jsii.member(jsii_name="eastInput")
    def east_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "eastInput"))

    @builtins.property
    @jsii.member(jsii_name="eastVarInput")
    def east_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "eastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="northInput")
    def north_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "northInput"))

    @builtins.property
    @jsii.member(jsii_name="northVarInput")
    def north_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "northVarInput"))

    @builtins.property
    @jsii.member(jsii_name="southInput")
    def south_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "southInput"))

    @builtins.property
    @jsii.member(jsii_name="southVarInput")
    def south_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "southVarInput"))

    @builtins.property
    @jsii.member(jsii_name="westInput")
    def west_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "westInput"))

    @builtins.property
    @jsii.member(jsii_name="westVarInput")
    def west_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "westVarInput"))

    @builtins.property
    @jsii.member(jsii_name="east")
    def east(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "east"))

    @east.setter
    def east(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e84af0ee48b27997d64956ad210dae2fd1e8d640b0bbc497ef9f03e15e12b66d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "east", value)

    @builtins.property
    @jsii.member(jsii_name="eastVar")
    def east_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "eastVar"))

    @east_var.setter
    def east_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc0e43c3c9ac3368c8943039c0a9fa4c1bd541842ec998d36c1ab8bfcd940305)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "eastVar", value)

    @builtins.property
    @jsii.member(jsii_name="north")
    def north(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "north"))

    @north.setter
    def north(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a38450f036e7cf1ca6fb3c02bc6eacf5da155973f78607dbd316a13cb098d104)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "north", value)

    @builtins.property
    @jsii.member(jsii_name="northVar")
    def north_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "northVar"))

    @north_var.setter
    def north_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__88cd0f1861e43ba07e987b70920a724c6dcf8bf10c637c219564687f93d159b8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "northVar", value)

    @builtins.property
    @jsii.member(jsii_name="south")
    def south(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "south"))

    @south.setter
    def south(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ce76e9d40418acad4e2ecf2f47f0f4841940ce94c16c7c4621288cbebe99f9d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "south", value)

    @builtins.property
    @jsii.member(jsii_name="southVar")
    def south_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "southVar"))

    @south_var.setter
    def south_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a6d9d66b13db71bc47d20df54ad43db3d085df2d314dd53079a6135c488f81b9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "southVar", value)

    @builtins.property
    @jsii.member(jsii_name="west")
    def west(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "west"))

    @west.setter
    def west(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ff488d9344d9c3f42f6d44452b13605e49fadc5369caf11ce78bed0f889effa6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "west", value)

    @builtins.property
    @jsii.member(jsii_name="westVar")
    def west_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "westVar"))

    @west_var.setter
    def west_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__28e0bf32cdeea43aa76adec8afed18dbe4650f4fdf4afe03263801fbca544a56)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "westVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitRelativeCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitRelativeCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitRelativeCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fc0d588fbb76a9ed380ed8926f6375a586e54b8cb55e30e90125310cae91e5e3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitRemoveColor",
    jsii_struct_bases=[],
    name_mapping={
        "color": "color",
        "color_var": "colorVar",
        "feather": "feather",
        "feather_var": "featherVar",
        "tolerance": "tolerance",
        "tolerance_var": "toleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitRemoveColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
        feather: typing.Optional[builtins.str] = None,
        feather_var: typing.Optional[builtins.str] = None,
        tolerance: typing.Optional[builtins.str] = None,
        tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        :param feather: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        :param feather_var: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        :param tolerance: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        :param tolerance_var: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d1d55468914bdaf340a5b62e613eb8afaf273028303436ff1b7caf7f19d19aa5)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
            check_type(argname="argument feather", value=feather, expected_type=type_hints["feather"])
            check_type(argname="argument feather_var", value=feather_var, expected_type=type_hints["feather_var"])
            check_type(argname="argument tolerance", value=tolerance, expected_type=type_hints["tolerance"])
            check_type(argname="argument tolerance_var", value=tolerance_var, expected_type=type_hints["tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var
        if feather is not None:
            self._values["feather"] = feather
        if feather_var is not None:
            self._values["feather_var"] = feather_var
        if tolerance is not None:
            self._values["tolerance"] = tolerance
        if tolerance_var is not None:
            self._values["tolerance_var"] = tolerance_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        '''
        result = self._values.get("feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather_var(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        '''
        result = self._values.get("feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        '''
        result = self._values.get("tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance_var(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        result = self._values.get("tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitRemoveColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitRemoveColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitRemoveColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__838295d6ed991eb959ed2bd7e1286ecf0d2b9a260d9955840f8553d4d5f2475f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitRemoveColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1da778a03a5aceea9d5c87c6609326f72945df91a14d6208f676556964471295)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitRemoveColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ec68ee0d815aab72f189eac168f758d40d68fc9b0e440f81f409991ce4cf9b90)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__33b9a463f3edee65e83d344415a56dd76be8c507eaf20a4953400ea6f9aee285)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e52002a8b548037f46c991b8c6bca4f8230ee213877978071d870e8a2d078735)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitRemoveColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitRemoveColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitRemoveColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9e7d67e7fef1f722b95ad88297f0b35a3abeb9de80acb7e48d64fb663f4530e2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitRemoveColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitRemoveColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__77d312297bd07a41afbe102f76c60c2906a883a5249a32471f1bcc09d2ed0b0d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @jsii.member(jsii_name="resetFeather")
    def reset_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeather", []))

    @jsii.member(jsii_name="resetFeatherVar")
    def reset_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatherVar", []))

    @jsii.member(jsii_name="resetTolerance")
    def reset_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTolerance", []))

    @jsii.member(jsii_name="resetToleranceVar")
    def reset_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featherInput")
    def feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherInput"))

    @builtins.property
    @jsii.member(jsii_name="featherVarInput")
    def feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceInput")
    def tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceVarInput")
    def tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__517ecf6a27717e49b302baa34ee49192f25c21262d40aaccbf403a3887d676cb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__64653a55f64a9893d029f05be44ed9c4724d2569487f214abb7bb2eb51466e40)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="feather")
    def feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "feather"))

    @feather.setter
    def feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ef0f914b35123581197b4913e2cd7b56dac19b5cd0ac92ad81717a7422fc5463)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "feather", value)

    @builtins.property
    @jsii.member(jsii_name="featherVar")
    def feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featherVar"))

    @feather_var.setter
    def feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a9e54b0e37066ecd93b858b445dffb507d3ad3d0dfd33173af357b3b8ac637d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featherVar", value)

    @builtins.property
    @jsii.member(jsii_name="tolerance")
    def tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tolerance"))

    @tolerance.setter
    def tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3bbd284a2dfa520d172ecee9f18ea174d1226dfd76897918e1b25779b7660e85)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tolerance", value)

    @builtins.property
    @jsii.member(jsii_name="toleranceVar")
    def tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "toleranceVar"))

    @tolerance_var.setter
    def tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__526650662a5b53d8927d8d2c4d577cc3c32efde7574919d64c38dfc3eba2ad78)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "toleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitRemoveColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitRemoveColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitRemoveColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4df76dc7e9f67cf4f843d04eb987d7f1b00dfb367d08de993b5ef08f67cf6942)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitResize",
    jsii_struct_bases=[],
    name_mapping={
        "aspect": "aspect",
        "aspect_var": "aspectVar",
        "height": "height",
        "height_var": "heightVar",
        "type": "type",
        "type_var": "typeVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitResize:
    def __init__(
        self,
        *,
        aspect: typing.Optional[builtins.str] = None,
        aspect_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param aspect: Preserves the aspect ratio. Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect DataAkamaiImagingPolicyImage#aspect}
        :param aspect_var: Preserves the aspect ratio. Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_var DataAkamaiImagingPolicyImage#aspect_var}
        :param height: The height to resize the source image to. Must be set if height is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height to resize the source image to. Must be set if height is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param type: Sets constraints for the image resize. Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: Sets constraints for the image resize. Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        :param width: The width to resize the source image to. Must be set if width is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width to resize the source image to. Must be set if width is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__59fc43f7b286d896b7f916d57ca39746c58b41c79b187a137305fa2d8f179fa4)
            check_type(argname="argument aspect", value=aspect, expected_type=type_hints["aspect"])
            check_type(argname="argument aspect_var", value=aspect_var, expected_type=type_hints["aspect_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if aspect is not None:
            self._values["aspect"] = aspect
        if aspect_var is not None:
            self._values["aspect_var"] = aspect_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def aspect(self) -> typing.Optional[builtins.str]:
        '''Preserves the aspect ratio.

        Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect DataAkamaiImagingPolicyImage#aspect}
        '''
        result = self._values.get("aspect")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def aspect_var(self) -> typing.Optional[builtins.str]:
        '''Preserves the aspect ratio.

        Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_var DataAkamaiImagingPolicyImage#aspect_var}
        '''
        result = self._values.get("aspect_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height to resize the source image to. Must be set if height is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height to resize the source image to. Must be set if height is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''Sets constraints for the image resize.

        Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''Sets constraints for the image resize.

        Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width to resize the source image to. Must be set if width is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width to resize the source image to. Must be set if width is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitResize(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitResizeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitResizeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dd4a5b4290f9df1296d8a704129193fb18c34d5c5c771d3428d4580772a10b67)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitResizeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cb21fd11ccadebdf36f10856fbfafae1469617d9064e39244374d972d1fc57e7)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitResizeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a690c50edad0e8a0ae9f44ad45e085330c90ad5adf8e55d5f1dff590338b5cc5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cb0f0782e0bace61dbb19879f912fdfe071008efe5fafa339bca438bcb54dd10)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6206993e8f1b562ed64adf7f18c01aa40e99334c5360ecc2e10cbafda0272bec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitResize]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitResize]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitResize]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aae192916e1c15edced5dd5025a685ee50e9330400e26d75c437c7feab3b122e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitResizeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitResizeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__26f7222a7886ab8f838f1dc41b31f79a46eab498e1650334389148e08fe7eb51)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAspect")
    def reset_aspect(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspect", []))

    @jsii.member(jsii_name="resetAspectVar")
    def reset_aspect_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspectVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="aspectInput")
    def aspect_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "aspectInput"))

    @builtins.property
    @jsii.member(jsii_name="aspectVarInput")
    def aspect_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "aspectVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="aspect")
    def aspect(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "aspect"))

    @aspect.setter
    def aspect(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__714513a95f739c8947d7f8a8fb41ca7b523c544ae0a6e2a6b8e73b3ce3f4a6f6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "aspect", value)

    @builtins.property
    @jsii.member(jsii_name="aspectVar")
    def aspect_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "aspectVar"))

    @aspect_var.setter
    def aspect_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__749a866d309c8f9e177af119037b5e5ebb15e74af9e54a6923934e69cf3911ec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "aspectVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d6902cb8bef0f5b096b2ec196cedd12e952d3c13dc77ab1f7a9cdb30188f018a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__305f8414a1234f19855d934d3c6018df11b48f33ea964de8aabc90a9405821cf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5a487b110f01db75b0f9a7047188c91d9d76e1f24fdd5b80802ed62af701a81a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a9b7bac49476d46be9e81ec5d3def0fe6463226693527784e678bb6fe9f6954f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d7e63dbc26e95f788fce1c00b80220c0977e392e8ebe16a80c0bb56fa94ec742)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a64ee2102685ebd96528bfbec22cb859baa2b3f1bf759f44e370a6f4b1440eb6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitResize]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitResize]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitResize]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d47c75aeaa84690e9613afa491aa605e9e238ff4baf5f7d0e84b554f2604be2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitRotate",
    jsii_struct_bases=[],
    name_mapping={"degrees": "degrees", "degrees_var": "degreesVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitRotate:
    def __init__(
        self,
        *,
        degrees: typing.Optional[builtins.str] = None,
        degrees_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param degrees: The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees DataAkamaiImagingPolicyImage#degrees}
        :param degrees_var: The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees_var DataAkamaiImagingPolicyImage#degrees_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ad5e7c7619ec593776ccb13dfad6a494164e3af6b030eb8bea5d1e2f83c74b3)
            check_type(argname="argument degrees", value=degrees, expected_type=type_hints["degrees"])
            check_type(argname="argument degrees_var", value=degrees_var, expected_type=type_hints["degrees_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if degrees is not None:
            self._values["degrees"] = degrees
        if degrees_var is not None:
            self._values["degrees_var"] = degrees_var

    @builtins.property
    def degrees(self) -> typing.Optional[builtins.str]:
        '''The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees DataAkamaiImagingPolicyImage#degrees}
        '''
        result = self._values.get("degrees")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def degrees_var(self) -> typing.Optional[builtins.str]:
        '''The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees_var DataAkamaiImagingPolicyImage#degrees_var}
        '''
        result = self._values.get("degrees_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitRotate(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitRotateList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitRotateList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__71c37b630dd8d8eb016d2d13aa1fb3449f8f770da559625f81299b4ae9644b50)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitRotateOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b7f0f4943b91934aced78a2bc3a996a5c96eed16ecce7933b4253bf1600a312c)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitRotateOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1761f63821ed0fa45180b17af96db1570514ff5eddfe30d218eb74f0ac5caa60)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d455e67929950966d40fa11168c38b6f58fc29382c7bf7b8ef5cebb6afd9495e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__357209581a697124956db518ea5cb7d579e2090e8bf56b9219244953524b0066)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitRotate]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitRotate]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitRotate]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f25909f2401fda171fba0634189e64591fb1b570cd0a13dbe06ff69c0df9a645)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitRotateOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitRotateOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__158fe4c9e12782ec1dfda9397b4af1c49802ed27e512dc0ce7a66319d6307a41)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetDegrees")
    def reset_degrees(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDegrees", []))

    @jsii.member(jsii_name="resetDegreesVar")
    def reset_degrees_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDegreesVar", []))

    @builtins.property
    @jsii.member(jsii_name="degreesInput")
    def degrees_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "degreesInput"))

    @builtins.property
    @jsii.member(jsii_name="degreesVarInput")
    def degrees_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "degreesVarInput"))

    @builtins.property
    @jsii.member(jsii_name="degrees")
    def degrees(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "degrees"))

    @degrees.setter
    def degrees(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7efdce39f801d3ce29944a9e13e3c87a77ab6702cf7c8118331a812f77b22f47)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "degrees", value)

    @builtins.property
    @jsii.member(jsii_name="degreesVar")
    def degrees_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "degreesVar"))

    @degrees_var.setter
    def degrees_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__22e5dc95a1b3ff0b6c6bb1697b960efc1c82d18644c5a41eedef26a9bae85abf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "degreesVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitRotate]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitRotate]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitRotate]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7581fa1c7bda884148d8b64098a0684070b225092c6ab45c1d75759a46b519f4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitScale",
    jsii_struct_bases=[],
    name_mapping={
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitScale:
    def __init__(
        self,
        *,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param height: Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged. Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged. Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__276fa11efad00029f7dbbc92acbff2669c3ef3fb51cb34861c8212d3b8cc5dde)
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size.

        Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size.

        Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged.

        Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged.

        Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitScale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitScaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitScaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af821a6f0e7a0b02044a74deb13f9793f703a4d23aab5900fedcabaf91ee5d3c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitScaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__10eeaaaa02c47f5c6489294644e347b3e9f3630b5f2b503da9b3415e50534822)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitScaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__36c5113a64ac628b00020365aac4045e41be2deace3ee7df9a80eebdf466c4d3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0aab99a8f58f6c8439387062043c944b749fead665553d026f5bb1d32c6e1a86)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__29f7fdc8786db0921bbbf50bf4ba7e1ffdceddb85d3e3b26a404b6110a3514dd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitScale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitScale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitScale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__853c4e46ff758fadf0d516ee99c16264ae44cc2b05c8e5612cbac63b050931c5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitScaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitScaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__60df57aff79b90256dded50b72a8b964f72c12272d10eadf4a9bc6325971eacd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__017b4a43146e718d7d850c101e636b40007355b1014ad4dd31d9e5dd7e75b60e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3d003f1f8f9d202fb82727c178eccae6897c7ed7ae6f617f51ebb97505648e11)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__96df0464d548f879f03e308d8ee1ff23e6ab710f80f78de9028c3daf762e7130)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac61c3061a06b818fa8404a7a2ad9b95586f21917d3932379fc4d35d0e3c8183)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitScale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitScale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitScale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aaa5a910e10d3f3f59ebd948b40921b0763bd990bf68a62151d9dcf17c2f0b10)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitShear",
    jsii_struct_bases=[],
    name_mapping={
        "x_shear": "xShear",
        "x_shear_var": "xShearVar",
        "y_shear": "yShear",
        "y_shear_var": "yShearVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitShear:
    def __init__(
        self,
        *,
        x_shear: typing.Optional[builtins.str] = None,
        x_shear_var: typing.Optional[builtins.str] = None,
        y_shear: typing.Optional[builtins.str] = None,
        y_shear_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param x_shear: The amount to shear along the x-axis, measured in multiples of the image's width. Must be set if yShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear DataAkamaiImagingPolicyImage#x_shear}
        :param x_shear_var: The amount to shear along the x-axis, measured in multiples of the image's width. Must be set if yShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear_var DataAkamaiImagingPolicyImage#x_shear_var}
        :param y_shear: The amount to shear along the y-axis, measured in multiples of the image's height. Must be set if xShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear DataAkamaiImagingPolicyImage#y_shear}
        :param y_shear_var: The amount to shear along the y-axis, measured in multiples of the image's height. Must be set if xShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear_var DataAkamaiImagingPolicyImage#y_shear_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__33fcba8a752a40a0cad8ca86e936e7a32fcc326a164dc24f44a1b35a9cceed86)
            check_type(argname="argument x_shear", value=x_shear, expected_type=type_hints["x_shear"])
            check_type(argname="argument x_shear_var", value=x_shear_var, expected_type=type_hints["x_shear_var"])
            check_type(argname="argument y_shear", value=y_shear, expected_type=type_hints["y_shear"])
            check_type(argname="argument y_shear_var", value=y_shear_var, expected_type=type_hints["y_shear_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if x_shear is not None:
            self._values["x_shear"] = x_shear
        if x_shear_var is not None:
            self._values["x_shear_var"] = x_shear_var
        if y_shear is not None:
            self._values["y_shear"] = y_shear
        if y_shear_var is not None:
            self._values["y_shear_var"] = y_shear_var

    @builtins.property
    def x_shear(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the x-axis, measured in multiples of the image's width.

        Must be set if yShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear DataAkamaiImagingPolicyImage#x_shear}
        '''
        result = self._values.get("x_shear")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_shear_var(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the x-axis, measured in multiples of the image's width.

        Must be set if yShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear_var DataAkamaiImagingPolicyImage#x_shear_var}
        '''
        result = self._values.get("x_shear_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_shear(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the y-axis, measured in multiples of the image's height.

        Must be set if xShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear DataAkamaiImagingPolicyImage#y_shear}
        '''
        result = self._values.get("y_shear")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_shear_var(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the y-axis, measured in multiples of the image's height.

        Must be set if xShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear_var DataAkamaiImagingPolicyImage#y_shear_var}
        '''
        result = self._values.get("y_shear_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitShear(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitShearList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitShearList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1e69d0e7c11bb7a53227a69f78f7e8ecafdd4b7167fada3b9cbef0f194ae3676)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitShearOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__50feceb911d507027b36a359497e455cabc41475543a8791812d4bd3bbd2dc90)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitShearOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dbee84f380fbfcdd492e7bba5ca44ef9d603b60df2deb970bdb2f711cfb9a3be)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c0fa87053d66ba670c9624ca3ec51a6f82ac43fb909eabf42d582f01c0133b54)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0c842cc4fa134cc06fc55ec65133d90aa4262e3838dcb3ae7abe7269e3864b28)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitShear]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitShear]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitShear]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6b9d127ac8d0798b240795746fb479ad02301e5195efbff88fe9f4488e5135b9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitShearOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitShearOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8eb0ce78a86ffb96d1a7f211f1bf6a4d57a0edc352fa9ce5728f3934b9a007df)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetXShear")
    def reset_x_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXShear", []))

    @jsii.member(jsii_name="resetXShearVar")
    def reset_x_shear_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXShearVar", []))

    @jsii.member(jsii_name="resetYShear")
    def reset_y_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYShear", []))

    @jsii.member(jsii_name="resetYShearVar")
    def reset_y_shear_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYShearVar", []))

    @builtins.property
    @jsii.member(jsii_name="xShearInput")
    def x_shear_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xShearInput"))

    @builtins.property
    @jsii.member(jsii_name="xShearVarInput")
    def x_shear_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xShearVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yShearInput")
    def y_shear_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yShearInput"))

    @builtins.property
    @jsii.member(jsii_name="yShearVarInput")
    def y_shear_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yShearVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xShear")
    def x_shear(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xShear"))

    @x_shear.setter
    def x_shear(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c90b3ee055f2d0f3d60af11fdc16698028d3f12f70fea0fa3e0dc01fe68638b2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xShear", value)

    @builtins.property
    @jsii.member(jsii_name="xShearVar")
    def x_shear_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xShearVar"))

    @x_shear_var.setter
    def x_shear_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__612f7455e3f8bff79c3875d9eee2c1d59c00a82cc087f870b2df232d8cba940a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xShearVar", value)

    @builtins.property
    @jsii.member(jsii_name="yShear")
    def y_shear(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yShear"))

    @y_shear.setter
    def y_shear(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__418ea43411784e15d63996eae3a5f73317284a02d555629f02f53e1d17581eb0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yShear", value)

    @builtins.property
    @jsii.member(jsii_name="yShearVar")
    def y_shear_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yShearVar"))

    @y_shear_var.setter
    def y_shear_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7b83fc9c1fb69e50c80e6d003db2db65128c9aba1d7d830ffbd15e2b8d1a0c11)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yShearVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitShear]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitShear]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitShear]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2c8ead9ddc5eb4a171ff6ee76e5733171018d0c355664141766bbce73bdc423a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitTrim",
    jsii_struct_bases=[],
    name_mapping={
        "fuzz": "fuzz",
        "fuzz_var": "fuzzVar",
        "padding": "padding",
        "padding_var": "paddingVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitTrim:
    def __init__(
        self,
        *,
        fuzz: typing.Optional[builtins.str] = None,
        fuzz_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fuzz: The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz DataAkamaiImagingPolicyImage#fuzz}
        :param fuzz_var: The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz_var DataAkamaiImagingPolicyImage#fuzz_var}
        :param padding: The amount of padding in pixels to add to the trimmed image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: The amount of padding in pixels to add to the trimmed image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ca4eda415114deafcb53ece08de1e577eca37483cbc324ace26ddc9d8f3c8ec1)
            check_type(argname="argument fuzz", value=fuzz, expected_type=type_hints["fuzz"])
            check_type(argname="argument fuzz_var", value=fuzz_var, expected_type=type_hints["fuzz_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fuzz is not None:
            self._values["fuzz"] = fuzz
        if fuzz_var is not None:
            self._values["fuzz_var"] = fuzz_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var

    @builtins.property
    def fuzz(self) -> typing.Optional[builtins.str]:
        '''The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz DataAkamaiImagingPolicyImage#fuzz}
        '''
        result = self._values.get("fuzz")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fuzz_var(self) -> typing.Optional[builtins.str]:
        '''The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz_var DataAkamaiImagingPolicyImage#fuzz_var}
        '''
        result = self._values.get("fuzz_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''The amount of padding in pixels to add to the trimmed image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''The amount of padding in pixels to add to the trimmed image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitTrim(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitTrimList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitTrimList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__31e5f39498fdd9e6d0509e88bf21365071c068c8fc9cfea14290d51ce435261e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitTrimOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ab32278b88568eb33b55fed9c1f8b1aee8aaa67e201560ce7f8192ffabd161a)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitTrimOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__010385bf794df51d6706d42c7870c80290fd6d42c11c60ab2eae131865a207a9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__59286bcb994e80d6c497ab8e9dbd022facd0cfa18af67121625099b963a17e91)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__617ec5dea9a4e1ca41939854d92ff0d85e2bbf3c8f973a17f148c0d9654fc3ca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitTrim]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitTrim]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitTrim]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__512bf7d367333fbe6c8862a3478ae382f13a437a0bb673f6a98d171698ee7d21)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitTrimOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitTrimOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e1a1446aea64aa96108794bfd9a75c964daa63af6e2e03edf1b9b365d79899bd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetFuzz")
    def reset_fuzz(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFuzz", []))

    @jsii.member(jsii_name="resetFuzzVar")
    def reset_fuzz_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFuzzVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @builtins.property
    @jsii.member(jsii_name="fuzzInput")
    def fuzz_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fuzzInput"))

    @builtins.property
    @jsii.member(jsii_name="fuzzVarInput")
    def fuzz_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fuzzVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="fuzz")
    def fuzz(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fuzz"))

    @fuzz.setter
    def fuzz(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__99f57cc3c4a9cfc8e6d409f3677567d10ba567d3d2d2ce318f636f56f5e9612a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fuzz", value)

    @builtins.property
    @jsii.member(jsii_name="fuzzVar")
    def fuzz_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fuzzVar"))

    @fuzz_var.setter
    def fuzz_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__262c8e9714c9d08684de1211aec584cbb539e78c4ea14438919087c197387cdb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fuzzVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a17ed6f284ea6e3d7324f70670c92dcc14c7311d944b55ba79c01853c8fa9933)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__712590b65eec48c4dae8ea06bfd0d01673060958fdf4244b010ccf6922334b1a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitTrim]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitTrim]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitTrim]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4503b2aaa5f708bbfe06b2fffa5ff0304319df4d04ce978357d045053c885659)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitUnsharpMask",
    jsii_struct_bases=[],
    name_mapping={
        "gain": "gain",
        "gain_var": "gainVar",
        "sigma": "sigma",
        "sigma_var": "sigmaVar",
        "threshold": "threshold",
        "threshold_var": "thresholdVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitUnsharpMask:
    def __init__(
        self,
        *,
        gain: typing.Optional[builtins.str] = None,
        gain_var: typing.Optional[builtins.str] = None,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
        threshold: typing.Optional[builtins.str] = None,
        threshold_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param gain: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        :param gain_var: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        :param sigma: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        :param threshold: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        :param threshold_var: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__89409d5b123b71c4035a49281c341ac01361296748f192bac2216b0371129c85)
            check_type(argname="argument gain", value=gain, expected_type=type_hints["gain"])
            check_type(argname="argument gain_var", value=gain_var, expected_type=type_hints["gain_var"])
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
            check_type(argname="argument threshold", value=threshold, expected_type=type_hints["threshold"])
            check_type(argname="argument threshold_var", value=threshold_var, expected_type=type_hints["threshold_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if gain is not None:
            self._values["gain"] = gain
        if gain_var is not None:
            self._values["gain_var"] = gain_var
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var
        if threshold is not None:
            self._values["threshold"] = threshold
        if threshold_var is not None:
            self._values["threshold_var"] = threshold_var

    @builtins.property
    def gain(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        '''
        result = self._values.get("gain")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gain_var(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        '''
        result = self._values.get("gain_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        '''
        result = self._values.get("threshold")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold_var(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        result = self._values.get("threshold_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitUnsharpMask(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitUnsharpMaskList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitUnsharpMaskList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d674eb7973754eb52eb87df4fe5f670b4b17b604f28f8ea5575b9c03ede0f588)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitUnsharpMaskOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d450fa37a20c74b2da6d1c69c3ceaa1b9a00506fe311f19d2f657c8a0ae14a4e)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitUnsharpMaskOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__037bddfd58c38c260bcea572136fabd8729be71834c6378af9f79b2800970bbf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__57b4fa04783fb96afc2bcf2353fe0ac1969da50446dadb0d39cc3f2dc55c4bf0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e48e8538c3fa47b1f8881d7cd7b63975d58f64f86001e4605530ee77f15aa57c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitUnsharpMask]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitUnsharpMask]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitUnsharpMask]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e85022ecf746cb7c986e7fff8c890db5aa5778f0871c199bf8f5ac9ec0830c25)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitUnsharpMaskOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitUnsharpMaskOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ccd5d46f29e1eec64efc06d89851f923e47d9500454e7bf550551ba441c1f3d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetGain")
    def reset_gain(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGain", []))

    @jsii.member(jsii_name="resetGainVar")
    def reset_gain_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGainVar", []))

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @jsii.member(jsii_name="resetThreshold")
    def reset_threshold(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThreshold", []))

    @jsii.member(jsii_name="resetThresholdVar")
    def reset_threshold_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThresholdVar", []))

    @builtins.property
    @jsii.member(jsii_name="gainInput")
    def gain_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainInput"))

    @builtins.property
    @jsii.member(jsii_name="gainVarInput")
    def gain_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdInput")
    def threshold_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdVarInput")
    def threshold_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gain")
    def gain(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gain"))

    @gain.setter
    def gain(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5e42838269442a69e2667fabe19a37bb1892d2bb2eb457a4550ea6708807e47a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gain", value)

    @builtins.property
    @jsii.member(jsii_name="gainVar")
    def gain_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gainVar"))

    @gain_var.setter
    def gain_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__628e660af4bf5a7614329bce876dcdc30ca65b80b8f3e41b3fc93f4af06fe073)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gainVar", value)

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__39522b0161ebc1fe5a836156fe0e813abc7209124a4707ab54a8afa04adb52e8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cf727d619df3c070fe2f41d7a828d995b6c57bbf3dda467f2a5c1078f40ca980)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="threshold")
    def threshold(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "threshold"))

    @threshold.setter
    def threshold(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a488b54f568d39b44999a328f0ca1870334f43233db0e6d994c90e4b02ee3ad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "threshold", value)

    @builtins.property
    @jsii.member(jsii_name="thresholdVar")
    def threshold_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "thresholdVar"))

    @threshold_var.setter
    def threshold_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cda51513b8d4483862ffe00a461090e675a822fda27d10b2b6e33f021fdee8ff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "thresholdVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitUnsharpMask]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitUnsharpMask]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitUnsharpMask]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5aace9b45beb236604e09848a3ce322c3e1612559cd720de816649f0b15a99ad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquare",
    jsii_struct_bases=[],
    name_mapping={
        "append": "append",
        "aspect_crop": "aspectCrop",
        "background_color": "backgroundColor",
        "blur": "blur",
        "chroma_key": "chromaKey",
        "composite": "composite",
        "compound": "compound",
        "contrast": "contrast",
        "crop": "crop",
        "face_crop": "faceCrop",
        "feature_crop": "featureCrop",
        "fit_and_fill": "fitAndFill",
        "goop": "goop",
        "grayscale": "grayscale",
        "hsl": "hsl",
        "hsv": "hsv",
        "if_dimension": "ifDimension",
        "if_orientation": "ifOrientation",
        "im_query": "imQuery",
        "max_colors": "maxColors",
        "mirror": "mirror",
        "mono_hue": "monoHue",
        "opacity": "opacity",
        "region_of_interest_crop": "regionOfInterestCrop",
        "relative_crop": "relativeCrop",
        "remove_color": "removeColor",
        "resize": "resize",
        "rotate": "rotate",
        "scale": "scale",
        "shear": "shear",
        "trim": "trim",
        "unsharp_mask": "unsharpMask",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquare:
    def __init__(
        self,
        *,
        append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareAppend", typing.Dict[builtins.str, typing.Any]]]]] = None,
        aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareAspectCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareBackgroundColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareBlur", typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareChromaKey", typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareComposite", typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareCompound", typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareContrast", typing.Dict[builtins.str, typing.Any]]]]] = None,
        crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareFaceCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareFeatureCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareFitAndFill", typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareGoop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareGrayscale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareHsl", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareHsv", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfDimension", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfOrientation", typing.Dict[builtins.str, typing.Any]]]]] = None,
        im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareImQuery", typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareMaxColors", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareMirror", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareMonoHue", typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareOpacity", typing.Dict[builtins.str, typing.Any]]]]] = None,
        region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareRegionOfInterestCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareRelativeCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareRemoveColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareResize", typing.Dict[builtins.str, typing.Any]]]]] = None,
        rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareRotate", typing.Dict[builtins.str, typing.Any]]]]] = None,
        scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareScale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareShear", typing.Dict[builtins.str, typing.Any]]]]] = None,
        trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareTrim", typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareUnsharpMask", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param append: append block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        :param aspect_crop: aspect_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param crop: crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        :param face_crop: face_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        :param feature_crop: feature_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        :param fit_and_fill: fit_and_fill block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param im_query: im_query block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param region_of_interest_crop: region_of_interest_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        :param relative_crop: relative_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param resize: resize block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        :param rotate: rotate block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        :param scale: scale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param shear: shear block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        :param trim: trim block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__559d813fb88ce890e6b254a3c263ab4e5889ab3297033e8d293858a397486f41)
            check_type(argname="argument append", value=append, expected_type=type_hints["append"])
            check_type(argname="argument aspect_crop", value=aspect_crop, expected_type=type_hints["aspect_crop"])
            check_type(argname="argument background_color", value=background_color, expected_type=type_hints["background_color"])
            check_type(argname="argument blur", value=blur, expected_type=type_hints["blur"])
            check_type(argname="argument chroma_key", value=chroma_key, expected_type=type_hints["chroma_key"])
            check_type(argname="argument composite", value=composite, expected_type=type_hints["composite"])
            check_type(argname="argument compound", value=compound, expected_type=type_hints["compound"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument crop", value=crop, expected_type=type_hints["crop"])
            check_type(argname="argument face_crop", value=face_crop, expected_type=type_hints["face_crop"])
            check_type(argname="argument feature_crop", value=feature_crop, expected_type=type_hints["feature_crop"])
            check_type(argname="argument fit_and_fill", value=fit_and_fill, expected_type=type_hints["fit_and_fill"])
            check_type(argname="argument goop", value=goop, expected_type=type_hints["goop"])
            check_type(argname="argument grayscale", value=grayscale, expected_type=type_hints["grayscale"])
            check_type(argname="argument hsl", value=hsl, expected_type=type_hints["hsl"])
            check_type(argname="argument hsv", value=hsv, expected_type=type_hints["hsv"])
            check_type(argname="argument if_dimension", value=if_dimension, expected_type=type_hints["if_dimension"])
            check_type(argname="argument if_orientation", value=if_orientation, expected_type=type_hints["if_orientation"])
            check_type(argname="argument im_query", value=im_query, expected_type=type_hints["im_query"])
            check_type(argname="argument max_colors", value=max_colors, expected_type=type_hints["max_colors"])
            check_type(argname="argument mirror", value=mirror, expected_type=type_hints["mirror"])
            check_type(argname="argument mono_hue", value=mono_hue, expected_type=type_hints["mono_hue"])
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument region_of_interest_crop", value=region_of_interest_crop, expected_type=type_hints["region_of_interest_crop"])
            check_type(argname="argument relative_crop", value=relative_crop, expected_type=type_hints["relative_crop"])
            check_type(argname="argument remove_color", value=remove_color, expected_type=type_hints["remove_color"])
            check_type(argname="argument resize", value=resize, expected_type=type_hints["resize"])
            check_type(argname="argument rotate", value=rotate, expected_type=type_hints["rotate"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument shear", value=shear, expected_type=type_hints["shear"])
            check_type(argname="argument trim", value=trim, expected_type=type_hints["trim"])
            check_type(argname="argument unsharp_mask", value=unsharp_mask, expected_type=type_hints["unsharp_mask"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if append is not None:
            self._values["append"] = append
        if aspect_crop is not None:
            self._values["aspect_crop"] = aspect_crop
        if background_color is not None:
            self._values["background_color"] = background_color
        if blur is not None:
            self._values["blur"] = blur
        if chroma_key is not None:
            self._values["chroma_key"] = chroma_key
        if composite is not None:
            self._values["composite"] = composite
        if compound is not None:
            self._values["compound"] = compound
        if contrast is not None:
            self._values["contrast"] = contrast
        if crop is not None:
            self._values["crop"] = crop
        if face_crop is not None:
            self._values["face_crop"] = face_crop
        if feature_crop is not None:
            self._values["feature_crop"] = feature_crop
        if fit_and_fill is not None:
            self._values["fit_and_fill"] = fit_and_fill
        if goop is not None:
            self._values["goop"] = goop
        if grayscale is not None:
            self._values["grayscale"] = grayscale
        if hsl is not None:
            self._values["hsl"] = hsl
        if hsv is not None:
            self._values["hsv"] = hsv
        if if_dimension is not None:
            self._values["if_dimension"] = if_dimension
        if if_orientation is not None:
            self._values["if_orientation"] = if_orientation
        if im_query is not None:
            self._values["im_query"] = im_query
        if max_colors is not None:
            self._values["max_colors"] = max_colors
        if mirror is not None:
            self._values["mirror"] = mirror
        if mono_hue is not None:
            self._values["mono_hue"] = mono_hue
        if opacity is not None:
            self._values["opacity"] = opacity
        if region_of_interest_crop is not None:
            self._values["region_of_interest_crop"] = region_of_interest_crop
        if relative_crop is not None:
            self._values["relative_crop"] = relative_crop
        if remove_color is not None:
            self._values["remove_color"] = remove_color
        if resize is not None:
            self._values["resize"] = resize
        if rotate is not None:
            self._values["rotate"] = rotate
        if scale is not None:
            self._values["scale"] = scale
        if shear is not None:
            self._values["shear"] = shear
        if trim is not None:
            self._values["trim"] = trim
        if unsharp_mask is not None:
            self._values["unsharp_mask"] = unsharp_mask

    @builtins.property
    def append(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareAppend"]]]:
        '''append block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        '''
        result = self._values.get("append")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareAppend"]]], result)

    @builtins.property
    def aspect_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareAspectCrop"]]]:
        '''aspect_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        '''
        result = self._values.get("aspect_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareAspectCrop"]]], result)

    @builtins.property
    def background_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareBackgroundColor"]]]:
        '''background_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        '''
        result = self._values.get("background_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareBackgroundColor"]]], result)

    @builtins.property
    def blur(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareBlur"]]]:
        '''blur block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        '''
        result = self._values.get("blur")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareBlur"]]], result)

    @builtins.property
    def chroma_key(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareChromaKey"]]]:
        '''chroma_key block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        '''
        result = self._values.get("chroma_key")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareChromaKey"]]], result)

    @builtins.property
    def composite(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareComposite"]]]:
        '''composite block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        '''
        result = self._values.get("composite")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareComposite"]]], result)

    @builtins.property
    def compound(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareCompound"]]]:
        '''compound block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        '''
        result = self._values.get("compound")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareCompound"]]], result)

    @builtins.property
    def contrast(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareContrast"]]]:
        '''contrast block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareContrast"]]], result)

    @builtins.property
    def crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareCrop"]]]:
        '''crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        '''
        result = self._values.get("crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareCrop"]]], result)

    @builtins.property
    def face_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareFaceCrop"]]]:
        '''face_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        '''
        result = self._values.get("face_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareFaceCrop"]]], result)

    @builtins.property
    def feature_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareFeatureCrop"]]]:
        '''feature_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        '''
        result = self._values.get("feature_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareFeatureCrop"]]], result)

    @builtins.property
    def fit_and_fill(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareFitAndFill"]]]:
        '''fit_and_fill block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        '''
        result = self._values.get("fit_and_fill")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareFitAndFill"]]], result)

    @builtins.property
    def goop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareGoop"]]]:
        '''goop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        '''
        result = self._values.get("goop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareGoop"]]], result)

    @builtins.property
    def grayscale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareGrayscale"]]]:
        '''grayscale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        '''
        result = self._values.get("grayscale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareGrayscale"]]], result)

    @builtins.property
    def hsl(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareHsl"]]]:
        '''hsl block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        '''
        result = self._values.get("hsl")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareHsl"]]], result)

    @builtins.property
    def hsv(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareHsv"]]]:
        '''hsv block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        '''
        result = self._values.get("hsv")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareHsv"]]], result)

    @builtins.property
    def if_dimension(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfDimension"]]]:
        '''if_dimension block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        '''
        result = self._values.get("if_dimension")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfDimension"]]], result)

    @builtins.property
    def if_orientation(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfOrientation"]]]:
        '''if_orientation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        '''
        result = self._values.get("if_orientation")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfOrientation"]]], result)

    @builtins.property
    def im_query(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareImQuery"]]]:
        '''im_query block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        '''
        result = self._values.get("im_query")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareImQuery"]]], result)

    @builtins.property
    def max_colors(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareMaxColors"]]]:
        '''max_colors block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        '''
        result = self._values.get("max_colors")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareMaxColors"]]], result)

    @builtins.property
    def mirror(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareMirror"]]]:
        '''mirror block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        '''
        result = self._values.get("mirror")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareMirror"]]], result)

    @builtins.property
    def mono_hue(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareMonoHue"]]]:
        '''mono_hue block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        '''
        result = self._values.get("mono_hue")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareMonoHue"]]], result)

    @builtins.property
    def opacity(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareOpacity"]]]:
        '''opacity block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareOpacity"]]], result)

    @builtins.property
    def region_of_interest_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareRegionOfInterestCrop"]]]:
        '''region_of_interest_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        '''
        result = self._values.get("region_of_interest_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareRegionOfInterestCrop"]]], result)

    @builtins.property
    def relative_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareRelativeCrop"]]]:
        '''relative_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        '''
        result = self._values.get("relative_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareRelativeCrop"]]], result)

    @builtins.property
    def remove_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareRemoveColor"]]]:
        '''remove_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        '''
        result = self._values.get("remove_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareRemoveColor"]]], result)

    @builtins.property
    def resize(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareResize"]]]:
        '''resize block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        '''
        result = self._values.get("resize")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareResize"]]], result)

    @builtins.property
    def rotate(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareRotate"]]]:
        '''rotate block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        '''
        result = self._values.get("rotate")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareRotate"]]], result)

    @builtins.property
    def scale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareScale"]]]:
        '''scale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareScale"]]], result)

    @builtins.property
    def shear(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareShear"]]]:
        '''shear block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        '''
        result = self._values.get("shear")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareShear"]]], result)

    @builtins.property
    def trim(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareTrim"]]]:
        '''trim block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        '''
        result = self._values.get("trim")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareTrim"]]], result)

    @builtins.property
    def unsharp_mask(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareUnsharpMask"]]]:
        '''unsharp_mask block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        result = self._values.get("unsharp_mask")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareUnsharpMask"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquare(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareAppend",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_priority": "gravityPriority",
        "gravity_priority_var": "gravityPriorityVar",
        "gravity_var": "gravityVar",
        "preserve_minor_dimension": "preserveMinorDimension",
        "preserve_minor_dimension_var": "preserveMinorDimensionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareAppend:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareAppendImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_priority: typing.Optional[builtins.str] = None,
        gravity_priority_var: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        preserve_minor_dimension: typing.Optional[builtins.str] = None,
        preserve_minor_dimension_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Specifies where to place the ``image`` relative to the source image. The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_priority: Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal. The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority DataAkamaiImagingPolicyImage#gravity_priority}
        :param gravity_priority_var: Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal. The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority_var DataAkamaiImagingPolicyImage#gravity_priority_var}
        :param gravity_var: Specifies where to place the ``image`` relative to the source image. The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param preserve_minor_dimension: Whether to preserve the source image's minor dimension, ``false`` by default. The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension DataAkamaiImagingPolicyImage#preserve_minor_dimension}
        :param preserve_minor_dimension_var: Whether to preserve the source image's minor dimension, ``false`` by default. The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension_var DataAkamaiImagingPolicyImage#preserve_minor_dimension_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareAppendImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__83d931805d271f85db322985ad5f6762c1f9b6f5dc59e8d9ee06721c3ed3804b)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_priority", value=gravity_priority, expected_type=type_hints["gravity_priority"])
            check_type(argname="argument gravity_priority_var", value=gravity_priority_var, expected_type=type_hints["gravity_priority_var"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument preserve_minor_dimension", value=preserve_minor_dimension, expected_type=type_hints["preserve_minor_dimension"])
            check_type(argname="argument preserve_minor_dimension_var", value=preserve_minor_dimension_var, expected_type=type_hints["preserve_minor_dimension_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_priority is not None:
            self._values["gravity_priority"] = gravity_priority
        if gravity_priority_var is not None:
            self._values["gravity_priority_var"] = gravity_priority_var
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if preserve_minor_dimension is not None:
            self._values["preserve_minor_dimension"] = preserve_minor_dimension
        if preserve_minor_dimension_var is not None:
            self._values["preserve_minor_dimension_var"] = preserve_minor_dimension_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareAppendImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareAppendImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Specifies where to place the ``image`` relative to the source image.

        The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_priority(self) -> typing.Optional[builtins.str]:
        '''Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal.

        The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority DataAkamaiImagingPolicyImage#gravity_priority}
        '''
        result = self._values.get("gravity_priority")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_priority_var(self) -> typing.Optional[builtins.str]:
        '''Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal.

        The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority_var DataAkamaiImagingPolicyImage#gravity_priority_var}
        '''
        result = self._values.get("gravity_priority_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Specifies where to place the ``image`` relative to the source image.

        The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def preserve_minor_dimension(self) -> typing.Optional[builtins.str]:
        '''Whether to preserve the source image's minor dimension, ``false`` by default.

        The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension DataAkamaiImagingPolicyImage#preserve_minor_dimension}
        '''
        result = self._values.get("preserve_minor_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def preserve_minor_dimension_var(self) -> typing.Optional[builtins.str]:
        '''Whether to preserve the source image's minor dimension, ``false`` by default.

        The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension_var DataAkamaiImagingPolicyImage#preserve_minor_dimension_var}
        '''
        result = self._values.get("preserve_minor_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareAppend(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareAppendImage",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareAppendImage:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareAppendImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareAppendImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareAppendImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c1770619f76bcfea49ee55b7f285792ca2cc94ac3bcfe2bcd19fafde2e421abd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareAppendImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareAppendImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareAppendImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e256d9b399456e03e6cb9b06c1fe7d8861b080e3ea4ca5745065aaa4e006af1e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareAppendList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareAppendList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__53e8548bb1c9dcd07db5b1fed2081a055b125dc7eec0fba4b73b332d3197ce5f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareAppendOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e06e0925acead52702a1af867385b8a3dc6e10a1112d0a31b17d31d2ed2bda7)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareAppendOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__695a7d2e577285144b9776842b5755ae58d14a6b71048716e6914159f4ec29b4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a75af49bebdf2d79afb103abf1f72f905e970b9cbf6482a420366d73f4d5fc8d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7dc08797fbb2fde246cdc5bd2316ebe343231178d8130fc1a2a8497435376b6f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareAppend]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareAppend]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareAppend]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d5e1a771aa1cd5354376e7d47eb0fcb7fe4699949f25599d1098de3df34d807a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareAppendOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareAppendOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__040c65469ba9172cf7c0ce74d3a879ca83949f2ef172f0fe881358b843c82e96)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareAppendImage()

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityPriority")
    def reset_gravity_priority(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityPriority", []))

    @jsii.member(jsii_name="resetGravityPriorityVar")
    def reset_gravity_priority_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityPriorityVar", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPreserveMinorDimension")
    def reset_preserve_minor_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPreserveMinorDimension", []))

    @jsii.member(jsii_name="resetPreserveMinorDimensionVar")
    def reset_preserve_minor_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPreserveMinorDimensionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareAppendImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareAppendImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityInput")
    def gravity_priority_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityPriorityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityVarInput")
    def gravity_priority_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityPriorityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareAppendImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareAppendImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionInput")
    def preserve_minor_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "preserveMinorDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionVarInput")
    def preserve_minor_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "preserveMinorDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__20b95be2ddaa2c2a4d84ab8cf2205210ed88d0c2735fbc4066d335a30bcf49ba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityPriority")
    def gravity_priority(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityPriority"))

    @gravity_priority.setter
    def gravity_priority(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5c3044726cbe1242f7f4c649a743f1a87000529d19dc8a280493e278a045971f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityPriority", value)

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityVar")
    def gravity_priority_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityPriorityVar"))

    @gravity_priority_var.setter
    def gravity_priority_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e874a8dcc68edc22038f1c259fd214bd43c31d7d4dcc5877b92873b1a6d05a34)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityPriorityVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b0136122e4913b4310ebdb17a51c936126de821d4f165d2712b1641007e4e0a2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimension")
    def preserve_minor_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "preserveMinorDimension"))

    @preserve_minor_dimension.setter
    def preserve_minor_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f8752f17331825480fe19a12b4c2ddb9f97739710d15a0ef131cec8c8e39d543)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "preserveMinorDimension", value)

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionVar")
    def preserve_minor_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "preserveMinorDimensionVar"))

    @preserve_minor_dimension_var.setter
    def preserve_minor_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4d10bcdc027bc86808c5867a831ebb7ad3312c85fd645e3e6a5be3f916f0a48f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "preserveMinorDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareAppend]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareAppend]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareAppend]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0cb9e4ef1db73da845c586e204ea4b03ead14c706af6bb821bc358b5bca0bf7a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareAspectCrop",
    jsii_struct_bases=[],
    name_mapping={
        "allow_expansion": "allowExpansion",
        "allow_expansion_var": "allowExpansionVar",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareAspectCrop:
    def __init__(
        self,
        *,
        allow_expansion: typing.Optional[builtins.str] = None,
        allow_expansion_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_expansion: Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image. Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        :param allow_expansion_var: Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image. Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        :param height: The height term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The width term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        :param x_position: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__83e7e84c5ce4d19d692861fe3a796fd599b46122ee7ecbc90fab64f3cba53df5)
            check_type(argname="argument allow_expansion", value=allow_expansion, expected_type=type_hints["allow_expansion"])
            check_type(argname="argument allow_expansion_var", value=allow_expansion_var, expected_type=type_hints["allow_expansion_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if allow_expansion is not None:
            self._values["allow_expansion"] = allow_expansion
        if allow_expansion_var is not None:
            self._values["allow_expansion_var"] = allow_expansion_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def allow_expansion(self) -> typing.Optional[builtins.str]:
        '''Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image.

        Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        '''
        result = self._values.get("allow_expansion")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def allow_expansion_var(self) -> typing.Optional[builtins.str]:
        '''Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image.

        Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        '''
        result = self._values.get("allow_expansion_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareAspectCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareAspectCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareAspectCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a4da0441bcb31f48d78259ce66e75457ad37f0d204750b286060ed304332405b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareAspectCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0212279d98672ecef4d00e80f90ad8ad1004ef7d42bd0064e22e56a363c462d1)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareAspectCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__495de28ea2337ffa248a513373df67564688915e4dd20f6c414d62eb30183c09)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eb7de27609500414de4a47a8badd577d751f05857db0262178a01223e9806dd4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0447a4fba0bc5f08cb07ca35c1877ef5ccc4dbbc42821a4f7a8507e7ea6fc8e3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareAspectCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareAspectCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareAspectCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__25103d06298e215204fa47560d65155e6444e25e29594bd4bf2fae63bd9bfa21)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareAspectCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareAspectCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f0e249ab822d20433db2864219ff9e0588ee0b65dcd68a1819922f9ec6f2f9b3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAllowExpansion")
    def reset_allow_expansion(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansion", []))

    @jsii.member(jsii_name="resetAllowExpansionVar")
    def reset_allow_expansion_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansionVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionInput")
    def allow_expansion_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVarInput")
    def allow_expansion_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansion")
    def allow_expansion(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansion"))

    @allow_expansion.setter
    def allow_expansion(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__797a49a6148ab64bcdf030649ee020b34b9362382e99e25c517d6a00baab0d17)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansion", value)

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVar")
    def allow_expansion_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansionVar"))

    @allow_expansion_var.setter
    def allow_expansion_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3488b2c4928d1dbf8a64ca61c1a8de1d038272c9982e98a9a73b166595533006)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansionVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3fad6041f8f06e6c0ee4c69f9d8ad88e8b45f7c2e986ea882b0b4f48d4fc4f0c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__34dc8389543df41b7af6d6737eac03230030bc995922ce4d914e9ca7e0bd239f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__427920a4d50d4c9b2fd281616907f8a4edfc28437bad7d35aed4367f95b5f1e7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d094d72da18232656eb07bbc546e0c20883293b216cb0031c6a4b7ec2d48fcf7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__65692588f4aef3afd0d556a9b0437f732de2473858daf05b7ac210880b1de78d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5155ae17ab709ee07f7051619aa59c358783a6d54d66319a9d024b3b4bd5ddca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3499444fc0c01f84ed7ceb1f5945101cd5e0bc671b8e47325c5686bab30331e7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__946373a454fe6d77ab13a59395c3e2e0dcc535c30d794b2cc02518195bb225f9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareAspectCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareAspectCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareAspectCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__202d66a639b22b5edfa48a525223b67560e286f21ccf7f2f08afb738b484132c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareBackgroundColor",
    jsii_struct_bases=[],
    name_mapping={"color": "color", "color_var": "colorVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareBackgroundColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__33d866507f40e35b1ef2541d35a8e775f3f821aa753fdd29ac72b2ed92960f80)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareBackgroundColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareBackgroundColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareBackgroundColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eebe8b5244614e1e350d5597c15a9238ad16d0ede71f6fe495e5ec6d379b48d8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareBackgroundColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb7e606d8dd450423776f26129edd6c8d3a52667f2485155c73b563950a64dca)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareBackgroundColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__10a2c5fc6a0dbbc0bf01d14d885a28114f88d26fd7305961fc64d6c017c15aed)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__73a7f91fad37555c069179ca8b207ca3593139ed70e98c0a7cfa1f2b36112127)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__81957b37f5c605143db9ab1f521110a32781691efa93259d7ca585b49e540b2e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareBackgroundColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareBackgroundColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0a3962aab104e5e9be11fa3770908db95d4c6f31a93f049f262790a4df370426)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareBackgroundColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareBackgroundColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0fdf36d6cc70251e38c960b24c7bce128148f87b1450111c603f81e82364cf9f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__186fdd7f4b3dd44698a5e86a318cb2eebf918c91c258d6d8290a09eba2a08b3c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aab2d344fe5359305a4d71b8e98b8e319acb179f3b9560cd559b0a8d79a8565e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareBackgroundColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareBackgroundColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareBackgroundColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5786c521db1a1b8a4f8c5623c8d71ad5ffcbeb5a89af6dd12d4ed2324b968fd2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareBlur",
    jsii_struct_bases=[],
    name_mapping={"sigma": "sigma", "sigma_var": "sigmaVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareBlur:
    def __init__(
        self,
        *,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param sigma: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2102282ace4782ad1c638fad0c2bfe323caa2e395d8b204e5686f285cf1c9e72)
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareBlur(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareBlurList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareBlurList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e08c202230675011225d64ea0b17131c36be21bc1c28b989a9161ffbe3f777a4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareBlurOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d5a09272c8a1ffe75212ae0e13a3f60e18d621fb73d5d7e550d19dcc47f7629)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareBlurOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7ae1449f6ad5efdeba6bba2707160f7dc15edcd835429cf4efaa2d9d68185569)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ec10bc39e1431c219d7f0a612cc4dbd1d0b832981085113a6196bbec5bdf4b1b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__479aa8d55366b214e5483a428dcbe2c8c2905b1a98523ec876dcfcce6a2cfc93)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareBlur]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareBlur]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b6f4e01d5aa5b90af50d267a180df511fd2add3ca086f7eaf61409960772d52f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareBlurOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareBlurOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__99328d82472a2a0ffc2a3d67548cda8e7cb902ecd6c1d7b86908049460bfad48)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8ee250626f157669b9040de9c766c4fcb128f5e78629e84c1a77c78692121263)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1a010b62d87cea64b542f08986abedd51cfa8f3d943eb12553be4e5124638476)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareBlur]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareBlur]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareBlur]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8e447e821c352a4929a524855f96724e4ef2ee04692d33b9bd345ef70891616b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareChromaKey",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_feather": "hueFeather",
        "hue_feather_var": "hueFeatherVar",
        "hue_tolerance": "hueTolerance",
        "hue_tolerance_var": "hueToleranceVar",
        "hue_var": "hueVar",
        "lightness_feather": "lightnessFeather",
        "lightness_feather_var": "lightnessFeatherVar",
        "lightness_tolerance": "lightnessTolerance",
        "lightness_tolerance_var": "lightnessToleranceVar",
        "saturation_feather": "saturationFeather",
        "saturation_feather_var": "saturationFeatherVar",
        "saturation_tolerance": "saturationTolerance",
        "saturation_tolerance_var": "saturationToleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareChromaKey:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_feather: typing.Optional[builtins.str] = None,
        hue_feather_var: typing.Optional[builtins.str] = None,
        hue_tolerance: typing.Optional[builtins.str] = None,
        hue_tolerance_var: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness_feather: typing.Optional[builtins.str] = None,
        lightness_feather_var: typing.Optional[builtins.str] = None,
        lightness_tolerance: typing.Optional[builtins.str] = None,
        lightness_tolerance_var: typing.Optional[builtins.str] = None,
        saturation_feather: typing.Optional[builtins.str] = None,
        saturation_feather_var: typing.Optional[builtins.str] = None,
        saturation_tolerance: typing.Optional[builtins.str] = None,
        saturation_tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_feather: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        :param hue_feather_var: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        :param hue_tolerance: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        :param hue_tolerance_var: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        :param hue_var: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness_feather: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        :param lightness_feather_var: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        :param lightness_tolerance: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        :param lightness_tolerance_var: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        :param saturation_feather: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        :param saturation_feather_var: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        :param saturation_tolerance: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        :param saturation_tolerance_var: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__966786363417dbd5c362b21556b8022ab4213bf22f0cd80fb3f05b4da3d86452)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_feather", value=hue_feather, expected_type=type_hints["hue_feather"])
            check_type(argname="argument hue_feather_var", value=hue_feather_var, expected_type=type_hints["hue_feather_var"])
            check_type(argname="argument hue_tolerance", value=hue_tolerance, expected_type=type_hints["hue_tolerance"])
            check_type(argname="argument hue_tolerance_var", value=hue_tolerance_var, expected_type=type_hints["hue_tolerance_var"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness_feather", value=lightness_feather, expected_type=type_hints["lightness_feather"])
            check_type(argname="argument lightness_feather_var", value=lightness_feather_var, expected_type=type_hints["lightness_feather_var"])
            check_type(argname="argument lightness_tolerance", value=lightness_tolerance, expected_type=type_hints["lightness_tolerance"])
            check_type(argname="argument lightness_tolerance_var", value=lightness_tolerance_var, expected_type=type_hints["lightness_tolerance_var"])
            check_type(argname="argument saturation_feather", value=saturation_feather, expected_type=type_hints["saturation_feather"])
            check_type(argname="argument saturation_feather_var", value=saturation_feather_var, expected_type=type_hints["saturation_feather_var"])
            check_type(argname="argument saturation_tolerance", value=saturation_tolerance, expected_type=type_hints["saturation_tolerance"])
            check_type(argname="argument saturation_tolerance_var", value=saturation_tolerance_var, expected_type=type_hints["saturation_tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_feather is not None:
            self._values["hue_feather"] = hue_feather
        if hue_feather_var is not None:
            self._values["hue_feather_var"] = hue_feather_var
        if hue_tolerance is not None:
            self._values["hue_tolerance"] = hue_tolerance
        if hue_tolerance_var is not None:
            self._values["hue_tolerance_var"] = hue_tolerance_var
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness_feather is not None:
            self._values["lightness_feather"] = lightness_feather
        if lightness_feather_var is not None:
            self._values["lightness_feather_var"] = lightness_feather_var
        if lightness_tolerance is not None:
            self._values["lightness_tolerance"] = lightness_tolerance
        if lightness_tolerance_var is not None:
            self._values["lightness_tolerance_var"] = lightness_tolerance_var
        if saturation_feather is not None:
            self._values["saturation_feather"] = saturation_feather
        if saturation_feather_var is not None:
            self._values["saturation_feather_var"] = saturation_feather_var
        if saturation_tolerance is not None:
            self._values["saturation_tolerance"] = saturation_tolerance
        if saturation_tolerance_var is not None:
            self._values["saturation_tolerance_var"] = saturation_tolerance_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        '''
        result = self._values.get("hue_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        '''
        result = self._values.get("hue_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        '''
        result = self._values.get("hue_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        '''
        result = self._values.get("hue_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        '''
        result = self._values.get("lightness_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        '''
        result = self._values.get("lightness_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        '''
        result = self._values.get("lightness_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        '''
        result = self._values.get("lightness_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        '''
        result = self._values.get("saturation_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        '''
        result = self._values.get("saturation_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        '''
        result = self._values.get("saturation_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        result = self._values.get("saturation_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareChromaKey(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareChromaKeyList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareChromaKeyList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__78f643e086e69795074dec0a4404779072be580edef74c77112f21bfd377ee91)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareChromaKeyOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1e511424a7522666ad981aa0c449f2b2bd8543f9664affbcbde130b85db2ec98)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareChromaKeyOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3fa696449f7b4a2732044b35e0468939e9314dd2d0a05f45487e564e7ac3ff6a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__629bf2c3513ccf174220a5cad2b72a8a25c2331864bfc2d77f095e140f6177a1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__68401ce50e116908d2af4650afae8c22e2946bdc3a3fead530c0a1469ff3e0ce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareChromaKey]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareChromaKey]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ebd412c5561ee24501386b73c708caf5261bb15b4509d8f6ffca866342fc2cfc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareChromaKeyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareChromaKeyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7f21354801dde1ec8dc18e637e5438e1a100a59ebf3f475523461936b3169fb4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueFeather")
    def reset_hue_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeather", []))

    @jsii.member(jsii_name="resetHueFeatherVar")
    def reset_hue_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeatherVar", []))

    @jsii.member(jsii_name="resetHueTolerance")
    def reset_hue_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueTolerance", []))

    @jsii.member(jsii_name="resetHueToleranceVar")
    def reset_hue_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueToleranceVar", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightnessFeather")
    def reset_lightness_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeather", []))

    @jsii.member(jsii_name="resetLightnessFeatherVar")
    def reset_lightness_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeatherVar", []))

    @jsii.member(jsii_name="resetLightnessTolerance")
    def reset_lightness_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessTolerance", []))

    @jsii.member(jsii_name="resetLightnessToleranceVar")
    def reset_lightness_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessToleranceVar", []))

    @jsii.member(jsii_name="resetSaturationFeather")
    def reset_saturation_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeather", []))

    @jsii.member(jsii_name="resetSaturationFeatherVar")
    def reset_saturation_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeatherVar", []))

    @jsii.member(jsii_name="resetSaturationTolerance")
    def reset_saturation_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationTolerance", []))

    @jsii.member(jsii_name="resetSaturationToleranceVar")
    def reset_saturation_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherInput")
    def hue_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVarInput")
    def hue_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceInput")
    def hue_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVarInput")
    def hue_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherInput")
    def lightness_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVarInput")
    def lightness_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceInput")
    def lightness_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVarInput")
    def lightness_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherInput")
    def saturation_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVarInput")
    def saturation_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceInput")
    def saturation_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVarInput")
    def saturation_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__401bbb89b4d5767cd632ea549e1cceaf28133fbb3b2dd70572b05f2a8cf0670e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeather")
    def hue_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeather"))

    @hue_feather.setter
    def hue_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__45f401f909a6d6172475edd6512e9287e9e8803642f0db76d387511d2ab40bb6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeather", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVar")
    def hue_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeatherVar"))

    @hue_feather_var.setter
    def hue_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__644ef49c23b25fe5b85bba311261400a1d34bf1a382f65e218a967fa0b31edf3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueTolerance")
    def hue_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueTolerance"))

    @hue_tolerance.setter
    def hue_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4142b71d6ed98b687b8f0039767a789a020499f32d15c11f0dfd797e0758918e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVar")
    def hue_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueToleranceVar"))

    @hue_tolerance_var.setter
    def hue_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f98d9c76c07a368f95809c34a1361cbdbd272a953f146521b6e47eb8ddd306fe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__30ed17c3abe2e291467584f72b65896c0a75c31d8f093f4508c8b601ae96e3e4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeather")
    def lightness_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeather"))

    @lightness_feather.setter
    def lightness_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c375c97f1662357d04429c3388996c556cb2f28b2e3bd239836cb5ae7949a705)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeather", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVar")
    def lightness_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeatherVar"))

    @lightness_feather_var.setter
    def lightness_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c3b1698a374045d0ff3bda95014b3ca5e0810682e0dca9ecb10636fffff988b1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessTolerance")
    def lightness_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessTolerance"))

    @lightness_tolerance.setter
    def lightness_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__719936e2c7a87f9e7ab69db9799e713f97062a599306675c11ec2f456e415b83)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVar")
    def lightness_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessToleranceVar"))

    @lightness_tolerance_var.setter
    def lightness_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0d94ffe6430b827791c30c95e0318f05c9c79d9eabf81aeda296b8b030001399)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeather")
    def saturation_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeather"))

    @saturation_feather.setter
    def saturation_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__124af56433ba93c84c19a4b50b2dea76efbb2c507b5edf06f3e92a37c818ed16)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeather", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVar")
    def saturation_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeatherVar"))

    @saturation_feather_var.setter
    def saturation_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eb2e0465f8f1815c2bd25c5922dced885b12ce1c67486a7c1c296f59a52ca19e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationTolerance")
    def saturation_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationTolerance"))

    @saturation_tolerance.setter
    def saturation_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__18996fe359b36f45e3beb37c644f3a71151a976fa4025776f21142ba1b0e2303)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVar")
    def saturation_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationToleranceVar"))

    @saturation_tolerance_var.setter
    def saturation_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__db2a0deceb023469ae597abbefda65c764f3be149385548ab02ffcb062e6922d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareChromaKey]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareChromaKey]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareChromaKey]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5c00734aa8950e73cf9160c4ed301306df2de4ba6e88f7de032c18b54e211946)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareComposite",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "placement": "placement",
        "placement_var": "placementVar",
        "scale": "scale",
        "scale_dimension": "scaleDimension",
        "scale_dimension_var": "scaleDimensionVar",
        "scale_var": "scaleVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareComposite:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareCompositeImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        placement: typing.Optional[builtins.str] = None,
        placement_var: typing.Optional[builtins.str] = None,
        scale: typing.Optional[builtins.str] = None,
        scale_dimension: typing.Optional[builtins.str] = None,
        scale_dimension_var: typing.Optional[builtins.str] = None,
        scale_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param placement: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        :param placement_var: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        :param scale: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param scale_dimension: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        :param scale_dimension_var: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        :param scale_var: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        :param x_position: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareCompositeImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1a87f9948aa24d863788f96e8e34a6ae27cbe4c92f945a6b45ecb9f92590c0a6)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument placement", value=placement, expected_type=type_hints["placement"])
            check_type(argname="argument placement_var", value=placement_var, expected_type=type_hints["placement_var"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument scale_dimension", value=scale_dimension, expected_type=type_hints["scale_dimension"])
            check_type(argname="argument scale_dimension_var", value=scale_dimension_var, expected_type=type_hints["scale_dimension_var"])
            check_type(argname="argument scale_var", value=scale_var, expected_type=type_hints["scale_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if placement is not None:
            self._values["placement"] = placement
        if placement_var is not None:
            self._values["placement_var"] = placement_var
        if scale is not None:
            self._values["scale"] = scale
        if scale_dimension is not None:
            self._values["scale_dimension"] = scale_dimension
        if scale_dimension_var is not None:
            self._values["scale_dimension_var"] = scale_dimension_var
        if scale_var is not None:
            self._values["scale_var"] = scale_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareCompositeImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareCompositeImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        '''
        result = self._values.get("placement")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement_var(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        '''
        result = self._values.get("placement_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        '''
        result = self._values.get("scale_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        '''
        result = self._values.get("scale_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        '''
        result = self._values.get("scale_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareComposite(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareCompositeImage",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareCompositeImage:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareCompositeImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareCompositeImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareCompositeImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ba3bc1a234cf01a4251109643ac784607bda833146e35ab37ab5ffc9f5fafcd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareCompositeImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareCompositeImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a67bbb17f16c52d655eb93d8e12325e984693db90fd050043279141abb5cd8ff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareCompositeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareCompositeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3c621226bf6fdf08a7efc13a10144ee8fe77c16d91b4ae0e6c641ded7f5c7389)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareCompositeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a0b241595b9eb1baa070233028ba46a5a0b3f4ab1337a5424a29c79d289e3a07)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareCompositeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f9290a62b497c247a2bbcc0386941e4c6d1d0dd28a9b8826e76171a7663a09f7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e61254fc181442ad98b93c5440e41b09da88418a5f023880890667d984b4f15c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ef01911f94c00de9cc2222c195ef2fc3f636a13b4e59a89bd1371b781fd24c49)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareComposite]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareComposite]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9dffec34481b54f454dae5702f557c9d6fe8938507927fbe6a203703e1f0a81d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareCompositeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareCompositeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2c3771232d32a1fe8a1c42fae397c181ed4235c64503ae2afd969adb16cd379e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareCompositeImage()

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPlacement")
    def reset_placement(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacement", []))

    @jsii.member(jsii_name="resetPlacementVar")
    def reset_placement_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacementVar", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetScaleDimension")
    def reset_scale_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimension", []))

    @jsii.member(jsii_name="resetScaleDimensionVar")
    def reset_scale_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimensionVar", []))

    @jsii.member(jsii_name="resetScaleVar")
    def reset_scale_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareCompositeImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareCompositeImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareCompositeImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="placementInput")
    def placement_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementInput"))

    @builtins.property
    @jsii.member(jsii_name="placementVarInput")
    def placement_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionInput")
    def scale_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVarInput")
    def scale_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleVarInput")
    def scale_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e5464b53acd47a1e1ff5861ecd952120c3f2b532960b114a5d8c46625f63e12f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__854b7e4d1a68876ba8528d9a60a5d73c1f82c9e43e75630b8b214c9770951842)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="placement")
    def placement(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placement"))

    @placement.setter
    def placement(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e99f4f450f7dc198a3e3a6c665e8807d39685eeba69f3704e6d7c9ea9294b79c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placement", value)

    @builtins.property
    @jsii.member(jsii_name="placementVar")
    def placement_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placementVar"))

    @placement_var.setter
    def placement_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__80c1346359ef898b8569d1eeb9f964b10f3bd5408fc44040e4340ef581f29179)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placementVar", value)

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scale"))

    @scale.setter
    def scale(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cbec1ac79f84064bcea809dad78e466734d9513e1e325276d7ef729adfdce074)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scale", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimension")
    def scale_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimension"))

    @scale_dimension.setter
    def scale_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__83ecb5a85b9dca81b4e369a08165a6663a2daf87dafbea1ac9a4e8b44ab4a553)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimension", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVar")
    def scale_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimensionVar"))

    @scale_dimension_var.setter
    def scale_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8c1c005f1801da79d1bfd76bc59be72a7ff45b1fa6df2761339a99be887c5116)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="scaleVar")
    def scale_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleVar"))

    @scale_var.setter
    def scale_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1ced1959b7d08a2c000ebe645f236972a707523719f8deb56278602abcddbec5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0b10f91ac709cfffb5fa345a17053b67271e7e7db67c77c2cd6e7f36a895927a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__90d507faabe7be4bce74bf8c91e00fed5a1a33f267551dab0f7db8dfae615b16)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e3986c19c5272beb491f18ae0384a3ab1d1d05993f9621b8c70086499601adcd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d621d4b146e768c00b3e69509820fd063a8dc89f5ad47e16858d2218c70abaed)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareComposite]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareComposite]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareComposite]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d95b2f7eab92afa0c5dd2bbc3cfe406fa9811c3c931cb226afa3b70699445a1b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareCompound",
    jsii_struct_bases=[],
    name_mapping={"transformations": "transformations"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareCompound:
    def __init__(
        self,
        *,
        transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param transformations: transformations block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a707c84b60ef641c4cd2fe8872a0f074c921d2df3fd6b82ab4e85e528a7a97e1)
            check_type(argname="argument transformations", value=transformations, expected_type=type_hints["transformations"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if transformations is not None:
            self._values["transformations"] = transformations

    @builtins.property
    def transformations(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareCompoundTransformations"]]]:
        '''transformations block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        result = self._values.get("transformations")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareCompoundTransformations"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareCompound(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareCompoundList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareCompoundList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ed6d9520aaa883d9f312b4662b15357e9ac7b8d4e3ecd3e38f6f99fb1b66da3d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareCompoundOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1363966c7056cda5eb30629f37a339a449bd1905640111d1cd55a82b1a6cd077)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareCompoundOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__26fc01931986427f511eab3afd30de15de002797b0cf19448a65540c263f7ee6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__58183d2e20a816451fbd952bef414491216ad0c711e8065a0cd6d2a1963400ab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__524cc98f16736bd921c592172ec51f8b82213aee513824516b993140f52a776d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareCompound]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareCompound]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5c40729978ac3f3829ad7071065d53e8fa7dc168b1e1bec0652a406b71f88b94)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareCompoundOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareCompoundOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__737aa92aa0b371fe797b1ddeaea303de534f3e6f20b2bdf61adf22e674690046)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformations")
    def put_transformations(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0e71b7370aa4400db364105165edcdaeb5b0aa70351c3b39d4c37453638e29f9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTransformations", [value]))

    @jsii.member(jsii_name="resetTransformations")
    def reset_transformations(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformations", []))

    @builtins.property
    @jsii.member(jsii_name="transformations")
    def transformations(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareCompoundTransformationsList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareCompoundTransformationsList", jsii.get(self, "transformations"))

    @builtins.property
    @jsii.member(jsii_name="transformationsInput")
    def transformations_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareCompoundTransformations"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareCompoundTransformations"]]], jsii.get(self, "transformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareCompound]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareCompound]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareCompound]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4de7b7a55e34fd9ab7050a0f0bd3d6fb405dc2927ae0e4b1d10bbb4d45389fe9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareCompoundTransformations",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareCompoundTransformations:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareCompoundTransformations(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareCompoundTransformationsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareCompoundTransformationsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__17a4a68b61dbfdcd287c1ba12753733def10f630b9440fd684dcaeef58d005a5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareCompoundTransformationsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6a1e6e522fd29e46b59b3ec4cbdc1be4e654902c991b4cf38acb962e5b0c044c)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareCompoundTransformationsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__78fe5ee7d3cb57ad5d3ff4bea09d202e88a9ec15535d7e8b931bcddbb0843a0b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__89cdcefb415061e7de8f5b531aeb5bcdf586acd7d25a04ba824be2b31ee54537)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__45b0ab46466c1a89835eace7d5101c337b6be4609743863b3e0686d72070a49b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareCompoundTransformations]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareCompoundTransformations]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareCompoundTransformations]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d1d45f541c5ddf39463627def4dc58c8aa464614c8b2bf372de9b76a783e6b40)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareCompoundTransformationsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareCompoundTransformationsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1e25fe5cdc51c2d524ad18f93308961fbe4244f9594e4834d3b839ae2c3b3949)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareCompoundTransformations]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareCompoundTransformations]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareCompoundTransformations]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1a9121bfa77cd411def7373fb7c58a32f2f9cf9b0de387ea4198e7697bec8e68)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareContrast",
    jsii_struct_bases=[],
    name_mapping={
        "brightness": "brightness",
        "brightness_var": "brightnessVar",
        "contrast": "contrast",
        "contrast_var": "contrastVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareContrast:
    def __init__(
        self,
        *,
        brightness: typing.Optional[builtins.str] = None,
        brightness_var: typing.Optional[builtins.str] = None,
        contrast: typing.Optional[builtins.str] = None,
        contrast_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param brightness: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        :param brightness_var: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        :param contrast: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param contrast_var: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7c8cfc22246d60022c5e47ee6d9b0b64e06771f1aa01b37aadd505ebcde36018)
            check_type(argname="argument brightness", value=brightness, expected_type=type_hints["brightness"])
            check_type(argname="argument brightness_var", value=brightness_var, expected_type=type_hints["brightness_var"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument contrast_var", value=contrast_var, expected_type=type_hints["contrast_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if brightness is not None:
            self._values["brightness"] = brightness
        if brightness_var is not None:
            self._values["brightness_var"] = brightness_var
        if contrast is not None:
            self._values["contrast"] = contrast
        if contrast_var is not None:
            self._values["contrast_var"] = contrast_var

    @builtins.property
    def brightness(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        '''
        result = self._values.get("brightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def brightness_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        '''
        result = self._values.get("brightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        result = self._values.get("contrast_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareContrast(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareContrastList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareContrastList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1ab0041b86f5089c0a0ab2b29009ce0054d614af539cf211e6b55e48523ed43a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareContrastOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa2cb232569ec218e86c9eed7c315c4d1397b2bdc5228a37605fd06fdef109c5)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareContrastOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0d5e90309707bb04645850cbc78f3c1806d7234ee994431de6556a42acea61b6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ec6ef12d5ca1e1d4559e8694570deb956a7a911538213159c8814bb305702497)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__305665c388af5d860b758a480258a8ace4b6dfe6d96a7a536987c45a0c323e2e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareContrast]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareContrast]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8809caf252acafccadaaea9365137780d441fcb864e23fc6540d576d898c47b5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareContrastOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareContrastOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__962184110ee435f5354d7611511869f4bc8f4c5452e6d398e5cfcde1b543b2b1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetBrightness")
    def reset_brightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightness", []))

    @jsii.member(jsii_name="resetBrightnessVar")
    def reset_brightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightnessVar", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetContrastVar")
    def reset_contrast_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrastVar", []))

    @builtins.property
    @jsii.member(jsii_name="brightnessInput")
    def brightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="brightnessVarInput")
    def brightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastVarInput")
    def contrast_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="brightness")
    def brightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightness"))

    @brightness.setter
    def brightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a0606c989358828e06299f5fdbe923b089e862b1981a1128c798184b4df1d0fb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightness", value)

    @builtins.property
    @jsii.member(jsii_name="brightnessVar")
    def brightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightnessVar"))

    @brightness_var.setter
    def brightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__06e13a0bec7836a4ada716f8571d3ddb6f9095957d36e3eea11922a9ebcfb2f1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrast"))

    @contrast.setter
    def contrast(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e5d8422a0004ec84d1c8dd421298371d30c2f4725d37291d0068028f91d022f3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrast", value)

    @builtins.property
    @jsii.member(jsii_name="contrastVar")
    def contrast_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrastVar"))

    @contrast_var.setter
    def contrast_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1906affbf3d29a7a6d359458a015e87370e5e683aa9128e31a002bbfbe662fe0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrastVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareContrast]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareContrast]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareContrast]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__14275b7f415a548555fafbbcec657709dd851f9cce6ab279729d52128c2a9765)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareCrop",
    jsii_struct_bases=[],
    name_mapping={
        "allow_expansion": "allowExpansion",
        "allow_expansion_var": "allowExpansionVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareCrop:
    def __init__(
        self,
        *,
        allow_expansion: typing.Optional[builtins.str] = None,
        allow_expansion_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_expansion: If cropping an area outside of the existing canvas, expands the image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        :param allow_expansion_var: If cropping an area outside of the existing canvas, expands the image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        :param gravity: Frame of reference for X and Y Positions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Frame of reference for X and Y Positions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The number of pixels to crop along the y-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The number of pixels to crop along the y-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The number of pixels to crop along the x-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The number of pixels to crop along the x-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        :param x_position: The x-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ce9921cc1a6d049f0ce3f755986a6b3cd96d8b9b5c57dc1bb792ee4e229fc95f)
            check_type(argname="argument allow_expansion", value=allow_expansion, expected_type=type_hints["allow_expansion"])
            check_type(argname="argument allow_expansion_var", value=allow_expansion_var, expected_type=type_hints["allow_expansion_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if allow_expansion is not None:
            self._values["allow_expansion"] = allow_expansion
        if allow_expansion_var is not None:
            self._values["allow_expansion_var"] = allow_expansion_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def allow_expansion(self) -> typing.Optional[builtins.str]:
        '''If cropping an area outside of the existing canvas, expands the image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        '''
        result = self._values.get("allow_expansion")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def allow_expansion_var(self) -> typing.Optional[builtins.str]:
        '''If cropping an area outside of the existing canvas, expands the image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        '''
        result = self._values.get("allow_expansion_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Frame of reference for X and Y Positions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Frame of reference for X and Y Positions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the y-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the y-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the x-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the x-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__09c84efdab57b879c50ae4ffded402ca1ee0e0c5aa12755b58dc36afa2e071cb)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__06668ed24eda0e68337c2d8b83e6d1343cf1a3abc0f2f56ff88850e4c1bbfc9a)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ba0c6b14d09877b4c7c86be0421bbea45127e8be94be74f867e1dd22388731f7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__42708c7c0022f22e2ad58d8c72850e37d86f38fe3b4f8c0eb6baa8b03270a28b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__57e88c9660924b3dca71e9e4f82b24b81c137b75f03707588ba01d88ec74aade)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b280cd30ae41a294b60a3f5f3bf570df805633099c7d3d60b8acadc5553a953d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9e0d5cda2d68d787c4aef03e9b96c00ec6701624175415adf3156f919f272387)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAllowExpansion")
    def reset_allow_expansion(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansion", []))

    @jsii.member(jsii_name="resetAllowExpansionVar")
    def reset_allow_expansion_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansionVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionInput")
    def allow_expansion_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVarInput")
    def allow_expansion_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansion")
    def allow_expansion(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansion"))

    @allow_expansion.setter
    def allow_expansion(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac175655eae69c9bd27a5131969e867993853d44d6cf1ae8401f8025dc087381)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansion", value)

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVar")
    def allow_expansion_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansionVar"))

    @allow_expansion_var.setter
    def allow_expansion_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c375467d39405592fe3c79bb03c2e19630243e5fab2d605c2b09f439c6e99f9d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansionVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__867ca64e869951c14186dbaba59fa4396639821be5550e6c7fc7e63de8b20914)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1dc42bea81462c0aa18ccde971c05605db3b0a6255783ceeb74f92537375173c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a53847167ba8f855e8092fa0aac5592788c58a0dcecd81cc8b10bbe75e464c5e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d1bb17215dcd6ac10eb3cd05a65f5193525172eccf2552253520be6bd979aa4b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6d29747ebbf1a16bbd1f1b2debb45975e6ef66aaa256b68a565dcfe753852331)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8e8cb09e72080e9220944608ad731fca7b87ae8e2e5c4768bdb1e5fe4d151c0a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a795350eb6147f56f8e3bb057547a81ec18c90ffcd4595ee17e509a977f8ca2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6eabf87d9341f83c7383367dfec3b9354309e59a757333484f1b90601f37f049)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__83ed3bb30dcd14e92d59ee16abf76c43c305f1d5035a92eb8209fb6fe06f458b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f5fd50b8c62f53806d08a489c038b32f96674eaafa87fc4482c7ccab6592f104)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f50ad986a4fcdd8f6d01b7a46378c189b930465728f73015f4c1107f95ea2f12)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareFaceCrop",
    jsii_struct_bases=[],
    name_mapping={
        "algorithm": "algorithm",
        "algorithm_var": "algorithmVar",
        "confidence": "confidence",
        "confidence_var": "confidenceVar",
        "fail_gravity": "failGravity",
        "fail_gravity_var": "failGravityVar",
        "focus": "focus",
        "focus_var": "focusVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "padding": "padding",
        "padding_var": "paddingVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareFaceCrop:
    def __init__(
        self,
        *,
        algorithm: typing.Optional[builtins.str] = None,
        algorithm_var: typing.Optional[builtins.str] = None,
        confidence: typing.Optional[builtins.str] = None,
        confidence_var: typing.Optional[builtins.str] = None,
        fail_gravity: typing.Optional[builtins.str] = None,
        fail_gravity_var: typing.Optional[builtins.str] = None,
        focus: typing.Optional[builtins.str] = None,
        focus_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param algorithm: Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm DataAkamaiImagingPolicyImage#algorithm}
        :param algorithm_var: Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm_var DataAkamaiImagingPolicyImage#algorithm_var}
        :param confidence: With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image. Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence DataAkamaiImagingPolicyImage#confidence}
        :param confidence_var: With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image. Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence_var DataAkamaiImagingPolicyImage#confidence_var}
        :param fail_gravity: Controls placement of the crop if Image and Video Manager does not detect any faces in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        :param fail_gravity_var: Controls placement of the crop if Image and Video Manager does not detect any faces in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        :param focus: Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus DataAkamaiImagingPolicyImage#focus}
        :param focus_var: Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus_var DataAkamaiImagingPolicyImage#focus_var}
        :param gravity: Controls placement of the crop. Directions are relative to the face(s) plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Controls placement of the crop. Directions are relative to the face(s) plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param padding: The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        :param style: Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3e87564133e64badd611b84c6723ffcff53660ae5ae20c5026923ad794faf319)
            check_type(argname="argument algorithm", value=algorithm, expected_type=type_hints["algorithm"])
            check_type(argname="argument algorithm_var", value=algorithm_var, expected_type=type_hints["algorithm_var"])
            check_type(argname="argument confidence", value=confidence, expected_type=type_hints["confidence"])
            check_type(argname="argument confidence_var", value=confidence_var, expected_type=type_hints["confidence_var"])
            check_type(argname="argument fail_gravity", value=fail_gravity, expected_type=type_hints["fail_gravity"])
            check_type(argname="argument fail_gravity_var", value=fail_gravity_var, expected_type=type_hints["fail_gravity_var"])
            check_type(argname="argument focus", value=focus, expected_type=type_hints["focus"])
            check_type(argname="argument focus_var", value=focus_var, expected_type=type_hints["focus_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if algorithm is not None:
            self._values["algorithm"] = algorithm
        if algorithm_var is not None:
            self._values["algorithm_var"] = algorithm_var
        if confidence is not None:
            self._values["confidence"] = confidence
        if confidence_var is not None:
            self._values["confidence_var"] = confidence_var
        if fail_gravity is not None:
            self._values["fail_gravity"] = fail_gravity
        if fail_gravity_var is not None:
            self._values["fail_gravity_var"] = fail_gravity_var
        if focus is not None:
            self._values["focus"] = focus
        if focus_var is not None:
            self._values["focus_var"] = focus_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def algorithm(self) -> typing.Optional[builtins.str]:
        '''Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm DataAkamaiImagingPolicyImage#algorithm}
        '''
        result = self._values.get("algorithm")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def algorithm_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm_var DataAkamaiImagingPolicyImage#algorithm_var}
        '''
        result = self._values.get("algorithm_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def confidence(self) -> typing.Optional[builtins.str]:
        '''With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image.

        Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence DataAkamaiImagingPolicyImage#confidence}
        '''
        result = self._values.get("confidence")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def confidence_var(self) -> typing.Optional[builtins.str]:
        '''With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image.

        Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence_var DataAkamaiImagingPolicyImage#confidence_var}
        '''
        result = self._values.get("confidence_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any faces in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        '''
        result = self._values.get("fail_gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any faces in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        '''
        result = self._values.get("fail_gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def focus(self) -> typing.Optional[builtins.str]:
        '''Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus DataAkamaiImagingPolicyImage#focus}
        '''
        result = self._values.get("focus")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def focus_var(self) -> typing.Optional[builtins.str]:
        '''Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus_var DataAkamaiImagingPolicyImage#focus_var}
        '''
        result = self._values.get("focus_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the face(s) plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the face(s) plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareFaceCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareFaceCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareFaceCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2695a08d47a870828679dad2458e22d6b12875a1b00ddd776ab3169fb2c85c24)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareFaceCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e95d7c2091ca9ae506695630f2b0b5521dc0510f5ba822985f778945e19ee557)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareFaceCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8d22812ca547b7559d0fc17bb414f88b997a1bb26df241d7d69bec6d8040ceb9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__177f200c5d56a36d2e0165b07523b0651f2b36e66442b5c38acc5531d3e0d324)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1868fc91a071c1f2427f2d04c9b08f984045e2bf89419086104d2e55093a6fe0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareFaceCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareFaceCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareFaceCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1ac2abdcabdfe112a0c9ac17c1eb7ae7197f5b800794f9e630e3009fe0da7f05)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareFaceCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareFaceCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d6379c22f974e63ad16531eecb1b0bfb0d85e0fd3e71ec3ffd03abb20f00d724)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAlgorithm")
    def reset_algorithm(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAlgorithm", []))

    @jsii.member(jsii_name="resetAlgorithmVar")
    def reset_algorithm_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAlgorithmVar", []))

    @jsii.member(jsii_name="resetConfidence")
    def reset_confidence(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetConfidence", []))

    @jsii.member(jsii_name="resetConfidenceVar")
    def reset_confidence_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetConfidenceVar", []))

    @jsii.member(jsii_name="resetFailGravity")
    def reset_fail_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravity", []))

    @jsii.member(jsii_name="resetFailGravityVar")
    def reset_fail_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravityVar", []))

    @jsii.member(jsii_name="resetFocus")
    def reset_focus(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFocus", []))

    @jsii.member(jsii_name="resetFocusVar")
    def reset_focus_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFocusVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="algorithmInput")
    def algorithm_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "algorithmInput"))

    @builtins.property
    @jsii.member(jsii_name="algorithmVarInput")
    def algorithm_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "algorithmVarInput"))

    @builtins.property
    @jsii.member(jsii_name="confidenceInput")
    def confidence_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "confidenceInput"))

    @builtins.property
    @jsii.member(jsii_name="confidenceVarInput")
    def confidence_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "confidenceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityInput")
    def fail_gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityVarInput")
    def fail_gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="focusInput")
    def focus_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "focusInput"))

    @builtins.property
    @jsii.member(jsii_name="focusVarInput")
    def focus_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "focusVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="algorithm")
    def algorithm(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "algorithm"))

    @algorithm.setter
    def algorithm(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__04d5f6fcf7e06cd5d58ecfd7cc139bb7e2240f7d1a2a57d30ec1a3f5b972cddd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "algorithm", value)

    @builtins.property
    @jsii.member(jsii_name="algorithmVar")
    def algorithm_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "algorithmVar"))

    @algorithm_var.setter
    def algorithm_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b10d1df296032150603fc75204093c4601ef5b133b385304102785a87af0fa9b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "algorithmVar", value)

    @builtins.property
    @jsii.member(jsii_name="confidence")
    def confidence(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "confidence"))

    @confidence.setter
    def confidence(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__105473a6352b43c50d0f02885f8fef7e24500e6bd1eeb0904be38ca8ebef7f22)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "confidence", value)

    @builtins.property
    @jsii.member(jsii_name="confidenceVar")
    def confidence_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "confidenceVar"))

    @confidence_var.setter
    def confidence_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__252fdec85173b3283742b401e78663af645eea360f20987ecff73bdde7e02507)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "confidenceVar", value)

    @builtins.property
    @jsii.member(jsii_name="failGravity")
    def fail_gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravity"))

    @fail_gravity.setter
    def fail_gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__401a8fe9b0e91b8ea36c140c08a2266baec89b59fed46a47a0b3b4bce116534e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravity", value)

    @builtins.property
    @jsii.member(jsii_name="failGravityVar")
    def fail_gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravityVar"))

    @fail_gravity_var.setter
    def fail_gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3f194078ca95b789fba0c3029e25f015786db5f8e6659d543936a5c8a0465014)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="focus")
    def focus(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "focus"))

    @focus.setter
    def focus(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0a3ecf717401f30c71cc45f6b654084df962f3882b99bb547352f0c040260355)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "focus", value)

    @builtins.property
    @jsii.member(jsii_name="focusVar")
    def focus_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "focusVar"))

    @focus_var.setter
    def focus_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__affb0f8fe0c1e7df2ef2d69784b38a3e3395f0df57906744b3803ec85e2258cf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "focusVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8d26970db3f505fe5cece681fa9a8419f397d4cf4c2267888ccafad73de4ee90)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a28bbddc20e2ccb6b707183ca5ccb4547b8f36d709695567403f9689220082e9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__30a6cfff702c4d3da9109b32d43fef301bf5d04bbee7aaa59cae652ff9f1bb5a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__94b81cf43c06f4272e6063875433df4da565504bc499d7529edb271a0013edb6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d6a03d4aab57235d9f37037a09fe9ef955f2b33b3c4d61ea91b021a674a26947)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3f08a1a9598db6a0c9d05f59665c8da3d792afdf19fdd6b714f7876870c079b6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b28ee1fa35a70884d36a7dc42f1c8e26fabcfca713fa5a236ce9a607b19dbf91)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c03e3bf669fbf2cb300506dd1a56d9b41d9a2f3e69c65bcdb44da453325e7c48)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6d96808968f25ed3d15cdd439451c61fccbfc9b101e78a8fb800d339081a2e66)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d26e77009ea0df363d275f2b47bd91220221ff91be9fe3fc912ec27ae945936a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareFaceCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareFaceCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareFaceCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__50e1f274420f73f9968187fa7647fe50c7d3ab9a4ec9808aad97be2daa911e6e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareFeatureCrop",
    jsii_struct_bases=[],
    name_mapping={
        "fail_gravity": "failGravity",
        "fail_gravity_var": "failGravityVar",
        "feature_radius": "featureRadius",
        "feature_radius_var": "featureRadiusVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "max_features": "maxFeatures",
        "max_features_var": "maxFeaturesVar",
        "min_feature_quality": "minFeatureQuality",
        "min_feature_quality_var": "minFeatureQualityVar",
        "padding": "padding",
        "padding_var": "paddingVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareFeatureCrop:
    def __init__(
        self,
        *,
        fail_gravity: typing.Optional[builtins.str] = None,
        fail_gravity_var: typing.Optional[builtins.str] = None,
        feature_radius: typing.Optional[builtins.str] = None,
        feature_radius_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        max_features: typing.Optional[builtins.str] = None,
        max_features_var: typing.Optional[builtins.str] = None,
        min_feature_quality: typing.Optional[builtins.str] = None,
        min_feature_quality_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fail_gravity: Controls placement of the crop if Image and Video Manager does not detect any features in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        :param fail_gravity_var: Controls placement of the crop if Image and Video Manager does not detect any features in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        :param feature_radius: The size in pixels of the important features to search for. If identified, two features never appear closer together than this value, ``8.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius DataAkamaiImagingPolicyImage#feature_radius}
        :param feature_radius_var: The size in pixels of the important features to search for. If identified, two features never appear closer together than this value, ``8.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius_var DataAkamaiImagingPolicyImage#feature_radius_var}
        :param gravity: Controls placement of the crop. Directions are relative to the region of interest plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Controls placement of the crop. Directions are relative to the region of interest plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param max_features: The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features DataAkamaiImagingPolicyImage#max_features}
        :param max_features_var: The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features_var DataAkamaiImagingPolicyImage#max_features_var}
        :param min_feature_quality: Determines the minimum quality level of the feature identified. To consider a feature important, the feature needs to surpass this value. Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality DataAkamaiImagingPolicyImage#min_feature_quality}
        :param min_feature_quality_var: Determines the minimum quality level of the feature identified. To consider a feature important, the feature needs to surpass this value. Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality_var DataAkamaiImagingPolicyImage#min_feature_quality_var}
        :param padding: Adds space around the region of interest. The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: Adds space around the region of interest. The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        :param style: Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__23aa641e68b544029723516a04c7d1a3a087cd056e8f4053772ca649116bbdcf)
            check_type(argname="argument fail_gravity", value=fail_gravity, expected_type=type_hints["fail_gravity"])
            check_type(argname="argument fail_gravity_var", value=fail_gravity_var, expected_type=type_hints["fail_gravity_var"])
            check_type(argname="argument feature_radius", value=feature_radius, expected_type=type_hints["feature_radius"])
            check_type(argname="argument feature_radius_var", value=feature_radius_var, expected_type=type_hints["feature_radius_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument max_features", value=max_features, expected_type=type_hints["max_features"])
            check_type(argname="argument max_features_var", value=max_features_var, expected_type=type_hints["max_features_var"])
            check_type(argname="argument min_feature_quality", value=min_feature_quality, expected_type=type_hints["min_feature_quality"])
            check_type(argname="argument min_feature_quality_var", value=min_feature_quality_var, expected_type=type_hints["min_feature_quality_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fail_gravity is not None:
            self._values["fail_gravity"] = fail_gravity
        if fail_gravity_var is not None:
            self._values["fail_gravity_var"] = fail_gravity_var
        if feature_radius is not None:
            self._values["feature_radius"] = feature_radius
        if feature_radius_var is not None:
            self._values["feature_radius_var"] = feature_radius_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if max_features is not None:
            self._values["max_features"] = max_features
        if max_features_var is not None:
            self._values["max_features_var"] = max_features_var
        if min_feature_quality is not None:
            self._values["min_feature_quality"] = min_feature_quality
        if min_feature_quality_var is not None:
            self._values["min_feature_quality_var"] = min_feature_quality_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def fail_gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any features in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        '''
        result = self._values.get("fail_gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any features in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        '''
        result = self._values.get("fail_gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feature_radius(self) -> typing.Optional[builtins.str]:
        '''The size in pixels of the important features to search for.

        If identified, two features never appear closer together than this value, ``8.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius DataAkamaiImagingPolicyImage#feature_radius}
        '''
        result = self._values.get("feature_radius")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feature_radius_var(self) -> typing.Optional[builtins.str]:
        '''The size in pixels of the important features to search for.

        If identified, two features never appear closer together than this value, ``8.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius_var DataAkamaiImagingPolicyImage#feature_radius_var}
        '''
        result = self._values.get("feature_radius_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the region of interest plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the region of interest plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def max_features(self) -> typing.Optional[builtins.str]:
        '''The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features DataAkamaiImagingPolicyImage#max_features}
        '''
        result = self._values.get("max_features")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def max_features_var(self) -> typing.Optional[builtins.str]:
        '''The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features_var DataAkamaiImagingPolicyImage#max_features_var}
        '''
        result = self._values.get("max_features_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def min_feature_quality(self) -> typing.Optional[builtins.str]:
        '''Determines the minimum quality level of the feature identified.

        To consider a feature important, the feature needs to surpass this value.  Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality DataAkamaiImagingPolicyImage#min_feature_quality}
        '''
        result = self._values.get("min_feature_quality")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def min_feature_quality_var(self) -> typing.Optional[builtins.str]:
        '''Determines the minimum quality level of the feature identified.

        To consider a feature important, the feature needs to surpass this value.  Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality_var DataAkamaiImagingPolicyImage#min_feature_quality_var}
        '''
        result = self._values.get("min_feature_quality_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''Adds space around the region of interest.

        The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''Adds space around the region of interest.

        The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareFeatureCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareFeatureCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareFeatureCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f931340dc1ce20fc35018b8ab14559a0b7c240c86155a0c74c24c50f6747642)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareFeatureCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0171589b4234cd1dc9c88fd7fefca8bbe6b2d5e7c5e6f03691457b86cd3c41e5)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareFeatureCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3db1d8df1a9f7bf0c55ddd1863abbd1a900a7bd710a7b423e86e1c875b1ccdbb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b1a681aecb12826f33812a0497d78c7ad1d37e951cead3d0395cc14e549ee34d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__06462f155b903907e5a9c9b0203b1fdbbaf34abc09d77a5e38dc0b47b2e7a2cd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareFeatureCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareFeatureCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareFeatureCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7f8bc379f661929ab12898e5a22d45fca471decbb63d428da0fbbe0668197fc0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareFeatureCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareFeatureCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0e7d72f387c10d6df6a35e758cf85ca3e60782ff3a4782f4cf9f4d4fb8a37140)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetFailGravity")
    def reset_fail_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravity", []))

    @jsii.member(jsii_name="resetFailGravityVar")
    def reset_fail_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravityVar", []))

    @jsii.member(jsii_name="resetFeatureRadius")
    def reset_feature_radius(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureRadius", []))

    @jsii.member(jsii_name="resetFeatureRadiusVar")
    def reset_feature_radius_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureRadiusVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetMaxFeatures")
    def reset_max_features(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxFeatures", []))

    @jsii.member(jsii_name="resetMaxFeaturesVar")
    def reset_max_features_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxFeaturesVar", []))

    @jsii.member(jsii_name="resetMinFeatureQuality")
    def reset_min_feature_quality(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMinFeatureQuality", []))

    @jsii.member(jsii_name="resetMinFeatureQualityVar")
    def reset_min_feature_quality_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMinFeatureQualityVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="failGravityInput")
    def fail_gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityVarInput")
    def fail_gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featureRadiusInput")
    def feature_radius_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featureRadiusInput"))

    @builtins.property
    @jsii.member(jsii_name="featureRadiusVarInput")
    def feature_radius_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featureRadiusVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesInput")
    def max_features_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "maxFeaturesInput"))

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesVarInput")
    def max_features_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "maxFeaturesVarInput"))

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityInput")
    def min_feature_quality_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "minFeatureQualityInput"))

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityVarInput")
    def min_feature_quality_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "minFeatureQualityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravity")
    def fail_gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravity"))

    @fail_gravity.setter
    def fail_gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0357fd552037eb5d64675e2de941d0eb9b344cd589780b7d04beb6129d57e9ae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravity", value)

    @builtins.property
    @jsii.member(jsii_name="failGravityVar")
    def fail_gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravityVar"))

    @fail_gravity_var.setter
    def fail_gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__03b000b63541c2f935f1e4f0a5bb7a8a9d16e7edaae42d08e7e867575a885108)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="featureRadius")
    def feature_radius(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featureRadius"))

    @feature_radius.setter
    def feature_radius(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0de83f8382155b1ec66bb1d48282819cc58beb52b139370bebcf18844d720d3d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featureRadius", value)

    @builtins.property
    @jsii.member(jsii_name="featureRadiusVar")
    def feature_radius_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featureRadiusVar"))

    @feature_radius_var.setter
    def feature_radius_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ccedddd53efaecdf0da82bbd14fa62b5e45303ca1ff09e120bcccb940a3a8e9d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featureRadiusVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__603f84d8604090e44c3eb43c76f35744627a6fd4edd005fd672e32c74e92cbe6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb564667c6f4341c5545073edb32b700306c413470366b9ebb076d8ac36b275f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__65e6df569cd407ac25136af5bd47dc367bd7a5372a29e7798d5b9cd06df10f2c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a0ca25ac6943651958d414130d4be2e8df016db49a72a6b6c5e38dbc233651c4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="maxFeatures")
    def max_features(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "maxFeatures"))

    @max_features.setter
    def max_features(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__68f1902736b3c39cb79d73c3f8a7bc92deb9d0c1b2d7dea9f90cf6e0f10d2f0e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "maxFeatures", value)

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesVar")
    def max_features_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "maxFeaturesVar"))

    @max_features_var.setter
    def max_features_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__49d7c5b8896f91841693d218af85e1d6124da5261302a440598e6b1039cdb4fc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "maxFeaturesVar", value)

    @builtins.property
    @jsii.member(jsii_name="minFeatureQuality")
    def min_feature_quality(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "minFeatureQuality"))

    @min_feature_quality.setter
    def min_feature_quality(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__00f58fb94216b4714305ec44186517346acfafe270e17fe47332a5129fc43831)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "minFeatureQuality", value)

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityVar")
    def min_feature_quality_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "minFeatureQualityVar"))

    @min_feature_quality_var.setter
    def min_feature_quality_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4cf6fd3c58d6346c63860df084db3cb16b528159e750d34dc3b4b18dccaf9e36)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "minFeatureQualityVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__41d794b6641ceb97cad2e2a00706d556743276f716d9b27fd342cacc9a562182)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1778c4fdc99ff890fc479b611b5295282e39af35c57db7bce4eb86048626928b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc1fd844125d9e12f012f46bf0c3e4f437f6b49e76e8e4031ada099b5e26e165)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4264d5cd5f883b969e1ad2dd11e4aad0b4593926f72b8a6b3724160848eaf9ae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9036166071af2a37ae4e9330000096181ace3ecc3971d533a248885f0717302a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f0bc967830bfbc82edfb4856a3ce5765c8be4002375e9d2a44b5c3d2827821f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareFeatureCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareFeatureCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareFeatureCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__258bc6cf6a1dfa640017e39be547e26f5c923d96585dc26d00bf87a6691a6875)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareFitAndFill",
    jsii_struct_bases=[],
    name_mapping={
        "fill_transformation": "fillTransformation",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareFitAndFill:
    def __init__(
        self,
        *,
        fill_transformation: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareFitAndFillFillTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fill_transformation: fill_transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_transformation DataAkamaiImagingPolicyImage#fill_transformation}
        :param height: The height value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The width value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(fill_transformation, dict):
            fill_transformation = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareFitAndFillFillTransformation(**fill_transformation)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__075627c54a783a26eb7d7600a79a417cda47db7e8315d029dcbbb674f032ae58)
            check_type(argname="argument fill_transformation", value=fill_transformation, expected_type=type_hints["fill_transformation"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fill_transformation is not None:
            self._values["fill_transformation"] = fill_transformation
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def fill_transformation(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareFitAndFillFillTransformation"]:
        '''fill_transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_transformation DataAkamaiImagingPolicyImage#fill_transformation}
        '''
        result = self._values.get("fill_transformation")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareFitAndFillFillTransformation"], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareFitAndFill(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareFitAndFillFillTransformation",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareFitAndFillFillTransformation:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareFitAndFillFillTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareFitAndFillFillTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareFitAndFillFillTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a59019def119bf297a0a8b681f7b380dfe91f99b4a2983f466bf3bacd0487b49)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareFitAndFillFillTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareFitAndFillFillTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareFitAndFillFillTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1d376a3409f2660ccf47019614e5d82c3b8400a41a40bd51950ab5bdd586d1b5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareFitAndFillList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareFitAndFillList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4dcd92d9a628d526d0516ddb50e54b40fe25efd0fbcd0805c9580d25ca5faf03)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareFitAndFillOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__03be98bf5f373eccaf214213170ae0a07c629787057939e3bf89828548aa7ada)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareFitAndFillOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f8ffac9b912a0381c7e9d68e85753d629bc62448f00faec01fb8b29449a6de63)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c4ab2ef4ff49865909a93328822241027471637f32356be54d284bbef696a8f9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fecd1540aef868d9f3d0e2863d7d3a2c35af41e81da6312e38e7054ee9e4b037)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareFitAndFill]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareFitAndFill]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareFitAndFill]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f2ed021a4d1f8cf6ce485a1b94d8ac8218c1961a20e6d1bde475ac311d237e3f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareFitAndFillOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareFitAndFillOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__794eb04e618ffa9b1c59a6ceae8cdb438eb42eca60dcca8b3451701e1360b3e2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putFillTransformation")
    def put_fill_transformation(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareFitAndFillFillTransformation()

        return typing.cast(None, jsii.invoke(self, "putFillTransformation", [value]))

    @jsii.member(jsii_name="resetFillTransformation")
    def reset_fill_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFillTransformation", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="fillTransformation")
    def fill_transformation(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareFitAndFillFillTransformationOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareFitAndFillFillTransformationOutputReference, jsii.get(self, "fillTransformation"))

    @builtins.property
    @jsii.member(jsii_name="fillTransformationInput")
    def fill_transformation_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareFitAndFillFillTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareFitAndFillFillTransformation], jsii.get(self, "fillTransformationInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__695aaea6c2ea0cc2f08fca87c9a37028b05b52c4431295a7b94322e2f431c2c5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b30b33533f116287a745f91e38d6582c0d314115f32eb91f7b16a60668277df0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fe93fb4af87ab9ae11dbdba1f2bcf5af333dd7fca5d0b2db034c5d40f3e4b5d7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9b287b39e6a84895491b189a28f729ccb95c74b45e9379312d0d55dbd8e09d20)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareFitAndFill]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareFitAndFill]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareFitAndFill]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d4547106bb0a7bfea28776052b4d00d46aff5e3d0730053373eecb80121bff51)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareGoop",
    jsii_struct_bases=[],
    name_mapping={
        "chaos": "chaos",
        "chaos_var": "chaosVar",
        "density": "density",
        "density_var": "densityVar",
        "power": "power",
        "power_var": "powerVar",
        "seed": "seed",
        "seed_var": "seedVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareGoop:
    def __init__(
        self,
        *,
        chaos: typing.Optional[builtins.str] = None,
        chaos_var: typing.Optional[builtins.str] = None,
        density: typing.Optional[builtins.str] = None,
        density_var: typing.Optional[builtins.str] = None,
        power: typing.Optional[builtins.str] = None,
        power_var: typing.Optional[builtins.str] = None,
        seed: typing.Optional[builtins.str] = None,
        seed_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param chaos: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        :param chaos_var: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        :param density: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        :param density_var: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        :param power: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        :param power_var: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        :param seed: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        :param seed_var: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__70da9bb5dd6d658dd31b8099ac79095c2ac32423df9abe4bdc0aad48aa8c2aa0)
            check_type(argname="argument chaos", value=chaos, expected_type=type_hints["chaos"])
            check_type(argname="argument chaos_var", value=chaos_var, expected_type=type_hints["chaos_var"])
            check_type(argname="argument density", value=density, expected_type=type_hints["density"])
            check_type(argname="argument density_var", value=density_var, expected_type=type_hints["density_var"])
            check_type(argname="argument power", value=power, expected_type=type_hints["power"])
            check_type(argname="argument power_var", value=power_var, expected_type=type_hints["power_var"])
            check_type(argname="argument seed", value=seed, expected_type=type_hints["seed"])
            check_type(argname="argument seed_var", value=seed_var, expected_type=type_hints["seed_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if chaos is not None:
            self._values["chaos"] = chaos
        if chaos_var is not None:
            self._values["chaos_var"] = chaos_var
        if density is not None:
            self._values["density"] = density
        if density_var is not None:
            self._values["density_var"] = density_var
        if power is not None:
            self._values["power"] = power
        if power_var is not None:
            self._values["power_var"] = power_var
        if seed is not None:
            self._values["seed"] = seed
        if seed_var is not None:
            self._values["seed_var"] = seed_var

    @builtins.property
    def chaos(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        '''
        result = self._values.get("chaos")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def chaos_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        '''
        result = self._values.get("chaos_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        '''
        result = self._values.get("density")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density_var(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        '''
        result = self._values.get("density_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        '''
        result = self._values.get("power")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power_var(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        '''
        result = self._values.get("power_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        '''
        result = self._values.get("seed")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed_var(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        result = self._values.get("seed_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareGoop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareGoopList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareGoopList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__69950b4c7eb5709933d237591a7a0c7b32d2e6601a5de44c6894ba211fd72714)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareGoopOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f0492ef1635845bf27f9c8f506a69779ec55ee39c91de86e92f2453c8148d6a9)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareGoopOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__25cfad9863299422d720d27e4137d2f2107b4cd2e2a49d6003364a6b1e882e74)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a1cc1ae6e5902d9dfa12bc06f7738e9f06c2cfbaee0926c739e81b07f02b0187)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0a54d9fab251da80877fc9012f704e9765c49d49a9579a01ac52605c2a763230)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareGoop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareGoop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f13623481549341f1bfeff3b64aeb0dab3fc613538381dad6e3c34ddaf1245a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareGoopOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareGoopOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2e71c63277c1fbe77358b2701122590d314bf1932daeacdf8e68dcea933954bd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetChaos")
    def reset_chaos(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaos", []))

    @jsii.member(jsii_name="resetChaosVar")
    def reset_chaos_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaosVar", []))

    @jsii.member(jsii_name="resetDensity")
    def reset_density(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensity", []))

    @jsii.member(jsii_name="resetDensityVar")
    def reset_density_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensityVar", []))

    @jsii.member(jsii_name="resetPower")
    def reset_power(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPower", []))

    @jsii.member(jsii_name="resetPowerVar")
    def reset_power_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPowerVar", []))

    @jsii.member(jsii_name="resetSeed")
    def reset_seed(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeed", []))

    @jsii.member(jsii_name="resetSeedVar")
    def reset_seed_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeedVar", []))

    @builtins.property
    @jsii.member(jsii_name="chaosInput")
    def chaos_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosInput"))

    @builtins.property
    @jsii.member(jsii_name="chaosVarInput")
    def chaos_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosVarInput"))

    @builtins.property
    @jsii.member(jsii_name="densityInput")
    def density_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityInput"))

    @builtins.property
    @jsii.member(jsii_name="densityVarInput")
    def density_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="powerInput")
    def power_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerInput"))

    @builtins.property
    @jsii.member(jsii_name="powerVarInput")
    def power_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerVarInput"))

    @builtins.property
    @jsii.member(jsii_name="seedInput")
    def seed_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedInput"))

    @builtins.property
    @jsii.member(jsii_name="seedVarInput")
    def seed_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedVarInput"))

    @builtins.property
    @jsii.member(jsii_name="chaos")
    def chaos(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaos"))

    @chaos.setter
    def chaos(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__037949aa4251d6951d5333b73e2c4df27c60f854944240aac6a2203a6f8f46f8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaos", value)

    @builtins.property
    @jsii.member(jsii_name="chaosVar")
    def chaos_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaosVar"))

    @chaos_var.setter
    def chaos_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2df21bf1ebc1fb508b72d10be39feaf60127de9c6c8b47d26c86998619df4024)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaosVar", value)

    @builtins.property
    @jsii.member(jsii_name="density")
    def density(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "density"))

    @density.setter
    def density(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1718370c9a1ea914b3bcc6103b8c02f43a24fe02da52544911f46105e3c2a410)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "density", value)

    @builtins.property
    @jsii.member(jsii_name="densityVar")
    def density_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "densityVar"))

    @density_var.setter
    def density_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__627d6e731d6b4b6175439f4b36ccdec366d8e663efa91b18e2393ea2f4ae68e8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "densityVar", value)

    @builtins.property
    @jsii.member(jsii_name="power")
    def power(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "power"))

    @power.setter
    def power(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e56dfe5e0426203f278660dc1da5c86407f4dc3a24d28308ff3493f9e0fda849)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "power", value)

    @builtins.property
    @jsii.member(jsii_name="powerVar")
    def power_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "powerVar"))

    @power_var.setter
    def power_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__28e3f4d542fdf5f060aab9643d9b6d5a438289f5e27e070339dcea91708b26b5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "powerVar", value)

    @builtins.property
    @jsii.member(jsii_name="seed")
    def seed(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seed"))

    @seed.setter
    def seed(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6ca3fa4a3bce305d7bac00dbeb95da9aa90f09b9ef136db94b9f2923c83803e2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seed", value)

    @builtins.property
    @jsii.member(jsii_name="seedVar")
    def seed_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seedVar"))

    @seed_var.setter
    def seed_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0dbb038f26d7d95e7d3119def9a261594fd02af2645b80cab887032714e88ff8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seedVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareGoop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareGoop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareGoop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c91f5510ee9df67989bc954919680df785e48b9a8e5e690dd7b504b0c8fdb72d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareGrayscale",
    jsii_struct_bases=[],
    name_mapping={"type": "type", "type_var": "typeVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareGrayscale:
    def __init__(
        self,
        *,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param type: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f8a8e73a1bc63d888f1117bd97e8b7a915485ac0ede098dc359a1d64503b1b5)
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareGrayscale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareGrayscaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareGrayscaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7fa4dd4445d00a0f426711f8bd397d8bf241b9662dcf2c28b54c1a48fcbe2753)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareGrayscaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6af299051007d9a1dcbde63b1f0a88b1bd9265d79626b0a6b28dfe94eed17a3d)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareGrayscaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__19cfd78a4f628e809ec3b04eb3bf6087008bedbefcb045778ea7f267056eefb0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5fda5679f818a9bdd4dd48ad51f0b24559fd99f67882870f9c01c3c1d3b45761)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a891207310abb0fbb58b22323dbec75d34d79f1a62ed1a94a51803c375ace41)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareGrayscale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareGrayscale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2835badb939247e8aec7dfc88d138d5cdc04237e9b2464601a3cf7f7ad535ab7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareGrayscaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareGrayscaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d1c70dac9bc5cb62a77f591da42c49146a7c8d4321f956566e478847a602c2c3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c67bd584d20121ce15c719759e8ca4ad6846cc304d96022d08850e1a9a4293ec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc6799d47c6385ded923ba8168d695b62e65914f32b3f71b8f66a225169cc891)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareGrayscale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareGrayscale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareGrayscale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7ead7b4a747b697ce00eeb890cd4ee5021100b0a67aeafd7fd3b5b950e6a2f8b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareHsl",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "lightness": "lightness",
        "lightness_var": "lightnessVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareHsl:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness: typing.Optional[builtins.str] = None,
        lightness_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        :param lightness_var: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c493fb96f01b9fb46fade37a94b3bdf6aef08acbc6d3661eb0aefebe228f876b)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness", value=lightness, expected_type=type_hints["lightness"])
            check_type(argname="argument lightness_var", value=lightness_var, expected_type=type_hints["lightness_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness is not None:
            self._values["lightness"] = lightness
        if lightness_var is not None:
            self._values["lightness_var"] = lightness_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        '''
        result = self._values.get("lightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        '''
        result = self._values.get("lightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareHsl(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareHslList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareHslList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__73a1784f6f79fa6a4a0a8c9d1e0204bbdfec17973e6cc6eb794dab82849f9526)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareHslOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__084ceb725fbacd7aa1c551782c06a5f1e450f1c6095cdbf6315c91c1a089066f)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareHslOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__65200199bcd946d4733e4c1e6f199cd052cafa6da84bfaf0b1f0e0958445195c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__de86043303e7e7aee5119d66a0d91f073eb1d1c7a7c758cb76c902a20a853b5a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__079d802923300e96230b64a6245e1f6b56703ced7fdfc2f1d1bdbd9835c11712)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareHsl]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareHsl]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2aad456f3397c8e662e2ae112a17104e63748bfe4f9987bd61859a78c0e6aeaf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareHslOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareHslOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a977dae8799cce83fe2b22136f6fb90fc3240743c93cd962079a1abfd86f6d09)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightness")
    def reset_lightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightness", []))

    @jsii.member(jsii_name="resetLightnessVar")
    def reset_lightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessInput")
    def lightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessVarInput")
    def lightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e3dc327ac9ef54f48bd4807e707101889789ce0c939b3d94bbbfbaf38095afcc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fb1a54f0492428e64c17c2976bb0dfb7926df1e19207ee620f90138fdc4c0c58)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightness")
    def lightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightness"))

    @lightness.setter
    def lightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e85c89b2d11d39ef97cf95477b1d24232ea635b53517359adae452d8025ff8a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightness", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessVar")
    def lightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessVar"))

    @lightness_var.setter
    def lightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__790eb8b7a6bbafae59abd92d162873d3d2efaae3826b9da7efad5157fa992579)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d0e6bd969cf267e58792e67da20001655a706ae3fbc14fb2b963b82273ead79a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a59a00e55e9058c4b964d81df0cb8e60f5b318add74809040623863be33ee75e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareHsl]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareHsl]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareHsl]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4e9f561f3a628ced8da425ce904e3211c72ef6b1f56fe33b7f6ea7ae716c16aa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareHsv",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareHsv:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        :param value: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ef2e0e92dfbeaeeac085b9f1cd770bfd6b6627664ad9dc167dc9f91195c78ed6)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareHsv(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareHsvList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareHsvList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__67a131f6e42af29a8f41548b4a353e8aca0d0cdde628024d8cea67997bdbb19f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareHsvOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a32abf5f97deab00d0329f2e5665f2557c4348d87f88edde82d1cfb738733030)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareHsvOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1574bb7ae46e61058704cf6bfede8f54f55ca4e698f2136998bdb48a6b1ad0f8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__26eec2f26e98c74f21f4cb2ed9018d420b4c14a226301d01c04f6bb2eff512d6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__666dbe7cfe6ee54d81b0cf161b76d30b3667f0968dfa4d26bad01e6caa248095)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareHsv]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareHsv]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1577b150bfa48e0d903789c738077b525d09b7d7fffd1ee4229ac19fd45bbc78)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareHsvOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareHsvOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__27868edc6e336e0b696f7426eac5cfaa40976c505aceea09459cb23dce5f41ba)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__baf8c8e4a754dfefd7e4a1c68459ead6e14c877ab42c05a23db39ff2f9293281)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ed06365dc21afbaad69eedb2a1b909c95bfd2b94cddff6be340be84a575c667)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8ab12fb067342ef4601c74f32e0ff1326069c93131641be3189173b207993053)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b609178dd0f754679b01da06441b4d21c4e65d95ddc42275fa2f2e53d46cbc68)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__43e2df768903ab25cab7122db04a7634c3f593eb02a66df83333506cc28d3a14)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aa2f80dc574fa1ead473d73a783084b0ad902d0e98c6abb3c5c82b7179603b05)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareHsv]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareHsv]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareHsv]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6462a8ee4e098477979732e77df39ff8cc088c1c00af90f1ab8a717bd6dd5a86)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfDimension",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "dimension": "dimension",
        "dimension_var": "dimensionVar",
        "equal": "equal",
        "greater_than": "greaterThan",
        "less_than": "lessThan",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfDimension:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        dimension: typing.Optional[builtins.str] = None,
        dimension_var: typing.Optional[builtins.str] = None,
        equal: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionEqual", typing.Dict[builtins.str, typing.Any]]] = None,
        greater_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionGreaterThan", typing.Dict[builtins.str, typing.Any]]] = None,
        less_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionLessThan", typing.Dict[builtins.str, typing.Any]]] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param dimension: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        :param dimension_var: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        :param equal: equal block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        :param greater_than: greater_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        :param less_than: less_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        :param value: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionDefault(**default)
        if isinstance(equal, dict):
            equal = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionEqual(**equal)
        if isinstance(greater_than, dict):
            greater_than = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionGreaterThan(**greater_than)
        if isinstance(less_than, dict):
            less_than = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionLessThan(**less_than)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__27c0a8ad9edd69ce8458ef1ef474297905b3516c5a94caeef22d180b650ccdda)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument dimension", value=dimension, expected_type=type_hints["dimension"])
            check_type(argname="argument dimension_var", value=dimension_var, expected_type=type_hints["dimension_var"])
            check_type(argname="argument equal", value=equal, expected_type=type_hints["equal"])
            check_type(argname="argument greater_than", value=greater_than, expected_type=type_hints["greater_than"])
            check_type(argname="argument less_than", value=less_than, expected_type=type_hints["less_than"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if dimension is not None:
            self._values["dimension"] = dimension
        if dimension_var is not None:
            self._values["dimension_var"] = dimension_var
        if equal is not None:
            self._values["equal"] = equal
        if greater_than is not None:
            self._values["greater_than"] = greater_than
        if less_than is not None:
            self._values["less_than"] = less_than
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionDefault"], result)

    @builtins.property
    def dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        '''
        result = self._values.get("dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        '''
        result = self._values.get("dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def equal(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionEqual"]:
        '''equal block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        '''
        result = self._values.get("equal")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionEqual"], result)

    @builtins.property
    def greater_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionGreaterThan"]:
        '''greater_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        '''
        result = self._values.get("greater_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionGreaterThan"], result)

    @builtins.property
    def less_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionLessThan"]:
        '''less_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        '''
        result = self._values.get("less_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionLessThan"], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfDimension(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__01e8f439cc86b5ba17a63493da2c5d9cc249374a569d6bb1c19a204f13de16b5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fe9d1611dbb2143e62aa6ffb75e8388ca6ef05d39f366fcffffde2bf975e5c0c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionEqual",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionEqual:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionEqual(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionEqualOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionEqualOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6cff6648c2f3c76334430758dbcd2c9e447e6b0648b312a70f98ba104aa8be30)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionEqual], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionEqual],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__828851b99a13b1a7e251039029b28e9b7c6b03c4f0f692be78f660f8e1b177cf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionGreaterThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionGreaterThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionGreaterThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionGreaterThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionGreaterThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f5846f36049f79ee15266d50eccd8b9d76d08fe5404f51bef9db22f1700bf4a2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionGreaterThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionGreaterThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__72819944360d4ad188d23d651da594b07a6c658671edecc157f07354397112c2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionLessThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionLessThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionLessThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionLessThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionLessThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eb7902bf5c1acbb1db028de570641c6fe871778b7fafbd67805302e1ff2e8a4c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionLessThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionLessThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__078711588c0ffd762a36534c726fc30dfdfb4f48716626f5974293afa27f5b3e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8bfc57c1ec8adea701d580e78e22cc4da27e3ec3a545ba18b2b66c42880000c7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3da6e7d07113450500817bcf1ea546c43771559d107034ebb8664ae294032da0)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4558d1471770a32713d2758f3f24bfc17a0923f27102e50d294b5958fd4fe9b3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__75bdfeb7261faf1e0331982aa94dcd8928962401ef113d5bdaae6fdad0fbf3b3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7c94d188626b0a71f2e4f3ebf9fabc33ec639245c94da34fed1d421a947b1d16)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfDimension]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfDimension]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1bef6495ce7d6564a53901a06b91774617408de0df19345f97947e18beea01e4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9f987694db19adcb2486c175f82f158b3d0c95bf99d02c12ac92877b8a0727c2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putEqual")
    def put_equal(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionEqual()

        return typing.cast(None, jsii.invoke(self, "putEqual", [value]))

    @jsii.member(jsii_name="putGreaterThan")
    def put_greater_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionGreaterThan()

        return typing.cast(None, jsii.invoke(self, "putGreaterThan", [value]))

    @jsii.member(jsii_name="putLessThan")
    def put_less_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionLessThan()

        return typing.cast(None, jsii.invoke(self, "putLessThan", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetDimension")
    def reset_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimension", []))

    @jsii.member(jsii_name="resetDimensionVar")
    def reset_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimensionVar", []))

    @jsii.member(jsii_name="resetEqual")
    def reset_equal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEqual", []))

    @jsii.member(jsii_name="resetGreaterThan")
    def reset_greater_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGreaterThan", []))

    @jsii.member(jsii_name="resetLessThan")
    def reset_less_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLessThan", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="equal")
    def equal(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionEqualOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionEqualOutputReference, jsii.get(self, "equal"))

    @builtins.property
    @jsii.member(jsii_name="greaterThan")
    def greater_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionGreaterThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionGreaterThanOutputReference, jsii.get(self, "greaterThan"))

    @builtins.property
    @jsii.member(jsii_name="lessThan")
    def less_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionLessThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionLessThanOutputReference, jsii.get(self, "lessThan"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionInput")
    def dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionVarInput")
    def dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="equalInput")
    def equal_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionEqual], jsii.get(self, "equalInput"))

    @builtins.property
    @jsii.member(jsii_name="greaterThanInput")
    def greater_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionGreaterThan], jsii.get(self, "greaterThanInput"))

    @builtins.property
    @jsii.member(jsii_name="lessThanInput")
    def less_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionLessThan], jsii.get(self, "lessThanInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="dimension")
    def dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimension"))

    @dimension.setter
    def dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__68182550d1cfc9c385b4f9219c8d070995d355f28aca38fe79550ba18509ec84)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimension", value)

    @builtins.property
    @jsii.member(jsii_name="dimensionVar")
    def dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimensionVar"))

    @dimension_var.setter
    def dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__96f2fbbe6586e3bb2386767f66e6fa82975a4a28b000eef0bbfba3d1ddf97830)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__83e7eaa4526c026987e49b5ba7eab5af0352eccaa6b790ac70e3008f779f04cf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a756f5b667837bf4ae15ba2f305cc8f82d3218ca0f1d2afacb78e836da915879)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfDimension]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfDimension]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfDimension]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cc14870d2f5082ba2eb8aaaef9c378bbd707eddc14f6cac049238e582dd58718)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfOrientation",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "landscape": "landscape",
        "portrait": "portrait",
        "square": "square",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfOrientation:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        landscape: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationLandscape", typing.Dict[builtins.str, typing.Any]]] = None,
        portrait: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationPortrait", typing.Dict[builtins.str, typing.Any]]] = None,
        square: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationSquare", typing.Dict[builtins.str, typing.Any]]] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param landscape: landscape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        :param portrait: portrait block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        :param square: square block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationDefault(**default)
        if isinstance(landscape, dict):
            landscape = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationLandscape(**landscape)
        if isinstance(portrait, dict):
            portrait = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationPortrait(**portrait)
        if isinstance(square, dict):
            square = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationSquare(**square)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c9ab72782398252bbfc430adc88b6cc6ce8193392491d219136cd30eb651c822)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument landscape", value=landscape, expected_type=type_hints["landscape"])
            check_type(argname="argument portrait", value=portrait, expected_type=type_hints["portrait"])
            check_type(argname="argument square", value=square, expected_type=type_hints["square"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if landscape is not None:
            self._values["landscape"] = landscape
        if portrait is not None:
            self._values["portrait"] = portrait
        if square is not None:
            self._values["square"] = square

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationDefault"], result)

    @builtins.property
    def landscape(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationLandscape"]:
        '''landscape block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        '''
        result = self._values.get("landscape")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationLandscape"], result)

    @builtins.property
    def portrait(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationPortrait"]:
        '''portrait block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        '''
        result = self._values.get("portrait")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationPortrait"], result)

    @builtins.property
    def square(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationSquare"]:
        '''square block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        result = self._values.get("square")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationSquare"], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfOrientation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d7c3970d36d553e28358c526733a598dc6e2616ce83c64edd2fc00c23174921c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ef8214e4c8f936b86b6962c74891d8478b986426ab5e6737c4c38ac3bf5f9e6f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationLandscape",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationLandscape:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationLandscape(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationLandscapeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationLandscapeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__983d370df419d8f99fbcef6366cf07c1a200cb9564271ee6cb3f51ab1c3e46f4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationLandscape], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationLandscape],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__295fb6dd4599d7dc76b182769942b75d83654118ed2b15bacb8e99e1e8a8cb2f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__41ab127f31175a74ebeb0887a140c41361969fdfd6625395de3f8a5701fa7aa2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__022c4169e9896263dedbf30826d512862ff7b8baaaa1638599007fc2e4f5b29b)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__21f293c38dbda6e93690b2686b22f710cafe642a1ca9ad2ec418cf55caf96c2c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a67f96804ca26f2ccabb2ba0d77661ac42d72e6d3ee43fa680a7116a214cfed6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fd45527e24ff8993bbc1cf00a0feacebd26e4785041447aebff93c9dc5468a01)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfOrientation]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfOrientation]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__13718d7707478987d0b56849a8b7dc1ab72b41993a1046c173d2c612b26497c2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__42bf273b168b4b713bff6194baeaea52506962d399965b0571d17e32a1e0af33)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putLandscape")
    def put_landscape(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationLandscape()

        return typing.cast(None, jsii.invoke(self, "putLandscape", [value]))

    @jsii.member(jsii_name="putPortrait")
    def put_portrait(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationPortrait()

        return typing.cast(None, jsii.invoke(self, "putPortrait", [value]))

    @jsii.member(jsii_name="putSquare")
    def put_square(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationSquare()

        return typing.cast(None, jsii.invoke(self, "putSquare", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetLandscape")
    def reset_landscape(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLandscape", []))

    @jsii.member(jsii_name="resetPortrait")
    def reset_portrait(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPortrait", []))

    @jsii.member(jsii_name="resetSquare")
    def reset_square(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSquare", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="landscape")
    def landscape(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationLandscapeOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationLandscapeOutputReference, jsii.get(self, "landscape"))

    @builtins.property
    @jsii.member(jsii_name="portrait")
    def portrait(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationPortraitOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationPortraitOutputReference", jsii.get(self, "portrait"))

    @builtins.property
    @jsii.member(jsii_name="square")
    def square(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationSquareOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationSquareOutputReference", jsii.get(self, "square"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="landscapeInput")
    def landscape_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationLandscape], jsii.get(self, "landscapeInput"))

    @builtins.property
    @jsii.member(jsii_name="portraitInput")
    def portrait_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationPortrait"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationPortrait"], jsii.get(self, "portraitInput"))

    @builtins.property
    @jsii.member(jsii_name="squareInput")
    def square_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationSquare"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationSquare"], jsii.get(self, "squareInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfOrientation]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfOrientation]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfOrientation]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__56896b02fa53c3ffa8b3bd7f0f911470bfe7e4a93075445612fe7aeb1e27c7a5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationPortrait",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationPortrait:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationPortrait(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationPortraitOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationPortraitOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9b76711f97b11778f0c5d5a0880069af1a0feccf351d43ffe041825269933ee7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationPortrait]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationPortrait], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationPortrait],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6b635391d0421d2e443f68f77e5bd136482d1c437c1dbb8c5eb045f7155ea4b8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationSquare",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationSquare:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationSquare(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationSquareOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationSquareOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__319a1f9cc9eabce755885af980c257b02d8b260b7f59cd07ed7589822214d698)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationSquare]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationSquare], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationSquare],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a9d20da8aa1b69365534147c7f7b4414d633c3207dc1ac9dfa80dcb531b4995a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareImQuery",
    jsii_struct_bases=[],
    name_mapping={
        "allowed_transformations": "allowedTransformations",
        "query_var": "queryVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareImQuery:
    def __init__(
        self,
        *,
        allowed_transformations: typing.Sequence[builtins.str],
        query_var: builtins.str,
    ) -> None:
        '''
        :param allowed_transformations: Specifies the transformations that can be applied using the query string parameter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allowed_transformations DataAkamaiImagingPolicyImage#allowed_transformations}
        :param query_var: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#query_var DataAkamaiImagingPolicyImage#query_var}.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8e13ead97d5bf7a2a0b733a95e10f52efa074e0f26d9d63fb299df5c0c633dd3)
            check_type(argname="argument allowed_transformations", value=allowed_transformations, expected_type=type_hints["allowed_transformations"])
            check_type(argname="argument query_var", value=query_var, expected_type=type_hints["query_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "allowed_transformations": allowed_transformations,
            "query_var": query_var,
        }

    @builtins.property
    def allowed_transformations(self) -> typing.List[builtins.str]:
        '''Specifies the transformations that can be applied using the query string parameter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allowed_transformations DataAkamaiImagingPolicyImage#allowed_transformations}
        '''
        result = self._values.get("allowed_transformations")
        assert result is not None, "Required property 'allowed_transformations' is missing"
        return typing.cast(typing.List[builtins.str], result)

    @builtins.property
    def query_var(self) -> builtins.str:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#query_var DataAkamaiImagingPolicyImage#query_var}.'''
        result = self._values.get("query_var")
        assert result is not None, "Required property 'query_var' is missing"
        return typing.cast(builtins.str, result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareImQuery(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareImQueryList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareImQueryList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5c2473f35a378efeb9f610ab695dee0a9b59e479431dda600d1113741904a135)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareImQueryOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be8deb2910367e3bd74c82fbd9e9fdad8f067fc5291196592609770a16894080)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareImQueryOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__558ae54f398b3be900d3de2d20587a2c7ebccf546081e7df3bfa9322b8f7f24b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b0ee2c70d9a5724d0b360011955e40bb70b76a8b0b7e7b96921e3e552a74746a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4790329637019f52c2c3a3d2ef92589c939f236842adec956bcf20e6e8f709ed)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareImQuery]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareImQuery]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareImQuery]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__536595651acc52d61f6492fd45715829733f7d2d9588c8baeba663242740ddce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareImQueryOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareImQueryOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d51da62c5b5d264c85beac85dd0cebefe5ff65dea66b3963620d9117e93017fe)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @builtins.property
    @jsii.member(jsii_name="allowedTransformationsInput")
    def allowed_transformations_input(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "allowedTransformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="queryVarInput")
    def query_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "queryVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowedTransformations")
    def allowed_transformations(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "allowedTransformations"))

    @allowed_transformations.setter
    def allowed_transformations(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__70a4b456d0309aa0f8a91a8a818fc5985cbbfa7f377a8a77b521424e64224795)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowedTransformations", value)

    @builtins.property
    @jsii.member(jsii_name="queryVar")
    def query_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "queryVar"))

    @query_var.setter
    def query_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0fae39b37a86c52a58d039810381d3c57a27160c9e021ca9ee4adfdb913fe61e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "queryVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareImQuery]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareImQuery]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareImQuery]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__08d4ebc4cc6d90c9c70bc5996a5f88b6e47b029009aeaa06c8120a5f58602e8f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareMaxColors",
    jsii_struct_bases=[],
    name_mapping={"colors": "colors", "colors_var": "colorsVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareMaxColors:
    def __init__(
        self,
        *,
        colors: typing.Optional[builtins.str] = None,
        colors_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param colors: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        :param colors_var: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e91e444b0daffc38bd8e102df0412e36c1ef96780053971cc9c41663844fc51c)
            check_type(argname="argument colors", value=colors, expected_type=type_hints["colors"])
            check_type(argname="argument colors_var", value=colors_var, expected_type=type_hints["colors_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if colors is not None:
            self._values["colors"] = colors
        if colors_var is not None:
            self._values["colors_var"] = colors_var

    @builtins.property
    def colors(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        '''
        result = self._values.get("colors")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def colors_var(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        result = self._values.get("colors_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareMaxColors(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareMaxColorsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareMaxColorsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a2e9872b4564bd503c72c177a88a2d0e082ce274a56d21568cd8c23b6c3bc44)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareMaxColorsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e8f1342ecd110ffff1d486e119e5c523e4f58238571b4cc2ef8601b42a6dd7d0)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareMaxColorsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b9d9b940a801c8e224a50c1c187ca6f362a156c801710eaf8f8bbcd74a5b233b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fae4e9173676d6749074bdee090cd5c7691e88da7f950c732f50b63cf35f90d7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__065e8feb2e8ad041e46ee85a29bececfb19993443cc68a55a0a23cde1dd503c1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareMaxColors]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareMaxColors]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9b089d5ded6b9ba2fa51b4751e43940372b2541a5f5239c16cd5c2a622825459)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareMaxColorsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareMaxColorsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6296d4548b2660a97d1616b683debb8b9a800770ca221408154f67683ec08607)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColors")
    def reset_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColors", []))

    @jsii.member(jsii_name="resetColorsVar")
    def reset_colors_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorsVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorsInput")
    def colors_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsInput"))

    @builtins.property
    @jsii.member(jsii_name="colorsVarInput")
    def colors_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsVarInput"))

    @builtins.property
    @jsii.member(jsii_name="colors")
    def colors(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colors"))

    @colors.setter
    def colors(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__021b43027cb58f3baaff0811bf25249988185f010c0e51d8773bc246bd4ac2a0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colors", value)

    @builtins.property
    @jsii.member(jsii_name="colorsVar")
    def colors_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorsVar"))

    @colors_var.setter
    def colors_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7888fb62e9beabb59a1e45ef97f67af670103937eb31283f790e4b31261c76e7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorsVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareMaxColors]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareMaxColors]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareMaxColors]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3aa2c89698bec75d01aca0d03de3c12ca370b9e77f9b47d21b0f8718bb0b13ae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareMirror",
    jsii_struct_bases=[],
    name_mapping={
        "horizontal": "horizontal",
        "horizontal_var": "horizontalVar",
        "vertical": "vertical",
        "vertical_var": "verticalVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareMirror:
    def __init__(
        self,
        *,
        horizontal: typing.Optional[builtins.str] = None,
        horizontal_var: typing.Optional[builtins.str] = None,
        vertical: typing.Optional[builtins.str] = None,
        vertical_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param horizontal: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        :param horizontal_var: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        :param vertical: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        :param vertical_var: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__52e8a2132c31bd4ab21d455347259cc5a73756d3b6d3d8f85f5c7c64db46502a)
            check_type(argname="argument horizontal", value=horizontal, expected_type=type_hints["horizontal"])
            check_type(argname="argument horizontal_var", value=horizontal_var, expected_type=type_hints["horizontal_var"])
            check_type(argname="argument vertical", value=vertical, expected_type=type_hints["vertical"])
            check_type(argname="argument vertical_var", value=vertical_var, expected_type=type_hints["vertical_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if horizontal is not None:
            self._values["horizontal"] = horizontal
        if horizontal_var is not None:
            self._values["horizontal_var"] = horizontal_var
        if vertical is not None:
            self._values["vertical"] = vertical
        if vertical_var is not None:
            self._values["vertical_var"] = vertical_var

    @builtins.property
    def horizontal(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        '''
        result = self._values.get("horizontal")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def horizontal_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        '''
        result = self._values.get("horizontal_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        '''
        result = self._values.get("vertical")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        result = self._values.get("vertical_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareMirror(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareMirrorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareMirrorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f032b98c515814ddcc1dfb11cac7ab83befc01a1c9adeb29fa7a64ff9982a1fd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareMirrorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc83817157b8f0066a7509d10242033260f7e1d21a0df81f29ee9b2fd45d87e9)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareMirrorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1fd6478119ee7c9a79bb42581a15245a733584bc79663eb77f9d80477c90a5ae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__84528019f99d24b179a8d14dd3358fc0cb28879b90c69f5f869fe458c0700d66)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dd57cb90523e26a619a8606d2572c4c91fc751d98a313b7c2de96d7b6c1d838f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareMirror]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareMirror]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2c60811ff3fe44e417dd65ed66bede60daac38108a3db1f97a05b33447325799)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareMirrorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareMirrorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__402efca99bdb5e5ab1e45764b7631d829813309418af7f511177906725726da4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHorizontal")
    def reset_horizontal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontal", []))

    @jsii.member(jsii_name="resetHorizontalVar")
    def reset_horizontal_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontalVar", []))

    @jsii.member(jsii_name="resetVertical")
    def reset_vertical(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVertical", []))

    @jsii.member(jsii_name="resetVerticalVar")
    def reset_vertical_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVerticalVar", []))

    @builtins.property
    @jsii.member(jsii_name="horizontalInput")
    def horizontal_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontalVarInput")
    def horizontal_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalInput")
    def vertical_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalVarInput")
    def vertical_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontal")
    def horizontal(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontal"))

    @horizontal.setter
    def horizontal(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1a09cb7b70645c301d9c2f7eba2c6b65cf8f7726c1f7a7f4c728e6f13873b913)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontal", value)

    @builtins.property
    @jsii.member(jsii_name="horizontalVar")
    def horizontal_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontalVar"))

    @horizontal_var.setter
    def horizontal_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a428038f67ef3391387a7f54a10ac4193dc13a45b90df8f52025d78f64c95f34)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontalVar", value)

    @builtins.property
    @jsii.member(jsii_name="vertical")
    def vertical(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "vertical"))

    @vertical.setter
    def vertical(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab83d20c423b81e6a005909de15caf709ed38154f73448e23bac7b7d67848e93)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "vertical", value)

    @builtins.property
    @jsii.member(jsii_name="verticalVar")
    def vertical_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "verticalVar"))

    @vertical_var.setter
    def vertical_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__92a39ea12a2cec7b75261f7bbb8b1a0073e9b4c1a68b19ef2a19ef2c4bee54ba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "verticalVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareMirror]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareMirror]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareMirror]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fe5e825ab07314b3b385b64aa9f525dc80a2d5264ed2e34598d0f3479db7eccf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareMonoHue",
    jsii_struct_bases=[],
    name_mapping={"hue": "hue", "hue_var": "hueVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareMonoHue:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a4fbf19718f4b444d74d4865c102fb7ff8894a1cd3a5c1a0da44ebd6787448ba)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareMonoHue(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareMonoHueList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareMonoHueList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0376b841cdae8db0a9557e25c929d9f58190633e549895341404687ed7c8710e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareMonoHueOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fc9ab88da1ceb1e37bc1d8aaf4f38218c533e88c157f10f9ac0f6f4fe359ab42)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareMonoHueOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bacfc93c3816415053104eabaebe43261dcb9c4a61da3c7f910b73abde85d81f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb1e0b0337dbc81aeafbb00f5a63a96daf2b1aaca68fdd747042fadd3c41e028)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6d6e91c0ab291c22fe8dd9f1706bdd8cbffa1368d298c7e02ce5d357d521280e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareMonoHue]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareMonoHue]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1a9e9fadb654783f98849988db3699672efb2f211327ad932fec4d5fc1773945)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareMonoHueOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareMonoHueOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a25614bd2b727010d2107178a563fe95465238c2411d44388ba7a7d2fa34bc8a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c27d47ee956c58e56f1671b2a657f75fe28d0f7a2c08b785d1ecb6aa63bc667f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c40a26b3e2036c715bf4635351b9a2bd70786f87524210a179fe6325981c2dc3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareMonoHue]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareMonoHue]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareMonoHue]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1837f788ee8308f8480c169a749a2645c28b2ff045da5c516af9b093822fd469)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareOpacity",
    jsii_struct_bases=[],
    name_mapping={"opacity": "opacity", "opacity_var": "opacityVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareOpacity:
    def __init__(
        self,
        *,
        opacity: typing.Optional[builtins.str] = None,
        opacity_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param opacity: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param opacity_var: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__757777c601d06613b8a2f680f63361e482f47ea90541fed72329c8f42843fe16)
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument opacity_var", value=opacity_var, expected_type=type_hints["opacity_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if opacity is not None:
            self._values["opacity"] = opacity
        if opacity_var is not None:
            self._values["opacity_var"] = opacity_var

    @builtins.property
    def opacity(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def opacity_var(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        result = self._values.get("opacity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareOpacity(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareOpacityList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareOpacityList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6697d3c1a69cc8154661b00cfe256600b9c97365cac6d3c4798459cde6cb4768)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareOpacityOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a451e2ac3defe82bee453baa17ecc60ded0ab4149783fd90be2ce5bc148fa90a)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareOpacityOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__faf2c31ba665f27858b5f90d73da7fad61934915d4f877e1f78502512e70ae60)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e50781ef151110d05dbb196c2cd7c06ae90325baec601cacb435650c04805362)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__600fb8dda1acfb7cd6568ab7b485c8b821938027b50d4a7f1190cfa5e8e5965c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareOpacity]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareOpacity]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3388509b9f146e999d2e89b469cc062054742c7b2a03f0c90d9dc338e45205cf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareOpacityOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareOpacityOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c8cc14175d45445c5e221a3e9a5d537c37b19662aed94f83e186da0ea8453bf8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetOpacityVar")
    def reset_opacity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacityVar", []))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityVarInput")
    def opacity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacity"))

    @opacity.setter
    def opacity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__385fc9bfcf8a7291489212983c3a5d9e33b5c15b9805fa63351ac5cf90f4a53a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacity", value)

    @builtins.property
    @jsii.member(jsii_name="opacityVar")
    def opacity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacityVar"))

    @opacity_var.setter
    def opacity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7531b4dee4da42949c6848252b11bd8c99e74b84c1551ae154bdf33b92275187)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacityVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareOpacity]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareOpacity]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareOpacity]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c880d49ea3bd2a13f7d3a61fd74350a252e5172044991415da3d2df6c1a1dab8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0922bf79185fb255837d5d13fea0de488acafc0bcb068cbe0cbba6f9d689159c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putAppend")
    def put_append(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareAppend, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__14a6f2094efc2783a029766a5e72c2c424211f0bee09dd0d83c3f0b86376da2e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putAppend", [value]))

    @jsii.member(jsii_name="putAspectCrop")
    def put_aspect_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareAspectCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aa94b0751af8da8cdaea441b831d72b89fb57dcce0950d952d8ed987838e095b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putAspectCrop", [value]))

    @jsii.member(jsii_name="putBackgroundColor")
    def put_background_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__caca802d5c40562e32b152947987193eb9231d228bfe9c8ac0679828eb75657d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBackgroundColor", [value]))

    @jsii.member(jsii_name="putBlur")
    def put_blur(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareBlur, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eb3bd114098e4781055f05855dcf3c1134cfbe8427b696311cecdb8faa6a757a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBlur", [value]))

    @jsii.member(jsii_name="putChromaKey")
    def put_chroma_key(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareChromaKey, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__da85ba79aa719cf7d1050461d54d1817a9829bc51e89e06831a4c6aeeaafbaa8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putChromaKey", [value]))

    @jsii.member(jsii_name="putComposite")
    def put_composite(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareComposite, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__56b64c9bc344e3f1be1ed3891741993fc2c5968deb4a329459d423cf5d80e9ca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putComposite", [value]))

    @jsii.member(jsii_name="putCompound")
    def put_compound(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareCompound, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d8a9f00dc4b41b0e88536134653c359f90c954c5834c138473288400fbf114e9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCompound", [value]))

    @jsii.member(jsii_name="putContrast")
    def put_contrast(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareContrast, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2b459969da9b2cf8d2c8d9b4566ff8bed29c8a3b1e44aae565494e7adab8a979)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putContrast", [value]))

    @jsii.member(jsii_name="putCrop")
    def put_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2daf28427c6e7a068eb444898f727f6f0709e9bac9cf3c021ef802707d251af6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCrop", [value]))

    @jsii.member(jsii_name="putFaceCrop")
    def put_face_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareFaceCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__317addb51dc5b8f6b1f6546dae69fe021d5e089069f4861bf185896ad37e3178)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFaceCrop", [value]))

    @jsii.member(jsii_name="putFeatureCrop")
    def put_feature_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareFeatureCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__493aa64c2ec127d67cac6ed31c7a652d936b0ac0290d27c65bd715d51de4eab1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFeatureCrop", [value]))

    @jsii.member(jsii_name="putFitAndFill")
    def put_fit_and_fill(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareFitAndFill, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6b596b7d6edb0a17c610bedcf3e7ea4432761a0ecac61cd0191619960d8d6b86)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFitAndFill", [value]))

    @jsii.member(jsii_name="putGoop")
    def put_goop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareGoop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5468f476559af8b3f4e35c04150ce0d85c96155a2c03de8a62d90e6e8a760d92)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGoop", [value]))

    @jsii.member(jsii_name="putGrayscale")
    def put_grayscale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareGrayscale, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b5402c0dcca51901c06bd089aeb1643513d7f75819cc62c14ab95b951868bdc8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGrayscale", [value]))

    @jsii.member(jsii_name="putHsl")
    def put_hsl(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareHsl, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac513e45d4a29d6804da9ef6661ed2ae7acf07d407bc242dcfb11928ea5c8c5d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsl", [value]))

    @jsii.member(jsii_name="putHsv")
    def put_hsv(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareHsv, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1a8169c29dfe4c42d4b81f073bc39a157d3c39e1f6ab70add04418d72dde9f86)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsv", [value]))

    @jsii.member(jsii_name="putIfDimension")
    def put_if_dimension(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfDimension, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f60c67ae45bf641b05f1f5842aca499666736aa0729d1af82236532b996dbae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfDimension", [value]))

    @jsii.member(jsii_name="putIfOrientation")
    def put_if_orientation(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a838f333357b14b3b7041b4d38ab17da430a33e3d7c760f8ae492b056bc4addf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfOrientation", [value]))

    @jsii.member(jsii_name="putImQuery")
    def put_im_query(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareImQuery, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1a1dfcbd6b52444ebe3f5a08c8ea2487eef0422184a9de69d80b89cac4ed7fb2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putImQuery", [value]))

    @jsii.member(jsii_name="putMaxColors")
    def put_max_colors(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareMaxColors, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__677b62cb8ad22cf58265caef3fda3a17fccb9dd7f99e6141a9c94dec06b00c61)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMaxColors", [value]))

    @jsii.member(jsii_name="putMirror")
    def put_mirror(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareMirror, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cffcf2f634609b8464f715a7a2d1865698d8f9a373d2d8722d05cdcc8d072116)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMirror", [value]))

    @jsii.member(jsii_name="putMonoHue")
    def put_mono_hue(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareMonoHue, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f05cba21b4f0d76bb98b39de9d28744e8661b5c2dff560d56ae2911727be28d4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMonoHue", [value]))

    @jsii.member(jsii_name="putOpacity")
    def put_opacity(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareOpacity, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c1e4e2f071369575df75f46bf564c961e47e64e3c29b9e21643af4a6a0d82149)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putOpacity", [value]))

    @jsii.member(jsii_name="putRegionOfInterestCrop")
    def put_region_of_interest_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareRegionOfInterestCrop", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bda3d8ae7ebdd503627ea3da43408caeeb6d4b640bd1075dfe188087addaa9bb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRegionOfInterestCrop", [value]))

    @jsii.member(jsii_name="putRelativeCrop")
    def put_relative_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareRelativeCrop", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c93fdae0214e63bbb80cfc973dd3cb7c57de6ca2c66ad58f54cd65a3a2f7bd5a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRelativeCrop", [value]))

    @jsii.member(jsii_name="putRemoveColor")
    def put_remove_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareRemoveColor", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3e373cf1c4d07d3a26163be2c729d5ef329779bbed785444903318ded41bbd0c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRemoveColor", [value]))

    @jsii.member(jsii_name="putResize")
    def put_resize(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareResize", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__43c3d9238813d0604c661fec6fb89ec20df8637374c6a26d2957255913abaf8a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putResize", [value]))

    @jsii.member(jsii_name="putRotate")
    def put_rotate(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareRotate", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d20ab15342b45de66068deedc9ced10bdf32031bfaa22124267dab67ec732fe0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRotate", [value]))

    @jsii.member(jsii_name="putScale")
    def put_scale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareScale", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6a6b13eb774f0636e9aba635ba5e22e8454370aedecaae7bffd6b0628d748096)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putScale", [value]))

    @jsii.member(jsii_name="putShear")
    def put_shear(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareShear", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b18b929617faf4b4d5ed07d31206bf9e6b4d3210c13428b2f6786a6cac68f4b9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putShear", [value]))

    @jsii.member(jsii_name="putTrim")
    def put_trim(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareTrim", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5d2cd93b0196f3f2c5619279cd406cb47a463595cbd12d896a5927b52a8c0fe9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTrim", [value]))

    @jsii.member(jsii_name="putUnsharpMask")
    def put_unsharp_mask(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareUnsharpMask", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__33619631aba6e69256f693212711cbe677af2ada2c55d83e3f451a277a92ce2a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putUnsharpMask", [value]))

    @jsii.member(jsii_name="resetAppend")
    def reset_append(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAppend", []))

    @jsii.member(jsii_name="resetAspectCrop")
    def reset_aspect_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspectCrop", []))

    @jsii.member(jsii_name="resetBackgroundColor")
    def reset_background_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBackgroundColor", []))

    @jsii.member(jsii_name="resetBlur")
    def reset_blur(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBlur", []))

    @jsii.member(jsii_name="resetChromaKey")
    def reset_chroma_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChromaKey", []))

    @jsii.member(jsii_name="resetComposite")
    def reset_composite(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetComposite", []))

    @jsii.member(jsii_name="resetCompound")
    def reset_compound(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCompound", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetCrop")
    def reset_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCrop", []))

    @jsii.member(jsii_name="resetFaceCrop")
    def reset_face_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFaceCrop", []))

    @jsii.member(jsii_name="resetFeatureCrop")
    def reset_feature_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureCrop", []))

    @jsii.member(jsii_name="resetFitAndFill")
    def reset_fit_and_fill(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFitAndFill", []))

    @jsii.member(jsii_name="resetGoop")
    def reset_goop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGoop", []))

    @jsii.member(jsii_name="resetGrayscale")
    def reset_grayscale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGrayscale", []))

    @jsii.member(jsii_name="resetHsl")
    def reset_hsl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsl", []))

    @jsii.member(jsii_name="resetHsv")
    def reset_hsv(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsv", []))

    @jsii.member(jsii_name="resetIfDimension")
    def reset_if_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfDimension", []))

    @jsii.member(jsii_name="resetIfOrientation")
    def reset_if_orientation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfOrientation", []))

    @jsii.member(jsii_name="resetImQuery")
    def reset_im_query(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetImQuery", []))

    @jsii.member(jsii_name="resetMaxColors")
    def reset_max_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxColors", []))

    @jsii.member(jsii_name="resetMirror")
    def reset_mirror(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMirror", []))

    @jsii.member(jsii_name="resetMonoHue")
    def reset_mono_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonoHue", []))

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetRegionOfInterestCrop")
    def reset_region_of_interest_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRegionOfInterestCrop", []))

    @jsii.member(jsii_name="resetRelativeCrop")
    def reset_relative_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRelativeCrop", []))

    @jsii.member(jsii_name="resetRemoveColor")
    def reset_remove_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRemoveColor", []))

    @jsii.member(jsii_name="resetResize")
    def reset_resize(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetResize", []))

    @jsii.member(jsii_name="resetRotate")
    def reset_rotate(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRotate", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetShear")
    def reset_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetShear", []))

    @jsii.member(jsii_name="resetTrim")
    def reset_trim(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTrim", []))

    @jsii.member(jsii_name="resetUnsharpMask")
    def reset_unsharp_mask(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUnsharpMask", []))

    @builtins.property
    @jsii.member(jsii_name="append")
    def append(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareAppendList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareAppendList, jsii.get(self, "append"))

    @builtins.property
    @jsii.member(jsii_name="aspectCrop")
    def aspect_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareAspectCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareAspectCropList, jsii.get(self, "aspectCrop"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColor")
    def background_color(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareBackgroundColorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareBackgroundColorList, jsii.get(self, "backgroundColor"))

    @builtins.property
    @jsii.member(jsii_name="blur")
    def blur(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareBlurList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareBlurList, jsii.get(self, "blur"))

    @builtins.property
    @jsii.member(jsii_name="chromaKey")
    def chroma_key(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareChromaKeyList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareChromaKeyList, jsii.get(self, "chromaKey"))

    @builtins.property
    @jsii.member(jsii_name="composite")
    def composite(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareCompositeList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareCompositeList, jsii.get(self, "composite"))

    @builtins.property
    @jsii.member(jsii_name="compound")
    def compound(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareCompoundList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareCompoundList, jsii.get(self, "compound"))

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareContrastList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareContrastList, jsii.get(self, "contrast"))

    @builtins.property
    @jsii.member(jsii_name="crop")
    def crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareCropList, jsii.get(self, "crop"))

    @builtins.property
    @jsii.member(jsii_name="faceCrop")
    def face_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareFaceCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareFaceCropList, jsii.get(self, "faceCrop"))

    @builtins.property
    @jsii.member(jsii_name="featureCrop")
    def feature_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareFeatureCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareFeatureCropList, jsii.get(self, "featureCrop"))

    @builtins.property
    @jsii.member(jsii_name="fitAndFill")
    def fit_and_fill(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareFitAndFillList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareFitAndFillList, jsii.get(self, "fitAndFill"))

    @builtins.property
    @jsii.member(jsii_name="goop")
    def goop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareGoopList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareGoopList, jsii.get(self, "goop"))

    @builtins.property
    @jsii.member(jsii_name="grayscale")
    def grayscale(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareGrayscaleList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareGrayscaleList, jsii.get(self, "grayscale"))

    @builtins.property
    @jsii.member(jsii_name="hsl")
    def hsl(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareHslList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareHslList, jsii.get(self, "hsl"))

    @builtins.property
    @jsii.member(jsii_name="hsv")
    def hsv(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareHsvList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareHsvList, jsii.get(self, "hsv"))

    @builtins.property
    @jsii.member(jsii_name="ifDimension")
    def if_dimension(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionList, jsii.get(self, "ifDimension"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientation")
    def if_orientation(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationList, jsii.get(self, "ifOrientation"))

    @builtins.property
    @jsii.member(jsii_name="imQuery")
    def im_query(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareImQueryList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareImQueryList, jsii.get(self, "imQuery"))

    @builtins.property
    @jsii.member(jsii_name="maxColors")
    def max_colors(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareMaxColorsList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareMaxColorsList, jsii.get(self, "maxColors"))

    @builtins.property
    @jsii.member(jsii_name="mirror")
    def mirror(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareMirrorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareMirrorList, jsii.get(self, "mirror"))

    @builtins.property
    @jsii.member(jsii_name="monoHue")
    def mono_hue(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareMonoHueList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareMonoHueList, jsii.get(self, "monoHue"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareOpacityList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareOpacityList, jsii.get(self, "opacity"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestCrop")
    def region_of_interest_crop(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareRegionOfInterestCropList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareRegionOfInterestCropList", jsii.get(self, "regionOfInterestCrop"))

    @builtins.property
    @jsii.member(jsii_name="relativeCrop")
    def relative_crop(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareRelativeCropList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareRelativeCropList", jsii.get(self, "relativeCrop"))

    @builtins.property
    @jsii.member(jsii_name="removeColor")
    def remove_color(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareRemoveColorList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareRemoveColorList", jsii.get(self, "removeColor"))

    @builtins.property
    @jsii.member(jsii_name="resize")
    def resize(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareResizeList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareResizeList", jsii.get(self, "resize"))

    @builtins.property
    @jsii.member(jsii_name="rotate")
    def rotate(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareRotateList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareRotateList", jsii.get(self, "rotate"))

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareScaleList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareScaleList", jsii.get(self, "scale"))

    @builtins.property
    @jsii.member(jsii_name="shear")
    def shear(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareShearList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareShearList", jsii.get(self, "shear"))

    @builtins.property
    @jsii.member(jsii_name="trim")
    def trim(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareTrimList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareTrimList", jsii.get(self, "trim"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMask")
    def unsharp_mask(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareUnsharpMaskList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareUnsharpMaskList", jsii.get(self, "unsharpMask"))

    @builtins.property
    @jsii.member(jsii_name="appendInput")
    def append_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareAppend]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareAppend]]], jsii.get(self, "appendInput"))

    @builtins.property
    @jsii.member(jsii_name="aspectCropInput")
    def aspect_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareAspectCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareAspectCrop]]], jsii.get(self, "aspectCropInput"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColorInput")
    def background_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareBackgroundColor]]], jsii.get(self, "backgroundColorInput"))

    @builtins.property
    @jsii.member(jsii_name="blurInput")
    def blur_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareBlur]]], jsii.get(self, "blurInput"))

    @builtins.property
    @jsii.member(jsii_name="chromaKeyInput")
    def chroma_key_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareChromaKey]]], jsii.get(self, "chromaKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="compositeInput")
    def composite_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareComposite]]], jsii.get(self, "compositeInput"))

    @builtins.property
    @jsii.member(jsii_name="compoundInput")
    def compound_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareCompound]]], jsii.get(self, "compoundInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareContrast]]], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="cropInput")
    def crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareCrop]]], jsii.get(self, "cropInput"))

    @builtins.property
    @jsii.member(jsii_name="faceCropInput")
    def face_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareFaceCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareFaceCrop]]], jsii.get(self, "faceCropInput"))

    @builtins.property
    @jsii.member(jsii_name="featureCropInput")
    def feature_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareFeatureCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareFeatureCrop]]], jsii.get(self, "featureCropInput"))

    @builtins.property
    @jsii.member(jsii_name="fitAndFillInput")
    def fit_and_fill_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareFitAndFill]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareFitAndFill]]], jsii.get(self, "fitAndFillInput"))

    @builtins.property
    @jsii.member(jsii_name="goopInput")
    def goop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareGoop]]], jsii.get(self, "goopInput"))

    @builtins.property
    @jsii.member(jsii_name="grayscaleInput")
    def grayscale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareGrayscale]]], jsii.get(self, "grayscaleInput"))

    @builtins.property
    @jsii.member(jsii_name="hslInput")
    def hsl_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareHsl]]], jsii.get(self, "hslInput"))

    @builtins.property
    @jsii.member(jsii_name="hsvInput")
    def hsv_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareHsv]]], jsii.get(self, "hsvInput"))

    @builtins.property
    @jsii.member(jsii_name="ifDimensionInput")
    def if_dimension_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfDimension]]], jsii.get(self, "ifDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientationInput")
    def if_orientation_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfOrientation]]], jsii.get(self, "ifOrientationInput"))

    @builtins.property
    @jsii.member(jsii_name="imQueryInput")
    def im_query_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareImQuery]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareImQuery]]], jsii.get(self, "imQueryInput"))

    @builtins.property
    @jsii.member(jsii_name="maxColorsInput")
    def max_colors_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareMaxColors]]], jsii.get(self, "maxColorsInput"))

    @builtins.property
    @jsii.member(jsii_name="mirrorInput")
    def mirror_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareMirror]]], jsii.get(self, "mirrorInput"))

    @builtins.property
    @jsii.member(jsii_name="monoHueInput")
    def mono_hue_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareMonoHue]]], jsii.get(self, "monoHueInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareOpacity]]], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestCropInput")
    def region_of_interest_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareRegionOfInterestCrop"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareRegionOfInterestCrop"]]], jsii.get(self, "regionOfInterestCropInput"))

    @builtins.property
    @jsii.member(jsii_name="relativeCropInput")
    def relative_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareRelativeCrop"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareRelativeCrop"]]], jsii.get(self, "relativeCropInput"))

    @builtins.property
    @jsii.member(jsii_name="removeColorInput")
    def remove_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareRemoveColor"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareRemoveColor"]]], jsii.get(self, "removeColorInput"))

    @builtins.property
    @jsii.member(jsii_name="resizeInput")
    def resize_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareResize"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareResize"]]], jsii.get(self, "resizeInput"))

    @builtins.property
    @jsii.member(jsii_name="rotateInput")
    def rotate_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareRotate"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareRotate"]]], jsii.get(self, "rotateInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareScale"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareScale"]]], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="shearInput")
    def shear_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareShear"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareShear"]]], jsii.get(self, "shearInput"))

    @builtins.property
    @jsii.member(jsii_name="trimInput")
    def trim_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareTrim"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareTrim"]]], jsii.get(self, "trimInput"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMaskInput")
    def unsharp_mask_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareUnsharpMask"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareUnsharpMask"]]], jsii.get(self, "unsharpMaskInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquare]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquare], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquare],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d1ee1dad2de144dc0a3ba7f2c02a1acaef0040850239b810703863e44a9c05a9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareRegionOfInterestCrop",
    jsii_struct_bases=[],
    name_mapping={
        "region_of_interest": "regionOfInterest",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareRegionOfInterestCrop:
    def __init__(
        self,
        *,
        region_of_interest: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareRegionOfInterestCropRegionOfInterest", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param region_of_interest: region_of_interest block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest DataAkamaiImagingPolicyImage#region_of_interest}
        :param gravity: The placement of the crop area relative to the specified area of interest. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: The placement of the crop area relative to the specified area of interest. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param style: Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(region_of_interest, dict):
            region_of_interest = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareRegionOfInterestCropRegionOfInterest(**region_of_interest)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6207ea859ca02712a5f916a6e2477e3dda83ef0710edadaebdeb7d4e74279a4e)
            check_type(argname="argument region_of_interest", value=region_of_interest, expected_type=type_hints["region_of_interest"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "region_of_interest": region_of_interest,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def region_of_interest(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareRegionOfInterestCropRegionOfInterest":
        '''region_of_interest block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest DataAkamaiImagingPolicyImage#region_of_interest}
        '''
        result = self._values.get("region_of_interest")
        assert result is not None, "Required property 'region_of_interest' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareRegionOfInterestCropRegionOfInterest", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''The placement of the crop area relative to the specified area of interest.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''The placement of the crop area relative to the specified area of interest.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareRegionOfInterestCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareRegionOfInterestCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareRegionOfInterestCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7529d6126811fda68429c9d5261fe0769c3546962121756ca04edd0b375b07e4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareRegionOfInterestCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1bb6dac71d1c5f9a53e1937472ff2bb16d4a4a3be05fc82e278a35a6225895a9)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareRegionOfInterestCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b3ec0af11d924733505f51eefe2e3f8b4934d5dc0a55ac9419458d79f2425a7a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__06af25b76be6026b655ab0e4981dd22542ebdcb2d3088b4121dad47b3e3e9f17)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c5549b12bb945fcf3a8fb8ae7cdf5c8c8c01de8feb46f910ddd22546dce91561)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareRegionOfInterestCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareRegionOfInterestCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareRegionOfInterestCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__590f831948849fdffe967004f9a05809996d9577a2046bc704dcc8a203bfb9a5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareRegionOfInterestCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareRegionOfInterestCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5aa6e518e1fbdab00b175601c7235f2c6cc39ca12fe3ea172909c44c93ba4cc1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putRegionOfInterest")
    def put_region_of_interest(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareRegionOfInterestCropRegionOfInterest()

        return typing.cast(None, jsii.invoke(self, "putRegionOfInterest", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterest")
    def region_of_interest(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareRegionOfInterestCropRegionOfInterestOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareRegionOfInterestCropRegionOfInterestOutputReference", jsii.get(self, "regionOfInterest"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestInput")
    def region_of_interest_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareRegionOfInterestCropRegionOfInterest"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareRegionOfInterestCropRegionOfInterest"], jsii.get(self, "regionOfInterestInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aa86c80dfd3f47c35cc047e7c2368c1057af424a531e3f86d7d32e50cd3c08a1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__41a3857c43184c01d12d15b3cee40b166e668a203965174d9e854c5f89abe1d1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__17a232933c4682d4137f3e97888bce97c418657ad439350e56c8f88e9f5986da)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__32d3b5d462173b14021d2b3fc2e45e0cfb0f45befef5d72fd6d316bb37b50c99)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4807f6b928de400446c8c7fe1ec1dd3684ee186df4200cc5bd99fda54e3249f6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c5bb66e706587fe5123dbbac80d033264326e32bfb56699257dc1ec1d8f3acaa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c764fcbb51d5596231482ea7818a0ee1996586934f89bbc5e5d5d4248bd22db0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f256126ad94d30978db9a922fea1f5ebc8036e7218be78b72a0f7e439df7487)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareRegionOfInterestCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareRegionOfInterestCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareRegionOfInterestCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7353a67e981cbeb671dd6b0d26af8bc847a2027e8ddb8268943b73a1f144ad81)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareRegionOfInterestCropRegionOfInterest",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareRegionOfInterestCropRegionOfInterest:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareRegionOfInterestCropRegionOfInterest(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareRegionOfInterestCropRegionOfInterestOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareRegionOfInterestCropRegionOfInterestOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7b3caa532ff2ba6680b9dcd12d32685d93332c87459a64a5e8efcd5e4f636b55)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareRegionOfInterestCropRegionOfInterest]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareRegionOfInterestCropRegionOfInterest], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareRegionOfInterestCropRegionOfInterest],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9f6c7e145a045dddb71ddafb8660548b304792666ba63fdba951f964cd664ca1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareRelativeCrop",
    jsii_struct_bases=[],
    name_mapping={
        "east": "east",
        "east_var": "eastVar",
        "north": "north",
        "north_var": "northVar",
        "south": "south",
        "south_var": "southVar",
        "west": "west",
        "west_var": "westVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareRelativeCrop:
    def __init__(
        self,
        *,
        east: typing.Optional[builtins.str] = None,
        east_var: typing.Optional[builtins.str] = None,
        north: typing.Optional[builtins.str] = None,
        north_var: typing.Optional[builtins.str] = None,
        south: typing.Optional[builtins.str] = None,
        south_var: typing.Optional[builtins.str] = None,
        west: typing.Optional[builtins.str] = None,
        west_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param east: The number of pixels to shrink or expand the right side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east DataAkamaiImagingPolicyImage#east}
        :param east_var: The number of pixels to shrink or expand the right side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east_var DataAkamaiImagingPolicyImage#east_var}
        :param north: The number of pixels to shrink or expand the top side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north DataAkamaiImagingPolicyImage#north}
        :param north_var: The number of pixels to shrink or expand the top side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north_var DataAkamaiImagingPolicyImage#north_var}
        :param south: The number of pixels to shrink or expand the bottom side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south DataAkamaiImagingPolicyImage#south}
        :param south_var: The number of pixels to shrink or expand the bottom side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south_var DataAkamaiImagingPolicyImage#south_var}
        :param west: The number of pixels to shrink or expand the left side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west DataAkamaiImagingPolicyImage#west}
        :param west_var: The number of pixels to shrink or expand the left side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west_var DataAkamaiImagingPolicyImage#west_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__737c699a0d50e46d324bcb0b9ef302ad5a1c8624aab0c53c85f29a9852b557fa)
            check_type(argname="argument east", value=east, expected_type=type_hints["east"])
            check_type(argname="argument east_var", value=east_var, expected_type=type_hints["east_var"])
            check_type(argname="argument north", value=north, expected_type=type_hints["north"])
            check_type(argname="argument north_var", value=north_var, expected_type=type_hints["north_var"])
            check_type(argname="argument south", value=south, expected_type=type_hints["south"])
            check_type(argname="argument south_var", value=south_var, expected_type=type_hints["south_var"])
            check_type(argname="argument west", value=west, expected_type=type_hints["west"])
            check_type(argname="argument west_var", value=west_var, expected_type=type_hints["west_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if east is not None:
            self._values["east"] = east
        if east_var is not None:
            self._values["east_var"] = east_var
        if north is not None:
            self._values["north"] = north
        if north_var is not None:
            self._values["north_var"] = north_var
        if south is not None:
            self._values["south"] = south
        if south_var is not None:
            self._values["south_var"] = south_var
        if west is not None:
            self._values["west"] = west
        if west_var is not None:
            self._values["west_var"] = west_var

    @builtins.property
    def east(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the right side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east DataAkamaiImagingPolicyImage#east}
        '''
        result = self._values.get("east")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def east_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the right side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east_var DataAkamaiImagingPolicyImage#east_var}
        '''
        result = self._values.get("east_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def north(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the top side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north DataAkamaiImagingPolicyImage#north}
        '''
        result = self._values.get("north")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def north_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the top side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north_var DataAkamaiImagingPolicyImage#north_var}
        '''
        result = self._values.get("north_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def south(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the bottom side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south DataAkamaiImagingPolicyImage#south}
        '''
        result = self._values.get("south")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def south_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the bottom side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south_var DataAkamaiImagingPolicyImage#south_var}
        '''
        result = self._values.get("south_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def west(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the left side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west DataAkamaiImagingPolicyImage#west}
        '''
        result = self._values.get("west")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def west_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the left side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west_var DataAkamaiImagingPolicyImage#west_var}
        '''
        result = self._values.get("west_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareRelativeCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareRelativeCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareRelativeCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__84448d62a137b17af2d04ad7c72e0c63dcd4726ed92784e6f738a6dccc2e3f04)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareRelativeCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e9cbbea6e792c565c10885e7a6505bd69f11ce8340a65ddbf4d80b39fdcf7743)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareRelativeCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__488e25a763bc6bcccf1da21cf7a87c31a710ee063d1708f5702789cdcbb6f0a7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__82ccb32a4b7809d1b59dbfe492cf387faf6e9be66569d7607f8cebf5e413a15d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1a46206639bf24c736b4b09a609a95b1679cbb1d669fd2720b9ccf5cded76dd7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareRelativeCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareRelativeCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareRelativeCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b0b2f667088582cc06998d5d42c93d1b46f518f7843a3071a84bd2e0065b20b8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareRelativeCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareRelativeCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__046448fd889ba360e026c0880d17736a350df44e2847bd3184703bacd418f740)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetEast")
    def reset_east(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEast", []))

    @jsii.member(jsii_name="resetEastVar")
    def reset_east_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEastVar", []))

    @jsii.member(jsii_name="resetNorth")
    def reset_north(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNorth", []))

    @jsii.member(jsii_name="resetNorthVar")
    def reset_north_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNorthVar", []))

    @jsii.member(jsii_name="resetSouth")
    def reset_south(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSouth", []))

    @jsii.member(jsii_name="resetSouthVar")
    def reset_south_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSouthVar", []))

    @jsii.member(jsii_name="resetWest")
    def reset_west(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWest", []))

    @jsii.member(jsii_name="resetWestVar")
    def reset_west_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWestVar", []))

    @builtins.property
    @jsii.member(jsii_name="eastInput")
    def east_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "eastInput"))

    @builtins.property
    @jsii.member(jsii_name="eastVarInput")
    def east_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "eastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="northInput")
    def north_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "northInput"))

    @builtins.property
    @jsii.member(jsii_name="northVarInput")
    def north_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "northVarInput"))

    @builtins.property
    @jsii.member(jsii_name="southInput")
    def south_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "southInput"))

    @builtins.property
    @jsii.member(jsii_name="southVarInput")
    def south_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "southVarInput"))

    @builtins.property
    @jsii.member(jsii_name="westInput")
    def west_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "westInput"))

    @builtins.property
    @jsii.member(jsii_name="westVarInput")
    def west_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "westVarInput"))

    @builtins.property
    @jsii.member(jsii_name="east")
    def east(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "east"))

    @east.setter
    def east(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__16a64c83a2be89ab8b2baac88eabc5445374e5ea566ab2b30c41677b1188ff86)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "east", value)

    @builtins.property
    @jsii.member(jsii_name="eastVar")
    def east_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "eastVar"))

    @east_var.setter
    def east_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__56816d8c16ab76dda83cdcafa1dc942ebc74d4fa943d9f4d046ef1c9c634c175)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "eastVar", value)

    @builtins.property
    @jsii.member(jsii_name="north")
    def north(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "north"))

    @north.setter
    def north(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__665c7144dc05276ad3e04b1a5b697dea27604322527497c4688248abd6b5ae90)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "north", value)

    @builtins.property
    @jsii.member(jsii_name="northVar")
    def north_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "northVar"))

    @north_var.setter
    def north_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2713cc6490a2969e64b3b8aba4360620d992818ab6235b40f455831956e87a88)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "northVar", value)

    @builtins.property
    @jsii.member(jsii_name="south")
    def south(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "south"))

    @south.setter
    def south(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0aa4bf7dbf231f5c4461d93a308c80932d429054464d87d3da3f5e200e1d9c1d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "south", value)

    @builtins.property
    @jsii.member(jsii_name="southVar")
    def south_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "southVar"))

    @south_var.setter
    def south_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e491d729403762592532923f799ace5c3c994f652d029452b132aa0c8686b465)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "southVar", value)

    @builtins.property
    @jsii.member(jsii_name="west")
    def west(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "west"))

    @west.setter
    def west(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__12b2a49c8202d8c80f89fcd3dc2ec294dbad615f3bb511482e970cd94cc6c489)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "west", value)

    @builtins.property
    @jsii.member(jsii_name="westVar")
    def west_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "westVar"))

    @west_var.setter
    def west_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__738372ab914e0c7b5742416bc67e447bdfae3f706daef6ae3cce06ca7aa7137a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "westVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareRelativeCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareRelativeCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareRelativeCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e4258027049caed494c539b10c3380981504332de4f67fff6bd034886500cd89)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareRemoveColor",
    jsii_struct_bases=[],
    name_mapping={
        "color": "color",
        "color_var": "colorVar",
        "feather": "feather",
        "feather_var": "featherVar",
        "tolerance": "tolerance",
        "tolerance_var": "toleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareRemoveColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
        feather: typing.Optional[builtins.str] = None,
        feather_var: typing.Optional[builtins.str] = None,
        tolerance: typing.Optional[builtins.str] = None,
        tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        :param feather: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        :param feather_var: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        :param tolerance: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        :param tolerance_var: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eb86046ade4d5baac1c348a0b0f09a7102ac40b2f2391dbd61ce24c2307c990d)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
            check_type(argname="argument feather", value=feather, expected_type=type_hints["feather"])
            check_type(argname="argument feather_var", value=feather_var, expected_type=type_hints["feather_var"])
            check_type(argname="argument tolerance", value=tolerance, expected_type=type_hints["tolerance"])
            check_type(argname="argument tolerance_var", value=tolerance_var, expected_type=type_hints["tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var
        if feather is not None:
            self._values["feather"] = feather
        if feather_var is not None:
            self._values["feather_var"] = feather_var
        if tolerance is not None:
            self._values["tolerance"] = tolerance
        if tolerance_var is not None:
            self._values["tolerance_var"] = tolerance_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        '''
        result = self._values.get("feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather_var(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        '''
        result = self._values.get("feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        '''
        result = self._values.get("tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance_var(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        result = self._values.get("tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareRemoveColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareRemoveColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareRemoveColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b2582dbf37d889d392acd9a94fcafe9ea77d7e10d4e2b326ad689ebc18c07490)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareRemoveColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__53c771cc9ef40acb14672a7b39c9e247411e7521c0117854770bcd27fb355e10)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareRemoveColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fe3942a8097a20e42720c84ab1dce1a19a85339e45857ef7c6293a0ea4774c1e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d2892c42d93ee098b00e521ac7b33fb908027e9c0dcdab23ceb685bc010c3670)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b2717b8ba2295e4ddc2fbd020bbd9f04893a23a883ff51e5bac0792dbd5141f3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareRemoveColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareRemoveColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareRemoveColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__44e08ad5521ee96e2bf24aac175885c67cfb3b34bcc05a3723c62798812a1fdf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareRemoveColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareRemoveColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__20a0c44a83cf26fc6bad510e19049a930b56e79d72e3d852509f6d9ee0107213)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @jsii.member(jsii_name="resetFeather")
    def reset_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeather", []))

    @jsii.member(jsii_name="resetFeatherVar")
    def reset_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatherVar", []))

    @jsii.member(jsii_name="resetTolerance")
    def reset_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTolerance", []))

    @jsii.member(jsii_name="resetToleranceVar")
    def reset_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featherInput")
    def feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherInput"))

    @builtins.property
    @jsii.member(jsii_name="featherVarInput")
    def feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceInput")
    def tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceVarInput")
    def tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b672b420781b65cf1a821937fd68cad7c454840c5bfa92ad2863b429e4079664)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e6f76a1ead8b8e65520c599da7151df52bb53c816e2d3c1d72b2081f1787a39b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="feather")
    def feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "feather"))

    @feather.setter
    def feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c466bdd760510426597aeebf3ecbd4a310912aae55fb45ef3538927ff2b7d9f3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "feather", value)

    @builtins.property
    @jsii.member(jsii_name="featherVar")
    def feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featherVar"))

    @feather_var.setter
    def feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__79c902d30e2b81800287eadff72d743f1dbb7f332d4409db87b8e07026d09c77)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featherVar", value)

    @builtins.property
    @jsii.member(jsii_name="tolerance")
    def tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tolerance"))

    @tolerance.setter
    def tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a217b0f12ab19ecbd601540905eeceb791ed7dd23ebdc8798027fffc212a5933)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tolerance", value)

    @builtins.property
    @jsii.member(jsii_name="toleranceVar")
    def tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "toleranceVar"))

    @tolerance_var.setter
    def tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab43bc1197c793ebfe27ce414b48c8f23d18402864d7fda8ca24cdee649c76e8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "toleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareRemoveColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareRemoveColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareRemoveColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bed23d3061fec9ed229b48e48dc957607d4080913d3e7a36750d60ac79e16bf1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareResize",
    jsii_struct_bases=[],
    name_mapping={
        "aspect": "aspect",
        "aspect_var": "aspectVar",
        "height": "height",
        "height_var": "heightVar",
        "type": "type",
        "type_var": "typeVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareResize:
    def __init__(
        self,
        *,
        aspect: typing.Optional[builtins.str] = None,
        aspect_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param aspect: Preserves the aspect ratio. Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect DataAkamaiImagingPolicyImage#aspect}
        :param aspect_var: Preserves the aspect ratio. Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_var DataAkamaiImagingPolicyImage#aspect_var}
        :param height: The height to resize the source image to. Must be set if height is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height to resize the source image to. Must be set if height is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param type: Sets constraints for the image resize. Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: Sets constraints for the image resize. Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        :param width: The width to resize the source image to. Must be set if width is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width to resize the source image to. Must be set if width is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__294a38b4611d015c20a5cd4345e7f1f5e9032f560887331067c0be09b3bc7609)
            check_type(argname="argument aspect", value=aspect, expected_type=type_hints["aspect"])
            check_type(argname="argument aspect_var", value=aspect_var, expected_type=type_hints["aspect_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if aspect is not None:
            self._values["aspect"] = aspect
        if aspect_var is not None:
            self._values["aspect_var"] = aspect_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def aspect(self) -> typing.Optional[builtins.str]:
        '''Preserves the aspect ratio.

        Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect DataAkamaiImagingPolicyImage#aspect}
        '''
        result = self._values.get("aspect")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def aspect_var(self) -> typing.Optional[builtins.str]:
        '''Preserves the aspect ratio.

        Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_var DataAkamaiImagingPolicyImage#aspect_var}
        '''
        result = self._values.get("aspect_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height to resize the source image to. Must be set if height is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height to resize the source image to. Must be set if height is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''Sets constraints for the image resize.

        Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''Sets constraints for the image resize.

        Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width to resize the source image to. Must be set if width is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width to resize the source image to. Must be set if width is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareResize(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareResizeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareResizeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f6763b48e363c105fdb50cbc6e2db684298c8546c1594be636afce4358408fd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareResizeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__64b2b5fff124a86ead6faa7864061641f6a93bb7a6d67ef992cc1cf005b5cd86)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareResizeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e9347dc8ed00f42df64e6b30d0813c3263ed71bfb707c2fe39fb188b2f571afe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__80ffa8160766e5c2528e20c51197c08b387f180e6666340db8f4778e048d27f2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9348a4bd32de26948855bfc0485c72f43105227ac3c84f9e9a08f3fd5d1c61fc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareResize]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareResize]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareResize]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__259bb5ccfc0be7f0bfc4a7bf0b350e69041a29a8ba127986071ae1e1733a6c3a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareResizeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareResizeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6ab4d9bc61c07262f15dad63cc3ef393af4b8386cc0327c0619e7eddf2ac44d0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAspect")
    def reset_aspect(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspect", []))

    @jsii.member(jsii_name="resetAspectVar")
    def reset_aspect_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspectVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="aspectInput")
    def aspect_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "aspectInput"))

    @builtins.property
    @jsii.member(jsii_name="aspectVarInput")
    def aspect_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "aspectVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="aspect")
    def aspect(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "aspect"))

    @aspect.setter
    def aspect(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dcae121578ea4884e55849b779133f844ccc6c557dcba16ae0590ca5d0fca785)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "aspect", value)

    @builtins.property
    @jsii.member(jsii_name="aspectVar")
    def aspect_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "aspectVar"))

    @aspect_var.setter
    def aspect_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4f1a430f52ddd71f559e5122f08b22b55a0df45d90979f01ec60fac580c63b10)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "aspectVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f438fac8cb3583c688bdeeb7aad4619919e3bb488541b24e66dbab35747399a5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__34c42f495ce7e91ba84f4aab7d6720e0a2c8db66a5fc982efb582050f3f28918)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b9556cc8547db4ba2bf464c37b3375462677f1b1b35b433b15014d4b58c348ba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__28af0b3f821e74cf3bdb376d4a12ceade667ff50cabc9b45023abb50e9f88c32)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ef48457a9abee35ad34bf76ff6b5a4495a0c8d8fb311a08c9e5e5e49673b0986)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a448a187f70e21454759f998ec80ac214cc620643cf460c124913d52a9b5fe3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareResize]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareResize]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareResize]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__52549d091976d25deaade3171495169449da09ae9475c6422f35dce77438d43a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareRotate",
    jsii_struct_bases=[],
    name_mapping={"degrees": "degrees", "degrees_var": "degreesVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareRotate:
    def __init__(
        self,
        *,
        degrees: typing.Optional[builtins.str] = None,
        degrees_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param degrees: The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees DataAkamaiImagingPolicyImage#degrees}
        :param degrees_var: The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees_var DataAkamaiImagingPolicyImage#degrees_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b4c88c99906878594bc7b130051197d342b52051f11ca822aee069accf51114c)
            check_type(argname="argument degrees", value=degrees, expected_type=type_hints["degrees"])
            check_type(argname="argument degrees_var", value=degrees_var, expected_type=type_hints["degrees_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if degrees is not None:
            self._values["degrees"] = degrees
        if degrees_var is not None:
            self._values["degrees_var"] = degrees_var

    @builtins.property
    def degrees(self) -> typing.Optional[builtins.str]:
        '''The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees DataAkamaiImagingPolicyImage#degrees}
        '''
        result = self._values.get("degrees")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def degrees_var(self) -> typing.Optional[builtins.str]:
        '''The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees_var DataAkamaiImagingPolicyImage#degrees_var}
        '''
        result = self._values.get("degrees_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareRotate(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareRotateList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareRotateList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cb76dc5aa19bf81fbcb860681a0e1e7af6453fa63b6d1d722f1a58ad89d053ee)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareRotateOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e79204f3b84072f48c550205d952a572852933fdde87df62a97df93d70431914)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareRotateOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e45f4eac4bc9efe8c40ae4ad9cc011222de1aa60698c79e3e2f8f9332789fb12)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b1bf042b11979395c1adcdcf9293cde827ca108c5ee1bdc0ecc1609bb2c4a457)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c4b822311da6350e0c2dc3d5a0cf35d951eb3078f1bcb0401e0a07763e350570)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareRotate]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareRotate]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareRotate]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__16199ce3b95a64c88a2b8aa14450e863050f2104f903918ca614b6a4e5642272)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareRotateOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareRotateOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9de90009ec760d65ab7771d443dacf2b0e55d98fcd8e46698828a744f840a371)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetDegrees")
    def reset_degrees(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDegrees", []))

    @jsii.member(jsii_name="resetDegreesVar")
    def reset_degrees_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDegreesVar", []))

    @builtins.property
    @jsii.member(jsii_name="degreesInput")
    def degrees_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "degreesInput"))

    @builtins.property
    @jsii.member(jsii_name="degreesVarInput")
    def degrees_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "degreesVarInput"))

    @builtins.property
    @jsii.member(jsii_name="degrees")
    def degrees(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "degrees"))

    @degrees.setter
    def degrees(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b0e56f2b210306f1ceaa57cb98fb4eb028d6111d6d5230798ad6b7b3508af745)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "degrees", value)

    @builtins.property
    @jsii.member(jsii_name="degreesVar")
    def degrees_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "degreesVar"))

    @degrees_var.setter
    def degrees_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fb48bab9a77d6eb6ef306b106c7830f1cca9b9450250432ceab4fe4b07a93dd4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "degreesVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareRotate]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareRotate]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareRotate]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ee246752cda2cb956942ef1336774b49657e7093ba47766f8f8e3c4e412d9721)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareScale",
    jsii_struct_bases=[],
    name_mapping={
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareScale:
    def __init__(
        self,
        *,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param height: Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged. Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged. Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a6f03a2959faa9d8b8d61b501dd1a6c293633d7d6ec779e01802d16f3eb114d0)
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size.

        Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size.

        Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged.

        Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged.

        Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareScale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareScaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareScaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__42b6d0475b281065f86cfd7172a8250f9603ab8c583170e2f0696999fd065a51)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareScaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1e9ae89e7357c5814c04099fbc27856ea9a636bb92a70d9aa0a43731fa5de1c7)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareScaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ad0c16f4868d7fff3f88c1d3aa3670fa14e48bee8938dc2bedd43e051c2555ba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__811128d9fa1115759ebf92bc04588c23714265c5815137cb59d6b87cb29a7b2f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5756d323fd5568a0677e19187fa7e2606132536cc5d48b08e1fe6dcdb7215e42)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareScale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareScale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareScale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d25057d0576b775dd7926d63bf4cde0da3ca641eb0762d4a8b0e665514a1077d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareScaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareScaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cba01b211358b805ede90dded52a561c3ffc8aa39fa8f8895374c10d76a9bb19)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ae3da4bc644924eb1a00bea73ee8b26229a8aa879ffb12e2c774fc2aeb1d3fe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bcf365b046701649f11a3921d3ef5f812e8f85d5b1b02f165954d8289db5aa39)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d805cc6635514b9ce5525e5a99217c82ed43cbf32c9d55891190a1f7681c829a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fea63aa91b5f2ee3c63200630caf354ce9e82722ef17f4697812485fd10445c9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareScale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareScale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareScale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4cf49af4e690371cf819878ef8a1595fa4eb4b6f689fb44a5bf929718767f19a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareShear",
    jsii_struct_bases=[],
    name_mapping={
        "x_shear": "xShear",
        "x_shear_var": "xShearVar",
        "y_shear": "yShear",
        "y_shear_var": "yShearVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareShear:
    def __init__(
        self,
        *,
        x_shear: typing.Optional[builtins.str] = None,
        x_shear_var: typing.Optional[builtins.str] = None,
        y_shear: typing.Optional[builtins.str] = None,
        y_shear_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param x_shear: The amount to shear along the x-axis, measured in multiples of the image's width. Must be set if yShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear DataAkamaiImagingPolicyImage#x_shear}
        :param x_shear_var: The amount to shear along the x-axis, measured in multiples of the image's width. Must be set if yShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear_var DataAkamaiImagingPolicyImage#x_shear_var}
        :param y_shear: The amount to shear along the y-axis, measured in multiples of the image's height. Must be set if xShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear DataAkamaiImagingPolicyImage#y_shear}
        :param y_shear_var: The amount to shear along the y-axis, measured in multiples of the image's height. Must be set if xShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear_var DataAkamaiImagingPolicyImage#y_shear_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9c527fee438a53563de3477aa4bcf05977ecb53f3b468798268e5d0fe97e44a8)
            check_type(argname="argument x_shear", value=x_shear, expected_type=type_hints["x_shear"])
            check_type(argname="argument x_shear_var", value=x_shear_var, expected_type=type_hints["x_shear_var"])
            check_type(argname="argument y_shear", value=y_shear, expected_type=type_hints["y_shear"])
            check_type(argname="argument y_shear_var", value=y_shear_var, expected_type=type_hints["y_shear_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if x_shear is not None:
            self._values["x_shear"] = x_shear
        if x_shear_var is not None:
            self._values["x_shear_var"] = x_shear_var
        if y_shear is not None:
            self._values["y_shear"] = y_shear
        if y_shear_var is not None:
            self._values["y_shear_var"] = y_shear_var

    @builtins.property
    def x_shear(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the x-axis, measured in multiples of the image's width.

        Must be set if yShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear DataAkamaiImagingPolicyImage#x_shear}
        '''
        result = self._values.get("x_shear")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_shear_var(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the x-axis, measured in multiples of the image's width.

        Must be set if yShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear_var DataAkamaiImagingPolicyImage#x_shear_var}
        '''
        result = self._values.get("x_shear_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_shear(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the y-axis, measured in multiples of the image's height.

        Must be set if xShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear DataAkamaiImagingPolicyImage#y_shear}
        '''
        result = self._values.get("y_shear")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_shear_var(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the y-axis, measured in multiples of the image's height.

        Must be set if xShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear_var DataAkamaiImagingPolicyImage#y_shear_var}
        '''
        result = self._values.get("y_shear_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareShear(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareShearList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareShearList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f4fd2c74df17557ce81b9508c70901da5a76c4f31b8feab79c13e7e607b86103)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareShearOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__090cff20fb025d3d6defc0af200c243c30db5ffe93cf7d3a9f451b3192c15c74)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareShearOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__80c6269f3cbe99ab31ed1e5f4aca86e3d6c3fc1cf58637fe10152d623395acf3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__546a25dd26d61968a226cf1d9f2a0035fb4542a61f6484eb613a8f968fe689bd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d230fc1aa62d7a8ef5301e6e41ac7608c57dedae815c7dc09d6159a2471b7b2c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareShear]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareShear]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareShear]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a541858cec62f40caf37b15ce93b69d408ebfd6fe420750502dbda1284a65fd4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareShearOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareShearOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8dda9a6d1ae4ea0d652ac7722a1973e7dd31eed96dfea9defd633731f4af6abd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetXShear")
    def reset_x_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXShear", []))

    @jsii.member(jsii_name="resetXShearVar")
    def reset_x_shear_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXShearVar", []))

    @jsii.member(jsii_name="resetYShear")
    def reset_y_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYShear", []))

    @jsii.member(jsii_name="resetYShearVar")
    def reset_y_shear_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYShearVar", []))

    @builtins.property
    @jsii.member(jsii_name="xShearInput")
    def x_shear_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xShearInput"))

    @builtins.property
    @jsii.member(jsii_name="xShearVarInput")
    def x_shear_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xShearVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yShearInput")
    def y_shear_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yShearInput"))

    @builtins.property
    @jsii.member(jsii_name="yShearVarInput")
    def y_shear_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yShearVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xShear")
    def x_shear(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xShear"))

    @x_shear.setter
    def x_shear(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__559c15b893a9a72643ac3f73211e060fbfa05eb5932c8ae8052cfa857646508f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xShear", value)

    @builtins.property
    @jsii.member(jsii_name="xShearVar")
    def x_shear_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xShearVar"))

    @x_shear_var.setter
    def x_shear_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d1eb78dbf2d47ee29b2f976b50f6e2c21639329b504395ec7896914dcb7e4db4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xShearVar", value)

    @builtins.property
    @jsii.member(jsii_name="yShear")
    def y_shear(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yShear"))

    @y_shear.setter
    def y_shear(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__624b73c8d93c3704eff84f874fa851f78574c9aaf39749b3d8a2f6327a912985)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yShear", value)

    @builtins.property
    @jsii.member(jsii_name="yShearVar")
    def y_shear_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yShearVar"))

    @y_shear_var.setter
    def y_shear_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ed7e14735cae112ccf41433a2c52424ccb87cb6e37dd1fecbe088db08a9bbaf6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yShearVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareShear]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareShear]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareShear]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__70abba92496a1beab6de5ee40a289211d40e33bc93268cb4bc0638d108c3e2d6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareTrim",
    jsii_struct_bases=[],
    name_mapping={
        "fuzz": "fuzz",
        "fuzz_var": "fuzzVar",
        "padding": "padding",
        "padding_var": "paddingVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareTrim:
    def __init__(
        self,
        *,
        fuzz: typing.Optional[builtins.str] = None,
        fuzz_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fuzz: The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz DataAkamaiImagingPolicyImage#fuzz}
        :param fuzz_var: The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz_var DataAkamaiImagingPolicyImage#fuzz_var}
        :param padding: The amount of padding in pixels to add to the trimmed image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: The amount of padding in pixels to add to the trimmed image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8279fea56bd04499e0b0389c23005d2856052bea996ce8553f31a85c3422b9a6)
            check_type(argname="argument fuzz", value=fuzz, expected_type=type_hints["fuzz"])
            check_type(argname="argument fuzz_var", value=fuzz_var, expected_type=type_hints["fuzz_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fuzz is not None:
            self._values["fuzz"] = fuzz
        if fuzz_var is not None:
            self._values["fuzz_var"] = fuzz_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var

    @builtins.property
    def fuzz(self) -> typing.Optional[builtins.str]:
        '''The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz DataAkamaiImagingPolicyImage#fuzz}
        '''
        result = self._values.get("fuzz")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fuzz_var(self) -> typing.Optional[builtins.str]:
        '''The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz_var DataAkamaiImagingPolicyImage#fuzz_var}
        '''
        result = self._values.get("fuzz_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''The amount of padding in pixels to add to the trimmed image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''The amount of padding in pixels to add to the trimmed image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareTrim(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareTrimList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareTrimList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__17baabc14b97fa1db85a1269951bdd4c67b9090b3ded392cd672d7e0d76bbf0a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareTrimOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be9fad572e94c8249edf69765a3858072797d5337272315f0ee89e25591b0295)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareTrimOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c9c70e0c80246efb2cdf9c70fd18e6c8763f32f0823b946b8a564d99347ce174)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__64c5ec2dab11c890426b886ad5d11f5ad8caeb68209036b6194181fa9cdf5150)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__38711600a2a205567cab852c19ac323e2be05a6a8b444c917fa53f55a0e4e50f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareTrim]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareTrim]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareTrim]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__330ee1cfee6e0a599a86f2cb95efebce31a3329277c0f8f3a6be1bae785a8669)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareTrimOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareTrimOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__da71e5740a7b5b06f9da940c6375f5c4690cb49c7aef5302b4fabaedc26de2b4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetFuzz")
    def reset_fuzz(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFuzz", []))

    @jsii.member(jsii_name="resetFuzzVar")
    def reset_fuzz_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFuzzVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @builtins.property
    @jsii.member(jsii_name="fuzzInput")
    def fuzz_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fuzzInput"))

    @builtins.property
    @jsii.member(jsii_name="fuzzVarInput")
    def fuzz_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fuzzVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="fuzz")
    def fuzz(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fuzz"))

    @fuzz.setter
    def fuzz(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3c1d8a0513e8c9bf47bb1dfd0cdabc03684de83140fc891eafcfc7dea7b2d4fb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fuzz", value)

    @builtins.property
    @jsii.member(jsii_name="fuzzVar")
    def fuzz_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fuzzVar"))

    @fuzz_var.setter
    def fuzz_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c5044a2f178357318d21656ba5f68dee59ed2b86e509e7d3f2674ce7d1325cae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fuzzVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b74608ec219066a409bda5b79154c33a96cf8bbd3abd1a018a57fe4b47890739)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__95598a1850b369da18d8afde341d6bf9a52842e1817d10af3f821ecf03f54705)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareTrim]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareTrim]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareTrim]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d15a317e37c986a2f8fe26b7953e27f8c33dbbf56951ff89610dc79d7b25b83)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareUnsharpMask",
    jsii_struct_bases=[],
    name_mapping={
        "gain": "gain",
        "gain_var": "gainVar",
        "sigma": "sigma",
        "sigma_var": "sigmaVar",
        "threshold": "threshold",
        "threshold_var": "thresholdVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareUnsharpMask:
    def __init__(
        self,
        *,
        gain: typing.Optional[builtins.str] = None,
        gain_var: typing.Optional[builtins.str] = None,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
        threshold: typing.Optional[builtins.str] = None,
        threshold_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param gain: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        :param gain_var: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        :param sigma: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        :param threshold: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        :param threshold_var: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c66054391f9ff430ed6082a41d2b1195585216ea753286536abea0de6bdbfbc6)
            check_type(argname="argument gain", value=gain, expected_type=type_hints["gain"])
            check_type(argname="argument gain_var", value=gain_var, expected_type=type_hints["gain_var"])
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
            check_type(argname="argument threshold", value=threshold, expected_type=type_hints["threshold"])
            check_type(argname="argument threshold_var", value=threshold_var, expected_type=type_hints["threshold_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if gain is not None:
            self._values["gain"] = gain
        if gain_var is not None:
            self._values["gain_var"] = gain_var
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var
        if threshold is not None:
            self._values["threshold"] = threshold
        if threshold_var is not None:
            self._values["threshold_var"] = threshold_var

    @builtins.property
    def gain(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        '''
        result = self._values.get("gain")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gain_var(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        '''
        result = self._values.get("gain_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        '''
        result = self._values.get("threshold")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold_var(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        result = self._values.get("threshold_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareUnsharpMask(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareUnsharpMaskList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareUnsharpMaskList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0de8cff8c21201f369778a76b7bbcd46c3ffaf7072351f5a2ca0b5348deb39ea)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareUnsharpMaskOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4da4bbaf9e6e8fc37a91001c3f9cac514d4b1db43b48d3df60a9d1c6bd6ddef2)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareUnsharpMaskOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__55863b7194d368ae40ead87c32b7dbbf5a80bcbc5c31ebbf8a5c15be10f1d643)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f53fa89a8e94b6123fa9f11df2e56fee35eb7362ea83479d1191372aa2f57845)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d63c554f4681d1fa93159c4655f9dded41b2541f21deb6be9473ea65414e256f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareUnsharpMask]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareUnsharpMask]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareUnsharpMask]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__efed3d665912efe2a894f5a04da1ac1187edaa3aad883534ac03f7a33f1c9906)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareUnsharpMaskOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareUnsharpMaskOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d5f4d23074f6bb1004fa883fac9bab25fc1757b8bc26aadb67044d38c6615aef)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetGain")
    def reset_gain(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGain", []))

    @jsii.member(jsii_name="resetGainVar")
    def reset_gain_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGainVar", []))

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @jsii.member(jsii_name="resetThreshold")
    def reset_threshold(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThreshold", []))

    @jsii.member(jsii_name="resetThresholdVar")
    def reset_threshold_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThresholdVar", []))

    @builtins.property
    @jsii.member(jsii_name="gainInput")
    def gain_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainInput"))

    @builtins.property
    @jsii.member(jsii_name="gainVarInput")
    def gain_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdInput")
    def threshold_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdVarInput")
    def threshold_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gain")
    def gain(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gain"))

    @gain.setter
    def gain(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ffbf3380283b2655dbc285d0ee2f22dcdbc85872e803e92939e9628b33dad46c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gain", value)

    @builtins.property
    @jsii.member(jsii_name="gainVar")
    def gain_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gainVar"))

    @gain_var.setter
    def gain_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__155477a3093f4d58b9465191999f059d102e4218c2d571ffb4db7d9b65f51e96)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gainVar", value)

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__77b9ed7c952ff1ccb87897c54de2a9a69be8062fedfc4bf88680dc84ef4c2bdd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__64d64d30073a2624f851d14eed2d89576ecc0de2d405ce2f2a0dbccf669741f2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="threshold")
    def threshold(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "threshold"))

    @threshold.setter
    def threshold(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4c7e8a88c29d29ee95170dea16dd8562e158378b6dbf9bee5003c7f0e3e6c85e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "threshold", value)

    @builtins.property
    @jsii.member(jsii_name="thresholdVar")
    def threshold_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "thresholdVar"))

    @threshold_var.setter
    def threshold_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9b36890328c4e75dd899517d3d3499ee07d1acc00badd8af5349d971fa06e66e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "thresholdVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareUnsharpMask]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareUnsharpMask]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareUnsharpMask]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0178b4b2a2bf80c8368f07c2cff45157a92e6576004b4d0a121a045b645f8655)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultImQuery",
    jsii_struct_bases=[],
    name_mapping={
        "allowed_transformations": "allowedTransformations",
        "query_var": "queryVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultImQuery:
    def __init__(
        self,
        *,
        allowed_transformations: typing.Sequence[builtins.str],
        query_var: builtins.str,
    ) -> None:
        '''
        :param allowed_transformations: Specifies the transformations that can be applied using the query string parameter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allowed_transformations DataAkamaiImagingPolicyImage#allowed_transformations}
        :param query_var: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#query_var DataAkamaiImagingPolicyImage#query_var}.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3555da39899fdd5d1c06f726e663e27318ab50abddec5cad8ae5caa772ae8f54)
            check_type(argname="argument allowed_transformations", value=allowed_transformations, expected_type=type_hints["allowed_transformations"])
            check_type(argname="argument query_var", value=query_var, expected_type=type_hints["query_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "allowed_transformations": allowed_transformations,
            "query_var": query_var,
        }

    @builtins.property
    def allowed_transformations(self) -> typing.List[builtins.str]:
        '''Specifies the transformations that can be applied using the query string parameter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allowed_transformations DataAkamaiImagingPolicyImage#allowed_transformations}
        '''
        result = self._values.get("allowed_transformations")
        assert result is not None, "Required property 'allowed_transformations' is missing"
        return typing.cast(typing.List[builtins.str], result)

    @builtins.property
    def query_var(self) -> builtins.str:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#query_var DataAkamaiImagingPolicyImage#query_var}.'''
        result = self._values.get("query_var")
        assert result is not None, "Required property 'query_var' is missing"
        return typing.cast(builtins.str, result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultImQuery(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultImQueryList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultImQueryList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9e351131ed9a75b4bf4b4ece22bd009901002cc111cce2b65318ecb002c59d0d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultImQueryOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__722a38328d4addd141445ecd9f4b242008f6a82a63585d5f128ea309febc750c)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultImQueryOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2c9ded8f2d56d58ec52758ef3ca515180e72a6cc6303566724bf29c382c0eeb7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b57a41fe84484f3a6ec40f96ad9045b61aa3ecbc519372c4f47a76edbe8d1992)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5af4891016e5a7b8b6b0e5e18946ecc1bdb8096a08d1c44a3fb4540024dc1df3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultImQuery]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultImQuery]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultImQuery]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d907dc386a14413919aa114ad889de9a2de0bcd54d7939577a7c30f3936af578)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultImQueryOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultImQueryOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b7dc2f5dc516b862c17e2389b33df366ececfe2b2954050a8abdd17485c75d92)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @builtins.property
    @jsii.member(jsii_name="allowedTransformationsInput")
    def allowed_transformations_input(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "allowedTransformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="queryVarInput")
    def query_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "queryVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowedTransformations")
    def allowed_transformations(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "allowedTransformations"))

    @allowed_transformations.setter
    def allowed_transformations(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2fb6355084a81fae4333b71861d8d055529600bc647979f6a77a5b6621fab993)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowedTransformations", value)

    @builtins.property
    @jsii.member(jsii_name="queryVar")
    def query_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "queryVar"))

    @query_var.setter
    def query_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6d4d560e05072c9c0bb37b97e5048320925a5177d41d7c6f3b03aa27f450672f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "queryVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultImQuery]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultImQuery]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultImQuery]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__30526aecc73675de8e00f89e1dcf1cfd0ee576c2c05019af6a930dddba6d0d72)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultMaxColors",
    jsii_struct_bases=[],
    name_mapping={"colors": "colors", "colors_var": "colorsVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultMaxColors:
    def __init__(
        self,
        *,
        colors: typing.Optional[builtins.str] = None,
        colors_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param colors: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        :param colors_var: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6b69011c73a026cdb46b729f6a6d629168f261737141cc6a5e31906ca8b5fd53)
            check_type(argname="argument colors", value=colors, expected_type=type_hints["colors"])
            check_type(argname="argument colors_var", value=colors_var, expected_type=type_hints["colors_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if colors is not None:
            self._values["colors"] = colors
        if colors_var is not None:
            self._values["colors_var"] = colors_var

    @builtins.property
    def colors(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        '''
        result = self._values.get("colors")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def colors_var(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        result = self._values.get("colors_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultMaxColors(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultMaxColorsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultMaxColorsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__62752fb04fb77a74d077b79374cf25814d8ec3bc53b0d62a50badde9b7cf245b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultMaxColorsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eba706a0bdc399d2cc6abe5d7245190693c98b5e899ebe63df9f38ba7d324266)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultMaxColorsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3b4b78d105c9fffeab6e44c14c951b7861fef28e14b03368a5cbac5c2c32dc7e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ff6153a699dd58ec0e983d486547fdb12c156f7b97a3f88ba77f570b0c7101f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a709f9d3dc4769eb38f7f322200d8abec1d9428c956d1e40b2f9d9d74132513a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultMaxColors]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultMaxColors]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__07d6eb65b0f804b70b644cc6bf2f0db9ffb43a49af63b4500d704d30be27f644)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultMaxColorsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultMaxColorsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a37e8aa14055d3ac02b1a126d91505f985cc05f70048ef786b3014b83e1c3e1d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColors")
    def reset_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColors", []))

    @jsii.member(jsii_name="resetColorsVar")
    def reset_colors_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorsVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorsInput")
    def colors_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsInput"))

    @builtins.property
    @jsii.member(jsii_name="colorsVarInput")
    def colors_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsVarInput"))

    @builtins.property
    @jsii.member(jsii_name="colors")
    def colors(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colors"))

    @colors.setter
    def colors(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__077f7b12b38a8de0041a5fcc3db6170628556c8ab60f25a93a5a746c1bf2f415)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colors", value)

    @builtins.property
    @jsii.member(jsii_name="colorsVar")
    def colors_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorsVar"))

    @colors_var.setter
    def colors_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5947356d9446d93f5e2e71dd109221af86d8057e7ac69d36b6847c64b2c9c8ce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorsVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultMaxColors]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultMaxColors]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultMaxColors]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2c1d9ebaaa730651f6048cb4093200c32d4d10ca6e36f27cfd9ad926e1c3e947)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultMirror",
    jsii_struct_bases=[],
    name_mapping={
        "horizontal": "horizontal",
        "horizontal_var": "horizontalVar",
        "vertical": "vertical",
        "vertical_var": "verticalVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultMirror:
    def __init__(
        self,
        *,
        horizontal: typing.Optional[builtins.str] = None,
        horizontal_var: typing.Optional[builtins.str] = None,
        vertical: typing.Optional[builtins.str] = None,
        vertical_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param horizontal: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        :param horizontal_var: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        :param vertical: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        :param vertical_var: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__830a66a539c091b1c087fcf349796dcbaf57ff044a7c8fd31dd98068c020f4c9)
            check_type(argname="argument horizontal", value=horizontal, expected_type=type_hints["horizontal"])
            check_type(argname="argument horizontal_var", value=horizontal_var, expected_type=type_hints["horizontal_var"])
            check_type(argname="argument vertical", value=vertical, expected_type=type_hints["vertical"])
            check_type(argname="argument vertical_var", value=vertical_var, expected_type=type_hints["vertical_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if horizontal is not None:
            self._values["horizontal"] = horizontal
        if horizontal_var is not None:
            self._values["horizontal_var"] = horizontal_var
        if vertical is not None:
            self._values["vertical"] = vertical
        if vertical_var is not None:
            self._values["vertical_var"] = vertical_var

    @builtins.property
    def horizontal(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        '''
        result = self._values.get("horizontal")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def horizontal_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        '''
        result = self._values.get("horizontal_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        '''
        result = self._values.get("vertical")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        result = self._values.get("vertical_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultMirror(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultMirrorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultMirrorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__73d89d3a8ef5e238ec538a9470aaf7c6a58b108a62086991ec2fa8282b9987f1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultMirrorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__71debddd93fbead9c5b2a78c2108dc0a0512d67288f2b308a72e653368f327bb)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultMirrorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a06b4ecb06d094a86696fc51996a7b9f5eeccdc82651ce8b82398a89dd8fd1c4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5a2f937f1eac155190d881fdcad133f8667d765cd6d04c2d8362bcf642dd8990)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__89c24594a7f1cea25776283ce1c9e5cfbd4d852bdaab07fddc29d124ec9d531e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultMirror]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultMirror]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__10f3aca697de2793f11ab896ed0fc6910d99d4f762bf577b3102ac4494f514b6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultMirrorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultMirrorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cfa1699b3f1a87d39477ed2895162c16f5ec8246e3ac870cbaef9b6ee9c4e5b4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHorizontal")
    def reset_horizontal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontal", []))

    @jsii.member(jsii_name="resetHorizontalVar")
    def reset_horizontal_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontalVar", []))

    @jsii.member(jsii_name="resetVertical")
    def reset_vertical(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVertical", []))

    @jsii.member(jsii_name="resetVerticalVar")
    def reset_vertical_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVerticalVar", []))

    @builtins.property
    @jsii.member(jsii_name="horizontalInput")
    def horizontal_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontalVarInput")
    def horizontal_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalInput")
    def vertical_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalVarInput")
    def vertical_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontal")
    def horizontal(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontal"))

    @horizontal.setter
    def horizontal(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c4053c403bb81e57cac0ac4daee8a3cfec8780a878f13c5c1a6d0c094987df15)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontal", value)

    @builtins.property
    @jsii.member(jsii_name="horizontalVar")
    def horizontal_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontalVar"))

    @horizontal_var.setter
    def horizontal_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__72a3246c737b774ca59508b34576261aa7d7a01615a3678fc599e0defff0d76e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontalVar", value)

    @builtins.property
    @jsii.member(jsii_name="vertical")
    def vertical(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "vertical"))

    @vertical.setter
    def vertical(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b04b512a94806019790e3fb8dd44547645df5a708f393a65f7977c6bff577c9b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "vertical", value)

    @builtins.property
    @jsii.member(jsii_name="verticalVar")
    def vertical_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "verticalVar"))

    @vertical_var.setter
    def vertical_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__72fb1e63e146bc15331839a8ae35cc2bf4bf7553cbbe4a56d79cf79651b2237a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "verticalVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultMirror]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultMirror]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultMirror]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6c43e4ac843fc233942cf14b55502065b3c45f9e29fb07028479b90b27fe7680)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultMonoHue",
    jsii_struct_bases=[],
    name_mapping={"hue": "hue", "hue_var": "hueVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultMonoHue:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fe7b2a3b86ec3401d1010132d47bc6863b3b03c778decdc79208cc115bd66ef9)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultMonoHue(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultMonoHueList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultMonoHueList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__83dac72f559f12b9628afa60d45bb968009d04c1202d0c2c8a51c804e3a4b32e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultMonoHueOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__39445fe74a996bb9500c8bc7eb9ab042836638999c6b3922b70d4d44e874e1a0)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultMonoHueOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__79de15f464ac75f05fc946ee09a4bb8536a2c569abc3b81117a5a9d4ea6b2b97)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__abfe436f5d79bd770d71937fbcf5e71adc25b268eb9c4e5a18b0c59471fea2c4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bf73432253aa425c333b111881cef2f1c76e73203c783cb5166d276f0d6903df)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultMonoHue]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultMonoHue]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5cf7113e7a959f63b4131e04b409be53df28b58dbf7cd437e9fbef3c73ab0a60)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultMonoHueOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultMonoHueOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7c19e644e43b42b20a1cacdf295fc868885be221f5c5e8ac63b8c3dfa2d49d2b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__834930e1b7f02b6818e83b90930e9c7747bfa93a82351f83c433c65d7c28ace6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5bb5cc28b352f460145449cb5ca191e00138cc18887574702df53ff797bf0d33)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultMonoHue]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultMonoHue]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultMonoHue]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__340d9411b3d7e8c530a5ded6d508505afb0843093b349f5b39d107405816b71b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultOpacity",
    jsii_struct_bases=[],
    name_mapping={"opacity": "opacity", "opacity_var": "opacityVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultOpacity:
    def __init__(
        self,
        *,
        opacity: typing.Optional[builtins.str] = None,
        opacity_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param opacity: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param opacity_var: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__52f33fa437ea71f916df77de1b45caf346c20a984c422ec179eea119729fd886)
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument opacity_var", value=opacity_var, expected_type=type_hints["opacity_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if opacity is not None:
            self._values["opacity"] = opacity
        if opacity_var is not None:
            self._values["opacity_var"] = opacity_var

    @builtins.property
    def opacity(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def opacity_var(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        result = self._values.get("opacity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultOpacity(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultOpacityList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultOpacityList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__80b8949dced7a6413ca85276cd2ec01e816ff6c2a53b5e3de9a138ab9d2a5234)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultOpacityOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a4399995270c33466947a791a2b60779b9a1e3b4e3f6c395fa8f6154324a4001)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultOpacityOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__103387c266019d308b09a2edcb1daf84f5fc39fbccdf063ef43c9e9858597696)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__19fbf5dc386831ff154107897bd6e53a0ce74494a069cab2a3161ba4ce0ae4f3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__65bb94cdea2ae26ffaa5da8fab494b0363569822684cd1a943c8887fd999c992)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultOpacity]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultOpacity]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6c29e4799aff5860bee0d764b9e684327afe1ee817fddf3116bf060bea83fcb2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultOpacityOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultOpacityOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c09ef90b22a82db54e7f6c5cec5fe20c78b8e488d17a9e34046b4b9896b0f129)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetOpacityVar")
    def reset_opacity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacityVar", []))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityVarInput")
    def opacity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacity"))

    @opacity.setter
    def opacity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ca90670a5021bdc06b9b1b337f0e987d2783600517fe408957591f0c0fa08cff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacity", value)

    @builtins.property
    @jsii.member(jsii_name="opacityVar")
    def opacity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacityVar"))

    @opacity_var.setter
    def opacity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4c86ac1e740ce2e5f0d83e011d78849f17650bed4a8ca43810800ac3498d1edc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacityVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultOpacity]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultOpacity]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultOpacity]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3b678bd9c6643646f1c07f4ecae7d16b2fb932ddc80f831bbd34f232570e9eca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9be38d57d15046dac79c6d6d1a9d95d528f412a8b644220750c3a6421a10201e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putAppend")
    def put_append(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppend, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ff932d9c462dca9e4fe84c3172206d58ab8b7c20d8873117d524c2a059e8f580)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putAppend", [value]))

    @jsii.member(jsii_name="putAspectCrop")
    def put_aspect_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAspectCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__feb9f99ad920e8d213b1225bf32f8fe88bc655e176b3e51cd2036bf95fb2c911)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putAspectCrop", [value]))

    @jsii.member(jsii_name="putBackgroundColor")
    def put_background_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__19d74d3a97a1c5a4af2f7abacf14e99a490ba42b9996b368f9240e1f6f114d67)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBackgroundColor", [value]))

    @jsii.member(jsii_name="putBlur")
    def put_blur(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultBlur, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ebe56c4ab8b2a3e2f6d3a9c82811ac8216eec7fe9b321010534f097a95d7f468)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBlur", [value]))

    @jsii.member(jsii_name="putChromaKey")
    def put_chroma_key(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultChromaKey, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f9c8d1714d17c18df8e1fca0ec3660c17bd14ca9c9cdb2da85b57b00e41bf485)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putChromaKey", [value]))

    @jsii.member(jsii_name="putComposite")
    def put_composite(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultComposite, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a3dab5ef7b9c6395dcf81aa3e4ce190019a72adf1ea7c212dc094a2dcb2162a7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putComposite", [value]))

    @jsii.member(jsii_name="putCompound")
    def put_compound(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompound, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__63227203b0d796575550e7fc1070f8555a571fce03bf90f1d9e8808d997c2c3a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCompound", [value]))

    @jsii.member(jsii_name="putContrast")
    def put_contrast(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultContrast, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__33f7f988c73ffe58156aeebcf8e8be36441e5d890dd7db4d6499c9bcb945abc6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putContrast", [value]))

    @jsii.member(jsii_name="putCrop")
    def put_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__946b6d47477ac1c3a47e8a6aeabc20f6204c6f202639f92d43d4371a57921d32)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCrop", [value]))

    @jsii.member(jsii_name="putFaceCrop")
    def put_face_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFaceCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cce11ec2bf15b217c3884658b7bd753890763528da22288aaa7c623eba16798d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFaceCrop", [value]))

    @jsii.member(jsii_name="putFeatureCrop")
    def put_feature_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFeatureCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f8dfdf50eb33c9a46b13013f2a2ca04693bd4e9979d7bc97608622ab7662ec7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFeatureCrop", [value]))

    @jsii.member(jsii_name="putFitAndFill")
    def put_fit_and_fill(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFill, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac1d103682ad4e978a6d05b9885b101707479917d743c457195a03e6706680b8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFitAndFill", [value]))

    @jsii.member(jsii_name="putGoop")
    def put_goop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultGoop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__55dec016490f966e5df531f8268de9070b5245aac545a45e4c2b0f488c0bcdf0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGoop", [value]))

    @jsii.member(jsii_name="putGrayscale")
    def put_grayscale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultGrayscale, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d8828b17008ad975bf9da72a147ff3d76bbbf9e418a694ddba71729e8984b3a5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGrayscale", [value]))

    @jsii.member(jsii_name="putHsl")
    def put_hsl(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultHsl, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__69012f835fe5240c1cb1e050102e9119f6ad6898c548efe519b39cfc42b9d0e0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsl", [value]))

    @jsii.member(jsii_name="putHsv")
    def put_hsv(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultHsv, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6156b7843a1a6a287d81fea93c06975619058664ce5cf2fe700d335e7daf8b76)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsv", [value]))

    @jsii.member(jsii_name="putIfDimension")
    def put_if_dimension(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimension, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__98a4091c26f13ede54b0933cbfafe3e29e1be3b0a6f042b066308086912578cf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfDimension", [value]))

    @jsii.member(jsii_name="putIfOrientation")
    def put_if_orientation(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__17a510415dd57390f974c17d68b4f29e972fb118409eeb0a16f8757a3b95b60a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfOrientation", [value]))

    @jsii.member(jsii_name="putImQuery")
    def put_im_query(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultImQuery, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__346467e29bc14bd716f5029533d347122984627e0357ad4568d10da83fbeedb8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putImQuery", [value]))

    @jsii.member(jsii_name="putMaxColors")
    def put_max_colors(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultMaxColors, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cef6ec261841d3415b383e5add609a087c7fe2a10731868f6fd3948afce07394)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMaxColors", [value]))

    @jsii.member(jsii_name="putMirror")
    def put_mirror(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultMirror, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ffbf653051d58c96ebc21e523d2143d0c44752fc729b464ff9c35107808ddf25)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMirror", [value]))

    @jsii.member(jsii_name="putMonoHue")
    def put_mono_hue(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultMonoHue, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f1de8b6d835ebd58f58014dd1340ed493ddb95df12cc136e47abc73a0e6c1f2f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMonoHue", [value]))

    @jsii.member(jsii_name="putOpacity")
    def put_opacity(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultOpacity, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d2c19032aebf56c8f50a070628ec6475fa1483dcadf07712d162b547367687c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putOpacity", [value]))

    @jsii.member(jsii_name="putRegionOfInterestCrop")
    def put_region_of_interest_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCrop", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fe34154456069df8f4aad1bb87b0481a1e76239c6677a8e1faecb3f51f47e3a8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRegionOfInterestCrop", [value]))

    @jsii.member(jsii_name="putRelativeCrop")
    def put_relative_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRelativeCrop", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a640a018653689800722f7b80aef3e9d45ba50a2dc2fca236cd4824b89dc636c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRelativeCrop", [value]))

    @jsii.member(jsii_name="putRemoveColor")
    def put_remove_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRemoveColor", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb549f65998ac0f86b50d94a7ed4d92b4521513eb872ce0f11116395627ac693)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRemoveColor", [value]))

    @jsii.member(jsii_name="putResize")
    def put_resize(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultResize", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f3ec9ce11d76dc50f2029e865fad84d917764570601de23c78f4f192822e7c40)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putResize", [value]))

    @jsii.member(jsii_name="putRotate")
    def put_rotate(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRotate", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3f903a4a626c55510f8522a8e8373f6a296ffee26927c3e4883d10230958f0a9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRotate", [value]))

    @jsii.member(jsii_name="putScale")
    def put_scale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultScale", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__55f2a91711cc20c27d30b738a94d3bf22cdbc975dc59afb27723bd68b450a39f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putScale", [value]))

    @jsii.member(jsii_name="putShear")
    def put_shear(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultShear", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d7d0d2378c31826ac100642a62b9dc739b901dc4b29ffdb766f9e78dd2fbe6dc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putShear", [value]))

    @jsii.member(jsii_name="putTrim")
    def put_trim(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultTrim", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9010d9f04371fa4cd5c0b676e182765b87b4bcd6e18a70aac1cb2115df69b576)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTrim", [value]))

    @jsii.member(jsii_name="putUnsharpMask")
    def put_unsharp_mask(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultUnsharpMask", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3cf64917848d8c00be822f3e79a2c3016beda6bd71837955e80a90f7440d46a3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putUnsharpMask", [value]))

    @jsii.member(jsii_name="resetAppend")
    def reset_append(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAppend", []))

    @jsii.member(jsii_name="resetAspectCrop")
    def reset_aspect_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspectCrop", []))

    @jsii.member(jsii_name="resetBackgroundColor")
    def reset_background_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBackgroundColor", []))

    @jsii.member(jsii_name="resetBlur")
    def reset_blur(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBlur", []))

    @jsii.member(jsii_name="resetChromaKey")
    def reset_chroma_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChromaKey", []))

    @jsii.member(jsii_name="resetComposite")
    def reset_composite(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetComposite", []))

    @jsii.member(jsii_name="resetCompound")
    def reset_compound(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCompound", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetCrop")
    def reset_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCrop", []))

    @jsii.member(jsii_name="resetFaceCrop")
    def reset_face_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFaceCrop", []))

    @jsii.member(jsii_name="resetFeatureCrop")
    def reset_feature_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureCrop", []))

    @jsii.member(jsii_name="resetFitAndFill")
    def reset_fit_and_fill(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFitAndFill", []))

    @jsii.member(jsii_name="resetGoop")
    def reset_goop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGoop", []))

    @jsii.member(jsii_name="resetGrayscale")
    def reset_grayscale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGrayscale", []))

    @jsii.member(jsii_name="resetHsl")
    def reset_hsl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsl", []))

    @jsii.member(jsii_name="resetHsv")
    def reset_hsv(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsv", []))

    @jsii.member(jsii_name="resetIfDimension")
    def reset_if_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfDimension", []))

    @jsii.member(jsii_name="resetIfOrientation")
    def reset_if_orientation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfOrientation", []))

    @jsii.member(jsii_name="resetImQuery")
    def reset_im_query(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetImQuery", []))

    @jsii.member(jsii_name="resetMaxColors")
    def reset_max_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxColors", []))

    @jsii.member(jsii_name="resetMirror")
    def reset_mirror(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMirror", []))

    @jsii.member(jsii_name="resetMonoHue")
    def reset_mono_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonoHue", []))

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetRegionOfInterestCrop")
    def reset_region_of_interest_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRegionOfInterestCrop", []))

    @jsii.member(jsii_name="resetRelativeCrop")
    def reset_relative_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRelativeCrop", []))

    @jsii.member(jsii_name="resetRemoveColor")
    def reset_remove_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRemoveColor", []))

    @jsii.member(jsii_name="resetResize")
    def reset_resize(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetResize", []))

    @jsii.member(jsii_name="resetRotate")
    def reset_rotate(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRotate", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetShear")
    def reset_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetShear", []))

    @jsii.member(jsii_name="resetTrim")
    def reset_trim(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTrim", []))

    @jsii.member(jsii_name="resetUnsharpMask")
    def reset_unsharp_mask(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUnsharpMask", []))

    @builtins.property
    @jsii.member(jsii_name="append")
    def append(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendList, jsii.get(self, "append"))

    @builtins.property
    @jsii.member(jsii_name="aspectCrop")
    def aspect_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAspectCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAspectCropList, jsii.get(self, "aspectCrop"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColor")
    def background_color(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultBackgroundColorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultBackgroundColorList, jsii.get(self, "backgroundColor"))

    @builtins.property
    @jsii.member(jsii_name="blur")
    def blur(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultBlurList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultBlurList, jsii.get(self, "blur"))

    @builtins.property
    @jsii.member(jsii_name="chromaKey")
    def chroma_key(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultChromaKeyList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultChromaKeyList, jsii.get(self, "chromaKey"))

    @builtins.property
    @jsii.member(jsii_name="composite")
    def composite(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeList, jsii.get(self, "composite"))

    @builtins.property
    @jsii.member(jsii_name="compound")
    def compound(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompoundList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompoundList, jsii.get(self, "compound"))

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultContrastList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultContrastList, jsii.get(self, "contrast"))

    @builtins.property
    @jsii.member(jsii_name="crop")
    def crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCropList, jsii.get(self, "crop"))

    @builtins.property
    @jsii.member(jsii_name="faceCrop")
    def face_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFaceCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFaceCropList, jsii.get(self, "faceCrop"))

    @builtins.property
    @jsii.member(jsii_name="featureCrop")
    def feature_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFeatureCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFeatureCropList, jsii.get(self, "featureCrop"))

    @builtins.property
    @jsii.member(jsii_name="fitAndFill")
    def fit_and_fill(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillList, jsii.get(self, "fitAndFill"))

    @builtins.property
    @jsii.member(jsii_name="goop")
    def goop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultGoopList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultGoopList, jsii.get(self, "goop"))

    @builtins.property
    @jsii.member(jsii_name="grayscale")
    def grayscale(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultGrayscaleList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultGrayscaleList, jsii.get(self, "grayscale"))

    @builtins.property
    @jsii.member(jsii_name="hsl")
    def hsl(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultHslList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultHslList, jsii.get(self, "hsl"))

    @builtins.property
    @jsii.member(jsii_name="hsv")
    def hsv(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultHsvList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultHsvList, jsii.get(self, "hsv"))

    @builtins.property
    @jsii.member(jsii_name="ifDimension")
    def if_dimension(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionList", jsii.get(self, "ifDimension"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientation")
    def if_orientation(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationList, jsii.get(self, "ifOrientation"))

    @builtins.property
    @jsii.member(jsii_name="imQuery")
    def im_query(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultImQueryList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultImQueryList, jsii.get(self, "imQuery"))

    @builtins.property
    @jsii.member(jsii_name="maxColors")
    def max_colors(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultMaxColorsList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultMaxColorsList, jsii.get(self, "maxColors"))

    @builtins.property
    @jsii.member(jsii_name="mirror")
    def mirror(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultMirrorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultMirrorList, jsii.get(self, "mirror"))

    @builtins.property
    @jsii.member(jsii_name="monoHue")
    def mono_hue(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultMonoHueList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultMonoHueList, jsii.get(self, "monoHue"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultOpacityList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultOpacityList, jsii.get(self, "opacity"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestCrop")
    def region_of_interest_crop(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropList", jsii.get(self, "regionOfInterestCrop"))

    @builtins.property
    @jsii.member(jsii_name="relativeCrop")
    def relative_crop(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRelativeCropList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRelativeCropList", jsii.get(self, "relativeCrop"))

    @builtins.property
    @jsii.member(jsii_name="removeColor")
    def remove_color(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRemoveColorList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRemoveColorList", jsii.get(self, "removeColor"))

    @builtins.property
    @jsii.member(jsii_name="resize")
    def resize(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultResizeList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultResizeList", jsii.get(self, "resize"))

    @builtins.property
    @jsii.member(jsii_name="rotate")
    def rotate(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRotateList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRotateList", jsii.get(self, "rotate"))

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultScaleList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultScaleList", jsii.get(self, "scale"))

    @builtins.property
    @jsii.member(jsii_name="shear")
    def shear(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultShearList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultShearList", jsii.get(self, "shear"))

    @builtins.property
    @jsii.member(jsii_name="trim")
    def trim(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultTrimList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultTrimList", jsii.get(self, "trim"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMask")
    def unsharp_mask(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultUnsharpMaskList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultUnsharpMaskList", jsii.get(self, "unsharpMask"))

    @builtins.property
    @jsii.member(jsii_name="appendInput")
    def append_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppend]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppend]]], jsii.get(self, "appendInput"))

    @builtins.property
    @jsii.member(jsii_name="aspectCropInput")
    def aspect_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAspectCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAspectCrop]]], jsii.get(self, "aspectCropInput"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColorInput")
    def background_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultBackgroundColor]]], jsii.get(self, "backgroundColorInput"))

    @builtins.property
    @jsii.member(jsii_name="blurInput")
    def blur_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultBlur]]], jsii.get(self, "blurInput"))

    @builtins.property
    @jsii.member(jsii_name="chromaKeyInput")
    def chroma_key_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultChromaKey]]], jsii.get(self, "chromaKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="compositeInput")
    def composite_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultComposite]]], jsii.get(self, "compositeInput"))

    @builtins.property
    @jsii.member(jsii_name="compoundInput")
    def compound_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompound]]], jsii.get(self, "compoundInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultContrast]]], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="cropInput")
    def crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCrop]]], jsii.get(self, "cropInput"))

    @builtins.property
    @jsii.member(jsii_name="faceCropInput")
    def face_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFaceCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFaceCrop]]], jsii.get(self, "faceCropInput"))

    @builtins.property
    @jsii.member(jsii_name="featureCropInput")
    def feature_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFeatureCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFeatureCrop]]], jsii.get(self, "featureCropInput"))

    @builtins.property
    @jsii.member(jsii_name="fitAndFillInput")
    def fit_and_fill_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFill]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFill]]], jsii.get(self, "fitAndFillInput"))

    @builtins.property
    @jsii.member(jsii_name="goopInput")
    def goop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultGoop]]], jsii.get(self, "goopInput"))

    @builtins.property
    @jsii.member(jsii_name="grayscaleInput")
    def grayscale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultGrayscale]]], jsii.get(self, "grayscaleInput"))

    @builtins.property
    @jsii.member(jsii_name="hslInput")
    def hsl_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultHsl]]], jsii.get(self, "hslInput"))

    @builtins.property
    @jsii.member(jsii_name="hsvInput")
    def hsv_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultHsv]]], jsii.get(self, "hsvInput"))

    @builtins.property
    @jsii.member(jsii_name="ifDimensionInput")
    def if_dimension_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimension]]], jsii.get(self, "ifDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientationInput")
    def if_orientation_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientation]]], jsii.get(self, "ifOrientationInput"))

    @builtins.property
    @jsii.member(jsii_name="imQueryInput")
    def im_query_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultImQuery]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultImQuery]]], jsii.get(self, "imQueryInput"))

    @builtins.property
    @jsii.member(jsii_name="maxColorsInput")
    def max_colors_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultMaxColors]]], jsii.get(self, "maxColorsInput"))

    @builtins.property
    @jsii.member(jsii_name="mirrorInput")
    def mirror_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultMirror]]], jsii.get(self, "mirrorInput"))

    @builtins.property
    @jsii.member(jsii_name="monoHueInput")
    def mono_hue_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultMonoHue]]], jsii.get(self, "monoHueInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultOpacity]]], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestCropInput")
    def region_of_interest_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCrop"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCrop"]]], jsii.get(self, "regionOfInterestCropInput"))

    @builtins.property
    @jsii.member(jsii_name="relativeCropInput")
    def relative_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRelativeCrop"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRelativeCrop"]]], jsii.get(self, "relativeCropInput"))

    @builtins.property
    @jsii.member(jsii_name="removeColorInput")
    def remove_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRemoveColor"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRemoveColor"]]], jsii.get(self, "removeColorInput"))

    @builtins.property
    @jsii.member(jsii_name="resizeInput")
    def resize_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultResize"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultResize"]]], jsii.get(self, "resizeInput"))

    @builtins.property
    @jsii.member(jsii_name="rotateInput")
    def rotate_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRotate"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRotate"]]], jsii.get(self, "rotateInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultScale"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultScale"]]], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="shearInput")
    def shear_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultShear"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultShear"]]], jsii.get(self, "shearInput"))

    @builtins.property
    @jsii.member(jsii_name="trimInput")
    def trim_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultTrim"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultTrim"]]], jsii.get(self, "trimInput"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMaskInput")
    def unsharp_mask_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultUnsharpMask"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultUnsharpMask"]]], jsii.get(self, "unsharpMaskInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e9b580c81a809145e28847628ec0121e5ea2010fd5b1869e359e9aedc3b91804)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCrop",
    jsii_struct_bases=[],
    name_mapping={
        "region_of_interest": "regionOfInterest",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCrop:
    def __init__(
        self,
        *,
        region_of_interest: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterest", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param region_of_interest: region_of_interest block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest DataAkamaiImagingPolicyImage#region_of_interest}
        :param gravity: The placement of the crop area relative to the specified area of interest. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: The placement of the crop area relative to the specified area of interest. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param style: Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(region_of_interest, dict):
            region_of_interest = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterest(**region_of_interest)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c73283cee2a2dd5cde5ee8be0d42efbd23342d7812d7a1495201fe691bacaf9e)
            check_type(argname="argument region_of_interest", value=region_of_interest, expected_type=type_hints["region_of_interest"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "region_of_interest": region_of_interest,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def region_of_interest(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterest":
        '''region_of_interest block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest DataAkamaiImagingPolicyImage#region_of_interest}
        '''
        result = self._values.get("region_of_interest")
        assert result is not None, "Required property 'region_of_interest' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterest", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''The placement of the crop area relative to the specified area of interest.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''The placement of the crop area relative to the specified area of interest.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be57e6c7b87aaff767f23060e10004d8d99c8c983374332e648bb9e2fb708caa)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1aa2fe7be463e043e5b5cabc69ddd1243d1c90bd47022c6451ac09a5f487f3a6)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d71442071a24385f5db3cc9152e95fd145094888d3d51e33ea5bf7e8fccb83e8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__20340150972c619855ae7fd17239776af35eb3ad269d6ec9517c94a44d289391)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b0a6a70b65109f3439fb342681334678b550446bc9e9d892d0813a7ac217f1af)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ecf824f69ae01ff98ac6768283b34b18ce2463185329c0e8019ff16c1644c553)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eca0a5555c676d2327d90fe27e189f776fe058e25ec9824f8c3a6801df9eb54f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putRegionOfInterest")
    def put_region_of_interest(
        self,
        *,
        circle_shape: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestCircleShape", typing.Dict[builtins.str, typing.Any]]]]] = None,
        point_shape: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestPointShape", typing.Dict[builtins.str, typing.Any]]]]] = None,
        polygon_shape: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestPolygonShape", typing.Dict[builtins.str, typing.Any]]]]] = None,
        rectangle_shape: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestRectangleShape", typing.Dict[builtins.str, typing.Any]]]]] = None,
        union_shape: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestUnionShape", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param circle_shape: circle_shape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#circle_shape DataAkamaiImagingPolicyImage#circle_shape}
        :param point_shape: point_shape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#point_shape DataAkamaiImagingPolicyImage#point_shape}
        :param polygon_shape: polygon_shape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#polygon_shape DataAkamaiImagingPolicyImage#polygon_shape}
        :param rectangle_shape: rectangle_shape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rectangle_shape DataAkamaiImagingPolicyImage#rectangle_shape}
        :param union_shape: union_shape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#union_shape DataAkamaiImagingPolicyImage#union_shape}
        '''
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterest(
            circle_shape=circle_shape,
            point_shape=point_shape,
            polygon_shape=polygon_shape,
            rectangle_shape=rectangle_shape,
            union_shape=union_shape,
        )

        return typing.cast(None, jsii.invoke(self, "putRegionOfInterest", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterest")
    def region_of_interest(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestOutputReference", jsii.get(self, "regionOfInterest"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestInput")
    def region_of_interest_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterest"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterest"], jsii.get(self, "regionOfInterestInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6868cd277dddc7ef97b91c07241b83f1409e4722d4924c358d8d50fa33c25592)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__429e66a9398ab0f1f378212a13330993450e477b1ccbf64cc6b455358f0896c7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__20ff88bbe613f6ee46a55792d619fbdc80479c60f8474962c61f8ff12991d4dc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6c8d9c5c025b3bc59b3f9baad96ad659a32217793a6348acbfdbcd4ee4d60fce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5e8aca9a9e98d3d4875cddc6484dc9f0786e697c0f02def3f029c7ccd2d886a3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0e57bad62b7571b6cb451ea7438b804d37b7d3c0497e5b49cf5d5f4c1833a03a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__acb61eb40b7af3f26e5e6bce035becf26dc156ffe92b5b7221125c1a401c3a4a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a3d15c356d46cec28f5975eb74e6729962336f5d4e43d6beb6e44f51a13f992c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9b67990a564c67e283998276f8253f7fb4ec09e516a42de24c0177a65a347ac0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterest",
    jsii_struct_bases=[],
    name_mapping={
        "circle_shape": "circleShape",
        "point_shape": "pointShape",
        "polygon_shape": "polygonShape",
        "rectangle_shape": "rectangleShape",
        "union_shape": "unionShape",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterest:
    def __init__(
        self,
        *,
        circle_shape: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestCircleShape", typing.Dict[builtins.str, typing.Any]]]]] = None,
        point_shape: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestPointShape", typing.Dict[builtins.str, typing.Any]]]]] = None,
        polygon_shape: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestPolygonShape", typing.Dict[builtins.str, typing.Any]]]]] = None,
        rectangle_shape: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestRectangleShape", typing.Dict[builtins.str, typing.Any]]]]] = None,
        union_shape: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestUnionShape", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param circle_shape: circle_shape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#circle_shape DataAkamaiImagingPolicyImage#circle_shape}
        :param point_shape: point_shape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#point_shape DataAkamaiImagingPolicyImage#point_shape}
        :param polygon_shape: polygon_shape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#polygon_shape DataAkamaiImagingPolicyImage#polygon_shape}
        :param rectangle_shape: rectangle_shape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rectangle_shape DataAkamaiImagingPolicyImage#rectangle_shape}
        :param union_shape: union_shape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#union_shape DataAkamaiImagingPolicyImage#union_shape}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__77949a39506e960097a8755a1fcd4ee2235dce5a2cd2b3823d919fb9d8cba098)
            check_type(argname="argument circle_shape", value=circle_shape, expected_type=type_hints["circle_shape"])
            check_type(argname="argument point_shape", value=point_shape, expected_type=type_hints["point_shape"])
            check_type(argname="argument polygon_shape", value=polygon_shape, expected_type=type_hints["polygon_shape"])
            check_type(argname="argument rectangle_shape", value=rectangle_shape, expected_type=type_hints["rectangle_shape"])
            check_type(argname="argument union_shape", value=union_shape, expected_type=type_hints["union_shape"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if circle_shape is not None:
            self._values["circle_shape"] = circle_shape
        if point_shape is not None:
            self._values["point_shape"] = point_shape
        if polygon_shape is not None:
            self._values["polygon_shape"] = polygon_shape
        if rectangle_shape is not None:
            self._values["rectangle_shape"] = rectangle_shape
        if union_shape is not None:
            self._values["union_shape"] = union_shape

    @builtins.property
    def circle_shape(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestCircleShape"]]]:
        '''circle_shape block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#circle_shape DataAkamaiImagingPolicyImage#circle_shape}
        '''
        result = self._values.get("circle_shape")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestCircleShape"]]], result)

    @builtins.property
    def point_shape(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestPointShape"]]]:
        '''point_shape block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#point_shape DataAkamaiImagingPolicyImage#point_shape}
        '''
        result = self._values.get("point_shape")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestPointShape"]]], result)

    @builtins.property
    def polygon_shape(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestPolygonShape"]]]:
        '''polygon_shape block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#polygon_shape DataAkamaiImagingPolicyImage#polygon_shape}
        '''
        result = self._values.get("polygon_shape")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestPolygonShape"]]], result)

    @builtins.property
    def rectangle_shape(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestRectangleShape"]]]:
        '''rectangle_shape block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rectangle_shape DataAkamaiImagingPolicyImage#rectangle_shape}
        '''
        result = self._values.get("rectangle_shape")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestRectangleShape"]]], result)

    @builtins.property
    def union_shape(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestUnionShape"]]]:
        '''union_shape block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#union_shape DataAkamaiImagingPolicyImage#union_shape}
        '''
        result = self._values.get("union_shape")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestUnionShape"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterest(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestCircleShape",
    jsii_struct_bases=[],
    name_mapping={"center": "center", "radius": "radius", "radius_var": "radiusVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestCircleShape:
    def __init__(
        self,
        *,
        center: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestCircleShapeCenter", typing.Dict[builtins.str, typing.Any]],
        radius: typing.Optional[builtins.str] = None,
        radius_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param center: center block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#center DataAkamaiImagingPolicyImage#center}
        :param radius: The radius of the circle measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#radius DataAkamaiImagingPolicyImage#radius}
        :param radius_var: The radius of the circle measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#radius_var DataAkamaiImagingPolicyImage#radius_var}
        '''
        if isinstance(center, dict):
            center = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestCircleShapeCenter(**center)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ec046e66d1cb9fff3ddb2c3a7379b6d29ce22edf6ae662515907dc89fbf5bd5)
            check_type(argname="argument center", value=center, expected_type=type_hints["center"])
            check_type(argname="argument radius", value=radius, expected_type=type_hints["radius"])
            check_type(argname="argument radius_var", value=radius_var, expected_type=type_hints["radius_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "center": center,
        }
        if radius is not None:
            self._values["radius"] = radius
        if radius_var is not None:
            self._values["radius_var"] = radius_var

    @builtins.property
    def center(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestCircleShapeCenter":
        '''center block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#center DataAkamaiImagingPolicyImage#center}
        '''
        result = self._values.get("center")
        assert result is not None, "Required property 'center' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestCircleShapeCenter", result)

    @builtins.property
    def radius(self) -> typing.Optional[builtins.str]:
        '''The radius of the circle measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#radius DataAkamaiImagingPolicyImage#radius}
        '''
        result = self._values.get("radius")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def radius_var(self) -> typing.Optional[builtins.str]:
        '''The radius of the circle measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#radius_var DataAkamaiImagingPolicyImage#radius_var}
        '''
        result = self._values.get("radius_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestCircleShape(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestCircleShapeCenter",
    jsii_struct_bases=[],
    name_mapping={"x": "x", "x_var": "xVar", "y": "y", "y_var": "yVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestCircleShapeCenter:
    def __init__(
        self,
        *,
        x: typing.Optional[builtins.str] = None,
        x_var: typing.Optional[builtins.str] = None,
        y: typing.Optional[builtins.str] = None,
        y_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param x: The horizontal position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x DataAkamaiImagingPolicyImage#x}
        :param x_var: The horizontal position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_var DataAkamaiImagingPolicyImage#x_var}
        :param y: The vertical position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y DataAkamaiImagingPolicyImage#y}
        :param y_var: The vertical position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_var DataAkamaiImagingPolicyImage#y_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__15ca420c7daec94103918b1378e0f75c7d55f93177f5d41c9056a42cfb607ab4)
            check_type(argname="argument x", value=x, expected_type=type_hints["x"])
            check_type(argname="argument x_var", value=x_var, expected_type=type_hints["x_var"])
            check_type(argname="argument y", value=y, expected_type=type_hints["y"])
            check_type(argname="argument y_var", value=y_var, expected_type=type_hints["y_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if x is not None:
            self._values["x"] = x
        if x_var is not None:
            self._values["x_var"] = x_var
        if y is not None:
            self._values["y"] = y
        if y_var is not None:
            self._values["y_var"] = y_var

    @builtins.property
    def x(self) -> typing.Optional[builtins.str]:
        '''The horizontal position of the point, measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x DataAkamaiImagingPolicyImage#x}
        '''
        result = self._values.get("x")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_var(self) -> typing.Optional[builtins.str]:
        '''The horizontal position of the point, measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_var DataAkamaiImagingPolicyImage#x_var}
        '''
        result = self._values.get("x_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y(self) -> typing.Optional[builtins.str]:
        '''The vertical position of the point, measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y DataAkamaiImagingPolicyImage#y}
        '''
        result = self._values.get("y")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_var(self) -> typing.Optional[builtins.str]:
        '''The vertical position of the point, measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_var DataAkamaiImagingPolicyImage#y_var}
        '''
        result = self._values.get("y_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestCircleShapeCenter(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestCircleShapeCenterOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestCircleShapeCenterOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3fabbde5531a8776501e261e8f9371e7a0527fff6f30e1c0b7144b6395ca593f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetX")
    def reset_x(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetX", []))

    @jsii.member(jsii_name="resetXVar")
    def reset_x_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXVar", []))

    @jsii.member(jsii_name="resetY")
    def reset_y(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetY", []))

    @jsii.member(jsii_name="resetYVar")
    def reset_y_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYVar", []))

    @builtins.property
    @jsii.member(jsii_name="xInput")
    def x_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xInput"))

    @builtins.property
    @jsii.member(jsii_name="xVarInput")
    def x_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yInput")
    def y_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yInput"))

    @builtins.property
    @jsii.member(jsii_name="yVarInput")
    def y_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yVarInput"))

    @builtins.property
    @jsii.member(jsii_name="x")
    def x(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "x"))

    @x.setter
    def x(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__81c53b55d873a18ade1ebab72296747cee2b214bc3ccf0a73710aaa760b338fc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "x", value)

    @builtins.property
    @jsii.member(jsii_name="xVar")
    def x_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xVar"))

    @x_var.setter
    def x_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ca05ec7a4e489939683aa36ece3856615f8bb34ff9d69f96e02a23877ee677ae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xVar", value)

    @builtins.property
    @jsii.member(jsii_name="y")
    def y(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "y"))

    @y.setter
    def y(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d2be4debb1d09ffc4262b902a189b14d7574665c441d9e9a6b95397b512ed336)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "y", value)

    @builtins.property
    @jsii.member(jsii_name="yVar")
    def y_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yVar"))

    @y_var.setter
    def y_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__68ae0affdfb6d3510148e0f2adbe7be409efa1bdb2bf9d284b8016c4480c59ca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestCircleShapeCenter]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestCircleShapeCenter], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestCircleShapeCenter],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cbc4830cab2b27b6ca85035fef47a954f05fdee3d58dd24472992c0093866c71)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestCircleShapeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestCircleShapeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__93064c9825443cc1c40b83add0a444c37a2b01a8ab5da329b1b23f8c81f67bca)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestCircleShapeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a9c6f66f9fc041f71a58d3c05b6944804d117142346e69547967746d9113615d)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestCircleShapeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__45c0aedc9658355065308ed037b399e083c851e55dafaf95281b567324d00cd0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6fb031486a7fc8ffbeb54f80291acd57e7f4cc0c4e870dd3e132dbd3fce34499)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e0653db107f481daaa23a23c28626bd31cd5a3bf4630edf9360df0cc006456cd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestCircleShape]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestCircleShape]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestCircleShape]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__94cade5622c0cfb320a76cc9cdca74fb0f434010a06b122c6307550dcddc8eb6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestCircleShapeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestCircleShapeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6cbac94d8487322f87b2ad30b689e3a492f6606105f220f231a0189e88adf18b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putCenter")
    def put_center(
        self,
        *,
        x: typing.Optional[builtins.str] = None,
        x_var: typing.Optional[builtins.str] = None,
        y: typing.Optional[builtins.str] = None,
        y_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param x: The horizontal position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x DataAkamaiImagingPolicyImage#x}
        :param x_var: The horizontal position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_var DataAkamaiImagingPolicyImage#x_var}
        :param y: The vertical position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y DataAkamaiImagingPolicyImage#y}
        :param y_var: The vertical position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_var DataAkamaiImagingPolicyImage#y_var}
        '''
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestCircleShapeCenter(
            x=x, x_var=x_var, y=y, y_var=y_var
        )

        return typing.cast(None, jsii.invoke(self, "putCenter", [value]))

    @jsii.member(jsii_name="resetRadius")
    def reset_radius(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRadius", []))

    @jsii.member(jsii_name="resetRadiusVar")
    def reset_radius_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRadiusVar", []))

    @builtins.property
    @jsii.member(jsii_name="center")
    def center(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestCircleShapeCenterOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestCircleShapeCenterOutputReference, jsii.get(self, "center"))

    @builtins.property
    @jsii.member(jsii_name="centerInput")
    def center_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestCircleShapeCenter]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestCircleShapeCenter], jsii.get(self, "centerInput"))

    @builtins.property
    @jsii.member(jsii_name="radiusInput")
    def radius_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "radiusInput"))

    @builtins.property
    @jsii.member(jsii_name="radiusVarInput")
    def radius_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "radiusVarInput"))

    @builtins.property
    @jsii.member(jsii_name="radius")
    def radius(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "radius"))

    @radius.setter
    def radius(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__68756c999969890ce0021a921cbb8abc2b8f52d17cd6d2d0311e20aef694db1c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "radius", value)

    @builtins.property
    @jsii.member(jsii_name="radiusVar")
    def radius_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "radiusVar"))

    @radius_var.setter
    def radius_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d3c0e4b31210c067404097e9d4ddae69a3eb0d6cedecd10b54752adf1b92c1a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "radiusVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestCircleShape]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestCircleShape]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestCircleShape]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__757bc957731fa4eeecb5427d2c69725f7cad52bf86418b0ee45c6d7d007000e0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8571139e30c0ea91124c7a2d1ae038c6445feef004a2a882aa87737feca03790)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putCircleShape")
    def put_circle_shape(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestCircleShape, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__721fdbef6ec6678e7358eaa38a225bb13c2c5eab949a79539dae73fd37c86638)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCircleShape", [value]))

    @jsii.member(jsii_name="putPointShape")
    def put_point_shape(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestPointShape", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cb6da82adf1d9e86f44c3db96377ea49f0ff16a42dac3a8a6b8da21448d05081)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putPointShape", [value]))

    @jsii.member(jsii_name="putPolygonShape")
    def put_polygon_shape(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestPolygonShape", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ada9ab541bc0a2e4e187206209834843ee30f08146e5da2ca1b50de3afbbf27)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putPolygonShape", [value]))

    @jsii.member(jsii_name="putRectangleShape")
    def put_rectangle_shape(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestRectangleShape", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8f306e4df7a30c08e093ea31c4f2656f481749dcf051c3e9e8afc681fb3ae21e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRectangleShape", [value]))

    @jsii.member(jsii_name="putUnionShape")
    def put_union_shape(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestUnionShape", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e2453980a90e51265649464b058a577f4373ce7dd0d05d53e9afb0f422af33a2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putUnionShape", [value]))

    @jsii.member(jsii_name="resetCircleShape")
    def reset_circle_shape(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCircleShape", []))

    @jsii.member(jsii_name="resetPointShape")
    def reset_point_shape(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPointShape", []))

    @jsii.member(jsii_name="resetPolygonShape")
    def reset_polygon_shape(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPolygonShape", []))

    @jsii.member(jsii_name="resetRectangleShape")
    def reset_rectangle_shape(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRectangleShape", []))

    @jsii.member(jsii_name="resetUnionShape")
    def reset_union_shape(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUnionShape", []))

    @builtins.property
    @jsii.member(jsii_name="circleShape")
    def circle_shape(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestCircleShapeList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestCircleShapeList, jsii.get(self, "circleShape"))

    @builtins.property
    @jsii.member(jsii_name="pointShape")
    def point_shape(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestPointShapeList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestPointShapeList", jsii.get(self, "pointShape"))

    @builtins.property
    @jsii.member(jsii_name="polygonShape")
    def polygon_shape(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestPolygonShapeList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestPolygonShapeList", jsii.get(self, "polygonShape"))

    @builtins.property
    @jsii.member(jsii_name="rectangleShape")
    def rectangle_shape(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestRectangleShapeList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestRectangleShapeList", jsii.get(self, "rectangleShape"))

    @builtins.property
    @jsii.member(jsii_name="unionShape")
    def union_shape(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestUnionShapeList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestUnionShapeList", jsii.get(self, "unionShape"))

    @builtins.property
    @jsii.member(jsii_name="circleShapeInput")
    def circle_shape_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestCircleShape]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestCircleShape]]], jsii.get(self, "circleShapeInput"))

    @builtins.property
    @jsii.member(jsii_name="pointShapeInput")
    def point_shape_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestPointShape"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestPointShape"]]], jsii.get(self, "pointShapeInput"))

    @builtins.property
    @jsii.member(jsii_name="polygonShapeInput")
    def polygon_shape_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestPolygonShape"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestPolygonShape"]]], jsii.get(self, "polygonShapeInput"))

    @builtins.property
    @jsii.member(jsii_name="rectangleShapeInput")
    def rectangle_shape_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestRectangleShape"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestRectangleShape"]]], jsii.get(self, "rectangleShapeInput"))

    @builtins.property
    @jsii.member(jsii_name="unionShapeInput")
    def union_shape_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestUnionShape"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestUnionShape"]]], jsii.get(self, "unionShapeInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterest]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterest], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterest],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5e2df891fbb9665daaf21af95e480597e062c8acff2abcd35dfa39949aa1751e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestPointShape",
    jsii_struct_bases=[],
    name_mapping={"x": "x", "x_var": "xVar", "y": "y", "y_var": "yVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestPointShape:
    def __init__(
        self,
        *,
        x: typing.Optional[builtins.str] = None,
        x_var: typing.Optional[builtins.str] = None,
        y: typing.Optional[builtins.str] = None,
        y_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param x: The horizontal position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x DataAkamaiImagingPolicyImage#x}
        :param x_var: The horizontal position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_var DataAkamaiImagingPolicyImage#x_var}
        :param y: The vertical position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y DataAkamaiImagingPolicyImage#y}
        :param y_var: The vertical position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_var DataAkamaiImagingPolicyImage#y_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f64195ba6326bf5695fc6008489c0cd3fe0cfedf206ccf6e82b40a65b8c3d8b)
            check_type(argname="argument x", value=x, expected_type=type_hints["x"])
            check_type(argname="argument x_var", value=x_var, expected_type=type_hints["x_var"])
            check_type(argname="argument y", value=y, expected_type=type_hints["y"])
            check_type(argname="argument y_var", value=y_var, expected_type=type_hints["y_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if x is not None:
            self._values["x"] = x
        if x_var is not None:
            self._values["x_var"] = x_var
        if y is not None:
            self._values["y"] = y
        if y_var is not None:
            self._values["y_var"] = y_var

    @builtins.property
    def x(self) -> typing.Optional[builtins.str]:
        '''The horizontal position of the point, measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x DataAkamaiImagingPolicyImage#x}
        '''
        result = self._values.get("x")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_var(self) -> typing.Optional[builtins.str]:
        '''The horizontal position of the point, measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_var DataAkamaiImagingPolicyImage#x_var}
        '''
        result = self._values.get("x_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y(self) -> typing.Optional[builtins.str]:
        '''The vertical position of the point, measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y DataAkamaiImagingPolicyImage#y}
        '''
        result = self._values.get("y")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_var(self) -> typing.Optional[builtins.str]:
        '''The vertical position of the point, measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_var DataAkamaiImagingPolicyImage#y_var}
        '''
        result = self._values.get("y_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestPointShape(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestPointShapeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestPointShapeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c2a22ef60865fde355d38d25190dc996fe4d7bdbd5f26b6b2535688eb3deccc4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestPointShapeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ffc3b8c4f26a094fda9daa90d5bc62896fa1760feab9b35a1c11a5efdaa56c6)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestPointShapeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f7d941292efdf7d9ca8e7293cc877f7c8c7110e49510f5a5f01a8c5f15ed63f2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4acfeb846fbd25705d527b19f41c36ff2f6294cbd0c57e00d06c2807c388d206)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c782ca52c282156bd1af37f4c51358ed14fe5e98bb43d311d77204abad95a17b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestPointShape]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestPointShape]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestPointShape]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aa607d9e3a00ac2e350695e0869c2ad447e4dd886ab07a0c3157695638bc804a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestPointShapeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestPointShapeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__78168c5e5fc8acf9a174005c9c9ac14351f37f6ab9de8b9ac4655e4d62521bc4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetX")
    def reset_x(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetX", []))

    @jsii.member(jsii_name="resetXVar")
    def reset_x_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXVar", []))

    @jsii.member(jsii_name="resetY")
    def reset_y(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetY", []))

    @jsii.member(jsii_name="resetYVar")
    def reset_y_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYVar", []))

    @builtins.property
    @jsii.member(jsii_name="xInput")
    def x_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xInput"))

    @builtins.property
    @jsii.member(jsii_name="xVarInput")
    def x_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yInput")
    def y_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yInput"))

    @builtins.property
    @jsii.member(jsii_name="yVarInput")
    def y_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yVarInput"))

    @builtins.property
    @jsii.member(jsii_name="x")
    def x(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "x"))

    @x.setter
    def x(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c8a9da1549dfc617d42d5a3d71ebd39d80042bb1bc1ef3e035cc22789d175658)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "x", value)

    @builtins.property
    @jsii.member(jsii_name="xVar")
    def x_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xVar"))

    @x_var.setter
    def x_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ae25c5dee2a7ed1b5f5557b37182ffd35cc2c2394c61cd8a7fac38704b87dc89)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xVar", value)

    @builtins.property
    @jsii.member(jsii_name="y")
    def y(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "y"))

    @y.setter
    def y(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__732146da0dd80df68a20e490a9a2ff2737875e6ae2383817225c394c115715ee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "y", value)

    @builtins.property
    @jsii.member(jsii_name="yVar")
    def y_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yVar"))

    @y_var.setter
    def y_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b9778014ec32fc58a16c505fece536d0a80d568ef31c10eea1e60b4decbafb3b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestPointShape]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestPointShape]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestPointShape]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9324db5f230dbc53feac52f5bacba0629273a638f1a3e649875c9320e8366cdb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestPolygonShape",
    jsii_struct_bases=[],
    name_mapping={"points": "points"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestPolygonShape:
    def __init__(
        self,
        *,
        points: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestPolygonShapePoints", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param points: points block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#points DataAkamaiImagingPolicyImage#points}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ca1a4891e66b93e50075624af74f9a696686f3ecd68f417933dcac1e160570d2)
            check_type(argname="argument points", value=points, expected_type=type_hints["points"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "points": points,
        }

    @builtins.property
    def points(
        self,
    ) -> typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestPolygonShapePoints"]]:
        '''points block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#points DataAkamaiImagingPolicyImage#points}
        '''
        result = self._values.get("points")
        assert result is not None, "Required property 'points' is missing"
        return typing.cast(typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestPolygonShapePoints"]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestPolygonShape(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestPolygonShapeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestPolygonShapeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6fec4998fc8156148ca747e54c0cfe188c574fea259668a39ea872b4cf339e6f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestPolygonShapeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3bcaf97e83ae4694d25ed5eb99dd32ee33bb7c4600c6fc9784d6d05816b22f84)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestPolygonShapeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8f944bdb76bf1900fbdbca623bcf82166d317f2adf8309f9303bc5211241eba3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__857e6db99c9e3881bfa2ec05bcc09f075e5e5dc3032a17a52826444a4e72a8c5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__30b519bb78d87b764d3e57f4c65768501c6bd6f239e6d7bafb3b378810412ca0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestPolygonShape]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestPolygonShape]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestPolygonShape]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__52be9b8def8d984fef4f11cf97f1c3b6fcffd93eb7f02893b2e8db642d33419f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestPolygonShapeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestPolygonShapeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5fff22025c2b4dce860ca7bcb6801f5aee003859f4701d3dc9a6678670c2bf17)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putPoints")
    def put_points(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestPolygonShapePoints", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8013449358258b1431a9165885165ea294674ef542a6db4bbf68d18c7cfadb86)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putPoints", [value]))

    @builtins.property
    @jsii.member(jsii_name="points")
    def points(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestPolygonShapePointsList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestPolygonShapePointsList", jsii.get(self, "points"))

    @builtins.property
    @jsii.member(jsii_name="pointsInput")
    def points_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestPolygonShapePoints"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestPolygonShapePoints"]]], jsii.get(self, "pointsInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestPolygonShape]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestPolygonShape]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestPolygonShape]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c7b4f1815a68e33c51fd9a90eb16c65bb4291b43a0aadff2747cb6279a4eb0d6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestPolygonShapePoints",
    jsii_struct_bases=[],
    name_mapping={"x": "x", "x_var": "xVar", "y": "y", "y_var": "yVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestPolygonShapePoints:
    def __init__(
        self,
        *,
        x: typing.Optional[builtins.str] = None,
        x_var: typing.Optional[builtins.str] = None,
        y: typing.Optional[builtins.str] = None,
        y_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param x: The horizontal position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x DataAkamaiImagingPolicyImage#x}
        :param x_var: The horizontal position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_var DataAkamaiImagingPolicyImage#x_var}
        :param y: The vertical position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y DataAkamaiImagingPolicyImage#y}
        :param y_var: The vertical position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_var DataAkamaiImagingPolicyImage#y_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__872fa777196e8453886ebe6a8834ab3c7c9768c1ef4c99202cee9e8bebf18b90)
            check_type(argname="argument x", value=x, expected_type=type_hints["x"])
            check_type(argname="argument x_var", value=x_var, expected_type=type_hints["x_var"])
            check_type(argname="argument y", value=y, expected_type=type_hints["y"])
            check_type(argname="argument y_var", value=y_var, expected_type=type_hints["y_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if x is not None:
            self._values["x"] = x
        if x_var is not None:
            self._values["x_var"] = x_var
        if y is not None:
            self._values["y"] = y
        if y_var is not None:
            self._values["y_var"] = y_var

    @builtins.property
    def x(self) -> typing.Optional[builtins.str]:
        '''The horizontal position of the point, measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x DataAkamaiImagingPolicyImage#x}
        '''
        result = self._values.get("x")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_var(self) -> typing.Optional[builtins.str]:
        '''The horizontal position of the point, measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_var DataAkamaiImagingPolicyImage#x_var}
        '''
        result = self._values.get("x_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y(self) -> typing.Optional[builtins.str]:
        '''The vertical position of the point, measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y DataAkamaiImagingPolicyImage#y}
        '''
        result = self._values.get("y")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_var(self) -> typing.Optional[builtins.str]:
        '''The vertical position of the point, measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_var DataAkamaiImagingPolicyImage#y_var}
        '''
        result = self._values.get("y_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestPolygonShapePoints(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestPolygonShapePointsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestPolygonShapePointsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3d50e38ff22b0e25be43f73cfa09f66f1f36d94e3ebc693f261540a5c7fa8250)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestPolygonShapePointsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__96f2096231772bb1d27b66883628a150c21db8752c8230779250e98568546e61)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestPolygonShapePointsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0d93ee4dc4934a6a03bff40dc780946ba58e2472849c81cd209aee8a5741c36a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f338ca0b1315c4f6eea9e3072728f2d96c1d643d3d64bbfeea61943ff31967ae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f9ebc88971eb90cb671150a0513054330fb825343c83f3872689db2688ef0fd2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestPolygonShapePoints]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestPolygonShapePoints]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestPolygonShapePoints]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__31231d34904229c3965f176c6a4b3e741d4ce8a10726265da48bc5ab0ac249f5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestPolygonShapePointsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestPolygonShapePointsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c6405e9a12e9af7a708a6aafeed7cd2cfd33979148c1f4aa79d33f5eb560d425)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetX")
    def reset_x(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetX", []))

    @jsii.member(jsii_name="resetXVar")
    def reset_x_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXVar", []))

    @jsii.member(jsii_name="resetY")
    def reset_y(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetY", []))

    @jsii.member(jsii_name="resetYVar")
    def reset_y_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYVar", []))

    @builtins.property
    @jsii.member(jsii_name="xInput")
    def x_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xInput"))

    @builtins.property
    @jsii.member(jsii_name="xVarInput")
    def x_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yInput")
    def y_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yInput"))

    @builtins.property
    @jsii.member(jsii_name="yVarInput")
    def y_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yVarInput"))

    @builtins.property
    @jsii.member(jsii_name="x")
    def x(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "x"))

    @x.setter
    def x(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f6d86639fefe37ebfd814a6205cad74f828c4618a7842eb0c88bba1eeddb63d4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "x", value)

    @builtins.property
    @jsii.member(jsii_name="xVar")
    def x_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xVar"))

    @x_var.setter
    def x_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4b9fecc9737e6db3040d48722ab532a463a78c0b99994395f11207b0288ca8a7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xVar", value)

    @builtins.property
    @jsii.member(jsii_name="y")
    def y(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "y"))

    @y.setter
    def y(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__17b1949615d4eabff2f0788c84d49650b2690ff71d06110bf6b74d72ebace4e3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "y", value)

    @builtins.property
    @jsii.member(jsii_name="yVar")
    def y_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yVar"))

    @y_var.setter
    def y_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2e1c930a4f3d20844eef83acb3f5ebf311417e2487b3041f2794346413c19245)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestPolygonShapePoints]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestPolygonShapePoints]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestPolygonShapePoints]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0cdb73252c9b31472455accf06e3188cbc7f7274d46e4e58dc6eb6a688259252)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestRectangleShape",
    jsii_struct_bases=[],
    name_mapping={
        "anchor": "anchor",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestRectangleShape:
    def __init__(
        self,
        *,
        anchor: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestRectangleShapeAnchor", typing.Dict[builtins.str, typing.Any]],
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param anchor: anchor block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#anchor DataAkamaiImagingPolicyImage#anchor}
        :param height: Extends the rectangle down from the ``anchor`` point. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: Extends the rectangle down from the ``anchor`` point. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: Extends the rectangle right from the ``anchor`` point. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: Extends the rectangle right from the ``anchor`` point. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(anchor, dict):
            anchor = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestRectangleShapeAnchor(**anchor)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fea46f55a588e7f5dbea17915f44e7f05bac651a65bf2f2b32a1090a29d85efe)
            check_type(argname="argument anchor", value=anchor, expected_type=type_hints["anchor"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "anchor": anchor,
        }
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def anchor(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestRectangleShapeAnchor":
        '''anchor block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#anchor DataAkamaiImagingPolicyImage#anchor}
        '''
        result = self._values.get("anchor")
        assert result is not None, "Required property 'anchor' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestRectangleShapeAnchor", result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''Extends the rectangle down from the ``anchor`` point.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''Extends the rectangle down from the ``anchor`` point.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''Extends the rectangle right from the ``anchor`` point.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''Extends the rectangle right from the ``anchor`` point.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestRectangleShape(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestRectangleShapeAnchor",
    jsii_struct_bases=[],
    name_mapping={"x": "x", "x_var": "xVar", "y": "y", "y_var": "yVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestRectangleShapeAnchor:
    def __init__(
        self,
        *,
        x: typing.Optional[builtins.str] = None,
        x_var: typing.Optional[builtins.str] = None,
        y: typing.Optional[builtins.str] = None,
        y_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param x: The horizontal position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x DataAkamaiImagingPolicyImage#x}
        :param x_var: The horizontal position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_var DataAkamaiImagingPolicyImage#x_var}
        :param y: The vertical position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y DataAkamaiImagingPolicyImage#y}
        :param y_var: The vertical position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_var DataAkamaiImagingPolicyImage#y_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a2b199943a59c0f5c9477594cc4eae480c84d72a26651d7f2ecc995c51f12cdc)
            check_type(argname="argument x", value=x, expected_type=type_hints["x"])
            check_type(argname="argument x_var", value=x_var, expected_type=type_hints["x_var"])
            check_type(argname="argument y", value=y, expected_type=type_hints["y"])
            check_type(argname="argument y_var", value=y_var, expected_type=type_hints["y_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if x is not None:
            self._values["x"] = x
        if x_var is not None:
            self._values["x_var"] = x_var
        if y is not None:
            self._values["y"] = y
        if y_var is not None:
            self._values["y_var"] = y_var

    @builtins.property
    def x(self) -> typing.Optional[builtins.str]:
        '''The horizontal position of the point, measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x DataAkamaiImagingPolicyImage#x}
        '''
        result = self._values.get("x")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_var(self) -> typing.Optional[builtins.str]:
        '''The horizontal position of the point, measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_var DataAkamaiImagingPolicyImage#x_var}
        '''
        result = self._values.get("x_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y(self) -> typing.Optional[builtins.str]:
        '''The vertical position of the point, measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y DataAkamaiImagingPolicyImage#y}
        '''
        result = self._values.get("y")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_var(self) -> typing.Optional[builtins.str]:
        '''The vertical position of the point, measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_var DataAkamaiImagingPolicyImage#y_var}
        '''
        result = self._values.get("y_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestRectangleShapeAnchor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestRectangleShapeAnchorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestRectangleShapeAnchorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9c88194cfb2311d435a1bd0550175079dcee395ae228176c7e5b36956191ca32)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetX")
    def reset_x(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetX", []))

    @jsii.member(jsii_name="resetXVar")
    def reset_x_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXVar", []))

    @jsii.member(jsii_name="resetY")
    def reset_y(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetY", []))

    @jsii.member(jsii_name="resetYVar")
    def reset_y_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYVar", []))

    @builtins.property
    @jsii.member(jsii_name="xInput")
    def x_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xInput"))

    @builtins.property
    @jsii.member(jsii_name="xVarInput")
    def x_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yInput")
    def y_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yInput"))

    @builtins.property
    @jsii.member(jsii_name="yVarInput")
    def y_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yVarInput"))

    @builtins.property
    @jsii.member(jsii_name="x")
    def x(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "x"))

    @x.setter
    def x(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__866c8cd0d710e6941a4e286f2087a2876a40be12841e6697789244c2a1d96051)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "x", value)

    @builtins.property
    @jsii.member(jsii_name="xVar")
    def x_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xVar"))

    @x_var.setter
    def x_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__32b526f4145c53a8e52c6173d391efd31838b18b138296d9614a55b4798efdfd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xVar", value)

    @builtins.property
    @jsii.member(jsii_name="y")
    def y(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "y"))

    @y.setter
    def y(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__975c19cce59b1dc04f9bbb5dda887978a4c8e87680b86aa5ce16b462c75c74c3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "y", value)

    @builtins.property
    @jsii.member(jsii_name="yVar")
    def y_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yVar"))

    @y_var.setter
    def y_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__000e1f5342882ebab8b15edf91377e343b4ab0dcade9b00c26ab8b9585de8a0e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestRectangleShapeAnchor]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestRectangleShapeAnchor], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestRectangleShapeAnchor],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8d9e45fb1f4e09bf74cd5b9986392d963b9a35d3dd771ca3afab1f6df0f9be01)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestRectangleShapeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestRectangleShapeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea0123c454d6eadc2fe991770c2bb5ec9f6d87271982990800539b4e1f797fd5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestRectangleShapeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ec7932d4235892616fbecc52f8e14aa2cd84a91973e8d669f25ff0761c3d1158)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestRectangleShapeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__60c885123ab326ec851d87751c2e49c26fb74f35467c00de651c5de71a2818fd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0c7572063d4dc14a3a4f4e3e82eb46424a085cb1094f82649a0e12776ca805ef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1316d14c691f153c05771b03a9998d59c14cb37e588ba6405339156345f2720b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestRectangleShape]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestRectangleShape]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestRectangleShape]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c3976ac9d882d71b422a82f7a2c9a8f3bdb3cba04b324e17b553ebe994774c80)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestRectangleShapeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestRectangleShapeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__077338d0d71a15369bf98b0aa832d2a409d8883888996bb0c64aab89e4a9bb7f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putAnchor")
    def put_anchor(
        self,
        *,
        x: typing.Optional[builtins.str] = None,
        x_var: typing.Optional[builtins.str] = None,
        y: typing.Optional[builtins.str] = None,
        y_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param x: The horizontal position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x DataAkamaiImagingPolicyImage#x}
        :param x_var: The horizontal position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_var DataAkamaiImagingPolicyImage#x_var}
        :param y: The vertical position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y DataAkamaiImagingPolicyImage#y}
        :param y_var: The vertical position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_var DataAkamaiImagingPolicyImage#y_var}
        '''
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestRectangleShapeAnchor(
            x=x, x_var=x_var, y=y, y_var=y_var
        )

        return typing.cast(None, jsii.invoke(self, "putAnchor", [value]))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="anchor")
    def anchor(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestRectangleShapeAnchorOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestRectangleShapeAnchorOutputReference, jsii.get(self, "anchor"))

    @builtins.property
    @jsii.member(jsii_name="anchorInput")
    def anchor_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestRectangleShapeAnchor]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestRectangleShapeAnchor], jsii.get(self, "anchorInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__37e17558aa62058ff216d8c3a38c31b815bbb6085b16d084872e388c143f6754)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8c64b467db2fe8721ad35c965d97b0f9515f6107c6eb7eee14827f593cc8c572)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__74a1406b90c199174cea193edfb14818c638f9ec28cfab2a0a8a1d4e3e7f8b6d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c4d9e3f7040a52d186885fa19561fe73c0249ccac835402ab18d6dfc01d79970)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestRectangleShape]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestRectangleShape]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestRectangleShape]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aa61609c486b7d6e1ad4518505fd9c4353fbd925ac633bd3d93adace367039ee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestUnionShape",
    jsii_struct_bases=[],
    name_mapping={"shapes": "shapes"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestUnionShape:
    def __init__(
        self,
        *,
        shapes: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestUnionShapeShapes", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param shapes: shapes block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shapes DataAkamaiImagingPolicyImage#shapes}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__52e02882c872ddecf537632e45bc82a3f331eb19a12922a86a6152d93aa157ac)
            check_type(argname="argument shapes", value=shapes, expected_type=type_hints["shapes"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "shapes": shapes,
        }

    @builtins.property
    def shapes(
        self,
    ) -> typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestUnionShapeShapes"]]:
        '''shapes block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shapes DataAkamaiImagingPolicyImage#shapes}
        '''
        result = self._values.get("shapes")
        assert result is not None, "Required property 'shapes' is missing"
        return typing.cast(typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestUnionShapeShapes"]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestUnionShape(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestUnionShapeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestUnionShapeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a0c959b34a3cd6bb46dafa954c56a36794abe0b21b2eb265f8b601c6bccab141)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestUnionShapeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9f116e81d583ab738f53480d2edd6da9545c02a0cbd95300d376a4879ec57a4d)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestUnionShapeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__718c4e46753b2aa4d20cd6e1017de019abc98a58e4d6cdfc5a5a7248a55b944a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dc724b3b4596840b82f25836752324f7fe5e382602c812ee44eb1a30d316cd16)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c1dff561318090fb971652fddba9ba37d950ed54a01463397af410cf90fa22cb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestUnionShape]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestUnionShape]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestUnionShape]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__12f5e95bb8111492ca330ced9ec99309cc1d310998c6e4df4c237f850f3c3416)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestUnionShapeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestUnionShapeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__147eacd1d4245d0558f091cb799ea54f380c6866c0994e88f8e181d56a4dddc4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putShapes")
    def put_shapes(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestUnionShapeShapes", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__89281864f5d0f0491ae4c7855ae98e90a70cfdae955ff6c0b6328b092b5f04c2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putShapes", [value]))

    @builtins.property
    @jsii.member(jsii_name="shapes")
    def shapes(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestUnionShapeShapesList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestUnionShapeShapesList", jsii.get(self, "shapes"))

    @builtins.property
    @jsii.member(jsii_name="shapesInput")
    def shapes_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestUnionShapeShapes"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestUnionShapeShapes"]]], jsii.get(self, "shapesInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestUnionShape]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestUnionShape]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestUnionShape]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1cddd0f4d398671f05e5a72836fd87530f7346b5dc7efef4673127fd0a340d0b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestUnionShapeShapes",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestUnionShapeShapes:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestUnionShapeShapes(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestUnionShapeShapesList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestUnionShapeShapesList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__adbd5d2ec6830303436e0132c3ddaaf64134fccaec8f5179ad14bc3b16df123b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestUnionShapeShapesOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6917311c2cc1d59cc93f26116daac8ceb49dfc17ba57b9fc05fad31ffd95009a)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestUnionShapeShapesOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a0faa6849b1bf5b8d27183af3f7dea51850047b989c7c05d96e7c6ca671b8e1e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d3410d87482181228e615f818e5948e5d14c06257d8576d4bda4a6748d4075e0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fd765ed90ef2765c550d789446ecc235691c5144e467c3d1d9e94ae22ee6e63f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestUnionShapeShapes]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestUnionShapeShapes]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestUnionShapeShapes]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5fb428ca2fe43358fcc12bc1de26e5df82b9566f9a63409672d19219bba9c754)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestUnionShapeShapesOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestUnionShapeShapesOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4da2886b2c6e88d66e5468b0e32fc351e8f128114d2485e9965d052ef1d21fac)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestUnionShapeShapes]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestUnionShapeShapes]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestUnionShapeShapes]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__80003233b0b37412993ed08e87ff704f338ec4fece23c8071d42df5179189a21)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRelativeCrop",
    jsii_struct_bases=[],
    name_mapping={
        "east": "east",
        "east_var": "eastVar",
        "north": "north",
        "north_var": "northVar",
        "south": "south",
        "south_var": "southVar",
        "west": "west",
        "west_var": "westVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRelativeCrop:
    def __init__(
        self,
        *,
        east: typing.Optional[builtins.str] = None,
        east_var: typing.Optional[builtins.str] = None,
        north: typing.Optional[builtins.str] = None,
        north_var: typing.Optional[builtins.str] = None,
        south: typing.Optional[builtins.str] = None,
        south_var: typing.Optional[builtins.str] = None,
        west: typing.Optional[builtins.str] = None,
        west_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param east: The number of pixels to shrink or expand the right side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east DataAkamaiImagingPolicyImage#east}
        :param east_var: The number of pixels to shrink or expand the right side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east_var DataAkamaiImagingPolicyImage#east_var}
        :param north: The number of pixels to shrink or expand the top side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north DataAkamaiImagingPolicyImage#north}
        :param north_var: The number of pixels to shrink or expand the top side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north_var DataAkamaiImagingPolicyImage#north_var}
        :param south: The number of pixels to shrink or expand the bottom side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south DataAkamaiImagingPolicyImage#south}
        :param south_var: The number of pixels to shrink or expand the bottom side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south_var DataAkamaiImagingPolicyImage#south_var}
        :param west: The number of pixels to shrink or expand the left side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west DataAkamaiImagingPolicyImage#west}
        :param west_var: The number of pixels to shrink or expand the left side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west_var DataAkamaiImagingPolicyImage#west_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea1367cdd626310e2892f408595a1a22163a481257c5ed5e7099cda4ad532ce5)
            check_type(argname="argument east", value=east, expected_type=type_hints["east"])
            check_type(argname="argument east_var", value=east_var, expected_type=type_hints["east_var"])
            check_type(argname="argument north", value=north, expected_type=type_hints["north"])
            check_type(argname="argument north_var", value=north_var, expected_type=type_hints["north_var"])
            check_type(argname="argument south", value=south, expected_type=type_hints["south"])
            check_type(argname="argument south_var", value=south_var, expected_type=type_hints["south_var"])
            check_type(argname="argument west", value=west, expected_type=type_hints["west"])
            check_type(argname="argument west_var", value=west_var, expected_type=type_hints["west_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if east is not None:
            self._values["east"] = east
        if east_var is not None:
            self._values["east_var"] = east_var
        if north is not None:
            self._values["north"] = north
        if north_var is not None:
            self._values["north_var"] = north_var
        if south is not None:
            self._values["south"] = south
        if south_var is not None:
            self._values["south_var"] = south_var
        if west is not None:
            self._values["west"] = west
        if west_var is not None:
            self._values["west_var"] = west_var

    @builtins.property
    def east(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the right side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east DataAkamaiImagingPolicyImage#east}
        '''
        result = self._values.get("east")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def east_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the right side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east_var DataAkamaiImagingPolicyImage#east_var}
        '''
        result = self._values.get("east_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def north(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the top side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north DataAkamaiImagingPolicyImage#north}
        '''
        result = self._values.get("north")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def north_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the top side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north_var DataAkamaiImagingPolicyImage#north_var}
        '''
        result = self._values.get("north_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def south(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the bottom side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south DataAkamaiImagingPolicyImage#south}
        '''
        result = self._values.get("south")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def south_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the bottom side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south_var DataAkamaiImagingPolicyImage#south_var}
        '''
        result = self._values.get("south_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def west(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the left side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west DataAkamaiImagingPolicyImage#west}
        '''
        result = self._values.get("west")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def west_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the left side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west_var DataAkamaiImagingPolicyImage#west_var}
        '''
        result = self._values.get("west_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRelativeCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRelativeCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRelativeCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2f0d6851e77b0bde4211b09d6c5b16da41de2b6814b5c830518932b698cef5d9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRelativeCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a6de09828a387bfdf057c0b73e038105a4d895714227e78f03698feb24de9beb)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRelativeCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8fa08fc04a4195d90b698e9cacac793a90f117f850d96d4dbec95fea1361f416)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__676455d13a1f5fe71b2d1b215c60775fb116da7c9bdf43f9d1622160e1905a87)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__920fd7fbbd86ad6f51d83d405c02d88e8d39e009a3be5e842ef43fe3b78575c5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRelativeCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRelativeCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRelativeCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b062490429f72b52599afaf5c58e3f701f0b0ec2393fc1dbcd4277abcd0eebc6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRelativeCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRelativeCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f4636f136d7d0cde487738cf54a796186b2a8066fb98f9c3d276bb40f5ccdc70)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetEast")
    def reset_east(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEast", []))

    @jsii.member(jsii_name="resetEastVar")
    def reset_east_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEastVar", []))

    @jsii.member(jsii_name="resetNorth")
    def reset_north(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNorth", []))

    @jsii.member(jsii_name="resetNorthVar")
    def reset_north_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNorthVar", []))

    @jsii.member(jsii_name="resetSouth")
    def reset_south(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSouth", []))

    @jsii.member(jsii_name="resetSouthVar")
    def reset_south_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSouthVar", []))

    @jsii.member(jsii_name="resetWest")
    def reset_west(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWest", []))

    @jsii.member(jsii_name="resetWestVar")
    def reset_west_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWestVar", []))

    @builtins.property
    @jsii.member(jsii_name="eastInput")
    def east_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "eastInput"))

    @builtins.property
    @jsii.member(jsii_name="eastVarInput")
    def east_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "eastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="northInput")
    def north_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "northInput"))

    @builtins.property
    @jsii.member(jsii_name="northVarInput")
    def north_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "northVarInput"))

    @builtins.property
    @jsii.member(jsii_name="southInput")
    def south_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "southInput"))

    @builtins.property
    @jsii.member(jsii_name="southVarInput")
    def south_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "southVarInput"))

    @builtins.property
    @jsii.member(jsii_name="westInput")
    def west_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "westInput"))

    @builtins.property
    @jsii.member(jsii_name="westVarInput")
    def west_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "westVarInput"))

    @builtins.property
    @jsii.member(jsii_name="east")
    def east(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "east"))

    @east.setter
    def east(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f233797331c7329e2b1b49e55e5f7ac7bc0a04763c9f4ab1e4793011bbf3d851)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "east", value)

    @builtins.property
    @jsii.member(jsii_name="eastVar")
    def east_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "eastVar"))

    @east_var.setter
    def east_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__41d14be4d1cd96a68f90cc47917d48759e7a88e1b80dd54934bb830f7ce0f6ae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "eastVar", value)

    @builtins.property
    @jsii.member(jsii_name="north")
    def north(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "north"))

    @north.setter
    def north(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__accb3906ac2d3262628292bfe84df6be491f62006f95aedcda46375d674c63ec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "north", value)

    @builtins.property
    @jsii.member(jsii_name="northVar")
    def north_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "northVar"))

    @north_var.setter
    def north_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__53c8ba650a64d224180d96cf48e5d6ba5d0bc23bf837d4de9417884b3cfb3340)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "northVar", value)

    @builtins.property
    @jsii.member(jsii_name="south")
    def south(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "south"))

    @south.setter
    def south(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a2589acea56b29017a627a604aeefc4d2bf9b2311d6c8420b0774ca0b95ada90)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "south", value)

    @builtins.property
    @jsii.member(jsii_name="southVar")
    def south_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "southVar"))

    @south_var.setter
    def south_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5cdade51ae1c075c5998c43249ec0d5f3ed1eba154600c2b8436632855046b9b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "southVar", value)

    @builtins.property
    @jsii.member(jsii_name="west")
    def west(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "west"))

    @west.setter
    def west(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4dd421ba75a7594898ccc4ff910e523285adfccb1c7c50131a785b1b75c7c4a6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "west", value)

    @builtins.property
    @jsii.member(jsii_name="westVar")
    def west_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "westVar"))

    @west_var.setter
    def west_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__464238760c38deb35ca8f0592ae88ae7390663bc9d7b67e63184b095d52fd24b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "westVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRelativeCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRelativeCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRelativeCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0cb95fb9d16497d71ef9e65b60336441e89a5bb5fa782a9c4bd5c2515ffbc83b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRemoveColor",
    jsii_struct_bases=[],
    name_mapping={
        "color": "color",
        "color_var": "colorVar",
        "feather": "feather",
        "feather_var": "featherVar",
        "tolerance": "tolerance",
        "tolerance_var": "toleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRemoveColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
        feather: typing.Optional[builtins.str] = None,
        feather_var: typing.Optional[builtins.str] = None,
        tolerance: typing.Optional[builtins.str] = None,
        tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        :param feather: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        :param feather_var: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        :param tolerance: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        :param tolerance_var: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ce4cc03f1d676d3616b0200090cd19d0c809a0cc0824042b478351a76327a2da)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
            check_type(argname="argument feather", value=feather, expected_type=type_hints["feather"])
            check_type(argname="argument feather_var", value=feather_var, expected_type=type_hints["feather_var"])
            check_type(argname="argument tolerance", value=tolerance, expected_type=type_hints["tolerance"])
            check_type(argname="argument tolerance_var", value=tolerance_var, expected_type=type_hints["tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var
        if feather is not None:
            self._values["feather"] = feather
        if feather_var is not None:
            self._values["feather_var"] = feather_var
        if tolerance is not None:
            self._values["tolerance"] = tolerance
        if tolerance_var is not None:
            self._values["tolerance_var"] = tolerance_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        '''
        result = self._values.get("feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather_var(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        '''
        result = self._values.get("feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        '''
        result = self._values.get("tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance_var(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        result = self._values.get("tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRemoveColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRemoveColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRemoveColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a5e1580c555ffbc1dc1c06d5118a29c748aa0327673ffca57057155ace10529)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRemoveColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__629dc99a4bc3f592816b36668e298cf43775446ca7d98d575e0fe2d48f19a3b2)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRemoveColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ed97b7b9878e00808ef7d9b2fe8f12b787a8eb86d17f23e36b388a7dcfc9fdc0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b18fc3840d304e50d7e349da6931013f751d9e7be37fd5b94ca209698ab7d88b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5c6668fdee7506c73d92aa755617e1201ba643df4ed558f02f6e318ac1b297b9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRemoveColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRemoveColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRemoveColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f8a51b81a3f1754ff91f85174b7e90bb1c8a8654750ff05b0b8ae3353e9af80d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRemoveColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRemoveColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a8a435d3616a9b4a97fe8626b19e82d9ec97e85741c8612bbe19fc94a4384d7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @jsii.member(jsii_name="resetFeather")
    def reset_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeather", []))

    @jsii.member(jsii_name="resetFeatherVar")
    def reset_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatherVar", []))

    @jsii.member(jsii_name="resetTolerance")
    def reset_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTolerance", []))

    @jsii.member(jsii_name="resetToleranceVar")
    def reset_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featherInput")
    def feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherInput"))

    @builtins.property
    @jsii.member(jsii_name="featherVarInput")
    def feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceInput")
    def tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceVarInput")
    def tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e3aa0a0ef7b31490df09d8a3ef24a93af89458f0c3e4eec46aa63a556f55be50)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0d511e355e5c1845e45c3c7a8b3414a1fd53aae08b88650dc11975fd2530e800)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="feather")
    def feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "feather"))

    @feather.setter
    def feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3bf3390ed404348a39aa72a6f51527ae64a3ec25f8b4313dc5b3fd42cf6218b7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "feather", value)

    @builtins.property
    @jsii.member(jsii_name="featherVar")
    def feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featherVar"))

    @feather_var.setter
    def feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9819c04ed9a0d0f2dc81a6af2e6a77009a3e04574e7f3eb606757bde2bb0940b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featherVar", value)

    @builtins.property
    @jsii.member(jsii_name="tolerance")
    def tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tolerance"))

    @tolerance.setter
    def tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0430e88b0828fd331d16c5259531f477c743de1fa539d5ccc0969dd43408f41e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tolerance", value)

    @builtins.property
    @jsii.member(jsii_name="toleranceVar")
    def tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "toleranceVar"))

    @tolerance_var.setter
    def tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b7f8e04c9a18d0f6a70e3d46d50feaa29aab1c0c58d841bb4964b80d1e5b9fff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "toleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRemoveColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRemoveColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRemoveColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e199d4c9c7e116f28799c843fc9e335915066167926ee228cabbc9a5d9853109)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultResize",
    jsii_struct_bases=[],
    name_mapping={
        "aspect": "aspect",
        "aspect_var": "aspectVar",
        "height": "height",
        "height_var": "heightVar",
        "type": "type",
        "type_var": "typeVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultResize:
    def __init__(
        self,
        *,
        aspect: typing.Optional[builtins.str] = None,
        aspect_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param aspect: Preserves the aspect ratio. Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect DataAkamaiImagingPolicyImage#aspect}
        :param aspect_var: Preserves the aspect ratio. Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_var DataAkamaiImagingPolicyImage#aspect_var}
        :param height: The height to resize the source image to. Must be set if height is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height to resize the source image to. Must be set if height is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param type: Sets constraints for the image resize. Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: Sets constraints for the image resize. Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        :param width: The width to resize the source image to. Must be set if width is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width to resize the source image to. Must be set if width is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f8dbcf32dd5831b6658cf0d03a28c9350cec985459669c0c08e019b4432c19f)
            check_type(argname="argument aspect", value=aspect, expected_type=type_hints["aspect"])
            check_type(argname="argument aspect_var", value=aspect_var, expected_type=type_hints["aspect_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if aspect is not None:
            self._values["aspect"] = aspect
        if aspect_var is not None:
            self._values["aspect_var"] = aspect_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def aspect(self) -> typing.Optional[builtins.str]:
        '''Preserves the aspect ratio.

        Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect DataAkamaiImagingPolicyImage#aspect}
        '''
        result = self._values.get("aspect")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def aspect_var(self) -> typing.Optional[builtins.str]:
        '''Preserves the aspect ratio.

        Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_var DataAkamaiImagingPolicyImage#aspect_var}
        '''
        result = self._values.get("aspect_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height to resize the source image to. Must be set if height is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height to resize the source image to. Must be set if height is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''Sets constraints for the image resize.

        Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''Sets constraints for the image resize.

        Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width to resize the source image to. Must be set if width is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width to resize the source image to. Must be set if width is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultResize(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultResizeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultResizeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ec245061d8b0f8eef8cc7af8910fd7107adc888c0bc5e780ee71991d5144c014)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultResizeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ba110b54faaa52bf44dd958afb8e760714820884890dc0dfb5bc9c8ac834f00)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultResizeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__60205814418e2164e48417b15535055caaf3e8513f0ffe84771c4f303e36e34f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c8a3ebf32876927d77a4334d06198762e2d818e3352c18ac94c860a32eed93d1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__62cd1c5278bbe3b1b7059f9b5dfae190d1206e74f85efd37f3f43ede30f0a130)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultResize]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultResize]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultResize]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__372a7d24901bf2bb56c3e3d7955009ae395447d25a30ff2e2f8effddf587108b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultResizeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultResizeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__48d9fb3158bb3beb14743898f06f74660be4db137af64d6d175064281e9ca9b9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAspect")
    def reset_aspect(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspect", []))

    @jsii.member(jsii_name="resetAspectVar")
    def reset_aspect_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspectVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="aspectInput")
    def aspect_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "aspectInput"))

    @builtins.property
    @jsii.member(jsii_name="aspectVarInput")
    def aspect_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "aspectVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="aspect")
    def aspect(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "aspect"))

    @aspect.setter
    def aspect(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__74272c602051d25171b0cb55b01a8e492b72c92f3cd45ce38db1d21d2e6b8904)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "aspect", value)

    @builtins.property
    @jsii.member(jsii_name="aspectVar")
    def aspect_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "aspectVar"))

    @aspect_var.setter
    def aspect_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7a4c9c5f0870703874c3fc62d3d2b05d55d5ac408fb02dcbe4224ee499ed8d89)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "aspectVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3686e9b0a03ffb594d9683057f920b0bdd189f0af202ea12d64316128903b3b7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3fb66edd22c1ee37749ebccc3c7594d9f50546cf2513f17311fc750f513f3cc8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d63a94f54fe66d77de5075486c217ce0b4e936dba8172c7a434498d9e8a1523f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7eae71fc5c98f8fd23562beb597fabd80b362e1bb740aa3f6824f346a442f97c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__08418c490745ef4dd92c17b87c17e35a4440142bc38992730bfb90d3b1de97fb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f8c2ddb05eabae9de3a5ead98e90832a935ccb4578c09976cc53cf7796ea9f98)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultResize]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultResize]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultResize]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2786b96f42553165a96ba90496792defa7fb45e5a5c59b25434c2876692679b8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRotate",
    jsii_struct_bases=[],
    name_mapping={"degrees": "degrees", "degrees_var": "degreesVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRotate:
    def __init__(
        self,
        *,
        degrees: typing.Optional[builtins.str] = None,
        degrees_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param degrees: The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees DataAkamaiImagingPolicyImage#degrees}
        :param degrees_var: The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees_var DataAkamaiImagingPolicyImage#degrees_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6ed18b9f1de01542d840a35e7de37016f1245b77b295630e9d627832f6673c77)
            check_type(argname="argument degrees", value=degrees, expected_type=type_hints["degrees"])
            check_type(argname="argument degrees_var", value=degrees_var, expected_type=type_hints["degrees_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if degrees is not None:
            self._values["degrees"] = degrees
        if degrees_var is not None:
            self._values["degrees_var"] = degrees_var

    @builtins.property
    def degrees(self) -> typing.Optional[builtins.str]:
        '''The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees DataAkamaiImagingPolicyImage#degrees}
        '''
        result = self._values.get("degrees")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def degrees_var(self) -> typing.Optional[builtins.str]:
        '''The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees_var DataAkamaiImagingPolicyImage#degrees_var}
        '''
        result = self._values.get("degrees_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRotate(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRotateList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRotateList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f8f013cf94608b0e91d82fe50f452ac2761d8a2baa99fd950ea860c6799aec06)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRotateOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__12bedefd5fb9b30d0df2b27ed77884b5300300ccdf1e27a518f6ceaef16eef86)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRotateOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__258a281185e383dc09fef61d2a980427f4d5175d08328aef5c42a98d7df65b3b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5b9070e530664b8c21966e824f40087081428ddb8b382fa39524eb2245ddd14d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__795f13ab28bd6be934d3c92589e66ab58b9e4c0d535ab2a55cd126aa41b32926)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRotate]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRotate]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRotate]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e67339a40dc966f4dbd109f0f823dd980fd474c8939dd78beac7220076a306aa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRotateOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRotateOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a2a92fa161b707625bc8f80d758cd6e96d4c599d48bfe99511fb4f3f3cf693e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetDegrees")
    def reset_degrees(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDegrees", []))

    @jsii.member(jsii_name="resetDegreesVar")
    def reset_degrees_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDegreesVar", []))

    @builtins.property
    @jsii.member(jsii_name="degreesInput")
    def degrees_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "degreesInput"))

    @builtins.property
    @jsii.member(jsii_name="degreesVarInput")
    def degrees_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "degreesVarInput"))

    @builtins.property
    @jsii.member(jsii_name="degrees")
    def degrees(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "degrees"))

    @degrees.setter
    def degrees(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f55194fd5940f3b7b172c9dd9e0874614a7e6edcf66a16886803bf3301e19acc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "degrees", value)

    @builtins.property
    @jsii.member(jsii_name="degreesVar")
    def degrees_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "degreesVar"))

    @degrees_var.setter
    def degrees_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__84f11447b2c2c3805919f8d83d243db5fdb6824b5ca8efb8b86ab4c09c9ecfe5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "degreesVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRotate]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRotate]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRotate]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__57961f925b5223b66f93a88311f195a0d30084d53135601b379eda2c4248793d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultScale",
    jsii_struct_bases=[],
    name_mapping={
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultScale:
    def __init__(
        self,
        *,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param height: Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged. Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged. Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f585cd1527a702143c69404f2c52adde791d1d97b1197fa6599ba6d12addca2e)
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size.

        Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size.

        Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged.

        Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged.

        Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultScale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultScaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultScaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__786fffca32cd6a5e4c3a45c1d68637d3e3db7ce29fec4c996e9df8a7805b126a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultScaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__77cbc8ab2db6fa45bcdce5c25ce9b385e69194caf0ccf2ff70dbb945f871a67b)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultScaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__60e784cb62b6313ceae1e4231e2e78c10a78fe5c0177b3b62d62c6e2c45ae19f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__769bf6cd4709484a42945fdd5637c8f4a03d1941cceb63d2f921918561bc3d3a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f2239a1723bbe009edae1452d8ec10ccd06896239b5f71fe775086772d709a8b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultScale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultScale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultScale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f28603a68c36292658e81071462df430dfa18f7e481c00951127d498fcba9e6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultScaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultScaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ca233fc5344fe8f17d8d0b145e4ff15185df2a56e7b8c87ed690d281654e57f7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1232963c687d75ae7fd94e59ccb1909cab7fbbd2da607524a94735c84391e666)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8175ce5520dc5f49f0eb70f56f35ee04de0efdb20315bbd777f953ca01c76ef3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d1d91dd8f3449980e7075881d35bb1a9ec594d12f6e475ba30e8676c73cdd948)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3c10d33221c83cd6257e9b5d73ac30109cd801b6e760ea0ba0a294e2d6a080f7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultScale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultScale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultScale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dc9fd32e0d827bbcf98b5449f75e804bdd9df78c393491b7c46ad07595be079b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultShear",
    jsii_struct_bases=[],
    name_mapping={
        "x_shear": "xShear",
        "x_shear_var": "xShearVar",
        "y_shear": "yShear",
        "y_shear_var": "yShearVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultShear:
    def __init__(
        self,
        *,
        x_shear: typing.Optional[builtins.str] = None,
        x_shear_var: typing.Optional[builtins.str] = None,
        y_shear: typing.Optional[builtins.str] = None,
        y_shear_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param x_shear: The amount to shear along the x-axis, measured in multiples of the image's width. Must be set if yShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear DataAkamaiImagingPolicyImage#x_shear}
        :param x_shear_var: The amount to shear along the x-axis, measured in multiples of the image's width. Must be set if yShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear_var DataAkamaiImagingPolicyImage#x_shear_var}
        :param y_shear: The amount to shear along the y-axis, measured in multiples of the image's height. Must be set if xShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear DataAkamaiImagingPolicyImage#y_shear}
        :param y_shear_var: The amount to shear along the y-axis, measured in multiples of the image's height. Must be set if xShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear_var DataAkamaiImagingPolicyImage#y_shear_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7352e0704212ddc6990fd995230265bf36c9d2d1c19056456118467f0bc4c431)
            check_type(argname="argument x_shear", value=x_shear, expected_type=type_hints["x_shear"])
            check_type(argname="argument x_shear_var", value=x_shear_var, expected_type=type_hints["x_shear_var"])
            check_type(argname="argument y_shear", value=y_shear, expected_type=type_hints["y_shear"])
            check_type(argname="argument y_shear_var", value=y_shear_var, expected_type=type_hints["y_shear_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if x_shear is not None:
            self._values["x_shear"] = x_shear
        if x_shear_var is not None:
            self._values["x_shear_var"] = x_shear_var
        if y_shear is not None:
            self._values["y_shear"] = y_shear
        if y_shear_var is not None:
            self._values["y_shear_var"] = y_shear_var

    @builtins.property
    def x_shear(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the x-axis, measured in multiples of the image's width.

        Must be set if yShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear DataAkamaiImagingPolicyImage#x_shear}
        '''
        result = self._values.get("x_shear")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_shear_var(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the x-axis, measured in multiples of the image's width.

        Must be set if yShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear_var DataAkamaiImagingPolicyImage#x_shear_var}
        '''
        result = self._values.get("x_shear_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_shear(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the y-axis, measured in multiples of the image's height.

        Must be set if xShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear DataAkamaiImagingPolicyImage#y_shear}
        '''
        result = self._values.get("y_shear")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_shear_var(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the y-axis, measured in multiples of the image's height.

        Must be set if xShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear_var DataAkamaiImagingPolicyImage#y_shear_var}
        '''
        result = self._values.get("y_shear_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultShear(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultShearList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultShearList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ded284f24f8836413310df9b9f07da65c50c19233b9640f905839633524b856)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultShearOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fef88cf2c17100a83a639c611d8ba1be1b97396918ee5558a64ffdb855ca2e0b)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultShearOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0e88120ca65214ce625e27b459d0078444e5be790100d32e6fd9adbfcf20c938)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c55dec73821ee36b9d514e369b284f68279d43169363824e3ea344cc24bfefb4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1a0e288742d6eb79869e343f7149585da0fa620456fd0e5528d5617342d769cd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultShear]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultShear]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultShear]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f8118a3d0f30e7984b04746962c5bd676766232a8b45a61bd3a2469defd0c277)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultShearOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultShearOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__93523e8dea30e2431bbf74a8afd87e9c52a593f235861c3c49acf061157688aa)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetXShear")
    def reset_x_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXShear", []))

    @jsii.member(jsii_name="resetXShearVar")
    def reset_x_shear_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXShearVar", []))

    @jsii.member(jsii_name="resetYShear")
    def reset_y_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYShear", []))

    @jsii.member(jsii_name="resetYShearVar")
    def reset_y_shear_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYShearVar", []))

    @builtins.property
    @jsii.member(jsii_name="xShearInput")
    def x_shear_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xShearInput"))

    @builtins.property
    @jsii.member(jsii_name="xShearVarInput")
    def x_shear_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xShearVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yShearInput")
    def y_shear_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yShearInput"))

    @builtins.property
    @jsii.member(jsii_name="yShearVarInput")
    def y_shear_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yShearVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xShear")
    def x_shear(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xShear"))

    @x_shear.setter
    def x_shear(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f69efd129074b99ff4ee0b314cbd73415d96e6b25044746d2a79b2ed6c03436)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xShear", value)

    @builtins.property
    @jsii.member(jsii_name="xShearVar")
    def x_shear_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xShearVar"))

    @x_shear_var.setter
    def x_shear_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__36a779fe174cbc45da008457e39aafd7164805f8da694739822e72ecdaab7e4b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xShearVar", value)

    @builtins.property
    @jsii.member(jsii_name="yShear")
    def y_shear(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yShear"))

    @y_shear.setter
    def y_shear(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7bb65e7977676ddbc1d5c0db478cbe29190f523f0f67b187b080cb7841440e52)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yShear", value)

    @builtins.property
    @jsii.member(jsii_name="yShearVar")
    def y_shear_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yShearVar"))

    @y_shear_var.setter
    def y_shear_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eea9ac32c8b78ebf31eef4f96a0c37ed5367b41c672b3363e0dc6bd20bca4c24)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yShearVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultShear]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultShear]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultShear]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3010d7dca7f0500abd28550f3006781f767d4328a9b8ce10317da84145af1b82)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultTrim",
    jsii_struct_bases=[],
    name_mapping={
        "fuzz": "fuzz",
        "fuzz_var": "fuzzVar",
        "padding": "padding",
        "padding_var": "paddingVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultTrim:
    def __init__(
        self,
        *,
        fuzz: typing.Optional[builtins.str] = None,
        fuzz_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fuzz: The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz DataAkamaiImagingPolicyImage#fuzz}
        :param fuzz_var: The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz_var DataAkamaiImagingPolicyImage#fuzz_var}
        :param padding: The amount of padding in pixels to add to the trimmed image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: The amount of padding in pixels to add to the trimmed image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c9202d595f90470b4230c794d3d0380cb21e09c4b2c348813b9a2bed950344f2)
            check_type(argname="argument fuzz", value=fuzz, expected_type=type_hints["fuzz"])
            check_type(argname="argument fuzz_var", value=fuzz_var, expected_type=type_hints["fuzz_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fuzz is not None:
            self._values["fuzz"] = fuzz
        if fuzz_var is not None:
            self._values["fuzz_var"] = fuzz_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var

    @builtins.property
    def fuzz(self) -> typing.Optional[builtins.str]:
        '''The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz DataAkamaiImagingPolicyImage#fuzz}
        '''
        result = self._values.get("fuzz")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fuzz_var(self) -> typing.Optional[builtins.str]:
        '''The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz_var DataAkamaiImagingPolicyImage#fuzz_var}
        '''
        result = self._values.get("fuzz_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''The amount of padding in pixels to add to the trimmed image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''The amount of padding in pixels to add to the trimmed image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultTrim(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultTrimList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultTrimList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__86cf5bbad55a5cc575caf9a66119bb93e8c01ddaea2acc9ea9056b42535ea823)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultTrimOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cc5b8f3ffb575c8eed7e40b351ee18fbbd0791ec8c8ead8a8ebf3dfdf8f197ea)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultTrimOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7c68b51381b27865bd05e7d29a7946c318282b2c1180ff0a18c68cc1f19f1756)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1549f14f2a3247d3198e02715f07b6a5356dbe3e710b2404b1c4d9263775389d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd45196fab56f5838d48cc3dfd65799097cef3b3c39ed40e7940c9dc94c15a35)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultTrim]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultTrim]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultTrim]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__706b2ba2556634ea9cdd82db4448975c9436aa119e852bbb896d797c437b18f4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultTrimOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultTrimOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__99d592b9f7ca19fe6d39230f051c567bfb8f6db8087e098205af93d2d1e220c9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetFuzz")
    def reset_fuzz(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFuzz", []))

    @jsii.member(jsii_name="resetFuzzVar")
    def reset_fuzz_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFuzzVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @builtins.property
    @jsii.member(jsii_name="fuzzInput")
    def fuzz_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fuzzInput"))

    @builtins.property
    @jsii.member(jsii_name="fuzzVarInput")
    def fuzz_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fuzzVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="fuzz")
    def fuzz(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fuzz"))

    @fuzz.setter
    def fuzz(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea945d0e015f25af40c5eb8cf079481c1920cf01c125ec26d1b50ab73fa89d6b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fuzz", value)

    @builtins.property
    @jsii.member(jsii_name="fuzzVar")
    def fuzz_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fuzzVar"))

    @fuzz_var.setter
    def fuzz_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d6150a38c8b5bbaa20c6821794be615713ac021f18a84cee6dcb548378eb371e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fuzzVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f77689bc64212e813bb5a4fe595b9d64b597bc30ee7812e4b8b31b3d43f9da6c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__208069e685b9528f89c632695a94d729b8563e0bd350f1186ebce78255742a09)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultTrim]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultTrim]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultTrim]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ed2f2d114e345d25d21719be074ae8b1622a291073c328281ab21b85f407ffef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultUnsharpMask",
    jsii_struct_bases=[],
    name_mapping={
        "gain": "gain",
        "gain_var": "gainVar",
        "sigma": "sigma",
        "sigma_var": "sigmaVar",
        "threshold": "threshold",
        "threshold_var": "thresholdVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultUnsharpMask:
    def __init__(
        self,
        *,
        gain: typing.Optional[builtins.str] = None,
        gain_var: typing.Optional[builtins.str] = None,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
        threshold: typing.Optional[builtins.str] = None,
        threshold_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param gain: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        :param gain_var: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        :param sigma: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        :param threshold: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        :param threshold_var: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b1ed5a20ffd5d42dfdf8a334364c031ba5ca17158ac8e336e6e98fa2afc330a9)
            check_type(argname="argument gain", value=gain, expected_type=type_hints["gain"])
            check_type(argname="argument gain_var", value=gain_var, expected_type=type_hints["gain_var"])
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
            check_type(argname="argument threshold", value=threshold, expected_type=type_hints["threshold"])
            check_type(argname="argument threshold_var", value=threshold_var, expected_type=type_hints["threshold_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if gain is not None:
            self._values["gain"] = gain
        if gain_var is not None:
            self._values["gain_var"] = gain_var
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var
        if threshold is not None:
            self._values["threshold"] = threshold
        if threshold_var is not None:
            self._values["threshold_var"] = threshold_var

    @builtins.property
    def gain(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        '''
        result = self._values.get("gain")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gain_var(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        '''
        result = self._values.get("gain_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        '''
        result = self._values.get("threshold")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold_var(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        result = self._values.get("threshold_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultUnsharpMask(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultUnsharpMaskList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultUnsharpMaskList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__139f588a594b78899c3bfe3d73d9b48510f94d0d39af4dca0c301dfca7cd64bf)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultUnsharpMaskOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8711649401a5061b7de7b9154754d78313ef5d807d458e5a3bacc088a00e0f0b)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultUnsharpMaskOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2f1294372362421a1f06f5cb0a6a3d71f9f03d7f625709f37c9c77fcc3680d23)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__96c0a2dc58ea57233e185fc82a47b37e87197d7738f8d2484062fd4564e1ec33)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b3ad44a9c6b09e261a9500bc40cf198ef10a2ae1abd295c72281d166835ef2d4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultUnsharpMask]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultUnsharpMask]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultUnsharpMask]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__39a74982aabb3b70ff93426edfe41a1d1be4398f8584d4228d751ef5fcd9dad0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultUnsharpMaskOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultUnsharpMaskOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__54b2c8b71b95ac4c25840cac25516509a5b9f85b6e11d4318ed800746bf94aa5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetGain")
    def reset_gain(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGain", []))

    @jsii.member(jsii_name="resetGainVar")
    def reset_gain_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGainVar", []))

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @jsii.member(jsii_name="resetThreshold")
    def reset_threshold(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThreshold", []))

    @jsii.member(jsii_name="resetThresholdVar")
    def reset_threshold_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThresholdVar", []))

    @builtins.property
    @jsii.member(jsii_name="gainInput")
    def gain_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainInput"))

    @builtins.property
    @jsii.member(jsii_name="gainVarInput")
    def gain_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdInput")
    def threshold_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdVarInput")
    def threshold_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gain")
    def gain(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gain"))

    @gain.setter
    def gain(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ae784a8e33df9d08cb3b2a206ad2021d36de20923233b15cd5cf6d7e7e173125)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gain", value)

    @builtins.property
    @jsii.member(jsii_name="gainVar")
    def gain_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gainVar"))

    @gain_var.setter
    def gain_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__229c42db779a9d4bc1a2d3b7c610e357a61d31ad2b0f8d101614cc2d2cd280bc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gainVar", value)

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eafbfc1cf136867c31db315803a72d04c5099bd246eda230539a32afb45f13b6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a32795c917b9f1a0278618e6b9b7c912dcff44b297168647e90d02566ada8ec2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="threshold")
    def threshold(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "threshold"))

    @threshold.setter
    def threshold(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__19023119a459b351a90b36b85914c1e2ccf5393461a8e5bffc64bc5042390a56)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "threshold", value)

    @builtins.property
    @jsii.member(jsii_name="thresholdVar")
    def threshold_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "thresholdVar"))

    @threshold_var.setter
    def threshold_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9f5bfc2479a2d2dabbbe9277b006e50e1af1f4af54f16751bdf67cfd785dd539)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "thresholdVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultUnsharpMask]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultUnsharpMask]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultUnsharpMask]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__efa1dd5926fc199c7c4f9de6d7b07a3986e07fb275837041de9b64e1159bff1d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqual",
    jsii_struct_bases=[],
    name_mapping={
        "append": "append",
        "aspect_crop": "aspectCrop",
        "background_color": "backgroundColor",
        "blur": "blur",
        "chroma_key": "chromaKey",
        "composite": "composite",
        "compound": "compound",
        "contrast": "contrast",
        "crop": "crop",
        "face_crop": "faceCrop",
        "feature_crop": "featureCrop",
        "fit_and_fill": "fitAndFill",
        "goop": "goop",
        "grayscale": "grayscale",
        "hsl": "hsl",
        "hsv": "hsv",
        "if_dimension": "ifDimension",
        "if_orientation": "ifOrientation",
        "im_query": "imQuery",
        "max_colors": "maxColors",
        "mirror": "mirror",
        "mono_hue": "monoHue",
        "opacity": "opacity",
        "region_of_interest_crop": "regionOfInterestCrop",
        "relative_crop": "relativeCrop",
        "remove_color": "removeColor",
        "resize": "resize",
        "rotate": "rotate",
        "scale": "scale",
        "shear": "shear",
        "trim": "trim",
        "unsharp_mask": "unsharpMask",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqual:
    def __init__(
        self,
        *,
        append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppend", typing.Dict[builtins.str, typing.Any]]]]] = None,
        aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAspectCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualBackgroundColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualBlur", typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualChromaKey", typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualComposite", typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompound", typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualContrast", typing.Dict[builtins.str, typing.Any]]]]] = None,
        crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFaceCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFeatureCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFill", typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualGoop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualGrayscale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualHsl", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualHsv", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientation", typing.Dict[builtins.str, typing.Any]]]]] = None,
        im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualImQuery", typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualMaxColors", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualMirror", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualMonoHue", typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualOpacity", typing.Dict[builtins.str, typing.Any]]]]] = None,
        region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRelativeCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRemoveColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualResize", typing.Dict[builtins.str, typing.Any]]]]] = None,
        rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRotate", typing.Dict[builtins.str, typing.Any]]]]] = None,
        scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualScale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualShear", typing.Dict[builtins.str, typing.Any]]]]] = None,
        trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualTrim", typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualUnsharpMask", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param append: append block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        :param aspect_crop: aspect_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param crop: crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        :param face_crop: face_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        :param feature_crop: feature_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        :param fit_and_fill: fit_and_fill block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param im_query: im_query block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param region_of_interest_crop: region_of_interest_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        :param relative_crop: relative_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param resize: resize block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        :param rotate: rotate block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        :param scale: scale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param shear: shear block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        :param trim: trim block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f9610166f983ff216bcc96091e5d6169c042a5f7f4a284ad2356235f528c3905)
            check_type(argname="argument append", value=append, expected_type=type_hints["append"])
            check_type(argname="argument aspect_crop", value=aspect_crop, expected_type=type_hints["aspect_crop"])
            check_type(argname="argument background_color", value=background_color, expected_type=type_hints["background_color"])
            check_type(argname="argument blur", value=blur, expected_type=type_hints["blur"])
            check_type(argname="argument chroma_key", value=chroma_key, expected_type=type_hints["chroma_key"])
            check_type(argname="argument composite", value=composite, expected_type=type_hints["composite"])
            check_type(argname="argument compound", value=compound, expected_type=type_hints["compound"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument crop", value=crop, expected_type=type_hints["crop"])
            check_type(argname="argument face_crop", value=face_crop, expected_type=type_hints["face_crop"])
            check_type(argname="argument feature_crop", value=feature_crop, expected_type=type_hints["feature_crop"])
            check_type(argname="argument fit_and_fill", value=fit_and_fill, expected_type=type_hints["fit_and_fill"])
            check_type(argname="argument goop", value=goop, expected_type=type_hints["goop"])
            check_type(argname="argument grayscale", value=grayscale, expected_type=type_hints["grayscale"])
            check_type(argname="argument hsl", value=hsl, expected_type=type_hints["hsl"])
            check_type(argname="argument hsv", value=hsv, expected_type=type_hints["hsv"])
            check_type(argname="argument if_dimension", value=if_dimension, expected_type=type_hints["if_dimension"])
            check_type(argname="argument if_orientation", value=if_orientation, expected_type=type_hints["if_orientation"])
            check_type(argname="argument im_query", value=im_query, expected_type=type_hints["im_query"])
            check_type(argname="argument max_colors", value=max_colors, expected_type=type_hints["max_colors"])
            check_type(argname="argument mirror", value=mirror, expected_type=type_hints["mirror"])
            check_type(argname="argument mono_hue", value=mono_hue, expected_type=type_hints["mono_hue"])
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument region_of_interest_crop", value=region_of_interest_crop, expected_type=type_hints["region_of_interest_crop"])
            check_type(argname="argument relative_crop", value=relative_crop, expected_type=type_hints["relative_crop"])
            check_type(argname="argument remove_color", value=remove_color, expected_type=type_hints["remove_color"])
            check_type(argname="argument resize", value=resize, expected_type=type_hints["resize"])
            check_type(argname="argument rotate", value=rotate, expected_type=type_hints["rotate"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument shear", value=shear, expected_type=type_hints["shear"])
            check_type(argname="argument trim", value=trim, expected_type=type_hints["trim"])
            check_type(argname="argument unsharp_mask", value=unsharp_mask, expected_type=type_hints["unsharp_mask"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if append is not None:
            self._values["append"] = append
        if aspect_crop is not None:
            self._values["aspect_crop"] = aspect_crop
        if background_color is not None:
            self._values["background_color"] = background_color
        if blur is not None:
            self._values["blur"] = blur
        if chroma_key is not None:
            self._values["chroma_key"] = chroma_key
        if composite is not None:
            self._values["composite"] = composite
        if compound is not None:
            self._values["compound"] = compound
        if contrast is not None:
            self._values["contrast"] = contrast
        if crop is not None:
            self._values["crop"] = crop
        if face_crop is not None:
            self._values["face_crop"] = face_crop
        if feature_crop is not None:
            self._values["feature_crop"] = feature_crop
        if fit_and_fill is not None:
            self._values["fit_and_fill"] = fit_and_fill
        if goop is not None:
            self._values["goop"] = goop
        if grayscale is not None:
            self._values["grayscale"] = grayscale
        if hsl is not None:
            self._values["hsl"] = hsl
        if hsv is not None:
            self._values["hsv"] = hsv
        if if_dimension is not None:
            self._values["if_dimension"] = if_dimension
        if if_orientation is not None:
            self._values["if_orientation"] = if_orientation
        if im_query is not None:
            self._values["im_query"] = im_query
        if max_colors is not None:
            self._values["max_colors"] = max_colors
        if mirror is not None:
            self._values["mirror"] = mirror
        if mono_hue is not None:
            self._values["mono_hue"] = mono_hue
        if opacity is not None:
            self._values["opacity"] = opacity
        if region_of_interest_crop is not None:
            self._values["region_of_interest_crop"] = region_of_interest_crop
        if relative_crop is not None:
            self._values["relative_crop"] = relative_crop
        if remove_color is not None:
            self._values["remove_color"] = remove_color
        if resize is not None:
            self._values["resize"] = resize
        if rotate is not None:
            self._values["rotate"] = rotate
        if scale is not None:
            self._values["scale"] = scale
        if shear is not None:
            self._values["shear"] = shear
        if trim is not None:
            self._values["trim"] = trim
        if unsharp_mask is not None:
            self._values["unsharp_mask"] = unsharp_mask

    @builtins.property
    def append(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppend"]]]:
        '''append block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        '''
        result = self._values.get("append")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppend"]]], result)

    @builtins.property
    def aspect_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAspectCrop"]]]:
        '''aspect_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        '''
        result = self._values.get("aspect_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAspectCrop"]]], result)

    @builtins.property
    def background_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualBackgroundColor"]]]:
        '''background_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        '''
        result = self._values.get("background_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualBackgroundColor"]]], result)

    @builtins.property
    def blur(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualBlur"]]]:
        '''blur block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        '''
        result = self._values.get("blur")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualBlur"]]], result)

    @builtins.property
    def chroma_key(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualChromaKey"]]]:
        '''chroma_key block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        '''
        result = self._values.get("chroma_key")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualChromaKey"]]], result)

    @builtins.property
    def composite(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualComposite"]]]:
        '''composite block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        '''
        result = self._values.get("composite")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualComposite"]]], result)

    @builtins.property
    def compound(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompound"]]]:
        '''compound block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        '''
        result = self._values.get("compound")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompound"]]], result)

    @builtins.property
    def contrast(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualContrast"]]]:
        '''contrast block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualContrast"]]], result)

    @builtins.property
    def crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCrop"]]]:
        '''crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        '''
        result = self._values.get("crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCrop"]]], result)

    @builtins.property
    def face_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFaceCrop"]]]:
        '''face_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        '''
        result = self._values.get("face_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFaceCrop"]]], result)

    @builtins.property
    def feature_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFeatureCrop"]]]:
        '''feature_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        '''
        result = self._values.get("feature_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFeatureCrop"]]], result)

    @builtins.property
    def fit_and_fill(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFill"]]]:
        '''fit_and_fill block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        '''
        result = self._values.get("fit_and_fill")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFill"]]], result)

    @builtins.property
    def goop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualGoop"]]]:
        '''goop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        '''
        result = self._values.get("goop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualGoop"]]], result)

    @builtins.property
    def grayscale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualGrayscale"]]]:
        '''grayscale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        '''
        result = self._values.get("grayscale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualGrayscale"]]], result)

    @builtins.property
    def hsl(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualHsl"]]]:
        '''hsl block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        '''
        result = self._values.get("hsl")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualHsl"]]], result)

    @builtins.property
    def hsv(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualHsv"]]]:
        '''hsv block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        '''
        result = self._values.get("hsv")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualHsv"]]], result)

    @builtins.property
    def if_dimension(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimension]]]:
        '''if_dimension block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        '''
        result = self._values.get("if_dimension")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimension]]], result)

    @builtins.property
    def if_orientation(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientation"]]]:
        '''if_orientation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        '''
        result = self._values.get("if_orientation")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientation"]]], result)

    @builtins.property
    def im_query(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualImQuery"]]]:
        '''im_query block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        '''
        result = self._values.get("im_query")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualImQuery"]]], result)

    @builtins.property
    def max_colors(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualMaxColors"]]]:
        '''max_colors block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        '''
        result = self._values.get("max_colors")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualMaxColors"]]], result)

    @builtins.property
    def mirror(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualMirror"]]]:
        '''mirror block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        '''
        result = self._values.get("mirror")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualMirror"]]], result)

    @builtins.property
    def mono_hue(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualMonoHue"]]]:
        '''mono_hue block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        '''
        result = self._values.get("mono_hue")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualMonoHue"]]], result)

    @builtins.property
    def opacity(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualOpacity"]]]:
        '''opacity block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualOpacity"]]], result)

    @builtins.property
    def region_of_interest_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCrop"]]]:
        '''region_of_interest_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        '''
        result = self._values.get("region_of_interest_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCrop"]]], result)

    @builtins.property
    def relative_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRelativeCrop"]]]:
        '''relative_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        '''
        result = self._values.get("relative_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRelativeCrop"]]], result)

    @builtins.property
    def remove_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRemoveColor"]]]:
        '''remove_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        '''
        result = self._values.get("remove_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRemoveColor"]]], result)

    @builtins.property
    def resize(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualResize"]]]:
        '''resize block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        '''
        result = self._values.get("resize")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualResize"]]], result)

    @builtins.property
    def rotate(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRotate"]]]:
        '''rotate block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        '''
        result = self._values.get("rotate")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRotate"]]], result)

    @builtins.property
    def scale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualScale"]]]:
        '''scale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualScale"]]], result)

    @builtins.property
    def shear(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualShear"]]]:
        '''shear block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        '''
        result = self._values.get("shear")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualShear"]]], result)

    @builtins.property
    def trim(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualTrim"]]]:
        '''trim block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        '''
        result = self._values.get("trim")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualTrim"]]], result)

    @builtins.property
    def unsharp_mask(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualUnsharpMask"]]]:
        '''unsharp_mask block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        result = self._values.get("unsharp_mask")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualUnsharpMask"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqual(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppend",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_priority": "gravityPriority",
        "gravity_priority_var": "gravityPriorityVar",
        "gravity_var": "gravityVar",
        "preserve_minor_dimension": "preserveMinorDimension",
        "preserve_minor_dimension_var": "preserveMinorDimensionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppend:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_priority: typing.Optional[builtins.str] = None,
        gravity_priority_var: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        preserve_minor_dimension: typing.Optional[builtins.str] = None,
        preserve_minor_dimension_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Specifies where to place the ``image`` relative to the source image. The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_priority: Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal. The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority DataAkamaiImagingPolicyImage#gravity_priority}
        :param gravity_priority_var: Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal. The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority_var DataAkamaiImagingPolicyImage#gravity_priority_var}
        :param gravity_var: Specifies where to place the ``image`` relative to the source image. The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param preserve_minor_dimension: Whether to preserve the source image's minor dimension, ``false`` by default. The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension DataAkamaiImagingPolicyImage#preserve_minor_dimension}
        :param preserve_minor_dimension_var: Whether to preserve the source image's minor dimension, ``false`` by default. The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension_var DataAkamaiImagingPolicyImage#preserve_minor_dimension_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__54ef7a70c67c2de45f975831ad58be1292d72d5b9cfd12e3fd1e74b442a10994)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_priority", value=gravity_priority, expected_type=type_hints["gravity_priority"])
            check_type(argname="argument gravity_priority_var", value=gravity_priority_var, expected_type=type_hints["gravity_priority_var"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument preserve_minor_dimension", value=preserve_minor_dimension, expected_type=type_hints["preserve_minor_dimension"])
            check_type(argname="argument preserve_minor_dimension_var", value=preserve_minor_dimension_var, expected_type=type_hints["preserve_minor_dimension_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_priority is not None:
            self._values["gravity_priority"] = gravity_priority
        if gravity_priority_var is not None:
            self._values["gravity_priority_var"] = gravity_priority_var
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if preserve_minor_dimension is not None:
            self._values["preserve_minor_dimension"] = preserve_minor_dimension
        if preserve_minor_dimension_var is not None:
            self._values["preserve_minor_dimension_var"] = preserve_minor_dimension_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Specifies where to place the ``image`` relative to the source image.

        The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_priority(self) -> typing.Optional[builtins.str]:
        '''Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal.

        The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority DataAkamaiImagingPolicyImage#gravity_priority}
        '''
        result = self._values.get("gravity_priority")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_priority_var(self) -> typing.Optional[builtins.str]:
        '''Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal.

        The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority_var DataAkamaiImagingPolicyImage#gravity_priority_var}
        '''
        result = self._values.get("gravity_priority_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Specifies where to place the ``image`` relative to the source image.

        The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def preserve_minor_dimension(self) -> typing.Optional[builtins.str]:
        '''Whether to preserve the source image's minor dimension, ``false`` by default.

        The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension DataAkamaiImagingPolicyImage#preserve_minor_dimension}
        '''
        result = self._values.get("preserve_minor_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def preserve_minor_dimension_var(self) -> typing.Optional[builtins.str]:
        '''Whether to preserve the source image's minor dimension, ``false`` by default.

        The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension_var DataAkamaiImagingPolicyImage#preserve_minor_dimension_var}
        '''
        result = self._values.get("preserve_minor_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppend(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImage",
    jsii_struct_bases=[],
    name_mapping={
        "box_image": "boxImage",
        "circle_image": "circleImage",
        "text_image": "textImage",
        "url_image": "urlImage",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImage:
    def __init__(
        self,
        *,
        box_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageBoxImage", typing.Dict[builtins.str, typing.Any]]]]] = None,
        circle_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageCircleImage", typing.Dict[builtins.str, typing.Any]]]]] = None,
        text_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageTextImage", typing.Dict[builtins.str, typing.Any]]]]] = None,
        url_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageUrlImage", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param box_image: box_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#box_image DataAkamaiImagingPolicyImage#box_image}
        :param circle_image: circle_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#circle_image DataAkamaiImagingPolicyImage#circle_image}
        :param text_image: text_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text_image DataAkamaiImagingPolicyImage#text_image}
        :param url_image: url_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url_image DataAkamaiImagingPolicyImage#url_image}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__496dd66396e6ce69815a11bb2496be0ffa2697698b83a5134a6c230a08c0db9b)
            check_type(argname="argument box_image", value=box_image, expected_type=type_hints["box_image"])
            check_type(argname="argument circle_image", value=circle_image, expected_type=type_hints["circle_image"])
            check_type(argname="argument text_image", value=text_image, expected_type=type_hints["text_image"])
            check_type(argname="argument url_image", value=url_image, expected_type=type_hints["url_image"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if box_image is not None:
            self._values["box_image"] = box_image
        if circle_image is not None:
            self._values["circle_image"] = circle_image
        if text_image is not None:
            self._values["text_image"] = text_image
        if url_image is not None:
            self._values["url_image"] = url_image

    @builtins.property
    def box_image(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageBoxImage"]]]:
        '''box_image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#box_image DataAkamaiImagingPolicyImage#box_image}
        '''
        result = self._values.get("box_image")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageBoxImage"]]], result)

    @builtins.property
    def circle_image(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageCircleImage"]]]:
        '''circle_image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#circle_image DataAkamaiImagingPolicyImage#circle_image}
        '''
        result = self._values.get("circle_image")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageCircleImage"]]], result)

    @builtins.property
    def text_image(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageTextImage"]]]:
        '''text_image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text_image DataAkamaiImagingPolicyImage#text_image}
        '''
        result = self._values.get("text_image")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageTextImage"]]], result)

    @builtins.property
    def url_image(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageUrlImage"]]]:
        '''url_image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url_image DataAkamaiImagingPolicyImage#url_image}
        '''
        result = self._values.get("url_image")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageUrlImage"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageBoxImage",
    jsii_struct_bases=[],
    name_mapping={
        "color": "color",
        "color_var": "colorVar",
        "height": "height",
        "height_var": "heightVar",
        "transformation": "transformation",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageBoxImage:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        transformation: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageBoxImageTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The fill color of the box, not the edge of the box. The API supports hexadecimal representation and CSS hexadecimal color values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The fill color of the box, not the edge of the box. The API supports hexadecimal representation and CSS hexadecimal color values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        :param height: The height of the box in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height of the box in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param transformation: transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        :param width: The width of the box in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width of the box in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(transformation, dict):
            transformation = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageBoxImageTransformation(**transformation)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b8d3931579eaded6c358b50f9cd6677d56e9fdd0308e904e65b8ec5770fe2966)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument transformation", value=transformation, expected_type=type_hints["transformation"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if transformation is not None:
            self._values["transformation"] = transformation
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The fill color of the box, not the edge of the box.

        The API supports hexadecimal representation and CSS hexadecimal color values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The fill color of the box, not the edge of the box.

        The API supports hexadecimal representation and CSS hexadecimal color values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height of the box in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height of the box in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def transformation(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageBoxImageTransformation"]:
        '''transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        '''
        result = self._values.get("transformation")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageBoxImageTransformation"], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width of the box in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width of the box in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageBoxImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageBoxImageList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageBoxImageList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3f0843ed6085a5d7fefbb2b6d29ffd9e1c09e393794b48e38f5860bc227d7076)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageBoxImageOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aaad172f572593ce43dd6437da6300aedeeb758146cb91ef2665d3bf086cd800)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageBoxImageOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a8521fa1271f5d32a26305cf5718a241d75ba960c29bcfe9ae3b031647d55fbd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d7ca54e0b9e925319dad5a5246969b65b0c9920d7036d7360310f5cb60612e55)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__23a0604af6818c253d8e97b1634ffcee088330dc352edeb249d717f12b226da7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageBoxImage]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageBoxImage]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageBoxImage]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d45f3f933249f8c7c0bf854598d09482d0e4cbb2f8e2d859e960ab59841cf7bf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageBoxImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageBoxImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__863429b966dacf4adbd889290bd4ddd3a4ef7afd84f5fe8df2470b25549f407e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformation")
    def put_transformation(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageBoxImageTransformation()

        return typing.cast(None, jsii.invoke(self, "putTransformation", [value]))

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetTransformation")
    def reset_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformation", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="transformation")
    def transformation(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageBoxImageTransformationOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageBoxImageTransformationOutputReference", jsii.get(self, "transformation"))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="transformationInput")
    def transformation_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageBoxImageTransformation"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageBoxImageTransformation"], jsii.get(self, "transformationInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d32ff915eaf140213332fbd52c44e2d1bf3605a6b1dfed91441fadda54f4ce63)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ae251dc7fb4feb32fe3211443c7972d4c1d62eb44d2fb2fc7536d5a9dccf6367)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__08edc488eebce647e9b7cb98ee43e5da55b9954d2cd88131d327755faba20277)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4b4627fd664b7cbb0e97c4f57e8a4de6b85338c4610a7ffbf8c47797f1cac5a5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6407daa317514db47737978d27c49fe0fcae20f014b6589c80f8504960e065ba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e532a4b36594d35022e54fedae6549f22e092de596d3f03478c11d63e97b480a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageBoxImage]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageBoxImage]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageBoxImage]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__287040c06b41f73afb28692f5a73ae98c3a2d95bb03c7c1e0fd259573fb01377)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageBoxImageTransformation",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageBoxImageTransformation:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageBoxImageTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageBoxImageTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageBoxImageTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e160f3045f4ceea05fa82479fc86f4c88c7cf3718f0cd078f4db11872360336c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageBoxImageTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageBoxImageTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageBoxImageTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__37632d9e9417f6f826aaf9e0b2e0de923b051748dba8c5fae9624620d03b5795)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageCircleImage",
    jsii_struct_bases=[],
    name_mapping={
        "color": "color",
        "color_var": "colorVar",
        "diameter": "diameter",
        "diameter_var": "diameterVar",
        "transformation": "transformation",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageCircleImage:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
        diameter: typing.Optional[builtins.str] = None,
        diameter_var: typing.Optional[builtins.str] = None,
        transformation: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageCircleImageTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The fill color of the circle. The API supports hexadecimal representation and CSS hexadecimal color values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The fill color of the circle. The API supports hexadecimal representation and CSS hexadecimal color values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        :param diameter: The diameter of the circle. The diameter will be the width and the height of the image in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#diameter DataAkamaiImagingPolicyImage#diameter}
        :param diameter_var: The diameter of the circle. The diameter will be the width and the height of the image in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#diameter_var DataAkamaiImagingPolicyImage#diameter_var}
        :param transformation: transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        :param width: The width of the box in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width of the box in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(transformation, dict):
            transformation = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageCircleImageTransformation(**transformation)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0df31be1a1006ee134318b7375ac9210ecad0c113acb906c8243c167d13bd19a)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
            check_type(argname="argument diameter", value=diameter, expected_type=type_hints["diameter"])
            check_type(argname="argument diameter_var", value=diameter_var, expected_type=type_hints["diameter_var"])
            check_type(argname="argument transformation", value=transformation, expected_type=type_hints["transformation"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var
        if diameter is not None:
            self._values["diameter"] = diameter
        if diameter_var is not None:
            self._values["diameter_var"] = diameter_var
        if transformation is not None:
            self._values["transformation"] = transformation
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The fill color of the circle. The API supports hexadecimal representation and CSS hexadecimal color values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The fill color of the circle. The API supports hexadecimal representation and CSS hexadecimal color values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def diameter(self) -> typing.Optional[builtins.str]:
        '''The diameter of the circle. The diameter will be the width and the height of the image in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#diameter DataAkamaiImagingPolicyImage#diameter}
        '''
        result = self._values.get("diameter")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def diameter_var(self) -> typing.Optional[builtins.str]:
        '''The diameter of the circle. The diameter will be the width and the height of the image in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#diameter_var DataAkamaiImagingPolicyImage#diameter_var}
        '''
        result = self._values.get("diameter_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def transformation(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageCircleImageTransformation"]:
        '''transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        '''
        result = self._values.get("transformation")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageCircleImageTransformation"], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width of the box in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width of the box in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageCircleImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageCircleImageList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageCircleImageList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d622cff2be4170a056c357d82074985dd883d9e37c6744540fe16c66491f43c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageCircleImageOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__61e7ed2f8b36b460f6bbee71a4d916bbc4949c64d03ae50af8105bd9fc4d6e27)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageCircleImageOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__37b80eaeb6885919865809ebafd79c857b997d90b28273c4ba49b4a18bbf5036)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bfe929c8f2f5956784b16474a7ea5a24fd2b2b90995f7579ff7224ef94123660)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__01f0c552b862821901f72ac829e6c833d225cc1827a6f91220dddd0a40eee97b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageCircleImage]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageCircleImage]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageCircleImage]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__db83f9ca9bc21293720def1cebd520d23881d9a9b12b9d03434a6e32489f1f6f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageCircleImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageCircleImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__426ced8f59ef5fd7315fed49a98e314d8db2aba102b27c5a6850c1e2fb4f968d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformation")
    def put_transformation(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageCircleImageTransformation()

        return typing.cast(None, jsii.invoke(self, "putTransformation", [value]))

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @jsii.member(jsii_name="resetDiameter")
    def reset_diameter(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDiameter", []))

    @jsii.member(jsii_name="resetDiameterVar")
    def reset_diameter_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDiameterVar", []))

    @jsii.member(jsii_name="resetTransformation")
    def reset_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformation", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="transformation")
    def transformation(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageCircleImageTransformationOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageCircleImageTransformationOutputReference", jsii.get(self, "transformation"))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="diameterInput")
    def diameter_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "diameterInput"))

    @builtins.property
    @jsii.member(jsii_name="diameterVarInput")
    def diameter_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "diameterVarInput"))

    @builtins.property
    @jsii.member(jsii_name="transformationInput")
    def transformation_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageCircleImageTransformation"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageCircleImageTransformation"], jsii.get(self, "transformationInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bd92cffd5cd8f18499cf574023d4062ac267bb10c4a9b6be164795a44d2b5bf1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c685b8a2e93a46e7d829c8c9ff5b01a5c7d3658bcba1ca9a41882eb2824a0c00)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="diameter")
    def diameter(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "diameter"))

    @diameter.setter
    def diameter(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8fa31c5f4abee7c3dee0aee5ea4ece9a1d273a44da7eb359da998650ba6d141c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "diameter", value)

    @builtins.property
    @jsii.member(jsii_name="diameterVar")
    def diameter_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "diameterVar"))

    @diameter_var.setter
    def diameter_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c7e90260a89024f9b847877d4c05ca95ccc4fc3e2ebbadc877421e53574cb71a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "diameterVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dc810de0365358ee398fedd3158c73f76564b02c731d9fb1bf95204e3c992b3c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3eb17a5f15f22709eb97d11af09bf632d18a2629c2b116cca350cfead1165805)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageCircleImage]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageCircleImage]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageCircleImage]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ff3d809d4623c287a6fa9ad1a9d6ed7233eee22358ee699c957eb6bee4528a01)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageCircleImageTransformation",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageCircleImageTransformation:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageCircleImageTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageCircleImageTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageCircleImageTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8c62e2f3b7a55c104077683297dad4cb0e94b1e9f03d8f72589204de562bd2de)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageCircleImageTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageCircleImageTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageCircleImageTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1a14aa2690aa5ea6d3c00a054965d9cfae2c9c9253ad8056327b38a38cd4130f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7a7bbf3163aeb3d20a9a1ebd68fc16af17a1afff1c6d58cf6c8a4b250e49ba8e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putBoxImage")
    def put_box_image(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageBoxImage, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__150723d42ecebb3a4655294f408284934d58e441dae3ba78a811bbf78838ba79)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBoxImage", [value]))

    @jsii.member(jsii_name="putCircleImage")
    def put_circle_image(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageCircleImage, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6de01a1c028a40891a7ba356818515f2d0582f4b0df0199ce2bd4c09ff37adb6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCircleImage", [value]))

    @jsii.member(jsii_name="putTextImage")
    def put_text_image(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageTextImage", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7915c81c5a4270690745462e1c072aea076cd4c7efe315b8871ce919471c19f2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTextImage", [value]))

    @jsii.member(jsii_name="putUrlImage")
    def put_url_image(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageUrlImage", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__351b70ea4404f9a3307fe03856eafb0f50a9c00a9fb9574d51854b6347f45a37)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putUrlImage", [value]))

    @jsii.member(jsii_name="resetBoxImage")
    def reset_box_image(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBoxImage", []))

    @jsii.member(jsii_name="resetCircleImage")
    def reset_circle_image(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCircleImage", []))

    @jsii.member(jsii_name="resetTextImage")
    def reset_text_image(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTextImage", []))

    @jsii.member(jsii_name="resetUrlImage")
    def reset_url_image(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUrlImage", []))

    @builtins.property
    @jsii.member(jsii_name="boxImage")
    def box_image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageBoxImageList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageBoxImageList, jsii.get(self, "boxImage"))

    @builtins.property
    @jsii.member(jsii_name="circleImage")
    def circle_image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageCircleImageList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageCircleImageList, jsii.get(self, "circleImage"))

    @builtins.property
    @jsii.member(jsii_name="textImage")
    def text_image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageTextImageList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageTextImageList", jsii.get(self, "textImage"))

    @builtins.property
    @jsii.member(jsii_name="urlImage")
    def url_image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageUrlImageList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageUrlImageList", jsii.get(self, "urlImage"))

    @builtins.property
    @jsii.member(jsii_name="boxImageInput")
    def box_image_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageBoxImage]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageBoxImage]]], jsii.get(self, "boxImageInput"))

    @builtins.property
    @jsii.member(jsii_name="circleImageInput")
    def circle_image_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageCircleImage]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageCircleImage]]], jsii.get(self, "circleImageInput"))

    @builtins.property
    @jsii.member(jsii_name="textImageInput")
    def text_image_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageTextImage"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageTextImage"]]], jsii.get(self, "textImageInput"))

    @builtins.property
    @jsii.member(jsii_name="urlImageInput")
    def url_image_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageUrlImage"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageUrlImage"]]], jsii.get(self, "urlImageInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ee7954e55cdc6fa6dd6b7ee8c3235621393565845e1d8c3186410f383286fae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageTextImage",
    jsii_struct_bases=[],
    name_mapping={
        "fill": "fill",
        "fill_var": "fillVar",
        "size": "size",
        "size_var": "sizeVar",
        "stroke": "stroke",
        "stroke_size": "strokeSize",
        "stroke_size_var": "strokeSizeVar",
        "stroke_var": "strokeVar",
        "text": "text",
        "text_var": "textVar",
        "transformation": "transformation",
        "typeface": "typeface",
        "typeface_var": "typefaceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageTextImage:
    def __init__(
        self,
        *,
        fill: typing.Optional[builtins.str] = None,
        fill_var: typing.Optional[builtins.str] = None,
        size: typing.Optional[builtins.str] = None,
        size_var: typing.Optional[builtins.str] = None,
        stroke: typing.Optional[builtins.str] = None,
        stroke_size: typing.Optional[builtins.str] = None,
        stroke_size_var: typing.Optional[builtins.str] = None,
        stroke_var: typing.Optional[builtins.str] = None,
        text: typing.Optional[builtins.str] = None,
        text_var: typing.Optional[builtins.str] = None,
        transformation: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageTextImageTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        typeface: typing.Optional[builtins.str] = None,
        typeface_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fill: The main fill color of the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill DataAkamaiImagingPolicyImage#fill}
        :param fill_var: The main fill color of the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_var DataAkamaiImagingPolicyImage#fill_var}
        :param size: The size in pixels to render the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#size DataAkamaiImagingPolicyImage#size}
        :param size_var: The size in pixels to render the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#size_var DataAkamaiImagingPolicyImage#size_var}
        :param stroke: The color for the outline of the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke DataAkamaiImagingPolicyImage#stroke}
        :param stroke_size: The thickness in points for the outline of the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_size DataAkamaiImagingPolicyImage#stroke_size}
        :param stroke_size_var: The thickness in points for the outline of the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_size_var DataAkamaiImagingPolicyImage#stroke_size_var}
        :param stroke_var: The color for the outline of the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_var DataAkamaiImagingPolicyImage#stroke_var}
        :param text: The line of text to render. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text DataAkamaiImagingPolicyImage#text}
        :param text_var: The line of text to render. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text_var DataAkamaiImagingPolicyImage#text_var}
        :param transformation: transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        :param typeface: The font family to apply to the text image. This may be a URL to a TrueType or WOFF (v1) typeface, or a string that refers to one of the standard built-in browser fonts. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#typeface DataAkamaiImagingPolicyImage#typeface}
        :param typeface_var: The font family to apply to the text image. This may be a URL to a TrueType or WOFF (v1) typeface, or a string that refers to one of the standard built-in browser fonts. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#typeface_var DataAkamaiImagingPolicyImage#typeface_var}
        '''
        if isinstance(transformation, dict):
            transformation = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageTextImageTransformation(**transformation)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0c8c4d274d1e26be044c6c6aca277b265f57e6af67c975a1bb1691b0c6211f47)
            check_type(argname="argument fill", value=fill, expected_type=type_hints["fill"])
            check_type(argname="argument fill_var", value=fill_var, expected_type=type_hints["fill_var"])
            check_type(argname="argument size", value=size, expected_type=type_hints["size"])
            check_type(argname="argument size_var", value=size_var, expected_type=type_hints["size_var"])
            check_type(argname="argument stroke", value=stroke, expected_type=type_hints["stroke"])
            check_type(argname="argument stroke_size", value=stroke_size, expected_type=type_hints["stroke_size"])
            check_type(argname="argument stroke_size_var", value=stroke_size_var, expected_type=type_hints["stroke_size_var"])
            check_type(argname="argument stroke_var", value=stroke_var, expected_type=type_hints["stroke_var"])
            check_type(argname="argument text", value=text, expected_type=type_hints["text"])
            check_type(argname="argument text_var", value=text_var, expected_type=type_hints["text_var"])
            check_type(argname="argument transformation", value=transformation, expected_type=type_hints["transformation"])
            check_type(argname="argument typeface", value=typeface, expected_type=type_hints["typeface"])
            check_type(argname="argument typeface_var", value=typeface_var, expected_type=type_hints["typeface_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fill is not None:
            self._values["fill"] = fill
        if fill_var is not None:
            self._values["fill_var"] = fill_var
        if size is not None:
            self._values["size"] = size
        if size_var is not None:
            self._values["size_var"] = size_var
        if stroke is not None:
            self._values["stroke"] = stroke
        if stroke_size is not None:
            self._values["stroke_size"] = stroke_size
        if stroke_size_var is not None:
            self._values["stroke_size_var"] = stroke_size_var
        if stroke_var is not None:
            self._values["stroke_var"] = stroke_var
        if text is not None:
            self._values["text"] = text
        if text_var is not None:
            self._values["text_var"] = text_var
        if transformation is not None:
            self._values["transformation"] = transformation
        if typeface is not None:
            self._values["typeface"] = typeface
        if typeface_var is not None:
            self._values["typeface_var"] = typeface_var

    @builtins.property
    def fill(self) -> typing.Optional[builtins.str]:
        '''The main fill color of the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill DataAkamaiImagingPolicyImage#fill}
        '''
        result = self._values.get("fill")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fill_var(self) -> typing.Optional[builtins.str]:
        '''The main fill color of the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_var DataAkamaiImagingPolicyImage#fill_var}
        '''
        result = self._values.get("fill_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def size(self) -> typing.Optional[builtins.str]:
        '''The size in pixels to render the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#size DataAkamaiImagingPolicyImage#size}
        '''
        result = self._values.get("size")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def size_var(self) -> typing.Optional[builtins.str]:
        '''The size in pixels to render the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#size_var DataAkamaiImagingPolicyImage#size_var}
        '''
        result = self._values.get("size_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def stroke(self) -> typing.Optional[builtins.str]:
        '''The color for the outline of the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke DataAkamaiImagingPolicyImage#stroke}
        '''
        result = self._values.get("stroke")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def stroke_size(self) -> typing.Optional[builtins.str]:
        '''The thickness in points for the outline of the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_size DataAkamaiImagingPolicyImage#stroke_size}
        '''
        result = self._values.get("stroke_size")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def stroke_size_var(self) -> typing.Optional[builtins.str]:
        '''The thickness in points for the outline of the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_size_var DataAkamaiImagingPolicyImage#stroke_size_var}
        '''
        result = self._values.get("stroke_size_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def stroke_var(self) -> typing.Optional[builtins.str]:
        '''The color for the outline of the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_var DataAkamaiImagingPolicyImage#stroke_var}
        '''
        result = self._values.get("stroke_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def text(self) -> typing.Optional[builtins.str]:
        '''The line of text to render.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text DataAkamaiImagingPolicyImage#text}
        '''
        result = self._values.get("text")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def text_var(self) -> typing.Optional[builtins.str]:
        '''The line of text to render.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text_var DataAkamaiImagingPolicyImage#text_var}
        '''
        result = self._values.get("text_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def transformation(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageTextImageTransformation"]:
        '''transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        '''
        result = self._values.get("transformation")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageTextImageTransformation"], result)

    @builtins.property
    def typeface(self) -> typing.Optional[builtins.str]:
        '''The font family to apply to the text image.

        This may be a URL to a TrueType or WOFF (v1) typeface, or a string that refers to one of the standard built-in browser fonts.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#typeface DataAkamaiImagingPolicyImage#typeface}
        '''
        result = self._values.get("typeface")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def typeface_var(self) -> typing.Optional[builtins.str]:
        '''The font family to apply to the text image.

        This may be a URL to a TrueType or WOFF (v1) typeface, or a string that refers to one of the standard built-in browser fonts.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#typeface_var DataAkamaiImagingPolicyImage#typeface_var}
        '''
        result = self._values.get("typeface_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageTextImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageTextImageList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageTextImageList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3bceda44ca74cd94290de9786654359c55ff43f0134adb3c6faad0eca9944883)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageTextImageOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__37e63ef93576887ddf5b07657a094de87563b65fbac7f47a1faea003b6f4f502)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageTextImageOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__54ab423f6aaace1d96143068dec0f21934e3e0e4827d92f2911d57656ee3552a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__abb95720abe56c9d828d377683649693f36a1de3407813cf2e2e4db1b72b5811)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a3ca14888f0999056b710abaa41abc456c4836a94b17121ffe991a29b50b2b89)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageTextImage]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageTextImage]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageTextImage]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8ddcca0cc5efa1f39bbfe497f8de720a8601cd153546ae786bbc2322c184c118)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageTextImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageTextImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9bb4cb1417ff37c7c84eaf12c5106abd2e05362d134e6b71a70f16114cbff949)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformation")
    def put_transformation(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageTextImageTransformation()

        return typing.cast(None, jsii.invoke(self, "putTransformation", [value]))

    @jsii.member(jsii_name="resetFill")
    def reset_fill(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFill", []))

    @jsii.member(jsii_name="resetFillVar")
    def reset_fill_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFillVar", []))

    @jsii.member(jsii_name="resetSize")
    def reset_size(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSize", []))

    @jsii.member(jsii_name="resetSizeVar")
    def reset_size_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSizeVar", []))

    @jsii.member(jsii_name="resetStroke")
    def reset_stroke(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStroke", []))

    @jsii.member(jsii_name="resetStrokeSize")
    def reset_stroke_size(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStrokeSize", []))

    @jsii.member(jsii_name="resetStrokeSizeVar")
    def reset_stroke_size_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStrokeSizeVar", []))

    @jsii.member(jsii_name="resetStrokeVar")
    def reset_stroke_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStrokeVar", []))

    @jsii.member(jsii_name="resetText")
    def reset_text(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetText", []))

    @jsii.member(jsii_name="resetTextVar")
    def reset_text_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTextVar", []))

    @jsii.member(jsii_name="resetTransformation")
    def reset_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformation", []))

    @jsii.member(jsii_name="resetTypeface")
    def reset_typeface(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeface", []))

    @jsii.member(jsii_name="resetTypefaceVar")
    def reset_typeface_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypefaceVar", []))

    @builtins.property
    @jsii.member(jsii_name="transformation")
    def transformation(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageTextImageTransformationOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageTextImageTransformationOutputReference", jsii.get(self, "transformation"))

    @builtins.property
    @jsii.member(jsii_name="fillInput")
    def fill_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fillInput"))

    @builtins.property
    @jsii.member(jsii_name="fillVarInput")
    def fill_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fillVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sizeInput")
    def size_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sizeInput"))

    @builtins.property
    @jsii.member(jsii_name="sizeVarInput")
    def size_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sizeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="strokeInput")
    def stroke_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "strokeInput"))

    @builtins.property
    @jsii.member(jsii_name="strokeSizeInput")
    def stroke_size_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "strokeSizeInput"))

    @builtins.property
    @jsii.member(jsii_name="strokeSizeVarInput")
    def stroke_size_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "strokeSizeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="strokeVarInput")
    def stroke_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "strokeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="textInput")
    def text_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "textInput"))

    @builtins.property
    @jsii.member(jsii_name="textVarInput")
    def text_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "textVarInput"))

    @builtins.property
    @jsii.member(jsii_name="transformationInput")
    def transformation_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageTextImageTransformation"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageTextImageTransformation"], jsii.get(self, "transformationInput"))

    @builtins.property
    @jsii.member(jsii_name="typefaceInput")
    def typeface_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typefaceInput"))

    @builtins.property
    @jsii.member(jsii_name="typefaceVarInput")
    def typeface_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typefaceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="fill")
    def fill(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fill"))

    @fill.setter
    def fill(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c1f2d53d84e503251e2be43640792790e456fc21d349bb43e8d24bc891783b95)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fill", value)

    @builtins.property
    @jsii.member(jsii_name="fillVar")
    def fill_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fillVar"))

    @fill_var.setter
    def fill_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__669b36eb7b65425090d3969f15e812323989246ea9625caea5c54499608e5564)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fillVar", value)

    @builtins.property
    @jsii.member(jsii_name="size")
    def size(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "size"))

    @size.setter
    def size(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e627531afe878a527fc6d0bc954a92ddb7e34e6b91c74755e90feb4033c74564)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "size", value)

    @builtins.property
    @jsii.member(jsii_name="sizeVar")
    def size_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sizeVar"))

    @size_var.setter
    def size_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6bae7d518e86ad7267405ce38158db715493d5f141d45fa851fc225c6dce68e3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sizeVar", value)

    @builtins.property
    @jsii.member(jsii_name="stroke")
    def stroke(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "stroke"))

    @stroke.setter
    def stroke(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5a8ccfef7ceec781c7980762bb6f39075da20f0fb559241e858cb2d092d64137)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "stroke", value)

    @builtins.property
    @jsii.member(jsii_name="strokeSize")
    def stroke_size(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "strokeSize"))

    @stroke_size.setter
    def stroke_size(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4bd2448be43450b03c92b97e960d90d6c6041c0d2b770cde9a1909757df446a4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "strokeSize", value)

    @builtins.property
    @jsii.member(jsii_name="strokeSizeVar")
    def stroke_size_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "strokeSizeVar"))

    @stroke_size_var.setter
    def stroke_size_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c12f5c10b878bfc03f2d4b33a322788be7eeaed782f6288831bf8e4d8e8cd4bf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "strokeSizeVar", value)

    @builtins.property
    @jsii.member(jsii_name="strokeVar")
    def stroke_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "strokeVar"))

    @stroke_var.setter
    def stroke_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f0d598d6759226208fc848e2d86fcd7e9a77e41d170e99c780fe89d5ff57bfed)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "strokeVar", value)

    @builtins.property
    @jsii.member(jsii_name="text")
    def text(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "text"))

    @text.setter
    def text(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2864675835cd3a49371e2b2224414b9cd4e92533666b03c72b2bcc0dc890ba4d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "text", value)

    @builtins.property
    @jsii.member(jsii_name="textVar")
    def text_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "textVar"))

    @text_var.setter
    def text_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d615dabaf51ae60d9d5f73827dad5d1c9e4c10e4b80988a6a4a535073838f27)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "textVar", value)

    @builtins.property
    @jsii.member(jsii_name="typeface")
    def typeface(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeface"))

    @typeface.setter
    def typeface(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__22c6e6247cbae05f38424de90f1c5ca02439dd5ea93e4e7106142fc60914bb4c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeface", value)

    @builtins.property
    @jsii.member(jsii_name="typefaceVar")
    def typeface_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typefaceVar"))

    @typeface_var.setter
    def typeface_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__037caa161aa985c1bc643e9ba554b562f85a3eb8d7a12f1189bbd3c7ba6c340e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typefaceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageTextImage]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageTextImage]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageTextImage]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d8efe9cd2964d5df8d3c94e430a398af259700c69ad7828a89c6e094c63e35a1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageTextImageTransformation",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageTextImageTransformation:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageTextImageTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageTextImageTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageTextImageTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__31950d8b1ccac43654627360aba0442f95c5753b7ce2ab02df8517f22fdb8ea4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageTextImageTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageTextImageTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageTextImageTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5b6016b3a46e5b6c53c1f3022bbf0e114d9b889cf052dbf4248848c3004738f1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageUrlImage",
    jsii_struct_bases=[],
    name_mapping={
        "transformation": "transformation",
        "url": "url",
        "url_var": "urlVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageUrlImage:
    def __init__(
        self,
        *,
        transformation: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageUrlImageTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        url: typing.Optional[builtins.str] = None,
        url_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param transformation: transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        :param url: The URL of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url DataAkamaiImagingPolicyImage#url}
        :param url_var: The URL of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url_var DataAkamaiImagingPolicyImage#url_var}
        '''
        if isinstance(transformation, dict):
            transformation = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageUrlImageTransformation(**transformation)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c86c376a4f80c98bd821ecc84cdbbc0b30b4eba3d423ec67b1051d71322fb912)
            check_type(argname="argument transformation", value=transformation, expected_type=type_hints["transformation"])
            check_type(argname="argument url", value=url, expected_type=type_hints["url"])
            check_type(argname="argument url_var", value=url_var, expected_type=type_hints["url_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if transformation is not None:
            self._values["transformation"] = transformation
        if url is not None:
            self._values["url"] = url
        if url_var is not None:
            self._values["url_var"] = url_var

    @builtins.property
    def transformation(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageUrlImageTransformation"]:
        '''transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        '''
        result = self._values.get("transformation")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageUrlImageTransformation"], result)

    @builtins.property
    def url(self) -> typing.Optional[builtins.str]:
        '''The URL of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url DataAkamaiImagingPolicyImage#url}
        '''
        result = self._values.get("url")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def url_var(self) -> typing.Optional[builtins.str]:
        '''The URL of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url_var DataAkamaiImagingPolicyImage#url_var}
        '''
        result = self._values.get("url_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageUrlImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageUrlImageList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageUrlImageList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__745c53218a73851e6f8c5bb90753f7e846a6969e18b9bd325d1a81e854016dcd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageUrlImageOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7f94d85340af75542ef9c4395384d43ededd9f9a22a94ae0d959e0ed0751ba63)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageUrlImageOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6c571b7ae9e11ca5ec1ad88868df843300a90d2a4d6fdfeb200aa11d446a4328)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bf739d9c30cd6934d218b477e8941ac755fd6b12f66c1a03fb4e5b249ae0b846)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ae732a9d25c29c309ebb29b4f51382ab4f8f4e62bb5d995f92436fbef34892bc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageUrlImage]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageUrlImage]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageUrlImage]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__473db764d9458a9ee99b5fd7454067a6611376e0305820d0443a46aab4e1620d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageUrlImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageUrlImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__12783130ee8dca84a437e40622b6146426692bda97b180c905161caef2a3a000)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformation")
    def put_transformation(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageUrlImageTransformation()

        return typing.cast(None, jsii.invoke(self, "putTransformation", [value]))

    @jsii.member(jsii_name="resetTransformation")
    def reset_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformation", []))

    @jsii.member(jsii_name="resetUrl")
    def reset_url(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUrl", []))

    @jsii.member(jsii_name="resetUrlVar")
    def reset_url_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUrlVar", []))

    @builtins.property
    @jsii.member(jsii_name="transformation")
    def transformation(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageUrlImageTransformationOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageUrlImageTransformationOutputReference", jsii.get(self, "transformation"))

    @builtins.property
    @jsii.member(jsii_name="transformationInput")
    def transformation_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageUrlImageTransformation"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageUrlImageTransformation"], jsii.get(self, "transformationInput"))

    @builtins.property
    @jsii.member(jsii_name="urlInput")
    def url_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "urlInput"))

    @builtins.property
    @jsii.member(jsii_name="urlVarInput")
    def url_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "urlVarInput"))

    @builtins.property
    @jsii.member(jsii_name="url")
    def url(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "url"))

    @url.setter
    def url(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a36f58491d8e1ca7853343cb1a91800696cdacf96f851f196daa5ddf575efe41)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "url", value)

    @builtins.property
    @jsii.member(jsii_name="urlVar")
    def url_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "urlVar"))

    @url_var.setter
    def url_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7b53aaa16d2c322078737d0062d7ac0e160adfd1047ddfa72f21e3e60bd63b19)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "urlVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageUrlImage]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageUrlImage]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageUrlImage]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__10d7a85598412d4bb548990001db06029d2118f88c88ac2c165f2e806a963115)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageUrlImageTransformation",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageUrlImageTransformation:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageUrlImageTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageUrlImageTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageUrlImageTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__70938e910e5f5fbc2a2d058d7287e74f1d99b5cb3bbe9e5961cba4107c8b929f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageUrlImageTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageUrlImageTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageUrlImageTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c08cccd3c452781074fe12ee8ab8b798383ea1ff9bb0f3885ab79715572536a4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__44ac10a6ebadbc972acece3d58236ca245e18f0b84490cb69af0ceae44b9fd46)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d57180d469d346e87bbe6ba53afb4b5e0a391c649847246cdff6588e571df84)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__04ecd46b434cceaf45d7ae9c233fadc126486e2beb85e5ff3be54e54abf3db77)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fe5195717602223d1a774285849bae4437234fb2dce6db5d256a3a9bf15c6d11)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ee2708cc2f53a0bf7c71b88ae5a1aea9ed94383158afb29bbf7d3df59974a0e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppend]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppend]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppend]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__87e41c31e513e8f72c362bafc353de500ccccbaba1f7bd466c90a1dac6b157b2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3808105c92720fdd695c2cb06c66b04084ded71b781da8b77a1ee6f1a1f80fcd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(
        self,
        *,
        box_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageBoxImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
        circle_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageCircleImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
        text_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageTextImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
        url_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageUrlImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param box_image: box_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#box_image DataAkamaiImagingPolicyImage#box_image}
        :param circle_image: circle_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#circle_image DataAkamaiImagingPolicyImage#circle_image}
        :param text_image: text_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text_image DataAkamaiImagingPolicyImage#text_image}
        :param url_image: url_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url_image DataAkamaiImagingPolicyImage#url_image}
        '''
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImage(
            box_image=box_image,
            circle_image=circle_image,
            text_image=text_image,
            url_image=url_image,
        )

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityPriority")
    def reset_gravity_priority(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityPriority", []))

    @jsii.member(jsii_name="resetGravityPriorityVar")
    def reset_gravity_priority_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityPriorityVar", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPreserveMinorDimension")
    def reset_preserve_minor_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPreserveMinorDimension", []))

    @jsii.member(jsii_name="resetPreserveMinorDimensionVar")
    def reset_preserve_minor_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPreserveMinorDimensionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityInput")
    def gravity_priority_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityPriorityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityVarInput")
    def gravity_priority_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityPriorityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionInput")
    def preserve_minor_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "preserveMinorDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionVarInput")
    def preserve_minor_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "preserveMinorDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6aaef68143bfa4f239094e4d0b87cc5a6e54c465b2ae9885c8263f9de6b5fe61)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityPriority")
    def gravity_priority(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityPriority"))

    @gravity_priority.setter
    def gravity_priority(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__05dac6b5bdcd7a8a0d18bb26411b3320011065bcd23548d6033f188721079eb5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityPriority", value)

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityVar")
    def gravity_priority_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityPriorityVar"))

    @gravity_priority_var.setter
    def gravity_priority_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0e665167b6f9e0cc3af59b8da6e91aca18e711c0f78d935c24a48f03a3f8bbf9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityPriorityVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__711a73c7e3f3c45a1e45cfc2b0d3ac22f6e888cd9468bafbac83c8c5dba955c8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimension")
    def preserve_minor_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "preserveMinorDimension"))

    @preserve_minor_dimension.setter
    def preserve_minor_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__792a091dab79dccf3b2845a44c057d180809a165d53260316ad55e630b67e1d3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "preserveMinorDimension", value)

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionVar")
    def preserve_minor_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "preserveMinorDimensionVar"))

    @preserve_minor_dimension_var.setter
    def preserve_minor_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8b1321f2aea4499e03edb9198f8f1101b1864053008993aeb6e8821b2148d5b8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "preserveMinorDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppend]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppend]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppend]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__22c691adfe294a4247da3b48e48db7e16f08a142df6d9eb08b6cd9fc3e2bb61b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAspectCrop",
    jsii_struct_bases=[],
    name_mapping={
        "allow_expansion": "allowExpansion",
        "allow_expansion_var": "allowExpansionVar",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAspectCrop:
    def __init__(
        self,
        *,
        allow_expansion: typing.Optional[builtins.str] = None,
        allow_expansion_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_expansion: Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image. Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        :param allow_expansion_var: Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image. Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        :param height: The height term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The width term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        :param x_position: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e2432039101009040bf50a1179b7177dab55a8d8b8d53da3fc205d89ab39c2bf)
            check_type(argname="argument allow_expansion", value=allow_expansion, expected_type=type_hints["allow_expansion"])
            check_type(argname="argument allow_expansion_var", value=allow_expansion_var, expected_type=type_hints["allow_expansion_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if allow_expansion is not None:
            self._values["allow_expansion"] = allow_expansion
        if allow_expansion_var is not None:
            self._values["allow_expansion_var"] = allow_expansion_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def allow_expansion(self) -> typing.Optional[builtins.str]:
        '''Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image.

        Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        '''
        result = self._values.get("allow_expansion")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def allow_expansion_var(self) -> typing.Optional[builtins.str]:
        '''Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image.

        Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        '''
        result = self._values.get("allow_expansion_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAspectCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAspectCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAspectCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d16c24e0785d9a2bff0157b5b84bb9fe4d3a32bf853a8ea6837277f48d4d0dbc)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAspectCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__304fea66b976d2cc2192c9e6a43975e96240edd44ba5dc2bebf26f9e98c3b46c)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAspectCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7c9240f01944fde66cf6cb155e1c38e7043c074c04a3cb38dcb93c23b3db431f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ba6aa17ec26f59b253774fe0bd1dab53c17568dde588bc53d56811f26ecda4db)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2f920d951c6791f6e2ff65d29086e911f15c2f6992785c9ad016d8c9dae6ca5b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAspectCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAspectCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAspectCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__61ec8475acc67fa6f055c0aa8518bc6cdb409d1fedc2d0d7e52b83c9ba9d17d5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAspectCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAspectCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be07bda1331737b993d1799c54623d16a317f0cbc35a97f6c904c13feed4b5c2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAllowExpansion")
    def reset_allow_expansion(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansion", []))

    @jsii.member(jsii_name="resetAllowExpansionVar")
    def reset_allow_expansion_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansionVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionInput")
    def allow_expansion_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVarInput")
    def allow_expansion_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansion")
    def allow_expansion(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansion"))

    @allow_expansion.setter
    def allow_expansion(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7f8fe8e3c581c8811273a8f771638b4b3c550bd476c658ae9dfcfc6c6a502d75)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansion", value)

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVar")
    def allow_expansion_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansionVar"))

    @allow_expansion_var.setter
    def allow_expansion_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__505eac300993cb30e8c52390bb71dcd9b620df0a81ee49711317ddcf2a701ae2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansionVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__17283254310e7c34717387dca23d74550cc841239a087fa1cb438f72c6889bda)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__03caea8083a30efe2a5164c3d45570d11cc098be51679b41165f55a65c3c592f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c8abded11d46dc69c123b3c077f2d54df3dc466e3fb8547dc5d6ff5872b45aef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eb45dc862253c72ec93910882c72d7b11ca2ff697dedd645bef270db5b1f623b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__65d686f5e17dd2a671155e1710963540eacdbf4fa9df45fb2063338aca1e2404)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__79ddd610cd47039547975eb661393c0373ac4516b3d048d9f42a7d4a9ce95e4a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__30cbb75e9709a3aed5b1c6a716e9b2616eacf43f467659071c98a4d09c83d04e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__983deb9bb568f47ccbbbeb2a9ec313a1a08690026466fac01e33e565cff21dfa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAspectCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAspectCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAspectCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__03d4f294dc6a117945c375ecadc3836a45969833102e78ed3f9fa89f5d5fa309)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualBackgroundColor",
    jsii_struct_bases=[],
    name_mapping={"color": "color", "color_var": "colorVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualBackgroundColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c046cdc92d58bc1b20d6d27ed19418e8ffc2c10803d810d1c71eb210ada271df)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualBackgroundColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualBackgroundColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualBackgroundColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d9877490496df295208a325cf4bbdc28c3fa02e3102ac54dcbe83ec616346390)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualBackgroundColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d5f379811f8e86a49e155907c1d2ffe594151ca231c4e08a459b0368b0316f3)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualBackgroundColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7f5e8436cbaa2439b4e84c58e2c51a6add69541f6f758fb267f67fbb1a7b200b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dc236c7a542d8fb89bc21d77c2878f6cdd7be04b3c1a6d624e6fa420fd796606)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8dbfa75b419e5392da5e8c306c878e3a57c713ca162fbe20409762c77dbbb0b7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualBackgroundColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualBackgroundColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__813f3e06f2ce62315a74973d3e499ed3e223669f58dab148188b57ab4f535a03)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualBackgroundColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualBackgroundColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd6b8e0c0267eb2612f85d72be741552480aafdea88b2412bc48b9536385f13a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__59c6da9575f90327b907192deb92c264993be3ff9f69c6bc9911754faef5e900)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4d4acbb5a2d74cbbfc5f0654a907ab78fbd1158b5a3d948df874a67124392527)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualBackgroundColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualBackgroundColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualBackgroundColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__57eb2b7d9ece4358f6d2a19c1610a0140964947decce21fb4b52a8fd4d592695)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualBlur",
    jsii_struct_bases=[],
    name_mapping={"sigma": "sigma", "sigma_var": "sigmaVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualBlur:
    def __init__(
        self,
        *,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param sigma: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__69e63243a32e5d6cb7bb53e6e21bf5811b00283ade97b9c206149392fc54e07c)
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualBlur(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualBlurList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualBlurList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ca29dd4ebe29179ec50be1680086f092a4b511b5d395cee6c23097dc93d247d5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualBlurOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d0a7cd907aafaedf6782bc53aea0257f1a074c14db8eaf3100439bd2aab8190f)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualBlurOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a65598408fd61813a3dd6197b053560330e6234b894d3ff58b42a9577a99c04a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__24628010987e090902b85216df628774fe2fae3ca32da1111aa156bc338f0f09)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8b499bf725c52c115da61a4bc9e8403062079b5b52b570435269ad2793cf0845)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualBlur]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualBlur]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__013139a65e775227c71ebb93a2b980b5d6ce56ec773aaf30c46b52f0956f2fe2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualBlurOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualBlurOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f7fb571ffe3e796bcc547ea833fc2ed8b301c9438f4f98c204c6741a0ca001c6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__26ac82e90f12022167deaaa9115095122cfbf681aa76576413205d6f351842c7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4168d279887b9ad94fa0daba8db7171b07c543bddee549f4e23ded5d49c93de0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualBlur]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualBlur]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualBlur]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__23e9237914134a12950928c627bda46cbfe873acf42388059b8c1261c2a85b4c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualChromaKey",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_feather": "hueFeather",
        "hue_feather_var": "hueFeatherVar",
        "hue_tolerance": "hueTolerance",
        "hue_tolerance_var": "hueToleranceVar",
        "hue_var": "hueVar",
        "lightness_feather": "lightnessFeather",
        "lightness_feather_var": "lightnessFeatherVar",
        "lightness_tolerance": "lightnessTolerance",
        "lightness_tolerance_var": "lightnessToleranceVar",
        "saturation_feather": "saturationFeather",
        "saturation_feather_var": "saturationFeatherVar",
        "saturation_tolerance": "saturationTolerance",
        "saturation_tolerance_var": "saturationToleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualChromaKey:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_feather: typing.Optional[builtins.str] = None,
        hue_feather_var: typing.Optional[builtins.str] = None,
        hue_tolerance: typing.Optional[builtins.str] = None,
        hue_tolerance_var: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness_feather: typing.Optional[builtins.str] = None,
        lightness_feather_var: typing.Optional[builtins.str] = None,
        lightness_tolerance: typing.Optional[builtins.str] = None,
        lightness_tolerance_var: typing.Optional[builtins.str] = None,
        saturation_feather: typing.Optional[builtins.str] = None,
        saturation_feather_var: typing.Optional[builtins.str] = None,
        saturation_tolerance: typing.Optional[builtins.str] = None,
        saturation_tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_feather: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        :param hue_feather_var: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        :param hue_tolerance: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        :param hue_tolerance_var: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        :param hue_var: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness_feather: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        :param lightness_feather_var: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        :param lightness_tolerance: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        :param lightness_tolerance_var: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        :param saturation_feather: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        :param saturation_feather_var: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        :param saturation_tolerance: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        :param saturation_tolerance_var: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7c48e05726cf83e84ee7f56ff48dcf58d08c1e70a94606e48201d034b18f876c)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_feather", value=hue_feather, expected_type=type_hints["hue_feather"])
            check_type(argname="argument hue_feather_var", value=hue_feather_var, expected_type=type_hints["hue_feather_var"])
            check_type(argname="argument hue_tolerance", value=hue_tolerance, expected_type=type_hints["hue_tolerance"])
            check_type(argname="argument hue_tolerance_var", value=hue_tolerance_var, expected_type=type_hints["hue_tolerance_var"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness_feather", value=lightness_feather, expected_type=type_hints["lightness_feather"])
            check_type(argname="argument lightness_feather_var", value=lightness_feather_var, expected_type=type_hints["lightness_feather_var"])
            check_type(argname="argument lightness_tolerance", value=lightness_tolerance, expected_type=type_hints["lightness_tolerance"])
            check_type(argname="argument lightness_tolerance_var", value=lightness_tolerance_var, expected_type=type_hints["lightness_tolerance_var"])
            check_type(argname="argument saturation_feather", value=saturation_feather, expected_type=type_hints["saturation_feather"])
            check_type(argname="argument saturation_feather_var", value=saturation_feather_var, expected_type=type_hints["saturation_feather_var"])
            check_type(argname="argument saturation_tolerance", value=saturation_tolerance, expected_type=type_hints["saturation_tolerance"])
            check_type(argname="argument saturation_tolerance_var", value=saturation_tolerance_var, expected_type=type_hints["saturation_tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_feather is not None:
            self._values["hue_feather"] = hue_feather
        if hue_feather_var is not None:
            self._values["hue_feather_var"] = hue_feather_var
        if hue_tolerance is not None:
            self._values["hue_tolerance"] = hue_tolerance
        if hue_tolerance_var is not None:
            self._values["hue_tolerance_var"] = hue_tolerance_var
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness_feather is not None:
            self._values["lightness_feather"] = lightness_feather
        if lightness_feather_var is not None:
            self._values["lightness_feather_var"] = lightness_feather_var
        if lightness_tolerance is not None:
            self._values["lightness_tolerance"] = lightness_tolerance
        if lightness_tolerance_var is not None:
            self._values["lightness_tolerance_var"] = lightness_tolerance_var
        if saturation_feather is not None:
            self._values["saturation_feather"] = saturation_feather
        if saturation_feather_var is not None:
            self._values["saturation_feather_var"] = saturation_feather_var
        if saturation_tolerance is not None:
            self._values["saturation_tolerance"] = saturation_tolerance
        if saturation_tolerance_var is not None:
            self._values["saturation_tolerance_var"] = saturation_tolerance_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        '''
        result = self._values.get("hue_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        '''
        result = self._values.get("hue_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        '''
        result = self._values.get("hue_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        '''
        result = self._values.get("hue_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        '''
        result = self._values.get("lightness_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        '''
        result = self._values.get("lightness_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        '''
        result = self._values.get("lightness_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        '''
        result = self._values.get("lightness_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        '''
        result = self._values.get("saturation_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        '''
        result = self._values.get("saturation_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        '''
        result = self._values.get("saturation_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        result = self._values.get("saturation_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualChromaKey(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualChromaKeyList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualChromaKeyList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6c08135af8934f27be78a1e64cac19a34c36fe91b506450b69a47fa2c359e610)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualChromaKeyOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb33a0918f48d9963a7a82fc2621937f53859ffd79df4b6266b20cf061cba0be)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualChromaKeyOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ef8e62f75abff926f1f66d5cd681c6157a327a47067d2fdb36e4f56ac948a07a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4d08f06e6e19031b4f68bcb290b1613a4ae244164bf8ae5ca99d4e75ebfaa642)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7253cf4dd5ff3bb6788f902d4edb25b18c8feaca0ce0b817d794cab254107adf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualChromaKey]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualChromaKey]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__115449508e4be01e71c6e6b140951ecc276e0595d24d742dda775239b5c1d4a6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualChromaKeyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualChromaKeyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb9e48cd0e152a433ca3fa40fe939b7b62b926419015c7835454a99da695f895)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueFeather")
    def reset_hue_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeather", []))

    @jsii.member(jsii_name="resetHueFeatherVar")
    def reset_hue_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeatherVar", []))

    @jsii.member(jsii_name="resetHueTolerance")
    def reset_hue_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueTolerance", []))

    @jsii.member(jsii_name="resetHueToleranceVar")
    def reset_hue_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueToleranceVar", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightnessFeather")
    def reset_lightness_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeather", []))

    @jsii.member(jsii_name="resetLightnessFeatherVar")
    def reset_lightness_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeatherVar", []))

    @jsii.member(jsii_name="resetLightnessTolerance")
    def reset_lightness_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessTolerance", []))

    @jsii.member(jsii_name="resetLightnessToleranceVar")
    def reset_lightness_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessToleranceVar", []))

    @jsii.member(jsii_name="resetSaturationFeather")
    def reset_saturation_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeather", []))

    @jsii.member(jsii_name="resetSaturationFeatherVar")
    def reset_saturation_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeatherVar", []))

    @jsii.member(jsii_name="resetSaturationTolerance")
    def reset_saturation_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationTolerance", []))

    @jsii.member(jsii_name="resetSaturationToleranceVar")
    def reset_saturation_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherInput")
    def hue_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVarInput")
    def hue_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceInput")
    def hue_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVarInput")
    def hue_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherInput")
    def lightness_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVarInput")
    def lightness_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceInput")
    def lightness_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVarInput")
    def lightness_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherInput")
    def saturation_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVarInput")
    def saturation_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceInput")
    def saturation_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVarInput")
    def saturation_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b66ef16feaaad087d35aad4e1c1c4de182b965ca36b9ed78762785f805c02bc9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeather")
    def hue_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeather"))

    @hue_feather.setter
    def hue_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a42d5237070c12179db7f97d2a2e21dbc37bfdceca0a5f78e620110a35408b0b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeather", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVar")
    def hue_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeatherVar"))

    @hue_feather_var.setter
    def hue_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__10f3e4d43a53a61da0875f32f7315f5ce7a74cd4d7c867c03cd51d4133c36baf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueTolerance")
    def hue_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueTolerance"))

    @hue_tolerance.setter
    def hue_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c8df5b5ea723398bcf67c65960492e294e1c4f6f08fec9e1442a27066a508026)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVar")
    def hue_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueToleranceVar"))

    @hue_tolerance_var.setter
    def hue_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__369f0615c4537a95b6bc8cb983ec153ffb6838c4d00673fe991116505ae766ff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e93fb64cc5ba50561447a280c4500cf2ee42a7d1a71bc1ca07c192011b10cced)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeather")
    def lightness_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeather"))

    @lightness_feather.setter
    def lightness_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d00c5530c1c4df675f665171f6c16e49c81003b272e20d59317b6427516ecf54)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeather", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVar")
    def lightness_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeatherVar"))

    @lightness_feather_var.setter
    def lightness_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__885c6d45915c68eb61dde3cc5c44361e91088d7da7d9822e8d8e17ac43c2f9b1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessTolerance")
    def lightness_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessTolerance"))

    @lightness_tolerance.setter
    def lightness_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3efb5ba00bfd94a7baaaf8b18ead293def3fe459af080655ebf71bb44cc9c577)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVar")
    def lightness_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessToleranceVar"))

    @lightness_tolerance_var.setter
    def lightness_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa74df2e3bdb17bc84eee67c5e6a1e68d927f22556c2c4ff72c5c3ae1171a9de)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeather")
    def saturation_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeather"))

    @saturation_feather.setter
    def saturation_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f82c6c73b30631cb19711df6e3f17a73454269e1f7b347b822422e8d08b8359)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeather", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVar")
    def saturation_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeatherVar"))

    @saturation_feather_var.setter
    def saturation_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bfe9dd5770b985d2ab068f9c6b4cb74ecc58fda2c6bd133bb7cfc6cd56e905b8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationTolerance")
    def saturation_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationTolerance"))

    @saturation_tolerance.setter
    def saturation_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9c2a56a195002ae919c8dca18d9769defee48cf4c8dc75762f1248530a8d6695)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVar")
    def saturation_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationToleranceVar"))

    @saturation_tolerance_var.setter
    def saturation_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aba4620158c304627f22ebc7fc4f00eabfdd8670dc67c5fd5a1fdf88f43ee2e9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualChromaKey]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualChromaKey]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualChromaKey]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1906ab2d1de8a5518b8249343b92013ce795496accb3568db4f4c512a88e4727)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualComposite",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "placement": "placement",
        "placement_var": "placementVar",
        "scale": "scale",
        "scale_dimension": "scaleDimension",
        "scale_dimension_var": "scaleDimensionVar",
        "scale_var": "scaleVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualComposite:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        placement: typing.Optional[builtins.str] = None,
        placement_var: typing.Optional[builtins.str] = None,
        scale: typing.Optional[builtins.str] = None,
        scale_dimension: typing.Optional[builtins.str] = None,
        scale_dimension_var: typing.Optional[builtins.str] = None,
        scale_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param placement: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        :param placement_var: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        :param scale: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param scale_dimension: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        :param scale_dimension_var: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        :param scale_var: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        :param x_position: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dd382cb39b60d3751caa7ad6695b80b40b6b3d0ff4a68b94e7a0d6f9e38e003f)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument placement", value=placement, expected_type=type_hints["placement"])
            check_type(argname="argument placement_var", value=placement_var, expected_type=type_hints["placement_var"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument scale_dimension", value=scale_dimension, expected_type=type_hints["scale_dimension"])
            check_type(argname="argument scale_dimension_var", value=scale_dimension_var, expected_type=type_hints["scale_dimension_var"])
            check_type(argname="argument scale_var", value=scale_var, expected_type=type_hints["scale_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if placement is not None:
            self._values["placement"] = placement
        if placement_var is not None:
            self._values["placement_var"] = placement_var
        if scale is not None:
            self._values["scale"] = scale
        if scale_dimension is not None:
            self._values["scale_dimension"] = scale_dimension
        if scale_dimension_var is not None:
            self._values["scale_dimension_var"] = scale_dimension_var
        if scale_var is not None:
            self._values["scale_var"] = scale_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        '''
        result = self._values.get("placement")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement_var(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        '''
        result = self._values.get("placement_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        '''
        result = self._values.get("scale_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        '''
        result = self._values.get("scale_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        '''
        result = self._values.get("scale_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualComposite(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImage",
    jsii_struct_bases=[],
    name_mapping={
        "box_image": "boxImage",
        "circle_image": "circleImage",
        "text_image": "textImage",
        "url_image": "urlImage",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImage:
    def __init__(
        self,
        *,
        box_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageBoxImage", typing.Dict[builtins.str, typing.Any]]]]] = None,
        circle_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageCircleImage", typing.Dict[builtins.str, typing.Any]]]]] = None,
        text_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageTextImage", typing.Dict[builtins.str, typing.Any]]]]] = None,
        url_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageUrlImage", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param box_image: box_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#box_image DataAkamaiImagingPolicyImage#box_image}
        :param circle_image: circle_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#circle_image DataAkamaiImagingPolicyImage#circle_image}
        :param text_image: text_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text_image DataAkamaiImagingPolicyImage#text_image}
        :param url_image: url_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url_image DataAkamaiImagingPolicyImage#url_image}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ed8b7ca9577a6723a9d53c380516ed42a5a6d72bea16737682dda835244c64d5)
            check_type(argname="argument box_image", value=box_image, expected_type=type_hints["box_image"])
            check_type(argname="argument circle_image", value=circle_image, expected_type=type_hints["circle_image"])
            check_type(argname="argument text_image", value=text_image, expected_type=type_hints["text_image"])
            check_type(argname="argument url_image", value=url_image, expected_type=type_hints["url_image"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if box_image is not None:
            self._values["box_image"] = box_image
        if circle_image is not None:
            self._values["circle_image"] = circle_image
        if text_image is not None:
            self._values["text_image"] = text_image
        if url_image is not None:
            self._values["url_image"] = url_image

    @builtins.property
    def box_image(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageBoxImage"]]]:
        '''box_image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#box_image DataAkamaiImagingPolicyImage#box_image}
        '''
        result = self._values.get("box_image")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageBoxImage"]]], result)

    @builtins.property
    def circle_image(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageCircleImage"]]]:
        '''circle_image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#circle_image DataAkamaiImagingPolicyImage#circle_image}
        '''
        result = self._values.get("circle_image")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageCircleImage"]]], result)

    @builtins.property
    def text_image(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageTextImage"]]]:
        '''text_image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text_image DataAkamaiImagingPolicyImage#text_image}
        '''
        result = self._values.get("text_image")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageTextImage"]]], result)

    @builtins.property
    def url_image(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageUrlImage"]]]:
        '''url_image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url_image DataAkamaiImagingPolicyImage#url_image}
        '''
        result = self._values.get("url_image")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageUrlImage"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageBoxImage",
    jsii_struct_bases=[],
    name_mapping={
        "color": "color",
        "color_var": "colorVar",
        "height": "height",
        "height_var": "heightVar",
        "transformation": "transformation",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageBoxImage:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        transformation: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageBoxImageTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The fill color of the box, not the edge of the box. The API supports hexadecimal representation and CSS hexadecimal color values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The fill color of the box, not the edge of the box. The API supports hexadecimal representation and CSS hexadecimal color values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        :param height: The height of the box in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height of the box in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param transformation: transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        :param width: The width of the box in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width of the box in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(transformation, dict):
            transformation = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageBoxImageTransformation(**transformation)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__03b2344823762be67f5a545b51dc091b525f0b8331314086c34077366d654fcd)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument transformation", value=transformation, expected_type=type_hints["transformation"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if transformation is not None:
            self._values["transformation"] = transformation
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The fill color of the box, not the edge of the box.

        The API supports hexadecimal representation and CSS hexadecimal color values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The fill color of the box, not the edge of the box.

        The API supports hexadecimal representation and CSS hexadecimal color values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height of the box in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height of the box in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def transformation(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageBoxImageTransformation"]:
        '''transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        '''
        result = self._values.get("transformation")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageBoxImageTransformation"], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width of the box in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width of the box in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageBoxImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageBoxImageList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageBoxImageList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__64996a164e98d81123f022530d01f9ce2111e4d4b4e9572a9eff53f7e3a5729d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageBoxImageOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b1d9a406fe1d77f43640121f7afb6776c46ec6767d964b338770eecf8c8b192f)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageBoxImageOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7b135bb7b52decdbecfbafc3de94df72170bbb0bd16eb71e3aacd5a4c0dccc5c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2aa4500a5c61bf27f812ba26b9cbcdb621382fb758fe06784a4ebeac37724694)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c2b4aaa06501d12e70def71c3cf08783f4e3c28d0b44de7a4ede8b46543cc1d7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageBoxImage]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageBoxImage]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageBoxImage]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d1c7a9f014bba5a3318998e657059aee87d197a2de92784006950bfc3816bb73)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageBoxImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageBoxImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fec052c620798f1d267e3ca0aa32d2bbd44c9a25336da12303ff8fc8f8a1c972)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformation")
    def put_transformation(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageBoxImageTransformation()

        return typing.cast(None, jsii.invoke(self, "putTransformation", [value]))

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetTransformation")
    def reset_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformation", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="transformation")
    def transformation(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageBoxImageTransformationOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageBoxImageTransformationOutputReference", jsii.get(self, "transformation"))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="transformationInput")
    def transformation_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageBoxImageTransformation"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageBoxImageTransformation"], jsii.get(self, "transformationInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0723ac71f263be1578ca7861dd7a2826ab39293b4280b4708c284781c59ff31d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1b52b72c4d0cccd8a15838512864dca25fc81e9de2c1c918a48cf18353145793)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f11bb32b2b23ecd68e8e4923733c2650a0f20f03a76e84316e0143cef51c8024)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2550e212b3081869003f743055e9ffc650a0eee21e894c1dcf0a8ba34716a334)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__573014568544495a1ec4ee79b1d84c9c45c5483d3077701a02d8fdaeb3900827)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f44398dd5ebf8f60555b13e4fea5b610866bc0a71e5ada1d76ba915f0a0f9194)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageBoxImage]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageBoxImage]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageBoxImage]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__429b98c0afb3c03730abb6c10e9f75296e11f197dd418372d4a477f4e147520b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageBoxImageTransformation",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageBoxImageTransformation:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageBoxImageTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageBoxImageTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageBoxImageTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9c17e5fa03da9c8d3e888e1a98199291b4e8a1508d6ccb762afeb447865977a6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageBoxImageTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageBoxImageTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageBoxImageTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c0c4f0a57da9253688463e2c77734e6a443cc7c55566b35f334286441e772bbc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageCircleImage",
    jsii_struct_bases=[],
    name_mapping={
        "color": "color",
        "color_var": "colorVar",
        "diameter": "diameter",
        "diameter_var": "diameterVar",
        "transformation": "transformation",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageCircleImage:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
        diameter: typing.Optional[builtins.str] = None,
        diameter_var: typing.Optional[builtins.str] = None,
        transformation: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageCircleImageTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The fill color of the circle. The API supports hexadecimal representation and CSS hexadecimal color values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The fill color of the circle. The API supports hexadecimal representation and CSS hexadecimal color values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        :param diameter: The diameter of the circle. The diameter will be the width and the height of the image in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#diameter DataAkamaiImagingPolicyImage#diameter}
        :param diameter_var: The diameter of the circle. The diameter will be the width and the height of the image in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#diameter_var DataAkamaiImagingPolicyImage#diameter_var}
        :param transformation: transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        :param width: The width of the box in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width of the box in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(transformation, dict):
            transformation = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageCircleImageTransformation(**transformation)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be66f7075152a4fc1b91329a11a354a9adb85a7bfdb018f364816c6024208aa4)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
            check_type(argname="argument diameter", value=diameter, expected_type=type_hints["diameter"])
            check_type(argname="argument diameter_var", value=diameter_var, expected_type=type_hints["diameter_var"])
            check_type(argname="argument transformation", value=transformation, expected_type=type_hints["transformation"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var
        if diameter is not None:
            self._values["diameter"] = diameter
        if diameter_var is not None:
            self._values["diameter_var"] = diameter_var
        if transformation is not None:
            self._values["transformation"] = transformation
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The fill color of the circle. The API supports hexadecimal representation and CSS hexadecimal color values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The fill color of the circle. The API supports hexadecimal representation and CSS hexadecimal color values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def diameter(self) -> typing.Optional[builtins.str]:
        '''The diameter of the circle. The diameter will be the width and the height of the image in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#diameter DataAkamaiImagingPolicyImage#diameter}
        '''
        result = self._values.get("diameter")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def diameter_var(self) -> typing.Optional[builtins.str]:
        '''The diameter of the circle. The diameter will be the width and the height of the image in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#diameter_var DataAkamaiImagingPolicyImage#diameter_var}
        '''
        result = self._values.get("diameter_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def transformation(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageCircleImageTransformation"]:
        '''transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        '''
        result = self._values.get("transformation")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageCircleImageTransformation"], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width of the box in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width of the box in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageCircleImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageCircleImageList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageCircleImageList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d678eccf3694577f54f7837e3960c05d58a4d06a28ca1c19132b71d9e0ab47eb)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageCircleImageOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__364768f45b586bc432d7c393028d0362eed73f03f2b879228213a2b5b0325034)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageCircleImageOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0b040145a5bf9f113411d3581d5e708bbfb50765c54135bff4a8ceaded3c3db5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d721d18396462795d3a9c66dd1cd41b1507147d17df648ca34180a999b7ef25b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1d1c01c2441fdd8a3b936e8da3435d1ed3f226aad60fd32c478faa02bcd12e6c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageCircleImage]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageCircleImage]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageCircleImage]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cac4ad9debd78eb474c5319716de5d669f704a030780bba93a588b49fdd20d4e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageCircleImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageCircleImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a292d250f6c90b11eb1f1285c9b32ff6549e63c06f4f0328114b10ec5c23bb7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformation")
    def put_transformation(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageCircleImageTransformation()

        return typing.cast(None, jsii.invoke(self, "putTransformation", [value]))

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @jsii.member(jsii_name="resetDiameter")
    def reset_diameter(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDiameter", []))

    @jsii.member(jsii_name="resetDiameterVar")
    def reset_diameter_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDiameterVar", []))

    @jsii.member(jsii_name="resetTransformation")
    def reset_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformation", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="transformation")
    def transformation(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageCircleImageTransformationOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageCircleImageTransformationOutputReference", jsii.get(self, "transformation"))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="diameterInput")
    def diameter_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "diameterInput"))

    @builtins.property
    @jsii.member(jsii_name="diameterVarInput")
    def diameter_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "diameterVarInput"))

    @builtins.property
    @jsii.member(jsii_name="transformationInput")
    def transformation_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageCircleImageTransformation"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageCircleImageTransformation"], jsii.get(self, "transformationInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__831c4b08d6e7d6006afdee75ecb1e7f3a54d7cf45c931af39cff4e3ac297467f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1bcfb2c61daf93bc5826e917eacac8e06b867a5a235484ed4a3aa4709ee4fbbe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="diameter")
    def diameter(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "diameter"))

    @diameter.setter
    def diameter(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7579e6a167eb7c30f6d7579c30111e822b3f89bf4597c79bb48f46f254fe30b2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "diameter", value)

    @builtins.property
    @jsii.member(jsii_name="diameterVar")
    def diameter_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "diameterVar"))

    @diameter_var.setter
    def diameter_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__049d37f6bc10cb8caf9cdfbf30f945264708bc8875bf8a4499ca19d9e14aedfb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "diameterVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1694359143159cbd5b4530c952add256452394c9780724f2d4929e8182571c7e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea02669b54b8d64198796c03521bfa4424b3d41d1b1de9b9a829b2e82db341b2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageCircleImage]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageCircleImage]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageCircleImage]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d3bf67d2285d6f7ba9c0fda6335b8fb7c76d8b9cfeae8db8f0984c5370ace1a8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageCircleImageTransformation",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageCircleImageTransformation:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageCircleImageTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageCircleImageTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageCircleImageTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__83ace6a35980e66a0acc4bdb718e91942c585d5d829f6cd4f5332058f773a4d0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageCircleImageTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageCircleImageTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageCircleImageTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d91874ea4c6532ee055248627c8a86f661bd598ea7bd55b9bcdd8f094e952531)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__858f60e4743748ae789fa789f704ccb5afeded05bafeaf753270168340e0a78a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putBoxImage")
    def put_box_image(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageBoxImage, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a2552101bc46d2f6fe27f5bdce5fa7335876349bfa0e7cd38e9e16b4979b27ef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBoxImage", [value]))

    @jsii.member(jsii_name="putCircleImage")
    def put_circle_image(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageCircleImage, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bbccc1a12dd95e3d9a1548acbd43e9635d8147b5aedb1900644eef1aeea8ad7c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCircleImage", [value]))

    @jsii.member(jsii_name="putTextImage")
    def put_text_image(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageTextImage", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f51579f4438b00ed5ce1327f28fe427c21aa56a6511dad7f53ff6e6275cd2bc8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTextImage", [value]))

    @jsii.member(jsii_name="putUrlImage")
    def put_url_image(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageUrlImage", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8df45f91fa3d1bcbef2979a2de0e65ebb183c0d80c17b8114478841f687217b3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putUrlImage", [value]))

    @jsii.member(jsii_name="resetBoxImage")
    def reset_box_image(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBoxImage", []))

    @jsii.member(jsii_name="resetCircleImage")
    def reset_circle_image(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCircleImage", []))

    @jsii.member(jsii_name="resetTextImage")
    def reset_text_image(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTextImage", []))

    @jsii.member(jsii_name="resetUrlImage")
    def reset_url_image(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUrlImage", []))

    @builtins.property
    @jsii.member(jsii_name="boxImage")
    def box_image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageBoxImageList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageBoxImageList, jsii.get(self, "boxImage"))

    @builtins.property
    @jsii.member(jsii_name="circleImage")
    def circle_image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageCircleImageList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageCircleImageList, jsii.get(self, "circleImage"))

    @builtins.property
    @jsii.member(jsii_name="textImage")
    def text_image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageTextImageList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageTextImageList", jsii.get(self, "textImage"))

    @builtins.property
    @jsii.member(jsii_name="urlImage")
    def url_image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageUrlImageList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageUrlImageList", jsii.get(self, "urlImage"))

    @builtins.property
    @jsii.member(jsii_name="boxImageInput")
    def box_image_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageBoxImage]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageBoxImage]]], jsii.get(self, "boxImageInput"))

    @builtins.property
    @jsii.member(jsii_name="circleImageInput")
    def circle_image_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageCircleImage]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageCircleImage]]], jsii.get(self, "circleImageInput"))

    @builtins.property
    @jsii.member(jsii_name="textImageInput")
    def text_image_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageTextImage"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageTextImage"]]], jsii.get(self, "textImageInput"))

    @builtins.property
    @jsii.member(jsii_name="urlImageInput")
    def url_image_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageUrlImage"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageUrlImage"]]], jsii.get(self, "urlImageInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5e1dbd407b22d8b1208770231ab5026827b82489091b8cce8d4fa2f8f56d41ba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageTextImage",
    jsii_struct_bases=[],
    name_mapping={
        "fill": "fill",
        "fill_var": "fillVar",
        "size": "size",
        "size_var": "sizeVar",
        "stroke": "stroke",
        "stroke_size": "strokeSize",
        "stroke_size_var": "strokeSizeVar",
        "stroke_var": "strokeVar",
        "text": "text",
        "text_var": "textVar",
        "transformation": "transformation",
        "typeface": "typeface",
        "typeface_var": "typefaceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageTextImage:
    def __init__(
        self,
        *,
        fill: typing.Optional[builtins.str] = None,
        fill_var: typing.Optional[builtins.str] = None,
        size: typing.Optional[builtins.str] = None,
        size_var: typing.Optional[builtins.str] = None,
        stroke: typing.Optional[builtins.str] = None,
        stroke_size: typing.Optional[builtins.str] = None,
        stroke_size_var: typing.Optional[builtins.str] = None,
        stroke_var: typing.Optional[builtins.str] = None,
        text: typing.Optional[builtins.str] = None,
        text_var: typing.Optional[builtins.str] = None,
        transformation: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageTextImageTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        typeface: typing.Optional[builtins.str] = None,
        typeface_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fill: The main fill color of the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill DataAkamaiImagingPolicyImage#fill}
        :param fill_var: The main fill color of the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_var DataAkamaiImagingPolicyImage#fill_var}
        :param size: The size in pixels to render the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#size DataAkamaiImagingPolicyImage#size}
        :param size_var: The size in pixels to render the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#size_var DataAkamaiImagingPolicyImage#size_var}
        :param stroke: The color for the outline of the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke DataAkamaiImagingPolicyImage#stroke}
        :param stroke_size: The thickness in points for the outline of the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_size DataAkamaiImagingPolicyImage#stroke_size}
        :param stroke_size_var: The thickness in points for the outline of the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_size_var DataAkamaiImagingPolicyImage#stroke_size_var}
        :param stroke_var: The color for the outline of the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_var DataAkamaiImagingPolicyImage#stroke_var}
        :param text: The line of text to render. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text DataAkamaiImagingPolicyImage#text}
        :param text_var: The line of text to render. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text_var DataAkamaiImagingPolicyImage#text_var}
        :param transformation: transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        :param typeface: The font family to apply to the text image. This may be a URL to a TrueType or WOFF (v1) typeface, or a string that refers to one of the standard built-in browser fonts. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#typeface DataAkamaiImagingPolicyImage#typeface}
        :param typeface_var: The font family to apply to the text image. This may be a URL to a TrueType or WOFF (v1) typeface, or a string that refers to one of the standard built-in browser fonts. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#typeface_var DataAkamaiImagingPolicyImage#typeface_var}
        '''
        if isinstance(transformation, dict):
            transformation = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageTextImageTransformation(**transformation)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dab7a1e4ecee5a26ca20a7193ab0f60a7f8d87a8f58ac3b7526ee624c0745f03)
            check_type(argname="argument fill", value=fill, expected_type=type_hints["fill"])
            check_type(argname="argument fill_var", value=fill_var, expected_type=type_hints["fill_var"])
            check_type(argname="argument size", value=size, expected_type=type_hints["size"])
            check_type(argname="argument size_var", value=size_var, expected_type=type_hints["size_var"])
            check_type(argname="argument stroke", value=stroke, expected_type=type_hints["stroke"])
            check_type(argname="argument stroke_size", value=stroke_size, expected_type=type_hints["stroke_size"])
            check_type(argname="argument stroke_size_var", value=stroke_size_var, expected_type=type_hints["stroke_size_var"])
            check_type(argname="argument stroke_var", value=stroke_var, expected_type=type_hints["stroke_var"])
            check_type(argname="argument text", value=text, expected_type=type_hints["text"])
            check_type(argname="argument text_var", value=text_var, expected_type=type_hints["text_var"])
            check_type(argname="argument transformation", value=transformation, expected_type=type_hints["transformation"])
            check_type(argname="argument typeface", value=typeface, expected_type=type_hints["typeface"])
            check_type(argname="argument typeface_var", value=typeface_var, expected_type=type_hints["typeface_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fill is not None:
            self._values["fill"] = fill
        if fill_var is not None:
            self._values["fill_var"] = fill_var
        if size is not None:
            self._values["size"] = size
        if size_var is not None:
            self._values["size_var"] = size_var
        if stroke is not None:
            self._values["stroke"] = stroke
        if stroke_size is not None:
            self._values["stroke_size"] = stroke_size
        if stroke_size_var is not None:
            self._values["stroke_size_var"] = stroke_size_var
        if stroke_var is not None:
            self._values["stroke_var"] = stroke_var
        if text is not None:
            self._values["text"] = text
        if text_var is not None:
            self._values["text_var"] = text_var
        if transformation is not None:
            self._values["transformation"] = transformation
        if typeface is not None:
            self._values["typeface"] = typeface
        if typeface_var is not None:
            self._values["typeface_var"] = typeface_var

    @builtins.property
    def fill(self) -> typing.Optional[builtins.str]:
        '''The main fill color of the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill DataAkamaiImagingPolicyImage#fill}
        '''
        result = self._values.get("fill")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fill_var(self) -> typing.Optional[builtins.str]:
        '''The main fill color of the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_var DataAkamaiImagingPolicyImage#fill_var}
        '''
        result = self._values.get("fill_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def size(self) -> typing.Optional[builtins.str]:
        '''The size in pixels to render the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#size DataAkamaiImagingPolicyImage#size}
        '''
        result = self._values.get("size")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def size_var(self) -> typing.Optional[builtins.str]:
        '''The size in pixels to render the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#size_var DataAkamaiImagingPolicyImage#size_var}
        '''
        result = self._values.get("size_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def stroke(self) -> typing.Optional[builtins.str]:
        '''The color for the outline of the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke DataAkamaiImagingPolicyImage#stroke}
        '''
        result = self._values.get("stroke")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def stroke_size(self) -> typing.Optional[builtins.str]:
        '''The thickness in points for the outline of the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_size DataAkamaiImagingPolicyImage#stroke_size}
        '''
        result = self._values.get("stroke_size")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def stroke_size_var(self) -> typing.Optional[builtins.str]:
        '''The thickness in points for the outline of the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_size_var DataAkamaiImagingPolicyImage#stroke_size_var}
        '''
        result = self._values.get("stroke_size_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def stroke_var(self) -> typing.Optional[builtins.str]:
        '''The color for the outline of the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_var DataAkamaiImagingPolicyImage#stroke_var}
        '''
        result = self._values.get("stroke_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def text(self) -> typing.Optional[builtins.str]:
        '''The line of text to render.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text DataAkamaiImagingPolicyImage#text}
        '''
        result = self._values.get("text")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def text_var(self) -> typing.Optional[builtins.str]:
        '''The line of text to render.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text_var DataAkamaiImagingPolicyImage#text_var}
        '''
        result = self._values.get("text_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def transformation(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageTextImageTransformation"]:
        '''transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        '''
        result = self._values.get("transformation")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageTextImageTransformation"], result)

    @builtins.property
    def typeface(self) -> typing.Optional[builtins.str]:
        '''The font family to apply to the text image.

        This may be a URL to a TrueType or WOFF (v1) typeface, or a string that refers to one of the standard built-in browser fonts.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#typeface DataAkamaiImagingPolicyImage#typeface}
        '''
        result = self._values.get("typeface")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def typeface_var(self) -> typing.Optional[builtins.str]:
        '''The font family to apply to the text image.

        This may be a URL to a TrueType or WOFF (v1) typeface, or a string that refers to one of the standard built-in browser fonts.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#typeface_var DataAkamaiImagingPolicyImage#typeface_var}
        '''
        result = self._values.get("typeface_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageTextImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageTextImageList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageTextImageList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8f8df7cab5031d23c842cee458ec6e21b41962d72b13bfa5a02a639733008eeb)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageTextImageOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6442c4969949202d576c9a3af69c39e8d1ae4c42b32be1077eaf2d9b3fc831d0)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageTextImageOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1237617acbd74d1e8d08743c5d73ac25e9d4deef55307b6424d8cd1c709a683f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e8b30f24c7c72110e41da5a1acf905ce97dcb2f514e2dc90656c64469a321396)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4efc7aef2fc75151fbc7a32114e70bbeebc4246d31950403ca6feac19e65bd8e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageTextImage]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageTextImage]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageTextImage]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__36aebfe5e97bad9d132b4388e4ed6fc0e94b367bac082ae5bed48f5535e9f03e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageTextImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageTextImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e1582845c2d02925fe20b8c27f09f52a35e776f25b090f2975882fb16861f9b8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformation")
    def put_transformation(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageTextImageTransformation()

        return typing.cast(None, jsii.invoke(self, "putTransformation", [value]))

    @jsii.member(jsii_name="resetFill")
    def reset_fill(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFill", []))

    @jsii.member(jsii_name="resetFillVar")
    def reset_fill_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFillVar", []))

    @jsii.member(jsii_name="resetSize")
    def reset_size(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSize", []))

    @jsii.member(jsii_name="resetSizeVar")
    def reset_size_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSizeVar", []))

    @jsii.member(jsii_name="resetStroke")
    def reset_stroke(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStroke", []))

    @jsii.member(jsii_name="resetStrokeSize")
    def reset_stroke_size(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStrokeSize", []))

    @jsii.member(jsii_name="resetStrokeSizeVar")
    def reset_stroke_size_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStrokeSizeVar", []))

    @jsii.member(jsii_name="resetStrokeVar")
    def reset_stroke_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStrokeVar", []))

    @jsii.member(jsii_name="resetText")
    def reset_text(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetText", []))

    @jsii.member(jsii_name="resetTextVar")
    def reset_text_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTextVar", []))

    @jsii.member(jsii_name="resetTransformation")
    def reset_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformation", []))

    @jsii.member(jsii_name="resetTypeface")
    def reset_typeface(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeface", []))

    @jsii.member(jsii_name="resetTypefaceVar")
    def reset_typeface_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypefaceVar", []))

    @builtins.property
    @jsii.member(jsii_name="transformation")
    def transformation(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageTextImageTransformationOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageTextImageTransformationOutputReference", jsii.get(self, "transformation"))

    @builtins.property
    @jsii.member(jsii_name="fillInput")
    def fill_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fillInput"))

    @builtins.property
    @jsii.member(jsii_name="fillVarInput")
    def fill_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fillVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sizeInput")
    def size_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sizeInput"))

    @builtins.property
    @jsii.member(jsii_name="sizeVarInput")
    def size_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sizeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="strokeInput")
    def stroke_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "strokeInput"))

    @builtins.property
    @jsii.member(jsii_name="strokeSizeInput")
    def stroke_size_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "strokeSizeInput"))

    @builtins.property
    @jsii.member(jsii_name="strokeSizeVarInput")
    def stroke_size_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "strokeSizeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="strokeVarInput")
    def stroke_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "strokeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="textInput")
    def text_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "textInput"))

    @builtins.property
    @jsii.member(jsii_name="textVarInput")
    def text_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "textVarInput"))

    @builtins.property
    @jsii.member(jsii_name="transformationInput")
    def transformation_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageTextImageTransformation"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageTextImageTransformation"], jsii.get(self, "transformationInput"))

    @builtins.property
    @jsii.member(jsii_name="typefaceInput")
    def typeface_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typefaceInput"))

    @builtins.property
    @jsii.member(jsii_name="typefaceVarInput")
    def typeface_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typefaceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="fill")
    def fill(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fill"))

    @fill.setter
    def fill(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fcef1acd36f4987b1cd0bf909dd1f9dde56d4ecab7bca39bc10042c4c909482e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fill", value)

    @builtins.property
    @jsii.member(jsii_name="fillVar")
    def fill_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fillVar"))

    @fill_var.setter
    def fill_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__53504cdc0f2a7b6b2d24ffadb94390e926989322826d42133bbbc5f39a5ff945)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fillVar", value)

    @builtins.property
    @jsii.member(jsii_name="size")
    def size(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "size"))

    @size.setter
    def size(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2b9f3d2ea73c22551d10699c63e5ea31f51d14163af0f6d742bed52a9cb369be)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "size", value)

    @builtins.property
    @jsii.member(jsii_name="sizeVar")
    def size_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sizeVar"))

    @size_var.setter
    def size_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__13a7b2fefc154e891880a616a4c3c096b80da63109c89778954da7dbd99c9bf1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sizeVar", value)

    @builtins.property
    @jsii.member(jsii_name="stroke")
    def stroke(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "stroke"))

    @stroke.setter
    def stroke(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__75e7316a7e3cbd891e10f014992d9d7717b9ee9aabac6316d96c21b9b8803b9d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "stroke", value)

    @builtins.property
    @jsii.member(jsii_name="strokeSize")
    def stroke_size(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "strokeSize"))

    @stroke_size.setter
    def stroke_size(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__98a547dfe778df24336ce154d706e5b143804507af8ec519b66aac47e78a747a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "strokeSize", value)

    @builtins.property
    @jsii.member(jsii_name="strokeSizeVar")
    def stroke_size_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "strokeSizeVar"))

    @stroke_size_var.setter
    def stroke_size_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__56f53f4902c00df5f56aa0fa57f47311a0b4c88b272590fd2c2ece067d613436)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "strokeSizeVar", value)

    @builtins.property
    @jsii.member(jsii_name="strokeVar")
    def stroke_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "strokeVar"))

    @stroke_var.setter
    def stroke_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__71e47acf816bdbbb457afd348b8695b1bb0d579443b7d487c277da8ca3c33697)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "strokeVar", value)

    @builtins.property
    @jsii.member(jsii_name="text")
    def text(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "text"))

    @text.setter
    def text(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a18c4ed2676cc9bdd7a7ffcebf139978dca145febf633437301004133d15f53a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "text", value)

    @builtins.property
    @jsii.member(jsii_name="textVar")
    def text_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "textVar"))

    @text_var.setter
    def text_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a1c2897a1af70eb3c737e24d73429e6944d0d0bec3c943ba3b610e3e85fd5ca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "textVar", value)

    @builtins.property
    @jsii.member(jsii_name="typeface")
    def typeface(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeface"))

    @typeface.setter
    def typeface(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__112c04a9a015c888b60d30d5dbdcb04a1a349251ba7c24f3c34d459024aca965)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeface", value)

    @builtins.property
    @jsii.member(jsii_name="typefaceVar")
    def typeface_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typefaceVar"))

    @typeface_var.setter
    def typeface_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__51cad2bb7e7d7c75e100de71cb64dfe4f3ad28463fc299073b921090d723d54b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typefaceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageTextImage]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageTextImage]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageTextImage]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__476561e2e99965eae637d96f2e70a12853584c5234e31fba6b4321d9a210cfdf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageTextImageTransformation",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageTextImageTransformation:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageTextImageTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageTextImageTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageTextImageTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1b2f2ddad32f28e9602628b7a28d71034ff4a53bcaaa3e4c4dc146dcfaa0c699)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageTextImageTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageTextImageTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageTextImageTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3750b8d5b7e79b735f64f461f827ba098f16f9d538eba25f2d0dbb76ccd5a569)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageUrlImage",
    jsii_struct_bases=[],
    name_mapping={
        "transformation": "transformation",
        "url": "url",
        "url_var": "urlVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageUrlImage:
    def __init__(
        self,
        *,
        transformation: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageUrlImageTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        url: typing.Optional[builtins.str] = None,
        url_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param transformation: transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        :param url: The URL of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url DataAkamaiImagingPolicyImage#url}
        :param url_var: The URL of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url_var DataAkamaiImagingPolicyImage#url_var}
        '''
        if isinstance(transformation, dict):
            transformation = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageUrlImageTransformation(**transformation)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b3f8d3c086bce697d94763765415d9537429c64e9477e5289c6bf956ee27896f)
            check_type(argname="argument transformation", value=transformation, expected_type=type_hints["transformation"])
            check_type(argname="argument url", value=url, expected_type=type_hints["url"])
            check_type(argname="argument url_var", value=url_var, expected_type=type_hints["url_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if transformation is not None:
            self._values["transformation"] = transformation
        if url is not None:
            self._values["url"] = url
        if url_var is not None:
            self._values["url_var"] = url_var

    @builtins.property
    def transformation(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageUrlImageTransformation"]:
        '''transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        '''
        result = self._values.get("transformation")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageUrlImageTransformation"], result)

    @builtins.property
    def url(self) -> typing.Optional[builtins.str]:
        '''The URL of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url DataAkamaiImagingPolicyImage#url}
        '''
        result = self._values.get("url")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def url_var(self) -> typing.Optional[builtins.str]:
        '''The URL of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url_var DataAkamaiImagingPolicyImage#url_var}
        '''
        result = self._values.get("url_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageUrlImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageUrlImageList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageUrlImageList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f86b0bc00a1a219d15a129f84f131b26c8fafc6c2a03a6e807587010eb3eb42)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageUrlImageOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__de3d274e1a2000e2a5bbc2fb22fc250733d590225cd139a0bf6004b746131eb9)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageUrlImageOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ba24e080162678783bccd15dc51f26946e10aa223c6e743b87b07a67019d096b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f7c6fc930a27ac40db41b522915cf9f717b524ae107f5834cc6a93cf7a2819b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f672fde717ec8e974d5682eac1b2c926fe9f53bbe1434952a8e786a92d43b457)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageUrlImage]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageUrlImage]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageUrlImage]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0d8a127706b9a084f505b52e01ae3001397d3866c5f3c56dfa1a411fbe43cb19)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageUrlImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageUrlImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__35f9ac49147120833ef6b4e246a84b95f9254f05db8b3f1e83f2f6986ea49d6d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformation")
    def put_transformation(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageUrlImageTransformation()

        return typing.cast(None, jsii.invoke(self, "putTransformation", [value]))

    @jsii.member(jsii_name="resetTransformation")
    def reset_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformation", []))

    @jsii.member(jsii_name="resetUrl")
    def reset_url(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUrl", []))

    @jsii.member(jsii_name="resetUrlVar")
    def reset_url_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUrlVar", []))

    @builtins.property
    @jsii.member(jsii_name="transformation")
    def transformation(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageUrlImageTransformationOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageUrlImageTransformationOutputReference", jsii.get(self, "transformation"))

    @builtins.property
    @jsii.member(jsii_name="transformationInput")
    def transformation_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageUrlImageTransformation"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageUrlImageTransformation"], jsii.get(self, "transformationInput"))

    @builtins.property
    @jsii.member(jsii_name="urlInput")
    def url_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "urlInput"))

    @builtins.property
    @jsii.member(jsii_name="urlVarInput")
    def url_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "urlVarInput"))

    @builtins.property
    @jsii.member(jsii_name="url")
    def url(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "url"))

    @url.setter
    def url(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1cd2614f18dd2726e744737bcf1ea1e3f4281e852d6bfae8b23526a673f9f7bd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "url", value)

    @builtins.property
    @jsii.member(jsii_name="urlVar")
    def url_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "urlVar"))

    @url_var.setter
    def url_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3bd8d4d6498ffe74d1ba0bb1ed1b74d20cc22f5908506600a9c9a43f804748dc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "urlVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageUrlImage]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageUrlImage]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageUrlImage]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0bd8121ef03b9742eb109a5ea7dc077a5392d509f8b35a215495a7b3ad9477fd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageUrlImageTransformation",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageUrlImageTransformation:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageUrlImageTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageUrlImageTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageUrlImageTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4664c4cf6cc3dcaf81f32c3ba14641b2dd0e8ebbff47919a576e9f75bd286916)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageUrlImageTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageUrlImageTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageUrlImageTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4b85080e290aff60b038200c31600aa41c88b97c368f01b66818c00056adaaa2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__21ab37ee08d87cb4b368c31c22b380eeec9f03966fc6d39f2aa2670055600776)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dc865d631ec2e93fdee27013366daa6549c85f8cfdfac83e7a196b56b831d8eb)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__749d87f8aa4ba38931009563d03b68f34fb7cd7ddd1b35e7b4e19769fc4364a6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__69422b2d9038e0beb152f9dfc9485524599bc5625ce421ebc64efff81fdd05c5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b9bb7870c764bce5646e0f0e61c0913a07d353436bb799d332339c56efc70a35)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualComposite]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualComposite]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e480e2e5938d343ad37399f5829455b8676aa1a495a45cc8666a36d4667787e9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b3c1a7b54abac46988e04020022c44585526b3b559bcf47b874e56d133082112)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(
        self,
        *,
        box_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageBoxImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
        circle_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageCircleImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
        text_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageTextImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
        url_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageUrlImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param box_image: box_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#box_image DataAkamaiImagingPolicyImage#box_image}
        :param circle_image: circle_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#circle_image DataAkamaiImagingPolicyImage#circle_image}
        :param text_image: text_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text_image DataAkamaiImagingPolicyImage#text_image}
        :param url_image: url_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url_image DataAkamaiImagingPolicyImage#url_image}
        '''
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImage(
            box_image=box_image,
            circle_image=circle_image,
            text_image=text_image,
            url_image=url_image,
        )

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPlacement")
    def reset_placement(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacement", []))

    @jsii.member(jsii_name="resetPlacementVar")
    def reset_placement_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacementVar", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetScaleDimension")
    def reset_scale_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimension", []))

    @jsii.member(jsii_name="resetScaleDimensionVar")
    def reset_scale_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimensionVar", []))

    @jsii.member(jsii_name="resetScaleVar")
    def reset_scale_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="placementInput")
    def placement_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementInput"))

    @builtins.property
    @jsii.member(jsii_name="placementVarInput")
    def placement_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionInput")
    def scale_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVarInput")
    def scale_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleVarInput")
    def scale_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__649be815e3e7140e9be20c613f5bc68bcddec6e47738792d262df83cb17b70b5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fb6153cacbcaa3078b2e5c2f77b979609dac786b0249b7ff231b4c2fa55128c2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="placement")
    def placement(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placement"))

    @placement.setter
    def placement(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0df8b7cfceac5d450fb4efab077a8c07e01008c2a550dbb31dec8b4a5caa2c5b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placement", value)

    @builtins.property
    @jsii.member(jsii_name="placementVar")
    def placement_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placementVar"))

    @placement_var.setter
    def placement_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b569c52b9311b6b00f990cf07dd0728a2d0e2d08a68e1a6690512c5969bdaf6a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placementVar", value)

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scale"))

    @scale.setter
    def scale(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e19786d85534a702a6628ae3f0349a29bddeeffdc4f3e55ea9185b48f5317584)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scale", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimension")
    def scale_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimension"))

    @scale_dimension.setter
    def scale_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__618b7dc10d544432f8b0586d18be784e8b962bbd43ebaefeb7d0470f23bda9ff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimension", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVar")
    def scale_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimensionVar"))

    @scale_dimension_var.setter
    def scale_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cc14806dcf0916a2b8b4dfb494581a3060933bb38af0349de83e7bb53c645543)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="scaleVar")
    def scale_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleVar"))

    @scale_var.setter
    def scale_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2275c71e149de5ec68eeaea3d7f96f99fb2703a4784170fd00ff3e5f0faf23c6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1865b0d21b2b31d68f8c2e293b9d76ec227fa4ac7ab4ad8222d5299847a0602f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5e59b1ed189618b50376c097ee01f928f9e3c793e7c5ee8b2882fa5fece12bf8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2399464fd813cd33f9283fb1397f01d54425fedf4bbb1ce6a13c4667325de44d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5996ef424079219847d21126d935db48703917de8f539f2aa28c6ae1a34ab9ab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualComposite]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualComposite]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualComposite]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bee550a78060aad39f2a32efb54aeacb905e2cb659e09349c1a07e441df1a36a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompound",
    jsii_struct_bases=[],
    name_mapping={"transformations": "transformations"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompound:
    def __init__(
        self,
        *,
        transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformations, typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param transformations: transformations block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9fca78c4e6644942404e3cd638565e27a437e952ae9ed6d3841898829d3f8d2c)
            check_type(argname="argument transformations", value=transformations, expected_type=type_hints["transformations"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if transformations is not None:
            self._values["transformations"] = transformations

    @builtins.property
    def transformations(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformations]]]:
        '''transformations block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        result = self._values.get("transformations")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformations]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompound(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompoundList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompoundList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8edae56321cdc2b95c7d53d494b97b089763f31d807a6bf116169d546444f09a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompoundOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a34f2a5aec212c43a9eb2d59b5d9cef25ff1b33814e340b1fc6b42b75d7c5dac)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompoundOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__414ac70e92f30fb7c9a2270d397457cef322c07e6f974a41936ad1ca117681b6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__405ddb2098f5008a90de749adee0c077a251d215d9ed9b66896a0a23abc570e0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7ba139c3020553805c309b66a031acc87116ed1de66bc82e6a0f2f8221dd9c7f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompound]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompound]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e1ca0f8726a0b45c992cf279c11c192be437a38eac0b66470c5baa568862d488)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompoundOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompoundOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0896598a706ffa1c369ebddda66b98f213fa58d44d6115e24aad1dcb483f2afd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformations")
    def put_transformations(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformations, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9b34606d595cc9fb72c16511a03da27a9c9735c65e86febd2f898d50eb13cf10)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTransformations", [value]))

    @jsii.member(jsii_name="resetTransformations")
    def reset_transformations(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformations", []))

    @builtins.property
    @jsii.member(jsii_name="transformations")
    def transformations(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsList", jsii.get(self, "transformations"))

    @builtins.property
    @jsii.member(jsii_name="transformationsInput")
    def transformations_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformations]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformations]]], jsii.get(self, "transformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompound]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompound]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompound]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d5baf5700412d0817684b95575441994826b28f004e1eb805c6f5b949704b11)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualContrast",
    jsii_struct_bases=[],
    name_mapping={
        "brightness": "brightness",
        "brightness_var": "brightnessVar",
        "contrast": "contrast",
        "contrast_var": "contrastVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualContrast:
    def __init__(
        self,
        *,
        brightness: typing.Optional[builtins.str] = None,
        brightness_var: typing.Optional[builtins.str] = None,
        contrast: typing.Optional[builtins.str] = None,
        contrast_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param brightness: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        :param brightness_var: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        :param contrast: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param contrast_var: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6a6b01ed64b135eef8d4e131e30ef9289064af14d5a7f2ea2342780dcb007852)
            check_type(argname="argument brightness", value=brightness, expected_type=type_hints["brightness"])
            check_type(argname="argument brightness_var", value=brightness_var, expected_type=type_hints["brightness_var"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument contrast_var", value=contrast_var, expected_type=type_hints["contrast_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if brightness is not None:
            self._values["brightness"] = brightness
        if brightness_var is not None:
            self._values["brightness_var"] = brightness_var
        if contrast is not None:
            self._values["contrast"] = contrast
        if contrast_var is not None:
            self._values["contrast_var"] = contrast_var

    @builtins.property
    def brightness(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        '''
        result = self._values.get("brightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def brightness_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        '''
        result = self._values.get("brightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        result = self._values.get("contrast_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualContrast(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualContrastList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualContrastList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__499df652395d8741450bd92eb932325e9e8d138fe3a4fcd305c1d528080edd11)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualContrastOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__056f799aac82bcfb95a848d8717d21ce08028aa88d93ffb7a24d0a37aa298a05)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualContrastOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7810b9fa7c92e7f9f368de40322beeb3e732cadb49b1f5b77e1db2ef83fabd1c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ebe6dfdbe2f71e1c1dee32294ada0397bfa7969eab462fdaad906d594a2f093)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7e86681cfffaf89266f0bb60ea9db3929363e20342832566270f9b869e385856)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualContrast]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualContrast]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dc316bbec3e0669ea758122dc7a45b1d491c4460a11c559dc89b8cdcbb00d936)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualContrastOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualContrastOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1e71512710a03afc48acfe26f6aa01a1e338d45462ccd8f06c3e8a91a86b5d5d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetBrightness")
    def reset_brightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightness", []))

    @jsii.member(jsii_name="resetBrightnessVar")
    def reset_brightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightnessVar", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetContrastVar")
    def reset_contrast_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrastVar", []))

    @builtins.property
    @jsii.member(jsii_name="brightnessInput")
    def brightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="brightnessVarInput")
    def brightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastVarInput")
    def contrast_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="brightness")
    def brightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightness"))

    @brightness.setter
    def brightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c49199cd308b05fc70ff05a88af90ed4808b930d7ec0fb4341a8e19a35d91c59)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightness", value)

    @builtins.property
    @jsii.member(jsii_name="brightnessVar")
    def brightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightnessVar"))

    @brightness_var.setter
    def brightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0fc93b75c6c7b0f9177b1f15a8d047b1599fe1febb82722c20082b00b225cca6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrast"))

    @contrast.setter
    def contrast(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c8239eeaa82826ad1584bf4b86aec9ce5f0c80a2a7f20bd5d2e7b692e351d242)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrast", value)

    @builtins.property
    @jsii.member(jsii_name="contrastVar")
    def contrast_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrastVar"))

    @contrast_var.setter
    def contrast_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fc726bd2d5b446788f71c43e98765beb621f28e0b439987966b58e56a55f004a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrastVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualContrast]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualContrast]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualContrast]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__97413b9097e748f8445edc6765799f55fdd94eaa4c7e80766eaad5bd195b2754)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCrop",
    jsii_struct_bases=[],
    name_mapping={
        "allow_expansion": "allowExpansion",
        "allow_expansion_var": "allowExpansionVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCrop:
    def __init__(
        self,
        *,
        allow_expansion: typing.Optional[builtins.str] = None,
        allow_expansion_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_expansion: If cropping an area outside of the existing canvas, expands the image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        :param allow_expansion_var: If cropping an area outside of the existing canvas, expands the image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        :param gravity: Frame of reference for X and Y Positions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Frame of reference for X and Y Positions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The number of pixels to crop along the y-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The number of pixels to crop along the y-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The number of pixels to crop along the x-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The number of pixels to crop along the x-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        :param x_position: The x-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__41085125756bc85fe639289c5c6b008546751938b522f84ea090881e73d434f5)
            check_type(argname="argument allow_expansion", value=allow_expansion, expected_type=type_hints["allow_expansion"])
            check_type(argname="argument allow_expansion_var", value=allow_expansion_var, expected_type=type_hints["allow_expansion_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if allow_expansion is not None:
            self._values["allow_expansion"] = allow_expansion
        if allow_expansion_var is not None:
            self._values["allow_expansion_var"] = allow_expansion_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def allow_expansion(self) -> typing.Optional[builtins.str]:
        '''If cropping an area outside of the existing canvas, expands the image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        '''
        result = self._values.get("allow_expansion")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def allow_expansion_var(self) -> typing.Optional[builtins.str]:
        '''If cropping an area outside of the existing canvas, expands the image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        '''
        result = self._values.get("allow_expansion_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Frame of reference for X and Y Positions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Frame of reference for X and Y Positions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the y-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the y-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the x-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the x-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__61b69a0701fde8e3eafa5e90168e196ba3163713247edebd38f643c4e1aa04f1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8e3ffc65a14da70a4a27638ab3ab58594b912a1922ef703d66ab072ffc07dc15)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ceddee13b256c1a275607005610800170a40f0ff81bd2d59e17411b3c6c18883)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__deb1fd071626a8f772bf5849ef982534bcceb6fa120793bb210e0cc5fe1b4e72)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c9470a3c7682983b0cbc5b97ed6ae5bf3dbbf3532e604ee81f0e4faeace38a05)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__50d250130f5135a02aec990e205d89f7a24ef9c6fab001590ce6d3884b5c170c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__01fd444855be93da0fffcc8dfc982f896e42533e10b16a578a7a6dcd107b22a0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAllowExpansion")
    def reset_allow_expansion(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansion", []))

    @jsii.member(jsii_name="resetAllowExpansionVar")
    def reset_allow_expansion_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansionVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionInput")
    def allow_expansion_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVarInput")
    def allow_expansion_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansion")
    def allow_expansion(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansion"))

    @allow_expansion.setter
    def allow_expansion(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d199f0f342eaa9ff528075d6cd1928167afd1433d41c3c43dbfad08a5e216ab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansion", value)

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVar")
    def allow_expansion_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansionVar"))

    @allow_expansion_var.setter
    def allow_expansion_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7564c410fc9cf5929939eb331483da7beb1bde4dfe7e6f42fa3f4d6845516347)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansionVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d4e8022cc584d0a06b467dbd8b27fe255d47ef980880fd44ede15fa2087fdf72)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__58ad5250c2d324ee2bb426a1d5e6296759bf0bde88789ad4a32fb428c056b649)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ecd5b94e7fb3dbb58f06f422473e5507e1ef5130f4cef7df184e136cff982be2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0eb9c985218cf3dabd9e04e7df8c78ec36542b1cc12f6a38563f6c850ce2826c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d7cf4afc03903c9f464ec2987a292004657840ee817c78b4c6e205430ed987a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6b09bef4f6846ede23ea152d47d522df9972ea6044d1eb65b29b914b13897189)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__96a7f2848c720eb8e8fd7f27dd5eb4df8198212358206fa3b7e333c16ea7fd67)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b96c2a093ad26748cffb88f223d6fe3e912c3c259dae75f4c29d96aaafe880f5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a8e37b700d59ebbc8a432a8086302b83529935d05fd6d01481f9d0d5fdd50ab7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aed9210b445b29391db88ddd090b72608b12fd8f9374c3f30840a99258959863)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__11153a138159a2c650516fbc8e0a0a84666e2a5b0b694620a5a4f56d70cf76c0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFaceCrop",
    jsii_struct_bases=[],
    name_mapping={
        "algorithm": "algorithm",
        "algorithm_var": "algorithmVar",
        "confidence": "confidence",
        "confidence_var": "confidenceVar",
        "fail_gravity": "failGravity",
        "fail_gravity_var": "failGravityVar",
        "focus": "focus",
        "focus_var": "focusVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "padding": "padding",
        "padding_var": "paddingVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFaceCrop:
    def __init__(
        self,
        *,
        algorithm: typing.Optional[builtins.str] = None,
        algorithm_var: typing.Optional[builtins.str] = None,
        confidence: typing.Optional[builtins.str] = None,
        confidence_var: typing.Optional[builtins.str] = None,
        fail_gravity: typing.Optional[builtins.str] = None,
        fail_gravity_var: typing.Optional[builtins.str] = None,
        focus: typing.Optional[builtins.str] = None,
        focus_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param algorithm: Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm DataAkamaiImagingPolicyImage#algorithm}
        :param algorithm_var: Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm_var DataAkamaiImagingPolicyImage#algorithm_var}
        :param confidence: With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image. Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence DataAkamaiImagingPolicyImage#confidence}
        :param confidence_var: With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image. Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence_var DataAkamaiImagingPolicyImage#confidence_var}
        :param fail_gravity: Controls placement of the crop if Image and Video Manager does not detect any faces in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        :param fail_gravity_var: Controls placement of the crop if Image and Video Manager does not detect any faces in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        :param focus: Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus DataAkamaiImagingPolicyImage#focus}
        :param focus_var: Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus_var DataAkamaiImagingPolicyImage#focus_var}
        :param gravity: Controls placement of the crop. Directions are relative to the face(s) plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Controls placement of the crop. Directions are relative to the face(s) plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param padding: The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        :param style: Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d760aa9b5a84d74ccea2c803f88ee1960b04ccf45e42bd33ff1db61ee1a2e53f)
            check_type(argname="argument algorithm", value=algorithm, expected_type=type_hints["algorithm"])
            check_type(argname="argument algorithm_var", value=algorithm_var, expected_type=type_hints["algorithm_var"])
            check_type(argname="argument confidence", value=confidence, expected_type=type_hints["confidence"])
            check_type(argname="argument confidence_var", value=confidence_var, expected_type=type_hints["confidence_var"])
            check_type(argname="argument fail_gravity", value=fail_gravity, expected_type=type_hints["fail_gravity"])
            check_type(argname="argument fail_gravity_var", value=fail_gravity_var, expected_type=type_hints["fail_gravity_var"])
            check_type(argname="argument focus", value=focus, expected_type=type_hints["focus"])
            check_type(argname="argument focus_var", value=focus_var, expected_type=type_hints["focus_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if algorithm is not None:
            self._values["algorithm"] = algorithm
        if algorithm_var is not None:
            self._values["algorithm_var"] = algorithm_var
        if confidence is not None:
            self._values["confidence"] = confidence
        if confidence_var is not None:
            self._values["confidence_var"] = confidence_var
        if fail_gravity is not None:
            self._values["fail_gravity"] = fail_gravity
        if fail_gravity_var is not None:
            self._values["fail_gravity_var"] = fail_gravity_var
        if focus is not None:
            self._values["focus"] = focus
        if focus_var is not None:
            self._values["focus_var"] = focus_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def algorithm(self) -> typing.Optional[builtins.str]:
        '''Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm DataAkamaiImagingPolicyImage#algorithm}
        '''
        result = self._values.get("algorithm")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def algorithm_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm_var DataAkamaiImagingPolicyImage#algorithm_var}
        '''
        result = self._values.get("algorithm_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def confidence(self) -> typing.Optional[builtins.str]:
        '''With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image.

        Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence DataAkamaiImagingPolicyImage#confidence}
        '''
        result = self._values.get("confidence")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def confidence_var(self) -> typing.Optional[builtins.str]:
        '''With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image.

        Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence_var DataAkamaiImagingPolicyImage#confidence_var}
        '''
        result = self._values.get("confidence_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any faces in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        '''
        result = self._values.get("fail_gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any faces in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        '''
        result = self._values.get("fail_gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def focus(self) -> typing.Optional[builtins.str]:
        '''Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus DataAkamaiImagingPolicyImage#focus}
        '''
        result = self._values.get("focus")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def focus_var(self) -> typing.Optional[builtins.str]:
        '''Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus_var DataAkamaiImagingPolicyImage#focus_var}
        '''
        result = self._values.get("focus_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the face(s) plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the face(s) plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFaceCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFaceCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFaceCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__547dd9f7a3e0380efa3a8a30d3c9c31647d34ad46058c3ac258547c94f416fff)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFaceCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__43c55117b14a8954aafeb805525797f0d030ea08ca249968a168fbb48d111547)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFaceCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__56b7d3a6d85cea2c01a289536b57880870efc6429d5ba7287e40081645e64d3a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__127a4c79bcbeb3c220aea682e7a7fb86fc3031a767944fbea21be21a954c104a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__170a46693948ad0e80d8b4ddf521f5fea25dcd1b99b01d3cc583a3cc84698935)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFaceCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFaceCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFaceCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8f3e35f40b081a631ef3f15a21762f798db89dbfd94238315cd23be7397f50d6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFaceCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFaceCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ba6e8c881a8532c4cb4413e2ac105667c375195b8706b101f4fe7fdc8792170d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAlgorithm")
    def reset_algorithm(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAlgorithm", []))

    @jsii.member(jsii_name="resetAlgorithmVar")
    def reset_algorithm_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAlgorithmVar", []))

    @jsii.member(jsii_name="resetConfidence")
    def reset_confidence(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetConfidence", []))

    @jsii.member(jsii_name="resetConfidenceVar")
    def reset_confidence_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetConfidenceVar", []))

    @jsii.member(jsii_name="resetFailGravity")
    def reset_fail_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravity", []))

    @jsii.member(jsii_name="resetFailGravityVar")
    def reset_fail_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravityVar", []))

    @jsii.member(jsii_name="resetFocus")
    def reset_focus(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFocus", []))

    @jsii.member(jsii_name="resetFocusVar")
    def reset_focus_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFocusVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="algorithmInput")
    def algorithm_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "algorithmInput"))

    @builtins.property
    @jsii.member(jsii_name="algorithmVarInput")
    def algorithm_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "algorithmVarInput"))

    @builtins.property
    @jsii.member(jsii_name="confidenceInput")
    def confidence_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "confidenceInput"))

    @builtins.property
    @jsii.member(jsii_name="confidenceVarInput")
    def confidence_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "confidenceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityInput")
    def fail_gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityVarInput")
    def fail_gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="focusInput")
    def focus_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "focusInput"))

    @builtins.property
    @jsii.member(jsii_name="focusVarInput")
    def focus_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "focusVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="algorithm")
    def algorithm(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "algorithm"))

    @algorithm.setter
    def algorithm(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8c58aaacc7bda424fc2908ef81955b73563d05e1bf3f6c0595cdc04abdf7bb0f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "algorithm", value)

    @builtins.property
    @jsii.member(jsii_name="algorithmVar")
    def algorithm_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "algorithmVar"))

    @algorithm_var.setter
    def algorithm_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c09f39a921a5939b46c4b717daa4879f51cde6a850a601193c1815779721c28b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "algorithmVar", value)

    @builtins.property
    @jsii.member(jsii_name="confidence")
    def confidence(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "confidence"))

    @confidence.setter
    def confidence(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4064419d9162dbd9df6dff51d87c59061cff5fbc6663bce7c5062f55e4193759)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "confidence", value)

    @builtins.property
    @jsii.member(jsii_name="confidenceVar")
    def confidence_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "confidenceVar"))

    @confidence_var.setter
    def confidence_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2efccc4dff47b8b0534054ee6995f55dd733a60dc6d81cd3c04214357eb1c056)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "confidenceVar", value)

    @builtins.property
    @jsii.member(jsii_name="failGravity")
    def fail_gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravity"))

    @fail_gravity.setter
    def fail_gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__048c5dc820db99465c1c74ffdaaf36c22673054390277c8ff51fd001a856d62e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravity", value)

    @builtins.property
    @jsii.member(jsii_name="failGravityVar")
    def fail_gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravityVar"))

    @fail_gravity_var.setter
    def fail_gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8402ec6d5796ab629b0485854ae4479d89986e00e99e28a5c543ccd5f3b03f1e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="focus")
    def focus(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "focus"))

    @focus.setter
    def focus(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2bebb8c817e0eaba983c2b382b12e8476a26a6621c59ac2dcd2dda6613db7ee4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "focus", value)

    @builtins.property
    @jsii.member(jsii_name="focusVar")
    def focus_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "focusVar"))

    @focus_var.setter
    def focus_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f4449da956dced941484bc1f38638120f0b1192ed8d0c69c9ccf48d5de97b12f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "focusVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1afa89e117d5d33263593e9777d16e91965a2313fe1421371bbc7ba7ac2425fd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9f9077114df3e0d76f7f73531214f7f3294278e5efbba47e4b60bd2e319ec394)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__789d566ebf1c8eb0c0002bca42503d22e1f75a6cf1e767af8069836a46e46141)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d999475d4e4ea1d696ab1d3664be45c72546caff80615ff716f5b2826253fdc2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__45814a59af3174844b88852b8e33a761ab6a42cc438c08e23a30ddb94693a353)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3e2040229398d1dadf7d8cec3324edc4d8f8dcd9bc2b16073aa9688ec9b419cb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e0e9601d2ef482ef81ff2be16a61444acfecd778d8f70dc8c0338ddbe1bb2967)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f5c76c1c0e49e079bc04a2a8bc519c31fe0f08a27f17188dfa2c205e14a3dd6f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__52fde9e2b379a54f965ec45333e07caea800fb0298fbebe93baf3bef2e275080)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f97fe4ec04835b9dc5adef6787736acadf56d75cde71c210cda876d129213a1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFaceCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFaceCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFaceCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ce1af62da03338ae8be202ccb296891ae101dba0c381d43280a46e54cbfcea58)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFeatureCrop",
    jsii_struct_bases=[],
    name_mapping={
        "fail_gravity": "failGravity",
        "fail_gravity_var": "failGravityVar",
        "feature_radius": "featureRadius",
        "feature_radius_var": "featureRadiusVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "max_features": "maxFeatures",
        "max_features_var": "maxFeaturesVar",
        "min_feature_quality": "minFeatureQuality",
        "min_feature_quality_var": "minFeatureQualityVar",
        "padding": "padding",
        "padding_var": "paddingVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFeatureCrop:
    def __init__(
        self,
        *,
        fail_gravity: typing.Optional[builtins.str] = None,
        fail_gravity_var: typing.Optional[builtins.str] = None,
        feature_radius: typing.Optional[builtins.str] = None,
        feature_radius_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        max_features: typing.Optional[builtins.str] = None,
        max_features_var: typing.Optional[builtins.str] = None,
        min_feature_quality: typing.Optional[builtins.str] = None,
        min_feature_quality_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fail_gravity: Controls placement of the crop if Image and Video Manager does not detect any features in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        :param fail_gravity_var: Controls placement of the crop if Image and Video Manager does not detect any features in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        :param feature_radius: The size in pixels of the important features to search for. If identified, two features never appear closer together than this value, ``8.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius DataAkamaiImagingPolicyImage#feature_radius}
        :param feature_radius_var: The size in pixels of the important features to search for. If identified, two features never appear closer together than this value, ``8.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius_var DataAkamaiImagingPolicyImage#feature_radius_var}
        :param gravity: Controls placement of the crop. Directions are relative to the region of interest plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Controls placement of the crop. Directions are relative to the region of interest plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param max_features: The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features DataAkamaiImagingPolicyImage#max_features}
        :param max_features_var: The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features_var DataAkamaiImagingPolicyImage#max_features_var}
        :param min_feature_quality: Determines the minimum quality level of the feature identified. To consider a feature important, the feature needs to surpass this value. Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality DataAkamaiImagingPolicyImage#min_feature_quality}
        :param min_feature_quality_var: Determines the minimum quality level of the feature identified. To consider a feature important, the feature needs to surpass this value. Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality_var DataAkamaiImagingPolicyImage#min_feature_quality_var}
        :param padding: Adds space around the region of interest. The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: Adds space around the region of interest. The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        :param style: Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__22642f6ee9413cb82708cc7ec4be32de2c1df1ed307110f724af0d6ec738e615)
            check_type(argname="argument fail_gravity", value=fail_gravity, expected_type=type_hints["fail_gravity"])
            check_type(argname="argument fail_gravity_var", value=fail_gravity_var, expected_type=type_hints["fail_gravity_var"])
            check_type(argname="argument feature_radius", value=feature_radius, expected_type=type_hints["feature_radius"])
            check_type(argname="argument feature_radius_var", value=feature_radius_var, expected_type=type_hints["feature_radius_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument max_features", value=max_features, expected_type=type_hints["max_features"])
            check_type(argname="argument max_features_var", value=max_features_var, expected_type=type_hints["max_features_var"])
            check_type(argname="argument min_feature_quality", value=min_feature_quality, expected_type=type_hints["min_feature_quality"])
            check_type(argname="argument min_feature_quality_var", value=min_feature_quality_var, expected_type=type_hints["min_feature_quality_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fail_gravity is not None:
            self._values["fail_gravity"] = fail_gravity
        if fail_gravity_var is not None:
            self._values["fail_gravity_var"] = fail_gravity_var
        if feature_radius is not None:
            self._values["feature_radius"] = feature_radius
        if feature_radius_var is not None:
            self._values["feature_radius_var"] = feature_radius_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if max_features is not None:
            self._values["max_features"] = max_features
        if max_features_var is not None:
            self._values["max_features_var"] = max_features_var
        if min_feature_quality is not None:
            self._values["min_feature_quality"] = min_feature_quality
        if min_feature_quality_var is not None:
            self._values["min_feature_quality_var"] = min_feature_quality_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def fail_gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any features in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        '''
        result = self._values.get("fail_gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any features in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        '''
        result = self._values.get("fail_gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feature_radius(self) -> typing.Optional[builtins.str]:
        '''The size in pixels of the important features to search for.

        If identified, two features never appear closer together than this value, ``8.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius DataAkamaiImagingPolicyImage#feature_radius}
        '''
        result = self._values.get("feature_radius")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feature_radius_var(self) -> typing.Optional[builtins.str]:
        '''The size in pixels of the important features to search for.

        If identified, two features never appear closer together than this value, ``8.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius_var DataAkamaiImagingPolicyImage#feature_radius_var}
        '''
        result = self._values.get("feature_radius_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the region of interest plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the region of interest plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def max_features(self) -> typing.Optional[builtins.str]:
        '''The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features DataAkamaiImagingPolicyImage#max_features}
        '''
        result = self._values.get("max_features")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def max_features_var(self) -> typing.Optional[builtins.str]:
        '''The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features_var DataAkamaiImagingPolicyImage#max_features_var}
        '''
        result = self._values.get("max_features_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def min_feature_quality(self) -> typing.Optional[builtins.str]:
        '''Determines the minimum quality level of the feature identified.

        To consider a feature important, the feature needs to surpass this value.  Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality DataAkamaiImagingPolicyImage#min_feature_quality}
        '''
        result = self._values.get("min_feature_quality")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def min_feature_quality_var(self) -> typing.Optional[builtins.str]:
        '''Determines the minimum quality level of the feature identified.

        To consider a feature important, the feature needs to surpass this value.  Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality_var DataAkamaiImagingPolicyImage#min_feature_quality_var}
        '''
        result = self._values.get("min_feature_quality_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''Adds space around the region of interest.

        The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''Adds space around the region of interest.

        The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFeatureCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFeatureCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFeatureCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1e667e7be34cf6971c87b30d0ad4b2f7a1ea8318b7d1b90eeab2bace43dd7eb7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFeatureCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__27686500940562d75c3ecca8f79b63a54f736cf1cb5b02dbe74ab9d00eea8957)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFeatureCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a017806e9276c5ecbdff6851f6ed21db8dc46e5176e98b358f03236570b1f91)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__57b455a84e2d72c573fbd554ec96e4d7c9b38df1cab008324a4530e9284886b0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a13c3a3e451e7060302eecddaa10a6e37237a5b253aca26f3a4524510c4905e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFeatureCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFeatureCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFeatureCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__308ec060530debfa68bcd83338553dcb84c5f8f622ccf9df7fa1060f2007b682)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFeatureCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFeatureCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__79fd1e8d99333083a00938f3f33752898719cbc6404a07c52033a8b862741c42)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetFailGravity")
    def reset_fail_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravity", []))

    @jsii.member(jsii_name="resetFailGravityVar")
    def reset_fail_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravityVar", []))

    @jsii.member(jsii_name="resetFeatureRadius")
    def reset_feature_radius(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureRadius", []))

    @jsii.member(jsii_name="resetFeatureRadiusVar")
    def reset_feature_radius_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureRadiusVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetMaxFeatures")
    def reset_max_features(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxFeatures", []))

    @jsii.member(jsii_name="resetMaxFeaturesVar")
    def reset_max_features_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxFeaturesVar", []))

    @jsii.member(jsii_name="resetMinFeatureQuality")
    def reset_min_feature_quality(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMinFeatureQuality", []))

    @jsii.member(jsii_name="resetMinFeatureQualityVar")
    def reset_min_feature_quality_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMinFeatureQualityVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="failGravityInput")
    def fail_gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityVarInput")
    def fail_gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featureRadiusInput")
    def feature_radius_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featureRadiusInput"))

    @builtins.property
    @jsii.member(jsii_name="featureRadiusVarInput")
    def feature_radius_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featureRadiusVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesInput")
    def max_features_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "maxFeaturesInput"))

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesVarInput")
    def max_features_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "maxFeaturesVarInput"))

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityInput")
    def min_feature_quality_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "minFeatureQualityInput"))

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityVarInput")
    def min_feature_quality_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "minFeatureQualityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravity")
    def fail_gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravity"))

    @fail_gravity.setter
    def fail_gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7a9b72d2a68a4475a1bb9643502e62e0bd33fcd0a1c77123b269a569d0796ebb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravity", value)

    @builtins.property
    @jsii.member(jsii_name="failGravityVar")
    def fail_gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravityVar"))

    @fail_gravity_var.setter
    def fail_gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1bb5b83af56e284aea6fd41a8911fe1d75d562ca871b813552daf71bc9d14b5a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="featureRadius")
    def feature_radius(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featureRadius"))

    @feature_radius.setter
    def feature_radius(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4e197a8b1b4620e19d33dfb2f4d46ea54ab615b69d3eed8672c22ede6704ef77)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featureRadius", value)

    @builtins.property
    @jsii.member(jsii_name="featureRadiusVar")
    def feature_radius_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featureRadiusVar"))

    @feature_radius_var.setter
    def feature_radius_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1bce70fe9d1b5fe91a3d5102c1269b7f58f24b0bc9241e134e75e7e9f403e30d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featureRadiusVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__66f894196d4d2af2421dab312b0854ca8daa431c705ff3e096c57bd4cbeb70c2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ff6e763e596dfe02d3fe42dfa052fc7cc41bd0aec7c118772c781369c3f1b4c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1045bb939a810d29df0135061436811341b27e39dd90b4ebea0bd8ef278b3e95)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__774460cafa602e9ac4a684f25662bb57e7f6905b793e767c909da51fe6206bcc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="maxFeatures")
    def max_features(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "maxFeatures"))

    @max_features.setter
    def max_features(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bea161fda399a9998a4b09fa1ea08b085b375135d94dc03563ed06f288335344)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "maxFeatures", value)

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesVar")
    def max_features_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "maxFeaturesVar"))

    @max_features_var.setter
    def max_features_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3e80d195b6436d8ef8d9a9ce35f0aa583fd92292a19342291cf68b0013729a67)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "maxFeaturesVar", value)

    @builtins.property
    @jsii.member(jsii_name="minFeatureQuality")
    def min_feature_quality(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "minFeatureQuality"))

    @min_feature_quality.setter
    def min_feature_quality(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b85655436879a292b586df2f5fac7c895ab9d1aa41467fea9d4839a6473c53bd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "minFeatureQuality", value)

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityVar")
    def min_feature_quality_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "minFeatureQualityVar"))

    @min_feature_quality_var.setter
    def min_feature_quality_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3bfc6f6fd5e9b746f34addf1f463d14431aec479ce50d2559efca865f37c1a90)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "minFeatureQualityVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a7bce65cc2c756bfe1cd7811d08d671df51e28d5fe241577aefb68c5bc42a301)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__55fc2cdbd0c2804abb6f7af545efd60f2b675ba87c6dd65940872469f76eb6dd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1c9115b364f4d7d3b281511685306917b096da343f7548cb58c9673a859aa0a9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__57d47fce589cb0a8868881fe8cde556da5b731a0fdfc3f254220572848d3f70e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ef5a9a874a066b407dec7340eed180e916e855d3bba17abed309804ba62a6c6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__354addb70b37d2357fe7df78b2d8c2a16e95127ee38adee984b9623e917d3228)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFeatureCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFeatureCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFeatureCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__924ad50aa08195a0d55383fc280873d17ba7a9bfa1cbbae71ecd00964ba29c8b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFill",
    jsii_struct_bases=[],
    name_mapping={
        "fill_transformation": "fillTransformation",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFill:
    def __init__(
        self,
        *,
        fill_transformation: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fill_transformation: fill_transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_transformation DataAkamaiImagingPolicyImage#fill_transformation}
        :param height: The height value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The width value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(fill_transformation, dict):
            fill_transformation = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformation(**fill_transformation)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8ac4f0432f5d873c161cd807c2c6cbba301356693bc1062b029f39a92f8438fa)
            check_type(argname="argument fill_transformation", value=fill_transformation, expected_type=type_hints["fill_transformation"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fill_transformation is not None:
            self._values["fill_transformation"] = fill_transformation
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def fill_transformation(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformation"]:
        '''fill_transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_transformation DataAkamaiImagingPolicyImage#fill_transformation}
        '''
        result = self._values.get("fill_transformation")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformation"], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFill(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformation",
    jsii_struct_bases=[],
    name_mapping={
        "append": "append",
        "aspect_crop": "aspectCrop",
        "background_color": "backgroundColor",
        "blur": "blur",
        "chroma_key": "chromaKey",
        "composite": "composite",
        "compound": "compound",
        "contrast": "contrast",
        "crop": "crop",
        "face_crop": "faceCrop",
        "feature_crop": "featureCrop",
        "fit_and_fill": "fitAndFill",
        "goop": "goop",
        "grayscale": "grayscale",
        "hsl": "hsl",
        "hsv": "hsv",
        "if_dimension": "ifDimension",
        "if_orientation": "ifOrientation",
        "im_query": "imQuery",
        "max_colors": "maxColors",
        "mirror": "mirror",
        "mono_hue": "monoHue",
        "opacity": "opacity",
        "region_of_interest_crop": "regionOfInterestCrop",
        "relative_crop": "relativeCrop",
        "remove_color": "removeColor",
        "resize": "resize",
        "rotate": "rotate",
        "scale": "scale",
        "shear": "shear",
        "trim": "trim",
        "unsharp_mask": "unsharpMask",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformation:
    def __init__(
        self,
        *,
        append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationAppend", typing.Dict[builtins.str, typing.Any]]]]] = None,
        aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationAspectCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationBackgroundColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationBlur", typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationChromaKey", typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationComposite", typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationCompound", typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationContrast", typing.Dict[builtins.str, typing.Any]]]]] = None,
        crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationFaceCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationFeatureCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationFitAndFill", typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationGoop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationGrayscale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationHsl", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationHsv", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfDimension", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfOrientation", typing.Dict[builtins.str, typing.Any]]]]] = None,
        im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationImQuery", typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationMaxColors", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationMirror", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationMonoHue", typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationOpacity", typing.Dict[builtins.str, typing.Any]]]]] = None,
        region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationRegionOfInterestCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationRelativeCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationRemoveColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationResize", typing.Dict[builtins.str, typing.Any]]]]] = None,
        rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationRotate", typing.Dict[builtins.str, typing.Any]]]]] = None,
        scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationScale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationShear", typing.Dict[builtins.str, typing.Any]]]]] = None,
        trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationTrim", typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationUnsharpMask", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param append: append block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        :param aspect_crop: aspect_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param crop: crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        :param face_crop: face_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        :param feature_crop: feature_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        :param fit_and_fill: fit_and_fill block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param im_query: im_query block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param region_of_interest_crop: region_of_interest_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        :param relative_crop: relative_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param resize: resize block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        :param rotate: rotate block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        :param scale: scale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param shear: shear block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        :param trim: trim block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c6b67698c27a5f68931440aa1dd24c0cc62451bcaf571798a368f86603ff5e6f)
            check_type(argname="argument append", value=append, expected_type=type_hints["append"])
            check_type(argname="argument aspect_crop", value=aspect_crop, expected_type=type_hints["aspect_crop"])
            check_type(argname="argument background_color", value=background_color, expected_type=type_hints["background_color"])
            check_type(argname="argument blur", value=blur, expected_type=type_hints["blur"])
            check_type(argname="argument chroma_key", value=chroma_key, expected_type=type_hints["chroma_key"])
            check_type(argname="argument composite", value=composite, expected_type=type_hints["composite"])
            check_type(argname="argument compound", value=compound, expected_type=type_hints["compound"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument crop", value=crop, expected_type=type_hints["crop"])
            check_type(argname="argument face_crop", value=face_crop, expected_type=type_hints["face_crop"])
            check_type(argname="argument feature_crop", value=feature_crop, expected_type=type_hints["feature_crop"])
            check_type(argname="argument fit_and_fill", value=fit_and_fill, expected_type=type_hints["fit_and_fill"])
            check_type(argname="argument goop", value=goop, expected_type=type_hints["goop"])
            check_type(argname="argument grayscale", value=grayscale, expected_type=type_hints["grayscale"])
            check_type(argname="argument hsl", value=hsl, expected_type=type_hints["hsl"])
            check_type(argname="argument hsv", value=hsv, expected_type=type_hints["hsv"])
            check_type(argname="argument if_dimension", value=if_dimension, expected_type=type_hints["if_dimension"])
            check_type(argname="argument if_orientation", value=if_orientation, expected_type=type_hints["if_orientation"])
            check_type(argname="argument im_query", value=im_query, expected_type=type_hints["im_query"])
            check_type(argname="argument max_colors", value=max_colors, expected_type=type_hints["max_colors"])
            check_type(argname="argument mirror", value=mirror, expected_type=type_hints["mirror"])
            check_type(argname="argument mono_hue", value=mono_hue, expected_type=type_hints["mono_hue"])
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument region_of_interest_crop", value=region_of_interest_crop, expected_type=type_hints["region_of_interest_crop"])
            check_type(argname="argument relative_crop", value=relative_crop, expected_type=type_hints["relative_crop"])
            check_type(argname="argument remove_color", value=remove_color, expected_type=type_hints["remove_color"])
            check_type(argname="argument resize", value=resize, expected_type=type_hints["resize"])
            check_type(argname="argument rotate", value=rotate, expected_type=type_hints["rotate"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument shear", value=shear, expected_type=type_hints["shear"])
            check_type(argname="argument trim", value=trim, expected_type=type_hints["trim"])
            check_type(argname="argument unsharp_mask", value=unsharp_mask, expected_type=type_hints["unsharp_mask"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if append is not None:
            self._values["append"] = append
        if aspect_crop is not None:
            self._values["aspect_crop"] = aspect_crop
        if background_color is not None:
            self._values["background_color"] = background_color
        if blur is not None:
            self._values["blur"] = blur
        if chroma_key is not None:
            self._values["chroma_key"] = chroma_key
        if composite is not None:
            self._values["composite"] = composite
        if compound is not None:
            self._values["compound"] = compound
        if contrast is not None:
            self._values["contrast"] = contrast
        if crop is not None:
            self._values["crop"] = crop
        if face_crop is not None:
            self._values["face_crop"] = face_crop
        if feature_crop is not None:
            self._values["feature_crop"] = feature_crop
        if fit_and_fill is not None:
            self._values["fit_and_fill"] = fit_and_fill
        if goop is not None:
            self._values["goop"] = goop
        if grayscale is not None:
            self._values["grayscale"] = grayscale
        if hsl is not None:
            self._values["hsl"] = hsl
        if hsv is not None:
            self._values["hsv"] = hsv
        if if_dimension is not None:
            self._values["if_dimension"] = if_dimension
        if if_orientation is not None:
            self._values["if_orientation"] = if_orientation
        if im_query is not None:
            self._values["im_query"] = im_query
        if max_colors is not None:
            self._values["max_colors"] = max_colors
        if mirror is not None:
            self._values["mirror"] = mirror
        if mono_hue is not None:
            self._values["mono_hue"] = mono_hue
        if opacity is not None:
            self._values["opacity"] = opacity
        if region_of_interest_crop is not None:
            self._values["region_of_interest_crop"] = region_of_interest_crop
        if relative_crop is not None:
            self._values["relative_crop"] = relative_crop
        if remove_color is not None:
            self._values["remove_color"] = remove_color
        if resize is not None:
            self._values["resize"] = resize
        if rotate is not None:
            self._values["rotate"] = rotate
        if scale is not None:
            self._values["scale"] = scale
        if shear is not None:
            self._values["shear"] = shear
        if trim is not None:
            self._values["trim"] = trim
        if unsharp_mask is not None:
            self._values["unsharp_mask"] = unsharp_mask

    @builtins.property
    def append(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationAppend"]]]:
        '''append block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        '''
        result = self._values.get("append")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationAppend"]]], result)

    @builtins.property
    def aspect_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationAspectCrop"]]]:
        '''aspect_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        '''
        result = self._values.get("aspect_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationAspectCrop"]]], result)

    @builtins.property
    def background_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationBackgroundColor"]]]:
        '''background_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        '''
        result = self._values.get("background_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationBackgroundColor"]]], result)

    @builtins.property
    def blur(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationBlur"]]]:
        '''blur block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        '''
        result = self._values.get("blur")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationBlur"]]], result)

    @builtins.property
    def chroma_key(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationChromaKey"]]]:
        '''chroma_key block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        '''
        result = self._values.get("chroma_key")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationChromaKey"]]], result)

    @builtins.property
    def composite(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationComposite"]]]:
        '''composite block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        '''
        result = self._values.get("composite")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationComposite"]]], result)

    @builtins.property
    def compound(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationCompound"]]]:
        '''compound block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        '''
        result = self._values.get("compound")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationCompound"]]], result)

    @builtins.property
    def contrast(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationContrast"]]]:
        '''contrast block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationContrast"]]], result)

    @builtins.property
    def crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationCrop"]]]:
        '''crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        '''
        result = self._values.get("crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationCrop"]]], result)

    @builtins.property
    def face_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationFaceCrop"]]]:
        '''face_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        '''
        result = self._values.get("face_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationFaceCrop"]]], result)

    @builtins.property
    def feature_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationFeatureCrop"]]]:
        '''feature_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        '''
        result = self._values.get("feature_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationFeatureCrop"]]], result)

    @builtins.property
    def fit_and_fill(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationFitAndFill"]]]:
        '''fit_and_fill block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        '''
        result = self._values.get("fit_and_fill")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationFitAndFill"]]], result)

    @builtins.property
    def goop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationGoop"]]]:
        '''goop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        '''
        result = self._values.get("goop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationGoop"]]], result)

    @builtins.property
    def grayscale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationGrayscale"]]]:
        '''grayscale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        '''
        result = self._values.get("grayscale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationGrayscale"]]], result)

    @builtins.property
    def hsl(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationHsl"]]]:
        '''hsl block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        '''
        result = self._values.get("hsl")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationHsl"]]], result)

    @builtins.property
    def hsv(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationHsv"]]]:
        '''hsv block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        '''
        result = self._values.get("hsv")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationHsv"]]], result)

    @builtins.property
    def if_dimension(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfDimension"]]]:
        '''if_dimension block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        '''
        result = self._values.get("if_dimension")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfDimension"]]], result)

    @builtins.property
    def if_orientation(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfOrientation"]]]:
        '''if_orientation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        '''
        result = self._values.get("if_orientation")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfOrientation"]]], result)

    @builtins.property
    def im_query(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationImQuery"]]]:
        '''im_query block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        '''
        result = self._values.get("im_query")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationImQuery"]]], result)

    @builtins.property
    def max_colors(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationMaxColors"]]]:
        '''max_colors block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        '''
        result = self._values.get("max_colors")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationMaxColors"]]], result)

    @builtins.property
    def mirror(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationMirror"]]]:
        '''mirror block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        '''
        result = self._values.get("mirror")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationMirror"]]], result)

    @builtins.property
    def mono_hue(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationMonoHue"]]]:
        '''mono_hue block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        '''
        result = self._values.get("mono_hue")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationMonoHue"]]], result)

    @builtins.property
    def opacity(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationOpacity"]]]:
        '''opacity block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationOpacity"]]], result)

    @builtins.property
    def region_of_interest_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationRegionOfInterestCrop"]]]:
        '''region_of_interest_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        '''
        result = self._values.get("region_of_interest_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationRegionOfInterestCrop"]]], result)

    @builtins.property
    def relative_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationRelativeCrop"]]]:
        '''relative_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        '''
        result = self._values.get("relative_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationRelativeCrop"]]], result)

    @builtins.property
    def remove_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationRemoveColor"]]]:
        '''remove_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        '''
        result = self._values.get("remove_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationRemoveColor"]]], result)

    @builtins.property
    def resize(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationResize"]]]:
        '''resize block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        '''
        result = self._values.get("resize")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationResize"]]], result)

    @builtins.property
    def rotate(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationRotate"]]]:
        '''rotate block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        '''
        result = self._values.get("rotate")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationRotate"]]], result)

    @builtins.property
    def scale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationScale"]]]:
        '''scale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationScale"]]], result)

    @builtins.property
    def shear(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationShear"]]]:
        '''shear block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        '''
        result = self._values.get("shear")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationShear"]]], result)

    @builtins.property
    def trim(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationTrim"]]]:
        '''trim block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        '''
        result = self._values.get("trim")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationTrim"]]], result)

    @builtins.property
    def unsharp_mask(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationUnsharpMask"]]]:
        '''unsharp_mask block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        result = self._values.get("unsharp_mask")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationUnsharpMask"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationAppend",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_priority": "gravityPriority",
        "gravity_priority_var": "gravityPriorityVar",
        "gravity_var": "gravityVar",
        "preserve_minor_dimension": "preserveMinorDimension",
        "preserve_minor_dimension_var": "preserveMinorDimensionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationAppend:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationAppendImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_priority: typing.Optional[builtins.str] = None,
        gravity_priority_var: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        preserve_minor_dimension: typing.Optional[builtins.str] = None,
        preserve_minor_dimension_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Specifies where to place the ``image`` relative to the source image. The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_priority: Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal. The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority DataAkamaiImagingPolicyImage#gravity_priority}
        :param gravity_priority_var: Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal. The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority_var DataAkamaiImagingPolicyImage#gravity_priority_var}
        :param gravity_var: Specifies where to place the ``image`` relative to the source image. The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param preserve_minor_dimension: Whether to preserve the source image's minor dimension, ``false`` by default. The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension DataAkamaiImagingPolicyImage#preserve_minor_dimension}
        :param preserve_minor_dimension_var: Whether to preserve the source image's minor dimension, ``false`` by default. The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension_var DataAkamaiImagingPolicyImage#preserve_minor_dimension_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationAppendImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4589d01ae75a28a2134854131326dceb5a0ac650dbdf482ccc6b3825add566e8)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_priority", value=gravity_priority, expected_type=type_hints["gravity_priority"])
            check_type(argname="argument gravity_priority_var", value=gravity_priority_var, expected_type=type_hints["gravity_priority_var"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument preserve_minor_dimension", value=preserve_minor_dimension, expected_type=type_hints["preserve_minor_dimension"])
            check_type(argname="argument preserve_minor_dimension_var", value=preserve_minor_dimension_var, expected_type=type_hints["preserve_minor_dimension_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_priority is not None:
            self._values["gravity_priority"] = gravity_priority
        if gravity_priority_var is not None:
            self._values["gravity_priority_var"] = gravity_priority_var
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if preserve_minor_dimension is not None:
            self._values["preserve_minor_dimension"] = preserve_minor_dimension
        if preserve_minor_dimension_var is not None:
            self._values["preserve_minor_dimension_var"] = preserve_minor_dimension_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationAppendImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationAppendImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Specifies where to place the ``image`` relative to the source image.

        The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_priority(self) -> typing.Optional[builtins.str]:
        '''Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal.

        The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority DataAkamaiImagingPolicyImage#gravity_priority}
        '''
        result = self._values.get("gravity_priority")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_priority_var(self) -> typing.Optional[builtins.str]:
        '''Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal.

        The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority_var DataAkamaiImagingPolicyImage#gravity_priority_var}
        '''
        result = self._values.get("gravity_priority_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Specifies where to place the ``image`` relative to the source image.

        The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def preserve_minor_dimension(self) -> typing.Optional[builtins.str]:
        '''Whether to preserve the source image's minor dimension, ``false`` by default.

        The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension DataAkamaiImagingPolicyImage#preserve_minor_dimension}
        '''
        result = self._values.get("preserve_minor_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def preserve_minor_dimension_var(self) -> typing.Optional[builtins.str]:
        '''Whether to preserve the source image's minor dimension, ``false`` by default.

        The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension_var DataAkamaiImagingPolicyImage#preserve_minor_dimension_var}
        '''
        result = self._values.get("preserve_minor_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationAppend(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationAppendImage",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationAppendImage:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationAppendImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationAppendImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationAppendImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__219dbcf35bf7ebf6208c55a31b8d36f03e96193dcc0f78d0deb65c59aa06db46)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationAppendImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationAppendImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationAppendImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9cec9db8bc640c02eb214fe83f1721297408bec5a8f481f20ecb5ea53a8e4be3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationAppendList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationAppendList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5fc3c87c4fcdd250e089401d4e960791d0a83101a5ac90b12c7eaf7149e7dc3e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationAppendOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c4ad26354f7a3279ccaa24a0bae9e7d1914ccc905b8f214a0a316822dd912827)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationAppendOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8915aaca36083027da14dd0cd81c907e751d750b663c3f274a51f90502c4aab7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__84733d5d9eba72eaf22cc4877bdb526c45589e730725fbb04be3c86302ad5d7e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f4454353ae59bb6c284b7c9d0ac1e217e5ef8c9a71367264effa5bc400792d7e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationAppend]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationAppend]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationAppend]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4921faae2de111b59562c6639045ad716165d043cb473126b018111fad5fa953)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationAppendOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationAppendOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0835843426d4273c69ed8f0dd71129fb302667994c94a384943d954abdd3d5ae)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationAppendImage()

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityPriority")
    def reset_gravity_priority(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityPriority", []))

    @jsii.member(jsii_name="resetGravityPriorityVar")
    def reset_gravity_priority_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityPriorityVar", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPreserveMinorDimension")
    def reset_preserve_minor_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPreserveMinorDimension", []))

    @jsii.member(jsii_name="resetPreserveMinorDimensionVar")
    def reset_preserve_minor_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPreserveMinorDimensionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationAppendImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationAppendImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityInput")
    def gravity_priority_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityPriorityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityVarInput")
    def gravity_priority_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityPriorityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationAppendImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationAppendImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionInput")
    def preserve_minor_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "preserveMinorDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionVarInput")
    def preserve_minor_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "preserveMinorDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__265fb065aa7cd534dde3f4e56e4a9a3b1e6611316df65c6483eb80c774633b53)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityPriority")
    def gravity_priority(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityPriority"))

    @gravity_priority.setter
    def gravity_priority(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__31133ba098397ab53860d9fd10cf64c7dc867adfac2f3c652e356531c0d3b21b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityPriority", value)

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityVar")
    def gravity_priority_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityPriorityVar"))

    @gravity_priority_var.setter
    def gravity_priority_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__261ba5bb94b454fedbf0efdbeac42fd30a41fdf0c3e16e5d3ec81a15f7f68aed)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityPriorityVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__967f2360c3ff5b542f40e486202f267fd4f1a8fc5a51ce7b94f4600af11ab523)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimension")
    def preserve_minor_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "preserveMinorDimension"))

    @preserve_minor_dimension.setter
    def preserve_minor_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4d2ed4d5bb570417914124d02a9bdff1ce0f22bdc4915c842e1ff1e389379bd7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "preserveMinorDimension", value)

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionVar")
    def preserve_minor_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "preserveMinorDimensionVar"))

    @preserve_minor_dimension_var.setter
    def preserve_minor_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__27dcaf922c748b77df0e9570596dae72b5bfd2dcf3086a4c8b0135950fc957cc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "preserveMinorDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationAppend]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationAppend]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationAppend]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1cc39ad6ff9c0b936d29e21c75096fd4b9f388573e6d8ff7221ac48e1a203b1e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationAspectCrop",
    jsii_struct_bases=[],
    name_mapping={
        "allow_expansion": "allowExpansion",
        "allow_expansion_var": "allowExpansionVar",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationAspectCrop:
    def __init__(
        self,
        *,
        allow_expansion: typing.Optional[builtins.str] = None,
        allow_expansion_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_expansion: Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image. Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        :param allow_expansion_var: Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image. Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        :param height: The height term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The width term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        :param x_position: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2554bcb3eb260d9fcff57a5acc2676849b557c9fba027d01b45b91a0b63f4fb4)
            check_type(argname="argument allow_expansion", value=allow_expansion, expected_type=type_hints["allow_expansion"])
            check_type(argname="argument allow_expansion_var", value=allow_expansion_var, expected_type=type_hints["allow_expansion_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if allow_expansion is not None:
            self._values["allow_expansion"] = allow_expansion
        if allow_expansion_var is not None:
            self._values["allow_expansion_var"] = allow_expansion_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def allow_expansion(self) -> typing.Optional[builtins.str]:
        '''Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image.

        Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        '''
        result = self._values.get("allow_expansion")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def allow_expansion_var(self) -> typing.Optional[builtins.str]:
        '''Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image.

        Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        '''
        result = self._values.get("allow_expansion_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationAspectCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationAspectCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationAspectCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac5ec5341d71051b1dcaaf6e3266da02a7d9e39b4ad532a4826943b8bf980c84)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationAspectCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3d718f4c8fbd9c7e86724205044458101c5c6dcadec75b4e978ee93cebd4a9dc)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationAspectCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5958014de5b6b79547f7c8073212cab62c23b29a072344a4965c059dd13ad90c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a90ced775776202da78dfad1ccc6fc51dd10e4e0524296c35881dbff9ae03fe2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__72273409a8510f09859ad85c00b977d29a320a14402c2c26684fab199cb27a4f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationAspectCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationAspectCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationAspectCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cf06c18d164a26f634e485939bcc4cd3f343b54432c8729c0138dfaf4b3b952d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationAspectCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationAspectCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0982fdc33ad55f710cb181b8bfff4e73ce180a50d13b6862aa73fc42355618a3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAllowExpansion")
    def reset_allow_expansion(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansion", []))

    @jsii.member(jsii_name="resetAllowExpansionVar")
    def reset_allow_expansion_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansionVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionInput")
    def allow_expansion_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVarInput")
    def allow_expansion_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansion")
    def allow_expansion(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansion"))

    @allow_expansion.setter
    def allow_expansion(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9618672817262fd731d29c7038424c38961e01ff5d874b008983f1bc1bccaa6c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansion", value)

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVar")
    def allow_expansion_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansionVar"))

    @allow_expansion_var.setter
    def allow_expansion_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__50904c721eedc5a6dc06b6894be1575201c8598ddca83f1c5b5a3f283a821fdb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansionVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__478314d31ba066321f5c872a752ec88dcdc71241123ff75af963ee758de3200a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fc765dc791dc52743a7ab804fcd43a23d9e34905ee2ad4346f3d072724b25c3d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__72c4fda9bd30ddabebf46310a7a1ae584b716041bcc847bda665405816d5d5fd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1fd27e75b15e49dd8515cd0eba9b68ab3478bb40165edc2102f3edae4aefd8c0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__22c650155bc18d1f865f7876d6df21e9ec6be5d08e1fae5e6a0cb360c746ca4e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e7c8b59c94c1e108bb25f9ef171f3cb08732c5d682757143735305bb6fa6f604)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8c5e602cdc70532f3ccdad1662d6982749ff32405a5ebd45be29870cfba32667)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__00fa17d390d504ebc23a65d371adff9b7e3fd7c5fc345fc4b4a72a90ebfccc3c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationAspectCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationAspectCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationAspectCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__375655be7a5ea9228d4b462b833960d5aa98293e58584c1c10a698ddc4205e2b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationBackgroundColor",
    jsii_struct_bases=[],
    name_mapping={"color": "color", "color_var": "colorVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationBackgroundColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__463b5493e2e21526981ec93eb23b56a5a769485013f672ff5be6b29a75c2558e)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationBackgroundColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationBackgroundColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationBackgroundColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eb59371f5fc844c4298a0df42ad9c867e8a2c7cdf49e29c14a093872c7827efa)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationBackgroundColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e97143f72f242e5b49849bf6692ece421b0d3f5e2dea4a5faae21c512149612e)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationBackgroundColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6514d09705f5313ee9c794da4f785a110ba8ff6e21d78fae7d71f01d8d0e17f2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4d156fb4facd47f38b2c3260310949b4a5cc7687f09bf6b297568cb19b67048e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__624943d87e640167ce807dce215b87f5d69a2704cd419615271890a168caba1d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationBackgroundColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationBackgroundColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__79d1a01601fb5159ca16fe5ffa979292eea7a1018b333ef488b222c64d21701d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationBackgroundColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationBackgroundColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cbeeadaf4d29b6b0e3f8a58c86944010a80d166b9aec8ae6591248bcc213ef52)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__21e569226e50cddcfeff90e52fb02b9848af10dd750e2c1a0778b7dd2d18c394)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__70b310ac4f97da0a0b43eaf71543a67668faa21ed8a9621f1946fe5392d07734)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationBackgroundColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationBackgroundColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationBackgroundColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5daccbdffc662daae0f859118f3c3716f50c5c0c72df3c0b51c56b4608ca881f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationBlur",
    jsii_struct_bases=[],
    name_mapping={"sigma": "sigma", "sigma_var": "sigmaVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationBlur:
    def __init__(
        self,
        *,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param sigma: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ec3ef45c1621c509980fd572048c3a6d7f45474e70cc9b52f10faffd5d0d920c)
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationBlur(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationBlurList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationBlurList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__06ef3d087b0617ae381aa908885c599db2aa22bb47ad4d07cfbb701105a476a8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationBlurOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7515d32a8b2370c3050285641b53bad1474cb3a665bd0b85151d3f4ea299d600)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationBlurOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__13dcf94ae7d16812916e5b5b7b6c6b6d6b524445619fc2d58617aafe7e217a80)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__30029d8f64286789e3423c60648207e47d5711225e6e88a183896316019eabe8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3738a8223d37858539f869a2749d273856372e78c9455733d2cb38d7481a97ae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationBlur]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationBlur]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__35883f89b64a08bf4784aeca82c04a497b04a8716dba1462282f3bb9a0297527)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationBlurOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationBlurOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9deba5dde857fd122d348df3dd9f9734a31006b59d316519e7eaf5db80229cb6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__454836a4bfa43085d59f518a994c58dc5d026b39b70a518265e4d5ab426942d6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ce9d5665cbe6505924c3ab7648a441acf3538590a95b6a9c87b5e5063a41777)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationBlur]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationBlur]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationBlur]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__69d749a1396edcd9d984611fb3cbe54159a304566da42e84478150703e68fcd7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationChromaKey",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_feather": "hueFeather",
        "hue_feather_var": "hueFeatherVar",
        "hue_tolerance": "hueTolerance",
        "hue_tolerance_var": "hueToleranceVar",
        "hue_var": "hueVar",
        "lightness_feather": "lightnessFeather",
        "lightness_feather_var": "lightnessFeatherVar",
        "lightness_tolerance": "lightnessTolerance",
        "lightness_tolerance_var": "lightnessToleranceVar",
        "saturation_feather": "saturationFeather",
        "saturation_feather_var": "saturationFeatherVar",
        "saturation_tolerance": "saturationTolerance",
        "saturation_tolerance_var": "saturationToleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationChromaKey:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_feather: typing.Optional[builtins.str] = None,
        hue_feather_var: typing.Optional[builtins.str] = None,
        hue_tolerance: typing.Optional[builtins.str] = None,
        hue_tolerance_var: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness_feather: typing.Optional[builtins.str] = None,
        lightness_feather_var: typing.Optional[builtins.str] = None,
        lightness_tolerance: typing.Optional[builtins.str] = None,
        lightness_tolerance_var: typing.Optional[builtins.str] = None,
        saturation_feather: typing.Optional[builtins.str] = None,
        saturation_feather_var: typing.Optional[builtins.str] = None,
        saturation_tolerance: typing.Optional[builtins.str] = None,
        saturation_tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_feather: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        :param hue_feather_var: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        :param hue_tolerance: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        :param hue_tolerance_var: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        :param hue_var: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness_feather: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        :param lightness_feather_var: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        :param lightness_tolerance: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        :param lightness_tolerance_var: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        :param saturation_feather: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        :param saturation_feather_var: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        :param saturation_tolerance: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        :param saturation_tolerance_var: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__952e1803cc5b7ab692294d4e2e739f4825555d4695b11ad84fc4dbd91ecd9990)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_feather", value=hue_feather, expected_type=type_hints["hue_feather"])
            check_type(argname="argument hue_feather_var", value=hue_feather_var, expected_type=type_hints["hue_feather_var"])
            check_type(argname="argument hue_tolerance", value=hue_tolerance, expected_type=type_hints["hue_tolerance"])
            check_type(argname="argument hue_tolerance_var", value=hue_tolerance_var, expected_type=type_hints["hue_tolerance_var"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness_feather", value=lightness_feather, expected_type=type_hints["lightness_feather"])
            check_type(argname="argument lightness_feather_var", value=lightness_feather_var, expected_type=type_hints["lightness_feather_var"])
            check_type(argname="argument lightness_tolerance", value=lightness_tolerance, expected_type=type_hints["lightness_tolerance"])
            check_type(argname="argument lightness_tolerance_var", value=lightness_tolerance_var, expected_type=type_hints["lightness_tolerance_var"])
            check_type(argname="argument saturation_feather", value=saturation_feather, expected_type=type_hints["saturation_feather"])
            check_type(argname="argument saturation_feather_var", value=saturation_feather_var, expected_type=type_hints["saturation_feather_var"])
            check_type(argname="argument saturation_tolerance", value=saturation_tolerance, expected_type=type_hints["saturation_tolerance"])
            check_type(argname="argument saturation_tolerance_var", value=saturation_tolerance_var, expected_type=type_hints["saturation_tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_feather is not None:
            self._values["hue_feather"] = hue_feather
        if hue_feather_var is not None:
            self._values["hue_feather_var"] = hue_feather_var
        if hue_tolerance is not None:
            self._values["hue_tolerance"] = hue_tolerance
        if hue_tolerance_var is not None:
            self._values["hue_tolerance_var"] = hue_tolerance_var
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness_feather is not None:
            self._values["lightness_feather"] = lightness_feather
        if lightness_feather_var is not None:
            self._values["lightness_feather_var"] = lightness_feather_var
        if lightness_tolerance is not None:
            self._values["lightness_tolerance"] = lightness_tolerance
        if lightness_tolerance_var is not None:
            self._values["lightness_tolerance_var"] = lightness_tolerance_var
        if saturation_feather is not None:
            self._values["saturation_feather"] = saturation_feather
        if saturation_feather_var is not None:
            self._values["saturation_feather_var"] = saturation_feather_var
        if saturation_tolerance is not None:
            self._values["saturation_tolerance"] = saturation_tolerance
        if saturation_tolerance_var is not None:
            self._values["saturation_tolerance_var"] = saturation_tolerance_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        '''
        result = self._values.get("hue_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        '''
        result = self._values.get("hue_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        '''
        result = self._values.get("hue_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        '''
        result = self._values.get("hue_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        '''
        result = self._values.get("lightness_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        '''
        result = self._values.get("lightness_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        '''
        result = self._values.get("lightness_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        '''
        result = self._values.get("lightness_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        '''
        result = self._values.get("saturation_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        '''
        result = self._values.get("saturation_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        '''
        result = self._values.get("saturation_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        result = self._values.get("saturation_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationChromaKey(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationChromaKeyList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationChromaKeyList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4e8ed609015dd78f7019d1d448797a29b25c297944b353daa653cea42076af66)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationChromaKeyOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__728ad502fb789d5019fae4dc7a81c440269ae46997be459204540c64f0958342)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationChromaKeyOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__206b3324e5723ed2e99133f9be1bd4b45b45e8dd36f09e8fdd9366610323de87)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9adcc1b0109b10eb9abfb32c25c1220146ba2e176f997542123c004bbd958cb7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4dab789d6c98ec15ee2b91ecc909c971d5308246358fd8d8e6c8d8d31826d3e7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationChromaKey]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationChromaKey]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fded866044add5e46121bf0b0ba91a414c806dbc9dfd58fd26e08a3943122b3c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationChromaKeyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationChromaKeyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b228ea5eac94b953800b7c374101bc5b6a48b115f08f9329ae227ec31a0ec20a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueFeather")
    def reset_hue_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeather", []))

    @jsii.member(jsii_name="resetHueFeatherVar")
    def reset_hue_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeatherVar", []))

    @jsii.member(jsii_name="resetHueTolerance")
    def reset_hue_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueTolerance", []))

    @jsii.member(jsii_name="resetHueToleranceVar")
    def reset_hue_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueToleranceVar", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightnessFeather")
    def reset_lightness_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeather", []))

    @jsii.member(jsii_name="resetLightnessFeatherVar")
    def reset_lightness_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeatherVar", []))

    @jsii.member(jsii_name="resetLightnessTolerance")
    def reset_lightness_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessTolerance", []))

    @jsii.member(jsii_name="resetLightnessToleranceVar")
    def reset_lightness_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessToleranceVar", []))

    @jsii.member(jsii_name="resetSaturationFeather")
    def reset_saturation_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeather", []))

    @jsii.member(jsii_name="resetSaturationFeatherVar")
    def reset_saturation_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeatherVar", []))

    @jsii.member(jsii_name="resetSaturationTolerance")
    def reset_saturation_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationTolerance", []))

    @jsii.member(jsii_name="resetSaturationToleranceVar")
    def reset_saturation_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherInput")
    def hue_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVarInput")
    def hue_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceInput")
    def hue_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVarInput")
    def hue_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherInput")
    def lightness_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVarInput")
    def lightness_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceInput")
    def lightness_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVarInput")
    def lightness_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherInput")
    def saturation_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVarInput")
    def saturation_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceInput")
    def saturation_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVarInput")
    def saturation_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__61fdca3156d5b5d618d1d019437585b6ae0d57a4461b21c43c96b225c28fb6aa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeather")
    def hue_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeather"))

    @hue_feather.setter
    def hue_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c536484bf9804636640e333df1f1297726a2e9ef69c160e581f44c51e7a85173)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeather", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVar")
    def hue_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeatherVar"))

    @hue_feather_var.setter
    def hue_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dd407313b317b9fa28b875ad63d97dfb220f3c3834b2ea274c510f857866fa10)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueTolerance")
    def hue_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueTolerance"))

    @hue_tolerance.setter
    def hue_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0a4a0068945098a28cf950f45a61226fb6c4aa57857fedc9ee2b191e3e39dbc4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVar")
    def hue_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueToleranceVar"))

    @hue_tolerance_var.setter
    def hue_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cef317251c85175bf0b30523b031afe7661580390383f28cb8792ecf01efcd54)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__327e82928173ab34833971aef6b7333bf5d24e1db49ee67b4ce7f44674443c95)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeather")
    def lightness_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeather"))

    @lightness_feather.setter
    def lightness_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fd6efba7d2097345a6980a598a59e6ee691ccb601db7f44d3ed46891c696e401)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeather", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVar")
    def lightness_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeatherVar"))

    @lightness_feather_var.setter
    def lightness_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__45c16e18b66429d7b8ef22857d0bb8bff93307a36327feb4254bcb73df4f588b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessTolerance")
    def lightness_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessTolerance"))

    @lightness_tolerance.setter
    def lightness_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__95897a5b0b1d4e38aa52aed6d13faa22b878f55299923772a1e720e4b978af53)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVar")
    def lightness_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessToleranceVar"))

    @lightness_tolerance_var.setter
    def lightness_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__32b6902670a0c6fa7b175565c3e12d2dced5f1915016a67669a5261cd6583f93)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeather")
    def saturation_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeather"))

    @saturation_feather.setter
    def saturation_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__84b46ad959ca58aee4dfcdbacc42692e3d2c0778c5694e7bf8e86f6bae166afc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeather", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVar")
    def saturation_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeatherVar"))

    @saturation_feather_var.setter
    def saturation_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__51e3b00972afa26dd8722063a725c573fee88e66c22e5edf931f70cea76e3c01)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationTolerance")
    def saturation_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationTolerance"))

    @saturation_tolerance.setter
    def saturation_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d305b87c43445592bdcea40f8ba4f46baad12e90c523eb63e06c619ce733ea21)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVar")
    def saturation_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationToleranceVar"))

    @saturation_tolerance_var.setter
    def saturation_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e8162a2e539ed6518ff70faad35615d7e6f1fe804ef89bb4e9a0f442bf2c6699)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationChromaKey]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationChromaKey]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationChromaKey]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c23df8b61732e46c33060ba49a5d02b0673a6e3c1ad2ab0d24a560a3f727883e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationComposite",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "placement": "placement",
        "placement_var": "placementVar",
        "scale": "scale",
        "scale_dimension": "scaleDimension",
        "scale_dimension_var": "scaleDimensionVar",
        "scale_var": "scaleVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationComposite:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationCompositeImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        placement: typing.Optional[builtins.str] = None,
        placement_var: typing.Optional[builtins.str] = None,
        scale: typing.Optional[builtins.str] = None,
        scale_dimension: typing.Optional[builtins.str] = None,
        scale_dimension_var: typing.Optional[builtins.str] = None,
        scale_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param placement: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        :param placement_var: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        :param scale: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param scale_dimension: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        :param scale_dimension_var: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        :param scale_var: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        :param x_position: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationCompositeImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ccc50a648c4b64d9d5eeb69ae1f9a8decb9c65e0bd9982abbbf32b2b4aa9a583)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument placement", value=placement, expected_type=type_hints["placement"])
            check_type(argname="argument placement_var", value=placement_var, expected_type=type_hints["placement_var"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument scale_dimension", value=scale_dimension, expected_type=type_hints["scale_dimension"])
            check_type(argname="argument scale_dimension_var", value=scale_dimension_var, expected_type=type_hints["scale_dimension_var"])
            check_type(argname="argument scale_var", value=scale_var, expected_type=type_hints["scale_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if placement is not None:
            self._values["placement"] = placement
        if placement_var is not None:
            self._values["placement_var"] = placement_var
        if scale is not None:
            self._values["scale"] = scale
        if scale_dimension is not None:
            self._values["scale_dimension"] = scale_dimension
        if scale_dimension_var is not None:
            self._values["scale_dimension_var"] = scale_dimension_var
        if scale_var is not None:
            self._values["scale_var"] = scale_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationCompositeImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationCompositeImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        '''
        result = self._values.get("placement")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement_var(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        '''
        result = self._values.get("placement_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        '''
        result = self._values.get("scale_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        '''
        result = self._values.get("scale_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        '''
        result = self._values.get("scale_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationComposite(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationCompositeImage",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationCompositeImage:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationCompositeImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationCompositeImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationCompositeImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__134fa6f3bbfbe01ada9eb7fa9970a0d27cf2cfc641b550066fcd339cd5953bdc)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationCompositeImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationCompositeImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5c367315613e54f44d447c7136fcbbe7ca94dcc00cc9663262c88711a19db349)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationCompositeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationCompositeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__74672d115dacc34afc05aef8ae14de26d5778c510b811e5888ee5014b84db45d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationCompositeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d8711cb03a8e750c75b43e017e73546d727f896b62e16832a40798ddbf6d0a82)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationCompositeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__242501d1a69d75d291b35c82e40bb3152174fd9bb46328e5d9e5f653c7d3d8ae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__99afbfadffc636a26f793f9b863b78c41f882e857c7ffec571c8f64d158085f6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f411c7f85e10933456c6544ad1349dd02b5a346b2e8b1713364e7ef3b846d7c3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationComposite]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationComposite]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7fb1ce8354e56ed0cdac0d08f47e5415e3b34aa551117f067100172877debe38)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationCompositeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationCompositeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a92ecd8ec449ce5bd65098764365c53cbe7f87ba17ab24a37a926d6c68fa7f2b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationCompositeImage()

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPlacement")
    def reset_placement(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacement", []))

    @jsii.member(jsii_name="resetPlacementVar")
    def reset_placement_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacementVar", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetScaleDimension")
    def reset_scale_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimension", []))

    @jsii.member(jsii_name="resetScaleDimensionVar")
    def reset_scale_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimensionVar", []))

    @jsii.member(jsii_name="resetScaleVar")
    def reset_scale_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationCompositeImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationCompositeImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationCompositeImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="placementInput")
    def placement_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementInput"))

    @builtins.property
    @jsii.member(jsii_name="placementVarInput")
    def placement_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionInput")
    def scale_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVarInput")
    def scale_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleVarInput")
    def scale_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c31dae0f58076e39575661aa7d8ebb86e2e8c2a80dbefbe3a910a64243ecd7b9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5da34c0d734f6dec7658f66b58c5721e6a7c6376944e83cda5c29f1c7aeb391f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="placement")
    def placement(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placement"))

    @placement.setter
    def placement(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__152e47a55d33850bbb778bd793bcbe5c225a17e633f368ec7023538d2846e041)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placement", value)

    @builtins.property
    @jsii.member(jsii_name="placementVar")
    def placement_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placementVar"))

    @placement_var.setter
    def placement_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a1f50e51f646a59d6aeaa757329da9a4bc6ff61e79245c099a3db0d47738969)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placementVar", value)

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scale"))

    @scale.setter
    def scale(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1482a8e0867bc0e38f1e3a14a85c85cd3c32dd4d4c5e84d16f5efe78b5ae2d32)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scale", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimension")
    def scale_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimension"))

    @scale_dimension.setter
    def scale_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__03409d6c1d918c081574b971d71bd1a653d8cfe8bbbfae6f968c02fbc5bd7987)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimension", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVar")
    def scale_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimensionVar"))

    @scale_dimension_var.setter
    def scale_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c102d16b911e7149a5939e3ae56888bfeb0876909256a009b3bd8bc7396ed4d3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="scaleVar")
    def scale_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleVar"))

    @scale_var.setter
    def scale_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__16b985a15d2f1a53c9f6f1c0c2cfca520aa79961139e45d57f658266fb4fe168)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b80a959909d26690ccb9307d53a3098ad49d72508ac127f52cfa648113494594)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f9226c1317212c04dca032f7fe979495962c9818a452649bb7eda30ab9b9a17f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3183282273159462095f9495c3a522eaf603c826c75cf535053cb4069d2fedcb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__553b8f253f85707ac5d6b896987f5f6e142590f55382ba49ff0b21da2c4b28af)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationComposite]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationComposite]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationComposite]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__83995c12d27d4c63f6a42da51a0f283b91cb2d11ece7c3cbd2903879565d6bd4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationCompound",
    jsii_struct_bases=[],
    name_mapping={"transformations": "transformations"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationCompound:
    def __init__(
        self,
        *,
        transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param transformations: transformations block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__09e3a109dfb3ef91b331d2fa1bcb6af831ab114ca46d4766ad9667230a8c005c)
            check_type(argname="argument transformations", value=transformations, expected_type=type_hints["transformations"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if transformations is not None:
            self._values["transformations"] = transformations

    @builtins.property
    def transformations(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationCompoundTransformations"]]]:
        '''transformations block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        result = self._values.get("transformations")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationCompoundTransformations"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationCompound(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationCompoundList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationCompoundList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__014824bb1490c195b429baa58db1235ab181f6b3fe2e4d58d06d491ef055445e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationCompoundOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__94930a70ffe86c6dad3330fe59b57033f88e913857c5760b6b07135e184e9103)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationCompoundOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6751f68cd546c65ab66f3685d50e44fdb670abbc10bc3e67a3654ff5f0daa48b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d3dbee138205a80750dc80da087d19d7ab7a4be5f82d065ea9439beae90781d1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__00fad4bc3c54a75aa617d8afcc6b551ded0fe999f0e5423d8c96b5045b0c773e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationCompound]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationCompound]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__42255988ef2a8986ae37d816d9dd8d45a7ec45cf7176f90ecf5b2d46b9cb1d98)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationCompoundOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationCompoundOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__24852093336d4944d2915f7c8ee3691e8bffddd4fcaac841f93c31387f466d47)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformations")
    def put_transformations(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__510c4cc658bc0eea9427fef9cc0d3f40b6a99f638a78059d38250008891376f2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTransformations", [value]))

    @jsii.member(jsii_name="resetTransformations")
    def reset_transformations(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformations", []))

    @builtins.property
    @jsii.member(jsii_name="transformations")
    def transformations(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationCompoundTransformationsList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationCompoundTransformationsList", jsii.get(self, "transformations"))

    @builtins.property
    @jsii.member(jsii_name="transformationsInput")
    def transformations_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationCompoundTransformations"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationCompoundTransformations"]]], jsii.get(self, "transformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationCompound]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationCompound]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationCompound]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c84a686521814e3e939d1acdd84dd90f4114733af95fa84c40de86d112d97d2b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationCompoundTransformations",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationCompoundTransformations:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationCompoundTransformations(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationCompoundTransformationsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationCompoundTransformationsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c87e07907e1a7668dbc5408b393c1b10c7955b74d13132d8f71d9db97011a8c8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationCompoundTransformationsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3fdc6b3e05262d3b6dc47973c55e7c511b7315073e3a687cd7c03a4f1e532aed)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationCompoundTransformationsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a3ea3dcd614d99d485e664c580e6da6decb5403cd1c1944887aa83d8eea5966f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a8b70986045953d4ad71314bd397a0cf163f3840dcbad6a632d5e43a157eeefe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0db20ce85ac57c75be83042b479c03b1d40c78755fe751cfeeaaefbe9a29ad0d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationCompoundTransformations]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationCompoundTransformations]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationCompoundTransformations]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__916170b17b1c875f07fe01755a8ae38683ba36ecc6d19f9433d0c4a87274e2f0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationCompoundTransformationsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationCompoundTransformationsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4c660e8e8a96983e776cf33a191f505c29efeb5cbf9233ef5b9400dd3d62c133)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationCompoundTransformations]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationCompoundTransformations]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationCompoundTransformations]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a66c362791430066569bcdfef07dabea018351d46b566486335994f2f20f9a8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationContrast",
    jsii_struct_bases=[],
    name_mapping={
        "brightness": "brightness",
        "brightness_var": "brightnessVar",
        "contrast": "contrast",
        "contrast_var": "contrastVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationContrast:
    def __init__(
        self,
        *,
        brightness: typing.Optional[builtins.str] = None,
        brightness_var: typing.Optional[builtins.str] = None,
        contrast: typing.Optional[builtins.str] = None,
        contrast_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param brightness: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        :param brightness_var: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        :param contrast: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param contrast_var: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ebe98f4b7b88f4d2cc9907c61059e17d98d44ab29f79a3de23c4595b804d4a75)
            check_type(argname="argument brightness", value=brightness, expected_type=type_hints["brightness"])
            check_type(argname="argument brightness_var", value=brightness_var, expected_type=type_hints["brightness_var"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument contrast_var", value=contrast_var, expected_type=type_hints["contrast_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if brightness is not None:
            self._values["brightness"] = brightness
        if brightness_var is not None:
            self._values["brightness_var"] = brightness_var
        if contrast is not None:
            self._values["contrast"] = contrast
        if contrast_var is not None:
            self._values["contrast_var"] = contrast_var

    @builtins.property
    def brightness(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        '''
        result = self._values.get("brightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def brightness_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        '''
        result = self._values.get("brightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        result = self._values.get("contrast_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationContrast(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationContrastList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationContrastList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7fa01967dc56daffb85952195450f976c681c0064869a1873d124a1e606937a6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationContrastOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9cee2219a49a8d9677bcd4dd550a9c54203d8c644332fc758adf52c656b56e79)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationContrastOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0fad0da2cc179ae3b33ace1dd55f8bc1e663b8ff8ee2a3781b578a4ef5598257)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4872683a01b0bde8631ee4fd9bf82abbb3ad02dc943ced1de0564ad5cb6b297b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__004fee243a6bb9c1181b468f3b96a91445094d80d695cb5f620f0a19604e91d0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationContrast]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationContrast]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f7cf03b5eefa296918e5af41bb8a351906a4eb10f7563aeb565951b6e65a243b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationContrastOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationContrastOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb4cfc67d58600931eaffb9c93b8b207b037df4ecea34d4e46cf89220116c72b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetBrightness")
    def reset_brightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightness", []))

    @jsii.member(jsii_name="resetBrightnessVar")
    def reset_brightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightnessVar", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetContrastVar")
    def reset_contrast_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrastVar", []))

    @builtins.property
    @jsii.member(jsii_name="brightnessInput")
    def brightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="brightnessVarInput")
    def brightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastVarInput")
    def contrast_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="brightness")
    def brightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightness"))

    @brightness.setter
    def brightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5de9f745531d80c91f1b4d970ee9a065433da1079104754c68c26dc3713a25e0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightness", value)

    @builtins.property
    @jsii.member(jsii_name="brightnessVar")
    def brightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightnessVar"))

    @brightness_var.setter
    def brightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ecc6a7f36f59da1970e8d431e9e248edf24676882ea98f1ae852370122d13360)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrast"))

    @contrast.setter
    def contrast(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__546ed1a47da94d4f4b24bef7a4df4b945bd3051b77d85318f77e03e9e0652386)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrast", value)

    @builtins.property
    @jsii.member(jsii_name="contrastVar")
    def contrast_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrastVar"))

    @contrast_var.setter
    def contrast_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a4cdfdcbbb29950ed7e6032ff2497d3d5412f3b89246e1abf6220b3c7b78ab7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrastVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationContrast]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationContrast]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationContrast]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2c97a66578d2c47fe1024ee4f59bdb1675de5d23174a413fd197e31a631eee3d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationCrop",
    jsii_struct_bases=[],
    name_mapping={
        "allow_expansion": "allowExpansion",
        "allow_expansion_var": "allowExpansionVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationCrop:
    def __init__(
        self,
        *,
        allow_expansion: typing.Optional[builtins.str] = None,
        allow_expansion_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_expansion: If cropping an area outside of the existing canvas, expands the image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        :param allow_expansion_var: If cropping an area outside of the existing canvas, expands the image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        :param gravity: Frame of reference for X and Y Positions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Frame of reference for X and Y Positions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The number of pixels to crop along the y-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The number of pixels to crop along the y-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The number of pixels to crop along the x-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The number of pixels to crop along the x-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        :param x_position: The x-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ee8343245033a638ae3c3cc1aab14aa1a3c7fd8a921770b32cafe79468b1ce4a)
            check_type(argname="argument allow_expansion", value=allow_expansion, expected_type=type_hints["allow_expansion"])
            check_type(argname="argument allow_expansion_var", value=allow_expansion_var, expected_type=type_hints["allow_expansion_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if allow_expansion is not None:
            self._values["allow_expansion"] = allow_expansion
        if allow_expansion_var is not None:
            self._values["allow_expansion_var"] = allow_expansion_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def allow_expansion(self) -> typing.Optional[builtins.str]:
        '''If cropping an area outside of the existing canvas, expands the image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        '''
        result = self._values.get("allow_expansion")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def allow_expansion_var(self) -> typing.Optional[builtins.str]:
        '''If cropping an area outside of the existing canvas, expands the image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        '''
        result = self._values.get("allow_expansion_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Frame of reference for X and Y Positions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Frame of reference for X and Y Positions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the y-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the y-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the x-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the x-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d2d1c94563fb24303dbb0320e5c37a5fd24187c3cdad9c270568d3c2e14333c1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5115a1b1a1d7683a1ebcf6b36b854c387352d37e571827e4d499eff6ac9ad158)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__57f31881324ca0f62e197158a3b2a4f0d5252103c1f281e770bcbe05701a4022)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8073e660982cece91bb101534d3a96ec2f95c2b0a8b68f38e20e638662653e7e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d4e5feb0264ff1cbbc0de298c3a6a27b46a1dfdf73db4625f24abba1b334dc0c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2374ed5ea683a9cc7817dc3b9d7abd4d5121e8665f10f29cb1a9d74e8f3ca94a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b3bdfbe2f804e1979c9ebfaa82b40b42b61d0dd0215c8862f7a1dc29b6e68b68)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAllowExpansion")
    def reset_allow_expansion(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansion", []))

    @jsii.member(jsii_name="resetAllowExpansionVar")
    def reset_allow_expansion_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansionVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionInput")
    def allow_expansion_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVarInput")
    def allow_expansion_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansion")
    def allow_expansion(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansion"))

    @allow_expansion.setter
    def allow_expansion(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f31b337c91389a8541cccea789d26a002db25a6d25a29287ef8ed3500018422f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansion", value)

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVar")
    def allow_expansion_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansionVar"))

    @allow_expansion_var.setter
    def allow_expansion_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__66bd4f84f12739693257011a49eeead5712afaaba154b644ea1a8755c857a7c7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansionVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__615c58aea73e769b6163fad5e2abe993fc31a75800ccd661d007eb80f318b786)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e61aec581531b20823cfa1cca75f2f30be84afd3c8e60e872f1a867e84ba30e3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f8a05dd36d52db433142cad0d11e181dead5c4f90a599feb2fc9d97bd235f53e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c4db2c936c2b6120bd8f69281bb39ed0f7133191a6785e47d1a975ea37cb8080)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__26423dd5d9179a6f1bf4aa24224f95dbcab2bf415892f57c0ce4e5cbdd216ac5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7c330ab4b6ca3c362f8cbaf5d55418b29bf6f102419d1fc4bdfe5d8e45b31585)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d3d62017a01da4640755ded27f2845c5943a158082be6b1994b336d24842de1d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b5d36242375bb7299368c2bea6a7c03a0a45fbf7edb590c532f02c565911e774)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__299dc202f8755c9169a3baa3ef0e1b65c74a991898f187b00997b6058aece033)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6acf09061410b5da37006486541a6d301cc40651316e8ac0d81e59e4370a6998)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e4703ae6274ecda5f66cf81174c3267ca7c05d3435837445f2abc94efecf6aaf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationFaceCrop",
    jsii_struct_bases=[],
    name_mapping={
        "algorithm": "algorithm",
        "algorithm_var": "algorithmVar",
        "confidence": "confidence",
        "confidence_var": "confidenceVar",
        "fail_gravity": "failGravity",
        "fail_gravity_var": "failGravityVar",
        "focus": "focus",
        "focus_var": "focusVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "padding": "padding",
        "padding_var": "paddingVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationFaceCrop:
    def __init__(
        self,
        *,
        algorithm: typing.Optional[builtins.str] = None,
        algorithm_var: typing.Optional[builtins.str] = None,
        confidence: typing.Optional[builtins.str] = None,
        confidence_var: typing.Optional[builtins.str] = None,
        fail_gravity: typing.Optional[builtins.str] = None,
        fail_gravity_var: typing.Optional[builtins.str] = None,
        focus: typing.Optional[builtins.str] = None,
        focus_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param algorithm: Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm DataAkamaiImagingPolicyImage#algorithm}
        :param algorithm_var: Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm_var DataAkamaiImagingPolicyImage#algorithm_var}
        :param confidence: With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image. Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence DataAkamaiImagingPolicyImage#confidence}
        :param confidence_var: With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image. Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence_var DataAkamaiImagingPolicyImage#confidence_var}
        :param fail_gravity: Controls placement of the crop if Image and Video Manager does not detect any faces in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        :param fail_gravity_var: Controls placement of the crop if Image and Video Manager does not detect any faces in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        :param focus: Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus DataAkamaiImagingPolicyImage#focus}
        :param focus_var: Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus_var DataAkamaiImagingPolicyImage#focus_var}
        :param gravity: Controls placement of the crop. Directions are relative to the face(s) plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Controls placement of the crop. Directions are relative to the face(s) plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param padding: The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        :param style: Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4376399f4e3b2aabb65e2260112cabe3fdd9dad14eab60ad3468aa3c89e6a435)
            check_type(argname="argument algorithm", value=algorithm, expected_type=type_hints["algorithm"])
            check_type(argname="argument algorithm_var", value=algorithm_var, expected_type=type_hints["algorithm_var"])
            check_type(argname="argument confidence", value=confidence, expected_type=type_hints["confidence"])
            check_type(argname="argument confidence_var", value=confidence_var, expected_type=type_hints["confidence_var"])
            check_type(argname="argument fail_gravity", value=fail_gravity, expected_type=type_hints["fail_gravity"])
            check_type(argname="argument fail_gravity_var", value=fail_gravity_var, expected_type=type_hints["fail_gravity_var"])
            check_type(argname="argument focus", value=focus, expected_type=type_hints["focus"])
            check_type(argname="argument focus_var", value=focus_var, expected_type=type_hints["focus_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if algorithm is not None:
            self._values["algorithm"] = algorithm
        if algorithm_var is not None:
            self._values["algorithm_var"] = algorithm_var
        if confidence is not None:
            self._values["confidence"] = confidence
        if confidence_var is not None:
            self._values["confidence_var"] = confidence_var
        if fail_gravity is not None:
            self._values["fail_gravity"] = fail_gravity
        if fail_gravity_var is not None:
            self._values["fail_gravity_var"] = fail_gravity_var
        if focus is not None:
            self._values["focus"] = focus
        if focus_var is not None:
            self._values["focus_var"] = focus_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def algorithm(self) -> typing.Optional[builtins.str]:
        '''Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm DataAkamaiImagingPolicyImage#algorithm}
        '''
        result = self._values.get("algorithm")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def algorithm_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm_var DataAkamaiImagingPolicyImage#algorithm_var}
        '''
        result = self._values.get("algorithm_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def confidence(self) -> typing.Optional[builtins.str]:
        '''With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image.

        Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence DataAkamaiImagingPolicyImage#confidence}
        '''
        result = self._values.get("confidence")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def confidence_var(self) -> typing.Optional[builtins.str]:
        '''With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image.

        Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence_var DataAkamaiImagingPolicyImage#confidence_var}
        '''
        result = self._values.get("confidence_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any faces in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        '''
        result = self._values.get("fail_gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any faces in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        '''
        result = self._values.get("fail_gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def focus(self) -> typing.Optional[builtins.str]:
        '''Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus DataAkamaiImagingPolicyImage#focus}
        '''
        result = self._values.get("focus")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def focus_var(self) -> typing.Optional[builtins.str]:
        '''Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus_var DataAkamaiImagingPolicyImage#focus_var}
        '''
        result = self._values.get("focus_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the face(s) plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the face(s) plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationFaceCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationFaceCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationFaceCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f5fa2d6717a39d10126d1a363898f94ee6988746fdc8fa2cf86f082996643e04)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationFaceCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__40a2b58796c158d08a943ec7c60cc8fbbf12786f3d2a4395ec4913cb565d818e)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationFaceCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__036c0d35a18617df10d557e310004836ce087ab286020643f576393c0287e8f5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5a033410dcf8cc05b276bcb6f56c3f43c8f0099312f0c520ada50726391d7bd3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a12f0db2dc1fae7303e97c45fe9ab99d2378298b7b8ad223c0186b441a2a79dc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationFaceCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationFaceCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationFaceCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3704d4cc509f319702b6fcb7ec0e4da1c5f38e0d31e91999d52f7b0b067a1b40)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationFaceCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationFaceCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__edcf998d2c7e6976b5f741a956e6de7ef0bea38ddebb67154ab5b760efb90cb6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAlgorithm")
    def reset_algorithm(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAlgorithm", []))

    @jsii.member(jsii_name="resetAlgorithmVar")
    def reset_algorithm_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAlgorithmVar", []))

    @jsii.member(jsii_name="resetConfidence")
    def reset_confidence(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetConfidence", []))

    @jsii.member(jsii_name="resetConfidenceVar")
    def reset_confidence_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetConfidenceVar", []))

    @jsii.member(jsii_name="resetFailGravity")
    def reset_fail_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravity", []))

    @jsii.member(jsii_name="resetFailGravityVar")
    def reset_fail_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravityVar", []))

    @jsii.member(jsii_name="resetFocus")
    def reset_focus(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFocus", []))

    @jsii.member(jsii_name="resetFocusVar")
    def reset_focus_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFocusVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="algorithmInput")
    def algorithm_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "algorithmInput"))

    @builtins.property
    @jsii.member(jsii_name="algorithmVarInput")
    def algorithm_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "algorithmVarInput"))

    @builtins.property
    @jsii.member(jsii_name="confidenceInput")
    def confidence_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "confidenceInput"))

    @builtins.property
    @jsii.member(jsii_name="confidenceVarInput")
    def confidence_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "confidenceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityInput")
    def fail_gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityVarInput")
    def fail_gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="focusInput")
    def focus_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "focusInput"))

    @builtins.property
    @jsii.member(jsii_name="focusVarInput")
    def focus_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "focusVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="algorithm")
    def algorithm(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "algorithm"))

    @algorithm.setter
    def algorithm(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d0ba01acfbc4664a7a6bac36f7c106beb1b71c16d90720ccf5488b07f06a34fc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "algorithm", value)

    @builtins.property
    @jsii.member(jsii_name="algorithmVar")
    def algorithm_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "algorithmVar"))

    @algorithm_var.setter
    def algorithm_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7c9da40cead7914bff25db6c8d42edb5835368dd5d3d6ab695a34c39b6167b90)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "algorithmVar", value)

    @builtins.property
    @jsii.member(jsii_name="confidence")
    def confidence(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "confidence"))

    @confidence.setter
    def confidence(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d071a4e0c122b6adce09aa81fa377260bc86a124abdeb22166f52f35afd4829a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "confidence", value)

    @builtins.property
    @jsii.member(jsii_name="confidenceVar")
    def confidence_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "confidenceVar"))

    @confidence_var.setter
    def confidence_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a0ea20e4d6248a3412c396dcdb54b934dfbe8db31bb6e6cff4274f70763e64c8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "confidenceVar", value)

    @builtins.property
    @jsii.member(jsii_name="failGravity")
    def fail_gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravity"))

    @fail_gravity.setter
    def fail_gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__03029c371ed1e4881eb9d8ea87ce73d14024c03a48a2ca3de9eb2570c2637ece)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravity", value)

    @builtins.property
    @jsii.member(jsii_name="failGravityVar")
    def fail_gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravityVar"))

    @fail_gravity_var.setter
    def fail_gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a8afdd94046006cc905262d83f62739c94b4f94b42e81211af867a1c058a44d7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="focus")
    def focus(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "focus"))

    @focus.setter
    def focus(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__717ce34ebbffd0a3242ec7b2a1033183972e9da0fb2425bf4d3fd5d97eee18a2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "focus", value)

    @builtins.property
    @jsii.member(jsii_name="focusVar")
    def focus_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "focusVar"))

    @focus_var.setter
    def focus_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c6994b8b889c44fc1671069ba808662e26bb5e6653ceb7493d13dbc420093ccb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "focusVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__65ca98204e51503aaef7e06997e715c61bfe3a9836790160735a0814eeaa5b86)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e0daea1277cca3f127ced2f297f2cbc7c8b8bfe003d1d1f56bf083d9504b5987)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c0cdcd823b097bbd1d55ebc20d73aea10958e97142bf67c9120d1f5f172cc016)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b97e2f95ba36bfd876b2fd452059a833744157b153c86c9b603206cea1377d89)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__00b0a3f616c36dd927b4ba4da6cc1aef9d6b57cbab6c993899865ef7230f84cd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bd09737dda1b07f2a6d720ce753ffadfe7aa24a5d6f9062d2fc839bef5370156)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__585cc59ba3d2a34a1152972c2174e6724a3e410f5b27e3006ed19ddd2cc4d052)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a74ef451a18ac042970a624a802b0883c59cf1658533b524b3af70780f5afab5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__09536d26c239b5a3fffca2f17039e911fcd1e5b11ba09e6cb1ee29b0d1d22f14)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e4efab23058336bd751407fb4370004cdef027d1fac8b5d3de9a0c158e349da1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationFaceCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationFaceCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationFaceCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bd13de55174b649e1ea7158f5643bcd0c3cd917181360b3116cd1df9f264dfef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationFeatureCrop",
    jsii_struct_bases=[],
    name_mapping={
        "fail_gravity": "failGravity",
        "fail_gravity_var": "failGravityVar",
        "feature_radius": "featureRadius",
        "feature_radius_var": "featureRadiusVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "max_features": "maxFeatures",
        "max_features_var": "maxFeaturesVar",
        "min_feature_quality": "minFeatureQuality",
        "min_feature_quality_var": "minFeatureQualityVar",
        "padding": "padding",
        "padding_var": "paddingVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationFeatureCrop:
    def __init__(
        self,
        *,
        fail_gravity: typing.Optional[builtins.str] = None,
        fail_gravity_var: typing.Optional[builtins.str] = None,
        feature_radius: typing.Optional[builtins.str] = None,
        feature_radius_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        max_features: typing.Optional[builtins.str] = None,
        max_features_var: typing.Optional[builtins.str] = None,
        min_feature_quality: typing.Optional[builtins.str] = None,
        min_feature_quality_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fail_gravity: Controls placement of the crop if Image and Video Manager does not detect any features in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        :param fail_gravity_var: Controls placement of the crop if Image and Video Manager does not detect any features in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        :param feature_radius: The size in pixels of the important features to search for. If identified, two features never appear closer together than this value, ``8.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius DataAkamaiImagingPolicyImage#feature_radius}
        :param feature_radius_var: The size in pixels of the important features to search for. If identified, two features never appear closer together than this value, ``8.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius_var DataAkamaiImagingPolicyImage#feature_radius_var}
        :param gravity: Controls placement of the crop. Directions are relative to the region of interest plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Controls placement of the crop. Directions are relative to the region of interest plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param max_features: The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features DataAkamaiImagingPolicyImage#max_features}
        :param max_features_var: The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features_var DataAkamaiImagingPolicyImage#max_features_var}
        :param min_feature_quality: Determines the minimum quality level of the feature identified. To consider a feature important, the feature needs to surpass this value. Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality DataAkamaiImagingPolicyImage#min_feature_quality}
        :param min_feature_quality_var: Determines the minimum quality level of the feature identified. To consider a feature important, the feature needs to surpass this value. Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality_var DataAkamaiImagingPolicyImage#min_feature_quality_var}
        :param padding: Adds space around the region of interest. The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: Adds space around the region of interest. The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        :param style: Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c95283774828d5625c7edf0bb34564cc47bf00d57e53a584dc236ba8f063aa03)
            check_type(argname="argument fail_gravity", value=fail_gravity, expected_type=type_hints["fail_gravity"])
            check_type(argname="argument fail_gravity_var", value=fail_gravity_var, expected_type=type_hints["fail_gravity_var"])
            check_type(argname="argument feature_radius", value=feature_radius, expected_type=type_hints["feature_radius"])
            check_type(argname="argument feature_radius_var", value=feature_radius_var, expected_type=type_hints["feature_radius_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument max_features", value=max_features, expected_type=type_hints["max_features"])
            check_type(argname="argument max_features_var", value=max_features_var, expected_type=type_hints["max_features_var"])
            check_type(argname="argument min_feature_quality", value=min_feature_quality, expected_type=type_hints["min_feature_quality"])
            check_type(argname="argument min_feature_quality_var", value=min_feature_quality_var, expected_type=type_hints["min_feature_quality_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fail_gravity is not None:
            self._values["fail_gravity"] = fail_gravity
        if fail_gravity_var is not None:
            self._values["fail_gravity_var"] = fail_gravity_var
        if feature_radius is not None:
            self._values["feature_radius"] = feature_radius
        if feature_radius_var is not None:
            self._values["feature_radius_var"] = feature_radius_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if max_features is not None:
            self._values["max_features"] = max_features
        if max_features_var is not None:
            self._values["max_features_var"] = max_features_var
        if min_feature_quality is not None:
            self._values["min_feature_quality"] = min_feature_quality
        if min_feature_quality_var is not None:
            self._values["min_feature_quality_var"] = min_feature_quality_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def fail_gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any features in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        '''
        result = self._values.get("fail_gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any features in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        '''
        result = self._values.get("fail_gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feature_radius(self) -> typing.Optional[builtins.str]:
        '''The size in pixels of the important features to search for.

        If identified, two features never appear closer together than this value, ``8.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius DataAkamaiImagingPolicyImage#feature_radius}
        '''
        result = self._values.get("feature_radius")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feature_radius_var(self) -> typing.Optional[builtins.str]:
        '''The size in pixels of the important features to search for.

        If identified, two features never appear closer together than this value, ``8.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius_var DataAkamaiImagingPolicyImage#feature_radius_var}
        '''
        result = self._values.get("feature_radius_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the region of interest plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the region of interest plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def max_features(self) -> typing.Optional[builtins.str]:
        '''The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features DataAkamaiImagingPolicyImage#max_features}
        '''
        result = self._values.get("max_features")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def max_features_var(self) -> typing.Optional[builtins.str]:
        '''The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features_var DataAkamaiImagingPolicyImage#max_features_var}
        '''
        result = self._values.get("max_features_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def min_feature_quality(self) -> typing.Optional[builtins.str]:
        '''Determines the minimum quality level of the feature identified.

        To consider a feature important, the feature needs to surpass this value.  Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality DataAkamaiImagingPolicyImage#min_feature_quality}
        '''
        result = self._values.get("min_feature_quality")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def min_feature_quality_var(self) -> typing.Optional[builtins.str]:
        '''Determines the minimum quality level of the feature identified.

        To consider a feature important, the feature needs to surpass this value.  Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality_var DataAkamaiImagingPolicyImage#min_feature_quality_var}
        '''
        result = self._values.get("min_feature_quality_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''Adds space around the region of interest.

        The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''Adds space around the region of interest.

        The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationFeatureCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationFeatureCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationFeatureCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d425030acda6592a747bd4dd7125d7f937d5cd8045a446bcf11830a67764f38)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationFeatureCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1e0dc253627deb09b3705534f3c173e7b469fa12ff54a7fd4b368efd599663bd)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationFeatureCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fded53316d585f7136265f033f6426c154f3fb10074488a610028fc8029de157)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6edb9fdad7c1f0d16c8346ac87a8dda9a87aaadf54d1d435161fa5bbca6f9e52)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ea62c43228252a055301961badc283c082a39432337744695d198c5bfde95db)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationFeatureCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationFeatureCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationFeatureCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d01531f92aa14b56d22ba4b6edbd7193720d21f75370bdca8bd1cd4f0f5b1a98)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationFeatureCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationFeatureCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__77b34fcb21b75568b40ff1bd713aaa7556ba7cce2003f302b71f70f933eeb2fa)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetFailGravity")
    def reset_fail_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravity", []))

    @jsii.member(jsii_name="resetFailGravityVar")
    def reset_fail_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravityVar", []))

    @jsii.member(jsii_name="resetFeatureRadius")
    def reset_feature_radius(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureRadius", []))

    @jsii.member(jsii_name="resetFeatureRadiusVar")
    def reset_feature_radius_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureRadiusVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetMaxFeatures")
    def reset_max_features(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxFeatures", []))

    @jsii.member(jsii_name="resetMaxFeaturesVar")
    def reset_max_features_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxFeaturesVar", []))

    @jsii.member(jsii_name="resetMinFeatureQuality")
    def reset_min_feature_quality(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMinFeatureQuality", []))

    @jsii.member(jsii_name="resetMinFeatureQualityVar")
    def reset_min_feature_quality_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMinFeatureQualityVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="failGravityInput")
    def fail_gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityVarInput")
    def fail_gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featureRadiusInput")
    def feature_radius_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featureRadiusInput"))

    @builtins.property
    @jsii.member(jsii_name="featureRadiusVarInput")
    def feature_radius_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featureRadiusVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesInput")
    def max_features_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "maxFeaturesInput"))

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesVarInput")
    def max_features_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "maxFeaturesVarInput"))

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityInput")
    def min_feature_quality_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "minFeatureQualityInput"))

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityVarInput")
    def min_feature_quality_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "minFeatureQualityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravity")
    def fail_gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravity"))

    @fail_gravity.setter
    def fail_gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c8c3088d608630828e9d114e6d7174dfefc640abbbce113a4c8fcbc62e6b643e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravity", value)

    @builtins.property
    @jsii.member(jsii_name="failGravityVar")
    def fail_gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravityVar"))

    @fail_gravity_var.setter
    def fail_gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d901c78b1afadc8497a20a9fc2cd8fd51413298a2ee0b454d808e404c0f0d707)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="featureRadius")
    def feature_radius(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featureRadius"))

    @feature_radius.setter
    def feature_radius(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1a417acfd4675387d426d1e3fdd1df77bd3f0b417ed389331866df4e1a628343)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featureRadius", value)

    @builtins.property
    @jsii.member(jsii_name="featureRadiusVar")
    def feature_radius_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featureRadiusVar"))

    @feature_radius_var.setter
    def feature_radius_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__60deef109d1dcea23d225fe5098813b597a02c3a7b3c37586d0c30b56e2d434f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featureRadiusVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__403042b0e72f66bd956048528ef7c7ff186e0e07a2210a75654c7f538a2d5e37)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9e7b7d5fd239ff8dad32f619a2217d0ca81af1425e701b47be021480c81da573)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5fcdf26ba092cf6ff397feb52cb458e8b39b84b146d0d78cc48a8acd89a3e78e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__210852eb54fc0d68045237fa5e70800deddb5ec6ccba3e1fffada004d7048c1c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="maxFeatures")
    def max_features(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "maxFeatures"))

    @max_features.setter
    def max_features(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__41845d87018858816693caf24a04e37ad19b39a121d57c88dfdbc7865d062c0e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "maxFeatures", value)

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesVar")
    def max_features_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "maxFeaturesVar"))

    @max_features_var.setter
    def max_features_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__63b6140abf6646675f474f9d3c5bdf79315152d2d3882a86fb092d5deea02e7b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "maxFeaturesVar", value)

    @builtins.property
    @jsii.member(jsii_name="minFeatureQuality")
    def min_feature_quality(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "minFeatureQuality"))

    @min_feature_quality.setter
    def min_feature_quality(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c59cef965e94a7ed16aca74dbd6a51d1d3a499e2921a7e4d8bb88d34308ee711)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "minFeatureQuality", value)

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityVar")
    def min_feature_quality_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "minFeatureQualityVar"))

    @min_feature_quality_var.setter
    def min_feature_quality_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a1d846bc9062f70ea0dbe58bb6900519e46b4d881363e5d27a133d7adf29d1f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "minFeatureQualityVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6d505107316960a8c186b03baa077e902b48740c809985ba209879f0758b7b91)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b2ff5d565ec7f394c72388c87972ff39c43f6c513c1679b144f4ca8c0d452894)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__20c92061b04f28e7958c0dcd6d99a35aa55819d9dcd73b0df2738c81004b2bc6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__53194f2f9088bf896b27525bd19b9e6babf79dde92447096a9975ac144f32cf5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__68a11e335cece40b6a85a79edfdd2b9430f5840549143924bd0359f994c8a25d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__28cbda00d93413bef0f9dc9a552bb65e111dd6c0cb738bf9e74d2d53a40f9e92)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationFeatureCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationFeatureCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationFeatureCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cb6e25ebe924f3c534346e22c4f4e0b31dce4d68616b75d23f861483280f3389)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationFitAndFill",
    jsii_struct_bases=[],
    name_mapping={
        "fill_transformation": "fillTransformation",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationFitAndFill:
    def __init__(
        self,
        *,
        fill_transformation: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationFitAndFillFillTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fill_transformation: fill_transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_transformation DataAkamaiImagingPolicyImage#fill_transformation}
        :param height: The height value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The width value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(fill_transformation, dict):
            fill_transformation = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationFitAndFillFillTransformation(**fill_transformation)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7986373c9dbe89e19aaf9ac3b0d86525d1206c375e9bfe5ab18dc0d81c344a01)
            check_type(argname="argument fill_transformation", value=fill_transformation, expected_type=type_hints["fill_transformation"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fill_transformation is not None:
            self._values["fill_transformation"] = fill_transformation
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def fill_transformation(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationFitAndFillFillTransformation"]:
        '''fill_transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_transformation DataAkamaiImagingPolicyImage#fill_transformation}
        '''
        result = self._values.get("fill_transformation")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationFitAndFillFillTransformation"], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationFitAndFill(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationFitAndFillFillTransformation",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationFitAndFillFillTransformation:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationFitAndFillFillTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationFitAndFillFillTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationFitAndFillFillTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__34c06487a6c6f0c014df415969f93f917baf658d0968031fe0855a7ba4881a1f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationFitAndFillFillTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationFitAndFillFillTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationFitAndFillFillTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a50d8aa44519475c1c1908c0cbed579b07ab4115aa3838e52c64cf86e00770e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationFitAndFillList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationFitAndFillList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cf5e4538b09def4d2c466afd931d98c9175dcb1450e7abf42b98da5438fa33eb)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationFitAndFillOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8c98675ee0e86bb0c925bd17b7a541b7581704ec40ae4a5add2660fede10e9ca)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationFitAndFillOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e708485a4efce111fb63a2f450df3f56442bf647de29ac173a437d1d4bc0e1a8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3070ff9d1f32f83ca561ec3669edadc5e325f431411541e996606f61adc9e17c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f58e84cc0b54b04b3b48c45a82e14f41ca2d44edc4c5f93fea43dc3d6b8ef5f1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationFitAndFill]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationFitAndFill]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationFitAndFill]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d0fbf4f4881b8f1922437cc7b5ffaa81f13e19a5b26d93360346be5951643094)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationFitAndFillOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationFitAndFillOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__377bcb011c9d7fbf8b28edf95581f2d5eb078b0c1b381adce57291f43acb24e1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putFillTransformation")
    def put_fill_transformation(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationFitAndFillFillTransformation()

        return typing.cast(None, jsii.invoke(self, "putFillTransformation", [value]))

    @jsii.member(jsii_name="resetFillTransformation")
    def reset_fill_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFillTransformation", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="fillTransformation")
    def fill_transformation(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationFitAndFillFillTransformationOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationFitAndFillFillTransformationOutputReference, jsii.get(self, "fillTransformation"))

    @builtins.property
    @jsii.member(jsii_name="fillTransformationInput")
    def fill_transformation_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationFitAndFillFillTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationFitAndFillFillTransformation], jsii.get(self, "fillTransformationInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1d4949930030adbffcae18d6551bcf0a94dd449f501d29dfca063c34f4c1556f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a906b7a7b13158b04c2d3bf0f54234e1f8c6d8e1f0a1faf0c93b78120e1a3a58)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9b142d9d99228e41124ade58de85f18d80e6c8abb76d75ebc7ec38f20596e510)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b1206148d006539e40be83e48e9b56427b0389e8abe076ecd8c71cdd13d12ac8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationFitAndFill]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationFitAndFill]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationFitAndFill]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c2fb93a672f58cd28ee37d876469a47a7c820524941c52b69fff5fe9a396db03)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationGoop",
    jsii_struct_bases=[],
    name_mapping={
        "chaos": "chaos",
        "chaos_var": "chaosVar",
        "density": "density",
        "density_var": "densityVar",
        "power": "power",
        "power_var": "powerVar",
        "seed": "seed",
        "seed_var": "seedVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationGoop:
    def __init__(
        self,
        *,
        chaos: typing.Optional[builtins.str] = None,
        chaos_var: typing.Optional[builtins.str] = None,
        density: typing.Optional[builtins.str] = None,
        density_var: typing.Optional[builtins.str] = None,
        power: typing.Optional[builtins.str] = None,
        power_var: typing.Optional[builtins.str] = None,
        seed: typing.Optional[builtins.str] = None,
        seed_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param chaos: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        :param chaos_var: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        :param density: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        :param density_var: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        :param power: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        :param power_var: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        :param seed: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        :param seed_var: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f563ce6279decd830b874ffb4d0cc16e7ac26b0e1a1eee5a38be27ab8906adb9)
            check_type(argname="argument chaos", value=chaos, expected_type=type_hints["chaos"])
            check_type(argname="argument chaos_var", value=chaos_var, expected_type=type_hints["chaos_var"])
            check_type(argname="argument density", value=density, expected_type=type_hints["density"])
            check_type(argname="argument density_var", value=density_var, expected_type=type_hints["density_var"])
            check_type(argname="argument power", value=power, expected_type=type_hints["power"])
            check_type(argname="argument power_var", value=power_var, expected_type=type_hints["power_var"])
            check_type(argname="argument seed", value=seed, expected_type=type_hints["seed"])
            check_type(argname="argument seed_var", value=seed_var, expected_type=type_hints["seed_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if chaos is not None:
            self._values["chaos"] = chaos
        if chaos_var is not None:
            self._values["chaos_var"] = chaos_var
        if density is not None:
            self._values["density"] = density
        if density_var is not None:
            self._values["density_var"] = density_var
        if power is not None:
            self._values["power"] = power
        if power_var is not None:
            self._values["power_var"] = power_var
        if seed is not None:
            self._values["seed"] = seed
        if seed_var is not None:
            self._values["seed_var"] = seed_var

    @builtins.property
    def chaos(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        '''
        result = self._values.get("chaos")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def chaos_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        '''
        result = self._values.get("chaos_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        '''
        result = self._values.get("density")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density_var(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        '''
        result = self._values.get("density_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        '''
        result = self._values.get("power")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power_var(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        '''
        result = self._values.get("power_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        '''
        result = self._values.get("seed")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed_var(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        result = self._values.get("seed_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationGoop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationGoopList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationGoopList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5c9a5af309b0c787b69084f45b447e69ef78aef134d126b9e8df00691dd40221)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationGoopOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af0ec0ba28e755ab0b6aca05186f641fd3c2d89d2a1bacf81a7dbbdbe0c06a99)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationGoopOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a3e120fd5df0efa04fd2014c5634511a7b8e9ad249d1d101e964625b759c434f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c71e2dd04db7aa1f30ffa60f5e0a720b4e698c2119a4fe75a0124e60c95a22cb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5b59c18ef9fd7d03e624bb725f6f354f57b9f6c8213345e02ef766518567ce6b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationGoop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationGoop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2921d87399c5a1876a9a06b94d345512aad7444260ba21a8c9d042dea54a691f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationGoopOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationGoopOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb0f5824553b98da5cc81582848bee3ca371eedadb0a9acd76111623c7d7eb78)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetChaos")
    def reset_chaos(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaos", []))

    @jsii.member(jsii_name="resetChaosVar")
    def reset_chaos_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaosVar", []))

    @jsii.member(jsii_name="resetDensity")
    def reset_density(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensity", []))

    @jsii.member(jsii_name="resetDensityVar")
    def reset_density_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensityVar", []))

    @jsii.member(jsii_name="resetPower")
    def reset_power(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPower", []))

    @jsii.member(jsii_name="resetPowerVar")
    def reset_power_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPowerVar", []))

    @jsii.member(jsii_name="resetSeed")
    def reset_seed(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeed", []))

    @jsii.member(jsii_name="resetSeedVar")
    def reset_seed_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeedVar", []))

    @builtins.property
    @jsii.member(jsii_name="chaosInput")
    def chaos_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosInput"))

    @builtins.property
    @jsii.member(jsii_name="chaosVarInput")
    def chaos_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosVarInput"))

    @builtins.property
    @jsii.member(jsii_name="densityInput")
    def density_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityInput"))

    @builtins.property
    @jsii.member(jsii_name="densityVarInput")
    def density_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="powerInput")
    def power_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerInput"))

    @builtins.property
    @jsii.member(jsii_name="powerVarInput")
    def power_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerVarInput"))

    @builtins.property
    @jsii.member(jsii_name="seedInput")
    def seed_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedInput"))

    @builtins.property
    @jsii.member(jsii_name="seedVarInput")
    def seed_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedVarInput"))

    @builtins.property
    @jsii.member(jsii_name="chaos")
    def chaos(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaos"))

    @chaos.setter
    def chaos(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5cfb63ede2bf517e0346220be903444d9a577775ae795cde20f45e3002f91ff5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaos", value)

    @builtins.property
    @jsii.member(jsii_name="chaosVar")
    def chaos_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaosVar"))

    @chaos_var.setter
    def chaos_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ddbc7c0f5ac2ee3cabb0907b18b0d06a99a384ac5a2f42506552b430902b0766)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaosVar", value)

    @builtins.property
    @jsii.member(jsii_name="density")
    def density(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "density"))

    @density.setter
    def density(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ef6181ff8cd24d79997e825aa9dadc19ec3b2a4b2b1a1beddaa96057e104c5c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "density", value)

    @builtins.property
    @jsii.member(jsii_name="densityVar")
    def density_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "densityVar"))

    @density_var.setter
    def density_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__74ce8f333ed62f7ce6dfdfa3476dd7034bcc9d16a1cd894103f0e1195b2c8981)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "densityVar", value)

    @builtins.property
    @jsii.member(jsii_name="power")
    def power(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "power"))

    @power.setter
    def power(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a28e1d55c7beb44533be9cf1594527b075137c01c804d5948f5293f11edca12)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "power", value)

    @builtins.property
    @jsii.member(jsii_name="powerVar")
    def power_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "powerVar"))

    @power_var.setter
    def power_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3f8832702a78669efe0f148cf4332f5c0b1a777cfd3ae289879d7e1302c2ae95)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "powerVar", value)

    @builtins.property
    @jsii.member(jsii_name="seed")
    def seed(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seed"))

    @seed.setter
    def seed(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bee9afb2e161d2a37bc86e1cd425f6db3914a7939ffcb09fecfeabb254049492)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seed", value)

    @builtins.property
    @jsii.member(jsii_name="seedVar")
    def seed_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seedVar"))

    @seed_var.setter
    def seed_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__97224ba100b19c0669ecf2d54242a8d9b13af7a566ad34401509adf93626e7ea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seedVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationGoop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationGoop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationGoop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__77cd0d2722936aaf15b732642a5ec43599d00aa3301d9bca01413624c7ff80e6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationGrayscale",
    jsii_struct_bases=[],
    name_mapping={"type": "type", "type_var": "typeVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationGrayscale:
    def __init__(
        self,
        *,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param type: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fd638e9021a4c2b0078e5fcb2a8543fb3e6452704abf6879d10494d087c3618c)
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationGrayscale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationGrayscaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationGrayscaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0819cccf4688afae1413992eea3b2552250e8bec5d62079355305753839097ea)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationGrayscaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aaa7476ca43a4e07497989764081f86139b72de048b2c06f946f17a1a4f5639f)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationGrayscaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9f3b491ad0d98e89eebcb5776ce3ee778d3dd123983b43b5e824ea18f45c1cda)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__565f8673a8983e3d55d0517e53d68d83f2f52d909a1553d80f7dc43dc17186b5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8b7c3a3c26c698fa6294e59578a0c84e0f1dc8e2b1922b78aef64e0ee15f2235)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationGrayscale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationGrayscale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0eb7b468f6f812bf82954c6768a66fda04a70a424b6e906b5d5c987dea2473a4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationGrayscaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationGrayscaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c56ea82755d3943879f3c6aa344107ed128a0a0f544b222e9fe8a1bec9c53132)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fbde28bc890ca6028df54afe109d7c51c932345979696afaa36db9cfc9150067)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d4a78be88b1464bdbe07bed5af9eb3c187949e64636bfe9dd278d82463039aa4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationGrayscale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationGrayscale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationGrayscale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3c1b13ec42fad652a2956e1844aa91a6b7c3e97c9de1c0c589f660101360583b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationHsl",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "lightness": "lightness",
        "lightness_var": "lightnessVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationHsl:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness: typing.Optional[builtins.str] = None,
        lightness_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        :param lightness_var: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__90d612381ed592375330b6b0ab49ca6e671128a26db244d1c26a35c0f97e7bf1)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness", value=lightness, expected_type=type_hints["lightness"])
            check_type(argname="argument lightness_var", value=lightness_var, expected_type=type_hints["lightness_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness is not None:
            self._values["lightness"] = lightness
        if lightness_var is not None:
            self._values["lightness_var"] = lightness_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        '''
        result = self._values.get("lightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        '''
        result = self._values.get("lightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationHsl(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationHslList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationHslList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__87ab83f7442b378e95f524b219f9e802df2b1cffe73a76f931a4b9f483046cc5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationHslOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__76fc5504dc2a6f3143387f036733ae1c6f1614dae20c20415811ff7abba8ab66)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationHslOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__99d948d51f1358454f40001de4d0b9f11ec2f3120d2d0fb5e2efeed09429237b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7ae5329eb339023866695317f0d50b3f64c3b493d6e6f817e9c63d9935a5d371)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__66241e21d133d72fe80d59f30532d1ab83d5763750b82d82dbcd5a6192bf1f64)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationHsl]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationHsl]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b0a6dd070d7292b4a8ccc105d0c278880edef57a01e92df69d3dbe4aed46452a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationHslOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationHslOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd656963ebc330ebe1ab1effedf7a5b950b2c93aa1334a9b2f79ceb093146dc5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightness")
    def reset_lightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightness", []))

    @jsii.member(jsii_name="resetLightnessVar")
    def reset_lightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessInput")
    def lightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessVarInput")
    def lightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__698d05fa772e2bc429f2019a75f0a146215fa70df23b3e31b3ad037ba91c4d85)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2727b62512c52266afef123b25f5de8a3eb1d228aea45f4442d1dc0108e16eb1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightness")
    def lightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightness"))

    @lightness.setter
    def lightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__459f68b91e3892fb8c441b357419476cc7a5f6ab8995a5369727b9f50537b5c0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightness", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessVar")
    def lightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessVar"))

    @lightness_var.setter
    def lightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3227a751406611739024989b89e8c32005ba786c2c39b0e9d714ae0344f2693e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fe5363b13983101123cb93a558bd8b81dffb22e11ab093ce8086e89da0a5360a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__51d2d67fdfa5efb5d77b413542294b38e113b7be1a516549b38a6da27feaa5cf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationHsl]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationHsl]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationHsl]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b5d7ddddd3a655a24ad95b186fc97b062432c93f049917090a5e025169f20198)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationHsv",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationHsv:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        :param value: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4fe5096e143b27f1e1a661c094b9689dd6e826fc2f75fcdfc996ccdd8fcc917d)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationHsv(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationHsvList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationHsvList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d20d95715f488f0794a97b6a1db7000cdfd64e299fab221fb9a37779f3ae6543)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationHsvOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a19043c0be5d29311c4c5045b4f35098fd67438b259257c88b0a1a45c25f99ea)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationHsvOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__93fcb6056491143738826d3252e796d19210fbb143fed5f870d8c45692d6b18c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4cb2dd311e1b28187f1ca12a54a84b1e6682867c91fa41760863b8ad418db2fa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a09e0202bc93b5a9df855b92b45a012d36d93a0d1089e10468091fe1288136dc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationHsv]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationHsv]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c444bfe6d4a70debd874884c17071dc2a8c00982a9c0be806da756616b86ed05)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationHsvOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationHsvOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__57dad4f59d3d74c8694305218a610bf50a8d4b637d4bd9b5bf6a45c66c04f24d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9f21ed19a554c9d86033807b4b2758cb1ff7b898103765b3ad562c84770c44b7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df3da4d69e1df710d33b143c6117d31388c4236bdf0907f4cd4a432d0ab3904d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b5a81e0d5484213ed10e3f4d460d7c6359af154c990c67460d9b65920516633e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__188c1e93f036e1597e82d8e9c80f1efb2a5cb2c524701488103e986ccae41306)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__13b5a7e00db02cb890c562804e1e93d48fa8369b75a62136bdd5fa7affbd1e10)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__860be918bb3a9ddc27ab513505f92ab9dd752cdb92d451e772b860fa4ef5caf8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationHsv]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationHsv]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationHsv]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7be100c33542b89063485fc7d963f4d2c75163b4b065941fe1aac05e609eee40)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfDimension",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "dimension": "dimension",
        "dimension_var": "dimensionVar",
        "equal": "equal",
        "greater_than": "greaterThan",
        "less_than": "lessThan",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfDimension:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfDimensionDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        dimension: typing.Optional[builtins.str] = None,
        dimension_var: typing.Optional[builtins.str] = None,
        equal: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfDimensionEqual", typing.Dict[builtins.str, typing.Any]]] = None,
        greater_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfDimensionGreaterThan", typing.Dict[builtins.str, typing.Any]]] = None,
        less_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfDimensionLessThan", typing.Dict[builtins.str, typing.Any]]] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param dimension: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        :param dimension_var: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        :param equal: equal block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        :param greater_than: greater_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        :param less_than: less_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        :param value: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfDimensionDefault(**default)
        if isinstance(equal, dict):
            equal = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfDimensionEqual(**equal)
        if isinstance(greater_than, dict):
            greater_than = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfDimensionGreaterThan(**greater_than)
        if isinstance(less_than, dict):
            less_than = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfDimensionLessThan(**less_than)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__58819759185c2dd49e7255d35da0e10ce825baf5203d02e44d87c0ecef21300d)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument dimension", value=dimension, expected_type=type_hints["dimension"])
            check_type(argname="argument dimension_var", value=dimension_var, expected_type=type_hints["dimension_var"])
            check_type(argname="argument equal", value=equal, expected_type=type_hints["equal"])
            check_type(argname="argument greater_than", value=greater_than, expected_type=type_hints["greater_than"])
            check_type(argname="argument less_than", value=less_than, expected_type=type_hints["less_than"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if dimension is not None:
            self._values["dimension"] = dimension
        if dimension_var is not None:
            self._values["dimension_var"] = dimension_var
        if equal is not None:
            self._values["equal"] = equal
        if greater_than is not None:
            self._values["greater_than"] = greater_than
        if less_than is not None:
            self._values["less_than"] = less_than
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfDimensionDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfDimensionDefault"], result)

    @builtins.property
    def dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        '''
        result = self._values.get("dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        '''
        result = self._values.get("dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def equal(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfDimensionEqual"]:
        '''equal block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        '''
        result = self._values.get("equal")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfDimensionEqual"], result)

    @builtins.property
    def greater_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfDimensionGreaterThan"]:
        '''greater_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        '''
        result = self._values.get("greater_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfDimensionGreaterThan"], result)

    @builtins.property
    def less_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfDimensionLessThan"]:
        '''less_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        '''
        result = self._values.get("less_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfDimensionLessThan"], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfDimension(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfDimensionDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfDimensionDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfDimensionDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfDimensionDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfDimensionDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__312bcac7f9a3379ed760bb01ad0812971ecf797d8266938ed143b9384dd9ba0d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfDimensionDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfDimensionDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1a15cd393972661921e65dea9cda1ab227c13c8e46004eefbecdc1f70617f9ed)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfDimensionEqual",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfDimensionEqual:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfDimensionEqual(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfDimensionEqualOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfDimensionEqualOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ee158c967ce6556dac3ffaf7f92c805bf7f908eea6fa47670e56ecaed24757a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfDimensionEqual], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfDimensionEqual],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__91ef4663f37cc7c3e3c5e59e03fb8e08803acc26bb33d7d3381f0cf3b3fe34bb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfDimensionGreaterThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfDimensionGreaterThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfDimensionGreaterThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfDimensionGreaterThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfDimensionGreaterThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d92b9ea9622a3efb0e388831360fb381030f09f15f5652332dd036f689267184)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfDimensionGreaterThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfDimensionGreaterThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d3407b09e6140eb1e42f1176c93c1b70411fb9d996e806c072ba0635f94c4198)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfDimensionLessThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfDimensionLessThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfDimensionLessThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfDimensionLessThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfDimensionLessThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d2ce4f9883fab94e2e3bb6fdc8cb64e6c700f421964e887809d7ac554436855e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfDimensionLessThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfDimensionLessThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__583595842e58746c6aa4219d36b352a4b917d361ac597d72abc6004e27ce26f9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfDimensionList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfDimensionList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a559db3a05acee78160adf6545addb9afd5e2d5b8a693417bc5436a0578148ab)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfDimensionOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b2f7fb61406023e7e35c4bd670f3b388db08f33f62485effac30c673fc041bb2)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfDimensionOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__69ee9366f44a6cfb0fe76aa261cc6698a69a5dafe46f0cebf80f9afa54301ace)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7c53f68e49e752bfc1a1c837107230cde523215c9b82d92beeffbe93af8fad83)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2804199d2776d436c33158aac47334c90126b0f23815f153562dcb8c35f9e427)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfDimension]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfDimension]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fc5af52b9c7accd100686e6785e8d79ef4f498dce0f8ce005dc8ac97a2a704a0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfDimensionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfDimensionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4086c233555c42d3e942033f90ac78fb4b0390240a28a3fe101812c4d6f80304)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfDimensionDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putEqual")
    def put_equal(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfDimensionEqual()

        return typing.cast(None, jsii.invoke(self, "putEqual", [value]))

    @jsii.member(jsii_name="putGreaterThan")
    def put_greater_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfDimensionGreaterThan()

        return typing.cast(None, jsii.invoke(self, "putGreaterThan", [value]))

    @jsii.member(jsii_name="putLessThan")
    def put_less_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfDimensionLessThan()

        return typing.cast(None, jsii.invoke(self, "putLessThan", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetDimension")
    def reset_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimension", []))

    @jsii.member(jsii_name="resetDimensionVar")
    def reset_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimensionVar", []))

    @jsii.member(jsii_name="resetEqual")
    def reset_equal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEqual", []))

    @jsii.member(jsii_name="resetGreaterThan")
    def reset_greater_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGreaterThan", []))

    @jsii.member(jsii_name="resetLessThan")
    def reset_less_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLessThan", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfDimensionDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfDimensionDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="equal")
    def equal(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfDimensionEqualOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfDimensionEqualOutputReference, jsii.get(self, "equal"))

    @builtins.property
    @jsii.member(jsii_name="greaterThan")
    def greater_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfDimensionGreaterThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfDimensionGreaterThanOutputReference, jsii.get(self, "greaterThan"))

    @builtins.property
    @jsii.member(jsii_name="lessThan")
    def less_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfDimensionLessThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfDimensionLessThanOutputReference, jsii.get(self, "lessThan"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfDimensionDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionInput")
    def dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionVarInput")
    def dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="equalInput")
    def equal_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfDimensionEqual], jsii.get(self, "equalInput"))

    @builtins.property
    @jsii.member(jsii_name="greaterThanInput")
    def greater_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfDimensionGreaterThan], jsii.get(self, "greaterThanInput"))

    @builtins.property
    @jsii.member(jsii_name="lessThanInput")
    def less_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfDimensionLessThan], jsii.get(self, "lessThanInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="dimension")
    def dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimension"))

    @dimension.setter
    def dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__658b22bc45931785acbf5c5f56f81a97db8d18df7ffb07823ad843b594a3c11e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimension", value)

    @builtins.property
    @jsii.member(jsii_name="dimensionVar")
    def dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimensionVar"))

    @dimension_var.setter
    def dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a736c6d4874df58e59f2758a5c2401f5c37ebd73dd1657352f5edb8cb2ebc4bc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cc29685226d81469043f1d3479d6ba571130ab7c4867857d6a562b15f42bae4b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b520c3e269163fe303d583b00ea331b3a59f2c4cd080a5721ed74d318b24d280)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfDimension]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfDimension]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfDimension]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__509977350019f49a0f3f7e9adc500627ea497a0879c52c342fc56e7476858eef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfOrientation",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "landscape": "landscape",
        "portrait": "portrait",
        "square": "square",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfOrientation:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfOrientationDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        landscape: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfOrientationLandscape", typing.Dict[builtins.str, typing.Any]]] = None,
        portrait: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfOrientationPortrait", typing.Dict[builtins.str, typing.Any]]] = None,
        square: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfOrientationSquare", typing.Dict[builtins.str, typing.Any]]] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param landscape: landscape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        :param portrait: portrait block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        :param square: square block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfOrientationDefault(**default)
        if isinstance(landscape, dict):
            landscape = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfOrientationLandscape(**landscape)
        if isinstance(portrait, dict):
            portrait = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfOrientationPortrait(**portrait)
        if isinstance(square, dict):
            square = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfOrientationSquare(**square)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__438540bc9a23701972a81aaa2f0153ceb38c9270645dbbfa55cf320bc58351d3)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument landscape", value=landscape, expected_type=type_hints["landscape"])
            check_type(argname="argument portrait", value=portrait, expected_type=type_hints["portrait"])
            check_type(argname="argument square", value=square, expected_type=type_hints["square"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if landscape is not None:
            self._values["landscape"] = landscape
        if portrait is not None:
            self._values["portrait"] = portrait
        if square is not None:
            self._values["square"] = square

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfOrientationDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfOrientationDefault"], result)

    @builtins.property
    def landscape(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfOrientationLandscape"]:
        '''landscape block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        '''
        result = self._values.get("landscape")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfOrientationLandscape"], result)

    @builtins.property
    def portrait(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfOrientationPortrait"]:
        '''portrait block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        '''
        result = self._values.get("portrait")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfOrientationPortrait"], result)

    @builtins.property
    def square(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfOrientationSquare"]:
        '''square block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        result = self._values.get("square")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfOrientationSquare"], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfOrientation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfOrientationDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfOrientationDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfOrientationDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfOrientationDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfOrientationDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__243cc8b19f8d6a849ef00b649a0a18ba6c6616ed1af4b5d7770f913cec8c8cef)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfOrientationDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfOrientationDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__800fb9da6b92e7ab567cf2b97d7732f015b6e63d5b31bc871ce78f4b94b0a75b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfOrientationLandscape",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfOrientationLandscape:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfOrientationLandscape(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfOrientationLandscapeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfOrientationLandscapeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b32cc4079a62e20a8fc4d78c3ffe7b36d4eaf2eea309ae3f194f542792d795b9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfOrientationLandscape], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfOrientationLandscape],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__75eb45e03fa305af1de4ae8c120d76405fc89c340484f63850ff95efc59d3000)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfOrientationList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfOrientationList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1679bad1eb7bde9c44adf7fd5027fc3fb90f672c25ba60de524c4723710a07b1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfOrientationOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__25219b397a5057c2c2b72faefbf867d939ca60bbacaf556001016d746a484e33)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfOrientationOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__12871fc464b1f9e60c3cd255264d4c0d8eba3cfc003867a07cd55f84b955a04d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d3eae0f59332a4e175f270e001b8420cce5c8e983e06158889146e7de71d9079)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__838a89904d1a52bcea47148689c9a47053d2feaa37676e6e84821ddc542ba623)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfOrientation]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfOrientation]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bd8f46a33cc125518f066a1652aa1a9c54accd7f7d27c0c030b0ae6798d9d8d5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfOrientationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfOrientationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__913a7e00a27a1a487e82ac4ed58d98becfff65b74d0482ddf27855038cb9e88c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfOrientationDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putLandscape")
    def put_landscape(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfOrientationLandscape()

        return typing.cast(None, jsii.invoke(self, "putLandscape", [value]))

    @jsii.member(jsii_name="putPortrait")
    def put_portrait(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfOrientationPortrait()

        return typing.cast(None, jsii.invoke(self, "putPortrait", [value]))

    @jsii.member(jsii_name="putSquare")
    def put_square(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfOrientationSquare()

        return typing.cast(None, jsii.invoke(self, "putSquare", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetLandscape")
    def reset_landscape(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLandscape", []))

    @jsii.member(jsii_name="resetPortrait")
    def reset_portrait(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPortrait", []))

    @jsii.member(jsii_name="resetSquare")
    def reset_square(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSquare", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfOrientationDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfOrientationDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="landscape")
    def landscape(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfOrientationLandscapeOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfOrientationLandscapeOutputReference, jsii.get(self, "landscape"))

    @builtins.property
    @jsii.member(jsii_name="portrait")
    def portrait(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfOrientationPortraitOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfOrientationPortraitOutputReference", jsii.get(self, "portrait"))

    @builtins.property
    @jsii.member(jsii_name="square")
    def square(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfOrientationSquareOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfOrientationSquareOutputReference", jsii.get(self, "square"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfOrientationDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="landscapeInput")
    def landscape_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfOrientationLandscape], jsii.get(self, "landscapeInput"))

    @builtins.property
    @jsii.member(jsii_name="portraitInput")
    def portrait_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfOrientationPortrait"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfOrientationPortrait"], jsii.get(self, "portraitInput"))

    @builtins.property
    @jsii.member(jsii_name="squareInput")
    def square_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfOrientationSquare"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfOrientationSquare"], jsii.get(self, "squareInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfOrientation]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfOrientation]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfOrientation]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dfd88b722a327063a540ca525158680a3f7fe61b654d9daa9bcb430248db5584)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfOrientationPortrait",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfOrientationPortrait:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfOrientationPortrait(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfOrientationPortraitOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfOrientationPortraitOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__550a14106d1030338338098df65a3b4dac7601753e46102036817ffcef39c3a4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfOrientationPortrait]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfOrientationPortrait], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfOrientationPortrait],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b43fbe7c7da94a780e66bd0b24bb1e661c80a19b11423478ab1d2632518854ac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfOrientationSquare",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfOrientationSquare:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfOrientationSquare(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfOrientationSquareOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfOrientationSquareOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f810f18c85a4e75de97b547d0d76124ba8c5127b44ae382892e8db93eaf1d627)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfOrientationSquare]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfOrientationSquare], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfOrientationSquare],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5a493d84f22d100b677678ce7048705df007a103633c4f64318dcde2c406a27e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationImQuery",
    jsii_struct_bases=[],
    name_mapping={
        "allowed_transformations": "allowedTransformations",
        "query_var": "queryVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationImQuery:
    def __init__(
        self,
        *,
        allowed_transformations: typing.Sequence[builtins.str],
        query_var: builtins.str,
    ) -> None:
        '''
        :param allowed_transformations: Specifies the transformations that can be applied using the query string parameter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allowed_transformations DataAkamaiImagingPolicyImage#allowed_transformations}
        :param query_var: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#query_var DataAkamaiImagingPolicyImage#query_var}.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8229596cb52c7c5834f5b61b83116a1e24373aa44cb27d534233a4d4f5e35f90)
            check_type(argname="argument allowed_transformations", value=allowed_transformations, expected_type=type_hints["allowed_transformations"])
            check_type(argname="argument query_var", value=query_var, expected_type=type_hints["query_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "allowed_transformations": allowed_transformations,
            "query_var": query_var,
        }

    @builtins.property
    def allowed_transformations(self) -> typing.List[builtins.str]:
        '''Specifies the transformations that can be applied using the query string parameter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allowed_transformations DataAkamaiImagingPolicyImage#allowed_transformations}
        '''
        result = self._values.get("allowed_transformations")
        assert result is not None, "Required property 'allowed_transformations' is missing"
        return typing.cast(typing.List[builtins.str], result)

    @builtins.property
    def query_var(self) -> builtins.str:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#query_var DataAkamaiImagingPolicyImage#query_var}.'''
        result = self._values.get("query_var")
        assert result is not None, "Required property 'query_var' is missing"
        return typing.cast(builtins.str, result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationImQuery(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationImQueryList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationImQueryList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6ce49df65923109b450b662f7e493c579cfb641ce6d1508719ac28adddb903d5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationImQueryOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f2db23f6fbbaa2eb637f6792871bfefdc1fe65484439901429f280a0dc686d35)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationImQueryOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__48cb197314251cf7dde03c4796a18ab5d422f1340add057051b07cb2c2afc278)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0df9d26f25ad0b54187794488306a0c862034c6f26884f7ca6f799a631a5e8c5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ff9247fca4ce1d55a569a67a0ee618e4a410039ea2e3d9285becc8553cce989b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationImQuery]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationImQuery]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationImQuery]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9844af6d1c79d2af54c66e881b3e8266074cd250bb209dbfd5bd882e7d788cf2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationImQueryOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationImQueryOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a877a3682c837d6193a3a1ff81f19c84d71ce8deb91d9b03df26e8e7c051d662)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @builtins.property
    @jsii.member(jsii_name="allowedTransformationsInput")
    def allowed_transformations_input(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "allowedTransformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="queryVarInput")
    def query_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "queryVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowedTransformations")
    def allowed_transformations(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "allowedTransformations"))

    @allowed_transformations.setter
    def allowed_transformations(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c61ac6ab396bdc1e745cec985eba1cf9a09c3ecddb5910cbaa2bc131e2f1a6cd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowedTransformations", value)

    @builtins.property
    @jsii.member(jsii_name="queryVar")
    def query_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "queryVar"))

    @query_var.setter
    def query_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2aa01eba8fa3bd33044523354c8f33604ec29744c19d275557b4b8097a7ce76b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "queryVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationImQuery]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationImQuery]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationImQuery]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e3b22e8d948aa581c9182864cca5e59af08bf18dd6ce6e1889cc76af9f5e43f6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationMaxColors",
    jsii_struct_bases=[],
    name_mapping={"colors": "colors", "colors_var": "colorsVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationMaxColors:
    def __init__(
        self,
        *,
        colors: typing.Optional[builtins.str] = None,
        colors_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param colors: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        :param colors_var: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9693bb3e1541bfdfdef057c5e4d4c69657e825a2fb612e8cbc292b28e210ef84)
            check_type(argname="argument colors", value=colors, expected_type=type_hints["colors"])
            check_type(argname="argument colors_var", value=colors_var, expected_type=type_hints["colors_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if colors is not None:
            self._values["colors"] = colors
        if colors_var is not None:
            self._values["colors_var"] = colors_var

    @builtins.property
    def colors(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        '''
        result = self._values.get("colors")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def colors_var(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        result = self._values.get("colors_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationMaxColors(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationMaxColorsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationMaxColorsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__24d92b02f03ab9d7951e244007e04ffa7580c142e3255bca704b9d431c8abe20)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationMaxColorsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__615b12bb794142dcfb5bdf061823753b9626be2271595c706e0ca38004df91cf)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationMaxColorsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d5b7992a3bfa3000189cb3b936d309153003216f5c6d4c9019dcfa119e5b8102)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b925fde5999f57f585105199d513f6a2ff3937eccddc413f873f6b5b987481ea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__01bc923c42c8fbd375faa6a2908b1b87a2325be91e90de24734a9bb2e2c5fcb2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationMaxColors]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationMaxColors]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b8420f729931f8a86dd85b9b64294ce0c87e08db94c94dc9f8bd355c9a190cd2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationMaxColorsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationMaxColorsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__41033391fac377e625f9d3d0c0313f1b9c4b2f3b1b9ad07dbcb661d0daa8087f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColors")
    def reset_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColors", []))

    @jsii.member(jsii_name="resetColorsVar")
    def reset_colors_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorsVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorsInput")
    def colors_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsInput"))

    @builtins.property
    @jsii.member(jsii_name="colorsVarInput")
    def colors_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsVarInput"))

    @builtins.property
    @jsii.member(jsii_name="colors")
    def colors(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colors"))

    @colors.setter
    def colors(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b0b443b25e95d20a38272e2cd88466fa0c68ad7bd678180c670121e75029ccae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colors", value)

    @builtins.property
    @jsii.member(jsii_name="colorsVar")
    def colors_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorsVar"))

    @colors_var.setter
    def colors_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6cca139888b503907f1c9e84987db7626ebd18e6f9713df3ea02a556d944fd6a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorsVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationMaxColors]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationMaxColors]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationMaxColors]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9fcb4c9844eb7f1bb31068a64a7c4ec7e9353080a1830964793f670156071956)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationMirror",
    jsii_struct_bases=[],
    name_mapping={
        "horizontal": "horizontal",
        "horizontal_var": "horizontalVar",
        "vertical": "vertical",
        "vertical_var": "verticalVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationMirror:
    def __init__(
        self,
        *,
        horizontal: typing.Optional[builtins.str] = None,
        horizontal_var: typing.Optional[builtins.str] = None,
        vertical: typing.Optional[builtins.str] = None,
        vertical_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param horizontal: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        :param horizontal_var: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        :param vertical: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        :param vertical_var: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f561d9f2b1a06ab972ac197cf24c7921369858283391aaedab84e631fc2ccc4d)
            check_type(argname="argument horizontal", value=horizontal, expected_type=type_hints["horizontal"])
            check_type(argname="argument horizontal_var", value=horizontal_var, expected_type=type_hints["horizontal_var"])
            check_type(argname="argument vertical", value=vertical, expected_type=type_hints["vertical"])
            check_type(argname="argument vertical_var", value=vertical_var, expected_type=type_hints["vertical_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if horizontal is not None:
            self._values["horizontal"] = horizontal
        if horizontal_var is not None:
            self._values["horizontal_var"] = horizontal_var
        if vertical is not None:
            self._values["vertical"] = vertical
        if vertical_var is not None:
            self._values["vertical_var"] = vertical_var

    @builtins.property
    def horizontal(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        '''
        result = self._values.get("horizontal")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def horizontal_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        '''
        result = self._values.get("horizontal_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        '''
        result = self._values.get("vertical")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        result = self._values.get("vertical_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationMirror(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationMirrorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationMirrorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4c56598fb73d826b5049d9d60d632e612dcab23846e74f8d081688b1938154b1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationMirrorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5d50b1292251712080c7bc9ca6cb6666cbaf46ddbfcb69c2c6e788e6b2ade5ee)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationMirrorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea4ca9e0f035b33f6ad28e1f3ed1fec47bba17ad489585c8c8fa067d16b601d7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__84091c538cd212dca8b8452abbf41e28e6889c011317fa3c35a02ffa96236f10)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__16b131170dead02967e52400403bbaa46950e8ccab5045fc30859cff8b4dfc73)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationMirror]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationMirror]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__55b422f3faf239e0068965547445f0d8fd49a35a765b30f5e56263161cab5c6e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationMirrorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationMirrorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4d79daaa69153a14ff39edc9c0c5b6612f8ef68ed92d50fa36982b11a62f3140)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHorizontal")
    def reset_horizontal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontal", []))

    @jsii.member(jsii_name="resetHorizontalVar")
    def reset_horizontal_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontalVar", []))

    @jsii.member(jsii_name="resetVertical")
    def reset_vertical(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVertical", []))

    @jsii.member(jsii_name="resetVerticalVar")
    def reset_vertical_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVerticalVar", []))

    @builtins.property
    @jsii.member(jsii_name="horizontalInput")
    def horizontal_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontalVarInput")
    def horizontal_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalInput")
    def vertical_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalVarInput")
    def vertical_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontal")
    def horizontal(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontal"))

    @horizontal.setter
    def horizontal(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fc1258d8bc76542b277a879fe20f41aad557e69d00ba8253efef3bd65d22834a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontal", value)

    @builtins.property
    @jsii.member(jsii_name="horizontalVar")
    def horizontal_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontalVar"))

    @horizontal_var.setter
    def horizontal_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__faae3106b07ece535b41a6f93b8ac3c9bbb5d4d8a38b02d36a9af5b9b909ca1f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontalVar", value)

    @builtins.property
    @jsii.member(jsii_name="vertical")
    def vertical(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "vertical"))

    @vertical.setter
    def vertical(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ba7c48e1a95ecf9fe3aa6f7271a96e84aee37146f6fb93814d53311f77ea1ba8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "vertical", value)

    @builtins.property
    @jsii.member(jsii_name="verticalVar")
    def vertical_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "verticalVar"))

    @vertical_var.setter
    def vertical_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b9b7f7c3ac114aba3c02d5f6e090a7226c355853c2c8d4fcc8c9bf9d7c686681)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "verticalVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationMirror]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationMirror]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationMirror]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7c58c496dcf79bc235e52fb613f905ac13e07b359f9f85af67e6b814f31511d1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationMonoHue",
    jsii_struct_bases=[],
    name_mapping={"hue": "hue", "hue_var": "hueVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationMonoHue:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f77e934421f55a007876966a5a608db014a878dc113919fa4a1b4775fab77ea)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationMonoHue(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationMonoHueList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationMonoHueList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__648e89d9cd8f4608d82a56021d9fed82fede9439e68f597249b20c8b568aa88d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationMonoHueOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bbeb5fa9f36bb7412d60e4f0400432187b6961fff3b8e7a77fde789dcae3e6a8)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationMonoHueOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8537e3f762603fac046e95c63f287cda0c8ff500a5b630650a6c5e875c3b86c9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__851250303630888086c2d017ac09fef1767fd98d8bc9ce3f0af4f3046e35c6a0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__22b5eb3b02e2302babb97d2ac96931cfda44cba1ae4f50f246ab707efdc7e0ba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationMonoHue]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationMonoHue]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__86c3c2d4666f35df3008949d840e46f8dfb2f5077b7336e1b42b9d272be4d998)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationMonoHueOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationMonoHueOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__970ec8cab2723bd5a8d00d0ca777492863a8b4dab47b022d1a388cdd64ada565)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3d879b0295cd01d47668c9a9fa5b2331401d21f1a11fa017fa4a04288f4be1c3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f35fb57b0474a8a323640d041a0e4347b38b36a3e9593a84efa631bb6daf8534)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationMonoHue]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationMonoHue]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationMonoHue]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f20768e3913e8dec3f6c87398fad5ab139c58693e61ba7b0b592b74d4b60c4e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationOpacity",
    jsii_struct_bases=[],
    name_mapping={"opacity": "opacity", "opacity_var": "opacityVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationOpacity:
    def __init__(
        self,
        *,
        opacity: typing.Optional[builtins.str] = None,
        opacity_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param opacity: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param opacity_var: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2c4a9cbc05f14cee9d6751f9d2125055fc30a6a07df80c7634b5c21f5ad6541b)
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument opacity_var", value=opacity_var, expected_type=type_hints["opacity_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if opacity is not None:
            self._values["opacity"] = opacity
        if opacity_var is not None:
            self._values["opacity_var"] = opacity_var

    @builtins.property
    def opacity(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def opacity_var(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        result = self._values.get("opacity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationOpacity(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationOpacityList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationOpacityList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b5706d828b0736610c0ff9f59f0f18ebccf1dc5c5d9ddb47348e09a212bb5d3f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationOpacityOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab0c14bdba1b48a5cfe4d059181e9125b5c7e7e25b480d9add8cb0f389b34a92)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationOpacityOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b1a87e917bf298b1ba9c28380908c23f5da0cdbd86a5178eedd49468fe6e54d2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f8f0f287b524eb02584011ab091d9a1bbee21bddd43368d7bfaf6c344aa0eda)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__72c23804df87c62063f1039e6f3bd85533bcf225e363d1398580012d531d5177)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationOpacity]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationOpacity]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__12035f617ebea15a5a5420533b585903b1aacb0f46e05a9b599a8d01f491f284)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationOpacityOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationOpacityOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ba82fdb61b7d067988bf868fa86fa0d81061fe74e12dc0b96851c57990832f3e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetOpacityVar")
    def reset_opacity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacityVar", []))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityVarInput")
    def opacity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacity"))

    @opacity.setter
    def opacity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4153ccc21a811d178b40874a1a87e364f3f579f3ae1d6c2f6401088ea0c17484)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacity", value)

    @builtins.property
    @jsii.member(jsii_name="opacityVar")
    def opacity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacityVar"))

    @opacity_var.setter
    def opacity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6bbc056cd47a4ad47630140daecc8b4070b8e3463d41770240e1088cf81b4450)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacityVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationOpacity]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationOpacity]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationOpacity]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__69213ff9f090073eff482ab9953c96747aa407d83e5ff957973102392e255675)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__07eba29310eb061d895f4ebdf9e1d5c836c1746cce4a48913c463937e00a37fb)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putAppend")
    def put_append(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationAppend, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dadf6069f69a51b50646d07b5b08bdda6d6ad5921326f1337dcc03dd4c55ff9b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putAppend", [value]))

    @jsii.member(jsii_name="putAspectCrop")
    def put_aspect_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationAspectCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2764266cc2871ea9c3594c6ea2d29a3b2b9697d3eb6227b41f6daa03f84d8948)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putAspectCrop", [value]))

    @jsii.member(jsii_name="putBackgroundColor")
    def put_background_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__809e3eae74dd9a93c296ab2af533fcf9c21c0d7ae9acf5f945f473a06db37e4c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBackgroundColor", [value]))

    @jsii.member(jsii_name="putBlur")
    def put_blur(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationBlur, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__59ed3f40c8c20b9895023f66acb6ce3f6460f6a379834d0447aee12bb2b9dc72)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBlur", [value]))

    @jsii.member(jsii_name="putChromaKey")
    def put_chroma_key(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationChromaKey, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e2a3ef1a6899e5d0093a3309b95e4a7893611c3bd5d23cf8e42e9519d8249ab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putChromaKey", [value]))

    @jsii.member(jsii_name="putComposite")
    def put_composite(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationComposite, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__094951c72571bcaea01be4d2b743935c2aa9b45b7ac62b9d641ea109b7b412b4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putComposite", [value]))

    @jsii.member(jsii_name="putCompound")
    def put_compound(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationCompound, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__388a8b151a26753c7e816504f5f832ef4bf7503b9c005a17a58c54b6b231b2aa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCompound", [value]))

    @jsii.member(jsii_name="putContrast")
    def put_contrast(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationContrast, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a136e5a9d31f897ce56031e3a328f767471cec0c20ca25d200ef100ffbf90bc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putContrast", [value]))

    @jsii.member(jsii_name="putCrop")
    def put_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cb68b81ccf44ee37a27aff393bdf56b8471bbf4e8533ede3088cc05ca08b726b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCrop", [value]))

    @jsii.member(jsii_name="putFaceCrop")
    def put_face_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationFaceCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0c23c0adebb5a9a587d0b3bcdbfb41f1f42fa5e0f307ab972372aaeecfd5de3c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFaceCrop", [value]))

    @jsii.member(jsii_name="putFeatureCrop")
    def put_feature_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationFeatureCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__69999b83bf4ab87928ffe3e6eec45dc5d506593ebabb94041592f6eb2aab2c3c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFeatureCrop", [value]))

    @jsii.member(jsii_name="putFitAndFill")
    def put_fit_and_fill(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationFitAndFill, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__237c0d1addfcf6e871614ebc0361e65298e98a6caa559311619cde042bb43d31)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFitAndFill", [value]))

    @jsii.member(jsii_name="putGoop")
    def put_goop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationGoop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bd125625543d011ced957a0c2959cf2ffe35152a3ecc5d75eebf7a4ef32e0f69)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGoop", [value]))

    @jsii.member(jsii_name="putGrayscale")
    def put_grayscale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationGrayscale, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4d4adfcf1300c813e024e33a28d2a2c8ca8ab9d19cec3aad36a63e1805e314f7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGrayscale", [value]))

    @jsii.member(jsii_name="putHsl")
    def put_hsl(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationHsl, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a26402cc6f8ba6c8154207c736caaae9ba40efb0b651388edb84fdd6bc2316d3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsl", [value]))

    @jsii.member(jsii_name="putHsv")
    def put_hsv(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationHsv, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__02d82dc03e99a7435541217d1c64d310bd6832276d56ebff1418d4d6da54d883)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsv", [value]))

    @jsii.member(jsii_name="putIfDimension")
    def put_if_dimension(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfDimension, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac6dfc9a111b9e3a05c43231639febb2887b1a2a4c0ba7cad83600e67aafdc9f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfDimension", [value]))

    @jsii.member(jsii_name="putIfOrientation")
    def put_if_orientation(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__99d59d5edee85d800c1f5d56c03fee016d8a535339e0573e4c9c09d13894b7eb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfOrientation", [value]))

    @jsii.member(jsii_name="putImQuery")
    def put_im_query(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationImQuery, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cf496178879c654722b5b2d10cbc65ddb1c8b77f9e3891bc22458fac0ec3d021)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putImQuery", [value]))

    @jsii.member(jsii_name="putMaxColors")
    def put_max_colors(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationMaxColors, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__56dccc710c5f5e81eb12ed3944fa2fbd842236d3f6499beceeacf0188fb2a24e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMaxColors", [value]))

    @jsii.member(jsii_name="putMirror")
    def put_mirror(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationMirror, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8ca45dd44adf7251e74f18c0653afce79c0e9e42e944db88f0f1cb4a750b3beb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMirror", [value]))

    @jsii.member(jsii_name="putMonoHue")
    def put_mono_hue(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationMonoHue, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f68744da72076b31482752771b57e3834bbbf0116507641aa6b226faeb588015)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMonoHue", [value]))

    @jsii.member(jsii_name="putOpacity")
    def put_opacity(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationOpacity, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1b8b317b10c7e64c50565fc1481d322307b0fd3d66f6c3fcf029fc357266c5d0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putOpacity", [value]))

    @jsii.member(jsii_name="putRegionOfInterestCrop")
    def put_region_of_interest_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationRegionOfInterestCrop", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__736f443828d77e03313f84b53b749033ccd34ae65593b9be81dd11bfabf21650)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRegionOfInterestCrop", [value]))

    @jsii.member(jsii_name="putRelativeCrop")
    def put_relative_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationRelativeCrop", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1eeb267e32eec2611b6632d3016693f5730fc2b10a94a2435f4a6925437988e9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRelativeCrop", [value]))

    @jsii.member(jsii_name="putRemoveColor")
    def put_remove_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationRemoveColor", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a703b1b95b488c9c6ac0efda243c0ccd444e4ae36065be75d6e2577acbf90381)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRemoveColor", [value]))

    @jsii.member(jsii_name="putResize")
    def put_resize(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationResize", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2afb0eb9590b12d8ae737d0df71156d50d056fcd31bdd36fc6ac1a5fbfdad2e1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putResize", [value]))

    @jsii.member(jsii_name="putRotate")
    def put_rotate(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationRotate", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6bf07098d29fccb49e2c4d4f79af7ad101ac7043a37e909ee931b87785a57d0a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRotate", [value]))

    @jsii.member(jsii_name="putScale")
    def put_scale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationScale", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b53c86e5dc4c363a607e00c7bb0d7f90fc4504f844a0d73e2cb6ed9a256ff0ba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putScale", [value]))

    @jsii.member(jsii_name="putShear")
    def put_shear(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationShear", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b39f647759e5d747f440b6cf2f23e43748bacc8f9ab1107647ec179c40f7d1f2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putShear", [value]))

    @jsii.member(jsii_name="putTrim")
    def put_trim(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationTrim", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cb493628ecc534cfa85d853865c4e470459fdefacf36ce1b4741b9d178086ef5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTrim", [value]))

    @jsii.member(jsii_name="putUnsharpMask")
    def put_unsharp_mask(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationUnsharpMask", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ffb00c44b367bdad91175b97960f8275f6d354af7ee1c6d4698d30c827ad8fd7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putUnsharpMask", [value]))

    @jsii.member(jsii_name="resetAppend")
    def reset_append(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAppend", []))

    @jsii.member(jsii_name="resetAspectCrop")
    def reset_aspect_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspectCrop", []))

    @jsii.member(jsii_name="resetBackgroundColor")
    def reset_background_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBackgroundColor", []))

    @jsii.member(jsii_name="resetBlur")
    def reset_blur(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBlur", []))

    @jsii.member(jsii_name="resetChromaKey")
    def reset_chroma_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChromaKey", []))

    @jsii.member(jsii_name="resetComposite")
    def reset_composite(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetComposite", []))

    @jsii.member(jsii_name="resetCompound")
    def reset_compound(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCompound", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetCrop")
    def reset_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCrop", []))

    @jsii.member(jsii_name="resetFaceCrop")
    def reset_face_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFaceCrop", []))

    @jsii.member(jsii_name="resetFeatureCrop")
    def reset_feature_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureCrop", []))

    @jsii.member(jsii_name="resetFitAndFill")
    def reset_fit_and_fill(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFitAndFill", []))

    @jsii.member(jsii_name="resetGoop")
    def reset_goop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGoop", []))

    @jsii.member(jsii_name="resetGrayscale")
    def reset_grayscale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGrayscale", []))

    @jsii.member(jsii_name="resetHsl")
    def reset_hsl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsl", []))

    @jsii.member(jsii_name="resetHsv")
    def reset_hsv(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsv", []))

    @jsii.member(jsii_name="resetIfDimension")
    def reset_if_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfDimension", []))

    @jsii.member(jsii_name="resetIfOrientation")
    def reset_if_orientation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfOrientation", []))

    @jsii.member(jsii_name="resetImQuery")
    def reset_im_query(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetImQuery", []))

    @jsii.member(jsii_name="resetMaxColors")
    def reset_max_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxColors", []))

    @jsii.member(jsii_name="resetMirror")
    def reset_mirror(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMirror", []))

    @jsii.member(jsii_name="resetMonoHue")
    def reset_mono_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonoHue", []))

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetRegionOfInterestCrop")
    def reset_region_of_interest_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRegionOfInterestCrop", []))

    @jsii.member(jsii_name="resetRelativeCrop")
    def reset_relative_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRelativeCrop", []))

    @jsii.member(jsii_name="resetRemoveColor")
    def reset_remove_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRemoveColor", []))

    @jsii.member(jsii_name="resetResize")
    def reset_resize(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetResize", []))

    @jsii.member(jsii_name="resetRotate")
    def reset_rotate(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRotate", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetShear")
    def reset_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetShear", []))

    @jsii.member(jsii_name="resetTrim")
    def reset_trim(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTrim", []))

    @jsii.member(jsii_name="resetUnsharpMask")
    def reset_unsharp_mask(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUnsharpMask", []))

    @builtins.property
    @jsii.member(jsii_name="append")
    def append(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationAppendList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationAppendList, jsii.get(self, "append"))

    @builtins.property
    @jsii.member(jsii_name="aspectCrop")
    def aspect_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationAspectCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationAspectCropList, jsii.get(self, "aspectCrop"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColor")
    def background_color(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationBackgroundColorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationBackgroundColorList, jsii.get(self, "backgroundColor"))

    @builtins.property
    @jsii.member(jsii_name="blur")
    def blur(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationBlurList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationBlurList, jsii.get(self, "blur"))

    @builtins.property
    @jsii.member(jsii_name="chromaKey")
    def chroma_key(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationChromaKeyList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationChromaKeyList, jsii.get(self, "chromaKey"))

    @builtins.property
    @jsii.member(jsii_name="composite")
    def composite(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationCompositeList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationCompositeList, jsii.get(self, "composite"))

    @builtins.property
    @jsii.member(jsii_name="compound")
    def compound(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationCompoundList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationCompoundList, jsii.get(self, "compound"))

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationContrastList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationContrastList, jsii.get(self, "contrast"))

    @builtins.property
    @jsii.member(jsii_name="crop")
    def crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationCropList, jsii.get(self, "crop"))

    @builtins.property
    @jsii.member(jsii_name="faceCrop")
    def face_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationFaceCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationFaceCropList, jsii.get(self, "faceCrop"))

    @builtins.property
    @jsii.member(jsii_name="featureCrop")
    def feature_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationFeatureCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationFeatureCropList, jsii.get(self, "featureCrop"))

    @builtins.property
    @jsii.member(jsii_name="fitAndFill")
    def fit_and_fill(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationFitAndFillList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationFitAndFillList, jsii.get(self, "fitAndFill"))

    @builtins.property
    @jsii.member(jsii_name="goop")
    def goop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationGoopList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationGoopList, jsii.get(self, "goop"))

    @builtins.property
    @jsii.member(jsii_name="grayscale")
    def grayscale(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationGrayscaleList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationGrayscaleList, jsii.get(self, "grayscale"))

    @builtins.property
    @jsii.member(jsii_name="hsl")
    def hsl(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationHslList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationHslList, jsii.get(self, "hsl"))

    @builtins.property
    @jsii.member(jsii_name="hsv")
    def hsv(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationHsvList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationHsvList, jsii.get(self, "hsv"))

    @builtins.property
    @jsii.member(jsii_name="ifDimension")
    def if_dimension(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfDimensionList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfDimensionList, jsii.get(self, "ifDimension"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientation")
    def if_orientation(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfOrientationList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfOrientationList, jsii.get(self, "ifOrientation"))

    @builtins.property
    @jsii.member(jsii_name="imQuery")
    def im_query(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationImQueryList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationImQueryList, jsii.get(self, "imQuery"))

    @builtins.property
    @jsii.member(jsii_name="maxColors")
    def max_colors(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationMaxColorsList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationMaxColorsList, jsii.get(self, "maxColors"))

    @builtins.property
    @jsii.member(jsii_name="mirror")
    def mirror(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationMirrorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationMirrorList, jsii.get(self, "mirror"))

    @builtins.property
    @jsii.member(jsii_name="monoHue")
    def mono_hue(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationMonoHueList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationMonoHueList, jsii.get(self, "monoHue"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationOpacityList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationOpacityList, jsii.get(self, "opacity"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestCrop")
    def region_of_interest_crop(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationRegionOfInterestCropList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationRegionOfInterestCropList", jsii.get(self, "regionOfInterestCrop"))

    @builtins.property
    @jsii.member(jsii_name="relativeCrop")
    def relative_crop(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationRelativeCropList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationRelativeCropList", jsii.get(self, "relativeCrop"))

    @builtins.property
    @jsii.member(jsii_name="removeColor")
    def remove_color(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationRemoveColorList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationRemoveColorList", jsii.get(self, "removeColor"))

    @builtins.property
    @jsii.member(jsii_name="resize")
    def resize(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationResizeList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationResizeList", jsii.get(self, "resize"))

    @builtins.property
    @jsii.member(jsii_name="rotate")
    def rotate(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationRotateList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationRotateList", jsii.get(self, "rotate"))

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationScaleList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationScaleList", jsii.get(self, "scale"))

    @builtins.property
    @jsii.member(jsii_name="shear")
    def shear(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationShearList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationShearList", jsii.get(self, "shear"))

    @builtins.property
    @jsii.member(jsii_name="trim")
    def trim(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationTrimList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationTrimList", jsii.get(self, "trim"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMask")
    def unsharp_mask(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationUnsharpMaskList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationUnsharpMaskList", jsii.get(self, "unsharpMask"))

    @builtins.property
    @jsii.member(jsii_name="appendInput")
    def append_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationAppend]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationAppend]]], jsii.get(self, "appendInput"))

    @builtins.property
    @jsii.member(jsii_name="aspectCropInput")
    def aspect_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationAspectCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationAspectCrop]]], jsii.get(self, "aspectCropInput"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColorInput")
    def background_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationBackgroundColor]]], jsii.get(self, "backgroundColorInput"))

    @builtins.property
    @jsii.member(jsii_name="blurInput")
    def blur_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationBlur]]], jsii.get(self, "blurInput"))

    @builtins.property
    @jsii.member(jsii_name="chromaKeyInput")
    def chroma_key_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationChromaKey]]], jsii.get(self, "chromaKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="compositeInput")
    def composite_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationComposite]]], jsii.get(self, "compositeInput"))

    @builtins.property
    @jsii.member(jsii_name="compoundInput")
    def compound_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationCompound]]], jsii.get(self, "compoundInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationContrast]]], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="cropInput")
    def crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationCrop]]], jsii.get(self, "cropInput"))

    @builtins.property
    @jsii.member(jsii_name="faceCropInput")
    def face_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationFaceCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationFaceCrop]]], jsii.get(self, "faceCropInput"))

    @builtins.property
    @jsii.member(jsii_name="featureCropInput")
    def feature_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationFeatureCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationFeatureCrop]]], jsii.get(self, "featureCropInput"))

    @builtins.property
    @jsii.member(jsii_name="fitAndFillInput")
    def fit_and_fill_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationFitAndFill]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationFitAndFill]]], jsii.get(self, "fitAndFillInput"))

    @builtins.property
    @jsii.member(jsii_name="goopInput")
    def goop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationGoop]]], jsii.get(self, "goopInput"))

    @builtins.property
    @jsii.member(jsii_name="grayscaleInput")
    def grayscale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationGrayscale]]], jsii.get(self, "grayscaleInput"))

    @builtins.property
    @jsii.member(jsii_name="hslInput")
    def hsl_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationHsl]]], jsii.get(self, "hslInput"))

    @builtins.property
    @jsii.member(jsii_name="hsvInput")
    def hsv_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationHsv]]], jsii.get(self, "hsvInput"))

    @builtins.property
    @jsii.member(jsii_name="ifDimensionInput")
    def if_dimension_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfDimension]]], jsii.get(self, "ifDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientationInput")
    def if_orientation_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfOrientation]]], jsii.get(self, "ifOrientationInput"))

    @builtins.property
    @jsii.member(jsii_name="imQueryInput")
    def im_query_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationImQuery]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationImQuery]]], jsii.get(self, "imQueryInput"))

    @builtins.property
    @jsii.member(jsii_name="maxColorsInput")
    def max_colors_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationMaxColors]]], jsii.get(self, "maxColorsInput"))

    @builtins.property
    @jsii.member(jsii_name="mirrorInput")
    def mirror_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationMirror]]], jsii.get(self, "mirrorInput"))

    @builtins.property
    @jsii.member(jsii_name="monoHueInput")
    def mono_hue_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationMonoHue]]], jsii.get(self, "monoHueInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationOpacity]]], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestCropInput")
    def region_of_interest_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationRegionOfInterestCrop"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationRegionOfInterestCrop"]]], jsii.get(self, "regionOfInterestCropInput"))

    @builtins.property
    @jsii.member(jsii_name="relativeCropInput")
    def relative_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationRelativeCrop"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationRelativeCrop"]]], jsii.get(self, "relativeCropInput"))

    @builtins.property
    @jsii.member(jsii_name="removeColorInput")
    def remove_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationRemoveColor"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationRemoveColor"]]], jsii.get(self, "removeColorInput"))

    @builtins.property
    @jsii.member(jsii_name="resizeInput")
    def resize_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationResize"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationResize"]]], jsii.get(self, "resizeInput"))

    @builtins.property
    @jsii.member(jsii_name="rotateInput")
    def rotate_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationRotate"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationRotate"]]], jsii.get(self, "rotateInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationScale"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationScale"]]], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="shearInput")
    def shear_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationShear"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationShear"]]], jsii.get(self, "shearInput"))

    @builtins.property
    @jsii.member(jsii_name="trimInput")
    def trim_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationTrim"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationTrim"]]], jsii.get(self, "trimInput"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMaskInput")
    def unsharp_mask_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationUnsharpMask"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationUnsharpMask"]]], jsii.get(self, "unsharpMaskInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3d1a23c741c09be259867b480f344d382b8b3e3344b05c8df78035ee3007e776)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationRegionOfInterestCrop",
    jsii_struct_bases=[],
    name_mapping={
        "region_of_interest": "regionOfInterest",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationRegionOfInterestCrop:
    def __init__(
        self,
        *,
        region_of_interest: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationRegionOfInterestCropRegionOfInterest", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param region_of_interest: region_of_interest block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest DataAkamaiImagingPolicyImage#region_of_interest}
        :param gravity: The placement of the crop area relative to the specified area of interest. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: The placement of the crop area relative to the specified area of interest. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param style: Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(region_of_interest, dict):
            region_of_interest = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationRegionOfInterestCropRegionOfInterest(**region_of_interest)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a952edda8d305ff0cc1ddd2cd21b650135105d8998b9c4d021a70a8897b0e538)
            check_type(argname="argument region_of_interest", value=region_of_interest, expected_type=type_hints["region_of_interest"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "region_of_interest": region_of_interest,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def region_of_interest(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationRegionOfInterestCropRegionOfInterest":
        '''region_of_interest block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest DataAkamaiImagingPolicyImage#region_of_interest}
        '''
        result = self._values.get("region_of_interest")
        assert result is not None, "Required property 'region_of_interest' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationRegionOfInterestCropRegionOfInterest", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''The placement of the crop area relative to the specified area of interest.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''The placement of the crop area relative to the specified area of interest.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationRegionOfInterestCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationRegionOfInterestCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationRegionOfInterestCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__93aa8b5110387fa4f11b1d14820bdb95f839139980d091efa916c76cecb8c89c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationRegionOfInterestCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cecf2dd6eed02c9abb4f868795392decef280c6d769b9e94f9a260af6876edb4)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationRegionOfInterestCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__92802343bb32dca59eb2b23b80364c27f12849f383762db5c6e0f7667051b3cb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a7b722799aa417da854953abec27dc7d3c2870119464e915ad902357e994ad17)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__edcda98981cc433facd16515434f4537987fe81209762e11ced83d25c8a92205)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationRegionOfInterestCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationRegionOfInterestCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationRegionOfInterestCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e366b8eb7541cd927a07cb5bd239acd92f94f32e254bb4d88364c779ca7decfa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationRegionOfInterestCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationRegionOfInterestCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac515b81724e4a43201b90bb849232afc9292cff5924f470d31e2205eab92a97)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putRegionOfInterest")
    def put_region_of_interest(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationRegionOfInterestCropRegionOfInterest()

        return typing.cast(None, jsii.invoke(self, "putRegionOfInterest", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterest")
    def region_of_interest(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestOutputReference", jsii.get(self, "regionOfInterest"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestInput")
    def region_of_interest_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationRegionOfInterestCropRegionOfInterest"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationRegionOfInterestCropRegionOfInterest"], jsii.get(self, "regionOfInterestInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0bf118b84be17aa3895cc7bb8c6fd435116ba8d7c48d3435964fad64ca0ad8ac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e37add6f530a0cfdeabbe2e29047581ca5fb5cfff6b552879a16f98434128fb3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2be40aef1b3271cf89d937d650f07c3c701a0aafa44c6a105959e56e2ecb78f1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e51994f11549e5345ff88307d21311538c37e60611be839a24de58ce3b8d8128)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a1a7531ad899790311a39227fc26f5eda37e51464d4afc0b7e70bfa1de0abdf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c6ce055f6eaee64fdbddb72cf627b68017685810f01b5a8991f8211ca634b7b7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__34628081db93003c64a4dd5014f39e7ee3317a1cceee55d6e4c6c7d2b5204d78)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__12236367a34d54293e673ec84a5a4dc2fda90fad3691da47783a035803d04bf4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationRegionOfInterestCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationRegionOfInterestCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationRegionOfInterestCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__32e82d93215738ceefb7efa6f236135b9eaf36d2cd03cc0d63ba7adca50ebc9a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationRegionOfInterestCropRegionOfInterest",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationRegionOfInterestCropRegionOfInterest:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationRegionOfInterestCropRegionOfInterest(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b4e3b520e5c9c5bd075bcdfcc46505a7f91dd125c01a5a444f41a43904fd29ec)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationRegionOfInterestCropRegionOfInterest]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationRegionOfInterestCropRegionOfInterest], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationRegionOfInterestCropRegionOfInterest],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7cf569606cbf69ec03e144f0829b4e970b4efe0b3d86d09110f990df8a712508)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationRelativeCrop",
    jsii_struct_bases=[],
    name_mapping={
        "east": "east",
        "east_var": "eastVar",
        "north": "north",
        "north_var": "northVar",
        "south": "south",
        "south_var": "southVar",
        "west": "west",
        "west_var": "westVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationRelativeCrop:
    def __init__(
        self,
        *,
        east: typing.Optional[builtins.str] = None,
        east_var: typing.Optional[builtins.str] = None,
        north: typing.Optional[builtins.str] = None,
        north_var: typing.Optional[builtins.str] = None,
        south: typing.Optional[builtins.str] = None,
        south_var: typing.Optional[builtins.str] = None,
        west: typing.Optional[builtins.str] = None,
        west_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param east: The number of pixels to shrink or expand the right side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east DataAkamaiImagingPolicyImage#east}
        :param east_var: The number of pixels to shrink or expand the right side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east_var DataAkamaiImagingPolicyImage#east_var}
        :param north: The number of pixels to shrink or expand the top side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north DataAkamaiImagingPolicyImage#north}
        :param north_var: The number of pixels to shrink or expand the top side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north_var DataAkamaiImagingPolicyImage#north_var}
        :param south: The number of pixels to shrink or expand the bottom side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south DataAkamaiImagingPolicyImage#south}
        :param south_var: The number of pixels to shrink or expand the bottom side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south_var DataAkamaiImagingPolicyImage#south_var}
        :param west: The number of pixels to shrink or expand the left side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west DataAkamaiImagingPolicyImage#west}
        :param west_var: The number of pixels to shrink or expand the left side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west_var DataAkamaiImagingPolicyImage#west_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8f3392d6692cc1ac0f88095e6bf95efdf2d92c15b72b9b9d1d82257bc9462894)
            check_type(argname="argument east", value=east, expected_type=type_hints["east"])
            check_type(argname="argument east_var", value=east_var, expected_type=type_hints["east_var"])
            check_type(argname="argument north", value=north, expected_type=type_hints["north"])
            check_type(argname="argument north_var", value=north_var, expected_type=type_hints["north_var"])
            check_type(argname="argument south", value=south, expected_type=type_hints["south"])
            check_type(argname="argument south_var", value=south_var, expected_type=type_hints["south_var"])
            check_type(argname="argument west", value=west, expected_type=type_hints["west"])
            check_type(argname="argument west_var", value=west_var, expected_type=type_hints["west_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if east is not None:
            self._values["east"] = east
        if east_var is not None:
            self._values["east_var"] = east_var
        if north is not None:
            self._values["north"] = north
        if north_var is not None:
            self._values["north_var"] = north_var
        if south is not None:
            self._values["south"] = south
        if south_var is not None:
            self._values["south_var"] = south_var
        if west is not None:
            self._values["west"] = west
        if west_var is not None:
            self._values["west_var"] = west_var

    @builtins.property
    def east(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the right side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east DataAkamaiImagingPolicyImage#east}
        '''
        result = self._values.get("east")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def east_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the right side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east_var DataAkamaiImagingPolicyImage#east_var}
        '''
        result = self._values.get("east_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def north(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the top side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north DataAkamaiImagingPolicyImage#north}
        '''
        result = self._values.get("north")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def north_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the top side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north_var DataAkamaiImagingPolicyImage#north_var}
        '''
        result = self._values.get("north_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def south(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the bottom side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south DataAkamaiImagingPolicyImage#south}
        '''
        result = self._values.get("south")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def south_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the bottom side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south_var DataAkamaiImagingPolicyImage#south_var}
        '''
        result = self._values.get("south_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def west(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the left side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west DataAkamaiImagingPolicyImage#west}
        '''
        result = self._values.get("west")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def west_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the left side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west_var DataAkamaiImagingPolicyImage#west_var}
        '''
        result = self._values.get("west_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationRelativeCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationRelativeCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationRelativeCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a19ee6cba9054d227bbbe4e860274efd6d4927ec60d6c67678ab54018ac41fb4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationRelativeCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5a291d18d8d5fa4370ed90b63244eace615def5acdae6763768f3a36ae653b6a)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationRelativeCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__02b8c01baa5e90a4acbcc0f85a9720bef3790e830af11f05672a55ef12992fc9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__94ac519411fdc8130bbc92131bb2d73f4b66f6b7e14b616d93aa4b1009a34f1e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9355856f007fc586990c013af1a64ab6d6d7247e93301a14ab41a8aea4cc45ba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationRelativeCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationRelativeCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationRelativeCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2783343610ba5ec40b9ca0cbdad1b01a25e59771fbd316b6e91ba50107533a1d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationRelativeCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationRelativeCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d6fe1476d4cc614739876cba94bec544ea82717c8ef06418b9a8b8f43a652a6f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetEast")
    def reset_east(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEast", []))

    @jsii.member(jsii_name="resetEastVar")
    def reset_east_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEastVar", []))

    @jsii.member(jsii_name="resetNorth")
    def reset_north(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNorth", []))

    @jsii.member(jsii_name="resetNorthVar")
    def reset_north_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNorthVar", []))

    @jsii.member(jsii_name="resetSouth")
    def reset_south(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSouth", []))

    @jsii.member(jsii_name="resetSouthVar")
    def reset_south_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSouthVar", []))

    @jsii.member(jsii_name="resetWest")
    def reset_west(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWest", []))

    @jsii.member(jsii_name="resetWestVar")
    def reset_west_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWestVar", []))

    @builtins.property
    @jsii.member(jsii_name="eastInput")
    def east_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "eastInput"))

    @builtins.property
    @jsii.member(jsii_name="eastVarInput")
    def east_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "eastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="northInput")
    def north_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "northInput"))

    @builtins.property
    @jsii.member(jsii_name="northVarInput")
    def north_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "northVarInput"))

    @builtins.property
    @jsii.member(jsii_name="southInput")
    def south_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "southInput"))

    @builtins.property
    @jsii.member(jsii_name="southVarInput")
    def south_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "southVarInput"))

    @builtins.property
    @jsii.member(jsii_name="westInput")
    def west_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "westInput"))

    @builtins.property
    @jsii.member(jsii_name="westVarInput")
    def west_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "westVarInput"))

    @builtins.property
    @jsii.member(jsii_name="east")
    def east(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "east"))

    @east.setter
    def east(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__44bf76063071fde597734420a351a9c79920a7e49d61fe97d391371dba729ecd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "east", value)

    @builtins.property
    @jsii.member(jsii_name="eastVar")
    def east_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "eastVar"))

    @east_var.setter
    def east_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d4b87c0b96c210c39e502e2ddf88ffb5c587a11a01f92250b0be3b33a40980b6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "eastVar", value)

    @builtins.property
    @jsii.member(jsii_name="north")
    def north(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "north"))

    @north.setter
    def north(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__72af2222fa6deb6b4f7f23d96de231ca58a5ebd67e92a324f19a73370b404bb1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "north", value)

    @builtins.property
    @jsii.member(jsii_name="northVar")
    def north_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "northVar"))

    @north_var.setter
    def north_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0bfa4e91aa915925f0b7be003656896b39b2eb8d8bd536e3ab24d4968bffb009)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "northVar", value)

    @builtins.property
    @jsii.member(jsii_name="south")
    def south(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "south"))

    @south.setter
    def south(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__168b1ea5b526a1be65356e69ff93ac8efcea8c062b08d35c67fbd6ef182b1e1a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "south", value)

    @builtins.property
    @jsii.member(jsii_name="southVar")
    def south_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "southVar"))

    @south_var.setter
    def south_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__45b6f7fe7cea660917feb0c2cc7df56118d441782f485784a01c36273908c7bb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "southVar", value)

    @builtins.property
    @jsii.member(jsii_name="west")
    def west(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "west"))

    @west.setter
    def west(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4d118453b7e93ca7121d8ad2e00a77cae4844037bc1f3f98b9f6a6405f81c8b9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "west", value)

    @builtins.property
    @jsii.member(jsii_name="westVar")
    def west_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "westVar"))

    @west_var.setter
    def west_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__73b779bf6d27ad27662c2e82d9bd68a54358ca9dca2a034b58add138ddc8b2c3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "westVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationRelativeCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationRelativeCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationRelativeCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df54f34e0fe0b85fcd0666e7f7241b4ab557598918e30166338298696246146e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationRemoveColor",
    jsii_struct_bases=[],
    name_mapping={
        "color": "color",
        "color_var": "colorVar",
        "feather": "feather",
        "feather_var": "featherVar",
        "tolerance": "tolerance",
        "tolerance_var": "toleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationRemoveColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
        feather: typing.Optional[builtins.str] = None,
        feather_var: typing.Optional[builtins.str] = None,
        tolerance: typing.Optional[builtins.str] = None,
        tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        :param feather: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        :param feather_var: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        :param tolerance: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        :param tolerance_var: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2595ccd92a6fc5304745182ea43541ae97646ecd937b863b497c07036be29d09)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
            check_type(argname="argument feather", value=feather, expected_type=type_hints["feather"])
            check_type(argname="argument feather_var", value=feather_var, expected_type=type_hints["feather_var"])
            check_type(argname="argument tolerance", value=tolerance, expected_type=type_hints["tolerance"])
            check_type(argname="argument tolerance_var", value=tolerance_var, expected_type=type_hints["tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var
        if feather is not None:
            self._values["feather"] = feather
        if feather_var is not None:
            self._values["feather_var"] = feather_var
        if tolerance is not None:
            self._values["tolerance"] = tolerance
        if tolerance_var is not None:
            self._values["tolerance_var"] = tolerance_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        '''
        result = self._values.get("feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather_var(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        '''
        result = self._values.get("feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        '''
        result = self._values.get("tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance_var(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        result = self._values.get("tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationRemoveColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationRemoveColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationRemoveColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b3d2252e5acd166effde30215ac57a198e7735c0fd91de16fe70e5cd996fa5dc)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationRemoveColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3491ebd907d05359024b569a82db6e48baf91fac5f25afd931483c38785a29d8)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationRemoveColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c70331fa77cb71e9e30a590a870424f80003af577d2cb5e927fa99972639f748)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__927f5cdc5e55a94661ba7242547f323aee517e47e5b8a542bf9302aa12857e52)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__784f3ff1df2936acf29f307a8573e436ac41377337b226e4542d0940600929b8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationRemoveColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationRemoveColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationRemoveColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dbed47a062aec92cbcc05be96f253a2b94be6125cab2fa93885ce27b1a3b3849)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationRemoveColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationRemoveColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0240c24efc93278106cb422276f4c82ac2b1fefa0104718885c439dd28f488d9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @jsii.member(jsii_name="resetFeather")
    def reset_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeather", []))

    @jsii.member(jsii_name="resetFeatherVar")
    def reset_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatherVar", []))

    @jsii.member(jsii_name="resetTolerance")
    def reset_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTolerance", []))

    @jsii.member(jsii_name="resetToleranceVar")
    def reset_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featherInput")
    def feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherInput"))

    @builtins.property
    @jsii.member(jsii_name="featherVarInput")
    def feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceInput")
    def tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceVarInput")
    def tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8f8c6495a5263a0a6d4f287bc0260115cb694eaa68a907697990df12baa00bdc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7e0acb5319a51be256083fde63541627eb863ba380c7a3c20df15bd82f686331)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="feather")
    def feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "feather"))

    @feather.setter
    def feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__27541ba5b879cb64315bb2affbf2f49e2bd0d2939e0c0c9ec8d185c85c5ebbff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "feather", value)

    @builtins.property
    @jsii.member(jsii_name="featherVar")
    def feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featherVar"))

    @feather_var.setter
    def feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0178cca2f6efb6cb9621e4e566acad8d9c53b7088a4d0b019728ae3ac8a76be4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featherVar", value)

    @builtins.property
    @jsii.member(jsii_name="tolerance")
    def tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tolerance"))

    @tolerance.setter
    def tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a9a5a2864fde605e08b07e38e33a93dc6e5342865b8a0ca4626d494df3b706fa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tolerance", value)

    @builtins.property
    @jsii.member(jsii_name="toleranceVar")
    def tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "toleranceVar"))

    @tolerance_var.setter
    def tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8dfd41b54141ff0f49711deeacae2b76dc3a6813cc84ecdcf8f3a075f63bff01)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "toleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationRemoveColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationRemoveColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationRemoveColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__864cb0c224ba5d7881b0f7f349445983ca03c2b0332a32c22250edbe855d12d2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationResize",
    jsii_struct_bases=[],
    name_mapping={
        "aspect": "aspect",
        "aspect_var": "aspectVar",
        "height": "height",
        "height_var": "heightVar",
        "type": "type",
        "type_var": "typeVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationResize:
    def __init__(
        self,
        *,
        aspect: typing.Optional[builtins.str] = None,
        aspect_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param aspect: Preserves the aspect ratio. Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect DataAkamaiImagingPolicyImage#aspect}
        :param aspect_var: Preserves the aspect ratio. Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_var DataAkamaiImagingPolicyImage#aspect_var}
        :param height: The height to resize the source image to. Must be set if height is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height to resize the source image to. Must be set if height is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param type: Sets constraints for the image resize. Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: Sets constraints for the image resize. Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        :param width: The width to resize the source image to. Must be set if width is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width to resize the source image to. Must be set if width is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__92a140a2851298893c3dc03d6dd1efa0320ac6ea2c6e91d9bf9aa1d519ec0e28)
            check_type(argname="argument aspect", value=aspect, expected_type=type_hints["aspect"])
            check_type(argname="argument aspect_var", value=aspect_var, expected_type=type_hints["aspect_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if aspect is not None:
            self._values["aspect"] = aspect
        if aspect_var is not None:
            self._values["aspect_var"] = aspect_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def aspect(self) -> typing.Optional[builtins.str]:
        '''Preserves the aspect ratio.

        Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect DataAkamaiImagingPolicyImage#aspect}
        '''
        result = self._values.get("aspect")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def aspect_var(self) -> typing.Optional[builtins.str]:
        '''Preserves the aspect ratio.

        Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_var DataAkamaiImagingPolicyImage#aspect_var}
        '''
        result = self._values.get("aspect_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height to resize the source image to. Must be set if height is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height to resize the source image to. Must be set if height is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''Sets constraints for the image resize.

        Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''Sets constraints for the image resize.

        Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width to resize the source image to. Must be set if width is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width to resize the source image to. Must be set if width is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationResize(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationResizeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationResizeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__13ac1c2923227b616aeee067143e237e5bdca1fab196e4ea7d12a44e6e4ecd04)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationResizeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__44e58bdc0824f519898e8a7fc506c00b87b72f54a17a804a833332b3232b688a)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationResizeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3e1bc449901c173046ff9988187860c7afadc59542a5a0d843d19e575b0cf3ef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2894642bbdd9458ec7c6597afeb57285828f5f2a369b9170d8f93c4f5c6bc818)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dec38efee804cfcd8ac6d4e8fdb584f31f40b314778e11f22410476f78fe57a7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationResize]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationResize]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationResize]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0e05cfb07ce906bd321e9d6437e30a4da12f7e45a9d95386c9b4ad97d8bfe12a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationResizeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationResizeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b8f6ecbe1a15fe2c9b2172f26f82baa521cb23ee023d1ebb1f1afb639e013935)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAspect")
    def reset_aspect(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspect", []))

    @jsii.member(jsii_name="resetAspectVar")
    def reset_aspect_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspectVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="aspectInput")
    def aspect_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "aspectInput"))

    @builtins.property
    @jsii.member(jsii_name="aspectVarInput")
    def aspect_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "aspectVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="aspect")
    def aspect(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "aspect"))

    @aspect.setter
    def aspect(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ef3d18e3616efc076f3a8ba75e66ae84c8be637d419fe299d3da732852bea48e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "aspect", value)

    @builtins.property
    @jsii.member(jsii_name="aspectVar")
    def aspect_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "aspectVar"))

    @aspect_var.setter
    def aspect_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4986c381221e0f84952f6dac50535d43c61bd9ffa2f7a16a0e15035a093e3a6d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "aspectVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d8a35cf66bb4a9dcfee21f3baf1afdc32bdeb3d6f03ea4adc3551f6df59ade63)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__91388528067e9079eeaf5e4a531236986d40bd3eeefde77797fd9bce16d7fa64)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d83b9e75cac329a4bcd5ac92249adb3311f89f6d562c95cebedccc3b44a1f50)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__538e518b7884a0f4c23dd19243b97d433897b459f49e4655538ddd7e8074a23a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__16aa4bdccfe6712cc5ae14720eca253d915a6cdcfc0de57d529517561941be1a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2c5bf5f1860abafa5692e2e8328cb6368a0acf8d74bd6d9b948ab7f921f808e2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationResize]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationResize]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationResize]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ba9ad720f9a9cae34f047c825a663ca558228881366b56b56a742b567e3e4d9a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationRotate",
    jsii_struct_bases=[],
    name_mapping={"degrees": "degrees", "degrees_var": "degreesVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationRotate:
    def __init__(
        self,
        *,
        degrees: typing.Optional[builtins.str] = None,
        degrees_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param degrees: The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees DataAkamaiImagingPolicyImage#degrees}
        :param degrees_var: The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees_var DataAkamaiImagingPolicyImage#degrees_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e6ba9b8d4489afe9dac0fb3354e41283ef4746e7147f1f3ca0c684f443ebdfb4)
            check_type(argname="argument degrees", value=degrees, expected_type=type_hints["degrees"])
            check_type(argname="argument degrees_var", value=degrees_var, expected_type=type_hints["degrees_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if degrees is not None:
            self._values["degrees"] = degrees
        if degrees_var is not None:
            self._values["degrees_var"] = degrees_var

    @builtins.property
    def degrees(self) -> typing.Optional[builtins.str]:
        '''The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees DataAkamaiImagingPolicyImage#degrees}
        '''
        result = self._values.get("degrees")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def degrees_var(self) -> typing.Optional[builtins.str]:
        '''The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees_var DataAkamaiImagingPolicyImage#degrees_var}
        '''
        result = self._values.get("degrees_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationRotate(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationRotateList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationRotateList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d60afce73aa607d75ecb3d5d63de727dfaf93f0f77647e3236021e70b7531b3b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationRotateOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4c97abfea8b17a2f204199791978f118db2527e0a9ca7e112368e331cd090374)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationRotateOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df841329a92e6a1470e3cbe5b0de5c1a13119de2ff63736dd5349ff3c8a23fbb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d78bf1782bf90162fd8260eff94d44a9783c7ed89ddbfe22397fe30cab537094)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fe249575523ba4beffa11f5bcf4910927ac76b01f28dc31851971039b1184619)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationRotate]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationRotate]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationRotate]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__185c57129c9947100e24a3879631efbb06781cca119329842adf60c18daf36fd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationRotateOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationRotateOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8aaa175f573a85882c6fc3a746b4449053cee4ed04b59a2d6d62d579b7991046)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetDegrees")
    def reset_degrees(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDegrees", []))

    @jsii.member(jsii_name="resetDegreesVar")
    def reset_degrees_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDegreesVar", []))

    @builtins.property
    @jsii.member(jsii_name="degreesInput")
    def degrees_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "degreesInput"))

    @builtins.property
    @jsii.member(jsii_name="degreesVarInput")
    def degrees_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "degreesVarInput"))

    @builtins.property
    @jsii.member(jsii_name="degrees")
    def degrees(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "degrees"))

    @degrees.setter
    def degrees(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__abc7d9234500e1d2e70850b08f219f88d438a27cfe7b4ff5b830e16495ef4dad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "degrees", value)

    @builtins.property
    @jsii.member(jsii_name="degreesVar")
    def degrees_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "degreesVar"))

    @degrees_var.setter
    def degrees_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__13a83e7963f494a25f801100c922f04845fd0183be5f157cbad65263c0629b2a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "degreesVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationRotate]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationRotate]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationRotate]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__01fd45b3ff15b3e668ed0ec1ddfcb0eae4961a62fb0b24fb94888cd7a0abee5f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationScale",
    jsii_struct_bases=[],
    name_mapping={
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationScale:
    def __init__(
        self,
        *,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param height: Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged. Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged. Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__51c7589c95fd054caa99c7af3f65d12416a1d90071d259c3f0c5156b44f8f649)
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size.

        Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size.

        Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged.

        Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged.

        Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationScale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationScaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationScaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1233668529620ed8ed0faa1638e9ab0f0754262a759b6a52001c97c196002f05)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationScaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__766b58da8ae5d1926d6cdff5d8ccd9896cfd4904f94c7ca47b2c3d42b824e02d)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationScaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6b87ff8f31b707e0afe38191f9cd127ef20b2714a6e61eab5fd18d27ccb9bf87)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__15a00399670e16477a68272db9e05c9939373baf738e2191faa6fafdcb50aad8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be4bad40f0e3c88532cddf4e386d0ccea86da5bb430618bbeaa42a411308167b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationScale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationScale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationScale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__09fbb87e7df2cccd8045b53a7b4a3b7a25594c9e828002c18f5938276c470fee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationScaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationScaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__275867c05e6a8371ce229fc2cb2ab5847c2715afaaabc48068bbc0f2a030ce69)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b1be46a0381672386ded813b91a28dbb846cce977fec06c008a59f2768ade84a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__00c22a960ab8dbb22e05e0ddadf828fb52b7d720d265efb8d5c40ad4015b590d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c63486e3a7c553368061e8819ae035b4175a82f41f811560000fe807b81974a9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bf4b20e9c39af7aed2d86ad48f7ccba53a2b4972f680f57bacc66094cecc11ee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationScale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationScale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationScale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__82f589f11125c78d6bd53028a07463b0370a88c4ca4741d4f9f5c845eefe2502)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationShear",
    jsii_struct_bases=[],
    name_mapping={
        "x_shear": "xShear",
        "x_shear_var": "xShearVar",
        "y_shear": "yShear",
        "y_shear_var": "yShearVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationShear:
    def __init__(
        self,
        *,
        x_shear: typing.Optional[builtins.str] = None,
        x_shear_var: typing.Optional[builtins.str] = None,
        y_shear: typing.Optional[builtins.str] = None,
        y_shear_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param x_shear: The amount to shear along the x-axis, measured in multiples of the image's width. Must be set if yShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear DataAkamaiImagingPolicyImage#x_shear}
        :param x_shear_var: The amount to shear along the x-axis, measured in multiples of the image's width. Must be set if yShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear_var DataAkamaiImagingPolicyImage#x_shear_var}
        :param y_shear: The amount to shear along the y-axis, measured in multiples of the image's height. Must be set if xShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear DataAkamaiImagingPolicyImage#y_shear}
        :param y_shear_var: The amount to shear along the y-axis, measured in multiples of the image's height. Must be set if xShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear_var DataAkamaiImagingPolicyImage#y_shear_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0f55cc231e189253bda09bc2832b48743cf7bc69fce0b881cbf2f5400dd31e1e)
            check_type(argname="argument x_shear", value=x_shear, expected_type=type_hints["x_shear"])
            check_type(argname="argument x_shear_var", value=x_shear_var, expected_type=type_hints["x_shear_var"])
            check_type(argname="argument y_shear", value=y_shear, expected_type=type_hints["y_shear"])
            check_type(argname="argument y_shear_var", value=y_shear_var, expected_type=type_hints["y_shear_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if x_shear is not None:
            self._values["x_shear"] = x_shear
        if x_shear_var is not None:
            self._values["x_shear_var"] = x_shear_var
        if y_shear is not None:
            self._values["y_shear"] = y_shear
        if y_shear_var is not None:
            self._values["y_shear_var"] = y_shear_var

    @builtins.property
    def x_shear(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the x-axis, measured in multiples of the image's width.

        Must be set if yShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear DataAkamaiImagingPolicyImage#x_shear}
        '''
        result = self._values.get("x_shear")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_shear_var(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the x-axis, measured in multiples of the image's width.

        Must be set if yShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear_var DataAkamaiImagingPolicyImage#x_shear_var}
        '''
        result = self._values.get("x_shear_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_shear(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the y-axis, measured in multiples of the image's height.

        Must be set if xShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear DataAkamaiImagingPolicyImage#y_shear}
        '''
        result = self._values.get("y_shear")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_shear_var(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the y-axis, measured in multiples of the image's height.

        Must be set if xShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear_var DataAkamaiImagingPolicyImage#y_shear_var}
        '''
        result = self._values.get("y_shear_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationShear(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationShearList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationShearList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__925cf6689d68966a8d44adc6b210863a0d2186f4201be2161aa6bec718696355)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationShearOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fb7a3026b347aaeeebe5e3401a251af832dacf5cb8364fc89152f121a9aaafca)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationShearOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2e9923fa975320f92de2b25fb92082177552677ee076f475ac7c126da02a058d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__33db35a391c0ed85ccd16a2fd208ecce9816e1e148dff59e22690795a2782e07)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__27676ff4b9e6fc5eb2d594a34d1a89aa24f525f1626a23d52612158ff8d25535)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationShear]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationShear]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationShear]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ae612d53b8eb71c95408cf0773ffd528b9725da056cd4bd69e64fb66ff417c6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationShearOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationShearOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7793fffd1ea63a5df3fbecba0c718970ca40aebf5747e0433a4ecd76d34bf265)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetXShear")
    def reset_x_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXShear", []))

    @jsii.member(jsii_name="resetXShearVar")
    def reset_x_shear_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXShearVar", []))

    @jsii.member(jsii_name="resetYShear")
    def reset_y_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYShear", []))

    @jsii.member(jsii_name="resetYShearVar")
    def reset_y_shear_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYShearVar", []))

    @builtins.property
    @jsii.member(jsii_name="xShearInput")
    def x_shear_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xShearInput"))

    @builtins.property
    @jsii.member(jsii_name="xShearVarInput")
    def x_shear_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xShearVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yShearInput")
    def y_shear_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yShearInput"))

    @builtins.property
    @jsii.member(jsii_name="yShearVarInput")
    def y_shear_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yShearVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xShear")
    def x_shear(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xShear"))

    @x_shear.setter
    def x_shear(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fd35d191389a4f20dccc6f5d29ed75b3a969226f3ee513b79ff298d440615edf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xShear", value)

    @builtins.property
    @jsii.member(jsii_name="xShearVar")
    def x_shear_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xShearVar"))

    @x_shear_var.setter
    def x_shear_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__84d2430b7f42cf261d8d2d69a6e262c87776a1d99072392a9a45c75b89bfe383)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xShearVar", value)

    @builtins.property
    @jsii.member(jsii_name="yShear")
    def y_shear(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yShear"))

    @y_shear.setter
    def y_shear(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2b59f5670c6e1490e8c227fb2bcbcf620d069aa33550a5892c200dc062dcb205)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yShear", value)

    @builtins.property
    @jsii.member(jsii_name="yShearVar")
    def y_shear_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yShearVar"))

    @y_shear_var.setter
    def y_shear_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be01db728ec622e0905e85705e3e44178e94baaa7206245750d3f004c0acfe9f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yShearVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationShear]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationShear]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationShear]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d8ee8b9048b63cd74fbf3266a53553102ab70c6d36511399d4ee4b8925b9a6a8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationTrim",
    jsii_struct_bases=[],
    name_mapping={
        "fuzz": "fuzz",
        "fuzz_var": "fuzzVar",
        "padding": "padding",
        "padding_var": "paddingVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationTrim:
    def __init__(
        self,
        *,
        fuzz: typing.Optional[builtins.str] = None,
        fuzz_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fuzz: The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz DataAkamaiImagingPolicyImage#fuzz}
        :param fuzz_var: The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz_var DataAkamaiImagingPolicyImage#fuzz_var}
        :param padding: The amount of padding in pixels to add to the trimmed image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: The amount of padding in pixels to add to the trimmed image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__80740edfabcdb06315c4da900bcf8fb78e83ed5160899dffdb2eb437413be0a0)
            check_type(argname="argument fuzz", value=fuzz, expected_type=type_hints["fuzz"])
            check_type(argname="argument fuzz_var", value=fuzz_var, expected_type=type_hints["fuzz_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fuzz is not None:
            self._values["fuzz"] = fuzz
        if fuzz_var is not None:
            self._values["fuzz_var"] = fuzz_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var

    @builtins.property
    def fuzz(self) -> typing.Optional[builtins.str]:
        '''The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz DataAkamaiImagingPolicyImage#fuzz}
        '''
        result = self._values.get("fuzz")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fuzz_var(self) -> typing.Optional[builtins.str]:
        '''The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz_var DataAkamaiImagingPolicyImage#fuzz_var}
        '''
        result = self._values.get("fuzz_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''The amount of padding in pixels to add to the trimmed image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''The amount of padding in pixels to add to the trimmed image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationTrim(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationTrimList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationTrimList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__55881b28e51c04d22ca05a8874bb26e1c089aa5adbbf24458ba6b0e41732e406)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationTrimOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__03902bb04600759c2862ba3fa5320e3e6cea90e6a62a184c134c1367fe265672)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationTrimOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4e051607b4110b2e5b2ea9a932fb57b9e29b73f62f55561d2869c673063c96f0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea44db21ca8ab34387e1de0b6bd554ee76c3fe0ec6c607ada75b803fa568b2bd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3d3b581a182126f0727678d77d9d35167ba10c58493cbe0dfa097ddb28851a58)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationTrim]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationTrim]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationTrim]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__17a1fbf85dad0ab18bf48b7c3428abe2969675428d71911a769d733e8780924d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationTrimOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationTrimOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__849c717f1e5a02978143307aff9bb9235dcf529d97125e613e8a699c9faa7f1e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetFuzz")
    def reset_fuzz(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFuzz", []))

    @jsii.member(jsii_name="resetFuzzVar")
    def reset_fuzz_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFuzzVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @builtins.property
    @jsii.member(jsii_name="fuzzInput")
    def fuzz_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fuzzInput"))

    @builtins.property
    @jsii.member(jsii_name="fuzzVarInput")
    def fuzz_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fuzzVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="fuzz")
    def fuzz(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fuzz"))

    @fuzz.setter
    def fuzz(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e64be3a634a95a66a61538b9eeeef1487e80c4459c4e48c74c9e6f0caabb3a82)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fuzz", value)

    @builtins.property
    @jsii.member(jsii_name="fuzzVar")
    def fuzz_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fuzzVar"))

    @fuzz_var.setter
    def fuzz_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fe74df0d044a36ab248186497713d59946079aa9c3510e70aef1019df24efe35)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fuzzVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eefa2dc342463f31b3867cc9fa3f139ea57c6f584ff74b5f230f08c20a8ecf4b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1990eff664b06d5cfe3def615e8305152175c0c9d895d87450af8f7c785fb849)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationTrim]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationTrim]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationTrim]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__410a69da14fee97681047615c9132cf23d4ae30a045d86265484b3c20b06d441)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationUnsharpMask",
    jsii_struct_bases=[],
    name_mapping={
        "gain": "gain",
        "gain_var": "gainVar",
        "sigma": "sigma",
        "sigma_var": "sigmaVar",
        "threshold": "threshold",
        "threshold_var": "thresholdVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationUnsharpMask:
    def __init__(
        self,
        *,
        gain: typing.Optional[builtins.str] = None,
        gain_var: typing.Optional[builtins.str] = None,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
        threshold: typing.Optional[builtins.str] = None,
        threshold_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param gain: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        :param gain_var: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        :param sigma: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        :param threshold: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        :param threshold_var: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__85613fcf09dad525b6649122eb1028bf8e997d52e9cec8e25e777db2215e67b0)
            check_type(argname="argument gain", value=gain, expected_type=type_hints["gain"])
            check_type(argname="argument gain_var", value=gain_var, expected_type=type_hints["gain_var"])
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
            check_type(argname="argument threshold", value=threshold, expected_type=type_hints["threshold"])
            check_type(argname="argument threshold_var", value=threshold_var, expected_type=type_hints["threshold_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if gain is not None:
            self._values["gain"] = gain
        if gain_var is not None:
            self._values["gain_var"] = gain_var
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var
        if threshold is not None:
            self._values["threshold"] = threshold
        if threshold_var is not None:
            self._values["threshold_var"] = threshold_var

    @builtins.property
    def gain(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        '''
        result = self._values.get("gain")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gain_var(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        '''
        result = self._values.get("gain_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        '''
        result = self._values.get("threshold")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold_var(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        result = self._values.get("threshold_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationUnsharpMask(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationUnsharpMaskList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationUnsharpMaskList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f7bc4b6f80e9f481e97cdb6ada31a982e94b1e7b9dad4d7fe6c7874deda89ca4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationUnsharpMaskOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__24cecda28070d311e04a312f87e9d1235b0e3f053b6f7838212f3e7aba43bef0)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationUnsharpMaskOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ebf85333e22338b234d197d26918dd071ed09d1aaf6cec2932724f4aac704c78)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5d56116150080a929626e469c45f309e59e90f446628b52a7750d78720750ce3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f80981e7beaacc6ed45125632d6e6436e43f1d03dcdea7a416d8f195e305544a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationUnsharpMask]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationUnsharpMask]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationUnsharpMask]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__35d2724878046453c519de2c8b65c74ff4b43fc4acad081ffad38104d5e7a68e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationUnsharpMaskOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationUnsharpMaskOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__85afcd9608ff2be01fcfad605af4c9421ea8adb44a9b59a114ea720fd59582d6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetGain")
    def reset_gain(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGain", []))

    @jsii.member(jsii_name="resetGainVar")
    def reset_gain_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGainVar", []))

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @jsii.member(jsii_name="resetThreshold")
    def reset_threshold(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThreshold", []))

    @jsii.member(jsii_name="resetThresholdVar")
    def reset_threshold_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThresholdVar", []))

    @builtins.property
    @jsii.member(jsii_name="gainInput")
    def gain_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainInput"))

    @builtins.property
    @jsii.member(jsii_name="gainVarInput")
    def gain_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdInput")
    def threshold_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdVarInput")
    def threshold_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gain")
    def gain(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gain"))

    @gain.setter
    def gain(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ef5dc368b0c198521ceda6329eb6830ebce52af8b02b800430c145d2903bb5f0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gain", value)

    @builtins.property
    @jsii.member(jsii_name="gainVar")
    def gain_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gainVar"))

    @gain_var.setter
    def gain_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1934ad2939aeca0eabdc87a760b4c082c63fac670079c0dd0a40d3278180fcf7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gainVar", value)

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc54f97f7935a3fdb252b0352977112eb21ea88e922a73f2a3499a665f199ee5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__76d6eda967fb9df4b904ec34aa2064ca5e4cd6ccad2e9a29d946a09de95731a7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="threshold")
    def threshold(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "threshold"))

    @threshold.setter
    def threshold(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__75faece7f335b7acf616450a440b027c90d94d536d6b95eb10a02a8cca281b04)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "threshold", value)

    @builtins.property
    @jsii.member(jsii_name="thresholdVar")
    def threshold_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "thresholdVar"))

    @threshold_var.setter
    def threshold_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ec9fe5988c553b946a98bf9fb0db6e47184ae488af2ca8f62f97e8ef2d9cbb2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "thresholdVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationUnsharpMask]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationUnsharpMask]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationUnsharpMask]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__49b4d982d2da0d238f5dd0c4916d601752bea53480de839bdcf14d3047c8c027)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__91354dd04d15c5dcacdd6c4b6b58c9b0a5a581379b9ead6438dd247496cf170d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__243110bb3c23280f78c7395cd880a0507777ef74a8c5343b31d0582a89951256)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__10775e3df7eb03b13f0da1d818ea8e19456c92691c924aec1f03662b8bd2128a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dedf652072ad21e83e96a3fb65849b7bee606ad89ddd39b8826d752bfbdb816f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__091bc960ec9b9327c3320971e195788440a75d8da62f45aad13da18c06dba426)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFill]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFill]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFill]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fc0016fd3e16c63e2c51be5d4f7205d0eaa9a159015f27990b1add2fac53e68a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ca43ebf140e0e7a4cddaa2bbd8179221264a0c8ebf85d4a6d9f7b81cc32f62a7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putFillTransformation")
    def put_fill_transformation(
        self,
        *,
        append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationAppend, typing.Dict[builtins.str, typing.Any]]]]] = None,
        aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationAspectCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
        crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationFaceCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationFeatureCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationFitAndFill, typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
        im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationImQuery, typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
        region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationRegionOfInterestCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationRelativeCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
        resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationResize, typing.Dict[builtins.str, typing.Any]]]]] = None,
        rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationRotate, typing.Dict[builtins.str, typing.Any]]]]] = None,
        scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationScale, typing.Dict[builtins.str, typing.Any]]]]] = None,
        shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationShear, typing.Dict[builtins.str, typing.Any]]]]] = None,
        trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationTrim, typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param append: append block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        :param aspect_crop: aspect_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param crop: crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        :param face_crop: face_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        :param feature_crop: feature_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        :param fit_and_fill: fit_and_fill block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param im_query: im_query block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param region_of_interest_crop: region_of_interest_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        :param relative_crop: relative_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param resize: resize block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        :param rotate: rotate block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        :param scale: scale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param shear: shear block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        :param trim: trim block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformation(
            append=append,
            aspect_crop=aspect_crop,
            background_color=background_color,
            blur=blur,
            chroma_key=chroma_key,
            composite=composite,
            compound=compound,
            contrast=contrast,
            crop=crop,
            face_crop=face_crop,
            feature_crop=feature_crop,
            fit_and_fill=fit_and_fill,
            goop=goop,
            grayscale=grayscale,
            hsl=hsl,
            hsv=hsv,
            if_dimension=if_dimension,
            if_orientation=if_orientation,
            im_query=im_query,
            max_colors=max_colors,
            mirror=mirror,
            mono_hue=mono_hue,
            opacity=opacity,
            region_of_interest_crop=region_of_interest_crop,
            relative_crop=relative_crop,
            remove_color=remove_color,
            resize=resize,
            rotate=rotate,
            scale=scale,
            shear=shear,
            trim=trim,
            unsharp_mask=unsharp_mask,
        )

        return typing.cast(None, jsii.invoke(self, "putFillTransformation", [value]))

    @jsii.member(jsii_name="resetFillTransformation")
    def reset_fill_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFillTransformation", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="fillTransformation")
    def fill_transformation(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationOutputReference, jsii.get(self, "fillTransformation"))

    @builtins.property
    @jsii.member(jsii_name="fillTransformationInput")
    def fill_transformation_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformation], jsii.get(self, "fillTransformationInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8f0d51b03debc0806ace7ecacc28e04ccdab041e77ce1faea3006dad417fede8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__54c74669c707d022c71a8f5b67bb6841ad15d47c220a11d391ac375769b5747c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__91129322871f5051301c1e20e12a8b837a0236fb99c44f691120f652944a9c3b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f41552b76065e38c552560814e8bc7d8e3c811accdd165890144333787a296a3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFill]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFill]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFill]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e60d0b88c1055facaa5dfa623fd3c55d22b362ee3c1f450bbd7f1f97dc584403)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualGoop",
    jsii_struct_bases=[],
    name_mapping={
        "chaos": "chaos",
        "chaos_var": "chaosVar",
        "density": "density",
        "density_var": "densityVar",
        "power": "power",
        "power_var": "powerVar",
        "seed": "seed",
        "seed_var": "seedVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualGoop:
    def __init__(
        self,
        *,
        chaos: typing.Optional[builtins.str] = None,
        chaos_var: typing.Optional[builtins.str] = None,
        density: typing.Optional[builtins.str] = None,
        density_var: typing.Optional[builtins.str] = None,
        power: typing.Optional[builtins.str] = None,
        power_var: typing.Optional[builtins.str] = None,
        seed: typing.Optional[builtins.str] = None,
        seed_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param chaos: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        :param chaos_var: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        :param density: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        :param density_var: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        :param power: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        :param power_var: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        :param seed: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        :param seed_var: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a5ff26a315ff481848e33366c5e34a9e27bd0022f4498964cddb141510fbe9b)
            check_type(argname="argument chaos", value=chaos, expected_type=type_hints["chaos"])
            check_type(argname="argument chaos_var", value=chaos_var, expected_type=type_hints["chaos_var"])
            check_type(argname="argument density", value=density, expected_type=type_hints["density"])
            check_type(argname="argument density_var", value=density_var, expected_type=type_hints["density_var"])
            check_type(argname="argument power", value=power, expected_type=type_hints["power"])
            check_type(argname="argument power_var", value=power_var, expected_type=type_hints["power_var"])
            check_type(argname="argument seed", value=seed, expected_type=type_hints["seed"])
            check_type(argname="argument seed_var", value=seed_var, expected_type=type_hints["seed_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if chaos is not None:
            self._values["chaos"] = chaos
        if chaos_var is not None:
            self._values["chaos_var"] = chaos_var
        if density is not None:
            self._values["density"] = density
        if density_var is not None:
            self._values["density_var"] = density_var
        if power is not None:
            self._values["power"] = power
        if power_var is not None:
            self._values["power_var"] = power_var
        if seed is not None:
            self._values["seed"] = seed
        if seed_var is not None:
            self._values["seed_var"] = seed_var

    @builtins.property
    def chaos(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        '''
        result = self._values.get("chaos")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def chaos_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        '''
        result = self._values.get("chaos_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        '''
        result = self._values.get("density")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density_var(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        '''
        result = self._values.get("density_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        '''
        result = self._values.get("power")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power_var(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        '''
        result = self._values.get("power_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        '''
        result = self._values.get("seed")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed_var(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        result = self._values.get("seed_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualGoop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualGoopList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualGoopList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d3d09ae0f0d03bcfb5f00fbef739094b0138da25c3d68acdcac41050c254062f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualGoopOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__45ddba1bc25b8b863243c8ad1e34e30f79ef009424ec5e93417690fe65f39f5d)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualGoopOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3201e5ac768e03640f61edab9be4dcf00439ea2e71e19ae08a1f68441397cf6e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__500ebe4c2e5d12caf9f0c93a25a9519a548e1993f0ae00f1582980b068385f53)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2aa9eeb1c64c573621541cd336e626000bb0bda256b4006c4959617bba152842)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualGoop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualGoop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7c029261d7d7120f41afff6b36282125bedab8dc9cc8a51bac67675bb354969c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualGoopOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualGoopOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4740c61794d4669aac6dbadd237e879626dd8c6619eeb9e98e1e0849da67d357)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetChaos")
    def reset_chaos(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaos", []))

    @jsii.member(jsii_name="resetChaosVar")
    def reset_chaos_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaosVar", []))

    @jsii.member(jsii_name="resetDensity")
    def reset_density(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensity", []))

    @jsii.member(jsii_name="resetDensityVar")
    def reset_density_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensityVar", []))

    @jsii.member(jsii_name="resetPower")
    def reset_power(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPower", []))

    @jsii.member(jsii_name="resetPowerVar")
    def reset_power_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPowerVar", []))

    @jsii.member(jsii_name="resetSeed")
    def reset_seed(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeed", []))

    @jsii.member(jsii_name="resetSeedVar")
    def reset_seed_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeedVar", []))

    @builtins.property
    @jsii.member(jsii_name="chaosInput")
    def chaos_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosInput"))

    @builtins.property
    @jsii.member(jsii_name="chaosVarInput")
    def chaos_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosVarInput"))

    @builtins.property
    @jsii.member(jsii_name="densityInput")
    def density_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityInput"))

    @builtins.property
    @jsii.member(jsii_name="densityVarInput")
    def density_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="powerInput")
    def power_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerInput"))

    @builtins.property
    @jsii.member(jsii_name="powerVarInput")
    def power_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerVarInput"))

    @builtins.property
    @jsii.member(jsii_name="seedInput")
    def seed_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedInput"))

    @builtins.property
    @jsii.member(jsii_name="seedVarInput")
    def seed_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedVarInput"))

    @builtins.property
    @jsii.member(jsii_name="chaos")
    def chaos(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaos"))

    @chaos.setter
    def chaos(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__17cca990ca6cc025896780ac4ccb37be1cbdf9ddc94f6db2cf8653f1de4861c2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaos", value)

    @builtins.property
    @jsii.member(jsii_name="chaosVar")
    def chaos_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaosVar"))

    @chaos_var.setter
    def chaos_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1c243afda3fc0dd2e874a5942c2d5e3acac4e34f8f70881d000e7a8b86c54810)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaosVar", value)

    @builtins.property
    @jsii.member(jsii_name="density")
    def density(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "density"))

    @density.setter
    def density(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a85702c5d1e511bd0136a384f2446a4fd5f7dfdfae06856752f1a1f5b1f09f28)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "density", value)

    @builtins.property
    @jsii.member(jsii_name="densityVar")
    def density_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "densityVar"))

    @density_var.setter
    def density_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1b01f18764bcfa0a6fac818dd2614791e28409d89315f6a62e92da5b78f3b6c6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "densityVar", value)

    @builtins.property
    @jsii.member(jsii_name="power")
    def power(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "power"))

    @power.setter
    def power(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__954f2a8769350f63c0ae9a27c5fa60bf722b930035eca2de5329068e0758a99d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "power", value)

    @builtins.property
    @jsii.member(jsii_name="powerVar")
    def power_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "powerVar"))

    @power_var.setter
    def power_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df93544de0e045351c9d73911ab341ccb9ff7dbe9e020bc42ddae00e974c2c65)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "powerVar", value)

    @builtins.property
    @jsii.member(jsii_name="seed")
    def seed(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seed"))

    @seed.setter
    def seed(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ec6461a55ef2019eacf8d6760b1fd7495a91d0d155ecb160d93e5afda34d5490)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seed", value)

    @builtins.property
    @jsii.member(jsii_name="seedVar")
    def seed_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seedVar"))

    @seed_var.setter
    def seed_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ffb055fa2be958c1df51ba40a5c1f8af2991ccc1096e9798f2a062c4a4e4d11c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seedVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualGoop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualGoop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualGoop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac6febd05d8b0cc0a38fdc0da696226fb867357d83d726c039914b1fa43d1b2e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualGrayscale",
    jsii_struct_bases=[],
    name_mapping={"type": "type", "type_var": "typeVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualGrayscale:
    def __init__(
        self,
        *,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param type: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ee583e15677f24391526bbe381c9736e2ecc156a73849bbb10a24a2507b8ff3a)
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualGrayscale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualGrayscaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualGrayscaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4f75bb8b546f917d32af6f57c79f1c627fa03d530bc4a188cb68d4c2a930b5a0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualGrayscaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ad8d91f42c74afe15a3b282041e7f6c4bdcdd0e3924222a961ad8276980788e)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualGrayscaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e213fc66a4080fb0f8831861bd06a63202d7c3b5284b10762c9544c0cfa0dbf5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__efc2943c47e0cafa5edb50c62ef35ed2fed013a70eb747b09e0ad7bb2945e8b7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2b3a7e9d1d9568da3f6aa92e6946bf4301d91d8f2383e16b5162246b366262e8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualGrayscale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualGrayscale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b5f416644d2421832c451aa4fd709d3ed30609fb7f00ad28fe08155940d728bf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualGrayscaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualGrayscaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f042c8e66390146e7bf2575b9849c795225db14d62cbf0f0aafb9d1d956c42f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3fcd90519583fcf23b2f2eb9c51a5c98090598640b0a1e1d8661d84254f4a7d6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__84b3acf39cdb7edb6af58cb9ffe032540fabc6ffb44db17a5d1b31411b3dbb0b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualGrayscale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualGrayscale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualGrayscale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__93f9baad53fc48fc8e6d35c727f205c90455ea61dd32dbadbed3082c1dc73664)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualHsl",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "lightness": "lightness",
        "lightness_var": "lightnessVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualHsl:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness: typing.Optional[builtins.str] = None,
        lightness_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        :param lightness_var: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d4c78a32c54ab6eb2b662eb747bafe06724f4b468de9757b63acade69d7a4d2e)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness", value=lightness, expected_type=type_hints["lightness"])
            check_type(argname="argument lightness_var", value=lightness_var, expected_type=type_hints["lightness_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness is not None:
            self._values["lightness"] = lightness
        if lightness_var is not None:
            self._values["lightness_var"] = lightness_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        '''
        result = self._values.get("lightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        '''
        result = self._values.get("lightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualHsl(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualHslList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualHslList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bd9795719a6e13a41427182902011dae938a90548a176d2797e7f68b8dcfe010)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualHslOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a07b599021160a24e031af7ee558577945714269f3d52d559b9ecbdc988f035d)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualHslOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ca0beadb27d92491558930b505ef53b1f05a10a624291ed99a294939ce4ca195)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__69dd9867c09f54f4496d327b2d57e34125eed3150c82aa56c7b32139ab2cba6b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__14e9d7be10b8b92a313af8333049cab608f041efa384c6a04ebfc1cff1fabb87)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualHsl]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualHsl]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8742f1a931093d1ed08574d4847cc677db293dad8e8e1cf5467590debe90cea8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualHslOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualHslOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9f42d12f0c29a38b4a8e4f4a468f1b7cabe95dc0e0ef0f9975dabbef9623c5f9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightness")
    def reset_lightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightness", []))

    @jsii.member(jsii_name="resetLightnessVar")
    def reset_lightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessInput")
    def lightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessVarInput")
    def lightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dc709a7e6699708529a9924c0b6eff3f0a81bc922b5733c43e4addf77a76ee5f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8d529844c800c3e0b230c0912958d280d207e607a947fa3beab8eed497865fb2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightness")
    def lightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightness"))

    @lightness.setter
    def lightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__24514c198c2b271d8caca724637e125fe5187812eae6d6d0d8aeb57c3dc3b938)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightness", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessVar")
    def lightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessVar"))

    @lightness_var.setter
    def lightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c74a4a6674da948cb2525d3b7b83f2b32f14132060b65dc3162ebe50c0b5ee80)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__413bc82b83c8a150cbc1f9ce113a0ddb760b0936d60abfdf8753f28bed8b76c0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__24ff90d1ea73289a674408020f2a49019813d4ccb825c3bea51ad2345b14d8a3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualHsl]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualHsl]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualHsl]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__68b567bb3a950a74f1bdae5246f3be32d344746c4a45b2670a10ff2773ba960d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualHsv",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualHsv:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        :param value: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c43223fb4db6da0b9d1ff2a68fc55f9e273aa0e530a8c12498af7bc67b1812e5)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualHsv(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualHsvList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualHsvList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__53756c56eb74d3e07a782f3a8913932d1c40c54df9fd0593e3433a07e5adba80)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualHsvOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4571b0497bcaf1b1dbbbe972c4d13c557534065580b8f53088151a35cbb1aac3)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualHsvOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8f74ce24f388c2ba1b365d66e05d3dbc3ebac70adaec09fb88e1467d3313cf6f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__37ea3c99fa95816951d3b606203e68c928a7b98884a17c02418b1c24c6687f08)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a55ef5adf4d8024a0a702918b436dc9e2f437a52dcfebb063152c47f1702c6d2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualHsv]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualHsv]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__71d7e9c4c5ef45b9cae3900f3a9de28b0c3c7f441e7130edff5556ef43942fbe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualHsvOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualHsvOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f80777b673b2c604dbb9cd0103a260d9f1cbe6cd36d41039fef6b9ab32fa724)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ad5288ce6a2bf6dc3f715a333125efc54fd5539cb06676f3e805cd8c154fc3b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f2980f4622514c872d7fa0761f70148b04022019eb7627923d743b7ca879ce8e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c47c80e181519e5fc6c6e0bc4970253b3de752274fd846a829ae34f07fc305f4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4e9a4f6e9eaac5a74068761c538a1d613e3735ea555c64bff3fcdeefa7f060db)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4c9939e062632bab0eb112267e0e4769603c268c0e9f75308a24b8b704e419e4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ae12380104f0cad00a20958fcf02690ce50a01bb51de0f8d835f441fdbe579c7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualHsv]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualHsv]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualHsv]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d92d36d100e88eb6fbb23845e4b3c651bf162d52e7f29f82c84aa428e980bb4c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientation",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "landscape": "landscape",
        "portrait": "portrait",
        "square": "square",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientation:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        landscape: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscape", typing.Dict[builtins.str, typing.Any]]] = None,
        portrait: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortrait", typing.Dict[builtins.str, typing.Any]]] = None,
        square: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquare", typing.Dict[builtins.str, typing.Any]]] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param landscape: landscape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        :param portrait: portrait block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        :param square: square block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefault(**default)
        if isinstance(landscape, dict):
            landscape = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscape(**landscape)
        if isinstance(portrait, dict):
            portrait = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortrait(**portrait)
        if isinstance(square, dict):
            square = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquare(**square)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f1b032b49083c4ebde46c8172c90562305e6fe0d3bbc1e84c5487646eef0b8c)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument landscape", value=landscape, expected_type=type_hints["landscape"])
            check_type(argname="argument portrait", value=portrait, expected_type=type_hints["portrait"])
            check_type(argname="argument square", value=square, expected_type=type_hints["square"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if landscape is not None:
            self._values["landscape"] = landscape
        if portrait is not None:
            self._values["portrait"] = portrait
        if square is not None:
            self._values["square"] = square

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefault"], result)

    @builtins.property
    def landscape(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscape"]:
        '''landscape block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        '''
        result = self._values.get("landscape")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscape"], result)

    @builtins.property
    def portrait(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortrait"]:
        '''portrait block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        '''
        result = self._values.get("portrait")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortrait"], result)

    @builtins.property
    def square(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquare"]:
        '''square block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        result = self._values.get("square")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquare"], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefault",
    jsii_struct_bases=[],
    name_mapping={
        "append": "append",
        "aspect_crop": "aspectCrop",
        "background_color": "backgroundColor",
        "blur": "blur",
        "chroma_key": "chromaKey",
        "composite": "composite",
        "compound": "compound",
        "contrast": "contrast",
        "crop": "crop",
        "face_crop": "faceCrop",
        "feature_crop": "featureCrop",
        "fit_and_fill": "fitAndFill",
        "goop": "goop",
        "grayscale": "grayscale",
        "hsl": "hsl",
        "hsv": "hsv",
        "if_dimension": "ifDimension",
        "if_orientation": "ifOrientation",
        "im_query": "imQuery",
        "max_colors": "maxColors",
        "mirror": "mirror",
        "mono_hue": "monoHue",
        "opacity": "opacity",
        "region_of_interest_crop": "regionOfInterestCrop",
        "relative_crop": "relativeCrop",
        "remove_color": "removeColor",
        "resize": "resize",
        "rotate": "rotate",
        "scale": "scale",
        "shear": "shear",
        "trim": "trim",
        "unsharp_mask": "unsharpMask",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefault:
    def __init__(
        self,
        *,
        append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultAppend", typing.Dict[builtins.str, typing.Any]]]]] = None,
        aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultAspectCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultBackgroundColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultBlur", typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultChromaKey", typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultComposite", typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultCompound", typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultContrast", typing.Dict[builtins.str, typing.Any]]]]] = None,
        crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultFaceCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultFeatureCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultFitAndFill", typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultGoop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultGrayscale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultHsl", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultHsv", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfDimension", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfOrientation", typing.Dict[builtins.str, typing.Any]]]]] = None,
        im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultImQuery", typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultMaxColors", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultMirror", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultMonoHue", typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultOpacity", typing.Dict[builtins.str, typing.Any]]]]] = None,
        region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultRegionOfInterestCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultRelativeCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultRemoveColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultResize", typing.Dict[builtins.str, typing.Any]]]]] = None,
        rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultRotate", typing.Dict[builtins.str, typing.Any]]]]] = None,
        scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultScale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultShear", typing.Dict[builtins.str, typing.Any]]]]] = None,
        trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultTrim", typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultUnsharpMask", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param append: append block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        :param aspect_crop: aspect_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param crop: crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        :param face_crop: face_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        :param feature_crop: feature_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        :param fit_and_fill: fit_and_fill block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param im_query: im_query block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param region_of_interest_crop: region_of_interest_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        :param relative_crop: relative_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param resize: resize block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        :param rotate: rotate block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        :param scale: scale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param shear: shear block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        :param trim: trim block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a502ed3dc4ce5d9a4fac7592ab9d29dd42dda261a0ae5e99ebbf4cea89e89f85)
            check_type(argname="argument append", value=append, expected_type=type_hints["append"])
            check_type(argname="argument aspect_crop", value=aspect_crop, expected_type=type_hints["aspect_crop"])
            check_type(argname="argument background_color", value=background_color, expected_type=type_hints["background_color"])
            check_type(argname="argument blur", value=blur, expected_type=type_hints["blur"])
            check_type(argname="argument chroma_key", value=chroma_key, expected_type=type_hints["chroma_key"])
            check_type(argname="argument composite", value=composite, expected_type=type_hints["composite"])
            check_type(argname="argument compound", value=compound, expected_type=type_hints["compound"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument crop", value=crop, expected_type=type_hints["crop"])
            check_type(argname="argument face_crop", value=face_crop, expected_type=type_hints["face_crop"])
            check_type(argname="argument feature_crop", value=feature_crop, expected_type=type_hints["feature_crop"])
            check_type(argname="argument fit_and_fill", value=fit_and_fill, expected_type=type_hints["fit_and_fill"])
            check_type(argname="argument goop", value=goop, expected_type=type_hints["goop"])
            check_type(argname="argument grayscale", value=grayscale, expected_type=type_hints["grayscale"])
            check_type(argname="argument hsl", value=hsl, expected_type=type_hints["hsl"])
            check_type(argname="argument hsv", value=hsv, expected_type=type_hints["hsv"])
            check_type(argname="argument if_dimension", value=if_dimension, expected_type=type_hints["if_dimension"])
            check_type(argname="argument if_orientation", value=if_orientation, expected_type=type_hints["if_orientation"])
            check_type(argname="argument im_query", value=im_query, expected_type=type_hints["im_query"])
            check_type(argname="argument max_colors", value=max_colors, expected_type=type_hints["max_colors"])
            check_type(argname="argument mirror", value=mirror, expected_type=type_hints["mirror"])
            check_type(argname="argument mono_hue", value=mono_hue, expected_type=type_hints["mono_hue"])
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument region_of_interest_crop", value=region_of_interest_crop, expected_type=type_hints["region_of_interest_crop"])
            check_type(argname="argument relative_crop", value=relative_crop, expected_type=type_hints["relative_crop"])
            check_type(argname="argument remove_color", value=remove_color, expected_type=type_hints["remove_color"])
            check_type(argname="argument resize", value=resize, expected_type=type_hints["resize"])
            check_type(argname="argument rotate", value=rotate, expected_type=type_hints["rotate"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument shear", value=shear, expected_type=type_hints["shear"])
            check_type(argname="argument trim", value=trim, expected_type=type_hints["trim"])
            check_type(argname="argument unsharp_mask", value=unsharp_mask, expected_type=type_hints["unsharp_mask"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if append is not None:
            self._values["append"] = append
        if aspect_crop is not None:
            self._values["aspect_crop"] = aspect_crop
        if background_color is not None:
            self._values["background_color"] = background_color
        if blur is not None:
            self._values["blur"] = blur
        if chroma_key is not None:
            self._values["chroma_key"] = chroma_key
        if composite is not None:
            self._values["composite"] = composite
        if compound is not None:
            self._values["compound"] = compound
        if contrast is not None:
            self._values["contrast"] = contrast
        if crop is not None:
            self._values["crop"] = crop
        if face_crop is not None:
            self._values["face_crop"] = face_crop
        if feature_crop is not None:
            self._values["feature_crop"] = feature_crop
        if fit_and_fill is not None:
            self._values["fit_and_fill"] = fit_and_fill
        if goop is not None:
            self._values["goop"] = goop
        if grayscale is not None:
            self._values["grayscale"] = grayscale
        if hsl is not None:
            self._values["hsl"] = hsl
        if hsv is not None:
            self._values["hsv"] = hsv
        if if_dimension is not None:
            self._values["if_dimension"] = if_dimension
        if if_orientation is not None:
            self._values["if_orientation"] = if_orientation
        if im_query is not None:
            self._values["im_query"] = im_query
        if max_colors is not None:
            self._values["max_colors"] = max_colors
        if mirror is not None:
            self._values["mirror"] = mirror
        if mono_hue is not None:
            self._values["mono_hue"] = mono_hue
        if opacity is not None:
            self._values["opacity"] = opacity
        if region_of_interest_crop is not None:
            self._values["region_of_interest_crop"] = region_of_interest_crop
        if relative_crop is not None:
            self._values["relative_crop"] = relative_crop
        if remove_color is not None:
            self._values["remove_color"] = remove_color
        if resize is not None:
            self._values["resize"] = resize
        if rotate is not None:
            self._values["rotate"] = rotate
        if scale is not None:
            self._values["scale"] = scale
        if shear is not None:
            self._values["shear"] = shear
        if trim is not None:
            self._values["trim"] = trim
        if unsharp_mask is not None:
            self._values["unsharp_mask"] = unsharp_mask

    @builtins.property
    def append(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultAppend"]]]:
        '''append block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        '''
        result = self._values.get("append")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultAppend"]]], result)

    @builtins.property
    def aspect_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultAspectCrop"]]]:
        '''aspect_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        '''
        result = self._values.get("aspect_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultAspectCrop"]]], result)

    @builtins.property
    def background_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultBackgroundColor"]]]:
        '''background_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        '''
        result = self._values.get("background_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultBackgroundColor"]]], result)

    @builtins.property
    def blur(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultBlur"]]]:
        '''blur block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        '''
        result = self._values.get("blur")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultBlur"]]], result)

    @builtins.property
    def chroma_key(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultChromaKey"]]]:
        '''chroma_key block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        '''
        result = self._values.get("chroma_key")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultChromaKey"]]], result)

    @builtins.property
    def composite(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultComposite"]]]:
        '''composite block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        '''
        result = self._values.get("composite")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultComposite"]]], result)

    @builtins.property
    def compound(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultCompound"]]]:
        '''compound block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        '''
        result = self._values.get("compound")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultCompound"]]], result)

    @builtins.property
    def contrast(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultContrast"]]]:
        '''contrast block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultContrast"]]], result)

    @builtins.property
    def crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultCrop"]]]:
        '''crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        '''
        result = self._values.get("crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultCrop"]]], result)

    @builtins.property
    def face_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultFaceCrop"]]]:
        '''face_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        '''
        result = self._values.get("face_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultFaceCrop"]]], result)

    @builtins.property
    def feature_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultFeatureCrop"]]]:
        '''feature_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        '''
        result = self._values.get("feature_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultFeatureCrop"]]], result)

    @builtins.property
    def fit_and_fill(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultFitAndFill"]]]:
        '''fit_and_fill block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        '''
        result = self._values.get("fit_and_fill")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultFitAndFill"]]], result)

    @builtins.property
    def goop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultGoop"]]]:
        '''goop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        '''
        result = self._values.get("goop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultGoop"]]], result)

    @builtins.property
    def grayscale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultGrayscale"]]]:
        '''grayscale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        '''
        result = self._values.get("grayscale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultGrayscale"]]], result)

    @builtins.property
    def hsl(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultHsl"]]]:
        '''hsl block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        '''
        result = self._values.get("hsl")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultHsl"]]], result)

    @builtins.property
    def hsv(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultHsv"]]]:
        '''hsv block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        '''
        result = self._values.get("hsv")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultHsv"]]], result)

    @builtins.property
    def if_dimension(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfDimension"]]]:
        '''if_dimension block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        '''
        result = self._values.get("if_dimension")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfDimension"]]], result)

    @builtins.property
    def if_orientation(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfOrientation"]]]:
        '''if_orientation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        '''
        result = self._values.get("if_orientation")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfOrientation"]]], result)

    @builtins.property
    def im_query(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultImQuery"]]]:
        '''im_query block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        '''
        result = self._values.get("im_query")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultImQuery"]]], result)

    @builtins.property
    def max_colors(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultMaxColors"]]]:
        '''max_colors block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        '''
        result = self._values.get("max_colors")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultMaxColors"]]], result)

    @builtins.property
    def mirror(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultMirror"]]]:
        '''mirror block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        '''
        result = self._values.get("mirror")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultMirror"]]], result)

    @builtins.property
    def mono_hue(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultMonoHue"]]]:
        '''mono_hue block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        '''
        result = self._values.get("mono_hue")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultMonoHue"]]], result)

    @builtins.property
    def opacity(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultOpacity"]]]:
        '''opacity block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultOpacity"]]], result)

    @builtins.property
    def region_of_interest_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultRegionOfInterestCrop"]]]:
        '''region_of_interest_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        '''
        result = self._values.get("region_of_interest_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultRegionOfInterestCrop"]]], result)

    @builtins.property
    def relative_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultRelativeCrop"]]]:
        '''relative_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        '''
        result = self._values.get("relative_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultRelativeCrop"]]], result)

    @builtins.property
    def remove_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultRemoveColor"]]]:
        '''remove_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        '''
        result = self._values.get("remove_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultRemoveColor"]]], result)

    @builtins.property
    def resize(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultResize"]]]:
        '''resize block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        '''
        result = self._values.get("resize")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultResize"]]], result)

    @builtins.property
    def rotate(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultRotate"]]]:
        '''rotate block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        '''
        result = self._values.get("rotate")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultRotate"]]], result)

    @builtins.property
    def scale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultScale"]]]:
        '''scale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultScale"]]], result)

    @builtins.property
    def shear(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultShear"]]]:
        '''shear block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        '''
        result = self._values.get("shear")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultShear"]]], result)

    @builtins.property
    def trim(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultTrim"]]]:
        '''trim block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        '''
        result = self._values.get("trim")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultTrim"]]], result)

    @builtins.property
    def unsharp_mask(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultUnsharpMask"]]]:
        '''unsharp_mask block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        result = self._values.get("unsharp_mask")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultUnsharpMask"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultAppend",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_priority": "gravityPriority",
        "gravity_priority_var": "gravityPriorityVar",
        "gravity_var": "gravityVar",
        "preserve_minor_dimension": "preserveMinorDimension",
        "preserve_minor_dimension_var": "preserveMinorDimensionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultAppend:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultAppendImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_priority: typing.Optional[builtins.str] = None,
        gravity_priority_var: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        preserve_minor_dimension: typing.Optional[builtins.str] = None,
        preserve_minor_dimension_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Specifies where to place the ``image`` relative to the source image. The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_priority: Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal. The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority DataAkamaiImagingPolicyImage#gravity_priority}
        :param gravity_priority_var: Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal. The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority_var DataAkamaiImagingPolicyImage#gravity_priority_var}
        :param gravity_var: Specifies where to place the ``image`` relative to the source image. The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param preserve_minor_dimension: Whether to preserve the source image's minor dimension, ``false`` by default. The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension DataAkamaiImagingPolicyImage#preserve_minor_dimension}
        :param preserve_minor_dimension_var: Whether to preserve the source image's minor dimension, ``false`` by default. The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension_var DataAkamaiImagingPolicyImage#preserve_minor_dimension_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultAppendImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a25e0d8c737a410ad00ce28450394b644a0543196752b1b68845b9f67298963b)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_priority", value=gravity_priority, expected_type=type_hints["gravity_priority"])
            check_type(argname="argument gravity_priority_var", value=gravity_priority_var, expected_type=type_hints["gravity_priority_var"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument preserve_minor_dimension", value=preserve_minor_dimension, expected_type=type_hints["preserve_minor_dimension"])
            check_type(argname="argument preserve_minor_dimension_var", value=preserve_minor_dimension_var, expected_type=type_hints["preserve_minor_dimension_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_priority is not None:
            self._values["gravity_priority"] = gravity_priority
        if gravity_priority_var is not None:
            self._values["gravity_priority_var"] = gravity_priority_var
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if preserve_minor_dimension is not None:
            self._values["preserve_minor_dimension"] = preserve_minor_dimension
        if preserve_minor_dimension_var is not None:
            self._values["preserve_minor_dimension_var"] = preserve_minor_dimension_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultAppendImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultAppendImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Specifies where to place the ``image`` relative to the source image.

        The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_priority(self) -> typing.Optional[builtins.str]:
        '''Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal.

        The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority DataAkamaiImagingPolicyImage#gravity_priority}
        '''
        result = self._values.get("gravity_priority")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_priority_var(self) -> typing.Optional[builtins.str]:
        '''Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal.

        The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority_var DataAkamaiImagingPolicyImage#gravity_priority_var}
        '''
        result = self._values.get("gravity_priority_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Specifies where to place the ``image`` relative to the source image.

        The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def preserve_minor_dimension(self) -> typing.Optional[builtins.str]:
        '''Whether to preserve the source image's minor dimension, ``false`` by default.

        The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension DataAkamaiImagingPolicyImage#preserve_minor_dimension}
        '''
        result = self._values.get("preserve_minor_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def preserve_minor_dimension_var(self) -> typing.Optional[builtins.str]:
        '''Whether to preserve the source image's minor dimension, ``false`` by default.

        The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension_var DataAkamaiImagingPolicyImage#preserve_minor_dimension_var}
        '''
        result = self._values.get("preserve_minor_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultAppend(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultAppendImage",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultAppendImage:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultAppendImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultAppendImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultAppendImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9bd96583a8dcde5181474ef2da6287891d5a36ff5db39bdf8cb4f243466e2f06)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultAppendImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultAppendImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultAppendImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a825709b726586bf8aba55d526beeaa432d6129fb08aefb9305fc7c1fa0926d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultAppendList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultAppendList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__565a2e54d842cc8e4216fcb74d2bdc48e54cbf00483dd095219619937ece578d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultAppendOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__56ba05e90f9ac0faa65c46e97785fc1cab5ffe0bc43ec0b98d02f6b71317917d)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultAppendOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d57fd2fe3d6df5f27bfd926c7ef3b6cbcac88668090a193488c2cacce6051f5d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__abee1fcc65b0cf5c7511bc42c3cdcff91efd92d3dee0bdc6b971d35e3d159ed4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0c440f917b5140ff9db2e6d747125b286ba63b319f65b818e41889b02e88c696)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultAppend]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultAppend]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultAppend]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__74f6646f2ed8aa6a80d5ec59bc092c25d2f71cc94d9f78ee89bc072a01e0d711)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultAppendOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultAppendOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ce06642455c54b4d600df9c43d8d86e8ff078e7ce355c90ba91a8ddd54b1827)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultAppendImage()

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityPriority")
    def reset_gravity_priority(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityPriority", []))

    @jsii.member(jsii_name="resetGravityPriorityVar")
    def reset_gravity_priority_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityPriorityVar", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPreserveMinorDimension")
    def reset_preserve_minor_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPreserveMinorDimension", []))

    @jsii.member(jsii_name="resetPreserveMinorDimensionVar")
    def reset_preserve_minor_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPreserveMinorDimensionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultAppendImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultAppendImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityInput")
    def gravity_priority_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityPriorityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityVarInput")
    def gravity_priority_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityPriorityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultAppendImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultAppendImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionInput")
    def preserve_minor_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "preserveMinorDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionVarInput")
    def preserve_minor_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "preserveMinorDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d18e5ddad0bb0bd802042f99aed4f2cd3ce58bf26a8e6a003f489e0fdea22913)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityPriority")
    def gravity_priority(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityPriority"))

    @gravity_priority.setter
    def gravity_priority(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b874ca1308be0908a6038660787608fc9faede54c8352d681ab35bf5ec731d3e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityPriority", value)

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityVar")
    def gravity_priority_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityPriorityVar"))

    @gravity_priority_var.setter
    def gravity_priority_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__348433aab0e10a856aed375ebbcbc89a8b0f5056bdc077dfce0cb61678f7ac25)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityPriorityVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__88c9915e7b1b1ac217684fc86065c9b05afd72f1e9a7e6920d53f8b2b64bc750)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimension")
    def preserve_minor_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "preserveMinorDimension"))

    @preserve_minor_dimension.setter
    def preserve_minor_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6d55d3f9cf74953906e0f2d61492368048c2cab079c42ad00e4759f55b400b03)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "preserveMinorDimension", value)

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionVar")
    def preserve_minor_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "preserveMinorDimensionVar"))

    @preserve_minor_dimension_var.setter
    def preserve_minor_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ce4384ab51b8abd824d35c7986596a6f55a26c78e09db2761bfccf9a169b714a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "preserveMinorDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultAppend]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultAppend]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultAppend]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4f4b519329efd911a7b33637f84faafb7cd62b16ba2f37b7902f727cdc3e8e2c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultAspectCrop",
    jsii_struct_bases=[],
    name_mapping={
        "allow_expansion": "allowExpansion",
        "allow_expansion_var": "allowExpansionVar",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultAspectCrop:
    def __init__(
        self,
        *,
        allow_expansion: typing.Optional[builtins.str] = None,
        allow_expansion_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_expansion: Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image. Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        :param allow_expansion_var: Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image. Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        :param height: The height term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The width term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        :param x_position: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d5466dd3d1f63d88900fe08f624188663dd1813feda0a1423151d2383119deed)
            check_type(argname="argument allow_expansion", value=allow_expansion, expected_type=type_hints["allow_expansion"])
            check_type(argname="argument allow_expansion_var", value=allow_expansion_var, expected_type=type_hints["allow_expansion_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if allow_expansion is not None:
            self._values["allow_expansion"] = allow_expansion
        if allow_expansion_var is not None:
            self._values["allow_expansion_var"] = allow_expansion_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def allow_expansion(self) -> typing.Optional[builtins.str]:
        '''Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image.

        Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        '''
        result = self._values.get("allow_expansion")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def allow_expansion_var(self) -> typing.Optional[builtins.str]:
        '''Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image.

        Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        '''
        result = self._values.get("allow_expansion_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultAspectCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultAspectCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultAspectCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e9db905c5354c5c725a1c31244e978518909b87627cbc5d12c4d5c5c6a7ae19b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultAspectCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__da1699d68c8a3f48d52bdec16efe5c691765d81ec3d96e4ac3c8bbe8a38f79da)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultAspectCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__58604c127fd3e53bf984421b2b84fe2fb49ce6ba7e55489180dcf50e8566e786)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__53338fc949b38f58accbdb11007bfb89c7c81b54b82687acbdf21af2d4ce7aa7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7e3d13e13b527c287e422ed0db88f2b583939fd369fd5351d5be09c5e8f4179d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultAspectCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultAspectCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultAspectCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d6bfbb7e09874c808575df0baa0f92f219cdfe80d28ab41d691861cc9615f8eb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultAspectCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultAspectCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__65c9ff879d46f4181bc615839317ec615a6a79ba13dc2f157c12104290e2faa9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAllowExpansion")
    def reset_allow_expansion(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansion", []))

    @jsii.member(jsii_name="resetAllowExpansionVar")
    def reset_allow_expansion_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansionVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionInput")
    def allow_expansion_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVarInput")
    def allow_expansion_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansion")
    def allow_expansion(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansion"))

    @allow_expansion.setter
    def allow_expansion(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3e2bc6475e2cce06631230b19ffc2e73023a7ba4623205d11c6d87b7b9f017e9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansion", value)

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVar")
    def allow_expansion_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansionVar"))

    @allow_expansion_var.setter
    def allow_expansion_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5376a58d53293826b5f363096b7c242f9d21911c70a8ef30cdd00132451a1fc5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansionVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__16d01994aa76a4ce3bfdfb7384d9aae294ec3679b6ee23dc83b0e989a19534a6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__081ba389234435e020c11836d174fffdecdf6213117020a1b744ef823bdac5dc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__82285b98092d5a59a05810adab3d18042c74de3f3c711c784b75f1e1ad125227)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c52cda3f7e10c7aec07503cb848dec9a37246038b49fd8e0109f64a68dcd4d75)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1545b9e76d9a7b3e4646949b5a51f45dca187f84b01e76b2a14c699e6e812fd3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cbb541cdff169b5b4cba7e10579043a565e37baa4b7e62d743e0c325e84a5672)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1432ce87da481ca906a32beba39939a753381140309ce25561ccbc942e1013b1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__44283c53aa9383dca49fdb5a074a8c7b368db69a0b79f0c162d5d6f8f8944b77)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultAspectCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultAspectCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultAspectCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a090009cf6801830bd591f48e0cecd4039f2820ed75ad923acc7127b682d5637)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultBackgroundColor",
    jsii_struct_bases=[],
    name_mapping={"color": "color", "color_var": "colorVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultBackgroundColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3fa07a7c7e0e1e1140250f1ffd3b79b1bf9d0769ef55390b449f87a0bb7d63e7)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultBackgroundColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultBackgroundColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultBackgroundColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a42327658dd2ea71c73ab3c92e1f0db1d5b649314398305a585954eb39cffa2c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultBackgroundColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__39960b18f1252b49f7c0983f320d53cb88e4b6e5ab09706608efbcdf1ccaa13e)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultBackgroundColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__49cc005d2e664da7d166792ffeecb4b715f822854a5a921ab848188d43f4f0f4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0efaab5b1e7589b1fbee3bf7c7fc1be677de1c568602ba585824029b65883213)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7727e93b4768faa99cb227ffdb6ace32798c0cfaad06171d378aa14f2058ca22)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultBackgroundColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultBackgroundColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__60f4c2de0ade8669972a6a8355226eafa3b56d766297b1b83da6fab5e2e503f8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultBackgroundColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultBackgroundColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__06fbc886be258b45ebf7abbb945dcd3d29a746ddf09b2579228fdf54a21e00a8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e4f839af466d1cccd5fd508cd456edcefd6f8c228e0d54f71e7230a069f1d36d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5bfcf449fc8924eb29ba5e819de5b8591b6b189a3592049cb40009fe6b05c3fd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultBackgroundColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultBackgroundColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultBackgroundColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6dd98941f191ec5ee9d088c7c387bac0c21b2905e5973bf32169ea663a5fa4cd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultBlur",
    jsii_struct_bases=[],
    name_mapping={"sigma": "sigma", "sigma_var": "sigmaVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultBlur:
    def __init__(
        self,
        *,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param sigma: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f2f90110add250006f1986e151f45ed33f4ee3346c40a2fe162bd059d27e6029)
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultBlur(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultBlurList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultBlurList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b4a091ecbeb86d426823e86d48e9698e8c6adf2dbf6d3661cbc692db82c56435)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultBlurOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__13e32a822ddc77edb1030e9c377c954eb34874a64de081aafec47054ce2eb57a)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultBlurOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c09fe9cd41ff759397afa4808aca310034d6ff34399d1483a00d21094109f626)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a753a335b8d6db65479d8c87cc0681298aef19808b0dfdb8ba15f022fa164e5a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c4d5cbe59af757dec7e5896e8348f99a54f5c647236b1902b774fb5bf0079fe9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultBlur]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultBlur]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4cfe4fd568255060e447b62fb83378752d519a01f082b1ec37f2a1583757455b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultBlurOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultBlurOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d91abb2bfd39ca8eb366e40862e411c2ecb38d74be506066a59c1bd3b786b8f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2be4fae7e6c23909b0a01dd880f607d09d533688b1852b6f4e1182b74d954d64)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7f881930b3ec6042034d940707856ab9f3a626e5ddff95cd9fd72854cd23ad52)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultBlur]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultBlur]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultBlur]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__501819551458b9be5a0b40ec82b27f76b101a462a109a5381b462be3ce18c490)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultChromaKey",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_feather": "hueFeather",
        "hue_feather_var": "hueFeatherVar",
        "hue_tolerance": "hueTolerance",
        "hue_tolerance_var": "hueToleranceVar",
        "hue_var": "hueVar",
        "lightness_feather": "lightnessFeather",
        "lightness_feather_var": "lightnessFeatherVar",
        "lightness_tolerance": "lightnessTolerance",
        "lightness_tolerance_var": "lightnessToleranceVar",
        "saturation_feather": "saturationFeather",
        "saturation_feather_var": "saturationFeatherVar",
        "saturation_tolerance": "saturationTolerance",
        "saturation_tolerance_var": "saturationToleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultChromaKey:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_feather: typing.Optional[builtins.str] = None,
        hue_feather_var: typing.Optional[builtins.str] = None,
        hue_tolerance: typing.Optional[builtins.str] = None,
        hue_tolerance_var: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness_feather: typing.Optional[builtins.str] = None,
        lightness_feather_var: typing.Optional[builtins.str] = None,
        lightness_tolerance: typing.Optional[builtins.str] = None,
        lightness_tolerance_var: typing.Optional[builtins.str] = None,
        saturation_feather: typing.Optional[builtins.str] = None,
        saturation_feather_var: typing.Optional[builtins.str] = None,
        saturation_tolerance: typing.Optional[builtins.str] = None,
        saturation_tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_feather: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        :param hue_feather_var: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        :param hue_tolerance: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        :param hue_tolerance_var: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        :param hue_var: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness_feather: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        :param lightness_feather_var: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        :param lightness_tolerance: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        :param lightness_tolerance_var: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        :param saturation_feather: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        :param saturation_feather_var: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        :param saturation_tolerance: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        :param saturation_tolerance_var: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8d84ff63689c491a306f184283670c664fc184b4ec55ad17ef07f08cd0f382e2)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_feather", value=hue_feather, expected_type=type_hints["hue_feather"])
            check_type(argname="argument hue_feather_var", value=hue_feather_var, expected_type=type_hints["hue_feather_var"])
            check_type(argname="argument hue_tolerance", value=hue_tolerance, expected_type=type_hints["hue_tolerance"])
            check_type(argname="argument hue_tolerance_var", value=hue_tolerance_var, expected_type=type_hints["hue_tolerance_var"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness_feather", value=lightness_feather, expected_type=type_hints["lightness_feather"])
            check_type(argname="argument lightness_feather_var", value=lightness_feather_var, expected_type=type_hints["lightness_feather_var"])
            check_type(argname="argument lightness_tolerance", value=lightness_tolerance, expected_type=type_hints["lightness_tolerance"])
            check_type(argname="argument lightness_tolerance_var", value=lightness_tolerance_var, expected_type=type_hints["lightness_tolerance_var"])
            check_type(argname="argument saturation_feather", value=saturation_feather, expected_type=type_hints["saturation_feather"])
            check_type(argname="argument saturation_feather_var", value=saturation_feather_var, expected_type=type_hints["saturation_feather_var"])
            check_type(argname="argument saturation_tolerance", value=saturation_tolerance, expected_type=type_hints["saturation_tolerance"])
            check_type(argname="argument saturation_tolerance_var", value=saturation_tolerance_var, expected_type=type_hints["saturation_tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_feather is not None:
            self._values["hue_feather"] = hue_feather
        if hue_feather_var is not None:
            self._values["hue_feather_var"] = hue_feather_var
        if hue_tolerance is not None:
            self._values["hue_tolerance"] = hue_tolerance
        if hue_tolerance_var is not None:
            self._values["hue_tolerance_var"] = hue_tolerance_var
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness_feather is not None:
            self._values["lightness_feather"] = lightness_feather
        if lightness_feather_var is not None:
            self._values["lightness_feather_var"] = lightness_feather_var
        if lightness_tolerance is not None:
            self._values["lightness_tolerance"] = lightness_tolerance
        if lightness_tolerance_var is not None:
            self._values["lightness_tolerance_var"] = lightness_tolerance_var
        if saturation_feather is not None:
            self._values["saturation_feather"] = saturation_feather
        if saturation_feather_var is not None:
            self._values["saturation_feather_var"] = saturation_feather_var
        if saturation_tolerance is not None:
            self._values["saturation_tolerance"] = saturation_tolerance
        if saturation_tolerance_var is not None:
            self._values["saturation_tolerance_var"] = saturation_tolerance_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        '''
        result = self._values.get("hue_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        '''
        result = self._values.get("hue_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        '''
        result = self._values.get("hue_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        '''
        result = self._values.get("hue_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        '''
        result = self._values.get("lightness_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        '''
        result = self._values.get("lightness_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        '''
        result = self._values.get("lightness_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        '''
        result = self._values.get("lightness_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        '''
        result = self._values.get("saturation_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        '''
        result = self._values.get("saturation_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        '''
        result = self._values.get("saturation_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        result = self._values.get("saturation_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultChromaKey(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultChromaKeyList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultChromaKeyList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6162dbc0b9efd39ee70e081c9f492d06223a544521e6f5d3cd1494229563f6e4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultChromaKeyOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bbaf87191e0f6a83d31a7d0b3cf5344af4f5103480a55a9e3b76d3057a5fcd24)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultChromaKeyOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__864fa5ae7fcaf734f53ecb0030680fe464e75676c83990e970aaabd368d5327d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d365dfa9c8d3683c4c5666a4266c97c9819f54d750ecb5816fadd4f0945efd8c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a934c3fcecbe23f1ce35009b34bfeebc72e53cbbd101a088ac2ea3866154ae64)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultChromaKey]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultChromaKey]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__03d7879f4ad7637a74b96449d2863f5722516afeb424bc2dde97f8afff42d8a0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultChromaKeyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultChromaKeyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__249cd365c23b5df72dc96c162ab9cb53930e7cd993358897ee8d26149ab8a412)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueFeather")
    def reset_hue_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeather", []))

    @jsii.member(jsii_name="resetHueFeatherVar")
    def reset_hue_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeatherVar", []))

    @jsii.member(jsii_name="resetHueTolerance")
    def reset_hue_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueTolerance", []))

    @jsii.member(jsii_name="resetHueToleranceVar")
    def reset_hue_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueToleranceVar", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightnessFeather")
    def reset_lightness_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeather", []))

    @jsii.member(jsii_name="resetLightnessFeatherVar")
    def reset_lightness_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeatherVar", []))

    @jsii.member(jsii_name="resetLightnessTolerance")
    def reset_lightness_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessTolerance", []))

    @jsii.member(jsii_name="resetLightnessToleranceVar")
    def reset_lightness_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessToleranceVar", []))

    @jsii.member(jsii_name="resetSaturationFeather")
    def reset_saturation_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeather", []))

    @jsii.member(jsii_name="resetSaturationFeatherVar")
    def reset_saturation_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeatherVar", []))

    @jsii.member(jsii_name="resetSaturationTolerance")
    def reset_saturation_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationTolerance", []))

    @jsii.member(jsii_name="resetSaturationToleranceVar")
    def reset_saturation_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherInput")
    def hue_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVarInput")
    def hue_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceInput")
    def hue_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVarInput")
    def hue_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherInput")
    def lightness_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVarInput")
    def lightness_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceInput")
    def lightness_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVarInput")
    def lightness_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherInput")
    def saturation_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVarInput")
    def saturation_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceInput")
    def saturation_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVarInput")
    def saturation_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__919b826359fd9a77a02cabfe8305bd48f009b6b520eb97a43b12c22f39a39eb4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeather")
    def hue_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeather"))

    @hue_feather.setter
    def hue_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ffc9849b19d2f41f59f0ecb4337db2ce6854eac204b078b2431afd35c00bb0ff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeather", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVar")
    def hue_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeatherVar"))

    @hue_feather_var.setter
    def hue_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__79acfb0443d68f6acaf835daf5fc191a27ec4238353068e96899ed1aef6cdda1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueTolerance")
    def hue_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueTolerance"))

    @hue_tolerance.setter
    def hue_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__239601376cb1d85cdddcd00105058824618b63e5909499dae7471bc06932a402)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVar")
    def hue_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueToleranceVar"))

    @hue_tolerance_var.setter
    def hue_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f324fa1d352708b1306ec9e2c5a4a798dcc7ee2ccc7a089a33ac254e9018757f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8797db65970907a11d345077ab76422ac2a85265816afa9df0abeee648bd5f46)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeather")
    def lightness_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeather"))

    @lightness_feather.setter
    def lightness_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ef4d71995e9381f87ad41ff7285a6d586e0bfce0bc6641197b7029660614eed2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeather", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVar")
    def lightness_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeatherVar"))

    @lightness_feather_var.setter
    def lightness_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c07066c5e745405a72b31ddcdb5bcafd1780371b016d7dde200cc21ccc0662ea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessTolerance")
    def lightness_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessTolerance"))

    @lightness_tolerance.setter
    def lightness_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6a21302a80fc54ed632f5ec124b8f658ddec82a6ce516b414bc7dc52585b800d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVar")
    def lightness_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessToleranceVar"))

    @lightness_tolerance_var.setter
    def lightness_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2524d89f2ce45fe3b8de9ea50c289a07b33ad35b506a37067b1d6855e5e203f3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeather")
    def saturation_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeather"))

    @saturation_feather.setter
    def saturation_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__07c69b193e16209813c40b875d8ab6b710a2d9724db6c1ad138d34e1d976da63)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeather", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVar")
    def saturation_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeatherVar"))

    @saturation_feather_var.setter
    def saturation_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9359dabff3df36e70556fed600a223b107ba3edfd70d0c67fab543bdebf74d65)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationTolerance")
    def saturation_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationTolerance"))

    @saturation_tolerance.setter
    def saturation_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__903c18206e3d77df7489d98da29243e2c81752cd6f1bd6a18b88da3930a24b7b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVar")
    def saturation_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationToleranceVar"))

    @saturation_tolerance_var.setter
    def saturation_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__269305e7e59d51d48ec34fde3224916ddb4c43568931bc06cb419240c969ea4a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultChromaKey]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultChromaKey]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultChromaKey]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be16690ad52a7a1b2b6585261a02f2483210b3860cd48fdefe153762e2ec73ae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultComposite",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "placement": "placement",
        "placement_var": "placementVar",
        "scale": "scale",
        "scale_dimension": "scaleDimension",
        "scale_dimension_var": "scaleDimensionVar",
        "scale_var": "scaleVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultComposite:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultCompositeImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        placement: typing.Optional[builtins.str] = None,
        placement_var: typing.Optional[builtins.str] = None,
        scale: typing.Optional[builtins.str] = None,
        scale_dimension: typing.Optional[builtins.str] = None,
        scale_dimension_var: typing.Optional[builtins.str] = None,
        scale_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param placement: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        :param placement_var: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        :param scale: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param scale_dimension: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        :param scale_dimension_var: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        :param scale_var: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        :param x_position: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultCompositeImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c42689f05177911d9a7dad1f9f9a6d45332e71e34109d1527602c51b149cf486)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument placement", value=placement, expected_type=type_hints["placement"])
            check_type(argname="argument placement_var", value=placement_var, expected_type=type_hints["placement_var"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument scale_dimension", value=scale_dimension, expected_type=type_hints["scale_dimension"])
            check_type(argname="argument scale_dimension_var", value=scale_dimension_var, expected_type=type_hints["scale_dimension_var"])
            check_type(argname="argument scale_var", value=scale_var, expected_type=type_hints["scale_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if placement is not None:
            self._values["placement"] = placement
        if placement_var is not None:
            self._values["placement_var"] = placement_var
        if scale is not None:
            self._values["scale"] = scale
        if scale_dimension is not None:
            self._values["scale_dimension"] = scale_dimension
        if scale_dimension_var is not None:
            self._values["scale_dimension_var"] = scale_dimension_var
        if scale_var is not None:
            self._values["scale_var"] = scale_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultCompositeImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultCompositeImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        '''
        result = self._values.get("placement")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement_var(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        '''
        result = self._values.get("placement_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        '''
        result = self._values.get("scale_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        '''
        result = self._values.get("scale_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        '''
        result = self._values.get("scale_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultComposite(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultCompositeImage",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultCompositeImage:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultCompositeImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultCompositeImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultCompositeImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b0dd546c76ff9ba76107a9c78fd35ae13115df8fe14dacb922be63b71d337bcb)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultCompositeImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultCompositeImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0b71b7567e4743375e975b4ad9f64e6607e800136b16b9f29fda6c7f908df4e1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultCompositeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultCompositeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f8534fbd68c6ea653f3c71d1910d46e7cc0151d000c7163d59c3cf49f917bb91)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultCompositeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a7214ece1a62e78781ecd722753635efb6fe9e07e187512c385c7aa8ab14d86a)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultCompositeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5557006d7c85d52bab99d62ee75fbf109ae7a3680bce99433d92f59a5d1b90a3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c3fca08f313055af0dd185ddf3b34c9c9fc64c1608366008b22dcbb20005ea59)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__272f35e1aa42227c552e9013aebbba1b7891370d664baf061c040c79b4536b93)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultComposite]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultComposite]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ad244de12005baf059bf183bc1a0216aeb53b84b431c8edaec24477c4540471f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultCompositeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultCompositeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__97bae8610cc6399dbf30cc5217e51ec251350ca3311ed677a38c491ed8618429)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultCompositeImage()

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPlacement")
    def reset_placement(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacement", []))

    @jsii.member(jsii_name="resetPlacementVar")
    def reset_placement_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacementVar", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetScaleDimension")
    def reset_scale_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimension", []))

    @jsii.member(jsii_name="resetScaleDimensionVar")
    def reset_scale_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimensionVar", []))

    @jsii.member(jsii_name="resetScaleVar")
    def reset_scale_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultCompositeImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultCompositeImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultCompositeImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="placementInput")
    def placement_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementInput"))

    @builtins.property
    @jsii.member(jsii_name="placementVarInput")
    def placement_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionInput")
    def scale_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVarInput")
    def scale_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleVarInput")
    def scale_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a77db58f851cc3528ad4102129a96c790a84c319bc323252c9beb211a628583)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e827f04be61b916dd9c9a7bd942669caeab8ebc1b1d7e0e3a763e6bf3ab66b3f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="placement")
    def placement(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placement"))

    @placement.setter
    def placement(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ddb0087276369f8b53851094bc72bdc55360f582c89d9a42e39d8e633ed43a49)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placement", value)

    @builtins.property
    @jsii.member(jsii_name="placementVar")
    def placement_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placementVar"))

    @placement_var.setter
    def placement_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c94e6607cdea6fd86e11d39d96b6f39e6b37c181f198e8401a9226aa8672efb4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placementVar", value)

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scale"))

    @scale.setter
    def scale(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cf8839617b8e0734c54f44651cedcc56990153da50489b2cd784ee77d33a5498)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scale", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimension")
    def scale_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimension"))

    @scale_dimension.setter
    def scale_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7fc7f639cd6027e1add89f9408fc0b39208329054ec3c73e1fbd4e0b3ccec8a2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimension", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVar")
    def scale_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimensionVar"))

    @scale_dimension_var.setter
    def scale_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__33be99ebf291d537138681d6001252009e43f1a145f236abbde8334fc22c78d4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="scaleVar")
    def scale_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleVar"))

    @scale_var.setter
    def scale_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__26754e8a7ea2a2f2c8058603ca5c10713387b3ada43c2a8b23b9c6ccc5fb88af)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__62eca33a4ce165743e057c64090bdf4245fe2d104ef202b33195fe9cd6e5c5fd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f99e2b9fc899fa631acaad9ca498a2de3a9687666faa6547c4147a301803d2c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d179065e6dfa35d6a16e2df3d3a081c1911576b2c8598fb3d6fe83f8d9e1407b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ab653f4f48faa5f30f542ed572232407b68d841d369c7297a781876b3740178)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultComposite]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultComposite]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultComposite]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9cda2bdfc3cf6318b3c41c1e7c878dc3eb14c3d42ca90cdb5e2eef04387fe92b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultCompound",
    jsii_struct_bases=[],
    name_mapping={"transformations": "transformations"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultCompound:
    def __init__(
        self,
        *,
        transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param transformations: transformations block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6eb56abbe4411e3b14bd09fcad1b3ab78b3f563a141d5c4f8e51abfe75a85e38)
            check_type(argname="argument transformations", value=transformations, expected_type=type_hints["transformations"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if transformations is not None:
            self._values["transformations"] = transformations

    @builtins.property
    def transformations(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultCompoundTransformations"]]]:
        '''transformations block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        result = self._values.get("transformations")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultCompoundTransformations"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultCompound(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultCompoundList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultCompoundList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dac40e0f49a246adef09fe7341da697c6d10ba61bdac92b1fa21cc74646186ea)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultCompoundOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__88c8c8b221564089a9c5349f642250680547b120ac0d9efdf807d47934622c59)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultCompoundOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f368f4536365f1885fb565708dcd3efaead89bd62a04040748bd3042b695fb7d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fba4f9e6d9c2b52e8e24c2118c4246745cf87bb7dfe9b92c57779c618c8bc4ac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d0df7cf47c8ef86c1a3c236be1fe42df28ab82be91d4109f21835ef99e66d14f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultCompound]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultCompound]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e180227284a68a0a7367b6868210822d89e9342764f5cdc81b9edb0b358e7dcc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultCompoundOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultCompoundOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__10697ae7d78d76a9f68ec34416fe03c3e92930e7c4d551127f99c996030331f9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformations")
    def put_transformations(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f3ac48b3fa5f414aaab6ebb8e90bfd865ed2c0e601db117e745ccf884a725d10)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTransformations", [value]))

    @jsii.member(jsii_name="resetTransformations")
    def reset_transformations(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformations", []))

    @builtins.property
    @jsii.member(jsii_name="transformations")
    def transformations(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultCompoundTransformationsList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultCompoundTransformationsList", jsii.get(self, "transformations"))

    @builtins.property
    @jsii.member(jsii_name="transformationsInput")
    def transformations_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultCompoundTransformations"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultCompoundTransformations"]]], jsii.get(self, "transformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultCompound]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultCompound]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultCompound]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__33010350d1c9663f41c091762f79721309e758c8735cdf43130c024a9d3ac908)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultCompoundTransformations",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultCompoundTransformations:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultCompoundTransformations(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultCompoundTransformationsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultCompoundTransformationsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__68ac169a2a314d36f6b5b98d4319ac904b33f836c34342eb18a5ca7c4a750e8d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultCompoundTransformationsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bd213ec20b9559dc7c2ca2ac94bef108f38ae305d3367c6473738d5767ea90ba)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultCompoundTransformationsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__69d267417602e314866c267132f140092585ce31b7df67f538eea21adafe9e85)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fec6818cabf8f97e82473af44a835a9f60dac84233cb9b9da7e4f528fe01ed8d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ad423ad855d7a3009953a72189c5f3036381735b21d6772eee559c4017e3b4df)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultCompoundTransformations]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultCompoundTransformations]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultCompoundTransformations]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__009a9de77f0f1996c4f6130999ae30357d57ca198f95685933007994735cefb1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultCompoundTransformationsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultCompoundTransformationsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9788c494ff4ece8f30997b02a43499f8cd7ab82b7ce53513bbf1e44efde6faef)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultCompoundTransformations]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultCompoundTransformations]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultCompoundTransformations]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bf1dec111b20a70fec23e925dc1fc3041ea252fc5e2d620f8de993fb3dfe8d33)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultContrast",
    jsii_struct_bases=[],
    name_mapping={
        "brightness": "brightness",
        "brightness_var": "brightnessVar",
        "contrast": "contrast",
        "contrast_var": "contrastVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultContrast:
    def __init__(
        self,
        *,
        brightness: typing.Optional[builtins.str] = None,
        brightness_var: typing.Optional[builtins.str] = None,
        contrast: typing.Optional[builtins.str] = None,
        contrast_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param brightness: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        :param brightness_var: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        :param contrast: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param contrast_var: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac9d4ccc6de42fa1154fd732229e978b23e81babf6fc94ea58f2c0dae7c799e5)
            check_type(argname="argument brightness", value=brightness, expected_type=type_hints["brightness"])
            check_type(argname="argument brightness_var", value=brightness_var, expected_type=type_hints["brightness_var"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument contrast_var", value=contrast_var, expected_type=type_hints["contrast_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if brightness is not None:
            self._values["brightness"] = brightness
        if brightness_var is not None:
            self._values["brightness_var"] = brightness_var
        if contrast is not None:
            self._values["contrast"] = contrast
        if contrast_var is not None:
            self._values["contrast_var"] = contrast_var

    @builtins.property
    def brightness(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        '''
        result = self._values.get("brightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def brightness_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        '''
        result = self._values.get("brightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        result = self._values.get("contrast_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultContrast(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultContrastList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultContrastList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__506c5b1f7bc451cf1575946095b5546c7ec12f7621c8e1a73298039e47c4498d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultContrastOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2c72ac37aaae4fa064aad81587b73fae0842e7508e04ec09afbaba3c50cef6cb)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultContrastOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__43fe81857e0f642afc7469472c815ecdc9ac1d24b7d018112b66c64ae833538e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__64b2ad82aadce0ff3949ceba01c8bf3c83b441973a0b5bc84e6a543a166f2aad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7b8b1ca48d71a367d47bd861d24b9863ecc51588ac85ef4798f8371d92ff74ba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultContrast]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultContrast]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__068ccb2a972d02a953d84c024a9a4417ccaef0af53649eddac981687b9798464)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultContrastOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultContrastOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__87f61080d00eb00c863c6cd5a7625a7dde09973f4bdffba7e471c7ec051e1efe)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetBrightness")
    def reset_brightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightness", []))

    @jsii.member(jsii_name="resetBrightnessVar")
    def reset_brightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightnessVar", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetContrastVar")
    def reset_contrast_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrastVar", []))

    @builtins.property
    @jsii.member(jsii_name="brightnessInput")
    def brightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="brightnessVarInput")
    def brightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastVarInput")
    def contrast_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="brightness")
    def brightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightness"))

    @brightness.setter
    def brightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9c68ea9992130877ab9d8662e8b94855ef2c4819fbf8b715b5e34b4ac7cfbe2a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightness", value)

    @builtins.property
    @jsii.member(jsii_name="brightnessVar")
    def brightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightnessVar"))

    @brightness_var.setter
    def brightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9287795bc60e63034404f0ad6a07d7e4282d8ec88c52727d7e6214a1dacefecb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrast"))

    @contrast.setter
    def contrast(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__51e1fe114a6706b5e477ab468feb93d747eebb833a24226799d2c02018080c7c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrast", value)

    @builtins.property
    @jsii.member(jsii_name="contrastVar")
    def contrast_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrastVar"))

    @contrast_var.setter
    def contrast_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__36b6b1e0dc6764c0f14b64c3b62f46a5aa5dbe7a3e35ee999a9ce083138a39ff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrastVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultContrast]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultContrast]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultContrast]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__04bcf17355b36ff3f90d934331ee65fa56b13ec96cd28cf0d72f1ebdd90caf36)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultCrop",
    jsii_struct_bases=[],
    name_mapping={
        "allow_expansion": "allowExpansion",
        "allow_expansion_var": "allowExpansionVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultCrop:
    def __init__(
        self,
        *,
        allow_expansion: typing.Optional[builtins.str] = None,
        allow_expansion_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_expansion: If cropping an area outside of the existing canvas, expands the image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        :param allow_expansion_var: If cropping an area outside of the existing canvas, expands the image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        :param gravity: Frame of reference for X and Y Positions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Frame of reference for X and Y Positions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The number of pixels to crop along the y-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The number of pixels to crop along the y-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The number of pixels to crop along the x-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The number of pixels to crop along the x-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        :param x_position: The x-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8adf423a63ee4c642c967140f2626284ea989dad45eb9387b51e9b055157ed22)
            check_type(argname="argument allow_expansion", value=allow_expansion, expected_type=type_hints["allow_expansion"])
            check_type(argname="argument allow_expansion_var", value=allow_expansion_var, expected_type=type_hints["allow_expansion_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if allow_expansion is not None:
            self._values["allow_expansion"] = allow_expansion
        if allow_expansion_var is not None:
            self._values["allow_expansion_var"] = allow_expansion_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def allow_expansion(self) -> typing.Optional[builtins.str]:
        '''If cropping an area outside of the existing canvas, expands the image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        '''
        result = self._values.get("allow_expansion")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def allow_expansion_var(self) -> typing.Optional[builtins.str]:
        '''If cropping an area outside of the existing canvas, expands the image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        '''
        result = self._values.get("allow_expansion_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Frame of reference for X and Y Positions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Frame of reference for X and Y Positions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the y-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the y-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the x-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the x-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a39145d5540b81c5525e623b15c1b57ed6ec5df5d1e4db47686f0e186e58e9ae)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__404d0a8c1a1d0ae6e3f1096c503f3747e6bbf7b6f9a3b0c9a552d52c69f996e2)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__49859aa95254f825f6f9fc0a2e2642edff3aee621a4166e0051fea530cb78bcf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__272ece5678cfdcafa22883b43fccfe9b898938fee04554d14844113740e7d738)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__84c0dc4ea5415ffd033014d8dfa35f61909b49425e3d38fe64fed44f6972dc89)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6bc517ceed310d7703f0f5af18d7ba73dbf4610a2947a3019f9fa96e743075ac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4b4650eefca8f016b0c4234bf5b7e7fce731821f20176ee5db88ff8851e0a296)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAllowExpansion")
    def reset_allow_expansion(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansion", []))

    @jsii.member(jsii_name="resetAllowExpansionVar")
    def reset_allow_expansion_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansionVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionInput")
    def allow_expansion_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVarInput")
    def allow_expansion_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansion")
    def allow_expansion(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansion"))

    @allow_expansion.setter
    def allow_expansion(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__35b923b6f61fc16a36864a0ebd1ceee05db8662fd3e14a0520e49aadbd7d9ae0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansion", value)

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVar")
    def allow_expansion_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansionVar"))

    @allow_expansion_var.setter
    def allow_expansion_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__02110451e3ac3ec444332f416b0fe6ea27d1cf4735769e3c11137894c362e6db)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansionVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__876dc4eceb4b575c7d78275a3b0b7dd3c8826a2328c2db5c82233d46d071c920)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__78d08a9337755567886eeda5fcfec2c1ec51328b47ed2c38464c230b89d73f0d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2bc9e9408b5fa84d7406ef0440ce424d20fcfd8b6093deffe49eeb646857cac5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d49ca1259cbb6988d9bd145c219dc40de537e4d7047b396a136f03c9ccf5e30b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2abd0cf35503571cacc02e44c53587ceb0a0e700f7966ab358e9c44451a64d79)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__99e5358fe377588328610727acea22053a488b593b04b3821f467d1d986e18bc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1caeb858a0321bba99ad315490c5e1386f6cb842a6edef5fc56c8ba4c9cba91e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1e9211e8127ad3f1d5e384924383cd014581e5d882c3bffd7bc9ac7a7c2a0ef0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e56894a26a373fbcdfaf9661980e3f040b32caffd9d15eddc37e8a826e678d74)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6a232bed0c867db13bf9924e25addc131017a29129a0ffe2786e639fccbfca99)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a9722419a51b919d7bd8053f5c2589fa411844e8a74efef8e4453ce5a8c82d6d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultFaceCrop",
    jsii_struct_bases=[],
    name_mapping={
        "algorithm": "algorithm",
        "algorithm_var": "algorithmVar",
        "confidence": "confidence",
        "confidence_var": "confidenceVar",
        "fail_gravity": "failGravity",
        "fail_gravity_var": "failGravityVar",
        "focus": "focus",
        "focus_var": "focusVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "padding": "padding",
        "padding_var": "paddingVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultFaceCrop:
    def __init__(
        self,
        *,
        algorithm: typing.Optional[builtins.str] = None,
        algorithm_var: typing.Optional[builtins.str] = None,
        confidence: typing.Optional[builtins.str] = None,
        confidence_var: typing.Optional[builtins.str] = None,
        fail_gravity: typing.Optional[builtins.str] = None,
        fail_gravity_var: typing.Optional[builtins.str] = None,
        focus: typing.Optional[builtins.str] = None,
        focus_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param algorithm: Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm DataAkamaiImagingPolicyImage#algorithm}
        :param algorithm_var: Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm_var DataAkamaiImagingPolicyImage#algorithm_var}
        :param confidence: With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image. Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence DataAkamaiImagingPolicyImage#confidence}
        :param confidence_var: With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image. Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence_var DataAkamaiImagingPolicyImage#confidence_var}
        :param fail_gravity: Controls placement of the crop if Image and Video Manager does not detect any faces in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        :param fail_gravity_var: Controls placement of the crop if Image and Video Manager does not detect any faces in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        :param focus: Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus DataAkamaiImagingPolicyImage#focus}
        :param focus_var: Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus_var DataAkamaiImagingPolicyImage#focus_var}
        :param gravity: Controls placement of the crop. Directions are relative to the face(s) plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Controls placement of the crop. Directions are relative to the face(s) plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param padding: The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        :param style: Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__782bc417996302f19ec0d65044bf6d3546e321dadab3d2ca3718819c758159f1)
            check_type(argname="argument algorithm", value=algorithm, expected_type=type_hints["algorithm"])
            check_type(argname="argument algorithm_var", value=algorithm_var, expected_type=type_hints["algorithm_var"])
            check_type(argname="argument confidence", value=confidence, expected_type=type_hints["confidence"])
            check_type(argname="argument confidence_var", value=confidence_var, expected_type=type_hints["confidence_var"])
            check_type(argname="argument fail_gravity", value=fail_gravity, expected_type=type_hints["fail_gravity"])
            check_type(argname="argument fail_gravity_var", value=fail_gravity_var, expected_type=type_hints["fail_gravity_var"])
            check_type(argname="argument focus", value=focus, expected_type=type_hints["focus"])
            check_type(argname="argument focus_var", value=focus_var, expected_type=type_hints["focus_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if algorithm is not None:
            self._values["algorithm"] = algorithm
        if algorithm_var is not None:
            self._values["algorithm_var"] = algorithm_var
        if confidence is not None:
            self._values["confidence"] = confidence
        if confidence_var is not None:
            self._values["confidence_var"] = confidence_var
        if fail_gravity is not None:
            self._values["fail_gravity"] = fail_gravity
        if fail_gravity_var is not None:
            self._values["fail_gravity_var"] = fail_gravity_var
        if focus is not None:
            self._values["focus"] = focus
        if focus_var is not None:
            self._values["focus_var"] = focus_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def algorithm(self) -> typing.Optional[builtins.str]:
        '''Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm DataAkamaiImagingPolicyImage#algorithm}
        '''
        result = self._values.get("algorithm")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def algorithm_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm_var DataAkamaiImagingPolicyImage#algorithm_var}
        '''
        result = self._values.get("algorithm_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def confidence(self) -> typing.Optional[builtins.str]:
        '''With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image.

        Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence DataAkamaiImagingPolicyImage#confidence}
        '''
        result = self._values.get("confidence")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def confidence_var(self) -> typing.Optional[builtins.str]:
        '''With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image.

        Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence_var DataAkamaiImagingPolicyImage#confidence_var}
        '''
        result = self._values.get("confidence_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any faces in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        '''
        result = self._values.get("fail_gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any faces in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        '''
        result = self._values.get("fail_gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def focus(self) -> typing.Optional[builtins.str]:
        '''Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus DataAkamaiImagingPolicyImage#focus}
        '''
        result = self._values.get("focus")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def focus_var(self) -> typing.Optional[builtins.str]:
        '''Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus_var DataAkamaiImagingPolicyImage#focus_var}
        '''
        result = self._values.get("focus_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the face(s) plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the face(s) plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultFaceCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultFaceCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultFaceCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dd44976cd32b5010dce1475bba5fb64b90972ba8134d04c6642bcb3db4fda095)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultFaceCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__49ae8846f6477ab0405397edd7e9972d5aa115f315f69f6e8913af882e65572c)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultFaceCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__39e32b2dca737204d5924208161104fa8ebcbc5e31c06594f6c741c963d5ce46)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8be901fb8ac99ace6f2e991126ae31d69642af79ebd8d5f6e3d41e102a1dfc1f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ce0b956ce32d02db7ce7d28cd72669d588a2cc98f8dbc560181867891bd8ba6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultFaceCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultFaceCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultFaceCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c3fb8fc4b93a20abb17c663dd5120547aa99e6f748d2b38720e0b061b5c9ebbf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultFaceCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultFaceCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ac48e9cd41e91bb974531560c1224e4c466f3a9046e2e291940ef3cc531fb9a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAlgorithm")
    def reset_algorithm(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAlgorithm", []))

    @jsii.member(jsii_name="resetAlgorithmVar")
    def reset_algorithm_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAlgorithmVar", []))

    @jsii.member(jsii_name="resetConfidence")
    def reset_confidence(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetConfidence", []))

    @jsii.member(jsii_name="resetConfidenceVar")
    def reset_confidence_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetConfidenceVar", []))

    @jsii.member(jsii_name="resetFailGravity")
    def reset_fail_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravity", []))

    @jsii.member(jsii_name="resetFailGravityVar")
    def reset_fail_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravityVar", []))

    @jsii.member(jsii_name="resetFocus")
    def reset_focus(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFocus", []))

    @jsii.member(jsii_name="resetFocusVar")
    def reset_focus_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFocusVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="algorithmInput")
    def algorithm_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "algorithmInput"))

    @builtins.property
    @jsii.member(jsii_name="algorithmVarInput")
    def algorithm_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "algorithmVarInput"))

    @builtins.property
    @jsii.member(jsii_name="confidenceInput")
    def confidence_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "confidenceInput"))

    @builtins.property
    @jsii.member(jsii_name="confidenceVarInput")
    def confidence_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "confidenceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityInput")
    def fail_gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityVarInput")
    def fail_gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="focusInput")
    def focus_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "focusInput"))

    @builtins.property
    @jsii.member(jsii_name="focusVarInput")
    def focus_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "focusVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="algorithm")
    def algorithm(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "algorithm"))

    @algorithm.setter
    def algorithm(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f5d81be1800e9e137e9a9146c75170a8808cc35d6120ccf3498816512b5f88b5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "algorithm", value)

    @builtins.property
    @jsii.member(jsii_name="algorithmVar")
    def algorithm_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "algorithmVar"))

    @algorithm_var.setter
    def algorithm_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4891d304eca6f010cf53f8d258f8d27240abe5ed700cbac993f2509d1fdecd56)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "algorithmVar", value)

    @builtins.property
    @jsii.member(jsii_name="confidence")
    def confidence(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "confidence"))

    @confidence.setter
    def confidence(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d903d5992c1d8b61c34b1170313fdef4976d3a81df22da544ce64b3744170774)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "confidence", value)

    @builtins.property
    @jsii.member(jsii_name="confidenceVar")
    def confidence_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "confidenceVar"))

    @confidence_var.setter
    def confidence_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9f30f033225fccdfc3b74139343e7dbbc7d25c710220aebf3a45ebafdf5bf18c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "confidenceVar", value)

    @builtins.property
    @jsii.member(jsii_name="failGravity")
    def fail_gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravity"))

    @fail_gravity.setter
    def fail_gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5dd710aaa6f82f4a98bdf04e196edb4acd9299f36f60e38a32e768d28de4075e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravity", value)

    @builtins.property
    @jsii.member(jsii_name="failGravityVar")
    def fail_gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravityVar"))

    @fail_gravity_var.setter
    def fail_gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__13a4253f470a0a83ec3407c99e3c119c9aac6551104b5151abc5cafd8532282e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="focus")
    def focus(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "focus"))

    @focus.setter
    def focus(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__981aa295991a61a4673d2b1c3bcf9db6970cd079817c7aa40a08b188ad9007be)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "focus", value)

    @builtins.property
    @jsii.member(jsii_name="focusVar")
    def focus_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "focusVar"))

    @focus_var.setter
    def focus_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__37ab15fca15f0a3e03f360502eb903178d857a33adcb27e345c7fe903dec94a7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "focusVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__41d78def70fdbbbed8ea2acb856419d323931239682155ccc2b7f7e0ebd9b24c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f5fabc72ff7fd95bdda8e9ef5784e4f29130aaa22c5e843648f0748a7d0c1e09)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4be78b7e662d3f9d66a8199904acef0a894104a1250646c998d25fbcadf6182f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5293d74186839dc1bc8b47893b38226d832c49ee4112494f27aee4298eb78366)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3d3f8413d503ff4728a8ba3f82b0a9d30e669c202301b045ded51bb3dbd5c5ad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f64be151594ab344f531f4a5949bb5e58b20d9e6b54b39e237df2374db4595d0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__12c85312b44ada705ad251765629f7fb29aba44d1f8524c472f3eac2526ea3eb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__21ace4ec9a43318c0084ed0f206ab0f75767bd584c02c94b0c0792c4889a4334)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__589d2f1fd952a305ede841677e58778ee2d83a1c235154201e8fe6f98e303e6e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f227af011d91f8a6ecb3ce3a02377b317d4116800d18568d6233ab081f029dc2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultFaceCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultFaceCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultFaceCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__472a8ab1b3d6e7b0ab06111cf97285a4b5753a6021ff97bd1b3f4dc4b233c995)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultFeatureCrop",
    jsii_struct_bases=[],
    name_mapping={
        "fail_gravity": "failGravity",
        "fail_gravity_var": "failGravityVar",
        "feature_radius": "featureRadius",
        "feature_radius_var": "featureRadiusVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "max_features": "maxFeatures",
        "max_features_var": "maxFeaturesVar",
        "min_feature_quality": "minFeatureQuality",
        "min_feature_quality_var": "minFeatureQualityVar",
        "padding": "padding",
        "padding_var": "paddingVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultFeatureCrop:
    def __init__(
        self,
        *,
        fail_gravity: typing.Optional[builtins.str] = None,
        fail_gravity_var: typing.Optional[builtins.str] = None,
        feature_radius: typing.Optional[builtins.str] = None,
        feature_radius_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        max_features: typing.Optional[builtins.str] = None,
        max_features_var: typing.Optional[builtins.str] = None,
        min_feature_quality: typing.Optional[builtins.str] = None,
        min_feature_quality_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fail_gravity: Controls placement of the crop if Image and Video Manager does not detect any features in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        :param fail_gravity_var: Controls placement of the crop if Image and Video Manager does not detect any features in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        :param feature_radius: The size in pixels of the important features to search for. If identified, two features never appear closer together than this value, ``8.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius DataAkamaiImagingPolicyImage#feature_radius}
        :param feature_radius_var: The size in pixels of the important features to search for. If identified, two features never appear closer together than this value, ``8.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius_var DataAkamaiImagingPolicyImage#feature_radius_var}
        :param gravity: Controls placement of the crop. Directions are relative to the region of interest plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Controls placement of the crop. Directions are relative to the region of interest plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param max_features: The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features DataAkamaiImagingPolicyImage#max_features}
        :param max_features_var: The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features_var DataAkamaiImagingPolicyImage#max_features_var}
        :param min_feature_quality: Determines the minimum quality level of the feature identified. To consider a feature important, the feature needs to surpass this value. Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality DataAkamaiImagingPolicyImage#min_feature_quality}
        :param min_feature_quality_var: Determines the minimum quality level of the feature identified. To consider a feature important, the feature needs to surpass this value. Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality_var DataAkamaiImagingPolicyImage#min_feature_quality_var}
        :param padding: Adds space around the region of interest. The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: Adds space around the region of interest. The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        :param style: Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__50f433f1b681c6d46ce0018a2d933cc882b28621f1c5d93a029578b5a2e70558)
            check_type(argname="argument fail_gravity", value=fail_gravity, expected_type=type_hints["fail_gravity"])
            check_type(argname="argument fail_gravity_var", value=fail_gravity_var, expected_type=type_hints["fail_gravity_var"])
            check_type(argname="argument feature_radius", value=feature_radius, expected_type=type_hints["feature_radius"])
            check_type(argname="argument feature_radius_var", value=feature_radius_var, expected_type=type_hints["feature_radius_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument max_features", value=max_features, expected_type=type_hints["max_features"])
            check_type(argname="argument max_features_var", value=max_features_var, expected_type=type_hints["max_features_var"])
            check_type(argname="argument min_feature_quality", value=min_feature_quality, expected_type=type_hints["min_feature_quality"])
            check_type(argname="argument min_feature_quality_var", value=min_feature_quality_var, expected_type=type_hints["min_feature_quality_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fail_gravity is not None:
            self._values["fail_gravity"] = fail_gravity
        if fail_gravity_var is not None:
            self._values["fail_gravity_var"] = fail_gravity_var
        if feature_radius is not None:
            self._values["feature_radius"] = feature_radius
        if feature_radius_var is not None:
            self._values["feature_radius_var"] = feature_radius_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if max_features is not None:
            self._values["max_features"] = max_features
        if max_features_var is not None:
            self._values["max_features_var"] = max_features_var
        if min_feature_quality is not None:
            self._values["min_feature_quality"] = min_feature_quality
        if min_feature_quality_var is not None:
            self._values["min_feature_quality_var"] = min_feature_quality_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def fail_gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any features in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        '''
        result = self._values.get("fail_gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any features in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        '''
        result = self._values.get("fail_gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feature_radius(self) -> typing.Optional[builtins.str]:
        '''The size in pixels of the important features to search for.

        If identified, two features never appear closer together than this value, ``8.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius DataAkamaiImagingPolicyImage#feature_radius}
        '''
        result = self._values.get("feature_radius")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feature_radius_var(self) -> typing.Optional[builtins.str]:
        '''The size in pixels of the important features to search for.

        If identified, two features never appear closer together than this value, ``8.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius_var DataAkamaiImagingPolicyImage#feature_radius_var}
        '''
        result = self._values.get("feature_radius_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the region of interest plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the region of interest plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def max_features(self) -> typing.Optional[builtins.str]:
        '''The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features DataAkamaiImagingPolicyImage#max_features}
        '''
        result = self._values.get("max_features")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def max_features_var(self) -> typing.Optional[builtins.str]:
        '''The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features_var DataAkamaiImagingPolicyImage#max_features_var}
        '''
        result = self._values.get("max_features_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def min_feature_quality(self) -> typing.Optional[builtins.str]:
        '''Determines the minimum quality level of the feature identified.

        To consider a feature important, the feature needs to surpass this value.  Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality DataAkamaiImagingPolicyImage#min_feature_quality}
        '''
        result = self._values.get("min_feature_quality")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def min_feature_quality_var(self) -> typing.Optional[builtins.str]:
        '''Determines the minimum quality level of the feature identified.

        To consider a feature important, the feature needs to surpass this value.  Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality_var DataAkamaiImagingPolicyImage#min_feature_quality_var}
        '''
        result = self._values.get("min_feature_quality_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''Adds space around the region of interest.

        The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''Adds space around the region of interest.

        The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultFeatureCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultFeatureCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultFeatureCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8bb99f052039e75c5c51c94827303a8e464c4209fa3d4a399ee43cffcd4e675a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultFeatureCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7f75be86ca1ab43cafea8a2df7926fc1b41bd85240a6e3ed7b91b84b75f653f9)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultFeatureCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__267220dbf0e3c50b379e37791e08739bd6f2e3011e9ffb92b4dfd78b6ebfc682)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__81389a994cce784c297ec1cf3e27889759d5088cc6b5cee5f391777c2874069d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__58f92b20c35e9a7fb6b705b8c795f4b8779644500bb24d40fcb7165dfb9acef6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultFeatureCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultFeatureCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultFeatureCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__29cb5912d2b4c3bafc6b89ae1ba5e8b75c3c19df1991a5f1f97f0a740ecddf28)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultFeatureCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultFeatureCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a34a4ea27235fbb9e4875ad05d31ab11840d45a9fb30d2401570c1dccd413b6e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetFailGravity")
    def reset_fail_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravity", []))

    @jsii.member(jsii_name="resetFailGravityVar")
    def reset_fail_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravityVar", []))

    @jsii.member(jsii_name="resetFeatureRadius")
    def reset_feature_radius(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureRadius", []))

    @jsii.member(jsii_name="resetFeatureRadiusVar")
    def reset_feature_radius_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureRadiusVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetMaxFeatures")
    def reset_max_features(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxFeatures", []))

    @jsii.member(jsii_name="resetMaxFeaturesVar")
    def reset_max_features_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxFeaturesVar", []))

    @jsii.member(jsii_name="resetMinFeatureQuality")
    def reset_min_feature_quality(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMinFeatureQuality", []))

    @jsii.member(jsii_name="resetMinFeatureQualityVar")
    def reset_min_feature_quality_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMinFeatureQualityVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="failGravityInput")
    def fail_gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityVarInput")
    def fail_gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featureRadiusInput")
    def feature_radius_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featureRadiusInput"))

    @builtins.property
    @jsii.member(jsii_name="featureRadiusVarInput")
    def feature_radius_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featureRadiusVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesInput")
    def max_features_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "maxFeaturesInput"))

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesVarInput")
    def max_features_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "maxFeaturesVarInput"))

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityInput")
    def min_feature_quality_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "minFeatureQualityInput"))

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityVarInput")
    def min_feature_quality_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "minFeatureQualityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravity")
    def fail_gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravity"))

    @fail_gravity.setter
    def fail_gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c2cc6bb393ba93431b484604f978ed4202ac96fcce1e62e6707481816f667eaf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravity", value)

    @builtins.property
    @jsii.member(jsii_name="failGravityVar")
    def fail_gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravityVar"))

    @fail_gravity_var.setter
    def fail_gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__634f5ed4aba69bb54f40755997656debbc863d3d04378a95886af73b7d1c4b30)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="featureRadius")
    def feature_radius(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featureRadius"))

    @feature_radius.setter
    def feature_radius(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b97bf1d3570fae9c79713883ac839152767c5e23d9d6832f79fd6ab12a63d20b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featureRadius", value)

    @builtins.property
    @jsii.member(jsii_name="featureRadiusVar")
    def feature_radius_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featureRadiusVar"))

    @feature_radius_var.setter
    def feature_radius_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f8caf9da0cd43d768384ad647dd2e645d88611727df95e983b865d44e4396bcf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featureRadiusVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9512bb3b5530df7b0a68a178fbf5ae8add65e9fae68f9825bc91d6175ca38891)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__51c6c4137027b40fe01387434e52f9a4fa302fad91ed39d596f6145544dc6296)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e8876c550f19e79cae957fe93f19188053af6872a9e5f2941d4f7718c160e0ee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__33b99006cef0e2338aa5db9a6271d2bad8e6a6766fe50295bbab4023f2628c58)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="maxFeatures")
    def max_features(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "maxFeatures"))

    @max_features.setter
    def max_features(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f0fa4311599a6e95ebc5af984429b4fe6d40e2d2a3da19d4c0d2c171cc2811f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "maxFeatures", value)

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesVar")
    def max_features_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "maxFeaturesVar"))

    @max_features_var.setter
    def max_features_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d14c28490c711e6de5cd41601683cf7608b41b1a8c1fd2bb3064f1cad4b7467c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "maxFeaturesVar", value)

    @builtins.property
    @jsii.member(jsii_name="minFeatureQuality")
    def min_feature_quality(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "minFeatureQuality"))

    @min_feature_quality.setter
    def min_feature_quality(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__49f3f737e5ce38fe6f3101d0cb656d22b996651a84694b5a7e0356f66e82a7b3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "minFeatureQuality", value)

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityVar")
    def min_feature_quality_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "minFeatureQualityVar"))

    @min_feature_quality_var.setter
    def min_feature_quality_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4b388de368261ed645c6e46377cbf3ba87f93ebbde4fa1bac9e05c3b51999e38)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "minFeatureQualityVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__576c96fa2a1e10a410d2d0a15a03862b83f30506256025aeda62fc36316f63e5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4b8008417a221d219810c23c0d253e60961b188d150d724b5bf893f71775aa00)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__16a81a61cc9eb638cdf287f5bee3f975285a2e79056e3629f7509c8388650d73)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__97f6a4d469534aaa732b6a9cd3efd55d85a73b1624903d74e00060ee268683c5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7a4272b08e3e4545a0b22324b3832a674475205e8a9da9c20bf4da2705bb8e3d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a94dfc3732b29424bcab8ef76b054a773a8f9fbde003a2d3b400872eef002fe7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultFeatureCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultFeatureCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultFeatureCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b8e897eac07b8d1f6869bd6229efc31f808ecb8ffbb9241f6a083aa5071415a7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultFitAndFill",
    jsii_struct_bases=[],
    name_mapping={
        "fill_transformation": "fillTransformation",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultFitAndFill:
    def __init__(
        self,
        *,
        fill_transformation: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultFitAndFillFillTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fill_transformation: fill_transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_transformation DataAkamaiImagingPolicyImage#fill_transformation}
        :param height: The height value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The width value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(fill_transformation, dict):
            fill_transformation = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultFitAndFillFillTransformation(**fill_transformation)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2c4ad2b8b58b8eb05a792ca85c81c3526c5ce4a206d9acb6674750a62d595175)
            check_type(argname="argument fill_transformation", value=fill_transformation, expected_type=type_hints["fill_transformation"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fill_transformation is not None:
            self._values["fill_transformation"] = fill_transformation
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def fill_transformation(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultFitAndFillFillTransformation"]:
        '''fill_transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_transformation DataAkamaiImagingPolicyImage#fill_transformation}
        '''
        result = self._values.get("fill_transformation")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultFitAndFillFillTransformation"], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultFitAndFill(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultFitAndFillFillTransformation",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultFitAndFillFillTransformation:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultFitAndFillFillTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultFitAndFillFillTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultFitAndFillFillTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e7f60ac2995a2b0c1f67891241d66ced2d1c9b4631a3dc0be1a86bda868f567f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultFitAndFillFillTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultFitAndFillFillTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultFitAndFillFillTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af0b52c5df76a9bbc2e6414e6c48eaed143d714ff34f09f5cd86801bed9140af)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultFitAndFillList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultFitAndFillList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b8f6ba64010f82b5575da40719573fa3aa199f7104eda0c496a11a26f4008c40)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultFitAndFillOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c8da504bc6c3df5ffeac428951997beb89bd951cdbe4037a66c0c22e073b85b0)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultFitAndFillOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4b0a92abb4e16d4a54e4b401a0b9d6f71b31aada78ee4f77f5f2ece8980d1fbc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__27b6f29e92b2123a8c73175ecafbccd30448fc669a8972df4a04694f2362ca2a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e56a0e319b04003c9fa19d7e19c833966171146ccb5ff56fbedde36b1cd18a76)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultFitAndFill]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultFitAndFill]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultFitAndFill]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0042413d3d0667f9f8816e4b5ac4880548a516db22bbe7fa46a622ffd9185ae0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultFitAndFillOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultFitAndFillOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__11e951298f3ee5a7134aee69568765c19cb2e892461dda345bdf5ed40fe52567)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putFillTransformation")
    def put_fill_transformation(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultFitAndFillFillTransformation()

        return typing.cast(None, jsii.invoke(self, "putFillTransformation", [value]))

    @jsii.member(jsii_name="resetFillTransformation")
    def reset_fill_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFillTransformation", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="fillTransformation")
    def fill_transformation(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultFitAndFillFillTransformationOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultFitAndFillFillTransformationOutputReference, jsii.get(self, "fillTransformation"))

    @builtins.property
    @jsii.member(jsii_name="fillTransformationInput")
    def fill_transformation_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultFitAndFillFillTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultFitAndFillFillTransformation], jsii.get(self, "fillTransformationInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1bcc462f913a3321d4f5bb90ca782dd562328f3e39f59d1f892c90fe90bdb258)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__804a0f69450cdf7de5bf049577e5a6c9813a5c423671d0fdc953740bad50ad16)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0bdd7315a44bb7ffa55e009b56f706eefce518f6d3f6bb18757f7627a5e9a52e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__278e45c75e372e737d8498ac4c3058fc4cb9020da6607904e5cc21904d7d76f5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultFitAndFill]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultFitAndFill]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultFitAndFill]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cf1c0a53e551a91efe362eafb49087978ff92086a81494ab769f67432a4d9233)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultGoop",
    jsii_struct_bases=[],
    name_mapping={
        "chaos": "chaos",
        "chaos_var": "chaosVar",
        "density": "density",
        "density_var": "densityVar",
        "power": "power",
        "power_var": "powerVar",
        "seed": "seed",
        "seed_var": "seedVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultGoop:
    def __init__(
        self,
        *,
        chaos: typing.Optional[builtins.str] = None,
        chaos_var: typing.Optional[builtins.str] = None,
        density: typing.Optional[builtins.str] = None,
        density_var: typing.Optional[builtins.str] = None,
        power: typing.Optional[builtins.str] = None,
        power_var: typing.Optional[builtins.str] = None,
        seed: typing.Optional[builtins.str] = None,
        seed_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param chaos: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        :param chaos_var: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        :param density: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        :param density_var: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        :param power: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        :param power_var: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        :param seed: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        :param seed_var: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa6a39e7c7c566b020cce494cfd1f543b41c1b664fd47c721d4be940e78db6f3)
            check_type(argname="argument chaos", value=chaos, expected_type=type_hints["chaos"])
            check_type(argname="argument chaos_var", value=chaos_var, expected_type=type_hints["chaos_var"])
            check_type(argname="argument density", value=density, expected_type=type_hints["density"])
            check_type(argname="argument density_var", value=density_var, expected_type=type_hints["density_var"])
            check_type(argname="argument power", value=power, expected_type=type_hints["power"])
            check_type(argname="argument power_var", value=power_var, expected_type=type_hints["power_var"])
            check_type(argname="argument seed", value=seed, expected_type=type_hints["seed"])
            check_type(argname="argument seed_var", value=seed_var, expected_type=type_hints["seed_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if chaos is not None:
            self._values["chaos"] = chaos
        if chaos_var is not None:
            self._values["chaos_var"] = chaos_var
        if density is not None:
            self._values["density"] = density
        if density_var is not None:
            self._values["density_var"] = density_var
        if power is not None:
            self._values["power"] = power
        if power_var is not None:
            self._values["power_var"] = power_var
        if seed is not None:
            self._values["seed"] = seed
        if seed_var is not None:
            self._values["seed_var"] = seed_var

    @builtins.property
    def chaos(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        '''
        result = self._values.get("chaos")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def chaos_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        '''
        result = self._values.get("chaos_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        '''
        result = self._values.get("density")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density_var(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        '''
        result = self._values.get("density_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        '''
        result = self._values.get("power")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power_var(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        '''
        result = self._values.get("power_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        '''
        result = self._values.get("seed")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed_var(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        result = self._values.get("seed_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultGoop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultGoopList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultGoopList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c3d3433c480a5ee5768610c1e9bf60846ccaa8bcccc3a4d1a3e94370a79e7b03)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultGoopOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__997d0bf7756c406ff0b5245341ae1fc2725b28cad2652ac276ab155a34c2295e)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultGoopOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f7684d81a5a10cc9bbe9a4ebb5f41f3079bb4d76b414aa3812e0ad65d670b25a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__86bd7ade3095fbdc8b2eabfde973c651e28a807d169cf322d1f38e6559be5216)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e4a60bfa39dfe8be2c560a131b153d92a9ede35796e2c1b9bc7ceed0203c779d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultGoop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultGoop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3edb662e8f7a162e3054b34aaaaaa6c6bdfc0901d1e2d61af2126052f2f1b170)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultGoopOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultGoopOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4bf024edb17edeadb31f5da34f38141d9c2a8c8633d8c7bd18e19e327a9bbb82)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetChaos")
    def reset_chaos(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaos", []))

    @jsii.member(jsii_name="resetChaosVar")
    def reset_chaos_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaosVar", []))

    @jsii.member(jsii_name="resetDensity")
    def reset_density(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensity", []))

    @jsii.member(jsii_name="resetDensityVar")
    def reset_density_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensityVar", []))

    @jsii.member(jsii_name="resetPower")
    def reset_power(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPower", []))

    @jsii.member(jsii_name="resetPowerVar")
    def reset_power_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPowerVar", []))

    @jsii.member(jsii_name="resetSeed")
    def reset_seed(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeed", []))

    @jsii.member(jsii_name="resetSeedVar")
    def reset_seed_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeedVar", []))

    @builtins.property
    @jsii.member(jsii_name="chaosInput")
    def chaos_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosInput"))

    @builtins.property
    @jsii.member(jsii_name="chaosVarInput")
    def chaos_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosVarInput"))

    @builtins.property
    @jsii.member(jsii_name="densityInput")
    def density_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityInput"))

    @builtins.property
    @jsii.member(jsii_name="densityVarInput")
    def density_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="powerInput")
    def power_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerInput"))

    @builtins.property
    @jsii.member(jsii_name="powerVarInput")
    def power_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerVarInput"))

    @builtins.property
    @jsii.member(jsii_name="seedInput")
    def seed_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedInput"))

    @builtins.property
    @jsii.member(jsii_name="seedVarInput")
    def seed_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedVarInput"))

    @builtins.property
    @jsii.member(jsii_name="chaos")
    def chaos(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaos"))

    @chaos.setter
    def chaos(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7244837a70649618e4ab3ca8bb1a6293b1793482ffbab38b222bbed115f97d86)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaos", value)

    @builtins.property
    @jsii.member(jsii_name="chaosVar")
    def chaos_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaosVar"))

    @chaos_var.setter
    def chaos_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e02dde66a19c2427f73e6a844ac9d3c079e36d21a7b730b2a101fa2a4aa1fd7c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaosVar", value)

    @builtins.property
    @jsii.member(jsii_name="density")
    def density(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "density"))

    @density.setter
    def density(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__05cc9fc7aeaef608d74c980ee9a4b4882fe561ca3d1ea6da140ae439ae2f1dea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "density", value)

    @builtins.property
    @jsii.member(jsii_name="densityVar")
    def density_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "densityVar"))

    @density_var.setter
    def density_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a11feedcdba12fa12076f3daabbe68c355c9e68cc2f6c961aadf5838d292525b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "densityVar", value)

    @builtins.property
    @jsii.member(jsii_name="power")
    def power(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "power"))

    @power.setter
    def power(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__807118e33aa9c4571d64b122ab2b6bd51cccceccef79bcf2e38f109c618606a9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "power", value)

    @builtins.property
    @jsii.member(jsii_name="powerVar")
    def power_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "powerVar"))

    @power_var.setter
    def power_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0fc3287b623702e522c0dcd1ddeba3885a6b801c83f1d36ff617bcd0ba6d9960)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "powerVar", value)

    @builtins.property
    @jsii.member(jsii_name="seed")
    def seed(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seed"))

    @seed.setter
    def seed(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d7fbd0ffc9ae4f25be0827b6cc25f452e50d57e137c4e7e1ea8f6c89338a0ef9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seed", value)

    @builtins.property
    @jsii.member(jsii_name="seedVar")
    def seed_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seedVar"))

    @seed_var.setter
    def seed_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f4e121f6cc6e519729c7e026759b28d55b2e980b222a437a3c5922bd15c77426)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seedVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultGoop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultGoop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultGoop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b18e5e9b1dc1c2a35072896795dcf116465edcfb2b2fc61bc4fea5fd8ca0c324)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultGrayscale",
    jsii_struct_bases=[],
    name_mapping={"type": "type", "type_var": "typeVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultGrayscale:
    def __init__(
        self,
        *,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param type: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f503f8f8a7dddb84b56140310d280c69de37569d7b2265bcb51aa0329ecbcf35)
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultGrayscale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultGrayscaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultGrayscaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cfb8a97f651f080cccc128dbb5191a1483d9eea5e253bff7f56dcdc1586436d0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultGrayscaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0067a02b59e247345826b7ca5d3489abe9897d395a954ba80ecdb970547841fe)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultGrayscaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bfcb2efc4c4ec2bf16bbc11a87897cba8c17ddf25f69d707e6542e9271220fa0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__02332b09a4c4315956f53b60e566cd77dbb59438a4abe5f52bffffeb9196f141)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b6e0a7a1bc7dd7ae06858654442fc7d6c6052b65b27f515c0c90056c94f0b967)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultGrayscale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultGrayscale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__128e0b62dad9cb259dce0d3b1eff1fe5da3eb17cec4920a66037fb3444a31cda)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultGrayscaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultGrayscaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8079cdbf25985df7d8a2d8f06b4c7ff70b52a78d81a76bcc53d3f4afd6f9b6d1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bbf05a61b176b0289a8da7e7822dbde1ca5388f660080da5c5f8cccf223bec61)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c0526c0b029a06f8f85c07faa0df7bed3496e703993c0f65f1a643fc300791f1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultGrayscale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultGrayscale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultGrayscale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8f0f46f7712d94c30db9c9115df6845d1f5fd2644e8a39ba5615ee1a38b2f901)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultHsl",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "lightness": "lightness",
        "lightness_var": "lightnessVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultHsl:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness: typing.Optional[builtins.str] = None,
        lightness_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        :param lightness_var: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7691de670fa63d787b120c70a56a709809456803d4d59d80dfe2d54c22b8765a)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness", value=lightness, expected_type=type_hints["lightness"])
            check_type(argname="argument lightness_var", value=lightness_var, expected_type=type_hints["lightness_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness is not None:
            self._values["lightness"] = lightness
        if lightness_var is not None:
            self._values["lightness_var"] = lightness_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        '''
        result = self._values.get("lightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        '''
        result = self._values.get("lightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultHsl(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultHslList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultHslList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d8f338f38e9e16e66183a15d3735d7e9f6df925f268430b96e58703b9de194d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultHslOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__79988428e7e258e9f1647704403593475456c6e9101421cd5054bc2939d822af)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultHslOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cf9ca091bc89cb00e3e3ac97407d143c6683777b03ee0eda0cf29407127eb6fb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d856997729ce15755dc553e9a03c4afa14103610e1f91b6d3f766581c9d4162)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea7b3335f84cc191a822e3ad48147a04bc0fb4d597cafb9401a8b3d1efca0d7f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultHsl]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultHsl]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0baf1b2bf23e393aeb64f1749fddedec00f5f2eb64736f082b86af98bc15f75c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultHslOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultHslOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__225eec2a88c254f2b6ac18c3af24a993657284511eda8732838445fb15e533ff)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightness")
    def reset_lightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightness", []))

    @jsii.member(jsii_name="resetLightnessVar")
    def reset_lightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessInput")
    def lightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessVarInput")
    def lightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ce0c8ed8915561c02ce24abca673eb237e549eec9bd01d65f88dca52e5338876)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ff5c7de2a44730796480725a6339a27f76624db9806a35adf10b8348741ebe91)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightness")
    def lightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightness"))

    @lightness.setter
    def lightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dc4ef1bedfefd5c4aec0a84302f9f75428d1f9bd86cd70eb4afa9eec8a23fb84)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightness", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessVar")
    def lightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessVar"))

    @lightness_var.setter
    def lightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a50882e3f0cb4628b2a5d208318426b9354a93c3f6573f6c3e21d2c15d03392)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__47c13c7d0657a36ddc8173f5f0272b0225ae84dd37f10797819cc4c24d3b60d5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__845ecbacd261d4e645bf546867ad663e31fad8a98da81871a4c7cae2b9ed02a7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultHsl]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultHsl]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultHsl]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a186aac3426c0c916af7748be8e2c4bd988d2e6d7ac3c1c9d13a23011988612f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultHsv",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultHsv:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        :param value: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__90c1047021657d77ba4e30d8c34f18b4228dd7ee9d24996c55fbd8aeda537302)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultHsv(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultHsvList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultHsvList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6b3c3dd14cd70ac771526b4e83f8204fd2186446e683a1d1c7ba751329898163)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultHsvOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7537af6324f420b2a9293e432ca140e519405eeb6b68a243764c8f0953c50cfd)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultHsvOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__97d0e8414cc5cb2f87efba25358bd5ec26d1e91ce97c6236e7d2288c6d8ca616)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aeb7317e21cded7a32e87143603a620981f9da8224182d71713dcef66d33652e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e92c589afe93a475f195b6edb0b07880007190ed8b0e822b0e98e3e6b016f750)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultHsv]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultHsv]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__43c721c854f1c79e6deebee5a2ae0150582eb6c188e9a52ec52d0481cd7a7df7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultHsvOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultHsvOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2c82f06205cf271102d3e719bb1fec457332e26ef5eb6d971f9823c18dd12d54)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__56c6636c69e30b45e751813f68be1b15f479fa7160e51b988d65970bff078a00)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__248cb90de4d9b07b7bdce0b927dd4eb372d6d505181e34b895f18fa3f9a62d73)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__415ed686d7af30590946a66ee4873f1eb1cd490d7d81e5f8c70c205fa3443bef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a378911dfd0b9e841658154867bdcc8b679da5269b5024246c18270326e19e4c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__67cf5a9e1bed1baf14e6073dbc47a4c434d4cec1947b22d940c389f3d8b8e55a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__04f5ea3553b338ec2e13f3edfb03541c1fc0d1bf6e7bb3c5e0602ba4c9b92380)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultHsv]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultHsv]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultHsv]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4d48ec92ffd2919bf40344796dd8c9977aa15141685f58bca914b119de34a46c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfDimension",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "dimension": "dimension",
        "dimension_var": "dimensionVar",
        "equal": "equal",
        "greater_than": "greaterThan",
        "less_than": "lessThan",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfDimension:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        dimension: typing.Optional[builtins.str] = None,
        dimension_var: typing.Optional[builtins.str] = None,
        equal: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionEqual", typing.Dict[builtins.str, typing.Any]]] = None,
        greater_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionGreaterThan", typing.Dict[builtins.str, typing.Any]]] = None,
        less_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionLessThan", typing.Dict[builtins.str, typing.Any]]] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param dimension: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        :param dimension_var: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        :param equal: equal block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        :param greater_than: greater_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        :param less_than: less_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        :param value: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionDefault(**default)
        if isinstance(equal, dict):
            equal = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionEqual(**equal)
        if isinstance(greater_than, dict):
            greater_than = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionGreaterThan(**greater_than)
        if isinstance(less_than, dict):
            less_than = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionLessThan(**less_than)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af1ebe7de976c7de8f139b0e0c4357074853b66f48e3b7b7ec0ef882da971c10)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument dimension", value=dimension, expected_type=type_hints["dimension"])
            check_type(argname="argument dimension_var", value=dimension_var, expected_type=type_hints["dimension_var"])
            check_type(argname="argument equal", value=equal, expected_type=type_hints["equal"])
            check_type(argname="argument greater_than", value=greater_than, expected_type=type_hints["greater_than"])
            check_type(argname="argument less_than", value=less_than, expected_type=type_hints["less_than"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if dimension is not None:
            self._values["dimension"] = dimension
        if dimension_var is not None:
            self._values["dimension_var"] = dimension_var
        if equal is not None:
            self._values["equal"] = equal
        if greater_than is not None:
            self._values["greater_than"] = greater_than
        if less_than is not None:
            self._values["less_than"] = less_than
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionDefault"], result)

    @builtins.property
    def dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        '''
        result = self._values.get("dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        '''
        result = self._values.get("dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def equal(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionEqual"]:
        '''equal block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        '''
        result = self._values.get("equal")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionEqual"], result)

    @builtins.property
    def greater_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionGreaterThan"]:
        '''greater_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        '''
        result = self._values.get("greater_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionGreaterThan"], result)

    @builtins.property
    def less_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionLessThan"]:
        '''less_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        '''
        result = self._values.get("less_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionLessThan"], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfDimension(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__944d927fa3b5244d3babc9032e739ff29739ed0ef5a65b3c2733136dee5f3175)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a0c561cc145c356e0433a6910be9e2c38b0bd396ad83e03afd2f18865a6ed992)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionEqual",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionEqual:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionEqual(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionEqualOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionEqualOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1efa3906a3d2bcbcdacfb93e8c1944b897c060415205b36a8fc35876d2a035ae)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionEqual], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionEqual],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9528f3d6e8f6a3249bd23bfe8e862d75446ea8df226649178cf048fa6cfc7ebf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionGreaterThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionGreaterThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionGreaterThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionGreaterThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionGreaterThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ee792446ed6f47ab5ed7111107bd56ba0c412d1ea54c35f4b7818344af9005b5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionGreaterThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionGreaterThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b84effa208aca5d571520db1bd81baed1781f85d3ca8ff2ac541a9a9afa32650)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionLessThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionLessThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionLessThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionLessThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionLessThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__86a3519286afcbfea73e766e5353f867b131f60780a27f29df5e7f3936e5fff0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionLessThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionLessThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__44a1b65af26fce345c4116283945d0c3558abf34f1a7a897f46380eb7cde78a1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__68d38912778c12a0e9d62d7f46f31f77b542b956b37864c339ce0bb8994dcaa7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__000d8a1b54d8dc4fbf79cff2bb4d6df828f5e3f14c9377e1e87ca992a2cb7df4)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c722454c1c8d53b45c3e6987d468c504c909bbd3a37615ad6043566ccca9cb9b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5e5f3426d3a1ef098074d164c8783079bfb8049e304eecb119e106f114b82123)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__38c2e2d99050ee35f4d45aa3bacbdf7f5d853f89c84ce7541b9ce7911b076fc1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfDimension]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfDimension]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__39ea41c542006f48b2dd2f1456cd225d81deb2a60ebbb06a9727bdb48b5d7853)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__45df24b236a4210400ea243c1e77f49e75dd9a37fc73feea5d40f6129147dddc)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putEqual")
    def put_equal(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionEqual()

        return typing.cast(None, jsii.invoke(self, "putEqual", [value]))

    @jsii.member(jsii_name="putGreaterThan")
    def put_greater_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionGreaterThan()

        return typing.cast(None, jsii.invoke(self, "putGreaterThan", [value]))

    @jsii.member(jsii_name="putLessThan")
    def put_less_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionLessThan()

        return typing.cast(None, jsii.invoke(self, "putLessThan", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetDimension")
    def reset_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimension", []))

    @jsii.member(jsii_name="resetDimensionVar")
    def reset_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimensionVar", []))

    @jsii.member(jsii_name="resetEqual")
    def reset_equal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEqual", []))

    @jsii.member(jsii_name="resetGreaterThan")
    def reset_greater_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGreaterThan", []))

    @jsii.member(jsii_name="resetLessThan")
    def reset_less_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLessThan", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="equal")
    def equal(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionEqualOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionEqualOutputReference, jsii.get(self, "equal"))

    @builtins.property
    @jsii.member(jsii_name="greaterThan")
    def greater_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionGreaterThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionGreaterThanOutputReference, jsii.get(self, "greaterThan"))

    @builtins.property
    @jsii.member(jsii_name="lessThan")
    def less_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionLessThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionLessThanOutputReference, jsii.get(self, "lessThan"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionInput")
    def dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionVarInput")
    def dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="equalInput")
    def equal_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionEqual], jsii.get(self, "equalInput"))

    @builtins.property
    @jsii.member(jsii_name="greaterThanInput")
    def greater_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionGreaterThan], jsii.get(self, "greaterThanInput"))

    @builtins.property
    @jsii.member(jsii_name="lessThanInput")
    def less_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionLessThan], jsii.get(self, "lessThanInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="dimension")
    def dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimension"))

    @dimension.setter
    def dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1c2f7c64901f19aa8c9f59bcff9fbc833c21e67b4b41b7f496365d388e1fd1ae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimension", value)

    @builtins.property
    @jsii.member(jsii_name="dimensionVar")
    def dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimensionVar"))

    @dimension_var.setter
    def dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c24afc633b49614f4db3b8a70d51d0ddd6795c899fcd1480aefd239d98ffd42a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__93780ae4a30adce6b73ce3f65717fa44868458d069e9b15ab0f288695a09089d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__315f9f6a30f6b5d7395acc45794d4eda0d44959db41d64528c10cc80d350ee99)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfDimension]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfDimension]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfDimension]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d4bcfb89e27282588817bcaa9d27b28051b9e6773580868a101899996b4bb1de)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfOrientation",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "landscape": "landscape",
        "portrait": "portrait",
        "square": "square",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfOrientation:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        landscape: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationLandscape", typing.Dict[builtins.str, typing.Any]]] = None,
        portrait: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationPortrait", typing.Dict[builtins.str, typing.Any]]] = None,
        square: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationSquare", typing.Dict[builtins.str, typing.Any]]] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param landscape: landscape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        :param portrait: portrait block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        :param square: square block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationDefault(**default)
        if isinstance(landscape, dict):
            landscape = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationLandscape(**landscape)
        if isinstance(portrait, dict):
            portrait = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationPortrait(**portrait)
        if isinstance(square, dict):
            square = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationSquare(**square)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9b89165aaaeafdb49f41d7187a04f9909c4010775e7fe6450fb3cb5798b6bf20)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument landscape", value=landscape, expected_type=type_hints["landscape"])
            check_type(argname="argument portrait", value=portrait, expected_type=type_hints["portrait"])
            check_type(argname="argument square", value=square, expected_type=type_hints["square"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if landscape is not None:
            self._values["landscape"] = landscape
        if portrait is not None:
            self._values["portrait"] = portrait
        if square is not None:
            self._values["square"] = square

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationDefault"], result)

    @builtins.property
    def landscape(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationLandscape"]:
        '''landscape block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        '''
        result = self._values.get("landscape")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationLandscape"], result)

    @builtins.property
    def portrait(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationPortrait"]:
        '''portrait block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        '''
        result = self._values.get("portrait")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationPortrait"], result)

    @builtins.property
    def square(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationSquare"]:
        '''square block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        result = self._values.get("square")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationSquare"], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfOrientation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3d4a311f318ceb14766b550edb530341dd8a4a798cf1b0ca92d1f7fe577ceeac)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0f90393813c5875a7fb77b13971607934dd7f872da5f42f749ceec2fd23aaddf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationLandscape",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationLandscape:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationLandscape(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationLandscapeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationLandscapeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f34e16074f842e0684919e044b89994fd29e53dd506bdb16c1df727bb7927c02)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationLandscape], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationLandscape],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__486ec0ee921c31b4bb06253c5ade761362a75ce5f19836cc2fe929c555bfd6a4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0fb487c80f10cb3326ec746a112239680e19b252de472b27b807609dd47c49b8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__30092acd834e9ccbb38fb9f8c8e1c752909c8ec47680b4e97385ef516252cdcf)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6041aa80f785c2c2985d2e57a31c7e8b986f1e1870c66e6432e913f92d9d311f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d7e2112c8913c3d756c7225706bcf190f3ece527b789956ec07bb586bcccff19)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7a6fabe2f0d684bc734f48e857e471dc2d31a0d1fe38f6a440075897aa4fdf24)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfOrientation]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfOrientation]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__718ba72375c51896d407400b1afb77da493a0b10ec474f559a0a2beb7b27b8e7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__25b45fad327664567151d5b1df41560bf48444651c2e47fe727f53e55aa1d837)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putLandscape")
    def put_landscape(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationLandscape()

        return typing.cast(None, jsii.invoke(self, "putLandscape", [value]))

    @jsii.member(jsii_name="putPortrait")
    def put_portrait(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationPortrait()

        return typing.cast(None, jsii.invoke(self, "putPortrait", [value]))

    @jsii.member(jsii_name="putSquare")
    def put_square(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationSquare()

        return typing.cast(None, jsii.invoke(self, "putSquare", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetLandscape")
    def reset_landscape(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLandscape", []))

    @jsii.member(jsii_name="resetPortrait")
    def reset_portrait(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPortrait", []))

    @jsii.member(jsii_name="resetSquare")
    def reset_square(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSquare", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="landscape")
    def landscape(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationLandscapeOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationLandscapeOutputReference, jsii.get(self, "landscape"))

    @builtins.property
    @jsii.member(jsii_name="portrait")
    def portrait(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationPortraitOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationPortraitOutputReference", jsii.get(self, "portrait"))

    @builtins.property
    @jsii.member(jsii_name="square")
    def square(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationSquareOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationSquareOutputReference", jsii.get(self, "square"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="landscapeInput")
    def landscape_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationLandscape], jsii.get(self, "landscapeInput"))

    @builtins.property
    @jsii.member(jsii_name="portraitInput")
    def portrait_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationPortrait"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationPortrait"], jsii.get(self, "portraitInput"))

    @builtins.property
    @jsii.member(jsii_name="squareInput")
    def square_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationSquare"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationSquare"], jsii.get(self, "squareInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfOrientation]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfOrientation]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfOrientation]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__264b3b5757761bf1249c25627ded0118d1429ca49c5ffbaf4c3eff6111628607)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationPortrait",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationPortrait:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationPortrait(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationPortraitOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationPortraitOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__869ff47fc597654f9ba0a32e6bd395a3c5a7eede611dea6ba94367307dc3a388)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationPortrait]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationPortrait], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationPortrait],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b26e0c9a1225e3fb87902f879abcda9b6821a642ebc98c96ebb1813b29bc2688)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationSquare",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationSquare:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationSquare(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationSquareOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationSquareOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7c63c0554e94c226aa4dd83e2d5b857f2bfd3c189f956bbfdad3e4291c57c3d3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationSquare]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationSquare], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationSquare],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7a071dad3aabcb9bb24e0bcc4dfb056a9afc89b17ad4c94d372dd00ae0d409af)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultImQuery",
    jsii_struct_bases=[],
    name_mapping={
        "allowed_transformations": "allowedTransformations",
        "query_var": "queryVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultImQuery:
    def __init__(
        self,
        *,
        allowed_transformations: typing.Sequence[builtins.str],
        query_var: builtins.str,
    ) -> None:
        '''
        :param allowed_transformations: Specifies the transformations that can be applied using the query string parameter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allowed_transformations DataAkamaiImagingPolicyImage#allowed_transformations}
        :param query_var: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#query_var DataAkamaiImagingPolicyImage#query_var}.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fe50f71382e309604dd21c3a045f35ae0ad099993ef1a438bd580e4383544000)
            check_type(argname="argument allowed_transformations", value=allowed_transformations, expected_type=type_hints["allowed_transformations"])
            check_type(argname="argument query_var", value=query_var, expected_type=type_hints["query_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "allowed_transformations": allowed_transformations,
            "query_var": query_var,
        }

    @builtins.property
    def allowed_transformations(self) -> typing.List[builtins.str]:
        '''Specifies the transformations that can be applied using the query string parameter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allowed_transformations DataAkamaiImagingPolicyImage#allowed_transformations}
        '''
        result = self._values.get("allowed_transformations")
        assert result is not None, "Required property 'allowed_transformations' is missing"
        return typing.cast(typing.List[builtins.str], result)

    @builtins.property
    def query_var(self) -> builtins.str:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#query_var DataAkamaiImagingPolicyImage#query_var}.'''
        result = self._values.get("query_var")
        assert result is not None, "Required property 'query_var' is missing"
        return typing.cast(builtins.str, result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultImQuery(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultImQueryList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultImQueryList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d5de499917ef11631667cd358344270d46c63fbba734cb0760cd0fb0a825cab0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultImQueryOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d088c96ecc3a920bff9bfad1eb6af754cd99ba7d1c5734cbc40d07652eaabb96)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultImQueryOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__98106dad64a84139ff85787aac53fdf3e43076ccedf22fe45da2202ece50201d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a99d1eea98bcf7f3643c1c4131c7dcd54c30a7a78ab1ba7c2d78b3deeb83ea90)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__98b2def30be85cccc9de4892d5c6e2a5cb1139fa4c7a1aacbee8c68b283e2704)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultImQuery]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultImQuery]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultImQuery]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2693406d45ec46dd36c0152c7e029d640377ba2a4e4daaca3a19873746b1f508)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultImQueryOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultImQueryOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cae4686139ba92d7ddde960f7d8780cac031ca0836c6693b82e8105d8c4e9335)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @builtins.property
    @jsii.member(jsii_name="allowedTransformationsInput")
    def allowed_transformations_input(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "allowedTransformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="queryVarInput")
    def query_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "queryVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowedTransformations")
    def allowed_transformations(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "allowedTransformations"))

    @allowed_transformations.setter
    def allowed_transformations(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7bfb978e5cc24ba8bf292ad22919c77731d08364065ae1e7d07c10e173661aa1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowedTransformations", value)

    @builtins.property
    @jsii.member(jsii_name="queryVar")
    def query_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "queryVar"))

    @query_var.setter
    def query_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2812e037cd192cbc4964aef3a986e5001c707773706807e2172ebc49ae0c2c98)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "queryVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultImQuery]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultImQuery]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultImQuery]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d82af6415f80491bed67eb8d386c5147f727db04d17e853402b48054d1f6f95)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultMaxColors",
    jsii_struct_bases=[],
    name_mapping={"colors": "colors", "colors_var": "colorsVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultMaxColors:
    def __init__(
        self,
        *,
        colors: typing.Optional[builtins.str] = None,
        colors_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param colors: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        :param colors_var: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__42ffa043547f04788fe4a59a7832b36fc4eab83267d26f637ba418e700f6578b)
            check_type(argname="argument colors", value=colors, expected_type=type_hints["colors"])
            check_type(argname="argument colors_var", value=colors_var, expected_type=type_hints["colors_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if colors is not None:
            self._values["colors"] = colors
        if colors_var is not None:
            self._values["colors_var"] = colors_var

    @builtins.property
    def colors(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        '''
        result = self._values.get("colors")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def colors_var(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        result = self._values.get("colors_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultMaxColors(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultMaxColorsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultMaxColorsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ffea54229552410a26a434d89d458756039752cab0e5bcdff0384a12bd532de5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultMaxColorsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb931c65fd17d0955d3d5677570a0f3735a5ef700e4b64bfd3e0f2fc300f4e30)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultMaxColorsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cf505a4fec0a2c68712e067f9b0144eca78ad20b9ea57739f94da6bc2a2a96e1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__43e0018c5bcab4545d9e7efe54529c9d31623f7f54ab271c780a9ff5bf4cfb2a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f0546cad81e0c47caf2da9ce49f5f569ab1594f082c6c78bdf318f15634cd170)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultMaxColors]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultMaxColors]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__09d71a6e777c205211a6d1040c8ecdfa9067077d5930a53438910e589e30cb12)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultMaxColorsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultMaxColorsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__974696152176d670d7ce4c5c74cbbde29dbd9b800e8023e629bccc51ca0ae349)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColors")
    def reset_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColors", []))

    @jsii.member(jsii_name="resetColorsVar")
    def reset_colors_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorsVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorsInput")
    def colors_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsInput"))

    @builtins.property
    @jsii.member(jsii_name="colorsVarInput")
    def colors_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsVarInput"))

    @builtins.property
    @jsii.member(jsii_name="colors")
    def colors(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colors"))

    @colors.setter
    def colors(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__368358d51838aa2188c7f56f847456e633ce5e326a5b9afd093d97f19899d76e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colors", value)

    @builtins.property
    @jsii.member(jsii_name="colorsVar")
    def colors_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorsVar"))

    @colors_var.setter
    def colors_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__88d5155a272abe08c26ba54b419a5b236408b12767c90866e8bbadf97439a783)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorsVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultMaxColors]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultMaxColors]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultMaxColors]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__63981a734d7604c8fe6ae8f937edc0ada8ee1d032779147b4aa2b86acf38b570)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultMirror",
    jsii_struct_bases=[],
    name_mapping={
        "horizontal": "horizontal",
        "horizontal_var": "horizontalVar",
        "vertical": "vertical",
        "vertical_var": "verticalVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultMirror:
    def __init__(
        self,
        *,
        horizontal: typing.Optional[builtins.str] = None,
        horizontal_var: typing.Optional[builtins.str] = None,
        vertical: typing.Optional[builtins.str] = None,
        vertical_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param horizontal: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        :param horizontal_var: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        :param vertical: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        :param vertical_var: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea7dabbe39868515353c0a465887feaf680998209b2da00eb29f836af52a5466)
            check_type(argname="argument horizontal", value=horizontal, expected_type=type_hints["horizontal"])
            check_type(argname="argument horizontal_var", value=horizontal_var, expected_type=type_hints["horizontal_var"])
            check_type(argname="argument vertical", value=vertical, expected_type=type_hints["vertical"])
            check_type(argname="argument vertical_var", value=vertical_var, expected_type=type_hints["vertical_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if horizontal is not None:
            self._values["horizontal"] = horizontal
        if horizontal_var is not None:
            self._values["horizontal_var"] = horizontal_var
        if vertical is not None:
            self._values["vertical"] = vertical
        if vertical_var is not None:
            self._values["vertical_var"] = vertical_var

    @builtins.property
    def horizontal(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        '''
        result = self._values.get("horizontal")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def horizontal_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        '''
        result = self._values.get("horizontal_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        '''
        result = self._values.get("vertical")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        result = self._values.get("vertical_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultMirror(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultMirrorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultMirrorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__589a82dd06254bfad2b18b3de2a485f877cfc433c4328e38b2657afe8e646772)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultMirrorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bcbfbd0e97c94dae22dcf01442afc8b8940b18f8d045d9d974a3515ad2ab9203)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultMirrorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6454a27b0afeeb2195067734580e4850e4c58ac5e2258efaad556453c1cabcd0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a76b17781b5afd2e1f062f51086288d6e5555c3b2292c52e3fe653c26cffddb4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e0964e10aa870a45c6eac7a458d8970a181ffafad68d748004b10128866896db)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultMirror]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultMirror]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4b1e91bf9ddbbeef9c1f409e5e0cc75870a6051599871aecc9dec7605046601f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultMirrorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultMirrorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__48db27545e00e5048c8542b2aeeeea5a62080c5dd7766a8ee16fe14891e15814)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHorizontal")
    def reset_horizontal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontal", []))

    @jsii.member(jsii_name="resetHorizontalVar")
    def reset_horizontal_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontalVar", []))

    @jsii.member(jsii_name="resetVertical")
    def reset_vertical(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVertical", []))

    @jsii.member(jsii_name="resetVerticalVar")
    def reset_vertical_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVerticalVar", []))

    @builtins.property
    @jsii.member(jsii_name="horizontalInput")
    def horizontal_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontalVarInput")
    def horizontal_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalInput")
    def vertical_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalVarInput")
    def vertical_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontal")
    def horizontal(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontal"))

    @horizontal.setter
    def horizontal(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a356e15173da732f4e818d5a1d9392b7100acebf01dd39c6cb235b946810d8d2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontal", value)

    @builtins.property
    @jsii.member(jsii_name="horizontalVar")
    def horizontal_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontalVar"))

    @horizontal_var.setter
    def horizontal_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2387f7d4d8157694b3e93a611bc971b0ca3ff901e97181cdd53fd770195dd04f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontalVar", value)

    @builtins.property
    @jsii.member(jsii_name="vertical")
    def vertical(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "vertical"))

    @vertical.setter
    def vertical(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb13dfc787461fa07c49614cd4f49328deb900f213bf8f3b8055fad3ac30d963)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "vertical", value)

    @builtins.property
    @jsii.member(jsii_name="verticalVar")
    def vertical_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "verticalVar"))

    @vertical_var.setter
    def vertical_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__37f0956ea53647d63ef226e6a8df845cd23fb8178b993a41441d072b62cbbd59)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "verticalVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultMirror]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultMirror]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultMirror]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__310889156f6eeea7b5c6437e9cb3dcf182fe58c78e87441a3f9e6a13baa29326)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultMonoHue",
    jsii_struct_bases=[],
    name_mapping={"hue": "hue", "hue_var": "hueVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultMonoHue:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3fbab4f6cbe62ad849aff98c30d17b58f28de85cf5ee02e8243e559ff13a136d)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultMonoHue(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultMonoHueList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultMonoHueList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__15d293ff2202913f63683c1c0d6bb37c9f19506412e5640d1b799da640df55b5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultMonoHueOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d28ac9eb8b5b623fb47156f6439e68ea1bc93235e1db754b884ea571ecb0a6e7)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultMonoHueOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8f7f1d4db77d7a804420d6c6f48c963607484fa21b8ddec9fdfd57a86b699e81)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c56566a8406c0f9675e70ea8cedfff1a8693b885ba94e1284fcae6671a3fc083)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b54aec9431cb5f39be2f433c8de3c8ebed99ca1419f037dcff09869047e658d5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultMonoHue]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultMonoHue]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d80ed24897fa9a39279b4c6c4b87631937a7e9f8d16543f9bc8ec758096b3351)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultMonoHueOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultMonoHueOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a7a7a566400b990558fa071bb3ccdfceb2f7e6e588bcf3c898136fa8caa88921)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__975d1e5a09154d62e4a7eb3c5c6868a98d4ace258a86b36581b50df1fdd9934a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9251cb7cacf2fa6e7f9777dab749199011cde52855cc6022dd11f88d46b4c676)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultMonoHue]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultMonoHue]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultMonoHue]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__74d4429f2eb34b57bee2dc9ee1125f13f622247663e87c0fd8558cc258776e0a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultOpacity",
    jsii_struct_bases=[],
    name_mapping={"opacity": "opacity", "opacity_var": "opacityVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultOpacity:
    def __init__(
        self,
        *,
        opacity: typing.Optional[builtins.str] = None,
        opacity_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param opacity: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param opacity_var: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__82a087971b7631fb651a2cf4f19c7b8a562c2cca537eaff5dd77e97e5abf8404)
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument opacity_var", value=opacity_var, expected_type=type_hints["opacity_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if opacity is not None:
            self._values["opacity"] = opacity
        if opacity_var is not None:
            self._values["opacity_var"] = opacity_var

    @builtins.property
    def opacity(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def opacity_var(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        result = self._values.get("opacity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultOpacity(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultOpacityList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultOpacityList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7bcbbd0e94c2f956f46d43e40b3f4b695bd39cb4be8d864e81f3ec7335dab193)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultOpacityOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__75b0a663077a7b9cd51effbc91ba64ec24363d40a839dec06a86b306cbc7eb58)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultOpacityOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c79964fdb7ef33fb65f4eb9753c69b512dad569bee6e9573bae0003eb1ce5be4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a9f38dcffd0020e05b7d3db42123dbdb39b1aa331c6d6ff315b8d9b784258a0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d645a97b0c35384b0c64a779487857e093a042abc575bca30db314abb1373df)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultOpacity]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultOpacity]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1aa3c2a75b4fc7f6370b45f21c182e3a64839287626132460db390ecea9e1ee0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultOpacityOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultOpacityOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__db8d365f9a24a355f27e39b6b724f8e1f3125c34f4e0d1f7617dc0f7f0a733a8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetOpacityVar")
    def reset_opacity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacityVar", []))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityVarInput")
    def opacity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacity"))

    @opacity.setter
    def opacity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bee6144ada15ae14ce129c91559e2718a80dee871d2d05faf1b4e537beda04b8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacity", value)

    @builtins.property
    @jsii.member(jsii_name="opacityVar")
    def opacity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacityVar"))

    @opacity_var.setter
    def opacity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5b90cf13b9a6741c7acf9692eeaab88467c41e218f5aca1830d2868526494a31)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacityVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultOpacity]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultOpacity]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultOpacity]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6fab2901594d6a77f848f44078090962779f0f2abe00f424a337757483cc2094)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4c8085c924c7debe73e43c036fa47f205f08530086e00af37e32fc204f0cf073)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putAppend")
    def put_append(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultAppend, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f8b43c55572c0194901d7f4a68c621d65d6b9a683f48184ec4ab933fde8f83e8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putAppend", [value]))

    @jsii.member(jsii_name="putAspectCrop")
    def put_aspect_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultAspectCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3bdf00e5e7abd4cf718544d83cd39d779094d0bb7bac2d883b1e80613321fa07)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putAspectCrop", [value]))

    @jsii.member(jsii_name="putBackgroundColor")
    def put_background_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2c397d556c8014676bb48dd0483d502fcab29cb49690d13df4f8fb83b122a803)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBackgroundColor", [value]))

    @jsii.member(jsii_name="putBlur")
    def put_blur(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultBlur, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__38e732c0f1c8008614f62d8b995cdae88e0700ecf2d31d5f03e0504b22f34efa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBlur", [value]))

    @jsii.member(jsii_name="putChromaKey")
    def put_chroma_key(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultChromaKey, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a86dcc5c1087ff537ba8ea560877241729459bf58b1ec49dc978e1ba31b8e82a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putChromaKey", [value]))

    @jsii.member(jsii_name="putComposite")
    def put_composite(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultComposite, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9f704b9714c69e62fb23c57043cc273a32f18e2ac47191e4a8bc7284d984cfed)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putComposite", [value]))

    @jsii.member(jsii_name="putCompound")
    def put_compound(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultCompound, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9de93e3b1905e615445557138d8ab49c0c4bb3993ef89f29f9a10af41a39f1d0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCompound", [value]))

    @jsii.member(jsii_name="putContrast")
    def put_contrast(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultContrast, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c599fbdfcfc50023d1be727743487534c631bcd529e27090b4c31da8b7a821a1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putContrast", [value]))

    @jsii.member(jsii_name="putCrop")
    def put_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4c29e5c9bfd16599f46ae40690b199a32ad6efe0596696702f155603885e998a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCrop", [value]))

    @jsii.member(jsii_name="putFaceCrop")
    def put_face_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultFaceCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d8452a9546df1e02da3f944adc9d3183a5e53ce568fac81f1bdaf22511ab75b1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFaceCrop", [value]))

    @jsii.member(jsii_name="putFeatureCrop")
    def put_feature_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultFeatureCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9351a92afde4edc22402d64d2c78a54e5ebdeefd185e6992c37e44e3b1ffaeda)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFeatureCrop", [value]))

    @jsii.member(jsii_name="putFitAndFill")
    def put_fit_and_fill(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultFitAndFill, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__92bb450f59af49eb3260418b2318cf13ec361b3cab77cd90f84dceaaa497cbe7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFitAndFill", [value]))

    @jsii.member(jsii_name="putGoop")
    def put_goop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultGoop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__19091315c09c61083810a3c14df41169103d4c82d23d1f79b2d3eaa3d8f5ab8d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGoop", [value]))

    @jsii.member(jsii_name="putGrayscale")
    def put_grayscale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultGrayscale, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ca84d2a5d2473fb64bcf68b45e929ef5ef754717622284873fdd9d91aceb1cf4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGrayscale", [value]))

    @jsii.member(jsii_name="putHsl")
    def put_hsl(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultHsl, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e316e707f2fd3806d1b984e5efcfae794acaa8413671dde64e85f8d2b4fd904)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsl", [value]))

    @jsii.member(jsii_name="putHsv")
    def put_hsv(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultHsv, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__16dcefd18a05b020714acac0c7c7fad4993ff62cd94a82f3da23db2f407ebb5c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsv", [value]))

    @jsii.member(jsii_name="putIfDimension")
    def put_if_dimension(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfDimension, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8b525166fdc6e4864886882fbba7de28787c30c893d059f90fe2f98ba97fd318)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfDimension", [value]))

    @jsii.member(jsii_name="putIfOrientation")
    def put_if_orientation(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ee3a4d2f0dfbe59fad128a809d53938f3ede62867db871e9ea62c26c9562deed)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfOrientation", [value]))

    @jsii.member(jsii_name="putImQuery")
    def put_im_query(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultImQuery, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5b6d73d408e23e9054325937904504b08fd23f6b2145d52e240d2c4d3811df88)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putImQuery", [value]))

    @jsii.member(jsii_name="putMaxColors")
    def put_max_colors(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultMaxColors, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a5caa054080fdfd49bb65b6b6a6b39ddc36a78c8c627f8f4a2c935106c5ddc6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMaxColors", [value]))

    @jsii.member(jsii_name="putMirror")
    def put_mirror(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultMirror, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d468a168d3a542ece41876286c97c9fab247448bf319db4af56eda973078c148)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMirror", [value]))

    @jsii.member(jsii_name="putMonoHue")
    def put_mono_hue(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultMonoHue, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fb6ec77a03df1c1d312fb376ae6c94b326363ee61430777e0cd60dad162bbea8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMonoHue", [value]))

    @jsii.member(jsii_name="putOpacity")
    def put_opacity(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultOpacity, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fcad4e5c76ea5b4523c5893ec2c065f188ae9eafac63b1afe6f03ad215e83bce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putOpacity", [value]))

    @jsii.member(jsii_name="putRegionOfInterestCrop")
    def put_region_of_interest_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultRegionOfInterestCrop", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a445ea8255a5d84da52e9240edc04e46c75f5a2f1f838552bf872886999509c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRegionOfInterestCrop", [value]))

    @jsii.member(jsii_name="putRelativeCrop")
    def put_relative_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultRelativeCrop", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__25eec169d02e48cceae34b1ff3ffa9962e2f1f0d96cc2d43e9e48a2af7c35ef8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRelativeCrop", [value]))

    @jsii.member(jsii_name="putRemoveColor")
    def put_remove_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultRemoveColor", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2b34f0475e115a24347df8cd579d98b1d1463d15db9d963fc85e116f7b4f6cf7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRemoveColor", [value]))

    @jsii.member(jsii_name="putResize")
    def put_resize(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultResize", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__66069e2ab17dbf340ae3ef8a8ca388050d1c2d734570062dda37144b00727a27)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putResize", [value]))

    @jsii.member(jsii_name="putRotate")
    def put_rotate(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultRotate", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f4743a48ff4a9d3100d9753fbd7d9606b4141c82a76442bbd4df51f4894519f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRotate", [value]))

    @jsii.member(jsii_name="putScale")
    def put_scale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultScale", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__59e12c334e13a7700adf1b8bbac61e60245d6d98c8d54aedb4f07c7e4aecd97b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putScale", [value]))

    @jsii.member(jsii_name="putShear")
    def put_shear(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultShear", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be3f4fdc1f30d9a8dad9f3a57eb17dc6a7bccd2067ac3fe15f16a93ee0da6f95)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putShear", [value]))

    @jsii.member(jsii_name="putTrim")
    def put_trim(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultTrim", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e13fc60fbeb8defd82765e7b328919d135fc093364c718ca3bbbef88654d9c76)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTrim", [value]))

    @jsii.member(jsii_name="putUnsharpMask")
    def put_unsharp_mask(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultUnsharpMask", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1da5ecf3bb87d334e888d5ce129fc291d97a3353293661d219c35e6e4e96cb2d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putUnsharpMask", [value]))

    @jsii.member(jsii_name="resetAppend")
    def reset_append(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAppend", []))

    @jsii.member(jsii_name="resetAspectCrop")
    def reset_aspect_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspectCrop", []))

    @jsii.member(jsii_name="resetBackgroundColor")
    def reset_background_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBackgroundColor", []))

    @jsii.member(jsii_name="resetBlur")
    def reset_blur(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBlur", []))

    @jsii.member(jsii_name="resetChromaKey")
    def reset_chroma_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChromaKey", []))

    @jsii.member(jsii_name="resetComposite")
    def reset_composite(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetComposite", []))

    @jsii.member(jsii_name="resetCompound")
    def reset_compound(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCompound", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetCrop")
    def reset_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCrop", []))

    @jsii.member(jsii_name="resetFaceCrop")
    def reset_face_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFaceCrop", []))

    @jsii.member(jsii_name="resetFeatureCrop")
    def reset_feature_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureCrop", []))

    @jsii.member(jsii_name="resetFitAndFill")
    def reset_fit_and_fill(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFitAndFill", []))

    @jsii.member(jsii_name="resetGoop")
    def reset_goop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGoop", []))

    @jsii.member(jsii_name="resetGrayscale")
    def reset_grayscale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGrayscale", []))

    @jsii.member(jsii_name="resetHsl")
    def reset_hsl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsl", []))

    @jsii.member(jsii_name="resetHsv")
    def reset_hsv(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsv", []))

    @jsii.member(jsii_name="resetIfDimension")
    def reset_if_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfDimension", []))

    @jsii.member(jsii_name="resetIfOrientation")
    def reset_if_orientation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfOrientation", []))

    @jsii.member(jsii_name="resetImQuery")
    def reset_im_query(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetImQuery", []))

    @jsii.member(jsii_name="resetMaxColors")
    def reset_max_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxColors", []))

    @jsii.member(jsii_name="resetMirror")
    def reset_mirror(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMirror", []))

    @jsii.member(jsii_name="resetMonoHue")
    def reset_mono_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonoHue", []))

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetRegionOfInterestCrop")
    def reset_region_of_interest_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRegionOfInterestCrop", []))

    @jsii.member(jsii_name="resetRelativeCrop")
    def reset_relative_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRelativeCrop", []))

    @jsii.member(jsii_name="resetRemoveColor")
    def reset_remove_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRemoveColor", []))

    @jsii.member(jsii_name="resetResize")
    def reset_resize(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetResize", []))

    @jsii.member(jsii_name="resetRotate")
    def reset_rotate(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRotate", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetShear")
    def reset_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetShear", []))

    @jsii.member(jsii_name="resetTrim")
    def reset_trim(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTrim", []))

    @jsii.member(jsii_name="resetUnsharpMask")
    def reset_unsharp_mask(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUnsharpMask", []))

    @builtins.property
    @jsii.member(jsii_name="append")
    def append(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultAppendList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultAppendList, jsii.get(self, "append"))

    @builtins.property
    @jsii.member(jsii_name="aspectCrop")
    def aspect_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultAspectCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultAspectCropList, jsii.get(self, "aspectCrop"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColor")
    def background_color(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultBackgroundColorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultBackgroundColorList, jsii.get(self, "backgroundColor"))

    @builtins.property
    @jsii.member(jsii_name="blur")
    def blur(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultBlurList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultBlurList, jsii.get(self, "blur"))

    @builtins.property
    @jsii.member(jsii_name="chromaKey")
    def chroma_key(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultChromaKeyList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultChromaKeyList, jsii.get(self, "chromaKey"))

    @builtins.property
    @jsii.member(jsii_name="composite")
    def composite(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultCompositeList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultCompositeList, jsii.get(self, "composite"))

    @builtins.property
    @jsii.member(jsii_name="compound")
    def compound(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultCompoundList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultCompoundList, jsii.get(self, "compound"))

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultContrastList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultContrastList, jsii.get(self, "contrast"))

    @builtins.property
    @jsii.member(jsii_name="crop")
    def crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultCropList, jsii.get(self, "crop"))

    @builtins.property
    @jsii.member(jsii_name="faceCrop")
    def face_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultFaceCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultFaceCropList, jsii.get(self, "faceCrop"))

    @builtins.property
    @jsii.member(jsii_name="featureCrop")
    def feature_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultFeatureCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultFeatureCropList, jsii.get(self, "featureCrop"))

    @builtins.property
    @jsii.member(jsii_name="fitAndFill")
    def fit_and_fill(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultFitAndFillList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultFitAndFillList, jsii.get(self, "fitAndFill"))

    @builtins.property
    @jsii.member(jsii_name="goop")
    def goop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultGoopList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultGoopList, jsii.get(self, "goop"))

    @builtins.property
    @jsii.member(jsii_name="grayscale")
    def grayscale(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultGrayscaleList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultGrayscaleList, jsii.get(self, "grayscale"))

    @builtins.property
    @jsii.member(jsii_name="hsl")
    def hsl(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultHslList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultHslList, jsii.get(self, "hsl"))

    @builtins.property
    @jsii.member(jsii_name="hsv")
    def hsv(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultHsvList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultHsvList, jsii.get(self, "hsv"))

    @builtins.property
    @jsii.member(jsii_name="ifDimension")
    def if_dimension(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionList, jsii.get(self, "ifDimension"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientation")
    def if_orientation(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationList, jsii.get(self, "ifOrientation"))

    @builtins.property
    @jsii.member(jsii_name="imQuery")
    def im_query(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultImQueryList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultImQueryList, jsii.get(self, "imQuery"))

    @builtins.property
    @jsii.member(jsii_name="maxColors")
    def max_colors(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultMaxColorsList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultMaxColorsList, jsii.get(self, "maxColors"))

    @builtins.property
    @jsii.member(jsii_name="mirror")
    def mirror(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultMirrorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultMirrorList, jsii.get(self, "mirror"))

    @builtins.property
    @jsii.member(jsii_name="monoHue")
    def mono_hue(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultMonoHueList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultMonoHueList, jsii.get(self, "monoHue"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultOpacityList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultOpacityList, jsii.get(self, "opacity"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestCrop")
    def region_of_interest_crop(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultRegionOfInterestCropList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultRegionOfInterestCropList", jsii.get(self, "regionOfInterestCrop"))

    @builtins.property
    @jsii.member(jsii_name="relativeCrop")
    def relative_crop(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultRelativeCropList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultRelativeCropList", jsii.get(self, "relativeCrop"))

    @builtins.property
    @jsii.member(jsii_name="removeColor")
    def remove_color(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultRemoveColorList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultRemoveColorList", jsii.get(self, "removeColor"))

    @builtins.property
    @jsii.member(jsii_name="resize")
    def resize(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultResizeList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultResizeList", jsii.get(self, "resize"))

    @builtins.property
    @jsii.member(jsii_name="rotate")
    def rotate(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultRotateList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultRotateList", jsii.get(self, "rotate"))

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultScaleList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultScaleList", jsii.get(self, "scale"))

    @builtins.property
    @jsii.member(jsii_name="shear")
    def shear(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultShearList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultShearList", jsii.get(self, "shear"))

    @builtins.property
    @jsii.member(jsii_name="trim")
    def trim(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultTrimList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultTrimList", jsii.get(self, "trim"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMask")
    def unsharp_mask(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultUnsharpMaskList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultUnsharpMaskList", jsii.get(self, "unsharpMask"))

    @builtins.property
    @jsii.member(jsii_name="appendInput")
    def append_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultAppend]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultAppend]]], jsii.get(self, "appendInput"))

    @builtins.property
    @jsii.member(jsii_name="aspectCropInput")
    def aspect_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultAspectCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultAspectCrop]]], jsii.get(self, "aspectCropInput"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColorInput")
    def background_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultBackgroundColor]]], jsii.get(self, "backgroundColorInput"))

    @builtins.property
    @jsii.member(jsii_name="blurInput")
    def blur_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultBlur]]], jsii.get(self, "blurInput"))

    @builtins.property
    @jsii.member(jsii_name="chromaKeyInput")
    def chroma_key_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultChromaKey]]], jsii.get(self, "chromaKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="compositeInput")
    def composite_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultComposite]]], jsii.get(self, "compositeInput"))

    @builtins.property
    @jsii.member(jsii_name="compoundInput")
    def compound_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultCompound]]], jsii.get(self, "compoundInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultContrast]]], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="cropInput")
    def crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultCrop]]], jsii.get(self, "cropInput"))

    @builtins.property
    @jsii.member(jsii_name="faceCropInput")
    def face_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultFaceCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultFaceCrop]]], jsii.get(self, "faceCropInput"))

    @builtins.property
    @jsii.member(jsii_name="featureCropInput")
    def feature_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultFeatureCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultFeatureCrop]]], jsii.get(self, "featureCropInput"))

    @builtins.property
    @jsii.member(jsii_name="fitAndFillInput")
    def fit_and_fill_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultFitAndFill]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultFitAndFill]]], jsii.get(self, "fitAndFillInput"))

    @builtins.property
    @jsii.member(jsii_name="goopInput")
    def goop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultGoop]]], jsii.get(self, "goopInput"))

    @builtins.property
    @jsii.member(jsii_name="grayscaleInput")
    def grayscale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultGrayscale]]], jsii.get(self, "grayscaleInput"))

    @builtins.property
    @jsii.member(jsii_name="hslInput")
    def hsl_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultHsl]]], jsii.get(self, "hslInput"))

    @builtins.property
    @jsii.member(jsii_name="hsvInput")
    def hsv_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultHsv]]], jsii.get(self, "hsvInput"))

    @builtins.property
    @jsii.member(jsii_name="ifDimensionInput")
    def if_dimension_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfDimension]]], jsii.get(self, "ifDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientationInput")
    def if_orientation_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfOrientation]]], jsii.get(self, "ifOrientationInput"))

    @builtins.property
    @jsii.member(jsii_name="imQueryInput")
    def im_query_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultImQuery]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultImQuery]]], jsii.get(self, "imQueryInput"))

    @builtins.property
    @jsii.member(jsii_name="maxColorsInput")
    def max_colors_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultMaxColors]]], jsii.get(self, "maxColorsInput"))

    @builtins.property
    @jsii.member(jsii_name="mirrorInput")
    def mirror_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultMirror]]], jsii.get(self, "mirrorInput"))

    @builtins.property
    @jsii.member(jsii_name="monoHueInput")
    def mono_hue_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultMonoHue]]], jsii.get(self, "monoHueInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultOpacity]]], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestCropInput")
    def region_of_interest_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultRegionOfInterestCrop"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultRegionOfInterestCrop"]]], jsii.get(self, "regionOfInterestCropInput"))

    @builtins.property
    @jsii.member(jsii_name="relativeCropInput")
    def relative_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultRelativeCrop"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultRelativeCrop"]]], jsii.get(self, "relativeCropInput"))

    @builtins.property
    @jsii.member(jsii_name="removeColorInput")
    def remove_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultRemoveColor"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultRemoveColor"]]], jsii.get(self, "removeColorInput"))

    @builtins.property
    @jsii.member(jsii_name="resizeInput")
    def resize_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultResize"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultResize"]]], jsii.get(self, "resizeInput"))

    @builtins.property
    @jsii.member(jsii_name="rotateInput")
    def rotate_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultRotate"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultRotate"]]], jsii.get(self, "rotateInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultScale"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultScale"]]], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="shearInput")
    def shear_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultShear"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultShear"]]], jsii.get(self, "shearInput"))

    @builtins.property
    @jsii.member(jsii_name="trimInput")
    def trim_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultTrim"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultTrim"]]], jsii.get(self, "trimInput"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMaskInput")
    def unsharp_mask_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultUnsharpMask"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultUnsharpMask"]]], jsii.get(self, "unsharpMaskInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0f90e028bf237b6377e1189feacb10cc9b48606474bb33ee91ed239190cc9175)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultRegionOfInterestCrop",
    jsii_struct_bases=[],
    name_mapping={
        "region_of_interest": "regionOfInterest",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultRegionOfInterestCrop:
    def __init__(
        self,
        *,
        region_of_interest: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultRegionOfInterestCropRegionOfInterest", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param region_of_interest: region_of_interest block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest DataAkamaiImagingPolicyImage#region_of_interest}
        :param gravity: The placement of the crop area relative to the specified area of interest. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: The placement of the crop area relative to the specified area of interest. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param style: Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(region_of_interest, dict):
            region_of_interest = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultRegionOfInterestCropRegionOfInterest(**region_of_interest)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fd53e6755be85f599a76daa7685dd19f61a6702ad2ce920b3befc35049b93419)
            check_type(argname="argument region_of_interest", value=region_of_interest, expected_type=type_hints["region_of_interest"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "region_of_interest": region_of_interest,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def region_of_interest(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultRegionOfInterestCropRegionOfInterest":
        '''region_of_interest block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest DataAkamaiImagingPolicyImage#region_of_interest}
        '''
        result = self._values.get("region_of_interest")
        assert result is not None, "Required property 'region_of_interest' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultRegionOfInterestCropRegionOfInterest", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''The placement of the crop area relative to the specified area of interest.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''The placement of the crop area relative to the specified area of interest.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultRegionOfInterestCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultRegionOfInterestCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultRegionOfInterestCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c260b0bd53315878d0650be382148034f468e6a1476e9e3f39dbf529f03ad1c7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultRegionOfInterestCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d5089e9fc53f99afb849b614aecb14853df8466c9126b2e099f39890fc62ea85)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultRegionOfInterestCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9dad22e8f09e58200542ce17bf9d6b58b370d3a238dc1f0a69b9f321ca9ce855)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__75aec14b0a355fad9cc44a8cbc5536414a954f64998452e4c9f26be40ccecf44)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8d41e6e5a8b0e7e80a9c808d207f89e0109463880388024976321836f70d46d3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultRegionOfInterestCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultRegionOfInterestCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultRegionOfInterestCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f2da5498b44143b2dc285c2b0b150d7192478ded2bf68b867eb67ccb0680e05)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultRegionOfInterestCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultRegionOfInterestCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__74718e0d4211521c834fc0d0cc69c871487427fdf3c4a08e9aff48a526275d46)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putRegionOfInterest")
    def put_region_of_interest(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultRegionOfInterestCropRegionOfInterest()

        return typing.cast(None, jsii.invoke(self, "putRegionOfInterest", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterest")
    def region_of_interest(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultRegionOfInterestCropRegionOfInterestOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultRegionOfInterestCropRegionOfInterestOutputReference", jsii.get(self, "regionOfInterest"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestInput")
    def region_of_interest_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultRegionOfInterestCropRegionOfInterest"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultRegionOfInterestCropRegionOfInterest"], jsii.get(self, "regionOfInterestInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__674bd44a0d371628c9d83165cfa19311dc3a5f7f7deadf2992f1adc1dc6beb3e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8fb423cab08a77289ba61f091b41caec1b5851e73be7124425d2ae8b412aab9a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__613bde77c8ffdc626726c1b32911f6d99bc17c756399b37d799857fb3709bed9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1b314b89dcd652f00aa9b7df9e6470f95f46bd0073b0f8f775f7abd5212723d3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__849859f1730ca70f6668041d6977b4ff24212b0fb374affbe4f1342619a9de38)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb4d5f543c60d429c6dd8da9ec85db5381c6e181d7eff79c8da30891d8ad0c66)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0387e0153c819baff08684ac549776b39c56bb55ed2a790196bf2df25b029eed)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__452dd01dee750abf8a85d887c14ea13861a5350635a541833041e868ef020291)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultRegionOfInterestCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultRegionOfInterestCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultRegionOfInterestCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b1c2d1640004473a52078088457375f0458f043d8896fb05d0b56aaa1f5646e6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultRegionOfInterestCropRegionOfInterest",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultRegionOfInterestCropRegionOfInterest:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultRegionOfInterestCropRegionOfInterest(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultRegionOfInterestCropRegionOfInterestOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultRegionOfInterestCropRegionOfInterestOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b2366a41e8175fa8ef28022ffc2387ee7ad9bdc0a3784cbea6055941fcd84156)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultRegionOfInterestCropRegionOfInterest]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultRegionOfInterestCropRegionOfInterest], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultRegionOfInterestCropRegionOfInterest],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__274742ded4e683638ac6c7ee7e1b6f7365d31fc0135ab4bd8f642397d85a739f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultRelativeCrop",
    jsii_struct_bases=[],
    name_mapping={
        "east": "east",
        "east_var": "eastVar",
        "north": "north",
        "north_var": "northVar",
        "south": "south",
        "south_var": "southVar",
        "west": "west",
        "west_var": "westVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultRelativeCrop:
    def __init__(
        self,
        *,
        east: typing.Optional[builtins.str] = None,
        east_var: typing.Optional[builtins.str] = None,
        north: typing.Optional[builtins.str] = None,
        north_var: typing.Optional[builtins.str] = None,
        south: typing.Optional[builtins.str] = None,
        south_var: typing.Optional[builtins.str] = None,
        west: typing.Optional[builtins.str] = None,
        west_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param east: The number of pixels to shrink or expand the right side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east DataAkamaiImagingPolicyImage#east}
        :param east_var: The number of pixels to shrink or expand the right side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east_var DataAkamaiImagingPolicyImage#east_var}
        :param north: The number of pixels to shrink or expand the top side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north DataAkamaiImagingPolicyImage#north}
        :param north_var: The number of pixels to shrink or expand the top side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north_var DataAkamaiImagingPolicyImage#north_var}
        :param south: The number of pixels to shrink or expand the bottom side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south DataAkamaiImagingPolicyImage#south}
        :param south_var: The number of pixels to shrink or expand the bottom side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south_var DataAkamaiImagingPolicyImage#south_var}
        :param west: The number of pixels to shrink or expand the left side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west DataAkamaiImagingPolicyImage#west}
        :param west_var: The number of pixels to shrink or expand the left side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west_var DataAkamaiImagingPolicyImage#west_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7e3d6deab0c1534318460b6d24be720e2b8c11d80c77d3eaa28bbcc6c058a78d)
            check_type(argname="argument east", value=east, expected_type=type_hints["east"])
            check_type(argname="argument east_var", value=east_var, expected_type=type_hints["east_var"])
            check_type(argname="argument north", value=north, expected_type=type_hints["north"])
            check_type(argname="argument north_var", value=north_var, expected_type=type_hints["north_var"])
            check_type(argname="argument south", value=south, expected_type=type_hints["south"])
            check_type(argname="argument south_var", value=south_var, expected_type=type_hints["south_var"])
            check_type(argname="argument west", value=west, expected_type=type_hints["west"])
            check_type(argname="argument west_var", value=west_var, expected_type=type_hints["west_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if east is not None:
            self._values["east"] = east
        if east_var is not None:
            self._values["east_var"] = east_var
        if north is not None:
            self._values["north"] = north
        if north_var is not None:
            self._values["north_var"] = north_var
        if south is not None:
            self._values["south"] = south
        if south_var is not None:
            self._values["south_var"] = south_var
        if west is not None:
            self._values["west"] = west
        if west_var is not None:
            self._values["west_var"] = west_var

    @builtins.property
    def east(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the right side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east DataAkamaiImagingPolicyImage#east}
        '''
        result = self._values.get("east")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def east_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the right side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east_var DataAkamaiImagingPolicyImage#east_var}
        '''
        result = self._values.get("east_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def north(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the top side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north DataAkamaiImagingPolicyImage#north}
        '''
        result = self._values.get("north")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def north_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the top side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north_var DataAkamaiImagingPolicyImage#north_var}
        '''
        result = self._values.get("north_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def south(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the bottom side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south DataAkamaiImagingPolicyImage#south}
        '''
        result = self._values.get("south")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def south_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the bottom side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south_var DataAkamaiImagingPolicyImage#south_var}
        '''
        result = self._values.get("south_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def west(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the left side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west DataAkamaiImagingPolicyImage#west}
        '''
        result = self._values.get("west")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def west_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the left side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west_var DataAkamaiImagingPolicyImage#west_var}
        '''
        result = self._values.get("west_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultRelativeCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultRelativeCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultRelativeCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__658ea4e65c025a81bdcd91be9784c5aaced7d8eb161f1d285243ddefcf0d1f43)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultRelativeCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cda1d52bd078f4702441b65500cdb8987b5223833dd7c5bc7aac926c50a93542)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultRelativeCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e4a7412bf30d3d019ea966ef4a5f8c0185e8399eb0c4f6f9f62f26a0571aead2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cf34e626f353ec11083a6b98f17ce66fcfb4d3a27f95b55cf343efb1906634dc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e75399c8f08044d4f492b44998857fa3a14e2ecfcc7a82695a28cf54f22e61de)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultRelativeCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultRelativeCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultRelativeCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a4ca9d9e0202e126e34ad2f0888697fb00fbae787d069684f052cc812e02a3e3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultRelativeCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultRelativeCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6db5f27114817e4d1af6b8faa48e5c60943967b5ac37ebd023a25efcb14dac7e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetEast")
    def reset_east(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEast", []))

    @jsii.member(jsii_name="resetEastVar")
    def reset_east_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEastVar", []))

    @jsii.member(jsii_name="resetNorth")
    def reset_north(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNorth", []))

    @jsii.member(jsii_name="resetNorthVar")
    def reset_north_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNorthVar", []))

    @jsii.member(jsii_name="resetSouth")
    def reset_south(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSouth", []))

    @jsii.member(jsii_name="resetSouthVar")
    def reset_south_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSouthVar", []))

    @jsii.member(jsii_name="resetWest")
    def reset_west(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWest", []))

    @jsii.member(jsii_name="resetWestVar")
    def reset_west_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWestVar", []))

    @builtins.property
    @jsii.member(jsii_name="eastInput")
    def east_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "eastInput"))

    @builtins.property
    @jsii.member(jsii_name="eastVarInput")
    def east_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "eastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="northInput")
    def north_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "northInput"))

    @builtins.property
    @jsii.member(jsii_name="northVarInput")
    def north_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "northVarInput"))

    @builtins.property
    @jsii.member(jsii_name="southInput")
    def south_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "southInput"))

    @builtins.property
    @jsii.member(jsii_name="southVarInput")
    def south_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "southVarInput"))

    @builtins.property
    @jsii.member(jsii_name="westInput")
    def west_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "westInput"))

    @builtins.property
    @jsii.member(jsii_name="westVarInput")
    def west_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "westVarInput"))

    @builtins.property
    @jsii.member(jsii_name="east")
    def east(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "east"))

    @east.setter
    def east(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__47c715a430714a1927095db1e2397b6796710cc15542a12bd58e3fe14dfec54f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "east", value)

    @builtins.property
    @jsii.member(jsii_name="eastVar")
    def east_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "eastVar"))

    @east_var.setter
    def east_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__905613dd810fa17479ebcb473c2e6297135a9b75493b1c02a08b7b0a79ba1afb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "eastVar", value)

    @builtins.property
    @jsii.member(jsii_name="north")
    def north(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "north"))

    @north.setter
    def north(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__860c319fe6f74a9db951d143a0840c32b4454bd1044fc918687bffddca1a753b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "north", value)

    @builtins.property
    @jsii.member(jsii_name="northVar")
    def north_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "northVar"))

    @north_var.setter
    def north_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__240caa97bbbb60f72144e5ae602b1ac4c0d95283a7bb362697565798b9d3f942)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "northVar", value)

    @builtins.property
    @jsii.member(jsii_name="south")
    def south(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "south"))

    @south.setter
    def south(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bcd097c0f521e5db8a8da84b74dbd4953c71afa7236f57a65e3551ffc599c54b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "south", value)

    @builtins.property
    @jsii.member(jsii_name="southVar")
    def south_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "southVar"))

    @south_var.setter
    def south_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ad90b539e2bdb085f9ee8326888acc99af813eb568ee2e383a1f3c428a780b85)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "southVar", value)

    @builtins.property
    @jsii.member(jsii_name="west")
    def west(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "west"))

    @west.setter
    def west(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f1790ecfb1a3ddb5ca9abe38d1d9e183b15c983b986a1a2f1fe2eb8d4d3a9a18)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "west", value)

    @builtins.property
    @jsii.member(jsii_name="westVar")
    def west_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "westVar"))

    @west_var.setter
    def west_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__81c12649bbf21355d833114f9d48cbd48146803d7aed9426699fe2a6108e4b0e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "westVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultRelativeCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultRelativeCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultRelativeCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__566c3c5d3b2de36e3d4c2ea9c3b575d6a2735a05a34099c62bb6f364929fa32c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultRemoveColor",
    jsii_struct_bases=[],
    name_mapping={
        "color": "color",
        "color_var": "colorVar",
        "feather": "feather",
        "feather_var": "featherVar",
        "tolerance": "tolerance",
        "tolerance_var": "toleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultRemoveColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
        feather: typing.Optional[builtins.str] = None,
        feather_var: typing.Optional[builtins.str] = None,
        tolerance: typing.Optional[builtins.str] = None,
        tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        :param feather: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        :param feather_var: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        :param tolerance: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        :param tolerance_var: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__93ffe7fa69b4fd6d7fd68bc20f70d601cdf724c1f5dcb2eec1b415ac6b195634)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
            check_type(argname="argument feather", value=feather, expected_type=type_hints["feather"])
            check_type(argname="argument feather_var", value=feather_var, expected_type=type_hints["feather_var"])
            check_type(argname="argument tolerance", value=tolerance, expected_type=type_hints["tolerance"])
            check_type(argname="argument tolerance_var", value=tolerance_var, expected_type=type_hints["tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var
        if feather is not None:
            self._values["feather"] = feather
        if feather_var is not None:
            self._values["feather_var"] = feather_var
        if tolerance is not None:
            self._values["tolerance"] = tolerance
        if tolerance_var is not None:
            self._values["tolerance_var"] = tolerance_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        '''
        result = self._values.get("feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather_var(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        '''
        result = self._values.get("feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        '''
        result = self._values.get("tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance_var(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        result = self._values.get("tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultRemoveColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultRemoveColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultRemoveColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b7d8b48f5e98fa7d850e2b6836de151fb2c4ad53a0c21b4cf45a5e429fd6cfc0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultRemoveColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2fe08dd72958cb5fc8d4d94e146e97a29affcb07280b21612341fbb188878bd3)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultRemoveColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__181de546865ccfda4ef2ac5b84dba2c45c6ed328ab8437fed34f33e3817f846c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a9d4874862cd8b9871a132dde03df28b6aba8493b5105f05969968e89b6b8ca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a3ec19117b7eae66efa3c7a744dbf0496ebc6d8931a55a0950f86e141bbe1cd3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultRemoveColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultRemoveColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultRemoveColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a316327bf97a780d15daf3d02133b1edaa103839d94cbff22028b1765c6900c8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultRemoveColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultRemoveColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f67d029f5d2b49df453fd570dff86f113c19d20abb6b4891c1cd965b59151249)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @jsii.member(jsii_name="resetFeather")
    def reset_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeather", []))

    @jsii.member(jsii_name="resetFeatherVar")
    def reset_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatherVar", []))

    @jsii.member(jsii_name="resetTolerance")
    def reset_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTolerance", []))

    @jsii.member(jsii_name="resetToleranceVar")
    def reset_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featherInput")
    def feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherInput"))

    @builtins.property
    @jsii.member(jsii_name="featherVarInput")
    def feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceInput")
    def tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceVarInput")
    def tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ccb39d2d32a1848b86c089226711b320de1d4363ed20956a334af737c2f1aa65)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f216fe7fa68d248eb4bf4e60a6e5dd17dcd578c16308b5bc52030e2888734bd1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="feather")
    def feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "feather"))

    @feather.setter
    def feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b138e392d1e259a7437128a73cffedac198a44cf542f931dc0ea786bbaa1c523)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "feather", value)

    @builtins.property
    @jsii.member(jsii_name="featherVar")
    def feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featherVar"))

    @feather_var.setter
    def feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dd1b67b98a9d8395317c8766c848bd35b1de355f56e179c3c8baa68ef41e2c1b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featherVar", value)

    @builtins.property
    @jsii.member(jsii_name="tolerance")
    def tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tolerance"))

    @tolerance.setter
    def tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__15a0b3aff12953688961c6eac5028c76d6c677c1d2158ac224f81f154860d537)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tolerance", value)

    @builtins.property
    @jsii.member(jsii_name="toleranceVar")
    def tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "toleranceVar"))

    @tolerance_var.setter
    def tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__561ba25d2e1b1d25703971a742e22d3b9b2eb0f657a9dcaaa74820f6ce0b70be)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "toleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultRemoveColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultRemoveColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultRemoveColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b08815dba1a52aedbdfeb9ec6933369c2c4490dce896abe2054d60e2f85131b5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultResize",
    jsii_struct_bases=[],
    name_mapping={
        "aspect": "aspect",
        "aspect_var": "aspectVar",
        "height": "height",
        "height_var": "heightVar",
        "type": "type",
        "type_var": "typeVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultResize:
    def __init__(
        self,
        *,
        aspect: typing.Optional[builtins.str] = None,
        aspect_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param aspect: Preserves the aspect ratio. Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect DataAkamaiImagingPolicyImage#aspect}
        :param aspect_var: Preserves the aspect ratio. Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_var DataAkamaiImagingPolicyImage#aspect_var}
        :param height: The height to resize the source image to. Must be set if height is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height to resize the source image to. Must be set if height is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param type: Sets constraints for the image resize. Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: Sets constraints for the image resize. Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        :param width: The width to resize the source image to. Must be set if width is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width to resize the source image to. Must be set if width is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__75495f45c596934978c5d1dffa159b74b7c596be1ee1d2088ef94175fae597e5)
            check_type(argname="argument aspect", value=aspect, expected_type=type_hints["aspect"])
            check_type(argname="argument aspect_var", value=aspect_var, expected_type=type_hints["aspect_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if aspect is not None:
            self._values["aspect"] = aspect
        if aspect_var is not None:
            self._values["aspect_var"] = aspect_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def aspect(self) -> typing.Optional[builtins.str]:
        '''Preserves the aspect ratio.

        Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect DataAkamaiImagingPolicyImage#aspect}
        '''
        result = self._values.get("aspect")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def aspect_var(self) -> typing.Optional[builtins.str]:
        '''Preserves the aspect ratio.

        Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_var DataAkamaiImagingPolicyImage#aspect_var}
        '''
        result = self._values.get("aspect_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height to resize the source image to. Must be set if height is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height to resize the source image to. Must be set if height is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''Sets constraints for the image resize.

        Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''Sets constraints for the image resize.

        Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width to resize the source image to. Must be set if width is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width to resize the source image to. Must be set if width is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultResize(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultResizeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultResizeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__33d287a35f23c4d1e6cf15bbf3307306f3a68befae66fe527c8d5cfa95e50ed8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultResizeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__003906d2471813aa254e92d28cd2c1cecba0a60e963881ee3497e67477a92674)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultResizeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa1f7aa831100a87b558ed8ec3b3f33306175e371dbaf7d866db6584671d35ea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fb1ac1bd20c2a10ed18bcbba085ed88ecbdba76de6f13acc681b491a7cfa35ce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6c3141b3c362974bf9f957d8483318699847abe126a2e332b05a55294381b5d8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultResize]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultResize]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultResize]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__59303389680cfbc080e18625d09ab28e7df6addb2197d8a3133167063049fc4c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultResizeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultResizeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__389da6281ae3e578d231f623e978885c8a7cfc7248751744eb8ad48037ace9f7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAspect")
    def reset_aspect(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspect", []))

    @jsii.member(jsii_name="resetAspectVar")
    def reset_aspect_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspectVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="aspectInput")
    def aspect_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "aspectInput"))

    @builtins.property
    @jsii.member(jsii_name="aspectVarInput")
    def aspect_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "aspectVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="aspect")
    def aspect(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "aspect"))

    @aspect.setter
    def aspect(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__20fc985cb77d96581a18485851fa7dcd5579de597c7d66cf1db4ce119b630896)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "aspect", value)

    @builtins.property
    @jsii.member(jsii_name="aspectVar")
    def aspect_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "aspectVar"))

    @aspect_var.setter
    def aspect_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6093273d32734ea865de0b6a8b276ccca0ad0eb58cbb5784f07bf31bff5f583c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "aspectVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__095abb9c7bb88128d10332537e157c62e936b5f1287f861faaf12edd16d9cdf0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c34f2151cd3198233525c5a075f81b16c4249e68b4f07b2591a8be1533974b94)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__377b27987b3191906c329b1d217639cde974cbaee56f9434a901734043db48ec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd0800d63cfa29c5c8306550aca23d8dd430727076960c22d102e803e09515ab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bad224f60fbe6b98269c027646c224880c8d69aa8af8d0d508f7be95afd87f5b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3315cad775cfe1332496fa451846a6d0a753c289d0171380dc4e13f850fd27ec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultResize]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultResize]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultResize]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__403a280be7bb4ccdab5c00317a83d9197500874f3f61ff1fa1e60983538586e5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultRotate",
    jsii_struct_bases=[],
    name_mapping={"degrees": "degrees", "degrees_var": "degreesVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultRotate:
    def __init__(
        self,
        *,
        degrees: typing.Optional[builtins.str] = None,
        degrees_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param degrees: The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees DataAkamaiImagingPolicyImage#degrees}
        :param degrees_var: The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees_var DataAkamaiImagingPolicyImage#degrees_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ec38955bb05d0aab91dc9c0b9d7887bbc5582a1711a2c4a553d46878f7fafc4d)
            check_type(argname="argument degrees", value=degrees, expected_type=type_hints["degrees"])
            check_type(argname="argument degrees_var", value=degrees_var, expected_type=type_hints["degrees_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if degrees is not None:
            self._values["degrees"] = degrees
        if degrees_var is not None:
            self._values["degrees_var"] = degrees_var

    @builtins.property
    def degrees(self) -> typing.Optional[builtins.str]:
        '''The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees DataAkamaiImagingPolicyImage#degrees}
        '''
        result = self._values.get("degrees")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def degrees_var(self) -> typing.Optional[builtins.str]:
        '''The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees_var DataAkamaiImagingPolicyImage#degrees_var}
        '''
        result = self._values.get("degrees_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultRotate(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultRotateList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultRotateList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__34045e9036e41964421b7c3fa2d5322e2a1d2af524e8f631592f2744f98999e0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultRotateOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__18d1263356082ae8e348f4ad4030f53c17f029e292d2b96e34ec703d5208df8b)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultRotateOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c183dc6c1517d9344f5c59d735569d1d8fd72393ffb3136ee61c12b0a8669e38)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__886af4c02c2c4f7fd16d51f1b75ee37baf8c11ee6212caec1490ed0b05dc8b37)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__62dcdf51924d301f94c2e7ee509c0d23354ca11248a715f10c25b86ff4076771)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultRotate]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultRotate]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultRotate]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__faeff8cda69cbfaa4e29505f4ae6ea4ac12c92418827f1981573ea4b00c0033d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultRotateOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultRotateOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__82cb700e2fd0119b368c6e068ff479e8b975ee0a6155ae2c6ba28a02303bd81c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetDegrees")
    def reset_degrees(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDegrees", []))

    @jsii.member(jsii_name="resetDegreesVar")
    def reset_degrees_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDegreesVar", []))

    @builtins.property
    @jsii.member(jsii_name="degreesInput")
    def degrees_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "degreesInput"))

    @builtins.property
    @jsii.member(jsii_name="degreesVarInput")
    def degrees_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "degreesVarInput"))

    @builtins.property
    @jsii.member(jsii_name="degrees")
    def degrees(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "degrees"))

    @degrees.setter
    def degrees(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a27cf833bf76dacdacd3b85020f78d5f5ae3e47afc96128c764744854bef3909)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "degrees", value)

    @builtins.property
    @jsii.member(jsii_name="degreesVar")
    def degrees_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "degreesVar"))

    @degrees_var.setter
    def degrees_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e88500e30aeae14ee4188d47bc071db4d4288dd4d95379ad20babb89cc84403c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "degreesVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultRotate]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultRotate]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultRotate]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__173eb762a611f2fcffc8e032e036397f7aaf4ec6f026d9303198e90495ab4a8a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultScale",
    jsii_struct_bases=[],
    name_mapping={
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultScale:
    def __init__(
        self,
        *,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param height: Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged. Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged. Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f9c4ffb7737225449fa7b87f063f9d4c1fc15680afe8458cf55c3b86ca8e7c95)
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size.

        Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size.

        Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged.

        Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged.

        Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultScale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultScaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultScaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d513cd11758f865b4a489db8bc54c749ecda28e00f50f0836dd027e92d51fded)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultScaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__139b0d7328b3de8bec3f8d145a1f2dab6e31346e67bbb820599da1bde8eb757f)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultScaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5539b09c3a155ca0c122639644f1d2afce87a3189a6150ad399ea0bf94c5ade8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0101e7f678d426e5c2b8acef2c96c31bc2d2032f5329295593dd594d8bbcd822)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ec59b99d32085fa30c24e9adbd574669b55462b6e8b75c6cbf0a2f7feaba13c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultScale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultScale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultScale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__54cb9661d68d2a25b29446fe8ff47dfc7037eec9e400d2db39d485902987153d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultScaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultScaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cdb5d825c401edd3462dd345d033a5306bafddfc2c688928d962f838a9b3f997)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__44c1aee791debb3cd0e9535f016ddc470801a21d470178609dea3d519eed8c35)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d85f2eca106a4cfeecf09804b1553ed321c8a44237728193e1151bd1c0db6db8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8045af63be1efe768a1e2c54e23c8e36d5f5b4f748ede0fdd97d58a84f71db8c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__710db0cba61c53aa4905d29b37b6b306689e9de272adbe8b18bcf9a27484234c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultScale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultScale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultScale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__da23c1d354ca36d330d3f5af2c0fda7823e5867a0104860130c749be60626c93)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultShear",
    jsii_struct_bases=[],
    name_mapping={
        "x_shear": "xShear",
        "x_shear_var": "xShearVar",
        "y_shear": "yShear",
        "y_shear_var": "yShearVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultShear:
    def __init__(
        self,
        *,
        x_shear: typing.Optional[builtins.str] = None,
        x_shear_var: typing.Optional[builtins.str] = None,
        y_shear: typing.Optional[builtins.str] = None,
        y_shear_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param x_shear: The amount to shear along the x-axis, measured in multiples of the image's width. Must be set if yShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear DataAkamaiImagingPolicyImage#x_shear}
        :param x_shear_var: The amount to shear along the x-axis, measured in multiples of the image's width. Must be set if yShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear_var DataAkamaiImagingPolicyImage#x_shear_var}
        :param y_shear: The amount to shear along the y-axis, measured in multiples of the image's height. Must be set if xShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear DataAkamaiImagingPolicyImage#y_shear}
        :param y_shear_var: The amount to shear along the y-axis, measured in multiples of the image's height. Must be set if xShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear_var DataAkamaiImagingPolicyImage#y_shear_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__966dddfe0a1dc2cf401b3661652bc84b255154e2fcda746457e0ef0f1e8a0ef5)
            check_type(argname="argument x_shear", value=x_shear, expected_type=type_hints["x_shear"])
            check_type(argname="argument x_shear_var", value=x_shear_var, expected_type=type_hints["x_shear_var"])
            check_type(argname="argument y_shear", value=y_shear, expected_type=type_hints["y_shear"])
            check_type(argname="argument y_shear_var", value=y_shear_var, expected_type=type_hints["y_shear_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if x_shear is not None:
            self._values["x_shear"] = x_shear
        if x_shear_var is not None:
            self._values["x_shear_var"] = x_shear_var
        if y_shear is not None:
            self._values["y_shear"] = y_shear
        if y_shear_var is not None:
            self._values["y_shear_var"] = y_shear_var

    @builtins.property
    def x_shear(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the x-axis, measured in multiples of the image's width.

        Must be set if yShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear DataAkamaiImagingPolicyImage#x_shear}
        '''
        result = self._values.get("x_shear")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_shear_var(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the x-axis, measured in multiples of the image's width.

        Must be set if yShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear_var DataAkamaiImagingPolicyImage#x_shear_var}
        '''
        result = self._values.get("x_shear_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_shear(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the y-axis, measured in multiples of the image's height.

        Must be set if xShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear DataAkamaiImagingPolicyImage#y_shear}
        '''
        result = self._values.get("y_shear")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_shear_var(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the y-axis, measured in multiples of the image's height.

        Must be set if xShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear_var DataAkamaiImagingPolicyImage#y_shear_var}
        '''
        result = self._values.get("y_shear_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultShear(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultShearList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultShearList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6a0fd4639b02722efb8c6153ffcbedafeb3e4a4473ae51dbd3292f06f040dbd0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultShearOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__94b05984892c96943b5d60eea2234451a7e6bda03c91b593d8eaf8500d3ba7bb)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultShearOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0f0bd1662442d230c8857a965d5f03814a7033f980e587ed0250bb76008b2bd4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b9af63822f5b94e6c221b604351fc06144be914954f213328b3dfa314563dab5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a4742315970302309eb652f2872af14e2db0984a573bf6135a07c26592e67e43)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultShear]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultShear]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultShear]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__71bf6095630472eb24bfd6547dd5ec218b0e3c2b1601e9a430242394d5b9d47e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultShearOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultShearOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c4660fcb7cd1e77fba7e71a36f835f2962df0c49440c0ab10905371f04e1fdf6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetXShear")
    def reset_x_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXShear", []))

    @jsii.member(jsii_name="resetXShearVar")
    def reset_x_shear_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXShearVar", []))

    @jsii.member(jsii_name="resetYShear")
    def reset_y_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYShear", []))

    @jsii.member(jsii_name="resetYShearVar")
    def reset_y_shear_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYShearVar", []))

    @builtins.property
    @jsii.member(jsii_name="xShearInput")
    def x_shear_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xShearInput"))

    @builtins.property
    @jsii.member(jsii_name="xShearVarInput")
    def x_shear_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xShearVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yShearInput")
    def y_shear_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yShearInput"))

    @builtins.property
    @jsii.member(jsii_name="yShearVarInput")
    def y_shear_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yShearVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xShear")
    def x_shear(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xShear"))

    @x_shear.setter
    def x_shear(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__874d4603d6dbf23bc698c1f7073c69c6130c543ed8cfcb631401a3fbfedcb6f3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xShear", value)

    @builtins.property
    @jsii.member(jsii_name="xShearVar")
    def x_shear_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xShearVar"))

    @x_shear_var.setter
    def x_shear_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__779a8b1761b13133937bfaa485b4fbdc00fcec6f362c8872ae1449f34e65f7b6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xShearVar", value)

    @builtins.property
    @jsii.member(jsii_name="yShear")
    def y_shear(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yShear"))

    @y_shear.setter
    def y_shear(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dfa097d591c204c95f8d82e71678a3def0586cd893780d493c4ec6b1eb5d8f96)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yShear", value)

    @builtins.property
    @jsii.member(jsii_name="yShearVar")
    def y_shear_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yShearVar"))

    @y_shear_var.setter
    def y_shear_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5b63d7f5e15eeb3445a610ffd27ff0ce239f202574ffe9bb9c4011bbdf3795c6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yShearVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultShear]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultShear]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultShear]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d0b1bbd19108f7840db8e8bc0ddd4cbe498665fd0a0fa419cafd54e1a0853853)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultTrim",
    jsii_struct_bases=[],
    name_mapping={
        "fuzz": "fuzz",
        "fuzz_var": "fuzzVar",
        "padding": "padding",
        "padding_var": "paddingVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultTrim:
    def __init__(
        self,
        *,
        fuzz: typing.Optional[builtins.str] = None,
        fuzz_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fuzz: The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz DataAkamaiImagingPolicyImage#fuzz}
        :param fuzz_var: The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz_var DataAkamaiImagingPolicyImage#fuzz_var}
        :param padding: The amount of padding in pixels to add to the trimmed image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: The amount of padding in pixels to add to the trimmed image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2fc2d1927970b2efe97aefeb86ed25c213f4f036de0882220703b3c5dd318d12)
            check_type(argname="argument fuzz", value=fuzz, expected_type=type_hints["fuzz"])
            check_type(argname="argument fuzz_var", value=fuzz_var, expected_type=type_hints["fuzz_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fuzz is not None:
            self._values["fuzz"] = fuzz
        if fuzz_var is not None:
            self._values["fuzz_var"] = fuzz_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var

    @builtins.property
    def fuzz(self) -> typing.Optional[builtins.str]:
        '''The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz DataAkamaiImagingPolicyImage#fuzz}
        '''
        result = self._values.get("fuzz")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fuzz_var(self) -> typing.Optional[builtins.str]:
        '''The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz_var DataAkamaiImagingPolicyImage#fuzz_var}
        '''
        result = self._values.get("fuzz_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''The amount of padding in pixels to add to the trimmed image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''The amount of padding in pixels to add to the trimmed image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultTrim(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultTrimList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultTrimList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d33397a09f8fd410fb9bb6d5c9194db82fc8f4d655f1b34089087247dbd20d0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultTrimOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b10da52a9d93324bbcf4e64f34409be462f6a1bd3aa3de50c4ebf2d61f7eb446)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultTrimOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e94b5d95796fefb8d4e1b5571d1a333f1a9208776d24b8b75cc815d12fabd74c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6053d5df323ca3ef1c24947af6824ea163870eebaf4de79957dcc1c4e169c971)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a3173df0f0c84191e4e01b5c2d713bfcbe773d8d62bd78aa4769b87bcec3760b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultTrim]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultTrim]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultTrim]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb81511b52604a085608cac9e38e727aa49058a1ebecf9e6e6734933517c5e6d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultTrimOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultTrimOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c150a09586a26afade291189cd88f4f95953c988411990e5c90580bc20e7decb)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetFuzz")
    def reset_fuzz(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFuzz", []))

    @jsii.member(jsii_name="resetFuzzVar")
    def reset_fuzz_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFuzzVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @builtins.property
    @jsii.member(jsii_name="fuzzInput")
    def fuzz_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fuzzInput"))

    @builtins.property
    @jsii.member(jsii_name="fuzzVarInput")
    def fuzz_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fuzzVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="fuzz")
    def fuzz(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fuzz"))

    @fuzz.setter
    def fuzz(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__00ac0f69bee59c292bed5420092f1a4a6d81732aa2ce4cf57f4b590b15f02cf6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fuzz", value)

    @builtins.property
    @jsii.member(jsii_name="fuzzVar")
    def fuzz_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fuzzVar"))

    @fuzz_var.setter
    def fuzz_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0868b9e481ea4b13bb150caa0f116492befe7f14d6614026d89da97e03afc62f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fuzzVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__81c41b403b16d7087bb1dd0545d6fdb0e92f002dc3f6fb8ce75ff493550baee6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__562a67ede16349f66f9a680637b91ee6c46906671338b26eb04765ac42d90529)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultTrim]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultTrim]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultTrim]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__287f7394c5a32271e36a2ffed0272ac48534ff55ece767c10c6968bbb4684544)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultUnsharpMask",
    jsii_struct_bases=[],
    name_mapping={
        "gain": "gain",
        "gain_var": "gainVar",
        "sigma": "sigma",
        "sigma_var": "sigmaVar",
        "threshold": "threshold",
        "threshold_var": "thresholdVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultUnsharpMask:
    def __init__(
        self,
        *,
        gain: typing.Optional[builtins.str] = None,
        gain_var: typing.Optional[builtins.str] = None,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
        threshold: typing.Optional[builtins.str] = None,
        threshold_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param gain: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        :param gain_var: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        :param sigma: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        :param threshold: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        :param threshold_var: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5eca001484278de9cc950b9cbeeba0606cc5211185675033e4e470c555967344)
            check_type(argname="argument gain", value=gain, expected_type=type_hints["gain"])
            check_type(argname="argument gain_var", value=gain_var, expected_type=type_hints["gain_var"])
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
            check_type(argname="argument threshold", value=threshold, expected_type=type_hints["threshold"])
            check_type(argname="argument threshold_var", value=threshold_var, expected_type=type_hints["threshold_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if gain is not None:
            self._values["gain"] = gain
        if gain_var is not None:
            self._values["gain_var"] = gain_var
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var
        if threshold is not None:
            self._values["threshold"] = threshold
        if threshold_var is not None:
            self._values["threshold_var"] = threshold_var

    @builtins.property
    def gain(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        '''
        result = self._values.get("gain")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gain_var(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        '''
        result = self._values.get("gain_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        '''
        result = self._values.get("threshold")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold_var(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        result = self._values.get("threshold_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultUnsharpMask(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultUnsharpMaskList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultUnsharpMaskList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f3bec16728459fd22606c64fdf24b4e7e7ce066b51eaf728a8284d8463226d2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultUnsharpMaskOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c23f0e9ad9fbeeefcb404697068cd3182a853b056e7dfdddc9e6b329e4721798)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultUnsharpMaskOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__519b64e12b1cb4be9ceb7d849ed6c6b32db3dbd962d4d7e82c314967d42e195d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8e2c7a2fa33471b3d0f40660ad1ffe36df931d33708f102cc91882cf1a345583)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__093f5e1f03e5a5b52be158d9c8fe537c4a7a7cb3470d03e2ce5c5d32415b9c10)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultUnsharpMask]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultUnsharpMask]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultUnsharpMask]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b8fd4664ee5976981177b1c937f666e7ca055eb3c8c91167f2b6688e6e1eadcb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultUnsharpMaskOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultUnsharpMaskOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c5091b5e24d291c4ca0168f9ab42b1616bac740b0f510fedc538fcda650ef95b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetGain")
    def reset_gain(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGain", []))

    @jsii.member(jsii_name="resetGainVar")
    def reset_gain_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGainVar", []))

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @jsii.member(jsii_name="resetThreshold")
    def reset_threshold(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThreshold", []))

    @jsii.member(jsii_name="resetThresholdVar")
    def reset_threshold_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThresholdVar", []))

    @builtins.property
    @jsii.member(jsii_name="gainInput")
    def gain_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainInput"))

    @builtins.property
    @jsii.member(jsii_name="gainVarInput")
    def gain_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdInput")
    def threshold_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdVarInput")
    def threshold_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gain")
    def gain(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gain"))

    @gain.setter
    def gain(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__70bafe7db501adf435a61700d02847e09e69c12cc28c87d78b16491444384b8c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gain", value)

    @builtins.property
    @jsii.member(jsii_name="gainVar")
    def gain_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gainVar"))

    @gain_var.setter
    def gain_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__550b9b1327483d8f72bc7cfb3335d7a52ea7acd4c246840612bac7d963483ece)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gainVar", value)

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0096515e8c5768ff95f7ccdecc653e9a8828e67b73213e54f92734d57ccd0e4a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d907f1943169acc2b109e9b541a2c5c7ceea78f012a84f763beceff0aec47508)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="threshold")
    def threshold(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "threshold"))

    @threshold.setter
    def threshold(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a3a3aa95dc19525edd7a03078018d9a0f9a0ca05b91dc69ffcb3de9eda60ca6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "threshold", value)

    @builtins.property
    @jsii.member(jsii_name="thresholdVar")
    def threshold_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "thresholdVar"))

    @threshold_var.setter
    def threshold_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__10855b43e36c54355e7a88ce092c5a08f1de298363844d333a9056939bf6dc96)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "thresholdVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultUnsharpMask]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultUnsharpMask]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultUnsharpMask]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e45a728b5f93f8cdb6e26d48d3cfafc687af77545e1e0000a4814614b255555)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscape",
    jsii_struct_bases=[],
    name_mapping={
        "append": "append",
        "aspect_crop": "aspectCrop",
        "background_color": "backgroundColor",
        "blur": "blur",
        "chroma_key": "chromaKey",
        "composite": "composite",
        "compound": "compound",
        "contrast": "contrast",
        "crop": "crop",
        "face_crop": "faceCrop",
        "feature_crop": "featureCrop",
        "fit_and_fill": "fitAndFill",
        "goop": "goop",
        "grayscale": "grayscale",
        "hsl": "hsl",
        "hsv": "hsv",
        "if_dimension": "ifDimension",
        "if_orientation": "ifOrientation",
        "im_query": "imQuery",
        "max_colors": "maxColors",
        "mirror": "mirror",
        "mono_hue": "monoHue",
        "opacity": "opacity",
        "region_of_interest_crop": "regionOfInterestCrop",
        "relative_crop": "relativeCrop",
        "remove_color": "removeColor",
        "resize": "resize",
        "rotate": "rotate",
        "scale": "scale",
        "shear": "shear",
        "trim": "trim",
        "unsharp_mask": "unsharpMask",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscape:
    def __init__(
        self,
        *,
        append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeAppend", typing.Dict[builtins.str, typing.Any]]]]] = None,
        aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeAspectCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeBackgroundColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeBlur", typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeChromaKey", typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeComposite", typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeCompound", typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeContrast", typing.Dict[builtins.str, typing.Any]]]]] = None,
        crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeFaceCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeFeatureCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeFitAndFill", typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeGoop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeGrayscale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeHsl", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeHsv", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfDimension", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientation", typing.Dict[builtins.str, typing.Any]]]]] = None,
        im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeImQuery", typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeMaxColors", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeMirror", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeMonoHue", typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeOpacity", typing.Dict[builtins.str, typing.Any]]]]] = None,
        region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeRegionOfInterestCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeRelativeCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeRemoveColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeResize", typing.Dict[builtins.str, typing.Any]]]]] = None,
        rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeRotate", typing.Dict[builtins.str, typing.Any]]]]] = None,
        scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeScale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeShear", typing.Dict[builtins.str, typing.Any]]]]] = None,
        trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeTrim", typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeUnsharpMask", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param append: append block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        :param aspect_crop: aspect_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param crop: crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        :param face_crop: face_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        :param feature_crop: feature_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        :param fit_and_fill: fit_and_fill block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param im_query: im_query block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param region_of_interest_crop: region_of_interest_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        :param relative_crop: relative_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param resize: resize block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        :param rotate: rotate block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        :param scale: scale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param shear: shear block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        :param trim: trim block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ea1da60b8411019289a08c7b19af372a379af6aa50e05b96af8a1eab4d7bca1)
            check_type(argname="argument append", value=append, expected_type=type_hints["append"])
            check_type(argname="argument aspect_crop", value=aspect_crop, expected_type=type_hints["aspect_crop"])
            check_type(argname="argument background_color", value=background_color, expected_type=type_hints["background_color"])
            check_type(argname="argument blur", value=blur, expected_type=type_hints["blur"])
            check_type(argname="argument chroma_key", value=chroma_key, expected_type=type_hints["chroma_key"])
            check_type(argname="argument composite", value=composite, expected_type=type_hints["composite"])
            check_type(argname="argument compound", value=compound, expected_type=type_hints["compound"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument crop", value=crop, expected_type=type_hints["crop"])
            check_type(argname="argument face_crop", value=face_crop, expected_type=type_hints["face_crop"])
            check_type(argname="argument feature_crop", value=feature_crop, expected_type=type_hints["feature_crop"])
            check_type(argname="argument fit_and_fill", value=fit_and_fill, expected_type=type_hints["fit_and_fill"])
            check_type(argname="argument goop", value=goop, expected_type=type_hints["goop"])
            check_type(argname="argument grayscale", value=grayscale, expected_type=type_hints["grayscale"])
            check_type(argname="argument hsl", value=hsl, expected_type=type_hints["hsl"])
            check_type(argname="argument hsv", value=hsv, expected_type=type_hints["hsv"])
            check_type(argname="argument if_dimension", value=if_dimension, expected_type=type_hints["if_dimension"])
            check_type(argname="argument if_orientation", value=if_orientation, expected_type=type_hints["if_orientation"])
            check_type(argname="argument im_query", value=im_query, expected_type=type_hints["im_query"])
            check_type(argname="argument max_colors", value=max_colors, expected_type=type_hints["max_colors"])
            check_type(argname="argument mirror", value=mirror, expected_type=type_hints["mirror"])
            check_type(argname="argument mono_hue", value=mono_hue, expected_type=type_hints["mono_hue"])
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument region_of_interest_crop", value=region_of_interest_crop, expected_type=type_hints["region_of_interest_crop"])
            check_type(argname="argument relative_crop", value=relative_crop, expected_type=type_hints["relative_crop"])
            check_type(argname="argument remove_color", value=remove_color, expected_type=type_hints["remove_color"])
            check_type(argname="argument resize", value=resize, expected_type=type_hints["resize"])
            check_type(argname="argument rotate", value=rotate, expected_type=type_hints["rotate"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument shear", value=shear, expected_type=type_hints["shear"])
            check_type(argname="argument trim", value=trim, expected_type=type_hints["trim"])
            check_type(argname="argument unsharp_mask", value=unsharp_mask, expected_type=type_hints["unsharp_mask"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if append is not None:
            self._values["append"] = append
        if aspect_crop is not None:
            self._values["aspect_crop"] = aspect_crop
        if background_color is not None:
            self._values["background_color"] = background_color
        if blur is not None:
            self._values["blur"] = blur
        if chroma_key is not None:
            self._values["chroma_key"] = chroma_key
        if composite is not None:
            self._values["composite"] = composite
        if compound is not None:
            self._values["compound"] = compound
        if contrast is not None:
            self._values["contrast"] = contrast
        if crop is not None:
            self._values["crop"] = crop
        if face_crop is not None:
            self._values["face_crop"] = face_crop
        if feature_crop is not None:
            self._values["feature_crop"] = feature_crop
        if fit_and_fill is not None:
            self._values["fit_and_fill"] = fit_and_fill
        if goop is not None:
            self._values["goop"] = goop
        if grayscale is not None:
            self._values["grayscale"] = grayscale
        if hsl is not None:
            self._values["hsl"] = hsl
        if hsv is not None:
            self._values["hsv"] = hsv
        if if_dimension is not None:
            self._values["if_dimension"] = if_dimension
        if if_orientation is not None:
            self._values["if_orientation"] = if_orientation
        if im_query is not None:
            self._values["im_query"] = im_query
        if max_colors is not None:
            self._values["max_colors"] = max_colors
        if mirror is not None:
            self._values["mirror"] = mirror
        if mono_hue is not None:
            self._values["mono_hue"] = mono_hue
        if opacity is not None:
            self._values["opacity"] = opacity
        if region_of_interest_crop is not None:
            self._values["region_of_interest_crop"] = region_of_interest_crop
        if relative_crop is not None:
            self._values["relative_crop"] = relative_crop
        if remove_color is not None:
            self._values["remove_color"] = remove_color
        if resize is not None:
            self._values["resize"] = resize
        if rotate is not None:
            self._values["rotate"] = rotate
        if scale is not None:
            self._values["scale"] = scale
        if shear is not None:
            self._values["shear"] = shear
        if trim is not None:
            self._values["trim"] = trim
        if unsharp_mask is not None:
            self._values["unsharp_mask"] = unsharp_mask

    @builtins.property
    def append(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeAppend"]]]:
        '''append block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        '''
        result = self._values.get("append")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeAppend"]]], result)

    @builtins.property
    def aspect_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeAspectCrop"]]]:
        '''aspect_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        '''
        result = self._values.get("aspect_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeAspectCrop"]]], result)

    @builtins.property
    def background_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeBackgroundColor"]]]:
        '''background_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        '''
        result = self._values.get("background_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeBackgroundColor"]]], result)

    @builtins.property
    def blur(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeBlur"]]]:
        '''blur block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        '''
        result = self._values.get("blur")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeBlur"]]], result)

    @builtins.property
    def chroma_key(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeChromaKey"]]]:
        '''chroma_key block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        '''
        result = self._values.get("chroma_key")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeChromaKey"]]], result)

    @builtins.property
    def composite(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeComposite"]]]:
        '''composite block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        '''
        result = self._values.get("composite")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeComposite"]]], result)

    @builtins.property
    def compound(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeCompound"]]]:
        '''compound block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        '''
        result = self._values.get("compound")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeCompound"]]], result)

    @builtins.property
    def contrast(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeContrast"]]]:
        '''contrast block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeContrast"]]], result)

    @builtins.property
    def crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeCrop"]]]:
        '''crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        '''
        result = self._values.get("crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeCrop"]]], result)

    @builtins.property
    def face_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeFaceCrop"]]]:
        '''face_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        '''
        result = self._values.get("face_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeFaceCrop"]]], result)

    @builtins.property
    def feature_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeFeatureCrop"]]]:
        '''feature_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        '''
        result = self._values.get("feature_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeFeatureCrop"]]], result)

    @builtins.property
    def fit_and_fill(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeFitAndFill"]]]:
        '''fit_and_fill block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        '''
        result = self._values.get("fit_and_fill")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeFitAndFill"]]], result)

    @builtins.property
    def goop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeGoop"]]]:
        '''goop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        '''
        result = self._values.get("goop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeGoop"]]], result)

    @builtins.property
    def grayscale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeGrayscale"]]]:
        '''grayscale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        '''
        result = self._values.get("grayscale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeGrayscale"]]], result)

    @builtins.property
    def hsl(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeHsl"]]]:
        '''hsl block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        '''
        result = self._values.get("hsl")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeHsl"]]], result)

    @builtins.property
    def hsv(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeHsv"]]]:
        '''hsv block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        '''
        result = self._values.get("hsv")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeHsv"]]], result)

    @builtins.property
    def if_dimension(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfDimension"]]]:
        '''if_dimension block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        '''
        result = self._values.get("if_dimension")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfDimension"]]], result)

    @builtins.property
    def if_orientation(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientation"]]]:
        '''if_orientation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        '''
        result = self._values.get("if_orientation")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientation"]]], result)

    @builtins.property
    def im_query(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeImQuery"]]]:
        '''im_query block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        '''
        result = self._values.get("im_query")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeImQuery"]]], result)

    @builtins.property
    def max_colors(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeMaxColors"]]]:
        '''max_colors block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        '''
        result = self._values.get("max_colors")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeMaxColors"]]], result)

    @builtins.property
    def mirror(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeMirror"]]]:
        '''mirror block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        '''
        result = self._values.get("mirror")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeMirror"]]], result)

    @builtins.property
    def mono_hue(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeMonoHue"]]]:
        '''mono_hue block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        '''
        result = self._values.get("mono_hue")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeMonoHue"]]], result)

    @builtins.property
    def opacity(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeOpacity"]]]:
        '''opacity block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeOpacity"]]], result)

    @builtins.property
    def region_of_interest_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeRegionOfInterestCrop"]]]:
        '''region_of_interest_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        '''
        result = self._values.get("region_of_interest_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeRegionOfInterestCrop"]]], result)

    @builtins.property
    def relative_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeRelativeCrop"]]]:
        '''relative_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        '''
        result = self._values.get("relative_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeRelativeCrop"]]], result)

    @builtins.property
    def remove_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeRemoveColor"]]]:
        '''remove_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        '''
        result = self._values.get("remove_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeRemoveColor"]]], result)

    @builtins.property
    def resize(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeResize"]]]:
        '''resize block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        '''
        result = self._values.get("resize")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeResize"]]], result)

    @builtins.property
    def rotate(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeRotate"]]]:
        '''rotate block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        '''
        result = self._values.get("rotate")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeRotate"]]], result)

    @builtins.property
    def scale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeScale"]]]:
        '''scale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeScale"]]], result)

    @builtins.property
    def shear(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeShear"]]]:
        '''shear block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        '''
        result = self._values.get("shear")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeShear"]]], result)

    @builtins.property
    def trim(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeTrim"]]]:
        '''trim block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        '''
        result = self._values.get("trim")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeTrim"]]], result)

    @builtins.property
    def unsharp_mask(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeUnsharpMask"]]]:
        '''unsharp_mask block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        result = self._values.get("unsharp_mask")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeUnsharpMask"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscape(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeAppend",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_priority": "gravityPriority",
        "gravity_priority_var": "gravityPriorityVar",
        "gravity_var": "gravityVar",
        "preserve_minor_dimension": "preserveMinorDimension",
        "preserve_minor_dimension_var": "preserveMinorDimensionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeAppend:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeAppendImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_priority: typing.Optional[builtins.str] = None,
        gravity_priority_var: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        preserve_minor_dimension: typing.Optional[builtins.str] = None,
        preserve_minor_dimension_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Specifies where to place the ``image`` relative to the source image. The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_priority: Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal. The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority DataAkamaiImagingPolicyImage#gravity_priority}
        :param gravity_priority_var: Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal. The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority_var DataAkamaiImagingPolicyImage#gravity_priority_var}
        :param gravity_var: Specifies where to place the ``image`` relative to the source image. The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param preserve_minor_dimension: Whether to preserve the source image's minor dimension, ``false`` by default. The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension DataAkamaiImagingPolicyImage#preserve_minor_dimension}
        :param preserve_minor_dimension_var: Whether to preserve the source image's minor dimension, ``false`` by default. The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension_var DataAkamaiImagingPolicyImage#preserve_minor_dimension_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeAppendImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d7da8e00e83ab26b51e83de15aa9e28ec555be284bad111b4ba86afb423b2f94)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_priority", value=gravity_priority, expected_type=type_hints["gravity_priority"])
            check_type(argname="argument gravity_priority_var", value=gravity_priority_var, expected_type=type_hints["gravity_priority_var"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument preserve_minor_dimension", value=preserve_minor_dimension, expected_type=type_hints["preserve_minor_dimension"])
            check_type(argname="argument preserve_minor_dimension_var", value=preserve_minor_dimension_var, expected_type=type_hints["preserve_minor_dimension_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_priority is not None:
            self._values["gravity_priority"] = gravity_priority
        if gravity_priority_var is not None:
            self._values["gravity_priority_var"] = gravity_priority_var
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if preserve_minor_dimension is not None:
            self._values["preserve_minor_dimension"] = preserve_minor_dimension
        if preserve_minor_dimension_var is not None:
            self._values["preserve_minor_dimension_var"] = preserve_minor_dimension_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeAppendImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeAppendImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Specifies where to place the ``image`` relative to the source image.

        The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_priority(self) -> typing.Optional[builtins.str]:
        '''Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal.

        The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority DataAkamaiImagingPolicyImage#gravity_priority}
        '''
        result = self._values.get("gravity_priority")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_priority_var(self) -> typing.Optional[builtins.str]:
        '''Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal.

        The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority_var DataAkamaiImagingPolicyImage#gravity_priority_var}
        '''
        result = self._values.get("gravity_priority_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Specifies where to place the ``image`` relative to the source image.

        The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def preserve_minor_dimension(self) -> typing.Optional[builtins.str]:
        '''Whether to preserve the source image's minor dimension, ``false`` by default.

        The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension DataAkamaiImagingPolicyImage#preserve_minor_dimension}
        '''
        result = self._values.get("preserve_minor_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def preserve_minor_dimension_var(self) -> typing.Optional[builtins.str]:
        '''Whether to preserve the source image's minor dimension, ``false`` by default.

        The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension_var DataAkamaiImagingPolicyImage#preserve_minor_dimension_var}
        '''
        result = self._values.get("preserve_minor_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeAppend(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeAppendImage",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeAppendImage:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeAppendImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeAppendImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeAppendImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ee09e1c18fc0ee351ee21c4317175d054e837ebb5ad04d7b0223cc5c2f3f70b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeAppendImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeAppendImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeAppendImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bead86213996639e75cda5b2371f2a90c8c14f272d7d6147b7ca64dbd6c6e90e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeAppendList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeAppendList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b644e5df532a1d963d893a5f644c486a54b89ced759d84baca44af306329147f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeAppendOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9095731408dfcecb1e1c2af0b0679d60e2f8df5cb9d8abeee845969f64dd77a7)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeAppendOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__47d03bf87257fac34357a6ed528b325b5a041bfde9cd3e676363819f9a989b03)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b41021a72e37f979cc2aa20f1232c992f366a8fec1b41776f626153f49be77f9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b48252413223c32b188dcf0e6cd9dbbdbff96b6f56dd759643e1e1a1b99ae96b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeAppend]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeAppend]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeAppend]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8d06313cf465b2cb8b3f11edbe94d0398d958fc42a8ccf4836f94eecb45026e0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeAppendOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeAppendOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b5810319c5349c2449a50689dd26bcea1a5d6e69b0676690ed20ac568347b149)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeAppendImage()

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityPriority")
    def reset_gravity_priority(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityPriority", []))

    @jsii.member(jsii_name="resetGravityPriorityVar")
    def reset_gravity_priority_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityPriorityVar", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPreserveMinorDimension")
    def reset_preserve_minor_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPreserveMinorDimension", []))

    @jsii.member(jsii_name="resetPreserveMinorDimensionVar")
    def reset_preserve_minor_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPreserveMinorDimensionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeAppendImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeAppendImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityInput")
    def gravity_priority_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityPriorityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityVarInput")
    def gravity_priority_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityPriorityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeAppendImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeAppendImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionInput")
    def preserve_minor_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "preserveMinorDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionVarInput")
    def preserve_minor_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "preserveMinorDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__64a5b4188cb32df7af010356f26303521d4cb28dcd4da13c9efb4571d6073d29)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityPriority")
    def gravity_priority(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityPriority"))

    @gravity_priority.setter
    def gravity_priority(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ff8e10e458e3ebfdc0289ae482c8161636eea7ea9ae4b461a01906116cb08c9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityPriority", value)

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityVar")
    def gravity_priority_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityPriorityVar"))

    @gravity_priority_var.setter
    def gravity_priority_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7c4eaa7413cd12308dd312f3f3a02f2507ca2f7dca27c47aa90f1cf6276965a0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityPriorityVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0e532a7e99c1ad6313dc0412a8661bf53eeedd8b9b58ddf44cf0f6085126fab2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimension")
    def preserve_minor_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "preserveMinorDimension"))

    @preserve_minor_dimension.setter
    def preserve_minor_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aa26c099082864923ecf5a64d9d72ea040bf0fdbc7ae8208406b28b3d02199d7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "preserveMinorDimension", value)

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionVar")
    def preserve_minor_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "preserveMinorDimensionVar"))

    @preserve_minor_dimension_var.setter
    def preserve_minor_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__562f3335d6f12ddad6a1efd9d160e275ddb548459a7108faaa87e5d53ea81be7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "preserveMinorDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeAppend]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeAppend]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeAppend]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__11c497afbbe1e2d09f49be8976c7d07e497756964c8255780df01db1d5318299)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeAspectCrop",
    jsii_struct_bases=[],
    name_mapping={
        "allow_expansion": "allowExpansion",
        "allow_expansion_var": "allowExpansionVar",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeAspectCrop:
    def __init__(
        self,
        *,
        allow_expansion: typing.Optional[builtins.str] = None,
        allow_expansion_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_expansion: Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image. Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        :param allow_expansion_var: Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image. Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        :param height: The height term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The width term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        :param x_position: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__389e53b077a565496b1695aab78c41f51cce3f7ca1422dbdbbd52440e2d13e65)
            check_type(argname="argument allow_expansion", value=allow_expansion, expected_type=type_hints["allow_expansion"])
            check_type(argname="argument allow_expansion_var", value=allow_expansion_var, expected_type=type_hints["allow_expansion_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if allow_expansion is not None:
            self._values["allow_expansion"] = allow_expansion
        if allow_expansion_var is not None:
            self._values["allow_expansion_var"] = allow_expansion_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def allow_expansion(self) -> typing.Optional[builtins.str]:
        '''Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image.

        Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        '''
        result = self._values.get("allow_expansion")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def allow_expansion_var(self) -> typing.Optional[builtins.str]:
        '''Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image.

        Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        '''
        result = self._values.get("allow_expansion_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeAspectCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeAspectCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeAspectCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__65faa0b81380f37bd44cbc1bc63d16c0c7ff26fffe31f08bb3843afd2a799c75)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeAspectCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__20f6835f1343127249ff1bd877086b7bf67f4eed09197f214a113581770e2a4b)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeAspectCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__112fa3c46bc635c19ab1470f496e1253750d4a04b7d205c9495029293fc9450e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8cc1f2cd726ec56712e17089b0bf05dbdbce512e5865b6dc6e52b7ceb4d7729b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__49d1368c0667573205e57735cb571f62fd86c925e7fcdfb729db0e791a9466b9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeAspectCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeAspectCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeAspectCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__da41c019cd1f272f51cd3aba583b0564ec0087e85c5a9a0c2ad12c79fab74a49)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeAspectCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeAspectCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8983ae9c99e1ec13af661f54fe16f3a6becbcbcb8a0bfee992cf056dce4ba475)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAllowExpansion")
    def reset_allow_expansion(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansion", []))

    @jsii.member(jsii_name="resetAllowExpansionVar")
    def reset_allow_expansion_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansionVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionInput")
    def allow_expansion_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVarInput")
    def allow_expansion_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansion")
    def allow_expansion(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansion"))

    @allow_expansion.setter
    def allow_expansion(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__18a6a2afb9f14a2988383920467ddbf1d58189ae0d358b59d2afe9827b904604)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansion", value)

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVar")
    def allow_expansion_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansionVar"))

    @allow_expansion_var.setter
    def allow_expansion_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__57b2440254da28d1b8acfcb3b22843b255680c9619ac197ccc855842f5892d5b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansionVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__80d9217a847721f89106149c59197e4eae7c1aaa3874b244a228c138122d6861)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__09d4b1fd8da0b09392975f64d093ad4330bcaf700ce568b12eaad16be09fafcc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__335d9b40f369b7329978a3b0ef214ebf13c0db94ae03624322344fe91a1d84df)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6d00283e3bd9759d04706ac53e2adc040886685206cb298c0b64e803c43d0f8a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__87d070f336c8044b4cdc83af103afb8c414c141b758c4f5bea7c941a5fedfcf9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__744990a1c9c69b4de3f515fe5a5dd63932034bf667854d6acc64a76c924b6b2e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f39f7afa954191cb652420003d4d91374ea23ec91a901c351e6d8ca9eb79b83f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0d442cba42708dec5b8f792f951999d78d54220f97ae11311be61fb914eff345)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeAspectCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeAspectCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeAspectCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e91eabc0c8f87d70952fba7809b3b762d3fe004effd697bf3541af29369d44d2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeBackgroundColor",
    jsii_struct_bases=[],
    name_mapping={"color": "color", "color_var": "colorVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeBackgroundColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__65a2fd44e67063ec89889007dc39646199be29407ab290fbf7c2a670779cd8e7)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeBackgroundColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeBackgroundColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeBackgroundColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__379ff818c53ad376980c99df1faa79a95d23f28677c83417389511db182cb6c5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeBackgroundColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d2e2cef62c36863d77212305e5296246042ae0b4b787bc5115d7cc8cbc6e2150)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeBackgroundColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5e7b8c9f1e5455dbb0f4c805cbfa38e26716215a74f3be260192fc13efcc41aa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b8ed26a763fcea74501e77b83882e15ae9a3253a1ba64dcbdd106b1ac02641cf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be3e5ae2a980794e020cb47052fe2851dc7b646a4dfdf154271f1ed0b3f8d543)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeBackgroundColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeBackgroundColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f360e3691a4036499cfeb4a5b08795712f472740eb7ec33501778110a132348d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeBackgroundColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeBackgroundColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__944a3ccc52b955ba04c9c088a68dd58686190f40a577d4590369c3ad7e65afe8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c921e67b829c1708a78cb65fdad2adab4b3a6c2eaa53bf57a6ddad9d08432065)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__256ec3b0acfa8eb5cca7500b73836a0c0be49284d644e9217c29978e0a741e0a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeBackgroundColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeBackgroundColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeBackgroundColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d43cccad2763d86d892d2f624899f7de647e5df2e66e777c9732d189664376c3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeBlur",
    jsii_struct_bases=[],
    name_mapping={"sigma": "sigma", "sigma_var": "sigmaVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeBlur:
    def __init__(
        self,
        *,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param sigma: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3842ff4d21156beea912ffcf998dcc381f1eaa0fa178c89da8e4825a27f874af)
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeBlur(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeBlurList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeBlurList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__177a8ac1596b280b09694255a6dab5aa7d2397a2209f506554f436856bb1927b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeBlurOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__78fe5b6826351ec9e5becbd8ef834ca8939bc69e22f59a5fc853de2aeb7bb7d8)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeBlurOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2c8232b83ca3c5de45b8ad4e1e04c54b2838327371b713e000846a2d19e5bf1d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__395211aafec512b07207e56d9c3f1c23530d350d9e8666355f0428f37c6d7439)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ba0f1e7890b25e819349970538a1e25cbaa0106be869125659f8cecce9b87e9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeBlur]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeBlur]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7fac83116db676c62915350bac2650f2fcc5f1bb8c1123804cb49fb65e7d1a7e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeBlurOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeBlurOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8c30d92cc0bdd32d3b4457b23c6bec13e8b6b848b18e111bb796d5e3fd7d5bbe)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3e7cef87fb4b441f214a15c0e9ab11e6768b2e72d3127362b98b0e71439a0af2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7a4bb55fb9a9d6fc01b184afc39c4f2e85def7dd6ace76a3137e676675e9ef4d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeBlur]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeBlur]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeBlur]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__66f178245a688102304dc9b1387c214ec388e57f1febf6bce1f87bf143f8559a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeChromaKey",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_feather": "hueFeather",
        "hue_feather_var": "hueFeatherVar",
        "hue_tolerance": "hueTolerance",
        "hue_tolerance_var": "hueToleranceVar",
        "hue_var": "hueVar",
        "lightness_feather": "lightnessFeather",
        "lightness_feather_var": "lightnessFeatherVar",
        "lightness_tolerance": "lightnessTolerance",
        "lightness_tolerance_var": "lightnessToleranceVar",
        "saturation_feather": "saturationFeather",
        "saturation_feather_var": "saturationFeatherVar",
        "saturation_tolerance": "saturationTolerance",
        "saturation_tolerance_var": "saturationToleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeChromaKey:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_feather: typing.Optional[builtins.str] = None,
        hue_feather_var: typing.Optional[builtins.str] = None,
        hue_tolerance: typing.Optional[builtins.str] = None,
        hue_tolerance_var: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness_feather: typing.Optional[builtins.str] = None,
        lightness_feather_var: typing.Optional[builtins.str] = None,
        lightness_tolerance: typing.Optional[builtins.str] = None,
        lightness_tolerance_var: typing.Optional[builtins.str] = None,
        saturation_feather: typing.Optional[builtins.str] = None,
        saturation_feather_var: typing.Optional[builtins.str] = None,
        saturation_tolerance: typing.Optional[builtins.str] = None,
        saturation_tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_feather: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        :param hue_feather_var: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        :param hue_tolerance: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        :param hue_tolerance_var: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        :param hue_var: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness_feather: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        :param lightness_feather_var: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        :param lightness_tolerance: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        :param lightness_tolerance_var: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        :param saturation_feather: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        :param saturation_feather_var: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        :param saturation_tolerance: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        :param saturation_tolerance_var: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__99d3816910579a0ad9b7ffbcae61b5cd73b724f9f96d88a9ba004088e886c7b6)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_feather", value=hue_feather, expected_type=type_hints["hue_feather"])
            check_type(argname="argument hue_feather_var", value=hue_feather_var, expected_type=type_hints["hue_feather_var"])
            check_type(argname="argument hue_tolerance", value=hue_tolerance, expected_type=type_hints["hue_tolerance"])
            check_type(argname="argument hue_tolerance_var", value=hue_tolerance_var, expected_type=type_hints["hue_tolerance_var"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness_feather", value=lightness_feather, expected_type=type_hints["lightness_feather"])
            check_type(argname="argument lightness_feather_var", value=lightness_feather_var, expected_type=type_hints["lightness_feather_var"])
            check_type(argname="argument lightness_tolerance", value=lightness_tolerance, expected_type=type_hints["lightness_tolerance"])
            check_type(argname="argument lightness_tolerance_var", value=lightness_tolerance_var, expected_type=type_hints["lightness_tolerance_var"])
            check_type(argname="argument saturation_feather", value=saturation_feather, expected_type=type_hints["saturation_feather"])
            check_type(argname="argument saturation_feather_var", value=saturation_feather_var, expected_type=type_hints["saturation_feather_var"])
            check_type(argname="argument saturation_tolerance", value=saturation_tolerance, expected_type=type_hints["saturation_tolerance"])
            check_type(argname="argument saturation_tolerance_var", value=saturation_tolerance_var, expected_type=type_hints["saturation_tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_feather is not None:
            self._values["hue_feather"] = hue_feather
        if hue_feather_var is not None:
            self._values["hue_feather_var"] = hue_feather_var
        if hue_tolerance is not None:
            self._values["hue_tolerance"] = hue_tolerance
        if hue_tolerance_var is not None:
            self._values["hue_tolerance_var"] = hue_tolerance_var
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness_feather is not None:
            self._values["lightness_feather"] = lightness_feather
        if lightness_feather_var is not None:
            self._values["lightness_feather_var"] = lightness_feather_var
        if lightness_tolerance is not None:
            self._values["lightness_tolerance"] = lightness_tolerance
        if lightness_tolerance_var is not None:
            self._values["lightness_tolerance_var"] = lightness_tolerance_var
        if saturation_feather is not None:
            self._values["saturation_feather"] = saturation_feather
        if saturation_feather_var is not None:
            self._values["saturation_feather_var"] = saturation_feather_var
        if saturation_tolerance is not None:
            self._values["saturation_tolerance"] = saturation_tolerance
        if saturation_tolerance_var is not None:
            self._values["saturation_tolerance_var"] = saturation_tolerance_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        '''
        result = self._values.get("hue_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        '''
        result = self._values.get("hue_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        '''
        result = self._values.get("hue_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        '''
        result = self._values.get("hue_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        '''
        result = self._values.get("lightness_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        '''
        result = self._values.get("lightness_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        '''
        result = self._values.get("lightness_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        '''
        result = self._values.get("lightness_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        '''
        result = self._values.get("saturation_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        '''
        result = self._values.get("saturation_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        '''
        result = self._values.get("saturation_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        result = self._values.get("saturation_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeChromaKey(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeChromaKeyList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeChromaKeyList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__73fd08dae9d1a1f69048010447564026a1df9865a9743b84cd61b545f51e4c7d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeChromaKeyOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__755196a66193156ca824c6002def3a6217a2411a805a099779003d9fc2b291b1)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeChromaKeyOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__55699e23a02dcf77842d765b74dfb8e4cb94ad047e590f24763389b9c06e353f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__01f9a5f4666718a531c61c85caef96254e25a85f900e1f7543d197343dd0441e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c902608b306d68ce7e16f99491c2841d625df6a4692d6428eb7ef7400bedc910)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeChromaKey]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeChromaKey]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f1508d30338988451eb6899ccc51e95dcb70bc13d9ee23eafd01795d321b8ad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeChromaKeyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeChromaKeyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__30fda8ce94eb234d78c8b6eb11de1f6f888d76d03d0675982a3f213c1eb0cf95)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueFeather")
    def reset_hue_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeather", []))

    @jsii.member(jsii_name="resetHueFeatherVar")
    def reset_hue_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeatherVar", []))

    @jsii.member(jsii_name="resetHueTolerance")
    def reset_hue_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueTolerance", []))

    @jsii.member(jsii_name="resetHueToleranceVar")
    def reset_hue_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueToleranceVar", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightnessFeather")
    def reset_lightness_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeather", []))

    @jsii.member(jsii_name="resetLightnessFeatherVar")
    def reset_lightness_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeatherVar", []))

    @jsii.member(jsii_name="resetLightnessTolerance")
    def reset_lightness_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessTolerance", []))

    @jsii.member(jsii_name="resetLightnessToleranceVar")
    def reset_lightness_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessToleranceVar", []))

    @jsii.member(jsii_name="resetSaturationFeather")
    def reset_saturation_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeather", []))

    @jsii.member(jsii_name="resetSaturationFeatherVar")
    def reset_saturation_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeatherVar", []))

    @jsii.member(jsii_name="resetSaturationTolerance")
    def reset_saturation_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationTolerance", []))

    @jsii.member(jsii_name="resetSaturationToleranceVar")
    def reset_saturation_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherInput")
    def hue_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVarInput")
    def hue_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceInput")
    def hue_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVarInput")
    def hue_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherInput")
    def lightness_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVarInput")
    def lightness_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceInput")
    def lightness_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVarInput")
    def lightness_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherInput")
    def saturation_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVarInput")
    def saturation_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceInput")
    def saturation_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVarInput")
    def saturation_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__60ba867f05ebfd8c0660623ad0cf6d6de371cc43c6405683c581a8b37c68204b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeather")
    def hue_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeather"))

    @hue_feather.setter
    def hue_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__082857ce312246eb68482ba9d66d5fd63f1a8d50b8af73001e53a286ec8d1f98)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeather", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVar")
    def hue_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeatherVar"))

    @hue_feather_var.setter
    def hue_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3c1f66a6eae32b77e81b3c14d0aca8089cfa70dd7c10e70c3d51d19cad05285b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueTolerance")
    def hue_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueTolerance"))

    @hue_tolerance.setter
    def hue_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3798556460b0fe37eda71ff386a96bd47de66f1caba6be395199dbeb540d62bf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVar")
    def hue_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueToleranceVar"))

    @hue_tolerance_var.setter
    def hue_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__017a50aefca7b5985e358b5293f70d70d1722959dee6068b160845987b6d1b1e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c88ba8203954395949808ca449971902d61f301f83a61e72113363ed7dddeb31)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeather")
    def lightness_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeather"))

    @lightness_feather.setter
    def lightness_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__58c56f80d1473ebec12e43d6e47c62440a9122281262f32d065cd4f45507b9ad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeather", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVar")
    def lightness_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeatherVar"))

    @lightness_feather_var.setter
    def lightness_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0e03f367fa44a19a0cd12b06759aa6d7f0046cc0f3ec3ddce71bf08ff101b2a9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessTolerance")
    def lightness_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessTolerance"))

    @lightness_tolerance.setter
    def lightness_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1efc56fa5cd31bcef0a013e0b69e65fea582d1a0f94f14f339bb627a68f51d86)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVar")
    def lightness_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessToleranceVar"))

    @lightness_tolerance_var.setter
    def lightness_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__abfa9dc55f066b317ff3fcb5e4a7edbf2bdbce17cec1e6efc512fa64d8ed0652)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeather")
    def saturation_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeather"))

    @saturation_feather.setter
    def saturation_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__30df7212e206b0ff02055312f9ee42d8015f8bf811308abdae6f78ff1cd28a9a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeather", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVar")
    def saturation_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeatherVar"))

    @saturation_feather_var.setter
    def saturation_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1c8bf5da9d17c1d484b08cd6d03bff1837f396232ef4a30e400ce28e32dd2cc9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationTolerance")
    def saturation_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationTolerance"))

    @saturation_tolerance.setter
    def saturation_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a2f9ebfaec3dacf31e5f56ac45ac47cf588d2cc1f9de053538a3f2f2ba4a6a17)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVar")
    def saturation_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationToleranceVar"))

    @saturation_tolerance_var.setter
    def saturation_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1b2eee868ddbddd1ee5b06578a54d5e78270b6c30a8a71662d4f2a921c396294)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeChromaKey]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeChromaKey]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeChromaKey]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3f04e1a735164fb5f175bb92bf0fa1f7402cef651212919744217a2b5ff03f59)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeComposite",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "placement": "placement",
        "placement_var": "placementVar",
        "scale": "scale",
        "scale_dimension": "scaleDimension",
        "scale_dimension_var": "scaleDimensionVar",
        "scale_var": "scaleVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeComposite:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeCompositeImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        placement: typing.Optional[builtins.str] = None,
        placement_var: typing.Optional[builtins.str] = None,
        scale: typing.Optional[builtins.str] = None,
        scale_dimension: typing.Optional[builtins.str] = None,
        scale_dimension_var: typing.Optional[builtins.str] = None,
        scale_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param placement: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        :param placement_var: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        :param scale: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param scale_dimension: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        :param scale_dimension_var: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        :param scale_var: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        :param x_position: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeCompositeImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc61554d62fa8f05d10df3c15adc047fe7d3e39904036322841c84f25cf2b85e)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument placement", value=placement, expected_type=type_hints["placement"])
            check_type(argname="argument placement_var", value=placement_var, expected_type=type_hints["placement_var"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument scale_dimension", value=scale_dimension, expected_type=type_hints["scale_dimension"])
            check_type(argname="argument scale_dimension_var", value=scale_dimension_var, expected_type=type_hints["scale_dimension_var"])
            check_type(argname="argument scale_var", value=scale_var, expected_type=type_hints["scale_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if placement is not None:
            self._values["placement"] = placement
        if placement_var is not None:
            self._values["placement_var"] = placement_var
        if scale is not None:
            self._values["scale"] = scale
        if scale_dimension is not None:
            self._values["scale_dimension"] = scale_dimension
        if scale_dimension_var is not None:
            self._values["scale_dimension_var"] = scale_dimension_var
        if scale_var is not None:
            self._values["scale_var"] = scale_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeCompositeImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeCompositeImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        '''
        result = self._values.get("placement")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement_var(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        '''
        result = self._values.get("placement_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        '''
        result = self._values.get("scale_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        '''
        result = self._values.get("scale_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        '''
        result = self._values.get("scale_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeComposite(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeCompositeImage",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeCompositeImage:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeCompositeImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeCompositeImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeCompositeImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b0d9376ff9cbab74c0a1b5a8ae0ce9154d254295e54f74eca70fa1200c3ca6a4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeCompositeImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeCompositeImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ba78cbca59a26fb1cfb825fd68df111ee05894a308777f933e62e542f43f0b6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeCompositeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeCompositeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a451536d89d8a69bacb3340a8a6cc8893bf2a2e24bc3f8f694ff754641e2559)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeCompositeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a9d01109b1044396bba9d80a985620bdeb512606e0e646d910f6cc689e8f965)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeCompositeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bd844c9b714b8a0ca67f2bed14d2579068c742eb7fb0e15fa03918e8cf36e22c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__22b3c093c6251ba4b3ede0f884b96a3038ec5e64b4fd92625f7ab8d0119a648c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1d96431fd9a3cffe3f569c29bfad5f82cf850ac16cb81b729ef446ad6b0d9f96)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeComposite]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeComposite]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cf83d68962f8a98be73c0ada20fbd850e69c5185c53d593e2a18a0b394473997)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeCompositeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeCompositeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7caeddea81cf2fe02ea089bd8860412c7e89eaa70caf31b158cfb0b7faa5eb44)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeCompositeImage()

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPlacement")
    def reset_placement(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacement", []))

    @jsii.member(jsii_name="resetPlacementVar")
    def reset_placement_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacementVar", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetScaleDimension")
    def reset_scale_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimension", []))

    @jsii.member(jsii_name="resetScaleDimensionVar")
    def reset_scale_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimensionVar", []))

    @jsii.member(jsii_name="resetScaleVar")
    def reset_scale_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeCompositeImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeCompositeImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeCompositeImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="placementInput")
    def placement_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementInput"))

    @builtins.property
    @jsii.member(jsii_name="placementVarInput")
    def placement_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionInput")
    def scale_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVarInput")
    def scale_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleVarInput")
    def scale_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7ff469cf5b9f9c9cf11f70ed60c7cb2a2b6e742870c44f5511ee7409c8075e78)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7cb995c8f2cb002e5c3d32b6eec7738712f0d35b460aa7ce1f9e03a0570e15b2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="placement")
    def placement(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placement"))

    @placement.setter
    def placement(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1660074e76acd8125ffa56a8f3d1ae8886485f2775ef81f9fc114ad2758d54e6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placement", value)

    @builtins.property
    @jsii.member(jsii_name="placementVar")
    def placement_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placementVar"))

    @placement_var.setter
    def placement_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__40200dbd2710b7b0f08e69bff18f49566e15e3f25a44147d0ba0ff8f1a2a42c6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placementVar", value)

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scale"))

    @scale.setter
    def scale(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c3ddf32b200d06a9a2f36a1ecfaf1b186da89962bfc5195c9b3f2c2639a615e4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scale", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimension")
    def scale_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimension"))

    @scale_dimension.setter
    def scale_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__788d44e843e3c9c1c26260ba54a2f56f8e4e4d7cafc78bb95bc23bffd00f2823)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimension", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVar")
    def scale_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimensionVar"))

    @scale_dimension_var.setter
    def scale_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7496607baffdb73a7eefb1ee327a3d62ed4d3add41f1fa1e5de8d3b15e607740)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="scaleVar")
    def scale_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleVar"))

    @scale_var.setter
    def scale_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__76d9e09128b63552ad9d5dd09cf353f58ed43ef376676b7c61e4d055d25e8cae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c8355f4ad492a301190e348b21ea932e7ed10fa09788ef0e2ce722a150ac7d4f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ba9caab8225e1f3b0a458ea35cbff31aab0c3b28487ed507aa7b8e25137d0692)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c3def4ea5ecbf34909364f402cfdff0aa23e70fca1dbecfb547b4472bc335577)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7242da3810a7c8d7a9fbf44b51168c6e98a46d74adcfe43cd4caa3fee7bc32c7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeComposite]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeComposite]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeComposite]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e0bca579a23f9c4d741d5ae8bb130c7e9dc69295a5afce9432970e2b690259f8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeCompound",
    jsii_struct_bases=[],
    name_mapping={"transformations": "transformations"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeCompound:
    def __init__(
        self,
        *,
        transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param transformations: transformations block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c980cc25496fbaaf1db162122b5493166dd1687be86a1ea7c104f28ac2d3b408)
            check_type(argname="argument transformations", value=transformations, expected_type=type_hints["transformations"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if transformations is not None:
            self._values["transformations"] = transformations

    @builtins.property
    def transformations(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeCompoundTransformations"]]]:
        '''transformations block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        result = self._values.get("transformations")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeCompoundTransformations"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeCompound(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeCompoundList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeCompoundList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f4450ee559c7c9d9571c20662a598f8f3288f7d9b3cd38b01f91f5547b8bcb2c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeCompoundOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1b111fd1917cc3c95c3e492e6d511c556471df36870f81c6e784538fe275b428)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeCompoundOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__91e2e9263a6a9dbfd25608e7a9dfc0bd4a6c2ddb069d3ba1328b14c028c767fc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ce51256e0a7c743a53c8e79280731d1bd4826e28a39483998e2624ff7b3e5e04)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1321e0f3fbdd0c100d54a74bf6344cd850f648ea9b59ab1f1ea3213d7cdbb318)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeCompound]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeCompound]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d770fa9fe73beb3e25008f93614b1cce32e2de48dd21d75d17657dc798aefb7c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeCompoundOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeCompoundOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__63c322f3633c1f41bccbec8c5547d6e6a63b083190d6bd2ddda6107263422ddb)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformations")
    def put_transformations(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6695d73585ef7b119375c4e345f29bed472838e8d0347383b552897111d04822)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTransformations", [value]))

    @jsii.member(jsii_name="resetTransformations")
    def reset_transformations(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformations", []))

    @builtins.property
    @jsii.member(jsii_name="transformations")
    def transformations(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeCompoundTransformationsList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeCompoundTransformationsList", jsii.get(self, "transformations"))

    @builtins.property
    @jsii.member(jsii_name="transformationsInput")
    def transformations_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeCompoundTransformations"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeCompoundTransformations"]]], jsii.get(self, "transformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeCompound]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeCompound]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeCompound]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__adb913e83c0e38f0063861b720cce380461d5ca6d6cf9f01c089af6d600ce05b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeCompoundTransformations",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeCompoundTransformations:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeCompoundTransformations(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeCompoundTransformationsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeCompoundTransformationsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__de8c6412ebfdd0267e152000e3ad74422044c1f7a50086aeb93329f215e26985)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeCompoundTransformationsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9e9db0a1fd0c23679739791cd7f0c8acb8d14ceb62d2ee50f0fc6245eec8aa17)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeCompoundTransformationsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc59a35794759381a0b30b9db830dad3b6d3f3afe262d2f91b6679f0f5aa242c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e099cae2ebf8411b6647f4046338ce5d8fff89037d53be80c9aedb1a04213178)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__afe33947e1a025c41e1a45766bfe2edb015cbd41a24eb62074eb08dc4f802a13)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeCompoundTransformations]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeCompoundTransformations]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeCompoundTransformations]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__34568d87673dfcf4cc4336d6673c8b982a895a0fb53a7126034badc96dba048d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeCompoundTransformationsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeCompoundTransformationsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3c4f597c37df25f23dad227edc67762916e60138578763801f3a0e160edbddaf)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeCompoundTransformations]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeCompoundTransformations]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeCompoundTransformations]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bff464ac8c974b0654d552b1e633f599ff86c7af5a17764258f8d7483934936c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeContrast",
    jsii_struct_bases=[],
    name_mapping={
        "brightness": "brightness",
        "brightness_var": "brightnessVar",
        "contrast": "contrast",
        "contrast_var": "contrastVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeContrast:
    def __init__(
        self,
        *,
        brightness: typing.Optional[builtins.str] = None,
        brightness_var: typing.Optional[builtins.str] = None,
        contrast: typing.Optional[builtins.str] = None,
        contrast_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param brightness: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        :param brightness_var: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        :param contrast: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param contrast_var: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e2bf73b04401cf9259236684f841bce8866cc8e43c93bc279c5c069b18f92ff0)
            check_type(argname="argument brightness", value=brightness, expected_type=type_hints["brightness"])
            check_type(argname="argument brightness_var", value=brightness_var, expected_type=type_hints["brightness_var"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument contrast_var", value=contrast_var, expected_type=type_hints["contrast_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if brightness is not None:
            self._values["brightness"] = brightness
        if brightness_var is not None:
            self._values["brightness_var"] = brightness_var
        if contrast is not None:
            self._values["contrast"] = contrast
        if contrast_var is not None:
            self._values["contrast_var"] = contrast_var

    @builtins.property
    def brightness(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        '''
        result = self._values.get("brightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def brightness_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        '''
        result = self._values.get("brightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        result = self._values.get("contrast_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeContrast(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeContrastList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeContrastList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__02e17e9c548285437ab8af8ade99756423851a77785b26407399e1924d17ae20)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeContrastOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__16a29454fe2ad93989f2de9d960ceb401d3cc3bb54537445e389dbd27e2602f3)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeContrastOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__239ef8adffa7e0c2076aa507699fc85d4df87eee842830cf7002bd8dbf7c5e0e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7031c4cef29bb7de2e4bb6afeafab03373ac32b0d584bdccadca3c898d44e59a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2279b8f2c01518e223be8abb1e0c276c0b0e5097912f1be656d21ef035c6596a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeContrast]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeContrast]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a714bce559032ea67c611e22257a1479ddabc2a259fb39f7bbf62cc57b8be695)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeContrastOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeContrastOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ee3b103ee5b583512119b75c8ca15f1f479d533d78e9c639422e2a11cb85ebf)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetBrightness")
    def reset_brightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightness", []))

    @jsii.member(jsii_name="resetBrightnessVar")
    def reset_brightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightnessVar", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetContrastVar")
    def reset_contrast_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrastVar", []))

    @builtins.property
    @jsii.member(jsii_name="brightnessInput")
    def brightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="brightnessVarInput")
    def brightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastVarInput")
    def contrast_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="brightness")
    def brightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightness"))

    @brightness.setter
    def brightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__115a73eeab26facc5715cddc592f1123a9fa1d5b66fbcd5a44d5348132486e5e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightness", value)

    @builtins.property
    @jsii.member(jsii_name="brightnessVar")
    def brightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightnessVar"))

    @brightness_var.setter
    def brightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__56de63a1a6ee3b67ed3bee13d0312072bfe787bb79d630d41daecc1feccbf608)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrast"))

    @contrast.setter
    def contrast(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__069ac3011f55838a5a32fa08b1cfdfeb5455794d2ec90883262b69239d2d4780)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrast", value)

    @builtins.property
    @jsii.member(jsii_name="contrastVar")
    def contrast_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrastVar"))

    @contrast_var.setter
    def contrast_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__86dccc6ad6ab2d0fa23a27d85648c7925a83a9de85856953892bf1929b4e7c1d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrastVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeContrast]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeContrast]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeContrast]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d0ea33c0dfcee73ea1066b6acdfb7e850037e7d473a679488f0dfb926e1519ec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeCrop",
    jsii_struct_bases=[],
    name_mapping={
        "allow_expansion": "allowExpansion",
        "allow_expansion_var": "allowExpansionVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeCrop:
    def __init__(
        self,
        *,
        allow_expansion: typing.Optional[builtins.str] = None,
        allow_expansion_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_expansion: If cropping an area outside of the existing canvas, expands the image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        :param allow_expansion_var: If cropping an area outside of the existing canvas, expands the image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        :param gravity: Frame of reference for X and Y Positions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Frame of reference for X and Y Positions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The number of pixels to crop along the y-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The number of pixels to crop along the y-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The number of pixels to crop along the x-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The number of pixels to crop along the x-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        :param x_position: The x-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a3b970af6b77c208d2ba75da5a95069ebf9e9c7b37e7e4cb9e2b3a7d36715f5)
            check_type(argname="argument allow_expansion", value=allow_expansion, expected_type=type_hints["allow_expansion"])
            check_type(argname="argument allow_expansion_var", value=allow_expansion_var, expected_type=type_hints["allow_expansion_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if allow_expansion is not None:
            self._values["allow_expansion"] = allow_expansion
        if allow_expansion_var is not None:
            self._values["allow_expansion_var"] = allow_expansion_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def allow_expansion(self) -> typing.Optional[builtins.str]:
        '''If cropping an area outside of the existing canvas, expands the image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        '''
        result = self._values.get("allow_expansion")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def allow_expansion_var(self) -> typing.Optional[builtins.str]:
        '''If cropping an area outside of the existing canvas, expands the image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        '''
        result = self._values.get("allow_expansion_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Frame of reference for X and Y Positions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Frame of reference for X and Y Positions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the y-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the y-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the x-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the x-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__51ad7837a0d847296d81c976efc6a070100d16988042446e847bf5726b80c253)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bad709eb1e1861873d998465dd5c691446aff5d16253b0fe7684ee2a072edb14)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ec3455bf359f3e012873cbbf9d78e31a18649a0e527f22dd6e8b166c9d9fb061)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fe8a0184acca97917695d9f6d1aad1105ea246a1ce114cc8dc990d167e61f7d9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a0eb8fbd3b4745d323543d3d71450dc269f5ee1252c58252151d8b354eace24)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5380f61f2474d6dcf974ebda9facc79729c9689d4626ce7c85fc976b8df60b4d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__807e5b430e8b9a0e9709162e538f6ef7ad2b234655daac186ee3ea8d458385fc)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAllowExpansion")
    def reset_allow_expansion(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansion", []))

    @jsii.member(jsii_name="resetAllowExpansionVar")
    def reset_allow_expansion_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansionVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionInput")
    def allow_expansion_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVarInput")
    def allow_expansion_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansion")
    def allow_expansion(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansion"))

    @allow_expansion.setter
    def allow_expansion(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8de163b885d93762470ba6b83af1d46a6917224952ef74c9a2fa4ef1ee5335f8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansion", value)

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVar")
    def allow_expansion_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansionVar"))

    @allow_expansion_var.setter
    def allow_expansion_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dcd26e8abc655660b40bff7e6137eaa6626ad8303330d26bc73eb73c30ef023e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansionVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__38cb18730e4dbc71e17953b91efa26f31698991e2bebcc38d01254593b0aff3c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__21f6b5fae98b42215315b1b1062b7e8704213ff236580d00652d99fe4cda05eb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4cadcfde3f2072433188ab2cd153986db8ca433b00bb3c4dd9828495e6406030)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6230b88282acf50366ff154068303a339969cf5c9880784bbbd110a69728fc0e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4d20d15bcd7b3dcbb88cc21f4ad1e0c5db63e7bd00f9519cd722d06936c35816)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6a277c711f140ee3cace9cf44a2868c986f9d0c42bfad30f5df24604580cfae7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c8b81fd3e8b050f740bd4c2918d3c8b3d9eb34e7e980bd1001a8bf9fabd1b112)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0d0097f5a74c8b5e9526877592a4d11caf2af52e5036d20679d49652bd9f51eb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__01c5e6e6cde6b86fcab72195105b33cce9dc1c9fc6e1f3bdaa38448a40c7781e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4f9b9f42793fb914af2c78077b49252289514542ea8a70f27bed96d5a3b618f6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3d767b7808aeeeaf8b4bfe07975bb430c8ec1edd8c0be17090c1a1e999042c01)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeFaceCrop",
    jsii_struct_bases=[],
    name_mapping={
        "algorithm": "algorithm",
        "algorithm_var": "algorithmVar",
        "confidence": "confidence",
        "confidence_var": "confidenceVar",
        "fail_gravity": "failGravity",
        "fail_gravity_var": "failGravityVar",
        "focus": "focus",
        "focus_var": "focusVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "padding": "padding",
        "padding_var": "paddingVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeFaceCrop:
    def __init__(
        self,
        *,
        algorithm: typing.Optional[builtins.str] = None,
        algorithm_var: typing.Optional[builtins.str] = None,
        confidence: typing.Optional[builtins.str] = None,
        confidence_var: typing.Optional[builtins.str] = None,
        fail_gravity: typing.Optional[builtins.str] = None,
        fail_gravity_var: typing.Optional[builtins.str] = None,
        focus: typing.Optional[builtins.str] = None,
        focus_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param algorithm: Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm DataAkamaiImagingPolicyImage#algorithm}
        :param algorithm_var: Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm_var DataAkamaiImagingPolicyImage#algorithm_var}
        :param confidence: With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image. Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence DataAkamaiImagingPolicyImage#confidence}
        :param confidence_var: With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image. Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence_var DataAkamaiImagingPolicyImage#confidence_var}
        :param fail_gravity: Controls placement of the crop if Image and Video Manager does not detect any faces in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        :param fail_gravity_var: Controls placement of the crop if Image and Video Manager does not detect any faces in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        :param focus: Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus DataAkamaiImagingPolicyImage#focus}
        :param focus_var: Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus_var DataAkamaiImagingPolicyImage#focus_var}
        :param gravity: Controls placement of the crop. Directions are relative to the face(s) plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Controls placement of the crop. Directions are relative to the face(s) plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param padding: The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        :param style: Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1a03db72411d7b4f8030fe56c79dbbdf1409ba09356a9e6c1007c6cece6d6208)
            check_type(argname="argument algorithm", value=algorithm, expected_type=type_hints["algorithm"])
            check_type(argname="argument algorithm_var", value=algorithm_var, expected_type=type_hints["algorithm_var"])
            check_type(argname="argument confidence", value=confidence, expected_type=type_hints["confidence"])
            check_type(argname="argument confidence_var", value=confidence_var, expected_type=type_hints["confidence_var"])
            check_type(argname="argument fail_gravity", value=fail_gravity, expected_type=type_hints["fail_gravity"])
            check_type(argname="argument fail_gravity_var", value=fail_gravity_var, expected_type=type_hints["fail_gravity_var"])
            check_type(argname="argument focus", value=focus, expected_type=type_hints["focus"])
            check_type(argname="argument focus_var", value=focus_var, expected_type=type_hints["focus_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if algorithm is not None:
            self._values["algorithm"] = algorithm
        if algorithm_var is not None:
            self._values["algorithm_var"] = algorithm_var
        if confidence is not None:
            self._values["confidence"] = confidence
        if confidence_var is not None:
            self._values["confidence_var"] = confidence_var
        if fail_gravity is not None:
            self._values["fail_gravity"] = fail_gravity
        if fail_gravity_var is not None:
            self._values["fail_gravity_var"] = fail_gravity_var
        if focus is not None:
            self._values["focus"] = focus
        if focus_var is not None:
            self._values["focus_var"] = focus_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def algorithm(self) -> typing.Optional[builtins.str]:
        '''Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm DataAkamaiImagingPolicyImage#algorithm}
        '''
        result = self._values.get("algorithm")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def algorithm_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm_var DataAkamaiImagingPolicyImage#algorithm_var}
        '''
        result = self._values.get("algorithm_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def confidence(self) -> typing.Optional[builtins.str]:
        '''With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image.

        Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence DataAkamaiImagingPolicyImage#confidence}
        '''
        result = self._values.get("confidence")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def confidence_var(self) -> typing.Optional[builtins.str]:
        '''With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image.

        Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence_var DataAkamaiImagingPolicyImage#confidence_var}
        '''
        result = self._values.get("confidence_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any faces in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        '''
        result = self._values.get("fail_gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any faces in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        '''
        result = self._values.get("fail_gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def focus(self) -> typing.Optional[builtins.str]:
        '''Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus DataAkamaiImagingPolicyImage#focus}
        '''
        result = self._values.get("focus")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def focus_var(self) -> typing.Optional[builtins.str]:
        '''Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus_var DataAkamaiImagingPolicyImage#focus_var}
        '''
        result = self._values.get("focus_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the face(s) plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the face(s) plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeFaceCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeFaceCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeFaceCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__99d5466048e34253451e7cc2e8fd87ca4b0f100830cb155366cf3464cf4d154b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeFaceCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f23ea1d516eba9b63873aa497b4e414b07b73a7b97f726d9d955188b6af8f83c)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeFaceCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c2316ccb1108fbaecb4adaf7b88ddc1abd414b3dc677e87627663cb9e6ae0ea9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__36a6963712abc543e9c0cebdc08165abb16b71e85e54de1bbf32c1833ab5c79e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1d7abe49d61c66d4784094b28662173eb9b4d2d8f5e54c0ef4bea3056938ec2e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeFaceCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeFaceCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeFaceCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a08c9c5821b369c27de996225c55b7707eb0122d465775e369ce6f428e77e3c0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeFaceCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeFaceCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__212ae634d8f9cbd83f41374251438cc25bf2d382b38275975e0c528dc2e9a8d7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAlgorithm")
    def reset_algorithm(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAlgorithm", []))

    @jsii.member(jsii_name="resetAlgorithmVar")
    def reset_algorithm_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAlgorithmVar", []))

    @jsii.member(jsii_name="resetConfidence")
    def reset_confidence(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetConfidence", []))

    @jsii.member(jsii_name="resetConfidenceVar")
    def reset_confidence_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetConfidenceVar", []))

    @jsii.member(jsii_name="resetFailGravity")
    def reset_fail_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravity", []))

    @jsii.member(jsii_name="resetFailGravityVar")
    def reset_fail_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravityVar", []))

    @jsii.member(jsii_name="resetFocus")
    def reset_focus(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFocus", []))

    @jsii.member(jsii_name="resetFocusVar")
    def reset_focus_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFocusVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="algorithmInput")
    def algorithm_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "algorithmInput"))

    @builtins.property
    @jsii.member(jsii_name="algorithmVarInput")
    def algorithm_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "algorithmVarInput"))

    @builtins.property
    @jsii.member(jsii_name="confidenceInput")
    def confidence_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "confidenceInput"))

    @builtins.property
    @jsii.member(jsii_name="confidenceVarInput")
    def confidence_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "confidenceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityInput")
    def fail_gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityVarInput")
    def fail_gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="focusInput")
    def focus_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "focusInput"))

    @builtins.property
    @jsii.member(jsii_name="focusVarInput")
    def focus_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "focusVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="algorithm")
    def algorithm(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "algorithm"))

    @algorithm.setter
    def algorithm(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f62af0d78c4dc65a1c1135803f0b01a3b422d45f17627d7b46b20e2532a9e9ee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "algorithm", value)

    @builtins.property
    @jsii.member(jsii_name="algorithmVar")
    def algorithm_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "algorithmVar"))

    @algorithm_var.setter
    def algorithm_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ab0bf5743cfc2965f1c7690ff5613dfd9b6d065601f6ab7f60a285eba6ebcdd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "algorithmVar", value)

    @builtins.property
    @jsii.member(jsii_name="confidence")
    def confidence(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "confidence"))

    @confidence.setter
    def confidence(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0472ba389da3c370bc937d8706eaf8af5a1dcc14066bde7ce0895682ea38106a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "confidence", value)

    @builtins.property
    @jsii.member(jsii_name="confidenceVar")
    def confidence_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "confidenceVar"))

    @confidence_var.setter
    def confidence_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1e64e72c1b80a82d71aa4dcb072435e248e1ebd1e8a2fd89fb5ab7e4821eb3ea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "confidenceVar", value)

    @builtins.property
    @jsii.member(jsii_name="failGravity")
    def fail_gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravity"))

    @fail_gravity.setter
    def fail_gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dac297b8aa99fe9b20fe6039f493716bd5975599ad14d79f3215de8430164c84)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravity", value)

    @builtins.property
    @jsii.member(jsii_name="failGravityVar")
    def fail_gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravityVar"))

    @fail_gravity_var.setter
    def fail_gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5eee277091226d88eb905bd5a1e91a5d679b7956c337734a912e47fa6a54a542)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="focus")
    def focus(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "focus"))

    @focus.setter
    def focus(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b52fbdc8ed0b47fa1d33554abf9cd3acf785fc02a25b4dbabb16d6270be79774)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "focus", value)

    @builtins.property
    @jsii.member(jsii_name="focusVar")
    def focus_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "focusVar"))

    @focus_var.setter
    def focus_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b9604de5d17aea848f03c885ee59f59f539148cf411b97303db046ebfd52af51)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "focusVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3565c40eb1c19c0a17e76eb8900717722f260940eaf2be1a1ab9c4a3ca5b3abf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__411f175c951686171091c0ae6b80d048ed753aba83fd46cc02612a0a045a11e8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__42bd6f91ce10f06e80445c6cb525ed87b355b927f32122d7c240046238e69596)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__91d2513243aed4f36738d3c2a0521c1ee85741c652d28aa23b48cbf1886d1208)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__83dd5a2959dacaa347ccfb376c4e104987d68ecb46de38bd7721e7c610af24fb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab045afc119ae263c4363f5e740aac7e65da980cc7edf4cd5d0e7419a4ba9e0c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0e6931e855924a7074512cbb71e1d80cf2e2c38a07ef81cf97aba50e180ff241)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2b1308d19463b3f0647fca4f3e31e907261175c2dec08a9a0689660ac3a8f042)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__52815017e74f2401c62f626142f3a1f980630315991042455b49b12da64ea787)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be205e564cd9a230f525ab433c0cd74962061598ac56b3b92aa91275e7a65d4e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeFaceCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeFaceCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeFaceCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__367655890b0af027700ed1fdd02341e42325a6b65c5ec32d0821c79ec13eca08)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeFeatureCrop",
    jsii_struct_bases=[],
    name_mapping={
        "fail_gravity": "failGravity",
        "fail_gravity_var": "failGravityVar",
        "feature_radius": "featureRadius",
        "feature_radius_var": "featureRadiusVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "max_features": "maxFeatures",
        "max_features_var": "maxFeaturesVar",
        "min_feature_quality": "minFeatureQuality",
        "min_feature_quality_var": "minFeatureQualityVar",
        "padding": "padding",
        "padding_var": "paddingVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeFeatureCrop:
    def __init__(
        self,
        *,
        fail_gravity: typing.Optional[builtins.str] = None,
        fail_gravity_var: typing.Optional[builtins.str] = None,
        feature_radius: typing.Optional[builtins.str] = None,
        feature_radius_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        max_features: typing.Optional[builtins.str] = None,
        max_features_var: typing.Optional[builtins.str] = None,
        min_feature_quality: typing.Optional[builtins.str] = None,
        min_feature_quality_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fail_gravity: Controls placement of the crop if Image and Video Manager does not detect any features in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        :param fail_gravity_var: Controls placement of the crop if Image and Video Manager does not detect any features in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        :param feature_radius: The size in pixels of the important features to search for. If identified, two features never appear closer together than this value, ``8.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius DataAkamaiImagingPolicyImage#feature_radius}
        :param feature_radius_var: The size in pixels of the important features to search for. If identified, two features never appear closer together than this value, ``8.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius_var DataAkamaiImagingPolicyImage#feature_radius_var}
        :param gravity: Controls placement of the crop. Directions are relative to the region of interest plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Controls placement of the crop. Directions are relative to the region of interest plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param max_features: The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features DataAkamaiImagingPolicyImage#max_features}
        :param max_features_var: The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features_var DataAkamaiImagingPolicyImage#max_features_var}
        :param min_feature_quality: Determines the minimum quality level of the feature identified. To consider a feature important, the feature needs to surpass this value. Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality DataAkamaiImagingPolicyImage#min_feature_quality}
        :param min_feature_quality_var: Determines the minimum quality level of the feature identified. To consider a feature important, the feature needs to surpass this value. Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality_var DataAkamaiImagingPolicyImage#min_feature_quality_var}
        :param padding: Adds space around the region of interest. The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: Adds space around the region of interest. The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        :param style: Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2b3f1c30e75619626924be57d5985a88dc55b0e8dea33f742bee4b41f03617b6)
            check_type(argname="argument fail_gravity", value=fail_gravity, expected_type=type_hints["fail_gravity"])
            check_type(argname="argument fail_gravity_var", value=fail_gravity_var, expected_type=type_hints["fail_gravity_var"])
            check_type(argname="argument feature_radius", value=feature_radius, expected_type=type_hints["feature_radius"])
            check_type(argname="argument feature_radius_var", value=feature_radius_var, expected_type=type_hints["feature_radius_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument max_features", value=max_features, expected_type=type_hints["max_features"])
            check_type(argname="argument max_features_var", value=max_features_var, expected_type=type_hints["max_features_var"])
            check_type(argname="argument min_feature_quality", value=min_feature_quality, expected_type=type_hints["min_feature_quality"])
            check_type(argname="argument min_feature_quality_var", value=min_feature_quality_var, expected_type=type_hints["min_feature_quality_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fail_gravity is not None:
            self._values["fail_gravity"] = fail_gravity
        if fail_gravity_var is not None:
            self._values["fail_gravity_var"] = fail_gravity_var
        if feature_radius is not None:
            self._values["feature_radius"] = feature_radius
        if feature_radius_var is not None:
            self._values["feature_radius_var"] = feature_radius_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if max_features is not None:
            self._values["max_features"] = max_features
        if max_features_var is not None:
            self._values["max_features_var"] = max_features_var
        if min_feature_quality is not None:
            self._values["min_feature_quality"] = min_feature_quality
        if min_feature_quality_var is not None:
            self._values["min_feature_quality_var"] = min_feature_quality_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def fail_gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any features in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        '''
        result = self._values.get("fail_gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any features in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        '''
        result = self._values.get("fail_gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feature_radius(self) -> typing.Optional[builtins.str]:
        '''The size in pixels of the important features to search for.

        If identified, two features never appear closer together than this value, ``8.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius DataAkamaiImagingPolicyImage#feature_radius}
        '''
        result = self._values.get("feature_radius")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feature_radius_var(self) -> typing.Optional[builtins.str]:
        '''The size in pixels of the important features to search for.

        If identified, two features never appear closer together than this value, ``8.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius_var DataAkamaiImagingPolicyImage#feature_radius_var}
        '''
        result = self._values.get("feature_radius_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the region of interest plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the region of interest plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def max_features(self) -> typing.Optional[builtins.str]:
        '''The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features DataAkamaiImagingPolicyImage#max_features}
        '''
        result = self._values.get("max_features")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def max_features_var(self) -> typing.Optional[builtins.str]:
        '''The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features_var DataAkamaiImagingPolicyImage#max_features_var}
        '''
        result = self._values.get("max_features_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def min_feature_quality(self) -> typing.Optional[builtins.str]:
        '''Determines the minimum quality level of the feature identified.

        To consider a feature important, the feature needs to surpass this value.  Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality DataAkamaiImagingPolicyImage#min_feature_quality}
        '''
        result = self._values.get("min_feature_quality")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def min_feature_quality_var(self) -> typing.Optional[builtins.str]:
        '''Determines the minimum quality level of the feature identified.

        To consider a feature important, the feature needs to surpass this value.  Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality_var DataAkamaiImagingPolicyImage#min_feature_quality_var}
        '''
        result = self._values.get("min_feature_quality_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''Adds space around the region of interest.

        The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''Adds space around the region of interest.

        The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeFeatureCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeFeatureCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeFeatureCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6b791721b5d07a9f2393b37351d4c5c209c373601e77cf82115831cf82e38f99)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeFeatureCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__561a88138ab1eebd9a7ada4ff05cce94793e3f36b195fbe2002c4560f1cdb43e)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeFeatureCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bba012b4cc6a6448fe20de0671a0db77a79f671f86df7454acf551d0103b317e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__85d179bef465a4103cbddbafe190957e47c861ab87f2fc4772f3fc5143250884)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__09a0aa687bedb5cfaff19c582918d2b987b61c01eb0c010c9254116fb9352561)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeFeatureCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeFeatureCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeFeatureCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1bec8f24676971dbcdf9585ac8f1f8bd912214e075c70ecbd45b737869f587b3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeFeatureCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeFeatureCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5e2de871c484073ce66dcf40ae1668af10fbb6c37bb7a12ae635d3c0efa86e73)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetFailGravity")
    def reset_fail_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravity", []))

    @jsii.member(jsii_name="resetFailGravityVar")
    def reset_fail_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravityVar", []))

    @jsii.member(jsii_name="resetFeatureRadius")
    def reset_feature_radius(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureRadius", []))

    @jsii.member(jsii_name="resetFeatureRadiusVar")
    def reset_feature_radius_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureRadiusVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetMaxFeatures")
    def reset_max_features(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxFeatures", []))

    @jsii.member(jsii_name="resetMaxFeaturesVar")
    def reset_max_features_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxFeaturesVar", []))

    @jsii.member(jsii_name="resetMinFeatureQuality")
    def reset_min_feature_quality(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMinFeatureQuality", []))

    @jsii.member(jsii_name="resetMinFeatureQualityVar")
    def reset_min_feature_quality_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMinFeatureQualityVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="failGravityInput")
    def fail_gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityVarInput")
    def fail_gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featureRadiusInput")
    def feature_radius_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featureRadiusInput"))

    @builtins.property
    @jsii.member(jsii_name="featureRadiusVarInput")
    def feature_radius_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featureRadiusVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesInput")
    def max_features_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "maxFeaturesInput"))

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesVarInput")
    def max_features_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "maxFeaturesVarInput"))

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityInput")
    def min_feature_quality_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "minFeatureQualityInput"))

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityVarInput")
    def min_feature_quality_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "minFeatureQualityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravity")
    def fail_gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravity"))

    @fail_gravity.setter
    def fail_gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__761585772d70af04b24baa37b15a9dd39afb4ca03a5efba09da8b8b0b871cdee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravity", value)

    @builtins.property
    @jsii.member(jsii_name="failGravityVar")
    def fail_gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravityVar"))

    @fail_gravity_var.setter
    def fail_gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a523fc7c68d17bf87f7eddd9c612598ed23d3513cd48f7abf3bc3beced5d8d4b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="featureRadius")
    def feature_radius(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featureRadius"))

    @feature_radius.setter
    def feature_radius(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1177918dfe7f27d539b887e6a2b454d3f9558f6050b3faa0ab62980790eb43cd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featureRadius", value)

    @builtins.property
    @jsii.member(jsii_name="featureRadiusVar")
    def feature_radius_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featureRadiusVar"))

    @feature_radius_var.setter
    def feature_radius_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0189aab645279bd659be29979520918087a6be1c02adf286e37987fb3db4e2bf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featureRadiusVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__07f48bdf1e4d3a6895ce662367fabfee5bf68dde9f118b11c02d221591aa5204)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6d12ec234ad3b5e3d2778c6b44eae29929fae0b4b55424f845568a9bf4a1c56e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ce432ca8f72fe948dd8c7af64e969188db0ea286572926d9650a304f905af07)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__658b7e3ca61a8775213f0d99c15fac116cfaa03c0ae7dea76dfdd2cccf0b221e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="maxFeatures")
    def max_features(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "maxFeatures"))

    @max_features.setter
    def max_features(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__38403112c40913d2fae08fbb42eeef428c1186309b1de242248f39f1edbbaf1b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "maxFeatures", value)

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesVar")
    def max_features_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "maxFeaturesVar"))

    @max_features_var.setter
    def max_features_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b92a478096acc4995ad8f03f18ed47ba9e4ed06f2788bc463621b41f05e44d27)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "maxFeaturesVar", value)

    @builtins.property
    @jsii.member(jsii_name="minFeatureQuality")
    def min_feature_quality(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "minFeatureQuality"))

    @min_feature_quality.setter
    def min_feature_quality(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__23c5761a0600c7dedf887d0750207685fd5c93598b63885e7741767ef6c38457)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "minFeatureQuality", value)

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityVar")
    def min_feature_quality_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "minFeatureQualityVar"))

    @min_feature_quality_var.setter
    def min_feature_quality_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6eafe230e228bf6da1edc226374a45745b03adbc04ec208aad8f7889c888e25c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "minFeatureQualityVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__99088bf545c5c8eac947b48dec2c95f6714adb5d933563389f9e5c7079b5cbca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e3f229fae84bbda44e6e1c47b0e90759bf2073308b141cd2f05a32bfc52a7f85)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__379bdae60002b93ac524eeb17001b3379abcdfaec5c010b948cac068d3feb4ac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2085869b7c2869edc1fd3480a8a2d4affae8c2b2b17d8fa3daa5b39015126251)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dafbd1b2a1af36d458bb6f949c4bae89ef692e33b96a2f87afbd389085be057f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__00348caca8d5e62fffe9c6662789801bc72ce946199815d74ab880c252ff7d13)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeFeatureCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeFeatureCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeFeatureCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__245d4bf280a999e2ceb01b0e47537ca27d9ccceba66d9f75b514728af481549c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeFitAndFill",
    jsii_struct_bases=[],
    name_mapping={
        "fill_transformation": "fillTransformation",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeFitAndFill:
    def __init__(
        self,
        *,
        fill_transformation: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeFitAndFillFillTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fill_transformation: fill_transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_transformation DataAkamaiImagingPolicyImage#fill_transformation}
        :param height: The height value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The width value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(fill_transformation, dict):
            fill_transformation = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeFitAndFillFillTransformation(**fill_transformation)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e53d9888705ceb932255999e20150d5cf7327bcd58092e3ff02f72e1b16b49f2)
            check_type(argname="argument fill_transformation", value=fill_transformation, expected_type=type_hints["fill_transformation"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fill_transformation is not None:
            self._values["fill_transformation"] = fill_transformation
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def fill_transformation(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeFitAndFillFillTransformation"]:
        '''fill_transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_transformation DataAkamaiImagingPolicyImage#fill_transformation}
        '''
        result = self._values.get("fill_transformation")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeFitAndFillFillTransformation"], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeFitAndFill(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeFitAndFillFillTransformation",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeFitAndFillFillTransformation:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeFitAndFillFillTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeFitAndFillFillTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeFitAndFillFillTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fcfd6dca2d89916ba8013820e1813ed12d3782ab43c51cd9f15bd1cde066fce6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeFitAndFillFillTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeFitAndFillFillTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeFitAndFillFillTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f605091b1957da404cc1e04b0969dc12dd926cf7fd0a98eccf029795db010236)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeFitAndFillList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeFitAndFillList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__63844ef0f487b210d73e9d52ba60048f28a8f79d087ae070d34692f9c5dbe4f7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeFitAndFillOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3affbe7dc9b75e2c85093496f69d73e444f52e8bc91f4fead08cec5561ef4dff)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeFitAndFillOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0679ae97c3538b2158936a13bd13de4ef4c5f587dc43f181c3cce3358b4fffc5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b2d7b42eb1c88b8d010b50cf2cd0f54f4d4255ba39e0e43234cdeedd9653ff67)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__09ada8e3661008e7ff3d9177299b0e94ab74c6dc3f8387f1a9a318e9218ddd01)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeFitAndFill]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeFitAndFill]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeFitAndFill]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0f784e871aa56bbc413088f9fc569952e6d29f09d95efea2df90378979626c4c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeFitAndFillOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeFitAndFillOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be1ef914f3e49da4316271bbd3376d1b9adb6875dec7286699ea9a75dbb2f98f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putFillTransformation")
    def put_fill_transformation(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeFitAndFillFillTransformation()

        return typing.cast(None, jsii.invoke(self, "putFillTransformation", [value]))

    @jsii.member(jsii_name="resetFillTransformation")
    def reset_fill_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFillTransformation", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="fillTransformation")
    def fill_transformation(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeFitAndFillFillTransformationOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeFitAndFillFillTransformationOutputReference, jsii.get(self, "fillTransformation"))

    @builtins.property
    @jsii.member(jsii_name="fillTransformationInput")
    def fill_transformation_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeFitAndFillFillTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeFitAndFillFillTransformation], jsii.get(self, "fillTransformationInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a3589ebc49a23ddf80622a7051a4bc139138434aa3e038fd3504c7205707d298)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b972dcca1b90d79bc72c8dfea1cbefe79b8251eb616183084b6efca45aa6f5df)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e22aa2bb1b4af6a399789f774da8c31ed96adc995b41cb11a281d58600e1d674)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ddd9370c2685c0df71c86c2efb817088a50f33ee287978442399f76ca4bda23)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeFitAndFill]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeFitAndFill]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeFitAndFill]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__04971c9b047187af234ec9b7bdf69fc73e7e704b17ba061396fd30c765cfe300)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeGoop",
    jsii_struct_bases=[],
    name_mapping={
        "chaos": "chaos",
        "chaos_var": "chaosVar",
        "density": "density",
        "density_var": "densityVar",
        "power": "power",
        "power_var": "powerVar",
        "seed": "seed",
        "seed_var": "seedVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeGoop:
    def __init__(
        self,
        *,
        chaos: typing.Optional[builtins.str] = None,
        chaos_var: typing.Optional[builtins.str] = None,
        density: typing.Optional[builtins.str] = None,
        density_var: typing.Optional[builtins.str] = None,
        power: typing.Optional[builtins.str] = None,
        power_var: typing.Optional[builtins.str] = None,
        seed: typing.Optional[builtins.str] = None,
        seed_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param chaos: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        :param chaos_var: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        :param density: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        :param density_var: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        :param power: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        :param power_var: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        :param seed: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        :param seed_var: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ae9c7b3d016a7495effae73acddf3840105f3289ee253264a84d7808de91d96)
            check_type(argname="argument chaos", value=chaos, expected_type=type_hints["chaos"])
            check_type(argname="argument chaos_var", value=chaos_var, expected_type=type_hints["chaos_var"])
            check_type(argname="argument density", value=density, expected_type=type_hints["density"])
            check_type(argname="argument density_var", value=density_var, expected_type=type_hints["density_var"])
            check_type(argname="argument power", value=power, expected_type=type_hints["power"])
            check_type(argname="argument power_var", value=power_var, expected_type=type_hints["power_var"])
            check_type(argname="argument seed", value=seed, expected_type=type_hints["seed"])
            check_type(argname="argument seed_var", value=seed_var, expected_type=type_hints["seed_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if chaos is not None:
            self._values["chaos"] = chaos
        if chaos_var is not None:
            self._values["chaos_var"] = chaos_var
        if density is not None:
            self._values["density"] = density
        if density_var is not None:
            self._values["density_var"] = density_var
        if power is not None:
            self._values["power"] = power
        if power_var is not None:
            self._values["power_var"] = power_var
        if seed is not None:
            self._values["seed"] = seed
        if seed_var is not None:
            self._values["seed_var"] = seed_var

    @builtins.property
    def chaos(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        '''
        result = self._values.get("chaos")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def chaos_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        '''
        result = self._values.get("chaos_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        '''
        result = self._values.get("density")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density_var(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        '''
        result = self._values.get("density_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        '''
        result = self._values.get("power")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power_var(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        '''
        result = self._values.get("power_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        '''
        result = self._values.get("seed")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed_var(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        result = self._values.get("seed_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeGoop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeGoopList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeGoopList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9f9ed73b5b7db5aa4752e67bade9bc9dbec2917743e7548522ca2f5eff211132)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeGoopOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b5664ccc74dd0e06d5dee7e97fb578fec3f33fab1e8d169aa36907d20568ee33)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeGoopOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d0d30f985924beaee839dc22ec8a149e34f417481e551d1efdac04dba6f4f91a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd9edf5b65ad530d98ca46ba087f4b9b3e8095872723cdd3b8430dfe159676ad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d8dace419c523325ba77babb24c16572c4a81e6737a6e571a6eb8c092432ed0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeGoop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeGoop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__327a652d09173c5298f73e0a0357ca15bc12ae00d7d1eb1dacaa87b1acf0a703)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeGoopOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeGoopOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea5735989145bb9190193ebbc3e462b4ef13f0f82f3dd7031238b6132fbc8e9a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetChaos")
    def reset_chaos(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaos", []))

    @jsii.member(jsii_name="resetChaosVar")
    def reset_chaos_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaosVar", []))

    @jsii.member(jsii_name="resetDensity")
    def reset_density(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensity", []))

    @jsii.member(jsii_name="resetDensityVar")
    def reset_density_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensityVar", []))

    @jsii.member(jsii_name="resetPower")
    def reset_power(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPower", []))

    @jsii.member(jsii_name="resetPowerVar")
    def reset_power_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPowerVar", []))

    @jsii.member(jsii_name="resetSeed")
    def reset_seed(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeed", []))

    @jsii.member(jsii_name="resetSeedVar")
    def reset_seed_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeedVar", []))

    @builtins.property
    @jsii.member(jsii_name="chaosInput")
    def chaos_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosInput"))

    @builtins.property
    @jsii.member(jsii_name="chaosVarInput")
    def chaos_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosVarInput"))

    @builtins.property
    @jsii.member(jsii_name="densityInput")
    def density_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityInput"))

    @builtins.property
    @jsii.member(jsii_name="densityVarInput")
    def density_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="powerInput")
    def power_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerInput"))

    @builtins.property
    @jsii.member(jsii_name="powerVarInput")
    def power_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerVarInput"))

    @builtins.property
    @jsii.member(jsii_name="seedInput")
    def seed_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedInput"))

    @builtins.property
    @jsii.member(jsii_name="seedVarInput")
    def seed_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedVarInput"))

    @builtins.property
    @jsii.member(jsii_name="chaos")
    def chaos(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaos"))

    @chaos.setter
    def chaos(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__464217cec508a06c046798cf7bf31c24aa477c89c322434650978725b9c0902e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaos", value)

    @builtins.property
    @jsii.member(jsii_name="chaosVar")
    def chaos_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaosVar"))

    @chaos_var.setter
    def chaos_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__55630f93f7916180c665e957622dc271b41f01318a8247661b02a7d19bcf9041)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaosVar", value)

    @builtins.property
    @jsii.member(jsii_name="density")
    def density(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "density"))

    @density.setter
    def density(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__33d3411230b13209b25486ca4988357e913ada8663910516821e46ae5baa2dbd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "density", value)

    @builtins.property
    @jsii.member(jsii_name="densityVar")
    def density_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "densityVar"))

    @density_var.setter
    def density_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cf290d9de0c303059bc594320417ebcba12df26d20d759be5f5b0b379f3b4b54)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "densityVar", value)

    @builtins.property
    @jsii.member(jsii_name="power")
    def power(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "power"))

    @power.setter
    def power(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9fbdcee1c044d7c6b89c8d704a644f935afcf038a926890b48e6ea881e272602)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "power", value)

    @builtins.property
    @jsii.member(jsii_name="powerVar")
    def power_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "powerVar"))

    @power_var.setter
    def power_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e6fd21c03f0d8897ff7e8ef6198e2ac45ae46e895dbe7e1a88173d1a543fdc8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "powerVar", value)

    @builtins.property
    @jsii.member(jsii_name="seed")
    def seed(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seed"))

    @seed.setter
    def seed(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c70b15cbf9513dcf11596599b1c9c6d154770cff27209314004d85956848dafd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seed", value)

    @builtins.property
    @jsii.member(jsii_name="seedVar")
    def seed_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seedVar"))

    @seed_var.setter
    def seed_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__765e7654b580fe7c74653c8687f884afdce90079f600958b6241bea3f16eee86)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seedVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeGoop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeGoop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeGoop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d70755f13dd4bc51e9f26db46f38e8db54e9fae1c92ffc915d66747464e690e7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeGrayscale",
    jsii_struct_bases=[],
    name_mapping={"type": "type", "type_var": "typeVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeGrayscale:
    def __init__(
        self,
        *,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param type: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a20cf1431aee1f959d9325412b6c22e9a8af7eb977bf4743f002a2f8784ab9e)
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeGrayscale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeGrayscaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeGrayscaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__92087cc2d5cef03b637b5ab99632e2b4ffc27c4076b0820e2741278427a6548d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeGrayscaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b239c5f6b6b18e4288803031a4e326850c6fc3a8c51fffe2d95d7ab5bad10259)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeGrayscaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a736eb1b7eec39e58846bc271eaaa30d562d4a529eb3895ef4b525d455c184f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5de5d1951a95c24d7d65ca3017b12b35c4b7759c6e00e41c2b1e198c9cec188d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2472438eeefd3b41f2a6b3019de198fe21d9b4bcc733bd5e0f10345e3ac692f8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeGrayscale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeGrayscale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cb07653d2d5a9714a064639f3f2fbb966a2b8d46042a7050c6cf6479c310a2a1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeGrayscaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeGrayscaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dc138002ecb891b4740a2dcb61ca049eeb5174e32e6c9f237b2a5a9c819416fa)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d39639deec2ef164ab7053349f4f1866810247ff2f1946215f615e92d14e4b43)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b4f86ea03ad89b23689307d0000fee80027787fae02a7bcca966b41b745fdadc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeGrayscale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeGrayscale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeGrayscale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d41c12c29a4a23712fa09a41218c56f65cbd4a2bb4e372ad2a1a19a31e3f88b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeHsl",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "lightness": "lightness",
        "lightness_var": "lightnessVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeHsl:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness: typing.Optional[builtins.str] = None,
        lightness_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        :param lightness_var: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f5814cb20e699286d64bb9e51952c308958a6dbe1d3f6be0ce351522e6cc6cef)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness", value=lightness, expected_type=type_hints["lightness"])
            check_type(argname="argument lightness_var", value=lightness_var, expected_type=type_hints["lightness_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness is not None:
            self._values["lightness"] = lightness
        if lightness_var is not None:
            self._values["lightness_var"] = lightness_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        '''
        result = self._values.get("lightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        '''
        result = self._values.get("lightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeHsl(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeHslList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeHslList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2f79bbf286e876a14b429926ddc84d950e7d8db3a886bc2627c699542806f16f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeHslOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af78e7f98437c3ef1466452d2949414afe5802c33eeec0783a1b096e3b542b05)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeHslOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c6059ca73529141309c4608924c398cb87f8c1ea9637ad1a48255e7813d00d12)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__63f7ac698e651a04df3c2f33691fbc8aaef9f55b577d405eaadab30efd320347)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dc8df1f3c79f3faeb3474637416844d8d5e63fc34b66646f4705d76bbbbf26de)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeHsl]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeHsl]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__35cdf41e1e5296a8cd103cba056476e5510951b76f18169313d3d5eb91db394e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeHslOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeHslOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d2d1a9e4f4f8d6e091bb74f02af26930aa25a78674718ed64ecf5a196ee8a77d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightness")
    def reset_lightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightness", []))

    @jsii.member(jsii_name="resetLightnessVar")
    def reset_lightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessInput")
    def lightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessVarInput")
    def lightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__087ff0daa616764b580437a3248e46e2733adbec3e29679d951f7dd477e5192d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f5a7dd35dd9d0dda1a5f071a2e4bd56de8343fe530e3c5388c7ec4250ab39e28)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightness")
    def lightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightness"))

    @lightness.setter
    def lightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__459a204e0287e8db7c1607e3f42c420f1d4f850eb113f35f3cab3d619b8c12a9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightness", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessVar")
    def lightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessVar"))

    @lightness_var.setter
    def lightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4b3da526ea3ba37e6debb168e4da736b7b7bf6abfc571a6a72e43fadea8a7713)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ae750e1fa6632aa260173ce1265dd943072893a88cc2c80d22f8ed4a3d30db81)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e957dea405dea6e3cd2a01e6860ecf512fbdec201470f8204629cc4e709ca37a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeHsl]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeHsl]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeHsl]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a45782c6ca694f0b044b1bbc1c4f7c14d9db985dc63df88b41818ffb6724e3fa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeHsv",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeHsv:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        :param value: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__06491600faf7f63a129cbe1ac11f4c791545e4f66ba6657551861c7cfa9054bc)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeHsv(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeHsvList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeHsvList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac309a8abcca4cad0671a65669ffbe50883a358b34a1642b4e1cb7674b1fbd94)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeHsvOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f511f20ac6221b129a3678190331ad69909a565d323ad37ccd1791e4cd240c03)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeHsvOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d9ad2cbee2ad5242356fac0319f7f1fbd6b5acc6033d343212741fb4748e1934)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__69193771591e3adc9d395d1117ec4bc7fb5df7c25520008e5eafa83262ef7852)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__05c6c60c61024dff32585ff7a9cfa6f5a5e60d92a181112b9106c23a950d3771)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeHsv]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeHsv]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0cc6d7ebdf6b6c5add4af87aefcec29aca79bfae0b578b57a4cf813288950794)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeHsvOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeHsvOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__847f5ef4ad0048ecf5acaed7b4c2fdd585c5a80f32828c194a71a2f159bfad4a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f5a12a855f089d2086e31258f11d17bfcc9baf1ad0a42f10d94d5d093ea705f6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__96f145cbf2f452c7ebb1102d160ff06f949862ff46ca4f90a3acc74903327b46)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2619eb6d34ec9170b136625b57b9cf518662810b3b940232bb37f03873334621)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df0c2c0c06b062897c12a4ca3b2b2d2fc8b11f0149c82d9dbcb41d5210a1fe55)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e8ddc14be4197f424ecde40b385d11c2fb8df90035770d36553ceb21f478e13d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5191d0ef6fe54c00d1b9bd11016aef8fc086a2de0bad13f4c7815a125537a5c5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeHsv]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeHsv]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeHsv]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__56fa18f985bae1e2396c5fdf717446111e9ee9f37ec8a1d6ad89a3d1eae22ab3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfDimension",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "dimension": "dimension",
        "dimension_var": "dimensionVar",
        "equal": "equal",
        "greater_than": "greaterThan",
        "less_than": "lessThan",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfDimension:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        dimension: typing.Optional[builtins.str] = None,
        dimension_var: typing.Optional[builtins.str] = None,
        equal: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionEqual", typing.Dict[builtins.str, typing.Any]]] = None,
        greater_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionGreaterThan", typing.Dict[builtins.str, typing.Any]]] = None,
        less_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionLessThan", typing.Dict[builtins.str, typing.Any]]] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param dimension: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        :param dimension_var: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        :param equal: equal block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        :param greater_than: greater_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        :param less_than: less_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        :param value: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionDefault(**default)
        if isinstance(equal, dict):
            equal = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionEqual(**equal)
        if isinstance(greater_than, dict):
            greater_than = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionGreaterThan(**greater_than)
        if isinstance(less_than, dict):
            less_than = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionLessThan(**less_than)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__708e28e1ef161c1d59fcf161d06cb99ae1fc85b8daac893ddb05a231769c095b)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument dimension", value=dimension, expected_type=type_hints["dimension"])
            check_type(argname="argument dimension_var", value=dimension_var, expected_type=type_hints["dimension_var"])
            check_type(argname="argument equal", value=equal, expected_type=type_hints["equal"])
            check_type(argname="argument greater_than", value=greater_than, expected_type=type_hints["greater_than"])
            check_type(argname="argument less_than", value=less_than, expected_type=type_hints["less_than"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if dimension is not None:
            self._values["dimension"] = dimension
        if dimension_var is not None:
            self._values["dimension_var"] = dimension_var
        if equal is not None:
            self._values["equal"] = equal
        if greater_than is not None:
            self._values["greater_than"] = greater_than
        if less_than is not None:
            self._values["less_than"] = less_than
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionDefault"], result)

    @builtins.property
    def dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        '''
        result = self._values.get("dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        '''
        result = self._values.get("dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def equal(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionEqual"]:
        '''equal block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        '''
        result = self._values.get("equal")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionEqual"], result)

    @builtins.property
    def greater_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionGreaterThan"]:
        '''greater_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        '''
        result = self._values.get("greater_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionGreaterThan"], result)

    @builtins.property
    def less_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionLessThan"]:
        '''less_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        '''
        result = self._values.get("less_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionLessThan"], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfDimension(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__988cb483193ce05e0f84b45f6c70ab388e796b9d7cadebdb5bfc0e03e77e2b1d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac11c1589935bea29ae0ae54d16cf729d478c0bb24eda808650258b93e387406)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionEqual",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionEqual:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionEqual(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionEqualOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionEqualOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__16a8f5873abafab59d0c84e3f0b4702e4a8831c34333b32c0dac484908aaa58f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionEqual], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionEqual],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__91bcdbebce2721efdb9e35a185ee5c42a224148466e85bdf35830bb258b04a59)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionGreaterThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionGreaterThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionGreaterThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionGreaterThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionGreaterThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f01bd9db2470516404a28862f9cf7eeeae2d7db20158b2ccd2d435d69987e16)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionGreaterThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionGreaterThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__adfbb665a5d712065f247491198056ffda2fdc2c1d5e1dbfd20027ef8342fdc4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionLessThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionLessThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionLessThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionLessThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionLessThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3936cbf5af65928d7f915290cd52f43b3099897cb61376a330f4d9d9cff7a471)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionLessThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionLessThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ccb57b94b2170fbd9647974a6e9c47359dfc9347af473de0b5409d9ee10b89f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c694d88a63a23335efcd854e0830a191c979387e6a8e3214024678713f1702b3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__49c8a5ba3622e90b70a6adec9a2d740cfa5ba74939452b69177ebb754f89410a)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__74afe7a4fe06a3f8bc06adc76bdc9a14ac21cddc9ec3c250b62ebddd6bacb29c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ccca83acf00880fe529731dc211e97ecfc0b4bb02bdd6ec4ce7af9473f8692d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f4b561471ab3189998b10b0f0eec0e904f5a6f64e13ce2fde76a8e026beaefe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfDimension]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfDimension]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__84e4e35a039018a2000465b95c54800e07d43945eedfcf39076a677516e50591)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8978f07dbbcdd30b7471bab96b8145fc1820cc537bc036fa44a12708d5a3d91d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putEqual")
    def put_equal(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionEqual()

        return typing.cast(None, jsii.invoke(self, "putEqual", [value]))

    @jsii.member(jsii_name="putGreaterThan")
    def put_greater_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionGreaterThan()

        return typing.cast(None, jsii.invoke(self, "putGreaterThan", [value]))

    @jsii.member(jsii_name="putLessThan")
    def put_less_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionLessThan()

        return typing.cast(None, jsii.invoke(self, "putLessThan", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetDimension")
    def reset_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimension", []))

    @jsii.member(jsii_name="resetDimensionVar")
    def reset_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimensionVar", []))

    @jsii.member(jsii_name="resetEqual")
    def reset_equal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEqual", []))

    @jsii.member(jsii_name="resetGreaterThan")
    def reset_greater_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGreaterThan", []))

    @jsii.member(jsii_name="resetLessThan")
    def reset_less_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLessThan", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="equal")
    def equal(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionEqualOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionEqualOutputReference, jsii.get(self, "equal"))

    @builtins.property
    @jsii.member(jsii_name="greaterThan")
    def greater_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionGreaterThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionGreaterThanOutputReference, jsii.get(self, "greaterThan"))

    @builtins.property
    @jsii.member(jsii_name="lessThan")
    def less_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionLessThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionLessThanOutputReference, jsii.get(self, "lessThan"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionInput")
    def dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionVarInput")
    def dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="equalInput")
    def equal_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionEqual], jsii.get(self, "equalInput"))

    @builtins.property
    @jsii.member(jsii_name="greaterThanInput")
    def greater_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionGreaterThan], jsii.get(self, "greaterThanInput"))

    @builtins.property
    @jsii.member(jsii_name="lessThanInput")
    def less_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionLessThan], jsii.get(self, "lessThanInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="dimension")
    def dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimension"))

    @dimension.setter
    def dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4365f45a2b3e3b5ffe10d9791837baf6f89eb85635beb2ba7db36723ebf27e3c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimension", value)

    @builtins.property
    @jsii.member(jsii_name="dimensionVar")
    def dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimensionVar"))

    @dimension_var.setter
    def dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__abe9378ace4ea4f2e39ba7b9ea4f39766c6f8b005ff9fc7eb1890d2be42c9f2e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb32089aa538710c8a912bf978cdf43ee2d8b52a41445bf0d8472c5ee290c744)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__890c6ada3e680a6bce9761d8f7d2d7fa70167669a4502a937f55b446dd235936)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfDimension]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfDimension]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfDimension]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__901f951293558f6aa76ad485ae0b4df6e047c581d9bbe097a861a90a079fadae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientation",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "landscape": "landscape",
        "portrait": "portrait",
        "square": "square",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientation:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        landscape: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationLandscape", typing.Dict[builtins.str, typing.Any]]] = None,
        portrait: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationPortrait", typing.Dict[builtins.str, typing.Any]]] = None,
        square: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationSquare", typing.Dict[builtins.str, typing.Any]]] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param landscape: landscape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        :param portrait: portrait block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        :param square: square block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationDefault(**default)
        if isinstance(landscape, dict):
            landscape = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationLandscape(**landscape)
        if isinstance(portrait, dict):
            portrait = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationPortrait(**portrait)
        if isinstance(square, dict):
            square = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationSquare(**square)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4beed0c3f11290096b6b97c14d4091bf93450b72f0f4d2a5566007521868e818)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument landscape", value=landscape, expected_type=type_hints["landscape"])
            check_type(argname="argument portrait", value=portrait, expected_type=type_hints["portrait"])
            check_type(argname="argument square", value=square, expected_type=type_hints["square"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if landscape is not None:
            self._values["landscape"] = landscape
        if portrait is not None:
            self._values["portrait"] = portrait
        if square is not None:
            self._values["square"] = square

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationDefault"], result)

    @builtins.property
    def landscape(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationLandscape"]:
        '''landscape block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        '''
        result = self._values.get("landscape")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationLandscape"], result)

    @builtins.property
    def portrait(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationPortrait"]:
        '''portrait block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        '''
        result = self._values.get("portrait")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationPortrait"], result)

    @builtins.property
    def square(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationSquare"]:
        '''square block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        result = self._values.get("square")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationSquare"], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a06cde229ef0236e37ca29e0244e545304d3dec887ee594bd6b2e7b20192d793)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__faee977e2fcda3c3870320e734c2328bddb07bc189f11e4173d915bb66ed465d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationLandscape",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationLandscape:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationLandscape(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationLandscapeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationLandscapeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c82d46bf2b536603ba90b1f091996ef1331ce3680880af06087b9a06fb839d65)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationLandscape], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationLandscape],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__65a82b6bab514a5a50fc4df85c3df416fd6f3495f672f17cf74261e4dcb23e2b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b92e4154e4b0ff554a57f384dbe61cd75b43f38a4c2cdb4a897d4592c4c4f4a9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a20e86aad3857e568c0bf48cf850a2d79b54b531b597d036c7e92c9b6be6bc4)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__946f3c12573a854618580f38a2642fda7acae00aa1e997076201512729b97721)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6a433170325ed5f27111bd5a10f7e62a75e7b7afee727347328d143db01ca686)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c99654e0bfb2ce882e25be8c7cde49b9a6186977dd4f56c63f4bdfeec1d1e3f4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientation]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientation]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__43b2a0d96fdf0bb688a7a376429e968a6ad461999de5eeeb0f20b611572c8e0d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0cc2442a4bce5427bcb67ad79a0134814bee0edfa9fcd94fbdb1d6b7c113c23b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putLandscape")
    def put_landscape(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationLandscape()

        return typing.cast(None, jsii.invoke(self, "putLandscape", [value]))

    @jsii.member(jsii_name="putPortrait")
    def put_portrait(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationPortrait()

        return typing.cast(None, jsii.invoke(self, "putPortrait", [value]))

    @jsii.member(jsii_name="putSquare")
    def put_square(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationSquare()

        return typing.cast(None, jsii.invoke(self, "putSquare", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetLandscape")
    def reset_landscape(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLandscape", []))

    @jsii.member(jsii_name="resetPortrait")
    def reset_portrait(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPortrait", []))

    @jsii.member(jsii_name="resetSquare")
    def reset_square(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSquare", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="landscape")
    def landscape(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationLandscapeOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationLandscapeOutputReference, jsii.get(self, "landscape"))

    @builtins.property
    @jsii.member(jsii_name="portrait")
    def portrait(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationPortraitOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationPortraitOutputReference", jsii.get(self, "portrait"))

    @builtins.property
    @jsii.member(jsii_name="square")
    def square(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationSquareOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationSquareOutputReference", jsii.get(self, "square"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="landscapeInput")
    def landscape_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationLandscape], jsii.get(self, "landscapeInput"))

    @builtins.property
    @jsii.member(jsii_name="portraitInput")
    def portrait_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationPortrait"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationPortrait"], jsii.get(self, "portraitInput"))

    @builtins.property
    @jsii.member(jsii_name="squareInput")
    def square_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationSquare"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationSquare"], jsii.get(self, "squareInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientation]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientation]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientation]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__69ac11b19130bce63e4c05a0d1de0b30c35ad3dbac40bc88a429eed2f026acca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationPortrait",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationPortrait:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationPortrait(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationPortraitOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationPortraitOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__510310ec9a33ddcb9b5d51b7afa30d470d2771d84096eca19a534ef3cbfeba04)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationPortrait]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationPortrait], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationPortrait],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__326618bd8a11f35d0d7d58bd3f90a0cfe59a1c28dc387113c4e47ca21cbcb256)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationSquare",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationSquare:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationSquare(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationSquareOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationSquareOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__34e76789b80dabcedf2ba61240077117f8f40b331e4daad78ffcd863cbae3373)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationSquare]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationSquare], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationSquare],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0cc9bd483114db84f517592c7826cafe717159886008f8afb3ebe2c140fcf6ed)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeImQuery",
    jsii_struct_bases=[],
    name_mapping={
        "allowed_transformations": "allowedTransformations",
        "query_var": "queryVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeImQuery:
    def __init__(
        self,
        *,
        allowed_transformations: typing.Sequence[builtins.str],
        query_var: builtins.str,
    ) -> None:
        '''
        :param allowed_transformations: Specifies the transformations that can be applied using the query string parameter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allowed_transformations DataAkamaiImagingPolicyImage#allowed_transformations}
        :param query_var: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#query_var DataAkamaiImagingPolicyImage#query_var}.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fe6e6d6deb9b59bf94fbcd4d3dafea2e3af546647491fd07c15d2fcd79ce6e79)
            check_type(argname="argument allowed_transformations", value=allowed_transformations, expected_type=type_hints["allowed_transformations"])
            check_type(argname="argument query_var", value=query_var, expected_type=type_hints["query_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "allowed_transformations": allowed_transformations,
            "query_var": query_var,
        }

    @builtins.property
    def allowed_transformations(self) -> typing.List[builtins.str]:
        '''Specifies the transformations that can be applied using the query string parameter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allowed_transformations DataAkamaiImagingPolicyImage#allowed_transformations}
        '''
        result = self._values.get("allowed_transformations")
        assert result is not None, "Required property 'allowed_transformations' is missing"
        return typing.cast(typing.List[builtins.str], result)

    @builtins.property
    def query_var(self) -> builtins.str:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#query_var DataAkamaiImagingPolicyImage#query_var}.'''
        result = self._values.get("query_var")
        assert result is not None, "Required property 'query_var' is missing"
        return typing.cast(builtins.str, result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeImQuery(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeImQueryList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeImQueryList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__011003cb8e319ed694d86ec1e8123c434e03278657b8ca3ab23b06fab40ff60f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeImQueryOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dd776dadf54cb4336ba49a14fa99c88b2f616089ecdb91555d96aaf9050f9a42)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeImQueryOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5582dbd39477cc921bc03fc0920daa05299e5c6524d82b374ea7276d65892240)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a83c045ef01fe5139545ebc3746107f11b3d7600f8c02a599e8439a00b2963ab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0c5ccdfc2c36afa900a903e7d8b121eddff672042ba68d9347a4b229cae57dc3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeImQuery]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeImQuery]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeImQuery]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__26cbc8bd4324bd4bec2e9406a49d84c6b02cba401bdc3d7a3db3d60b6697f543)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeImQueryOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeImQueryOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d2b688b5b25dd29b2640c06262a5251d5488f3267874c74072567239808c747c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @builtins.property
    @jsii.member(jsii_name="allowedTransformationsInput")
    def allowed_transformations_input(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "allowedTransformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="queryVarInput")
    def query_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "queryVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowedTransformations")
    def allowed_transformations(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "allowedTransformations"))

    @allowed_transformations.setter
    def allowed_transformations(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c944725f25b8d20f6b4c70ab4a8b5e92292e89a580c6bcfdff8f55cfe2a381e4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowedTransformations", value)

    @builtins.property
    @jsii.member(jsii_name="queryVar")
    def query_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "queryVar"))

    @query_var.setter
    def query_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__75a843eb6f5ddd12bc91edf519b95438f4fd73452f7a6b1b59ef25965f020b4e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "queryVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeImQuery]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeImQuery]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeImQuery]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dc96c0c5b7c67f0723a8854563b736e600437f8e3129441aef06fde85d5b77c8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeMaxColors",
    jsii_struct_bases=[],
    name_mapping={"colors": "colors", "colors_var": "colorsVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeMaxColors:
    def __init__(
        self,
        *,
        colors: typing.Optional[builtins.str] = None,
        colors_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param colors: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        :param colors_var: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0225cb390652951b8f02925e0529ea3b6579bf5779caf927d7c1cf7c29f84d64)
            check_type(argname="argument colors", value=colors, expected_type=type_hints["colors"])
            check_type(argname="argument colors_var", value=colors_var, expected_type=type_hints["colors_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if colors is not None:
            self._values["colors"] = colors
        if colors_var is not None:
            self._values["colors_var"] = colors_var

    @builtins.property
    def colors(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        '''
        result = self._values.get("colors")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def colors_var(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        result = self._values.get("colors_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeMaxColors(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeMaxColorsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeMaxColorsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1a6c2d11ab0870ec1d93e2ac566b68990d6257e22ef25d54b7c5f728d16f2883)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeMaxColorsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ef40de9f1cea558b311fad66948c2bff034d141be35115281e1d260c5f9401de)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeMaxColorsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a03be71ed70a39c742d6d7993b2ff69221a81b757697c2daedbb7649ccd6a5d6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__91a9f2b05e704b2001bb6afdba57c507c10866a8b8cd9163a27cddc43f4d17c5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e015ed56b564daf49c805f5ba86cad88087cce804184f370de9c5937ccf65431)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeMaxColors]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeMaxColors]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__304530f6bf4b0d494dfd4bc5a5d067377d4344a658e657aadb18ecaa6e77fe9c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeMaxColorsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeMaxColorsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ccf910d649be5b045d2797081adc1a70ba44e4c2ad886543821c4d25fdcfb4d7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColors")
    def reset_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColors", []))

    @jsii.member(jsii_name="resetColorsVar")
    def reset_colors_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorsVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorsInput")
    def colors_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsInput"))

    @builtins.property
    @jsii.member(jsii_name="colorsVarInput")
    def colors_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsVarInput"))

    @builtins.property
    @jsii.member(jsii_name="colors")
    def colors(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colors"))

    @colors.setter
    def colors(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a7c03270b6bc388e6e6bc6cfe774fc1923bcb63eb5ed1c960d51f37058ff81f5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colors", value)

    @builtins.property
    @jsii.member(jsii_name="colorsVar")
    def colors_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorsVar"))

    @colors_var.setter
    def colors_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8acbda0695d1b9ed7e00cc90867f747000a1a7c0462f60f0a2f73aba5204f884)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorsVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeMaxColors]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeMaxColors]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeMaxColors]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be6b3b518db65d6d231547f3d57cf506c9bb52986d5bf95a6659b715794c1597)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeMirror",
    jsii_struct_bases=[],
    name_mapping={
        "horizontal": "horizontal",
        "horizontal_var": "horizontalVar",
        "vertical": "vertical",
        "vertical_var": "verticalVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeMirror:
    def __init__(
        self,
        *,
        horizontal: typing.Optional[builtins.str] = None,
        horizontal_var: typing.Optional[builtins.str] = None,
        vertical: typing.Optional[builtins.str] = None,
        vertical_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param horizontal: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        :param horizontal_var: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        :param vertical: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        :param vertical_var: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8461777a6506495055fd9d7ec4bd7f50fd34a538aa8041b7c8f89592579dc00a)
            check_type(argname="argument horizontal", value=horizontal, expected_type=type_hints["horizontal"])
            check_type(argname="argument horizontal_var", value=horizontal_var, expected_type=type_hints["horizontal_var"])
            check_type(argname="argument vertical", value=vertical, expected_type=type_hints["vertical"])
            check_type(argname="argument vertical_var", value=vertical_var, expected_type=type_hints["vertical_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if horizontal is not None:
            self._values["horizontal"] = horizontal
        if horizontal_var is not None:
            self._values["horizontal_var"] = horizontal_var
        if vertical is not None:
            self._values["vertical"] = vertical
        if vertical_var is not None:
            self._values["vertical_var"] = vertical_var

    @builtins.property
    def horizontal(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        '''
        result = self._values.get("horizontal")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def horizontal_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        '''
        result = self._values.get("horizontal_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        '''
        result = self._values.get("vertical")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        result = self._values.get("vertical_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeMirror(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeMirrorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeMirrorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3b56e0e99063a5192596801a51456070953109d00037207c50cce1ad4ae40882)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeMirrorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__834b25110d507f879d992338c0a25a80f668e0d955747f665b1689e66b82747a)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeMirrorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dbb3cb3baccbef2cf64b385e0bbc782b729c10a5d0c84f2c75f2b30e1563c193)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0c2627d34fa1bc4472014e3a129817344e22ca36e47a7049eeac483b4f9f8162)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__52b7184c7bbda56c6816dde7ac4a2654252e11631ccb2a2941b368823c0b5309)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeMirror]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeMirror]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d505b5743667826d467d1f03c3fae075613e9319e89e5265ece3eeabb2e5b94)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeMirrorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeMirrorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ddb5847f7374ff2c394f16d1842e1eb63a31ab2a2aa0761fb077c30bbe251815)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHorizontal")
    def reset_horizontal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontal", []))

    @jsii.member(jsii_name="resetHorizontalVar")
    def reset_horizontal_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontalVar", []))

    @jsii.member(jsii_name="resetVertical")
    def reset_vertical(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVertical", []))

    @jsii.member(jsii_name="resetVerticalVar")
    def reset_vertical_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVerticalVar", []))

    @builtins.property
    @jsii.member(jsii_name="horizontalInput")
    def horizontal_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontalVarInput")
    def horizontal_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalInput")
    def vertical_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalVarInput")
    def vertical_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontal")
    def horizontal(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontal"))

    @horizontal.setter
    def horizontal(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f5f05da4084cb028ce7dc2da5964811c7ca96640bf7a17381081820463965914)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontal", value)

    @builtins.property
    @jsii.member(jsii_name="horizontalVar")
    def horizontal_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontalVar"))

    @horizontal_var.setter
    def horizontal_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__097e9127123029369076d1e4b6c83aafe23bdc1e4eeb312f23f8c200268d726c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontalVar", value)

    @builtins.property
    @jsii.member(jsii_name="vertical")
    def vertical(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "vertical"))

    @vertical.setter
    def vertical(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e3b7d1d41f5b6900da74b9d5a4bde9ece788db4ffd550789ea0f2919f6691133)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "vertical", value)

    @builtins.property
    @jsii.member(jsii_name="verticalVar")
    def vertical_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "verticalVar"))

    @vertical_var.setter
    def vertical_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0b0a7c344552204fd5fd3fb374a08094fedb27f66191266a2d2cd88c35c93a44)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "verticalVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeMirror]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeMirror]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeMirror]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1dd99817cbb0fc42b42ca198e5c66152af13b5e6a66dded5bf8569e65d4988b5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeMonoHue",
    jsii_struct_bases=[],
    name_mapping={"hue": "hue", "hue_var": "hueVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeMonoHue:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ba1afad3d6fb06e44bac21c47005bae5c957c1074bbd894851a38dbd64e7e0a3)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeMonoHue(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeMonoHueList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeMonoHueList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fc92fcedea2a2c3d8f269564d04d111ac9bdd7161fc2278f56f1f61941144ef0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeMonoHueOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__61958491d300cb655b79c227110acd3fb8b46dd86b856adb3ccd86ee72759ec9)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeMonoHueOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__326937832b43fb64f6346cb4fca2e232955c0f0c71ab609a3312afe658be3dda)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1ed70b6efec4b3e97a6dd89f4fd6a5804e24b5e06ddf4a74cc2026dcbc92c8b3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__19949c3241a489d7ecf1c6e463144e7511b33e1fc5002302c38da86c74874759)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeMonoHue]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeMonoHue]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__541cfa8a03a57ea0bdc787fa98ab365a0a6bbeab41cb6b8fb7e29388f782743c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeMonoHueOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeMonoHueOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__843c504c75b2e8cab0467fe7d03f0b0674b0b84e3e6acc1ee0ef2047a8a1e26d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__972c4a6cc75a3f730e92fed79f1189de8d43fd25e0d07eee9dd2428207e61d3b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__feb2a51bf58827c2d737eacd98a075fdf9616eb6c5c01fd48c25579958f09894)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeMonoHue]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeMonoHue]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeMonoHue]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9bcd14cc75fdf432a75c6cccae166b117025f73dff24158e954e912531b07476)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeOpacity",
    jsii_struct_bases=[],
    name_mapping={"opacity": "opacity", "opacity_var": "opacityVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeOpacity:
    def __init__(
        self,
        *,
        opacity: typing.Optional[builtins.str] = None,
        opacity_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param opacity: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param opacity_var: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bdc32247dfe16965d99b85961aedf4c9db7f64dcb2410a7162840ce1d5affe43)
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument opacity_var", value=opacity_var, expected_type=type_hints["opacity_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if opacity is not None:
            self._values["opacity"] = opacity
        if opacity_var is not None:
            self._values["opacity_var"] = opacity_var

    @builtins.property
    def opacity(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def opacity_var(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        result = self._values.get("opacity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeOpacity(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeOpacityList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeOpacityList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__259fde2cc4198959baae5ae9749bb2bc35d8719decb08d8dd7f8812f543b4cd9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeOpacityOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4187e63f4933c94e33991d0899af6654313329a15d0f405c5fe741d2e9e9e14e)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeOpacityOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e0a45a0d1212668487a4eefee26ac00479be426db139bf66a984d836be59ecac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__27714830119ffee1ec5560678edd0e9ccd8182d84aaa0d998cf96fb7a8a5eaa4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c03542f19e792455e2c3f7247f0fa2943c4fdf10d7f1614763eed6342d19ca81)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeOpacity]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeOpacity]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__48fd7d8811b9656e92e5b2a4a1da189c65a8b76f672b870bf753ed4d743a72b4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeOpacityOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeOpacityOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__566ea3567c5f7ab449811a5be3e82f19167bd980ffdeca7aa3f73a34e91a5ea4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetOpacityVar")
    def reset_opacity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacityVar", []))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityVarInput")
    def opacity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacity"))

    @opacity.setter
    def opacity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__32ca2acffeb45cb7ec3a0d8ecd2591347b413e0c01845614b74034acf5d58db1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacity", value)

    @builtins.property
    @jsii.member(jsii_name="opacityVar")
    def opacity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacityVar"))

    @opacity_var.setter
    def opacity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fc193c7eb71fe1bbcd358f9d4e1953d1aed55a366a671687165f5f10d41e938f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacityVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeOpacity]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeOpacity]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeOpacity]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a7af86880adaf738c99f550ce2aa6b697f719e2f6a42f318ffa211277e79d4c3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7f1c9677cce70352c3040ee997620a49ad04166cf9cabf412d3e41b87f6516b4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putAppend")
    def put_append(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeAppend, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5a728d669b9fda1baf398f8e4e4d9bbb9e7e4cc2d2ed4ba8fc0dc19eca8a343c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putAppend", [value]))

    @jsii.member(jsii_name="putAspectCrop")
    def put_aspect_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeAspectCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a52164af69ae3965b5510038dd59737ca4645845d889c4484b9a3efced051db)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putAspectCrop", [value]))

    @jsii.member(jsii_name="putBackgroundColor")
    def put_background_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7df4573d316264c61487a747562fce1f9f8b1a11872aaa4a3ca6a3295116cd0a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBackgroundColor", [value]))

    @jsii.member(jsii_name="putBlur")
    def put_blur(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeBlur, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__987093c4f4028bbd9b2585ffee2219abd73275d1746162778bd7c87279c26359)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBlur", [value]))

    @jsii.member(jsii_name="putChromaKey")
    def put_chroma_key(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeChromaKey, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a4fdfff1c3495ce831dfdf16511675df9b52e871eeeff21466f7e82cc242074)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putChromaKey", [value]))

    @jsii.member(jsii_name="putComposite")
    def put_composite(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeComposite, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9124d1a05ea6c9b837e6399d7e7e78e92e26c7dc655b8c148184d2aefc551511)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putComposite", [value]))

    @jsii.member(jsii_name="putCompound")
    def put_compound(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeCompound, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f481ef257fc28c757c8944274bef6262488dcd4a6d87e1b7d3cd5664d8543c9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCompound", [value]))

    @jsii.member(jsii_name="putContrast")
    def put_contrast(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeContrast, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6fc1098ce6926da86129866cbc1e7befb22e98937b19af1812143d38b583753a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putContrast", [value]))

    @jsii.member(jsii_name="putCrop")
    def put_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dc2a1f9ed99849053abddbee7b34dd49c80ad198c8e8da67e29d7bab9847a92f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCrop", [value]))

    @jsii.member(jsii_name="putFaceCrop")
    def put_face_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeFaceCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b7c789477b324a73fd69be013f6e42db751225a7feeafa5df06adb72e38cdc99)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFaceCrop", [value]))

    @jsii.member(jsii_name="putFeatureCrop")
    def put_feature_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeFeatureCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__32cd660ec632cd5f5a6a47235a673e10e03948c0973ff3158ed05ce2eb56f5e3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFeatureCrop", [value]))

    @jsii.member(jsii_name="putFitAndFill")
    def put_fit_and_fill(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeFitAndFill, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e8155c4c958119097560aa5ff4942388642aa4bfd91730deb6b077f7420a247b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFitAndFill", [value]))

    @jsii.member(jsii_name="putGoop")
    def put_goop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeGoop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4495e1c70b4100b1cd2b3593d9cf0909d752620baf96f0e5e54f17031dbe4c80)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGoop", [value]))

    @jsii.member(jsii_name="putGrayscale")
    def put_grayscale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeGrayscale, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d35752dcc5b83eaf5eb61705970772424469053e3995bdef5262e69e72e8efa4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGrayscale", [value]))

    @jsii.member(jsii_name="putHsl")
    def put_hsl(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeHsl, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7f563c44237532304b3be3f9691601b97f88693b067537ba45985ec6dbb32644)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsl", [value]))

    @jsii.member(jsii_name="putHsv")
    def put_hsv(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeHsv, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6c7450ea73ddad20612d96313984fb913af1d0f8018da6239b449d85d307f27e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsv", [value]))

    @jsii.member(jsii_name="putIfDimension")
    def put_if_dimension(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfDimension, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5474c4a787ad070a8b2d302eee7381ee748be898646662abc36b76bb6c1f0838)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfDimension", [value]))

    @jsii.member(jsii_name="putIfOrientation")
    def put_if_orientation(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d831e427426c4e6ec0c363e8c26efc1d2fb6695ccdda1e2f09752ca8742d980)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfOrientation", [value]))

    @jsii.member(jsii_name="putImQuery")
    def put_im_query(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeImQuery, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c15a82b8f2d5caa44c9ec7c6683075d171ac9a213925985113bbdb1bbcd33604)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putImQuery", [value]))

    @jsii.member(jsii_name="putMaxColors")
    def put_max_colors(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeMaxColors, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ed2e0e3dfb497373df11ad918a3d68f056fed3d3b5905fc4723326a55d6e77bd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMaxColors", [value]))

    @jsii.member(jsii_name="putMirror")
    def put_mirror(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeMirror, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f191173c50dc54e9c8f734833d16a59a1457468764b98c2f8c82f4c99e5b7863)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMirror", [value]))

    @jsii.member(jsii_name="putMonoHue")
    def put_mono_hue(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeMonoHue, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e6df945124382ab893d0bb937d021ff98fe54a992b4053fe20862e09d7557493)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMonoHue", [value]))

    @jsii.member(jsii_name="putOpacity")
    def put_opacity(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeOpacity, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d9e845f55dff1d565d79884a955fbc45ed0fddd9d1c93de2adef550cc7627ab5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putOpacity", [value]))

    @jsii.member(jsii_name="putRegionOfInterestCrop")
    def put_region_of_interest_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeRegionOfInterestCrop", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bdb7f53d7719efceed0824d93a41434321236a2e2281b7f3309d1bd374ef1a73)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRegionOfInterestCrop", [value]))

    @jsii.member(jsii_name="putRelativeCrop")
    def put_relative_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeRelativeCrop", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8fdf033608d7c79d72250e592ce195e1d6712c7ee208628f2fbbc194ef2d6dae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRelativeCrop", [value]))

    @jsii.member(jsii_name="putRemoveColor")
    def put_remove_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeRemoveColor", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bca2e868758c46645f8a34fa578cc76035d0032106ed54c33cf7b8f35463ae48)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRemoveColor", [value]))

    @jsii.member(jsii_name="putResize")
    def put_resize(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeResize", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__909fbe3b51c90d6463c205f2bac1ec7753478ee3159aebd221eb3f71a3fc1680)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putResize", [value]))

    @jsii.member(jsii_name="putRotate")
    def put_rotate(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeRotate", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__32807de8dd154058b0907dcfc545beec1a4dd02bb8dd97cbcd7f912d0f64bfda)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRotate", [value]))

    @jsii.member(jsii_name="putScale")
    def put_scale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeScale", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__139b178d9f1079f6a4edce857b18f795ed7465d9a98a2a99ca3dbe0ae4a7d1a2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putScale", [value]))

    @jsii.member(jsii_name="putShear")
    def put_shear(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeShear", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8c34e1fc11aacd4067c6fd520f601fe75aff1f68f2a9b0f0d4302c6bcb70fff5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putShear", [value]))

    @jsii.member(jsii_name="putTrim")
    def put_trim(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeTrim", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4be43d8fca5e1318b6b3ead167150bb153d0e6aa6a71d2d7b4056c10b2bde568)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTrim", [value]))

    @jsii.member(jsii_name="putUnsharpMask")
    def put_unsharp_mask(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeUnsharpMask", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__17fc26561b2008bccf5517152e55202ab23ee0c62aa7c0fe23911e88186df6d4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putUnsharpMask", [value]))

    @jsii.member(jsii_name="resetAppend")
    def reset_append(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAppend", []))

    @jsii.member(jsii_name="resetAspectCrop")
    def reset_aspect_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspectCrop", []))

    @jsii.member(jsii_name="resetBackgroundColor")
    def reset_background_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBackgroundColor", []))

    @jsii.member(jsii_name="resetBlur")
    def reset_blur(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBlur", []))

    @jsii.member(jsii_name="resetChromaKey")
    def reset_chroma_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChromaKey", []))

    @jsii.member(jsii_name="resetComposite")
    def reset_composite(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetComposite", []))

    @jsii.member(jsii_name="resetCompound")
    def reset_compound(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCompound", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetCrop")
    def reset_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCrop", []))

    @jsii.member(jsii_name="resetFaceCrop")
    def reset_face_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFaceCrop", []))

    @jsii.member(jsii_name="resetFeatureCrop")
    def reset_feature_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureCrop", []))

    @jsii.member(jsii_name="resetFitAndFill")
    def reset_fit_and_fill(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFitAndFill", []))

    @jsii.member(jsii_name="resetGoop")
    def reset_goop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGoop", []))

    @jsii.member(jsii_name="resetGrayscale")
    def reset_grayscale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGrayscale", []))

    @jsii.member(jsii_name="resetHsl")
    def reset_hsl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsl", []))

    @jsii.member(jsii_name="resetHsv")
    def reset_hsv(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsv", []))

    @jsii.member(jsii_name="resetIfDimension")
    def reset_if_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfDimension", []))

    @jsii.member(jsii_name="resetIfOrientation")
    def reset_if_orientation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfOrientation", []))

    @jsii.member(jsii_name="resetImQuery")
    def reset_im_query(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetImQuery", []))

    @jsii.member(jsii_name="resetMaxColors")
    def reset_max_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxColors", []))

    @jsii.member(jsii_name="resetMirror")
    def reset_mirror(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMirror", []))

    @jsii.member(jsii_name="resetMonoHue")
    def reset_mono_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonoHue", []))

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetRegionOfInterestCrop")
    def reset_region_of_interest_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRegionOfInterestCrop", []))

    @jsii.member(jsii_name="resetRelativeCrop")
    def reset_relative_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRelativeCrop", []))

    @jsii.member(jsii_name="resetRemoveColor")
    def reset_remove_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRemoveColor", []))

    @jsii.member(jsii_name="resetResize")
    def reset_resize(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetResize", []))

    @jsii.member(jsii_name="resetRotate")
    def reset_rotate(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRotate", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetShear")
    def reset_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetShear", []))

    @jsii.member(jsii_name="resetTrim")
    def reset_trim(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTrim", []))

    @jsii.member(jsii_name="resetUnsharpMask")
    def reset_unsharp_mask(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUnsharpMask", []))

    @builtins.property
    @jsii.member(jsii_name="append")
    def append(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeAppendList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeAppendList, jsii.get(self, "append"))

    @builtins.property
    @jsii.member(jsii_name="aspectCrop")
    def aspect_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeAspectCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeAspectCropList, jsii.get(self, "aspectCrop"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColor")
    def background_color(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeBackgroundColorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeBackgroundColorList, jsii.get(self, "backgroundColor"))

    @builtins.property
    @jsii.member(jsii_name="blur")
    def blur(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeBlurList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeBlurList, jsii.get(self, "blur"))

    @builtins.property
    @jsii.member(jsii_name="chromaKey")
    def chroma_key(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeChromaKeyList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeChromaKeyList, jsii.get(self, "chromaKey"))

    @builtins.property
    @jsii.member(jsii_name="composite")
    def composite(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeCompositeList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeCompositeList, jsii.get(self, "composite"))

    @builtins.property
    @jsii.member(jsii_name="compound")
    def compound(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeCompoundList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeCompoundList, jsii.get(self, "compound"))

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeContrastList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeContrastList, jsii.get(self, "contrast"))

    @builtins.property
    @jsii.member(jsii_name="crop")
    def crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeCropList, jsii.get(self, "crop"))

    @builtins.property
    @jsii.member(jsii_name="faceCrop")
    def face_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeFaceCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeFaceCropList, jsii.get(self, "faceCrop"))

    @builtins.property
    @jsii.member(jsii_name="featureCrop")
    def feature_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeFeatureCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeFeatureCropList, jsii.get(self, "featureCrop"))

    @builtins.property
    @jsii.member(jsii_name="fitAndFill")
    def fit_and_fill(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeFitAndFillList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeFitAndFillList, jsii.get(self, "fitAndFill"))

    @builtins.property
    @jsii.member(jsii_name="goop")
    def goop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeGoopList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeGoopList, jsii.get(self, "goop"))

    @builtins.property
    @jsii.member(jsii_name="grayscale")
    def grayscale(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeGrayscaleList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeGrayscaleList, jsii.get(self, "grayscale"))

    @builtins.property
    @jsii.member(jsii_name="hsl")
    def hsl(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeHslList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeHslList, jsii.get(self, "hsl"))

    @builtins.property
    @jsii.member(jsii_name="hsv")
    def hsv(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeHsvList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeHsvList, jsii.get(self, "hsv"))

    @builtins.property
    @jsii.member(jsii_name="ifDimension")
    def if_dimension(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionList, jsii.get(self, "ifDimension"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientation")
    def if_orientation(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationList, jsii.get(self, "ifOrientation"))

    @builtins.property
    @jsii.member(jsii_name="imQuery")
    def im_query(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeImQueryList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeImQueryList, jsii.get(self, "imQuery"))

    @builtins.property
    @jsii.member(jsii_name="maxColors")
    def max_colors(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeMaxColorsList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeMaxColorsList, jsii.get(self, "maxColors"))

    @builtins.property
    @jsii.member(jsii_name="mirror")
    def mirror(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeMirrorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeMirrorList, jsii.get(self, "mirror"))

    @builtins.property
    @jsii.member(jsii_name="monoHue")
    def mono_hue(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeMonoHueList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeMonoHueList, jsii.get(self, "monoHue"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeOpacityList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeOpacityList, jsii.get(self, "opacity"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestCrop")
    def region_of_interest_crop(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeRegionOfInterestCropList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeRegionOfInterestCropList", jsii.get(self, "regionOfInterestCrop"))

    @builtins.property
    @jsii.member(jsii_name="relativeCrop")
    def relative_crop(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeRelativeCropList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeRelativeCropList", jsii.get(self, "relativeCrop"))

    @builtins.property
    @jsii.member(jsii_name="removeColor")
    def remove_color(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeRemoveColorList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeRemoveColorList", jsii.get(self, "removeColor"))

    @builtins.property
    @jsii.member(jsii_name="resize")
    def resize(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeResizeList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeResizeList", jsii.get(self, "resize"))

    @builtins.property
    @jsii.member(jsii_name="rotate")
    def rotate(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeRotateList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeRotateList", jsii.get(self, "rotate"))

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeScaleList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeScaleList", jsii.get(self, "scale"))

    @builtins.property
    @jsii.member(jsii_name="shear")
    def shear(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeShearList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeShearList", jsii.get(self, "shear"))

    @builtins.property
    @jsii.member(jsii_name="trim")
    def trim(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeTrimList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeTrimList", jsii.get(self, "trim"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMask")
    def unsharp_mask(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeUnsharpMaskList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeUnsharpMaskList", jsii.get(self, "unsharpMask"))

    @builtins.property
    @jsii.member(jsii_name="appendInput")
    def append_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeAppend]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeAppend]]], jsii.get(self, "appendInput"))

    @builtins.property
    @jsii.member(jsii_name="aspectCropInput")
    def aspect_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeAspectCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeAspectCrop]]], jsii.get(self, "aspectCropInput"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColorInput")
    def background_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeBackgroundColor]]], jsii.get(self, "backgroundColorInput"))

    @builtins.property
    @jsii.member(jsii_name="blurInput")
    def blur_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeBlur]]], jsii.get(self, "blurInput"))

    @builtins.property
    @jsii.member(jsii_name="chromaKeyInput")
    def chroma_key_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeChromaKey]]], jsii.get(self, "chromaKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="compositeInput")
    def composite_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeComposite]]], jsii.get(self, "compositeInput"))

    @builtins.property
    @jsii.member(jsii_name="compoundInput")
    def compound_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeCompound]]], jsii.get(self, "compoundInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeContrast]]], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="cropInput")
    def crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeCrop]]], jsii.get(self, "cropInput"))

    @builtins.property
    @jsii.member(jsii_name="faceCropInput")
    def face_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeFaceCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeFaceCrop]]], jsii.get(self, "faceCropInput"))

    @builtins.property
    @jsii.member(jsii_name="featureCropInput")
    def feature_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeFeatureCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeFeatureCrop]]], jsii.get(self, "featureCropInput"))

    @builtins.property
    @jsii.member(jsii_name="fitAndFillInput")
    def fit_and_fill_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeFitAndFill]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeFitAndFill]]], jsii.get(self, "fitAndFillInput"))

    @builtins.property
    @jsii.member(jsii_name="goopInput")
    def goop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeGoop]]], jsii.get(self, "goopInput"))

    @builtins.property
    @jsii.member(jsii_name="grayscaleInput")
    def grayscale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeGrayscale]]], jsii.get(self, "grayscaleInput"))

    @builtins.property
    @jsii.member(jsii_name="hslInput")
    def hsl_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeHsl]]], jsii.get(self, "hslInput"))

    @builtins.property
    @jsii.member(jsii_name="hsvInput")
    def hsv_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeHsv]]], jsii.get(self, "hsvInput"))

    @builtins.property
    @jsii.member(jsii_name="ifDimensionInput")
    def if_dimension_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfDimension]]], jsii.get(self, "ifDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientationInput")
    def if_orientation_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientation]]], jsii.get(self, "ifOrientationInput"))

    @builtins.property
    @jsii.member(jsii_name="imQueryInput")
    def im_query_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeImQuery]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeImQuery]]], jsii.get(self, "imQueryInput"))

    @builtins.property
    @jsii.member(jsii_name="maxColorsInput")
    def max_colors_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeMaxColors]]], jsii.get(self, "maxColorsInput"))

    @builtins.property
    @jsii.member(jsii_name="mirrorInput")
    def mirror_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeMirror]]], jsii.get(self, "mirrorInput"))

    @builtins.property
    @jsii.member(jsii_name="monoHueInput")
    def mono_hue_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeMonoHue]]], jsii.get(self, "monoHueInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeOpacity]]], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestCropInput")
    def region_of_interest_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeRegionOfInterestCrop"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeRegionOfInterestCrop"]]], jsii.get(self, "regionOfInterestCropInput"))

    @builtins.property
    @jsii.member(jsii_name="relativeCropInput")
    def relative_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeRelativeCrop"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeRelativeCrop"]]], jsii.get(self, "relativeCropInput"))

    @builtins.property
    @jsii.member(jsii_name="removeColorInput")
    def remove_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeRemoveColor"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeRemoveColor"]]], jsii.get(self, "removeColorInput"))

    @builtins.property
    @jsii.member(jsii_name="resizeInput")
    def resize_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeResize"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeResize"]]], jsii.get(self, "resizeInput"))

    @builtins.property
    @jsii.member(jsii_name="rotateInput")
    def rotate_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeRotate"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeRotate"]]], jsii.get(self, "rotateInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeScale"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeScale"]]], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="shearInput")
    def shear_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeShear"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeShear"]]], jsii.get(self, "shearInput"))

    @builtins.property
    @jsii.member(jsii_name="trimInput")
    def trim_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeTrim"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeTrim"]]], jsii.get(self, "trimInput"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMaskInput")
    def unsharp_mask_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeUnsharpMask"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeUnsharpMask"]]], jsii.get(self, "unsharpMaskInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscape], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscape],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__271324e929a668df7f467e1fbbbb3519e4c4def8c5b104bed39fbdbfae3633b4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeRegionOfInterestCrop",
    jsii_struct_bases=[],
    name_mapping={
        "region_of_interest": "regionOfInterest",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeRegionOfInterestCrop:
    def __init__(
        self,
        *,
        region_of_interest: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeRegionOfInterestCropRegionOfInterest", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param region_of_interest: region_of_interest block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest DataAkamaiImagingPolicyImage#region_of_interest}
        :param gravity: The placement of the crop area relative to the specified area of interest. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: The placement of the crop area relative to the specified area of interest. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param style: Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(region_of_interest, dict):
            region_of_interest = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeRegionOfInterestCropRegionOfInterest(**region_of_interest)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1b8e175842f1149d2f9505bd9b91925e245419854b41b64756618abc72e8f400)
            check_type(argname="argument region_of_interest", value=region_of_interest, expected_type=type_hints["region_of_interest"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "region_of_interest": region_of_interest,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def region_of_interest(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeRegionOfInterestCropRegionOfInterest":
        '''region_of_interest block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest DataAkamaiImagingPolicyImage#region_of_interest}
        '''
        result = self._values.get("region_of_interest")
        assert result is not None, "Required property 'region_of_interest' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeRegionOfInterestCropRegionOfInterest", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''The placement of the crop area relative to the specified area of interest.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''The placement of the crop area relative to the specified area of interest.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeRegionOfInterestCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeRegionOfInterestCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeRegionOfInterestCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__59510dabebce85bff768319618d5ef32ffbf7a19b3534302f4bc266c15ef9267)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeRegionOfInterestCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__935336e4e15cafe74cee32273d052c24e0ee001bd2476a72b325558d47a4f945)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeRegionOfInterestCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__86e65c75d83aaeff7c58884397c15fa4347e0bc5dd5d1401f0281bbaa9aac7a2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__48e20e2977de1ddf5cd421470251268dc736eb55e606711f706061e48241be20)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cf61741691d57238f1ff3e4135f8c740cc10a872124bad062d2a5c6b0fd4391a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeRegionOfInterestCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeRegionOfInterestCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeRegionOfInterestCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7c7e1550ddcabb46528991551fa23125b1d663b2f24d08b3a9b865e4f00d8d0d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeRegionOfInterestCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeRegionOfInterestCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__26763f6e13188ad54e095ba14a17327f24e70aafa9246067fca58f7e33f07a91)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putRegionOfInterest")
    def put_region_of_interest(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeRegionOfInterestCropRegionOfInterest()

        return typing.cast(None, jsii.invoke(self, "putRegionOfInterest", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterest")
    def region_of_interest(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeRegionOfInterestCropRegionOfInterestOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeRegionOfInterestCropRegionOfInterestOutputReference", jsii.get(self, "regionOfInterest"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestInput")
    def region_of_interest_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeRegionOfInterestCropRegionOfInterest"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeRegionOfInterestCropRegionOfInterest"], jsii.get(self, "regionOfInterestInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fb8eeaa93bed0d3a95f7993ffd3864c937ddbb5cfcaae22e1b48c992ed8353c7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea68158a441c2094763ed34043b263f59017d9c519e0245722266549e60940ec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3d5e98506cb1b4d49c15e69577e6ac2fb030fc3fc6292fdd20a0cfa40e71fc1a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7697a669fc505845b4d71f8a8bbfca3bd16aaf7dee81b226d50493246a8a7bf2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d58b48c9dd35d2d9798aea2b9692417661d974ad7e7458f602a6889f7215b626)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e4dfd1da666808653828d4f96cec58dd120d9d986b92c6bdd81b0f69b568f15e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__42a01e8c582237bf6c8400d28d4840713e79e3760752bd9200407eb0af93db2b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cf38cf719918c881a771120218ef0cc47b6b1f700f9b4112b65a7fdab4c99d20)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeRegionOfInterestCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeRegionOfInterestCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeRegionOfInterestCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e8b66ceeb841535bc6f66474a064e115fd9261052b471c7ab9cb388734aa3370)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeRegionOfInterestCropRegionOfInterest",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeRegionOfInterestCropRegionOfInterest:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeRegionOfInterestCropRegionOfInterest(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeRegionOfInterestCropRegionOfInterestOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeRegionOfInterestCropRegionOfInterestOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b0cde9442009b08b66579fc3206e4a71894ceaa645be762498d5113e1ca7a764)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeRegionOfInterestCropRegionOfInterest]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeRegionOfInterestCropRegionOfInterest], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeRegionOfInterestCropRegionOfInterest],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5133a12152db4e3a43409d6ca414c07683c606aeeddbd3b3908c44d11ca97bca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeRelativeCrop",
    jsii_struct_bases=[],
    name_mapping={
        "east": "east",
        "east_var": "eastVar",
        "north": "north",
        "north_var": "northVar",
        "south": "south",
        "south_var": "southVar",
        "west": "west",
        "west_var": "westVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeRelativeCrop:
    def __init__(
        self,
        *,
        east: typing.Optional[builtins.str] = None,
        east_var: typing.Optional[builtins.str] = None,
        north: typing.Optional[builtins.str] = None,
        north_var: typing.Optional[builtins.str] = None,
        south: typing.Optional[builtins.str] = None,
        south_var: typing.Optional[builtins.str] = None,
        west: typing.Optional[builtins.str] = None,
        west_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param east: The number of pixels to shrink or expand the right side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east DataAkamaiImagingPolicyImage#east}
        :param east_var: The number of pixels to shrink or expand the right side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east_var DataAkamaiImagingPolicyImage#east_var}
        :param north: The number of pixels to shrink or expand the top side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north DataAkamaiImagingPolicyImage#north}
        :param north_var: The number of pixels to shrink or expand the top side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north_var DataAkamaiImagingPolicyImage#north_var}
        :param south: The number of pixels to shrink or expand the bottom side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south DataAkamaiImagingPolicyImage#south}
        :param south_var: The number of pixels to shrink or expand the bottom side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south_var DataAkamaiImagingPolicyImage#south_var}
        :param west: The number of pixels to shrink or expand the left side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west DataAkamaiImagingPolicyImage#west}
        :param west_var: The number of pixels to shrink or expand the left side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west_var DataAkamaiImagingPolicyImage#west_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__981f975ec26c49cf778c0dd4e8cde199f64d90ddb8f5d14577815039c13d7360)
            check_type(argname="argument east", value=east, expected_type=type_hints["east"])
            check_type(argname="argument east_var", value=east_var, expected_type=type_hints["east_var"])
            check_type(argname="argument north", value=north, expected_type=type_hints["north"])
            check_type(argname="argument north_var", value=north_var, expected_type=type_hints["north_var"])
            check_type(argname="argument south", value=south, expected_type=type_hints["south"])
            check_type(argname="argument south_var", value=south_var, expected_type=type_hints["south_var"])
            check_type(argname="argument west", value=west, expected_type=type_hints["west"])
            check_type(argname="argument west_var", value=west_var, expected_type=type_hints["west_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if east is not None:
            self._values["east"] = east
        if east_var is not None:
            self._values["east_var"] = east_var
        if north is not None:
            self._values["north"] = north
        if north_var is not None:
            self._values["north_var"] = north_var
        if south is not None:
            self._values["south"] = south
        if south_var is not None:
            self._values["south_var"] = south_var
        if west is not None:
            self._values["west"] = west
        if west_var is not None:
            self._values["west_var"] = west_var

    @builtins.property
    def east(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the right side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east DataAkamaiImagingPolicyImage#east}
        '''
        result = self._values.get("east")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def east_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the right side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east_var DataAkamaiImagingPolicyImage#east_var}
        '''
        result = self._values.get("east_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def north(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the top side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north DataAkamaiImagingPolicyImage#north}
        '''
        result = self._values.get("north")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def north_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the top side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north_var DataAkamaiImagingPolicyImage#north_var}
        '''
        result = self._values.get("north_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def south(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the bottom side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south DataAkamaiImagingPolicyImage#south}
        '''
        result = self._values.get("south")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def south_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the bottom side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south_var DataAkamaiImagingPolicyImage#south_var}
        '''
        result = self._values.get("south_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def west(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the left side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west DataAkamaiImagingPolicyImage#west}
        '''
        result = self._values.get("west")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def west_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the left side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west_var DataAkamaiImagingPolicyImage#west_var}
        '''
        result = self._values.get("west_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeRelativeCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeRelativeCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeRelativeCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a2ff73fea4898f6b804cdfb983619407c63f34082aa033f71685d065ef4de41d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeRelativeCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__63517f4057968a7110856bf47b21000ecaecb76d00b3417b10dd9abae7832fa0)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeRelativeCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__58c03ab30a3806802c01ca03e91cd4daeb240628c2d146ee30024604e7b1fdb9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e8037da1b58a07f2fa3127d8d3dbd8e0bcb0ee0dbe7220b2073e52a8579b2a9f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aec5b74e8f7a75c26957699a67284acaaa9e921da27054e46e6df154d1e286c3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeRelativeCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeRelativeCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeRelativeCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__21844c27cfe13d8e3d4e101c762edd68a87baa91872c36fd0e9c0d2419cf6789)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeRelativeCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeRelativeCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__957ba3c2fdcf507276cacee96d6938d5c6bc16d110c1f1eb32fe7d28f6b8b225)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetEast")
    def reset_east(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEast", []))

    @jsii.member(jsii_name="resetEastVar")
    def reset_east_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEastVar", []))

    @jsii.member(jsii_name="resetNorth")
    def reset_north(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNorth", []))

    @jsii.member(jsii_name="resetNorthVar")
    def reset_north_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNorthVar", []))

    @jsii.member(jsii_name="resetSouth")
    def reset_south(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSouth", []))

    @jsii.member(jsii_name="resetSouthVar")
    def reset_south_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSouthVar", []))

    @jsii.member(jsii_name="resetWest")
    def reset_west(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWest", []))

    @jsii.member(jsii_name="resetWestVar")
    def reset_west_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWestVar", []))

    @builtins.property
    @jsii.member(jsii_name="eastInput")
    def east_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "eastInput"))

    @builtins.property
    @jsii.member(jsii_name="eastVarInput")
    def east_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "eastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="northInput")
    def north_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "northInput"))

    @builtins.property
    @jsii.member(jsii_name="northVarInput")
    def north_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "northVarInput"))

    @builtins.property
    @jsii.member(jsii_name="southInput")
    def south_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "southInput"))

    @builtins.property
    @jsii.member(jsii_name="southVarInput")
    def south_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "southVarInput"))

    @builtins.property
    @jsii.member(jsii_name="westInput")
    def west_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "westInput"))

    @builtins.property
    @jsii.member(jsii_name="westVarInput")
    def west_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "westVarInput"))

    @builtins.property
    @jsii.member(jsii_name="east")
    def east(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "east"))

    @east.setter
    def east(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8d29a3dd9615a1bc701827092e51f1c41e377a962f5e9b3c009ad6b9e64672cf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "east", value)

    @builtins.property
    @jsii.member(jsii_name="eastVar")
    def east_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "eastVar"))

    @east_var.setter
    def east_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3dd371b709b43914f4a744763839dceacf0c3dc9e0a2a7194761a13181e90b4f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "eastVar", value)

    @builtins.property
    @jsii.member(jsii_name="north")
    def north(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "north"))

    @north.setter
    def north(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__128cca6b941368decc1e9de07073d9800a7009f177e4322c3a3775dc8d733eae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "north", value)

    @builtins.property
    @jsii.member(jsii_name="northVar")
    def north_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "northVar"))

    @north_var.setter
    def north_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fdcea8e2460a42391bad21e2155e7d9f65cf01da7bbc5cb1726479da0ba92b69)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "northVar", value)

    @builtins.property
    @jsii.member(jsii_name="south")
    def south(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "south"))

    @south.setter
    def south(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e7ad4195843de852b752414e1495ff6c23886984c0d828bca07b598743d3e0a6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "south", value)

    @builtins.property
    @jsii.member(jsii_name="southVar")
    def south_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "southVar"))

    @south_var.setter
    def south_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8607b71289e705912e5a458894924638781fce04033db0c061097f2c5ec3f00b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "southVar", value)

    @builtins.property
    @jsii.member(jsii_name="west")
    def west(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "west"))

    @west.setter
    def west(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3c9bfea56172c63b10cea473d0b145777b38923503094760af7ec901bf490566)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "west", value)

    @builtins.property
    @jsii.member(jsii_name="westVar")
    def west_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "westVar"))

    @west_var.setter
    def west_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__80bb3345a52c09d1f57a3a479ae1c1127ec9cdccfec15c40c159d1d2134d053f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "westVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeRelativeCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeRelativeCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeRelativeCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__facd15a8bfe618526115ea16ed75fda6a1321be69d274385fde7f672d6564bff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeRemoveColor",
    jsii_struct_bases=[],
    name_mapping={
        "color": "color",
        "color_var": "colorVar",
        "feather": "feather",
        "feather_var": "featherVar",
        "tolerance": "tolerance",
        "tolerance_var": "toleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeRemoveColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
        feather: typing.Optional[builtins.str] = None,
        feather_var: typing.Optional[builtins.str] = None,
        tolerance: typing.Optional[builtins.str] = None,
        tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        :param feather: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        :param feather_var: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        :param tolerance: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        :param tolerance_var: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d64b2f45ea36544928c9686777ee9722e2ab29108642eb9499ad6dab8698207e)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
            check_type(argname="argument feather", value=feather, expected_type=type_hints["feather"])
            check_type(argname="argument feather_var", value=feather_var, expected_type=type_hints["feather_var"])
            check_type(argname="argument tolerance", value=tolerance, expected_type=type_hints["tolerance"])
            check_type(argname="argument tolerance_var", value=tolerance_var, expected_type=type_hints["tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var
        if feather is not None:
            self._values["feather"] = feather
        if feather_var is not None:
            self._values["feather_var"] = feather_var
        if tolerance is not None:
            self._values["tolerance"] = tolerance
        if tolerance_var is not None:
            self._values["tolerance_var"] = tolerance_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        '''
        result = self._values.get("feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather_var(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        '''
        result = self._values.get("feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        '''
        result = self._values.get("tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance_var(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        result = self._values.get("tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeRemoveColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeRemoveColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeRemoveColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__50109c628e5a826d65fd96d6c0f01a3da7c4ace6c366a53d20d9fb732c5a4b63)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeRemoveColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8c5c01c6a6ae79c73bb91def59cfe8b6ea99dc5846f55818a6a644759c962762)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeRemoveColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ad25f429d8c80e0765ad9ba2ef31f2c0b5b35f610343a928e5c1ddb3c9db6d67)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__17e6fa05a40b03c05b46cac3bb387c4d37fc333d5e4ceb5aa7aad5ebc90337f5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea3043ed0ad6f9e0eddba8e191f917aab96aa6539c7a05a9c375f80ed68a3585)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeRemoveColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeRemoveColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeRemoveColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a5e5699b9e808ea51569b3d13c3964c7edd594388502dc9a13106ab6efea03b3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeRemoveColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeRemoveColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cfc8d4dd8394ced61b510b8f5e92331cd19f05f7d613ae0c044fb9273be3e004)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @jsii.member(jsii_name="resetFeather")
    def reset_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeather", []))

    @jsii.member(jsii_name="resetFeatherVar")
    def reset_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatherVar", []))

    @jsii.member(jsii_name="resetTolerance")
    def reset_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTolerance", []))

    @jsii.member(jsii_name="resetToleranceVar")
    def reset_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featherInput")
    def feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherInput"))

    @builtins.property
    @jsii.member(jsii_name="featherVarInput")
    def feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceInput")
    def tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceVarInput")
    def tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1d39babebaca3ade80727c2d6c0bcc638a11aa20c36f97a3f422eb64b2a460c2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4781246e9f5d03ae4fc28a48bf710239a34c1e55912f4140e321692425101c6e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="feather")
    def feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "feather"))

    @feather.setter
    def feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__871e81af90b241e319e4f284ad7b6db961ebc662dcaecd722264102debaad5c1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "feather", value)

    @builtins.property
    @jsii.member(jsii_name="featherVar")
    def feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featherVar"))

    @feather_var.setter
    def feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a0511341e39d5c7d3b81ee360b7f4d220ff4a17860a7ade52be5b958ca2fa1a8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featherVar", value)

    @builtins.property
    @jsii.member(jsii_name="tolerance")
    def tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tolerance"))

    @tolerance.setter
    def tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__748da040833db5a83b2971f0c5f00011eab47b6628be4cb01170a06abcd2ec59)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tolerance", value)

    @builtins.property
    @jsii.member(jsii_name="toleranceVar")
    def tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "toleranceVar"))

    @tolerance_var.setter
    def tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aa8b9f00b4ec6588d96325a2ce357c9d5329dc2b1258e126621b93f546980a24)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "toleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeRemoveColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeRemoveColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeRemoveColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__22ff821a086c1b674dc237521fc4b9bcc1789012d4d2b1a86f122b2bfd4a42da)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeResize",
    jsii_struct_bases=[],
    name_mapping={
        "aspect": "aspect",
        "aspect_var": "aspectVar",
        "height": "height",
        "height_var": "heightVar",
        "type": "type",
        "type_var": "typeVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeResize:
    def __init__(
        self,
        *,
        aspect: typing.Optional[builtins.str] = None,
        aspect_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param aspect: Preserves the aspect ratio. Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect DataAkamaiImagingPolicyImage#aspect}
        :param aspect_var: Preserves the aspect ratio. Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_var DataAkamaiImagingPolicyImage#aspect_var}
        :param height: The height to resize the source image to. Must be set if height is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height to resize the source image to. Must be set if height is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param type: Sets constraints for the image resize. Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: Sets constraints for the image resize. Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        :param width: The width to resize the source image to. Must be set if width is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width to resize the source image to. Must be set if width is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8639dac2bbcefb5e19832142d3649b6debb61e975b01dab0f80eb64cf6718196)
            check_type(argname="argument aspect", value=aspect, expected_type=type_hints["aspect"])
            check_type(argname="argument aspect_var", value=aspect_var, expected_type=type_hints["aspect_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if aspect is not None:
            self._values["aspect"] = aspect
        if aspect_var is not None:
            self._values["aspect_var"] = aspect_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def aspect(self) -> typing.Optional[builtins.str]:
        '''Preserves the aspect ratio.

        Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect DataAkamaiImagingPolicyImage#aspect}
        '''
        result = self._values.get("aspect")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def aspect_var(self) -> typing.Optional[builtins.str]:
        '''Preserves the aspect ratio.

        Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_var DataAkamaiImagingPolicyImage#aspect_var}
        '''
        result = self._values.get("aspect_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height to resize the source image to. Must be set if height is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height to resize the source image to. Must be set if height is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''Sets constraints for the image resize.

        Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''Sets constraints for the image resize.

        Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width to resize the source image to. Must be set if width is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width to resize the source image to. Must be set if width is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeResize(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeResizeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeResizeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a419697becd06fb999a667ac4484f180d5de3a3aa1fe719bf45d71494cd2fa12)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeResizeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__65c645bf9f3c8d1f968d5df5d5756c2fa55b898708067f8597166d94ac4872d6)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeResizeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c0c187cfa32cb0d27affd0001a8cdf5292856e0a2994d62201e58a5cd025e698)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f0bbe6972869791587842e3d8670ab6afa8cda7bafc49c4e33360f461ef3e59c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f96b97911bc38716d92d34245131ea10c625651edbaddd8687aa5e5e777cc09)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeResize]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeResize]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeResize]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__21c5369b5c10096c20ce2176dfe9f17eb1a1cefe3ea22273db302a1bdafbd7d8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeResizeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeResizeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d16a724215f87c74b7478f27e88243c1119fad32029194a17b04d85c310355e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAspect")
    def reset_aspect(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspect", []))

    @jsii.member(jsii_name="resetAspectVar")
    def reset_aspect_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspectVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="aspectInput")
    def aspect_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "aspectInput"))

    @builtins.property
    @jsii.member(jsii_name="aspectVarInput")
    def aspect_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "aspectVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="aspect")
    def aspect(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "aspect"))

    @aspect.setter
    def aspect(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__16d79a7f3269fcacd2348d629b4ac84a7327c296403b87980ad21a4d294328a5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "aspect", value)

    @builtins.property
    @jsii.member(jsii_name="aspectVar")
    def aspect_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "aspectVar"))

    @aspect_var.setter
    def aspect_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__70a4e9e3a6bb3b8b74caa5c50ea0fd27bc0502ee4170ea08c1227af850fbaaec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "aspectVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b707e1c9221d1a48e298d2bfe3e1e86b45b5a708527bbc5e75f65016ce63c15b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__160894ef8b400a5d304f7c78dff8e8f854c8ce0d8cda1caf2190de91af0fbf46)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d0769c3bfbb90cf8453ff5e1244b038d2ab6b4dbe69d05d175243cbeab63c09c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aa17bab160371946411fc1a64e2b63bcd6472b58e5b209a19ef5ff4603cb6e7a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3c15b3d770719775d8aeedf3bb1f1abcdaf604bb4e4078b4f8c9bae84d51320a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2224b60c16d497ba51b810356170531cb673f997d7406aa3937fd8788a3535f2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeResize]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeResize]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeResize]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__99f4420055c21620e2297bef6235915e03a0505fc4a290f2eb8b5a5657763e1d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeRotate",
    jsii_struct_bases=[],
    name_mapping={"degrees": "degrees", "degrees_var": "degreesVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeRotate:
    def __init__(
        self,
        *,
        degrees: typing.Optional[builtins.str] = None,
        degrees_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param degrees: The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees DataAkamaiImagingPolicyImage#degrees}
        :param degrees_var: The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees_var DataAkamaiImagingPolicyImage#degrees_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2590489eb5a60d16fcd53ff320a3ecd4e3f6f2cf989defdaee82870d12e20fd5)
            check_type(argname="argument degrees", value=degrees, expected_type=type_hints["degrees"])
            check_type(argname="argument degrees_var", value=degrees_var, expected_type=type_hints["degrees_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if degrees is not None:
            self._values["degrees"] = degrees
        if degrees_var is not None:
            self._values["degrees_var"] = degrees_var

    @builtins.property
    def degrees(self) -> typing.Optional[builtins.str]:
        '''The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees DataAkamaiImagingPolicyImage#degrees}
        '''
        result = self._values.get("degrees")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def degrees_var(self) -> typing.Optional[builtins.str]:
        '''The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees_var DataAkamaiImagingPolicyImage#degrees_var}
        '''
        result = self._values.get("degrees_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeRotate(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeRotateList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeRotateList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__69a4c5a1a2dc85dafa1c8b3f75c872baf6c4a0b59e020ad980f322289465a193)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeRotateOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a227335fac0ddfd93461fefee3d8c13b153566b7c2d9ee3c914fbd31b815f0e2)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeRotateOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f49e1958202e2bf52797035ee4f08006289913ab7f87d3a8410e4bfaa7ef5614)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b001752f88ff1119e7f965aaa6004f7124ea6ab1c2541963c594b918dad18714)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a52338d86d109b13b9b6af9f50df5ca903211d423bf6401aaf98fb6ce30d5c6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeRotate]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeRotate]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeRotate]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8edf6721f1e93053de7400cff28bff54d832fa3c27a8e26bc577706004b2ad95)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeRotateOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeRotateOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__35b5cdd9dfdc2145860ae5636d8d6d9969cdf7139b93eee3a9ed185433c98bd1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetDegrees")
    def reset_degrees(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDegrees", []))

    @jsii.member(jsii_name="resetDegreesVar")
    def reset_degrees_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDegreesVar", []))

    @builtins.property
    @jsii.member(jsii_name="degreesInput")
    def degrees_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "degreesInput"))

    @builtins.property
    @jsii.member(jsii_name="degreesVarInput")
    def degrees_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "degreesVarInput"))

    @builtins.property
    @jsii.member(jsii_name="degrees")
    def degrees(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "degrees"))

    @degrees.setter
    def degrees(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab5dc9e51a4407478f163cdb0938cbdc1b1f0e575b4358fc46d0da6268358f0e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "degrees", value)

    @builtins.property
    @jsii.member(jsii_name="degreesVar")
    def degrees_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "degreesVar"))

    @degrees_var.setter
    def degrees_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fe2b6be11139f91c9508117cc6cc741dc4f5eb406bae5ec921900696eb972f1e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "degreesVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeRotate]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeRotate]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeRotate]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ea62804e0f840071866b3230e28680bd420f726259b8d3780073acd4273c779)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeScale",
    jsii_struct_bases=[],
    name_mapping={
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeScale:
    def __init__(
        self,
        *,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param height: Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged. Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged. Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e1c5cf63efcd0d7b63439ba68c653fc84d06b7c2ebe712053c0948d1f44f9b39)
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size.

        Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size.

        Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged.

        Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged.

        Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeScale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeScaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeScaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c260147ed1060ac1b60c361b781e9fd8193c3cec50b256a3bffcfa8ff1bbd675)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeScaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d5d738c19321448a11d0669041e7d645019a7191d953fa22fcd16b286f6390f6)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeScaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4392dc7da99a173c32cbbeec507860dfc944d3b91a0d43976ff2e04fb723c007)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5222ae51cad8cba30b3740816d3a56202647dd17799c7b0e077bf86eb3af32ab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__edee306500b3adc76b092d3edcc9951952ba5795132939fc7e23032b8c0a4967)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeScale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeScale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeScale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__089562136cdaab8d9d611a1a8eb12aae931fdab9fd7a8e3c98ca7eca4b6dc9c9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeScaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeScaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5c39c852ce0f42c3ceecb5c7339769e4dba7f4be302a2ecad2de766b908384be)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__40aa0ac6362616dea2a9863d1ce3d320938b178295fa36ffd1b16d60fca89766)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e38404af06555a9a2b64f832bfdc8e84fd1f89817f04363fdb8da542252e5336)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f0eb7a577e84d8148fe353f9ec5e355e0a49bff580634dbf8e368559b112fa3b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9f05ae0e1c075d86043f75b8f1471f958487ed326a2da893bcfd3961a8e145ca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeScale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeScale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeScale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4fd6d1999fcf18ed8abca37215ab07331321749274cf2f9f724f4fd5a1f12ceb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeShear",
    jsii_struct_bases=[],
    name_mapping={
        "x_shear": "xShear",
        "x_shear_var": "xShearVar",
        "y_shear": "yShear",
        "y_shear_var": "yShearVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeShear:
    def __init__(
        self,
        *,
        x_shear: typing.Optional[builtins.str] = None,
        x_shear_var: typing.Optional[builtins.str] = None,
        y_shear: typing.Optional[builtins.str] = None,
        y_shear_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param x_shear: The amount to shear along the x-axis, measured in multiples of the image's width. Must be set if yShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear DataAkamaiImagingPolicyImage#x_shear}
        :param x_shear_var: The amount to shear along the x-axis, measured in multiples of the image's width. Must be set if yShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear_var DataAkamaiImagingPolicyImage#x_shear_var}
        :param y_shear: The amount to shear along the y-axis, measured in multiples of the image's height. Must be set if xShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear DataAkamaiImagingPolicyImage#y_shear}
        :param y_shear_var: The amount to shear along the y-axis, measured in multiples of the image's height. Must be set if xShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear_var DataAkamaiImagingPolicyImage#y_shear_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cf1df29c7e5beed43f917ac75d51f58cd8b5f90b3b98d9ebfec238e1e97d9890)
            check_type(argname="argument x_shear", value=x_shear, expected_type=type_hints["x_shear"])
            check_type(argname="argument x_shear_var", value=x_shear_var, expected_type=type_hints["x_shear_var"])
            check_type(argname="argument y_shear", value=y_shear, expected_type=type_hints["y_shear"])
            check_type(argname="argument y_shear_var", value=y_shear_var, expected_type=type_hints["y_shear_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if x_shear is not None:
            self._values["x_shear"] = x_shear
        if x_shear_var is not None:
            self._values["x_shear_var"] = x_shear_var
        if y_shear is not None:
            self._values["y_shear"] = y_shear
        if y_shear_var is not None:
            self._values["y_shear_var"] = y_shear_var

    @builtins.property
    def x_shear(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the x-axis, measured in multiples of the image's width.

        Must be set if yShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear DataAkamaiImagingPolicyImage#x_shear}
        '''
        result = self._values.get("x_shear")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_shear_var(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the x-axis, measured in multiples of the image's width.

        Must be set if yShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear_var DataAkamaiImagingPolicyImage#x_shear_var}
        '''
        result = self._values.get("x_shear_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_shear(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the y-axis, measured in multiples of the image's height.

        Must be set if xShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear DataAkamaiImagingPolicyImage#y_shear}
        '''
        result = self._values.get("y_shear")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_shear_var(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the y-axis, measured in multiples of the image's height.

        Must be set if xShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear_var DataAkamaiImagingPolicyImage#y_shear_var}
        '''
        result = self._values.get("y_shear_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeShear(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeShearList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeShearList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b2258c0c63c7a85eb454f7527b3beaea4cd0c79de5dfe2781aff40274d6fba4c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeShearOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5bbd3d7ec21133df91fc3e055d84eaa020031ec48a5543f78a6e0af5d82133a5)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeShearOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__871a82f77218966799179d7bdaddf23ef46f49b942add5f4709477dbc5d7ccfb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a17e253441a2315a124107f25b84e4734fc3f4ee159254256dfbeea918f27d64)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__60d5a1ea438ff0ecf9adc22daf26f0bbdbaa95a1eb27aa8174d48c6ee527c6bf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeShear]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeShear]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeShear]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a21b81223a495f6f255deed81aea4e3115aa6081bd5e7e3419886a5216cc98ae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeShearOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeShearOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e44dc5736da0a756dfaf58596fa7edc2cce860f8cb1e7bf08640b20f69e699ff)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetXShear")
    def reset_x_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXShear", []))

    @jsii.member(jsii_name="resetXShearVar")
    def reset_x_shear_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXShearVar", []))

    @jsii.member(jsii_name="resetYShear")
    def reset_y_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYShear", []))

    @jsii.member(jsii_name="resetYShearVar")
    def reset_y_shear_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYShearVar", []))

    @builtins.property
    @jsii.member(jsii_name="xShearInput")
    def x_shear_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xShearInput"))

    @builtins.property
    @jsii.member(jsii_name="xShearVarInput")
    def x_shear_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xShearVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yShearInput")
    def y_shear_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yShearInput"))

    @builtins.property
    @jsii.member(jsii_name="yShearVarInput")
    def y_shear_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yShearVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xShear")
    def x_shear(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xShear"))

    @x_shear.setter
    def x_shear(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8f0860255b935d0086d25150301bc6b081b20a59952be8f61bd63ae425dece4d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xShear", value)

    @builtins.property
    @jsii.member(jsii_name="xShearVar")
    def x_shear_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xShearVar"))

    @x_shear_var.setter
    def x_shear_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bddccb9b58a5a834ea87fd3b59fcce2ece5eebfd88c159aca826ee689877a27b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xShearVar", value)

    @builtins.property
    @jsii.member(jsii_name="yShear")
    def y_shear(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yShear"))

    @y_shear.setter
    def y_shear(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__42794b7aed59bdf18a994d6ea31e6e0d119123e94ba62fecb5bc00dc20fa58bf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yShear", value)

    @builtins.property
    @jsii.member(jsii_name="yShearVar")
    def y_shear_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yShearVar"))

    @y_shear_var.setter
    def y_shear_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0a78fd3a0082b2ae83b5b754490f45280c1aaa9fff020a5f08e70c815bcae9c7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yShearVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeShear]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeShear]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeShear]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d74b9c5e777618eda64a33f712015c19990e5afd732cb2727bac8fca644506c9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeTrim",
    jsii_struct_bases=[],
    name_mapping={
        "fuzz": "fuzz",
        "fuzz_var": "fuzzVar",
        "padding": "padding",
        "padding_var": "paddingVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeTrim:
    def __init__(
        self,
        *,
        fuzz: typing.Optional[builtins.str] = None,
        fuzz_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fuzz: The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz DataAkamaiImagingPolicyImage#fuzz}
        :param fuzz_var: The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz_var DataAkamaiImagingPolicyImage#fuzz_var}
        :param padding: The amount of padding in pixels to add to the trimmed image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: The amount of padding in pixels to add to the trimmed image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e1a6aa6ae504de29b337effefcc64176bf95aea1aa223b6489b5e4d817663b44)
            check_type(argname="argument fuzz", value=fuzz, expected_type=type_hints["fuzz"])
            check_type(argname="argument fuzz_var", value=fuzz_var, expected_type=type_hints["fuzz_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fuzz is not None:
            self._values["fuzz"] = fuzz
        if fuzz_var is not None:
            self._values["fuzz_var"] = fuzz_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var

    @builtins.property
    def fuzz(self) -> typing.Optional[builtins.str]:
        '''The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz DataAkamaiImagingPolicyImage#fuzz}
        '''
        result = self._values.get("fuzz")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fuzz_var(self) -> typing.Optional[builtins.str]:
        '''The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz_var DataAkamaiImagingPolicyImage#fuzz_var}
        '''
        result = self._values.get("fuzz_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''The amount of padding in pixels to add to the trimmed image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''The amount of padding in pixels to add to the trimmed image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeTrim(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeTrimList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeTrimList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1bc47534fb29c3a97eea7f4dd912284349057d761b055ccc001ef588d2fad94d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeTrimOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f4b99c2bea1bee9150b700ea0cdf0137e7d1c57c57beada414a45deda93d2be8)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeTrimOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ed86d0413c2c948f385901a0fb3b290258664e9a15df21af773e2f977b1033ea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ff7db66ee23797dda331119dce3bc85f51e166a01714055bcd0b1daca0778b25)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df0d977e35b82316fb1b1afd54ef02e9115501620428dcc59eb58ede6bb41e0d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeTrim]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeTrim]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeTrim]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8b820bffddcaa80c16a1098d5f2a730e7e5f78965075c9c349e7cd9bc69c74dc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeTrimOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeTrimOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa449de9f6f4536fe45cba6bf0fc1b21cbc29b56efeda9a364ef799b15cf3117)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetFuzz")
    def reset_fuzz(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFuzz", []))

    @jsii.member(jsii_name="resetFuzzVar")
    def reset_fuzz_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFuzzVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @builtins.property
    @jsii.member(jsii_name="fuzzInput")
    def fuzz_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fuzzInput"))

    @builtins.property
    @jsii.member(jsii_name="fuzzVarInput")
    def fuzz_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fuzzVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="fuzz")
    def fuzz(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fuzz"))

    @fuzz.setter
    def fuzz(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__90ffa5feb6e3f78422b4339d64ccab83b850c5f733f9efbd54af88940d616cf6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fuzz", value)

    @builtins.property
    @jsii.member(jsii_name="fuzzVar")
    def fuzz_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fuzzVar"))

    @fuzz_var.setter
    def fuzz_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__57a1919c810dd2e1b9c28c2f0068a898047047e6b51030db2979191aeb69c561)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fuzzVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__61d15bbe2a066388b55370c3c51d50ce1cc9a6d00bb690d217b1be036ddf3543)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__041d921c2361b1690a2dfdefba5e5868b52af89008c963458817ef7001a66c42)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeTrim]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeTrim]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeTrim]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__33615b21c652536f4f72ad7bfe0931a324b86158e8a3b8aac7b7d3e0613c0fff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeUnsharpMask",
    jsii_struct_bases=[],
    name_mapping={
        "gain": "gain",
        "gain_var": "gainVar",
        "sigma": "sigma",
        "sigma_var": "sigmaVar",
        "threshold": "threshold",
        "threshold_var": "thresholdVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeUnsharpMask:
    def __init__(
        self,
        *,
        gain: typing.Optional[builtins.str] = None,
        gain_var: typing.Optional[builtins.str] = None,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
        threshold: typing.Optional[builtins.str] = None,
        threshold_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param gain: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        :param gain_var: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        :param sigma: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        :param threshold: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        :param threshold_var: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a9da695a3764fe8d9dfc13e380aac2cf285822b404fc2939de8422ccc4394122)
            check_type(argname="argument gain", value=gain, expected_type=type_hints["gain"])
            check_type(argname="argument gain_var", value=gain_var, expected_type=type_hints["gain_var"])
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
            check_type(argname="argument threshold", value=threshold, expected_type=type_hints["threshold"])
            check_type(argname="argument threshold_var", value=threshold_var, expected_type=type_hints["threshold_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if gain is not None:
            self._values["gain"] = gain
        if gain_var is not None:
            self._values["gain_var"] = gain_var
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var
        if threshold is not None:
            self._values["threshold"] = threshold
        if threshold_var is not None:
            self._values["threshold_var"] = threshold_var

    @builtins.property
    def gain(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        '''
        result = self._values.get("gain")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gain_var(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        '''
        result = self._values.get("gain_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        '''
        result = self._values.get("threshold")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold_var(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        result = self._values.get("threshold_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeUnsharpMask(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeUnsharpMaskList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeUnsharpMaskList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d5b109e7d910efa33059643ecba2ea58a72f4acfa00086e60807624d7a8e89d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeUnsharpMaskOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__134cc9b1b98d7bfa6124cf5883e8db45fddaa0cd3998c6ab133328090ef93a39)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeUnsharpMaskOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__375adb0bdbf3535ceeee464e15b5ace5a99c9becf4f5539b1c9790d1ff634f29)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__74b2234e7dac6476132ea5c5129799c4b86cb77d4f56389d678fc4ea44866072)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__22419482f93df40d2d7e6e1d85df135d1d7489a1183b237608cc791385a51d3e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeUnsharpMask]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeUnsharpMask]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeUnsharpMask]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4867c52e88025fbea2a42b63206d3d0b7fd023660efedd04d689dfbb77f48229)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeUnsharpMaskOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeUnsharpMaskOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__caeb547ace8bee2059edf3ceb613a313ac76182397be95791e66f61046311453)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetGain")
    def reset_gain(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGain", []))

    @jsii.member(jsii_name="resetGainVar")
    def reset_gain_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGainVar", []))

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @jsii.member(jsii_name="resetThreshold")
    def reset_threshold(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThreshold", []))

    @jsii.member(jsii_name="resetThresholdVar")
    def reset_threshold_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThresholdVar", []))

    @builtins.property
    @jsii.member(jsii_name="gainInput")
    def gain_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainInput"))

    @builtins.property
    @jsii.member(jsii_name="gainVarInput")
    def gain_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdInput")
    def threshold_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdVarInput")
    def threshold_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gain")
    def gain(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gain"))

    @gain.setter
    def gain(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__81532c46edc6a13c85dbf54864d91164f4eb18767fa04afd1dce8262729c7353)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gain", value)

    @builtins.property
    @jsii.member(jsii_name="gainVar")
    def gain_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gainVar"))

    @gain_var.setter
    def gain_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9594ae94518e08767edf30ebb36fbc74981edbc871b0440fb99c26d39d610420)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gainVar", value)

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1a40cb12ed7bc7954b2af27e5207b986956fef8ca95596106c9a1f5271af2869)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0db70fdb981b4065965fa66a7179cf5401f977c0d6e00a9ef77925edfa931e0d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="threshold")
    def threshold(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "threshold"))

    @threshold.setter
    def threshold(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__19904d8d1a24952f652e3ba008b9f51952fc00871dffce72f21bb48c746531b8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "threshold", value)

    @builtins.property
    @jsii.member(jsii_name="thresholdVar")
    def threshold_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "thresholdVar"))

    @threshold_var.setter
    def threshold_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3dc30df001ca70a27e365fa7bb2f996fa995dae9f52ea800b05e3a5a9b7cccac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "thresholdVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeUnsharpMask]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeUnsharpMask]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeUnsharpMask]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bf802dd5c41745d0272d791d4a588f75470e597727ada545ffa536e43325082a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__545747a07b0cb849f27aa80d67c9a9680435f526c8345187c8c984722fc1448c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a85277ce9cb45b04eef1baefcbe879cd238a763bd75c176b8c5bc2c324ccdea)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__99c352f05c16d409a8d17c62f3b15238b667d89bd49edc01ca2156b06d10a3f3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d966a34a2059d5db453754f30d1036d169117cd743fa4ce0008cfc748e25c092)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ea553c4867402d106112bb4fcd9c75824bde02d4d6135e260ffa0ad8704a1b7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientation]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientation]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f18748208e53feae456709bdc162ec2a09c5634f81ce5d72fac3bdcbfc4b78d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b8f9e7545677928eff10f1246b8c31e176147c7416114903b40e4624a8736602)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(
        self,
        *,
        append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultAppend, typing.Dict[builtins.str, typing.Any]]]]] = None,
        aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultAspectCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
        crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultFaceCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultFeatureCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultFitAndFill, typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
        im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultImQuery, typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
        region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultRegionOfInterestCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultRelativeCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
        resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultResize, typing.Dict[builtins.str, typing.Any]]]]] = None,
        rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultRotate, typing.Dict[builtins.str, typing.Any]]]]] = None,
        scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultScale, typing.Dict[builtins.str, typing.Any]]]]] = None,
        shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultShear, typing.Dict[builtins.str, typing.Any]]]]] = None,
        trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultTrim, typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param append: append block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        :param aspect_crop: aspect_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param crop: crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        :param face_crop: face_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        :param feature_crop: feature_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        :param fit_and_fill: fit_and_fill block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param im_query: im_query block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param region_of_interest_crop: region_of_interest_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        :param relative_crop: relative_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param resize: resize block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        :param rotate: rotate block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        :param scale: scale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param shear: shear block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        :param trim: trim block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefault(
            append=append,
            aspect_crop=aspect_crop,
            background_color=background_color,
            blur=blur,
            chroma_key=chroma_key,
            composite=composite,
            compound=compound,
            contrast=contrast,
            crop=crop,
            face_crop=face_crop,
            feature_crop=feature_crop,
            fit_and_fill=fit_and_fill,
            goop=goop,
            grayscale=grayscale,
            hsl=hsl,
            hsv=hsv,
            if_dimension=if_dimension,
            if_orientation=if_orientation,
            im_query=im_query,
            max_colors=max_colors,
            mirror=mirror,
            mono_hue=mono_hue,
            opacity=opacity,
            region_of_interest_crop=region_of_interest_crop,
            relative_crop=relative_crop,
            remove_color=remove_color,
            resize=resize,
            rotate=rotate,
            scale=scale,
            shear=shear,
            trim=trim,
            unsharp_mask=unsharp_mask,
        )

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putLandscape")
    def put_landscape(
        self,
        *,
        append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeAppend, typing.Dict[builtins.str, typing.Any]]]]] = None,
        aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeAspectCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
        crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeFaceCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeFeatureCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeFitAndFill, typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
        im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeImQuery, typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
        region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeRegionOfInterestCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeRelativeCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
        resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeResize, typing.Dict[builtins.str, typing.Any]]]]] = None,
        rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeRotate, typing.Dict[builtins.str, typing.Any]]]]] = None,
        scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeScale, typing.Dict[builtins.str, typing.Any]]]]] = None,
        shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeShear, typing.Dict[builtins.str, typing.Any]]]]] = None,
        trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeTrim, typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param append: append block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        :param aspect_crop: aspect_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param crop: crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        :param face_crop: face_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        :param feature_crop: feature_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        :param fit_and_fill: fit_and_fill block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param im_query: im_query block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param region_of_interest_crop: region_of_interest_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        :param relative_crop: relative_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param resize: resize block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        :param rotate: rotate block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        :param scale: scale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param shear: shear block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        :param trim: trim block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscape(
            append=append,
            aspect_crop=aspect_crop,
            background_color=background_color,
            blur=blur,
            chroma_key=chroma_key,
            composite=composite,
            compound=compound,
            contrast=contrast,
            crop=crop,
            face_crop=face_crop,
            feature_crop=feature_crop,
            fit_and_fill=fit_and_fill,
            goop=goop,
            grayscale=grayscale,
            hsl=hsl,
            hsv=hsv,
            if_dimension=if_dimension,
            if_orientation=if_orientation,
            im_query=im_query,
            max_colors=max_colors,
            mirror=mirror,
            mono_hue=mono_hue,
            opacity=opacity,
            region_of_interest_crop=region_of_interest_crop,
            relative_crop=relative_crop,
            remove_color=remove_color,
            resize=resize,
            rotate=rotate,
            scale=scale,
            shear=shear,
            trim=trim,
            unsharp_mask=unsharp_mask,
        )

        return typing.cast(None, jsii.invoke(self, "putLandscape", [value]))

    @jsii.member(jsii_name="putPortrait")
    def put_portrait(
        self,
        *,
        append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitAppend", typing.Dict[builtins.str, typing.Any]]]]] = None,
        aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitAspectCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitBackgroundColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitBlur", typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitChromaKey", typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitComposite", typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitCompound", typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitContrast", typing.Dict[builtins.str, typing.Any]]]]] = None,
        crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitFaceCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitFeatureCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitFitAndFill", typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitGoop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitGrayscale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitHsl", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitHsv", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfDimension", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfOrientation", typing.Dict[builtins.str, typing.Any]]]]] = None,
        im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitImQuery", typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitMaxColors", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitMirror", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitMonoHue", typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitOpacity", typing.Dict[builtins.str, typing.Any]]]]] = None,
        region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitRegionOfInterestCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitRelativeCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitRemoveColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitResize", typing.Dict[builtins.str, typing.Any]]]]] = None,
        rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitRotate", typing.Dict[builtins.str, typing.Any]]]]] = None,
        scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitScale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitShear", typing.Dict[builtins.str, typing.Any]]]]] = None,
        trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitTrim", typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitUnsharpMask", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param append: append block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        :param aspect_crop: aspect_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param crop: crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        :param face_crop: face_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        :param feature_crop: feature_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        :param fit_and_fill: fit_and_fill block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param im_query: im_query block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param region_of_interest_crop: region_of_interest_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        :param relative_crop: relative_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param resize: resize block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        :param rotate: rotate block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        :param scale: scale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param shear: shear block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        :param trim: trim block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortrait(
            append=append,
            aspect_crop=aspect_crop,
            background_color=background_color,
            blur=blur,
            chroma_key=chroma_key,
            composite=composite,
            compound=compound,
            contrast=contrast,
            crop=crop,
            face_crop=face_crop,
            feature_crop=feature_crop,
            fit_and_fill=fit_and_fill,
            goop=goop,
            grayscale=grayscale,
            hsl=hsl,
            hsv=hsv,
            if_dimension=if_dimension,
            if_orientation=if_orientation,
            im_query=im_query,
            max_colors=max_colors,
            mirror=mirror,
            mono_hue=mono_hue,
            opacity=opacity,
            region_of_interest_crop=region_of_interest_crop,
            relative_crop=relative_crop,
            remove_color=remove_color,
            resize=resize,
            rotate=rotate,
            scale=scale,
            shear=shear,
            trim=trim,
            unsharp_mask=unsharp_mask,
        )

        return typing.cast(None, jsii.invoke(self, "putPortrait", [value]))

    @jsii.member(jsii_name="putSquare")
    def put_square(
        self,
        *,
        append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareAppend", typing.Dict[builtins.str, typing.Any]]]]] = None,
        aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareAspectCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareBackgroundColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareBlur", typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareChromaKey", typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareComposite", typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareCompound", typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareContrast", typing.Dict[builtins.str, typing.Any]]]]] = None,
        crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareFaceCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareFeatureCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareFitAndFill", typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareGoop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareGrayscale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareHsl", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareHsv", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfDimension", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfOrientation", typing.Dict[builtins.str, typing.Any]]]]] = None,
        im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareImQuery", typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareMaxColors", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareMirror", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareMonoHue", typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareOpacity", typing.Dict[builtins.str, typing.Any]]]]] = None,
        region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareRegionOfInterestCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareRelativeCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareRemoveColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareResize", typing.Dict[builtins.str, typing.Any]]]]] = None,
        rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareRotate", typing.Dict[builtins.str, typing.Any]]]]] = None,
        scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareScale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareShear", typing.Dict[builtins.str, typing.Any]]]]] = None,
        trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareTrim", typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareUnsharpMask", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param append: append block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        :param aspect_crop: aspect_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param crop: crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        :param face_crop: face_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        :param feature_crop: feature_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        :param fit_and_fill: fit_and_fill block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param im_query: im_query block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param region_of_interest_crop: region_of_interest_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        :param relative_crop: relative_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param resize: resize block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        :param rotate: rotate block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        :param scale: scale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param shear: shear block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        :param trim: trim block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquare(
            append=append,
            aspect_crop=aspect_crop,
            background_color=background_color,
            blur=blur,
            chroma_key=chroma_key,
            composite=composite,
            compound=compound,
            contrast=contrast,
            crop=crop,
            face_crop=face_crop,
            feature_crop=feature_crop,
            fit_and_fill=fit_and_fill,
            goop=goop,
            grayscale=grayscale,
            hsl=hsl,
            hsv=hsv,
            if_dimension=if_dimension,
            if_orientation=if_orientation,
            im_query=im_query,
            max_colors=max_colors,
            mirror=mirror,
            mono_hue=mono_hue,
            opacity=opacity,
            region_of_interest_crop=region_of_interest_crop,
            relative_crop=relative_crop,
            remove_color=remove_color,
            resize=resize,
            rotate=rotate,
            scale=scale,
            shear=shear,
            trim=trim,
            unsharp_mask=unsharp_mask,
        )

        return typing.cast(None, jsii.invoke(self, "putSquare", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetLandscape")
    def reset_landscape(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLandscape", []))

    @jsii.member(jsii_name="resetPortrait")
    def reset_portrait(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPortrait", []))

    @jsii.member(jsii_name="resetSquare")
    def reset_square(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSquare", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="landscape")
    def landscape(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeOutputReference, jsii.get(self, "landscape"))

    @builtins.property
    @jsii.member(jsii_name="portrait")
    def portrait(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitOutputReference", jsii.get(self, "portrait"))

    @builtins.property
    @jsii.member(jsii_name="square")
    def square(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareOutputReference", jsii.get(self, "square"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="landscapeInput")
    def landscape_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscape], jsii.get(self, "landscapeInput"))

    @builtins.property
    @jsii.member(jsii_name="portraitInput")
    def portrait_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortrait"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortrait"], jsii.get(self, "portraitInput"))

    @builtins.property
    @jsii.member(jsii_name="squareInput")
    def square_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquare"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquare"], jsii.get(self, "squareInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientation]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientation]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientation]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d19effa7e3be55e54cf0eb53d597ec688453b338841167c34c36755817288035)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortrait",
    jsii_struct_bases=[],
    name_mapping={
        "append": "append",
        "aspect_crop": "aspectCrop",
        "background_color": "backgroundColor",
        "blur": "blur",
        "chroma_key": "chromaKey",
        "composite": "composite",
        "compound": "compound",
        "contrast": "contrast",
        "crop": "crop",
        "face_crop": "faceCrop",
        "feature_crop": "featureCrop",
        "fit_and_fill": "fitAndFill",
        "goop": "goop",
        "grayscale": "grayscale",
        "hsl": "hsl",
        "hsv": "hsv",
        "if_dimension": "ifDimension",
        "if_orientation": "ifOrientation",
        "im_query": "imQuery",
        "max_colors": "maxColors",
        "mirror": "mirror",
        "mono_hue": "monoHue",
        "opacity": "opacity",
        "region_of_interest_crop": "regionOfInterestCrop",
        "relative_crop": "relativeCrop",
        "remove_color": "removeColor",
        "resize": "resize",
        "rotate": "rotate",
        "scale": "scale",
        "shear": "shear",
        "trim": "trim",
        "unsharp_mask": "unsharpMask",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortrait:
    def __init__(
        self,
        *,
        append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitAppend", typing.Dict[builtins.str, typing.Any]]]]] = None,
        aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitAspectCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitBackgroundColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitBlur", typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitChromaKey", typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitComposite", typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitCompound", typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitContrast", typing.Dict[builtins.str, typing.Any]]]]] = None,
        crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitFaceCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitFeatureCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitFitAndFill", typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitGoop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitGrayscale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitHsl", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitHsv", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfDimension", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfOrientation", typing.Dict[builtins.str, typing.Any]]]]] = None,
        im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitImQuery", typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitMaxColors", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitMirror", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitMonoHue", typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitOpacity", typing.Dict[builtins.str, typing.Any]]]]] = None,
        region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitRegionOfInterestCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitRelativeCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitRemoveColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitResize", typing.Dict[builtins.str, typing.Any]]]]] = None,
        rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitRotate", typing.Dict[builtins.str, typing.Any]]]]] = None,
        scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitScale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitShear", typing.Dict[builtins.str, typing.Any]]]]] = None,
        trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitTrim", typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitUnsharpMask", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param append: append block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        :param aspect_crop: aspect_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param crop: crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        :param face_crop: face_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        :param feature_crop: feature_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        :param fit_and_fill: fit_and_fill block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param im_query: im_query block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param region_of_interest_crop: region_of_interest_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        :param relative_crop: relative_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param resize: resize block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        :param rotate: rotate block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        :param scale: scale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param shear: shear block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        :param trim: trim block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5803fba9e8a4b806fd5312628cfd3a53de4a14f4f4a45cb64ee52babaaf19267)
            check_type(argname="argument append", value=append, expected_type=type_hints["append"])
            check_type(argname="argument aspect_crop", value=aspect_crop, expected_type=type_hints["aspect_crop"])
            check_type(argname="argument background_color", value=background_color, expected_type=type_hints["background_color"])
            check_type(argname="argument blur", value=blur, expected_type=type_hints["blur"])
            check_type(argname="argument chroma_key", value=chroma_key, expected_type=type_hints["chroma_key"])
            check_type(argname="argument composite", value=composite, expected_type=type_hints["composite"])
            check_type(argname="argument compound", value=compound, expected_type=type_hints["compound"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument crop", value=crop, expected_type=type_hints["crop"])
            check_type(argname="argument face_crop", value=face_crop, expected_type=type_hints["face_crop"])
            check_type(argname="argument feature_crop", value=feature_crop, expected_type=type_hints["feature_crop"])
            check_type(argname="argument fit_and_fill", value=fit_and_fill, expected_type=type_hints["fit_and_fill"])
            check_type(argname="argument goop", value=goop, expected_type=type_hints["goop"])
            check_type(argname="argument grayscale", value=grayscale, expected_type=type_hints["grayscale"])
            check_type(argname="argument hsl", value=hsl, expected_type=type_hints["hsl"])
            check_type(argname="argument hsv", value=hsv, expected_type=type_hints["hsv"])
            check_type(argname="argument if_dimension", value=if_dimension, expected_type=type_hints["if_dimension"])
            check_type(argname="argument if_orientation", value=if_orientation, expected_type=type_hints["if_orientation"])
            check_type(argname="argument im_query", value=im_query, expected_type=type_hints["im_query"])
            check_type(argname="argument max_colors", value=max_colors, expected_type=type_hints["max_colors"])
            check_type(argname="argument mirror", value=mirror, expected_type=type_hints["mirror"])
            check_type(argname="argument mono_hue", value=mono_hue, expected_type=type_hints["mono_hue"])
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument region_of_interest_crop", value=region_of_interest_crop, expected_type=type_hints["region_of_interest_crop"])
            check_type(argname="argument relative_crop", value=relative_crop, expected_type=type_hints["relative_crop"])
            check_type(argname="argument remove_color", value=remove_color, expected_type=type_hints["remove_color"])
            check_type(argname="argument resize", value=resize, expected_type=type_hints["resize"])
            check_type(argname="argument rotate", value=rotate, expected_type=type_hints["rotate"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument shear", value=shear, expected_type=type_hints["shear"])
            check_type(argname="argument trim", value=trim, expected_type=type_hints["trim"])
            check_type(argname="argument unsharp_mask", value=unsharp_mask, expected_type=type_hints["unsharp_mask"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if append is not None:
            self._values["append"] = append
        if aspect_crop is not None:
            self._values["aspect_crop"] = aspect_crop
        if background_color is not None:
            self._values["background_color"] = background_color
        if blur is not None:
            self._values["blur"] = blur
        if chroma_key is not None:
            self._values["chroma_key"] = chroma_key
        if composite is not None:
            self._values["composite"] = composite
        if compound is not None:
            self._values["compound"] = compound
        if contrast is not None:
            self._values["contrast"] = contrast
        if crop is not None:
            self._values["crop"] = crop
        if face_crop is not None:
            self._values["face_crop"] = face_crop
        if feature_crop is not None:
            self._values["feature_crop"] = feature_crop
        if fit_and_fill is not None:
            self._values["fit_and_fill"] = fit_and_fill
        if goop is not None:
            self._values["goop"] = goop
        if grayscale is not None:
            self._values["grayscale"] = grayscale
        if hsl is not None:
            self._values["hsl"] = hsl
        if hsv is not None:
            self._values["hsv"] = hsv
        if if_dimension is not None:
            self._values["if_dimension"] = if_dimension
        if if_orientation is not None:
            self._values["if_orientation"] = if_orientation
        if im_query is not None:
            self._values["im_query"] = im_query
        if max_colors is not None:
            self._values["max_colors"] = max_colors
        if mirror is not None:
            self._values["mirror"] = mirror
        if mono_hue is not None:
            self._values["mono_hue"] = mono_hue
        if opacity is not None:
            self._values["opacity"] = opacity
        if region_of_interest_crop is not None:
            self._values["region_of_interest_crop"] = region_of_interest_crop
        if relative_crop is not None:
            self._values["relative_crop"] = relative_crop
        if remove_color is not None:
            self._values["remove_color"] = remove_color
        if resize is not None:
            self._values["resize"] = resize
        if rotate is not None:
            self._values["rotate"] = rotate
        if scale is not None:
            self._values["scale"] = scale
        if shear is not None:
            self._values["shear"] = shear
        if trim is not None:
            self._values["trim"] = trim
        if unsharp_mask is not None:
            self._values["unsharp_mask"] = unsharp_mask

    @builtins.property
    def append(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitAppend"]]]:
        '''append block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        '''
        result = self._values.get("append")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitAppend"]]], result)

    @builtins.property
    def aspect_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitAspectCrop"]]]:
        '''aspect_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        '''
        result = self._values.get("aspect_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitAspectCrop"]]], result)

    @builtins.property
    def background_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitBackgroundColor"]]]:
        '''background_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        '''
        result = self._values.get("background_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitBackgroundColor"]]], result)

    @builtins.property
    def blur(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitBlur"]]]:
        '''blur block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        '''
        result = self._values.get("blur")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitBlur"]]], result)

    @builtins.property
    def chroma_key(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitChromaKey"]]]:
        '''chroma_key block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        '''
        result = self._values.get("chroma_key")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitChromaKey"]]], result)

    @builtins.property
    def composite(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitComposite"]]]:
        '''composite block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        '''
        result = self._values.get("composite")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitComposite"]]], result)

    @builtins.property
    def compound(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitCompound"]]]:
        '''compound block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        '''
        result = self._values.get("compound")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitCompound"]]], result)

    @builtins.property
    def contrast(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitContrast"]]]:
        '''contrast block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitContrast"]]], result)

    @builtins.property
    def crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitCrop"]]]:
        '''crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        '''
        result = self._values.get("crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitCrop"]]], result)

    @builtins.property
    def face_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitFaceCrop"]]]:
        '''face_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        '''
        result = self._values.get("face_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitFaceCrop"]]], result)

    @builtins.property
    def feature_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitFeatureCrop"]]]:
        '''feature_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        '''
        result = self._values.get("feature_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitFeatureCrop"]]], result)

    @builtins.property
    def fit_and_fill(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitFitAndFill"]]]:
        '''fit_and_fill block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        '''
        result = self._values.get("fit_and_fill")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitFitAndFill"]]], result)

    @builtins.property
    def goop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitGoop"]]]:
        '''goop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        '''
        result = self._values.get("goop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitGoop"]]], result)

    @builtins.property
    def grayscale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitGrayscale"]]]:
        '''grayscale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        '''
        result = self._values.get("grayscale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitGrayscale"]]], result)

    @builtins.property
    def hsl(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitHsl"]]]:
        '''hsl block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        '''
        result = self._values.get("hsl")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitHsl"]]], result)

    @builtins.property
    def hsv(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitHsv"]]]:
        '''hsv block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        '''
        result = self._values.get("hsv")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitHsv"]]], result)

    @builtins.property
    def if_dimension(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfDimension"]]]:
        '''if_dimension block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        '''
        result = self._values.get("if_dimension")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfDimension"]]], result)

    @builtins.property
    def if_orientation(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfOrientation"]]]:
        '''if_orientation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        '''
        result = self._values.get("if_orientation")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfOrientation"]]], result)

    @builtins.property
    def im_query(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitImQuery"]]]:
        '''im_query block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        '''
        result = self._values.get("im_query")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitImQuery"]]], result)

    @builtins.property
    def max_colors(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitMaxColors"]]]:
        '''max_colors block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        '''
        result = self._values.get("max_colors")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitMaxColors"]]], result)

    @builtins.property
    def mirror(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitMirror"]]]:
        '''mirror block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        '''
        result = self._values.get("mirror")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitMirror"]]], result)

    @builtins.property
    def mono_hue(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitMonoHue"]]]:
        '''mono_hue block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        '''
        result = self._values.get("mono_hue")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitMonoHue"]]], result)

    @builtins.property
    def opacity(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitOpacity"]]]:
        '''opacity block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitOpacity"]]], result)

    @builtins.property
    def region_of_interest_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitRegionOfInterestCrop"]]]:
        '''region_of_interest_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        '''
        result = self._values.get("region_of_interest_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitRegionOfInterestCrop"]]], result)

    @builtins.property
    def relative_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitRelativeCrop"]]]:
        '''relative_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        '''
        result = self._values.get("relative_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitRelativeCrop"]]], result)

    @builtins.property
    def remove_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitRemoveColor"]]]:
        '''remove_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        '''
        result = self._values.get("remove_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitRemoveColor"]]], result)

    @builtins.property
    def resize(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitResize"]]]:
        '''resize block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        '''
        result = self._values.get("resize")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitResize"]]], result)

    @builtins.property
    def rotate(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitRotate"]]]:
        '''rotate block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        '''
        result = self._values.get("rotate")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitRotate"]]], result)

    @builtins.property
    def scale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitScale"]]]:
        '''scale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitScale"]]], result)

    @builtins.property
    def shear(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitShear"]]]:
        '''shear block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        '''
        result = self._values.get("shear")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitShear"]]], result)

    @builtins.property
    def trim(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitTrim"]]]:
        '''trim block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        '''
        result = self._values.get("trim")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitTrim"]]], result)

    @builtins.property
    def unsharp_mask(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitUnsharpMask"]]]:
        '''unsharp_mask block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        result = self._values.get("unsharp_mask")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitUnsharpMask"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortrait(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitAppend",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_priority": "gravityPriority",
        "gravity_priority_var": "gravityPriorityVar",
        "gravity_var": "gravityVar",
        "preserve_minor_dimension": "preserveMinorDimension",
        "preserve_minor_dimension_var": "preserveMinorDimensionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitAppend:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitAppendImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_priority: typing.Optional[builtins.str] = None,
        gravity_priority_var: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        preserve_minor_dimension: typing.Optional[builtins.str] = None,
        preserve_minor_dimension_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Specifies where to place the ``image`` relative to the source image. The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_priority: Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal. The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority DataAkamaiImagingPolicyImage#gravity_priority}
        :param gravity_priority_var: Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal. The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority_var DataAkamaiImagingPolicyImage#gravity_priority_var}
        :param gravity_var: Specifies where to place the ``image`` relative to the source image. The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param preserve_minor_dimension: Whether to preserve the source image's minor dimension, ``false`` by default. The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension DataAkamaiImagingPolicyImage#preserve_minor_dimension}
        :param preserve_minor_dimension_var: Whether to preserve the source image's minor dimension, ``false`` by default. The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension_var DataAkamaiImagingPolicyImage#preserve_minor_dimension_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitAppendImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d08e752459d410de8611c4447794a51378bef4356d705b999961511da2a88bbe)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_priority", value=gravity_priority, expected_type=type_hints["gravity_priority"])
            check_type(argname="argument gravity_priority_var", value=gravity_priority_var, expected_type=type_hints["gravity_priority_var"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument preserve_minor_dimension", value=preserve_minor_dimension, expected_type=type_hints["preserve_minor_dimension"])
            check_type(argname="argument preserve_minor_dimension_var", value=preserve_minor_dimension_var, expected_type=type_hints["preserve_minor_dimension_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_priority is not None:
            self._values["gravity_priority"] = gravity_priority
        if gravity_priority_var is not None:
            self._values["gravity_priority_var"] = gravity_priority_var
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if preserve_minor_dimension is not None:
            self._values["preserve_minor_dimension"] = preserve_minor_dimension
        if preserve_minor_dimension_var is not None:
            self._values["preserve_minor_dimension_var"] = preserve_minor_dimension_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitAppendImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitAppendImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Specifies where to place the ``image`` relative to the source image.

        The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_priority(self) -> typing.Optional[builtins.str]:
        '''Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal.

        The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority DataAkamaiImagingPolicyImage#gravity_priority}
        '''
        result = self._values.get("gravity_priority")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_priority_var(self) -> typing.Optional[builtins.str]:
        '''Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal.

        The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority_var DataAkamaiImagingPolicyImage#gravity_priority_var}
        '''
        result = self._values.get("gravity_priority_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Specifies where to place the ``image`` relative to the source image.

        The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def preserve_minor_dimension(self) -> typing.Optional[builtins.str]:
        '''Whether to preserve the source image's minor dimension, ``false`` by default.

        The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension DataAkamaiImagingPolicyImage#preserve_minor_dimension}
        '''
        result = self._values.get("preserve_minor_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def preserve_minor_dimension_var(self) -> typing.Optional[builtins.str]:
        '''Whether to preserve the source image's minor dimension, ``false`` by default.

        The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension_var DataAkamaiImagingPolicyImage#preserve_minor_dimension_var}
        '''
        result = self._values.get("preserve_minor_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitAppend(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitAppendImage",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitAppendImage:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitAppendImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitAppendImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitAppendImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f284405a598a36381509677524bd3467ddbff215ce9d38c4d09e8bcde80a5b16)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitAppendImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitAppendImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitAppendImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a6ee86cf2b8bbd02c590356f9940dd1bc002ee45784898373d1cf456c944d515)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitAppendList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitAppendList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fc1ddee508a1d81835220d07d9b85814cf61276134f4fd1c95ed483f5cc3f747)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitAppendOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__049f2de6d38ecb3fbe2c0f27f15c0f9bac60c3df7bace035b01893f09f2b160b)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitAppendOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__921512722d44fe5824f9157c9081bb331f24dde56e181786a00fb4376cdff08f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c86d2e3e07a66d1441960fe33c1896da5c9526fd36fc9ee85446e3ee13f57d96)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9b30af7ac236180d97c6368c51010343dd1b543f0fcbfb77b4388864c58f7e3c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitAppend]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitAppend]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitAppend]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bd46fdc14c10a9b89ffabc1ad9a784b39359d49346fd9335fbabbd9168b223c7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitAppendOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitAppendOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__65612f5dd57be613597ca8e938a799ab39c5eb853a7f9a8580c287be1d3eedfe)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitAppendImage()

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityPriority")
    def reset_gravity_priority(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityPriority", []))

    @jsii.member(jsii_name="resetGravityPriorityVar")
    def reset_gravity_priority_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityPriorityVar", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPreserveMinorDimension")
    def reset_preserve_minor_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPreserveMinorDimension", []))

    @jsii.member(jsii_name="resetPreserveMinorDimensionVar")
    def reset_preserve_minor_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPreserveMinorDimensionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitAppendImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitAppendImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityInput")
    def gravity_priority_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityPriorityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityVarInput")
    def gravity_priority_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityPriorityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitAppendImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitAppendImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionInput")
    def preserve_minor_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "preserveMinorDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionVarInput")
    def preserve_minor_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "preserveMinorDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fd60de2698c4640a0965038a499047a7e513d08522983646baa9631f201053b0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityPriority")
    def gravity_priority(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityPriority"))

    @gravity_priority.setter
    def gravity_priority(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2c57105fb3cb70579861502ec857f6b7854abfa23059eba3eb2fd0bfc7767392)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityPriority", value)

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityVar")
    def gravity_priority_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityPriorityVar"))

    @gravity_priority_var.setter
    def gravity_priority_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5c86711c74f0df43915fc47569fbff86dbf3f31dcfd277b8bba6ad1ba6d4d85b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityPriorityVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__33392c0b8522e71a61f36ca8e342d1223f3f1d021b674933b5d0e1a31934ae73)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimension")
    def preserve_minor_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "preserveMinorDimension"))

    @preserve_minor_dimension.setter
    def preserve_minor_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cb36c6bafb3914af9ef6e5be9565add2ed2b213e6c2d8bcd7f3cf59b4b4d40ca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "preserveMinorDimension", value)

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionVar")
    def preserve_minor_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "preserveMinorDimensionVar"))

    @preserve_minor_dimension_var.setter
    def preserve_minor_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d91b742bf6609140c70cb4916f8cbb773b76b114ed99e3d075d8c2242801c744)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "preserveMinorDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitAppend]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitAppend]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitAppend]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cfb881f561b8de1115569efae11086b638a3d182cb6a784651838f231f2335aa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitAspectCrop",
    jsii_struct_bases=[],
    name_mapping={
        "allow_expansion": "allowExpansion",
        "allow_expansion_var": "allowExpansionVar",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitAspectCrop:
    def __init__(
        self,
        *,
        allow_expansion: typing.Optional[builtins.str] = None,
        allow_expansion_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_expansion: Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image. Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        :param allow_expansion_var: Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image. Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        :param height: The height term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The width term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        :param x_position: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__43f3fcf14abce9f8ee581e74e6eb7c6e1fbdb92a68a34580d928262a4fdd9495)
            check_type(argname="argument allow_expansion", value=allow_expansion, expected_type=type_hints["allow_expansion"])
            check_type(argname="argument allow_expansion_var", value=allow_expansion_var, expected_type=type_hints["allow_expansion_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if allow_expansion is not None:
            self._values["allow_expansion"] = allow_expansion
        if allow_expansion_var is not None:
            self._values["allow_expansion_var"] = allow_expansion_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def allow_expansion(self) -> typing.Optional[builtins.str]:
        '''Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image.

        Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        '''
        result = self._values.get("allow_expansion")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def allow_expansion_var(self) -> typing.Optional[builtins.str]:
        '''Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image.

        Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        '''
        result = self._values.get("allow_expansion_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitAspectCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitAspectCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitAspectCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bdc693b414207ec057a5c42aecdbfa8f41623a92de91e37399dfed3cef268352)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitAspectCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__714fd5a93f46fc9d5a915364001a14953d90337bb2c432c989ba1f004b167a77)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitAspectCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0fb698f1aabce8c1971093c49c9f68609b4dec88a4134817bb169ebcb83b3428)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3e87b2ca40f86dd1965ac7824571df0a7f71161b82826f35cf2025af1ba342a1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8e53e6706978a26d406cef2870774edf8ae6696cbf5c821b6e07ffd1856ad651)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitAspectCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitAspectCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitAspectCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e78f8a8a5bf2529049ec7c887a3ed96210005861ae9c4fe150f44cf4a39fc63)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitAspectCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitAspectCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1bee916f468f1043a7185378499fbaa0a80b40dcfc7ab4f9f78cd96a72ff2dda)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAllowExpansion")
    def reset_allow_expansion(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansion", []))

    @jsii.member(jsii_name="resetAllowExpansionVar")
    def reset_allow_expansion_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansionVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionInput")
    def allow_expansion_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVarInput")
    def allow_expansion_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansion")
    def allow_expansion(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansion"))

    @allow_expansion.setter
    def allow_expansion(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__69b8f97eb51ff6bf53f9805c6d188de2db37d4fdde71dee32c75d115b8e8b08a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansion", value)

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVar")
    def allow_expansion_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansionVar"))

    @allow_expansion_var.setter
    def allow_expansion_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f426c284e956ae654905d776f5fd671ec81cb68332d6d4979dbe5ceded1abfb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansionVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8bba5508a4197b45d095b82b9abc3c69fe059acd3cfd321890d98af318340803)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__086fa1c394e02895e9469d53ac36a6bb295853813e8159231fa0de548170ad41)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d786dc22c586b61b3a189e87acb03fe9e54d2948d5e38317570ae6f4d02e607a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__92099e9a2b346aca44fa3b45e6c31cf9fbb2359a96c1d0e43b41829618bef20d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__235cd306b354115048ce6c35cc37194f5223a5a8d2877855e482cdc2567b85fb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__573d218ffac066fcdd40c16f2a2fe128837e7dc4766c3decf523632fc63f67e4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__405f367005abd453d574657a89884003f4a801a781a9e14528448a5806ef36a0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be6a9125d35bc304282e142715d71e00539c8672d587c9543f86c710e0b6c6e4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitAspectCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitAspectCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitAspectCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9602fe266bdc1fcaf71a8d492ce41b94eeee4c0224919c1bd0b96e6dc08b6fc3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitBackgroundColor",
    jsii_struct_bases=[],
    name_mapping={"color": "color", "color_var": "colorVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitBackgroundColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__185a9e545a7f370580f240dc47c97c3f6482e040e5e0e9a4f92ef2c1aa46e110)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitBackgroundColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitBackgroundColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitBackgroundColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__774bc67ba91edc563b380e92634c73bb690a7e4b272198e9d2a2cad724648f58)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitBackgroundColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d5eb0104c3c067597685c2a60c5ecead921788e583618781b249f44f1646869f)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitBackgroundColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1980d6a401c184b56ecb18c82c86c755712f7dea6df9123e0ac92bd5d158b122)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a91e8f93ea1f0b84174ed966129bd0b6c2a1d0223b6660baaa76036a821da6dc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a996bcd5ddf4907d504d5e608fcec009baabc36f8c7a28e0fec6ee1008f23d09)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitBackgroundColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitBackgroundColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__591beb58791c353cc488e272afaf8f6bda7a9840a6e02fc4fa4c4e884f923d09)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitBackgroundColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitBackgroundColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__97a138d0a530438760865a806a9bdb45a89b6512e8e0f193773d53edf9aab055)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be0c33ef4d13319395094805ef82178ad7c88e6ff090167ee9ca2727ccd2ab76)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__97b7d362fe2dbf16aad5d4cfdc8d99d2df7710ffa408d4b4b359909e67ae9d64)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitBackgroundColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitBackgroundColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitBackgroundColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0246f5f7e19703f8dbaef8763f507c8b83abc2cdbf62f93674eabadf5386c1af)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitBlur",
    jsii_struct_bases=[],
    name_mapping={"sigma": "sigma", "sigma_var": "sigmaVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitBlur:
    def __init__(
        self,
        *,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param sigma: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9e07f0664fbf4b2864a977d6fd23cb16d7a206362654788c2bd8bdd0987e41cf)
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitBlur(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitBlurList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitBlurList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3f0290fde695a20aa8d6d925e0b6d141c16e4c1ead17d5e1b6a6a27fa78fca76)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitBlurOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__def151f0a900fae5c4a47d11b37f12efd81c1c5812168b190ac5cd5e727504a1)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitBlurOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__730e0e0e25ee17900f5872f92813654b31e86defb5327485508c6a6f251925fd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f9366d9db047dcc3f4ff2799369b8c8e290a643692cd31241f4aab3dacfe3e44)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fc3a8b72d87e6c3819aaf20d690d38da62fbe561037218f51f31c3bdc7e26fd4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitBlur]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitBlur]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c9c06d029116c1e613484697a7cfaf4015c97a479753285d6d71d75af6e57eb4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitBlurOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitBlurOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a93f7f2b693158db50ea8f92ef27a136dae0454722f500ef0351bb393cba1f9e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__24bbe21d1185671fce9376b10c8146330db46ed1845c2475c55e3f5dcff19855)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b3e34441ba855ecc7659aa0850f4b859f07514c91263b328eb0807a87e309bca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitBlur]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitBlur]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitBlur]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c8b5e60dbbd7236da8b447e429bf0b9a1993f3b05b88e4a1790a85b0f3fd8417)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitChromaKey",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_feather": "hueFeather",
        "hue_feather_var": "hueFeatherVar",
        "hue_tolerance": "hueTolerance",
        "hue_tolerance_var": "hueToleranceVar",
        "hue_var": "hueVar",
        "lightness_feather": "lightnessFeather",
        "lightness_feather_var": "lightnessFeatherVar",
        "lightness_tolerance": "lightnessTolerance",
        "lightness_tolerance_var": "lightnessToleranceVar",
        "saturation_feather": "saturationFeather",
        "saturation_feather_var": "saturationFeatherVar",
        "saturation_tolerance": "saturationTolerance",
        "saturation_tolerance_var": "saturationToleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitChromaKey:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_feather: typing.Optional[builtins.str] = None,
        hue_feather_var: typing.Optional[builtins.str] = None,
        hue_tolerance: typing.Optional[builtins.str] = None,
        hue_tolerance_var: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness_feather: typing.Optional[builtins.str] = None,
        lightness_feather_var: typing.Optional[builtins.str] = None,
        lightness_tolerance: typing.Optional[builtins.str] = None,
        lightness_tolerance_var: typing.Optional[builtins.str] = None,
        saturation_feather: typing.Optional[builtins.str] = None,
        saturation_feather_var: typing.Optional[builtins.str] = None,
        saturation_tolerance: typing.Optional[builtins.str] = None,
        saturation_tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_feather: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        :param hue_feather_var: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        :param hue_tolerance: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        :param hue_tolerance_var: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        :param hue_var: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness_feather: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        :param lightness_feather_var: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        :param lightness_tolerance: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        :param lightness_tolerance_var: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        :param saturation_feather: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        :param saturation_feather_var: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        :param saturation_tolerance: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        :param saturation_tolerance_var: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ba760bd7b9ba02badcb77b5f4306d3b588c3ea0619c66adc51db0305643aa378)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_feather", value=hue_feather, expected_type=type_hints["hue_feather"])
            check_type(argname="argument hue_feather_var", value=hue_feather_var, expected_type=type_hints["hue_feather_var"])
            check_type(argname="argument hue_tolerance", value=hue_tolerance, expected_type=type_hints["hue_tolerance"])
            check_type(argname="argument hue_tolerance_var", value=hue_tolerance_var, expected_type=type_hints["hue_tolerance_var"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness_feather", value=lightness_feather, expected_type=type_hints["lightness_feather"])
            check_type(argname="argument lightness_feather_var", value=lightness_feather_var, expected_type=type_hints["lightness_feather_var"])
            check_type(argname="argument lightness_tolerance", value=lightness_tolerance, expected_type=type_hints["lightness_tolerance"])
            check_type(argname="argument lightness_tolerance_var", value=lightness_tolerance_var, expected_type=type_hints["lightness_tolerance_var"])
            check_type(argname="argument saturation_feather", value=saturation_feather, expected_type=type_hints["saturation_feather"])
            check_type(argname="argument saturation_feather_var", value=saturation_feather_var, expected_type=type_hints["saturation_feather_var"])
            check_type(argname="argument saturation_tolerance", value=saturation_tolerance, expected_type=type_hints["saturation_tolerance"])
            check_type(argname="argument saturation_tolerance_var", value=saturation_tolerance_var, expected_type=type_hints["saturation_tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_feather is not None:
            self._values["hue_feather"] = hue_feather
        if hue_feather_var is not None:
            self._values["hue_feather_var"] = hue_feather_var
        if hue_tolerance is not None:
            self._values["hue_tolerance"] = hue_tolerance
        if hue_tolerance_var is not None:
            self._values["hue_tolerance_var"] = hue_tolerance_var
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness_feather is not None:
            self._values["lightness_feather"] = lightness_feather
        if lightness_feather_var is not None:
            self._values["lightness_feather_var"] = lightness_feather_var
        if lightness_tolerance is not None:
            self._values["lightness_tolerance"] = lightness_tolerance
        if lightness_tolerance_var is not None:
            self._values["lightness_tolerance_var"] = lightness_tolerance_var
        if saturation_feather is not None:
            self._values["saturation_feather"] = saturation_feather
        if saturation_feather_var is not None:
            self._values["saturation_feather_var"] = saturation_feather_var
        if saturation_tolerance is not None:
            self._values["saturation_tolerance"] = saturation_tolerance
        if saturation_tolerance_var is not None:
            self._values["saturation_tolerance_var"] = saturation_tolerance_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        '''
        result = self._values.get("hue_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        '''
        result = self._values.get("hue_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        '''
        result = self._values.get("hue_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        '''
        result = self._values.get("hue_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        '''
        result = self._values.get("lightness_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        '''
        result = self._values.get("lightness_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        '''
        result = self._values.get("lightness_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        '''
        result = self._values.get("lightness_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        '''
        result = self._values.get("saturation_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        '''
        result = self._values.get("saturation_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        '''
        result = self._values.get("saturation_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        result = self._values.get("saturation_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitChromaKey(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitChromaKeyList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitChromaKeyList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ebe0045963ff1aac986af53e433aedd0ea5ad3016e77ee674fbde4189b6062c7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitChromaKeyOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7beaf3480718f7a847f8fc0b2542f0d00cb67fa07ce42f08343a65448b536943)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitChromaKeyOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0d32958768bf98604965a7f5805d1412d89d3bd2d91efc39e9e2036f85f71cab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5c0371bb40149a56d27833005a274afa40dd0b59a99a8d80a785728bdb8bc124)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c71b3a4b57ab1a42a25a69612802128f393661679d1ca39d2d860678c3c1c333)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitChromaKey]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitChromaKey]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__caf6b8e2df1550ee037223b0ff0f37abc0a40cedc3072b71278c281bd20ed3a3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitChromaKeyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitChromaKeyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__334df983b1b49865bd683cc2b4226a81a3b2c62a4f54b2b75713f812bb838a90)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueFeather")
    def reset_hue_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeather", []))

    @jsii.member(jsii_name="resetHueFeatherVar")
    def reset_hue_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeatherVar", []))

    @jsii.member(jsii_name="resetHueTolerance")
    def reset_hue_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueTolerance", []))

    @jsii.member(jsii_name="resetHueToleranceVar")
    def reset_hue_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueToleranceVar", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightnessFeather")
    def reset_lightness_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeather", []))

    @jsii.member(jsii_name="resetLightnessFeatherVar")
    def reset_lightness_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeatherVar", []))

    @jsii.member(jsii_name="resetLightnessTolerance")
    def reset_lightness_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessTolerance", []))

    @jsii.member(jsii_name="resetLightnessToleranceVar")
    def reset_lightness_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessToleranceVar", []))

    @jsii.member(jsii_name="resetSaturationFeather")
    def reset_saturation_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeather", []))

    @jsii.member(jsii_name="resetSaturationFeatherVar")
    def reset_saturation_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeatherVar", []))

    @jsii.member(jsii_name="resetSaturationTolerance")
    def reset_saturation_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationTolerance", []))

    @jsii.member(jsii_name="resetSaturationToleranceVar")
    def reset_saturation_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherInput")
    def hue_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVarInput")
    def hue_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceInput")
    def hue_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVarInput")
    def hue_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherInput")
    def lightness_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVarInput")
    def lightness_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceInput")
    def lightness_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVarInput")
    def lightness_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherInput")
    def saturation_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVarInput")
    def saturation_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceInput")
    def saturation_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVarInput")
    def saturation_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__85c99cf33af2ed18340fc04fe0df79c7e5d57682962f89a1e774aa39f3271386)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeather")
    def hue_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeather"))

    @hue_feather.setter
    def hue_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6a6783eb176c291aca5120a1963ecefbac1135b194817c9c42bc028987c9a686)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeather", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVar")
    def hue_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeatherVar"))

    @hue_feather_var.setter
    def hue_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__98aa39a945085c7a3f9237fa93f3d27b0927f1b440bc94aa8d2d19dad5fac9d2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueTolerance")
    def hue_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueTolerance"))

    @hue_tolerance.setter
    def hue_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__733739bc03c8bc889b1168e1928ae22cb8c551f677ae647e39b5db4405b5afdb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVar")
    def hue_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueToleranceVar"))

    @hue_tolerance_var.setter
    def hue_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__91942988d932a91bc5711d8da6693dfd5dc8157ec72646bcd2bf4cbc381a2ca0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__56d9087b2e3aed7d1cadea3494638c33750f1769186eaf62dc18b34b4ca3f1f1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeather")
    def lightness_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeather"))

    @lightness_feather.setter
    def lightness_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__41e133923baf83c04ba0529b655022162f62ba885ad0e1c6f7af850b9b577cc0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeather", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVar")
    def lightness_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeatherVar"))

    @lightness_feather_var.setter
    def lightness_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__89a136a2041fd0787236a29269a3037657cc8490dd3576607c326b486894674d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessTolerance")
    def lightness_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessTolerance"))

    @lightness_tolerance.setter
    def lightness_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b43d90d9cbaf0e42ef9c2e95b54918cb0e7d6182ec2f03ff8394820b13017215)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVar")
    def lightness_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessToleranceVar"))

    @lightness_tolerance_var.setter
    def lightness_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c9014dc337d2727e0d904bbba4a7778466aeae71ca2f92c6810fb1216111946d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeather")
    def saturation_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeather"))

    @saturation_feather.setter
    def saturation_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__534092eda5282d171cb24fe35f4dc10afa41059e0e82c314c46392d5c8bacbaf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeather", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVar")
    def saturation_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeatherVar"))

    @saturation_feather_var.setter
    def saturation_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ee0149ec0dc760c487c0b4b5a7419fb3d9d8893e34c8f8d6ddcfaf3a2102b70)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationTolerance")
    def saturation_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationTolerance"))

    @saturation_tolerance.setter
    def saturation_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1a112ad91fa362ba4bf27b19bc1b1d7d1ccb8884512a52b3ccba07c7cd61564f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVar")
    def saturation_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationToleranceVar"))

    @saturation_tolerance_var.setter
    def saturation_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5a4f17878a216420663dae1c6896fdc7c3ae75aaf0b5741fddfcdd3263a79790)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitChromaKey]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitChromaKey]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitChromaKey]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9af76bf95420d30a18ae167a3594d796cf464e5f5a651192dc2291fc0e5662b0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitComposite",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "placement": "placement",
        "placement_var": "placementVar",
        "scale": "scale",
        "scale_dimension": "scaleDimension",
        "scale_dimension_var": "scaleDimensionVar",
        "scale_var": "scaleVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitComposite:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitCompositeImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        placement: typing.Optional[builtins.str] = None,
        placement_var: typing.Optional[builtins.str] = None,
        scale: typing.Optional[builtins.str] = None,
        scale_dimension: typing.Optional[builtins.str] = None,
        scale_dimension_var: typing.Optional[builtins.str] = None,
        scale_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param placement: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        :param placement_var: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        :param scale: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param scale_dimension: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        :param scale_dimension_var: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        :param scale_var: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        :param x_position: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitCompositeImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0c95bc09830d1991409bb06e0812b654ceeaa73a38f6cf5c2dd411c919071bda)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument placement", value=placement, expected_type=type_hints["placement"])
            check_type(argname="argument placement_var", value=placement_var, expected_type=type_hints["placement_var"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument scale_dimension", value=scale_dimension, expected_type=type_hints["scale_dimension"])
            check_type(argname="argument scale_dimension_var", value=scale_dimension_var, expected_type=type_hints["scale_dimension_var"])
            check_type(argname="argument scale_var", value=scale_var, expected_type=type_hints["scale_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if placement is not None:
            self._values["placement"] = placement
        if placement_var is not None:
            self._values["placement_var"] = placement_var
        if scale is not None:
            self._values["scale"] = scale
        if scale_dimension is not None:
            self._values["scale_dimension"] = scale_dimension
        if scale_dimension_var is not None:
            self._values["scale_dimension_var"] = scale_dimension_var
        if scale_var is not None:
            self._values["scale_var"] = scale_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitCompositeImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitCompositeImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        '''
        result = self._values.get("placement")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement_var(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        '''
        result = self._values.get("placement_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        '''
        result = self._values.get("scale_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        '''
        result = self._values.get("scale_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        '''
        result = self._values.get("scale_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitComposite(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitCompositeImage",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitCompositeImage:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitCompositeImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitCompositeImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitCompositeImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e139827f1697b8578ce001ad899e5d42cdde070c2036b0281890a26382df0eef)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitCompositeImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitCompositeImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4054314d4698bf783da650c88dac1e8bbd7d5e998ecd3cf0ef103bb309ca8837)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitCompositeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitCompositeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__91ebe716e7d15eb7a14bec371b7f7c3c4d4ea96133602626d4e05533b836806a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitCompositeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d9cec7b6ab47c389cb13e240a7fc6e0bf7878f8244d46267b052c236218ab448)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitCompositeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__69411cf9a989d606dc8ebc505ace7c2157b80a1dfd581e1cc26ec3ac4ed1788c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2f3e2e838ce7d561ba206fa03d4092fa154efbb1c53dcc75dee2d4b2a08b2966)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__50d9745079d1a85561d80f3a872bb55d860e277a0116c5b6aaf5f28f19d45c4b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitComposite]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitComposite]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__08fb1edda37cf501dc4b248f82c50d6dad56fab6ce40558987ba501153f1164a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitCompositeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitCompositeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7f46fa91a4983cdfdd0a6866197cb1b55f001f1fc60f8ffacaff49fb21ad62ed)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitCompositeImage()

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPlacement")
    def reset_placement(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacement", []))

    @jsii.member(jsii_name="resetPlacementVar")
    def reset_placement_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacementVar", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetScaleDimension")
    def reset_scale_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimension", []))

    @jsii.member(jsii_name="resetScaleDimensionVar")
    def reset_scale_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimensionVar", []))

    @jsii.member(jsii_name="resetScaleVar")
    def reset_scale_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitCompositeImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitCompositeImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitCompositeImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="placementInput")
    def placement_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementInput"))

    @builtins.property
    @jsii.member(jsii_name="placementVarInput")
    def placement_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionInput")
    def scale_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVarInput")
    def scale_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleVarInput")
    def scale_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a8d3985f1c63ea7c3784578a167130bff4ed4c1668ec48ae13345769075e3b4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__396c2f69d9f91235e222537979bd505f11627b96593c44e775b8fbf2a85c6d15)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="placement")
    def placement(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placement"))

    @placement.setter
    def placement(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0693a4286b251bac28f6e5a025f1ea38b7cdc31dcc49d9ffdd3c6b07b327a58e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placement", value)

    @builtins.property
    @jsii.member(jsii_name="placementVar")
    def placement_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placementVar"))

    @placement_var.setter
    def placement_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6bef783d6add4a97d43dd6f3013f66f4b167d29a1ac3737fab7c83f8cd4fcd7c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placementVar", value)

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scale"))

    @scale.setter
    def scale(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bbcef3f2119f5a0e60564089f62c786fc261bfaa5651d53b4b2ac6388a681118)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scale", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimension")
    def scale_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimension"))

    @scale_dimension.setter
    def scale_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__42bc9200963b92bd69317e90efa2790ebf8fabd92b3917364027c7dedee50335)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimension", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVar")
    def scale_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimensionVar"))

    @scale_dimension_var.setter
    def scale_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0d306a1abfda4dcc5700956f53c88cc68ce8871a0059be466a19600c750f576f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="scaleVar")
    def scale_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleVar"))

    @scale_var.setter
    def scale_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b731dbdd7a8af9897ede9ebf8008b72e00f2267a94903de85b3d39b97401907d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e4660a6e8406c940446209267a8a9fb89fd9dd14f0c70c5935a8dc183fba8b00)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__08da77fb4641308ac2ce3ff40cb2b1e76aa8694c9f055a3bfe5c2cda0f14c163)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__986336fd64847167619cc3e2e524529822ff2fc48fb8df4b46724e799e013dad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b95d706c1fc41d6e2148e75f6cc0c4603d3f934d6d3790e911446f2efe1f2650)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitComposite]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitComposite]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitComposite]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8db234a7fccfaa9136d179b5847c15bc5d166c2bc6df573547b9883b2be5d576)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitCompound",
    jsii_struct_bases=[],
    name_mapping={"transformations": "transformations"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitCompound:
    def __init__(
        self,
        *,
        transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param transformations: transformations block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f57bae8c1ab016d22cfe7a417c08c4bd4ea69e769a27bd4267b62a9a3c2ad431)
            check_type(argname="argument transformations", value=transformations, expected_type=type_hints["transformations"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if transformations is not None:
            self._values["transformations"] = transformations

    @builtins.property
    def transformations(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitCompoundTransformations"]]]:
        '''transformations block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        result = self._values.get("transformations")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitCompoundTransformations"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitCompound(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitCompoundList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitCompoundList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__11ab919ab93c1b7ba9feac3d0fd60b0bfa909ef8b4037a2d5b162dcaf270f206)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitCompoundOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6b340e5e3950d3ab18a7799bbbff564303734854e8cc3eb2a1d1ac9349b850fb)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitCompoundOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__32fb6a1b35bc021646c58de602c4b749aeb850c246aec64a98f58a246626930f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a781e9a3d7fdfeb0f0f66762427e5ea86c47fbdda8321f2fa1c12a8198d4db8a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fdf30c7ad1f0d61e4b6636b3c696854659b89171346de34e3867863f39dce227)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitCompound]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitCompound]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c840baa9fdea0942f8f3d96039a46c119613c29532c482cc3772294342c02384)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitCompoundOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitCompoundOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9079fef1c3d955de784b640174fc6ebf336a7145eff3e7b27107275b2d517439)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformations")
    def put_transformations(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__402f435400d2fb9043a56e8bbe4709b1854b05fe7a898eb4c54262811cdca1d8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTransformations", [value]))

    @jsii.member(jsii_name="resetTransformations")
    def reset_transformations(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformations", []))

    @builtins.property
    @jsii.member(jsii_name="transformations")
    def transformations(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitCompoundTransformationsList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitCompoundTransformationsList", jsii.get(self, "transformations"))

    @builtins.property
    @jsii.member(jsii_name="transformationsInput")
    def transformations_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitCompoundTransformations"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitCompoundTransformations"]]], jsii.get(self, "transformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitCompound]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitCompound]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitCompound]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eec22fc05efbe60307c4694cab6e50a3fc56758ca74f2b2c6a6d6023b0c67715)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitCompoundTransformations",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitCompoundTransformations:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitCompoundTransformations(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitCompoundTransformationsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitCompoundTransformationsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__02d608d209a1bececd525075f7b7d8f03dd2b81c7e3de8826cfc5b80e6e27577)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitCompoundTransformationsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ea9934ed47c32717d3c8045f8346bdd494cb5632529b7f5adcaecd3614a4e3c)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitCompoundTransformationsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab7c0cdc72948525486a28a586af98ee55762f70b5e855c227dd7c74d253ba65)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fee9196cd1471c2b9f66447c1fda3d30f6310a0015cf8ee08b9186868a2372d2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea63600cdc3440b4fb8b9c0dc4432cbfb890fd13571acefad92bea8391938f53)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitCompoundTransformations]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitCompoundTransformations]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitCompoundTransformations]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0588fdb4073cbfd38437a594e43e641f741d97177070e4096394dc3841224d1f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitCompoundTransformationsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitCompoundTransformationsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__38d8cf29ac7f5a0ee4655b78a495ce7715c601e8cb8adde89f4ce49084869a64)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitCompoundTransformations]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitCompoundTransformations]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitCompoundTransformations]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__468c1fc05661686673e86422fb551f13eb78cd73d4a432de414aca28b988713d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitContrast",
    jsii_struct_bases=[],
    name_mapping={
        "brightness": "brightness",
        "brightness_var": "brightnessVar",
        "contrast": "contrast",
        "contrast_var": "contrastVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitContrast:
    def __init__(
        self,
        *,
        brightness: typing.Optional[builtins.str] = None,
        brightness_var: typing.Optional[builtins.str] = None,
        contrast: typing.Optional[builtins.str] = None,
        contrast_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param brightness: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        :param brightness_var: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        :param contrast: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param contrast_var: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a2a8c88aafe56bb2f4a3f671fc7c2ff0e01b51241edbdfd0c502397fefbe7760)
            check_type(argname="argument brightness", value=brightness, expected_type=type_hints["brightness"])
            check_type(argname="argument brightness_var", value=brightness_var, expected_type=type_hints["brightness_var"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument contrast_var", value=contrast_var, expected_type=type_hints["contrast_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if brightness is not None:
            self._values["brightness"] = brightness
        if brightness_var is not None:
            self._values["brightness_var"] = brightness_var
        if contrast is not None:
            self._values["contrast"] = contrast
        if contrast_var is not None:
            self._values["contrast_var"] = contrast_var

    @builtins.property
    def brightness(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        '''
        result = self._values.get("brightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def brightness_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        '''
        result = self._values.get("brightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        result = self._values.get("contrast_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitContrast(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitContrastList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitContrastList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__38f989e23c0609425a4f28cc4e5edda69f9edd9eda3750ab4b10399100d50203)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitContrastOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__58077d1eb47df72fd69ba3ee29f4850fe68f3bd5f7f1e925537e0d9495041675)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitContrastOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3e39a689572b89c45806c195938725042944219dc2e0b58e801f1cad24e32af2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3c335d4cbe79a8edcbe6bc8fd57a918bb4b4fcd97d4451b52a74874d1660132d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2e4e2095064cc6f91c8e2b7c0f3b2abb45246f369777a1c4f95ad5b5bb221b72)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitContrast]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitContrast]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dc1a2b80748cc935536273a6b8ab229187764392beb01192db853c02156b926a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitContrastOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitContrastOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8f886cdfd2a400a756fca772ac12307762a03da07fff4dafb19d864b7887bcb0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetBrightness")
    def reset_brightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightness", []))

    @jsii.member(jsii_name="resetBrightnessVar")
    def reset_brightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightnessVar", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetContrastVar")
    def reset_contrast_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrastVar", []))

    @builtins.property
    @jsii.member(jsii_name="brightnessInput")
    def brightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="brightnessVarInput")
    def brightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastVarInput")
    def contrast_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="brightness")
    def brightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightness"))

    @brightness.setter
    def brightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__45592a0ba5d1a9b826aaaba44ad1a3e8ffb33fec37562afa4a02f3ca89be1c4c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightness", value)

    @builtins.property
    @jsii.member(jsii_name="brightnessVar")
    def brightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightnessVar"))

    @brightness_var.setter
    def brightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__68daf245a48e32d56acd24e0b75852eb7400e1b01be8b19c411ec2a9fcfdbadf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrast"))

    @contrast.setter
    def contrast(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0d40e278564f5724b878f8a89810c8a8a354f6df0ef074a2874035b52a5db3d8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrast", value)

    @builtins.property
    @jsii.member(jsii_name="contrastVar")
    def contrast_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrastVar"))

    @contrast_var.setter
    def contrast_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__22baa40d88c01d7dd57bd2b1ab60486b78fccb505a8b2b9d5daf8cfd353dfaed)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrastVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitContrast]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitContrast]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitContrast]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3fe76df6503c84b5b5a08384c0e1b1baf1ea095c00e0ed178a6b2e375ab6fcbf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitCrop",
    jsii_struct_bases=[],
    name_mapping={
        "allow_expansion": "allowExpansion",
        "allow_expansion_var": "allowExpansionVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitCrop:
    def __init__(
        self,
        *,
        allow_expansion: typing.Optional[builtins.str] = None,
        allow_expansion_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_expansion: If cropping an area outside of the existing canvas, expands the image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        :param allow_expansion_var: If cropping an area outside of the existing canvas, expands the image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        :param gravity: Frame of reference for X and Y Positions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Frame of reference for X and Y Positions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The number of pixels to crop along the y-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The number of pixels to crop along the y-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The number of pixels to crop along the x-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The number of pixels to crop along the x-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        :param x_position: The x-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4aef3165a5f565c1bf221acd83b7619206b8afe5784026141a0c3adc46225f76)
            check_type(argname="argument allow_expansion", value=allow_expansion, expected_type=type_hints["allow_expansion"])
            check_type(argname="argument allow_expansion_var", value=allow_expansion_var, expected_type=type_hints["allow_expansion_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if allow_expansion is not None:
            self._values["allow_expansion"] = allow_expansion
        if allow_expansion_var is not None:
            self._values["allow_expansion_var"] = allow_expansion_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def allow_expansion(self) -> typing.Optional[builtins.str]:
        '''If cropping an area outside of the existing canvas, expands the image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        '''
        result = self._values.get("allow_expansion")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def allow_expansion_var(self) -> typing.Optional[builtins.str]:
        '''If cropping an area outside of the existing canvas, expands the image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        '''
        result = self._values.get("allow_expansion_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Frame of reference for X and Y Positions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Frame of reference for X and Y Positions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the y-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the y-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the x-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the x-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0825b094d49a32afe6bba3dbe38105fc82e744005186ec0ff3de733b025193b0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6075bb8fdf28e9cc85be089f6951cbf2cd7203e1378e938900791353876a5339)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a7026ab4c1e58585938a9a91039ae1aea809c5bf2d596fc8f9d79a530166d8d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5e780f52bc26a340d3d5cc12d1cca6150be48b17e980c1cfd6e356fe4521a480)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c55a523bea0e448ca7d9cc9958c4ebd28baa5673e7a062be7d4a1e7a2eea746c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__81ead6474810f3bc0aa121bf99f3c8a309deb75ee74a5ff378fe0407385cad55)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a43ce9a76c8fd3646cd1a863b93e3519f91b29fc1a0a2b0bf7e6043daf854b38)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAllowExpansion")
    def reset_allow_expansion(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansion", []))

    @jsii.member(jsii_name="resetAllowExpansionVar")
    def reset_allow_expansion_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansionVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionInput")
    def allow_expansion_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVarInput")
    def allow_expansion_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansion")
    def allow_expansion(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansion"))

    @allow_expansion.setter
    def allow_expansion(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f4c0557047cf96c660bfea43328ad3bba50196868852f3d3eb3dcff77cb8633c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansion", value)

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVar")
    def allow_expansion_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansionVar"))

    @allow_expansion_var.setter
    def allow_expansion_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ca7ea62b5f403bc06d794de639d645e15626722e78a2561ecbf9236a8a6d6c30)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansionVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a4f0fcbe543e4f8e6f3317e9a0cf10b4912c577d287b84279911f1471d82572)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ced8c33ef5f9630bacfd6dbbd581ff0453dd028b335ac5b8e44bbfc6a0176304)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e06859ea872fdd2078d7a2290c5563920db29372bc8142b20425508f79954128)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ae7d36f0b9b28fe2d89a08156732f586f9cb75f537984959d68dd2c2e5095e30)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__70011c8f8b337a83d415027142ca1e785b8506779882e3f2f16aeefc02b3cd3d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c931e35561584a4c053b3d04a6fa6bd28d7c93ab509b2c7fc66e444068f640ed)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c7ecac83f56c26a387ccb18c3098a06bd9c221fd3a13169015aa4df9d30e8ede)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e17ea5e52ef4695f532c5f00db492fde306bc56ad2e5dd9b4f03090924b726d6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__35248726141ef72510c5e78c3ee118d344aee47a768716808008754a83261de3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__96e297213135e136f63f37340b8d8ea9c0eef2dd3fadccff0a7c92c90f42e718)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__07d1849dfc5d34e7e1393a814ce8b59836f989917cf14e04e6c14f70a3719ae0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitFaceCrop",
    jsii_struct_bases=[],
    name_mapping={
        "algorithm": "algorithm",
        "algorithm_var": "algorithmVar",
        "confidence": "confidence",
        "confidence_var": "confidenceVar",
        "fail_gravity": "failGravity",
        "fail_gravity_var": "failGravityVar",
        "focus": "focus",
        "focus_var": "focusVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "padding": "padding",
        "padding_var": "paddingVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitFaceCrop:
    def __init__(
        self,
        *,
        algorithm: typing.Optional[builtins.str] = None,
        algorithm_var: typing.Optional[builtins.str] = None,
        confidence: typing.Optional[builtins.str] = None,
        confidence_var: typing.Optional[builtins.str] = None,
        fail_gravity: typing.Optional[builtins.str] = None,
        fail_gravity_var: typing.Optional[builtins.str] = None,
        focus: typing.Optional[builtins.str] = None,
        focus_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param algorithm: Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm DataAkamaiImagingPolicyImage#algorithm}
        :param algorithm_var: Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm_var DataAkamaiImagingPolicyImage#algorithm_var}
        :param confidence: With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image. Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence DataAkamaiImagingPolicyImage#confidence}
        :param confidence_var: With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image. Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence_var DataAkamaiImagingPolicyImage#confidence_var}
        :param fail_gravity: Controls placement of the crop if Image and Video Manager does not detect any faces in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        :param fail_gravity_var: Controls placement of the crop if Image and Video Manager does not detect any faces in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        :param focus: Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus DataAkamaiImagingPolicyImage#focus}
        :param focus_var: Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus_var DataAkamaiImagingPolicyImage#focus_var}
        :param gravity: Controls placement of the crop. Directions are relative to the face(s) plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Controls placement of the crop. Directions are relative to the face(s) plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param padding: The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        :param style: Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5432420cb35bf2de7f93f7a89751b56d4b10469cf2ba9000989a3994f53f8cc7)
            check_type(argname="argument algorithm", value=algorithm, expected_type=type_hints["algorithm"])
            check_type(argname="argument algorithm_var", value=algorithm_var, expected_type=type_hints["algorithm_var"])
            check_type(argname="argument confidence", value=confidence, expected_type=type_hints["confidence"])
            check_type(argname="argument confidence_var", value=confidence_var, expected_type=type_hints["confidence_var"])
            check_type(argname="argument fail_gravity", value=fail_gravity, expected_type=type_hints["fail_gravity"])
            check_type(argname="argument fail_gravity_var", value=fail_gravity_var, expected_type=type_hints["fail_gravity_var"])
            check_type(argname="argument focus", value=focus, expected_type=type_hints["focus"])
            check_type(argname="argument focus_var", value=focus_var, expected_type=type_hints["focus_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if algorithm is not None:
            self._values["algorithm"] = algorithm
        if algorithm_var is not None:
            self._values["algorithm_var"] = algorithm_var
        if confidence is not None:
            self._values["confidence"] = confidence
        if confidence_var is not None:
            self._values["confidence_var"] = confidence_var
        if fail_gravity is not None:
            self._values["fail_gravity"] = fail_gravity
        if fail_gravity_var is not None:
            self._values["fail_gravity_var"] = fail_gravity_var
        if focus is not None:
            self._values["focus"] = focus
        if focus_var is not None:
            self._values["focus_var"] = focus_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def algorithm(self) -> typing.Optional[builtins.str]:
        '''Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm DataAkamaiImagingPolicyImage#algorithm}
        '''
        result = self._values.get("algorithm")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def algorithm_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm_var DataAkamaiImagingPolicyImage#algorithm_var}
        '''
        result = self._values.get("algorithm_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def confidence(self) -> typing.Optional[builtins.str]:
        '''With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image.

        Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence DataAkamaiImagingPolicyImage#confidence}
        '''
        result = self._values.get("confidence")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def confidence_var(self) -> typing.Optional[builtins.str]:
        '''With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image.

        Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence_var DataAkamaiImagingPolicyImage#confidence_var}
        '''
        result = self._values.get("confidence_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any faces in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        '''
        result = self._values.get("fail_gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any faces in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        '''
        result = self._values.get("fail_gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def focus(self) -> typing.Optional[builtins.str]:
        '''Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus DataAkamaiImagingPolicyImage#focus}
        '''
        result = self._values.get("focus")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def focus_var(self) -> typing.Optional[builtins.str]:
        '''Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus_var DataAkamaiImagingPolicyImage#focus_var}
        '''
        result = self._values.get("focus_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the face(s) plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the face(s) plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitFaceCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitFaceCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitFaceCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3b6db8a262c94bf02ef7e43f9b0fb4623862679026c8dcfb40495ae9db4eb88f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitFaceCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f929b76e68c76edbaf058d7ec69c2a9b9e9852859ebf1951a5cec48a59e5201c)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitFaceCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8ca9f8478330e24d43ea148aa0e4c0a34f6792a0c3a1e030081fb6192c83da01)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc12040e109edbc9ec0a5341949224ea34e8b4b0f58817ccfefbfedf6342772d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bafa45e2f36831e6069eeddb83bc2d608145da8d2887aecd30d7bee228583814)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitFaceCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitFaceCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitFaceCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f411ec1cfa7ead0bd732202f816b2e53aa7c52cac426f7ea238e4aefd9ac599)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitFaceCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitFaceCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9b41365776fc8ce14d7c34998b648f5ace04a916c11bbe215af00c0cd4e56c5c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAlgorithm")
    def reset_algorithm(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAlgorithm", []))

    @jsii.member(jsii_name="resetAlgorithmVar")
    def reset_algorithm_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAlgorithmVar", []))

    @jsii.member(jsii_name="resetConfidence")
    def reset_confidence(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetConfidence", []))

    @jsii.member(jsii_name="resetConfidenceVar")
    def reset_confidence_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetConfidenceVar", []))

    @jsii.member(jsii_name="resetFailGravity")
    def reset_fail_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravity", []))

    @jsii.member(jsii_name="resetFailGravityVar")
    def reset_fail_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravityVar", []))

    @jsii.member(jsii_name="resetFocus")
    def reset_focus(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFocus", []))

    @jsii.member(jsii_name="resetFocusVar")
    def reset_focus_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFocusVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="algorithmInput")
    def algorithm_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "algorithmInput"))

    @builtins.property
    @jsii.member(jsii_name="algorithmVarInput")
    def algorithm_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "algorithmVarInput"))

    @builtins.property
    @jsii.member(jsii_name="confidenceInput")
    def confidence_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "confidenceInput"))

    @builtins.property
    @jsii.member(jsii_name="confidenceVarInput")
    def confidence_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "confidenceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityInput")
    def fail_gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityVarInput")
    def fail_gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="focusInput")
    def focus_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "focusInput"))

    @builtins.property
    @jsii.member(jsii_name="focusVarInput")
    def focus_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "focusVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="algorithm")
    def algorithm(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "algorithm"))

    @algorithm.setter
    def algorithm(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e1832d9be1ab670f051e7310abba4195387d422869c9a47030062a940c622dee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "algorithm", value)

    @builtins.property
    @jsii.member(jsii_name="algorithmVar")
    def algorithm_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "algorithmVar"))

    @algorithm_var.setter
    def algorithm_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__830199475aca94954c4f1a666b621d32dfe3a2748fb01835ff7f45a17d147643)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "algorithmVar", value)

    @builtins.property
    @jsii.member(jsii_name="confidence")
    def confidence(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "confidence"))

    @confidence.setter
    def confidence(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bbe4377dd0dbd3e3622259b8d3e8fce59eb8330e5f37d471809d37c3c0ac1c2c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "confidence", value)

    @builtins.property
    @jsii.member(jsii_name="confidenceVar")
    def confidence_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "confidenceVar"))

    @confidence_var.setter
    def confidence_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9f00b193e8cb0c518701efcbfb4938ddb94a50c2abcf0309391c3079f8afc121)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "confidenceVar", value)

    @builtins.property
    @jsii.member(jsii_name="failGravity")
    def fail_gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravity"))

    @fail_gravity.setter
    def fail_gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a72a49b60a3da66e042c7bab322e91eb87d7f61e1d2cd0c5de59ae317addecd0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravity", value)

    @builtins.property
    @jsii.member(jsii_name="failGravityVar")
    def fail_gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravityVar"))

    @fail_gravity_var.setter
    def fail_gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__179c5701781b1eaf1b75f9976b144db26ef4dd2400c0d1cac8135024aac57bca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="focus")
    def focus(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "focus"))

    @focus.setter
    def focus(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__07299fc95f591ddb93a7e8b5a034df3b9283aba6f6fdb022b233a40f2b2fe81d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "focus", value)

    @builtins.property
    @jsii.member(jsii_name="focusVar")
    def focus_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "focusVar"))

    @focus_var.setter
    def focus_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cf9895dc43a42b9311e342affac313514b12d12facaa4966ba5999c6339a5fa1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "focusVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__69f1e3c06dcf2639568d44ccfeb8338be4f9338841eac3cfc4d66584f5e6881e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__954016e7855b575fc5e144324fbec183689a78e4b6b9fa03a0746b5796c1c46b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__531921adac5547f453bc73ae063ff2e002e2e1f8eb1e5b8add98ac1dd0aab9cc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fc92ff010ac18a0ad4d0dac32f0fa5e6f3f4e69d4d975a856fe224305cd2eea4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__024f33fc3890c31ab89d764f5ddfdd43a5850f1ff6b48d6ec9e99f56465fc03f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a4278749726cb6ae9bce102466b49422204ed45ac79824da56ec3c0292bae0b4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c952f0c77fb152b1df183901bfc411a74636157390093f1eba0a4c8e329d50be)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__beb35bb9688f9cd2c900b986b84b01fe3c7990fe07df2001dff8ae7d9cecf760)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4f7f33e491c62ac15e54f859da3b1a8e75d98620f76b8c9aa40b16ec4d108af0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__06f2ac697f5b312e1c847592e8ec792ecd0362a08102a2204086ac85eae63eb0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitFaceCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitFaceCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitFaceCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c3e3bfcb72bb1aaf71666be154c9003b2502b6c7e69ac8426e70f712fcc4436c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitFeatureCrop",
    jsii_struct_bases=[],
    name_mapping={
        "fail_gravity": "failGravity",
        "fail_gravity_var": "failGravityVar",
        "feature_radius": "featureRadius",
        "feature_radius_var": "featureRadiusVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "max_features": "maxFeatures",
        "max_features_var": "maxFeaturesVar",
        "min_feature_quality": "minFeatureQuality",
        "min_feature_quality_var": "minFeatureQualityVar",
        "padding": "padding",
        "padding_var": "paddingVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitFeatureCrop:
    def __init__(
        self,
        *,
        fail_gravity: typing.Optional[builtins.str] = None,
        fail_gravity_var: typing.Optional[builtins.str] = None,
        feature_radius: typing.Optional[builtins.str] = None,
        feature_radius_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        max_features: typing.Optional[builtins.str] = None,
        max_features_var: typing.Optional[builtins.str] = None,
        min_feature_quality: typing.Optional[builtins.str] = None,
        min_feature_quality_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fail_gravity: Controls placement of the crop if Image and Video Manager does not detect any features in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        :param fail_gravity_var: Controls placement of the crop if Image and Video Manager does not detect any features in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        :param feature_radius: The size in pixels of the important features to search for. If identified, two features never appear closer together than this value, ``8.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius DataAkamaiImagingPolicyImage#feature_radius}
        :param feature_radius_var: The size in pixels of the important features to search for. If identified, two features never appear closer together than this value, ``8.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius_var DataAkamaiImagingPolicyImage#feature_radius_var}
        :param gravity: Controls placement of the crop. Directions are relative to the region of interest plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Controls placement of the crop. Directions are relative to the region of interest plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param max_features: The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features DataAkamaiImagingPolicyImage#max_features}
        :param max_features_var: The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features_var DataAkamaiImagingPolicyImage#max_features_var}
        :param min_feature_quality: Determines the minimum quality level of the feature identified. To consider a feature important, the feature needs to surpass this value. Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality DataAkamaiImagingPolicyImage#min_feature_quality}
        :param min_feature_quality_var: Determines the minimum quality level of the feature identified. To consider a feature important, the feature needs to surpass this value. Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality_var DataAkamaiImagingPolicyImage#min_feature_quality_var}
        :param padding: Adds space around the region of interest. The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: Adds space around the region of interest. The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        :param style: Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__442954502d28f820eea1d69aefe4cad3fccf7df9c1aa339c0f9ee213457d0a8a)
            check_type(argname="argument fail_gravity", value=fail_gravity, expected_type=type_hints["fail_gravity"])
            check_type(argname="argument fail_gravity_var", value=fail_gravity_var, expected_type=type_hints["fail_gravity_var"])
            check_type(argname="argument feature_radius", value=feature_radius, expected_type=type_hints["feature_radius"])
            check_type(argname="argument feature_radius_var", value=feature_radius_var, expected_type=type_hints["feature_radius_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument max_features", value=max_features, expected_type=type_hints["max_features"])
            check_type(argname="argument max_features_var", value=max_features_var, expected_type=type_hints["max_features_var"])
            check_type(argname="argument min_feature_quality", value=min_feature_quality, expected_type=type_hints["min_feature_quality"])
            check_type(argname="argument min_feature_quality_var", value=min_feature_quality_var, expected_type=type_hints["min_feature_quality_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fail_gravity is not None:
            self._values["fail_gravity"] = fail_gravity
        if fail_gravity_var is not None:
            self._values["fail_gravity_var"] = fail_gravity_var
        if feature_radius is not None:
            self._values["feature_radius"] = feature_radius
        if feature_radius_var is not None:
            self._values["feature_radius_var"] = feature_radius_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if max_features is not None:
            self._values["max_features"] = max_features
        if max_features_var is not None:
            self._values["max_features_var"] = max_features_var
        if min_feature_quality is not None:
            self._values["min_feature_quality"] = min_feature_quality
        if min_feature_quality_var is not None:
            self._values["min_feature_quality_var"] = min_feature_quality_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def fail_gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any features in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        '''
        result = self._values.get("fail_gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any features in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        '''
        result = self._values.get("fail_gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feature_radius(self) -> typing.Optional[builtins.str]:
        '''The size in pixels of the important features to search for.

        If identified, two features never appear closer together than this value, ``8.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius DataAkamaiImagingPolicyImage#feature_radius}
        '''
        result = self._values.get("feature_radius")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feature_radius_var(self) -> typing.Optional[builtins.str]:
        '''The size in pixels of the important features to search for.

        If identified, two features never appear closer together than this value, ``8.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius_var DataAkamaiImagingPolicyImage#feature_radius_var}
        '''
        result = self._values.get("feature_radius_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the region of interest plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the region of interest plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def max_features(self) -> typing.Optional[builtins.str]:
        '''The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features DataAkamaiImagingPolicyImage#max_features}
        '''
        result = self._values.get("max_features")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def max_features_var(self) -> typing.Optional[builtins.str]:
        '''The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features_var DataAkamaiImagingPolicyImage#max_features_var}
        '''
        result = self._values.get("max_features_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def min_feature_quality(self) -> typing.Optional[builtins.str]:
        '''Determines the minimum quality level of the feature identified.

        To consider a feature important, the feature needs to surpass this value.  Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality DataAkamaiImagingPolicyImage#min_feature_quality}
        '''
        result = self._values.get("min_feature_quality")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def min_feature_quality_var(self) -> typing.Optional[builtins.str]:
        '''Determines the minimum quality level of the feature identified.

        To consider a feature important, the feature needs to surpass this value.  Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality_var DataAkamaiImagingPolicyImage#min_feature_quality_var}
        '''
        result = self._values.get("min_feature_quality_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''Adds space around the region of interest.

        The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''Adds space around the region of interest.

        The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitFeatureCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitFeatureCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitFeatureCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c0fcb245ee024f9f321e73857fb9312a769bf81e1f2520c1ced51c65a7f45ea0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitFeatureCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b816dbede46fa653cae362ae30d815ef7fca69bcc289849e7ff03d1ef2eec2e5)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitFeatureCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__53c32317e54e60f554da9bf368271f22c183043624c4d8049df9367ed3716acf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7a7547c441de3c37201868b5731cf60ece0b9d24e52d6947049206a6bfd87263)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__04026993284994c1d8b3af678ef9fd319f9bd582e203bd27511f169547638bd2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitFeatureCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitFeatureCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitFeatureCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__61a815c5891956c2a81d956eaf3324ddedeff218c61c84b8580b739f52567bac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitFeatureCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitFeatureCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4e38b052468914cbd22a616adddef693e47194715b2718fbfbb09bc5d7a94aac)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetFailGravity")
    def reset_fail_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravity", []))

    @jsii.member(jsii_name="resetFailGravityVar")
    def reset_fail_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravityVar", []))

    @jsii.member(jsii_name="resetFeatureRadius")
    def reset_feature_radius(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureRadius", []))

    @jsii.member(jsii_name="resetFeatureRadiusVar")
    def reset_feature_radius_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureRadiusVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetMaxFeatures")
    def reset_max_features(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxFeatures", []))

    @jsii.member(jsii_name="resetMaxFeaturesVar")
    def reset_max_features_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxFeaturesVar", []))

    @jsii.member(jsii_name="resetMinFeatureQuality")
    def reset_min_feature_quality(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMinFeatureQuality", []))

    @jsii.member(jsii_name="resetMinFeatureQualityVar")
    def reset_min_feature_quality_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMinFeatureQualityVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="failGravityInput")
    def fail_gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityVarInput")
    def fail_gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featureRadiusInput")
    def feature_radius_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featureRadiusInput"))

    @builtins.property
    @jsii.member(jsii_name="featureRadiusVarInput")
    def feature_radius_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featureRadiusVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesInput")
    def max_features_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "maxFeaturesInput"))

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesVarInput")
    def max_features_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "maxFeaturesVarInput"))

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityInput")
    def min_feature_quality_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "minFeatureQualityInput"))

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityVarInput")
    def min_feature_quality_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "minFeatureQualityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravity")
    def fail_gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravity"))

    @fail_gravity.setter
    def fail_gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__58e4534fb46101579cdbeebfcb3127c73fb446e7bd2745df4f7f985ed95a7bc0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravity", value)

    @builtins.property
    @jsii.member(jsii_name="failGravityVar")
    def fail_gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravityVar"))

    @fail_gravity_var.setter
    def fail_gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__50914fbb6bc216e77c6771d6d132b0649c65de215cf4e3469faf81b38aee1a4e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="featureRadius")
    def feature_radius(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featureRadius"))

    @feature_radius.setter
    def feature_radius(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8410958637c790066f1f96355d6a3bdf06afb1a875f980ccfaa65d2b64dfadfb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featureRadius", value)

    @builtins.property
    @jsii.member(jsii_name="featureRadiusVar")
    def feature_radius_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featureRadiusVar"))

    @feature_radius_var.setter
    def feature_radius_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ffb074e94fe5dc2a0f6a1e5d5a84fc013cb1e21cffe823b7d3f2e86b9a46e660)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featureRadiusVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__69bf94700d25b5bcabe4b5803648d8d5659a1cd2b756f8381bd6aca480ec2358)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__01204596bc510383d65989ad51979a45bfcb76d0bd87d5805059926c8b59c444)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1fa3e24206619cc12bce22c06672825a5f993540ef5e28f463880fb110cd319d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__83a27a6826a883d7e770b021e45a8f0fa9ed4ebf5a5e1ec1c128135f026cd695)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="maxFeatures")
    def max_features(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "maxFeatures"))

    @max_features.setter
    def max_features(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a23829001fe8e4cfdfb1d021ed0065b4d05971b9db31878518de2cfbad366966)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "maxFeatures", value)

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesVar")
    def max_features_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "maxFeaturesVar"))

    @max_features_var.setter
    def max_features_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__edd597cd18a7010fefc20c52850e33a1638d76eb4a55b0c8cafea88647989672)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "maxFeaturesVar", value)

    @builtins.property
    @jsii.member(jsii_name="minFeatureQuality")
    def min_feature_quality(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "minFeatureQuality"))

    @min_feature_quality.setter
    def min_feature_quality(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8bae826a04832193c05a2c88f7702e11e8e5bd8f16704dd3af563d9d3c7e5525)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "minFeatureQuality", value)

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityVar")
    def min_feature_quality_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "minFeatureQualityVar"))

    @min_feature_quality_var.setter
    def min_feature_quality_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0bcef8ba1f24c7d8cbb76457c07f39fc013a6439086a5f6d7ac3bb8f6fe95604)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "minFeatureQualityVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aac2b5b144c8888e1a67314cb433ae3063f267aa39b41130e72c17b622f51d75)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f7fb3798001c3de5b711ceaa6727da975145ee0c615ced24752cc7463cf15af4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b032713653b702c23b14d0eb9b22feacfd1829c44bef67eaf2973f688da1e16e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ee4677671ecec0a939e999244fb14402c266938d20e47be3075fa800972a06a2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__230e1e28072f2e34b3299b4c7aa818c89e3e4992983a93bda8a655db1c5898b7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d0f4034f7e37b1a7a16633548239ce0672228f18c8d172c92687d6c3f3755b3f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitFeatureCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitFeatureCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitFeatureCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__508abaec2aa7e2fce09357944491b523cf7d8b86d041392b880a472be7e1e048)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitFitAndFill",
    jsii_struct_bases=[],
    name_mapping={
        "fill_transformation": "fillTransformation",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitFitAndFill:
    def __init__(
        self,
        *,
        fill_transformation: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitFitAndFillFillTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fill_transformation: fill_transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_transformation DataAkamaiImagingPolicyImage#fill_transformation}
        :param height: The height value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The width value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(fill_transformation, dict):
            fill_transformation = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitFitAndFillFillTransformation(**fill_transformation)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c20845a7f8ac2b937f466a8041a68cc507e765762c1de9feefd52b12d9d7dd5a)
            check_type(argname="argument fill_transformation", value=fill_transformation, expected_type=type_hints["fill_transformation"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fill_transformation is not None:
            self._values["fill_transformation"] = fill_transformation
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def fill_transformation(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitFitAndFillFillTransformation"]:
        '''fill_transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_transformation DataAkamaiImagingPolicyImage#fill_transformation}
        '''
        result = self._values.get("fill_transformation")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitFitAndFillFillTransformation"], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitFitAndFill(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitFitAndFillFillTransformation",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitFitAndFillFillTransformation:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitFitAndFillFillTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitFitAndFillFillTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitFitAndFillFillTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2317de3a9134e75a45ad09bc9d81ee8754df8b8bf411f26b249cc4b2516f9395)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitFitAndFillFillTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitFitAndFillFillTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitFitAndFillFillTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__91040ca424c1fe4cc0df7dd19d880e52b416e9955bbf4bc03763cb305f6d2063)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitFitAndFillList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitFitAndFillList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c24dfaa65587c32a179bf0a62cb2b0592da985621ee001fe0fe8a1d40f695d23)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitFitAndFillOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9412f50859a87b03d3de562ad0d30782ae6ac59360aa4cf3b2d0292de4361927)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitFitAndFillOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__41b980822ea05d4c33b03ff55384bd0ac0233fa3414c1507ff199969c7365201)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a5372fc2db279b0a63371a90bbf54a0e69e9c367385f93d0e2620760dc9523c3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e16c612133a8563c42b787b51a539a32d3df7650c75d1d67b0e2b5bd771e3232)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitFitAndFill]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitFitAndFill]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitFitAndFill]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ba106f684bead73af3cfd8c4742471c1c441bbbe7f3abd1a216a32bdb4995548)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitFitAndFillOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitFitAndFillOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3880f9d357787de82dcf830059bd0f5ea671b21a7b2e46fbd5a390eeae9e7aee)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putFillTransformation")
    def put_fill_transformation(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitFitAndFillFillTransformation()

        return typing.cast(None, jsii.invoke(self, "putFillTransformation", [value]))

    @jsii.member(jsii_name="resetFillTransformation")
    def reset_fill_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFillTransformation", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="fillTransformation")
    def fill_transformation(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitFitAndFillFillTransformationOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitFitAndFillFillTransformationOutputReference, jsii.get(self, "fillTransformation"))

    @builtins.property
    @jsii.member(jsii_name="fillTransformationInput")
    def fill_transformation_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitFitAndFillFillTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitFitAndFillFillTransformation], jsii.get(self, "fillTransformationInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__67f30a8c6496e448a5d89bb065d2f94c2ff182f8bcbdffc7e1e5260baf8c956e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f597951526b14cf152d0e7a202ef4c717ffa89f344acffdb2fe16fa66804c399)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__71099b787bf4eff679c8d51754971728fd91227e20ecf935118564e479357c0e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__219f29e3c76486b61f8103b1f4b15af3c09577cbe4eb40ffa74119d1cf03ae6c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitFitAndFill]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitFitAndFill]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitFitAndFill]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cda2b282a5bad784e963bf86d904b835ac3a2ae18ce000f9c9342ef5ba59ded5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitGoop",
    jsii_struct_bases=[],
    name_mapping={
        "chaos": "chaos",
        "chaos_var": "chaosVar",
        "density": "density",
        "density_var": "densityVar",
        "power": "power",
        "power_var": "powerVar",
        "seed": "seed",
        "seed_var": "seedVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitGoop:
    def __init__(
        self,
        *,
        chaos: typing.Optional[builtins.str] = None,
        chaos_var: typing.Optional[builtins.str] = None,
        density: typing.Optional[builtins.str] = None,
        density_var: typing.Optional[builtins.str] = None,
        power: typing.Optional[builtins.str] = None,
        power_var: typing.Optional[builtins.str] = None,
        seed: typing.Optional[builtins.str] = None,
        seed_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param chaos: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        :param chaos_var: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        :param density: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        :param density_var: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        :param power: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        :param power_var: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        :param seed: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        :param seed_var: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4bfe53d4020f00b366c9ee5f2ea658ab4c41b919f20690a84a8cb70cc3453644)
            check_type(argname="argument chaos", value=chaos, expected_type=type_hints["chaos"])
            check_type(argname="argument chaos_var", value=chaos_var, expected_type=type_hints["chaos_var"])
            check_type(argname="argument density", value=density, expected_type=type_hints["density"])
            check_type(argname="argument density_var", value=density_var, expected_type=type_hints["density_var"])
            check_type(argname="argument power", value=power, expected_type=type_hints["power"])
            check_type(argname="argument power_var", value=power_var, expected_type=type_hints["power_var"])
            check_type(argname="argument seed", value=seed, expected_type=type_hints["seed"])
            check_type(argname="argument seed_var", value=seed_var, expected_type=type_hints["seed_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if chaos is not None:
            self._values["chaos"] = chaos
        if chaos_var is not None:
            self._values["chaos_var"] = chaos_var
        if density is not None:
            self._values["density"] = density
        if density_var is not None:
            self._values["density_var"] = density_var
        if power is not None:
            self._values["power"] = power
        if power_var is not None:
            self._values["power_var"] = power_var
        if seed is not None:
            self._values["seed"] = seed
        if seed_var is not None:
            self._values["seed_var"] = seed_var

    @builtins.property
    def chaos(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        '''
        result = self._values.get("chaos")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def chaos_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        '''
        result = self._values.get("chaos_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        '''
        result = self._values.get("density")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density_var(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        '''
        result = self._values.get("density_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        '''
        result = self._values.get("power")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power_var(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        '''
        result = self._values.get("power_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        '''
        result = self._values.get("seed")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed_var(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        result = self._values.get("seed_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitGoop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitGoopList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitGoopList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0e94f85b4d27d84948bf0537a9542355706f1cc1f701fe23e3ab8f535fdf9df8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitGoopOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d0f58174880a62e0dfc2556bcd4092849bd8868d3d21ee2869b80be736a91a3c)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitGoopOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7ef00b2d0180ec88d93195545ed38fc22dd5e072d90f28a509ea800f5e1ff8b9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cc4c01edc320950b14f14c8d4042752cbd24d079d458c98e3e256071a6e93877)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7747404fe4f9a333ae19d4fc8055cca91d67b4426a89a20a61c105a76e662942)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitGoop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitGoop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__07bdb9788e86d4d43a36ce9fc1235e35a0b21829e0e9f7114cc72db6699c910f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitGoopOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitGoopOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fffa2365c8a03e0f5e7f563a51abd431c473ba78b15ccf8d3362443dfd1958b5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetChaos")
    def reset_chaos(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaos", []))

    @jsii.member(jsii_name="resetChaosVar")
    def reset_chaos_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaosVar", []))

    @jsii.member(jsii_name="resetDensity")
    def reset_density(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensity", []))

    @jsii.member(jsii_name="resetDensityVar")
    def reset_density_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensityVar", []))

    @jsii.member(jsii_name="resetPower")
    def reset_power(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPower", []))

    @jsii.member(jsii_name="resetPowerVar")
    def reset_power_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPowerVar", []))

    @jsii.member(jsii_name="resetSeed")
    def reset_seed(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeed", []))

    @jsii.member(jsii_name="resetSeedVar")
    def reset_seed_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeedVar", []))

    @builtins.property
    @jsii.member(jsii_name="chaosInput")
    def chaos_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosInput"))

    @builtins.property
    @jsii.member(jsii_name="chaosVarInput")
    def chaos_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosVarInput"))

    @builtins.property
    @jsii.member(jsii_name="densityInput")
    def density_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityInput"))

    @builtins.property
    @jsii.member(jsii_name="densityVarInput")
    def density_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="powerInput")
    def power_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerInput"))

    @builtins.property
    @jsii.member(jsii_name="powerVarInput")
    def power_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerVarInput"))

    @builtins.property
    @jsii.member(jsii_name="seedInput")
    def seed_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedInput"))

    @builtins.property
    @jsii.member(jsii_name="seedVarInput")
    def seed_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedVarInput"))

    @builtins.property
    @jsii.member(jsii_name="chaos")
    def chaos(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaos"))

    @chaos.setter
    def chaos(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1a9690cafcc807b1561bd1654439f6b7678d88944e9de5c294391b71780009a9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaos", value)

    @builtins.property
    @jsii.member(jsii_name="chaosVar")
    def chaos_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaosVar"))

    @chaos_var.setter
    def chaos_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__98079cdebe728646e966af574b28a2cb385eb32667841a4511896a2a2823533b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaosVar", value)

    @builtins.property
    @jsii.member(jsii_name="density")
    def density(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "density"))

    @density.setter
    def density(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f58061beeca0b5db4364b1fb0e0f7568e4b8daa0af6af41eda9efd0e1edecd09)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "density", value)

    @builtins.property
    @jsii.member(jsii_name="densityVar")
    def density_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "densityVar"))

    @density_var.setter
    def density_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__660c46f9ffcf671a8fc816d394581263c9b94e35948bc61cbf015d5c280eaa0a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "densityVar", value)

    @builtins.property
    @jsii.member(jsii_name="power")
    def power(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "power"))

    @power.setter
    def power(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__817a8bd864b9e759841d510398d2e481332fad2004a0eb284d71496288b73c06)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "power", value)

    @builtins.property
    @jsii.member(jsii_name="powerVar")
    def power_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "powerVar"))

    @power_var.setter
    def power_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__46a8454b9e75cc548a3d02ae9a551449597ff942ba04b4baca78b965154d4dcd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "powerVar", value)

    @builtins.property
    @jsii.member(jsii_name="seed")
    def seed(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seed"))

    @seed.setter
    def seed(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d3d64ef4e586e6814b9d49318f291a4932f787e59acc4d474028452b3b325ef3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seed", value)

    @builtins.property
    @jsii.member(jsii_name="seedVar")
    def seed_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seedVar"))

    @seed_var.setter
    def seed_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4d7da58005be47f72f0ca202e6c966e3635dff350a8a3c594571408837449996)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seedVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitGoop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitGoop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitGoop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b756ede84983f07de718f3c03baf6c0e23ba1684d994b704a25dd7352af15cf9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitGrayscale",
    jsii_struct_bases=[],
    name_mapping={"type": "type", "type_var": "typeVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitGrayscale:
    def __init__(
        self,
        *,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param type: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__04d6f456cf8dbf4cca15fb44c8d34c9fdf7750c74fce087dc173a2af83810822)
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitGrayscale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitGrayscaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitGrayscaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f461540edd10761db0c5898c79fee1dc30c512a09d92f4a1bcd86d95d8989645)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitGrayscaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d5b07b4180f5e896349cefa63e87577192a9ac381d86552e68e95cf39a6f2733)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitGrayscaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__25d6fdfed0c122c39b0748a32cffaaf4becb56364a8245b4f6fb7e31a48f8ba2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cf5d19951fefcf94f6a2c7292ccaf09d65318081937831b0cf9e46b2a4efa5f1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ac8779a5fbd22f9f85066b0fd45f52d15ca3ee2955e777ecd3dea76fdde59af)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitGrayscale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitGrayscale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ee12810d814f27fb376e4bf7c26a1fac89b735b9dac169208fdf3a8de8ac2c20)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitGrayscaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitGrayscaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__042648b223786ae653d1b08ce4a89b8741af45fc1913d0dc577b4215ccde0f79)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc62f32765e8db823e911db8ac81c12531ca32d5d5704d8e5bdf56d88ceb5879)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fdfa5c7ba486ff625e04bd2d1943645e4ca2f482fde66a4a5ef78b4820cd0eb8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitGrayscale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitGrayscale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitGrayscale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7c0dac323873ce68d6d342cfb2d514ee1b300ee52374362fe5dd5617126a231e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitHsl",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "lightness": "lightness",
        "lightness_var": "lightnessVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitHsl:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness: typing.Optional[builtins.str] = None,
        lightness_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        :param lightness_var: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ddb8f285f0bba2877f4ef05f1703169a737af7b341499b59a872545996cf3d9a)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness", value=lightness, expected_type=type_hints["lightness"])
            check_type(argname="argument lightness_var", value=lightness_var, expected_type=type_hints["lightness_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness is not None:
            self._values["lightness"] = lightness
        if lightness_var is not None:
            self._values["lightness_var"] = lightness_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        '''
        result = self._values.get("lightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        '''
        result = self._values.get("lightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitHsl(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitHslList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitHslList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f8bc72844b9a55c37e0ad0216f405935551b78636c16f0bf49d9fbf85e182e0b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitHslOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4b57e5ec22dd397a0bc3e1254a8c8418a9b50cba054c2749e0547978fd1ac7b2)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitHslOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8db9d86dfce9c9777e95acb7a5c068da4d072fba52c92a62e11bb0affa60c3d1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5640afef1842243611d92c457d7828a6005f5d73854ce32ca52dcbda9f24d525)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e6eb4af187e204f1bc2a86a0e80f9efac5a52046fbfdfd4bf06d11604dcb446f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitHsl]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitHsl]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__50a186637cfedb0085eada6714fafc0d291b134e233035b09cee5e9a2c2cd1da)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitHslOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitHslOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__598374315f47c2042b9192a53533987beb03a8b345068793acb37a83fcaa5d19)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightness")
    def reset_lightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightness", []))

    @jsii.member(jsii_name="resetLightnessVar")
    def reset_lightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessInput")
    def lightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessVarInput")
    def lightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__010420b5d3435b92789a386039475d54755ac60c569797daaee5b67f8f5059a2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ce724fd0995e246a3b986862b98c1fd57281254f12bd93755bc7364c7c42ac6f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightness")
    def lightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightness"))

    @lightness.setter
    def lightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d86389d5537ead3d8c2419445eb6975f6380f272a29b17acf977d562bb87680)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightness", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessVar")
    def lightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessVar"))

    @lightness_var.setter
    def lightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__02714b39ad8a0a56ce5307f6ef853c0584afec5c6eefcdb8ad99a034a1a8d6aa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__84d4eded06ba26e50a17ca0637ecd7dd94b9d099709e57ed9b642d65c93ccab1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__689449d71626b8fcf51d7bda7f317d715f81c31566e6ffe93693517a07de49b9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitHsl]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitHsl]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitHsl]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a3f40a73dfd1a498a69763de8c127eee228df43a602f0543d993f4863b9e25e0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitHsv",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitHsv:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        :param value: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d8bb166d44b6940dda4d59bfe246474df84c8bad87eba1113dcc62ce79b3d6e)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitHsv(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitHsvList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitHsvList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__763ed91e1683cd7b6a889f961e4ee8e8d7be8d8c5765527942c51f0785611bda)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitHsvOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1a6fddbfbc229f8475b587be4f0f1daacd569ebf19f6b68d5b8ca0783f196992)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitHsvOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e3334a247a40b54c9a9daaafdd6917b3e84b594972d009a99658412447ab5041)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ac16843fd3064774d2570af6b876df51dd4f0868c2cbf20fa153016f478a0ec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bd4d7ba977f8ecfcc139bdb4ed99df6f7e424afaadab67a356701a0ef225468f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitHsv]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitHsv]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ff6c764a2dc04345a125c754c3b8b0089d58635e0c927b8911dce072bf7bf74)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitHsvOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitHsvOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a439860b04cf1a5489dce42e96b4bb69c13812ffa059a070aee4a27396278e44)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4bb311ebd41c6b57ffba629998829431b5566778411de28c907c63ccac989bb8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__734c42d0678b50df182bc2ce43a5de39c5bdbbc251602cdc8e500a086b3ca071)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0920a968c047fa755baaf0e1fd18b1991a9173730142096813f5adf7e86731e8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aa4f8b55864630cbe2fdb7cc6ff83161fe0e212834bc6adf7df061fd05fe72a7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__de206f70ba6d4475a8001a0f5f21ba27798cd8e7ac617585d8d0e6178c59e66a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dabc6e03c569a58cc67e6e3064d91bc1736e717e89e69e11341e9da40b02c565)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitHsv]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitHsv]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitHsv]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__634543b05b87fb2b3bfdef5f5f552a9ddb66e019f481880e48f5e4c4fd2d5cbb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfDimension",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "dimension": "dimension",
        "dimension_var": "dimensionVar",
        "equal": "equal",
        "greater_than": "greaterThan",
        "less_than": "lessThan",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfDimension:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        dimension: typing.Optional[builtins.str] = None,
        dimension_var: typing.Optional[builtins.str] = None,
        equal: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionEqual", typing.Dict[builtins.str, typing.Any]]] = None,
        greater_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionGreaterThan", typing.Dict[builtins.str, typing.Any]]] = None,
        less_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionLessThan", typing.Dict[builtins.str, typing.Any]]] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param dimension: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        :param dimension_var: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        :param equal: equal block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        :param greater_than: greater_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        :param less_than: less_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        :param value: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionDefault(**default)
        if isinstance(equal, dict):
            equal = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionEqual(**equal)
        if isinstance(greater_than, dict):
            greater_than = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionGreaterThan(**greater_than)
        if isinstance(less_than, dict):
            less_than = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionLessThan(**less_than)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3fd28bda8fffd7302340d3d396ee35b85eb35d7d9276dec862e0dc09a5e2f856)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument dimension", value=dimension, expected_type=type_hints["dimension"])
            check_type(argname="argument dimension_var", value=dimension_var, expected_type=type_hints["dimension_var"])
            check_type(argname="argument equal", value=equal, expected_type=type_hints["equal"])
            check_type(argname="argument greater_than", value=greater_than, expected_type=type_hints["greater_than"])
            check_type(argname="argument less_than", value=less_than, expected_type=type_hints["less_than"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if dimension is not None:
            self._values["dimension"] = dimension
        if dimension_var is not None:
            self._values["dimension_var"] = dimension_var
        if equal is not None:
            self._values["equal"] = equal
        if greater_than is not None:
            self._values["greater_than"] = greater_than
        if less_than is not None:
            self._values["less_than"] = less_than
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionDefault"], result)

    @builtins.property
    def dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        '''
        result = self._values.get("dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        '''
        result = self._values.get("dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def equal(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionEqual"]:
        '''equal block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        '''
        result = self._values.get("equal")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionEqual"], result)

    @builtins.property
    def greater_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionGreaterThan"]:
        '''greater_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        '''
        result = self._values.get("greater_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionGreaterThan"], result)

    @builtins.property
    def less_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionLessThan"]:
        '''less_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        '''
        result = self._values.get("less_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionLessThan"], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfDimension(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ac6d4064fae6ac4a2c0151e348f81a35b198917745b0b9b476623c98fde4d85)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__413223f77be0f86fdc2ec7019f70895f4d69f24207f37cc4cb0b4527d2b2c5b9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionEqual",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionEqual:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionEqual(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionEqualOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionEqualOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d808103a16975bdd49f385c56f2efb0c8121443f48f41b561ceb0ef593632ff3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionEqual], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionEqual],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3fd11f450c122ff06ed8c15623abe9857605de6e7cd32e529803c1bf1a180cd7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionGreaterThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionGreaterThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionGreaterThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionGreaterThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionGreaterThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b85a08cb758c122fe08fb26866bfa427699881dda236c81c1d5d2622e9618331)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionGreaterThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionGreaterThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dae737a825b4fe1b88520ce1023a1b9c821b6a1ab3a75cadcc1e06b46ac1d42a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionLessThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionLessThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionLessThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionLessThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionLessThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb8e9db38a17bccdf768212b6d4c63a5ecf9e1d74b95a8910d7153d50adadc2a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionLessThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionLessThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1afbc6cbd67c5a02f99cc396c7cbae95f53315b41d37792a4b4dd3f21e6a8941)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__93c3074834c5e7a429256d2624e31c6a702873275c86d37d2d719b87edc629d1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__956c99dc014aa33a6d817e49fc16a1a230b8e89ae4aafe6dbc6cfca50b3fd078)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c9c96c21e7377093e87498cd14f6034f63df9c706248609837816e98cd099dcc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d554dcdf670647ea00ed20bb2344e0405c32fd535db7ff535819060d662e888)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a27121c67889b62b22ce79055738d19c85502f550ccb3f8135c3b23f6be2fb43)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfDimension]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfDimension]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ab13f618dc80c951576362eb64e2164cb3cd996504d1c97b8126a25cbffa297)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__748e63dd066c377da338ebb9434b62be0d132ea4bb7283abbc6468701df76081)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putEqual")
    def put_equal(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionEqual()

        return typing.cast(None, jsii.invoke(self, "putEqual", [value]))

    @jsii.member(jsii_name="putGreaterThan")
    def put_greater_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionGreaterThan()

        return typing.cast(None, jsii.invoke(self, "putGreaterThan", [value]))

    @jsii.member(jsii_name="putLessThan")
    def put_less_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionLessThan()

        return typing.cast(None, jsii.invoke(self, "putLessThan", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetDimension")
    def reset_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimension", []))

    @jsii.member(jsii_name="resetDimensionVar")
    def reset_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimensionVar", []))

    @jsii.member(jsii_name="resetEqual")
    def reset_equal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEqual", []))

    @jsii.member(jsii_name="resetGreaterThan")
    def reset_greater_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGreaterThan", []))

    @jsii.member(jsii_name="resetLessThan")
    def reset_less_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLessThan", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="equal")
    def equal(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionEqualOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionEqualOutputReference, jsii.get(self, "equal"))

    @builtins.property
    @jsii.member(jsii_name="greaterThan")
    def greater_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionGreaterThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionGreaterThanOutputReference, jsii.get(self, "greaterThan"))

    @builtins.property
    @jsii.member(jsii_name="lessThan")
    def less_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionLessThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionLessThanOutputReference, jsii.get(self, "lessThan"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionInput")
    def dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionVarInput")
    def dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="equalInput")
    def equal_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionEqual], jsii.get(self, "equalInput"))

    @builtins.property
    @jsii.member(jsii_name="greaterThanInput")
    def greater_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionGreaterThan], jsii.get(self, "greaterThanInput"))

    @builtins.property
    @jsii.member(jsii_name="lessThanInput")
    def less_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionLessThan], jsii.get(self, "lessThanInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="dimension")
    def dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimension"))

    @dimension.setter
    def dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__96e9a51b480a83628c44dde865f772e987fad37627bb5d508f1b82de28bdcb1f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimension", value)

    @builtins.property
    @jsii.member(jsii_name="dimensionVar")
    def dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimensionVar"))

    @dimension_var.setter
    def dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__857a2287ca91e456213d8b72c1821e97289d503ab4c0c5b840de48000632df23)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e4d7a1fc49899616068cc10822f6136a557af9e80fb58b21e6e1d501f673f4ce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8d90357c680eab4428975ffe29b1e9363f5892e1afcc64903a8432ba8507b722)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfDimension]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfDimension]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfDimension]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e012d4c74644cffa539f3093b4b6fa77457804de029f7ec1343518fe1375f207)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfOrientation",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "landscape": "landscape",
        "portrait": "portrait",
        "square": "square",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfOrientation:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        landscape: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationLandscape", typing.Dict[builtins.str, typing.Any]]] = None,
        portrait: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationPortrait", typing.Dict[builtins.str, typing.Any]]] = None,
        square: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationSquare", typing.Dict[builtins.str, typing.Any]]] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param landscape: landscape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        :param portrait: portrait block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        :param square: square block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationDefault(**default)
        if isinstance(landscape, dict):
            landscape = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationLandscape(**landscape)
        if isinstance(portrait, dict):
            portrait = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationPortrait(**portrait)
        if isinstance(square, dict):
            square = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationSquare(**square)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ff46b4bd9f18069d3e8fc735f7daaf79857a47566b27de01f09f89f045ddf56)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument landscape", value=landscape, expected_type=type_hints["landscape"])
            check_type(argname="argument portrait", value=portrait, expected_type=type_hints["portrait"])
            check_type(argname="argument square", value=square, expected_type=type_hints["square"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if landscape is not None:
            self._values["landscape"] = landscape
        if portrait is not None:
            self._values["portrait"] = portrait
        if square is not None:
            self._values["square"] = square

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationDefault"], result)

    @builtins.property
    def landscape(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationLandscape"]:
        '''landscape block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        '''
        result = self._values.get("landscape")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationLandscape"], result)

    @builtins.property
    def portrait(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationPortrait"]:
        '''portrait block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        '''
        result = self._values.get("portrait")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationPortrait"], result)

    @builtins.property
    def square(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationSquare"]:
        '''square block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        result = self._values.get("square")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationSquare"], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfOrientation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f37c998135f2620123fbc3a62c4f8e6b61c7048c34d1b66f0f2475e193fa46ff)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__99b8a9703b2c8997871673e35aa9729027fc675631aeed4bec67972d1cce660c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationLandscape",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationLandscape:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationLandscape(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationLandscapeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationLandscapeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1a83b20cf4edf3e37e6bcd90fda7b1fc2a1b434314bb4ac6332876c01eba7b57)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationLandscape], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationLandscape],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d2af2d7baefe5501c75c7f2bd40e9b0bde5cc506d924936363432dd9018f284)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c44e990eea53c9e1576f39f2336329317137cdf78108231d09770cb36b8cea87)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__067301fe21b92239aefaf9b38125733a2761e190fc867216ef26da51e42f60a7)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__191c3076ae24359bceca7ede720de1b5853988a90e82144838691d9379669770)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9477b1acaba6bbde18dc22965dd37283d0756031fb011d0502451dd614bbc1d4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8bee6fd361b1e2dd98ed9915ae2e3dfca7def4fe697f72225de3b7e8f17e277c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfOrientation]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfOrientation]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__06d5756d585d607754ddc556c67e00d6a415cff891e1b6286320fc62fac62019)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ff609e7720de1d4ceda21c298c25bbaeeda74e4747d99bc91df5ea6b3e527799)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putLandscape")
    def put_landscape(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationLandscape()

        return typing.cast(None, jsii.invoke(self, "putLandscape", [value]))

    @jsii.member(jsii_name="putPortrait")
    def put_portrait(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationPortrait()

        return typing.cast(None, jsii.invoke(self, "putPortrait", [value]))

    @jsii.member(jsii_name="putSquare")
    def put_square(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationSquare()

        return typing.cast(None, jsii.invoke(self, "putSquare", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetLandscape")
    def reset_landscape(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLandscape", []))

    @jsii.member(jsii_name="resetPortrait")
    def reset_portrait(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPortrait", []))

    @jsii.member(jsii_name="resetSquare")
    def reset_square(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSquare", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="landscape")
    def landscape(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationLandscapeOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationLandscapeOutputReference, jsii.get(self, "landscape"))

    @builtins.property
    @jsii.member(jsii_name="portrait")
    def portrait(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationPortraitOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationPortraitOutputReference", jsii.get(self, "portrait"))

    @builtins.property
    @jsii.member(jsii_name="square")
    def square(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationSquareOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationSquareOutputReference", jsii.get(self, "square"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="landscapeInput")
    def landscape_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationLandscape], jsii.get(self, "landscapeInput"))

    @builtins.property
    @jsii.member(jsii_name="portraitInput")
    def portrait_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationPortrait"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationPortrait"], jsii.get(self, "portraitInput"))

    @builtins.property
    @jsii.member(jsii_name="squareInput")
    def square_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationSquare"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationSquare"], jsii.get(self, "squareInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfOrientation]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfOrientation]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfOrientation]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d307bc0668dc91f17115e1b5a6512e52425b062237a7013d4ab5ca663ff3e28)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationPortrait",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationPortrait:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationPortrait(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationPortraitOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationPortraitOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__29597d59f10dbe49fc510bc41e740471379d94de269d44a33bcd74b4677cec75)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationPortrait]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationPortrait], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationPortrait],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac37ac2b9b4070cea6965408a8d4ca1298a775883d010ff9eb5117c8c577e462)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationSquare",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationSquare:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationSquare(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationSquareOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationSquareOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4446adf0447fa3fb9da63053bd2b434e8a733c5f15b594777959c44910cf9b2c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationSquare]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationSquare], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationSquare],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cfceef05eca8cc061bf201947598d33bb595bac31a1d6989e09238f6a9c130dd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitImQuery",
    jsii_struct_bases=[],
    name_mapping={
        "allowed_transformations": "allowedTransformations",
        "query_var": "queryVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitImQuery:
    def __init__(
        self,
        *,
        allowed_transformations: typing.Sequence[builtins.str],
        query_var: builtins.str,
    ) -> None:
        '''
        :param allowed_transformations: Specifies the transformations that can be applied using the query string parameter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allowed_transformations DataAkamaiImagingPolicyImage#allowed_transformations}
        :param query_var: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#query_var DataAkamaiImagingPolicyImage#query_var}.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c8e8519db02fa4a70aebf26f003e7b7a9be13208c388cd98809461fc7b9e4fce)
            check_type(argname="argument allowed_transformations", value=allowed_transformations, expected_type=type_hints["allowed_transformations"])
            check_type(argname="argument query_var", value=query_var, expected_type=type_hints["query_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "allowed_transformations": allowed_transformations,
            "query_var": query_var,
        }

    @builtins.property
    def allowed_transformations(self) -> typing.List[builtins.str]:
        '''Specifies the transformations that can be applied using the query string parameter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allowed_transformations DataAkamaiImagingPolicyImage#allowed_transformations}
        '''
        result = self._values.get("allowed_transformations")
        assert result is not None, "Required property 'allowed_transformations' is missing"
        return typing.cast(typing.List[builtins.str], result)

    @builtins.property
    def query_var(self) -> builtins.str:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#query_var DataAkamaiImagingPolicyImage#query_var}.'''
        result = self._values.get("query_var")
        assert result is not None, "Required property 'query_var' is missing"
        return typing.cast(builtins.str, result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitImQuery(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitImQueryList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitImQueryList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__411fc8c555486f4df24d00c9a2433196c4ae0d344acac3325f403f9e77975cb2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitImQueryOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ddcd0061f31a75803b53be718f39b708f89c514716c5572adf6eca958a177b53)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitImQueryOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__008a8a42ecb66ecd8c178cf7ad502230826b7e732fe3a76374da6d3f48faff5e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8c20f7ba8e55a727c5cfce253d740ee62cbe90608297eb72b9dd5110501acd3d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b073e260e0e3ae234ad1b6b9d91af1ce4280eee4ff43989e50f2accb3f8f9b9a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitImQuery]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitImQuery]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitImQuery]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ca47bdfb536253da1b9ae0f9dabc372b5115582f977a2728b0953316d7b43b37)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitImQueryOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitImQueryOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__705caa96c624385361bd251c3e103381d182334ef26406d4e18f4579c6a07466)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @builtins.property
    @jsii.member(jsii_name="allowedTransformationsInput")
    def allowed_transformations_input(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "allowedTransformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="queryVarInput")
    def query_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "queryVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowedTransformations")
    def allowed_transformations(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "allowedTransformations"))

    @allowed_transformations.setter
    def allowed_transformations(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a086e8dca655d7084b82fe0a237948ecbe8c1b6cc02dfdc184a5d221aa4fdab0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowedTransformations", value)

    @builtins.property
    @jsii.member(jsii_name="queryVar")
    def query_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "queryVar"))

    @query_var.setter
    def query_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ef8bff16d1aded2a04a4760cf2b1bf2fc6ef32be0b2ff6c64c2d275e1ca89d50)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "queryVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitImQuery]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitImQuery]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitImQuery]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9c4852e6ca6e4ebd9228ff4af111adbd0ed60409622aa01988c0a657c364589b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitMaxColors",
    jsii_struct_bases=[],
    name_mapping={"colors": "colors", "colors_var": "colorsVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitMaxColors:
    def __init__(
        self,
        *,
        colors: typing.Optional[builtins.str] = None,
        colors_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param colors: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        :param colors_var: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aaebad27b00fe7b79741393c60c6fa3e6b01828177296291b02bce95ab351fab)
            check_type(argname="argument colors", value=colors, expected_type=type_hints["colors"])
            check_type(argname="argument colors_var", value=colors_var, expected_type=type_hints["colors_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if colors is not None:
            self._values["colors"] = colors
        if colors_var is not None:
            self._values["colors_var"] = colors_var

    @builtins.property
    def colors(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        '''
        result = self._values.get("colors")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def colors_var(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        result = self._values.get("colors_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitMaxColors(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitMaxColorsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitMaxColorsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fc36ae3ce4396c237ce96ffdd39a7ced9508f747ac15e2326b0a4c3eec34318a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitMaxColorsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__74fd9a0087564a9d1a38992fa154b510f8fe8ccc123951f066111d2c9cc4cbe6)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitMaxColorsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b5e066efd3103856357803aa7a6a2fe21203bdf2f96dc26b76c83b920b2ec71e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fe03882d309567f69b0f27b54c451fbab334af7066f8cedfe992a335bbd1fefa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aec2f9dd682f49b6d2ab17852024d32f296a78706ce0ccfc4641ad60ff38160f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitMaxColors]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitMaxColors]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__63c819cc54ebb519f505fdb7decde4842f961199a1fa82f514bd2129768917ef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitMaxColorsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitMaxColorsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8c17a52eca7e8b82df6669cf1c7c12bfbeeb5afb65820027df0d41ea54e4a083)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColors")
    def reset_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColors", []))

    @jsii.member(jsii_name="resetColorsVar")
    def reset_colors_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorsVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorsInput")
    def colors_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsInput"))

    @builtins.property
    @jsii.member(jsii_name="colorsVarInput")
    def colors_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsVarInput"))

    @builtins.property
    @jsii.member(jsii_name="colors")
    def colors(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colors"))

    @colors.setter
    def colors(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ca3fe07601a3277303f754022570a6ed939bb1213933ff22bf1f88277e29b94d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colors", value)

    @builtins.property
    @jsii.member(jsii_name="colorsVar")
    def colors_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorsVar"))

    @colors_var.setter
    def colors_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__036b6eb906743b3940bc47f2a8a67152ed88ab48b2ba378f3cbe59e9b66285c0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorsVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitMaxColors]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitMaxColors]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitMaxColors]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__798be2a632b5b5c0681636e1738228080412c4054eb0e174e6cc3144b9d99592)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitMirror",
    jsii_struct_bases=[],
    name_mapping={
        "horizontal": "horizontal",
        "horizontal_var": "horizontalVar",
        "vertical": "vertical",
        "vertical_var": "verticalVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitMirror:
    def __init__(
        self,
        *,
        horizontal: typing.Optional[builtins.str] = None,
        horizontal_var: typing.Optional[builtins.str] = None,
        vertical: typing.Optional[builtins.str] = None,
        vertical_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param horizontal: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        :param horizontal_var: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        :param vertical: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        :param vertical_var: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__03675f09d63a25d05267adda9bde31b8f61bb96df4d365db80429957ed46aeb3)
            check_type(argname="argument horizontal", value=horizontal, expected_type=type_hints["horizontal"])
            check_type(argname="argument horizontal_var", value=horizontal_var, expected_type=type_hints["horizontal_var"])
            check_type(argname="argument vertical", value=vertical, expected_type=type_hints["vertical"])
            check_type(argname="argument vertical_var", value=vertical_var, expected_type=type_hints["vertical_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if horizontal is not None:
            self._values["horizontal"] = horizontal
        if horizontal_var is not None:
            self._values["horizontal_var"] = horizontal_var
        if vertical is not None:
            self._values["vertical"] = vertical
        if vertical_var is not None:
            self._values["vertical_var"] = vertical_var

    @builtins.property
    def horizontal(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        '''
        result = self._values.get("horizontal")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def horizontal_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        '''
        result = self._values.get("horizontal_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        '''
        result = self._values.get("vertical")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        result = self._values.get("vertical_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitMirror(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitMirrorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitMirrorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f3437ee8773f1a4c227c7465250eaeaa19821908d17827ee137885981a5e8aee)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitMirrorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__27b97de31a107c3accbe57ab9e7d878009d393131ffdbbf5e9833a15c8037532)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitMirrorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b1dc4ca634df1903b0f13ec81c45d95f96aa73be1a394560c989dc45e3894d62)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7a06dc4c19e35001d7f5c0045ef4b61fff31633f56f47122831d106521684017)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2c3e244c7745a2891dc7df10c4cb439b3de7114f3f82c923308c39c8d5a196e1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitMirror]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitMirror]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__18a89cfd4e2e009d99826852572efbb7e53ea89f2d24c5f9188323043c64c5eb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitMirrorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitMirrorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dd5e02d512c99ad1bc2b4d10d428800c17c908cc3d52c038ddce0a79f9c82749)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHorizontal")
    def reset_horizontal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontal", []))

    @jsii.member(jsii_name="resetHorizontalVar")
    def reset_horizontal_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontalVar", []))

    @jsii.member(jsii_name="resetVertical")
    def reset_vertical(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVertical", []))

    @jsii.member(jsii_name="resetVerticalVar")
    def reset_vertical_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVerticalVar", []))

    @builtins.property
    @jsii.member(jsii_name="horizontalInput")
    def horizontal_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontalVarInput")
    def horizontal_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalInput")
    def vertical_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalVarInput")
    def vertical_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontal")
    def horizontal(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontal"))

    @horizontal.setter
    def horizontal(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0cebdc97a0fa2f9198fab9dca99cea33257cb47050b199ddabd37ce9db7119cd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontal", value)

    @builtins.property
    @jsii.member(jsii_name="horizontalVar")
    def horizontal_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontalVar"))

    @horizontal_var.setter
    def horizontal_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea3623955e684dd2a62e42899a259fc6de8110ca357cc113ded1b0d7958e78b9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontalVar", value)

    @builtins.property
    @jsii.member(jsii_name="vertical")
    def vertical(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "vertical"))

    @vertical.setter
    def vertical(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__58ecf63d0f7e6793855ceab89b4fb4da5cd9849ff63f2c3c8b5ba57d28d30f75)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "vertical", value)

    @builtins.property
    @jsii.member(jsii_name="verticalVar")
    def vertical_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "verticalVar"))

    @vertical_var.setter
    def vertical_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__919e558f12ca263b6f3881e3e58c1e146baa38fccb03d59001d5f31dd694b133)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "verticalVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitMirror]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitMirror]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitMirror]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d4d70c589f2e737b9a2884dbd331b9f9e4761021457983a6dcd73daf711cbecb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitMonoHue",
    jsii_struct_bases=[],
    name_mapping={"hue": "hue", "hue_var": "hueVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitMonoHue:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__80e429253fa018840b5c75440e4303daa791cc7e9e5602fbefbb61ac315cbadd)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitMonoHue(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitMonoHueList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitMonoHueList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__32e8bcdeb6a33532ab4117133c2ed26ea43c7f73bd555b602400d1d45d95ef12)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitMonoHueOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ae45d29e4c61dddb069b5bf73872b8d54cd019e02aaf2f67975a7661909220ec)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitMonoHueOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b09f03dc629a8c395481cf88fd74d322bb667498d2891d181408c5e3a975c399)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__24eb537d70a9b88a28a16d734f72c8f5af020a23145c3fd91233a5c262b7d21a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__de8db6c90496a1471fed23750122745f7b05b75c663a3ea4a0a7122727c79b41)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitMonoHue]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitMonoHue]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f4e8601b946482a415d8f191f9b977d922cc183e6b6feb0a54a5a4a88173c17c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitMonoHueOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitMonoHueOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8db4f389a1f7b723a84f2e1844ca905917b6aaed9c7cb2646898549ca989b8c1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d098123fea4a74a32b8211a795d79d125617dcef60a93d4f6f77f417dbd9a79f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ce194cd663b107861b63503bf19fd0f078e998be64a978346c695ec098c6deeb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitMonoHue]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitMonoHue]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitMonoHue]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__631fa6aa7a774b7753fc89f07ec0aaa17567cc593f4d274b059b14c9c9bad570)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitOpacity",
    jsii_struct_bases=[],
    name_mapping={"opacity": "opacity", "opacity_var": "opacityVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitOpacity:
    def __init__(
        self,
        *,
        opacity: typing.Optional[builtins.str] = None,
        opacity_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param opacity: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param opacity_var: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__12ad4d0a511fe7065ffae13ec81de9354c3cda9b585ff1912cf86f0c723fa5d6)
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument opacity_var", value=opacity_var, expected_type=type_hints["opacity_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if opacity is not None:
            self._values["opacity"] = opacity
        if opacity_var is not None:
            self._values["opacity_var"] = opacity_var

    @builtins.property
    def opacity(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def opacity_var(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        result = self._values.get("opacity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitOpacity(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitOpacityList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitOpacityList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d1a6784cafd77b389624f987fc51b23bb323be11be7c9674dac3e7bad081312)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitOpacityOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6caa655d637517675cb6f2b82a0e744f0c8086e89ffd78a5de71a0fd14bc2c86)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitOpacityOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__81dae8065f66bc06e401c7f45a4e77ab2676d9273faa77a634cb54df972843f8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3720a6a765cefc04482415954b4f21b04068418d1409ad4f0f44b0f31ed001a6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a2e8159d692f8d4a0696a49d25a17776bf28f1b317ea5263ea28aacbe1a98009)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitOpacity]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitOpacity]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c9e76f0329784e762306ce752c13bbbd7c29ea0caed34891cfef3f74bcea5c48)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitOpacityOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitOpacityOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2da1247c617be44242032ebb6ae137840e74f54bd498e7978f8f717422befe5d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetOpacityVar")
    def reset_opacity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacityVar", []))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityVarInput")
    def opacity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacity"))

    @opacity.setter
    def opacity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd62dd9ead76f12cf6ae5365a69a9ae6e5ea443031062c7e4831287eacd869d1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacity", value)

    @builtins.property
    @jsii.member(jsii_name="opacityVar")
    def opacity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacityVar"))

    @opacity_var.setter
    def opacity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4186e81c09a645dc80b6de18f1c87cec62f7d7b7379b91868aabb6562c74ec72)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacityVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitOpacity]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitOpacity]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitOpacity]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__92913a7398f910ad3fcb57db19b503b116ddf9279be9de8eec843cdf6e281450)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8328b10642ec4ff622ccb97fbf8a90fbfc8c55a14af36ef54ee86b0d98a7ede5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putAppend")
    def put_append(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitAppend, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d7c14092e532972f0140d376cb7a09cc3867a36de68b0ec54240d0757a335685)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putAppend", [value]))

    @jsii.member(jsii_name="putAspectCrop")
    def put_aspect_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitAspectCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f23cc42eec10376d9a2ae04c16b775f66c63438ba276fd523af5fc6889f6f5f7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putAspectCrop", [value]))

    @jsii.member(jsii_name="putBackgroundColor")
    def put_background_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ce8f5988001d29a96d3fd9ef2af00dda2d4380732ceabfc5d2828bd029d1d12)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBackgroundColor", [value]))

    @jsii.member(jsii_name="putBlur")
    def put_blur(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitBlur, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fda489d1befccc3da7f5698e8e079b868e334cfdc31ccf6e6aa64aec267d26b6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBlur", [value]))

    @jsii.member(jsii_name="putChromaKey")
    def put_chroma_key(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitChromaKey, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7248178224fb7735a2b7ab2b6a0b1dcce304a89bcda2ee4c03721107398ae2ac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putChromaKey", [value]))

    @jsii.member(jsii_name="putComposite")
    def put_composite(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitComposite, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__308a5c2e0113c516602fab9eeb9831eac1b12cb1b8fe6b6254fe90b86c03922a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putComposite", [value]))

    @jsii.member(jsii_name="putCompound")
    def put_compound(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitCompound, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c146194fd662142701bedfb92eea28e6b66f20ab2473ecfea7f983b396e55af6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCompound", [value]))

    @jsii.member(jsii_name="putContrast")
    def put_contrast(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitContrast, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__968685c990a1ef6934a6e094069141e2d769e3f91054f380372023eee6a3f9b1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putContrast", [value]))

    @jsii.member(jsii_name="putCrop")
    def put_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b5a42c0458fd99dbe13eb92c24e119de86a3100f4dca3223250760ae94b4f810)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCrop", [value]))

    @jsii.member(jsii_name="putFaceCrop")
    def put_face_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitFaceCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__661d367f7765379a756d54258951c02294d215c897e111a5c33ad6de1dee23c7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFaceCrop", [value]))

    @jsii.member(jsii_name="putFeatureCrop")
    def put_feature_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitFeatureCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__78230f9e2cb2d2da11fde5175f48fea3673b2565d911955f1f92222e6e8afe53)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFeatureCrop", [value]))

    @jsii.member(jsii_name="putFitAndFill")
    def put_fit_and_fill(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitFitAndFill, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8de299306632771dc8775db870062899b30cb7497b05c99833bfb162806b6222)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFitAndFill", [value]))

    @jsii.member(jsii_name="putGoop")
    def put_goop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitGoop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__17f40990e148b8a9761434aaf4d069b968f7cafeede8bf77e0e2071d626a634a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGoop", [value]))

    @jsii.member(jsii_name="putGrayscale")
    def put_grayscale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitGrayscale, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__750a5c8c6dd3589693f26ec7f09986a81ce9f9d966007ad916452c8994e1f9f7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGrayscale", [value]))

    @jsii.member(jsii_name="putHsl")
    def put_hsl(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitHsl, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a2e0fc7eb5d5626671cd205610e912fbb4a1a06f0c7f135616a9f6dc1a58c50)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsl", [value]))

    @jsii.member(jsii_name="putHsv")
    def put_hsv(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitHsv, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1df586770cafb057eceedc228b184ba7e4920c54b0f5f5f1229ab9ee9e25682b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsv", [value]))

    @jsii.member(jsii_name="putIfDimension")
    def put_if_dimension(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfDimension, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__26184b771281db35ab73c8df9c562031d6c933ede8687a6208131b7dd61b1827)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfDimension", [value]))

    @jsii.member(jsii_name="putIfOrientation")
    def put_if_orientation(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__51845716905e864f3d84496655603063ae47fb364d885cb69094cf5f98c24cae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfOrientation", [value]))

    @jsii.member(jsii_name="putImQuery")
    def put_im_query(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitImQuery, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__69d196da6915092978f39c94960e58225b5940e186dde138aff241b14ce96e2b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putImQuery", [value]))

    @jsii.member(jsii_name="putMaxColors")
    def put_max_colors(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitMaxColors, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fb81c33a9fc8d7e2737540103d16fa38d7f0042c908eb8812a11d6548bb8c302)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMaxColors", [value]))

    @jsii.member(jsii_name="putMirror")
    def put_mirror(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitMirror, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d349a7cfbc0c3f33537e2fd1d5e03e9b94b7786599e91fade650c58c89b8e636)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMirror", [value]))

    @jsii.member(jsii_name="putMonoHue")
    def put_mono_hue(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitMonoHue, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f3817e88ef03169b31a1f885c5eaecbcf76044a0a8e5001d69ed48cddeeb23c5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMonoHue", [value]))

    @jsii.member(jsii_name="putOpacity")
    def put_opacity(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitOpacity, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__503a95d6208d9158e2c6f9c08d6088b4252206013d97db9c4ef149f8caf360f2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putOpacity", [value]))

    @jsii.member(jsii_name="putRegionOfInterestCrop")
    def put_region_of_interest_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitRegionOfInterestCrop", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e15184da16069889660c3bc3f43aaa6c9564be6737a16af9ab2fe0975f3fc523)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRegionOfInterestCrop", [value]))

    @jsii.member(jsii_name="putRelativeCrop")
    def put_relative_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitRelativeCrop", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f3db6a02340007baa2fae7893e86ae9a7342eb9bef15ed8945a0f400d39fb303)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRelativeCrop", [value]))

    @jsii.member(jsii_name="putRemoveColor")
    def put_remove_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitRemoveColor", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a84ce2bd63c89dfb0d434b7404d2b220109cb44c94a958ac8a84a0b1c4ff707b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRemoveColor", [value]))

    @jsii.member(jsii_name="putResize")
    def put_resize(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitResize", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3b26bb9537b5a42eafd97c92f432229b587ab8ab32b374423febbdb4a3fdffd6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putResize", [value]))

    @jsii.member(jsii_name="putRotate")
    def put_rotate(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitRotate", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__70f3a7053848ac861983c0a1dfdec0c771b1b0bbf23d7bd32392e3658ba1e71b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRotate", [value]))

    @jsii.member(jsii_name="putScale")
    def put_scale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitScale", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7101bc69ef1af4e9c1546df14e342e1f0688ea8bf4f32bea62c67f3da328b8c3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putScale", [value]))

    @jsii.member(jsii_name="putShear")
    def put_shear(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitShear", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__017a14fb6b9d68c4edc4e31ccf2f21dda3c923a6a02687c4c9f4479e05531c15)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putShear", [value]))

    @jsii.member(jsii_name="putTrim")
    def put_trim(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitTrim", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7134b4ddb6bca82455aabb5a9478a6674d2dcc063fbee0d03a8b576b8ea0d187)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTrim", [value]))

    @jsii.member(jsii_name="putUnsharpMask")
    def put_unsharp_mask(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitUnsharpMask", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__24457b04b8a5e78a5ee28338833865a98f0933a92f8e3b822a7c83a6cc6dfb7b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putUnsharpMask", [value]))

    @jsii.member(jsii_name="resetAppend")
    def reset_append(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAppend", []))

    @jsii.member(jsii_name="resetAspectCrop")
    def reset_aspect_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspectCrop", []))

    @jsii.member(jsii_name="resetBackgroundColor")
    def reset_background_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBackgroundColor", []))

    @jsii.member(jsii_name="resetBlur")
    def reset_blur(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBlur", []))

    @jsii.member(jsii_name="resetChromaKey")
    def reset_chroma_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChromaKey", []))

    @jsii.member(jsii_name="resetComposite")
    def reset_composite(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetComposite", []))

    @jsii.member(jsii_name="resetCompound")
    def reset_compound(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCompound", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetCrop")
    def reset_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCrop", []))

    @jsii.member(jsii_name="resetFaceCrop")
    def reset_face_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFaceCrop", []))

    @jsii.member(jsii_name="resetFeatureCrop")
    def reset_feature_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureCrop", []))

    @jsii.member(jsii_name="resetFitAndFill")
    def reset_fit_and_fill(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFitAndFill", []))

    @jsii.member(jsii_name="resetGoop")
    def reset_goop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGoop", []))

    @jsii.member(jsii_name="resetGrayscale")
    def reset_grayscale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGrayscale", []))

    @jsii.member(jsii_name="resetHsl")
    def reset_hsl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsl", []))

    @jsii.member(jsii_name="resetHsv")
    def reset_hsv(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsv", []))

    @jsii.member(jsii_name="resetIfDimension")
    def reset_if_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfDimension", []))

    @jsii.member(jsii_name="resetIfOrientation")
    def reset_if_orientation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfOrientation", []))

    @jsii.member(jsii_name="resetImQuery")
    def reset_im_query(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetImQuery", []))

    @jsii.member(jsii_name="resetMaxColors")
    def reset_max_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxColors", []))

    @jsii.member(jsii_name="resetMirror")
    def reset_mirror(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMirror", []))

    @jsii.member(jsii_name="resetMonoHue")
    def reset_mono_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonoHue", []))

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetRegionOfInterestCrop")
    def reset_region_of_interest_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRegionOfInterestCrop", []))

    @jsii.member(jsii_name="resetRelativeCrop")
    def reset_relative_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRelativeCrop", []))

    @jsii.member(jsii_name="resetRemoveColor")
    def reset_remove_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRemoveColor", []))

    @jsii.member(jsii_name="resetResize")
    def reset_resize(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetResize", []))

    @jsii.member(jsii_name="resetRotate")
    def reset_rotate(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRotate", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetShear")
    def reset_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetShear", []))

    @jsii.member(jsii_name="resetTrim")
    def reset_trim(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTrim", []))

    @jsii.member(jsii_name="resetUnsharpMask")
    def reset_unsharp_mask(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUnsharpMask", []))

    @builtins.property
    @jsii.member(jsii_name="append")
    def append(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitAppendList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitAppendList, jsii.get(self, "append"))

    @builtins.property
    @jsii.member(jsii_name="aspectCrop")
    def aspect_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitAspectCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitAspectCropList, jsii.get(self, "aspectCrop"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColor")
    def background_color(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitBackgroundColorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitBackgroundColorList, jsii.get(self, "backgroundColor"))

    @builtins.property
    @jsii.member(jsii_name="blur")
    def blur(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitBlurList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitBlurList, jsii.get(self, "blur"))

    @builtins.property
    @jsii.member(jsii_name="chromaKey")
    def chroma_key(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitChromaKeyList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitChromaKeyList, jsii.get(self, "chromaKey"))

    @builtins.property
    @jsii.member(jsii_name="composite")
    def composite(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitCompositeList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitCompositeList, jsii.get(self, "composite"))

    @builtins.property
    @jsii.member(jsii_name="compound")
    def compound(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitCompoundList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitCompoundList, jsii.get(self, "compound"))

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitContrastList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitContrastList, jsii.get(self, "contrast"))

    @builtins.property
    @jsii.member(jsii_name="crop")
    def crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitCropList, jsii.get(self, "crop"))

    @builtins.property
    @jsii.member(jsii_name="faceCrop")
    def face_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitFaceCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitFaceCropList, jsii.get(self, "faceCrop"))

    @builtins.property
    @jsii.member(jsii_name="featureCrop")
    def feature_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitFeatureCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitFeatureCropList, jsii.get(self, "featureCrop"))

    @builtins.property
    @jsii.member(jsii_name="fitAndFill")
    def fit_and_fill(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitFitAndFillList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitFitAndFillList, jsii.get(self, "fitAndFill"))

    @builtins.property
    @jsii.member(jsii_name="goop")
    def goop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitGoopList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitGoopList, jsii.get(self, "goop"))

    @builtins.property
    @jsii.member(jsii_name="grayscale")
    def grayscale(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitGrayscaleList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitGrayscaleList, jsii.get(self, "grayscale"))

    @builtins.property
    @jsii.member(jsii_name="hsl")
    def hsl(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitHslList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitHslList, jsii.get(self, "hsl"))

    @builtins.property
    @jsii.member(jsii_name="hsv")
    def hsv(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitHsvList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitHsvList, jsii.get(self, "hsv"))

    @builtins.property
    @jsii.member(jsii_name="ifDimension")
    def if_dimension(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionList, jsii.get(self, "ifDimension"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientation")
    def if_orientation(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationList, jsii.get(self, "ifOrientation"))

    @builtins.property
    @jsii.member(jsii_name="imQuery")
    def im_query(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitImQueryList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitImQueryList, jsii.get(self, "imQuery"))

    @builtins.property
    @jsii.member(jsii_name="maxColors")
    def max_colors(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitMaxColorsList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitMaxColorsList, jsii.get(self, "maxColors"))

    @builtins.property
    @jsii.member(jsii_name="mirror")
    def mirror(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitMirrorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitMirrorList, jsii.get(self, "mirror"))

    @builtins.property
    @jsii.member(jsii_name="monoHue")
    def mono_hue(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitMonoHueList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitMonoHueList, jsii.get(self, "monoHue"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitOpacityList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitOpacityList, jsii.get(self, "opacity"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestCrop")
    def region_of_interest_crop(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitRegionOfInterestCropList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitRegionOfInterestCropList", jsii.get(self, "regionOfInterestCrop"))

    @builtins.property
    @jsii.member(jsii_name="relativeCrop")
    def relative_crop(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitRelativeCropList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitRelativeCropList", jsii.get(self, "relativeCrop"))

    @builtins.property
    @jsii.member(jsii_name="removeColor")
    def remove_color(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitRemoveColorList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitRemoveColorList", jsii.get(self, "removeColor"))

    @builtins.property
    @jsii.member(jsii_name="resize")
    def resize(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitResizeList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitResizeList", jsii.get(self, "resize"))

    @builtins.property
    @jsii.member(jsii_name="rotate")
    def rotate(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitRotateList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitRotateList", jsii.get(self, "rotate"))

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitScaleList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitScaleList", jsii.get(self, "scale"))

    @builtins.property
    @jsii.member(jsii_name="shear")
    def shear(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitShearList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitShearList", jsii.get(self, "shear"))

    @builtins.property
    @jsii.member(jsii_name="trim")
    def trim(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitTrimList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitTrimList", jsii.get(self, "trim"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMask")
    def unsharp_mask(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitUnsharpMaskList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitUnsharpMaskList", jsii.get(self, "unsharpMask"))

    @builtins.property
    @jsii.member(jsii_name="appendInput")
    def append_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitAppend]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitAppend]]], jsii.get(self, "appendInput"))

    @builtins.property
    @jsii.member(jsii_name="aspectCropInput")
    def aspect_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitAspectCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitAspectCrop]]], jsii.get(self, "aspectCropInput"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColorInput")
    def background_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitBackgroundColor]]], jsii.get(self, "backgroundColorInput"))

    @builtins.property
    @jsii.member(jsii_name="blurInput")
    def blur_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitBlur]]], jsii.get(self, "blurInput"))

    @builtins.property
    @jsii.member(jsii_name="chromaKeyInput")
    def chroma_key_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitChromaKey]]], jsii.get(self, "chromaKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="compositeInput")
    def composite_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitComposite]]], jsii.get(self, "compositeInput"))

    @builtins.property
    @jsii.member(jsii_name="compoundInput")
    def compound_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitCompound]]], jsii.get(self, "compoundInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitContrast]]], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="cropInput")
    def crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitCrop]]], jsii.get(self, "cropInput"))

    @builtins.property
    @jsii.member(jsii_name="faceCropInput")
    def face_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitFaceCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitFaceCrop]]], jsii.get(self, "faceCropInput"))

    @builtins.property
    @jsii.member(jsii_name="featureCropInput")
    def feature_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitFeatureCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitFeatureCrop]]], jsii.get(self, "featureCropInput"))

    @builtins.property
    @jsii.member(jsii_name="fitAndFillInput")
    def fit_and_fill_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitFitAndFill]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitFitAndFill]]], jsii.get(self, "fitAndFillInput"))

    @builtins.property
    @jsii.member(jsii_name="goopInput")
    def goop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitGoop]]], jsii.get(self, "goopInput"))

    @builtins.property
    @jsii.member(jsii_name="grayscaleInput")
    def grayscale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitGrayscale]]], jsii.get(self, "grayscaleInput"))

    @builtins.property
    @jsii.member(jsii_name="hslInput")
    def hsl_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitHsl]]], jsii.get(self, "hslInput"))

    @builtins.property
    @jsii.member(jsii_name="hsvInput")
    def hsv_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitHsv]]], jsii.get(self, "hsvInput"))

    @builtins.property
    @jsii.member(jsii_name="ifDimensionInput")
    def if_dimension_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfDimension]]], jsii.get(self, "ifDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientationInput")
    def if_orientation_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfOrientation]]], jsii.get(self, "ifOrientationInput"))

    @builtins.property
    @jsii.member(jsii_name="imQueryInput")
    def im_query_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitImQuery]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitImQuery]]], jsii.get(self, "imQueryInput"))

    @builtins.property
    @jsii.member(jsii_name="maxColorsInput")
    def max_colors_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitMaxColors]]], jsii.get(self, "maxColorsInput"))

    @builtins.property
    @jsii.member(jsii_name="mirrorInput")
    def mirror_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitMirror]]], jsii.get(self, "mirrorInput"))

    @builtins.property
    @jsii.member(jsii_name="monoHueInput")
    def mono_hue_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitMonoHue]]], jsii.get(self, "monoHueInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitOpacity]]], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestCropInput")
    def region_of_interest_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitRegionOfInterestCrop"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitRegionOfInterestCrop"]]], jsii.get(self, "regionOfInterestCropInput"))

    @builtins.property
    @jsii.member(jsii_name="relativeCropInput")
    def relative_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitRelativeCrop"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitRelativeCrop"]]], jsii.get(self, "relativeCropInput"))

    @builtins.property
    @jsii.member(jsii_name="removeColorInput")
    def remove_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitRemoveColor"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitRemoveColor"]]], jsii.get(self, "removeColorInput"))

    @builtins.property
    @jsii.member(jsii_name="resizeInput")
    def resize_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitResize"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitResize"]]], jsii.get(self, "resizeInput"))

    @builtins.property
    @jsii.member(jsii_name="rotateInput")
    def rotate_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitRotate"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitRotate"]]], jsii.get(self, "rotateInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitScale"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitScale"]]], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="shearInput")
    def shear_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitShear"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitShear"]]], jsii.get(self, "shearInput"))

    @builtins.property
    @jsii.member(jsii_name="trimInput")
    def trim_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitTrim"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitTrim"]]], jsii.get(self, "trimInput"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMaskInput")
    def unsharp_mask_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitUnsharpMask"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitUnsharpMask"]]], jsii.get(self, "unsharpMaskInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortrait]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortrait], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortrait],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b7b68c10272b4770bc654f40362b8fc7310f353db8457e77f7b2adc327339d00)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitRegionOfInterestCrop",
    jsii_struct_bases=[],
    name_mapping={
        "region_of_interest": "regionOfInterest",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitRegionOfInterestCrop:
    def __init__(
        self,
        *,
        region_of_interest: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitRegionOfInterestCropRegionOfInterest", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param region_of_interest: region_of_interest block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest DataAkamaiImagingPolicyImage#region_of_interest}
        :param gravity: The placement of the crop area relative to the specified area of interest. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: The placement of the crop area relative to the specified area of interest. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param style: Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(region_of_interest, dict):
            region_of_interest = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitRegionOfInterestCropRegionOfInterest(**region_of_interest)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2b20cba472a9aea60ca6f056110f8f191716c289f7d2e664de1ccadf122d15fb)
            check_type(argname="argument region_of_interest", value=region_of_interest, expected_type=type_hints["region_of_interest"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "region_of_interest": region_of_interest,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def region_of_interest(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitRegionOfInterestCropRegionOfInterest":
        '''region_of_interest block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest DataAkamaiImagingPolicyImage#region_of_interest}
        '''
        result = self._values.get("region_of_interest")
        assert result is not None, "Required property 'region_of_interest' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitRegionOfInterestCropRegionOfInterest", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''The placement of the crop area relative to the specified area of interest.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''The placement of the crop area relative to the specified area of interest.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitRegionOfInterestCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitRegionOfInterestCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitRegionOfInterestCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ff5ef2e57b4408bb6087baa8f1348b253501c894f8ceacbe3cff0800f1fcf6fb)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitRegionOfInterestCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__50f07caf5e6560af1e624ba703bfaeebbd5e252495a2d1012b18ed3bb5abd01e)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitRegionOfInterestCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__10db650e3d3aecf87a4f9e8961d15d464a3c013e47ba7fba1828bd501a31bf41)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__16fc50ec5784517451ece8ba6aad5bcd268262c3a23d9f94b190c9d874b59b21)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__11db3cc565316ca7696269b0d7ba07dc0b96b4da795db32de49ea7f142d3d311)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitRegionOfInterestCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitRegionOfInterestCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitRegionOfInterestCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5557c65275e202d5467c27c3fdb3fd1eed0ab2687576c510515f1ed34749ea37)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitRegionOfInterestCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitRegionOfInterestCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__efccecebfe6ec4b7996feee0e5e5e7a7f2554e706ba47967c69ba2999413b1bb)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putRegionOfInterest")
    def put_region_of_interest(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitRegionOfInterestCropRegionOfInterest()

        return typing.cast(None, jsii.invoke(self, "putRegionOfInterest", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterest")
    def region_of_interest(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitRegionOfInterestCropRegionOfInterestOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitRegionOfInterestCropRegionOfInterestOutputReference", jsii.get(self, "regionOfInterest"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestInput")
    def region_of_interest_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitRegionOfInterestCropRegionOfInterest"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitRegionOfInterestCropRegionOfInterest"], jsii.get(self, "regionOfInterestInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7233df54c9073a2ad05227d4ede9fda3627ef1b2b9c9bdd616e2c6657c8ed91c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__417c6a596a42012136068e35843d6adb8ec75e6da2dd62dd4fd2f56b9e4c4c8c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7387de1131fbeed6f2b7a7bcd24332d851748617b12e935a151cfe034bb9bfb8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc8d00d73333ffaedba24b1665182dd7d1e8a7b4c33e51e56906625b13a2a6d3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d2d7cc4a38052d3348e6022e65a3a54d84f80591f60a390c7dee67d590daca01)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__640fe6fb22dcdd83775e36b3441e9b091f74bd439bbcf6b7406a62374b50ee6f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aadb069c3e2a03cc7084c44be019c29ed28b2def21a89d9c211a0270c4a475fa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c07f562a42ac4c56b42d5ba0f2569eb5db6ae8a2a3df1f570b1ee2eecd73b94c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitRegionOfInterestCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitRegionOfInterestCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitRegionOfInterestCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f287dc4f60913ab305b1a83784da762c0bc9bf1823c1948ae90686d036b1c2e9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitRegionOfInterestCropRegionOfInterest",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitRegionOfInterestCropRegionOfInterest:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitRegionOfInterestCropRegionOfInterest(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitRegionOfInterestCropRegionOfInterestOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitRegionOfInterestCropRegionOfInterestOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f6841a3e6baf37bb04923e0cf76f2d39ad2b6a3cc1cb0149abc30aa48e935213)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitRegionOfInterestCropRegionOfInterest]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitRegionOfInterestCropRegionOfInterest], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitRegionOfInterestCropRegionOfInterest],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f36dc4999c66b41e3b7c7ef57480568d5ea18bff9d5756612839116008cbc289)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitRelativeCrop",
    jsii_struct_bases=[],
    name_mapping={
        "east": "east",
        "east_var": "eastVar",
        "north": "north",
        "north_var": "northVar",
        "south": "south",
        "south_var": "southVar",
        "west": "west",
        "west_var": "westVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitRelativeCrop:
    def __init__(
        self,
        *,
        east: typing.Optional[builtins.str] = None,
        east_var: typing.Optional[builtins.str] = None,
        north: typing.Optional[builtins.str] = None,
        north_var: typing.Optional[builtins.str] = None,
        south: typing.Optional[builtins.str] = None,
        south_var: typing.Optional[builtins.str] = None,
        west: typing.Optional[builtins.str] = None,
        west_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param east: The number of pixels to shrink or expand the right side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east DataAkamaiImagingPolicyImage#east}
        :param east_var: The number of pixels to shrink or expand the right side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east_var DataAkamaiImagingPolicyImage#east_var}
        :param north: The number of pixels to shrink or expand the top side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north DataAkamaiImagingPolicyImage#north}
        :param north_var: The number of pixels to shrink or expand the top side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north_var DataAkamaiImagingPolicyImage#north_var}
        :param south: The number of pixels to shrink or expand the bottom side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south DataAkamaiImagingPolicyImage#south}
        :param south_var: The number of pixels to shrink or expand the bottom side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south_var DataAkamaiImagingPolicyImage#south_var}
        :param west: The number of pixels to shrink or expand the left side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west DataAkamaiImagingPolicyImage#west}
        :param west_var: The number of pixels to shrink or expand the left side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west_var DataAkamaiImagingPolicyImage#west_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__930f0f9707221986bd8f5d0a02ece61eee837843fe595a878b50b733bfb9cb63)
            check_type(argname="argument east", value=east, expected_type=type_hints["east"])
            check_type(argname="argument east_var", value=east_var, expected_type=type_hints["east_var"])
            check_type(argname="argument north", value=north, expected_type=type_hints["north"])
            check_type(argname="argument north_var", value=north_var, expected_type=type_hints["north_var"])
            check_type(argname="argument south", value=south, expected_type=type_hints["south"])
            check_type(argname="argument south_var", value=south_var, expected_type=type_hints["south_var"])
            check_type(argname="argument west", value=west, expected_type=type_hints["west"])
            check_type(argname="argument west_var", value=west_var, expected_type=type_hints["west_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if east is not None:
            self._values["east"] = east
        if east_var is not None:
            self._values["east_var"] = east_var
        if north is not None:
            self._values["north"] = north
        if north_var is not None:
            self._values["north_var"] = north_var
        if south is not None:
            self._values["south"] = south
        if south_var is not None:
            self._values["south_var"] = south_var
        if west is not None:
            self._values["west"] = west
        if west_var is not None:
            self._values["west_var"] = west_var

    @builtins.property
    def east(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the right side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east DataAkamaiImagingPolicyImage#east}
        '''
        result = self._values.get("east")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def east_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the right side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east_var DataAkamaiImagingPolicyImage#east_var}
        '''
        result = self._values.get("east_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def north(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the top side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north DataAkamaiImagingPolicyImage#north}
        '''
        result = self._values.get("north")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def north_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the top side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north_var DataAkamaiImagingPolicyImage#north_var}
        '''
        result = self._values.get("north_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def south(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the bottom side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south DataAkamaiImagingPolicyImage#south}
        '''
        result = self._values.get("south")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def south_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the bottom side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south_var DataAkamaiImagingPolicyImage#south_var}
        '''
        result = self._values.get("south_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def west(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the left side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west DataAkamaiImagingPolicyImage#west}
        '''
        result = self._values.get("west")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def west_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the left side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west_var DataAkamaiImagingPolicyImage#west_var}
        '''
        result = self._values.get("west_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitRelativeCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitRelativeCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitRelativeCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8859dcecb8c6f70068948b414f335024aad36f62a4be77b6a98e0d8bc75a3af5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitRelativeCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8521c8ff29355397a42649b658f93a48f2880e6383b09d8cc83df47a5df2e9c2)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitRelativeCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b094ca27e0d745574f22ed5bd554804c37408715a6a0b5dd98d2fb6eefca9200)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6401a1db31a941d37661c34f6b8d9d78b64c020ff638d87263f7f2c8ba667a54)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb0945338271f71995ef86f8d43ed9eb52e469d06e620b5f4766d840b6237bd9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitRelativeCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitRelativeCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitRelativeCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__48f10804ecb582b5bb855c28f9040a7487ca0e4f84bf24f8edfe5a8d465465b4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitRelativeCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitRelativeCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__74f07a52d6620cbac9f71e5d7dca4efde70ecb2c6b98b1b14228ceda51d1a74a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetEast")
    def reset_east(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEast", []))

    @jsii.member(jsii_name="resetEastVar")
    def reset_east_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEastVar", []))

    @jsii.member(jsii_name="resetNorth")
    def reset_north(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNorth", []))

    @jsii.member(jsii_name="resetNorthVar")
    def reset_north_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNorthVar", []))

    @jsii.member(jsii_name="resetSouth")
    def reset_south(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSouth", []))

    @jsii.member(jsii_name="resetSouthVar")
    def reset_south_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSouthVar", []))

    @jsii.member(jsii_name="resetWest")
    def reset_west(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWest", []))

    @jsii.member(jsii_name="resetWestVar")
    def reset_west_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWestVar", []))

    @builtins.property
    @jsii.member(jsii_name="eastInput")
    def east_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "eastInput"))

    @builtins.property
    @jsii.member(jsii_name="eastVarInput")
    def east_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "eastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="northInput")
    def north_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "northInput"))

    @builtins.property
    @jsii.member(jsii_name="northVarInput")
    def north_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "northVarInput"))

    @builtins.property
    @jsii.member(jsii_name="southInput")
    def south_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "southInput"))

    @builtins.property
    @jsii.member(jsii_name="southVarInput")
    def south_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "southVarInput"))

    @builtins.property
    @jsii.member(jsii_name="westInput")
    def west_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "westInput"))

    @builtins.property
    @jsii.member(jsii_name="westVarInput")
    def west_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "westVarInput"))

    @builtins.property
    @jsii.member(jsii_name="east")
    def east(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "east"))

    @east.setter
    def east(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a1731dc11a9f2b0a9c03f1fefda2d48cb35d7c3ca162dfe134c3c2e4749bcb3d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "east", value)

    @builtins.property
    @jsii.member(jsii_name="eastVar")
    def east_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "eastVar"))

    @east_var.setter
    def east_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0dec19342d2e4dfdf975e9d50401a3ceaed37479669ec4e2344151e4d2fae032)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "eastVar", value)

    @builtins.property
    @jsii.member(jsii_name="north")
    def north(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "north"))

    @north.setter
    def north(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7517b2b1bfe74c53d4b12c9e7745df1870275783305cf31bb9949b66705ad54b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "north", value)

    @builtins.property
    @jsii.member(jsii_name="northVar")
    def north_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "northVar"))

    @north_var.setter
    def north_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dcae4a63cc7f3c3a16860efdc0f46e49ba502abf3b9181f0b830502c35517d64)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "northVar", value)

    @builtins.property
    @jsii.member(jsii_name="south")
    def south(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "south"))

    @south.setter
    def south(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__56bfdd711e80f0aa81d6021e642d32b4231ec347fddf0c3051752e36858668f6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "south", value)

    @builtins.property
    @jsii.member(jsii_name="southVar")
    def south_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "southVar"))

    @south_var.setter
    def south_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__80478b356b88059bcc27c172ceac03012364202f9a8bfbf217b67e1038dc8530)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "southVar", value)

    @builtins.property
    @jsii.member(jsii_name="west")
    def west(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "west"))

    @west.setter
    def west(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7f4b59548228c1c216b5a6fc50c6b3f0232574519ff54d3eee2acff54d53e6c3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "west", value)

    @builtins.property
    @jsii.member(jsii_name="westVar")
    def west_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "westVar"))

    @west_var.setter
    def west_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4d2945e9c21c9e6cb0d7f7d97d8d77b13b9a0488b8a26706f1563667f8005975)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "westVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitRelativeCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitRelativeCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitRelativeCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__69d9b797fdfbe97724fe0535409c1b4b887f1bea0f02f1d1dc7ecfc1c354360e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitRemoveColor",
    jsii_struct_bases=[],
    name_mapping={
        "color": "color",
        "color_var": "colorVar",
        "feather": "feather",
        "feather_var": "featherVar",
        "tolerance": "tolerance",
        "tolerance_var": "toleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitRemoveColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
        feather: typing.Optional[builtins.str] = None,
        feather_var: typing.Optional[builtins.str] = None,
        tolerance: typing.Optional[builtins.str] = None,
        tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        :param feather: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        :param feather_var: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        :param tolerance: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        :param tolerance_var: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bece44622855b8247f6fec259f90808616c4fc7ef1f0f510c99351577622221b)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
            check_type(argname="argument feather", value=feather, expected_type=type_hints["feather"])
            check_type(argname="argument feather_var", value=feather_var, expected_type=type_hints["feather_var"])
            check_type(argname="argument tolerance", value=tolerance, expected_type=type_hints["tolerance"])
            check_type(argname="argument tolerance_var", value=tolerance_var, expected_type=type_hints["tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var
        if feather is not None:
            self._values["feather"] = feather
        if feather_var is not None:
            self._values["feather_var"] = feather_var
        if tolerance is not None:
            self._values["tolerance"] = tolerance
        if tolerance_var is not None:
            self._values["tolerance_var"] = tolerance_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        '''
        result = self._values.get("feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather_var(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        '''
        result = self._values.get("feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        '''
        result = self._values.get("tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance_var(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        result = self._values.get("tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitRemoveColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitRemoveColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitRemoveColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6b21db201379d2cc252ba665fd145ddf91e3a90bf3a308330f1e01e0b3d38ee1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitRemoveColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a6b7ded3bcfe0995169d254bdf9c5e2d39e617c9110f5e918bcd3c60fe8d0c20)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitRemoveColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e70840cfaddb85046837d0e698e608e171136ec9e5f5ed63f6c72db3bd6999d2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__42e5a07fe07291c0e6d07968ee3a950b073edc9fcaf37d5d98e06e79b32a095b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6effdec4c1175cf606e778921184a974e3ec31da9f37aa615f77964773b10c96)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitRemoveColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitRemoveColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitRemoveColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__01d8a86055b7fa0bd03d9f958ce532fd4d97577eb5f09eec1410b13100bde79e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitRemoveColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitRemoveColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f20a84114af303d8a1081d04562acbc28b01be4061a1d0b6620982c6c3c9a249)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @jsii.member(jsii_name="resetFeather")
    def reset_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeather", []))

    @jsii.member(jsii_name="resetFeatherVar")
    def reset_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatherVar", []))

    @jsii.member(jsii_name="resetTolerance")
    def reset_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTolerance", []))

    @jsii.member(jsii_name="resetToleranceVar")
    def reset_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featherInput")
    def feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherInput"))

    @builtins.property
    @jsii.member(jsii_name="featherVarInput")
    def feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceInput")
    def tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceVarInput")
    def tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa45d7e75ab413eb2694fddbb84633af38631fb6b2344f861ece045b5f578150)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5b084ae73f08b453eaf8fe5926350ba10671b32a07b7cad8c28ccc972951cb97)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="feather")
    def feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "feather"))

    @feather.setter
    def feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__47e6774491f8d7dc695e4e262703290444ff373f1215df176999e1c1d910a2bc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "feather", value)

    @builtins.property
    @jsii.member(jsii_name="featherVar")
    def feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featherVar"))

    @feather_var.setter
    def feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6adecaa293f59fd66dd4b2a4b84a2f4a3317f7f462a418079863843fff14544f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featherVar", value)

    @builtins.property
    @jsii.member(jsii_name="tolerance")
    def tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tolerance"))

    @tolerance.setter
    def tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6721b3e66a4fd31c46b460bd044ce01376826b27ebe7ae5f224ebf720c8525b2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tolerance", value)

    @builtins.property
    @jsii.member(jsii_name="toleranceVar")
    def tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "toleranceVar"))

    @tolerance_var.setter
    def tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e9c8129a75a606a13a69250f5f858ebc16439467fabdf6d0288072f118c32af9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "toleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitRemoveColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitRemoveColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitRemoveColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f3bceee480e7015fba2caf9630ed9404defd5ee61dea0f0f4b210365a952f73e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitResize",
    jsii_struct_bases=[],
    name_mapping={
        "aspect": "aspect",
        "aspect_var": "aspectVar",
        "height": "height",
        "height_var": "heightVar",
        "type": "type",
        "type_var": "typeVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitResize:
    def __init__(
        self,
        *,
        aspect: typing.Optional[builtins.str] = None,
        aspect_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param aspect: Preserves the aspect ratio. Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect DataAkamaiImagingPolicyImage#aspect}
        :param aspect_var: Preserves the aspect ratio. Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_var DataAkamaiImagingPolicyImage#aspect_var}
        :param height: The height to resize the source image to. Must be set if height is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height to resize the source image to. Must be set if height is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param type: Sets constraints for the image resize. Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: Sets constraints for the image resize. Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        :param width: The width to resize the source image to. Must be set if width is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width to resize the source image to. Must be set if width is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ce40b09cd0e72d5d46c2f929493a15284a4c22aa21048ddc9e8815c23f472ffd)
            check_type(argname="argument aspect", value=aspect, expected_type=type_hints["aspect"])
            check_type(argname="argument aspect_var", value=aspect_var, expected_type=type_hints["aspect_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if aspect is not None:
            self._values["aspect"] = aspect
        if aspect_var is not None:
            self._values["aspect_var"] = aspect_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def aspect(self) -> typing.Optional[builtins.str]:
        '''Preserves the aspect ratio.

        Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect DataAkamaiImagingPolicyImage#aspect}
        '''
        result = self._values.get("aspect")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def aspect_var(self) -> typing.Optional[builtins.str]:
        '''Preserves the aspect ratio.

        Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_var DataAkamaiImagingPolicyImage#aspect_var}
        '''
        result = self._values.get("aspect_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height to resize the source image to. Must be set if height is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height to resize the source image to. Must be set if height is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''Sets constraints for the image resize.

        Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''Sets constraints for the image resize.

        Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width to resize the source image to. Must be set if width is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width to resize the source image to. Must be set if width is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitResize(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitResizeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitResizeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9dbaf92fb9d69e3b1a7d247f8a9dbd49f42f5ed19fea26b6692cdd9d9290566d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitResizeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__40095e0258791353ee79e45e21728afa1be171668eb10ae62dfa86ca19e56151)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitResizeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c425cd55b4e58aecc86dfa73448736ff9aa21ec29f0e3a96d63f26b0da6480e3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a8a3a8fa085cc96a5e5941c1739ec8019f73c547fbde47aac9e227ade4fa870)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a79b49b7d3bfec106e91829a4e20fc45be01cc27792e1c680c024dbdd8a9c86)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitResize]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitResize]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitResize]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__22fcbff22fc7367d0b2b4b21bb95688b6fa4ecedf9fb55af9ad7aa3917ec35d5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitResizeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitResizeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__31f67e4295c20bb808ceba2eb6a9238f43ab13c90757a88a18f02fa5b2a35e80)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAspect")
    def reset_aspect(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspect", []))

    @jsii.member(jsii_name="resetAspectVar")
    def reset_aspect_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspectVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="aspectInput")
    def aspect_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "aspectInput"))

    @builtins.property
    @jsii.member(jsii_name="aspectVarInput")
    def aspect_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "aspectVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="aspect")
    def aspect(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "aspect"))

    @aspect.setter
    def aspect(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__decd7f9831a1fbd73bf6f5d5cc2de62402129c27cbbebc42680ffbc8235ab53d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "aspect", value)

    @builtins.property
    @jsii.member(jsii_name="aspectVar")
    def aspect_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "aspectVar"))

    @aspect_var.setter
    def aspect_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b7f016a0c0b160a2d6c3f8541cce7ebbda44d2585dbcf5dd0e19f2a30bb109b5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "aspectVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__71ce65f23aa004fe7743b7e07969421468e174c8409c21eefb3a7e7b8aad1a9f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ebb4382a31105d7d7a396520b4c6a9f65ef47ac3415ab9fe2886901db68ee686)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cc2c868d13da4d9485f92bc3e493cbfc24c7d221661d4d066ba596210b6eccb4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4fc46e93a979e91eef9c27cf387201c2e87b793f82defe4de0ba06852ebe3d51)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f9c76b19d3562bde230c3033f64c6a22079671b58412b1faab97e9d460ef201b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f791c11b1813b4c4cec49bbe6cdfbd0ff863d324f9d142f4f30b15c931b50b0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitResize]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitResize]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitResize]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__405e3c86644029f6d4a0ed76b14f403c8136058c1fb8ca9fd15b33b6b2bb4645)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitRotate",
    jsii_struct_bases=[],
    name_mapping={"degrees": "degrees", "degrees_var": "degreesVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitRotate:
    def __init__(
        self,
        *,
        degrees: typing.Optional[builtins.str] = None,
        degrees_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param degrees: The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees DataAkamaiImagingPolicyImage#degrees}
        :param degrees_var: The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees_var DataAkamaiImagingPolicyImage#degrees_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__33e07ab36764d6bf270206989ccce8b6c535e8d50cfd5b0724d6b43fe8dd2de1)
            check_type(argname="argument degrees", value=degrees, expected_type=type_hints["degrees"])
            check_type(argname="argument degrees_var", value=degrees_var, expected_type=type_hints["degrees_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if degrees is not None:
            self._values["degrees"] = degrees
        if degrees_var is not None:
            self._values["degrees_var"] = degrees_var

    @builtins.property
    def degrees(self) -> typing.Optional[builtins.str]:
        '''The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees DataAkamaiImagingPolicyImage#degrees}
        '''
        result = self._values.get("degrees")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def degrees_var(self) -> typing.Optional[builtins.str]:
        '''The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees_var DataAkamaiImagingPolicyImage#degrees_var}
        '''
        result = self._values.get("degrees_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitRotate(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitRotateList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitRotateList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1957320f078724f05e3b8dd50f24544ae797ab6e4dcbdc5e006b97354a314887)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitRotateOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4d1707061e9da630c78feb1c08e87ddd584cbbcc74274db82701e12727d8c60b)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitRotateOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d41799def3fdfebb06ce4ba21ffd12bf916b40258ca398c1a4ada870a070b35c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bbd0217a2b8364aba39e97579a86be6d6d9b9afe9a3d6287f8dff99c1c7761b6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__667a75770b1c7c6581b39365560d03800ae70fbeea147413d454fcd39a8ee31c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitRotate]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitRotate]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitRotate]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__686c6430e3115d72d2cc48577fc3c714aa0baa5747e09b61efd54a11816f7385)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitRotateOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitRotateOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f12b3b9f2476cadb17b723ef5a527437cb61fc3c8fd390c4deb4b53d48ebc3c2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetDegrees")
    def reset_degrees(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDegrees", []))

    @jsii.member(jsii_name="resetDegreesVar")
    def reset_degrees_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDegreesVar", []))

    @builtins.property
    @jsii.member(jsii_name="degreesInput")
    def degrees_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "degreesInput"))

    @builtins.property
    @jsii.member(jsii_name="degreesVarInput")
    def degrees_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "degreesVarInput"))

    @builtins.property
    @jsii.member(jsii_name="degrees")
    def degrees(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "degrees"))

    @degrees.setter
    def degrees(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__873981ec9ad1a35e50c0450081b84d809c874091a2af2d9370648ff337c06286)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "degrees", value)

    @builtins.property
    @jsii.member(jsii_name="degreesVar")
    def degrees_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "degreesVar"))

    @degrees_var.setter
    def degrees_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__42ee0dddaf88e355dc845edf48cae4efba733da8b22212a79031b85ae2922aa2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "degreesVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitRotate]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitRotate]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitRotate]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ef726a3fd5d60b20de9aaf42ca2f8fdd9cdba751d875c571162934fb2ba7282a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitScale",
    jsii_struct_bases=[],
    name_mapping={
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitScale:
    def __init__(
        self,
        *,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param height: Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged. Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged. Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ade9a84b00de0c8e2cd3d23047048a388ced722c30f4a67c3073636c3189de2)
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size.

        Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size.

        Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged.

        Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged.

        Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitScale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitScaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitScaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ebf348ea318a5343266c9d2e450cbeab66825f7adfd78c089d9849351c28be98)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitScaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d9bd80049bb24fd7b94058863c143341f39bf5d75f3d7bc23b72a634641a8b86)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitScaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e5a275828260011ef405d833da52e278a6ecd64404a6fba5d3fc0f0a74ce1d64)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1e5d80c9db6f9d5a1a88b81cc3334d9af0fed0ac53bb051890fb6ce70f47078a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0504244e36f56e9c5cb74bdb05a9c74eb32c4951f102e6a904292a50315efa21)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitScale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitScale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitScale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ca76190f4f7d512253d745ef6cd83ab668d69725f4edc3b84c49c0b586e69688)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitScaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitScaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__01a34f1d0c99e0919779ec8028e50e55ed98b211984bd7d965f0b72c3a6c593e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__15c017cd1b81f7b2c88149525ebe2f3f3d60c177c7d6cb30d4bed23a5938233e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bed79af9419d2f194be46c502c5bd0ad91a500dc38d5e2598feb91ac4adfc70d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8036b1f375b3e8cef660439fe3495544daebeb93625502e06bb67ca1e89d59c9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc2d5d86209a2950e05ac76cbd785bc8efe7382a7a7d73daeef6c241d3ae6299)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitScale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitScale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitScale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5d833137d8571a1b15abf64ab492002ec199fd43e290d9a822ad975f51563935)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitShear",
    jsii_struct_bases=[],
    name_mapping={
        "x_shear": "xShear",
        "x_shear_var": "xShearVar",
        "y_shear": "yShear",
        "y_shear_var": "yShearVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitShear:
    def __init__(
        self,
        *,
        x_shear: typing.Optional[builtins.str] = None,
        x_shear_var: typing.Optional[builtins.str] = None,
        y_shear: typing.Optional[builtins.str] = None,
        y_shear_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param x_shear: The amount to shear along the x-axis, measured in multiples of the image's width. Must be set if yShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear DataAkamaiImagingPolicyImage#x_shear}
        :param x_shear_var: The amount to shear along the x-axis, measured in multiples of the image's width. Must be set if yShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear_var DataAkamaiImagingPolicyImage#x_shear_var}
        :param y_shear: The amount to shear along the y-axis, measured in multiples of the image's height. Must be set if xShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear DataAkamaiImagingPolicyImage#y_shear}
        :param y_shear_var: The amount to shear along the y-axis, measured in multiples of the image's height. Must be set if xShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear_var DataAkamaiImagingPolicyImage#y_shear_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__69339c38d33035a88e15c7322ef4b46ce823d9ff892c8923cf150f766891d27c)
            check_type(argname="argument x_shear", value=x_shear, expected_type=type_hints["x_shear"])
            check_type(argname="argument x_shear_var", value=x_shear_var, expected_type=type_hints["x_shear_var"])
            check_type(argname="argument y_shear", value=y_shear, expected_type=type_hints["y_shear"])
            check_type(argname="argument y_shear_var", value=y_shear_var, expected_type=type_hints["y_shear_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if x_shear is not None:
            self._values["x_shear"] = x_shear
        if x_shear_var is not None:
            self._values["x_shear_var"] = x_shear_var
        if y_shear is not None:
            self._values["y_shear"] = y_shear
        if y_shear_var is not None:
            self._values["y_shear_var"] = y_shear_var

    @builtins.property
    def x_shear(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the x-axis, measured in multiples of the image's width.

        Must be set if yShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear DataAkamaiImagingPolicyImage#x_shear}
        '''
        result = self._values.get("x_shear")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_shear_var(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the x-axis, measured in multiples of the image's width.

        Must be set if yShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear_var DataAkamaiImagingPolicyImage#x_shear_var}
        '''
        result = self._values.get("x_shear_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_shear(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the y-axis, measured in multiples of the image's height.

        Must be set if xShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear DataAkamaiImagingPolicyImage#y_shear}
        '''
        result = self._values.get("y_shear")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_shear_var(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the y-axis, measured in multiples of the image's height.

        Must be set if xShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear_var DataAkamaiImagingPolicyImage#y_shear_var}
        '''
        result = self._values.get("y_shear_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitShear(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitShearList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitShearList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__36357762a7124e69520e1f57c1977960a77faed7d42e6ac48ed0b5872a95f1f2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitShearOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b30f98e59f467ccb0ee12c059ad359728824bf454cef03776ecee667b65daa2f)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitShearOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f4a92bcea95a52badf6ac35c2771b233e3a1d9efcb88c6c50980bf8fc7f39a33)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fe1b630e5e3e468ead75e1e581c1ad217ac2288505631c6d35b104343188f60a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0513f78166422503e10eac789bb205156240388611a3d6b76b0ed05ddfdd520a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitShear]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitShear]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitShear]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__30e3e7f07d6133ddb3cd8fb080a8919c389fbbfe4547ed987be95b2876e1be0d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitShearOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitShearOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7fc48aec3ee0c8ccac297451bed5b65f98633c7539257b8655e578083609fc6f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetXShear")
    def reset_x_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXShear", []))

    @jsii.member(jsii_name="resetXShearVar")
    def reset_x_shear_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXShearVar", []))

    @jsii.member(jsii_name="resetYShear")
    def reset_y_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYShear", []))

    @jsii.member(jsii_name="resetYShearVar")
    def reset_y_shear_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYShearVar", []))

    @builtins.property
    @jsii.member(jsii_name="xShearInput")
    def x_shear_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xShearInput"))

    @builtins.property
    @jsii.member(jsii_name="xShearVarInput")
    def x_shear_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xShearVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yShearInput")
    def y_shear_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yShearInput"))

    @builtins.property
    @jsii.member(jsii_name="yShearVarInput")
    def y_shear_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yShearVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xShear")
    def x_shear(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xShear"))

    @x_shear.setter
    def x_shear(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d4e1c21b9fb4e8b74691cf1c3077ea8ad5d38bcb7a134e5650d262cf380adf22)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xShear", value)

    @builtins.property
    @jsii.member(jsii_name="xShearVar")
    def x_shear_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xShearVar"))

    @x_shear_var.setter
    def x_shear_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__55a6c5147bd0c0408aadd022a0be215cb144a875d27c9ef03a67f324d02c2212)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xShearVar", value)

    @builtins.property
    @jsii.member(jsii_name="yShear")
    def y_shear(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yShear"))

    @y_shear.setter
    def y_shear(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4632f65101bb6225dd3479d6661eeb8d3a6613fbf0a09e21cb65056ab694ac8d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yShear", value)

    @builtins.property
    @jsii.member(jsii_name="yShearVar")
    def y_shear_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yShearVar"))

    @y_shear_var.setter
    def y_shear_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5bece789f24399798f0fdd9e6de7b3389993837755b6e16906b0dde8e10ac09e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yShearVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitShear]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitShear]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitShear]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3152d52a2309d5eb6d46aaf5175b987a77d9527f99bb0882d263ac8365ed12db)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitTrim",
    jsii_struct_bases=[],
    name_mapping={
        "fuzz": "fuzz",
        "fuzz_var": "fuzzVar",
        "padding": "padding",
        "padding_var": "paddingVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitTrim:
    def __init__(
        self,
        *,
        fuzz: typing.Optional[builtins.str] = None,
        fuzz_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fuzz: The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz DataAkamaiImagingPolicyImage#fuzz}
        :param fuzz_var: The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz_var DataAkamaiImagingPolicyImage#fuzz_var}
        :param padding: The amount of padding in pixels to add to the trimmed image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: The amount of padding in pixels to add to the trimmed image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a8dfbcf48c0106d01f06e53bf557b1f7ba3283ecb2d44a76e090b28360a03552)
            check_type(argname="argument fuzz", value=fuzz, expected_type=type_hints["fuzz"])
            check_type(argname="argument fuzz_var", value=fuzz_var, expected_type=type_hints["fuzz_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fuzz is not None:
            self._values["fuzz"] = fuzz
        if fuzz_var is not None:
            self._values["fuzz_var"] = fuzz_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var

    @builtins.property
    def fuzz(self) -> typing.Optional[builtins.str]:
        '''The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz DataAkamaiImagingPolicyImage#fuzz}
        '''
        result = self._values.get("fuzz")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fuzz_var(self) -> typing.Optional[builtins.str]:
        '''The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz_var DataAkamaiImagingPolicyImage#fuzz_var}
        '''
        result = self._values.get("fuzz_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''The amount of padding in pixels to add to the trimmed image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''The amount of padding in pixels to add to the trimmed image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitTrim(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitTrimList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitTrimList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7bfa824f706b69207d551d7283409c18888d97a1efdcc5088bfbd72c2ba0fa5e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitTrimOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b50cd360784f19dabb5fdaf61dfa4cbff1f3e6fbf4b58adf420da4860b17200b)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitTrimOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df78e72152c0d505115eb45fed27de6fc76ec628eed13df1abe58e4e3e0794fb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e15b6f626ea7ad56775733ea37dedaab54b666566e06656b15dcaccdab08b0e8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7226e2b3998c63a0fe318a5898a004c27381f44c64cba4d365864eb33f3f6a4a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitTrim]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitTrim]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitTrim]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__50b56929fb265bb28412e64e4c8de91b270f4aec616a939ce920a181055cf929)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitTrimOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitTrimOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cdec27939eb753cc60a5f9608b28dc1aa834fe3b8dcb2962169427cb96eff0db)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetFuzz")
    def reset_fuzz(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFuzz", []))

    @jsii.member(jsii_name="resetFuzzVar")
    def reset_fuzz_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFuzzVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @builtins.property
    @jsii.member(jsii_name="fuzzInput")
    def fuzz_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fuzzInput"))

    @builtins.property
    @jsii.member(jsii_name="fuzzVarInput")
    def fuzz_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fuzzVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="fuzz")
    def fuzz(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fuzz"))

    @fuzz.setter
    def fuzz(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__51ccb4b2b55de2510e60685decd78227dbb79d3a126a0f66e1eb0f26ef002692)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fuzz", value)

    @builtins.property
    @jsii.member(jsii_name="fuzzVar")
    def fuzz_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fuzzVar"))

    @fuzz_var.setter
    def fuzz_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b94b14a8d0d786b95240d550b85e6ffb0d1eaec40f934f81d3f0f59984594340)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fuzzVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4b1d342a9427bc29b1e9246531525ada517ad091ff01e1f6c7a6d652d4967b81)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__614120b02c5650166d112b9db721080e800ed9f718b30926eeffba81b59aa7a7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitTrim]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitTrim]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitTrim]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9e858d5ae1cf0edd6ac0f300667577cd580d9a694c33766d413cdda143c7804f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitUnsharpMask",
    jsii_struct_bases=[],
    name_mapping={
        "gain": "gain",
        "gain_var": "gainVar",
        "sigma": "sigma",
        "sigma_var": "sigmaVar",
        "threshold": "threshold",
        "threshold_var": "thresholdVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitUnsharpMask:
    def __init__(
        self,
        *,
        gain: typing.Optional[builtins.str] = None,
        gain_var: typing.Optional[builtins.str] = None,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
        threshold: typing.Optional[builtins.str] = None,
        threshold_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param gain: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        :param gain_var: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        :param sigma: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        :param threshold: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        :param threshold_var: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e9fce2e325074b15ee615efe54d2ccf9448680ed0f55d38e361648faffbc8235)
            check_type(argname="argument gain", value=gain, expected_type=type_hints["gain"])
            check_type(argname="argument gain_var", value=gain_var, expected_type=type_hints["gain_var"])
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
            check_type(argname="argument threshold", value=threshold, expected_type=type_hints["threshold"])
            check_type(argname="argument threshold_var", value=threshold_var, expected_type=type_hints["threshold_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if gain is not None:
            self._values["gain"] = gain
        if gain_var is not None:
            self._values["gain_var"] = gain_var
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var
        if threshold is not None:
            self._values["threshold"] = threshold
        if threshold_var is not None:
            self._values["threshold_var"] = threshold_var

    @builtins.property
    def gain(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        '''
        result = self._values.get("gain")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gain_var(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        '''
        result = self._values.get("gain_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        '''
        result = self._values.get("threshold")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold_var(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        result = self._values.get("threshold_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitUnsharpMask(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitUnsharpMaskList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitUnsharpMaskList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1a9a4c1f57c3965722aef84f073bd5132db6f1025b4d3c66ab1ce6edfa9e2e5c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitUnsharpMaskOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__05f1acae541da6a96fd2a007d722bcc0dfdea044bf4c1d2e312f914412d841f9)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitUnsharpMaskOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6d3ce9f1a433bfeec926538931c9b5bc1cf9ca331ec8310b3d16dc9b1cd92312)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__60bee646fa23e1f547100b7c246d9c4ff8dede07fb887b2e1b428c2786bf46ef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd5d7efca6224a7e23813a69b6c4a975b344f9155179999c5207d55e5f151bd0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitUnsharpMask]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitUnsharpMask]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitUnsharpMask]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f14ff97ae458470a1736a4c6c2d99a5ff0a9c043dd6e4f4c6f695b922b217625)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitUnsharpMaskOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitUnsharpMaskOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8f7e32e6905a49711bb9eada0bd51e3a4fc2b3a0e0a100dc6986db04b2b29012)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetGain")
    def reset_gain(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGain", []))

    @jsii.member(jsii_name="resetGainVar")
    def reset_gain_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGainVar", []))

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @jsii.member(jsii_name="resetThreshold")
    def reset_threshold(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThreshold", []))

    @jsii.member(jsii_name="resetThresholdVar")
    def reset_threshold_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThresholdVar", []))

    @builtins.property
    @jsii.member(jsii_name="gainInput")
    def gain_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainInput"))

    @builtins.property
    @jsii.member(jsii_name="gainVarInput")
    def gain_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdInput")
    def threshold_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdVarInput")
    def threshold_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gain")
    def gain(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gain"))

    @gain.setter
    def gain(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac611c53327cc2d7e4ef625ddf642faf01b0e0583f6a17b3f170f49ca0149666)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gain", value)

    @builtins.property
    @jsii.member(jsii_name="gainVar")
    def gain_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gainVar"))

    @gain_var.setter
    def gain_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2824a3c7ab5e35addec3841fa42ee05f8a24cccc183e28e464d905b185315195)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gainVar", value)

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f3cd887fbd41930855e6f09ac793443b26381f89d1c6fc03625291fc6fe5ba04)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9f8e9e1b48f6f109554302011eb3261e7b346f47e3f937550a239d321424bdb1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="threshold")
    def threshold(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "threshold"))

    @threshold.setter
    def threshold(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d7477cf8b94a2345b666414c087d137e9ce70ea80559b681dd7659be623a34c6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "threshold", value)

    @builtins.property
    @jsii.member(jsii_name="thresholdVar")
    def threshold_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "thresholdVar"))

    @threshold_var.setter
    def threshold_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c1726a6a3e95dce6925a7814a98c0ac71d12497638e2ae24b3548796f35b9545)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "thresholdVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitUnsharpMask]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitUnsharpMask]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitUnsharpMask]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a8c6d4bedd04cb7adabb0e4d7ce865cc9f55b83934a186cbf434f66b0fdd769b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquare",
    jsii_struct_bases=[],
    name_mapping={
        "append": "append",
        "aspect_crop": "aspectCrop",
        "background_color": "backgroundColor",
        "blur": "blur",
        "chroma_key": "chromaKey",
        "composite": "composite",
        "compound": "compound",
        "contrast": "contrast",
        "crop": "crop",
        "face_crop": "faceCrop",
        "feature_crop": "featureCrop",
        "fit_and_fill": "fitAndFill",
        "goop": "goop",
        "grayscale": "grayscale",
        "hsl": "hsl",
        "hsv": "hsv",
        "if_dimension": "ifDimension",
        "if_orientation": "ifOrientation",
        "im_query": "imQuery",
        "max_colors": "maxColors",
        "mirror": "mirror",
        "mono_hue": "monoHue",
        "opacity": "opacity",
        "region_of_interest_crop": "regionOfInterestCrop",
        "relative_crop": "relativeCrop",
        "remove_color": "removeColor",
        "resize": "resize",
        "rotate": "rotate",
        "scale": "scale",
        "shear": "shear",
        "trim": "trim",
        "unsharp_mask": "unsharpMask",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquare:
    def __init__(
        self,
        *,
        append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareAppend", typing.Dict[builtins.str, typing.Any]]]]] = None,
        aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareAspectCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareBackgroundColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareBlur", typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareChromaKey", typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareComposite", typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareCompound", typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareContrast", typing.Dict[builtins.str, typing.Any]]]]] = None,
        crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareFaceCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareFeatureCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareFitAndFill", typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareGoop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareGrayscale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareHsl", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareHsv", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfDimension", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfOrientation", typing.Dict[builtins.str, typing.Any]]]]] = None,
        im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareImQuery", typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareMaxColors", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareMirror", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareMonoHue", typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareOpacity", typing.Dict[builtins.str, typing.Any]]]]] = None,
        region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareRegionOfInterestCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareRelativeCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareRemoveColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareResize", typing.Dict[builtins.str, typing.Any]]]]] = None,
        rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareRotate", typing.Dict[builtins.str, typing.Any]]]]] = None,
        scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareScale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareShear", typing.Dict[builtins.str, typing.Any]]]]] = None,
        trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareTrim", typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareUnsharpMask", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param append: append block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        :param aspect_crop: aspect_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param crop: crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        :param face_crop: face_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        :param feature_crop: feature_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        :param fit_and_fill: fit_and_fill block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param im_query: im_query block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param region_of_interest_crop: region_of_interest_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        :param relative_crop: relative_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param resize: resize block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        :param rotate: rotate block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        :param scale: scale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param shear: shear block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        :param trim: trim block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7b203722a6dcfabe59e180a10f4041976a3571720d6526b3ee80648b070844ab)
            check_type(argname="argument append", value=append, expected_type=type_hints["append"])
            check_type(argname="argument aspect_crop", value=aspect_crop, expected_type=type_hints["aspect_crop"])
            check_type(argname="argument background_color", value=background_color, expected_type=type_hints["background_color"])
            check_type(argname="argument blur", value=blur, expected_type=type_hints["blur"])
            check_type(argname="argument chroma_key", value=chroma_key, expected_type=type_hints["chroma_key"])
            check_type(argname="argument composite", value=composite, expected_type=type_hints["composite"])
            check_type(argname="argument compound", value=compound, expected_type=type_hints["compound"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument crop", value=crop, expected_type=type_hints["crop"])
            check_type(argname="argument face_crop", value=face_crop, expected_type=type_hints["face_crop"])
            check_type(argname="argument feature_crop", value=feature_crop, expected_type=type_hints["feature_crop"])
            check_type(argname="argument fit_and_fill", value=fit_and_fill, expected_type=type_hints["fit_and_fill"])
            check_type(argname="argument goop", value=goop, expected_type=type_hints["goop"])
            check_type(argname="argument grayscale", value=grayscale, expected_type=type_hints["grayscale"])
            check_type(argname="argument hsl", value=hsl, expected_type=type_hints["hsl"])
            check_type(argname="argument hsv", value=hsv, expected_type=type_hints["hsv"])
            check_type(argname="argument if_dimension", value=if_dimension, expected_type=type_hints["if_dimension"])
            check_type(argname="argument if_orientation", value=if_orientation, expected_type=type_hints["if_orientation"])
            check_type(argname="argument im_query", value=im_query, expected_type=type_hints["im_query"])
            check_type(argname="argument max_colors", value=max_colors, expected_type=type_hints["max_colors"])
            check_type(argname="argument mirror", value=mirror, expected_type=type_hints["mirror"])
            check_type(argname="argument mono_hue", value=mono_hue, expected_type=type_hints["mono_hue"])
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument region_of_interest_crop", value=region_of_interest_crop, expected_type=type_hints["region_of_interest_crop"])
            check_type(argname="argument relative_crop", value=relative_crop, expected_type=type_hints["relative_crop"])
            check_type(argname="argument remove_color", value=remove_color, expected_type=type_hints["remove_color"])
            check_type(argname="argument resize", value=resize, expected_type=type_hints["resize"])
            check_type(argname="argument rotate", value=rotate, expected_type=type_hints["rotate"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument shear", value=shear, expected_type=type_hints["shear"])
            check_type(argname="argument trim", value=trim, expected_type=type_hints["trim"])
            check_type(argname="argument unsharp_mask", value=unsharp_mask, expected_type=type_hints["unsharp_mask"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if append is not None:
            self._values["append"] = append
        if aspect_crop is not None:
            self._values["aspect_crop"] = aspect_crop
        if background_color is not None:
            self._values["background_color"] = background_color
        if blur is not None:
            self._values["blur"] = blur
        if chroma_key is not None:
            self._values["chroma_key"] = chroma_key
        if composite is not None:
            self._values["composite"] = composite
        if compound is not None:
            self._values["compound"] = compound
        if contrast is not None:
            self._values["contrast"] = contrast
        if crop is not None:
            self._values["crop"] = crop
        if face_crop is not None:
            self._values["face_crop"] = face_crop
        if feature_crop is not None:
            self._values["feature_crop"] = feature_crop
        if fit_and_fill is not None:
            self._values["fit_and_fill"] = fit_and_fill
        if goop is not None:
            self._values["goop"] = goop
        if grayscale is not None:
            self._values["grayscale"] = grayscale
        if hsl is not None:
            self._values["hsl"] = hsl
        if hsv is not None:
            self._values["hsv"] = hsv
        if if_dimension is not None:
            self._values["if_dimension"] = if_dimension
        if if_orientation is not None:
            self._values["if_orientation"] = if_orientation
        if im_query is not None:
            self._values["im_query"] = im_query
        if max_colors is not None:
            self._values["max_colors"] = max_colors
        if mirror is not None:
            self._values["mirror"] = mirror
        if mono_hue is not None:
            self._values["mono_hue"] = mono_hue
        if opacity is not None:
            self._values["opacity"] = opacity
        if region_of_interest_crop is not None:
            self._values["region_of_interest_crop"] = region_of_interest_crop
        if relative_crop is not None:
            self._values["relative_crop"] = relative_crop
        if remove_color is not None:
            self._values["remove_color"] = remove_color
        if resize is not None:
            self._values["resize"] = resize
        if rotate is not None:
            self._values["rotate"] = rotate
        if scale is not None:
            self._values["scale"] = scale
        if shear is not None:
            self._values["shear"] = shear
        if trim is not None:
            self._values["trim"] = trim
        if unsharp_mask is not None:
            self._values["unsharp_mask"] = unsharp_mask

    @builtins.property
    def append(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareAppend"]]]:
        '''append block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        '''
        result = self._values.get("append")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareAppend"]]], result)

    @builtins.property
    def aspect_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareAspectCrop"]]]:
        '''aspect_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        '''
        result = self._values.get("aspect_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareAspectCrop"]]], result)

    @builtins.property
    def background_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareBackgroundColor"]]]:
        '''background_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        '''
        result = self._values.get("background_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareBackgroundColor"]]], result)

    @builtins.property
    def blur(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareBlur"]]]:
        '''blur block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        '''
        result = self._values.get("blur")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareBlur"]]], result)

    @builtins.property
    def chroma_key(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareChromaKey"]]]:
        '''chroma_key block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        '''
        result = self._values.get("chroma_key")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareChromaKey"]]], result)

    @builtins.property
    def composite(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareComposite"]]]:
        '''composite block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        '''
        result = self._values.get("composite")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareComposite"]]], result)

    @builtins.property
    def compound(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareCompound"]]]:
        '''compound block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        '''
        result = self._values.get("compound")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareCompound"]]], result)

    @builtins.property
    def contrast(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareContrast"]]]:
        '''contrast block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareContrast"]]], result)

    @builtins.property
    def crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareCrop"]]]:
        '''crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        '''
        result = self._values.get("crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareCrop"]]], result)

    @builtins.property
    def face_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareFaceCrop"]]]:
        '''face_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        '''
        result = self._values.get("face_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareFaceCrop"]]], result)

    @builtins.property
    def feature_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareFeatureCrop"]]]:
        '''feature_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        '''
        result = self._values.get("feature_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareFeatureCrop"]]], result)

    @builtins.property
    def fit_and_fill(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareFitAndFill"]]]:
        '''fit_and_fill block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        '''
        result = self._values.get("fit_and_fill")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareFitAndFill"]]], result)

    @builtins.property
    def goop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareGoop"]]]:
        '''goop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        '''
        result = self._values.get("goop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareGoop"]]], result)

    @builtins.property
    def grayscale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareGrayscale"]]]:
        '''grayscale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        '''
        result = self._values.get("grayscale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareGrayscale"]]], result)

    @builtins.property
    def hsl(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareHsl"]]]:
        '''hsl block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        '''
        result = self._values.get("hsl")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareHsl"]]], result)

    @builtins.property
    def hsv(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareHsv"]]]:
        '''hsv block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        '''
        result = self._values.get("hsv")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareHsv"]]], result)

    @builtins.property
    def if_dimension(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfDimension"]]]:
        '''if_dimension block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        '''
        result = self._values.get("if_dimension")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfDimension"]]], result)

    @builtins.property
    def if_orientation(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfOrientation"]]]:
        '''if_orientation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        '''
        result = self._values.get("if_orientation")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfOrientation"]]], result)

    @builtins.property
    def im_query(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareImQuery"]]]:
        '''im_query block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        '''
        result = self._values.get("im_query")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareImQuery"]]], result)

    @builtins.property
    def max_colors(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareMaxColors"]]]:
        '''max_colors block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        '''
        result = self._values.get("max_colors")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareMaxColors"]]], result)

    @builtins.property
    def mirror(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareMirror"]]]:
        '''mirror block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        '''
        result = self._values.get("mirror")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareMirror"]]], result)

    @builtins.property
    def mono_hue(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareMonoHue"]]]:
        '''mono_hue block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        '''
        result = self._values.get("mono_hue")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareMonoHue"]]], result)

    @builtins.property
    def opacity(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareOpacity"]]]:
        '''opacity block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareOpacity"]]], result)

    @builtins.property
    def region_of_interest_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareRegionOfInterestCrop"]]]:
        '''region_of_interest_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        '''
        result = self._values.get("region_of_interest_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareRegionOfInterestCrop"]]], result)

    @builtins.property
    def relative_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareRelativeCrop"]]]:
        '''relative_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        '''
        result = self._values.get("relative_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareRelativeCrop"]]], result)

    @builtins.property
    def remove_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareRemoveColor"]]]:
        '''remove_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        '''
        result = self._values.get("remove_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareRemoveColor"]]], result)

    @builtins.property
    def resize(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareResize"]]]:
        '''resize block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        '''
        result = self._values.get("resize")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareResize"]]], result)

    @builtins.property
    def rotate(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareRotate"]]]:
        '''rotate block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        '''
        result = self._values.get("rotate")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareRotate"]]], result)

    @builtins.property
    def scale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareScale"]]]:
        '''scale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareScale"]]], result)

    @builtins.property
    def shear(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareShear"]]]:
        '''shear block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        '''
        result = self._values.get("shear")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareShear"]]], result)

    @builtins.property
    def trim(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareTrim"]]]:
        '''trim block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        '''
        result = self._values.get("trim")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareTrim"]]], result)

    @builtins.property
    def unsharp_mask(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareUnsharpMask"]]]:
        '''unsharp_mask block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        result = self._values.get("unsharp_mask")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareUnsharpMask"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquare(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareAppend",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_priority": "gravityPriority",
        "gravity_priority_var": "gravityPriorityVar",
        "gravity_var": "gravityVar",
        "preserve_minor_dimension": "preserveMinorDimension",
        "preserve_minor_dimension_var": "preserveMinorDimensionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareAppend:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareAppendImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_priority: typing.Optional[builtins.str] = None,
        gravity_priority_var: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        preserve_minor_dimension: typing.Optional[builtins.str] = None,
        preserve_minor_dimension_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Specifies where to place the ``image`` relative to the source image. The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_priority: Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal. The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority DataAkamaiImagingPolicyImage#gravity_priority}
        :param gravity_priority_var: Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal. The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority_var DataAkamaiImagingPolicyImage#gravity_priority_var}
        :param gravity_var: Specifies where to place the ``image`` relative to the source image. The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param preserve_minor_dimension: Whether to preserve the source image's minor dimension, ``false`` by default. The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension DataAkamaiImagingPolicyImage#preserve_minor_dimension}
        :param preserve_minor_dimension_var: Whether to preserve the source image's minor dimension, ``false`` by default. The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension_var DataAkamaiImagingPolicyImage#preserve_minor_dimension_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareAppendImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bfcd0a358a628c236848881945c6171dfb652406911d1740083ff2f89d77b32a)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_priority", value=gravity_priority, expected_type=type_hints["gravity_priority"])
            check_type(argname="argument gravity_priority_var", value=gravity_priority_var, expected_type=type_hints["gravity_priority_var"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument preserve_minor_dimension", value=preserve_minor_dimension, expected_type=type_hints["preserve_minor_dimension"])
            check_type(argname="argument preserve_minor_dimension_var", value=preserve_minor_dimension_var, expected_type=type_hints["preserve_minor_dimension_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_priority is not None:
            self._values["gravity_priority"] = gravity_priority
        if gravity_priority_var is not None:
            self._values["gravity_priority_var"] = gravity_priority_var
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if preserve_minor_dimension is not None:
            self._values["preserve_minor_dimension"] = preserve_minor_dimension
        if preserve_minor_dimension_var is not None:
            self._values["preserve_minor_dimension_var"] = preserve_minor_dimension_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareAppendImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareAppendImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Specifies where to place the ``image`` relative to the source image.

        The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_priority(self) -> typing.Optional[builtins.str]:
        '''Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal.

        The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority DataAkamaiImagingPolicyImage#gravity_priority}
        '''
        result = self._values.get("gravity_priority")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_priority_var(self) -> typing.Optional[builtins.str]:
        '''Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal.

        The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority_var DataAkamaiImagingPolicyImage#gravity_priority_var}
        '''
        result = self._values.get("gravity_priority_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Specifies where to place the ``image`` relative to the source image.

        The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def preserve_minor_dimension(self) -> typing.Optional[builtins.str]:
        '''Whether to preserve the source image's minor dimension, ``false`` by default.

        The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension DataAkamaiImagingPolicyImage#preserve_minor_dimension}
        '''
        result = self._values.get("preserve_minor_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def preserve_minor_dimension_var(self) -> typing.Optional[builtins.str]:
        '''Whether to preserve the source image's minor dimension, ``false`` by default.

        The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension_var DataAkamaiImagingPolicyImage#preserve_minor_dimension_var}
        '''
        result = self._values.get("preserve_minor_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareAppend(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareAppendImage",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareAppendImage:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareAppendImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareAppendImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareAppendImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__152c82f4f62d545bfd4c3cf4fbdf6fb32fd15e85e95edac8ecd8900f5d7792be)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareAppendImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareAppendImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareAppendImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd62b1821b1dce59901451c1b07fd591e7aeabab8c94737d1a33a7967a0707b0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareAppendList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareAppendList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8222e0fa2231dee20e946a68aa891d3033d856d5c4202a9fdcd7d0acec7a03bd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareAppendOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f02b79e120d97fa22e614a7181287f78d7f716a80f7d5a5cec105e293779a9ab)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareAppendOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cb1e46a7f57684a3169ffe4ed93e548efc18fc3b69dd1cb86af18658d01d3e95)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__57d16a14aa0de29820d57b7627f8d5e15b28d0518b6a29b04e7eb175d1aef646)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4f9e25fa91e251be23414d5f14ad807b56f43993af14668cd084aad22a7b56ca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareAppend]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareAppend]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareAppend]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__530904d28a6eecbef04753647645cdb6ccc3e7dab5ef05a1d5569a42c8b7c40a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareAppendOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareAppendOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b763aab317f402b4c3f2d7f646df3cd32ab8f9fa362ad3356e771218c7f75762)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareAppendImage()

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityPriority")
    def reset_gravity_priority(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityPriority", []))

    @jsii.member(jsii_name="resetGravityPriorityVar")
    def reset_gravity_priority_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityPriorityVar", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPreserveMinorDimension")
    def reset_preserve_minor_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPreserveMinorDimension", []))

    @jsii.member(jsii_name="resetPreserveMinorDimensionVar")
    def reset_preserve_minor_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPreserveMinorDimensionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareAppendImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareAppendImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityInput")
    def gravity_priority_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityPriorityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityVarInput")
    def gravity_priority_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityPriorityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareAppendImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareAppendImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionInput")
    def preserve_minor_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "preserveMinorDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionVarInput")
    def preserve_minor_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "preserveMinorDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1aa0c733fd98ac67ffe7e5013a34db047c302874d8fdd550c94883e355b2e4d3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityPriority")
    def gravity_priority(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityPriority"))

    @gravity_priority.setter
    def gravity_priority(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c88e2f91294d5119f9a081045c7dc4c3903858b182dcfbc45ac812dffe5eac09)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityPriority", value)

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityVar")
    def gravity_priority_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityPriorityVar"))

    @gravity_priority_var.setter
    def gravity_priority_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b7abba9f34e2d35bd297120ff0bf829631f8099c6b2e3775fcdbf32b47a0e039)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityPriorityVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__42dcd8de42966e4aaa3688fec84523e74aadc8987db48482d9a4e9a992a186e5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimension")
    def preserve_minor_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "preserveMinorDimension"))

    @preserve_minor_dimension.setter
    def preserve_minor_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d2c939e0314b961842cf72fd3afa5a05ff5c5cc86e584156a7446f2ee5548c33)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "preserveMinorDimension", value)

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionVar")
    def preserve_minor_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "preserveMinorDimensionVar"))

    @preserve_minor_dimension_var.setter
    def preserve_minor_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1b11c0c114352fbb2a8fd45184aa72987f299ee7b7861aaa6d0b14ee82b904c4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "preserveMinorDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareAppend]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareAppend]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareAppend]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c0faceaf9f24bcec4fe5f991fbf64bcc6c072a83753bdc8fdc305944b1b1a1c1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareAspectCrop",
    jsii_struct_bases=[],
    name_mapping={
        "allow_expansion": "allowExpansion",
        "allow_expansion_var": "allowExpansionVar",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareAspectCrop:
    def __init__(
        self,
        *,
        allow_expansion: typing.Optional[builtins.str] = None,
        allow_expansion_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_expansion: Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image. Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        :param allow_expansion_var: Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image. Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        :param height: The height term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The width term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        :param x_position: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__38e400289b7960bc947642e36b026c191826e9a9793dd7bea5a0cb1640c5d1a1)
            check_type(argname="argument allow_expansion", value=allow_expansion, expected_type=type_hints["allow_expansion"])
            check_type(argname="argument allow_expansion_var", value=allow_expansion_var, expected_type=type_hints["allow_expansion_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if allow_expansion is not None:
            self._values["allow_expansion"] = allow_expansion
        if allow_expansion_var is not None:
            self._values["allow_expansion_var"] = allow_expansion_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def allow_expansion(self) -> typing.Optional[builtins.str]:
        '''Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image.

        Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        '''
        result = self._values.get("allow_expansion")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def allow_expansion_var(self) -> typing.Optional[builtins.str]:
        '''Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image.

        Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        '''
        result = self._values.get("allow_expansion_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareAspectCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareAspectCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareAspectCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__181b96669170bf22f89a197a70ea468cecd64f4c54d966e688cdd378d63f6a60)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareAspectCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b8ff75e0c7dd77b5d1d50521c85053b6ecddbc3b01972b3f924b68044d237eba)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareAspectCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3e61565a5198712c3bd5c4e1b7afbdb1591240efa3e1a353c02deae6c8a2a202)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1a78be10b7e3ca15c5cad582bc2d31787e50e575ecd3914bfdc77fa6a73fe4fe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__66d5b77de40dfb423bb437a43df24dd81bf381edfc5e4cab982f7a574c84a910)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareAspectCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareAspectCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareAspectCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f5db1e75e651feff6f62a25c17512131c68927b8190272bdfb4a81722f1c3248)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareAspectCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareAspectCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__86050060ab40aea51edd28b801c2196a4bf5facd3290aa5381eda40854968909)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAllowExpansion")
    def reset_allow_expansion(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansion", []))

    @jsii.member(jsii_name="resetAllowExpansionVar")
    def reset_allow_expansion_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansionVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionInput")
    def allow_expansion_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVarInput")
    def allow_expansion_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansion")
    def allow_expansion(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansion"))

    @allow_expansion.setter
    def allow_expansion(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8103f661624d6024865bb866190917db0a877a21fa9697ae20ca131b875c0fab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansion", value)

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVar")
    def allow_expansion_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansionVar"))

    @allow_expansion_var.setter
    def allow_expansion_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7e1c5652bdaf53a3d2dc5d6a73cb07dcfe907989362b335c0943af2706c4e9db)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansionVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a5c49535b145d8052d967da7278fb1eaf2402dee3355a35322fd78a072a588cc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__45de806ad236417c314ac553bec895c54a02dc11248bfc483f1a73dc63b3c515)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e2692f97689a57555ed30a039af2a5b2aa60c0971d22ddc08e57b0f946063317)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eb60d1f0d647064cf867387a4e41f691c2033c186335be9e25b76400ee5b4dbf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea6977cfea93edc537d01bd279dd6ca0f9e0066a17557f12bb6dcb2099e5fbe6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4d7ca353b33dc2c299b617885e4651fcf25569127aee76d57c6e8391824e24b2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__87991c17b435f6ea375b5c3abb599a6ffb9b6bcf0fffa545bddd8728096f37c4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cdca809350d62c550b55ec069b5a8e5d8c0b7f2e454391c396f7ce07af28690d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareAspectCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareAspectCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareAspectCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__47ed96b166692f47ee079631b0bf237610c0c44aff5e426e1a22e2ef5335caae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareBackgroundColor",
    jsii_struct_bases=[],
    name_mapping={"color": "color", "color_var": "colorVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareBackgroundColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eeeb3f822b162790c7032194f68bb271f343fe79c1ce4179cd791954133417a9)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareBackgroundColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareBackgroundColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareBackgroundColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fec32439cc99bb0a558d65b867511b3bbfc638e251bad0e67591c13f8c64f4a4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareBackgroundColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__25c5be44013318289f12e0e20e9d4b80a9e0a06ca9237c8097b7faacf6bb3c96)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareBackgroundColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6be33102889547d701b9d93d31f9a95dff60c14f4041e9ebe15fc11b7adeaeb0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__327c1d406754b2a5bcf74b73cc666c10c2b75dd39274f45f4d581662e189546c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__47b51491e02f0358c9f30e384cc10a7dd1859d9c5f6b70a7cf83ee3495681b0a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareBackgroundColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareBackgroundColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c34084010a48525f8428cd75f584d1d41bae04a6495014349db05d381f83242d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareBackgroundColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareBackgroundColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__07788c831c2ed01314ced784c97994818f56ac177e323f770e08e8549bdbbe33)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa353f52d8b442bb233a4a12891ffe853827ce6e8c3ef318a2a69fb4af6dd68f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8856ab07d1710c32a031486991f0ea97d623a4f91a24d88bb2359aa105494c0f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareBackgroundColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareBackgroundColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareBackgroundColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__29d20b884dfea6a95929e636c9bed04dd29f52241ae99d12a2fca5b4a6fcf418)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareBlur",
    jsii_struct_bases=[],
    name_mapping={"sigma": "sigma", "sigma_var": "sigmaVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareBlur:
    def __init__(
        self,
        *,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param sigma: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__92ccba77454af57cbdb00bdf501af1013c9698b8d05bc1e0b0a18766bf7fb1d7)
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareBlur(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareBlurList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareBlurList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__468c5600721cab104abbeec1a2777ad35fb821bf1c6477c6dd89ba44eeb27c3c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareBlurOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__53e382a92ab7cf54456b8dce96afb341cb2607ebc9bc56fcc288da9958bb94ee)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareBlurOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__135911f2c5ee7a8177b5f1da6f9e111327bc70445da62b1f863a6b5f856d78a7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e6ba1829745339222a5ca98b3dcd7b5feb5efa938d8320d53e10c542366e040)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e6c67ee92b0efc684b8b08b111c786cd00e294525322b95067ef928bf352c336)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareBlur]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareBlur]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__01cbbd52d20d212eb90078031bbd9b8d66ddeff1a5244a7e6a6fea310a2b0bdd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareBlurOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareBlurOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e48d88af70e2fb733229e395f279d70f98e58a420e55445fd032f4b9209c6566)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6addd8fb7694e7f251af69cf61731fbcfd15d5637e796f18bbc3d6032b655b4f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b6ff6c3f1aa5cf9190ebb03ac93a548bc3cef1424528a8999e19f9de630035b9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareBlur]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareBlur]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareBlur]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f323fb09148a17d583d6840b920276936c848d390bbd42cae6f64ff38b35b429)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareChromaKey",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_feather": "hueFeather",
        "hue_feather_var": "hueFeatherVar",
        "hue_tolerance": "hueTolerance",
        "hue_tolerance_var": "hueToleranceVar",
        "hue_var": "hueVar",
        "lightness_feather": "lightnessFeather",
        "lightness_feather_var": "lightnessFeatherVar",
        "lightness_tolerance": "lightnessTolerance",
        "lightness_tolerance_var": "lightnessToleranceVar",
        "saturation_feather": "saturationFeather",
        "saturation_feather_var": "saturationFeatherVar",
        "saturation_tolerance": "saturationTolerance",
        "saturation_tolerance_var": "saturationToleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareChromaKey:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_feather: typing.Optional[builtins.str] = None,
        hue_feather_var: typing.Optional[builtins.str] = None,
        hue_tolerance: typing.Optional[builtins.str] = None,
        hue_tolerance_var: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness_feather: typing.Optional[builtins.str] = None,
        lightness_feather_var: typing.Optional[builtins.str] = None,
        lightness_tolerance: typing.Optional[builtins.str] = None,
        lightness_tolerance_var: typing.Optional[builtins.str] = None,
        saturation_feather: typing.Optional[builtins.str] = None,
        saturation_feather_var: typing.Optional[builtins.str] = None,
        saturation_tolerance: typing.Optional[builtins.str] = None,
        saturation_tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_feather: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        :param hue_feather_var: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        :param hue_tolerance: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        :param hue_tolerance_var: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        :param hue_var: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness_feather: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        :param lightness_feather_var: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        :param lightness_tolerance: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        :param lightness_tolerance_var: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        :param saturation_feather: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        :param saturation_feather_var: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        :param saturation_tolerance: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        :param saturation_tolerance_var: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e9550d0e6144a557791fbaf4b3715868a347dae6f03811810f86b2a61546f729)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_feather", value=hue_feather, expected_type=type_hints["hue_feather"])
            check_type(argname="argument hue_feather_var", value=hue_feather_var, expected_type=type_hints["hue_feather_var"])
            check_type(argname="argument hue_tolerance", value=hue_tolerance, expected_type=type_hints["hue_tolerance"])
            check_type(argname="argument hue_tolerance_var", value=hue_tolerance_var, expected_type=type_hints["hue_tolerance_var"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness_feather", value=lightness_feather, expected_type=type_hints["lightness_feather"])
            check_type(argname="argument lightness_feather_var", value=lightness_feather_var, expected_type=type_hints["lightness_feather_var"])
            check_type(argname="argument lightness_tolerance", value=lightness_tolerance, expected_type=type_hints["lightness_tolerance"])
            check_type(argname="argument lightness_tolerance_var", value=lightness_tolerance_var, expected_type=type_hints["lightness_tolerance_var"])
            check_type(argname="argument saturation_feather", value=saturation_feather, expected_type=type_hints["saturation_feather"])
            check_type(argname="argument saturation_feather_var", value=saturation_feather_var, expected_type=type_hints["saturation_feather_var"])
            check_type(argname="argument saturation_tolerance", value=saturation_tolerance, expected_type=type_hints["saturation_tolerance"])
            check_type(argname="argument saturation_tolerance_var", value=saturation_tolerance_var, expected_type=type_hints["saturation_tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_feather is not None:
            self._values["hue_feather"] = hue_feather
        if hue_feather_var is not None:
            self._values["hue_feather_var"] = hue_feather_var
        if hue_tolerance is not None:
            self._values["hue_tolerance"] = hue_tolerance
        if hue_tolerance_var is not None:
            self._values["hue_tolerance_var"] = hue_tolerance_var
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness_feather is not None:
            self._values["lightness_feather"] = lightness_feather
        if lightness_feather_var is not None:
            self._values["lightness_feather_var"] = lightness_feather_var
        if lightness_tolerance is not None:
            self._values["lightness_tolerance"] = lightness_tolerance
        if lightness_tolerance_var is not None:
            self._values["lightness_tolerance_var"] = lightness_tolerance_var
        if saturation_feather is not None:
            self._values["saturation_feather"] = saturation_feather
        if saturation_feather_var is not None:
            self._values["saturation_feather_var"] = saturation_feather_var
        if saturation_tolerance is not None:
            self._values["saturation_tolerance"] = saturation_tolerance
        if saturation_tolerance_var is not None:
            self._values["saturation_tolerance_var"] = saturation_tolerance_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        '''
        result = self._values.get("hue_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        '''
        result = self._values.get("hue_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        '''
        result = self._values.get("hue_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        '''
        result = self._values.get("hue_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        '''
        result = self._values.get("lightness_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        '''
        result = self._values.get("lightness_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        '''
        result = self._values.get("lightness_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        '''
        result = self._values.get("lightness_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        '''
        result = self._values.get("saturation_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        '''
        result = self._values.get("saturation_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        '''
        result = self._values.get("saturation_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        result = self._values.get("saturation_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareChromaKey(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareChromaKeyList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareChromaKeyList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d8c5c51b9eef8b6b251544b7620300745255f04b2553bb30670ad631ae219354)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareChromaKeyOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b21975d7dc721c5c8771b48cf92403ed7e25ee892899c70b8482e4794bded082)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareChromaKeyOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5cceb34f2e7fd1e4ce5a797700101c645a818aca21b85053b8a018b57bd471f8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c557a78458b9fc6ffd5d950b5036511d3e271c3f34a74f2969a59172bce8628c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4378a88cf01df400cc26f083e6b4ce0545e3f1c986f8a70c22eba6eab5267ce8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareChromaKey]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareChromaKey]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4221ac29e5737d7c39335b52318115348894d6db8fb90ab5e7a20a22b355f899)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareChromaKeyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareChromaKeyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af5d243ad79e0eff9e94d5076899600b5da3dbe481dc2c47b12d2d7e76c3908c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueFeather")
    def reset_hue_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeather", []))

    @jsii.member(jsii_name="resetHueFeatherVar")
    def reset_hue_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeatherVar", []))

    @jsii.member(jsii_name="resetHueTolerance")
    def reset_hue_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueTolerance", []))

    @jsii.member(jsii_name="resetHueToleranceVar")
    def reset_hue_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueToleranceVar", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightnessFeather")
    def reset_lightness_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeather", []))

    @jsii.member(jsii_name="resetLightnessFeatherVar")
    def reset_lightness_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeatherVar", []))

    @jsii.member(jsii_name="resetLightnessTolerance")
    def reset_lightness_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessTolerance", []))

    @jsii.member(jsii_name="resetLightnessToleranceVar")
    def reset_lightness_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessToleranceVar", []))

    @jsii.member(jsii_name="resetSaturationFeather")
    def reset_saturation_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeather", []))

    @jsii.member(jsii_name="resetSaturationFeatherVar")
    def reset_saturation_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeatherVar", []))

    @jsii.member(jsii_name="resetSaturationTolerance")
    def reset_saturation_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationTolerance", []))

    @jsii.member(jsii_name="resetSaturationToleranceVar")
    def reset_saturation_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherInput")
    def hue_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVarInput")
    def hue_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceInput")
    def hue_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVarInput")
    def hue_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherInput")
    def lightness_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVarInput")
    def lightness_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceInput")
    def lightness_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVarInput")
    def lightness_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherInput")
    def saturation_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVarInput")
    def saturation_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceInput")
    def saturation_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVarInput")
    def saturation_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__12544bd7b8d340372412e233d00d0323ff3059b3605367209db4464995582b46)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeather")
    def hue_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeather"))

    @hue_feather.setter
    def hue_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1068bf007e70b5b619d8d7da9de7e57cf4859a902fc94164a484e37008aa9b38)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeather", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVar")
    def hue_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeatherVar"))

    @hue_feather_var.setter
    def hue_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__079907732901b20000553d28481521a4826226772e31c6595a2d944236dee463)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueTolerance")
    def hue_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueTolerance"))

    @hue_tolerance.setter
    def hue_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2abe4eb84faffcd3454ae9cdf67b4e73dcbdf91608f79873c62d74c5b467e8f6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVar")
    def hue_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueToleranceVar"))

    @hue_tolerance_var.setter
    def hue_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c6eefbdc43688916bbff663fe4c843ac269c60f7bca2169a47a03c7526f16ba3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b18ce75a97c03e8bb4c15de8ef374ba352e4c2bb9507e58928275b76194cbd2d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeather")
    def lightness_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeather"))

    @lightness_feather.setter
    def lightness_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb506bf837638b7f48be81837445f34a30b51bbe3f4578af4230ac6ec25f8d67)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeather", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVar")
    def lightness_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeatherVar"))

    @lightness_feather_var.setter
    def lightness_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__edb77fd4191a8ac1a78a83f66e586015c877299f378ebe697b047b64d83d7cc0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessTolerance")
    def lightness_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessTolerance"))

    @lightness_tolerance.setter
    def lightness_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__928bbcf075f5dde21222847e7bb44885838aa5ac851923e7e005abc4376832c8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVar")
    def lightness_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessToleranceVar"))

    @lightness_tolerance_var.setter
    def lightness_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9b56a8722e62e1dcb6efd140f4b1808619f7abc52501cb498b0ee091ef32331e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeather")
    def saturation_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeather"))

    @saturation_feather.setter
    def saturation_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ec89bc70f577c9df0c9b8b756d7ebbd93486d6faf94c49f03d3be431afa6daf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeather", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVar")
    def saturation_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeatherVar"))

    @saturation_feather_var.setter
    def saturation_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__deabef47c311390f4e2537d894662f9d157f72848ee159839a566de45f0fc623)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationTolerance")
    def saturation_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationTolerance"))

    @saturation_tolerance.setter
    def saturation_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f7ed46ab60228450f4ae7568819b2397c1babcf580ec2d4deed900400a2c09dc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVar")
    def saturation_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationToleranceVar"))

    @saturation_tolerance_var.setter
    def saturation_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ceb43f99200930d17ea2ec9c4f4b9675ef26ae8c6c1a28c6b688633e2413b35)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareChromaKey]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareChromaKey]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareChromaKey]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e5e459f5feda060b3cdea61266fd8616dc0610a167b700ff77c998347cf572aa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareComposite",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "placement": "placement",
        "placement_var": "placementVar",
        "scale": "scale",
        "scale_dimension": "scaleDimension",
        "scale_dimension_var": "scaleDimensionVar",
        "scale_var": "scaleVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareComposite:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareCompositeImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        placement: typing.Optional[builtins.str] = None,
        placement_var: typing.Optional[builtins.str] = None,
        scale: typing.Optional[builtins.str] = None,
        scale_dimension: typing.Optional[builtins.str] = None,
        scale_dimension_var: typing.Optional[builtins.str] = None,
        scale_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param placement: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        :param placement_var: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        :param scale: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param scale_dimension: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        :param scale_dimension_var: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        :param scale_var: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        :param x_position: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareCompositeImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fcac26eb06e1696cd3bab2cee29ae3cfb83a5f7e6ee453cbbb51aafff32c670f)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument placement", value=placement, expected_type=type_hints["placement"])
            check_type(argname="argument placement_var", value=placement_var, expected_type=type_hints["placement_var"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument scale_dimension", value=scale_dimension, expected_type=type_hints["scale_dimension"])
            check_type(argname="argument scale_dimension_var", value=scale_dimension_var, expected_type=type_hints["scale_dimension_var"])
            check_type(argname="argument scale_var", value=scale_var, expected_type=type_hints["scale_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if placement is not None:
            self._values["placement"] = placement
        if placement_var is not None:
            self._values["placement_var"] = placement_var
        if scale is not None:
            self._values["scale"] = scale
        if scale_dimension is not None:
            self._values["scale_dimension"] = scale_dimension
        if scale_dimension_var is not None:
            self._values["scale_dimension_var"] = scale_dimension_var
        if scale_var is not None:
            self._values["scale_var"] = scale_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareCompositeImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareCompositeImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        '''
        result = self._values.get("placement")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement_var(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        '''
        result = self._values.get("placement_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        '''
        result = self._values.get("scale_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        '''
        result = self._values.get("scale_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        '''
        result = self._values.get("scale_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareComposite(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareCompositeImage",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareCompositeImage:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareCompositeImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareCompositeImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareCompositeImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f50963826f9532ea2961ffe2499bc08155189364973315187378bf2d4190705)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareCompositeImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareCompositeImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__de8877bc6bff5a5f4cac79aa79ae87e1266a07f68fad9c691c87b2bed587a201)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareCompositeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareCompositeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b1fbb8c057d802d1cafa1878b06ded7c25ee9a82c7d684de319b2bc408560abc)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareCompositeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc001313b8d1cf7a7e0e316462eebca2721fb832319d5d7b3097a4e7f6073016)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareCompositeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__51d3e15031b82327eccb238dc226041a824f23ca2abd52cc5e952ece1624eeab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4fc4b083a479d10c1ddc14eb87fa126ac0a339632b7c08cf28c294c8f422660d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__102d18c2716efe4715e1c6773a26160fde62fcf879144aa09b84112671949c2e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareComposite]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareComposite]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__70e63e6e61a918616e3e58a27c505facaed1f53cb8e844286ebb8b056cd5483c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareCompositeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareCompositeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__15389b61da9e22f38307e1a91c571b94c9413eacf9994ecd28507556c16256d7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareCompositeImage()

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPlacement")
    def reset_placement(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacement", []))

    @jsii.member(jsii_name="resetPlacementVar")
    def reset_placement_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacementVar", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetScaleDimension")
    def reset_scale_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimension", []))

    @jsii.member(jsii_name="resetScaleDimensionVar")
    def reset_scale_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimensionVar", []))

    @jsii.member(jsii_name="resetScaleVar")
    def reset_scale_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareCompositeImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareCompositeImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareCompositeImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="placementInput")
    def placement_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementInput"))

    @builtins.property
    @jsii.member(jsii_name="placementVarInput")
    def placement_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionInput")
    def scale_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVarInput")
    def scale_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleVarInput")
    def scale_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9f6224930d1c8edd75e864b8006f270757b3548b7ed40e29cd98ceb1bfb5d555)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fb51a7ae56399f0c5c293c7f69f013c6136c52f6d4af5c103a28273a1a8abcb1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="placement")
    def placement(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placement"))

    @placement.setter
    def placement(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__05905d7f0030f53ebc1a357f9e3bf34b5a660c50e834ffb576711db20e7d99d3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placement", value)

    @builtins.property
    @jsii.member(jsii_name="placementVar")
    def placement_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placementVar"))

    @placement_var.setter
    def placement_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__39d26cc884971ede37a6abe2f5ab08bca95451f399ac755b2dc0813b148263f8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placementVar", value)

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scale"))

    @scale.setter
    def scale(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9f9d9d356b83a9ed957eeb1fa829c46e8c00120e91082ff4c65a3b986580c40a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scale", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimension")
    def scale_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimension"))

    @scale_dimension.setter
    def scale_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bbcf67c6309cdd096c3b657b0da14455a3fa4212cdddc94c23d4565dcda78030)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimension", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVar")
    def scale_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimensionVar"))

    @scale_dimension_var.setter
    def scale_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2dcc0d2c925dce86cf6b9a39e0cfa37fb4930565895f6c37627f3c8bd1a8d90f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="scaleVar")
    def scale_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleVar"))

    @scale_var.setter
    def scale_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ccedede1fcefb14153ae0a4f883ac3b4b844f011113b30dd849fa341e6d1e4c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eb54a55060aeb89f414f804f3ee5af8bbaddd5d297a177fa44291c866a71e6bb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b06a10f3a511f4ae550cb26c8e0817c952effe25bd75fffad852267d09083418)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__82bb3b5a92fac45a6ae32d96d28e8f4750a1954d791cdd93a8fbce3fac86f0f3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7daf971a6dc737f0e27873793d4aa6fa9134a3aaa516c45a9b1c15c3003c57ba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareComposite]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareComposite]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareComposite]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__468fa1d00779d72e96dff8a8b2fd798ac3e1b911972b6b4d546865eedaaf5800)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareCompound",
    jsii_struct_bases=[],
    name_mapping={"transformations": "transformations"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareCompound:
    def __init__(
        self,
        *,
        transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param transformations: transformations block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__395dd6b6ce6c67a2662ddbdcdd780e674902e51e2dd8a2a4b10f570c1db1b5a4)
            check_type(argname="argument transformations", value=transformations, expected_type=type_hints["transformations"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if transformations is not None:
            self._values["transformations"] = transformations

    @builtins.property
    def transformations(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareCompoundTransformations"]]]:
        '''transformations block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        result = self._values.get("transformations")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareCompoundTransformations"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareCompound(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareCompoundList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareCompoundList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__daa9349c4f6b4e27de1631b3909e3a69ae192c30ac1aacd108bcb75dd605cca5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareCompoundOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__261d1794d3622303403ba4fec793749ed5f9c8f40d2b9225350585932ecd40a6)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareCompoundOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__99174a7c6b92d28d32d08791cad37c82e220cbaf3759ea8fa877108270b73ce5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f2c3e2ea3f30bd212573b55cab14f655183380c9b727ae14e673c6695acfd42d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__abb0b334a42f6015b8ad4d5f96607472693e9d28debbacd11ac767f8801ee6bc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareCompound]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareCompound]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b41cda472fbb9e0563a48b0002b78c6a35b82e1cf5674abdf2cc24e592d57f08)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareCompoundOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareCompoundOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__920c395bf54ca7c1d78bed589c7f95532b0df71e9f2a4ba532c730d91925967f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformations")
    def put_transformations(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__101b7c0884a74414a0a430aead42e1e7dbdd397ce879978122212b5d472a0a28)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTransformations", [value]))

    @jsii.member(jsii_name="resetTransformations")
    def reset_transformations(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformations", []))

    @builtins.property
    @jsii.member(jsii_name="transformations")
    def transformations(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareCompoundTransformationsList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareCompoundTransformationsList", jsii.get(self, "transformations"))

    @builtins.property
    @jsii.member(jsii_name="transformationsInput")
    def transformations_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareCompoundTransformations"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareCompoundTransformations"]]], jsii.get(self, "transformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareCompound]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareCompound]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareCompound]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__00aa40a0b26d683d0b74f31ba5ecc08cd3a0f5fb81cf9cc0e0271e7aa33f937d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareCompoundTransformations",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareCompoundTransformations:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareCompoundTransformations(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareCompoundTransformationsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareCompoundTransformationsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__667d5c57a7906839aafe744beb487fb63d27e6e929a7f4a989f2e204df4fe4e1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareCompoundTransformationsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c6880efe0e7f800d3fd6bb4781ce4fbd2e70d5b30bb478576b1903d3a66225ae)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareCompoundTransformationsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1205f64f196b98559603c4b48a544a819a55a116f17b51573674d4f846e0a380)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1e4c2eaf563fef361a9f35fb77c8057f90bfbefe0322ed1d0d65dac51388aec6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8863d798fd67919830891a6fb337c5b90578e3c9332fa1c5e69709365aacc4f0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareCompoundTransformations]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareCompoundTransformations]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareCompoundTransformations]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__578c2998fd014a8ce5a39c39e90793beb40ed1ffdfacc2c59819c99af95a86b8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareCompoundTransformationsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareCompoundTransformationsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__03b961bcdf665b4ef654a9d1b6800e152ae15ee47daaee77f08048c161568e08)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareCompoundTransformations]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareCompoundTransformations]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareCompoundTransformations]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__86604e1e67361729f2b2d617b748ccd94676631f0ba943756086e4dabd62759b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareContrast",
    jsii_struct_bases=[],
    name_mapping={
        "brightness": "brightness",
        "brightness_var": "brightnessVar",
        "contrast": "contrast",
        "contrast_var": "contrastVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareContrast:
    def __init__(
        self,
        *,
        brightness: typing.Optional[builtins.str] = None,
        brightness_var: typing.Optional[builtins.str] = None,
        contrast: typing.Optional[builtins.str] = None,
        contrast_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param brightness: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        :param brightness_var: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        :param contrast: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param contrast_var: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fd0563f4323968ed101be53cffc0f93690af71d4d012216e160dcf0308425055)
            check_type(argname="argument brightness", value=brightness, expected_type=type_hints["brightness"])
            check_type(argname="argument brightness_var", value=brightness_var, expected_type=type_hints["brightness_var"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument contrast_var", value=contrast_var, expected_type=type_hints["contrast_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if brightness is not None:
            self._values["brightness"] = brightness
        if brightness_var is not None:
            self._values["brightness_var"] = brightness_var
        if contrast is not None:
            self._values["contrast"] = contrast
        if contrast_var is not None:
            self._values["contrast_var"] = contrast_var

    @builtins.property
    def brightness(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        '''
        result = self._values.get("brightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def brightness_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        '''
        result = self._values.get("brightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        result = self._values.get("contrast_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareContrast(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareContrastList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareContrastList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d78e0a07728d8bf67d9172057abccd62a0eb6eaa3bd2cdb57c7897e0627bce6f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareContrastOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__38f307d319d2d89a984bd76a19eeda7fd8c8c82cc7b08b6448eef9e82aaa3a98)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareContrastOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a63d01029a039653a14388df224dd06e879c10016a35b22d9f11fc7935a7f2cd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cede54e3e3a90f38fc630ae5a6222f671bf0beca8a7877a149e66768347442bc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b1aefc7ff42bedf07bc9e4846b2012f46737b40268ff478321fabbbfb178fc0f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareContrast]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareContrast]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6564f11ea55f18bdd683e9bf88a672d437141705ead4536fa14b4a3037247d11)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareContrastOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareContrastOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a65148cce7bf847fc25192bd79baae742ead50a4fc3eb60cf714e72ac82a81e5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetBrightness")
    def reset_brightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightness", []))

    @jsii.member(jsii_name="resetBrightnessVar")
    def reset_brightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightnessVar", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetContrastVar")
    def reset_contrast_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrastVar", []))

    @builtins.property
    @jsii.member(jsii_name="brightnessInput")
    def brightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="brightnessVarInput")
    def brightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastVarInput")
    def contrast_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="brightness")
    def brightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightness"))

    @brightness.setter
    def brightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__00ad7a4a2a799729c6e5c4a16ff18e26181a7b5efa74535626565908455dcb71)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightness", value)

    @builtins.property
    @jsii.member(jsii_name="brightnessVar")
    def brightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightnessVar"))

    @brightness_var.setter
    def brightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__73897a84641144a96231f5c4182712f34c9d994ca3143c1bec43a54866176bad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrast"))

    @contrast.setter
    def contrast(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cc9abd28d05c26f78a05caa03ed8e3a1d37c5b13f4431aee4348db6861a0fa62)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrast", value)

    @builtins.property
    @jsii.member(jsii_name="contrastVar")
    def contrast_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrastVar"))

    @contrast_var.setter
    def contrast_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__deffc8b71ac302f1dcb34d9546a34146ffaa01e66b09422a82368e69b98eb711)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrastVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareContrast]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareContrast]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareContrast]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a025a8be57a49c72700e940d3f161deb148c9060172b359491594d220fa349b0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareCrop",
    jsii_struct_bases=[],
    name_mapping={
        "allow_expansion": "allowExpansion",
        "allow_expansion_var": "allowExpansionVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareCrop:
    def __init__(
        self,
        *,
        allow_expansion: typing.Optional[builtins.str] = None,
        allow_expansion_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_expansion: If cropping an area outside of the existing canvas, expands the image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        :param allow_expansion_var: If cropping an area outside of the existing canvas, expands the image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        :param gravity: Frame of reference for X and Y Positions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Frame of reference for X and Y Positions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The number of pixels to crop along the y-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The number of pixels to crop along the y-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The number of pixels to crop along the x-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The number of pixels to crop along the x-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        :param x_position: The x-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1e142cb93bf9b3c8835442075e060027fdd28032d726bdebb5d1a3aafb0f5ea6)
            check_type(argname="argument allow_expansion", value=allow_expansion, expected_type=type_hints["allow_expansion"])
            check_type(argname="argument allow_expansion_var", value=allow_expansion_var, expected_type=type_hints["allow_expansion_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if allow_expansion is not None:
            self._values["allow_expansion"] = allow_expansion
        if allow_expansion_var is not None:
            self._values["allow_expansion_var"] = allow_expansion_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def allow_expansion(self) -> typing.Optional[builtins.str]:
        '''If cropping an area outside of the existing canvas, expands the image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        '''
        result = self._values.get("allow_expansion")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def allow_expansion_var(self) -> typing.Optional[builtins.str]:
        '''If cropping an area outside of the existing canvas, expands the image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        '''
        result = self._values.get("allow_expansion_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Frame of reference for X and Y Positions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Frame of reference for X and Y Positions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the y-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the y-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the x-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the x-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a274760aed6c0d89a8b6d65671f3942d12700754c66d7d495c22185d486e6983)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a2ebb210ec8443bde47d585085a5258625aece4ae2cce0965d7d8e9f425329e2)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0e5eb2a5ca583d988b9ae49683fb9df315d86a773383a986e61984e3abfa03b4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1573c1abb326412d1940ea7a4bba9620679fd8c744a61933e8b1a5d87a89d55b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3cd71cd9b6ea038d1162f19958d77f5690d88800d8478e972cbb6b7ef4284459)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8ff135138e60613856120550bd49129d63920d1ba969b09bf12c24f231ff6c28)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8d966f8e2745b10b414f197ab83c319fbc7ccea2ab6512d9773cd91ebd6ee6d1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAllowExpansion")
    def reset_allow_expansion(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansion", []))

    @jsii.member(jsii_name="resetAllowExpansionVar")
    def reset_allow_expansion_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansionVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionInput")
    def allow_expansion_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVarInput")
    def allow_expansion_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansion")
    def allow_expansion(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansion"))

    @allow_expansion.setter
    def allow_expansion(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e4425aae6e35d0779467a054b80d1d6f322d5db6a6c1b51e9795ef9aa295f1d7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansion", value)

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVar")
    def allow_expansion_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansionVar"))

    @allow_expansion_var.setter
    def allow_expansion_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c9f5ec7ef78f7ab56450c1b8e79ca4e4d7b71ce3b79b7b7454ab7c24825d3f1c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansionVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__36d665af1da371414ed07dc079754d770cc9430309639d4db4649ae165cb96f6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__19170c8cb3927d62a143fc546932959db18eb44fa93c35d398fc39da713a7da6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c9a13d7cd07e854e93f91945cc9f7183f11dd30a40027ff2b82b94e408eae46e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__808c40b87cc739e0bfae312855e562c4cbfde37ade791d676ddf57be9132ca97)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b6e321d69d52eed4b78229ce9a2e908d9c70d2c46ebe00b33012c33ab81d59a3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0173c0f330bd4f3e876550dbd9703adfbe46bf986a177e050f5c36833a3ddcbb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1ba0d88e0e109f02842a6e7c8e74f9061e2457fa2e91143f3245d58e9286fd43)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f0045eec49192a02e64096ea57c4b82582a4641e7bf324f45a5643a496453763)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__10c5be4ce3a4d42631910ee2ac3f20cf5b95d5401767b31ebb0b0c826770edbf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__897ab94ab7f40667e001257d2969f0a9294f088e54f38710f0bd4b4f8e9731f9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__86202bedf2a2e38e4a0d32b427ab4ea01cfe3200c167733cf36d62e353772cad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareFaceCrop",
    jsii_struct_bases=[],
    name_mapping={
        "algorithm": "algorithm",
        "algorithm_var": "algorithmVar",
        "confidence": "confidence",
        "confidence_var": "confidenceVar",
        "fail_gravity": "failGravity",
        "fail_gravity_var": "failGravityVar",
        "focus": "focus",
        "focus_var": "focusVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "padding": "padding",
        "padding_var": "paddingVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareFaceCrop:
    def __init__(
        self,
        *,
        algorithm: typing.Optional[builtins.str] = None,
        algorithm_var: typing.Optional[builtins.str] = None,
        confidence: typing.Optional[builtins.str] = None,
        confidence_var: typing.Optional[builtins.str] = None,
        fail_gravity: typing.Optional[builtins.str] = None,
        fail_gravity_var: typing.Optional[builtins.str] = None,
        focus: typing.Optional[builtins.str] = None,
        focus_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param algorithm: Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm DataAkamaiImagingPolicyImage#algorithm}
        :param algorithm_var: Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm_var DataAkamaiImagingPolicyImage#algorithm_var}
        :param confidence: With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image. Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence DataAkamaiImagingPolicyImage#confidence}
        :param confidence_var: With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image. Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence_var DataAkamaiImagingPolicyImage#confidence_var}
        :param fail_gravity: Controls placement of the crop if Image and Video Manager does not detect any faces in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        :param fail_gravity_var: Controls placement of the crop if Image and Video Manager does not detect any faces in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        :param focus: Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus DataAkamaiImagingPolicyImage#focus}
        :param focus_var: Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus_var DataAkamaiImagingPolicyImage#focus_var}
        :param gravity: Controls placement of the crop. Directions are relative to the face(s) plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Controls placement of the crop. Directions are relative to the face(s) plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param padding: The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        :param style: Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aaf751870095745610d1bed29a7976c1995f575c4e30e146f999a8d5f5d9c44b)
            check_type(argname="argument algorithm", value=algorithm, expected_type=type_hints["algorithm"])
            check_type(argname="argument algorithm_var", value=algorithm_var, expected_type=type_hints["algorithm_var"])
            check_type(argname="argument confidence", value=confidence, expected_type=type_hints["confidence"])
            check_type(argname="argument confidence_var", value=confidence_var, expected_type=type_hints["confidence_var"])
            check_type(argname="argument fail_gravity", value=fail_gravity, expected_type=type_hints["fail_gravity"])
            check_type(argname="argument fail_gravity_var", value=fail_gravity_var, expected_type=type_hints["fail_gravity_var"])
            check_type(argname="argument focus", value=focus, expected_type=type_hints["focus"])
            check_type(argname="argument focus_var", value=focus_var, expected_type=type_hints["focus_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if algorithm is not None:
            self._values["algorithm"] = algorithm
        if algorithm_var is not None:
            self._values["algorithm_var"] = algorithm_var
        if confidence is not None:
            self._values["confidence"] = confidence
        if confidence_var is not None:
            self._values["confidence_var"] = confidence_var
        if fail_gravity is not None:
            self._values["fail_gravity"] = fail_gravity
        if fail_gravity_var is not None:
            self._values["fail_gravity_var"] = fail_gravity_var
        if focus is not None:
            self._values["focus"] = focus
        if focus_var is not None:
            self._values["focus_var"] = focus_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def algorithm(self) -> typing.Optional[builtins.str]:
        '''Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm DataAkamaiImagingPolicyImage#algorithm}
        '''
        result = self._values.get("algorithm")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def algorithm_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm_var DataAkamaiImagingPolicyImage#algorithm_var}
        '''
        result = self._values.get("algorithm_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def confidence(self) -> typing.Optional[builtins.str]:
        '''With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image.

        Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence DataAkamaiImagingPolicyImage#confidence}
        '''
        result = self._values.get("confidence")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def confidence_var(self) -> typing.Optional[builtins.str]:
        '''With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image.

        Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence_var DataAkamaiImagingPolicyImage#confidence_var}
        '''
        result = self._values.get("confidence_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any faces in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        '''
        result = self._values.get("fail_gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any faces in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        '''
        result = self._values.get("fail_gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def focus(self) -> typing.Optional[builtins.str]:
        '''Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus DataAkamaiImagingPolicyImage#focus}
        '''
        result = self._values.get("focus")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def focus_var(self) -> typing.Optional[builtins.str]:
        '''Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus_var DataAkamaiImagingPolicyImage#focus_var}
        '''
        result = self._values.get("focus_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the face(s) plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the face(s) plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareFaceCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareFaceCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareFaceCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3b6c8325d245d301e677616f3cf716bfe881130b63bd4796fbd3d85e44fabfd0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareFaceCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__51e952fea13e85f2b2032cab9623a66aedfb58195cf7653c7992c193d3621562)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareFaceCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0f7e1ae069d0634e75eef48f3f2aaa0482e3b2bd6359a3b861004f105c9185d5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2df35155b369aed58bedfe7406a13cb41ffe538efe2d5955b94b8c10bb931e53)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__13a821aa88efcbbb2e90d2d078c67e376b0d93f15e8577243de67b2f23b3fbb8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareFaceCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareFaceCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareFaceCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__683957369b74535c269977c49249d35667808e2ae0ff0a2078563f2f6235a9b6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareFaceCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareFaceCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6c3de9fe881faa23b3b304e25983f80784991e11e6d6dccde5f47912c900083f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAlgorithm")
    def reset_algorithm(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAlgorithm", []))

    @jsii.member(jsii_name="resetAlgorithmVar")
    def reset_algorithm_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAlgorithmVar", []))

    @jsii.member(jsii_name="resetConfidence")
    def reset_confidence(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetConfidence", []))

    @jsii.member(jsii_name="resetConfidenceVar")
    def reset_confidence_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetConfidenceVar", []))

    @jsii.member(jsii_name="resetFailGravity")
    def reset_fail_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravity", []))

    @jsii.member(jsii_name="resetFailGravityVar")
    def reset_fail_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravityVar", []))

    @jsii.member(jsii_name="resetFocus")
    def reset_focus(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFocus", []))

    @jsii.member(jsii_name="resetFocusVar")
    def reset_focus_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFocusVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="algorithmInput")
    def algorithm_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "algorithmInput"))

    @builtins.property
    @jsii.member(jsii_name="algorithmVarInput")
    def algorithm_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "algorithmVarInput"))

    @builtins.property
    @jsii.member(jsii_name="confidenceInput")
    def confidence_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "confidenceInput"))

    @builtins.property
    @jsii.member(jsii_name="confidenceVarInput")
    def confidence_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "confidenceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityInput")
    def fail_gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityVarInput")
    def fail_gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="focusInput")
    def focus_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "focusInput"))

    @builtins.property
    @jsii.member(jsii_name="focusVarInput")
    def focus_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "focusVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="algorithm")
    def algorithm(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "algorithm"))

    @algorithm.setter
    def algorithm(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7f8bc6ebe1ae044c3bc508215b8f9db2691008c1e4589cb77f29e13eeae3cf4a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "algorithm", value)

    @builtins.property
    @jsii.member(jsii_name="algorithmVar")
    def algorithm_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "algorithmVar"))

    @algorithm_var.setter
    def algorithm_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__867ecf65de1a6dd105a8c0f738c4824b28517002855ed672d4a9539b70a5d9fe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "algorithmVar", value)

    @builtins.property
    @jsii.member(jsii_name="confidence")
    def confidence(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "confidence"))

    @confidence.setter
    def confidence(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6b3a362beb57047ebf56f9c514b4fba38e3ee435e09e1b9aa3cd0403fde06daa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "confidence", value)

    @builtins.property
    @jsii.member(jsii_name="confidenceVar")
    def confidence_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "confidenceVar"))

    @confidence_var.setter
    def confidence_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bbdab29edce1d7b3a7aad7742a6cc292258cd4bca2910974e73f70b4caa0ac10)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "confidenceVar", value)

    @builtins.property
    @jsii.member(jsii_name="failGravity")
    def fail_gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravity"))

    @fail_gravity.setter
    def fail_gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3c37416767d423fcd5e7f76331cc1188aa5cec3a4b7d6a2684e5bf17f97b3153)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravity", value)

    @builtins.property
    @jsii.member(jsii_name="failGravityVar")
    def fail_gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravityVar"))

    @fail_gravity_var.setter
    def fail_gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__886892f2d0a76eedaf33021255a25912306161263e08274273afda34b39b317d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="focus")
    def focus(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "focus"))

    @focus.setter
    def focus(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d2a6c90552c8df74f575b6f275f14828390e5f79d51001f1ff57186f6d27a521)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "focus", value)

    @builtins.property
    @jsii.member(jsii_name="focusVar")
    def focus_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "focusVar"))

    @focus_var.setter
    def focus_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__852045479089930172a21699b55655792e953881e917ea8caf633c718c0ae8a2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "focusVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__46b297ec9c07aa5ab6d38a2198078cad0a542ad7623a37984d3094afd76d30ae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d6ab0fdbfba3b3910657fa54985ad9416c442ad44c5ee12f1134cee36d342533)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__893df2f6aa42cee9c789769d18786f607ba2f6dda3bede8ba82f10a592747838)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1c93698fa7d9f3aa7295017f75bd098170087494310a734612c9b4931eb0d38c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__251950de8ea5e8aa6bb3730cd9e5bd6802cb00fd2d7365004dcee09cfe6b1251)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__898c0a7ae7a5551e76637ed4f406e13734edd302db1dc71661d7519957e8b307)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d14a9ec78b0fd9d890908e974779d47b45f5f6611f577efa6b27f85f4de58b52)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__08f3a080078442f267f7aaee3bbaaf96b75f9ba95c5545553cc9b8ce08d0e644)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__42957379db7e7698a5a3109abd5382e309ae1198ca78c7109a48d2a2ec73f09e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f8d4fa33b469ea992027c9ec208daa3384737f036006f27fce01ac3ab830f965)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareFaceCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareFaceCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareFaceCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__18b3d543067d6245c779b6d5505225985c52be1578e680fa73f3a526b15c65a0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareFeatureCrop",
    jsii_struct_bases=[],
    name_mapping={
        "fail_gravity": "failGravity",
        "fail_gravity_var": "failGravityVar",
        "feature_radius": "featureRadius",
        "feature_radius_var": "featureRadiusVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "max_features": "maxFeatures",
        "max_features_var": "maxFeaturesVar",
        "min_feature_quality": "minFeatureQuality",
        "min_feature_quality_var": "minFeatureQualityVar",
        "padding": "padding",
        "padding_var": "paddingVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareFeatureCrop:
    def __init__(
        self,
        *,
        fail_gravity: typing.Optional[builtins.str] = None,
        fail_gravity_var: typing.Optional[builtins.str] = None,
        feature_radius: typing.Optional[builtins.str] = None,
        feature_radius_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        max_features: typing.Optional[builtins.str] = None,
        max_features_var: typing.Optional[builtins.str] = None,
        min_feature_quality: typing.Optional[builtins.str] = None,
        min_feature_quality_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fail_gravity: Controls placement of the crop if Image and Video Manager does not detect any features in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        :param fail_gravity_var: Controls placement of the crop if Image and Video Manager does not detect any features in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        :param feature_radius: The size in pixels of the important features to search for. If identified, two features never appear closer together than this value, ``8.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius DataAkamaiImagingPolicyImage#feature_radius}
        :param feature_radius_var: The size in pixels of the important features to search for. If identified, two features never appear closer together than this value, ``8.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius_var DataAkamaiImagingPolicyImage#feature_radius_var}
        :param gravity: Controls placement of the crop. Directions are relative to the region of interest plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Controls placement of the crop. Directions are relative to the region of interest plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param max_features: The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features DataAkamaiImagingPolicyImage#max_features}
        :param max_features_var: The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features_var DataAkamaiImagingPolicyImage#max_features_var}
        :param min_feature_quality: Determines the minimum quality level of the feature identified. To consider a feature important, the feature needs to surpass this value. Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality DataAkamaiImagingPolicyImage#min_feature_quality}
        :param min_feature_quality_var: Determines the minimum quality level of the feature identified. To consider a feature important, the feature needs to surpass this value. Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality_var DataAkamaiImagingPolicyImage#min_feature_quality_var}
        :param padding: Adds space around the region of interest. The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: Adds space around the region of interest. The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        :param style: Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ec57bd4a03784d8b60ec9907be6d2611a057b3aafcfde9454e8c3ef59a343f12)
            check_type(argname="argument fail_gravity", value=fail_gravity, expected_type=type_hints["fail_gravity"])
            check_type(argname="argument fail_gravity_var", value=fail_gravity_var, expected_type=type_hints["fail_gravity_var"])
            check_type(argname="argument feature_radius", value=feature_radius, expected_type=type_hints["feature_radius"])
            check_type(argname="argument feature_radius_var", value=feature_radius_var, expected_type=type_hints["feature_radius_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument max_features", value=max_features, expected_type=type_hints["max_features"])
            check_type(argname="argument max_features_var", value=max_features_var, expected_type=type_hints["max_features_var"])
            check_type(argname="argument min_feature_quality", value=min_feature_quality, expected_type=type_hints["min_feature_quality"])
            check_type(argname="argument min_feature_quality_var", value=min_feature_quality_var, expected_type=type_hints["min_feature_quality_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fail_gravity is not None:
            self._values["fail_gravity"] = fail_gravity
        if fail_gravity_var is not None:
            self._values["fail_gravity_var"] = fail_gravity_var
        if feature_radius is not None:
            self._values["feature_radius"] = feature_radius
        if feature_radius_var is not None:
            self._values["feature_radius_var"] = feature_radius_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if max_features is not None:
            self._values["max_features"] = max_features
        if max_features_var is not None:
            self._values["max_features_var"] = max_features_var
        if min_feature_quality is not None:
            self._values["min_feature_quality"] = min_feature_quality
        if min_feature_quality_var is not None:
            self._values["min_feature_quality_var"] = min_feature_quality_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def fail_gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any features in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        '''
        result = self._values.get("fail_gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any features in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        '''
        result = self._values.get("fail_gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feature_radius(self) -> typing.Optional[builtins.str]:
        '''The size in pixels of the important features to search for.

        If identified, two features never appear closer together than this value, ``8.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius DataAkamaiImagingPolicyImage#feature_radius}
        '''
        result = self._values.get("feature_radius")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feature_radius_var(self) -> typing.Optional[builtins.str]:
        '''The size in pixels of the important features to search for.

        If identified, two features never appear closer together than this value, ``8.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius_var DataAkamaiImagingPolicyImage#feature_radius_var}
        '''
        result = self._values.get("feature_radius_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the region of interest plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the region of interest plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def max_features(self) -> typing.Optional[builtins.str]:
        '''The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features DataAkamaiImagingPolicyImage#max_features}
        '''
        result = self._values.get("max_features")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def max_features_var(self) -> typing.Optional[builtins.str]:
        '''The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features_var DataAkamaiImagingPolicyImage#max_features_var}
        '''
        result = self._values.get("max_features_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def min_feature_quality(self) -> typing.Optional[builtins.str]:
        '''Determines the minimum quality level of the feature identified.

        To consider a feature important, the feature needs to surpass this value.  Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality DataAkamaiImagingPolicyImage#min_feature_quality}
        '''
        result = self._values.get("min_feature_quality")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def min_feature_quality_var(self) -> typing.Optional[builtins.str]:
        '''Determines the minimum quality level of the feature identified.

        To consider a feature important, the feature needs to surpass this value.  Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality_var DataAkamaiImagingPolicyImage#min_feature_quality_var}
        '''
        result = self._values.get("min_feature_quality_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''Adds space around the region of interest.

        The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''Adds space around the region of interest.

        The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareFeatureCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareFeatureCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareFeatureCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__92f1967ab6495492749a0c679f81134e533abe2d8f62a77bf6d3ca0d79437f34)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareFeatureCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__11fb73c765e8dd961dfbda326285b860b0bbdae82418cb1bc7b32ac2829be298)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareFeatureCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__419f69148d14169e26d450f2c4ec52f0fd3e315a070906906ff8371b6f5e92e7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__153a0ac5bf497821843d204b8632d975890ac099a18528034882c12243707a7c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b5c80463a07ccd6f7d5727c6e7c93b7a18b7637266c344247716cba028b0adf4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareFeatureCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareFeatureCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareFeatureCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8eb3218ad6bc72212d9285e0407b6a834f28f49da796b73f1bab6dd01e56a231)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareFeatureCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareFeatureCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__030a9296defdc95f8d3687c8d0124fffba6d79f3953d4edeb4cc074e0808ef40)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetFailGravity")
    def reset_fail_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravity", []))

    @jsii.member(jsii_name="resetFailGravityVar")
    def reset_fail_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravityVar", []))

    @jsii.member(jsii_name="resetFeatureRadius")
    def reset_feature_radius(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureRadius", []))

    @jsii.member(jsii_name="resetFeatureRadiusVar")
    def reset_feature_radius_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureRadiusVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetMaxFeatures")
    def reset_max_features(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxFeatures", []))

    @jsii.member(jsii_name="resetMaxFeaturesVar")
    def reset_max_features_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxFeaturesVar", []))

    @jsii.member(jsii_name="resetMinFeatureQuality")
    def reset_min_feature_quality(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMinFeatureQuality", []))

    @jsii.member(jsii_name="resetMinFeatureQualityVar")
    def reset_min_feature_quality_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMinFeatureQualityVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="failGravityInput")
    def fail_gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityVarInput")
    def fail_gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featureRadiusInput")
    def feature_radius_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featureRadiusInput"))

    @builtins.property
    @jsii.member(jsii_name="featureRadiusVarInput")
    def feature_radius_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featureRadiusVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesInput")
    def max_features_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "maxFeaturesInput"))

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesVarInput")
    def max_features_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "maxFeaturesVarInput"))

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityInput")
    def min_feature_quality_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "minFeatureQualityInput"))

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityVarInput")
    def min_feature_quality_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "minFeatureQualityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravity")
    def fail_gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravity"))

    @fail_gravity.setter
    def fail_gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__85f866bd692f157caf87997633e2179bab354f5c16e0d213d56bc930a6d7df46)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravity", value)

    @builtins.property
    @jsii.member(jsii_name="failGravityVar")
    def fail_gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravityVar"))

    @fail_gravity_var.setter
    def fail_gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__777da2b59a83ebfe1941e1637ffebb2ceae2421920d7e2c036f1c9fd2f1d85aa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="featureRadius")
    def feature_radius(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featureRadius"))

    @feature_radius.setter
    def feature_radius(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6a1bc5a5081e8b4c676ff184a75ec93254493ad08aff44c11129f30910b77e88)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featureRadius", value)

    @builtins.property
    @jsii.member(jsii_name="featureRadiusVar")
    def feature_radius_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featureRadiusVar"))

    @feature_radius_var.setter
    def feature_radius_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a9c91ede26fe283d2a8a6ec7afd1d74eb6c53fea24a58960b44f9aea34a3068b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featureRadiusVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__db66a4e9e5a72b39f2481f08bf6b13922f8c87d426f3ce6b6f01232e46014d70)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__da2f929e1e3bc5f0984dabef43d8a92aa29a2212a9d6860b435194afc987963b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a90b064818511f4e6ddf5ab39a87ff2c99431ea8da11821625c446de4b50635)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__09a6fae7fa753dcb60aa1ac673a9301a439d1011d02e52bf680b598408b11eaa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="maxFeatures")
    def max_features(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "maxFeatures"))

    @max_features.setter
    def max_features(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cf09078b48494c28eb0f56e0e6d7e339d7b888115bf38b7f502b76320d461c2f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "maxFeatures", value)

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesVar")
    def max_features_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "maxFeaturesVar"))

    @max_features_var.setter
    def max_features_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1bd345d5758cda4b45f5dcace491c3f64c503fde8bc98959a11f8a0b68dd6400)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "maxFeaturesVar", value)

    @builtins.property
    @jsii.member(jsii_name="minFeatureQuality")
    def min_feature_quality(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "minFeatureQuality"))

    @min_feature_quality.setter
    def min_feature_quality(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0161e0a4f4ab0e95cf8fee7961542636a91a0d29e69eb83f1f08be11fd177def)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "minFeatureQuality", value)

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityVar")
    def min_feature_quality_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "minFeatureQualityVar"))

    @min_feature_quality_var.setter
    def min_feature_quality_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a2175808c50409469ce2ea1545a5ff888c198f0f8fe2256de47045c8fc9f1ac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "minFeatureQualityVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4abb08023d45a306df4ed0fc6a493e838310ae5fec597d8310ab9d1b2e1f48f2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ae19c4c8bb48b41d10b19d46bc17cc55f19aad3b488c1753f212a2459bfedf1a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__829c2401b1402d6225bae6b4837f03447f8b583148ccdb6dc3447618984d1bd1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__552a6ed08ee2d6ac1eb1cb279cbe59d874a5952dcfaa4dcec70df17d2504b74b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ffef68fff6f035f1ca9029e0257ac5c76973839e917abd0eb898fe8e241722c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5c13b59f1f05ac80982596bccc5c7398cd6ba8d046c9ff3a76fd5c340a28706a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareFeatureCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareFeatureCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareFeatureCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ba6f5e269b23130fe04698583759ca8c15e7c4d7b25c870df4ea0761ad22818)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareFitAndFill",
    jsii_struct_bases=[],
    name_mapping={
        "fill_transformation": "fillTransformation",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareFitAndFill:
    def __init__(
        self,
        *,
        fill_transformation: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareFitAndFillFillTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fill_transformation: fill_transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_transformation DataAkamaiImagingPolicyImage#fill_transformation}
        :param height: The height value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The width value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(fill_transformation, dict):
            fill_transformation = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareFitAndFillFillTransformation(**fill_transformation)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__96072031784f0a78800b34e0dc2680d28b9c481dfb4d2c911c77afe49197846a)
            check_type(argname="argument fill_transformation", value=fill_transformation, expected_type=type_hints["fill_transformation"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fill_transformation is not None:
            self._values["fill_transformation"] = fill_transformation
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def fill_transformation(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareFitAndFillFillTransformation"]:
        '''fill_transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_transformation DataAkamaiImagingPolicyImage#fill_transformation}
        '''
        result = self._values.get("fill_transformation")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareFitAndFillFillTransformation"], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareFitAndFill(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareFitAndFillFillTransformation",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareFitAndFillFillTransformation:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareFitAndFillFillTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareFitAndFillFillTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareFitAndFillFillTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__033e9a5226cbf1bba169a4f14f3ca557f5d0a5d975dc0e2f7e8abf0ed3cc0351)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareFitAndFillFillTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareFitAndFillFillTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareFitAndFillFillTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a956d7f0f8c15ceb4b53f5bfd97f0e4dd8d08b639efc3bf43ec369de4631539)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareFitAndFillList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareFitAndFillList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__77d88493969dc7b32b9ee399c8764800cc9f79f4f8773a3e99fc831c77f7723d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareFitAndFillOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b1fbc37ee6796b4695fe763de883bf01027eced70652127a0856a703302f43a8)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareFitAndFillOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__69c37c1d8eb4a43526d21077c59d04ca6e90485a28cb162f7003b9f1706c2ef7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__181a2bf6ff94976fd0c46ea6f908840649ae4961bbc23c49486a8c5c1f606cb4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c9a1c9917d9f509741745542c521d0ace3abe4dbe387565873186632fb51baf7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareFitAndFill]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareFitAndFill]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareFitAndFill]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd97e35b66c41cc85799d133d237355c2f95cdfcd2a084b2586e8fb4b6ed4bee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareFitAndFillOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareFitAndFillOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f75b04c82d2ed83289790140a9f0d6ddba7459957bc1af8732a70dfe1d395336)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putFillTransformation")
    def put_fill_transformation(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareFitAndFillFillTransformation()

        return typing.cast(None, jsii.invoke(self, "putFillTransformation", [value]))

    @jsii.member(jsii_name="resetFillTransformation")
    def reset_fill_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFillTransformation", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="fillTransformation")
    def fill_transformation(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareFitAndFillFillTransformationOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareFitAndFillFillTransformationOutputReference, jsii.get(self, "fillTransformation"))

    @builtins.property
    @jsii.member(jsii_name="fillTransformationInput")
    def fill_transformation_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareFitAndFillFillTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareFitAndFillFillTransformation], jsii.get(self, "fillTransformationInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d64e2c6043cf185facb7d591c4e448fd270c2577e330d00df84647630015e7da)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6781496b1b1e3fbd9378179444cdbaa501e993835662131e88c146b7ab67a44b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2990270afaaec385a5e7adf1a6bf30cd0c4bcc999ae4bd98f23c112d67a42f46)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ec574d0b5bebed117a561cac1b775760b384707ade1642ef980b902ab3a0c4f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareFitAndFill]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareFitAndFill]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareFitAndFill]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7fff20842e9a14622be25256efcf5603e8aaf61a407fde1aebdc5cc1f4cdb875)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareGoop",
    jsii_struct_bases=[],
    name_mapping={
        "chaos": "chaos",
        "chaos_var": "chaosVar",
        "density": "density",
        "density_var": "densityVar",
        "power": "power",
        "power_var": "powerVar",
        "seed": "seed",
        "seed_var": "seedVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareGoop:
    def __init__(
        self,
        *,
        chaos: typing.Optional[builtins.str] = None,
        chaos_var: typing.Optional[builtins.str] = None,
        density: typing.Optional[builtins.str] = None,
        density_var: typing.Optional[builtins.str] = None,
        power: typing.Optional[builtins.str] = None,
        power_var: typing.Optional[builtins.str] = None,
        seed: typing.Optional[builtins.str] = None,
        seed_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param chaos: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        :param chaos_var: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        :param density: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        :param density_var: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        :param power: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        :param power_var: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        :param seed: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        :param seed_var: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c8e027870ae93d72a971e115888ceb9e06d32bd14b0b884fcc5a0fa961b35576)
            check_type(argname="argument chaos", value=chaos, expected_type=type_hints["chaos"])
            check_type(argname="argument chaos_var", value=chaos_var, expected_type=type_hints["chaos_var"])
            check_type(argname="argument density", value=density, expected_type=type_hints["density"])
            check_type(argname="argument density_var", value=density_var, expected_type=type_hints["density_var"])
            check_type(argname="argument power", value=power, expected_type=type_hints["power"])
            check_type(argname="argument power_var", value=power_var, expected_type=type_hints["power_var"])
            check_type(argname="argument seed", value=seed, expected_type=type_hints["seed"])
            check_type(argname="argument seed_var", value=seed_var, expected_type=type_hints["seed_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if chaos is not None:
            self._values["chaos"] = chaos
        if chaos_var is not None:
            self._values["chaos_var"] = chaos_var
        if density is not None:
            self._values["density"] = density
        if density_var is not None:
            self._values["density_var"] = density_var
        if power is not None:
            self._values["power"] = power
        if power_var is not None:
            self._values["power_var"] = power_var
        if seed is not None:
            self._values["seed"] = seed
        if seed_var is not None:
            self._values["seed_var"] = seed_var

    @builtins.property
    def chaos(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        '''
        result = self._values.get("chaos")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def chaos_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        '''
        result = self._values.get("chaos_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        '''
        result = self._values.get("density")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density_var(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        '''
        result = self._values.get("density_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        '''
        result = self._values.get("power")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power_var(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        '''
        result = self._values.get("power_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        '''
        result = self._values.get("seed")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed_var(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        result = self._values.get("seed_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareGoop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareGoopList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareGoopList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cc13d9ca7037947c1a8d8671e1faeee5e1ddc5986645982e55c573e1fe5161de)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareGoopOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6d98f5e5d92c8170e89addba5ae1101ce6d5aa1766815df3b322fc2f53b51ad1)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareGoopOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a4e52079fdd7f71856142b12b170dc7c55f9842a2fc7467f5061f27abf7057f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b4be0cd3fbd5ec2373946904ce1cd6adfd9385d5745cca3886b2af499155afef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e1842134929f928efad2619fcfc7458826bbd67d6648ec02d792794f25049996)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareGoop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareGoop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1427288648a949cf49b4125367adab012ddfa7666c2c944351c55ccbfffae4c6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareGoopOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareGoopOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2b0a97fd725e060a810cf1a3c95a20f374922d0073edcd6a4c49e8baaf7c53e1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetChaos")
    def reset_chaos(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaos", []))

    @jsii.member(jsii_name="resetChaosVar")
    def reset_chaos_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaosVar", []))

    @jsii.member(jsii_name="resetDensity")
    def reset_density(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensity", []))

    @jsii.member(jsii_name="resetDensityVar")
    def reset_density_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensityVar", []))

    @jsii.member(jsii_name="resetPower")
    def reset_power(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPower", []))

    @jsii.member(jsii_name="resetPowerVar")
    def reset_power_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPowerVar", []))

    @jsii.member(jsii_name="resetSeed")
    def reset_seed(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeed", []))

    @jsii.member(jsii_name="resetSeedVar")
    def reset_seed_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeedVar", []))

    @builtins.property
    @jsii.member(jsii_name="chaosInput")
    def chaos_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosInput"))

    @builtins.property
    @jsii.member(jsii_name="chaosVarInput")
    def chaos_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosVarInput"))

    @builtins.property
    @jsii.member(jsii_name="densityInput")
    def density_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityInput"))

    @builtins.property
    @jsii.member(jsii_name="densityVarInput")
    def density_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="powerInput")
    def power_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerInput"))

    @builtins.property
    @jsii.member(jsii_name="powerVarInput")
    def power_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerVarInput"))

    @builtins.property
    @jsii.member(jsii_name="seedInput")
    def seed_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedInput"))

    @builtins.property
    @jsii.member(jsii_name="seedVarInput")
    def seed_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedVarInput"))

    @builtins.property
    @jsii.member(jsii_name="chaos")
    def chaos(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaos"))

    @chaos.setter
    def chaos(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7bcfec5b64a81832a429218c528b80df4ed2ebc8fc16390c1b9f7256f7243281)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaos", value)

    @builtins.property
    @jsii.member(jsii_name="chaosVar")
    def chaos_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaosVar"))

    @chaos_var.setter
    def chaos_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__abc9cade008ebaf5edbdac5cf5ccbebd3ed990452fbb8c513385d6f9c2b9b7c9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaosVar", value)

    @builtins.property
    @jsii.member(jsii_name="density")
    def density(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "density"))

    @density.setter
    def density(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3b762db39f6b42aeef7253af01209d023e2d0eae243b64b5c4de1e8b2265f876)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "density", value)

    @builtins.property
    @jsii.member(jsii_name="densityVar")
    def density_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "densityVar"))

    @density_var.setter
    def density_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6a281f0221a1e171d22a8cf20efb80aefbfd46cecbcf27e1321837b3a59b455a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "densityVar", value)

    @builtins.property
    @jsii.member(jsii_name="power")
    def power(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "power"))

    @power.setter
    def power(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be5000409a355ad0dc114ac4f1c00bb3474260722b51bd7030beb57c939d42ee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "power", value)

    @builtins.property
    @jsii.member(jsii_name="powerVar")
    def power_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "powerVar"))

    @power_var.setter
    def power_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2e8ed0e004bb684420a8271b3f651a493bf245e9b06737f30128d028c2c8f1e7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "powerVar", value)

    @builtins.property
    @jsii.member(jsii_name="seed")
    def seed(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seed"))

    @seed.setter
    def seed(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a80b21b7a9dd5ae8b9a5597e0eca315f055413b73c88f0f5b11ee77d7a635f8e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seed", value)

    @builtins.property
    @jsii.member(jsii_name="seedVar")
    def seed_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seedVar"))

    @seed_var.setter
    def seed_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a264f3eb5135648fb53a6b939b4b6f7363ee5caefbc5fdf2e53ad363adbc25bb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seedVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareGoop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareGoop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareGoop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f2f3780c0a04f7bf3b833976025c1fb624c4c5e3166d4bb1e89831fc58ee5ab5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareGrayscale",
    jsii_struct_bases=[],
    name_mapping={"type": "type", "type_var": "typeVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareGrayscale:
    def __init__(
        self,
        *,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param type: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e163779cf846e4f6f40db6aae6bd02d992c2d0957deceab17694e42eb73eb677)
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareGrayscale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareGrayscaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareGrayscaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5e8fb19300cee6ac70ad07063524e8a50fca95c432c174b5ede9d696231176a3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareGrayscaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1b3e612bb72b5eaeeb2d8377b32324cb20cbc205c41f8103be7032be06026cc1)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareGrayscaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c40ad83cb7bfd214ae6b20044cffa00ef52238808a06e1e06c2bba9373fe2b6f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7bb689d1ce805b15fd59fd64a8a31ce8efd1abe9d3259e3643b90f116ee629e0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eee7c9c8a6f9ed2604ac927313e1ea57571f77a1b1c94904e80ecf163df5b0da)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareGrayscale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareGrayscale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__278b3c0dfdea03211f823483b20a9463f15369023942b233d0b09f672def5afc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareGrayscaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareGrayscaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a226483183990cebaae0c544bdeeeab86332d94cb852871939ca400e09e653d5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d67faaee9c13f12181a94404675975317301ce6428b4a1ca1a06a476fa158a9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aaea0f6ef57e0bfcef816550c2e80d0ed50108c667713d2b6963e61aed024d4f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareGrayscale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareGrayscale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareGrayscale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__add4ca637fdd841e3cce91516a15ab1fd40dbfeb158dff1d7cb0a16bf6e251dd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareHsl",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "lightness": "lightness",
        "lightness_var": "lightnessVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareHsl:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness: typing.Optional[builtins.str] = None,
        lightness_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        :param lightness_var: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__459606150dac3bdb90b7bd43edadfefe83c637cc539d9112cab32c40c1f6561c)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness", value=lightness, expected_type=type_hints["lightness"])
            check_type(argname="argument lightness_var", value=lightness_var, expected_type=type_hints["lightness_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness is not None:
            self._values["lightness"] = lightness
        if lightness_var is not None:
            self._values["lightness_var"] = lightness_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        '''
        result = self._values.get("lightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        '''
        result = self._values.get("lightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareHsl(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareHslList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareHslList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ff879ad53fb21b78e3db8095c3210f4af86d4a24bd23b32f266776c462cb442a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareHslOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d5995c7a9bdc0d26fc03cfa63be8acc64a218510650b891021446a9771437a8a)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareHslOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6996629b053aae7350cb7ab22f4329d862ef19d3f8e62056b0b7725fe0b58e9e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d975a5f1b0208968b49cdb6868fdb71b62b3a1ddd794a54ba2619bee0c5cd07e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6aaec5bb079d2cdf98a2930c0d980ce4387dbbb51c2e0d2a7054ef7c674e830f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareHsl]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareHsl]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7635912ba7916944bcb83bf8f6de9b0be067b4a976227968b8dc707ba0d70a5c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareHslOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareHslOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e7eead1d0cacfdec02770b2ac39b5aa0e12416b76c36fa9d818e4e70d9f4239d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightness")
    def reset_lightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightness", []))

    @jsii.member(jsii_name="resetLightnessVar")
    def reset_lightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessInput")
    def lightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessVarInput")
    def lightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8beddf7075d7c3763e98da8d48a1b478e8690b55330796f14c03767650281e5d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c8dbb616f0380fe6b171e97d97466312c45a845c8cc7f527aa6b92caeaf258b2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightness")
    def lightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightness"))

    @lightness.setter
    def lightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cdcbf5e7d8b99b1a025caf07597be280edfc03bf81953d4ef16c00360f200aa1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightness", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessVar")
    def lightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessVar"))

    @lightness_var.setter
    def lightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2e6106b9b8968404861928b3e6c666958b25becfcfaa9fd467f3b380773c3197)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__febdfadeedd0e957d1a09c09c65dd5ab2347686bf13dcb058e18e3c236af150e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4230d692f7cc96c42e62fe6f6fa8b59730239b97d96a505dba5f4e8f2fdb0705)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareHsl]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareHsl]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareHsl]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e3ddc5ae9e67be21d878a5cd4828323ba42ff4b711fbe5a4f91f5318dd7e7bb3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareHsv",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareHsv:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        :param value: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__329255a12df3fe2e0a219d5215c0daef7dd77491c30c2361d5e3a4040da3e8b2)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareHsv(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareHsvList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareHsvList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2c04d6e6cf84cbeddbba3acc32578100f18cf40463675f39b4dd437ca9856ce5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareHsvOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__64e01426e1819918f5d79ef2e9e5797cbd56d9288a39ae502bd9e443ac47b766)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareHsvOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9eb53e996cd9a2c3ead10adcb8e929eb0748303e70f29ccb7d708d80df498fd4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__86385bb511a729804b69f21496f85c51664a090c8708a768f83f64ab8924f4d8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__affcaf21c8311b7b52e59454bc8c7251039e3d683b15affef0beafa9905a066e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareHsv]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareHsv]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f9a5b28e29fa4b176993232643e33c042378b04f48ce282900c6af1f05ced833)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareHsvOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareHsvOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e91bcc74f5665fea53172535bed34fdcce0f90d393ae642c1695f0cb8ca8338f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0dfc371b99be9ab6b453f9cbe7bab04cf0de78d19b2cf72d16bb5f7a73c64f82)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__49a33af0d8d2a3854c9870732e97fe9edcd5b31b24d176914ae76c1fb6c5ec32)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__769247d59e8094399c81d95396db905b205b330f14e7764704b22590e1004847)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__974cabfb78f0a5d4f353254a8f9d2f1dca8a732bd22b1e700eb0dd00d4047387)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__67bea9aa7c7d304be90577877ce3f3536bae59209f369db5031e184d78a6492f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__19aaaa4bcb10e879201394dea620db2dab5e9a71400b76e8d85284ecca6753b1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareHsv]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareHsv]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareHsv]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b5ebb852b48dd3b9fec9e137bfa8254e2eda1e710576138207be1fb70d68540c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfDimension",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "dimension": "dimension",
        "dimension_var": "dimensionVar",
        "equal": "equal",
        "greater_than": "greaterThan",
        "less_than": "lessThan",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfDimension:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfDimensionDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        dimension: typing.Optional[builtins.str] = None,
        dimension_var: typing.Optional[builtins.str] = None,
        equal: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfDimensionEqual", typing.Dict[builtins.str, typing.Any]]] = None,
        greater_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfDimensionGreaterThan", typing.Dict[builtins.str, typing.Any]]] = None,
        less_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfDimensionLessThan", typing.Dict[builtins.str, typing.Any]]] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param dimension: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        :param dimension_var: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        :param equal: equal block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        :param greater_than: greater_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        :param less_than: less_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        :param value: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfDimensionDefault(**default)
        if isinstance(equal, dict):
            equal = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfDimensionEqual(**equal)
        if isinstance(greater_than, dict):
            greater_than = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfDimensionGreaterThan(**greater_than)
        if isinstance(less_than, dict):
            less_than = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfDimensionLessThan(**less_than)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__68bcb6500b685ac557a5da34565dd720dbd057f0ea2a8e163c818268b8c63e06)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument dimension", value=dimension, expected_type=type_hints["dimension"])
            check_type(argname="argument dimension_var", value=dimension_var, expected_type=type_hints["dimension_var"])
            check_type(argname="argument equal", value=equal, expected_type=type_hints["equal"])
            check_type(argname="argument greater_than", value=greater_than, expected_type=type_hints["greater_than"])
            check_type(argname="argument less_than", value=less_than, expected_type=type_hints["less_than"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if dimension is not None:
            self._values["dimension"] = dimension
        if dimension_var is not None:
            self._values["dimension_var"] = dimension_var
        if equal is not None:
            self._values["equal"] = equal
        if greater_than is not None:
            self._values["greater_than"] = greater_than
        if less_than is not None:
            self._values["less_than"] = less_than
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfDimensionDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfDimensionDefault"], result)

    @builtins.property
    def dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        '''
        result = self._values.get("dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        '''
        result = self._values.get("dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def equal(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfDimensionEqual"]:
        '''equal block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        '''
        result = self._values.get("equal")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfDimensionEqual"], result)

    @builtins.property
    def greater_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfDimensionGreaterThan"]:
        '''greater_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        '''
        result = self._values.get("greater_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfDimensionGreaterThan"], result)

    @builtins.property
    def less_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfDimensionLessThan"]:
        '''less_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        '''
        result = self._values.get("less_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfDimensionLessThan"], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfDimension(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfDimensionDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfDimensionDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfDimensionDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfDimensionDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfDimensionDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__743fa8bc8403c1d7e1c6d4ccd2522f6ef8889a1d9e20ba3fc264f914a5649948)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfDimensionDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfDimensionDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a9312437cdf545af43b7e8391489e5265c6b6f07f9c1bee454e98f4585baed7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfDimensionEqual",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfDimensionEqual:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfDimensionEqual(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfDimensionEqualOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfDimensionEqualOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7409378fc85074bf69073cf68c2ea96b33f2f17b358bc3c7230cbc466c4be9a9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfDimensionEqual], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfDimensionEqual],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__726bc8b9d5d3ae4b41fe4a06dfc96855199da9624a6e5592a13c221290cca596)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfDimensionGreaterThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfDimensionGreaterThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfDimensionGreaterThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfDimensionGreaterThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfDimensionGreaterThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5c93f54bfd599d4f5f474509074000a164009bb22985f7c0bf524178f18280e8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfDimensionGreaterThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfDimensionGreaterThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e97148a7b34521de481820d03fead325ba76981b2efba57593c4da31010c24fb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfDimensionLessThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfDimensionLessThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfDimensionLessThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfDimensionLessThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfDimensionLessThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0f7e0051e384f836f71161585cf5d3d9e53fbb6187b5d7653f6f3cd9ba109605)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfDimensionLessThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfDimensionLessThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9e61ad9ea852730c48be3b5145aac58387be1feaa9212918e51b5b19ab614e3c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfDimensionList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfDimensionList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6c0e6fea847b559c341ad510a98d8fc44287b98f90a3bd3168c1fa1adff42798)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfDimensionOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0356e3d0ea7ff85ac17bcaedc154ea903c7d024cd15615e2bd496f91ad9a85cb)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfDimensionOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cfd7857f88217f58046810303bf4140f3fd2594bbc61ba27451160dcb600ec19)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__258aed32e7a7e463303fc52c8e85d730662df376458020f1d9074ddb8f0c4434)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3e90a51b9e6d84b9bc5227d404e82bdf6840c0e80543483de8cdd492743e2ff8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfDimension]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfDimension]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__adb3add31852ce61118c240529e7c2d8d4d71d861f40298adeafa2435b2c051c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfDimensionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfDimensionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__234d35eb94e3d056856ea41969f9fa0859a355ec00df1a1e62d8cdf70b961f6b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfDimensionDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putEqual")
    def put_equal(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfDimensionEqual()

        return typing.cast(None, jsii.invoke(self, "putEqual", [value]))

    @jsii.member(jsii_name="putGreaterThan")
    def put_greater_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfDimensionGreaterThan()

        return typing.cast(None, jsii.invoke(self, "putGreaterThan", [value]))

    @jsii.member(jsii_name="putLessThan")
    def put_less_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfDimensionLessThan()

        return typing.cast(None, jsii.invoke(self, "putLessThan", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetDimension")
    def reset_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimension", []))

    @jsii.member(jsii_name="resetDimensionVar")
    def reset_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimensionVar", []))

    @jsii.member(jsii_name="resetEqual")
    def reset_equal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEqual", []))

    @jsii.member(jsii_name="resetGreaterThan")
    def reset_greater_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGreaterThan", []))

    @jsii.member(jsii_name="resetLessThan")
    def reset_less_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLessThan", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfDimensionDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfDimensionDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="equal")
    def equal(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfDimensionEqualOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfDimensionEqualOutputReference, jsii.get(self, "equal"))

    @builtins.property
    @jsii.member(jsii_name="greaterThan")
    def greater_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfDimensionGreaterThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfDimensionGreaterThanOutputReference, jsii.get(self, "greaterThan"))

    @builtins.property
    @jsii.member(jsii_name="lessThan")
    def less_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfDimensionLessThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfDimensionLessThanOutputReference, jsii.get(self, "lessThan"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfDimensionDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionInput")
    def dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionVarInput")
    def dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="equalInput")
    def equal_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfDimensionEqual], jsii.get(self, "equalInput"))

    @builtins.property
    @jsii.member(jsii_name="greaterThanInput")
    def greater_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfDimensionGreaterThan], jsii.get(self, "greaterThanInput"))

    @builtins.property
    @jsii.member(jsii_name="lessThanInput")
    def less_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfDimensionLessThan], jsii.get(self, "lessThanInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="dimension")
    def dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimension"))

    @dimension.setter
    def dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6deb4f7e2cd4bc61c05fa4436ef323184a061e4410880ebc12fba0d1e791111b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimension", value)

    @builtins.property
    @jsii.member(jsii_name="dimensionVar")
    def dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimensionVar"))

    @dimension_var.setter
    def dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9275baa9724eadf39caa492948b4859b2952165b31846e4f1a8b06126f24ceb1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__964e5262584b930679190b203281d30a2fdcedb5bb20a64252da1023d2fd2193)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3e5a7ecc6d389e4b0202bb06b7b95514589042925c10c4789334e921bfd7637f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfDimension]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfDimension]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfDimension]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a41d3123347ca64db2e83b8a87e85925ae316fc9c6a6ff57adf041bad3f6ca30)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfOrientation",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "landscape": "landscape",
        "portrait": "portrait",
        "square": "square",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfOrientation:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfOrientationDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        landscape: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfOrientationLandscape", typing.Dict[builtins.str, typing.Any]]] = None,
        portrait: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfOrientationPortrait", typing.Dict[builtins.str, typing.Any]]] = None,
        square: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfOrientationSquare", typing.Dict[builtins.str, typing.Any]]] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param landscape: landscape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        :param portrait: portrait block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        :param square: square block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfOrientationDefault(**default)
        if isinstance(landscape, dict):
            landscape = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfOrientationLandscape(**landscape)
        if isinstance(portrait, dict):
            portrait = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfOrientationPortrait(**portrait)
        if isinstance(square, dict):
            square = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfOrientationSquare(**square)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__14255674e118ff0007e8635210e405e9b3639829383244cda16115ab27816a73)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument landscape", value=landscape, expected_type=type_hints["landscape"])
            check_type(argname="argument portrait", value=portrait, expected_type=type_hints["portrait"])
            check_type(argname="argument square", value=square, expected_type=type_hints["square"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if landscape is not None:
            self._values["landscape"] = landscape
        if portrait is not None:
            self._values["portrait"] = portrait
        if square is not None:
            self._values["square"] = square

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfOrientationDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfOrientationDefault"], result)

    @builtins.property
    def landscape(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfOrientationLandscape"]:
        '''landscape block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        '''
        result = self._values.get("landscape")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfOrientationLandscape"], result)

    @builtins.property
    def portrait(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfOrientationPortrait"]:
        '''portrait block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        '''
        result = self._values.get("portrait")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfOrientationPortrait"], result)

    @builtins.property
    def square(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfOrientationSquare"]:
        '''square block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        result = self._values.get("square")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfOrientationSquare"], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfOrientation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfOrientationDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfOrientationDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfOrientationDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfOrientationDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfOrientationDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7db3b10193aa5aee4f15348d59e830977c51bc951da0982769827d8dbe4a3cfc)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfOrientationDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfOrientationDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2bbb55fd7fe7b3b59c44a584237e169e9d9003d73984bd2e19d6d92afba14d76)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfOrientationLandscape",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfOrientationLandscape:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfOrientationLandscape(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfOrientationLandscapeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfOrientationLandscapeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8737893d2d0a38515918dbf971eb572b1e5f78c902302c80a5f42330da76d6a5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfOrientationLandscape], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfOrientationLandscape],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a4f6d45d3e5d6f2606f444f6cc21653c7af01a75d003c2c9670df8624cec30eb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfOrientationList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfOrientationList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__79d5978d371b2a85df57d6f8d8e2f0f0f0b712a503e551244af2776a4db182eb)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfOrientationOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5b18b4a5cedb60877f03be562ca020e4680ffb745e81d9e341f47f03f03235c0)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfOrientationOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f458b22e8fb35552f882df183bafe1dc67ce6e7b26c5d2c70dcd2496eacec3b4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c73d6873a8f3293e3d695ef81393a73941175aad55147d6cbed12c411c2b1826)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6eeffceb3075a87f6a8630fbeaf03907066f00d61904c74399feae6339f17ace)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfOrientation]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfOrientation]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bf9b5b1c6ea39a3387384aab9d9a5cc4ae782e96325fc83ce643a2116a5c1125)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfOrientationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfOrientationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8d9cb230cab2eabf8df78fbc24a277d0acc05e86b172d8b9ac62557662974fd7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfOrientationDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putLandscape")
    def put_landscape(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfOrientationLandscape()

        return typing.cast(None, jsii.invoke(self, "putLandscape", [value]))

    @jsii.member(jsii_name="putPortrait")
    def put_portrait(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfOrientationPortrait()

        return typing.cast(None, jsii.invoke(self, "putPortrait", [value]))

    @jsii.member(jsii_name="putSquare")
    def put_square(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfOrientationSquare()

        return typing.cast(None, jsii.invoke(self, "putSquare", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetLandscape")
    def reset_landscape(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLandscape", []))

    @jsii.member(jsii_name="resetPortrait")
    def reset_portrait(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPortrait", []))

    @jsii.member(jsii_name="resetSquare")
    def reset_square(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSquare", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfOrientationDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfOrientationDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="landscape")
    def landscape(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfOrientationLandscapeOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfOrientationLandscapeOutputReference, jsii.get(self, "landscape"))

    @builtins.property
    @jsii.member(jsii_name="portrait")
    def portrait(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfOrientationPortraitOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfOrientationPortraitOutputReference", jsii.get(self, "portrait"))

    @builtins.property
    @jsii.member(jsii_name="square")
    def square(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfOrientationSquareOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfOrientationSquareOutputReference", jsii.get(self, "square"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfOrientationDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="landscapeInput")
    def landscape_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfOrientationLandscape], jsii.get(self, "landscapeInput"))

    @builtins.property
    @jsii.member(jsii_name="portraitInput")
    def portrait_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfOrientationPortrait"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfOrientationPortrait"], jsii.get(self, "portraitInput"))

    @builtins.property
    @jsii.member(jsii_name="squareInput")
    def square_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfOrientationSquare"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfOrientationSquare"], jsii.get(self, "squareInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfOrientation]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfOrientation]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfOrientation]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__09f8606ed4519662aaf1a4121d0479c646296b86575236ce8063aa9469d1e352)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfOrientationPortrait",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfOrientationPortrait:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfOrientationPortrait(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfOrientationPortraitOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfOrientationPortraitOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__38480f22ea0fc04cc16af4094f54d2319de1f12749bd2962c6fca3e8f45d9e5f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfOrientationPortrait]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfOrientationPortrait], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfOrientationPortrait],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4649233953ad33679e3ffb6750a55934102c40ae17ca22147b45cd6154e4e4c2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfOrientationSquare",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfOrientationSquare:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfOrientationSquare(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfOrientationSquareOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfOrientationSquareOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f2a4d38fc2502f0a9d545c0d7a18c2447ec97f9d1ee8430aeb18bee8a738e292)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfOrientationSquare]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfOrientationSquare], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfOrientationSquare],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__84a8b3382904dc2518ff3476ade13509b0eb32590e9270ff527523c35624c4c8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareImQuery",
    jsii_struct_bases=[],
    name_mapping={
        "allowed_transformations": "allowedTransformations",
        "query_var": "queryVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareImQuery:
    def __init__(
        self,
        *,
        allowed_transformations: typing.Sequence[builtins.str],
        query_var: builtins.str,
    ) -> None:
        '''
        :param allowed_transformations: Specifies the transformations that can be applied using the query string parameter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allowed_transformations DataAkamaiImagingPolicyImage#allowed_transformations}
        :param query_var: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#query_var DataAkamaiImagingPolicyImage#query_var}.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__06dbf502cc0830d2ffc29e15b42d02f6ff529fdc34c38643b404dea6d91db160)
            check_type(argname="argument allowed_transformations", value=allowed_transformations, expected_type=type_hints["allowed_transformations"])
            check_type(argname="argument query_var", value=query_var, expected_type=type_hints["query_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "allowed_transformations": allowed_transformations,
            "query_var": query_var,
        }

    @builtins.property
    def allowed_transformations(self) -> typing.List[builtins.str]:
        '''Specifies the transformations that can be applied using the query string parameter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allowed_transformations DataAkamaiImagingPolicyImage#allowed_transformations}
        '''
        result = self._values.get("allowed_transformations")
        assert result is not None, "Required property 'allowed_transformations' is missing"
        return typing.cast(typing.List[builtins.str], result)

    @builtins.property
    def query_var(self) -> builtins.str:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#query_var DataAkamaiImagingPolicyImage#query_var}.'''
        result = self._values.get("query_var")
        assert result is not None, "Required property 'query_var' is missing"
        return typing.cast(builtins.str, result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareImQuery(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareImQueryList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareImQueryList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5bd274e4ffdde4c264824a2a1ac08285728ca2ab91fb0f89ea9f5ac68e302146)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareImQueryOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2cba4f547b4b9e70393f473f0c0fbbe872cb05a7769f7d6de62ef58df2b5bda9)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareImQueryOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0e462529c68083d13ba0cc68858329e99f6e20dd7092778e1c60320b17f5cc32)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1311203c0af297858d872361a6b1d7f154169c457c49eb2886a9d5baa9602914)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f6351f2d30b864454a68a22a7257d959668f7d50c3442ac2344a6693adcbcad3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareImQuery]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareImQuery]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareImQuery]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f7efcdebe0dd2c6a6a49b3255cbd576262ed074f70e1151c5695965c185014c1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareImQueryOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareImQueryOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ce7ed26b816ad79fa3729e65b13669c4ab3158118333fa067a3dd2134f6341e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @builtins.property
    @jsii.member(jsii_name="allowedTransformationsInput")
    def allowed_transformations_input(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "allowedTransformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="queryVarInput")
    def query_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "queryVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowedTransformations")
    def allowed_transformations(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "allowedTransformations"))

    @allowed_transformations.setter
    def allowed_transformations(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b319e873837acef6a4d695f21d9d6e9396671198c5603e580695b69a56a7ddf4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowedTransformations", value)

    @builtins.property
    @jsii.member(jsii_name="queryVar")
    def query_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "queryVar"))

    @query_var.setter
    def query_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fe52dad4fdcb12a0640420c70b3849ec3066069f815de8309236264f7f3b1711)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "queryVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareImQuery]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareImQuery]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareImQuery]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__21fa3fc8a3bf320bfb9f6393a94cb0182b798ba646eb93ad0f7e8ef4e212d2ae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareMaxColors",
    jsii_struct_bases=[],
    name_mapping={"colors": "colors", "colors_var": "colorsVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareMaxColors:
    def __init__(
        self,
        *,
        colors: typing.Optional[builtins.str] = None,
        colors_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param colors: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        :param colors_var: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__57e09c3e77ad027fe30b53e7fd7bfdeb86de946a6e00333282fb15d214b9436d)
            check_type(argname="argument colors", value=colors, expected_type=type_hints["colors"])
            check_type(argname="argument colors_var", value=colors_var, expected_type=type_hints["colors_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if colors is not None:
            self._values["colors"] = colors
        if colors_var is not None:
            self._values["colors_var"] = colors_var

    @builtins.property
    def colors(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        '''
        result = self._values.get("colors")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def colors_var(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        result = self._values.get("colors_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareMaxColors(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareMaxColorsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareMaxColorsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__22cf695fb5f942aaa463984a5ad1ed93e30eb157e61f35faa9e71a6297894358)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareMaxColorsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2b0b5dfabfbecb682f355906ffab1f860470b34d345c5d28c299e4a67b8a786d)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareMaxColorsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__afe2b3011b538c68b4467f40e0a54222836e266d192e4c5c4a6827096bd7d439)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6aa181c9ae05b385fea524c0c47c1ca69bf83810f9170604a607e6e9f5b28f41)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c485e5fe61e58a6e232cf0ce69d2baa5f481b3cc3ac96f2dbdbe1b7fe05eae3f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareMaxColors]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareMaxColors]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__864b2c2f25d59601fe6ee3f3f59897fee4cc5770de99872827b5358011dd28d0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareMaxColorsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareMaxColorsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a876f35fe8c925e1710ad281340491f8b32b8b64ca9463425685560be2b9048)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColors")
    def reset_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColors", []))

    @jsii.member(jsii_name="resetColorsVar")
    def reset_colors_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorsVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorsInput")
    def colors_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsInput"))

    @builtins.property
    @jsii.member(jsii_name="colorsVarInput")
    def colors_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsVarInput"))

    @builtins.property
    @jsii.member(jsii_name="colors")
    def colors(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colors"))

    @colors.setter
    def colors(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0513a223da046c1b3827a76231ac26488780432733062a33847b0db552dcad9f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colors", value)

    @builtins.property
    @jsii.member(jsii_name="colorsVar")
    def colors_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorsVar"))

    @colors_var.setter
    def colors_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2f03e8bfaefcd32b662e499a9a1da5e1726a9f6e76a8b9c9001acb256eec93f2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorsVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareMaxColors]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareMaxColors]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareMaxColors]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__85934676df9473f542c7f0a7f970295cf72254fa62e75b7fa4d8e7fecb888090)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareMirror",
    jsii_struct_bases=[],
    name_mapping={
        "horizontal": "horizontal",
        "horizontal_var": "horizontalVar",
        "vertical": "vertical",
        "vertical_var": "verticalVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareMirror:
    def __init__(
        self,
        *,
        horizontal: typing.Optional[builtins.str] = None,
        horizontal_var: typing.Optional[builtins.str] = None,
        vertical: typing.Optional[builtins.str] = None,
        vertical_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param horizontal: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        :param horizontal_var: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        :param vertical: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        :param vertical_var: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__989a276d487d6234224c7d371a207589e9e31cb9c8e8e432314a79385b4cbe17)
            check_type(argname="argument horizontal", value=horizontal, expected_type=type_hints["horizontal"])
            check_type(argname="argument horizontal_var", value=horizontal_var, expected_type=type_hints["horizontal_var"])
            check_type(argname="argument vertical", value=vertical, expected_type=type_hints["vertical"])
            check_type(argname="argument vertical_var", value=vertical_var, expected_type=type_hints["vertical_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if horizontal is not None:
            self._values["horizontal"] = horizontal
        if horizontal_var is not None:
            self._values["horizontal_var"] = horizontal_var
        if vertical is not None:
            self._values["vertical"] = vertical
        if vertical_var is not None:
            self._values["vertical_var"] = vertical_var

    @builtins.property
    def horizontal(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        '''
        result = self._values.get("horizontal")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def horizontal_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        '''
        result = self._values.get("horizontal_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        '''
        result = self._values.get("vertical")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        result = self._values.get("vertical_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareMirror(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareMirrorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareMirrorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a926ec6663486b73b7371a4ebb4a10c7bb32973dc5af796a57a5bd402317404)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareMirrorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__704787eb796237bc7f1987b5a1da36753e67d9a6d5dc6ce50f101e30eaf26eec)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareMirrorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9cb2f6f67976db411853b224261bf3e4736b2d371901a772d46b9144a4700aae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9519bf99ce0a43c5ebf285088eadf87c11b04ca54dcdeb665f70717b8e6f9d2a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f7137340b0127052d8e5a21e286a77e42e613c0c60cc93ddebf990e2b6a08d87)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareMirror]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareMirror]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b76ec43d3a669bf9423024fa20cff0cf8bb7ee79d2d88bde7ca208b2cc98eb57)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareMirrorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareMirrorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__212111c9e1da5b2cfcf47cab30a21df0d9374872bb54d2d64e2b29d5820a2daf)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHorizontal")
    def reset_horizontal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontal", []))

    @jsii.member(jsii_name="resetHorizontalVar")
    def reset_horizontal_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontalVar", []))

    @jsii.member(jsii_name="resetVertical")
    def reset_vertical(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVertical", []))

    @jsii.member(jsii_name="resetVerticalVar")
    def reset_vertical_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVerticalVar", []))

    @builtins.property
    @jsii.member(jsii_name="horizontalInput")
    def horizontal_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontalVarInput")
    def horizontal_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalInput")
    def vertical_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalVarInput")
    def vertical_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontal")
    def horizontal(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontal"))

    @horizontal.setter
    def horizontal(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2bdbe614b81a090080e6501d1942db4e2154fb11f86a29063244415169fe40bd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontal", value)

    @builtins.property
    @jsii.member(jsii_name="horizontalVar")
    def horizontal_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontalVar"))

    @horizontal_var.setter
    def horizontal_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__874783236c2fc7b33cb375522f5c00fdb22452410d16d96fc4e4ddeae5f90fdb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontalVar", value)

    @builtins.property
    @jsii.member(jsii_name="vertical")
    def vertical(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "vertical"))

    @vertical.setter
    def vertical(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__39399b94a7c86185148941ddefd66030344f8774f0a77e44a3486b108a389412)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "vertical", value)

    @builtins.property
    @jsii.member(jsii_name="verticalVar")
    def vertical_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "verticalVar"))

    @vertical_var.setter
    def vertical_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c5b77fc887fe02f6f66b3ce0e2eb3230d38e99b87ab1c96b8f5f37b3a64387ef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "verticalVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareMirror]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareMirror]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareMirror]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2c0863ed28547d338e1c39b7dd86a986c32493cba5be18104bbd3d15c48775a9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareMonoHue",
    jsii_struct_bases=[],
    name_mapping={"hue": "hue", "hue_var": "hueVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareMonoHue:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aca3551e3a6afeadc06f273663c2bcb8970dc1deb53dfdd1f91eebbbf3c62e04)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareMonoHue(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareMonoHueList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareMonoHueList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__63db07163dbdc9967f9d193a7232acc167971c4bf7b07db8d41cbb4721678292)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareMonoHueOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e51228ba6651caa99e5856a4fefcb31938fea158365f019441ea980e0c54ec32)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareMonoHueOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8b42069909e5c1c67028f39ef802bbf371e9383df9e6d6f6d44e650f9ba3bb62)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1b04e7d2b4327abaf9a6054434e8de0e0b4ba042ae24c1568b89d4baaca220b2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd90d37f80cf9ef3ac7669b397f726e7a9662e993a2220571412ebbb7a20ba49)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareMonoHue]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareMonoHue]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__21a5028f5ae5df1b2340ba121f0c18291057380e7bb50aa9937402bb9cbfb3e8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareMonoHueOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareMonoHueOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f67366d880e0ac77e748f024ecae555b71e307fb5274354b27ff8e92519eeafb)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ac431390467df9c91f3b7392a603017c02b2498e1fa169d207f930ac16e77db)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c3e97ca2707434410f0bb8d6a3db8796a121af1fb53da3d6726b8b73364f0e32)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareMonoHue]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareMonoHue]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareMonoHue]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1e4f533b8a03a542ace2b6946152ce0e8a83c4a042db6e5b8017d15f9c5ee996)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareOpacity",
    jsii_struct_bases=[],
    name_mapping={"opacity": "opacity", "opacity_var": "opacityVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareOpacity:
    def __init__(
        self,
        *,
        opacity: typing.Optional[builtins.str] = None,
        opacity_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param opacity: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param opacity_var: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4eaee5f3852fdcc09c9093280a7e28c61bd3358396c56657f23f79ad7c3fcbd1)
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument opacity_var", value=opacity_var, expected_type=type_hints["opacity_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if opacity is not None:
            self._values["opacity"] = opacity
        if opacity_var is not None:
            self._values["opacity_var"] = opacity_var

    @builtins.property
    def opacity(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def opacity_var(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        result = self._values.get("opacity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareOpacity(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareOpacityList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareOpacityList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b0c84a6ac86c5fe8395f9b7a22a3328669407259af3cb06b17454506dbf0e7ab)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareOpacityOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__73af304c6ddb0b15833f7cf6db0748723d3b1399312da3d8f2c9004237576848)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareOpacityOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9cc8893ba085656ff64e1d3c40bffcd45a479231561ec6feebf8d0ad1ac6c8d3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d070de0c607dcef3fda01bf3d3e38ac58572cc5c6f8e9c1375ff17cc09400450)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__17bbb01c5e574a7ff4f64efd9ed192be3fd1fd7f60c305b6379d16593ee2a8a3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareOpacity]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareOpacity]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__802069f9d1906e3d4053e67710be4b6b741ebf928e7609a525fb7365416d1e83)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareOpacityOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareOpacityOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__364a4dff9044a213d208b2ee01143200b40e9307d602b0e5d20f77dd84df7171)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetOpacityVar")
    def reset_opacity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacityVar", []))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityVarInput")
    def opacity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacity"))

    @opacity.setter
    def opacity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0938165c725b5c76640434d86367aac35743c80770892ba8ee66fdcf764eaf09)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacity", value)

    @builtins.property
    @jsii.member(jsii_name="opacityVar")
    def opacity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacityVar"))

    @opacity_var.setter
    def opacity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__462b1ae8566ae347427b8dfb0a44efe80a6d4a388e7b73db0eb319afe56cff6e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacityVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareOpacity]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareOpacity]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareOpacity]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f1dc4ce299522fdc83ab55d904c48ecec01830c1194db122638bd446fcdfd94)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a187893349df800c4e6cf36627b9bddc0451c1b22434c14f4b40f8c910284eb5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putAppend")
    def put_append(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareAppend, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8af68af34bf6e8341959c5cfec5757085d6b0373d0907302276e83d428798daf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putAppend", [value]))

    @jsii.member(jsii_name="putAspectCrop")
    def put_aspect_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareAspectCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2129943501366f586f4f209f767814accb8a418bf4b41d948921d97d2e15715f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putAspectCrop", [value]))

    @jsii.member(jsii_name="putBackgroundColor")
    def put_background_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7e7a527d258515c19de9c76562347dc8a8b9dab1e74b6fce4fbbdd1582a7b8ea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBackgroundColor", [value]))

    @jsii.member(jsii_name="putBlur")
    def put_blur(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareBlur, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__91ad21a110ab7cd2a5d06e2c09c4bed03d4279be6accb88908a8f7505a9882c7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBlur", [value]))

    @jsii.member(jsii_name="putChromaKey")
    def put_chroma_key(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareChromaKey, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8663db3b6ea8144e0266f091b94f831250cee32b71f5f689518021b3505de1d3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putChromaKey", [value]))

    @jsii.member(jsii_name="putComposite")
    def put_composite(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareComposite, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1ed54e5642291d70f563def8e39fb673127169cb3c975943036993b3c7cc464d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putComposite", [value]))

    @jsii.member(jsii_name="putCompound")
    def put_compound(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareCompound, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bf9717311eefa35b497b4a46613b6f24c8c6c95315ca98b17f21741240b7b97c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCompound", [value]))

    @jsii.member(jsii_name="putContrast")
    def put_contrast(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareContrast, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0855367e3b488ba469c6c48ce8de2e780d51cdad383403a502309005841c097b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putContrast", [value]))

    @jsii.member(jsii_name="putCrop")
    def put_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7e1489803e50434176bf9739c30659fcc5088763ee01fb03e0644992f56e2ad1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCrop", [value]))

    @jsii.member(jsii_name="putFaceCrop")
    def put_face_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareFaceCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e46f3c1da093fae99d237109021c472ecb9698f82020ac9576a557acfa221cb7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFaceCrop", [value]))

    @jsii.member(jsii_name="putFeatureCrop")
    def put_feature_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareFeatureCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__28b061cbee555a5e64e778f230ed69d135959639eafddee848875ce1930dfbf5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFeatureCrop", [value]))

    @jsii.member(jsii_name="putFitAndFill")
    def put_fit_and_fill(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareFitAndFill, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9f3b86205c315b676a9bb8d8f287842b872979983866c8d4f270cff4c7afb610)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFitAndFill", [value]))

    @jsii.member(jsii_name="putGoop")
    def put_goop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareGoop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__45ecbda62b797831747530f14760224bd14cffc62f07ec88fcc778f928c37263)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGoop", [value]))

    @jsii.member(jsii_name="putGrayscale")
    def put_grayscale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareGrayscale, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dafc58d554e672f6a674c19f170e0732e51a45e4b05ca76fb081b6de04c12656)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGrayscale", [value]))

    @jsii.member(jsii_name="putHsl")
    def put_hsl(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareHsl, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5a2bcbb46101467f0eda820ccf58ad97f4c190da1d09d97a37c464a99783f49a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsl", [value]))

    @jsii.member(jsii_name="putHsv")
    def put_hsv(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareHsv, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a231de53086267b50d7dc0cf9cfc22fcb2ed09fc9667aec8ed523f7219819612)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsv", [value]))

    @jsii.member(jsii_name="putIfDimension")
    def put_if_dimension(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfDimension, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ea6448d42bdfe8326b4a7288002969de97519821f269ff8770810b384f4b30a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfDimension", [value]))

    @jsii.member(jsii_name="putIfOrientation")
    def put_if_orientation(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e875d560667a294068f66a5fdf4e603464b70f413c20c33ae7e75a3c113cedd7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfOrientation", [value]))

    @jsii.member(jsii_name="putImQuery")
    def put_im_query(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareImQuery, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cacbeb5490a45ee3071d23ca631b83e1c4446193a94f05dfaecff28a815d4f21)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putImQuery", [value]))

    @jsii.member(jsii_name="putMaxColors")
    def put_max_colors(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareMaxColors, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__92cf1e80a59dc687540a5087e2eac7702429dc766f3bfa31e79f6987955a49ec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMaxColors", [value]))

    @jsii.member(jsii_name="putMirror")
    def put_mirror(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareMirror, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fd3a3afd79c8202ecefae6acb788684b30073c00b269e61e608e7505aa6c700b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMirror", [value]))

    @jsii.member(jsii_name="putMonoHue")
    def put_mono_hue(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareMonoHue, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9025a1a3e876f2b142c596cf779f3eb7cf73ddb1959f414ea76b3b45e5b1ff60)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMonoHue", [value]))

    @jsii.member(jsii_name="putOpacity")
    def put_opacity(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareOpacity, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ca24567d998d9309de7ac949b413ae01d683f996fa633dc7cab1ff044962cb21)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putOpacity", [value]))

    @jsii.member(jsii_name="putRegionOfInterestCrop")
    def put_region_of_interest_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareRegionOfInterestCrop", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e3d7aa70d9dce8db30b03b33eb236de48945e27a149f7ffc34de91ee7a55fc76)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRegionOfInterestCrop", [value]))

    @jsii.member(jsii_name="putRelativeCrop")
    def put_relative_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareRelativeCrop", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c544c3a880c65d30c270ff9a0f4289b69392ba06dd794fcaeafc396cf5aee9f2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRelativeCrop", [value]))

    @jsii.member(jsii_name="putRemoveColor")
    def put_remove_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareRemoveColor", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a37bd4afa3c52500052daeaa8690b1989d5c7b7442f252ef83d5abf744df608b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRemoveColor", [value]))

    @jsii.member(jsii_name="putResize")
    def put_resize(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareResize", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e8ac727ba8155a6e7dfa21a9b1106283cad896d8e03785f9a6cd6d13239ce199)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putResize", [value]))

    @jsii.member(jsii_name="putRotate")
    def put_rotate(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareRotate", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f090ebf16641fb32b1770188d0fc5a3086a0d5dd043dadcbb5a9dfeecdcda07d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRotate", [value]))

    @jsii.member(jsii_name="putScale")
    def put_scale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareScale", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b8a2426e0ce7a1228346c8ed45e33b48d2853c1cbc0f6417247e6f2d5f0f642c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putScale", [value]))

    @jsii.member(jsii_name="putShear")
    def put_shear(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareShear", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6bff90cb7ddf77add0e9ee7431728ddc5ae32b53c5f5242ad3434d251ccfba9d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putShear", [value]))

    @jsii.member(jsii_name="putTrim")
    def put_trim(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareTrim", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a859d1821a50ed82d83864c3ecb46fad157604ab66296a41c7ca41d8ee9d8484)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTrim", [value]))

    @jsii.member(jsii_name="putUnsharpMask")
    def put_unsharp_mask(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareUnsharpMask", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7ae4bdcc968e20bc297084042cd5b79e73002a407629cdea8011d25891a6e837)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putUnsharpMask", [value]))

    @jsii.member(jsii_name="resetAppend")
    def reset_append(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAppend", []))

    @jsii.member(jsii_name="resetAspectCrop")
    def reset_aspect_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspectCrop", []))

    @jsii.member(jsii_name="resetBackgroundColor")
    def reset_background_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBackgroundColor", []))

    @jsii.member(jsii_name="resetBlur")
    def reset_blur(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBlur", []))

    @jsii.member(jsii_name="resetChromaKey")
    def reset_chroma_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChromaKey", []))

    @jsii.member(jsii_name="resetComposite")
    def reset_composite(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetComposite", []))

    @jsii.member(jsii_name="resetCompound")
    def reset_compound(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCompound", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetCrop")
    def reset_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCrop", []))

    @jsii.member(jsii_name="resetFaceCrop")
    def reset_face_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFaceCrop", []))

    @jsii.member(jsii_name="resetFeatureCrop")
    def reset_feature_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureCrop", []))

    @jsii.member(jsii_name="resetFitAndFill")
    def reset_fit_and_fill(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFitAndFill", []))

    @jsii.member(jsii_name="resetGoop")
    def reset_goop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGoop", []))

    @jsii.member(jsii_name="resetGrayscale")
    def reset_grayscale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGrayscale", []))

    @jsii.member(jsii_name="resetHsl")
    def reset_hsl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsl", []))

    @jsii.member(jsii_name="resetHsv")
    def reset_hsv(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsv", []))

    @jsii.member(jsii_name="resetIfDimension")
    def reset_if_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfDimension", []))

    @jsii.member(jsii_name="resetIfOrientation")
    def reset_if_orientation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfOrientation", []))

    @jsii.member(jsii_name="resetImQuery")
    def reset_im_query(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetImQuery", []))

    @jsii.member(jsii_name="resetMaxColors")
    def reset_max_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxColors", []))

    @jsii.member(jsii_name="resetMirror")
    def reset_mirror(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMirror", []))

    @jsii.member(jsii_name="resetMonoHue")
    def reset_mono_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonoHue", []))

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetRegionOfInterestCrop")
    def reset_region_of_interest_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRegionOfInterestCrop", []))

    @jsii.member(jsii_name="resetRelativeCrop")
    def reset_relative_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRelativeCrop", []))

    @jsii.member(jsii_name="resetRemoveColor")
    def reset_remove_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRemoveColor", []))

    @jsii.member(jsii_name="resetResize")
    def reset_resize(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetResize", []))

    @jsii.member(jsii_name="resetRotate")
    def reset_rotate(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRotate", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetShear")
    def reset_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetShear", []))

    @jsii.member(jsii_name="resetTrim")
    def reset_trim(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTrim", []))

    @jsii.member(jsii_name="resetUnsharpMask")
    def reset_unsharp_mask(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUnsharpMask", []))

    @builtins.property
    @jsii.member(jsii_name="append")
    def append(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareAppendList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareAppendList, jsii.get(self, "append"))

    @builtins.property
    @jsii.member(jsii_name="aspectCrop")
    def aspect_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareAspectCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareAspectCropList, jsii.get(self, "aspectCrop"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColor")
    def background_color(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareBackgroundColorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareBackgroundColorList, jsii.get(self, "backgroundColor"))

    @builtins.property
    @jsii.member(jsii_name="blur")
    def blur(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareBlurList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareBlurList, jsii.get(self, "blur"))

    @builtins.property
    @jsii.member(jsii_name="chromaKey")
    def chroma_key(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareChromaKeyList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareChromaKeyList, jsii.get(self, "chromaKey"))

    @builtins.property
    @jsii.member(jsii_name="composite")
    def composite(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareCompositeList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareCompositeList, jsii.get(self, "composite"))

    @builtins.property
    @jsii.member(jsii_name="compound")
    def compound(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareCompoundList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareCompoundList, jsii.get(self, "compound"))

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareContrastList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareContrastList, jsii.get(self, "contrast"))

    @builtins.property
    @jsii.member(jsii_name="crop")
    def crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareCropList, jsii.get(self, "crop"))

    @builtins.property
    @jsii.member(jsii_name="faceCrop")
    def face_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareFaceCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareFaceCropList, jsii.get(self, "faceCrop"))

    @builtins.property
    @jsii.member(jsii_name="featureCrop")
    def feature_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareFeatureCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareFeatureCropList, jsii.get(self, "featureCrop"))

    @builtins.property
    @jsii.member(jsii_name="fitAndFill")
    def fit_and_fill(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareFitAndFillList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareFitAndFillList, jsii.get(self, "fitAndFill"))

    @builtins.property
    @jsii.member(jsii_name="goop")
    def goop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareGoopList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareGoopList, jsii.get(self, "goop"))

    @builtins.property
    @jsii.member(jsii_name="grayscale")
    def grayscale(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareGrayscaleList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareGrayscaleList, jsii.get(self, "grayscale"))

    @builtins.property
    @jsii.member(jsii_name="hsl")
    def hsl(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareHslList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareHslList, jsii.get(self, "hsl"))

    @builtins.property
    @jsii.member(jsii_name="hsv")
    def hsv(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareHsvList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareHsvList, jsii.get(self, "hsv"))

    @builtins.property
    @jsii.member(jsii_name="ifDimension")
    def if_dimension(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfDimensionList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfDimensionList, jsii.get(self, "ifDimension"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientation")
    def if_orientation(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfOrientationList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfOrientationList, jsii.get(self, "ifOrientation"))

    @builtins.property
    @jsii.member(jsii_name="imQuery")
    def im_query(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareImQueryList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareImQueryList, jsii.get(self, "imQuery"))

    @builtins.property
    @jsii.member(jsii_name="maxColors")
    def max_colors(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareMaxColorsList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareMaxColorsList, jsii.get(self, "maxColors"))

    @builtins.property
    @jsii.member(jsii_name="mirror")
    def mirror(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareMirrorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareMirrorList, jsii.get(self, "mirror"))

    @builtins.property
    @jsii.member(jsii_name="monoHue")
    def mono_hue(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareMonoHueList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareMonoHueList, jsii.get(self, "monoHue"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareOpacityList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareOpacityList, jsii.get(self, "opacity"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestCrop")
    def region_of_interest_crop(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareRegionOfInterestCropList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareRegionOfInterestCropList", jsii.get(self, "regionOfInterestCrop"))

    @builtins.property
    @jsii.member(jsii_name="relativeCrop")
    def relative_crop(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareRelativeCropList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareRelativeCropList", jsii.get(self, "relativeCrop"))

    @builtins.property
    @jsii.member(jsii_name="removeColor")
    def remove_color(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareRemoveColorList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareRemoveColorList", jsii.get(self, "removeColor"))

    @builtins.property
    @jsii.member(jsii_name="resize")
    def resize(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareResizeList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareResizeList", jsii.get(self, "resize"))

    @builtins.property
    @jsii.member(jsii_name="rotate")
    def rotate(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareRotateList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareRotateList", jsii.get(self, "rotate"))

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareScaleList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareScaleList", jsii.get(self, "scale"))

    @builtins.property
    @jsii.member(jsii_name="shear")
    def shear(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareShearList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareShearList", jsii.get(self, "shear"))

    @builtins.property
    @jsii.member(jsii_name="trim")
    def trim(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareTrimList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareTrimList", jsii.get(self, "trim"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMask")
    def unsharp_mask(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareUnsharpMaskList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareUnsharpMaskList", jsii.get(self, "unsharpMask"))

    @builtins.property
    @jsii.member(jsii_name="appendInput")
    def append_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareAppend]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareAppend]]], jsii.get(self, "appendInput"))

    @builtins.property
    @jsii.member(jsii_name="aspectCropInput")
    def aspect_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareAspectCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareAspectCrop]]], jsii.get(self, "aspectCropInput"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColorInput")
    def background_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareBackgroundColor]]], jsii.get(self, "backgroundColorInput"))

    @builtins.property
    @jsii.member(jsii_name="blurInput")
    def blur_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareBlur]]], jsii.get(self, "blurInput"))

    @builtins.property
    @jsii.member(jsii_name="chromaKeyInput")
    def chroma_key_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareChromaKey]]], jsii.get(self, "chromaKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="compositeInput")
    def composite_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareComposite]]], jsii.get(self, "compositeInput"))

    @builtins.property
    @jsii.member(jsii_name="compoundInput")
    def compound_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareCompound]]], jsii.get(self, "compoundInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareContrast]]], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="cropInput")
    def crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareCrop]]], jsii.get(self, "cropInput"))

    @builtins.property
    @jsii.member(jsii_name="faceCropInput")
    def face_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareFaceCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareFaceCrop]]], jsii.get(self, "faceCropInput"))

    @builtins.property
    @jsii.member(jsii_name="featureCropInput")
    def feature_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareFeatureCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareFeatureCrop]]], jsii.get(self, "featureCropInput"))

    @builtins.property
    @jsii.member(jsii_name="fitAndFillInput")
    def fit_and_fill_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareFitAndFill]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareFitAndFill]]], jsii.get(self, "fitAndFillInput"))

    @builtins.property
    @jsii.member(jsii_name="goopInput")
    def goop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareGoop]]], jsii.get(self, "goopInput"))

    @builtins.property
    @jsii.member(jsii_name="grayscaleInput")
    def grayscale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareGrayscale]]], jsii.get(self, "grayscaleInput"))

    @builtins.property
    @jsii.member(jsii_name="hslInput")
    def hsl_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareHsl]]], jsii.get(self, "hslInput"))

    @builtins.property
    @jsii.member(jsii_name="hsvInput")
    def hsv_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareHsv]]], jsii.get(self, "hsvInput"))

    @builtins.property
    @jsii.member(jsii_name="ifDimensionInput")
    def if_dimension_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfDimension]]], jsii.get(self, "ifDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientationInput")
    def if_orientation_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfOrientation]]], jsii.get(self, "ifOrientationInput"))

    @builtins.property
    @jsii.member(jsii_name="imQueryInput")
    def im_query_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareImQuery]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareImQuery]]], jsii.get(self, "imQueryInput"))

    @builtins.property
    @jsii.member(jsii_name="maxColorsInput")
    def max_colors_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareMaxColors]]], jsii.get(self, "maxColorsInput"))

    @builtins.property
    @jsii.member(jsii_name="mirrorInput")
    def mirror_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareMirror]]], jsii.get(self, "mirrorInput"))

    @builtins.property
    @jsii.member(jsii_name="monoHueInput")
    def mono_hue_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareMonoHue]]], jsii.get(self, "monoHueInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareOpacity]]], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestCropInput")
    def region_of_interest_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareRegionOfInterestCrop"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareRegionOfInterestCrop"]]], jsii.get(self, "regionOfInterestCropInput"))

    @builtins.property
    @jsii.member(jsii_name="relativeCropInput")
    def relative_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareRelativeCrop"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareRelativeCrop"]]], jsii.get(self, "relativeCropInput"))

    @builtins.property
    @jsii.member(jsii_name="removeColorInput")
    def remove_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareRemoveColor"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareRemoveColor"]]], jsii.get(self, "removeColorInput"))

    @builtins.property
    @jsii.member(jsii_name="resizeInput")
    def resize_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareResize"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareResize"]]], jsii.get(self, "resizeInput"))

    @builtins.property
    @jsii.member(jsii_name="rotateInput")
    def rotate_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareRotate"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareRotate"]]], jsii.get(self, "rotateInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareScale"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareScale"]]], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="shearInput")
    def shear_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareShear"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareShear"]]], jsii.get(self, "shearInput"))

    @builtins.property
    @jsii.member(jsii_name="trimInput")
    def trim_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareTrim"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareTrim"]]], jsii.get(self, "trimInput"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMaskInput")
    def unsharp_mask_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareUnsharpMask"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareUnsharpMask"]]], jsii.get(self, "unsharpMaskInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquare]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquare], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquare],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8e29971f8eaea000ca884164bae4eb3143d9752238f81244d44fb1c2910549eb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareRegionOfInterestCrop",
    jsii_struct_bases=[],
    name_mapping={
        "region_of_interest": "regionOfInterest",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareRegionOfInterestCrop:
    def __init__(
        self,
        *,
        region_of_interest: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareRegionOfInterestCropRegionOfInterest", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param region_of_interest: region_of_interest block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest DataAkamaiImagingPolicyImage#region_of_interest}
        :param gravity: The placement of the crop area relative to the specified area of interest. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: The placement of the crop area relative to the specified area of interest. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param style: Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(region_of_interest, dict):
            region_of_interest = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareRegionOfInterestCropRegionOfInterest(**region_of_interest)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8c5c9550ec0bd7aa9ee30a6f1307704b554bad9f10c092e3432caa61ab6dd3d9)
            check_type(argname="argument region_of_interest", value=region_of_interest, expected_type=type_hints["region_of_interest"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "region_of_interest": region_of_interest,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def region_of_interest(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareRegionOfInterestCropRegionOfInterest":
        '''region_of_interest block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest DataAkamaiImagingPolicyImage#region_of_interest}
        '''
        result = self._values.get("region_of_interest")
        assert result is not None, "Required property 'region_of_interest' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareRegionOfInterestCropRegionOfInterest", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''The placement of the crop area relative to the specified area of interest.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''The placement of the crop area relative to the specified area of interest.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareRegionOfInterestCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareRegionOfInterestCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareRegionOfInterestCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__732251d8322c5516ca94bc26b8bdeb4b2c5ccc18b369468a9367a1fe0f4bbbd1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareRegionOfInterestCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a0870755fd75a3ec378020cdbbd59a582404b536ee205b3883a7fd7321e93577)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareRegionOfInterestCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__25e58d6e7c340487d78fd654233eccb70470966f9bf1aa0c2ebc86ced6f624be)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5308d1fc55add7db8d2d3e6653a681346e2e123dab6185dd2bb054036c3707f4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7e914f9b3b4393d9cdcf8192bb2353bbb3ba4d55a922b72adeed3e85df62cbc1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareRegionOfInterestCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareRegionOfInterestCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareRegionOfInterestCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fc480edf6d7abb7a10e275a1f00d7144064cbb0728e7838992f54eb84b9c850b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareRegionOfInterestCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareRegionOfInterestCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__081dcdc40f72872f6a5c1c81158277e946f6bec2c197defd33def614bc8ef508)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putRegionOfInterest")
    def put_region_of_interest(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareRegionOfInterestCropRegionOfInterest()

        return typing.cast(None, jsii.invoke(self, "putRegionOfInterest", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterest")
    def region_of_interest(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareRegionOfInterestCropRegionOfInterestOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareRegionOfInterestCropRegionOfInterestOutputReference", jsii.get(self, "regionOfInterest"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestInput")
    def region_of_interest_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareRegionOfInterestCropRegionOfInterest"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareRegionOfInterestCropRegionOfInterest"], jsii.get(self, "regionOfInterestInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d242ab0591cdda61f227f33d35818773231a08043210627776a5321006d1b70)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c9c3fbb2f6c71a681294d53688660abf3225eb528b44c4156d7ff02c751e386c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f0a5472cba036d48bce16c1bcce8ab194df06014b118339e6985ddf971a01f98)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__19b493c1954cc27ff953a8f0377154d2f1ed40d36c1959aec2cd2645fdb6fa69)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7125abfd3c173ea5a0f9c728ddbaefc28b5049862c87bea1df54a8fbc07b9905)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c30837f126202b960a8e71017b5064aaf299dcaaa8feb547ceca0cd52a02e404)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a5cb9d2cfe8b9779d7c4f7155405752caa523b6b249ef259e27893753db8a13)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c60ab2480d4209c2fbf92807bbdb4572d3f41e406090914586216be187eff565)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareRegionOfInterestCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareRegionOfInterestCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareRegionOfInterestCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9bff23792d4983d6ac2922add147c1e0beff7fe78183b3260b5f75b140ea7b78)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareRegionOfInterestCropRegionOfInterest",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareRegionOfInterestCropRegionOfInterest:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareRegionOfInterestCropRegionOfInterest(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareRegionOfInterestCropRegionOfInterestOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareRegionOfInterestCropRegionOfInterestOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b34d8202f2e7110af9609f7f2a822978d505f785a2e126f74f61bf942ee0be63)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareRegionOfInterestCropRegionOfInterest]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareRegionOfInterestCropRegionOfInterest], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareRegionOfInterestCropRegionOfInterest],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e4db3b90b9fa22e1f30fdf9ee0387878e0cac647948e102f5e757faf843a1eaa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareRelativeCrop",
    jsii_struct_bases=[],
    name_mapping={
        "east": "east",
        "east_var": "eastVar",
        "north": "north",
        "north_var": "northVar",
        "south": "south",
        "south_var": "southVar",
        "west": "west",
        "west_var": "westVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareRelativeCrop:
    def __init__(
        self,
        *,
        east: typing.Optional[builtins.str] = None,
        east_var: typing.Optional[builtins.str] = None,
        north: typing.Optional[builtins.str] = None,
        north_var: typing.Optional[builtins.str] = None,
        south: typing.Optional[builtins.str] = None,
        south_var: typing.Optional[builtins.str] = None,
        west: typing.Optional[builtins.str] = None,
        west_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param east: The number of pixels to shrink or expand the right side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east DataAkamaiImagingPolicyImage#east}
        :param east_var: The number of pixels to shrink or expand the right side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east_var DataAkamaiImagingPolicyImage#east_var}
        :param north: The number of pixels to shrink or expand the top side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north DataAkamaiImagingPolicyImage#north}
        :param north_var: The number of pixels to shrink or expand the top side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north_var DataAkamaiImagingPolicyImage#north_var}
        :param south: The number of pixels to shrink or expand the bottom side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south DataAkamaiImagingPolicyImage#south}
        :param south_var: The number of pixels to shrink or expand the bottom side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south_var DataAkamaiImagingPolicyImage#south_var}
        :param west: The number of pixels to shrink or expand the left side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west DataAkamaiImagingPolicyImage#west}
        :param west_var: The number of pixels to shrink or expand the left side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west_var DataAkamaiImagingPolicyImage#west_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0f7e40d04f6c670bfc21355d80e0a7655016b1c61b3ae4976ab0f77a02ef3e14)
            check_type(argname="argument east", value=east, expected_type=type_hints["east"])
            check_type(argname="argument east_var", value=east_var, expected_type=type_hints["east_var"])
            check_type(argname="argument north", value=north, expected_type=type_hints["north"])
            check_type(argname="argument north_var", value=north_var, expected_type=type_hints["north_var"])
            check_type(argname="argument south", value=south, expected_type=type_hints["south"])
            check_type(argname="argument south_var", value=south_var, expected_type=type_hints["south_var"])
            check_type(argname="argument west", value=west, expected_type=type_hints["west"])
            check_type(argname="argument west_var", value=west_var, expected_type=type_hints["west_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if east is not None:
            self._values["east"] = east
        if east_var is not None:
            self._values["east_var"] = east_var
        if north is not None:
            self._values["north"] = north
        if north_var is not None:
            self._values["north_var"] = north_var
        if south is not None:
            self._values["south"] = south
        if south_var is not None:
            self._values["south_var"] = south_var
        if west is not None:
            self._values["west"] = west
        if west_var is not None:
            self._values["west_var"] = west_var

    @builtins.property
    def east(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the right side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east DataAkamaiImagingPolicyImage#east}
        '''
        result = self._values.get("east")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def east_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the right side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east_var DataAkamaiImagingPolicyImage#east_var}
        '''
        result = self._values.get("east_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def north(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the top side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north DataAkamaiImagingPolicyImage#north}
        '''
        result = self._values.get("north")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def north_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the top side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north_var DataAkamaiImagingPolicyImage#north_var}
        '''
        result = self._values.get("north_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def south(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the bottom side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south DataAkamaiImagingPolicyImage#south}
        '''
        result = self._values.get("south")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def south_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the bottom side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south_var DataAkamaiImagingPolicyImage#south_var}
        '''
        result = self._values.get("south_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def west(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the left side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west DataAkamaiImagingPolicyImage#west}
        '''
        result = self._values.get("west")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def west_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the left side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west_var DataAkamaiImagingPolicyImage#west_var}
        '''
        result = self._values.get("west_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareRelativeCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareRelativeCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareRelativeCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a47a9ec19311010982b06f58c92cdcca93ec9cba83339ae39a327252d15bf4e7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareRelativeCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1554d77f0f90fe54c8fa036e3f0e4bd6beada8012bd0c714e57530b9ca2f5728)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareRelativeCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bf67589986bfe02bf099a92e0f6ba90a72c3495eb87da1f8584cfb9a7ffc1fd0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a44e6947003e32fe9c59ee98a09fa64913768a6b963e8f534bc977064289f9be)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d1a296d41da3e949a1c69826ed09e079389d8f6ccd62e8a903dc0184d344fadf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareRelativeCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareRelativeCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareRelativeCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8e26fb8b0663fe9759f60bb4fdfc743f4c7b7d245d9733592a03bb1e15364d23)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareRelativeCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareRelativeCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b1767becc9d6d5b3ef02eb102525198eb37a8e5daa3e930bc2a258b596bc3d98)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetEast")
    def reset_east(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEast", []))

    @jsii.member(jsii_name="resetEastVar")
    def reset_east_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEastVar", []))

    @jsii.member(jsii_name="resetNorth")
    def reset_north(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNorth", []))

    @jsii.member(jsii_name="resetNorthVar")
    def reset_north_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNorthVar", []))

    @jsii.member(jsii_name="resetSouth")
    def reset_south(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSouth", []))

    @jsii.member(jsii_name="resetSouthVar")
    def reset_south_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSouthVar", []))

    @jsii.member(jsii_name="resetWest")
    def reset_west(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWest", []))

    @jsii.member(jsii_name="resetWestVar")
    def reset_west_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWestVar", []))

    @builtins.property
    @jsii.member(jsii_name="eastInput")
    def east_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "eastInput"))

    @builtins.property
    @jsii.member(jsii_name="eastVarInput")
    def east_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "eastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="northInput")
    def north_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "northInput"))

    @builtins.property
    @jsii.member(jsii_name="northVarInput")
    def north_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "northVarInput"))

    @builtins.property
    @jsii.member(jsii_name="southInput")
    def south_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "southInput"))

    @builtins.property
    @jsii.member(jsii_name="southVarInput")
    def south_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "southVarInput"))

    @builtins.property
    @jsii.member(jsii_name="westInput")
    def west_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "westInput"))

    @builtins.property
    @jsii.member(jsii_name="westVarInput")
    def west_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "westVarInput"))

    @builtins.property
    @jsii.member(jsii_name="east")
    def east(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "east"))

    @east.setter
    def east(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d8b3bf13d6d592c49fce14e7d74e81b49a2a115ba800e20e0c2775fb18cd44cd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "east", value)

    @builtins.property
    @jsii.member(jsii_name="eastVar")
    def east_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "eastVar"))

    @east_var.setter
    def east_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__573b9f0654e00a37c8fe6a24b7e04de116ebaa03c99897c26ae8a3ff50e3d1d5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "eastVar", value)

    @builtins.property
    @jsii.member(jsii_name="north")
    def north(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "north"))

    @north.setter
    def north(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ed838aa21850c8cc4255c21e9dcab524580d06701283442e02d8efaef2362ec8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "north", value)

    @builtins.property
    @jsii.member(jsii_name="northVar")
    def north_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "northVar"))

    @north_var.setter
    def north_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc0e559cfec08916cfbcd880eff4a1274efeecf36407fde7f86989cf878e14ce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "northVar", value)

    @builtins.property
    @jsii.member(jsii_name="south")
    def south(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "south"))

    @south.setter
    def south(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__84387083660bc45e38a6d3ba8feabe8d24b5bb67821e9923363ee26a06471b87)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "south", value)

    @builtins.property
    @jsii.member(jsii_name="southVar")
    def south_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "southVar"))

    @south_var.setter
    def south_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2637391ed835151ac8500fe56da9f5bc09aa2c9c21c9adda05321b47974a2d1a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "southVar", value)

    @builtins.property
    @jsii.member(jsii_name="west")
    def west(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "west"))

    @west.setter
    def west(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8d69a8a8f3de647a129087ae65792860cb34eacef02463fd363856de9dcae31f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "west", value)

    @builtins.property
    @jsii.member(jsii_name="westVar")
    def west_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "westVar"))

    @west_var.setter
    def west_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cb1fb58f04a0930114fc43d9a2d3a82fc01d71101e9d7a30e3c5e49f59d3fa7b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "westVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareRelativeCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareRelativeCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareRelativeCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__14858dbdebc9193db3c2139e9fdfcd0a80d0c06479030f7c6c3cd950c3a299d6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareRemoveColor",
    jsii_struct_bases=[],
    name_mapping={
        "color": "color",
        "color_var": "colorVar",
        "feather": "feather",
        "feather_var": "featherVar",
        "tolerance": "tolerance",
        "tolerance_var": "toleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareRemoveColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
        feather: typing.Optional[builtins.str] = None,
        feather_var: typing.Optional[builtins.str] = None,
        tolerance: typing.Optional[builtins.str] = None,
        tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        :param feather: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        :param feather_var: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        :param tolerance: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        :param tolerance_var: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d62cd6d0ef72a64cf4d1482672caf65d042b4963ca35b1de30adc00519ec67a8)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
            check_type(argname="argument feather", value=feather, expected_type=type_hints["feather"])
            check_type(argname="argument feather_var", value=feather_var, expected_type=type_hints["feather_var"])
            check_type(argname="argument tolerance", value=tolerance, expected_type=type_hints["tolerance"])
            check_type(argname="argument tolerance_var", value=tolerance_var, expected_type=type_hints["tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var
        if feather is not None:
            self._values["feather"] = feather
        if feather_var is not None:
            self._values["feather_var"] = feather_var
        if tolerance is not None:
            self._values["tolerance"] = tolerance
        if tolerance_var is not None:
            self._values["tolerance_var"] = tolerance_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        '''
        result = self._values.get("feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather_var(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        '''
        result = self._values.get("feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        '''
        result = self._values.get("tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance_var(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        result = self._values.get("tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareRemoveColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareRemoveColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareRemoveColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d62edb59c152a89b804030278573f6e5eb258205ca1fb123e9882924a8b7ff24)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareRemoveColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3d7e4fa953b56547f1a2e5caaa43a297753654d2a3103765b94a4ff51c9df5e9)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareRemoveColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__21a29b57d90a898af3abd3a250708b22da4e46457d20d1c7f54873677afbfb66)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__32986e947600323ac9562e68d22f42fbead50f7600d44bcbb69fc79bf7b0457f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e2f14eb89801a7dcdae3c2f6998147ed33438d60f18ea8dd8af0d4890947147e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareRemoveColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareRemoveColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareRemoveColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__591b5da94f41b4b9b053a730286ca8316a2b0d170c5a86f9a061f8581f8a9645)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareRemoveColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareRemoveColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2df2908f4e13847438441faf8572684783134ef903ac2b083c1397b768171c9f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @jsii.member(jsii_name="resetFeather")
    def reset_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeather", []))

    @jsii.member(jsii_name="resetFeatherVar")
    def reset_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatherVar", []))

    @jsii.member(jsii_name="resetTolerance")
    def reset_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTolerance", []))

    @jsii.member(jsii_name="resetToleranceVar")
    def reset_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featherInput")
    def feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherInput"))

    @builtins.property
    @jsii.member(jsii_name="featherVarInput")
    def feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceInput")
    def tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceVarInput")
    def tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fc6dba28b5efc7e83ce18a05d9c29ec7a21be897ce5a1e9d41e8534e70c9e226)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c671d9ef7f73be44ddfb70de9ce15ac2697de5a652dc738fd1358823caea4cad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="feather")
    def feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "feather"))

    @feather.setter
    def feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7a96fc10e5ead40d2f13fd5979c10b5563e8788d96a2adc69b26c4b9b1b30133)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "feather", value)

    @builtins.property
    @jsii.member(jsii_name="featherVar")
    def feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featherVar"))

    @feather_var.setter
    def feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2e571d6ac0ef38c2ca66c9e0829d6c46b5d34e13914479787dffc075b4d3dd50)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featherVar", value)

    @builtins.property
    @jsii.member(jsii_name="tolerance")
    def tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tolerance"))

    @tolerance.setter
    def tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e39b719157034fdb22e7f5e5d811b7900c698eeb864b8259a4d1cbacc6ad61b4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tolerance", value)

    @builtins.property
    @jsii.member(jsii_name="toleranceVar")
    def tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "toleranceVar"))

    @tolerance_var.setter
    def tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__44d9a4c31a9713f48a23caaf72e5b987254f8ab21ecded4ab3254a2ca6511db7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "toleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareRemoveColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareRemoveColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareRemoveColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e6ac42ea5d8147f54ec914f29c173e2425d5ad8b453365c50d9cf6f13b276098)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareResize",
    jsii_struct_bases=[],
    name_mapping={
        "aspect": "aspect",
        "aspect_var": "aspectVar",
        "height": "height",
        "height_var": "heightVar",
        "type": "type",
        "type_var": "typeVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareResize:
    def __init__(
        self,
        *,
        aspect: typing.Optional[builtins.str] = None,
        aspect_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param aspect: Preserves the aspect ratio. Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect DataAkamaiImagingPolicyImage#aspect}
        :param aspect_var: Preserves the aspect ratio. Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_var DataAkamaiImagingPolicyImage#aspect_var}
        :param height: The height to resize the source image to. Must be set if height is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height to resize the source image to. Must be set if height is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param type: Sets constraints for the image resize. Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: Sets constraints for the image resize. Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        :param width: The width to resize the source image to. Must be set if width is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width to resize the source image to. Must be set if width is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1e4a6edd1ab538b8a7e3ab3516ef2d61d4b28280ef1ca7ef17ca6d5ca41ce9e6)
            check_type(argname="argument aspect", value=aspect, expected_type=type_hints["aspect"])
            check_type(argname="argument aspect_var", value=aspect_var, expected_type=type_hints["aspect_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if aspect is not None:
            self._values["aspect"] = aspect
        if aspect_var is not None:
            self._values["aspect_var"] = aspect_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def aspect(self) -> typing.Optional[builtins.str]:
        '''Preserves the aspect ratio.

        Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect DataAkamaiImagingPolicyImage#aspect}
        '''
        result = self._values.get("aspect")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def aspect_var(self) -> typing.Optional[builtins.str]:
        '''Preserves the aspect ratio.

        Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_var DataAkamaiImagingPolicyImage#aspect_var}
        '''
        result = self._values.get("aspect_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height to resize the source image to. Must be set if height is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height to resize the source image to. Must be set if height is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''Sets constraints for the image resize.

        Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''Sets constraints for the image resize.

        Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width to resize the source image to. Must be set if width is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width to resize the source image to. Must be set if width is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareResize(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareResizeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareResizeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d7d030e0640f22aea0c174cde88ec526ce62cb6b3157b7b3a713be6af7319d6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareResizeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c3e90468c75cc53c9212926ebc99d84276c93f2eaa5d3fef8a9c7f53a6284c07)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareResizeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__45fae7e1f52c602d0ab4d9e8e78207fa5b246b91f5cdad6cf8f1cfa716323168)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2fd6be744011bdbf9bc665d0dc73a36c220335bd555598b9229f6b6583c0d090)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ed33adef4235a399526ec38474611fd5fdf76f8aa58e3410dad418683760e74)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareResize]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareResize]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareResize]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e18a74b780557bbd97c4f4ede370d3dbcd4e0841a15e0aea89f144a792e7c05d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareResizeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareResizeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7818e623445f6085da1a8aaf6e0e1f263177f555a12332a7b5921a700ef2ffd8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAspect")
    def reset_aspect(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspect", []))

    @jsii.member(jsii_name="resetAspectVar")
    def reset_aspect_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspectVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="aspectInput")
    def aspect_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "aspectInput"))

    @builtins.property
    @jsii.member(jsii_name="aspectVarInput")
    def aspect_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "aspectVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="aspect")
    def aspect(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "aspect"))

    @aspect.setter
    def aspect(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__22934de58cbdf092dd6ed84667b4a9cc157007bd906f3cf4d2af1d4630b91fd8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "aspect", value)

    @builtins.property
    @jsii.member(jsii_name="aspectVar")
    def aspect_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "aspectVar"))

    @aspect_var.setter
    def aspect_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__058ec5eb5a5c3bc04d19f46911081fde54ed13bf0dfacb8e2e5998fb615722fc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "aspectVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c8290880cc0e2883bd8f85b7cc0f6ff38d39f75c5406b6801016ad401372c9c8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df2645856801c68943575e325168a0631441f7b9416338937ae65c55c13626e5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__733d0bdef43b3eb1fe7d88b56d5fbc85dfdaad9fa6382a54e405533f085a22fb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__654d63d3eb4f4ff666dcfc651fcf0236b07595a51cec3cfc862a57ccc6ba44b8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2acc6b96d999fcd803122114e7dfe850e7eeba3cc0615094d23cb246aa5b533f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__46fc39756d9d3ccc55642e50f653a3c4256e3b44701495c61c5b6f8e0e1d7284)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareResize]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareResize]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareResize]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__908e96163dcadf39146bd314dbd95dad5a36bb4fe46142cac7e29075b80a4153)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareRotate",
    jsii_struct_bases=[],
    name_mapping={"degrees": "degrees", "degrees_var": "degreesVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareRotate:
    def __init__(
        self,
        *,
        degrees: typing.Optional[builtins.str] = None,
        degrees_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param degrees: The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees DataAkamaiImagingPolicyImage#degrees}
        :param degrees_var: The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees_var DataAkamaiImagingPolicyImage#degrees_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e737fb20217f97eae0c3a512a1723b435c87a79413774b3d0aad09a810906b0a)
            check_type(argname="argument degrees", value=degrees, expected_type=type_hints["degrees"])
            check_type(argname="argument degrees_var", value=degrees_var, expected_type=type_hints["degrees_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if degrees is not None:
            self._values["degrees"] = degrees
        if degrees_var is not None:
            self._values["degrees_var"] = degrees_var

    @builtins.property
    def degrees(self) -> typing.Optional[builtins.str]:
        '''The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees DataAkamaiImagingPolicyImage#degrees}
        '''
        result = self._values.get("degrees")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def degrees_var(self) -> typing.Optional[builtins.str]:
        '''The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees_var DataAkamaiImagingPolicyImage#degrees_var}
        '''
        result = self._values.get("degrees_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareRotate(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareRotateList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareRotateList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f36ce233fb99aea46b11ed301d364ed41a67b7a61e13df22844817c148485ea5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareRotateOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__12e62a9e93e583e394766d7a11fb2d748e82e154cc3635f9a1121b1adb8e5f71)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareRotateOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9fccc41b6a838ca117d413e4e5012abfb106d5fe9ddc20e9014598961ed18bf8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__abcaafd7b67405548ace9688cd4c0a415debb5b37bf5fe06634475299ed96df0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d37322288208349c15695e97dc8c843d863c84c1a2738ab1628bd5381064ebb0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareRotate]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareRotate]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareRotate]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cdb9a6d85ee8e9a78efa7df8036689b06dadb6cdd641cedef5242ad3905985d6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareRotateOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareRotateOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__55d9eaf82cf2506ae65bee02640a76828323bbfb344da2b23a2bc69a6c45f22c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetDegrees")
    def reset_degrees(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDegrees", []))

    @jsii.member(jsii_name="resetDegreesVar")
    def reset_degrees_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDegreesVar", []))

    @builtins.property
    @jsii.member(jsii_name="degreesInput")
    def degrees_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "degreesInput"))

    @builtins.property
    @jsii.member(jsii_name="degreesVarInput")
    def degrees_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "degreesVarInput"))

    @builtins.property
    @jsii.member(jsii_name="degrees")
    def degrees(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "degrees"))

    @degrees.setter
    def degrees(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3275a4c9a63f14766a5fe76f2e82582b35eac9238a3ad7bfe489fcd5c43a2a9e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "degrees", value)

    @builtins.property
    @jsii.member(jsii_name="degreesVar")
    def degrees_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "degreesVar"))

    @degrees_var.setter
    def degrees_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__38e6ab32a6abb6db417dca1b163631f95dbb189580269ffb84dea0312b2b9ab2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "degreesVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareRotate]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareRotate]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareRotate]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ee6edc457702c59755028a09ee0a283d6286e2809a17a8f3ed735fc4619c0b3d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareScale",
    jsii_struct_bases=[],
    name_mapping={
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareScale:
    def __init__(
        self,
        *,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param height: Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged. Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged. Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f23813af21a49b2478f3e275994027f65db538799a95e80ee4cbdf72c9bb8101)
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size.

        Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size.

        Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged.

        Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged.

        Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareScale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareScaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareScaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__275e500a5199010ae44296423beb17793f0e43d577e7eb6953e37f215e9cd35c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareScaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b83444b3f7014eaf7e702d21f34331f37161a26cd324e40cb2d83f257f69f5ae)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareScaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0170c65c45520ae396dcb38baa7a0a57ced6306ea899cfa125881d10ad815678)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1dcdab3e89e205bc9fe8460bed7043251abb9f6fe556c1ef96286fb101979571)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d78f56fbcef89376579757aad95326551147345f7bb5fe81b0a734dbfdbd74f0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareScale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareScale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareScale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a0b8e4ad8502cf0718b50f2b584ef3477adc5dddccda64edfbdb0cc93aadbb66)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareScaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareScaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1616eac80eb70e457fc19ddf058ad7adef7f49764762b2b323f6c8d0ca1fdc0d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb4a5c683e9eba1a9e1b12ad44ebe414f6fd9ae615f331cb586cecaaa6b66dbb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__35cef45cc556acacb35d4b157e512756d0fc7b0978cb85b13967f4a10b9227c1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e09234e5b529f1bfcf8662ae71158488178241145fc9750ef133e827dfd38450)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dbf29874db7c849141be09bcd22e217eec37c5084612d852c85a30acf53b6d5d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareScale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareScale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareScale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__878cc69e6d9305564abb5203e5c22da68174d74bbe476e39f58a69b2df16cd33)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareShear",
    jsii_struct_bases=[],
    name_mapping={
        "x_shear": "xShear",
        "x_shear_var": "xShearVar",
        "y_shear": "yShear",
        "y_shear_var": "yShearVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareShear:
    def __init__(
        self,
        *,
        x_shear: typing.Optional[builtins.str] = None,
        x_shear_var: typing.Optional[builtins.str] = None,
        y_shear: typing.Optional[builtins.str] = None,
        y_shear_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param x_shear: The amount to shear along the x-axis, measured in multiples of the image's width. Must be set if yShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear DataAkamaiImagingPolicyImage#x_shear}
        :param x_shear_var: The amount to shear along the x-axis, measured in multiples of the image's width. Must be set if yShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear_var DataAkamaiImagingPolicyImage#x_shear_var}
        :param y_shear: The amount to shear along the y-axis, measured in multiples of the image's height. Must be set if xShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear DataAkamaiImagingPolicyImage#y_shear}
        :param y_shear_var: The amount to shear along the y-axis, measured in multiples of the image's height. Must be set if xShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear_var DataAkamaiImagingPolicyImage#y_shear_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4b66eb6d1731342bf36dd61c52ea48b510f02e5fdc6bdb298538526c941159fa)
            check_type(argname="argument x_shear", value=x_shear, expected_type=type_hints["x_shear"])
            check_type(argname="argument x_shear_var", value=x_shear_var, expected_type=type_hints["x_shear_var"])
            check_type(argname="argument y_shear", value=y_shear, expected_type=type_hints["y_shear"])
            check_type(argname="argument y_shear_var", value=y_shear_var, expected_type=type_hints["y_shear_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if x_shear is not None:
            self._values["x_shear"] = x_shear
        if x_shear_var is not None:
            self._values["x_shear_var"] = x_shear_var
        if y_shear is not None:
            self._values["y_shear"] = y_shear
        if y_shear_var is not None:
            self._values["y_shear_var"] = y_shear_var

    @builtins.property
    def x_shear(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the x-axis, measured in multiples of the image's width.

        Must be set if yShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear DataAkamaiImagingPolicyImage#x_shear}
        '''
        result = self._values.get("x_shear")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_shear_var(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the x-axis, measured in multiples of the image's width.

        Must be set if yShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear_var DataAkamaiImagingPolicyImage#x_shear_var}
        '''
        result = self._values.get("x_shear_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_shear(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the y-axis, measured in multiples of the image's height.

        Must be set if xShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear DataAkamaiImagingPolicyImage#y_shear}
        '''
        result = self._values.get("y_shear")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_shear_var(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the y-axis, measured in multiples of the image's height.

        Must be set if xShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear_var DataAkamaiImagingPolicyImage#y_shear_var}
        '''
        result = self._values.get("y_shear_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareShear(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareShearList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareShearList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d56a0f5503ff9622a5144afc9ff92d815ac9857fc17f05306c8a49a8ce4ef85f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareShearOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__46375232899ae74e29522a97d236eadafd9bc40b2a41b3199cff5f23c9763b09)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareShearOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d994cd9682effc72ee8eaab6e7be213e223ce706fe0821447a4bedfffbd89a2a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3bc60a7fd76c94d74acb13dd062ad6562c067ff9f9ede4f5c4f13e5dde39fcb7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d7735e8e9c4c8f0352d5d81568314b0f24278b9d5cf0200cac03a89b6f567c35)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareShear]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareShear]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareShear]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2c5dff934b4be4add64736bed3d8becef2f515b43ae74d9ee788910989026bbc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareShearOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareShearOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dcc5df6b504a22e83373a50134a67bf1a34dfc4f81d22ea2d78530fa3768dd9b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetXShear")
    def reset_x_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXShear", []))

    @jsii.member(jsii_name="resetXShearVar")
    def reset_x_shear_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXShearVar", []))

    @jsii.member(jsii_name="resetYShear")
    def reset_y_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYShear", []))

    @jsii.member(jsii_name="resetYShearVar")
    def reset_y_shear_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYShearVar", []))

    @builtins.property
    @jsii.member(jsii_name="xShearInput")
    def x_shear_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xShearInput"))

    @builtins.property
    @jsii.member(jsii_name="xShearVarInput")
    def x_shear_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xShearVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yShearInput")
    def y_shear_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yShearInput"))

    @builtins.property
    @jsii.member(jsii_name="yShearVarInput")
    def y_shear_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yShearVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xShear")
    def x_shear(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xShear"))

    @x_shear.setter
    def x_shear(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__74909ee3117516bc466234e705f360a7a7f7b16c97a807f05516e0f2218337ec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xShear", value)

    @builtins.property
    @jsii.member(jsii_name="xShearVar")
    def x_shear_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xShearVar"))

    @x_shear_var.setter
    def x_shear_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__13627d298a3a35e297bbd5b9716d5611f3ff1be99f1ce8b70b7990fa8ddb0277)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xShearVar", value)

    @builtins.property
    @jsii.member(jsii_name="yShear")
    def y_shear(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yShear"))

    @y_shear.setter
    def y_shear(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2e59e81e4adcc9e11a4788ab0704d56e38f9e5d1f36312286529b562e943c3fb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yShear", value)

    @builtins.property
    @jsii.member(jsii_name="yShearVar")
    def y_shear_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yShearVar"))

    @y_shear_var.setter
    def y_shear_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ac4de92de8fb90b2c1a7dff40078f7e39821c456b8ce6a152869a33a7db6d12)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yShearVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareShear]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareShear]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareShear]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e603f51ba58e983686a0b56c0847701d47b93f6441ff9d4961f6a56f69aaf03b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareTrim",
    jsii_struct_bases=[],
    name_mapping={
        "fuzz": "fuzz",
        "fuzz_var": "fuzzVar",
        "padding": "padding",
        "padding_var": "paddingVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareTrim:
    def __init__(
        self,
        *,
        fuzz: typing.Optional[builtins.str] = None,
        fuzz_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fuzz: The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz DataAkamaiImagingPolicyImage#fuzz}
        :param fuzz_var: The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz_var DataAkamaiImagingPolicyImage#fuzz_var}
        :param padding: The amount of padding in pixels to add to the trimmed image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: The amount of padding in pixels to add to the trimmed image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c94b78d0518f46a05879830fb598744d11ce0c2b5fbe5f59395fab37db4712ee)
            check_type(argname="argument fuzz", value=fuzz, expected_type=type_hints["fuzz"])
            check_type(argname="argument fuzz_var", value=fuzz_var, expected_type=type_hints["fuzz_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fuzz is not None:
            self._values["fuzz"] = fuzz
        if fuzz_var is not None:
            self._values["fuzz_var"] = fuzz_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var

    @builtins.property
    def fuzz(self) -> typing.Optional[builtins.str]:
        '''The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz DataAkamaiImagingPolicyImage#fuzz}
        '''
        result = self._values.get("fuzz")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fuzz_var(self) -> typing.Optional[builtins.str]:
        '''The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz_var DataAkamaiImagingPolicyImage#fuzz_var}
        '''
        result = self._values.get("fuzz_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''The amount of padding in pixels to add to the trimmed image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''The amount of padding in pixels to add to the trimmed image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareTrim(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareTrimList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareTrimList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9fec35998780a1913dcaddabb87d29d7a91be067fa774d29d3d2b21990ebcbf8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareTrimOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8120b033834e5899ddfeb8eece6a0380b686c4787b116c27ff8fc750fe73a610)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareTrimOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9764eb0be1be62924d2f0c55388fe33d5e533054ccc7da389f2fbd544a11a12f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b00f9398931587f074e1f317d5cb8dacf1fd9f90ab28dc2b01825aa476751780)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a200cb50b0bb5560e0534c3437658da2e2158fc7cdb690c1effc2d954a9605be)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareTrim]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareTrim]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareTrim]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__76110b6ba3e4d116684d69c8fd5c731c7ae244bd118d7349a733804a932b1d18)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareTrimOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareTrimOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b756a24c2cb3b59502265789445e2bdce56ee0c4bc665747743970a98571b5c9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetFuzz")
    def reset_fuzz(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFuzz", []))

    @jsii.member(jsii_name="resetFuzzVar")
    def reset_fuzz_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFuzzVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @builtins.property
    @jsii.member(jsii_name="fuzzInput")
    def fuzz_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fuzzInput"))

    @builtins.property
    @jsii.member(jsii_name="fuzzVarInput")
    def fuzz_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fuzzVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="fuzz")
    def fuzz(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fuzz"))

    @fuzz.setter
    def fuzz(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9c192530850e140c2fb268caf48c7e17d68a1b958c9e8faa0e6c5b4472c3e572)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fuzz", value)

    @builtins.property
    @jsii.member(jsii_name="fuzzVar")
    def fuzz_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fuzzVar"))

    @fuzz_var.setter
    def fuzz_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__142172ed34f9817fd71199e15b6a940afe1103c6559c605f06a06fa2f79be7d0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fuzzVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6fc73b063473a5c0976d24d02caa6f8f229c47a834e87718c2e7ec86fa2817f9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2516cd5574250c83ef9fca2e7b7569f9bafe281871664b14677a92545435928f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareTrim]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareTrim]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareTrim]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7093d0218e199be0c1a88dda11c1b3e89c54090f2221cc1a24c8ef9a0e0895c2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareUnsharpMask",
    jsii_struct_bases=[],
    name_mapping={
        "gain": "gain",
        "gain_var": "gainVar",
        "sigma": "sigma",
        "sigma_var": "sigmaVar",
        "threshold": "threshold",
        "threshold_var": "thresholdVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareUnsharpMask:
    def __init__(
        self,
        *,
        gain: typing.Optional[builtins.str] = None,
        gain_var: typing.Optional[builtins.str] = None,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
        threshold: typing.Optional[builtins.str] = None,
        threshold_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param gain: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        :param gain_var: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        :param sigma: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        :param threshold: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        :param threshold_var: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__32c318803f32d244b9dfbbd6abe464ec2e8c468f7acde7a58e23842e98d55d0f)
            check_type(argname="argument gain", value=gain, expected_type=type_hints["gain"])
            check_type(argname="argument gain_var", value=gain_var, expected_type=type_hints["gain_var"])
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
            check_type(argname="argument threshold", value=threshold, expected_type=type_hints["threshold"])
            check_type(argname="argument threshold_var", value=threshold_var, expected_type=type_hints["threshold_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if gain is not None:
            self._values["gain"] = gain
        if gain_var is not None:
            self._values["gain_var"] = gain_var
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var
        if threshold is not None:
            self._values["threshold"] = threshold
        if threshold_var is not None:
            self._values["threshold_var"] = threshold_var

    @builtins.property
    def gain(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        '''
        result = self._values.get("gain")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gain_var(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        '''
        result = self._values.get("gain_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        '''
        result = self._values.get("threshold")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold_var(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        result = self._values.get("threshold_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareUnsharpMask(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareUnsharpMaskList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareUnsharpMaskList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab8eebfc5c560ef8b0c2910354741a096e012bfe40ffefe0124d3cbd8e005b19)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareUnsharpMaskOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__950b94b59d19badf9cbabdaea705efc33697dbe28b506438bb1b8fa5b6e70564)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareUnsharpMaskOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__23453ab80368bbd14016f3d8ceaa2479e4a8413382fcb7933f5e8de4abf041ec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3eb4623ddd56c2d339c8ab2b5377cbd51226bdbb0c889a86686ad3c516dae4b6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d05b91dfde0324fafcecf26a7775d648b0e8396eed12eee124816242af34c8c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareUnsharpMask]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareUnsharpMask]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareUnsharpMask]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__90a269bfdc9aea47200fbdf17778c7438e9d3ffb2f42506e434d91220a91e376)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareUnsharpMaskOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareUnsharpMaskOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1b1345ac1f6e84acb0b0448d87c3403a05b02f648f931f14216d13cf285f82d4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetGain")
    def reset_gain(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGain", []))

    @jsii.member(jsii_name="resetGainVar")
    def reset_gain_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGainVar", []))

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @jsii.member(jsii_name="resetThreshold")
    def reset_threshold(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThreshold", []))

    @jsii.member(jsii_name="resetThresholdVar")
    def reset_threshold_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThresholdVar", []))

    @builtins.property
    @jsii.member(jsii_name="gainInput")
    def gain_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainInput"))

    @builtins.property
    @jsii.member(jsii_name="gainVarInput")
    def gain_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdInput")
    def threshold_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdVarInput")
    def threshold_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gain")
    def gain(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gain"))

    @gain.setter
    def gain(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3d37917393598896e2cb8672c487d8b33c57c7ec69f5650e1d83558c1c584917)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gain", value)

    @builtins.property
    @jsii.member(jsii_name="gainVar")
    def gain_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gainVar"))

    @gain_var.setter
    def gain_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7db5d7ba0aab801c0dbcbf549cd323d7a809f6927795df5aeab5a4547cef2a6b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gainVar", value)

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__279cd57dd62125d7799dc391aa31ff5e302dd8c270af142fe575d896730ac60c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__67f5ed38f3558e7ec281beb5c380c98ea0dec8e2864a30b673985c1eac97716c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="threshold")
    def threshold(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "threshold"))

    @threshold.setter
    def threshold(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc81ebdb3108d31755deec4275f1dd88a6cced5a5113995b916ec5e699b8dda2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "threshold", value)

    @builtins.property
    @jsii.member(jsii_name="thresholdVar")
    def threshold_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "thresholdVar"))

    @threshold_var.setter
    def threshold_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f72e41e64d78d728f54e118e182d5e1a46aaed3f4eb60d9d48028991c15d2fb4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "thresholdVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareUnsharpMask]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareUnsharpMask]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareUnsharpMask]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__afe64af8a48c2ee81a9752b3ead51a61dd897e934062957e1b03da0d4d1f2c85)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualImQuery",
    jsii_struct_bases=[],
    name_mapping={
        "allowed_transformations": "allowedTransformations",
        "query_var": "queryVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualImQuery:
    def __init__(
        self,
        *,
        allowed_transformations: typing.Sequence[builtins.str],
        query_var: builtins.str,
    ) -> None:
        '''
        :param allowed_transformations: Specifies the transformations that can be applied using the query string parameter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allowed_transformations DataAkamaiImagingPolicyImage#allowed_transformations}
        :param query_var: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#query_var DataAkamaiImagingPolicyImage#query_var}.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__19093720e2aa0e36231f9debabe7943c05ff1edf366b523b8d6190c8f2857dd4)
            check_type(argname="argument allowed_transformations", value=allowed_transformations, expected_type=type_hints["allowed_transformations"])
            check_type(argname="argument query_var", value=query_var, expected_type=type_hints["query_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "allowed_transformations": allowed_transformations,
            "query_var": query_var,
        }

    @builtins.property
    def allowed_transformations(self) -> typing.List[builtins.str]:
        '''Specifies the transformations that can be applied using the query string parameter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allowed_transformations DataAkamaiImagingPolicyImage#allowed_transformations}
        '''
        result = self._values.get("allowed_transformations")
        assert result is not None, "Required property 'allowed_transformations' is missing"
        return typing.cast(typing.List[builtins.str], result)

    @builtins.property
    def query_var(self) -> builtins.str:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#query_var DataAkamaiImagingPolicyImage#query_var}.'''
        result = self._values.get("query_var")
        assert result is not None, "Required property 'query_var' is missing"
        return typing.cast(builtins.str, result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualImQuery(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualImQueryList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualImQueryList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8af10eca322a3a370cabbeb736cd6950b75139989c65feb95abdf73fc84e0ea2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualImQueryOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__88160733a08c25ec5f1b8135332c3b970a36f6ef85b7bd874e054e798f576fbb)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualImQueryOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4c8df4f2ab5f4642237bffff52acc6cd00a34f606a6aff2a92b60b212efef8b9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__494a7da61be4c4aece181df4545338dea572f6fa627f7dbadd14b0948d2a59cb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f5742c874c46d3fe14955b8d10d39da1056250b2cc917f73a03baa5c93c73afa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualImQuery]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualImQuery]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualImQuery]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__775025c9be614c1e44b9588301e24e580cb10df14db415dba186f8f7689a73f8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualImQueryOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualImQueryOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb6c4c606c08452780eaeb4da533c7195032714dfc524a09cf54e071fec81899)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @builtins.property
    @jsii.member(jsii_name="allowedTransformationsInput")
    def allowed_transformations_input(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "allowedTransformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="queryVarInput")
    def query_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "queryVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowedTransformations")
    def allowed_transformations(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "allowedTransformations"))

    @allowed_transformations.setter
    def allowed_transformations(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b013b8cac8615575b3db7c0d087279925c02107f3fcb1e69618d37693cca3ad9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowedTransformations", value)

    @builtins.property
    @jsii.member(jsii_name="queryVar")
    def query_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "queryVar"))

    @query_var.setter
    def query_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c308d85997f8e8354f8f36c0f03e5b246d8cb28c76077bef1941881857f2beb7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "queryVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualImQuery]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualImQuery]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualImQuery]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f9f2ab34917b70501c8adfc140e9b28ece66eb99e06705320b30acb3d77ee867)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualMaxColors",
    jsii_struct_bases=[],
    name_mapping={"colors": "colors", "colors_var": "colorsVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualMaxColors:
    def __init__(
        self,
        *,
        colors: typing.Optional[builtins.str] = None,
        colors_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param colors: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        :param colors_var: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d852b1b086d0f91988b09666c29d4256ece720db5985ada379821c304e6e410f)
            check_type(argname="argument colors", value=colors, expected_type=type_hints["colors"])
            check_type(argname="argument colors_var", value=colors_var, expected_type=type_hints["colors_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if colors is not None:
            self._values["colors"] = colors
        if colors_var is not None:
            self._values["colors_var"] = colors_var

    @builtins.property
    def colors(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        '''
        result = self._values.get("colors")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def colors_var(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        result = self._values.get("colors_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualMaxColors(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualMaxColorsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualMaxColorsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cff4003843baea3da275ddb91b46907c10ca1dd4e365f0dc7fca5fb93fe10c8b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualMaxColorsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5d27dca72606330d27452b3e8e5896a090b2226a881278a134612432f3ad25ff)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualMaxColorsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e13c2fdf5c07484847111b8c6fc5e86011dcd7c70feb61aba564a4eb45c409b8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e1cff62853a5b69586fdcab2ee208cec718f6d4fa6bb1e5553cdf61427667778)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8bdb8059cd97055dfd48e05081ad3e114596747052693dcf47c4cfc0c56d0733)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualMaxColors]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualMaxColors]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__69f9189dd7e02f739a230d4665292e5b4c0d373ea452f0a12c35c86c751ad5f2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualMaxColorsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualMaxColorsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e1444030e810b536bd2163bfcb004074ac21439d5714eb884898b7ab85783e30)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColors")
    def reset_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColors", []))

    @jsii.member(jsii_name="resetColorsVar")
    def reset_colors_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorsVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorsInput")
    def colors_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsInput"))

    @builtins.property
    @jsii.member(jsii_name="colorsVarInput")
    def colors_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsVarInput"))

    @builtins.property
    @jsii.member(jsii_name="colors")
    def colors(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colors"))

    @colors.setter
    def colors(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b482c1517541b83ad75523897c74b9a91e140fdd587cd500660a434716f85bac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colors", value)

    @builtins.property
    @jsii.member(jsii_name="colorsVar")
    def colors_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorsVar"))

    @colors_var.setter
    def colors_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__539547e4ce1cd1addaeef0c7fb4eacfafef1f4d4c0d4855fcc7fe65b600dcbb5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorsVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualMaxColors]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualMaxColors]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualMaxColors]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f88bdc9b92a18330f26990fdd3661521d6ac86dfd69bea4da3a196705f726c9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualMirror",
    jsii_struct_bases=[],
    name_mapping={
        "horizontal": "horizontal",
        "horizontal_var": "horizontalVar",
        "vertical": "vertical",
        "vertical_var": "verticalVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualMirror:
    def __init__(
        self,
        *,
        horizontal: typing.Optional[builtins.str] = None,
        horizontal_var: typing.Optional[builtins.str] = None,
        vertical: typing.Optional[builtins.str] = None,
        vertical_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param horizontal: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        :param horizontal_var: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        :param vertical: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        :param vertical_var: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f23b804fa35e38ec18cad158b459f2d21bf1d009400b2fee021fecff9ecbea3e)
            check_type(argname="argument horizontal", value=horizontal, expected_type=type_hints["horizontal"])
            check_type(argname="argument horizontal_var", value=horizontal_var, expected_type=type_hints["horizontal_var"])
            check_type(argname="argument vertical", value=vertical, expected_type=type_hints["vertical"])
            check_type(argname="argument vertical_var", value=vertical_var, expected_type=type_hints["vertical_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if horizontal is not None:
            self._values["horizontal"] = horizontal
        if horizontal_var is not None:
            self._values["horizontal_var"] = horizontal_var
        if vertical is not None:
            self._values["vertical"] = vertical
        if vertical_var is not None:
            self._values["vertical_var"] = vertical_var

    @builtins.property
    def horizontal(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        '''
        result = self._values.get("horizontal")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def horizontal_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        '''
        result = self._values.get("horizontal_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        '''
        result = self._values.get("vertical")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        result = self._values.get("vertical_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualMirror(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualMirrorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualMirrorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__45825706650855dc7e1dcdb8294177739c5b70d12a74aa114be9a94b225350ee)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualMirrorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__90c28206001933d96c3bd899cc393ed326a8edf87cbf6a4530aea7c3ffc33d0a)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualMirrorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__67e73cea6a189c196d02856f70dca4b1970ab24fff64cb091094a37dc75cde50)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__797319edd74f2d334d1a79ed4d092f7074558038c85c688c911915eef2a50a88)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__884d6f13982d7e31e36ffe927cce7f002df7190d95173923a542add024bb5ee7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualMirror]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualMirror]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6ecf36e490d0875a244991f865fa2f3d9f0a99440a7b4e974b65e4af9d3eed85)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualMirrorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualMirrorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8f0ea683f07fd6055cc6f1bedc4705787b76612efee793fcd2e6e776a99b6fd8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHorizontal")
    def reset_horizontal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontal", []))

    @jsii.member(jsii_name="resetHorizontalVar")
    def reset_horizontal_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontalVar", []))

    @jsii.member(jsii_name="resetVertical")
    def reset_vertical(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVertical", []))

    @jsii.member(jsii_name="resetVerticalVar")
    def reset_vertical_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVerticalVar", []))

    @builtins.property
    @jsii.member(jsii_name="horizontalInput")
    def horizontal_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontalVarInput")
    def horizontal_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalInput")
    def vertical_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalVarInput")
    def vertical_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontal")
    def horizontal(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontal"))

    @horizontal.setter
    def horizontal(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__860be0aa47c5601a9f711866c231ed1f3d63dede5ae36a44425e676c54b35ea3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontal", value)

    @builtins.property
    @jsii.member(jsii_name="horizontalVar")
    def horizontal_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontalVar"))

    @horizontal_var.setter
    def horizontal_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__deda14828416839180179393fa40fe21b04a4d7ef09612a320a3f61c772c1184)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontalVar", value)

    @builtins.property
    @jsii.member(jsii_name="vertical")
    def vertical(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "vertical"))

    @vertical.setter
    def vertical(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__22d7aeb0a1e5e6f2087a94f96061c3c42ed547cc1efd72fd8206040afe20be69)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "vertical", value)

    @builtins.property
    @jsii.member(jsii_name="verticalVar")
    def vertical_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "verticalVar"))

    @vertical_var.setter
    def vertical_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f305cee0835e9091fb926ee1f6614e66eb61d14f8adca1c3f58b56087842b72b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "verticalVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualMirror]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualMirror]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualMirror]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b3dd089ef56e33f4b7600d787c5538cec40c27069f0d9dd8a64fe1aab5f2ee10)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualMonoHue",
    jsii_struct_bases=[],
    name_mapping={"hue": "hue", "hue_var": "hueVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualMonoHue:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f4d307c913ddb1c8b8fda833ef21c911d89c1ca66c16ff93780b002848871926)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualMonoHue(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualMonoHueList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualMonoHueList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__82d45ef24e072cad51f137031f63507a0f88b90c1bc2c83cd809a85d2dfd556a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualMonoHueOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b004ecae5295b1643d21988cfc202b7e3abec3082eeb868cec5d33af9e445a87)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualMonoHueOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__98c60bf6b9196c4bdaf71af9300ccbfd85faa4f2873ab97d22c90962e0018028)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9b628da7c496b7a2a912723922ff7507cdf04259b8604514df4b3dc4f02445a7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__70b95bc5052d20cc7a95374a35374d2d2b6a5d392b3ba73df9f68fb6e596ae5c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualMonoHue]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualMonoHue]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0bbff87d0e9f016596db5401df6a882be21dad600de9e06689d61042836286ff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualMonoHueOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualMonoHueOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3658a04f2140f63ce849bd5d3cf5a4652b0b7c9173d5ebbb3236c670053bdf33)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__73603dc1b49d51f96a02ff4490c9f60ea73164f88079e0f83fa5054358cfe8b6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa5e94a6616f210d9c8efdeae7f5c4d22cbe73aea668fe70bdf45ed33373a7f2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualMonoHue]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualMonoHue]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualMonoHue]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__25dd3a669d792edb9fb7610481f88377dc0f5285b647daef246c203fe367e4c7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualOpacity",
    jsii_struct_bases=[],
    name_mapping={"opacity": "opacity", "opacity_var": "opacityVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualOpacity:
    def __init__(
        self,
        *,
        opacity: typing.Optional[builtins.str] = None,
        opacity_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param opacity: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param opacity_var: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f9e640f3fb8ada173ad40abf55798385726e83a93888ce724017d73ae32d057)
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument opacity_var", value=opacity_var, expected_type=type_hints["opacity_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if opacity is not None:
            self._values["opacity"] = opacity
        if opacity_var is not None:
            self._values["opacity_var"] = opacity_var

    @builtins.property
    def opacity(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def opacity_var(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        result = self._values.get("opacity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualOpacity(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualOpacityList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualOpacityList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a7975a76eb522e2e3953f1a20ae9e56e6fc49a1ae70d0fbd32c0c20c505852a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualOpacityOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0da80bc69256a4b78d751de4da2d9b8a5c0f94ca1026ee4ceefce1a9b31ddb03)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualOpacityOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ba7424eaf21f91ffeb73d0e118f7fa9021cbfc40faccbe4434357213a3c5bb3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6b193d1eeb93bd0fba9ad0e344f38104fa9d1e4728d3570b1fc0a16225881b65)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ccd3ebfe28e368dbdfa75f248e3d1655ed09ddc9ee23ebadab0aa9d64a118a4d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualOpacity]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualOpacity]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c726c6094c9e732a3aea7771e0163f176e8a3bd481c4bf5ab964f07ed2c691ed)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualOpacityOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualOpacityOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1905fd9b136c1acbf9345b7c8ef254ebf40013561060b56e90742b453551524d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetOpacityVar")
    def reset_opacity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacityVar", []))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityVarInput")
    def opacity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacity"))

    @opacity.setter
    def opacity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8dabd21fd3e160fc141c87d1d6d346e9b739a7eef21d93b5185576cfb8e55ee9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacity", value)

    @builtins.property
    @jsii.member(jsii_name="opacityVar")
    def opacity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacityVar"))

    @opacity_var.setter
    def opacity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dddf25303f5612e5e3dc878203c8cbfc7c697adcdc228f1e0bb0b0ccadba6b03)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacityVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualOpacity]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualOpacity]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualOpacity]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__35b1db74fba238bd9007b827bb6795a492d5b270dd65325ca0a2ec319805ea93)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eed86efdf0c4155b9e87f05cef8e5f7b8657aff9359ffe046d3f72d6512f287c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putAppend")
    def put_append(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppend, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c1894ef614e8e03cebc5d71a2df67aac913fb72d664f1db2062cb9aad3f6e66a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putAppend", [value]))

    @jsii.member(jsii_name="putAspectCrop")
    def put_aspect_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAspectCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9627bf7944a6bffcbfd7794ded6d32f61e71c96117d01c509a6bfa75638b1179)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putAspectCrop", [value]))

    @jsii.member(jsii_name="putBackgroundColor")
    def put_background_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c38dc5274fdae0b425a4a01e94df3d593e7c2bae18985184c6909271cae8bafd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBackgroundColor", [value]))

    @jsii.member(jsii_name="putBlur")
    def put_blur(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualBlur, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7f24ba1fc2a7cf93cac65542331ed7f33a96512c6e0732cb78be9f78dba64709)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBlur", [value]))

    @jsii.member(jsii_name="putChromaKey")
    def put_chroma_key(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualChromaKey, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__40cd8d2dce22127c3be6afcd57d048b370445f87322ff6d08341498b0a5367f0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putChromaKey", [value]))

    @jsii.member(jsii_name="putComposite")
    def put_composite(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualComposite, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1061bebcd62044b73217423b6f3a126fe51be6722616ec3ed371c138d4406d55)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putComposite", [value]))

    @jsii.member(jsii_name="putCompound")
    def put_compound(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompound, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__59470f374119cc5621631b6e5e84495b6ed52f2ad70e1efccaf9c307a98376e6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCompound", [value]))

    @jsii.member(jsii_name="putContrast")
    def put_contrast(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualContrast, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b8729117c95d15c20ab735e0d5a49d4e301e096eb20fb5765b6267b77badb291)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putContrast", [value]))

    @jsii.member(jsii_name="putCrop")
    def put_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__83510e09bdc2d272816a747fae07bc64f2c57f5bce20451ce678db2fc5c466c5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCrop", [value]))

    @jsii.member(jsii_name="putFaceCrop")
    def put_face_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFaceCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b3642b19b0d91089ec73a9b8016868988b7a49d06c85a8ebe9ae89e461a82967)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFaceCrop", [value]))

    @jsii.member(jsii_name="putFeatureCrop")
    def put_feature_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFeatureCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6d3556ee20a91ab1d337c495d14774e7ab68cad9627fe23e9aa9592722cdd83f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFeatureCrop", [value]))

    @jsii.member(jsii_name="putFitAndFill")
    def put_fit_and_fill(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFill, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1ddeff3fa9f2bb25362142b3c084a54ae3351890c6d7dbd1bf2fbb5d2cee1c03)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFitAndFill", [value]))

    @jsii.member(jsii_name="putGoop")
    def put_goop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualGoop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a4399ec2e9d49f860415846e2f787a4b8fd953dd1f8f84b5621e9c1835257f63)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGoop", [value]))

    @jsii.member(jsii_name="putGrayscale")
    def put_grayscale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualGrayscale, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7bcfd1d2189658df3a5f05cd89ab5ba39d161c5fae1bf64e4c1778e7d4d455f4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGrayscale", [value]))

    @jsii.member(jsii_name="putHsl")
    def put_hsl(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualHsl, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b141d2a8897f7cfcc02d3f3c63df37cf6ef6b4c81d89745ea6f3afff656bc048)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsl", [value]))

    @jsii.member(jsii_name="putHsv")
    def put_hsv(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualHsv, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__01ebe3d4661f36c25342fdef8dc764d36d9013f14a1efef0994d29132f8e5bb2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsv", [value]))

    @jsii.member(jsii_name="putIfDimension")
    def put_if_dimension(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimension, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f9250762c04dfebd2090377342b5616530d5450566842fbf80bbe63461dacc3d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfDimension", [value]))

    @jsii.member(jsii_name="putIfOrientation")
    def put_if_orientation(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__993d247d0a265146eb6c6fcea5087e2f3f865f5f29a6486bc4b9a83612f10396)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfOrientation", [value]))

    @jsii.member(jsii_name="putImQuery")
    def put_im_query(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualImQuery, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6a875a3ab78aec9041d8912416a749b82f64f2b90072f03df19dfbc9ead52d2e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putImQuery", [value]))

    @jsii.member(jsii_name="putMaxColors")
    def put_max_colors(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualMaxColors, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4316c8b04caa1d631cc0f8f14fa468a827c8f7218f9f36955d34278958621f11)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMaxColors", [value]))

    @jsii.member(jsii_name="putMirror")
    def put_mirror(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualMirror, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__28399fac47dda6a961583729f439e064aa772ddeab59d2dbafe47d99cea4e630)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMirror", [value]))

    @jsii.member(jsii_name="putMonoHue")
    def put_mono_hue(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualMonoHue, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__775e1624d2ea665b09c8b22d28343a058c9a4c0f3b05e472e70f5d240b06ec8d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMonoHue", [value]))

    @jsii.member(jsii_name="putOpacity")
    def put_opacity(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualOpacity, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7886aa0307d4bb5dd9e53d4eebcaa75a4ccdcfd9895b2bf4e5811b406577c6ee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putOpacity", [value]))

    @jsii.member(jsii_name="putRegionOfInterestCrop")
    def put_region_of_interest_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCrop", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4346938a298b21f2777cb1989b53c7210f97069e39c765872567ea0830b3ef79)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRegionOfInterestCrop", [value]))

    @jsii.member(jsii_name="putRelativeCrop")
    def put_relative_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRelativeCrop", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2128c6015d4436d93cda304620498b5d93d1cf198520b4d3881207b3a28b6678)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRelativeCrop", [value]))

    @jsii.member(jsii_name="putRemoveColor")
    def put_remove_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRemoveColor", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9b34f88a8e52c3fa7b30b6b497805fd13b8b72585b3a05b440f5437f92adf251)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRemoveColor", [value]))

    @jsii.member(jsii_name="putResize")
    def put_resize(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualResize", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__06ebe2545ff916cb7e56b458d5c5985f8bb84e8cf4aa01419ee31dc45578e5f0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putResize", [value]))

    @jsii.member(jsii_name="putRotate")
    def put_rotate(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRotate", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d4d1b83d6913dccd5884ac800319b83cb71e892d8f88b0324c1b95abc631f867)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRotate", [value]))

    @jsii.member(jsii_name="putScale")
    def put_scale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualScale", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa3700be24c516f1c49ba38e308dfbcf541dbe058a944e61adcd714dd30c3567)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putScale", [value]))

    @jsii.member(jsii_name="putShear")
    def put_shear(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualShear", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6251d58146eb44f32c78a24641c1ffd37a5a08c22db6ca1dab3a46eba391a708)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putShear", [value]))

    @jsii.member(jsii_name="putTrim")
    def put_trim(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualTrim", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6a2559c9a76552a932ca8e3648ee41c6c751058693cf1b6b3018b5cf2b11b12c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTrim", [value]))

    @jsii.member(jsii_name="putUnsharpMask")
    def put_unsharp_mask(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualUnsharpMask", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cf60e3bf61c29a8fb31e20aac66764db6a402316426a53d14c5389dcbaa61c7c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putUnsharpMask", [value]))

    @jsii.member(jsii_name="resetAppend")
    def reset_append(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAppend", []))

    @jsii.member(jsii_name="resetAspectCrop")
    def reset_aspect_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspectCrop", []))

    @jsii.member(jsii_name="resetBackgroundColor")
    def reset_background_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBackgroundColor", []))

    @jsii.member(jsii_name="resetBlur")
    def reset_blur(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBlur", []))

    @jsii.member(jsii_name="resetChromaKey")
    def reset_chroma_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChromaKey", []))

    @jsii.member(jsii_name="resetComposite")
    def reset_composite(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetComposite", []))

    @jsii.member(jsii_name="resetCompound")
    def reset_compound(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCompound", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetCrop")
    def reset_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCrop", []))

    @jsii.member(jsii_name="resetFaceCrop")
    def reset_face_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFaceCrop", []))

    @jsii.member(jsii_name="resetFeatureCrop")
    def reset_feature_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureCrop", []))

    @jsii.member(jsii_name="resetFitAndFill")
    def reset_fit_and_fill(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFitAndFill", []))

    @jsii.member(jsii_name="resetGoop")
    def reset_goop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGoop", []))

    @jsii.member(jsii_name="resetGrayscale")
    def reset_grayscale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGrayscale", []))

    @jsii.member(jsii_name="resetHsl")
    def reset_hsl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsl", []))

    @jsii.member(jsii_name="resetHsv")
    def reset_hsv(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsv", []))

    @jsii.member(jsii_name="resetIfDimension")
    def reset_if_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfDimension", []))

    @jsii.member(jsii_name="resetIfOrientation")
    def reset_if_orientation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfOrientation", []))

    @jsii.member(jsii_name="resetImQuery")
    def reset_im_query(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetImQuery", []))

    @jsii.member(jsii_name="resetMaxColors")
    def reset_max_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxColors", []))

    @jsii.member(jsii_name="resetMirror")
    def reset_mirror(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMirror", []))

    @jsii.member(jsii_name="resetMonoHue")
    def reset_mono_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonoHue", []))

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetRegionOfInterestCrop")
    def reset_region_of_interest_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRegionOfInterestCrop", []))

    @jsii.member(jsii_name="resetRelativeCrop")
    def reset_relative_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRelativeCrop", []))

    @jsii.member(jsii_name="resetRemoveColor")
    def reset_remove_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRemoveColor", []))

    @jsii.member(jsii_name="resetResize")
    def reset_resize(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetResize", []))

    @jsii.member(jsii_name="resetRotate")
    def reset_rotate(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRotate", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetShear")
    def reset_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetShear", []))

    @jsii.member(jsii_name="resetTrim")
    def reset_trim(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTrim", []))

    @jsii.member(jsii_name="resetUnsharpMask")
    def reset_unsharp_mask(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUnsharpMask", []))

    @builtins.property
    @jsii.member(jsii_name="append")
    def append(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendList, jsii.get(self, "append"))

    @builtins.property
    @jsii.member(jsii_name="aspectCrop")
    def aspect_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAspectCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAspectCropList, jsii.get(self, "aspectCrop"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColor")
    def background_color(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualBackgroundColorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualBackgroundColorList, jsii.get(self, "backgroundColor"))

    @builtins.property
    @jsii.member(jsii_name="blur")
    def blur(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualBlurList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualBlurList, jsii.get(self, "blur"))

    @builtins.property
    @jsii.member(jsii_name="chromaKey")
    def chroma_key(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualChromaKeyList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualChromaKeyList, jsii.get(self, "chromaKey"))

    @builtins.property
    @jsii.member(jsii_name="composite")
    def composite(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeList, jsii.get(self, "composite"))

    @builtins.property
    @jsii.member(jsii_name="compound")
    def compound(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompoundList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompoundList, jsii.get(self, "compound"))

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualContrastList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualContrastList, jsii.get(self, "contrast"))

    @builtins.property
    @jsii.member(jsii_name="crop")
    def crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCropList, jsii.get(self, "crop"))

    @builtins.property
    @jsii.member(jsii_name="faceCrop")
    def face_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFaceCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFaceCropList, jsii.get(self, "faceCrop"))

    @builtins.property
    @jsii.member(jsii_name="featureCrop")
    def feature_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFeatureCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFeatureCropList, jsii.get(self, "featureCrop"))

    @builtins.property
    @jsii.member(jsii_name="fitAndFill")
    def fit_and_fill(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillList, jsii.get(self, "fitAndFill"))

    @builtins.property
    @jsii.member(jsii_name="goop")
    def goop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualGoopList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualGoopList, jsii.get(self, "goop"))

    @builtins.property
    @jsii.member(jsii_name="grayscale")
    def grayscale(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualGrayscaleList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualGrayscaleList, jsii.get(self, "grayscale"))

    @builtins.property
    @jsii.member(jsii_name="hsl")
    def hsl(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualHslList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualHslList, jsii.get(self, "hsl"))

    @builtins.property
    @jsii.member(jsii_name="hsv")
    def hsv(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualHsvList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualHsvList, jsii.get(self, "hsv"))

    @builtins.property
    @jsii.member(jsii_name="ifDimension")
    def if_dimension(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionList", jsii.get(self, "ifDimension"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientation")
    def if_orientation(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationList, jsii.get(self, "ifOrientation"))

    @builtins.property
    @jsii.member(jsii_name="imQuery")
    def im_query(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualImQueryList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualImQueryList, jsii.get(self, "imQuery"))

    @builtins.property
    @jsii.member(jsii_name="maxColors")
    def max_colors(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualMaxColorsList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualMaxColorsList, jsii.get(self, "maxColors"))

    @builtins.property
    @jsii.member(jsii_name="mirror")
    def mirror(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualMirrorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualMirrorList, jsii.get(self, "mirror"))

    @builtins.property
    @jsii.member(jsii_name="monoHue")
    def mono_hue(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualMonoHueList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualMonoHueList, jsii.get(self, "monoHue"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualOpacityList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualOpacityList, jsii.get(self, "opacity"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestCrop")
    def region_of_interest_crop(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropList", jsii.get(self, "regionOfInterestCrop"))

    @builtins.property
    @jsii.member(jsii_name="relativeCrop")
    def relative_crop(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRelativeCropList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRelativeCropList", jsii.get(self, "relativeCrop"))

    @builtins.property
    @jsii.member(jsii_name="removeColor")
    def remove_color(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRemoveColorList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRemoveColorList", jsii.get(self, "removeColor"))

    @builtins.property
    @jsii.member(jsii_name="resize")
    def resize(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualResizeList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualResizeList", jsii.get(self, "resize"))

    @builtins.property
    @jsii.member(jsii_name="rotate")
    def rotate(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRotateList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRotateList", jsii.get(self, "rotate"))

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualScaleList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualScaleList", jsii.get(self, "scale"))

    @builtins.property
    @jsii.member(jsii_name="shear")
    def shear(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualShearList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualShearList", jsii.get(self, "shear"))

    @builtins.property
    @jsii.member(jsii_name="trim")
    def trim(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualTrimList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualTrimList", jsii.get(self, "trim"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMask")
    def unsharp_mask(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualUnsharpMaskList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualUnsharpMaskList", jsii.get(self, "unsharpMask"))

    @builtins.property
    @jsii.member(jsii_name="appendInput")
    def append_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppend]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppend]]], jsii.get(self, "appendInput"))

    @builtins.property
    @jsii.member(jsii_name="aspectCropInput")
    def aspect_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAspectCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAspectCrop]]], jsii.get(self, "aspectCropInput"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColorInput")
    def background_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualBackgroundColor]]], jsii.get(self, "backgroundColorInput"))

    @builtins.property
    @jsii.member(jsii_name="blurInput")
    def blur_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualBlur]]], jsii.get(self, "blurInput"))

    @builtins.property
    @jsii.member(jsii_name="chromaKeyInput")
    def chroma_key_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualChromaKey]]], jsii.get(self, "chromaKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="compositeInput")
    def composite_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualComposite]]], jsii.get(self, "compositeInput"))

    @builtins.property
    @jsii.member(jsii_name="compoundInput")
    def compound_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompound]]], jsii.get(self, "compoundInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualContrast]]], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="cropInput")
    def crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCrop]]], jsii.get(self, "cropInput"))

    @builtins.property
    @jsii.member(jsii_name="faceCropInput")
    def face_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFaceCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFaceCrop]]], jsii.get(self, "faceCropInput"))

    @builtins.property
    @jsii.member(jsii_name="featureCropInput")
    def feature_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFeatureCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFeatureCrop]]], jsii.get(self, "featureCropInput"))

    @builtins.property
    @jsii.member(jsii_name="fitAndFillInput")
    def fit_and_fill_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFill]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFill]]], jsii.get(self, "fitAndFillInput"))

    @builtins.property
    @jsii.member(jsii_name="goopInput")
    def goop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualGoop]]], jsii.get(self, "goopInput"))

    @builtins.property
    @jsii.member(jsii_name="grayscaleInput")
    def grayscale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualGrayscale]]], jsii.get(self, "grayscaleInput"))

    @builtins.property
    @jsii.member(jsii_name="hslInput")
    def hsl_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualHsl]]], jsii.get(self, "hslInput"))

    @builtins.property
    @jsii.member(jsii_name="hsvInput")
    def hsv_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualHsv]]], jsii.get(self, "hsvInput"))

    @builtins.property
    @jsii.member(jsii_name="ifDimensionInput")
    def if_dimension_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimension]]], jsii.get(self, "ifDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientationInput")
    def if_orientation_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientation]]], jsii.get(self, "ifOrientationInput"))

    @builtins.property
    @jsii.member(jsii_name="imQueryInput")
    def im_query_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualImQuery]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualImQuery]]], jsii.get(self, "imQueryInput"))

    @builtins.property
    @jsii.member(jsii_name="maxColorsInput")
    def max_colors_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualMaxColors]]], jsii.get(self, "maxColorsInput"))

    @builtins.property
    @jsii.member(jsii_name="mirrorInput")
    def mirror_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualMirror]]], jsii.get(self, "mirrorInput"))

    @builtins.property
    @jsii.member(jsii_name="monoHueInput")
    def mono_hue_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualMonoHue]]], jsii.get(self, "monoHueInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualOpacity]]], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestCropInput")
    def region_of_interest_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCrop"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCrop"]]], jsii.get(self, "regionOfInterestCropInput"))

    @builtins.property
    @jsii.member(jsii_name="relativeCropInput")
    def relative_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRelativeCrop"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRelativeCrop"]]], jsii.get(self, "relativeCropInput"))

    @builtins.property
    @jsii.member(jsii_name="removeColorInput")
    def remove_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRemoveColor"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRemoveColor"]]], jsii.get(self, "removeColorInput"))

    @builtins.property
    @jsii.member(jsii_name="resizeInput")
    def resize_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualResize"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualResize"]]], jsii.get(self, "resizeInput"))

    @builtins.property
    @jsii.member(jsii_name="rotateInput")
    def rotate_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRotate"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRotate"]]], jsii.get(self, "rotateInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualScale"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualScale"]]], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="shearInput")
    def shear_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualShear"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualShear"]]], jsii.get(self, "shearInput"))

    @builtins.property
    @jsii.member(jsii_name="trimInput")
    def trim_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualTrim"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualTrim"]]], jsii.get(self, "trimInput"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMaskInput")
    def unsharp_mask_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualUnsharpMask"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualUnsharpMask"]]], jsii.get(self, "unsharpMaskInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqual], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqual],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a55bc868a58d30035d769682afd3bc306e1020c313c1e4ef1b9bffcfcf0c5dd5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCrop",
    jsii_struct_bases=[],
    name_mapping={
        "region_of_interest": "regionOfInterest",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCrop:
    def __init__(
        self,
        *,
        region_of_interest: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterest", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param region_of_interest: region_of_interest block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest DataAkamaiImagingPolicyImage#region_of_interest}
        :param gravity: The placement of the crop area relative to the specified area of interest. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: The placement of the crop area relative to the specified area of interest. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param style: Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(region_of_interest, dict):
            region_of_interest = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterest(**region_of_interest)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cbdbb2ddf5af516bf1ccd7cf71152980ec5a915a7ac7ed773d33130fa0d6ae62)
            check_type(argname="argument region_of_interest", value=region_of_interest, expected_type=type_hints["region_of_interest"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "region_of_interest": region_of_interest,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def region_of_interest(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterest":
        '''region_of_interest block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest DataAkamaiImagingPolicyImage#region_of_interest}
        '''
        result = self._values.get("region_of_interest")
        assert result is not None, "Required property 'region_of_interest' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterest", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''The placement of the crop area relative to the specified area of interest.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''The placement of the crop area relative to the specified area of interest.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac022cb29f393efc63c8c251a8d5ecb0c8a8cdff7667213fff80735807c0f58a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__776c7ab9bb308317b63626a3981c75f9502dd8eb4a2639d106173af95f4a2639)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eaedf6976a34eee9895190f783b39a7b7ed94d0e23ec3dac978c17c7940e0a48)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__962b38131d5657dc3ca590b726191c6b2a2870dd3f4f57c4b4db0cc2409cd41d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5a525a277d4b6867618e4bac6f8d0bb0efc98e0314e3026135cafff3c1d89a8d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1bb60439b3ec8f489be4cf0076a68310d985d09591aa8926f6c5f34aaa82e7f2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1388e2db166708d52cff9e32d0d2f9fa911fe0c31cef871276cc769d49a8867b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putRegionOfInterest")
    def put_region_of_interest(
        self,
        *,
        circle_shape: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestCircleShape", typing.Dict[builtins.str, typing.Any]]]]] = None,
        point_shape: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestPointShape", typing.Dict[builtins.str, typing.Any]]]]] = None,
        polygon_shape: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestPolygonShape", typing.Dict[builtins.str, typing.Any]]]]] = None,
        rectangle_shape: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestRectangleShape", typing.Dict[builtins.str, typing.Any]]]]] = None,
        union_shape: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestUnionShape", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param circle_shape: circle_shape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#circle_shape DataAkamaiImagingPolicyImage#circle_shape}
        :param point_shape: point_shape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#point_shape DataAkamaiImagingPolicyImage#point_shape}
        :param polygon_shape: polygon_shape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#polygon_shape DataAkamaiImagingPolicyImage#polygon_shape}
        :param rectangle_shape: rectangle_shape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rectangle_shape DataAkamaiImagingPolicyImage#rectangle_shape}
        :param union_shape: union_shape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#union_shape DataAkamaiImagingPolicyImage#union_shape}
        '''
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterest(
            circle_shape=circle_shape,
            point_shape=point_shape,
            polygon_shape=polygon_shape,
            rectangle_shape=rectangle_shape,
            union_shape=union_shape,
        )

        return typing.cast(None, jsii.invoke(self, "putRegionOfInterest", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterest")
    def region_of_interest(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestOutputReference", jsii.get(self, "regionOfInterest"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestInput")
    def region_of_interest_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterest"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterest"], jsii.get(self, "regionOfInterestInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__548928e6e228f0f88d8ecbd1eaac14f3967b6c986140d5789656d53d86817295)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b70516a93857106e5f86a33b034089d86fcd993dc30101ac3157d3592125d72c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f41fbed307aeb986f5520c38e200442a5569497bff453a71c1a185e524386365)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1c9b9741c587bfdfb5d5e628658c24abdecb3314d151290b137251d75df5ac23)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d7962ba03846a216f81bfe069c19e97b1bf1f5c05b7db29c21eb88c8d7519ec2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c45dff11d7ed9b918d4cb9beb8033d28727edad5debc82fd112a42c40794a273)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9dd674fd9c90113b4edf65b4a47e1a0b020e270adf792a8dc7e58f4e4854d219)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a43497d9f832c7c4c21053e5221fc1e427f40cf85bfa1871aefd963e90638dce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6a8171c89cc0121e6befc3a347662336f733d91a7188acf70734b66b1cfb7bc3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterest",
    jsii_struct_bases=[],
    name_mapping={
        "circle_shape": "circleShape",
        "point_shape": "pointShape",
        "polygon_shape": "polygonShape",
        "rectangle_shape": "rectangleShape",
        "union_shape": "unionShape",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterest:
    def __init__(
        self,
        *,
        circle_shape: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestCircleShape", typing.Dict[builtins.str, typing.Any]]]]] = None,
        point_shape: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestPointShape", typing.Dict[builtins.str, typing.Any]]]]] = None,
        polygon_shape: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestPolygonShape", typing.Dict[builtins.str, typing.Any]]]]] = None,
        rectangle_shape: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestRectangleShape", typing.Dict[builtins.str, typing.Any]]]]] = None,
        union_shape: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestUnionShape", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param circle_shape: circle_shape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#circle_shape DataAkamaiImagingPolicyImage#circle_shape}
        :param point_shape: point_shape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#point_shape DataAkamaiImagingPolicyImage#point_shape}
        :param polygon_shape: polygon_shape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#polygon_shape DataAkamaiImagingPolicyImage#polygon_shape}
        :param rectangle_shape: rectangle_shape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rectangle_shape DataAkamaiImagingPolicyImage#rectangle_shape}
        :param union_shape: union_shape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#union_shape DataAkamaiImagingPolicyImage#union_shape}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b73fb5328ec1c7f80eece1a4c71efde3c38bf3cdeff9eba2c0ce7d6c88936385)
            check_type(argname="argument circle_shape", value=circle_shape, expected_type=type_hints["circle_shape"])
            check_type(argname="argument point_shape", value=point_shape, expected_type=type_hints["point_shape"])
            check_type(argname="argument polygon_shape", value=polygon_shape, expected_type=type_hints["polygon_shape"])
            check_type(argname="argument rectangle_shape", value=rectangle_shape, expected_type=type_hints["rectangle_shape"])
            check_type(argname="argument union_shape", value=union_shape, expected_type=type_hints["union_shape"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if circle_shape is not None:
            self._values["circle_shape"] = circle_shape
        if point_shape is not None:
            self._values["point_shape"] = point_shape
        if polygon_shape is not None:
            self._values["polygon_shape"] = polygon_shape
        if rectangle_shape is not None:
            self._values["rectangle_shape"] = rectangle_shape
        if union_shape is not None:
            self._values["union_shape"] = union_shape

    @builtins.property
    def circle_shape(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestCircleShape"]]]:
        '''circle_shape block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#circle_shape DataAkamaiImagingPolicyImage#circle_shape}
        '''
        result = self._values.get("circle_shape")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestCircleShape"]]], result)

    @builtins.property
    def point_shape(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestPointShape"]]]:
        '''point_shape block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#point_shape DataAkamaiImagingPolicyImage#point_shape}
        '''
        result = self._values.get("point_shape")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestPointShape"]]], result)

    @builtins.property
    def polygon_shape(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestPolygonShape"]]]:
        '''polygon_shape block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#polygon_shape DataAkamaiImagingPolicyImage#polygon_shape}
        '''
        result = self._values.get("polygon_shape")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestPolygonShape"]]], result)

    @builtins.property
    def rectangle_shape(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestRectangleShape"]]]:
        '''rectangle_shape block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rectangle_shape DataAkamaiImagingPolicyImage#rectangle_shape}
        '''
        result = self._values.get("rectangle_shape")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestRectangleShape"]]], result)

    @builtins.property
    def union_shape(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestUnionShape"]]]:
        '''union_shape block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#union_shape DataAkamaiImagingPolicyImage#union_shape}
        '''
        result = self._values.get("union_shape")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestUnionShape"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterest(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestCircleShape",
    jsii_struct_bases=[],
    name_mapping={"center": "center", "radius": "radius", "radius_var": "radiusVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestCircleShape:
    def __init__(
        self,
        *,
        center: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestCircleShapeCenter", typing.Dict[builtins.str, typing.Any]],
        radius: typing.Optional[builtins.str] = None,
        radius_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param center: center block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#center DataAkamaiImagingPolicyImage#center}
        :param radius: The radius of the circle measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#radius DataAkamaiImagingPolicyImage#radius}
        :param radius_var: The radius of the circle measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#radius_var DataAkamaiImagingPolicyImage#radius_var}
        '''
        if isinstance(center, dict):
            center = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestCircleShapeCenter(**center)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2e0a8e569e3627b941e02e56377d51af500cc600ff903a523cdbcb764ee8fb8a)
            check_type(argname="argument center", value=center, expected_type=type_hints["center"])
            check_type(argname="argument radius", value=radius, expected_type=type_hints["radius"])
            check_type(argname="argument radius_var", value=radius_var, expected_type=type_hints["radius_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "center": center,
        }
        if radius is not None:
            self._values["radius"] = radius
        if radius_var is not None:
            self._values["radius_var"] = radius_var

    @builtins.property
    def center(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestCircleShapeCenter":
        '''center block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#center DataAkamaiImagingPolicyImage#center}
        '''
        result = self._values.get("center")
        assert result is not None, "Required property 'center' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestCircleShapeCenter", result)

    @builtins.property
    def radius(self) -> typing.Optional[builtins.str]:
        '''The radius of the circle measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#radius DataAkamaiImagingPolicyImage#radius}
        '''
        result = self._values.get("radius")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def radius_var(self) -> typing.Optional[builtins.str]:
        '''The radius of the circle measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#radius_var DataAkamaiImagingPolicyImage#radius_var}
        '''
        result = self._values.get("radius_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestCircleShape(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestCircleShapeCenter",
    jsii_struct_bases=[],
    name_mapping={"x": "x", "x_var": "xVar", "y": "y", "y_var": "yVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestCircleShapeCenter:
    def __init__(
        self,
        *,
        x: typing.Optional[builtins.str] = None,
        x_var: typing.Optional[builtins.str] = None,
        y: typing.Optional[builtins.str] = None,
        y_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param x: The horizontal position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x DataAkamaiImagingPolicyImage#x}
        :param x_var: The horizontal position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_var DataAkamaiImagingPolicyImage#x_var}
        :param y: The vertical position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y DataAkamaiImagingPolicyImage#y}
        :param y_var: The vertical position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_var DataAkamaiImagingPolicyImage#y_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c4a73362cdc0a7b1b171a3eb81d2d90907d4e34dda1b3deb1b0dd444deda19d3)
            check_type(argname="argument x", value=x, expected_type=type_hints["x"])
            check_type(argname="argument x_var", value=x_var, expected_type=type_hints["x_var"])
            check_type(argname="argument y", value=y, expected_type=type_hints["y"])
            check_type(argname="argument y_var", value=y_var, expected_type=type_hints["y_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if x is not None:
            self._values["x"] = x
        if x_var is not None:
            self._values["x_var"] = x_var
        if y is not None:
            self._values["y"] = y
        if y_var is not None:
            self._values["y_var"] = y_var

    @builtins.property
    def x(self) -> typing.Optional[builtins.str]:
        '''The horizontal position of the point, measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x DataAkamaiImagingPolicyImage#x}
        '''
        result = self._values.get("x")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_var(self) -> typing.Optional[builtins.str]:
        '''The horizontal position of the point, measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_var DataAkamaiImagingPolicyImage#x_var}
        '''
        result = self._values.get("x_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y(self) -> typing.Optional[builtins.str]:
        '''The vertical position of the point, measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y DataAkamaiImagingPolicyImage#y}
        '''
        result = self._values.get("y")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_var(self) -> typing.Optional[builtins.str]:
        '''The vertical position of the point, measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_var DataAkamaiImagingPolicyImage#y_var}
        '''
        result = self._values.get("y_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestCircleShapeCenter(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestCircleShapeCenterOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestCircleShapeCenterOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9c172bcd0464df7e63a5d65af3c96e91aedec43f29578b0178a9a57ca9dc2e5c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetX")
    def reset_x(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetX", []))

    @jsii.member(jsii_name="resetXVar")
    def reset_x_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXVar", []))

    @jsii.member(jsii_name="resetY")
    def reset_y(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetY", []))

    @jsii.member(jsii_name="resetYVar")
    def reset_y_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYVar", []))

    @builtins.property
    @jsii.member(jsii_name="xInput")
    def x_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xInput"))

    @builtins.property
    @jsii.member(jsii_name="xVarInput")
    def x_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yInput")
    def y_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yInput"))

    @builtins.property
    @jsii.member(jsii_name="yVarInput")
    def y_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yVarInput"))

    @builtins.property
    @jsii.member(jsii_name="x")
    def x(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "x"))

    @x.setter
    def x(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e3bd190dca71191ee7695021fdbbe80b2b18b845643622dd494ab70afffa936a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "x", value)

    @builtins.property
    @jsii.member(jsii_name="xVar")
    def x_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xVar"))

    @x_var.setter
    def x_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8540bad479051671188fa779394c0c6ea6907df72ca97b9cb0fca4982ea9025e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xVar", value)

    @builtins.property
    @jsii.member(jsii_name="y")
    def y(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "y"))

    @y.setter
    def y(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__035725a2927aafc07cec1c4002ff4f7ab0296c9f7d4d3bf3d2f9a47e3ae5cf68)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "y", value)

    @builtins.property
    @jsii.member(jsii_name="yVar")
    def y_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yVar"))

    @y_var.setter
    def y_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aae8875bedf608d52fb387a08f67e203c37d37022107b7d15ccd05387f3099c0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestCircleShapeCenter]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestCircleShapeCenter], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestCircleShapeCenter],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d2cb7d72243da32aaa10a2111cc4f79d65a57f30158daa0e3ce8c1fea7589b3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestCircleShapeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestCircleShapeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__26223902411d0ce37fd0c595f56b8155eb6245116052a998703457462932b005)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestCircleShapeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8f07c1e7f9af8ffbe8b3d2891533f80c0e3e3aa0d5b99c31c0344fc6b72b24fb)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestCircleShapeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__866223590a09c92065e29258cfa0ecb70503a72c7b883c37525fb6ba991c7bdd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__31c94ddae00852a87701f54532db4f7d00c5d51186475746667313f502f2d8d8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__245589f4b4eafbd3575982a19d8d556f3d3fc9c0adf6d9ee3275a73fae090e9c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestCircleShape]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestCircleShape]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestCircleShape]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ac71bb932b3588fc540aeac622ae4f264e928f774362c980e8f1ffb80a20444)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestCircleShapeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestCircleShapeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9f29bde6e22963011d4904bc417d879916c7e9590c11303cc87dc50bcf6bfdfc)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putCenter")
    def put_center(
        self,
        *,
        x: typing.Optional[builtins.str] = None,
        x_var: typing.Optional[builtins.str] = None,
        y: typing.Optional[builtins.str] = None,
        y_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param x: The horizontal position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x DataAkamaiImagingPolicyImage#x}
        :param x_var: The horizontal position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_var DataAkamaiImagingPolicyImage#x_var}
        :param y: The vertical position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y DataAkamaiImagingPolicyImage#y}
        :param y_var: The vertical position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_var DataAkamaiImagingPolicyImage#y_var}
        '''
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestCircleShapeCenter(
            x=x, x_var=x_var, y=y, y_var=y_var
        )

        return typing.cast(None, jsii.invoke(self, "putCenter", [value]))

    @jsii.member(jsii_name="resetRadius")
    def reset_radius(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRadius", []))

    @jsii.member(jsii_name="resetRadiusVar")
    def reset_radius_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRadiusVar", []))

    @builtins.property
    @jsii.member(jsii_name="center")
    def center(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestCircleShapeCenterOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestCircleShapeCenterOutputReference, jsii.get(self, "center"))

    @builtins.property
    @jsii.member(jsii_name="centerInput")
    def center_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestCircleShapeCenter]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestCircleShapeCenter], jsii.get(self, "centerInput"))

    @builtins.property
    @jsii.member(jsii_name="radiusInput")
    def radius_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "radiusInput"))

    @builtins.property
    @jsii.member(jsii_name="radiusVarInput")
    def radius_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "radiusVarInput"))

    @builtins.property
    @jsii.member(jsii_name="radius")
    def radius(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "radius"))

    @radius.setter
    def radius(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4c5f14c8f06ee450247ab7cd05f3a6f836566b2c4ed59f5147adfd0f10c7c673)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "radius", value)

    @builtins.property
    @jsii.member(jsii_name="radiusVar")
    def radius_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "radiusVar"))

    @radius_var.setter
    def radius_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__32c46bcc3704f7478c988f53c4bb93cf8a01e9b58cfc53f0ee6097e252a4568c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "radiusVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestCircleShape]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestCircleShape]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestCircleShape]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e2f856f92608042d5257589a7ba7e5b7fd2babdb432bac52adb6c6cdd54a5383)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__efdb5f3ee62a65c8c782806694a92d912257378898f312fa13e39b5f4f9174f6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putCircleShape")
    def put_circle_shape(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestCircleShape, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ba2b37ade5cf312e0d81c9f31407108622f42e7d4a9932b04a2eca68caec961)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCircleShape", [value]))

    @jsii.member(jsii_name="putPointShape")
    def put_point_shape(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestPointShape", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e6dc726e407384bb8a98d2e6c467329fed44f06176a3ffea6485433763a2c14a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putPointShape", [value]))

    @jsii.member(jsii_name="putPolygonShape")
    def put_polygon_shape(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestPolygonShape", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8eba1508ec60c6e6f798b100fecf6c877c5e44a5d4d79e147512282d277a10a8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putPolygonShape", [value]))

    @jsii.member(jsii_name="putRectangleShape")
    def put_rectangle_shape(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestRectangleShape", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__81196781a9c07e46a3c14869047e3e3f34dc5bc80d8d4c37a19579320df9608a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRectangleShape", [value]))

    @jsii.member(jsii_name="putUnionShape")
    def put_union_shape(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestUnionShape", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c3da170d22400e9d87459e18ca6e7746dd302527a227fd193227bf32b03cb72b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putUnionShape", [value]))

    @jsii.member(jsii_name="resetCircleShape")
    def reset_circle_shape(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCircleShape", []))

    @jsii.member(jsii_name="resetPointShape")
    def reset_point_shape(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPointShape", []))

    @jsii.member(jsii_name="resetPolygonShape")
    def reset_polygon_shape(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPolygonShape", []))

    @jsii.member(jsii_name="resetRectangleShape")
    def reset_rectangle_shape(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRectangleShape", []))

    @jsii.member(jsii_name="resetUnionShape")
    def reset_union_shape(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUnionShape", []))

    @builtins.property
    @jsii.member(jsii_name="circleShape")
    def circle_shape(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestCircleShapeList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestCircleShapeList, jsii.get(self, "circleShape"))

    @builtins.property
    @jsii.member(jsii_name="pointShape")
    def point_shape(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestPointShapeList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestPointShapeList", jsii.get(self, "pointShape"))

    @builtins.property
    @jsii.member(jsii_name="polygonShape")
    def polygon_shape(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestPolygonShapeList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestPolygonShapeList", jsii.get(self, "polygonShape"))

    @builtins.property
    @jsii.member(jsii_name="rectangleShape")
    def rectangle_shape(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestRectangleShapeList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestRectangleShapeList", jsii.get(self, "rectangleShape"))

    @builtins.property
    @jsii.member(jsii_name="unionShape")
    def union_shape(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestUnionShapeList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestUnionShapeList", jsii.get(self, "unionShape"))

    @builtins.property
    @jsii.member(jsii_name="circleShapeInput")
    def circle_shape_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestCircleShape]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestCircleShape]]], jsii.get(self, "circleShapeInput"))

    @builtins.property
    @jsii.member(jsii_name="pointShapeInput")
    def point_shape_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestPointShape"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestPointShape"]]], jsii.get(self, "pointShapeInput"))

    @builtins.property
    @jsii.member(jsii_name="polygonShapeInput")
    def polygon_shape_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestPolygonShape"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestPolygonShape"]]], jsii.get(self, "polygonShapeInput"))

    @builtins.property
    @jsii.member(jsii_name="rectangleShapeInput")
    def rectangle_shape_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestRectangleShape"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestRectangleShape"]]], jsii.get(self, "rectangleShapeInput"))

    @builtins.property
    @jsii.member(jsii_name="unionShapeInput")
    def union_shape_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestUnionShape"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestUnionShape"]]], jsii.get(self, "unionShapeInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterest]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterest], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterest],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c420884fe945f3336840d13f775c80addeb6b72c7d7578fa41c51232bac1724a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestPointShape",
    jsii_struct_bases=[],
    name_mapping={"x": "x", "x_var": "xVar", "y": "y", "y_var": "yVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestPointShape:
    def __init__(
        self,
        *,
        x: typing.Optional[builtins.str] = None,
        x_var: typing.Optional[builtins.str] = None,
        y: typing.Optional[builtins.str] = None,
        y_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param x: The horizontal position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x DataAkamaiImagingPolicyImage#x}
        :param x_var: The horizontal position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_var DataAkamaiImagingPolicyImage#x_var}
        :param y: The vertical position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y DataAkamaiImagingPolicyImage#y}
        :param y_var: The vertical position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_var DataAkamaiImagingPolicyImage#y_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0d80988a0d37899a010830f5b7289a57993ad7c28f1c1ab47d310c1ce5deb27e)
            check_type(argname="argument x", value=x, expected_type=type_hints["x"])
            check_type(argname="argument x_var", value=x_var, expected_type=type_hints["x_var"])
            check_type(argname="argument y", value=y, expected_type=type_hints["y"])
            check_type(argname="argument y_var", value=y_var, expected_type=type_hints["y_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if x is not None:
            self._values["x"] = x
        if x_var is not None:
            self._values["x_var"] = x_var
        if y is not None:
            self._values["y"] = y
        if y_var is not None:
            self._values["y_var"] = y_var

    @builtins.property
    def x(self) -> typing.Optional[builtins.str]:
        '''The horizontal position of the point, measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x DataAkamaiImagingPolicyImage#x}
        '''
        result = self._values.get("x")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_var(self) -> typing.Optional[builtins.str]:
        '''The horizontal position of the point, measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_var DataAkamaiImagingPolicyImage#x_var}
        '''
        result = self._values.get("x_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y(self) -> typing.Optional[builtins.str]:
        '''The vertical position of the point, measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y DataAkamaiImagingPolicyImage#y}
        '''
        result = self._values.get("y")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_var(self) -> typing.Optional[builtins.str]:
        '''The vertical position of the point, measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_var DataAkamaiImagingPolicyImage#y_var}
        '''
        result = self._values.get("y_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestPointShape(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestPointShapeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestPointShapeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0f974277963d849d8ae337582ff6282f78345ce02b8fa56e4a416d5ba7116768)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestPointShapeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ee05a9aac6f9a8c5e7ba7ebc4c0dcad009cb032f3f9dc15041f68a81c4863392)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestPointShapeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6958159ef04a54d4f05aebbc0e555b4e23fa37ca5a18867d009000f2cf8879a8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7148ea30727cebd9aefd55e398f7be392036ede268b6c79523e69bfe0fc058a7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5e2753d12365818cf6fe43aca0957d3fe96b9d1e7dd7d24ee43ec69035dfafdd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestPointShape]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestPointShape]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestPointShape]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3af3f9661d35874f8f99f889bd0f0bb417dbfa770bf2ebc2fcb19c606846e221)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestPointShapeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestPointShapeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__25839a335a90a7a94e14a7eaff8db6196499f0babc45839580f672bf089cd587)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetX")
    def reset_x(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetX", []))

    @jsii.member(jsii_name="resetXVar")
    def reset_x_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXVar", []))

    @jsii.member(jsii_name="resetY")
    def reset_y(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetY", []))

    @jsii.member(jsii_name="resetYVar")
    def reset_y_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYVar", []))

    @builtins.property
    @jsii.member(jsii_name="xInput")
    def x_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xInput"))

    @builtins.property
    @jsii.member(jsii_name="xVarInput")
    def x_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yInput")
    def y_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yInput"))

    @builtins.property
    @jsii.member(jsii_name="yVarInput")
    def y_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yVarInput"))

    @builtins.property
    @jsii.member(jsii_name="x")
    def x(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "x"))

    @x.setter
    def x(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__78a96d15c6c44cf226452523751ddeaca3281c36d816522beef543d38b59e6be)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "x", value)

    @builtins.property
    @jsii.member(jsii_name="xVar")
    def x_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xVar"))

    @x_var.setter
    def x_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3854ae6ac8267ff5e2b41253eda09237469e7e44dc846ec554219efbe532c700)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xVar", value)

    @builtins.property
    @jsii.member(jsii_name="y")
    def y(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "y"))

    @y.setter
    def y(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__95d32b149db7b4d72150de7e0bb45f2cfd61baeeb779524af187050a0fbc9daf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "y", value)

    @builtins.property
    @jsii.member(jsii_name="yVar")
    def y_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yVar"))

    @y_var.setter
    def y_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5922fc027bd77dae69fb75dd8e517e5729b25967426cdd10c35dad1732df59fe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestPointShape]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestPointShape]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestPointShape]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b9acd49dd43fdb69e0d448dfa229d1356f6d81eac3fd0822669ee5f4eb672d09)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestPolygonShape",
    jsii_struct_bases=[],
    name_mapping={"points": "points"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestPolygonShape:
    def __init__(
        self,
        *,
        points: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestPolygonShapePoints", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param points: points block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#points DataAkamaiImagingPolicyImage#points}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ffff8cb238483d910458629b61658667a735670a6aff8229c3c2fd3be88668a)
            check_type(argname="argument points", value=points, expected_type=type_hints["points"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "points": points,
        }

    @builtins.property
    def points(
        self,
    ) -> typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestPolygonShapePoints"]]:
        '''points block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#points DataAkamaiImagingPolicyImage#points}
        '''
        result = self._values.get("points")
        assert result is not None, "Required property 'points' is missing"
        return typing.cast(typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestPolygonShapePoints"]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestPolygonShape(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestPolygonShapeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestPolygonShapeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0d51a66103a3aa01560e2e9814306bc5c8a761670cde9590feb53f3fc22c7740)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestPolygonShapeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a04e4e30141238ff71500949e1c026bb1007b49c01da0df3ca190930ba53870e)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestPolygonShapeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0975d1fab8426b67294c6612f605f4c5fa2e2c7fd1e6c2e366ddb93ed9e06baa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5e891cae81e404d233937eeaaf068a4a66e23a417b0b83aee0211d2105b850e8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c23efca4f57abde4f4a21b6720c5ea2a4d9f0fbe09177e7d24701a70e6a2fc9d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestPolygonShape]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestPolygonShape]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestPolygonShape]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__28284466869c989ac214548431ad8777eba43999e1c931ed46cf9b3246627227)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestPolygonShapeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestPolygonShapeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__62cb4b2f200a3b543828a061132eb86b6da9cc87d101df5332bc4ecb691a3a2b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putPoints")
    def put_points(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestPolygonShapePoints", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ed8b141414a009d87976e37c52f508445d8d869de4f4f3883bfb7cadbc995175)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putPoints", [value]))

    @builtins.property
    @jsii.member(jsii_name="points")
    def points(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestPolygonShapePointsList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestPolygonShapePointsList", jsii.get(self, "points"))

    @builtins.property
    @jsii.member(jsii_name="pointsInput")
    def points_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestPolygonShapePoints"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestPolygonShapePoints"]]], jsii.get(self, "pointsInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestPolygonShape]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestPolygonShape]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestPolygonShape]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__59ec31d9d0edcc426775c2d6264de4de8ce6a80c0f50080741051b86799f7c25)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestPolygonShapePoints",
    jsii_struct_bases=[],
    name_mapping={"x": "x", "x_var": "xVar", "y": "y", "y_var": "yVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestPolygonShapePoints:
    def __init__(
        self,
        *,
        x: typing.Optional[builtins.str] = None,
        x_var: typing.Optional[builtins.str] = None,
        y: typing.Optional[builtins.str] = None,
        y_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param x: The horizontal position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x DataAkamaiImagingPolicyImage#x}
        :param x_var: The horizontal position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_var DataAkamaiImagingPolicyImage#x_var}
        :param y: The vertical position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y DataAkamaiImagingPolicyImage#y}
        :param y_var: The vertical position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_var DataAkamaiImagingPolicyImage#y_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9406c2570e043f510f369a7d74fad9ba695b9f6bf47570f53bc327c87ee9755e)
            check_type(argname="argument x", value=x, expected_type=type_hints["x"])
            check_type(argname="argument x_var", value=x_var, expected_type=type_hints["x_var"])
            check_type(argname="argument y", value=y, expected_type=type_hints["y"])
            check_type(argname="argument y_var", value=y_var, expected_type=type_hints["y_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if x is not None:
            self._values["x"] = x
        if x_var is not None:
            self._values["x_var"] = x_var
        if y is not None:
            self._values["y"] = y
        if y_var is not None:
            self._values["y_var"] = y_var

    @builtins.property
    def x(self) -> typing.Optional[builtins.str]:
        '''The horizontal position of the point, measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x DataAkamaiImagingPolicyImage#x}
        '''
        result = self._values.get("x")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_var(self) -> typing.Optional[builtins.str]:
        '''The horizontal position of the point, measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_var DataAkamaiImagingPolicyImage#x_var}
        '''
        result = self._values.get("x_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y(self) -> typing.Optional[builtins.str]:
        '''The vertical position of the point, measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y DataAkamaiImagingPolicyImage#y}
        '''
        result = self._values.get("y")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_var(self) -> typing.Optional[builtins.str]:
        '''The vertical position of the point, measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_var DataAkamaiImagingPolicyImage#y_var}
        '''
        result = self._values.get("y_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestPolygonShapePoints(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestPolygonShapePointsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestPolygonShapePointsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__32fc9e4f3666bec7896303e8b09479d759c1feab5099aba1c1c42cdc24e51ccd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestPolygonShapePointsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__49b1c7e4f308a2082bd818b7c99877b315c800381a7abf450b9411dc75b05af4)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestPolygonShapePointsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f6afb470df62c81d98b80e1c79e329c0e776ffb8affa845cef30719a88e3c1fd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__49c2847d356505718ef724fbf8cc320af0a459de18f54052b8da7806864f71d6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cee387d7b4d84f315305c7a11b52c3a1c670a1428e165a3f28bc9f4e1c8fef55)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestPolygonShapePoints]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestPolygonShapePoints]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestPolygonShapePoints]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__075dff8340ba78a077fd24501830cef44da61b76b4836f564d46a387f486e4c9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestPolygonShapePointsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestPolygonShapePointsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4b97c67ed8e95fc4835f42c365900e6ad5805ef6badc291ffcad8e4062468a95)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetX")
    def reset_x(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetX", []))

    @jsii.member(jsii_name="resetXVar")
    def reset_x_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXVar", []))

    @jsii.member(jsii_name="resetY")
    def reset_y(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetY", []))

    @jsii.member(jsii_name="resetYVar")
    def reset_y_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYVar", []))

    @builtins.property
    @jsii.member(jsii_name="xInput")
    def x_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xInput"))

    @builtins.property
    @jsii.member(jsii_name="xVarInput")
    def x_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yInput")
    def y_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yInput"))

    @builtins.property
    @jsii.member(jsii_name="yVarInput")
    def y_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yVarInput"))

    @builtins.property
    @jsii.member(jsii_name="x")
    def x(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "x"))

    @x.setter
    def x(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7a8654cb0a689b6b7211598da372665ece9e69dafeb5da41d140063c54a091e4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "x", value)

    @builtins.property
    @jsii.member(jsii_name="xVar")
    def x_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xVar"))

    @x_var.setter
    def x_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a7a0d621197a530c6d2eaf4b4ea8009cc43ffde7468ce748b4e3614e94215ef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xVar", value)

    @builtins.property
    @jsii.member(jsii_name="y")
    def y(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "y"))

    @y.setter
    def y(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7b49313180f3a0e14a5d0b68bdd618b742b2f3d986c375ebb6bbfc4e5d53bb57)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "y", value)

    @builtins.property
    @jsii.member(jsii_name="yVar")
    def y_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yVar"))

    @y_var.setter
    def y_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2227ce2351ea874033cf88693055dd20cdfd7e033cc8b07577f9bd099cd8e497)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestPolygonShapePoints]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestPolygonShapePoints]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestPolygonShapePoints]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a2ff9a972492b833388b019bd66fcc987951a51e794025759b0cf0ce94894d39)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestRectangleShape",
    jsii_struct_bases=[],
    name_mapping={
        "anchor": "anchor",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestRectangleShape:
    def __init__(
        self,
        *,
        anchor: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestRectangleShapeAnchor", typing.Dict[builtins.str, typing.Any]],
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param anchor: anchor block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#anchor DataAkamaiImagingPolicyImage#anchor}
        :param height: Extends the rectangle down from the ``anchor`` point. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: Extends the rectangle down from the ``anchor`` point. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: Extends the rectangle right from the ``anchor`` point. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: Extends the rectangle right from the ``anchor`` point. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(anchor, dict):
            anchor = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestRectangleShapeAnchor(**anchor)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7529667db2ebb068654100e70760b5090edd6118eb939839e12425382be87d14)
            check_type(argname="argument anchor", value=anchor, expected_type=type_hints["anchor"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "anchor": anchor,
        }
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def anchor(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestRectangleShapeAnchor":
        '''anchor block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#anchor DataAkamaiImagingPolicyImage#anchor}
        '''
        result = self._values.get("anchor")
        assert result is not None, "Required property 'anchor' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestRectangleShapeAnchor", result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''Extends the rectangle down from the ``anchor`` point.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''Extends the rectangle down from the ``anchor`` point.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''Extends the rectangle right from the ``anchor`` point.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''Extends the rectangle right from the ``anchor`` point.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestRectangleShape(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestRectangleShapeAnchor",
    jsii_struct_bases=[],
    name_mapping={"x": "x", "x_var": "xVar", "y": "y", "y_var": "yVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestRectangleShapeAnchor:
    def __init__(
        self,
        *,
        x: typing.Optional[builtins.str] = None,
        x_var: typing.Optional[builtins.str] = None,
        y: typing.Optional[builtins.str] = None,
        y_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param x: The horizontal position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x DataAkamaiImagingPolicyImage#x}
        :param x_var: The horizontal position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_var DataAkamaiImagingPolicyImage#x_var}
        :param y: The vertical position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y DataAkamaiImagingPolicyImage#y}
        :param y_var: The vertical position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_var DataAkamaiImagingPolicyImage#y_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f1bb95f7e3f79e00946725537770d03740a92fd70d6acb90bb39e65607fd138f)
            check_type(argname="argument x", value=x, expected_type=type_hints["x"])
            check_type(argname="argument x_var", value=x_var, expected_type=type_hints["x_var"])
            check_type(argname="argument y", value=y, expected_type=type_hints["y"])
            check_type(argname="argument y_var", value=y_var, expected_type=type_hints["y_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if x is not None:
            self._values["x"] = x
        if x_var is not None:
            self._values["x_var"] = x_var
        if y is not None:
            self._values["y"] = y
        if y_var is not None:
            self._values["y_var"] = y_var

    @builtins.property
    def x(self) -> typing.Optional[builtins.str]:
        '''The horizontal position of the point, measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x DataAkamaiImagingPolicyImage#x}
        '''
        result = self._values.get("x")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_var(self) -> typing.Optional[builtins.str]:
        '''The horizontal position of the point, measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_var DataAkamaiImagingPolicyImage#x_var}
        '''
        result = self._values.get("x_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y(self) -> typing.Optional[builtins.str]:
        '''The vertical position of the point, measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y DataAkamaiImagingPolicyImage#y}
        '''
        result = self._values.get("y")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_var(self) -> typing.Optional[builtins.str]:
        '''The vertical position of the point, measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_var DataAkamaiImagingPolicyImage#y_var}
        '''
        result = self._values.get("y_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestRectangleShapeAnchor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestRectangleShapeAnchorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestRectangleShapeAnchorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb36fe1e4207e728fcd7f1f8f3ddc2adb26e96628d321b6544d9ac9d8e3bbc60)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetX")
    def reset_x(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetX", []))

    @jsii.member(jsii_name="resetXVar")
    def reset_x_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXVar", []))

    @jsii.member(jsii_name="resetY")
    def reset_y(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetY", []))

    @jsii.member(jsii_name="resetYVar")
    def reset_y_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYVar", []))

    @builtins.property
    @jsii.member(jsii_name="xInput")
    def x_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xInput"))

    @builtins.property
    @jsii.member(jsii_name="xVarInput")
    def x_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yInput")
    def y_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yInput"))

    @builtins.property
    @jsii.member(jsii_name="yVarInput")
    def y_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yVarInput"))

    @builtins.property
    @jsii.member(jsii_name="x")
    def x(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "x"))

    @x.setter
    def x(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f78213c5451a2a6cb9a238892288710c55354a1807db89b7540ff31bf4fcbbe0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "x", value)

    @builtins.property
    @jsii.member(jsii_name="xVar")
    def x_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xVar"))

    @x_var.setter
    def x_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b26d705e23af3d000f930a1436dc5d94ce09ce8781bcda22b25779cf16cb9782)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xVar", value)

    @builtins.property
    @jsii.member(jsii_name="y")
    def y(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "y"))

    @y.setter
    def y(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a072166128f79be0d72681f350c4ea67519c2c1cbb4b10182e9331463ea1d1f2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "y", value)

    @builtins.property
    @jsii.member(jsii_name="yVar")
    def y_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yVar"))

    @y_var.setter
    def y_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cfaad3b02090e13893cc8a5d37c69151d918ba2b0f49f041b3e5c2f44349f722)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestRectangleShapeAnchor]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestRectangleShapeAnchor], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestRectangleShapeAnchor],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f0680709731bcec7f0c838a18a73d4ae26a1c57779c51097c63f2136390c9145)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestRectangleShapeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestRectangleShapeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__63601013234668190394fb6089af8f58e9d9af81248141b30c87a44686661894)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestRectangleShapeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d11dcd3bc6ed2cbbe67f6edcd684e76060a8fcc5bc6791c08310900a772a4fb)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestRectangleShapeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ae547f8aa322befb8d1f9b76933797b94c9d57e5d005cc62bf8236748ff46c26)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1902cb0e57f1306d041e303394850bc9b614352ed210bba1e3ee35f8294e6f8a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__147a0001f6054ec9a77d3219c025eb0795ce2005c15a6ae45bcb1750a096cf4b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestRectangleShape]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestRectangleShape]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestRectangleShape]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d000f85257033afc68bbe3dd0cce135c2a961c21cac6506364a5e77d3f3587b0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestRectangleShapeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestRectangleShapeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e43133eea8ff3ace51ffb30383364902306221004ce19d477598dc7866dbd7b0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putAnchor")
    def put_anchor(
        self,
        *,
        x: typing.Optional[builtins.str] = None,
        x_var: typing.Optional[builtins.str] = None,
        y: typing.Optional[builtins.str] = None,
        y_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param x: The horizontal position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x DataAkamaiImagingPolicyImage#x}
        :param x_var: The horizontal position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_var DataAkamaiImagingPolicyImage#x_var}
        :param y: The vertical position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y DataAkamaiImagingPolicyImage#y}
        :param y_var: The vertical position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_var DataAkamaiImagingPolicyImage#y_var}
        '''
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestRectangleShapeAnchor(
            x=x, x_var=x_var, y=y, y_var=y_var
        )

        return typing.cast(None, jsii.invoke(self, "putAnchor", [value]))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="anchor")
    def anchor(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestRectangleShapeAnchorOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestRectangleShapeAnchorOutputReference, jsii.get(self, "anchor"))

    @builtins.property
    @jsii.member(jsii_name="anchorInput")
    def anchor_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestRectangleShapeAnchor]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestRectangleShapeAnchor], jsii.get(self, "anchorInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7aad7f89764f004cc777108c57a36dda8963ed1eaa770084d791601e78b2e258)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac0fc95945f4ef722d407284856c628ca14d148d9d311bb8b5f7d5ebd7af48da)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__186ca368809ce755d7ab427926f7c0604bd6698fa7004bfa80f8a4dec973bd3b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bf3b5a5dd53bb2e2725ded1c0e54a641fef9cca4485d32fb68d94e91e0c28145)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestRectangleShape]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestRectangleShape]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestRectangleShape]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9b2c53c4a5adb51788b238646fab9c0e78ec2db3e27734bdd52771a36230af13)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestUnionShape",
    jsii_struct_bases=[],
    name_mapping={"shapes": "shapes"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestUnionShape:
    def __init__(
        self,
        *,
        shapes: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestUnionShapeShapes", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param shapes: shapes block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shapes DataAkamaiImagingPolicyImage#shapes}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6bad1d9ea5e944df55f5f957ae687e18a95c03592e87cdef701b06364cc9467b)
            check_type(argname="argument shapes", value=shapes, expected_type=type_hints["shapes"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "shapes": shapes,
        }

    @builtins.property
    def shapes(
        self,
    ) -> typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestUnionShapeShapes"]]:
        '''shapes block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shapes DataAkamaiImagingPolicyImage#shapes}
        '''
        result = self._values.get("shapes")
        assert result is not None, "Required property 'shapes' is missing"
        return typing.cast(typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestUnionShapeShapes"]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestUnionShape(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestUnionShapeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestUnionShapeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1c9bc0c0990472c4ec983c52fa8cb5114768b8e77e8f73ba4f2e2899aed4ef2c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestUnionShapeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cccf5ed529303ade36513db3296b74b1de3887d3432c9e04f9d85076926dcfd1)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestUnionShapeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8c4b1d3fe5ff51a47e63a506642375d01f8547c7bf98f9ced3f3f9c9104f6974)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__48871d9702b1edb69b38a91d16a14e1c2c37a0889d87e22be3fe6be1a2b700ef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c90245e4c5b1895110083e8b1d8efeb8d9cce5e906e195c4dd2e3dc3e6b50187)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestUnionShape]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestUnionShape]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestUnionShape]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__649db662bcd8c00d516c56f550828c5efee1f78f0b9a5096f551b327cf4a2401)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestUnionShapeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestUnionShapeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__07b5c7c7f1165f5393f1bfc83be2fc3e547beff68c5c68b6627225256c81fc70)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putShapes")
    def put_shapes(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestUnionShapeShapes", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4dd4a8df30625979de407ff5b53ab4ca79c7a9d5c637e0ca6e58323759441527)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putShapes", [value]))

    @builtins.property
    @jsii.member(jsii_name="shapes")
    def shapes(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestUnionShapeShapesList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestUnionShapeShapesList", jsii.get(self, "shapes"))

    @builtins.property
    @jsii.member(jsii_name="shapesInput")
    def shapes_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestUnionShapeShapes"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestUnionShapeShapes"]]], jsii.get(self, "shapesInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestUnionShape]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestUnionShape]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestUnionShape]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__23d3b94576e41260c60849410eae792e24cd805e9fb5ec7a8431179fad1f2d99)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestUnionShapeShapes",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestUnionShapeShapes:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestUnionShapeShapes(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestUnionShapeShapesList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestUnionShapeShapesList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e707002de48e9f60ec1c8150a5e845033f1542749077026e783df938a1c21ce7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestUnionShapeShapesOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df86758307b126d7fa553fc24d545c89e14ac56ab9dbf83c87e2e02693c2761a)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestUnionShapeShapesOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5dd29a7310bfef469a4f5d47fb4d911b71d6edd46763be5c842190cd3b52ea9d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9f251c655e8981ced0c3c9ba6f2fe3194d8a0ab8c7dc0b705b90e4312d268ba7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b3ba26ef612ac2503a8eaba3003e2c5aab1a3851815a2e31b4776a9acd8b865d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestUnionShapeShapes]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestUnionShapeShapes]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestUnionShapeShapes]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__436cc19da8e2711e2b10780d3e5718fa36e224616ca67c9de22b9c956f984339)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestUnionShapeShapesOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestUnionShapeShapesOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be29ba4736d2a67505d5823dde531e686d225f19fd16b62559633e563243bcbf)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestUnionShapeShapes]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestUnionShapeShapes]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestUnionShapeShapes]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9757578a8f790836898c6e1124e2c18f25913529046935e6d7d836d18d9a9acb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRelativeCrop",
    jsii_struct_bases=[],
    name_mapping={
        "east": "east",
        "east_var": "eastVar",
        "north": "north",
        "north_var": "northVar",
        "south": "south",
        "south_var": "southVar",
        "west": "west",
        "west_var": "westVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRelativeCrop:
    def __init__(
        self,
        *,
        east: typing.Optional[builtins.str] = None,
        east_var: typing.Optional[builtins.str] = None,
        north: typing.Optional[builtins.str] = None,
        north_var: typing.Optional[builtins.str] = None,
        south: typing.Optional[builtins.str] = None,
        south_var: typing.Optional[builtins.str] = None,
        west: typing.Optional[builtins.str] = None,
        west_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param east: The number of pixels to shrink or expand the right side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east DataAkamaiImagingPolicyImage#east}
        :param east_var: The number of pixels to shrink or expand the right side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east_var DataAkamaiImagingPolicyImage#east_var}
        :param north: The number of pixels to shrink or expand the top side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north DataAkamaiImagingPolicyImage#north}
        :param north_var: The number of pixels to shrink or expand the top side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north_var DataAkamaiImagingPolicyImage#north_var}
        :param south: The number of pixels to shrink or expand the bottom side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south DataAkamaiImagingPolicyImage#south}
        :param south_var: The number of pixels to shrink or expand the bottom side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south_var DataAkamaiImagingPolicyImage#south_var}
        :param west: The number of pixels to shrink or expand the left side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west DataAkamaiImagingPolicyImage#west}
        :param west_var: The number of pixels to shrink or expand the left side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west_var DataAkamaiImagingPolicyImage#west_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__610c08221f06dfb6c26fc4f222bf996dffbfaf723f7b669249ef093f4b64a8bf)
            check_type(argname="argument east", value=east, expected_type=type_hints["east"])
            check_type(argname="argument east_var", value=east_var, expected_type=type_hints["east_var"])
            check_type(argname="argument north", value=north, expected_type=type_hints["north"])
            check_type(argname="argument north_var", value=north_var, expected_type=type_hints["north_var"])
            check_type(argname="argument south", value=south, expected_type=type_hints["south"])
            check_type(argname="argument south_var", value=south_var, expected_type=type_hints["south_var"])
            check_type(argname="argument west", value=west, expected_type=type_hints["west"])
            check_type(argname="argument west_var", value=west_var, expected_type=type_hints["west_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if east is not None:
            self._values["east"] = east
        if east_var is not None:
            self._values["east_var"] = east_var
        if north is not None:
            self._values["north"] = north
        if north_var is not None:
            self._values["north_var"] = north_var
        if south is not None:
            self._values["south"] = south
        if south_var is not None:
            self._values["south_var"] = south_var
        if west is not None:
            self._values["west"] = west
        if west_var is not None:
            self._values["west_var"] = west_var

    @builtins.property
    def east(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the right side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east DataAkamaiImagingPolicyImage#east}
        '''
        result = self._values.get("east")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def east_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the right side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east_var DataAkamaiImagingPolicyImage#east_var}
        '''
        result = self._values.get("east_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def north(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the top side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north DataAkamaiImagingPolicyImage#north}
        '''
        result = self._values.get("north")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def north_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the top side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north_var DataAkamaiImagingPolicyImage#north_var}
        '''
        result = self._values.get("north_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def south(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the bottom side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south DataAkamaiImagingPolicyImage#south}
        '''
        result = self._values.get("south")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def south_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the bottom side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south_var DataAkamaiImagingPolicyImage#south_var}
        '''
        result = self._values.get("south_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def west(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the left side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west DataAkamaiImagingPolicyImage#west}
        '''
        result = self._values.get("west")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def west_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the left side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west_var DataAkamaiImagingPolicyImage#west_var}
        '''
        result = self._values.get("west_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRelativeCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRelativeCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRelativeCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f075c0136bbbcb043b4d51a0da46a0e4f2736256f43595065d7997998ed5279e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRelativeCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8cb7f56609d563e93f0c24b0bbaa9a9cd0263f37b8f22fac8d05cda9c168a774)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRelativeCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1ff34f6e9adeed40073079a95fa47b29bc4dd6aeef0621a7d61d02ba2c9d2fb9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__093900ac736a2ebb9c7f1bd7e0cdd7ceedeb5ad3e59a5af4bd903c994599a26c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__53320318e8be6e74be0004dfec8affca9724ef68662cb8d8f51a2893c39d8c38)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRelativeCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRelativeCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRelativeCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c7408baf4baa939385a4e82d64ee5febfe95012216b504af267a443c1b2c30e9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRelativeCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRelativeCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__13ab2ea1b8e5c88323b803db592374e092caecd3305e85072811e4063c5a71e5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetEast")
    def reset_east(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEast", []))

    @jsii.member(jsii_name="resetEastVar")
    def reset_east_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEastVar", []))

    @jsii.member(jsii_name="resetNorth")
    def reset_north(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNorth", []))

    @jsii.member(jsii_name="resetNorthVar")
    def reset_north_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNorthVar", []))

    @jsii.member(jsii_name="resetSouth")
    def reset_south(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSouth", []))

    @jsii.member(jsii_name="resetSouthVar")
    def reset_south_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSouthVar", []))

    @jsii.member(jsii_name="resetWest")
    def reset_west(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWest", []))

    @jsii.member(jsii_name="resetWestVar")
    def reset_west_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWestVar", []))

    @builtins.property
    @jsii.member(jsii_name="eastInput")
    def east_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "eastInput"))

    @builtins.property
    @jsii.member(jsii_name="eastVarInput")
    def east_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "eastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="northInput")
    def north_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "northInput"))

    @builtins.property
    @jsii.member(jsii_name="northVarInput")
    def north_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "northVarInput"))

    @builtins.property
    @jsii.member(jsii_name="southInput")
    def south_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "southInput"))

    @builtins.property
    @jsii.member(jsii_name="southVarInput")
    def south_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "southVarInput"))

    @builtins.property
    @jsii.member(jsii_name="westInput")
    def west_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "westInput"))

    @builtins.property
    @jsii.member(jsii_name="westVarInput")
    def west_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "westVarInput"))

    @builtins.property
    @jsii.member(jsii_name="east")
    def east(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "east"))

    @east.setter
    def east(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c926b9630f9a16bb1624c27c367b380f378b36d1df0c10236da5a8f44b81f14b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "east", value)

    @builtins.property
    @jsii.member(jsii_name="eastVar")
    def east_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "eastVar"))

    @east_var.setter
    def east_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e915c233e7ca1ac997b743eb4c3033a7f649fad7e7093b255bc843e6e987b936)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "eastVar", value)

    @builtins.property
    @jsii.member(jsii_name="north")
    def north(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "north"))

    @north.setter
    def north(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__24311384752c31ef36ad5676a65880f4afd496013c8ae8b5c8470ac1d1d7d32c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "north", value)

    @builtins.property
    @jsii.member(jsii_name="northVar")
    def north_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "northVar"))

    @north_var.setter
    def north_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6a96a9061447f6ed7510efd5fb070f573154c67eae0c2274034a1939a033f8bf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "northVar", value)

    @builtins.property
    @jsii.member(jsii_name="south")
    def south(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "south"))

    @south.setter
    def south(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7e3ced16be2141edc66558329f18913c6f9ee585914134506a209abfba0fbc6d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "south", value)

    @builtins.property
    @jsii.member(jsii_name="southVar")
    def south_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "southVar"))

    @south_var.setter
    def south_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c1e8f73aa1ee982e01dbff05d54b8b5121ad354eaccc4d71899c2f5585e0e3e2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "southVar", value)

    @builtins.property
    @jsii.member(jsii_name="west")
    def west(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "west"))

    @west.setter
    def west(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__708be54ca477c0b2f3c7cd7a049ee9ddd02196f3aec884d0f5a3bbe24b8fd4f3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "west", value)

    @builtins.property
    @jsii.member(jsii_name="westVar")
    def west_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "westVar"))

    @west_var.setter
    def west_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__60fb81c55eae691f94c69fe25f60b8a448bea0f1ba7e91196fa563042312a313)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "westVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRelativeCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRelativeCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRelativeCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b9486c797448d355f24e9ff74aac5ab0c8442c6fda404ca7dcb054142317735b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRemoveColor",
    jsii_struct_bases=[],
    name_mapping={
        "color": "color",
        "color_var": "colorVar",
        "feather": "feather",
        "feather_var": "featherVar",
        "tolerance": "tolerance",
        "tolerance_var": "toleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRemoveColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
        feather: typing.Optional[builtins.str] = None,
        feather_var: typing.Optional[builtins.str] = None,
        tolerance: typing.Optional[builtins.str] = None,
        tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        :param feather: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        :param feather_var: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        :param tolerance: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        :param tolerance_var: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__036973d0d18ab6d8b6f33bb3bd3730fbe5a64911786d0623b305556279f55126)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
            check_type(argname="argument feather", value=feather, expected_type=type_hints["feather"])
            check_type(argname="argument feather_var", value=feather_var, expected_type=type_hints["feather_var"])
            check_type(argname="argument tolerance", value=tolerance, expected_type=type_hints["tolerance"])
            check_type(argname="argument tolerance_var", value=tolerance_var, expected_type=type_hints["tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var
        if feather is not None:
            self._values["feather"] = feather
        if feather_var is not None:
            self._values["feather_var"] = feather_var
        if tolerance is not None:
            self._values["tolerance"] = tolerance
        if tolerance_var is not None:
            self._values["tolerance_var"] = tolerance_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        '''
        result = self._values.get("feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather_var(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        '''
        result = self._values.get("feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        '''
        result = self._values.get("tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance_var(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        result = self._values.get("tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRemoveColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRemoveColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRemoveColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4d4d16cc8154fcf2245b277505d40d967c0689920f8ee1524eac5b371e1fb8cc)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRemoveColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2dac4fc36128355c687d100b11384a4c6e35cfe0846a149b8063a40b9cfc670f)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRemoveColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e5c60b52289e941ba2c6bdd775c6713f4ca5d1335276df9588135667dd000094)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__27c4989fee5a3f6dbdbb3462e93b2a67ca0c78bc6a253eab530b40e53e4c618f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c16f50fbfabe439bae5b65e2e2a0197bd66e3bdcc19faf2801427cc65f8a7b54)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRemoveColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRemoveColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRemoveColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__85e7679694031e0fa6581319e3ea4e8431b11327098f4903f904990a7d9e621f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRemoveColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRemoveColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4bd8a933c6f2d86c69ba40c4b4442f5e6401741a76cffc137ec3ff531c172173)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @jsii.member(jsii_name="resetFeather")
    def reset_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeather", []))

    @jsii.member(jsii_name="resetFeatherVar")
    def reset_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatherVar", []))

    @jsii.member(jsii_name="resetTolerance")
    def reset_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTolerance", []))

    @jsii.member(jsii_name="resetToleranceVar")
    def reset_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featherInput")
    def feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherInput"))

    @builtins.property
    @jsii.member(jsii_name="featherVarInput")
    def feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceInput")
    def tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceVarInput")
    def tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1fdb48d196d2e5faad0cce76efab87904980c038cf4ba4da6b6daccece80f7e1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0a044de10c54a9bb6f3c6f5451111821f98897b36a630364f370ea71ec94fac1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="feather")
    def feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "feather"))

    @feather.setter
    def feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1c60d9c281d5ac6001c3ce82bd46d998d1c013536f61d33f3a4fef704de0dbb5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "feather", value)

    @builtins.property
    @jsii.member(jsii_name="featherVar")
    def feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featherVar"))

    @feather_var.setter
    def feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cb13021dba21bde98271fa17b85af8fcd06fec65e9655e85b385e190a5754088)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featherVar", value)

    @builtins.property
    @jsii.member(jsii_name="tolerance")
    def tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tolerance"))

    @tolerance.setter
    def tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__29b925f9a0f18c4b10f701fe9f75dee05d9f5c422e8652616052fc7deb5a45be)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tolerance", value)

    @builtins.property
    @jsii.member(jsii_name="toleranceVar")
    def tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "toleranceVar"))

    @tolerance_var.setter
    def tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a85df2fa70b899ba0d54f91aa305280dc33fc571f2c70bb04e73769a0a10d45)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "toleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRemoveColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRemoveColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRemoveColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__62ef42a8314a4858abe48e2c5006ae10e4c0048b1bb6eb6b3717d998bcfecba8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualResize",
    jsii_struct_bases=[],
    name_mapping={
        "aspect": "aspect",
        "aspect_var": "aspectVar",
        "height": "height",
        "height_var": "heightVar",
        "type": "type",
        "type_var": "typeVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualResize:
    def __init__(
        self,
        *,
        aspect: typing.Optional[builtins.str] = None,
        aspect_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param aspect: Preserves the aspect ratio. Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect DataAkamaiImagingPolicyImage#aspect}
        :param aspect_var: Preserves the aspect ratio. Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_var DataAkamaiImagingPolicyImage#aspect_var}
        :param height: The height to resize the source image to. Must be set if height is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height to resize the source image to. Must be set if height is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param type: Sets constraints for the image resize. Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: Sets constraints for the image resize. Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        :param width: The width to resize the source image to. Must be set if width is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width to resize the source image to. Must be set if width is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5d7d7f1a3fb80aa5210ba1634dee1ad0d04775625aa9710434f059ea8ec74237)
            check_type(argname="argument aspect", value=aspect, expected_type=type_hints["aspect"])
            check_type(argname="argument aspect_var", value=aspect_var, expected_type=type_hints["aspect_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if aspect is not None:
            self._values["aspect"] = aspect
        if aspect_var is not None:
            self._values["aspect_var"] = aspect_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def aspect(self) -> typing.Optional[builtins.str]:
        '''Preserves the aspect ratio.

        Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect DataAkamaiImagingPolicyImage#aspect}
        '''
        result = self._values.get("aspect")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def aspect_var(self) -> typing.Optional[builtins.str]:
        '''Preserves the aspect ratio.

        Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_var DataAkamaiImagingPolicyImage#aspect_var}
        '''
        result = self._values.get("aspect_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height to resize the source image to. Must be set if height is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height to resize the source image to. Must be set if height is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''Sets constraints for the image resize.

        Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''Sets constraints for the image resize.

        Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width to resize the source image to. Must be set if width is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width to resize the source image to. Must be set if width is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualResize(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualResizeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualResizeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__09cf2e2fd1e7dafa66ab90b47cbf8c514f167c7410ae0752934d10938734a19a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualResizeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1394269ad376a9f849bdfec2139537cc9f3c0b3b88c1054b6df7c45914c5e964)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualResizeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__655a4ec5edac936e5dcb1f861a97667d13ba8e41f907017b0267ae73523627fd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dc96adc5cc1ea5119f576410d1d96245afbb0736c89e55a41997c6730f5fa77d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e55a2c2d29c8058e35dc07c0b71844a62175daf692ffd4928295497f34c221f7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualResize]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualResize]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualResize]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__84d779835f9d958e3b9639f3dc5ecb69f0acda7472ec3b28671ee5e0fd46f172)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualResizeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualResizeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__78b073c519ab4ff9e9dadc74613be8456a548bf311a6a213199183fbe6e3b7da)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAspect")
    def reset_aspect(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspect", []))

    @jsii.member(jsii_name="resetAspectVar")
    def reset_aspect_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspectVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="aspectInput")
    def aspect_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "aspectInput"))

    @builtins.property
    @jsii.member(jsii_name="aspectVarInput")
    def aspect_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "aspectVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="aspect")
    def aspect(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "aspect"))

    @aspect.setter
    def aspect(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8ac929d62fb40210299c194d5808d988187438f3b54a6963865941f323bd8115)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "aspect", value)

    @builtins.property
    @jsii.member(jsii_name="aspectVar")
    def aspect_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "aspectVar"))

    @aspect_var.setter
    def aspect_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ef175cb4752d5e4c3055011b842da62d04bdefe66ba9303fe36ab5cf18e59bae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "aspectVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e626b333602eeb28a5326897b1e034444f5038db6bb1367a1ce492ba1c3e988b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f0a1ef4f2599908b94e911b4395731ccae285122fbf8c73faa665ac8de033d0d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc76b4c3b492da3e7345f6f72f891a19e1b06a72fb82c37650507dd645f369dc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__408d3c2d817b0bae82460e632adef0cc7097a741e6633c93d2951febad303924)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d92b8abf03d5061c545e99e6e760805bdb4ba300796828b234c969422494b7df)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4d39ef6c843e9c328db485b274b2626595398794984fa16d104568fac3614eb8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualResize]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualResize]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualResize]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9054d0058351791e792b32eeb5ce805dead13861aa5825edda9cebb0150b56ad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRotate",
    jsii_struct_bases=[],
    name_mapping={"degrees": "degrees", "degrees_var": "degreesVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRotate:
    def __init__(
        self,
        *,
        degrees: typing.Optional[builtins.str] = None,
        degrees_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param degrees: The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees DataAkamaiImagingPolicyImage#degrees}
        :param degrees_var: The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees_var DataAkamaiImagingPolicyImage#degrees_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__47376b4cf5d3f90dd549df6aa72961ed425fec9f31edd87d8fbca239d1558b72)
            check_type(argname="argument degrees", value=degrees, expected_type=type_hints["degrees"])
            check_type(argname="argument degrees_var", value=degrees_var, expected_type=type_hints["degrees_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if degrees is not None:
            self._values["degrees"] = degrees
        if degrees_var is not None:
            self._values["degrees_var"] = degrees_var

    @builtins.property
    def degrees(self) -> typing.Optional[builtins.str]:
        '''The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees DataAkamaiImagingPolicyImage#degrees}
        '''
        result = self._values.get("degrees")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def degrees_var(self) -> typing.Optional[builtins.str]:
        '''The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees_var DataAkamaiImagingPolicyImage#degrees_var}
        '''
        result = self._values.get("degrees_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRotate(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRotateList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRotateList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f825b1554a761cc9927d03a6b8ad9e4ae7df6af27a1ebeeb34bcc86b24b73819)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRotateOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__281a3c7070b811a170ce620a8700fd3b5e9202d4804cb44bffc47ff5d260e98e)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRotateOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2abf7e248f3c8af45e54e1c7fb360051cb4c008a5e8f88a5efced9882a0dfb7c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dc9809fe260affdf725f5b605e69bc40057866118a9a11ff232e08357daee0a7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be86f7df29fbf915b3e3624e2f6387674d7ad215fb479b4a155615c4b19f83a9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRotate]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRotate]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRotate]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8582a6e56daff1ff300f545fe85dab84d2a9c779a8934bb880549a4314ad905a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRotateOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRotateOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__777ab40d53c15af92d2c0ae45879f1526a090841bec457cecf702381aea3ff9b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetDegrees")
    def reset_degrees(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDegrees", []))

    @jsii.member(jsii_name="resetDegreesVar")
    def reset_degrees_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDegreesVar", []))

    @builtins.property
    @jsii.member(jsii_name="degreesInput")
    def degrees_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "degreesInput"))

    @builtins.property
    @jsii.member(jsii_name="degreesVarInput")
    def degrees_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "degreesVarInput"))

    @builtins.property
    @jsii.member(jsii_name="degrees")
    def degrees(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "degrees"))

    @degrees.setter
    def degrees(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2635e7600d809247615758bfec1280f2d90d589c5ccdc54e8441bcde2833c379)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "degrees", value)

    @builtins.property
    @jsii.member(jsii_name="degreesVar")
    def degrees_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "degreesVar"))

    @degrees_var.setter
    def degrees_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f0b9369c7b810832d2bda9a258bc96e3b5b51d5b28aeaad9146fa207a1a21c65)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "degreesVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRotate]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRotate]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRotate]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fdafe6533fb5d05e1b397627c5b100a015349fb9c448cabfaeed2ac99525ea33)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualScale",
    jsii_struct_bases=[],
    name_mapping={
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualScale:
    def __init__(
        self,
        *,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param height: Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged. Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged. Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aea2694b866a2a729cdafcb02b90331b0b6fe122275df198910dff3d01511ced)
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size.

        Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size.

        Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged.

        Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged.

        Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualScale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualScaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualScaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__670cdda37c1291f4a9e6dcfd36269ea51bce9a9a05e3720b00a83c7cec172788)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualScaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__86262af2d8ec618a5d667f9ae25df922cf4d80ef061bc0077fcf797b10baba11)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualScaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b8a835164335daa1f8574c20dbaaf0098b9730a8337b218dc8853525d76275c7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__080a4b3f76a5c34eea1b4235d37dfa35ce465f7c8866baac1631a6e311fc47ea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__475c6e0b4bc8e80d9336dafeea2ccbc877f54922dc61cf94cac82366b334aacc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualScale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualScale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualScale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ca30ef3d533fe4dda87877e3adf297e67842f82b8cac0a25a5f8af27bb9d8a5e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualScaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualScaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e73faf9063e6239ae796787dd41d975826427eabe11f98d36ddda6d6fe068d17)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9580f3fa823a36d974737e16b430ecc4cdfe070253882db5d42c0ade70ddcc75)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c156e9953a188fb0462e3d1fd0159d083d8c85284bb56d415176d93d804c3fd8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__78c1da7a8042517b8ae79d5ef2844e47fccf75cfd37784b8f65fd9f885d79d04)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__14003df6624475d03b7864c40c22450f5f925bf1802ba6708eca6273c2563b88)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualScale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualScale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualScale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c9ddba36d7c41ff28ea8ed9945b9b01b78f85a02c83abe384bca55fa2a4ef303)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualShear",
    jsii_struct_bases=[],
    name_mapping={
        "x_shear": "xShear",
        "x_shear_var": "xShearVar",
        "y_shear": "yShear",
        "y_shear_var": "yShearVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualShear:
    def __init__(
        self,
        *,
        x_shear: typing.Optional[builtins.str] = None,
        x_shear_var: typing.Optional[builtins.str] = None,
        y_shear: typing.Optional[builtins.str] = None,
        y_shear_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param x_shear: The amount to shear along the x-axis, measured in multiples of the image's width. Must be set if yShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear DataAkamaiImagingPolicyImage#x_shear}
        :param x_shear_var: The amount to shear along the x-axis, measured in multiples of the image's width. Must be set if yShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear_var DataAkamaiImagingPolicyImage#x_shear_var}
        :param y_shear: The amount to shear along the y-axis, measured in multiples of the image's height. Must be set if xShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear DataAkamaiImagingPolicyImage#y_shear}
        :param y_shear_var: The amount to shear along the y-axis, measured in multiples of the image's height. Must be set if xShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear_var DataAkamaiImagingPolicyImage#y_shear_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9fd2e9cc2f7ea68d2d2f9c5b6cd23b3af57858f061fd90707a57c1f52c0aabdb)
            check_type(argname="argument x_shear", value=x_shear, expected_type=type_hints["x_shear"])
            check_type(argname="argument x_shear_var", value=x_shear_var, expected_type=type_hints["x_shear_var"])
            check_type(argname="argument y_shear", value=y_shear, expected_type=type_hints["y_shear"])
            check_type(argname="argument y_shear_var", value=y_shear_var, expected_type=type_hints["y_shear_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if x_shear is not None:
            self._values["x_shear"] = x_shear
        if x_shear_var is not None:
            self._values["x_shear_var"] = x_shear_var
        if y_shear is not None:
            self._values["y_shear"] = y_shear
        if y_shear_var is not None:
            self._values["y_shear_var"] = y_shear_var

    @builtins.property
    def x_shear(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the x-axis, measured in multiples of the image's width.

        Must be set if yShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear DataAkamaiImagingPolicyImage#x_shear}
        '''
        result = self._values.get("x_shear")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_shear_var(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the x-axis, measured in multiples of the image's width.

        Must be set if yShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear_var DataAkamaiImagingPolicyImage#x_shear_var}
        '''
        result = self._values.get("x_shear_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_shear(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the y-axis, measured in multiples of the image's height.

        Must be set if xShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear DataAkamaiImagingPolicyImage#y_shear}
        '''
        result = self._values.get("y_shear")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_shear_var(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the y-axis, measured in multiples of the image's height.

        Must be set if xShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear_var DataAkamaiImagingPolicyImage#y_shear_var}
        '''
        result = self._values.get("y_shear_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualShear(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualShearList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualShearList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__59393fa94185f7548f1de29cf22159a89ca908fbf490dd9549af8e5a7e863c6c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualShearOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__63a1d61b4c9ab74deafe965d1073711ae5351261e30efc5dada5609b4b8c20e0)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualShearOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ebbe4102ea30296bcee31b88533f6030147822e549946b04649c5e054bd6ca5d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c58daf6da49461e5800bae8959cba11f1f1d800858df722fdc764d4d23779bb7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9b405300b658278124f121d773511ec436f5fd697373e709675a27a98f587af1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualShear]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualShear]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualShear]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6d4855fb194d3ca0855704880b79a1fff1ac27f03f9cd9bc7d1c4029995733e1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualShearOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualShearOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f7815ef05f9708189d3b84e7182ad2e6624c5a63c5019eef1e9cb6cfc45415af)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetXShear")
    def reset_x_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXShear", []))

    @jsii.member(jsii_name="resetXShearVar")
    def reset_x_shear_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXShearVar", []))

    @jsii.member(jsii_name="resetYShear")
    def reset_y_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYShear", []))

    @jsii.member(jsii_name="resetYShearVar")
    def reset_y_shear_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYShearVar", []))

    @builtins.property
    @jsii.member(jsii_name="xShearInput")
    def x_shear_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xShearInput"))

    @builtins.property
    @jsii.member(jsii_name="xShearVarInput")
    def x_shear_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xShearVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yShearInput")
    def y_shear_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yShearInput"))

    @builtins.property
    @jsii.member(jsii_name="yShearVarInput")
    def y_shear_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yShearVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xShear")
    def x_shear(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xShear"))

    @x_shear.setter
    def x_shear(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__140c31c0b06dc23034df1b8416d78a962926490e1f342ab929e788eb87dbe043)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xShear", value)

    @builtins.property
    @jsii.member(jsii_name="xShearVar")
    def x_shear_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xShearVar"))

    @x_shear_var.setter
    def x_shear_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__56841e166d2029e834228eb62ad168a9024062a2b5ef7df563e0c27f41819201)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xShearVar", value)

    @builtins.property
    @jsii.member(jsii_name="yShear")
    def y_shear(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yShear"))

    @y_shear.setter
    def y_shear(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4acc65b1b26a5ea7feef05f84388b2b8ab9eb080db795cd58508195e09879582)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yShear", value)

    @builtins.property
    @jsii.member(jsii_name="yShearVar")
    def y_shear_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yShearVar"))

    @y_shear_var.setter
    def y_shear_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__87c08dfd855814a6b7ec3b6935148165da879aab42bc13d8bca6f5550b521c58)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yShearVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualShear]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualShear]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualShear]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__61c132346f15c2c90e4d1ef7a6796ee5803855f2548b8ab0783e4bf88996d37b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualTrim",
    jsii_struct_bases=[],
    name_mapping={
        "fuzz": "fuzz",
        "fuzz_var": "fuzzVar",
        "padding": "padding",
        "padding_var": "paddingVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualTrim:
    def __init__(
        self,
        *,
        fuzz: typing.Optional[builtins.str] = None,
        fuzz_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fuzz: The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz DataAkamaiImagingPolicyImage#fuzz}
        :param fuzz_var: The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz_var DataAkamaiImagingPolicyImage#fuzz_var}
        :param padding: The amount of padding in pixels to add to the trimmed image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: The amount of padding in pixels to add to the trimmed image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0eec113964903655f1638e8a45cf798f47d4392901aab65102e43176ad27e21c)
            check_type(argname="argument fuzz", value=fuzz, expected_type=type_hints["fuzz"])
            check_type(argname="argument fuzz_var", value=fuzz_var, expected_type=type_hints["fuzz_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fuzz is not None:
            self._values["fuzz"] = fuzz
        if fuzz_var is not None:
            self._values["fuzz_var"] = fuzz_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var

    @builtins.property
    def fuzz(self) -> typing.Optional[builtins.str]:
        '''The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz DataAkamaiImagingPolicyImage#fuzz}
        '''
        result = self._values.get("fuzz")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fuzz_var(self) -> typing.Optional[builtins.str]:
        '''The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz_var DataAkamaiImagingPolicyImage#fuzz_var}
        '''
        result = self._values.get("fuzz_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''The amount of padding in pixels to add to the trimmed image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''The amount of padding in pixels to add to the trimmed image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualTrim(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualTrimList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualTrimList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f5df9d292bffab933862617717a029550ed9e41ab0de4e57ed8aef0c2155eb31)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualTrimOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__23f08ad559af8229616ae7e166758368f311a45be3ab681b91d28b8f4894eff9)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualTrimOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ccb6b4634ff97097a9d7dc6be1e6da25b7c574846584eabf65d1752f59a5028)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c8c15f651ef2c2f40d2f2d5e8f37eeb09287a6c7d229d1b85ca5193b2af65aab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f36555e033678b95e4136ee51bd37683e587b902ae0ee5e5f21dbe781e87750)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualTrim]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualTrim]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualTrim]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__198364f938bea092aa4c18c8e61fba6dde2ec14634e3a745e7f6e86f3d0f9f70)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualTrimOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualTrimOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b2afad4cb92356ce63de6303f10a1e93869a1654fd5674301bfd4599eae2159f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetFuzz")
    def reset_fuzz(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFuzz", []))

    @jsii.member(jsii_name="resetFuzzVar")
    def reset_fuzz_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFuzzVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @builtins.property
    @jsii.member(jsii_name="fuzzInput")
    def fuzz_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fuzzInput"))

    @builtins.property
    @jsii.member(jsii_name="fuzzVarInput")
    def fuzz_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fuzzVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="fuzz")
    def fuzz(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fuzz"))

    @fuzz.setter
    def fuzz(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cc6bc01599355b21f8be9857a3a10f9c78eee679391cc2011948d6308f8baf07)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fuzz", value)

    @builtins.property
    @jsii.member(jsii_name="fuzzVar")
    def fuzz_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fuzzVar"))

    @fuzz_var.setter
    def fuzz_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0e24e9d0906c5123cc86f869e93b384905b93b58a70faee240d5c05b646a4fb9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fuzzVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0795bd57d3722fc25b7f6deebb9447edc7af42627b369232ac3a3ca2f00a9b2c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__21a91318d1c0ff7faddd5c81f548eed7697511c623f0550185f14d196eb41678)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualTrim]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualTrim]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualTrim]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4086fae2f1108ec5f2f0d90bfb88688d787f69f8420fecdbd79c6a15c66defe0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualUnsharpMask",
    jsii_struct_bases=[],
    name_mapping={
        "gain": "gain",
        "gain_var": "gainVar",
        "sigma": "sigma",
        "sigma_var": "sigmaVar",
        "threshold": "threshold",
        "threshold_var": "thresholdVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualUnsharpMask:
    def __init__(
        self,
        *,
        gain: typing.Optional[builtins.str] = None,
        gain_var: typing.Optional[builtins.str] = None,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
        threshold: typing.Optional[builtins.str] = None,
        threshold_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param gain: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        :param gain_var: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        :param sigma: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        :param threshold: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        :param threshold_var: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__09579a20179572b6491c65a33c0a47ad80838dd6d59d70211942ecb127963921)
            check_type(argname="argument gain", value=gain, expected_type=type_hints["gain"])
            check_type(argname="argument gain_var", value=gain_var, expected_type=type_hints["gain_var"])
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
            check_type(argname="argument threshold", value=threshold, expected_type=type_hints["threshold"])
            check_type(argname="argument threshold_var", value=threshold_var, expected_type=type_hints["threshold_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if gain is not None:
            self._values["gain"] = gain
        if gain_var is not None:
            self._values["gain_var"] = gain_var
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var
        if threshold is not None:
            self._values["threshold"] = threshold
        if threshold_var is not None:
            self._values["threshold_var"] = threshold_var

    @builtins.property
    def gain(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        '''
        result = self._values.get("gain")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gain_var(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        '''
        result = self._values.get("gain_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        '''
        result = self._values.get("threshold")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold_var(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        result = self._values.get("threshold_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualUnsharpMask(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualUnsharpMaskList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualUnsharpMaskList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5be60f066e361bae9c42606927178ec73719425ada2b188a1ba85a13d4cb0373)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualUnsharpMaskOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6c6516be22b5c5d0a09505e7a344451a00c43c1461ab14583d5be85d5e23d429)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualUnsharpMaskOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ddddbd80ef6bf41bd1d2a91af92bc68821a2b798a6615c3f74593d94f471d4af)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__769d060f8a43de3f71820b59d4b79e32bb96f78f332d2954ff7bcf0f3ebbed77)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__27934ca150e63b89ed754d625cbd774faeccd88904fff838064872e7184b7a30)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualUnsharpMask]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualUnsharpMask]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualUnsharpMask]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__75e039a71abe28c18a89baf7fd137ad31cdad448104ca3254f97dca60439e141)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualUnsharpMaskOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualUnsharpMaskOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__371a9b7dc93fa4cece7b3aaa944c336515465c9d03a835ded9442155cd1c1135)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetGain")
    def reset_gain(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGain", []))

    @jsii.member(jsii_name="resetGainVar")
    def reset_gain_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGainVar", []))

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @jsii.member(jsii_name="resetThreshold")
    def reset_threshold(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThreshold", []))

    @jsii.member(jsii_name="resetThresholdVar")
    def reset_threshold_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThresholdVar", []))

    @builtins.property
    @jsii.member(jsii_name="gainInput")
    def gain_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainInput"))

    @builtins.property
    @jsii.member(jsii_name="gainVarInput")
    def gain_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdInput")
    def threshold_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdVarInput")
    def threshold_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gain")
    def gain(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gain"))

    @gain.setter
    def gain(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__953a08368eea4a7e38f70ce86cf34bd25b639e69f77d34f6a790c43d88e059e9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gain", value)

    @builtins.property
    @jsii.member(jsii_name="gainVar")
    def gain_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gainVar"))

    @gain_var.setter
    def gain_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a960a61b01b7354bfb55d586816d60f44a6a316de51e7d376d53daa8b4f5e680)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gainVar", value)

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a31c862e2167ea7be8d08640a8a4806017a678efe48ad7029a62ff445d86db6f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be147840ed106b8f3ee54ed971afa1a48994567e27008ced7eacc615931a4692)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="threshold")
    def threshold(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "threshold"))

    @threshold.setter
    def threshold(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e4e9fdad6cb0ddeef66d48430d285b35c3f1d014b4bb1c1a80591c4a3e616d52)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "threshold", value)

    @builtins.property
    @jsii.member(jsii_name="thresholdVar")
    def threshold_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "thresholdVar"))

    @threshold_var.setter
    def threshold_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6aad903ba39551b7a31337f00a6f52e994e62cc73b5e6c8c542b0c77338703aa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "thresholdVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualUnsharpMask]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualUnsharpMask]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualUnsharpMask]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__95cc5ec9f7f8b7d789079f97ef472173409cdd4211fe72ba6b4b53d4edc3b9e0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThan",
    jsii_struct_bases=[],
    name_mapping={
        "append": "append",
        "aspect_crop": "aspectCrop",
        "background_color": "backgroundColor",
        "blur": "blur",
        "chroma_key": "chromaKey",
        "composite": "composite",
        "compound": "compound",
        "contrast": "contrast",
        "crop": "crop",
        "face_crop": "faceCrop",
        "feature_crop": "featureCrop",
        "fit_and_fill": "fitAndFill",
        "goop": "goop",
        "grayscale": "grayscale",
        "hsl": "hsl",
        "hsv": "hsv",
        "if_dimension": "ifDimension",
        "if_orientation": "ifOrientation",
        "im_query": "imQuery",
        "max_colors": "maxColors",
        "mirror": "mirror",
        "mono_hue": "monoHue",
        "opacity": "opacity",
        "region_of_interest_crop": "regionOfInterestCrop",
        "relative_crop": "relativeCrop",
        "remove_color": "removeColor",
        "resize": "resize",
        "rotate": "rotate",
        "scale": "scale",
        "shear": "shear",
        "trim": "trim",
        "unsharp_mask": "unsharpMask",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThan:
    def __init__(
        self,
        *,
        append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppend", typing.Dict[builtins.str, typing.Any]]]]] = None,
        aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAspectCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanBackgroundColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanBlur", typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanChromaKey", typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanComposite", typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompound", typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanContrast", typing.Dict[builtins.str, typing.Any]]]]] = None,
        crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFaceCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFeatureCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFill", typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanGoop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanGrayscale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanHsl", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanHsv", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientation", typing.Dict[builtins.str, typing.Any]]]]] = None,
        im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanImQuery", typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanMaxColors", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanMirror", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanMonoHue", typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanOpacity", typing.Dict[builtins.str, typing.Any]]]]] = None,
        region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRelativeCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRemoveColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanResize", typing.Dict[builtins.str, typing.Any]]]]] = None,
        rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRotate", typing.Dict[builtins.str, typing.Any]]]]] = None,
        scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanScale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanShear", typing.Dict[builtins.str, typing.Any]]]]] = None,
        trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanTrim", typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanUnsharpMask", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param append: append block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        :param aspect_crop: aspect_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param crop: crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        :param face_crop: face_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        :param feature_crop: feature_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        :param fit_and_fill: fit_and_fill block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param im_query: im_query block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param region_of_interest_crop: region_of_interest_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        :param relative_crop: relative_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param resize: resize block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        :param rotate: rotate block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        :param scale: scale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param shear: shear block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        :param trim: trim block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7df1b74984fffba7715c03845cead313492ce7b8523cae59fe381ad231b716f3)
            check_type(argname="argument append", value=append, expected_type=type_hints["append"])
            check_type(argname="argument aspect_crop", value=aspect_crop, expected_type=type_hints["aspect_crop"])
            check_type(argname="argument background_color", value=background_color, expected_type=type_hints["background_color"])
            check_type(argname="argument blur", value=blur, expected_type=type_hints["blur"])
            check_type(argname="argument chroma_key", value=chroma_key, expected_type=type_hints["chroma_key"])
            check_type(argname="argument composite", value=composite, expected_type=type_hints["composite"])
            check_type(argname="argument compound", value=compound, expected_type=type_hints["compound"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument crop", value=crop, expected_type=type_hints["crop"])
            check_type(argname="argument face_crop", value=face_crop, expected_type=type_hints["face_crop"])
            check_type(argname="argument feature_crop", value=feature_crop, expected_type=type_hints["feature_crop"])
            check_type(argname="argument fit_and_fill", value=fit_and_fill, expected_type=type_hints["fit_and_fill"])
            check_type(argname="argument goop", value=goop, expected_type=type_hints["goop"])
            check_type(argname="argument grayscale", value=grayscale, expected_type=type_hints["grayscale"])
            check_type(argname="argument hsl", value=hsl, expected_type=type_hints["hsl"])
            check_type(argname="argument hsv", value=hsv, expected_type=type_hints["hsv"])
            check_type(argname="argument if_dimension", value=if_dimension, expected_type=type_hints["if_dimension"])
            check_type(argname="argument if_orientation", value=if_orientation, expected_type=type_hints["if_orientation"])
            check_type(argname="argument im_query", value=im_query, expected_type=type_hints["im_query"])
            check_type(argname="argument max_colors", value=max_colors, expected_type=type_hints["max_colors"])
            check_type(argname="argument mirror", value=mirror, expected_type=type_hints["mirror"])
            check_type(argname="argument mono_hue", value=mono_hue, expected_type=type_hints["mono_hue"])
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument region_of_interest_crop", value=region_of_interest_crop, expected_type=type_hints["region_of_interest_crop"])
            check_type(argname="argument relative_crop", value=relative_crop, expected_type=type_hints["relative_crop"])
            check_type(argname="argument remove_color", value=remove_color, expected_type=type_hints["remove_color"])
            check_type(argname="argument resize", value=resize, expected_type=type_hints["resize"])
            check_type(argname="argument rotate", value=rotate, expected_type=type_hints["rotate"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument shear", value=shear, expected_type=type_hints["shear"])
            check_type(argname="argument trim", value=trim, expected_type=type_hints["trim"])
            check_type(argname="argument unsharp_mask", value=unsharp_mask, expected_type=type_hints["unsharp_mask"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if append is not None:
            self._values["append"] = append
        if aspect_crop is not None:
            self._values["aspect_crop"] = aspect_crop
        if background_color is not None:
            self._values["background_color"] = background_color
        if blur is not None:
            self._values["blur"] = blur
        if chroma_key is not None:
            self._values["chroma_key"] = chroma_key
        if composite is not None:
            self._values["composite"] = composite
        if compound is not None:
            self._values["compound"] = compound
        if contrast is not None:
            self._values["contrast"] = contrast
        if crop is not None:
            self._values["crop"] = crop
        if face_crop is not None:
            self._values["face_crop"] = face_crop
        if feature_crop is not None:
            self._values["feature_crop"] = feature_crop
        if fit_and_fill is not None:
            self._values["fit_and_fill"] = fit_and_fill
        if goop is not None:
            self._values["goop"] = goop
        if grayscale is not None:
            self._values["grayscale"] = grayscale
        if hsl is not None:
            self._values["hsl"] = hsl
        if hsv is not None:
            self._values["hsv"] = hsv
        if if_dimension is not None:
            self._values["if_dimension"] = if_dimension
        if if_orientation is not None:
            self._values["if_orientation"] = if_orientation
        if im_query is not None:
            self._values["im_query"] = im_query
        if max_colors is not None:
            self._values["max_colors"] = max_colors
        if mirror is not None:
            self._values["mirror"] = mirror
        if mono_hue is not None:
            self._values["mono_hue"] = mono_hue
        if opacity is not None:
            self._values["opacity"] = opacity
        if region_of_interest_crop is not None:
            self._values["region_of_interest_crop"] = region_of_interest_crop
        if relative_crop is not None:
            self._values["relative_crop"] = relative_crop
        if remove_color is not None:
            self._values["remove_color"] = remove_color
        if resize is not None:
            self._values["resize"] = resize
        if rotate is not None:
            self._values["rotate"] = rotate
        if scale is not None:
            self._values["scale"] = scale
        if shear is not None:
            self._values["shear"] = shear
        if trim is not None:
            self._values["trim"] = trim
        if unsharp_mask is not None:
            self._values["unsharp_mask"] = unsharp_mask

    @builtins.property
    def append(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppend"]]]:
        '''append block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        '''
        result = self._values.get("append")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppend"]]], result)

    @builtins.property
    def aspect_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAspectCrop"]]]:
        '''aspect_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        '''
        result = self._values.get("aspect_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAspectCrop"]]], result)

    @builtins.property
    def background_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanBackgroundColor"]]]:
        '''background_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        '''
        result = self._values.get("background_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanBackgroundColor"]]], result)

    @builtins.property
    def blur(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanBlur"]]]:
        '''blur block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        '''
        result = self._values.get("blur")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanBlur"]]], result)

    @builtins.property
    def chroma_key(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanChromaKey"]]]:
        '''chroma_key block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        '''
        result = self._values.get("chroma_key")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanChromaKey"]]], result)

    @builtins.property
    def composite(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanComposite"]]]:
        '''composite block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        '''
        result = self._values.get("composite")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanComposite"]]], result)

    @builtins.property
    def compound(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompound"]]]:
        '''compound block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        '''
        result = self._values.get("compound")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompound"]]], result)

    @builtins.property
    def contrast(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanContrast"]]]:
        '''contrast block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanContrast"]]], result)

    @builtins.property
    def crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCrop"]]]:
        '''crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        '''
        result = self._values.get("crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCrop"]]], result)

    @builtins.property
    def face_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFaceCrop"]]]:
        '''face_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        '''
        result = self._values.get("face_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFaceCrop"]]], result)

    @builtins.property
    def feature_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFeatureCrop"]]]:
        '''feature_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        '''
        result = self._values.get("feature_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFeatureCrop"]]], result)

    @builtins.property
    def fit_and_fill(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFill"]]]:
        '''fit_and_fill block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        '''
        result = self._values.get("fit_and_fill")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFill"]]], result)

    @builtins.property
    def goop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanGoop"]]]:
        '''goop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        '''
        result = self._values.get("goop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanGoop"]]], result)

    @builtins.property
    def grayscale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanGrayscale"]]]:
        '''grayscale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        '''
        result = self._values.get("grayscale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanGrayscale"]]], result)

    @builtins.property
    def hsl(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanHsl"]]]:
        '''hsl block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        '''
        result = self._values.get("hsl")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanHsl"]]], result)

    @builtins.property
    def hsv(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanHsv"]]]:
        '''hsv block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        '''
        result = self._values.get("hsv")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanHsv"]]], result)

    @builtins.property
    def if_dimension(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimension]]]:
        '''if_dimension block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        '''
        result = self._values.get("if_dimension")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimension]]], result)

    @builtins.property
    def if_orientation(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientation"]]]:
        '''if_orientation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        '''
        result = self._values.get("if_orientation")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientation"]]], result)

    @builtins.property
    def im_query(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanImQuery"]]]:
        '''im_query block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        '''
        result = self._values.get("im_query")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanImQuery"]]], result)

    @builtins.property
    def max_colors(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanMaxColors"]]]:
        '''max_colors block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        '''
        result = self._values.get("max_colors")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanMaxColors"]]], result)

    @builtins.property
    def mirror(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanMirror"]]]:
        '''mirror block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        '''
        result = self._values.get("mirror")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanMirror"]]], result)

    @builtins.property
    def mono_hue(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanMonoHue"]]]:
        '''mono_hue block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        '''
        result = self._values.get("mono_hue")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanMonoHue"]]], result)

    @builtins.property
    def opacity(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanOpacity"]]]:
        '''opacity block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanOpacity"]]], result)

    @builtins.property
    def region_of_interest_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCrop"]]]:
        '''region_of_interest_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        '''
        result = self._values.get("region_of_interest_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCrop"]]], result)

    @builtins.property
    def relative_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRelativeCrop"]]]:
        '''relative_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        '''
        result = self._values.get("relative_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRelativeCrop"]]], result)

    @builtins.property
    def remove_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRemoveColor"]]]:
        '''remove_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        '''
        result = self._values.get("remove_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRemoveColor"]]], result)

    @builtins.property
    def resize(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanResize"]]]:
        '''resize block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        '''
        result = self._values.get("resize")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanResize"]]], result)

    @builtins.property
    def rotate(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRotate"]]]:
        '''rotate block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        '''
        result = self._values.get("rotate")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRotate"]]], result)

    @builtins.property
    def scale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanScale"]]]:
        '''scale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanScale"]]], result)

    @builtins.property
    def shear(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanShear"]]]:
        '''shear block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        '''
        result = self._values.get("shear")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanShear"]]], result)

    @builtins.property
    def trim(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanTrim"]]]:
        '''trim block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        '''
        result = self._values.get("trim")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanTrim"]]], result)

    @builtins.property
    def unsharp_mask(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanUnsharpMask"]]]:
        '''unsharp_mask block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        result = self._values.get("unsharp_mask")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanUnsharpMask"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppend",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_priority": "gravityPriority",
        "gravity_priority_var": "gravityPriorityVar",
        "gravity_var": "gravityVar",
        "preserve_minor_dimension": "preserveMinorDimension",
        "preserve_minor_dimension_var": "preserveMinorDimensionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppend:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_priority: typing.Optional[builtins.str] = None,
        gravity_priority_var: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        preserve_minor_dimension: typing.Optional[builtins.str] = None,
        preserve_minor_dimension_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Specifies where to place the ``image`` relative to the source image. The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_priority: Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal. The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority DataAkamaiImagingPolicyImage#gravity_priority}
        :param gravity_priority_var: Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal. The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority_var DataAkamaiImagingPolicyImage#gravity_priority_var}
        :param gravity_var: Specifies where to place the ``image`` relative to the source image. The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param preserve_minor_dimension: Whether to preserve the source image's minor dimension, ``false`` by default. The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension DataAkamaiImagingPolicyImage#preserve_minor_dimension}
        :param preserve_minor_dimension_var: Whether to preserve the source image's minor dimension, ``false`` by default. The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension_var DataAkamaiImagingPolicyImage#preserve_minor_dimension_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9978052f76fe1e9e269830163d9db343545fe07d1b641e13a858e86db46808f8)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_priority", value=gravity_priority, expected_type=type_hints["gravity_priority"])
            check_type(argname="argument gravity_priority_var", value=gravity_priority_var, expected_type=type_hints["gravity_priority_var"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument preserve_minor_dimension", value=preserve_minor_dimension, expected_type=type_hints["preserve_minor_dimension"])
            check_type(argname="argument preserve_minor_dimension_var", value=preserve_minor_dimension_var, expected_type=type_hints["preserve_minor_dimension_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_priority is not None:
            self._values["gravity_priority"] = gravity_priority
        if gravity_priority_var is not None:
            self._values["gravity_priority_var"] = gravity_priority_var
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if preserve_minor_dimension is not None:
            self._values["preserve_minor_dimension"] = preserve_minor_dimension
        if preserve_minor_dimension_var is not None:
            self._values["preserve_minor_dimension_var"] = preserve_minor_dimension_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Specifies where to place the ``image`` relative to the source image.

        The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_priority(self) -> typing.Optional[builtins.str]:
        '''Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal.

        The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority DataAkamaiImagingPolicyImage#gravity_priority}
        '''
        result = self._values.get("gravity_priority")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_priority_var(self) -> typing.Optional[builtins.str]:
        '''Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal.

        The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority_var DataAkamaiImagingPolicyImage#gravity_priority_var}
        '''
        result = self._values.get("gravity_priority_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Specifies where to place the ``image`` relative to the source image.

        The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def preserve_minor_dimension(self) -> typing.Optional[builtins.str]:
        '''Whether to preserve the source image's minor dimension, ``false`` by default.

        The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension DataAkamaiImagingPolicyImage#preserve_minor_dimension}
        '''
        result = self._values.get("preserve_minor_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def preserve_minor_dimension_var(self) -> typing.Optional[builtins.str]:
        '''Whether to preserve the source image's minor dimension, ``false`` by default.

        The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension_var DataAkamaiImagingPolicyImage#preserve_minor_dimension_var}
        '''
        result = self._values.get("preserve_minor_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppend(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImage",
    jsii_struct_bases=[],
    name_mapping={
        "box_image": "boxImage",
        "circle_image": "circleImage",
        "text_image": "textImage",
        "url_image": "urlImage",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImage:
    def __init__(
        self,
        *,
        box_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageBoxImage", typing.Dict[builtins.str, typing.Any]]]]] = None,
        circle_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageCircleImage", typing.Dict[builtins.str, typing.Any]]]]] = None,
        text_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageTextImage", typing.Dict[builtins.str, typing.Any]]]]] = None,
        url_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageUrlImage", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param box_image: box_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#box_image DataAkamaiImagingPolicyImage#box_image}
        :param circle_image: circle_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#circle_image DataAkamaiImagingPolicyImage#circle_image}
        :param text_image: text_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text_image DataAkamaiImagingPolicyImage#text_image}
        :param url_image: url_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url_image DataAkamaiImagingPolicyImage#url_image}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__67018b5ebff9d7645ccad0843008d068b6f21f6f4b54e19624a2f6635e873bb4)
            check_type(argname="argument box_image", value=box_image, expected_type=type_hints["box_image"])
            check_type(argname="argument circle_image", value=circle_image, expected_type=type_hints["circle_image"])
            check_type(argname="argument text_image", value=text_image, expected_type=type_hints["text_image"])
            check_type(argname="argument url_image", value=url_image, expected_type=type_hints["url_image"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if box_image is not None:
            self._values["box_image"] = box_image
        if circle_image is not None:
            self._values["circle_image"] = circle_image
        if text_image is not None:
            self._values["text_image"] = text_image
        if url_image is not None:
            self._values["url_image"] = url_image

    @builtins.property
    def box_image(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageBoxImage"]]]:
        '''box_image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#box_image DataAkamaiImagingPolicyImage#box_image}
        '''
        result = self._values.get("box_image")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageBoxImage"]]], result)

    @builtins.property
    def circle_image(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageCircleImage"]]]:
        '''circle_image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#circle_image DataAkamaiImagingPolicyImage#circle_image}
        '''
        result = self._values.get("circle_image")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageCircleImage"]]], result)

    @builtins.property
    def text_image(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageTextImage"]]]:
        '''text_image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text_image DataAkamaiImagingPolicyImage#text_image}
        '''
        result = self._values.get("text_image")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageTextImage"]]], result)

    @builtins.property
    def url_image(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageUrlImage"]]]:
        '''url_image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url_image DataAkamaiImagingPolicyImage#url_image}
        '''
        result = self._values.get("url_image")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageUrlImage"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageBoxImage",
    jsii_struct_bases=[],
    name_mapping={
        "color": "color",
        "color_var": "colorVar",
        "height": "height",
        "height_var": "heightVar",
        "transformation": "transformation",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageBoxImage:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        transformation: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageBoxImageTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The fill color of the box, not the edge of the box. The API supports hexadecimal representation and CSS hexadecimal color values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The fill color of the box, not the edge of the box. The API supports hexadecimal representation and CSS hexadecimal color values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        :param height: The height of the box in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height of the box in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param transformation: transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        :param width: The width of the box in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width of the box in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(transformation, dict):
            transformation = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageBoxImageTransformation(**transformation)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f754665d14706422a57db156b50adfb85d825c1e69b5312d4b1ccd825bd2ca8)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument transformation", value=transformation, expected_type=type_hints["transformation"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if transformation is not None:
            self._values["transformation"] = transformation
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The fill color of the box, not the edge of the box.

        The API supports hexadecimal representation and CSS hexadecimal color values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The fill color of the box, not the edge of the box.

        The API supports hexadecimal representation and CSS hexadecimal color values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height of the box in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height of the box in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def transformation(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageBoxImageTransformation"]:
        '''transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        '''
        result = self._values.get("transformation")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageBoxImageTransformation"], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width of the box in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width of the box in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageBoxImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageBoxImageList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageBoxImageList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9af871ba671ef85006e107cba602601d2a9b7076844d2884450fc39e492259d0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageBoxImageOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__162a23d842e81e93e3d13c23bfef68251d0bef79fcaa835d57a351e13f4afe85)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageBoxImageOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9cb1a306928a0ba5ecb9dfc7f8365cd85379b5b3163f7803702f14f88680fd71)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0b279189edcda169387b8d0c7ca61b2b2fe3fa3f96627615849d26604bd98457)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__015c5d03e5305c7f923bfdff7513a255cf7de99944b26c15f885ccab4d4f8176)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageBoxImage]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageBoxImage]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageBoxImage]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4566ff805f1874c59e6d14d8b5932bcf0764031ccd98e885ceef56c9bf519499)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageBoxImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageBoxImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b4f8ccfa2c97154147f9e63f68454058e57f6797b6e44564f4c3f77f8025ba71)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformation")
    def put_transformation(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageBoxImageTransformation()

        return typing.cast(None, jsii.invoke(self, "putTransformation", [value]))

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetTransformation")
    def reset_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformation", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="transformation")
    def transformation(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageBoxImageTransformationOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageBoxImageTransformationOutputReference", jsii.get(self, "transformation"))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="transformationInput")
    def transformation_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageBoxImageTransformation"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageBoxImageTransformation"], jsii.get(self, "transformationInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__686e1c7bdff7b276d63cc36bdd8ccae1bf5ecf0a1aa2bcae4f9d22b782a9ff06)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb29ea35068827a18e5c5bd03aab8768dda0807d10a7f642f6c0dd6415b6909d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__44017f0084eec57a4603eb6c249a67b8097bc3e638e4cfb35e0de757119d10c5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__44662bdc34e1eba22e908e8672e78ccc90a600a7051cb4c6b38990a268fe8541)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8947589822463bff7893cbfa8ac00737bdeac4c9b1257fdf7a2ee5fb974f1121)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a33c79ba768e47bb8a4a831f07995c32f1f4e8f635668d0a92bb4e7f54d23e49)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageBoxImage]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageBoxImage]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageBoxImage]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__afcc2a9f7dad172d84040702f018feab102268c10cd538e8929fe7c78bf6dc5d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageBoxImageTransformation",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageBoxImageTransformation:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageBoxImageTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageBoxImageTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageBoxImageTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c60e0dc79f7ccb5dd3ab4b39fe51a8a0535b2250d07c624c94db04ae7433f17a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageBoxImageTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageBoxImageTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageBoxImageTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7092eb9a46ecb74c866669c830e32a25650766f29a6a62012b4da8f7b22921ce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageCircleImage",
    jsii_struct_bases=[],
    name_mapping={
        "color": "color",
        "color_var": "colorVar",
        "diameter": "diameter",
        "diameter_var": "diameterVar",
        "transformation": "transformation",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageCircleImage:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
        diameter: typing.Optional[builtins.str] = None,
        diameter_var: typing.Optional[builtins.str] = None,
        transformation: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageCircleImageTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The fill color of the circle. The API supports hexadecimal representation and CSS hexadecimal color values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The fill color of the circle. The API supports hexadecimal representation and CSS hexadecimal color values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        :param diameter: The diameter of the circle. The diameter will be the width and the height of the image in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#diameter DataAkamaiImagingPolicyImage#diameter}
        :param diameter_var: The diameter of the circle. The diameter will be the width and the height of the image in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#diameter_var DataAkamaiImagingPolicyImage#diameter_var}
        :param transformation: transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        :param width: The width of the box in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width of the box in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(transformation, dict):
            transformation = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageCircleImageTransformation(**transformation)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f2ff3ce947b6e0fc1b750173bacbe61eec13a3b0d833aaf78591667f05b06727)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
            check_type(argname="argument diameter", value=diameter, expected_type=type_hints["diameter"])
            check_type(argname="argument diameter_var", value=diameter_var, expected_type=type_hints["diameter_var"])
            check_type(argname="argument transformation", value=transformation, expected_type=type_hints["transformation"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var
        if diameter is not None:
            self._values["diameter"] = diameter
        if diameter_var is not None:
            self._values["diameter_var"] = diameter_var
        if transformation is not None:
            self._values["transformation"] = transformation
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The fill color of the circle. The API supports hexadecimal representation and CSS hexadecimal color values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The fill color of the circle. The API supports hexadecimal representation and CSS hexadecimal color values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def diameter(self) -> typing.Optional[builtins.str]:
        '''The diameter of the circle. The diameter will be the width and the height of the image in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#diameter DataAkamaiImagingPolicyImage#diameter}
        '''
        result = self._values.get("diameter")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def diameter_var(self) -> typing.Optional[builtins.str]:
        '''The diameter of the circle. The diameter will be the width and the height of the image in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#diameter_var DataAkamaiImagingPolicyImage#diameter_var}
        '''
        result = self._values.get("diameter_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def transformation(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageCircleImageTransformation"]:
        '''transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        '''
        result = self._values.get("transformation")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageCircleImageTransformation"], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width of the box in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width of the box in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageCircleImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageCircleImageList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageCircleImageList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2e8b8717a41b2a59b12cd0f5e5fa3c71c7660c30184fb82f78f9f0b04cafa6db)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageCircleImageOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cb791574b43d01c8dd255f6f32c48af7d3de1aded2b2d7aa4151277caed8bb4e)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageCircleImageOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2036056ef4417915d85d31fb6a80cea5f73426d2f8a122111b3740b7d7f3b1d8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1453b80fd29f9ae009ca18d882b8ac0923ffe2720bf389abb9cf85638f879e16)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__deb56767d730978f134ffb18fd22c91bc1d88d9b444de9db9a8092483e716f59)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageCircleImage]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageCircleImage]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageCircleImage]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__06aeaea46d033a486c3b2b74b611150c176a874794d89620f64482f394ec505f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageCircleImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageCircleImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__387417730d0f58cb0dc4107748a6fe3df48e102d1d9098b04f5924a52b627c52)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformation")
    def put_transformation(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageCircleImageTransformation()

        return typing.cast(None, jsii.invoke(self, "putTransformation", [value]))

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @jsii.member(jsii_name="resetDiameter")
    def reset_diameter(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDiameter", []))

    @jsii.member(jsii_name="resetDiameterVar")
    def reset_diameter_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDiameterVar", []))

    @jsii.member(jsii_name="resetTransformation")
    def reset_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformation", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="transformation")
    def transformation(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageCircleImageTransformationOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageCircleImageTransformationOutputReference", jsii.get(self, "transformation"))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="diameterInput")
    def diameter_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "diameterInput"))

    @builtins.property
    @jsii.member(jsii_name="diameterVarInput")
    def diameter_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "diameterVarInput"))

    @builtins.property
    @jsii.member(jsii_name="transformationInput")
    def transformation_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageCircleImageTransformation"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageCircleImageTransformation"], jsii.get(self, "transformationInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__21659c6495e17879f75ae64777dbc2f9d01c6a81c3ef79e5911fd1397ac6f4a4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__db9ced955c3ad9db6e6038668e0cb1ddb8e9f43eec3ddd25c647a80aa2df99ad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="diameter")
    def diameter(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "diameter"))

    @diameter.setter
    def diameter(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1d4963e950f8e2775a600969daf2300bef20d1eddd276f2232004ae7b66916ad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "diameter", value)

    @builtins.property
    @jsii.member(jsii_name="diameterVar")
    def diameter_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "diameterVar"))

    @diameter_var.setter
    def diameter_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a0342eb122174c4c1681c146e51ba0aaf6f154f6b737c9d1323e47f38e2f2bc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "diameterVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c8478ca0bccb4c0ede372f38e5d6f28a880377b061e8d7f6afb5de75998f5943)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3bf40e65e6f6f4977ffcc4b0664c83ebfb4ab911726095f7b32d713111b7cf5d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageCircleImage]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageCircleImage]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageCircleImage]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__25743d79e34d84ba6566d777fa447af914734328279d20fd7003da98638aca23)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageCircleImageTransformation",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageCircleImageTransformation:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageCircleImageTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageCircleImageTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageCircleImageTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f6078da358540c1fa75dd0adb23e1da25804cd91caf2cc8e89d14788fe0d732c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageCircleImageTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageCircleImageTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageCircleImageTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__109b8a6a5130060608c04f06a3491c8f141351c44f16626611e43ebc8d6ab3ee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__95c107d6416695e2d67c93babea96bad4df8f72ee49f6913fa0b533ed9bd9634)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putBoxImage")
    def put_box_image(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageBoxImage, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac9f6b4403263fb3ce95fdecb95f2e6bcb3a8f47d8e80454b84d314c02de1617)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBoxImage", [value]))

    @jsii.member(jsii_name="putCircleImage")
    def put_circle_image(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageCircleImage, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af9e387618ca75d630775a924c59efe6b4e651c641e82bff22861cf0a1126dcf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCircleImage", [value]))

    @jsii.member(jsii_name="putTextImage")
    def put_text_image(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageTextImage", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__55fbdb25e9ac488b9d6c34a243e9953e8518bd9e2fbb70cd00cdcb9a57300573)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTextImage", [value]))

    @jsii.member(jsii_name="putUrlImage")
    def put_url_image(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageUrlImage", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__73f611426fdd24506d8aaa52adf6f7440c9c8b85be7762104c82f781b95cd4b1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putUrlImage", [value]))

    @jsii.member(jsii_name="resetBoxImage")
    def reset_box_image(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBoxImage", []))

    @jsii.member(jsii_name="resetCircleImage")
    def reset_circle_image(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCircleImage", []))

    @jsii.member(jsii_name="resetTextImage")
    def reset_text_image(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTextImage", []))

    @jsii.member(jsii_name="resetUrlImage")
    def reset_url_image(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUrlImage", []))

    @builtins.property
    @jsii.member(jsii_name="boxImage")
    def box_image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageBoxImageList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageBoxImageList, jsii.get(self, "boxImage"))

    @builtins.property
    @jsii.member(jsii_name="circleImage")
    def circle_image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageCircleImageList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageCircleImageList, jsii.get(self, "circleImage"))

    @builtins.property
    @jsii.member(jsii_name="textImage")
    def text_image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageTextImageList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageTextImageList", jsii.get(self, "textImage"))

    @builtins.property
    @jsii.member(jsii_name="urlImage")
    def url_image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageUrlImageList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageUrlImageList", jsii.get(self, "urlImage"))

    @builtins.property
    @jsii.member(jsii_name="boxImageInput")
    def box_image_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageBoxImage]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageBoxImage]]], jsii.get(self, "boxImageInput"))

    @builtins.property
    @jsii.member(jsii_name="circleImageInput")
    def circle_image_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageCircleImage]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageCircleImage]]], jsii.get(self, "circleImageInput"))

    @builtins.property
    @jsii.member(jsii_name="textImageInput")
    def text_image_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageTextImage"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageTextImage"]]], jsii.get(self, "textImageInput"))

    @builtins.property
    @jsii.member(jsii_name="urlImageInput")
    def url_image_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageUrlImage"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageUrlImage"]]], jsii.get(self, "urlImageInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__31cb46047b9b4853d5be49689402d314dffe2a428474f15b687c63915c6f896c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageTextImage",
    jsii_struct_bases=[],
    name_mapping={
        "fill": "fill",
        "fill_var": "fillVar",
        "size": "size",
        "size_var": "sizeVar",
        "stroke": "stroke",
        "stroke_size": "strokeSize",
        "stroke_size_var": "strokeSizeVar",
        "stroke_var": "strokeVar",
        "text": "text",
        "text_var": "textVar",
        "transformation": "transformation",
        "typeface": "typeface",
        "typeface_var": "typefaceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageTextImage:
    def __init__(
        self,
        *,
        fill: typing.Optional[builtins.str] = None,
        fill_var: typing.Optional[builtins.str] = None,
        size: typing.Optional[builtins.str] = None,
        size_var: typing.Optional[builtins.str] = None,
        stroke: typing.Optional[builtins.str] = None,
        stroke_size: typing.Optional[builtins.str] = None,
        stroke_size_var: typing.Optional[builtins.str] = None,
        stroke_var: typing.Optional[builtins.str] = None,
        text: typing.Optional[builtins.str] = None,
        text_var: typing.Optional[builtins.str] = None,
        transformation: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageTextImageTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        typeface: typing.Optional[builtins.str] = None,
        typeface_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fill: The main fill color of the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill DataAkamaiImagingPolicyImage#fill}
        :param fill_var: The main fill color of the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_var DataAkamaiImagingPolicyImage#fill_var}
        :param size: The size in pixels to render the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#size DataAkamaiImagingPolicyImage#size}
        :param size_var: The size in pixels to render the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#size_var DataAkamaiImagingPolicyImage#size_var}
        :param stroke: The color for the outline of the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke DataAkamaiImagingPolicyImage#stroke}
        :param stroke_size: The thickness in points for the outline of the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_size DataAkamaiImagingPolicyImage#stroke_size}
        :param stroke_size_var: The thickness in points for the outline of the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_size_var DataAkamaiImagingPolicyImage#stroke_size_var}
        :param stroke_var: The color for the outline of the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_var DataAkamaiImagingPolicyImage#stroke_var}
        :param text: The line of text to render. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text DataAkamaiImagingPolicyImage#text}
        :param text_var: The line of text to render. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text_var DataAkamaiImagingPolicyImage#text_var}
        :param transformation: transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        :param typeface: The font family to apply to the text image. This may be a URL to a TrueType or WOFF (v1) typeface, or a string that refers to one of the standard built-in browser fonts. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#typeface DataAkamaiImagingPolicyImage#typeface}
        :param typeface_var: The font family to apply to the text image. This may be a URL to a TrueType or WOFF (v1) typeface, or a string that refers to one of the standard built-in browser fonts. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#typeface_var DataAkamaiImagingPolicyImage#typeface_var}
        '''
        if isinstance(transformation, dict):
            transformation = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageTextImageTransformation(**transformation)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fd9e9a53059db0568e4d94bc81e3811080d2b81840437092cce5b5bd644ff035)
            check_type(argname="argument fill", value=fill, expected_type=type_hints["fill"])
            check_type(argname="argument fill_var", value=fill_var, expected_type=type_hints["fill_var"])
            check_type(argname="argument size", value=size, expected_type=type_hints["size"])
            check_type(argname="argument size_var", value=size_var, expected_type=type_hints["size_var"])
            check_type(argname="argument stroke", value=stroke, expected_type=type_hints["stroke"])
            check_type(argname="argument stroke_size", value=stroke_size, expected_type=type_hints["stroke_size"])
            check_type(argname="argument stroke_size_var", value=stroke_size_var, expected_type=type_hints["stroke_size_var"])
            check_type(argname="argument stroke_var", value=stroke_var, expected_type=type_hints["stroke_var"])
            check_type(argname="argument text", value=text, expected_type=type_hints["text"])
            check_type(argname="argument text_var", value=text_var, expected_type=type_hints["text_var"])
            check_type(argname="argument transformation", value=transformation, expected_type=type_hints["transformation"])
            check_type(argname="argument typeface", value=typeface, expected_type=type_hints["typeface"])
            check_type(argname="argument typeface_var", value=typeface_var, expected_type=type_hints["typeface_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fill is not None:
            self._values["fill"] = fill
        if fill_var is not None:
            self._values["fill_var"] = fill_var
        if size is not None:
            self._values["size"] = size
        if size_var is not None:
            self._values["size_var"] = size_var
        if stroke is not None:
            self._values["stroke"] = stroke
        if stroke_size is not None:
            self._values["stroke_size"] = stroke_size
        if stroke_size_var is not None:
            self._values["stroke_size_var"] = stroke_size_var
        if stroke_var is not None:
            self._values["stroke_var"] = stroke_var
        if text is not None:
            self._values["text"] = text
        if text_var is not None:
            self._values["text_var"] = text_var
        if transformation is not None:
            self._values["transformation"] = transformation
        if typeface is not None:
            self._values["typeface"] = typeface
        if typeface_var is not None:
            self._values["typeface_var"] = typeface_var

    @builtins.property
    def fill(self) -> typing.Optional[builtins.str]:
        '''The main fill color of the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill DataAkamaiImagingPolicyImage#fill}
        '''
        result = self._values.get("fill")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fill_var(self) -> typing.Optional[builtins.str]:
        '''The main fill color of the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_var DataAkamaiImagingPolicyImage#fill_var}
        '''
        result = self._values.get("fill_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def size(self) -> typing.Optional[builtins.str]:
        '''The size in pixels to render the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#size DataAkamaiImagingPolicyImage#size}
        '''
        result = self._values.get("size")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def size_var(self) -> typing.Optional[builtins.str]:
        '''The size in pixels to render the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#size_var DataAkamaiImagingPolicyImage#size_var}
        '''
        result = self._values.get("size_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def stroke(self) -> typing.Optional[builtins.str]:
        '''The color for the outline of the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke DataAkamaiImagingPolicyImage#stroke}
        '''
        result = self._values.get("stroke")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def stroke_size(self) -> typing.Optional[builtins.str]:
        '''The thickness in points for the outline of the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_size DataAkamaiImagingPolicyImage#stroke_size}
        '''
        result = self._values.get("stroke_size")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def stroke_size_var(self) -> typing.Optional[builtins.str]:
        '''The thickness in points for the outline of the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_size_var DataAkamaiImagingPolicyImage#stroke_size_var}
        '''
        result = self._values.get("stroke_size_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def stroke_var(self) -> typing.Optional[builtins.str]:
        '''The color for the outline of the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_var DataAkamaiImagingPolicyImage#stroke_var}
        '''
        result = self._values.get("stroke_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def text(self) -> typing.Optional[builtins.str]:
        '''The line of text to render.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text DataAkamaiImagingPolicyImage#text}
        '''
        result = self._values.get("text")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def text_var(self) -> typing.Optional[builtins.str]:
        '''The line of text to render.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text_var DataAkamaiImagingPolicyImage#text_var}
        '''
        result = self._values.get("text_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def transformation(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageTextImageTransformation"]:
        '''transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        '''
        result = self._values.get("transformation")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageTextImageTransformation"], result)

    @builtins.property
    def typeface(self) -> typing.Optional[builtins.str]:
        '''The font family to apply to the text image.

        This may be a URL to a TrueType or WOFF (v1) typeface, or a string that refers to one of the standard built-in browser fonts.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#typeface DataAkamaiImagingPolicyImage#typeface}
        '''
        result = self._values.get("typeface")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def typeface_var(self) -> typing.Optional[builtins.str]:
        '''The font family to apply to the text image.

        This may be a URL to a TrueType or WOFF (v1) typeface, or a string that refers to one of the standard built-in browser fonts.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#typeface_var DataAkamaiImagingPolicyImage#typeface_var}
        '''
        result = self._values.get("typeface_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageTextImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageTextImageList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageTextImageList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e33218c375629da17ce8c210fd61390a65fd2eaf54a4c5a4c808a8cc3c960a28)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageTextImageOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__01bb5551bcd4f1f6d6c9bae19d6b3002a8dbc4cd40ef83e85aa8a882d791cd1f)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageTextImageOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5db4aab7523e612b78834740760491020937dee91b9baf9a4574b39a6dd90c8a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__97bf1d80f7ec9712a1c7799cc5d2662d96c1a4ae8750541a6878868eb0bc350a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c6ad3931c475b2b66d9a98e56253ea383d116e6bcf55436682260f636ec3dda7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageTextImage]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageTextImage]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageTextImage]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c92608ff385af19719349a74b82b489cb16765c37fddad2e4de436df9f103fc5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageTextImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageTextImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8f813e5d42cbeeb55a0b42aac4442432147226e2048d38f5dd6ccd1b6680e892)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformation")
    def put_transformation(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageTextImageTransformation()

        return typing.cast(None, jsii.invoke(self, "putTransformation", [value]))

    @jsii.member(jsii_name="resetFill")
    def reset_fill(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFill", []))

    @jsii.member(jsii_name="resetFillVar")
    def reset_fill_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFillVar", []))

    @jsii.member(jsii_name="resetSize")
    def reset_size(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSize", []))

    @jsii.member(jsii_name="resetSizeVar")
    def reset_size_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSizeVar", []))

    @jsii.member(jsii_name="resetStroke")
    def reset_stroke(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStroke", []))

    @jsii.member(jsii_name="resetStrokeSize")
    def reset_stroke_size(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStrokeSize", []))

    @jsii.member(jsii_name="resetStrokeSizeVar")
    def reset_stroke_size_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStrokeSizeVar", []))

    @jsii.member(jsii_name="resetStrokeVar")
    def reset_stroke_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStrokeVar", []))

    @jsii.member(jsii_name="resetText")
    def reset_text(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetText", []))

    @jsii.member(jsii_name="resetTextVar")
    def reset_text_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTextVar", []))

    @jsii.member(jsii_name="resetTransformation")
    def reset_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformation", []))

    @jsii.member(jsii_name="resetTypeface")
    def reset_typeface(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeface", []))

    @jsii.member(jsii_name="resetTypefaceVar")
    def reset_typeface_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypefaceVar", []))

    @builtins.property
    @jsii.member(jsii_name="transformation")
    def transformation(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageTextImageTransformationOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageTextImageTransformationOutputReference", jsii.get(self, "transformation"))

    @builtins.property
    @jsii.member(jsii_name="fillInput")
    def fill_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fillInput"))

    @builtins.property
    @jsii.member(jsii_name="fillVarInput")
    def fill_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fillVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sizeInput")
    def size_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sizeInput"))

    @builtins.property
    @jsii.member(jsii_name="sizeVarInput")
    def size_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sizeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="strokeInput")
    def stroke_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "strokeInput"))

    @builtins.property
    @jsii.member(jsii_name="strokeSizeInput")
    def stroke_size_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "strokeSizeInput"))

    @builtins.property
    @jsii.member(jsii_name="strokeSizeVarInput")
    def stroke_size_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "strokeSizeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="strokeVarInput")
    def stroke_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "strokeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="textInput")
    def text_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "textInput"))

    @builtins.property
    @jsii.member(jsii_name="textVarInput")
    def text_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "textVarInput"))

    @builtins.property
    @jsii.member(jsii_name="transformationInput")
    def transformation_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageTextImageTransformation"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageTextImageTransformation"], jsii.get(self, "transformationInput"))

    @builtins.property
    @jsii.member(jsii_name="typefaceInput")
    def typeface_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typefaceInput"))

    @builtins.property
    @jsii.member(jsii_name="typefaceVarInput")
    def typeface_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typefaceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="fill")
    def fill(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fill"))

    @fill.setter
    def fill(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0adf52ad268b7b09edc548deb1abb665340ef8446dafe4d63d8364becb93a236)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fill", value)

    @builtins.property
    @jsii.member(jsii_name="fillVar")
    def fill_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fillVar"))

    @fill_var.setter
    def fill_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__36ee2a3756c45fbcf3d21927bbf2c8de4ec8005521cff3b79ae8865816325019)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fillVar", value)

    @builtins.property
    @jsii.member(jsii_name="size")
    def size(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "size"))

    @size.setter
    def size(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d478b1b4f61c9bc9d194af37791483658db9e4e9a7957c99876f67c74eacf85e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "size", value)

    @builtins.property
    @jsii.member(jsii_name="sizeVar")
    def size_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sizeVar"))

    @size_var.setter
    def size_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc3d6865cee15216ddb1fd13d02ad688da61ef1298422bd0e4ce55b321ddf9e4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sizeVar", value)

    @builtins.property
    @jsii.member(jsii_name="stroke")
    def stroke(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "stroke"))

    @stroke.setter
    def stroke(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__66682727ebac19f8247948be40ff03c8363e0d1315dd2ae5960ab598b671a12d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "stroke", value)

    @builtins.property
    @jsii.member(jsii_name="strokeSize")
    def stroke_size(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "strokeSize"))

    @stroke_size.setter
    def stroke_size(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ad1455aaac0416ee08400c5bd3ef0984f00dd7ae8c4b6fbfd0f8de5f15272af)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "strokeSize", value)

    @builtins.property
    @jsii.member(jsii_name="strokeSizeVar")
    def stroke_size_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "strokeSizeVar"))

    @stroke_size_var.setter
    def stroke_size_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cf151f95cc44446a4c94499325da42d824a5ce6258c9bc59c2d58cdc3b7303f3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "strokeSizeVar", value)

    @builtins.property
    @jsii.member(jsii_name="strokeVar")
    def stroke_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "strokeVar"))

    @stroke_var.setter
    def stroke_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__de56c5dad54b99c472487834c05353db93a2343673d997970beef43c329224e5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "strokeVar", value)

    @builtins.property
    @jsii.member(jsii_name="text")
    def text(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "text"))

    @text.setter
    def text(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4efcdf4d371cc1cf48976a7c04de9db1b71507cc81c6a3dc2a83b7fcc5472390)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "text", value)

    @builtins.property
    @jsii.member(jsii_name="textVar")
    def text_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "textVar"))

    @text_var.setter
    def text_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ad759d56b25c4e495520aef9ec17ace53fc4368bc9588c84a271a4cd95f51d01)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "textVar", value)

    @builtins.property
    @jsii.member(jsii_name="typeface")
    def typeface(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeface"))

    @typeface.setter
    def typeface(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c005db85bb438c917fe3873c1f18b3aa6ba1b881006f5636f7c891a29feea761)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeface", value)

    @builtins.property
    @jsii.member(jsii_name="typefaceVar")
    def typeface_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typefaceVar"))

    @typeface_var.setter
    def typeface_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b64c4419e2742a4100d736b6a7e890d966ae84b7e6e2a888c1393ba08c47c60c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typefaceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageTextImage]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageTextImage]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageTextImage]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e65fb1507ce4e4f331e43cd857ee736882c766b1a5a6341e6c0115acdb76a7cd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageTextImageTransformation",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageTextImageTransformation:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageTextImageTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageTextImageTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageTextImageTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__96bfa45dddb3b4a070286923e694853f575e1cd3571383e00361eecba7219c1d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageTextImageTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageTextImageTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageTextImageTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bfa8936bb10a450be3a616af85b08c9775262a88fdec1a1110f4d1fa36227406)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageUrlImage",
    jsii_struct_bases=[],
    name_mapping={
        "transformation": "transformation",
        "url": "url",
        "url_var": "urlVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageUrlImage:
    def __init__(
        self,
        *,
        transformation: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageUrlImageTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        url: typing.Optional[builtins.str] = None,
        url_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param transformation: transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        :param url: The URL of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url DataAkamaiImagingPolicyImage#url}
        :param url_var: The URL of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url_var DataAkamaiImagingPolicyImage#url_var}
        '''
        if isinstance(transformation, dict):
            transformation = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageUrlImageTransformation(**transformation)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a8e517970b2aeb29f6766c3b780b5e2874d79281c58793f9226c3faa3261c304)
            check_type(argname="argument transformation", value=transformation, expected_type=type_hints["transformation"])
            check_type(argname="argument url", value=url, expected_type=type_hints["url"])
            check_type(argname="argument url_var", value=url_var, expected_type=type_hints["url_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if transformation is not None:
            self._values["transformation"] = transformation
        if url is not None:
            self._values["url"] = url
        if url_var is not None:
            self._values["url_var"] = url_var

    @builtins.property
    def transformation(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageUrlImageTransformation"]:
        '''transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        '''
        result = self._values.get("transformation")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageUrlImageTransformation"], result)

    @builtins.property
    def url(self) -> typing.Optional[builtins.str]:
        '''The URL of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url DataAkamaiImagingPolicyImage#url}
        '''
        result = self._values.get("url")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def url_var(self) -> typing.Optional[builtins.str]:
        '''The URL of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url_var DataAkamaiImagingPolicyImage#url_var}
        '''
        result = self._values.get("url_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageUrlImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageUrlImageList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageUrlImageList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f6ce6b90e41f4ad419b1ce05fcd91e991959c915f8142b848de90e7794034cb1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageUrlImageOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0a171feaa1ac60537c231872e515615fcd6b81453dfffc72ef29401f076531bb)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageUrlImageOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e7bfcda02b9092db8d1e94b439a33e7f7fe2f108d2e2e3d2194c06681d5309c7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__15228d8edade5b594a133122feb6b052cc85b2bb43dabde6b4cf5d6ab6fdfc37)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2217b04abc5577041d3be3d71debbe6be7692f00c2f86a579b623762ed9f913a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageUrlImage]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageUrlImage]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageUrlImage]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3b307a65d217631af08818de70cd8e3628f771ce73044625de6d534f21c42523)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageUrlImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageUrlImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__adf9c69c2f83261cf88305a2c8726e2ce8766e8c51a069994c56fcce54939441)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformation")
    def put_transformation(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageUrlImageTransformation()

        return typing.cast(None, jsii.invoke(self, "putTransformation", [value]))

    @jsii.member(jsii_name="resetTransformation")
    def reset_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformation", []))

    @jsii.member(jsii_name="resetUrl")
    def reset_url(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUrl", []))

    @jsii.member(jsii_name="resetUrlVar")
    def reset_url_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUrlVar", []))

    @builtins.property
    @jsii.member(jsii_name="transformation")
    def transformation(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageUrlImageTransformationOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageUrlImageTransformationOutputReference", jsii.get(self, "transformation"))

    @builtins.property
    @jsii.member(jsii_name="transformationInput")
    def transformation_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageUrlImageTransformation"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageUrlImageTransformation"], jsii.get(self, "transformationInput"))

    @builtins.property
    @jsii.member(jsii_name="urlInput")
    def url_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "urlInput"))

    @builtins.property
    @jsii.member(jsii_name="urlVarInput")
    def url_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "urlVarInput"))

    @builtins.property
    @jsii.member(jsii_name="url")
    def url(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "url"))

    @url.setter
    def url(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1b6eba80ef45f26e82f03cc9eb4443e53a8077a91357327d232c61992f3cca31)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "url", value)

    @builtins.property
    @jsii.member(jsii_name="urlVar")
    def url_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "urlVar"))

    @url_var.setter
    def url_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d67e3635217803c4b72afeb84049e9425d0c4c32b0e22ea9c51a77a36f9de51b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "urlVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageUrlImage]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageUrlImage]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageUrlImage]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e0ee104a352e383e938ef2f87bcdadfece90bed2af2f16f7517ff489b1cdd19b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageUrlImageTransformation",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageUrlImageTransformation:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageUrlImageTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageUrlImageTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageUrlImageTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ce0616debc6ad815f89cdf0cdc863c9f53abd8653f8801ccee073a8b192682ec)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageUrlImageTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageUrlImageTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageUrlImageTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__07fe6321c38a2f3449bd599ed6f432c0ff7383f926a513ca482475e7e391f3bf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e1b4a13d538532ce92542ef44576ea784c0e7e38cd6520372f921e5f90693fb3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2492dcd28ad8c68477bfe239608f5787784ba830eb5685afa3f904456192edd4)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eb4c1613b1d81399563e7e1d1f76834ff4c9c21ceb036b80687ebf714b89deac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f77be8a6c9f9c0a103356e555a79d61610b8b1fe27f98b124c339a7e2d1b038c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__59ec88c2a562f3fdd7ff4f4f770f64a1e8ffb2169cfa28d08e886b5acdf02cc8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppend]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppend]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppend]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1d71ee652c49e35f35f7540c4d929bbde3063643e79db546be9be8910caae995)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__40601103598d0244a27efdf941081df01a963b708b6907de5f818a0f4826d92d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(
        self,
        *,
        box_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageBoxImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
        circle_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageCircleImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
        text_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageTextImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
        url_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageUrlImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param box_image: box_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#box_image DataAkamaiImagingPolicyImage#box_image}
        :param circle_image: circle_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#circle_image DataAkamaiImagingPolicyImage#circle_image}
        :param text_image: text_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text_image DataAkamaiImagingPolicyImage#text_image}
        :param url_image: url_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url_image DataAkamaiImagingPolicyImage#url_image}
        '''
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImage(
            box_image=box_image,
            circle_image=circle_image,
            text_image=text_image,
            url_image=url_image,
        )

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityPriority")
    def reset_gravity_priority(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityPriority", []))

    @jsii.member(jsii_name="resetGravityPriorityVar")
    def reset_gravity_priority_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityPriorityVar", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPreserveMinorDimension")
    def reset_preserve_minor_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPreserveMinorDimension", []))

    @jsii.member(jsii_name="resetPreserveMinorDimensionVar")
    def reset_preserve_minor_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPreserveMinorDimensionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityInput")
    def gravity_priority_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityPriorityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityVarInput")
    def gravity_priority_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityPriorityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionInput")
    def preserve_minor_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "preserveMinorDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionVarInput")
    def preserve_minor_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "preserveMinorDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5b0a42d186355cc601ac17fd1093053c4c962110f835720b9f24940ea6b98214)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityPriority")
    def gravity_priority(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityPriority"))

    @gravity_priority.setter
    def gravity_priority(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d766bb898ac6f4ac994459f5f0bdc35e2f773d63528b598cb229888398213ad0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityPriority", value)

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityVar")
    def gravity_priority_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityPriorityVar"))

    @gravity_priority_var.setter
    def gravity_priority_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a432129628caf296113362176c71ebc98a453af60dd75b20cc7bfe0ebab6ad35)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityPriorityVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9042eea107e045ea13d4f2bb8434b1b90a6f8072d5dee58d10ce497c8605eb24)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimension")
    def preserve_minor_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "preserveMinorDimension"))

    @preserve_minor_dimension.setter
    def preserve_minor_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a73a2face045b29c41ba8841e83f0daa2801383e679ce5b361694245b36d56e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "preserveMinorDimension", value)

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionVar")
    def preserve_minor_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "preserveMinorDimensionVar"))

    @preserve_minor_dimension_var.setter
    def preserve_minor_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa5d8db7aed98a760907ec76f209cb8fc2c647bbb1196754e90a8ae78c4ed177)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "preserveMinorDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppend]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppend]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppend]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__42d8c0a3eadd4a1758793f5826f433220a9e54fe23a46b7fc8819469c0c54e97)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAspectCrop",
    jsii_struct_bases=[],
    name_mapping={
        "allow_expansion": "allowExpansion",
        "allow_expansion_var": "allowExpansionVar",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAspectCrop:
    def __init__(
        self,
        *,
        allow_expansion: typing.Optional[builtins.str] = None,
        allow_expansion_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_expansion: Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image. Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        :param allow_expansion_var: Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image. Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        :param height: The height term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The width term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        :param x_position: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__453c2aab0936625c633757a38a6aa6b7c6d452610df98513b2eb04d0cb201f2c)
            check_type(argname="argument allow_expansion", value=allow_expansion, expected_type=type_hints["allow_expansion"])
            check_type(argname="argument allow_expansion_var", value=allow_expansion_var, expected_type=type_hints["allow_expansion_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if allow_expansion is not None:
            self._values["allow_expansion"] = allow_expansion
        if allow_expansion_var is not None:
            self._values["allow_expansion_var"] = allow_expansion_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def allow_expansion(self) -> typing.Optional[builtins.str]:
        '''Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image.

        Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        '''
        result = self._values.get("allow_expansion")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def allow_expansion_var(self) -> typing.Optional[builtins.str]:
        '''Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image.

        Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        '''
        result = self._values.get("allow_expansion_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAspectCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAspectCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAspectCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ba34637879def9260498aa967f199f4e7fa4821ea7cf5abefb55b0ce830942e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAspectCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c2becdd00a4eba52fd4684127947ddb96750f38fda081621087768ff4d14ce22)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAspectCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c3507394c626e7429b6b081f6f9bc2e45ef25c4ba4fe84143d3185f1f74f3e09)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__561fa1ab0238f82f93aea942fc011a85c4b710d85cce2bb10af354d93cc59370)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__054aad885b28fe8e32bbd39ea12ab5c744982b18c099ab2e3c89126f81f2b0dc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAspectCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAspectCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAspectCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ab7140dd049b5189ded9e82c0327e587ddddec6d444a9039cee6ad6ee151f08)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAspectCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAspectCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5af7cee8f38484a4760a5211e344679be113f73f5019502d5e7ec6912a43ea7d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAllowExpansion")
    def reset_allow_expansion(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansion", []))

    @jsii.member(jsii_name="resetAllowExpansionVar")
    def reset_allow_expansion_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansionVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionInput")
    def allow_expansion_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVarInput")
    def allow_expansion_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansion")
    def allow_expansion(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansion"))

    @allow_expansion.setter
    def allow_expansion(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2698948602d4ace4cf75375733a6079a428e2361f386ff52bed934903f85f681)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansion", value)

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVar")
    def allow_expansion_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansionVar"))

    @allow_expansion_var.setter
    def allow_expansion_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6d4b8ac087384024f752a8bc8a200447100a6548dc5c8c6970192573b5a31a98)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansionVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a85ebd23f65bdd0c81c8b6a4b8f756558af9cd946c274e605e27457062a41c1f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3f77f667b5067babbf27016179cfa88b07e33d73c926747f54ebbb1833490ef4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c88a04c3b060cb34faaaa11d7f62fcede4f6c5efa9f2c8dc92914bd444f634d8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__957545e633effc653eda3e56f57a1f0c551565e334e0573916dfae06d2db0d60)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__36f5fcf76ef1cd001e6c30fe23bfe0ec2ecc851d51e95e4c72c927afcfdbe7e6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f4c5f5edf9651d6a36f88573bf3a06b0ce406bffaa7e19e6e89bc3ebc93c2ad4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__90b7a606db5f1c5aab659c46e15d44a0093079568f16ae0f8703173316da63be)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__86b75132306d95572bb917901230b2b68e4dda63537e753c6d2ecaf5ebe37a7d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAspectCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAspectCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAspectCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__725b2d1bed00cd21054b5607e7da537943a6b8d595fb4920e5a4bfeb93f2c38d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanBackgroundColor",
    jsii_struct_bases=[],
    name_mapping={"color": "color", "color_var": "colorVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanBackgroundColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ad92520c3d958829627fdf3f85a3cf56c3b042aa596abe270dd038f2b3bed17f)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanBackgroundColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanBackgroundColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanBackgroundColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8aeb05ea020bcd4a108d7bf1acaa542b1d745e933bcc477ccd2f963394b1cc98)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanBackgroundColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dc7f9fc43242c49bf15400fe04a4474ae01e58063930b99973988230007e7850)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanBackgroundColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9952003e5a3d404045d1d907d28430cb852368cefce654847147e658261316d0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__860ac4bf5b031ab8cbe85a3b13e4d6bde715e8751f6a0a9604c7c55b7c2fb098)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__10eb40b39d7093150c3be5a821bdfda830ff51e020c746b450b4dd09c522c7c2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanBackgroundColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanBackgroundColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e0b279d47a7839897ecb0329e22be3884b523ada2c4daf8d61232671a79d1ef5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanBackgroundColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanBackgroundColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3c87116636b4619cab6bb167c99ae2b490c3785b8937f292d102db31795c82f2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__241610105aa852aa295bb2f862f040efa8b2ea9481c410dc510cb36ce5ebba5f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a6c2992e5eb5035a0145d37947c2c8b20d81ef0dbcab6b7b40df25a6f407f791)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanBackgroundColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanBackgroundColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanBackgroundColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c7bacb51bf81953035154bf362c0d9bd74e5a953d864d8b6b36e3e0cfce709f7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanBlur",
    jsii_struct_bases=[],
    name_mapping={"sigma": "sigma", "sigma_var": "sigmaVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanBlur:
    def __init__(
        self,
        *,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param sigma: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__765ee1420db4181c66e1614c9b4d658240d1263dbf13b500fa5117e0c13266b5)
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanBlur(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanBlurList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanBlurList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__25665964bea09f31725a25d7ba9e40888a17a86ef82c3e38789cf98d018e47de)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanBlurOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f3db2964b66a6d600bfad30c31b738c97488826c99ec89ea0babfcc4003b1e6d)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanBlurOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bea3bcad117b74d9a632522c7a9f3ccb2386df591fd125e73b699af80231e1ae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b655026b51833fcc929808dab36327d9aa9270163bd8c0b6240454a1023b6989)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9090343e24d4b1ab263125605fd9129bb0be3fa701a060a1b5435b0317269b26)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanBlur]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanBlur]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__84e21db75d92925974f3d4c6ebc65894308826634b9a86a0e2059c28ea45e3b3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanBlurOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanBlurOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__77bd72b2c189e1f0b3ba2d8fcad63478917620b61683877e62f7f6554eaecf96)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7da8650234d8e3c16e11a2ded7e3e8598aacab37708f4af0d6f8d6e035074385)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4f62d398a6b8ded0642ce13d5eee93c5f75f6df9976d98f9697d7847149d29c2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanBlur]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanBlur]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanBlur]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__387f2c8c85a359643210792a45ed39a62dc09c4af550e9f8a5bdb435d6216d57)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanChromaKey",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_feather": "hueFeather",
        "hue_feather_var": "hueFeatherVar",
        "hue_tolerance": "hueTolerance",
        "hue_tolerance_var": "hueToleranceVar",
        "hue_var": "hueVar",
        "lightness_feather": "lightnessFeather",
        "lightness_feather_var": "lightnessFeatherVar",
        "lightness_tolerance": "lightnessTolerance",
        "lightness_tolerance_var": "lightnessToleranceVar",
        "saturation_feather": "saturationFeather",
        "saturation_feather_var": "saturationFeatherVar",
        "saturation_tolerance": "saturationTolerance",
        "saturation_tolerance_var": "saturationToleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanChromaKey:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_feather: typing.Optional[builtins.str] = None,
        hue_feather_var: typing.Optional[builtins.str] = None,
        hue_tolerance: typing.Optional[builtins.str] = None,
        hue_tolerance_var: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness_feather: typing.Optional[builtins.str] = None,
        lightness_feather_var: typing.Optional[builtins.str] = None,
        lightness_tolerance: typing.Optional[builtins.str] = None,
        lightness_tolerance_var: typing.Optional[builtins.str] = None,
        saturation_feather: typing.Optional[builtins.str] = None,
        saturation_feather_var: typing.Optional[builtins.str] = None,
        saturation_tolerance: typing.Optional[builtins.str] = None,
        saturation_tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_feather: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        :param hue_feather_var: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        :param hue_tolerance: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        :param hue_tolerance_var: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        :param hue_var: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness_feather: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        :param lightness_feather_var: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        :param lightness_tolerance: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        :param lightness_tolerance_var: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        :param saturation_feather: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        :param saturation_feather_var: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        :param saturation_tolerance: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        :param saturation_tolerance_var: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4b2cfb86c9a2c78f9f8dc43c7531f942f3e0128df655b7a51f3d884a75512deb)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_feather", value=hue_feather, expected_type=type_hints["hue_feather"])
            check_type(argname="argument hue_feather_var", value=hue_feather_var, expected_type=type_hints["hue_feather_var"])
            check_type(argname="argument hue_tolerance", value=hue_tolerance, expected_type=type_hints["hue_tolerance"])
            check_type(argname="argument hue_tolerance_var", value=hue_tolerance_var, expected_type=type_hints["hue_tolerance_var"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness_feather", value=lightness_feather, expected_type=type_hints["lightness_feather"])
            check_type(argname="argument lightness_feather_var", value=lightness_feather_var, expected_type=type_hints["lightness_feather_var"])
            check_type(argname="argument lightness_tolerance", value=lightness_tolerance, expected_type=type_hints["lightness_tolerance"])
            check_type(argname="argument lightness_tolerance_var", value=lightness_tolerance_var, expected_type=type_hints["lightness_tolerance_var"])
            check_type(argname="argument saturation_feather", value=saturation_feather, expected_type=type_hints["saturation_feather"])
            check_type(argname="argument saturation_feather_var", value=saturation_feather_var, expected_type=type_hints["saturation_feather_var"])
            check_type(argname="argument saturation_tolerance", value=saturation_tolerance, expected_type=type_hints["saturation_tolerance"])
            check_type(argname="argument saturation_tolerance_var", value=saturation_tolerance_var, expected_type=type_hints["saturation_tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_feather is not None:
            self._values["hue_feather"] = hue_feather
        if hue_feather_var is not None:
            self._values["hue_feather_var"] = hue_feather_var
        if hue_tolerance is not None:
            self._values["hue_tolerance"] = hue_tolerance
        if hue_tolerance_var is not None:
            self._values["hue_tolerance_var"] = hue_tolerance_var
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness_feather is not None:
            self._values["lightness_feather"] = lightness_feather
        if lightness_feather_var is not None:
            self._values["lightness_feather_var"] = lightness_feather_var
        if lightness_tolerance is not None:
            self._values["lightness_tolerance"] = lightness_tolerance
        if lightness_tolerance_var is not None:
            self._values["lightness_tolerance_var"] = lightness_tolerance_var
        if saturation_feather is not None:
            self._values["saturation_feather"] = saturation_feather
        if saturation_feather_var is not None:
            self._values["saturation_feather_var"] = saturation_feather_var
        if saturation_tolerance is not None:
            self._values["saturation_tolerance"] = saturation_tolerance
        if saturation_tolerance_var is not None:
            self._values["saturation_tolerance_var"] = saturation_tolerance_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        '''
        result = self._values.get("hue_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        '''
        result = self._values.get("hue_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        '''
        result = self._values.get("hue_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        '''
        result = self._values.get("hue_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        '''
        result = self._values.get("lightness_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        '''
        result = self._values.get("lightness_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        '''
        result = self._values.get("lightness_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        '''
        result = self._values.get("lightness_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        '''
        result = self._values.get("saturation_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        '''
        result = self._values.get("saturation_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        '''
        result = self._values.get("saturation_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        result = self._values.get("saturation_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanChromaKey(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanChromaKeyList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanChromaKeyList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e3bd066caa78b9ee9517bbd919dfa37030e3ac6e34521bc1c2b8fb4bfee823e5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanChromaKeyOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__721dcdd8bf2cf639f8e97220430c12c4b78fe8fc4ebd91219611e2a3cb0e9602)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanChromaKeyOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e6bc09666492316fe51b352735aa5715f10d48130ee72142cd034573b1fb0ffd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c3a4268f21e17ba35a46ff64fee214fd1216aa9e4f71fa0e1ada43726c22181b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab7c29368721687713f4bf1d98658cac8b8aa4dbbf706f95bde8398b70d3b306)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanChromaKey]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanChromaKey]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b106eb1bc8ab38090e8448b53d4efd55d2151d21c19ea59f21a4d309e2a921cb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanChromaKeyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanChromaKeyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__81ae3a29e17e3d5c33403055c05f269a1a7c569ef97cf47699d48f4ec6c678a0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueFeather")
    def reset_hue_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeather", []))

    @jsii.member(jsii_name="resetHueFeatherVar")
    def reset_hue_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeatherVar", []))

    @jsii.member(jsii_name="resetHueTolerance")
    def reset_hue_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueTolerance", []))

    @jsii.member(jsii_name="resetHueToleranceVar")
    def reset_hue_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueToleranceVar", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightnessFeather")
    def reset_lightness_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeather", []))

    @jsii.member(jsii_name="resetLightnessFeatherVar")
    def reset_lightness_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeatherVar", []))

    @jsii.member(jsii_name="resetLightnessTolerance")
    def reset_lightness_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessTolerance", []))

    @jsii.member(jsii_name="resetLightnessToleranceVar")
    def reset_lightness_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessToleranceVar", []))

    @jsii.member(jsii_name="resetSaturationFeather")
    def reset_saturation_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeather", []))

    @jsii.member(jsii_name="resetSaturationFeatherVar")
    def reset_saturation_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeatherVar", []))

    @jsii.member(jsii_name="resetSaturationTolerance")
    def reset_saturation_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationTolerance", []))

    @jsii.member(jsii_name="resetSaturationToleranceVar")
    def reset_saturation_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherInput")
    def hue_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVarInput")
    def hue_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceInput")
    def hue_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVarInput")
    def hue_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherInput")
    def lightness_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVarInput")
    def lightness_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceInput")
    def lightness_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVarInput")
    def lightness_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherInput")
    def saturation_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVarInput")
    def saturation_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceInput")
    def saturation_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVarInput")
    def saturation_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6d665311965f1482e13a954894b20a6499750a24ce4cae1c830b7b76c0737261)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeather")
    def hue_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeather"))

    @hue_feather.setter
    def hue_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dd7535018f5b26d1e7f839b6e5d6140ef14aa97b58f7ea622ac4bc0f8b6369fe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeather", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVar")
    def hue_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeatherVar"))

    @hue_feather_var.setter
    def hue_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__155eae6c623bea6952327aa6df13ecf1808d9360e244a17c5490fccb018a0066)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueTolerance")
    def hue_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueTolerance"))

    @hue_tolerance.setter
    def hue_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d45bf9d3585084e279b1685da2ad7e85c98fa09fc52e944d2c7f7b43d2a25997)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVar")
    def hue_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueToleranceVar"))

    @hue_tolerance_var.setter
    def hue_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5a2f7fd69f2081dc91bfa97e4611618612ac79d17295e11f63527e716ee04b16)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2792ba8b7a3e4fc93722f8c314857741730c2399c85bb5461f1fa66b44075e51)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeather")
    def lightness_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeather"))

    @lightness_feather.setter
    def lightness_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__399ab8a95058813b7bbe366b09f30c58563071104263b17d64b4a4644b798aeb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeather", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVar")
    def lightness_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeatherVar"))

    @lightness_feather_var.setter
    def lightness_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b6c2044cca3de38d80bf39320b21e3c3a42cf69388e1df571f3b0528664da43e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessTolerance")
    def lightness_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessTolerance"))

    @lightness_tolerance.setter
    def lightness_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd67f98ca889d2deb09cddf7cda9be6fc3336bf96232e8302f2b4fada78d3cde)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVar")
    def lightness_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessToleranceVar"))

    @lightness_tolerance_var.setter
    def lightness_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__42784bc280ebe013bf66d54362a70b0c9d17b3f0a18c7804c445115d6014057d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeather")
    def saturation_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeather"))

    @saturation_feather.setter
    def saturation_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a13b8122268ac2a678d2f9a2beb6d9ca307be432bd834af46a4f1e723ef375cf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeather", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVar")
    def saturation_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeatherVar"))

    @saturation_feather_var.setter
    def saturation_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1aa66d3b11a69996f614fce53c1ce0c1d2bd31613c023a606e4cc7ecb96df2c8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationTolerance")
    def saturation_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationTolerance"))

    @saturation_tolerance.setter
    def saturation_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ee9251286ffd087d947d4fe707f675644171deabbce012ba042d20dd074c66be)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVar")
    def saturation_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationToleranceVar"))

    @saturation_tolerance_var.setter
    def saturation_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d02bd41881225e89337a42d07dda3221762a6fdf47d066525f59515490691198)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanChromaKey]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanChromaKey]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanChromaKey]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e6a428fa18241403ef4a2c59cf313d64dda597b13410987c17fca4066acbab07)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanComposite",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "placement": "placement",
        "placement_var": "placementVar",
        "scale": "scale",
        "scale_dimension": "scaleDimension",
        "scale_dimension_var": "scaleDimensionVar",
        "scale_var": "scaleVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanComposite:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        placement: typing.Optional[builtins.str] = None,
        placement_var: typing.Optional[builtins.str] = None,
        scale: typing.Optional[builtins.str] = None,
        scale_dimension: typing.Optional[builtins.str] = None,
        scale_dimension_var: typing.Optional[builtins.str] = None,
        scale_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param placement: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        :param placement_var: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        :param scale: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param scale_dimension: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        :param scale_dimension_var: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        :param scale_var: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        :param x_position: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e405bd375c34e3279eeb387aecdd13d8247ca63da4b2c8f707302b1b30769b6c)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument placement", value=placement, expected_type=type_hints["placement"])
            check_type(argname="argument placement_var", value=placement_var, expected_type=type_hints["placement_var"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument scale_dimension", value=scale_dimension, expected_type=type_hints["scale_dimension"])
            check_type(argname="argument scale_dimension_var", value=scale_dimension_var, expected_type=type_hints["scale_dimension_var"])
            check_type(argname="argument scale_var", value=scale_var, expected_type=type_hints["scale_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if placement is not None:
            self._values["placement"] = placement
        if placement_var is not None:
            self._values["placement_var"] = placement_var
        if scale is not None:
            self._values["scale"] = scale
        if scale_dimension is not None:
            self._values["scale_dimension"] = scale_dimension
        if scale_dimension_var is not None:
            self._values["scale_dimension_var"] = scale_dimension_var
        if scale_var is not None:
            self._values["scale_var"] = scale_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        '''
        result = self._values.get("placement")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement_var(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        '''
        result = self._values.get("placement_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        '''
        result = self._values.get("scale_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        '''
        result = self._values.get("scale_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        '''
        result = self._values.get("scale_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanComposite(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImage",
    jsii_struct_bases=[],
    name_mapping={
        "box_image": "boxImage",
        "circle_image": "circleImage",
        "text_image": "textImage",
        "url_image": "urlImage",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImage:
    def __init__(
        self,
        *,
        box_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageBoxImage", typing.Dict[builtins.str, typing.Any]]]]] = None,
        circle_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageCircleImage", typing.Dict[builtins.str, typing.Any]]]]] = None,
        text_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageTextImage", typing.Dict[builtins.str, typing.Any]]]]] = None,
        url_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageUrlImage", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param box_image: box_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#box_image DataAkamaiImagingPolicyImage#box_image}
        :param circle_image: circle_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#circle_image DataAkamaiImagingPolicyImage#circle_image}
        :param text_image: text_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text_image DataAkamaiImagingPolicyImage#text_image}
        :param url_image: url_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url_image DataAkamaiImagingPolicyImage#url_image}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__269961db8470e6d88f97190ae6488fa2e39c63ac470b4ea74ba5c4c70431627d)
            check_type(argname="argument box_image", value=box_image, expected_type=type_hints["box_image"])
            check_type(argname="argument circle_image", value=circle_image, expected_type=type_hints["circle_image"])
            check_type(argname="argument text_image", value=text_image, expected_type=type_hints["text_image"])
            check_type(argname="argument url_image", value=url_image, expected_type=type_hints["url_image"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if box_image is not None:
            self._values["box_image"] = box_image
        if circle_image is not None:
            self._values["circle_image"] = circle_image
        if text_image is not None:
            self._values["text_image"] = text_image
        if url_image is not None:
            self._values["url_image"] = url_image

    @builtins.property
    def box_image(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageBoxImage"]]]:
        '''box_image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#box_image DataAkamaiImagingPolicyImage#box_image}
        '''
        result = self._values.get("box_image")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageBoxImage"]]], result)

    @builtins.property
    def circle_image(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageCircleImage"]]]:
        '''circle_image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#circle_image DataAkamaiImagingPolicyImage#circle_image}
        '''
        result = self._values.get("circle_image")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageCircleImage"]]], result)

    @builtins.property
    def text_image(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageTextImage"]]]:
        '''text_image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text_image DataAkamaiImagingPolicyImage#text_image}
        '''
        result = self._values.get("text_image")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageTextImage"]]], result)

    @builtins.property
    def url_image(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageUrlImage"]]]:
        '''url_image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url_image DataAkamaiImagingPolicyImage#url_image}
        '''
        result = self._values.get("url_image")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageUrlImage"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageBoxImage",
    jsii_struct_bases=[],
    name_mapping={
        "color": "color",
        "color_var": "colorVar",
        "height": "height",
        "height_var": "heightVar",
        "transformation": "transformation",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageBoxImage:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        transformation: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageBoxImageTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The fill color of the box, not the edge of the box. The API supports hexadecimal representation and CSS hexadecimal color values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The fill color of the box, not the edge of the box. The API supports hexadecimal representation and CSS hexadecimal color values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        :param height: The height of the box in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height of the box in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param transformation: transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        :param width: The width of the box in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width of the box in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(transformation, dict):
            transformation = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageBoxImageTransformation(**transformation)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f96826994dbd31f3a70efbedc33185c6f694c8bd689ef985514d05ab54035270)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument transformation", value=transformation, expected_type=type_hints["transformation"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if transformation is not None:
            self._values["transformation"] = transformation
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The fill color of the box, not the edge of the box.

        The API supports hexadecimal representation and CSS hexadecimal color values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The fill color of the box, not the edge of the box.

        The API supports hexadecimal representation and CSS hexadecimal color values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height of the box in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height of the box in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def transformation(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageBoxImageTransformation"]:
        '''transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        '''
        result = self._values.get("transformation")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageBoxImageTransformation"], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width of the box in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width of the box in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageBoxImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageBoxImageList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageBoxImageList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dc50991a894fc1cfa8695ead363d892faef70bb9e9a272a26eeb26dfc2e526c8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageBoxImageOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8b80baf75650e12323d4f1a11762a17bf8746b5f1ea90ba292fce7468e5f7b31)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageBoxImageOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c538f8984ec70689fae0de0ab9b384f4a970a6c749d616b13112179341436c9d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9064cee0d58e343304af32b92322f847931a3fb1491f6c03435d75611e1a0f30)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a24b84946b1902cedada007d95a8b124f07cf8775cd2436f471dfbe82182d345)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageBoxImage]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageBoxImage]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageBoxImage]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__49494dd680cab6eaa38757b521b7c57279605bbe47329d3c64038215075405e8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageBoxImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageBoxImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__02267c9a1893df4115f3015376b6cd004ca48598f7c3246d083346ae47102555)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformation")
    def put_transformation(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageBoxImageTransformation()

        return typing.cast(None, jsii.invoke(self, "putTransformation", [value]))

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetTransformation")
    def reset_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformation", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="transformation")
    def transformation(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageBoxImageTransformationOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageBoxImageTransformationOutputReference", jsii.get(self, "transformation"))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="transformationInput")
    def transformation_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageBoxImageTransformation"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageBoxImageTransformation"], jsii.get(self, "transformationInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a644cca1f5dab1cf484f8fb6e962c96d22c5024da43e959527ab033d914f1779)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__397d0cc7f64d4549dbc6f94bc0714dc2f3a1127cc772db9fffa3efe0080eb647)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6fcf55fb53a9d378b8442c99d49f847ea81b885270be528cfc5a46ddbe9c4dc6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d517e418075d4f2e1cb097745a40fb926c9b1d35547c9daed29d68127d83b827)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__28a16a7e80c364cac964f51148ea14c170c9b84716f47f60313ae42621077d3c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b69781b4d4e0b756e6fa1a0ce21b795ee9faf2e33a8146ae28485c90223da321)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageBoxImage]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageBoxImage]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageBoxImage]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__12326e5030b5126301a6a61ad2be7dcd2a32ffc12bf230f514991229402cdbb5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageBoxImageTransformation",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageBoxImageTransformation:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageBoxImageTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageBoxImageTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageBoxImageTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3e2d3e5f4bca7cd38f8a3f019ebfde559364c55199da4519f262df2b982697c4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageBoxImageTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageBoxImageTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageBoxImageTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__80cc0ad4e0f9df00eb80258a6b77e3b8e829b084f8c7924a394f45691504bc36)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageCircleImage",
    jsii_struct_bases=[],
    name_mapping={
        "color": "color",
        "color_var": "colorVar",
        "diameter": "diameter",
        "diameter_var": "diameterVar",
        "transformation": "transformation",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageCircleImage:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
        diameter: typing.Optional[builtins.str] = None,
        diameter_var: typing.Optional[builtins.str] = None,
        transformation: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageCircleImageTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The fill color of the circle. The API supports hexadecimal representation and CSS hexadecimal color values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The fill color of the circle. The API supports hexadecimal representation and CSS hexadecimal color values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        :param diameter: The diameter of the circle. The diameter will be the width and the height of the image in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#diameter DataAkamaiImagingPolicyImage#diameter}
        :param diameter_var: The diameter of the circle. The diameter will be the width and the height of the image in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#diameter_var DataAkamaiImagingPolicyImage#diameter_var}
        :param transformation: transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        :param width: The width of the box in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width of the box in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(transformation, dict):
            transformation = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageCircleImageTransformation(**transformation)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e73323d42f07c9d43768be14372c7afdf405664974057e664bec6c0e631c190b)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
            check_type(argname="argument diameter", value=diameter, expected_type=type_hints["diameter"])
            check_type(argname="argument diameter_var", value=diameter_var, expected_type=type_hints["diameter_var"])
            check_type(argname="argument transformation", value=transformation, expected_type=type_hints["transformation"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var
        if diameter is not None:
            self._values["diameter"] = diameter
        if diameter_var is not None:
            self._values["diameter_var"] = diameter_var
        if transformation is not None:
            self._values["transformation"] = transformation
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The fill color of the circle. The API supports hexadecimal representation and CSS hexadecimal color values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The fill color of the circle. The API supports hexadecimal representation and CSS hexadecimal color values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def diameter(self) -> typing.Optional[builtins.str]:
        '''The diameter of the circle. The diameter will be the width and the height of the image in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#diameter DataAkamaiImagingPolicyImage#diameter}
        '''
        result = self._values.get("diameter")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def diameter_var(self) -> typing.Optional[builtins.str]:
        '''The diameter of the circle. The diameter will be the width and the height of the image in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#diameter_var DataAkamaiImagingPolicyImage#diameter_var}
        '''
        result = self._values.get("diameter_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def transformation(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageCircleImageTransformation"]:
        '''transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        '''
        result = self._values.get("transformation")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageCircleImageTransformation"], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width of the box in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width of the box in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageCircleImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageCircleImageList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageCircleImageList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7de61064ed76eb87360fea00071949c93899200658d74b2715ca960e20ebd7a0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageCircleImageOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__04f71b6c17a32b8ad20c13041a7c5a9caf3af2a34bca52ac210d934e2290f2f2)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageCircleImageOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fd9bc0ee205eca95e7a2284cff52aab53e782a5c3be1003f8958dcf8c3427cf8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__162cc440e42f34259fa54a66817be6a932ee359c861d9d5e6b56443b16f20d97)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cf214a3c03843044a57d860287bac41d4c9bf9c5884e141727cc42c174fdafe6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageCircleImage]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageCircleImage]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageCircleImage]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dc9dd2093b4e94cf4e47ab3b1b1cc16c28ac79e1ee994707fcba99c1bad45224)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageCircleImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageCircleImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1bc3183960646194ffed0919c5f96c7e4ef8c8e3bd69a78484188918f7ac5641)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformation")
    def put_transformation(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageCircleImageTransformation()

        return typing.cast(None, jsii.invoke(self, "putTransformation", [value]))

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @jsii.member(jsii_name="resetDiameter")
    def reset_diameter(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDiameter", []))

    @jsii.member(jsii_name="resetDiameterVar")
    def reset_diameter_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDiameterVar", []))

    @jsii.member(jsii_name="resetTransformation")
    def reset_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformation", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="transformation")
    def transformation(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageCircleImageTransformationOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageCircleImageTransformationOutputReference", jsii.get(self, "transformation"))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="diameterInput")
    def diameter_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "diameterInput"))

    @builtins.property
    @jsii.member(jsii_name="diameterVarInput")
    def diameter_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "diameterVarInput"))

    @builtins.property
    @jsii.member(jsii_name="transformationInput")
    def transformation_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageCircleImageTransformation"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageCircleImageTransformation"], jsii.get(self, "transformationInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c7df9881fb1e9b79367d4ce6d3605b70f71e34fc594ea9ce30e10e9c6923cf7d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__59d948a43c63d464cea558d20e79718e37fa822d58bb8cb233e758ede082cb63)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="diameter")
    def diameter(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "diameter"))

    @diameter.setter
    def diameter(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4614e7b0ba79c7edef682d8a453c3e07da28cc272c2a50cba7b721baca357a20)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "diameter", value)

    @builtins.property
    @jsii.member(jsii_name="diameterVar")
    def diameter_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "diameterVar"))

    @diameter_var.setter
    def diameter_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c4644f8d0b1a0f8402aae14d28a3dc38fb61646fb7b6079b59958f1a7492e3b0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "diameterVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__69323bc4c71de5208499486b32b37f005de451656bd4bda3d553ee57ba68bd0a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5343b4665bd990a23e8dc40fa4fe17e0b5aa55ec2df5cfc86dcd5423ae00faa3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageCircleImage]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageCircleImage]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageCircleImage]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1b18d8af838032572d9790300153f168bd34f0aba53163b20cf49c14f2ed6859)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageCircleImageTransformation",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageCircleImageTransformation:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageCircleImageTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageCircleImageTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageCircleImageTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c311727ad8343b9a83639ae34266860607f886ea1e49ad9acefe8534e3e45e2a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageCircleImageTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageCircleImageTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageCircleImageTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b2a5d9fe53a5ed2326122e685a9b2ffc4d76273f2e3ad6b8dc50c5824209e83a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d11cf22236afce92ffdd8ffb7fb2f1f1ac3322d4158beb2825cfb510969b243e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putBoxImage")
    def put_box_image(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageBoxImage, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8e2265fa7b0114f49503ef49dbacb3e5be0e2e8fb07ecaf4de6a7c8462ea89e8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBoxImage", [value]))

    @jsii.member(jsii_name="putCircleImage")
    def put_circle_image(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageCircleImage, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ad8d8c1ec444ad998f04fb34ea6ad2a6f28bed4ad69520e3bfe626959ca3e42a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCircleImage", [value]))

    @jsii.member(jsii_name="putTextImage")
    def put_text_image(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageTextImage", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__431417ff17a8559a9b4678c5f9ca12ebd4355c14cb7066643c1cf880d2d6f04b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTextImage", [value]))

    @jsii.member(jsii_name="putUrlImage")
    def put_url_image(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageUrlImage", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bd2e0b47ce60e44e10c56b240fb221c5b3dfe3a102faf5f7e51be1ae23e3acfb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putUrlImage", [value]))

    @jsii.member(jsii_name="resetBoxImage")
    def reset_box_image(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBoxImage", []))

    @jsii.member(jsii_name="resetCircleImage")
    def reset_circle_image(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCircleImage", []))

    @jsii.member(jsii_name="resetTextImage")
    def reset_text_image(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTextImage", []))

    @jsii.member(jsii_name="resetUrlImage")
    def reset_url_image(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUrlImage", []))

    @builtins.property
    @jsii.member(jsii_name="boxImage")
    def box_image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageBoxImageList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageBoxImageList, jsii.get(self, "boxImage"))

    @builtins.property
    @jsii.member(jsii_name="circleImage")
    def circle_image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageCircleImageList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageCircleImageList, jsii.get(self, "circleImage"))

    @builtins.property
    @jsii.member(jsii_name="textImage")
    def text_image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageTextImageList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageTextImageList", jsii.get(self, "textImage"))

    @builtins.property
    @jsii.member(jsii_name="urlImage")
    def url_image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageUrlImageList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageUrlImageList", jsii.get(self, "urlImage"))

    @builtins.property
    @jsii.member(jsii_name="boxImageInput")
    def box_image_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageBoxImage]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageBoxImage]]], jsii.get(self, "boxImageInput"))

    @builtins.property
    @jsii.member(jsii_name="circleImageInput")
    def circle_image_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageCircleImage]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageCircleImage]]], jsii.get(self, "circleImageInput"))

    @builtins.property
    @jsii.member(jsii_name="textImageInput")
    def text_image_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageTextImage"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageTextImage"]]], jsii.get(self, "textImageInput"))

    @builtins.property
    @jsii.member(jsii_name="urlImageInput")
    def url_image_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageUrlImage"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageUrlImage"]]], jsii.get(self, "urlImageInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1e8d2d5d2653a83a8a3d189caaa5ce1ac7359e5fc7e0b2a2086d136a67529ba6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageTextImage",
    jsii_struct_bases=[],
    name_mapping={
        "fill": "fill",
        "fill_var": "fillVar",
        "size": "size",
        "size_var": "sizeVar",
        "stroke": "stroke",
        "stroke_size": "strokeSize",
        "stroke_size_var": "strokeSizeVar",
        "stroke_var": "strokeVar",
        "text": "text",
        "text_var": "textVar",
        "transformation": "transformation",
        "typeface": "typeface",
        "typeface_var": "typefaceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageTextImage:
    def __init__(
        self,
        *,
        fill: typing.Optional[builtins.str] = None,
        fill_var: typing.Optional[builtins.str] = None,
        size: typing.Optional[builtins.str] = None,
        size_var: typing.Optional[builtins.str] = None,
        stroke: typing.Optional[builtins.str] = None,
        stroke_size: typing.Optional[builtins.str] = None,
        stroke_size_var: typing.Optional[builtins.str] = None,
        stroke_var: typing.Optional[builtins.str] = None,
        text: typing.Optional[builtins.str] = None,
        text_var: typing.Optional[builtins.str] = None,
        transformation: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageTextImageTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        typeface: typing.Optional[builtins.str] = None,
        typeface_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fill: The main fill color of the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill DataAkamaiImagingPolicyImage#fill}
        :param fill_var: The main fill color of the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_var DataAkamaiImagingPolicyImage#fill_var}
        :param size: The size in pixels to render the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#size DataAkamaiImagingPolicyImage#size}
        :param size_var: The size in pixels to render the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#size_var DataAkamaiImagingPolicyImage#size_var}
        :param stroke: The color for the outline of the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke DataAkamaiImagingPolicyImage#stroke}
        :param stroke_size: The thickness in points for the outline of the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_size DataAkamaiImagingPolicyImage#stroke_size}
        :param stroke_size_var: The thickness in points for the outline of the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_size_var DataAkamaiImagingPolicyImage#stroke_size_var}
        :param stroke_var: The color for the outline of the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_var DataAkamaiImagingPolicyImage#stroke_var}
        :param text: The line of text to render. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text DataAkamaiImagingPolicyImage#text}
        :param text_var: The line of text to render. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text_var DataAkamaiImagingPolicyImage#text_var}
        :param transformation: transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        :param typeface: The font family to apply to the text image. This may be a URL to a TrueType or WOFF (v1) typeface, or a string that refers to one of the standard built-in browser fonts. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#typeface DataAkamaiImagingPolicyImage#typeface}
        :param typeface_var: The font family to apply to the text image. This may be a URL to a TrueType or WOFF (v1) typeface, or a string that refers to one of the standard built-in browser fonts. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#typeface_var DataAkamaiImagingPolicyImage#typeface_var}
        '''
        if isinstance(transformation, dict):
            transformation = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageTextImageTransformation(**transformation)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__02f9a973072d8b3461f6b91ddd2a69fd5713f8126e6c571c984c568116fc677c)
            check_type(argname="argument fill", value=fill, expected_type=type_hints["fill"])
            check_type(argname="argument fill_var", value=fill_var, expected_type=type_hints["fill_var"])
            check_type(argname="argument size", value=size, expected_type=type_hints["size"])
            check_type(argname="argument size_var", value=size_var, expected_type=type_hints["size_var"])
            check_type(argname="argument stroke", value=stroke, expected_type=type_hints["stroke"])
            check_type(argname="argument stroke_size", value=stroke_size, expected_type=type_hints["stroke_size"])
            check_type(argname="argument stroke_size_var", value=stroke_size_var, expected_type=type_hints["stroke_size_var"])
            check_type(argname="argument stroke_var", value=stroke_var, expected_type=type_hints["stroke_var"])
            check_type(argname="argument text", value=text, expected_type=type_hints["text"])
            check_type(argname="argument text_var", value=text_var, expected_type=type_hints["text_var"])
            check_type(argname="argument transformation", value=transformation, expected_type=type_hints["transformation"])
            check_type(argname="argument typeface", value=typeface, expected_type=type_hints["typeface"])
            check_type(argname="argument typeface_var", value=typeface_var, expected_type=type_hints["typeface_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fill is not None:
            self._values["fill"] = fill
        if fill_var is not None:
            self._values["fill_var"] = fill_var
        if size is not None:
            self._values["size"] = size
        if size_var is not None:
            self._values["size_var"] = size_var
        if stroke is not None:
            self._values["stroke"] = stroke
        if stroke_size is not None:
            self._values["stroke_size"] = stroke_size
        if stroke_size_var is not None:
            self._values["stroke_size_var"] = stroke_size_var
        if stroke_var is not None:
            self._values["stroke_var"] = stroke_var
        if text is not None:
            self._values["text"] = text
        if text_var is not None:
            self._values["text_var"] = text_var
        if transformation is not None:
            self._values["transformation"] = transformation
        if typeface is not None:
            self._values["typeface"] = typeface
        if typeface_var is not None:
            self._values["typeface_var"] = typeface_var

    @builtins.property
    def fill(self) -> typing.Optional[builtins.str]:
        '''The main fill color of the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill DataAkamaiImagingPolicyImage#fill}
        '''
        result = self._values.get("fill")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fill_var(self) -> typing.Optional[builtins.str]:
        '''The main fill color of the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_var DataAkamaiImagingPolicyImage#fill_var}
        '''
        result = self._values.get("fill_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def size(self) -> typing.Optional[builtins.str]:
        '''The size in pixels to render the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#size DataAkamaiImagingPolicyImage#size}
        '''
        result = self._values.get("size")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def size_var(self) -> typing.Optional[builtins.str]:
        '''The size in pixels to render the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#size_var DataAkamaiImagingPolicyImage#size_var}
        '''
        result = self._values.get("size_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def stroke(self) -> typing.Optional[builtins.str]:
        '''The color for the outline of the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke DataAkamaiImagingPolicyImage#stroke}
        '''
        result = self._values.get("stroke")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def stroke_size(self) -> typing.Optional[builtins.str]:
        '''The thickness in points for the outline of the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_size DataAkamaiImagingPolicyImage#stroke_size}
        '''
        result = self._values.get("stroke_size")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def stroke_size_var(self) -> typing.Optional[builtins.str]:
        '''The thickness in points for the outline of the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_size_var DataAkamaiImagingPolicyImage#stroke_size_var}
        '''
        result = self._values.get("stroke_size_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def stroke_var(self) -> typing.Optional[builtins.str]:
        '''The color for the outline of the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_var DataAkamaiImagingPolicyImage#stroke_var}
        '''
        result = self._values.get("stroke_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def text(self) -> typing.Optional[builtins.str]:
        '''The line of text to render.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text DataAkamaiImagingPolicyImage#text}
        '''
        result = self._values.get("text")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def text_var(self) -> typing.Optional[builtins.str]:
        '''The line of text to render.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text_var DataAkamaiImagingPolicyImage#text_var}
        '''
        result = self._values.get("text_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def transformation(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageTextImageTransformation"]:
        '''transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        '''
        result = self._values.get("transformation")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageTextImageTransformation"], result)

    @builtins.property
    def typeface(self) -> typing.Optional[builtins.str]:
        '''The font family to apply to the text image.

        This may be a URL to a TrueType or WOFF (v1) typeface, or a string that refers to one of the standard built-in browser fonts.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#typeface DataAkamaiImagingPolicyImage#typeface}
        '''
        result = self._values.get("typeface")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def typeface_var(self) -> typing.Optional[builtins.str]:
        '''The font family to apply to the text image.

        This may be a URL to a TrueType or WOFF (v1) typeface, or a string that refers to one of the standard built-in browser fonts.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#typeface_var DataAkamaiImagingPolicyImage#typeface_var}
        '''
        result = self._values.get("typeface_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageTextImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageTextImageList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageTextImageList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bd3eb6762a489dc75d9b6b26d713beb516314a4d1dcf3bb0765be70991d76e46)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageTextImageOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9cd72bfe6072e57d6668c3d479d44802e720a0633a39f849982da5954f145699)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageTextImageOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a29e948a2b5f4a22e8c09a493d05b88b4e140d64a625073df6be0295ca1671c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dbb9b7174bb127be7452e04cc8c28e140416553c34bb4807637f78dc0ad43d53)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e96c83a8a9b710da6f258b55a2631987876576e732cef39bc59128d50d8f5c37)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageTextImage]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageTextImage]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageTextImage]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3e4ceea15aba7e3558c91eb6c0348b4946fcdb58c60c08db09aa898c81e928d8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageTextImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageTextImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__77927e5ff5e4d6c49d501f42a80981d4447aa7dbc154c4228e92de4ccc47c89b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformation")
    def put_transformation(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageTextImageTransformation()

        return typing.cast(None, jsii.invoke(self, "putTransformation", [value]))

    @jsii.member(jsii_name="resetFill")
    def reset_fill(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFill", []))

    @jsii.member(jsii_name="resetFillVar")
    def reset_fill_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFillVar", []))

    @jsii.member(jsii_name="resetSize")
    def reset_size(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSize", []))

    @jsii.member(jsii_name="resetSizeVar")
    def reset_size_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSizeVar", []))

    @jsii.member(jsii_name="resetStroke")
    def reset_stroke(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStroke", []))

    @jsii.member(jsii_name="resetStrokeSize")
    def reset_stroke_size(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStrokeSize", []))

    @jsii.member(jsii_name="resetStrokeSizeVar")
    def reset_stroke_size_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStrokeSizeVar", []))

    @jsii.member(jsii_name="resetStrokeVar")
    def reset_stroke_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStrokeVar", []))

    @jsii.member(jsii_name="resetText")
    def reset_text(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetText", []))

    @jsii.member(jsii_name="resetTextVar")
    def reset_text_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTextVar", []))

    @jsii.member(jsii_name="resetTransformation")
    def reset_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformation", []))

    @jsii.member(jsii_name="resetTypeface")
    def reset_typeface(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeface", []))

    @jsii.member(jsii_name="resetTypefaceVar")
    def reset_typeface_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypefaceVar", []))

    @builtins.property
    @jsii.member(jsii_name="transformation")
    def transformation(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageTextImageTransformationOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageTextImageTransformationOutputReference", jsii.get(self, "transformation"))

    @builtins.property
    @jsii.member(jsii_name="fillInput")
    def fill_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fillInput"))

    @builtins.property
    @jsii.member(jsii_name="fillVarInput")
    def fill_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fillVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sizeInput")
    def size_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sizeInput"))

    @builtins.property
    @jsii.member(jsii_name="sizeVarInput")
    def size_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sizeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="strokeInput")
    def stroke_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "strokeInput"))

    @builtins.property
    @jsii.member(jsii_name="strokeSizeInput")
    def stroke_size_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "strokeSizeInput"))

    @builtins.property
    @jsii.member(jsii_name="strokeSizeVarInput")
    def stroke_size_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "strokeSizeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="strokeVarInput")
    def stroke_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "strokeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="textInput")
    def text_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "textInput"))

    @builtins.property
    @jsii.member(jsii_name="textVarInput")
    def text_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "textVarInput"))

    @builtins.property
    @jsii.member(jsii_name="transformationInput")
    def transformation_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageTextImageTransformation"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageTextImageTransformation"], jsii.get(self, "transformationInput"))

    @builtins.property
    @jsii.member(jsii_name="typefaceInput")
    def typeface_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typefaceInput"))

    @builtins.property
    @jsii.member(jsii_name="typefaceVarInput")
    def typeface_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typefaceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="fill")
    def fill(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fill"))

    @fill.setter
    def fill(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__51d7fd59004c601098cfb6b93465674a16f3b2e996d8d3c76122c52883bf46a5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fill", value)

    @builtins.property
    @jsii.member(jsii_name="fillVar")
    def fill_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fillVar"))

    @fill_var.setter
    def fill_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4be6e636dceff69ae455ac9d94cff9311798faa1f6788ca0c6cb85780776ece0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fillVar", value)

    @builtins.property
    @jsii.member(jsii_name="size")
    def size(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "size"))

    @size.setter
    def size(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b58abee429d832460632633942a30322f1db06616c50dbff1d3b2e65a23fdcb5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "size", value)

    @builtins.property
    @jsii.member(jsii_name="sizeVar")
    def size_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sizeVar"))

    @size_var.setter
    def size_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8c6cce16aed43b4ba1c07be72492d87b234555b291c11768fa3d32b5ffa45a9b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sizeVar", value)

    @builtins.property
    @jsii.member(jsii_name="stroke")
    def stroke(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "stroke"))

    @stroke.setter
    def stroke(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__509fc3ff56e64ba47f903023d1d721245c1320c05d89485c6525a1fcfe4fb26a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "stroke", value)

    @builtins.property
    @jsii.member(jsii_name="strokeSize")
    def stroke_size(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "strokeSize"))

    @stroke_size.setter
    def stroke_size(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b9b8631e7830413d602249b52e8a363fc98158b6b7804b6314998e1a08f197b3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "strokeSize", value)

    @builtins.property
    @jsii.member(jsii_name="strokeSizeVar")
    def stroke_size_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "strokeSizeVar"))

    @stroke_size_var.setter
    def stroke_size_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9f32df4eedaedfb582dd1094e8925b0a06cc3cc1cf68a188850072d84e4780d8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "strokeSizeVar", value)

    @builtins.property
    @jsii.member(jsii_name="strokeVar")
    def stroke_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "strokeVar"))

    @stroke_var.setter
    def stroke_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4b3384997fc1feec8505a696c12b1302543fed81018b4c74c4b75cea93978fa3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "strokeVar", value)

    @builtins.property
    @jsii.member(jsii_name="text")
    def text(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "text"))

    @text.setter
    def text(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7c7016d1038962342788334f05b8a4e098e79ed752f1ab74104d10d431a1e1a3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "text", value)

    @builtins.property
    @jsii.member(jsii_name="textVar")
    def text_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "textVar"))

    @text_var.setter
    def text_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__84b006a2b66bc88e7784321cf3349f7013ffb99a3e3a1681c313e5f69b1616d2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "textVar", value)

    @builtins.property
    @jsii.member(jsii_name="typeface")
    def typeface(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeface"))

    @typeface.setter
    def typeface(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__79f08631aacff10a40946163ffa095eceb357655e200c33675f97655221aa376)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeface", value)

    @builtins.property
    @jsii.member(jsii_name="typefaceVar")
    def typeface_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typefaceVar"))

    @typeface_var.setter
    def typeface_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0f3b701c5770bd3809eb43d71fb0f045d946d3eb6aae56c2835d8d43bce49297)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typefaceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageTextImage]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageTextImage]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageTextImage]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ee3ea251ec3b9764750f2865b0555e18a2242107653e63697e460255f700fd9f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageTextImageTransformation",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageTextImageTransformation:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageTextImageTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageTextImageTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageTextImageTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cafac727d818126e15e8d08166076da69097f49fcdbec089657b9292379e3a94)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageTextImageTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageTextImageTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageTextImageTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__45501c5b6c1b0c75cdf6d4e2e9b58da22e569c80f7fabf04247c2d51550f5ea5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageUrlImage",
    jsii_struct_bases=[],
    name_mapping={
        "transformation": "transformation",
        "url": "url",
        "url_var": "urlVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageUrlImage:
    def __init__(
        self,
        *,
        transformation: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageUrlImageTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        url: typing.Optional[builtins.str] = None,
        url_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param transformation: transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        :param url: The URL of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url DataAkamaiImagingPolicyImage#url}
        :param url_var: The URL of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url_var DataAkamaiImagingPolicyImage#url_var}
        '''
        if isinstance(transformation, dict):
            transformation = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageUrlImageTransformation(**transformation)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9dc33f28ea97478cc6bea4e59b3a9ca6dea76eea43e3a41451b94f5a05d9fe37)
            check_type(argname="argument transformation", value=transformation, expected_type=type_hints["transformation"])
            check_type(argname="argument url", value=url, expected_type=type_hints["url"])
            check_type(argname="argument url_var", value=url_var, expected_type=type_hints["url_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if transformation is not None:
            self._values["transformation"] = transformation
        if url is not None:
            self._values["url"] = url
        if url_var is not None:
            self._values["url_var"] = url_var

    @builtins.property
    def transformation(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageUrlImageTransformation"]:
        '''transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        '''
        result = self._values.get("transformation")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageUrlImageTransformation"], result)

    @builtins.property
    def url(self) -> typing.Optional[builtins.str]:
        '''The URL of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url DataAkamaiImagingPolicyImage#url}
        '''
        result = self._values.get("url")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def url_var(self) -> typing.Optional[builtins.str]:
        '''The URL of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url_var DataAkamaiImagingPolicyImage#url_var}
        '''
        result = self._values.get("url_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageUrlImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageUrlImageList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageUrlImageList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__248048ca6dcc3e8b79cabd76563492da1c7c5ed6509c850a021d1d9204fe22d0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageUrlImageOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f645e3a73d7e6816dc3ec5e74ddf7c3e13f7a6e7b14c0d815728e0d00e431439)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageUrlImageOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e51fcfa440027b1eff7d9cb48d26d852acb93100f6370e4adf972c240ef8f638)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b6bc4a0059b025adfd35d42acd1b6a4ea78b4bffc04b6d8f6387863c00e93e2b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__386016b7a4ba2fdb91b7bd1655047f0e3cb5dce50b24fe79e8c3aefa036bf4a4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageUrlImage]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageUrlImage]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageUrlImage]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__10e4ff26b3c7758f3e60288eada3e016fa45b65636d8868b7812d62f2df90223)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageUrlImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageUrlImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__95b9d7fbe9514c8de6843198a0416a8dff5c1166777da8af5054a4ee3a69d32e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformation")
    def put_transformation(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageUrlImageTransformation()

        return typing.cast(None, jsii.invoke(self, "putTransformation", [value]))

    @jsii.member(jsii_name="resetTransformation")
    def reset_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformation", []))

    @jsii.member(jsii_name="resetUrl")
    def reset_url(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUrl", []))

    @jsii.member(jsii_name="resetUrlVar")
    def reset_url_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUrlVar", []))

    @builtins.property
    @jsii.member(jsii_name="transformation")
    def transformation(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageUrlImageTransformationOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageUrlImageTransformationOutputReference", jsii.get(self, "transformation"))

    @builtins.property
    @jsii.member(jsii_name="transformationInput")
    def transformation_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageUrlImageTransformation"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageUrlImageTransformation"], jsii.get(self, "transformationInput"))

    @builtins.property
    @jsii.member(jsii_name="urlInput")
    def url_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "urlInput"))

    @builtins.property
    @jsii.member(jsii_name="urlVarInput")
    def url_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "urlVarInput"))

    @builtins.property
    @jsii.member(jsii_name="url")
    def url(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "url"))

    @url.setter
    def url(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8ca70e2b6e2b259ff030400267687d58d0be4c8121232ae7cdaac58951cac4ed)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "url", value)

    @builtins.property
    @jsii.member(jsii_name="urlVar")
    def url_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "urlVar"))

    @url_var.setter
    def url_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f77680a5c165f318db76245e9e47c688b66ff29e1a976ff8378aca6ef0da122d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "urlVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageUrlImage]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageUrlImage]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageUrlImage]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6c0b9fe47b629676a9fd74b11b3395592f77f3d0d2d6968811b161fe4d468daa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageUrlImageTransformation",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageUrlImageTransformation:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageUrlImageTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageUrlImageTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageUrlImageTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fe2c175f6005cf7a4dc3e9764756050ff2cbc0ab35b4fab6a106199a4ce6057a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageUrlImageTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageUrlImageTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageUrlImageTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ecfa990cb2dc989fe17eb605f8fe44071d0d3c7f180500c1756c10de9f5e427)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__288a7c371ee6d7e79bbdcd307d580417e0d16db2862c3ed4f49e238779202c11)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d7e2edf2ea93ecb524e5e30667b74abc65d072db4d35a5e558710a0685c8f474)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9c953862b29a7eae57eaad63961c0b6c4d1aa9d9b02d68db81093ae9a7a632eb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d9274283cae0c5b44f452e5abf012a6933efdcaa2a779b833b936d870291da1c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e6479a6e822cf161509ad013fc6a399424fe07a9bf7c54691edc9fd55b6c74ef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanComposite]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanComposite]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__560a0964f744a2157690849c88e5fa00c06629f4f062cafef1800478346a937c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bba3e068d4959499cde4dbd844cef8b3b21c074e7c3ebf34085ee7d5f12fcc39)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(
        self,
        *,
        box_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageBoxImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
        circle_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageCircleImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
        text_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageTextImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
        url_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageUrlImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param box_image: box_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#box_image DataAkamaiImagingPolicyImage#box_image}
        :param circle_image: circle_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#circle_image DataAkamaiImagingPolicyImage#circle_image}
        :param text_image: text_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text_image DataAkamaiImagingPolicyImage#text_image}
        :param url_image: url_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url_image DataAkamaiImagingPolicyImage#url_image}
        '''
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImage(
            box_image=box_image,
            circle_image=circle_image,
            text_image=text_image,
            url_image=url_image,
        )

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPlacement")
    def reset_placement(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacement", []))

    @jsii.member(jsii_name="resetPlacementVar")
    def reset_placement_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacementVar", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetScaleDimension")
    def reset_scale_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimension", []))

    @jsii.member(jsii_name="resetScaleDimensionVar")
    def reset_scale_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimensionVar", []))

    @jsii.member(jsii_name="resetScaleVar")
    def reset_scale_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="placementInput")
    def placement_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementInput"))

    @builtins.property
    @jsii.member(jsii_name="placementVarInput")
    def placement_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionInput")
    def scale_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVarInput")
    def scale_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleVarInput")
    def scale_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__48d9941742efc12f3dd23086ef41bea0b4153bc47381db955df8256f01c1f548)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f37b95b2b64cb9824b7541aef225eeb5af1b94509b980be39840d9a9d5ea719f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="placement")
    def placement(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placement"))

    @placement.setter
    def placement(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5d791faccd8e6c2894fb661ea5a268b8bb136b4d1b0a0a4a272264c430e30d20)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placement", value)

    @builtins.property
    @jsii.member(jsii_name="placementVar")
    def placement_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placementVar"))

    @placement_var.setter
    def placement_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a1546e194bd8cd542d6b897a929c2bfa85f09b97f99e5d91cdbb46a1331ee31e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placementVar", value)

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scale"))

    @scale.setter
    def scale(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__08dd5f27e448c0e2720124e00b3835254ab0556af7986d6d60fab947ee710ceb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scale", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimension")
    def scale_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimension"))

    @scale_dimension.setter
    def scale_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c2cf58c65c2f5b1caa7889ac06367e44c0c6723248ed7ecd9c1ab765265cd217)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimension", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVar")
    def scale_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimensionVar"))

    @scale_dimension_var.setter
    def scale_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__127193147cb40b07543ba50898b3a983b58b07ada682a2ac6dbdc21a7d7e4534)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="scaleVar")
    def scale_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleVar"))

    @scale_var.setter
    def scale_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__48b0dcbcab7fc3be5bcf12d7b416000327e774cf4e9ddec25e61bd2652ae25d7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ffc62db5b8ab28243dcc430a23206a168995ad32bc786a894474c92cdf071dda)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e37e6ca4abb07f2d9990b1d9073841c377e731c0edef1abb00c0dbc7795667f1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0afe90ffb1b8728a77aa58ddc28bf4c0de82810eca86a09346455e795b83f29c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5e1e52f6db88cf900a0ab45c17ccb93080a0a4416b32a289f48f37b4c948dac0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanComposite]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanComposite]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanComposite]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f8f5e014adf4d686b7976f10402aabd644d816da38a2f54794504a4d50f601ab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompound",
    jsii_struct_bases=[],
    name_mapping={"transformations": "transformations"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompound:
    def __init__(
        self,
        *,
        transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformations, typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param transformations: transformations block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d753a22b2bf555f65c241bbfa27b181c83a204e0d7af97417f2af7c85de6c4ee)
            check_type(argname="argument transformations", value=transformations, expected_type=type_hints["transformations"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if transformations is not None:
            self._values["transformations"] = transformations

    @builtins.property
    def transformations(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformations]]]:
        '''transformations block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        result = self._values.get("transformations")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformations]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompound(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompoundList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompoundList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f9f84f022c8206054058bd02ca86d60144d1f51addc7f047886301f34b6e4fdf)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompoundOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e72e5eae42edf5a856ba8c8710f750c19b3dba52eb800352832ab82307ef0fc5)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompoundOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e80eb70ca625755cd53f48e55d161ae83732b9e4d6d0bc9de8d059e59039cfb1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cfee9e72a0c498ea8285406f115cdfbffc11a4851acfaa837981d0ef7d311da0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__02ea0c457254846f6f7960ee7a344e6dbd4ee1f9f8d213244f5904be20c0b365)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompound]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompound]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9234bd0478478dfd3aefeb95f33d39437679bb274856fbd549764878cd6c474c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompoundOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompoundOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b4ab49f1fa3d5980d4949ec477435dd19a154eac75b993065086d3bf398f44a9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformations")
    def put_transformations(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformations, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__85997e4006c3e668cb587c091247229c6d90a5245792d6801ad1378a5abe7e84)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTransformations", [value]))

    @jsii.member(jsii_name="resetTransformations")
    def reset_transformations(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformations", []))

    @builtins.property
    @jsii.member(jsii_name="transformations")
    def transformations(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsList", jsii.get(self, "transformations"))

    @builtins.property
    @jsii.member(jsii_name="transformationsInput")
    def transformations_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformations]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformations]]], jsii.get(self, "transformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompound]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompound]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompound]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__15d25fbdf7aa6467cba2f8e92a87198e6c12e9c631a7bb7f4a9d9c67cb78489c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanContrast",
    jsii_struct_bases=[],
    name_mapping={
        "brightness": "brightness",
        "brightness_var": "brightnessVar",
        "contrast": "contrast",
        "contrast_var": "contrastVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanContrast:
    def __init__(
        self,
        *,
        brightness: typing.Optional[builtins.str] = None,
        brightness_var: typing.Optional[builtins.str] = None,
        contrast: typing.Optional[builtins.str] = None,
        contrast_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param brightness: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        :param brightness_var: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        :param contrast: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param contrast_var: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8baa744d3f660283b8543ef78e0d37cb1077e7c60c9ab274bb23c847503c2f45)
            check_type(argname="argument brightness", value=brightness, expected_type=type_hints["brightness"])
            check_type(argname="argument brightness_var", value=brightness_var, expected_type=type_hints["brightness_var"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument contrast_var", value=contrast_var, expected_type=type_hints["contrast_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if brightness is not None:
            self._values["brightness"] = brightness
        if brightness_var is not None:
            self._values["brightness_var"] = brightness_var
        if contrast is not None:
            self._values["contrast"] = contrast
        if contrast_var is not None:
            self._values["contrast_var"] = contrast_var

    @builtins.property
    def brightness(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        '''
        result = self._values.get("brightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def brightness_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        '''
        result = self._values.get("brightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        result = self._values.get("contrast_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanContrast(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanContrastList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanContrastList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cf1d1f2790b42b5b373cef54eb412faed0a3cc5f5e4f8b0237d7594bbab5c4cf)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanContrastOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7a79e2c01fe9a9edb8d9ad3079b733ceca6780a1d648a141e303a8c2712fed9d)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanContrastOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d4f69e463603adc4b5f15893dffa0d189a2c2295d56b41eb217b7ecd75967fba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__214c5334f154393c90ac4ec824ba782f4af22b3132234efa8233c1dc1842492b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9be3879f59c97aa4c329283d483d416d8f7d161ee550c0943fb94688a618ce3c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanContrast]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanContrast]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__de1c2f9dca9fb6ee5ecbdc7c189ee697b4249382d23024d74f4e0c831e2d5bcc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanContrastOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanContrastOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6a73597ad334c701968b39866e8d4d2e0809e2ae6f4554ca503cf1b97c8af5eb)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetBrightness")
    def reset_brightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightness", []))

    @jsii.member(jsii_name="resetBrightnessVar")
    def reset_brightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightnessVar", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetContrastVar")
    def reset_contrast_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrastVar", []))

    @builtins.property
    @jsii.member(jsii_name="brightnessInput")
    def brightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="brightnessVarInput")
    def brightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastVarInput")
    def contrast_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="brightness")
    def brightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightness"))

    @brightness.setter
    def brightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bdd2a8821c5b4b561d7d4e58cfe21b2b1d79a507c8422f0111d92b259fee9316)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightness", value)

    @builtins.property
    @jsii.member(jsii_name="brightnessVar")
    def brightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightnessVar"))

    @brightness_var.setter
    def brightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1e9a8c80c365dc21abaf21e8b8a9bd23d496aedb29690a6578bc2deaa71ae158)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrast"))

    @contrast.setter
    def contrast(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bd509f31e59aed000ae63aaf4e7355ffb1c72895898380743860d3aa18923e99)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrast", value)

    @builtins.property
    @jsii.member(jsii_name="contrastVar")
    def contrast_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrastVar"))

    @contrast_var.setter
    def contrast_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__70b8e111d0c8c110bb15e8959ce88c7dd674e15171fa1844333792ec02c33280)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrastVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanContrast]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanContrast]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanContrast]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__246fdd4ad6fba7de6fd8ee2ed5cb7c439e476d1180867751f6f959ba1ccf62bf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCrop",
    jsii_struct_bases=[],
    name_mapping={
        "allow_expansion": "allowExpansion",
        "allow_expansion_var": "allowExpansionVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCrop:
    def __init__(
        self,
        *,
        allow_expansion: typing.Optional[builtins.str] = None,
        allow_expansion_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_expansion: If cropping an area outside of the existing canvas, expands the image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        :param allow_expansion_var: If cropping an area outside of the existing canvas, expands the image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        :param gravity: Frame of reference for X and Y Positions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Frame of reference for X and Y Positions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The number of pixels to crop along the y-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The number of pixels to crop along the y-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The number of pixels to crop along the x-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The number of pixels to crop along the x-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        :param x_position: The x-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__03825ef66222480db9b42cc6b7a01ef894e3937667e094fec41dc495c3f65ed5)
            check_type(argname="argument allow_expansion", value=allow_expansion, expected_type=type_hints["allow_expansion"])
            check_type(argname="argument allow_expansion_var", value=allow_expansion_var, expected_type=type_hints["allow_expansion_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if allow_expansion is not None:
            self._values["allow_expansion"] = allow_expansion
        if allow_expansion_var is not None:
            self._values["allow_expansion_var"] = allow_expansion_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def allow_expansion(self) -> typing.Optional[builtins.str]:
        '''If cropping an area outside of the existing canvas, expands the image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        '''
        result = self._values.get("allow_expansion")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def allow_expansion_var(self) -> typing.Optional[builtins.str]:
        '''If cropping an area outside of the existing canvas, expands the image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        '''
        result = self._values.get("allow_expansion_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Frame of reference for X and Y Positions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Frame of reference for X and Y Positions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the y-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the y-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the x-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the x-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__56d48a5989dfa3c53273d409d68837e1d0ff72a7a0d63775c4b374446f332533)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6bd5013cfc6bfa03042585fb133a7aec5370886d7c13dcaa099351dc0da4320f)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a78e30304392a4f3ef1228f4b2dc68575b9ab7dbd485f20575a8aec709087f6f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__989f21d446282e41c5a50fffaa636409401207b9f14caa2f7d9ccd6ebd07317a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c284bc8343c3b7b541dfe685278bb423a77438ecf167115ad56e7c0a5fda31f2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__08e9572760a9c460fa1cdee698a453eca97addf42ebb4656d1a68119f832779c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8db82c2058e44724936543f95f07a5dfd905703ea14682b3fb4ac820c679cd4a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAllowExpansion")
    def reset_allow_expansion(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansion", []))

    @jsii.member(jsii_name="resetAllowExpansionVar")
    def reset_allow_expansion_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansionVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionInput")
    def allow_expansion_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVarInput")
    def allow_expansion_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansion")
    def allow_expansion(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansion"))

    @allow_expansion.setter
    def allow_expansion(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ef672bd75e384a82a9467139c3456c676a5802a9512afb986439b3c3331f3caa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansion", value)

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVar")
    def allow_expansion_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansionVar"))

    @allow_expansion_var.setter
    def allow_expansion_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__12d14bc92c7b4ccf27fd63cae8222c2361ed079a5ea30170942386f6fd425dd0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansionVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__040b3f58b83bb2dcb80e0de3d7f47292097e881ee42eb52c19f69cd8bb52c449)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a67e50d8778087d0327b025455ff32bd55ea939643429a62508b96dfa597eeeb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__25599833646145b481fd9de1b63aa5abfd64794d40eef75dc2d08f33d833fe5b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__288ed022794d96b7d643bba05485d38fbc0dd19ffa5bcd393aede610e2110dd1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__db0f3c9894cc580fa940c7d30df825194a011be98e3b7f2766f0a01bfa01c0d8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f54f15248eb106eeadf9cd882eec55c0ca6a07c9ede13edbd4775e4ac76652c7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__200171fe255270fc1812441fbed61418fbf459362e2fb67d4dd22e144086b03b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1c352726cdd54ad8498abd5a698f3ee706bf7d6dc6d4001d1cd0ae2d2678613d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8f4295a5878c0e2649369fa4835569f9352c8618c2a9a07e3247bcf247948855)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__69c05d0f6769e0babc4b06a4aa2f9c2a0b8b9a184044657b7a3c36eeaa2cacd7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__507b8c9a44c7a2edc85edbe03734964471ab4404f083e9bad3b7b7bc07db464e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFaceCrop",
    jsii_struct_bases=[],
    name_mapping={
        "algorithm": "algorithm",
        "algorithm_var": "algorithmVar",
        "confidence": "confidence",
        "confidence_var": "confidenceVar",
        "fail_gravity": "failGravity",
        "fail_gravity_var": "failGravityVar",
        "focus": "focus",
        "focus_var": "focusVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "padding": "padding",
        "padding_var": "paddingVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFaceCrop:
    def __init__(
        self,
        *,
        algorithm: typing.Optional[builtins.str] = None,
        algorithm_var: typing.Optional[builtins.str] = None,
        confidence: typing.Optional[builtins.str] = None,
        confidence_var: typing.Optional[builtins.str] = None,
        fail_gravity: typing.Optional[builtins.str] = None,
        fail_gravity_var: typing.Optional[builtins.str] = None,
        focus: typing.Optional[builtins.str] = None,
        focus_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param algorithm: Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm DataAkamaiImagingPolicyImage#algorithm}
        :param algorithm_var: Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm_var DataAkamaiImagingPolicyImage#algorithm_var}
        :param confidence: With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image. Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence DataAkamaiImagingPolicyImage#confidence}
        :param confidence_var: With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image. Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence_var DataAkamaiImagingPolicyImage#confidence_var}
        :param fail_gravity: Controls placement of the crop if Image and Video Manager does not detect any faces in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        :param fail_gravity_var: Controls placement of the crop if Image and Video Manager does not detect any faces in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        :param focus: Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus DataAkamaiImagingPolicyImage#focus}
        :param focus_var: Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus_var DataAkamaiImagingPolicyImage#focus_var}
        :param gravity: Controls placement of the crop. Directions are relative to the face(s) plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Controls placement of the crop. Directions are relative to the face(s) plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param padding: The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        :param style: Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cb5cb167dd4f2ce25d4acf439d727e80bd8f14a9aba9d71b9d7374458399ff37)
            check_type(argname="argument algorithm", value=algorithm, expected_type=type_hints["algorithm"])
            check_type(argname="argument algorithm_var", value=algorithm_var, expected_type=type_hints["algorithm_var"])
            check_type(argname="argument confidence", value=confidence, expected_type=type_hints["confidence"])
            check_type(argname="argument confidence_var", value=confidence_var, expected_type=type_hints["confidence_var"])
            check_type(argname="argument fail_gravity", value=fail_gravity, expected_type=type_hints["fail_gravity"])
            check_type(argname="argument fail_gravity_var", value=fail_gravity_var, expected_type=type_hints["fail_gravity_var"])
            check_type(argname="argument focus", value=focus, expected_type=type_hints["focus"])
            check_type(argname="argument focus_var", value=focus_var, expected_type=type_hints["focus_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if algorithm is not None:
            self._values["algorithm"] = algorithm
        if algorithm_var is not None:
            self._values["algorithm_var"] = algorithm_var
        if confidence is not None:
            self._values["confidence"] = confidence
        if confidence_var is not None:
            self._values["confidence_var"] = confidence_var
        if fail_gravity is not None:
            self._values["fail_gravity"] = fail_gravity
        if fail_gravity_var is not None:
            self._values["fail_gravity_var"] = fail_gravity_var
        if focus is not None:
            self._values["focus"] = focus
        if focus_var is not None:
            self._values["focus_var"] = focus_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def algorithm(self) -> typing.Optional[builtins.str]:
        '''Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm DataAkamaiImagingPolicyImage#algorithm}
        '''
        result = self._values.get("algorithm")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def algorithm_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm_var DataAkamaiImagingPolicyImage#algorithm_var}
        '''
        result = self._values.get("algorithm_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def confidence(self) -> typing.Optional[builtins.str]:
        '''With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image.

        Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence DataAkamaiImagingPolicyImage#confidence}
        '''
        result = self._values.get("confidence")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def confidence_var(self) -> typing.Optional[builtins.str]:
        '''With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image.

        Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence_var DataAkamaiImagingPolicyImage#confidence_var}
        '''
        result = self._values.get("confidence_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any faces in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        '''
        result = self._values.get("fail_gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any faces in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        '''
        result = self._values.get("fail_gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def focus(self) -> typing.Optional[builtins.str]:
        '''Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus DataAkamaiImagingPolicyImage#focus}
        '''
        result = self._values.get("focus")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def focus_var(self) -> typing.Optional[builtins.str]:
        '''Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus_var DataAkamaiImagingPolicyImage#focus_var}
        '''
        result = self._values.get("focus_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the face(s) plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the face(s) plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFaceCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFaceCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFaceCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__539f05145b0c609b3d59433e82ea3727f1c2eb07f957993cbb95ae3071a5d23a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFaceCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__73549aaef9a583d91213fbed1d3065d82a8c1afa4fa67adf56472dba8e8b7732)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFaceCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fb072faad5158e976c567b933bcd5bea95cb09b45242ca94c41196b801a53132)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__651da22bafa7d09ffa62472ea4db3ee8d3b1ff684c9148d2bd20630e38a1af2d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1d21b04bf6911e0f5040f1759ea4b0fb9fd165329439d2defd4018794a1ada12)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFaceCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFaceCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFaceCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7e9c0d554a2bcfb8ca80e96cafdc242f30fcaf3a3ba8e237835fd9de71100bfe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFaceCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFaceCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c345e54e0cad98d26f0a3e3bd25644f8dfb1eca0e06a19559b7f00027ff3789b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAlgorithm")
    def reset_algorithm(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAlgorithm", []))

    @jsii.member(jsii_name="resetAlgorithmVar")
    def reset_algorithm_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAlgorithmVar", []))

    @jsii.member(jsii_name="resetConfidence")
    def reset_confidence(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetConfidence", []))

    @jsii.member(jsii_name="resetConfidenceVar")
    def reset_confidence_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetConfidenceVar", []))

    @jsii.member(jsii_name="resetFailGravity")
    def reset_fail_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravity", []))

    @jsii.member(jsii_name="resetFailGravityVar")
    def reset_fail_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravityVar", []))

    @jsii.member(jsii_name="resetFocus")
    def reset_focus(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFocus", []))

    @jsii.member(jsii_name="resetFocusVar")
    def reset_focus_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFocusVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="algorithmInput")
    def algorithm_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "algorithmInput"))

    @builtins.property
    @jsii.member(jsii_name="algorithmVarInput")
    def algorithm_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "algorithmVarInput"))

    @builtins.property
    @jsii.member(jsii_name="confidenceInput")
    def confidence_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "confidenceInput"))

    @builtins.property
    @jsii.member(jsii_name="confidenceVarInput")
    def confidence_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "confidenceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityInput")
    def fail_gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityVarInput")
    def fail_gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="focusInput")
    def focus_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "focusInput"))

    @builtins.property
    @jsii.member(jsii_name="focusVarInput")
    def focus_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "focusVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="algorithm")
    def algorithm(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "algorithm"))

    @algorithm.setter
    def algorithm(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a08a42a3625ecac70b59fc28933dda8a8552c1b7542539f4c9b47913466a40e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "algorithm", value)

    @builtins.property
    @jsii.member(jsii_name="algorithmVar")
    def algorithm_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "algorithmVar"))

    @algorithm_var.setter
    def algorithm_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__57d7995877add8ebaba5ff50a9721bb965210ef43d662cde073d46de3b4c9c0c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "algorithmVar", value)

    @builtins.property
    @jsii.member(jsii_name="confidence")
    def confidence(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "confidence"))

    @confidence.setter
    def confidence(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7ae74b1a89cc4bcb698acec8bff47c15d89aa3b6dc03f5899d490e7b593eaa25)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "confidence", value)

    @builtins.property
    @jsii.member(jsii_name="confidenceVar")
    def confidence_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "confidenceVar"))

    @confidence_var.setter
    def confidence_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__760343801bf8028a824fb23e1da34d03abcc304979aea84b6bfcffc6dd679706)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "confidenceVar", value)

    @builtins.property
    @jsii.member(jsii_name="failGravity")
    def fail_gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravity"))

    @fail_gravity.setter
    def fail_gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__57e7e21d8a4eff8fc7f08a43ab6c7c328988e2954a9acd32aa208fa897cc1d45)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravity", value)

    @builtins.property
    @jsii.member(jsii_name="failGravityVar")
    def fail_gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravityVar"))

    @fail_gravity_var.setter
    def fail_gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__854023198713cbbd6fca83d48fd8b9bc4ac2aa9912a0361608f099415d5e65f7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="focus")
    def focus(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "focus"))

    @focus.setter
    def focus(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d2d511289485d8a462b649bbc48a0dc6d3acb090784bc98c384a24c9d40e2052)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "focus", value)

    @builtins.property
    @jsii.member(jsii_name="focusVar")
    def focus_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "focusVar"))

    @focus_var.setter
    def focus_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5488f23f49ed3cd729dc4b2e32342de8c0fa6eaf1f03b4127bec086dd3aa888f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "focusVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8737df35414454608847755fb52df09fb2387724821a97ead67436d221bb82b8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ca4ca370166699e33c58b2e81fbf93dd95b134a8cd93c22a7dfcab5a87bca8ed)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__098ddcd61c40f51e76e6cb60eaae4b8c2090fd5f8fc3fe7dafda84a14f2f08c6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2caaa85fc5a90e723da1b0bbc6ec5bad96ade73334dacc0564cae3ecc93245b3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__81ff350862dd1b5ae76f064833cb3e457b6588431a77ee090150b6a49cef45a1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1c90955b734b0544dcbaacc052b95164ccd6bf105db072ae6256a0b23cc49d05)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fc40b17b032f80cc2d5f8993eae09b43f92b59ad1a69ed5f010d84bd8fea4400)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__81d4a3ebbeffabc13379bcfc97d05223996053f34ad9b62f2f435f0543139fcf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__78d7aa463d0848db46d9c80e595f662d3b7048d1d3d26394ba39efa5338b5402)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__83b8c2c1f8377fe3bb380669198695328a344b42606ec94c7b8af8c28b354ebc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFaceCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFaceCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFaceCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c96ac4250a28a88a07335255f1a7c1528110da69e7baa246a34d098dbcd725c3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFeatureCrop",
    jsii_struct_bases=[],
    name_mapping={
        "fail_gravity": "failGravity",
        "fail_gravity_var": "failGravityVar",
        "feature_radius": "featureRadius",
        "feature_radius_var": "featureRadiusVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "max_features": "maxFeatures",
        "max_features_var": "maxFeaturesVar",
        "min_feature_quality": "minFeatureQuality",
        "min_feature_quality_var": "minFeatureQualityVar",
        "padding": "padding",
        "padding_var": "paddingVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFeatureCrop:
    def __init__(
        self,
        *,
        fail_gravity: typing.Optional[builtins.str] = None,
        fail_gravity_var: typing.Optional[builtins.str] = None,
        feature_radius: typing.Optional[builtins.str] = None,
        feature_radius_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        max_features: typing.Optional[builtins.str] = None,
        max_features_var: typing.Optional[builtins.str] = None,
        min_feature_quality: typing.Optional[builtins.str] = None,
        min_feature_quality_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fail_gravity: Controls placement of the crop if Image and Video Manager does not detect any features in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        :param fail_gravity_var: Controls placement of the crop if Image and Video Manager does not detect any features in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        :param feature_radius: The size in pixels of the important features to search for. If identified, two features never appear closer together than this value, ``8.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius DataAkamaiImagingPolicyImage#feature_radius}
        :param feature_radius_var: The size in pixels of the important features to search for. If identified, two features never appear closer together than this value, ``8.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius_var DataAkamaiImagingPolicyImage#feature_radius_var}
        :param gravity: Controls placement of the crop. Directions are relative to the region of interest plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Controls placement of the crop. Directions are relative to the region of interest plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param max_features: The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features DataAkamaiImagingPolicyImage#max_features}
        :param max_features_var: The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features_var DataAkamaiImagingPolicyImage#max_features_var}
        :param min_feature_quality: Determines the minimum quality level of the feature identified. To consider a feature important, the feature needs to surpass this value. Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality DataAkamaiImagingPolicyImage#min_feature_quality}
        :param min_feature_quality_var: Determines the minimum quality level of the feature identified. To consider a feature important, the feature needs to surpass this value. Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality_var DataAkamaiImagingPolicyImage#min_feature_quality_var}
        :param padding: Adds space around the region of interest. The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: Adds space around the region of interest. The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        :param style: Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6a72a363f90150d7cded530ed43b426a7dd2b07f10bdd839d3e85d908a9306ba)
            check_type(argname="argument fail_gravity", value=fail_gravity, expected_type=type_hints["fail_gravity"])
            check_type(argname="argument fail_gravity_var", value=fail_gravity_var, expected_type=type_hints["fail_gravity_var"])
            check_type(argname="argument feature_radius", value=feature_radius, expected_type=type_hints["feature_radius"])
            check_type(argname="argument feature_radius_var", value=feature_radius_var, expected_type=type_hints["feature_radius_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument max_features", value=max_features, expected_type=type_hints["max_features"])
            check_type(argname="argument max_features_var", value=max_features_var, expected_type=type_hints["max_features_var"])
            check_type(argname="argument min_feature_quality", value=min_feature_quality, expected_type=type_hints["min_feature_quality"])
            check_type(argname="argument min_feature_quality_var", value=min_feature_quality_var, expected_type=type_hints["min_feature_quality_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fail_gravity is not None:
            self._values["fail_gravity"] = fail_gravity
        if fail_gravity_var is not None:
            self._values["fail_gravity_var"] = fail_gravity_var
        if feature_radius is not None:
            self._values["feature_radius"] = feature_radius
        if feature_radius_var is not None:
            self._values["feature_radius_var"] = feature_radius_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if max_features is not None:
            self._values["max_features"] = max_features
        if max_features_var is not None:
            self._values["max_features_var"] = max_features_var
        if min_feature_quality is not None:
            self._values["min_feature_quality"] = min_feature_quality
        if min_feature_quality_var is not None:
            self._values["min_feature_quality_var"] = min_feature_quality_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def fail_gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any features in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        '''
        result = self._values.get("fail_gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any features in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        '''
        result = self._values.get("fail_gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feature_radius(self) -> typing.Optional[builtins.str]:
        '''The size in pixels of the important features to search for.

        If identified, two features never appear closer together than this value, ``8.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius DataAkamaiImagingPolicyImage#feature_radius}
        '''
        result = self._values.get("feature_radius")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feature_radius_var(self) -> typing.Optional[builtins.str]:
        '''The size in pixels of the important features to search for.

        If identified, two features never appear closer together than this value, ``8.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius_var DataAkamaiImagingPolicyImage#feature_radius_var}
        '''
        result = self._values.get("feature_radius_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the region of interest plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the region of interest plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def max_features(self) -> typing.Optional[builtins.str]:
        '''The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features DataAkamaiImagingPolicyImage#max_features}
        '''
        result = self._values.get("max_features")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def max_features_var(self) -> typing.Optional[builtins.str]:
        '''The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features_var DataAkamaiImagingPolicyImage#max_features_var}
        '''
        result = self._values.get("max_features_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def min_feature_quality(self) -> typing.Optional[builtins.str]:
        '''Determines the minimum quality level of the feature identified.

        To consider a feature important, the feature needs to surpass this value.  Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality DataAkamaiImagingPolicyImage#min_feature_quality}
        '''
        result = self._values.get("min_feature_quality")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def min_feature_quality_var(self) -> typing.Optional[builtins.str]:
        '''Determines the minimum quality level of the feature identified.

        To consider a feature important, the feature needs to surpass this value.  Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality_var DataAkamaiImagingPolicyImage#min_feature_quality_var}
        '''
        result = self._values.get("min_feature_quality_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''Adds space around the region of interest.

        The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''Adds space around the region of interest.

        The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFeatureCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFeatureCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFeatureCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__83a9c34e39cc6df2a41c59f2218e85885389cc2c38bb7595171ab3529a553f99)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFeatureCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__916d9b124561c60f530627c4da8932ebbfff8acf316b3dbc19b20d5fb18d318e)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFeatureCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__16766bd143e13b14586cf676b4bed98ad866a47bf24e43d6fae05b4a494c4d68)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a3c6e0175b740df0043a96c17e74c01e36f3da88d0aaa78acac508526c96d11c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a33768c83a261e80a0f597b86c10717fec7ae3251163df82ed01c3269ea902c8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFeatureCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFeatureCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFeatureCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__89eaa45de187620c75a407ee4bd00f0c4068e0c11ef17b239f30b28d35eb4341)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFeatureCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFeatureCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__073a47ad4d50ab89a47c8ec774f26875ed6862d2cc6dd40a01fd501db61fa040)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetFailGravity")
    def reset_fail_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravity", []))

    @jsii.member(jsii_name="resetFailGravityVar")
    def reset_fail_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravityVar", []))

    @jsii.member(jsii_name="resetFeatureRadius")
    def reset_feature_radius(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureRadius", []))

    @jsii.member(jsii_name="resetFeatureRadiusVar")
    def reset_feature_radius_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureRadiusVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetMaxFeatures")
    def reset_max_features(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxFeatures", []))

    @jsii.member(jsii_name="resetMaxFeaturesVar")
    def reset_max_features_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxFeaturesVar", []))

    @jsii.member(jsii_name="resetMinFeatureQuality")
    def reset_min_feature_quality(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMinFeatureQuality", []))

    @jsii.member(jsii_name="resetMinFeatureQualityVar")
    def reset_min_feature_quality_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMinFeatureQualityVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="failGravityInput")
    def fail_gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityVarInput")
    def fail_gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featureRadiusInput")
    def feature_radius_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featureRadiusInput"))

    @builtins.property
    @jsii.member(jsii_name="featureRadiusVarInput")
    def feature_radius_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featureRadiusVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesInput")
    def max_features_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "maxFeaturesInput"))

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesVarInput")
    def max_features_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "maxFeaturesVarInput"))

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityInput")
    def min_feature_quality_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "minFeatureQualityInput"))

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityVarInput")
    def min_feature_quality_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "minFeatureQualityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravity")
    def fail_gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravity"))

    @fail_gravity.setter
    def fail_gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__728e505de315616d9a5d53406498bb3c4393b44291679ffa8768f1ea57cc45aa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravity", value)

    @builtins.property
    @jsii.member(jsii_name="failGravityVar")
    def fail_gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravityVar"))

    @fail_gravity_var.setter
    def fail_gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__92cd3a5122cd91ce777c6c66eb07c68d83d203be7f862a4c73bbe311783e1730)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="featureRadius")
    def feature_radius(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featureRadius"))

    @feature_radius.setter
    def feature_radius(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b3f43a7e36a1a010681bca759718077e8c9ea5022b1dede9367c44b269019725)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featureRadius", value)

    @builtins.property
    @jsii.member(jsii_name="featureRadiusVar")
    def feature_radius_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featureRadiusVar"))

    @feature_radius_var.setter
    def feature_radius_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__db2d530e0f4c274791270798724e49daa0efc32577e5de138b52427ef100a05a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featureRadiusVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4d835b5d6a3b6d26b082afc33a8e582f82979fa8a6a886db782a277c46c97d1b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__442049bfd2f9d05592de36f04c64ec7360d168c9d35651aeef358eea6e746dec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__91947f565a10d16c6c194a22ac763391d1476fdf32294acb8fbd8ce759b1806f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6fd0cd2beceec31a4be9cbb85d99022963c25a72b3a3479e63bad702ac045cee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="maxFeatures")
    def max_features(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "maxFeatures"))

    @max_features.setter
    def max_features(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7c4422cfcde300f52b8b82259ca9b80b197dd7fbe70d05d6c34009c35251f5b8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "maxFeatures", value)

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesVar")
    def max_features_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "maxFeaturesVar"))

    @max_features_var.setter
    def max_features_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__82e8109c444b9e95d2846abb83028c8be94cf126a1cd2330d950ab5bc88cf5c3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "maxFeaturesVar", value)

    @builtins.property
    @jsii.member(jsii_name="minFeatureQuality")
    def min_feature_quality(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "minFeatureQuality"))

    @min_feature_quality.setter
    def min_feature_quality(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0d03b0d800c3e55c5be9f69cd509e49d1a073e51999990f1f5798731b64c3dde)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "minFeatureQuality", value)

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityVar")
    def min_feature_quality_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "minFeatureQualityVar"))

    @min_feature_quality_var.setter
    def min_feature_quality_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bdafbf70f038289bc47334fc667985b168ff32cf922e8733a14979c4d96c050d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "minFeatureQualityVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__67f850a67517979989477dbd2d9aec4c85662aa7f4aa76a9666e82212b60ce25)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dfb515bb100d29d3fdb61651c03fb6b9417f1ff3ed67c3295606991b2bfa983e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e412d7221e8e977340bab073be7510d041f3ed7a80c42b7f4bcb3a6e5d5984fb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cccd4c445a2a04783804a436344824d22b9aca298b268107c3241bb48615b160)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1d35f1cfa95d74465146dc1ad085e9763c82c646c5d385ce5fa2e431f11b9ca6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5af3a6637a6b27d3e0bb01d47a83a497c52b4ee4999e015f04cb5951c806d48a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFeatureCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFeatureCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFeatureCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1fb7a76fc1b8dce38fea51921c86cd4159f903087969428506de6747cff87840)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFill",
    jsii_struct_bases=[],
    name_mapping={
        "fill_transformation": "fillTransformation",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFill:
    def __init__(
        self,
        *,
        fill_transformation: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fill_transformation: fill_transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_transformation DataAkamaiImagingPolicyImage#fill_transformation}
        :param height: The height value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The width value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(fill_transformation, dict):
            fill_transformation = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformation(**fill_transformation)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cbd9dc11bf25aa7aed8e85610c23e8747d4efe34d7731e607f0af0e2a73c602e)
            check_type(argname="argument fill_transformation", value=fill_transformation, expected_type=type_hints["fill_transformation"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fill_transformation is not None:
            self._values["fill_transformation"] = fill_transformation
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def fill_transformation(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformation"]:
        '''fill_transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_transformation DataAkamaiImagingPolicyImage#fill_transformation}
        '''
        result = self._values.get("fill_transformation")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformation"], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFill(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformation",
    jsii_struct_bases=[],
    name_mapping={
        "append": "append",
        "aspect_crop": "aspectCrop",
        "background_color": "backgroundColor",
        "blur": "blur",
        "chroma_key": "chromaKey",
        "composite": "composite",
        "compound": "compound",
        "contrast": "contrast",
        "crop": "crop",
        "face_crop": "faceCrop",
        "feature_crop": "featureCrop",
        "fit_and_fill": "fitAndFill",
        "goop": "goop",
        "grayscale": "grayscale",
        "hsl": "hsl",
        "hsv": "hsv",
        "if_dimension": "ifDimension",
        "if_orientation": "ifOrientation",
        "im_query": "imQuery",
        "max_colors": "maxColors",
        "mirror": "mirror",
        "mono_hue": "monoHue",
        "opacity": "opacity",
        "region_of_interest_crop": "regionOfInterestCrop",
        "relative_crop": "relativeCrop",
        "remove_color": "removeColor",
        "resize": "resize",
        "rotate": "rotate",
        "scale": "scale",
        "shear": "shear",
        "trim": "trim",
        "unsharp_mask": "unsharpMask",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformation:
    def __init__(
        self,
        *,
        append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationAppend", typing.Dict[builtins.str, typing.Any]]]]] = None,
        aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationAspectCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationBackgroundColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationBlur", typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationChromaKey", typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationComposite", typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationCompound", typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationContrast", typing.Dict[builtins.str, typing.Any]]]]] = None,
        crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationFaceCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationFeatureCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationFitAndFill", typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationGoop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationGrayscale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationHsl", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationHsv", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfDimension", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfOrientation", typing.Dict[builtins.str, typing.Any]]]]] = None,
        im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationImQuery", typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationMaxColors", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationMirror", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationMonoHue", typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationOpacity", typing.Dict[builtins.str, typing.Any]]]]] = None,
        region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationRegionOfInterestCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationRelativeCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationRemoveColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationResize", typing.Dict[builtins.str, typing.Any]]]]] = None,
        rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationRotate", typing.Dict[builtins.str, typing.Any]]]]] = None,
        scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationScale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationShear", typing.Dict[builtins.str, typing.Any]]]]] = None,
        trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationTrim", typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationUnsharpMask", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param append: append block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        :param aspect_crop: aspect_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param crop: crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        :param face_crop: face_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        :param feature_crop: feature_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        :param fit_and_fill: fit_and_fill block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param im_query: im_query block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param region_of_interest_crop: region_of_interest_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        :param relative_crop: relative_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param resize: resize block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        :param rotate: rotate block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        :param scale: scale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param shear: shear block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        :param trim: trim block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b3d841b8f593857dd7d581408459bcbac3b023a89252329f1a61ec5752492daa)
            check_type(argname="argument append", value=append, expected_type=type_hints["append"])
            check_type(argname="argument aspect_crop", value=aspect_crop, expected_type=type_hints["aspect_crop"])
            check_type(argname="argument background_color", value=background_color, expected_type=type_hints["background_color"])
            check_type(argname="argument blur", value=blur, expected_type=type_hints["blur"])
            check_type(argname="argument chroma_key", value=chroma_key, expected_type=type_hints["chroma_key"])
            check_type(argname="argument composite", value=composite, expected_type=type_hints["composite"])
            check_type(argname="argument compound", value=compound, expected_type=type_hints["compound"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument crop", value=crop, expected_type=type_hints["crop"])
            check_type(argname="argument face_crop", value=face_crop, expected_type=type_hints["face_crop"])
            check_type(argname="argument feature_crop", value=feature_crop, expected_type=type_hints["feature_crop"])
            check_type(argname="argument fit_and_fill", value=fit_and_fill, expected_type=type_hints["fit_and_fill"])
            check_type(argname="argument goop", value=goop, expected_type=type_hints["goop"])
            check_type(argname="argument grayscale", value=grayscale, expected_type=type_hints["grayscale"])
            check_type(argname="argument hsl", value=hsl, expected_type=type_hints["hsl"])
            check_type(argname="argument hsv", value=hsv, expected_type=type_hints["hsv"])
            check_type(argname="argument if_dimension", value=if_dimension, expected_type=type_hints["if_dimension"])
            check_type(argname="argument if_orientation", value=if_orientation, expected_type=type_hints["if_orientation"])
            check_type(argname="argument im_query", value=im_query, expected_type=type_hints["im_query"])
            check_type(argname="argument max_colors", value=max_colors, expected_type=type_hints["max_colors"])
            check_type(argname="argument mirror", value=mirror, expected_type=type_hints["mirror"])
            check_type(argname="argument mono_hue", value=mono_hue, expected_type=type_hints["mono_hue"])
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument region_of_interest_crop", value=region_of_interest_crop, expected_type=type_hints["region_of_interest_crop"])
            check_type(argname="argument relative_crop", value=relative_crop, expected_type=type_hints["relative_crop"])
            check_type(argname="argument remove_color", value=remove_color, expected_type=type_hints["remove_color"])
            check_type(argname="argument resize", value=resize, expected_type=type_hints["resize"])
            check_type(argname="argument rotate", value=rotate, expected_type=type_hints["rotate"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument shear", value=shear, expected_type=type_hints["shear"])
            check_type(argname="argument trim", value=trim, expected_type=type_hints["trim"])
            check_type(argname="argument unsharp_mask", value=unsharp_mask, expected_type=type_hints["unsharp_mask"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if append is not None:
            self._values["append"] = append
        if aspect_crop is not None:
            self._values["aspect_crop"] = aspect_crop
        if background_color is not None:
            self._values["background_color"] = background_color
        if blur is not None:
            self._values["blur"] = blur
        if chroma_key is not None:
            self._values["chroma_key"] = chroma_key
        if composite is not None:
            self._values["composite"] = composite
        if compound is not None:
            self._values["compound"] = compound
        if contrast is not None:
            self._values["contrast"] = contrast
        if crop is not None:
            self._values["crop"] = crop
        if face_crop is not None:
            self._values["face_crop"] = face_crop
        if feature_crop is not None:
            self._values["feature_crop"] = feature_crop
        if fit_and_fill is not None:
            self._values["fit_and_fill"] = fit_and_fill
        if goop is not None:
            self._values["goop"] = goop
        if grayscale is not None:
            self._values["grayscale"] = grayscale
        if hsl is not None:
            self._values["hsl"] = hsl
        if hsv is not None:
            self._values["hsv"] = hsv
        if if_dimension is not None:
            self._values["if_dimension"] = if_dimension
        if if_orientation is not None:
            self._values["if_orientation"] = if_orientation
        if im_query is not None:
            self._values["im_query"] = im_query
        if max_colors is not None:
            self._values["max_colors"] = max_colors
        if mirror is not None:
            self._values["mirror"] = mirror
        if mono_hue is not None:
            self._values["mono_hue"] = mono_hue
        if opacity is not None:
            self._values["opacity"] = opacity
        if region_of_interest_crop is not None:
            self._values["region_of_interest_crop"] = region_of_interest_crop
        if relative_crop is not None:
            self._values["relative_crop"] = relative_crop
        if remove_color is not None:
            self._values["remove_color"] = remove_color
        if resize is not None:
            self._values["resize"] = resize
        if rotate is not None:
            self._values["rotate"] = rotate
        if scale is not None:
            self._values["scale"] = scale
        if shear is not None:
            self._values["shear"] = shear
        if trim is not None:
            self._values["trim"] = trim
        if unsharp_mask is not None:
            self._values["unsharp_mask"] = unsharp_mask

    @builtins.property
    def append(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationAppend"]]]:
        '''append block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        '''
        result = self._values.get("append")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationAppend"]]], result)

    @builtins.property
    def aspect_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationAspectCrop"]]]:
        '''aspect_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        '''
        result = self._values.get("aspect_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationAspectCrop"]]], result)

    @builtins.property
    def background_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationBackgroundColor"]]]:
        '''background_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        '''
        result = self._values.get("background_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationBackgroundColor"]]], result)

    @builtins.property
    def blur(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationBlur"]]]:
        '''blur block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        '''
        result = self._values.get("blur")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationBlur"]]], result)

    @builtins.property
    def chroma_key(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationChromaKey"]]]:
        '''chroma_key block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        '''
        result = self._values.get("chroma_key")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationChromaKey"]]], result)

    @builtins.property
    def composite(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationComposite"]]]:
        '''composite block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        '''
        result = self._values.get("composite")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationComposite"]]], result)

    @builtins.property
    def compound(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationCompound"]]]:
        '''compound block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        '''
        result = self._values.get("compound")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationCompound"]]], result)

    @builtins.property
    def contrast(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationContrast"]]]:
        '''contrast block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationContrast"]]], result)

    @builtins.property
    def crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationCrop"]]]:
        '''crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        '''
        result = self._values.get("crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationCrop"]]], result)

    @builtins.property
    def face_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationFaceCrop"]]]:
        '''face_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        '''
        result = self._values.get("face_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationFaceCrop"]]], result)

    @builtins.property
    def feature_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationFeatureCrop"]]]:
        '''feature_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        '''
        result = self._values.get("feature_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationFeatureCrop"]]], result)

    @builtins.property
    def fit_and_fill(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationFitAndFill"]]]:
        '''fit_and_fill block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        '''
        result = self._values.get("fit_and_fill")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationFitAndFill"]]], result)

    @builtins.property
    def goop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationGoop"]]]:
        '''goop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        '''
        result = self._values.get("goop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationGoop"]]], result)

    @builtins.property
    def grayscale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationGrayscale"]]]:
        '''grayscale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        '''
        result = self._values.get("grayscale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationGrayscale"]]], result)

    @builtins.property
    def hsl(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationHsl"]]]:
        '''hsl block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        '''
        result = self._values.get("hsl")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationHsl"]]], result)

    @builtins.property
    def hsv(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationHsv"]]]:
        '''hsv block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        '''
        result = self._values.get("hsv")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationHsv"]]], result)

    @builtins.property
    def if_dimension(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfDimension"]]]:
        '''if_dimension block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        '''
        result = self._values.get("if_dimension")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfDimension"]]], result)

    @builtins.property
    def if_orientation(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfOrientation"]]]:
        '''if_orientation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        '''
        result = self._values.get("if_orientation")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfOrientation"]]], result)

    @builtins.property
    def im_query(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationImQuery"]]]:
        '''im_query block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        '''
        result = self._values.get("im_query")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationImQuery"]]], result)

    @builtins.property
    def max_colors(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationMaxColors"]]]:
        '''max_colors block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        '''
        result = self._values.get("max_colors")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationMaxColors"]]], result)

    @builtins.property
    def mirror(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationMirror"]]]:
        '''mirror block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        '''
        result = self._values.get("mirror")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationMirror"]]], result)

    @builtins.property
    def mono_hue(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationMonoHue"]]]:
        '''mono_hue block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        '''
        result = self._values.get("mono_hue")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationMonoHue"]]], result)

    @builtins.property
    def opacity(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationOpacity"]]]:
        '''opacity block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationOpacity"]]], result)

    @builtins.property
    def region_of_interest_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationRegionOfInterestCrop"]]]:
        '''region_of_interest_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        '''
        result = self._values.get("region_of_interest_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationRegionOfInterestCrop"]]], result)

    @builtins.property
    def relative_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationRelativeCrop"]]]:
        '''relative_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        '''
        result = self._values.get("relative_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationRelativeCrop"]]], result)

    @builtins.property
    def remove_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationRemoveColor"]]]:
        '''remove_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        '''
        result = self._values.get("remove_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationRemoveColor"]]], result)

    @builtins.property
    def resize(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationResize"]]]:
        '''resize block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        '''
        result = self._values.get("resize")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationResize"]]], result)

    @builtins.property
    def rotate(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationRotate"]]]:
        '''rotate block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        '''
        result = self._values.get("rotate")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationRotate"]]], result)

    @builtins.property
    def scale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationScale"]]]:
        '''scale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationScale"]]], result)

    @builtins.property
    def shear(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationShear"]]]:
        '''shear block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        '''
        result = self._values.get("shear")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationShear"]]], result)

    @builtins.property
    def trim(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationTrim"]]]:
        '''trim block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        '''
        result = self._values.get("trim")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationTrim"]]], result)

    @builtins.property
    def unsharp_mask(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationUnsharpMask"]]]:
        '''unsharp_mask block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        result = self._values.get("unsharp_mask")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationUnsharpMask"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationAppend",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_priority": "gravityPriority",
        "gravity_priority_var": "gravityPriorityVar",
        "gravity_var": "gravityVar",
        "preserve_minor_dimension": "preserveMinorDimension",
        "preserve_minor_dimension_var": "preserveMinorDimensionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationAppend:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationAppendImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_priority: typing.Optional[builtins.str] = None,
        gravity_priority_var: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        preserve_minor_dimension: typing.Optional[builtins.str] = None,
        preserve_minor_dimension_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Specifies where to place the ``image`` relative to the source image. The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_priority: Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal. The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority DataAkamaiImagingPolicyImage#gravity_priority}
        :param gravity_priority_var: Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal. The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority_var DataAkamaiImagingPolicyImage#gravity_priority_var}
        :param gravity_var: Specifies where to place the ``image`` relative to the source image. The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param preserve_minor_dimension: Whether to preserve the source image's minor dimension, ``false`` by default. The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension DataAkamaiImagingPolicyImage#preserve_minor_dimension}
        :param preserve_minor_dimension_var: Whether to preserve the source image's minor dimension, ``false`` by default. The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension_var DataAkamaiImagingPolicyImage#preserve_minor_dimension_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationAppendImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0fe6d273285f72ee9c50bcf2b68947a4dcfba4d008526b263fe16d2914521dc1)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_priority", value=gravity_priority, expected_type=type_hints["gravity_priority"])
            check_type(argname="argument gravity_priority_var", value=gravity_priority_var, expected_type=type_hints["gravity_priority_var"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument preserve_minor_dimension", value=preserve_minor_dimension, expected_type=type_hints["preserve_minor_dimension"])
            check_type(argname="argument preserve_minor_dimension_var", value=preserve_minor_dimension_var, expected_type=type_hints["preserve_minor_dimension_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_priority is not None:
            self._values["gravity_priority"] = gravity_priority
        if gravity_priority_var is not None:
            self._values["gravity_priority_var"] = gravity_priority_var
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if preserve_minor_dimension is not None:
            self._values["preserve_minor_dimension"] = preserve_minor_dimension
        if preserve_minor_dimension_var is not None:
            self._values["preserve_minor_dimension_var"] = preserve_minor_dimension_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationAppendImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationAppendImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Specifies where to place the ``image`` relative to the source image.

        The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_priority(self) -> typing.Optional[builtins.str]:
        '''Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal.

        The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority DataAkamaiImagingPolicyImage#gravity_priority}
        '''
        result = self._values.get("gravity_priority")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_priority_var(self) -> typing.Optional[builtins.str]:
        '''Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal.

        The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority_var DataAkamaiImagingPolicyImage#gravity_priority_var}
        '''
        result = self._values.get("gravity_priority_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Specifies where to place the ``image`` relative to the source image.

        The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def preserve_minor_dimension(self) -> typing.Optional[builtins.str]:
        '''Whether to preserve the source image's minor dimension, ``false`` by default.

        The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension DataAkamaiImagingPolicyImage#preserve_minor_dimension}
        '''
        result = self._values.get("preserve_minor_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def preserve_minor_dimension_var(self) -> typing.Optional[builtins.str]:
        '''Whether to preserve the source image's minor dimension, ``false`` by default.

        The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension_var DataAkamaiImagingPolicyImage#preserve_minor_dimension_var}
        '''
        result = self._values.get("preserve_minor_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationAppend(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationAppendImage",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationAppendImage:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationAppendImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationAppendImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationAppendImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__981e9ef32b543cc2882ef2a96f86c5dd88714f78377dd61bfefd10ce76dc064c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationAppendImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationAppendImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationAppendImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__674761ca697cffe1ca3ac7bf43ffa784855fcdb5cb3de3d6afea7848cf86f748)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationAppendList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationAppendList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5e41975b9af90ca6aa0cd8df372a107643da76140979538bc1e90f5e59e63f76)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationAppendOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__35e5e5a98b1acc81a34d8d9d85c475f78358b6911249509d57b680ad750441d6)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationAppendOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2580ceb7fb04b965cc67334361479cd4e2df0dae08532bafc6292f11d96239e3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3509ae135382cd01c64d9b047369397d90e286bcd52cb21fccc65d4504db7508)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__15000dc60ad83beff26c1cee639c33f11d5676a37470c444918e7541f4743445)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationAppend]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationAppend]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationAppend]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fc4b953a78b81f16172c3f6623975cd81a6b472ebd6d8f7c546fe82a715f027b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationAppendOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationAppendOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f70e89e29a7433b0ee7de2e9b6316131a89cee9eb68444626579336b8933b7eb)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationAppendImage()

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityPriority")
    def reset_gravity_priority(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityPriority", []))

    @jsii.member(jsii_name="resetGravityPriorityVar")
    def reset_gravity_priority_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityPriorityVar", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPreserveMinorDimension")
    def reset_preserve_minor_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPreserveMinorDimension", []))

    @jsii.member(jsii_name="resetPreserveMinorDimensionVar")
    def reset_preserve_minor_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPreserveMinorDimensionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationAppendImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationAppendImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityInput")
    def gravity_priority_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityPriorityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityVarInput")
    def gravity_priority_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityPriorityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationAppendImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationAppendImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionInput")
    def preserve_minor_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "preserveMinorDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionVarInput")
    def preserve_minor_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "preserveMinorDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e9fb57031044cfe853655a8447e31661a10c34179d08b98d08810bb18b2c31aa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityPriority")
    def gravity_priority(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityPriority"))

    @gravity_priority.setter
    def gravity_priority(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c5790ef94294bfe3e1a4defc5a7c72c2905ad7f45defff7a7046e68d46ce9372)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityPriority", value)

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityVar")
    def gravity_priority_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityPriorityVar"))

    @gravity_priority_var.setter
    def gravity_priority_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2e750e29521d1835fc3ed3b24b461102b4260d8a903f0e0deac228b94cb3c4fa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityPriorityVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7a1c31df74d30eb0e57abbc391419b4963557e5e327bb71127c0a426fa9a7ac0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimension")
    def preserve_minor_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "preserveMinorDimension"))

    @preserve_minor_dimension.setter
    def preserve_minor_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5edc94ed3dff2b53a7b6786da61cec98a142a10112057707db961ba1ddc3c537)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "preserveMinorDimension", value)

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionVar")
    def preserve_minor_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "preserveMinorDimensionVar"))

    @preserve_minor_dimension_var.setter
    def preserve_minor_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7a7b501606374e0d690a0742633bf04096d6bce1fd032a61f0ffab00100e1e83)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "preserveMinorDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationAppend]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationAppend]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationAppend]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bcb06ac66b5f7e4c285dca3d2478af318826714c638017d9913f25a4f1321afb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationAspectCrop",
    jsii_struct_bases=[],
    name_mapping={
        "allow_expansion": "allowExpansion",
        "allow_expansion_var": "allowExpansionVar",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationAspectCrop:
    def __init__(
        self,
        *,
        allow_expansion: typing.Optional[builtins.str] = None,
        allow_expansion_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_expansion: Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image. Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        :param allow_expansion_var: Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image. Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        :param height: The height term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The width term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        :param x_position: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df3674449c5101874484a4dcc669f822c49df5e6fdea109652bcfc4617a245ac)
            check_type(argname="argument allow_expansion", value=allow_expansion, expected_type=type_hints["allow_expansion"])
            check_type(argname="argument allow_expansion_var", value=allow_expansion_var, expected_type=type_hints["allow_expansion_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if allow_expansion is not None:
            self._values["allow_expansion"] = allow_expansion
        if allow_expansion_var is not None:
            self._values["allow_expansion_var"] = allow_expansion_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def allow_expansion(self) -> typing.Optional[builtins.str]:
        '''Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image.

        Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        '''
        result = self._values.get("allow_expansion")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def allow_expansion_var(self) -> typing.Optional[builtins.str]:
        '''Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image.

        Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        '''
        result = self._values.get("allow_expansion_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationAspectCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationAspectCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationAspectCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d58703c0e0353617abec5425c77a288baeb8ae7d3971dc88d6c110215bf7f7c5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationAspectCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a63b098793c8867d01e0e9be3b204770a1fe6be82158bfec044487de21af5b44)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationAspectCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__102cecc83540ecadabe4d34fa42c688315a80a4dfd20cf88563468e8f0d55121)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c384fb29cc09c00c55f7c634956d997c26e6183cca36a946747e6acf7000b868)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cb1f1afb2f59b5c1a11f6e30065f90afc54f10aa7a714e9f059dccf41fe9fed2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationAspectCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationAspectCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationAspectCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e053a6cc6d12be992618f10dd1f40f9409f02025114cd012088fc0bbcb2e21e0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationAspectCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationAspectCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1e92367be572ff99b33639f7b877d5f24f6f794ce5362bf47fbb1eb256ee3f44)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAllowExpansion")
    def reset_allow_expansion(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansion", []))

    @jsii.member(jsii_name="resetAllowExpansionVar")
    def reset_allow_expansion_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansionVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionInput")
    def allow_expansion_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVarInput")
    def allow_expansion_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansion")
    def allow_expansion(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansion"))

    @allow_expansion.setter
    def allow_expansion(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__41e8a8017a7af8a271e70d861b5ddc58de5c5d6349f6322961990a2631ef2aa1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansion", value)

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVar")
    def allow_expansion_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansionVar"))

    @allow_expansion_var.setter
    def allow_expansion_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__219fdabadb457ba1d1edd7aacc1ec442cd7e1c81a53499d70565f1cf2739ceeb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansionVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__84c77a24c9c2e02159f7b2fb83ae6a824f158e845744e2bcfb6d7f99ba4e1b72)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d4f1184a46818bb7bdc5edde4d71509b4edf9ec547ea41a2da6fcf2173fee0da)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6d61da3456bd671638ebd739363f4a8003987c090cfe9f3a82d6638c33888b8c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6733a7f3e0e4f900911b46cea49d2d28d5e51e65cee7ee79c60aa24f06e0ab6a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__417a8222b8578bd3e6370d5fad3937acb42b28a1b8597473b460bfd5bb4d0f07)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c9483bc22d2de6b7b6d409ea22fd4840c05c7af71121b47fcdc5170f77e57a9a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__38fba26fbe1bbfadbaa27fb5b0b8398439d39d543d3598d6497fc7ca2be7b0a6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__287f80ecbb8bfa4084ac643637d69036f6d6a9f5c96e41660c0198bdc74a3b90)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationAspectCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationAspectCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationAspectCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b4bb0330795f1f7e87685133a9c2c3e2628a8b44fefb24a3093c5b0fcf3d3de3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationBackgroundColor",
    jsii_struct_bases=[],
    name_mapping={"color": "color", "color_var": "colorVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationBackgroundColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1fe256b1e84ee5b482ee4441ff1303d5672bc2c697bc2c5192f8713b2d4d46f3)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationBackgroundColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationBackgroundColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationBackgroundColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bbabc4029c08883b55840c924543685d35aa2c8410e1e060630995d80516e271)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationBackgroundColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b70f37f54856858b9f7e19b376b6ced788586bfb5fa1cc71f7a37d77a1eae584)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationBackgroundColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4436621921bf4ffa91584e34af1418eed49dfe3806a1a6d4d95d8854526883a4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ca792045af738a30ec1f9a369519fd960574274857974bf9568c87908689e784)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__21121254ca727c594bcf8648e82d46a6ef4cfae5ccbd8839bab50d901a670d9c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationBackgroundColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationBackgroundColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__376424791f4455a0b53e7ea7abb8a9d229120e89eb2a810df3d5c11d06434f8b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationBackgroundColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationBackgroundColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e945a0327043cb8bd757ec64dbdb98561ffbbdd9a007ccc70843fdfa8f8c0c73)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d3332855e75e7bdca07aa01e238bb91bc1eea9b9950385ed3037472fb720d31f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eb1aa1bfaa0d61fe8fbadec8286c41f907080bf5aafeb19c0d17a91d9f3ca66b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationBackgroundColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationBackgroundColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationBackgroundColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__378d365368237ae505488143b509152b6e2d644e1b893c998459092cdb40e8c6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationBlur",
    jsii_struct_bases=[],
    name_mapping={"sigma": "sigma", "sigma_var": "sigmaVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationBlur:
    def __init__(
        self,
        *,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param sigma: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__413447ab66f2944a127c89370bee2a0f3753bfe44d84ef1e09221dbb873d9ff3)
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationBlur(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationBlurList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationBlurList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9b59b992576ee0841159ba169a495e6bb38b3c6d23ef86185b7f278e030e32bc)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationBlurOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9671641b9278e45d662ccb4f072c6f0de235e46e1f63dec190efa79b7738ee0b)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationBlurOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ba40e09d574a42dac35fb042b37b7dac37cad64b7d31055487ce9e97b4c94b5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9bb15f24fda8786689be33a598d464b92072477db2a8f3cb926fa6855d3694c4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c27e62e81173787faa1301ef9d8200522de28bcf7e9089be57945c7a5eb9dd0e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationBlur]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationBlur]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1cb1b4bb8a046d0db1df4e068553a67e1581c5750602a88d66b48b2ae205864f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationBlurOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationBlurOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b60b9e553107e424612676430098ca22940c2fe71be82dcdd8eec88c81a90140)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3f498fd35f9d165f1e35b73a0584b3475f5428a6fc1ab89c7bb8f014b5e2d39e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b1cf3568a13ecd356dc7253b5ac3621b4f162975b6af32b5a266004e6fbdbdfb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationBlur]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationBlur]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationBlur]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7c8a1b0e63b3f4b805b51dfad4ccc0d67be4db9c4af7bdafca0324657812b927)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationChromaKey",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_feather": "hueFeather",
        "hue_feather_var": "hueFeatherVar",
        "hue_tolerance": "hueTolerance",
        "hue_tolerance_var": "hueToleranceVar",
        "hue_var": "hueVar",
        "lightness_feather": "lightnessFeather",
        "lightness_feather_var": "lightnessFeatherVar",
        "lightness_tolerance": "lightnessTolerance",
        "lightness_tolerance_var": "lightnessToleranceVar",
        "saturation_feather": "saturationFeather",
        "saturation_feather_var": "saturationFeatherVar",
        "saturation_tolerance": "saturationTolerance",
        "saturation_tolerance_var": "saturationToleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationChromaKey:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_feather: typing.Optional[builtins.str] = None,
        hue_feather_var: typing.Optional[builtins.str] = None,
        hue_tolerance: typing.Optional[builtins.str] = None,
        hue_tolerance_var: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness_feather: typing.Optional[builtins.str] = None,
        lightness_feather_var: typing.Optional[builtins.str] = None,
        lightness_tolerance: typing.Optional[builtins.str] = None,
        lightness_tolerance_var: typing.Optional[builtins.str] = None,
        saturation_feather: typing.Optional[builtins.str] = None,
        saturation_feather_var: typing.Optional[builtins.str] = None,
        saturation_tolerance: typing.Optional[builtins.str] = None,
        saturation_tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_feather: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        :param hue_feather_var: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        :param hue_tolerance: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        :param hue_tolerance_var: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        :param hue_var: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness_feather: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        :param lightness_feather_var: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        :param lightness_tolerance: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        :param lightness_tolerance_var: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        :param saturation_feather: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        :param saturation_feather_var: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        :param saturation_tolerance: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        :param saturation_tolerance_var: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__43cc09c3a40a9383e402d46c8e503cc505f870658b6cc7ea4a459d10846d99e8)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_feather", value=hue_feather, expected_type=type_hints["hue_feather"])
            check_type(argname="argument hue_feather_var", value=hue_feather_var, expected_type=type_hints["hue_feather_var"])
            check_type(argname="argument hue_tolerance", value=hue_tolerance, expected_type=type_hints["hue_tolerance"])
            check_type(argname="argument hue_tolerance_var", value=hue_tolerance_var, expected_type=type_hints["hue_tolerance_var"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness_feather", value=lightness_feather, expected_type=type_hints["lightness_feather"])
            check_type(argname="argument lightness_feather_var", value=lightness_feather_var, expected_type=type_hints["lightness_feather_var"])
            check_type(argname="argument lightness_tolerance", value=lightness_tolerance, expected_type=type_hints["lightness_tolerance"])
            check_type(argname="argument lightness_tolerance_var", value=lightness_tolerance_var, expected_type=type_hints["lightness_tolerance_var"])
            check_type(argname="argument saturation_feather", value=saturation_feather, expected_type=type_hints["saturation_feather"])
            check_type(argname="argument saturation_feather_var", value=saturation_feather_var, expected_type=type_hints["saturation_feather_var"])
            check_type(argname="argument saturation_tolerance", value=saturation_tolerance, expected_type=type_hints["saturation_tolerance"])
            check_type(argname="argument saturation_tolerance_var", value=saturation_tolerance_var, expected_type=type_hints["saturation_tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_feather is not None:
            self._values["hue_feather"] = hue_feather
        if hue_feather_var is not None:
            self._values["hue_feather_var"] = hue_feather_var
        if hue_tolerance is not None:
            self._values["hue_tolerance"] = hue_tolerance
        if hue_tolerance_var is not None:
            self._values["hue_tolerance_var"] = hue_tolerance_var
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness_feather is not None:
            self._values["lightness_feather"] = lightness_feather
        if lightness_feather_var is not None:
            self._values["lightness_feather_var"] = lightness_feather_var
        if lightness_tolerance is not None:
            self._values["lightness_tolerance"] = lightness_tolerance
        if lightness_tolerance_var is not None:
            self._values["lightness_tolerance_var"] = lightness_tolerance_var
        if saturation_feather is not None:
            self._values["saturation_feather"] = saturation_feather
        if saturation_feather_var is not None:
            self._values["saturation_feather_var"] = saturation_feather_var
        if saturation_tolerance is not None:
            self._values["saturation_tolerance"] = saturation_tolerance
        if saturation_tolerance_var is not None:
            self._values["saturation_tolerance_var"] = saturation_tolerance_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        '''
        result = self._values.get("hue_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        '''
        result = self._values.get("hue_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        '''
        result = self._values.get("hue_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        '''
        result = self._values.get("hue_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        '''
        result = self._values.get("lightness_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        '''
        result = self._values.get("lightness_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        '''
        result = self._values.get("lightness_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        '''
        result = self._values.get("lightness_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        '''
        result = self._values.get("saturation_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        '''
        result = self._values.get("saturation_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        '''
        result = self._values.get("saturation_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        result = self._values.get("saturation_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationChromaKey(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationChromaKeyList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationChromaKeyList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f0c9810e5809bfd3d4fb407fb025b8eeebc02c3ad6bd10ed9444e8bad4a8a3a3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationChromaKeyOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__293ded71ef557376370fa36b64f95027eb4acee6fef9481b0e3169f6ffef26e4)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationChromaKeyOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__275841f210195ec33a4fb70126799fefff7554311420c3d66ffa32371f58401c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b9a2942a38ff2862c40157f0daed528bb92f8d26872b9a1255abe8ee4d88e233)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__62b2e3e3dbc62dba372d98006add69670c3dca1a4f22a262146dd149b03a5ec0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationChromaKey]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationChromaKey]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__871b2b9897ffff91d31e54728a215fe221022a6827a5594b4bee7774b5466bbd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationChromaKeyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationChromaKeyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__925381e31292a383f8cb4601fb879c6802e38ae3db8675d712dcd9e5b3acb322)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueFeather")
    def reset_hue_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeather", []))

    @jsii.member(jsii_name="resetHueFeatherVar")
    def reset_hue_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeatherVar", []))

    @jsii.member(jsii_name="resetHueTolerance")
    def reset_hue_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueTolerance", []))

    @jsii.member(jsii_name="resetHueToleranceVar")
    def reset_hue_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueToleranceVar", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightnessFeather")
    def reset_lightness_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeather", []))

    @jsii.member(jsii_name="resetLightnessFeatherVar")
    def reset_lightness_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeatherVar", []))

    @jsii.member(jsii_name="resetLightnessTolerance")
    def reset_lightness_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessTolerance", []))

    @jsii.member(jsii_name="resetLightnessToleranceVar")
    def reset_lightness_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessToleranceVar", []))

    @jsii.member(jsii_name="resetSaturationFeather")
    def reset_saturation_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeather", []))

    @jsii.member(jsii_name="resetSaturationFeatherVar")
    def reset_saturation_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeatherVar", []))

    @jsii.member(jsii_name="resetSaturationTolerance")
    def reset_saturation_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationTolerance", []))

    @jsii.member(jsii_name="resetSaturationToleranceVar")
    def reset_saturation_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherInput")
    def hue_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVarInput")
    def hue_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceInput")
    def hue_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVarInput")
    def hue_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherInput")
    def lightness_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVarInput")
    def lightness_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceInput")
    def lightness_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVarInput")
    def lightness_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherInput")
    def saturation_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVarInput")
    def saturation_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceInput")
    def saturation_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVarInput")
    def saturation_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0d1544886931fde90fa718fcd4d1d742826649011e21b55ab2b6a1f0936a9e00)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeather")
    def hue_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeather"))

    @hue_feather.setter
    def hue_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f69fed8d8b8a02431251508e5b391e41e3c6b673e6fae6582060334b83be508)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeather", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVar")
    def hue_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeatherVar"))

    @hue_feather_var.setter
    def hue_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__110e4beb0950f9476bc7ee76280d65704625addc6bc7a9268b82a947d4e99f31)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueTolerance")
    def hue_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueTolerance"))

    @hue_tolerance.setter
    def hue_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__63c674a507ca603dd2f90a04083c46a0294ea4dfa333e1b737829e00d8013f68)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVar")
    def hue_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueToleranceVar"))

    @hue_tolerance_var.setter
    def hue_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ba16c8692f5f3261df6362d5208c4796ba7b9cc3f80cfb2bc5eb81fb05c3c93)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a45f041833b710fa8bb1df33a915dcd3fc4b234a20318de6ee21785fc61c2356)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeather")
    def lightness_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeather"))

    @lightness_feather.setter
    def lightness_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__728f1c585dcd885349687b7d2699c6409eb0b6c881151bcd17a1c103306aba7c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeather", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVar")
    def lightness_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeatherVar"))

    @lightness_feather_var.setter
    def lightness_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d5fe457ce4352bfde6de83a00d40eea30d04dc3d5237f3356746a4e5f347880)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessTolerance")
    def lightness_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessTolerance"))

    @lightness_tolerance.setter
    def lightness_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3e684f4de0644ff446501380e4098a112a51ecdf2d5d4b15a6e5044ed3a0b7d7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVar")
    def lightness_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessToleranceVar"))

    @lightness_tolerance_var.setter
    def lightness_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__204731300620a1a6790fe57e11e25555c2ab361a3782145a6d36d3c9f9733389)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeather")
    def saturation_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeather"))

    @saturation_feather.setter
    def saturation_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__36b368310974c180feb2bf9c878bd1ee68cf50f6bc4e4523057c4d43b44dcb08)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeather", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVar")
    def saturation_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeatherVar"))

    @saturation_feather_var.setter
    def saturation_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc2fe29c8545e8bad0b36959da57ec4227d9d6589039e50fc875a6e08fede057)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationTolerance")
    def saturation_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationTolerance"))

    @saturation_tolerance.setter
    def saturation_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c4390b80e84ac85d280206abdecf2293d0654d126148c5e164731aa373f5cce7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVar")
    def saturation_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationToleranceVar"))

    @saturation_tolerance_var.setter
    def saturation_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__77bb9e7ab0a87ab67195b53f047a7938734337b1fd5b745f798cd2729bfc96a4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationChromaKey]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationChromaKey]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationChromaKey]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__406d01f4715b0a81bf6e8b2828643f355a59dc11d20855d873c8cb7c45e95c0e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationComposite",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "placement": "placement",
        "placement_var": "placementVar",
        "scale": "scale",
        "scale_dimension": "scaleDimension",
        "scale_dimension_var": "scaleDimensionVar",
        "scale_var": "scaleVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationComposite:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationCompositeImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        placement: typing.Optional[builtins.str] = None,
        placement_var: typing.Optional[builtins.str] = None,
        scale: typing.Optional[builtins.str] = None,
        scale_dimension: typing.Optional[builtins.str] = None,
        scale_dimension_var: typing.Optional[builtins.str] = None,
        scale_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param placement: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        :param placement_var: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        :param scale: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param scale_dimension: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        :param scale_dimension_var: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        :param scale_var: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        :param x_position: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationCompositeImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c6f613bf587670e55b22528962eac8a9d9d42844fa1c9a0eb7f1a20d9194e97b)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument placement", value=placement, expected_type=type_hints["placement"])
            check_type(argname="argument placement_var", value=placement_var, expected_type=type_hints["placement_var"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument scale_dimension", value=scale_dimension, expected_type=type_hints["scale_dimension"])
            check_type(argname="argument scale_dimension_var", value=scale_dimension_var, expected_type=type_hints["scale_dimension_var"])
            check_type(argname="argument scale_var", value=scale_var, expected_type=type_hints["scale_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if placement is not None:
            self._values["placement"] = placement
        if placement_var is not None:
            self._values["placement_var"] = placement_var
        if scale is not None:
            self._values["scale"] = scale
        if scale_dimension is not None:
            self._values["scale_dimension"] = scale_dimension
        if scale_dimension_var is not None:
            self._values["scale_dimension_var"] = scale_dimension_var
        if scale_var is not None:
            self._values["scale_var"] = scale_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationCompositeImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationCompositeImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        '''
        result = self._values.get("placement")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement_var(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        '''
        result = self._values.get("placement_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        '''
        result = self._values.get("scale_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        '''
        result = self._values.get("scale_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        '''
        result = self._values.get("scale_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationComposite(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationCompositeImage",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationCompositeImage:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationCompositeImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationCompositeImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationCompositeImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6628ce15eadcdd5e05a0f408e513fed53d5d8a669cd1f03e45508a5599738a44)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationCompositeImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationCompositeImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3dc3bf725314b8fd62950b37e90b54c4cb99910a96f466ef930e9d57bc8992f0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationCompositeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationCompositeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d3a197d2745453d814c5f3494d59d377a302ec055043b2930a609b195c34d536)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationCompositeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b0287ded8194c875ad6a56c1ce728b17b5f2eeaaa8d42eb8ffbbe7febee15d5d)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationCompositeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__38375288778c9958294acdd6d0e00a8a081947ed8981afa680bd11979b5bd083)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a41eda1194a491ac4963038c3bdec2520a3cbdbfee1f16e89018a47a70afb9ff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__766d571f62d900d4f1843459450e6c85d4e66d396dd476397db765cff620e1ad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationComposite]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationComposite]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6ec4d34ebac04a109abe8ce6ace3316fe3520f120ab252c0694ade8a7aff5f54)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationCompositeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationCompositeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e2ae2b48d95e1f2b2538ffd642034170dcb0a31ad1cb8b353e9948fa3c55ff90)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationCompositeImage()

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPlacement")
    def reset_placement(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacement", []))

    @jsii.member(jsii_name="resetPlacementVar")
    def reset_placement_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacementVar", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetScaleDimension")
    def reset_scale_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimension", []))

    @jsii.member(jsii_name="resetScaleDimensionVar")
    def reset_scale_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimensionVar", []))

    @jsii.member(jsii_name="resetScaleVar")
    def reset_scale_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationCompositeImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationCompositeImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationCompositeImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="placementInput")
    def placement_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementInput"))

    @builtins.property
    @jsii.member(jsii_name="placementVarInput")
    def placement_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionInput")
    def scale_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVarInput")
    def scale_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleVarInput")
    def scale_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ff41ff7afa163ee43c6175388478d771c8fa3d58a5b867924f3f0b979c6f5cbf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__204114051b38c1e627c1a1d8caf05990082f93e1887a45d15e516dbfab35c932)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="placement")
    def placement(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placement"))

    @placement.setter
    def placement(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fae0a60a26377abed8ff23bf6f7412dcc7c89716e1ad0aaf1e42114772941153)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placement", value)

    @builtins.property
    @jsii.member(jsii_name="placementVar")
    def placement_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placementVar"))

    @placement_var.setter
    def placement_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d5b3bd9fcb0e566874398224412ddbd3b94145d7b594f3517fe71995bbb505da)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placementVar", value)

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scale"))

    @scale.setter
    def scale(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__820e4e4a9c8838a179c37621fb2a53e2019e1c72c4690567d308681aa0a30997)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scale", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimension")
    def scale_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimension"))

    @scale_dimension.setter
    def scale_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__63e2d7106a7265f88cc418c14d1718e3820ed808f1b88f1daef54dffe07d127f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimension", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVar")
    def scale_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimensionVar"))

    @scale_dimension_var.setter
    def scale_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__330e088b10e2e7ded4a43d6b54f85e2133cc666d3d8f16debdb94400afede3cc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="scaleVar")
    def scale_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleVar"))

    @scale_var.setter
    def scale_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9c3a4e7b2a4652f5ec8be732a9965b6f3b4e7ab2b7f94a118b5a96b43658cdcb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__03c204db1073cd3d82fc0204eae0f1cb7c05d3df671eb30525e85a80e59ebfda)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8b03e729c89a5f59418d5045a18e54cdfa7efe136e6c38ab2c50bbde51bff124)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c670e1eb3f1d41765c875b54e9e9cc64f3920c391c9dfdf7813b22e209f2cc0e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__019328bfdb22626be6dd5d4b3ed8cb7e313cf2065254af55c10171b8fb9dae28)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationComposite]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationComposite]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationComposite]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c1dc2383761ff21dfbc86613b8d945f335faf9f1a14c728a2a3a84286b1c1d64)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationCompound",
    jsii_struct_bases=[],
    name_mapping={"transformations": "transformations"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationCompound:
    def __init__(
        self,
        *,
        transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param transformations: transformations block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a730689d609e1c0f5cddc9a23ea026e34e35dd602faf8d1e60225fbab4188eeb)
            check_type(argname="argument transformations", value=transformations, expected_type=type_hints["transformations"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if transformations is not None:
            self._values["transformations"] = transformations

    @builtins.property
    def transformations(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationCompoundTransformations"]]]:
        '''transformations block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        result = self._values.get("transformations")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationCompoundTransformations"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationCompound(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationCompoundList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationCompoundList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__48402fbc961b1f41a281647580d12415cb21e9d657a9b1ad229b34664ee4de64)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationCompoundOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c405ecc859ece98f6d130208afbb8b6b1c51c70066f9d3313b379c72cca24512)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationCompoundOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ed9bcbd9e485c32d6361c47aaf1a7c91ad5df3089d218ec83575c0021401b7fd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__21963e453cca505d5d5cf9b11427e9411e9bcf5c5f173d8bc7503ae9a55513c3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__757918abb167d41f95dbcce2e85ce3c1119ca4d61b4bb239760632c666370fda)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationCompound]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationCompound]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__36ead8748aea3722e09d0de18da729ab928e4e9991fe5290626cb915a954ce93)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationCompoundOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationCompoundOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ee7b1779fcc8a58ecb965b2dc20d19ab559692f092f804a631244ad52b755112)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformations")
    def put_transformations(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__18ff57f252708df9947fcab1dc7c563a630c467d0ab6f8a2bfc141ce984b8c72)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTransformations", [value]))

    @jsii.member(jsii_name="resetTransformations")
    def reset_transformations(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformations", []))

    @builtins.property
    @jsii.member(jsii_name="transformations")
    def transformations(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationCompoundTransformationsList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationCompoundTransformationsList", jsii.get(self, "transformations"))

    @builtins.property
    @jsii.member(jsii_name="transformationsInput")
    def transformations_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationCompoundTransformations"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationCompoundTransformations"]]], jsii.get(self, "transformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationCompound]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationCompound]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationCompound]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9b0874f8b4413867a0629d6d395c8139b0b20e6cf28e8a3c628acaa4726257cd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationCompoundTransformations",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationCompoundTransformations:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationCompoundTransformations(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationCompoundTransformationsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationCompoundTransformationsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0f48729034243b0ba264865ef10c227149d2c457a776468fd7beb667db6180de)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationCompoundTransformationsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ec2305c345b10838adcd14a4b32eb521d1b4c6507a02e79d4fab398d83bad476)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationCompoundTransformationsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9e7f8d3b07d378cc9e2751c27ff0d21e2baa1c1895ce7eabbe75752a90647305)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc9fe30902564b85c741f66ef97b50942ed2a5f1d1c5295d584ba7c1b1520538)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__420ec1cdb1ea08ee8b823e61f7037d73d029da2aa8415233e6310ecea2b99c45)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationCompoundTransformations]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationCompoundTransformations]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationCompoundTransformations]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b8830a4783807a8bad1e8ded6be2c4be1b61a4634d1fba36239b9e2cf8ff1054)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationCompoundTransformationsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationCompoundTransformationsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0b45d71cb5628ee0e24599fbf388f3778b903ed79dc1bb5645ff0b50cd2d6938)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationCompoundTransformations]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationCompoundTransformations]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationCompoundTransformations]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__241f658578d48669772cab98fb4839a4b5c4efde69a269fb53cd4d4f07c5aa25)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationContrast",
    jsii_struct_bases=[],
    name_mapping={
        "brightness": "brightness",
        "brightness_var": "brightnessVar",
        "contrast": "contrast",
        "contrast_var": "contrastVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationContrast:
    def __init__(
        self,
        *,
        brightness: typing.Optional[builtins.str] = None,
        brightness_var: typing.Optional[builtins.str] = None,
        contrast: typing.Optional[builtins.str] = None,
        contrast_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param brightness: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        :param brightness_var: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        :param contrast: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param contrast_var: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4e49ca7faa2b68a84a47014d0c3dcdb19367f6ce5d55246b95485bde50d4bd2b)
            check_type(argname="argument brightness", value=brightness, expected_type=type_hints["brightness"])
            check_type(argname="argument brightness_var", value=brightness_var, expected_type=type_hints["brightness_var"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument contrast_var", value=contrast_var, expected_type=type_hints["contrast_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if brightness is not None:
            self._values["brightness"] = brightness
        if brightness_var is not None:
            self._values["brightness_var"] = brightness_var
        if contrast is not None:
            self._values["contrast"] = contrast
        if contrast_var is not None:
            self._values["contrast_var"] = contrast_var

    @builtins.property
    def brightness(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        '''
        result = self._values.get("brightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def brightness_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        '''
        result = self._values.get("brightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        result = self._values.get("contrast_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationContrast(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationContrastList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationContrastList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f322d5ba0d4d5597fbc1b48df2a9dfdb4d0aa1705ea9399162826b57d722e86)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationContrastOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__82cc9c53676e31ec81a7c6130a5560437121561217c7e5656563673eef478f9a)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationContrastOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__411543f8e02ca8206060485de817dac06eeae75a399d1711c6cac6ce3a19864b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a1ae7fba953761c3f05e0fbdc05733f230489d417d322fe20256334682506c3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__94bd9a24770f546b25537447756f8588a256bc9c7df47f0d7d2b5cde68646229)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationContrast]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationContrast]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__86deba42f5bbb133a3ac715f932b01954a27e96d8df0f1d3def2ae51816c5b33)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationContrastOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationContrastOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c6e521883e98a156bdcd4b358e0fdd0d9c11252529d7fe8cbdd8aea6e52d0bf4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetBrightness")
    def reset_brightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightness", []))

    @jsii.member(jsii_name="resetBrightnessVar")
    def reset_brightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightnessVar", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetContrastVar")
    def reset_contrast_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrastVar", []))

    @builtins.property
    @jsii.member(jsii_name="brightnessInput")
    def brightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="brightnessVarInput")
    def brightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastVarInput")
    def contrast_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="brightness")
    def brightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightness"))

    @brightness.setter
    def brightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__09cbd7da8e26ac8a27b10ff8effbf4aa205d03536618069f1de067ed8e452ff5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightness", value)

    @builtins.property
    @jsii.member(jsii_name="brightnessVar")
    def brightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightnessVar"))

    @brightness_var.setter
    def brightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__edc608b3ab9754dcf632a9402a8e5eb95cf3f67758ea5e917f2f7afd2fdc1ef3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrast"))

    @contrast.setter
    def contrast(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f1ca572fcf10d9c17aa95d129b88cccbc0b44f5f1609fb9cd7b4261385a4faff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrast", value)

    @builtins.property
    @jsii.member(jsii_name="contrastVar")
    def contrast_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrastVar"))

    @contrast_var.setter
    def contrast_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__758a4da6cfef59f277a989a51793220ff2f6125855bae212813f811200247c87)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrastVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationContrast]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationContrast]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationContrast]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7b16cced07b64d632fd2a5126f547b53ac03ebc49908133d93d37b9009c5927c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationCrop",
    jsii_struct_bases=[],
    name_mapping={
        "allow_expansion": "allowExpansion",
        "allow_expansion_var": "allowExpansionVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationCrop:
    def __init__(
        self,
        *,
        allow_expansion: typing.Optional[builtins.str] = None,
        allow_expansion_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_expansion: If cropping an area outside of the existing canvas, expands the image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        :param allow_expansion_var: If cropping an area outside of the existing canvas, expands the image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        :param gravity: Frame of reference for X and Y Positions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Frame of reference for X and Y Positions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The number of pixels to crop along the y-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The number of pixels to crop along the y-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The number of pixels to crop along the x-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The number of pixels to crop along the x-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        :param x_position: The x-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8b8cbdb70c60bed1762ec0b4adc6c94a8beb0c61f7f891b163b6e0bd3b477a1c)
            check_type(argname="argument allow_expansion", value=allow_expansion, expected_type=type_hints["allow_expansion"])
            check_type(argname="argument allow_expansion_var", value=allow_expansion_var, expected_type=type_hints["allow_expansion_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if allow_expansion is not None:
            self._values["allow_expansion"] = allow_expansion
        if allow_expansion_var is not None:
            self._values["allow_expansion_var"] = allow_expansion_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def allow_expansion(self) -> typing.Optional[builtins.str]:
        '''If cropping an area outside of the existing canvas, expands the image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        '''
        result = self._values.get("allow_expansion")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def allow_expansion_var(self) -> typing.Optional[builtins.str]:
        '''If cropping an area outside of the existing canvas, expands the image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        '''
        result = self._values.get("allow_expansion_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Frame of reference for X and Y Positions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Frame of reference for X and Y Positions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the y-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the y-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the x-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the x-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__892539feeb7ec8d795c59e89f1340dc0d3fb29292028c2be1d7575dd28a64070)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9e5584f0a3e077fe1715279a1c0b5327b19b491ef88c6ac36162aa83e985b678)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bcedd881f8506734973a667cfe273c82b5f384ce7744b4b488a780fa7b8b33e3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__957cd4bc3321cd90e4987848dea20b5849d4461927cf0d6c11087fa80bb2d361)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__15299bf063b73604e92d6a6286abe31fb6ddc06b1ef6026b3efe31ed33048078)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e125dbf63356a2d079019f5980d32294242f12ce345698b06c92b64dacd78eba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__abb5ccd73c68dcd846e70c7de04a56457ee86690be2c6099b6d636f9cade0627)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAllowExpansion")
    def reset_allow_expansion(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansion", []))

    @jsii.member(jsii_name="resetAllowExpansionVar")
    def reset_allow_expansion_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansionVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionInput")
    def allow_expansion_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVarInput")
    def allow_expansion_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansion")
    def allow_expansion(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansion"))

    @allow_expansion.setter
    def allow_expansion(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a4030b48d7540f6b665b1d7a12bd87d775cf04ab35396ab0381b8e09f42005c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansion", value)

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVar")
    def allow_expansion_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansionVar"))

    @allow_expansion_var.setter
    def allow_expansion_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__612add1ebb1d50402927b788a29cea8a86c92329d86dde4a66c46093b53a6b03)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansionVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__669e11d213272ad5c247b5cef3be8bef4e384cc7521dfc7d12c3fd82d97043f6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__186697430c81ac6ff3158750ac73953ecbbb1724113e9af9d52e070059792653)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e0bd901face09b682beee1d830f102667c904eb22a1494689c774c3d151c7176)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7c7dfd702b6619c0cace75dce227e789dab4ca769d88a8244f019b1b16add6bd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fdaab32bab2bf6514acfd1b5225d8806d13d176a6d386ca0352f388cc66989b3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6adc8f9f2d41286a92057f54a3de8e91950a4b847805f87c18d4ae65f8f43b4b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a8bdc8c06ec68b651172757987463ed33625d156d32d537437be413f1df5471)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c4f0ae4fa7c0aca2224adf5ca31809139bd60d13d6ef29d660a1cd79ea44f34d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1bb3cb121dc98e04c5ff5be901f1b98706ff21798daa5e35719d82220581aeae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b7778f5ad16cbf2431f76d926004d351e5a54ca9f1ad3065087f81841df05d2b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1e4f3bef3779692a95689299c428c8b1d9a51fbc8302daf866244a16a2bea92f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationFaceCrop",
    jsii_struct_bases=[],
    name_mapping={
        "algorithm": "algorithm",
        "algorithm_var": "algorithmVar",
        "confidence": "confidence",
        "confidence_var": "confidenceVar",
        "fail_gravity": "failGravity",
        "fail_gravity_var": "failGravityVar",
        "focus": "focus",
        "focus_var": "focusVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "padding": "padding",
        "padding_var": "paddingVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationFaceCrop:
    def __init__(
        self,
        *,
        algorithm: typing.Optional[builtins.str] = None,
        algorithm_var: typing.Optional[builtins.str] = None,
        confidence: typing.Optional[builtins.str] = None,
        confidence_var: typing.Optional[builtins.str] = None,
        fail_gravity: typing.Optional[builtins.str] = None,
        fail_gravity_var: typing.Optional[builtins.str] = None,
        focus: typing.Optional[builtins.str] = None,
        focus_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param algorithm: Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm DataAkamaiImagingPolicyImage#algorithm}
        :param algorithm_var: Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm_var DataAkamaiImagingPolicyImage#algorithm_var}
        :param confidence: With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image. Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence DataAkamaiImagingPolicyImage#confidence}
        :param confidence_var: With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image. Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence_var DataAkamaiImagingPolicyImage#confidence_var}
        :param fail_gravity: Controls placement of the crop if Image and Video Manager does not detect any faces in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        :param fail_gravity_var: Controls placement of the crop if Image and Video Manager does not detect any faces in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        :param focus: Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus DataAkamaiImagingPolicyImage#focus}
        :param focus_var: Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus_var DataAkamaiImagingPolicyImage#focus_var}
        :param gravity: Controls placement of the crop. Directions are relative to the face(s) plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Controls placement of the crop. Directions are relative to the face(s) plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param padding: The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        :param style: Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c2d9f11b5b1044aa188328d7f1ff497d31bd3cd9ee5143a0fe6fcf2ba7af3a84)
            check_type(argname="argument algorithm", value=algorithm, expected_type=type_hints["algorithm"])
            check_type(argname="argument algorithm_var", value=algorithm_var, expected_type=type_hints["algorithm_var"])
            check_type(argname="argument confidence", value=confidence, expected_type=type_hints["confidence"])
            check_type(argname="argument confidence_var", value=confidence_var, expected_type=type_hints["confidence_var"])
            check_type(argname="argument fail_gravity", value=fail_gravity, expected_type=type_hints["fail_gravity"])
            check_type(argname="argument fail_gravity_var", value=fail_gravity_var, expected_type=type_hints["fail_gravity_var"])
            check_type(argname="argument focus", value=focus, expected_type=type_hints["focus"])
            check_type(argname="argument focus_var", value=focus_var, expected_type=type_hints["focus_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if algorithm is not None:
            self._values["algorithm"] = algorithm
        if algorithm_var is not None:
            self._values["algorithm_var"] = algorithm_var
        if confidence is not None:
            self._values["confidence"] = confidence
        if confidence_var is not None:
            self._values["confidence_var"] = confidence_var
        if fail_gravity is not None:
            self._values["fail_gravity"] = fail_gravity
        if fail_gravity_var is not None:
            self._values["fail_gravity_var"] = fail_gravity_var
        if focus is not None:
            self._values["focus"] = focus
        if focus_var is not None:
            self._values["focus_var"] = focus_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def algorithm(self) -> typing.Optional[builtins.str]:
        '''Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm DataAkamaiImagingPolicyImage#algorithm}
        '''
        result = self._values.get("algorithm")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def algorithm_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm_var DataAkamaiImagingPolicyImage#algorithm_var}
        '''
        result = self._values.get("algorithm_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def confidence(self) -> typing.Optional[builtins.str]:
        '''With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image.

        Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence DataAkamaiImagingPolicyImage#confidence}
        '''
        result = self._values.get("confidence")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def confidence_var(self) -> typing.Optional[builtins.str]:
        '''With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image.

        Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence_var DataAkamaiImagingPolicyImage#confidence_var}
        '''
        result = self._values.get("confidence_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any faces in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        '''
        result = self._values.get("fail_gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any faces in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        '''
        result = self._values.get("fail_gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def focus(self) -> typing.Optional[builtins.str]:
        '''Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus DataAkamaiImagingPolicyImage#focus}
        '''
        result = self._values.get("focus")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def focus_var(self) -> typing.Optional[builtins.str]:
        '''Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus_var DataAkamaiImagingPolicyImage#focus_var}
        '''
        result = self._values.get("focus_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the face(s) plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the face(s) plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationFaceCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationFaceCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationFaceCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa5654912928e05ec2cbd402e1a227354b4d2da511c39ebc2f8386ccdf7dd54a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationFaceCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ddd9ccbf0942e1a53db79eef5cc0681544f196a3b10ce615509ee419a74941d6)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationFaceCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a5193b6337785a7c25a84de4c1f58bbe81c2efe4c6767ff58e34b8fef6746519)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bfe0382fc2aaa5526821b5c5b69052b2da80ff95c064cddeef8adc2de4ca6a52)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df1a3821d4803305fd1b5458601a163e358eb840ed6f3ee341db2ac9c148c0c6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationFaceCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationFaceCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationFaceCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__45b3307b86f4163d299efe931343d62e41e2b9e49d58c0dc738f8f56d2023ddd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationFaceCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationFaceCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0a9fc095dabe8e119c4616425c37b25e8ca3436ae1d58ab74542f13dd213a200)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAlgorithm")
    def reset_algorithm(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAlgorithm", []))

    @jsii.member(jsii_name="resetAlgorithmVar")
    def reset_algorithm_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAlgorithmVar", []))

    @jsii.member(jsii_name="resetConfidence")
    def reset_confidence(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetConfidence", []))

    @jsii.member(jsii_name="resetConfidenceVar")
    def reset_confidence_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetConfidenceVar", []))

    @jsii.member(jsii_name="resetFailGravity")
    def reset_fail_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravity", []))

    @jsii.member(jsii_name="resetFailGravityVar")
    def reset_fail_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravityVar", []))

    @jsii.member(jsii_name="resetFocus")
    def reset_focus(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFocus", []))

    @jsii.member(jsii_name="resetFocusVar")
    def reset_focus_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFocusVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="algorithmInput")
    def algorithm_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "algorithmInput"))

    @builtins.property
    @jsii.member(jsii_name="algorithmVarInput")
    def algorithm_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "algorithmVarInput"))

    @builtins.property
    @jsii.member(jsii_name="confidenceInput")
    def confidence_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "confidenceInput"))

    @builtins.property
    @jsii.member(jsii_name="confidenceVarInput")
    def confidence_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "confidenceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityInput")
    def fail_gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityVarInput")
    def fail_gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="focusInput")
    def focus_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "focusInput"))

    @builtins.property
    @jsii.member(jsii_name="focusVarInput")
    def focus_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "focusVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="algorithm")
    def algorithm(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "algorithm"))

    @algorithm.setter
    def algorithm(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a1c4d8d6266cc19d58fc7e2271965679e0e8287e807b9abcc3f8bed8caee42c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "algorithm", value)

    @builtins.property
    @jsii.member(jsii_name="algorithmVar")
    def algorithm_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "algorithmVar"))

    @algorithm_var.setter
    def algorithm_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e0234162c3eba97623be7bf9a58a90097e66faa689ba60a205b5aea57c7a160c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "algorithmVar", value)

    @builtins.property
    @jsii.member(jsii_name="confidence")
    def confidence(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "confidence"))

    @confidence.setter
    def confidence(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e0bb561540321116cadc3824185940324d4f4b92ec051383b1f9be89bcbf8542)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "confidence", value)

    @builtins.property
    @jsii.member(jsii_name="confidenceVar")
    def confidence_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "confidenceVar"))

    @confidence_var.setter
    def confidence_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7b8a54d7da61d167960d0c5e6f84e062663dc9bcfa2287eb3489107b4245400f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "confidenceVar", value)

    @builtins.property
    @jsii.member(jsii_name="failGravity")
    def fail_gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravity"))

    @fail_gravity.setter
    def fail_gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9550211ae9a3efec8d7c64c66871bc95ae706b76277a3b7229680b579ed381c2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravity", value)

    @builtins.property
    @jsii.member(jsii_name="failGravityVar")
    def fail_gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravityVar"))

    @fail_gravity_var.setter
    def fail_gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ce0f17eb40069827c8959df40cddef11eb47750357604d01e9eeed83de227f22)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="focus")
    def focus(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "focus"))

    @focus.setter
    def focus(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b741ec893d1c91c53be9ab43538f1a40f045d50fb8b1e062e0040d4b6dc4db17)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "focus", value)

    @builtins.property
    @jsii.member(jsii_name="focusVar")
    def focus_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "focusVar"))

    @focus_var.setter
    def focus_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eba38921ebd05a32567ac6f9aef4f88791ccd2fd2cc0ae2aaa0d6f9a47c5cd1a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "focusVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dd7bf5bb868141db3198b5a1eac3ee94abc0a5eec53ba5bba48de056ebf85a98)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__536d0122520dc12555bd3cfcbd8196dc800d51327f14836e77d4db809c4cedcf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4f95606fd0c66392992ce6c9e294c1b24526a9838fd3fb9e389a9fb0f3b0e772)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0a09681b3ea1011e60b3239a445d86d7d108ee3306ff7c6ea79eeebb1b691bfc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__55a475773881050806b82a090f48e839e1d4839c9ce57a2d507da2e77daac237)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6ecc5ac68a8641bf6a2757c6bbc6694881f004bceec2e01a6cae0f1dca925f6b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__91a3aceb8fa39b2d9094f2e3502ef3474ac2e62cbdd9dc066af6bf2603ca5076)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c0d769ca82c97d9eba5939359121992dc5db7c98da39892fa8bc2b8e43a80167)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd230c370b7100aa47385128273d8c095401aa90ba57d47b1fbbcbc7925a1107)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0feb8e680eeb6b6f663d6f5664abcfde6fcf87b3b4a1c64c3ad1dbb869b6d561)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationFaceCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationFaceCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationFaceCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__61999ea5924fd1b627b90bf13b0fb62355e37118bc26133bc5d998588867a905)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationFeatureCrop",
    jsii_struct_bases=[],
    name_mapping={
        "fail_gravity": "failGravity",
        "fail_gravity_var": "failGravityVar",
        "feature_radius": "featureRadius",
        "feature_radius_var": "featureRadiusVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "max_features": "maxFeatures",
        "max_features_var": "maxFeaturesVar",
        "min_feature_quality": "minFeatureQuality",
        "min_feature_quality_var": "minFeatureQualityVar",
        "padding": "padding",
        "padding_var": "paddingVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationFeatureCrop:
    def __init__(
        self,
        *,
        fail_gravity: typing.Optional[builtins.str] = None,
        fail_gravity_var: typing.Optional[builtins.str] = None,
        feature_radius: typing.Optional[builtins.str] = None,
        feature_radius_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        max_features: typing.Optional[builtins.str] = None,
        max_features_var: typing.Optional[builtins.str] = None,
        min_feature_quality: typing.Optional[builtins.str] = None,
        min_feature_quality_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fail_gravity: Controls placement of the crop if Image and Video Manager does not detect any features in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        :param fail_gravity_var: Controls placement of the crop if Image and Video Manager does not detect any features in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        :param feature_radius: The size in pixels of the important features to search for. If identified, two features never appear closer together than this value, ``8.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius DataAkamaiImagingPolicyImage#feature_radius}
        :param feature_radius_var: The size in pixels of the important features to search for. If identified, two features never appear closer together than this value, ``8.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius_var DataAkamaiImagingPolicyImage#feature_radius_var}
        :param gravity: Controls placement of the crop. Directions are relative to the region of interest plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Controls placement of the crop. Directions are relative to the region of interest plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param max_features: The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features DataAkamaiImagingPolicyImage#max_features}
        :param max_features_var: The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features_var DataAkamaiImagingPolicyImage#max_features_var}
        :param min_feature_quality: Determines the minimum quality level of the feature identified. To consider a feature important, the feature needs to surpass this value. Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality DataAkamaiImagingPolicyImage#min_feature_quality}
        :param min_feature_quality_var: Determines the minimum quality level of the feature identified. To consider a feature important, the feature needs to surpass this value. Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality_var DataAkamaiImagingPolicyImage#min_feature_quality_var}
        :param padding: Adds space around the region of interest. The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: Adds space around the region of interest. The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        :param style: Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f70bb4c9c1ff39acf5236e6b6c73239a3ff61fa8897ae7fd5cbe28b1c82822e0)
            check_type(argname="argument fail_gravity", value=fail_gravity, expected_type=type_hints["fail_gravity"])
            check_type(argname="argument fail_gravity_var", value=fail_gravity_var, expected_type=type_hints["fail_gravity_var"])
            check_type(argname="argument feature_radius", value=feature_radius, expected_type=type_hints["feature_radius"])
            check_type(argname="argument feature_radius_var", value=feature_radius_var, expected_type=type_hints["feature_radius_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument max_features", value=max_features, expected_type=type_hints["max_features"])
            check_type(argname="argument max_features_var", value=max_features_var, expected_type=type_hints["max_features_var"])
            check_type(argname="argument min_feature_quality", value=min_feature_quality, expected_type=type_hints["min_feature_quality"])
            check_type(argname="argument min_feature_quality_var", value=min_feature_quality_var, expected_type=type_hints["min_feature_quality_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fail_gravity is not None:
            self._values["fail_gravity"] = fail_gravity
        if fail_gravity_var is not None:
            self._values["fail_gravity_var"] = fail_gravity_var
        if feature_radius is not None:
            self._values["feature_radius"] = feature_radius
        if feature_radius_var is not None:
            self._values["feature_radius_var"] = feature_radius_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if max_features is not None:
            self._values["max_features"] = max_features
        if max_features_var is not None:
            self._values["max_features_var"] = max_features_var
        if min_feature_quality is not None:
            self._values["min_feature_quality"] = min_feature_quality
        if min_feature_quality_var is not None:
            self._values["min_feature_quality_var"] = min_feature_quality_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def fail_gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any features in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        '''
        result = self._values.get("fail_gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any features in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        '''
        result = self._values.get("fail_gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feature_radius(self) -> typing.Optional[builtins.str]:
        '''The size in pixels of the important features to search for.

        If identified, two features never appear closer together than this value, ``8.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius DataAkamaiImagingPolicyImage#feature_radius}
        '''
        result = self._values.get("feature_radius")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feature_radius_var(self) -> typing.Optional[builtins.str]:
        '''The size in pixels of the important features to search for.

        If identified, two features never appear closer together than this value, ``8.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius_var DataAkamaiImagingPolicyImage#feature_radius_var}
        '''
        result = self._values.get("feature_radius_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the region of interest plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the region of interest plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def max_features(self) -> typing.Optional[builtins.str]:
        '''The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features DataAkamaiImagingPolicyImage#max_features}
        '''
        result = self._values.get("max_features")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def max_features_var(self) -> typing.Optional[builtins.str]:
        '''The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features_var DataAkamaiImagingPolicyImage#max_features_var}
        '''
        result = self._values.get("max_features_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def min_feature_quality(self) -> typing.Optional[builtins.str]:
        '''Determines the minimum quality level of the feature identified.

        To consider a feature important, the feature needs to surpass this value.  Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality DataAkamaiImagingPolicyImage#min_feature_quality}
        '''
        result = self._values.get("min_feature_quality")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def min_feature_quality_var(self) -> typing.Optional[builtins.str]:
        '''Determines the minimum quality level of the feature identified.

        To consider a feature important, the feature needs to surpass this value.  Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality_var DataAkamaiImagingPolicyImage#min_feature_quality_var}
        '''
        result = self._values.get("min_feature_quality_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''Adds space around the region of interest.

        The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''Adds space around the region of interest.

        The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationFeatureCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationFeatureCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationFeatureCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__05e4fa4a75d38060cbf1d26297ea9b1755cd114cdc5768b616217b708dbc69c7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationFeatureCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__16c9d4208a9d4429b97606ccfcdbb45926e323de2b413c2b9fa3d56a8a227f1e)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationFeatureCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a1d3ca84a0d2d72b493a46ba2cd884733c4bb13c799e005003f26ea9beaf7668)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb2f234bcf5f9ca5c5ac48ec7cf1aa198a32700163fb9824b6dbfa731220a334)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f3e640e5b959920f891738fa2cf67b6cae0cfbb4a66df874abb58e28be1f0b24)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationFeatureCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationFeatureCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationFeatureCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1854bc4573a2e8bd43999934c970b4db11d6c452af1c104f582ace6943a11d62)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationFeatureCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationFeatureCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__420bddbb7f97d215dc13b1d58559df214a32fd47deb93045ffaa16e8d7b2afdd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetFailGravity")
    def reset_fail_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravity", []))

    @jsii.member(jsii_name="resetFailGravityVar")
    def reset_fail_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravityVar", []))

    @jsii.member(jsii_name="resetFeatureRadius")
    def reset_feature_radius(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureRadius", []))

    @jsii.member(jsii_name="resetFeatureRadiusVar")
    def reset_feature_radius_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureRadiusVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetMaxFeatures")
    def reset_max_features(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxFeatures", []))

    @jsii.member(jsii_name="resetMaxFeaturesVar")
    def reset_max_features_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxFeaturesVar", []))

    @jsii.member(jsii_name="resetMinFeatureQuality")
    def reset_min_feature_quality(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMinFeatureQuality", []))

    @jsii.member(jsii_name="resetMinFeatureQualityVar")
    def reset_min_feature_quality_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMinFeatureQualityVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="failGravityInput")
    def fail_gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityVarInput")
    def fail_gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featureRadiusInput")
    def feature_radius_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featureRadiusInput"))

    @builtins.property
    @jsii.member(jsii_name="featureRadiusVarInput")
    def feature_radius_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featureRadiusVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesInput")
    def max_features_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "maxFeaturesInput"))

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesVarInput")
    def max_features_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "maxFeaturesVarInput"))

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityInput")
    def min_feature_quality_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "minFeatureQualityInput"))

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityVarInput")
    def min_feature_quality_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "minFeatureQualityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravity")
    def fail_gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravity"))

    @fail_gravity.setter
    def fail_gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__683f4446b0e692211676851405db8dd66a422785d68453e23cf34880f6820f88)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravity", value)

    @builtins.property
    @jsii.member(jsii_name="failGravityVar")
    def fail_gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravityVar"))

    @fail_gravity_var.setter
    def fail_gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4af8020d9793746684751d48d32fa698827183a2f9b189e63fcfdfa802cb143c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="featureRadius")
    def feature_radius(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featureRadius"))

    @feature_radius.setter
    def feature_radius(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9fbac775e6ba13fe15a9b38aa00710bcc237c208cfd500e8d6979784f69e9295)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featureRadius", value)

    @builtins.property
    @jsii.member(jsii_name="featureRadiusVar")
    def feature_radius_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featureRadiusVar"))

    @feature_radius_var.setter
    def feature_radius_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e63081879a1e254dd95ea4fac6626d2f1ed1da9e75e5eb4007d6d6438dd71a92)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featureRadiusVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__020d3767448dcc860c7d6f2de0cb7d18d7bb0c20fe0e011bf62b844d479cce39)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7202d820bd90027cd9bbadbd4634bcfd1c26e5481e19c4763f138be749b281f1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5b7853413ccb2ff8c234076a80435b1d00c384a096fa0370c39fea131c2bfc9b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bfdde96c84e5a5ca9430c803ef1696c4fd86e565f56a76327579fa4b917e6352)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="maxFeatures")
    def max_features(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "maxFeatures"))

    @max_features.setter
    def max_features(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__361344ceb30c5e7fbb70b2169c309c83b4b13f692348fb44ef4b43f4c87eb945)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "maxFeatures", value)

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesVar")
    def max_features_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "maxFeaturesVar"))

    @max_features_var.setter
    def max_features_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0e416ab09954ba29eaa16238a1d7e6e4d2613a6fa48ac9ad5e45c599abdedae4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "maxFeaturesVar", value)

    @builtins.property
    @jsii.member(jsii_name="minFeatureQuality")
    def min_feature_quality(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "minFeatureQuality"))

    @min_feature_quality.setter
    def min_feature_quality(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__00540d3b80080421fcff8fc47cc3df5a020fd98462ac5d302624a62e90186065)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "minFeatureQuality", value)

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityVar")
    def min_feature_quality_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "minFeatureQualityVar"))

    @min_feature_quality_var.setter
    def min_feature_quality_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab65bcfe1c48d14142823e6c7a098fc8c12c4702fd5b1b15d66e02aa00843be2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "minFeatureQualityVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b8d10ec8529c7ae48da718cad3922a552e820a03e467ccda98751b88c6d20cd9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d7b878b75e625eb7237d7bfc7125d245fe0f84a03b11598404aec433ad88fc2b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dcfb6bcdb57639395c1a548e87bb7bb58a429cb0d92d875e0f2ed95e29bbebc6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__73d45624c9af1f4ffff6ad95df403af58ad28cd634dce4e714b3e2d47b202d0d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fbd5095351bdb8314d1047b64298463fd76fe8fa817dafc6c279d1049fd6c283)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__08befbb31fad0cecf594c471c9d8ef0f1cda231033cbfa623dd0fc218984dbfe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationFeatureCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationFeatureCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationFeatureCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__20078851d77b12dca4327240f142f1e319ce55f64715a7a85d3a082c696404c6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationFitAndFill",
    jsii_struct_bases=[],
    name_mapping={
        "fill_transformation": "fillTransformation",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationFitAndFill:
    def __init__(
        self,
        *,
        fill_transformation: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationFitAndFillFillTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fill_transformation: fill_transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_transformation DataAkamaiImagingPolicyImage#fill_transformation}
        :param height: The height value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The width value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(fill_transformation, dict):
            fill_transformation = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationFitAndFillFillTransformation(**fill_transformation)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1350974dad7613456aa12e26c4f429eb9b8539d3c2d78def2c30a89c3213e62d)
            check_type(argname="argument fill_transformation", value=fill_transformation, expected_type=type_hints["fill_transformation"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fill_transformation is not None:
            self._values["fill_transformation"] = fill_transformation
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def fill_transformation(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationFitAndFillFillTransformation"]:
        '''fill_transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_transformation DataAkamaiImagingPolicyImage#fill_transformation}
        '''
        result = self._values.get("fill_transformation")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationFitAndFillFillTransformation"], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationFitAndFill(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationFitAndFillFillTransformation",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationFitAndFillFillTransformation:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationFitAndFillFillTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationFitAndFillFillTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationFitAndFillFillTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be67ccab2b62c340420fad5fcf60d87c661fb5d40df016edd654021b5721e911)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationFitAndFillFillTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationFitAndFillFillTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationFitAndFillFillTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d6f7bd80dce9bdec772443126986d156b124e160dda50bf3e84870f7485213e3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationFitAndFillList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationFitAndFillList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__da00b997502c590ad3646d564df19bb76329607a7fa0f5a5ef211c395e259842)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationFitAndFillOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ad3d3ada832dc8e2330f033c34bb9e24affe73d778578d97e54b007a36b884d)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationFitAndFillOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ffc0d18a0152ea652f079ad35078d371d536b3f5220bbc5be2102b8f9605603)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__484c84c461deb3534a5bb425270c0d6762cece1e1285885f928a986f1de710c9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__082f4fcb7e5dd6b13217f3faa156313016df2d0e376830a23989f2f055f06d30)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationFitAndFill]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationFitAndFill]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationFitAndFill]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fda7001be986f4b11c7f1e55d4a1b37b7a2be4ef463890b13b767771d5510da3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationFitAndFillOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationFitAndFillOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a81400ce35b86b35a9e70d160a444b1a8511c8f547b13c1332e51935dee0d8ee)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putFillTransformation")
    def put_fill_transformation(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationFitAndFillFillTransformation()

        return typing.cast(None, jsii.invoke(self, "putFillTransformation", [value]))

    @jsii.member(jsii_name="resetFillTransformation")
    def reset_fill_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFillTransformation", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="fillTransformation")
    def fill_transformation(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationFitAndFillFillTransformationOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationFitAndFillFillTransformationOutputReference, jsii.get(self, "fillTransformation"))

    @builtins.property
    @jsii.member(jsii_name="fillTransformationInput")
    def fill_transformation_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationFitAndFillFillTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationFitAndFillFillTransformation], jsii.get(self, "fillTransformationInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9977d2c0ea0d322a1fcd0e223074b9efbfe82553c477872e1b204ae77556f82d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aa7725345f3b214c3b15411ac7e665c4467b2c1b9f98bcaf444d6ce354f88075)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fc2c6c0564e3573e63e53bd987dd2968e35422801a4df6092257814dbab82543)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5d6b2c0d08e531360cb238a7959e8951f61db875d0e6535dc79d071bd7ad8ce7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationFitAndFill]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationFitAndFill]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationFitAndFill]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__91262a0a32f34cf23addc771964d70d8aa1b637580c4ffaa09313d18766e30f8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationGoop",
    jsii_struct_bases=[],
    name_mapping={
        "chaos": "chaos",
        "chaos_var": "chaosVar",
        "density": "density",
        "density_var": "densityVar",
        "power": "power",
        "power_var": "powerVar",
        "seed": "seed",
        "seed_var": "seedVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationGoop:
    def __init__(
        self,
        *,
        chaos: typing.Optional[builtins.str] = None,
        chaos_var: typing.Optional[builtins.str] = None,
        density: typing.Optional[builtins.str] = None,
        density_var: typing.Optional[builtins.str] = None,
        power: typing.Optional[builtins.str] = None,
        power_var: typing.Optional[builtins.str] = None,
        seed: typing.Optional[builtins.str] = None,
        seed_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param chaos: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        :param chaos_var: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        :param density: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        :param density_var: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        :param power: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        :param power_var: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        :param seed: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        :param seed_var: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f974d60804105ceb3d9a70aa196a2cefa60889264ee00d347308e5d2405df16d)
            check_type(argname="argument chaos", value=chaos, expected_type=type_hints["chaos"])
            check_type(argname="argument chaos_var", value=chaos_var, expected_type=type_hints["chaos_var"])
            check_type(argname="argument density", value=density, expected_type=type_hints["density"])
            check_type(argname="argument density_var", value=density_var, expected_type=type_hints["density_var"])
            check_type(argname="argument power", value=power, expected_type=type_hints["power"])
            check_type(argname="argument power_var", value=power_var, expected_type=type_hints["power_var"])
            check_type(argname="argument seed", value=seed, expected_type=type_hints["seed"])
            check_type(argname="argument seed_var", value=seed_var, expected_type=type_hints["seed_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if chaos is not None:
            self._values["chaos"] = chaos
        if chaos_var is not None:
            self._values["chaos_var"] = chaos_var
        if density is not None:
            self._values["density"] = density
        if density_var is not None:
            self._values["density_var"] = density_var
        if power is not None:
            self._values["power"] = power
        if power_var is not None:
            self._values["power_var"] = power_var
        if seed is not None:
            self._values["seed"] = seed
        if seed_var is not None:
            self._values["seed_var"] = seed_var

    @builtins.property
    def chaos(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        '''
        result = self._values.get("chaos")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def chaos_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        '''
        result = self._values.get("chaos_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        '''
        result = self._values.get("density")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density_var(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        '''
        result = self._values.get("density_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        '''
        result = self._values.get("power")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power_var(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        '''
        result = self._values.get("power_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        '''
        result = self._values.get("seed")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed_var(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        result = self._values.get("seed_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationGoop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationGoopList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationGoopList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dab66a5077624e40f96cade19c398966371e8bfbcab9176c9081adfdfb9becd7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationGoopOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__86ea72176927d768bc8922523202f772b0b116b50c044d2de7b3674577ef458e)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationGoopOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5dbb4ced5e8df1da7ec28c95f19e59f0638aaef3b68b8388c053d4c351858218)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__07072c5fdb031020f7e96a46c3ff558ddd6bb35b0bfdf01fc587c427219fdc08)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cfdf1beda94c537cb870238dbf7b7b704aed283e527a847fd217a52ae89da9e7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationGoop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationGoop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__421be5f75d15d5c4961874a9338a2c87afa27ff84a2211a65b20c2dc815c2a04)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationGoopOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationGoopOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__40e02e2c8a5aea933fde5a0ddb5a2cd4bc9c02bb05bc4998ed55c53f7eae11e1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetChaos")
    def reset_chaos(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaos", []))

    @jsii.member(jsii_name="resetChaosVar")
    def reset_chaos_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaosVar", []))

    @jsii.member(jsii_name="resetDensity")
    def reset_density(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensity", []))

    @jsii.member(jsii_name="resetDensityVar")
    def reset_density_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensityVar", []))

    @jsii.member(jsii_name="resetPower")
    def reset_power(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPower", []))

    @jsii.member(jsii_name="resetPowerVar")
    def reset_power_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPowerVar", []))

    @jsii.member(jsii_name="resetSeed")
    def reset_seed(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeed", []))

    @jsii.member(jsii_name="resetSeedVar")
    def reset_seed_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeedVar", []))

    @builtins.property
    @jsii.member(jsii_name="chaosInput")
    def chaos_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosInput"))

    @builtins.property
    @jsii.member(jsii_name="chaosVarInput")
    def chaos_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosVarInput"))

    @builtins.property
    @jsii.member(jsii_name="densityInput")
    def density_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityInput"))

    @builtins.property
    @jsii.member(jsii_name="densityVarInput")
    def density_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="powerInput")
    def power_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerInput"))

    @builtins.property
    @jsii.member(jsii_name="powerVarInput")
    def power_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerVarInput"))

    @builtins.property
    @jsii.member(jsii_name="seedInput")
    def seed_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedInput"))

    @builtins.property
    @jsii.member(jsii_name="seedVarInput")
    def seed_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedVarInput"))

    @builtins.property
    @jsii.member(jsii_name="chaos")
    def chaos(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaos"))

    @chaos.setter
    def chaos(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__29b570d8f3f72a6f67e22af35685f527474ac74fafca928dfea593c213d05720)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaos", value)

    @builtins.property
    @jsii.member(jsii_name="chaosVar")
    def chaos_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaosVar"))

    @chaos_var.setter
    def chaos_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6bb55880fee635609c5b4566509b321f85a0a95b0274b76ff33ee30584148e16)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaosVar", value)

    @builtins.property
    @jsii.member(jsii_name="density")
    def density(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "density"))

    @density.setter
    def density(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ef9dbf94d68ce964c661ba23988a0d36e5fe22a2c53c20d74d04db92ce6ee85e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "density", value)

    @builtins.property
    @jsii.member(jsii_name="densityVar")
    def density_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "densityVar"))

    @density_var.setter
    def density_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2144246c598b4a4fe6ef4b9af97ad968c01e5d8f04bca81a8aeb300f8be8cd62)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "densityVar", value)

    @builtins.property
    @jsii.member(jsii_name="power")
    def power(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "power"))

    @power.setter
    def power(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__db7756df242deb8a77af1a69f44c7ec13efd4cd41a0d00339c676b7a2a13e35a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "power", value)

    @builtins.property
    @jsii.member(jsii_name="powerVar")
    def power_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "powerVar"))

    @power_var.setter
    def power_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1fc0705faab63dfaaf584fb300a58cd19652857495f299633d0f775d96641b5f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "powerVar", value)

    @builtins.property
    @jsii.member(jsii_name="seed")
    def seed(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seed"))

    @seed.setter
    def seed(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__648f29c13a484cb1be13e6959518b67d2112052fe2344f0b06e5b1605092734a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seed", value)

    @builtins.property
    @jsii.member(jsii_name="seedVar")
    def seed_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seedVar"))

    @seed_var.setter
    def seed_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ce0d798dd56c7a0ef766f7cb90c8ffa912c60611778f90decd1b9672c0f9d02c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seedVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationGoop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationGoop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationGoop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1302e3ef80b8675ccf4117f0298da4bce72fb65794e73c29a2db9808aa720fe1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationGrayscale",
    jsii_struct_bases=[],
    name_mapping={"type": "type", "type_var": "typeVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationGrayscale:
    def __init__(
        self,
        *,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param type: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__44dc5164c2a0c636568a94c071d26a1566e185f606da17ba201f2c9780d285bd)
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationGrayscale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationGrayscaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationGrayscaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c420a41dc2d85902412225f2e021ff2b4e47ef62a9d25ecb4c875bce02c50235)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationGrayscaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e7454f8e4cc144daee4d9876de1533819768bfc89c694436edb100b92c2c5f73)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationGrayscaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7dd11b4037bfb5469ecf35272dd47447de364a25476e560befb9629972b20c82)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__12f9bdbe1a9d7ac1312c24da3d43b9a49c77e198f5737886f7f4e76ec43ca1f4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7631d914c223bc1e74f643e8fdda5ff8e585082783d99c1f44542185de4a8147)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationGrayscale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationGrayscale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1aa0606fbb38a27704698414b6dbc312b56f9c64ae874faf55fee4fb896cfb53)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationGrayscaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationGrayscaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1a33d286b6b7b382fe6b725a08c052f20fc8a23f552c990efde207b83aee20e1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8bce526bb4ef7f876ba7c42c2fcb563d0725236eaf99ea6940b141d173a32bcf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b7e74e66304623ffff668a73ed3414fd9b33b0ae65cb066f5ca1eae66e824199)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationGrayscale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationGrayscale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationGrayscale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cf3d73e771487046ccdad26bcb487a1e3e1619ad6acefa8b18228738563e1cb9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationHsl",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "lightness": "lightness",
        "lightness_var": "lightnessVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationHsl:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness: typing.Optional[builtins.str] = None,
        lightness_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        :param lightness_var: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1a4c0130061a7d275a5cedc3bd78bff9c6a9ee2145992423821d33c26a44ede8)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness", value=lightness, expected_type=type_hints["lightness"])
            check_type(argname="argument lightness_var", value=lightness_var, expected_type=type_hints["lightness_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness is not None:
            self._values["lightness"] = lightness
        if lightness_var is not None:
            self._values["lightness_var"] = lightness_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        '''
        result = self._values.get("lightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        '''
        result = self._values.get("lightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationHsl(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationHslList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationHslList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d6d2cfb9d8cc16b7da871a561693a92d7f639e4ff38285d1c2cc29857fd780bb)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationHslOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d1cedd908fdb20936576590a47e6f9e5c513f495b4df7b79a738b31a89beef32)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationHslOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__450c3aae36b2dfde4db9f8d4b87908126ece430b6d89b7dac1c722d1e485b77b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d7387bd5f6c5b5560d0c5ddb2f4acec322fd0d8ec88865f229a82bca4fa465e1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b5b45bbe286a5d6a626124184f6ea55ee9f1508dbc6b09167a86635fef2cb387)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationHsl]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationHsl]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__43a3f2b7d9acd0d5693ca67eb7c9a0412100a52ce89f5600cbf959c804d26cd6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationHslOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationHslOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__06832eee4f37294ab6b74ece5489c702c04ab493e77eb4703b8423b6b4e5766a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightness")
    def reset_lightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightness", []))

    @jsii.member(jsii_name="resetLightnessVar")
    def reset_lightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessInput")
    def lightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessVarInput")
    def lightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c1695435c44de87c1d9ab184d94d9335d6edd875cb1d28ce3d35ed3f7bbb010a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0930bcd60059bd69f8471747c0c0b81bc289505b72b3c061f16a2643b1d0730a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightness")
    def lightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightness"))

    @lightness.setter
    def lightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4af51bdc7fc825b4d318d9adf6134409840495656c843775e85a6d4e47984795)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightness", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessVar")
    def lightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessVar"))

    @lightness_var.setter
    def lightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b4ea9b23120f95ee54b88594db4e610953bd01b1c550dfbe856979d76e75fdc4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__49a7c22e399467cce3ece1b1dcdb44d658a35a675f9689e09083e4c8f1007021)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7555d00c4ef6286c4c2370e5ad52cad8032041a173def812eb4780a608e23029)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationHsl]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationHsl]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationHsl]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5835c6296319e1b6f9fd73d1651904046f47f9e260afb34fb86712959611251e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationHsv",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationHsv:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        :param value: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ba90fdff9a93a9068d675feff78163550aca454162d29d47d88db6eb6177d3b4)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationHsv(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationHsvList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationHsvList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__48b6dd119a766b5b5701ec06ad4935c483452b3383476f67c0395d639f6a0b81)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationHsvOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e8901e1322dc7a6819302f7dbe795cac3e3f10424c6b5f2559e67834e65d34e6)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationHsvOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8b0ce4fa0a5cc069f02fc9dad0cbf3c24143fbf2791df55081e978567ed51d8e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3631438ad1a3581b34a7fc5216a2cc1d69277ffc15e5dc4e237b3b5b336f40db)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__56cf3f14d79a28bf7933f40e29743ce90d674f48a05a89824da8234bf2741613)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationHsv]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationHsv]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__797f0b1ce0d484990b76bfbc7275e0948a7ad9ce0a37a81a6472fbe9770ff486)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationHsvOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationHsvOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__06355969e3497871cb102eff538c7d3428236e93545cd0112121a9c4ae48abff)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8e9607ad80978d3949b1055dfcd211410ae2a3e4fea64744c9867c2cfc3714e6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c130f9bc6f73949c50f78944aac12920258a815cd4a987db0e235def24f36a51)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d6c2251c3aaca8c9d862c6b15a52f838e768f1203e9e191625c40e4896664b6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c83fc43726a29e1deac1af05c439d00826c87373f1a102ed6daae11b67999b83)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0e2f3c04c313b1be011e633bb16cdd4ef5c52393f3b9c46be2e9b34829d19e8b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__467ec0bcdd454e6f3a1aa4987b09d971df7b71e000e321f78361eedcc87873e1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationHsv]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationHsv]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationHsv]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2e7224fc3b6e75091e34997961b0cbb8a431e068ee36d2a13e074e917177ee54)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfDimension",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "dimension": "dimension",
        "dimension_var": "dimensionVar",
        "equal": "equal",
        "greater_than": "greaterThan",
        "less_than": "lessThan",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfDimension:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfDimensionDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        dimension: typing.Optional[builtins.str] = None,
        dimension_var: typing.Optional[builtins.str] = None,
        equal: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfDimensionEqual", typing.Dict[builtins.str, typing.Any]]] = None,
        greater_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfDimensionGreaterThan", typing.Dict[builtins.str, typing.Any]]] = None,
        less_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfDimensionLessThan", typing.Dict[builtins.str, typing.Any]]] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param dimension: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        :param dimension_var: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        :param equal: equal block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        :param greater_than: greater_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        :param less_than: less_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        :param value: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfDimensionDefault(**default)
        if isinstance(equal, dict):
            equal = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfDimensionEqual(**equal)
        if isinstance(greater_than, dict):
            greater_than = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfDimensionGreaterThan(**greater_than)
        if isinstance(less_than, dict):
            less_than = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfDimensionLessThan(**less_than)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c11052fa04f8661640896a8046e2cafcb17efcfb23028fdd711007536b8f1611)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument dimension", value=dimension, expected_type=type_hints["dimension"])
            check_type(argname="argument dimension_var", value=dimension_var, expected_type=type_hints["dimension_var"])
            check_type(argname="argument equal", value=equal, expected_type=type_hints["equal"])
            check_type(argname="argument greater_than", value=greater_than, expected_type=type_hints["greater_than"])
            check_type(argname="argument less_than", value=less_than, expected_type=type_hints["less_than"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if dimension is not None:
            self._values["dimension"] = dimension
        if dimension_var is not None:
            self._values["dimension_var"] = dimension_var
        if equal is not None:
            self._values["equal"] = equal
        if greater_than is not None:
            self._values["greater_than"] = greater_than
        if less_than is not None:
            self._values["less_than"] = less_than
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfDimensionDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfDimensionDefault"], result)

    @builtins.property
    def dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        '''
        result = self._values.get("dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        '''
        result = self._values.get("dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def equal(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfDimensionEqual"]:
        '''equal block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        '''
        result = self._values.get("equal")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfDimensionEqual"], result)

    @builtins.property
    def greater_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfDimensionGreaterThan"]:
        '''greater_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        '''
        result = self._values.get("greater_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfDimensionGreaterThan"], result)

    @builtins.property
    def less_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfDimensionLessThan"]:
        '''less_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        '''
        result = self._values.get("less_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfDimensionLessThan"], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfDimension(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfDimensionDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfDimensionDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfDimensionDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfDimensionDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfDimensionDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ef6fdb3826017130352033bdb18f0b3f12de36b9b33ceebbf00af0d23bbff7e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfDimensionDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfDimensionDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__32d99d6512ab8937b4ae8f30350242a838df1ac8d8c44618ee3654e0da1d4247)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfDimensionEqual",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfDimensionEqual:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfDimensionEqual(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfDimensionEqualOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfDimensionEqualOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__42a64ce60c1712c5ea85850113e952437e8f9a9e767a40b58444bd5f33c900a2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfDimensionEqual], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfDimensionEqual],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__25b8b44b8937b1719640771ea2854d9618d540c9f6aa2c0e7dc5905aa21df523)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfDimensionGreaterThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfDimensionGreaterThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfDimensionGreaterThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfDimensionGreaterThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfDimensionGreaterThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f8d6e240e2359b04996ae528a9d1c3b70a1ad412c0c596dbf125319fff53b39)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfDimensionGreaterThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfDimensionGreaterThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__56164531cf42b541b6f6bc2b763407942423b1153728f4fe01c8e3615d4fead4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfDimensionLessThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfDimensionLessThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfDimensionLessThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfDimensionLessThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfDimensionLessThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5854989e7fc554925c80d0d3e98c96568f6aa948cb0dc35e59512c4f77bdb2d1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfDimensionLessThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfDimensionLessThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e2e1ccf29249617cf0707981c78b6f052bff0a1b0939b08adee320a6a2a7cd29)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfDimensionList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfDimensionList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1b9984d3cccd5896dbf211e88a5a90059e2508d7ce36bb3333ec83043c0d0f0c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfDimensionOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eed760dcfc5a7d6e84890b83e4e83ebbac781eee491946cbeb2754ab58f6b380)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfDimensionOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__85dd91f9fec63cd6523ba246e95d64372f6c4f59c5c5b0bbf75ad7387adb29a1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ecef9b8254c5e1c85f1ca55f0b06a3f5e192079d43ccf5df148ef8fbb0be0a64)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0e7a97bb4357257a3d4741bfe0ea4448f6b9fc7a93e148de9466911b329a57c4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfDimension]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfDimension]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__19abf967894b403e5c999724b9e0ee78282d5253ef7fe51b81da368677fc0659)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfDimensionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfDimensionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e54a6fb3372504ed994730ec69bc85d2da32738ae7bee61c497252116af693c2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfDimensionDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putEqual")
    def put_equal(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfDimensionEqual()

        return typing.cast(None, jsii.invoke(self, "putEqual", [value]))

    @jsii.member(jsii_name="putGreaterThan")
    def put_greater_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfDimensionGreaterThan()

        return typing.cast(None, jsii.invoke(self, "putGreaterThan", [value]))

    @jsii.member(jsii_name="putLessThan")
    def put_less_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfDimensionLessThan()

        return typing.cast(None, jsii.invoke(self, "putLessThan", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetDimension")
    def reset_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimension", []))

    @jsii.member(jsii_name="resetDimensionVar")
    def reset_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimensionVar", []))

    @jsii.member(jsii_name="resetEqual")
    def reset_equal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEqual", []))

    @jsii.member(jsii_name="resetGreaterThan")
    def reset_greater_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGreaterThan", []))

    @jsii.member(jsii_name="resetLessThan")
    def reset_less_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLessThan", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfDimensionDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfDimensionDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="equal")
    def equal(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfDimensionEqualOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfDimensionEqualOutputReference, jsii.get(self, "equal"))

    @builtins.property
    @jsii.member(jsii_name="greaterThan")
    def greater_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfDimensionGreaterThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfDimensionGreaterThanOutputReference, jsii.get(self, "greaterThan"))

    @builtins.property
    @jsii.member(jsii_name="lessThan")
    def less_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfDimensionLessThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfDimensionLessThanOutputReference, jsii.get(self, "lessThan"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfDimensionDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionInput")
    def dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionVarInput")
    def dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="equalInput")
    def equal_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfDimensionEqual], jsii.get(self, "equalInput"))

    @builtins.property
    @jsii.member(jsii_name="greaterThanInput")
    def greater_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfDimensionGreaterThan], jsii.get(self, "greaterThanInput"))

    @builtins.property
    @jsii.member(jsii_name="lessThanInput")
    def less_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfDimensionLessThan], jsii.get(self, "lessThanInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="dimension")
    def dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimension"))

    @dimension.setter
    def dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7c4513a114deed25d02a668d11076fd09b911d67595b157b8aeba3347b72398c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimension", value)

    @builtins.property
    @jsii.member(jsii_name="dimensionVar")
    def dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimensionVar"))

    @dimension_var.setter
    def dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5b6d79fef0b57fcf33f2fd147a4868c13aea59613388f0522f5eb331cd6444b3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__41a0cd185b6aa30f6a61cb2ea32af44f5ea770faf0c01a796956da6249f292a9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d22977e0aa946dc8d569b14130724d87439d5b2c341123cb41343572bbd22315)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfDimension]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfDimension]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfDimension]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__36f57df2ae7098f0231fc0d1887d45d3195057b8ac91dc6e925cc1d79ab30d9c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfOrientation",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "landscape": "landscape",
        "portrait": "portrait",
        "square": "square",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfOrientation:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfOrientationDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        landscape: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfOrientationLandscape", typing.Dict[builtins.str, typing.Any]]] = None,
        portrait: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfOrientationPortrait", typing.Dict[builtins.str, typing.Any]]] = None,
        square: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfOrientationSquare", typing.Dict[builtins.str, typing.Any]]] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param landscape: landscape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        :param portrait: portrait block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        :param square: square block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfOrientationDefault(**default)
        if isinstance(landscape, dict):
            landscape = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfOrientationLandscape(**landscape)
        if isinstance(portrait, dict):
            portrait = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfOrientationPortrait(**portrait)
        if isinstance(square, dict):
            square = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfOrientationSquare(**square)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__66712df68f5f2a2be627d3149486f08e7aac8446cb288961daf00fef8353064e)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument landscape", value=landscape, expected_type=type_hints["landscape"])
            check_type(argname="argument portrait", value=portrait, expected_type=type_hints["portrait"])
            check_type(argname="argument square", value=square, expected_type=type_hints["square"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if landscape is not None:
            self._values["landscape"] = landscape
        if portrait is not None:
            self._values["portrait"] = portrait
        if square is not None:
            self._values["square"] = square

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfOrientationDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfOrientationDefault"], result)

    @builtins.property
    def landscape(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfOrientationLandscape"]:
        '''landscape block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        '''
        result = self._values.get("landscape")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfOrientationLandscape"], result)

    @builtins.property
    def portrait(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfOrientationPortrait"]:
        '''portrait block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        '''
        result = self._values.get("portrait")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfOrientationPortrait"], result)

    @builtins.property
    def square(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfOrientationSquare"]:
        '''square block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        result = self._values.get("square")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfOrientationSquare"], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfOrientation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfOrientationDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfOrientationDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfOrientationDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfOrientationDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfOrientationDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4dc4b5b77ea1288b2b64774b42c066fb3a37b4eb1bb5e60c5487c7c3c840951c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfOrientationDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfOrientationDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f5098fac80b21cf6d1b4956b548e5287265741a8e08263434cd2476e693913d2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfOrientationLandscape",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfOrientationLandscape:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfOrientationLandscape(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfOrientationLandscapeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfOrientationLandscapeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0c0ef77f8857befaf63cbec792a03b374e9b714052fecafe4737d7778e9d888e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfOrientationLandscape], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfOrientationLandscape],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7ed97f33e1be8793784b9255b185762fa7e956b7e055bc9c10f4678930d3d067)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfOrientationList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfOrientationList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eca61e8f17066f2ca3484228ce52e27e972c46b9008cc6b3f89021b5ca4ea100)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfOrientationOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__93b2b8069d3503f117daab43759deccbf68c3b3243f6c3dc2a853dcd7ac32839)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfOrientationOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__513e848506026f032d4cc47bc23978e2de306267f03a4b30cbd7bc30490b9e5f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a3f646c0e3cbcc3c8e4044bd32534944b96c58359c896c04aae1a45b3146be67)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__935a857d1c8ef2ae3c87ae45a6f6536cfeb6297b104a28d16725a24797ddd5f5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfOrientation]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfOrientation]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b57056a45500872292a8506021e654d5cf7b8a17b2371ab5433626fc03c8bb3f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfOrientationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfOrientationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8178e3cc57a477c5eb241c3b0bcf0f7153ab1f87ec5f90f67059e8277a71b22a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfOrientationDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putLandscape")
    def put_landscape(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfOrientationLandscape()

        return typing.cast(None, jsii.invoke(self, "putLandscape", [value]))

    @jsii.member(jsii_name="putPortrait")
    def put_portrait(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfOrientationPortrait()

        return typing.cast(None, jsii.invoke(self, "putPortrait", [value]))

    @jsii.member(jsii_name="putSquare")
    def put_square(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfOrientationSquare()

        return typing.cast(None, jsii.invoke(self, "putSquare", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetLandscape")
    def reset_landscape(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLandscape", []))

    @jsii.member(jsii_name="resetPortrait")
    def reset_portrait(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPortrait", []))

    @jsii.member(jsii_name="resetSquare")
    def reset_square(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSquare", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfOrientationDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfOrientationDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="landscape")
    def landscape(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfOrientationLandscapeOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfOrientationLandscapeOutputReference, jsii.get(self, "landscape"))

    @builtins.property
    @jsii.member(jsii_name="portrait")
    def portrait(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfOrientationPortraitOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfOrientationPortraitOutputReference", jsii.get(self, "portrait"))

    @builtins.property
    @jsii.member(jsii_name="square")
    def square(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfOrientationSquareOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfOrientationSquareOutputReference", jsii.get(self, "square"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfOrientationDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="landscapeInput")
    def landscape_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfOrientationLandscape], jsii.get(self, "landscapeInput"))

    @builtins.property
    @jsii.member(jsii_name="portraitInput")
    def portrait_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfOrientationPortrait"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfOrientationPortrait"], jsii.get(self, "portraitInput"))

    @builtins.property
    @jsii.member(jsii_name="squareInput")
    def square_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfOrientationSquare"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfOrientationSquare"], jsii.get(self, "squareInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfOrientation]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfOrientation]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfOrientation]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dbab29472b26eb53a703733b12de0c3caaec4816fd32a9a865ae8ba782f95be4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfOrientationPortrait",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfOrientationPortrait:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfOrientationPortrait(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfOrientationPortraitOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfOrientationPortraitOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ae93b3c8d47bd15e87e93529142064718e123d27ee91a257e407a3f994bec572)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfOrientationPortrait]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfOrientationPortrait], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfOrientationPortrait],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c61e16a000ad5de8752a75fa8ef6322f4fea88510a3434798e7b3aff768572f9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfOrientationSquare",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfOrientationSquare:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfOrientationSquare(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfOrientationSquareOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfOrientationSquareOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__382735b414ab2745cc15acaec188aa1dc815d79e472feea07eb6f57822d8a233)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfOrientationSquare]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfOrientationSquare], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfOrientationSquare],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__82b22af0173ab43d6e48caba09ac39d934e85b54b836dca086299ba5bf18d94b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationImQuery",
    jsii_struct_bases=[],
    name_mapping={
        "allowed_transformations": "allowedTransformations",
        "query_var": "queryVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationImQuery:
    def __init__(
        self,
        *,
        allowed_transformations: typing.Sequence[builtins.str],
        query_var: builtins.str,
    ) -> None:
        '''
        :param allowed_transformations: Specifies the transformations that can be applied using the query string parameter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allowed_transformations DataAkamaiImagingPolicyImage#allowed_transformations}
        :param query_var: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#query_var DataAkamaiImagingPolicyImage#query_var}.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b94c0e168680c2f354216d885b79314590ad5ec2459b1582232814734cb3f6cc)
            check_type(argname="argument allowed_transformations", value=allowed_transformations, expected_type=type_hints["allowed_transformations"])
            check_type(argname="argument query_var", value=query_var, expected_type=type_hints["query_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "allowed_transformations": allowed_transformations,
            "query_var": query_var,
        }

    @builtins.property
    def allowed_transformations(self) -> typing.List[builtins.str]:
        '''Specifies the transformations that can be applied using the query string parameter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allowed_transformations DataAkamaiImagingPolicyImage#allowed_transformations}
        '''
        result = self._values.get("allowed_transformations")
        assert result is not None, "Required property 'allowed_transformations' is missing"
        return typing.cast(typing.List[builtins.str], result)

    @builtins.property
    def query_var(self) -> builtins.str:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#query_var DataAkamaiImagingPolicyImage#query_var}.'''
        result = self._values.get("query_var")
        assert result is not None, "Required property 'query_var' is missing"
        return typing.cast(builtins.str, result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationImQuery(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationImQueryList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationImQueryList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a3d245dd0b58f95dc7a8d611d4f9e2782be5802acc958eece3ef3d9c335966ca)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationImQueryOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c33a25e48827db99a3ac848fe1ddedb1f6fcd1000c010c26b34c423fd1138d5c)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationImQueryOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bd306caca62dab1e9cea19f421c94b5c081f87017946de52c90ff10b53930a49)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f81d3c23ba32e8caee48d19e06b98a520edefc44ff9ed405f4973f887de930f9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__73e96f9cce66b523e8e7748fd9f21c732c5d7ea9c98453fc707e07569f7b3e2e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationImQuery]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationImQuery]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationImQuery]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__41106556c18b60260a1e0d618df778a2e256456a05881907897d72f053843a62)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationImQueryOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationImQueryOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8bc32887f6ec1c20f7aa9c97804633c356570377770989647070272391419a9a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @builtins.property
    @jsii.member(jsii_name="allowedTransformationsInput")
    def allowed_transformations_input(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "allowedTransformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="queryVarInput")
    def query_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "queryVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowedTransformations")
    def allowed_transformations(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "allowedTransformations"))

    @allowed_transformations.setter
    def allowed_transformations(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__43e523dfbc89b04e9039db9c460bbcdefeb5146a90223ce493176334672229dd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowedTransformations", value)

    @builtins.property
    @jsii.member(jsii_name="queryVar")
    def query_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "queryVar"))

    @query_var.setter
    def query_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6bfd6abccb221182a4edf4dd87c026d03d81c6b53bf0c75122a813eacbf34996)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "queryVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationImQuery]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationImQuery]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationImQuery]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b9b68792ef88f8d5f9f79cd9f837a297b578d21410d55cca679d76d9ade568d9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationMaxColors",
    jsii_struct_bases=[],
    name_mapping={"colors": "colors", "colors_var": "colorsVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationMaxColors:
    def __init__(
        self,
        *,
        colors: typing.Optional[builtins.str] = None,
        colors_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param colors: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        :param colors_var: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__82a240ba9bfbf958e7fce6f7d7a1b7ab1a0728f6f88c3aca245265baf775d9bc)
            check_type(argname="argument colors", value=colors, expected_type=type_hints["colors"])
            check_type(argname="argument colors_var", value=colors_var, expected_type=type_hints["colors_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if colors is not None:
            self._values["colors"] = colors
        if colors_var is not None:
            self._values["colors_var"] = colors_var

    @builtins.property
    def colors(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        '''
        result = self._values.get("colors")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def colors_var(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        result = self._values.get("colors_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationMaxColors(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationMaxColorsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationMaxColorsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__78972bb9ecd28860a7074799a0b9f863d5bc5adfb6bd3909e88e595799ddc4ca)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationMaxColorsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d3f7249060866dd1e92b242e765d8d0ac0b4b15ad2cc3e7500a3ac58074cf01d)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationMaxColorsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__da74ffe1af29abb1c6a2a50d656cfdede1dca287779e9eadece31acbe2361c2c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd747deafdccf9d0bbbeb4690b83dd855eaaedb85c9156c401ec032d4b8c52a1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6aedf3cb9396c6aa49f9e96f22a62981ef9e9a4d0aac2948168650af94443246)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationMaxColors]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationMaxColors]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0dcbed9560bc7a662659889cea7ebf2330607cc28d2bdcfe6af4bdd66687d891)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationMaxColorsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationMaxColorsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a8ff88c33704bb19bcfcf7c007aa7efa576f466c59d3a82c08dff2a48d895cb3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColors")
    def reset_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColors", []))

    @jsii.member(jsii_name="resetColorsVar")
    def reset_colors_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorsVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorsInput")
    def colors_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsInput"))

    @builtins.property
    @jsii.member(jsii_name="colorsVarInput")
    def colors_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsVarInput"))

    @builtins.property
    @jsii.member(jsii_name="colors")
    def colors(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colors"))

    @colors.setter
    def colors(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__69e47ee7fa9865b640309fd6d41cd6e7e98dd7c8cfd609b83e010def28d0ea44)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colors", value)

    @builtins.property
    @jsii.member(jsii_name="colorsVar")
    def colors_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorsVar"))

    @colors_var.setter
    def colors_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5e8290868965e254b040157f11f7ba7eb77dd6a2c06939db195d4bfd5212743f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorsVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationMaxColors]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationMaxColors]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationMaxColors]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__88553eaf5d8de6abcf3ba31a61724be101dbfd641afc7fdafafdc7b53a16b180)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationMirror",
    jsii_struct_bases=[],
    name_mapping={
        "horizontal": "horizontal",
        "horizontal_var": "horizontalVar",
        "vertical": "vertical",
        "vertical_var": "verticalVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationMirror:
    def __init__(
        self,
        *,
        horizontal: typing.Optional[builtins.str] = None,
        horizontal_var: typing.Optional[builtins.str] = None,
        vertical: typing.Optional[builtins.str] = None,
        vertical_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param horizontal: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        :param horizontal_var: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        :param vertical: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        :param vertical_var: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ea1a01625702a912ce26120dc71bc75261f35f61d265c729b951b025179ca8b)
            check_type(argname="argument horizontal", value=horizontal, expected_type=type_hints["horizontal"])
            check_type(argname="argument horizontal_var", value=horizontal_var, expected_type=type_hints["horizontal_var"])
            check_type(argname="argument vertical", value=vertical, expected_type=type_hints["vertical"])
            check_type(argname="argument vertical_var", value=vertical_var, expected_type=type_hints["vertical_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if horizontal is not None:
            self._values["horizontal"] = horizontal
        if horizontal_var is not None:
            self._values["horizontal_var"] = horizontal_var
        if vertical is not None:
            self._values["vertical"] = vertical
        if vertical_var is not None:
            self._values["vertical_var"] = vertical_var

    @builtins.property
    def horizontal(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        '''
        result = self._values.get("horizontal")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def horizontal_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        '''
        result = self._values.get("horizontal_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        '''
        result = self._values.get("vertical")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        result = self._values.get("vertical_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationMirror(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationMirrorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationMirrorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__21ef9df5a1965d297831ddae1dc6ca3d6271d6317e4a47d8cbf500fe3f5f54ab)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationMirrorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f44f82f9156123da5f3cfd9f6dcbe009a4c398ba6d83ea40aacbd5ea47fa80da)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationMirrorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4e494a358a2f0713e1039d002ebfc1b98dd7c93212b748f7639877eefbd86d9f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cc6a4632621f3c50d368bad40f3bdd079e0a000c12a221a0fa3d6f1b3279d057)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c82fca58cc879963eda9d2c87316b4a49a0364a0541a610741719824afa15410)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationMirror]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationMirror]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b7cde8fc7651176c0dd5bd3cadaa377372f73bdbdcc5853db7ab78eb11121063)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationMirrorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationMirrorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb30fde8f2c6286ec708fb20c7add1277ef4c80d6438877ec95c54fc8daece09)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHorizontal")
    def reset_horizontal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontal", []))

    @jsii.member(jsii_name="resetHorizontalVar")
    def reset_horizontal_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontalVar", []))

    @jsii.member(jsii_name="resetVertical")
    def reset_vertical(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVertical", []))

    @jsii.member(jsii_name="resetVerticalVar")
    def reset_vertical_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVerticalVar", []))

    @builtins.property
    @jsii.member(jsii_name="horizontalInput")
    def horizontal_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontalVarInput")
    def horizontal_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalInput")
    def vertical_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalVarInput")
    def vertical_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontal")
    def horizontal(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontal"))

    @horizontal.setter
    def horizontal(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__36912c2e9cc8feb5f3199c1e5b00847fd20df15fa4107e44b01abbe5208f66ce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontal", value)

    @builtins.property
    @jsii.member(jsii_name="horizontalVar")
    def horizontal_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontalVar"))

    @horizontal_var.setter
    def horizontal_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4258c06bc34701e6fc736f917f5934e89bddd2226425ee366fe44a28183c8943)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontalVar", value)

    @builtins.property
    @jsii.member(jsii_name="vertical")
    def vertical(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "vertical"))

    @vertical.setter
    def vertical(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a1417bcc87415b8b58c4442599d5b7f74b038b1b75e3d80ea641b5cddb9f1d72)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "vertical", value)

    @builtins.property
    @jsii.member(jsii_name="verticalVar")
    def vertical_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "verticalVar"))

    @vertical_var.setter
    def vertical_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1eae9b7f0bbe7f934d2980fb7631c62e5c57c0a6c97d532d352b5b3160908595)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "verticalVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationMirror]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationMirror]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationMirror]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__895bf9af4f2e97bc5cb16cd6e4d5db1d40422e614a2be39411fb876e471fc31a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationMonoHue",
    jsii_struct_bases=[],
    name_mapping={"hue": "hue", "hue_var": "hueVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationMonoHue:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0c916e437bdb284f7f56902f183b30ccdb77009510fbb56ff9227e9160177c89)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationMonoHue(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationMonoHueList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationMonoHueList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4c4053640e948063421ac7250472c406162e9ae377aa7a6c2fc06a47c4c4ef8f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationMonoHueOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__713d2a20fa79ce47fc60bbb83b89875c9ab3fe88713b965a8b0758c7d64db9d3)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationMonoHueOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f0ce294749da49e790b91a4726d83a32e3e5a089b610f7e28d0e77ba945d050)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__08e6574d13e03dbecf5fa9586e67d62beb171e4ccf21bbd3866393fe82c6796f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4665ffc7d9c5938fe134bc14fe362c80b451729376c8d50b9477a575e5907de0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationMonoHue]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationMonoHue]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8608de0bc3e25045deeaf80ec1e74284a39dcb9eafd47815dfd62c43a99592d8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationMonoHueOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationMonoHueOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__29935ae84e0c54748e18a3be3fa9ab0af066d6a0c8756f6dea6b7c4544ea13aa)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9858b6b5dc853193fbed9d2443262372e3781f3253f9509f7e19c76a6988fdef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__96824fda4ea7d48df288471ff09281e2f11500eaa0436007fb1608e20e43c55f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationMonoHue]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationMonoHue]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationMonoHue]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__10b8246de63ff4956c21db237c69efc8239e82a489b0e64b25877dbd667766e2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationOpacity",
    jsii_struct_bases=[],
    name_mapping={"opacity": "opacity", "opacity_var": "opacityVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationOpacity:
    def __init__(
        self,
        *,
        opacity: typing.Optional[builtins.str] = None,
        opacity_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param opacity: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param opacity_var: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__19024b24f4c72b4a6d63bfc41b74388fcf08a7f19a539d78630a1a38e7e5f575)
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument opacity_var", value=opacity_var, expected_type=type_hints["opacity_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if opacity is not None:
            self._values["opacity"] = opacity
        if opacity_var is not None:
            self._values["opacity_var"] = opacity_var

    @builtins.property
    def opacity(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def opacity_var(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        result = self._values.get("opacity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationOpacity(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationOpacityList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationOpacityList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bd5bd96b36c6249217c77c1da730b213c867ddf4e249c2a8f0ee4c0c12ecd88b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationOpacityOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb81c7a9e577f01f296481c8c11281b519e99d83aa98c145abac858acb68e6f0)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationOpacityOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a7496720ebeb0cb55dd1862a4ef6f34ac51f0b960aa894f82f5e757d47ad6b64)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a0034586660ed77c9f0e7dbfc802aa381bac102203fc7c134170b3244dbb4057)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__072b9cf7474dd0627664656aa0c9223843c88cad54cd8f3f05f96d164edef0b9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationOpacity]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationOpacity]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__090a7b57c558f3b97c9f6f9fbb65f744157fd03733536d61884a5726ce9cf371)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationOpacityOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationOpacityOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dc792d785d617f16494461c105ce8984564abb0ef80f33929178f13925d55641)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetOpacityVar")
    def reset_opacity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacityVar", []))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityVarInput")
    def opacity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacity"))

    @opacity.setter
    def opacity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a97516ce15a342820b419d824b5b5b25dde42e2aa021ef585b72315ed3ebcc8b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacity", value)

    @builtins.property
    @jsii.member(jsii_name="opacityVar")
    def opacity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacityVar"))

    @opacity_var.setter
    def opacity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c7a7b9f64d585cbfeb9c1e49644a7a63c5427013e59a19931987cca92a6c8bc2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacityVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationOpacity]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationOpacity]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationOpacity]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__586cd2f75dc4016b95cfcc26b096cd0af512df88787268810294b29f50dfd9fc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__38a68ba5820cecc530c8441c071af29cd8356c68c12ae86e4c57227ef39f1530)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putAppend")
    def put_append(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationAppend, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__377b1b89c2f72acb0197a87e4d3bf40f8c31ed833bd2f0148083219129fa76cf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putAppend", [value]))

    @jsii.member(jsii_name="putAspectCrop")
    def put_aspect_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationAspectCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a4d1bff03de2814b5b3b44bef162d1e67264571143c9895043a3ea84378c922)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putAspectCrop", [value]))

    @jsii.member(jsii_name="putBackgroundColor")
    def put_background_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f8248c610ec65d53cca61d1add17a6c83d59144cac9c86c8383dda4c20003d0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBackgroundColor", [value]))

    @jsii.member(jsii_name="putBlur")
    def put_blur(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationBlur, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8c65916750d987ea4f56d203697e5ed5f468991ca0f39501ce62791161607187)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBlur", [value]))

    @jsii.member(jsii_name="putChromaKey")
    def put_chroma_key(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationChromaKey, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e9ce7abf569057bcd2164c1401cab38aade9cfc63793c77ec2fb174027ad9903)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putChromaKey", [value]))

    @jsii.member(jsii_name="putComposite")
    def put_composite(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationComposite, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__437c03be55facee004c35bc1be8eb80424a0d6334bb85e83d46e449ad7cc7fca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putComposite", [value]))

    @jsii.member(jsii_name="putCompound")
    def put_compound(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationCompound, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__efa90b1056f3a04e4671955d8dd1edeb1cbabd4af7247d24fc56797c5a0e7a7b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCompound", [value]))

    @jsii.member(jsii_name="putContrast")
    def put_contrast(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationContrast, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0df93e71961e9340705038c685a863eadf7fcc8d907fa90e2921da5120813a33)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putContrast", [value]))

    @jsii.member(jsii_name="putCrop")
    def put_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2c0ba366900ccfb2b98b1589721b784dbef224a64c292f966af00b9607636a0e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCrop", [value]))

    @jsii.member(jsii_name="putFaceCrop")
    def put_face_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationFaceCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea636facdb5b9e0b30ccb11186a943bbc4b4dab5660c233cfd88883bd99e4745)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFaceCrop", [value]))

    @jsii.member(jsii_name="putFeatureCrop")
    def put_feature_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationFeatureCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c66df67b0fbb2c9ccf35f2f4f4155831d9963b895a914c942dca8615a7233608)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFeatureCrop", [value]))

    @jsii.member(jsii_name="putFitAndFill")
    def put_fit_and_fill(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationFitAndFill, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5b12ecec24e0f07db79afdee1b52fc57292df77190caf3e19d2cf00778a18b92)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFitAndFill", [value]))

    @jsii.member(jsii_name="putGoop")
    def put_goop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationGoop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a3f50cd51cd5a37fb6625ec1c26b05646bd2c39005ee1d94e5ec1ec7c5a85ae7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGoop", [value]))

    @jsii.member(jsii_name="putGrayscale")
    def put_grayscale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationGrayscale, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a1e51bfa3caf9b148534cc106ec4b07c99c5834527cf11fcb5b59e400a22f29e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGrayscale", [value]))

    @jsii.member(jsii_name="putHsl")
    def put_hsl(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationHsl, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f50a092576849d75b1879063f625146355100be4316d56b82478763f32974933)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsl", [value]))

    @jsii.member(jsii_name="putHsv")
    def put_hsv(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationHsv, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f14b144aec0f393369b17068d73643505cf948f613973a1732eef1ade2125ed)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsv", [value]))

    @jsii.member(jsii_name="putIfDimension")
    def put_if_dimension(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfDimension, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__280667437d298e05eb4825cbbae64bf572baee3a9708d66f496d444c6085afce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfDimension", [value]))

    @jsii.member(jsii_name="putIfOrientation")
    def put_if_orientation(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0a8ca44ebdf06b22477809d1e552b9a447ce1ec4626851fe7e8c61412e6c67c3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfOrientation", [value]))

    @jsii.member(jsii_name="putImQuery")
    def put_im_query(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationImQuery, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d694a9b674331e8ca2c10978861591632314c51333c81f8ec4ff67384cbba72)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putImQuery", [value]))

    @jsii.member(jsii_name="putMaxColors")
    def put_max_colors(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationMaxColors, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c413055e19dc61ab739af9efe0a2b5268c6d83d59882c1febd22f86e6ed09e40)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMaxColors", [value]))

    @jsii.member(jsii_name="putMirror")
    def put_mirror(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationMirror, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9dda2e3f4b249918f2ba0454a335163811a09b5a8218ab81c9fef22299b93138)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMirror", [value]))

    @jsii.member(jsii_name="putMonoHue")
    def put_mono_hue(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationMonoHue, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4029c9f9073e59cf548ff5d3f748a20c0e6dd083b2c50dfe5cc28a08ff9373e3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMonoHue", [value]))

    @jsii.member(jsii_name="putOpacity")
    def put_opacity(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationOpacity, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dd5c25c64d34a65a5f4e41d0e128a852e13e373be743fb357debf517fbc2b537)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putOpacity", [value]))

    @jsii.member(jsii_name="putRegionOfInterestCrop")
    def put_region_of_interest_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationRegionOfInterestCrop", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e964a7d9b75b6feebc236efa96931c4da16fbf64b7d876c422dd9a4ce6f9d611)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRegionOfInterestCrop", [value]))

    @jsii.member(jsii_name="putRelativeCrop")
    def put_relative_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationRelativeCrop", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__12374394a8de8e1c58817789510faf703956b5a98c787bf1a999e5dd6368c975)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRelativeCrop", [value]))

    @jsii.member(jsii_name="putRemoveColor")
    def put_remove_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationRemoveColor", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6dcab603c20eb03afee3250f4db58fb58bad3743a8763ea14d21737f5103cdb6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRemoveColor", [value]))

    @jsii.member(jsii_name="putResize")
    def put_resize(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationResize", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d4df65c988ee2060c02bbb1e70792c59e8a53126854f039fee578ef9a2d230a6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putResize", [value]))

    @jsii.member(jsii_name="putRotate")
    def put_rotate(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationRotate", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8550b4a17b146e3c3e7a57645cd4f7e4e34257ba8249697ccad601992f2eeb8d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRotate", [value]))

    @jsii.member(jsii_name="putScale")
    def put_scale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationScale", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__29b05f374e86374162b08e589618404ded74821b90fc56c9a44e05c5925c00e8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putScale", [value]))

    @jsii.member(jsii_name="putShear")
    def put_shear(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationShear", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b243f5a2f2ff0d00467f54b1ebb00e88274d29fbbd5aaf738ddb800e1e6328e2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putShear", [value]))

    @jsii.member(jsii_name="putTrim")
    def put_trim(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationTrim", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1295d2bc87cbc21154cd41f470ad1eb36c18db6638fca819ce6fc47151cda82c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTrim", [value]))

    @jsii.member(jsii_name="putUnsharpMask")
    def put_unsharp_mask(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationUnsharpMask", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__66cf8366c25ffe123ef047ab5933376865d52d4c9a6f608e7318b3e447bbc1c9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putUnsharpMask", [value]))

    @jsii.member(jsii_name="resetAppend")
    def reset_append(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAppend", []))

    @jsii.member(jsii_name="resetAspectCrop")
    def reset_aspect_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspectCrop", []))

    @jsii.member(jsii_name="resetBackgroundColor")
    def reset_background_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBackgroundColor", []))

    @jsii.member(jsii_name="resetBlur")
    def reset_blur(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBlur", []))

    @jsii.member(jsii_name="resetChromaKey")
    def reset_chroma_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChromaKey", []))

    @jsii.member(jsii_name="resetComposite")
    def reset_composite(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetComposite", []))

    @jsii.member(jsii_name="resetCompound")
    def reset_compound(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCompound", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetCrop")
    def reset_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCrop", []))

    @jsii.member(jsii_name="resetFaceCrop")
    def reset_face_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFaceCrop", []))

    @jsii.member(jsii_name="resetFeatureCrop")
    def reset_feature_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureCrop", []))

    @jsii.member(jsii_name="resetFitAndFill")
    def reset_fit_and_fill(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFitAndFill", []))

    @jsii.member(jsii_name="resetGoop")
    def reset_goop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGoop", []))

    @jsii.member(jsii_name="resetGrayscale")
    def reset_grayscale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGrayscale", []))

    @jsii.member(jsii_name="resetHsl")
    def reset_hsl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsl", []))

    @jsii.member(jsii_name="resetHsv")
    def reset_hsv(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsv", []))

    @jsii.member(jsii_name="resetIfDimension")
    def reset_if_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfDimension", []))

    @jsii.member(jsii_name="resetIfOrientation")
    def reset_if_orientation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfOrientation", []))

    @jsii.member(jsii_name="resetImQuery")
    def reset_im_query(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetImQuery", []))

    @jsii.member(jsii_name="resetMaxColors")
    def reset_max_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxColors", []))

    @jsii.member(jsii_name="resetMirror")
    def reset_mirror(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMirror", []))

    @jsii.member(jsii_name="resetMonoHue")
    def reset_mono_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonoHue", []))

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetRegionOfInterestCrop")
    def reset_region_of_interest_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRegionOfInterestCrop", []))

    @jsii.member(jsii_name="resetRelativeCrop")
    def reset_relative_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRelativeCrop", []))

    @jsii.member(jsii_name="resetRemoveColor")
    def reset_remove_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRemoveColor", []))

    @jsii.member(jsii_name="resetResize")
    def reset_resize(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetResize", []))

    @jsii.member(jsii_name="resetRotate")
    def reset_rotate(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRotate", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetShear")
    def reset_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetShear", []))

    @jsii.member(jsii_name="resetTrim")
    def reset_trim(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTrim", []))

    @jsii.member(jsii_name="resetUnsharpMask")
    def reset_unsharp_mask(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUnsharpMask", []))

    @builtins.property
    @jsii.member(jsii_name="append")
    def append(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationAppendList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationAppendList, jsii.get(self, "append"))

    @builtins.property
    @jsii.member(jsii_name="aspectCrop")
    def aspect_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationAspectCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationAspectCropList, jsii.get(self, "aspectCrop"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColor")
    def background_color(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationBackgroundColorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationBackgroundColorList, jsii.get(self, "backgroundColor"))

    @builtins.property
    @jsii.member(jsii_name="blur")
    def blur(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationBlurList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationBlurList, jsii.get(self, "blur"))

    @builtins.property
    @jsii.member(jsii_name="chromaKey")
    def chroma_key(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationChromaKeyList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationChromaKeyList, jsii.get(self, "chromaKey"))

    @builtins.property
    @jsii.member(jsii_name="composite")
    def composite(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationCompositeList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationCompositeList, jsii.get(self, "composite"))

    @builtins.property
    @jsii.member(jsii_name="compound")
    def compound(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationCompoundList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationCompoundList, jsii.get(self, "compound"))

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationContrastList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationContrastList, jsii.get(self, "contrast"))

    @builtins.property
    @jsii.member(jsii_name="crop")
    def crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationCropList, jsii.get(self, "crop"))

    @builtins.property
    @jsii.member(jsii_name="faceCrop")
    def face_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationFaceCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationFaceCropList, jsii.get(self, "faceCrop"))

    @builtins.property
    @jsii.member(jsii_name="featureCrop")
    def feature_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationFeatureCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationFeatureCropList, jsii.get(self, "featureCrop"))

    @builtins.property
    @jsii.member(jsii_name="fitAndFill")
    def fit_and_fill(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationFitAndFillList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationFitAndFillList, jsii.get(self, "fitAndFill"))

    @builtins.property
    @jsii.member(jsii_name="goop")
    def goop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationGoopList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationGoopList, jsii.get(self, "goop"))

    @builtins.property
    @jsii.member(jsii_name="grayscale")
    def grayscale(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationGrayscaleList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationGrayscaleList, jsii.get(self, "grayscale"))

    @builtins.property
    @jsii.member(jsii_name="hsl")
    def hsl(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationHslList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationHslList, jsii.get(self, "hsl"))

    @builtins.property
    @jsii.member(jsii_name="hsv")
    def hsv(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationHsvList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationHsvList, jsii.get(self, "hsv"))

    @builtins.property
    @jsii.member(jsii_name="ifDimension")
    def if_dimension(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfDimensionList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfDimensionList, jsii.get(self, "ifDimension"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientation")
    def if_orientation(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfOrientationList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfOrientationList, jsii.get(self, "ifOrientation"))

    @builtins.property
    @jsii.member(jsii_name="imQuery")
    def im_query(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationImQueryList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationImQueryList, jsii.get(self, "imQuery"))

    @builtins.property
    @jsii.member(jsii_name="maxColors")
    def max_colors(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationMaxColorsList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationMaxColorsList, jsii.get(self, "maxColors"))

    @builtins.property
    @jsii.member(jsii_name="mirror")
    def mirror(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationMirrorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationMirrorList, jsii.get(self, "mirror"))

    @builtins.property
    @jsii.member(jsii_name="monoHue")
    def mono_hue(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationMonoHueList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationMonoHueList, jsii.get(self, "monoHue"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationOpacityList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationOpacityList, jsii.get(self, "opacity"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestCrop")
    def region_of_interest_crop(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationRegionOfInterestCropList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationRegionOfInterestCropList", jsii.get(self, "regionOfInterestCrop"))

    @builtins.property
    @jsii.member(jsii_name="relativeCrop")
    def relative_crop(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationRelativeCropList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationRelativeCropList", jsii.get(self, "relativeCrop"))

    @builtins.property
    @jsii.member(jsii_name="removeColor")
    def remove_color(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationRemoveColorList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationRemoveColorList", jsii.get(self, "removeColor"))

    @builtins.property
    @jsii.member(jsii_name="resize")
    def resize(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationResizeList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationResizeList", jsii.get(self, "resize"))

    @builtins.property
    @jsii.member(jsii_name="rotate")
    def rotate(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationRotateList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationRotateList", jsii.get(self, "rotate"))

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationScaleList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationScaleList", jsii.get(self, "scale"))

    @builtins.property
    @jsii.member(jsii_name="shear")
    def shear(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationShearList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationShearList", jsii.get(self, "shear"))

    @builtins.property
    @jsii.member(jsii_name="trim")
    def trim(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationTrimList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationTrimList", jsii.get(self, "trim"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMask")
    def unsharp_mask(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationUnsharpMaskList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationUnsharpMaskList", jsii.get(self, "unsharpMask"))

    @builtins.property
    @jsii.member(jsii_name="appendInput")
    def append_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationAppend]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationAppend]]], jsii.get(self, "appendInput"))

    @builtins.property
    @jsii.member(jsii_name="aspectCropInput")
    def aspect_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationAspectCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationAspectCrop]]], jsii.get(self, "aspectCropInput"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColorInput")
    def background_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationBackgroundColor]]], jsii.get(self, "backgroundColorInput"))

    @builtins.property
    @jsii.member(jsii_name="blurInput")
    def blur_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationBlur]]], jsii.get(self, "blurInput"))

    @builtins.property
    @jsii.member(jsii_name="chromaKeyInput")
    def chroma_key_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationChromaKey]]], jsii.get(self, "chromaKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="compositeInput")
    def composite_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationComposite]]], jsii.get(self, "compositeInput"))

    @builtins.property
    @jsii.member(jsii_name="compoundInput")
    def compound_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationCompound]]], jsii.get(self, "compoundInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationContrast]]], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="cropInput")
    def crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationCrop]]], jsii.get(self, "cropInput"))

    @builtins.property
    @jsii.member(jsii_name="faceCropInput")
    def face_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationFaceCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationFaceCrop]]], jsii.get(self, "faceCropInput"))

    @builtins.property
    @jsii.member(jsii_name="featureCropInput")
    def feature_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationFeatureCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationFeatureCrop]]], jsii.get(self, "featureCropInput"))

    @builtins.property
    @jsii.member(jsii_name="fitAndFillInput")
    def fit_and_fill_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationFitAndFill]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationFitAndFill]]], jsii.get(self, "fitAndFillInput"))

    @builtins.property
    @jsii.member(jsii_name="goopInput")
    def goop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationGoop]]], jsii.get(self, "goopInput"))

    @builtins.property
    @jsii.member(jsii_name="grayscaleInput")
    def grayscale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationGrayscale]]], jsii.get(self, "grayscaleInput"))

    @builtins.property
    @jsii.member(jsii_name="hslInput")
    def hsl_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationHsl]]], jsii.get(self, "hslInput"))

    @builtins.property
    @jsii.member(jsii_name="hsvInput")
    def hsv_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationHsv]]], jsii.get(self, "hsvInput"))

    @builtins.property
    @jsii.member(jsii_name="ifDimensionInput")
    def if_dimension_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfDimension]]], jsii.get(self, "ifDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientationInput")
    def if_orientation_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfOrientation]]], jsii.get(self, "ifOrientationInput"))

    @builtins.property
    @jsii.member(jsii_name="imQueryInput")
    def im_query_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationImQuery]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationImQuery]]], jsii.get(self, "imQueryInput"))

    @builtins.property
    @jsii.member(jsii_name="maxColorsInput")
    def max_colors_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationMaxColors]]], jsii.get(self, "maxColorsInput"))

    @builtins.property
    @jsii.member(jsii_name="mirrorInput")
    def mirror_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationMirror]]], jsii.get(self, "mirrorInput"))

    @builtins.property
    @jsii.member(jsii_name="monoHueInput")
    def mono_hue_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationMonoHue]]], jsii.get(self, "monoHueInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationOpacity]]], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestCropInput")
    def region_of_interest_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationRegionOfInterestCrop"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationRegionOfInterestCrop"]]], jsii.get(self, "regionOfInterestCropInput"))

    @builtins.property
    @jsii.member(jsii_name="relativeCropInput")
    def relative_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationRelativeCrop"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationRelativeCrop"]]], jsii.get(self, "relativeCropInput"))

    @builtins.property
    @jsii.member(jsii_name="removeColorInput")
    def remove_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationRemoveColor"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationRemoveColor"]]], jsii.get(self, "removeColorInput"))

    @builtins.property
    @jsii.member(jsii_name="resizeInput")
    def resize_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationResize"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationResize"]]], jsii.get(self, "resizeInput"))

    @builtins.property
    @jsii.member(jsii_name="rotateInput")
    def rotate_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationRotate"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationRotate"]]], jsii.get(self, "rotateInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationScale"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationScale"]]], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="shearInput")
    def shear_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationShear"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationShear"]]], jsii.get(self, "shearInput"))

    @builtins.property
    @jsii.member(jsii_name="trimInput")
    def trim_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationTrim"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationTrim"]]], jsii.get(self, "trimInput"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMaskInput")
    def unsharp_mask_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationUnsharpMask"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationUnsharpMask"]]], jsii.get(self, "unsharpMaskInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5e4f9e7648e349b8787f8e49c53ad453e9a81935191c824a5a917e795b5d31d6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationRegionOfInterestCrop",
    jsii_struct_bases=[],
    name_mapping={
        "region_of_interest": "regionOfInterest",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationRegionOfInterestCrop:
    def __init__(
        self,
        *,
        region_of_interest: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationRegionOfInterestCropRegionOfInterest", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param region_of_interest: region_of_interest block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest DataAkamaiImagingPolicyImage#region_of_interest}
        :param gravity: The placement of the crop area relative to the specified area of interest. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: The placement of the crop area relative to the specified area of interest. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param style: Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(region_of_interest, dict):
            region_of_interest = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationRegionOfInterestCropRegionOfInterest(**region_of_interest)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__08dca83ec295f8dec28f2841f48dfbe54706378807057be1de49c834da97b1a2)
            check_type(argname="argument region_of_interest", value=region_of_interest, expected_type=type_hints["region_of_interest"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "region_of_interest": region_of_interest,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def region_of_interest(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationRegionOfInterestCropRegionOfInterest":
        '''region_of_interest block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest DataAkamaiImagingPolicyImage#region_of_interest}
        '''
        result = self._values.get("region_of_interest")
        assert result is not None, "Required property 'region_of_interest' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationRegionOfInterestCropRegionOfInterest", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''The placement of the crop area relative to the specified area of interest.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''The placement of the crop area relative to the specified area of interest.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationRegionOfInterestCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationRegionOfInterestCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationRegionOfInterestCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1cc81c254001bdfd439f0351302d837352bdb645679c41e0b6c4cce5ea3ba601)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationRegionOfInterestCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e3e7e3858fbb837afca49a46d8dbd3b8d83f290ccc14e65d49d49c1dfd7e0bae)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationRegionOfInterestCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__88fd1971723d2b230c7a07fa6d371b48f31e3a27f0bc7843f34b5c6d9c330d8a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4f0191c096f38b30edcc38262ac79f04847ea360236ce18aa35c1481e35fbdb6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ec69bafaace5260a2337cd6a8c57eeacd3b22ce51d4bad31f8e96fbfc71ff41e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationRegionOfInterestCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationRegionOfInterestCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationRegionOfInterestCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d2cac68c7b06ac8d882475eacd66a1c99afdf53a3daacd91abf5bd446af3693a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationRegionOfInterestCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationRegionOfInterestCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__65a9a3dd788c8b3955cadee232ce9ef5e9b4db9fea143659fb29404434f7bacd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putRegionOfInterest")
    def put_region_of_interest(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationRegionOfInterestCropRegionOfInterest()

        return typing.cast(None, jsii.invoke(self, "putRegionOfInterest", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterest")
    def region_of_interest(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestOutputReference", jsii.get(self, "regionOfInterest"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestInput")
    def region_of_interest_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationRegionOfInterestCropRegionOfInterest"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationRegionOfInterestCropRegionOfInterest"], jsii.get(self, "regionOfInterestInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a50826adb042bd39c29d41cd6143bee6526ffeae462271ddb30af376124e55be)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c78422db57392440bf1254955e0ab7dab0790c408f7da73986fee96630883ddf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab4618e28eb84a20ff81f3dde9f1dbe6ef4d4391141cbb773df86569c9e68f4c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d8e39094e14544db4b879cf0df22dad1e7041796c0d4c403fee073cb45bd2f0b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__109bdc10caec0b039deddb97dfd793886e007bd4cc70cfbcf3aea86737980396)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__102d4c921b5f2866fc228bdb78ee7fe6d3bcdeb4d18e6de447345ac27fb56b10)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__84112f0cbb3df8b3bec12eeb7633f9ad4c399d36858c08cdc5694a332f24ff89)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d7a52a3efd1e03e35d72bb3f08d9882caf3fa057b58b7c23e945b009b83c2b2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationRegionOfInterestCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationRegionOfInterestCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationRegionOfInterestCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3efd462b01575d24fbc49ec9053b46d4fc2b08c8e3eec08970eeed617a6e8474)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationRegionOfInterestCropRegionOfInterest",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationRegionOfInterestCropRegionOfInterest:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationRegionOfInterestCropRegionOfInterest(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__969ac0f427043a607c96de8c9f83d76e65d5bbef078f05be96175af74e0073c2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationRegionOfInterestCropRegionOfInterest]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationRegionOfInterestCropRegionOfInterest], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationRegionOfInterestCropRegionOfInterest],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__12107750c43a876978e11c84ddb4957938321774b63ce0c1375f71ab7f0af10c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationRelativeCrop",
    jsii_struct_bases=[],
    name_mapping={
        "east": "east",
        "east_var": "eastVar",
        "north": "north",
        "north_var": "northVar",
        "south": "south",
        "south_var": "southVar",
        "west": "west",
        "west_var": "westVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationRelativeCrop:
    def __init__(
        self,
        *,
        east: typing.Optional[builtins.str] = None,
        east_var: typing.Optional[builtins.str] = None,
        north: typing.Optional[builtins.str] = None,
        north_var: typing.Optional[builtins.str] = None,
        south: typing.Optional[builtins.str] = None,
        south_var: typing.Optional[builtins.str] = None,
        west: typing.Optional[builtins.str] = None,
        west_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param east: The number of pixels to shrink or expand the right side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east DataAkamaiImagingPolicyImage#east}
        :param east_var: The number of pixels to shrink or expand the right side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east_var DataAkamaiImagingPolicyImage#east_var}
        :param north: The number of pixels to shrink or expand the top side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north DataAkamaiImagingPolicyImage#north}
        :param north_var: The number of pixels to shrink or expand the top side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north_var DataAkamaiImagingPolicyImage#north_var}
        :param south: The number of pixels to shrink or expand the bottom side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south DataAkamaiImagingPolicyImage#south}
        :param south_var: The number of pixels to shrink or expand the bottom side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south_var DataAkamaiImagingPolicyImage#south_var}
        :param west: The number of pixels to shrink or expand the left side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west DataAkamaiImagingPolicyImage#west}
        :param west_var: The number of pixels to shrink or expand the left side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west_var DataAkamaiImagingPolicyImage#west_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__590066f16b9d916513f2f04f23d7628b4a2744b9e171a4ccfc4d2d8be3d4305d)
            check_type(argname="argument east", value=east, expected_type=type_hints["east"])
            check_type(argname="argument east_var", value=east_var, expected_type=type_hints["east_var"])
            check_type(argname="argument north", value=north, expected_type=type_hints["north"])
            check_type(argname="argument north_var", value=north_var, expected_type=type_hints["north_var"])
            check_type(argname="argument south", value=south, expected_type=type_hints["south"])
            check_type(argname="argument south_var", value=south_var, expected_type=type_hints["south_var"])
            check_type(argname="argument west", value=west, expected_type=type_hints["west"])
            check_type(argname="argument west_var", value=west_var, expected_type=type_hints["west_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if east is not None:
            self._values["east"] = east
        if east_var is not None:
            self._values["east_var"] = east_var
        if north is not None:
            self._values["north"] = north
        if north_var is not None:
            self._values["north_var"] = north_var
        if south is not None:
            self._values["south"] = south
        if south_var is not None:
            self._values["south_var"] = south_var
        if west is not None:
            self._values["west"] = west
        if west_var is not None:
            self._values["west_var"] = west_var

    @builtins.property
    def east(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the right side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east DataAkamaiImagingPolicyImage#east}
        '''
        result = self._values.get("east")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def east_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the right side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east_var DataAkamaiImagingPolicyImage#east_var}
        '''
        result = self._values.get("east_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def north(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the top side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north DataAkamaiImagingPolicyImage#north}
        '''
        result = self._values.get("north")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def north_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the top side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north_var DataAkamaiImagingPolicyImage#north_var}
        '''
        result = self._values.get("north_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def south(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the bottom side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south DataAkamaiImagingPolicyImage#south}
        '''
        result = self._values.get("south")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def south_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the bottom side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south_var DataAkamaiImagingPolicyImage#south_var}
        '''
        result = self._values.get("south_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def west(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the left side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west DataAkamaiImagingPolicyImage#west}
        '''
        result = self._values.get("west")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def west_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the left side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west_var DataAkamaiImagingPolicyImage#west_var}
        '''
        result = self._values.get("west_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationRelativeCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationRelativeCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationRelativeCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c217c3ebd2db97c90964a3cec13297739bc5f21ad3e45ece274af6865c8ce410)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationRelativeCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__81654c112c8dc83049cf58fada8ddf61073e408eb207cebbb5a419324c78021c)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationRelativeCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e373f6ee28acbc42a4fcf732c8580ca0d55f8de72d8ab71a2338776ac8e1670c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd637ac77a6a7fcd5da7394690ad6e466ea5ad7572df4c1071585205a29621c5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__08c63d8c280f4368341c579d1af1c0444e6d75805cd8e547d335d2693cf90090)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationRelativeCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationRelativeCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationRelativeCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6a7de6c439864407f1994c99f1e85061ca1f6599cd5ac57baa27d6f943ae674c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationRelativeCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationRelativeCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d892407c90a9cfc2ca0f1e75b6226f1ee52f5d379fc37fd5ee32569204cbbaab)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetEast")
    def reset_east(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEast", []))

    @jsii.member(jsii_name="resetEastVar")
    def reset_east_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEastVar", []))

    @jsii.member(jsii_name="resetNorth")
    def reset_north(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNorth", []))

    @jsii.member(jsii_name="resetNorthVar")
    def reset_north_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNorthVar", []))

    @jsii.member(jsii_name="resetSouth")
    def reset_south(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSouth", []))

    @jsii.member(jsii_name="resetSouthVar")
    def reset_south_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSouthVar", []))

    @jsii.member(jsii_name="resetWest")
    def reset_west(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWest", []))

    @jsii.member(jsii_name="resetWestVar")
    def reset_west_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWestVar", []))

    @builtins.property
    @jsii.member(jsii_name="eastInput")
    def east_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "eastInput"))

    @builtins.property
    @jsii.member(jsii_name="eastVarInput")
    def east_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "eastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="northInput")
    def north_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "northInput"))

    @builtins.property
    @jsii.member(jsii_name="northVarInput")
    def north_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "northVarInput"))

    @builtins.property
    @jsii.member(jsii_name="southInput")
    def south_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "southInput"))

    @builtins.property
    @jsii.member(jsii_name="southVarInput")
    def south_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "southVarInput"))

    @builtins.property
    @jsii.member(jsii_name="westInput")
    def west_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "westInput"))

    @builtins.property
    @jsii.member(jsii_name="westVarInput")
    def west_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "westVarInput"))

    @builtins.property
    @jsii.member(jsii_name="east")
    def east(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "east"))

    @east.setter
    def east(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__efe41602e8252fc645675ea6d26c01e490ffbd01bb97b4a615b8c0373b79f5ee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "east", value)

    @builtins.property
    @jsii.member(jsii_name="eastVar")
    def east_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "eastVar"))

    @east_var.setter
    def east_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ecb287d4ab41b488f6f04db977e27c0b3db0c53b1e88e6682a3d4fe8680bbe61)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "eastVar", value)

    @builtins.property
    @jsii.member(jsii_name="north")
    def north(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "north"))

    @north.setter
    def north(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5dbe2c6af50245d811798e63475ccb83e88fecd93ff564bab75ab278ce455d05)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "north", value)

    @builtins.property
    @jsii.member(jsii_name="northVar")
    def north_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "northVar"))

    @north_var.setter
    def north_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a1235f8622811aa3b6f07b333ffb0c78157e6596cb17c09d9fd255f0f524245e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "northVar", value)

    @builtins.property
    @jsii.member(jsii_name="south")
    def south(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "south"))

    @south.setter
    def south(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__406dac3b8af8e7d4ca9b2a1e17f963dca325e4a957da59d1dfd3746fa6fdb0c9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "south", value)

    @builtins.property
    @jsii.member(jsii_name="southVar")
    def south_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "southVar"))

    @south_var.setter
    def south_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__91f3d31ab90f4e8c46ef57af8c6191c385b339a480fade9f6f8819dea66038fb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "southVar", value)

    @builtins.property
    @jsii.member(jsii_name="west")
    def west(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "west"))

    @west.setter
    def west(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8c727dad628deaa261fb74fe5700c7939a12a4c248453e74cb68ce5c51283dad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "west", value)

    @builtins.property
    @jsii.member(jsii_name="westVar")
    def west_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "westVar"))

    @west_var.setter
    def west_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__45d3a4bd52118d3046ac44a8f2ed9f27e346f5f8c3cbdde1260cf07b811810e3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "westVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationRelativeCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationRelativeCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationRelativeCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eb6a67d635ef909582130979bdd15f7991f6d831cf36657d1c380880a6828c89)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationRemoveColor",
    jsii_struct_bases=[],
    name_mapping={
        "color": "color",
        "color_var": "colorVar",
        "feather": "feather",
        "feather_var": "featherVar",
        "tolerance": "tolerance",
        "tolerance_var": "toleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationRemoveColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
        feather: typing.Optional[builtins.str] = None,
        feather_var: typing.Optional[builtins.str] = None,
        tolerance: typing.Optional[builtins.str] = None,
        tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        :param feather: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        :param feather_var: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        :param tolerance: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        :param tolerance_var: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__75f0708352211a93a2e9f04ace9017f8fe3e466e5a65a08fc94e467294840297)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
            check_type(argname="argument feather", value=feather, expected_type=type_hints["feather"])
            check_type(argname="argument feather_var", value=feather_var, expected_type=type_hints["feather_var"])
            check_type(argname="argument tolerance", value=tolerance, expected_type=type_hints["tolerance"])
            check_type(argname="argument tolerance_var", value=tolerance_var, expected_type=type_hints["tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var
        if feather is not None:
            self._values["feather"] = feather
        if feather_var is not None:
            self._values["feather_var"] = feather_var
        if tolerance is not None:
            self._values["tolerance"] = tolerance
        if tolerance_var is not None:
            self._values["tolerance_var"] = tolerance_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        '''
        result = self._values.get("feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather_var(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        '''
        result = self._values.get("feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        '''
        result = self._values.get("tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance_var(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        result = self._values.get("tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationRemoveColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationRemoveColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationRemoveColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7cc1fe99dc01fb7311a2d5331d61a0be407d168b4cdbcb2d378fc7595cf0a8fb)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationRemoveColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0d738ac7397349dd87d105061c7276c9d1d8cc42f5c6c7780b83bfa65b63d5a7)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationRemoveColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__783be84e35f3eb1095989076ebfbc71bcbac44095818e2eb47e784e16583da97)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bd6072bb9365cd75525f2773663dfacb9a7c250e1c74419c422d3996635510fe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6389a2fd16f1f4f7ca60e3fc4da163ec0797f34211d2d3ef2d83fb6319a2f491)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationRemoveColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationRemoveColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationRemoveColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1813c1f96b3b15f0a9637b82de2bc335cb602a0e4b36cb8f0322c71ef098996e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationRemoveColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationRemoveColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f6f5bb5402d6642e4f7147269f2c91143a37e7450e8f0dd41cf00ac4de5d9309)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @jsii.member(jsii_name="resetFeather")
    def reset_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeather", []))

    @jsii.member(jsii_name="resetFeatherVar")
    def reset_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatherVar", []))

    @jsii.member(jsii_name="resetTolerance")
    def reset_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTolerance", []))

    @jsii.member(jsii_name="resetToleranceVar")
    def reset_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featherInput")
    def feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherInput"))

    @builtins.property
    @jsii.member(jsii_name="featherVarInput")
    def feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceInput")
    def tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceVarInput")
    def tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__06a6a6dde6ffdc743e8dd4051b2d1a67536e8d808cebafcd2ff78103e2abdf4e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3f5820406da304c5cc96d4479249dd0a247e3435acab3cf86e665707d5862df6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="feather")
    def feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "feather"))

    @feather.setter
    def feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__87499fe432478e986045f06d4f8fa923081c954b0f339606982b36f262cbd82b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "feather", value)

    @builtins.property
    @jsii.member(jsii_name="featherVar")
    def feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featherVar"))

    @feather_var.setter
    def feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f06b8701024217ccd781adb199eccbbcff36763f53fe9b0e3f225536c7e4cc3d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featherVar", value)

    @builtins.property
    @jsii.member(jsii_name="tolerance")
    def tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tolerance"))

    @tolerance.setter
    def tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__24c87a8cf78b5a5e2a9865ec2eecb6a384b285009b927fe4e241a4bc4bf27e37)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tolerance", value)

    @builtins.property
    @jsii.member(jsii_name="toleranceVar")
    def tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "toleranceVar"))

    @tolerance_var.setter
    def tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__17a7e0475e874c0172aafdd605930452a35bdcdc372aa10820e3a44e78cb281e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "toleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationRemoveColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationRemoveColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationRemoveColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__91d3acdad82441e19b2a78e8e779e18a1e07fa73997373f62eacc8ff573812b9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationResize",
    jsii_struct_bases=[],
    name_mapping={
        "aspect": "aspect",
        "aspect_var": "aspectVar",
        "height": "height",
        "height_var": "heightVar",
        "type": "type",
        "type_var": "typeVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationResize:
    def __init__(
        self,
        *,
        aspect: typing.Optional[builtins.str] = None,
        aspect_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param aspect: Preserves the aspect ratio. Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect DataAkamaiImagingPolicyImage#aspect}
        :param aspect_var: Preserves the aspect ratio. Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_var DataAkamaiImagingPolicyImage#aspect_var}
        :param height: The height to resize the source image to. Must be set if height is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height to resize the source image to. Must be set if height is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param type: Sets constraints for the image resize. Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: Sets constraints for the image resize. Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        :param width: The width to resize the source image to. Must be set if width is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width to resize the source image to. Must be set if width is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__95fa6cbe6d3874f1f9acf1ddfa1535ac6ccfa0edb5e62c2083965ceb43114717)
            check_type(argname="argument aspect", value=aspect, expected_type=type_hints["aspect"])
            check_type(argname="argument aspect_var", value=aspect_var, expected_type=type_hints["aspect_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if aspect is not None:
            self._values["aspect"] = aspect
        if aspect_var is not None:
            self._values["aspect_var"] = aspect_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def aspect(self) -> typing.Optional[builtins.str]:
        '''Preserves the aspect ratio.

        Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect DataAkamaiImagingPolicyImage#aspect}
        '''
        result = self._values.get("aspect")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def aspect_var(self) -> typing.Optional[builtins.str]:
        '''Preserves the aspect ratio.

        Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_var DataAkamaiImagingPolicyImage#aspect_var}
        '''
        result = self._values.get("aspect_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height to resize the source image to. Must be set if height is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height to resize the source image to. Must be set if height is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''Sets constraints for the image resize.

        Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''Sets constraints for the image resize.

        Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width to resize the source image to. Must be set if width is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width to resize the source image to. Must be set if width is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationResize(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationResizeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationResizeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d61b7cb9a2f5b6f903795e2e2795bced15d868bdb826f0dbe4f2238a37257fe6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationResizeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__92ce66917d5d823d8296c036ff91a2abe0983901f99267ec1cd05abb85b857fc)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationResizeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__37d93a4f7801d67e453c99b7c0ff4b77780dfb4c7b5e9361cb43673e89fee9a4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8af80ae5cd1b02347b9e7e7003384ad7ec1d378f969e38eac76fcf8a76deef1a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d5a7d441f786a8697faa692815426bbde6c8f5185e1fc7a6034ea4f5fe2808ad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationResize]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationResize]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationResize]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7e79054d95b97fa8af5be802a4744e1ed41a0bf316301cc1819c84634f4be3a5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationResizeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationResizeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a118acda5bacb649d63416f301f55f1ac76a676cfab75ff78dca55ce9f8d1bf8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAspect")
    def reset_aspect(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspect", []))

    @jsii.member(jsii_name="resetAspectVar")
    def reset_aspect_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspectVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="aspectInput")
    def aspect_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "aspectInput"))

    @builtins.property
    @jsii.member(jsii_name="aspectVarInput")
    def aspect_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "aspectVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="aspect")
    def aspect(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "aspect"))

    @aspect.setter
    def aspect(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__265bd80a8e84a42ba1782c7994416e19f7a12786953c2cdda3369b417b3c3aa2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "aspect", value)

    @builtins.property
    @jsii.member(jsii_name="aspectVar")
    def aspect_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "aspectVar"))

    @aspect_var.setter
    def aspect_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__93acc9d0e14bad4b0bf5eacfd1142829ce58dd3651caaf9ceb83d9f2f4f6ffdb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "aspectVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__516acc8d359c91fdb7f4a25602626748819fa19ef6a02f3cf9ed8114a0cf35aa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c0f9eb3ebc2f664979fb03995c408441b48d5344025e09bb0870f12d7da667b1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__572bc128d40ea134bacf0924b44ad8b2ccbb14852d4157825ce58d29fd195989)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fe70d00218be8433b1ccd24a6791253bb22a46d9bfefdd1d1c0882dbe8048d1e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__205c24cad888c1987c607d1c497b60697eab9e096a53f3ff1120778a2e5b4655)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7ed8acbf96a3140ccd5fb8eb9baafd2b0c8cbfa91ceb7d50f3e531c222869df9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationResize]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationResize]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationResize]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aeb5838a1ced82d558a337f37fd4b6517a406587d8b6bf3e0529f098c80b0022)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationRotate",
    jsii_struct_bases=[],
    name_mapping={"degrees": "degrees", "degrees_var": "degreesVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationRotate:
    def __init__(
        self,
        *,
        degrees: typing.Optional[builtins.str] = None,
        degrees_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param degrees: The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees DataAkamaiImagingPolicyImage#degrees}
        :param degrees_var: The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees_var DataAkamaiImagingPolicyImage#degrees_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fc20a6413efa434d412c1974647c4c008122f812b96a9b3801ced4ccd869f096)
            check_type(argname="argument degrees", value=degrees, expected_type=type_hints["degrees"])
            check_type(argname="argument degrees_var", value=degrees_var, expected_type=type_hints["degrees_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if degrees is not None:
            self._values["degrees"] = degrees
        if degrees_var is not None:
            self._values["degrees_var"] = degrees_var

    @builtins.property
    def degrees(self) -> typing.Optional[builtins.str]:
        '''The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees DataAkamaiImagingPolicyImage#degrees}
        '''
        result = self._values.get("degrees")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def degrees_var(self) -> typing.Optional[builtins.str]:
        '''The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees_var DataAkamaiImagingPolicyImage#degrees_var}
        '''
        result = self._values.get("degrees_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationRotate(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationRotateList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationRotateList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8f5961649cf6f73aaa8c6adc7aa2ac9f04355ff93a1528d9e22e845df21d9d25)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationRotateOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b31de38d6b44cd31c3b9c2159534ca164f54308d636258d11a3a042c79887fa9)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationRotateOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d3b6c3166351df24eecb67806a81b1fe87fb48254e0b55d5310347ecb7ae0e2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d3b81bd91eb0383762a4e983c09f48a0d154cb20609359c0d6fcac7076181317)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d8bbc52e88ca72e2be1bfc5608391e6494c76f1bbf8a0b524dcd2040d022ecd1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationRotate]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationRotate]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationRotate]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__620339f8b35b346d4b9bbc0dd1fa36f2ac342619166059ed0b756650ce0a6189)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationRotateOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationRotateOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1e03d2ca7993d95e4a0c396728c4e794af90a1bebf40156de3e4c9be7daabb25)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetDegrees")
    def reset_degrees(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDegrees", []))

    @jsii.member(jsii_name="resetDegreesVar")
    def reset_degrees_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDegreesVar", []))

    @builtins.property
    @jsii.member(jsii_name="degreesInput")
    def degrees_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "degreesInput"))

    @builtins.property
    @jsii.member(jsii_name="degreesVarInput")
    def degrees_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "degreesVarInput"))

    @builtins.property
    @jsii.member(jsii_name="degrees")
    def degrees(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "degrees"))

    @degrees.setter
    def degrees(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__93c7b4aede4303467ef6dfb0e9d3ef556454b6b86ab990a4ecac2dca4e8a40b5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "degrees", value)

    @builtins.property
    @jsii.member(jsii_name="degreesVar")
    def degrees_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "degreesVar"))

    @degrees_var.setter
    def degrees_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e353a7968701844e695d3610e71c5582e80c17f7bd7f95cd611f31bf38d965c7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "degreesVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationRotate]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationRotate]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationRotate]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__79c54112b4414996727a3f72ce2b24e8181157646cf592ca8004ad59f3d52a23)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationScale",
    jsii_struct_bases=[],
    name_mapping={
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationScale:
    def __init__(
        self,
        *,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param height: Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged. Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged. Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f560f2c93b43181ad4800eaa832534e8a5a2860eb92b6b3840c86bd5927f589e)
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size.

        Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size.

        Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged.

        Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged.

        Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationScale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationScaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationScaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df9900163d9091f6a69e5db2a5d694b138a6e7b5eb1c1b46f32d5d60a503a485)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationScaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__73d368d1206c8e089ee7d8adfc70c7ecd3ef9c0000383fe7879c0d46da2df471)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationScaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8aa7e8b4abd1b2bc5790eec2aac369f4064e9c01acac43c234d65265105d1a69)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0453757969b1429a1b49e7195fd9fba2d52d3eff0919a58743cb25b60ac9da17)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d6e0e958bb3b45806beefd5e76e1df6ad36aef698bb6f0f50fc935c596d4266c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationScale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationScale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationScale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__35e46cb3b48fa190be4a5f1c41022acd6f58a627e0ea2dd5128a3976b7b6da87)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationScaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationScaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3b4bc1e036c0a58149024ee56e34521830c2492d31fd868404cf6e3ef706248c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e9025da19b8e92944717ae674a3ed8f616d8df4c0c4052b21638d7423a3ff12a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e47283a53107ff5aad466ae8d201dd7d060469f3b8ff5a782b7b81d4ad098ba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f1c2ca0abab62c926f9fdd2723f3d62a02a7cdc2cdd21be6fda71873c0094cf6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d954c82b923312974e5b9c650a06b1f378128d2eb019bd6e169ee06e2f804c38)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationScale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationScale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationScale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__995132cfc63ce12afd6cccf1940bacc5a4b1866d50e4a02a750dbf55e1297a65)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationShear",
    jsii_struct_bases=[],
    name_mapping={
        "x_shear": "xShear",
        "x_shear_var": "xShearVar",
        "y_shear": "yShear",
        "y_shear_var": "yShearVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationShear:
    def __init__(
        self,
        *,
        x_shear: typing.Optional[builtins.str] = None,
        x_shear_var: typing.Optional[builtins.str] = None,
        y_shear: typing.Optional[builtins.str] = None,
        y_shear_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param x_shear: The amount to shear along the x-axis, measured in multiples of the image's width. Must be set if yShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear DataAkamaiImagingPolicyImage#x_shear}
        :param x_shear_var: The amount to shear along the x-axis, measured in multiples of the image's width. Must be set if yShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear_var DataAkamaiImagingPolicyImage#x_shear_var}
        :param y_shear: The amount to shear along the y-axis, measured in multiples of the image's height. Must be set if xShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear DataAkamaiImagingPolicyImage#y_shear}
        :param y_shear_var: The amount to shear along the y-axis, measured in multiples of the image's height. Must be set if xShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear_var DataAkamaiImagingPolicyImage#y_shear_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b4978e9075d059443c55cb27378c8c3e688ba4c1c464b36fe79b8405990ca3ab)
            check_type(argname="argument x_shear", value=x_shear, expected_type=type_hints["x_shear"])
            check_type(argname="argument x_shear_var", value=x_shear_var, expected_type=type_hints["x_shear_var"])
            check_type(argname="argument y_shear", value=y_shear, expected_type=type_hints["y_shear"])
            check_type(argname="argument y_shear_var", value=y_shear_var, expected_type=type_hints["y_shear_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if x_shear is not None:
            self._values["x_shear"] = x_shear
        if x_shear_var is not None:
            self._values["x_shear_var"] = x_shear_var
        if y_shear is not None:
            self._values["y_shear"] = y_shear
        if y_shear_var is not None:
            self._values["y_shear_var"] = y_shear_var

    @builtins.property
    def x_shear(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the x-axis, measured in multiples of the image's width.

        Must be set if yShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear DataAkamaiImagingPolicyImage#x_shear}
        '''
        result = self._values.get("x_shear")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_shear_var(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the x-axis, measured in multiples of the image's width.

        Must be set if yShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear_var DataAkamaiImagingPolicyImage#x_shear_var}
        '''
        result = self._values.get("x_shear_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_shear(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the y-axis, measured in multiples of the image's height.

        Must be set if xShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear DataAkamaiImagingPolicyImage#y_shear}
        '''
        result = self._values.get("y_shear")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_shear_var(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the y-axis, measured in multiples of the image's height.

        Must be set if xShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear_var DataAkamaiImagingPolicyImage#y_shear_var}
        '''
        result = self._values.get("y_shear_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationShear(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationShearList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationShearList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb7d6f44a42f7da1f4da9f09e2064dc1767c36a00b3b53f87739d8e127f1b648)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationShearOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__34574c829436dd0825f15300cfa7327503e3477bd935b3dabf17276b26f2bd6e)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationShearOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1888c78f9965dd8e0d5bd1189a3281bb5bced849004961ac1a6811280e1b3021)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aa9f7ae796586ad9a0e49c0071c5e323c065b9861997a22217e291fda1b44762)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c48849f916ca828593a8299811d969310aeb4fc29d9a3fe8a7fa74dbdeead2ef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationShear]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationShear]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationShear]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c739b037c801a0c517a6586eaf5d1b697a9f560c499e68aeb38f74a4004c0783)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationShearOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationShearOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c57d951d7e0db50c52de7702b77bae1dca1991ed97f9a97b1d129b1a081b83d9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetXShear")
    def reset_x_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXShear", []))

    @jsii.member(jsii_name="resetXShearVar")
    def reset_x_shear_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXShearVar", []))

    @jsii.member(jsii_name="resetYShear")
    def reset_y_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYShear", []))

    @jsii.member(jsii_name="resetYShearVar")
    def reset_y_shear_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYShearVar", []))

    @builtins.property
    @jsii.member(jsii_name="xShearInput")
    def x_shear_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xShearInput"))

    @builtins.property
    @jsii.member(jsii_name="xShearVarInput")
    def x_shear_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xShearVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yShearInput")
    def y_shear_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yShearInput"))

    @builtins.property
    @jsii.member(jsii_name="yShearVarInput")
    def y_shear_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yShearVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xShear")
    def x_shear(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xShear"))

    @x_shear.setter
    def x_shear(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8dbec60af68ac435a56147855ebf7881bfaf667dc5b97f3970cf94d9351f6e8a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xShear", value)

    @builtins.property
    @jsii.member(jsii_name="xShearVar")
    def x_shear_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xShearVar"))

    @x_shear_var.setter
    def x_shear_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ceca01adb261b59c46eacb344db9f3718e038588e0e4f2351ed3e699cd30524)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xShearVar", value)

    @builtins.property
    @jsii.member(jsii_name="yShear")
    def y_shear(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yShear"))

    @y_shear.setter
    def y_shear(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__491fb46c14187fa8d3aee84c4c386e57a223f16f4de09718c34e025e0147b155)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yShear", value)

    @builtins.property
    @jsii.member(jsii_name="yShearVar")
    def y_shear_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yShearVar"))

    @y_shear_var.setter
    def y_shear_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a71b441c842e2890086e750107a7661bd2d48591e52a7bf0d95827b213a3bca9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yShearVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationShear]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationShear]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationShear]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__03093e920f982c771941188711f76540a2e9704b0b97a59017c919b85b21ce53)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationTrim",
    jsii_struct_bases=[],
    name_mapping={
        "fuzz": "fuzz",
        "fuzz_var": "fuzzVar",
        "padding": "padding",
        "padding_var": "paddingVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationTrim:
    def __init__(
        self,
        *,
        fuzz: typing.Optional[builtins.str] = None,
        fuzz_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fuzz: The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz DataAkamaiImagingPolicyImage#fuzz}
        :param fuzz_var: The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz_var DataAkamaiImagingPolicyImage#fuzz_var}
        :param padding: The amount of padding in pixels to add to the trimmed image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: The amount of padding in pixels to add to the trimmed image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d17a919a592a91973849c36fe9429cbf4f2e58b0910fc74da2ab66e475384da5)
            check_type(argname="argument fuzz", value=fuzz, expected_type=type_hints["fuzz"])
            check_type(argname="argument fuzz_var", value=fuzz_var, expected_type=type_hints["fuzz_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fuzz is not None:
            self._values["fuzz"] = fuzz
        if fuzz_var is not None:
            self._values["fuzz_var"] = fuzz_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var

    @builtins.property
    def fuzz(self) -> typing.Optional[builtins.str]:
        '''The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz DataAkamaiImagingPolicyImage#fuzz}
        '''
        result = self._values.get("fuzz")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fuzz_var(self) -> typing.Optional[builtins.str]:
        '''The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz_var DataAkamaiImagingPolicyImage#fuzz_var}
        '''
        result = self._values.get("fuzz_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''The amount of padding in pixels to add to the trimmed image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''The amount of padding in pixels to add to the trimmed image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationTrim(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationTrimList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationTrimList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__225900d0b3fa6d6c743657058778d62efa50f3edb479763d558aaaa579b3055b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationTrimOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc91714f52155d6a609a08f9428a2bc44c4df0f18b72eb8d03b7b5e9daaf2f7e)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationTrimOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__15be2f5594d47e9de8bccc86bebe30c83df42661f3f0c0ab61c686ddb59065da)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__278b46d9250c8c20ab13e50b97312d6541ec1f14edab6c76da049c945da67a22)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b1de510565c803e8d2dfdf4e8e1b364ea7d52cc56fef89a4bb0c42e0c28adca1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationTrim]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationTrim]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationTrim]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__72544d7365dd2ecea6155b67279d08b230f0b6baebdeb71802aeab8dceac7e74)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationTrimOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationTrimOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__59356952bcfc6a76f502ec7dcb629afd8be283036e8a449cab8fc272a8c3e956)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetFuzz")
    def reset_fuzz(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFuzz", []))

    @jsii.member(jsii_name="resetFuzzVar")
    def reset_fuzz_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFuzzVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @builtins.property
    @jsii.member(jsii_name="fuzzInput")
    def fuzz_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fuzzInput"))

    @builtins.property
    @jsii.member(jsii_name="fuzzVarInput")
    def fuzz_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fuzzVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="fuzz")
    def fuzz(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fuzz"))

    @fuzz.setter
    def fuzz(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b2313e0e745ab3b5fb223b6a968e65ab57af1fa62687eff2bf884338c7f0dced)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fuzz", value)

    @builtins.property
    @jsii.member(jsii_name="fuzzVar")
    def fuzz_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fuzzVar"))

    @fuzz_var.setter
    def fuzz_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9774a5bfd9148990028db2a5f049117660c245e38a62c3465846f013ca448488)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fuzzVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7cd2fe85ba56972522e64aceb4c3fef94b88a76ddbbe94ae8a36157294fc8631)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cca4f6247375d6301ce99f6450f5e069a5323da8a3380cf0b71b835c503a44f1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationTrim]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationTrim]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationTrim]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bd281c0f7d4695db44044ef36dba39d0e16c34a2de2ffe5923b6659a78c787ce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationUnsharpMask",
    jsii_struct_bases=[],
    name_mapping={
        "gain": "gain",
        "gain_var": "gainVar",
        "sigma": "sigma",
        "sigma_var": "sigmaVar",
        "threshold": "threshold",
        "threshold_var": "thresholdVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationUnsharpMask:
    def __init__(
        self,
        *,
        gain: typing.Optional[builtins.str] = None,
        gain_var: typing.Optional[builtins.str] = None,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
        threshold: typing.Optional[builtins.str] = None,
        threshold_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param gain: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        :param gain_var: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        :param sigma: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        :param threshold: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        :param threshold_var: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f13e88e8ac5a4a06145d9f070f599a27da01ea7c63c60319f9983ac108f96185)
            check_type(argname="argument gain", value=gain, expected_type=type_hints["gain"])
            check_type(argname="argument gain_var", value=gain_var, expected_type=type_hints["gain_var"])
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
            check_type(argname="argument threshold", value=threshold, expected_type=type_hints["threshold"])
            check_type(argname="argument threshold_var", value=threshold_var, expected_type=type_hints["threshold_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if gain is not None:
            self._values["gain"] = gain
        if gain_var is not None:
            self._values["gain_var"] = gain_var
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var
        if threshold is not None:
            self._values["threshold"] = threshold
        if threshold_var is not None:
            self._values["threshold_var"] = threshold_var

    @builtins.property
    def gain(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        '''
        result = self._values.get("gain")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gain_var(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        '''
        result = self._values.get("gain_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        '''
        result = self._values.get("threshold")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold_var(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        result = self._values.get("threshold_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationUnsharpMask(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationUnsharpMaskList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationUnsharpMaskList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__123d720cdf697d888c47b1e6891da4f897701de5e1c838236dc38a089d8be087)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationUnsharpMaskOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f1668fbab407ef38752b0a7573629a8a27e497827681787cff0339697302166)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationUnsharpMaskOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__daa4cc61e6c76685d5ef8440443058ca0aca04fa4b5091b23d2104f2c6f5886a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e2dac529c1dbc0fdfdb45a17b98094df3b99a81504fba810218b5ef514e0dd56)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e95c1623ab4ade697638d62fe4585e517659ed24e07e67a5bc0084ee890052bd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationUnsharpMask]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationUnsharpMask]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationUnsharpMask]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7cb5408437439e8182f7d7a3950ffef722cafd8c8e462c4249b32f41b4e57623)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationUnsharpMaskOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationUnsharpMaskOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1aebf49b4785ce6bf491550ba90605596939db55ae643b97d50b2619fc3c1ff9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetGain")
    def reset_gain(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGain", []))

    @jsii.member(jsii_name="resetGainVar")
    def reset_gain_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGainVar", []))

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @jsii.member(jsii_name="resetThreshold")
    def reset_threshold(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThreshold", []))

    @jsii.member(jsii_name="resetThresholdVar")
    def reset_threshold_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThresholdVar", []))

    @builtins.property
    @jsii.member(jsii_name="gainInput")
    def gain_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainInput"))

    @builtins.property
    @jsii.member(jsii_name="gainVarInput")
    def gain_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdInput")
    def threshold_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdVarInput")
    def threshold_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gain")
    def gain(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gain"))

    @gain.setter
    def gain(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__57b0759649febd3ba4ec589efc4cab8c92d08532ef12f784a29d72058e4644a6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gain", value)

    @builtins.property
    @jsii.member(jsii_name="gainVar")
    def gain_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gainVar"))

    @gain_var.setter
    def gain_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d56ea4c20c7452a6cfb98f087dafb22eb2a67d22a6bbc3370f5d10a0a58958fd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gainVar", value)

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f617147efb11d4f2bff1c152af3e6f977552a561d99559d2014eae5c5d380211)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3c64aa4e471a41457265504c3cb505cfc81565b75b5b3aa94e24edeeaa4c89c7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="threshold")
    def threshold(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "threshold"))

    @threshold.setter
    def threshold(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__de8744e6a58d720d0552dfdf5c166c54fcaabd67391cebe911858c8357a737d7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "threshold", value)

    @builtins.property
    @jsii.member(jsii_name="thresholdVar")
    def threshold_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "thresholdVar"))

    @threshold_var.setter
    def threshold_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__666cb62d72dbe46c198acdf6d3f9d479093751c428c2143c052be5d1922450cc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "thresholdVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationUnsharpMask]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationUnsharpMask]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationUnsharpMask]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8dbf82d8660a49442ce5225178d1903e7d6545fea5eec2d49aee7e2c73fc301f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0620949ce3a0d4aa2623077d691763523371c7d684f5cfc00cc5f4acddc390fd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__74cc305e371148f606a8a9ac1c6178d83b66a54b8328dd95dfa2afafe1017162)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2b1579b6d1af0a2ae4adcd304c4678b0dc127002e68a221af48a72ec9795e8ae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__79e84f8eabd472d126e12a3d161c4185cbe7c514c749f095a36508f9e688de1c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__67138e9e10f5afa60078e28639b250c0073f65d0d8f2c6f2fc91c1f5ca49885b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFill]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFill]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFill]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__85328930cce8695d3ddb801bc14d952cfade4a7445c112a02857dd3d415fc324)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9321040fb6ced1698a9f8e5451fd082294d3e6c8c74bd69d11b63c10f2ba6fcb)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putFillTransformation")
    def put_fill_transformation(
        self,
        *,
        append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationAppend, typing.Dict[builtins.str, typing.Any]]]]] = None,
        aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationAspectCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
        crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationFaceCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationFeatureCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationFitAndFill, typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
        im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationImQuery, typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
        region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationRegionOfInterestCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationRelativeCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
        resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationResize, typing.Dict[builtins.str, typing.Any]]]]] = None,
        rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationRotate, typing.Dict[builtins.str, typing.Any]]]]] = None,
        scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationScale, typing.Dict[builtins.str, typing.Any]]]]] = None,
        shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationShear, typing.Dict[builtins.str, typing.Any]]]]] = None,
        trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationTrim, typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param append: append block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        :param aspect_crop: aspect_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param crop: crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        :param face_crop: face_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        :param feature_crop: feature_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        :param fit_and_fill: fit_and_fill block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param im_query: im_query block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param region_of_interest_crop: region_of_interest_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        :param relative_crop: relative_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param resize: resize block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        :param rotate: rotate block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        :param scale: scale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param shear: shear block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        :param trim: trim block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformation(
            append=append,
            aspect_crop=aspect_crop,
            background_color=background_color,
            blur=blur,
            chroma_key=chroma_key,
            composite=composite,
            compound=compound,
            contrast=contrast,
            crop=crop,
            face_crop=face_crop,
            feature_crop=feature_crop,
            fit_and_fill=fit_and_fill,
            goop=goop,
            grayscale=grayscale,
            hsl=hsl,
            hsv=hsv,
            if_dimension=if_dimension,
            if_orientation=if_orientation,
            im_query=im_query,
            max_colors=max_colors,
            mirror=mirror,
            mono_hue=mono_hue,
            opacity=opacity,
            region_of_interest_crop=region_of_interest_crop,
            relative_crop=relative_crop,
            remove_color=remove_color,
            resize=resize,
            rotate=rotate,
            scale=scale,
            shear=shear,
            trim=trim,
            unsharp_mask=unsharp_mask,
        )

        return typing.cast(None, jsii.invoke(self, "putFillTransformation", [value]))

    @jsii.member(jsii_name="resetFillTransformation")
    def reset_fill_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFillTransformation", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="fillTransformation")
    def fill_transformation(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationOutputReference, jsii.get(self, "fillTransformation"))

    @builtins.property
    @jsii.member(jsii_name="fillTransformationInput")
    def fill_transformation_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformation], jsii.get(self, "fillTransformationInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e3a16e67ff1d4ba4be9e658f8b7b9246ddd62531d9f1bc749a3c106d43a9f604)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__278c35d65945948a89eb8268a131077f0aa99360e1ad8788a3486e605cb11fb3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__55646112dcae1aafe2f03b5d4f56d3e378f9a9d3de5d043efa1c6d33cdffbd6f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c040e956b5468b9ef9f1e6d29aaf612db87ea1eafc48eb5f6954cae011a1b348)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFill]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFill]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFill]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7542cd2ccb20e2da9ca55ca20b5498a5845c06860c8cc0d7c1c5d75c2012f3fc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanGoop",
    jsii_struct_bases=[],
    name_mapping={
        "chaos": "chaos",
        "chaos_var": "chaosVar",
        "density": "density",
        "density_var": "densityVar",
        "power": "power",
        "power_var": "powerVar",
        "seed": "seed",
        "seed_var": "seedVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanGoop:
    def __init__(
        self,
        *,
        chaos: typing.Optional[builtins.str] = None,
        chaos_var: typing.Optional[builtins.str] = None,
        density: typing.Optional[builtins.str] = None,
        density_var: typing.Optional[builtins.str] = None,
        power: typing.Optional[builtins.str] = None,
        power_var: typing.Optional[builtins.str] = None,
        seed: typing.Optional[builtins.str] = None,
        seed_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param chaos: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        :param chaos_var: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        :param density: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        :param density_var: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        :param power: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        :param power_var: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        :param seed: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        :param seed_var: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a2a2cfeb35de82b60af1d02b170657ca53cca2c7ca9f9c491089c8453ba07bd7)
            check_type(argname="argument chaos", value=chaos, expected_type=type_hints["chaos"])
            check_type(argname="argument chaos_var", value=chaos_var, expected_type=type_hints["chaos_var"])
            check_type(argname="argument density", value=density, expected_type=type_hints["density"])
            check_type(argname="argument density_var", value=density_var, expected_type=type_hints["density_var"])
            check_type(argname="argument power", value=power, expected_type=type_hints["power"])
            check_type(argname="argument power_var", value=power_var, expected_type=type_hints["power_var"])
            check_type(argname="argument seed", value=seed, expected_type=type_hints["seed"])
            check_type(argname="argument seed_var", value=seed_var, expected_type=type_hints["seed_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if chaos is not None:
            self._values["chaos"] = chaos
        if chaos_var is not None:
            self._values["chaos_var"] = chaos_var
        if density is not None:
            self._values["density"] = density
        if density_var is not None:
            self._values["density_var"] = density_var
        if power is not None:
            self._values["power"] = power
        if power_var is not None:
            self._values["power_var"] = power_var
        if seed is not None:
            self._values["seed"] = seed
        if seed_var is not None:
            self._values["seed_var"] = seed_var

    @builtins.property
    def chaos(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        '''
        result = self._values.get("chaos")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def chaos_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        '''
        result = self._values.get("chaos_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        '''
        result = self._values.get("density")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density_var(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        '''
        result = self._values.get("density_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        '''
        result = self._values.get("power")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power_var(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        '''
        result = self._values.get("power_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        '''
        result = self._values.get("seed")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed_var(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        result = self._values.get("seed_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanGoop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanGoopList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanGoopList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4b18f977a735db5716769ed758549a23c433d26f2e6beeb9ee86a0a016f59b9c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanGoopOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aa3c356d026bd8ea533ea167740614fa00a603b78b4f23de43934ea2f3410a9f)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanGoopOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1b3581aac4381a3d1b9d508509504b23ffa287553e067af335b565aac1742d09)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__225789bc1635644d24d2840bc0e3fd3a77c0c5eb166dd7bdff98b27700673205)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__97ec7e296fd5518a651a43cb8615fda484f7109d4a2219f148deec1739fd8d29)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanGoop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanGoop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8fc6dd74f9a86c7dab59bf966fce1a90c18909959154e31dadb5afa802cb7ff4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanGoopOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanGoopOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7a9ac061ea061943014408f6c2f53a952d515e8c29c92cb6af2bd0a3d451b4ed)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetChaos")
    def reset_chaos(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaos", []))

    @jsii.member(jsii_name="resetChaosVar")
    def reset_chaos_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaosVar", []))

    @jsii.member(jsii_name="resetDensity")
    def reset_density(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensity", []))

    @jsii.member(jsii_name="resetDensityVar")
    def reset_density_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensityVar", []))

    @jsii.member(jsii_name="resetPower")
    def reset_power(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPower", []))

    @jsii.member(jsii_name="resetPowerVar")
    def reset_power_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPowerVar", []))

    @jsii.member(jsii_name="resetSeed")
    def reset_seed(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeed", []))

    @jsii.member(jsii_name="resetSeedVar")
    def reset_seed_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeedVar", []))

    @builtins.property
    @jsii.member(jsii_name="chaosInput")
    def chaos_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosInput"))

    @builtins.property
    @jsii.member(jsii_name="chaosVarInput")
    def chaos_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosVarInput"))

    @builtins.property
    @jsii.member(jsii_name="densityInput")
    def density_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityInput"))

    @builtins.property
    @jsii.member(jsii_name="densityVarInput")
    def density_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="powerInput")
    def power_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerInput"))

    @builtins.property
    @jsii.member(jsii_name="powerVarInput")
    def power_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerVarInput"))

    @builtins.property
    @jsii.member(jsii_name="seedInput")
    def seed_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedInput"))

    @builtins.property
    @jsii.member(jsii_name="seedVarInput")
    def seed_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedVarInput"))

    @builtins.property
    @jsii.member(jsii_name="chaos")
    def chaos(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaos"))

    @chaos.setter
    def chaos(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__da358f01840dfdda09e516f4c7279eed2783928d2ba1b4c0e88b8779a6e9224f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaos", value)

    @builtins.property
    @jsii.member(jsii_name="chaosVar")
    def chaos_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaosVar"))

    @chaos_var.setter
    def chaos_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__046eab22872888373b9f0d6a82bd5e00ffbfa08d8d9130c41424757d036634f8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaosVar", value)

    @builtins.property
    @jsii.member(jsii_name="density")
    def density(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "density"))

    @density.setter
    def density(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__52111f78df0acf398845dc033e660f03364672b63948e8249cbddba872e515a7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "density", value)

    @builtins.property
    @jsii.member(jsii_name="densityVar")
    def density_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "densityVar"))

    @density_var.setter
    def density_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a5edf14dd1d0910864f1daae33ceb11892a6de1c737e05736a3bb4f44ff39c68)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "densityVar", value)

    @builtins.property
    @jsii.member(jsii_name="power")
    def power(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "power"))

    @power.setter
    def power(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5e438d840ece9a58415867785973ec591d3f67582fc540b6c4ff5a95156990d6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "power", value)

    @builtins.property
    @jsii.member(jsii_name="powerVar")
    def power_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "powerVar"))

    @power_var.setter
    def power_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b166e748393bddfbd76a3b7fb4b1d26053395bf8a93bef9efbd26a9152a2b6a0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "powerVar", value)

    @builtins.property
    @jsii.member(jsii_name="seed")
    def seed(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seed"))

    @seed.setter
    def seed(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__96e470c3ca31de100e2cf1389f7b2f793c61d456bae031c153c3c48caf30ebc9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seed", value)

    @builtins.property
    @jsii.member(jsii_name="seedVar")
    def seed_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seedVar"))

    @seed_var.setter
    def seed_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6a443b381898bec9cb1a776bfee4144e058e33d0aeecad500fd63e79c3f20753)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seedVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanGoop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanGoop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanGoop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bf0256d79acb4f612a8da0fca96610499cd2a59c51ef8435414eb8ffb53d886a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanGrayscale",
    jsii_struct_bases=[],
    name_mapping={"type": "type", "type_var": "typeVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanGrayscale:
    def __init__(
        self,
        *,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param type: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0aadc2f5097125a6d2921c5d0f996ae201673af22c19376015df5a375b3673f6)
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanGrayscale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanGrayscaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanGrayscaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8cc309ce90cd4d617bf1e94da25d8a2b9b1183de5c9ef3e3a5d4004cb74f9d6d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanGrayscaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__57f6b1454daedc07c7a8c307869e3a5de24bb6032f786c0666e0280e612bee4f)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanGrayscaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bfa8648618e33032d02b2b910d5de7219bdc092a01b60e859ef080ea335c5973)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__765ac6551bd29a09f55beb82c31573eb06a297b459472e37e6bd580df86d3ab7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6b810db8bdd8cecd5548d56ffbeb1990d8e659d40e753ef94651e414a294a7fb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanGrayscale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanGrayscale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a5c56d0bf87c841a69c0f0506d1d2e47c039ca53f3d331ed3fa538902f90b9a5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanGrayscaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanGrayscaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5e6622e28da6994cb53117cde77c99d6b5ea7d9c255d77acf6b6ac59d79da3e9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ba696a54dd8a82102aa913ae2886f597da98e44fe73c545dc7afccf91b9d8a3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a737fe6dab202b42f8734c1a0a6c1df5864a889742392f334680a8c044f96d4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanGrayscale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanGrayscale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanGrayscale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2cf203e8397caebd3d9b9219709da9c6971670ba7725f520b8d51c6019ce0f11)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanHsl",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "lightness": "lightness",
        "lightness_var": "lightnessVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanHsl:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness: typing.Optional[builtins.str] = None,
        lightness_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        :param lightness_var: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__17a87be3d926c8ba0a058f5f8fd49bc1a9bbfc7fc46ae69251e0c34364f5ac47)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness", value=lightness, expected_type=type_hints["lightness"])
            check_type(argname="argument lightness_var", value=lightness_var, expected_type=type_hints["lightness_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness is not None:
            self._values["lightness"] = lightness
        if lightness_var is not None:
            self._values["lightness_var"] = lightness_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        '''
        result = self._values.get("lightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        '''
        result = self._values.get("lightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanHsl(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanHslList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanHslList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__84f6d1159d38e820ab81bbc73077866b3c013e9b1fdc60071fc9c7de3aceaf29)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanHslOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e3349ee404f6791ff202956979283e24472a5bdfc44d31ad18a7311ac24ba722)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanHslOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__319bff8e09799d582a28fbb666ba358882a009226dcc2b83fdb393cc02b03e32)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac539df1fd8388675d0631e57fca17db84a6fcb2ae11464a3e5713d29038b00a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__31d31f9ccfbb1cf0e406f6464265d061106bafe9159b8a45dcadcb1a6ee25901)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanHsl]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanHsl]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f38360b1b7441b126c6907bbfbaf54affe44f1b2eee886c2f2c5bff280dec8fb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanHslOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanHslOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__74d71af0d6ac37838a476ec1da1cb2f9327dbcaf2d3f5e7dbc3c3888a184df82)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightness")
    def reset_lightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightness", []))

    @jsii.member(jsii_name="resetLightnessVar")
    def reset_lightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessInput")
    def lightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessVarInput")
    def lightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8b6aaba06c4ed1bcc6a1838d8f2a291308301ab8a3fb4b205b2f02616ef544b5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__80e1bc6cf706ea44b8d924dde0538a7466db0dc6d921d74abb389054ec82e84b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightness")
    def lightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightness"))

    @lightness.setter
    def lightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ba11b66adab5f6f5412d5d797805c68ef806267995d57ebc6485dc116b02f8ad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightness", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessVar")
    def lightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessVar"))

    @lightness_var.setter
    def lightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c808609c7e27e887f8ee325b83238a1060f15380b2db541267f8fa2189cc5f79)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7821b80d2a719d890d81d748af6a3f5ecc4972081312fa30e5e362518fe6ffbe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ba34c466dd97f868869243379fa426b79aa653475dd0d9e66dfe4ce9df98697d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanHsl]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanHsl]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanHsl]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__16e6193b5002e1de2404a6d5f9d70b22924f2a97b525b631ccc6360d2aa0e0e0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanHsv",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanHsv:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        :param value: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4d403b4bf8465b37e7d4c55390b339d2a9241d2e4196d206febfaa82753ac042)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanHsv(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanHsvList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanHsvList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b0f3248b83931e6bae1ad362c4ca76b90ea0ba210f63fba30ad29608a089daa0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanHsvOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__131f617e10b13c1871da6e5f725c170671148202c141c2bd13d2d31696cdbb1a)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanHsvOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8b3fc52baa64c3c6bd3c548f74d379650091825e6f045daad1ab9b1df2f7e966)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__40b9fe7d5055eb8167328187aefde8803bf38c3f9c012fbf4f77fa422483295a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__493b0b3ef149ea8c09be8e1481726b07cf42d24d122a6b3604f14712b081f26c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanHsv]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanHsv]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c87fdb17ab645d1707dc1a968dea123cdad275803ce4e108390f5fea0c8e665c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanHsvOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanHsvOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__42d26515059a4de50ad745699a9ebac84390275db2493fe57e46db150f5e5605)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__026657d89745afe0f3ca5d324476fb72e6b3f3bf3f89f277e620ffc3995c8682)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__05d02908a5e8159962a443f3610033079a9a13286dc2befc003877f254734a59)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__52f2dedca00ceb5b234b9ff04deaf7d6e69780a42a2384dd8eb4a304593ad974)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__25f90a096cf461e9c5478c5da9c89b9db7317d9afd159e00bc52e3b3af123729)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__67833f106cb0d613e9b895d89edef8262260712c8bfa412c5e461db7cf52c8f3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__170864e9657802c5c35a53e90bfe850c74ec93b880eed95a7461b3e032c56623)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanHsv]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanHsv]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanHsv]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__469ebfae364d17f70f46e0bc4e204b1e83135ad477cfa3082b75c1bbce82d8e7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientation",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "landscape": "landscape",
        "portrait": "portrait",
        "square": "square",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientation:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        landscape: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscape", typing.Dict[builtins.str, typing.Any]]] = None,
        portrait: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortrait", typing.Dict[builtins.str, typing.Any]]] = None,
        square: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquare", typing.Dict[builtins.str, typing.Any]]] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param landscape: landscape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        :param portrait: portrait block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        :param square: square block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefault(**default)
        if isinstance(landscape, dict):
            landscape = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscape(**landscape)
        if isinstance(portrait, dict):
            portrait = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortrait(**portrait)
        if isinstance(square, dict):
            square = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquare(**square)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a618d7e8272268d506d685d5fbec723c3fc7229d47cbd0ef8311e987b80ea73)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument landscape", value=landscape, expected_type=type_hints["landscape"])
            check_type(argname="argument portrait", value=portrait, expected_type=type_hints["portrait"])
            check_type(argname="argument square", value=square, expected_type=type_hints["square"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if landscape is not None:
            self._values["landscape"] = landscape
        if portrait is not None:
            self._values["portrait"] = portrait
        if square is not None:
            self._values["square"] = square

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefault"], result)

    @builtins.property
    def landscape(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscape"]:
        '''landscape block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        '''
        result = self._values.get("landscape")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscape"], result)

    @builtins.property
    def portrait(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortrait"]:
        '''portrait block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        '''
        result = self._values.get("portrait")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortrait"], result)

    @builtins.property
    def square(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquare"]:
        '''square block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        result = self._values.get("square")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquare"], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefault",
    jsii_struct_bases=[],
    name_mapping={
        "append": "append",
        "aspect_crop": "aspectCrop",
        "background_color": "backgroundColor",
        "blur": "blur",
        "chroma_key": "chromaKey",
        "composite": "composite",
        "compound": "compound",
        "contrast": "contrast",
        "crop": "crop",
        "face_crop": "faceCrop",
        "feature_crop": "featureCrop",
        "fit_and_fill": "fitAndFill",
        "goop": "goop",
        "grayscale": "grayscale",
        "hsl": "hsl",
        "hsv": "hsv",
        "if_dimension": "ifDimension",
        "if_orientation": "ifOrientation",
        "im_query": "imQuery",
        "max_colors": "maxColors",
        "mirror": "mirror",
        "mono_hue": "monoHue",
        "opacity": "opacity",
        "region_of_interest_crop": "regionOfInterestCrop",
        "relative_crop": "relativeCrop",
        "remove_color": "removeColor",
        "resize": "resize",
        "rotate": "rotate",
        "scale": "scale",
        "shear": "shear",
        "trim": "trim",
        "unsharp_mask": "unsharpMask",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefault:
    def __init__(
        self,
        *,
        append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultAppend", typing.Dict[builtins.str, typing.Any]]]]] = None,
        aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultAspectCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultBackgroundColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultBlur", typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultChromaKey", typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultComposite", typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultCompound", typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultContrast", typing.Dict[builtins.str, typing.Any]]]]] = None,
        crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultFaceCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultFeatureCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultFitAndFill", typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultGoop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultGrayscale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultHsl", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultHsv", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimension", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientation", typing.Dict[builtins.str, typing.Any]]]]] = None,
        im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultImQuery", typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultMaxColors", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultMirror", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultMonoHue", typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultOpacity", typing.Dict[builtins.str, typing.Any]]]]] = None,
        region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultRegionOfInterestCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultRelativeCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultRemoveColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultResize", typing.Dict[builtins.str, typing.Any]]]]] = None,
        rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultRotate", typing.Dict[builtins.str, typing.Any]]]]] = None,
        scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultScale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultShear", typing.Dict[builtins.str, typing.Any]]]]] = None,
        trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultTrim", typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultUnsharpMask", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param append: append block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        :param aspect_crop: aspect_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param crop: crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        :param face_crop: face_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        :param feature_crop: feature_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        :param fit_and_fill: fit_and_fill block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param im_query: im_query block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param region_of_interest_crop: region_of_interest_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        :param relative_crop: relative_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param resize: resize block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        :param rotate: rotate block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        :param scale: scale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param shear: shear block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        :param trim: trim block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__89d5d71a8754a3b85c4489730da4c47eb05f5c3d7f1c27d27eef09db97b4df86)
            check_type(argname="argument append", value=append, expected_type=type_hints["append"])
            check_type(argname="argument aspect_crop", value=aspect_crop, expected_type=type_hints["aspect_crop"])
            check_type(argname="argument background_color", value=background_color, expected_type=type_hints["background_color"])
            check_type(argname="argument blur", value=blur, expected_type=type_hints["blur"])
            check_type(argname="argument chroma_key", value=chroma_key, expected_type=type_hints["chroma_key"])
            check_type(argname="argument composite", value=composite, expected_type=type_hints["composite"])
            check_type(argname="argument compound", value=compound, expected_type=type_hints["compound"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument crop", value=crop, expected_type=type_hints["crop"])
            check_type(argname="argument face_crop", value=face_crop, expected_type=type_hints["face_crop"])
            check_type(argname="argument feature_crop", value=feature_crop, expected_type=type_hints["feature_crop"])
            check_type(argname="argument fit_and_fill", value=fit_and_fill, expected_type=type_hints["fit_and_fill"])
            check_type(argname="argument goop", value=goop, expected_type=type_hints["goop"])
            check_type(argname="argument grayscale", value=grayscale, expected_type=type_hints["grayscale"])
            check_type(argname="argument hsl", value=hsl, expected_type=type_hints["hsl"])
            check_type(argname="argument hsv", value=hsv, expected_type=type_hints["hsv"])
            check_type(argname="argument if_dimension", value=if_dimension, expected_type=type_hints["if_dimension"])
            check_type(argname="argument if_orientation", value=if_orientation, expected_type=type_hints["if_orientation"])
            check_type(argname="argument im_query", value=im_query, expected_type=type_hints["im_query"])
            check_type(argname="argument max_colors", value=max_colors, expected_type=type_hints["max_colors"])
            check_type(argname="argument mirror", value=mirror, expected_type=type_hints["mirror"])
            check_type(argname="argument mono_hue", value=mono_hue, expected_type=type_hints["mono_hue"])
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument region_of_interest_crop", value=region_of_interest_crop, expected_type=type_hints["region_of_interest_crop"])
            check_type(argname="argument relative_crop", value=relative_crop, expected_type=type_hints["relative_crop"])
            check_type(argname="argument remove_color", value=remove_color, expected_type=type_hints["remove_color"])
            check_type(argname="argument resize", value=resize, expected_type=type_hints["resize"])
            check_type(argname="argument rotate", value=rotate, expected_type=type_hints["rotate"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument shear", value=shear, expected_type=type_hints["shear"])
            check_type(argname="argument trim", value=trim, expected_type=type_hints["trim"])
            check_type(argname="argument unsharp_mask", value=unsharp_mask, expected_type=type_hints["unsharp_mask"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if append is not None:
            self._values["append"] = append
        if aspect_crop is not None:
            self._values["aspect_crop"] = aspect_crop
        if background_color is not None:
            self._values["background_color"] = background_color
        if blur is not None:
            self._values["blur"] = blur
        if chroma_key is not None:
            self._values["chroma_key"] = chroma_key
        if composite is not None:
            self._values["composite"] = composite
        if compound is not None:
            self._values["compound"] = compound
        if contrast is not None:
            self._values["contrast"] = contrast
        if crop is not None:
            self._values["crop"] = crop
        if face_crop is not None:
            self._values["face_crop"] = face_crop
        if feature_crop is not None:
            self._values["feature_crop"] = feature_crop
        if fit_and_fill is not None:
            self._values["fit_and_fill"] = fit_and_fill
        if goop is not None:
            self._values["goop"] = goop
        if grayscale is not None:
            self._values["grayscale"] = grayscale
        if hsl is not None:
            self._values["hsl"] = hsl
        if hsv is not None:
            self._values["hsv"] = hsv
        if if_dimension is not None:
            self._values["if_dimension"] = if_dimension
        if if_orientation is not None:
            self._values["if_orientation"] = if_orientation
        if im_query is not None:
            self._values["im_query"] = im_query
        if max_colors is not None:
            self._values["max_colors"] = max_colors
        if mirror is not None:
            self._values["mirror"] = mirror
        if mono_hue is not None:
            self._values["mono_hue"] = mono_hue
        if opacity is not None:
            self._values["opacity"] = opacity
        if region_of_interest_crop is not None:
            self._values["region_of_interest_crop"] = region_of_interest_crop
        if relative_crop is not None:
            self._values["relative_crop"] = relative_crop
        if remove_color is not None:
            self._values["remove_color"] = remove_color
        if resize is not None:
            self._values["resize"] = resize
        if rotate is not None:
            self._values["rotate"] = rotate
        if scale is not None:
            self._values["scale"] = scale
        if shear is not None:
            self._values["shear"] = shear
        if trim is not None:
            self._values["trim"] = trim
        if unsharp_mask is not None:
            self._values["unsharp_mask"] = unsharp_mask

    @builtins.property
    def append(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultAppend"]]]:
        '''append block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        '''
        result = self._values.get("append")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultAppend"]]], result)

    @builtins.property
    def aspect_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultAspectCrop"]]]:
        '''aspect_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        '''
        result = self._values.get("aspect_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultAspectCrop"]]], result)

    @builtins.property
    def background_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultBackgroundColor"]]]:
        '''background_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        '''
        result = self._values.get("background_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultBackgroundColor"]]], result)

    @builtins.property
    def blur(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultBlur"]]]:
        '''blur block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        '''
        result = self._values.get("blur")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultBlur"]]], result)

    @builtins.property
    def chroma_key(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultChromaKey"]]]:
        '''chroma_key block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        '''
        result = self._values.get("chroma_key")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultChromaKey"]]], result)

    @builtins.property
    def composite(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultComposite"]]]:
        '''composite block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        '''
        result = self._values.get("composite")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultComposite"]]], result)

    @builtins.property
    def compound(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultCompound"]]]:
        '''compound block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        '''
        result = self._values.get("compound")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultCompound"]]], result)

    @builtins.property
    def contrast(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultContrast"]]]:
        '''contrast block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultContrast"]]], result)

    @builtins.property
    def crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultCrop"]]]:
        '''crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        '''
        result = self._values.get("crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultCrop"]]], result)

    @builtins.property
    def face_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultFaceCrop"]]]:
        '''face_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        '''
        result = self._values.get("face_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultFaceCrop"]]], result)

    @builtins.property
    def feature_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultFeatureCrop"]]]:
        '''feature_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        '''
        result = self._values.get("feature_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultFeatureCrop"]]], result)

    @builtins.property
    def fit_and_fill(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultFitAndFill"]]]:
        '''fit_and_fill block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        '''
        result = self._values.get("fit_and_fill")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultFitAndFill"]]], result)

    @builtins.property
    def goop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultGoop"]]]:
        '''goop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        '''
        result = self._values.get("goop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultGoop"]]], result)

    @builtins.property
    def grayscale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultGrayscale"]]]:
        '''grayscale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        '''
        result = self._values.get("grayscale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultGrayscale"]]], result)

    @builtins.property
    def hsl(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultHsl"]]]:
        '''hsl block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        '''
        result = self._values.get("hsl")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultHsl"]]], result)

    @builtins.property
    def hsv(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultHsv"]]]:
        '''hsv block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        '''
        result = self._values.get("hsv")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultHsv"]]], result)

    @builtins.property
    def if_dimension(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimension"]]]:
        '''if_dimension block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        '''
        result = self._values.get("if_dimension")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimension"]]], result)

    @builtins.property
    def if_orientation(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientation"]]]:
        '''if_orientation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        '''
        result = self._values.get("if_orientation")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientation"]]], result)

    @builtins.property
    def im_query(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultImQuery"]]]:
        '''im_query block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        '''
        result = self._values.get("im_query")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultImQuery"]]], result)

    @builtins.property
    def max_colors(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultMaxColors"]]]:
        '''max_colors block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        '''
        result = self._values.get("max_colors")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultMaxColors"]]], result)

    @builtins.property
    def mirror(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultMirror"]]]:
        '''mirror block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        '''
        result = self._values.get("mirror")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultMirror"]]], result)

    @builtins.property
    def mono_hue(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultMonoHue"]]]:
        '''mono_hue block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        '''
        result = self._values.get("mono_hue")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultMonoHue"]]], result)

    @builtins.property
    def opacity(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultOpacity"]]]:
        '''opacity block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultOpacity"]]], result)

    @builtins.property
    def region_of_interest_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultRegionOfInterestCrop"]]]:
        '''region_of_interest_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        '''
        result = self._values.get("region_of_interest_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultRegionOfInterestCrop"]]], result)

    @builtins.property
    def relative_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultRelativeCrop"]]]:
        '''relative_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        '''
        result = self._values.get("relative_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultRelativeCrop"]]], result)

    @builtins.property
    def remove_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultRemoveColor"]]]:
        '''remove_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        '''
        result = self._values.get("remove_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultRemoveColor"]]], result)

    @builtins.property
    def resize(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultResize"]]]:
        '''resize block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        '''
        result = self._values.get("resize")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultResize"]]], result)

    @builtins.property
    def rotate(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultRotate"]]]:
        '''rotate block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        '''
        result = self._values.get("rotate")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultRotate"]]], result)

    @builtins.property
    def scale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultScale"]]]:
        '''scale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultScale"]]], result)

    @builtins.property
    def shear(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultShear"]]]:
        '''shear block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        '''
        result = self._values.get("shear")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultShear"]]], result)

    @builtins.property
    def trim(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultTrim"]]]:
        '''trim block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        '''
        result = self._values.get("trim")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultTrim"]]], result)

    @builtins.property
    def unsharp_mask(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultUnsharpMask"]]]:
        '''unsharp_mask block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        result = self._values.get("unsharp_mask")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultUnsharpMask"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultAppend",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_priority": "gravityPriority",
        "gravity_priority_var": "gravityPriorityVar",
        "gravity_var": "gravityVar",
        "preserve_minor_dimension": "preserveMinorDimension",
        "preserve_minor_dimension_var": "preserveMinorDimensionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultAppend:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultAppendImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_priority: typing.Optional[builtins.str] = None,
        gravity_priority_var: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        preserve_minor_dimension: typing.Optional[builtins.str] = None,
        preserve_minor_dimension_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Specifies where to place the ``image`` relative to the source image. The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_priority: Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal. The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority DataAkamaiImagingPolicyImage#gravity_priority}
        :param gravity_priority_var: Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal. The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority_var DataAkamaiImagingPolicyImage#gravity_priority_var}
        :param gravity_var: Specifies where to place the ``image`` relative to the source image. The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param preserve_minor_dimension: Whether to preserve the source image's minor dimension, ``false`` by default. The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension DataAkamaiImagingPolicyImage#preserve_minor_dimension}
        :param preserve_minor_dimension_var: Whether to preserve the source image's minor dimension, ``false`` by default. The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension_var DataAkamaiImagingPolicyImage#preserve_minor_dimension_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultAppendImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b5e7283381e862091e55d51629c6fed874f1dc2266b212c325cbca8369094e49)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_priority", value=gravity_priority, expected_type=type_hints["gravity_priority"])
            check_type(argname="argument gravity_priority_var", value=gravity_priority_var, expected_type=type_hints["gravity_priority_var"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument preserve_minor_dimension", value=preserve_minor_dimension, expected_type=type_hints["preserve_minor_dimension"])
            check_type(argname="argument preserve_minor_dimension_var", value=preserve_minor_dimension_var, expected_type=type_hints["preserve_minor_dimension_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_priority is not None:
            self._values["gravity_priority"] = gravity_priority
        if gravity_priority_var is not None:
            self._values["gravity_priority_var"] = gravity_priority_var
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if preserve_minor_dimension is not None:
            self._values["preserve_minor_dimension"] = preserve_minor_dimension
        if preserve_minor_dimension_var is not None:
            self._values["preserve_minor_dimension_var"] = preserve_minor_dimension_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultAppendImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultAppendImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Specifies where to place the ``image`` relative to the source image.

        The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_priority(self) -> typing.Optional[builtins.str]:
        '''Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal.

        The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority DataAkamaiImagingPolicyImage#gravity_priority}
        '''
        result = self._values.get("gravity_priority")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_priority_var(self) -> typing.Optional[builtins.str]:
        '''Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal.

        The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority_var DataAkamaiImagingPolicyImage#gravity_priority_var}
        '''
        result = self._values.get("gravity_priority_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Specifies where to place the ``image`` relative to the source image.

        The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def preserve_minor_dimension(self) -> typing.Optional[builtins.str]:
        '''Whether to preserve the source image's minor dimension, ``false`` by default.

        The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension DataAkamaiImagingPolicyImage#preserve_minor_dimension}
        '''
        result = self._values.get("preserve_minor_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def preserve_minor_dimension_var(self) -> typing.Optional[builtins.str]:
        '''Whether to preserve the source image's minor dimension, ``false`` by default.

        The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension_var DataAkamaiImagingPolicyImage#preserve_minor_dimension_var}
        '''
        result = self._values.get("preserve_minor_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultAppend(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultAppendImage",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultAppendImage:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultAppendImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultAppendImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultAppendImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f80ecf11f4aea282115fc71cd8c7a329d2b9d45e6e8a3162395a2d8ed9fe841)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultAppendImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultAppendImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultAppendImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8cdaad8755b60c38c7efba3e5d30c300859d3306fae9672dd63228c0cccd852c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultAppendList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultAppendList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a1b0677f36d8f09304b81a0e6c9c4a92d706c950febbb3c44b66c0c591e96b1e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultAppendOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__546edc4e2a84b7ed34d631923093e88532426dc5b605ecbbb8b84131bf0caf46)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultAppendOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dfbe8dd96b9ed6d760083e9660bb99014b7d9f2716321985124b271198434fba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d840611b50cbc231fc85b088ee4d0341e421f1e18d06b00854a712da5c95a0cb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df66bfbcfda149fe4ba965232af0455e89e0689d521116d088dd092b7341e791)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultAppend]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultAppend]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultAppend]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8158d3cbd9b970bd2a0e69e97d44a11becba060a92e0b862488e08a67f134b0e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultAppendOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultAppendOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a32f0cc2242c4b433461bc6917a94256f84364997315ecce289e631a234fa8da)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultAppendImage()

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityPriority")
    def reset_gravity_priority(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityPriority", []))

    @jsii.member(jsii_name="resetGravityPriorityVar")
    def reset_gravity_priority_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityPriorityVar", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPreserveMinorDimension")
    def reset_preserve_minor_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPreserveMinorDimension", []))

    @jsii.member(jsii_name="resetPreserveMinorDimensionVar")
    def reset_preserve_minor_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPreserveMinorDimensionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultAppendImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultAppendImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityInput")
    def gravity_priority_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityPriorityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityVarInput")
    def gravity_priority_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityPriorityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultAppendImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultAppendImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionInput")
    def preserve_minor_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "preserveMinorDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionVarInput")
    def preserve_minor_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "preserveMinorDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ee5da5d742694f3bfe02291c0190208f51e2c72bfd86ca2558ebf5ef6cd83136)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityPriority")
    def gravity_priority(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityPriority"))

    @gravity_priority.setter
    def gravity_priority(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__07765fc1cbad5c41c5c7c01e945455a61eb155e45716bc1ea742280579dfdee3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityPriority", value)

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityVar")
    def gravity_priority_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityPriorityVar"))

    @gravity_priority_var.setter
    def gravity_priority_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__384da401d7e75fac48a8eacb0b0c9094611cedbef733aace1e1026a7bb5ac9e6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityPriorityVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c0bff60474012731bd2bd11c2196822a851cab3c051892298693bbfdae13aec2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimension")
    def preserve_minor_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "preserveMinorDimension"))

    @preserve_minor_dimension.setter
    def preserve_minor_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8237d1aaa55464c0d75e63c920ed301cd66835510786b48172a24adb4f5f2619)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "preserveMinorDimension", value)

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionVar")
    def preserve_minor_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "preserveMinorDimensionVar"))

    @preserve_minor_dimension_var.setter
    def preserve_minor_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__312919ff52b5a851e0007be704a56ae188f036013a1f74c9890bf884e673bfae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "preserveMinorDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultAppend]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultAppend]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultAppend]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a01cda44ca23bb699141c1dfece3535bbd4418a7b07d56ef7274213082a29f9e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultAspectCrop",
    jsii_struct_bases=[],
    name_mapping={
        "allow_expansion": "allowExpansion",
        "allow_expansion_var": "allowExpansionVar",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultAspectCrop:
    def __init__(
        self,
        *,
        allow_expansion: typing.Optional[builtins.str] = None,
        allow_expansion_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_expansion: Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image. Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        :param allow_expansion_var: Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image. Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        :param height: The height term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The width term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        :param x_position: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5a7947e070c977d833b34edac6ae5b95bb2aa6acab0e3c7aa3d3115be0442bb1)
            check_type(argname="argument allow_expansion", value=allow_expansion, expected_type=type_hints["allow_expansion"])
            check_type(argname="argument allow_expansion_var", value=allow_expansion_var, expected_type=type_hints["allow_expansion_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if allow_expansion is not None:
            self._values["allow_expansion"] = allow_expansion
        if allow_expansion_var is not None:
            self._values["allow_expansion_var"] = allow_expansion_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def allow_expansion(self) -> typing.Optional[builtins.str]:
        '''Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image.

        Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        '''
        result = self._values.get("allow_expansion")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def allow_expansion_var(self) -> typing.Optional[builtins.str]:
        '''Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image.

        Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        '''
        result = self._values.get("allow_expansion_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultAspectCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultAspectCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultAspectCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0c4af3b76d6d65d525a0e1506d24e28d0c62078ab580ed096c84780beb281944)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultAspectCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__57d3533095442bfdce86da4e012221292f283de082bc6d3e1d896e30b16b3cad)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultAspectCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ecd9fa1f22f24438c0649a79baf9b217215e1a4d222d282db0405c39d90bf462)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__24a0391a8aea9c03e29fc9c7839dae01f62fc9c67cfb66202d983bf2b362da6a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e98489218175f43de879d2d50e43382554e64057215283e1023da749017256e4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultAspectCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultAspectCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultAspectCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b30f28216e293db26011376877307755939723a44a6b84af22e62fc77663e186)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultAspectCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultAspectCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cdc753dd5a1ef8c33a95bd0e290c5977029c8d6610e505af5dfc8319581ab233)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAllowExpansion")
    def reset_allow_expansion(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansion", []))

    @jsii.member(jsii_name="resetAllowExpansionVar")
    def reset_allow_expansion_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansionVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionInput")
    def allow_expansion_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVarInput")
    def allow_expansion_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansion")
    def allow_expansion(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansion"))

    @allow_expansion.setter
    def allow_expansion(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__78a4adf69613e347747a7f2ab8f20cc4ae2a55cab0cd1c7baefea33e3fe93ae6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansion", value)

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVar")
    def allow_expansion_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansionVar"))

    @allow_expansion_var.setter
    def allow_expansion_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__34494fd12bc8f874f257e4dbb7995fef1dcf37b076604e64d48f539f337ac439)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansionVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__465d924c150182ba41b1bfdcf9a04f86282835e90b60f8405b80e3af479c7776)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dd8e9fd246c79e3b6308f7468193930a3b15e1a82952dde9a984c617dd6cd731)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d26b4d67ef64547c0e65e64eb51376632b681e2a74b291ad4b3f80c36e68870c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ca72451a4086f81611386cf18b41939ffd530a366f075f81f607e5f25c029e00)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4e1e9ba8212f47d5d70238ef3460aac9d8b77080f8d4cc11f549167b4c56e27f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ef47182de643d47f266d5803eca202fce080a61df7e2957f4d41948c231b345a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__436a4526efbfbbb13a3d77f077eb4a99e21bdaa7cbc98ae2dc749279785870b1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a91782fcfbb6a5390b196e0d549d570ce84332f109cbd9508f2b272c0326b8d0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultAspectCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultAspectCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultAspectCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__077f26cca7bcd5e58616486ee041c182f62b721c070484611490eb70704bf2ef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultBackgroundColor",
    jsii_struct_bases=[],
    name_mapping={"color": "color", "color_var": "colorVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultBackgroundColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e5abc47ea946ce09e7f3e265f9cb8a350ff75f0390c551f5a267abc7fb2929c0)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultBackgroundColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultBackgroundColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultBackgroundColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__27672f3000c4c2f631c159dbafbde7a4d129936205c343b5f1487f6ea1623673)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultBackgroundColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a870fdf67c15f801a8f62cbcef6a24670813eb9d5b513c6731e0206357e057ea)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultBackgroundColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__453756c6abda0a8a508e711cbf3819fdb491a9b5c27855c2c78bcf5b7d814881)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f8e9c177c5f1fc51c05b13f0b20f54ae12befd75dbaf5ffd4dd84d5ef14a7805)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ed0fec5cf224600ff1edd1ff17731a9bdcaa5c5c95af4f375777e88f4d7a2fc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultBackgroundColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultBackgroundColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ca3a2af9e33d1f7ae9638bb92170743a413f6d3d828c095899d7965d7e2e6d38)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultBackgroundColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultBackgroundColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__da38eccdff8618e1ee48f1f6ca554502923be8e9f763c20fb1f19aa99717c372)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__55bbbd1a29cddc074a4ce7ece24bd53cd9c58b2872343ca189653e511db800cc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__91fb8acfa13ac02e81dc8dc7edd330590032448bcadd7a2a3de73c339bb8067f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultBackgroundColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultBackgroundColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultBackgroundColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f862e6b0648c7ff23bbc0ba8d907f4e864a2a7758d3c429e4bc10d215f19be4f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultBlur",
    jsii_struct_bases=[],
    name_mapping={"sigma": "sigma", "sigma_var": "sigmaVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultBlur:
    def __init__(
        self,
        *,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param sigma: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8ed4abe8f2e3cd17acbf0a3e7dc2a3089c1f246fb4f2974e8ff32d5c9dd8110e)
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultBlur(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultBlurList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultBlurList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aa97886f8f466f18eb34e2d9759a0dbd98d20e11cd02968f2f449bf3a9c389d8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultBlurOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a2c10649fae8f23962da35d7ac7f482b4b75f2388bd02058df6e1da2284cca84)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultBlurOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d288101fad12492cf804acba0730cac26a16609a9a31778c275ef9696c75dab1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8dfde29b176a911699f54cc03868c14ba9db7af0d90c9e968168c9b1e95a6228)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e3b52705c048475c8f3cec6562f720fc214831f4dd13ba1d8993697550a9b6ed)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultBlur]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultBlur]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6bf364387001257d4242d72cb51b24164ca6e100180fe2586c9f13bf05b12c8a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultBlurOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultBlurOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c97c7b2b582ecc3388be236e9b1dde0f38e901dfc2dff21a1f52c11dc00ca156)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__108c3b5d4f8387b3588f927033485567c1d1b8d927b66f0936beef11134515af)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a46f5c1f17ea6f269a57ab9b036be0d313293bd4a9f1c81ca574f938c76b1b5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultBlur]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultBlur]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultBlur]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__86541674be93b0e0ab39d5a858247fd6603a98f9a21c485a0320dea350844c4d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultChromaKey",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_feather": "hueFeather",
        "hue_feather_var": "hueFeatherVar",
        "hue_tolerance": "hueTolerance",
        "hue_tolerance_var": "hueToleranceVar",
        "hue_var": "hueVar",
        "lightness_feather": "lightnessFeather",
        "lightness_feather_var": "lightnessFeatherVar",
        "lightness_tolerance": "lightnessTolerance",
        "lightness_tolerance_var": "lightnessToleranceVar",
        "saturation_feather": "saturationFeather",
        "saturation_feather_var": "saturationFeatherVar",
        "saturation_tolerance": "saturationTolerance",
        "saturation_tolerance_var": "saturationToleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultChromaKey:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_feather: typing.Optional[builtins.str] = None,
        hue_feather_var: typing.Optional[builtins.str] = None,
        hue_tolerance: typing.Optional[builtins.str] = None,
        hue_tolerance_var: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness_feather: typing.Optional[builtins.str] = None,
        lightness_feather_var: typing.Optional[builtins.str] = None,
        lightness_tolerance: typing.Optional[builtins.str] = None,
        lightness_tolerance_var: typing.Optional[builtins.str] = None,
        saturation_feather: typing.Optional[builtins.str] = None,
        saturation_feather_var: typing.Optional[builtins.str] = None,
        saturation_tolerance: typing.Optional[builtins.str] = None,
        saturation_tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_feather: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        :param hue_feather_var: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        :param hue_tolerance: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        :param hue_tolerance_var: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        :param hue_var: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness_feather: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        :param lightness_feather_var: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        :param lightness_tolerance: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        :param lightness_tolerance_var: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        :param saturation_feather: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        :param saturation_feather_var: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        :param saturation_tolerance: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        :param saturation_tolerance_var: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__19c2e2a3cee02bd57ab95ee5bcdadb2ecadd9019374eb48c0b3a0a878af12e17)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_feather", value=hue_feather, expected_type=type_hints["hue_feather"])
            check_type(argname="argument hue_feather_var", value=hue_feather_var, expected_type=type_hints["hue_feather_var"])
            check_type(argname="argument hue_tolerance", value=hue_tolerance, expected_type=type_hints["hue_tolerance"])
            check_type(argname="argument hue_tolerance_var", value=hue_tolerance_var, expected_type=type_hints["hue_tolerance_var"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness_feather", value=lightness_feather, expected_type=type_hints["lightness_feather"])
            check_type(argname="argument lightness_feather_var", value=lightness_feather_var, expected_type=type_hints["lightness_feather_var"])
            check_type(argname="argument lightness_tolerance", value=lightness_tolerance, expected_type=type_hints["lightness_tolerance"])
            check_type(argname="argument lightness_tolerance_var", value=lightness_tolerance_var, expected_type=type_hints["lightness_tolerance_var"])
            check_type(argname="argument saturation_feather", value=saturation_feather, expected_type=type_hints["saturation_feather"])
            check_type(argname="argument saturation_feather_var", value=saturation_feather_var, expected_type=type_hints["saturation_feather_var"])
            check_type(argname="argument saturation_tolerance", value=saturation_tolerance, expected_type=type_hints["saturation_tolerance"])
            check_type(argname="argument saturation_tolerance_var", value=saturation_tolerance_var, expected_type=type_hints["saturation_tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_feather is not None:
            self._values["hue_feather"] = hue_feather
        if hue_feather_var is not None:
            self._values["hue_feather_var"] = hue_feather_var
        if hue_tolerance is not None:
            self._values["hue_tolerance"] = hue_tolerance
        if hue_tolerance_var is not None:
            self._values["hue_tolerance_var"] = hue_tolerance_var
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness_feather is not None:
            self._values["lightness_feather"] = lightness_feather
        if lightness_feather_var is not None:
            self._values["lightness_feather_var"] = lightness_feather_var
        if lightness_tolerance is not None:
            self._values["lightness_tolerance"] = lightness_tolerance
        if lightness_tolerance_var is not None:
            self._values["lightness_tolerance_var"] = lightness_tolerance_var
        if saturation_feather is not None:
            self._values["saturation_feather"] = saturation_feather
        if saturation_feather_var is not None:
            self._values["saturation_feather_var"] = saturation_feather_var
        if saturation_tolerance is not None:
            self._values["saturation_tolerance"] = saturation_tolerance
        if saturation_tolerance_var is not None:
            self._values["saturation_tolerance_var"] = saturation_tolerance_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        '''
        result = self._values.get("hue_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        '''
        result = self._values.get("hue_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        '''
        result = self._values.get("hue_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        '''
        result = self._values.get("hue_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        '''
        result = self._values.get("lightness_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        '''
        result = self._values.get("lightness_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        '''
        result = self._values.get("lightness_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        '''
        result = self._values.get("lightness_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        '''
        result = self._values.get("saturation_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        '''
        result = self._values.get("saturation_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        '''
        result = self._values.get("saturation_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        result = self._values.get("saturation_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultChromaKey(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultChromaKeyList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultChromaKeyList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ca28e6946db9ada1133dfdc35e1d45e286d24922f46615809a1dc502c29e83a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultChromaKeyOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__333bed6d19577f76a8cf558d1f7f3b81f53f9623197f9bd94b791970aec2a1e8)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultChromaKeyOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fcac7bbc87cfbaa0adc30d446ccd5e26a453093866e99ad5beb89eccc96fc351)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__06d386c1392206bf1d3919096b0838eb3e624a314b75316db4861a36de28fb12)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eb6a585b4a46f7ce7080ee33e538bb43d2a94ec600a79dca587ef8b7cb59583a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultChromaKey]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultChromaKey]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c790d4a43d180d721ebb3d2aaee3a61f4c40e17eea764f75cf592d40936f1c1e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultChromaKeyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultChromaKeyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__86d18b5d2da3d82abe3b2065503a4e17bb3bfa89ef162e70ba2dcd9219b6f1ae)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueFeather")
    def reset_hue_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeather", []))

    @jsii.member(jsii_name="resetHueFeatherVar")
    def reset_hue_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeatherVar", []))

    @jsii.member(jsii_name="resetHueTolerance")
    def reset_hue_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueTolerance", []))

    @jsii.member(jsii_name="resetHueToleranceVar")
    def reset_hue_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueToleranceVar", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightnessFeather")
    def reset_lightness_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeather", []))

    @jsii.member(jsii_name="resetLightnessFeatherVar")
    def reset_lightness_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeatherVar", []))

    @jsii.member(jsii_name="resetLightnessTolerance")
    def reset_lightness_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessTolerance", []))

    @jsii.member(jsii_name="resetLightnessToleranceVar")
    def reset_lightness_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessToleranceVar", []))

    @jsii.member(jsii_name="resetSaturationFeather")
    def reset_saturation_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeather", []))

    @jsii.member(jsii_name="resetSaturationFeatherVar")
    def reset_saturation_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeatherVar", []))

    @jsii.member(jsii_name="resetSaturationTolerance")
    def reset_saturation_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationTolerance", []))

    @jsii.member(jsii_name="resetSaturationToleranceVar")
    def reset_saturation_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherInput")
    def hue_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVarInput")
    def hue_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceInput")
    def hue_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVarInput")
    def hue_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherInput")
    def lightness_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVarInput")
    def lightness_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceInput")
    def lightness_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVarInput")
    def lightness_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherInput")
    def saturation_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVarInput")
    def saturation_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceInput")
    def saturation_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVarInput")
    def saturation_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5d0e716d740e57418d905c4c50c768a73660950d19a98e1068a544ae81dde108)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeather")
    def hue_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeather"))

    @hue_feather.setter
    def hue_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dc85c968915bd1ae87a9a03f927ccf95405baca77efb4ebc4f25bcc8c5333e99)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeather", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVar")
    def hue_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeatherVar"))

    @hue_feather_var.setter
    def hue_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__10188f6283f909e2764c9707b7fb6b142f009d7d6b20e05fe69cb6cfa29c19c5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueTolerance")
    def hue_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueTolerance"))

    @hue_tolerance.setter
    def hue_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a4d38b4025395608f06c79adfa71c56ef985718bcf4b512bd9725c6614321626)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVar")
    def hue_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueToleranceVar"))

    @hue_tolerance_var.setter
    def hue_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ae523faa46314c161976431cea4016d9975732dab53f5c94c98d50be2cbfb43c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fbf160b5667951b5d80d4efc4bd2cd3035707e5931341b424d7ed2f48edbd176)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeather")
    def lightness_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeather"))

    @lightness_feather.setter
    def lightness_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8362aaa08a4c34d22a85608e600f9856a19efb74bbd14774f80f8446a4e1b650)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeather", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVar")
    def lightness_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeatherVar"))

    @lightness_feather_var.setter
    def lightness_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2dc3c5ffd87d7f2039800a28be35b8b2af200a8b4d7d6b4464403bb670a1950f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessTolerance")
    def lightness_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessTolerance"))

    @lightness_tolerance.setter
    def lightness_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dff29f7ea3f8b99aba62c7e4f8b85f3950d69653a16a7a411871ab053a9c233b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVar")
    def lightness_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessToleranceVar"))

    @lightness_tolerance_var.setter
    def lightness_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0b0eab05384e0f4e1c86b00a2c4b6e7094ed92f4c37fca0d13c5b136c0f9e2d0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeather")
    def saturation_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeather"))

    @saturation_feather.setter
    def saturation_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1a6baa1095b9e797546ce18627e2bf0971c5c3e992e364d194229be5e612643b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeather", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVar")
    def saturation_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeatherVar"))

    @saturation_feather_var.setter
    def saturation_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c17d515108e86940304cb16abf813c68738d8472e62432f42bc008a037c93352)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationTolerance")
    def saturation_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationTolerance"))

    @saturation_tolerance.setter
    def saturation_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8decd74d4faa01dcc09c23a6acca9c7de2dcb00044a38adf4e73005254ee9c73)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVar")
    def saturation_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationToleranceVar"))

    @saturation_tolerance_var.setter
    def saturation_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4f1ed7658d61f9beff5aab0652295aca887fdd800946ae2f456d3c3d34738fc3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultChromaKey]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultChromaKey]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultChromaKey]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7df3a370a932a1a3babc607e7b87153879077587312fcf4b9d619a8f0c5823a5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultComposite",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "placement": "placement",
        "placement_var": "placementVar",
        "scale": "scale",
        "scale_dimension": "scaleDimension",
        "scale_dimension_var": "scaleDimensionVar",
        "scale_var": "scaleVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultComposite:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultCompositeImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        placement: typing.Optional[builtins.str] = None,
        placement_var: typing.Optional[builtins.str] = None,
        scale: typing.Optional[builtins.str] = None,
        scale_dimension: typing.Optional[builtins.str] = None,
        scale_dimension_var: typing.Optional[builtins.str] = None,
        scale_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param placement: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        :param placement_var: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        :param scale: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param scale_dimension: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        :param scale_dimension_var: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        :param scale_var: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        :param x_position: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultCompositeImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a5588cfe8cf6edd8855e5c2b921068ddfaf8da9eefe481bcdcafb246495573ae)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument placement", value=placement, expected_type=type_hints["placement"])
            check_type(argname="argument placement_var", value=placement_var, expected_type=type_hints["placement_var"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument scale_dimension", value=scale_dimension, expected_type=type_hints["scale_dimension"])
            check_type(argname="argument scale_dimension_var", value=scale_dimension_var, expected_type=type_hints["scale_dimension_var"])
            check_type(argname="argument scale_var", value=scale_var, expected_type=type_hints["scale_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if placement is not None:
            self._values["placement"] = placement
        if placement_var is not None:
            self._values["placement_var"] = placement_var
        if scale is not None:
            self._values["scale"] = scale
        if scale_dimension is not None:
            self._values["scale_dimension"] = scale_dimension
        if scale_dimension_var is not None:
            self._values["scale_dimension_var"] = scale_dimension_var
        if scale_var is not None:
            self._values["scale_var"] = scale_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultCompositeImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultCompositeImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        '''
        result = self._values.get("placement")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement_var(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        '''
        result = self._values.get("placement_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        '''
        result = self._values.get("scale_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        '''
        result = self._values.get("scale_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        '''
        result = self._values.get("scale_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultComposite(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultCompositeImage",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultCompositeImage:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultCompositeImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultCompositeImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultCompositeImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c1fec1d5c31c8af06314838addf15e99c77fbc9b224ace7fc68d2e286d795525)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultCompositeImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultCompositeImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d9b05a162ce6da4bdcc07b511f52684aa804d07ded1cbfdd09b4c34ed304bd56)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultCompositeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultCompositeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af66073ed8923dfab322a7efaa78d8699adb760053efa58b3f544e862a1c7871)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultCompositeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b12c7f14cff11aa830ab779ac8e3e9f6569e680c229699fa2863baa64af608e4)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultCompositeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cacd9b6b4c79b28e50eff7ecb8624c86f58784b37941397569e9b9b3b590f041)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__48c722177b8f2411886ad4c7c121ed32b9d41219adc6d12d4e039aa27fc11496)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e3ce828ccbd0f69a61dc9c126edcbaf4b3c2826e42466bc7eef53292433c4edc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultComposite]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultComposite]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bf0fe7cf3e4aa2f2d15635ec71701569b473f625c11fdc16817752e56982289f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultCompositeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultCompositeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4496561792aaebce36057a0e397666c06a96aa452085f9a600c15bf8a6673202)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultCompositeImage()

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPlacement")
    def reset_placement(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacement", []))

    @jsii.member(jsii_name="resetPlacementVar")
    def reset_placement_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacementVar", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetScaleDimension")
    def reset_scale_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimension", []))

    @jsii.member(jsii_name="resetScaleDimensionVar")
    def reset_scale_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimensionVar", []))

    @jsii.member(jsii_name="resetScaleVar")
    def reset_scale_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultCompositeImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultCompositeImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultCompositeImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="placementInput")
    def placement_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementInput"))

    @builtins.property
    @jsii.member(jsii_name="placementVarInput")
    def placement_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionInput")
    def scale_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVarInput")
    def scale_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleVarInput")
    def scale_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9fa7565531dc0ad25bb9e0c97a1232f2e821746b606d1b3f52336f5dc04fe496)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5781e908eb0d8efe37247c98544f8f477e0df6d66d4a85ecc385a11ce1fc66bf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="placement")
    def placement(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placement"))

    @placement.setter
    def placement(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__58adcdd42f42d1085fba778d942f622ca25003c9afd83fb7fbcb2762d0ff95f7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placement", value)

    @builtins.property
    @jsii.member(jsii_name="placementVar")
    def placement_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placementVar"))

    @placement_var.setter
    def placement_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__33292aca4c181bb1ba15211d986972eb659661eb9dd5df7f5f7851ddd1889472)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placementVar", value)

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scale"))

    @scale.setter
    def scale(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e46ab66a585d24bdda1a5e017acd5daf99f44001784c28d6021bf5bb68da4824)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scale", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimension")
    def scale_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimension"))

    @scale_dimension.setter
    def scale_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__944ab18ecd8ee9310273259f2aa795ddaac5b805a4f2d384b3b3de1f5a6e6651)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimension", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVar")
    def scale_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimensionVar"))

    @scale_dimension_var.setter
    def scale_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__47852495dd1aa40435b8240f7f6cc9031b1943ad0d1f9f051bae4a7a0e459cec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="scaleVar")
    def scale_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleVar"))

    @scale_var.setter
    def scale_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fd62d6be3576cc9b581fefcb84fef7947dda303fdc77312a3d2eca2dc2678104)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__88a49c22bb0734185fcf9edd2f0f49e63ae4b5b62fd739f76a178d7964755f22)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e57b1380231f785d3dd0c8785105e03fd987100559132d9105e3e082b5220a52)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bac059da2d3949a27a6c834747bdafd6f01642d9ed72a5c2dc33ddff55c0a0f6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d485ad7250a1c73b47bb1b4664343b2f88fdd727825a43fe05888631193dce42)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultComposite]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultComposite]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultComposite]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a47262c077ba5c5710ab92ff34415ca0cf083c0d8f76e4d1a9d011c41018fc23)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultCompound",
    jsii_struct_bases=[],
    name_mapping={"transformations": "transformations"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultCompound:
    def __init__(
        self,
        *,
        transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param transformations: transformations block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b0a19dd8633fb834c5604b810a36d52529d957fa952159cc3f605a3bd46bbbfb)
            check_type(argname="argument transformations", value=transformations, expected_type=type_hints["transformations"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if transformations is not None:
            self._values["transformations"] = transformations

    @builtins.property
    def transformations(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultCompoundTransformations"]]]:
        '''transformations block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        result = self._values.get("transformations")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultCompoundTransformations"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultCompound(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultCompoundList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultCompoundList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ba2d5177781cfa70d71873f37245e0dbf5dd492a03ab91fd70741e9f3e1efc3f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultCompoundOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__087112c4dcb096432cebf90eb09198162ce788a5ca1a3007b7cdb2603b5effeb)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultCompoundOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2812fbe1060f7c19d04cae0f05a3430228773fa115a89d9db166c89959ffe2b7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa0bfdc65f89901e4d604a51fa5c735f054ad36d1f33f5b3ca4157b3380e2ce4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6fbbbec218c5a26c08ebc9500f6af16ad726066138f5b8653d60b88cd7aaaac5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultCompound]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultCompound]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__409312009d96be6872c1baa8e351591c05b3f8be13cb877dbd5ab22df879ef44)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultCompoundOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultCompoundOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cf22496a43ce47319b60de228fd2a52d3c5f2f33d7dc18c848d28af3dbd18332)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformations")
    def put_transformations(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3cbc3fbd202911b9a6a4431a533f792e8004b4ef4b4733158be13b7864da3de2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTransformations", [value]))

    @jsii.member(jsii_name="resetTransformations")
    def reset_transformations(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformations", []))

    @builtins.property
    @jsii.member(jsii_name="transformations")
    def transformations(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultCompoundTransformationsList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultCompoundTransformationsList", jsii.get(self, "transformations"))

    @builtins.property
    @jsii.member(jsii_name="transformationsInput")
    def transformations_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultCompoundTransformations"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultCompoundTransformations"]]], jsii.get(self, "transformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultCompound]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultCompound]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultCompound]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__14f275572d081a59b013410a998966a54ac16f61d101b550b602c337733d977f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultCompoundTransformations",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultCompoundTransformations:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultCompoundTransformations(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultCompoundTransformationsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultCompoundTransformationsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cced54b842c56103d23f628fde2098da4c0c621d9c0b12accdab1d917edc418f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultCompoundTransformationsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8dd86895f325a67bd26bd2e9f3b8910951dd819f4718384fdb78ec95b8c83959)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultCompoundTransformationsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2e193d70250e49c25713dfb381a9464b09c529e0777cb2c3ed39e289986d4542)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3332ca4194bc3012ba27bfc1d2e552225b5c65149f4a1b1dd4f1ce74926268c2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f3a6d885898404ff5bc644d74a0e4b1e9f7049314ab8a75d8e8ab1477a5b01ad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultCompoundTransformations]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultCompoundTransformations]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultCompoundTransformations]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7ddbb2a2b69ace4da54416e9d98f578174d2b0b0a5c1cbf35bad036dd9d77703)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultCompoundTransformationsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultCompoundTransformationsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__61d1894e13a5441f0b043ddb3d3c805484c1d70a3b370960b8fbbb528c28d06f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultCompoundTransformations]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultCompoundTransformations]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultCompoundTransformations]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1ae294845ac4a6003e6c24aeb6e93e431a55fd169c64b34c033b71e8604ccb77)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultContrast",
    jsii_struct_bases=[],
    name_mapping={
        "brightness": "brightness",
        "brightness_var": "brightnessVar",
        "contrast": "contrast",
        "contrast_var": "contrastVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultContrast:
    def __init__(
        self,
        *,
        brightness: typing.Optional[builtins.str] = None,
        brightness_var: typing.Optional[builtins.str] = None,
        contrast: typing.Optional[builtins.str] = None,
        contrast_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param brightness: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        :param brightness_var: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        :param contrast: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param contrast_var: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7e53f3ee5afe839612dd327291dc7e57b521f3f6cb319789d06e543c27367adc)
            check_type(argname="argument brightness", value=brightness, expected_type=type_hints["brightness"])
            check_type(argname="argument brightness_var", value=brightness_var, expected_type=type_hints["brightness_var"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument contrast_var", value=contrast_var, expected_type=type_hints["contrast_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if brightness is not None:
            self._values["brightness"] = brightness
        if brightness_var is not None:
            self._values["brightness_var"] = brightness_var
        if contrast is not None:
            self._values["contrast"] = contrast
        if contrast_var is not None:
            self._values["contrast_var"] = contrast_var

    @builtins.property
    def brightness(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        '''
        result = self._values.get("brightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def brightness_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        '''
        result = self._values.get("brightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        result = self._values.get("contrast_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultContrast(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultContrastList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultContrastList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__28dad02503da87e0d13e97a97ec4ae5b0adc7ce8a50ed30753edeee854005fe4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultContrastOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9519ad9a18149dd3b8a901e7ce11d8c602b62d6cd965f04fe5b0dab8dcf4e8a0)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultContrastOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b45b155e49e9a49368d6ddbcd41f44551935db4b0179a23cb7fafa63ccf7b1a9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6ead1b029e32876da1ea67ab6100b88f75d468b91362fe21a71e6c8e2398316a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f2fdc7e1acfa43550df2f1c1cbf69b3e5b3c76c7024ca618a5a1271a03632731)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultContrast]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultContrast]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8c9a6e89b343ae7f662175e4ceae30873db93cfb47a1f965cb7beb25a44722eb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultContrastOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultContrastOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f82db855c14deedde66a6372917a91e8447dec34f64cc08202183fa0f5350c76)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetBrightness")
    def reset_brightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightness", []))

    @jsii.member(jsii_name="resetBrightnessVar")
    def reset_brightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightnessVar", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetContrastVar")
    def reset_contrast_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrastVar", []))

    @builtins.property
    @jsii.member(jsii_name="brightnessInput")
    def brightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="brightnessVarInput")
    def brightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastVarInput")
    def contrast_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="brightness")
    def brightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightness"))

    @brightness.setter
    def brightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2273c647608893177c662f3fd435c40ab47106d38b0f0764c14abe404235000c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightness", value)

    @builtins.property
    @jsii.member(jsii_name="brightnessVar")
    def brightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightnessVar"))

    @brightness_var.setter
    def brightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__87d040a3010e6193323cce279b300b31017252865e4e2ee2faffbca24defd686)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrast"))

    @contrast.setter
    def contrast(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6225532ddc0edbe1f767ed3aa7a8e956da2cc1f35509bc762d21a6742df60d88)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrast", value)

    @builtins.property
    @jsii.member(jsii_name="contrastVar")
    def contrast_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrastVar"))

    @contrast_var.setter
    def contrast_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a898a9b01f0f0606fcbee24b2546d837c3140477bdc6fad634de8d5043cac929)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrastVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultContrast]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultContrast]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultContrast]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5e725dfe4c6843133b549b175641309217bf0e6b507155b0bea4abba5bd5f402)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultCrop",
    jsii_struct_bases=[],
    name_mapping={
        "allow_expansion": "allowExpansion",
        "allow_expansion_var": "allowExpansionVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultCrop:
    def __init__(
        self,
        *,
        allow_expansion: typing.Optional[builtins.str] = None,
        allow_expansion_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_expansion: If cropping an area outside of the existing canvas, expands the image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        :param allow_expansion_var: If cropping an area outside of the existing canvas, expands the image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        :param gravity: Frame of reference for X and Y Positions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Frame of reference for X and Y Positions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The number of pixels to crop along the y-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The number of pixels to crop along the y-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The number of pixels to crop along the x-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The number of pixels to crop along the x-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        :param x_position: The x-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7f052ffe931ca93fb33b43b2e19b61742e36e9364db232fc0cdfa5a6917aae4e)
            check_type(argname="argument allow_expansion", value=allow_expansion, expected_type=type_hints["allow_expansion"])
            check_type(argname="argument allow_expansion_var", value=allow_expansion_var, expected_type=type_hints["allow_expansion_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if allow_expansion is not None:
            self._values["allow_expansion"] = allow_expansion
        if allow_expansion_var is not None:
            self._values["allow_expansion_var"] = allow_expansion_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def allow_expansion(self) -> typing.Optional[builtins.str]:
        '''If cropping an area outside of the existing canvas, expands the image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        '''
        result = self._values.get("allow_expansion")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def allow_expansion_var(self) -> typing.Optional[builtins.str]:
        '''If cropping an area outside of the existing canvas, expands the image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        '''
        result = self._values.get("allow_expansion_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Frame of reference for X and Y Positions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Frame of reference for X and Y Positions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the y-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the y-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the x-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the x-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__891659b9ec4a1933fe64348daacaf89bf4dcff4ca05ada57f089ea08f4c1fa1e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__54bc1ba860d4cafbcf319cb367ae5f7a1ccdd03492960f133af25d280baa225b)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aa6e3ae9c3efe93540de29ac504c2217c425af434e0ac6f6ea60c35faa87144e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a6db71f54250163222330aaf1671da8c6bd365b017fe25ad8085bffdcfdb6ee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__07dcd6606878ebaf608c6bee05984e312a616a44f20eb3cb1759b684799e20c6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__03dbc00ef0f0ff986d5b0bcc48e1d1c66aa58ad8853b19305f65900a9f6313d2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2342e75392b403724ebc5a49a1a553d9c5a13c9f2f42beff94c410e9037d5e7c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAllowExpansion")
    def reset_allow_expansion(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansion", []))

    @jsii.member(jsii_name="resetAllowExpansionVar")
    def reset_allow_expansion_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansionVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionInput")
    def allow_expansion_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVarInput")
    def allow_expansion_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansion")
    def allow_expansion(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansion"))

    @allow_expansion.setter
    def allow_expansion(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fca375769d345d8b625eda1752a0ac46dc94c4fa932621427db20b6f41c73429)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansion", value)

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVar")
    def allow_expansion_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansionVar"))

    @allow_expansion_var.setter
    def allow_expansion_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__87e0f1b9a70d584d5f8555827ee3249cc4c879b9af0409a62744a4c2f09cabd8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansionVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__399c5bc1df3709638898ae0bbfb4ca8ea4babb4f6291c009b8eaf8fdc342279d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c08202637a4c2a70578f63ffd43910a1395a2b9a5d80ac08e301b69790012f82)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fee8defc6cc3508894ad176146ca499ecc78eacb967d34f2d9a54013967c53aa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3bfea5cf1dddb59428ca304bf131098c66b5e35afa1064372f0548783a760d05)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e2375dbc1abcb294bccd7273cd811c591bc815bcc020839786235b087f7a13d1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2f68ea067729e1e3118590d95e69682f4c3587e72c6a1b0f2907e3f532c0c095)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__620fbc06c855b4bc3976f79eabd7b724a9bc9026d502bdf4f7df6dc05a54ee73)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ed579c1a56a464488fd95ab212ea7b2ef32d72e8d3a97df45b43ed180732ad83)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b67bc3cabcee134be2cfe7507e0b8e147682adeaea0942427a2aba873f538ed8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__da2ecabefd38d32a79f63e5cdf91dfb8319aa325067e2fc42c50bf42db48cd57)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__da30913bf32755c42216fbea39022f97da1abc42c407feb6427c335bb45e8aac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultFaceCrop",
    jsii_struct_bases=[],
    name_mapping={
        "algorithm": "algorithm",
        "algorithm_var": "algorithmVar",
        "confidence": "confidence",
        "confidence_var": "confidenceVar",
        "fail_gravity": "failGravity",
        "fail_gravity_var": "failGravityVar",
        "focus": "focus",
        "focus_var": "focusVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "padding": "padding",
        "padding_var": "paddingVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultFaceCrop:
    def __init__(
        self,
        *,
        algorithm: typing.Optional[builtins.str] = None,
        algorithm_var: typing.Optional[builtins.str] = None,
        confidence: typing.Optional[builtins.str] = None,
        confidence_var: typing.Optional[builtins.str] = None,
        fail_gravity: typing.Optional[builtins.str] = None,
        fail_gravity_var: typing.Optional[builtins.str] = None,
        focus: typing.Optional[builtins.str] = None,
        focus_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param algorithm: Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm DataAkamaiImagingPolicyImage#algorithm}
        :param algorithm_var: Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm_var DataAkamaiImagingPolicyImage#algorithm_var}
        :param confidence: With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image. Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence DataAkamaiImagingPolicyImage#confidence}
        :param confidence_var: With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image. Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence_var DataAkamaiImagingPolicyImage#confidence_var}
        :param fail_gravity: Controls placement of the crop if Image and Video Manager does not detect any faces in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        :param fail_gravity_var: Controls placement of the crop if Image and Video Manager does not detect any faces in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        :param focus: Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus DataAkamaiImagingPolicyImage#focus}
        :param focus_var: Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus_var DataAkamaiImagingPolicyImage#focus_var}
        :param gravity: Controls placement of the crop. Directions are relative to the face(s) plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Controls placement of the crop. Directions are relative to the face(s) plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param padding: The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        :param style: Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d33b63a973bb7ffa315f86110b7f208fbb8540a2ee9343392d88ffb6423c1b35)
            check_type(argname="argument algorithm", value=algorithm, expected_type=type_hints["algorithm"])
            check_type(argname="argument algorithm_var", value=algorithm_var, expected_type=type_hints["algorithm_var"])
            check_type(argname="argument confidence", value=confidence, expected_type=type_hints["confidence"])
            check_type(argname="argument confidence_var", value=confidence_var, expected_type=type_hints["confidence_var"])
            check_type(argname="argument fail_gravity", value=fail_gravity, expected_type=type_hints["fail_gravity"])
            check_type(argname="argument fail_gravity_var", value=fail_gravity_var, expected_type=type_hints["fail_gravity_var"])
            check_type(argname="argument focus", value=focus, expected_type=type_hints["focus"])
            check_type(argname="argument focus_var", value=focus_var, expected_type=type_hints["focus_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if algorithm is not None:
            self._values["algorithm"] = algorithm
        if algorithm_var is not None:
            self._values["algorithm_var"] = algorithm_var
        if confidence is not None:
            self._values["confidence"] = confidence
        if confidence_var is not None:
            self._values["confidence_var"] = confidence_var
        if fail_gravity is not None:
            self._values["fail_gravity"] = fail_gravity
        if fail_gravity_var is not None:
            self._values["fail_gravity_var"] = fail_gravity_var
        if focus is not None:
            self._values["focus"] = focus
        if focus_var is not None:
            self._values["focus_var"] = focus_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def algorithm(self) -> typing.Optional[builtins.str]:
        '''Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm DataAkamaiImagingPolicyImage#algorithm}
        '''
        result = self._values.get("algorithm")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def algorithm_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm_var DataAkamaiImagingPolicyImage#algorithm_var}
        '''
        result = self._values.get("algorithm_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def confidence(self) -> typing.Optional[builtins.str]:
        '''With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image.

        Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence DataAkamaiImagingPolicyImage#confidence}
        '''
        result = self._values.get("confidence")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def confidence_var(self) -> typing.Optional[builtins.str]:
        '''With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image.

        Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence_var DataAkamaiImagingPolicyImage#confidence_var}
        '''
        result = self._values.get("confidence_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any faces in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        '''
        result = self._values.get("fail_gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any faces in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        '''
        result = self._values.get("fail_gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def focus(self) -> typing.Optional[builtins.str]:
        '''Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus DataAkamaiImagingPolicyImage#focus}
        '''
        result = self._values.get("focus")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def focus_var(self) -> typing.Optional[builtins.str]:
        '''Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus_var DataAkamaiImagingPolicyImage#focus_var}
        '''
        result = self._values.get("focus_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the face(s) plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the face(s) plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultFaceCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultFaceCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultFaceCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eb7341fd54b16741689431187d39a490a10ea861758b9ee02ae6b2fc39e5b373)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultFaceCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__73dd3b5a16c53a9f4469a142bb95b1eab5528daf805a85e55a11861e88e09bb6)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultFaceCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__16f259eccb19c846f9222ecf896c27b70eb848de7c74c0752d26767cc2379465)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8bcb88c5e4a2025112cadb91d76344ccc5a06bc2b09a7c6ed817d618ae29956f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__16a98ed73f45ae835a2d0d80a94ca99c97d59196503f849b7b7650b3a1863e26)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultFaceCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultFaceCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultFaceCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ecb3323419a476d401c864b109067e03ad0523c57ff88f79f284374e61f50fee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultFaceCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultFaceCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dc56696d7df3b570d87db5fb9319443034f04e31d047c090ea5d7e300eeccfa9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAlgorithm")
    def reset_algorithm(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAlgorithm", []))

    @jsii.member(jsii_name="resetAlgorithmVar")
    def reset_algorithm_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAlgorithmVar", []))

    @jsii.member(jsii_name="resetConfidence")
    def reset_confidence(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetConfidence", []))

    @jsii.member(jsii_name="resetConfidenceVar")
    def reset_confidence_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetConfidenceVar", []))

    @jsii.member(jsii_name="resetFailGravity")
    def reset_fail_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravity", []))

    @jsii.member(jsii_name="resetFailGravityVar")
    def reset_fail_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravityVar", []))

    @jsii.member(jsii_name="resetFocus")
    def reset_focus(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFocus", []))

    @jsii.member(jsii_name="resetFocusVar")
    def reset_focus_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFocusVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="algorithmInput")
    def algorithm_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "algorithmInput"))

    @builtins.property
    @jsii.member(jsii_name="algorithmVarInput")
    def algorithm_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "algorithmVarInput"))

    @builtins.property
    @jsii.member(jsii_name="confidenceInput")
    def confidence_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "confidenceInput"))

    @builtins.property
    @jsii.member(jsii_name="confidenceVarInput")
    def confidence_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "confidenceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityInput")
    def fail_gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityVarInput")
    def fail_gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="focusInput")
    def focus_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "focusInput"))

    @builtins.property
    @jsii.member(jsii_name="focusVarInput")
    def focus_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "focusVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="algorithm")
    def algorithm(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "algorithm"))

    @algorithm.setter
    def algorithm(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0b733f5e8b1c5dc668bb2f879126501cbe1e10e4fc422b75f78688d6fbc332d9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "algorithm", value)

    @builtins.property
    @jsii.member(jsii_name="algorithmVar")
    def algorithm_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "algorithmVar"))

    @algorithm_var.setter
    def algorithm_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2bd42c815d47e2899fa478bf4e7ad508ba288e6017b97f25109f640105d37057)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "algorithmVar", value)

    @builtins.property
    @jsii.member(jsii_name="confidence")
    def confidence(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "confidence"))

    @confidence.setter
    def confidence(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a0210b29d47bf718c75c413862b4dfdd32d71615df2b1b835ced9b460551161)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "confidence", value)

    @builtins.property
    @jsii.member(jsii_name="confidenceVar")
    def confidence_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "confidenceVar"))

    @confidence_var.setter
    def confidence_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b1fd9af90077a903484ac80232bbaa62ec9368ea17a71998848dacef4f69627e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "confidenceVar", value)

    @builtins.property
    @jsii.member(jsii_name="failGravity")
    def fail_gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravity"))

    @fail_gravity.setter
    def fail_gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c9fd39f6dd8fd07dc74b085697dd1ae0335097d949a8ccb1e6ec08e1454b4b09)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravity", value)

    @builtins.property
    @jsii.member(jsii_name="failGravityVar")
    def fail_gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravityVar"))

    @fail_gravity_var.setter
    def fail_gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__308a8381dda264120b83112398c07a03804960c7579af9495e8df53ed73bf323)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="focus")
    def focus(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "focus"))

    @focus.setter
    def focus(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__15dc4364de9c6f1cc6e53d04300b6778d0ac05b2de963aa6986813d8072d6b60)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "focus", value)

    @builtins.property
    @jsii.member(jsii_name="focusVar")
    def focus_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "focusVar"))

    @focus_var.setter
    def focus_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__00ab24d724081c7f5446f69117b401d92299d141ffd92ef747835a6aeee60681)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "focusVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c04c6f10bc5fb42de9b75520dda962c525350b3da4dd9f92b523c18f2fa19723)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ec5dbd8495704c75cb3ae20e19c67c6b6e74858bc92a75b2704b8fba87b789d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__13854919271c2a5d2966f4d45ff18632d163879e0fbca93a502d01b738b31244)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc4db9cd27577db32e393876f99ac69add99dc6540f55072568513b06631d9f9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dde9c32d4f69682c9c2adae2e7d30f0349f1504635f00937d69ab7daf57a46e0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__454b4574746842474412cf6f44ec1ee3a74d6f80f482ed1989179f3ed1091388)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a0962109e83edd48fba6f6f1f5af323140ef0e8c7da9adcad1242472d6618de)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd13dd244bbf81675e88d38e6c915867077a2223b36395f58d7318dcee3c5d9b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5440d7e500a1b8da715d3c2b16bd19d92b4ff85f224485074c12d6e3bd5f04ae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3c04464fafd2a4729cd171e42d180ea7313753ced14f5e249fa29fa75de6f86e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultFaceCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultFaceCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultFaceCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__73b11a745c64cafcaaf802f1154585fa9221e23988d0a2dffc4f751bf266f46f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultFeatureCrop",
    jsii_struct_bases=[],
    name_mapping={
        "fail_gravity": "failGravity",
        "fail_gravity_var": "failGravityVar",
        "feature_radius": "featureRadius",
        "feature_radius_var": "featureRadiusVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "max_features": "maxFeatures",
        "max_features_var": "maxFeaturesVar",
        "min_feature_quality": "minFeatureQuality",
        "min_feature_quality_var": "minFeatureQualityVar",
        "padding": "padding",
        "padding_var": "paddingVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultFeatureCrop:
    def __init__(
        self,
        *,
        fail_gravity: typing.Optional[builtins.str] = None,
        fail_gravity_var: typing.Optional[builtins.str] = None,
        feature_radius: typing.Optional[builtins.str] = None,
        feature_radius_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        max_features: typing.Optional[builtins.str] = None,
        max_features_var: typing.Optional[builtins.str] = None,
        min_feature_quality: typing.Optional[builtins.str] = None,
        min_feature_quality_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fail_gravity: Controls placement of the crop if Image and Video Manager does not detect any features in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        :param fail_gravity_var: Controls placement of the crop if Image and Video Manager does not detect any features in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        :param feature_radius: The size in pixels of the important features to search for. If identified, two features never appear closer together than this value, ``8.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius DataAkamaiImagingPolicyImage#feature_radius}
        :param feature_radius_var: The size in pixels of the important features to search for. If identified, two features never appear closer together than this value, ``8.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius_var DataAkamaiImagingPolicyImage#feature_radius_var}
        :param gravity: Controls placement of the crop. Directions are relative to the region of interest plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Controls placement of the crop. Directions are relative to the region of interest plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param max_features: The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features DataAkamaiImagingPolicyImage#max_features}
        :param max_features_var: The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features_var DataAkamaiImagingPolicyImage#max_features_var}
        :param min_feature_quality: Determines the minimum quality level of the feature identified. To consider a feature important, the feature needs to surpass this value. Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality DataAkamaiImagingPolicyImage#min_feature_quality}
        :param min_feature_quality_var: Determines the minimum quality level of the feature identified. To consider a feature important, the feature needs to surpass this value. Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality_var DataAkamaiImagingPolicyImage#min_feature_quality_var}
        :param padding: Adds space around the region of interest. The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: Adds space around the region of interest. The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        :param style: Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__261ecbd169fdf27b49ceb725fb78dbf9e6cdf19f2fc672a49705ff8a5e33d440)
            check_type(argname="argument fail_gravity", value=fail_gravity, expected_type=type_hints["fail_gravity"])
            check_type(argname="argument fail_gravity_var", value=fail_gravity_var, expected_type=type_hints["fail_gravity_var"])
            check_type(argname="argument feature_radius", value=feature_radius, expected_type=type_hints["feature_radius"])
            check_type(argname="argument feature_radius_var", value=feature_radius_var, expected_type=type_hints["feature_radius_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument max_features", value=max_features, expected_type=type_hints["max_features"])
            check_type(argname="argument max_features_var", value=max_features_var, expected_type=type_hints["max_features_var"])
            check_type(argname="argument min_feature_quality", value=min_feature_quality, expected_type=type_hints["min_feature_quality"])
            check_type(argname="argument min_feature_quality_var", value=min_feature_quality_var, expected_type=type_hints["min_feature_quality_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fail_gravity is not None:
            self._values["fail_gravity"] = fail_gravity
        if fail_gravity_var is not None:
            self._values["fail_gravity_var"] = fail_gravity_var
        if feature_radius is not None:
            self._values["feature_radius"] = feature_radius
        if feature_radius_var is not None:
            self._values["feature_radius_var"] = feature_radius_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if max_features is not None:
            self._values["max_features"] = max_features
        if max_features_var is not None:
            self._values["max_features_var"] = max_features_var
        if min_feature_quality is not None:
            self._values["min_feature_quality"] = min_feature_quality
        if min_feature_quality_var is not None:
            self._values["min_feature_quality_var"] = min_feature_quality_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def fail_gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any features in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        '''
        result = self._values.get("fail_gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any features in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        '''
        result = self._values.get("fail_gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feature_radius(self) -> typing.Optional[builtins.str]:
        '''The size in pixels of the important features to search for.

        If identified, two features never appear closer together than this value, ``8.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius DataAkamaiImagingPolicyImage#feature_radius}
        '''
        result = self._values.get("feature_radius")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feature_radius_var(self) -> typing.Optional[builtins.str]:
        '''The size in pixels of the important features to search for.

        If identified, two features never appear closer together than this value, ``8.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius_var DataAkamaiImagingPolicyImage#feature_radius_var}
        '''
        result = self._values.get("feature_radius_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the region of interest plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the region of interest plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def max_features(self) -> typing.Optional[builtins.str]:
        '''The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features DataAkamaiImagingPolicyImage#max_features}
        '''
        result = self._values.get("max_features")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def max_features_var(self) -> typing.Optional[builtins.str]:
        '''The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features_var DataAkamaiImagingPolicyImage#max_features_var}
        '''
        result = self._values.get("max_features_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def min_feature_quality(self) -> typing.Optional[builtins.str]:
        '''Determines the minimum quality level of the feature identified.

        To consider a feature important, the feature needs to surpass this value.  Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality DataAkamaiImagingPolicyImage#min_feature_quality}
        '''
        result = self._values.get("min_feature_quality")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def min_feature_quality_var(self) -> typing.Optional[builtins.str]:
        '''Determines the minimum quality level of the feature identified.

        To consider a feature important, the feature needs to surpass this value.  Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality_var DataAkamaiImagingPolicyImage#min_feature_quality_var}
        '''
        result = self._values.get("min_feature_quality_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''Adds space around the region of interest.

        The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''Adds space around the region of interest.

        The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultFeatureCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultFeatureCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultFeatureCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a098532ebd1862fce74c156057bbfa43d2c40fd3cfa9c571a48979e52b75e124)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultFeatureCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f929a4280741c699eda38c467e648ee5849484375c7659a42b77db96573ee600)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultFeatureCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5b98bac1efd3032b491e9ee914c8ae9a0bbd7ab4c5e8008cf455d9506a0ce423)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__afcf567ec15feb3106ccd4f9d9bc24a0aafa8378d738f45a199abbec03eef602)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5557f6975cfd01e750127818ec9737ea3bbacace1deed288ce40ccd2d839a6fb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultFeatureCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultFeatureCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultFeatureCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3c76afe0e34833e897850cfda135cccc56a8a9aa0def53e911c53d81c4ef2f67)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultFeatureCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultFeatureCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dffa68a62ca30b010812330c6b4560aebcaf9004f64ffb76505a4bb8ef024739)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetFailGravity")
    def reset_fail_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravity", []))

    @jsii.member(jsii_name="resetFailGravityVar")
    def reset_fail_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravityVar", []))

    @jsii.member(jsii_name="resetFeatureRadius")
    def reset_feature_radius(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureRadius", []))

    @jsii.member(jsii_name="resetFeatureRadiusVar")
    def reset_feature_radius_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureRadiusVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetMaxFeatures")
    def reset_max_features(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxFeatures", []))

    @jsii.member(jsii_name="resetMaxFeaturesVar")
    def reset_max_features_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxFeaturesVar", []))

    @jsii.member(jsii_name="resetMinFeatureQuality")
    def reset_min_feature_quality(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMinFeatureQuality", []))

    @jsii.member(jsii_name="resetMinFeatureQualityVar")
    def reset_min_feature_quality_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMinFeatureQualityVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="failGravityInput")
    def fail_gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityVarInput")
    def fail_gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featureRadiusInput")
    def feature_radius_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featureRadiusInput"))

    @builtins.property
    @jsii.member(jsii_name="featureRadiusVarInput")
    def feature_radius_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featureRadiusVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesInput")
    def max_features_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "maxFeaturesInput"))

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesVarInput")
    def max_features_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "maxFeaturesVarInput"))

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityInput")
    def min_feature_quality_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "minFeatureQualityInput"))

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityVarInput")
    def min_feature_quality_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "minFeatureQualityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravity")
    def fail_gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravity"))

    @fail_gravity.setter
    def fail_gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__faa97026f56d6bbae0b7206f822beee8cd142e60834469e9c05cb6b9a9c4c2c8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravity", value)

    @builtins.property
    @jsii.member(jsii_name="failGravityVar")
    def fail_gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravityVar"))

    @fail_gravity_var.setter
    def fail_gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b52becfcd189edf7a2f9ad61f33c475f56541852ba4a01c37520f4668a763065)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="featureRadius")
    def feature_radius(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featureRadius"))

    @feature_radius.setter
    def feature_radius(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__32aecac4ba726477154fe8b234f22d83d598f0123edc373fd8cd5380abd60a7e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featureRadius", value)

    @builtins.property
    @jsii.member(jsii_name="featureRadiusVar")
    def feature_radius_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featureRadiusVar"))

    @feature_radius_var.setter
    def feature_radius_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3f3b5cab457416869fb234e2d00b674c5758c046a42d39434acb0bb01a6429c0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featureRadiusVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8467db88fd43e3d3daef2f7c941353d839f97cf2d800a4c670b6dc9dab60da9a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ae0d5cac4c8c540374c61044a24fb0ee15d354e82422ce61b890835fd5ef21ea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__75b598a6f21232d2d04b564291eea91effa2c270e0e19272b7830c7cdfbbff08)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__76d5bf0afa1fbb0ddaed65b1cc0f7832ab7eeeb260de7738bad912ed38400405)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="maxFeatures")
    def max_features(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "maxFeatures"))

    @max_features.setter
    def max_features(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__801485eccfeda105cfc3605b9d1d51efb7c327b0b5dbee941a55b6fbd6e8bacd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "maxFeatures", value)

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesVar")
    def max_features_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "maxFeaturesVar"))

    @max_features_var.setter
    def max_features_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__044c76690d89d162f4c2bccf7f5c6876e58dd7d586af8451bbe9265184134fb4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "maxFeaturesVar", value)

    @builtins.property
    @jsii.member(jsii_name="minFeatureQuality")
    def min_feature_quality(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "minFeatureQuality"))

    @min_feature_quality.setter
    def min_feature_quality(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__977cf8dc691943f43f2b06c6017b750c643af08b85da20653080ad3bc3aeffc6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "minFeatureQuality", value)

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityVar")
    def min_feature_quality_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "minFeatureQualityVar"))

    @min_feature_quality_var.setter
    def min_feature_quality_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8d832d3bd72acebc4d074f55e4c00a73f5c71c5ca246d9b3063a728bd348b4e2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "minFeatureQualityVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__124f770e388cd8cae1ae399fe50a8ca02c09fd6e75907f630810d86c2409aab5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__91d3687f7e2fd0dd637049973e79e45bbec44b7caba3bfcca2344aacf04e780b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__06d54220b8d786660cf529191663e2e2b773ff51fcd012475191c52e78c4e616)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8ecd63d74dc3f765224892f896f2519c03a28f5a2fbd3a2b0b7661d9489a1c65)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6be92343f7fc80278f642a735dec88d015026cc326da60de7d77c2622575da19)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3b79f8eded01cb6e7e80b194efee26b90ef341b82d5915419349c841efba6cdf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultFeatureCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultFeatureCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultFeatureCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a5e38e4af8ba8c837061e7e35100ae336339357f97be17963f6d5184566d5e79)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultFitAndFill",
    jsii_struct_bases=[],
    name_mapping={
        "fill_transformation": "fillTransformation",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultFitAndFill:
    def __init__(
        self,
        *,
        fill_transformation: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultFitAndFillFillTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fill_transformation: fill_transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_transformation DataAkamaiImagingPolicyImage#fill_transformation}
        :param height: The height value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The width value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(fill_transformation, dict):
            fill_transformation = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultFitAndFillFillTransformation(**fill_transformation)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__29253c40992dd49d3a6107a43524df647e3530d8c14068932878137e97b60ca1)
            check_type(argname="argument fill_transformation", value=fill_transformation, expected_type=type_hints["fill_transformation"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fill_transformation is not None:
            self._values["fill_transformation"] = fill_transformation
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def fill_transformation(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultFitAndFillFillTransformation"]:
        '''fill_transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_transformation DataAkamaiImagingPolicyImage#fill_transformation}
        '''
        result = self._values.get("fill_transformation")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultFitAndFillFillTransformation"], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultFitAndFill(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultFitAndFillFillTransformation",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultFitAndFillFillTransformation:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultFitAndFillFillTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultFitAndFillFillTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultFitAndFillFillTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eeba1854336fdd075ea283680f2e43263e720e120e339aa7fb6c9dff78b5da7d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultFitAndFillFillTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultFitAndFillFillTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultFitAndFillFillTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9aa07b3ad8a0644b2bed667656058ff464f86d8ef458dd4348ce8ff0a37e084f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultFitAndFillList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultFitAndFillList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bfd7346616d6c45e6fb0ffe7ca4636d992f9198b96f665089b61f74b1bc01b72)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultFitAndFillOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__49b2414c897c13fd3fcb614962f242fcd2a92b7d541f067af1d3798aa3396414)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultFitAndFillOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4597bb482560abba344f9e1e42e3eecf316a266f621201353658ec223df84f0c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__70531646bbaec86233eb32c5693426cd76dcc41cc15deb0e66e076e33d02ef1e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c8dd29c9e3685363b729361187288659f82820549d1a054cb4bc4c542c5fe3d4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultFitAndFill]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultFitAndFill]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultFitAndFill]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be31b233e6ac40b8cc6bb7762eb47b8eed056a8423b0c1db857e2d07703402c3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultFitAndFillOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultFitAndFillOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__83988c336795d87f718617277a938ee7770eb19f95c3ecd98aa9aed952945c89)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putFillTransformation")
    def put_fill_transformation(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultFitAndFillFillTransformation()

        return typing.cast(None, jsii.invoke(self, "putFillTransformation", [value]))

    @jsii.member(jsii_name="resetFillTransformation")
    def reset_fill_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFillTransformation", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="fillTransformation")
    def fill_transformation(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultFitAndFillFillTransformationOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultFitAndFillFillTransformationOutputReference, jsii.get(self, "fillTransformation"))

    @builtins.property
    @jsii.member(jsii_name="fillTransformationInput")
    def fill_transformation_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultFitAndFillFillTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultFitAndFillFillTransformation], jsii.get(self, "fillTransformationInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8f67c6555bb1d7b7f537e9554537c6b04982bbfe9b9ef6ae49069a48d4b1d360)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__152903726bd98952cc763e9d8c430954294633bcadeb94164c3c42af4dee2617)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b76b044f73b2a37df8953bc4aa667982bab4add9ad76f757462d175be7d27b45)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b8378bfc79bcb2234e2d5d20cb6f8085a6efe3be14dd7bce32726a05a33da5c6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultFitAndFill]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultFitAndFill]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultFitAndFill]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eb6fb932994be91e6a81c45f03c7ef2d91b7aa48d37d9fd7069336d41473b71f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultGoop",
    jsii_struct_bases=[],
    name_mapping={
        "chaos": "chaos",
        "chaos_var": "chaosVar",
        "density": "density",
        "density_var": "densityVar",
        "power": "power",
        "power_var": "powerVar",
        "seed": "seed",
        "seed_var": "seedVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultGoop:
    def __init__(
        self,
        *,
        chaos: typing.Optional[builtins.str] = None,
        chaos_var: typing.Optional[builtins.str] = None,
        density: typing.Optional[builtins.str] = None,
        density_var: typing.Optional[builtins.str] = None,
        power: typing.Optional[builtins.str] = None,
        power_var: typing.Optional[builtins.str] = None,
        seed: typing.Optional[builtins.str] = None,
        seed_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param chaos: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        :param chaos_var: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        :param density: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        :param density_var: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        :param power: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        :param power_var: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        :param seed: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        :param seed_var: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__09c252c0dc7feebfa4f402fd424aac435c1dfceff8edefd6748c673843253966)
            check_type(argname="argument chaos", value=chaos, expected_type=type_hints["chaos"])
            check_type(argname="argument chaos_var", value=chaos_var, expected_type=type_hints["chaos_var"])
            check_type(argname="argument density", value=density, expected_type=type_hints["density"])
            check_type(argname="argument density_var", value=density_var, expected_type=type_hints["density_var"])
            check_type(argname="argument power", value=power, expected_type=type_hints["power"])
            check_type(argname="argument power_var", value=power_var, expected_type=type_hints["power_var"])
            check_type(argname="argument seed", value=seed, expected_type=type_hints["seed"])
            check_type(argname="argument seed_var", value=seed_var, expected_type=type_hints["seed_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if chaos is not None:
            self._values["chaos"] = chaos
        if chaos_var is not None:
            self._values["chaos_var"] = chaos_var
        if density is not None:
            self._values["density"] = density
        if density_var is not None:
            self._values["density_var"] = density_var
        if power is not None:
            self._values["power"] = power
        if power_var is not None:
            self._values["power_var"] = power_var
        if seed is not None:
            self._values["seed"] = seed
        if seed_var is not None:
            self._values["seed_var"] = seed_var

    @builtins.property
    def chaos(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        '''
        result = self._values.get("chaos")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def chaos_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        '''
        result = self._values.get("chaos_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        '''
        result = self._values.get("density")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density_var(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        '''
        result = self._values.get("density_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        '''
        result = self._values.get("power")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power_var(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        '''
        result = self._values.get("power_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        '''
        result = self._values.get("seed")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed_var(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        result = self._values.get("seed_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultGoop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultGoopList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultGoopList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__273e5ed8e85d3f393c61bc9f4955f4c020aba22b2e4fec4f59ede7384125fefd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultGoopOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f1869d3e44eca10913d61e2c55d303d19617139935d654928e5e30b9f79dac66)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultGoopOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e5c0ad2d21f95a497bfccc9b0d6878f1290bb42ef1eab6999b05def2c40d7708)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f135f0e6a758f9a1852c5e66329313c3c141f8ddffd0b2268564294861d59306)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__67349df44ddf650aebad418920c6f9f4168239190e4f87f840705d7f2466939c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultGoop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultGoop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__70d6b2431c173e7045b837b20dd87596ebc081f75754b6f757f38ea49d45dc3b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultGoopOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultGoopOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4740b25628dc11bafcabf255ba168a2dd7fef9b6bc26c23d594f23054f873006)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetChaos")
    def reset_chaos(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaos", []))

    @jsii.member(jsii_name="resetChaosVar")
    def reset_chaos_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaosVar", []))

    @jsii.member(jsii_name="resetDensity")
    def reset_density(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensity", []))

    @jsii.member(jsii_name="resetDensityVar")
    def reset_density_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensityVar", []))

    @jsii.member(jsii_name="resetPower")
    def reset_power(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPower", []))

    @jsii.member(jsii_name="resetPowerVar")
    def reset_power_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPowerVar", []))

    @jsii.member(jsii_name="resetSeed")
    def reset_seed(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeed", []))

    @jsii.member(jsii_name="resetSeedVar")
    def reset_seed_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeedVar", []))

    @builtins.property
    @jsii.member(jsii_name="chaosInput")
    def chaos_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosInput"))

    @builtins.property
    @jsii.member(jsii_name="chaosVarInput")
    def chaos_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosVarInput"))

    @builtins.property
    @jsii.member(jsii_name="densityInput")
    def density_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityInput"))

    @builtins.property
    @jsii.member(jsii_name="densityVarInput")
    def density_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="powerInput")
    def power_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerInput"))

    @builtins.property
    @jsii.member(jsii_name="powerVarInput")
    def power_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerVarInput"))

    @builtins.property
    @jsii.member(jsii_name="seedInput")
    def seed_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedInput"))

    @builtins.property
    @jsii.member(jsii_name="seedVarInput")
    def seed_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedVarInput"))

    @builtins.property
    @jsii.member(jsii_name="chaos")
    def chaos(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaos"))

    @chaos.setter
    def chaos(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bde143715459f22043b64820aec750972854c4745f25eca189b220d5be181049)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaos", value)

    @builtins.property
    @jsii.member(jsii_name="chaosVar")
    def chaos_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaosVar"))

    @chaos_var.setter
    def chaos_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__18dec71137f6a38610666e102795f1f39a68f531f6245366347e0a5e199f0457)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaosVar", value)

    @builtins.property
    @jsii.member(jsii_name="density")
    def density(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "density"))

    @density.setter
    def density(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6170e2316334d2fbb48dcf11e1d69a17d42b2d5abee48cbd980feca73ce1c565)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "density", value)

    @builtins.property
    @jsii.member(jsii_name="densityVar")
    def density_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "densityVar"))

    @density_var.setter
    def density_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__799ab3bf5f908b631ace3a64e13748a011361cbe8d7dd82aa0e2351ddc552946)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "densityVar", value)

    @builtins.property
    @jsii.member(jsii_name="power")
    def power(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "power"))

    @power.setter
    def power(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fce217a9efc2ef576a08e864f32d1ef4b342a0b0b3f19d2095433d1dd226eac6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "power", value)

    @builtins.property
    @jsii.member(jsii_name="powerVar")
    def power_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "powerVar"))

    @power_var.setter
    def power_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6b15ba2a9ebc90d0802e471d3ab9815d02de137891f21ce2368ede4214dbf4ff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "powerVar", value)

    @builtins.property
    @jsii.member(jsii_name="seed")
    def seed(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seed"))

    @seed.setter
    def seed(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__055b2edee4b9c161006e392d80fa9c3714473b590c76acf98a7ebc294cbd82c8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seed", value)

    @builtins.property
    @jsii.member(jsii_name="seedVar")
    def seed_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seedVar"))

    @seed_var.setter
    def seed_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7261b2130090500691e681adf3f015039ef8f94d5f1809d53a951c1b3c8a2ffc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seedVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultGoop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultGoop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultGoop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e8e69dba40d950172d5b91d7da611eb70e5ffda7aff6f7dfbd08f8177a5f208e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultGrayscale",
    jsii_struct_bases=[],
    name_mapping={"type": "type", "type_var": "typeVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultGrayscale:
    def __init__(
        self,
        *,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param type: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e4e18a7108c3c03e78da4763db38ab8ca8206411caa9f1c69d7f041d361dad69)
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultGrayscale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultGrayscaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultGrayscaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f002ef32d4c4b824e53fecad42ba25954c66293e6407a3d120ee42ce9c6a5752)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultGrayscaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d9cc50cb28e6505d3b4483ccb739d8a6a1a8eb18312122e32c578874fea688f0)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultGrayscaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f67f3dec23a48485119f284e3e220cac8d6b832f9c123fcf9b403cecd73fcbc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7b50cf223f6d70835c943f64b1ec9763ba919fdc4cc2c759e18a9420b3936b08)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bbcf38f614467f28205b1b9c1dabfaad7ed48c2c0d85c620a0a6aa54d17cf430)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultGrayscale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultGrayscale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ba7e78bbc6e81001296c421e9d03ae5f26a92bdf40ae2de9ce811b78368bb103)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultGrayscaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultGrayscaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__55d5102228104f3e1cd567ff1b63d8565f0e3388d713f1d1ba88b3ba6a1e1739)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5df2cdd37186dd50fbb31ad18c9ecdec3f12e2f07abbbfdec1ba64e1bdb280c4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a7e273808a7748db027a1ad1ee8cded19d13755ee17d2fa9740f4a7a77515a79)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultGrayscale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultGrayscale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultGrayscale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c0601ff5b185235f73bb11c5104e4eabee0ef2c289c8b68bc429ed65efee4101)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultHsl",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "lightness": "lightness",
        "lightness_var": "lightnessVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultHsl:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness: typing.Optional[builtins.str] = None,
        lightness_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        :param lightness_var: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b58499da248ae86e1a89bbb7380f193a8b3a49355c76f22e499b5935568134c0)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness", value=lightness, expected_type=type_hints["lightness"])
            check_type(argname="argument lightness_var", value=lightness_var, expected_type=type_hints["lightness_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness is not None:
            self._values["lightness"] = lightness
        if lightness_var is not None:
            self._values["lightness_var"] = lightness_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        '''
        result = self._values.get("lightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        '''
        result = self._values.get("lightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultHsl(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultHslList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultHslList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9c1e1d2dc9c8e9eea61db8dd25f8cbc84a24d851048cc5a51b6ce39d43b2ad5a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultHslOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__40e91f8065724272d9a9abeaaba509f25ae5b602a2886a1f6a4633412cdef9c2)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultHslOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b620205b8cf37ff96696ced7243a9cebcc2e4320cebd26f311915b319009f77d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__906c695117e5c52b5704af02bdfcc0c2e6099c90593e6f4008fcf825e21b60ef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3b57c9707dc34b4251e74526d53ede7bc53eedcdf289c506f2ee3a56a4e87aa9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultHsl]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultHsl]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7c6d9d631311f62585b59d78d553646f38ccc101ed665185489a890f7c54f17b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultHslOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultHslOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__568bc9010cda8babde5befba0f73428b4fc0cc4fd775db635b2b14ce54d4bb70)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightness")
    def reset_lightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightness", []))

    @jsii.member(jsii_name="resetLightnessVar")
    def reset_lightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessInput")
    def lightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessVarInput")
    def lightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__60def31950561cf1aef12ca7986524c3f3867bcace7c904c33bdb42957568a02)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c8b1cafadb8f554d633728c9028f2bbda6cb9f4bf02d24c2a37f9bb4857c6dca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightness")
    def lightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightness"))

    @lightness.setter
    def lightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__93aa9728099fee2ae1270f818aa8043a864f3b7bf518bc2b0696e8aad9032612)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightness", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessVar")
    def lightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessVar"))

    @lightness_var.setter
    def lightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__430ff470e17858a9a81af1d2003f40de0d1660cf6be3c3615a8b48fb9e0c1750)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f6b0580f5bc36a41cddd5527255a6f94bcb319c751cb791e18349fa11d3d17db)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e43356567f185b949f54966c0056c5e6549d6fba6c1544537551cc590e2352b0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultHsl]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultHsl]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultHsl]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e8cfc7950cf3682bfe2cfaff4d07c8e6af1476c1b53de95eceff1cead3d5c24e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultHsv",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultHsv:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        :param value: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0d2a5afa71881d47bf7f0b501da0ee9c84b478796d58a45b254b97a3e4af6174)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultHsv(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultHsvList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultHsvList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__912ce36b1534981f17122445bdb9e2ad9b6509130f2e2bcc80303cb85ab54aa3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultHsvOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e374c6684957e744732963e9da1c6ab6c68687780789e7a1e3a8ef092a34731a)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultHsvOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c0cb7659dc045c2c420e8d0b325b5a878c351ddd2176128c4657e3300a895e66)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8d11f8e2102a85eb2ba71e8d4ce445ffe0be55c310a5eb04f9dae75c1c29d014)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dfd9dcae2c57d04d9c351369f9f5b06c5f00f026468992b68d24a5f41ba255be)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultHsv]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultHsv]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__57cd13a3dc57df9959f59a87c15d4637d0dc15a45d952b9cd945ad7ac4b50be3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultHsvOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultHsvOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f479ee7e54f49634023ed8fd0c5e800068b8954c26a4fc4817319d250ca51b6e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4caa08cc0a097914382f6a0ea07dd9fbd75a1d0057d2b0ca57c9546aeac32010)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5b5d790544fc9bdcc2bc776a040d43a4e293f60355ba370a275b869f3bd3a63b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__29b6f2369efff415b7d9c14e3a48e064f4d4ea4ae3d6e3572becf9f7c9b0c66c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e4fbe051236551fe65c20ea2ee03f5b8985eb55827d151e117bef86712307a06)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__da8ccc7d06497a6ae2b10dbd8f6c9665da94cc096df6c2e79f9ee92545eb5c19)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__83dcaa36493f4a924e1ffaa8771bd19c896cdc8485ba5c346935330eb978efd3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultHsv]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultHsv]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultHsv]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2f6fe2eb311e5f7dce718673b400ec22fc4198fa0acfd9cea3617b39f35dae09)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimension",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "dimension": "dimension",
        "dimension_var": "dimensionVar",
        "equal": "equal",
        "greater_than": "greaterThan",
        "less_than": "lessThan",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimension:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        dimension: typing.Optional[builtins.str] = None,
        dimension_var: typing.Optional[builtins.str] = None,
        equal: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionEqual", typing.Dict[builtins.str, typing.Any]]] = None,
        greater_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionGreaterThan", typing.Dict[builtins.str, typing.Any]]] = None,
        less_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionLessThan", typing.Dict[builtins.str, typing.Any]]] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param dimension: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        :param dimension_var: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        :param equal: equal block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        :param greater_than: greater_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        :param less_than: less_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        :param value: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionDefault(**default)
        if isinstance(equal, dict):
            equal = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionEqual(**equal)
        if isinstance(greater_than, dict):
            greater_than = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionGreaterThan(**greater_than)
        if isinstance(less_than, dict):
            less_than = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionLessThan(**less_than)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ece5c28956ec2fcafeae3079409d365303b85da096128040addcd7e74e0ad520)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument dimension", value=dimension, expected_type=type_hints["dimension"])
            check_type(argname="argument dimension_var", value=dimension_var, expected_type=type_hints["dimension_var"])
            check_type(argname="argument equal", value=equal, expected_type=type_hints["equal"])
            check_type(argname="argument greater_than", value=greater_than, expected_type=type_hints["greater_than"])
            check_type(argname="argument less_than", value=less_than, expected_type=type_hints["less_than"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if dimension is not None:
            self._values["dimension"] = dimension
        if dimension_var is not None:
            self._values["dimension_var"] = dimension_var
        if equal is not None:
            self._values["equal"] = equal
        if greater_than is not None:
            self._values["greater_than"] = greater_than
        if less_than is not None:
            self._values["less_than"] = less_than
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionDefault"], result)

    @builtins.property
    def dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        '''
        result = self._values.get("dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        '''
        result = self._values.get("dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def equal(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionEqual"]:
        '''equal block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        '''
        result = self._values.get("equal")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionEqual"], result)

    @builtins.property
    def greater_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionGreaterThan"]:
        '''greater_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        '''
        result = self._values.get("greater_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionGreaterThan"], result)

    @builtins.property
    def less_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionLessThan"]:
        '''less_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        '''
        result = self._values.get("less_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionLessThan"], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimension(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5b09193adbf68b6ab884e95ff879534e30a54c10936c99955ba5a3208622cb2c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b7def33ee1d55c1a6cf910ddfb9c8489d3973fe55584475334be3d19aff73d3c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionEqual",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionEqual:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionEqual(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionEqualOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionEqualOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0382b82c571d6e3cb82bc80c27a1a04d50d5fa6b9a006558b1d33e779ef40af6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionEqual], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionEqual],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__04782993ec3f87278f4ce76addfa495984ca01f162859298397cc872c7dbd65b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionGreaterThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionGreaterThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionGreaterThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionGreaterThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionGreaterThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__28c1aabf0850104d8a194ffd1f84aee779f1cf3aa76e7f3e4d0cde3a1a69f2bd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionGreaterThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionGreaterThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f3dbb26105e533e4133c95425728e50a086691f497cecf7664ac1bec1d10ba84)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionLessThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionLessThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionLessThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionLessThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionLessThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__849e1cf18ed0fb49873684423b6f51e902714b403625c87eb1a63f51fdeee213)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionLessThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionLessThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__91483facb7f5cc3f4cbffcf6f60eb4ca9feb4fcddb19920bdd2daa7142e8bfa4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6c388a14b5b3fbea3f2067185301b5654de11ebc5e4e3db54e9ae2a33538393d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d637f1a2f90beeedfd0d94f2c79cfc691271072c74ce3a4e9e3b0ac69718f5e3)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1c00f904ba71c4594cc532e0866fb644773411805c12b64669671998a8439dda)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__511c01ee0626deae08261b373485fef46cd936bee52b305662ad2f9e9a9d726f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8728e7d24a77f37118d94aa483127273869b69ad23b1078ed8f791a12ca80f05)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimension]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimension]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__97b3d4ef86d89423ab7251c9143eabf5001c5f54bbd7cd6931cd10f1c9b8e54b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__55b7b18500f3ca1daca1fb3232d2ac9db4686313d5b2fd9a101b00e75aab3339)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putEqual")
    def put_equal(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionEqual()

        return typing.cast(None, jsii.invoke(self, "putEqual", [value]))

    @jsii.member(jsii_name="putGreaterThan")
    def put_greater_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionGreaterThan()

        return typing.cast(None, jsii.invoke(self, "putGreaterThan", [value]))

    @jsii.member(jsii_name="putLessThan")
    def put_less_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionLessThan()

        return typing.cast(None, jsii.invoke(self, "putLessThan", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetDimension")
    def reset_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimension", []))

    @jsii.member(jsii_name="resetDimensionVar")
    def reset_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimensionVar", []))

    @jsii.member(jsii_name="resetEqual")
    def reset_equal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEqual", []))

    @jsii.member(jsii_name="resetGreaterThan")
    def reset_greater_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGreaterThan", []))

    @jsii.member(jsii_name="resetLessThan")
    def reset_less_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLessThan", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="equal")
    def equal(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionEqualOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionEqualOutputReference, jsii.get(self, "equal"))

    @builtins.property
    @jsii.member(jsii_name="greaterThan")
    def greater_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionGreaterThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionGreaterThanOutputReference, jsii.get(self, "greaterThan"))

    @builtins.property
    @jsii.member(jsii_name="lessThan")
    def less_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionLessThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionLessThanOutputReference, jsii.get(self, "lessThan"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionInput")
    def dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionVarInput")
    def dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="equalInput")
    def equal_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionEqual], jsii.get(self, "equalInput"))

    @builtins.property
    @jsii.member(jsii_name="greaterThanInput")
    def greater_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionGreaterThan], jsii.get(self, "greaterThanInput"))

    @builtins.property
    @jsii.member(jsii_name="lessThanInput")
    def less_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionLessThan], jsii.get(self, "lessThanInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="dimension")
    def dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimension"))

    @dimension.setter
    def dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__583da33fabe0793b6a6bb2343e90005f6f7b0fb0680961c67956193ddc985cb9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimension", value)

    @builtins.property
    @jsii.member(jsii_name="dimensionVar")
    def dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimensionVar"))

    @dimension_var.setter
    def dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__165306ed26e9795ca3066b8fa556767ed99069e8b9d5c8ff378727fc3293daff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc63524e2ac9db178bb6aff6e5c457ac1d8035cb0b69017d38c2b1899bc23c4a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__70e84a14a0c22fd0ec020c6375998305ad42694a3f14dad00f80cdf7aac2d343)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimension]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimension]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimension]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df3208f24882396ee7ed9b5d9aa6161675ae31590b1f454cee2af109386d6415)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientation",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "landscape": "landscape",
        "portrait": "portrait",
        "square": "square",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientation:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        landscape: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationLandscape", typing.Dict[builtins.str, typing.Any]]] = None,
        portrait: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationPortrait", typing.Dict[builtins.str, typing.Any]]] = None,
        square: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationSquare", typing.Dict[builtins.str, typing.Any]]] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param landscape: landscape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        :param portrait: portrait block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        :param square: square block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationDefault(**default)
        if isinstance(landscape, dict):
            landscape = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationLandscape(**landscape)
        if isinstance(portrait, dict):
            portrait = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationPortrait(**portrait)
        if isinstance(square, dict):
            square = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationSquare(**square)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f66cddcc170cd5d5b0c4e770af9b4976c9ec5726175d3e13a7448cfa7f1bab5c)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument landscape", value=landscape, expected_type=type_hints["landscape"])
            check_type(argname="argument portrait", value=portrait, expected_type=type_hints["portrait"])
            check_type(argname="argument square", value=square, expected_type=type_hints["square"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if landscape is not None:
            self._values["landscape"] = landscape
        if portrait is not None:
            self._values["portrait"] = portrait
        if square is not None:
            self._values["square"] = square

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationDefault"], result)

    @builtins.property
    def landscape(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationLandscape"]:
        '''landscape block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        '''
        result = self._values.get("landscape")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationLandscape"], result)

    @builtins.property
    def portrait(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationPortrait"]:
        '''portrait block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        '''
        result = self._values.get("portrait")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationPortrait"], result)

    @builtins.property
    def square(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationSquare"]:
        '''square block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        result = self._values.get("square")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationSquare"], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8831a41984059ef81c2a405cc22bf81544d3b8457487bc0f158738bc4b49cf0c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__49cbc665c30a0f117531814c954d3ff92fe04e328ea35dbac743fe632c1f6735)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationLandscape",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationLandscape:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationLandscape(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationLandscapeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationLandscapeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df68d8123a96a3e5fd4864c93a83d071db376f53c869b083cc08fb9d94979da1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationLandscape], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationLandscape],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__98bb49db75a3b041c387a9ade2d972c481c4161e1a6a1f7f76d83092d614be8d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3f96cf876ef1b06ec860cf3aa4997a16cdb1037120056892d30bb79a254c5391)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8b80df736c1dbb318a64dcab29e0a03c2ed16339c2971f2870a4824b1331ff31)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__46ed1e82ce6faed0557ab2b0306935abe475f6cf65bd824b3ee295c1fb4a5dfb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea25668102d390122e7791d74091243c456b1e920f3a3ec1ae6426de50d43d7f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aaab604b73c0f0dcb50f072ccd28bef8baf876ec1516b180f90f50cb4795926d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientation]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientation]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fba8ebf961f5d190926d13020f5ce28c5de74f16c50ef04ca9fb12d34a01e19b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ce960e637584f14d48996abb37f10103a2ea319e6926f9aba1228159c45bef71)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putLandscape")
    def put_landscape(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationLandscape()

        return typing.cast(None, jsii.invoke(self, "putLandscape", [value]))

    @jsii.member(jsii_name="putPortrait")
    def put_portrait(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationPortrait()

        return typing.cast(None, jsii.invoke(self, "putPortrait", [value]))

    @jsii.member(jsii_name="putSquare")
    def put_square(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationSquare()

        return typing.cast(None, jsii.invoke(self, "putSquare", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetLandscape")
    def reset_landscape(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLandscape", []))

    @jsii.member(jsii_name="resetPortrait")
    def reset_portrait(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPortrait", []))

    @jsii.member(jsii_name="resetSquare")
    def reset_square(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSquare", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="landscape")
    def landscape(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationLandscapeOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationLandscapeOutputReference, jsii.get(self, "landscape"))

    @builtins.property
    @jsii.member(jsii_name="portrait")
    def portrait(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationPortraitOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationPortraitOutputReference", jsii.get(self, "portrait"))

    @builtins.property
    @jsii.member(jsii_name="square")
    def square(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationSquareOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationSquareOutputReference", jsii.get(self, "square"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="landscapeInput")
    def landscape_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationLandscape], jsii.get(self, "landscapeInput"))

    @builtins.property
    @jsii.member(jsii_name="portraitInput")
    def portrait_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationPortrait"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationPortrait"], jsii.get(self, "portraitInput"))

    @builtins.property
    @jsii.member(jsii_name="squareInput")
    def square_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationSquare"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationSquare"], jsii.get(self, "squareInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientation]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientation]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientation]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__08efa36d4ed1b8dda8039f52e0a7c48e85d7812487bd468ae48cdbe4f0757717)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationPortrait",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationPortrait:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationPortrait(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationPortraitOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationPortraitOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7dca517abc6c36cab101e6a295487775a9b367569e710a27bc1e90def5759552)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationPortrait]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationPortrait], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationPortrait],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3bc4c61d02e8dcf463d8c0ab3b6d94ecc1395162a6ff62d330e48d0524b3ec56)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationSquare",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationSquare:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationSquare(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationSquareOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationSquareOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e0d15ec7b53c2714aa3fa1859e3d9db29bed84d8a17d7d4e8a1791f8941676cc)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationSquare]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationSquare], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationSquare],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__81e148f59cedaeeb584ccd50311e5293e67dfcf9b082cea4a9a1416647b9dafd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultImQuery",
    jsii_struct_bases=[],
    name_mapping={
        "allowed_transformations": "allowedTransformations",
        "query_var": "queryVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultImQuery:
    def __init__(
        self,
        *,
        allowed_transformations: typing.Sequence[builtins.str],
        query_var: builtins.str,
    ) -> None:
        '''
        :param allowed_transformations: Specifies the transformations that can be applied using the query string parameter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allowed_transformations DataAkamaiImagingPolicyImage#allowed_transformations}
        :param query_var: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#query_var DataAkamaiImagingPolicyImage#query_var}.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6172b1ab778f545deed578a699eff819c8ad9afac70f33a339fc364280153de8)
            check_type(argname="argument allowed_transformations", value=allowed_transformations, expected_type=type_hints["allowed_transformations"])
            check_type(argname="argument query_var", value=query_var, expected_type=type_hints["query_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "allowed_transformations": allowed_transformations,
            "query_var": query_var,
        }

    @builtins.property
    def allowed_transformations(self) -> typing.List[builtins.str]:
        '''Specifies the transformations that can be applied using the query string parameter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allowed_transformations DataAkamaiImagingPolicyImage#allowed_transformations}
        '''
        result = self._values.get("allowed_transformations")
        assert result is not None, "Required property 'allowed_transformations' is missing"
        return typing.cast(typing.List[builtins.str], result)

    @builtins.property
    def query_var(self) -> builtins.str:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#query_var DataAkamaiImagingPolicyImage#query_var}.'''
        result = self._values.get("query_var")
        assert result is not None, "Required property 'query_var' is missing"
        return typing.cast(builtins.str, result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultImQuery(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultImQueryList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultImQueryList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__05398f0988d26fc4dbc9835604955377839593fc49f3540a78927abd3d7beddf)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultImQueryOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__49ba09293387edb8a2667380dfce01f8cd3832707d31c957d8d919bb38924d00)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultImQueryOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7a839a8449cf08e0a9cf10e9d596084addc30ac3a441aa10282f71c1683a693f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1c2f67d8a4277e24dbae2c2206482b750d0b260c0704cd525637fdbe65845d73)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2efaf84d9c30f19f47a014ac7556c44f1e9886369a204bee016b7f28d9b6b305)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultImQuery]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultImQuery]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultImQuery]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fc063b34b5db15996b32a5e4114d6680d15acd67c2a8d760543bafec9e095b9b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultImQueryOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultImQueryOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__948ce60f711663a10a7e8a8370290aad00cdd47cdc6bed0023a98231306cf059)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @builtins.property
    @jsii.member(jsii_name="allowedTransformationsInput")
    def allowed_transformations_input(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "allowedTransformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="queryVarInput")
    def query_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "queryVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowedTransformations")
    def allowed_transformations(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "allowedTransformations"))

    @allowed_transformations.setter
    def allowed_transformations(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__20ea8ceca9fd521f645e7193724e18349b1d258dbf79c7d18c678358eeccc98d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowedTransformations", value)

    @builtins.property
    @jsii.member(jsii_name="queryVar")
    def query_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "queryVar"))

    @query_var.setter
    def query_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ccebd45b8ec745ec228b38a1761b9bfe5fe30ae49d586edefe7a271e7a01cf0d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "queryVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultImQuery]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultImQuery]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultImQuery]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c71f0293df2e8089ad394181706478165b69a048e3adbb91761b426cd074c332)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultMaxColors",
    jsii_struct_bases=[],
    name_mapping={"colors": "colors", "colors_var": "colorsVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultMaxColors:
    def __init__(
        self,
        *,
        colors: typing.Optional[builtins.str] = None,
        colors_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param colors: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        :param colors_var: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d53e616c772a0f231c9724c394741bae8a61c1ab5a04a16931e9da32ced367f4)
            check_type(argname="argument colors", value=colors, expected_type=type_hints["colors"])
            check_type(argname="argument colors_var", value=colors_var, expected_type=type_hints["colors_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if colors is not None:
            self._values["colors"] = colors
        if colors_var is not None:
            self._values["colors_var"] = colors_var

    @builtins.property
    def colors(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        '''
        result = self._values.get("colors")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def colors_var(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        result = self._values.get("colors_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultMaxColors(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultMaxColorsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultMaxColorsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af787441dad27a771506e366a90e70bb9c6415545ccb9211f8848f36ac3817bb)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultMaxColorsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4e9f0ebc25f27d44a816d07a3c9c5dec6c65d225b0c38f2b50a9bcf2e05573a2)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultMaxColorsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__03d810c65c63e623e3f78b177a1ec8cca390b8a3b9d332a4b28f554b0218e345)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ff471cbe3529ab940c57711d072b59e9e01b3b30c343eda926cf66a4747d7a1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c41ee1d73677381308120c6f4b85c166c70f4e3961632d45acf3039fcecda544)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultMaxColors]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultMaxColors]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__92e8fefcc84b1ba4d56e3f51ed17347889446ce3e77e2d64c8d781d5b8229912)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultMaxColorsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultMaxColorsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__653c84ddf6f27698fa312b36e01c28c9aa7a38a9d771e1490e7036a35f0cb97d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColors")
    def reset_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColors", []))

    @jsii.member(jsii_name="resetColorsVar")
    def reset_colors_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorsVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorsInput")
    def colors_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsInput"))

    @builtins.property
    @jsii.member(jsii_name="colorsVarInput")
    def colors_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsVarInput"))

    @builtins.property
    @jsii.member(jsii_name="colors")
    def colors(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colors"))

    @colors.setter
    def colors(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__83763497cd206e37348ad8420ec1e2999fce8405e2e98a0e7a06b9a4a03f9059)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colors", value)

    @builtins.property
    @jsii.member(jsii_name="colorsVar")
    def colors_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorsVar"))

    @colors_var.setter
    def colors_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__77aacbde2eeaa5b882c0102b9a17c56ee75ca528e86611862f944f1e1be42a2f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorsVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultMaxColors]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultMaxColors]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultMaxColors]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e543539bd4c5537efdf8fdc61ab98a97b30b38fc927a81980ea3c288a450c16e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultMirror",
    jsii_struct_bases=[],
    name_mapping={
        "horizontal": "horizontal",
        "horizontal_var": "horizontalVar",
        "vertical": "vertical",
        "vertical_var": "verticalVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultMirror:
    def __init__(
        self,
        *,
        horizontal: typing.Optional[builtins.str] = None,
        horizontal_var: typing.Optional[builtins.str] = None,
        vertical: typing.Optional[builtins.str] = None,
        vertical_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param horizontal: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        :param horizontal_var: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        :param vertical: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        :param vertical_var: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__112894a0a3f3fe3dc6b8a181fe878bb1ebda3016fdfdc997350006440d3fdbb9)
            check_type(argname="argument horizontal", value=horizontal, expected_type=type_hints["horizontal"])
            check_type(argname="argument horizontal_var", value=horizontal_var, expected_type=type_hints["horizontal_var"])
            check_type(argname="argument vertical", value=vertical, expected_type=type_hints["vertical"])
            check_type(argname="argument vertical_var", value=vertical_var, expected_type=type_hints["vertical_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if horizontal is not None:
            self._values["horizontal"] = horizontal
        if horizontal_var is not None:
            self._values["horizontal_var"] = horizontal_var
        if vertical is not None:
            self._values["vertical"] = vertical
        if vertical_var is not None:
            self._values["vertical_var"] = vertical_var

    @builtins.property
    def horizontal(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        '''
        result = self._values.get("horizontal")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def horizontal_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        '''
        result = self._values.get("horizontal_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        '''
        result = self._values.get("vertical")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        result = self._values.get("vertical_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultMirror(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultMirrorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultMirrorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b10ef815bce28b8cd1cb59d9172e50d8fca6ba45c706f4e9057ddaf27dd60582)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultMirrorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d319837f541a8aed0856b2126c7b69292bd5da323e669d9df0e680d2a4a6848f)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultMirrorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c3be8e1078abcdc9f5a1725a5f62cef6655a59431cd35e2d740661ab27144982)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7096dcb57865da0e3239cfe9f055c9770e9f15f657b6dc832cca9983f1e8ffc4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__447466217e4bc59b2ea4e29557dff82e641f75ef6cfb5c8a9069e3e1310534a2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultMirror]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultMirror]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7908aa4380b9e28ef6629b1555958766c4eabed5f2e939e5b969e62a6428e3b5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultMirrorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultMirrorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__907a3284699cbe47dabf2c0a6655844d33bfcc69e43deb88942df52fc0fa08f3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHorizontal")
    def reset_horizontal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontal", []))

    @jsii.member(jsii_name="resetHorizontalVar")
    def reset_horizontal_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontalVar", []))

    @jsii.member(jsii_name="resetVertical")
    def reset_vertical(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVertical", []))

    @jsii.member(jsii_name="resetVerticalVar")
    def reset_vertical_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVerticalVar", []))

    @builtins.property
    @jsii.member(jsii_name="horizontalInput")
    def horizontal_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontalVarInput")
    def horizontal_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalInput")
    def vertical_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalVarInput")
    def vertical_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontal")
    def horizontal(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontal"))

    @horizontal.setter
    def horizontal(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3f29052d0a0a632f1bd1098a582d162b3582bb120815bfe709f8a81c5c97bee9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontal", value)

    @builtins.property
    @jsii.member(jsii_name="horizontalVar")
    def horizontal_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontalVar"))

    @horizontal_var.setter
    def horizontal_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d80041e91850b6f0c71e01cb67313b9c5e2e8a3336a9afdaec919b7cdb41060)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontalVar", value)

    @builtins.property
    @jsii.member(jsii_name="vertical")
    def vertical(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "vertical"))

    @vertical.setter
    def vertical(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5776746a8fec0a6fb834bf39d3760d5bec537019997f3646aa8d34da43151ae1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "vertical", value)

    @builtins.property
    @jsii.member(jsii_name="verticalVar")
    def vertical_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "verticalVar"))

    @vertical_var.setter
    def vertical_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2db2beb33088ca29be0da3aaf6dccec8ac444ccec771573fd1abeec020997554)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "verticalVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultMirror]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultMirror]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultMirror]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e6fd9d30d7d8e2856a94a0d4c04d648e507ecabebddd512c21f3e5e948a1646c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultMonoHue",
    jsii_struct_bases=[],
    name_mapping={"hue": "hue", "hue_var": "hueVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultMonoHue:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7347fa8863d5f224e0160abc90b0c13b8c35a736921de49d0cd593c366a2c8c8)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultMonoHue(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultMonoHueList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultMonoHueList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c799196f17d6548ff17f1bb5fec338fcf550dc1b11c2d8e4616bd7911bc66591)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultMonoHueOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__45f7436a20179fd4274f7c42c27528ac79dc6745c029d6cfd0f368fb427f67a0)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultMonoHueOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b751600bd246b842e04d51199fb87adc27a560a64ffc40b403c10278873d9ff0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__444e973d30289ce47e61d103c3c1a667c4e8a5dfc3ebbc24a073db1bfb68d7e9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e2404f816bce698b86cfb841d6d56c170fc58247d72265c7ee17b97e6279edb3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultMonoHue]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultMonoHue]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ec8b6cdcb19ad9111f06508dbed0dd830b13a6753b14210becd900f362b65eee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultMonoHueOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultMonoHueOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b3a50ef431a8acf24a3da258060d5ff430bb25f576b942937824a1886408db38)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f8eaf8bcbade5c5117072f39217aab0120bdd8afb6b5f9720a43182b43a632fa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2e04fcff391ed07d3fb2104c91cfda8876d170ffd5f41697d60a42204e2f1c3f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultMonoHue]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultMonoHue]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultMonoHue]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8bfd845fb15df89dc694e6bbbf92f130ae607c9761f18cef42446fbace517ed1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultOpacity",
    jsii_struct_bases=[],
    name_mapping={"opacity": "opacity", "opacity_var": "opacityVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultOpacity:
    def __init__(
        self,
        *,
        opacity: typing.Optional[builtins.str] = None,
        opacity_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param opacity: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param opacity_var: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a40e4ab22cf7c97eb76439fe306f90d9b01b0a279e486b611c090d59cf652dd5)
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument opacity_var", value=opacity_var, expected_type=type_hints["opacity_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if opacity is not None:
            self._values["opacity"] = opacity
        if opacity_var is not None:
            self._values["opacity_var"] = opacity_var

    @builtins.property
    def opacity(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def opacity_var(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        result = self._values.get("opacity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultOpacity(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultOpacityList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultOpacityList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__13c57bd35a4236f6d0f020669118129544710c7a59d5b80c7e88ceaa8d5864ba)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultOpacityOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__99155c1ebfcad885ce9edeacf3483772834497c1a7571834f6f21df4cc09172b)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultOpacityOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6fa6eb7812f48a742b7e1913b36b2a98fca49b1c2af95a77b3f6dd2864f9b751)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f6c053f2a67f3adf2de247aeef08014a979371aa2622be280f645c1d5d4cefc5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dbc4fa97389e742f1556f56909f196f750ecd013a41a0313148c15391d4807ae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultOpacity]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultOpacity]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d6e76c8fabccd6011ca9705cfa60ba305c6521bc5f7f1541b59ed950d177432)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultOpacityOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultOpacityOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9fba455fc1c1dc47948199a5d36d872971cc48e4a1f8e1689024306a5aba5bd9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetOpacityVar")
    def reset_opacity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacityVar", []))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityVarInput")
    def opacity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacity"))

    @opacity.setter
    def opacity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__45f6ed3e7d8ab4558318d44cf8fdd3bef73b12b745e1f168fe552eacfbdfd3d7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacity", value)

    @builtins.property
    @jsii.member(jsii_name="opacityVar")
    def opacity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacityVar"))

    @opacity_var.setter
    def opacity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3381cdd1fa7bac98d84ce32c4a754420e57452cda8c56e046e34f2da9c078cd4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacityVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultOpacity]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultOpacity]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultOpacity]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b9cbe1b79138ce11e23419d163765681f282c8c7ad8aa799410590f98659f3b2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea6176e1097143def891406a8a6317b59a2bcc8f4be4129c53b4ba4c9a747bb0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putAppend")
    def put_append(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultAppend, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ff7a5fc8261d2ad42c627b3e881900df80d6ab158cc262a499057242610de8b6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putAppend", [value]))

    @jsii.member(jsii_name="putAspectCrop")
    def put_aspect_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultAspectCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc099b4e4cdcc1ec174b6e4187dc0e443f8545a7db066cf612ba79b9f1f0516e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putAspectCrop", [value]))

    @jsii.member(jsii_name="putBackgroundColor")
    def put_background_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__46e7f5757769a2a6e28ffc786f1c095be5c810146a1348ede91511dad8edcfd0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBackgroundColor", [value]))

    @jsii.member(jsii_name="putBlur")
    def put_blur(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultBlur, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1a4f525606830b32e3e7a9ac532ea9128d59e3a35f19e5067a3872bdc0567459)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBlur", [value]))

    @jsii.member(jsii_name="putChromaKey")
    def put_chroma_key(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultChromaKey, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c625c04b0fdaaa6e970e2ef6e724c7e0b3798ce0ca37f7a9f26bca1fcbea85e9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putChromaKey", [value]))

    @jsii.member(jsii_name="putComposite")
    def put_composite(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultComposite, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__428400109b983ebeeeb2626792a3411d1a91fef7e8b43a5445fc39dfc1e9a52a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putComposite", [value]))

    @jsii.member(jsii_name="putCompound")
    def put_compound(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultCompound, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d12ba62e1d011315efdba2549abd8b68f3126b0bbfa4987075fc7dc7363fcfde)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCompound", [value]))

    @jsii.member(jsii_name="putContrast")
    def put_contrast(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultContrast, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f167c8cc83ac1753696ac33c22fb7a3162a0b9a5e3d3233d931559500196bf9b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putContrast", [value]))

    @jsii.member(jsii_name="putCrop")
    def put_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c0fba9be449c5cba70bc0a50ee59ecd70d01602dca2fda7496d2cb51f11ab38e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCrop", [value]))

    @jsii.member(jsii_name="putFaceCrop")
    def put_face_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultFaceCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b735f904e4a98586223af34d51f8e1747b72e0fa29c62d7698df6e8d3f25bc37)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFaceCrop", [value]))

    @jsii.member(jsii_name="putFeatureCrop")
    def put_feature_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultFeatureCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3506d3dcd08413ef1bf5cb382745395e5965c409c9cd95fba0c24ee08862d337)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFeatureCrop", [value]))

    @jsii.member(jsii_name="putFitAndFill")
    def put_fit_and_fill(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultFitAndFill, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__65c2c08fef63cdd784b6d06e564b7c39036172b185a4fa5057d50d03a23cc427)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFitAndFill", [value]))

    @jsii.member(jsii_name="putGoop")
    def put_goop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultGoop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__519deec959ef26c63de399f8eaf4a7276abf6b5e37029686ef3f3b0208be1700)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGoop", [value]))

    @jsii.member(jsii_name="putGrayscale")
    def put_grayscale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultGrayscale, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8340a75d97bb18e09a75b7bc5ec4fabba69ce6832c18a4064fba493a08d97bcf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGrayscale", [value]))

    @jsii.member(jsii_name="putHsl")
    def put_hsl(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultHsl, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__481e1229eaead4400aa213e8ab51147e50fbf1d1674faee2ede12051a1993dc8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsl", [value]))

    @jsii.member(jsii_name="putHsv")
    def put_hsv(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultHsv, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e8399063a598c7e458bfa1294a1805a2c00362378aee71324286818bd56d48a1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsv", [value]))

    @jsii.member(jsii_name="putIfDimension")
    def put_if_dimension(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimension, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__de668f64d758c646b882244eae372881e19189002cb3e16ceee73e415d6bb1e5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfDimension", [value]))

    @jsii.member(jsii_name="putIfOrientation")
    def put_if_orientation(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8574b5dff81ae9b1899f9f4b447d7c7065ff9e46ec18696dac31cfcfc9570268)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfOrientation", [value]))

    @jsii.member(jsii_name="putImQuery")
    def put_im_query(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultImQuery, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2c4310718454c3ca724d120cc1c59e3f72fbd7f58a6f5af379e47bf340298a01)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putImQuery", [value]))

    @jsii.member(jsii_name="putMaxColors")
    def put_max_colors(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultMaxColors, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__14809759725207fd54c239fcaaf0622e5def640f01b5cbfbe60256b32b3a345c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMaxColors", [value]))

    @jsii.member(jsii_name="putMirror")
    def put_mirror(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultMirror, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__21545951ae8b62ff53a6e240ee40c15477ebe9a85a7abf6b99f2fad0dc2578a4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMirror", [value]))

    @jsii.member(jsii_name="putMonoHue")
    def put_mono_hue(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultMonoHue, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d3c15ba9f68dd191d5eaf32ec14778f7290ae1261e68b1c920c2f0f2cfcc2d9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMonoHue", [value]))

    @jsii.member(jsii_name="putOpacity")
    def put_opacity(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultOpacity, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__75db1b7049f68764ddea4aafbc93820dc72058f223470e8e9458df3e6b49f04f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putOpacity", [value]))

    @jsii.member(jsii_name="putRegionOfInterestCrop")
    def put_region_of_interest_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultRegionOfInterestCrop", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1e7b67f9f144d72e5739961c7267823c69a4d5e33122f160f8412afdb9c0b901)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRegionOfInterestCrop", [value]))

    @jsii.member(jsii_name="putRelativeCrop")
    def put_relative_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultRelativeCrop", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7e04a70d3571a1f5f8df37982a245283034c4cca195a4061048f93d962c745e0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRelativeCrop", [value]))

    @jsii.member(jsii_name="putRemoveColor")
    def put_remove_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultRemoveColor", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aab2f63bb6d2c712e2e2109cf9c662a7a6edb38154e0a9c08519cdc48d22ddc5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRemoveColor", [value]))

    @jsii.member(jsii_name="putResize")
    def put_resize(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultResize", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__de22d484e506e74ec99f5c722b9c13dfb37c5079aec9bf952be7b353e9988565)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putResize", [value]))

    @jsii.member(jsii_name="putRotate")
    def put_rotate(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultRotate", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b3f3a5739470b1cd33e9fb8858c058a028ff97d2df0fcc2b77f4abe82d9f01ca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRotate", [value]))

    @jsii.member(jsii_name="putScale")
    def put_scale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultScale", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2bd7f255a1314671b53d37f73dd71968551fa105304c9327d75bc0c27b41f9eb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putScale", [value]))

    @jsii.member(jsii_name="putShear")
    def put_shear(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultShear", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f684776c081b29613085b0c163b7710b4a94d933efbe17510495709f1ae376b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putShear", [value]))

    @jsii.member(jsii_name="putTrim")
    def put_trim(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultTrim", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d88392416035a754d35cf649a42b69ee1d3f5a95c8d00b2874e230584718033)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTrim", [value]))

    @jsii.member(jsii_name="putUnsharpMask")
    def put_unsharp_mask(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultUnsharpMask", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__82d72e0dcda3dc137b589d4232b1ccc321ebf66976d69cff96a3bd252787a70a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putUnsharpMask", [value]))

    @jsii.member(jsii_name="resetAppend")
    def reset_append(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAppend", []))

    @jsii.member(jsii_name="resetAspectCrop")
    def reset_aspect_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspectCrop", []))

    @jsii.member(jsii_name="resetBackgroundColor")
    def reset_background_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBackgroundColor", []))

    @jsii.member(jsii_name="resetBlur")
    def reset_blur(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBlur", []))

    @jsii.member(jsii_name="resetChromaKey")
    def reset_chroma_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChromaKey", []))

    @jsii.member(jsii_name="resetComposite")
    def reset_composite(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetComposite", []))

    @jsii.member(jsii_name="resetCompound")
    def reset_compound(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCompound", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetCrop")
    def reset_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCrop", []))

    @jsii.member(jsii_name="resetFaceCrop")
    def reset_face_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFaceCrop", []))

    @jsii.member(jsii_name="resetFeatureCrop")
    def reset_feature_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureCrop", []))

    @jsii.member(jsii_name="resetFitAndFill")
    def reset_fit_and_fill(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFitAndFill", []))

    @jsii.member(jsii_name="resetGoop")
    def reset_goop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGoop", []))

    @jsii.member(jsii_name="resetGrayscale")
    def reset_grayscale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGrayscale", []))

    @jsii.member(jsii_name="resetHsl")
    def reset_hsl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsl", []))

    @jsii.member(jsii_name="resetHsv")
    def reset_hsv(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsv", []))

    @jsii.member(jsii_name="resetIfDimension")
    def reset_if_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfDimension", []))

    @jsii.member(jsii_name="resetIfOrientation")
    def reset_if_orientation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfOrientation", []))

    @jsii.member(jsii_name="resetImQuery")
    def reset_im_query(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetImQuery", []))

    @jsii.member(jsii_name="resetMaxColors")
    def reset_max_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxColors", []))

    @jsii.member(jsii_name="resetMirror")
    def reset_mirror(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMirror", []))

    @jsii.member(jsii_name="resetMonoHue")
    def reset_mono_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonoHue", []))

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetRegionOfInterestCrop")
    def reset_region_of_interest_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRegionOfInterestCrop", []))

    @jsii.member(jsii_name="resetRelativeCrop")
    def reset_relative_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRelativeCrop", []))

    @jsii.member(jsii_name="resetRemoveColor")
    def reset_remove_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRemoveColor", []))

    @jsii.member(jsii_name="resetResize")
    def reset_resize(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetResize", []))

    @jsii.member(jsii_name="resetRotate")
    def reset_rotate(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRotate", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetShear")
    def reset_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetShear", []))

    @jsii.member(jsii_name="resetTrim")
    def reset_trim(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTrim", []))

    @jsii.member(jsii_name="resetUnsharpMask")
    def reset_unsharp_mask(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUnsharpMask", []))

    @builtins.property
    @jsii.member(jsii_name="append")
    def append(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultAppendList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultAppendList, jsii.get(self, "append"))

    @builtins.property
    @jsii.member(jsii_name="aspectCrop")
    def aspect_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultAspectCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultAspectCropList, jsii.get(self, "aspectCrop"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColor")
    def background_color(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultBackgroundColorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultBackgroundColorList, jsii.get(self, "backgroundColor"))

    @builtins.property
    @jsii.member(jsii_name="blur")
    def blur(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultBlurList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultBlurList, jsii.get(self, "blur"))

    @builtins.property
    @jsii.member(jsii_name="chromaKey")
    def chroma_key(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultChromaKeyList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultChromaKeyList, jsii.get(self, "chromaKey"))

    @builtins.property
    @jsii.member(jsii_name="composite")
    def composite(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultCompositeList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultCompositeList, jsii.get(self, "composite"))

    @builtins.property
    @jsii.member(jsii_name="compound")
    def compound(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultCompoundList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultCompoundList, jsii.get(self, "compound"))

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultContrastList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultContrastList, jsii.get(self, "contrast"))

    @builtins.property
    @jsii.member(jsii_name="crop")
    def crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultCropList, jsii.get(self, "crop"))

    @builtins.property
    @jsii.member(jsii_name="faceCrop")
    def face_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultFaceCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultFaceCropList, jsii.get(self, "faceCrop"))

    @builtins.property
    @jsii.member(jsii_name="featureCrop")
    def feature_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultFeatureCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultFeatureCropList, jsii.get(self, "featureCrop"))

    @builtins.property
    @jsii.member(jsii_name="fitAndFill")
    def fit_and_fill(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultFitAndFillList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultFitAndFillList, jsii.get(self, "fitAndFill"))

    @builtins.property
    @jsii.member(jsii_name="goop")
    def goop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultGoopList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultGoopList, jsii.get(self, "goop"))

    @builtins.property
    @jsii.member(jsii_name="grayscale")
    def grayscale(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultGrayscaleList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultGrayscaleList, jsii.get(self, "grayscale"))

    @builtins.property
    @jsii.member(jsii_name="hsl")
    def hsl(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultHslList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultHslList, jsii.get(self, "hsl"))

    @builtins.property
    @jsii.member(jsii_name="hsv")
    def hsv(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultHsvList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultHsvList, jsii.get(self, "hsv"))

    @builtins.property
    @jsii.member(jsii_name="ifDimension")
    def if_dimension(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionList, jsii.get(self, "ifDimension"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientation")
    def if_orientation(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationList, jsii.get(self, "ifOrientation"))

    @builtins.property
    @jsii.member(jsii_name="imQuery")
    def im_query(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultImQueryList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultImQueryList, jsii.get(self, "imQuery"))

    @builtins.property
    @jsii.member(jsii_name="maxColors")
    def max_colors(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultMaxColorsList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultMaxColorsList, jsii.get(self, "maxColors"))

    @builtins.property
    @jsii.member(jsii_name="mirror")
    def mirror(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultMirrorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultMirrorList, jsii.get(self, "mirror"))

    @builtins.property
    @jsii.member(jsii_name="monoHue")
    def mono_hue(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultMonoHueList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultMonoHueList, jsii.get(self, "monoHue"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultOpacityList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultOpacityList, jsii.get(self, "opacity"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestCrop")
    def region_of_interest_crop(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultRegionOfInterestCropList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultRegionOfInterestCropList", jsii.get(self, "regionOfInterestCrop"))

    @builtins.property
    @jsii.member(jsii_name="relativeCrop")
    def relative_crop(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultRelativeCropList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultRelativeCropList", jsii.get(self, "relativeCrop"))

    @builtins.property
    @jsii.member(jsii_name="removeColor")
    def remove_color(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultRemoveColorList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultRemoveColorList", jsii.get(self, "removeColor"))

    @builtins.property
    @jsii.member(jsii_name="resize")
    def resize(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultResizeList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultResizeList", jsii.get(self, "resize"))

    @builtins.property
    @jsii.member(jsii_name="rotate")
    def rotate(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultRotateList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultRotateList", jsii.get(self, "rotate"))

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultScaleList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultScaleList", jsii.get(self, "scale"))

    @builtins.property
    @jsii.member(jsii_name="shear")
    def shear(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultShearList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultShearList", jsii.get(self, "shear"))

    @builtins.property
    @jsii.member(jsii_name="trim")
    def trim(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultTrimList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultTrimList", jsii.get(self, "trim"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMask")
    def unsharp_mask(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultUnsharpMaskList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultUnsharpMaskList", jsii.get(self, "unsharpMask"))

    @builtins.property
    @jsii.member(jsii_name="appendInput")
    def append_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultAppend]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultAppend]]], jsii.get(self, "appendInput"))

    @builtins.property
    @jsii.member(jsii_name="aspectCropInput")
    def aspect_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultAspectCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultAspectCrop]]], jsii.get(self, "aspectCropInput"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColorInput")
    def background_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultBackgroundColor]]], jsii.get(self, "backgroundColorInput"))

    @builtins.property
    @jsii.member(jsii_name="blurInput")
    def blur_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultBlur]]], jsii.get(self, "blurInput"))

    @builtins.property
    @jsii.member(jsii_name="chromaKeyInput")
    def chroma_key_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultChromaKey]]], jsii.get(self, "chromaKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="compositeInput")
    def composite_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultComposite]]], jsii.get(self, "compositeInput"))

    @builtins.property
    @jsii.member(jsii_name="compoundInput")
    def compound_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultCompound]]], jsii.get(self, "compoundInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultContrast]]], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="cropInput")
    def crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultCrop]]], jsii.get(self, "cropInput"))

    @builtins.property
    @jsii.member(jsii_name="faceCropInput")
    def face_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultFaceCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultFaceCrop]]], jsii.get(self, "faceCropInput"))

    @builtins.property
    @jsii.member(jsii_name="featureCropInput")
    def feature_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultFeatureCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultFeatureCrop]]], jsii.get(self, "featureCropInput"))

    @builtins.property
    @jsii.member(jsii_name="fitAndFillInput")
    def fit_and_fill_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultFitAndFill]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultFitAndFill]]], jsii.get(self, "fitAndFillInput"))

    @builtins.property
    @jsii.member(jsii_name="goopInput")
    def goop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultGoop]]], jsii.get(self, "goopInput"))

    @builtins.property
    @jsii.member(jsii_name="grayscaleInput")
    def grayscale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultGrayscale]]], jsii.get(self, "grayscaleInput"))

    @builtins.property
    @jsii.member(jsii_name="hslInput")
    def hsl_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultHsl]]], jsii.get(self, "hslInput"))

    @builtins.property
    @jsii.member(jsii_name="hsvInput")
    def hsv_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultHsv]]], jsii.get(self, "hsvInput"))

    @builtins.property
    @jsii.member(jsii_name="ifDimensionInput")
    def if_dimension_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimension]]], jsii.get(self, "ifDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientationInput")
    def if_orientation_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientation]]], jsii.get(self, "ifOrientationInput"))

    @builtins.property
    @jsii.member(jsii_name="imQueryInput")
    def im_query_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultImQuery]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultImQuery]]], jsii.get(self, "imQueryInput"))

    @builtins.property
    @jsii.member(jsii_name="maxColorsInput")
    def max_colors_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultMaxColors]]], jsii.get(self, "maxColorsInput"))

    @builtins.property
    @jsii.member(jsii_name="mirrorInput")
    def mirror_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultMirror]]], jsii.get(self, "mirrorInput"))

    @builtins.property
    @jsii.member(jsii_name="monoHueInput")
    def mono_hue_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultMonoHue]]], jsii.get(self, "monoHueInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultOpacity]]], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestCropInput")
    def region_of_interest_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultRegionOfInterestCrop"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultRegionOfInterestCrop"]]], jsii.get(self, "regionOfInterestCropInput"))

    @builtins.property
    @jsii.member(jsii_name="relativeCropInput")
    def relative_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultRelativeCrop"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultRelativeCrop"]]], jsii.get(self, "relativeCropInput"))

    @builtins.property
    @jsii.member(jsii_name="removeColorInput")
    def remove_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultRemoveColor"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultRemoveColor"]]], jsii.get(self, "removeColorInput"))

    @builtins.property
    @jsii.member(jsii_name="resizeInput")
    def resize_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultResize"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultResize"]]], jsii.get(self, "resizeInput"))

    @builtins.property
    @jsii.member(jsii_name="rotateInput")
    def rotate_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultRotate"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultRotate"]]], jsii.get(self, "rotateInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultScale"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultScale"]]], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="shearInput")
    def shear_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultShear"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultShear"]]], jsii.get(self, "shearInput"))

    @builtins.property
    @jsii.member(jsii_name="trimInput")
    def trim_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultTrim"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultTrim"]]], jsii.get(self, "trimInput"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMaskInput")
    def unsharp_mask_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultUnsharpMask"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultUnsharpMask"]]], jsii.get(self, "unsharpMaskInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2217d94cb82de56ac216a51b484878c42e5aa3ed7f2bd91144c58d7f4de6ea11)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultRegionOfInterestCrop",
    jsii_struct_bases=[],
    name_mapping={
        "region_of_interest": "regionOfInterest",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultRegionOfInterestCrop:
    def __init__(
        self,
        *,
        region_of_interest: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultRegionOfInterestCropRegionOfInterest", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param region_of_interest: region_of_interest block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest DataAkamaiImagingPolicyImage#region_of_interest}
        :param gravity: The placement of the crop area relative to the specified area of interest. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: The placement of the crop area relative to the specified area of interest. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param style: Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(region_of_interest, dict):
            region_of_interest = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultRegionOfInterestCropRegionOfInterest(**region_of_interest)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8c290ed1ab1424731f72e0388627e07bc116b14290b4ebc1e0d9e4bc4428dcea)
            check_type(argname="argument region_of_interest", value=region_of_interest, expected_type=type_hints["region_of_interest"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "region_of_interest": region_of_interest,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def region_of_interest(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultRegionOfInterestCropRegionOfInterest":
        '''region_of_interest block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest DataAkamaiImagingPolicyImage#region_of_interest}
        '''
        result = self._values.get("region_of_interest")
        assert result is not None, "Required property 'region_of_interest' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultRegionOfInterestCropRegionOfInterest", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''The placement of the crop area relative to the specified area of interest.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''The placement of the crop area relative to the specified area of interest.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultRegionOfInterestCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultRegionOfInterestCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultRegionOfInterestCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b685e1fe18ca729faed6bcb78a4d0a4a7c2823fb1b50b5c0f6774b4371321209)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultRegionOfInterestCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e6e9b9e41c403341b6f9b7e6113d616d3b46ec83d6a580f7a96adc13d719e040)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultRegionOfInterestCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a19d4bbe25fa528488e42bec9f9e5e390f085af90e296565b18331141b29540c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__78e4c161cd98f62409613266463691e604acc8fadb27e184f49145f845dd2df2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be069d092901fadd085312bef520e44e6750fcf96bcddd9f59c869f9f762db23)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultRegionOfInterestCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultRegionOfInterestCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultRegionOfInterestCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d8cc34b0f63b86ef149c6ad43f6559c0261adc04e23533f953458f2fcde58215)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultRegionOfInterestCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultRegionOfInterestCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0a5d538b50bd0c8c95dccda5228a47054ec130a7978b185f618d35a87af1af30)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putRegionOfInterest")
    def put_region_of_interest(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultRegionOfInterestCropRegionOfInterest()

        return typing.cast(None, jsii.invoke(self, "putRegionOfInterest", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterest")
    def region_of_interest(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultRegionOfInterestCropRegionOfInterestOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultRegionOfInterestCropRegionOfInterestOutputReference", jsii.get(self, "regionOfInterest"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestInput")
    def region_of_interest_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultRegionOfInterestCropRegionOfInterest"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultRegionOfInterestCropRegionOfInterest"], jsii.get(self, "regionOfInterestInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3739fd42224e148e32c2561f7617c0c55138fd13c7658bc1ea1e313a597e993f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9e3fee7fa82e8cc7a5c4a00b0463569a7695277fd83bbdacfd05a6e4a187e069)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__69076b5d5c94baff0a5d3dd843dc6ca3a72a4cf1580a5aa45109f5b726d2075e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__49b8bc7c0fa759c2b41102e40aba175533cac0d228132ed64c3d9bf60eac2226)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__79b133e967647cddf00fc5b4377de40b1cd22b7d68712acce128930b37d69b95)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7aeba087cd0b17db16443bf2d11772c1b38ad901c661f746e87d2cd81f3ece9d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__81e0c99598018954ee44373504b5d9729f0672a78046225b99f5c7a568ea14f2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__948151d319faf9306a6d235ed3fe7af33a2fff319479b3b2c94231ec0acc08e8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultRegionOfInterestCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultRegionOfInterestCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultRegionOfInterestCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__709ec323556db1d590cb1cee5fe47b6b4b162e080f6588d8aa1bffc1ad792f59)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultRegionOfInterestCropRegionOfInterest",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultRegionOfInterestCropRegionOfInterest:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultRegionOfInterestCropRegionOfInterest(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultRegionOfInterestCropRegionOfInterestOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultRegionOfInterestCropRegionOfInterestOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__81956ff451e6bc164a3f0be3eb186f6735006db7c0a2eafbb515865f23da9b3d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultRegionOfInterestCropRegionOfInterest]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultRegionOfInterestCropRegionOfInterest], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultRegionOfInterestCropRegionOfInterest],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f859736a4d5c1fad87dd257e6778e4ce405ac8aa1e39eafa200ca047af05c0ee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultRelativeCrop",
    jsii_struct_bases=[],
    name_mapping={
        "east": "east",
        "east_var": "eastVar",
        "north": "north",
        "north_var": "northVar",
        "south": "south",
        "south_var": "southVar",
        "west": "west",
        "west_var": "westVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultRelativeCrop:
    def __init__(
        self,
        *,
        east: typing.Optional[builtins.str] = None,
        east_var: typing.Optional[builtins.str] = None,
        north: typing.Optional[builtins.str] = None,
        north_var: typing.Optional[builtins.str] = None,
        south: typing.Optional[builtins.str] = None,
        south_var: typing.Optional[builtins.str] = None,
        west: typing.Optional[builtins.str] = None,
        west_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param east: The number of pixels to shrink or expand the right side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east DataAkamaiImagingPolicyImage#east}
        :param east_var: The number of pixels to shrink or expand the right side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east_var DataAkamaiImagingPolicyImage#east_var}
        :param north: The number of pixels to shrink or expand the top side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north DataAkamaiImagingPolicyImage#north}
        :param north_var: The number of pixels to shrink or expand the top side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north_var DataAkamaiImagingPolicyImage#north_var}
        :param south: The number of pixels to shrink or expand the bottom side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south DataAkamaiImagingPolicyImage#south}
        :param south_var: The number of pixels to shrink or expand the bottom side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south_var DataAkamaiImagingPolicyImage#south_var}
        :param west: The number of pixels to shrink or expand the left side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west DataAkamaiImagingPolicyImage#west}
        :param west_var: The number of pixels to shrink or expand the left side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west_var DataAkamaiImagingPolicyImage#west_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ed1b54a7ee6a4e941a3bdac190ca9d89f98704d2f8250b19b7453f8d5c48e45)
            check_type(argname="argument east", value=east, expected_type=type_hints["east"])
            check_type(argname="argument east_var", value=east_var, expected_type=type_hints["east_var"])
            check_type(argname="argument north", value=north, expected_type=type_hints["north"])
            check_type(argname="argument north_var", value=north_var, expected_type=type_hints["north_var"])
            check_type(argname="argument south", value=south, expected_type=type_hints["south"])
            check_type(argname="argument south_var", value=south_var, expected_type=type_hints["south_var"])
            check_type(argname="argument west", value=west, expected_type=type_hints["west"])
            check_type(argname="argument west_var", value=west_var, expected_type=type_hints["west_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if east is not None:
            self._values["east"] = east
        if east_var is not None:
            self._values["east_var"] = east_var
        if north is not None:
            self._values["north"] = north
        if north_var is not None:
            self._values["north_var"] = north_var
        if south is not None:
            self._values["south"] = south
        if south_var is not None:
            self._values["south_var"] = south_var
        if west is not None:
            self._values["west"] = west
        if west_var is not None:
            self._values["west_var"] = west_var

    @builtins.property
    def east(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the right side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east DataAkamaiImagingPolicyImage#east}
        '''
        result = self._values.get("east")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def east_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the right side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east_var DataAkamaiImagingPolicyImage#east_var}
        '''
        result = self._values.get("east_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def north(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the top side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north DataAkamaiImagingPolicyImage#north}
        '''
        result = self._values.get("north")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def north_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the top side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north_var DataAkamaiImagingPolicyImage#north_var}
        '''
        result = self._values.get("north_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def south(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the bottom side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south DataAkamaiImagingPolicyImage#south}
        '''
        result = self._values.get("south")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def south_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the bottom side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south_var DataAkamaiImagingPolicyImage#south_var}
        '''
        result = self._values.get("south_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def west(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the left side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west DataAkamaiImagingPolicyImage#west}
        '''
        result = self._values.get("west")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def west_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the left side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west_var DataAkamaiImagingPolicyImage#west_var}
        '''
        result = self._values.get("west_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultRelativeCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultRelativeCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultRelativeCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c3ad04df58c9df6dc84166aa96e0ac4b8f299dbc30f398f90445f70e78afa130)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultRelativeCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9239b33a0ac3ee494f10e0bb39cecfa215693fc122e576d60e9189057c3d7261)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultRelativeCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__934d4143df79e1a8620fe12ff33ef83eff6e5ff49a9f4bc1431c49be206ca0d8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__046440c04da5efa471e34b1675a28934dc3f368d787660172ed7f1041469d611)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__088089882b6c4d366de1f2a3ec55697ad5302d7d6773350ffe0890eb9eacf51c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultRelativeCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultRelativeCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultRelativeCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a6263dd2af3ceb616efb28ba1135a650c64abc5fae1d7ff4b616b3a9a3951c7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultRelativeCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultRelativeCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__270237c2118002dc91cd495d031e116813cb9978cd748c2b2140503da67211d0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetEast")
    def reset_east(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEast", []))

    @jsii.member(jsii_name="resetEastVar")
    def reset_east_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEastVar", []))

    @jsii.member(jsii_name="resetNorth")
    def reset_north(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNorth", []))

    @jsii.member(jsii_name="resetNorthVar")
    def reset_north_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNorthVar", []))

    @jsii.member(jsii_name="resetSouth")
    def reset_south(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSouth", []))

    @jsii.member(jsii_name="resetSouthVar")
    def reset_south_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSouthVar", []))

    @jsii.member(jsii_name="resetWest")
    def reset_west(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWest", []))

    @jsii.member(jsii_name="resetWestVar")
    def reset_west_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWestVar", []))

    @builtins.property
    @jsii.member(jsii_name="eastInput")
    def east_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "eastInput"))

    @builtins.property
    @jsii.member(jsii_name="eastVarInput")
    def east_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "eastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="northInput")
    def north_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "northInput"))

    @builtins.property
    @jsii.member(jsii_name="northVarInput")
    def north_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "northVarInput"))

    @builtins.property
    @jsii.member(jsii_name="southInput")
    def south_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "southInput"))

    @builtins.property
    @jsii.member(jsii_name="southVarInput")
    def south_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "southVarInput"))

    @builtins.property
    @jsii.member(jsii_name="westInput")
    def west_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "westInput"))

    @builtins.property
    @jsii.member(jsii_name="westVarInput")
    def west_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "westVarInput"))

    @builtins.property
    @jsii.member(jsii_name="east")
    def east(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "east"))

    @east.setter
    def east(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea790bc1c961d6a48ef60f2318c75934d9eba03160e496de6a40c10ecab00f7a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "east", value)

    @builtins.property
    @jsii.member(jsii_name="eastVar")
    def east_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "eastVar"))

    @east_var.setter
    def east_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__abec31b52fdb97625b6f68a07d0b7a91e94cbf5f6fb21f6db17f0e7011301740)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "eastVar", value)

    @builtins.property
    @jsii.member(jsii_name="north")
    def north(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "north"))

    @north.setter
    def north(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__74098f7c34c92a422261530dd40fd387d34e5b784fe19223193d615dea7399c8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "north", value)

    @builtins.property
    @jsii.member(jsii_name="northVar")
    def north_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "northVar"))

    @north_var.setter
    def north_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e8ba6219b78908139bfce40d58867bf7d70c037e60cf9ea98ea3c0880651f84b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "northVar", value)

    @builtins.property
    @jsii.member(jsii_name="south")
    def south(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "south"))

    @south.setter
    def south(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__99998c236226718034fedab80efd2dc5e57b02fff789f663cf3560cff39463da)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "south", value)

    @builtins.property
    @jsii.member(jsii_name="southVar")
    def south_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "southVar"))

    @south_var.setter
    def south_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2dcb0e3225c5ad8c6c2d549b258b94aa9471b562fcb89d895b9d0e4dba8fd945)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "southVar", value)

    @builtins.property
    @jsii.member(jsii_name="west")
    def west(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "west"))

    @west.setter
    def west(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d7a6c11ec6131248969556fced2f641fd401452f8bb9267b2dd611e1350aaec4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "west", value)

    @builtins.property
    @jsii.member(jsii_name="westVar")
    def west_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "westVar"))

    @west_var.setter
    def west_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa39951bda996523c11cbc97ee46e259fd695eb9e99a9dd26e5eafb6a238e464)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "westVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultRelativeCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultRelativeCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultRelativeCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8d9290e20051218e6ce20b2099f0b461facbc620cfd1ecfce0d07e6bd9cd0a40)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultRemoveColor",
    jsii_struct_bases=[],
    name_mapping={
        "color": "color",
        "color_var": "colorVar",
        "feather": "feather",
        "feather_var": "featherVar",
        "tolerance": "tolerance",
        "tolerance_var": "toleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultRemoveColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
        feather: typing.Optional[builtins.str] = None,
        feather_var: typing.Optional[builtins.str] = None,
        tolerance: typing.Optional[builtins.str] = None,
        tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        :param feather: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        :param feather_var: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        :param tolerance: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        :param tolerance_var: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4d007f07c32db62e781315efeedf5b47a35b91f7ff80da2e916f5e234b35e60e)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
            check_type(argname="argument feather", value=feather, expected_type=type_hints["feather"])
            check_type(argname="argument feather_var", value=feather_var, expected_type=type_hints["feather_var"])
            check_type(argname="argument tolerance", value=tolerance, expected_type=type_hints["tolerance"])
            check_type(argname="argument tolerance_var", value=tolerance_var, expected_type=type_hints["tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var
        if feather is not None:
            self._values["feather"] = feather
        if feather_var is not None:
            self._values["feather_var"] = feather_var
        if tolerance is not None:
            self._values["tolerance"] = tolerance
        if tolerance_var is not None:
            self._values["tolerance_var"] = tolerance_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        '''
        result = self._values.get("feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather_var(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        '''
        result = self._values.get("feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        '''
        result = self._values.get("tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance_var(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        result = self._values.get("tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultRemoveColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultRemoveColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultRemoveColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e1f38b9673c06a4b288c44ca20935136cdb2cd1dc04d2d8532f25e3e5aa71227)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultRemoveColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a0fcc5a12ae46301dc3602588ec24f552ae4f858103b4260d634ca95d60ca96)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultRemoveColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1dee4a91848dbca39bf3e8b128a0f73790c37997304a0c65090968a8e1c1afb3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7682357291b5fb2e758f86593292b9006c89c5adcc751133971fa2d4b73e80ed)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ae0a8d9eab045441e706b9edeed6218406acaf87653900c29d7d8c1e10710c9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultRemoveColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultRemoveColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultRemoveColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__912050674631ce40f26e4b63b81aed157bba0c35305f735f31b8481cb3e7bc2a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultRemoveColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultRemoveColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e264ba637342aab4402990b89342c4a963c268ffe2b4955b969475fcb4aa5629)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @jsii.member(jsii_name="resetFeather")
    def reset_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeather", []))

    @jsii.member(jsii_name="resetFeatherVar")
    def reset_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatherVar", []))

    @jsii.member(jsii_name="resetTolerance")
    def reset_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTolerance", []))

    @jsii.member(jsii_name="resetToleranceVar")
    def reset_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featherInput")
    def feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherInput"))

    @builtins.property
    @jsii.member(jsii_name="featherVarInput")
    def feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceInput")
    def tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceVarInput")
    def tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d98b0b2ea12ff95752cdacca503288017c13171565cec3ad53d2785e276a93f5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d4d26132acc8a66f2134585829d6cbc9f0c62bd6518aaa647b17a5b812d698a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="feather")
    def feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "feather"))

    @feather.setter
    def feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f112102c3d9691a9e9cf4bdbda2eae5aa73de74fd554617fcc9fee59b8f6d96)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "feather", value)

    @builtins.property
    @jsii.member(jsii_name="featherVar")
    def feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featherVar"))

    @feather_var.setter
    def feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0006d9b25025fd8b2fe9864bb566fc944c61f98af7026a01c20120911b08cd22)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featherVar", value)

    @builtins.property
    @jsii.member(jsii_name="tolerance")
    def tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tolerance"))

    @tolerance.setter
    def tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__abce91cbbbc3c610dd83ebaac5f4043600ea9c83e69b225edaae03ab3b5f6b43)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tolerance", value)

    @builtins.property
    @jsii.member(jsii_name="toleranceVar")
    def tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "toleranceVar"))

    @tolerance_var.setter
    def tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aa28d4d79f264474cbe762b730b4813ecfbe16a2baa9223969cdf766367e0543)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "toleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultRemoveColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultRemoveColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultRemoveColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a5e4b5b849e2b7a53d7e442bd5ec2362adaf15415c26964828888ea3def6089c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultResize",
    jsii_struct_bases=[],
    name_mapping={
        "aspect": "aspect",
        "aspect_var": "aspectVar",
        "height": "height",
        "height_var": "heightVar",
        "type": "type",
        "type_var": "typeVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultResize:
    def __init__(
        self,
        *,
        aspect: typing.Optional[builtins.str] = None,
        aspect_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param aspect: Preserves the aspect ratio. Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect DataAkamaiImagingPolicyImage#aspect}
        :param aspect_var: Preserves the aspect ratio. Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_var DataAkamaiImagingPolicyImage#aspect_var}
        :param height: The height to resize the source image to. Must be set if height is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height to resize the source image to. Must be set if height is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param type: Sets constraints for the image resize. Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: Sets constraints for the image resize. Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        :param width: The width to resize the source image to. Must be set if width is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width to resize the source image to. Must be set if width is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__24c3d5caa261c7fb43024a871f1f30d14868908c7fb16b0a98acfe02c34fb77a)
            check_type(argname="argument aspect", value=aspect, expected_type=type_hints["aspect"])
            check_type(argname="argument aspect_var", value=aspect_var, expected_type=type_hints["aspect_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if aspect is not None:
            self._values["aspect"] = aspect
        if aspect_var is not None:
            self._values["aspect_var"] = aspect_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def aspect(self) -> typing.Optional[builtins.str]:
        '''Preserves the aspect ratio.

        Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect DataAkamaiImagingPolicyImage#aspect}
        '''
        result = self._values.get("aspect")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def aspect_var(self) -> typing.Optional[builtins.str]:
        '''Preserves the aspect ratio.

        Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_var DataAkamaiImagingPolicyImage#aspect_var}
        '''
        result = self._values.get("aspect_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height to resize the source image to. Must be set if height is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height to resize the source image to. Must be set if height is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''Sets constraints for the image resize.

        Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''Sets constraints for the image resize.

        Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width to resize the source image to. Must be set if width is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width to resize the source image to. Must be set if width is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultResize(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultResizeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultResizeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f3d4559fec583c3f3651c9a3826cd496d2b274e9cf243ddf223158a83ff942fa)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultResizeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__068b0fc9e0d2cefdbbc8493bcf97cb5fd21891322a93f52b111b5c6f5a30b9fa)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultResizeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c335df3a265f1d993805a63354fe83c1b00c436de9a424ada04010a414f49f2c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1061182bc007b34a573cf1d25356c254d5f539a6e5dc1c901f7e0a1675ef7e51)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e9451206c74fb31a5583df4418ddb0e41d6f12747d5c27a1610d0910a10d5d08)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultResize]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultResize]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultResize]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a0b930ab63c6f8e53c75bc0a80672e6571f77fbf9880d961be411fd76ea65d7f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultResizeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultResizeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__11a42caf81f97c5554e29eb405b9fd1f2323cc8f908a0d0d4adf983bfcebabd5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAspect")
    def reset_aspect(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspect", []))

    @jsii.member(jsii_name="resetAspectVar")
    def reset_aspect_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspectVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="aspectInput")
    def aspect_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "aspectInput"))

    @builtins.property
    @jsii.member(jsii_name="aspectVarInput")
    def aspect_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "aspectVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="aspect")
    def aspect(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "aspect"))

    @aspect.setter
    def aspect(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ed9df1ad63edd14c8cb562c0a6b0b4343c476d56522cc1c4efcbe0c19b8e3abf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "aspect", value)

    @builtins.property
    @jsii.member(jsii_name="aspectVar")
    def aspect_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "aspectVar"))

    @aspect_var.setter
    def aspect_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0c4d7c6fbba31b207c32bbe05c99f821a640a903034154c528424ad62a440112)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "aspectVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2db101da05453d30a91e2725771225e3dabb14166dffd8fe561e87a16f5d5860)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3257375cfb62a58d9e3b4228671a1acb893e4d29887863c7f584faa000fe9b18)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aebc2774d4f5a83e6efd66ae1ffadd28c170be840e8ed88970c07b9545bb54f5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0dd370d9e418c034d3c5636549de1d0e3cac3acc35c40fd75bc55547f972c183)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3f187cd7e022e2719afe50b8e33c2062206f4baaad20ca5f3c711621590ec69c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__881d6a3307eae7a2f896270e2b036f537f01053a3da96ce71745ba1bea12c58c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultResize]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultResize]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultResize]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cb5c7903c24eb9ea07d6829ea5234576de36a58f186f06a9489d85190682afa2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultRotate",
    jsii_struct_bases=[],
    name_mapping={"degrees": "degrees", "degrees_var": "degreesVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultRotate:
    def __init__(
        self,
        *,
        degrees: typing.Optional[builtins.str] = None,
        degrees_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param degrees: The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees DataAkamaiImagingPolicyImage#degrees}
        :param degrees_var: The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees_var DataAkamaiImagingPolicyImage#degrees_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__135dbc29326ef219c6b0e37871f835d5588a4b904cd47fb04a3a51221c4e9613)
            check_type(argname="argument degrees", value=degrees, expected_type=type_hints["degrees"])
            check_type(argname="argument degrees_var", value=degrees_var, expected_type=type_hints["degrees_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if degrees is not None:
            self._values["degrees"] = degrees
        if degrees_var is not None:
            self._values["degrees_var"] = degrees_var

    @builtins.property
    def degrees(self) -> typing.Optional[builtins.str]:
        '''The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees DataAkamaiImagingPolicyImage#degrees}
        '''
        result = self._values.get("degrees")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def degrees_var(self) -> typing.Optional[builtins.str]:
        '''The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees_var DataAkamaiImagingPolicyImage#degrees_var}
        '''
        result = self._values.get("degrees_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultRotate(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultRotateList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultRotateList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4e2a2987dcc3aaeeab01943fd56ac7e6163b4290d2f86744992d14dafd7b4c4f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultRotateOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4c5c53659c52adc65321560c94f9f900a89d033b8d3c55995ed932d9a3e542f4)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultRotateOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a2bc92f4567bc1b07fe574b7669a2acf40ac08b58f0b7aaf96cf9c86e535654)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__26a85aa79a737c0f20943cdccf71180166dc7a9e2e21d4dba61a179d5b53c827)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__81bad3ea9c97cc308496a32719d23f02dbc527b2d5287f2e6fc2875522265bb0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultRotate]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultRotate]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultRotate]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e783ebbd815ea6918312a7b57bd522394833666f70b4757a893a186bacca56d6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultRotateOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultRotateOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__195fdc8816a4dafba20c0937dda055890e8577483b3122d982e2a88cf32e1276)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetDegrees")
    def reset_degrees(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDegrees", []))

    @jsii.member(jsii_name="resetDegreesVar")
    def reset_degrees_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDegreesVar", []))

    @builtins.property
    @jsii.member(jsii_name="degreesInput")
    def degrees_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "degreesInput"))

    @builtins.property
    @jsii.member(jsii_name="degreesVarInput")
    def degrees_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "degreesVarInput"))

    @builtins.property
    @jsii.member(jsii_name="degrees")
    def degrees(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "degrees"))

    @degrees.setter
    def degrees(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__58083d6aa4a7968bef3d8f21dcaa70d872a65f40948eb5f8c54a5884d4e05748)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "degrees", value)

    @builtins.property
    @jsii.member(jsii_name="degreesVar")
    def degrees_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "degreesVar"))

    @degrees_var.setter
    def degrees_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3abc77e14c60a2e21905788423d101a7b891b9fb1865457b50959f61dfa4a2b1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "degreesVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultRotate]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultRotate]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultRotate]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cfe8ef5497b9ab5aa6cc46cedba8737e9b4520c3b7a1c74d3a4aac1417f73fd2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultScale",
    jsii_struct_bases=[],
    name_mapping={
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultScale:
    def __init__(
        self,
        *,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param height: Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged. Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged. Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7312700a26a1c31e183a58b576045c0268518c03f4f2ae664fb4738c0c0d2e83)
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size.

        Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size.

        Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged.

        Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged.

        Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultScale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultScaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultScaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d2cfbf607e33c377ddd1f3a386251767596b64ba44ea76373d40e9b9f9cf0d36)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultScaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__625267fce86881d124ba33c3da8a17580b065b4c16dd4e8f524ae435b9aece49)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultScaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa183c379ee1387b7ed1d82a8812991cc33593164a0c38aaa2f36f83602c6412)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8793ce5712593aaa5d54bdbbcb6a1053dcb47fe9747465d809c4a2191565b9c5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fd8cce0a3d0d51da529ff9d0999d491e6f37d38da751d96f5956984d158aeb3c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultScale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultScale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultScale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__71137812bad5909fa40a8206b8b34f668dce69d35eab3ef3df92643aa6ffe357)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultScaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultScaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1ed3d5dac865759ee5aae9d134540f7f7f876125e7245befc76da92b8c8af406)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f49d0b8c4f08dee1752ec480b3ad9eb1842471893ae3425467648d5524381c63)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__584df2d61d9c26d76dfd42d09705054e09162734d343469003030e3f0af378e9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8d7dc0720ff3abacdb28f66c72c263ca5f5d87f6bec764ef15e0ea20f831019b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8aaef137a059ea9d891e26828776e07619def40866665c75643e9fd821080f23)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultScale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultScale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultScale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__100f4e93b89de9ad149eb6a5b3471a401f404da2293563dd730770ac42a141c6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultShear",
    jsii_struct_bases=[],
    name_mapping={
        "x_shear": "xShear",
        "x_shear_var": "xShearVar",
        "y_shear": "yShear",
        "y_shear_var": "yShearVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultShear:
    def __init__(
        self,
        *,
        x_shear: typing.Optional[builtins.str] = None,
        x_shear_var: typing.Optional[builtins.str] = None,
        y_shear: typing.Optional[builtins.str] = None,
        y_shear_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param x_shear: The amount to shear along the x-axis, measured in multiples of the image's width. Must be set if yShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear DataAkamaiImagingPolicyImage#x_shear}
        :param x_shear_var: The amount to shear along the x-axis, measured in multiples of the image's width. Must be set if yShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear_var DataAkamaiImagingPolicyImage#x_shear_var}
        :param y_shear: The amount to shear along the y-axis, measured in multiples of the image's height. Must be set if xShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear DataAkamaiImagingPolicyImage#y_shear}
        :param y_shear_var: The amount to shear along the y-axis, measured in multiples of the image's height. Must be set if xShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear_var DataAkamaiImagingPolicyImage#y_shear_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__73014ca4a44903d043f4561e9c8181d5b9da0c8796d6fe407e27ec5856fa3fe9)
            check_type(argname="argument x_shear", value=x_shear, expected_type=type_hints["x_shear"])
            check_type(argname="argument x_shear_var", value=x_shear_var, expected_type=type_hints["x_shear_var"])
            check_type(argname="argument y_shear", value=y_shear, expected_type=type_hints["y_shear"])
            check_type(argname="argument y_shear_var", value=y_shear_var, expected_type=type_hints["y_shear_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if x_shear is not None:
            self._values["x_shear"] = x_shear
        if x_shear_var is not None:
            self._values["x_shear_var"] = x_shear_var
        if y_shear is not None:
            self._values["y_shear"] = y_shear
        if y_shear_var is not None:
            self._values["y_shear_var"] = y_shear_var

    @builtins.property
    def x_shear(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the x-axis, measured in multiples of the image's width.

        Must be set if yShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear DataAkamaiImagingPolicyImage#x_shear}
        '''
        result = self._values.get("x_shear")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_shear_var(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the x-axis, measured in multiples of the image's width.

        Must be set if yShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear_var DataAkamaiImagingPolicyImage#x_shear_var}
        '''
        result = self._values.get("x_shear_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_shear(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the y-axis, measured in multiples of the image's height.

        Must be set if xShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear DataAkamaiImagingPolicyImage#y_shear}
        '''
        result = self._values.get("y_shear")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_shear_var(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the y-axis, measured in multiples of the image's height.

        Must be set if xShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear_var DataAkamaiImagingPolicyImage#y_shear_var}
        '''
        result = self._values.get("y_shear_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultShear(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultShearList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultShearList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4781f0328763c5877f082065cb2d21c7cb44d46a301b813ec89f1505066c74bd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultShearOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__67340e91731b7252f4138118262fdd8fd52f20727add6e2e5ef9e18f3da62a2e)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultShearOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a308ef0a1926904f4386c256e59f5e8b91ddd21a494dc97d644151dc250f12c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__20f72279b3299e81940c4b7e655eefdca3073b1d70e92a5a61fe93b98d97d7ad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e072dcf258836b733071f2ac21d9889b1b1bef765d8e913d2bb95d5419fac59)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultShear]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultShear]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultShear]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d3c906259b23e07d11f3e923569cdb9b39b640250f8de9c5f64c3118fbd95b09)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultShearOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultShearOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f43eb03bc0705ad7da6955aec1e314426df69eefd15c00f356d7332b85ec2653)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetXShear")
    def reset_x_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXShear", []))

    @jsii.member(jsii_name="resetXShearVar")
    def reset_x_shear_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXShearVar", []))

    @jsii.member(jsii_name="resetYShear")
    def reset_y_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYShear", []))

    @jsii.member(jsii_name="resetYShearVar")
    def reset_y_shear_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYShearVar", []))

    @builtins.property
    @jsii.member(jsii_name="xShearInput")
    def x_shear_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xShearInput"))

    @builtins.property
    @jsii.member(jsii_name="xShearVarInput")
    def x_shear_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xShearVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yShearInput")
    def y_shear_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yShearInput"))

    @builtins.property
    @jsii.member(jsii_name="yShearVarInput")
    def y_shear_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yShearVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xShear")
    def x_shear(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xShear"))

    @x_shear.setter
    def x_shear(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__970e2335ac9f913ccde7b40a128501ac03e7d031814722b11a29b0e815fba4e6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xShear", value)

    @builtins.property
    @jsii.member(jsii_name="xShearVar")
    def x_shear_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xShearVar"))

    @x_shear_var.setter
    def x_shear_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__98801ff70909b3b258aa19d7be87045d72206ceaa986ee7e70ecc06e64eb9670)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xShearVar", value)

    @builtins.property
    @jsii.member(jsii_name="yShear")
    def y_shear(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yShear"))

    @y_shear.setter
    def y_shear(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__08f96065bc0eac9d81b8e63f1ba837df365a42cd328e4f1959d31cda0c79cd27)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yShear", value)

    @builtins.property
    @jsii.member(jsii_name="yShearVar")
    def y_shear_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yShearVar"))

    @y_shear_var.setter
    def y_shear_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be657d306e20708a7e905d61ffa36d080e853695931e3152f8d202954ba465ba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yShearVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultShear]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultShear]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultShear]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8770485e4f804c023bfd04674f08928640107dac43f495cf6022b23705fa5f09)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultTrim",
    jsii_struct_bases=[],
    name_mapping={
        "fuzz": "fuzz",
        "fuzz_var": "fuzzVar",
        "padding": "padding",
        "padding_var": "paddingVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultTrim:
    def __init__(
        self,
        *,
        fuzz: typing.Optional[builtins.str] = None,
        fuzz_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fuzz: The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz DataAkamaiImagingPolicyImage#fuzz}
        :param fuzz_var: The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz_var DataAkamaiImagingPolicyImage#fuzz_var}
        :param padding: The amount of padding in pixels to add to the trimmed image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: The amount of padding in pixels to add to the trimmed image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__31d6ed06aed734d1a759f0660ab13c9f5695d06433dddc06da9386b50668c0be)
            check_type(argname="argument fuzz", value=fuzz, expected_type=type_hints["fuzz"])
            check_type(argname="argument fuzz_var", value=fuzz_var, expected_type=type_hints["fuzz_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fuzz is not None:
            self._values["fuzz"] = fuzz
        if fuzz_var is not None:
            self._values["fuzz_var"] = fuzz_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var

    @builtins.property
    def fuzz(self) -> typing.Optional[builtins.str]:
        '''The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz DataAkamaiImagingPolicyImage#fuzz}
        '''
        result = self._values.get("fuzz")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fuzz_var(self) -> typing.Optional[builtins.str]:
        '''The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz_var DataAkamaiImagingPolicyImage#fuzz_var}
        '''
        result = self._values.get("fuzz_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''The amount of padding in pixels to add to the trimmed image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''The amount of padding in pixels to add to the trimmed image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultTrim(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultTrimList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultTrimList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__927fcfa7fb76a4780145aba39fe41565e13befe6102fa32bd09617d34ced007c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultTrimOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f0b706c8151e01cf55e82b0e11decb9255a9bdc328db80de97bb68775841ddc8)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultTrimOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6b777a43b394fe4823926cbc681b27c8696f4a866b3696c4190d320885e250c5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__35ad3a16cc06435337f030b92e4a21cb3e0adefbdd0f9f422c9b6732d7dc859f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fe54b9c54f5d55103e0ccf2d1dd5e53b0dbc4be55a5da71b94286263036a7dfb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultTrim]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultTrim]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultTrim]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ba91787f441de2c10ddbccc76ac0dd58735421c364889b6d8155b1a656352755)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultTrimOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultTrimOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7dcf867f481d5c34aa37446da8cc90aeb67ffcc35bcf8ee0a14802246e82665f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetFuzz")
    def reset_fuzz(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFuzz", []))

    @jsii.member(jsii_name="resetFuzzVar")
    def reset_fuzz_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFuzzVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @builtins.property
    @jsii.member(jsii_name="fuzzInput")
    def fuzz_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fuzzInput"))

    @builtins.property
    @jsii.member(jsii_name="fuzzVarInput")
    def fuzz_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fuzzVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="fuzz")
    def fuzz(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fuzz"))

    @fuzz.setter
    def fuzz(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__610d13927346463701df27b7d7dcbb55bdba6cdf0cf405b2410e9e717ecd24c9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fuzz", value)

    @builtins.property
    @jsii.member(jsii_name="fuzzVar")
    def fuzz_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fuzzVar"))

    @fuzz_var.setter
    def fuzz_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c2477b323eb816ee56b9b418c7a89c0536bde36295c35964e7b832569aedc47e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fuzzVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__866b544f61263d9b5d019deeedaf0c7ff1d51f5253eb9898e15d564888388d5e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__93bbbf8db044f051f54e002fc7d2546fb6c7789a7a84e2a2cf7e40d16d4e0476)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultTrim]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultTrim]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultTrim]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__29c5331470570898c6d7d7fbaf75a246a80b7cb4e0f08aad92319e2107baf447)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultUnsharpMask",
    jsii_struct_bases=[],
    name_mapping={
        "gain": "gain",
        "gain_var": "gainVar",
        "sigma": "sigma",
        "sigma_var": "sigmaVar",
        "threshold": "threshold",
        "threshold_var": "thresholdVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultUnsharpMask:
    def __init__(
        self,
        *,
        gain: typing.Optional[builtins.str] = None,
        gain_var: typing.Optional[builtins.str] = None,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
        threshold: typing.Optional[builtins.str] = None,
        threshold_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param gain: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        :param gain_var: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        :param sigma: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        :param threshold: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        :param threshold_var: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fc8054a9e6306ae1d9144f9086b079ee9873bc98c30803828ac2900b427c5f0a)
            check_type(argname="argument gain", value=gain, expected_type=type_hints["gain"])
            check_type(argname="argument gain_var", value=gain_var, expected_type=type_hints["gain_var"])
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
            check_type(argname="argument threshold", value=threshold, expected_type=type_hints["threshold"])
            check_type(argname="argument threshold_var", value=threshold_var, expected_type=type_hints["threshold_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if gain is not None:
            self._values["gain"] = gain
        if gain_var is not None:
            self._values["gain_var"] = gain_var
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var
        if threshold is not None:
            self._values["threshold"] = threshold
        if threshold_var is not None:
            self._values["threshold_var"] = threshold_var

    @builtins.property
    def gain(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        '''
        result = self._values.get("gain")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gain_var(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        '''
        result = self._values.get("gain_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        '''
        result = self._values.get("threshold")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold_var(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        result = self._values.get("threshold_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultUnsharpMask(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultUnsharpMaskList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultUnsharpMaskList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__36296ec9ff3bbff189ee849afdba81fce5f3e37025423a4fee6e98f5a89a2be2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultUnsharpMaskOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0bf765c5d0ee8feef255fb868b838fc07c08f2226cbef3d66e85986e8d94a606)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultUnsharpMaskOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d930053a586819b8f6017218f757ace8934d4286cef7d359aecdf4ab818c4aae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__68a7de16bb470ee0645ebeaabb599a98d1eea5c40ccaeeb062213f62d37c5c5d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a9f09fc980f68bdbf8304c9c7d53aec3bae6d138e3a284f883ead42a92060ee2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultUnsharpMask]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultUnsharpMask]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultUnsharpMask]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__95aca04a4aa793295334dc52cba03dbd113319a6dace416a3b777b60385b8265)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultUnsharpMaskOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultUnsharpMaskOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8aca5999fdbb90701b461f28ab74796ceed931efd3f86168bce884480aa87f24)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetGain")
    def reset_gain(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGain", []))

    @jsii.member(jsii_name="resetGainVar")
    def reset_gain_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGainVar", []))

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @jsii.member(jsii_name="resetThreshold")
    def reset_threshold(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThreshold", []))

    @jsii.member(jsii_name="resetThresholdVar")
    def reset_threshold_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThresholdVar", []))

    @builtins.property
    @jsii.member(jsii_name="gainInput")
    def gain_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainInput"))

    @builtins.property
    @jsii.member(jsii_name="gainVarInput")
    def gain_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdInput")
    def threshold_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdVarInput")
    def threshold_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gain")
    def gain(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gain"))

    @gain.setter
    def gain(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f58106834a17cff3e599673eeb6c0c1563c22c08a6b734b70e25b882caafa39d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gain", value)

    @builtins.property
    @jsii.member(jsii_name="gainVar")
    def gain_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gainVar"))

    @gain_var.setter
    def gain_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__272ef568630240925fb5d0665cf068d1e425b40be160038d95b1e3f7d42a691f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gainVar", value)

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__81450867a8fff1d088c5bb4cf80e43a7bd1ea9b280ae5c9d81beeb4fc4fd3f79)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c850f5ec7edf7ecc00c1d075a8c93ab9b6e01ac13c5b27c15479099ee2f8fc9d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="threshold")
    def threshold(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "threshold"))

    @threshold.setter
    def threshold(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__01e6678f5cc040898a6e1d3ebe3e2d40f2514e6fa72d29e57a209cc8ed452bc2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "threshold", value)

    @builtins.property
    @jsii.member(jsii_name="thresholdVar")
    def threshold_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "thresholdVar"))

    @threshold_var.setter
    def threshold_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8f2bd83eb76f4e3e0c4ee4e3ad0ede1f4273b4feec96fa4b14e7c195956b47a1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "thresholdVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultUnsharpMask]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultUnsharpMask]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultUnsharpMask]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aaa17646e26dae431002b903f99389397f307187342996b60ce6ca665297dd97)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscape",
    jsii_struct_bases=[],
    name_mapping={
        "append": "append",
        "aspect_crop": "aspectCrop",
        "background_color": "backgroundColor",
        "blur": "blur",
        "chroma_key": "chromaKey",
        "composite": "composite",
        "compound": "compound",
        "contrast": "contrast",
        "crop": "crop",
        "face_crop": "faceCrop",
        "feature_crop": "featureCrop",
        "fit_and_fill": "fitAndFill",
        "goop": "goop",
        "grayscale": "grayscale",
        "hsl": "hsl",
        "hsv": "hsv",
        "if_dimension": "ifDimension",
        "if_orientation": "ifOrientation",
        "im_query": "imQuery",
        "max_colors": "maxColors",
        "mirror": "mirror",
        "mono_hue": "monoHue",
        "opacity": "opacity",
        "region_of_interest_crop": "regionOfInterestCrop",
        "relative_crop": "relativeCrop",
        "remove_color": "removeColor",
        "resize": "resize",
        "rotate": "rotate",
        "scale": "scale",
        "shear": "shear",
        "trim": "trim",
        "unsharp_mask": "unsharpMask",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscape:
    def __init__(
        self,
        *,
        append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeAppend", typing.Dict[builtins.str, typing.Any]]]]] = None,
        aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeAspectCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeBackgroundColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeBlur", typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeChromaKey", typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeComposite", typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompound", typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeContrast", typing.Dict[builtins.str, typing.Any]]]]] = None,
        crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeFaceCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeFeatureCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeFitAndFill", typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeGoop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeGrayscale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeHsl", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeHsv", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimension", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientation", typing.Dict[builtins.str, typing.Any]]]]] = None,
        im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeImQuery", typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeMaxColors", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeMirror", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeMonoHue", typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeOpacity", typing.Dict[builtins.str, typing.Any]]]]] = None,
        region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeRegionOfInterestCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeRelativeCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeRemoveColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeResize", typing.Dict[builtins.str, typing.Any]]]]] = None,
        rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeRotate", typing.Dict[builtins.str, typing.Any]]]]] = None,
        scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeScale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeShear", typing.Dict[builtins.str, typing.Any]]]]] = None,
        trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeTrim", typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeUnsharpMask", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param append: append block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        :param aspect_crop: aspect_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param crop: crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        :param face_crop: face_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        :param feature_crop: feature_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        :param fit_and_fill: fit_and_fill block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param im_query: im_query block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param region_of_interest_crop: region_of_interest_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        :param relative_crop: relative_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param resize: resize block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        :param rotate: rotate block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        :param scale: scale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param shear: shear block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        :param trim: trim block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8c7fd8d02c256549a1fc7d168b7dd165e53379af0f41ea07d24c9e5d996f8b1f)
            check_type(argname="argument append", value=append, expected_type=type_hints["append"])
            check_type(argname="argument aspect_crop", value=aspect_crop, expected_type=type_hints["aspect_crop"])
            check_type(argname="argument background_color", value=background_color, expected_type=type_hints["background_color"])
            check_type(argname="argument blur", value=blur, expected_type=type_hints["blur"])
            check_type(argname="argument chroma_key", value=chroma_key, expected_type=type_hints["chroma_key"])
            check_type(argname="argument composite", value=composite, expected_type=type_hints["composite"])
            check_type(argname="argument compound", value=compound, expected_type=type_hints["compound"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument crop", value=crop, expected_type=type_hints["crop"])
            check_type(argname="argument face_crop", value=face_crop, expected_type=type_hints["face_crop"])
            check_type(argname="argument feature_crop", value=feature_crop, expected_type=type_hints["feature_crop"])
            check_type(argname="argument fit_and_fill", value=fit_and_fill, expected_type=type_hints["fit_and_fill"])
            check_type(argname="argument goop", value=goop, expected_type=type_hints["goop"])
            check_type(argname="argument grayscale", value=grayscale, expected_type=type_hints["grayscale"])
            check_type(argname="argument hsl", value=hsl, expected_type=type_hints["hsl"])
            check_type(argname="argument hsv", value=hsv, expected_type=type_hints["hsv"])
            check_type(argname="argument if_dimension", value=if_dimension, expected_type=type_hints["if_dimension"])
            check_type(argname="argument if_orientation", value=if_orientation, expected_type=type_hints["if_orientation"])
            check_type(argname="argument im_query", value=im_query, expected_type=type_hints["im_query"])
            check_type(argname="argument max_colors", value=max_colors, expected_type=type_hints["max_colors"])
            check_type(argname="argument mirror", value=mirror, expected_type=type_hints["mirror"])
            check_type(argname="argument mono_hue", value=mono_hue, expected_type=type_hints["mono_hue"])
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument region_of_interest_crop", value=region_of_interest_crop, expected_type=type_hints["region_of_interest_crop"])
            check_type(argname="argument relative_crop", value=relative_crop, expected_type=type_hints["relative_crop"])
            check_type(argname="argument remove_color", value=remove_color, expected_type=type_hints["remove_color"])
            check_type(argname="argument resize", value=resize, expected_type=type_hints["resize"])
            check_type(argname="argument rotate", value=rotate, expected_type=type_hints["rotate"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument shear", value=shear, expected_type=type_hints["shear"])
            check_type(argname="argument trim", value=trim, expected_type=type_hints["trim"])
            check_type(argname="argument unsharp_mask", value=unsharp_mask, expected_type=type_hints["unsharp_mask"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if append is not None:
            self._values["append"] = append
        if aspect_crop is not None:
            self._values["aspect_crop"] = aspect_crop
        if background_color is not None:
            self._values["background_color"] = background_color
        if blur is not None:
            self._values["blur"] = blur
        if chroma_key is not None:
            self._values["chroma_key"] = chroma_key
        if composite is not None:
            self._values["composite"] = composite
        if compound is not None:
            self._values["compound"] = compound
        if contrast is not None:
            self._values["contrast"] = contrast
        if crop is not None:
            self._values["crop"] = crop
        if face_crop is not None:
            self._values["face_crop"] = face_crop
        if feature_crop is not None:
            self._values["feature_crop"] = feature_crop
        if fit_and_fill is not None:
            self._values["fit_and_fill"] = fit_and_fill
        if goop is not None:
            self._values["goop"] = goop
        if grayscale is not None:
            self._values["grayscale"] = grayscale
        if hsl is not None:
            self._values["hsl"] = hsl
        if hsv is not None:
            self._values["hsv"] = hsv
        if if_dimension is not None:
            self._values["if_dimension"] = if_dimension
        if if_orientation is not None:
            self._values["if_orientation"] = if_orientation
        if im_query is not None:
            self._values["im_query"] = im_query
        if max_colors is not None:
            self._values["max_colors"] = max_colors
        if mirror is not None:
            self._values["mirror"] = mirror
        if mono_hue is not None:
            self._values["mono_hue"] = mono_hue
        if opacity is not None:
            self._values["opacity"] = opacity
        if region_of_interest_crop is not None:
            self._values["region_of_interest_crop"] = region_of_interest_crop
        if relative_crop is not None:
            self._values["relative_crop"] = relative_crop
        if remove_color is not None:
            self._values["remove_color"] = remove_color
        if resize is not None:
            self._values["resize"] = resize
        if rotate is not None:
            self._values["rotate"] = rotate
        if scale is not None:
            self._values["scale"] = scale
        if shear is not None:
            self._values["shear"] = shear
        if trim is not None:
            self._values["trim"] = trim
        if unsharp_mask is not None:
            self._values["unsharp_mask"] = unsharp_mask

    @builtins.property
    def append(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeAppend"]]]:
        '''append block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        '''
        result = self._values.get("append")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeAppend"]]], result)

    @builtins.property
    def aspect_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeAspectCrop"]]]:
        '''aspect_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        '''
        result = self._values.get("aspect_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeAspectCrop"]]], result)

    @builtins.property
    def background_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeBackgroundColor"]]]:
        '''background_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        '''
        result = self._values.get("background_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeBackgroundColor"]]], result)

    @builtins.property
    def blur(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeBlur"]]]:
        '''blur block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        '''
        result = self._values.get("blur")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeBlur"]]], result)

    @builtins.property
    def chroma_key(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeChromaKey"]]]:
        '''chroma_key block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        '''
        result = self._values.get("chroma_key")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeChromaKey"]]], result)

    @builtins.property
    def composite(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeComposite"]]]:
        '''composite block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        '''
        result = self._values.get("composite")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeComposite"]]], result)

    @builtins.property
    def compound(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompound"]]]:
        '''compound block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        '''
        result = self._values.get("compound")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompound"]]], result)

    @builtins.property
    def contrast(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeContrast"]]]:
        '''contrast block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeContrast"]]], result)

    @builtins.property
    def crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeCrop"]]]:
        '''crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        '''
        result = self._values.get("crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeCrop"]]], result)

    @builtins.property
    def face_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeFaceCrop"]]]:
        '''face_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        '''
        result = self._values.get("face_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeFaceCrop"]]], result)

    @builtins.property
    def feature_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeFeatureCrop"]]]:
        '''feature_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        '''
        result = self._values.get("feature_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeFeatureCrop"]]], result)

    @builtins.property
    def fit_and_fill(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeFitAndFill"]]]:
        '''fit_and_fill block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        '''
        result = self._values.get("fit_and_fill")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeFitAndFill"]]], result)

    @builtins.property
    def goop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeGoop"]]]:
        '''goop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        '''
        result = self._values.get("goop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeGoop"]]], result)

    @builtins.property
    def grayscale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeGrayscale"]]]:
        '''grayscale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        '''
        result = self._values.get("grayscale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeGrayscale"]]], result)

    @builtins.property
    def hsl(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeHsl"]]]:
        '''hsl block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        '''
        result = self._values.get("hsl")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeHsl"]]], result)

    @builtins.property
    def hsv(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeHsv"]]]:
        '''hsv block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        '''
        result = self._values.get("hsv")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeHsv"]]], result)

    @builtins.property
    def if_dimension(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimension"]]]:
        '''if_dimension block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        '''
        result = self._values.get("if_dimension")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimension"]]], result)

    @builtins.property
    def if_orientation(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientation"]]]:
        '''if_orientation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        '''
        result = self._values.get("if_orientation")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientation"]]], result)

    @builtins.property
    def im_query(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeImQuery"]]]:
        '''im_query block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        '''
        result = self._values.get("im_query")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeImQuery"]]], result)

    @builtins.property
    def max_colors(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeMaxColors"]]]:
        '''max_colors block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        '''
        result = self._values.get("max_colors")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeMaxColors"]]], result)

    @builtins.property
    def mirror(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeMirror"]]]:
        '''mirror block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        '''
        result = self._values.get("mirror")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeMirror"]]], result)

    @builtins.property
    def mono_hue(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeMonoHue"]]]:
        '''mono_hue block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        '''
        result = self._values.get("mono_hue")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeMonoHue"]]], result)

    @builtins.property
    def opacity(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeOpacity"]]]:
        '''opacity block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeOpacity"]]], result)

    @builtins.property
    def region_of_interest_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeRegionOfInterestCrop"]]]:
        '''region_of_interest_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        '''
        result = self._values.get("region_of_interest_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeRegionOfInterestCrop"]]], result)

    @builtins.property
    def relative_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeRelativeCrop"]]]:
        '''relative_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        '''
        result = self._values.get("relative_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeRelativeCrop"]]], result)

    @builtins.property
    def remove_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeRemoveColor"]]]:
        '''remove_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        '''
        result = self._values.get("remove_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeRemoveColor"]]], result)

    @builtins.property
    def resize(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeResize"]]]:
        '''resize block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        '''
        result = self._values.get("resize")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeResize"]]], result)

    @builtins.property
    def rotate(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeRotate"]]]:
        '''rotate block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        '''
        result = self._values.get("rotate")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeRotate"]]], result)

    @builtins.property
    def scale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeScale"]]]:
        '''scale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeScale"]]], result)

    @builtins.property
    def shear(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeShear"]]]:
        '''shear block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        '''
        result = self._values.get("shear")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeShear"]]], result)

    @builtins.property
    def trim(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeTrim"]]]:
        '''trim block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        '''
        result = self._values.get("trim")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeTrim"]]], result)

    @builtins.property
    def unsharp_mask(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeUnsharpMask"]]]:
        '''unsharp_mask block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        result = self._values.get("unsharp_mask")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeUnsharpMask"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscape(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeAppend",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_priority": "gravityPriority",
        "gravity_priority_var": "gravityPriorityVar",
        "gravity_var": "gravityVar",
        "preserve_minor_dimension": "preserveMinorDimension",
        "preserve_minor_dimension_var": "preserveMinorDimensionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeAppend:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeAppendImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_priority: typing.Optional[builtins.str] = None,
        gravity_priority_var: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        preserve_minor_dimension: typing.Optional[builtins.str] = None,
        preserve_minor_dimension_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Specifies where to place the ``image`` relative to the source image. The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_priority: Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal. The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority DataAkamaiImagingPolicyImage#gravity_priority}
        :param gravity_priority_var: Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal. The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority_var DataAkamaiImagingPolicyImage#gravity_priority_var}
        :param gravity_var: Specifies where to place the ``image`` relative to the source image. The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param preserve_minor_dimension: Whether to preserve the source image's minor dimension, ``false`` by default. The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension DataAkamaiImagingPolicyImage#preserve_minor_dimension}
        :param preserve_minor_dimension_var: Whether to preserve the source image's minor dimension, ``false`` by default. The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension_var DataAkamaiImagingPolicyImage#preserve_minor_dimension_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeAppendImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__61751cf885b88e6b39029871fca80e11c8659c62f44d3912d506cc0a89f1fea6)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_priority", value=gravity_priority, expected_type=type_hints["gravity_priority"])
            check_type(argname="argument gravity_priority_var", value=gravity_priority_var, expected_type=type_hints["gravity_priority_var"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument preserve_minor_dimension", value=preserve_minor_dimension, expected_type=type_hints["preserve_minor_dimension"])
            check_type(argname="argument preserve_minor_dimension_var", value=preserve_minor_dimension_var, expected_type=type_hints["preserve_minor_dimension_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_priority is not None:
            self._values["gravity_priority"] = gravity_priority
        if gravity_priority_var is not None:
            self._values["gravity_priority_var"] = gravity_priority_var
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if preserve_minor_dimension is not None:
            self._values["preserve_minor_dimension"] = preserve_minor_dimension
        if preserve_minor_dimension_var is not None:
            self._values["preserve_minor_dimension_var"] = preserve_minor_dimension_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeAppendImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeAppendImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Specifies where to place the ``image`` relative to the source image.

        The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_priority(self) -> typing.Optional[builtins.str]:
        '''Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal.

        The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority DataAkamaiImagingPolicyImage#gravity_priority}
        '''
        result = self._values.get("gravity_priority")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_priority_var(self) -> typing.Optional[builtins.str]:
        '''Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal.

        The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority_var DataAkamaiImagingPolicyImage#gravity_priority_var}
        '''
        result = self._values.get("gravity_priority_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Specifies where to place the ``image`` relative to the source image.

        The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def preserve_minor_dimension(self) -> typing.Optional[builtins.str]:
        '''Whether to preserve the source image's minor dimension, ``false`` by default.

        The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension DataAkamaiImagingPolicyImage#preserve_minor_dimension}
        '''
        result = self._values.get("preserve_minor_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def preserve_minor_dimension_var(self) -> typing.Optional[builtins.str]:
        '''Whether to preserve the source image's minor dimension, ``false`` by default.

        The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension_var DataAkamaiImagingPolicyImage#preserve_minor_dimension_var}
        '''
        result = self._values.get("preserve_minor_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeAppend(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeAppendImage",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeAppendImage:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeAppendImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeAppendImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeAppendImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9e1066481400c787e989615f6f1ed1c4f04fa2f4283719fb1bbad60bce52ca9f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeAppendImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeAppendImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeAppendImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9f7b058cc5f93235fbc67b6091f954119bb1873340704c21e39e2f9b4c2167a3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeAppendList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeAppendList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__25e8526511f3724beb79631dead26b061095178950a277e3951145f697e4b192)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeAppendOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__53c53c2d735c0646d58de2f0879c878451541e00e3c7116ee927b5b70972cc5e)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeAppendOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e159e40e16dc209fef6265c78f3975f68ff21bec503b0e13518aa7f0cbac41a4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f66be26d68d78d3f33dc11430103c5653ce17e8e9a59c7c77eff08dab77b05d5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b9f7498e8f30519b58ea097f705fa214f396bc945ed6c0ec36a58381d1a09fdd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeAppend]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeAppend]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeAppend]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e51fcb94346564121f9e0342f0c11787069a40ee6f53c5e04e260d3caf3012bf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeAppendOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeAppendOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__153794407fc8be9617fa28ae764c606f66c73b2d610f59603e34001c918b2bf1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeAppendImage()

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityPriority")
    def reset_gravity_priority(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityPriority", []))

    @jsii.member(jsii_name="resetGravityPriorityVar")
    def reset_gravity_priority_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityPriorityVar", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPreserveMinorDimension")
    def reset_preserve_minor_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPreserveMinorDimension", []))

    @jsii.member(jsii_name="resetPreserveMinorDimensionVar")
    def reset_preserve_minor_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPreserveMinorDimensionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeAppendImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeAppendImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityInput")
    def gravity_priority_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityPriorityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityVarInput")
    def gravity_priority_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityPriorityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeAppendImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeAppendImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionInput")
    def preserve_minor_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "preserveMinorDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionVarInput")
    def preserve_minor_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "preserveMinorDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a51040d82eff60b9a9d430d32d81a7ae82b71d367ebe27f6a0f239a94a0ccfe7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityPriority")
    def gravity_priority(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityPriority"))

    @gravity_priority.setter
    def gravity_priority(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__15d23fe3b84bbee91ceda5e5f4a8282469a694957659f62dfe46066c9fc632c4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityPriority", value)

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityVar")
    def gravity_priority_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityPriorityVar"))

    @gravity_priority_var.setter
    def gravity_priority_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c2f02557f7374a51d956c1ebb3bbb09fea6629d8272709d69af2d518a3782001)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityPriorityVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0432ffc21baf8741159781ada42bec15f5df4aa02327234f2d3a376813d40d99)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimension")
    def preserve_minor_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "preserveMinorDimension"))

    @preserve_minor_dimension.setter
    def preserve_minor_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__656970042e06fd7e7524cf04159ddda3ea9d2872902a642ec9d35ff11b7e7e6e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "preserveMinorDimension", value)

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionVar")
    def preserve_minor_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "preserveMinorDimensionVar"))

    @preserve_minor_dimension_var.setter
    def preserve_minor_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__da2e034b657d2db7afc7f22b4e0bc6aa9fc86b7018ceeef7ec3cf77cdad52ee1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "preserveMinorDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeAppend]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeAppend]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeAppend]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__04685955ab2a0a990c638f97efa50b1ce4899d5fd88d90d93f302dc9c5988676)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeAspectCrop",
    jsii_struct_bases=[],
    name_mapping={
        "allow_expansion": "allowExpansion",
        "allow_expansion_var": "allowExpansionVar",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeAspectCrop:
    def __init__(
        self,
        *,
        allow_expansion: typing.Optional[builtins.str] = None,
        allow_expansion_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_expansion: Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image. Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        :param allow_expansion_var: Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image. Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        :param height: The height term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The width term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        :param x_position: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5461a44ca66d56bfdf80a9c3b1041fdb5e45c3846f7ecd9fa9fb106e13eb43f3)
            check_type(argname="argument allow_expansion", value=allow_expansion, expected_type=type_hints["allow_expansion"])
            check_type(argname="argument allow_expansion_var", value=allow_expansion_var, expected_type=type_hints["allow_expansion_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if allow_expansion is not None:
            self._values["allow_expansion"] = allow_expansion
        if allow_expansion_var is not None:
            self._values["allow_expansion_var"] = allow_expansion_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def allow_expansion(self) -> typing.Optional[builtins.str]:
        '''Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image.

        Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        '''
        result = self._values.get("allow_expansion")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def allow_expansion_var(self) -> typing.Optional[builtins.str]:
        '''Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image.

        Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        '''
        result = self._values.get("allow_expansion_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeAspectCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeAspectCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeAspectCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ed923ae0c93fc95c42618261724e3d4af2d98f6a9094ce9cc43d81c95571d22a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeAspectCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__75b900c8d8306bd9a86e48751cb5e685b05ee4c7633e748b33ee1d17f3a72a72)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeAspectCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ebd32147dca117055ca7c4959e56b17e14f2375f2df9e2bcc83009786ffba571)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__42e3eeafde5cd88061aed9dbc45e538f24ef6099317cca36cdd506b303977599)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd7c115c4a00501e33232250b212946cbb20d5fd22cd0bbe23f3e0fabc75c93b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeAspectCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeAspectCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeAspectCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8ed0a902748b2377ea8385d49bc5c1b06cb2a52c20f15da1e29e207240c9e898)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeAspectCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeAspectCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c3d5475d01eff8d82db896952b8303ee419ef1ade895bb619f9c20110a035999)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAllowExpansion")
    def reset_allow_expansion(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansion", []))

    @jsii.member(jsii_name="resetAllowExpansionVar")
    def reset_allow_expansion_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansionVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionInput")
    def allow_expansion_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVarInput")
    def allow_expansion_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansion")
    def allow_expansion(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansion"))

    @allow_expansion.setter
    def allow_expansion(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fe439babff21c16e78b09e300a77852593c118e5cd51a1a630958e07a60c12b0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansion", value)

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVar")
    def allow_expansion_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansionVar"))

    @allow_expansion_var.setter
    def allow_expansion_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a5aaac73852bb65710fe41a39720d100b2871c8ec7000b322b9350c5b448d779)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansionVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b009edd8366fc6fbd99f954fe3ddeb1e29e1dbdf10692abaa5d15d8f36b8e2cb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d3dad3949e19b18a16c5647c9a4f19c15a4aa64900949fa9c4daaaf626711eed)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7b33aa2a5804edba3015aceefb66aa5ba912519815d4e8e1af4baed7b0328010)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__10ab8d624279181b8a85de764d3a2425d923012e1c26b5c5d1068c5c3ad0764b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c1fb48f9859a9daa1e01eb12722c7c4ec85bc4587ff049b4b60f7565f2e92e1c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8fbef85b5180aff3ff8c11a8c2ce96664778c6c482232b5a22f4b22a70a638f0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bd9a7b1f522823777e4331d046ab5ed4ea4633580c524405d8434fece3ae06cf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e1ae3a7785befb9b6b92ba5be12fe8b26e47aa7e01eac789ad3de3b1c5a2a943)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeAspectCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeAspectCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeAspectCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e7f096e8ba4ea28fe4478ee70a65e38ec79211c859140a7ce8789d0a4a0b8d19)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeBackgroundColor",
    jsii_struct_bases=[],
    name_mapping={"color": "color", "color_var": "colorVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeBackgroundColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dad27ba6f80a1c8d975dfb46558717d7da28c31cde47c82f311391d8bfa474b7)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeBackgroundColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeBackgroundColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeBackgroundColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__160eb40d0f941ed95d86ad8576a32de6d458c983227683ce36cf2f81c9d34985)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeBackgroundColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d25530bf50e1d8da51dcd31702de9dbbab24e1a4cfdede9327ce6493eb2767b)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeBackgroundColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a15e3e0864b1623cff1e442cde02e00b4c538f54791e8359721bb0c9743bd79f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d6ef262826ba823cf9cafdf29b04c9cb444508e5fec912f3343135f45e2eb471)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b9999121d514cdf8963a08faa6c55e83114b77c942ff9b8e1257820989e6fbe9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeBackgroundColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeBackgroundColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ee9e5537a1597710089338eef64592e4aa247c32e0e24d77a08783870108ef76)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeBackgroundColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeBackgroundColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__42d8b529808e6c797c16f8bad76e2e1805d3169e8257161dd52d8fa47097f052)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a6a50a2089116431e6d9350313261a459ec1711b659adea936182705f3858bb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__93b740f024315ceea6ef9025225cd31cffffb2e29030cdac8ad6735df98376ab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeBackgroundColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeBackgroundColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeBackgroundColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f2d6ad1a65ddc365c87d402220e73a5525792b633d85629c395a795b2c5383a6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeBlur",
    jsii_struct_bases=[],
    name_mapping={"sigma": "sigma", "sigma_var": "sigmaVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeBlur:
    def __init__(
        self,
        *,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param sigma: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9e62df943705da01302a38dd0a6ccfae78c2b802269ca50f62def6bf9edaae38)
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeBlur(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeBlurList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeBlurList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7fed8722d12d0977889c9c150d2361fd211ec6a01bd02e73baaf4fec47af2480)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeBlurOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c71c6c44bbdd508ac50e1e17c080dee0fbaf7f8b8035a42fd4d7cb263db768e0)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeBlurOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a9294062590d26f8d19e70f9b03af6de5fceeeccc788f97cd0df0677aa05fcfc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5c08559a22c0cc2f98d3075fe61581b4641413d744a1cedbf7ccdfb40a8e8b2f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__280bd00cb3068dbd90705ca09fc10458590ba889247eeffc6d51d89d4f555c2f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeBlur]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeBlur]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__45238f95ab2d1e721a1b7ac3329c70aa5d1f0987c5f2917f5b7a464bad512cde)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeBlurOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeBlurOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__336671b6dd340497007fac416befbf52d7da74f834774ac83236b3074b0106dd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__78cabbbc8ff216f86fc7951556c2befaae294a5b93b67656e96dcc0388a05c16)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__897fb855acea87a1fc219355d840e21fd4d0571f0fc450c60ab71db790654e53)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeBlur]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeBlur]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeBlur]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__04dce9d7c8d00e37cee53dcdcb2a29f3c3ddea4d67162ca0f5926ad549c411be)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeChromaKey",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_feather": "hueFeather",
        "hue_feather_var": "hueFeatherVar",
        "hue_tolerance": "hueTolerance",
        "hue_tolerance_var": "hueToleranceVar",
        "hue_var": "hueVar",
        "lightness_feather": "lightnessFeather",
        "lightness_feather_var": "lightnessFeatherVar",
        "lightness_tolerance": "lightnessTolerance",
        "lightness_tolerance_var": "lightnessToleranceVar",
        "saturation_feather": "saturationFeather",
        "saturation_feather_var": "saturationFeatherVar",
        "saturation_tolerance": "saturationTolerance",
        "saturation_tolerance_var": "saturationToleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeChromaKey:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_feather: typing.Optional[builtins.str] = None,
        hue_feather_var: typing.Optional[builtins.str] = None,
        hue_tolerance: typing.Optional[builtins.str] = None,
        hue_tolerance_var: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness_feather: typing.Optional[builtins.str] = None,
        lightness_feather_var: typing.Optional[builtins.str] = None,
        lightness_tolerance: typing.Optional[builtins.str] = None,
        lightness_tolerance_var: typing.Optional[builtins.str] = None,
        saturation_feather: typing.Optional[builtins.str] = None,
        saturation_feather_var: typing.Optional[builtins.str] = None,
        saturation_tolerance: typing.Optional[builtins.str] = None,
        saturation_tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_feather: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        :param hue_feather_var: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        :param hue_tolerance: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        :param hue_tolerance_var: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        :param hue_var: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness_feather: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        :param lightness_feather_var: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        :param lightness_tolerance: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        :param lightness_tolerance_var: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        :param saturation_feather: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        :param saturation_feather_var: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        :param saturation_tolerance: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        :param saturation_tolerance_var: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__961ff049d0e8c4874826749037904b51b5bdac1e288f3f0d35bd797b6de251f0)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_feather", value=hue_feather, expected_type=type_hints["hue_feather"])
            check_type(argname="argument hue_feather_var", value=hue_feather_var, expected_type=type_hints["hue_feather_var"])
            check_type(argname="argument hue_tolerance", value=hue_tolerance, expected_type=type_hints["hue_tolerance"])
            check_type(argname="argument hue_tolerance_var", value=hue_tolerance_var, expected_type=type_hints["hue_tolerance_var"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness_feather", value=lightness_feather, expected_type=type_hints["lightness_feather"])
            check_type(argname="argument lightness_feather_var", value=lightness_feather_var, expected_type=type_hints["lightness_feather_var"])
            check_type(argname="argument lightness_tolerance", value=lightness_tolerance, expected_type=type_hints["lightness_tolerance"])
            check_type(argname="argument lightness_tolerance_var", value=lightness_tolerance_var, expected_type=type_hints["lightness_tolerance_var"])
            check_type(argname="argument saturation_feather", value=saturation_feather, expected_type=type_hints["saturation_feather"])
            check_type(argname="argument saturation_feather_var", value=saturation_feather_var, expected_type=type_hints["saturation_feather_var"])
            check_type(argname="argument saturation_tolerance", value=saturation_tolerance, expected_type=type_hints["saturation_tolerance"])
            check_type(argname="argument saturation_tolerance_var", value=saturation_tolerance_var, expected_type=type_hints["saturation_tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_feather is not None:
            self._values["hue_feather"] = hue_feather
        if hue_feather_var is not None:
            self._values["hue_feather_var"] = hue_feather_var
        if hue_tolerance is not None:
            self._values["hue_tolerance"] = hue_tolerance
        if hue_tolerance_var is not None:
            self._values["hue_tolerance_var"] = hue_tolerance_var
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness_feather is not None:
            self._values["lightness_feather"] = lightness_feather
        if lightness_feather_var is not None:
            self._values["lightness_feather_var"] = lightness_feather_var
        if lightness_tolerance is not None:
            self._values["lightness_tolerance"] = lightness_tolerance
        if lightness_tolerance_var is not None:
            self._values["lightness_tolerance_var"] = lightness_tolerance_var
        if saturation_feather is not None:
            self._values["saturation_feather"] = saturation_feather
        if saturation_feather_var is not None:
            self._values["saturation_feather_var"] = saturation_feather_var
        if saturation_tolerance is not None:
            self._values["saturation_tolerance"] = saturation_tolerance
        if saturation_tolerance_var is not None:
            self._values["saturation_tolerance_var"] = saturation_tolerance_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        '''
        result = self._values.get("hue_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        '''
        result = self._values.get("hue_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        '''
        result = self._values.get("hue_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        '''
        result = self._values.get("hue_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        '''
        result = self._values.get("lightness_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        '''
        result = self._values.get("lightness_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        '''
        result = self._values.get("lightness_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        '''
        result = self._values.get("lightness_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        '''
        result = self._values.get("saturation_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        '''
        result = self._values.get("saturation_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        '''
        result = self._values.get("saturation_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        result = self._values.get("saturation_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeChromaKey(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeChromaKeyList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeChromaKeyList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6083fe8ac6f6b48662e395bdb0af7ad2bc0ad41b46c809f2069092a603e796ad)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeChromaKeyOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__747fe8bb16e634021ec34ff82d4bbdac518cdf4b40c935d1f6f6742103318615)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeChromaKeyOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a05b22f22682cd84686f9afea4d5231309545189a653c5a3dd85f3340906b025)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d8988fae8b9d70c6eb74863fc28df45e15d812f553b4bd4662c7d4c54cc7843)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__656664b35ea500828abebad5813f1ccddddbfd658a63b7b750fc7509ee29e0e3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeChromaKey]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeChromaKey]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb2d09731224a01842a356d6eeeda1b6c7a73a47003be7d9b37b3dee0672266a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeChromaKeyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeChromaKeyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b623659784b76dee6408f191e72b696e7a24f368df2ab481a427256ad405fca6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueFeather")
    def reset_hue_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeather", []))

    @jsii.member(jsii_name="resetHueFeatherVar")
    def reset_hue_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeatherVar", []))

    @jsii.member(jsii_name="resetHueTolerance")
    def reset_hue_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueTolerance", []))

    @jsii.member(jsii_name="resetHueToleranceVar")
    def reset_hue_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueToleranceVar", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightnessFeather")
    def reset_lightness_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeather", []))

    @jsii.member(jsii_name="resetLightnessFeatherVar")
    def reset_lightness_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeatherVar", []))

    @jsii.member(jsii_name="resetLightnessTolerance")
    def reset_lightness_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessTolerance", []))

    @jsii.member(jsii_name="resetLightnessToleranceVar")
    def reset_lightness_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessToleranceVar", []))

    @jsii.member(jsii_name="resetSaturationFeather")
    def reset_saturation_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeather", []))

    @jsii.member(jsii_name="resetSaturationFeatherVar")
    def reset_saturation_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeatherVar", []))

    @jsii.member(jsii_name="resetSaturationTolerance")
    def reset_saturation_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationTolerance", []))

    @jsii.member(jsii_name="resetSaturationToleranceVar")
    def reset_saturation_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherInput")
    def hue_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVarInput")
    def hue_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceInput")
    def hue_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVarInput")
    def hue_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherInput")
    def lightness_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVarInput")
    def lightness_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceInput")
    def lightness_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVarInput")
    def lightness_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherInput")
    def saturation_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVarInput")
    def saturation_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceInput")
    def saturation_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVarInput")
    def saturation_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ca83b7e26ce42b9e8923aec85b480b8ffcddb3a2a11ce358de9f6dbc61409a18)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeather")
    def hue_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeather"))

    @hue_feather.setter
    def hue_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab1821e0a033a19c0b9bc70ed5b99c814a863571c2772985f074bb18473673b8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeather", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVar")
    def hue_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeatherVar"))

    @hue_feather_var.setter
    def hue_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d4208307ba9df74c46f140ff4b7ff1ea85af68984a0c5cd31adc8a1f94c7d9f9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueTolerance")
    def hue_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueTolerance"))

    @hue_tolerance.setter
    def hue_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8598ed13dc187492039914e636dc1c1912f7f7b14e99812c6945463747c7a14d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVar")
    def hue_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueToleranceVar"))

    @hue_tolerance_var.setter
    def hue_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e49e30bbd40fe1e217b100a2a970f6a84956160dad33c7862d6e9898130f58a0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f4e874e86edecdcd0c939389cb55b6ef073e9f0d90320948c760e4cde3ae5a56)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeather")
    def lightness_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeather"))

    @lightness_feather.setter
    def lightness_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__63e35df02a26f5ce18d03f74fa703d649ca367406001a17670b39abcd7b950c3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeather", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVar")
    def lightness_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeatherVar"))

    @lightness_feather_var.setter
    def lightness_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e92fbdb8ddb7923946475e252a18177699289493236636f9197b6b75af2964d8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessTolerance")
    def lightness_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessTolerance"))

    @lightness_tolerance.setter
    def lightness_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7c3bf53ac373a9b7a3b5076fa4a7f8fa90b5ace87011b9acf0ed8d0e6bdafb83)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVar")
    def lightness_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessToleranceVar"))

    @lightness_tolerance_var.setter
    def lightness_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac6f5a4320174f8cb42e023e8779e56f322c4b55ac96e5acaff056e59bb49774)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeather")
    def saturation_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeather"))

    @saturation_feather.setter
    def saturation_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cae07e64c91c82185c7e6e404807c608bbc9ea73bb02bd7a6a125c1ba897ca5d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeather", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVar")
    def saturation_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeatherVar"))

    @saturation_feather_var.setter
    def saturation_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f2fa2667d8c2641c4267c89e5a43af320d0ecc14d5c8ccd2ae8eb1217b214c61)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationTolerance")
    def saturation_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationTolerance"))

    @saturation_tolerance.setter
    def saturation_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8e3601a5469f9002eb221be1770ad84fd4b4183b75c9562841c8b9e7c4795a96)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVar")
    def saturation_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationToleranceVar"))

    @saturation_tolerance_var.setter
    def saturation_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__456cbfe1cc580a9c9a12953ca98741f87bdc7bd30a025d44e18fe2b6ef143ada)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeChromaKey]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeChromaKey]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeChromaKey]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__917267d79763b60cfd46713a19ba26e778fba1f1a9b165e2b499f26eb40cbfb2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeComposite",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "placement": "placement",
        "placement_var": "placementVar",
        "scale": "scale",
        "scale_dimension": "scaleDimension",
        "scale_dimension_var": "scaleDimensionVar",
        "scale_var": "scaleVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeComposite:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompositeImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        placement: typing.Optional[builtins.str] = None,
        placement_var: typing.Optional[builtins.str] = None,
        scale: typing.Optional[builtins.str] = None,
        scale_dimension: typing.Optional[builtins.str] = None,
        scale_dimension_var: typing.Optional[builtins.str] = None,
        scale_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param placement: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        :param placement_var: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        :param scale: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param scale_dimension: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        :param scale_dimension_var: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        :param scale_var: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        :param x_position: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompositeImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4f0e28f01a75d68d1e753e3be904bef93f4bb5fb6ec5c6102abc6233e1acabef)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument placement", value=placement, expected_type=type_hints["placement"])
            check_type(argname="argument placement_var", value=placement_var, expected_type=type_hints["placement_var"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument scale_dimension", value=scale_dimension, expected_type=type_hints["scale_dimension"])
            check_type(argname="argument scale_dimension_var", value=scale_dimension_var, expected_type=type_hints["scale_dimension_var"])
            check_type(argname="argument scale_var", value=scale_var, expected_type=type_hints["scale_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if placement is not None:
            self._values["placement"] = placement
        if placement_var is not None:
            self._values["placement_var"] = placement_var
        if scale is not None:
            self._values["scale"] = scale
        if scale_dimension is not None:
            self._values["scale_dimension"] = scale_dimension
        if scale_dimension_var is not None:
            self._values["scale_dimension_var"] = scale_dimension_var
        if scale_var is not None:
            self._values["scale_var"] = scale_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompositeImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompositeImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        '''
        result = self._values.get("placement")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement_var(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        '''
        result = self._values.get("placement_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        '''
        result = self._values.get("scale_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        '''
        result = self._values.get("scale_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        '''
        result = self._values.get("scale_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeComposite(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompositeImage",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompositeImage:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompositeImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompositeImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompositeImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7b24520936861ee93360406f454b35c32b3cb0dcfb40df2b919566a782ffde3e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompositeImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompositeImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5fc4dc19b2c94152304afb45b252b8197ae5993874e3bae847c919ac7a965c9b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompositeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompositeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c52315f14456bf43d81453726f467425e0a828cc870b6ce48f492a71f94834fd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompositeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__34bf986ef8a60fa92b70651716619fd89a08b685d63f4f53bfa94bf623c7d416)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompositeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a3b4668b4f9c69ae192ee053fd37b55ad95440cfdc45428b8089de7eb8474f5f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3dce6c6b0ee2465600c5f18b7d63b35a53fa601b6bea9a411e374bc4d9d075e8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ae012693840f3e7939b92587fb9d35b976d4208055f393d1a7aa7bf2bc3f8bc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeComposite]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeComposite]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b2f26e80f0f4e3f6cbf081d11be9b3fbdc99551cc4ecb6735f806e4176219361)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompositeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompositeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d98f3c4cc1164b80fae0b5a920e575526a1040ccfbddbd119f1752f69196d8a3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompositeImage()

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPlacement")
    def reset_placement(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacement", []))

    @jsii.member(jsii_name="resetPlacementVar")
    def reset_placement_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacementVar", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetScaleDimension")
    def reset_scale_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimension", []))

    @jsii.member(jsii_name="resetScaleDimensionVar")
    def reset_scale_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimensionVar", []))

    @jsii.member(jsii_name="resetScaleVar")
    def reset_scale_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompositeImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompositeImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompositeImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="placementInput")
    def placement_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementInput"))

    @builtins.property
    @jsii.member(jsii_name="placementVarInput")
    def placement_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionInput")
    def scale_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVarInput")
    def scale_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleVarInput")
    def scale_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4655618e1c2d32029975c4638703991f10784232d25a9b200f2a2ffdf18ae133)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6ab969c5f346310e150f30de14464fba99859fc2daa5f80a747ee023861d4867)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="placement")
    def placement(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placement"))

    @placement.setter
    def placement(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea2dbbc847871478a70233bf5780057255c635b94f8f3244ba59db80fdc2ca12)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placement", value)

    @builtins.property
    @jsii.member(jsii_name="placementVar")
    def placement_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placementVar"))

    @placement_var.setter
    def placement_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5718245a9d60d94b2adbfaf5ce5825c0307441d58dfeb4eb52e655f9ee2fd0b5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placementVar", value)

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scale"))

    @scale.setter
    def scale(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__16e77fde7ebf2ade9272095d64b6fd736227d3a7a7b89813c8e8182881572bbd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scale", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimension")
    def scale_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimension"))

    @scale_dimension.setter
    def scale_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3246f05875619576e6cc6c8fe4ed7d8f9aa8e957bef980544980c1d09e8104ac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimension", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVar")
    def scale_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimensionVar"))

    @scale_dimension_var.setter
    def scale_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7788917b66d46a5c114fb4ee70d0e649b8c96024a86912e837f68ec1be835cbe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="scaleVar")
    def scale_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleVar"))

    @scale_var.setter
    def scale_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__80cabc3441b8e653f36d4024653b19e854b4ab5ac3dfa0fbe6ebea17ac3bbf51)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__77b2c2a7225cd5507566be4082365ed754da4ff149c62d16c252b1edb04c104d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__02120def2a1698f0f35be25c1fbcacf899cc9cad28aed9c3388c56f3af0a643c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be3476c4038d49285465a0dc0e6eafe843d2c78d60ddb2753a390077e1aaa3d6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__760517a4696f87200636db420bc83a02a4a35b52901def4dba67dee9b216221d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeComposite]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeComposite]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeComposite]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ed627723d08f9562936d22eadfe5c29840e33b4c9d976d69ad8668e77c40cb1f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompound",
    jsii_struct_bases=[],
    name_mapping={"transformations": "transformations"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompound:
    def __init__(
        self,
        *,
        transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param transformations: transformations block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b033d9066c744c4ef0f0e92403724409363dd1edb0d3bbd753d2d6dfedfc2e67)
            check_type(argname="argument transformations", value=transformations, expected_type=type_hints["transformations"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if transformations is not None:
            self._values["transformations"] = transformations

    @builtins.property
    def transformations(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompoundTransformations"]]]:
        '''transformations block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        result = self._values.get("transformations")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompoundTransformations"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompound(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompoundList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompoundList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cc09548141dcc68fe58b98ceaa5684dc03a920a1008fbba6bd720c1f0757fed5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompoundOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ed1820d39f454c90598f4beffe18705569d81def79bc1057daefd7e938209e22)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompoundOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd0832e89b355be60dcb23daeaf3b9a6472aed92c5654fa0c3a1d7bbe7bc6ada)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__79623db50be96901d0e87d8586bdef8a4dcbef5531eed8eb2119286cf54ad6b3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ecf4bfca6b398a5d4f4bc2e28c1307a706b22903c7a39b08e93825a3e60a39ba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompound]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompound]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3f7eb87309069a1ed8424324a8d5d363f2f7aebef9d22d115453a32bc85e8fcb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompoundOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompoundOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__80377fd8e69696dd01c4e24fb3f00adaae16e8a63cb974255798096b2f530dd2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformations")
    def put_transformations(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b77d5a92c835fd3f642e25982777caa121747ee13b5685c52f61f35fb347a5d3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTransformations", [value]))

    @jsii.member(jsii_name="resetTransformations")
    def reset_transformations(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformations", []))

    @builtins.property
    @jsii.member(jsii_name="transformations")
    def transformations(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompoundTransformationsList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompoundTransformationsList", jsii.get(self, "transformations"))

    @builtins.property
    @jsii.member(jsii_name="transformationsInput")
    def transformations_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompoundTransformations"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompoundTransformations"]]], jsii.get(self, "transformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompound]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompound]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompound]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0e7aec1b11288021bb86f95343d596d230236d1223ec2ecbee5001fab1ed60cc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompoundTransformations",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompoundTransformations:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompoundTransformations(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompoundTransformationsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompoundTransformationsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f04e85cc6fc0056a1c19d24893494498ae80448ab9342e8a91c98787e66d0dfd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompoundTransformationsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fb9ae17e6de65ae2c8e82da8323cb2a4bf81e7ee8e28a6d05f62cd37f08d7d67)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompoundTransformationsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__000ffad4a4f7668c684c482b60f25dc92a5abb8cafd512b8dcf0bec76843b899)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__530de03ddea6e716daba4590d32987711a77c51ae3c2c63999b290165789ed03)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fe2386501edd5f618972544e11aa16e02e12028ef0f37141e9f6e0f5effbdb67)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompoundTransformations]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompoundTransformations]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompoundTransformations]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f33cb7b61ebd2dd3d969fe3ddbe93a2f839906526c9706a26eff6990e119cb7e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompoundTransformationsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompoundTransformationsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c510928fe669a7bdcca3fc670553a34c3e1e67d660d4675edd54a8aed9cd5602)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompoundTransformations]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompoundTransformations]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompoundTransformations]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2e3cacfb6e4386d141dece3e456b7df135ac702da1b3ab2cfcae517d36217218)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeContrast",
    jsii_struct_bases=[],
    name_mapping={
        "brightness": "brightness",
        "brightness_var": "brightnessVar",
        "contrast": "contrast",
        "contrast_var": "contrastVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeContrast:
    def __init__(
        self,
        *,
        brightness: typing.Optional[builtins.str] = None,
        brightness_var: typing.Optional[builtins.str] = None,
        contrast: typing.Optional[builtins.str] = None,
        contrast_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param brightness: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        :param brightness_var: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        :param contrast: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param contrast_var: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__33b3fdd5c2bc17cd29c208d3d6e04ca9642f68e45f1352b6efb21cbd90dfc2a3)
            check_type(argname="argument brightness", value=brightness, expected_type=type_hints["brightness"])
            check_type(argname="argument brightness_var", value=brightness_var, expected_type=type_hints["brightness_var"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument contrast_var", value=contrast_var, expected_type=type_hints["contrast_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if brightness is not None:
            self._values["brightness"] = brightness
        if brightness_var is not None:
            self._values["brightness_var"] = brightness_var
        if contrast is not None:
            self._values["contrast"] = contrast
        if contrast_var is not None:
            self._values["contrast_var"] = contrast_var

    @builtins.property
    def brightness(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        '''
        result = self._values.get("brightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def brightness_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        '''
        result = self._values.get("brightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        result = self._values.get("contrast_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeContrast(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeContrastList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeContrastList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3098229a2569d114cca9a573f050d77c9a22901cd4c725fe8582bd6e0cd980d4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeContrastOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7e7dea9ad26021373d334e9da2b3ce84c885dd8c06c0fb472426647116f11c01)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeContrastOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ba4d79cedf551a6aef13804048a53f6d29392b4566b747337a4d41a55172021c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__054eaa4748e1fcb9db5a4fcecb27254f901f4d6e4644014edf56d033f0d2d147)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2caaa3e8f78108c97bfbeea15cb34428bcb9f4f96701b98df634b70166921bbf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeContrast]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeContrast]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5307587420a203392faa24e3507ed8eeaf8ca1434f8251039edc6df34503ab84)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeContrastOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeContrastOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__98ca125ce30fd2a46e799630a05a324084f7b2ab4711c502ea860fbd2a5352a3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetBrightness")
    def reset_brightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightness", []))

    @jsii.member(jsii_name="resetBrightnessVar")
    def reset_brightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightnessVar", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetContrastVar")
    def reset_contrast_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrastVar", []))

    @builtins.property
    @jsii.member(jsii_name="brightnessInput")
    def brightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="brightnessVarInput")
    def brightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastVarInput")
    def contrast_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="brightness")
    def brightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightness"))

    @brightness.setter
    def brightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a6539a254e0f51bbde33dde6114a4c57af730bc1a4911b3ee2a9ede92997e59)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightness", value)

    @builtins.property
    @jsii.member(jsii_name="brightnessVar")
    def brightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightnessVar"))

    @brightness_var.setter
    def brightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5e2a84eef1f48cff085c7b2c6e83e47cfb98a3b10949e20a942274ff6264d650)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrast"))

    @contrast.setter
    def contrast(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__edbfabb779cb60b27627642d1b6bac693a169c837d39f6d2c3d5b09c1a678be5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrast", value)

    @builtins.property
    @jsii.member(jsii_name="contrastVar")
    def contrast_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrastVar"))

    @contrast_var.setter
    def contrast_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b81424cfcce3c6f5a488caee9f76893d6bdbf5bcb749183124f3bdb3a7a4ef4e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrastVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeContrast]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeContrast]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeContrast]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f4df19b96fab5df189c58e15644a82839ea3c6e6c6f62843e675d3eb54ad3b65)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeCrop",
    jsii_struct_bases=[],
    name_mapping={
        "allow_expansion": "allowExpansion",
        "allow_expansion_var": "allowExpansionVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeCrop:
    def __init__(
        self,
        *,
        allow_expansion: typing.Optional[builtins.str] = None,
        allow_expansion_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_expansion: If cropping an area outside of the existing canvas, expands the image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        :param allow_expansion_var: If cropping an area outside of the existing canvas, expands the image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        :param gravity: Frame of reference for X and Y Positions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Frame of reference for X and Y Positions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The number of pixels to crop along the y-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The number of pixels to crop along the y-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The number of pixels to crop along the x-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The number of pixels to crop along the x-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        :param x_position: The x-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0c56a18fdec0d86640dc4f18635aebf6c84ce86f2a8c8d926caedaa6ebb1c7b9)
            check_type(argname="argument allow_expansion", value=allow_expansion, expected_type=type_hints["allow_expansion"])
            check_type(argname="argument allow_expansion_var", value=allow_expansion_var, expected_type=type_hints["allow_expansion_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if allow_expansion is not None:
            self._values["allow_expansion"] = allow_expansion
        if allow_expansion_var is not None:
            self._values["allow_expansion_var"] = allow_expansion_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def allow_expansion(self) -> typing.Optional[builtins.str]:
        '''If cropping an area outside of the existing canvas, expands the image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        '''
        result = self._values.get("allow_expansion")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def allow_expansion_var(self) -> typing.Optional[builtins.str]:
        '''If cropping an area outside of the existing canvas, expands the image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        '''
        result = self._values.get("allow_expansion_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Frame of reference for X and Y Positions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Frame of reference for X and Y Positions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the y-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the y-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the x-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the x-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__957114655d566d8dcb1c1ece56d81fcd66a565e6ac635831fe9903597c1ddb04)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ad4d200a8501ddda3ea7dc69290e22e295d33a950ceb736bb95e5edb00f07515)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__146c599573c80af446465298e3644db5932f6ee8bee80d3a28c35e84d1540796)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__65e571d88b26786bd088fcc41cffcb83bbc18d9cdc2c810f3c1187c342b0f505)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3f41205e274a56ced79b087e31b8c296eebd7d27f79005570b855d4b6271e2bb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1534f44507d9eb1e11ea66247de2389e2368e877c10ce35a322358826ea0f65e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__81760ce8f9dc2d1b7102cc92bd62d8bb47dc47c3387e61b632ef1fdacfa7730f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAllowExpansion")
    def reset_allow_expansion(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansion", []))

    @jsii.member(jsii_name="resetAllowExpansionVar")
    def reset_allow_expansion_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansionVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionInput")
    def allow_expansion_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVarInput")
    def allow_expansion_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansion")
    def allow_expansion(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansion"))

    @allow_expansion.setter
    def allow_expansion(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8090aa48f8c7fc4539bd8ccc816a215e813014a762bc3658d45dc41a9edeb5c0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansion", value)

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVar")
    def allow_expansion_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansionVar"))

    @allow_expansion_var.setter
    def allow_expansion_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a8cacce2c756ba7082a3c0ae4c82a37277f41a0aac6f8ef7135edbd5462b5e8b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansionVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5060e355163df77cd65d3e9faa416251a2248071352624c1a453fb73bc7023e3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b7f0eb5b0be6ee45a9532078262698f92d4c916db38edb2b2a4c452a738c491f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__40f2b55222e73c3b175ddf1e03ca3a3c9f978eab2e8b048742faf5dedddf02a5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__09d8d691ad42d18a5f8a3b900526acf2f1b1d8a15ba55853da90749d2fe56be3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8e8b1bcce855fed90eac8e35b126b558f9b6ed3b2f54f1ab6495d592bd030b2f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2f235351db2277b2271adf63aac95baaf86e7e44489e6a8034438e14ca2e11c6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6c951d4c21162e2b8800ef8b971aff9f682bb7f134098f3ebf537a778a4fab1a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4be1b8b412ec9bd3e6c2ddd2223f3b39592d73886e72613f83f7a198f5ed4962)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__95d562bcbbbeb5a654c550c01e3b57b94ebf9301f31bde61dd78771da08234d0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__456b4fb86a233bc2e952eab67a898459569e296e84f4e572246a8da6e462f734)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cdd71088c338458cd79acc377bcc6f788c1f8e8b3834c2387f1279e516388135)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeFaceCrop",
    jsii_struct_bases=[],
    name_mapping={
        "algorithm": "algorithm",
        "algorithm_var": "algorithmVar",
        "confidence": "confidence",
        "confidence_var": "confidenceVar",
        "fail_gravity": "failGravity",
        "fail_gravity_var": "failGravityVar",
        "focus": "focus",
        "focus_var": "focusVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "padding": "padding",
        "padding_var": "paddingVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeFaceCrop:
    def __init__(
        self,
        *,
        algorithm: typing.Optional[builtins.str] = None,
        algorithm_var: typing.Optional[builtins.str] = None,
        confidence: typing.Optional[builtins.str] = None,
        confidence_var: typing.Optional[builtins.str] = None,
        fail_gravity: typing.Optional[builtins.str] = None,
        fail_gravity_var: typing.Optional[builtins.str] = None,
        focus: typing.Optional[builtins.str] = None,
        focus_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param algorithm: Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm DataAkamaiImagingPolicyImage#algorithm}
        :param algorithm_var: Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm_var DataAkamaiImagingPolicyImage#algorithm_var}
        :param confidence: With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image. Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence DataAkamaiImagingPolicyImage#confidence}
        :param confidence_var: With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image. Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence_var DataAkamaiImagingPolicyImage#confidence_var}
        :param fail_gravity: Controls placement of the crop if Image and Video Manager does not detect any faces in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        :param fail_gravity_var: Controls placement of the crop if Image and Video Manager does not detect any faces in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        :param focus: Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus DataAkamaiImagingPolicyImage#focus}
        :param focus_var: Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus_var DataAkamaiImagingPolicyImage#focus_var}
        :param gravity: Controls placement of the crop. Directions are relative to the face(s) plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Controls placement of the crop. Directions are relative to the face(s) plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param padding: The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        :param style: Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a46cde272e51b3b9039d092458bae4bc5d65eb5659ca2f1a06d8c072cb7ccff9)
            check_type(argname="argument algorithm", value=algorithm, expected_type=type_hints["algorithm"])
            check_type(argname="argument algorithm_var", value=algorithm_var, expected_type=type_hints["algorithm_var"])
            check_type(argname="argument confidence", value=confidence, expected_type=type_hints["confidence"])
            check_type(argname="argument confidence_var", value=confidence_var, expected_type=type_hints["confidence_var"])
            check_type(argname="argument fail_gravity", value=fail_gravity, expected_type=type_hints["fail_gravity"])
            check_type(argname="argument fail_gravity_var", value=fail_gravity_var, expected_type=type_hints["fail_gravity_var"])
            check_type(argname="argument focus", value=focus, expected_type=type_hints["focus"])
            check_type(argname="argument focus_var", value=focus_var, expected_type=type_hints["focus_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if algorithm is not None:
            self._values["algorithm"] = algorithm
        if algorithm_var is not None:
            self._values["algorithm_var"] = algorithm_var
        if confidence is not None:
            self._values["confidence"] = confidence
        if confidence_var is not None:
            self._values["confidence_var"] = confidence_var
        if fail_gravity is not None:
            self._values["fail_gravity"] = fail_gravity
        if fail_gravity_var is not None:
            self._values["fail_gravity_var"] = fail_gravity_var
        if focus is not None:
            self._values["focus"] = focus
        if focus_var is not None:
            self._values["focus_var"] = focus_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def algorithm(self) -> typing.Optional[builtins.str]:
        '''Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm DataAkamaiImagingPolicyImage#algorithm}
        '''
        result = self._values.get("algorithm")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def algorithm_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm_var DataAkamaiImagingPolicyImage#algorithm_var}
        '''
        result = self._values.get("algorithm_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def confidence(self) -> typing.Optional[builtins.str]:
        '''With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image.

        Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence DataAkamaiImagingPolicyImage#confidence}
        '''
        result = self._values.get("confidence")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def confidence_var(self) -> typing.Optional[builtins.str]:
        '''With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image.

        Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence_var DataAkamaiImagingPolicyImage#confidence_var}
        '''
        result = self._values.get("confidence_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any faces in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        '''
        result = self._values.get("fail_gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any faces in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        '''
        result = self._values.get("fail_gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def focus(self) -> typing.Optional[builtins.str]:
        '''Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus DataAkamaiImagingPolicyImage#focus}
        '''
        result = self._values.get("focus")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def focus_var(self) -> typing.Optional[builtins.str]:
        '''Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus_var DataAkamaiImagingPolicyImage#focus_var}
        '''
        result = self._values.get("focus_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the face(s) plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the face(s) plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeFaceCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeFaceCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeFaceCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c7b2bb7e6a3b8b5fa088e43b8b66ed838f894fe1983d41132aa88cef4e42b8c4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeFaceCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1aaa320e176059119cf30f890788f9d1ebd3ea045230b05b2b873c6b64044dbf)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeFaceCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__59c1e793f6bbd4f769bbe9cd70f24b3e71fcbe6a1e1cf41421a567578da6ea77)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d2d9c85b0e6601814285db3eea049a3cfe9b14f8510bdd1062c61f19dc80ad8e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__605d23b8b7f8a23e30b0c0b7a90f3e3610ed44dc13c1bf0bb246e2ac4dec177c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeFaceCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeFaceCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeFaceCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c3c2fa841773a0ee8ea4cc7e2e0ad2bc69ac31372b5501f7bf9cb9eda37bc80c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeFaceCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeFaceCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8ad566c5263ad64ede1ad3debb2a52721e7500121ed7bd3cc2e47b52e5920642)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAlgorithm")
    def reset_algorithm(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAlgorithm", []))

    @jsii.member(jsii_name="resetAlgorithmVar")
    def reset_algorithm_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAlgorithmVar", []))

    @jsii.member(jsii_name="resetConfidence")
    def reset_confidence(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetConfidence", []))

    @jsii.member(jsii_name="resetConfidenceVar")
    def reset_confidence_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetConfidenceVar", []))

    @jsii.member(jsii_name="resetFailGravity")
    def reset_fail_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravity", []))

    @jsii.member(jsii_name="resetFailGravityVar")
    def reset_fail_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravityVar", []))

    @jsii.member(jsii_name="resetFocus")
    def reset_focus(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFocus", []))

    @jsii.member(jsii_name="resetFocusVar")
    def reset_focus_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFocusVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="algorithmInput")
    def algorithm_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "algorithmInput"))

    @builtins.property
    @jsii.member(jsii_name="algorithmVarInput")
    def algorithm_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "algorithmVarInput"))

    @builtins.property
    @jsii.member(jsii_name="confidenceInput")
    def confidence_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "confidenceInput"))

    @builtins.property
    @jsii.member(jsii_name="confidenceVarInput")
    def confidence_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "confidenceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityInput")
    def fail_gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityVarInput")
    def fail_gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="focusInput")
    def focus_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "focusInput"))

    @builtins.property
    @jsii.member(jsii_name="focusVarInput")
    def focus_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "focusVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="algorithm")
    def algorithm(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "algorithm"))

    @algorithm.setter
    def algorithm(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__270ab6327a5409e766ad5e3dbc25522f80c8d12e70633df2675264d48ae73726)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "algorithm", value)

    @builtins.property
    @jsii.member(jsii_name="algorithmVar")
    def algorithm_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "algorithmVar"))

    @algorithm_var.setter
    def algorithm_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__207d34b900205c60a275f664052fcf7b92a476c9958a54af927b840b995f0450)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "algorithmVar", value)

    @builtins.property
    @jsii.member(jsii_name="confidence")
    def confidence(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "confidence"))

    @confidence.setter
    def confidence(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c4e2fc1f46538386b70d716fd29f88aafe3fa306b9e404ed11c2952badc532ad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "confidence", value)

    @builtins.property
    @jsii.member(jsii_name="confidenceVar")
    def confidence_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "confidenceVar"))

    @confidence_var.setter
    def confidence_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__082fd205fcf521df586d25eb9795d9b3c89e3b024de292a57732c5a9c87e5e96)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "confidenceVar", value)

    @builtins.property
    @jsii.member(jsii_name="failGravity")
    def fail_gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravity"))

    @fail_gravity.setter
    def fail_gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d4297480413b7b72bf713c45000d6fa65134ec6725981792efd08654d34d07f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravity", value)

    @builtins.property
    @jsii.member(jsii_name="failGravityVar")
    def fail_gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravityVar"))

    @fail_gravity_var.setter
    def fail_gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bd1ee6be20df895b55aeaffd4fddaf5f791411e73014262b1b7d3bae1546ca51)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="focus")
    def focus(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "focus"))

    @focus.setter
    def focus(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__005bc1d4791319edb24f9ecb6c1ca4e8bc6d359ecfd69884c1f74c734bf56af9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "focus", value)

    @builtins.property
    @jsii.member(jsii_name="focusVar")
    def focus_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "focusVar"))

    @focus_var.setter
    def focus_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__02342f9c7016f60f28a465a6949b1811ba2db69f9f4a5df08747bfe067b485e8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "focusVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__131df25e1900f98ea7d482bcc0d8767ebd5d3ed41fa6b54e316de93f5667ab60)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a15cd103ea9cff556e3f2e46a95258c4b14a6b7f644e544b70a802ee77bc90f9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4abc54f9bb1a5e5960b5114b295fb7567d07c72418010896d3e2298fc6edfaa3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7a19184255a2697bdc43aa610ac28dd426faee4208ffe6fd6d4ab9bac54f0f56)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e3813b427bf0121c89540fb39f7bd7430017d76ed089040c466cf1bb671a0416)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1a6be838aff0c29b6e4e090f5ce7767729ff0846115eb786e7d6d8a5e462b9c6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__82fe9a8429d78a41009d5d9ff4c46ba8df11ffef0bd227fb21dc948c4b7061a8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0db6a14697d7336ceb43bf04b9de56220930e4b402a767618f363f646e77399d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e64d09e254b43dd6d51cf78070de9819048627a3336dd60e82133245b31e8481)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3e75bbdea6f278bb55eb1d0b0f33f45c41003343413263bb035c8bd30f9ce488)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeFaceCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeFaceCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeFaceCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5d1221bc6b94839655c3584687a6cc4b4071ec86709674bb2767943c47e6cec3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeFeatureCrop",
    jsii_struct_bases=[],
    name_mapping={
        "fail_gravity": "failGravity",
        "fail_gravity_var": "failGravityVar",
        "feature_radius": "featureRadius",
        "feature_radius_var": "featureRadiusVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "max_features": "maxFeatures",
        "max_features_var": "maxFeaturesVar",
        "min_feature_quality": "minFeatureQuality",
        "min_feature_quality_var": "minFeatureQualityVar",
        "padding": "padding",
        "padding_var": "paddingVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeFeatureCrop:
    def __init__(
        self,
        *,
        fail_gravity: typing.Optional[builtins.str] = None,
        fail_gravity_var: typing.Optional[builtins.str] = None,
        feature_radius: typing.Optional[builtins.str] = None,
        feature_radius_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        max_features: typing.Optional[builtins.str] = None,
        max_features_var: typing.Optional[builtins.str] = None,
        min_feature_quality: typing.Optional[builtins.str] = None,
        min_feature_quality_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fail_gravity: Controls placement of the crop if Image and Video Manager does not detect any features in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        :param fail_gravity_var: Controls placement of the crop if Image and Video Manager does not detect any features in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        :param feature_radius: The size in pixels of the important features to search for. If identified, two features never appear closer together than this value, ``8.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius DataAkamaiImagingPolicyImage#feature_radius}
        :param feature_radius_var: The size in pixels of the important features to search for. If identified, two features never appear closer together than this value, ``8.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius_var DataAkamaiImagingPolicyImage#feature_radius_var}
        :param gravity: Controls placement of the crop. Directions are relative to the region of interest plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Controls placement of the crop. Directions are relative to the region of interest plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param max_features: The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features DataAkamaiImagingPolicyImage#max_features}
        :param max_features_var: The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features_var DataAkamaiImagingPolicyImage#max_features_var}
        :param min_feature_quality: Determines the minimum quality level of the feature identified. To consider a feature important, the feature needs to surpass this value. Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality DataAkamaiImagingPolicyImage#min_feature_quality}
        :param min_feature_quality_var: Determines the minimum quality level of the feature identified. To consider a feature important, the feature needs to surpass this value. Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality_var DataAkamaiImagingPolicyImage#min_feature_quality_var}
        :param padding: Adds space around the region of interest. The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: Adds space around the region of interest. The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        :param style: Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__88bd3c2d45e012607b518bb962210750321339b1d9f63a44161e86e715406a20)
            check_type(argname="argument fail_gravity", value=fail_gravity, expected_type=type_hints["fail_gravity"])
            check_type(argname="argument fail_gravity_var", value=fail_gravity_var, expected_type=type_hints["fail_gravity_var"])
            check_type(argname="argument feature_radius", value=feature_radius, expected_type=type_hints["feature_radius"])
            check_type(argname="argument feature_radius_var", value=feature_radius_var, expected_type=type_hints["feature_radius_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument max_features", value=max_features, expected_type=type_hints["max_features"])
            check_type(argname="argument max_features_var", value=max_features_var, expected_type=type_hints["max_features_var"])
            check_type(argname="argument min_feature_quality", value=min_feature_quality, expected_type=type_hints["min_feature_quality"])
            check_type(argname="argument min_feature_quality_var", value=min_feature_quality_var, expected_type=type_hints["min_feature_quality_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fail_gravity is not None:
            self._values["fail_gravity"] = fail_gravity
        if fail_gravity_var is not None:
            self._values["fail_gravity_var"] = fail_gravity_var
        if feature_radius is not None:
            self._values["feature_radius"] = feature_radius
        if feature_radius_var is not None:
            self._values["feature_radius_var"] = feature_radius_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if max_features is not None:
            self._values["max_features"] = max_features
        if max_features_var is not None:
            self._values["max_features_var"] = max_features_var
        if min_feature_quality is not None:
            self._values["min_feature_quality"] = min_feature_quality
        if min_feature_quality_var is not None:
            self._values["min_feature_quality_var"] = min_feature_quality_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def fail_gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any features in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        '''
        result = self._values.get("fail_gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any features in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        '''
        result = self._values.get("fail_gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feature_radius(self) -> typing.Optional[builtins.str]:
        '''The size in pixels of the important features to search for.

        If identified, two features never appear closer together than this value, ``8.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius DataAkamaiImagingPolicyImage#feature_radius}
        '''
        result = self._values.get("feature_radius")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feature_radius_var(self) -> typing.Optional[builtins.str]:
        '''The size in pixels of the important features to search for.

        If identified, two features never appear closer together than this value, ``8.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius_var DataAkamaiImagingPolicyImage#feature_radius_var}
        '''
        result = self._values.get("feature_radius_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the region of interest plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the region of interest plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def max_features(self) -> typing.Optional[builtins.str]:
        '''The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features DataAkamaiImagingPolicyImage#max_features}
        '''
        result = self._values.get("max_features")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def max_features_var(self) -> typing.Optional[builtins.str]:
        '''The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features_var DataAkamaiImagingPolicyImage#max_features_var}
        '''
        result = self._values.get("max_features_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def min_feature_quality(self) -> typing.Optional[builtins.str]:
        '''Determines the minimum quality level of the feature identified.

        To consider a feature important, the feature needs to surpass this value.  Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality DataAkamaiImagingPolicyImage#min_feature_quality}
        '''
        result = self._values.get("min_feature_quality")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def min_feature_quality_var(self) -> typing.Optional[builtins.str]:
        '''Determines the minimum quality level of the feature identified.

        To consider a feature important, the feature needs to surpass this value.  Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality_var DataAkamaiImagingPolicyImage#min_feature_quality_var}
        '''
        result = self._values.get("min_feature_quality_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''Adds space around the region of interest.

        The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''Adds space around the region of interest.

        The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeFeatureCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeFeatureCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeFeatureCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cba073eaeb8eaac082d36370380a3460403d50be82b8535543fb21a94e473b74)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeFeatureCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3f8800ce8aad66084b2dee9dcc58c877b8cb64b84909383dd7480a5d58576e81)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeFeatureCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__66c06d9cc0ef82c7b58661fe0643c2872f87f8c75e956bdfe3c0b41b62931747)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c7b83adb8b6a57873d15244c309382de4c325dcf8d7b31aba2477049ef613350)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__670e8a672b1538e4473db57933de3d3c895f6c55711256da48a7df49ce942b63)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeFeatureCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeFeatureCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeFeatureCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1d9d2ba47a9b9e4403212c6e55a7ce0adbe4093e5222791a53efa22f8d582933)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeFeatureCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeFeatureCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fc5f296c4188b256c1336c9c0fe5c5c4706d90d644e2facdd30ecf2d75670f4a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetFailGravity")
    def reset_fail_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravity", []))

    @jsii.member(jsii_name="resetFailGravityVar")
    def reset_fail_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravityVar", []))

    @jsii.member(jsii_name="resetFeatureRadius")
    def reset_feature_radius(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureRadius", []))

    @jsii.member(jsii_name="resetFeatureRadiusVar")
    def reset_feature_radius_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureRadiusVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetMaxFeatures")
    def reset_max_features(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxFeatures", []))

    @jsii.member(jsii_name="resetMaxFeaturesVar")
    def reset_max_features_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxFeaturesVar", []))

    @jsii.member(jsii_name="resetMinFeatureQuality")
    def reset_min_feature_quality(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMinFeatureQuality", []))

    @jsii.member(jsii_name="resetMinFeatureQualityVar")
    def reset_min_feature_quality_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMinFeatureQualityVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="failGravityInput")
    def fail_gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityVarInput")
    def fail_gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featureRadiusInput")
    def feature_radius_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featureRadiusInput"))

    @builtins.property
    @jsii.member(jsii_name="featureRadiusVarInput")
    def feature_radius_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featureRadiusVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesInput")
    def max_features_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "maxFeaturesInput"))

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesVarInput")
    def max_features_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "maxFeaturesVarInput"))

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityInput")
    def min_feature_quality_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "minFeatureQualityInput"))

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityVarInput")
    def min_feature_quality_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "minFeatureQualityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravity")
    def fail_gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravity"))

    @fail_gravity.setter
    def fail_gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a5ea5633516325ed06d1fe51fde25e07b812d094eb3a171874858c810c40cdcb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravity", value)

    @builtins.property
    @jsii.member(jsii_name="failGravityVar")
    def fail_gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravityVar"))

    @fail_gravity_var.setter
    def fail_gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f463588fe52eb2206b3eb08b68a3129b068c2f176df5e7eef3cde6dd3f29f25b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="featureRadius")
    def feature_radius(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featureRadius"))

    @feature_radius.setter
    def feature_radius(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e27a7fe8c2c98f6012cc2491674932c9e0e8765b0f315565d4f19315d8fefcf2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featureRadius", value)

    @builtins.property
    @jsii.member(jsii_name="featureRadiusVar")
    def feature_radius_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featureRadiusVar"))

    @feature_radius_var.setter
    def feature_radius_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa29d624d4f37657e406c2d26a0fa76078d6dd335b5dce043089b07bd5ea240e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featureRadiusVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__890b4d3e2e0f563cc05188ae44160d98d06a1b31132a535cf691302a30aa0e24)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__08a005b6abe2941340987c58feb67bbbfd089d6c41fa9ceca8cd4543f4e01c9e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3af9fa8b2ba0f3a2652196c340c49ac59a6724e7bdc5db6b752eee2b78ca3c45)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__79fa30b504a142b6c70eb0897c480c8ea7e384239bbf21cbfd286cf69f744695)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="maxFeatures")
    def max_features(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "maxFeatures"))

    @max_features.setter
    def max_features(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d1ade6ec68219ac99d0802f412620d2b4ef0d6f9afad75cad5329abdf458ba37)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "maxFeatures", value)

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesVar")
    def max_features_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "maxFeaturesVar"))

    @max_features_var.setter
    def max_features_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__145ac3801dcd94b53bf94926bc365c890fae81ed2732b9e51986f16a474b6153)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "maxFeaturesVar", value)

    @builtins.property
    @jsii.member(jsii_name="minFeatureQuality")
    def min_feature_quality(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "minFeatureQuality"))

    @min_feature_quality.setter
    def min_feature_quality(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2c0e6560115b951717b5b77e3f8f3f63b03b281062f12bf296888d19a627e648)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "minFeatureQuality", value)

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityVar")
    def min_feature_quality_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "minFeatureQualityVar"))

    @min_feature_quality_var.setter
    def min_feature_quality_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fe30e290792316892438337228e79d2138c1986b8517bfb73385d401b816ef18)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "minFeatureQualityVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f4fe7636d5d97d7c62cb598fc154a008e920e2235427c606849e543e9f0d87ef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c2e7a6ae4c2684ee99fe25f620c0174fe1538fa30b1781d6f785a10317e72593)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f466f77343d9d2946206f62f7b109c1d334382ec4d4878856dcb0cbc3cb9822b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4e8af2cdb9675a3b9c9e81acce922e16ef56b9064767ecdc2f93e7d0ba4ce4b0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__88c78cb0839226249290f29d59deafb0e574639ee15f571f3fa770cca6d48bb4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__464b538a3dd026a6968add89f41189ca49544eb8cef267ee00d90251cf9df041)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeFeatureCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeFeatureCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeFeatureCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a2e88e4d5ec9e8c612a3c8f5e8bc549912738574441a6c36cccefae81c098e0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeFitAndFill",
    jsii_struct_bases=[],
    name_mapping={
        "fill_transformation": "fillTransformation",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeFitAndFill:
    def __init__(
        self,
        *,
        fill_transformation: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeFitAndFillFillTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fill_transformation: fill_transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_transformation DataAkamaiImagingPolicyImage#fill_transformation}
        :param height: The height value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The width value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(fill_transformation, dict):
            fill_transformation = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeFitAndFillFillTransformation(**fill_transformation)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fcd0a5eddb771ebe5a75a7f8ffcf09b5f762c65a8af2537a6e43fe9a3c730cd8)
            check_type(argname="argument fill_transformation", value=fill_transformation, expected_type=type_hints["fill_transformation"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fill_transformation is not None:
            self._values["fill_transformation"] = fill_transformation
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def fill_transformation(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeFitAndFillFillTransformation"]:
        '''fill_transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_transformation DataAkamaiImagingPolicyImage#fill_transformation}
        '''
        result = self._values.get("fill_transformation")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeFitAndFillFillTransformation"], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeFitAndFill(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeFitAndFillFillTransformation",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeFitAndFillFillTransformation:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeFitAndFillFillTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeFitAndFillFillTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeFitAndFillFillTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a7bb9a5c0445493d03cca90611e7f0e249d3c449bb06be13817dcccb4307dc97)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeFitAndFillFillTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeFitAndFillFillTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeFitAndFillFillTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f90b32c277f4f61e2604b9a5cd6a266ff6e385129168c3f409b4c652f1263e9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeFitAndFillList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeFitAndFillList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6270e68fd012f24fe23460d3cebbfb473f6abc25641376df3a9112cef06980c3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeFitAndFillOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__412f826d3ee416c57e61abb318345ab2c6b7d4c7e90d9e21ecc9f42a759b73a5)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeFitAndFillOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f28e846a0df636e99a998c33bcf6b68047a747d0d7df73fa8e93f678d01bae18)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__841d2be1db3291cc74b73780aa39b5ef19b5c8579c3a4bdd440613e8d3dca006)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__21f7ba17050bbe5b60fd541f3d1be2a5995cc395b8a9b1a35c14b5159053d67b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeFitAndFill]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeFitAndFill]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeFitAndFill]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1e973a991256d53f22c2c7c61a4720f99bf5bf66e73a71d325299a5e4efcf68f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeFitAndFillOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeFitAndFillOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7cfaf27dc24faad405ca7340989df8f06645f06fee9bc1a25a1d71a7cf9d14dc)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putFillTransformation")
    def put_fill_transformation(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeFitAndFillFillTransformation()

        return typing.cast(None, jsii.invoke(self, "putFillTransformation", [value]))

    @jsii.member(jsii_name="resetFillTransformation")
    def reset_fill_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFillTransformation", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="fillTransformation")
    def fill_transformation(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeFitAndFillFillTransformationOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeFitAndFillFillTransformationOutputReference, jsii.get(self, "fillTransformation"))

    @builtins.property
    @jsii.member(jsii_name="fillTransformationInput")
    def fill_transformation_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeFitAndFillFillTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeFitAndFillFillTransformation], jsii.get(self, "fillTransformationInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ae632d18c67b3ea7855b52af225abd0d13f3745696b81d480bbbd34868d5a55)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__31b4acd2f5807d014eb34f7581f40da8c9dfbfcea88a6c1d57369835de045b89)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c8fda031561c75ca91a1b30c51155fe415176477dac9c0a4e95abf5ce36ea3e9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__84588eefd36ebeeb5b059376f16b2018525d48f13d5409e19661d7e5d60f8416)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeFitAndFill]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeFitAndFill]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeFitAndFill]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__573ba8f4cf8b1aa95bff812ca266d603d9fda5b2966effd7fde829c2c86c8608)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeGoop",
    jsii_struct_bases=[],
    name_mapping={
        "chaos": "chaos",
        "chaos_var": "chaosVar",
        "density": "density",
        "density_var": "densityVar",
        "power": "power",
        "power_var": "powerVar",
        "seed": "seed",
        "seed_var": "seedVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeGoop:
    def __init__(
        self,
        *,
        chaos: typing.Optional[builtins.str] = None,
        chaos_var: typing.Optional[builtins.str] = None,
        density: typing.Optional[builtins.str] = None,
        density_var: typing.Optional[builtins.str] = None,
        power: typing.Optional[builtins.str] = None,
        power_var: typing.Optional[builtins.str] = None,
        seed: typing.Optional[builtins.str] = None,
        seed_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param chaos: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        :param chaos_var: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        :param density: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        :param density_var: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        :param power: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        :param power_var: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        :param seed: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        :param seed_var: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b98994db3acc03fc7c46be2921fd058b1a8857f70aaa6ed2e82ae7138a4cc8a3)
            check_type(argname="argument chaos", value=chaos, expected_type=type_hints["chaos"])
            check_type(argname="argument chaos_var", value=chaos_var, expected_type=type_hints["chaos_var"])
            check_type(argname="argument density", value=density, expected_type=type_hints["density"])
            check_type(argname="argument density_var", value=density_var, expected_type=type_hints["density_var"])
            check_type(argname="argument power", value=power, expected_type=type_hints["power"])
            check_type(argname="argument power_var", value=power_var, expected_type=type_hints["power_var"])
            check_type(argname="argument seed", value=seed, expected_type=type_hints["seed"])
            check_type(argname="argument seed_var", value=seed_var, expected_type=type_hints["seed_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if chaos is not None:
            self._values["chaos"] = chaos
        if chaos_var is not None:
            self._values["chaos_var"] = chaos_var
        if density is not None:
            self._values["density"] = density
        if density_var is not None:
            self._values["density_var"] = density_var
        if power is not None:
            self._values["power"] = power
        if power_var is not None:
            self._values["power_var"] = power_var
        if seed is not None:
            self._values["seed"] = seed
        if seed_var is not None:
            self._values["seed_var"] = seed_var

    @builtins.property
    def chaos(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        '''
        result = self._values.get("chaos")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def chaos_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        '''
        result = self._values.get("chaos_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        '''
        result = self._values.get("density")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density_var(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        '''
        result = self._values.get("density_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        '''
        result = self._values.get("power")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power_var(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        '''
        result = self._values.get("power_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        '''
        result = self._values.get("seed")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed_var(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        result = self._values.get("seed_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeGoop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeGoopList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeGoopList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b0eea9bf82be6b9789a42f1ae79966f38dd8b9554975888ee2a50f2172570bd7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeGoopOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b1b6514780c9bd13b18adf840710e4a6f7df1cb577fe21b4d89cce5b0bb8802b)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeGoopOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__147041f3c71a88b7aaa6f5f67316fd89cffb677c4e015f1945b4bd92dc14d730)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3d60398764334bea4a231c8c0b191e1c33c65a612fcb9acbbc04dd2636ac52da)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f201ae57646709100c567d99dc1567a80774133c6961dbb5fcde1157112d8fd0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeGoop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeGoop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e77f1a187ad801e5a73600fe1157b3e7c040c9e01db2a91956d9d1eaf007f8cc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeGoopOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeGoopOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4f39b3b066c5a19dc2b7112a1943bf8f34da66886056a4d8d4cc73e4211a7211)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetChaos")
    def reset_chaos(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaos", []))

    @jsii.member(jsii_name="resetChaosVar")
    def reset_chaos_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaosVar", []))

    @jsii.member(jsii_name="resetDensity")
    def reset_density(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensity", []))

    @jsii.member(jsii_name="resetDensityVar")
    def reset_density_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensityVar", []))

    @jsii.member(jsii_name="resetPower")
    def reset_power(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPower", []))

    @jsii.member(jsii_name="resetPowerVar")
    def reset_power_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPowerVar", []))

    @jsii.member(jsii_name="resetSeed")
    def reset_seed(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeed", []))

    @jsii.member(jsii_name="resetSeedVar")
    def reset_seed_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeedVar", []))

    @builtins.property
    @jsii.member(jsii_name="chaosInput")
    def chaos_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosInput"))

    @builtins.property
    @jsii.member(jsii_name="chaosVarInput")
    def chaos_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosVarInput"))

    @builtins.property
    @jsii.member(jsii_name="densityInput")
    def density_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityInput"))

    @builtins.property
    @jsii.member(jsii_name="densityVarInput")
    def density_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="powerInput")
    def power_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerInput"))

    @builtins.property
    @jsii.member(jsii_name="powerVarInput")
    def power_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerVarInput"))

    @builtins.property
    @jsii.member(jsii_name="seedInput")
    def seed_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedInput"))

    @builtins.property
    @jsii.member(jsii_name="seedVarInput")
    def seed_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedVarInput"))

    @builtins.property
    @jsii.member(jsii_name="chaos")
    def chaos(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaos"))

    @chaos.setter
    def chaos(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b76a180c197c05eef6d557984752d42bc88de82ab454c8d12d4bcb9ba4d297d0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaos", value)

    @builtins.property
    @jsii.member(jsii_name="chaosVar")
    def chaos_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaosVar"))

    @chaos_var.setter
    def chaos_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__626e04a51dd4f2acf908a0ddd439ff28fc4c79b9319647a0c90bc3f8bf390b00)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaosVar", value)

    @builtins.property
    @jsii.member(jsii_name="density")
    def density(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "density"))

    @density.setter
    def density(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__442afc8697ea4b020524232426738ab89028f5cdc2c1084bbde464393f52f5c8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "density", value)

    @builtins.property
    @jsii.member(jsii_name="densityVar")
    def density_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "densityVar"))

    @density_var.setter
    def density_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c869a1694ff0cc3fe915cece99327a13590134f23545e4e1ac28bebf4ce4c8d6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "densityVar", value)

    @builtins.property
    @jsii.member(jsii_name="power")
    def power(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "power"))

    @power.setter
    def power(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fc68eb50d399bbdbf6995c9750fe2507d1b7b5d1424959005b2314a4899d7e76)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "power", value)

    @builtins.property
    @jsii.member(jsii_name="powerVar")
    def power_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "powerVar"))

    @power_var.setter
    def power_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df79aadbefa6ce91f2acf70a1f778b2ffaee92355feeeb33a5a5118dc64997d7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "powerVar", value)

    @builtins.property
    @jsii.member(jsii_name="seed")
    def seed(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seed"))

    @seed.setter
    def seed(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bbcc1bead79b19bcece694ffd7e5004e3e58b6053b60da347fbadae97d4da5ba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seed", value)

    @builtins.property
    @jsii.member(jsii_name="seedVar")
    def seed_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seedVar"))

    @seed_var.setter
    def seed_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ae085c2078b0af21fdb072f64c8840241bb0c5e3bfe7b321196dc8e74395cdbc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seedVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeGoop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeGoop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeGoop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0f6891b69e14f9d34151d6d6d8d6382f2899ad1ff59a0260d794cfda5ee50f84)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeGrayscale",
    jsii_struct_bases=[],
    name_mapping={"type": "type", "type_var": "typeVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeGrayscale:
    def __init__(
        self,
        *,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param type: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__19f16bfd29620d3020d492bfbafd881847a7fbc9458067698a58dbfe053b51bb)
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeGrayscale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeGrayscaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeGrayscaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8ea3f918a02211a1e0a939763e6ff69161699bb7099a8be31f4f14f6aa089893)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeGrayscaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4074221a3f381813fa48e12ee82099f114891494c37d2009786a0cb2bf58007b)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeGrayscaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__457dc6df7d7222ded1dd6d394c9c14f716b620de723fe0882982136fc37c6280)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4e4499504ace72baaa0714fc44da5eabf06077065da421fed3dac94706f0c275)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d5e9f4a54bee46a623ee693166996b5a4166f5a583eba173756cd6ce5583bfe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeGrayscale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeGrayscale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b012aa26b165d38f4fb5df1c669e286d5487fa565620adc5afee8be2611ea330)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeGrayscaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeGrayscaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__79ced125177a0953009a170599f7ce1dd91f0d783092bb37dadd0b96fdf0776b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5144fa194dde0f00a8818cc39d032a3c8fe94f19a0125743f2917d12883e520b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f624d0f930cc7d8260aac6b49169c240fd5bd1a195cf2e2b60140a7a38fbdad1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeGrayscale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeGrayscale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeGrayscale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e4fdb9d38e5232375ce9dee6909d6e01f6ed30d06abc59b9bf468ab55a324f2c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeHsl",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "lightness": "lightness",
        "lightness_var": "lightnessVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeHsl:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness: typing.Optional[builtins.str] = None,
        lightness_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        :param lightness_var: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d66515866039fc94be133ad7cb97a434246c670c3aa7880144c9b051c8fea3d6)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness", value=lightness, expected_type=type_hints["lightness"])
            check_type(argname="argument lightness_var", value=lightness_var, expected_type=type_hints["lightness_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness is not None:
            self._values["lightness"] = lightness
        if lightness_var is not None:
            self._values["lightness_var"] = lightness_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        '''
        result = self._values.get("lightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        '''
        result = self._values.get("lightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeHsl(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeHslList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeHslList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ad9bd5095b1f9bfcd7d7c531857e9163b56357d0288aeb1730035da4c9f01ea2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeHslOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__15f6b767fd170dfddbff9eb454c61c4b94ebdf8c9723bc2355c52b8f48af30f1)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeHslOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5524b4f0604ed8a0f2ec8d1a9834ff69e5c449b44a4f5e87859e493b33d105f6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be4b370913f07da5902364565f7a12e980fc44f5926a437d30ae5ef2b2609c1b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e22a5a92c68b2f92565a509dbfba7e8632f49c51e551973140e845fbd855ce65)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeHsl]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeHsl]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8f958dd58143bdf7b62585702cf1a6fa8301aefc9f5fd6deb880d6d80e001d1a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeHslOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeHslOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__897b5ec06c6ea8ef3d587c0dad2a4c427aeedf8652b621069988aa2a6d6d8f40)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightness")
    def reset_lightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightness", []))

    @jsii.member(jsii_name="resetLightnessVar")
    def reset_lightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessInput")
    def lightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessVarInput")
    def lightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0b1b35edfc004c6f3fe2787834ec05956e9ffb74c1e33114bbd5d2649d576e14)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__74f7dd71837c626d87d318782a2599b22cfe3b573f76ebcb62d007e92945b29d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightness")
    def lightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightness"))

    @lightness.setter
    def lightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__65f2ed99469b8852214907d97ae223b476ef9bb5419fb41cd22b296e0d4fd1ac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightness", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessVar")
    def lightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessVar"))

    @lightness_var.setter
    def lightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__edeb1448046b6d99883a65e7aca4cfd3275282d0560a8adff58bd6e4e7bbc479)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__936bf862e872868001b26b8a568bf65e156271567cd6b2e79dbe34472441a478)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a0ecb27fb0734df61e3972af6097f58d23fe4b5f333fb384cf8b3cf81be2416c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeHsl]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeHsl]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeHsl]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__976726973b2efa97773f0aba76b493d05c4a75ad985bde087a332c5ebf1fc1a9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeHsv",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeHsv:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        :param value: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__489f6f10e0a187cf035cb72c8c4516d3ede64c3e06ca6f1093f6816b16fd0ead)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeHsv(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeHsvList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeHsvList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d97ea29fb1372533333a3040cd609c27d4f82ab14c095670775e0f92d1873533)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeHsvOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__70871bd7b8234b485a2e8ad0968a0fcf6fefbfde2b82b726c2ade2ba39a4d5e8)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeHsvOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__263c3286cba3d11f4f8f3fcdb5945042b6ec8333f9b1a2301f3464d648cdfbeb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bdfdf765eedc071d85b5563c044f3558b166385afa2351cee54fca65ace9df5a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ff038f70d5c79ee72c92115c83dd20836f8c31e01ed8a96b1875e335b536f52f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeHsv]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeHsv]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__85c3c9fdf3124182d6a1b51700479994a9f9f8c5a7c5a01ca327d8251061bfce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeHsvOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeHsvOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__79bb42c3d54fa94577b4071df271b9e4ca403e2470d38b67b66f5141c29625a5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c5bc24b6ad185f964f10539edc36f7f4832612631507f591d205304785916417)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__746863ab3fc0f89f6da2a420e3e0d72a0e2170555b4c8bcbcf5c63acbd182fc8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__77ef5b7c0652516acd9553e03b0712ccb5d4e5e5960028a612a0f79e72617208)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__162ceafe1ab29f5ca89be9871283e305537c952596d9fbf0d44f8b25fa29fc74)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2444b3f64d7529130b2bcea08185a447f784a762853d0f7ec4d6a9006376e0c5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3c49abc7a8d09371e2cfc8f7d18f83ab12c94750f5aecfdcb3aed637d498c0a6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeHsv]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeHsv]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeHsv]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3b99e6df6417bf7ca2323cb27d18b9b9e1a195cf5017abdd3b9ffec9228df9d2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimension",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "dimension": "dimension",
        "dimension_var": "dimensionVar",
        "equal": "equal",
        "greater_than": "greaterThan",
        "less_than": "lessThan",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimension:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        dimension: typing.Optional[builtins.str] = None,
        dimension_var: typing.Optional[builtins.str] = None,
        equal: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionEqual", typing.Dict[builtins.str, typing.Any]]] = None,
        greater_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionGreaterThan", typing.Dict[builtins.str, typing.Any]]] = None,
        less_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionLessThan", typing.Dict[builtins.str, typing.Any]]] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param dimension: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        :param dimension_var: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        :param equal: equal block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        :param greater_than: greater_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        :param less_than: less_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        :param value: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionDefault(**default)
        if isinstance(equal, dict):
            equal = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionEqual(**equal)
        if isinstance(greater_than, dict):
            greater_than = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionGreaterThan(**greater_than)
        if isinstance(less_than, dict):
            less_than = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionLessThan(**less_than)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3eb06446c40f37668def278f7e9b8959052688921a1b45cbccb61fd4f8422078)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument dimension", value=dimension, expected_type=type_hints["dimension"])
            check_type(argname="argument dimension_var", value=dimension_var, expected_type=type_hints["dimension_var"])
            check_type(argname="argument equal", value=equal, expected_type=type_hints["equal"])
            check_type(argname="argument greater_than", value=greater_than, expected_type=type_hints["greater_than"])
            check_type(argname="argument less_than", value=less_than, expected_type=type_hints["less_than"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if dimension is not None:
            self._values["dimension"] = dimension
        if dimension_var is not None:
            self._values["dimension_var"] = dimension_var
        if equal is not None:
            self._values["equal"] = equal
        if greater_than is not None:
            self._values["greater_than"] = greater_than
        if less_than is not None:
            self._values["less_than"] = less_than
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionDefault"], result)

    @builtins.property
    def dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        '''
        result = self._values.get("dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        '''
        result = self._values.get("dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def equal(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionEqual"]:
        '''equal block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        '''
        result = self._values.get("equal")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionEqual"], result)

    @builtins.property
    def greater_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionGreaterThan"]:
        '''greater_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        '''
        result = self._values.get("greater_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionGreaterThan"], result)

    @builtins.property
    def less_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionLessThan"]:
        '''less_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        '''
        result = self._values.get("less_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionLessThan"], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimension(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3e1aaf51635f038144a044e85d8eba927010f2b1eb223485bd07b3ced2b0e0ee)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__96366c15fdc679184041ee747d4b07d73e7588c32e5e386c2c80197780b2b396)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionEqual",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionEqual:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionEqual(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionEqualOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionEqualOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e262497be7dada5e87a0955b3e2c55dc4812acb84b2072e860b63b39a971f331)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionEqual], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionEqual],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1198e7d3bd381a722e150d958beef6fae4c7ba6d86e4d5de9be69e3528cd5b58)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionGreaterThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionGreaterThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionGreaterThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionGreaterThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionGreaterThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e88466cac7f5128a46741a2d6701eaab00e79e4a1787ea12f9b6334633ebdd28)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionGreaterThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionGreaterThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__abdd1700b455ea207c9b9ead5ee541eb103b027ba6352815cf5cfa9e91b31ad7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionLessThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionLessThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionLessThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionLessThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionLessThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7ab06412ba907ae172bcfcaa9438f1edd45c55861ed48111536fc161ba89227f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionLessThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionLessThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2134422bd7ac6dad19d9cf67a96ae76a9cd14814af2f397b5dc20543bb7ac392)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a99b5813203203a6c72c6985fb19236c35beaa62a74c7e153d14489e8b353d2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__739715ffd9729ffb9a5ac50b56a0f9aff40891141223246d4319313797eef813)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__87519af00fba25103366c211a805a37b71fc64207e0e5290fe0460332bd0c71c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__09f59fb36259a34f2e695d9fbd923c1932f8f3f0db96006e5d0f189e1eb714ce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ef1d3509cad2febdff704575f86cc509a725f2610336a7deffe4553577cce90)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimension]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimension]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a6c71bddaa0c7d38b480986734984573e64b9b262a6a2b0ccda39cee74beae4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__475678c28f9e102d9d63f6b7719ea6249ae25695d0665d35bcb5395ddf4f8066)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putEqual")
    def put_equal(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionEqual()

        return typing.cast(None, jsii.invoke(self, "putEqual", [value]))

    @jsii.member(jsii_name="putGreaterThan")
    def put_greater_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionGreaterThan()

        return typing.cast(None, jsii.invoke(self, "putGreaterThan", [value]))

    @jsii.member(jsii_name="putLessThan")
    def put_less_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionLessThan()

        return typing.cast(None, jsii.invoke(self, "putLessThan", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetDimension")
    def reset_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimension", []))

    @jsii.member(jsii_name="resetDimensionVar")
    def reset_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimensionVar", []))

    @jsii.member(jsii_name="resetEqual")
    def reset_equal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEqual", []))

    @jsii.member(jsii_name="resetGreaterThan")
    def reset_greater_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGreaterThan", []))

    @jsii.member(jsii_name="resetLessThan")
    def reset_less_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLessThan", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="equal")
    def equal(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionEqualOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionEqualOutputReference, jsii.get(self, "equal"))

    @builtins.property
    @jsii.member(jsii_name="greaterThan")
    def greater_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionGreaterThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionGreaterThanOutputReference, jsii.get(self, "greaterThan"))

    @builtins.property
    @jsii.member(jsii_name="lessThan")
    def less_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionLessThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionLessThanOutputReference, jsii.get(self, "lessThan"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionInput")
    def dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionVarInput")
    def dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="equalInput")
    def equal_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionEqual], jsii.get(self, "equalInput"))

    @builtins.property
    @jsii.member(jsii_name="greaterThanInput")
    def greater_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionGreaterThan], jsii.get(self, "greaterThanInput"))

    @builtins.property
    @jsii.member(jsii_name="lessThanInput")
    def less_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionLessThan], jsii.get(self, "lessThanInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="dimension")
    def dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimension"))

    @dimension.setter
    def dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__da5c6d50122be15db3b33936357b7be8a45eec6bcaf41de81f423f6b839c571a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimension", value)

    @builtins.property
    @jsii.member(jsii_name="dimensionVar")
    def dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimensionVar"))

    @dimension_var.setter
    def dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fc810517542e23b3b56f629bb030a782b96ddec300ff2d25cbf1333e7a25486f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__34f2d20f4f167157d81d69a7f4097dd0e3d529d7fcb10d94f7b7c27f64aa4293)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c251072a7cd34531c9cf51231e02130a7fe7a9dcff03db9982a242af552bed59)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimension]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimension]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimension]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a065b58f639f45231401980f6ebfe5f4cbb5e1046abf4fead7f8e0768cc49dba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientation",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "landscape": "landscape",
        "portrait": "portrait",
        "square": "square",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientation:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        landscape: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationLandscape", typing.Dict[builtins.str, typing.Any]]] = None,
        portrait: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationPortrait", typing.Dict[builtins.str, typing.Any]]] = None,
        square: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationSquare", typing.Dict[builtins.str, typing.Any]]] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param landscape: landscape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        :param portrait: portrait block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        :param square: square block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationDefault(**default)
        if isinstance(landscape, dict):
            landscape = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationLandscape(**landscape)
        if isinstance(portrait, dict):
            portrait = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationPortrait(**portrait)
        if isinstance(square, dict):
            square = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationSquare(**square)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__14168c50af37807951a7848209a289a09f93b74ba53dc8cfae302ca1a9214c03)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument landscape", value=landscape, expected_type=type_hints["landscape"])
            check_type(argname="argument portrait", value=portrait, expected_type=type_hints["portrait"])
            check_type(argname="argument square", value=square, expected_type=type_hints["square"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if landscape is not None:
            self._values["landscape"] = landscape
        if portrait is not None:
            self._values["portrait"] = portrait
        if square is not None:
            self._values["square"] = square

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationDefault"], result)

    @builtins.property
    def landscape(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationLandscape"]:
        '''landscape block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        '''
        result = self._values.get("landscape")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationLandscape"], result)

    @builtins.property
    def portrait(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationPortrait"]:
        '''portrait block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        '''
        result = self._values.get("portrait")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationPortrait"], result)

    @builtins.property
    def square(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationSquare"]:
        '''square block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        result = self._values.get("square")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationSquare"], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a0268399938d8a7d594ca6336212ed6ab1e48cdaddf9bd8458fda1f8c11f2829)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e0965d623e74308210f27ef8d41679a580aabd25042cad13281b6602844f0f2f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationLandscape",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationLandscape:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationLandscape(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationLandscapeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationLandscapeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9c7f729b11b752c6b4c662bfb608c82af8cdb8d35756c63a3aeb3453b64cb3bf)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationLandscape], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationLandscape],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__caa76f8d7b1f4fbf720afca2172b479c3b69347b722bf2479eb74975c7edad88)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2fa354c8c5cf95adbcf934f623dc54b7b4eb5f4e5fbfae8ee1b626a304153409)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2398b4175c2359c2bbf508d2d9d9ebd05995d33c514f6cf58bd9cc783997dce1)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4fdb6be488392c4b60157224a748d22687679a4f62482016ad57e98c5a1b2984)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f577962c2c84e46a773235f9daba1835897599bfaef1d6c4d667ee747f4d054)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__39fcd1d2e47bf0f162f2cba9011b3f10cde7685fe6f0db59ba928035849a40b8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientation]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientation]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c47f30ea130183df52eadec6d7e9688027724defac86ae69de1b6d85d0b50bcb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e91561f71c17fde7c02b045606553f0a9e527ce16e762273880d0fd3f8f134f4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putLandscape")
    def put_landscape(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationLandscape()

        return typing.cast(None, jsii.invoke(self, "putLandscape", [value]))

    @jsii.member(jsii_name="putPortrait")
    def put_portrait(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationPortrait()

        return typing.cast(None, jsii.invoke(self, "putPortrait", [value]))

    @jsii.member(jsii_name="putSquare")
    def put_square(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationSquare()

        return typing.cast(None, jsii.invoke(self, "putSquare", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetLandscape")
    def reset_landscape(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLandscape", []))

    @jsii.member(jsii_name="resetPortrait")
    def reset_portrait(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPortrait", []))

    @jsii.member(jsii_name="resetSquare")
    def reset_square(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSquare", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="landscape")
    def landscape(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationLandscapeOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationLandscapeOutputReference, jsii.get(self, "landscape"))

    @builtins.property
    @jsii.member(jsii_name="portrait")
    def portrait(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationPortraitOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationPortraitOutputReference", jsii.get(self, "portrait"))

    @builtins.property
    @jsii.member(jsii_name="square")
    def square(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationSquareOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationSquareOutputReference", jsii.get(self, "square"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="landscapeInput")
    def landscape_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationLandscape], jsii.get(self, "landscapeInput"))

    @builtins.property
    @jsii.member(jsii_name="portraitInput")
    def portrait_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationPortrait"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationPortrait"], jsii.get(self, "portraitInput"))

    @builtins.property
    @jsii.member(jsii_name="squareInput")
    def square_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationSquare"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationSquare"], jsii.get(self, "squareInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientation]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientation]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientation]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0b10dedf1d969082562f2a9157c3e70f75af1aa6a5aa4fa6e8ada5381e7dcdf9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationPortrait",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationPortrait:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationPortrait(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationPortraitOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationPortraitOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1708d657c2322511d61e572682ad3e81fdc1bc01e079afd2f08df4272fd76fb2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationPortrait]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationPortrait], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationPortrait],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0615e2a9b4cbd938e0f793d57b768adb309f3122f557757897320993a095de61)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationSquare",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationSquare:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationSquare(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationSquareOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationSquareOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a9f172da1c86a5238c4ae5786f0a6f67bdcb73b164fee7f6a9df72ebfd19848b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationSquare]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationSquare], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationSquare],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0d0aecea22b41f2971b9f494f61177f0fcfce00e951870197da21d68fbbe8b7c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeImQuery",
    jsii_struct_bases=[],
    name_mapping={
        "allowed_transformations": "allowedTransformations",
        "query_var": "queryVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeImQuery:
    def __init__(
        self,
        *,
        allowed_transformations: typing.Sequence[builtins.str],
        query_var: builtins.str,
    ) -> None:
        '''
        :param allowed_transformations: Specifies the transformations that can be applied using the query string parameter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allowed_transformations DataAkamaiImagingPolicyImage#allowed_transformations}
        :param query_var: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#query_var DataAkamaiImagingPolicyImage#query_var}.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9839e3ce1c30bd1806186bee7384264dbfc762472e23216641f720af389a670f)
            check_type(argname="argument allowed_transformations", value=allowed_transformations, expected_type=type_hints["allowed_transformations"])
            check_type(argname="argument query_var", value=query_var, expected_type=type_hints["query_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "allowed_transformations": allowed_transformations,
            "query_var": query_var,
        }

    @builtins.property
    def allowed_transformations(self) -> typing.List[builtins.str]:
        '''Specifies the transformations that can be applied using the query string parameter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allowed_transformations DataAkamaiImagingPolicyImage#allowed_transformations}
        '''
        result = self._values.get("allowed_transformations")
        assert result is not None, "Required property 'allowed_transformations' is missing"
        return typing.cast(typing.List[builtins.str], result)

    @builtins.property
    def query_var(self) -> builtins.str:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#query_var DataAkamaiImagingPolicyImage#query_var}.'''
        result = self._values.get("query_var")
        assert result is not None, "Required property 'query_var' is missing"
        return typing.cast(builtins.str, result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeImQuery(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeImQueryList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeImQueryList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4d205b71792a3b60017da305554e74e9b79dad68a4ae33bfc3ee44201c622db5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeImQueryOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5dc75bb2a12e070c69520db5e669a313b1355fb37d7cc9c1cb7a5c31cbaddb58)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeImQueryOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__adea483170f89907f970535e45c324c00d8b8cecbec70bc591e068b59d7c6707)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8e12f9c38de1e3ea6a980bc969bdde7c4db9c2c324572a28f56f3ca64cc094fb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__080ff770ece9bde6cd26127ee9a0a0446e851eb76d51d15987d88b3704e8c629)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeImQuery]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeImQuery]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeImQuery]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3c92f0b96658f444d3d1ce8519f03726f05b49b57b16185151ac9c3f59af853a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeImQueryOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeImQueryOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__75b585b807b58bee638158501b90644d8305c71417e48dd92236b451de13cfb8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @builtins.property
    @jsii.member(jsii_name="allowedTransformationsInput")
    def allowed_transformations_input(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "allowedTransformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="queryVarInput")
    def query_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "queryVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowedTransformations")
    def allowed_transformations(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "allowedTransformations"))

    @allowed_transformations.setter
    def allowed_transformations(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6b4fe08044c4a86225c618731081ff4a2025b2c5cde1efa797e7498265f7d47d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowedTransformations", value)

    @builtins.property
    @jsii.member(jsii_name="queryVar")
    def query_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "queryVar"))

    @query_var.setter
    def query_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7677559929224d9d09a668342913d2fc71659225e203c866291fdcaf32f7e1c6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "queryVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeImQuery]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeImQuery]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeImQuery]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__315399c0c271a11e81fb918c952c67437cb283ca3c73ec5bc7eabd7d016ac001)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeMaxColors",
    jsii_struct_bases=[],
    name_mapping={"colors": "colors", "colors_var": "colorsVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeMaxColors:
    def __init__(
        self,
        *,
        colors: typing.Optional[builtins.str] = None,
        colors_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param colors: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        :param colors_var: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__55fd8903a86200a47a84f3067b91fa771415228c05483168690e98900f92948b)
            check_type(argname="argument colors", value=colors, expected_type=type_hints["colors"])
            check_type(argname="argument colors_var", value=colors_var, expected_type=type_hints["colors_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if colors is not None:
            self._values["colors"] = colors
        if colors_var is not None:
            self._values["colors_var"] = colors_var

    @builtins.property
    def colors(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        '''
        result = self._values.get("colors")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def colors_var(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        result = self._values.get("colors_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeMaxColors(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeMaxColorsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeMaxColorsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2335f41395ecc88da49b043b30330bd3757368c3395037efece8d640175cfce3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeMaxColorsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3640666d054147584a5b890e5c9e70c6e0bf1f09ab440ad220b4180ba0974125)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeMaxColorsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__498f2c2efcd46170e10681a39350f6f90caaa637441dff0f684ad3f9313b909f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ada67f647a59e68ea090c35a9514d8e55086521f92b0d226343026d784ebac09)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ae4747563daedc68d66902c012240dcd5c2189e89526a538436264aa7430e95a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeMaxColors]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeMaxColors]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__34be9be7d6b8be3a7204afd9c5d63c3df705c1a84fbcdc093f64e36b5906ecb1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeMaxColorsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeMaxColorsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d5a4c480a802e73d403d117d5b180d5e8f65fe24eca3c8903e5cb07386ad9817)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColors")
    def reset_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColors", []))

    @jsii.member(jsii_name="resetColorsVar")
    def reset_colors_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorsVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorsInput")
    def colors_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsInput"))

    @builtins.property
    @jsii.member(jsii_name="colorsVarInput")
    def colors_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsVarInput"))

    @builtins.property
    @jsii.member(jsii_name="colors")
    def colors(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colors"))

    @colors.setter
    def colors(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f92b3b4eb3e0f639c890b4afb7317dcb478e0c117c01a24ece4448ce8eb0e7a9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colors", value)

    @builtins.property
    @jsii.member(jsii_name="colorsVar")
    def colors_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorsVar"))

    @colors_var.setter
    def colors_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1996483a79c7faec7240ae1dd252ef81cd5a7d9d78fabc3678f306f9085739d7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorsVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeMaxColors]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeMaxColors]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeMaxColors]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__efd76518a48f4e770e5d19b3401b8483e0418a073700c2e03159953d2eb553c5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeMirror",
    jsii_struct_bases=[],
    name_mapping={
        "horizontal": "horizontal",
        "horizontal_var": "horizontalVar",
        "vertical": "vertical",
        "vertical_var": "verticalVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeMirror:
    def __init__(
        self,
        *,
        horizontal: typing.Optional[builtins.str] = None,
        horizontal_var: typing.Optional[builtins.str] = None,
        vertical: typing.Optional[builtins.str] = None,
        vertical_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param horizontal: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        :param horizontal_var: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        :param vertical: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        :param vertical_var: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b290998076eb52ffb0b4abf40e874f3e9081ae7e6fb48694faa72a1a80634fac)
            check_type(argname="argument horizontal", value=horizontal, expected_type=type_hints["horizontal"])
            check_type(argname="argument horizontal_var", value=horizontal_var, expected_type=type_hints["horizontal_var"])
            check_type(argname="argument vertical", value=vertical, expected_type=type_hints["vertical"])
            check_type(argname="argument vertical_var", value=vertical_var, expected_type=type_hints["vertical_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if horizontal is not None:
            self._values["horizontal"] = horizontal
        if horizontal_var is not None:
            self._values["horizontal_var"] = horizontal_var
        if vertical is not None:
            self._values["vertical"] = vertical
        if vertical_var is not None:
            self._values["vertical_var"] = vertical_var

    @builtins.property
    def horizontal(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        '''
        result = self._values.get("horizontal")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def horizontal_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        '''
        result = self._values.get("horizontal_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        '''
        result = self._values.get("vertical")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        result = self._values.get("vertical_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeMirror(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeMirrorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeMirrorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ca4f8e1cdbbb71cc6100348e283734c370d12efd4f5d1fc2390d31c6766fd7e8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeMirrorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bd4c97ec6e1da125b910228460b825b600afdb1f3394d7e7509cb0d2797d2ea6)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeMirrorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__30f15940908c036bff848e8ee56d97ffc1e7ac4cb9b31522b1fb041f1e3be4a6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6cbec152ce79223c003d31f883ea8ce91b70668bff662bdd145c9d425b3ee397)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eb62763be5efbe27c3f3f510f52473541e5d998ae0da86e642dc6de5789881a0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeMirror]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeMirror]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__49e45ee01d4c0a6d90093ad12586db8ea78100dc58a3d6e3532be2c0f36f433e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeMirrorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeMirrorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ecb96b4c536fc733025f8eb15cf41b76420390a12bceb4c7464398b1f08a78a2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHorizontal")
    def reset_horizontal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontal", []))

    @jsii.member(jsii_name="resetHorizontalVar")
    def reset_horizontal_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontalVar", []))

    @jsii.member(jsii_name="resetVertical")
    def reset_vertical(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVertical", []))

    @jsii.member(jsii_name="resetVerticalVar")
    def reset_vertical_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVerticalVar", []))

    @builtins.property
    @jsii.member(jsii_name="horizontalInput")
    def horizontal_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontalVarInput")
    def horizontal_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalInput")
    def vertical_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalVarInput")
    def vertical_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontal")
    def horizontal(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontal"))

    @horizontal.setter
    def horizontal(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d0d71cad27dec51ea3af15aa67e3597f83e1b85d4ed55ddbab5d4e64d7288f97)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontal", value)

    @builtins.property
    @jsii.member(jsii_name="horizontalVar")
    def horizontal_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontalVar"))

    @horizontal_var.setter
    def horizontal_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8fabcfceb3667d59cf6bf1a994c0c1794496107ccf6fb3b9f87c6fd2ab57e40a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontalVar", value)

    @builtins.property
    @jsii.member(jsii_name="vertical")
    def vertical(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "vertical"))

    @vertical.setter
    def vertical(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b51041442dc14497f6bbec0f6074e4ac9bf9324982977a90c5913272e0894016)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "vertical", value)

    @builtins.property
    @jsii.member(jsii_name="verticalVar")
    def vertical_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "verticalVar"))

    @vertical_var.setter
    def vertical_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d4af1dd75933c9d2eaf3fb84235b52280a39de8ab224d47ee1a38f4c631b3186)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "verticalVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeMirror]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeMirror]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeMirror]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aa8d9b5fb6a56522fb2003c2689b349a693a74ec12331b6c028909b1d5020ef8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeMonoHue",
    jsii_struct_bases=[],
    name_mapping={"hue": "hue", "hue_var": "hueVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeMonoHue:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c1efb1ad3622413f2bd4584a8a0ddb41775cfddb1d5ce3fa03b8d50c7a18ac90)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeMonoHue(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeMonoHueList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeMonoHueList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__78c7363cfb83a9d7e90c0196ab46b577afab8505ac42bd1d77e20dfbce821581)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeMonoHueOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7c637a8b9e961a165ad4229c54475fcd025ea734237ea57a3c5e88b310f91695)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeMonoHueOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__056186a20eeb847fc8dd8a57e82ae42c24e84b0b51904af0b9b669f447221532)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a716897358b1d3f9bd06d1cf94d2cc52225e673a8e61d1d11e7282b9fd2d6c35)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__da28fc5f034b90ea836205c98fe3b7f521a508d25f654c54a7dbfc01259b85d3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeMonoHue]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeMonoHue]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__525d2fb3581bb662d404347fe15888614d6fc22f0d98038b0ab96278b6af8715)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeMonoHueOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeMonoHueOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6d81af029f78fd0b25377869d977426b8334b8a73e283b7d37f07e0b5aad7751)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__925a2850bfe2cf358827ff50e16bf25fb77cd785298fbf5ff8919f921392a18f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6ea8b3254996b9371fd3fd3250b01ad48fa52772477b59f76fccfad064b60dc4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeMonoHue]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeMonoHue]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeMonoHue]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__91b9a3b487040868ff75ae50409787c06540c627b5a18d2df86153f3ae2bab40)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeOpacity",
    jsii_struct_bases=[],
    name_mapping={"opacity": "opacity", "opacity_var": "opacityVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeOpacity:
    def __init__(
        self,
        *,
        opacity: typing.Optional[builtins.str] = None,
        opacity_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param opacity: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param opacity_var: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__493bda1dc749d1dabeceff7083c440d8e7fbf8ce33e294f5e0d3465524cb04c3)
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument opacity_var", value=opacity_var, expected_type=type_hints["opacity_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if opacity is not None:
            self._values["opacity"] = opacity
        if opacity_var is not None:
            self._values["opacity_var"] = opacity_var

    @builtins.property
    def opacity(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def opacity_var(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        result = self._values.get("opacity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeOpacity(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeOpacityList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeOpacityList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6635552a1f7c87c66e74d2cd85757a48e3ea4a2120403c803751f9de932f6855)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeOpacityOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__baac1d0cbfc0d82322edb78a85793e755403d80ee43bb98cade2efc2dd3370ba)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeOpacityOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e71d231f83a01142e0487f2ed19c3cbbfeed31b85021afc367dfb9954f82d522)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__581e9bf258c70d79c2fce636939930793c60220c43232dae041b6003d5fa33a0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__04ec7333c20f252ded2577ac9a409603330ba60c806b61e3b9757cf6a808e724)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeOpacity]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeOpacity]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8c75447ffd81b57a6d1dc8b028e54485b6516eb2b2c637da61301dcef0bb4818)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeOpacityOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeOpacityOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d7e4eb2e9ba8164dd0f7740d04f1fa1b1fd5cf66b5d940d3f82e2789cf0cedc0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetOpacityVar")
    def reset_opacity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacityVar", []))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityVarInput")
    def opacity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacity"))

    @opacity.setter
    def opacity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b3d326869dfb3cf24c28dd2e33958a460ddf1c0dd3382670ca9c799b64b4fb3b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacity", value)

    @builtins.property
    @jsii.member(jsii_name="opacityVar")
    def opacity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacityVar"))

    @opacity_var.setter
    def opacity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1988e807636957f143d2a765ae65eb671693e6796cef5f75a872ee4538596182)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacityVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeOpacity]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeOpacity]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeOpacity]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__454dc976721598caf0276a8cb19edb61902ab939a3f84ba8abf2fa0cb9887638)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c033ce66b01ee119270fe831b998fb6f40e8900eaf5c2fd263aca6b8007edb8d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putAppend")
    def put_append(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeAppend, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cac2107daa8efe60915d944d67e0d05ffea08878082cf862b559084c22a6035a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putAppend", [value]))

    @jsii.member(jsii_name="putAspectCrop")
    def put_aspect_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeAspectCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__257f58c117a04fe38a00f1958f8c7ddd66f7512ccfd7161e56c8b0d910681b81)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putAspectCrop", [value]))

    @jsii.member(jsii_name="putBackgroundColor")
    def put_background_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__838b039e485f62e2d63285aac4845db7c5e1434939995d345f99559521723d6a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBackgroundColor", [value]))

    @jsii.member(jsii_name="putBlur")
    def put_blur(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeBlur, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ad109d9898845c662b5a6d3181edc84c1dc76c526093fb05ce2b2f0999aae1d8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBlur", [value]))

    @jsii.member(jsii_name="putChromaKey")
    def put_chroma_key(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeChromaKey, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aba87980902479c2ba142117d52965d4e74ecd7a814dc359f81a999e1f564d43)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putChromaKey", [value]))

    @jsii.member(jsii_name="putComposite")
    def put_composite(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeComposite, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ffbaabbfca9e8fc0f9ac3add55c39297b63e31ad9afba1bc806fda729861f68f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putComposite", [value]))

    @jsii.member(jsii_name="putCompound")
    def put_compound(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompound, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7a6745b00479fc4b3770e92f418aa32b2ac0720bc2d988de6e51e05288c5414a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCompound", [value]))

    @jsii.member(jsii_name="putContrast")
    def put_contrast(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeContrast, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__63d7578242a44f8705f090a9e5c199468b2ded2813d5c6dbad501f3550c5fc81)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putContrast", [value]))

    @jsii.member(jsii_name="putCrop")
    def put_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__70061f4f73fae2b8f4ae83ead793da03376a67c63d223749d4d23dfbcea2d7d8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCrop", [value]))

    @jsii.member(jsii_name="putFaceCrop")
    def put_face_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeFaceCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__64fc4624abcb524217735bb53d4d2c3148ec509074ee67c54a9702834334b72b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFaceCrop", [value]))

    @jsii.member(jsii_name="putFeatureCrop")
    def put_feature_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeFeatureCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc4b35a79ffe7e8d7e23e809ce4127d3ca49687a5e1b84e9ed0a509151f38b24)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFeatureCrop", [value]))

    @jsii.member(jsii_name="putFitAndFill")
    def put_fit_and_fill(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeFitAndFill, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f8f2869738cac66d12b454130af0074ae0e8b5555f935116247c0ab673c0d435)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFitAndFill", [value]))

    @jsii.member(jsii_name="putGoop")
    def put_goop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeGoop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a161cbc9a133940d55fabe9ab1e7db7ef9d74cc9d6a758dd0d6fc3ac21ebe2d7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGoop", [value]))

    @jsii.member(jsii_name="putGrayscale")
    def put_grayscale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeGrayscale, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a28ea0961287260b93e4519d5bde032593af6e9fa9da51b6d77f7c7fea308432)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGrayscale", [value]))

    @jsii.member(jsii_name="putHsl")
    def put_hsl(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeHsl, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0d40de4afc8cc7fd532ec8b3ff1a394a306852f2e0a0c61d5770f3cd621bd4f9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsl", [value]))

    @jsii.member(jsii_name="putHsv")
    def put_hsv(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeHsv, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__034b25d7f2eb74f6b80f8524bfb61f6eb8489acc93e0fdbdca74e6137837ac9a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsv", [value]))

    @jsii.member(jsii_name="putIfDimension")
    def put_if_dimension(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimension, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9094dd8980daad43cc29042458209c01d8ae7327614fad1f04a074277764c8f7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfDimension", [value]))

    @jsii.member(jsii_name="putIfOrientation")
    def put_if_orientation(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d58901b47b8c37b5da8dff849bbf476dd37e2b8c24fb7a8e4e5540baf972a6d4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfOrientation", [value]))

    @jsii.member(jsii_name="putImQuery")
    def put_im_query(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeImQuery, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__591518aaf8ee4093f6b7320ed1d2b1eb37ee33e5a66df244529305b4251f1eeb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putImQuery", [value]))

    @jsii.member(jsii_name="putMaxColors")
    def put_max_colors(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeMaxColors, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__181de4bbc5fe0961efb0f274fad3c7fbeb5aca5fa56b93e317b84109137be047)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMaxColors", [value]))

    @jsii.member(jsii_name="putMirror")
    def put_mirror(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeMirror, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__526e3aa9f99b8b0e4fe4a579458051ae80a4d63648c0d81e2c7b5310b06ad3ba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMirror", [value]))

    @jsii.member(jsii_name="putMonoHue")
    def put_mono_hue(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeMonoHue, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d70b9e448f3841ea02657eeb6f208b9d71d9d09eefc447aad72710bc1266907d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMonoHue", [value]))

    @jsii.member(jsii_name="putOpacity")
    def put_opacity(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeOpacity, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__31d04d2b1cded80f237baaed7775681263de5aed8a8a4a22dd2a1e1b5bdab08a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putOpacity", [value]))

    @jsii.member(jsii_name="putRegionOfInterestCrop")
    def put_region_of_interest_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeRegionOfInterestCrop", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__90709eab428edb062f35083ffdba264f550d5fc4ec6d30e174cb2df6c9d43f01)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRegionOfInterestCrop", [value]))

    @jsii.member(jsii_name="putRelativeCrop")
    def put_relative_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeRelativeCrop", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__28c950dc464bc56534e436923e7c1be7bd5658851fa846270cfcd0c030193b0c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRelativeCrop", [value]))

    @jsii.member(jsii_name="putRemoveColor")
    def put_remove_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeRemoveColor", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a55fc7438bd7a587f178e8937d842a533f1dc1289fe23039fb2c59b86790576)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRemoveColor", [value]))

    @jsii.member(jsii_name="putResize")
    def put_resize(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeResize", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__88352b9e9b62a454802930bcaa6c757bf718662fa6f937b2343ff3f45433c434)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putResize", [value]))

    @jsii.member(jsii_name="putRotate")
    def put_rotate(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeRotate", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d23e3019b253b6650a04899a95aa2b8fab628ff14e83ebd6bdab505914885e61)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRotate", [value]))

    @jsii.member(jsii_name="putScale")
    def put_scale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeScale", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__39995a500704bc2d3ae1305a0b4f38563ab56a4035dd1f59abf4a906ec3d6ccf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putScale", [value]))

    @jsii.member(jsii_name="putShear")
    def put_shear(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeShear", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b717fb3fa682d97b2ab79f09cc41780432566fc6ee8bc2915a91a059ca6cd10c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putShear", [value]))

    @jsii.member(jsii_name="putTrim")
    def put_trim(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeTrim", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb9ae376f64cf85eb7fbae9fd4ac5535f510b274fd957da84cbc7762791d238a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTrim", [value]))

    @jsii.member(jsii_name="putUnsharpMask")
    def put_unsharp_mask(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeUnsharpMask", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d9c0c9a74207ce12581052f7dff49b1c46f62073d43e851443f9b526d2fde1b7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putUnsharpMask", [value]))

    @jsii.member(jsii_name="resetAppend")
    def reset_append(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAppend", []))

    @jsii.member(jsii_name="resetAspectCrop")
    def reset_aspect_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspectCrop", []))

    @jsii.member(jsii_name="resetBackgroundColor")
    def reset_background_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBackgroundColor", []))

    @jsii.member(jsii_name="resetBlur")
    def reset_blur(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBlur", []))

    @jsii.member(jsii_name="resetChromaKey")
    def reset_chroma_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChromaKey", []))

    @jsii.member(jsii_name="resetComposite")
    def reset_composite(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetComposite", []))

    @jsii.member(jsii_name="resetCompound")
    def reset_compound(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCompound", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetCrop")
    def reset_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCrop", []))

    @jsii.member(jsii_name="resetFaceCrop")
    def reset_face_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFaceCrop", []))

    @jsii.member(jsii_name="resetFeatureCrop")
    def reset_feature_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureCrop", []))

    @jsii.member(jsii_name="resetFitAndFill")
    def reset_fit_and_fill(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFitAndFill", []))

    @jsii.member(jsii_name="resetGoop")
    def reset_goop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGoop", []))

    @jsii.member(jsii_name="resetGrayscale")
    def reset_grayscale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGrayscale", []))

    @jsii.member(jsii_name="resetHsl")
    def reset_hsl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsl", []))

    @jsii.member(jsii_name="resetHsv")
    def reset_hsv(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsv", []))

    @jsii.member(jsii_name="resetIfDimension")
    def reset_if_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfDimension", []))

    @jsii.member(jsii_name="resetIfOrientation")
    def reset_if_orientation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfOrientation", []))

    @jsii.member(jsii_name="resetImQuery")
    def reset_im_query(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetImQuery", []))

    @jsii.member(jsii_name="resetMaxColors")
    def reset_max_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxColors", []))

    @jsii.member(jsii_name="resetMirror")
    def reset_mirror(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMirror", []))

    @jsii.member(jsii_name="resetMonoHue")
    def reset_mono_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonoHue", []))

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetRegionOfInterestCrop")
    def reset_region_of_interest_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRegionOfInterestCrop", []))

    @jsii.member(jsii_name="resetRelativeCrop")
    def reset_relative_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRelativeCrop", []))

    @jsii.member(jsii_name="resetRemoveColor")
    def reset_remove_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRemoveColor", []))

    @jsii.member(jsii_name="resetResize")
    def reset_resize(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetResize", []))

    @jsii.member(jsii_name="resetRotate")
    def reset_rotate(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRotate", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetShear")
    def reset_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetShear", []))

    @jsii.member(jsii_name="resetTrim")
    def reset_trim(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTrim", []))

    @jsii.member(jsii_name="resetUnsharpMask")
    def reset_unsharp_mask(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUnsharpMask", []))

    @builtins.property
    @jsii.member(jsii_name="append")
    def append(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeAppendList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeAppendList, jsii.get(self, "append"))

    @builtins.property
    @jsii.member(jsii_name="aspectCrop")
    def aspect_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeAspectCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeAspectCropList, jsii.get(self, "aspectCrop"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColor")
    def background_color(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeBackgroundColorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeBackgroundColorList, jsii.get(self, "backgroundColor"))

    @builtins.property
    @jsii.member(jsii_name="blur")
    def blur(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeBlurList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeBlurList, jsii.get(self, "blur"))

    @builtins.property
    @jsii.member(jsii_name="chromaKey")
    def chroma_key(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeChromaKeyList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeChromaKeyList, jsii.get(self, "chromaKey"))

    @builtins.property
    @jsii.member(jsii_name="composite")
    def composite(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompositeList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompositeList, jsii.get(self, "composite"))

    @builtins.property
    @jsii.member(jsii_name="compound")
    def compound(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompoundList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompoundList, jsii.get(self, "compound"))

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeContrastList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeContrastList, jsii.get(self, "contrast"))

    @builtins.property
    @jsii.member(jsii_name="crop")
    def crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeCropList, jsii.get(self, "crop"))

    @builtins.property
    @jsii.member(jsii_name="faceCrop")
    def face_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeFaceCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeFaceCropList, jsii.get(self, "faceCrop"))

    @builtins.property
    @jsii.member(jsii_name="featureCrop")
    def feature_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeFeatureCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeFeatureCropList, jsii.get(self, "featureCrop"))

    @builtins.property
    @jsii.member(jsii_name="fitAndFill")
    def fit_and_fill(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeFitAndFillList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeFitAndFillList, jsii.get(self, "fitAndFill"))

    @builtins.property
    @jsii.member(jsii_name="goop")
    def goop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeGoopList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeGoopList, jsii.get(self, "goop"))

    @builtins.property
    @jsii.member(jsii_name="grayscale")
    def grayscale(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeGrayscaleList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeGrayscaleList, jsii.get(self, "grayscale"))

    @builtins.property
    @jsii.member(jsii_name="hsl")
    def hsl(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeHslList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeHslList, jsii.get(self, "hsl"))

    @builtins.property
    @jsii.member(jsii_name="hsv")
    def hsv(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeHsvList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeHsvList, jsii.get(self, "hsv"))

    @builtins.property
    @jsii.member(jsii_name="ifDimension")
    def if_dimension(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionList, jsii.get(self, "ifDimension"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientation")
    def if_orientation(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationList, jsii.get(self, "ifOrientation"))

    @builtins.property
    @jsii.member(jsii_name="imQuery")
    def im_query(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeImQueryList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeImQueryList, jsii.get(self, "imQuery"))

    @builtins.property
    @jsii.member(jsii_name="maxColors")
    def max_colors(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeMaxColorsList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeMaxColorsList, jsii.get(self, "maxColors"))

    @builtins.property
    @jsii.member(jsii_name="mirror")
    def mirror(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeMirrorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeMirrorList, jsii.get(self, "mirror"))

    @builtins.property
    @jsii.member(jsii_name="monoHue")
    def mono_hue(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeMonoHueList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeMonoHueList, jsii.get(self, "monoHue"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeOpacityList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeOpacityList, jsii.get(self, "opacity"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestCrop")
    def region_of_interest_crop(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeRegionOfInterestCropList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeRegionOfInterestCropList", jsii.get(self, "regionOfInterestCrop"))

    @builtins.property
    @jsii.member(jsii_name="relativeCrop")
    def relative_crop(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeRelativeCropList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeRelativeCropList", jsii.get(self, "relativeCrop"))

    @builtins.property
    @jsii.member(jsii_name="removeColor")
    def remove_color(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeRemoveColorList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeRemoveColorList", jsii.get(self, "removeColor"))

    @builtins.property
    @jsii.member(jsii_name="resize")
    def resize(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeResizeList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeResizeList", jsii.get(self, "resize"))

    @builtins.property
    @jsii.member(jsii_name="rotate")
    def rotate(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeRotateList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeRotateList", jsii.get(self, "rotate"))

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeScaleList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeScaleList", jsii.get(self, "scale"))

    @builtins.property
    @jsii.member(jsii_name="shear")
    def shear(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeShearList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeShearList", jsii.get(self, "shear"))

    @builtins.property
    @jsii.member(jsii_name="trim")
    def trim(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeTrimList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeTrimList", jsii.get(self, "trim"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMask")
    def unsharp_mask(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeUnsharpMaskList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeUnsharpMaskList", jsii.get(self, "unsharpMask"))

    @builtins.property
    @jsii.member(jsii_name="appendInput")
    def append_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeAppend]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeAppend]]], jsii.get(self, "appendInput"))

    @builtins.property
    @jsii.member(jsii_name="aspectCropInput")
    def aspect_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeAspectCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeAspectCrop]]], jsii.get(self, "aspectCropInput"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColorInput")
    def background_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeBackgroundColor]]], jsii.get(self, "backgroundColorInput"))

    @builtins.property
    @jsii.member(jsii_name="blurInput")
    def blur_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeBlur]]], jsii.get(self, "blurInput"))

    @builtins.property
    @jsii.member(jsii_name="chromaKeyInput")
    def chroma_key_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeChromaKey]]], jsii.get(self, "chromaKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="compositeInput")
    def composite_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeComposite]]], jsii.get(self, "compositeInput"))

    @builtins.property
    @jsii.member(jsii_name="compoundInput")
    def compound_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompound]]], jsii.get(self, "compoundInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeContrast]]], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="cropInput")
    def crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeCrop]]], jsii.get(self, "cropInput"))

    @builtins.property
    @jsii.member(jsii_name="faceCropInput")
    def face_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeFaceCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeFaceCrop]]], jsii.get(self, "faceCropInput"))

    @builtins.property
    @jsii.member(jsii_name="featureCropInput")
    def feature_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeFeatureCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeFeatureCrop]]], jsii.get(self, "featureCropInput"))

    @builtins.property
    @jsii.member(jsii_name="fitAndFillInput")
    def fit_and_fill_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeFitAndFill]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeFitAndFill]]], jsii.get(self, "fitAndFillInput"))

    @builtins.property
    @jsii.member(jsii_name="goopInput")
    def goop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeGoop]]], jsii.get(self, "goopInput"))

    @builtins.property
    @jsii.member(jsii_name="grayscaleInput")
    def grayscale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeGrayscale]]], jsii.get(self, "grayscaleInput"))

    @builtins.property
    @jsii.member(jsii_name="hslInput")
    def hsl_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeHsl]]], jsii.get(self, "hslInput"))

    @builtins.property
    @jsii.member(jsii_name="hsvInput")
    def hsv_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeHsv]]], jsii.get(self, "hsvInput"))

    @builtins.property
    @jsii.member(jsii_name="ifDimensionInput")
    def if_dimension_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimension]]], jsii.get(self, "ifDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientationInput")
    def if_orientation_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientation]]], jsii.get(self, "ifOrientationInput"))

    @builtins.property
    @jsii.member(jsii_name="imQueryInput")
    def im_query_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeImQuery]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeImQuery]]], jsii.get(self, "imQueryInput"))

    @builtins.property
    @jsii.member(jsii_name="maxColorsInput")
    def max_colors_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeMaxColors]]], jsii.get(self, "maxColorsInput"))

    @builtins.property
    @jsii.member(jsii_name="mirrorInput")
    def mirror_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeMirror]]], jsii.get(self, "mirrorInput"))

    @builtins.property
    @jsii.member(jsii_name="monoHueInput")
    def mono_hue_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeMonoHue]]], jsii.get(self, "monoHueInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeOpacity]]], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestCropInput")
    def region_of_interest_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeRegionOfInterestCrop"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeRegionOfInterestCrop"]]], jsii.get(self, "regionOfInterestCropInput"))

    @builtins.property
    @jsii.member(jsii_name="relativeCropInput")
    def relative_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeRelativeCrop"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeRelativeCrop"]]], jsii.get(self, "relativeCropInput"))

    @builtins.property
    @jsii.member(jsii_name="removeColorInput")
    def remove_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeRemoveColor"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeRemoveColor"]]], jsii.get(self, "removeColorInput"))

    @builtins.property
    @jsii.member(jsii_name="resizeInput")
    def resize_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeResize"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeResize"]]], jsii.get(self, "resizeInput"))

    @builtins.property
    @jsii.member(jsii_name="rotateInput")
    def rotate_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeRotate"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeRotate"]]], jsii.get(self, "rotateInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeScale"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeScale"]]], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="shearInput")
    def shear_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeShear"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeShear"]]], jsii.get(self, "shearInput"))

    @builtins.property
    @jsii.member(jsii_name="trimInput")
    def trim_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeTrim"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeTrim"]]], jsii.get(self, "trimInput"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMaskInput")
    def unsharp_mask_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeUnsharpMask"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeUnsharpMask"]]], jsii.get(self, "unsharpMaskInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscape], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscape],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f3e675708aac6b1a642e7dbf8a9c2066855cc46419600cbaad5694f3442e8f48)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeRegionOfInterestCrop",
    jsii_struct_bases=[],
    name_mapping={
        "region_of_interest": "regionOfInterest",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeRegionOfInterestCrop:
    def __init__(
        self,
        *,
        region_of_interest: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeRegionOfInterestCropRegionOfInterest", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param region_of_interest: region_of_interest block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest DataAkamaiImagingPolicyImage#region_of_interest}
        :param gravity: The placement of the crop area relative to the specified area of interest. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: The placement of the crop area relative to the specified area of interest. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param style: Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(region_of_interest, dict):
            region_of_interest = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeRegionOfInterestCropRegionOfInterest(**region_of_interest)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c0b8ec82b3c8828566338d8c5737b69fa7552d7f3b7b465b12a3b543d30e819a)
            check_type(argname="argument region_of_interest", value=region_of_interest, expected_type=type_hints["region_of_interest"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "region_of_interest": region_of_interest,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def region_of_interest(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeRegionOfInterestCropRegionOfInterest":
        '''region_of_interest block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest DataAkamaiImagingPolicyImage#region_of_interest}
        '''
        result = self._values.get("region_of_interest")
        assert result is not None, "Required property 'region_of_interest' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeRegionOfInterestCropRegionOfInterest", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''The placement of the crop area relative to the specified area of interest.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''The placement of the crop area relative to the specified area of interest.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeRegionOfInterestCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeRegionOfInterestCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeRegionOfInterestCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__923e37fbba92a242b2f95dfe9b006c3b6ac03449ef2d876ad714fcb110d8d50f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeRegionOfInterestCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f361275f86deeee6cff0dcd192c3cd598cebe196dca0e04b7777c603dc9f1631)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeRegionOfInterestCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ba7ea7be9fdae2e9aff20dd3967e753ee97f09d3910c3f0da82a5b2f2926f182)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__87f0a8ee889e740d5b7c1d9dc793496e4221d33324690ae2dd19bede59e8b414)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__379b1fb1e2177fc7807e83c8f09868f55bcb240a512f5bf10d59b847d9c7aa59)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeRegionOfInterestCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeRegionOfInterestCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeRegionOfInterestCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__58893dfc3c91d5fae1c8512168b008dd69ce42be46d50ffe70de144e4ec4c3a9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeRegionOfInterestCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeRegionOfInterestCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a6f38d0b19a42558cb53c9a331c3e07a9471c0466aa901e32c70b19e5fc867f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putRegionOfInterest")
    def put_region_of_interest(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeRegionOfInterestCropRegionOfInterest()

        return typing.cast(None, jsii.invoke(self, "putRegionOfInterest", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterest")
    def region_of_interest(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeRegionOfInterestCropRegionOfInterestOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeRegionOfInterestCropRegionOfInterestOutputReference", jsii.get(self, "regionOfInterest"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestInput")
    def region_of_interest_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeRegionOfInterestCropRegionOfInterest"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeRegionOfInterestCropRegionOfInterest"], jsii.get(self, "regionOfInterestInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dd89a14f7b1941485cdc3024d7cb84f32a12c88547bd69e9ea5d9c4919f189a1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6bf6c03cd14234d05d1be71478f2aeb164dd8a24ece0566b03217afa515242e2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6a54428fc114aa0d8292e06e21d0d8ab2477c61d1b99e5f3f39460aae37d6686)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9b23298e74afec981dfb510e3dca6e71d80b31970746ce5116c4225bb9685aed)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ec7086f784112cb9c2d42178de1aabe660a9c236909d364017a47be36a0ec062)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__66c5dea1b54d3c6473016fab6bd9bae748d42f66c1f810325e05d169008236cc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__81fe3509c22f5e020095b22f825fbe3975ce28443f8b3804caa331df29bdbaea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__52e029029d4a9d07a632e6dd32f02ad5c3f3eb3667629ebdc3ca9b0e73a779e9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeRegionOfInterestCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeRegionOfInterestCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeRegionOfInterestCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f68ee0fbf3172aa01dd598e9cf05090c84aef2d38d4612d1e9fd292eab139190)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeRegionOfInterestCropRegionOfInterest",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeRegionOfInterestCropRegionOfInterest:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeRegionOfInterestCropRegionOfInterest(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeRegionOfInterestCropRegionOfInterestOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeRegionOfInterestCropRegionOfInterestOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dddb680d16645565e5f34d56a1ef47aa711c0d77e4cd066727c2941a722f0a4d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeRegionOfInterestCropRegionOfInterest]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeRegionOfInterestCropRegionOfInterest], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeRegionOfInterestCropRegionOfInterest],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ea42621995a096c34b34d593899775af12617483cf618dfb00bb29464a754db)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeRelativeCrop",
    jsii_struct_bases=[],
    name_mapping={
        "east": "east",
        "east_var": "eastVar",
        "north": "north",
        "north_var": "northVar",
        "south": "south",
        "south_var": "southVar",
        "west": "west",
        "west_var": "westVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeRelativeCrop:
    def __init__(
        self,
        *,
        east: typing.Optional[builtins.str] = None,
        east_var: typing.Optional[builtins.str] = None,
        north: typing.Optional[builtins.str] = None,
        north_var: typing.Optional[builtins.str] = None,
        south: typing.Optional[builtins.str] = None,
        south_var: typing.Optional[builtins.str] = None,
        west: typing.Optional[builtins.str] = None,
        west_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param east: The number of pixels to shrink or expand the right side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east DataAkamaiImagingPolicyImage#east}
        :param east_var: The number of pixels to shrink or expand the right side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east_var DataAkamaiImagingPolicyImage#east_var}
        :param north: The number of pixels to shrink or expand the top side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north DataAkamaiImagingPolicyImage#north}
        :param north_var: The number of pixels to shrink or expand the top side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north_var DataAkamaiImagingPolicyImage#north_var}
        :param south: The number of pixels to shrink or expand the bottom side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south DataAkamaiImagingPolicyImage#south}
        :param south_var: The number of pixels to shrink or expand the bottom side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south_var DataAkamaiImagingPolicyImage#south_var}
        :param west: The number of pixels to shrink or expand the left side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west DataAkamaiImagingPolicyImage#west}
        :param west_var: The number of pixels to shrink or expand the left side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west_var DataAkamaiImagingPolicyImage#west_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__94ec0508ea6fc98e6eb15c712036fc03a03b4c278d72ee5abaefd7af9deac47d)
            check_type(argname="argument east", value=east, expected_type=type_hints["east"])
            check_type(argname="argument east_var", value=east_var, expected_type=type_hints["east_var"])
            check_type(argname="argument north", value=north, expected_type=type_hints["north"])
            check_type(argname="argument north_var", value=north_var, expected_type=type_hints["north_var"])
            check_type(argname="argument south", value=south, expected_type=type_hints["south"])
            check_type(argname="argument south_var", value=south_var, expected_type=type_hints["south_var"])
            check_type(argname="argument west", value=west, expected_type=type_hints["west"])
            check_type(argname="argument west_var", value=west_var, expected_type=type_hints["west_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if east is not None:
            self._values["east"] = east
        if east_var is not None:
            self._values["east_var"] = east_var
        if north is not None:
            self._values["north"] = north
        if north_var is not None:
            self._values["north_var"] = north_var
        if south is not None:
            self._values["south"] = south
        if south_var is not None:
            self._values["south_var"] = south_var
        if west is not None:
            self._values["west"] = west
        if west_var is not None:
            self._values["west_var"] = west_var

    @builtins.property
    def east(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the right side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east DataAkamaiImagingPolicyImage#east}
        '''
        result = self._values.get("east")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def east_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the right side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east_var DataAkamaiImagingPolicyImage#east_var}
        '''
        result = self._values.get("east_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def north(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the top side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north DataAkamaiImagingPolicyImage#north}
        '''
        result = self._values.get("north")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def north_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the top side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north_var DataAkamaiImagingPolicyImage#north_var}
        '''
        result = self._values.get("north_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def south(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the bottom side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south DataAkamaiImagingPolicyImage#south}
        '''
        result = self._values.get("south")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def south_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the bottom side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south_var DataAkamaiImagingPolicyImage#south_var}
        '''
        result = self._values.get("south_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def west(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the left side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west DataAkamaiImagingPolicyImage#west}
        '''
        result = self._values.get("west")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def west_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the left side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west_var DataAkamaiImagingPolicyImage#west_var}
        '''
        result = self._values.get("west_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeRelativeCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeRelativeCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeRelativeCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d655f96d896122a8391a3cafd4b56c1b6bd6161e6638697ac44bdf0968ee434b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeRelativeCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be3f12fec9f0fffbf7428d2e62e9d2feb29c1b1ed1c8ebab95640b791fc4e13b)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeRelativeCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fd084477518f1932e37ef5940fc87c2dd06b6c1eb791c0150da64cc89381166b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5e85a69110178ed142fdbb7a9f7230e8fb448132031edb65d091b20cba936515)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f6e259242e0f2cd7e8dc4d176a1aa9ca774bd437a72e019000936d5323960944)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeRelativeCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeRelativeCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeRelativeCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4554e695cd99db7f8bbd9b739dff12825808531fd017aa336c792843042d5be3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeRelativeCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeRelativeCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eb1bc21835bbcedf5b8ad0f3ab5906513e08c905ac8b6307c3bc66f88d2dd609)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetEast")
    def reset_east(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEast", []))

    @jsii.member(jsii_name="resetEastVar")
    def reset_east_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEastVar", []))

    @jsii.member(jsii_name="resetNorth")
    def reset_north(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNorth", []))

    @jsii.member(jsii_name="resetNorthVar")
    def reset_north_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNorthVar", []))

    @jsii.member(jsii_name="resetSouth")
    def reset_south(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSouth", []))

    @jsii.member(jsii_name="resetSouthVar")
    def reset_south_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSouthVar", []))

    @jsii.member(jsii_name="resetWest")
    def reset_west(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWest", []))

    @jsii.member(jsii_name="resetWestVar")
    def reset_west_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWestVar", []))

    @builtins.property
    @jsii.member(jsii_name="eastInput")
    def east_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "eastInput"))

    @builtins.property
    @jsii.member(jsii_name="eastVarInput")
    def east_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "eastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="northInput")
    def north_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "northInput"))

    @builtins.property
    @jsii.member(jsii_name="northVarInput")
    def north_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "northVarInput"))

    @builtins.property
    @jsii.member(jsii_name="southInput")
    def south_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "southInput"))

    @builtins.property
    @jsii.member(jsii_name="southVarInput")
    def south_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "southVarInput"))

    @builtins.property
    @jsii.member(jsii_name="westInput")
    def west_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "westInput"))

    @builtins.property
    @jsii.member(jsii_name="westVarInput")
    def west_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "westVarInput"))

    @builtins.property
    @jsii.member(jsii_name="east")
    def east(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "east"))

    @east.setter
    def east(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6132ffa46ae357ab1e0e85d40236aeb3e32a250270a023fa5d2744473d07e817)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "east", value)

    @builtins.property
    @jsii.member(jsii_name="eastVar")
    def east_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "eastVar"))

    @east_var.setter
    def east_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3917b5b4b1bd1e99ba0a75a32a68979e100c269e4b68505e77a770988228e8dc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "eastVar", value)

    @builtins.property
    @jsii.member(jsii_name="north")
    def north(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "north"))

    @north.setter
    def north(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__557e7d040c44b4ff7be1568cbc2dad8daf307e4f6c66e4bd219a6d00f8645795)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "north", value)

    @builtins.property
    @jsii.member(jsii_name="northVar")
    def north_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "northVar"))

    @north_var.setter
    def north_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4c2c0f8f2650a1e5a94310c4250b8cfb0eeb44e54c8ae4ee01c32c3f0b176be1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "northVar", value)

    @builtins.property
    @jsii.member(jsii_name="south")
    def south(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "south"))

    @south.setter
    def south(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ba55d4689a8b16c5b921f46af6bc5cf967ed617c39897f96b13d4ce01232f094)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "south", value)

    @builtins.property
    @jsii.member(jsii_name="southVar")
    def south_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "southVar"))

    @south_var.setter
    def south_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f85bd75b7ed93f4efed34e21e6e7858d74074886387487cfa3944bb31e951d78)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "southVar", value)

    @builtins.property
    @jsii.member(jsii_name="west")
    def west(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "west"))

    @west.setter
    def west(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__54d839194b340d1c9488144755a09299f7e65364f357c0348c396128081d4813)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "west", value)

    @builtins.property
    @jsii.member(jsii_name="westVar")
    def west_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "westVar"))

    @west_var.setter
    def west_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a78ba24cc384f4551f5105d4174d089f77e4995c97270b08ec23a60bf6d10886)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "westVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeRelativeCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeRelativeCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeRelativeCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a25f2597cd4bc8689756724180bdb4589c279779eeae5db8e1572a3e509a7ce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeRemoveColor",
    jsii_struct_bases=[],
    name_mapping={
        "color": "color",
        "color_var": "colorVar",
        "feather": "feather",
        "feather_var": "featherVar",
        "tolerance": "tolerance",
        "tolerance_var": "toleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeRemoveColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
        feather: typing.Optional[builtins.str] = None,
        feather_var: typing.Optional[builtins.str] = None,
        tolerance: typing.Optional[builtins.str] = None,
        tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        :param feather: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        :param feather_var: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        :param tolerance: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        :param tolerance_var: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__41b534f0a8ee3c4b6c50b64d398cafb9feb5c3a4048062d124bf4e101606f419)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
            check_type(argname="argument feather", value=feather, expected_type=type_hints["feather"])
            check_type(argname="argument feather_var", value=feather_var, expected_type=type_hints["feather_var"])
            check_type(argname="argument tolerance", value=tolerance, expected_type=type_hints["tolerance"])
            check_type(argname="argument tolerance_var", value=tolerance_var, expected_type=type_hints["tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var
        if feather is not None:
            self._values["feather"] = feather
        if feather_var is not None:
            self._values["feather_var"] = feather_var
        if tolerance is not None:
            self._values["tolerance"] = tolerance
        if tolerance_var is not None:
            self._values["tolerance_var"] = tolerance_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        '''
        result = self._values.get("feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather_var(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        '''
        result = self._values.get("feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        '''
        result = self._values.get("tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance_var(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        result = self._values.get("tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeRemoveColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeRemoveColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeRemoveColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d22321e7af129ab1ff3cce926e11fc18bbd6f2d6c444a9d77303c54bfdb10dab)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeRemoveColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3d1e3601ff9047f738b44d569e2bc2e8d76cdd9030eaf82a20e758c904ee008a)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeRemoveColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__83ecc91ba6d4b21aacfa12505597d88f5b2eb6dd6d8663685d8638c850c579ef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__14becb7a712be534efd5cdac2c86a053c571abb61faab9d9f44b554471f55cdb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b6886cc37a247414379c8391e7c1b4385d5c23a50a93330b1ea7169e50402d02)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeRemoveColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeRemoveColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeRemoveColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5c53c28858ad058a41aba5db7a1cf0418f27f88825522b0a2ae47219803a53fc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeRemoveColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeRemoveColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__068788b6b56ee5140c0fcd2ed94a3347a65a11411b25eaceb64c3dbc53ef8cec)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @jsii.member(jsii_name="resetFeather")
    def reset_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeather", []))

    @jsii.member(jsii_name="resetFeatherVar")
    def reset_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatherVar", []))

    @jsii.member(jsii_name="resetTolerance")
    def reset_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTolerance", []))

    @jsii.member(jsii_name="resetToleranceVar")
    def reset_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featherInput")
    def feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherInput"))

    @builtins.property
    @jsii.member(jsii_name="featherVarInput")
    def feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceInput")
    def tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceVarInput")
    def tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ec2e195482cead0153e9ec795e0d06acc1cf0f8967aebb350a917496cba0282e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b0c7e9fca3cbb3cc2a681c743bf014b2d6d419d4cae9bfcf37f76673f0522399)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="feather")
    def feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "feather"))

    @feather.setter
    def feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9f84f2c38b73ab87bc0b06dbd8eca4161e3fcdd35778f7149926d5752195877d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "feather", value)

    @builtins.property
    @jsii.member(jsii_name="featherVar")
    def feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featherVar"))

    @feather_var.setter
    def feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__40dfaabe97596fb9b2a67073dbd7763c09470d12b77e7439f5a511748f97ec20)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featherVar", value)

    @builtins.property
    @jsii.member(jsii_name="tolerance")
    def tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tolerance"))

    @tolerance.setter
    def tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d2142872800f467268ba8d6a4e58de7b54daa574a001bcc9a7f6c4c69b570c21)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tolerance", value)

    @builtins.property
    @jsii.member(jsii_name="toleranceVar")
    def tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "toleranceVar"))

    @tolerance_var.setter
    def tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d9fb8cce1b670ecb470d716b38295bb96347a8785b586f5602d2aec5620e0409)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "toleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeRemoveColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeRemoveColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeRemoveColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cac3914f6df9dd0e041b628f3fb4c9d80a3bf624b5ae5417d7932731e063d35a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeResize",
    jsii_struct_bases=[],
    name_mapping={
        "aspect": "aspect",
        "aspect_var": "aspectVar",
        "height": "height",
        "height_var": "heightVar",
        "type": "type",
        "type_var": "typeVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeResize:
    def __init__(
        self,
        *,
        aspect: typing.Optional[builtins.str] = None,
        aspect_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param aspect: Preserves the aspect ratio. Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect DataAkamaiImagingPolicyImage#aspect}
        :param aspect_var: Preserves the aspect ratio. Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_var DataAkamaiImagingPolicyImage#aspect_var}
        :param height: The height to resize the source image to. Must be set if height is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height to resize the source image to. Must be set if height is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param type: Sets constraints for the image resize. Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: Sets constraints for the image resize. Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        :param width: The width to resize the source image to. Must be set if width is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width to resize the source image to. Must be set if width is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b9e40832ac6682a8e30c535d5ca3d4780aa621ae935cc81ecb20dde2d36cbb87)
            check_type(argname="argument aspect", value=aspect, expected_type=type_hints["aspect"])
            check_type(argname="argument aspect_var", value=aspect_var, expected_type=type_hints["aspect_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if aspect is not None:
            self._values["aspect"] = aspect
        if aspect_var is not None:
            self._values["aspect_var"] = aspect_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def aspect(self) -> typing.Optional[builtins.str]:
        '''Preserves the aspect ratio.

        Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect DataAkamaiImagingPolicyImage#aspect}
        '''
        result = self._values.get("aspect")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def aspect_var(self) -> typing.Optional[builtins.str]:
        '''Preserves the aspect ratio.

        Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_var DataAkamaiImagingPolicyImage#aspect_var}
        '''
        result = self._values.get("aspect_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height to resize the source image to. Must be set if height is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height to resize the source image to. Must be set if height is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''Sets constraints for the image resize.

        Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''Sets constraints for the image resize.

        Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width to resize the source image to. Must be set if width is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width to resize the source image to. Must be set if width is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeResize(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeResizeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeResizeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__806201270f896a4de635072f73edd681f68fcef8ed626b64a881f99e3aa6bc35)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeResizeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c285d156d4509967983cb31b270559e752320f9cc3d0c8af521a362f875c2fbc)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeResizeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d1bf93b3293c42d1f53fa32d4d2add0f07eef00557872d360a75fc69f25ebfa5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f255b791bface77ca36a96a1f94c469b9ad8d73e8d5f5f07f16ea1e5d3356da2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__065a1c72a39c41ec40411f3db153c47f519cccd33adfe045ef05b9ea5c2b4bfe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeResize]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeResize]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeResize]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bd4c793de4f7cda89e17edaed53d1332e17ee085c2927d17ccf82f613b94e72d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeResizeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeResizeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ffdbfb5b913f81219a8d8357f28176c89f0ced455d858133694910d093d8ca7c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAspect")
    def reset_aspect(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspect", []))

    @jsii.member(jsii_name="resetAspectVar")
    def reset_aspect_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspectVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="aspectInput")
    def aspect_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "aspectInput"))

    @builtins.property
    @jsii.member(jsii_name="aspectVarInput")
    def aspect_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "aspectVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="aspect")
    def aspect(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "aspect"))

    @aspect.setter
    def aspect(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__718515a115959ccb8f5900db7a0bad3b2baa5974cca84b05274e12d578787ed5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "aspect", value)

    @builtins.property
    @jsii.member(jsii_name="aspectVar")
    def aspect_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "aspectVar"))

    @aspect_var.setter
    def aspect_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bd26c61128dee2af5f0b2209586bda17aac8f79830fbcfc72c05542532e2aa37)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "aspectVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__587c7bce40b3278860d0fe701ea2826a52d112faacc68876e42c17c3807db8f1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__efda1d9744e9f2f33fed1f3d9827432eeba18d62f0c8791d5c53c52a8ed604e6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ae38b024597b1654287f1efffe22c0c316d852f2048e5654e7f6b201b7be4f4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ed2d31ca0c890b0142b69bdcf49d8b6f7b4df988dee1e137957f066add1d092c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__30b11f132f7a7b6577c15cf539d781ba5047adc618411270f7ef2f61cf75bee9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__12c4f0fac3b4a95488bb4b8f2ab75de83337e77913a7249e03fa6a4d9e2c36a7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeResize]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeResize]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeResize]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d4118d89bc4ac0a0b9339d6fd97d71f702a04ad4df8fa2b919369a74e465161d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeRotate",
    jsii_struct_bases=[],
    name_mapping={"degrees": "degrees", "degrees_var": "degreesVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeRotate:
    def __init__(
        self,
        *,
        degrees: typing.Optional[builtins.str] = None,
        degrees_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param degrees: The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees DataAkamaiImagingPolicyImage#degrees}
        :param degrees_var: The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees_var DataAkamaiImagingPolicyImage#degrees_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__32841d0e98c5f39ab6e304f60f672ffe779c9179de151464fbb6400cbd5653f1)
            check_type(argname="argument degrees", value=degrees, expected_type=type_hints["degrees"])
            check_type(argname="argument degrees_var", value=degrees_var, expected_type=type_hints["degrees_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if degrees is not None:
            self._values["degrees"] = degrees
        if degrees_var is not None:
            self._values["degrees_var"] = degrees_var

    @builtins.property
    def degrees(self) -> typing.Optional[builtins.str]:
        '''The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees DataAkamaiImagingPolicyImage#degrees}
        '''
        result = self._values.get("degrees")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def degrees_var(self) -> typing.Optional[builtins.str]:
        '''The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees_var DataAkamaiImagingPolicyImage#degrees_var}
        '''
        result = self._values.get("degrees_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeRotate(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeRotateList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeRotateList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0869756ed57b0be26910f95df8b50e360fd43c783966d65a47bce226b62164ae)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeRotateOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fbac936ded78dc5652b008da8714b0001e1ad03c7d1aa3ddc57ef13f0d47e23d)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeRotateOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aa1973d9e531b87b35ad4728a421b211e04e17429293fd2b04e32438930901b0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__612b1c6b71bdf6d58df0e4fe8be803b3411cbf7f375f179cdd1755c5a1fac847)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e0e9a0b3ac91a470a1685eaf005647878580106a205778685adfda64b3e60bcc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeRotate]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeRotate]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeRotate]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__508d10feabecc5c24fbc35f52d1a4834ff563b65c106a44f41b51c3852cec413)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeRotateOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeRotateOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__224a6fcf320b077c2b85d124f36d20757c0db40507b685342164f1067fb7a717)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetDegrees")
    def reset_degrees(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDegrees", []))

    @jsii.member(jsii_name="resetDegreesVar")
    def reset_degrees_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDegreesVar", []))

    @builtins.property
    @jsii.member(jsii_name="degreesInput")
    def degrees_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "degreesInput"))

    @builtins.property
    @jsii.member(jsii_name="degreesVarInput")
    def degrees_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "degreesVarInput"))

    @builtins.property
    @jsii.member(jsii_name="degrees")
    def degrees(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "degrees"))

    @degrees.setter
    def degrees(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__82c43f6aeb56009952463c2cbd5f8604da37d60d362b34840cb3670c6c48d93f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "degrees", value)

    @builtins.property
    @jsii.member(jsii_name="degreesVar")
    def degrees_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "degreesVar"))

    @degrees_var.setter
    def degrees_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2b5bba98cc4d97097e1c72662cfc5597cecfa905808851b6a380f582f4ad30b9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "degreesVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeRotate]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeRotate]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeRotate]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__632d7da450365964c3b0ba37315ca359e0c9c07d85fb532a11487a67ab552124)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeScale",
    jsii_struct_bases=[],
    name_mapping={
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeScale:
    def __init__(
        self,
        *,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param height: Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged. Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged. Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__da5e3506009dac8bfca65e68fc9a85b2de55aa85c74b828f31cf7d20ce2ec734)
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size.

        Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size.

        Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged.

        Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged.

        Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeScale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeScaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeScaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cddfcd46fb06d6ee53c75ba4a795a89f46995b836ab0090834cf93c74acc39bc)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeScaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ad39ac5b97e3acb82eddf7f6227ebb448bfdacdb51a780cb2efcd4efc2e3255)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeScaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d416a608a76a2a4380566d5d65d8cd7b342d244c278361d50356ac89d4b9663a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__34038e0c2231b62bd9ed8294b5547ef02173dd525fe7c066d6365c9352869371)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fe863d4274f8fe185c46fafae67e5527d02ad7478d7107329510d714fb2b5f2c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeScale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeScale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeScale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7812a4535b4351650430c4f403118dbfb4d7a9a9c8356a369315d3c046b36d86)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeScaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeScaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f827290528c459ad741b63a0560f58d342ba466404aef94e6589cf5af787d96)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__53ef474e3885b33dbd092a1c198c371c94f3b2953725bf1114c06f08d9d1de4f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b2c9512c7205a86a653d813954887238f58f10adf8e310a235c40935847ab948)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ebd88e263c7e6f0584986d24d4aef4f6f1c574c36e0d01424fd31235b4505b9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8011c21621fab43ba9e35ff8ff51e03b8842c2f5b4a675fa9b72e440047e419e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeScale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeScale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeScale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d38b9e67ce0aafbb289a7b855dce0a28e3302582b377b3914e9584d1740cc4a9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeShear",
    jsii_struct_bases=[],
    name_mapping={
        "x_shear": "xShear",
        "x_shear_var": "xShearVar",
        "y_shear": "yShear",
        "y_shear_var": "yShearVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeShear:
    def __init__(
        self,
        *,
        x_shear: typing.Optional[builtins.str] = None,
        x_shear_var: typing.Optional[builtins.str] = None,
        y_shear: typing.Optional[builtins.str] = None,
        y_shear_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param x_shear: The amount to shear along the x-axis, measured in multiples of the image's width. Must be set if yShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear DataAkamaiImagingPolicyImage#x_shear}
        :param x_shear_var: The amount to shear along the x-axis, measured in multiples of the image's width. Must be set if yShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear_var DataAkamaiImagingPolicyImage#x_shear_var}
        :param y_shear: The amount to shear along the y-axis, measured in multiples of the image's height. Must be set if xShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear DataAkamaiImagingPolicyImage#y_shear}
        :param y_shear_var: The amount to shear along the y-axis, measured in multiples of the image's height. Must be set if xShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear_var DataAkamaiImagingPolicyImage#y_shear_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fd6793f930a3e5fad565f3898e22ac98211ec60b9bed8818a7d5a1b84d3d26a1)
            check_type(argname="argument x_shear", value=x_shear, expected_type=type_hints["x_shear"])
            check_type(argname="argument x_shear_var", value=x_shear_var, expected_type=type_hints["x_shear_var"])
            check_type(argname="argument y_shear", value=y_shear, expected_type=type_hints["y_shear"])
            check_type(argname="argument y_shear_var", value=y_shear_var, expected_type=type_hints["y_shear_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if x_shear is not None:
            self._values["x_shear"] = x_shear
        if x_shear_var is not None:
            self._values["x_shear_var"] = x_shear_var
        if y_shear is not None:
            self._values["y_shear"] = y_shear
        if y_shear_var is not None:
            self._values["y_shear_var"] = y_shear_var

    @builtins.property
    def x_shear(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the x-axis, measured in multiples of the image's width.

        Must be set if yShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear DataAkamaiImagingPolicyImage#x_shear}
        '''
        result = self._values.get("x_shear")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_shear_var(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the x-axis, measured in multiples of the image's width.

        Must be set if yShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear_var DataAkamaiImagingPolicyImage#x_shear_var}
        '''
        result = self._values.get("x_shear_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_shear(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the y-axis, measured in multiples of the image's height.

        Must be set if xShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear DataAkamaiImagingPolicyImage#y_shear}
        '''
        result = self._values.get("y_shear")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_shear_var(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the y-axis, measured in multiples of the image's height.

        Must be set if xShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear_var DataAkamaiImagingPolicyImage#y_shear_var}
        '''
        result = self._values.get("y_shear_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeShear(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeShearList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeShearList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7221e2cece3c7374f29692e2c342fd53bb1d2366526119d1f72ff91b87aad4c9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeShearOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d95ce7c3eb640bd3fb1c8a0262436ed9d76e39f8507182d8ed052be03dd76d38)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeShearOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8600250202108cbb8dafc5e3e7f950e38c0990f0941cab5d7d8024297c1d0c6c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3b6add3e6027aefd4283f45712fc8f0d4d4c0cc50b803b733946e1a24e2df852)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f5f3fca900ee6acaed296a4b8081f298987215f62d67004ffdc263dc9693ba87)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeShear]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeShear]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeShear]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__105c42c7daadcf8290e1a7eea08d852b4cf778e7fc97a71dbe7d66bd14c92ab1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeShearOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeShearOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f983c62fe535e3c5d13d383d1330741746e22b70969c3d5d5adddb53a4377281)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetXShear")
    def reset_x_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXShear", []))

    @jsii.member(jsii_name="resetXShearVar")
    def reset_x_shear_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXShearVar", []))

    @jsii.member(jsii_name="resetYShear")
    def reset_y_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYShear", []))

    @jsii.member(jsii_name="resetYShearVar")
    def reset_y_shear_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYShearVar", []))

    @builtins.property
    @jsii.member(jsii_name="xShearInput")
    def x_shear_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xShearInput"))

    @builtins.property
    @jsii.member(jsii_name="xShearVarInput")
    def x_shear_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xShearVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yShearInput")
    def y_shear_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yShearInput"))

    @builtins.property
    @jsii.member(jsii_name="yShearVarInput")
    def y_shear_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yShearVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xShear")
    def x_shear(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xShear"))

    @x_shear.setter
    def x_shear(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__325a8f395ceaf12d109636ad968aa83459e82484b717bf920e990a67c95c42a8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xShear", value)

    @builtins.property
    @jsii.member(jsii_name="xShearVar")
    def x_shear_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xShearVar"))

    @x_shear_var.setter
    def x_shear_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__05ed821eb361413929085e81c38caaa0c7a8630da019d612dbd3bcdd1a782b73)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xShearVar", value)

    @builtins.property
    @jsii.member(jsii_name="yShear")
    def y_shear(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yShear"))

    @y_shear.setter
    def y_shear(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa1f72a077ff98966c71061e52de0fcaea1fdc125ff9c2510d24c64695f872aa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yShear", value)

    @builtins.property
    @jsii.member(jsii_name="yShearVar")
    def y_shear_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yShearVar"))

    @y_shear_var.setter
    def y_shear_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7258887b08f9b4c989773a27b19f8e6e53ff30d36a565bb4a210c9e5886432dc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yShearVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeShear]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeShear]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeShear]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__419f82487947b27eab076e3d44c49c7d88773463ae14db8d9a0897ebcb625698)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeTrim",
    jsii_struct_bases=[],
    name_mapping={
        "fuzz": "fuzz",
        "fuzz_var": "fuzzVar",
        "padding": "padding",
        "padding_var": "paddingVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeTrim:
    def __init__(
        self,
        *,
        fuzz: typing.Optional[builtins.str] = None,
        fuzz_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fuzz: The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz DataAkamaiImagingPolicyImage#fuzz}
        :param fuzz_var: The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz_var DataAkamaiImagingPolicyImage#fuzz_var}
        :param padding: The amount of padding in pixels to add to the trimmed image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: The amount of padding in pixels to add to the trimmed image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d493c7a0652318785c328bf0e3756ab49ecdca73c1ec45f277a2b968b48e5670)
            check_type(argname="argument fuzz", value=fuzz, expected_type=type_hints["fuzz"])
            check_type(argname="argument fuzz_var", value=fuzz_var, expected_type=type_hints["fuzz_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fuzz is not None:
            self._values["fuzz"] = fuzz
        if fuzz_var is not None:
            self._values["fuzz_var"] = fuzz_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var

    @builtins.property
    def fuzz(self) -> typing.Optional[builtins.str]:
        '''The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz DataAkamaiImagingPolicyImage#fuzz}
        '''
        result = self._values.get("fuzz")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fuzz_var(self) -> typing.Optional[builtins.str]:
        '''The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz_var DataAkamaiImagingPolicyImage#fuzz_var}
        '''
        result = self._values.get("fuzz_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''The amount of padding in pixels to add to the trimmed image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''The amount of padding in pixels to add to the trimmed image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeTrim(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeTrimList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeTrimList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__71ea7dcb1adf4edf1be58f02e44865893abf3d5f4341c0fa63528a7e8034d72c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeTrimOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3907be40b7daf1cd5056e06052dc8b60a4c32652b8e48c8f264d1e696d3197e8)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeTrimOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f6959ce99c752019a865b2c2de98211318216d42dadebea14d4f0b9ef29c3c8f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__474361083372a4e684f36092d7e445bc306061984ba4f998613935df1b1f39c4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fb63fd096ad03563f77701e831089144c02624261b7dd9fdd141b198f53cbf03)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeTrim]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeTrim]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeTrim]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__81a7c787c97a6844e5db82d82487b9b0f14b5ec5683f22c410f543a37c6e6b22)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeTrimOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeTrimOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f3676582676bcc1c6e3408829573f1b9f3830756b6a4329f7dc6ca5d6b1618f0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetFuzz")
    def reset_fuzz(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFuzz", []))

    @jsii.member(jsii_name="resetFuzzVar")
    def reset_fuzz_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFuzzVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @builtins.property
    @jsii.member(jsii_name="fuzzInput")
    def fuzz_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fuzzInput"))

    @builtins.property
    @jsii.member(jsii_name="fuzzVarInput")
    def fuzz_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fuzzVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="fuzz")
    def fuzz(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fuzz"))

    @fuzz.setter
    def fuzz(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a52f6ebd7a72a26fced9519ad05a7071de4e1a9b4f761d54845f8c32130b1678)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fuzz", value)

    @builtins.property
    @jsii.member(jsii_name="fuzzVar")
    def fuzz_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fuzzVar"))

    @fuzz_var.setter
    def fuzz_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__35fae95313df8e24c36b615a4729c888e1ce858e8ba9e1a1204c8bac23911c1b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fuzzVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d5393af8e0d5a27db259272a06dc05c62c4eb459431ba7d4f855645404f8b20c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f3ca9fd28322637eceac9c1c87d29fa749e65c092b6199cd7f736048c81a0d17)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeTrim]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeTrim]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeTrim]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c38a582e3bb2c063ec81c8be1781403d090a617cdd69dcc227b09578bf98a313)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeUnsharpMask",
    jsii_struct_bases=[],
    name_mapping={
        "gain": "gain",
        "gain_var": "gainVar",
        "sigma": "sigma",
        "sigma_var": "sigmaVar",
        "threshold": "threshold",
        "threshold_var": "thresholdVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeUnsharpMask:
    def __init__(
        self,
        *,
        gain: typing.Optional[builtins.str] = None,
        gain_var: typing.Optional[builtins.str] = None,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
        threshold: typing.Optional[builtins.str] = None,
        threshold_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param gain: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        :param gain_var: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        :param sigma: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        :param threshold: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        :param threshold_var: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d869bc1105cbbea013aad09b42a23fa545e7dabddd9bfa9e3f4bec5c8eff16e0)
            check_type(argname="argument gain", value=gain, expected_type=type_hints["gain"])
            check_type(argname="argument gain_var", value=gain_var, expected_type=type_hints["gain_var"])
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
            check_type(argname="argument threshold", value=threshold, expected_type=type_hints["threshold"])
            check_type(argname="argument threshold_var", value=threshold_var, expected_type=type_hints["threshold_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if gain is not None:
            self._values["gain"] = gain
        if gain_var is not None:
            self._values["gain_var"] = gain_var
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var
        if threshold is not None:
            self._values["threshold"] = threshold
        if threshold_var is not None:
            self._values["threshold_var"] = threshold_var

    @builtins.property
    def gain(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        '''
        result = self._values.get("gain")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gain_var(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        '''
        result = self._values.get("gain_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        '''
        result = self._values.get("threshold")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold_var(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        result = self._values.get("threshold_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeUnsharpMask(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeUnsharpMaskList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeUnsharpMaskList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ef34e92a2bc2ad224a338e9d7a68bcd6d954c7989207e883abf1e2cbe505fa0b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeUnsharpMaskOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4e90c6705021b2bbfe291cbf2abe91e1761b5bd28d47cb1bfbad6a78a0c308a7)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeUnsharpMaskOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5578a1d3d375b3dd8f62f47e4d0b30976feaea3691c5b64945281c27112385de)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a128702189d6f633133c4b22bd433c7496c3885186f45d4968eaa7fa262c624a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__13918c832db5b60c8aaf52993660efc5103b0dad3a83c14059d0bf66625ca395)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeUnsharpMask]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeUnsharpMask]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeUnsharpMask]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ffeb2593d96200f81adc1ef2380baedb206ca966046ab77e4e2d77ef7d1eba82)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeUnsharpMaskOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeUnsharpMaskOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__137ed6b03be9cd89e8937166a1b13bd0d597160e8ad137bd1fda58466b27eebb)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetGain")
    def reset_gain(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGain", []))

    @jsii.member(jsii_name="resetGainVar")
    def reset_gain_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGainVar", []))

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @jsii.member(jsii_name="resetThreshold")
    def reset_threshold(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThreshold", []))

    @jsii.member(jsii_name="resetThresholdVar")
    def reset_threshold_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThresholdVar", []))

    @builtins.property
    @jsii.member(jsii_name="gainInput")
    def gain_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainInput"))

    @builtins.property
    @jsii.member(jsii_name="gainVarInput")
    def gain_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdInput")
    def threshold_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdVarInput")
    def threshold_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gain")
    def gain(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gain"))

    @gain.setter
    def gain(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9fb21855ef6cc6f57a41db21fa73b74bb3a7cdcd6d2a3383ffc2f3b1bc273090)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gain", value)

    @builtins.property
    @jsii.member(jsii_name="gainVar")
    def gain_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gainVar"))

    @gain_var.setter
    def gain_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__97d7f65c63e71799b2da5b6f91daa361ae0e60c8618d22eafa9676891b4c015e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gainVar", value)

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f056c84aa118a989d558eb269e404c5e5373b80e22900c7c2b7cda15f54efd9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e358f092d3ae746ddcf07a3a9d374fef1bf801cc235f1a051e03d432800b0f4e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="threshold")
    def threshold(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "threshold"))

    @threshold.setter
    def threshold(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__76676adfc0ec721dd831ceaa08d002639b62488ff577732db9ebf46d3496aa91)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "threshold", value)

    @builtins.property
    @jsii.member(jsii_name="thresholdVar")
    def threshold_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "thresholdVar"))

    @threshold_var.setter
    def threshold_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ee05aad5bc778648fd16b04b343e6079c26ffe86f14626e8dd8a72e3b0dd849c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "thresholdVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeUnsharpMask]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeUnsharpMask]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeUnsharpMask]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b012d7eee0e9538ba65a3e7f3bd408402935889ac3feed8cb0625ffbe206d73f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__81754f7d5945a30fde628aadfa5f60e21cda524deacd97777deac039dc65b560)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0d28df60d5782c41038b78ac9ca82708520b43b368ab66bd4e8c551a5611827e)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e91fb00963332df2ce55d600e0775430d08cae6a0a13fb0072a6c1a1bf82d8fc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5c9839fa1ee117759f8d158f8b4445c4d7e0d86ea754bd4847de488f3a6e8c51)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e9b9ece4ab2358ea980cb0232cc9003aa4586b2781a0efaf6e734e83788e6f2e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientation]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientation]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__48fb692fc4266ad7186c43da4232cad1dc8cfd70ea7302278c27e6f08ad1ad68)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__67c62ffc6872abe11a556f0920905ae90aa013c739a5871dd8935f9058b2e7e1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(
        self,
        *,
        append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultAppend, typing.Dict[builtins.str, typing.Any]]]]] = None,
        aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultAspectCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
        crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultFaceCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultFeatureCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultFitAndFill, typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
        im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultImQuery, typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
        region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultRegionOfInterestCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultRelativeCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
        resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultResize, typing.Dict[builtins.str, typing.Any]]]]] = None,
        rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultRotate, typing.Dict[builtins.str, typing.Any]]]]] = None,
        scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultScale, typing.Dict[builtins.str, typing.Any]]]]] = None,
        shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultShear, typing.Dict[builtins.str, typing.Any]]]]] = None,
        trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultTrim, typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param append: append block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        :param aspect_crop: aspect_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param crop: crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        :param face_crop: face_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        :param feature_crop: feature_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        :param fit_and_fill: fit_and_fill block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param im_query: im_query block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param region_of_interest_crop: region_of_interest_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        :param relative_crop: relative_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param resize: resize block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        :param rotate: rotate block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        :param scale: scale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param shear: shear block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        :param trim: trim block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefault(
            append=append,
            aspect_crop=aspect_crop,
            background_color=background_color,
            blur=blur,
            chroma_key=chroma_key,
            composite=composite,
            compound=compound,
            contrast=contrast,
            crop=crop,
            face_crop=face_crop,
            feature_crop=feature_crop,
            fit_and_fill=fit_and_fill,
            goop=goop,
            grayscale=grayscale,
            hsl=hsl,
            hsv=hsv,
            if_dimension=if_dimension,
            if_orientation=if_orientation,
            im_query=im_query,
            max_colors=max_colors,
            mirror=mirror,
            mono_hue=mono_hue,
            opacity=opacity,
            region_of_interest_crop=region_of_interest_crop,
            relative_crop=relative_crop,
            remove_color=remove_color,
            resize=resize,
            rotate=rotate,
            scale=scale,
            shear=shear,
            trim=trim,
            unsharp_mask=unsharp_mask,
        )

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putLandscape")
    def put_landscape(
        self,
        *,
        append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeAppend, typing.Dict[builtins.str, typing.Any]]]]] = None,
        aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeAspectCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
        crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeFaceCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeFeatureCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeFitAndFill, typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
        im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeImQuery, typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
        region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeRegionOfInterestCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeRelativeCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
        resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeResize, typing.Dict[builtins.str, typing.Any]]]]] = None,
        rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeRotate, typing.Dict[builtins.str, typing.Any]]]]] = None,
        scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeScale, typing.Dict[builtins.str, typing.Any]]]]] = None,
        shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeShear, typing.Dict[builtins.str, typing.Any]]]]] = None,
        trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeTrim, typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param append: append block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        :param aspect_crop: aspect_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param crop: crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        :param face_crop: face_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        :param feature_crop: feature_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        :param fit_and_fill: fit_and_fill block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param im_query: im_query block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param region_of_interest_crop: region_of_interest_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        :param relative_crop: relative_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param resize: resize block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        :param rotate: rotate block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        :param scale: scale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param shear: shear block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        :param trim: trim block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscape(
            append=append,
            aspect_crop=aspect_crop,
            background_color=background_color,
            blur=blur,
            chroma_key=chroma_key,
            composite=composite,
            compound=compound,
            contrast=contrast,
            crop=crop,
            face_crop=face_crop,
            feature_crop=feature_crop,
            fit_and_fill=fit_and_fill,
            goop=goop,
            grayscale=grayscale,
            hsl=hsl,
            hsv=hsv,
            if_dimension=if_dimension,
            if_orientation=if_orientation,
            im_query=im_query,
            max_colors=max_colors,
            mirror=mirror,
            mono_hue=mono_hue,
            opacity=opacity,
            region_of_interest_crop=region_of_interest_crop,
            relative_crop=relative_crop,
            remove_color=remove_color,
            resize=resize,
            rotate=rotate,
            scale=scale,
            shear=shear,
            trim=trim,
            unsharp_mask=unsharp_mask,
        )

        return typing.cast(None, jsii.invoke(self, "putLandscape", [value]))

    @jsii.member(jsii_name="putPortrait")
    def put_portrait(
        self,
        *,
        append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitAppend", typing.Dict[builtins.str, typing.Any]]]]] = None,
        aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitAspectCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitBackgroundColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitBlur", typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitChromaKey", typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitComposite", typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitCompound", typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitContrast", typing.Dict[builtins.str, typing.Any]]]]] = None,
        crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitFaceCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitFeatureCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitFitAndFill", typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitGoop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitGrayscale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitHsl", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitHsv", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimension", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientation", typing.Dict[builtins.str, typing.Any]]]]] = None,
        im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitImQuery", typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitMaxColors", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitMirror", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitMonoHue", typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitOpacity", typing.Dict[builtins.str, typing.Any]]]]] = None,
        region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitRegionOfInterestCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitRelativeCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitRemoveColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitResize", typing.Dict[builtins.str, typing.Any]]]]] = None,
        rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitRotate", typing.Dict[builtins.str, typing.Any]]]]] = None,
        scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitScale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitShear", typing.Dict[builtins.str, typing.Any]]]]] = None,
        trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitTrim", typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitUnsharpMask", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param append: append block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        :param aspect_crop: aspect_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param crop: crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        :param face_crop: face_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        :param feature_crop: feature_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        :param fit_and_fill: fit_and_fill block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param im_query: im_query block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param region_of_interest_crop: region_of_interest_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        :param relative_crop: relative_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param resize: resize block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        :param rotate: rotate block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        :param scale: scale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param shear: shear block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        :param trim: trim block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortrait(
            append=append,
            aspect_crop=aspect_crop,
            background_color=background_color,
            blur=blur,
            chroma_key=chroma_key,
            composite=composite,
            compound=compound,
            contrast=contrast,
            crop=crop,
            face_crop=face_crop,
            feature_crop=feature_crop,
            fit_and_fill=fit_and_fill,
            goop=goop,
            grayscale=grayscale,
            hsl=hsl,
            hsv=hsv,
            if_dimension=if_dimension,
            if_orientation=if_orientation,
            im_query=im_query,
            max_colors=max_colors,
            mirror=mirror,
            mono_hue=mono_hue,
            opacity=opacity,
            region_of_interest_crop=region_of_interest_crop,
            relative_crop=relative_crop,
            remove_color=remove_color,
            resize=resize,
            rotate=rotate,
            scale=scale,
            shear=shear,
            trim=trim,
            unsharp_mask=unsharp_mask,
        )

        return typing.cast(None, jsii.invoke(self, "putPortrait", [value]))

    @jsii.member(jsii_name="putSquare")
    def put_square(
        self,
        *,
        append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareAppend", typing.Dict[builtins.str, typing.Any]]]]] = None,
        aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareAspectCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareBackgroundColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareBlur", typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareChromaKey", typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareComposite", typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareCompound", typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareContrast", typing.Dict[builtins.str, typing.Any]]]]] = None,
        crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareFaceCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareFeatureCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareFitAndFill", typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareGoop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareGrayscale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareHsl", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareHsv", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimension", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientation", typing.Dict[builtins.str, typing.Any]]]]] = None,
        im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareImQuery", typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareMaxColors", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareMirror", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareMonoHue", typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareOpacity", typing.Dict[builtins.str, typing.Any]]]]] = None,
        region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareRegionOfInterestCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareRelativeCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareRemoveColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareResize", typing.Dict[builtins.str, typing.Any]]]]] = None,
        rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareRotate", typing.Dict[builtins.str, typing.Any]]]]] = None,
        scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareScale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareShear", typing.Dict[builtins.str, typing.Any]]]]] = None,
        trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareTrim", typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareUnsharpMask", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param append: append block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        :param aspect_crop: aspect_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param crop: crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        :param face_crop: face_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        :param feature_crop: feature_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        :param fit_and_fill: fit_and_fill block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param im_query: im_query block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param region_of_interest_crop: region_of_interest_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        :param relative_crop: relative_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param resize: resize block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        :param rotate: rotate block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        :param scale: scale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param shear: shear block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        :param trim: trim block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquare(
            append=append,
            aspect_crop=aspect_crop,
            background_color=background_color,
            blur=blur,
            chroma_key=chroma_key,
            composite=composite,
            compound=compound,
            contrast=contrast,
            crop=crop,
            face_crop=face_crop,
            feature_crop=feature_crop,
            fit_and_fill=fit_and_fill,
            goop=goop,
            grayscale=grayscale,
            hsl=hsl,
            hsv=hsv,
            if_dimension=if_dimension,
            if_orientation=if_orientation,
            im_query=im_query,
            max_colors=max_colors,
            mirror=mirror,
            mono_hue=mono_hue,
            opacity=opacity,
            region_of_interest_crop=region_of_interest_crop,
            relative_crop=relative_crop,
            remove_color=remove_color,
            resize=resize,
            rotate=rotate,
            scale=scale,
            shear=shear,
            trim=trim,
            unsharp_mask=unsharp_mask,
        )

        return typing.cast(None, jsii.invoke(self, "putSquare", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetLandscape")
    def reset_landscape(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLandscape", []))

    @jsii.member(jsii_name="resetPortrait")
    def reset_portrait(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPortrait", []))

    @jsii.member(jsii_name="resetSquare")
    def reset_square(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSquare", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="landscape")
    def landscape(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeOutputReference, jsii.get(self, "landscape"))

    @builtins.property
    @jsii.member(jsii_name="portrait")
    def portrait(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitOutputReference", jsii.get(self, "portrait"))

    @builtins.property
    @jsii.member(jsii_name="square")
    def square(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareOutputReference", jsii.get(self, "square"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="landscapeInput")
    def landscape_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscape], jsii.get(self, "landscapeInput"))

    @builtins.property
    @jsii.member(jsii_name="portraitInput")
    def portrait_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortrait"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortrait"], jsii.get(self, "portraitInput"))

    @builtins.property
    @jsii.member(jsii_name="squareInput")
    def square_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquare"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquare"], jsii.get(self, "squareInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientation]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientation]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientation]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f063cf0cc19a2b47792d304f3797dc208099ac9ecd5839928bb85e33e62fd57)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortrait",
    jsii_struct_bases=[],
    name_mapping={
        "append": "append",
        "aspect_crop": "aspectCrop",
        "background_color": "backgroundColor",
        "blur": "blur",
        "chroma_key": "chromaKey",
        "composite": "composite",
        "compound": "compound",
        "contrast": "contrast",
        "crop": "crop",
        "face_crop": "faceCrop",
        "feature_crop": "featureCrop",
        "fit_and_fill": "fitAndFill",
        "goop": "goop",
        "grayscale": "grayscale",
        "hsl": "hsl",
        "hsv": "hsv",
        "if_dimension": "ifDimension",
        "if_orientation": "ifOrientation",
        "im_query": "imQuery",
        "max_colors": "maxColors",
        "mirror": "mirror",
        "mono_hue": "monoHue",
        "opacity": "opacity",
        "region_of_interest_crop": "regionOfInterestCrop",
        "relative_crop": "relativeCrop",
        "remove_color": "removeColor",
        "resize": "resize",
        "rotate": "rotate",
        "scale": "scale",
        "shear": "shear",
        "trim": "trim",
        "unsharp_mask": "unsharpMask",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortrait:
    def __init__(
        self,
        *,
        append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitAppend", typing.Dict[builtins.str, typing.Any]]]]] = None,
        aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitAspectCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitBackgroundColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitBlur", typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitChromaKey", typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitComposite", typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitCompound", typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitContrast", typing.Dict[builtins.str, typing.Any]]]]] = None,
        crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitFaceCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitFeatureCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitFitAndFill", typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitGoop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitGrayscale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitHsl", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitHsv", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimension", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientation", typing.Dict[builtins.str, typing.Any]]]]] = None,
        im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitImQuery", typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitMaxColors", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitMirror", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitMonoHue", typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitOpacity", typing.Dict[builtins.str, typing.Any]]]]] = None,
        region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitRegionOfInterestCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitRelativeCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitRemoveColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitResize", typing.Dict[builtins.str, typing.Any]]]]] = None,
        rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitRotate", typing.Dict[builtins.str, typing.Any]]]]] = None,
        scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitScale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitShear", typing.Dict[builtins.str, typing.Any]]]]] = None,
        trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitTrim", typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitUnsharpMask", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param append: append block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        :param aspect_crop: aspect_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param crop: crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        :param face_crop: face_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        :param feature_crop: feature_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        :param fit_and_fill: fit_and_fill block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param im_query: im_query block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param region_of_interest_crop: region_of_interest_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        :param relative_crop: relative_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param resize: resize block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        :param rotate: rotate block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        :param scale: scale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param shear: shear block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        :param trim: trim block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__581c483c816b789e3fdb2b4096cb73a69931a1f99874e5f7216e80a2bf34a3bf)
            check_type(argname="argument append", value=append, expected_type=type_hints["append"])
            check_type(argname="argument aspect_crop", value=aspect_crop, expected_type=type_hints["aspect_crop"])
            check_type(argname="argument background_color", value=background_color, expected_type=type_hints["background_color"])
            check_type(argname="argument blur", value=blur, expected_type=type_hints["blur"])
            check_type(argname="argument chroma_key", value=chroma_key, expected_type=type_hints["chroma_key"])
            check_type(argname="argument composite", value=composite, expected_type=type_hints["composite"])
            check_type(argname="argument compound", value=compound, expected_type=type_hints["compound"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument crop", value=crop, expected_type=type_hints["crop"])
            check_type(argname="argument face_crop", value=face_crop, expected_type=type_hints["face_crop"])
            check_type(argname="argument feature_crop", value=feature_crop, expected_type=type_hints["feature_crop"])
            check_type(argname="argument fit_and_fill", value=fit_and_fill, expected_type=type_hints["fit_and_fill"])
            check_type(argname="argument goop", value=goop, expected_type=type_hints["goop"])
            check_type(argname="argument grayscale", value=grayscale, expected_type=type_hints["grayscale"])
            check_type(argname="argument hsl", value=hsl, expected_type=type_hints["hsl"])
            check_type(argname="argument hsv", value=hsv, expected_type=type_hints["hsv"])
            check_type(argname="argument if_dimension", value=if_dimension, expected_type=type_hints["if_dimension"])
            check_type(argname="argument if_orientation", value=if_orientation, expected_type=type_hints["if_orientation"])
            check_type(argname="argument im_query", value=im_query, expected_type=type_hints["im_query"])
            check_type(argname="argument max_colors", value=max_colors, expected_type=type_hints["max_colors"])
            check_type(argname="argument mirror", value=mirror, expected_type=type_hints["mirror"])
            check_type(argname="argument mono_hue", value=mono_hue, expected_type=type_hints["mono_hue"])
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument region_of_interest_crop", value=region_of_interest_crop, expected_type=type_hints["region_of_interest_crop"])
            check_type(argname="argument relative_crop", value=relative_crop, expected_type=type_hints["relative_crop"])
            check_type(argname="argument remove_color", value=remove_color, expected_type=type_hints["remove_color"])
            check_type(argname="argument resize", value=resize, expected_type=type_hints["resize"])
            check_type(argname="argument rotate", value=rotate, expected_type=type_hints["rotate"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument shear", value=shear, expected_type=type_hints["shear"])
            check_type(argname="argument trim", value=trim, expected_type=type_hints["trim"])
            check_type(argname="argument unsharp_mask", value=unsharp_mask, expected_type=type_hints["unsharp_mask"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if append is not None:
            self._values["append"] = append
        if aspect_crop is not None:
            self._values["aspect_crop"] = aspect_crop
        if background_color is not None:
            self._values["background_color"] = background_color
        if blur is not None:
            self._values["blur"] = blur
        if chroma_key is not None:
            self._values["chroma_key"] = chroma_key
        if composite is not None:
            self._values["composite"] = composite
        if compound is not None:
            self._values["compound"] = compound
        if contrast is not None:
            self._values["contrast"] = contrast
        if crop is not None:
            self._values["crop"] = crop
        if face_crop is not None:
            self._values["face_crop"] = face_crop
        if feature_crop is not None:
            self._values["feature_crop"] = feature_crop
        if fit_and_fill is not None:
            self._values["fit_and_fill"] = fit_and_fill
        if goop is not None:
            self._values["goop"] = goop
        if grayscale is not None:
            self._values["grayscale"] = grayscale
        if hsl is not None:
            self._values["hsl"] = hsl
        if hsv is not None:
            self._values["hsv"] = hsv
        if if_dimension is not None:
            self._values["if_dimension"] = if_dimension
        if if_orientation is not None:
            self._values["if_orientation"] = if_orientation
        if im_query is not None:
            self._values["im_query"] = im_query
        if max_colors is not None:
            self._values["max_colors"] = max_colors
        if mirror is not None:
            self._values["mirror"] = mirror
        if mono_hue is not None:
            self._values["mono_hue"] = mono_hue
        if opacity is not None:
            self._values["opacity"] = opacity
        if region_of_interest_crop is not None:
            self._values["region_of_interest_crop"] = region_of_interest_crop
        if relative_crop is not None:
            self._values["relative_crop"] = relative_crop
        if remove_color is not None:
            self._values["remove_color"] = remove_color
        if resize is not None:
            self._values["resize"] = resize
        if rotate is not None:
            self._values["rotate"] = rotate
        if scale is not None:
            self._values["scale"] = scale
        if shear is not None:
            self._values["shear"] = shear
        if trim is not None:
            self._values["trim"] = trim
        if unsharp_mask is not None:
            self._values["unsharp_mask"] = unsharp_mask

    @builtins.property
    def append(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitAppend"]]]:
        '''append block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        '''
        result = self._values.get("append")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitAppend"]]], result)

    @builtins.property
    def aspect_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitAspectCrop"]]]:
        '''aspect_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        '''
        result = self._values.get("aspect_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitAspectCrop"]]], result)

    @builtins.property
    def background_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitBackgroundColor"]]]:
        '''background_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        '''
        result = self._values.get("background_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitBackgroundColor"]]], result)

    @builtins.property
    def blur(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitBlur"]]]:
        '''blur block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        '''
        result = self._values.get("blur")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitBlur"]]], result)

    @builtins.property
    def chroma_key(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitChromaKey"]]]:
        '''chroma_key block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        '''
        result = self._values.get("chroma_key")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitChromaKey"]]], result)

    @builtins.property
    def composite(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitComposite"]]]:
        '''composite block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        '''
        result = self._values.get("composite")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitComposite"]]], result)

    @builtins.property
    def compound(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitCompound"]]]:
        '''compound block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        '''
        result = self._values.get("compound")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitCompound"]]], result)

    @builtins.property
    def contrast(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitContrast"]]]:
        '''contrast block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitContrast"]]], result)

    @builtins.property
    def crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitCrop"]]]:
        '''crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        '''
        result = self._values.get("crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitCrop"]]], result)

    @builtins.property
    def face_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitFaceCrop"]]]:
        '''face_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        '''
        result = self._values.get("face_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitFaceCrop"]]], result)

    @builtins.property
    def feature_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitFeatureCrop"]]]:
        '''feature_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        '''
        result = self._values.get("feature_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitFeatureCrop"]]], result)

    @builtins.property
    def fit_and_fill(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitFitAndFill"]]]:
        '''fit_and_fill block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        '''
        result = self._values.get("fit_and_fill")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitFitAndFill"]]], result)

    @builtins.property
    def goop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitGoop"]]]:
        '''goop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        '''
        result = self._values.get("goop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitGoop"]]], result)

    @builtins.property
    def grayscale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitGrayscale"]]]:
        '''grayscale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        '''
        result = self._values.get("grayscale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitGrayscale"]]], result)

    @builtins.property
    def hsl(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitHsl"]]]:
        '''hsl block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        '''
        result = self._values.get("hsl")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitHsl"]]], result)

    @builtins.property
    def hsv(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitHsv"]]]:
        '''hsv block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        '''
        result = self._values.get("hsv")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitHsv"]]], result)

    @builtins.property
    def if_dimension(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimension"]]]:
        '''if_dimension block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        '''
        result = self._values.get("if_dimension")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimension"]]], result)

    @builtins.property
    def if_orientation(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientation"]]]:
        '''if_orientation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        '''
        result = self._values.get("if_orientation")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientation"]]], result)

    @builtins.property
    def im_query(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitImQuery"]]]:
        '''im_query block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        '''
        result = self._values.get("im_query")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitImQuery"]]], result)

    @builtins.property
    def max_colors(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitMaxColors"]]]:
        '''max_colors block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        '''
        result = self._values.get("max_colors")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitMaxColors"]]], result)

    @builtins.property
    def mirror(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitMirror"]]]:
        '''mirror block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        '''
        result = self._values.get("mirror")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitMirror"]]], result)

    @builtins.property
    def mono_hue(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitMonoHue"]]]:
        '''mono_hue block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        '''
        result = self._values.get("mono_hue")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitMonoHue"]]], result)

    @builtins.property
    def opacity(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitOpacity"]]]:
        '''opacity block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitOpacity"]]], result)

    @builtins.property
    def region_of_interest_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitRegionOfInterestCrop"]]]:
        '''region_of_interest_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        '''
        result = self._values.get("region_of_interest_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitRegionOfInterestCrop"]]], result)

    @builtins.property
    def relative_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitRelativeCrop"]]]:
        '''relative_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        '''
        result = self._values.get("relative_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitRelativeCrop"]]], result)

    @builtins.property
    def remove_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitRemoveColor"]]]:
        '''remove_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        '''
        result = self._values.get("remove_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitRemoveColor"]]], result)

    @builtins.property
    def resize(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitResize"]]]:
        '''resize block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        '''
        result = self._values.get("resize")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitResize"]]], result)

    @builtins.property
    def rotate(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitRotate"]]]:
        '''rotate block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        '''
        result = self._values.get("rotate")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitRotate"]]], result)

    @builtins.property
    def scale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitScale"]]]:
        '''scale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitScale"]]], result)

    @builtins.property
    def shear(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitShear"]]]:
        '''shear block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        '''
        result = self._values.get("shear")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitShear"]]], result)

    @builtins.property
    def trim(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitTrim"]]]:
        '''trim block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        '''
        result = self._values.get("trim")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitTrim"]]], result)

    @builtins.property
    def unsharp_mask(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitUnsharpMask"]]]:
        '''unsharp_mask block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        result = self._values.get("unsharp_mask")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitUnsharpMask"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortrait(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitAppend",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_priority": "gravityPriority",
        "gravity_priority_var": "gravityPriorityVar",
        "gravity_var": "gravityVar",
        "preserve_minor_dimension": "preserveMinorDimension",
        "preserve_minor_dimension_var": "preserveMinorDimensionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitAppend:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitAppendImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_priority: typing.Optional[builtins.str] = None,
        gravity_priority_var: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        preserve_minor_dimension: typing.Optional[builtins.str] = None,
        preserve_minor_dimension_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Specifies where to place the ``image`` relative to the source image. The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_priority: Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal. The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority DataAkamaiImagingPolicyImage#gravity_priority}
        :param gravity_priority_var: Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal. The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority_var DataAkamaiImagingPolicyImage#gravity_priority_var}
        :param gravity_var: Specifies where to place the ``image`` relative to the source image. The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param preserve_minor_dimension: Whether to preserve the source image's minor dimension, ``false`` by default. The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension DataAkamaiImagingPolicyImage#preserve_minor_dimension}
        :param preserve_minor_dimension_var: Whether to preserve the source image's minor dimension, ``false`` by default. The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension_var DataAkamaiImagingPolicyImage#preserve_minor_dimension_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitAppendImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cf28e681e9445235e01ed43e83e2433a91419dbc0a930a56e955c4de7f2d26f9)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_priority", value=gravity_priority, expected_type=type_hints["gravity_priority"])
            check_type(argname="argument gravity_priority_var", value=gravity_priority_var, expected_type=type_hints["gravity_priority_var"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument preserve_minor_dimension", value=preserve_minor_dimension, expected_type=type_hints["preserve_minor_dimension"])
            check_type(argname="argument preserve_minor_dimension_var", value=preserve_minor_dimension_var, expected_type=type_hints["preserve_minor_dimension_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_priority is not None:
            self._values["gravity_priority"] = gravity_priority
        if gravity_priority_var is not None:
            self._values["gravity_priority_var"] = gravity_priority_var
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if preserve_minor_dimension is not None:
            self._values["preserve_minor_dimension"] = preserve_minor_dimension
        if preserve_minor_dimension_var is not None:
            self._values["preserve_minor_dimension_var"] = preserve_minor_dimension_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitAppendImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitAppendImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Specifies where to place the ``image`` relative to the source image.

        The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_priority(self) -> typing.Optional[builtins.str]:
        '''Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal.

        The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority DataAkamaiImagingPolicyImage#gravity_priority}
        '''
        result = self._values.get("gravity_priority")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_priority_var(self) -> typing.Optional[builtins.str]:
        '''Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal.

        The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority_var DataAkamaiImagingPolicyImage#gravity_priority_var}
        '''
        result = self._values.get("gravity_priority_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Specifies where to place the ``image`` relative to the source image.

        The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def preserve_minor_dimension(self) -> typing.Optional[builtins.str]:
        '''Whether to preserve the source image's minor dimension, ``false`` by default.

        The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension DataAkamaiImagingPolicyImage#preserve_minor_dimension}
        '''
        result = self._values.get("preserve_minor_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def preserve_minor_dimension_var(self) -> typing.Optional[builtins.str]:
        '''Whether to preserve the source image's minor dimension, ``false`` by default.

        The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension_var DataAkamaiImagingPolicyImage#preserve_minor_dimension_var}
        '''
        result = self._values.get("preserve_minor_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitAppend(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitAppendImage",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitAppendImage:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitAppendImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitAppendImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitAppendImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6aaa0171f5b99d09083d50ebb52e369424564c256ade16113c32a8beb5f8df68)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitAppendImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitAppendImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitAppendImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ea20eca181b2c2552160a6f5d249b57290982df1f9eff5a751de268eab3c633)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitAppendList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitAppendList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ca1334fe566d6267bfc961c33f1681d20b0d2be8b57ae558239666210f1a3113)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitAppendOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f8e0ac34e2cacc6aceeb1ebd207d732c3b796200916eece1ea9f041b9119796d)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitAppendOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__de89aecebb697fb532f24675e159daefdaf9c01dd1f210db4342957633c67716)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0d9713657a7b7cd8f6c60917c9cdeaa104825a8b7eecea96021d8105ac659630)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8006d457be04d21be0e076a689e725a1b4f53ba95df62fc432e0387def2e3a97)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitAppend]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitAppend]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitAppend]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__99de87b79d0bda1741b529544e75bafb965d4b9bec7745ce8d43ffccf07f135e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitAppendOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitAppendOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__132634380302f43ec3ddf64b43dc81b09baee9db7b5d75b6d894deda402575be)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitAppendImage()

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityPriority")
    def reset_gravity_priority(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityPriority", []))

    @jsii.member(jsii_name="resetGravityPriorityVar")
    def reset_gravity_priority_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityPriorityVar", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPreserveMinorDimension")
    def reset_preserve_minor_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPreserveMinorDimension", []))

    @jsii.member(jsii_name="resetPreserveMinorDimensionVar")
    def reset_preserve_minor_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPreserveMinorDimensionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitAppendImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitAppendImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityInput")
    def gravity_priority_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityPriorityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityVarInput")
    def gravity_priority_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityPriorityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitAppendImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitAppendImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionInput")
    def preserve_minor_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "preserveMinorDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionVarInput")
    def preserve_minor_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "preserveMinorDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ff9ae9468d8547ba9bdce4c623d24616cca62b5c673382156b72e19b26be58b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityPriority")
    def gravity_priority(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityPriority"))

    @gravity_priority.setter
    def gravity_priority(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__52c6db5572129dad41cbaeca1cf2f7160376c348dc10f9639f46a058b40d548a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityPriority", value)

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityVar")
    def gravity_priority_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityPriorityVar"))

    @gravity_priority_var.setter
    def gravity_priority_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0f8f4c92259d6d4c945209037e3e83f814af1d65e5ab8ba9020307e3c303c12a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityPriorityVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__160a57ec69cbeb6f172a88a45a148c9ac69196f1449ea50f922fc82ab7743e7c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimension")
    def preserve_minor_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "preserveMinorDimension"))

    @preserve_minor_dimension.setter
    def preserve_minor_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d1da45c833c92c74622bbc22759eecee40db2fe95530e4efd276502346a40b69)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "preserveMinorDimension", value)

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionVar")
    def preserve_minor_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "preserveMinorDimensionVar"))

    @preserve_minor_dimension_var.setter
    def preserve_minor_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d3587d562c4730b6203f044c07133ce7692b74594ca43918941dbf3bcae46f9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "preserveMinorDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitAppend]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitAppend]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitAppend]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5a0e9138a5f756d4eb223b38c944fd7cce76439ab5b1c94a384f8dbd4508a1a3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitAspectCrop",
    jsii_struct_bases=[],
    name_mapping={
        "allow_expansion": "allowExpansion",
        "allow_expansion_var": "allowExpansionVar",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitAspectCrop:
    def __init__(
        self,
        *,
        allow_expansion: typing.Optional[builtins.str] = None,
        allow_expansion_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_expansion: Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image. Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        :param allow_expansion_var: Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image. Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        :param height: The height term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The width term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        :param x_position: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__73ef738724da83a126d97668bda2d3038600d954db7489218502e02cc47b54ed)
            check_type(argname="argument allow_expansion", value=allow_expansion, expected_type=type_hints["allow_expansion"])
            check_type(argname="argument allow_expansion_var", value=allow_expansion_var, expected_type=type_hints["allow_expansion_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if allow_expansion is not None:
            self._values["allow_expansion"] = allow_expansion
        if allow_expansion_var is not None:
            self._values["allow_expansion_var"] = allow_expansion_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def allow_expansion(self) -> typing.Optional[builtins.str]:
        '''Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image.

        Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        '''
        result = self._values.get("allow_expansion")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def allow_expansion_var(self) -> typing.Optional[builtins.str]:
        '''Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image.

        Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        '''
        result = self._values.get("allow_expansion_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitAspectCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitAspectCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitAspectCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f97e2642dbb580fa2914e94c9d5c3c658913ec84e265baaad04b7d012b07e9e2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitAspectCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__74db363c3e05f87191411769b056c9ac04eb69a66b282872f51dbf7b09625fcb)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitAspectCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e9c2b082d4400364616b77baeaba01be58b043caf32172f07e7b54b251a17529)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f0dc020924c1686c5d69e6f87372cb15c87603445e94ed26170eb5583ef1338)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__67190a4744fce13e7124a9a13e031687778e463405c339e9e22cf069ba663f6f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitAspectCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitAspectCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitAspectCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e5976248045ce013bf968a09307139a4dade339f7ac51c2df274f81b9bff2c70)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitAspectCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitAspectCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fcb2f87956482969d75d035756e3f018e5fab4a0f11d5063782041c1786ed622)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAllowExpansion")
    def reset_allow_expansion(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansion", []))

    @jsii.member(jsii_name="resetAllowExpansionVar")
    def reset_allow_expansion_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansionVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionInput")
    def allow_expansion_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVarInput")
    def allow_expansion_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansion")
    def allow_expansion(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansion"))

    @allow_expansion.setter
    def allow_expansion(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__29759e7745d6efae9160779e01ad8fe3bea340045386df85ba0e780c59d388ef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansion", value)

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVar")
    def allow_expansion_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansionVar"))

    @allow_expansion_var.setter
    def allow_expansion_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5efe00d6cc6d3c546a3b28615bcb36b5508882fbca8e3e03e4885ef219c8fd80)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansionVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__228748197c8e6b13d5cabc1c3f4cf525ecb8e729c270d5ab9ebf363f2652e238)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0a3af9400dea6c90841216e38db41ff0cbeda1b2bd84f0057fc7af10a0a75745)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e1ac74e579e25ac3bfec8f355613544f10288151cf27e1b7ebe56f13af52442)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f7adc99de65c2a3c1961991af022ecf672e0afb4d82ea3d3334e6596fb98d6d1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cda023b558119421365f031b00fa3e3cb06be376870c0a60c07806a6386dd3f9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5bef5f7a3912a99698f6a23d917830d4dcc1e39163989f7d32fe5d8172c48e4f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a213480a8a372d522e48c64e5b904aef59865136827cbc6bd3c14557ce7943e8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0bb767d32b10dbb36420a103a8e040da754c21a6bc659c0830cd00c15f9d2f35)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitAspectCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitAspectCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitAspectCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__49060308cd36c58305f8118adef9d2c4c355a7872c7ea4231836d125c92f28bf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitBackgroundColor",
    jsii_struct_bases=[],
    name_mapping={"color": "color", "color_var": "colorVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitBackgroundColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7b37131b4ddb1ac9020ebe11ec0cbcd84de73e51dbb2a8cd28941827ec023f05)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitBackgroundColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitBackgroundColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitBackgroundColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__85ffb355ab8271395a6d145fc6dd3e3dd84019dd08322b2b283cc13cd2c9447b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitBackgroundColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__73ac6b8becd9a6c2ead7a1442195be33b149a44884a0b8638fa14a530da65c29)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitBackgroundColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__de1db6d5d276ccf588c0e52a4bd84fb66d4358882dd29a2f4164a527e5031568)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__afcf1a856c65deadbf7e180859dfe0e860a7f9da45e74dd73d31ff893867946e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d92844b8247dfdcd0293696b3a8132cd7b1cae158aadc742f2e8fd1af4a15d5c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitBackgroundColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitBackgroundColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c542e1f895d9ba992c32c3203b48f06f4451eaabe1c12b3aac97a1d1ade931ba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitBackgroundColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitBackgroundColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c758386a16939969e058ac5b9682d03af49fe63b8785b58c56d1ff61fe2f6f6d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e5b163af455d12fa24125eec8a876d00ef15be1364f918d795c44636c7bd1aa0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6b9ed7955b699d30d4b0c6d259db65c23cd6da481f4500ae9aec25fb1a19a1e8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitBackgroundColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitBackgroundColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitBackgroundColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__50cc8d14a42fceaf926c47c118b68f8ca4e9afdc1dd34b2e72c666c7c94643aa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitBlur",
    jsii_struct_bases=[],
    name_mapping={"sigma": "sigma", "sigma_var": "sigmaVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitBlur:
    def __init__(
        self,
        *,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param sigma: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7a98d1fbb21377d7ab8fb5345df32cd67e1210d92b60d3d97287146cca30d631)
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitBlur(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitBlurList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitBlurList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__06b4d731a00176dc9c5edccaa8698b3d4f5bf77a4bf2d41cda992781abf81869)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitBlurOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cca2433a3afccd6987d815f0b5d9a59fc498c737c6ee0b705388a8fff1c0a1a8)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitBlurOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__afcfe70a0bb52317dbfd3136525dc9c041cedd90112125b7f5a1264d5d8eb706)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f4842cb7d8cb6de5941c33e9a2edeb8c9cb6cc1835001cec2ab9aa28717e7dcc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__852c3b20578d85b63ad43066dc8b8f4c32a00844fdaea9f65ffa42280fe282ad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitBlur]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitBlur]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__04c4bced5ecfb8003a19df2334f2196b97dc3dd40029a2fe63e2b12d6f95055d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitBlurOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitBlurOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7484984bb5a4cd88424e86bb718b52bcd67b8b092a4daffdbd80ed911b8a982c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3516a37d721886700271ced2c3f39d9d7d3723dd0b3ae0b1750ecbd76e3505f5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dab751020cd9484a438d840ca9caf673da8c749a0bc3674bd84860e29a83cd04)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitBlur]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitBlur]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitBlur]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__012a9b4a25f84cd6a9d67f7af2f8186085f7a40db57bd371bd90acb148a4aa98)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitChromaKey",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_feather": "hueFeather",
        "hue_feather_var": "hueFeatherVar",
        "hue_tolerance": "hueTolerance",
        "hue_tolerance_var": "hueToleranceVar",
        "hue_var": "hueVar",
        "lightness_feather": "lightnessFeather",
        "lightness_feather_var": "lightnessFeatherVar",
        "lightness_tolerance": "lightnessTolerance",
        "lightness_tolerance_var": "lightnessToleranceVar",
        "saturation_feather": "saturationFeather",
        "saturation_feather_var": "saturationFeatherVar",
        "saturation_tolerance": "saturationTolerance",
        "saturation_tolerance_var": "saturationToleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitChromaKey:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_feather: typing.Optional[builtins.str] = None,
        hue_feather_var: typing.Optional[builtins.str] = None,
        hue_tolerance: typing.Optional[builtins.str] = None,
        hue_tolerance_var: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness_feather: typing.Optional[builtins.str] = None,
        lightness_feather_var: typing.Optional[builtins.str] = None,
        lightness_tolerance: typing.Optional[builtins.str] = None,
        lightness_tolerance_var: typing.Optional[builtins.str] = None,
        saturation_feather: typing.Optional[builtins.str] = None,
        saturation_feather_var: typing.Optional[builtins.str] = None,
        saturation_tolerance: typing.Optional[builtins.str] = None,
        saturation_tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_feather: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        :param hue_feather_var: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        :param hue_tolerance: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        :param hue_tolerance_var: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        :param hue_var: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness_feather: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        :param lightness_feather_var: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        :param lightness_tolerance: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        :param lightness_tolerance_var: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        :param saturation_feather: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        :param saturation_feather_var: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        :param saturation_tolerance: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        :param saturation_tolerance_var: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0f59b98d3eee5dce7f7fa3a7dd6cddfa155209a8c07064dcb9044dd6a51c9941)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_feather", value=hue_feather, expected_type=type_hints["hue_feather"])
            check_type(argname="argument hue_feather_var", value=hue_feather_var, expected_type=type_hints["hue_feather_var"])
            check_type(argname="argument hue_tolerance", value=hue_tolerance, expected_type=type_hints["hue_tolerance"])
            check_type(argname="argument hue_tolerance_var", value=hue_tolerance_var, expected_type=type_hints["hue_tolerance_var"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness_feather", value=lightness_feather, expected_type=type_hints["lightness_feather"])
            check_type(argname="argument lightness_feather_var", value=lightness_feather_var, expected_type=type_hints["lightness_feather_var"])
            check_type(argname="argument lightness_tolerance", value=lightness_tolerance, expected_type=type_hints["lightness_tolerance"])
            check_type(argname="argument lightness_tolerance_var", value=lightness_tolerance_var, expected_type=type_hints["lightness_tolerance_var"])
            check_type(argname="argument saturation_feather", value=saturation_feather, expected_type=type_hints["saturation_feather"])
            check_type(argname="argument saturation_feather_var", value=saturation_feather_var, expected_type=type_hints["saturation_feather_var"])
            check_type(argname="argument saturation_tolerance", value=saturation_tolerance, expected_type=type_hints["saturation_tolerance"])
            check_type(argname="argument saturation_tolerance_var", value=saturation_tolerance_var, expected_type=type_hints["saturation_tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_feather is not None:
            self._values["hue_feather"] = hue_feather
        if hue_feather_var is not None:
            self._values["hue_feather_var"] = hue_feather_var
        if hue_tolerance is not None:
            self._values["hue_tolerance"] = hue_tolerance
        if hue_tolerance_var is not None:
            self._values["hue_tolerance_var"] = hue_tolerance_var
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness_feather is not None:
            self._values["lightness_feather"] = lightness_feather
        if lightness_feather_var is not None:
            self._values["lightness_feather_var"] = lightness_feather_var
        if lightness_tolerance is not None:
            self._values["lightness_tolerance"] = lightness_tolerance
        if lightness_tolerance_var is not None:
            self._values["lightness_tolerance_var"] = lightness_tolerance_var
        if saturation_feather is not None:
            self._values["saturation_feather"] = saturation_feather
        if saturation_feather_var is not None:
            self._values["saturation_feather_var"] = saturation_feather_var
        if saturation_tolerance is not None:
            self._values["saturation_tolerance"] = saturation_tolerance
        if saturation_tolerance_var is not None:
            self._values["saturation_tolerance_var"] = saturation_tolerance_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        '''
        result = self._values.get("hue_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        '''
        result = self._values.get("hue_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        '''
        result = self._values.get("hue_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        '''
        result = self._values.get("hue_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        '''
        result = self._values.get("lightness_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        '''
        result = self._values.get("lightness_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        '''
        result = self._values.get("lightness_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        '''
        result = self._values.get("lightness_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        '''
        result = self._values.get("saturation_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        '''
        result = self._values.get("saturation_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        '''
        result = self._values.get("saturation_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        result = self._values.get("saturation_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitChromaKey(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitChromaKeyList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitChromaKeyList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9e5c29ccc028c2883c88ac852729f2b8cb2f7b4c34de753faa54734f5543e46e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitChromaKeyOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4b56bd02b96f3eee75c544f7cf2f7b1322b946c084e45c032e07e93558654bef)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitChromaKeyOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e797e06d5d31336106bf693143a772df40d5fd2cf5ae7c7c10c4e03dec31ad6e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0b623566b51b51b38419c4cabe5a2e4dcbc073c90430e8f70456c7d400f55d49)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b35d384b8caee24b65a793a46b121cfe7059e97398b7d68941fb515a2e7a4ffb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitChromaKey]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitChromaKey]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__52491e5f2a53d37182c1aa9113c8a1eb141368994d097be60f40fdf901b27ff3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitChromaKeyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitChromaKeyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b393ff6d3b7d076b377864fb9d97079faf455bcd181c95df5b629bcf21f95765)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueFeather")
    def reset_hue_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeather", []))

    @jsii.member(jsii_name="resetHueFeatherVar")
    def reset_hue_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeatherVar", []))

    @jsii.member(jsii_name="resetHueTolerance")
    def reset_hue_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueTolerance", []))

    @jsii.member(jsii_name="resetHueToleranceVar")
    def reset_hue_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueToleranceVar", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightnessFeather")
    def reset_lightness_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeather", []))

    @jsii.member(jsii_name="resetLightnessFeatherVar")
    def reset_lightness_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeatherVar", []))

    @jsii.member(jsii_name="resetLightnessTolerance")
    def reset_lightness_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessTolerance", []))

    @jsii.member(jsii_name="resetLightnessToleranceVar")
    def reset_lightness_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessToleranceVar", []))

    @jsii.member(jsii_name="resetSaturationFeather")
    def reset_saturation_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeather", []))

    @jsii.member(jsii_name="resetSaturationFeatherVar")
    def reset_saturation_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeatherVar", []))

    @jsii.member(jsii_name="resetSaturationTolerance")
    def reset_saturation_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationTolerance", []))

    @jsii.member(jsii_name="resetSaturationToleranceVar")
    def reset_saturation_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherInput")
    def hue_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVarInput")
    def hue_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceInput")
    def hue_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVarInput")
    def hue_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherInput")
    def lightness_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVarInput")
    def lightness_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceInput")
    def lightness_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVarInput")
    def lightness_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherInput")
    def saturation_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVarInput")
    def saturation_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceInput")
    def saturation_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVarInput")
    def saturation_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d0b60998bc674c3278b2ed51528553d10baddd9917ab1d39b02c89f4cbbaee30)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeather")
    def hue_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeather"))

    @hue_feather.setter
    def hue_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2c2f35a3e294f0e373db566299379087b5c02667e0b0b2014dba160f42fa7265)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeather", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVar")
    def hue_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeatherVar"))

    @hue_feather_var.setter
    def hue_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__57849d5bd21a11958a8dba94dcb6f85e56753747e0fad1d99b9198fd0bb2fb16)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueTolerance")
    def hue_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueTolerance"))

    @hue_tolerance.setter
    def hue_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ec3483a8ec652ce2d0ac0a1e4d92b83c920c2fd022a96c70e7218af508ad53c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVar")
    def hue_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueToleranceVar"))

    @hue_tolerance_var.setter
    def hue_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__432c783c31ab56096dc3682773ea7332b2d2aaad235c9aa7a84b33ea00a1791c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c833b030c5cf3a6c9689a4b2c2f275879343c5029e53ff194d028313354d5080)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeather")
    def lightness_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeather"))

    @lightness_feather.setter
    def lightness_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c4fc41b837eca99617385e6c3191f015ce2b135b57bacba5d3c7584834ff849e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeather", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVar")
    def lightness_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeatherVar"))

    @lightness_feather_var.setter
    def lightness_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8247fdc6462d0f36142912de84b734df6b840d00e8915eb566850b2936c7e25e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessTolerance")
    def lightness_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessTolerance"))

    @lightness_tolerance.setter
    def lightness_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__74ae964bbd7365605eb9ad035c5f0afa8523540edec57bce2c2d4c274cabfde8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVar")
    def lightness_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessToleranceVar"))

    @lightness_tolerance_var.setter
    def lightness_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b7e1be4247d0fc1e55749cdcfe14d9b96ac544f275e50b845af5cb8aa1dd3721)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeather")
    def saturation_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeather"))

    @saturation_feather.setter
    def saturation_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__26976213bf77f4b18a2fbbd6554e0d70e57234f657bdda533f3a3a7fbd9d0430)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeather", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVar")
    def saturation_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeatherVar"))

    @saturation_feather_var.setter
    def saturation_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b44e797de7d26367b49c5169379f3d5241893b5b3f1e893e390a1b89a0000f19)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationTolerance")
    def saturation_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationTolerance"))

    @saturation_tolerance.setter
    def saturation_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__75f9fd4f85018267359244e1d6c9f9223174df13854aa2835ab7f287e2a23e07)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVar")
    def saturation_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationToleranceVar"))

    @saturation_tolerance_var.setter
    def saturation_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__584b2e2a4610a56fa3a9c33ddc45e5b6d8a370918b82875e1c603071dd5183ff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitChromaKey]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitChromaKey]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitChromaKey]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4e08bb85f04e343179ad56031d00fa7c3e31fd4f27ab9e55138837762145210f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitComposite",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "placement": "placement",
        "placement_var": "placementVar",
        "scale": "scale",
        "scale_dimension": "scaleDimension",
        "scale_dimension_var": "scaleDimensionVar",
        "scale_var": "scaleVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitComposite:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitCompositeImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        placement: typing.Optional[builtins.str] = None,
        placement_var: typing.Optional[builtins.str] = None,
        scale: typing.Optional[builtins.str] = None,
        scale_dimension: typing.Optional[builtins.str] = None,
        scale_dimension_var: typing.Optional[builtins.str] = None,
        scale_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param placement: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        :param placement_var: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        :param scale: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param scale_dimension: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        :param scale_dimension_var: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        :param scale_var: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        :param x_position: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitCompositeImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa39f223742be4df8f6abf1cef4be82e4238cd8be6ff5f4512582d0b6c5c28f3)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument placement", value=placement, expected_type=type_hints["placement"])
            check_type(argname="argument placement_var", value=placement_var, expected_type=type_hints["placement_var"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument scale_dimension", value=scale_dimension, expected_type=type_hints["scale_dimension"])
            check_type(argname="argument scale_dimension_var", value=scale_dimension_var, expected_type=type_hints["scale_dimension_var"])
            check_type(argname="argument scale_var", value=scale_var, expected_type=type_hints["scale_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if placement is not None:
            self._values["placement"] = placement
        if placement_var is not None:
            self._values["placement_var"] = placement_var
        if scale is not None:
            self._values["scale"] = scale
        if scale_dimension is not None:
            self._values["scale_dimension"] = scale_dimension
        if scale_dimension_var is not None:
            self._values["scale_dimension_var"] = scale_dimension_var
        if scale_var is not None:
            self._values["scale_var"] = scale_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitCompositeImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitCompositeImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        '''
        result = self._values.get("placement")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement_var(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        '''
        result = self._values.get("placement_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        '''
        result = self._values.get("scale_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        '''
        result = self._values.get("scale_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        '''
        result = self._values.get("scale_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitComposite(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitCompositeImage",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitCompositeImage:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitCompositeImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitCompositeImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitCompositeImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6c61a04b2180d16262341dc9a04da5f3d5f6644efcd79c3007c8afc494d774c0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitCompositeImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitCompositeImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__670bfc821c538f2b270be834ac6edb678ae10c5782aa042059d1f4503ab5e8ae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitCompositeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitCompositeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0c0d975dda36c13cec164c5e87fdead2fe4a40ce16a65d7255436be232f195fc)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitCompositeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8ea07bd3a395d0d78a1e6c108da22a88b0639912908deb91f9dd139d8b9182a7)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitCompositeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e0653bf22182b690afe858123eb2ada5a34a67ff55336fbfbd8de36f2a714dc3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b65127ee2db1c6a622d66e3fec86e3b7384d68ff2dbc1e8165d13ba5efc14293)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__84463990c6f76d1f1d768f9aa6d05f4ca7181091d6e9058006665490997d8bd8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitComposite]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitComposite]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fbe71579337142f28d4d2f5a8bf6cc5632aa46dbdb8226ddf3d317a66a3f2bfc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitCompositeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitCompositeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af0c8ccad9b68b75b21535977b0b8efd6cf16086f4e5fda4d949f37ac20bdb54)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitCompositeImage()

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPlacement")
    def reset_placement(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacement", []))

    @jsii.member(jsii_name="resetPlacementVar")
    def reset_placement_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacementVar", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetScaleDimension")
    def reset_scale_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimension", []))

    @jsii.member(jsii_name="resetScaleDimensionVar")
    def reset_scale_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimensionVar", []))

    @jsii.member(jsii_name="resetScaleVar")
    def reset_scale_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitCompositeImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitCompositeImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitCompositeImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="placementInput")
    def placement_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementInput"))

    @builtins.property
    @jsii.member(jsii_name="placementVarInput")
    def placement_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionInput")
    def scale_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVarInput")
    def scale_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleVarInput")
    def scale_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__60c2874709046324824b27de03d2427f1320d97cb414f47f879f37e39cdbdd43)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6d36247f9cbd0864651a8a51445b61ad74e4e870aefb1cbe6bf7192e217fbe9f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="placement")
    def placement(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placement"))

    @placement.setter
    def placement(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ca270467baf2c9a5ee45904bbd7a3ccc0c79abd047d2f8c3806c0b5b5f1a967)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placement", value)

    @builtins.property
    @jsii.member(jsii_name="placementVar")
    def placement_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placementVar"))

    @placement_var.setter
    def placement_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b22b14fa5ba18e555b6e049ea7cb7d9753aa037ae1f58343d7d28fcdd73e0411)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placementVar", value)

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scale"))

    @scale.setter
    def scale(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6dfebe7a56a41428dff183744524082b7a48ee3ad63e89eb551be4536fa54ba1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scale", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimension")
    def scale_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimension"))

    @scale_dimension.setter
    def scale_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__84c805ac28f78e8bb9ea0225d8e575c2fcb2e2b92576d54f85c1aa9b3b8f2100)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimension", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVar")
    def scale_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimensionVar"))

    @scale_dimension_var.setter
    def scale_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd554eaf65ff94f38e9871755f88caf9a84e0faf4b2e4d1ba2e532886cefc541)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="scaleVar")
    def scale_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleVar"))

    @scale_var.setter
    def scale_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dd4e352d8cbabee6452efac5b985fe495ec7116b81fe5dac71ffc3996b3d37b7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__95362065cc7464bec5d6958327c46eeb134dcd0a79e53e68cfaa2692bb8f17c1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__96681d5d7d0b01513f8d55c15049114edadbca55c750dc2b56120d78ab9eb2f8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__421d5108926d408c6170565e863b5e25ac786a854bb1f35f96d06a5024d94b42)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d434ad484ca31c58f9954ae152da4011c275caa36c2e4bddede89576699d51a4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitComposite]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitComposite]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitComposite]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b93a8de5b94e724c7812e3b788d10fff293b74b5a9a32aaddac57af520959660)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitCompound",
    jsii_struct_bases=[],
    name_mapping={"transformations": "transformations"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitCompound:
    def __init__(
        self,
        *,
        transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param transformations: transformations block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__547b837f88ae1f70cc82f3959edce2cb1d5c068e714ad98140210e67119ecb1d)
            check_type(argname="argument transformations", value=transformations, expected_type=type_hints["transformations"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if transformations is not None:
            self._values["transformations"] = transformations

    @builtins.property
    def transformations(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitCompoundTransformations"]]]:
        '''transformations block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        result = self._values.get("transformations")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitCompoundTransformations"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitCompound(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitCompoundList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitCompoundList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fc364c988ba8b490e155c7e8ed55bfb90c9636aa2e4a30920d1929fbe7aae4ce)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitCompoundOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__83808e5a579d89cf77dcc7e691d81216781835bd66424ea77060b82a5864cbab)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitCompoundOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__30e2e9dd38cbff0cc2292136065ef457fa9d69e26e441000439ce1c9a5a4a17c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bd2212571ea5112a603f77686dcf6ca84f8779ddb8a7bb3d6fe52e0e1869c57e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aec28e940a3196966bfcd834ddd18144855679a59d884fcd68dff92250c62014)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitCompound]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitCompound]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d88307322581d5aea754b59fa96a55b38750e640cfcbb17be6a7cbfb43b5891f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitCompoundOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitCompoundOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__90393130778d00b563a8076f09d30c37d0dfa6a70c7d8bbbf57f846d75bff15a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformations")
    def put_transformations(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__21a2811310414e02ae6584f2824c4e95cd525dd8797a3a1e8c7e39761188bdbc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTransformations", [value]))

    @jsii.member(jsii_name="resetTransformations")
    def reset_transformations(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformations", []))

    @builtins.property
    @jsii.member(jsii_name="transformations")
    def transformations(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitCompoundTransformationsList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitCompoundTransformationsList", jsii.get(self, "transformations"))

    @builtins.property
    @jsii.member(jsii_name="transformationsInput")
    def transformations_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitCompoundTransformations"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitCompoundTransformations"]]], jsii.get(self, "transformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitCompound]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitCompound]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitCompound]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dce6c307056df409c8633d008d64dcd1f296f782ea1264ab1884f10f4128fac2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitCompoundTransformations",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitCompoundTransformations:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitCompoundTransformations(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitCompoundTransformationsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitCompoundTransformationsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f5f3f62fbaaff1b761181bdee77321abc30838fe0f9b0912ea4f5d645c7e0daa)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitCompoundTransformationsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a48fa43d201a422c542bda92742a2f19b5cae1fd4db0792997386c7bcba5113)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitCompoundTransformationsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ae02ef54296c99baeaef8cafc4cdaa01675d3fd08f4d43b933c673458be6ab6b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__51297319239efe515d3677dae184ca111ff2fee8530546e941d998774e0cc0e9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__401be7a14cd54934b1857564bc9a15fd1f6031dcad62a59e0c117cabac1415ac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitCompoundTransformations]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitCompoundTransformations]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitCompoundTransformations]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b4711ae70758e2b9ae7f28cf31465a94800c657630dcc0f34ba7588dcdd384bd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitCompoundTransformationsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitCompoundTransformationsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7202340935311232cd4095d6cba99d852778beb235a529ed6c2de15711f14246)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitCompoundTransformations]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitCompoundTransformations]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitCompoundTransformations]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__54fb86980451bf307bc147cdb55c214d58beaa2a614b364e6cf7071e3f12c290)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitContrast",
    jsii_struct_bases=[],
    name_mapping={
        "brightness": "brightness",
        "brightness_var": "brightnessVar",
        "contrast": "contrast",
        "contrast_var": "contrastVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitContrast:
    def __init__(
        self,
        *,
        brightness: typing.Optional[builtins.str] = None,
        brightness_var: typing.Optional[builtins.str] = None,
        contrast: typing.Optional[builtins.str] = None,
        contrast_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param brightness: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        :param brightness_var: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        :param contrast: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param contrast_var: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2e5758b4d12d5b82ad4c04774e087186ee2fd5e7919502ca1ef83ca2141c10e1)
            check_type(argname="argument brightness", value=brightness, expected_type=type_hints["brightness"])
            check_type(argname="argument brightness_var", value=brightness_var, expected_type=type_hints["brightness_var"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument contrast_var", value=contrast_var, expected_type=type_hints["contrast_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if brightness is not None:
            self._values["brightness"] = brightness
        if brightness_var is not None:
            self._values["brightness_var"] = brightness_var
        if contrast is not None:
            self._values["contrast"] = contrast
        if contrast_var is not None:
            self._values["contrast_var"] = contrast_var

    @builtins.property
    def brightness(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        '''
        result = self._values.get("brightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def brightness_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        '''
        result = self._values.get("brightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        result = self._values.get("contrast_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitContrast(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitContrastList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitContrastList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d3ce73352402b2725f5c35a14ca569765f5537986bc37b93ad352e1b71a62aed)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitContrastOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__221fd42b5532fe4483578c31013880232f28b64839aa2c123cb528abea85cc7d)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitContrastOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b6842277b54b3fc2d4553c0c9ed6094c91c4825d3b07662a213ef4fd0ed49bbb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__906139c57e2590bb41d0a45405141a66e430e2644b1a3f116fc0abf892f84d4c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be75908691618c4c06a9eeca7db38cba5d74c066d8f52f70d7edd912716c0955)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitContrast]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitContrast]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d4222114067fb0f5b7a3482a2dc969ea99b8dc9023f38b736879abf9f66f82d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitContrastOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitContrastOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2538b1845a10237d5db7124280b86ca51c0c8839166af9a810d0398c13727a33)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetBrightness")
    def reset_brightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightness", []))

    @jsii.member(jsii_name="resetBrightnessVar")
    def reset_brightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightnessVar", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetContrastVar")
    def reset_contrast_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrastVar", []))

    @builtins.property
    @jsii.member(jsii_name="brightnessInput")
    def brightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="brightnessVarInput")
    def brightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastVarInput")
    def contrast_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="brightness")
    def brightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightness"))

    @brightness.setter
    def brightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4f3b6c2abffbb715462aeb20a9b70568912f950c5b7c48c3941a7a52886861ee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightness", value)

    @builtins.property
    @jsii.member(jsii_name="brightnessVar")
    def brightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightnessVar"))

    @brightness_var.setter
    def brightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e4e048fb2ca206cf691f4aefed348657b6a4285471b746a40fcf236cc66eb125)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrast"))

    @contrast.setter
    def contrast(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__72ddeca35731172ba8d98a8d1a7921a471b7e491d7529421103517884741363c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrast", value)

    @builtins.property
    @jsii.member(jsii_name="contrastVar")
    def contrast_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrastVar"))

    @contrast_var.setter
    def contrast_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__84e2a6ebbb66c029a869c7381099ae9af763138d91f3f21548fcfec687c60867)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrastVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitContrast]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitContrast]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitContrast]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8e8191eefdf4abc4d88ed39b0d62a612368635dcd8b4c5dd2fd2caeffb30f4d9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitCrop",
    jsii_struct_bases=[],
    name_mapping={
        "allow_expansion": "allowExpansion",
        "allow_expansion_var": "allowExpansionVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitCrop:
    def __init__(
        self,
        *,
        allow_expansion: typing.Optional[builtins.str] = None,
        allow_expansion_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_expansion: If cropping an area outside of the existing canvas, expands the image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        :param allow_expansion_var: If cropping an area outside of the existing canvas, expands the image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        :param gravity: Frame of reference for X and Y Positions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Frame of reference for X and Y Positions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The number of pixels to crop along the y-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The number of pixels to crop along the y-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The number of pixels to crop along the x-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The number of pixels to crop along the x-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        :param x_position: The x-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3d03a6ce6e4875c42c9736f6595e73aa10519915dd13181e97957124749cc54c)
            check_type(argname="argument allow_expansion", value=allow_expansion, expected_type=type_hints["allow_expansion"])
            check_type(argname="argument allow_expansion_var", value=allow_expansion_var, expected_type=type_hints["allow_expansion_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if allow_expansion is not None:
            self._values["allow_expansion"] = allow_expansion
        if allow_expansion_var is not None:
            self._values["allow_expansion_var"] = allow_expansion_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def allow_expansion(self) -> typing.Optional[builtins.str]:
        '''If cropping an area outside of the existing canvas, expands the image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        '''
        result = self._values.get("allow_expansion")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def allow_expansion_var(self) -> typing.Optional[builtins.str]:
        '''If cropping an area outside of the existing canvas, expands the image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        '''
        result = self._values.get("allow_expansion_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Frame of reference for X and Y Positions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Frame of reference for X and Y Positions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the y-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the y-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the x-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the x-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__927e3cc34ba845b3c8873f81f75997d24c2c650444c92db175b05896990cf453)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8f83f3a717a2eff3b4d2811d07ef62a6c8793333b736fb4d0241815c4075deec)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c49052d23c6f79f9775050ac18ac416eb77dfdcd9367fb803cef8114f36288d1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e016be0bb8c66f845f4a9e680a19aa0cd470b9aa80ce1ae6a5a8c9ca751e4eb9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5da86d39fca5cbb489a0b2ad27cf672a7a9574883e8c33fab16b114eef85385c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd502fd2a051d34ba821c91f319ea37d7a1585d3046f5e674ee66f15fe96a54d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3f07f9b656279db28f544de73fecadc634f15e1e8d1c2b84661d67a2c361ae54)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAllowExpansion")
    def reset_allow_expansion(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansion", []))

    @jsii.member(jsii_name="resetAllowExpansionVar")
    def reset_allow_expansion_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansionVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionInput")
    def allow_expansion_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVarInput")
    def allow_expansion_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansion")
    def allow_expansion(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansion"))

    @allow_expansion.setter
    def allow_expansion(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f7b87a46db95abbc6a2065a0476e9fbb42762743f4fb7f3fcae98042a8c416b5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansion", value)

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVar")
    def allow_expansion_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansionVar"))

    @allow_expansion_var.setter
    def allow_expansion_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__728188f84ddca7a5d4dbf15c63df44312a88e0ce0bef3383b147d8a9152f8800)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansionVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__895a4ab1379cf340d22a09ed07e954807e1c4219c0ded8b014ca90a3c05a7e2a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__915b05ee059c761133e733ca06b438394588100cc25e22dd5114ffdbc4565e80)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b1acce7d3c92ebfe5015e08a9ddb07e76c9c70749f4bbe270cc6ef9f6981a543)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__29a4af97d794aace579f90c84fcb69f393aca719d03ffc0a1fcf00fd9eb3b278)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a91573afb3024dee6442162e34e3b7ebd6f73884692b4f56fe781a979fef048)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__08cb053322fdeaa458e22da120f4510f42dd5245c62dda007d54fa59595b5d3b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6ec236abcf7f1433f3cd7ba76b895d0b3573aa2413756c95187fd848869b7d4d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__728e2c23163c5ee6536982dfc252dc0d1b28a8bc0b5c263ee56f1fc2faa0e98a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__92d3906dadddfd3d1d75260715f224122143b0362eaa0bf6bee6ceef185d1c64)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a3ebde096a31df4e68fb8742d2c03c2b21cf27f0bd581fcb2a56e11f4fbf71ce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5212f79e3775f13dadb4e115af89178f6642d078de1e35d2be19e3b23d4b8001)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitFaceCrop",
    jsii_struct_bases=[],
    name_mapping={
        "algorithm": "algorithm",
        "algorithm_var": "algorithmVar",
        "confidence": "confidence",
        "confidence_var": "confidenceVar",
        "fail_gravity": "failGravity",
        "fail_gravity_var": "failGravityVar",
        "focus": "focus",
        "focus_var": "focusVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "padding": "padding",
        "padding_var": "paddingVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitFaceCrop:
    def __init__(
        self,
        *,
        algorithm: typing.Optional[builtins.str] = None,
        algorithm_var: typing.Optional[builtins.str] = None,
        confidence: typing.Optional[builtins.str] = None,
        confidence_var: typing.Optional[builtins.str] = None,
        fail_gravity: typing.Optional[builtins.str] = None,
        fail_gravity_var: typing.Optional[builtins.str] = None,
        focus: typing.Optional[builtins.str] = None,
        focus_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param algorithm: Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm DataAkamaiImagingPolicyImage#algorithm}
        :param algorithm_var: Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm_var DataAkamaiImagingPolicyImage#algorithm_var}
        :param confidence: With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image. Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence DataAkamaiImagingPolicyImage#confidence}
        :param confidence_var: With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image. Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence_var DataAkamaiImagingPolicyImage#confidence_var}
        :param fail_gravity: Controls placement of the crop if Image and Video Manager does not detect any faces in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        :param fail_gravity_var: Controls placement of the crop if Image and Video Manager does not detect any faces in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        :param focus: Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus DataAkamaiImagingPolicyImage#focus}
        :param focus_var: Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus_var DataAkamaiImagingPolicyImage#focus_var}
        :param gravity: Controls placement of the crop. Directions are relative to the face(s) plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Controls placement of the crop. Directions are relative to the face(s) plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param padding: The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        :param style: Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__acdfad7eedbdaff2d6ec57c888d033c9e7d1f0fe2268912dbbfbb44b27543c77)
            check_type(argname="argument algorithm", value=algorithm, expected_type=type_hints["algorithm"])
            check_type(argname="argument algorithm_var", value=algorithm_var, expected_type=type_hints["algorithm_var"])
            check_type(argname="argument confidence", value=confidence, expected_type=type_hints["confidence"])
            check_type(argname="argument confidence_var", value=confidence_var, expected_type=type_hints["confidence_var"])
            check_type(argname="argument fail_gravity", value=fail_gravity, expected_type=type_hints["fail_gravity"])
            check_type(argname="argument fail_gravity_var", value=fail_gravity_var, expected_type=type_hints["fail_gravity_var"])
            check_type(argname="argument focus", value=focus, expected_type=type_hints["focus"])
            check_type(argname="argument focus_var", value=focus_var, expected_type=type_hints["focus_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if algorithm is not None:
            self._values["algorithm"] = algorithm
        if algorithm_var is not None:
            self._values["algorithm_var"] = algorithm_var
        if confidence is not None:
            self._values["confidence"] = confidence
        if confidence_var is not None:
            self._values["confidence_var"] = confidence_var
        if fail_gravity is not None:
            self._values["fail_gravity"] = fail_gravity
        if fail_gravity_var is not None:
            self._values["fail_gravity_var"] = fail_gravity_var
        if focus is not None:
            self._values["focus"] = focus
        if focus_var is not None:
            self._values["focus_var"] = focus_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def algorithm(self) -> typing.Optional[builtins.str]:
        '''Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm DataAkamaiImagingPolicyImage#algorithm}
        '''
        result = self._values.get("algorithm")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def algorithm_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm_var DataAkamaiImagingPolicyImage#algorithm_var}
        '''
        result = self._values.get("algorithm_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def confidence(self) -> typing.Optional[builtins.str]:
        '''With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image.

        Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence DataAkamaiImagingPolicyImage#confidence}
        '''
        result = self._values.get("confidence")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def confidence_var(self) -> typing.Optional[builtins.str]:
        '''With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image.

        Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence_var DataAkamaiImagingPolicyImage#confidence_var}
        '''
        result = self._values.get("confidence_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any faces in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        '''
        result = self._values.get("fail_gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any faces in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        '''
        result = self._values.get("fail_gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def focus(self) -> typing.Optional[builtins.str]:
        '''Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus DataAkamaiImagingPolicyImage#focus}
        '''
        result = self._values.get("focus")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def focus_var(self) -> typing.Optional[builtins.str]:
        '''Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus_var DataAkamaiImagingPolicyImage#focus_var}
        '''
        result = self._values.get("focus_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the face(s) plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the face(s) plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitFaceCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitFaceCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitFaceCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c9affa7f9e72ed40388ba3f6963e8a74fef81d4def46331ca52e1549264376f9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitFaceCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4e2577015949a8bee99f93063c58f72a3c6b97671c9e649f7bb6b08d41057cf5)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitFaceCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__544d793b2d05560407da0694d3b244c6f3386af65fe5adddd0d55853f079d6a7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fdc2405d13ccef68f2f7425c4c48e1b431a552e9423a8872fe9c604e23b6b9df)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4afcbfd31370325cb695a1468691819967fe4bd7262fa151988aa78c370c5fcc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitFaceCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitFaceCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitFaceCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a7a1b5196a3cb1b8e0005e81462b63ff78080fa407df32a7b395ad0389a7902e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitFaceCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitFaceCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c52ca72d5108b7965695e9844c2c8268d195e5462e2ed5c9587f2393cff91a6e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAlgorithm")
    def reset_algorithm(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAlgorithm", []))

    @jsii.member(jsii_name="resetAlgorithmVar")
    def reset_algorithm_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAlgorithmVar", []))

    @jsii.member(jsii_name="resetConfidence")
    def reset_confidence(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetConfidence", []))

    @jsii.member(jsii_name="resetConfidenceVar")
    def reset_confidence_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetConfidenceVar", []))

    @jsii.member(jsii_name="resetFailGravity")
    def reset_fail_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravity", []))

    @jsii.member(jsii_name="resetFailGravityVar")
    def reset_fail_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravityVar", []))

    @jsii.member(jsii_name="resetFocus")
    def reset_focus(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFocus", []))

    @jsii.member(jsii_name="resetFocusVar")
    def reset_focus_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFocusVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="algorithmInput")
    def algorithm_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "algorithmInput"))

    @builtins.property
    @jsii.member(jsii_name="algorithmVarInput")
    def algorithm_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "algorithmVarInput"))

    @builtins.property
    @jsii.member(jsii_name="confidenceInput")
    def confidence_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "confidenceInput"))

    @builtins.property
    @jsii.member(jsii_name="confidenceVarInput")
    def confidence_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "confidenceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityInput")
    def fail_gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityVarInput")
    def fail_gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="focusInput")
    def focus_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "focusInput"))

    @builtins.property
    @jsii.member(jsii_name="focusVarInput")
    def focus_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "focusVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="algorithm")
    def algorithm(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "algorithm"))

    @algorithm.setter
    def algorithm(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__299ee3e8c00313d4947c966fe5014b9acc889bc3255c1fe7d1a35dab45775848)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "algorithm", value)

    @builtins.property
    @jsii.member(jsii_name="algorithmVar")
    def algorithm_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "algorithmVar"))

    @algorithm_var.setter
    def algorithm_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b3ffd753185011b3200dc529921bc02fbf9ec2e2f15e8a177b95743c3136dea4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "algorithmVar", value)

    @builtins.property
    @jsii.member(jsii_name="confidence")
    def confidence(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "confidence"))

    @confidence.setter
    def confidence(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__643c0291aac40506646f1db745cbe273390638490e599b647941f8bd37f73c59)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "confidence", value)

    @builtins.property
    @jsii.member(jsii_name="confidenceVar")
    def confidence_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "confidenceVar"))

    @confidence_var.setter
    def confidence_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bce6be80768cc02be868b65f2832d503ed710846b6d866e88bc4f496e3c92ddf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "confidenceVar", value)

    @builtins.property
    @jsii.member(jsii_name="failGravity")
    def fail_gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravity"))

    @fail_gravity.setter
    def fail_gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cbbd1080b83eb0163678521fad33f80fb36946fdb0c10e5a59254cd3532bae5b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravity", value)

    @builtins.property
    @jsii.member(jsii_name="failGravityVar")
    def fail_gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravityVar"))

    @fail_gravity_var.setter
    def fail_gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__57b2000a05a62a5b7aded2ffbf55a0d66df296db92799e735bff589e5b2c5841)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="focus")
    def focus(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "focus"))

    @focus.setter
    def focus(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dab793b4053b7948ce51fce961320f5e51b327e658cc479f016b94bf3dc48198)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "focus", value)

    @builtins.property
    @jsii.member(jsii_name="focusVar")
    def focus_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "focusVar"))

    @focus_var.setter
    def focus_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__746f554e7868e383ea4aa38442662f705b399d63aae45be8e21129d9e9e87ac1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "focusVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__49da6272f619be4d271b36e7e52c592c889640254973e84b562001dc32afa2bb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7ce8285fcf59fd9502eb682ef8081288d9a01faf09702e62beb38398cb24dd97)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__62a589697bccae143bc62ed1b2f73b5075a85ab7e0aaecc44680e1fe4afaa64a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e256fca1862697d5996d360ad8d350d39a0089bd8a3931694622cb98c12297b4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__928986a41fe85b938705217cbcd16f95e65fdbbab6c10745419fafab4281d56e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__27638fc4d1f1aa0eb4dc9a080e6232421f1361f635fab7feaa5384a1730ecfcb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2eaab4793af598eb0ba333dcffffc525c291a4332cb18d33f056e98b76df156b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bf076fa20bfa1e06030f1442f9bb9254e1b2b51eb7f9610ff939569e2c9ab3dd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d59fa7a04476bfd948c9cd2759fd6e8701b742b01816393445613074c0f02bd9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__08daf6297aba04c46a0a87e0e92f5e9e0d7b4ec72368fd5e76bcf1c751b0c2d4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitFaceCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitFaceCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitFaceCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1a6fe789973bbff8e0fa6b636b78f2e3c15685d421be8f96f47e56eeb0401439)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitFeatureCrop",
    jsii_struct_bases=[],
    name_mapping={
        "fail_gravity": "failGravity",
        "fail_gravity_var": "failGravityVar",
        "feature_radius": "featureRadius",
        "feature_radius_var": "featureRadiusVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "max_features": "maxFeatures",
        "max_features_var": "maxFeaturesVar",
        "min_feature_quality": "minFeatureQuality",
        "min_feature_quality_var": "minFeatureQualityVar",
        "padding": "padding",
        "padding_var": "paddingVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitFeatureCrop:
    def __init__(
        self,
        *,
        fail_gravity: typing.Optional[builtins.str] = None,
        fail_gravity_var: typing.Optional[builtins.str] = None,
        feature_radius: typing.Optional[builtins.str] = None,
        feature_radius_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        max_features: typing.Optional[builtins.str] = None,
        max_features_var: typing.Optional[builtins.str] = None,
        min_feature_quality: typing.Optional[builtins.str] = None,
        min_feature_quality_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fail_gravity: Controls placement of the crop if Image and Video Manager does not detect any features in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        :param fail_gravity_var: Controls placement of the crop if Image and Video Manager does not detect any features in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        :param feature_radius: The size in pixels of the important features to search for. If identified, two features never appear closer together than this value, ``8.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius DataAkamaiImagingPolicyImage#feature_radius}
        :param feature_radius_var: The size in pixels of the important features to search for. If identified, two features never appear closer together than this value, ``8.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius_var DataAkamaiImagingPolicyImage#feature_radius_var}
        :param gravity: Controls placement of the crop. Directions are relative to the region of interest plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Controls placement of the crop. Directions are relative to the region of interest plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param max_features: The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features DataAkamaiImagingPolicyImage#max_features}
        :param max_features_var: The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features_var DataAkamaiImagingPolicyImage#max_features_var}
        :param min_feature_quality: Determines the minimum quality level of the feature identified. To consider a feature important, the feature needs to surpass this value. Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality DataAkamaiImagingPolicyImage#min_feature_quality}
        :param min_feature_quality_var: Determines the minimum quality level of the feature identified. To consider a feature important, the feature needs to surpass this value. Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality_var DataAkamaiImagingPolicyImage#min_feature_quality_var}
        :param padding: Adds space around the region of interest. The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: Adds space around the region of interest. The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        :param style: Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dd96ec8b35e1972f20069c8983cdd327035142d8c26635af2b0e242299fb44fb)
            check_type(argname="argument fail_gravity", value=fail_gravity, expected_type=type_hints["fail_gravity"])
            check_type(argname="argument fail_gravity_var", value=fail_gravity_var, expected_type=type_hints["fail_gravity_var"])
            check_type(argname="argument feature_radius", value=feature_radius, expected_type=type_hints["feature_radius"])
            check_type(argname="argument feature_radius_var", value=feature_radius_var, expected_type=type_hints["feature_radius_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument max_features", value=max_features, expected_type=type_hints["max_features"])
            check_type(argname="argument max_features_var", value=max_features_var, expected_type=type_hints["max_features_var"])
            check_type(argname="argument min_feature_quality", value=min_feature_quality, expected_type=type_hints["min_feature_quality"])
            check_type(argname="argument min_feature_quality_var", value=min_feature_quality_var, expected_type=type_hints["min_feature_quality_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fail_gravity is not None:
            self._values["fail_gravity"] = fail_gravity
        if fail_gravity_var is not None:
            self._values["fail_gravity_var"] = fail_gravity_var
        if feature_radius is not None:
            self._values["feature_radius"] = feature_radius
        if feature_radius_var is not None:
            self._values["feature_radius_var"] = feature_radius_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if max_features is not None:
            self._values["max_features"] = max_features
        if max_features_var is not None:
            self._values["max_features_var"] = max_features_var
        if min_feature_quality is not None:
            self._values["min_feature_quality"] = min_feature_quality
        if min_feature_quality_var is not None:
            self._values["min_feature_quality_var"] = min_feature_quality_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def fail_gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any features in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        '''
        result = self._values.get("fail_gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any features in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        '''
        result = self._values.get("fail_gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feature_radius(self) -> typing.Optional[builtins.str]:
        '''The size in pixels of the important features to search for.

        If identified, two features never appear closer together than this value, ``8.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius DataAkamaiImagingPolicyImage#feature_radius}
        '''
        result = self._values.get("feature_radius")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feature_radius_var(self) -> typing.Optional[builtins.str]:
        '''The size in pixels of the important features to search for.

        If identified, two features never appear closer together than this value, ``8.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius_var DataAkamaiImagingPolicyImage#feature_radius_var}
        '''
        result = self._values.get("feature_radius_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the region of interest plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the region of interest plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def max_features(self) -> typing.Optional[builtins.str]:
        '''The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features DataAkamaiImagingPolicyImage#max_features}
        '''
        result = self._values.get("max_features")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def max_features_var(self) -> typing.Optional[builtins.str]:
        '''The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features_var DataAkamaiImagingPolicyImage#max_features_var}
        '''
        result = self._values.get("max_features_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def min_feature_quality(self) -> typing.Optional[builtins.str]:
        '''Determines the minimum quality level of the feature identified.

        To consider a feature important, the feature needs to surpass this value.  Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality DataAkamaiImagingPolicyImage#min_feature_quality}
        '''
        result = self._values.get("min_feature_quality")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def min_feature_quality_var(self) -> typing.Optional[builtins.str]:
        '''Determines the minimum quality level of the feature identified.

        To consider a feature important, the feature needs to surpass this value.  Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality_var DataAkamaiImagingPolicyImage#min_feature_quality_var}
        '''
        result = self._values.get("min_feature_quality_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''Adds space around the region of interest.

        The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''Adds space around the region of interest.

        The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitFeatureCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitFeatureCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitFeatureCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a4cd1dbe1b1e8f999d54567070066dd4a040812fc8cce6e7115b91c7147d8a3c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitFeatureCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__569bbdd9eb5fbf1fb17df3563afc8b13a8d46c4aa3cdf402ffcb502e4e81d6e7)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitFeatureCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__506f4915d7d8636fd6d90d8f1e6f7b12b46446aa64422b0e31be59409beaedc2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea2fdf8022e4a1a5939f1bab86f2c92fcf92608913662fdb45a2137b85b0e225)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dcf51bada14770b4b5d773e94e323547ce6befe905fb65afee6986c8f070b6bf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitFeatureCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitFeatureCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitFeatureCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d07ef579b9c8b163b0bf0af435918c5b46d7338377f0d52713cd2f289e9cbc70)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitFeatureCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitFeatureCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__78eafcbc7351c1f8ed33548940f0ba58108c8416316a75f60c52744f1ea13e31)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetFailGravity")
    def reset_fail_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravity", []))

    @jsii.member(jsii_name="resetFailGravityVar")
    def reset_fail_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravityVar", []))

    @jsii.member(jsii_name="resetFeatureRadius")
    def reset_feature_radius(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureRadius", []))

    @jsii.member(jsii_name="resetFeatureRadiusVar")
    def reset_feature_radius_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureRadiusVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetMaxFeatures")
    def reset_max_features(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxFeatures", []))

    @jsii.member(jsii_name="resetMaxFeaturesVar")
    def reset_max_features_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxFeaturesVar", []))

    @jsii.member(jsii_name="resetMinFeatureQuality")
    def reset_min_feature_quality(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMinFeatureQuality", []))

    @jsii.member(jsii_name="resetMinFeatureQualityVar")
    def reset_min_feature_quality_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMinFeatureQualityVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="failGravityInput")
    def fail_gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityVarInput")
    def fail_gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featureRadiusInput")
    def feature_radius_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featureRadiusInput"))

    @builtins.property
    @jsii.member(jsii_name="featureRadiusVarInput")
    def feature_radius_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featureRadiusVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesInput")
    def max_features_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "maxFeaturesInput"))

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesVarInput")
    def max_features_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "maxFeaturesVarInput"))

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityInput")
    def min_feature_quality_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "minFeatureQualityInput"))

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityVarInput")
    def min_feature_quality_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "minFeatureQualityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravity")
    def fail_gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravity"))

    @fail_gravity.setter
    def fail_gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cfe13d0669ec6cb0c760b39fa1680a6ab4ce587ed0cdf8a6201862a80e2d804d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravity", value)

    @builtins.property
    @jsii.member(jsii_name="failGravityVar")
    def fail_gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravityVar"))

    @fail_gravity_var.setter
    def fail_gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3f1bd09fd24746bb9475173ff6ac728619372fe42b54c4e8fdfc85924bc25610)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="featureRadius")
    def feature_radius(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featureRadius"))

    @feature_radius.setter
    def feature_radius(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d8e40f31c42cbcb8d1991be000545c2d78657fb36433cc177102c78f86630072)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featureRadius", value)

    @builtins.property
    @jsii.member(jsii_name="featureRadiusVar")
    def feature_radius_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featureRadiusVar"))

    @feature_radius_var.setter
    def feature_radius_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c56d52bfea50c6464e39fd3f700f8ff2553fb689645a1f588194c6ca57b0f524)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featureRadiusVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4533cfd1c00f4cc34c1eeca5931bf09a88446a70be3a91788c9c1b1081c7118f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__42eb0833239a63493d15791fc7b639eb86625728a5fc31b4de8ad801ab7c2702)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3c9c1ec27e903b3f6c370a1412115164ab56776054b11acb37c6648a0297fe05)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__66093405f88d43767ab4d099d3c276afcc9e8679b54311edf99cfd7ac6bd1460)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="maxFeatures")
    def max_features(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "maxFeatures"))

    @max_features.setter
    def max_features(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0b2a46002d8462f54d43913eb64535ce53644abf2c5f5c18e7ca340de71b265b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "maxFeatures", value)

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesVar")
    def max_features_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "maxFeaturesVar"))

    @max_features_var.setter
    def max_features_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__331355d5c7aa1ae1143cd4178768b08b735d684c508d358e366960ec0245e5a7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "maxFeaturesVar", value)

    @builtins.property
    @jsii.member(jsii_name="minFeatureQuality")
    def min_feature_quality(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "minFeatureQuality"))

    @min_feature_quality.setter
    def min_feature_quality(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bff52a27e5e9b60cc87c6bee00e682878067e2df3ff02204a30c7aeebf6efcaa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "minFeatureQuality", value)

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityVar")
    def min_feature_quality_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "minFeatureQualityVar"))

    @min_feature_quality_var.setter
    def min_feature_quality_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1aa13ea66ee7a3778b8b08e45c39295e25fbfb16481aae7673e5d94d594cfe47)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "minFeatureQualityVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f4bdca9005a5cea247036f2aaeb198ecdc19a0765016f055509840d19fdc3f74)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__befd9a8146fd9d38ed3bcfe56fe0a119048895b5e72cb855b54d39e395abac87)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__804609545110ca02402d075a6e74612167f0b31dc505984982f352bbbdcc3697)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7b929f90e74fa3af0c7cc8a79b20fb2bc3a288db6116e0f90d7eaf40d90a39a0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__82ccd2f31fccd057c246b62344ea5275f9ed7cf8877329ff6de8880616341da8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__575789b37ed73e293a8c07b3a7c87a82bd9fab5365d45968e14b81fa4b159621)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitFeatureCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitFeatureCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitFeatureCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__13e062c9b7848a51833134d6a3b287b04cb7b4e7ae1511393d3755ccbef024b7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitFitAndFill",
    jsii_struct_bases=[],
    name_mapping={
        "fill_transformation": "fillTransformation",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitFitAndFill:
    def __init__(
        self,
        *,
        fill_transformation: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitFitAndFillFillTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fill_transformation: fill_transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_transformation DataAkamaiImagingPolicyImage#fill_transformation}
        :param height: The height value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The width value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(fill_transformation, dict):
            fill_transformation = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitFitAndFillFillTransformation(**fill_transformation)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0715606b9bb8e62f27f8e9f22b8ca76c28eddead3cc986b3356eee38bed3a877)
            check_type(argname="argument fill_transformation", value=fill_transformation, expected_type=type_hints["fill_transformation"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fill_transformation is not None:
            self._values["fill_transformation"] = fill_transformation
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def fill_transformation(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitFitAndFillFillTransformation"]:
        '''fill_transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_transformation DataAkamaiImagingPolicyImage#fill_transformation}
        '''
        result = self._values.get("fill_transformation")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitFitAndFillFillTransformation"], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitFitAndFill(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitFitAndFillFillTransformation",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitFitAndFillFillTransformation:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitFitAndFillFillTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitFitAndFillFillTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitFitAndFillFillTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2b0e76437960aefcbe5814c5380c704448900f3ab402f7742e713d29e028617f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitFitAndFillFillTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitFitAndFillFillTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitFitAndFillFillTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dc632981808cd8ee8914016fe4b9364c15a7a65916c14f32470469b5425ec421)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitFitAndFillList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitFitAndFillList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b008898784128e62801e9ab582455c67ca4bd0b39ff375d2e966abc587d3e144)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitFitAndFillOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c643da0150e42e7498ccabb3ac41fbf014eb75483bc810b3c8f168dcb96828f2)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitFitAndFillOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aade0a0d1849842f31cb67d95a1dee839c054c913940f2b91e0f982898c05b6c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d19141f63ef003ca13bdd9d53e2965a7eb1d25338a644d7a23a6e03bb5b34427)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__199885d2528c541b55b9c0b16b27a7f7cba2b13655e33a7b6ba722fb6d31b7d7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitFitAndFill]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitFitAndFill]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitFitAndFill]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d45d0c4c866ffd2119dfa9bbb5b1f911b1b9f110f5be85bb57b6509c583c00a4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitFitAndFillOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitFitAndFillOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d84b393fb2f0d36afdade5a034e8fff19d0ef1b83093320800150b5177473b38)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putFillTransformation")
    def put_fill_transformation(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitFitAndFillFillTransformation()

        return typing.cast(None, jsii.invoke(self, "putFillTransformation", [value]))

    @jsii.member(jsii_name="resetFillTransformation")
    def reset_fill_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFillTransformation", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="fillTransformation")
    def fill_transformation(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitFitAndFillFillTransformationOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitFitAndFillFillTransformationOutputReference, jsii.get(self, "fillTransformation"))

    @builtins.property
    @jsii.member(jsii_name="fillTransformationInput")
    def fill_transformation_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitFitAndFillFillTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitFitAndFillFillTransformation], jsii.get(self, "fillTransformationInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__42220afd885dbcd21eec516e3201947894757722c40c1aa06ce96819bc0b958d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ae5f6c831fb46c3ae72e2425ba691fb31210777f9d4b4cc3b1d86ac065bc0ccd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e0a672014abd11951e92f931b475767deb8c826423084503ddcd744b9af5515c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a07fa8fe4c32912f05254aeeefc237d917e9671bbd82a950b30879250309b666)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitFitAndFill]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitFitAndFill]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitFitAndFill]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__84d37593956e095515add874e408e8cbd611510a8efddbbe0741356e2c1f42b9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitGoop",
    jsii_struct_bases=[],
    name_mapping={
        "chaos": "chaos",
        "chaos_var": "chaosVar",
        "density": "density",
        "density_var": "densityVar",
        "power": "power",
        "power_var": "powerVar",
        "seed": "seed",
        "seed_var": "seedVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitGoop:
    def __init__(
        self,
        *,
        chaos: typing.Optional[builtins.str] = None,
        chaos_var: typing.Optional[builtins.str] = None,
        density: typing.Optional[builtins.str] = None,
        density_var: typing.Optional[builtins.str] = None,
        power: typing.Optional[builtins.str] = None,
        power_var: typing.Optional[builtins.str] = None,
        seed: typing.Optional[builtins.str] = None,
        seed_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param chaos: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        :param chaos_var: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        :param density: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        :param density_var: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        :param power: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        :param power_var: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        :param seed: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        :param seed_var: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__70f86978589547f9c1ba0cc71289a93d612edc6b61046caa18a135343f793059)
            check_type(argname="argument chaos", value=chaos, expected_type=type_hints["chaos"])
            check_type(argname="argument chaos_var", value=chaos_var, expected_type=type_hints["chaos_var"])
            check_type(argname="argument density", value=density, expected_type=type_hints["density"])
            check_type(argname="argument density_var", value=density_var, expected_type=type_hints["density_var"])
            check_type(argname="argument power", value=power, expected_type=type_hints["power"])
            check_type(argname="argument power_var", value=power_var, expected_type=type_hints["power_var"])
            check_type(argname="argument seed", value=seed, expected_type=type_hints["seed"])
            check_type(argname="argument seed_var", value=seed_var, expected_type=type_hints["seed_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if chaos is not None:
            self._values["chaos"] = chaos
        if chaos_var is not None:
            self._values["chaos_var"] = chaos_var
        if density is not None:
            self._values["density"] = density
        if density_var is not None:
            self._values["density_var"] = density_var
        if power is not None:
            self._values["power"] = power
        if power_var is not None:
            self._values["power_var"] = power_var
        if seed is not None:
            self._values["seed"] = seed
        if seed_var is not None:
            self._values["seed_var"] = seed_var

    @builtins.property
    def chaos(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        '''
        result = self._values.get("chaos")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def chaos_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        '''
        result = self._values.get("chaos_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        '''
        result = self._values.get("density")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density_var(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        '''
        result = self._values.get("density_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        '''
        result = self._values.get("power")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power_var(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        '''
        result = self._values.get("power_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        '''
        result = self._values.get("seed")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed_var(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        result = self._values.get("seed_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitGoop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitGoopList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitGoopList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b408946c27b25465636553c6905c628c78dba3626ec6efb93b6bcdaeb818fc74)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitGoopOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ba9968b81d5d04aebccaffa996b062ed3070926d98cb99ff3c3ae8f5c6af9ef5)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitGoopOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d54ba82496f3c4a663515dece05983b39a241e0e2425e484b78d9d96f77f2c36)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e2744771fb2f8bf2d2b1b3b0de86daa562cdd00e8ae1b3be60799520cd9608ea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b2bf8a16cfe4928dc348002188d41057dff24263ea9f0d11b843b84398f0e8c2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitGoop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitGoop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d628c6791d37400745cea8c21b37b1b4e2201a29c2713e2bc7780b51f9914ef6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitGoopOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitGoopOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a3ed3948f163c5dbf87ab06adb3202b3fa8c1ef975cd5e3a41bee0a38d060aaa)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetChaos")
    def reset_chaos(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaos", []))

    @jsii.member(jsii_name="resetChaosVar")
    def reset_chaos_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaosVar", []))

    @jsii.member(jsii_name="resetDensity")
    def reset_density(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensity", []))

    @jsii.member(jsii_name="resetDensityVar")
    def reset_density_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensityVar", []))

    @jsii.member(jsii_name="resetPower")
    def reset_power(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPower", []))

    @jsii.member(jsii_name="resetPowerVar")
    def reset_power_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPowerVar", []))

    @jsii.member(jsii_name="resetSeed")
    def reset_seed(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeed", []))

    @jsii.member(jsii_name="resetSeedVar")
    def reset_seed_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeedVar", []))

    @builtins.property
    @jsii.member(jsii_name="chaosInput")
    def chaos_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosInput"))

    @builtins.property
    @jsii.member(jsii_name="chaosVarInput")
    def chaos_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosVarInput"))

    @builtins.property
    @jsii.member(jsii_name="densityInput")
    def density_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityInput"))

    @builtins.property
    @jsii.member(jsii_name="densityVarInput")
    def density_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="powerInput")
    def power_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerInput"))

    @builtins.property
    @jsii.member(jsii_name="powerVarInput")
    def power_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerVarInput"))

    @builtins.property
    @jsii.member(jsii_name="seedInput")
    def seed_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedInput"))

    @builtins.property
    @jsii.member(jsii_name="seedVarInput")
    def seed_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedVarInput"))

    @builtins.property
    @jsii.member(jsii_name="chaos")
    def chaos(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaos"))

    @chaos.setter
    def chaos(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6ec893f596a5975f31b6a8d9d92749ecaf3680ea0b3c2e18298d269a3f8921dc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaos", value)

    @builtins.property
    @jsii.member(jsii_name="chaosVar")
    def chaos_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaosVar"))

    @chaos_var.setter
    def chaos_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2946add7e39698e063f9c06793a18455f85b85653190c3c25096be6d692122bd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaosVar", value)

    @builtins.property
    @jsii.member(jsii_name="density")
    def density(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "density"))

    @density.setter
    def density(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__17ea3c205629a7ef5f16839f797cb1d3ffad35f22e03a24692a1c9373faa9044)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "density", value)

    @builtins.property
    @jsii.member(jsii_name="densityVar")
    def density_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "densityVar"))

    @density_var.setter
    def density_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c0b8cb1aa9fe474ee6e50b0ade5d3b870ef171bcc79096a5fb52010864407472)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "densityVar", value)

    @builtins.property
    @jsii.member(jsii_name="power")
    def power(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "power"))

    @power.setter
    def power(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5c534d9bb0f80739ab99026f52cab5f2428bc76be0110ccae3c65f94cf839bc8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "power", value)

    @builtins.property
    @jsii.member(jsii_name="powerVar")
    def power_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "powerVar"))

    @power_var.setter
    def power_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e5b3632049986ad956794a4f7e2923302f8d9e69718225313f5570288123f804)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "powerVar", value)

    @builtins.property
    @jsii.member(jsii_name="seed")
    def seed(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seed"))

    @seed.setter
    def seed(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6fe76b8b987a475cfce68211c09c4c06dcf60ce9466f4261414b3d2c9a7031ef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seed", value)

    @builtins.property
    @jsii.member(jsii_name="seedVar")
    def seed_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seedVar"))

    @seed_var.setter
    def seed_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__857bc5dbb9c4efc58e7199362750ac175c74363ba596515ad23f382c15fe3e9f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seedVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitGoop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitGoop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitGoop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e9aceb7c1f03d1a31159e9808f7505062f3a585f780fa1be1eacb47f35df85b3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitGrayscale",
    jsii_struct_bases=[],
    name_mapping={"type": "type", "type_var": "typeVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitGrayscale:
    def __init__(
        self,
        *,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param type: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8c9da6ef4c7d53a6a1feb7abfb161b0919057665661184f1cea228c785c02dd6)
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitGrayscale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitGrayscaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitGrayscaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a9c33d3c286492b6c0362f7f5dc67b14e2f196c8dc9066d4e1d6f96320058c01)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitGrayscaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ae733e67abbb33c41e59792f0a9baf2e8662ac3df52a132afcc43d0289edbf0b)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitGrayscaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6142a270282b2ea34f05c7f236d7ceef9cd17c99a9286ba15b4c0edbe03bbbfc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f2d0e0b6086393eb3607f81c98c70f2a2964af248cade7bc1e9c841ce08282f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fdde1593c09273af2eb14c4d565cf1e5f6f9cbaa200b4cc921fb394c74326b1d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitGrayscale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitGrayscale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d60ad391bc6223a4e82e46a4f64bba3c804e8f9b492fdf75911a644e8c29a48)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitGrayscaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitGrayscaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a10185c4eeadd146cdb63a187ce5a9f8008999e65f75cdc47143f17371c5ab40)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4e60786e22cd8baf3a3001a5efe4d41e847f6e82dccba821899d2a00b176392b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0debf47ec893b7af1b7a61f34a1575c0ac87b4f215c7186e280dac687bbd8801)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitGrayscale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitGrayscale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitGrayscale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fbd8e48a4eb7d0ae9407cd8e0bb197f7c2d266dc2a9b94e5a078f6721af33533)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitHsl",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "lightness": "lightness",
        "lightness_var": "lightnessVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitHsl:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness: typing.Optional[builtins.str] = None,
        lightness_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        :param lightness_var: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2f455c9e12dba001706ec8ba95e35596ea4186219e5c85117e70b8086de62a55)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness", value=lightness, expected_type=type_hints["lightness"])
            check_type(argname="argument lightness_var", value=lightness_var, expected_type=type_hints["lightness_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness is not None:
            self._values["lightness"] = lightness
        if lightness_var is not None:
            self._values["lightness_var"] = lightness_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        '''
        result = self._values.get("lightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        '''
        result = self._values.get("lightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitHsl(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitHslList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitHslList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0aca0d4fa2c0774e6ba173b82ef294df08ca494f293b6ad882fdb60ea27fa1b2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitHslOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__34ad8bb1cc36d8c8fcade819d38a226cb6f29f6a3c12aaf21460ec63ef197321)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitHslOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e4ace28e14a3159e819df8df19922ed1d7e7a40d03a1af06d33e54ab666f4f00)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6b9a315a0084bc07af6b82a29dfd59048e277265ee97bb151c16b7bb9b9b4cf3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c34a4235c073caa985a21ce40898f92f61cb7c53d6bd8d470de514d7cb7289d0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitHsl]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitHsl]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__82f1519e987efc12b6d1cdc796a6a425b82133b60660464c08f5cdbc4ac87f71)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitHslOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitHslOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e25b2cb2b1c04782e4d65666bd319e47ac63f7c2bc3f3f33dea4cf3fa2d0a831)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightness")
    def reset_lightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightness", []))

    @jsii.member(jsii_name="resetLightnessVar")
    def reset_lightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessInput")
    def lightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessVarInput")
    def lightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5cd102afe3c3ecdf7e4129d1ed91124ac3e481de542f2e6593879a21ccfc154c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__59440bdcdb6a39c1cb6f7704d31e946f7adce45051962feb88d29f9f76dbf9db)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightness")
    def lightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightness"))

    @lightness.setter
    def lightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3c4e11ece86a05e6e1017c8652d5dd1f8aab9c665260f5cb6c54a6532abab153)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightness", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessVar")
    def lightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessVar"))

    @lightness_var.setter
    def lightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f39135d3764785c17830aee8c79820c0feb51fe9be35af63cf5d18bf9240072f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__38d46850fb0f34eea552e39d25964232869ed34282321944c5c9ea84ea857c21)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e5bb939f5f39387c302e4edc0a002d01fb0228684c5d1e7f76b25827e1285056)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitHsl]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitHsl]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitHsl]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2bbfdcf0009ec3a485cfdeaea19c1021ac721a3928ae22e488897c2ce494b972)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitHsv",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitHsv:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        :param value: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__803232ae624975a6b0b3ce6a34cff714f58f1a33b0b7c4ed748375ffd59a65d0)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitHsv(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitHsvList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitHsvList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d2e33c2f9d688f551482d32defd8cae9d7c312de291819cc6487145eb76cb367)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitHsvOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b487dad2025814da090dd395c626a19eb3ed6f4018b0a47f2cd6f45fa7938c63)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitHsvOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__850e9445ad26a3bfee354e447e9a957a3e3313f6b2dcdbf86f4da075249bd41e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__de3362a38875208bfcae1cb961b1d51af3909b51867f5293a7c467ea2db65d0d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cc4bb2c4d2d77620bd813137ece8dc3dbee21e9fe0a7f7962ba11949194c62eb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitHsv]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitHsv]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__55fa765a24fabd1eb4721bc8f3673681fa861ca741e4afdeeb1ffc7a3d3176dc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitHsvOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitHsvOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__99ab08c02383a895bbb9985a0b8c92d530772db7e2ecac5200e66b0e3383be67)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__554e421a7c111df63a6be6a09351f643ec93760a5a069df4d43038ef8224ef5b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__88facdc28e84c7ea79b2163929ed5ace66e6ae12d358733f3e07d0988ab6b241)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a4f0a532ad2e5db6eb70824c62859f4a8800a62564602d2cd415515d737c550)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__38fff16e6a5eb72f967c448209033f9f907927f393649fcb3372b3406804b33d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__76cf5c969705dca7816f88700a154c10d358ae4a9905fa9bc6a8c646f90cf39a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a902adaabf5b15d31db7da8fff9131caa5271dd24420e1343c63f86b6cadddf9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitHsv]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitHsv]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitHsv]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3d3e939d988517df33049afaa9b76703c1a52dac2c98e5183cfd9e11e8a7c6df)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimension",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "dimension": "dimension",
        "dimension_var": "dimensionVar",
        "equal": "equal",
        "greater_than": "greaterThan",
        "less_than": "lessThan",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimension:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        dimension: typing.Optional[builtins.str] = None,
        dimension_var: typing.Optional[builtins.str] = None,
        equal: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionEqual", typing.Dict[builtins.str, typing.Any]]] = None,
        greater_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionGreaterThan", typing.Dict[builtins.str, typing.Any]]] = None,
        less_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionLessThan", typing.Dict[builtins.str, typing.Any]]] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param dimension: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        :param dimension_var: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        :param equal: equal block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        :param greater_than: greater_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        :param less_than: less_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        :param value: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionDefault(**default)
        if isinstance(equal, dict):
            equal = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionEqual(**equal)
        if isinstance(greater_than, dict):
            greater_than = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionGreaterThan(**greater_than)
        if isinstance(less_than, dict):
            less_than = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionLessThan(**less_than)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2f4f17fb60e886fbb1993d1a18423c880a597fdbae3200c27093a5b513ec2c2f)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument dimension", value=dimension, expected_type=type_hints["dimension"])
            check_type(argname="argument dimension_var", value=dimension_var, expected_type=type_hints["dimension_var"])
            check_type(argname="argument equal", value=equal, expected_type=type_hints["equal"])
            check_type(argname="argument greater_than", value=greater_than, expected_type=type_hints["greater_than"])
            check_type(argname="argument less_than", value=less_than, expected_type=type_hints["less_than"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if dimension is not None:
            self._values["dimension"] = dimension
        if dimension_var is not None:
            self._values["dimension_var"] = dimension_var
        if equal is not None:
            self._values["equal"] = equal
        if greater_than is not None:
            self._values["greater_than"] = greater_than
        if less_than is not None:
            self._values["less_than"] = less_than
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionDefault"], result)

    @builtins.property
    def dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        '''
        result = self._values.get("dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        '''
        result = self._values.get("dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def equal(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionEqual"]:
        '''equal block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        '''
        result = self._values.get("equal")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionEqual"], result)

    @builtins.property
    def greater_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionGreaterThan"]:
        '''greater_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        '''
        result = self._values.get("greater_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionGreaterThan"], result)

    @builtins.property
    def less_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionLessThan"]:
        '''less_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        '''
        result = self._values.get("less_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionLessThan"], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimension(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4034d4fa1e593f5ac704e8c8d53ccef7afff3b969087128e22cbb6337158a770)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2215623b90e287f0f7a604613c2dbb4a4eb635dea419ec139b43917c5353f035)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionEqual",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionEqual:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionEqual(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionEqualOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionEqualOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__70c69701c0ccc253dfe42e03360582e36e78c1f2772e1721f7cb77ba105ccd1e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionEqual], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionEqual],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a5c06fc8eec84771cddd7ea720723ab8f1fd00875254f592285235749a86b74e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionGreaterThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionGreaterThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionGreaterThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionGreaterThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionGreaterThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__39e9507b7c39a4811f3db9e7e6570b665b522aef9f463b76c139440d3a5a15b0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionGreaterThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionGreaterThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f592e428bef5b3a13f4d03ad7f9998a11c7b4870aee71abe59a23cd422e1f626)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionLessThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionLessThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionLessThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionLessThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionLessThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b76baaa6ed2d0f53ecbe1144d7f945fca1940cab77f1b19a2b8e9784baf2cea6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionLessThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionLessThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__08b1f88f1356bb4294daa07c266d67d2e83c5845611a04afbbe5ec81f67f793a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__57d8b3ff55866289cdc24bac147ceac922f293abb4a984eb1bc697034089597a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__afbb1734d3435425f2ba29d6a63e9d49d61bab4708afaf7f19b97667f8a477e1)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__93ec28982bb0f109554c633c986c47d5e8d7f78299928134a8011bb319883ede)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a2ff95385a59380f88e8458a45321bb88d63e6ea815054c20de8e320ba1451b6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f753f2b61c2994e2635961dcba6514f1705368571a1fb8e03ec9d17c05aece7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimension]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimension]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c9b839c8665b80264fa0606896365ae0cb9c799becc735808c7592844b767db2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5b4a0a5d3c39b55ac09332574f912e15d05087ea271dc56af5946765fdc9a3a4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putEqual")
    def put_equal(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionEqual()

        return typing.cast(None, jsii.invoke(self, "putEqual", [value]))

    @jsii.member(jsii_name="putGreaterThan")
    def put_greater_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionGreaterThan()

        return typing.cast(None, jsii.invoke(self, "putGreaterThan", [value]))

    @jsii.member(jsii_name="putLessThan")
    def put_less_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionLessThan()

        return typing.cast(None, jsii.invoke(self, "putLessThan", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetDimension")
    def reset_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimension", []))

    @jsii.member(jsii_name="resetDimensionVar")
    def reset_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimensionVar", []))

    @jsii.member(jsii_name="resetEqual")
    def reset_equal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEqual", []))

    @jsii.member(jsii_name="resetGreaterThan")
    def reset_greater_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGreaterThan", []))

    @jsii.member(jsii_name="resetLessThan")
    def reset_less_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLessThan", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="equal")
    def equal(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionEqualOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionEqualOutputReference, jsii.get(self, "equal"))

    @builtins.property
    @jsii.member(jsii_name="greaterThan")
    def greater_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionGreaterThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionGreaterThanOutputReference, jsii.get(self, "greaterThan"))

    @builtins.property
    @jsii.member(jsii_name="lessThan")
    def less_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionLessThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionLessThanOutputReference, jsii.get(self, "lessThan"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionInput")
    def dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionVarInput")
    def dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="equalInput")
    def equal_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionEqual], jsii.get(self, "equalInput"))

    @builtins.property
    @jsii.member(jsii_name="greaterThanInput")
    def greater_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionGreaterThan], jsii.get(self, "greaterThanInput"))

    @builtins.property
    @jsii.member(jsii_name="lessThanInput")
    def less_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionLessThan], jsii.get(self, "lessThanInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="dimension")
    def dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimension"))

    @dimension.setter
    def dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c59042385cd74174b6b06d0ac005c1b5e2437b9fe576d7b69cdcd079ba3fe12e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimension", value)

    @builtins.property
    @jsii.member(jsii_name="dimensionVar")
    def dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimensionVar"))

    @dimension_var.setter
    def dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ff30b9c6128115a7b5a0594cbe57dc5f6e48cbc675a898d5dbf32ff11912aaa8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a1e3b2c31950528f5264b89dbd8accfcac2d88f2c272a6c25583211c09f8457c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c3998c4ea5688620fecf87fb302ea84b1b6076266fd2bfbd3793b1a74537587d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimension]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimension]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimension]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac9da738f5d883ef4f67ad3166287e9f68b1e22f2d65fc844a1668ff4cdc003e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientation",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "landscape": "landscape",
        "portrait": "portrait",
        "square": "square",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientation:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        landscape: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationLandscape", typing.Dict[builtins.str, typing.Any]]] = None,
        portrait: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationPortrait", typing.Dict[builtins.str, typing.Any]]] = None,
        square: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationSquare", typing.Dict[builtins.str, typing.Any]]] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param landscape: landscape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        :param portrait: portrait block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        :param square: square block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationDefault(**default)
        if isinstance(landscape, dict):
            landscape = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationLandscape(**landscape)
        if isinstance(portrait, dict):
            portrait = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationPortrait(**portrait)
        if isinstance(square, dict):
            square = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationSquare(**square)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__05a8de517cc01a635ac1918b384c3219d990d1ed0272577931ccd8034ba2dbb7)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument landscape", value=landscape, expected_type=type_hints["landscape"])
            check_type(argname="argument portrait", value=portrait, expected_type=type_hints["portrait"])
            check_type(argname="argument square", value=square, expected_type=type_hints["square"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if landscape is not None:
            self._values["landscape"] = landscape
        if portrait is not None:
            self._values["portrait"] = portrait
        if square is not None:
            self._values["square"] = square

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationDefault"], result)

    @builtins.property
    def landscape(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationLandscape"]:
        '''landscape block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        '''
        result = self._values.get("landscape")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationLandscape"], result)

    @builtins.property
    def portrait(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationPortrait"]:
        '''portrait block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        '''
        result = self._values.get("portrait")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationPortrait"], result)

    @builtins.property
    def square(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationSquare"]:
        '''square block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        result = self._values.get("square")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationSquare"], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__72343d961a3975a00d29396f01dd035b8a6c7ed8570ff8a00719fb1faf947c0b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__84862faff7ca7fbfcd86ad9f40f0c8cd7f5603c2681ac41f6f1067072a12ab32)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationLandscape",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationLandscape:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationLandscape(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationLandscapeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationLandscapeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7235e65ea5e60d848c4308c87096902e7d05c3a257e5e80894fb6e26e5b0c12a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationLandscape], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationLandscape],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__526777c0dc8a71fd9d19d1108872b71a10ed615eff4aac79d32d38f48ff6101f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc752883a874f589a50a3a43be05aff7adbc891914bdf54a5c2f11025798ce77)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__005df9ded6694f69db751f7cd766f03eaed09a9b4bb0e72cd51cd0576a4f101a)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dc7d655e6b019b5a478eb1f171199cd5818f7d665e302ce1a2e2089630f0e734)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a9aa02521f39817d257e16ba780f6cdfde37c077c17ffe0e967f0c5d8f405ad8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aa0755f38b4bf4a19434e4e6b08ffb6c2d0986d084c2f3eb50e1e433783d7281)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientation]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientation]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__490ef402f7317c57e63a986115d1c6be4307eda7e904bf9744aef2ccf1665d7d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__23d71193584476f242c7be210e50d0df7609c61f6b9eead42f3a654e64a65e39)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putLandscape")
    def put_landscape(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationLandscape()

        return typing.cast(None, jsii.invoke(self, "putLandscape", [value]))

    @jsii.member(jsii_name="putPortrait")
    def put_portrait(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationPortrait()

        return typing.cast(None, jsii.invoke(self, "putPortrait", [value]))

    @jsii.member(jsii_name="putSquare")
    def put_square(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationSquare()

        return typing.cast(None, jsii.invoke(self, "putSquare", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetLandscape")
    def reset_landscape(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLandscape", []))

    @jsii.member(jsii_name="resetPortrait")
    def reset_portrait(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPortrait", []))

    @jsii.member(jsii_name="resetSquare")
    def reset_square(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSquare", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="landscape")
    def landscape(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationLandscapeOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationLandscapeOutputReference, jsii.get(self, "landscape"))

    @builtins.property
    @jsii.member(jsii_name="portrait")
    def portrait(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationPortraitOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationPortraitOutputReference", jsii.get(self, "portrait"))

    @builtins.property
    @jsii.member(jsii_name="square")
    def square(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationSquareOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationSquareOutputReference", jsii.get(self, "square"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="landscapeInput")
    def landscape_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationLandscape], jsii.get(self, "landscapeInput"))

    @builtins.property
    @jsii.member(jsii_name="portraitInput")
    def portrait_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationPortrait"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationPortrait"], jsii.get(self, "portraitInput"))

    @builtins.property
    @jsii.member(jsii_name="squareInput")
    def square_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationSquare"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationSquare"], jsii.get(self, "squareInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientation]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientation]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientation]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d2a93b31560407d23b4f8049a6e4f77fb9c1a8b479e30236e38e9db4d7afdc68)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationPortrait",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationPortrait:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationPortrait(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationPortraitOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationPortraitOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab94eefaf0cb6eae794107c8b5e67b247cb44acee5b4053f824e8cda8281723d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationPortrait]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationPortrait], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationPortrait],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c47eb8a4dcb2762f16cbf499176fca9795e733c826cc884281325b61c26fb01f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationSquare",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationSquare:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationSquare(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationSquareOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationSquareOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__68f56990a7f58c3b6897b6969cffa4cc64df9e7b2e286ded9f086889f68c6f31)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationSquare]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationSquare], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationSquare],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8ea7c6929271c7c800994c600fc6d1c595e2cff48ef503853fd3e49ebf543b83)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitImQuery",
    jsii_struct_bases=[],
    name_mapping={
        "allowed_transformations": "allowedTransformations",
        "query_var": "queryVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitImQuery:
    def __init__(
        self,
        *,
        allowed_transformations: typing.Sequence[builtins.str],
        query_var: builtins.str,
    ) -> None:
        '''
        :param allowed_transformations: Specifies the transformations that can be applied using the query string parameter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allowed_transformations DataAkamaiImagingPolicyImage#allowed_transformations}
        :param query_var: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#query_var DataAkamaiImagingPolicyImage#query_var}.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e2bd47b6b03630ca980fd4e9d3dfe28842cd9c25473ddb0e8a6abfbbe0484f34)
            check_type(argname="argument allowed_transformations", value=allowed_transformations, expected_type=type_hints["allowed_transformations"])
            check_type(argname="argument query_var", value=query_var, expected_type=type_hints["query_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "allowed_transformations": allowed_transformations,
            "query_var": query_var,
        }

    @builtins.property
    def allowed_transformations(self) -> typing.List[builtins.str]:
        '''Specifies the transformations that can be applied using the query string parameter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allowed_transformations DataAkamaiImagingPolicyImage#allowed_transformations}
        '''
        result = self._values.get("allowed_transformations")
        assert result is not None, "Required property 'allowed_transformations' is missing"
        return typing.cast(typing.List[builtins.str], result)

    @builtins.property
    def query_var(self) -> builtins.str:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#query_var DataAkamaiImagingPolicyImage#query_var}.'''
        result = self._values.get("query_var")
        assert result is not None, "Required property 'query_var' is missing"
        return typing.cast(builtins.str, result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitImQuery(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitImQueryList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitImQueryList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__11f062c74adb01c389a78a07d6590b5341427ec3413e48fd7a77dcc8899a57f1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitImQueryOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d8c338221f6db00cad61ef49f6c2116a658a0a8295f69f81388a27294bab41dd)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitImQueryOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__da38c8155d78951c3144876438957ac6fddb34f6197d3aad15342c681f813384)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__176248ede06fc38f23e4ae600d0443038e240d3b53fd8e88b7077c5046133a90)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4c08ce561400208763862dbb77ca9b3155d2bd4c78dc732240ecd0de3bf1cdc3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitImQuery]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitImQuery]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitImQuery]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aab7ab198542f16868ed9c23dce92e66ca865a9089aa8dd61aafcd3863b4b9ad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitImQueryOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitImQueryOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4158dda7863dc3c5c175a2bdf0fb94ceeb51ea54e953a1c2dca09785ccc01675)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @builtins.property
    @jsii.member(jsii_name="allowedTransformationsInput")
    def allowed_transformations_input(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "allowedTransformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="queryVarInput")
    def query_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "queryVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowedTransformations")
    def allowed_transformations(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "allowedTransformations"))

    @allowed_transformations.setter
    def allowed_transformations(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b4aeaeebd3d67b4bbf389bd4de7fdefd2da16248b6bafa4a721c08608657e058)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowedTransformations", value)

    @builtins.property
    @jsii.member(jsii_name="queryVar")
    def query_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "queryVar"))

    @query_var.setter
    def query_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5a5dad7996dbed59bf18fccac1f10aec31222d0170f70472c1471ad2b7acc019)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "queryVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitImQuery]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitImQuery]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitImQuery]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f285a43177e74cc19c0ed4d02790986a75143c21fde3d0e26efbfda101e42be)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitMaxColors",
    jsii_struct_bases=[],
    name_mapping={"colors": "colors", "colors_var": "colorsVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitMaxColors:
    def __init__(
        self,
        *,
        colors: typing.Optional[builtins.str] = None,
        colors_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param colors: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        :param colors_var: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8e7806045196029619f61821f06534c2786698489daf34c90bcb8dbe62fb0ede)
            check_type(argname="argument colors", value=colors, expected_type=type_hints["colors"])
            check_type(argname="argument colors_var", value=colors_var, expected_type=type_hints["colors_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if colors is not None:
            self._values["colors"] = colors
        if colors_var is not None:
            self._values["colors_var"] = colors_var

    @builtins.property
    def colors(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        '''
        result = self._values.get("colors")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def colors_var(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        result = self._values.get("colors_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitMaxColors(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitMaxColorsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitMaxColorsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__023079d517ed2db0e5269bc14b8822f4736974961ee1b94f91fcb1505e44eb3c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitMaxColorsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c7d246394a5d4abc084fe7ac56d6a0e3de7d2a3b293d305eedef0595492ef68d)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitMaxColorsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__23a630e0879c1706d5d6d0fd99f04fbd40f78e8dda66d6d19a0a4c88ea518074)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__acdd2b03e8f1ce0034c5521e4833a9e86bbce6719541446839f5651b091f5cb7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3913cc837ef371d3d48d0cccceed7ef90e4bea365d33984b05752dd03b3951a7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitMaxColors]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitMaxColors]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d042b019443fad7faf8e78a173b72cf601d3dcc9d60dcd057c0f3e364b8d22a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitMaxColorsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitMaxColorsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f0e237a5d04fb8b7c0ba24a7a8ab8a9b4424a773dbcbeea0d97a80807d9c5365)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColors")
    def reset_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColors", []))

    @jsii.member(jsii_name="resetColorsVar")
    def reset_colors_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorsVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorsInput")
    def colors_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsInput"))

    @builtins.property
    @jsii.member(jsii_name="colorsVarInput")
    def colors_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsVarInput"))

    @builtins.property
    @jsii.member(jsii_name="colors")
    def colors(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colors"))

    @colors.setter
    def colors(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9dcd081f09f4adec367fc88c9ae9eda1162b9b7759ccaa3f0ed6d5edbff64f50)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colors", value)

    @builtins.property
    @jsii.member(jsii_name="colorsVar")
    def colors_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorsVar"))

    @colors_var.setter
    def colors_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4390be820d1af29a6cc09abef216766c976b466ed11e8025fafbdc8950f45ff8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorsVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitMaxColors]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitMaxColors]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitMaxColors]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5e819bf3b0d6d07d419e6e9a741a8316e8244d7576ea1679a24c38378bec5111)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitMirror",
    jsii_struct_bases=[],
    name_mapping={
        "horizontal": "horizontal",
        "horizontal_var": "horizontalVar",
        "vertical": "vertical",
        "vertical_var": "verticalVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitMirror:
    def __init__(
        self,
        *,
        horizontal: typing.Optional[builtins.str] = None,
        horizontal_var: typing.Optional[builtins.str] = None,
        vertical: typing.Optional[builtins.str] = None,
        vertical_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param horizontal: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        :param horizontal_var: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        :param vertical: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        :param vertical_var: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__570a5de552af53c202d32a1806404711b3d601b04a4e331ded61805d43151ab0)
            check_type(argname="argument horizontal", value=horizontal, expected_type=type_hints["horizontal"])
            check_type(argname="argument horizontal_var", value=horizontal_var, expected_type=type_hints["horizontal_var"])
            check_type(argname="argument vertical", value=vertical, expected_type=type_hints["vertical"])
            check_type(argname="argument vertical_var", value=vertical_var, expected_type=type_hints["vertical_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if horizontal is not None:
            self._values["horizontal"] = horizontal
        if horizontal_var is not None:
            self._values["horizontal_var"] = horizontal_var
        if vertical is not None:
            self._values["vertical"] = vertical
        if vertical_var is not None:
            self._values["vertical_var"] = vertical_var

    @builtins.property
    def horizontal(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        '''
        result = self._values.get("horizontal")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def horizontal_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        '''
        result = self._values.get("horizontal_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        '''
        result = self._values.get("vertical")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        result = self._values.get("vertical_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitMirror(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitMirrorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitMirrorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eb341bf81fd9ab3b4d4f1b2f510431ceb8264657d28dc4cc9d63223b44be1176)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitMirrorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a3eba197beff9f56c308f11da3301713f28b64a9c64641063633e4b89bf9e68b)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitMirrorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3b125aa67a907ac41ed1459fb23c60fdbff2db1f95afd26b642d868f4829beb9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__59f85aef02ece1217da3ab3fe93b1bf9ede82caa2141b80afa8590e64e618a9a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aa3718c421873ae5715e66d11594ba7ffaa35636b2ce2e6f2a7d9eb17bfe2a24)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitMirror]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitMirror]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__75e3ade37b1501b8da9f0d3b9972f6c8c564a39568aa431e9fc95408d5d1b5d4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitMirrorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitMirrorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b88d91dce046e98f8f51a19bf3dca42805fc50efd0dd54e88d9b64f12c4e5fa9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHorizontal")
    def reset_horizontal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontal", []))

    @jsii.member(jsii_name="resetHorizontalVar")
    def reset_horizontal_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontalVar", []))

    @jsii.member(jsii_name="resetVertical")
    def reset_vertical(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVertical", []))

    @jsii.member(jsii_name="resetVerticalVar")
    def reset_vertical_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVerticalVar", []))

    @builtins.property
    @jsii.member(jsii_name="horizontalInput")
    def horizontal_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontalVarInput")
    def horizontal_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalInput")
    def vertical_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalVarInput")
    def vertical_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontal")
    def horizontal(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontal"))

    @horizontal.setter
    def horizontal(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eb1e6f5a2866d439084616f2250c1139201444c862047523322876390d3a6a41)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontal", value)

    @builtins.property
    @jsii.member(jsii_name="horizontalVar")
    def horizontal_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontalVar"))

    @horizontal_var.setter
    def horizontal_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7f051ef3064e9aaaf7272e02c28b07e3133fcfaa7a650245ac4d0b13cc02d3ee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontalVar", value)

    @builtins.property
    @jsii.member(jsii_name="vertical")
    def vertical(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "vertical"))

    @vertical.setter
    def vertical(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e4af4362fc58baa7f8120fe4d0d08e15613a12c672cf4703b09f19fd3f9b4eda)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "vertical", value)

    @builtins.property
    @jsii.member(jsii_name="verticalVar")
    def vertical_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "verticalVar"))

    @vertical_var.setter
    def vertical_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__26fcaa0c2a02ac03ef21104e9dd2907d2d8a15f18db5868d7bb413a476a8b521)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "verticalVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitMirror]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitMirror]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitMirror]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bdde4aaf83af10d2a57bc87fb874149c735e17f69182ef3af15a432542cc5044)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitMonoHue",
    jsii_struct_bases=[],
    name_mapping={"hue": "hue", "hue_var": "hueVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitMonoHue:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__de1a6191b89679f814b99abe732d2188646a7c10bc1cfca2c3223f05a350bd79)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitMonoHue(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitMonoHueList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitMonoHueList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__31282eea8bbd0822af2fe28bc6569439d271da38752ea7dfcf4a28e9929e6908)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitMonoHueOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4de1b25d632ae3b93072a2951e9016977983ecab5d773dae095b1f2d7363ea5f)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitMonoHueOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b414c437a6ac695bb919b9e42c9dc0e8b9b79a1c70586908a3d4f7eaa2bcb264)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__58a201a3e539877c291d1050242ee4fcb37140edf08368143841ee31d4b5c270)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7da7628e5dbdbec674cd42f7dd5aacc5f9489a960a6bdaf646ba27cfc542cd15)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitMonoHue]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitMonoHue]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c5e6bc5a6c97d22b6ea6a2c45ddf0164978d29133dd175f31d000e8332c34bc3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitMonoHueOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitMonoHueOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__daab92f9e966d34344d7c970543be2451ea1a0deb360f4ef1962f5eab9bd4109)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9f1932e428214e3eceb930da7db3afae90546f3a75963de7dc1978a3161a6ce9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fb336dc3eda100e459a6d0dae4abfb69572c4028f86086206c787e33d0ac5b6a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitMonoHue]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitMonoHue]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitMonoHue]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__badaf237d114d03b253475e44b9232fe93af895c335ed0ce66f5409a6d531494)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitOpacity",
    jsii_struct_bases=[],
    name_mapping={"opacity": "opacity", "opacity_var": "opacityVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitOpacity:
    def __init__(
        self,
        *,
        opacity: typing.Optional[builtins.str] = None,
        opacity_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param opacity: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param opacity_var: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__969f12162f82bc8e690703d94ad360f1e4006b43444a4a108394dfd94c6c743d)
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument opacity_var", value=opacity_var, expected_type=type_hints["opacity_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if opacity is not None:
            self._values["opacity"] = opacity
        if opacity_var is not None:
            self._values["opacity_var"] = opacity_var

    @builtins.property
    def opacity(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def opacity_var(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        result = self._values.get("opacity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitOpacity(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitOpacityList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitOpacityList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ac09297e80275566738c5585ad5fbc271fc7b793f993b1cba1c7da43854c0da)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitOpacityOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8b00dc3428cf2aa37060c5dd229ac1b5af02ffa7d147c181c0054bd3727087d2)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitOpacityOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__615e6966053acc1a601c7c4a5845912700d2ad48d843df2e2e10573c2b191458)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4b0e281e71dbd14dcfd91d90dfd0db4667589fbf45212c4a37cd3dc18d3f5bbe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5567300d8d9f50c116c7257a91c2cdb27699752572e2c9cd5bb8a20911b51557)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitOpacity]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitOpacity]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a60e7c0b02e801996e0ac3525154b36cd03c8d39433a0a131ba4ca60e24212d9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitOpacityOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitOpacityOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8ed84e9ee606373060fa814a89d3eee184ce6c5e761e036d2bb34b7dc24542b7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetOpacityVar")
    def reset_opacity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacityVar", []))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityVarInput")
    def opacity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacity"))

    @opacity.setter
    def opacity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9399cb0d57599480233f306fa7c98548cb6f96af67822e6f8bc85acfdb678c28)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacity", value)

    @builtins.property
    @jsii.member(jsii_name="opacityVar")
    def opacity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacityVar"))

    @opacity_var.setter
    def opacity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5b99ba96650f7f89641204e07d7a102e4c91a756b994ff2422cec92790f62abe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacityVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitOpacity]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitOpacity]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitOpacity]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9272a0ee2d037981b078064a2062ecac16d30e9a4539c3b65452ef65b8c00827)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__783fc92c0f2c37bbcffb810f41e6cdf428ac17337f7daa986227921d62b35672)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putAppend")
    def put_append(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitAppend, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e9d807b206d046796569d6fc469a5a44381c6d48061bb8ea98208314b00d932d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putAppend", [value]))

    @jsii.member(jsii_name="putAspectCrop")
    def put_aspect_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitAspectCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4c26a83f7509a6a6135d3cf18dc56dddffdd04cc275d320cf753ad1e6c401fb8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putAspectCrop", [value]))

    @jsii.member(jsii_name="putBackgroundColor")
    def put_background_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__40c00dc13fd98f0f67a980315f130980319a70860f91553439ddaf900670fc03)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBackgroundColor", [value]))

    @jsii.member(jsii_name="putBlur")
    def put_blur(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitBlur, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e441af9f39e36010a484277bb3f8a1199e8cfbfdc73399bdc20cb6cead4a8336)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBlur", [value]))

    @jsii.member(jsii_name="putChromaKey")
    def put_chroma_key(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitChromaKey, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__016014b921d07248a1a298f86c5a570fb2ba7da2bd8bce01e02f0949b12aa6dd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putChromaKey", [value]))

    @jsii.member(jsii_name="putComposite")
    def put_composite(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitComposite, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c58bb160dca25df04c082401dbdef84f99af2a2c626719facc5ba3dae5103fb4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putComposite", [value]))

    @jsii.member(jsii_name="putCompound")
    def put_compound(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitCompound, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4092009504da9d9d2a7565bcbcc63defcbbd6d423c7828939ae18b78ac84ff7f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCompound", [value]))

    @jsii.member(jsii_name="putContrast")
    def put_contrast(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitContrast, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__da905cda11a2aab9aee33f88f0bc64d0c0f7648a69e66c5bfdf39360d4a2dc92)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putContrast", [value]))

    @jsii.member(jsii_name="putCrop")
    def put_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__26caf8186918202f34162f41d6d82a6f977126b8033c74602e42c767a725a1f7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCrop", [value]))

    @jsii.member(jsii_name="putFaceCrop")
    def put_face_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitFaceCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c7706f44effc55a3cafa02613308c14c5a2398e6142b221eda86ac46c8c3ab15)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFaceCrop", [value]))

    @jsii.member(jsii_name="putFeatureCrop")
    def put_feature_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitFeatureCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__97e49250c22bf8fbcc1c419a016d277733b4ce56735f417a80e2ba3c0d630b5e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFeatureCrop", [value]))

    @jsii.member(jsii_name="putFitAndFill")
    def put_fit_and_fill(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitFitAndFill, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__45f5187d12bf5edf6613105b140e201256b140e9a6f59b99db16fdba3ae6e068)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFitAndFill", [value]))

    @jsii.member(jsii_name="putGoop")
    def put_goop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitGoop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__722e18c605e51c9674e29243cb2d394481af226abb519fb736b3ee2aa64fce06)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGoop", [value]))

    @jsii.member(jsii_name="putGrayscale")
    def put_grayscale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitGrayscale, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__17ed5d2afb8321990518dd917926ed5443100180a8ec53fde29d1526024b796a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGrayscale", [value]))

    @jsii.member(jsii_name="putHsl")
    def put_hsl(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitHsl, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__78306cbd4c1702fbc2937482e830f4a000e160c62159fb5f2e0fb1e04fb01293)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsl", [value]))

    @jsii.member(jsii_name="putHsv")
    def put_hsv(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitHsv, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__58bc3b19a0b070d3d5cbfbbb3f1bb91a800326fecfce4233d5ab83a1db9aa02d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsv", [value]))

    @jsii.member(jsii_name="putIfDimension")
    def put_if_dimension(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimension, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__14fb6c785c558ad9a6a01d140deb0c8dc338338346f5c0fa04221b06c748987f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfDimension", [value]))

    @jsii.member(jsii_name="putIfOrientation")
    def put_if_orientation(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a5e0f25a7a445663618065a94a757c833231ec9dc0f36c10fad2e49b0fe76406)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfOrientation", [value]))

    @jsii.member(jsii_name="putImQuery")
    def put_im_query(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitImQuery, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__02165d0b6e0411436dff914950bb5b056215ef4b2157951136463698a7eb33dc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putImQuery", [value]))

    @jsii.member(jsii_name="putMaxColors")
    def put_max_colors(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitMaxColors, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d2e5bb186913ea6ebfbc290a65ca112c2e9bfd674b42ae7e6ecd022c12dd1b4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMaxColors", [value]))

    @jsii.member(jsii_name="putMirror")
    def put_mirror(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitMirror, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f6cf91dd2e7982daf45d563c4f44176b9c8e3eb3cbc3cbcee224251dd359630)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMirror", [value]))

    @jsii.member(jsii_name="putMonoHue")
    def put_mono_hue(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitMonoHue, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0bba76c960145afe8eea2eca438c2ed8b88e2cfed02469702c17411fc8d751c9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMonoHue", [value]))

    @jsii.member(jsii_name="putOpacity")
    def put_opacity(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitOpacity, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6177039df5dee773f992aa393d88689691b39086db8bd6655a504cbddf8cb52c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putOpacity", [value]))

    @jsii.member(jsii_name="putRegionOfInterestCrop")
    def put_region_of_interest_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitRegionOfInterestCrop", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__945b23839b4cb0ff3cc1742255081cf256c422604b34f2dffa14e0db16367d29)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRegionOfInterestCrop", [value]))

    @jsii.member(jsii_name="putRelativeCrop")
    def put_relative_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitRelativeCrop", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__845b41daea4c41e6a0d363f1501aa59627381c63689485752b39fcecec92b0d7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRelativeCrop", [value]))

    @jsii.member(jsii_name="putRemoveColor")
    def put_remove_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitRemoveColor", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__52a8019bb61014315ff7462c8f906c8fe6003b72207348f7e137a10d34b0c047)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRemoveColor", [value]))

    @jsii.member(jsii_name="putResize")
    def put_resize(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitResize", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__129bd5ab4aa65c85f12ded356453d1a4af5b623bb0aaebbb1964d727e01bea92)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putResize", [value]))

    @jsii.member(jsii_name="putRotate")
    def put_rotate(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitRotate", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__90dae658a3378e1424e33b43236d831cf4905126c60042a07197e9d8f6b978b9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRotate", [value]))

    @jsii.member(jsii_name="putScale")
    def put_scale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitScale", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__83085e7eceef76da550bf93edd26c7e3a22ec489533c67ddea64f8a00ef5df3f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putScale", [value]))

    @jsii.member(jsii_name="putShear")
    def put_shear(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitShear", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5c9decb74731587a618cd985d78e339d57b229ea9b6bb024d97db73f7bd5e74b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putShear", [value]))

    @jsii.member(jsii_name="putTrim")
    def put_trim(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitTrim", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6fc5e1bde11bfdf900dbbec2763515876df72cae7c05e24a46ef28c24db271cc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTrim", [value]))

    @jsii.member(jsii_name="putUnsharpMask")
    def put_unsharp_mask(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitUnsharpMask", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c2a4934213d4e4434cf3f94548f6d3f05b3b99286c6f706becb1bcdfd8cd54ec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putUnsharpMask", [value]))

    @jsii.member(jsii_name="resetAppend")
    def reset_append(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAppend", []))

    @jsii.member(jsii_name="resetAspectCrop")
    def reset_aspect_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspectCrop", []))

    @jsii.member(jsii_name="resetBackgroundColor")
    def reset_background_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBackgroundColor", []))

    @jsii.member(jsii_name="resetBlur")
    def reset_blur(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBlur", []))

    @jsii.member(jsii_name="resetChromaKey")
    def reset_chroma_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChromaKey", []))

    @jsii.member(jsii_name="resetComposite")
    def reset_composite(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetComposite", []))

    @jsii.member(jsii_name="resetCompound")
    def reset_compound(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCompound", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetCrop")
    def reset_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCrop", []))

    @jsii.member(jsii_name="resetFaceCrop")
    def reset_face_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFaceCrop", []))

    @jsii.member(jsii_name="resetFeatureCrop")
    def reset_feature_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureCrop", []))

    @jsii.member(jsii_name="resetFitAndFill")
    def reset_fit_and_fill(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFitAndFill", []))

    @jsii.member(jsii_name="resetGoop")
    def reset_goop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGoop", []))

    @jsii.member(jsii_name="resetGrayscale")
    def reset_grayscale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGrayscale", []))

    @jsii.member(jsii_name="resetHsl")
    def reset_hsl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsl", []))

    @jsii.member(jsii_name="resetHsv")
    def reset_hsv(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsv", []))

    @jsii.member(jsii_name="resetIfDimension")
    def reset_if_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfDimension", []))

    @jsii.member(jsii_name="resetIfOrientation")
    def reset_if_orientation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfOrientation", []))

    @jsii.member(jsii_name="resetImQuery")
    def reset_im_query(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetImQuery", []))

    @jsii.member(jsii_name="resetMaxColors")
    def reset_max_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxColors", []))

    @jsii.member(jsii_name="resetMirror")
    def reset_mirror(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMirror", []))

    @jsii.member(jsii_name="resetMonoHue")
    def reset_mono_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonoHue", []))

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetRegionOfInterestCrop")
    def reset_region_of_interest_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRegionOfInterestCrop", []))

    @jsii.member(jsii_name="resetRelativeCrop")
    def reset_relative_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRelativeCrop", []))

    @jsii.member(jsii_name="resetRemoveColor")
    def reset_remove_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRemoveColor", []))

    @jsii.member(jsii_name="resetResize")
    def reset_resize(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetResize", []))

    @jsii.member(jsii_name="resetRotate")
    def reset_rotate(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRotate", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetShear")
    def reset_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetShear", []))

    @jsii.member(jsii_name="resetTrim")
    def reset_trim(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTrim", []))

    @jsii.member(jsii_name="resetUnsharpMask")
    def reset_unsharp_mask(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUnsharpMask", []))

    @builtins.property
    @jsii.member(jsii_name="append")
    def append(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitAppendList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitAppendList, jsii.get(self, "append"))

    @builtins.property
    @jsii.member(jsii_name="aspectCrop")
    def aspect_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitAspectCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitAspectCropList, jsii.get(self, "aspectCrop"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColor")
    def background_color(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitBackgroundColorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitBackgroundColorList, jsii.get(self, "backgroundColor"))

    @builtins.property
    @jsii.member(jsii_name="blur")
    def blur(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitBlurList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitBlurList, jsii.get(self, "blur"))

    @builtins.property
    @jsii.member(jsii_name="chromaKey")
    def chroma_key(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitChromaKeyList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitChromaKeyList, jsii.get(self, "chromaKey"))

    @builtins.property
    @jsii.member(jsii_name="composite")
    def composite(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitCompositeList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitCompositeList, jsii.get(self, "composite"))

    @builtins.property
    @jsii.member(jsii_name="compound")
    def compound(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitCompoundList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitCompoundList, jsii.get(self, "compound"))

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitContrastList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitContrastList, jsii.get(self, "contrast"))

    @builtins.property
    @jsii.member(jsii_name="crop")
    def crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitCropList, jsii.get(self, "crop"))

    @builtins.property
    @jsii.member(jsii_name="faceCrop")
    def face_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitFaceCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitFaceCropList, jsii.get(self, "faceCrop"))

    @builtins.property
    @jsii.member(jsii_name="featureCrop")
    def feature_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitFeatureCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitFeatureCropList, jsii.get(self, "featureCrop"))

    @builtins.property
    @jsii.member(jsii_name="fitAndFill")
    def fit_and_fill(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitFitAndFillList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitFitAndFillList, jsii.get(self, "fitAndFill"))

    @builtins.property
    @jsii.member(jsii_name="goop")
    def goop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitGoopList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitGoopList, jsii.get(self, "goop"))

    @builtins.property
    @jsii.member(jsii_name="grayscale")
    def grayscale(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitGrayscaleList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitGrayscaleList, jsii.get(self, "grayscale"))

    @builtins.property
    @jsii.member(jsii_name="hsl")
    def hsl(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitHslList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitHslList, jsii.get(self, "hsl"))

    @builtins.property
    @jsii.member(jsii_name="hsv")
    def hsv(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitHsvList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitHsvList, jsii.get(self, "hsv"))

    @builtins.property
    @jsii.member(jsii_name="ifDimension")
    def if_dimension(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionList, jsii.get(self, "ifDimension"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientation")
    def if_orientation(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationList, jsii.get(self, "ifOrientation"))

    @builtins.property
    @jsii.member(jsii_name="imQuery")
    def im_query(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitImQueryList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitImQueryList, jsii.get(self, "imQuery"))

    @builtins.property
    @jsii.member(jsii_name="maxColors")
    def max_colors(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitMaxColorsList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitMaxColorsList, jsii.get(self, "maxColors"))

    @builtins.property
    @jsii.member(jsii_name="mirror")
    def mirror(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitMirrorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitMirrorList, jsii.get(self, "mirror"))

    @builtins.property
    @jsii.member(jsii_name="monoHue")
    def mono_hue(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitMonoHueList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitMonoHueList, jsii.get(self, "monoHue"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitOpacityList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitOpacityList, jsii.get(self, "opacity"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestCrop")
    def region_of_interest_crop(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitRegionOfInterestCropList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitRegionOfInterestCropList", jsii.get(self, "regionOfInterestCrop"))

    @builtins.property
    @jsii.member(jsii_name="relativeCrop")
    def relative_crop(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitRelativeCropList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitRelativeCropList", jsii.get(self, "relativeCrop"))

    @builtins.property
    @jsii.member(jsii_name="removeColor")
    def remove_color(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitRemoveColorList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitRemoveColorList", jsii.get(self, "removeColor"))

    @builtins.property
    @jsii.member(jsii_name="resize")
    def resize(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitResizeList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitResizeList", jsii.get(self, "resize"))

    @builtins.property
    @jsii.member(jsii_name="rotate")
    def rotate(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitRotateList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitRotateList", jsii.get(self, "rotate"))

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitScaleList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitScaleList", jsii.get(self, "scale"))

    @builtins.property
    @jsii.member(jsii_name="shear")
    def shear(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitShearList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitShearList", jsii.get(self, "shear"))

    @builtins.property
    @jsii.member(jsii_name="trim")
    def trim(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitTrimList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitTrimList", jsii.get(self, "trim"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMask")
    def unsharp_mask(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitUnsharpMaskList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitUnsharpMaskList", jsii.get(self, "unsharpMask"))

    @builtins.property
    @jsii.member(jsii_name="appendInput")
    def append_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitAppend]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitAppend]]], jsii.get(self, "appendInput"))

    @builtins.property
    @jsii.member(jsii_name="aspectCropInput")
    def aspect_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitAspectCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitAspectCrop]]], jsii.get(self, "aspectCropInput"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColorInput")
    def background_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitBackgroundColor]]], jsii.get(self, "backgroundColorInput"))

    @builtins.property
    @jsii.member(jsii_name="blurInput")
    def blur_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitBlur]]], jsii.get(self, "blurInput"))

    @builtins.property
    @jsii.member(jsii_name="chromaKeyInput")
    def chroma_key_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitChromaKey]]], jsii.get(self, "chromaKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="compositeInput")
    def composite_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitComposite]]], jsii.get(self, "compositeInput"))

    @builtins.property
    @jsii.member(jsii_name="compoundInput")
    def compound_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitCompound]]], jsii.get(self, "compoundInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitContrast]]], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="cropInput")
    def crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitCrop]]], jsii.get(self, "cropInput"))

    @builtins.property
    @jsii.member(jsii_name="faceCropInput")
    def face_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitFaceCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitFaceCrop]]], jsii.get(self, "faceCropInput"))

    @builtins.property
    @jsii.member(jsii_name="featureCropInput")
    def feature_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitFeatureCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitFeatureCrop]]], jsii.get(self, "featureCropInput"))

    @builtins.property
    @jsii.member(jsii_name="fitAndFillInput")
    def fit_and_fill_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitFitAndFill]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitFitAndFill]]], jsii.get(self, "fitAndFillInput"))

    @builtins.property
    @jsii.member(jsii_name="goopInput")
    def goop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitGoop]]], jsii.get(self, "goopInput"))

    @builtins.property
    @jsii.member(jsii_name="grayscaleInput")
    def grayscale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitGrayscale]]], jsii.get(self, "grayscaleInput"))

    @builtins.property
    @jsii.member(jsii_name="hslInput")
    def hsl_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitHsl]]], jsii.get(self, "hslInput"))

    @builtins.property
    @jsii.member(jsii_name="hsvInput")
    def hsv_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitHsv]]], jsii.get(self, "hsvInput"))

    @builtins.property
    @jsii.member(jsii_name="ifDimensionInput")
    def if_dimension_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimension]]], jsii.get(self, "ifDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientationInput")
    def if_orientation_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientation]]], jsii.get(self, "ifOrientationInput"))

    @builtins.property
    @jsii.member(jsii_name="imQueryInput")
    def im_query_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitImQuery]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitImQuery]]], jsii.get(self, "imQueryInput"))

    @builtins.property
    @jsii.member(jsii_name="maxColorsInput")
    def max_colors_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitMaxColors]]], jsii.get(self, "maxColorsInput"))

    @builtins.property
    @jsii.member(jsii_name="mirrorInput")
    def mirror_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitMirror]]], jsii.get(self, "mirrorInput"))

    @builtins.property
    @jsii.member(jsii_name="monoHueInput")
    def mono_hue_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitMonoHue]]], jsii.get(self, "monoHueInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitOpacity]]], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestCropInput")
    def region_of_interest_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitRegionOfInterestCrop"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitRegionOfInterestCrop"]]], jsii.get(self, "regionOfInterestCropInput"))

    @builtins.property
    @jsii.member(jsii_name="relativeCropInput")
    def relative_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitRelativeCrop"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitRelativeCrop"]]], jsii.get(self, "relativeCropInput"))

    @builtins.property
    @jsii.member(jsii_name="removeColorInput")
    def remove_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitRemoveColor"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitRemoveColor"]]], jsii.get(self, "removeColorInput"))

    @builtins.property
    @jsii.member(jsii_name="resizeInput")
    def resize_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitResize"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitResize"]]], jsii.get(self, "resizeInput"))

    @builtins.property
    @jsii.member(jsii_name="rotateInput")
    def rotate_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitRotate"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitRotate"]]], jsii.get(self, "rotateInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitScale"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitScale"]]], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="shearInput")
    def shear_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitShear"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitShear"]]], jsii.get(self, "shearInput"))

    @builtins.property
    @jsii.member(jsii_name="trimInput")
    def trim_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitTrim"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitTrim"]]], jsii.get(self, "trimInput"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMaskInput")
    def unsharp_mask_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitUnsharpMask"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitUnsharpMask"]]], jsii.get(self, "unsharpMaskInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortrait]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortrait], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortrait],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b50eaa5ad2383276b024b1feed276cf9ffe9a62d6e2f21a7f2b1528250103fd7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitRegionOfInterestCrop",
    jsii_struct_bases=[],
    name_mapping={
        "region_of_interest": "regionOfInterest",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitRegionOfInterestCrop:
    def __init__(
        self,
        *,
        region_of_interest: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitRegionOfInterestCropRegionOfInterest", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param region_of_interest: region_of_interest block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest DataAkamaiImagingPolicyImage#region_of_interest}
        :param gravity: The placement of the crop area relative to the specified area of interest. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: The placement of the crop area relative to the specified area of interest. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param style: Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(region_of_interest, dict):
            region_of_interest = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitRegionOfInterestCropRegionOfInterest(**region_of_interest)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ee06c232b97d9077dbeacac601313f4a0a1fbfbbe732f4b2a08928924cc9f280)
            check_type(argname="argument region_of_interest", value=region_of_interest, expected_type=type_hints["region_of_interest"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "region_of_interest": region_of_interest,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def region_of_interest(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitRegionOfInterestCropRegionOfInterest":
        '''region_of_interest block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest DataAkamaiImagingPolicyImage#region_of_interest}
        '''
        result = self._values.get("region_of_interest")
        assert result is not None, "Required property 'region_of_interest' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitRegionOfInterestCropRegionOfInterest", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''The placement of the crop area relative to the specified area of interest.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''The placement of the crop area relative to the specified area of interest.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitRegionOfInterestCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitRegionOfInterestCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitRegionOfInterestCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dbf81c42f5c67bf4e20615f3fb362ce9eadbcd3d8cfe637dad28efb34520f3ac)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitRegionOfInterestCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__44877a83f680c964ecd41bc6973f633dfd6bd7fd6279254745d6cb65099b2a38)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitRegionOfInterestCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e8a289aa4bf6a6236097b5522d2253a0ddd3bf384f177cc5f3b3ce72447c9ad5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d2c3391682e7aae1b69519fdfc748c404464ee50bd21d938b468587785ae64d7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fcbfda124f31f35f11eae93d310ddd86a2ba2b1e6bc70a894c7d6eb02c233a02)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitRegionOfInterestCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitRegionOfInterestCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitRegionOfInterestCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__59faf5a7eb8e203059843dd5f024c69f2370b3ef064ebcee082d9d2231b9d6f6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitRegionOfInterestCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitRegionOfInterestCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__488e12946a58f8aeb0749730dfc96f08fbc185f6df9956de4d03a2b9ce0eef0a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putRegionOfInterest")
    def put_region_of_interest(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitRegionOfInterestCropRegionOfInterest()

        return typing.cast(None, jsii.invoke(self, "putRegionOfInterest", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterest")
    def region_of_interest(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitRegionOfInterestCropRegionOfInterestOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitRegionOfInterestCropRegionOfInterestOutputReference", jsii.get(self, "regionOfInterest"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestInput")
    def region_of_interest_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitRegionOfInterestCropRegionOfInterest"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitRegionOfInterestCropRegionOfInterest"], jsii.get(self, "regionOfInterestInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d103046ec14b2bce0f9504e5856903d465c85af9b4d527ac4268193501a87c68)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__493d8fe4d0a0f3c18370c5e1ec607b207e363f824c069b36b99ca18ac0f023aa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9e0b432f3dd5e7af6358e5af104a91dd9c8dc3f8b0782178ca523ee159c83643)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c002c9f1104ed1b0def1e3754b1370cd25c0682758c975931dffe9c762de7a9a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d36769bda8a146d8815ad48270f9ba18b39126c4919576a2d80bc4923828a068)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bf66062a8748be21cb6a325319a6783099c79328ab8b02a7bccbedef64956354)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dcee0c459679e13e75df0da14c649a3d208b3f383c7f1750dbe4d5a608a1ee80)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5a5d2193a23fdeabf2cd36508790e6789db6f4dd085994ce16d2bc66b7e677e8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitRegionOfInterestCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitRegionOfInterestCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitRegionOfInterestCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__194f1f80b6f65fc7bea57271351b120db3072ef64d034e9ff9bf4ebffb4532eb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitRegionOfInterestCropRegionOfInterest",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitRegionOfInterestCropRegionOfInterest:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitRegionOfInterestCropRegionOfInterest(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitRegionOfInterestCropRegionOfInterestOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitRegionOfInterestCropRegionOfInterestOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ec7a09d1498dc725e4366879a8207db5f6104db01f3a4b57214bde67c8b49ea)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitRegionOfInterestCropRegionOfInterest]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitRegionOfInterestCropRegionOfInterest], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitRegionOfInterestCropRegionOfInterest],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__09d2b0e69b8e72fca486ea6563c05626b941034322089b958fbfd8d636f3124e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitRelativeCrop",
    jsii_struct_bases=[],
    name_mapping={
        "east": "east",
        "east_var": "eastVar",
        "north": "north",
        "north_var": "northVar",
        "south": "south",
        "south_var": "southVar",
        "west": "west",
        "west_var": "westVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitRelativeCrop:
    def __init__(
        self,
        *,
        east: typing.Optional[builtins.str] = None,
        east_var: typing.Optional[builtins.str] = None,
        north: typing.Optional[builtins.str] = None,
        north_var: typing.Optional[builtins.str] = None,
        south: typing.Optional[builtins.str] = None,
        south_var: typing.Optional[builtins.str] = None,
        west: typing.Optional[builtins.str] = None,
        west_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param east: The number of pixels to shrink or expand the right side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east DataAkamaiImagingPolicyImage#east}
        :param east_var: The number of pixels to shrink or expand the right side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east_var DataAkamaiImagingPolicyImage#east_var}
        :param north: The number of pixels to shrink or expand the top side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north DataAkamaiImagingPolicyImage#north}
        :param north_var: The number of pixels to shrink or expand the top side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north_var DataAkamaiImagingPolicyImage#north_var}
        :param south: The number of pixels to shrink or expand the bottom side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south DataAkamaiImagingPolicyImage#south}
        :param south_var: The number of pixels to shrink or expand the bottom side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south_var DataAkamaiImagingPolicyImage#south_var}
        :param west: The number of pixels to shrink or expand the left side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west DataAkamaiImagingPolicyImage#west}
        :param west_var: The number of pixels to shrink or expand the left side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west_var DataAkamaiImagingPolicyImage#west_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7261efb8bfb0258f2a3fbc390ec7729110a1b15ccd82f4134a0314f382b640f7)
            check_type(argname="argument east", value=east, expected_type=type_hints["east"])
            check_type(argname="argument east_var", value=east_var, expected_type=type_hints["east_var"])
            check_type(argname="argument north", value=north, expected_type=type_hints["north"])
            check_type(argname="argument north_var", value=north_var, expected_type=type_hints["north_var"])
            check_type(argname="argument south", value=south, expected_type=type_hints["south"])
            check_type(argname="argument south_var", value=south_var, expected_type=type_hints["south_var"])
            check_type(argname="argument west", value=west, expected_type=type_hints["west"])
            check_type(argname="argument west_var", value=west_var, expected_type=type_hints["west_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if east is not None:
            self._values["east"] = east
        if east_var is not None:
            self._values["east_var"] = east_var
        if north is not None:
            self._values["north"] = north
        if north_var is not None:
            self._values["north_var"] = north_var
        if south is not None:
            self._values["south"] = south
        if south_var is not None:
            self._values["south_var"] = south_var
        if west is not None:
            self._values["west"] = west
        if west_var is not None:
            self._values["west_var"] = west_var

    @builtins.property
    def east(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the right side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east DataAkamaiImagingPolicyImage#east}
        '''
        result = self._values.get("east")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def east_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the right side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east_var DataAkamaiImagingPolicyImage#east_var}
        '''
        result = self._values.get("east_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def north(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the top side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north DataAkamaiImagingPolicyImage#north}
        '''
        result = self._values.get("north")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def north_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the top side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north_var DataAkamaiImagingPolicyImage#north_var}
        '''
        result = self._values.get("north_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def south(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the bottom side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south DataAkamaiImagingPolicyImage#south}
        '''
        result = self._values.get("south")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def south_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the bottom side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south_var DataAkamaiImagingPolicyImage#south_var}
        '''
        result = self._values.get("south_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def west(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the left side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west DataAkamaiImagingPolicyImage#west}
        '''
        result = self._values.get("west")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def west_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the left side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west_var DataAkamaiImagingPolicyImage#west_var}
        '''
        result = self._values.get("west_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitRelativeCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitRelativeCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitRelativeCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fba07921f57d7b8f3a5310889e746cb2633b82d1ac86a5b9cac1b6006074a549)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitRelativeCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2bb4eed9401c0dcb047c8c66dd951f5bf888360f1598fe9c97aa840b1937a291)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitRelativeCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b8e9b646a1d6d32ca87f13b376dc8efd8c75ecce74192af5094841bf9359ac4b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__377bc3f9fb69876bf2bc8ab013dd6c5ac66a1b71901fc2d22e3f74eb670f60ba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__96d38154f77c8af9caa0265bf2fce01773e994523257237cdf843b7b030dc5bb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitRelativeCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitRelativeCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitRelativeCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d4f582884a72cd68a94f757bb31a85b885f8c8b8a43769b6e4f7e913c0651ce4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitRelativeCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitRelativeCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9802908726e986ce3bc271b273d7ac339c9950ff7d85a288b99393aaf606c25a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetEast")
    def reset_east(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEast", []))

    @jsii.member(jsii_name="resetEastVar")
    def reset_east_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEastVar", []))

    @jsii.member(jsii_name="resetNorth")
    def reset_north(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNorth", []))

    @jsii.member(jsii_name="resetNorthVar")
    def reset_north_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNorthVar", []))

    @jsii.member(jsii_name="resetSouth")
    def reset_south(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSouth", []))

    @jsii.member(jsii_name="resetSouthVar")
    def reset_south_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSouthVar", []))

    @jsii.member(jsii_name="resetWest")
    def reset_west(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWest", []))

    @jsii.member(jsii_name="resetWestVar")
    def reset_west_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWestVar", []))

    @builtins.property
    @jsii.member(jsii_name="eastInput")
    def east_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "eastInput"))

    @builtins.property
    @jsii.member(jsii_name="eastVarInput")
    def east_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "eastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="northInput")
    def north_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "northInput"))

    @builtins.property
    @jsii.member(jsii_name="northVarInput")
    def north_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "northVarInput"))

    @builtins.property
    @jsii.member(jsii_name="southInput")
    def south_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "southInput"))

    @builtins.property
    @jsii.member(jsii_name="southVarInput")
    def south_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "southVarInput"))

    @builtins.property
    @jsii.member(jsii_name="westInput")
    def west_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "westInput"))

    @builtins.property
    @jsii.member(jsii_name="westVarInput")
    def west_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "westVarInput"))

    @builtins.property
    @jsii.member(jsii_name="east")
    def east(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "east"))

    @east.setter
    def east(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d58e5192ba049183013e24d38f226751f92306ba691cf6a03ed0a40be0cfe28c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "east", value)

    @builtins.property
    @jsii.member(jsii_name="eastVar")
    def east_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "eastVar"))

    @east_var.setter
    def east_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f14c8c509ce5fe831d685a1df292818ab0fd9388c3d1372280888abdbb68b8dc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "eastVar", value)

    @builtins.property
    @jsii.member(jsii_name="north")
    def north(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "north"))

    @north.setter
    def north(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c8da8ddcb57f16deea7d0b7eed08451e654c0f33158b325527787b20871aa5ba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "north", value)

    @builtins.property
    @jsii.member(jsii_name="northVar")
    def north_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "northVar"))

    @north_var.setter
    def north_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4544d5eb0ca5dffb745ffce163c26d42d25477ea1eb2180423b51b66f4fb2800)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "northVar", value)

    @builtins.property
    @jsii.member(jsii_name="south")
    def south(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "south"))

    @south.setter
    def south(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__32f6ecbe474012d6b7cc1747aa18523caada0307d80975f8c914eebbcf5afbf2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "south", value)

    @builtins.property
    @jsii.member(jsii_name="southVar")
    def south_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "southVar"))

    @south_var.setter
    def south_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d5d4d972eb1073adc43e5649cc85db5e652f7e3b48545ec88bb61acdd0e8fc8d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "southVar", value)

    @builtins.property
    @jsii.member(jsii_name="west")
    def west(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "west"))

    @west.setter
    def west(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6063841afaf296d0c0d547fb85da56a9cf1d94c9d63a9ca3e500442323d3832c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "west", value)

    @builtins.property
    @jsii.member(jsii_name="westVar")
    def west_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "westVar"))

    @west_var.setter
    def west_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__44d4a82226d1959fcfa2c48c86675eab51b3b4375330a7f9d311fe1b191de2fc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "westVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitRelativeCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitRelativeCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitRelativeCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3fcb41e7e8be4cca9504754fdef9ef54a28b57cfcffe05a6fd2ffcc467d1daf9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitRemoveColor",
    jsii_struct_bases=[],
    name_mapping={
        "color": "color",
        "color_var": "colorVar",
        "feather": "feather",
        "feather_var": "featherVar",
        "tolerance": "tolerance",
        "tolerance_var": "toleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitRemoveColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
        feather: typing.Optional[builtins.str] = None,
        feather_var: typing.Optional[builtins.str] = None,
        tolerance: typing.Optional[builtins.str] = None,
        tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        :param feather: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        :param feather_var: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        :param tolerance: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        :param tolerance_var: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c9a071aec918e9e0925b7d9c6a343575a8c33d2ee8e1a9c62136d1439df09571)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
            check_type(argname="argument feather", value=feather, expected_type=type_hints["feather"])
            check_type(argname="argument feather_var", value=feather_var, expected_type=type_hints["feather_var"])
            check_type(argname="argument tolerance", value=tolerance, expected_type=type_hints["tolerance"])
            check_type(argname="argument tolerance_var", value=tolerance_var, expected_type=type_hints["tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var
        if feather is not None:
            self._values["feather"] = feather
        if feather_var is not None:
            self._values["feather_var"] = feather_var
        if tolerance is not None:
            self._values["tolerance"] = tolerance
        if tolerance_var is not None:
            self._values["tolerance_var"] = tolerance_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        '''
        result = self._values.get("feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather_var(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        '''
        result = self._values.get("feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        '''
        result = self._values.get("tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance_var(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        result = self._values.get("tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitRemoveColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitRemoveColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitRemoveColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__75aa66ec2d471fce89b55a533f9f9f717935aa082189e227dc05ff0b46deb340)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitRemoveColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__50571e852f46b20f46ed440b9c9e1c8a4d15d72ce3754843f1396a23ec77bed7)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitRemoveColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9981481e17e0f0f25dfc09123a33b805f443b1e9ed1a4c8e35756d1f1be2f3e8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fabc873c1d88c1e5c9d23c38a44928b5941156ea77654ebe4439b6af9cd6788d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a50f6aef31e98a62c28191dfb4c6f32bd3a22551313c30ea57aea7bf084f93d3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitRemoveColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitRemoveColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitRemoveColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b8ca257a26f2abaea8b1dfee6ec392ce1ca3fcf4d3a8bb39fa4e8a6fd896bcea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitRemoveColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitRemoveColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__daa69762cd7f6e8e51dc46e05b3e06a4b0afa2d92d8f20cfbccd44ff3ef49ea5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @jsii.member(jsii_name="resetFeather")
    def reset_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeather", []))

    @jsii.member(jsii_name="resetFeatherVar")
    def reset_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatherVar", []))

    @jsii.member(jsii_name="resetTolerance")
    def reset_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTolerance", []))

    @jsii.member(jsii_name="resetToleranceVar")
    def reset_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featherInput")
    def feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherInput"))

    @builtins.property
    @jsii.member(jsii_name="featherVarInput")
    def feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceInput")
    def tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceVarInput")
    def tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__05ef0ea20a8489b0935c363a368525032dc3d9865583ed806997e6f04592b2ad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a5775a3b75fc70434cd916f2ae45efec1151c26cdbfc82f10f9e2c4581c700db)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="feather")
    def feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "feather"))

    @feather.setter
    def feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f899b5f5b26c74e3137458c153fa7bab15a9863c95eacfc8e5f7a8b923cfc342)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "feather", value)

    @builtins.property
    @jsii.member(jsii_name="featherVar")
    def feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featherVar"))

    @feather_var.setter
    def feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7827b42c35b53e1980c4fbd3eddf24e3eb40884be55f384aad607fc0a50f2770)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featherVar", value)

    @builtins.property
    @jsii.member(jsii_name="tolerance")
    def tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tolerance"))

    @tolerance.setter
    def tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f7d040c51b37c57c497675485ac2777271bf4fa1fd40429f4ad1e801b7bb1d6f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tolerance", value)

    @builtins.property
    @jsii.member(jsii_name="toleranceVar")
    def tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "toleranceVar"))

    @tolerance_var.setter
    def tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ed9a45381f9bb3e7ec1d848a4fab54f408fbe30377015b3cf74ec4d2d2e718ea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "toleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitRemoveColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitRemoveColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitRemoveColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__72eadcef666a0df2a35f7cc92546e0f66dda21bb7a81b497007cb33617385879)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitResize",
    jsii_struct_bases=[],
    name_mapping={
        "aspect": "aspect",
        "aspect_var": "aspectVar",
        "height": "height",
        "height_var": "heightVar",
        "type": "type",
        "type_var": "typeVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitResize:
    def __init__(
        self,
        *,
        aspect: typing.Optional[builtins.str] = None,
        aspect_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param aspect: Preserves the aspect ratio. Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect DataAkamaiImagingPolicyImage#aspect}
        :param aspect_var: Preserves the aspect ratio. Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_var DataAkamaiImagingPolicyImage#aspect_var}
        :param height: The height to resize the source image to. Must be set if height is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height to resize the source image to. Must be set if height is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param type: Sets constraints for the image resize. Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: Sets constraints for the image resize. Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        :param width: The width to resize the source image to. Must be set if width is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width to resize the source image to. Must be set if width is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8f1e663bbb39d6a0724baacd4772ac1d48e13b7a3d1f1e7691ab176da899d8b0)
            check_type(argname="argument aspect", value=aspect, expected_type=type_hints["aspect"])
            check_type(argname="argument aspect_var", value=aspect_var, expected_type=type_hints["aspect_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if aspect is not None:
            self._values["aspect"] = aspect
        if aspect_var is not None:
            self._values["aspect_var"] = aspect_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def aspect(self) -> typing.Optional[builtins.str]:
        '''Preserves the aspect ratio.

        Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect DataAkamaiImagingPolicyImage#aspect}
        '''
        result = self._values.get("aspect")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def aspect_var(self) -> typing.Optional[builtins.str]:
        '''Preserves the aspect ratio.

        Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_var DataAkamaiImagingPolicyImage#aspect_var}
        '''
        result = self._values.get("aspect_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height to resize the source image to. Must be set if height is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height to resize the source image to. Must be set if height is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''Sets constraints for the image resize.

        Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''Sets constraints for the image resize.

        Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width to resize the source image to. Must be set if width is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width to resize the source image to. Must be set if width is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitResize(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitResizeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitResizeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fe43e2098b5aef6d4ab56c367ee206dabe2dfe09792ae8a2f07a28233bf3c14e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitResizeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5c27ae516ed5f47717c787f4771ccb3130dc7f5c3512b60b63fa26d801cae1fe)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitResizeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__317c7b35d8526f61d9464e74c42ff140ea8a20b5678df3d3c06541faf5a8dba8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4166d1f14e42dad9616425bbdfdae78810e5f713fc7d0ac0fa1fd785e0c09b35)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6bbd598376c7c9b5af52128d3e64353727c7e38e0e8fbd13ce68ca4b77edc0b5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitResize]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitResize]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitResize]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__422e66aea0ca43c5140c9136fc5c3e4c50a032a7b3af5f96a58469a43385a68f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitResizeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitResizeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__51926c299c90167184c7d15ff2494ee1ff4af0f00a5d7310e76abce40435e6b8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAspect")
    def reset_aspect(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspect", []))

    @jsii.member(jsii_name="resetAspectVar")
    def reset_aspect_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspectVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="aspectInput")
    def aspect_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "aspectInput"))

    @builtins.property
    @jsii.member(jsii_name="aspectVarInput")
    def aspect_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "aspectVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="aspect")
    def aspect(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "aspect"))

    @aspect.setter
    def aspect(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__93dedd8d5086b3b1d99ff3bb30af095f9136cc576f8abae6343a1f39428f2fd8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "aspect", value)

    @builtins.property
    @jsii.member(jsii_name="aspectVar")
    def aspect_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "aspectVar"))

    @aspect_var.setter
    def aspect_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3501fe459d8ed3532c599b26c40493022e281fb008750a1bdb1d151612129e6e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "aspectVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b3f4acc431e867d82d7acf470387a1d86283022f474a39881a4b33c464c89da7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d809eb76640b938586e940f397b9480b8197892bcd24937667200dc8fc9692b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5059ebff707cb4f6e705cacd9addf00a67b5d8828827913b3ca3313eee6a733b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__683dab9361a74d43d5ecbb1f8e5865006990ee7dcc2eb6c7d922cad6916c058d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cc4511f026712b0847fd5f7648488b59f846aab04035a070b84b2afe36f45e0a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b22009b96fdc081e7d344c85b9629d714a3cc54aa59b089ba1dd765d5d38f889)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitResize]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitResize]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitResize]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2b098d375d023b2d58e587c70f1eccc08b891fa37a0255f474ab4219e5f8c355)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitRotate",
    jsii_struct_bases=[],
    name_mapping={"degrees": "degrees", "degrees_var": "degreesVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitRotate:
    def __init__(
        self,
        *,
        degrees: typing.Optional[builtins.str] = None,
        degrees_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param degrees: The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees DataAkamaiImagingPolicyImage#degrees}
        :param degrees_var: The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees_var DataAkamaiImagingPolicyImage#degrees_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__91aeee15b8427f01209532a515bf972a598f41006c5c9bfd2a05ae03f8b06f7b)
            check_type(argname="argument degrees", value=degrees, expected_type=type_hints["degrees"])
            check_type(argname="argument degrees_var", value=degrees_var, expected_type=type_hints["degrees_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if degrees is not None:
            self._values["degrees"] = degrees
        if degrees_var is not None:
            self._values["degrees_var"] = degrees_var

    @builtins.property
    def degrees(self) -> typing.Optional[builtins.str]:
        '''The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees DataAkamaiImagingPolicyImage#degrees}
        '''
        result = self._values.get("degrees")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def degrees_var(self) -> typing.Optional[builtins.str]:
        '''The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees_var DataAkamaiImagingPolicyImage#degrees_var}
        '''
        result = self._values.get("degrees_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitRotate(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitRotateList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitRotateList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c7ba8c453553f7eda5404a89e3268de09edf2768176bea7198793ed2f44506aa)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitRotateOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bef0ee4f9f4de0a450a7eabea95ca68c63d070a2e6c4daa27f267c90f732353d)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitRotateOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1a15433a9d9c54c2b5b12a32188e8f24250e5609e82f8aba13d4c47cf53b7387)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ec97b1670a7ee69da86b6d27e47a1630aac7dcdbecfe934997a515cbeafbbe8c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0124340ab6179043459dd8830fbb4c4aec908f8c0271e52ccb15f4ee1686844c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitRotate]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitRotate]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitRotate]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e0247f4f4446ac3baf2f35658953c8093a2d894f3c4390ca2e5535e9d62744ab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitRotateOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitRotateOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8dc4b6a2b4f00bd85cbc9144804ee138f60f44d68563e6f5f0dfec038eb863b7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetDegrees")
    def reset_degrees(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDegrees", []))

    @jsii.member(jsii_name="resetDegreesVar")
    def reset_degrees_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDegreesVar", []))

    @builtins.property
    @jsii.member(jsii_name="degreesInput")
    def degrees_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "degreesInput"))

    @builtins.property
    @jsii.member(jsii_name="degreesVarInput")
    def degrees_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "degreesVarInput"))

    @builtins.property
    @jsii.member(jsii_name="degrees")
    def degrees(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "degrees"))

    @degrees.setter
    def degrees(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bcd24f0d79b243ac12a61049d3b9896ab45f9b61344aad102240421777623e6e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "degrees", value)

    @builtins.property
    @jsii.member(jsii_name="degreesVar")
    def degrees_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "degreesVar"))

    @degrees_var.setter
    def degrees_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bad275efa7fe6f949c357d6f35d0a4f836ca7031cc69f8752c3ecfbea93b32d5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "degreesVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitRotate]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitRotate]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitRotate]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0318dcfe0af0ede691281e7e161a10db1fc6f81b82d4c38c45d1896d8d0a7fe6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitScale",
    jsii_struct_bases=[],
    name_mapping={
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitScale:
    def __init__(
        self,
        *,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param height: Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged. Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged. Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b0d075f3855e686573075a7909ea9edfbf67061a89b735a67db3ee90c5f85aae)
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size.

        Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size.

        Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged.

        Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged.

        Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitScale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitScaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitScaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__30850251b2dc8e24c6abd95ad7f3d9c2519cb66e7c8551a431dc29391d6d0cf3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitScaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__28f3773eeb2c00e39d4a05d0326e2ab37e7a7ee2ab0bb4cb02249f3eb59c61a5)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitScaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8954f25488cb7f82841c06641b310a9858274fd7d1803261e9a456706e063e24)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c1a7c890586f32e893630140a3bb11200f733c3c05d56cc920981bf108ecd539)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f81e60bd0ab70dc0c1fe0f77cc947f011ec02d75045e87440e5e4a82b811e01f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitScale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitScale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitScale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4cb35c5c019dc5cd8da86ef96001e138a0bc29df7c8f8e8d70c21059c2c63450)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitScaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitScaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__94eeb567073de03211e0747331b94378883d91d4cd4c371891d4df581e70220c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5bcfc901ee7ddaed205aad1c4fb2beeff95b30ef52131541f083103eee77ebcd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__24e9139f2a8e975aab139452e21ef4b94701ca0cff3557da256c72c764b45ed5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c7ab2c7ae8798b9b3d0808daa5c25af0627d6b7378be7bbc0e92960cda2388a6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__333b0c6d1343d3c7e933f2737a10cf16fb58831eb08a7ce2ab3875fb78081f50)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitScale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitScale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitScale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bbf016ef0c6a7b5cad380b7f24f15c9949188cc169b46f50c8eb391fa39691b1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitShear",
    jsii_struct_bases=[],
    name_mapping={
        "x_shear": "xShear",
        "x_shear_var": "xShearVar",
        "y_shear": "yShear",
        "y_shear_var": "yShearVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitShear:
    def __init__(
        self,
        *,
        x_shear: typing.Optional[builtins.str] = None,
        x_shear_var: typing.Optional[builtins.str] = None,
        y_shear: typing.Optional[builtins.str] = None,
        y_shear_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param x_shear: The amount to shear along the x-axis, measured in multiples of the image's width. Must be set if yShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear DataAkamaiImagingPolicyImage#x_shear}
        :param x_shear_var: The amount to shear along the x-axis, measured in multiples of the image's width. Must be set if yShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear_var DataAkamaiImagingPolicyImage#x_shear_var}
        :param y_shear: The amount to shear along the y-axis, measured in multiples of the image's height. Must be set if xShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear DataAkamaiImagingPolicyImage#y_shear}
        :param y_shear_var: The amount to shear along the y-axis, measured in multiples of the image's height. Must be set if xShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear_var DataAkamaiImagingPolicyImage#y_shear_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4c2d892043363b79238c4d687cc684b7f329cec358c4714e260fc4c22ae6298d)
            check_type(argname="argument x_shear", value=x_shear, expected_type=type_hints["x_shear"])
            check_type(argname="argument x_shear_var", value=x_shear_var, expected_type=type_hints["x_shear_var"])
            check_type(argname="argument y_shear", value=y_shear, expected_type=type_hints["y_shear"])
            check_type(argname="argument y_shear_var", value=y_shear_var, expected_type=type_hints["y_shear_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if x_shear is not None:
            self._values["x_shear"] = x_shear
        if x_shear_var is not None:
            self._values["x_shear_var"] = x_shear_var
        if y_shear is not None:
            self._values["y_shear"] = y_shear
        if y_shear_var is not None:
            self._values["y_shear_var"] = y_shear_var

    @builtins.property
    def x_shear(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the x-axis, measured in multiples of the image's width.

        Must be set if yShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear DataAkamaiImagingPolicyImage#x_shear}
        '''
        result = self._values.get("x_shear")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_shear_var(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the x-axis, measured in multiples of the image's width.

        Must be set if yShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear_var DataAkamaiImagingPolicyImage#x_shear_var}
        '''
        result = self._values.get("x_shear_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_shear(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the y-axis, measured in multiples of the image's height.

        Must be set if xShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear DataAkamaiImagingPolicyImage#y_shear}
        '''
        result = self._values.get("y_shear")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_shear_var(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the y-axis, measured in multiples of the image's height.

        Must be set if xShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear_var DataAkamaiImagingPolicyImage#y_shear_var}
        '''
        result = self._values.get("y_shear_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitShear(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitShearList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitShearList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b1132d6d6d111550cf54ba5a930cd72d336fc0da2adb220c8b612facaa33b98a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitShearOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__72a4a7f1b9ddca74f23aa3f82f37cfc480a019681c6ae2faa33852f9c5b769a7)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitShearOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__70752ac7ef266da78303cd0c92f27690cdd1f3f502c205ab452ee5472c07c7c3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7fbe81587940127d765e8f3e1f30868efd98915e58c1be75818663aa2eabf115)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c8d65ae5269531cb030ffc0faabecb064ab34572e17729d294493ba4f3ef8781)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitShear]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitShear]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitShear]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d9a3ad58b55579be8957ebc497499f664ca9b71f5f3d889e287bf678442d9899)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitShearOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitShearOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__854e625b3d4fc5d78f1aff00f84be00d38e69d55d2a0758dc1678da15b880ad6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetXShear")
    def reset_x_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXShear", []))

    @jsii.member(jsii_name="resetXShearVar")
    def reset_x_shear_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXShearVar", []))

    @jsii.member(jsii_name="resetYShear")
    def reset_y_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYShear", []))

    @jsii.member(jsii_name="resetYShearVar")
    def reset_y_shear_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYShearVar", []))

    @builtins.property
    @jsii.member(jsii_name="xShearInput")
    def x_shear_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xShearInput"))

    @builtins.property
    @jsii.member(jsii_name="xShearVarInput")
    def x_shear_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xShearVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yShearInput")
    def y_shear_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yShearInput"))

    @builtins.property
    @jsii.member(jsii_name="yShearVarInput")
    def y_shear_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yShearVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xShear")
    def x_shear(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xShear"))

    @x_shear.setter
    def x_shear(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b9588a3782c9d9a2433f92b78c1e8e62cf4a154c9f097a09e11227936d229699)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xShear", value)

    @builtins.property
    @jsii.member(jsii_name="xShearVar")
    def x_shear_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xShearVar"))

    @x_shear_var.setter
    def x_shear_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6ef967bd011fff7fccc41cccf07036abbed2eef1a2921be0b791c96b7bd164a7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xShearVar", value)

    @builtins.property
    @jsii.member(jsii_name="yShear")
    def y_shear(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yShear"))

    @y_shear.setter
    def y_shear(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ad2752d5e12f3408210e4c350bafd535981b82c65ecbea43ec013e6f0461813b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yShear", value)

    @builtins.property
    @jsii.member(jsii_name="yShearVar")
    def y_shear_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yShearVar"))

    @y_shear_var.setter
    def y_shear_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ba573b4ba7798b090b509991997c11513e77d7e7802e08c5b7ed1938ea98635)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yShearVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitShear]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitShear]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitShear]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c1f472b34d5be5ef054f3018b3c4865581f159fc179bf429ca52cf06b34202f1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitTrim",
    jsii_struct_bases=[],
    name_mapping={
        "fuzz": "fuzz",
        "fuzz_var": "fuzzVar",
        "padding": "padding",
        "padding_var": "paddingVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitTrim:
    def __init__(
        self,
        *,
        fuzz: typing.Optional[builtins.str] = None,
        fuzz_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fuzz: The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz DataAkamaiImagingPolicyImage#fuzz}
        :param fuzz_var: The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz_var DataAkamaiImagingPolicyImage#fuzz_var}
        :param padding: The amount of padding in pixels to add to the trimmed image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: The amount of padding in pixels to add to the trimmed image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d9f35236fa5add893f41c4545adf5b5e22e76e8b188fe0429588b770146f9da6)
            check_type(argname="argument fuzz", value=fuzz, expected_type=type_hints["fuzz"])
            check_type(argname="argument fuzz_var", value=fuzz_var, expected_type=type_hints["fuzz_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fuzz is not None:
            self._values["fuzz"] = fuzz
        if fuzz_var is not None:
            self._values["fuzz_var"] = fuzz_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var

    @builtins.property
    def fuzz(self) -> typing.Optional[builtins.str]:
        '''The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz DataAkamaiImagingPolicyImage#fuzz}
        '''
        result = self._values.get("fuzz")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fuzz_var(self) -> typing.Optional[builtins.str]:
        '''The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz_var DataAkamaiImagingPolicyImage#fuzz_var}
        '''
        result = self._values.get("fuzz_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''The amount of padding in pixels to add to the trimmed image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''The amount of padding in pixels to add to the trimmed image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitTrim(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitTrimList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitTrimList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d6c0ec93b313f9205a22cfebea7f84388c33c626c4be4b2c4ee542990073b103)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitTrimOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__205c4063d0d83249c19e02fb9172f1e61d22d7de0525ab937376866d46a9da3e)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitTrimOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__17ff9c8c080df2b95e5a37a4ea8fd62814fff6a3e00126c9d72aab20b3b450b7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cf5e6e41d7f7e86fc89d55d891991a7f474db544a737686ce45719987079185b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__30f4ac6d90484fa1d5fd603fe8b6159e155e7c68922924ba9e38a899d62e8fd7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitTrim]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitTrim]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitTrim]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6b015b807b6e45de3705be3da1507a39e3ca46a20ad9fa0cdfd68d6ecacb5426)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitTrimOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitTrimOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__46fc1231a7e819526fad50651128250c660f2d19828a2b8786bd979ca340d824)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetFuzz")
    def reset_fuzz(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFuzz", []))

    @jsii.member(jsii_name="resetFuzzVar")
    def reset_fuzz_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFuzzVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @builtins.property
    @jsii.member(jsii_name="fuzzInput")
    def fuzz_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fuzzInput"))

    @builtins.property
    @jsii.member(jsii_name="fuzzVarInput")
    def fuzz_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fuzzVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="fuzz")
    def fuzz(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fuzz"))

    @fuzz.setter
    def fuzz(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2f4f211efeee01c2adcaa42e400a2b9c2d5fef3a6414f46087d044f73d23a8b5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fuzz", value)

    @builtins.property
    @jsii.member(jsii_name="fuzzVar")
    def fuzz_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fuzzVar"))

    @fuzz_var.setter
    def fuzz_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f863dd8512b0feb768ab893f5d7f3f5d2802bda001a727bd19a73b4c8f95a9f8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fuzzVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e1ee503ab34851273437856dae4c518925df47e2fdf01a7efa26fcd2ea7a0738)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d4882490a680ec26359c13a510b4e91d91a54e5eb4e5bc3588dbcc2fc7bc26b1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitTrim]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitTrim]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitTrim]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__67aac24f6f758706fe6d26dba4ffcf6331e6a5068712e91733ec9450efdc404d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitUnsharpMask",
    jsii_struct_bases=[],
    name_mapping={
        "gain": "gain",
        "gain_var": "gainVar",
        "sigma": "sigma",
        "sigma_var": "sigmaVar",
        "threshold": "threshold",
        "threshold_var": "thresholdVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitUnsharpMask:
    def __init__(
        self,
        *,
        gain: typing.Optional[builtins.str] = None,
        gain_var: typing.Optional[builtins.str] = None,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
        threshold: typing.Optional[builtins.str] = None,
        threshold_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param gain: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        :param gain_var: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        :param sigma: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        :param threshold: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        :param threshold_var: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__95961547e54a8892c37df456168435fc92f06fc7066f5758ae5cc526df0b09fb)
            check_type(argname="argument gain", value=gain, expected_type=type_hints["gain"])
            check_type(argname="argument gain_var", value=gain_var, expected_type=type_hints["gain_var"])
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
            check_type(argname="argument threshold", value=threshold, expected_type=type_hints["threshold"])
            check_type(argname="argument threshold_var", value=threshold_var, expected_type=type_hints["threshold_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if gain is not None:
            self._values["gain"] = gain
        if gain_var is not None:
            self._values["gain_var"] = gain_var
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var
        if threshold is not None:
            self._values["threshold"] = threshold
        if threshold_var is not None:
            self._values["threshold_var"] = threshold_var

    @builtins.property
    def gain(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        '''
        result = self._values.get("gain")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gain_var(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        '''
        result = self._values.get("gain_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        '''
        result = self._values.get("threshold")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold_var(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        result = self._values.get("threshold_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitUnsharpMask(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitUnsharpMaskList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitUnsharpMaskList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__796c0048c22504a936dd19deceb3e5c5a154c6cce8e0f3c5e1cee0714cdf9ee3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitUnsharpMaskOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f2412cd590916a68036b795498392e61c9b8712e5d9237a5d6e91ba3e66e5cb2)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitUnsharpMaskOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b0f86fd750bb27b390366655f3cc364ef33d137de84f4d91cbd42d12281d8cd4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8f746129753ea29985f333582853e8c1088ca459be03aa46bed41bf67f3e3c61)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d0a4a2d78b2fa6d130cfb4c60d254cbf99d11e67b135e6925e7c601004f140d9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitUnsharpMask]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitUnsharpMask]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitUnsharpMask]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7728fe050ee11a75c4db92283c5a3c35305a45e0875327f04abcd1344edc004c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitUnsharpMaskOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitUnsharpMaskOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eaa30540ec0ab1031288c2dfae3e0145b2b6773804691dff0be290464f6071aa)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetGain")
    def reset_gain(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGain", []))

    @jsii.member(jsii_name="resetGainVar")
    def reset_gain_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGainVar", []))

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @jsii.member(jsii_name="resetThreshold")
    def reset_threshold(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThreshold", []))

    @jsii.member(jsii_name="resetThresholdVar")
    def reset_threshold_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThresholdVar", []))

    @builtins.property
    @jsii.member(jsii_name="gainInput")
    def gain_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainInput"))

    @builtins.property
    @jsii.member(jsii_name="gainVarInput")
    def gain_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdInput")
    def threshold_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdVarInput")
    def threshold_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gain")
    def gain(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gain"))

    @gain.setter
    def gain(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6fe1f50397c04c1c2ee76d3f73e8d18ffab2d98a89fd9158fca3d0f0a745a3f3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gain", value)

    @builtins.property
    @jsii.member(jsii_name="gainVar")
    def gain_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gainVar"))

    @gain_var.setter
    def gain_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a4d694d5772b61e383bbf28de4c8402ccf4749cad314fd06697ee0a34d775617)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gainVar", value)

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9f0480607dc8dd35c4cb9254df373b5a38494f5aa9ec5ebaf1213449eb4070a2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__270d024f92a887a2d4e4bdd68e827812bca55eb5664669c63e4fb8f7b4a773af)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="threshold")
    def threshold(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "threshold"))

    @threshold.setter
    def threshold(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e50825751761b4da32f0fbeccaa3bee323cc9860996edd85c3aa4a6992c18cf8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "threshold", value)

    @builtins.property
    @jsii.member(jsii_name="thresholdVar")
    def threshold_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "thresholdVar"))

    @threshold_var.setter
    def threshold_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d00f13021ea6cee7103fa552712b9eafad7d50a8f7af9c00204c90f09f3619ad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "thresholdVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitUnsharpMask]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitUnsharpMask]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitUnsharpMask]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f6a4ee829c354bb9f81e435b40a9c9fe3a3a3002e97b425bb4104dbea40d032d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquare",
    jsii_struct_bases=[],
    name_mapping={
        "append": "append",
        "aspect_crop": "aspectCrop",
        "background_color": "backgroundColor",
        "blur": "blur",
        "chroma_key": "chromaKey",
        "composite": "composite",
        "compound": "compound",
        "contrast": "contrast",
        "crop": "crop",
        "face_crop": "faceCrop",
        "feature_crop": "featureCrop",
        "fit_and_fill": "fitAndFill",
        "goop": "goop",
        "grayscale": "grayscale",
        "hsl": "hsl",
        "hsv": "hsv",
        "if_dimension": "ifDimension",
        "if_orientation": "ifOrientation",
        "im_query": "imQuery",
        "max_colors": "maxColors",
        "mirror": "mirror",
        "mono_hue": "monoHue",
        "opacity": "opacity",
        "region_of_interest_crop": "regionOfInterestCrop",
        "relative_crop": "relativeCrop",
        "remove_color": "removeColor",
        "resize": "resize",
        "rotate": "rotate",
        "scale": "scale",
        "shear": "shear",
        "trim": "trim",
        "unsharp_mask": "unsharpMask",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquare:
    def __init__(
        self,
        *,
        append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareAppend", typing.Dict[builtins.str, typing.Any]]]]] = None,
        aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareAspectCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareBackgroundColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareBlur", typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareChromaKey", typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareComposite", typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareCompound", typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareContrast", typing.Dict[builtins.str, typing.Any]]]]] = None,
        crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareFaceCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareFeatureCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareFitAndFill", typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareGoop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareGrayscale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareHsl", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareHsv", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimension", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientation", typing.Dict[builtins.str, typing.Any]]]]] = None,
        im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareImQuery", typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareMaxColors", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareMirror", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareMonoHue", typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareOpacity", typing.Dict[builtins.str, typing.Any]]]]] = None,
        region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareRegionOfInterestCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareRelativeCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareRemoveColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareResize", typing.Dict[builtins.str, typing.Any]]]]] = None,
        rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareRotate", typing.Dict[builtins.str, typing.Any]]]]] = None,
        scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareScale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareShear", typing.Dict[builtins.str, typing.Any]]]]] = None,
        trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareTrim", typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareUnsharpMask", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param append: append block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        :param aspect_crop: aspect_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param crop: crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        :param face_crop: face_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        :param feature_crop: feature_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        :param fit_and_fill: fit_and_fill block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param im_query: im_query block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param region_of_interest_crop: region_of_interest_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        :param relative_crop: relative_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param resize: resize block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        :param rotate: rotate block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        :param scale: scale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param shear: shear block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        :param trim: trim block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1838eede7e270c91029971dd30a69df26771ac6446641dde0b49d529b99bcf37)
            check_type(argname="argument append", value=append, expected_type=type_hints["append"])
            check_type(argname="argument aspect_crop", value=aspect_crop, expected_type=type_hints["aspect_crop"])
            check_type(argname="argument background_color", value=background_color, expected_type=type_hints["background_color"])
            check_type(argname="argument blur", value=blur, expected_type=type_hints["blur"])
            check_type(argname="argument chroma_key", value=chroma_key, expected_type=type_hints["chroma_key"])
            check_type(argname="argument composite", value=composite, expected_type=type_hints["composite"])
            check_type(argname="argument compound", value=compound, expected_type=type_hints["compound"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument crop", value=crop, expected_type=type_hints["crop"])
            check_type(argname="argument face_crop", value=face_crop, expected_type=type_hints["face_crop"])
            check_type(argname="argument feature_crop", value=feature_crop, expected_type=type_hints["feature_crop"])
            check_type(argname="argument fit_and_fill", value=fit_and_fill, expected_type=type_hints["fit_and_fill"])
            check_type(argname="argument goop", value=goop, expected_type=type_hints["goop"])
            check_type(argname="argument grayscale", value=grayscale, expected_type=type_hints["grayscale"])
            check_type(argname="argument hsl", value=hsl, expected_type=type_hints["hsl"])
            check_type(argname="argument hsv", value=hsv, expected_type=type_hints["hsv"])
            check_type(argname="argument if_dimension", value=if_dimension, expected_type=type_hints["if_dimension"])
            check_type(argname="argument if_orientation", value=if_orientation, expected_type=type_hints["if_orientation"])
            check_type(argname="argument im_query", value=im_query, expected_type=type_hints["im_query"])
            check_type(argname="argument max_colors", value=max_colors, expected_type=type_hints["max_colors"])
            check_type(argname="argument mirror", value=mirror, expected_type=type_hints["mirror"])
            check_type(argname="argument mono_hue", value=mono_hue, expected_type=type_hints["mono_hue"])
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument region_of_interest_crop", value=region_of_interest_crop, expected_type=type_hints["region_of_interest_crop"])
            check_type(argname="argument relative_crop", value=relative_crop, expected_type=type_hints["relative_crop"])
            check_type(argname="argument remove_color", value=remove_color, expected_type=type_hints["remove_color"])
            check_type(argname="argument resize", value=resize, expected_type=type_hints["resize"])
            check_type(argname="argument rotate", value=rotate, expected_type=type_hints["rotate"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument shear", value=shear, expected_type=type_hints["shear"])
            check_type(argname="argument trim", value=trim, expected_type=type_hints["trim"])
            check_type(argname="argument unsharp_mask", value=unsharp_mask, expected_type=type_hints["unsharp_mask"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if append is not None:
            self._values["append"] = append
        if aspect_crop is not None:
            self._values["aspect_crop"] = aspect_crop
        if background_color is not None:
            self._values["background_color"] = background_color
        if blur is not None:
            self._values["blur"] = blur
        if chroma_key is not None:
            self._values["chroma_key"] = chroma_key
        if composite is not None:
            self._values["composite"] = composite
        if compound is not None:
            self._values["compound"] = compound
        if contrast is not None:
            self._values["contrast"] = contrast
        if crop is not None:
            self._values["crop"] = crop
        if face_crop is not None:
            self._values["face_crop"] = face_crop
        if feature_crop is not None:
            self._values["feature_crop"] = feature_crop
        if fit_and_fill is not None:
            self._values["fit_and_fill"] = fit_and_fill
        if goop is not None:
            self._values["goop"] = goop
        if grayscale is not None:
            self._values["grayscale"] = grayscale
        if hsl is not None:
            self._values["hsl"] = hsl
        if hsv is not None:
            self._values["hsv"] = hsv
        if if_dimension is not None:
            self._values["if_dimension"] = if_dimension
        if if_orientation is not None:
            self._values["if_orientation"] = if_orientation
        if im_query is not None:
            self._values["im_query"] = im_query
        if max_colors is not None:
            self._values["max_colors"] = max_colors
        if mirror is not None:
            self._values["mirror"] = mirror
        if mono_hue is not None:
            self._values["mono_hue"] = mono_hue
        if opacity is not None:
            self._values["opacity"] = opacity
        if region_of_interest_crop is not None:
            self._values["region_of_interest_crop"] = region_of_interest_crop
        if relative_crop is not None:
            self._values["relative_crop"] = relative_crop
        if remove_color is not None:
            self._values["remove_color"] = remove_color
        if resize is not None:
            self._values["resize"] = resize
        if rotate is not None:
            self._values["rotate"] = rotate
        if scale is not None:
            self._values["scale"] = scale
        if shear is not None:
            self._values["shear"] = shear
        if trim is not None:
            self._values["trim"] = trim
        if unsharp_mask is not None:
            self._values["unsharp_mask"] = unsharp_mask

    @builtins.property
    def append(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareAppend"]]]:
        '''append block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        '''
        result = self._values.get("append")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareAppend"]]], result)

    @builtins.property
    def aspect_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareAspectCrop"]]]:
        '''aspect_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        '''
        result = self._values.get("aspect_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareAspectCrop"]]], result)

    @builtins.property
    def background_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareBackgroundColor"]]]:
        '''background_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        '''
        result = self._values.get("background_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareBackgroundColor"]]], result)

    @builtins.property
    def blur(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareBlur"]]]:
        '''blur block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        '''
        result = self._values.get("blur")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareBlur"]]], result)

    @builtins.property
    def chroma_key(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareChromaKey"]]]:
        '''chroma_key block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        '''
        result = self._values.get("chroma_key")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareChromaKey"]]], result)

    @builtins.property
    def composite(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareComposite"]]]:
        '''composite block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        '''
        result = self._values.get("composite")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareComposite"]]], result)

    @builtins.property
    def compound(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareCompound"]]]:
        '''compound block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        '''
        result = self._values.get("compound")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareCompound"]]], result)

    @builtins.property
    def contrast(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareContrast"]]]:
        '''contrast block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareContrast"]]], result)

    @builtins.property
    def crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareCrop"]]]:
        '''crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        '''
        result = self._values.get("crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareCrop"]]], result)

    @builtins.property
    def face_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareFaceCrop"]]]:
        '''face_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        '''
        result = self._values.get("face_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareFaceCrop"]]], result)

    @builtins.property
    def feature_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareFeatureCrop"]]]:
        '''feature_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        '''
        result = self._values.get("feature_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareFeatureCrop"]]], result)

    @builtins.property
    def fit_and_fill(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareFitAndFill"]]]:
        '''fit_and_fill block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        '''
        result = self._values.get("fit_and_fill")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareFitAndFill"]]], result)

    @builtins.property
    def goop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareGoop"]]]:
        '''goop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        '''
        result = self._values.get("goop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareGoop"]]], result)

    @builtins.property
    def grayscale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareGrayscale"]]]:
        '''grayscale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        '''
        result = self._values.get("grayscale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareGrayscale"]]], result)

    @builtins.property
    def hsl(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareHsl"]]]:
        '''hsl block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        '''
        result = self._values.get("hsl")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareHsl"]]], result)

    @builtins.property
    def hsv(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareHsv"]]]:
        '''hsv block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        '''
        result = self._values.get("hsv")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareHsv"]]], result)

    @builtins.property
    def if_dimension(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimension"]]]:
        '''if_dimension block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        '''
        result = self._values.get("if_dimension")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimension"]]], result)

    @builtins.property
    def if_orientation(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientation"]]]:
        '''if_orientation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        '''
        result = self._values.get("if_orientation")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientation"]]], result)

    @builtins.property
    def im_query(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareImQuery"]]]:
        '''im_query block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        '''
        result = self._values.get("im_query")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareImQuery"]]], result)

    @builtins.property
    def max_colors(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareMaxColors"]]]:
        '''max_colors block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        '''
        result = self._values.get("max_colors")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareMaxColors"]]], result)

    @builtins.property
    def mirror(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareMirror"]]]:
        '''mirror block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        '''
        result = self._values.get("mirror")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareMirror"]]], result)

    @builtins.property
    def mono_hue(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareMonoHue"]]]:
        '''mono_hue block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        '''
        result = self._values.get("mono_hue")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareMonoHue"]]], result)

    @builtins.property
    def opacity(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareOpacity"]]]:
        '''opacity block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareOpacity"]]], result)

    @builtins.property
    def region_of_interest_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareRegionOfInterestCrop"]]]:
        '''region_of_interest_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        '''
        result = self._values.get("region_of_interest_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareRegionOfInterestCrop"]]], result)

    @builtins.property
    def relative_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareRelativeCrop"]]]:
        '''relative_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        '''
        result = self._values.get("relative_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareRelativeCrop"]]], result)

    @builtins.property
    def remove_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareRemoveColor"]]]:
        '''remove_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        '''
        result = self._values.get("remove_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareRemoveColor"]]], result)

    @builtins.property
    def resize(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareResize"]]]:
        '''resize block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        '''
        result = self._values.get("resize")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareResize"]]], result)

    @builtins.property
    def rotate(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareRotate"]]]:
        '''rotate block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        '''
        result = self._values.get("rotate")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareRotate"]]], result)

    @builtins.property
    def scale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareScale"]]]:
        '''scale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareScale"]]], result)

    @builtins.property
    def shear(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareShear"]]]:
        '''shear block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        '''
        result = self._values.get("shear")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareShear"]]], result)

    @builtins.property
    def trim(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareTrim"]]]:
        '''trim block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        '''
        result = self._values.get("trim")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareTrim"]]], result)

    @builtins.property
    def unsharp_mask(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareUnsharpMask"]]]:
        '''unsharp_mask block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        result = self._values.get("unsharp_mask")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareUnsharpMask"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquare(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareAppend",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_priority": "gravityPriority",
        "gravity_priority_var": "gravityPriorityVar",
        "gravity_var": "gravityVar",
        "preserve_minor_dimension": "preserveMinorDimension",
        "preserve_minor_dimension_var": "preserveMinorDimensionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareAppend:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareAppendImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_priority: typing.Optional[builtins.str] = None,
        gravity_priority_var: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        preserve_minor_dimension: typing.Optional[builtins.str] = None,
        preserve_minor_dimension_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Specifies where to place the ``image`` relative to the source image. The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_priority: Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal. The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority DataAkamaiImagingPolicyImage#gravity_priority}
        :param gravity_priority_var: Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal. The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority_var DataAkamaiImagingPolicyImage#gravity_priority_var}
        :param gravity_var: Specifies where to place the ``image`` relative to the source image. The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param preserve_minor_dimension: Whether to preserve the source image's minor dimension, ``false`` by default. The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension DataAkamaiImagingPolicyImage#preserve_minor_dimension}
        :param preserve_minor_dimension_var: Whether to preserve the source image's minor dimension, ``false`` by default. The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension_var DataAkamaiImagingPolicyImage#preserve_minor_dimension_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareAppendImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__39f60332b9b78816fa5245e8410c0da7520b22d5e40d4c7fb3a3f662008178c9)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_priority", value=gravity_priority, expected_type=type_hints["gravity_priority"])
            check_type(argname="argument gravity_priority_var", value=gravity_priority_var, expected_type=type_hints["gravity_priority_var"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument preserve_minor_dimension", value=preserve_minor_dimension, expected_type=type_hints["preserve_minor_dimension"])
            check_type(argname="argument preserve_minor_dimension_var", value=preserve_minor_dimension_var, expected_type=type_hints["preserve_minor_dimension_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_priority is not None:
            self._values["gravity_priority"] = gravity_priority
        if gravity_priority_var is not None:
            self._values["gravity_priority_var"] = gravity_priority_var
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if preserve_minor_dimension is not None:
            self._values["preserve_minor_dimension"] = preserve_minor_dimension
        if preserve_minor_dimension_var is not None:
            self._values["preserve_minor_dimension_var"] = preserve_minor_dimension_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareAppendImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareAppendImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Specifies where to place the ``image`` relative to the source image.

        The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_priority(self) -> typing.Optional[builtins.str]:
        '''Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal.

        The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority DataAkamaiImagingPolicyImage#gravity_priority}
        '''
        result = self._values.get("gravity_priority")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_priority_var(self) -> typing.Optional[builtins.str]:
        '''Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal.

        The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority_var DataAkamaiImagingPolicyImage#gravity_priority_var}
        '''
        result = self._values.get("gravity_priority_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Specifies where to place the ``image`` relative to the source image.

        The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def preserve_minor_dimension(self) -> typing.Optional[builtins.str]:
        '''Whether to preserve the source image's minor dimension, ``false`` by default.

        The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension DataAkamaiImagingPolicyImage#preserve_minor_dimension}
        '''
        result = self._values.get("preserve_minor_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def preserve_minor_dimension_var(self) -> typing.Optional[builtins.str]:
        '''Whether to preserve the source image's minor dimension, ``false`` by default.

        The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension_var DataAkamaiImagingPolicyImage#preserve_minor_dimension_var}
        '''
        result = self._values.get("preserve_minor_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareAppend(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareAppendImage",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareAppendImage:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareAppendImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareAppendImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareAppendImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__306cbccc8f8b88390ff5d4cbc86f489b85b7ae27c8cd1a27a7c8af2a1e8cfc17)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareAppendImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareAppendImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareAppendImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f9410434b04098d081d8fd97a5bc7b84ab84ef459721e73f0112ffb4740a4cf6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareAppendList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareAppendList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d6262faf5623e9a96d2e7d18281a5009f13fd95e87ea64140fdefea6966d95db)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareAppendOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a085ac02fa0ef85c6d24d3f3a353e3b9301040209bc595a641729682dd445276)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareAppendOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6b6ac708712cf4dfe7c3962fe639137c400b2b7dbd7c2b24e8d915a32a0571f3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0a6f7b7bac80ac7831868437b60d85306cbbb7d2b1003c52f082b76888e7bdc0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc040a92c013344dfe80fb8000af018bbffa3063b5d52f331d7bc17e01265090)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareAppend]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareAppend]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareAppend]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e420b780fdff2037ac9f170c29653cf6b295a73d7c3cb615b6fdcaffa4d07940)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareAppendOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareAppendOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ee1e7170e87663d9676ca2dce7b1e07f7cb6aad3d199184c64afaadde0630a67)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareAppendImage()

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityPriority")
    def reset_gravity_priority(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityPriority", []))

    @jsii.member(jsii_name="resetGravityPriorityVar")
    def reset_gravity_priority_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityPriorityVar", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPreserveMinorDimension")
    def reset_preserve_minor_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPreserveMinorDimension", []))

    @jsii.member(jsii_name="resetPreserveMinorDimensionVar")
    def reset_preserve_minor_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPreserveMinorDimensionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareAppendImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareAppendImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityInput")
    def gravity_priority_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityPriorityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityVarInput")
    def gravity_priority_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityPriorityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareAppendImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareAppendImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionInput")
    def preserve_minor_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "preserveMinorDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionVarInput")
    def preserve_minor_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "preserveMinorDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__166fa14d83441747d140b0bd9be32dd0e1f4730d89a5e1dc28ac7c1bcc1f0393)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityPriority")
    def gravity_priority(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityPriority"))

    @gravity_priority.setter
    def gravity_priority(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f5ad76bc78686cb43ae88f739b87c17ece0f29aebb01505b2fecc3c90feb5d0f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityPriority", value)

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityVar")
    def gravity_priority_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityPriorityVar"))

    @gravity_priority_var.setter
    def gravity_priority_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__087f5e9ee7fc9bda7697835e1b216e9d82f4b3e23f302ab6814a3d7a0b03770a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityPriorityVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__36978b3e934a435b756a0d54dba8670f60bfb63885a87a297579b5910b2da910)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimension")
    def preserve_minor_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "preserveMinorDimension"))

    @preserve_minor_dimension.setter
    def preserve_minor_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f0af7b42759cd7ef939ab99b79c593316f8bb07e130c522ad9a6cbc200e4d57b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "preserveMinorDimension", value)

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionVar")
    def preserve_minor_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "preserveMinorDimensionVar"))

    @preserve_minor_dimension_var.setter
    def preserve_minor_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0b7d6afa553a361060511b0417939696d12c16e5b7d4d1d1a919cc4eae83fbf9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "preserveMinorDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareAppend]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareAppend]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareAppend]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b4ef30d729e6a667d8ba5e63874d6ed4b9f027d0c20f728e5d0a4ace97446a05)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareAspectCrop",
    jsii_struct_bases=[],
    name_mapping={
        "allow_expansion": "allowExpansion",
        "allow_expansion_var": "allowExpansionVar",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareAspectCrop:
    def __init__(
        self,
        *,
        allow_expansion: typing.Optional[builtins.str] = None,
        allow_expansion_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_expansion: Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image. Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        :param allow_expansion_var: Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image. Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        :param height: The height term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The width term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        :param x_position: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7f8515621d8d8e12a0455f20b74f46dfa0783938a21c61a7dd1731d7c78da7a0)
            check_type(argname="argument allow_expansion", value=allow_expansion, expected_type=type_hints["allow_expansion"])
            check_type(argname="argument allow_expansion_var", value=allow_expansion_var, expected_type=type_hints["allow_expansion_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if allow_expansion is not None:
            self._values["allow_expansion"] = allow_expansion
        if allow_expansion_var is not None:
            self._values["allow_expansion_var"] = allow_expansion_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def allow_expansion(self) -> typing.Optional[builtins.str]:
        '''Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image.

        Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        '''
        result = self._values.get("allow_expansion")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def allow_expansion_var(self) -> typing.Optional[builtins.str]:
        '''Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image.

        Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        '''
        result = self._values.get("allow_expansion_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareAspectCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareAspectCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareAspectCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f638ded61eb481e984e831c0569b9b28de72fabf4c58bb2f983ea9ce358ee662)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareAspectCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0f6212c3df2e2adacb76cf58145102c7e24fb0ebc0fc89b490b0a2f363d7ede7)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareAspectCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__34d69da3586c1d5297a82fd8c0e54d92edfa5c8e66e79ce6a0337100128d3e55)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__04f5a9a60330089b774e1204c72dc2525735f1a7bfdcbeb7a6f742ab60f0632e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__479425c0e37ccdd43c7a225a89c711b638b2fab334e961ffc910a883c6a489fc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareAspectCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareAspectCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareAspectCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4fbff06afdc4e61caf1ef9808cad2cf094679cdafc4f20515f0c20704c640376)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareAspectCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareAspectCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b1f87dcb47c4dc137b3f44edb8bf01539b3398e02a528e9f0f45a312c5a1a714)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAllowExpansion")
    def reset_allow_expansion(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansion", []))

    @jsii.member(jsii_name="resetAllowExpansionVar")
    def reset_allow_expansion_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansionVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionInput")
    def allow_expansion_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVarInput")
    def allow_expansion_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansion")
    def allow_expansion(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansion"))

    @allow_expansion.setter
    def allow_expansion(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9236f8224fade5dc7e13dc1f8dc95ba702988d0966cc63234e584c2e59e4827d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansion", value)

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVar")
    def allow_expansion_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansionVar"))

    @allow_expansion_var.setter
    def allow_expansion_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cb5e8f8873450bfa2cd8b8282909c976108fec64c01f9d891d0f8fb4c89d8a92)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansionVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4416d05080df18769b534544636d0767c0eaa62a6967e93a0a624ec258b6e7d6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0bf2a27d5dd7a338d6e894730afa6768516def2ca168bdf10c25be86df4bd347)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__335133fabf2b3684da3da827a5126dba498442e1ecdfd3d6e7293b6ee86ee4fe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ec533a6bd00219ed54baa64806844d036a864238548a8e058cf47f3babb0ae61)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e635c71d02c7a02116a2789ac6a0b4552c8449bc1f5764fdfed638ff11a5f9fd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3d98880b9268ddb9fe5cb9fb298792ff54875e4600f4cf26377073de397bb7ca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0c6b955b2e8f79e4e0065bc3c6faf5714946994459782c7735eea6c396671507)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa877899c3f54b98af0c6bea77e9e4c0429eb2e7f33d2ce83e043c2d52cb0e69)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareAspectCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareAspectCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareAspectCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d6d40dcc5a747ffeaf7739016bb0bedbb762d408b4896f1155e2008ea165dc40)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareBackgroundColor",
    jsii_struct_bases=[],
    name_mapping={"color": "color", "color_var": "colorVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareBackgroundColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fbb3d9110d97f4a0a413c59fe925c49de757a6573b8cb046adeeaf9b8a4797d8)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareBackgroundColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareBackgroundColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareBackgroundColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f91b75a8aab13934d655c51813e15eb6ff2e226c207b1ee3523a6de989e3ff65)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareBackgroundColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e7d633ad6d44a464c0bc20b9f61de05ffcf9b19eb7b3b428a73622b39b9b7f12)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareBackgroundColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__745b9c7529d29fa893ab5580f64307fe19e2e67bec13cec43ea2918e751e52c4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3f2c3f33a338bffdbf1c61f511d269a0af1f6d7a6d4e384183f6b7779817e75e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__de2af25ed6f0adf40a1faacecbdd6fe2a0958df533e935ac688a596ea05aa348)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareBackgroundColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareBackgroundColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__827c7527030cfe43fba6afe97d5997996b093216cf6f2bba6d2d92ec400e44f5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareBackgroundColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareBackgroundColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ecc9825b7957f8b1be3919ba23558095fbd9179e92dfc15fd6de6396aa95a8d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac9f7fec18452cc39e6c2a591b2ece07670fab12ec4af22bd207d5a15150fe2c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dcd9f26ccc343b35e3d648fc46c0425754013723687992180ef0124afb78b590)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareBackgroundColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareBackgroundColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareBackgroundColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5e5be84fba7bff17f2ce339b0f4e31fcdcc5d9f042b9c43100cb975a0422d5a5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareBlur",
    jsii_struct_bases=[],
    name_mapping={"sigma": "sigma", "sigma_var": "sigmaVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareBlur:
    def __init__(
        self,
        *,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param sigma: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__903189e974791c345022c2a65d9f36437673a8581f8aa33934e800687b9e984b)
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareBlur(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareBlurList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareBlurList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7b320400b401320f65a76fb434139fc6fd67fe71161cb4e1f6fd054caac3c2a0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareBlurOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__44c9febbc0ec73f513bb3c8ea37368163a0438aad2a1119bd37c0487915cdac2)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareBlurOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8b71a529e6cc1afede850ab286fb1556411566f3dee546cfa5c535d3ad5407f4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d313aa0db73cd0ac6ad64d98044b7a1079d8763765084843d1a7e7ccf50c9f31)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__60c0d7c2ee470171ff3436f0bac05d7677f2dc8516fde03cc7edac7520d78757)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareBlur]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareBlur]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__86aa6beaf9dedec8c926312f8c6ea730d268d4727ab00c561ba27542570c33a3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareBlurOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareBlurOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7888085ba876a8423490792797efe75a483f273ea94d3ff78f2b261f9ca33966)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1dbb638d23e5d499e511d7e394a2c38aaac0d1d6d51a9fd8d71efbb5e8e4af4e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__20cb67017c66de39efd9904f8b9c646e24a8095168093ddcab6d91d47b8d33e8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareBlur]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareBlur]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareBlur]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f0c2dbfb58066b35fc63d63e6f81bb5a38f4efc4115644f71e59a60349aadb1f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareChromaKey",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_feather": "hueFeather",
        "hue_feather_var": "hueFeatherVar",
        "hue_tolerance": "hueTolerance",
        "hue_tolerance_var": "hueToleranceVar",
        "hue_var": "hueVar",
        "lightness_feather": "lightnessFeather",
        "lightness_feather_var": "lightnessFeatherVar",
        "lightness_tolerance": "lightnessTolerance",
        "lightness_tolerance_var": "lightnessToleranceVar",
        "saturation_feather": "saturationFeather",
        "saturation_feather_var": "saturationFeatherVar",
        "saturation_tolerance": "saturationTolerance",
        "saturation_tolerance_var": "saturationToleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareChromaKey:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_feather: typing.Optional[builtins.str] = None,
        hue_feather_var: typing.Optional[builtins.str] = None,
        hue_tolerance: typing.Optional[builtins.str] = None,
        hue_tolerance_var: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness_feather: typing.Optional[builtins.str] = None,
        lightness_feather_var: typing.Optional[builtins.str] = None,
        lightness_tolerance: typing.Optional[builtins.str] = None,
        lightness_tolerance_var: typing.Optional[builtins.str] = None,
        saturation_feather: typing.Optional[builtins.str] = None,
        saturation_feather_var: typing.Optional[builtins.str] = None,
        saturation_tolerance: typing.Optional[builtins.str] = None,
        saturation_tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_feather: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        :param hue_feather_var: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        :param hue_tolerance: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        :param hue_tolerance_var: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        :param hue_var: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness_feather: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        :param lightness_feather_var: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        :param lightness_tolerance: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        :param lightness_tolerance_var: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        :param saturation_feather: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        :param saturation_feather_var: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        :param saturation_tolerance: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        :param saturation_tolerance_var: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4264b3a88ee243b31ecc0ff59748be8e822449c254dc2ffa546d8e95d6812823)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_feather", value=hue_feather, expected_type=type_hints["hue_feather"])
            check_type(argname="argument hue_feather_var", value=hue_feather_var, expected_type=type_hints["hue_feather_var"])
            check_type(argname="argument hue_tolerance", value=hue_tolerance, expected_type=type_hints["hue_tolerance"])
            check_type(argname="argument hue_tolerance_var", value=hue_tolerance_var, expected_type=type_hints["hue_tolerance_var"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness_feather", value=lightness_feather, expected_type=type_hints["lightness_feather"])
            check_type(argname="argument lightness_feather_var", value=lightness_feather_var, expected_type=type_hints["lightness_feather_var"])
            check_type(argname="argument lightness_tolerance", value=lightness_tolerance, expected_type=type_hints["lightness_tolerance"])
            check_type(argname="argument lightness_tolerance_var", value=lightness_tolerance_var, expected_type=type_hints["lightness_tolerance_var"])
            check_type(argname="argument saturation_feather", value=saturation_feather, expected_type=type_hints["saturation_feather"])
            check_type(argname="argument saturation_feather_var", value=saturation_feather_var, expected_type=type_hints["saturation_feather_var"])
            check_type(argname="argument saturation_tolerance", value=saturation_tolerance, expected_type=type_hints["saturation_tolerance"])
            check_type(argname="argument saturation_tolerance_var", value=saturation_tolerance_var, expected_type=type_hints["saturation_tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_feather is not None:
            self._values["hue_feather"] = hue_feather
        if hue_feather_var is not None:
            self._values["hue_feather_var"] = hue_feather_var
        if hue_tolerance is not None:
            self._values["hue_tolerance"] = hue_tolerance
        if hue_tolerance_var is not None:
            self._values["hue_tolerance_var"] = hue_tolerance_var
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness_feather is not None:
            self._values["lightness_feather"] = lightness_feather
        if lightness_feather_var is not None:
            self._values["lightness_feather_var"] = lightness_feather_var
        if lightness_tolerance is not None:
            self._values["lightness_tolerance"] = lightness_tolerance
        if lightness_tolerance_var is not None:
            self._values["lightness_tolerance_var"] = lightness_tolerance_var
        if saturation_feather is not None:
            self._values["saturation_feather"] = saturation_feather
        if saturation_feather_var is not None:
            self._values["saturation_feather_var"] = saturation_feather_var
        if saturation_tolerance is not None:
            self._values["saturation_tolerance"] = saturation_tolerance
        if saturation_tolerance_var is not None:
            self._values["saturation_tolerance_var"] = saturation_tolerance_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        '''
        result = self._values.get("hue_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        '''
        result = self._values.get("hue_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        '''
        result = self._values.get("hue_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        '''
        result = self._values.get("hue_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        '''
        result = self._values.get("lightness_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        '''
        result = self._values.get("lightness_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        '''
        result = self._values.get("lightness_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        '''
        result = self._values.get("lightness_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        '''
        result = self._values.get("saturation_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        '''
        result = self._values.get("saturation_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        '''
        result = self._values.get("saturation_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        result = self._values.get("saturation_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareChromaKey(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareChromaKeyList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareChromaKeyList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__494c725af647fee358f282e009ed38650d0e2b1997cb971350c8311e81b07990)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareChromaKeyOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f08bd185d1c10404cf8ab31ee45ca2b6be13b6b3fc63059a09837edb6bdcdabd)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareChromaKeyOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__95f6ab321451271cca35970d13f9858b3b0d79347a58bf52cefc56209accad2a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d90e7f35f6ec22ae97bf584e9c529ba5ff6e6e7971abd116c68422c86060d3cd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6b6fdcf739d8ab2c6a833a41b3ab496f7b8a12cc33bf53da081e1ff2197d3f3b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareChromaKey]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareChromaKey]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f2121debf7edd6ec48d191db8b77efc64876b0d166c520c5ae8e4c03f484f094)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareChromaKeyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareChromaKeyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0275cb2511969e3e0fa5803d4f0fb99b5f81745224e6fc0671972aec7b77698f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueFeather")
    def reset_hue_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeather", []))

    @jsii.member(jsii_name="resetHueFeatherVar")
    def reset_hue_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeatherVar", []))

    @jsii.member(jsii_name="resetHueTolerance")
    def reset_hue_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueTolerance", []))

    @jsii.member(jsii_name="resetHueToleranceVar")
    def reset_hue_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueToleranceVar", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightnessFeather")
    def reset_lightness_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeather", []))

    @jsii.member(jsii_name="resetLightnessFeatherVar")
    def reset_lightness_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeatherVar", []))

    @jsii.member(jsii_name="resetLightnessTolerance")
    def reset_lightness_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessTolerance", []))

    @jsii.member(jsii_name="resetLightnessToleranceVar")
    def reset_lightness_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessToleranceVar", []))

    @jsii.member(jsii_name="resetSaturationFeather")
    def reset_saturation_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeather", []))

    @jsii.member(jsii_name="resetSaturationFeatherVar")
    def reset_saturation_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeatherVar", []))

    @jsii.member(jsii_name="resetSaturationTolerance")
    def reset_saturation_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationTolerance", []))

    @jsii.member(jsii_name="resetSaturationToleranceVar")
    def reset_saturation_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherInput")
    def hue_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVarInput")
    def hue_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceInput")
    def hue_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVarInput")
    def hue_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherInput")
    def lightness_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVarInput")
    def lightness_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceInput")
    def lightness_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVarInput")
    def lightness_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherInput")
    def saturation_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVarInput")
    def saturation_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceInput")
    def saturation_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVarInput")
    def saturation_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__13059e9c6b3a8113f17daab015a62f8a8fecb9e607c8bbbbab9fd767347280bb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeather")
    def hue_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeather"))

    @hue_feather.setter
    def hue_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a503e1bdbdc7f93c17638523e868b88435a032763bbe886ab04b26d1fda3ee0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeather", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVar")
    def hue_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeatherVar"))

    @hue_feather_var.setter
    def hue_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__13efea33be1539009353165db7cb86913f0a0c18e5f8811e64d87f6f8ffce1d3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueTolerance")
    def hue_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueTolerance"))

    @hue_tolerance.setter
    def hue_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__27d9cff27a3bb0a5d4ad2f3499b12a8b3bc9417f170490fde5aa459e04a1d5ba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVar")
    def hue_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueToleranceVar"))

    @hue_tolerance_var.setter
    def hue_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__24ab777745d1c247f24d338b8d2dabeee0ba7737392952a4c74a31195bc9ee30)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dcb1f96ac00cca46134325691b058816e800a9528131f2eccad08a339a9f8f9c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeather")
    def lightness_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeather"))

    @lightness_feather.setter
    def lightness_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__672cb339fd0aab33090b190d3d134918b39eaf8e1911fcbaecb5ba1e9ae61531)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeather", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVar")
    def lightness_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeatherVar"))

    @lightness_feather_var.setter
    def lightness_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__42ab3b886ec06f6db2ed2b8e48bc3d277c7067400f816c4024b8e2276a2aa1ec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessTolerance")
    def lightness_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessTolerance"))

    @lightness_tolerance.setter
    def lightness_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6b0fbb084124b706b611606836748b1fe6955dd6f255bb1b1d83ad944b57b730)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVar")
    def lightness_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessToleranceVar"))

    @lightness_tolerance_var.setter
    def lightness_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d85aff56dffeb67cda2b201fec0cdf9b139612d09a58466c9b5110beb776e573)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeather")
    def saturation_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeather"))

    @saturation_feather.setter
    def saturation_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d9e2e2f19e9a80251399c5b96849ecdeb4bd074422744d134d591a704568e84)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeather", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVar")
    def saturation_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeatherVar"))

    @saturation_feather_var.setter
    def saturation_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dd0e662715867cbea58a64264af8aadb43f35ed73742de985d3f65f3848ca996)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationTolerance")
    def saturation_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationTolerance"))

    @saturation_tolerance.setter
    def saturation_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f46af579221548852d4d319d2b6f9fba2b26ec3dc18885ef6d621a2e6459e480)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVar")
    def saturation_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationToleranceVar"))

    @saturation_tolerance_var.setter
    def saturation_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cae41c10ead469bfcb50a8963496f6be92d753afe28dead4ec8ee63df41a3995)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareChromaKey]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareChromaKey]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareChromaKey]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__88b483defb7952bd83f677f1cf919d5c77ab395334f17a16e9cbb100b2ba78aa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareComposite",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "placement": "placement",
        "placement_var": "placementVar",
        "scale": "scale",
        "scale_dimension": "scaleDimension",
        "scale_dimension_var": "scaleDimensionVar",
        "scale_var": "scaleVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareComposite:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareCompositeImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        placement: typing.Optional[builtins.str] = None,
        placement_var: typing.Optional[builtins.str] = None,
        scale: typing.Optional[builtins.str] = None,
        scale_dimension: typing.Optional[builtins.str] = None,
        scale_dimension_var: typing.Optional[builtins.str] = None,
        scale_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param placement: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        :param placement_var: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        :param scale: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param scale_dimension: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        :param scale_dimension_var: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        :param scale_var: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        :param x_position: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareCompositeImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a60a9eb9b7e4c4dffa3fd332a19e35404c7233a99970398fd4f7afdc9e0f45c)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument placement", value=placement, expected_type=type_hints["placement"])
            check_type(argname="argument placement_var", value=placement_var, expected_type=type_hints["placement_var"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument scale_dimension", value=scale_dimension, expected_type=type_hints["scale_dimension"])
            check_type(argname="argument scale_dimension_var", value=scale_dimension_var, expected_type=type_hints["scale_dimension_var"])
            check_type(argname="argument scale_var", value=scale_var, expected_type=type_hints["scale_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if placement is not None:
            self._values["placement"] = placement
        if placement_var is not None:
            self._values["placement_var"] = placement_var
        if scale is not None:
            self._values["scale"] = scale
        if scale_dimension is not None:
            self._values["scale_dimension"] = scale_dimension
        if scale_dimension_var is not None:
            self._values["scale_dimension_var"] = scale_dimension_var
        if scale_var is not None:
            self._values["scale_var"] = scale_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareCompositeImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareCompositeImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        '''
        result = self._values.get("placement")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement_var(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        '''
        result = self._values.get("placement_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        '''
        result = self._values.get("scale_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        '''
        result = self._values.get("scale_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        '''
        result = self._values.get("scale_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareComposite(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareCompositeImage",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareCompositeImage:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareCompositeImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareCompositeImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareCompositeImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d8698abbd28e19f8e029f67141cf0cfd824a969eedb118ebc880029a438ead58)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareCompositeImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareCompositeImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3da347eb976083f8ed3fd99b926bec93c8ca1fdd63061e97ba50058a3f5f8cae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareCompositeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareCompositeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab5195d8c9906094d192bd3b41813a560af97699d2e14ccbb4fb90a1738d3175)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareCompositeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__162f56097f0c3b49de06bfb7016af9961ccc6707dae31b09698f5f9259d741e9)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareCompositeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__004322b768eee5e9e6fbd2dc0ff3a2adc64924a67b56a5ffeeaea80bfbe4b0c0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3431225b2792c45265826a91c8c4f7d66c41f1c3543b057fcfd8f44f28518210)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__543e850f3216e0b22384e60974c323e1381d8e57c762fc95f429c31a21d2abe0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareComposite]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareComposite]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dafc644e14e7eeae021094a0554f90aa2f4fce47c034e648d842856d195097fa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareCompositeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareCompositeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__463ebac8373c64b83998691c12e5498b6ba85587956d754bed5aaf5ffea5bc40)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareCompositeImage()

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPlacement")
    def reset_placement(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacement", []))

    @jsii.member(jsii_name="resetPlacementVar")
    def reset_placement_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacementVar", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetScaleDimension")
    def reset_scale_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimension", []))

    @jsii.member(jsii_name="resetScaleDimensionVar")
    def reset_scale_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimensionVar", []))

    @jsii.member(jsii_name="resetScaleVar")
    def reset_scale_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareCompositeImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareCompositeImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareCompositeImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="placementInput")
    def placement_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementInput"))

    @builtins.property
    @jsii.member(jsii_name="placementVarInput")
    def placement_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionInput")
    def scale_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVarInput")
    def scale_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleVarInput")
    def scale_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a75be4e2a1cb2861ea0414d89301b0cf5194d57ca4e1723c64d1e4267a5d6bea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__999b799cd02eee253e8115f29bbdba04a128dff9a38c862d235e895c1b101aad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="placement")
    def placement(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placement"))

    @placement.setter
    def placement(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e29f8e0f906befcad143d8ae47151d1772019b95b97ffac4d7f875ac49419fd5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placement", value)

    @builtins.property
    @jsii.member(jsii_name="placementVar")
    def placement_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placementVar"))

    @placement_var.setter
    def placement_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f0bd1f4217341faec5843a914f320d0244868492fc6463def4f2455d2cb6db6c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placementVar", value)

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scale"))

    @scale.setter
    def scale(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1797bfe012df95985c0c2eb8864c84f32a8c70d7f6fed6d9fbce60297d1e33c2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scale", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimension")
    def scale_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimension"))

    @scale_dimension.setter
    def scale_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ace63100dcb5209841fba1c5425e68fae00967603a4eb9ff46dc11df75042234)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimension", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVar")
    def scale_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimensionVar"))

    @scale_dimension_var.setter
    def scale_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bd1736d898bffe3a1abd7a9143715768d113ad6d96aaa83fe596d304af64c711)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="scaleVar")
    def scale_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleVar"))

    @scale_var.setter
    def scale_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0d67e602c3f8ccf3bde1bd88daee5300d6ce55a8907dffc4db4d954782d82bdf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__288567d749898a73044305e32cd64f875a7d82e0bd867549a643e7070fe964c8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ac253a757f815ddaa59df3cc76d4bb7d0b39ff98b332e78f39d6b2eb307e384)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__75e59eecaa60c131ad2eab59de8c326119b97870f555ddf6b45de91eced6dfda)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e7d4711f2c7517eade6b9b999a30275786f60cfc719c6da6b9e6941bc020bcfc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareComposite]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareComposite]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareComposite]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__328f398519a674f1b1e3398c914fdfb84ec6aedbaf0920ac2e9dca74825f22bd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareCompound",
    jsii_struct_bases=[],
    name_mapping={"transformations": "transformations"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareCompound:
    def __init__(
        self,
        *,
        transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param transformations: transformations block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d93495432d716a7f8a81364505935db9a34507185ed5e312a57724acaa599042)
            check_type(argname="argument transformations", value=transformations, expected_type=type_hints["transformations"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if transformations is not None:
            self._values["transformations"] = transformations

    @builtins.property
    def transformations(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareCompoundTransformations"]]]:
        '''transformations block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        result = self._values.get("transformations")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareCompoundTransformations"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareCompound(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareCompoundList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareCompoundList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bf680c5bad912c006e7026d1cd013a0cfd47a2188dafb0c65e5334c50ed0e118)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareCompoundOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0a5c9c2b0ff947c5c2b4785b109e9a1a948b2382574e6d0f321adc4736b29957)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareCompoundOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d27d31d604a1d3c6face0bc38e78d652518e1c43dbad97da03755d7ac73ca161)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c18892cb737257e7740b401cab2173f84b5d858f291adc55816c0e869adf14d8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e87b13278edf8abfe86b23452eaabdca4b550edf5c1be00580f08784f73fd7c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareCompound]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareCompound]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__38b32fafaa2cf9996eaa7f93de0bdf6df8cd8e1366b6bdc3693712d212125957)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareCompoundOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareCompoundOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c124b3ca2e95afb20e1b92995b7edac5df9924405d4567809c0f3a9e8773cb12)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformations")
    def put_transformations(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__112ceae291bcbd5538fe62851c06d410e1d82b8bee7e54e2df13c9a792d09f0b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTransformations", [value]))

    @jsii.member(jsii_name="resetTransformations")
    def reset_transformations(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformations", []))

    @builtins.property
    @jsii.member(jsii_name="transformations")
    def transformations(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareCompoundTransformationsList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareCompoundTransformationsList", jsii.get(self, "transformations"))

    @builtins.property
    @jsii.member(jsii_name="transformationsInput")
    def transformations_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareCompoundTransformations"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareCompoundTransformations"]]], jsii.get(self, "transformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareCompound]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareCompound]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareCompound]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8b77121f09ebf3168798c3e462986ded13c524fc94de0478ef1f505c1eeb37ba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareCompoundTransformations",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareCompoundTransformations:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareCompoundTransformations(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareCompoundTransformationsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareCompoundTransformationsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__866f427dee67450015dd15a4de1881d4408ba2bed6aac257d7878c305553889d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareCompoundTransformationsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e66ed20d4441e36dce17110e83aa32c059998b34716c9d44ecce6a3e67809e2a)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareCompoundTransformationsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f51a7dd8a6ce8c2f979658f67f16748379f19fe1c412ebd3a7a3287646ced597)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ad5f153af76b633364d920ce95df58ce2bde34e65dd5c28d5d81c301d8a3596f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__644fa599af7f031303da87f619a4588f7c1ad8749e3f6c1a8421434ee477e428)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareCompoundTransformations]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareCompoundTransformations]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareCompoundTransformations]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f9c7a1f4550e4e7e9d8a5ec7277341addc54aa16100137abb5b8c4519a1b6d65)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareCompoundTransformationsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareCompoundTransformationsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4969bdea464f20eaf25b6a671b4c7a611df4c76d48ffecba2649c7cacfb23466)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareCompoundTransformations]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareCompoundTransformations]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareCompoundTransformations]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5e604278fef9fe837ed134c7c22623271e2276badd19d489c0610a8a42394deb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareContrast",
    jsii_struct_bases=[],
    name_mapping={
        "brightness": "brightness",
        "brightness_var": "brightnessVar",
        "contrast": "contrast",
        "contrast_var": "contrastVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareContrast:
    def __init__(
        self,
        *,
        brightness: typing.Optional[builtins.str] = None,
        brightness_var: typing.Optional[builtins.str] = None,
        contrast: typing.Optional[builtins.str] = None,
        contrast_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param brightness: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        :param brightness_var: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        :param contrast: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param contrast_var: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__19ad3321d736d2844fa941eae3075faa68eed39072ab650cf97e1d12c9585640)
            check_type(argname="argument brightness", value=brightness, expected_type=type_hints["brightness"])
            check_type(argname="argument brightness_var", value=brightness_var, expected_type=type_hints["brightness_var"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument contrast_var", value=contrast_var, expected_type=type_hints["contrast_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if brightness is not None:
            self._values["brightness"] = brightness
        if brightness_var is not None:
            self._values["brightness_var"] = brightness_var
        if contrast is not None:
            self._values["contrast"] = contrast
        if contrast_var is not None:
            self._values["contrast_var"] = contrast_var

    @builtins.property
    def brightness(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        '''
        result = self._values.get("brightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def brightness_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        '''
        result = self._values.get("brightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        result = self._values.get("contrast_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareContrast(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareContrastList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareContrastList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__260c6acd1270e2ddad0ce12a73cea85bccb664786d31fb6582451e5a0d851b33)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareContrastOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__12d3747296274df3039ceb2f0f26ef6ae89fbf1faf023fde20d3fdabbaca3328)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareContrastOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__41ab73e9f012c5dcba4b10426b7ad0b209053812a7c9c5ca5e79ff3a5766cee2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ad2f002e8e04c2e20444319bd8d908cd8173cde3679ce82895318fe39ba946e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cab12eb928e60054ba84bee4498732ecbcbf5c83b101d5242a7af8609cf1930a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareContrast]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareContrast]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6ea9f380522de30b391edfad0540361938633630dd614a008d93d9750621bc01)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareContrastOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareContrastOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9803ff48dfb1463952f6292c0785d354253af2be2f0f544eda72adb7617a3762)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetBrightness")
    def reset_brightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightness", []))

    @jsii.member(jsii_name="resetBrightnessVar")
    def reset_brightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightnessVar", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetContrastVar")
    def reset_contrast_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrastVar", []))

    @builtins.property
    @jsii.member(jsii_name="brightnessInput")
    def brightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="brightnessVarInput")
    def brightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastVarInput")
    def contrast_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="brightness")
    def brightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightness"))

    @brightness.setter
    def brightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0f5761dbe2a7773c7b998f4a144cc6e37d5678585b88c084d20553a4754283fd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightness", value)

    @builtins.property
    @jsii.member(jsii_name="brightnessVar")
    def brightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightnessVar"))

    @brightness_var.setter
    def brightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__21b7953524911ef1a45786450ba379e3ca69d283609d021bdcc41d6ff1810d2c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrast"))

    @contrast.setter
    def contrast(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__481b3525c61ffad442d22c919913b238161e62f8c2193012bb4754244131c041)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrast", value)

    @builtins.property
    @jsii.member(jsii_name="contrastVar")
    def contrast_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrastVar"))

    @contrast_var.setter
    def contrast_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6abe32b75adf8163ca81fc868dbe53c7b43a999373203ad0393b2e0eca81ec0a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrastVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareContrast]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareContrast]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareContrast]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e3bc02d26dfc2b2e05a70cfbd5fea26a2a865f6e4123d1064a629db3d2fc8786)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareCrop",
    jsii_struct_bases=[],
    name_mapping={
        "allow_expansion": "allowExpansion",
        "allow_expansion_var": "allowExpansionVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareCrop:
    def __init__(
        self,
        *,
        allow_expansion: typing.Optional[builtins.str] = None,
        allow_expansion_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_expansion: If cropping an area outside of the existing canvas, expands the image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        :param allow_expansion_var: If cropping an area outside of the existing canvas, expands the image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        :param gravity: Frame of reference for X and Y Positions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Frame of reference for X and Y Positions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The number of pixels to crop along the y-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The number of pixels to crop along the y-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The number of pixels to crop along the x-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The number of pixels to crop along the x-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        :param x_position: The x-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f4667173288f5da5cc7b94f8b88096ce61755640278207a42cf60eeb4cbc467)
            check_type(argname="argument allow_expansion", value=allow_expansion, expected_type=type_hints["allow_expansion"])
            check_type(argname="argument allow_expansion_var", value=allow_expansion_var, expected_type=type_hints["allow_expansion_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if allow_expansion is not None:
            self._values["allow_expansion"] = allow_expansion
        if allow_expansion_var is not None:
            self._values["allow_expansion_var"] = allow_expansion_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def allow_expansion(self) -> typing.Optional[builtins.str]:
        '''If cropping an area outside of the existing canvas, expands the image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        '''
        result = self._values.get("allow_expansion")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def allow_expansion_var(self) -> typing.Optional[builtins.str]:
        '''If cropping an area outside of the existing canvas, expands the image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        '''
        result = self._values.get("allow_expansion_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Frame of reference for X and Y Positions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Frame of reference for X and Y Positions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the y-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the y-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the x-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the x-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7dc1e6ec8f441f0e17bc0b6376ba0d18688c9ccb292c43a701a44dad3f546895)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b18e8e6fb9bd6a9a49f3b4170464c30416d923a39062350d0c7bfa728051c33b)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4540979a7270526be257b66b73fcafff0d6ee441b665a5b963060a68348af60d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9256a92a3270a74f1bf57cf025a9b8599e53018040fd6e780bfd41ac281aae68)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d289c5229b6a0d195efa28f06ea73b5599e3c869985ec08bd7521898bd1a1951)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7186b2a616bb3635c8ed65b62a8deb45bf4a6e2bc3611ae45494d96bd7d3daf9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__29059cda5f434195633bb60a391513aeec60050e05e6a5835ffdde00da5af1f2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAllowExpansion")
    def reset_allow_expansion(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansion", []))

    @jsii.member(jsii_name="resetAllowExpansionVar")
    def reset_allow_expansion_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansionVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionInput")
    def allow_expansion_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVarInput")
    def allow_expansion_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansion")
    def allow_expansion(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansion"))

    @allow_expansion.setter
    def allow_expansion(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__45c259b82ab5b88e981ccbe71632260f8086e5c4f5920959b18b4c7f23915248)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansion", value)

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVar")
    def allow_expansion_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansionVar"))

    @allow_expansion_var.setter
    def allow_expansion_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__edd82a6fb00c22f79e814e7f9eed5b9716054274719560307ee3ea2c26c7554a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansionVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c660b85cce91187b49acfdb12c5a3615d2fe34f2ec5c9b49398e14275f9c85d3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__77024307e312ff17750944201a8334ba094db7a5a41088653d0bda44bf2cb611)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4fe3faebf2b67381c7c5850c6941b97942150806703d579868c72bee9e261120)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__40c730e2ed27b1216d0c0762f8a6f7a13bc67c94a4ca1394075cd2a31e727759)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b75af24f7c51214ded8086abd199e6e2db13d1e4e59c53b0b7df0a1e33d72eec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4febf50f2db20da645ab9395d69e1a8dc2bdf322406ffef2137f20237a7874bd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ef9ce03cb772e62f7639b24abacd16b0e8fe584f6bc7096b7467b391cd0dd6df)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1c9f1ed2c73dd2a870156d2a56f4fce71199be830dd75142de41db40c89572a6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f0ef742ee94cf88499eafddf0fcbd69e3b794267e2e60ff5bca4a276301e629)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a5812b9de612c06588a83aa05e343bfc0d71d76dcf20c1d7275752c793e25149)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b79e224d40ddf8a4cf7ceef75e0435e8c89d6e45f1a319356462fac3d4ff5593)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareFaceCrop",
    jsii_struct_bases=[],
    name_mapping={
        "algorithm": "algorithm",
        "algorithm_var": "algorithmVar",
        "confidence": "confidence",
        "confidence_var": "confidenceVar",
        "fail_gravity": "failGravity",
        "fail_gravity_var": "failGravityVar",
        "focus": "focus",
        "focus_var": "focusVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "padding": "padding",
        "padding_var": "paddingVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareFaceCrop:
    def __init__(
        self,
        *,
        algorithm: typing.Optional[builtins.str] = None,
        algorithm_var: typing.Optional[builtins.str] = None,
        confidence: typing.Optional[builtins.str] = None,
        confidence_var: typing.Optional[builtins.str] = None,
        fail_gravity: typing.Optional[builtins.str] = None,
        fail_gravity_var: typing.Optional[builtins.str] = None,
        focus: typing.Optional[builtins.str] = None,
        focus_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param algorithm: Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm DataAkamaiImagingPolicyImage#algorithm}
        :param algorithm_var: Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm_var DataAkamaiImagingPolicyImage#algorithm_var}
        :param confidence: With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image. Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence DataAkamaiImagingPolicyImage#confidence}
        :param confidence_var: With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image. Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence_var DataAkamaiImagingPolicyImage#confidence_var}
        :param fail_gravity: Controls placement of the crop if Image and Video Manager does not detect any faces in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        :param fail_gravity_var: Controls placement of the crop if Image and Video Manager does not detect any faces in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        :param focus: Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus DataAkamaiImagingPolicyImage#focus}
        :param focus_var: Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus_var DataAkamaiImagingPolicyImage#focus_var}
        :param gravity: Controls placement of the crop. Directions are relative to the face(s) plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Controls placement of the crop. Directions are relative to the face(s) plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param padding: The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        :param style: Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d0640a5ea13314984f1925eb35e2ab3fd14ecff4d32c985d011c5a7ed5a69026)
            check_type(argname="argument algorithm", value=algorithm, expected_type=type_hints["algorithm"])
            check_type(argname="argument algorithm_var", value=algorithm_var, expected_type=type_hints["algorithm_var"])
            check_type(argname="argument confidence", value=confidence, expected_type=type_hints["confidence"])
            check_type(argname="argument confidence_var", value=confidence_var, expected_type=type_hints["confidence_var"])
            check_type(argname="argument fail_gravity", value=fail_gravity, expected_type=type_hints["fail_gravity"])
            check_type(argname="argument fail_gravity_var", value=fail_gravity_var, expected_type=type_hints["fail_gravity_var"])
            check_type(argname="argument focus", value=focus, expected_type=type_hints["focus"])
            check_type(argname="argument focus_var", value=focus_var, expected_type=type_hints["focus_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if algorithm is not None:
            self._values["algorithm"] = algorithm
        if algorithm_var is not None:
            self._values["algorithm_var"] = algorithm_var
        if confidence is not None:
            self._values["confidence"] = confidence
        if confidence_var is not None:
            self._values["confidence_var"] = confidence_var
        if fail_gravity is not None:
            self._values["fail_gravity"] = fail_gravity
        if fail_gravity_var is not None:
            self._values["fail_gravity_var"] = fail_gravity_var
        if focus is not None:
            self._values["focus"] = focus
        if focus_var is not None:
            self._values["focus_var"] = focus_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def algorithm(self) -> typing.Optional[builtins.str]:
        '''Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm DataAkamaiImagingPolicyImage#algorithm}
        '''
        result = self._values.get("algorithm")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def algorithm_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm_var DataAkamaiImagingPolicyImage#algorithm_var}
        '''
        result = self._values.get("algorithm_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def confidence(self) -> typing.Optional[builtins.str]:
        '''With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image.

        Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence DataAkamaiImagingPolicyImage#confidence}
        '''
        result = self._values.get("confidence")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def confidence_var(self) -> typing.Optional[builtins.str]:
        '''With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image.

        Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence_var DataAkamaiImagingPolicyImage#confidence_var}
        '''
        result = self._values.get("confidence_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any faces in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        '''
        result = self._values.get("fail_gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any faces in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        '''
        result = self._values.get("fail_gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def focus(self) -> typing.Optional[builtins.str]:
        '''Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus DataAkamaiImagingPolicyImage#focus}
        '''
        result = self._values.get("focus")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def focus_var(self) -> typing.Optional[builtins.str]:
        '''Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus_var DataAkamaiImagingPolicyImage#focus_var}
        '''
        result = self._values.get("focus_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the face(s) plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the face(s) plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareFaceCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareFaceCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareFaceCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7eeb5f2cd7cc81874db6feaa880d1e1d26c054c3dfdbcd4c34777e177b49d6ab)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareFaceCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7ca0d18772690834e3790e9304e1263daf5b76a56fa53d2a3a70ac69723064dd)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareFaceCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__890ef161671dab1d2276d5cc72c4cab5fc1761946966343ec648724eb58785a4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__13dee6e1e636b3a155deddaa2f4c29482986531f4b789cd46caaf2179f8dd471)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__027fcdc9b6a9c8ea8e798d6501e676b32fcdbf66c9537d22a550eb6e1c20dfa7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareFaceCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareFaceCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareFaceCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__10413e4363da4d2820643a76b5340f0b29dacd9922824ccc3cd8a0583054280c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareFaceCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareFaceCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8820abd331e659801f1486608f775bb0c924255e49198605a1082d2825a04927)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAlgorithm")
    def reset_algorithm(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAlgorithm", []))

    @jsii.member(jsii_name="resetAlgorithmVar")
    def reset_algorithm_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAlgorithmVar", []))

    @jsii.member(jsii_name="resetConfidence")
    def reset_confidence(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetConfidence", []))

    @jsii.member(jsii_name="resetConfidenceVar")
    def reset_confidence_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetConfidenceVar", []))

    @jsii.member(jsii_name="resetFailGravity")
    def reset_fail_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravity", []))

    @jsii.member(jsii_name="resetFailGravityVar")
    def reset_fail_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravityVar", []))

    @jsii.member(jsii_name="resetFocus")
    def reset_focus(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFocus", []))

    @jsii.member(jsii_name="resetFocusVar")
    def reset_focus_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFocusVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="algorithmInput")
    def algorithm_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "algorithmInput"))

    @builtins.property
    @jsii.member(jsii_name="algorithmVarInput")
    def algorithm_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "algorithmVarInput"))

    @builtins.property
    @jsii.member(jsii_name="confidenceInput")
    def confidence_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "confidenceInput"))

    @builtins.property
    @jsii.member(jsii_name="confidenceVarInput")
    def confidence_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "confidenceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityInput")
    def fail_gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityVarInput")
    def fail_gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="focusInput")
    def focus_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "focusInput"))

    @builtins.property
    @jsii.member(jsii_name="focusVarInput")
    def focus_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "focusVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="algorithm")
    def algorithm(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "algorithm"))

    @algorithm.setter
    def algorithm(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__353880c44a49507f62902e9d46e0e226769896c38130e49397944d5eca658f1e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "algorithm", value)

    @builtins.property
    @jsii.member(jsii_name="algorithmVar")
    def algorithm_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "algorithmVar"))

    @algorithm_var.setter
    def algorithm_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__17d5c6a84a657f181d251728a099b337b0f9281061cd4198b8b5be971d7e45a7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "algorithmVar", value)

    @builtins.property
    @jsii.member(jsii_name="confidence")
    def confidence(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "confidence"))

    @confidence.setter
    def confidence(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__92b4d472f9f96bdc636db4a6eb75e70c2d80071c7ac01c738aee1eb4e7e83b05)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "confidence", value)

    @builtins.property
    @jsii.member(jsii_name="confidenceVar")
    def confidence_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "confidenceVar"))

    @confidence_var.setter
    def confidence_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__17e3bf038d3bb407b4463d9f35650191cbd1fe3ae04b6d605a81a307accefbf7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "confidenceVar", value)

    @builtins.property
    @jsii.member(jsii_name="failGravity")
    def fail_gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravity"))

    @fail_gravity.setter
    def fail_gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b7d071ad52f5d352ad23d69967409c851bda70abaf7793668a0bba6e1975598b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravity", value)

    @builtins.property
    @jsii.member(jsii_name="failGravityVar")
    def fail_gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravityVar"))

    @fail_gravity_var.setter
    def fail_gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bd68b90e57236d5035e73938a6aec962f9d294d809fcbbdd40494eb250a4c91a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="focus")
    def focus(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "focus"))

    @focus.setter
    def focus(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__894ec54a87bdf3408c0b069ce505049f88177296d25a6b2fc5afc7e10ab544c4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "focus", value)

    @builtins.property
    @jsii.member(jsii_name="focusVar")
    def focus_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "focusVar"))

    @focus_var.setter
    def focus_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__61a5c2898f2c7a7d3ba6172fb6caee208f8f135c1e3a875fe05c7aff1f3150ea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "focusVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__294039c7821fdfb2104662cc0efb8a88573e2a73319eff1f409b54d3b804a3c0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d7e8fc9d5884a24b255ef94c33e498d3bca027f52f8e7f65694e72cf75221e38)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e3b7944c3bcffc322c64966717ea8ecbec9ec9e945d7f6c8cc7c58f6144d28f1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2e1e58d8b8a3bfe08c7c90cebfeb3f993f871ea5a21e9bf402dea85634cc3391)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__70e783cf721e71230b1eb1f101285355e7eb9e8f274af4bd161bdbd6d1f7a9ae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa7100456f0e8c4e3bd7e54705ac5bf96dd1d76c9489b7d40c9d931795036150)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__de13284bbe1f5a75a87709db91a4762ed67ff38444ff7b4223e828f1fda8ea5e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__70bfa48b3d5f055c0c120e3160e8feb2420baaa4b2660f8113aaeae6c5ac9388)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9b3b8674301449d33d497cf4214ab72ab646e2f592798e2eb8620f837da965d4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cb39ae9f85df74e362d27297db18d6efaf2c9d5d73bcd1660eb7fa55584baec3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareFaceCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareFaceCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareFaceCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c458113b56e361220bcdc934b2ea89845f863b39351fcc72f09fce344b20bfd1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareFeatureCrop",
    jsii_struct_bases=[],
    name_mapping={
        "fail_gravity": "failGravity",
        "fail_gravity_var": "failGravityVar",
        "feature_radius": "featureRadius",
        "feature_radius_var": "featureRadiusVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "max_features": "maxFeatures",
        "max_features_var": "maxFeaturesVar",
        "min_feature_quality": "minFeatureQuality",
        "min_feature_quality_var": "minFeatureQualityVar",
        "padding": "padding",
        "padding_var": "paddingVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareFeatureCrop:
    def __init__(
        self,
        *,
        fail_gravity: typing.Optional[builtins.str] = None,
        fail_gravity_var: typing.Optional[builtins.str] = None,
        feature_radius: typing.Optional[builtins.str] = None,
        feature_radius_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        max_features: typing.Optional[builtins.str] = None,
        max_features_var: typing.Optional[builtins.str] = None,
        min_feature_quality: typing.Optional[builtins.str] = None,
        min_feature_quality_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fail_gravity: Controls placement of the crop if Image and Video Manager does not detect any features in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        :param fail_gravity_var: Controls placement of the crop if Image and Video Manager does not detect any features in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        :param feature_radius: The size in pixels of the important features to search for. If identified, two features never appear closer together than this value, ``8.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius DataAkamaiImagingPolicyImage#feature_radius}
        :param feature_radius_var: The size in pixels of the important features to search for. If identified, two features never appear closer together than this value, ``8.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius_var DataAkamaiImagingPolicyImage#feature_radius_var}
        :param gravity: Controls placement of the crop. Directions are relative to the region of interest plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Controls placement of the crop. Directions are relative to the region of interest plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param max_features: The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features DataAkamaiImagingPolicyImage#max_features}
        :param max_features_var: The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features_var DataAkamaiImagingPolicyImage#max_features_var}
        :param min_feature_quality: Determines the minimum quality level of the feature identified. To consider a feature important, the feature needs to surpass this value. Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality DataAkamaiImagingPolicyImage#min_feature_quality}
        :param min_feature_quality_var: Determines the minimum quality level of the feature identified. To consider a feature important, the feature needs to surpass this value. Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality_var DataAkamaiImagingPolicyImage#min_feature_quality_var}
        :param padding: Adds space around the region of interest. The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: Adds space around the region of interest. The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        :param style: Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__675ccc036b8ad299c2c7652176788ccb828d71f4f08fc5869e5a8aa78bf70e2f)
            check_type(argname="argument fail_gravity", value=fail_gravity, expected_type=type_hints["fail_gravity"])
            check_type(argname="argument fail_gravity_var", value=fail_gravity_var, expected_type=type_hints["fail_gravity_var"])
            check_type(argname="argument feature_radius", value=feature_radius, expected_type=type_hints["feature_radius"])
            check_type(argname="argument feature_radius_var", value=feature_radius_var, expected_type=type_hints["feature_radius_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument max_features", value=max_features, expected_type=type_hints["max_features"])
            check_type(argname="argument max_features_var", value=max_features_var, expected_type=type_hints["max_features_var"])
            check_type(argname="argument min_feature_quality", value=min_feature_quality, expected_type=type_hints["min_feature_quality"])
            check_type(argname="argument min_feature_quality_var", value=min_feature_quality_var, expected_type=type_hints["min_feature_quality_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fail_gravity is not None:
            self._values["fail_gravity"] = fail_gravity
        if fail_gravity_var is not None:
            self._values["fail_gravity_var"] = fail_gravity_var
        if feature_radius is not None:
            self._values["feature_radius"] = feature_radius
        if feature_radius_var is not None:
            self._values["feature_radius_var"] = feature_radius_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if max_features is not None:
            self._values["max_features"] = max_features
        if max_features_var is not None:
            self._values["max_features_var"] = max_features_var
        if min_feature_quality is not None:
            self._values["min_feature_quality"] = min_feature_quality
        if min_feature_quality_var is not None:
            self._values["min_feature_quality_var"] = min_feature_quality_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def fail_gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any features in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        '''
        result = self._values.get("fail_gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any features in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        '''
        result = self._values.get("fail_gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feature_radius(self) -> typing.Optional[builtins.str]:
        '''The size in pixels of the important features to search for.

        If identified, two features never appear closer together than this value, ``8.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius DataAkamaiImagingPolicyImage#feature_radius}
        '''
        result = self._values.get("feature_radius")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feature_radius_var(self) -> typing.Optional[builtins.str]:
        '''The size in pixels of the important features to search for.

        If identified, two features never appear closer together than this value, ``8.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius_var DataAkamaiImagingPolicyImage#feature_radius_var}
        '''
        result = self._values.get("feature_radius_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the region of interest plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the region of interest plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def max_features(self) -> typing.Optional[builtins.str]:
        '''The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features DataAkamaiImagingPolicyImage#max_features}
        '''
        result = self._values.get("max_features")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def max_features_var(self) -> typing.Optional[builtins.str]:
        '''The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features_var DataAkamaiImagingPolicyImage#max_features_var}
        '''
        result = self._values.get("max_features_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def min_feature_quality(self) -> typing.Optional[builtins.str]:
        '''Determines the minimum quality level of the feature identified.

        To consider a feature important, the feature needs to surpass this value.  Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality DataAkamaiImagingPolicyImage#min_feature_quality}
        '''
        result = self._values.get("min_feature_quality")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def min_feature_quality_var(self) -> typing.Optional[builtins.str]:
        '''Determines the minimum quality level of the feature identified.

        To consider a feature important, the feature needs to surpass this value.  Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality_var DataAkamaiImagingPolicyImage#min_feature_quality_var}
        '''
        result = self._values.get("min_feature_quality_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''Adds space around the region of interest.

        The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''Adds space around the region of interest.

        The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareFeatureCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareFeatureCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareFeatureCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5fa9899fc11b41de925af9b7ab2e18a07f4eb7fd82ba64bcd420e184e0feb05d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareFeatureCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fb186533bb675f25b74efcc1843bf559a37c226b4e49a7d122b7ee5056991e60)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareFeatureCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__85bd08977243c67c1fb5e23bc5f664441189e37d674084a252c69f6905ea1305)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4d021924b70f2e08782fb1921e49bd402855dad136b07714bbf90169413d59ff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__72d15031e0666560ddaf09fa749120d3ad6db411aaa3c58dc82780932e22a5f9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareFeatureCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareFeatureCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareFeatureCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7ddfc18174b2e505b819e3fe9a9cb806c65ae3310cf0d246da6459a5aab10c2f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareFeatureCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareFeatureCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9694528d6e7f08343ddf7d11bebba24eebc61a7061fb2a6a65d5dd791876de32)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetFailGravity")
    def reset_fail_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravity", []))

    @jsii.member(jsii_name="resetFailGravityVar")
    def reset_fail_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravityVar", []))

    @jsii.member(jsii_name="resetFeatureRadius")
    def reset_feature_radius(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureRadius", []))

    @jsii.member(jsii_name="resetFeatureRadiusVar")
    def reset_feature_radius_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureRadiusVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetMaxFeatures")
    def reset_max_features(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxFeatures", []))

    @jsii.member(jsii_name="resetMaxFeaturesVar")
    def reset_max_features_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxFeaturesVar", []))

    @jsii.member(jsii_name="resetMinFeatureQuality")
    def reset_min_feature_quality(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMinFeatureQuality", []))

    @jsii.member(jsii_name="resetMinFeatureQualityVar")
    def reset_min_feature_quality_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMinFeatureQualityVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="failGravityInput")
    def fail_gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityVarInput")
    def fail_gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featureRadiusInput")
    def feature_radius_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featureRadiusInput"))

    @builtins.property
    @jsii.member(jsii_name="featureRadiusVarInput")
    def feature_radius_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featureRadiusVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesInput")
    def max_features_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "maxFeaturesInput"))

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesVarInput")
    def max_features_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "maxFeaturesVarInput"))

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityInput")
    def min_feature_quality_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "minFeatureQualityInput"))

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityVarInput")
    def min_feature_quality_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "minFeatureQualityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravity")
    def fail_gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravity"))

    @fail_gravity.setter
    def fail_gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b59773781f85e12b0b8242db529374a9cb45376aae64496ba389706083f4337d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravity", value)

    @builtins.property
    @jsii.member(jsii_name="failGravityVar")
    def fail_gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravityVar"))

    @fail_gravity_var.setter
    def fail_gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a778bd98202c7c77c35da905a9235221ed57aa8d892609c0f36d107070deb454)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="featureRadius")
    def feature_radius(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featureRadius"))

    @feature_radius.setter
    def feature_radius(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__608fd81a14304f5a72f9f894f409439b9a3aec73d762bfbf98775d866a700788)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featureRadius", value)

    @builtins.property
    @jsii.member(jsii_name="featureRadiusVar")
    def feature_radius_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featureRadiusVar"))

    @feature_radius_var.setter
    def feature_radius_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e47e9eef1d9f439414d142d30964530abd844c43bdbc635f2157e855877602d9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featureRadiusVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9870e8ab74e68bf1ce046aff37605841bfc50fadf14203639dc658689a438bfa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d1fd5c966e9f6e59d212bd4f2346d80b20c0d18f97f75d92086094c026f77d4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4b09903523a2a366af0180a36d6382480d6597d6500ed2e9e89981b542e613d3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d755a5ed81c87ef1140d3e03d754109d60389f016f99d0e5fd14ee8e469c5dda)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="maxFeatures")
    def max_features(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "maxFeatures"))

    @max_features.setter
    def max_features(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3e81fe6e5179071f5eb9fb9cb2cb3b290d7ae6c242ecf8d75e5ed4466065650d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "maxFeatures", value)

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesVar")
    def max_features_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "maxFeaturesVar"))

    @max_features_var.setter
    def max_features_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc1032bcf5601b6b47bf3272be9139348c357c1d1ec6354fe01d3111ca026505)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "maxFeaturesVar", value)

    @builtins.property
    @jsii.member(jsii_name="minFeatureQuality")
    def min_feature_quality(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "minFeatureQuality"))

    @min_feature_quality.setter
    def min_feature_quality(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__978d1bba7f0292319f799fb9b2520a12f391d2fec08e4789682e8841bcdf49dd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "minFeatureQuality", value)

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityVar")
    def min_feature_quality_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "minFeatureQualityVar"))

    @min_feature_quality_var.setter
    def min_feature_quality_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__18620fa477ff3a8f2969724b5b863a422de8dbbfadf1a3b24e7c1b9fb970bdd2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "minFeatureQualityVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e2f2d651887bc7f4198c6ed566bff0f68573ab5bddf22c36eeabaab85b71330f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1ba96db08a096b8b73328e9925afc12849a85261c3f237831dae4c92a2c51278)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__05c81bdc7d83f4038d54b5be9ecc94a51a0fa96878ff0a847d072e8419a54471)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3f02f4b22bc708cb8f46b4c982658f91206e5bbd259e0065f39777e41dceba63)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3b8ab16e8d4961c03bc92e79210417d01aae910af763d3bd2d070a062ae9b79c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d57b78b6c57a635153a527a6b44449f1d558d0ddc392c9d130f6ac63eb869d80)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareFeatureCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareFeatureCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareFeatureCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__76f8f47fc5f4d95a0357823adf13e64adfba546e0888eeac52866306e979cd0c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareFitAndFill",
    jsii_struct_bases=[],
    name_mapping={
        "fill_transformation": "fillTransformation",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareFitAndFill:
    def __init__(
        self,
        *,
        fill_transformation: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareFitAndFillFillTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fill_transformation: fill_transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_transformation DataAkamaiImagingPolicyImage#fill_transformation}
        :param height: The height value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The width value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(fill_transformation, dict):
            fill_transformation = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareFitAndFillFillTransformation(**fill_transformation)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__65076807fdde9381fd978f56d11e0cf5cbc87e2a40d349eaf02036d12c5ce8ad)
            check_type(argname="argument fill_transformation", value=fill_transformation, expected_type=type_hints["fill_transformation"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fill_transformation is not None:
            self._values["fill_transformation"] = fill_transformation
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def fill_transformation(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareFitAndFillFillTransformation"]:
        '''fill_transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_transformation DataAkamaiImagingPolicyImage#fill_transformation}
        '''
        result = self._values.get("fill_transformation")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareFitAndFillFillTransformation"], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareFitAndFill(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareFitAndFillFillTransformation",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareFitAndFillFillTransformation:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareFitAndFillFillTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareFitAndFillFillTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareFitAndFillFillTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f1f19f0a9abb43152bdb525258a588b702f7fa27e1a820e7db83e5568d03993c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareFitAndFillFillTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareFitAndFillFillTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareFitAndFillFillTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b206850ceaf0e262688d7d6a62d22353968d3a21ecc8ea3b61d325716eaeae5f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareFitAndFillList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareFitAndFillList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8b87b32418d747b492b6759411e531e35526e9ce71500e0d353d93576402f1e9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareFitAndFillOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__343f776bd9a3553e336bfa57fc1f0841ea2e90aab25d43899492bcf27e031e94)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareFitAndFillOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ccc405d61c83b78de172b7a065b5d878a1da30b5607001a0ec34b2edbb12a82)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__90e8f44630189e64bee9acc12840e2f7d679d722ba6831e7ff401c65d38ec886)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e5f377c3268b982e8547a1df2d100a010d5b7d967b1cce3ae8a6b7d12ebf21c5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareFitAndFill]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareFitAndFill]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareFitAndFill]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a5722b178a67b663cacaee66b961fb73cabb16b05f6a4c5a62c0861475ff77db)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareFitAndFillOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareFitAndFillOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__885222e201adca3f4d42c62337d410ce44d79a2e105cda9acd1149a376c05ca6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putFillTransformation")
    def put_fill_transformation(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareFitAndFillFillTransformation()

        return typing.cast(None, jsii.invoke(self, "putFillTransformation", [value]))

    @jsii.member(jsii_name="resetFillTransformation")
    def reset_fill_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFillTransformation", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="fillTransformation")
    def fill_transformation(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareFitAndFillFillTransformationOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareFitAndFillFillTransformationOutputReference, jsii.get(self, "fillTransformation"))

    @builtins.property
    @jsii.member(jsii_name="fillTransformationInput")
    def fill_transformation_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareFitAndFillFillTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareFitAndFillFillTransformation], jsii.get(self, "fillTransformationInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__00f1fe0f8ee46aa04b50953cecd486a8772353b963c848805bfe25f3f5ba4c75)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6cecd70a17aec31fe1d77c544e0f2a9d064f1e31b46928cc1df7659c78c764a2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6ff423acbf4e1a6c04ceded69a1e2b099725ee93ae8140aad883d4f4cd0afda0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc9a2482883c841e228c324df1d667b28787b7af8cdf8474e8c10f03572831d8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareFitAndFill]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareFitAndFill]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareFitAndFill]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7f4cc4fb65d429449f4f39df2ad21893a7bf2c94e532889e912e20d09944b193)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareGoop",
    jsii_struct_bases=[],
    name_mapping={
        "chaos": "chaos",
        "chaos_var": "chaosVar",
        "density": "density",
        "density_var": "densityVar",
        "power": "power",
        "power_var": "powerVar",
        "seed": "seed",
        "seed_var": "seedVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareGoop:
    def __init__(
        self,
        *,
        chaos: typing.Optional[builtins.str] = None,
        chaos_var: typing.Optional[builtins.str] = None,
        density: typing.Optional[builtins.str] = None,
        density_var: typing.Optional[builtins.str] = None,
        power: typing.Optional[builtins.str] = None,
        power_var: typing.Optional[builtins.str] = None,
        seed: typing.Optional[builtins.str] = None,
        seed_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param chaos: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        :param chaos_var: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        :param density: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        :param density_var: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        :param power: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        :param power_var: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        :param seed: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        :param seed_var: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__01ba7f57457274b04dcd78e7eb34daa9ebbea8265be876fb092c72eda73ada86)
            check_type(argname="argument chaos", value=chaos, expected_type=type_hints["chaos"])
            check_type(argname="argument chaos_var", value=chaos_var, expected_type=type_hints["chaos_var"])
            check_type(argname="argument density", value=density, expected_type=type_hints["density"])
            check_type(argname="argument density_var", value=density_var, expected_type=type_hints["density_var"])
            check_type(argname="argument power", value=power, expected_type=type_hints["power"])
            check_type(argname="argument power_var", value=power_var, expected_type=type_hints["power_var"])
            check_type(argname="argument seed", value=seed, expected_type=type_hints["seed"])
            check_type(argname="argument seed_var", value=seed_var, expected_type=type_hints["seed_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if chaos is not None:
            self._values["chaos"] = chaos
        if chaos_var is not None:
            self._values["chaos_var"] = chaos_var
        if density is not None:
            self._values["density"] = density
        if density_var is not None:
            self._values["density_var"] = density_var
        if power is not None:
            self._values["power"] = power
        if power_var is not None:
            self._values["power_var"] = power_var
        if seed is not None:
            self._values["seed"] = seed
        if seed_var is not None:
            self._values["seed_var"] = seed_var

    @builtins.property
    def chaos(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        '''
        result = self._values.get("chaos")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def chaos_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        '''
        result = self._values.get("chaos_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        '''
        result = self._values.get("density")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density_var(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        '''
        result = self._values.get("density_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        '''
        result = self._values.get("power")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power_var(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        '''
        result = self._values.get("power_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        '''
        result = self._values.get("seed")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed_var(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        result = self._values.get("seed_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareGoop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareGoopList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareGoopList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__957da100fd76b2b7a735b4e42da560dccb3b0e4d67267a27b90932f8b76a26ac)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareGoopOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a0129d7bd0b60746976431bbb90db4dba16ecf26117b9759ebd8bc7292a3abb0)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareGoopOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4dc5566a3aaf1803a573a5b6ea1523ce82310bd2eb0756eb318bc2b880c7aa3c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7f9053e794a1e6df022aa0b9035831ea733ad82f6f20b9da98ae9d079665ca6d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__884d44266779b4d9ced505868b8b75c7cfe963689351c641b21d813594dfb885)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareGoop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareGoop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9c58c2bce2898f0fbbb8d4e35c3bdb0c6072fce85aa498470f051d7c30b3bd31)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareGoopOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareGoopOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fc3887b58d4375b882b6f041877e68c5ac47319d4cf0d537c3ca769c23041b93)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetChaos")
    def reset_chaos(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaos", []))

    @jsii.member(jsii_name="resetChaosVar")
    def reset_chaos_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaosVar", []))

    @jsii.member(jsii_name="resetDensity")
    def reset_density(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensity", []))

    @jsii.member(jsii_name="resetDensityVar")
    def reset_density_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensityVar", []))

    @jsii.member(jsii_name="resetPower")
    def reset_power(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPower", []))

    @jsii.member(jsii_name="resetPowerVar")
    def reset_power_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPowerVar", []))

    @jsii.member(jsii_name="resetSeed")
    def reset_seed(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeed", []))

    @jsii.member(jsii_name="resetSeedVar")
    def reset_seed_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeedVar", []))

    @builtins.property
    @jsii.member(jsii_name="chaosInput")
    def chaos_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosInput"))

    @builtins.property
    @jsii.member(jsii_name="chaosVarInput")
    def chaos_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosVarInput"))

    @builtins.property
    @jsii.member(jsii_name="densityInput")
    def density_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityInput"))

    @builtins.property
    @jsii.member(jsii_name="densityVarInput")
    def density_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="powerInput")
    def power_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerInput"))

    @builtins.property
    @jsii.member(jsii_name="powerVarInput")
    def power_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerVarInput"))

    @builtins.property
    @jsii.member(jsii_name="seedInput")
    def seed_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedInput"))

    @builtins.property
    @jsii.member(jsii_name="seedVarInput")
    def seed_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedVarInput"))

    @builtins.property
    @jsii.member(jsii_name="chaos")
    def chaos(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaos"))

    @chaos.setter
    def chaos(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__24992ffb029ee61db2a86ed1924afe9a31efd8530ad76e06424bea9f2c7c24f6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaos", value)

    @builtins.property
    @jsii.member(jsii_name="chaosVar")
    def chaos_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaosVar"))

    @chaos_var.setter
    def chaos_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6df5f3e5f6cccab00eb0a4b4b3a5b68e0fe5befe26610dbae5e13659aef7ddfe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaosVar", value)

    @builtins.property
    @jsii.member(jsii_name="density")
    def density(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "density"))

    @density.setter
    def density(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2872b6a251fde4f5cadcfc78bf65474685d5d301fd723ea3f79f478ccde3f34d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "density", value)

    @builtins.property
    @jsii.member(jsii_name="densityVar")
    def density_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "densityVar"))

    @density_var.setter
    def density_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__06da20569dd02eadfa11971d902e5888d85fa1233ad2d97c7cea7989239304a5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "densityVar", value)

    @builtins.property
    @jsii.member(jsii_name="power")
    def power(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "power"))

    @power.setter
    def power(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__923516ff935f2089c2c395a71276b03e8c0743305e46eac3720f894cd4da4515)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "power", value)

    @builtins.property
    @jsii.member(jsii_name="powerVar")
    def power_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "powerVar"))

    @power_var.setter
    def power_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__654acaa29c40b5cad8c7f6a21d0c9941eb9ca4cef6813f21036f946be6b648ee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "powerVar", value)

    @builtins.property
    @jsii.member(jsii_name="seed")
    def seed(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seed"))

    @seed.setter
    def seed(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2da891c350dbb468858b5234f33cb891cf89ec3d812ee42e689f96ce63d5a930)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seed", value)

    @builtins.property
    @jsii.member(jsii_name="seedVar")
    def seed_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seedVar"))

    @seed_var.setter
    def seed_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f0455077f6a7631d7e9ea3dfec5fe3f173492ca722a68a87f0237d6e4914987b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seedVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareGoop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareGoop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareGoop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__889c4039b1da9d186e370509c6ceecfaf9339b07aa34e26f9c0bea272ed0b45e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareGrayscale",
    jsii_struct_bases=[],
    name_mapping={"type": "type", "type_var": "typeVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareGrayscale:
    def __init__(
        self,
        *,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param type: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ccb498f3ee7d83bb2bddba867c047e18ee950096ca25afc16a56216662877928)
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareGrayscale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareGrayscaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareGrayscaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a0b6edce50b7ee7c63e10eeef7fe30336d014ac85a668d6148d991704cd4f122)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareGrayscaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__84b10c6a6abae7dff582f202334d7f3ce1f399b511d9df6872561e9c871ce961)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareGrayscaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__019e2df045c3f5d6b7b6bd181a7a4f7699320df1a458628b71ccd41b136b77bc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ae91d16466d1a57c0a4a5537a46422d025fcfd15260d070a1b9e14f64ea920d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3d4cd1d1cd611b237faa38c434b7a94b2af270ca0b098873e047cc444ea46afe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareGrayscale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareGrayscale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9924f89e662c0e0c23674120291a83ee4e4496bd53535aafab1d645e029adf66)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareGrayscaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareGrayscaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9f8e409d8c5af2f57d3c7624620bbc0e83967caf4e884bd8f962b926e99e37f3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__71776b3e5d06a764396a377f72bec7c11e37604a779375f5fefe6b54ebe4fb28)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1b13bb8d7e5f4a8d507efd3ffb429583da919fa462fb3e184362ec37791ec3fa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareGrayscale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareGrayscale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareGrayscale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6d92eb673dcefac3d3a27691bfc610d8ca4a2d7f634775d4b9ef295cd5c19766)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareHsl",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "lightness": "lightness",
        "lightness_var": "lightnessVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareHsl:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness: typing.Optional[builtins.str] = None,
        lightness_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        :param lightness_var: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__769c7e9e107b6d2af2c977143c3d7d7e2a580c24874fc6a88d1732715ac69e73)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness", value=lightness, expected_type=type_hints["lightness"])
            check_type(argname="argument lightness_var", value=lightness_var, expected_type=type_hints["lightness_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness is not None:
            self._values["lightness"] = lightness
        if lightness_var is not None:
            self._values["lightness_var"] = lightness_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        '''
        result = self._values.get("lightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        '''
        result = self._values.get("lightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareHsl(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareHslList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareHslList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7a9fb7115fca8fa1d7609399112422e48310334dede836aa5bdaa4bfffd7fd6c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareHslOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__358b5ed5a945a892aaf0702a020ef9897f564903d0d94a9c549c89d7e4a71359)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareHslOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__669be711a2c613927943777a1e31ac511e90eb6ed9def66427758ab74013ca54)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fab917d3191c111a0387436e238e020fa8c764cde64583487e9ae59bf3f41543)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__87e4a463e10298bd7cc582e358d19e886e76b53946d0c69bcdeaa0e51e27038f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareHsl]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareHsl]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4b87227944a848c6ba1d47d4b6e0cdd77ad3aaf21fe3b094decf84647a9dc890)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareHslOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareHslOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6a8646cf2624d98e82f049839a7dbf258efe2f3fb1dcdf74f302a5a06c567ecb)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightness")
    def reset_lightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightness", []))

    @jsii.member(jsii_name="resetLightnessVar")
    def reset_lightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessInput")
    def lightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessVarInput")
    def lightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7277afbd3c6c9ff2572457552726e40120f2ddbaa814c59781a2aebb297ce303)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5cdd9b2ce3ef2c4bd6a21ef0773246b277a570b0108a74eb5b4267b8a4b528ea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightness")
    def lightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightness"))

    @lightness.setter
    def lightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1acf793811b6cb2ebb8b7f0b833cff6f4f143fcae38316ba4610c4d0a7fca9c2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightness", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessVar")
    def lightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessVar"))

    @lightness_var.setter
    def lightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5e66ccfd6b8943388dacdace3db23a0d1e390cc2a479ad10777ba26daa77586d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__13b5a9a887772d014e09546b0159aeac61c9e22af687271e2e4a99b73dc33cd2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b3ccdcffa64324d8dc6aac522108221d9c3ded83bcc7f6fd721b4c832256a355)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareHsl]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareHsl]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareHsl]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bdd37ef49922f352abc2ea3102d0c36060ba4f7637a8a924d1cd1cc6f8528a17)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareHsv",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareHsv:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        :param value: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__38da0499c23853a2ba8f741e661c8b088665f5999907fcaa1bd60f86665ee6c3)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareHsv(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareHsvList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareHsvList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fdf95bea8669f2e7bdf49f519feb37e37edc21f9c0b7c6702b102f41a7754d4d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareHsvOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a885422f563900ef0445d1bc0e89bc78e551edba7cceeca7dde3e2203150cd98)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareHsvOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__17847003b61ca584ca24e898791888caffac05c70c55c5bd915bf2ed904d652b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a3f5c552c5975c58fb5c5248fffb71403ffd071fc3e8c277e1ca7a9a9f93caf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eede8698dd1a68ba7272dc6e95bc3719a3c59002974244fc489db18515540376)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareHsv]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareHsv]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f6aa200890ec9baec734b3d10c86319b23bdec846a82d2bd6ddcf1fb5e02bb57)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareHsvOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareHsvOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__86f90305eb91597fdbd97c96a4cf8cab520776de7249317a0ba4c1e9350e55f1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__36b4ff0d43df4192d3e18acf875b0587cb2709e1e2bb8b86d90c1d344d30a2c4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bbb42c7bc29c0b111de5e73b5e97baa0355b35f47959c9594d5029f5ea91565e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__108f54336e6d64a4869d40b06024dd1cbc367bb3a37b7aa2c6f682df323875bd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e2bc4c680d22f456ea6da561c398a631a6e3d065ef87db350b91f3097b203734)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a3ca732a6ef48a617abc164ce657398e3ad605fdc7a0f0c0f6dbe3c206380bdb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__14ea593112c4f421e30dc299357aaecc5c331ed3eeaee26ed0479bf833172b0e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareHsv]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareHsv]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareHsv]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3e44c25519c9fda82c0553878b7ad0e9a662acdea6ecbecdd79843dd8ba844ff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimension",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "dimension": "dimension",
        "dimension_var": "dimensionVar",
        "equal": "equal",
        "greater_than": "greaterThan",
        "less_than": "lessThan",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimension:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        dimension: typing.Optional[builtins.str] = None,
        dimension_var: typing.Optional[builtins.str] = None,
        equal: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionEqual", typing.Dict[builtins.str, typing.Any]]] = None,
        greater_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionGreaterThan", typing.Dict[builtins.str, typing.Any]]] = None,
        less_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionLessThan", typing.Dict[builtins.str, typing.Any]]] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param dimension: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        :param dimension_var: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        :param equal: equal block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        :param greater_than: greater_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        :param less_than: less_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        :param value: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionDefault(**default)
        if isinstance(equal, dict):
            equal = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionEqual(**equal)
        if isinstance(greater_than, dict):
            greater_than = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionGreaterThan(**greater_than)
        if isinstance(less_than, dict):
            less_than = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionLessThan(**less_than)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8ee6f5eb3f2b3bb27249c5d04120682c6d896d828be97947c63a85c31ea2c447)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument dimension", value=dimension, expected_type=type_hints["dimension"])
            check_type(argname="argument dimension_var", value=dimension_var, expected_type=type_hints["dimension_var"])
            check_type(argname="argument equal", value=equal, expected_type=type_hints["equal"])
            check_type(argname="argument greater_than", value=greater_than, expected_type=type_hints["greater_than"])
            check_type(argname="argument less_than", value=less_than, expected_type=type_hints["less_than"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if dimension is not None:
            self._values["dimension"] = dimension
        if dimension_var is not None:
            self._values["dimension_var"] = dimension_var
        if equal is not None:
            self._values["equal"] = equal
        if greater_than is not None:
            self._values["greater_than"] = greater_than
        if less_than is not None:
            self._values["less_than"] = less_than
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionDefault"], result)

    @builtins.property
    def dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        '''
        result = self._values.get("dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        '''
        result = self._values.get("dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def equal(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionEqual"]:
        '''equal block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        '''
        result = self._values.get("equal")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionEqual"], result)

    @builtins.property
    def greater_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionGreaterThan"]:
        '''greater_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        '''
        result = self._values.get("greater_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionGreaterThan"], result)

    @builtins.property
    def less_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionLessThan"]:
        '''less_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        '''
        result = self._values.get("less_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionLessThan"], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimension(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0efc4fdd297c36c7b66d247f7da9a4c0fbd00512a241d003f6136fd7f86582f2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ba8207bc3924e5fd826cf820b84fc21c1ae4286519d0be87bbff0355ffd3cf9b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionEqual",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionEqual:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionEqual(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionEqualOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionEqualOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e49b058ca0127d80fabbb6c6e6dee68e51df02e5efafa72c2d3b9cf1c108e615)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionEqual], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionEqual],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__815700a974b7bf09f846bbdb275dd50113b15ae12d8007b3c2cc252704ebdbef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionGreaterThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionGreaterThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionGreaterThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionGreaterThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionGreaterThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__638d32b39094adea3a04bbc58ab9c84518c68e7ceb72c4d0d001248dd6594655)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionGreaterThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionGreaterThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f1f8c89fbf6dffa6cdd7902106060f54026ea7f069fb8b578313b06c20012fa6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionLessThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionLessThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionLessThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionLessThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionLessThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8c2f12cde5ef7bbfb847245c9920485167e12a5fed548de08ed61c9afef99ab1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionLessThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionLessThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f59a42d32ace5e257bba707e71af772d1103b822e4bf8954dbadefaed4aa5149)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__09f07e01a15b8d638e890492492293e87001c6df554643f177c74261aab1ef33)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__642ca7136492217b0f337d9ac0e13890f75c4ce53588b26caa104909e1811e01)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f195bf9f16f2ac1ae28af985a1c86dad5138e040fe09b35dc0700c837fff08b5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f312be2bc2ad99ad880eab15d0980eae78dd62346619725cc17261d48c7830ab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b845defb5f21799fdec3cec6070108f0b145c4cf5271fdfe4901729b6b54936e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimension]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimension]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f1fc0d7afbb3d5e3f1d827c632c980b634fd70336b16ed4812a44a34d97beb55)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__39d8b9fdbbb0f6027b54b6b9e28e6a120265eda0e754664349eecd0309b84ead)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putEqual")
    def put_equal(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionEqual()

        return typing.cast(None, jsii.invoke(self, "putEqual", [value]))

    @jsii.member(jsii_name="putGreaterThan")
    def put_greater_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionGreaterThan()

        return typing.cast(None, jsii.invoke(self, "putGreaterThan", [value]))

    @jsii.member(jsii_name="putLessThan")
    def put_less_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionLessThan()

        return typing.cast(None, jsii.invoke(self, "putLessThan", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetDimension")
    def reset_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimension", []))

    @jsii.member(jsii_name="resetDimensionVar")
    def reset_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimensionVar", []))

    @jsii.member(jsii_name="resetEqual")
    def reset_equal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEqual", []))

    @jsii.member(jsii_name="resetGreaterThan")
    def reset_greater_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGreaterThan", []))

    @jsii.member(jsii_name="resetLessThan")
    def reset_less_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLessThan", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="equal")
    def equal(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionEqualOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionEqualOutputReference, jsii.get(self, "equal"))

    @builtins.property
    @jsii.member(jsii_name="greaterThan")
    def greater_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionGreaterThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionGreaterThanOutputReference, jsii.get(self, "greaterThan"))

    @builtins.property
    @jsii.member(jsii_name="lessThan")
    def less_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionLessThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionLessThanOutputReference, jsii.get(self, "lessThan"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionInput")
    def dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionVarInput")
    def dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="equalInput")
    def equal_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionEqual], jsii.get(self, "equalInput"))

    @builtins.property
    @jsii.member(jsii_name="greaterThanInput")
    def greater_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionGreaterThan], jsii.get(self, "greaterThanInput"))

    @builtins.property
    @jsii.member(jsii_name="lessThanInput")
    def less_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionLessThan], jsii.get(self, "lessThanInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="dimension")
    def dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimension"))

    @dimension.setter
    def dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b6eb90210031075cd70ccb11b4a9800265065413dc7ff723e2ccbd1b27f4e846)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimension", value)

    @builtins.property
    @jsii.member(jsii_name="dimensionVar")
    def dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimensionVar"))

    @dimension_var.setter
    def dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6a6b38cda69b97518bac9972d0b3ab98269afda8160df05df33ce1d25bd3ac5f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__33b84e5ed13a9b3579fadc83f92deed87c764119040b70161bf3f43e2c1bad67)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b752137f955292189f5a12305553e4cf226661c9407f5863117db44cbbf0c633)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimension]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimension]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimension]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0c57b87241ec848dc29b93a6909125d971e59a123cd20145fab7f6e0c40faa41)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientation",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "landscape": "landscape",
        "portrait": "portrait",
        "square": "square",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientation:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        landscape: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationLandscape", typing.Dict[builtins.str, typing.Any]]] = None,
        portrait: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationPortrait", typing.Dict[builtins.str, typing.Any]]] = None,
        square: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationSquare", typing.Dict[builtins.str, typing.Any]]] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param landscape: landscape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        :param portrait: portrait block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        :param square: square block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationDefault(**default)
        if isinstance(landscape, dict):
            landscape = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationLandscape(**landscape)
        if isinstance(portrait, dict):
            portrait = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationPortrait(**portrait)
        if isinstance(square, dict):
            square = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationSquare(**square)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2f0c9d122d91a6ff939607f30168ee1d6977505b0c9bd3332b4d9bc08e96d5ab)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument landscape", value=landscape, expected_type=type_hints["landscape"])
            check_type(argname="argument portrait", value=portrait, expected_type=type_hints["portrait"])
            check_type(argname="argument square", value=square, expected_type=type_hints["square"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if landscape is not None:
            self._values["landscape"] = landscape
        if portrait is not None:
            self._values["portrait"] = portrait
        if square is not None:
            self._values["square"] = square

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationDefault"], result)

    @builtins.property
    def landscape(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationLandscape"]:
        '''landscape block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        '''
        result = self._values.get("landscape")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationLandscape"], result)

    @builtins.property
    def portrait(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationPortrait"]:
        '''portrait block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        '''
        result = self._values.get("portrait")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationPortrait"], result)

    @builtins.property
    def square(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationSquare"]:
        '''square block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        result = self._values.get("square")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationSquare"], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d80a59836f5813524dd90cb9651a7300efb241faa3a5c062034f89d711275a28)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea7df7959a7eb3c7347f69967b9daa305cfa9a9e211c3b46b85cb07d44361ef4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationLandscape",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationLandscape:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationLandscape(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationLandscapeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationLandscapeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0f0c7af368db48c2d3bb3d8810867b65c0c389edca117c228b5ae08140a07266)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationLandscape], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationLandscape],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__358c6790cb17e5551400996a0f4c9b9391db77cbd7a364a03302f5d6d7a3b7f3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8f6897021c3f5fedcaba959c36dfc8ec90a74df36ea1831fd5f41234992c1d0c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a1a9a3c87f6b3c99293e51e1e075a042447a7ecd14a14de25a6640bf24f5d58e)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__24ac8bcee347c95785b45cf10011368877fa3e0f6a4d2f3bcc8f66a0366ffd56)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cb35a3754b587bae8c1ff895d99f46a4ded2a320d7307c5565d4996b06a9ac39)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3babd2fada60de9dfb9c39c54d7d78e0a33f9a88a3b34278bafe664dc8deda57)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientation]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientation]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__78e16b5de1883727cf01611f9ed6a61d0784b3f21b41f7ad00273f1343c46c30)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__555b43beb38977bea7e3c0da85231badca65deae0a61d30e2c60e147195ef397)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putLandscape")
    def put_landscape(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationLandscape()

        return typing.cast(None, jsii.invoke(self, "putLandscape", [value]))

    @jsii.member(jsii_name="putPortrait")
    def put_portrait(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationPortrait()

        return typing.cast(None, jsii.invoke(self, "putPortrait", [value]))

    @jsii.member(jsii_name="putSquare")
    def put_square(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationSquare()

        return typing.cast(None, jsii.invoke(self, "putSquare", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetLandscape")
    def reset_landscape(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLandscape", []))

    @jsii.member(jsii_name="resetPortrait")
    def reset_portrait(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPortrait", []))

    @jsii.member(jsii_name="resetSquare")
    def reset_square(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSquare", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="landscape")
    def landscape(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationLandscapeOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationLandscapeOutputReference, jsii.get(self, "landscape"))

    @builtins.property
    @jsii.member(jsii_name="portrait")
    def portrait(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationPortraitOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationPortraitOutputReference", jsii.get(self, "portrait"))

    @builtins.property
    @jsii.member(jsii_name="square")
    def square(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationSquareOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationSquareOutputReference", jsii.get(self, "square"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="landscapeInput")
    def landscape_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationLandscape], jsii.get(self, "landscapeInput"))

    @builtins.property
    @jsii.member(jsii_name="portraitInput")
    def portrait_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationPortrait"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationPortrait"], jsii.get(self, "portraitInput"))

    @builtins.property
    @jsii.member(jsii_name="squareInput")
    def square_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationSquare"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationSquare"], jsii.get(self, "squareInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientation]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientation]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientation]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2cdb7938695f7871ed11fc6dfeef5314cacb63915c4ca6451ecd5d4df0b17938)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationPortrait",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationPortrait:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationPortrait(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationPortraitOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationPortraitOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__040b5a42dd02005e8ebf8773e3bbd3f819373cedc4e88e05f530df7d77094b34)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationPortrait]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationPortrait], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationPortrait],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7f621dd0fa616ab9b284603093a6296916ce4fe834ae348003b8b075fdc2f410)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationSquare",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationSquare:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationSquare(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationSquareOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationSquareOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4c14ade32091de7c1e55fd332ebc7bce2ac23c93ab6cd5a70da401c6bc324dde)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationSquare]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationSquare], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationSquare],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0bce29481f31d7eb7235af03b71134fe7365698e2c1ba3bbbcc23d0b65d34b5a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareImQuery",
    jsii_struct_bases=[],
    name_mapping={
        "allowed_transformations": "allowedTransformations",
        "query_var": "queryVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareImQuery:
    def __init__(
        self,
        *,
        allowed_transformations: typing.Sequence[builtins.str],
        query_var: builtins.str,
    ) -> None:
        '''
        :param allowed_transformations: Specifies the transformations that can be applied using the query string parameter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allowed_transformations DataAkamaiImagingPolicyImage#allowed_transformations}
        :param query_var: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#query_var DataAkamaiImagingPolicyImage#query_var}.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__59d47a96360b8356fbe095584b0289951161dbbc4ba06aa5cd2e555506b24719)
            check_type(argname="argument allowed_transformations", value=allowed_transformations, expected_type=type_hints["allowed_transformations"])
            check_type(argname="argument query_var", value=query_var, expected_type=type_hints["query_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "allowed_transformations": allowed_transformations,
            "query_var": query_var,
        }

    @builtins.property
    def allowed_transformations(self) -> typing.List[builtins.str]:
        '''Specifies the transformations that can be applied using the query string parameter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allowed_transformations DataAkamaiImagingPolicyImage#allowed_transformations}
        '''
        result = self._values.get("allowed_transformations")
        assert result is not None, "Required property 'allowed_transformations' is missing"
        return typing.cast(typing.List[builtins.str], result)

    @builtins.property
    def query_var(self) -> builtins.str:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#query_var DataAkamaiImagingPolicyImage#query_var}.'''
        result = self._values.get("query_var")
        assert result is not None, "Required property 'query_var' is missing"
        return typing.cast(builtins.str, result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareImQuery(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareImQueryList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareImQueryList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5bf36d5f61dd3985fb09147f33257f478e71966b289f7ab5d70e66c4b49347f8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareImQueryOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__47f63733a9bf92cbc546df29245ffe189f062db65858478a0b2d753d0a2c69b0)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareImQueryOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be8a13ddfd6869cad53da7821f47cefe688ed1a3b3ff745278361c2f1e964a4f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f7b0e8bd619a53a646987a81eb244c1bd0e8c41463c20a6704c3160f3587c15f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af57c62c6b09ce17c708300a03497b3cbf9a3226ebcbc6e72d11b34f2dab6ddd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareImQuery]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareImQuery]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareImQuery]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c109972fe18dbf2ce8a849e1d177ea5dd9911018f0fad5e64c000cc88cb34a43)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareImQueryOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareImQueryOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7548cbd4bd37662d164f94194193ae6876f99a6e0446cf9079555d33fdee9ff5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @builtins.property
    @jsii.member(jsii_name="allowedTransformationsInput")
    def allowed_transformations_input(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "allowedTransformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="queryVarInput")
    def query_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "queryVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowedTransformations")
    def allowed_transformations(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "allowedTransformations"))

    @allowed_transformations.setter
    def allowed_transformations(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__23beb2910c4f63d07233b6e8780b6ae437c7474608758f624355cc525ec6309a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowedTransformations", value)

    @builtins.property
    @jsii.member(jsii_name="queryVar")
    def query_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "queryVar"))

    @query_var.setter
    def query_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a7994f31ec617f60b336d87fa10898f80400627294d5e941008651b282792d5c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "queryVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareImQuery]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareImQuery]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareImQuery]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__60e6d37fc6f42b743ee22240d4c3a8938450f1c9b729a13b54f62a6750f57210)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareMaxColors",
    jsii_struct_bases=[],
    name_mapping={"colors": "colors", "colors_var": "colorsVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareMaxColors:
    def __init__(
        self,
        *,
        colors: typing.Optional[builtins.str] = None,
        colors_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param colors: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        :param colors_var: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dcddf0dcbd2bc0828e4ac939771bd8b80525a46f36bf332128ec1a1a7e6d7621)
            check_type(argname="argument colors", value=colors, expected_type=type_hints["colors"])
            check_type(argname="argument colors_var", value=colors_var, expected_type=type_hints["colors_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if colors is not None:
            self._values["colors"] = colors
        if colors_var is not None:
            self._values["colors_var"] = colors_var

    @builtins.property
    def colors(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        '''
        result = self._values.get("colors")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def colors_var(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        result = self._values.get("colors_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareMaxColors(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareMaxColorsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareMaxColorsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c9e9d1375d0bab312ac7966ca7c1dd73815cd13124f1848265e943163f182c3c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareMaxColorsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ed73407f7012262f210e765ca934feffcae324be26ff53f764ef2aa0856aa040)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareMaxColorsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__37fa1c9bff44cf2eadbf5cce25099314fdb14da9f594d4bf35e23a6444cf0189)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a6e05cc16d5d863b25aa6592aeb21e328807792fd75e3fb7f5d05c31013d553c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6563f2340f60b42f3eaa0916100b238476d2a4295675cd981661714dd3450924)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareMaxColors]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareMaxColors]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5a66b8d5a30482accad9f107c3bc9e394f605a6aa84b36d0dcc2079f865271e3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareMaxColorsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareMaxColorsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__70a392a8a0a101728294c1df703f54a45052a8e6eafa47f114df74298d9625cf)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColors")
    def reset_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColors", []))

    @jsii.member(jsii_name="resetColorsVar")
    def reset_colors_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorsVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorsInput")
    def colors_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsInput"))

    @builtins.property
    @jsii.member(jsii_name="colorsVarInput")
    def colors_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsVarInput"))

    @builtins.property
    @jsii.member(jsii_name="colors")
    def colors(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colors"))

    @colors.setter
    def colors(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a86f300201ee75917b1e1f36d0b7d012aa1c2dadc927abb24e2292e415284325)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colors", value)

    @builtins.property
    @jsii.member(jsii_name="colorsVar")
    def colors_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorsVar"))

    @colors_var.setter
    def colors_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df4bada1d052fe69374f0edee2301e4cd214c8e93bec2d1efdd2adc55f328972)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorsVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareMaxColors]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareMaxColors]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareMaxColors]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9b49a0637e684ac8af81580b1d5b00f25944792fe3280e1741a84a88bfb4a52e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareMirror",
    jsii_struct_bases=[],
    name_mapping={
        "horizontal": "horizontal",
        "horizontal_var": "horizontalVar",
        "vertical": "vertical",
        "vertical_var": "verticalVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareMirror:
    def __init__(
        self,
        *,
        horizontal: typing.Optional[builtins.str] = None,
        horizontal_var: typing.Optional[builtins.str] = None,
        vertical: typing.Optional[builtins.str] = None,
        vertical_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param horizontal: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        :param horizontal_var: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        :param vertical: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        :param vertical_var: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__69a8c1d99fbbc02e500e503175dcb14dffac7e5bb693ee4cf48a7406941b5727)
            check_type(argname="argument horizontal", value=horizontal, expected_type=type_hints["horizontal"])
            check_type(argname="argument horizontal_var", value=horizontal_var, expected_type=type_hints["horizontal_var"])
            check_type(argname="argument vertical", value=vertical, expected_type=type_hints["vertical"])
            check_type(argname="argument vertical_var", value=vertical_var, expected_type=type_hints["vertical_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if horizontal is not None:
            self._values["horizontal"] = horizontal
        if horizontal_var is not None:
            self._values["horizontal_var"] = horizontal_var
        if vertical is not None:
            self._values["vertical"] = vertical
        if vertical_var is not None:
            self._values["vertical_var"] = vertical_var

    @builtins.property
    def horizontal(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        '''
        result = self._values.get("horizontal")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def horizontal_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        '''
        result = self._values.get("horizontal_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        '''
        result = self._values.get("vertical")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        result = self._values.get("vertical_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareMirror(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareMirrorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareMirrorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3beeddf857817240dcec4379a8848e5da927e6b289a63d87a159b1bdfc591723)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareMirrorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d35d59581b6238728378d535f1fc02279f0b36b6e7e3d2af3b2a0c9b7c422cf7)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareMirrorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ecd888f53ac77cfd8f434cd2ffefb86069f2c97fdea267388f8d354c4a051019)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2e4d871cd123ed047451c9cade109d72b286435446dd693292bd40be66b59ca7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5521666ed9974b1a2898dff1e1d6e0088acb2a41b6590f94156845aed17bb197)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareMirror]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareMirror]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0924522e236b215b71f2253808bc4ac553c782058ddd72468934b5f1d1f742e5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareMirrorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareMirrorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__93ad273af26be725f5e103590b3acfea3a8628e2ea36184cfed4ac5c8a7b1eba)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHorizontal")
    def reset_horizontal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontal", []))

    @jsii.member(jsii_name="resetHorizontalVar")
    def reset_horizontal_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontalVar", []))

    @jsii.member(jsii_name="resetVertical")
    def reset_vertical(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVertical", []))

    @jsii.member(jsii_name="resetVerticalVar")
    def reset_vertical_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVerticalVar", []))

    @builtins.property
    @jsii.member(jsii_name="horizontalInput")
    def horizontal_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontalVarInput")
    def horizontal_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalInput")
    def vertical_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalVarInput")
    def vertical_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontal")
    def horizontal(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontal"))

    @horizontal.setter
    def horizontal(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__90e7ae3435e14d942345618e329cd1861acd181824bfa5c7f8da04356c4924a7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontal", value)

    @builtins.property
    @jsii.member(jsii_name="horizontalVar")
    def horizontal_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontalVar"))

    @horizontal_var.setter
    def horizontal_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__16ec83ce3c4d89f5958cfa58de821442c67925cfd7b42530018f8ef76366dcb3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontalVar", value)

    @builtins.property
    @jsii.member(jsii_name="vertical")
    def vertical(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "vertical"))

    @vertical.setter
    def vertical(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e08b34437f83cd36a0b1410bdf8ef4787ef8a70dc86e1ddf7cc77ed75435fab2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "vertical", value)

    @builtins.property
    @jsii.member(jsii_name="verticalVar")
    def vertical_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "verticalVar"))

    @vertical_var.setter
    def vertical_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__05567166c88c769217f5c6f54c40556a5ff9c1edbcd2c52329e94f2b6d46c317)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "verticalVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareMirror]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareMirror]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareMirror]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eebecbc1dfb38d6513a587d9a02d357c25018a153d20c0aee6c71c9f79ad255d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareMonoHue",
    jsii_struct_bases=[],
    name_mapping={"hue": "hue", "hue_var": "hueVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareMonoHue:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7951ea3123347710f2bc5b35ce0d70821e759e3162aea851aac976501c3400e0)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareMonoHue(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareMonoHueList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareMonoHueList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__18d8a699cbb63d5940367a5f1d368c7fa972bc9c333a099236ebcc24af64d5fa)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareMonoHueOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2689ee56a6677e06885ee55b349d8314c4c542d2a39647fbbe808177829308e8)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareMonoHueOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__10106b8bb1a66cc209c368859c103edfe4e7ee17dc8efbe52b3d7044d82e6511)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__05d4a18bb7f90310e0e26a38e754f8543a3e893745271a6c058051d996d186be)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eee13388af9cee6dcce077df3ca7168d05199bd8740415eb816f2e6ee2d7a828)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareMonoHue]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareMonoHue]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__75e25d9a0a6e43eed7e3a82ecbf7325b81f01b3ba90c11d763edefa2030ed6d3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareMonoHueOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareMonoHueOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7e6554caad0005ec1e77ca3aa2288e1a13fd60ce5341fea518d3480421b8d6e5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3db04a9343e174575a020561078fa04c2a6d82897ed5a9851a770327d9d1c97e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3036f9690604223c1d280cf7bb70493d52689a212afe518daa5ffb011ccdce4a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareMonoHue]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareMonoHue]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareMonoHue]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__36f2c3f14f312a8556dec6f321d6a19faee4cc645e1f63999caf1f094e52f0ba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareOpacity",
    jsii_struct_bases=[],
    name_mapping={"opacity": "opacity", "opacity_var": "opacityVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareOpacity:
    def __init__(
        self,
        *,
        opacity: typing.Optional[builtins.str] = None,
        opacity_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param opacity: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param opacity_var: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c8bcdecab8315c14c61491448d33ac524a3059e498567c7ed16d0cae0e93cdb9)
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument opacity_var", value=opacity_var, expected_type=type_hints["opacity_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if opacity is not None:
            self._values["opacity"] = opacity
        if opacity_var is not None:
            self._values["opacity_var"] = opacity_var

    @builtins.property
    def opacity(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def opacity_var(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        result = self._values.get("opacity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareOpacity(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareOpacityList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareOpacityList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c8cdf98f5a83c3450e6cfb0de0fa48557a393f419191146821f955ac2cb1ffbe)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareOpacityOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__855afa47872861bb467e937ec069957304ba23ef42708abcd84e3e416da3e427)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareOpacityOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0fb9e3b19ebcb62160295f242a91de147021341aeedf22027507d1bad1c99cbd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c7c655c31670d3440204824fd705181a719b18328d083419fb0aba245b12b96a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cc68b7f0e308f6d85d95e30689031bc80e4c37124d6e3638d1c73e3d86eb9564)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareOpacity]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareOpacity]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f0df500edabddb76269946517bab277badd2c9a7c737258929246683e9986160)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareOpacityOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareOpacityOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3fe12729900c823da1639d7ccb072da2b92153e07e79cad0d0622c216567295e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetOpacityVar")
    def reset_opacity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacityVar", []))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityVarInput")
    def opacity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacity"))

    @opacity.setter
    def opacity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__32240a8f3c998f822c3d9459e8fa86e9d922ab72e5adfc436818f15d38f9fd40)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacity", value)

    @builtins.property
    @jsii.member(jsii_name="opacityVar")
    def opacity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacityVar"))

    @opacity_var.setter
    def opacity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__abd203d5319866edc0f219ab8acc02784ac878d70c46615973b8b86b882693fd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacityVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareOpacity]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareOpacity]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareOpacity]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7803b673c93f73d18b6da5836edd10a28781600c01a15dac770fbe5a303a0bd8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a2bdc4145cddcd5e10a256fbb96839b0b0c124aaa8141b4152fd65215d654a9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putAppend")
    def put_append(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareAppend, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3f47d4d7180994a67f901516050acec7bbf902ec4e441187066ce221289e562f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putAppend", [value]))

    @jsii.member(jsii_name="putAspectCrop")
    def put_aspect_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareAspectCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f4e2b9ee9c9d17ae53995a425148295ea914b447025aa04328abec82fb91c609)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putAspectCrop", [value]))

    @jsii.member(jsii_name="putBackgroundColor")
    def put_background_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df7b0c8046d85b535ff6850e7408638f8472051c9f679c838d90b09250b0781c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBackgroundColor", [value]))

    @jsii.member(jsii_name="putBlur")
    def put_blur(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareBlur, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e3e80d3533efe80aeacacdf4fd612e5b66beb5e7e7d1e17eb9d888c454f1eb84)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBlur", [value]))

    @jsii.member(jsii_name="putChromaKey")
    def put_chroma_key(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareChromaKey, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fd3df6383fd96d123659a34cb59f1da78e4a59922f336c1fd927d53bf9f29f86)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putChromaKey", [value]))

    @jsii.member(jsii_name="putComposite")
    def put_composite(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareComposite, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__65098b9c56cab24eb318e34d62f23706e437e062146abbf75bd9f8477c6a53d5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putComposite", [value]))

    @jsii.member(jsii_name="putCompound")
    def put_compound(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareCompound, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f17e58bc0030de4a5d2e0104647f252ed98a155de82f8aa0ae9cdd5caef10c87)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCompound", [value]))

    @jsii.member(jsii_name="putContrast")
    def put_contrast(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareContrast, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__871ce9373c720264ef98ed1141dc8c17aa38210b219b5e3f3515d15a8c08eba4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putContrast", [value]))

    @jsii.member(jsii_name="putCrop")
    def put_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e216afaff58c678765b9d50795524717392c245dbc90e65ac135a54d88b6d798)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCrop", [value]))

    @jsii.member(jsii_name="putFaceCrop")
    def put_face_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareFaceCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d43ebf556973d31baf71cf7317a99228bd02dda59eee58e6cec5b3d46e6a41d7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFaceCrop", [value]))

    @jsii.member(jsii_name="putFeatureCrop")
    def put_feature_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareFeatureCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8e44e4681136abc990b8499a0f186c8c74d38407d200297cc9ee362bdf4e1a75)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFeatureCrop", [value]))

    @jsii.member(jsii_name="putFitAndFill")
    def put_fit_and_fill(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareFitAndFill, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d93f3927f49c95e4179ba73312a2bc8d9ea5b1256c2a4e8e66b0c2f821f0121c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFitAndFill", [value]))

    @jsii.member(jsii_name="putGoop")
    def put_goop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareGoop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__181740d58fc1e50d974b1cdcb64325b56476181449d7b5eac401018218a7c118)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGoop", [value]))

    @jsii.member(jsii_name="putGrayscale")
    def put_grayscale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareGrayscale, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fc3bf9109d6e7952758d1f4f8cde107b18a307b96f6e0731e5046605284b96b9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGrayscale", [value]))

    @jsii.member(jsii_name="putHsl")
    def put_hsl(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareHsl, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0bf4f7a9645bc519e99a36f4bb38eebbd3ac436c55e3a0379da633d179815862)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsl", [value]))

    @jsii.member(jsii_name="putHsv")
    def put_hsv(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareHsv, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__60f5063a4a6a6f108a89e8ef4b45efdd240b4b0843f391bc3aa16e6f43509f29)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsv", [value]))

    @jsii.member(jsii_name="putIfDimension")
    def put_if_dimension(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimension, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1c272f476fbdedd7e2fe7130efc9e30ca1724100956c84d979ed0fe1af8ed29d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfDimension", [value]))

    @jsii.member(jsii_name="putIfOrientation")
    def put_if_orientation(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__90bc1c545abd319b89a0cabdcaa14f2da14418cc47f617fab69c7558176edc18)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfOrientation", [value]))

    @jsii.member(jsii_name="putImQuery")
    def put_im_query(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareImQuery, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__012cbb2381f5db5af6a2bead786ec6431f8ebc394200ab6e854e3cefa464122c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putImQuery", [value]))

    @jsii.member(jsii_name="putMaxColors")
    def put_max_colors(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareMaxColors, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__800a9695ae7da23844a03c9e690a5d317809ea90c7d59b14610003a0b3db7619)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMaxColors", [value]))

    @jsii.member(jsii_name="putMirror")
    def put_mirror(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareMirror, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f4f013517dac55f0a8df40e3473b07779302e4264c6a9a2f7a9cdcabbc8d37df)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMirror", [value]))

    @jsii.member(jsii_name="putMonoHue")
    def put_mono_hue(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareMonoHue, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__141ec74ed71d04dff1406e9dd3f57aed540f5d9b4d5ac357ba8a23b12bcccc2d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMonoHue", [value]))

    @jsii.member(jsii_name="putOpacity")
    def put_opacity(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareOpacity, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7479b864a6e4d9c418b5cef43b2d9c4790b5cfca89605537ea728bd82cb648da)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putOpacity", [value]))

    @jsii.member(jsii_name="putRegionOfInterestCrop")
    def put_region_of_interest_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareRegionOfInterestCrop", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a1f5904fd51f61d893e3a4365868f0cbf382a62e202f69ab898f26ac634773dc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRegionOfInterestCrop", [value]))

    @jsii.member(jsii_name="putRelativeCrop")
    def put_relative_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareRelativeCrop", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__279a2d0144203dd6ef0e5a0afc48a930ce62612556133099625a9907e553c176)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRelativeCrop", [value]))

    @jsii.member(jsii_name="putRemoveColor")
    def put_remove_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareRemoveColor", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f05a3901bce1bb38406614a00e14aea080856f98500a571294e7d97625a17918)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRemoveColor", [value]))

    @jsii.member(jsii_name="putResize")
    def put_resize(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareResize", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__00eeb29516fb8a638af8f7ece4763e7f1e82afd906d298c24fa0b14b403a7f29)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putResize", [value]))

    @jsii.member(jsii_name="putRotate")
    def put_rotate(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareRotate", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e8a1d735281a3c6f132788a26f7f23f0f90041228bd4b64c6a6a491016ff9d07)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRotate", [value]))

    @jsii.member(jsii_name="putScale")
    def put_scale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareScale", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d1d9cea98f58a9bb308eb636b92a1635589a994d09b7663fd6f10b5bbf4621db)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putScale", [value]))

    @jsii.member(jsii_name="putShear")
    def put_shear(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareShear", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e08e975a1e7f2e929102c733a16d766ba5c88b7a0f68a6300c7840b37db4b5f5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putShear", [value]))

    @jsii.member(jsii_name="putTrim")
    def put_trim(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareTrim", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__974cd3ed8dc1648035bdcccef005cd0a1afe915d5e9e2ac5b0cf88d2598eff87)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTrim", [value]))

    @jsii.member(jsii_name="putUnsharpMask")
    def put_unsharp_mask(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareUnsharpMask", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6bdba9c940b20104eb756dfd3bf8cb485c36c9ca027a40a66d8eaea2b16c2eef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putUnsharpMask", [value]))

    @jsii.member(jsii_name="resetAppend")
    def reset_append(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAppend", []))

    @jsii.member(jsii_name="resetAspectCrop")
    def reset_aspect_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspectCrop", []))

    @jsii.member(jsii_name="resetBackgroundColor")
    def reset_background_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBackgroundColor", []))

    @jsii.member(jsii_name="resetBlur")
    def reset_blur(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBlur", []))

    @jsii.member(jsii_name="resetChromaKey")
    def reset_chroma_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChromaKey", []))

    @jsii.member(jsii_name="resetComposite")
    def reset_composite(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetComposite", []))

    @jsii.member(jsii_name="resetCompound")
    def reset_compound(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCompound", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetCrop")
    def reset_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCrop", []))

    @jsii.member(jsii_name="resetFaceCrop")
    def reset_face_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFaceCrop", []))

    @jsii.member(jsii_name="resetFeatureCrop")
    def reset_feature_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureCrop", []))

    @jsii.member(jsii_name="resetFitAndFill")
    def reset_fit_and_fill(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFitAndFill", []))

    @jsii.member(jsii_name="resetGoop")
    def reset_goop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGoop", []))

    @jsii.member(jsii_name="resetGrayscale")
    def reset_grayscale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGrayscale", []))

    @jsii.member(jsii_name="resetHsl")
    def reset_hsl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsl", []))

    @jsii.member(jsii_name="resetHsv")
    def reset_hsv(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsv", []))

    @jsii.member(jsii_name="resetIfDimension")
    def reset_if_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfDimension", []))

    @jsii.member(jsii_name="resetIfOrientation")
    def reset_if_orientation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfOrientation", []))

    @jsii.member(jsii_name="resetImQuery")
    def reset_im_query(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetImQuery", []))

    @jsii.member(jsii_name="resetMaxColors")
    def reset_max_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxColors", []))

    @jsii.member(jsii_name="resetMirror")
    def reset_mirror(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMirror", []))

    @jsii.member(jsii_name="resetMonoHue")
    def reset_mono_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonoHue", []))

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetRegionOfInterestCrop")
    def reset_region_of_interest_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRegionOfInterestCrop", []))

    @jsii.member(jsii_name="resetRelativeCrop")
    def reset_relative_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRelativeCrop", []))

    @jsii.member(jsii_name="resetRemoveColor")
    def reset_remove_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRemoveColor", []))

    @jsii.member(jsii_name="resetResize")
    def reset_resize(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetResize", []))

    @jsii.member(jsii_name="resetRotate")
    def reset_rotate(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRotate", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetShear")
    def reset_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetShear", []))

    @jsii.member(jsii_name="resetTrim")
    def reset_trim(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTrim", []))

    @jsii.member(jsii_name="resetUnsharpMask")
    def reset_unsharp_mask(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUnsharpMask", []))

    @builtins.property
    @jsii.member(jsii_name="append")
    def append(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareAppendList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareAppendList, jsii.get(self, "append"))

    @builtins.property
    @jsii.member(jsii_name="aspectCrop")
    def aspect_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareAspectCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareAspectCropList, jsii.get(self, "aspectCrop"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColor")
    def background_color(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareBackgroundColorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareBackgroundColorList, jsii.get(self, "backgroundColor"))

    @builtins.property
    @jsii.member(jsii_name="blur")
    def blur(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareBlurList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareBlurList, jsii.get(self, "blur"))

    @builtins.property
    @jsii.member(jsii_name="chromaKey")
    def chroma_key(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareChromaKeyList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareChromaKeyList, jsii.get(self, "chromaKey"))

    @builtins.property
    @jsii.member(jsii_name="composite")
    def composite(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareCompositeList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareCompositeList, jsii.get(self, "composite"))

    @builtins.property
    @jsii.member(jsii_name="compound")
    def compound(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareCompoundList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareCompoundList, jsii.get(self, "compound"))

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareContrastList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareContrastList, jsii.get(self, "contrast"))

    @builtins.property
    @jsii.member(jsii_name="crop")
    def crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareCropList, jsii.get(self, "crop"))

    @builtins.property
    @jsii.member(jsii_name="faceCrop")
    def face_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareFaceCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareFaceCropList, jsii.get(self, "faceCrop"))

    @builtins.property
    @jsii.member(jsii_name="featureCrop")
    def feature_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareFeatureCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareFeatureCropList, jsii.get(self, "featureCrop"))

    @builtins.property
    @jsii.member(jsii_name="fitAndFill")
    def fit_and_fill(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareFitAndFillList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareFitAndFillList, jsii.get(self, "fitAndFill"))

    @builtins.property
    @jsii.member(jsii_name="goop")
    def goop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareGoopList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareGoopList, jsii.get(self, "goop"))

    @builtins.property
    @jsii.member(jsii_name="grayscale")
    def grayscale(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareGrayscaleList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareGrayscaleList, jsii.get(self, "grayscale"))

    @builtins.property
    @jsii.member(jsii_name="hsl")
    def hsl(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareHslList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareHslList, jsii.get(self, "hsl"))

    @builtins.property
    @jsii.member(jsii_name="hsv")
    def hsv(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareHsvList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareHsvList, jsii.get(self, "hsv"))

    @builtins.property
    @jsii.member(jsii_name="ifDimension")
    def if_dimension(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionList, jsii.get(self, "ifDimension"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientation")
    def if_orientation(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationList, jsii.get(self, "ifOrientation"))

    @builtins.property
    @jsii.member(jsii_name="imQuery")
    def im_query(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareImQueryList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareImQueryList, jsii.get(self, "imQuery"))

    @builtins.property
    @jsii.member(jsii_name="maxColors")
    def max_colors(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareMaxColorsList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareMaxColorsList, jsii.get(self, "maxColors"))

    @builtins.property
    @jsii.member(jsii_name="mirror")
    def mirror(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareMirrorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareMirrorList, jsii.get(self, "mirror"))

    @builtins.property
    @jsii.member(jsii_name="monoHue")
    def mono_hue(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareMonoHueList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareMonoHueList, jsii.get(self, "monoHue"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareOpacityList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareOpacityList, jsii.get(self, "opacity"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestCrop")
    def region_of_interest_crop(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareRegionOfInterestCropList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareRegionOfInterestCropList", jsii.get(self, "regionOfInterestCrop"))

    @builtins.property
    @jsii.member(jsii_name="relativeCrop")
    def relative_crop(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareRelativeCropList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareRelativeCropList", jsii.get(self, "relativeCrop"))

    @builtins.property
    @jsii.member(jsii_name="removeColor")
    def remove_color(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareRemoveColorList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareRemoveColorList", jsii.get(self, "removeColor"))

    @builtins.property
    @jsii.member(jsii_name="resize")
    def resize(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareResizeList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareResizeList", jsii.get(self, "resize"))

    @builtins.property
    @jsii.member(jsii_name="rotate")
    def rotate(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareRotateList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareRotateList", jsii.get(self, "rotate"))

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareScaleList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareScaleList", jsii.get(self, "scale"))

    @builtins.property
    @jsii.member(jsii_name="shear")
    def shear(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareShearList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareShearList", jsii.get(self, "shear"))

    @builtins.property
    @jsii.member(jsii_name="trim")
    def trim(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareTrimList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareTrimList", jsii.get(self, "trim"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMask")
    def unsharp_mask(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareUnsharpMaskList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareUnsharpMaskList", jsii.get(self, "unsharpMask"))

    @builtins.property
    @jsii.member(jsii_name="appendInput")
    def append_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareAppend]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareAppend]]], jsii.get(self, "appendInput"))

    @builtins.property
    @jsii.member(jsii_name="aspectCropInput")
    def aspect_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareAspectCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareAspectCrop]]], jsii.get(self, "aspectCropInput"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColorInput")
    def background_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareBackgroundColor]]], jsii.get(self, "backgroundColorInput"))

    @builtins.property
    @jsii.member(jsii_name="blurInput")
    def blur_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareBlur]]], jsii.get(self, "blurInput"))

    @builtins.property
    @jsii.member(jsii_name="chromaKeyInput")
    def chroma_key_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareChromaKey]]], jsii.get(self, "chromaKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="compositeInput")
    def composite_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareComposite]]], jsii.get(self, "compositeInput"))

    @builtins.property
    @jsii.member(jsii_name="compoundInput")
    def compound_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareCompound]]], jsii.get(self, "compoundInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareContrast]]], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="cropInput")
    def crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareCrop]]], jsii.get(self, "cropInput"))

    @builtins.property
    @jsii.member(jsii_name="faceCropInput")
    def face_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareFaceCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareFaceCrop]]], jsii.get(self, "faceCropInput"))

    @builtins.property
    @jsii.member(jsii_name="featureCropInput")
    def feature_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareFeatureCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareFeatureCrop]]], jsii.get(self, "featureCropInput"))

    @builtins.property
    @jsii.member(jsii_name="fitAndFillInput")
    def fit_and_fill_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareFitAndFill]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareFitAndFill]]], jsii.get(self, "fitAndFillInput"))

    @builtins.property
    @jsii.member(jsii_name="goopInput")
    def goop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareGoop]]], jsii.get(self, "goopInput"))

    @builtins.property
    @jsii.member(jsii_name="grayscaleInput")
    def grayscale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareGrayscale]]], jsii.get(self, "grayscaleInput"))

    @builtins.property
    @jsii.member(jsii_name="hslInput")
    def hsl_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareHsl]]], jsii.get(self, "hslInput"))

    @builtins.property
    @jsii.member(jsii_name="hsvInput")
    def hsv_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareHsv]]], jsii.get(self, "hsvInput"))

    @builtins.property
    @jsii.member(jsii_name="ifDimensionInput")
    def if_dimension_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimension]]], jsii.get(self, "ifDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientationInput")
    def if_orientation_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientation]]], jsii.get(self, "ifOrientationInput"))

    @builtins.property
    @jsii.member(jsii_name="imQueryInput")
    def im_query_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareImQuery]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareImQuery]]], jsii.get(self, "imQueryInput"))

    @builtins.property
    @jsii.member(jsii_name="maxColorsInput")
    def max_colors_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareMaxColors]]], jsii.get(self, "maxColorsInput"))

    @builtins.property
    @jsii.member(jsii_name="mirrorInput")
    def mirror_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareMirror]]], jsii.get(self, "mirrorInput"))

    @builtins.property
    @jsii.member(jsii_name="monoHueInput")
    def mono_hue_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareMonoHue]]], jsii.get(self, "monoHueInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareOpacity]]], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestCropInput")
    def region_of_interest_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareRegionOfInterestCrop"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareRegionOfInterestCrop"]]], jsii.get(self, "regionOfInterestCropInput"))

    @builtins.property
    @jsii.member(jsii_name="relativeCropInput")
    def relative_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareRelativeCrop"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareRelativeCrop"]]], jsii.get(self, "relativeCropInput"))

    @builtins.property
    @jsii.member(jsii_name="removeColorInput")
    def remove_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareRemoveColor"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareRemoveColor"]]], jsii.get(self, "removeColorInput"))

    @builtins.property
    @jsii.member(jsii_name="resizeInput")
    def resize_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareResize"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareResize"]]], jsii.get(self, "resizeInput"))

    @builtins.property
    @jsii.member(jsii_name="rotateInput")
    def rotate_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareRotate"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareRotate"]]], jsii.get(self, "rotateInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareScale"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareScale"]]], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="shearInput")
    def shear_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareShear"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareShear"]]], jsii.get(self, "shearInput"))

    @builtins.property
    @jsii.member(jsii_name="trimInput")
    def trim_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareTrim"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareTrim"]]], jsii.get(self, "trimInput"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMaskInput")
    def unsharp_mask_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareUnsharpMask"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareUnsharpMask"]]], jsii.get(self, "unsharpMaskInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquare]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquare], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquare],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__711862abab1ab80f0b4d250cd0b6f7db9ba05394bd9cd1e258afd1ab0959cdaa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareRegionOfInterestCrop",
    jsii_struct_bases=[],
    name_mapping={
        "region_of_interest": "regionOfInterest",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareRegionOfInterestCrop:
    def __init__(
        self,
        *,
        region_of_interest: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareRegionOfInterestCropRegionOfInterest", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param region_of_interest: region_of_interest block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest DataAkamaiImagingPolicyImage#region_of_interest}
        :param gravity: The placement of the crop area relative to the specified area of interest. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: The placement of the crop area relative to the specified area of interest. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param style: Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(region_of_interest, dict):
            region_of_interest = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareRegionOfInterestCropRegionOfInterest(**region_of_interest)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f7691d1b519c22d732987a397153a7b52f999f9fb8d9876960f3edf71748fed4)
            check_type(argname="argument region_of_interest", value=region_of_interest, expected_type=type_hints["region_of_interest"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "region_of_interest": region_of_interest,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def region_of_interest(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareRegionOfInterestCropRegionOfInterest":
        '''region_of_interest block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest DataAkamaiImagingPolicyImage#region_of_interest}
        '''
        result = self._values.get("region_of_interest")
        assert result is not None, "Required property 'region_of_interest' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareRegionOfInterestCropRegionOfInterest", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''The placement of the crop area relative to the specified area of interest.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''The placement of the crop area relative to the specified area of interest.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareRegionOfInterestCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareRegionOfInterestCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareRegionOfInterestCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9373732cc1910c3abe845091e0191325037b89ee9cd7e88ab285c28a5d59dbdd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareRegionOfInterestCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2901dc9035c0b06d4192c332bdb0a668790dd941d86bd627d3b4be1af05558cd)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareRegionOfInterestCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__351a4a7e2a33e08150d8efbe7521ce4593878cc9e2c3c4b90353712506b94fb3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9383b43cbc3e54d2c1f6ad2de5567a4be68a5a3ee68f9d56cbf8bdf414cebca8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__67879de032b568534055b7b29e7605c9c4bfa166ee319568f6a3dae14d4f33be)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareRegionOfInterestCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareRegionOfInterestCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareRegionOfInterestCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__271f9b076668a70489fcb0a25aadc0c331effb01ffe1fa560afb7217006f2c43)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareRegionOfInterestCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareRegionOfInterestCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0bed9e744ef08a218ed23889bf61463887e387cba0d7ac03718d54b40caf5a33)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putRegionOfInterest")
    def put_region_of_interest(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareRegionOfInterestCropRegionOfInterest()

        return typing.cast(None, jsii.invoke(self, "putRegionOfInterest", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterest")
    def region_of_interest(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareRegionOfInterestCropRegionOfInterestOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareRegionOfInterestCropRegionOfInterestOutputReference", jsii.get(self, "regionOfInterest"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestInput")
    def region_of_interest_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareRegionOfInterestCropRegionOfInterest"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareRegionOfInterestCropRegionOfInterest"], jsii.get(self, "regionOfInterestInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__22a48f407af871acc45c91b58eda96ef2b238be77e86658010a420653bf872ab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2e12f0bbc0b68f1229b4ae69f3f378d22161613a3a789cddcc4bf174426f424d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d5839becdb1999436ad185580bd09f4f14cca556c4097ca2a9e27ee1ced7bcc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__72f734424260a7729e8fde4082decf4fb456809374cd93cb46ebd508c65c8e04)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dd31847a3ba858bbe304c000d65d7e92cb0fc5855cffa310bcd48ad5844ebac4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a687b833a8f2e48f3c4181546a300b90b9e566e1da589208c2f8a17d22c8a788)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bec3a7764b6bc897a9473dd66c4bcf8e09bab40f8596736e9b0d233a2a5ac1af)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eba820e77cee569994dcfd4f0673462de86cf9cf2a564ae62aae11b8258bc15c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareRegionOfInterestCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareRegionOfInterestCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareRegionOfInterestCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac417f0c82c5377ee20645feba63f9a9a98904aa2cecf443478a48f7cf713784)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareRegionOfInterestCropRegionOfInterest",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareRegionOfInterestCropRegionOfInterest:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareRegionOfInterestCropRegionOfInterest(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareRegionOfInterestCropRegionOfInterestOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareRegionOfInterestCropRegionOfInterestOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__874244e238aae7f9f43ccc665a88930e384348fb2aeaba1f7396a14db4365d1d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareRegionOfInterestCropRegionOfInterest]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareRegionOfInterestCropRegionOfInterest], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareRegionOfInterestCropRegionOfInterest],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e97005febbb8ebfc09f815bf8c973115f7f350559b56817cf3f670bb530a106)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareRelativeCrop",
    jsii_struct_bases=[],
    name_mapping={
        "east": "east",
        "east_var": "eastVar",
        "north": "north",
        "north_var": "northVar",
        "south": "south",
        "south_var": "southVar",
        "west": "west",
        "west_var": "westVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareRelativeCrop:
    def __init__(
        self,
        *,
        east: typing.Optional[builtins.str] = None,
        east_var: typing.Optional[builtins.str] = None,
        north: typing.Optional[builtins.str] = None,
        north_var: typing.Optional[builtins.str] = None,
        south: typing.Optional[builtins.str] = None,
        south_var: typing.Optional[builtins.str] = None,
        west: typing.Optional[builtins.str] = None,
        west_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param east: The number of pixels to shrink or expand the right side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east DataAkamaiImagingPolicyImage#east}
        :param east_var: The number of pixels to shrink or expand the right side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east_var DataAkamaiImagingPolicyImage#east_var}
        :param north: The number of pixels to shrink or expand the top side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north DataAkamaiImagingPolicyImage#north}
        :param north_var: The number of pixels to shrink or expand the top side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north_var DataAkamaiImagingPolicyImage#north_var}
        :param south: The number of pixels to shrink or expand the bottom side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south DataAkamaiImagingPolicyImage#south}
        :param south_var: The number of pixels to shrink or expand the bottom side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south_var DataAkamaiImagingPolicyImage#south_var}
        :param west: The number of pixels to shrink or expand the left side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west DataAkamaiImagingPolicyImage#west}
        :param west_var: The number of pixels to shrink or expand the left side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west_var DataAkamaiImagingPolicyImage#west_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c8ab8976591100e53e6ee621ab40c6c6dd00bc19f34c5055acb7aa0d07b02c7c)
            check_type(argname="argument east", value=east, expected_type=type_hints["east"])
            check_type(argname="argument east_var", value=east_var, expected_type=type_hints["east_var"])
            check_type(argname="argument north", value=north, expected_type=type_hints["north"])
            check_type(argname="argument north_var", value=north_var, expected_type=type_hints["north_var"])
            check_type(argname="argument south", value=south, expected_type=type_hints["south"])
            check_type(argname="argument south_var", value=south_var, expected_type=type_hints["south_var"])
            check_type(argname="argument west", value=west, expected_type=type_hints["west"])
            check_type(argname="argument west_var", value=west_var, expected_type=type_hints["west_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if east is not None:
            self._values["east"] = east
        if east_var is not None:
            self._values["east_var"] = east_var
        if north is not None:
            self._values["north"] = north
        if north_var is not None:
            self._values["north_var"] = north_var
        if south is not None:
            self._values["south"] = south
        if south_var is not None:
            self._values["south_var"] = south_var
        if west is not None:
            self._values["west"] = west
        if west_var is not None:
            self._values["west_var"] = west_var

    @builtins.property
    def east(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the right side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east DataAkamaiImagingPolicyImage#east}
        '''
        result = self._values.get("east")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def east_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the right side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east_var DataAkamaiImagingPolicyImage#east_var}
        '''
        result = self._values.get("east_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def north(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the top side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north DataAkamaiImagingPolicyImage#north}
        '''
        result = self._values.get("north")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def north_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the top side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north_var DataAkamaiImagingPolicyImage#north_var}
        '''
        result = self._values.get("north_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def south(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the bottom side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south DataAkamaiImagingPolicyImage#south}
        '''
        result = self._values.get("south")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def south_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the bottom side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south_var DataAkamaiImagingPolicyImage#south_var}
        '''
        result = self._values.get("south_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def west(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the left side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west DataAkamaiImagingPolicyImage#west}
        '''
        result = self._values.get("west")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def west_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the left side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west_var DataAkamaiImagingPolicyImage#west_var}
        '''
        result = self._values.get("west_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareRelativeCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareRelativeCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareRelativeCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0d1fe439e8b7840d9df5089a886bd69e814d4d7e6a6b3f6b369b19063fd8b2b9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareRelativeCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7eb55e5a87f5c5d190159b32727a0518870a8226df29b2a1b6f8c02decdf63ff)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareRelativeCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0de30aa426b72928e2f0731930772a8fa186e73fc029b1db7727ae8e15aeedec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1e98ecb41864ecab1414d04b89ef33368f1ea5a905124213d5fc9f0c93f136c3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__86bea19795b85a2343f871b04a6f5b2c8932864fb0bbc67073c581564addf527)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareRelativeCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareRelativeCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareRelativeCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__98740c1640546132e9003d71b9ccc5a709fec198a205cd05b7b3c8acd43deb81)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareRelativeCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareRelativeCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__970e880c2c869e7ba1102003c48d722f75dcd143b3490ec09ad16902ade82408)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetEast")
    def reset_east(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEast", []))

    @jsii.member(jsii_name="resetEastVar")
    def reset_east_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEastVar", []))

    @jsii.member(jsii_name="resetNorth")
    def reset_north(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNorth", []))

    @jsii.member(jsii_name="resetNorthVar")
    def reset_north_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNorthVar", []))

    @jsii.member(jsii_name="resetSouth")
    def reset_south(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSouth", []))

    @jsii.member(jsii_name="resetSouthVar")
    def reset_south_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSouthVar", []))

    @jsii.member(jsii_name="resetWest")
    def reset_west(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWest", []))

    @jsii.member(jsii_name="resetWestVar")
    def reset_west_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWestVar", []))

    @builtins.property
    @jsii.member(jsii_name="eastInput")
    def east_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "eastInput"))

    @builtins.property
    @jsii.member(jsii_name="eastVarInput")
    def east_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "eastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="northInput")
    def north_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "northInput"))

    @builtins.property
    @jsii.member(jsii_name="northVarInput")
    def north_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "northVarInput"))

    @builtins.property
    @jsii.member(jsii_name="southInput")
    def south_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "southInput"))

    @builtins.property
    @jsii.member(jsii_name="southVarInput")
    def south_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "southVarInput"))

    @builtins.property
    @jsii.member(jsii_name="westInput")
    def west_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "westInput"))

    @builtins.property
    @jsii.member(jsii_name="westVarInput")
    def west_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "westVarInput"))

    @builtins.property
    @jsii.member(jsii_name="east")
    def east(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "east"))

    @east.setter
    def east(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7852167b4e590c395cb9fdd986ca664f68655fd26ce40d7fc19bc4f22305a97f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "east", value)

    @builtins.property
    @jsii.member(jsii_name="eastVar")
    def east_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "eastVar"))

    @east_var.setter
    def east_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__47b924471a75fc3ad529c6446742a0d005dedbaa0d8f391e821f0a6a746ffdc1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "eastVar", value)

    @builtins.property
    @jsii.member(jsii_name="north")
    def north(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "north"))

    @north.setter
    def north(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b6eb5e3ecd5aae98119ee1cb2e27eb5bd35ca66f1a509079bf9258452c40c73f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "north", value)

    @builtins.property
    @jsii.member(jsii_name="northVar")
    def north_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "northVar"))

    @north_var.setter
    def north_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4c367a28fc058c69c4174293a45cdf7a988ceaefbf0c897203d29621cbe4d58e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "northVar", value)

    @builtins.property
    @jsii.member(jsii_name="south")
    def south(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "south"))

    @south.setter
    def south(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a7c417390d249e88ac9707b33cc407ceb121f90702b40d051888c9919cce7642)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "south", value)

    @builtins.property
    @jsii.member(jsii_name="southVar")
    def south_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "southVar"))

    @south_var.setter
    def south_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ab36bc4c91b443911f07fae0994da52b4dba816b092bdc052b288cde183b9bd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "southVar", value)

    @builtins.property
    @jsii.member(jsii_name="west")
    def west(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "west"))

    @west.setter
    def west(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9593c331c27f6ad1d687fc0fefe093a712d0a2031356ba548b0ed9242c4c2c59)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "west", value)

    @builtins.property
    @jsii.member(jsii_name="westVar")
    def west_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "westVar"))

    @west_var.setter
    def west_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a68594d2ee4907e8e5e901a9e058f8af82d6cd2e5ec3a3f09d75bf280965117a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "westVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareRelativeCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareRelativeCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareRelativeCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__52a66f11007716e371a534f6489243df728f6e2dff9f061e6290d4f29e4a28c4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareRemoveColor",
    jsii_struct_bases=[],
    name_mapping={
        "color": "color",
        "color_var": "colorVar",
        "feather": "feather",
        "feather_var": "featherVar",
        "tolerance": "tolerance",
        "tolerance_var": "toleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareRemoveColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
        feather: typing.Optional[builtins.str] = None,
        feather_var: typing.Optional[builtins.str] = None,
        tolerance: typing.Optional[builtins.str] = None,
        tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        :param feather: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        :param feather_var: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        :param tolerance: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        :param tolerance_var: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8e0f4cadc4e06959e5cd1a0f9961c2da4d30709c7428e4e22a2bd32d1ea7c233)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
            check_type(argname="argument feather", value=feather, expected_type=type_hints["feather"])
            check_type(argname="argument feather_var", value=feather_var, expected_type=type_hints["feather_var"])
            check_type(argname="argument tolerance", value=tolerance, expected_type=type_hints["tolerance"])
            check_type(argname="argument tolerance_var", value=tolerance_var, expected_type=type_hints["tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var
        if feather is not None:
            self._values["feather"] = feather
        if feather_var is not None:
            self._values["feather_var"] = feather_var
        if tolerance is not None:
            self._values["tolerance"] = tolerance
        if tolerance_var is not None:
            self._values["tolerance_var"] = tolerance_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        '''
        result = self._values.get("feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather_var(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        '''
        result = self._values.get("feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        '''
        result = self._values.get("tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance_var(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        result = self._values.get("tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareRemoveColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareRemoveColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareRemoveColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ad80a89809534a515d3c4a9fa9a908e2267dc49860e0fc7613a955752cddf035)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareRemoveColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__204485192a44ec25d73548a77febbd51d555893ae9fbb3ffc588c9a3cec475e5)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareRemoveColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__694eb9c5d0f06aa1f91a12c07b91a0aa9fe4e0b6d46d186e33504687c022693b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5d9ee76e27a217f60a084d3591f61473b37d11f0eb0c38534601e91692f7f538)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b873cecf6a075d4fefdaaf6359aba8b9f3cb651d03852c278f86e85167159809)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareRemoveColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareRemoveColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareRemoveColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a6587e7ca2fd37a4428e22b2c0ef007d916a3af07aa76f1c62bf9ede172b36b7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareRemoveColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareRemoveColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9890727cafceb5638ca2e5866be1ccb1a80834bdd096e0091d99995c9cff0ee2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @jsii.member(jsii_name="resetFeather")
    def reset_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeather", []))

    @jsii.member(jsii_name="resetFeatherVar")
    def reset_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatherVar", []))

    @jsii.member(jsii_name="resetTolerance")
    def reset_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTolerance", []))

    @jsii.member(jsii_name="resetToleranceVar")
    def reset_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featherInput")
    def feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherInput"))

    @builtins.property
    @jsii.member(jsii_name="featherVarInput")
    def feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceInput")
    def tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceVarInput")
    def tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7299e213b269e46841db0b27b6bb55830dcfff22b6f1f50643ea0da0d5f0116a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__970bed297f11a713cb5c29ac8047626cf891682ed58555abecc68a052342e4f4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="feather")
    def feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "feather"))

    @feather.setter
    def feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7ebc5a402fd146ac7e50c221a4bcefdd996bac4b3e33ef31a5f066ab7dfc5a5c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "feather", value)

    @builtins.property
    @jsii.member(jsii_name="featherVar")
    def feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featherVar"))

    @feather_var.setter
    def feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8e8ac22cc7e740ba39b42dafd216e25eab708ad80310aabced546b0f63073fc5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featherVar", value)

    @builtins.property
    @jsii.member(jsii_name="tolerance")
    def tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tolerance"))

    @tolerance.setter
    def tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8c93f979e1c1aa2ded6668dca44c8ef0706f775d695b738effff997d05928e23)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tolerance", value)

    @builtins.property
    @jsii.member(jsii_name="toleranceVar")
    def tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "toleranceVar"))

    @tolerance_var.setter
    def tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__60be1521ece58f995496ab48c58ca037fc76066d779679e3d397ffc0fd3a798b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "toleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareRemoveColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareRemoveColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareRemoveColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__49cd4cc592af9df95601af7da240234f2e9c33fc3d5163747265d7421e023f2d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareResize",
    jsii_struct_bases=[],
    name_mapping={
        "aspect": "aspect",
        "aspect_var": "aspectVar",
        "height": "height",
        "height_var": "heightVar",
        "type": "type",
        "type_var": "typeVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareResize:
    def __init__(
        self,
        *,
        aspect: typing.Optional[builtins.str] = None,
        aspect_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param aspect: Preserves the aspect ratio. Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect DataAkamaiImagingPolicyImage#aspect}
        :param aspect_var: Preserves the aspect ratio. Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_var DataAkamaiImagingPolicyImage#aspect_var}
        :param height: The height to resize the source image to. Must be set if height is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height to resize the source image to. Must be set if height is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param type: Sets constraints for the image resize. Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: Sets constraints for the image resize. Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        :param width: The width to resize the source image to. Must be set if width is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width to resize the source image to. Must be set if width is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a58290f38b6a6cd6ee30548c91eaa987e3fec7e3f788b117b806d1fcb4f3575)
            check_type(argname="argument aspect", value=aspect, expected_type=type_hints["aspect"])
            check_type(argname="argument aspect_var", value=aspect_var, expected_type=type_hints["aspect_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if aspect is not None:
            self._values["aspect"] = aspect
        if aspect_var is not None:
            self._values["aspect_var"] = aspect_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def aspect(self) -> typing.Optional[builtins.str]:
        '''Preserves the aspect ratio.

        Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect DataAkamaiImagingPolicyImage#aspect}
        '''
        result = self._values.get("aspect")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def aspect_var(self) -> typing.Optional[builtins.str]:
        '''Preserves the aspect ratio.

        Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_var DataAkamaiImagingPolicyImage#aspect_var}
        '''
        result = self._values.get("aspect_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height to resize the source image to. Must be set if height is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height to resize the source image to. Must be set if height is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''Sets constraints for the image resize.

        Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''Sets constraints for the image resize.

        Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width to resize the source image to. Must be set if width is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width to resize the source image to. Must be set if width is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareResize(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareResizeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareResizeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fcba1c29bc508fb8b8cf540966ef2138dc90231471416b7856e2b675d232b1d9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareResizeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e920b65114739cf43e409cb95090b76a42bbbfb378e1231e3382e81cd71426f5)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareResizeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__029af152b7520daac9fe3706c4a46082d97092b9206280979740a8bee6c93cd3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e06784ffb36adcd035e7c092ddd0b0b329e82ff58505da79ba479a78fc30bba3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cf4de2111303660f73bdb3f88a45fe673820f17ca1b96007584184a34a3f337b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareResize]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareResize]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareResize]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__24a5f3419922f9bb553778e3d56ed39c3b8d8d66d16e3caed09b2e0f9c71d009)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareResizeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareResizeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be7d0ecfb40844b344b710afcf605678a807ab5c2550e574af79b0c990acd717)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAspect")
    def reset_aspect(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspect", []))

    @jsii.member(jsii_name="resetAspectVar")
    def reset_aspect_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspectVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="aspectInput")
    def aspect_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "aspectInput"))

    @builtins.property
    @jsii.member(jsii_name="aspectVarInput")
    def aspect_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "aspectVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="aspect")
    def aspect(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "aspect"))

    @aspect.setter
    def aspect(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d5cd2170bb68442b9d29dcb7747afc7f91907d54c57dc4cdd4b9c1c53b37518f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "aspect", value)

    @builtins.property
    @jsii.member(jsii_name="aspectVar")
    def aspect_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "aspectVar"))

    @aspect_var.setter
    def aspect_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3f19579970ee31f6da53df1762efc4c08ea42368d026c3e2c565ddf3cc92b788)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "aspectVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4fbf2ef374632cc9927ea1aa182c91887fa4dc18617d847d4fac4bd4b11e5f3d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be9dc1e97a6235e772898a4a27646d07396e68b4fc21f74a3b6bbd2903b0f809)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dcfabbae8c4afe62d98ccee1f54b45697f36b1a766d1631cda14d32eb6cf35e4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__68958b526109cd4ada84faaf54ef8b35abbf53ca06f5b838eb8c01e52b6da903)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dbaabed79f90e776333208a9fd35c904f2ff29aa7433040a47a0371563454a41)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8206dc080adf0d4f4a86a12dc2b7f37b48798948bdf67079b69d1a1050d86722)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareResize]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareResize]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareResize]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc533681cddff983da7c464e3425a804a6bd6467fe0147991023cd8c352a269f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareRotate",
    jsii_struct_bases=[],
    name_mapping={"degrees": "degrees", "degrees_var": "degreesVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareRotate:
    def __init__(
        self,
        *,
        degrees: typing.Optional[builtins.str] = None,
        degrees_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param degrees: The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees DataAkamaiImagingPolicyImage#degrees}
        :param degrees_var: The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees_var DataAkamaiImagingPolicyImage#degrees_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__acca0dfd9a8270371bef5454821a182197a13cad8e18a38e48d64a72a652f2ab)
            check_type(argname="argument degrees", value=degrees, expected_type=type_hints["degrees"])
            check_type(argname="argument degrees_var", value=degrees_var, expected_type=type_hints["degrees_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if degrees is not None:
            self._values["degrees"] = degrees
        if degrees_var is not None:
            self._values["degrees_var"] = degrees_var

    @builtins.property
    def degrees(self) -> typing.Optional[builtins.str]:
        '''The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees DataAkamaiImagingPolicyImage#degrees}
        '''
        result = self._values.get("degrees")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def degrees_var(self) -> typing.Optional[builtins.str]:
        '''The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees_var DataAkamaiImagingPolicyImage#degrees_var}
        '''
        result = self._values.get("degrees_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareRotate(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareRotateList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareRotateList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__02ae553bc926523f8768fc3b96b5cf8071644b3e6ff47c450ca6be5b27ba80d6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareRotateOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e3967244de7f6418d4b89ce5343b8e2936c7a3372017062767007b057592d085)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareRotateOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__01ba6bf9759ac55586620a95d9ca949eaf4d6c21799a1d5f9501b7430a486fb3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f277ffe81b92fc35779fdd702e9ef137a40b73b357ffed656e677e30de11efe9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b2aad9ac3d9d380468395b59234aa02f184de32603f61308cfdc8e8743d69d99)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareRotate]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareRotate]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareRotate]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b03e361a1a3d781e15a771f5ef33aea2345864fb884aa88ada3ebeca3e7cdf22)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareRotateOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareRotateOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c9bf16b44630abaf2ff5f66738b778cd2ae79b589c2b5198ef49e50a00cb2744)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetDegrees")
    def reset_degrees(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDegrees", []))

    @jsii.member(jsii_name="resetDegreesVar")
    def reset_degrees_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDegreesVar", []))

    @builtins.property
    @jsii.member(jsii_name="degreesInput")
    def degrees_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "degreesInput"))

    @builtins.property
    @jsii.member(jsii_name="degreesVarInput")
    def degrees_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "degreesVarInput"))

    @builtins.property
    @jsii.member(jsii_name="degrees")
    def degrees(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "degrees"))

    @degrees.setter
    def degrees(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a348d08907c3c9c74a90dfa44082b19fd681942717a822190ca94140609e9664)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "degrees", value)

    @builtins.property
    @jsii.member(jsii_name="degreesVar")
    def degrees_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "degreesVar"))

    @degrees_var.setter
    def degrees_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ad9261946ee3cf4195a15bb667a33fc44675e10d3494bdec093ffb8eeba00b9f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "degreesVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareRotate]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareRotate]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareRotate]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__808620f5c01180c204035a0f6502ae614e34000fbe65356b79c2e2a1e18a2e56)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareScale",
    jsii_struct_bases=[],
    name_mapping={
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareScale:
    def __init__(
        self,
        *,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param height: Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged. Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged. Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f02213b372f4b7831e51677cd9e3d1b70760ddf6e038e742d6bb2a0beece98e4)
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size.

        Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size.

        Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged.

        Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged.

        Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareScale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareScaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareScaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__338b91dc1c190fc5d830a81a29ee846a21c1f0279cfc3f7250a3cecbabfa7f91)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareScaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d0d43e41e9116776ba9b872b3dd2f81270c651cd0018fefc44167ed902f936a8)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareScaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__561d8760470370d0c4bc75febd538b4256b6c3c209bb76f6cdef7e72767ef172)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__107bfa893e2e171b248e40da19effbd439f141a2c2180a330dc60e9b51250bd1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__52e6f466a85cd6a3d728c62fd2c80bee2cba06ac09411fcd0ebb2d129bfb2de7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareScale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareScale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareScale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c50dfeb59c1cc1de39d0860dfe18134401b7e6c537afd2e8dee4e4f0b232e0aa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareScaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareScaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ba6b379a26d4ca4fc24444b76defe7028ff872f1418a50341a34b7e818140538)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__41121642b606f07639a7feae37c672cf1219ffffb6dd173d1f74028896b9b772)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df1d2a1ec6acf4fc966f38bac354526ccc09c2ba594f8c535128708760d00914)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8733aa6ac0e98e20ffa35d7f9317f06ea6c29a87d955ef48e96af4821157be7c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2c8a988d5b61e976834293aaecd7e1db8614dd9824dc6e9675d6d98d8d2c1f39)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareScale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareScale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareScale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__270eecb28b404057ab8458a1ee075addb2802f099b489d17ee7cad61febf9811)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareShear",
    jsii_struct_bases=[],
    name_mapping={
        "x_shear": "xShear",
        "x_shear_var": "xShearVar",
        "y_shear": "yShear",
        "y_shear_var": "yShearVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareShear:
    def __init__(
        self,
        *,
        x_shear: typing.Optional[builtins.str] = None,
        x_shear_var: typing.Optional[builtins.str] = None,
        y_shear: typing.Optional[builtins.str] = None,
        y_shear_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param x_shear: The amount to shear along the x-axis, measured in multiples of the image's width. Must be set if yShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear DataAkamaiImagingPolicyImage#x_shear}
        :param x_shear_var: The amount to shear along the x-axis, measured in multiples of the image's width. Must be set if yShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear_var DataAkamaiImagingPolicyImage#x_shear_var}
        :param y_shear: The amount to shear along the y-axis, measured in multiples of the image's height. Must be set if xShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear DataAkamaiImagingPolicyImage#y_shear}
        :param y_shear_var: The amount to shear along the y-axis, measured in multiples of the image's height. Must be set if xShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear_var DataAkamaiImagingPolicyImage#y_shear_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__348f03d3add342b70701d15d8812d84a816240632959e2499bca5d5d401eb605)
            check_type(argname="argument x_shear", value=x_shear, expected_type=type_hints["x_shear"])
            check_type(argname="argument x_shear_var", value=x_shear_var, expected_type=type_hints["x_shear_var"])
            check_type(argname="argument y_shear", value=y_shear, expected_type=type_hints["y_shear"])
            check_type(argname="argument y_shear_var", value=y_shear_var, expected_type=type_hints["y_shear_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if x_shear is not None:
            self._values["x_shear"] = x_shear
        if x_shear_var is not None:
            self._values["x_shear_var"] = x_shear_var
        if y_shear is not None:
            self._values["y_shear"] = y_shear
        if y_shear_var is not None:
            self._values["y_shear_var"] = y_shear_var

    @builtins.property
    def x_shear(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the x-axis, measured in multiples of the image's width.

        Must be set if yShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear DataAkamaiImagingPolicyImage#x_shear}
        '''
        result = self._values.get("x_shear")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_shear_var(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the x-axis, measured in multiples of the image's width.

        Must be set if yShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear_var DataAkamaiImagingPolicyImage#x_shear_var}
        '''
        result = self._values.get("x_shear_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_shear(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the y-axis, measured in multiples of the image's height.

        Must be set if xShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear DataAkamaiImagingPolicyImage#y_shear}
        '''
        result = self._values.get("y_shear")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_shear_var(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the y-axis, measured in multiples of the image's height.

        Must be set if xShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear_var DataAkamaiImagingPolicyImage#y_shear_var}
        '''
        result = self._values.get("y_shear_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareShear(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareShearList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareShearList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c64d4a5f6c2683b57f4651cc90c623e6967a57085b74b1b5685e8eaed0cd81c2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareShearOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9e388f08ce847f3fb8e0abd41c7159dc64e418ae16d7d793ccb91a3d5bf6eec9)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareShearOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b311d70025154b7290a781bf9bf0eeb93f5df9ffe359def3e287e373abfd52b6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__46b0918dafd11002c1b7dc979e7508d8b58168f94f6808f1fb8a89f90df3a224)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a6921c3690da90fa7ea77924790af184a18b04538c0d41fb5366626b746cb037)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareShear]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareShear]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareShear]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__de714a78d6b26d7c80ae068be36464a62e4c870da0810006948b0ca859f9c05d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareShearOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareShearOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6737f6db0170975bc2b5d996234dbfccb410ca6b12b0bc3922413ef1c3a59358)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetXShear")
    def reset_x_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXShear", []))

    @jsii.member(jsii_name="resetXShearVar")
    def reset_x_shear_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXShearVar", []))

    @jsii.member(jsii_name="resetYShear")
    def reset_y_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYShear", []))

    @jsii.member(jsii_name="resetYShearVar")
    def reset_y_shear_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYShearVar", []))

    @builtins.property
    @jsii.member(jsii_name="xShearInput")
    def x_shear_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xShearInput"))

    @builtins.property
    @jsii.member(jsii_name="xShearVarInput")
    def x_shear_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xShearVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yShearInput")
    def y_shear_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yShearInput"))

    @builtins.property
    @jsii.member(jsii_name="yShearVarInput")
    def y_shear_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yShearVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xShear")
    def x_shear(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xShear"))

    @x_shear.setter
    def x_shear(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3edc6631e0eea749fc223a9692378aaf8c79db8758a7829bf9036c09f4761253)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xShear", value)

    @builtins.property
    @jsii.member(jsii_name="xShearVar")
    def x_shear_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xShearVar"))

    @x_shear_var.setter
    def x_shear_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e241398a792562e6e3e4e50dd193772a7ad089f62f41ac01d9fe41a77f77ff43)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xShearVar", value)

    @builtins.property
    @jsii.member(jsii_name="yShear")
    def y_shear(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yShear"))

    @y_shear.setter
    def y_shear(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7049a37c94ec1e6a88a17ce118049faa026933d65f458ed8f6a27b346d04f88c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yShear", value)

    @builtins.property
    @jsii.member(jsii_name="yShearVar")
    def y_shear_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yShearVar"))

    @y_shear_var.setter
    def y_shear_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2079728811dd42b2f6105ed80f7848e80d1d6c2d34306c0dbe2e0895f94fa6ce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yShearVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareShear]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareShear]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareShear]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5a0741929caae962ef0cf309fd2e37fd37dc7bdde1f0759665cfe95b969829a4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareTrim",
    jsii_struct_bases=[],
    name_mapping={
        "fuzz": "fuzz",
        "fuzz_var": "fuzzVar",
        "padding": "padding",
        "padding_var": "paddingVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareTrim:
    def __init__(
        self,
        *,
        fuzz: typing.Optional[builtins.str] = None,
        fuzz_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fuzz: The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz DataAkamaiImagingPolicyImage#fuzz}
        :param fuzz_var: The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz_var DataAkamaiImagingPolicyImage#fuzz_var}
        :param padding: The amount of padding in pixels to add to the trimmed image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: The amount of padding in pixels to add to the trimmed image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__055c0431b4a634be8d9b98f333449a7f5fa738b6090af44f48f85cd35ebc2904)
            check_type(argname="argument fuzz", value=fuzz, expected_type=type_hints["fuzz"])
            check_type(argname="argument fuzz_var", value=fuzz_var, expected_type=type_hints["fuzz_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fuzz is not None:
            self._values["fuzz"] = fuzz
        if fuzz_var is not None:
            self._values["fuzz_var"] = fuzz_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var

    @builtins.property
    def fuzz(self) -> typing.Optional[builtins.str]:
        '''The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz DataAkamaiImagingPolicyImage#fuzz}
        '''
        result = self._values.get("fuzz")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fuzz_var(self) -> typing.Optional[builtins.str]:
        '''The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz_var DataAkamaiImagingPolicyImage#fuzz_var}
        '''
        result = self._values.get("fuzz_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''The amount of padding in pixels to add to the trimmed image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''The amount of padding in pixels to add to the trimmed image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareTrim(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareTrimList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareTrimList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__98e897a7bdf63d66dfed78f0c8962a2e60f3bcbda493178e3dfe69a9d8e97016)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareTrimOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4c149ca569300eecf96127c66de31b93ddba208e21bebed727d0162381c390fc)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareTrimOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2f481cb206cac9642d4c4468b48e7dff323e013a217d7bc7fa320e11500cf475)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e8556cd577b8aef9ec8b2932ceb87e22a147ce5ebecff8ae128d51d56d9ce72e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__90b2a87708e02471a8b708ea0741b8bb1725e6d809c9cd1b1598d3b7bb58d9f3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareTrim]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareTrim]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareTrim]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2f59e6f979c351a63951b66e250d0b1833c54fe9765270e65f8772d7952c4f38)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareTrimOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareTrimOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ee54d2128806da4a0edd2973e26384485852858bbfac731bf570c66206f4b8be)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetFuzz")
    def reset_fuzz(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFuzz", []))

    @jsii.member(jsii_name="resetFuzzVar")
    def reset_fuzz_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFuzzVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @builtins.property
    @jsii.member(jsii_name="fuzzInput")
    def fuzz_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fuzzInput"))

    @builtins.property
    @jsii.member(jsii_name="fuzzVarInput")
    def fuzz_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fuzzVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="fuzz")
    def fuzz(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fuzz"))

    @fuzz.setter
    def fuzz(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0c9478f86cb71b1a0c3c7ff27dc642245211e841163944fdf4990bd0f1a7aaff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fuzz", value)

    @builtins.property
    @jsii.member(jsii_name="fuzzVar")
    def fuzz_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fuzzVar"))

    @fuzz_var.setter
    def fuzz_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cbfd0c34867a74a4f08f4247d5a478cd49bbdb016a827e37a3688498e52ba646)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fuzzVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d26bf1ea727018a6e1ad2aaee849497f9e9f0fc9ffe68dbbb0922b3ffded6c4a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7bfc07222ceafa960b30764be2dc9debcc4a424205fc9c64f8269a159e8eac9b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareTrim]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareTrim]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareTrim]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__40d19a517dba5923938c2dcc756a9ce683cb71cc47e2325ed486d99ce8c6e0e6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareUnsharpMask",
    jsii_struct_bases=[],
    name_mapping={
        "gain": "gain",
        "gain_var": "gainVar",
        "sigma": "sigma",
        "sigma_var": "sigmaVar",
        "threshold": "threshold",
        "threshold_var": "thresholdVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareUnsharpMask:
    def __init__(
        self,
        *,
        gain: typing.Optional[builtins.str] = None,
        gain_var: typing.Optional[builtins.str] = None,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
        threshold: typing.Optional[builtins.str] = None,
        threshold_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param gain: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        :param gain_var: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        :param sigma: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        :param threshold: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        :param threshold_var: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__54c87dfa5c36ac686bb1e613bac7a3ce37c7683d6f425b696eef75e134d3c5c1)
            check_type(argname="argument gain", value=gain, expected_type=type_hints["gain"])
            check_type(argname="argument gain_var", value=gain_var, expected_type=type_hints["gain_var"])
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
            check_type(argname="argument threshold", value=threshold, expected_type=type_hints["threshold"])
            check_type(argname="argument threshold_var", value=threshold_var, expected_type=type_hints["threshold_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if gain is not None:
            self._values["gain"] = gain
        if gain_var is not None:
            self._values["gain_var"] = gain_var
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var
        if threshold is not None:
            self._values["threshold"] = threshold
        if threshold_var is not None:
            self._values["threshold_var"] = threshold_var

    @builtins.property
    def gain(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        '''
        result = self._values.get("gain")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gain_var(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        '''
        result = self._values.get("gain_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        '''
        result = self._values.get("threshold")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold_var(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        result = self._values.get("threshold_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareUnsharpMask(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareUnsharpMaskList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareUnsharpMaskList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b84848bff30a8041c1e118bfa070d64d3c8fbf2439df21a1682d37cd4ac4e77b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareUnsharpMaskOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__56eac269248a5eb97cc535a07087219c29260ef1c9b75377b2603a5cf85cf835)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareUnsharpMaskOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1b70932afba3119fd1b517f9316c350b7b292090120f584ec3d9291d6d47b005)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f864d4a1e664e63a1d2b7df49f2a12008358bb136dcd064e7ec2409e0b39ca26)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f585f8033f12c3cc499cb14e60a47908d578344ad715d8375e8a2419bace840c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareUnsharpMask]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareUnsharpMask]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareUnsharpMask]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1a37e45ef667dc43a98befc22488816e36bf9054ed8f53fc3d9cca8baf656865)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareUnsharpMaskOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareUnsharpMaskOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b78a4c726237e956fec13a6e86eccd86f8237fb8e47b822efb498c96e9b55f18)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetGain")
    def reset_gain(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGain", []))

    @jsii.member(jsii_name="resetGainVar")
    def reset_gain_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGainVar", []))

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @jsii.member(jsii_name="resetThreshold")
    def reset_threshold(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThreshold", []))

    @jsii.member(jsii_name="resetThresholdVar")
    def reset_threshold_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThresholdVar", []))

    @builtins.property
    @jsii.member(jsii_name="gainInput")
    def gain_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainInput"))

    @builtins.property
    @jsii.member(jsii_name="gainVarInput")
    def gain_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdInput")
    def threshold_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdVarInput")
    def threshold_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gain")
    def gain(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gain"))

    @gain.setter
    def gain(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e7814b69a1ecd89f067e9ee5e98c2f4b680ffce867a8c28cb519596ffee274cf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gain", value)

    @builtins.property
    @jsii.member(jsii_name="gainVar")
    def gain_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gainVar"))

    @gain_var.setter
    def gain_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d3192726687adc09d45a338d68c2f65b0668971636a64df83f9439e672c9c6d0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gainVar", value)

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__302eb32c2828a22c946c7a27672792a0ebb6bdae078bff507152e2bd7d7026de)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eba6107f9fbf60381aadd460acce546ee27df48716d235c596b72ae9dbf9a4c0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="threshold")
    def threshold(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "threshold"))

    @threshold.setter
    def threshold(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1d5a11f3177e6adac4cf70b8fd0eba791e16195380a4dc32a7911ccc2db0439d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "threshold", value)

    @builtins.property
    @jsii.member(jsii_name="thresholdVar")
    def threshold_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "thresholdVar"))

    @threshold_var.setter
    def threshold_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__da72c91b4f0a9724b610f65cc1521272d35df1244137c9a0084fc3e462e16f56)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "thresholdVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareUnsharpMask]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareUnsharpMask]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareUnsharpMask]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__221baee7b8ddd84765041d13eb78d71443b41648998bb7368cc39ee1f4d7b0bd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanImQuery",
    jsii_struct_bases=[],
    name_mapping={
        "allowed_transformations": "allowedTransformations",
        "query_var": "queryVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanImQuery:
    def __init__(
        self,
        *,
        allowed_transformations: typing.Sequence[builtins.str],
        query_var: builtins.str,
    ) -> None:
        '''
        :param allowed_transformations: Specifies the transformations that can be applied using the query string parameter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allowed_transformations DataAkamaiImagingPolicyImage#allowed_transformations}
        :param query_var: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#query_var DataAkamaiImagingPolicyImage#query_var}.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__27df9d17d7b5bb21b2b9cd8370d5ba370cae6b35edbbc6217b64d5a195da9a13)
            check_type(argname="argument allowed_transformations", value=allowed_transformations, expected_type=type_hints["allowed_transformations"])
            check_type(argname="argument query_var", value=query_var, expected_type=type_hints["query_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "allowed_transformations": allowed_transformations,
            "query_var": query_var,
        }

    @builtins.property
    def allowed_transformations(self) -> typing.List[builtins.str]:
        '''Specifies the transformations that can be applied using the query string parameter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allowed_transformations DataAkamaiImagingPolicyImage#allowed_transformations}
        '''
        result = self._values.get("allowed_transformations")
        assert result is not None, "Required property 'allowed_transformations' is missing"
        return typing.cast(typing.List[builtins.str], result)

    @builtins.property
    def query_var(self) -> builtins.str:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#query_var DataAkamaiImagingPolicyImage#query_var}.'''
        result = self._values.get("query_var")
        assert result is not None, "Required property 'query_var' is missing"
        return typing.cast(builtins.str, result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanImQuery(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanImQueryList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanImQueryList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__47431f7326e444f114d89fcddf4a7283df16f27c955e1fd520795f4c6a07ea2f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanImQueryOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ca3880b47c72ac2147e2d4aace942d238274cb1a12ce63adcd9aa584b534f94)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanImQueryOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dd755f5af7eda6e9ef6cbbde6770d0e06e13ad5771fe0e9c79721c09ee91ac70)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2bc5129cc389e0526694f8e501b3f5ec829e9220d7a6010970f42f62954ae8f9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__732b5264f44aed90b9d4b91488ea40ed380defeaca318f505d2ac08d5ddfc2fa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanImQuery]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanImQuery]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanImQuery]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__44139b9a7c50308f1877425af6f059571a0fd304bbe4b6861f929f885674a7a6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanImQueryOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanImQueryOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ec8d19587cee4f1c892ece3c724e439032ff8f0c09176418f78a89aa5e12bd48)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @builtins.property
    @jsii.member(jsii_name="allowedTransformationsInput")
    def allowed_transformations_input(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "allowedTransformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="queryVarInput")
    def query_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "queryVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowedTransformations")
    def allowed_transformations(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "allowedTransformations"))

    @allowed_transformations.setter
    def allowed_transformations(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3c2e76e536aaaeca7041faebfb6c8428ad0206a6cdc0c221eb466d3d8b51df83)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowedTransformations", value)

    @builtins.property
    @jsii.member(jsii_name="queryVar")
    def query_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "queryVar"))

    @query_var.setter
    def query_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__91e06a557c677df661a62f0786e98fb9ff1e08ee158a09ec928bb55b666464f5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "queryVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanImQuery]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanImQuery]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanImQuery]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2acf66bf8e11e20a7a66f740ad1350a40803ae3192257b3c5b34ac2181381a99)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanMaxColors",
    jsii_struct_bases=[],
    name_mapping={"colors": "colors", "colors_var": "colorsVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanMaxColors:
    def __init__(
        self,
        *,
        colors: typing.Optional[builtins.str] = None,
        colors_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param colors: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        :param colors_var: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f1d33d16067f101c5790b93df8367871b3d940a8f9b3d5b41eee8679b566437)
            check_type(argname="argument colors", value=colors, expected_type=type_hints["colors"])
            check_type(argname="argument colors_var", value=colors_var, expected_type=type_hints["colors_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if colors is not None:
            self._values["colors"] = colors
        if colors_var is not None:
            self._values["colors_var"] = colors_var

    @builtins.property
    def colors(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        '''
        result = self._values.get("colors")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def colors_var(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        result = self._values.get("colors_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanMaxColors(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanMaxColorsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanMaxColorsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab8bd48b54426ff09e8412f189dae7435115ee566a73c07b6c6d8489b2aecfb6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanMaxColorsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__607a99e85e3c723d8a2b46b9ab36a9d3ee8f7badbaa25998f0027e8c8b85774e)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanMaxColorsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5d0b6bf8439c8e294f97e187f28f613397f3e59cf4de994816458562d50c993f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__db6ad4a1d7ce54c0bbee9ce39cdf2212c36ed6cb072aefa4415f735dfc1e3e07)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ab5fc52535e15914449a4a79b2f09e7dcb459bf041fc60c29767c0c1f63eae3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanMaxColors]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanMaxColors]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__18f7004d5de067f66c21a0670cbbeb5c2644eeaad4636fb8b992bd310c1db0be)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanMaxColorsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanMaxColorsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ff7e5e2ec61abeacc4d3d5e68146baaf2913c4ac657618506d1960b3e514e2ec)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColors")
    def reset_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColors", []))

    @jsii.member(jsii_name="resetColorsVar")
    def reset_colors_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorsVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorsInput")
    def colors_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsInput"))

    @builtins.property
    @jsii.member(jsii_name="colorsVarInput")
    def colors_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsVarInput"))

    @builtins.property
    @jsii.member(jsii_name="colors")
    def colors(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colors"))

    @colors.setter
    def colors(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a930150c666789304b2dd91ce005ea14f54f8c0da2dcd88a1b02e4dbddde9f0c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colors", value)

    @builtins.property
    @jsii.member(jsii_name="colorsVar")
    def colors_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorsVar"))

    @colors_var.setter
    def colors_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__28345fc0ef18274ab3bc8f6fc2fcfc6ced86e54e99302ad77ca4e14fcd39e6ad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorsVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanMaxColors]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanMaxColors]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanMaxColors]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__87943979c65ecb658fd8a4fd0c87cbfd8ce001d8941a4607ae3393c6587388bb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanMirror",
    jsii_struct_bases=[],
    name_mapping={
        "horizontal": "horizontal",
        "horizontal_var": "horizontalVar",
        "vertical": "vertical",
        "vertical_var": "verticalVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanMirror:
    def __init__(
        self,
        *,
        horizontal: typing.Optional[builtins.str] = None,
        horizontal_var: typing.Optional[builtins.str] = None,
        vertical: typing.Optional[builtins.str] = None,
        vertical_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param horizontal: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        :param horizontal_var: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        :param vertical: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        :param vertical_var: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__200307cef3f1477e9b69e3f0da42ab4b92efb2b5cb20a22f2b95387d1498c3ed)
            check_type(argname="argument horizontal", value=horizontal, expected_type=type_hints["horizontal"])
            check_type(argname="argument horizontal_var", value=horizontal_var, expected_type=type_hints["horizontal_var"])
            check_type(argname="argument vertical", value=vertical, expected_type=type_hints["vertical"])
            check_type(argname="argument vertical_var", value=vertical_var, expected_type=type_hints["vertical_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if horizontal is not None:
            self._values["horizontal"] = horizontal
        if horizontal_var is not None:
            self._values["horizontal_var"] = horizontal_var
        if vertical is not None:
            self._values["vertical"] = vertical
        if vertical_var is not None:
            self._values["vertical_var"] = vertical_var

    @builtins.property
    def horizontal(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        '''
        result = self._values.get("horizontal")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def horizontal_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        '''
        result = self._values.get("horizontal_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        '''
        result = self._values.get("vertical")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        result = self._values.get("vertical_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanMirror(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanMirrorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanMirrorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__15a9ed69dbef3e39bda576c99ad8b0650b6b6ff4417dc701ed5df4dfa11b21a3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanMirrorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4e9cb6d3f92ff066c7a31f7094188dfbbb41198496c986b055907c4a97eaf21f)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanMirrorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f31f40a41f717a8211e1e169bc9efdf2d9dd73ca37f6fdaeecf4d269be6d4141)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0064e001f8525dd889a4a34b90ac725e1098daca52f5ef304151e9ad62d7a961)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__88e84a092131afa98567e59229e3289175e44bfc29797a19f17982ddb387d2f7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanMirror]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanMirror]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__44f8384737018178a32b9f365a82f4bb17c5963cc7623f89c10139ff183fb284)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanMirrorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanMirrorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__07d45a789c33e2e5521babc05186307cfbdf3072bea66afa0e184ccb94712e04)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHorizontal")
    def reset_horizontal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontal", []))

    @jsii.member(jsii_name="resetHorizontalVar")
    def reset_horizontal_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontalVar", []))

    @jsii.member(jsii_name="resetVertical")
    def reset_vertical(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVertical", []))

    @jsii.member(jsii_name="resetVerticalVar")
    def reset_vertical_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVerticalVar", []))

    @builtins.property
    @jsii.member(jsii_name="horizontalInput")
    def horizontal_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontalVarInput")
    def horizontal_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalInput")
    def vertical_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalVarInput")
    def vertical_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontal")
    def horizontal(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontal"))

    @horizontal.setter
    def horizontal(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b4c15760bab83ec74b4df663bb1d51a52b4a8a2b09b019775eb071fbd29ee732)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontal", value)

    @builtins.property
    @jsii.member(jsii_name="horizontalVar")
    def horizontal_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontalVar"))

    @horizontal_var.setter
    def horizontal_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__abff007efacb1c515535ee037eb4e06b81d7da15ab68f3bae82a39859ee44c04)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontalVar", value)

    @builtins.property
    @jsii.member(jsii_name="vertical")
    def vertical(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "vertical"))

    @vertical.setter
    def vertical(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4333e65d5d6985e0a69acf140a12434feeb0fa1c6de68552f82040f346ca9413)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "vertical", value)

    @builtins.property
    @jsii.member(jsii_name="verticalVar")
    def vertical_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "verticalVar"))

    @vertical_var.setter
    def vertical_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__924bf94b00dba68fe31e81b667e5ba9124c070d098979faad190426590b0e7db)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "verticalVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanMirror]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanMirror]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanMirror]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2f4d8659907f5baabcf8f26e8caac601ffddbe1df49590c6127afab87ea7e748)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanMonoHue",
    jsii_struct_bases=[],
    name_mapping={"hue": "hue", "hue_var": "hueVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanMonoHue:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__47c64757cfed73be4717ff738e2222ed84e51290f0b7fb336735b82b40714a3a)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanMonoHue(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanMonoHueList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanMonoHueList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e4caefbead836d4e3e358bd8f7d75143afb4f33e9345aaf7bec096ab9cb8dd12)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanMonoHueOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__faefacca505d40c2ae59aa27d75f920aa7f91418aae06c613e38e7fb45d4b42f)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanMonoHueOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fe9254f1c1b8f487e84ef7f54440c1eb8252d14915cfca133dd3e252f5f47dd7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__90acb729641eb328354ec04bab88de09704ad415ce44407ede21f7dfe8d5b007)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__26be2fb36ba053508562fc63c3c66dd19c8cdec714fe396f138bb861488f5a33)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanMonoHue]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanMonoHue]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d2dfb9ead40b7df6de9671232518edc6f71c7c5c86704b2a8c35278e8e0cc6d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanMonoHueOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanMonoHueOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__009262d722f128585ae9c2c4c5840240633a14eaadce2d88b1e9c1122c4ccd5b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__437d52cbae5a149a1902930fc1012637a468da966d9189520ca58d29c3b55aca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__538227276d9b3caf4ef97522742111cc3cb33bec8dc9504992ae7ece8baad907)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanMonoHue]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanMonoHue]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanMonoHue]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5beeeb358a56db377bdf2dcb8c21807d8165d0be873044d7e627c14922f3808d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanOpacity",
    jsii_struct_bases=[],
    name_mapping={"opacity": "opacity", "opacity_var": "opacityVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanOpacity:
    def __init__(
        self,
        *,
        opacity: typing.Optional[builtins.str] = None,
        opacity_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param opacity: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param opacity_var: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e62b2c263b951e14e48eef301d0f3cfb836f8e78beae3d9d55942ed47eb7a8f9)
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument opacity_var", value=opacity_var, expected_type=type_hints["opacity_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if opacity is not None:
            self._values["opacity"] = opacity
        if opacity_var is not None:
            self._values["opacity_var"] = opacity_var

    @builtins.property
    def opacity(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def opacity_var(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        result = self._values.get("opacity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanOpacity(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanOpacityList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanOpacityList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__826c59eb67afa8d17414efa32910f55c68267517a6a9632cc37b8ff013ccbaf5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanOpacityOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa116c91aa1e01b5c2cb304757d65c2088eea30d11e2b06c176b64dfbe71938d)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanOpacityOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6652245d519ca2210e9b4ef1d061968c184a400dd7be89bf45e5207a98f394c0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d747a4abb005ce97fbeb1a2a66390dc6d153bc6ac6f26efecc3d05d28f1ef5d6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__910db550efbc528209f69497c753d8673de793887da329d69f1d60dee93f6ce6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanOpacity]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanOpacity]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c1540cfa4bcd73ca736106824a56b1521e8e8dcc7a5f5aa8939f81c4ec291ad0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanOpacityOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanOpacityOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2759571ddf3ff86b8cd9fc28cc11237ecfad5c449d1ce892e5933eff09f36b4a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetOpacityVar")
    def reset_opacity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacityVar", []))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityVarInput")
    def opacity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacity"))

    @opacity.setter
    def opacity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__587b6d6d17f899522c815a869a0f9cfffa18b5a8e664a6d24c423d4c8d4fc37b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacity", value)

    @builtins.property
    @jsii.member(jsii_name="opacityVar")
    def opacity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacityVar"))

    @opacity_var.setter
    def opacity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d2d9b8ca71e13ccf4368e5055a40de40ab4a1bb575ad6f7916dc53de687c060)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacityVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanOpacity]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanOpacity]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanOpacity]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__acf7961f46ce4a5c8a836a3f39ae915eb0a29b4d3a31991bda7fa3ae116b2cd0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9dd16bc63285eb3662b9619f8e266fa82761fc811607b1b10e7bc372955f10b8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putAppend")
    def put_append(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppend, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3299b1cedf2cb95114dac6bbd1fba38b75a29de8ea274440833c83f24ed0bdb2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putAppend", [value]))

    @jsii.member(jsii_name="putAspectCrop")
    def put_aspect_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAspectCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fcb0fef59cdebb71edfae5aaca8a41a19f98a5491f933524e8f17b35df568535)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putAspectCrop", [value]))

    @jsii.member(jsii_name="putBackgroundColor")
    def put_background_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3eb955321fcc47edc92832ce514ce865f0639259cefee8303db22d5511cd543a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBackgroundColor", [value]))

    @jsii.member(jsii_name="putBlur")
    def put_blur(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanBlur, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d4253e73eafe38cdb6e8e41efbd6053bb6e83f0451f7b78368f8b3849fc47316)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBlur", [value]))

    @jsii.member(jsii_name="putChromaKey")
    def put_chroma_key(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanChromaKey, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb8512b1873d2f266e6a6e2675fc51ce582d9f24a23183bd9f659f79f630e257)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putChromaKey", [value]))

    @jsii.member(jsii_name="putComposite")
    def put_composite(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanComposite, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__85349a9774decafa598841cb4fe4b897c0d1254b98de69a307bd985fb96cb399)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putComposite", [value]))

    @jsii.member(jsii_name="putCompound")
    def put_compound(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompound, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c60fe71aec5593fb4925502c57cd26731a15d310bd1d6aa366232c149af55db6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCompound", [value]))

    @jsii.member(jsii_name="putContrast")
    def put_contrast(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanContrast, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__181ed0d72b45b23e877f76c905dee4ff3bfe9ab508c3233e80cf0388d91dfcc3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putContrast", [value]))

    @jsii.member(jsii_name="putCrop")
    def put_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f52541016561fd4a6daa3902c58aede1e7a8c973d437dd1b64df1d8d151020bb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCrop", [value]))

    @jsii.member(jsii_name="putFaceCrop")
    def put_face_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFaceCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__708738907954c12fcc59612d4207cb7f3c867eecec4ea65c83b47d4dc12ecc2e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFaceCrop", [value]))

    @jsii.member(jsii_name="putFeatureCrop")
    def put_feature_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFeatureCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0dfcf48ae332d0ec321409041314cc78f145eea4c657ba0fca7d2185f1937923)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFeatureCrop", [value]))

    @jsii.member(jsii_name="putFitAndFill")
    def put_fit_and_fill(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFill, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9dbb7af584a9f6b2a2bb0d880c59a691e7508df736711654a1146dc285ba1cf7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFitAndFill", [value]))

    @jsii.member(jsii_name="putGoop")
    def put_goop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanGoop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c0d9cb8c60d75eb63c7f381622cf535debe7597ca3fb0605121f851a989b482e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGoop", [value]))

    @jsii.member(jsii_name="putGrayscale")
    def put_grayscale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanGrayscale, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__42c126639eddc95a1a5b451c3ac312e82bb1b4362877fc158f615757a8e395bf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGrayscale", [value]))

    @jsii.member(jsii_name="putHsl")
    def put_hsl(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanHsl, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f0322dcc262c7e0c162c2d6cd1dab33081b0d853ed7567cd4aa44bec512dd325)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsl", [value]))

    @jsii.member(jsii_name="putHsv")
    def put_hsv(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanHsv, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__603b6f6ec40eff7f69e70a0ed8614f3573637d4da3e6ae2eee5cc1f7f8a248d5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsv", [value]))

    @jsii.member(jsii_name="putIfDimension")
    def put_if_dimension(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimension, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__241040ec4da82919dc6755ce0e859977a19663f5a513169a0ecffe1e13707d6e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfDimension", [value]))

    @jsii.member(jsii_name="putIfOrientation")
    def put_if_orientation(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9dbd9a2127215b651bc8b8705704d6d9ababe6d5d6d45ddc6d091b6e55eae27a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfOrientation", [value]))

    @jsii.member(jsii_name="putImQuery")
    def put_im_query(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanImQuery, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bf0eb608a9cbd2a3865b203f28f78358e46ade35338f6f567722e75cb155a344)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putImQuery", [value]))

    @jsii.member(jsii_name="putMaxColors")
    def put_max_colors(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanMaxColors, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ea517fbe634de265ae668c844a8ff94be5a32936d72fa3565499a689ce85b6f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMaxColors", [value]))

    @jsii.member(jsii_name="putMirror")
    def put_mirror(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanMirror, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be95a4427c1b67df00cbea4cf0f2440bbccba705b113c937d267208893cc1a36)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMirror", [value]))

    @jsii.member(jsii_name="putMonoHue")
    def put_mono_hue(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanMonoHue, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__932a442dd5590be6cad9397e2d7df3a3ee79f68e5b123a8860dbd9fbb65037a3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMonoHue", [value]))

    @jsii.member(jsii_name="putOpacity")
    def put_opacity(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanOpacity, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__376db59ecd8e77c937489beeafeff9bb436e94fe12313b0e104acf5a020d7f3a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putOpacity", [value]))

    @jsii.member(jsii_name="putRegionOfInterestCrop")
    def put_region_of_interest_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCrop", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__355b7b237f6af0f64bd57d45cb01367c09f1ce2556cf9f422a4dad69edc654d0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRegionOfInterestCrop", [value]))

    @jsii.member(jsii_name="putRelativeCrop")
    def put_relative_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRelativeCrop", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7691be4e7c5ef04adf64ad6e9b1ccaf14c3a3617d3fa1811fdf8b14ff6c4e804)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRelativeCrop", [value]))

    @jsii.member(jsii_name="putRemoveColor")
    def put_remove_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRemoveColor", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__59c5c47d97dc562c3409b2c184e16b08e393fa29cc7d6ac82337bcc13c42c14e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRemoveColor", [value]))

    @jsii.member(jsii_name="putResize")
    def put_resize(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanResize", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9061cda6780b4c38f5cfb092ab6b28420ddc283579820963949f5235c545396f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putResize", [value]))

    @jsii.member(jsii_name="putRotate")
    def put_rotate(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRotate", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d9d799871eca086e042d99b1bf1fd770955abf5384354f52e21fbc73724a756)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRotate", [value]))

    @jsii.member(jsii_name="putScale")
    def put_scale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanScale", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c603861bc2052ab363aa34e6befc56c22906963165fb4f555c4d9674f36052b9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putScale", [value]))

    @jsii.member(jsii_name="putShear")
    def put_shear(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanShear", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__de75c5d80a437a2b329c49192b4bf02f6089bbff255108f2164a0c466f1ee754)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putShear", [value]))

    @jsii.member(jsii_name="putTrim")
    def put_trim(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanTrim", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a2968e54fbcae45fc3f77923408f2d04b034889ef642d7c799ba55524a47dbde)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTrim", [value]))

    @jsii.member(jsii_name="putUnsharpMask")
    def put_unsharp_mask(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanUnsharpMask", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__92a6cc6950f34efd9989cad9c341999b313c00cdc8331820bdaf63b2571cdbac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putUnsharpMask", [value]))

    @jsii.member(jsii_name="resetAppend")
    def reset_append(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAppend", []))

    @jsii.member(jsii_name="resetAspectCrop")
    def reset_aspect_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspectCrop", []))

    @jsii.member(jsii_name="resetBackgroundColor")
    def reset_background_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBackgroundColor", []))

    @jsii.member(jsii_name="resetBlur")
    def reset_blur(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBlur", []))

    @jsii.member(jsii_name="resetChromaKey")
    def reset_chroma_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChromaKey", []))

    @jsii.member(jsii_name="resetComposite")
    def reset_composite(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetComposite", []))

    @jsii.member(jsii_name="resetCompound")
    def reset_compound(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCompound", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetCrop")
    def reset_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCrop", []))

    @jsii.member(jsii_name="resetFaceCrop")
    def reset_face_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFaceCrop", []))

    @jsii.member(jsii_name="resetFeatureCrop")
    def reset_feature_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureCrop", []))

    @jsii.member(jsii_name="resetFitAndFill")
    def reset_fit_and_fill(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFitAndFill", []))

    @jsii.member(jsii_name="resetGoop")
    def reset_goop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGoop", []))

    @jsii.member(jsii_name="resetGrayscale")
    def reset_grayscale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGrayscale", []))

    @jsii.member(jsii_name="resetHsl")
    def reset_hsl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsl", []))

    @jsii.member(jsii_name="resetHsv")
    def reset_hsv(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsv", []))

    @jsii.member(jsii_name="resetIfDimension")
    def reset_if_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfDimension", []))

    @jsii.member(jsii_name="resetIfOrientation")
    def reset_if_orientation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfOrientation", []))

    @jsii.member(jsii_name="resetImQuery")
    def reset_im_query(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetImQuery", []))

    @jsii.member(jsii_name="resetMaxColors")
    def reset_max_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxColors", []))

    @jsii.member(jsii_name="resetMirror")
    def reset_mirror(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMirror", []))

    @jsii.member(jsii_name="resetMonoHue")
    def reset_mono_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonoHue", []))

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetRegionOfInterestCrop")
    def reset_region_of_interest_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRegionOfInterestCrop", []))

    @jsii.member(jsii_name="resetRelativeCrop")
    def reset_relative_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRelativeCrop", []))

    @jsii.member(jsii_name="resetRemoveColor")
    def reset_remove_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRemoveColor", []))

    @jsii.member(jsii_name="resetResize")
    def reset_resize(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetResize", []))

    @jsii.member(jsii_name="resetRotate")
    def reset_rotate(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRotate", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetShear")
    def reset_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetShear", []))

    @jsii.member(jsii_name="resetTrim")
    def reset_trim(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTrim", []))

    @jsii.member(jsii_name="resetUnsharpMask")
    def reset_unsharp_mask(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUnsharpMask", []))

    @builtins.property
    @jsii.member(jsii_name="append")
    def append(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendList, jsii.get(self, "append"))

    @builtins.property
    @jsii.member(jsii_name="aspectCrop")
    def aspect_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAspectCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAspectCropList, jsii.get(self, "aspectCrop"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColor")
    def background_color(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanBackgroundColorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanBackgroundColorList, jsii.get(self, "backgroundColor"))

    @builtins.property
    @jsii.member(jsii_name="blur")
    def blur(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanBlurList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanBlurList, jsii.get(self, "blur"))

    @builtins.property
    @jsii.member(jsii_name="chromaKey")
    def chroma_key(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanChromaKeyList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanChromaKeyList, jsii.get(self, "chromaKey"))

    @builtins.property
    @jsii.member(jsii_name="composite")
    def composite(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeList, jsii.get(self, "composite"))

    @builtins.property
    @jsii.member(jsii_name="compound")
    def compound(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompoundList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompoundList, jsii.get(self, "compound"))

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanContrastList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanContrastList, jsii.get(self, "contrast"))

    @builtins.property
    @jsii.member(jsii_name="crop")
    def crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCropList, jsii.get(self, "crop"))

    @builtins.property
    @jsii.member(jsii_name="faceCrop")
    def face_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFaceCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFaceCropList, jsii.get(self, "faceCrop"))

    @builtins.property
    @jsii.member(jsii_name="featureCrop")
    def feature_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFeatureCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFeatureCropList, jsii.get(self, "featureCrop"))

    @builtins.property
    @jsii.member(jsii_name="fitAndFill")
    def fit_and_fill(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillList, jsii.get(self, "fitAndFill"))

    @builtins.property
    @jsii.member(jsii_name="goop")
    def goop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanGoopList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanGoopList, jsii.get(self, "goop"))

    @builtins.property
    @jsii.member(jsii_name="grayscale")
    def grayscale(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanGrayscaleList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanGrayscaleList, jsii.get(self, "grayscale"))

    @builtins.property
    @jsii.member(jsii_name="hsl")
    def hsl(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanHslList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanHslList, jsii.get(self, "hsl"))

    @builtins.property
    @jsii.member(jsii_name="hsv")
    def hsv(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanHsvList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanHsvList, jsii.get(self, "hsv"))

    @builtins.property
    @jsii.member(jsii_name="ifDimension")
    def if_dimension(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionList", jsii.get(self, "ifDimension"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientation")
    def if_orientation(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationList, jsii.get(self, "ifOrientation"))

    @builtins.property
    @jsii.member(jsii_name="imQuery")
    def im_query(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanImQueryList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanImQueryList, jsii.get(self, "imQuery"))

    @builtins.property
    @jsii.member(jsii_name="maxColors")
    def max_colors(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanMaxColorsList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanMaxColorsList, jsii.get(self, "maxColors"))

    @builtins.property
    @jsii.member(jsii_name="mirror")
    def mirror(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanMirrorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanMirrorList, jsii.get(self, "mirror"))

    @builtins.property
    @jsii.member(jsii_name="monoHue")
    def mono_hue(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanMonoHueList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanMonoHueList, jsii.get(self, "monoHue"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanOpacityList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanOpacityList, jsii.get(self, "opacity"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestCrop")
    def region_of_interest_crop(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropList", jsii.get(self, "regionOfInterestCrop"))

    @builtins.property
    @jsii.member(jsii_name="relativeCrop")
    def relative_crop(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRelativeCropList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRelativeCropList", jsii.get(self, "relativeCrop"))

    @builtins.property
    @jsii.member(jsii_name="removeColor")
    def remove_color(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRemoveColorList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRemoveColorList", jsii.get(self, "removeColor"))

    @builtins.property
    @jsii.member(jsii_name="resize")
    def resize(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanResizeList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanResizeList", jsii.get(self, "resize"))

    @builtins.property
    @jsii.member(jsii_name="rotate")
    def rotate(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRotateList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRotateList", jsii.get(self, "rotate"))

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanScaleList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanScaleList", jsii.get(self, "scale"))

    @builtins.property
    @jsii.member(jsii_name="shear")
    def shear(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanShearList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanShearList", jsii.get(self, "shear"))

    @builtins.property
    @jsii.member(jsii_name="trim")
    def trim(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanTrimList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanTrimList", jsii.get(self, "trim"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMask")
    def unsharp_mask(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanUnsharpMaskList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanUnsharpMaskList", jsii.get(self, "unsharpMask"))

    @builtins.property
    @jsii.member(jsii_name="appendInput")
    def append_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppend]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppend]]], jsii.get(self, "appendInput"))

    @builtins.property
    @jsii.member(jsii_name="aspectCropInput")
    def aspect_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAspectCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAspectCrop]]], jsii.get(self, "aspectCropInput"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColorInput")
    def background_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanBackgroundColor]]], jsii.get(self, "backgroundColorInput"))

    @builtins.property
    @jsii.member(jsii_name="blurInput")
    def blur_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanBlur]]], jsii.get(self, "blurInput"))

    @builtins.property
    @jsii.member(jsii_name="chromaKeyInput")
    def chroma_key_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanChromaKey]]], jsii.get(self, "chromaKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="compositeInput")
    def composite_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanComposite]]], jsii.get(self, "compositeInput"))

    @builtins.property
    @jsii.member(jsii_name="compoundInput")
    def compound_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompound]]], jsii.get(self, "compoundInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanContrast]]], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="cropInput")
    def crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCrop]]], jsii.get(self, "cropInput"))

    @builtins.property
    @jsii.member(jsii_name="faceCropInput")
    def face_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFaceCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFaceCrop]]], jsii.get(self, "faceCropInput"))

    @builtins.property
    @jsii.member(jsii_name="featureCropInput")
    def feature_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFeatureCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFeatureCrop]]], jsii.get(self, "featureCropInput"))

    @builtins.property
    @jsii.member(jsii_name="fitAndFillInput")
    def fit_and_fill_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFill]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFill]]], jsii.get(self, "fitAndFillInput"))

    @builtins.property
    @jsii.member(jsii_name="goopInput")
    def goop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanGoop]]], jsii.get(self, "goopInput"))

    @builtins.property
    @jsii.member(jsii_name="grayscaleInput")
    def grayscale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanGrayscale]]], jsii.get(self, "grayscaleInput"))

    @builtins.property
    @jsii.member(jsii_name="hslInput")
    def hsl_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanHsl]]], jsii.get(self, "hslInput"))

    @builtins.property
    @jsii.member(jsii_name="hsvInput")
    def hsv_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanHsv]]], jsii.get(self, "hsvInput"))

    @builtins.property
    @jsii.member(jsii_name="ifDimensionInput")
    def if_dimension_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimension]]], jsii.get(self, "ifDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientationInput")
    def if_orientation_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientation]]], jsii.get(self, "ifOrientationInput"))

    @builtins.property
    @jsii.member(jsii_name="imQueryInput")
    def im_query_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanImQuery]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanImQuery]]], jsii.get(self, "imQueryInput"))

    @builtins.property
    @jsii.member(jsii_name="maxColorsInput")
    def max_colors_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanMaxColors]]], jsii.get(self, "maxColorsInput"))

    @builtins.property
    @jsii.member(jsii_name="mirrorInput")
    def mirror_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanMirror]]], jsii.get(self, "mirrorInput"))

    @builtins.property
    @jsii.member(jsii_name="monoHueInput")
    def mono_hue_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanMonoHue]]], jsii.get(self, "monoHueInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanOpacity]]], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestCropInput")
    def region_of_interest_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCrop"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCrop"]]], jsii.get(self, "regionOfInterestCropInput"))

    @builtins.property
    @jsii.member(jsii_name="relativeCropInput")
    def relative_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRelativeCrop"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRelativeCrop"]]], jsii.get(self, "relativeCropInput"))

    @builtins.property
    @jsii.member(jsii_name="removeColorInput")
    def remove_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRemoveColor"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRemoveColor"]]], jsii.get(self, "removeColorInput"))

    @builtins.property
    @jsii.member(jsii_name="resizeInput")
    def resize_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanResize"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanResize"]]], jsii.get(self, "resizeInput"))

    @builtins.property
    @jsii.member(jsii_name="rotateInput")
    def rotate_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRotate"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRotate"]]], jsii.get(self, "rotateInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanScale"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanScale"]]], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="shearInput")
    def shear_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanShear"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanShear"]]], jsii.get(self, "shearInput"))

    @builtins.property
    @jsii.member(jsii_name="trimInput")
    def trim_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanTrim"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanTrim"]]], jsii.get(self, "trimInput"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMaskInput")
    def unsharp_mask_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanUnsharpMask"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanUnsharpMask"]]], jsii.get(self, "unsharpMaskInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__89f5c4091344468238920196c2f831905de5adaddf022da217351000760f0cf3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCrop",
    jsii_struct_bases=[],
    name_mapping={
        "region_of_interest": "regionOfInterest",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCrop:
    def __init__(
        self,
        *,
        region_of_interest: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterest", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param region_of_interest: region_of_interest block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest DataAkamaiImagingPolicyImage#region_of_interest}
        :param gravity: The placement of the crop area relative to the specified area of interest. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: The placement of the crop area relative to the specified area of interest. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param style: Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(region_of_interest, dict):
            region_of_interest = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterest(**region_of_interest)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5053b688169839460f7e4a546d7b2aba6f6ffe2e5e008e8b70a85fb93bd74c54)
            check_type(argname="argument region_of_interest", value=region_of_interest, expected_type=type_hints["region_of_interest"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "region_of_interest": region_of_interest,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def region_of_interest(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterest":
        '''region_of_interest block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest DataAkamaiImagingPolicyImage#region_of_interest}
        '''
        result = self._values.get("region_of_interest")
        assert result is not None, "Required property 'region_of_interest' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterest", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''The placement of the crop area relative to the specified area of interest.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''The placement of the crop area relative to the specified area of interest.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c1c9145aad579ced1b66b996cfb58d94655b0bdaaed9c6d03b4e1bc1388a8745)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__da9d574403885e49be6e06d2ff294a40f8bd8c890b8e739d9e7912fb48b70f4c)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e6df840adbb68f2885acc507d14a59fd537661bae04ae7dd5f2b74bb54cfab5d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4271fa1c6abfeea539267e2168a98defcd2075c73df962a06af48da24a690fb6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__478face309bf21fee84b714ca179b5dc052d65c00591229125aaf72d2913aaee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9baf2f2af1f58b33abd316fd6f0baa7647e4fdda88a5548605965e04d0447426)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e0e708aac1025fbf33c40927cf6acbbb2206bb673954c8f2f25586f35a46c4e7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putRegionOfInterest")
    def put_region_of_interest(
        self,
        *,
        circle_shape: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestCircleShape", typing.Dict[builtins.str, typing.Any]]]]] = None,
        point_shape: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestPointShape", typing.Dict[builtins.str, typing.Any]]]]] = None,
        polygon_shape: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestPolygonShape", typing.Dict[builtins.str, typing.Any]]]]] = None,
        rectangle_shape: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestRectangleShape", typing.Dict[builtins.str, typing.Any]]]]] = None,
        union_shape: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestUnionShape", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param circle_shape: circle_shape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#circle_shape DataAkamaiImagingPolicyImage#circle_shape}
        :param point_shape: point_shape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#point_shape DataAkamaiImagingPolicyImage#point_shape}
        :param polygon_shape: polygon_shape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#polygon_shape DataAkamaiImagingPolicyImage#polygon_shape}
        :param rectangle_shape: rectangle_shape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rectangle_shape DataAkamaiImagingPolicyImage#rectangle_shape}
        :param union_shape: union_shape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#union_shape DataAkamaiImagingPolicyImage#union_shape}
        '''
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterest(
            circle_shape=circle_shape,
            point_shape=point_shape,
            polygon_shape=polygon_shape,
            rectangle_shape=rectangle_shape,
            union_shape=union_shape,
        )

        return typing.cast(None, jsii.invoke(self, "putRegionOfInterest", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterest")
    def region_of_interest(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestOutputReference", jsii.get(self, "regionOfInterest"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestInput")
    def region_of_interest_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterest"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterest"], jsii.get(self, "regionOfInterestInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d63242a57ed95f7c432c1c4a32c4da861f7a938a6c854f260c1adac8275dbf6b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e3b57fa4b86c943c27ce9f491d6efc9ab2264a56f878c6d4c014c1056642695c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc83e43347db71a4acd52bab9f0aa17175346cce226a198067285248fcc53db3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3f8b943ff22f6b1137bbc9c078a1184a5640070c3ead3bba3000642bf48bda06)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__066b766bde160431a5a8628af290c788ea8f8622ec1d6560e313ab56ac26375a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__865d0db1828ab1f5bd8c917f877701000d4600b727f178305dd8669f3d8773fd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fab3b440f071e3c4401995cdf8444721f5560f8fb06f120a055227d47f140341)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__21712924f3c950c203b0ed941daa31694ba95d227817a6a011cc2c25e57e14c3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e83999d122bcb8c444724d936d944e7c995aa5c212e9da8b2abfd7f5ddc6c382)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterest",
    jsii_struct_bases=[],
    name_mapping={
        "circle_shape": "circleShape",
        "point_shape": "pointShape",
        "polygon_shape": "polygonShape",
        "rectangle_shape": "rectangleShape",
        "union_shape": "unionShape",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterest:
    def __init__(
        self,
        *,
        circle_shape: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestCircleShape", typing.Dict[builtins.str, typing.Any]]]]] = None,
        point_shape: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestPointShape", typing.Dict[builtins.str, typing.Any]]]]] = None,
        polygon_shape: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestPolygonShape", typing.Dict[builtins.str, typing.Any]]]]] = None,
        rectangle_shape: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestRectangleShape", typing.Dict[builtins.str, typing.Any]]]]] = None,
        union_shape: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestUnionShape", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param circle_shape: circle_shape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#circle_shape DataAkamaiImagingPolicyImage#circle_shape}
        :param point_shape: point_shape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#point_shape DataAkamaiImagingPolicyImage#point_shape}
        :param polygon_shape: polygon_shape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#polygon_shape DataAkamaiImagingPolicyImage#polygon_shape}
        :param rectangle_shape: rectangle_shape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rectangle_shape DataAkamaiImagingPolicyImage#rectangle_shape}
        :param union_shape: union_shape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#union_shape DataAkamaiImagingPolicyImage#union_shape}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1ab226e3ef70b1f7413335700ffd1805466f2d982e4599265276312291f095cd)
            check_type(argname="argument circle_shape", value=circle_shape, expected_type=type_hints["circle_shape"])
            check_type(argname="argument point_shape", value=point_shape, expected_type=type_hints["point_shape"])
            check_type(argname="argument polygon_shape", value=polygon_shape, expected_type=type_hints["polygon_shape"])
            check_type(argname="argument rectangle_shape", value=rectangle_shape, expected_type=type_hints["rectangle_shape"])
            check_type(argname="argument union_shape", value=union_shape, expected_type=type_hints["union_shape"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if circle_shape is not None:
            self._values["circle_shape"] = circle_shape
        if point_shape is not None:
            self._values["point_shape"] = point_shape
        if polygon_shape is not None:
            self._values["polygon_shape"] = polygon_shape
        if rectangle_shape is not None:
            self._values["rectangle_shape"] = rectangle_shape
        if union_shape is not None:
            self._values["union_shape"] = union_shape

    @builtins.property
    def circle_shape(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestCircleShape"]]]:
        '''circle_shape block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#circle_shape DataAkamaiImagingPolicyImage#circle_shape}
        '''
        result = self._values.get("circle_shape")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestCircleShape"]]], result)

    @builtins.property
    def point_shape(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestPointShape"]]]:
        '''point_shape block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#point_shape DataAkamaiImagingPolicyImage#point_shape}
        '''
        result = self._values.get("point_shape")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestPointShape"]]], result)

    @builtins.property
    def polygon_shape(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestPolygonShape"]]]:
        '''polygon_shape block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#polygon_shape DataAkamaiImagingPolicyImage#polygon_shape}
        '''
        result = self._values.get("polygon_shape")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestPolygonShape"]]], result)

    @builtins.property
    def rectangle_shape(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestRectangleShape"]]]:
        '''rectangle_shape block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rectangle_shape DataAkamaiImagingPolicyImage#rectangle_shape}
        '''
        result = self._values.get("rectangle_shape")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestRectangleShape"]]], result)

    @builtins.property
    def union_shape(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestUnionShape"]]]:
        '''union_shape block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#union_shape DataAkamaiImagingPolicyImage#union_shape}
        '''
        result = self._values.get("union_shape")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestUnionShape"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterest(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestCircleShape",
    jsii_struct_bases=[],
    name_mapping={"center": "center", "radius": "radius", "radius_var": "radiusVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestCircleShape:
    def __init__(
        self,
        *,
        center: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestCircleShapeCenter", typing.Dict[builtins.str, typing.Any]],
        radius: typing.Optional[builtins.str] = None,
        radius_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param center: center block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#center DataAkamaiImagingPolicyImage#center}
        :param radius: The radius of the circle measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#radius DataAkamaiImagingPolicyImage#radius}
        :param radius_var: The radius of the circle measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#radius_var DataAkamaiImagingPolicyImage#radius_var}
        '''
        if isinstance(center, dict):
            center = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestCircleShapeCenter(**center)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7dc193d644fab2a89feb99191ccf2812cb06bf6d55f2c3d8848fd4827829f84e)
            check_type(argname="argument center", value=center, expected_type=type_hints["center"])
            check_type(argname="argument radius", value=radius, expected_type=type_hints["radius"])
            check_type(argname="argument radius_var", value=radius_var, expected_type=type_hints["radius_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "center": center,
        }
        if radius is not None:
            self._values["radius"] = radius
        if radius_var is not None:
            self._values["radius_var"] = radius_var

    @builtins.property
    def center(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestCircleShapeCenter":
        '''center block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#center DataAkamaiImagingPolicyImage#center}
        '''
        result = self._values.get("center")
        assert result is not None, "Required property 'center' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestCircleShapeCenter", result)

    @builtins.property
    def radius(self) -> typing.Optional[builtins.str]:
        '''The radius of the circle measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#radius DataAkamaiImagingPolicyImage#radius}
        '''
        result = self._values.get("radius")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def radius_var(self) -> typing.Optional[builtins.str]:
        '''The radius of the circle measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#radius_var DataAkamaiImagingPolicyImage#radius_var}
        '''
        result = self._values.get("radius_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestCircleShape(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestCircleShapeCenter",
    jsii_struct_bases=[],
    name_mapping={"x": "x", "x_var": "xVar", "y": "y", "y_var": "yVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestCircleShapeCenter:
    def __init__(
        self,
        *,
        x: typing.Optional[builtins.str] = None,
        x_var: typing.Optional[builtins.str] = None,
        y: typing.Optional[builtins.str] = None,
        y_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param x: The horizontal position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x DataAkamaiImagingPolicyImage#x}
        :param x_var: The horizontal position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_var DataAkamaiImagingPolicyImage#x_var}
        :param y: The vertical position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y DataAkamaiImagingPolicyImage#y}
        :param y_var: The vertical position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_var DataAkamaiImagingPolicyImage#y_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a22da91ade073ec55d4bc82f89fa56d14796a048999328f97b5140645222e69)
            check_type(argname="argument x", value=x, expected_type=type_hints["x"])
            check_type(argname="argument x_var", value=x_var, expected_type=type_hints["x_var"])
            check_type(argname="argument y", value=y, expected_type=type_hints["y"])
            check_type(argname="argument y_var", value=y_var, expected_type=type_hints["y_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if x is not None:
            self._values["x"] = x
        if x_var is not None:
            self._values["x_var"] = x_var
        if y is not None:
            self._values["y"] = y
        if y_var is not None:
            self._values["y_var"] = y_var

    @builtins.property
    def x(self) -> typing.Optional[builtins.str]:
        '''The horizontal position of the point, measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x DataAkamaiImagingPolicyImage#x}
        '''
        result = self._values.get("x")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_var(self) -> typing.Optional[builtins.str]:
        '''The horizontal position of the point, measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_var DataAkamaiImagingPolicyImage#x_var}
        '''
        result = self._values.get("x_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y(self) -> typing.Optional[builtins.str]:
        '''The vertical position of the point, measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y DataAkamaiImagingPolicyImage#y}
        '''
        result = self._values.get("y")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_var(self) -> typing.Optional[builtins.str]:
        '''The vertical position of the point, measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_var DataAkamaiImagingPolicyImage#y_var}
        '''
        result = self._values.get("y_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestCircleShapeCenter(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestCircleShapeCenterOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestCircleShapeCenterOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__caa182c6e442aa65b757eeb2e7f64e29cb184a514d484d2108f77ba207995961)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetX")
    def reset_x(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetX", []))

    @jsii.member(jsii_name="resetXVar")
    def reset_x_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXVar", []))

    @jsii.member(jsii_name="resetY")
    def reset_y(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetY", []))

    @jsii.member(jsii_name="resetYVar")
    def reset_y_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYVar", []))

    @builtins.property
    @jsii.member(jsii_name="xInput")
    def x_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xInput"))

    @builtins.property
    @jsii.member(jsii_name="xVarInput")
    def x_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yInput")
    def y_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yInput"))

    @builtins.property
    @jsii.member(jsii_name="yVarInput")
    def y_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yVarInput"))

    @builtins.property
    @jsii.member(jsii_name="x")
    def x(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "x"))

    @x.setter
    def x(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b6dcc90da29ee23702df4c51f4d744d4ef59fbdc9fac076d95ccaeb6b875e7b6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "x", value)

    @builtins.property
    @jsii.member(jsii_name="xVar")
    def x_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xVar"))

    @x_var.setter
    def x_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4802837b7215c189c733819977e3070b5aa7c83642665155db13023f275dee3e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xVar", value)

    @builtins.property
    @jsii.member(jsii_name="y")
    def y(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "y"))

    @y.setter
    def y(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2df56f24ea5ffd7675281cb0d305824924077dfd34adc68e62d4364bc0ada1e0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "y", value)

    @builtins.property
    @jsii.member(jsii_name="yVar")
    def y_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yVar"))

    @y_var.setter
    def y_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__862b20938a31fec5f069c115203976abb29ae37a3b529644466a2585b1cbe2e6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestCircleShapeCenter]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestCircleShapeCenter], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestCircleShapeCenter],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ae17c064ef6ac0e2c4306e5a670ac2fb36ce334af18155eaa3943c3c6528428)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestCircleShapeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestCircleShapeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1622a1f619332c4008c98022331a0fa4beb29969bdbda3463d90679869ac99cc)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestCircleShapeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4fc64a7dbba03f3de0a43bb1e827ec18bb585c2f165c82e043acb550956f60ee)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestCircleShapeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__884fb78f5bf49808c09c7dfc1a8797bc79a4423444d7f52b56752c819c9ed161)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b71f0ecf70a1ec963bc6172eb730f18cdfeb1e6edec7148fac3886b81d43e1fb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1e0daca25f7137dd1cbc400135e58871856cf04f9d8a0b301be577448986121e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestCircleShape]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestCircleShape]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestCircleShape]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__384329ebd85a2dd9ebd70f17f38b5e4dd34cb0a707ceaa470c31679985149f96)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestCircleShapeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestCircleShapeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__17703ed471734f3deb66352711cb40a78323ebefa5953f36aa89f6ca0cb6fbbf)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putCenter")
    def put_center(
        self,
        *,
        x: typing.Optional[builtins.str] = None,
        x_var: typing.Optional[builtins.str] = None,
        y: typing.Optional[builtins.str] = None,
        y_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param x: The horizontal position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x DataAkamaiImagingPolicyImage#x}
        :param x_var: The horizontal position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_var DataAkamaiImagingPolicyImage#x_var}
        :param y: The vertical position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y DataAkamaiImagingPolicyImage#y}
        :param y_var: The vertical position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_var DataAkamaiImagingPolicyImage#y_var}
        '''
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestCircleShapeCenter(
            x=x, x_var=x_var, y=y, y_var=y_var
        )

        return typing.cast(None, jsii.invoke(self, "putCenter", [value]))

    @jsii.member(jsii_name="resetRadius")
    def reset_radius(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRadius", []))

    @jsii.member(jsii_name="resetRadiusVar")
    def reset_radius_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRadiusVar", []))

    @builtins.property
    @jsii.member(jsii_name="center")
    def center(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestCircleShapeCenterOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestCircleShapeCenterOutputReference, jsii.get(self, "center"))

    @builtins.property
    @jsii.member(jsii_name="centerInput")
    def center_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestCircleShapeCenter]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestCircleShapeCenter], jsii.get(self, "centerInput"))

    @builtins.property
    @jsii.member(jsii_name="radiusInput")
    def radius_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "radiusInput"))

    @builtins.property
    @jsii.member(jsii_name="radiusVarInput")
    def radius_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "radiusVarInput"))

    @builtins.property
    @jsii.member(jsii_name="radius")
    def radius(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "radius"))

    @radius.setter
    def radius(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__29367a716469bb906db38a757a8a8c0267e0ec6d2ca0228a690cbaa6f07c15ee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "radius", value)

    @builtins.property
    @jsii.member(jsii_name="radiusVar")
    def radius_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "radiusVar"))

    @radius_var.setter
    def radius_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__055f028747188dea4817a0142ee74a9d271d0de15a8638f8c2bb7384a6c0b1a9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "radiusVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestCircleShape]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestCircleShape]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestCircleShape]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd266b8462be37c17d37a13026f941917c9e182be8c647021d26fd6994f81212)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__471277c62e6a8fc721fac65d8a22e28803f75e1f56fdf3192605ecd61bb036ba)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putCircleShape")
    def put_circle_shape(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestCircleShape, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__578d555cf5cef78032d176529850b7b2539d7c9ad54278a75b28c8db00eaa3ef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCircleShape", [value]))

    @jsii.member(jsii_name="putPointShape")
    def put_point_shape(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestPointShape", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9eae7f3d0c3258d1b8b465a4bf2bcfd6213c3d4f1e48e6a640956faf30b9ee47)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putPointShape", [value]))

    @jsii.member(jsii_name="putPolygonShape")
    def put_polygon_shape(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestPolygonShape", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__49daf412d38f371d4bd5c2c759b78a73cf0660a3a39b06140e40e35bc754bd49)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putPolygonShape", [value]))

    @jsii.member(jsii_name="putRectangleShape")
    def put_rectangle_shape(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestRectangleShape", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8d160a6d4be46d7e0754d0baf513a78b8ef2d65e25dc458cef4fa30aa949286e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRectangleShape", [value]))

    @jsii.member(jsii_name="putUnionShape")
    def put_union_shape(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestUnionShape", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__545d39ff85520c8bc2c664114e12572ef2ab90625698d17316652935ec61bef4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putUnionShape", [value]))

    @jsii.member(jsii_name="resetCircleShape")
    def reset_circle_shape(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCircleShape", []))

    @jsii.member(jsii_name="resetPointShape")
    def reset_point_shape(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPointShape", []))

    @jsii.member(jsii_name="resetPolygonShape")
    def reset_polygon_shape(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPolygonShape", []))

    @jsii.member(jsii_name="resetRectangleShape")
    def reset_rectangle_shape(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRectangleShape", []))

    @jsii.member(jsii_name="resetUnionShape")
    def reset_union_shape(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUnionShape", []))

    @builtins.property
    @jsii.member(jsii_name="circleShape")
    def circle_shape(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestCircleShapeList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestCircleShapeList, jsii.get(self, "circleShape"))

    @builtins.property
    @jsii.member(jsii_name="pointShape")
    def point_shape(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestPointShapeList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestPointShapeList", jsii.get(self, "pointShape"))

    @builtins.property
    @jsii.member(jsii_name="polygonShape")
    def polygon_shape(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestPolygonShapeList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestPolygonShapeList", jsii.get(self, "polygonShape"))

    @builtins.property
    @jsii.member(jsii_name="rectangleShape")
    def rectangle_shape(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestRectangleShapeList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestRectangleShapeList", jsii.get(self, "rectangleShape"))

    @builtins.property
    @jsii.member(jsii_name="unionShape")
    def union_shape(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestUnionShapeList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestUnionShapeList", jsii.get(self, "unionShape"))

    @builtins.property
    @jsii.member(jsii_name="circleShapeInput")
    def circle_shape_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestCircleShape]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestCircleShape]]], jsii.get(self, "circleShapeInput"))

    @builtins.property
    @jsii.member(jsii_name="pointShapeInput")
    def point_shape_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestPointShape"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestPointShape"]]], jsii.get(self, "pointShapeInput"))

    @builtins.property
    @jsii.member(jsii_name="polygonShapeInput")
    def polygon_shape_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestPolygonShape"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestPolygonShape"]]], jsii.get(self, "polygonShapeInput"))

    @builtins.property
    @jsii.member(jsii_name="rectangleShapeInput")
    def rectangle_shape_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestRectangleShape"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestRectangleShape"]]], jsii.get(self, "rectangleShapeInput"))

    @builtins.property
    @jsii.member(jsii_name="unionShapeInput")
    def union_shape_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestUnionShape"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestUnionShape"]]], jsii.get(self, "unionShapeInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterest]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterest], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterest],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d3fda68f88435efd85501f5b855857c433dfe44504d3d449696db934e469f95b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestPointShape",
    jsii_struct_bases=[],
    name_mapping={"x": "x", "x_var": "xVar", "y": "y", "y_var": "yVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestPointShape:
    def __init__(
        self,
        *,
        x: typing.Optional[builtins.str] = None,
        x_var: typing.Optional[builtins.str] = None,
        y: typing.Optional[builtins.str] = None,
        y_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param x: The horizontal position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x DataAkamaiImagingPolicyImage#x}
        :param x_var: The horizontal position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_var DataAkamaiImagingPolicyImage#x_var}
        :param y: The vertical position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y DataAkamaiImagingPolicyImage#y}
        :param y_var: The vertical position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_var DataAkamaiImagingPolicyImage#y_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1bb32e00791bcd54417d144ff0c483c47f5e2d7ca8c10045d8de59654d0e4107)
            check_type(argname="argument x", value=x, expected_type=type_hints["x"])
            check_type(argname="argument x_var", value=x_var, expected_type=type_hints["x_var"])
            check_type(argname="argument y", value=y, expected_type=type_hints["y"])
            check_type(argname="argument y_var", value=y_var, expected_type=type_hints["y_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if x is not None:
            self._values["x"] = x
        if x_var is not None:
            self._values["x_var"] = x_var
        if y is not None:
            self._values["y"] = y
        if y_var is not None:
            self._values["y_var"] = y_var

    @builtins.property
    def x(self) -> typing.Optional[builtins.str]:
        '''The horizontal position of the point, measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x DataAkamaiImagingPolicyImage#x}
        '''
        result = self._values.get("x")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_var(self) -> typing.Optional[builtins.str]:
        '''The horizontal position of the point, measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_var DataAkamaiImagingPolicyImage#x_var}
        '''
        result = self._values.get("x_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y(self) -> typing.Optional[builtins.str]:
        '''The vertical position of the point, measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y DataAkamaiImagingPolicyImage#y}
        '''
        result = self._values.get("y")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_var(self) -> typing.Optional[builtins.str]:
        '''The vertical position of the point, measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_var DataAkamaiImagingPolicyImage#y_var}
        '''
        result = self._values.get("y_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestPointShape(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestPointShapeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestPointShapeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f64d714859a25a25a78f2ad73141cc37cdb152f9ce3f327e6bc527970c8403dd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestPointShapeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8ced08f2f952f180c6135f1769ca9e7587f17b7a361e732c493e4964f12a876f)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestPointShapeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__34e529e8823e70c49a9282c4b64175c2416c647f049f84a0cb5acc96e20caac3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0567c4ae111f854264507e2e115ff9904a7bce9784fd0ec34c5f41d721ea9e20)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2f4f0c6e80450a002e762785242a3b3dfa32a3725a9501eecd8144eaf5e0bb98)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestPointShape]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestPointShape]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestPointShape]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__023092c1b3997e737c7c2e09ffb5e12c4ea16ba24eda1a841c4a726990fa32ec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestPointShapeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestPointShapeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__13acd4be1d63a1645b6987faa43e05ab27fd62b233d31a44625b40e27b02a3ac)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetX")
    def reset_x(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetX", []))

    @jsii.member(jsii_name="resetXVar")
    def reset_x_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXVar", []))

    @jsii.member(jsii_name="resetY")
    def reset_y(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetY", []))

    @jsii.member(jsii_name="resetYVar")
    def reset_y_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYVar", []))

    @builtins.property
    @jsii.member(jsii_name="xInput")
    def x_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xInput"))

    @builtins.property
    @jsii.member(jsii_name="xVarInput")
    def x_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yInput")
    def y_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yInput"))

    @builtins.property
    @jsii.member(jsii_name="yVarInput")
    def y_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yVarInput"))

    @builtins.property
    @jsii.member(jsii_name="x")
    def x(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "x"))

    @x.setter
    def x(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0d4762adb462ae41b14282ce64513c4436fbbe497b51ed327b6a3166be8acd5f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "x", value)

    @builtins.property
    @jsii.member(jsii_name="xVar")
    def x_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xVar"))

    @x_var.setter
    def x_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__110ecb363837bc9a77d1effe6d916dd3197c23a356ba16cf1be4155935833a8a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xVar", value)

    @builtins.property
    @jsii.member(jsii_name="y")
    def y(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "y"))

    @y.setter
    def y(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9e8704893df0331733461ef227c9329c72b268038445266ef0530b1aa1bf2618)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "y", value)

    @builtins.property
    @jsii.member(jsii_name="yVar")
    def y_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yVar"))

    @y_var.setter
    def y_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__06c860172652f4ee6049c570e437062a75ca93033dc314e9df6157360e2c97ce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestPointShape]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestPointShape]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestPointShape]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__36b747f377c7cf4b3dd4ab7227250b8b9cdea2a529ec9c13b310e2e8535384e9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestPolygonShape",
    jsii_struct_bases=[],
    name_mapping={"points": "points"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestPolygonShape:
    def __init__(
        self,
        *,
        points: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestPolygonShapePoints", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param points: points block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#points DataAkamaiImagingPolicyImage#points}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2591dbef82a5e9e261479e241266e94fb15b19c2941afc320afea836c3b560dc)
            check_type(argname="argument points", value=points, expected_type=type_hints["points"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "points": points,
        }

    @builtins.property
    def points(
        self,
    ) -> typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestPolygonShapePoints"]]:
        '''points block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#points DataAkamaiImagingPolicyImage#points}
        '''
        result = self._values.get("points")
        assert result is not None, "Required property 'points' is missing"
        return typing.cast(typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestPolygonShapePoints"]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestPolygonShape(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestPolygonShapeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestPolygonShapeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__88b88752e4d35db46d36a14e0fe3978638388955793886e5e72d082d2c95557a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestPolygonShapeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8ef98b9d5dff32cdb45d007284054f393435d4d9a6c4fd0c6bbc41dcd49cbd2d)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestPolygonShapeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b688ff98ede8f7411856ffce2ac0c4e09ff5fd79e441100abb588f05f7f759d9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0b556524816cf83adb38f68879d88e3c85dc336db5e1839dbbcc317d0980a9cd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e13dfe268927b9e1b4d3e4cd81d5c0830508d038761e34b800296c557ee8604f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestPolygonShape]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestPolygonShape]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestPolygonShape]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a9df0149add867dcc426f7cca125ccd3f540039163258f912afc37ce0ad9b80)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestPolygonShapeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestPolygonShapeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af3b175a75cb593554e7fd26a74999f14ef540f3836864a8f2ae95f8951765be)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putPoints")
    def put_points(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestPolygonShapePoints", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c301c8d9d6097e4795141b2592aa55a8eed091d8a0da2567595073dfaf701c9e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putPoints", [value]))

    @builtins.property
    @jsii.member(jsii_name="points")
    def points(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestPolygonShapePointsList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestPolygonShapePointsList", jsii.get(self, "points"))

    @builtins.property
    @jsii.member(jsii_name="pointsInput")
    def points_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestPolygonShapePoints"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestPolygonShapePoints"]]], jsii.get(self, "pointsInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestPolygonShape]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestPolygonShape]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestPolygonShape]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9779d56a97dc7963904cbb007c455d4bc6efe870cc7baa38447df0fa1f11aa85)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestPolygonShapePoints",
    jsii_struct_bases=[],
    name_mapping={"x": "x", "x_var": "xVar", "y": "y", "y_var": "yVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestPolygonShapePoints:
    def __init__(
        self,
        *,
        x: typing.Optional[builtins.str] = None,
        x_var: typing.Optional[builtins.str] = None,
        y: typing.Optional[builtins.str] = None,
        y_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param x: The horizontal position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x DataAkamaiImagingPolicyImage#x}
        :param x_var: The horizontal position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_var DataAkamaiImagingPolicyImage#x_var}
        :param y: The vertical position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y DataAkamaiImagingPolicyImage#y}
        :param y_var: The vertical position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_var DataAkamaiImagingPolicyImage#y_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5535041faa9c79bc9e13d27810cd090442f87bb04fc9c411d836e7822f1614f8)
            check_type(argname="argument x", value=x, expected_type=type_hints["x"])
            check_type(argname="argument x_var", value=x_var, expected_type=type_hints["x_var"])
            check_type(argname="argument y", value=y, expected_type=type_hints["y"])
            check_type(argname="argument y_var", value=y_var, expected_type=type_hints["y_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if x is not None:
            self._values["x"] = x
        if x_var is not None:
            self._values["x_var"] = x_var
        if y is not None:
            self._values["y"] = y
        if y_var is not None:
            self._values["y_var"] = y_var

    @builtins.property
    def x(self) -> typing.Optional[builtins.str]:
        '''The horizontal position of the point, measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x DataAkamaiImagingPolicyImage#x}
        '''
        result = self._values.get("x")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_var(self) -> typing.Optional[builtins.str]:
        '''The horizontal position of the point, measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_var DataAkamaiImagingPolicyImage#x_var}
        '''
        result = self._values.get("x_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y(self) -> typing.Optional[builtins.str]:
        '''The vertical position of the point, measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y DataAkamaiImagingPolicyImage#y}
        '''
        result = self._values.get("y")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_var(self) -> typing.Optional[builtins.str]:
        '''The vertical position of the point, measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_var DataAkamaiImagingPolicyImage#y_var}
        '''
        result = self._values.get("y_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestPolygonShapePoints(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestPolygonShapePointsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestPolygonShapePointsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cef5a31486ce91278e2dba5c58303bbbfe0da6e6cedb82ce21fab5a0985241b2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestPolygonShapePointsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__206cf36d934023a0a3336ea11e35e07daff1c15ef41c4472e5438420d749f526)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestPolygonShapePointsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__72f4b26c2f391f82f0e048d756893f6ea49d8343c2da023fd1e2669387c4ffe1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cca8a4c8a2d98bb3d7afff4511e59fb623139512f96878be6e760750dc316d95)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__43c394c908118b1d2fc5e302e524a9ea04348f2a7821985062f0221564afea29)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestPolygonShapePoints]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestPolygonShapePoints]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestPolygonShapePoints]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__91b42d827cd44861f527e0544e674a92582eec213c98223ec7af3f001dbbbbb2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestPolygonShapePointsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestPolygonShapePointsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e655eac63b25c03d2d796f532a3a4178bd68f8efcf742cd50d522ef37ed46a38)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetX")
    def reset_x(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetX", []))

    @jsii.member(jsii_name="resetXVar")
    def reset_x_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXVar", []))

    @jsii.member(jsii_name="resetY")
    def reset_y(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetY", []))

    @jsii.member(jsii_name="resetYVar")
    def reset_y_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYVar", []))

    @builtins.property
    @jsii.member(jsii_name="xInput")
    def x_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xInput"))

    @builtins.property
    @jsii.member(jsii_name="xVarInput")
    def x_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yInput")
    def y_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yInput"))

    @builtins.property
    @jsii.member(jsii_name="yVarInput")
    def y_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yVarInput"))

    @builtins.property
    @jsii.member(jsii_name="x")
    def x(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "x"))

    @x.setter
    def x(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fabb962141501ce65c04a3c00c837d1f1c746a5d12683cd7880807397f9fc2bc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "x", value)

    @builtins.property
    @jsii.member(jsii_name="xVar")
    def x_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xVar"))

    @x_var.setter
    def x_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__652fac6d219bfa4950130bb3760dc81b25b76d4040d46f6a8270611ec4317b1e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xVar", value)

    @builtins.property
    @jsii.member(jsii_name="y")
    def y(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "y"))

    @y.setter
    def y(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4cdd3fad1db65c29100d0566a9ba73eb7ed1492eefd242ce9795f1ce60371e9a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "y", value)

    @builtins.property
    @jsii.member(jsii_name="yVar")
    def y_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yVar"))

    @y_var.setter
    def y_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__59494807f297f42742e3f156bc6488d7e8b041a6767897bb5de2f64d81bd0e3c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestPolygonShapePoints]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestPolygonShapePoints]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestPolygonShapePoints]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__732eb12e27a6dcc3734c0bb5e649b486bdd1a2973234f589b4b3033badddbe5b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestRectangleShape",
    jsii_struct_bases=[],
    name_mapping={
        "anchor": "anchor",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestRectangleShape:
    def __init__(
        self,
        *,
        anchor: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestRectangleShapeAnchor", typing.Dict[builtins.str, typing.Any]],
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param anchor: anchor block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#anchor DataAkamaiImagingPolicyImage#anchor}
        :param height: Extends the rectangle down from the ``anchor`` point. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: Extends the rectangle down from the ``anchor`` point. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: Extends the rectangle right from the ``anchor`` point. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: Extends the rectangle right from the ``anchor`` point. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(anchor, dict):
            anchor = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestRectangleShapeAnchor(**anchor)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__db9651ef50c5eba547235a6835cad2f2451f10f8a2ae6e8ee6e7ec145a2d6c98)
            check_type(argname="argument anchor", value=anchor, expected_type=type_hints["anchor"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "anchor": anchor,
        }
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def anchor(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestRectangleShapeAnchor":
        '''anchor block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#anchor DataAkamaiImagingPolicyImage#anchor}
        '''
        result = self._values.get("anchor")
        assert result is not None, "Required property 'anchor' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestRectangleShapeAnchor", result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''Extends the rectangle down from the ``anchor`` point.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''Extends the rectangle down from the ``anchor`` point.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''Extends the rectangle right from the ``anchor`` point.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''Extends the rectangle right from the ``anchor`` point.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestRectangleShape(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestRectangleShapeAnchor",
    jsii_struct_bases=[],
    name_mapping={"x": "x", "x_var": "xVar", "y": "y", "y_var": "yVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestRectangleShapeAnchor:
    def __init__(
        self,
        *,
        x: typing.Optional[builtins.str] = None,
        x_var: typing.Optional[builtins.str] = None,
        y: typing.Optional[builtins.str] = None,
        y_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param x: The horizontal position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x DataAkamaiImagingPolicyImage#x}
        :param x_var: The horizontal position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_var DataAkamaiImagingPolicyImage#x_var}
        :param y: The vertical position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y DataAkamaiImagingPolicyImage#y}
        :param y_var: The vertical position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_var DataAkamaiImagingPolicyImage#y_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9880bd2bc36cad47173e0da94e1ad624ac35e4d724072aaee3d18184ec3d1588)
            check_type(argname="argument x", value=x, expected_type=type_hints["x"])
            check_type(argname="argument x_var", value=x_var, expected_type=type_hints["x_var"])
            check_type(argname="argument y", value=y, expected_type=type_hints["y"])
            check_type(argname="argument y_var", value=y_var, expected_type=type_hints["y_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if x is not None:
            self._values["x"] = x
        if x_var is not None:
            self._values["x_var"] = x_var
        if y is not None:
            self._values["y"] = y
        if y_var is not None:
            self._values["y_var"] = y_var

    @builtins.property
    def x(self) -> typing.Optional[builtins.str]:
        '''The horizontal position of the point, measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x DataAkamaiImagingPolicyImage#x}
        '''
        result = self._values.get("x")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_var(self) -> typing.Optional[builtins.str]:
        '''The horizontal position of the point, measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_var DataAkamaiImagingPolicyImage#x_var}
        '''
        result = self._values.get("x_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y(self) -> typing.Optional[builtins.str]:
        '''The vertical position of the point, measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y DataAkamaiImagingPolicyImage#y}
        '''
        result = self._values.get("y")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_var(self) -> typing.Optional[builtins.str]:
        '''The vertical position of the point, measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_var DataAkamaiImagingPolicyImage#y_var}
        '''
        result = self._values.get("y_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestRectangleShapeAnchor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestRectangleShapeAnchorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestRectangleShapeAnchorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c13757e6ee3b199e8bd269c1240416f56334e7f734d61c9c796e83a93bb3b0e0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetX")
    def reset_x(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetX", []))

    @jsii.member(jsii_name="resetXVar")
    def reset_x_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXVar", []))

    @jsii.member(jsii_name="resetY")
    def reset_y(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetY", []))

    @jsii.member(jsii_name="resetYVar")
    def reset_y_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYVar", []))

    @builtins.property
    @jsii.member(jsii_name="xInput")
    def x_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xInput"))

    @builtins.property
    @jsii.member(jsii_name="xVarInput")
    def x_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yInput")
    def y_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yInput"))

    @builtins.property
    @jsii.member(jsii_name="yVarInput")
    def y_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yVarInput"))

    @builtins.property
    @jsii.member(jsii_name="x")
    def x(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "x"))

    @x.setter
    def x(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__58613c27de30bba7907314ecbfa2d406893b15f15befbddda4a14fb72220dbf8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "x", value)

    @builtins.property
    @jsii.member(jsii_name="xVar")
    def x_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xVar"))

    @x_var.setter
    def x_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__10b934ea64176831f3acdd1438c23e3e012e9c91924cf4ced0477bfeb547e377)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xVar", value)

    @builtins.property
    @jsii.member(jsii_name="y")
    def y(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "y"))

    @y.setter
    def y(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f93dcabe34f16cace89d5f7b66d4c2b54f6080e936fc0756a7041e91114726b2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "y", value)

    @builtins.property
    @jsii.member(jsii_name="yVar")
    def y_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yVar"))

    @y_var.setter
    def y_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0197d7210570bea2692b8712e2ad73b531a9c6edbc3b8233fb23c3f0f9e095db)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestRectangleShapeAnchor]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestRectangleShapeAnchor], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestRectangleShapeAnchor],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__04c577435c1af32a8b1d1c59d6dfd87b472a0f02894878097bdb411d21fa5a27)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestRectangleShapeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestRectangleShapeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c5ace7f7d4129798750eb49836fa5ce6f9aa1a62472c8e931e9f00b810a67857)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestRectangleShapeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e6b6060efb74c106d2d6cb91cfb9a7e56e11a5a4e25497cc3935383704a0185f)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestRectangleShapeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cb62a1df929d1cb9b30d6e81c9445d46ef8a67f309b5e56e4a28f86242d6d074)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a5400468e5568a6b233c8528023a48b42c725524c3eccf2062e8714de7f6a7bc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__583ac6e262d0a7cce39f46a2613ed9a23636bf7aa698c0591bafc6f2099a8e8d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestRectangleShape]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestRectangleShape]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestRectangleShape]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d524139a60eb50abee579d8f0becf93bbe73ead48167c4400534409b00f31525)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestRectangleShapeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestRectangleShapeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__28b6cb3a0505104ad259229aba99acd20b8e392b4e7d92b6b078b773e5458ab4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putAnchor")
    def put_anchor(
        self,
        *,
        x: typing.Optional[builtins.str] = None,
        x_var: typing.Optional[builtins.str] = None,
        y: typing.Optional[builtins.str] = None,
        y_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param x: The horizontal position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x DataAkamaiImagingPolicyImage#x}
        :param x_var: The horizontal position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_var DataAkamaiImagingPolicyImage#x_var}
        :param y: The vertical position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y DataAkamaiImagingPolicyImage#y}
        :param y_var: The vertical position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_var DataAkamaiImagingPolicyImage#y_var}
        '''
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestRectangleShapeAnchor(
            x=x, x_var=x_var, y=y, y_var=y_var
        )

        return typing.cast(None, jsii.invoke(self, "putAnchor", [value]))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="anchor")
    def anchor(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestRectangleShapeAnchorOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestRectangleShapeAnchorOutputReference, jsii.get(self, "anchor"))

    @builtins.property
    @jsii.member(jsii_name="anchorInput")
    def anchor_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestRectangleShapeAnchor]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestRectangleShapeAnchor], jsii.get(self, "anchorInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__57d2360fe314b2b92f4ccfd79fcc7ef3c709c520f3000a9b8dd80a023829e24e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__87683863cab5a913801cb73da742ededba317d12af1fab2bcd68a6e9456617b0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6257a5fc387fee4c8bc0a96da883feb5fa981ce0e30cf1938554cf5569cdb17d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e783c2fd9eb7b19159ce5acd1785d5c8487899792d9d7f24ea0a3987486d5081)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestRectangleShape]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestRectangleShape]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestRectangleShape]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3cc6ff5d913e6a180ca4537ebad786d73fda9b68b4dd04747c0cf4ca0045e200)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestUnionShape",
    jsii_struct_bases=[],
    name_mapping={"shapes": "shapes"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestUnionShape:
    def __init__(
        self,
        *,
        shapes: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestUnionShapeShapes", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param shapes: shapes block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shapes DataAkamaiImagingPolicyImage#shapes}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f52e9f16a41dcea63918292bba7a4be135c834b474649cfcb551ab79c2f17c0d)
            check_type(argname="argument shapes", value=shapes, expected_type=type_hints["shapes"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "shapes": shapes,
        }

    @builtins.property
    def shapes(
        self,
    ) -> typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestUnionShapeShapes"]]:
        '''shapes block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shapes DataAkamaiImagingPolicyImage#shapes}
        '''
        result = self._values.get("shapes")
        assert result is not None, "Required property 'shapes' is missing"
        return typing.cast(typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestUnionShapeShapes"]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestUnionShape(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestUnionShapeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestUnionShapeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b4dcd33015057ae22f46cbbaccb9f6534cfc09f846fe47a5c09df84e03423186)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestUnionShapeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3826d899b7ef71859f15dee8b159cc6fefe35ad3152e86ca38466ea1b9ad26ce)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestUnionShapeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3044cd3c461476b53a435b12acc0f9f086ba22cd71340ada03dcf839862a423e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__96e67673297d84cc48dd2fc6d7d1546ffa6a526b2cc8cd1c52d7c68694b31e6f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a15e27a0d9a7d3f680547ab49b3b0b165f2b79e1b77e8fe5ab6e68ddcc6e652c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestUnionShape]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestUnionShape]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestUnionShape]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e7435862c8477e1eb57f7f0188004f37f2e657d460218670eb0c3d69c1a01772)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestUnionShapeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestUnionShapeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__16b1055e660120b182f78794ecf2494ebefc92aadd3bde704c61b329e9ee9653)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putShapes")
    def put_shapes(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestUnionShapeShapes", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1a5f56c13b1d8d49581e9f419191417a63ad6715f5038881f1aa35ee9c6543d5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putShapes", [value]))

    @builtins.property
    @jsii.member(jsii_name="shapes")
    def shapes(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestUnionShapeShapesList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestUnionShapeShapesList", jsii.get(self, "shapes"))

    @builtins.property
    @jsii.member(jsii_name="shapesInput")
    def shapes_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestUnionShapeShapes"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestUnionShapeShapes"]]], jsii.get(self, "shapesInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestUnionShape]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestUnionShape]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestUnionShape]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5c4aa08d5d0e1d24a3ced54b0bd8c4d111c5a0cbb28be281d4b820c1296dcd1b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestUnionShapeShapes",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestUnionShapeShapes:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestUnionShapeShapes(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestUnionShapeShapesList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestUnionShapeShapesList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d0e76b7b9b1b1704343058052fce03030a0b77bc83463304fc40a987f99dd14)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestUnionShapeShapesOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a3de3a563fe7aaeabaff9956f77b94a952b719d0ac3628ef49b009a47150ff5d)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestUnionShapeShapesOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1168595dc8eaa2ce842638cdab8a2ca062a89060dbaf9b2306cafcd22d77847e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__210eb1d46d36eceedbefa21444fb0717bebceb35a571e9a093bc829df8059c59)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1fd43b6503b921b7ef73054779b750885e86c173ca303f9fe07f73abeefa22fe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestUnionShapeShapes]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestUnionShapeShapes]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestUnionShapeShapes]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f6dd03a06c4b89b3b25426b32757da281ca371b4bda50cf00db32b82d0c3455e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestUnionShapeShapesOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestUnionShapeShapesOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df43643cddda3105b0697b1210118016ce727b07521b9d3f1ec91f28c4925d26)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestUnionShapeShapes]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestUnionShapeShapes]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestUnionShapeShapes]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e58480221f625549f4dae3289a9586ddcd6fab5a016a2294bf027fdc5e6ef792)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRelativeCrop",
    jsii_struct_bases=[],
    name_mapping={
        "east": "east",
        "east_var": "eastVar",
        "north": "north",
        "north_var": "northVar",
        "south": "south",
        "south_var": "southVar",
        "west": "west",
        "west_var": "westVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRelativeCrop:
    def __init__(
        self,
        *,
        east: typing.Optional[builtins.str] = None,
        east_var: typing.Optional[builtins.str] = None,
        north: typing.Optional[builtins.str] = None,
        north_var: typing.Optional[builtins.str] = None,
        south: typing.Optional[builtins.str] = None,
        south_var: typing.Optional[builtins.str] = None,
        west: typing.Optional[builtins.str] = None,
        west_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param east: The number of pixels to shrink or expand the right side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east DataAkamaiImagingPolicyImage#east}
        :param east_var: The number of pixels to shrink or expand the right side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east_var DataAkamaiImagingPolicyImage#east_var}
        :param north: The number of pixels to shrink or expand the top side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north DataAkamaiImagingPolicyImage#north}
        :param north_var: The number of pixels to shrink or expand the top side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north_var DataAkamaiImagingPolicyImage#north_var}
        :param south: The number of pixels to shrink or expand the bottom side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south DataAkamaiImagingPolicyImage#south}
        :param south_var: The number of pixels to shrink or expand the bottom side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south_var DataAkamaiImagingPolicyImage#south_var}
        :param west: The number of pixels to shrink or expand the left side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west DataAkamaiImagingPolicyImage#west}
        :param west_var: The number of pixels to shrink or expand the left side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west_var DataAkamaiImagingPolicyImage#west_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d7e27645765a147a93f34a2829baa3848c10b5d08abb9167fe19838d0e3eb2f7)
            check_type(argname="argument east", value=east, expected_type=type_hints["east"])
            check_type(argname="argument east_var", value=east_var, expected_type=type_hints["east_var"])
            check_type(argname="argument north", value=north, expected_type=type_hints["north"])
            check_type(argname="argument north_var", value=north_var, expected_type=type_hints["north_var"])
            check_type(argname="argument south", value=south, expected_type=type_hints["south"])
            check_type(argname="argument south_var", value=south_var, expected_type=type_hints["south_var"])
            check_type(argname="argument west", value=west, expected_type=type_hints["west"])
            check_type(argname="argument west_var", value=west_var, expected_type=type_hints["west_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if east is not None:
            self._values["east"] = east
        if east_var is not None:
            self._values["east_var"] = east_var
        if north is not None:
            self._values["north"] = north
        if north_var is not None:
            self._values["north_var"] = north_var
        if south is not None:
            self._values["south"] = south
        if south_var is not None:
            self._values["south_var"] = south_var
        if west is not None:
            self._values["west"] = west
        if west_var is not None:
            self._values["west_var"] = west_var

    @builtins.property
    def east(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the right side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east DataAkamaiImagingPolicyImage#east}
        '''
        result = self._values.get("east")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def east_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the right side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east_var DataAkamaiImagingPolicyImage#east_var}
        '''
        result = self._values.get("east_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def north(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the top side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north DataAkamaiImagingPolicyImage#north}
        '''
        result = self._values.get("north")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def north_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the top side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north_var DataAkamaiImagingPolicyImage#north_var}
        '''
        result = self._values.get("north_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def south(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the bottom side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south DataAkamaiImagingPolicyImage#south}
        '''
        result = self._values.get("south")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def south_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the bottom side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south_var DataAkamaiImagingPolicyImage#south_var}
        '''
        result = self._values.get("south_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def west(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the left side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west DataAkamaiImagingPolicyImage#west}
        '''
        result = self._values.get("west")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def west_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the left side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west_var DataAkamaiImagingPolicyImage#west_var}
        '''
        result = self._values.get("west_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRelativeCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRelativeCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRelativeCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2976a46347b4f352622cad89828bab63866b3b2388698cff505cc883cb240e17)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRelativeCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bf79a30dd4b6f578a8e82a8c05e2c40c0830317cffaa857d0398a6ff8724e7ab)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRelativeCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7f6fa8247f8fffabb2fa2f211a4817c567981e7b4cf2c098c9d0d355a9dd2e1a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f5ce541944a949a17323113ddb72658b9ae533f454fb842cd37641be864f3031)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e437d15b909e0d144ac28b002068f21a6199f03eac19296a6f5d96b731d02f02)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRelativeCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRelativeCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRelativeCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__40eabf43f4a10ea9461d2a5930f947720b47fc56d147699c4dd90900ddc8a354)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRelativeCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRelativeCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__631f8f372fda5641e3fb615599c4dcc2aca0a57ce200649da1d653349e94b689)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetEast")
    def reset_east(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEast", []))

    @jsii.member(jsii_name="resetEastVar")
    def reset_east_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEastVar", []))

    @jsii.member(jsii_name="resetNorth")
    def reset_north(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNorth", []))

    @jsii.member(jsii_name="resetNorthVar")
    def reset_north_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNorthVar", []))

    @jsii.member(jsii_name="resetSouth")
    def reset_south(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSouth", []))

    @jsii.member(jsii_name="resetSouthVar")
    def reset_south_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSouthVar", []))

    @jsii.member(jsii_name="resetWest")
    def reset_west(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWest", []))

    @jsii.member(jsii_name="resetWestVar")
    def reset_west_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWestVar", []))

    @builtins.property
    @jsii.member(jsii_name="eastInput")
    def east_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "eastInput"))

    @builtins.property
    @jsii.member(jsii_name="eastVarInput")
    def east_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "eastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="northInput")
    def north_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "northInput"))

    @builtins.property
    @jsii.member(jsii_name="northVarInput")
    def north_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "northVarInput"))

    @builtins.property
    @jsii.member(jsii_name="southInput")
    def south_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "southInput"))

    @builtins.property
    @jsii.member(jsii_name="southVarInput")
    def south_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "southVarInput"))

    @builtins.property
    @jsii.member(jsii_name="westInput")
    def west_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "westInput"))

    @builtins.property
    @jsii.member(jsii_name="westVarInput")
    def west_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "westVarInput"))

    @builtins.property
    @jsii.member(jsii_name="east")
    def east(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "east"))

    @east.setter
    def east(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__72e66f3a7b3f8391522179360c22a66f8900f1ddafb970a780a4582c0de5f990)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "east", value)

    @builtins.property
    @jsii.member(jsii_name="eastVar")
    def east_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "eastVar"))

    @east_var.setter
    def east_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e801c3edd907ef885aed5f3435c0ed3c6f933bbd6d4dcb90aac81c4f4f4c341a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "eastVar", value)

    @builtins.property
    @jsii.member(jsii_name="north")
    def north(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "north"))

    @north.setter
    def north(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4984f92bd2cc8928052e9b859892a24cbca72f4ddb11abf81fc5d00a733b71c6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "north", value)

    @builtins.property
    @jsii.member(jsii_name="northVar")
    def north_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "northVar"))

    @north_var.setter
    def north_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6cdb9aa95e5c46b9271d1153533fdb0e8a835be6e4725b1d49ecdaf8bd32f316)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "northVar", value)

    @builtins.property
    @jsii.member(jsii_name="south")
    def south(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "south"))

    @south.setter
    def south(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ec4fd157d03c9ecd0b69317a307a17f16b841a49102999711b47a20ec79e14a5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "south", value)

    @builtins.property
    @jsii.member(jsii_name="southVar")
    def south_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "southVar"))

    @south_var.setter
    def south_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7523453e7812573d6ab0b89be5757e24ae8400eb11950bdc41720839d2c7e915)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "southVar", value)

    @builtins.property
    @jsii.member(jsii_name="west")
    def west(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "west"))

    @west.setter
    def west(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a95be404b94bac341d472f4bfed8df000001ab1cedaf310067a5d5298bda4d0f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "west", value)

    @builtins.property
    @jsii.member(jsii_name="westVar")
    def west_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "westVar"))

    @west_var.setter
    def west_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f4df28367f1b8cb458d4379acc4617e5ca5ba23b65a42e9161c3af0376ff9c1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "westVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRelativeCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRelativeCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRelativeCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2f4eaa501b879ad2c4851d5b8ba29ed3cb219f740c009eedf61823b78dfb47e6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRemoveColor",
    jsii_struct_bases=[],
    name_mapping={
        "color": "color",
        "color_var": "colorVar",
        "feather": "feather",
        "feather_var": "featherVar",
        "tolerance": "tolerance",
        "tolerance_var": "toleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRemoveColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
        feather: typing.Optional[builtins.str] = None,
        feather_var: typing.Optional[builtins.str] = None,
        tolerance: typing.Optional[builtins.str] = None,
        tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        :param feather: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        :param feather_var: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        :param tolerance: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        :param tolerance_var: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3509900248263df0449fe7d1f31ce4b38f2494a51d4c46adce21fd8fb789062a)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
            check_type(argname="argument feather", value=feather, expected_type=type_hints["feather"])
            check_type(argname="argument feather_var", value=feather_var, expected_type=type_hints["feather_var"])
            check_type(argname="argument tolerance", value=tolerance, expected_type=type_hints["tolerance"])
            check_type(argname="argument tolerance_var", value=tolerance_var, expected_type=type_hints["tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var
        if feather is not None:
            self._values["feather"] = feather
        if feather_var is not None:
            self._values["feather_var"] = feather_var
        if tolerance is not None:
            self._values["tolerance"] = tolerance
        if tolerance_var is not None:
            self._values["tolerance_var"] = tolerance_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        '''
        result = self._values.get("feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather_var(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        '''
        result = self._values.get("feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        '''
        result = self._values.get("tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance_var(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        result = self._values.get("tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRemoveColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRemoveColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRemoveColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f2c7d43790931e2344a636e1a892b34f122b9130b96ed1e5fea6de5ec1e477ac)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRemoveColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__29cf1bffe81209e36d078929044ab34cb1a8279caa1a64f242c3902208679a77)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRemoveColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__abff425ab953c6fe24a4d2ddbee2cc22e52ddbda6f3759e389b7b7f201b705f0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b742be93c31bb8dd40a232d25eec71ab4b19b08e4d9b0526f67c22835f08de76)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9c47b939686a3a886b56bf3e7773992fee93d98c62b46fa5bf6181473edbf976)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRemoveColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRemoveColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRemoveColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2147570e86a39b213d8f50dc49f7295cd8453f13e750ed8abbad16bb6f2a50ab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRemoveColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRemoveColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__90a51b12311401785fb4218e7b50f0f6a304643f7c6fb209e502d60abc5d4d49)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @jsii.member(jsii_name="resetFeather")
    def reset_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeather", []))

    @jsii.member(jsii_name="resetFeatherVar")
    def reset_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatherVar", []))

    @jsii.member(jsii_name="resetTolerance")
    def reset_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTolerance", []))

    @jsii.member(jsii_name="resetToleranceVar")
    def reset_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featherInput")
    def feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherInput"))

    @builtins.property
    @jsii.member(jsii_name="featherVarInput")
    def feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceInput")
    def tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceVarInput")
    def tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f600d009ed6b7acb169673b614b7e9edb948305b38fa4126241b7ba3b544b439)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab7592f6a115b5d48ef2aaa3be3fc2444b84f224b2e496b28360fd69e528b797)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="feather")
    def feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "feather"))

    @feather.setter
    def feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__142e6613a6c2489791ab39eac42341f8bac2353621fdf9d09e70760c096a4dcf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "feather", value)

    @builtins.property
    @jsii.member(jsii_name="featherVar")
    def feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featherVar"))

    @feather_var.setter
    def feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ba0098ae82af40fa16c808cd15290f5da07a38755c7b3fba7c648cddfd89dec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featherVar", value)

    @builtins.property
    @jsii.member(jsii_name="tolerance")
    def tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tolerance"))

    @tolerance.setter
    def tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__52a00e74b801979d2ab9164518eb3fa43a9c32861cda125be90760c1afb0110c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tolerance", value)

    @builtins.property
    @jsii.member(jsii_name="toleranceVar")
    def tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "toleranceVar"))

    @tolerance_var.setter
    def tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d03b6acd51c2d181c391fad5f09fdd1a4b8d96a3f79c4ee061d3028e05a8def2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "toleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRemoveColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRemoveColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRemoveColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2436fd15661530a42171d9295a5c939656371a804d3d2fd27806d99eddcc8c10)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanResize",
    jsii_struct_bases=[],
    name_mapping={
        "aspect": "aspect",
        "aspect_var": "aspectVar",
        "height": "height",
        "height_var": "heightVar",
        "type": "type",
        "type_var": "typeVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanResize:
    def __init__(
        self,
        *,
        aspect: typing.Optional[builtins.str] = None,
        aspect_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param aspect: Preserves the aspect ratio. Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect DataAkamaiImagingPolicyImage#aspect}
        :param aspect_var: Preserves the aspect ratio. Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_var DataAkamaiImagingPolicyImage#aspect_var}
        :param height: The height to resize the source image to. Must be set if height is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height to resize the source image to. Must be set if height is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param type: Sets constraints for the image resize. Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: Sets constraints for the image resize. Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        :param width: The width to resize the source image to. Must be set if width is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width to resize the source image to. Must be set if width is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b5eed8babb6897f0272d2d994f007fe1dd9c20726005d06ecd9f2c850136ed41)
            check_type(argname="argument aspect", value=aspect, expected_type=type_hints["aspect"])
            check_type(argname="argument aspect_var", value=aspect_var, expected_type=type_hints["aspect_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if aspect is not None:
            self._values["aspect"] = aspect
        if aspect_var is not None:
            self._values["aspect_var"] = aspect_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def aspect(self) -> typing.Optional[builtins.str]:
        '''Preserves the aspect ratio.

        Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect DataAkamaiImagingPolicyImage#aspect}
        '''
        result = self._values.get("aspect")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def aspect_var(self) -> typing.Optional[builtins.str]:
        '''Preserves the aspect ratio.

        Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_var DataAkamaiImagingPolicyImage#aspect_var}
        '''
        result = self._values.get("aspect_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height to resize the source image to. Must be set if height is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height to resize the source image to. Must be set if height is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''Sets constraints for the image resize.

        Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''Sets constraints for the image resize.

        Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width to resize the source image to. Must be set if width is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width to resize the source image to. Must be set if width is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanResize(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanResizeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanResizeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__747d35228560aaa8fa267d98cefa4754b8b2d1092cc9fcb63bc67ce8f796e635)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanResizeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9cf0400db45bbe154563498f46aa2d17a5fedeff2df944b75918192afad84f70)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanResizeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__35256a953ba2795100bafdffc2958e68fe1270a3c17d1ebb4a6efe064034c3aa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__85dbe782348f41fd51440e29caecb9431df270b9ea667dfeea2acf0ccd76648f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d6ba15beac9b0357703348e1684e03c7a511b855732b3b0ab1f570f860353e70)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanResize]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanResize]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanResize]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3d17cc45ea73be2329fefa5d5772c6d657ffd4626f7dd69ac2f8bdfbbca73951)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanResizeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanResizeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__633450c159e6ee86b0125765df869082a5d0d26152929915e59018ab6afed300)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAspect")
    def reset_aspect(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspect", []))

    @jsii.member(jsii_name="resetAspectVar")
    def reset_aspect_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspectVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="aspectInput")
    def aspect_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "aspectInput"))

    @builtins.property
    @jsii.member(jsii_name="aspectVarInput")
    def aspect_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "aspectVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="aspect")
    def aspect(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "aspect"))

    @aspect.setter
    def aspect(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__15df86a7142df62e43172cfe65619a9197721a2322b55425b5db3127d82a13c1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "aspect", value)

    @builtins.property
    @jsii.member(jsii_name="aspectVar")
    def aspect_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "aspectVar"))

    @aspect_var.setter
    def aspect_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9fabda686bd77cb4739a7c38103160cedc730639ac596af6308a088eb5915379)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "aspectVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1b2bc98c14891a8ec86fb6fc7a450e3227dc28adfa421d6a626cf22c9ffcd759)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a7e0d78b1b25458bf76821c4f56d9bc3f1109864986d6a21536aede80f574b7b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1d36bcfe56bac2384b798ddf57ec242eed6b54ad3464263a57684cbbd7f6b76a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6ed47f7620c06ea9c38c7d6904be78932239a688550327858a034461e03dda37)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f0f40dbcda83f3811afb6d6c9617d865a6080176234c888f0e44d827c66d696e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__58e61ca6ae49f34351f5e78ddf75918d490dc718d3faf41a91d806ecb0a8d6f7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanResize]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanResize]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanResize]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d6832c14d775855a75c1b0e546d55a331090217a796fb4c3b88218c3b2db9773)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRotate",
    jsii_struct_bases=[],
    name_mapping={"degrees": "degrees", "degrees_var": "degreesVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRotate:
    def __init__(
        self,
        *,
        degrees: typing.Optional[builtins.str] = None,
        degrees_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param degrees: The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees DataAkamaiImagingPolicyImage#degrees}
        :param degrees_var: The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees_var DataAkamaiImagingPolicyImage#degrees_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__723051fcde47bd3969d3779172a3fc2e9f479690b44eb10c21d17bb460c3859f)
            check_type(argname="argument degrees", value=degrees, expected_type=type_hints["degrees"])
            check_type(argname="argument degrees_var", value=degrees_var, expected_type=type_hints["degrees_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if degrees is not None:
            self._values["degrees"] = degrees
        if degrees_var is not None:
            self._values["degrees_var"] = degrees_var

    @builtins.property
    def degrees(self) -> typing.Optional[builtins.str]:
        '''The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees DataAkamaiImagingPolicyImage#degrees}
        '''
        result = self._values.get("degrees")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def degrees_var(self) -> typing.Optional[builtins.str]:
        '''The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees_var DataAkamaiImagingPolicyImage#degrees_var}
        '''
        result = self._values.get("degrees_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRotate(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRotateList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRotateList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8bde8ca1462efd44e3f25dc92d1fcad7fabf6e6a75d408a24e1a6a8340536e07)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRotateOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a1dfcae39a1d7813bbe3b8ee73abf90956ca1011df1a38ca52c35901d42834fa)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRotateOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__40274a55fd7b28e3f8c89e6fe0a8cc6f07f2f63153d4f5cf8e215d680f3d913c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a7b740428bd578eb034192e09413ad864c50cb2ac55136e878a28bb1be8e6f85)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d2c4cb23419acd622ad45102dfca4e7b7258ac454619fc63ae4c43ab0df9b091)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRotate]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRotate]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRotate]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ec604ed031bea29ed05ed21a82730487054f4926e89942d1b5f038879b804aaa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRotateOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRotateOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__571aaa3b235139749d6b19ae8320e54ea8e6678bece9f31c07ccd754fb34d8fb)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetDegrees")
    def reset_degrees(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDegrees", []))

    @jsii.member(jsii_name="resetDegreesVar")
    def reset_degrees_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDegreesVar", []))

    @builtins.property
    @jsii.member(jsii_name="degreesInput")
    def degrees_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "degreesInput"))

    @builtins.property
    @jsii.member(jsii_name="degreesVarInput")
    def degrees_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "degreesVarInput"))

    @builtins.property
    @jsii.member(jsii_name="degrees")
    def degrees(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "degrees"))

    @degrees.setter
    def degrees(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__266800432fe09f25696690bb6fc2f5f4127a1a66eb87cab94b3a5f2c135be6cf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "degrees", value)

    @builtins.property
    @jsii.member(jsii_name="degreesVar")
    def degrees_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "degreesVar"))

    @degrees_var.setter
    def degrees_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__62e37ec6389b5a6dcded569a747360a8f2fc54295dd75b22fc02e9bd7a0a1e63)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "degreesVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRotate]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRotate]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRotate]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df670f2d81d7f874d2084cff6882b4ad12674807169a2a162dc796fc83dd1372)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanScale",
    jsii_struct_bases=[],
    name_mapping={
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanScale:
    def __init__(
        self,
        *,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param height: Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged. Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged. Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4b20f47caa94cae9aacb548eee4768656282cc939f2756ade123339f6a99b268)
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size.

        Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size.

        Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged.

        Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged.

        Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanScale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanScaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanScaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__469852d7a5f6d298bdae036e08f61765b3fdaf9c5b77a4c1a9452c2668e2208f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanScaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ad0849a1672274d9946234da8ea4222f2fc320785454a35546f449f2cfa8bd81)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanScaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea9be63fd8a3a0a4510bcead10cdb9a753749138464bf586025eedaf259c20ef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__83927d211b0d946d3b91b534105237524863c395e6c0f97677714a0e197c19cd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cfb2c3d8fe52b1e937af911929a036589e200f6e19482a7d359d99874ac14626)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanScale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanScale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanScale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__28a201a68ae830914145687981bf094dd456ad0ed64fb9ced591c4b405893fd4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanScaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanScaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0d95e57fe17e3740dad04c019dbffc88ea5cabd36fcef74b4d222e87300977c2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ee0928638aa443245404a32eee76434883396fa33a9c5a745399407b58a3c12a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f7dca4bf2a20c3e57601f102627129c20e605ff0cda44807926742f9669d60cb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__74c437118606ed6b51c3317b29c04401192b78f9ddb1dfeb62ac0f912f38c161)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c71696659ea35493e0e2d463718f627526f5c4e57f3bebbdf3cc1fcd703837ac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanScale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanScale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanScale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ec3a223291a5176934c3315c5c9e3f3307b7c9f3c2e777511db3c951238ba5b1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanShear",
    jsii_struct_bases=[],
    name_mapping={
        "x_shear": "xShear",
        "x_shear_var": "xShearVar",
        "y_shear": "yShear",
        "y_shear_var": "yShearVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanShear:
    def __init__(
        self,
        *,
        x_shear: typing.Optional[builtins.str] = None,
        x_shear_var: typing.Optional[builtins.str] = None,
        y_shear: typing.Optional[builtins.str] = None,
        y_shear_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param x_shear: The amount to shear along the x-axis, measured in multiples of the image's width. Must be set if yShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear DataAkamaiImagingPolicyImage#x_shear}
        :param x_shear_var: The amount to shear along the x-axis, measured in multiples of the image's width. Must be set if yShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear_var DataAkamaiImagingPolicyImage#x_shear_var}
        :param y_shear: The amount to shear along the y-axis, measured in multiples of the image's height. Must be set if xShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear DataAkamaiImagingPolicyImage#y_shear}
        :param y_shear_var: The amount to shear along the y-axis, measured in multiples of the image's height. Must be set if xShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear_var DataAkamaiImagingPolicyImage#y_shear_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__35c16f907779dc1d7642c664d7eb359e4a77519ec5d0523ad9c3076c91b2a704)
            check_type(argname="argument x_shear", value=x_shear, expected_type=type_hints["x_shear"])
            check_type(argname="argument x_shear_var", value=x_shear_var, expected_type=type_hints["x_shear_var"])
            check_type(argname="argument y_shear", value=y_shear, expected_type=type_hints["y_shear"])
            check_type(argname="argument y_shear_var", value=y_shear_var, expected_type=type_hints["y_shear_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if x_shear is not None:
            self._values["x_shear"] = x_shear
        if x_shear_var is not None:
            self._values["x_shear_var"] = x_shear_var
        if y_shear is not None:
            self._values["y_shear"] = y_shear
        if y_shear_var is not None:
            self._values["y_shear_var"] = y_shear_var

    @builtins.property
    def x_shear(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the x-axis, measured in multiples of the image's width.

        Must be set if yShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear DataAkamaiImagingPolicyImage#x_shear}
        '''
        result = self._values.get("x_shear")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_shear_var(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the x-axis, measured in multiples of the image's width.

        Must be set if yShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear_var DataAkamaiImagingPolicyImage#x_shear_var}
        '''
        result = self._values.get("x_shear_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_shear(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the y-axis, measured in multiples of the image's height.

        Must be set if xShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear DataAkamaiImagingPolicyImage#y_shear}
        '''
        result = self._values.get("y_shear")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_shear_var(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the y-axis, measured in multiples of the image's height.

        Must be set if xShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear_var DataAkamaiImagingPolicyImage#y_shear_var}
        '''
        result = self._values.get("y_shear_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanShear(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanShearList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanShearList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__75018a7a9084afd7c2ac9dae4271f66b9c98c8dbacd5da9bf785ca0a1800cdc3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanShearOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b349a7937be5dc16069a8fdf105ce788a5f2378a6998c3100e64463a32d0b765)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanShearOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2e439b94165b8ff7760e76917261aa338617c711fd4c9be80f9fb325b43937e5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__830aaf8914cb7f9a2e32086fef3d5871252ca41a46dbc16223cd22501ef2d2ae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f43c485ee7d04f7f87cd8541638bd691839cb6dc4662ad1f960e4f570a15ba4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanShear]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanShear]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanShear]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__67b2b3053b375432ee3819ad83c0fe57d294f6c29aa204b2698a365f8724b0d4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanShearOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanShearOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__659295ba1fadec747316955f7e57699d68c7c291d34c2220c218a8ed1e5f3327)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetXShear")
    def reset_x_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXShear", []))

    @jsii.member(jsii_name="resetXShearVar")
    def reset_x_shear_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXShearVar", []))

    @jsii.member(jsii_name="resetYShear")
    def reset_y_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYShear", []))

    @jsii.member(jsii_name="resetYShearVar")
    def reset_y_shear_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYShearVar", []))

    @builtins.property
    @jsii.member(jsii_name="xShearInput")
    def x_shear_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xShearInput"))

    @builtins.property
    @jsii.member(jsii_name="xShearVarInput")
    def x_shear_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xShearVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yShearInput")
    def y_shear_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yShearInput"))

    @builtins.property
    @jsii.member(jsii_name="yShearVarInput")
    def y_shear_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yShearVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xShear")
    def x_shear(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xShear"))

    @x_shear.setter
    def x_shear(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b7305b67fc40ef0c804da33751d0f6b248e3fe8531cb00d3fa69cf72ccab7fc9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xShear", value)

    @builtins.property
    @jsii.member(jsii_name="xShearVar")
    def x_shear_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xShearVar"))

    @x_shear_var.setter
    def x_shear_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__797706485cc8403a7fb92402231362431732d8a7884878a73fc0f4d29091b095)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xShearVar", value)

    @builtins.property
    @jsii.member(jsii_name="yShear")
    def y_shear(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yShear"))

    @y_shear.setter
    def y_shear(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__07a5fdf6fa6bd460845321562a0cdca1a4aff9c66a6e466ac605fa72db1d6705)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yShear", value)

    @builtins.property
    @jsii.member(jsii_name="yShearVar")
    def y_shear_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yShearVar"))

    @y_shear_var.setter
    def y_shear_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__519b7de24dba8fceb414ad3a340efba9da6ef48e8a0af4338a2f2b944d1cbd1e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yShearVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanShear]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanShear]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanShear]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7f9da20287473dfff2ff1215a3b08095526001d00736bef1e96b912de96ebf76)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanTrim",
    jsii_struct_bases=[],
    name_mapping={
        "fuzz": "fuzz",
        "fuzz_var": "fuzzVar",
        "padding": "padding",
        "padding_var": "paddingVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanTrim:
    def __init__(
        self,
        *,
        fuzz: typing.Optional[builtins.str] = None,
        fuzz_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fuzz: The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz DataAkamaiImagingPolicyImage#fuzz}
        :param fuzz_var: The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz_var DataAkamaiImagingPolicyImage#fuzz_var}
        :param padding: The amount of padding in pixels to add to the trimmed image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: The amount of padding in pixels to add to the trimmed image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d1391689438f1d509deef77e0093df93f4154f58f544889846c63dc359f6522)
            check_type(argname="argument fuzz", value=fuzz, expected_type=type_hints["fuzz"])
            check_type(argname="argument fuzz_var", value=fuzz_var, expected_type=type_hints["fuzz_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fuzz is not None:
            self._values["fuzz"] = fuzz
        if fuzz_var is not None:
            self._values["fuzz_var"] = fuzz_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var

    @builtins.property
    def fuzz(self) -> typing.Optional[builtins.str]:
        '''The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz DataAkamaiImagingPolicyImage#fuzz}
        '''
        result = self._values.get("fuzz")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fuzz_var(self) -> typing.Optional[builtins.str]:
        '''The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz_var DataAkamaiImagingPolicyImage#fuzz_var}
        '''
        result = self._values.get("fuzz_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''The amount of padding in pixels to add to the trimmed image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''The amount of padding in pixels to add to the trimmed image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanTrim(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanTrimList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanTrimList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7550a1bd7fc8a212ff8460b201d8b71aa5c4428396a14712213674e8eae3dc75)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanTrimOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab5c44846c2b0aa214073427af75ef2e43ce7f306137c22859ce0b237abb0580)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanTrimOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3b67249b54971de80da7d3049eae139f02d5fd3c5fbb8d1bd34a9d3e103ca2b2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__462c463d6de8f6c745316357a0a8da220301e2dea8e84229e92907a76cf1d0a3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__392e86cea747a106d6a3e2c2460abd1a5f64bd694bb82b63e30345d949c785dc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanTrim]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanTrim]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanTrim]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b44f212ccdb416d6be155e3969f2f524282c5b01f6ec443683580e43c222b360)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanTrimOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanTrimOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8e8ac8c236e7351e8fff018fad0be2c4c6beeae7e5bbb33997afcdd133b18538)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetFuzz")
    def reset_fuzz(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFuzz", []))

    @jsii.member(jsii_name="resetFuzzVar")
    def reset_fuzz_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFuzzVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @builtins.property
    @jsii.member(jsii_name="fuzzInput")
    def fuzz_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fuzzInput"))

    @builtins.property
    @jsii.member(jsii_name="fuzzVarInput")
    def fuzz_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fuzzVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="fuzz")
    def fuzz(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fuzz"))

    @fuzz.setter
    def fuzz(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6759e7dd7738feab091a3498cde41d9f6b4dcf233fabad6864f735861b9d89ca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fuzz", value)

    @builtins.property
    @jsii.member(jsii_name="fuzzVar")
    def fuzz_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fuzzVar"))

    @fuzz_var.setter
    def fuzz_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fca2c59999ae8b8dea4a1d8dd49994c3a20df1a6c09d6a7be2a73780106ed0a1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fuzzVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__28ef9e04d0bf2278257ae14056ae7a7789f36577d383e017efbd81f0c5488dbe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9fdb0ddd7268485985442a9dc96d661fb6288c2176f00928b9760f3afeb45672)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanTrim]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanTrim]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanTrim]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__304fe5af74c63d394eedd97d6f6d0d75fddc2b0e62b5f9d538a8ebc250db1ebc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanUnsharpMask",
    jsii_struct_bases=[],
    name_mapping={
        "gain": "gain",
        "gain_var": "gainVar",
        "sigma": "sigma",
        "sigma_var": "sigmaVar",
        "threshold": "threshold",
        "threshold_var": "thresholdVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanUnsharpMask:
    def __init__(
        self,
        *,
        gain: typing.Optional[builtins.str] = None,
        gain_var: typing.Optional[builtins.str] = None,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
        threshold: typing.Optional[builtins.str] = None,
        threshold_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param gain: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        :param gain_var: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        :param sigma: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        :param threshold: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        :param threshold_var: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aaf1dde1aa3098cdf8c405ee449a37e56897956bf53f2d86a66a44bac46aee8d)
            check_type(argname="argument gain", value=gain, expected_type=type_hints["gain"])
            check_type(argname="argument gain_var", value=gain_var, expected_type=type_hints["gain_var"])
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
            check_type(argname="argument threshold", value=threshold, expected_type=type_hints["threshold"])
            check_type(argname="argument threshold_var", value=threshold_var, expected_type=type_hints["threshold_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if gain is not None:
            self._values["gain"] = gain
        if gain_var is not None:
            self._values["gain_var"] = gain_var
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var
        if threshold is not None:
            self._values["threshold"] = threshold
        if threshold_var is not None:
            self._values["threshold_var"] = threshold_var

    @builtins.property
    def gain(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        '''
        result = self._values.get("gain")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gain_var(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        '''
        result = self._values.get("gain_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        '''
        result = self._values.get("threshold")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold_var(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        result = self._values.get("threshold_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanUnsharpMask(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanUnsharpMaskList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanUnsharpMaskList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__20d5f7e6d09b69678148aa0f61e16f6aea5c80767c9487a54bf68396962bc1f0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanUnsharpMaskOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d5d0e3028cda5381a9c10a534c94b6e36c278c41a8d8c9f40500f3500fa539b5)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanUnsharpMaskOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__438752f94f6dd2b2439ea565d57b5300cd49c84b7a52461f3d06cbeaa8018e32)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8f6cf57bb3e457ee5d861ef9619b0b1ca77226ef519095fd5f285842dceffeee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__90892a85c04d8029795089ffbfa5d68e62492871e77c7be71369cc1346fdd3ea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanUnsharpMask]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanUnsharpMask]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanUnsharpMask]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d26d70168c34dac69329e1373bf1c7f6d7cc6d5fe1ea79f000722bcd911b5bb5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanUnsharpMaskOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanUnsharpMaskOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7aea717f0397c4b78c719cd0994dc9991b7e5223a54321dec29e0919e30d9d25)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetGain")
    def reset_gain(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGain", []))

    @jsii.member(jsii_name="resetGainVar")
    def reset_gain_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGainVar", []))

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @jsii.member(jsii_name="resetThreshold")
    def reset_threshold(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThreshold", []))

    @jsii.member(jsii_name="resetThresholdVar")
    def reset_threshold_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThresholdVar", []))

    @builtins.property
    @jsii.member(jsii_name="gainInput")
    def gain_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainInput"))

    @builtins.property
    @jsii.member(jsii_name="gainVarInput")
    def gain_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdInput")
    def threshold_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdVarInput")
    def threshold_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gain")
    def gain(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gain"))

    @gain.setter
    def gain(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__783dc182d123361cf560c8255d868757ea7b6097d906ad1820cd1221aa67b260)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gain", value)

    @builtins.property
    @jsii.member(jsii_name="gainVar")
    def gain_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gainVar"))

    @gain_var.setter
    def gain_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a28392617a439caaffc81ff1f6ff895b8b1d205c960d8079f7168382a6a9ac0c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gainVar", value)

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ae83ae93db78819dd3d2e5ab6ba043e8cd13d12d84ca1da0f82aa3ae8ca4555f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__94c6d1bf5a7ecfb1c739b9888be38873f843cf4fdef28a1ae16a4a4afa4d2dce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="threshold")
    def threshold(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "threshold"))

    @threshold.setter
    def threshold(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__95140c97174970ebdd42eda880b60b6653a67dd0fc731511e31e1be9d9c44c6b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "threshold", value)

    @builtins.property
    @jsii.member(jsii_name="thresholdVar")
    def threshold_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "thresholdVar"))

    @threshold_var.setter
    def threshold_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a4f9e142618275b99e0c91399a5361155eb066965fcb92aac58acfbe2d07e95)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "thresholdVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanUnsharpMask]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanUnsharpMask]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanUnsharpMask]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__21b3f1d3e3da0e6b447e696dbca2c05d4633a7fba337f848eb68e28a78f85f9c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThan",
    jsii_struct_bases=[],
    name_mapping={
        "append": "append",
        "aspect_crop": "aspectCrop",
        "background_color": "backgroundColor",
        "blur": "blur",
        "chroma_key": "chromaKey",
        "composite": "composite",
        "compound": "compound",
        "contrast": "contrast",
        "crop": "crop",
        "face_crop": "faceCrop",
        "feature_crop": "featureCrop",
        "fit_and_fill": "fitAndFill",
        "goop": "goop",
        "grayscale": "grayscale",
        "hsl": "hsl",
        "hsv": "hsv",
        "if_dimension": "ifDimension",
        "if_orientation": "ifOrientation",
        "im_query": "imQuery",
        "max_colors": "maxColors",
        "mirror": "mirror",
        "mono_hue": "monoHue",
        "opacity": "opacity",
        "region_of_interest_crop": "regionOfInterestCrop",
        "relative_crop": "relativeCrop",
        "remove_color": "removeColor",
        "resize": "resize",
        "rotate": "rotate",
        "scale": "scale",
        "shear": "shear",
        "trim": "trim",
        "unsharp_mask": "unsharpMask",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThan:
    def __init__(
        self,
        *,
        append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppend", typing.Dict[builtins.str, typing.Any]]]]] = None,
        aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAspectCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanBackgroundColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanBlur", typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanChromaKey", typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanComposite", typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompound", typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanContrast", typing.Dict[builtins.str, typing.Any]]]]] = None,
        crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFaceCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFeatureCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFill", typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanGoop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanGrayscale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanHsl", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanHsv", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientation", typing.Dict[builtins.str, typing.Any]]]]] = None,
        im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanImQuery", typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanMaxColors", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanMirror", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanMonoHue", typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanOpacity", typing.Dict[builtins.str, typing.Any]]]]] = None,
        region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRelativeCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRemoveColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanResize", typing.Dict[builtins.str, typing.Any]]]]] = None,
        rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRotate", typing.Dict[builtins.str, typing.Any]]]]] = None,
        scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanScale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanShear", typing.Dict[builtins.str, typing.Any]]]]] = None,
        trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanTrim", typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanUnsharpMask", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param append: append block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        :param aspect_crop: aspect_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param crop: crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        :param face_crop: face_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        :param feature_crop: feature_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        :param fit_and_fill: fit_and_fill block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param im_query: im_query block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param region_of_interest_crop: region_of_interest_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        :param relative_crop: relative_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param resize: resize block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        :param rotate: rotate block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        :param scale: scale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param shear: shear block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        :param trim: trim block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b3ca27d67229dc10c6841248f8a66d4fac945614854abfc4fc5df0e11bc6b3ba)
            check_type(argname="argument append", value=append, expected_type=type_hints["append"])
            check_type(argname="argument aspect_crop", value=aspect_crop, expected_type=type_hints["aspect_crop"])
            check_type(argname="argument background_color", value=background_color, expected_type=type_hints["background_color"])
            check_type(argname="argument blur", value=blur, expected_type=type_hints["blur"])
            check_type(argname="argument chroma_key", value=chroma_key, expected_type=type_hints["chroma_key"])
            check_type(argname="argument composite", value=composite, expected_type=type_hints["composite"])
            check_type(argname="argument compound", value=compound, expected_type=type_hints["compound"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument crop", value=crop, expected_type=type_hints["crop"])
            check_type(argname="argument face_crop", value=face_crop, expected_type=type_hints["face_crop"])
            check_type(argname="argument feature_crop", value=feature_crop, expected_type=type_hints["feature_crop"])
            check_type(argname="argument fit_and_fill", value=fit_and_fill, expected_type=type_hints["fit_and_fill"])
            check_type(argname="argument goop", value=goop, expected_type=type_hints["goop"])
            check_type(argname="argument grayscale", value=grayscale, expected_type=type_hints["grayscale"])
            check_type(argname="argument hsl", value=hsl, expected_type=type_hints["hsl"])
            check_type(argname="argument hsv", value=hsv, expected_type=type_hints["hsv"])
            check_type(argname="argument if_dimension", value=if_dimension, expected_type=type_hints["if_dimension"])
            check_type(argname="argument if_orientation", value=if_orientation, expected_type=type_hints["if_orientation"])
            check_type(argname="argument im_query", value=im_query, expected_type=type_hints["im_query"])
            check_type(argname="argument max_colors", value=max_colors, expected_type=type_hints["max_colors"])
            check_type(argname="argument mirror", value=mirror, expected_type=type_hints["mirror"])
            check_type(argname="argument mono_hue", value=mono_hue, expected_type=type_hints["mono_hue"])
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument region_of_interest_crop", value=region_of_interest_crop, expected_type=type_hints["region_of_interest_crop"])
            check_type(argname="argument relative_crop", value=relative_crop, expected_type=type_hints["relative_crop"])
            check_type(argname="argument remove_color", value=remove_color, expected_type=type_hints["remove_color"])
            check_type(argname="argument resize", value=resize, expected_type=type_hints["resize"])
            check_type(argname="argument rotate", value=rotate, expected_type=type_hints["rotate"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument shear", value=shear, expected_type=type_hints["shear"])
            check_type(argname="argument trim", value=trim, expected_type=type_hints["trim"])
            check_type(argname="argument unsharp_mask", value=unsharp_mask, expected_type=type_hints["unsharp_mask"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if append is not None:
            self._values["append"] = append
        if aspect_crop is not None:
            self._values["aspect_crop"] = aspect_crop
        if background_color is not None:
            self._values["background_color"] = background_color
        if blur is not None:
            self._values["blur"] = blur
        if chroma_key is not None:
            self._values["chroma_key"] = chroma_key
        if composite is not None:
            self._values["composite"] = composite
        if compound is not None:
            self._values["compound"] = compound
        if contrast is not None:
            self._values["contrast"] = contrast
        if crop is not None:
            self._values["crop"] = crop
        if face_crop is not None:
            self._values["face_crop"] = face_crop
        if feature_crop is not None:
            self._values["feature_crop"] = feature_crop
        if fit_and_fill is not None:
            self._values["fit_and_fill"] = fit_and_fill
        if goop is not None:
            self._values["goop"] = goop
        if grayscale is not None:
            self._values["grayscale"] = grayscale
        if hsl is not None:
            self._values["hsl"] = hsl
        if hsv is not None:
            self._values["hsv"] = hsv
        if if_dimension is not None:
            self._values["if_dimension"] = if_dimension
        if if_orientation is not None:
            self._values["if_orientation"] = if_orientation
        if im_query is not None:
            self._values["im_query"] = im_query
        if max_colors is not None:
            self._values["max_colors"] = max_colors
        if mirror is not None:
            self._values["mirror"] = mirror
        if mono_hue is not None:
            self._values["mono_hue"] = mono_hue
        if opacity is not None:
            self._values["opacity"] = opacity
        if region_of_interest_crop is not None:
            self._values["region_of_interest_crop"] = region_of_interest_crop
        if relative_crop is not None:
            self._values["relative_crop"] = relative_crop
        if remove_color is not None:
            self._values["remove_color"] = remove_color
        if resize is not None:
            self._values["resize"] = resize
        if rotate is not None:
            self._values["rotate"] = rotate
        if scale is not None:
            self._values["scale"] = scale
        if shear is not None:
            self._values["shear"] = shear
        if trim is not None:
            self._values["trim"] = trim
        if unsharp_mask is not None:
            self._values["unsharp_mask"] = unsharp_mask

    @builtins.property
    def append(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppend"]]]:
        '''append block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        '''
        result = self._values.get("append")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppend"]]], result)

    @builtins.property
    def aspect_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAspectCrop"]]]:
        '''aspect_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        '''
        result = self._values.get("aspect_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAspectCrop"]]], result)

    @builtins.property
    def background_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanBackgroundColor"]]]:
        '''background_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        '''
        result = self._values.get("background_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanBackgroundColor"]]], result)

    @builtins.property
    def blur(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanBlur"]]]:
        '''blur block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        '''
        result = self._values.get("blur")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanBlur"]]], result)

    @builtins.property
    def chroma_key(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanChromaKey"]]]:
        '''chroma_key block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        '''
        result = self._values.get("chroma_key")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanChromaKey"]]], result)

    @builtins.property
    def composite(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanComposite"]]]:
        '''composite block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        '''
        result = self._values.get("composite")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanComposite"]]], result)

    @builtins.property
    def compound(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompound"]]]:
        '''compound block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        '''
        result = self._values.get("compound")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompound"]]], result)

    @builtins.property
    def contrast(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanContrast"]]]:
        '''contrast block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanContrast"]]], result)

    @builtins.property
    def crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCrop"]]]:
        '''crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        '''
        result = self._values.get("crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCrop"]]], result)

    @builtins.property
    def face_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFaceCrop"]]]:
        '''face_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        '''
        result = self._values.get("face_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFaceCrop"]]], result)

    @builtins.property
    def feature_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFeatureCrop"]]]:
        '''feature_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        '''
        result = self._values.get("feature_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFeatureCrop"]]], result)

    @builtins.property
    def fit_and_fill(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFill"]]]:
        '''fit_and_fill block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        '''
        result = self._values.get("fit_and_fill")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFill"]]], result)

    @builtins.property
    def goop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanGoop"]]]:
        '''goop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        '''
        result = self._values.get("goop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanGoop"]]], result)

    @builtins.property
    def grayscale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanGrayscale"]]]:
        '''grayscale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        '''
        result = self._values.get("grayscale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanGrayscale"]]], result)

    @builtins.property
    def hsl(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanHsl"]]]:
        '''hsl block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        '''
        result = self._values.get("hsl")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanHsl"]]], result)

    @builtins.property
    def hsv(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanHsv"]]]:
        '''hsv block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        '''
        result = self._values.get("hsv")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanHsv"]]], result)

    @builtins.property
    def if_dimension(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimension]]]:
        '''if_dimension block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        '''
        result = self._values.get("if_dimension")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimension]]], result)

    @builtins.property
    def if_orientation(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientation"]]]:
        '''if_orientation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        '''
        result = self._values.get("if_orientation")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientation"]]], result)

    @builtins.property
    def im_query(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanImQuery"]]]:
        '''im_query block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        '''
        result = self._values.get("im_query")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanImQuery"]]], result)

    @builtins.property
    def max_colors(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanMaxColors"]]]:
        '''max_colors block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        '''
        result = self._values.get("max_colors")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanMaxColors"]]], result)

    @builtins.property
    def mirror(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanMirror"]]]:
        '''mirror block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        '''
        result = self._values.get("mirror")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanMirror"]]], result)

    @builtins.property
    def mono_hue(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanMonoHue"]]]:
        '''mono_hue block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        '''
        result = self._values.get("mono_hue")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanMonoHue"]]], result)

    @builtins.property
    def opacity(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanOpacity"]]]:
        '''opacity block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanOpacity"]]], result)

    @builtins.property
    def region_of_interest_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCrop"]]]:
        '''region_of_interest_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        '''
        result = self._values.get("region_of_interest_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCrop"]]], result)

    @builtins.property
    def relative_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRelativeCrop"]]]:
        '''relative_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        '''
        result = self._values.get("relative_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRelativeCrop"]]], result)

    @builtins.property
    def remove_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRemoveColor"]]]:
        '''remove_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        '''
        result = self._values.get("remove_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRemoveColor"]]], result)

    @builtins.property
    def resize(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanResize"]]]:
        '''resize block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        '''
        result = self._values.get("resize")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanResize"]]], result)

    @builtins.property
    def rotate(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRotate"]]]:
        '''rotate block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        '''
        result = self._values.get("rotate")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRotate"]]], result)

    @builtins.property
    def scale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanScale"]]]:
        '''scale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanScale"]]], result)

    @builtins.property
    def shear(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanShear"]]]:
        '''shear block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        '''
        result = self._values.get("shear")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanShear"]]], result)

    @builtins.property
    def trim(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanTrim"]]]:
        '''trim block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        '''
        result = self._values.get("trim")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanTrim"]]], result)

    @builtins.property
    def unsharp_mask(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanUnsharpMask"]]]:
        '''unsharp_mask block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        result = self._values.get("unsharp_mask")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanUnsharpMask"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppend",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_priority": "gravityPriority",
        "gravity_priority_var": "gravityPriorityVar",
        "gravity_var": "gravityVar",
        "preserve_minor_dimension": "preserveMinorDimension",
        "preserve_minor_dimension_var": "preserveMinorDimensionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppend:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_priority: typing.Optional[builtins.str] = None,
        gravity_priority_var: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        preserve_minor_dimension: typing.Optional[builtins.str] = None,
        preserve_minor_dimension_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Specifies where to place the ``image`` relative to the source image. The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_priority: Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal. The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority DataAkamaiImagingPolicyImage#gravity_priority}
        :param gravity_priority_var: Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal. The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority_var DataAkamaiImagingPolicyImage#gravity_priority_var}
        :param gravity_var: Specifies where to place the ``image`` relative to the source image. The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param preserve_minor_dimension: Whether to preserve the source image's minor dimension, ``false`` by default. The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension DataAkamaiImagingPolicyImage#preserve_minor_dimension}
        :param preserve_minor_dimension_var: Whether to preserve the source image's minor dimension, ``false`` by default. The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension_var DataAkamaiImagingPolicyImage#preserve_minor_dimension_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e15de0b041dbbc2eaf4d5a9001013de10802c1dd96e2311d47c9cd227b073db4)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_priority", value=gravity_priority, expected_type=type_hints["gravity_priority"])
            check_type(argname="argument gravity_priority_var", value=gravity_priority_var, expected_type=type_hints["gravity_priority_var"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument preserve_minor_dimension", value=preserve_minor_dimension, expected_type=type_hints["preserve_minor_dimension"])
            check_type(argname="argument preserve_minor_dimension_var", value=preserve_minor_dimension_var, expected_type=type_hints["preserve_minor_dimension_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_priority is not None:
            self._values["gravity_priority"] = gravity_priority
        if gravity_priority_var is not None:
            self._values["gravity_priority_var"] = gravity_priority_var
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if preserve_minor_dimension is not None:
            self._values["preserve_minor_dimension"] = preserve_minor_dimension
        if preserve_minor_dimension_var is not None:
            self._values["preserve_minor_dimension_var"] = preserve_minor_dimension_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Specifies where to place the ``image`` relative to the source image.

        The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_priority(self) -> typing.Optional[builtins.str]:
        '''Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal.

        The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority DataAkamaiImagingPolicyImage#gravity_priority}
        '''
        result = self._values.get("gravity_priority")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_priority_var(self) -> typing.Optional[builtins.str]:
        '''Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal.

        The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority_var DataAkamaiImagingPolicyImage#gravity_priority_var}
        '''
        result = self._values.get("gravity_priority_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Specifies where to place the ``image`` relative to the source image.

        The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def preserve_minor_dimension(self) -> typing.Optional[builtins.str]:
        '''Whether to preserve the source image's minor dimension, ``false`` by default.

        The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension DataAkamaiImagingPolicyImage#preserve_minor_dimension}
        '''
        result = self._values.get("preserve_minor_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def preserve_minor_dimension_var(self) -> typing.Optional[builtins.str]:
        '''Whether to preserve the source image's minor dimension, ``false`` by default.

        The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension_var DataAkamaiImagingPolicyImage#preserve_minor_dimension_var}
        '''
        result = self._values.get("preserve_minor_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppend(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImage",
    jsii_struct_bases=[],
    name_mapping={
        "box_image": "boxImage",
        "circle_image": "circleImage",
        "text_image": "textImage",
        "url_image": "urlImage",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImage:
    def __init__(
        self,
        *,
        box_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageBoxImage", typing.Dict[builtins.str, typing.Any]]]]] = None,
        circle_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageCircleImage", typing.Dict[builtins.str, typing.Any]]]]] = None,
        text_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageTextImage", typing.Dict[builtins.str, typing.Any]]]]] = None,
        url_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageUrlImage", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param box_image: box_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#box_image DataAkamaiImagingPolicyImage#box_image}
        :param circle_image: circle_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#circle_image DataAkamaiImagingPolicyImage#circle_image}
        :param text_image: text_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text_image DataAkamaiImagingPolicyImage#text_image}
        :param url_image: url_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url_image DataAkamaiImagingPolicyImage#url_image}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b9807f3644210d493de311acdfb041bd543525d56875cf1801f9ffde570d1787)
            check_type(argname="argument box_image", value=box_image, expected_type=type_hints["box_image"])
            check_type(argname="argument circle_image", value=circle_image, expected_type=type_hints["circle_image"])
            check_type(argname="argument text_image", value=text_image, expected_type=type_hints["text_image"])
            check_type(argname="argument url_image", value=url_image, expected_type=type_hints["url_image"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if box_image is not None:
            self._values["box_image"] = box_image
        if circle_image is not None:
            self._values["circle_image"] = circle_image
        if text_image is not None:
            self._values["text_image"] = text_image
        if url_image is not None:
            self._values["url_image"] = url_image

    @builtins.property
    def box_image(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageBoxImage"]]]:
        '''box_image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#box_image DataAkamaiImagingPolicyImage#box_image}
        '''
        result = self._values.get("box_image")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageBoxImage"]]], result)

    @builtins.property
    def circle_image(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageCircleImage"]]]:
        '''circle_image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#circle_image DataAkamaiImagingPolicyImage#circle_image}
        '''
        result = self._values.get("circle_image")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageCircleImage"]]], result)

    @builtins.property
    def text_image(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageTextImage"]]]:
        '''text_image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text_image DataAkamaiImagingPolicyImage#text_image}
        '''
        result = self._values.get("text_image")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageTextImage"]]], result)

    @builtins.property
    def url_image(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageUrlImage"]]]:
        '''url_image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url_image DataAkamaiImagingPolicyImage#url_image}
        '''
        result = self._values.get("url_image")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageUrlImage"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageBoxImage",
    jsii_struct_bases=[],
    name_mapping={
        "color": "color",
        "color_var": "colorVar",
        "height": "height",
        "height_var": "heightVar",
        "transformation": "transformation",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageBoxImage:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        transformation: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageBoxImageTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The fill color of the box, not the edge of the box. The API supports hexadecimal representation and CSS hexadecimal color values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The fill color of the box, not the edge of the box. The API supports hexadecimal representation and CSS hexadecimal color values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        :param height: The height of the box in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height of the box in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param transformation: transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        :param width: The width of the box in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width of the box in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(transformation, dict):
            transformation = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageBoxImageTransformation(**transformation)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__37008486f7d50fa42b3c01d73fb25821c5b231d3cf07fa0e667bfc2d8229909e)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument transformation", value=transformation, expected_type=type_hints["transformation"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if transformation is not None:
            self._values["transformation"] = transformation
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The fill color of the box, not the edge of the box.

        The API supports hexadecimal representation and CSS hexadecimal color values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The fill color of the box, not the edge of the box.

        The API supports hexadecimal representation and CSS hexadecimal color values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height of the box in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height of the box in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def transformation(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageBoxImageTransformation"]:
        '''transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        '''
        result = self._values.get("transformation")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageBoxImageTransformation"], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width of the box in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width of the box in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageBoxImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageBoxImageList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageBoxImageList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4c1988ae55de84aaa29acb3f377ddd9ed0005f3655d774f7742cb016c4b7bfc7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageBoxImageOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__665aca8a729498f8dcde3f9c7213b484cdd4cd82ae97eea44d1301e07a0d0a48)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageBoxImageOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d887249ff5a54e48e6637d3a994febccd64fc42d26c5e2880f1deca80bf47552)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__00cef6d57faa63ece0b7da8b9bd0b945c9e607c073330a49d5fdc9329762e858)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eaf87695d9f899c35998db0d09f7a5128d8c6593519a4ebba9b0d3274d8780a3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageBoxImage]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageBoxImage]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageBoxImage]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c7552682082020a009311be2a4a15f44228bf871f5b181a8c253b59ecc5c78c1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageBoxImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageBoxImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f7d23ac6b9e63891f6ba4af5410d3b0c0dec84d62c3b7014c142c7f3ee32caf)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformation")
    def put_transformation(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageBoxImageTransformation()

        return typing.cast(None, jsii.invoke(self, "putTransformation", [value]))

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetTransformation")
    def reset_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformation", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="transformation")
    def transformation(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageBoxImageTransformationOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageBoxImageTransformationOutputReference", jsii.get(self, "transformation"))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="transformationInput")
    def transformation_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageBoxImageTransformation"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageBoxImageTransformation"], jsii.get(self, "transformationInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ec10237633bf0c6bca8a25fb1eeb177a9c609d50da5c6737ca3116a173cf24be)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d6b8086d550be93b979d6b2ab369f2c057479eb59a8aab11b2996a1a3c65a379)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb5f9a3cff198223d92812e3e665f8a55bdb89d67d3b8b176c65b4d3fc6749ca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__24880531f8ab68ff0c9f524d8aa86ce5578383b961898aceeff4c75ef0828a72)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a093555302d6544c305b84b887cd27d9e186c764aeb969205ecd4a488b2e82a7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d5037275cd20a208bacde4824934114728e22802222746241fef75befa981de5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageBoxImage]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageBoxImage]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageBoxImage]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0154bcef91b78916e901c5cb132cc812b3b855f6d15353b32e970f56e17afeba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageBoxImageTransformation",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageBoxImageTransformation:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageBoxImageTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageBoxImageTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageBoxImageTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__692090e75eca3d04519c07ba9191a09e0748b756971ea690abe94015cd32e3de)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageBoxImageTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageBoxImageTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageBoxImageTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6b4ab1bee32196994b905ab67b610c3486c1ddc3114faeedf2bd585256c000fd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageCircleImage",
    jsii_struct_bases=[],
    name_mapping={
        "color": "color",
        "color_var": "colorVar",
        "diameter": "diameter",
        "diameter_var": "diameterVar",
        "transformation": "transformation",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageCircleImage:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
        diameter: typing.Optional[builtins.str] = None,
        diameter_var: typing.Optional[builtins.str] = None,
        transformation: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageCircleImageTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The fill color of the circle. The API supports hexadecimal representation and CSS hexadecimal color values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The fill color of the circle. The API supports hexadecimal representation and CSS hexadecimal color values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        :param diameter: The diameter of the circle. The diameter will be the width and the height of the image in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#diameter DataAkamaiImagingPolicyImage#diameter}
        :param diameter_var: The diameter of the circle. The diameter will be the width and the height of the image in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#diameter_var DataAkamaiImagingPolicyImage#diameter_var}
        :param transformation: transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        :param width: The width of the box in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width of the box in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(transformation, dict):
            transformation = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageCircleImageTransformation(**transformation)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__765639eed9a84fe3bed7023f1a38ff17433989fa4bcd6b499a3248b05f5cfa6a)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
            check_type(argname="argument diameter", value=diameter, expected_type=type_hints["diameter"])
            check_type(argname="argument diameter_var", value=diameter_var, expected_type=type_hints["diameter_var"])
            check_type(argname="argument transformation", value=transformation, expected_type=type_hints["transformation"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var
        if diameter is not None:
            self._values["diameter"] = diameter
        if diameter_var is not None:
            self._values["diameter_var"] = diameter_var
        if transformation is not None:
            self._values["transformation"] = transformation
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The fill color of the circle. The API supports hexadecimal representation and CSS hexadecimal color values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The fill color of the circle. The API supports hexadecimal representation and CSS hexadecimal color values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def diameter(self) -> typing.Optional[builtins.str]:
        '''The diameter of the circle. The diameter will be the width and the height of the image in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#diameter DataAkamaiImagingPolicyImage#diameter}
        '''
        result = self._values.get("diameter")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def diameter_var(self) -> typing.Optional[builtins.str]:
        '''The diameter of the circle. The diameter will be the width and the height of the image in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#diameter_var DataAkamaiImagingPolicyImage#diameter_var}
        '''
        result = self._values.get("diameter_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def transformation(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageCircleImageTransformation"]:
        '''transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        '''
        result = self._values.get("transformation")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageCircleImageTransformation"], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width of the box in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width of the box in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageCircleImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageCircleImageList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageCircleImageList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__54ecfd8b3cfb8dfcafa2a168c749f00f6c7e871ff06b9e6dce23fe38a8da47c1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageCircleImageOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f7b03385006958c1da5f395c189a4b195d90e1e8c24dd2f666ec1ac8b09441a7)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageCircleImageOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f89864f39bf30fbfc21efdab2e4a34d7ed1b46ad30ae8686e4a009ffe58288b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__35c9f947f5d89e7203995e2d34be56eb917b1522b15a690b20b582299d92bddc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c070d68a6d873e0cf4bd4a61499f73f4bfdc49aef48f69c767c3f4c55de93585)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageCircleImage]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageCircleImage]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageCircleImage]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__adad60a0a05868010d2872682ac590e24f7d1336ea88c44ad4f7b34a286874ea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageCircleImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageCircleImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d3a728221e1b94a8edb213ac97edabae8f652bb4d27fbb867b9cb05d367064b8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformation")
    def put_transformation(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageCircleImageTransformation()

        return typing.cast(None, jsii.invoke(self, "putTransformation", [value]))

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @jsii.member(jsii_name="resetDiameter")
    def reset_diameter(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDiameter", []))

    @jsii.member(jsii_name="resetDiameterVar")
    def reset_diameter_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDiameterVar", []))

    @jsii.member(jsii_name="resetTransformation")
    def reset_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformation", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="transformation")
    def transformation(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageCircleImageTransformationOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageCircleImageTransformationOutputReference", jsii.get(self, "transformation"))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="diameterInput")
    def diameter_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "diameterInput"))

    @builtins.property
    @jsii.member(jsii_name="diameterVarInput")
    def diameter_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "diameterVarInput"))

    @builtins.property
    @jsii.member(jsii_name="transformationInput")
    def transformation_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageCircleImageTransformation"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageCircleImageTransformation"], jsii.get(self, "transformationInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e2499acee1d49d764fec6ce717b8a53767bff80ea306aeacb20eb65bca326a60)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b9f5c247723f7994ff3794b0629929a67c60d36414f8e546a940acfaae7c7a41)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="diameter")
    def diameter(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "diameter"))

    @diameter.setter
    def diameter(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c34bd4415ba5924fc763e259f13b0a2044fe691e782884c76e54b4e2c81ed4fa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "diameter", value)

    @builtins.property
    @jsii.member(jsii_name="diameterVar")
    def diameter_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "diameterVar"))

    @diameter_var.setter
    def diameter_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__97b627c9a2fe01d4ff25faa2a6565685824f65c5c5f654353a80b1b670f3fdf6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "diameterVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0bfe93bef93a9e895a4522493a541d86f1e69a9730010bec17f08be5d655405d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1beed3db9cdcf8a61a5025e6ac699f4989b996c8a300bfc92fa8a4a02b1bed44)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageCircleImage]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageCircleImage]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageCircleImage]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ce9cd8c75d80e7d26ee97cacd2195b719eedb2cdf982752b93f2dec2915045ab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageCircleImageTransformation",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageCircleImageTransformation:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageCircleImageTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageCircleImageTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageCircleImageTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__32b5de7f39c72e14b1dea3fce82ae5a7bf22737e56f8efb945f5865d61645a03)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageCircleImageTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageCircleImageTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageCircleImageTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ca4d581de1d48a999f82d895b32fa6677532b8f75f86b1f8abf08f22fd6fdc4e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c5a863aff3d3204a1c860748e7b1f6da4cd2ac90596219155a5133b34c21d0a8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putBoxImage")
    def put_box_image(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageBoxImage, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a9593d40af5d1e143168b8042aa54699f371fbcad02623c36335ae8b605de008)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBoxImage", [value]))

    @jsii.member(jsii_name="putCircleImage")
    def put_circle_image(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageCircleImage, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1dc0a2a52ad1732d2ec9c0277dfcaa4559a970188b541a99e3b47750580ac147)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCircleImage", [value]))

    @jsii.member(jsii_name="putTextImage")
    def put_text_image(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageTextImage", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__66e52e4188d14a3e7b8b500f7758df17695d45dfdc76a393f51646f40b279fd5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTextImage", [value]))

    @jsii.member(jsii_name="putUrlImage")
    def put_url_image(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageUrlImage", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3e03d065172c16e011ccfd3637653fb8f909943b88cc0be5cdad594e43e530b7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putUrlImage", [value]))

    @jsii.member(jsii_name="resetBoxImage")
    def reset_box_image(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBoxImage", []))

    @jsii.member(jsii_name="resetCircleImage")
    def reset_circle_image(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCircleImage", []))

    @jsii.member(jsii_name="resetTextImage")
    def reset_text_image(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTextImage", []))

    @jsii.member(jsii_name="resetUrlImage")
    def reset_url_image(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUrlImage", []))

    @builtins.property
    @jsii.member(jsii_name="boxImage")
    def box_image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageBoxImageList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageBoxImageList, jsii.get(self, "boxImage"))

    @builtins.property
    @jsii.member(jsii_name="circleImage")
    def circle_image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageCircleImageList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageCircleImageList, jsii.get(self, "circleImage"))

    @builtins.property
    @jsii.member(jsii_name="textImage")
    def text_image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageTextImageList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageTextImageList", jsii.get(self, "textImage"))

    @builtins.property
    @jsii.member(jsii_name="urlImage")
    def url_image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageUrlImageList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageUrlImageList", jsii.get(self, "urlImage"))

    @builtins.property
    @jsii.member(jsii_name="boxImageInput")
    def box_image_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageBoxImage]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageBoxImage]]], jsii.get(self, "boxImageInput"))

    @builtins.property
    @jsii.member(jsii_name="circleImageInput")
    def circle_image_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageCircleImage]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageCircleImage]]], jsii.get(self, "circleImageInput"))

    @builtins.property
    @jsii.member(jsii_name="textImageInput")
    def text_image_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageTextImage"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageTextImage"]]], jsii.get(self, "textImageInput"))

    @builtins.property
    @jsii.member(jsii_name="urlImageInput")
    def url_image_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageUrlImage"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageUrlImage"]]], jsii.get(self, "urlImageInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1305881de05ce5ea13b80233287eff7e26e70e876f2ce5b8bc548b3478690c8d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageTextImage",
    jsii_struct_bases=[],
    name_mapping={
        "fill": "fill",
        "fill_var": "fillVar",
        "size": "size",
        "size_var": "sizeVar",
        "stroke": "stroke",
        "stroke_size": "strokeSize",
        "stroke_size_var": "strokeSizeVar",
        "stroke_var": "strokeVar",
        "text": "text",
        "text_var": "textVar",
        "transformation": "transformation",
        "typeface": "typeface",
        "typeface_var": "typefaceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageTextImage:
    def __init__(
        self,
        *,
        fill: typing.Optional[builtins.str] = None,
        fill_var: typing.Optional[builtins.str] = None,
        size: typing.Optional[builtins.str] = None,
        size_var: typing.Optional[builtins.str] = None,
        stroke: typing.Optional[builtins.str] = None,
        stroke_size: typing.Optional[builtins.str] = None,
        stroke_size_var: typing.Optional[builtins.str] = None,
        stroke_var: typing.Optional[builtins.str] = None,
        text: typing.Optional[builtins.str] = None,
        text_var: typing.Optional[builtins.str] = None,
        transformation: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageTextImageTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        typeface: typing.Optional[builtins.str] = None,
        typeface_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fill: The main fill color of the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill DataAkamaiImagingPolicyImage#fill}
        :param fill_var: The main fill color of the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_var DataAkamaiImagingPolicyImage#fill_var}
        :param size: The size in pixels to render the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#size DataAkamaiImagingPolicyImage#size}
        :param size_var: The size in pixels to render the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#size_var DataAkamaiImagingPolicyImage#size_var}
        :param stroke: The color for the outline of the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke DataAkamaiImagingPolicyImage#stroke}
        :param stroke_size: The thickness in points for the outline of the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_size DataAkamaiImagingPolicyImage#stroke_size}
        :param stroke_size_var: The thickness in points for the outline of the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_size_var DataAkamaiImagingPolicyImage#stroke_size_var}
        :param stroke_var: The color for the outline of the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_var DataAkamaiImagingPolicyImage#stroke_var}
        :param text: The line of text to render. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text DataAkamaiImagingPolicyImage#text}
        :param text_var: The line of text to render. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text_var DataAkamaiImagingPolicyImage#text_var}
        :param transformation: transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        :param typeface: The font family to apply to the text image. This may be a URL to a TrueType or WOFF (v1) typeface, or a string that refers to one of the standard built-in browser fonts. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#typeface DataAkamaiImagingPolicyImage#typeface}
        :param typeface_var: The font family to apply to the text image. This may be a URL to a TrueType or WOFF (v1) typeface, or a string that refers to one of the standard built-in browser fonts. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#typeface_var DataAkamaiImagingPolicyImage#typeface_var}
        '''
        if isinstance(transformation, dict):
            transformation = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageTextImageTransformation(**transformation)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__548eda18db6a2b5cfdcca36548ad32f39be677baa6a58cfc8470a5e13e13e977)
            check_type(argname="argument fill", value=fill, expected_type=type_hints["fill"])
            check_type(argname="argument fill_var", value=fill_var, expected_type=type_hints["fill_var"])
            check_type(argname="argument size", value=size, expected_type=type_hints["size"])
            check_type(argname="argument size_var", value=size_var, expected_type=type_hints["size_var"])
            check_type(argname="argument stroke", value=stroke, expected_type=type_hints["stroke"])
            check_type(argname="argument stroke_size", value=stroke_size, expected_type=type_hints["stroke_size"])
            check_type(argname="argument stroke_size_var", value=stroke_size_var, expected_type=type_hints["stroke_size_var"])
            check_type(argname="argument stroke_var", value=stroke_var, expected_type=type_hints["stroke_var"])
            check_type(argname="argument text", value=text, expected_type=type_hints["text"])
            check_type(argname="argument text_var", value=text_var, expected_type=type_hints["text_var"])
            check_type(argname="argument transformation", value=transformation, expected_type=type_hints["transformation"])
            check_type(argname="argument typeface", value=typeface, expected_type=type_hints["typeface"])
            check_type(argname="argument typeface_var", value=typeface_var, expected_type=type_hints["typeface_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fill is not None:
            self._values["fill"] = fill
        if fill_var is not None:
            self._values["fill_var"] = fill_var
        if size is not None:
            self._values["size"] = size
        if size_var is not None:
            self._values["size_var"] = size_var
        if stroke is not None:
            self._values["stroke"] = stroke
        if stroke_size is not None:
            self._values["stroke_size"] = stroke_size
        if stroke_size_var is not None:
            self._values["stroke_size_var"] = stroke_size_var
        if stroke_var is not None:
            self._values["stroke_var"] = stroke_var
        if text is not None:
            self._values["text"] = text
        if text_var is not None:
            self._values["text_var"] = text_var
        if transformation is not None:
            self._values["transformation"] = transformation
        if typeface is not None:
            self._values["typeface"] = typeface
        if typeface_var is not None:
            self._values["typeface_var"] = typeface_var

    @builtins.property
    def fill(self) -> typing.Optional[builtins.str]:
        '''The main fill color of the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill DataAkamaiImagingPolicyImage#fill}
        '''
        result = self._values.get("fill")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fill_var(self) -> typing.Optional[builtins.str]:
        '''The main fill color of the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_var DataAkamaiImagingPolicyImage#fill_var}
        '''
        result = self._values.get("fill_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def size(self) -> typing.Optional[builtins.str]:
        '''The size in pixels to render the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#size DataAkamaiImagingPolicyImage#size}
        '''
        result = self._values.get("size")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def size_var(self) -> typing.Optional[builtins.str]:
        '''The size in pixels to render the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#size_var DataAkamaiImagingPolicyImage#size_var}
        '''
        result = self._values.get("size_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def stroke(self) -> typing.Optional[builtins.str]:
        '''The color for the outline of the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke DataAkamaiImagingPolicyImage#stroke}
        '''
        result = self._values.get("stroke")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def stroke_size(self) -> typing.Optional[builtins.str]:
        '''The thickness in points for the outline of the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_size DataAkamaiImagingPolicyImage#stroke_size}
        '''
        result = self._values.get("stroke_size")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def stroke_size_var(self) -> typing.Optional[builtins.str]:
        '''The thickness in points for the outline of the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_size_var DataAkamaiImagingPolicyImage#stroke_size_var}
        '''
        result = self._values.get("stroke_size_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def stroke_var(self) -> typing.Optional[builtins.str]:
        '''The color for the outline of the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_var DataAkamaiImagingPolicyImage#stroke_var}
        '''
        result = self._values.get("stroke_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def text(self) -> typing.Optional[builtins.str]:
        '''The line of text to render.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text DataAkamaiImagingPolicyImage#text}
        '''
        result = self._values.get("text")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def text_var(self) -> typing.Optional[builtins.str]:
        '''The line of text to render.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text_var DataAkamaiImagingPolicyImage#text_var}
        '''
        result = self._values.get("text_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def transformation(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageTextImageTransformation"]:
        '''transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        '''
        result = self._values.get("transformation")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageTextImageTransformation"], result)

    @builtins.property
    def typeface(self) -> typing.Optional[builtins.str]:
        '''The font family to apply to the text image.

        This may be a URL to a TrueType or WOFF (v1) typeface, or a string that refers to one of the standard built-in browser fonts.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#typeface DataAkamaiImagingPolicyImage#typeface}
        '''
        result = self._values.get("typeface")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def typeface_var(self) -> typing.Optional[builtins.str]:
        '''The font family to apply to the text image.

        This may be a URL to a TrueType or WOFF (v1) typeface, or a string that refers to one of the standard built-in browser fonts.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#typeface_var DataAkamaiImagingPolicyImage#typeface_var}
        '''
        result = self._values.get("typeface_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageTextImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageTextImageList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageTextImageList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__024290f5fe0a4b211f04e30105f6545691597ea420d711ecb824b3f48c2800b4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageTextImageOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__de19bcf5d265f6c461770bdee1e457400a30439dd2ae56e55b4f50eaa1dc8b00)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageTextImageOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__55bab8498a6570d27046665fe68fc10a67bb280f50337044646b502f1ce8c1c5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f23cf0649f458508bbab47cee91a8572f0c56d2ba5b53fa641d733849af0524e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4383df23eadd6e83a0996f70c40b3251ceee396d4744ab6038b532efa295286f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageTextImage]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageTextImage]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageTextImage]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a3513a4764c9e46ff09e9403a88d79cee0dbdd94cc0420aeecfefcb511dfa9b9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageTextImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageTextImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bd9b7bd12cc5e986297f29aea8d175809330bf5d67b6e2954cbaf2088b53ed8b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformation")
    def put_transformation(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageTextImageTransformation()

        return typing.cast(None, jsii.invoke(self, "putTransformation", [value]))

    @jsii.member(jsii_name="resetFill")
    def reset_fill(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFill", []))

    @jsii.member(jsii_name="resetFillVar")
    def reset_fill_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFillVar", []))

    @jsii.member(jsii_name="resetSize")
    def reset_size(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSize", []))

    @jsii.member(jsii_name="resetSizeVar")
    def reset_size_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSizeVar", []))

    @jsii.member(jsii_name="resetStroke")
    def reset_stroke(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStroke", []))

    @jsii.member(jsii_name="resetStrokeSize")
    def reset_stroke_size(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStrokeSize", []))

    @jsii.member(jsii_name="resetStrokeSizeVar")
    def reset_stroke_size_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStrokeSizeVar", []))

    @jsii.member(jsii_name="resetStrokeVar")
    def reset_stroke_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStrokeVar", []))

    @jsii.member(jsii_name="resetText")
    def reset_text(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetText", []))

    @jsii.member(jsii_name="resetTextVar")
    def reset_text_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTextVar", []))

    @jsii.member(jsii_name="resetTransformation")
    def reset_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformation", []))

    @jsii.member(jsii_name="resetTypeface")
    def reset_typeface(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeface", []))

    @jsii.member(jsii_name="resetTypefaceVar")
    def reset_typeface_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypefaceVar", []))

    @builtins.property
    @jsii.member(jsii_name="transformation")
    def transformation(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageTextImageTransformationOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageTextImageTransformationOutputReference", jsii.get(self, "transformation"))

    @builtins.property
    @jsii.member(jsii_name="fillInput")
    def fill_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fillInput"))

    @builtins.property
    @jsii.member(jsii_name="fillVarInput")
    def fill_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fillVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sizeInput")
    def size_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sizeInput"))

    @builtins.property
    @jsii.member(jsii_name="sizeVarInput")
    def size_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sizeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="strokeInput")
    def stroke_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "strokeInput"))

    @builtins.property
    @jsii.member(jsii_name="strokeSizeInput")
    def stroke_size_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "strokeSizeInput"))

    @builtins.property
    @jsii.member(jsii_name="strokeSizeVarInput")
    def stroke_size_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "strokeSizeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="strokeVarInput")
    def stroke_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "strokeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="textInput")
    def text_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "textInput"))

    @builtins.property
    @jsii.member(jsii_name="textVarInput")
    def text_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "textVarInput"))

    @builtins.property
    @jsii.member(jsii_name="transformationInput")
    def transformation_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageTextImageTransformation"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageTextImageTransformation"], jsii.get(self, "transformationInput"))

    @builtins.property
    @jsii.member(jsii_name="typefaceInput")
    def typeface_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typefaceInput"))

    @builtins.property
    @jsii.member(jsii_name="typefaceVarInput")
    def typeface_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typefaceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="fill")
    def fill(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fill"))

    @fill.setter
    def fill(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f9933ff16b752e16f843a889a4c2c246e68518fefc6fcbd3a7dc9d2154609f07)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fill", value)

    @builtins.property
    @jsii.member(jsii_name="fillVar")
    def fill_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fillVar"))

    @fill_var.setter
    def fill_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__865de5e276a8976d4cbeff965a0bd984bc659c72b68f9667889e7ff24509c0e7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fillVar", value)

    @builtins.property
    @jsii.member(jsii_name="size")
    def size(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "size"))

    @size.setter
    def size(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__48194d42ec16d490302fe0d16d1cdcdd7ef5f8b5669a7bf0ddce5a0d517e9b0c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "size", value)

    @builtins.property
    @jsii.member(jsii_name="sizeVar")
    def size_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sizeVar"))

    @size_var.setter
    def size_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b3dbab889dd371e570ec88da4ed6ab687fe196c3f7907d071e68d221c1c419a7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sizeVar", value)

    @builtins.property
    @jsii.member(jsii_name="stroke")
    def stroke(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "stroke"))

    @stroke.setter
    def stroke(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a865bca92275b3b4da1df43c671723a4bf08987fa5bb84482e9e87fc19718b2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "stroke", value)

    @builtins.property
    @jsii.member(jsii_name="strokeSize")
    def stroke_size(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "strokeSize"))

    @stroke_size.setter
    def stroke_size(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4dce2281119ad50602ba07e0e8bdf9213963ce71269714022255b77c047dc5f0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "strokeSize", value)

    @builtins.property
    @jsii.member(jsii_name="strokeSizeVar")
    def stroke_size_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "strokeSizeVar"))

    @stroke_size_var.setter
    def stroke_size_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1c5ec43ee26ff24d15402b6cf536583305eb6b48c9e3e288bebde0f01a48dd0a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "strokeSizeVar", value)

    @builtins.property
    @jsii.member(jsii_name="strokeVar")
    def stroke_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "strokeVar"))

    @stroke_var.setter
    def stroke_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__565145d179c277eb9ca4ed00568b8fdfb35d7034a48d344892b581db5ffd2325)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "strokeVar", value)

    @builtins.property
    @jsii.member(jsii_name="text")
    def text(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "text"))

    @text.setter
    def text(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c628feeeed0cc9c67df00a30c2844513f6a6d88f702ff93d400d2cfa7dd09077)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "text", value)

    @builtins.property
    @jsii.member(jsii_name="textVar")
    def text_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "textVar"))

    @text_var.setter
    def text_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8b95fba50804b0edfac28dc523e78400fef4789081fcbc614501ff51714d1153)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "textVar", value)

    @builtins.property
    @jsii.member(jsii_name="typeface")
    def typeface(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeface"))

    @typeface.setter
    def typeface(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__decbfc27e7ea9b72de27ac2a742108285f244c0d8075dc24b7ed95d0ecc84905)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeface", value)

    @builtins.property
    @jsii.member(jsii_name="typefaceVar")
    def typeface_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typefaceVar"))

    @typeface_var.setter
    def typeface_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f7ae33dca63de9987037d1cdbb21fbf84fe4238e899939200193c80d727597fb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typefaceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageTextImage]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageTextImage]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageTextImage]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2568f6e19514f72e25d861c379a98f5f87e475670d236e938e1df4161c249d63)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageTextImageTransformation",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageTextImageTransformation:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageTextImageTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageTextImageTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageTextImageTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bac6a8639ec4041d66eb37c57528898651bc966f215c0aa7d3b689b3a7f589a5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageTextImageTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageTextImageTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageTextImageTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__959a674735e71964f79fcfa20131c68b9b7eab5bfe8921efc3900a108ff1dbc0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageUrlImage",
    jsii_struct_bases=[],
    name_mapping={
        "transformation": "transformation",
        "url": "url",
        "url_var": "urlVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageUrlImage:
    def __init__(
        self,
        *,
        transformation: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageUrlImageTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        url: typing.Optional[builtins.str] = None,
        url_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param transformation: transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        :param url: The URL of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url DataAkamaiImagingPolicyImage#url}
        :param url_var: The URL of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url_var DataAkamaiImagingPolicyImage#url_var}
        '''
        if isinstance(transformation, dict):
            transformation = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageUrlImageTransformation(**transformation)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e143abb3310040296d911e8b7308be80bff989aebaa9969bea0a3e7e55fec60)
            check_type(argname="argument transformation", value=transformation, expected_type=type_hints["transformation"])
            check_type(argname="argument url", value=url, expected_type=type_hints["url"])
            check_type(argname="argument url_var", value=url_var, expected_type=type_hints["url_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if transformation is not None:
            self._values["transformation"] = transformation
        if url is not None:
            self._values["url"] = url
        if url_var is not None:
            self._values["url_var"] = url_var

    @builtins.property
    def transformation(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageUrlImageTransformation"]:
        '''transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        '''
        result = self._values.get("transformation")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageUrlImageTransformation"], result)

    @builtins.property
    def url(self) -> typing.Optional[builtins.str]:
        '''The URL of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url DataAkamaiImagingPolicyImage#url}
        '''
        result = self._values.get("url")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def url_var(self) -> typing.Optional[builtins.str]:
        '''The URL of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url_var DataAkamaiImagingPolicyImage#url_var}
        '''
        result = self._values.get("url_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageUrlImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageUrlImageList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageUrlImageList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c921ce24ad99b7330053c870ed712927fd997abc978ead5625168a1621f31592)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageUrlImageOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3835585d9f2c79a448b6578601a208e46414e1838fc53c1865c62318c82cb317)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageUrlImageOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1fb654422c456872bcb5e12e13c05a0cfafa833b290fc4b03e614f81c7ed313d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b22fd8604a7ff0070adb08cec5cfd5d6ab73d3a076df057212ded746507d488a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cb2ff910e57c27951e2642a73b9318931c9f5f2ce5435c978977199151b0632a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageUrlImage]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageUrlImage]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageUrlImage]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__30f5c70cfccc3008439d0bd06caa172540369ba12ba833a8c9bdfdd238d26a82)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageUrlImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageUrlImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__34a5790b9947db73ff64c590973d9c3db5fb46b73e3c1bc04a5627b908d5a13a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformation")
    def put_transformation(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageUrlImageTransformation()

        return typing.cast(None, jsii.invoke(self, "putTransformation", [value]))

    @jsii.member(jsii_name="resetTransformation")
    def reset_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformation", []))

    @jsii.member(jsii_name="resetUrl")
    def reset_url(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUrl", []))

    @jsii.member(jsii_name="resetUrlVar")
    def reset_url_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUrlVar", []))

    @builtins.property
    @jsii.member(jsii_name="transformation")
    def transformation(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageUrlImageTransformationOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageUrlImageTransformationOutputReference", jsii.get(self, "transformation"))

    @builtins.property
    @jsii.member(jsii_name="transformationInput")
    def transformation_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageUrlImageTransformation"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageUrlImageTransformation"], jsii.get(self, "transformationInput"))

    @builtins.property
    @jsii.member(jsii_name="urlInput")
    def url_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "urlInput"))

    @builtins.property
    @jsii.member(jsii_name="urlVarInput")
    def url_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "urlVarInput"))

    @builtins.property
    @jsii.member(jsii_name="url")
    def url(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "url"))

    @url.setter
    def url(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cb18187881a00b0f49e8527015e03c3694578c86fec4cd00dab52ce56f8eb289)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "url", value)

    @builtins.property
    @jsii.member(jsii_name="urlVar")
    def url_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "urlVar"))

    @url_var.setter
    def url_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__68edae1fec545006e019e223ee46c612f687ac4e00bed102fd2aca03668a8eb5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "urlVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageUrlImage]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageUrlImage]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageUrlImage]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4816cf57fe94f5fb0dcb16efdf06b444b8b9245ea646bc5f83fe316f7ef8abd6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageUrlImageTransformation",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageUrlImageTransformation:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageUrlImageTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageUrlImageTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageUrlImageTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6a634e6b7abe2e006cbef4dd720fc25d9af05428351ba24662b496c9187bfed0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageUrlImageTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageUrlImageTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageUrlImageTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e26f183407831fc75da825a77eebb1cd6514582800628c37691cfa46b3178cb1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1d3a1a0eca5a6fc65185ac0f8ba1ec80533cfe56a4189b238ca17d23f574cd24)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ebcf8a782702e488b65b4732302fad2ce1edb8d30b1aeb89a98b4fa4cc772cb)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__84c72afdea11bf04adf120d1e29bda682a887fc05871ce348a65e7a8367ee774)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__01064c1152ebdf38a4de1e9f30f66b5fab380eba1f3ac68a807edee035d58321)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8695a1f7d81565fbf1d3cfe4a6d68f4b7e85ef0de574d6bc40af97b6f337c81a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppend]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppend]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppend]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__68ca267cb754a628a1b83735f5ce24b126b0e32c465b6452a90bb0f36eed89ec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__406f0c1911748a93805b2dd4344a1f86d5f38c15856fb606b7dd873b8726751f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(
        self,
        *,
        box_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageBoxImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
        circle_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageCircleImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
        text_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageTextImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
        url_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageUrlImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param box_image: box_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#box_image DataAkamaiImagingPolicyImage#box_image}
        :param circle_image: circle_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#circle_image DataAkamaiImagingPolicyImage#circle_image}
        :param text_image: text_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text_image DataAkamaiImagingPolicyImage#text_image}
        :param url_image: url_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url_image DataAkamaiImagingPolicyImage#url_image}
        '''
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImage(
            box_image=box_image,
            circle_image=circle_image,
            text_image=text_image,
            url_image=url_image,
        )

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityPriority")
    def reset_gravity_priority(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityPriority", []))

    @jsii.member(jsii_name="resetGravityPriorityVar")
    def reset_gravity_priority_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityPriorityVar", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPreserveMinorDimension")
    def reset_preserve_minor_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPreserveMinorDimension", []))

    @jsii.member(jsii_name="resetPreserveMinorDimensionVar")
    def reset_preserve_minor_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPreserveMinorDimensionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityInput")
    def gravity_priority_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityPriorityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityVarInput")
    def gravity_priority_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityPriorityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionInput")
    def preserve_minor_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "preserveMinorDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionVarInput")
    def preserve_minor_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "preserveMinorDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__24ce85bb2b336b2bdea3ca08bf0ce3caf465028afe62ee676832aaf68ddbd8e7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityPriority")
    def gravity_priority(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityPriority"))

    @gravity_priority.setter
    def gravity_priority(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eaa126486cc066eef6306a7f07372b1954f947947c1725e5e2edbd9eed5dc08b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityPriority", value)

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityVar")
    def gravity_priority_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityPriorityVar"))

    @gravity_priority_var.setter
    def gravity_priority_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e56c993608348540627c7a07fbd4a8b680a4ac9b5c77d48c3fa473e3b8283dd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityPriorityVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f47e9c85de0c7c946b864daaf4fd6fc7ce547e801af00aca2450d9d59b293e29)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimension")
    def preserve_minor_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "preserveMinorDimension"))

    @preserve_minor_dimension.setter
    def preserve_minor_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c374ec8ef1166423608218a835e6dc8c7cfd29ac72d947eabb1450e5e1130aa6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "preserveMinorDimension", value)

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionVar")
    def preserve_minor_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "preserveMinorDimensionVar"))

    @preserve_minor_dimension_var.setter
    def preserve_minor_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4558224a4b9dca37eae88b3db96bddbf9b32944c62787ad85237596602746236)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "preserveMinorDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppend]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppend]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppend]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0450c8f4db73f1da0e39c96f75b5beba3d0f1170deb21a4616a44c8bcb808260)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAspectCrop",
    jsii_struct_bases=[],
    name_mapping={
        "allow_expansion": "allowExpansion",
        "allow_expansion_var": "allowExpansionVar",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAspectCrop:
    def __init__(
        self,
        *,
        allow_expansion: typing.Optional[builtins.str] = None,
        allow_expansion_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_expansion: Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image. Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        :param allow_expansion_var: Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image. Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        :param height: The height term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The width term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        :param x_position: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f1641145ae6d3c01e52f7a7455f9a3951217267160b54629bbdc48d3e9f5f54)
            check_type(argname="argument allow_expansion", value=allow_expansion, expected_type=type_hints["allow_expansion"])
            check_type(argname="argument allow_expansion_var", value=allow_expansion_var, expected_type=type_hints["allow_expansion_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if allow_expansion is not None:
            self._values["allow_expansion"] = allow_expansion
        if allow_expansion_var is not None:
            self._values["allow_expansion_var"] = allow_expansion_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def allow_expansion(self) -> typing.Optional[builtins.str]:
        '''Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image.

        Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        '''
        result = self._values.get("allow_expansion")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def allow_expansion_var(self) -> typing.Optional[builtins.str]:
        '''Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image.

        Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        '''
        result = self._values.get("allow_expansion_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAspectCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAspectCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAspectCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2f2ff8d46bd5d256cfd48669b3f57278cb0f73deb7db713b20bb88eb61340602)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAspectCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__57b0b6a37be37a6de4d8176c35df0c64a63ac7a46b87d79c83f7cc2b282f1dd5)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAspectCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b726637a7183319baeff81fa31acb4ea66fc894623491575723e385aaca8b92b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e3b120db5999de437702a44f5d09fc8ca5632325d759d7247f40ef608176b9a0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0341aac9b898616f7ec807bfd6210e64b47194857f63984676101063484ce01f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAspectCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAspectCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAspectCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fcc69386dc6e4a954de6f736aff9410ed66194ecabcfab837862db43448bc1fd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAspectCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAspectCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b1ca583a0e6c0197d094e3a218662e9af82cbd274de0fa76ca1d10b2dc2f414c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAllowExpansion")
    def reset_allow_expansion(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansion", []))

    @jsii.member(jsii_name="resetAllowExpansionVar")
    def reset_allow_expansion_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansionVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionInput")
    def allow_expansion_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVarInput")
    def allow_expansion_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansion")
    def allow_expansion(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansion"))

    @allow_expansion.setter
    def allow_expansion(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b313c42c48c45202a4c9759e5cfb1bb08b320857c97707d947667f3e28f9d5cb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansion", value)

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVar")
    def allow_expansion_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansionVar"))

    @allow_expansion_var.setter
    def allow_expansion_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__19437905eec5251bd051450f9236cffed91752b4b759b3815066b7b502b6ad3f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansionVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__367c812c73d6ffad2735a5ac0cce4c3597d2563ad14485c83d89378d62f6da25)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__34a1b9cc6bb609cfdc1382f6bd3393031471cb9ffe4596d35858e7141022eb9b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ce209d026931e69c01ad02bb826b6d8e0d163cca5b4aebb319f989d7aecd1a73)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7cb16fd08a3fe7019e6df4160576d9cd4583d585f9b2371dd997f5ae9b02ed9a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__de2c7f404fa63401ff000099e49d3eb0e64e2a0c16311eb7f1d49c6b1d9caa2a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__523b27594a8d553fa33c1e3d80b58641c35ab3c6840cd8d4a9d7597d03875a55)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e25e5317630909b4f073b13e63a01676bb9a55707d009c49c79759faaa902740)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a3d305396b5bc4ec4bf7bf65635001898958bb4acc1a72ec4a369667cf7ae1dd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAspectCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAspectCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAspectCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3afd62731111d1b35ddbe3bd645537bfbd2a933ffc5507ed358563f4c8adb6e4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanBackgroundColor",
    jsii_struct_bases=[],
    name_mapping={"color": "color", "color_var": "colorVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanBackgroundColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa5220f8f5a87f74446e618e66e5bf7e3dcd3dc35acf6511433f442f87ad78dd)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanBackgroundColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanBackgroundColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanBackgroundColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c160d568c3be330fc77d209b9cfdc852d9824610c414e8d97aedaadef1346bcd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanBackgroundColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ffc3aef9eeec4d9c0edb40dbbf24297de360e681288b2123c105f53ab4607fd1)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanBackgroundColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f9cd5356be79da9eb23be57e51c49dfa02a4e697c0c649d48f28bb4364c122cf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__17df4917955afc0f4377fa7389e3e98bc5fb8ae70e8a0d0dfbb7faa88f1d414a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2586d8590568fd9691ba5290c980dba5cd18580e5458fac878ab6e2649ec0479)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanBackgroundColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanBackgroundColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__11b8a9823daac5422dde4db296d2170250f13aac5dfdca17e05915144c3f24e6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanBackgroundColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanBackgroundColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__535751434410f3d3f8ac0bc83daac10e38e07107d43b8fc5f4e992ab3af86cb1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ec71ecf107059a93fb62ba51304cb1fb83b09ce0fd5efb15df86faa1ac8197d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d82ece0f1367c6bbde66d7e0519a4abec79a7e13cc3b2a860aba4de3aaec9ad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanBackgroundColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanBackgroundColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanBackgroundColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af3e7a4609a0198da289a765b1942db6b797759eb509e4a08d45580c8b058cf7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanBlur",
    jsii_struct_bases=[],
    name_mapping={"sigma": "sigma", "sigma_var": "sigmaVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanBlur:
    def __init__(
        self,
        *,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param sigma: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8d5d0d636aeb3e89337dba3b6c9eb6e9c4553ae6639754578e18da2fbf383a17)
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanBlur(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanBlurList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanBlurList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e7fca2af34b38a65754b8405db7a32708ec51f49809f97445288ae962d7109bf)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanBlurOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__59af16936352f5c73a5b9ff633a7d50f123a697045508af1fdd2a3ee53c02beb)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanBlurOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__59a20345b30ca9b7c2b1998e163a51950bef1f51f1d76f056c7b60538dd88ce3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b1aec9ba265809d58a8f8517effda993920015bca6a2549d2adf7b429e168591)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4f6e22cdef2f7c892d9cbed4f2e93ca9743e1d0ad198ea34621ba2a5a7c426c5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanBlur]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanBlur]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__07940286353e3e947dd037b10d19cba95575bd7f95acdc1633ebcb131b549e2d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanBlurOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanBlurOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e05f71a56e948075e09b2f42830086842564cefcaf679d4dff743f7e06e29cda)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d3828bcb510ae5b9acfd0bd8c759760089da219a93897b8b2c0f561a1f9da6ec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2971cb9f8d0c0ad2c6039a32fc2adea0209ee559b1970713179c92c61ac79751)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanBlur]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanBlur]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanBlur]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dd606259b5e2db40bb14b2f4c16297fd207858ca8c639922459654beea01742d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanChromaKey",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_feather": "hueFeather",
        "hue_feather_var": "hueFeatherVar",
        "hue_tolerance": "hueTolerance",
        "hue_tolerance_var": "hueToleranceVar",
        "hue_var": "hueVar",
        "lightness_feather": "lightnessFeather",
        "lightness_feather_var": "lightnessFeatherVar",
        "lightness_tolerance": "lightnessTolerance",
        "lightness_tolerance_var": "lightnessToleranceVar",
        "saturation_feather": "saturationFeather",
        "saturation_feather_var": "saturationFeatherVar",
        "saturation_tolerance": "saturationTolerance",
        "saturation_tolerance_var": "saturationToleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanChromaKey:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_feather: typing.Optional[builtins.str] = None,
        hue_feather_var: typing.Optional[builtins.str] = None,
        hue_tolerance: typing.Optional[builtins.str] = None,
        hue_tolerance_var: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness_feather: typing.Optional[builtins.str] = None,
        lightness_feather_var: typing.Optional[builtins.str] = None,
        lightness_tolerance: typing.Optional[builtins.str] = None,
        lightness_tolerance_var: typing.Optional[builtins.str] = None,
        saturation_feather: typing.Optional[builtins.str] = None,
        saturation_feather_var: typing.Optional[builtins.str] = None,
        saturation_tolerance: typing.Optional[builtins.str] = None,
        saturation_tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_feather: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        :param hue_feather_var: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        :param hue_tolerance: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        :param hue_tolerance_var: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        :param hue_var: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness_feather: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        :param lightness_feather_var: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        :param lightness_tolerance: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        :param lightness_tolerance_var: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        :param saturation_feather: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        :param saturation_feather_var: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        :param saturation_tolerance: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        :param saturation_tolerance_var: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f191cd0e7ccd57c4fcda3d752967afdb2196d89294c7bc7cbcefdbafde642cb5)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_feather", value=hue_feather, expected_type=type_hints["hue_feather"])
            check_type(argname="argument hue_feather_var", value=hue_feather_var, expected_type=type_hints["hue_feather_var"])
            check_type(argname="argument hue_tolerance", value=hue_tolerance, expected_type=type_hints["hue_tolerance"])
            check_type(argname="argument hue_tolerance_var", value=hue_tolerance_var, expected_type=type_hints["hue_tolerance_var"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness_feather", value=lightness_feather, expected_type=type_hints["lightness_feather"])
            check_type(argname="argument lightness_feather_var", value=lightness_feather_var, expected_type=type_hints["lightness_feather_var"])
            check_type(argname="argument lightness_tolerance", value=lightness_tolerance, expected_type=type_hints["lightness_tolerance"])
            check_type(argname="argument lightness_tolerance_var", value=lightness_tolerance_var, expected_type=type_hints["lightness_tolerance_var"])
            check_type(argname="argument saturation_feather", value=saturation_feather, expected_type=type_hints["saturation_feather"])
            check_type(argname="argument saturation_feather_var", value=saturation_feather_var, expected_type=type_hints["saturation_feather_var"])
            check_type(argname="argument saturation_tolerance", value=saturation_tolerance, expected_type=type_hints["saturation_tolerance"])
            check_type(argname="argument saturation_tolerance_var", value=saturation_tolerance_var, expected_type=type_hints["saturation_tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_feather is not None:
            self._values["hue_feather"] = hue_feather
        if hue_feather_var is not None:
            self._values["hue_feather_var"] = hue_feather_var
        if hue_tolerance is not None:
            self._values["hue_tolerance"] = hue_tolerance
        if hue_tolerance_var is not None:
            self._values["hue_tolerance_var"] = hue_tolerance_var
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness_feather is not None:
            self._values["lightness_feather"] = lightness_feather
        if lightness_feather_var is not None:
            self._values["lightness_feather_var"] = lightness_feather_var
        if lightness_tolerance is not None:
            self._values["lightness_tolerance"] = lightness_tolerance
        if lightness_tolerance_var is not None:
            self._values["lightness_tolerance_var"] = lightness_tolerance_var
        if saturation_feather is not None:
            self._values["saturation_feather"] = saturation_feather
        if saturation_feather_var is not None:
            self._values["saturation_feather_var"] = saturation_feather_var
        if saturation_tolerance is not None:
            self._values["saturation_tolerance"] = saturation_tolerance
        if saturation_tolerance_var is not None:
            self._values["saturation_tolerance_var"] = saturation_tolerance_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        '''
        result = self._values.get("hue_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        '''
        result = self._values.get("hue_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        '''
        result = self._values.get("hue_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        '''
        result = self._values.get("hue_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        '''
        result = self._values.get("lightness_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        '''
        result = self._values.get("lightness_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        '''
        result = self._values.get("lightness_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        '''
        result = self._values.get("lightness_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        '''
        result = self._values.get("saturation_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        '''
        result = self._values.get("saturation_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        '''
        result = self._values.get("saturation_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        result = self._values.get("saturation_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanChromaKey(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanChromaKeyList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanChromaKeyList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ff1c847d8f3f3e94295003409738592c3380b47605e300511e2379626b55ab1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanChromaKeyOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d02c2137449ed1e286fca1a57016d7de02193ed80b8d9aea8c1458d341c39d6)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanChromaKeyOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8ee96541ba332b6d4a074f91aacb9418ee6b86d147967678bf390e75c5c0d46a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__182c1532318e98034c60398e698e4e5691676251ce0c1d70f9cd55935e258b60)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc2d1a2570c21de703fc5fae52274d2c4b1295625f30d34b54230f3a71987b3e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanChromaKey]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanChromaKey]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__64ca17165e891e0335fb239a6fbcff5ee700f556a50d02e522f996077926370d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanChromaKeyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanChromaKeyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6fb49bc9f5fd9d8258e56a55b68cd4d693b5d125cf928fffde9d4895fdc0284d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueFeather")
    def reset_hue_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeather", []))

    @jsii.member(jsii_name="resetHueFeatherVar")
    def reset_hue_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeatherVar", []))

    @jsii.member(jsii_name="resetHueTolerance")
    def reset_hue_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueTolerance", []))

    @jsii.member(jsii_name="resetHueToleranceVar")
    def reset_hue_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueToleranceVar", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightnessFeather")
    def reset_lightness_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeather", []))

    @jsii.member(jsii_name="resetLightnessFeatherVar")
    def reset_lightness_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeatherVar", []))

    @jsii.member(jsii_name="resetLightnessTolerance")
    def reset_lightness_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessTolerance", []))

    @jsii.member(jsii_name="resetLightnessToleranceVar")
    def reset_lightness_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessToleranceVar", []))

    @jsii.member(jsii_name="resetSaturationFeather")
    def reset_saturation_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeather", []))

    @jsii.member(jsii_name="resetSaturationFeatherVar")
    def reset_saturation_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeatherVar", []))

    @jsii.member(jsii_name="resetSaturationTolerance")
    def reset_saturation_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationTolerance", []))

    @jsii.member(jsii_name="resetSaturationToleranceVar")
    def reset_saturation_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherInput")
    def hue_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVarInput")
    def hue_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceInput")
    def hue_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVarInput")
    def hue_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherInput")
    def lightness_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVarInput")
    def lightness_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceInput")
    def lightness_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVarInput")
    def lightness_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherInput")
    def saturation_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVarInput")
    def saturation_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceInput")
    def saturation_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVarInput")
    def saturation_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9b13e88e5f8256c2cd6467939848d35200792631032e40f072ee844aad335590)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeather")
    def hue_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeather"))

    @hue_feather.setter
    def hue_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f23296d16ab4ac6f0fb4e7cabff523a658b0e5dff1e6de45da5b5be5c8552f0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeather", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVar")
    def hue_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeatherVar"))

    @hue_feather_var.setter
    def hue_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__47144dfcb7620d82251885565360453705721c0d2162f07f0a34b6620a30300a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueTolerance")
    def hue_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueTolerance"))

    @hue_tolerance.setter
    def hue_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f17166b7674a4f6a6295eb6a68ca7d26d9889701b31b24d2c9e531835306f476)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVar")
    def hue_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueToleranceVar"))

    @hue_tolerance_var.setter
    def hue_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b022855ab0758ad6d0616708d532f364595b21537f9fc39e1af792dd63909876)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b00e6552e1702dbc246e6bb8ddeaee04978688f58ed0e00f4674d3b761bdf50c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeather")
    def lightness_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeather"))

    @lightness_feather.setter
    def lightness_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ffdafa9e7c923a75550c67e20a71752fc969ba4784b4af5fa144919781e31acc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeather", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVar")
    def lightness_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeatherVar"))

    @lightness_feather_var.setter
    def lightness_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__265b96478d33a4f9fb9778a7c9f485e8d95ba6043c69c72e3f72cee0cc6d0c8f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessTolerance")
    def lightness_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessTolerance"))

    @lightness_tolerance.setter
    def lightness_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__150982d66f4a92622d02ecb66cc06ceaa5c7803901fa3f7bd46f60f09a19989f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVar")
    def lightness_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessToleranceVar"))

    @lightness_tolerance_var.setter
    def lightness_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__534125a88f4a809024956f3ed6d570cc55be8303f47e2f597cd674b976d53a1c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeather")
    def saturation_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeather"))

    @saturation_feather.setter
    def saturation_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__419d3cf5bce2d0fc7b90d0c2e1a49034b6b16184d6fb0393a63439d47204250e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeather", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVar")
    def saturation_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeatherVar"))

    @saturation_feather_var.setter
    def saturation_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c2c736dda65af18f3e489c199674e26d4cb409b3d546cf0b40842d3fb9da5642)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationTolerance")
    def saturation_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationTolerance"))

    @saturation_tolerance.setter
    def saturation_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fdc9c7eec84f587206ae6477c1dcb816a7b52aded05ea3bcda729b26080d10c2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVar")
    def saturation_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationToleranceVar"))

    @saturation_tolerance_var.setter
    def saturation_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__82e43b509d8e546948035f40e322c77a813da33dee634dc7357307609135006c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanChromaKey]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanChromaKey]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanChromaKey]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fc1d8d5c6b996d0625eb47741069918094b345e4c4e45ef457defafbfb18a9f6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanComposite",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "placement": "placement",
        "placement_var": "placementVar",
        "scale": "scale",
        "scale_dimension": "scaleDimension",
        "scale_dimension_var": "scaleDimensionVar",
        "scale_var": "scaleVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanComposite:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        placement: typing.Optional[builtins.str] = None,
        placement_var: typing.Optional[builtins.str] = None,
        scale: typing.Optional[builtins.str] = None,
        scale_dimension: typing.Optional[builtins.str] = None,
        scale_dimension_var: typing.Optional[builtins.str] = None,
        scale_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param placement: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        :param placement_var: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        :param scale: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param scale_dimension: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        :param scale_dimension_var: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        :param scale_var: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        :param x_position: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a4359f2e7dc21e49cfda5d79382c74ebde23e44b9d928a8f9cda5a57b9d133d)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument placement", value=placement, expected_type=type_hints["placement"])
            check_type(argname="argument placement_var", value=placement_var, expected_type=type_hints["placement_var"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument scale_dimension", value=scale_dimension, expected_type=type_hints["scale_dimension"])
            check_type(argname="argument scale_dimension_var", value=scale_dimension_var, expected_type=type_hints["scale_dimension_var"])
            check_type(argname="argument scale_var", value=scale_var, expected_type=type_hints["scale_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if placement is not None:
            self._values["placement"] = placement
        if placement_var is not None:
            self._values["placement_var"] = placement_var
        if scale is not None:
            self._values["scale"] = scale
        if scale_dimension is not None:
            self._values["scale_dimension"] = scale_dimension
        if scale_dimension_var is not None:
            self._values["scale_dimension_var"] = scale_dimension_var
        if scale_var is not None:
            self._values["scale_var"] = scale_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        '''
        result = self._values.get("placement")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement_var(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        '''
        result = self._values.get("placement_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        '''
        result = self._values.get("scale_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        '''
        result = self._values.get("scale_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        '''
        result = self._values.get("scale_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanComposite(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImage",
    jsii_struct_bases=[],
    name_mapping={
        "box_image": "boxImage",
        "circle_image": "circleImage",
        "text_image": "textImage",
        "url_image": "urlImage",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImage:
    def __init__(
        self,
        *,
        box_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageBoxImage", typing.Dict[builtins.str, typing.Any]]]]] = None,
        circle_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageCircleImage", typing.Dict[builtins.str, typing.Any]]]]] = None,
        text_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageTextImage", typing.Dict[builtins.str, typing.Any]]]]] = None,
        url_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageUrlImage", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param box_image: box_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#box_image DataAkamaiImagingPolicyImage#box_image}
        :param circle_image: circle_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#circle_image DataAkamaiImagingPolicyImage#circle_image}
        :param text_image: text_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text_image DataAkamaiImagingPolicyImage#text_image}
        :param url_image: url_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url_image DataAkamaiImagingPolicyImage#url_image}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f2f2b164e52b57aca61636487bc211810c00a3475cf7033c369e9fff0cb7784a)
            check_type(argname="argument box_image", value=box_image, expected_type=type_hints["box_image"])
            check_type(argname="argument circle_image", value=circle_image, expected_type=type_hints["circle_image"])
            check_type(argname="argument text_image", value=text_image, expected_type=type_hints["text_image"])
            check_type(argname="argument url_image", value=url_image, expected_type=type_hints["url_image"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if box_image is not None:
            self._values["box_image"] = box_image
        if circle_image is not None:
            self._values["circle_image"] = circle_image
        if text_image is not None:
            self._values["text_image"] = text_image
        if url_image is not None:
            self._values["url_image"] = url_image

    @builtins.property
    def box_image(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageBoxImage"]]]:
        '''box_image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#box_image DataAkamaiImagingPolicyImage#box_image}
        '''
        result = self._values.get("box_image")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageBoxImage"]]], result)

    @builtins.property
    def circle_image(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageCircleImage"]]]:
        '''circle_image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#circle_image DataAkamaiImagingPolicyImage#circle_image}
        '''
        result = self._values.get("circle_image")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageCircleImage"]]], result)

    @builtins.property
    def text_image(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageTextImage"]]]:
        '''text_image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text_image DataAkamaiImagingPolicyImage#text_image}
        '''
        result = self._values.get("text_image")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageTextImage"]]], result)

    @builtins.property
    def url_image(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageUrlImage"]]]:
        '''url_image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url_image DataAkamaiImagingPolicyImage#url_image}
        '''
        result = self._values.get("url_image")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageUrlImage"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageBoxImage",
    jsii_struct_bases=[],
    name_mapping={
        "color": "color",
        "color_var": "colorVar",
        "height": "height",
        "height_var": "heightVar",
        "transformation": "transformation",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageBoxImage:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        transformation: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageBoxImageTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The fill color of the box, not the edge of the box. The API supports hexadecimal representation and CSS hexadecimal color values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The fill color of the box, not the edge of the box. The API supports hexadecimal representation and CSS hexadecimal color values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        :param height: The height of the box in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height of the box in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param transformation: transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        :param width: The width of the box in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width of the box in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(transformation, dict):
            transformation = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageBoxImageTransformation(**transformation)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__708c7648916704b416593f3917b681d95ef93836a3bc0385801422b8dbaed122)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument transformation", value=transformation, expected_type=type_hints["transformation"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if transformation is not None:
            self._values["transformation"] = transformation
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The fill color of the box, not the edge of the box.

        The API supports hexadecimal representation and CSS hexadecimal color values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The fill color of the box, not the edge of the box.

        The API supports hexadecimal representation and CSS hexadecimal color values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height of the box in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height of the box in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def transformation(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageBoxImageTransformation"]:
        '''transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        '''
        result = self._values.get("transformation")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageBoxImageTransformation"], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width of the box in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width of the box in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageBoxImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageBoxImageList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageBoxImageList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be450d5a39d73cab765040d75835fcfc3999219e050675ab87dacb0dd6b528ad)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageBoxImageOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5154baa87fc3074fa45efa27b0015cf2bafda8b8951dd58b28118f776512cb21)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageBoxImageOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__51204877ad733890dcae74bd3476e6b1f12acb8ec2f45c7168a2171f161d00e9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b3d9584f944f50a0e6b469d05e29339e253840e144ba2117b4e7f446b3cf7fe8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c6061192e57230b05b8ff4ac792bcfcab218ed43eec31577aa9ac0b889a25cb8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageBoxImage]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageBoxImage]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageBoxImage]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5b37877c55ec4d614fcdeb2aece7fbf77913c8ccd9fce43c78ceb1810c449c32)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageBoxImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageBoxImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a866fa719ebdbefbc0d241e63d83ae47236edfa6fc7d15a12a033fe87289b821)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformation")
    def put_transformation(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageBoxImageTransformation()

        return typing.cast(None, jsii.invoke(self, "putTransformation", [value]))

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetTransformation")
    def reset_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformation", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="transformation")
    def transformation(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageBoxImageTransformationOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageBoxImageTransformationOutputReference", jsii.get(self, "transformation"))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="transformationInput")
    def transformation_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageBoxImageTransformation"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageBoxImageTransformation"], jsii.get(self, "transformationInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3d9a78191bfad61e2a1f7f2f96e5cfe5d23df008636cf4bd5e177ca425434d5e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fc5324e02124ea678d05db33a4569b2319792b2ca08ad71592ff56a7fa460e76)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8800f4d2e31cb30fc5f05bb97e05b63f7bd534b79674cf69594b90aaf204d450)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f49007cb06b3efe0b31d8dac9bce05c726df3981d83cf8ae014983becef309c7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__65c1dbca85e4f88d8d18145ecd1b9dd371c354dde4d69ae562e64c4f641cebe9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b8de9f03d7db0e95c1c9ce974515dc0118bb11dfa1ded09e854c8df0e7afb91a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageBoxImage]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageBoxImage]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageBoxImage]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e83506883aac164a134cdcc30ed54446040b07c945171bd713929da9d80f7051)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageBoxImageTransformation",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageBoxImageTransformation:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageBoxImageTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageBoxImageTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageBoxImageTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a7e4ce528dd667cab4117bd8fc45c08effbfb0f42f9be8147337fbbe3ba83ea5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageBoxImageTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageBoxImageTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageBoxImageTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__114f424ec902ba066ad4c29a7c40327235db12c63b93e6eda2d09cb70899209c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageCircleImage",
    jsii_struct_bases=[],
    name_mapping={
        "color": "color",
        "color_var": "colorVar",
        "diameter": "diameter",
        "diameter_var": "diameterVar",
        "transformation": "transformation",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageCircleImage:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
        diameter: typing.Optional[builtins.str] = None,
        diameter_var: typing.Optional[builtins.str] = None,
        transformation: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageCircleImageTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The fill color of the circle. The API supports hexadecimal representation and CSS hexadecimal color values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The fill color of the circle. The API supports hexadecimal representation and CSS hexadecimal color values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        :param diameter: The diameter of the circle. The diameter will be the width and the height of the image in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#diameter DataAkamaiImagingPolicyImage#diameter}
        :param diameter_var: The diameter of the circle. The diameter will be the width and the height of the image in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#diameter_var DataAkamaiImagingPolicyImage#diameter_var}
        :param transformation: transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        :param width: The width of the box in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width of the box in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(transformation, dict):
            transformation = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageCircleImageTransformation(**transformation)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fb28228b423c92c7cdd927031a3f5149574cc7772d4da733d32f70548734f742)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
            check_type(argname="argument diameter", value=diameter, expected_type=type_hints["diameter"])
            check_type(argname="argument diameter_var", value=diameter_var, expected_type=type_hints["diameter_var"])
            check_type(argname="argument transformation", value=transformation, expected_type=type_hints["transformation"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var
        if diameter is not None:
            self._values["diameter"] = diameter
        if diameter_var is not None:
            self._values["diameter_var"] = diameter_var
        if transformation is not None:
            self._values["transformation"] = transformation
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The fill color of the circle. The API supports hexadecimal representation and CSS hexadecimal color values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The fill color of the circle. The API supports hexadecimal representation and CSS hexadecimal color values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def diameter(self) -> typing.Optional[builtins.str]:
        '''The diameter of the circle. The diameter will be the width and the height of the image in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#diameter DataAkamaiImagingPolicyImage#diameter}
        '''
        result = self._values.get("diameter")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def diameter_var(self) -> typing.Optional[builtins.str]:
        '''The diameter of the circle. The diameter will be the width and the height of the image in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#diameter_var DataAkamaiImagingPolicyImage#diameter_var}
        '''
        result = self._values.get("diameter_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def transformation(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageCircleImageTransformation"]:
        '''transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        '''
        result = self._values.get("transformation")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageCircleImageTransformation"], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width of the box in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width of the box in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageCircleImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageCircleImageList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageCircleImageList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__49cb7a9b6195ec03ff62911f0dca82cb7c6930089775961cdb7909f22a086880)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageCircleImageOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d8a48b879378e814eec7c95ad996792fb60f9c5fd9f0a091ecfec6732367e348)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageCircleImageOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a282959bd57a5a35d2bf48b9a8dc7be4398a0917f1feade13269ebfaa8b39f6f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2722af0c46079d65f54ddcac512eb9aebe8a0428a40dd6ee2e71f8a7332cd5cb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eb4e015b316581124e910cfc45473113ae869f72a6c7383e2bcf3e91ab943aa8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageCircleImage]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageCircleImage]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageCircleImage]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1339ca2c61cb2322ba6953e9cb907d133c0eb1a0d75178deccd005b249ddfff2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageCircleImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageCircleImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a2b963fedb47b0c7ad99e3175c8a538d483138871dedd87f9e5d2d39d55f500c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformation")
    def put_transformation(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageCircleImageTransformation()

        return typing.cast(None, jsii.invoke(self, "putTransformation", [value]))

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @jsii.member(jsii_name="resetDiameter")
    def reset_diameter(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDiameter", []))

    @jsii.member(jsii_name="resetDiameterVar")
    def reset_diameter_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDiameterVar", []))

    @jsii.member(jsii_name="resetTransformation")
    def reset_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformation", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="transformation")
    def transformation(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageCircleImageTransformationOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageCircleImageTransformationOutputReference", jsii.get(self, "transformation"))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="diameterInput")
    def diameter_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "diameterInput"))

    @builtins.property
    @jsii.member(jsii_name="diameterVarInput")
    def diameter_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "diameterVarInput"))

    @builtins.property
    @jsii.member(jsii_name="transformationInput")
    def transformation_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageCircleImageTransformation"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageCircleImageTransformation"], jsii.get(self, "transformationInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3e0acd794c6837f45ee039b854ae5ebc0d4904b99d08a6c15e927941453810cc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__19b61be95e2de9f61cb2a4472ba776ce51ff0c724ba378aae76b7eb793865277)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="diameter")
    def diameter(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "diameter"))

    @diameter.setter
    def diameter(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e8973e0418bb0ad3dddda4128555d52dbafe6c8126466d1ca5e4f522e267d871)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "diameter", value)

    @builtins.property
    @jsii.member(jsii_name="diameterVar")
    def diameter_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "diameterVar"))

    @diameter_var.setter
    def diameter_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__17ffeb33da56c4bc140c2ce6c6ae914a01549417ad3ff75508846c29fac0fcfc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "diameterVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5b8e6611476b50e1b8f147540b491e97571124444313717477d25c527be7e226)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4b9bb1f2085716c4cbe337f5646d0c9c99c1a3d159c6f6bc18726f3ef443c42d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageCircleImage]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageCircleImage]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageCircleImage]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fab858f5db9a6863aa87ba9115459f26908a55ae9342adf9e84822675a4aa775)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageCircleImageTransformation",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageCircleImageTransformation:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageCircleImageTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageCircleImageTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageCircleImageTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ae042bd0257649debd211f75ebd30bbe3be95a4233e0768db9c3c78e74f8bfcd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageCircleImageTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageCircleImageTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageCircleImageTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__db9b54e6a050b41cbda8224a63b156484bab397e98ee7b8b08d8c56c4f49aea2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ffeb25db26f0a88d75e9c22499e44b031c664a6407ca720c33c37b325b9df09b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putBoxImage")
    def put_box_image(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageBoxImage, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c69fb3ca594ba41a2f37a59122b363b511411dc005f69e9df02e371afa820ac8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBoxImage", [value]))

    @jsii.member(jsii_name="putCircleImage")
    def put_circle_image(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageCircleImage, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fd38f7551778fd5abe578c8fd37f5ab43ca0773796ae2f33cb0edab1b151b389)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCircleImage", [value]))

    @jsii.member(jsii_name="putTextImage")
    def put_text_image(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageTextImage", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bfda79255f347f6b00f3cb46e29eedacba2016770a405081ef59cc64a2047af2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTextImage", [value]))

    @jsii.member(jsii_name="putUrlImage")
    def put_url_image(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageUrlImage", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__85f60ea93890eb5fa0e769e866fa5db348f9b4a8154ad25ff225de804e5f4d40)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putUrlImage", [value]))

    @jsii.member(jsii_name="resetBoxImage")
    def reset_box_image(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBoxImage", []))

    @jsii.member(jsii_name="resetCircleImage")
    def reset_circle_image(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCircleImage", []))

    @jsii.member(jsii_name="resetTextImage")
    def reset_text_image(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTextImage", []))

    @jsii.member(jsii_name="resetUrlImage")
    def reset_url_image(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUrlImage", []))

    @builtins.property
    @jsii.member(jsii_name="boxImage")
    def box_image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageBoxImageList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageBoxImageList, jsii.get(self, "boxImage"))

    @builtins.property
    @jsii.member(jsii_name="circleImage")
    def circle_image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageCircleImageList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageCircleImageList, jsii.get(self, "circleImage"))

    @builtins.property
    @jsii.member(jsii_name="textImage")
    def text_image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageTextImageList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageTextImageList", jsii.get(self, "textImage"))

    @builtins.property
    @jsii.member(jsii_name="urlImage")
    def url_image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageUrlImageList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageUrlImageList", jsii.get(self, "urlImage"))

    @builtins.property
    @jsii.member(jsii_name="boxImageInput")
    def box_image_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageBoxImage]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageBoxImage]]], jsii.get(self, "boxImageInput"))

    @builtins.property
    @jsii.member(jsii_name="circleImageInput")
    def circle_image_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageCircleImage]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageCircleImage]]], jsii.get(self, "circleImageInput"))

    @builtins.property
    @jsii.member(jsii_name="textImageInput")
    def text_image_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageTextImage"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageTextImage"]]], jsii.get(self, "textImageInput"))

    @builtins.property
    @jsii.member(jsii_name="urlImageInput")
    def url_image_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageUrlImage"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageUrlImage"]]], jsii.get(self, "urlImageInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f487485cae3d06fa12b310a6dc7344f7275b6f2251489bbd5a87b2ab5011152e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageTextImage",
    jsii_struct_bases=[],
    name_mapping={
        "fill": "fill",
        "fill_var": "fillVar",
        "size": "size",
        "size_var": "sizeVar",
        "stroke": "stroke",
        "stroke_size": "strokeSize",
        "stroke_size_var": "strokeSizeVar",
        "stroke_var": "strokeVar",
        "text": "text",
        "text_var": "textVar",
        "transformation": "transformation",
        "typeface": "typeface",
        "typeface_var": "typefaceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageTextImage:
    def __init__(
        self,
        *,
        fill: typing.Optional[builtins.str] = None,
        fill_var: typing.Optional[builtins.str] = None,
        size: typing.Optional[builtins.str] = None,
        size_var: typing.Optional[builtins.str] = None,
        stroke: typing.Optional[builtins.str] = None,
        stroke_size: typing.Optional[builtins.str] = None,
        stroke_size_var: typing.Optional[builtins.str] = None,
        stroke_var: typing.Optional[builtins.str] = None,
        text: typing.Optional[builtins.str] = None,
        text_var: typing.Optional[builtins.str] = None,
        transformation: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageTextImageTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        typeface: typing.Optional[builtins.str] = None,
        typeface_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fill: The main fill color of the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill DataAkamaiImagingPolicyImage#fill}
        :param fill_var: The main fill color of the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_var DataAkamaiImagingPolicyImage#fill_var}
        :param size: The size in pixels to render the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#size DataAkamaiImagingPolicyImage#size}
        :param size_var: The size in pixels to render the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#size_var DataAkamaiImagingPolicyImage#size_var}
        :param stroke: The color for the outline of the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke DataAkamaiImagingPolicyImage#stroke}
        :param stroke_size: The thickness in points for the outline of the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_size DataAkamaiImagingPolicyImage#stroke_size}
        :param stroke_size_var: The thickness in points for the outline of the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_size_var DataAkamaiImagingPolicyImage#stroke_size_var}
        :param stroke_var: The color for the outline of the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_var DataAkamaiImagingPolicyImage#stroke_var}
        :param text: The line of text to render. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text DataAkamaiImagingPolicyImage#text}
        :param text_var: The line of text to render. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text_var DataAkamaiImagingPolicyImage#text_var}
        :param transformation: transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        :param typeface: The font family to apply to the text image. This may be a URL to a TrueType or WOFF (v1) typeface, or a string that refers to one of the standard built-in browser fonts. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#typeface DataAkamaiImagingPolicyImage#typeface}
        :param typeface_var: The font family to apply to the text image. This may be a URL to a TrueType or WOFF (v1) typeface, or a string that refers to one of the standard built-in browser fonts. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#typeface_var DataAkamaiImagingPolicyImage#typeface_var}
        '''
        if isinstance(transformation, dict):
            transformation = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageTextImageTransformation(**transformation)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__70adbe1e0b02bb1a5740a501618d384a4230f0d9013ef9f6c97642797acdac19)
            check_type(argname="argument fill", value=fill, expected_type=type_hints["fill"])
            check_type(argname="argument fill_var", value=fill_var, expected_type=type_hints["fill_var"])
            check_type(argname="argument size", value=size, expected_type=type_hints["size"])
            check_type(argname="argument size_var", value=size_var, expected_type=type_hints["size_var"])
            check_type(argname="argument stroke", value=stroke, expected_type=type_hints["stroke"])
            check_type(argname="argument stroke_size", value=stroke_size, expected_type=type_hints["stroke_size"])
            check_type(argname="argument stroke_size_var", value=stroke_size_var, expected_type=type_hints["stroke_size_var"])
            check_type(argname="argument stroke_var", value=stroke_var, expected_type=type_hints["stroke_var"])
            check_type(argname="argument text", value=text, expected_type=type_hints["text"])
            check_type(argname="argument text_var", value=text_var, expected_type=type_hints["text_var"])
            check_type(argname="argument transformation", value=transformation, expected_type=type_hints["transformation"])
            check_type(argname="argument typeface", value=typeface, expected_type=type_hints["typeface"])
            check_type(argname="argument typeface_var", value=typeface_var, expected_type=type_hints["typeface_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fill is not None:
            self._values["fill"] = fill
        if fill_var is not None:
            self._values["fill_var"] = fill_var
        if size is not None:
            self._values["size"] = size
        if size_var is not None:
            self._values["size_var"] = size_var
        if stroke is not None:
            self._values["stroke"] = stroke
        if stroke_size is not None:
            self._values["stroke_size"] = stroke_size
        if stroke_size_var is not None:
            self._values["stroke_size_var"] = stroke_size_var
        if stroke_var is not None:
            self._values["stroke_var"] = stroke_var
        if text is not None:
            self._values["text"] = text
        if text_var is not None:
            self._values["text_var"] = text_var
        if transformation is not None:
            self._values["transformation"] = transformation
        if typeface is not None:
            self._values["typeface"] = typeface
        if typeface_var is not None:
            self._values["typeface_var"] = typeface_var

    @builtins.property
    def fill(self) -> typing.Optional[builtins.str]:
        '''The main fill color of the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill DataAkamaiImagingPolicyImage#fill}
        '''
        result = self._values.get("fill")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fill_var(self) -> typing.Optional[builtins.str]:
        '''The main fill color of the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_var DataAkamaiImagingPolicyImage#fill_var}
        '''
        result = self._values.get("fill_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def size(self) -> typing.Optional[builtins.str]:
        '''The size in pixels to render the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#size DataAkamaiImagingPolicyImage#size}
        '''
        result = self._values.get("size")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def size_var(self) -> typing.Optional[builtins.str]:
        '''The size in pixels to render the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#size_var DataAkamaiImagingPolicyImage#size_var}
        '''
        result = self._values.get("size_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def stroke(self) -> typing.Optional[builtins.str]:
        '''The color for the outline of the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke DataAkamaiImagingPolicyImage#stroke}
        '''
        result = self._values.get("stroke")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def stroke_size(self) -> typing.Optional[builtins.str]:
        '''The thickness in points for the outline of the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_size DataAkamaiImagingPolicyImage#stroke_size}
        '''
        result = self._values.get("stroke_size")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def stroke_size_var(self) -> typing.Optional[builtins.str]:
        '''The thickness in points for the outline of the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_size_var DataAkamaiImagingPolicyImage#stroke_size_var}
        '''
        result = self._values.get("stroke_size_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def stroke_var(self) -> typing.Optional[builtins.str]:
        '''The color for the outline of the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_var DataAkamaiImagingPolicyImage#stroke_var}
        '''
        result = self._values.get("stroke_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def text(self) -> typing.Optional[builtins.str]:
        '''The line of text to render.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text DataAkamaiImagingPolicyImage#text}
        '''
        result = self._values.get("text")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def text_var(self) -> typing.Optional[builtins.str]:
        '''The line of text to render.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text_var DataAkamaiImagingPolicyImage#text_var}
        '''
        result = self._values.get("text_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def transformation(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageTextImageTransformation"]:
        '''transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        '''
        result = self._values.get("transformation")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageTextImageTransformation"], result)

    @builtins.property
    def typeface(self) -> typing.Optional[builtins.str]:
        '''The font family to apply to the text image.

        This may be a URL to a TrueType or WOFF (v1) typeface, or a string that refers to one of the standard built-in browser fonts.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#typeface DataAkamaiImagingPolicyImage#typeface}
        '''
        result = self._values.get("typeface")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def typeface_var(self) -> typing.Optional[builtins.str]:
        '''The font family to apply to the text image.

        This may be a URL to a TrueType or WOFF (v1) typeface, or a string that refers to one of the standard built-in browser fonts.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#typeface_var DataAkamaiImagingPolicyImage#typeface_var}
        '''
        result = self._values.get("typeface_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageTextImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageTextImageList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageTextImageList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d7dffd5678af4a135c1fc5c0a175c9ca9eaabfd73f067ec1b672b9d33efc7fd1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageTextImageOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1fdf66ee992b474a5b18230a18aa8cb222ea92075ee655045cc9bbb604214d38)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageTextImageOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9abb1d685f0f8bd6077d89ad5d7bfaf30de4a1b6e38e6783540963d590969adc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4b89197a2c01554a008c7e45557d87285496b68c16cb5a810f1ce7415b28d324)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__28b43ca20c9dd6526e6acaff5a135d0c9ea3370511b0a59fc46a995dfc9df01d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageTextImage]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageTextImage]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageTextImage]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0a88c9835f7ee5632b6b0352ea817b3db21b5e6c08d79df24e4665c70043e405)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageTextImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageTextImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e0f33bdc93ebdea7a22d103c1e6dc4dfaa6bb870762fec198ee53808edc33361)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformation")
    def put_transformation(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageTextImageTransformation()

        return typing.cast(None, jsii.invoke(self, "putTransformation", [value]))

    @jsii.member(jsii_name="resetFill")
    def reset_fill(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFill", []))

    @jsii.member(jsii_name="resetFillVar")
    def reset_fill_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFillVar", []))

    @jsii.member(jsii_name="resetSize")
    def reset_size(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSize", []))

    @jsii.member(jsii_name="resetSizeVar")
    def reset_size_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSizeVar", []))

    @jsii.member(jsii_name="resetStroke")
    def reset_stroke(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStroke", []))

    @jsii.member(jsii_name="resetStrokeSize")
    def reset_stroke_size(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStrokeSize", []))

    @jsii.member(jsii_name="resetStrokeSizeVar")
    def reset_stroke_size_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStrokeSizeVar", []))

    @jsii.member(jsii_name="resetStrokeVar")
    def reset_stroke_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStrokeVar", []))

    @jsii.member(jsii_name="resetText")
    def reset_text(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetText", []))

    @jsii.member(jsii_name="resetTextVar")
    def reset_text_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTextVar", []))

    @jsii.member(jsii_name="resetTransformation")
    def reset_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformation", []))

    @jsii.member(jsii_name="resetTypeface")
    def reset_typeface(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeface", []))

    @jsii.member(jsii_name="resetTypefaceVar")
    def reset_typeface_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypefaceVar", []))

    @builtins.property
    @jsii.member(jsii_name="transformation")
    def transformation(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageTextImageTransformationOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageTextImageTransformationOutputReference", jsii.get(self, "transformation"))

    @builtins.property
    @jsii.member(jsii_name="fillInput")
    def fill_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fillInput"))

    @builtins.property
    @jsii.member(jsii_name="fillVarInput")
    def fill_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fillVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sizeInput")
    def size_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sizeInput"))

    @builtins.property
    @jsii.member(jsii_name="sizeVarInput")
    def size_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sizeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="strokeInput")
    def stroke_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "strokeInput"))

    @builtins.property
    @jsii.member(jsii_name="strokeSizeInput")
    def stroke_size_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "strokeSizeInput"))

    @builtins.property
    @jsii.member(jsii_name="strokeSizeVarInput")
    def stroke_size_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "strokeSizeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="strokeVarInput")
    def stroke_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "strokeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="textInput")
    def text_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "textInput"))

    @builtins.property
    @jsii.member(jsii_name="textVarInput")
    def text_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "textVarInput"))

    @builtins.property
    @jsii.member(jsii_name="transformationInput")
    def transformation_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageTextImageTransformation"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageTextImageTransformation"], jsii.get(self, "transformationInput"))

    @builtins.property
    @jsii.member(jsii_name="typefaceInput")
    def typeface_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typefaceInput"))

    @builtins.property
    @jsii.member(jsii_name="typefaceVarInput")
    def typeface_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typefaceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="fill")
    def fill(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fill"))

    @fill.setter
    def fill(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__883ad2ee0f21cde8a8bf8d69f4a4e900a718025b16adce942273485a4aefb933)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fill", value)

    @builtins.property
    @jsii.member(jsii_name="fillVar")
    def fill_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fillVar"))

    @fill_var.setter
    def fill_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a8227341c028f16b51814ac23ba3a7ec25a67d1168a9b3c5257e46d3d7fa7464)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fillVar", value)

    @builtins.property
    @jsii.member(jsii_name="size")
    def size(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "size"))

    @size.setter
    def size(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ebae613e4ed9c8d6b47a508470e2655f2d6ebdcbc36dfb96f5b71aab0f208360)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "size", value)

    @builtins.property
    @jsii.member(jsii_name="sizeVar")
    def size_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sizeVar"))

    @size_var.setter
    def size_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b56d1fe8b6d42685352bab09aad1961e4e40d0a5a9522e9ddf54fc1f0778941e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sizeVar", value)

    @builtins.property
    @jsii.member(jsii_name="stroke")
    def stroke(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "stroke"))

    @stroke.setter
    def stroke(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7ef7329f38e51602d3a93e81ae49bf34a6908faf0a238bc3efb690759a3f346f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "stroke", value)

    @builtins.property
    @jsii.member(jsii_name="strokeSize")
    def stroke_size(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "strokeSize"))

    @stroke_size.setter
    def stroke_size(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bdc063f9b00899ed133c278ed87115e130a2781900aca4c1599144f7e474f191)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "strokeSize", value)

    @builtins.property
    @jsii.member(jsii_name="strokeSizeVar")
    def stroke_size_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "strokeSizeVar"))

    @stroke_size_var.setter
    def stroke_size_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0d0848051a411c36f3ae9cb3a388879efcec4eb6347d82cbb8fc1f90522b7ff1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "strokeSizeVar", value)

    @builtins.property
    @jsii.member(jsii_name="strokeVar")
    def stroke_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "strokeVar"))

    @stroke_var.setter
    def stroke_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__783086068957b377dfca1f18e1841f789ae8b935f916e2d8236dc9d3f05c78e7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "strokeVar", value)

    @builtins.property
    @jsii.member(jsii_name="text")
    def text(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "text"))

    @text.setter
    def text(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a146be55ddd36f40845e05176b230e81a7b3a68305006a4dfd9d635e49e5cad5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "text", value)

    @builtins.property
    @jsii.member(jsii_name="textVar")
    def text_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "textVar"))

    @text_var.setter
    def text_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__61aca6f32d36f7c29a11910f9bec3e35023a18a76ec29aa5c88434a2eb57baa7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "textVar", value)

    @builtins.property
    @jsii.member(jsii_name="typeface")
    def typeface(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeface"))

    @typeface.setter
    def typeface(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d57ae897f09ac17fc067e23f2a67d8b4ecbfa6a137290cff0d5834fdd3b99ca2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeface", value)

    @builtins.property
    @jsii.member(jsii_name="typefaceVar")
    def typeface_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typefaceVar"))

    @typeface_var.setter
    def typeface_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e0f73f8ebc155974d7bd080cb3dd13f5c588514883a1852dffd87690fde0d1db)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typefaceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageTextImage]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageTextImage]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageTextImage]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fbd28006b550b6bce371fce9d0f0ea6d985c21137ce967c065000fc377c26112)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageTextImageTransformation",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageTextImageTransformation:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageTextImageTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageTextImageTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageTextImageTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__28abbe9f246a1c7dd1ee2f68eb168bec416e26dc0bd9abbbbc4b8a298a9fddac)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageTextImageTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageTextImageTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageTextImageTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ee5f455ec70090a21cfc8520b5829889c5101dd52616395125e3e904b931e26e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageUrlImage",
    jsii_struct_bases=[],
    name_mapping={
        "transformation": "transformation",
        "url": "url",
        "url_var": "urlVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageUrlImage:
    def __init__(
        self,
        *,
        transformation: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageUrlImageTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        url: typing.Optional[builtins.str] = None,
        url_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param transformation: transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        :param url: The URL of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url DataAkamaiImagingPolicyImage#url}
        :param url_var: The URL of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url_var DataAkamaiImagingPolicyImage#url_var}
        '''
        if isinstance(transformation, dict):
            transformation = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageUrlImageTransformation(**transformation)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ae49f95aacd3a88f175664441d85955f778422c2c470c1326079906e9f55383f)
            check_type(argname="argument transformation", value=transformation, expected_type=type_hints["transformation"])
            check_type(argname="argument url", value=url, expected_type=type_hints["url"])
            check_type(argname="argument url_var", value=url_var, expected_type=type_hints["url_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if transformation is not None:
            self._values["transformation"] = transformation
        if url is not None:
            self._values["url"] = url
        if url_var is not None:
            self._values["url_var"] = url_var

    @builtins.property
    def transformation(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageUrlImageTransformation"]:
        '''transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        '''
        result = self._values.get("transformation")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageUrlImageTransformation"], result)

    @builtins.property
    def url(self) -> typing.Optional[builtins.str]:
        '''The URL of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url DataAkamaiImagingPolicyImage#url}
        '''
        result = self._values.get("url")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def url_var(self) -> typing.Optional[builtins.str]:
        '''The URL of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url_var DataAkamaiImagingPolicyImage#url_var}
        '''
        result = self._values.get("url_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageUrlImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageUrlImageList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageUrlImageList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a29f8b696b96b7442de51a13b3bc0ab71d8f2d9c5c77210c5913375843da0c3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageUrlImageOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__328a947c23a6abec72c74a3a63da80aaf008bb79f60da999a0d7494209d1cbe0)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageUrlImageOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a699e9b3633cd4c0960d817e8e49e89c235dda1ca2d321c62af2e5ff1182c266)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ff59cee7fb95228eded72a9018fc0eaa896db4b68587bbd78c4026c37af7e340)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5a3b07238f056316a375388a1e2ba3186404951e437818cab116ba72c7533de8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageUrlImage]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageUrlImage]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageUrlImage]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb5c28b7684ec515f50456eefe376bd61d9ab44a4c77aafa0444b96fbc97540a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageUrlImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageUrlImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3587c674068cdd12e6d57502630af23b8df4617fc7761966a859ff4f87a63556)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformation")
    def put_transformation(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageUrlImageTransformation()

        return typing.cast(None, jsii.invoke(self, "putTransformation", [value]))

    @jsii.member(jsii_name="resetTransformation")
    def reset_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformation", []))

    @jsii.member(jsii_name="resetUrl")
    def reset_url(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUrl", []))

    @jsii.member(jsii_name="resetUrlVar")
    def reset_url_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUrlVar", []))

    @builtins.property
    @jsii.member(jsii_name="transformation")
    def transformation(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageUrlImageTransformationOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageUrlImageTransformationOutputReference", jsii.get(self, "transformation"))

    @builtins.property
    @jsii.member(jsii_name="transformationInput")
    def transformation_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageUrlImageTransformation"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageUrlImageTransformation"], jsii.get(self, "transformationInput"))

    @builtins.property
    @jsii.member(jsii_name="urlInput")
    def url_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "urlInput"))

    @builtins.property
    @jsii.member(jsii_name="urlVarInput")
    def url_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "urlVarInput"))

    @builtins.property
    @jsii.member(jsii_name="url")
    def url(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "url"))

    @url.setter
    def url(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5539c0f67411cb0e7d6deaf1a8bb34befbd4c08c4c16ebd802eb6e3990be25c6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "url", value)

    @builtins.property
    @jsii.member(jsii_name="urlVar")
    def url_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "urlVar"))

    @url_var.setter
    def url_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aeb054f11d39be06b5006967e36fc641de707fd87e8ea2dbd09177c1afe85553)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "urlVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageUrlImage]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageUrlImage]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageUrlImage]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__50257dc7666424b7861fbca54feb1390f7babfad68510262408dea1224320434)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageUrlImageTransformation",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageUrlImageTransformation:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageUrlImageTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageUrlImageTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageUrlImageTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__349b807053faac359cc3ef3254831677f5488398b788b4fe84b607b4a7575300)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageUrlImageTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageUrlImageTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageUrlImageTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__13498266731e5ec3a88ab335cfed559658839b3c11bb9e14db72e653eeb1bffd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dfe23c81d2baf6a4b3971020cb268ba6efb5dd998f9359bd0abe200d145aee04)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4e1de8bb5421a77bbe96884368291e7e026a85e16f0fff3e892d6c2173f41035)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__23c2ef2c2db7b65688a86070f86677584e037ba3780a40c011c1dcbd2bcd415c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2590c5bb491d39d6e8b80f2f03e5f9f589a5e3be421122c73694726ac4f86951)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d9ce01dc2ad3b3aefd2f16492f1c3aa791134aaca7f00369883c7592d167d387)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanComposite]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanComposite]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bd7f24f7cfe6d43ef5275021fe7c767c906ddab2abcf898db3375fc42963fb36)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0986065363b0e397cba7dbe8f47f280e3f74a7a602718994aa6dabcb4c9ea92f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(
        self,
        *,
        box_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageBoxImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
        circle_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageCircleImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
        text_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageTextImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
        url_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageUrlImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param box_image: box_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#box_image DataAkamaiImagingPolicyImage#box_image}
        :param circle_image: circle_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#circle_image DataAkamaiImagingPolicyImage#circle_image}
        :param text_image: text_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text_image DataAkamaiImagingPolicyImage#text_image}
        :param url_image: url_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url_image DataAkamaiImagingPolicyImage#url_image}
        '''
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImage(
            box_image=box_image,
            circle_image=circle_image,
            text_image=text_image,
            url_image=url_image,
        )

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPlacement")
    def reset_placement(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacement", []))

    @jsii.member(jsii_name="resetPlacementVar")
    def reset_placement_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacementVar", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetScaleDimension")
    def reset_scale_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimension", []))

    @jsii.member(jsii_name="resetScaleDimensionVar")
    def reset_scale_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimensionVar", []))

    @jsii.member(jsii_name="resetScaleVar")
    def reset_scale_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="placementInput")
    def placement_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementInput"))

    @builtins.property
    @jsii.member(jsii_name="placementVarInput")
    def placement_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionInput")
    def scale_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVarInput")
    def scale_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleVarInput")
    def scale_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df9d3145d47bb1f1810468323c5db53532ebd56849f47e50f4e22bbcb5b25e54)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b51ce90c5501813d038a4d9e26cd92bbe494a3ebc2e45a1464916b825de7c39a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="placement")
    def placement(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placement"))

    @placement.setter
    def placement(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__953f57d334303c28496ff4a24297d8ba6205df5d965beaead2a751968a4cd2d7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placement", value)

    @builtins.property
    @jsii.member(jsii_name="placementVar")
    def placement_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placementVar"))

    @placement_var.setter
    def placement_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e23ffdc4203a3d600ab2f7066a321817a751763d5b86882bca10d1a668ef4f44)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placementVar", value)

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scale"))

    @scale.setter
    def scale(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c6dbd639b5ca709a0fc077d5d605d320df7d62a44fec4b780b2d8ff4f4bd1c50)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scale", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimension")
    def scale_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimension"))

    @scale_dimension.setter
    def scale_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7271d7277872497bb8d37d45d72a58bb6d66853058323e246baf870ec796e396)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimension", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVar")
    def scale_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimensionVar"))

    @scale_dimension_var.setter
    def scale_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__74b3451a23d7d7b022db0b63c0b981620399820ffa50554b4be1d9b37c1f8258)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="scaleVar")
    def scale_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleVar"))

    @scale_var.setter
    def scale_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4355edbb4693e1d5c573e20e916fe40e00023dfdbdcc743888f3b634a5d2f5b2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__446a5538e060d9decd39d4cf28c0e95204b44ab33d13cefc3784e71af83324c0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2f23e443b7113b292e35e0ae02a9e1632e27dc60e940f42fabdd5a8c338e5ea2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__60958a63dc85cf5ba30a4cd94188ac8ba37f8188072fe2d62bcd0a16f5cd1306)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af72a12882fb95b36352073df4302fde63a5c365c21790431d06087aa711aebd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanComposite]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanComposite]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanComposite]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8f091ef382c5f6de60ef0273ebe771dc7f6e58a5e4704f858a9bbad926b6cf69)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompound",
    jsii_struct_bases=[],
    name_mapping={"transformations": "transformations"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompound:
    def __init__(
        self,
        *,
        transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformations, typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param transformations: transformations block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a667a53ede10fced0e39e61013b8bddfefda118dc08271812c9189f7e62e2f1a)
            check_type(argname="argument transformations", value=transformations, expected_type=type_hints["transformations"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if transformations is not None:
            self._values["transformations"] = transformations

    @builtins.property
    def transformations(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformations]]]:
        '''transformations block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        result = self._values.get("transformations")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformations]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompound(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompoundList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompoundList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5a2c9ac218ad079e7e272b99a1ead15cc8d102497cc33231f2a81f009445f16c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompoundOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__95532ae492f9be44f694737d82c51995619a9f1dd5516b5acb11db61af388237)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompoundOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__57c7d267b8857a5dd0d097d67bdf8f948e334e5d613e400d68f038125787a55a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f6c6a2b29fa9964b3986bcaf03c1fece1ea0c6b4ead30f16d8a95cba0eeaf700)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c75fe3fc79c9013f81e2c4debb4e76eae15170429460e274a3ff49ca87c9fc33)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompound]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompound]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__50b82b9e17e0807e8fc80ecaf7638e31760dca00ca97fe4f3a4c3f3c6d3779db)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompoundOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompoundOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__19605a3ec57f4c883a20b266dfdad7e27be0e7c7ae9c31e5615458ee85fa6993)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformations")
    def put_transformations(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformations, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__052822070febe65f4bc16b7c91b2c85cc5a2695a254f4bc4ff9c0812208813db)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTransformations", [value]))

    @jsii.member(jsii_name="resetTransformations")
    def reset_transformations(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformations", []))

    @builtins.property
    @jsii.member(jsii_name="transformations")
    def transformations(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsList", jsii.get(self, "transformations"))

    @builtins.property
    @jsii.member(jsii_name="transformationsInput")
    def transformations_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformations]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformations]]], jsii.get(self, "transformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompound]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompound]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompound]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bfcb23989c42bd3108a9d25b6604bf2186938d381d7534d3ca259ffa53da8556)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanContrast",
    jsii_struct_bases=[],
    name_mapping={
        "brightness": "brightness",
        "brightness_var": "brightnessVar",
        "contrast": "contrast",
        "contrast_var": "contrastVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanContrast:
    def __init__(
        self,
        *,
        brightness: typing.Optional[builtins.str] = None,
        brightness_var: typing.Optional[builtins.str] = None,
        contrast: typing.Optional[builtins.str] = None,
        contrast_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param brightness: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        :param brightness_var: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        :param contrast: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param contrast_var: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b924168d3b1b5085f3ac207bd438d07cd1739a4ca375f30b2073938c6762a1df)
            check_type(argname="argument brightness", value=brightness, expected_type=type_hints["brightness"])
            check_type(argname="argument brightness_var", value=brightness_var, expected_type=type_hints["brightness_var"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument contrast_var", value=contrast_var, expected_type=type_hints["contrast_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if brightness is not None:
            self._values["brightness"] = brightness
        if brightness_var is not None:
            self._values["brightness_var"] = brightness_var
        if contrast is not None:
            self._values["contrast"] = contrast
        if contrast_var is not None:
            self._values["contrast_var"] = contrast_var

    @builtins.property
    def brightness(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        '''
        result = self._values.get("brightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def brightness_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        '''
        result = self._values.get("brightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        result = self._values.get("contrast_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanContrast(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanContrastList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanContrastList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__338cd012a1ecdd9ffc698095d2130e7694fea3c38e80be72e8f0a3eb0aaeb6bc)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanContrastOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f73daf55d03d6be72e2b261f3d8ad0f5ea902b67543f4f17b0d3984ad4356ceb)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanContrastOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac8e07df2977592f37e9c59246ac8d7745bf3cf0f7dbf3dd3fcdaa1fa3197fc6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2c63429a3fc11a1808c8e24df58c52c1b50c2c9fd933ff90749da25ee89c8793)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__665c0fe86eb40e07e01894f8102c6ec5fd87060450970ca502f3cfea70db955d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanContrast]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanContrast]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ae501965a8136121a673af385d1c83915c9cfc927966ab42daa0008525131575)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanContrastOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanContrastOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2f3b05bafa74c521e836ba2adf6a187926e7abf0aa45a624eaf5aec184ab5508)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetBrightness")
    def reset_brightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightness", []))

    @jsii.member(jsii_name="resetBrightnessVar")
    def reset_brightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightnessVar", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetContrastVar")
    def reset_contrast_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrastVar", []))

    @builtins.property
    @jsii.member(jsii_name="brightnessInput")
    def brightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="brightnessVarInput")
    def brightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastVarInput")
    def contrast_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="brightness")
    def brightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightness"))

    @brightness.setter
    def brightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fe3d3e5fbcde97f01e91e01465bbcfec1c805bad5c1acebf859306bff39b4a90)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightness", value)

    @builtins.property
    @jsii.member(jsii_name="brightnessVar")
    def brightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightnessVar"))

    @brightness_var.setter
    def brightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5b0c634469e6bad38f36e2ef4ebd617c2f945646fb25f6e963478f4e9bedb7d2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrast"))

    @contrast.setter
    def contrast(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d6d851f0708505658fc049c4688c784e375e821546b4f6194962b97c8eea7bf7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrast", value)

    @builtins.property
    @jsii.member(jsii_name="contrastVar")
    def contrast_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrastVar"))

    @contrast_var.setter
    def contrast_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6b30e291e1efb5d14c79b195f45f5468d8ddb86027b498fa84e127b5d0a4ee56)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrastVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanContrast]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanContrast]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanContrast]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__80d7f76a1f6d3c469637e1bad4f9e20c510018191af2b79994a324d52456c51e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCrop",
    jsii_struct_bases=[],
    name_mapping={
        "allow_expansion": "allowExpansion",
        "allow_expansion_var": "allowExpansionVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCrop:
    def __init__(
        self,
        *,
        allow_expansion: typing.Optional[builtins.str] = None,
        allow_expansion_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_expansion: If cropping an area outside of the existing canvas, expands the image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        :param allow_expansion_var: If cropping an area outside of the existing canvas, expands the image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        :param gravity: Frame of reference for X and Y Positions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Frame of reference for X and Y Positions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The number of pixels to crop along the y-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The number of pixels to crop along the y-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The number of pixels to crop along the x-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The number of pixels to crop along the x-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        :param x_position: The x-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ee81197b4ade093b13ac9b1c1c94d03de5a6485d8afd9666340f3dfd78de34cb)
            check_type(argname="argument allow_expansion", value=allow_expansion, expected_type=type_hints["allow_expansion"])
            check_type(argname="argument allow_expansion_var", value=allow_expansion_var, expected_type=type_hints["allow_expansion_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if allow_expansion is not None:
            self._values["allow_expansion"] = allow_expansion
        if allow_expansion_var is not None:
            self._values["allow_expansion_var"] = allow_expansion_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def allow_expansion(self) -> typing.Optional[builtins.str]:
        '''If cropping an area outside of the existing canvas, expands the image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        '''
        result = self._values.get("allow_expansion")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def allow_expansion_var(self) -> typing.Optional[builtins.str]:
        '''If cropping an area outside of the existing canvas, expands the image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        '''
        result = self._values.get("allow_expansion_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Frame of reference for X and Y Positions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Frame of reference for X and Y Positions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the y-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the y-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the x-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the x-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__166f67e4da6558fb65df92822bb2f38ced4e2a4dbc610befabbca6fd11c26cec)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9db6c0d063a512c85a2da5757ccd2274f2f78bd9dc52667622e7920c36e6fa95)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a7f044e8cd153e334ccfa767d1a423057b4da646ecd2285a155051f4c352075a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__68bc73404d40e9a26f2aa37fe1e330912fa745dfe1c6a8607a2e54db060f2594)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b86ab5efd8d68b71e44d190cf41c01b5059e22d8a31043d6cdb48fc5590c7cbf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__70b519fc6cb244b21ec65d91c68c14612e1c683b6fa48d1f13e7083f66e5cecf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e35ad99d2564da5474ca21affdad8ce13fa96913ca7232fb8dc74f13a51163d0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAllowExpansion")
    def reset_allow_expansion(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansion", []))

    @jsii.member(jsii_name="resetAllowExpansionVar")
    def reset_allow_expansion_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansionVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionInput")
    def allow_expansion_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVarInput")
    def allow_expansion_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansion")
    def allow_expansion(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansion"))

    @allow_expansion.setter
    def allow_expansion(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d521cb4eb82a1b7d95d4a4d78f79f971b52bbc44cc88593f5dee201a51a3d509)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansion", value)

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVar")
    def allow_expansion_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansionVar"))

    @allow_expansion_var.setter
    def allow_expansion_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__86db7b307732227c7a2139d7d7ddcfffe4257c5fc1940ad6df661f63d8705190)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansionVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__55f196d06ea99f197239ddc9a0cbbd10688067db0bfc13a4bcf2c8cee9996428)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__605dc8be8d3c0aec187ee40fe7a78dd55ed9c2ebfbf85934d1f1171f4e33f29e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d2831912997876c2f812a917483a82e3fb7ee5cae360a411a5ec662c431379d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac3eb5985cc676cf58e383a6a80369298799f98b857db1deb562c21fa03516dc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__150195a20bdfeb6ccf7fde8c6c0756f4d2356634b9f036bfb79a1fbcde6bf28e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dbfde54b75a7a0fa7e2d0edab100086dfd738c448a25c0d7a2c8a657bb621f5b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__52e3f1f86f873811f5c010b466a54b4c015850e13f9c1cc04212cfb6af08de3e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__07abcfde32d1d5f633e70faa9ed1087b0c8c23f13a97714c78d258530c736052)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8eb45a818bab8725345d72ed091e2ec7344ddf7c8a56df6f8cd7daa5f101acf4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__50474598b988bfb7942aab20ce5861b735534402df8c4da11b86c9c69f3567c0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__377025778f23778a55a51157821480d7231650c7b992cc20b6cf2c1f28227d4e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFaceCrop",
    jsii_struct_bases=[],
    name_mapping={
        "algorithm": "algorithm",
        "algorithm_var": "algorithmVar",
        "confidence": "confidence",
        "confidence_var": "confidenceVar",
        "fail_gravity": "failGravity",
        "fail_gravity_var": "failGravityVar",
        "focus": "focus",
        "focus_var": "focusVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "padding": "padding",
        "padding_var": "paddingVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFaceCrop:
    def __init__(
        self,
        *,
        algorithm: typing.Optional[builtins.str] = None,
        algorithm_var: typing.Optional[builtins.str] = None,
        confidence: typing.Optional[builtins.str] = None,
        confidence_var: typing.Optional[builtins.str] = None,
        fail_gravity: typing.Optional[builtins.str] = None,
        fail_gravity_var: typing.Optional[builtins.str] = None,
        focus: typing.Optional[builtins.str] = None,
        focus_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param algorithm: Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm DataAkamaiImagingPolicyImage#algorithm}
        :param algorithm_var: Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm_var DataAkamaiImagingPolicyImage#algorithm_var}
        :param confidence: With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image. Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence DataAkamaiImagingPolicyImage#confidence}
        :param confidence_var: With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image. Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence_var DataAkamaiImagingPolicyImage#confidence_var}
        :param fail_gravity: Controls placement of the crop if Image and Video Manager does not detect any faces in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        :param fail_gravity_var: Controls placement of the crop if Image and Video Manager does not detect any faces in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        :param focus: Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus DataAkamaiImagingPolicyImage#focus}
        :param focus_var: Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus_var DataAkamaiImagingPolicyImage#focus_var}
        :param gravity: Controls placement of the crop. Directions are relative to the face(s) plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Controls placement of the crop. Directions are relative to the face(s) plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param padding: The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        :param style: Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2966cb2ff8511e5e741a5ec21669f153c94bd6271c55029c667cc03d13f964ea)
            check_type(argname="argument algorithm", value=algorithm, expected_type=type_hints["algorithm"])
            check_type(argname="argument algorithm_var", value=algorithm_var, expected_type=type_hints["algorithm_var"])
            check_type(argname="argument confidence", value=confidence, expected_type=type_hints["confidence"])
            check_type(argname="argument confidence_var", value=confidence_var, expected_type=type_hints["confidence_var"])
            check_type(argname="argument fail_gravity", value=fail_gravity, expected_type=type_hints["fail_gravity"])
            check_type(argname="argument fail_gravity_var", value=fail_gravity_var, expected_type=type_hints["fail_gravity_var"])
            check_type(argname="argument focus", value=focus, expected_type=type_hints["focus"])
            check_type(argname="argument focus_var", value=focus_var, expected_type=type_hints["focus_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if algorithm is not None:
            self._values["algorithm"] = algorithm
        if algorithm_var is not None:
            self._values["algorithm_var"] = algorithm_var
        if confidence is not None:
            self._values["confidence"] = confidence
        if confidence_var is not None:
            self._values["confidence_var"] = confidence_var
        if fail_gravity is not None:
            self._values["fail_gravity"] = fail_gravity
        if fail_gravity_var is not None:
            self._values["fail_gravity_var"] = fail_gravity_var
        if focus is not None:
            self._values["focus"] = focus
        if focus_var is not None:
            self._values["focus_var"] = focus_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def algorithm(self) -> typing.Optional[builtins.str]:
        '''Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm DataAkamaiImagingPolicyImage#algorithm}
        '''
        result = self._values.get("algorithm")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def algorithm_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm_var DataAkamaiImagingPolicyImage#algorithm_var}
        '''
        result = self._values.get("algorithm_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def confidence(self) -> typing.Optional[builtins.str]:
        '''With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image.

        Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence DataAkamaiImagingPolicyImage#confidence}
        '''
        result = self._values.get("confidence")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def confidence_var(self) -> typing.Optional[builtins.str]:
        '''With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image.

        Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence_var DataAkamaiImagingPolicyImage#confidence_var}
        '''
        result = self._values.get("confidence_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any faces in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        '''
        result = self._values.get("fail_gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any faces in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        '''
        result = self._values.get("fail_gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def focus(self) -> typing.Optional[builtins.str]:
        '''Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus DataAkamaiImagingPolicyImage#focus}
        '''
        result = self._values.get("focus")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def focus_var(self) -> typing.Optional[builtins.str]:
        '''Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus_var DataAkamaiImagingPolicyImage#focus_var}
        '''
        result = self._values.get("focus_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the face(s) plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the face(s) plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFaceCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFaceCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFaceCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e8e0b1b344d2483e656220126ef865ab11d4bac082a511aa0729083ea3525718)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFaceCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0011c8a566c7a3e1449afcd94174301ac55b9d5c3be7aa0dcd897efbfd9dd9a6)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFaceCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8c7a2bb20b29f02e51056caaff8065d79361df4b215c8596684519ada936f9b2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__822c68c2481254395e9a4157440ade4aa7182b6b9a158f683a9804fd23ee7333)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__034573c17fd5502461b399f9be2bcba951e069d638b0d59ba0de0c741eba9532)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFaceCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFaceCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFaceCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8c4a60597530c6e68b1c91330cb4ecbb7bc1e85bef0678641e90c0a35be50df9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFaceCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFaceCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3712393ea4f45ba69dd391ef937b9cf047d4b995f07f2d66cc016dfb273fea9d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAlgorithm")
    def reset_algorithm(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAlgorithm", []))

    @jsii.member(jsii_name="resetAlgorithmVar")
    def reset_algorithm_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAlgorithmVar", []))

    @jsii.member(jsii_name="resetConfidence")
    def reset_confidence(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetConfidence", []))

    @jsii.member(jsii_name="resetConfidenceVar")
    def reset_confidence_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetConfidenceVar", []))

    @jsii.member(jsii_name="resetFailGravity")
    def reset_fail_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravity", []))

    @jsii.member(jsii_name="resetFailGravityVar")
    def reset_fail_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravityVar", []))

    @jsii.member(jsii_name="resetFocus")
    def reset_focus(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFocus", []))

    @jsii.member(jsii_name="resetFocusVar")
    def reset_focus_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFocusVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="algorithmInput")
    def algorithm_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "algorithmInput"))

    @builtins.property
    @jsii.member(jsii_name="algorithmVarInput")
    def algorithm_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "algorithmVarInput"))

    @builtins.property
    @jsii.member(jsii_name="confidenceInput")
    def confidence_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "confidenceInput"))

    @builtins.property
    @jsii.member(jsii_name="confidenceVarInput")
    def confidence_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "confidenceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityInput")
    def fail_gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityVarInput")
    def fail_gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="focusInput")
    def focus_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "focusInput"))

    @builtins.property
    @jsii.member(jsii_name="focusVarInput")
    def focus_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "focusVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="algorithm")
    def algorithm(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "algorithm"))

    @algorithm.setter
    def algorithm(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e992f09d79ca9bef2c0e3be872b4969b2228f06e830a4965a3953b139666a5f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "algorithm", value)

    @builtins.property
    @jsii.member(jsii_name="algorithmVar")
    def algorithm_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "algorithmVar"))

    @algorithm_var.setter
    def algorithm_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9fc6ceb99fbb1a483338094bf907c825d54c22274bf7a3b791756c793743bc01)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "algorithmVar", value)

    @builtins.property
    @jsii.member(jsii_name="confidence")
    def confidence(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "confidence"))

    @confidence.setter
    def confidence(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6da3d31898861590b7240a39641800363109b0806f41f2895e08fdeab2f8c0af)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "confidence", value)

    @builtins.property
    @jsii.member(jsii_name="confidenceVar")
    def confidence_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "confidenceVar"))

    @confidence_var.setter
    def confidence_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b81da2ea26735826aaea220ac69f3d6d18be175f0c7627c7bfa879609a025206)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "confidenceVar", value)

    @builtins.property
    @jsii.member(jsii_name="failGravity")
    def fail_gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravity"))

    @fail_gravity.setter
    def fail_gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a487f43fe5b4daa721af5f4209cc1a7728b0c04db61956cbdda21779d55a72aa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravity", value)

    @builtins.property
    @jsii.member(jsii_name="failGravityVar")
    def fail_gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravityVar"))

    @fail_gravity_var.setter
    def fail_gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__acbbed07dca8e34b92ff56233b5fa44931572fe2d3f164cca8def9c347061545)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="focus")
    def focus(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "focus"))

    @focus.setter
    def focus(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aa427498f38412201f7f9426963b773743ef33aa5aa13c89f7a05f78bf8db3da)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "focus", value)

    @builtins.property
    @jsii.member(jsii_name="focusVar")
    def focus_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "focusVar"))

    @focus_var.setter
    def focus_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2f58a993b90192dc7fb78447950fe5244fb82fc3e20956b24d8dc5d225564df4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "focusVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__64893807597d1b42dec2169355f8d9a372d49e8bfe6f5c63cc8ae784e7486658)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__84dcf3eb00e93fde64851eb4eb21e15b01f4bc39d689f73ad48808ebefc97b13)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f277d0f450effaf0cdcc217a967839c60fc409ca40773f58d146cd2f2f21a1c0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__00b373ae86c8d0b307cc393df3e43c542f2686d35ce44af9bf1ef8e927932d86)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0fb817b558dbabc4b066cc0cd0e0281aa30f6e0b125516eafbd248b9f8f5d962)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a57896376b4b53283bdd43ff208e550846b49b91ec7095e223d7d2af54629ed2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4012bf0554c3870289f217784927e9f6352a4fe957a62b71b036253f8adc9d34)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__111106860ccd277752d4df4a714985dc9c95df25836ea205f49cd01315a23375)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cba2f235b20a0120d45e2ec7dde3abd2b49e1f8e5c306d2852f5d45300445f5f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__32f980a8dd5667fb1023c40f7675c63db3830a0b74450eba1585b00883df5da2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFaceCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFaceCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFaceCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d400dd960bd892dd642c37f429ee155836b6713e41e3066eeefae75646c08b3f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFeatureCrop",
    jsii_struct_bases=[],
    name_mapping={
        "fail_gravity": "failGravity",
        "fail_gravity_var": "failGravityVar",
        "feature_radius": "featureRadius",
        "feature_radius_var": "featureRadiusVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "max_features": "maxFeatures",
        "max_features_var": "maxFeaturesVar",
        "min_feature_quality": "minFeatureQuality",
        "min_feature_quality_var": "minFeatureQualityVar",
        "padding": "padding",
        "padding_var": "paddingVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFeatureCrop:
    def __init__(
        self,
        *,
        fail_gravity: typing.Optional[builtins.str] = None,
        fail_gravity_var: typing.Optional[builtins.str] = None,
        feature_radius: typing.Optional[builtins.str] = None,
        feature_radius_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        max_features: typing.Optional[builtins.str] = None,
        max_features_var: typing.Optional[builtins.str] = None,
        min_feature_quality: typing.Optional[builtins.str] = None,
        min_feature_quality_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fail_gravity: Controls placement of the crop if Image and Video Manager does not detect any features in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        :param fail_gravity_var: Controls placement of the crop if Image and Video Manager does not detect any features in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        :param feature_radius: The size in pixels of the important features to search for. If identified, two features never appear closer together than this value, ``8.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius DataAkamaiImagingPolicyImage#feature_radius}
        :param feature_radius_var: The size in pixels of the important features to search for. If identified, two features never appear closer together than this value, ``8.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius_var DataAkamaiImagingPolicyImage#feature_radius_var}
        :param gravity: Controls placement of the crop. Directions are relative to the region of interest plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Controls placement of the crop. Directions are relative to the region of interest plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param max_features: The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features DataAkamaiImagingPolicyImage#max_features}
        :param max_features_var: The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features_var DataAkamaiImagingPolicyImage#max_features_var}
        :param min_feature_quality: Determines the minimum quality level of the feature identified. To consider a feature important, the feature needs to surpass this value. Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality DataAkamaiImagingPolicyImage#min_feature_quality}
        :param min_feature_quality_var: Determines the minimum quality level of the feature identified. To consider a feature important, the feature needs to surpass this value. Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality_var DataAkamaiImagingPolicyImage#min_feature_quality_var}
        :param padding: Adds space around the region of interest. The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: Adds space around the region of interest. The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        :param style: Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b31df24fac4aaefb43e549643bfe414df656c354632a05291989180ba7c79dc7)
            check_type(argname="argument fail_gravity", value=fail_gravity, expected_type=type_hints["fail_gravity"])
            check_type(argname="argument fail_gravity_var", value=fail_gravity_var, expected_type=type_hints["fail_gravity_var"])
            check_type(argname="argument feature_radius", value=feature_radius, expected_type=type_hints["feature_radius"])
            check_type(argname="argument feature_radius_var", value=feature_radius_var, expected_type=type_hints["feature_radius_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument max_features", value=max_features, expected_type=type_hints["max_features"])
            check_type(argname="argument max_features_var", value=max_features_var, expected_type=type_hints["max_features_var"])
            check_type(argname="argument min_feature_quality", value=min_feature_quality, expected_type=type_hints["min_feature_quality"])
            check_type(argname="argument min_feature_quality_var", value=min_feature_quality_var, expected_type=type_hints["min_feature_quality_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fail_gravity is not None:
            self._values["fail_gravity"] = fail_gravity
        if fail_gravity_var is not None:
            self._values["fail_gravity_var"] = fail_gravity_var
        if feature_radius is not None:
            self._values["feature_radius"] = feature_radius
        if feature_radius_var is not None:
            self._values["feature_radius_var"] = feature_radius_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if max_features is not None:
            self._values["max_features"] = max_features
        if max_features_var is not None:
            self._values["max_features_var"] = max_features_var
        if min_feature_quality is not None:
            self._values["min_feature_quality"] = min_feature_quality
        if min_feature_quality_var is not None:
            self._values["min_feature_quality_var"] = min_feature_quality_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def fail_gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any features in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        '''
        result = self._values.get("fail_gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any features in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        '''
        result = self._values.get("fail_gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feature_radius(self) -> typing.Optional[builtins.str]:
        '''The size in pixels of the important features to search for.

        If identified, two features never appear closer together than this value, ``8.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius DataAkamaiImagingPolicyImage#feature_radius}
        '''
        result = self._values.get("feature_radius")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feature_radius_var(self) -> typing.Optional[builtins.str]:
        '''The size in pixels of the important features to search for.

        If identified, two features never appear closer together than this value, ``8.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius_var DataAkamaiImagingPolicyImage#feature_radius_var}
        '''
        result = self._values.get("feature_radius_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the region of interest plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the region of interest plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def max_features(self) -> typing.Optional[builtins.str]:
        '''The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features DataAkamaiImagingPolicyImage#max_features}
        '''
        result = self._values.get("max_features")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def max_features_var(self) -> typing.Optional[builtins.str]:
        '''The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features_var DataAkamaiImagingPolicyImage#max_features_var}
        '''
        result = self._values.get("max_features_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def min_feature_quality(self) -> typing.Optional[builtins.str]:
        '''Determines the minimum quality level of the feature identified.

        To consider a feature important, the feature needs to surpass this value.  Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality DataAkamaiImagingPolicyImage#min_feature_quality}
        '''
        result = self._values.get("min_feature_quality")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def min_feature_quality_var(self) -> typing.Optional[builtins.str]:
        '''Determines the minimum quality level of the feature identified.

        To consider a feature important, the feature needs to surpass this value.  Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality_var DataAkamaiImagingPolicyImage#min_feature_quality_var}
        '''
        result = self._values.get("min_feature_quality_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''Adds space around the region of interest.

        The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''Adds space around the region of interest.

        The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFeatureCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFeatureCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFeatureCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__29216e42c8477f6557161f448ff2fe7c67a9199e5df1a5d1076aa5104edf1cbe)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFeatureCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__17542c96e75c30e8101825a60386acf1236279f5b09801b531b67613043579c0)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFeatureCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d0fa0dc37c82edb9c709ec17cec515f5193406f436e9f2a8f6777a3789728c81)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6aaf9d9d22053ea3bd003cc69a8e205242afea1e53b38bf9d489b09c9107c895)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e165b2df8a62bfd4806f434c7b958e695fa15e427adc3eaecd69a92ba52940df)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFeatureCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFeatureCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFeatureCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ba2ba0538347ae614fbe7ff8ad2877e3f7e35cc6ab03030b5186b4306a6f8920)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFeatureCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFeatureCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d13866cc70e5df7e48661825032c1be5b65a06dba46325f616dfffc8163b30f5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetFailGravity")
    def reset_fail_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravity", []))

    @jsii.member(jsii_name="resetFailGravityVar")
    def reset_fail_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravityVar", []))

    @jsii.member(jsii_name="resetFeatureRadius")
    def reset_feature_radius(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureRadius", []))

    @jsii.member(jsii_name="resetFeatureRadiusVar")
    def reset_feature_radius_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureRadiusVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetMaxFeatures")
    def reset_max_features(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxFeatures", []))

    @jsii.member(jsii_name="resetMaxFeaturesVar")
    def reset_max_features_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxFeaturesVar", []))

    @jsii.member(jsii_name="resetMinFeatureQuality")
    def reset_min_feature_quality(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMinFeatureQuality", []))

    @jsii.member(jsii_name="resetMinFeatureQualityVar")
    def reset_min_feature_quality_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMinFeatureQualityVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="failGravityInput")
    def fail_gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityVarInput")
    def fail_gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featureRadiusInput")
    def feature_radius_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featureRadiusInput"))

    @builtins.property
    @jsii.member(jsii_name="featureRadiusVarInput")
    def feature_radius_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featureRadiusVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesInput")
    def max_features_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "maxFeaturesInput"))

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesVarInput")
    def max_features_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "maxFeaturesVarInput"))

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityInput")
    def min_feature_quality_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "minFeatureQualityInput"))

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityVarInput")
    def min_feature_quality_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "minFeatureQualityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravity")
    def fail_gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravity"))

    @fail_gravity.setter
    def fail_gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a7260265af031b6ef3ffd20fe9a4ca00c73a158d5082d07acffe399c9f82de9d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravity", value)

    @builtins.property
    @jsii.member(jsii_name="failGravityVar")
    def fail_gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravityVar"))

    @fail_gravity_var.setter
    def fail_gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__50d2412c8d984c0c4b9c39d49bc392388c3c9f1c0a3ca75071b55396a5c94f8b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="featureRadius")
    def feature_radius(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featureRadius"))

    @feature_radius.setter
    def feature_radius(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__453fdd6192f0414f8729e8b42e98a3bed0cff751b77d6b06ea84de75c9f1b675)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featureRadius", value)

    @builtins.property
    @jsii.member(jsii_name="featureRadiusVar")
    def feature_radius_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featureRadiusVar"))

    @feature_radius_var.setter
    def feature_radius_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__40542994811c5fb809586c9baf153f9bacf3337a7600eaecf3bd6e2f88b242b2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featureRadiusVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__53e359759dc9901cbfdc15f826a327d045729dca533b13b99c634e510a086a37)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__536af20d1425f1869324ebc830de4fb640953ba2567f64215c96ecded61ab7a0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d3f697017c009f0b4466af030b4386303cf323321596cfdbd3b911edb6bad340)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__434990be3ce8968f9581d1014e1ea80e72515b0398f9b6f9eb4fbff095b02a34)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="maxFeatures")
    def max_features(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "maxFeatures"))

    @max_features.setter
    def max_features(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3c5910089d355990ce4faa11e13611fb4c94e7a35ec19a4bd7cd0e4efc1a5905)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "maxFeatures", value)

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesVar")
    def max_features_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "maxFeaturesVar"))

    @max_features_var.setter
    def max_features_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8458bd2936796bf0fc06172d6173eb24076acee8c88c8b01c08fd5e9ae034b05)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "maxFeaturesVar", value)

    @builtins.property
    @jsii.member(jsii_name="minFeatureQuality")
    def min_feature_quality(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "minFeatureQuality"))

    @min_feature_quality.setter
    def min_feature_quality(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8906eff308e6b33885282c13d9375fccd0dc10cfd3ca8e3cdce1555e81c36c3f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "minFeatureQuality", value)

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityVar")
    def min_feature_quality_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "minFeatureQualityVar"))

    @min_feature_quality_var.setter
    def min_feature_quality_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__54cacca4d1001a80a4be6854be7c2658e92c63c4ef17c7347674071c796219aa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "minFeatureQualityVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ce6bccb203c268d29bc8e202266146aee2f149b303e1c1758923f285329ec681)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c0c422ccca640e0de50316bcf3da5a037eb6b396be53e64e53de44395143feb7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__23f366f3cebb51dd34d8baf90c47cc61ed39c4ccdc8308209594e8f0165f3cc2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__03658aa847587d6afe3507f5c70d6f37e5c9d154d0c6aee184d0b3ee1c4a2292)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ba46c93fd6048e8267cf8d999d1d4a26d2a88490c63ad381f05bca935d8d1516)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6d600c86e32213ca5bde347b488084972f8ba7eedd6e35d98537e939f65d2c4d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFeatureCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFeatureCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFeatureCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a16d401a6ab917d3737bed37be4ff05fb5e10482666071105aa626fa4c533ba8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFill",
    jsii_struct_bases=[],
    name_mapping={
        "fill_transformation": "fillTransformation",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFill:
    def __init__(
        self,
        *,
        fill_transformation: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fill_transformation: fill_transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_transformation DataAkamaiImagingPolicyImage#fill_transformation}
        :param height: The height value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The width value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(fill_transformation, dict):
            fill_transformation = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformation(**fill_transformation)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7972e588a247bd4d7fd6c251132d189f822b05451bd02116648a94aeb97c7389)
            check_type(argname="argument fill_transformation", value=fill_transformation, expected_type=type_hints["fill_transformation"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fill_transformation is not None:
            self._values["fill_transformation"] = fill_transformation
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def fill_transformation(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformation"]:
        '''fill_transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_transformation DataAkamaiImagingPolicyImage#fill_transformation}
        '''
        result = self._values.get("fill_transformation")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformation"], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFill(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformation",
    jsii_struct_bases=[],
    name_mapping={
        "append": "append",
        "aspect_crop": "aspectCrop",
        "background_color": "backgroundColor",
        "blur": "blur",
        "chroma_key": "chromaKey",
        "composite": "composite",
        "compound": "compound",
        "contrast": "contrast",
        "crop": "crop",
        "face_crop": "faceCrop",
        "feature_crop": "featureCrop",
        "fit_and_fill": "fitAndFill",
        "goop": "goop",
        "grayscale": "grayscale",
        "hsl": "hsl",
        "hsv": "hsv",
        "if_dimension": "ifDimension",
        "if_orientation": "ifOrientation",
        "im_query": "imQuery",
        "max_colors": "maxColors",
        "mirror": "mirror",
        "mono_hue": "monoHue",
        "opacity": "opacity",
        "region_of_interest_crop": "regionOfInterestCrop",
        "relative_crop": "relativeCrop",
        "remove_color": "removeColor",
        "resize": "resize",
        "rotate": "rotate",
        "scale": "scale",
        "shear": "shear",
        "trim": "trim",
        "unsharp_mask": "unsharpMask",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformation:
    def __init__(
        self,
        *,
        append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationAppend", typing.Dict[builtins.str, typing.Any]]]]] = None,
        aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationAspectCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationBackgroundColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationBlur", typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationChromaKey", typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationComposite", typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationCompound", typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationContrast", typing.Dict[builtins.str, typing.Any]]]]] = None,
        crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationFaceCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationFeatureCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationFitAndFill", typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationGoop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationGrayscale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationHsl", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationHsv", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfDimension", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfOrientation", typing.Dict[builtins.str, typing.Any]]]]] = None,
        im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationImQuery", typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationMaxColors", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationMirror", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationMonoHue", typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationOpacity", typing.Dict[builtins.str, typing.Any]]]]] = None,
        region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationRegionOfInterestCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationRelativeCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationRemoveColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationResize", typing.Dict[builtins.str, typing.Any]]]]] = None,
        rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationRotate", typing.Dict[builtins.str, typing.Any]]]]] = None,
        scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationScale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationShear", typing.Dict[builtins.str, typing.Any]]]]] = None,
        trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationTrim", typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationUnsharpMask", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param append: append block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        :param aspect_crop: aspect_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param crop: crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        :param face_crop: face_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        :param feature_crop: feature_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        :param fit_and_fill: fit_and_fill block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param im_query: im_query block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param region_of_interest_crop: region_of_interest_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        :param relative_crop: relative_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param resize: resize block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        :param rotate: rotate block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        :param scale: scale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param shear: shear block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        :param trim: trim block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__23a64d6fd9c50b513a516e278e74adbd52b6f64e618623c4850302b2f13f97dd)
            check_type(argname="argument append", value=append, expected_type=type_hints["append"])
            check_type(argname="argument aspect_crop", value=aspect_crop, expected_type=type_hints["aspect_crop"])
            check_type(argname="argument background_color", value=background_color, expected_type=type_hints["background_color"])
            check_type(argname="argument blur", value=blur, expected_type=type_hints["blur"])
            check_type(argname="argument chroma_key", value=chroma_key, expected_type=type_hints["chroma_key"])
            check_type(argname="argument composite", value=composite, expected_type=type_hints["composite"])
            check_type(argname="argument compound", value=compound, expected_type=type_hints["compound"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument crop", value=crop, expected_type=type_hints["crop"])
            check_type(argname="argument face_crop", value=face_crop, expected_type=type_hints["face_crop"])
            check_type(argname="argument feature_crop", value=feature_crop, expected_type=type_hints["feature_crop"])
            check_type(argname="argument fit_and_fill", value=fit_and_fill, expected_type=type_hints["fit_and_fill"])
            check_type(argname="argument goop", value=goop, expected_type=type_hints["goop"])
            check_type(argname="argument grayscale", value=grayscale, expected_type=type_hints["grayscale"])
            check_type(argname="argument hsl", value=hsl, expected_type=type_hints["hsl"])
            check_type(argname="argument hsv", value=hsv, expected_type=type_hints["hsv"])
            check_type(argname="argument if_dimension", value=if_dimension, expected_type=type_hints["if_dimension"])
            check_type(argname="argument if_orientation", value=if_orientation, expected_type=type_hints["if_orientation"])
            check_type(argname="argument im_query", value=im_query, expected_type=type_hints["im_query"])
            check_type(argname="argument max_colors", value=max_colors, expected_type=type_hints["max_colors"])
            check_type(argname="argument mirror", value=mirror, expected_type=type_hints["mirror"])
            check_type(argname="argument mono_hue", value=mono_hue, expected_type=type_hints["mono_hue"])
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument region_of_interest_crop", value=region_of_interest_crop, expected_type=type_hints["region_of_interest_crop"])
            check_type(argname="argument relative_crop", value=relative_crop, expected_type=type_hints["relative_crop"])
            check_type(argname="argument remove_color", value=remove_color, expected_type=type_hints["remove_color"])
            check_type(argname="argument resize", value=resize, expected_type=type_hints["resize"])
            check_type(argname="argument rotate", value=rotate, expected_type=type_hints["rotate"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument shear", value=shear, expected_type=type_hints["shear"])
            check_type(argname="argument trim", value=trim, expected_type=type_hints["trim"])
            check_type(argname="argument unsharp_mask", value=unsharp_mask, expected_type=type_hints["unsharp_mask"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if append is not None:
            self._values["append"] = append
        if aspect_crop is not None:
            self._values["aspect_crop"] = aspect_crop
        if background_color is not None:
            self._values["background_color"] = background_color
        if blur is not None:
            self._values["blur"] = blur
        if chroma_key is not None:
            self._values["chroma_key"] = chroma_key
        if composite is not None:
            self._values["composite"] = composite
        if compound is not None:
            self._values["compound"] = compound
        if contrast is not None:
            self._values["contrast"] = contrast
        if crop is not None:
            self._values["crop"] = crop
        if face_crop is not None:
            self._values["face_crop"] = face_crop
        if feature_crop is not None:
            self._values["feature_crop"] = feature_crop
        if fit_and_fill is not None:
            self._values["fit_and_fill"] = fit_and_fill
        if goop is not None:
            self._values["goop"] = goop
        if grayscale is not None:
            self._values["grayscale"] = grayscale
        if hsl is not None:
            self._values["hsl"] = hsl
        if hsv is not None:
            self._values["hsv"] = hsv
        if if_dimension is not None:
            self._values["if_dimension"] = if_dimension
        if if_orientation is not None:
            self._values["if_orientation"] = if_orientation
        if im_query is not None:
            self._values["im_query"] = im_query
        if max_colors is not None:
            self._values["max_colors"] = max_colors
        if mirror is not None:
            self._values["mirror"] = mirror
        if mono_hue is not None:
            self._values["mono_hue"] = mono_hue
        if opacity is not None:
            self._values["opacity"] = opacity
        if region_of_interest_crop is not None:
            self._values["region_of_interest_crop"] = region_of_interest_crop
        if relative_crop is not None:
            self._values["relative_crop"] = relative_crop
        if remove_color is not None:
            self._values["remove_color"] = remove_color
        if resize is not None:
            self._values["resize"] = resize
        if rotate is not None:
            self._values["rotate"] = rotate
        if scale is not None:
            self._values["scale"] = scale
        if shear is not None:
            self._values["shear"] = shear
        if trim is not None:
            self._values["trim"] = trim
        if unsharp_mask is not None:
            self._values["unsharp_mask"] = unsharp_mask

    @builtins.property
    def append(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationAppend"]]]:
        '''append block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        '''
        result = self._values.get("append")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationAppend"]]], result)

    @builtins.property
    def aspect_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationAspectCrop"]]]:
        '''aspect_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        '''
        result = self._values.get("aspect_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationAspectCrop"]]], result)

    @builtins.property
    def background_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationBackgroundColor"]]]:
        '''background_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        '''
        result = self._values.get("background_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationBackgroundColor"]]], result)

    @builtins.property
    def blur(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationBlur"]]]:
        '''blur block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        '''
        result = self._values.get("blur")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationBlur"]]], result)

    @builtins.property
    def chroma_key(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationChromaKey"]]]:
        '''chroma_key block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        '''
        result = self._values.get("chroma_key")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationChromaKey"]]], result)

    @builtins.property
    def composite(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationComposite"]]]:
        '''composite block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        '''
        result = self._values.get("composite")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationComposite"]]], result)

    @builtins.property
    def compound(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationCompound"]]]:
        '''compound block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        '''
        result = self._values.get("compound")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationCompound"]]], result)

    @builtins.property
    def contrast(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationContrast"]]]:
        '''contrast block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationContrast"]]], result)

    @builtins.property
    def crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationCrop"]]]:
        '''crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        '''
        result = self._values.get("crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationCrop"]]], result)

    @builtins.property
    def face_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationFaceCrop"]]]:
        '''face_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        '''
        result = self._values.get("face_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationFaceCrop"]]], result)

    @builtins.property
    def feature_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationFeatureCrop"]]]:
        '''feature_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        '''
        result = self._values.get("feature_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationFeatureCrop"]]], result)

    @builtins.property
    def fit_and_fill(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationFitAndFill"]]]:
        '''fit_and_fill block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        '''
        result = self._values.get("fit_and_fill")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationFitAndFill"]]], result)

    @builtins.property
    def goop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationGoop"]]]:
        '''goop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        '''
        result = self._values.get("goop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationGoop"]]], result)

    @builtins.property
    def grayscale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationGrayscale"]]]:
        '''grayscale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        '''
        result = self._values.get("grayscale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationGrayscale"]]], result)

    @builtins.property
    def hsl(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationHsl"]]]:
        '''hsl block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        '''
        result = self._values.get("hsl")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationHsl"]]], result)

    @builtins.property
    def hsv(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationHsv"]]]:
        '''hsv block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        '''
        result = self._values.get("hsv")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationHsv"]]], result)

    @builtins.property
    def if_dimension(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfDimension"]]]:
        '''if_dimension block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        '''
        result = self._values.get("if_dimension")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfDimension"]]], result)

    @builtins.property
    def if_orientation(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfOrientation"]]]:
        '''if_orientation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        '''
        result = self._values.get("if_orientation")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfOrientation"]]], result)

    @builtins.property
    def im_query(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationImQuery"]]]:
        '''im_query block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        '''
        result = self._values.get("im_query")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationImQuery"]]], result)

    @builtins.property
    def max_colors(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationMaxColors"]]]:
        '''max_colors block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        '''
        result = self._values.get("max_colors")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationMaxColors"]]], result)

    @builtins.property
    def mirror(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationMirror"]]]:
        '''mirror block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        '''
        result = self._values.get("mirror")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationMirror"]]], result)

    @builtins.property
    def mono_hue(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationMonoHue"]]]:
        '''mono_hue block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        '''
        result = self._values.get("mono_hue")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationMonoHue"]]], result)

    @builtins.property
    def opacity(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationOpacity"]]]:
        '''opacity block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationOpacity"]]], result)

    @builtins.property
    def region_of_interest_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationRegionOfInterestCrop"]]]:
        '''region_of_interest_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        '''
        result = self._values.get("region_of_interest_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationRegionOfInterestCrop"]]], result)

    @builtins.property
    def relative_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationRelativeCrop"]]]:
        '''relative_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        '''
        result = self._values.get("relative_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationRelativeCrop"]]], result)

    @builtins.property
    def remove_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationRemoveColor"]]]:
        '''remove_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        '''
        result = self._values.get("remove_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationRemoveColor"]]], result)

    @builtins.property
    def resize(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationResize"]]]:
        '''resize block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        '''
        result = self._values.get("resize")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationResize"]]], result)

    @builtins.property
    def rotate(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationRotate"]]]:
        '''rotate block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        '''
        result = self._values.get("rotate")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationRotate"]]], result)

    @builtins.property
    def scale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationScale"]]]:
        '''scale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationScale"]]], result)

    @builtins.property
    def shear(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationShear"]]]:
        '''shear block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        '''
        result = self._values.get("shear")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationShear"]]], result)

    @builtins.property
    def trim(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationTrim"]]]:
        '''trim block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        '''
        result = self._values.get("trim")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationTrim"]]], result)

    @builtins.property
    def unsharp_mask(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationUnsharpMask"]]]:
        '''unsharp_mask block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        result = self._values.get("unsharp_mask")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationUnsharpMask"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationAppend",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_priority": "gravityPriority",
        "gravity_priority_var": "gravityPriorityVar",
        "gravity_var": "gravityVar",
        "preserve_minor_dimension": "preserveMinorDimension",
        "preserve_minor_dimension_var": "preserveMinorDimensionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationAppend:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationAppendImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_priority: typing.Optional[builtins.str] = None,
        gravity_priority_var: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        preserve_minor_dimension: typing.Optional[builtins.str] = None,
        preserve_minor_dimension_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Specifies where to place the ``image`` relative to the source image. The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_priority: Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal. The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority DataAkamaiImagingPolicyImage#gravity_priority}
        :param gravity_priority_var: Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal. The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority_var DataAkamaiImagingPolicyImage#gravity_priority_var}
        :param gravity_var: Specifies where to place the ``image`` relative to the source image. The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param preserve_minor_dimension: Whether to preserve the source image's minor dimension, ``false`` by default. The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension DataAkamaiImagingPolicyImage#preserve_minor_dimension}
        :param preserve_minor_dimension_var: Whether to preserve the source image's minor dimension, ``false`` by default. The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension_var DataAkamaiImagingPolicyImage#preserve_minor_dimension_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationAppendImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9777d9d2537e65c2b9858f7445c87d60a1264a5844b69560bd10827270db18a5)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_priority", value=gravity_priority, expected_type=type_hints["gravity_priority"])
            check_type(argname="argument gravity_priority_var", value=gravity_priority_var, expected_type=type_hints["gravity_priority_var"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument preserve_minor_dimension", value=preserve_minor_dimension, expected_type=type_hints["preserve_minor_dimension"])
            check_type(argname="argument preserve_minor_dimension_var", value=preserve_minor_dimension_var, expected_type=type_hints["preserve_minor_dimension_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_priority is not None:
            self._values["gravity_priority"] = gravity_priority
        if gravity_priority_var is not None:
            self._values["gravity_priority_var"] = gravity_priority_var
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if preserve_minor_dimension is not None:
            self._values["preserve_minor_dimension"] = preserve_minor_dimension
        if preserve_minor_dimension_var is not None:
            self._values["preserve_minor_dimension_var"] = preserve_minor_dimension_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationAppendImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationAppendImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Specifies where to place the ``image`` relative to the source image.

        The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_priority(self) -> typing.Optional[builtins.str]:
        '''Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal.

        The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority DataAkamaiImagingPolicyImage#gravity_priority}
        '''
        result = self._values.get("gravity_priority")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_priority_var(self) -> typing.Optional[builtins.str]:
        '''Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal.

        The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority_var DataAkamaiImagingPolicyImage#gravity_priority_var}
        '''
        result = self._values.get("gravity_priority_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Specifies where to place the ``image`` relative to the source image.

        The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def preserve_minor_dimension(self) -> typing.Optional[builtins.str]:
        '''Whether to preserve the source image's minor dimension, ``false`` by default.

        The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension DataAkamaiImagingPolicyImage#preserve_minor_dimension}
        '''
        result = self._values.get("preserve_minor_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def preserve_minor_dimension_var(self) -> typing.Optional[builtins.str]:
        '''Whether to preserve the source image's minor dimension, ``false`` by default.

        The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension_var DataAkamaiImagingPolicyImage#preserve_minor_dimension_var}
        '''
        result = self._values.get("preserve_minor_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationAppend(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationAppendImage",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationAppendImage:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationAppendImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationAppendImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationAppendImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5cef9a0e4f8115978f0f3e94ad59b6f02a4548cc16b7b2d22a5c7f29a12639b8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationAppendImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationAppendImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationAppendImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2fcb1b16eceb713a94f63514a2f8cb20811c845eef1cea89741ec69272ca3ec6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationAppendList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationAppendList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__889bb5b77b64a906bb69fe35307d673ee49b7a407917e0aae0e7ef55fb9a97cd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationAppendOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__24b8275da14c5182ccaec37091f1baaec5b159c9f0926759a2aa2f69f0289978)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationAppendOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3bd930a0fd6adacd23aa65a618e30dda56c68ba532e62d86a8d99fbd07d21683)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6d7ea0e5f465312815706e7d78134157421c62d6dc0da2c8bd992dfdabe14a02)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4c9248066303231c1c1afcc4e8a77c34c31d4714cba7759ef71b6281ce39c33c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationAppend]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationAppend]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationAppend]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__458e5b6169c21cf23c5b0c418209b051389f91af4fbd84414805b3a1362dcd1e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationAppendOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationAppendOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e5395680acb437aa5bd05333d6c57b3955dc1483f555d4997f38838306fd32db)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationAppendImage()

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityPriority")
    def reset_gravity_priority(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityPriority", []))

    @jsii.member(jsii_name="resetGravityPriorityVar")
    def reset_gravity_priority_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityPriorityVar", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPreserveMinorDimension")
    def reset_preserve_minor_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPreserveMinorDimension", []))

    @jsii.member(jsii_name="resetPreserveMinorDimensionVar")
    def reset_preserve_minor_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPreserveMinorDimensionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationAppendImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationAppendImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityInput")
    def gravity_priority_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityPriorityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityVarInput")
    def gravity_priority_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityPriorityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationAppendImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationAppendImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionInput")
    def preserve_minor_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "preserveMinorDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionVarInput")
    def preserve_minor_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "preserveMinorDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4c17a30baaaf255a2e36e70927d3e875166263bb676a8a01d88364d62c72568b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityPriority")
    def gravity_priority(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityPriority"))

    @gravity_priority.setter
    def gravity_priority(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f299401390895e296fce64d5abffb0aa26b70d3db3b1713d2744560a7168132)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityPriority", value)

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityVar")
    def gravity_priority_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityPriorityVar"))

    @gravity_priority_var.setter
    def gravity_priority_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a0e6cfeb1a94bb71008204b0c85489f11e46f451cbac2cd68809b76e8108bd38)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityPriorityVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3671a65b58fe53e147fefef01774624c6e71c5a1caa000252d1f76ccbf81d38f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimension")
    def preserve_minor_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "preserveMinorDimension"))

    @preserve_minor_dimension.setter
    def preserve_minor_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1ad8d8ee6094b5b7d77b848a1dbb15432609b9f7f6a331e69d2b57a3c1efa81d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "preserveMinorDimension", value)

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionVar")
    def preserve_minor_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "preserveMinorDimensionVar"))

    @preserve_minor_dimension_var.setter
    def preserve_minor_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fca8489d19700ec973b8dd0b2c88b36f53b2da49d4103cd995b5b02aaca5c1ac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "preserveMinorDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationAppend]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationAppend]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationAppend]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7f9275481c826a80fe4b59e01f3f6e261439ec7f8ddbee3b4ba30790b9793e03)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationAspectCrop",
    jsii_struct_bases=[],
    name_mapping={
        "allow_expansion": "allowExpansion",
        "allow_expansion_var": "allowExpansionVar",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationAspectCrop:
    def __init__(
        self,
        *,
        allow_expansion: typing.Optional[builtins.str] = None,
        allow_expansion_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_expansion: Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image. Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        :param allow_expansion_var: Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image. Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        :param height: The height term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The width term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        :param x_position: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e226072d5dbc69b917b0eae757f74b75f655942866f36995c812660a1d4ca750)
            check_type(argname="argument allow_expansion", value=allow_expansion, expected_type=type_hints["allow_expansion"])
            check_type(argname="argument allow_expansion_var", value=allow_expansion_var, expected_type=type_hints["allow_expansion_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if allow_expansion is not None:
            self._values["allow_expansion"] = allow_expansion
        if allow_expansion_var is not None:
            self._values["allow_expansion_var"] = allow_expansion_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def allow_expansion(self) -> typing.Optional[builtins.str]:
        '''Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image.

        Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        '''
        result = self._values.get("allow_expansion")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def allow_expansion_var(self) -> typing.Optional[builtins.str]:
        '''Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image.

        Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        '''
        result = self._values.get("allow_expansion_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationAspectCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationAspectCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationAspectCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__29bd055f6b411af80e1d28b2503c4c1073d811a15407e03b4ca066ca4bbc7480)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationAspectCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea368e0609d82843bbf03cbd3740d5a9906fda06edd89352cfebda1f1ac57846)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationAspectCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8e154038aed22af4b6ac040c8066f7dfc0bb735ce683d85433f1f71b5b8e6254)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__29a639b302f076a3f7ce6c68adfe5e01f604685582be200b7c5fe28e54c219ef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__12895c7c37f30c05ff75b6d92585a54276f7ea88b35da0cb75ffd53d3ec0dbe4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationAspectCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationAspectCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationAspectCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d96038c484ad704f539812f92ee78b560939f67931b83dc294d299f2309a6e7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationAspectCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationAspectCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2979348625a1f0b0aa6239e169e65d5d789a3b4ecd93eb98d27b5842ad01ccd0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAllowExpansion")
    def reset_allow_expansion(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansion", []))

    @jsii.member(jsii_name="resetAllowExpansionVar")
    def reset_allow_expansion_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansionVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionInput")
    def allow_expansion_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVarInput")
    def allow_expansion_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansion")
    def allow_expansion(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansion"))

    @allow_expansion.setter
    def allow_expansion(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__797760189cc43db78812116fbadad48956b6f84dc6b0e019cccd30b8b1f1b46d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansion", value)

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVar")
    def allow_expansion_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansionVar"))

    @allow_expansion_var.setter
    def allow_expansion_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5e05cd10abd3d1db319e350360b779a6aa3d10a2677f24eb9acdf52428b7322f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansionVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7ae2875bc57f4665cc6dc15278e5a2288427ee9570c9a5a553d8d192a49bf97d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4b591d49de92bc438825aabf4845003f6bb24cf8ad75fad21fdcf417183a71d1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1592d26ce7ddb719897cb783fe5137b88fe83b7c6cec7abdb289d2b2745a70d4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c64b1dcf1763e0ced0ecb72a46f110e6a7ea62bd4a5f878558568ccdfb6f1f30)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3b2eddffb1f64cb71fe3e52da1be75c9b82f0d36214fc7d3de13746034b68808)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4026e3c7b4ebd2145830dddbe9546ec16b13cc00209bc8049f8cd2b676f0fec2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0c235f53f18b335cff0313962b60df831230da472de82ce11f563f03e038695c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eb2839152bf9634a1c63f1be883fe66ff921dcc36c9b2233b11750a9106824a7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationAspectCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationAspectCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationAspectCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__701fab5d8e49403a263dbeebc289757498dea5e1ab8d8e947d6f7fbe08e37686)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationBackgroundColor",
    jsii_struct_bases=[],
    name_mapping={"color": "color", "color_var": "colorVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationBackgroundColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__65986ce228593adcea9b188aef56c1fec8441c0cbe11e527d40508f3af67d286)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationBackgroundColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationBackgroundColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationBackgroundColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ea7962cebceea822698fe6b7e00f1eb78b63e33b6ede7b0019d20f6cdd21a8f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationBackgroundColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e7f1dd0429c3642719da9e5f0fdd805ae850937155fae9bd5d97e56be0a9f244)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationBackgroundColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__94a12e66ffbc7d2d6e5c48524b2a810f69abe07eef56f36f47349ef2327afb15)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__55657280e75814112d084c353e5640cb6bac456314763a08b8dbac6e3fc08f73)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8b629a917eefd75f8bd3bcb68f672a96b6d10d1031594d3fc8794a28abe9ee82)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationBackgroundColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationBackgroundColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__977ac74510107e3a2403420e0eee47068ef05572ae1b0035d0ea88c1b612e885)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationBackgroundColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationBackgroundColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__caea199a9e58cec324e129bc51ac3906265e0a3311cdd6a21a1fbaf0f98c92be)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a20655b646d359d301ffe074133c353e8274c327a443c51f0f7b179c63307840)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d06164b1f6b7c12c7714b9b9977a9dc7600c0e827c0894968d10998ae24b5549)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationBackgroundColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationBackgroundColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationBackgroundColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__31fb24b03028c49bd14527b3c9d5b443c96e4aba212bddaec7cee724cd7efef7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationBlur",
    jsii_struct_bases=[],
    name_mapping={"sigma": "sigma", "sigma_var": "sigmaVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationBlur:
    def __init__(
        self,
        *,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param sigma: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0e6f2f0996b3278cdbe025681e3cf72290bc8345185c097f8bb098db0f490f8f)
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationBlur(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationBlurList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationBlurList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__706e993fe90cb13b95a192c80aeb24990e21328c478dd8365cdd2059e27f850e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationBlurOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__18205f01cb5c9bcdda6b0f68d8fe5980a327ccd93be9096d221409a968154a5c)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationBlurOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__740958b5368aceb0e52fe37eaec7c3998d2bb0dce87f01dcf6d5c1ee27b15fd2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__81c1c7c1b412345a20ba53a63a9211625f4b35890f83fd3cd2890713dc363786)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f47b3c6679d4b25b897db7fe960ee83d111dea9080e2cd0bfdab38dc6cf99e8b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationBlur]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationBlur]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8302644780365aa9a69202e26494c85c0488b6fe13ed972786500ecb346d5ebf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationBlurOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationBlurOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__16bafafef79081ad00897f9a890aac3132e3e8977c275a517c566d178eecbe50)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3b3bdde5dc68eca9b4862624aac0fc3e15cc7c6b340b5de6b1849137603806e3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ef76865e6c7907dc2f490bb37528dbcfe53e8dfac5ca0f18e495525f85246fb4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationBlur]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationBlur]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationBlur]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cb270ac6d5a3bf2cddf866311e9d82d195d378293a3bf5b1c13df7cf0cdc3118)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationChromaKey",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_feather": "hueFeather",
        "hue_feather_var": "hueFeatherVar",
        "hue_tolerance": "hueTolerance",
        "hue_tolerance_var": "hueToleranceVar",
        "hue_var": "hueVar",
        "lightness_feather": "lightnessFeather",
        "lightness_feather_var": "lightnessFeatherVar",
        "lightness_tolerance": "lightnessTolerance",
        "lightness_tolerance_var": "lightnessToleranceVar",
        "saturation_feather": "saturationFeather",
        "saturation_feather_var": "saturationFeatherVar",
        "saturation_tolerance": "saturationTolerance",
        "saturation_tolerance_var": "saturationToleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationChromaKey:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_feather: typing.Optional[builtins.str] = None,
        hue_feather_var: typing.Optional[builtins.str] = None,
        hue_tolerance: typing.Optional[builtins.str] = None,
        hue_tolerance_var: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness_feather: typing.Optional[builtins.str] = None,
        lightness_feather_var: typing.Optional[builtins.str] = None,
        lightness_tolerance: typing.Optional[builtins.str] = None,
        lightness_tolerance_var: typing.Optional[builtins.str] = None,
        saturation_feather: typing.Optional[builtins.str] = None,
        saturation_feather_var: typing.Optional[builtins.str] = None,
        saturation_tolerance: typing.Optional[builtins.str] = None,
        saturation_tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_feather: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        :param hue_feather_var: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        :param hue_tolerance: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        :param hue_tolerance_var: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        :param hue_var: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness_feather: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        :param lightness_feather_var: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        :param lightness_tolerance: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        :param lightness_tolerance_var: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        :param saturation_feather: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        :param saturation_feather_var: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        :param saturation_tolerance: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        :param saturation_tolerance_var: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cffb87b02f3a247107271d073a5186aa9790194f92bada8f51f142d9eab10bbf)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_feather", value=hue_feather, expected_type=type_hints["hue_feather"])
            check_type(argname="argument hue_feather_var", value=hue_feather_var, expected_type=type_hints["hue_feather_var"])
            check_type(argname="argument hue_tolerance", value=hue_tolerance, expected_type=type_hints["hue_tolerance"])
            check_type(argname="argument hue_tolerance_var", value=hue_tolerance_var, expected_type=type_hints["hue_tolerance_var"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness_feather", value=lightness_feather, expected_type=type_hints["lightness_feather"])
            check_type(argname="argument lightness_feather_var", value=lightness_feather_var, expected_type=type_hints["lightness_feather_var"])
            check_type(argname="argument lightness_tolerance", value=lightness_tolerance, expected_type=type_hints["lightness_tolerance"])
            check_type(argname="argument lightness_tolerance_var", value=lightness_tolerance_var, expected_type=type_hints["lightness_tolerance_var"])
            check_type(argname="argument saturation_feather", value=saturation_feather, expected_type=type_hints["saturation_feather"])
            check_type(argname="argument saturation_feather_var", value=saturation_feather_var, expected_type=type_hints["saturation_feather_var"])
            check_type(argname="argument saturation_tolerance", value=saturation_tolerance, expected_type=type_hints["saturation_tolerance"])
            check_type(argname="argument saturation_tolerance_var", value=saturation_tolerance_var, expected_type=type_hints["saturation_tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_feather is not None:
            self._values["hue_feather"] = hue_feather
        if hue_feather_var is not None:
            self._values["hue_feather_var"] = hue_feather_var
        if hue_tolerance is not None:
            self._values["hue_tolerance"] = hue_tolerance
        if hue_tolerance_var is not None:
            self._values["hue_tolerance_var"] = hue_tolerance_var
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness_feather is not None:
            self._values["lightness_feather"] = lightness_feather
        if lightness_feather_var is not None:
            self._values["lightness_feather_var"] = lightness_feather_var
        if lightness_tolerance is not None:
            self._values["lightness_tolerance"] = lightness_tolerance
        if lightness_tolerance_var is not None:
            self._values["lightness_tolerance_var"] = lightness_tolerance_var
        if saturation_feather is not None:
            self._values["saturation_feather"] = saturation_feather
        if saturation_feather_var is not None:
            self._values["saturation_feather_var"] = saturation_feather_var
        if saturation_tolerance is not None:
            self._values["saturation_tolerance"] = saturation_tolerance
        if saturation_tolerance_var is not None:
            self._values["saturation_tolerance_var"] = saturation_tolerance_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        '''
        result = self._values.get("hue_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        '''
        result = self._values.get("hue_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        '''
        result = self._values.get("hue_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        '''
        result = self._values.get("hue_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        '''
        result = self._values.get("lightness_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        '''
        result = self._values.get("lightness_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        '''
        result = self._values.get("lightness_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        '''
        result = self._values.get("lightness_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        '''
        result = self._values.get("saturation_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        '''
        result = self._values.get("saturation_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        '''
        result = self._values.get("saturation_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        result = self._values.get("saturation_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationChromaKey(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationChromaKeyList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationChromaKeyList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b47e768a98e68799ac3da54076f818ef97da7893c49633015b3456135bb2e892)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationChromaKeyOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1ef8d0672242f9e73731fd1d9c356d784ce6d0f542bc42348079a4db7a29c9f8)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationChromaKeyOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fef9feea5cd31fd468e14cbcb14fb9230381c6ff129db1875d51505a80c883a3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__744131f196e7f66a9fa2e043cab0f1d9a3fd216d70c7dd81a4b5d441d417d520)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d5656c6c08e563fab1ced11b089da2ae7b2e77f0341c91e8b89196aa908f95d3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationChromaKey]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationChromaKey]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d8acb4d48eba05d1a70cdb157ba483e008c393cd89b70325a6c655796cf98380)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationChromaKeyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationChromaKeyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d97b8fdc0d9c778f1933ca126fb4972ffd4421623668a139e591a59f762bfa0a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueFeather")
    def reset_hue_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeather", []))

    @jsii.member(jsii_name="resetHueFeatherVar")
    def reset_hue_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeatherVar", []))

    @jsii.member(jsii_name="resetHueTolerance")
    def reset_hue_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueTolerance", []))

    @jsii.member(jsii_name="resetHueToleranceVar")
    def reset_hue_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueToleranceVar", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightnessFeather")
    def reset_lightness_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeather", []))

    @jsii.member(jsii_name="resetLightnessFeatherVar")
    def reset_lightness_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeatherVar", []))

    @jsii.member(jsii_name="resetLightnessTolerance")
    def reset_lightness_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessTolerance", []))

    @jsii.member(jsii_name="resetLightnessToleranceVar")
    def reset_lightness_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessToleranceVar", []))

    @jsii.member(jsii_name="resetSaturationFeather")
    def reset_saturation_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeather", []))

    @jsii.member(jsii_name="resetSaturationFeatherVar")
    def reset_saturation_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeatherVar", []))

    @jsii.member(jsii_name="resetSaturationTolerance")
    def reset_saturation_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationTolerance", []))

    @jsii.member(jsii_name="resetSaturationToleranceVar")
    def reset_saturation_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherInput")
    def hue_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVarInput")
    def hue_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceInput")
    def hue_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVarInput")
    def hue_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherInput")
    def lightness_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVarInput")
    def lightness_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceInput")
    def lightness_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVarInput")
    def lightness_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherInput")
    def saturation_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVarInput")
    def saturation_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceInput")
    def saturation_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVarInput")
    def saturation_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cc97a11783f9fd20d5d40d0a0d960be7dc709d406d4bbffb96dd1085c60dc81a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeather")
    def hue_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeather"))

    @hue_feather.setter
    def hue_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0d872cb66795ea1039f772775f1b43dcbee848058b216e81139ed409a97aa165)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeather", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVar")
    def hue_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeatherVar"))

    @hue_feather_var.setter
    def hue_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__abfc85dcfc70f2de6c3851759f84a852fe98810e9d8116f47f5889fa11d47464)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueTolerance")
    def hue_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueTolerance"))

    @hue_tolerance.setter
    def hue_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a9a4b4c8409c7d6caf124302c223e55082fae771f4d7e26310f11a527310b3ae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVar")
    def hue_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueToleranceVar"))

    @hue_tolerance_var.setter
    def hue_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__94da47fff30c665f9721a53384d2febfedff6992e4e1abb6909b7738febeae89)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__12ec321dfd1b1592328e6a8a28bc05f119380cba145f641936b540537ee84d90)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeather")
    def lightness_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeather"))

    @lightness_feather.setter
    def lightness_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__598d3f2a3c907afe216cb9592a4cd0a71b52a28224d2fd0a4c9c94b50dd0f628)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeather", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVar")
    def lightness_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeatherVar"))

    @lightness_feather_var.setter
    def lightness_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fb507ab2c5ea2b9e959e8295c9d004017679e64af2cc059d2f5ab7c9c6555e9b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessTolerance")
    def lightness_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessTolerance"))

    @lightness_tolerance.setter
    def lightness_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f56d8ff5f33cac3339c138894c1cb40c174842040c55a33270589edc1179ffc2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVar")
    def lightness_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessToleranceVar"))

    @lightness_tolerance_var.setter
    def lightness_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f3bd8e4f7a3710cdc3bf429e6d2b08a7ac498af442fa4d4b47481a0d8deda42a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeather")
    def saturation_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeather"))

    @saturation_feather.setter
    def saturation_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__09c587420b2fa5cedb74882f365eb3e8cbef3ce0782895ad2de6f8ecb9141c15)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeather", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVar")
    def saturation_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeatherVar"))

    @saturation_feather_var.setter
    def saturation_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9401438ecda754d31aec8a149e9e701981fde25519c79e0f9dbe613646c0b9ae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationTolerance")
    def saturation_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationTolerance"))

    @saturation_tolerance.setter
    def saturation_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__98dbf4662c9bdd23de416b0891287e954981cbe0e12ab74f5e7fde670d1fadd9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVar")
    def saturation_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationToleranceVar"))

    @saturation_tolerance_var.setter
    def saturation_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__90c7bc4350241319451f5538e35c672cc133c64b9cde811a4a68bc1957b1ccaa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationChromaKey]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationChromaKey]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationChromaKey]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__41cc8acefff90b4d4b859fc62ce080c0d2a8a981cdb00afe17b5ff087166549c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationComposite",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "placement": "placement",
        "placement_var": "placementVar",
        "scale": "scale",
        "scale_dimension": "scaleDimension",
        "scale_dimension_var": "scaleDimensionVar",
        "scale_var": "scaleVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationComposite:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationCompositeImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        placement: typing.Optional[builtins.str] = None,
        placement_var: typing.Optional[builtins.str] = None,
        scale: typing.Optional[builtins.str] = None,
        scale_dimension: typing.Optional[builtins.str] = None,
        scale_dimension_var: typing.Optional[builtins.str] = None,
        scale_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param placement: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        :param placement_var: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        :param scale: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param scale_dimension: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        :param scale_dimension_var: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        :param scale_var: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        :param x_position: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationCompositeImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__231b9eaa053c23dc009b0f4dba0d2942946210db02dceee01bf76092804350eb)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument placement", value=placement, expected_type=type_hints["placement"])
            check_type(argname="argument placement_var", value=placement_var, expected_type=type_hints["placement_var"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument scale_dimension", value=scale_dimension, expected_type=type_hints["scale_dimension"])
            check_type(argname="argument scale_dimension_var", value=scale_dimension_var, expected_type=type_hints["scale_dimension_var"])
            check_type(argname="argument scale_var", value=scale_var, expected_type=type_hints["scale_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if placement is not None:
            self._values["placement"] = placement
        if placement_var is not None:
            self._values["placement_var"] = placement_var
        if scale is not None:
            self._values["scale"] = scale
        if scale_dimension is not None:
            self._values["scale_dimension"] = scale_dimension
        if scale_dimension_var is not None:
            self._values["scale_dimension_var"] = scale_dimension_var
        if scale_var is not None:
            self._values["scale_var"] = scale_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationCompositeImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationCompositeImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        '''
        result = self._values.get("placement")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement_var(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        '''
        result = self._values.get("placement_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        '''
        result = self._values.get("scale_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        '''
        result = self._values.get("scale_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        '''
        result = self._values.get("scale_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationComposite(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationCompositeImage",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationCompositeImage:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationCompositeImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationCompositeImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationCompositeImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2fee3c9a9a8335169fc704052909390b8332c167df0692e3f845342c0301f0f3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationCompositeImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationCompositeImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__69bd3b891c8b405c40e0458bb15f86fa08240f07ba22fb84d1a3aa5f2f5f8106)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationCompositeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationCompositeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d8d7aa656e114101483fac0ea62feae00d31aa7e127f2f053b6cd6f154503e8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationCompositeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b9056c0952e1f79bb0fe2ff47adec0f4b2d304283c5dca78704b013c109dae33)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationCompositeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3738dbddbc77394a878c3a3547b2560bbb246e0cc6da384fc297e8e2ae48e82b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dacf35cf91c8ccca8de82b1b33e8f7176856a68033b8bcf2d583fa50d580dd87)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__882e6a00bd2eae31e44c8e91ea1607784f89728eb8e55e5ca81dbf5c3274b67c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationComposite]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationComposite]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__79ca6b5ad49195c7a1f1e0c5cf95981a1e5b774912f21a12202bd97ad8e59ea8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationCompositeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationCompositeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__023effec17aac4322972f9352a709a35d946ec0a7105ef29ba43caf697cb6738)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationCompositeImage()

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPlacement")
    def reset_placement(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacement", []))

    @jsii.member(jsii_name="resetPlacementVar")
    def reset_placement_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacementVar", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetScaleDimension")
    def reset_scale_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimension", []))

    @jsii.member(jsii_name="resetScaleDimensionVar")
    def reset_scale_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimensionVar", []))

    @jsii.member(jsii_name="resetScaleVar")
    def reset_scale_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationCompositeImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationCompositeImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationCompositeImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="placementInput")
    def placement_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementInput"))

    @builtins.property
    @jsii.member(jsii_name="placementVarInput")
    def placement_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionInput")
    def scale_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVarInput")
    def scale_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleVarInput")
    def scale_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1fd7b1947b14a2e8ee55f220ebc56fa58225aad0061b6d7e8e0879275c25939c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ca85d89fa54e220a2e52ce0b57667fd24e07fd15250e113197e2e7e3d215291f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="placement")
    def placement(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placement"))

    @placement.setter
    def placement(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ff0825d9008225a09ce9801c6e5611fede943161808fd22e9acc6e41d0dbde4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placement", value)

    @builtins.property
    @jsii.member(jsii_name="placementVar")
    def placement_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placementVar"))

    @placement_var.setter
    def placement_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9c923d8a68641ead9cdea3aad5281e385b51e18fabec961efa3f54c26a7bf510)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placementVar", value)

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scale"))

    @scale.setter
    def scale(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b5efceaa04418c82654423858febd1f1b4061ab65ef24fbc81ceaac676a510f2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scale", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimension")
    def scale_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimension"))

    @scale_dimension.setter
    def scale_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__20036e061a97f94189f6f6958c2d2470d2bc6b882d943373aef6d9e0cf3e01f4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimension", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVar")
    def scale_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimensionVar"))

    @scale_dimension_var.setter
    def scale_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ed2c0adc004239f60d0e1fc739daa33df5ff98bc71a22bf862e206b411a81143)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="scaleVar")
    def scale_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleVar"))

    @scale_var.setter
    def scale_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b21ee0f8926884461353ec4ad9ac0e58965813ec9d573dda9de1aedccec07619)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fed91f2716c093e1bc92cd321adcc21b409a1fab0919cecd0d472949cd93e6fb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2e8a49342049805a0410f69414da2ac5075cea031d0c49b57e82819dad3fed72)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__53cd71233ed4c29cc95d6389b08e8bc2e666615269af3c2ab4cd51e6f3b76052)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b01c25b15d023ac618b369fd9375d20507adc5469334e81e7079a7b769ba2333)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationComposite]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationComposite]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationComposite]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5c8900d5f437219fab5cda506d4d3539a354771be7ae0892871ec94e9fbcce18)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationCompound",
    jsii_struct_bases=[],
    name_mapping={"transformations": "transformations"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationCompound:
    def __init__(
        self,
        *,
        transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param transformations: transformations block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9503a3b4547ee5ea3f9e4eb0ff7b993b9d87daf5736ad3a046e104dc981cd673)
            check_type(argname="argument transformations", value=transformations, expected_type=type_hints["transformations"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if transformations is not None:
            self._values["transformations"] = transformations

    @builtins.property
    def transformations(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationCompoundTransformations"]]]:
        '''transformations block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        result = self._values.get("transformations")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationCompoundTransformations"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationCompound(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationCompoundList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationCompoundList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7ac97a4437fab92b10c9ad9d244c628925cef84f8c1f649f9e4d891067d50e6b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationCompoundOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__480f976d13a9c1cc6a541ed24f52be897a6977a1672019e26ea2647ddf349b35)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationCompoundOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cfbfda7e15a0670063bdc98e0d95c0e146616e16f5c0542a8e0088aab41f8c22)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__81b613182404b80c6c537c3ed35539e133da024db1dc282fd09c16373a08d26f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e564bd33ce58b1f4673d7863bcbde5519ca90e67205cb6d28d4fd4f6cbecdada)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationCompound]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationCompound]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__41b1dfe1b940c9aa624a30440a355ddacd931b46d84ca4ba82a75fde41d685cd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationCompoundOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationCompoundOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__06780dc7d6b653b5ca7f8c0fd289975f529a22f5d9f20ba8de399b62ba42a914)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformations")
    def put_transformations(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6a4bf7710ca7845dd4840cc976288f786dcea1001f83d048ae57ff40b93a9a0e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTransformations", [value]))

    @jsii.member(jsii_name="resetTransformations")
    def reset_transformations(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformations", []))

    @builtins.property
    @jsii.member(jsii_name="transformations")
    def transformations(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationCompoundTransformationsList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationCompoundTransformationsList", jsii.get(self, "transformations"))

    @builtins.property
    @jsii.member(jsii_name="transformationsInput")
    def transformations_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationCompoundTransformations"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationCompoundTransformations"]]], jsii.get(self, "transformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationCompound]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationCompound]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationCompound]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d8305183101be1f86c39e6ef2e73de100ce92249b87e156027139839d40885c1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationCompoundTransformations",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationCompoundTransformations:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationCompoundTransformations(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationCompoundTransformationsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationCompoundTransformationsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c3aa08d9eec78fdb83971b4ae880ef3b37d49b320dba95d555f678ca1f6c2ee9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationCompoundTransformationsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__15776b7a01f2d867cf506dfdbedd5463587942ae7be683358faf79c3dbb085f3)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationCompoundTransformationsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__73b4aa1a65df1c125778ddc3c1ca8099dded21623a0dba7a7de163ee360cb073)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8f32806bc2e73310350874175cd71847289eecc4ef98516633a4b4646e54292f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a174bb4a67c26704443633bb0a35a22388e7a9fac9e2009befbf175963bcac0a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationCompoundTransformations]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationCompoundTransformations]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationCompoundTransformations]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f2106f5201809d74b696d4a59082234107c0767a344859da82447a34fedaafa1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationCompoundTransformationsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationCompoundTransformationsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c42006bba97154880d81ffc294cc117f680088c7ef4350f0f685de49c11be554)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationCompoundTransformations]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationCompoundTransformations]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationCompoundTransformations]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0779c19c10276cfee91ac842a1706a23c6aef5f0f3a41149df3189bc694f7a38)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationContrast",
    jsii_struct_bases=[],
    name_mapping={
        "brightness": "brightness",
        "brightness_var": "brightnessVar",
        "contrast": "contrast",
        "contrast_var": "contrastVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationContrast:
    def __init__(
        self,
        *,
        brightness: typing.Optional[builtins.str] = None,
        brightness_var: typing.Optional[builtins.str] = None,
        contrast: typing.Optional[builtins.str] = None,
        contrast_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param brightness: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        :param brightness_var: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        :param contrast: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param contrast_var: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__95b196c79f63bf80131aea2f039c8ba9a2abe707ca8ee4a46ea47b2d1ab44092)
            check_type(argname="argument brightness", value=brightness, expected_type=type_hints["brightness"])
            check_type(argname="argument brightness_var", value=brightness_var, expected_type=type_hints["brightness_var"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument contrast_var", value=contrast_var, expected_type=type_hints["contrast_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if brightness is not None:
            self._values["brightness"] = brightness
        if brightness_var is not None:
            self._values["brightness_var"] = brightness_var
        if contrast is not None:
            self._values["contrast"] = contrast
        if contrast_var is not None:
            self._values["contrast_var"] = contrast_var

    @builtins.property
    def brightness(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        '''
        result = self._values.get("brightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def brightness_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        '''
        result = self._values.get("brightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        result = self._values.get("contrast_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationContrast(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationContrastList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationContrastList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e134a1b3ffe8107aab331bd6f22071333929c2d242d5442c66631aa509880c7f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationContrastOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__908578eabff1dfb1879d0215030a5e576f2cb31ae2f89625e942ff3d19687558)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationContrastOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__44545202277daed969eb1bb607064680420fac9ffd684483af19849733da2d08)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__07c226c753d6da903c4813c563427b99706c924ddf6f9426d1f47e98e4c49199)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9cfaf967deca97705f053dd90579786af7061d4e1b8adc0eeb1f26d46917faae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationContrast]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationContrast]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cfb2851aec0f1362cdee049d69d96b02aa99cf09f7771bba1693ce858d6082c6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationContrastOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationContrastOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1b34aa0662d831b462451064d9b8a56f48a583aded73a535ca6b864d7664cfb9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetBrightness")
    def reset_brightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightness", []))

    @jsii.member(jsii_name="resetBrightnessVar")
    def reset_brightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightnessVar", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetContrastVar")
    def reset_contrast_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrastVar", []))

    @builtins.property
    @jsii.member(jsii_name="brightnessInput")
    def brightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="brightnessVarInput")
    def brightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastVarInput")
    def contrast_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="brightness")
    def brightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightness"))

    @brightness.setter
    def brightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6a2382a12cb873cc8ea746b4c1cda584ed2f45ad1262ca850dfdb2e6be525812)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightness", value)

    @builtins.property
    @jsii.member(jsii_name="brightnessVar")
    def brightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightnessVar"))

    @brightness_var.setter
    def brightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d440b15e6ca38a800da1d536935fe331673906d44c35f82b905e3cb34407936e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrast"))

    @contrast.setter
    def contrast(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__29b8e52ac4615eaf8ebfd74d38599b982686a6cffa1fde341eabbfacf06fb85c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrast", value)

    @builtins.property
    @jsii.member(jsii_name="contrastVar")
    def contrast_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrastVar"))

    @contrast_var.setter
    def contrast_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b59a330a67cb282e02762fabe4f676efb8395da071e037f99d50c7d23d3f2cc9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrastVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationContrast]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationContrast]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationContrast]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__17702db20c64d0e9b4f4e0333b835149585331ab24524c0d9511e6fb0c44477b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationCrop",
    jsii_struct_bases=[],
    name_mapping={
        "allow_expansion": "allowExpansion",
        "allow_expansion_var": "allowExpansionVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationCrop:
    def __init__(
        self,
        *,
        allow_expansion: typing.Optional[builtins.str] = None,
        allow_expansion_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_expansion: If cropping an area outside of the existing canvas, expands the image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        :param allow_expansion_var: If cropping an area outside of the existing canvas, expands the image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        :param gravity: Frame of reference for X and Y Positions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Frame of reference for X and Y Positions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The number of pixels to crop along the y-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The number of pixels to crop along the y-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The number of pixels to crop along the x-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The number of pixels to crop along the x-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        :param x_position: The x-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d3628ad8dfbd3c3e6610041e6b0d2dca3ef3cf5abc1054893e3ccd565635087e)
            check_type(argname="argument allow_expansion", value=allow_expansion, expected_type=type_hints["allow_expansion"])
            check_type(argname="argument allow_expansion_var", value=allow_expansion_var, expected_type=type_hints["allow_expansion_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if allow_expansion is not None:
            self._values["allow_expansion"] = allow_expansion
        if allow_expansion_var is not None:
            self._values["allow_expansion_var"] = allow_expansion_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def allow_expansion(self) -> typing.Optional[builtins.str]:
        '''If cropping an area outside of the existing canvas, expands the image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        '''
        result = self._values.get("allow_expansion")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def allow_expansion_var(self) -> typing.Optional[builtins.str]:
        '''If cropping an area outside of the existing canvas, expands the image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        '''
        result = self._values.get("allow_expansion_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Frame of reference for X and Y Positions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Frame of reference for X and Y Positions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the y-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the y-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the x-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the x-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b22f1eeb242cb727e66171d4df0759dba30d0813ed1a7ecd995b17a7f33ebdd2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b960000ea6412900fb9aa70336f8b3e3ee7dfa2c3368d1db966af8ddc39c2578)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__269631b95239a6622e2080545b7c885961f969b28e9f0dfb24c72760b83b3eb5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__15d3b5bf49c63a5d5fed9bf39b69302ac66d1216d4955151cf561084e23ff1b1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f6afad9ca717a6b4036c1b7a21e39edc6025efc74b31a97650e74ca52d38ef26)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6a9a96788a65e72e66eb4c0607ade6d0db81d38dd9c8dab3a8acf1ed72379771)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__846290406abc9ca05f7f84ce4bd2f7c9e9e86d5d3036bcd5d4d63a158abb1408)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAllowExpansion")
    def reset_allow_expansion(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansion", []))

    @jsii.member(jsii_name="resetAllowExpansionVar")
    def reset_allow_expansion_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansionVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionInput")
    def allow_expansion_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVarInput")
    def allow_expansion_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansion")
    def allow_expansion(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansion"))

    @allow_expansion.setter
    def allow_expansion(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__68ef91e2beba8d74e844c498b9972e95785cb267f3f64ec308eb5f368941d297)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansion", value)

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVar")
    def allow_expansion_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansionVar"))

    @allow_expansion_var.setter
    def allow_expansion_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5054e330910965a4fc7bdc9ba3ddb6d26419302656eef95c00e2d140242b5638)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansionVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__66f06be1942df7f68e7a6976ebd5099d1dd935c2edd08e5237171578b93a8b65)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2173a1f83d52b79e802006f7b1e753836f9028b27555514bc5110fb53c560449)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fc9da4e9ecae4c9cb81606a9fe424940f0b0bdb554c4145e586453c4d54b8be1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e2656c1f6ebda48075d104e0bb99239a711b4efdcb63ab9260770396b085660d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__220b58c21e7868e4618eec9937a3f7b3032dbd81c9ca4d9df6f4ea153ae8547f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e94f05a7e504d7d3ca70fc7eec54761925d7b9d13707c6d51be779deef7166fc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f4f533d78b472001020050213c071d8c02513f33bd859e3b19cbcffebf57cd5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a4f0a5341026f5ba20c01d904860c97228cb675333a7a55ec211592dc970c853)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ce60354028095c03a3d1389b8fb17038ce7fc5593e7108c194630feb6188ab63)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e54d3e463c7794591725b86c5365f35ba327fdd804180cc6d72809924ad9351d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__519520db29d248998d6c6d0b3b65b485918c26fa998baae0377b5b97a4c23de5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationFaceCrop",
    jsii_struct_bases=[],
    name_mapping={
        "algorithm": "algorithm",
        "algorithm_var": "algorithmVar",
        "confidence": "confidence",
        "confidence_var": "confidenceVar",
        "fail_gravity": "failGravity",
        "fail_gravity_var": "failGravityVar",
        "focus": "focus",
        "focus_var": "focusVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "padding": "padding",
        "padding_var": "paddingVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationFaceCrop:
    def __init__(
        self,
        *,
        algorithm: typing.Optional[builtins.str] = None,
        algorithm_var: typing.Optional[builtins.str] = None,
        confidence: typing.Optional[builtins.str] = None,
        confidence_var: typing.Optional[builtins.str] = None,
        fail_gravity: typing.Optional[builtins.str] = None,
        fail_gravity_var: typing.Optional[builtins.str] = None,
        focus: typing.Optional[builtins.str] = None,
        focus_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param algorithm: Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm DataAkamaiImagingPolicyImage#algorithm}
        :param algorithm_var: Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm_var DataAkamaiImagingPolicyImage#algorithm_var}
        :param confidence: With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image. Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence DataAkamaiImagingPolicyImage#confidence}
        :param confidence_var: With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image. Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence_var DataAkamaiImagingPolicyImage#confidence_var}
        :param fail_gravity: Controls placement of the crop if Image and Video Manager does not detect any faces in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        :param fail_gravity_var: Controls placement of the crop if Image and Video Manager does not detect any faces in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        :param focus: Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus DataAkamaiImagingPolicyImage#focus}
        :param focus_var: Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus_var DataAkamaiImagingPolicyImage#focus_var}
        :param gravity: Controls placement of the crop. Directions are relative to the face(s) plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Controls placement of the crop. Directions are relative to the face(s) plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param padding: The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        :param style: Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0e0d0bf7e128c0d30a4dcbd294847feec87254fbc80a74c1303c07cb8131a3e9)
            check_type(argname="argument algorithm", value=algorithm, expected_type=type_hints["algorithm"])
            check_type(argname="argument algorithm_var", value=algorithm_var, expected_type=type_hints["algorithm_var"])
            check_type(argname="argument confidence", value=confidence, expected_type=type_hints["confidence"])
            check_type(argname="argument confidence_var", value=confidence_var, expected_type=type_hints["confidence_var"])
            check_type(argname="argument fail_gravity", value=fail_gravity, expected_type=type_hints["fail_gravity"])
            check_type(argname="argument fail_gravity_var", value=fail_gravity_var, expected_type=type_hints["fail_gravity_var"])
            check_type(argname="argument focus", value=focus, expected_type=type_hints["focus"])
            check_type(argname="argument focus_var", value=focus_var, expected_type=type_hints["focus_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if algorithm is not None:
            self._values["algorithm"] = algorithm
        if algorithm_var is not None:
            self._values["algorithm_var"] = algorithm_var
        if confidence is not None:
            self._values["confidence"] = confidence
        if confidence_var is not None:
            self._values["confidence_var"] = confidence_var
        if fail_gravity is not None:
            self._values["fail_gravity"] = fail_gravity
        if fail_gravity_var is not None:
            self._values["fail_gravity_var"] = fail_gravity_var
        if focus is not None:
            self._values["focus"] = focus
        if focus_var is not None:
            self._values["focus_var"] = focus_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def algorithm(self) -> typing.Optional[builtins.str]:
        '''Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm DataAkamaiImagingPolicyImage#algorithm}
        '''
        result = self._values.get("algorithm")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def algorithm_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm_var DataAkamaiImagingPolicyImage#algorithm_var}
        '''
        result = self._values.get("algorithm_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def confidence(self) -> typing.Optional[builtins.str]:
        '''With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image.

        Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence DataAkamaiImagingPolicyImage#confidence}
        '''
        result = self._values.get("confidence")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def confidence_var(self) -> typing.Optional[builtins.str]:
        '''With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image.

        Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence_var DataAkamaiImagingPolicyImage#confidence_var}
        '''
        result = self._values.get("confidence_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any faces in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        '''
        result = self._values.get("fail_gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any faces in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        '''
        result = self._values.get("fail_gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def focus(self) -> typing.Optional[builtins.str]:
        '''Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus DataAkamaiImagingPolicyImage#focus}
        '''
        result = self._values.get("focus")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def focus_var(self) -> typing.Optional[builtins.str]:
        '''Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus_var DataAkamaiImagingPolicyImage#focus_var}
        '''
        result = self._values.get("focus_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the face(s) plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the face(s) plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationFaceCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationFaceCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationFaceCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b93dca81857adeacf84921c8130c201c76ea968efb7fa005a7e1d7b26ffdafad)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationFaceCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c2d8e0b46eb2e8f49afe27054f5809f03122f1e83d11a01b5ce526008ba5d761)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationFaceCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f2a1cdc1c366ddecf23197d08e03528695bf3b81f6bf91b5f3114dc03cd9cefd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a172249c04e5a4ebf6d1f76fa3fb166b6672cec176b51cd167a8c01f50a6385)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f0500afd024aeef9a3065800bc42eb2ef6c0237052a69a9e0c58f15c67e34abf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationFaceCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationFaceCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationFaceCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a4b9696fd54e49c9e8efbb7c93167237e72c7d217fe4cf1cf484903915f0740d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationFaceCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationFaceCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a7123d39ed3996de69761b570f4a6116cd09671d1d092f184cce2e45b6bf1af7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAlgorithm")
    def reset_algorithm(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAlgorithm", []))

    @jsii.member(jsii_name="resetAlgorithmVar")
    def reset_algorithm_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAlgorithmVar", []))

    @jsii.member(jsii_name="resetConfidence")
    def reset_confidence(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetConfidence", []))

    @jsii.member(jsii_name="resetConfidenceVar")
    def reset_confidence_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetConfidenceVar", []))

    @jsii.member(jsii_name="resetFailGravity")
    def reset_fail_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravity", []))

    @jsii.member(jsii_name="resetFailGravityVar")
    def reset_fail_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravityVar", []))

    @jsii.member(jsii_name="resetFocus")
    def reset_focus(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFocus", []))

    @jsii.member(jsii_name="resetFocusVar")
    def reset_focus_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFocusVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="algorithmInput")
    def algorithm_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "algorithmInput"))

    @builtins.property
    @jsii.member(jsii_name="algorithmVarInput")
    def algorithm_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "algorithmVarInput"))

    @builtins.property
    @jsii.member(jsii_name="confidenceInput")
    def confidence_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "confidenceInput"))

    @builtins.property
    @jsii.member(jsii_name="confidenceVarInput")
    def confidence_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "confidenceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityInput")
    def fail_gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityVarInput")
    def fail_gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="focusInput")
    def focus_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "focusInput"))

    @builtins.property
    @jsii.member(jsii_name="focusVarInput")
    def focus_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "focusVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="algorithm")
    def algorithm(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "algorithm"))

    @algorithm.setter
    def algorithm(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0dc3935ecc7ec5521771fb0d0917fe0a7ea4922f6a66f2cc5568d0a6a8c51ab6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "algorithm", value)

    @builtins.property
    @jsii.member(jsii_name="algorithmVar")
    def algorithm_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "algorithmVar"))

    @algorithm_var.setter
    def algorithm_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d3bbc61cdc0cb04cc6e9541af59f8b8158f0360fec583c54eab1d31cab724045)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "algorithmVar", value)

    @builtins.property
    @jsii.member(jsii_name="confidence")
    def confidence(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "confidence"))

    @confidence.setter
    def confidence(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__052ffb58bf8b5ad2a462087f9cf3ca30a735285022271f03cf1d63359e5e593d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "confidence", value)

    @builtins.property
    @jsii.member(jsii_name="confidenceVar")
    def confidence_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "confidenceVar"))

    @confidence_var.setter
    def confidence_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9e3d8ed8e9540f5c5dafefe35d4c0c4157ed56072eda42461327a85a7f3ff384)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "confidenceVar", value)

    @builtins.property
    @jsii.member(jsii_name="failGravity")
    def fail_gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravity"))

    @fail_gravity.setter
    def fail_gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c1d02cc4ecf2a2553e624b1f4f7ea0e40abd663ffe692be4e7a7aea6863ae1d9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravity", value)

    @builtins.property
    @jsii.member(jsii_name="failGravityVar")
    def fail_gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravityVar"))

    @fail_gravity_var.setter
    def fail_gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ad8608914bf5e43a0132354dbc1a30e46d8560edc96a4308f3dce2fa41eab0d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="focus")
    def focus(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "focus"))

    @focus.setter
    def focus(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__808ef14169cc21d4c4f7a86aae838bfad600bd25b400476fc1de7ff3efc71170)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "focus", value)

    @builtins.property
    @jsii.member(jsii_name="focusVar")
    def focus_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "focusVar"))

    @focus_var.setter
    def focus_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b7d8e6ae76fd75cd201b174c10e3829baf3c2dce2f8a74c5cdccdcd331f81817)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "focusVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c485a691d89c61325febbc16a32b26d27d4c4c3f53fe033b0ce8c69e0939111a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3c88c82caf74eef969a67b0eaa2eafde315943a0ba470407b7a6bf87048ee8ec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__90a97a57ab4913132b0e8318c3f71e898ce8730317c22ffd6a668505d6fca051)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__470b9776b7699e5c08f6933d935c21f593a2057c49b3140421008538fe7e14c6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4c43a329b001a100abdc407e7736d375d2b3507721d682dedbce07a559626657)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__008f75e46cc90f484616467756a40ea22f582dfef9ce089336978853e995446a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__baf7fe6cbc7fa12072b6beedcb19209a9ad464d99389292af3fc41a110104aba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3e9b8783d4090409d59db5d0d1b349f58b81b1b284be472803bbc21dbb0fb673)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1934c51cee8f53263242fcb02d4bc5cfacb30012468a7b74d03fd8cdf7526bfe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ae2709bf165cdc8bcee476cb7e2169e5605e2a21bcaec54b78786fb8dcf0927d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationFaceCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationFaceCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationFaceCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__87ea66f3d648249c88071dbf6b431fe3f1c9f06044d19398f65276f5c660b534)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationFeatureCrop",
    jsii_struct_bases=[],
    name_mapping={
        "fail_gravity": "failGravity",
        "fail_gravity_var": "failGravityVar",
        "feature_radius": "featureRadius",
        "feature_radius_var": "featureRadiusVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "max_features": "maxFeatures",
        "max_features_var": "maxFeaturesVar",
        "min_feature_quality": "minFeatureQuality",
        "min_feature_quality_var": "minFeatureQualityVar",
        "padding": "padding",
        "padding_var": "paddingVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationFeatureCrop:
    def __init__(
        self,
        *,
        fail_gravity: typing.Optional[builtins.str] = None,
        fail_gravity_var: typing.Optional[builtins.str] = None,
        feature_radius: typing.Optional[builtins.str] = None,
        feature_radius_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        max_features: typing.Optional[builtins.str] = None,
        max_features_var: typing.Optional[builtins.str] = None,
        min_feature_quality: typing.Optional[builtins.str] = None,
        min_feature_quality_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fail_gravity: Controls placement of the crop if Image and Video Manager does not detect any features in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        :param fail_gravity_var: Controls placement of the crop if Image and Video Manager does not detect any features in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        :param feature_radius: The size in pixels of the important features to search for. If identified, two features never appear closer together than this value, ``8.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius DataAkamaiImagingPolicyImage#feature_radius}
        :param feature_radius_var: The size in pixels of the important features to search for. If identified, two features never appear closer together than this value, ``8.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius_var DataAkamaiImagingPolicyImage#feature_radius_var}
        :param gravity: Controls placement of the crop. Directions are relative to the region of interest plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Controls placement of the crop. Directions are relative to the region of interest plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param max_features: The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features DataAkamaiImagingPolicyImage#max_features}
        :param max_features_var: The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features_var DataAkamaiImagingPolicyImage#max_features_var}
        :param min_feature_quality: Determines the minimum quality level of the feature identified. To consider a feature important, the feature needs to surpass this value. Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality DataAkamaiImagingPolicyImage#min_feature_quality}
        :param min_feature_quality_var: Determines the minimum quality level of the feature identified. To consider a feature important, the feature needs to surpass this value. Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality_var DataAkamaiImagingPolicyImage#min_feature_quality_var}
        :param padding: Adds space around the region of interest. The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: Adds space around the region of interest. The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        :param style: Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d4177368de1abdeefd5d5bf3fc7b3e6dea5d3be9f0ae44005cfa6b9350ffe5a6)
            check_type(argname="argument fail_gravity", value=fail_gravity, expected_type=type_hints["fail_gravity"])
            check_type(argname="argument fail_gravity_var", value=fail_gravity_var, expected_type=type_hints["fail_gravity_var"])
            check_type(argname="argument feature_radius", value=feature_radius, expected_type=type_hints["feature_radius"])
            check_type(argname="argument feature_radius_var", value=feature_radius_var, expected_type=type_hints["feature_radius_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument max_features", value=max_features, expected_type=type_hints["max_features"])
            check_type(argname="argument max_features_var", value=max_features_var, expected_type=type_hints["max_features_var"])
            check_type(argname="argument min_feature_quality", value=min_feature_quality, expected_type=type_hints["min_feature_quality"])
            check_type(argname="argument min_feature_quality_var", value=min_feature_quality_var, expected_type=type_hints["min_feature_quality_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fail_gravity is not None:
            self._values["fail_gravity"] = fail_gravity
        if fail_gravity_var is not None:
            self._values["fail_gravity_var"] = fail_gravity_var
        if feature_radius is not None:
            self._values["feature_radius"] = feature_radius
        if feature_radius_var is not None:
            self._values["feature_radius_var"] = feature_radius_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if max_features is not None:
            self._values["max_features"] = max_features
        if max_features_var is not None:
            self._values["max_features_var"] = max_features_var
        if min_feature_quality is not None:
            self._values["min_feature_quality"] = min_feature_quality
        if min_feature_quality_var is not None:
            self._values["min_feature_quality_var"] = min_feature_quality_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def fail_gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any features in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        '''
        result = self._values.get("fail_gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any features in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        '''
        result = self._values.get("fail_gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feature_radius(self) -> typing.Optional[builtins.str]:
        '''The size in pixels of the important features to search for.

        If identified, two features never appear closer together than this value, ``8.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius DataAkamaiImagingPolicyImage#feature_radius}
        '''
        result = self._values.get("feature_radius")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feature_radius_var(self) -> typing.Optional[builtins.str]:
        '''The size in pixels of the important features to search for.

        If identified, two features never appear closer together than this value, ``8.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius_var DataAkamaiImagingPolicyImage#feature_radius_var}
        '''
        result = self._values.get("feature_radius_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the region of interest plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the region of interest plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def max_features(self) -> typing.Optional[builtins.str]:
        '''The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features DataAkamaiImagingPolicyImage#max_features}
        '''
        result = self._values.get("max_features")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def max_features_var(self) -> typing.Optional[builtins.str]:
        '''The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features_var DataAkamaiImagingPolicyImage#max_features_var}
        '''
        result = self._values.get("max_features_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def min_feature_quality(self) -> typing.Optional[builtins.str]:
        '''Determines the minimum quality level of the feature identified.

        To consider a feature important, the feature needs to surpass this value.  Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality DataAkamaiImagingPolicyImage#min_feature_quality}
        '''
        result = self._values.get("min_feature_quality")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def min_feature_quality_var(self) -> typing.Optional[builtins.str]:
        '''Determines the minimum quality level of the feature identified.

        To consider a feature important, the feature needs to surpass this value.  Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality_var DataAkamaiImagingPolicyImage#min_feature_quality_var}
        '''
        result = self._values.get("min_feature_quality_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''Adds space around the region of interest.

        The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''Adds space around the region of interest.

        The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationFeatureCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationFeatureCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationFeatureCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__12d944bf74f4fc88dde408c58db93223fff1820bb368da8581046282225682c4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationFeatureCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__59d850bb70f368c45a3776773c571c70f80238dcfd864ac4a3b13cb8a4f77d3f)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationFeatureCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa9a8777b558d8544aa381f9e3e775eed48e7a393403623aa7d605065545e9ab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d73719819c4f600699451dcb6b445b57e72471369640c927170f1b27a744ef3c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__028b3487fcba03de203a8a2fc3089d5f032e8e962997a0d04a2e83ff55dc9be3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationFeatureCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationFeatureCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationFeatureCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6a564ec80eb64e02c37b513ade247522eb77d31ff9846f2c06653be2acd08c7f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationFeatureCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationFeatureCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d9066fd9264da4a1ea6671e7c19bfba2d1a6c32366d4fc75646c0c0ad8c98f8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetFailGravity")
    def reset_fail_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravity", []))

    @jsii.member(jsii_name="resetFailGravityVar")
    def reset_fail_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravityVar", []))

    @jsii.member(jsii_name="resetFeatureRadius")
    def reset_feature_radius(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureRadius", []))

    @jsii.member(jsii_name="resetFeatureRadiusVar")
    def reset_feature_radius_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureRadiusVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetMaxFeatures")
    def reset_max_features(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxFeatures", []))

    @jsii.member(jsii_name="resetMaxFeaturesVar")
    def reset_max_features_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxFeaturesVar", []))

    @jsii.member(jsii_name="resetMinFeatureQuality")
    def reset_min_feature_quality(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMinFeatureQuality", []))

    @jsii.member(jsii_name="resetMinFeatureQualityVar")
    def reset_min_feature_quality_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMinFeatureQualityVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="failGravityInput")
    def fail_gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityVarInput")
    def fail_gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featureRadiusInput")
    def feature_radius_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featureRadiusInput"))

    @builtins.property
    @jsii.member(jsii_name="featureRadiusVarInput")
    def feature_radius_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featureRadiusVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesInput")
    def max_features_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "maxFeaturesInput"))

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesVarInput")
    def max_features_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "maxFeaturesVarInput"))

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityInput")
    def min_feature_quality_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "minFeatureQualityInput"))

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityVarInput")
    def min_feature_quality_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "minFeatureQualityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravity")
    def fail_gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravity"))

    @fail_gravity.setter
    def fail_gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eac129c59bb9cd7be4a3557395e09221308b99897ef822f21dd49275262aafa1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravity", value)

    @builtins.property
    @jsii.member(jsii_name="failGravityVar")
    def fail_gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravityVar"))

    @fail_gravity_var.setter
    def fail_gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__35edb366470207dff397d05ab599906957509faa1e1b653330fa4e56919c6873)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="featureRadius")
    def feature_radius(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featureRadius"))

    @feature_radius.setter
    def feature_radius(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9bbed6be0586dfdd9bce52f935e621d81342ddf2b6a2b5eac18e5c858e5cd7c6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featureRadius", value)

    @builtins.property
    @jsii.member(jsii_name="featureRadiusVar")
    def feature_radius_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featureRadiusVar"))

    @feature_radius_var.setter
    def feature_radius_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a2406c098da679b5ff7d1d81f69324ebccb1b49b67e4488c73785229dfc39bfe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featureRadiusVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ee9dfce857bd3cad4ac4bdadf06d8a36d0b64404094d43b5f51f90c916a79e78)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9197fc3ea9117937bd320c045bf31038d155aaccffc63369bde6892f87db1501)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__79e68085d7a061d522cf8b8d1d0943e0c79fae7b4041c43df6b5e255c50fae92)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3f35b6e70b43ad86343aa815f67c6660eedfa488b87ce71e2a1ef07b0de20acb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="maxFeatures")
    def max_features(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "maxFeatures"))

    @max_features.setter
    def max_features(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7156076d8991137e686ac2a243b2701b41ca7c2c3444db5fd9fdaab438938a90)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "maxFeatures", value)

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesVar")
    def max_features_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "maxFeaturesVar"))

    @max_features_var.setter
    def max_features_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__52ccd8761bc696a2770e2c0096367e4ba40d35da6da6257da29a263d5ab1bdec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "maxFeaturesVar", value)

    @builtins.property
    @jsii.member(jsii_name="minFeatureQuality")
    def min_feature_quality(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "minFeatureQuality"))

    @min_feature_quality.setter
    def min_feature_quality(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__69d564900a3ee5768e39b558c826db6f52aaa3ce243ca8ee80df150766e1f062)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "minFeatureQuality", value)

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityVar")
    def min_feature_quality_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "minFeatureQualityVar"))

    @min_feature_quality_var.setter
    def min_feature_quality_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f127bd234563e5ef4c754f62cb6a8106332d8e22f25fd698866441f5d1f14e25)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "minFeatureQualityVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ca022ff2da9947bb3008561b2996059809588c1de13d139d4d9781f11a7f45b6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7480b6d06b8673722b218f897335b25c17bdc5420f8beb794195a71cca893c69)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__985a36b572b827c7336c05929cdef719873d9719f4d5ed7eb6e975a117db6a43)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7dc00fe4504e45050f24b51d4337eab120519f654824876a03536cb755658355)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e10c8431b019a4c5732ee43d62ac9615e631d40baea1f2c93ff2ef241368dea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ace7e9526a06a0fc2aa261622bdaacdaff5b40e73f84726fe25943b3cc30a2ea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationFeatureCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationFeatureCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationFeatureCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7b35cfcfa06c7570612f5bd4af22fcacb17e3e470fd51266ea5241255708f33a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationFitAndFill",
    jsii_struct_bases=[],
    name_mapping={
        "fill_transformation": "fillTransformation",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationFitAndFill:
    def __init__(
        self,
        *,
        fill_transformation: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationFitAndFillFillTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fill_transformation: fill_transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_transformation DataAkamaiImagingPolicyImage#fill_transformation}
        :param height: The height value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The width value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(fill_transformation, dict):
            fill_transformation = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationFitAndFillFillTransformation(**fill_transformation)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3b19686a3d230adb6cff92c7205489a84e2d476acb32d008e457a79a73788f5d)
            check_type(argname="argument fill_transformation", value=fill_transformation, expected_type=type_hints["fill_transformation"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fill_transformation is not None:
            self._values["fill_transformation"] = fill_transformation
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def fill_transformation(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationFitAndFillFillTransformation"]:
        '''fill_transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_transformation DataAkamaiImagingPolicyImage#fill_transformation}
        '''
        result = self._values.get("fill_transformation")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationFitAndFillFillTransformation"], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationFitAndFill(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationFitAndFillFillTransformation",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationFitAndFillFillTransformation:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationFitAndFillFillTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationFitAndFillFillTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationFitAndFillFillTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7106e766d400c9b52395b6c49f08bffb643f53c47d4d61ee5d0617a5c67e21dd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationFitAndFillFillTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationFitAndFillFillTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationFitAndFillFillTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0f654565cc729dbd22e6f964d5ea3973f429b78ae82520134332542c74821d2b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationFitAndFillList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationFitAndFillList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ce0dda1aba923e5c01dbedc685b9ca983beb5bcdab36bf7c0d2fadadd4f8e39)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationFitAndFillOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f14caafdc3e17b4f153ddcbb2adfa773d0a2cd2ab354aa82058457e97777a869)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationFitAndFillOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ef5e330465764beb40198c3aba3aecbdc55310632472249bd89b0dc9d27078d5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__48715bd34ec16c92b6cd1119de7fc9494c7c38716d1769f6492494245fd3c2d2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f01ec2b3139f5d917f9d8f659f140c7915d90e51a598531a118627e1e663930c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationFitAndFill]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationFitAndFill]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationFitAndFill]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ca6a16a865269cc403a3d90378c741ee820f8067aae426478c3a461b6087bef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationFitAndFillOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationFitAndFillOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__26b716e5c2d4265ffaa7e0f197426e609ceb2bf6c927550ff21b04628025d06b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putFillTransformation")
    def put_fill_transformation(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationFitAndFillFillTransformation()

        return typing.cast(None, jsii.invoke(self, "putFillTransformation", [value]))

    @jsii.member(jsii_name="resetFillTransformation")
    def reset_fill_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFillTransformation", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="fillTransformation")
    def fill_transformation(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationFitAndFillFillTransformationOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationFitAndFillFillTransformationOutputReference, jsii.get(self, "fillTransformation"))

    @builtins.property
    @jsii.member(jsii_name="fillTransformationInput")
    def fill_transformation_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationFitAndFillFillTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationFitAndFillFillTransformation], jsii.get(self, "fillTransformationInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4f116162c59dbb41f4493e23752ab65ecc09c8df0825beb3d179e0493cc9e133)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a9d9000c8b9e93c0d2080c06659cd8d51d75c9743ac23d542d39463a55387762)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d28b6958482df79a25e26da4bf4ce2179d2e5bb6ec8fdb53d2ad05f43b68909)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e7c1a8010fa3b52d202ac723848df4c107670571ed9080d80c13ae17cce45568)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationFitAndFill]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationFitAndFill]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationFitAndFill]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c1bcf3364d6706332d7cb9bf5a74e82ea23111c7c28162003d206f567c35fa5c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationGoop",
    jsii_struct_bases=[],
    name_mapping={
        "chaos": "chaos",
        "chaos_var": "chaosVar",
        "density": "density",
        "density_var": "densityVar",
        "power": "power",
        "power_var": "powerVar",
        "seed": "seed",
        "seed_var": "seedVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationGoop:
    def __init__(
        self,
        *,
        chaos: typing.Optional[builtins.str] = None,
        chaos_var: typing.Optional[builtins.str] = None,
        density: typing.Optional[builtins.str] = None,
        density_var: typing.Optional[builtins.str] = None,
        power: typing.Optional[builtins.str] = None,
        power_var: typing.Optional[builtins.str] = None,
        seed: typing.Optional[builtins.str] = None,
        seed_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param chaos: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        :param chaos_var: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        :param density: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        :param density_var: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        :param power: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        :param power_var: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        :param seed: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        :param seed_var: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__326ee12f831079005a917a5f63619fb3018a56f43630e7da089285d1a74fac0e)
            check_type(argname="argument chaos", value=chaos, expected_type=type_hints["chaos"])
            check_type(argname="argument chaos_var", value=chaos_var, expected_type=type_hints["chaos_var"])
            check_type(argname="argument density", value=density, expected_type=type_hints["density"])
            check_type(argname="argument density_var", value=density_var, expected_type=type_hints["density_var"])
            check_type(argname="argument power", value=power, expected_type=type_hints["power"])
            check_type(argname="argument power_var", value=power_var, expected_type=type_hints["power_var"])
            check_type(argname="argument seed", value=seed, expected_type=type_hints["seed"])
            check_type(argname="argument seed_var", value=seed_var, expected_type=type_hints["seed_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if chaos is not None:
            self._values["chaos"] = chaos
        if chaos_var is not None:
            self._values["chaos_var"] = chaos_var
        if density is not None:
            self._values["density"] = density
        if density_var is not None:
            self._values["density_var"] = density_var
        if power is not None:
            self._values["power"] = power
        if power_var is not None:
            self._values["power_var"] = power_var
        if seed is not None:
            self._values["seed"] = seed
        if seed_var is not None:
            self._values["seed_var"] = seed_var

    @builtins.property
    def chaos(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        '''
        result = self._values.get("chaos")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def chaos_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        '''
        result = self._values.get("chaos_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        '''
        result = self._values.get("density")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density_var(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        '''
        result = self._values.get("density_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        '''
        result = self._values.get("power")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power_var(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        '''
        result = self._values.get("power_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        '''
        result = self._values.get("seed")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed_var(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        result = self._values.get("seed_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationGoop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationGoopList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationGoopList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c9f2cdb1b1463e222825d0593e86722e389a930f0439256369a2c3d1e294dd3d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationGoopOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__855bb48871326d66d9958e4106e40aa665c77f81ae0fd6fa9bb8dc03d6f43778)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationGoopOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f85a0de7fa8b304fed1b3904d0bbe68b4a998f1031cc2ced3e5c92b082ed7c3d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f821293fd56788083d7cbe82ffc8e801e3a9b69e1191b0cbf7581aa4976fc37d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__71e4fcef63ba078b2205eddd67808764a169891a4c380321d04c6dbc0351397f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationGoop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationGoop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__faf48d968dbfa05a9f23ab8e049d44ba81367bf0fdf4daa5d86ad799297a14a6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationGoopOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationGoopOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c0b9dfe226469a7d3c80de34cd338a578d4f65834ba02a04d3db489ba9626bfa)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetChaos")
    def reset_chaos(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaos", []))

    @jsii.member(jsii_name="resetChaosVar")
    def reset_chaos_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaosVar", []))

    @jsii.member(jsii_name="resetDensity")
    def reset_density(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensity", []))

    @jsii.member(jsii_name="resetDensityVar")
    def reset_density_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensityVar", []))

    @jsii.member(jsii_name="resetPower")
    def reset_power(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPower", []))

    @jsii.member(jsii_name="resetPowerVar")
    def reset_power_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPowerVar", []))

    @jsii.member(jsii_name="resetSeed")
    def reset_seed(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeed", []))

    @jsii.member(jsii_name="resetSeedVar")
    def reset_seed_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeedVar", []))

    @builtins.property
    @jsii.member(jsii_name="chaosInput")
    def chaos_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosInput"))

    @builtins.property
    @jsii.member(jsii_name="chaosVarInput")
    def chaos_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosVarInput"))

    @builtins.property
    @jsii.member(jsii_name="densityInput")
    def density_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityInput"))

    @builtins.property
    @jsii.member(jsii_name="densityVarInput")
    def density_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="powerInput")
    def power_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerInput"))

    @builtins.property
    @jsii.member(jsii_name="powerVarInput")
    def power_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerVarInput"))

    @builtins.property
    @jsii.member(jsii_name="seedInput")
    def seed_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedInput"))

    @builtins.property
    @jsii.member(jsii_name="seedVarInput")
    def seed_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedVarInput"))

    @builtins.property
    @jsii.member(jsii_name="chaos")
    def chaos(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaos"))

    @chaos.setter
    def chaos(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fb14fca0975943badaaf0b16a9fc2d06d7c3f97eeb096be2f2ad50e78c075cb4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaos", value)

    @builtins.property
    @jsii.member(jsii_name="chaosVar")
    def chaos_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaosVar"))

    @chaos_var.setter
    def chaos_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f0c1a2b1a8ddf3d7a656ab0a67c3a11225e63d00e7e837a5d8cb335c69946a30)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaosVar", value)

    @builtins.property
    @jsii.member(jsii_name="density")
    def density(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "density"))

    @density.setter
    def density(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9c013ac013369062fef7e9918e025db6485e03d5236c4fe9e6afa9ac222420de)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "density", value)

    @builtins.property
    @jsii.member(jsii_name="densityVar")
    def density_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "densityVar"))

    @density_var.setter
    def density_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__754e0b27df5c641740b9bde91675c0a6d67636a457d0ae4b86fb50b1e55dedc4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "densityVar", value)

    @builtins.property
    @jsii.member(jsii_name="power")
    def power(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "power"))

    @power.setter
    def power(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e95507e2c3e86d410322c3c68aa93b5600604d992185f6763a8672cfc5e0a4fc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "power", value)

    @builtins.property
    @jsii.member(jsii_name="powerVar")
    def power_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "powerVar"))

    @power_var.setter
    def power_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__52a367bfc02cdef5e626c89ed9df3899ba0d819ec800c9f98a2e7b5d707d3386)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "powerVar", value)

    @builtins.property
    @jsii.member(jsii_name="seed")
    def seed(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seed"))

    @seed.setter
    def seed(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4257fffbf8b4b5bee3c75407fb15841e77f9233a56866a3a134d0d02d5c9baa5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seed", value)

    @builtins.property
    @jsii.member(jsii_name="seedVar")
    def seed_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seedVar"))

    @seed_var.setter
    def seed_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5812ed77b2ece2dd43095357e79f0bfb0a777e17fb64d224965f8c7f5af17628)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seedVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationGoop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationGoop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationGoop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e629c7f0c4f79db28e43412e3f2b9e0cfb4abb73941ee85b51e81323eeedc528)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationGrayscale",
    jsii_struct_bases=[],
    name_mapping={"type": "type", "type_var": "typeVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationGrayscale:
    def __init__(
        self,
        *,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param type: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ff542d095f9f800a8f7c5c4c22001a3fffd1db23736754b488da81715124ee76)
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationGrayscale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationGrayscaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationGrayscaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5884cb00f0bbb5d4d6506986b1b63fdb61a9855a9618f40eb583fc0215eafd0f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationGrayscaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3559ed8be9c3d49a745d85db4a87a4c5fd8742b24db5dedcd4f7dcebeead0c9b)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationGrayscaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__58f0b06e0f938811b8af79e2809ddcbcc6c7e87321b3b9ff45e861a0050ae2e4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__28641004d235dcd41c3ebed5d29f654419acc7b7bda46846811936fc146f354e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c27701729d39b0aa7bfcc662c4ebc9f25be472a467e9a84d4ba3febfe7cb4e11)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationGrayscale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationGrayscale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c928fdefafe76c62a1a4f43abd1ee479fb169dccc4d270db4cf008a6a6e7cc06)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationGrayscaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationGrayscaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ce8e18f71373e155b3215ae4d34734bdc5d3406ced522052e03cabdf881d0cd6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1ebca6b35c92ba3c0c103c1eccc6988b8d84ee26e2ba2f4ea58e9a3ebd1c4d87)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9381d60a1cafa0f0a3bb03eee2c77b2ff9487e705b5b9ec2c782b505b0dc1f15)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationGrayscale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationGrayscale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationGrayscale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__324c1ce034aad98c86710cc8f563255025392f7eaf9497f6775dd1f3f973a027)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationHsl",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "lightness": "lightness",
        "lightness_var": "lightnessVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationHsl:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness: typing.Optional[builtins.str] = None,
        lightness_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        :param lightness_var: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__124c203f73170d057bea5ff792db3fb9d99816bb10879e23bcd2568a71d33b48)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness", value=lightness, expected_type=type_hints["lightness"])
            check_type(argname="argument lightness_var", value=lightness_var, expected_type=type_hints["lightness_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness is not None:
            self._values["lightness"] = lightness
        if lightness_var is not None:
            self._values["lightness_var"] = lightness_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        '''
        result = self._values.get("lightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        '''
        result = self._values.get("lightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationHsl(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationHslList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationHslList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d1e7e4978380efcb0035b82c8532078f1f19a0cb558c6fe0e25ac0d0a20c5368)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationHslOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1639d0d358ed0e00c0c8eb462b59237453ad8aff4d9c0cfd8d88273198c2ac7e)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationHslOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a184ab11a87f647e6cfc560012ef1f52268ad33748dc8e7450dfef1ceffc79ab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1138b0c6b03a16923567708c89ed81ea00be43cf826cb32cbff0ddb20f47fd72)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__95138a3591e260551196d8df58eaf10440b5652084446f3f5e15434ac9874044)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationHsl]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationHsl]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__02cd01a26b261361e1ed312882f3677826a898ee6fc1d0ead470084b467b1081)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationHslOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationHslOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac4df095c921659ef51b62810339ccb438734bf42d83c08b44e986658be0256c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightness")
    def reset_lightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightness", []))

    @jsii.member(jsii_name="resetLightnessVar")
    def reset_lightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessInput")
    def lightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessVarInput")
    def lightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f0f8f652a297a08480a61a18d96cb378705d4bab305663e127a75ddc3c566f50)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__08217b7497faaa73255c9be284f84c61e16761f53020d24186107b2cae7a4750)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightness")
    def lightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightness"))

    @lightness.setter
    def lightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f32f386f89e632c08cfdff4321fc436d90bef5cbe5b35aa5946e9935c417003d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightness", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessVar")
    def lightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessVar"))

    @lightness_var.setter
    def lightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__db9175143d5cf5796ba70c8006be26fa6964b88e84b655a2fd582403bd90ee88)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e459d43730b4136d9d0dbe7e449bc04edd7f03b5ed4a631a6c6d241bd0e77c07)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d63a5eae389f8760e35e6c478a5ab6f3a553e438c60cacfdfad36247ac95b5fc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationHsl]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationHsl]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationHsl]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__530bfea7fc7eb83f7036800712a8e95fa3b94b70370676c0884aa6a2bed45bff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationHsv",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationHsv:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        :param value: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c88861665a19e53645ba9d41ce6abd1acabb5b5b938d367734d52d4d177e165f)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationHsv(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationHsvList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationHsvList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3d874c2a3aa1c7d56225d80091ca9ef63b0c9cac9d90109e196b2545900b46da)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationHsvOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f1d110fe8f146757b134d88cea6a7c687c7f36052647ea3770cc3501bd707f37)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationHsvOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__02cedc613fdbc7287edb72c4b4ad0cd1b0dfc4db63b56ed3c096f4dcba805dc7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cae0c2e97426cfc0a5f05be48db2d74b2a7f1fa7e065bb624cdad1e0d5f073a6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e2f85935b393b6749dadae3fe08ed779397974b2e5df4ca5b06653e81eb08e63)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationHsv]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationHsv]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__740e57c30b158fb53062878f6f568d309c62afd218d7e81d890789c41b80ccfc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationHsvOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationHsvOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c1722e249faf4b1e9610afdba917aa8241b9abae107d6cdf9f1e2841f57bf084)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dabab972e3c55e65ad650e8f13d411dffe0a51c46e4cebb7fe5c21d1a519026a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__200baebc4ee1d9c202687500592a17dddc699fc08c81e45a9a1d3aae6f68c0c8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d1d02d462556275ebb7b8072eee8179f0b38389c10c2b4358ad358f713f5175a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6af54c855adb69e64d1f0f9629428982d2481b523d6eeb562c5e95ca638cd284)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__34de48a6ddeb72a296435a3aaebcf76a2203e1a2c1270be397b5f1ed1d8821f5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f933e8b06ff893e29e6f464e6d14775f96a124756d77fd15d2f7de1fe0f48345)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationHsv]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationHsv]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationHsv]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5d03438b631a26dee068e7b0cb0128b60313a4446681e10bd62f3e63b7db6e05)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfDimension",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "dimension": "dimension",
        "dimension_var": "dimensionVar",
        "equal": "equal",
        "greater_than": "greaterThan",
        "less_than": "lessThan",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfDimension:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfDimensionDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        dimension: typing.Optional[builtins.str] = None,
        dimension_var: typing.Optional[builtins.str] = None,
        equal: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfDimensionEqual", typing.Dict[builtins.str, typing.Any]]] = None,
        greater_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfDimensionGreaterThan", typing.Dict[builtins.str, typing.Any]]] = None,
        less_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfDimensionLessThan", typing.Dict[builtins.str, typing.Any]]] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param dimension: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        :param dimension_var: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        :param equal: equal block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        :param greater_than: greater_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        :param less_than: less_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        :param value: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfDimensionDefault(**default)
        if isinstance(equal, dict):
            equal = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfDimensionEqual(**equal)
        if isinstance(greater_than, dict):
            greater_than = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfDimensionGreaterThan(**greater_than)
        if isinstance(less_than, dict):
            less_than = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfDimensionLessThan(**less_than)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a74daf4c499d37f2c052dd84e43ec834a900005a52fe4814fd633295f556bba)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument dimension", value=dimension, expected_type=type_hints["dimension"])
            check_type(argname="argument dimension_var", value=dimension_var, expected_type=type_hints["dimension_var"])
            check_type(argname="argument equal", value=equal, expected_type=type_hints["equal"])
            check_type(argname="argument greater_than", value=greater_than, expected_type=type_hints["greater_than"])
            check_type(argname="argument less_than", value=less_than, expected_type=type_hints["less_than"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if dimension is not None:
            self._values["dimension"] = dimension
        if dimension_var is not None:
            self._values["dimension_var"] = dimension_var
        if equal is not None:
            self._values["equal"] = equal
        if greater_than is not None:
            self._values["greater_than"] = greater_than
        if less_than is not None:
            self._values["less_than"] = less_than
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfDimensionDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfDimensionDefault"], result)

    @builtins.property
    def dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        '''
        result = self._values.get("dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        '''
        result = self._values.get("dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def equal(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfDimensionEqual"]:
        '''equal block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        '''
        result = self._values.get("equal")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfDimensionEqual"], result)

    @builtins.property
    def greater_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfDimensionGreaterThan"]:
        '''greater_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        '''
        result = self._values.get("greater_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfDimensionGreaterThan"], result)

    @builtins.property
    def less_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfDimensionLessThan"]:
        '''less_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        '''
        result = self._values.get("less_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfDimensionLessThan"], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfDimension(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfDimensionDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfDimensionDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfDimensionDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfDimensionDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfDimensionDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b189c31c362f4819e08c8e97f674e46f6e332fc4a26a9b96861f444971645a40)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfDimensionDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfDimensionDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c80ba3a079b1bc84c0a54c2585bb479da6539a1f1dbdc14bfc4c63e89b1fb7b4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfDimensionEqual",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfDimensionEqual:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfDimensionEqual(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfDimensionEqualOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfDimensionEqualOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0259dbac1b457b3235054fe3d59e95d9d61ea527fc7b30a74e76eaeb482edd2c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfDimensionEqual], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfDimensionEqual],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f54868a0afdd517019414820d7127da8469d75cf6c66897db941c4135d537f45)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfDimensionGreaterThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfDimensionGreaterThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfDimensionGreaterThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfDimensionGreaterThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfDimensionGreaterThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ffc3b866fe9791950d17ee1860df3e23e38a7f984ad0958aa7662dfb9676cf61)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfDimensionGreaterThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfDimensionGreaterThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0eea212ea479fbee791d69c368e54c998e383475652f892c654d936490d5fdee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfDimensionLessThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfDimensionLessThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfDimensionLessThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfDimensionLessThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfDimensionLessThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e45af4331987e8b1cb3fcfa736e743bd32ae5d899911bdbf7b65e3bbb69cbad)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfDimensionLessThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfDimensionLessThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2874327acba489539cc0c528e7655b3e5a2b27ee042feb8edf3bebeafe1c44d0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfDimensionList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfDimensionList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__934e48b10947ad489f2b8faedd9c6ae9447125550e4068fa7ad0ea5cc9ed5187)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfDimensionOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__868b22854d59f10f2a069025e7968ffb1d344ddce0e2df9c907736cc74cb95af)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfDimensionOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1db820d146801ac67b57ac67094bac12c65e95ec78083218276f9ad1c619ed2f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e3a98a5ed096400916e63b02ed045cecbd3921edd42f0ccb9c6b7b2e8371e118)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__34482feb338c2037ad96b04bc9a590c03edb1ad809cd75e4a1b5470d10c008e6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfDimension]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfDimension]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__79674984fbd6298029e3ef55adb6447bfbefdce01cdfbcb5cd391609f9965707)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfDimensionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfDimensionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__563f7dd4490ad07511d2ad77c7aa44d475569908b095c65737028cb21a3d8621)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfDimensionDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putEqual")
    def put_equal(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfDimensionEqual()

        return typing.cast(None, jsii.invoke(self, "putEqual", [value]))

    @jsii.member(jsii_name="putGreaterThan")
    def put_greater_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfDimensionGreaterThan()

        return typing.cast(None, jsii.invoke(self, "putGreaterThan", [value]))

    @jsii.member(jsii_name="putLessThan")
    def put_less_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfDimensionLessThan()

        return typing.cast(None, jsii.invoke(self, "putLessThan", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetDimension")
    def reset_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimension", []))

    @jsii.member(jsii_name="resetDimensionVar")
    def reset_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimensionVar", []))

    @jsii.member(jsii_name="resetEqual")
    def reset_equal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEqual", []))

    @jsii.member(jsii_name="resetGreaterThan")
    def reset_greater_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGreaterThan", []))

    @jsii.member(jsii_name="resetLessThan")
    def reset_less_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLessThan", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfDimensionDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfDimensionDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="equal")
    def equal(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfDimensionEqualOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfDimensionEqualOutputReference, jsii.get(self, "equal"))

    @builtins.property
    @jsii.member(jsii_name="greaterThan")
    def greater_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfDimensionGreaterThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfDimensionGreaterThanOutputReference, jsii.get(self, "greaterThan"))

    @builtins.property
    @jsii.member(jsii_name="lessThan")
    def less_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfDimensionLessThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfDimensionLessThanOutputReference, jsii.get(self, "lessThan"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfDimensionDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionInput")
    def dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionVarInput")
    def dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="equalInput")
    def equal_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfDimensionEqual], jsii.get(self, "equalInput"))

    @builtins.property
    @jsii.member(jsii_name="greaterThanInput")
    def greater_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfDimensionGreaterThan], jsii.get(self, "greaterThanInput"))

    @builtins.property
    @jsii.member(jsii_name="lessThanInput")
    def less_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfDimensionLessThan], jsii.get(self, "lessThanInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="dimension")
    def dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimension"))

    @dimension.setter
    def dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1c01e865ceb65292a472dd9e8258ad5dc837b024ec5da6f88497da7abffbc4e1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimension", value)

    @builtins.property
    @jsii.member(jsii_name="dimensionVar")
    def dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimensionVar"))

    @dimension_var.setter
    def dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fdcaba227e148fd5c28bc365b51ad523e2e80362afc0f619ad0ff951cd671473)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af69e6d8b610ff36f3e28227c49c95f93e9094eacb6d41eb1f5e3a0f36a3d34d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__02b51c57086224790ab8fe94733bd61c934b4a0ea6c48c50fff0a54d4784dcf7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfDimension]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfDimension]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfDimension]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__048c6ff5fb6a3e3fd623870646e307502dfb9b427bd0752e8f1f584c1c81c234)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfOrientation",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "landscape": "landscape",
        "portrait": "portrait",
        "square": "square",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfOrientation:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfOrientationDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        landscape: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfOrientationLandscape", typing.Dict[builtins.str, typing.Any]]] = None,
        portrait: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfOrientationPortrait", typing.Dict[builtins.str, typing.Any]]] = None,
        square: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfOrientationSquare", typing.Dict[builtins.str, typing.Any]]] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param landscape: landscape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        :param portrait: portrait block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        :param square: square block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfOrientationDefault(**default)
        if isinstance(landscape, dict):
            landscape = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfOrientationLandscape(**landscape)
        if isinstance(portrait, dict):
            portrait = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfOrientationPortrait(**portrait)
        if isinstance(square, dict):
            square = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfOrientationSquare(**square)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b85c76bc38955189a5c932da3638aec0e161224ffe6345d98fb34acdf305d5aa)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument landscape", value=landscape, expected_type=type_hints["landscape"])
            check_type(argname="argument portrait", value=portrait, expected_type=type_hints["portrait"])
            check_type(argname="argument square", value=square, expected_type=type_hints["square"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if landscape is not None:
            self._values["landscape"] = landscape
        if portrait is not None:
            self._values["portrait"] = portrait
        if square is not None:
            self._values["square"] = square

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfOrientationDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfOrientationDefault"], result)

    @builtins.property
    def landscape(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfOrientationLandscape"]:
        '''landscape block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        '''
        result = self._values.get("landscape")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfOrientationLandscape"], result)

    @builtins.property
    def portrait(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfOrientationPortrait"]:
        '''portrait block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        '''
        result = self._values.get("portrait")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfOrientationPortrait"], result)

    @builtins.property
    def square(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfOrientationSquare"]:
        '''square block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        result = self._values.get("square")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfOrientationSquare"], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfOrientation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfOrientationDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfOrientationDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfOrientationDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfOrientationDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfOrientationDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4aaf512be3855e525338d98f42a151a269fd6282a725ddd22f20cbe382408730)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfOrientationDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfOrientationDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c6d7a90cce831f67803e50b43abf551eb2b54b5fc78c04474425808a41b4767f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfOrientationLandscape",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfOrientationLandscape:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfOrientationLandscape(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfOrientationLandscapeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfOrientationLandscapeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1acb91f1b713fd51bf0fb2518c404f3ff900c334a1b12df292d113ed9cc59cde)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfOrientationLandscape], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfOrientationLandscape],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c5eb336caf479fc093556b4e57fef349418163b5e0dad5792dce47c0e25e146d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfOrientationList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfOrientationList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6212c4eadf5068a0f4d460e6961a32a28bdb9e98c97addd856e7336756ec6e03)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfOrientationOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__271edd7b64769022cf4fcc161228a3cfbd47e472fdaa4d0d02a59bf5b651e346)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfOrientationOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4d22ec06e0b7402907f6734b54bc2f5fa8c600aa99bda2e740adde8807b41337)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e4ec6b7e9acc0bafee08bb8633a7145ee135c5f9f76bc2df96aa24825552c282)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__28b833a5d17d500d62611044e7c8519b83798b8e2b1094a545b242a9ff3d422e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfOrientation]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfOrientation]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a47e35eed9c8f3b2b821f583eda2bbc4773f71d5f2b5802ee61d5c76c61b67ef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfOrientationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfOrientationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb35e6e2a2c33a87c6a77a84a3be0ef67a13e7de27011bb8aa15d6ac745d752a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfOrientationDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putLandscape")
    def put_landscape(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfOrientationLandscape()

        return typing.cast(None, jsii.invoke(self, "putLandscape", [value]))

    @jsii.member(jsii_name="putPortrait")
    def put_portrait(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfOrientationPortrait()

        return typing.cast(None, jsii.invoke(self, "putPortrait", [value]))

    @jsii.member(jsii_name="putSquare")
    def put_square(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfOrientationSquare()

        return typing.cast(None, jsii.invoke(self, "putSquare", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetLandscape")
    def reset_landscape(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLandscape", []))

    @jsii.member(jsii_name="resetPortrait")
    def reset_portrait(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPortrait", []))

    @jsii.member(jsii_name="resetSquare")
    def reset_square(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSquare", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfOrientationDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfOrientationDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="landscape")
    def landscape(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfOrientationLandscapeOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfOrientationLandscapeOutputReference, jsii.get(self, "landscape"))

    @builtins.property
    @jsii.member(jsii_name="portrait")
    def portrait(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfOrientationPortraitOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfOrientationPortraitOutputReference", jsii.get(self, "portrait"))

    @builtins.property
    @jsii.member(jsii_name="square")
    def square(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfOrientationSquareOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfOrientationSquareOutputReference", jsii.get(self, "square"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfOrientationDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="landscapeInput")
    def landscape_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfOrientationLandscape], jsii.get(self, "landscapeInput"))

    @builtins.property
    @jsii.member(jsii_name="portraitInput")
    def portrait_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfOrientationPortrait"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfOrientationPortrait"], jsii.get(self, "portraitInput"))

    @builtins.property
    @jsii.member(jsii_name="squareInput")
    def square_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfOrientationSquare"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfOrientationSquare"], jsii.get(self, "squareInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfOrientation]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfOrientation]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfOrientation]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c4e49751c5e9639a0f6f0990e60a1445e7f91e9bdd8cecfe4361c232aeaa0b24)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfOrientationPortrait",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfOrientationPortrait:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfOrientationPortrait(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfOrientationPortraitOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfOrientationPortraitOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__34be92edb7fde3484d5ff9198ac75d21c57a0180734865db292b2288bbc1e648)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfOrientationPortrait]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfOrientationPortrait], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfOrientationPortrait],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fcfdf2b312f873122de9e3cff7ccf68f1cf25c2b98baf844b343f2b3cfd0c848)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfOrientationSquare",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfOrientationSquare:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfOrientationSquare(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfOrientationSquareOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfOrientationSquareOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__035f40839cdf830d51a2f290740bbd6669bdff05ea40347d7ed7710cbf4da0a7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfOrientationSquare]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfOrientationSquare], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfOrientationSquare],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a9a0970f431c26396ff55969b65d84afe112f758bcc62889de6c14cca879c499)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationImQuery",
    jsii_struct_bases=[],
    name_mapping={
        "allowed_transformations": "allowedTransformations",
        "query_var": "queryVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationImQuery:
    def __init__(
        self,
        *,
        allowed_transformations: typing.Sequence[builtins.str],
        query_var: builtins.str,
    ) -> None:
        '''
        :param allowed_transformations: Specifies the transformations that can be applied using the query string parameter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allowed_transformations DataAkamaiImagingPolicyImage#allowed_transformations}
        :param query_var: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#query_var DataAkamaiImagingPolicyImage#query_var}.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af3e6d6ab16a413fff10c064eb240b1c7704d03fda0edb51437e06ad0d94450e)
            check_type(argname="argument allowed_transformations", value=allowed_transformations, expected_type=type_hints["allowed_transformations"])
            check_type(argname="argument query_var", value=query_var, expected_type=type_hints["query_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "allowed_transformations": allowed_transformations,
            "query_var": query_var,
        }

    @builtins.property
    def allowed_transformations(self) -> typing.List[builtins.str]:
        '''Specifies the transformations that can be applied using the query string parameter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allowed_transformations DataAkamaiImagingPolicyImage#allowed_transformations}
        '''
        result = self._values.get("allowed_transformations")
        assert result is not None, "Required property 'allowed_transformations' is missing"
        return typing.cast(typing.List[builtins.str], result)

    @builtins.property
    def query_var(self) -> builtins.str:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#query_var DataAkamaiImagingPolicyImage#query_var}.'''
        result = self._values.get("query_var")
        assert result is not None, "Required property 'query_var' is missing"
        return typing.cast(builtins.str, result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationImQuery(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationImQueryList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationImQueryList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a29a1cec1141179982ab300db20f5f1eeb6088c44a5f789d90ee5853b3b125e1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationImQueryOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d8c921029493c88e639c060d895e0700b15217f9eaa77bb195d6e8556cceb7c1)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationImQueryOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dd14a0ea159a576cb6a8535215c6b1bb9b670379e12b96c69f8a53ff33f2ebb8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ffadd6b7c7299203429de15239928bdda386041e7b6608d356383bcc7d61e15)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6872170d300917889aa543e84ca21f71654605c6b14959bef512808687f43ecd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationImQuery]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationImQuery]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationImQuery]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8804ddb0038b3022444f4e6fa1f3506175b15c5bf547a02e901bd64bdbe008b2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationImQueryOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationImQueryOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5c2ce34503ee9bbcf6a8dfeba74867056deb7daba8b0d84112038d0f49b5dc09)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @builtins.property
    @jsii.member(jsii_name="allowedTransformationsInput")
    def allowed_transformations_input(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "allowedTransformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="queryVarInput")
    def query_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "queryVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowedTransformations")
    def allowed_transformations(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "allowedTransformations"))

    @allowed_transformations.setter
    def allowed_transformations(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b1e0be5c8da59ef0ff1bb8b8a9fccc851eb35a50b5b3464adcc84015654ef6b3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowedTransformations", value)

    @builtins.property
    @jsii.member(jsii_name="queryVar")
    def query_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "queryVar"))

    @query_var.setter
    def query_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__56b14a146fa2c1a94ba4a8f33c947cc31d54cb06b8850ec4520a35840fa0a304)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "queryVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationImQuery]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationImQuery]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationImQuery]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__33755416fd5def4764e4c69d697782bd6fe32062d43e94e8fc8b73f137429f7e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationMaxColors",
    jsii_struct_bases=[],
    name_mapping={"colors": "colors", "colors_var": "colorsVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationMaxColors:
    def __init__(
        self,
        *,
        colors: typing.Optional[builtins.str] = None,
        colors_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param colors: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        :param colors_var: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e41049fbba1fc4de52882ba6c559571a2381872e1b3f7540029b10003d3de82d)
            check_type(argname="argument colors", value=colors, expected_type=type_hints["colors"])
            check_type(argname="argument colors_var", value=colors_var, expected_type=type_hints["colors_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if colors is not None:
            self._values["colors"] = colors
        if colors_var is not None:
            self._values["colors_var"] = colors_var

    @builtins.property
    def colors(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        '''
        result = self._values.get("colors")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def colors_var(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        result = self._values.get("colors_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationMaxColors(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationMaxColorsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationMaxColorsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__10be27d2ab45b4db76f028570ef27634e7ed249c35bdf37357c6bee2a760a9e9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationMaxColorsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e5561efb357ae6c34daf4de7ffdda6a86d9cb28b8c21efa57a858a03afabf8d6)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationMaxColorsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__31c9349f944e6eb5cd07b24d4831d074171ab5b5fc5ba151de5981587a8df3fc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a5fca52a6f7e58fdaff8c368ff5219604060d4777aca46fa340637c32b923440)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8beb90f86860f0a3d0a5f1cfa7255c1b424a5a3a0e96929ea090ad9066e349b9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationMaxColors]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationMaxColors]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fd556827344face610ffb567b3ef549c67e8eb365a1169fd453d04d5b404337b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationMaxColorsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationMaxColorsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a67f17bf3f18a3d8ff129a354e4579b09ac6c99625f6c0dcaf6baecbdb23eb6c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColors")
    def reset_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColors", []))

    @jsii.member(jsii_name="resetColorsVar")
    def reset_colors_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorsVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorsInput")
    def colors_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsInput"))

    @builtins.property
    @jsii.member(jsii_name="colorsVarInput")
    def colors_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsVarInput"))

    @builtins.property
    @jsii.member(jsii_name="colors")
    def colors(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colors"))

    @colors.setter
    def colors(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c75a7a8b91d107113a830d64f38450d9c8b954b8e68d3f2ed2386093cdf594f7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colors", value)

    @builtins.property
    @jsii.member(jsii_name="colorsVar")
    def colors_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorsVar"))

    @colors_var.setter
    def colors_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__453cd674c168bd8e6ec3f3a80ac88622f4dadc00d297c3a594e5a27a72f9cab0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorsVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationMaxColors]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationMaxColors]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationMaxColors]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a81e243438cc5ec5594ce88131be0b80d11f158513d8bfbef03e853981615d3b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationMirror",
    jsii_struct_bases=[],
    name_mapping={
        "horizontal": "horizontal",
        "horizontal_var": "horizontalVar",
        "vertical": "vertical",
        "vertical_var": "verticalVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationMirror:
    def __init__(
        self,
        *,
        horizontal: typing.Optional[builtins.str] = None,
        horizontal_var: typing.Optional[builtins.str] = None,
        vertical: typing.Optional[builtins.str] = None,
        vertical_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param horizontal: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        :param horizontal_var: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        :param vertical: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        :param vertical_var: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ce086f5122c6e9a7dd3327e8338f5a9d7dbbff6aa3c24f4c9defa8aeaef67b1c)
            check_type(argname="argument horizontal", value=horizontal, expected_type=type_hints["horizontal"])
            check_type(argname="argument horizontal_var", value=horizontal_var, expected_type=type_hints["horizontal_var"])
            check_type(argname="argument vertical", value=vertical, expected_type=type_hints["vertical"])
            check_type(argname="argument vertical_var", value=vertical_var, expected_type=type_hints["vertical_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if horizontal is not None:
            self._values["horizontal"] = horizontal
        if horizontal_var is not None:
            self._values["horizontal_var"] = horizontal_var
        if vertical is not None:
            self._values["vertical"] = vertical
        if vertical_var is not None:
            self._values["vertical_var"] = vertical_var

    @builtins.property
    def horizontal(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        '''
        result = self._values.get("horizontal")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def horizontal_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        '''
        result = self._values.get("horizontal_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        '''
        result = self._values.get("vertical")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        result = self._values.get("vertical_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationMirror(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationMirrorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationMirrorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa65fca98eda6958a8b1759b5779faae8d250e0e98ed3f0500e334b0838b0b76)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationMirrorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__281c1606225e2f80b058c4a765b0f400849b682d722fc4b459a731c0d1dac047)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationMirrorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ef7ee297b9c1629be38f4278d3a49f37e602bb25dcb8714c20a53379213cdf46)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__10061c9ba7cef213ec9b33b9216078e133811462a8995821b62bc77efd0c1392)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__918501fefb3890c50d5781906710df7f7ed67bc8ee8ff9c782234cff64b4cdaa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationMirror]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationMirror]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5e5c45ff2fa54073505c291f9ad220004235c2ff9d6e50700c308371d5b037aa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationMirrorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationMirrorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__85d762216c784f39b446a3b963171ae8bdadaaa8a21fa55e5c500d19a97817b9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHorizontal")
    def reset_horizontal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontal", []))

    @jsii.member(jsii_name="resetHorizontalVar")
    def reset_horizontal_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontalVar", []))

    @jsii.member(jsii_name="resetVertical")
    def reset_vertical(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVertical", []))

    @jsii.member(jsii_name="resetVerticalVar")
    def reset_vertical_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVerticalVar", []))

    @builtins.property
    @jsii.member(jsii_name="horizontalInput")
    def horizontal_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontalVarInput")
    def horizontal_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalInput")
    def vertical_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalVarInput")
    def vertical_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontal")
    def horizontal(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontal"))

    @horizontal.setter
    def horizontal(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b7b127c3f7c821a00a23fc5e38b3a780253bb32ff3b9edac7d2964f511d7886f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontal", value)

    @builtins.property
    @jsii.member(jsii_name="horizontalVar")
    def horizontal_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontalVar"))

    @horizontal_var.setter
    def horizontal_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__32dc8d887c8ae0626d0c5e0ddc4d5c15f7504be34db84218ca99f8188f34031c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontalVar", value)

    @builtins.property
    @jsii.member(jsii_name="vertical")
    def vertical(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "vertical"))

    @vertical.setter
    def vertical(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f2e71cfed0389419c54b7c22609fb9dcb396860c5dede4ca1ea50f69f9699783)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "vertical", value)

    @builtins.property
    @jsii.member(jsii_name="verticalVar")
    def vertical_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "verticalVar"))

    @vertical_var.setter
    def vertical_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__896eabbc03965c507baef086cfbdbb5e8a0b013213bf9f94803b84c65149cc1d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "verticalVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationMirror]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationMirror]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationMirror]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0cd794bbf594481c7f65765685c6f4c95bbe41415e1c38af28b7f9f7cb811b79)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationMonoHue",
    jsii_struct_bases=[],
    name_mapping={"hue": "hue", "hue_var": "hueVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationMonoHue:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b8b4952547e37af2d658d871acb2da61ad3340f52062f0b6ed0804ef79b50682)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationMonoHue(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationMonoHueList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationMonoHueList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b53a97be6e08d64b4c1724af9d0fa2722f6783d6811781ec4d2ba19797d56dfd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationMonoHueOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ff25f4d684f001c493748f2becc6b33fb086ab567f1f153a85ab04ed549e074)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationMonoHueOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__846521ab1991cf7050fb8324e8e85c33da323e9cc2d91087f59c0d675b776cc8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a5c41c4f690ab53124c791b8b432b3c8df7faeb9be223049c4db0107813aad3f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__04179aa32a9be957f3f9f976ac394923a3095243d5957f955353baaf20c9bd97)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationMonoHue]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationMonoHue]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a58ebe65872103649c4e595c310cce23c09c2475c743ea61cc95276412249705)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationMonoHueOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationMonoHueOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__18c18912f579eb1fae43c7f137d7276160576cf69cf95427987897301fdfd014)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e650527c49894f42a14537b45440d0da05b2508ad9227e9eaf2d614e0309becb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd0ae19bdf23a5346a6ebcde8d3383a060bf70d4febb5ccf4a2ca8956045ec9b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationMonoHue]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationMonoHue]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationMonoHue]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__da8e3cb715929a42a2da42f4b36e9b64decf2c88d518c87117e85409219f3c1c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationOpacity",
    jsii_struct_bases=[],
    name_mapping={"opacity": "opacity", "opacity_var": "opacityVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationOpacity:
    def __init__(
        self,
        *,
        opacity: typing.Optional[builtins.str] = None,
        opacity_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param opacity: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param opacity_var: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__73a23966b80b8180ccbdccc87f921f4b58ec6f5ee4d001ece2c63bcb1b151b6b)
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument opacity_var", value=opacity_var, expected_type=type_hints["opacity_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if opacity is not None:
            self._values["opacity"] = opacity
        if opacity_var is not None:
            self._values["opacity_var"] = opacity_var

    @builtins.property
    def opacity(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def opacity_var(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        result = self._values.get("opacity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationOpacity(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationOpacityList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationOpacityList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3d2f0f68dd0eac6a7b03470de8ebcd4a9f75611d4fcdf8cb546d5d1a928f9401)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationOpacityOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__71baaf886b23cf917f7b19bec2292f3b0ef67df277d9d683ff91db5d23d517d3)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationOpacityOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a293060e506b27e80b603b3af2faa32b8861ca0e9028cbea0270d48e703e634f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__94e82b936f8060aa4ee459286e4fd526513a27a39a4cf913b686367cca86db75)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bf8e9f8cb1a35e5e34261e2af849d7ba155c9a9d2786464e8d1be78e7ad06db4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationOpacity]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationOpacity]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc99781b6a5331060267abd3290588961b400e094661701c7e6ecea0d421eeac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationOpacityOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationOpacityOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__46f439d83caaee08dd0c7cec3bb41f9927bb0ec6e74bb80f3ef36f61f7476173)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetOpacityVar")
    def reset_opacity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacityVar", []))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityVarInput")
    def opacity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacity"))

    @opacity.setter
    def opacity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__315c973bddd1e52d36a4298ef2abd6eaa46e16b5e4ebe65884aad2200af5152b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacity", value)

    @builtins.property
    @jsii.member(jsii_name="opacityVar")
    def opacity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacityVar"))

    @opacity_var.setter
    def opacity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__338f4e65bfb5fdbc153184c649f376565a2ce3c841de9948faf1b06a73c853a5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacityVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationOpacity]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationOpacity]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationOpacity]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c796f33b719847260d0e7e9372f813d5e6f195d6923b534e343e73d329c58080)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c5cfc2c8222294366a707d1d9f7d9320101e187d8f269f74a200397021d84f95)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putAppend")
    def put_append(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationAppend, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d3c0f53f9fa37d37ee3446af4f656924799ef52736b49dbb98e4e7fbd0c79d77)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putAppend", [value]))

    @jsii.member(jsii_name="putAspectCrop")
    def put_aspect_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationAspectCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__030f3dbe7ed1449a955ef0b50408dc5f745b1bb46fb6d971358947684d6096d6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putAspectCrop", [value]))

    @jsii.member(jsii_name="putBackgroundColor")
    def put_background_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__19d2c70de8aa70f5fc8e1532f41d9718333ea817625e2b8e4db739f747aa2344)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBackgroundColor", [value]))

    @jsii.member(jsii_name="putBlur")
    def put_blur(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationBlur, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5fda9aa611c0fff84909a7766a4bed4f51491353159ae355e4161f733c0de6d1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBlur", [value]))

    @jsii.member(jsii_name="putChromaKey")
    def put_chroma_key(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationChromaKey, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e70c59a3dc03c1c31a1ed38f9dc4221a2c56546f1ceaaf88c3fc7416b22471ec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putChromaKey", [value]))

    @jsii.member(jsii_name="putComposite")
    def put_composite(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationComposite, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b8e5650d7d8117ebb98b11d980d84859872f7d41a88cd0cf59e692ae632acbd1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putComposite", [value]))

    @jsii.member(jsii_name="putCompound")
    def put_compound(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationCompound, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__02260706cf75c42bd23882c21c6d5547cf2070157dcae18d1af9d0067cb5dde9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCompound", [value]))

    @jsii.member(jsii_name="putContrast")
    def put_contrast(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationContrast, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__125c8dcf004db0b208e7aa20ebf684bad99de8290a94997b1f4a14b7040a25a9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putContrast", [value]))

    @jsii.member(jsii_name="putCrop")
    def put_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__379617f4fb8c4972c6dff3200ef7ccafa900d1e736b1a2540a81a8e71eb0c3ec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCrop", [value]))

    @jsii.member(jsii_name="putFaceCrop")
    def put_face_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationFaceCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__087fb336e644b341a13d17628e61c318d1b430191f42d9e7d7e2f21e85fa95f2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFaceCrop", [value]))

    @jsii.member(jsii_name="putFeatureCrop")
    def put_feature_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationFeatureCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dda1877fb9f1929ba4734863e43ddea2f3e493888aa4edc18db1ac8a99ae00ba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFeatureCrop", [value]))

    @jsii.member(jsii_name="putFitAndFill")
    def put_fit_and_fill(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationFitAndFill, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b076ab486b43d44a19659a6bb66701cd23e277bb0eb93b35a15a2cf0f4e77c91)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFitAndFill", [value]))

    @jsii.member(jsii_name="putGoop")
    def put_goop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationGoop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__88ae0c62cf49ed7c33a902a4ff556df3e0297f203aac79874403ce4840f9cde0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGoop", [value]))

    @jsii.member(jsii_name="putGrayscale")
    def put_grayscale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationGrayscale, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5b698cf1427ab831aabc162cb993c0f322ad0f562b3866d4aca02347442618ad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGrayscale", [value]))

    @jsii.member(jsii_name="putHsl")
    def put_hsl(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationHsl, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fe47ea9e7e643da2e42f49547e0dda95ee06552e9608f979a38b8a200f2e7337)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsl", [value]))

    @jsii.member(jsii_name="putHsv")
    def put_hsv(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationHsv, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__311179e2de5b758beebfbdbcb36b302a2878bf54469e3b8f684bbb0c27d53450)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsv", [value]))

    @jsii.member(jsii_name="putIfDimension")
    def put_if_dimension(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfDimension, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__378c28a4f0485e435a3ac91b2245b1126966b67781a902ec00ffe8c9ea82f804)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfDimension", [value]))

    @jsii.member(jsii_name="putIfOrientation")
    def put_if_orientation(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1c79eff71b9683628d7bd580ae63334e57a6852774dc3dc6581b159e6388f14b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfOrientation", [value]))

    @jsii.member(jsii_name="putImQuery")
    def put_im_query(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationImQuery, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f07cfbade3b18aa89453ab62be6b937cf353c27b73deabb951fa8c4d59ac2b77)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putImQuery", [value]))

    @jsii.member(jsii_name="putMaxColors")
    def put_max_colors(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationMaxColors, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4400a30721b6f2b248b46ac1af744bfdc3a56a2d07085f66775cf983d85a3149)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMaxColors", [value]))

    @jsii.member(jsii_name="putMirror")
    def put_mirror(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationMirror, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__70f5439f3672212a5964b615d427635282996d16ac599ea789917caa755067a8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMirror", [value]))

    @jsii.member(jsii_name="putMonoHue")
    def put_mono_hue(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationMonoHue, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__40722432ab5a1ec058337d23621893d02a28a09bd71bb2b62ae09a5f8b205cb8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMonoHue", [value]))

    @jsii.member(jsii_name="putOpacity")
    def put_opacity(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationOpacity, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3e8b3e13836f343bad33903850f751ebf5f16794bed74fb2aa15632f46337a4c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putOpacity", [value]))

    @jsii.member(jsii_name="putRegionOfInterestCrop")
    def put_region_of_interest_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationRegionOfInterestCrop", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ccbbbbc735ec900c45b1557c229c2aab9772903d89b28d34b3b944cb0c6f518)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRegionOfInterestCrop", [value]))

    @jsii.member(jsii_name="putRelativeCrop")
    def put_relative_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationRelativeCrop", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2c00e6fa6c4d9217286414facb737d5822e021d0f300ee253bbe2961e388034e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRelativeCrop", [value]))

    @jsii.member(jsii_name="putRemoveColor")
    def put_remove_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationRemoveColor", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__058170b9a119e80ac9c6e45b6e1399203eea25cd630fedf8f1f792ab9ede33ab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRemoveColor", [value]))

    @jsii.member(jsii_name="putResize")
    def put_resize(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationResize", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__472b2c9285d56e58157192b01a34064ff0e14e89fc94583c87adb11d7ecbdcf5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putResize", [value]))

    @jsii.member(jsii_name="putRotate")
    def put_rotate(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationRotate", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ddd686c4feb7471c19f3aba0001ffea629cf8d82fcc4152abe794971a9cd223)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRotate", [value]))

    @jsii.member(jsii_name="putScale")
    def put_scale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationScale", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a46068fc720c345f58a352c7288231c4355b3c8766c0394150dd24bfe382652)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putScale", [value]))

    @jsii.member(jsii_name="putShear")
    def put_shear(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationShear", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d9e0bb42a3e5851f8c6f14ad2f70c376022df49cf0ad814a86d9e9f7db08965d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putShear", [value]))

    @jsii.member(jsii_name="putTrim")
    def put_trim(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationTrim", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f4e6c546301bb7a98b3717efaab280481296fcc591901b0e69feb789c475eb14)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTrim", [value]))

    @jsii.member(jsii_name="putUnsharpMask")
    def put_unsharp_mask(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationUnsharpMask", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__55fd0bddac7d96e6fe561b60c94344c482617768f3b6f03fa927b2892cf518b0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putUnsharpMask", [value]))

    @jsii.member(jsii_name="resetAppend")
    def reset_append(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAppend", []))

    @jsii.member(jsii_name="resetAspectCrop")
    def reset_aspect_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspectCrop", []))

    @jsii.member(jsii_name="resetBackgroundColor")
    def reset_background_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBackgroundColor", []))

    @jsii.member(jsii_name="resetBlur")
    def reset_blur(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBlur", []))

    @jsii.member(jsii_name="resetChromaKey")
    def reset_chroma_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChromaKey", []))

    @jsii.member(jsii_name="resetComposite")
    def reset_composite(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetComposite", []))

    @jsii.member(jsii_name="resetCompound")
    def reset_compound(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCompound", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetCrop")
    def reset_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCrop", []))

    @jsii.member(jsii_name="resetFaceCrop")
    def reset_face_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFaceCrop", []))

    @jsii.member(jsii_name="resetFeatureCrop")
    def reset_feature_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureCrop", []))

    @jsii.member(jsii_name="resetFitAndFill")
    def reset_fit_and_fill(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFitAndFill", []))

    @jsii.member(jsii_name="resetGoop")
    def reset_goop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGoop", []))

    @jsii.member(jsii_name="resetGrayscale")
    def reset_grayscale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGrayscale", []))

    @jsii.member(jsii_name="resetHsl")
    def reset_hsl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsl", []))

    @jsii.member(jsii_name="resetHsv")
    def reset_hsv(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsv", []))

    @jsii.member(jsii_name="resetIfDimension")
    def reset_if_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfDimension", []))

    @jsii.member(jsii_name="resetIfOrientation")
    def reset_if_orientation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfOrientation", []))

    @jsii.member(jsii_name="resetImQuery")
    def reset_im_query(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetImQuery", []))

    @jsii.member(jsii_name="resetMaxColors")
    def reset_max_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxColors", []))

    @jsii.member(jsii_name="resetMirror")
    def reset_mirror(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMirror", []))

    @jsii.member(jsii_name="resetMonoHue")
    def reset_mono_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonoHue", []))

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetRegionOfInterestCrop")
    def reset_region_of_interest_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRegionOfInterestCrop", []))

    @jsii.member(jsii_name="resetRelativeCrop")
    def reset_relative_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRelativeCrop", []))

    @jsii.member(jsii_name="resetRemoveColor")
    def reset_remove_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRemoveColor", []))

    @jsii.member(jsii_name="resetResize")
    def reset_resize(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetResize", []))

    @jsii.member(jsii_name="resetRotate")
    def reset_rotate(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRotate", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetShear")
    def reset_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetShear", []))

    @jsii.member(jsii_name="resetTrim")
    def reset_trim(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTrim", []))

    @jsii.member(jsii_name="resetUnsharpMask")
    def reset_unsharp_mask(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUnsharpMask", []))

    @builtins.property
    @jsii.member(jsii_name="append")
    def append(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationAppendList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationAppendList, jsii.get(self, "append"))

    @builtins.property
    @jsii.member(jsii_name="aspectCrop")
    def aspect_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationAspectCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationAspectCropList, jsii.get(self, "aspectCrop"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColor")
    def background_color(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationBackgroundColorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationBackgroundColorList, jsii.get(self, "backgroundColor"))

    @builtins.property
    @jsii.member(jsii_name="blur")
    def blur(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationBlurList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationBlurList, jsii.get(self, "blur"))

    @builtins.property
    @jsii.member(jsii_name="chromaKey")
    def chroma_key(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationChromaKeyList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationChromaKeyList, jsii.get(self, "chromaKey"))

    @builtins.property
    @jsii.member(jsii_name="composite")
    def composite(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationCompositeList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationCompositeList, jsii.get(self, "composite"))

    @builtins.property
    @jsii.member(jsii_name="compound")
    def compound(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationCompoundList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationCompoundList, jsii.get(self, "compound"))

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationContrastList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationContrastList, jsii.get(self, "contrast"))

    @builtins.property
    @jsii.member(jsii_name="crop")
    def crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationCropList, jsii.get(self, "crop"))

    @builtins.property
    @jsii.member(jsii_name="faceCrop")
    def face_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationFaceCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationFaceCropList, jsii.get(self, "faceCrop"))

    @builtins.property
    @jsii.member(jsii_name="featureCrop")
    def feature_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationFeatureCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationFeatureCropList, jsii.get(self, "featureCrop"))

    @builtins.property
    @jsii.member(jsii_name="fitAndFill")
    def fit_and_fill(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationFitAndFillList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationFitAndFillList, jsii.get(self, "fitAndFill"))

    @builtins.property
    @jsii.member(jsii_name="goop")
    def goop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationGoopList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationGoopList, jsii.get(self, "goop"))

    @builtins.property
    @jsii.member(jsii_name="grayscale")
    def grayscale(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationGrayscaleList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationGrayscaleList, jsii.get(self, "grayscale"))

    @builtins.property
    @jsii.member(jsii_name="hsl")
    def hsl(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationHslList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationHslList, jsii.get(self, "hsl"))

    @builtins.property
    @jsii.member(jsii_name="hsv")
    def hsv(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationHsvList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationHsvList, jsii.get(self, "hsv"))

    @builtins.property
    @jsii.member(jsii_name="ifDimension")
    def if_dimension(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfDimensionList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfDimensionList, jsii.get(self, "ifDimension"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientation")
    def if_orientation(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfOrientationList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfOrientationList, jsii.get(self, "ifOrientation"))

    @builtins.property
    @jsii.member(jsii_name="imQuery")
    def im_query(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationImQueryList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationImQueryList, jsii.get(self, "imQuery"))

    @builtins.property
    @jsii.member(jsii_name="maxColors")
    def max_colors(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationMaxColorsList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationMaxColorsList, jsii.get(self, "maxColors"))

    @builtins.property
    @jsii.member(jsii_name="mirror")
    def mirror(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationMirrorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationMirrorList, jsii.get(self, "mirror"))

    @builtins.property
    @jsii.member(jsii_name="monoHue")
    def mono_hue(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationMonoHueList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationMonoHueList, jsii.get(self, "monoHue"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationOpacityList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationOpacityList, jsii.get(self, "opacity"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestCrop")
    def region_of_interest_crop(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationRegionOfInterestCropList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationRegionOfInterestCropList", jsii.get(self, "regionOfInterestCrop"))

    @builtins.property
    @jsii.member(jsii_name="relativeCrop")
    def relative_crop(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationRelativeCropList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationRelativeCropList", jsii.get(self, "relativeCrop"))

    @builtins.property
    @jsii.member(jsii_name="removeColor")
    def remove_color(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationRemoveColorList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationRemoveColorList", jsii.get(self, "removeColor"))

    @builtins.property
    @jsii.member(jsii_name="resize")
    def resize(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationResizeList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationResizeList", jsii.get(self, "resize"))

    @builtins.property
    @jsii.member(jsii_name="rotate")
    def rotate(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationRotateList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationRotateList", jsii.get(self, "rotate"))

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationScaleList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationScaleList", jsii.get(self, "scale"))

    @builtins.property
    @jsii.member(jsii_name="shear")
    def shear(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationShearList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationShearList", jsii.get(self, "shear"))

    @builtins.property
    @jsii.member(jsii_name="trim")
    def trim(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationTrimList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationTrimList", jsii.get(self, "trim"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMask")
    def unsharp_mask(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationUnsharpMaskList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationUnsharpMaskList", jsii.get(self, "unsharpMask"))

    @builtins.property
    @jsii.member(jsii_name="appendInput")
    def append_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationAppend]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationAppend]]], jsii.get(self, "appendInput"))

    @builtins.property
    @jsii.member(jsii_name="aspectCropInput")
    def aspect_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationAspectCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationAspectCrop]]], jsii.get(self, "aspectCropInput"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColorInput")
    def background_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationBackgroundColor]]], jsii.get(self, "backgroundColorInput"))

    @builtins.property
    @jsii.member(jsii_name="blurInput")
    def blur_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationBlur]]], jsii.get(self, "blurInput"))

    @builtins.property
    @jsii.member(jsii_name="chromaKeyInput")
    def chroma_key_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationChromaKey]]], jsii.get(self, "chromaKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="compositeInput")
    def composite_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationComposite]]], jsii.get(self, "compositeInput"))

    @builtins.property
    @jsii.member(jsii_name="compoundInput")
    def compound_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationCompound]]], jsii.get(self, "compoundInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationContrast]]], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="cropInput")
    def crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationCrop]]], jsii.get(self, "cropInput"))

    @builtins.property
    @jsii.member(jsii_name="faceCropInput")
    def face_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationFaceCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationFaceCrop]]], jsii.get(self, "faceCropInput"))

    @builtins.property
    @jsii.member(jsii_name="featureCropInput")
    def feature_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationFeatureCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationFeatureCrop]]], jsii.get(self, "featureCropInput"))

    @builtins.property
    @jsii.member(jsii_name="fitAndFillInput")
    def fit_and_fill_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationFitAndFill]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationFitAndFill]]], jsii.get(self, "fitAndFillInput"))

    @builtins.property
    @jsii.member(jsii_name="goopInput")
    def goop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationGoop]]], jsii.get(self, "goopInput"))

    @builtins.property
    @jsii.member(jsii_name="grayscaleInput")
    def grayscale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationGrayscale]]], jsii.get(self, "grayscaleInput"))

    @builtins.property
    @jsii.member(jsii_name="hslInput")
    def hsl_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationHsl]]], jsii.get(self, "hslInput"))

    @builtins.property
    @jsii.member(jsii_name="hsvInput")
    def hsv_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationHsv]]], jsii.get(self, "hsvInput"))

    @builtins.property
    @jsii.member(jsii_name="ifDimensionInput")
    def if_dimension_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfDimension]]], jsii.get(self, "ifDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientationInput")
    def if_orientation_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfOrientation]]], jsii.get(self, "ifOrientationInput"))

    @builtins.property
    @jsii.member(jsii_name="imQueryInput")
    def im_query_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationImQuery]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationImQuery]]], jsii.get(self, "imQueryInput"))

    @builtins.property
    @jsii.member(jsii_name="maxColorsInput")
    def max_colors_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationMaxColors]]], jsii.get(self, "maxColorsInput"))

    @builtins.property
    @jsii.member(jsii_name="mirrorInput")
    def mirror_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationMirror]]], jsii.get(self, "mirrorInput"))

    @builtins.property
    @jsii.member(jsii_name="monoHueInput")
    def mono_hue_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationMonoHue]]], jsii.get(self, "monoHueInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationOpacity]]], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestCropInput")
    def region_of_interest_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationRegionOfInterestCrop"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationRegionOfInterestCrop"]]], jsii.get(self, "regionOfInterestCropInput"))

    @builtins.property
    @jsii.member(jsii_name="relativeCropInput")
    def relative_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationRelativeCrop"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationRelativeCrop"]]], jsii.get(self, "relativeCropInput"))

    @builtins.property
    @jsii.member(jsii_name="removeColorInput")
    def remove_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationRemoveColor"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationRemoveColor"]]], jsii.get(self, "removeColorInput"))

    @builtins.property
    @jsii.member(jsii_name="resizeInput")
    def resize_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationResize"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationResize"]]], jsii.get(self, "resizeInput"))

    @builtins.property
    @jsii.member(jsii_name="rotateInput")
    def rotate_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationRotate"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationRotate"]]], jsii.get(self, "rotateInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationScale"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationScale"]]], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="shearInput")
    def shear_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationShear"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationShear"]]], jsii.get(self, "shearInput"))

    @builtins.property
    @jsii.member(jsii_name="trimInput")
    def trim_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationTrim"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationTrim"]]], jsii.get(self, "trimInput"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMaskInput")
    def unsharp_mask_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationUnsharpMask"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationUnsharpMask"]]], jsii.get(self, "unsharpMaskInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f4e0d79c9342bdb8650694c527b08c951a0f11d20b4e017dc6188f02cf1b689d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationRegionOfInterestCrop",
    jsii_struct_bases=[],
    name_mapping={
        "region_of_interest": "regionOfInterest",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationRegionOfInterestCrop:
    def __init__(
        self,
        *,
        region_of_interest: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationRegionOfInterestCropRegionOfInterest", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param region_of_interest: region_of_interest block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest DataAkamaiImagingPolicyImage#region_of_interest}
        :param gravity: The placement of the crop area relative to the specified area of interest. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: The placement of the crop area relative to the specified area of interest. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param style: Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(region_of_interest, dict):
            region_of_interest = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationRegionOfInterestCropRegionOfInterest(**region_of_interest)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__141679664895e26d5c9add8b1c029fececdc32dea5e363e4e18f53a4eecf9436)
            check_type(argname="argument region_of_interest", value=region_of_interest, expected_type=type_hints["region_of_interest"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "region_of_interest": region_of_interest,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def region_of_interest(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationRegionOfInterestCropRegionOfInterest":
        '''region_of_interest block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest DataAkamaiImagingPolicyImage#region_of_interest}
        '''
        result = self._values.get("region_of_interest")
        assert result is not None, "Required property 'region_of_interest' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationRegionOfInterestCropRegionOfInterest", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''The placement of the crop area relative to the specified area of interest.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''The placement of the crop area relative to the specified area of interest.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationRegionOfInterestCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationRegionOfInterestCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationRegionOfInterestCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__69566693420ba75fda45398dc60c669a31092b3afc5dfa680238020679cdb489)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationRegionOfInterestCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6512ac041d23568e6861566ee4da4641772ae4aa67c811c3a52944398a217c20)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationRegionOfInterestCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__57cd73f1ac003e3e6eef3c3e097be4b17efabf3e3c811b324e96f0e53ec32207)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d38460d6fe8abfcddaed599cb6892becc887763c450fa309f5f448e0d2679ac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7687c5c2c1cc8d1a5f7cdbd026b4c25506c987c1731440498ba953c29f71a993)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationRegionOfInterestCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationRegionOfInterestCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationRegionOfInterestCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e0e5842c58d03a4922bafcc9b53ed4ddba7f6447e8a9bc1012e44f7810efa7d4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationRegionOfInterestCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationRegionOfInterestCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d72d04aa288e52c72c0991beaf58c014aeef0f8ef2a45185e9d5cc7668e86548)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putRegionOfInterest")
    def put_region_of_interest(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationRegionOfInterestCropRegionOfInterest()

        return typing.cast(None, jsii.invoke(self, "putRegionOfInterest", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterest")
    def region_of_interest(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestOutputReference", jsii.get(self, "regionOfInterest"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestInput")
    def region_of_interest_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationRegionOfInterestCropRegionOfInterest"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationRegionOfInterestCropRegionOfInterest"], jsii.get(self, "regionOfInterestInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7a26ffb838ed34d6b1e790556528387036c1a5331caa3447f333047e75493855)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6772321a26722ea0133401d7a8388f881068754d10992b24599ce211e9288963)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__729f2360c755cb374691ac88d2a6ac7f032706a1ba39146df07420864f8a539a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a6d7878c3a2907c6b7a27a30f8d0ec2e12381ffbc41711a6f7fe58c73172ac08)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__095696d6041f62650f678a08a300acc15c0769376a8ca10bcb389e3206565737)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e55937594c972b503bdf9df570b0a5a1d6c13571bc9935d561e6116e2f131607)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d92d4efe340451c1ed1a338b05fc9c437bd039afbfb98caffebc6343e8bdd59b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__241a678fba34f747d71ec2e642dff239b1282f2093c51dc6809bf4354aa7c674)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationRegionOfInterestCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationRegionOfInterestCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationRegionOfInterestCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa06d315810daf7bc5f736c808f1e46e413e7fea56b9b70d4d32355f7cd9514a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationRegionOfInterestCropRegionOfInterest",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationRegionOfInterestCropRegionOfInterest:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationRegionOfInterestCropRegionOfInterest(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f60beb85583435371687d48c9d7293a8f4ae3622ba93c3f034e3f150110331cf)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationRegionOfInterestCropRegionOfInterest]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationRegionOfInterestCropRegionOfInterest], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationRegionOfInterestCropRegionOfInterest],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c727cfde2d49d74a7092cfe26ea7d029960ac9ffa8c9f3f9ef5a71dd3281ca89)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationRelativeCrop",
    jsii_struct_bases=[],
    name_mapping={
        "east": "east",
        "east_var": "eastVar",
        "north": "north",
        "north_var": "northVar",
        "south": "south",
        "south_var": "southVar",
        "west": "west",
        "west_var": "westVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationRelativeCrop:
    def __init__(
        self,
        *,
        east: typing.Optional[builtins.str] = None,
        east_var: typing.Optional[builtins.str] = None,
        north: typing.Optional[builtins.str] = None,
        north_var: typing.Optional[builtins.str] = None,
        south: typing.Optional[builtins.str] = None,
        south_var: typing.Optional[builtins.str] = None,
        west: typing.Optional[builtins.str] = None,
        west_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param east: The number of pixels to shrink or expand the right side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east DataAkamaiImagingPolicyImage#east}
        :param east_var: The number of pixels to shrink or expand the right side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east_var DataAkamaiImagingPolicyImage#east_var}
        :param north: The number of pixels to shrink or expand the top side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north DataAkamaiImagingPolicyImage#north}
        :param north_var: The number of pixels to shrink or expand the top side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north_var DataAkamaiImagingPolicyImage#north_var}
        :param south: The number of pixels to shrink or expand the bottom side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south DataAkamaiImagingPolicyImage#south}
        :param south_var: The number of pixels to shrink or expand the bottom side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south_var DataAkamaiImagingPolicyImage#south_var}
        :param west: The number of pixels to shrink or expand the left side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west DataAkamaiImagingPolicyImage#west}
        :param west_var: The number of pixels to shrink or expand the left side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west_var DataAkamaiImagingPolicyImage#west_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fc43c2586f021d0f36b09a063072550fcc581d7e6fa25b7306272370eab3c683)
            check_type(argname="argument east", value=east, expected_type=type_hints["east"])
            check_type(argname="argument east_var", value=east_var, expected_type=type_hints["east_var"])
            check_type(argname="argument north", value=north, expected_type=type_hints["north"])
            check_type(argname="argument north_var", value=north_var, expected_type=type_hints["north_var"])
            check_type(argname="argument south", value=south, expected_type=type_hints["south"])
            check_type(argname="argument south_var", value=south_var, expected_type=type_hints["south_var"])
            check_type(argname="argument west", value=west, expected_type=type_hints["west"])
            check_type(argname="argument west_var", value=west_var, expected_type=type_hints["west_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if east is not None:
            self._values["east"] = east
        if east_var is not None:
            self._values["east_var"] = east_var
        if north is not None:
            self._values["north"] = north
        if north_var is not None:
            self._values["north_var"] = north_var
        if south is not None:
            self._values["south"] = south
        if south_var is not None:
            self._values["south_var"] = south_var
        if west is not None:
            self._values["west"] = west
        if west_var is not None:
            self._values["west_var"] = west_var

    @builtins.property
    def east(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the right side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east DataAkamaiImagingPolicyImage#east}
        '''
        result = self._values.get("east")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def east_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the right side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east_var DataAkamaiImagingPolicyImage#east_var}
        '''
        result = self._values.get("east_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def north(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the top side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north DataAkamaiImagingPolicyImage#north}
        '''
        result = self._values.get("north")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def north_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the top side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north_var DataAkamaiImagingPolicyImage#north_var}
        '''
        result = self._values.get("north_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def south(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the bottom side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south DataAkamaiImagingPolicyImage#south}
        '''
        result = self._values.get("south")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def south_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the bottom side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south_var DataAkamaiImagingPolicyImage#south_var}
        '''
        result = self._values.get("south_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def west(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the left side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west DataAkamaiImagingPolicyImage#west}
        '''
        result = self._values.get("west")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def west_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the left side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west_var DataAkamaiImagingPolicyImage#west_var}
        '''
        result = self._values.get("west_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationRelativeCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationRelativeCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationRelativeCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8797b6b44ab913ae7719f4f7258aa10a09c9f76066086619a9ec5b81d89c9fcb)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationRelativeCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__90018c0b205f0972f04b1859b5a127588f301358af66432c0abd836b11d1595d)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationRelativeCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__51e93d8e7777456a741446d36281b23c359adbb50c2cbc1275023a7ce4c8e53f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eaa09d83e691b35ec14de4d79bbade95dbece54ea64432e3ac44bb8e5e1045ac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bf022e69306a3d4b8bcd7c391eb6312ed95ae7a1371d25f2ae7c87e682141ac1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationRelativeCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationRelativeCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationRelativeCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c9c7ecee0188d328a424214be792aeb44ff584bce226671361a6bcda09663121)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationRelativeCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationRelativeCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ddbb17e26ce211712a8dd5c95ac98c142e20aef4cbc34d0e42d388b24c6f528)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetEast")
    def reset_east(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEast", []))

    @jsii.member(jsii_name="resetEastVar")
    def reset_east_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEastVar", []))

    @jsii.member(jsii_name="resetNorth")
    def reset_north(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNorth", []))

    @jsii.member(jsii_name="resetNorthVar")
    def reset_north_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNorthVar", []))

    @jsii.member(jsii_name="resetSouth")
    def reset_south(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSouth", []))

    @jsii.member(jsii_name="resetSouthVar")
    def reset_south_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSouthVar", []))

    @jsii.member(jsii_name="resetWest")
    def reset_west(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWest", []))

    @jsii.member(jsii_name="resetWestVar")
    def reset_west_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWestVar", []))

    @builtins.property
    @jsii.member(jsii_name="eastInput")
    def east_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "eastInput"))

    @builtins.property
    @jsii.member(jsii_name="eastVarInput")
    def east_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "eastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="northInput")
    def north_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "northInput"))

    @builtins.property
    @jsii.member(jsii_name="northVarInput")
    def north_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "northVarInput"))

    @builtins.property
    @jsii.member(jsii_name="southInput")
    def south_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "southInput"))

    @builtins.property
    @jsii.member(jsii_name="southVarInput")
    def south_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "southVarInput"))

    @builtins.property
    @jsii.member(jsii_name="westInput")
    def west_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "westInput"))

    @builtins.property
    @jsii.member(jsii_name="westVarInput")
    def west_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "westVarInput"))

    @builtins.property
    @jsii.member(jsii_name="east")
    def east(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "east"))

    @east.setter
    def east(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__91a9d3473ec9202b85d56ae6e2075415b51f263a3d00533235cee28ee03553ce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "east", value)

    @builtins.property
    @jsii.member(jsii_name="eastVar")
    def east_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "eastVar"))

    @east_var.setter
    def east_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a52c0bd7229f5624bc8b3651eeb6f0fa7e6a7c95aa79e83587e9e1d1d9b8f34)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "eastVar", value)

    @builtins.property
    @jsii.member(jsii_name="north")
    def north(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "north"))

    @north.setter
    def north(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cdbc7d88650987f93a046a5bc4899157c61034c5c19d05fdb9db1423d82704cd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "north", value)

    @builtins.property
    @jsii.member(jsii_name="northVar")
    def north_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "northVar"))

    @north_var.setter
    def north_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3693bbc772d731aace5b12914935c01a36f895bc2a960cf55220e7c3a8e14747)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "northVar", value)

    @builtins.property
    @jsii.member(jsii_name="south")
    def south(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "south"))

    @south.setter
    def south(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c642cf6f28ad73d5a91d823cdffc1366b54cf6a8762cf027e04bb12456794f17)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "south", value)

    @builtins.property
    @jsii.member(jsii_name="southVar")
    def south_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "southVar"))

    @south_var.setter
    def south_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ffa8771ab2336ef631dbb7bb8cf23cf3d2f9dc83295c7bd70aea75c240bf10d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "southVar", value)

    @builtins.property
    @jsii.member(jsii_name="west")
    def west(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "west"))

    @west.setter
    def west(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa50a7d2d8f6c903adab0de55f79977255d9f41d63c05abf9af85c5b3f528b26)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "west", value)

    @builtins.property
    @jsii.member(jsii_name="westVar")
    def west_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "westVar"))

    @west_var.setter
    def west_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__61934cbf0fda634288f342c8c9269c9441edd1954b1cdfcb798afe6a3c033347)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "westVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationRelativeCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationRelativeCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationRelativeCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2c32ca70377760ab826e298977170db8999e9112c7c45627390a3efd9cc57dcf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationRemoveColor",
    jsii_struct_bases=[],
    name_mapping={
        "color": "color",
        "color_var": "colorVar",
        "feather": "feather",
        "feather_var": "featherVar",
        "tolerance": "tolerance",
        "tolerance_var": "toleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationRemoveColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
        feather: typing.Optional[builtins.str] = None,
        feather_var: typing.Optional[builtins.str] = None,
        tolerance: typing.Optional[builtins.str] = None,
        tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        :param feather: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        :param feather_var: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        :param tolerance: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        :param tolerance_var: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a958ecd0c670ba223e85e21351122f69a3055c8909991a8678f455b3b5760642)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
            check_type(argname="argument feather", value=feather, expected_type=type_hints["feather"])
            check_type(argname="argument feather_var", value=feather_var, expected_type=type_hints["feather_var"])
            check_type(argname="argument tolerance", value=tolerance, expected_type=type_hints["tolerance"])
            check_type(argname="argument tolerance_var", value=tolerance_var, expected_type=type_hints["tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var
        if feather is not None:
            self._values["feather"] = feather
        if feather_var is not None:
            self._values["feather_var"] = feather_var
        if tolerance is not None:
            self._values["tolerance"] = tolerance
        if tolerance_var is not None:
            self._values["tolerance_var"] = tolerance_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        '''
        result = self._values.get("feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather_var(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        '''
        result = self._values.get("feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        '''
        result = self._values.get("tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance_var(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        result = self._values.get("tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationRemoveColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationRemoveColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationRemoveColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3701bf21441805ea335a0659089695109c2c3b80a87f76a77fb4918e84a4d9e6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationRemoveColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__410312cea45eb2f9015808334770e748a7b280d808a1670b25825b237a00259f)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationRemoveColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__889f26e4aa79f567696cf8eb8da32ce45d45f1e239d0cdeaa5f9466311f33c58)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ccd40ef1cd7a9e741361b11929720ae3b0681dad18890b57fba88a41a1e7994e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__33183f84b3ff5e6b8da338041d97ee71f214159e7b615e1ec5e4b86f40a2ae02)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationRemoveColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationRemoveColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationRemoveColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__efebc5a32e2957d6af5af9ea5cfe618e4a81e3a94b851e0fe28801c4659c2081)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationRemoveColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationRemoveColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__801033da0fbd4b24ccbcbd36290b5101c58339b8508862bb47384b5b2780cc89)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @jsii.member(jsii_name="resetFeather")
    def reset_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeather", []))

    @jsii.member(jsii_name="resetFeatherVar")
    def reset_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatherVar", []))

    @jsii.member(jsii_name="resetTolerance")
    def reset_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTolerance", []))

    @jsii.member(jsii_name="resetToleranceVar")
    def reset_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featherInput")
    def feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherInput"))

    @builtins.property
    @jsii.member(jsii_name="featherVarInput")
    def feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceInput")
    def tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceVarInput")
    def tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b70765d55c6ab58fc9a88bee3955b6c7d59d133e872a472ca541389d746b3a6e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0168317da7eb18c59d658f13dc144066ea98320694eaedd634ce149a6e89299d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="feather")
    def feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "feather"))

    @feather.setter
    def feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f2204bc9989af902907a742c6eeb498724c49d792c7aafb1d30a1381ab72fac7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "feather", value)

    @builtins.property
    @jsii.member(jsii_name="featherVar")
    def feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featherVar"))

    @feather_var.setter
    def feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__988b19d1f12eab1093d3b84798af21b066d50f83fa634d6c0a7d91cea5fc05c4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featherVar", value)

    @builtins.property
    @jsii.member(jsii_name="tolerance")
    def tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tolerance"))

    @tolerance.setter
    def tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__817d997e3e3a8332e8dd728719a6eabcf9da20dfae68bb1d962cc1476ce61ed5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tolerance", value)

    @builtins.property
    @jsii.member(jsii_name="toleranceVar")
    def tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "toleranceVar"))

    @tolerance_var.setter
    def tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__57a7ab23a26226fc0e114f6f725d1e88044a02b3db7b205dbda4745324c5e457)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "toleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationRemoveColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationRemoveColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationRemoveColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d4cf4678d882604e9d96068eb763503308f80595c39d2bb3a7addf51f3b0fd34)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationResize",
    jsii_struct_bases=[],
    name_mapping={
        "aspect": "aspect",
        "aspect_var": "aspectVar",
        "height": "height",
        "height_var": "heightVar",
        "type": "type",
        "type_var": "typeVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationResize:
    def __init__(
        self,
        *,
        aspect: typing.Optional[builtins.str] = None,
        aspect_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param aspect: Preserves the aspect ratio. Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect DataAkamaiImagingPolicyImage#aspect}
        :param aspect_var: Preserves the aspect ratio. Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_var DataAkamaiImagingPolicyImage#aspect_var}
        :param height: The height to resize the source image to. Must be set if height is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height to resize the source image to. Must be set if height is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param type: Sets constraints for the image resize. Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: Sets constraints for the image resize. Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        :param width: The width to resize the source image to. Must be set if width is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width to resize the source image to. Must be set if width is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__13decac0c94c240854e61a2eb6df4dfd81129358bf5e9a89e36cf374f53e26ff)
            check_type(argname="argument aspect", value=aspect, expected_type=type_hints["aspect"])
            check_type(argname="argument aspect_var", value=aspect_var, expected_type=type_hints["aspect_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if aspect is not None:
            self._values["aspect"] = aspect
        if aspect_var is not None:
            self._values["aspect_var"] = aspect_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def aspect(self) -> typing.Optional[builtins.str]:
        '''Preserves the aspect ratio.

        Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect DataAkamaiImagingPolicyImage#aspect}
        '''
        result = self._values.get("aspect")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def aspect_var(self) -> typing.Optional[builtins.str]:
        '''Preserves the aspect ratio.

        Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_var DataAkamaiImagingPolicyImage#aspect_var}
        '''
        result = self._values.get("aspect_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height to resize the source image to. Must be set if height is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height to resize the source image to. Must be set if height is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''Sets constraints for the image resize.

        Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''Sets constraints for the image resize.

        Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width to resize the source image to. Must be set if width is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width to resize the source image to. Must be set if width is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationResize(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationResizeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationResizeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__86740805050e665a0bd82ac75e14b6b5c3b14bbce5a987b56b8292884e8f41cd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationResizeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0716ba8e051eed46434a22aaf8170f1457587e75074b16187ffd938a89437103)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationResizeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9773a534dd75eae0e6152c2b1a178e5b7805f1aa99c80818f274f825ffdf7e65)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2edba4f9efc014f4adf5c4ee6753fecb82126cf6633ab4e5b01bc3021b918b23)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b2ee4a9c5c06f233bdcff7a1bbaed714c1c26ec4caef570bf8f9764acad97569)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationResize]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationResize]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationResize]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa70b91706a1ac730d9b291faf1fb0cdae228e7425bdc0e6c12514c255790100)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationResizeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationResizeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0a63ebc4dbd92c1ce6a8c4dd7ad87f343b69ddb7292c0e01e52398d1818e0a01)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAspect")
    def reset_aspect(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspect", []))

    @jsii.member(jsii_name="resetAspectVar")
    def reset_aspect_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspectVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="aspectInput")
    def aspect_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "aspectInput"))

    @builtins.property
    @jsii.member(jsii_name="aspectVarInput")
    def aspect_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "aspectVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="aspect")
    def aspect(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "aspect"))

    @aspect.setter
    def aspect(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df2202d07996fdbeb31e5e9b8da8ca48c64c13da770a832a1839ab58678fa1c2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "aspect", value)

    @builtins.property
    @jsii.member(jsii_name="aspectVar")
    def aspect_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "aspectVar"))

    @aspect_var.setter
    def aspect_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea8c0b77850ebc59862c977aa0b8b7bcfd7023e5dfc635391dd42c39f629dbb2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "aspectVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__387d9b1fd5b402b73aa57083051fad1a6b9f6dec9362cd79b7d1b17353020cdf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__79d43be975642f018af00219048a6cdbeec004dfd55744f16cc9b0cb471ea4b2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__90c03bb3c76af43dd34c7bfbccbcde38e3f84713f46dbd274372644fd35dc5a9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__625c34765c94152e68f6457d8e6ceaa16455d5b5446a66a5fd0178e84ae30712)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cba5300889866983571c7b4bdb2aada922cbf1760fc1f002c2bc19495a7c4806)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f990bdf0a390132e4e3d4c2972fb3f95daf9448ec7811c7046187859631451d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationResize]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationResize]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationResize]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__309d176dbe8563031e3ce940cf343880b545113dbc4a3201c39f3c5adb0824da)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationRotate",
    jsii_struct_bases=[],
    name_mapping={"degrees": "degrees", "degrees_var": "degreesVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationRotate:
    def __init__(
        self,
        *,
        degrees: typing.Optional[builtins.str] = None,
        degrees_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param degrees: The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees DataAkamaiImagingPolicyImage#degrees}
        :param degrees_var: The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees_var DataAkamaiImagingPolicyImage#degrees_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aae58fb438fda1b9afaa277e95cddb0e18d5f5e95df6e39ca3343c3ea21d7031)
            check_type(argname="argument degrees", value=degrees, expected_type=type_hints["degrees"])
            check_type(argname="argument degrees_var", value=degrees_var, expected_type=type_hints["degrees_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if degrees is not None:
            self._values["degrees"] = degrees
        if degrees_var is not None:
            self._values["degrees_var"] = degrees_var

    @builtins.property
    def degrees(self) -> typing.Optional[builtins.str]:
        '''The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees DataAkamaiImagingPolicyImage#degrees}
        '''
        result = self._values.get("degrees")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def degrees_var(self) -> typing.Optional[builtins.str]:
        '''The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees_var DataAkamaiImagingPolicyImage#degrees_var}
        '''
        result = self._values.get("degrees_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationRotate(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationRotateList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationRotateList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__224f87a76f89415b031130d119cc3ce055d0777d3a53a7959d139bd7ff16062b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationRotateOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__046af13c282e654d2e605aa5f582d6aac85ce0af6e845afe55a5b178bc6ee4d4)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationRotateOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b6a51d9577ecee9f62465783060cea161b1984ac0a548039c728b7d096f619db)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__31c548decc39711b565a3c5b37ef41a4d7ab9136bf02ab04ed1e2061d3d4ded1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af76ea6056a3e66d3440ee684df74541ff4b07b9a7890e9057e8bbb9d6c660fc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationRotate]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationRotate]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationRotate]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fb2c2e94bdd9fccb67e1c1e23256fef139745ae2034582d55209da994ad3740f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationRotateOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationRotateOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a78052d96158927a66a03219dfa28907c4b192f9a2813dee0b2d33d5dea1577d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetDegrees")
    def reset_degrees(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDegrees", []))

    @jsii.member(jsii_name="resetDegreesVar")
    def reset_degrees_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDegreesVar", []))

    @builtins.property
    @jsii.member(jsii_name="degreesInput")
    def degrees_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "degreesInput"))

    @builtins.property
    @jsii.member(jsii_name="degreesVarInput")
    def degrees_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "degreesVarInput"))

    @builtins.property
    @jsii.member(jsii_name="degrees")
    def degrees(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "degrees"))

    @degrees.setter
    def degrees(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0731bda8c9e61e39e7fbad1641f7a6560dab84064979725f37a7c65b36aff23d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "degrees", value)

    @builtins.property
    @jsii.member(jsii_name="degreesVar")
    def degrees_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "degreesVar"))

    @degrees_var.setter
    def degrees_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a1ae997ada829eb04ea72557369f1dff2692462ddd6def0217261bb0d0826b74)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "degreesVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationRotate]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationRotate]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationRotate]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__101bfaebffff71267b4cc4054ffb42d8b40f34f279df293d224a7fd394099e90)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationScale",
    jsii_struct_bases=[],
    name_mapping={
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationScale:
    def __init__(
        self,
        *,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param height: Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged. Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged. Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7dbd30b70ee3dda8d1149848189e723e71366e230603013cac5e4daf56254fe7)
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size.

        Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size.

        Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged.

        Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged.

        Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationScale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationScaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationScaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8dced703ae699e715a4c6fed55574aa64d1ed94f14efd2bd85fa8f34813a2470)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationScaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa535533cdf2d2505fbe0323d2eb1d3d6c83ef0efe1267e454f8abe7a72fbf6e)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationScaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9692a2a39c83d9cb4641047d2af66806a9056b334aa0dce9fe580bd5c70980f3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e04327b7cf7722088c5639fa814f907ccb4b67025e3424dda6896711fd876df3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ba7ba4b07bc34409910625df21cb0c8ef0a92161992334a6ebe255991c30765)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationScale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationScale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationScale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4738f874b33f6d48a7579f7c784011bd6c122301f678c3adf7c0c16e7b463da5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationScaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationScaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ed3f1e8482b566dbee8472b7ad4121c0bc912422100f26114a85e39685a5bcdc)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c8af2954d9b6f661f42e86693e6a313f6494dbd028761b7c072996428a3ef796)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__984d090b4b909ec7ea80269e27a29865fe6f57abe9e7ca4c1c952d09879a5b19)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc456c83986a5f3aa608fc4eadc60ac6618d7d0c1f402287485f1cf9fa20d962)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2527775cd3952afbe9f2d247469d4c94dd07879243b5e13766b78af504685e13)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationScale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationScale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationScale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e895f858b63ff11145644bf9170b1d698e906388463fe24928384e0e794005f4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationShear",
    jsii_struct_bases=[],
    name_mapping={
        "x_shear": "xShear",
        "x_shear_var": "xShearVar",
        "y_shear": "yShear",
        "y_shear_var": "yShearVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationShear:
    def __init__(
        self,
        *,
        x_shear: typing.Optional[builtins.str] = None,
        x_shear_var: typing.Optional[builtins.str] = None,
        y_shear: typing.Optional[builtins.str] = None,
        y_shear_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param x_shear: The amount to shear along the x-axis, measured in multiples of the image's width. Must be set if yShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear DataAkamaiImagingPolicyImage#x_shear}
        :param x_shear_var: The amount to shear along the x-axis, measured in multiples of the image's width. Must be set if yShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear_var DataAkamaiImagingPolicyImage#x_shear_var}
        :param y_shear: The amount to shear along the y-axis, measured in multiples of the image's height. Must be set if xShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear DataAkamaiImagingPolicyImage#y_shear}
        :param y_shear_var: The amount to shear along the y-axis, measured in multiples of the image's height. Must be set if xShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear_var DataAkamaiImagingPolicyImage#y_shear_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dd946810bfabe4df59755e2bc816826ea586439f892e296a49e1291875131ee9)
            check_type(argname="argument x_shear", value=x_shear, expected_type=type_hints["x_shear"])
            check_type(argname="argument x_shear_var", value=x_shear_var, expected_type=type_hints["x_shear_var"])
            check_type(argname="argument y_shear", value=y_shear, expected_type=type_hints["y_shear"])
            check_type(argname="argument y_shear_var", value=y_shear_var, expected_type=type_hints["y_shear_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if x_shear is not None:
            self._values["x_shear"] = x_shear
        if x_shear_var is not None:
            self._values["x_shear_var"] = x_shear_var
        if y_shear is not None:
            self._values["y_shear"] = y_shear
        if y_shear_var is not None:
            self._values["y_shear_var"] = y_shear_var

    @builtins.property
    def x_shear(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the x-axis, measured in multiples of the image's width.

        Must be set if yShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear DataAkamaiImagingPolicyImage#x_shear}
        '''
        result = self._values.get("x_shear")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_shear_var(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the x-axis, measured in multiples of the image's width.

        Must be set if yShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear_var DataAkamaiImagingPolicyImage#x_shear_var}
        '''
        result = self._values.get("x_shear_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_shear(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the y-axis, measured in multiples of the image's height.

        Must be set if xShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear DataAkamaiImagingPolicyImage#y_shear}
        '''
        result = self._values.get("y_shear")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_shear_var(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the y-axis, measured in multiples of the image's height.

        Must be set if xShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear_var DataAkamaiImagingPolicyImage#y_shear_var}
        '''
        result = self._values.get("y_shear_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationShear(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationShearList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationShearList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__41275420cf348befdaaab80e3aff81e13ed1c455d9d1b36249f09ce93616019a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationShearOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4370905c6f24aa78635bd99ecc2a37eba0fde37dca1d3daac82663cb0c647ec7)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationShearOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d6c1bdb781e8b5c96a01080bdc1c6abe913e19af333d6bdda069362d39d5408d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d77e29791fd5b8d3ca045e11b719ae56a431fc9e7ae56902822abe8a24d8e81f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b5b93d36a7410a299480c9fe8eeb39d461ebfaad4703b31ac32677898e8d70b1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationShear]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationShear]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationShear]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e7fde82cafc0d814faa51964c44059b6199e72d1ce263859978a56a4e144c617)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationShearOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationShearOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__57fa5bb58c4c29c2520aafd6d11b6b9edc4949ef60e4b5dffb86e5cc727c5067)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetXShear")
    def reset_x_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXShear", []))

    @jsii.member(jsii_name="resetXShearVar")
    def reset_x_shear_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXShearVar", []))

    @jsii.member(jsii_name="resetYShear")
    def reset_y_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYShear", []))

    @jsii.member(jsii_name="resetYShearVar")
    def reset_y_shear_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYShearVar", []))

    @builtins.property
    @jsii.member(jsii_name="xShearInput")
    def x_shear_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xShearInput"))

    @builtins.property
    @jsii.member(jsii_name="xShearVarInput")
    def x_shear_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xShearVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yShearInput")
    def y_shear_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yShearInput"))

    @builtins.property
    @jsii.member(jsii_name="yShearVarInput")
    def y_shear_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yShearVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xShear")
    def x_shear(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xShear"))

    @x_shear.setter
    def x_shear(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4b3694da84bb44d748562cd9d1047da4451cf0c9140ac20798bc3f7c5f55efc2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xShear", value)

    @builtins.property
    @jsii.member(jsii_name="xShearVar")
    def x_shear_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xShearVar"))

    @x_shear_var.setter
    def x_shear_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__71399019a07ae24f5a9d0aa075642109c2a5d62dda411a4cffb12ee3031a8271)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xShearVar", value)

    @builtins.property
    @jsii.member(jsii_name="yShear")
    def y_shear(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yShear"))

    @y_shear.setter
    def y_shear(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e69cbcaae9032a82ed300dca0fa5276b18ad142cff7ca56e0316d07cfab52513)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yShear", value)

    @builtins.property
    @jsii.member(jsii_name="yShearVar")
    def y_shear_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yShearVar"))

    @y_shear_var.setter
    def y_shear_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8c4b6bc3a5452c60d8ad706d07f8771f538fcbdddd844ffdc7ff0f80ab9b51eb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yShearVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationShear]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationShear]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationShear]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__55816ebae7a13bd3320f53f4c49f76416a2acfab0f49551b7ddbf73d232d1583)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationTrim",
    jsii_struct_bases=[],
    name_mapping={
        "fuzz": "fuzz",
        "fuzz_var": "fuzzVar",
        "padding": "padding",
        "padding_var": "paddingVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationTrim:
    def __init__(
        self,
        *,
        fuzz: typing.Optional[builtins.str] = None,
        fuzz_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fuzz: The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz DataAkamaiImagingPolicyImage#fuzz}
        :param fuzz_var: The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz_var DataAkamaiImagingPolicyImage#fuzz_var}
        :param padding: The amount of padding in pixels to add to the trimmed image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: The amount of padding in pixels to add to the trimmed image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8e0e405f42cc5febfadfc89073f742882cdf8132cd02306c09a49ee3b3e60cac)
            check_type(argname="argument fuzz", value=fuzz, expected_type=type_hints["fuzz"])
            check_type(argname="argument fuzz_var", value=fuzz_var, expected_type=type_hints["fuzz_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fuzz is not None:
            self._values["fuzz"] = fuzz
        if fuzz_var is not None:
            self._values["fuzz_var"] = fuzz_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var

    @builtins.property
    def fuzz(self) -> typing.Optional[builtins.str]:
        '''The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz DataAkamaiImagingPolicyImage#fuzz}
        '''
        result = self._values.get("fuzz")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fuzz_var(self) -> typing.Optional[builtins.str]:
        '''The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz_var DataAkamaiImagingPolicyImage#fuzz_var}
        '''
        result = self._values.get("fuzz_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''The amount of padding in pixels to add to the trimmed image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''The amount of padding in pixels to add to the trimmed image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationTrim(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationTrimList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationTrimList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5908487151a2883e92cc1660f26bf0fe4b515c31e97fbdaaf5fb3b53c7c5fdb1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationTrimOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__37a90995dbbcef22b9247a10bb163150946be78701ead30c0f7ef56e4b40bbae)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationTrimOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d6274a67b79ead082e418b61db937b68bff99af1d5461d07087f24290edaa99)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6cdd24a634dfe602cc8d50a024adcdc17f40c07cce77c48a50ccd57c6ee1a50a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__12d51f007202399780836c54bb161b88c3104c76d76cdb752a8f71be6d06a433)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationTrim]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationTrim]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationTrim]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df4df345a99abcb8994a8e420b0fe0714ece332d6f4b813baed31c298a16f0ea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationTrimOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationTrimOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e7bb1844cf776e4db6a0c134d340dc3d6f865f203531beb1f5dbc99de9202ddd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetFuzz")
    def reset_fuzz(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFuzz", []))

    @jsii.member(jsii_name="resetFuzzVar")
    def reset_fuzz_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFuzzVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @builtins.property
    @jsii.member(jsii_name="fuzzInput")
    def fuzz_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fuzzInput"))

    @builtins.property
    @jsii.member(jsii_name="fuzzVarInput")
    def fuzz_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fuzzVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="fuzz")
    def fuzz(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fuzz"))

    @fuzz.setter
    def fuzz(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__523ed0256f24a9b01e6bd268cc518ba003290a3d42ad14c0b33569ef720fc4b3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fuzz", value)

    @builtins.property
    @jsii.member(jsii_name="fuzzVar")
    def fuzz_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fuzzVar"))

    @fuzz_var.setter
    def fuzz_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7cd2dd67986ac901d2948ff1a4ab28051ffe6f8974f9b9d2d9e0a5b308333b61)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fuzzVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5a3c2f46e57de3c56d43c844bf43b6278cdab8f41cb4a89ff0a3c2aa1a4b7699)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eb18a2e81d95a5bfc5363ab2199ee62d72241752b0730e2a31ad568bfa1821cf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationTrim]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationTrim]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationTrim]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2b1a5fe62503aa4f5b066dfa69375f2db1d747d14b03e350f2e62ed3863b8112)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationUnsharpMask",
    jsii_struct_bases=[],
    name_mapping={
        "gain": "gain",
        "gain_var": "gainVar",
        "sigma": "sigma",
        "sigma_var": "sigmaVar",
        "threshold": "threshold",
        "threshold_var": "thresholdVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationUnsharpMask:
    def __init__(
        self,
        *,
        gain: typing.Optional[builtins.str] = None,
        gain_var: typing.Optional[builtins.str] = None,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
        threshold: typing.Optional[builtins.str] = None,
        threshold_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param gain: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        :param gain_var: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        :param sigma: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        :param threshold: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        :param threshold_var: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__22665cba862e78538fb62e6809bddc10ef1ee1da39dfa21b54e844dc36531d20)
            check_type(argname="argument gain", value=gain, expected_type=type_hints["gain"])
            check_type(argname="argument gain_var", value=gain_var, expected_type=type_hints["gain_var"])
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
            check_type(argname="argument threshold", value=threshold, expected_type=type_hints["threshold"])
            check_type(argname="argument threshold_var", value=threshold_var, expected_type=type_hints["threshold_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if gain is not None:
            self._values["gain"] = gain
        if gain_var is not None:
            self._values["gain_var"] = gain_var
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var
        if threshold is not None:
            self._values["threshold"] = threshold
        if threshold_var is not None:
            self._values["threshold_var"] = threshold_var

    @builtins.property
    def gain(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        '''
        result = self._values.get("gain")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gain_var(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        '''
        result = self._values.get("gain_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        '''
        result = self._values.get("threshold")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold_var(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        result = self._values.get("threshold_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationUnsharpMask(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationUnsharpMaskList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationUnsharpMaskList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c55d6911c401b8c6c26a916540f293e6eef39e2aab0307f5aba5021385d81410)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationUnsharpMaskOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__33db31ed18850f28b634491254b52e6b39a7969d1e2671a123d5d58c395de709)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationUnsharpMaskOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7c5677247006f89418420d74536db954d91cdbc6586cf5f119f78131b8578ddc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__306ec1901690c8afb03f7d36f20226963db22018b7876d973b7266cf7261996b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__191869563db9dc043eaecd53bce2bdecbc9f080d82c5e3570fe72849ac9a1996)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationUnsharpMask]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationUnsharpMask]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationUnsharpMask]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__db7b5730d2aadf3e5228902e5a8e0e42ff78382426fca510eb1fb148ff18df9e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationUnsharpMaskOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationUnsharpMaskOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4afd89d3c93a6d41679e4ba945632eb18b5b28f39142a8ac9f8151c004832dd9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetGain")
    def reset_gain(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGain", []))

    @jsii.member(jsii_name="resetGainVar")
    def reset_gain_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGainVar", []))

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @jsii.member(jsii_name="resetThreshold")
    def reset_threshold(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThreshold", []))

    @jsii.member(jsii_name="resetThresholdVar")
    def reset_threshold_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThresholdVar", []))

    @builtins.property
    @jsii.member(jsii_name="gainInput")
    def gain_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainInput"))

    @builtins.property
    @jsii.member(jsii_name="gainVarInput")
    def gain_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdInput")
    def threshold_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdVarInput")
    def threshold_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gain")
    def gain(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gain"))

    @gain.setter
    def gain(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__05710d6021382ea09c6040e9d4065e99bc6d50e4cf2e53ff4557f3d76dfde72f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gain", value)

    @builtins.property
    @jsii.member(jsii_name="gainVar")
    def gain_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gainVar"))

    @gain_var.setter
    def gain_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__07b3a91defc5a52feb691d36326e2c88074646773c21733997813fc589bff3ba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gainVar", value)

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7a48a491b6de5a66ba33f914aac05e0f17782b050c65d9f98c24204266cca38f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b6a679aff951a170eb4e86fc29a4e95f54683fba2b94a514ddafb6d4720e3786)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="threshold")
    def threshold(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "threshold"))

    @threshold.setter
    def threshold(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b25c55bdf5912baadec34140eabb0e64113f9a2cd7bb4a31735166e84b2d7064)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "threshold", value)

    @builtins.property
    @jsii.member(jsii_name="thresholdVar")
    def threshold_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "thresholdVar"))

    @threshold_var.setter
    def threshold_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1fc66f68570f3bf3271291a1fb4ea1a46381611700d3120f78b870a5a0b0daf0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "thresholdVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationUnsharpMask]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationUnsharpMask]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationUnsharpMask]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b08ab4664752c581631baecc1f895b6b8abfde4b7da4dc9bf2cd9cf9dfbe47c0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2e8a460aeb59dbf183e33d868ff06cf80c77952d26fd07e3e9f3c9753f4d5b09)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1aeb3e5250496928d40f726c2a25e291c71ef1052b9b1318899de74d2012c2d0)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a99ad15e243401056002c64845832c48685ee13ce1e85b501ac1e27ecb8fe52c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d980970348f9ce18bd3aa55b7de180ea67fa1b7944eaf3f6c0027bb282e0ef7d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__007a102c97fa8ab1fe6b6002df3d73978aa02484c9f18d3ccd9b7071b4dbea20)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFill]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFill]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFill]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8dfc6fb56293cddacb4bdb632009b3dff1e8a7611e3ae14178e524a73081f1b0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ae0307c4a027cece168f7d148a7b79554d6fc8eff44e2ebe0f6b08b9e893a8d5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putFillTransformation")
    def put_fill_transformation(
        self,
        *,
        append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationAppend, typing.Dict[builtins.str, typing.Any]]]]] = None,
        aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationAspectCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
        crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationFaceCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationFeatureCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationFitAndFill, typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
        im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationImQuery, typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
        region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationRegionOfInterestCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationRelativeCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
        resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationResize, typing.Dict[builtins.str, typing.Any]]]]] = None,
        rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationRotate, typing.Dict[builtins.str, typing.Any]]]]] = None,
        scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationScale, typing.Dict[builtins.str, typing.Any]]]]] = None,
        shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationShear, typing.Dict[builtins.str, typing.Any]]]]] = None,
        trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationTrim, typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param append: append block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        :param aspect_crop: aspect_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param crop: crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        :param face_crop: face_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        :param feature_crop: feature_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        :param fit_and_fill: fit_and_fill block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param im_query: im_query block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param region_of_interest_crop: region_of_interest_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        :param relative_crop: relative_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param resize: resize block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        :param rotate: rotate block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        :param scale: scale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param shear: shear block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        :param trim: trim block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformation(
            append=append,
            aspect_crop=aspect_crop,
            background_color=background_color,
            blur=blur,
            chroma_key=chroma_key,
            composite=composite,
            compound=compound,
            contrast=contrast,
            crop=crop,
            face_crop=face_crop,
            feature_crop=feature_crop,
            fit_and_fill=fit_and_fill,
            goop=goop,
            grayscale=grayscale,
            hsl=hsl,
            hsv=hsv,
            if_dimension=if_dimension,
            if_orientation=if_orientation,
            im_query=im_query,
            max_colors=max_colors,
            mirror=mirror,
            mono_hue=mono_hue,
            opacity=opacity,
            region_of_interest_crop=region_of_interest_crop,
            relative_crop=relative_crop,
            remove_color=remove_color,
            resize=resize,
            rotate=rotate,
            scale=scale,
            shear=shear,
            trim=trim,
            unsharp_mask=unsharp_mask,
        )

        return typing.cast(None, jsii.invoke(self, "putFillTransformation", [value]))

    @jsii.member(jsii_name="resetFillTransformation")
    def reset_fill_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFillTransformation", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="fillTransformation")
    def fill_transformation(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationOutputReference, jsii.get(self, "fillTransformation"))

    @builtins.property
    @jsii.member(jsii_name="fillTransformationInput")
    def fill_transformation_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformation], jsii.get(self, "fillTransformationInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__88297e655ccbd3163076efed071f467735778b220c739c07923a6b5b60c4d0c8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__23c690cbfddb70de29fc0e26333e8102f0261d832d3c1017ff62a3a946aba757)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c5e3c9a784507035fddbd88633620dd065b3c874a0d4e87c4f2dfcda2e50f1ee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__edb47fa4fcff0fc80f1d6d35931abdc47062462220be730865757b26a132418f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFill]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFill]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFill]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cdd1f4dbeb9fb7e0ae1c3dd6be85c27fb90b4a47d6de597745b8796f9056a25c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanGoop",
    jsii_struct_bases=[],
    name_mapping={
        "chaos": "chaos",
        "chaos_var": "chaosVar",
        "density": "density",
        "density_var": "densityVar",
        "power": "power",
        "power_var": "powerVar",
        "seed": "seed",
        "seed_var": "seedVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanGoop:
    def __init__(
        self,
        *,
        chaos: typing.Optional[builtins.str] = None,
        chaos_var: typing.Optional[builtins.str] = None,
        density: typing.Optional[builtins.str] = None,
        density_var: typing.Optional[builtins.str] = None,
        power: typing.Optional[builtins.str] = None,
        power_var: typing.Optional[builtins.str] = None,
        seed: typing.Optional[builtins.str] = None,
        seed_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param chaos: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        :param chaos_var: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        :param density: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        :param density_var: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        :param power: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        :param power_var: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        :param seed: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        :param seed_var: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__346ffc789752570602c38fe6760eae3252465d53dcb94782bc2a105e018552e1)
            check_type(argname="argument chaos", value=chaos, expected_type=type_hints["chaos"])
            check_type(argname="argument chaos_var", value=chaos_var, expected_type=type_hints["chaos_var"])
            check_type(argname="argument density", value=density, expected_type=type_hints["density"])
            check_type(argname="argument density_var", value=density_var, expected_type=type_hints["density_var"])
            check_type(argname="argument power", value=power, expected_type=type_hints["power"])
            check_type(argname="argument power_var", value=power_var, expected_type=type_hints["power_var"])
            check_type(argname="argument seed", value=seed, expected_type=type_hints["seed"])
            check_type(argname="argument seed_var", value=seed_var, expected_type=type_hints["seed_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if chaos is not None:
            self._values["chaos"] = chaos
        if chaos_var is not None:
            self._values["chaos_var"] = chaos_var
        if density is not None:
            self._values["density"] = density
        if density_var is not None:
            self._values["density_var"] = density_var
        if power is not None:
            self._values["power"] = power
        if power_var is not None:
            self._values["power_var"] = power_var
        if seed is not None:
            self._values["seed"] = seed
        if seed_var is not None:
            self._values["seed_var"] = seed_var

    @builtins.property
    def chaos(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        '''
        result = self._values.get("chaos")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def chaos_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        '''
        result = self._values.get("chaos_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        '''
        result = self._values.get("density")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density_var(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        '''
        result = self._values.get("density_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        '''
        result = self._values.get("power")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power_var(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        '''
        result = self._values.get("power_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        '''
        result = self._values.get("seed")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed_var(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        result = self._values.get("seed_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanGoop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanGoopList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanGoopList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__37caf54c7e9f8a9fcb550e57ef1062760043aa1b2126edfa576d4b8c3b626279)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanGoopOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fc09b387e66a2138753af6197a6dd5050d2772fb164009ce04262b120600bc73)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanGoopOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d9fd575b138761be4d4713ea665bcfc42b2fb5dbe05b1b70d3ccea3458b6743f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__030ec5aee6bb6a53b3730f56a044f7cce5385363a1303c9d77834c7acab98c99)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cf4845dcf861d92827e369c1efa55dce270a159c874b799b783c5189b7d90146)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanGoop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanGoop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be93d0ccde877aa50822bc225f22a8d142a1a2695691317e1c3a5618c00dbbd0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanGoopOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanGoopOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dbd9f962eb35685d7d6d172c8f87d3fa3e62a7040029d7004a7d9043220bf257)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetChaos")
    def reset_chaos(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaos", []))

    @jsii.member(jsii_name="resetChaosVar")
    def reset_chaos_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaosVar", []))

    @jsii.member(jsii_name="resetDensity")
    def reset_density(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensity", []))

    @jsii.member(jsii_name="resetDensityVar")
    def reset_density_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensityVar", []))

    @jsii.member(jsii_name="resetPower")
    def reset_power(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPower", []))

    @jsii.member(jsii_name="resetPowerVar")
    def reset_power_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPowerVar", []))

    @jsii.member(jsii_name="resetSeed")
    def reset_seed(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeed", []))

    @jsii.member(jsii_name="resetSeedVar")
    def reset_seed_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeedVar", []))

    @builtins.property
    @jsii.member(jsii_name="chaosInput")
    def chaos_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosInput"))

    @builtins.property
    @jsii.member(jsii_name="chaosVarInput")
    def chaos_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosVarInput"))

    @builtins.property
    @jsii.member(jsii_name="densityInput")
    def density_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityInput"))

    @builtins.property
    @jsii.member(jsii_name="densityVarInput")
    def density_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="powerInput")
    def power_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerInput"))

    @builtins.property
    @jsii.member(jsii_name="powerVarInput")
    def power_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerVarInput"))

    @builtins.property
    @jsii.member(jsii_name="seedInput")
    def seed_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedInput"))

    @builtins.property
    @jsii.member(jsii_name="seedVarInput")
    def seed_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedVarInput"))

    @builtins.property
    @jsii.member(jsii_name="chaos")
    def chaos(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaos"))

    @chaos.setter
    def chaos(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__16f291527df8c9edcdfd5d6c3e52bcf35014c3132038aa91e7cae5f985bcdb31)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaos", value)

    @builtins.property
    @jsii.member(jsii_name="chaosVar")
    def chaos_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaosVar"))

    @chaos_var.setter
    def chaos_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5b3f0afa23dfef1329b8e65b16d11cf38991f865ffc2ecab14dacb358bd04200)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaosVar", value)

    @builtins.property
    @jsii.member(jsii_name="density")
    def density(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "density"))

    @density.setter
    def density(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__04d284fd546be527452e0127899b7c22f79138289da0e1c81441fa351e031dc6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "density", value)

    @builtins.property
    @jsii.member(jsii_name="densityVar")
    def density_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "densityVar"))

    @density_var.setter
    def density_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ec8c3aee3884660b57eedd83538af288bfc21e42906bafe7afe11b14379e8de4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "densityVar", value)

    @builtins.property
    @jsii.member(jsii_name="power")
    def power(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "power"))

    @power.setter
    def power(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8da223f970626194ec419e1d2806795c89154df4acd8e17ed94a0103fc70b2fc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "power", value)

    @builtins.property
    @jsii.member(jsii_name="powerVar")
    def power_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "powerVar"))

    @power_var.setter
    def power_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__05f2e2e98e5131847a0f29f48d73199d5b9aa4682e6e6a796eb39532b4f572f2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "powerVar", value)

    @builtins.property
    @jsii.member(jsii_name="seed")
    def seed(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seed"))

    @seed.setter
    def seed(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b7e7119619f7e776f23313b1692f3d584d450425d66ad0a94345283be82e3dd0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seed", value)

    @builtins.property
    @jsii.member(jsii_name="seedVar")
    def seed_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seedVar"))

    @seed_var.setter
    def seed_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3d34c17094e1052095802cfd393233e3cc70eabca19da72e9d3fd52b34af5272)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seedVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanGoop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanGoop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanGoop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac9d727ac732ce9a1155c98eef9b78e354965e27e07d0fea9829e5f90dffc802)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanGrayscale",
    jsii_struct_bases=[],
    name_mapping={"type": "type", "type_var": "typeVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanGrayscale:
    def __init__(
        self,
        *,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param type: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f6f3a61907fb87a9867b8f3749650a40cb6d8e7b42ef74b9764a3eac815fe5f7)
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanGrayscale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanGrayscaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanGrayscaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dd66ed8717977c8381fb99d3baeced500b4847b0ba605c1ae6a65248fdcfb03e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanGrayscaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5be45adcf41b3b0043a713b676c9616487ebc55b65e9034c2161e729ffd7117a)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanGrayscaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ecb05ed929f927eb5a3f1461eaba07cd6f52a5d5115a28ccc5c9ce09175f6a13)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5d686671a1d18032b47b71dae2f1ee4fab5c61ad0d7dc0fe54ed2de51585dd8a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a75a3d122abedbbebe0e7c9ff39d71bbc31ab4925fbebf80e497ea862fcfeaf1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanGrayscale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanGrayscale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__725f8d46b764f5f24e9bbaf760d9020757c112f1050c1288472134cad56808ed)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanGrayscaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanGrayscaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__19544e4784968c04c50cc17c0bb5a4cf476e97d6e84333e4d80a9639654a7ceb)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__68745e9033605fde6bca6c56a0abbd077221a29009cae25e0b32f94b988ca968)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1c49cc5a23c70e169091e40cb06cb89222709efb7ce54299dc719eec0c91f045)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanGrayscale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanGrayscale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanGrayscale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a2e4b4267e382515e18f7113f1de2bd2a612a5aee9ebe6d183bcd2e43eb363a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanHsl",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "lightness": "lightness",
        "lightness_var": "lightnessVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanHsl:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness: typing.Optional[builtins.str] = None,
        lightness_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        :param lightness_var: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5d0bba8142da0516c56e645e685890e27c83f9e2c0cc70581520d21fb0142483)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness", value=lightness, expected_type=type_hints["lightness"])
            check_type(argname="argument lightness_var", value=lightness_var, expected_type=type_hints["lightness_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness is not None:
            self._values["lightness"] = lightness
        if lightness_var is not None:
            self._values["lightness_var"] = lightness_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        '''
        result = self._values.get("lightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        '''
        result = self._values.get("lightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanHsl(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanHslList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanHslList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__16d9f334c7782887c9ef253c482ed51ed0e2534842d9aae28108297967328498)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanHslOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ccd136ab95c29cd96c5f7c492ec016fc7c1054280a6c922b03a673e1d875405c)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanHslOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fed30a469af62ab8f06b428d6f0720ecca9ad594f424e5feea2aa5d4bc0dded8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__63e8d20a7a3b31d7aad47504a7cd8db31cfcab23274993979d46801012607513)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__037921f43d1f194962a58affb109660f885ec3bc836dd18209de422d73bd62ed)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanHsl]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanHsl]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__835f5633bce237ba284aa965d061d439dd6262622c262897ca8b18ab0a3bafb1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanHslOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanHslOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__150398e21c379fe7d4705f85891335cc51365153a6793d2864b4050ed16dff8f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightness")
    def reset_lightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightness", []))

    @jsii.member(jsii_name="resetLightnessVar")
    def reset_lightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessInput")
    def lightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessVarInput")
    def lightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a3128ddcaab5533f4558cab777db7b81ffee9bccaa373059f3f6d36682e3966)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8e27ebcb6a4b43458f438763b7f8b686f8041007200f548dec45f54116fa44ed)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightness")
    def lightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightness"))

    @lightness.setter
    def lightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__009db36769e028647f920f0ab4cfb0e502d79500c1962acd0a18af28793661da)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightness", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessVar")
    def lightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessVar"))

    @lightness_var.setter
    def lightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c66f0386864fab88136597a4d4ae094cb86831a17cd5debdbe0234b91375f41c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fc46a2bddc0561214c004f569c43fa5ffd3fcf4fc1d8ff490b4048298b374d68)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d57472fe164e762b21d7b44767ef5b613d23fb1a1edd3fe0059c05e7a498267e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanHsl]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanHsl]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanHsl]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cac73b1b35645fb8550010741d072cfc95e053a2e1b3736db3bcdf9a4dbe2e4e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanHsv",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanHsv:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        :param value: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__97317dfab16e3e8e6130a531a51a32c4c989533d5d9a803b340bcaff4c872489)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanHsv(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanHsvList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanHsvList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2bca61df58a086f7f869978b1bfa1cd94eb42b010ce1f785ff51cb8f88981c09)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanHsvOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c06b248f44323188609d4d80f06583c89743eb69706d50c407aba692b4935c1e)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanHsvOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d0c4d032a29a4514733df4711a48f74d344dddc37be18aad383a09ecd629871e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b1f56b4661ec64fe73281b987787f5285c63a231ab3385bd020c1937e4e040a8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ed6492c9c75ac89eff92ea976b891b9521621394499d8a2d5f6104695745c52)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanHsv]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanHsv]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__14f07babd06d289d0b186fcc78052d73a98ad320a40d3ff74f89b4249c6ad95c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanHsvOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanHsvOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__87945433b5519597cea76fba5ca4016a2381952de52adedfb81c4d6eadc8cf47)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3366425ed57be06a08b84c2b7c657680d186b1212179b9fb24cc854a41a6beba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a957a69c1c596702176c778ed81a937cecd3746de406813a4c6a4f1339830468)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__28bc20a599fd65f1641748fa20c8f9b63d1edf8bed3919efa4a171a0e4fa4364)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e25d9015a07bf1cb8ac4d1772a0696fa0030239ac72dc31be46c6dd7303b4566)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9dbd09a3d3ae44a7435310fa58889cba3ce2d41e36d455601a78c64541143851)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ef8e4ef0389c069cdbfac8ef8c9c3c4c2da87c57b94e49e1ac365b7cb5667a5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanHsv]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanHsv]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanHsv]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__84060c322c758c435fe1e362c5fa6e546dce61f28727b90e18b4a563eee751bc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientation",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "landscape": "landscape",
        "portrait": "portrait",
        "square": "square",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientation:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        landscape: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscape", typing.Dict[builtins.str, typing.Any]]] = None,
        portrait: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortrait", typing.Dict[builtins.str, typing.Any]]] = None,
        square: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquare", typing.Dict[builtins.str, typing.Any]]] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param landscape: landscape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        :param portrait: portrait block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        :param square: square block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefault(**default)
        if isinstance(landscape, dict):
            landscape = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscape(**landscape)
        if isinstance(portrait, dict):
            portrait = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortrait(**portrait)
        if isinstance(square, dict):
            square = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquare(**square)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b29248726801396265947010bd667e8a64b6c84cb614dc69dbe459cc9da825e5)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument landscape", value=landscape, expected_type=type_hints["landscape"])
            check_type(argname="argument portrait", value=portrait, expected_type=type_hints["portrait"])
            check_type(argname="argument square", value=square, expected_type=type_hints["square"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if landscape is not None:
            self._values["landscape"] = landscape
        if portrait is not None:
            self._values["portrait"] = portrait
        if square is not None:
            self._values["square"] = square

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefault"], result)

    @builtins.property
    def landscape(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscape"]:
        '''landscape block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        '''
        result = self._values.get("landscape")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscape"], result)

    @builtins.property
    def portrait(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortrait"]:
        '''portrait block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        '''
        result = self._values.get("portrait")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortrait"], result)

    @builtins.property
    def square(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquare"]:
        '''square block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        result = self._values.get("square")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquare"], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefault",
    jsii_struct_bases=[],
    name_mapping={
        "append": "append",
        "aspect_crop": "aspectCrop",
        "background_color": "backgroundColor",
        "blur": "blur",
        "chroma_key": "chromaKey",
        "composite": "composite",
        "compound": "compound",
        "contrast": "contrast",
        "crop": "crop",
        "face_crop": "faceCrop",
        "feature_crop": "featureCrop",
        "fit_and_fill": "fitAndFill",
        "goop": "goop",
        "grayscale": "grayscale",
        "hsl": "hsl",
        "hsv": "hsv",
        "if_dimension": "ifDimension",
        "if_orientation": "ifOrientation",
        "im_query": "imQuery",
        "max_colors": "maxColors",
        "mirror": "mirror",
        "mono_hue": "monoHue",
        "opacity": "opacity",
        "region_of_interest_crop": "regionOfInterestCrop",
        "relative_crop": "relativeCrop",
        "remove_color": "removeColor",
        "resize": "resize",
        "rotate": "rotate",
        "scale": "scale",
        "shear": "shear",
        "trim": "trim",
        "unsharp_mask": "unsharpMask",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefault:
    def __init__(
        self,
        *,
        append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultAppend", typing.Dict[builtins.str, typing.Any]]]]] = None,
        aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultAspectCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultBackgroundColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultBlur", typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultChromaKey", typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultComposite", typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCompound", typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultContrast", typing.Dict[builtins.str, typing.Any]]]]] = None,
        crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultFaceCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultFeatureCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultFitAndFill", typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultGoop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultGrayscale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultHsl", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultHsv", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimension", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientation", typing.Dict[builtins.str, typing.Any]]]]] = None,
        im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultImQuery", typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultMaxColors", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultMirror", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultMonoHue", typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultOpacity", typing.Dict[builtins.str, typing.Any]]]]] = None,
        region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRegionOfInterestCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRelativeCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRemoveColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultResize", typing.Dict[builtins.str, typing.Any]]]]] = None,
        rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRotate", typing.Dict[builtins.str, typing.Any]]]]] = None,
        scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultScale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultShear", typing.Dict[builtins.str, typing.Any]]]]] = None,
        trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultTrim", typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultUnsharpMask", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param append: append block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        :param aspect_crop: aspect_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param crop: crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        :param face_crop: face_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        :param feature_crop: feature_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        :param fit_and_fill: fit_and_fill block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param im_query: im_query block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param region_of_interest_crop: region_of_interest_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        :param relative_crop: relative_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param resize: resize block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        :param rotate: rotate block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        :param scale: scale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param shear: shear block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        :param trim: trim block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cb3834bca27908676a1a57850e9b29cf946c1a43d2a531b9fdbc8f2bfa41c359)
            check_type(argname="argument append", value=append, expected_type=type_hints["append"])
            check_type(argname="argument aspect_crop", value=aspect_crop, expected_type=type_hints["aspect_crop"])
            check_type(argname="argument background_color", value=background_color, expected_type=type_hints["background_color"])
            check_type(argname="argument blur", value=blur, expected_type=type_hints["blur"])
            check_type(argname="argument chroma_key", value=chroma_key, expected_type=type_hints["chroma_key"])
            check_type(argname="argument composite", value=composite, expected_type=type_hints["composite"])
            check_type(argname="argument compound", value=compound, expected_type=type_hints["compound"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument crop", value=crop, expected_type=type_hints["crop"])
            check_type(argname="argument face_crop", value=face_crop, expected_type=type_hints["face_crop"])
            check_type(argname="argument feature_crop", value=feature_crop, expected_type=type_hints["feature_crop"])
            check_type(argname="argument fit_and_fill", value=fit_and_fill, expected_type=type_hints["fit_and_fill"])
            check_type(argname="argument goop", value=goop, expected_type=type_hints["goop"])
            check_type(argname="argument grayscale", value=grayscale, expected_type=type_hints["grayscale"])
            check_type(argname="argument hsl", value=hsl, expected_type=type_hints["hsl"])
            check_type(argname="argument hsv", value=hsv, expected_type=type_hints["hsv"])
            check_type(argname="argument if_dimension", value=if_dimension, expected_type=type_hints["if_dimension"])
            check_type(argname="argument if_orientation", value=if_orientation, expected_type=type_hints["if_orientation"])
            check_type(argname="argument im_query", value=im_query, expected_type=type_hints["im_query"])
            check_type(argname="argument max_colors", value=max_colors, expected_type=type_hints["max_colors"])
            check_type(argname="argument mirror", value=mirror, expected_type=type_hints["mirror"])
            check_type(argname="argument mono_hue", value=mono_hue, expected_type=type_hints["mono_hue"])
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument region_of_interest_crop", value=region_of_interest_crop, expected_type=type_hints["region_of_interest_crop"])
            check_type(argname="argument relative_crop", value=relative_crop, expected_type=type_hints["relative_crop"])
            check_type(argname="argument remove_color", value=remove_color, expected_type=type_hints["remove_color"])
            check_type(argname="argument resize", value=resize, expected_type=type_hints["resize"])
            check_type(argname="argument rotate", value=rotate, expected_type=type_hints["rotate"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument shear", value=shear, expected_type=type_hints["shear"])
            check_type(argname="argument trim", value=trim, expected_type=type_hints["trim"])
            check_type(argname="argument unsharp_mask", value=unsharp_mask, expected_type=type_hints["unsharp_mask"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if append is not None:
            self._values["append"] = append
        if aspect_crop is not None:
            self._values["aspect_crop"] = aspect_crop
        if background_color is not None:
            self._values["background_color"] = background_color
        if blur is not None:
            self._values["blur"] = blur
        if chroma_key is not None:
            self._values["chroma_key"] = chroma_key
        if composite is not None:
            self._values["composite"] = composite
        if compound is not None:
            self._values["compound"] = compound
        if contrast is not None:
            self._values["contrast"] = contrast
        if crop is not None:
            self._values["crop"] = crop
        if face_crop is not None:
            self._values["face_crop"] = face_crop
        if feature_crop is not None:
            self._values["feature_crop"] = feature_crop
        if fit_and_fill is not None:
            self._values["fit_and_fill"] = fit_and_fill
        if goop is not None:
            self._values["goop"] = goop
        if grayscale is not None:
            self._values["grayscale"] = grayscale
        if hsl is not None:
            self._values["hsl"] = hsl
        if hsv is not None:
            self._values["hsv"] = hsv
        if if_dimension is not None:
            self._values["if_dimension"] = if_dimension
        if if_orientation is not None:
            self._values["if_orientation"] = if_orientation
        if im_query is not None:
            self._values["im_query"] = im_query
        if max_colors is not None:
            self._values["max_colors"] = max_colors
        if mirror is not None:
            self._values["mirror"] = mirror
        if mono_hue is not None:
            self._values["mono_hue"] = mono_hue
        if opacity is not None:
            self._values["opacity"] = opacity
        if region_of_interest_crop is not None:
            self._values["region_of_interest_crop"] = region_of_interest_crop
        if relative_crop is not None:
            self._values["relative_crop"] = relative_crop
        if remove_color is not None:
            self._values["remove_color"] = remove_color
        if resize is not None:
            self._values["resize"] = resize
        if rotate is not None:
            self._values["rotate"] = rotate
        if scale is not None:
            self._values["scale"] = scale
        if shear is not None:
            self._values["shear"] = shear
        if trim is not None:
            self._values["trim"] = trim
        if unsharp_mask is not None:
            self._values["unsharp_mask"] = unsharp_mask

    @builtins.property
    def append(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultAppend"]]]:
        '''append block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        '''
        result = self._values.get("append")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultAppend"]]], result)

    @builtins.property
    def aspect_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultAspectCrop"]]]:
        '''aspect_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        '''
        result = self._values.get("aspect_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultAspectCrop"]]], result)

    @builtins.property
    def background_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultBackgroundColor"]]]:
        '''background_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        '''
        result = self._values.get("background_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultBackgroundColor"]]], result)

    @builtins.property
    def blur(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultBlur"]]]:
        '''blur block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        '''
        result = self._values.get("blur")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultBlur"]]], result)

    @builtins.property
    def chroma_key(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultChromaKey"]]]:
        '''chroma_key block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        '''
        result = self._values.get("chroma_key")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultChromaKey"]]], result)

    @builtins.property
    def composite(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultComposite"]]]:
        '''composite block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        '''
        result = self._values.get("composite")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultComposite"]]], result)

    @builtins.property
    def compound(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCompound"]]]:
        '''compound block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        '''
        result = self._values.get("compound")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCompound"]]], result)

    @builtins.property
    def contrast(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultContrast"]]]:
        '''contrast block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultContrast"]]], result)

    @builtins.property
    def crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCrop"]]]:
        '''crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        '''
        result = self._values.get("crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCrop"]]], result)

    @builtins.property
    def face_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultFaceCrop"]]]:
        '''face_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        '''
        result = self._values.get("face_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultFaceCrop"]]], result)

    @builtins.property
    def feature_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultFeatureCrop"]]]:
        '''feature_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        '''
        result = self._values.get("feature_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultFeatureCrop"]]], result)

    @builtins.property
    def fit_and_fill(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultFitAndFill"]]]:
        '''fit_and_fill block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        '''
        result = self._values.get("fit_and_fill")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultFitAndFill"]]], result)

    @builtins.property
    def goop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultGoop"]]]:
        '''goop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        '''
        result = self._values.get("goop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultGoop"]]], result)

    @builtins.property
    def grayscale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultGrayscale"]]]:
        '''grayscale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        '''
        result = self._values.get("grayscale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultGrayscale"]]], result)

    @builtins.property
    def hsl(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultHsl"]]]:
        '''hsl block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        '''
        result = self._values.get("hsl")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultHsl"]]], result)

    @builtins.property
    def hsv(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultHsv"]]]:
        '''hsv block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        '''
        result = self._values.get("hsv")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultHsv"]]], result)

    @builtins.property
    def if_dimension(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimension"]]]:
        '''if_dimension block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        '''
        result = self._values.get("if_dimension")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimension"]]], result)

    @builtins.property
    def if_orientation(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientation"]]]:
        '''if_orientation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        '''
        result = self._values.get("if_orientation")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientation"]]], result)

    @builtins.property
    def im_query(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultImQuery"]]]:
        '''im_query block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        '''
        result = self._values.get("im_query")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultImQuery"]]], result)

    @builtins.property
    def max_colors(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultMaxColors"]]]:
        '''max_colors block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        '''
        result = self._values.get("max_colors")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultMaxColors"]]], result)

    @builtins.property
    def mirror(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultMirror"]]]:
        '''mirror block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        '''
        result = self._values.get("mirror")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultMirror"]]], result)

    @builtins.property
    def mono_hue(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultMonoHue"]]]:
        '''mono_hue block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        '''
        result = self._values.get("mono_hue")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultMonoHue"]]], result)

    @builtins.property
    def opacity(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultOpacity"]]]:
        '''opacity block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultOpacity"]]], result)

    @builtins.property
    def region_of_interest_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRegionOfInterestCrop"]]]:
        '''region_of_interest_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        '''
        result = self._values.get("region_of_interest_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRegionOfInterestCrop"]]], result)

    @builtins.property
    def relative_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRelativeCrop"]]]:
        '''relative_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        '''
        result = self._values.get("relative_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRelativeCrop"]]], result)

    @builtins.property
    def remove_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRemoveColor"]]]:
        '''remove_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        '''
        result = self._values.get("remove_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRemoveColor"]]], result)

    @builtins.property
    def resize(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultResize"]]]:
        '''resize block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        '''
        result = self._values.get("resize")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultResize"]]], result)

    @builtins.property
    def rotate(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRotate"]]]:
        '''rotate block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        '''
        result = self._values.get("rotate")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRotate"]]], result)

    @builtins.property
    def scale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultScale"]]]:
        '''scale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultScale"]]], result)

    @builtins.property
    def shear(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultShear"]]]:
        '''shear block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        '''
        result = self._values.get("shear")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultShear"]]], result)

    @builtins.property
    def trim(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultTrim"]]]:
        '''trim block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        '''
        result = self._values.get("trim")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultTrim"]]], result)

    @builtins.property
    def unsharp_mask(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultUnsharpMask"]]]:
        '''unsharp_mask block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        result = self._values.get("unsharp_mask")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultUnsharpMask"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultAppend",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_priority": "gravityPriority",
        "gravity_priority_var": "gravityPriorityVar",
        "gravity_var": "gravityVar",
        "preserve_minor_dimension": "preserveMinorDimension",
        "preserve_minor_dimension_var": "preserveMinorDimensionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultAppend:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultAppendImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_priority: typing.Optional[builtins.str] = None,
        gravity_priority_var: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        preserve_minor_dimension: typing.Optional[builtins.str] = None,
        preserve_minor_dimension_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Specifies where to place the ``image`` relative to the source image. The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_priority: Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal. The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority DataAkamaiImagingPolicyImage#gravity_priority}
        :param gravity_priority_var: Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal. The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority_var DataAkamaiImagingPolicyImage#gravity_priority_var}
        :param gravity_var: Specifies where to place the ``image`` relative to the source image. The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param preserve_minor_dimension: Whether to preserve the source image's minor dimension, ``false`` by default. The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension DataAkamaiImagingPolicyImage#preserve_minor_dimension}
        :param preserve_minor_dimension_var: Whether to preserve the source image's minor dimension, ``false`` by default. The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension_var DataAkamaiImagingPolicyImage#preserve_minor_dimension_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultAppendImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af0ad88de6d499dd1d5abc5b2be97768c4f708c9dd6d116e68c6afc0b87e9d30)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_priority", value=gravity_priority, expected_type=type_hints["gravity_priority"])
            check_type(argname="argument gravity_priority_var", value=gravity_priority_var, expected_type=type_hints["gravity_priority_var"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument preserve_minor_dimension", value=preserve_minor_dimension, expected_type=type_hints["preserve_minor_dimension"])
            check_type(argname="argument preserve_minor_dimension_var", value=preserve_minor_dimension_var, expected_type=type_hints["preserve_minor_dimension_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_priority is not None:
            self._values["gravity_priority"] = gravity_priority
        if gravity_priority_var is not None:
            self._values["gravity_priority_var"] = gravity_priority_var
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if preserve_minor_dimension is not None:
            self._values["preserve_minor_dimension"] = preserve_minor_dimension
        if preserve_minor_dimension_var is not None:
            self._values["preserve_minor_dimension_var"] = preserve_minor_dimension_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultAppendImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultAppendImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Specifies where to place the ``image`` relative to the source image.

        The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_priority(self) -> typing.Optional[builtins.str]:
        '''Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal.

        The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority DataAkamaiImagingPolicyImage#gravity_priority}
        '''
        result = self._values.get("gravity_priority")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_priority_var(self) -> typing.Optional[builtins.str]:
        '''Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal.

        The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority_var DataAkamaiImagingPolicyImage#gravity_priority_var}
        '''
        result = self._values.get("gravity_priority_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Specifies where to place the ``image`` relative to the source image.

        The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def preserve_minor_dimension(self) -> typing.Optional[builtins.str]:
        '''Whether to preserve the source image's minor dimension, ``false`` by default.

        The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension DataAkamaiImagingPolicyImage#preserve_minor_dimension}
        '''
        result = self._values.get("preserve_minor_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def preserve_minor_dimension_var(self) -> typing.Optional[builtins.str]:
        '''Whether to preserve the source image's minor dimension, ``false`` by default.

        The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension_var DataAkamaiImagingPolicyImage#preserve_minor_dimension_var}
        '''
        result = self._values.get("preserve_minor_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultAppend(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultAppendImage",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultAppendImage:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultAppendImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultAppendImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultAppendImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e41e084d95a28c5aa306791b145fd52a3d3ab9fea1fa7c16e813dc049173ab19)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultAppendImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultAppendImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultAppendImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3acdb2db679d6ee2d9b897d56e32bd59b1fa2ab81c099ebf052dae4e916f4641)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultAppendList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultAppendList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a75994cd8cae8463efc6bcfc2301bc0ad3991873af970867ddd9b5a7cc928ca6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultAppendOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eeee4809836c3de6d8195bf0f3215ec499b3f80e507b6a28a1605d6963a83bb4)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultAppendOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__907b90b76595ce71030a0d2c6efbc122425ffc0e5a5b3f38043edbfbd82d3525)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__82c0529972cd79cbb704ec1c02b77f6a51af160e2e9e9e64ffbaf7b75257cb0c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ec080980ea8fe230b431a06677962c9382330b088b35a4fd6d1fadc6153ff48)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultAppend]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultAppend]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultAppend]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__164025edd67719ec818a5e8103e68b8ac8eb5c0142ef2e083425103b7d68fd52)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultAppendOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultAppendOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7c0371c14fa0d36c53123f79c151eb77f6280278be1b23ab04146ce3c04add2d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultAppendImage()

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityPriority")
    def reset_gravity_priority(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityPriority", []))

    @jsii.member(jsii_name="resetGravityPriorityVar")
    def reset_gravity_priority_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityPriorityVar", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPreserveMinorDimension")
    def reset_preserve_minor_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPreserveMinorDimension", []))

    @jsii.member(jsii_name="resetPreserveMinorDimensionVar")
    def reset_preserve_minor_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPreserveMinorDimensionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultAppendImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultAppendImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityInput")
    def gravity_priority_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityPriorityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityVarInput")
    def gravity_priority_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityPriorityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultAppendImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultAppendImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionInput")
    def preserve_minor_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "preserveMinorDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionVarInput")
    def preserve_minor_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "preserveMinorDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5bf069abee4b94e2e3da45e2166d0c192512086d69adf0c7e2d093a8e065a049)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityPriority")
    def gravity_priority(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityPriority"))

    @gravity_priority.setter
    def gravity_priority(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0cb85734cc236122942dede263945fbcfa7504bfbfcff298edf77e6f31e3a43b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityPriority", value)

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityVar")
    def gravity_priority_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityPriorityVar"))

    @gravity_priority_var.setter
    def gravity_priority_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bbfbab4fc363a1623ebc924a1e41a9d3420bd9fc7dc9e8b9a7d34298d75cf39b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityPriorityVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__835903219980e61a9011f05d9caded1a602c09b4ffda184cbd1fdc9493f3bc92)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimension")
    def preserve_minor_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "preserveMinorDimension"))

    @preserve_minor_dimension.setter
    def preserve_minor_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af4945deca5c3c3282527073858e74a4e252b7825647c4b8a96fa9ff64a4c2e2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "preserveMinorDimension", value)

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionVar")
    def preserve_minor_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "preserveMinorDimensionVar"))

    @preserve_minor_dimension_var.setter
    def preserve_minor_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e9a7420ddc25484583e2a7b9e56ba3ff46a63682b26a6034205809c07100acfd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "preserveMinorDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultAppend]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultAppend]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultAppend]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__55ffbe1bd86ccaa7ddd653d2e2e028a6332b7b39f12adef3c8d08dd247010d5b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultAspectCrop",
    jsii_struct_bases=[],
    name_mapping={
        "allow_expansion": "allowExpansion",
        "allow_expansion_var": "allowExpansionVar",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultAspectCrop:
    def __init__(
        self,
        *,
        allow_expansion: typing.Optional[builtins.str] = None,
        allow_expansion_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_expansion: Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image. Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        :param allow_expansion_var: Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image. Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        :param height: The height term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The width term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        :param x_position: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a150045a8f9e02d14665217e040a8a46aacf3ff2b59204259de04de280978bb5)
            check_type(argname="argument allow_expansion", value=allow_expansion, expected_type=type_hints["allow_expansion"])
            check_type(argname="argument allow_expansion_var", value=allow_expansion_var, expected_type=type_hints["allow_expansion_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if allow_expansion is not None:
            self._values["allow_expansion"] = allow_expansion
        if allow_expansion_var is not None:
            self._values["allow_expansion_var"] = allow_expansion_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def allow_expansion(self) -> typing.Optional[builtins.str]:
        '''Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image.

        Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        '''
        result = self._values.get("allow_expansion")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def allow_expansion_var(self) -> typing.Optional[builtins.str]:
        '''Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image.

        Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        '''
        result = self._values.get("allow_expansion_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultAspectCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultAspectCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultAspectCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b9d5ca9166d403665d45e5344ffbebf1e801885259a7d677f29e89ce6a7acde8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultAspectCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd93185ed7da65664f2c8b3c1dc7eba9a6f9a00f661429b382c456954aa04954)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultAspectCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a5cbf402e26de094ef0308196301672c4a82c491353ee64cebdb2e63b6a80acb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a4ca88fb5308e3ac4352c1484bd628cc15c4a3cec141ecdc482c8a1f3500ee93)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a9133f6484369d17a05a727330c31a2759a3d0af472af24220c5a16446228b3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultAspectCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultAspectCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultAspectCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d9b34ac1200c76379a6c5dbf6d5c1099808cfa10421afb4c663f76aa09a82986)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultAspectCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultAspectCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4759305a98dfbf24d420bfa865aebea5e7953fb171514a5350b7bf842d759d86)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAllowExpansion")
    def reset_allow_expansion(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansion", []))

    @jsii.member(jsii_name="resetAllowExpansionVar")
    def reset_allow_expansion_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansionVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionInput")
    def allow_expansion_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVarInput")
    def allow_expansion_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansion")
    def allow_expansion(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansion"))

    @allow_expansion.setter
    def allow_expansion(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8ff362158dc0dfd870803f430db4077cc58865ae7832d95f0f04b0f688cc88ce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansion", value)

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVar")
    def allow_expansion_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansionVar"))

    @allow_expansion_var.setter
    def allow_expansion_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a5ae52ac802a7473a0685a2cb3a53cf5009a2ff50cbe512fca39adaf6d050b9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansionVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d7d0a69b0821017ae5985fa55f72d620811b71ff688d71bc07c4cb6f7d615995)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b3dd378a5b890ddb17c8be690987877e87932a1f088ad2b493f15a9c91898cb5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a0fa4e44ea2c5a21cb0b1de444c470a4d875e61776952f3238bd4fe088ae03e3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__836f4bc9756a3711149bfa20e026d4de7af6de703751c8ddd43e41faf87d914d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d92e86d1741adad918a232bb4664f0b5e4f64ea2d43ccfa7583ac42814a87ef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__db1b59d321030f7f73106831c2b5d4d198a699bc604b119acb7198c8f759da22)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__64dfdcc57120540b904f85d5bb96197093d502b91243d3cf22eafd30ef2dbf08)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__13a7690d85e5d2e8b53365245df154abad01dd349cc7de62e9cacce76c6cab66)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultAspectCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultAspectCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultAspectCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__57ee5a16203eeb44b994083a9be9397cc2b4bc88ba82357d3740ecfedd3a9744)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultBackgroundColor",
    jsii_struct_bases=[],
    name_mapping={"color": "color", "color_var": "colorVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultBackgroundColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__330482b280e57e3ed5f564f1b54482220cd9d4496063f832ae38cb2f28413da4)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultBackgroundColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultBackgroundColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultBackgroundColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__00ddf1e8c9e5abad6239e56805ec7d57030b63d21d1afc23e43defe60575274a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultBackgroundColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1a7f943437faa38c8ff2241e1469c345fda18c5193d1dcef3c0f526e1fa2649e)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultBackgroundColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d86fcc2633ae0901e27dcf45800db305060d709c7a8156ca2a268a31582c7ed)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ee3feaa380975b1b85598f5c4bec2edc7ba174cc0176815c43c7ac6020af4222)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__56050047a8bc4b35512d1722eb5f3d7f7d5006588f2134d3d85d19206deb6849)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultBackgroundColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultBackgroundColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a50ba396b05c34a4d3455f4a27637b797a7fae9cae4d310fa820c135d97cc12d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultBackgroundColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultBackgroundColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__939a5ea1b14333b32051e3e090434dc88d6ffe329565412b2e90a950ec00ffa5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d87a4979cfe7047860e83aeffebf3d79ab70b95b926053fb60f7450824d7956)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e2d7a5bd7ff2c444b7cbb559ee3b057f424b88e400fda220fd24d1d717fe2102)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultBackgroundColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultBackgroundColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultBackgroundColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c50a9ff8787eb74286a816c57481c100bb67721c88ad7634ad7e21f1ebc87c92)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultBlur",
    jsii_struct_bases=[],
    name_mapping={"sigma": "sigma", "sigma_var": "sigmaVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultBlur:
    def __init__(
        self,
        *,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param sigma: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f042bd957196a2960a2b1fbedc5f974d95594f3cb347e737044b9e07e4f6d338)
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultBlur(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultBlurList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultBlurList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1d467a1720f034a3ecb2773dc28699cf0a4baaceac0df8bf58c14bcb4bc2b4e9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultBlurOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__02cdd21ba86ef904179502624160640ab3072e21182775abf589d436203b2436)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultBlurOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d60793714e725650ae37085eb8ca9c1b54b9e045b4df691e728051e33cbf1d1e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6664f31859ff3353bc2e50b26ef425a53d9288f6cd7167a3e0fcde0c8294767b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ad77d7e3cf62f8179d62245df6f84e532ffe436a1652806ce3fdb7e104a3ac39)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultBlur]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultBlur]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__689fdf8f60239693560b9747bd5ea9d7a729e81640785048813c580cdfbe6864)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultBlurOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultBlurOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c1a7aecddb6169a5dd69c6a4a2da48b6dfa6a58817bb89adf5da7df2e9522712)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__98d987013f31ccf4fa10fb12fb16d78ebed4749fe253de8eebd6f65e7877aa86)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__916510355ca6be2fe8f223820dba773be34330d8a3076a89ef7ea04483b70f92)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultBlur]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultBlur]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultBlur]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b63982f77ea794daa7d16fdc34343a7dc3e13a5b29270e22015703759d7c18cc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultChromaKey",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_feather": "hueFeather",
        "hue_feather_var": "hueFeatherVar",
        "hue_tolerance": "hueTolerance",
        "hue_tolerance_var": "hueToleranceVar",
        "hue_var": "hueVar",
        "lightness_feather": "lightnessFeather",
        "lightness_feather_var": "lightnessFeatherVar",
        "lightness_tolerance": "lightnessTolerance",
        "lightness_tolerance_var": "lightnessToleranceVar",
        "saturation_feather": "saturationFeather",
        "saturation_feather_var": "saturationFeatherVar",
        "saturation_tolerance": "saturationTolerance",
        "saturation_tolerance_var": "saturationToleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultChromaKey:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_feather: typing.Optional[builtins.str] = None,
        hue_feather_var: typing.Optional[builtins.str] = None,
        hue_tolerance: typing.Optional[builtins.str] = None,
        hue_tolerance_var: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness_feather: typing.Optional[builtins.str] = None,
        lightness_feather_var: typing.Optional[builtins.str] = None,
        lightness_tolerance: typing.Optional[builtins.str] = None,
        lightness_tolerance_var: typing.Optional[builtins.str] = None,
        saturation_feather: typing.Optional[builtins.str] = None,
        saturation_feather_var: typing.Optional[builtins.str] = None,
        saturation_tolerance: typing.Optional[builtins.str] = None,
        saturation_tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_feather: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        :param hue_feather_var: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        :param hue_tolerance: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        :param hue_tolerance_var: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        :param hue_var: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness_feather: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        :param lightness_feather_var: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        :param lightness_tolerance: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        :param lightness_tolerance_var: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        :param saturation_feather: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        :param saturation_feather_var: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        :param saturation_tolerance: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        :param saturation_tolerance_var: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5855f841ed1533e45732bae1145d5c314b47d35d3e887d8b947329ad94521e3f)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_feather", value=hue_feather, expected_type=type_hints["hue_feather"])
            check_type(argname="argument hue_feather_var", value=hue_feather_var, expected_type=type_hints["hue_feather_var"])
            check_type(argname="argument hue_tolerance", value=hue_tolerance, expected_type=type_hints["hue_tolerance"])
            check_type(argname="argument hue_tolerance_var", value=hue_tolerance_var, expected_type=type_hints["hue_tolerance_var"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness_feather", value=lightness_feather, expected_type=type_hints["lightness_feather"])
            check_type(argname="argument lightness_feather_var", value=lightness_feather_var, expected_type=type_hints["lightness_feather_var"])
            check_type(argname="argument lightness_tolerance", value=lightness_tolerance, expected_type=type_hints["lightness_tolerance"])
            check_type(argname="argument lightness_tolerance_var", value=lightness_tolerance_var, expected_type=type_hints["lightness_tolerance_var"])
            check_type(argname="argument saturation_feather", value=saturation_feather, expected_type=type_hints["saturation_feather"])
            check_type(argname="argument saturation_feather_var", value=saturation_feather_var, expected_type=type_hints["saturation_feather_var"])
            check_type(argname="argument saturation_tolerance", value=saturation_tolerance, expected_type=type_hints["saturation_tolerance"])
            check_type(argname="argument saturation_tolerance_var", value=saturation_tolerance_var, expected_type=type_hints["saturation_tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_feather is not None:
            self._values["hue_feather"] = hue_feather
        if hue_feather_var is not None:
            self._values["hue_feather_var"] = hue_feather_var
        if hue_tolerance is not None:
            self._values["hue_tolerance"] = hue_tolerance
        if hue_tolerance_var is not None:
            self._values["hue_tolerance_var"] = hue_tolerance_var
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness_feather is not None:
            self._values["lightness_feather"] = lightness_feather
        if lightness_feather_var is not None:
            self._values["lightness_feather_var"] = lightness_feather_var
        if lightness_tolerance is not None:
            self._values["lightness_tolerance"] = lightness_tolerance
        if lightness_tolerance_var is not None:
            self._values["lightness_tolerance_var"] = lightness_tolerance_var
        if saturation_feather is not None:
            self._values["saturation_feather"] = saturation_feather
        if saturation_feather_var is not None:
            self._values["saturation_feather_var"] = saturation_feather_var
        if saturation_tolerance is not None:
            self._values["saturation_tolerance"] = saturation_tolerance
        if saturation_tolerance_var is not None:
            self._values["saturation_tolerance_var"] = saturation_tolerance_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        '''
        result = self._values.get("hue_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        '''
        result = self._values.get("hue_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        '''
        result = self._values.get("hue_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        '''
        result = self._values.get("hue_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        '''
        result = self._values.get("lightness_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        '''
        result = self._values.get("lightness_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        '''
        result = self._values.get("lightness_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        '''
        result = self._values.get("lightness_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        '''
        result = self._values.get("saturation_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        '''
        result = self._values.get("saturation_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        '''
        result = self._values.get("saturation_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        result = self._values.get("saturation_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultChromaKey(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultChromaKeyList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultChromaKeyList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b43c43fa9174e23fcd96a1fa7e407af0d0347d75465ef796056a923f4641da13)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultChromaKeyOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ead8f9660b25538a28222a96614aa316c604a5142955e6ca222e20f58c734d3)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultChromaKeyOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4540662117572312efcfd992bcc1ea12bfd19a206dacdf17b6bf63337b2c0ef7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d63f302a4c6d43cd29f53977190fc28bb53e6928cdab670740eeb06201356530)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e8ed96eab15721cd8a0819ac905463750cd3cab4d94d21e6353506cfbd5dfdba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultChromaKey]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultChromaKey]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__14595f06756fcc7e13066b1278e3ed3c3711d55bc54e4f4420a84de65fff8bfa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultChromaKeyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultChromaKeyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1681044069c6681f3d3b273c545e1837246c5c767539bd7ffb7244778df3b58a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueFeather")
    def reset_hue_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeather", []))

    @jsii.member(jsii_name="resetHueFeatherVar")
    def reset_hue_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeatherVar", []))

    @jsii.member(jsii_name="resetHueTolerance")
    def reset_hue_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueTolerance", []))

    @jsii.member(jsii_name="resetHueToleranceVar")
    def reset_hue_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueToleranceVar", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightnessFeather")
    def reset_lightness_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeather", []))

    @jsii.member(jsii_name="resetLightnessFeatherVar")
    def reset_lightness_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeatherVar", []))

    @jsii.member(jsii_name="resetLightnessTolerance")
    def reset_lightness_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessTolerance", []))

    @jsii.member(jsii_name="resetLightnessToleranceVar")
    def reset_lightness_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessToleranceVar", []))

    @jsii.member(jsii_name="resetSaturationFeather")
    def reset_saturation_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeather", []))

    @jsii.member(jsii_name="resetSaturationFeatherVar")
    def reset_saturation_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeatherVar", []))

    @jsii.member(jsii_name="resetSaturationTolerance")
    def reset_saturation_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationTolerance", []))

    @jsii.member(jsii_name="resetSaturationToleranceVar")
    def reset_saturation_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherInput")
    def hue_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVarInput")
    def hue_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceInput")
    def hue_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVarInput")
    def hue_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherInput")
    def lightness_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVarInput")
    def lightness_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceInput")
    def lightness_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVarInput")
    def lightness_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherInput")
    def saturation_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVarInput")
    def saturation_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceInput")
    def saturation_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVarInput")
    def saturation_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a990d453e1500939ef9a35a7908283912904c0da444f8bd61cd80f6a61c8877f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeather")
    def hue_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeather"))

    @hue_feather.setter
    def hue_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__434f8aeeb3070df504fdd12c4eb6072fb7e8a512fc52a754b6c98696946dfec0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeather", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVar")
    def hue_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeatherVar"))

    @hue_feather_var.setter
    def hue_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__82b33a33a7d33d9980043e7a27a249ccfcf481153bf0d6f497949e793ee16b22)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueTolerance")
    def hue_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueTolerance"))

    @hue_tolerance.setter
    def hue_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2c48bf323eba60366610382cb3fac57a65b392312491a8b355ca919e079afa34)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVar")
    def hue_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueToleranceVar"))

    @hue_tolerance_var.setter
    def hue_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8930c31a074e584f84c9d0b4f21dc13877a4d19bae8c0fac629022000f6028d3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__684f50c048a18437c95644782f695043683cf590fb7657ea14359c6c3092aa8a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeather")
    def lightness_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeather"))

    @lightness_feather.setter
    def lightness_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__90bf6fb4447e29acce93af2a95fe0315da4ccf3688b0f458d0e862e2d8f1c76f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeather", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVar")
    def lightness_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeatherVar"))

    @lightness_feather_var.setter
    def lightness_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__adf3ae934e1997a2eb997c9ef5232be08b25d3865749a2ee279c4ef20a912c90)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessTolerance")
    def lightness_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessTolerance"))

    @lightness_tolerance.setter
    def lightness_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__88f7611fd6511553baf61e248d513cb495738b61e1626fd49875bbccd3c2bfba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVar")
    def lightness_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessToleranceVar"))

    @lightness_tolerance_var.setter
    def lightness_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b56d668ebc512f8c998b48ab24f2f7716bdcc0aa7cab57ca77a87aabe0fa2e27)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeather")
    def saturation_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeather"))

    @saturation_feather.setter
    def saturation_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__51d30ba0fd31024b7e93ecb863d105eca72389b5509f95cb60fdb4eaada624e4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeather", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVar")
    def saturation_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeatherVar"))

    @saturation_feather_var.setter
    def saturation_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aecbf57860e1b7341db92ec70f1b9de89c9281997e95094f2121f4b878a3a8ba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationTolerance")
    def saturation_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationTolerance"))

    @saturation_tolerance.setter
    def saturation_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__69c0ed2ed8c7209c948e0f7a8e1b1b3c7bf21aa30ad92eebd939c60990401a65)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVar")
    def saturation_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationToleranceVar"))

    @saturation_tolerance_var.setter
    def saturation_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f35788c33769c15f1965acbb3d2ffd5ded828bd21af7c7b9f4c6d7adef37125e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultChromaKey]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultChromaKey]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultChromaKey]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f77f382008cf18f23527580bf828f3c0b3c72640c9fac7c00d954cd6b4955115)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultComposite",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "placement": "placement",
        "placement_var": "placementVar",
        "scale": "scale",
        "scale_dimension": "scaleDimension",
        "scale_dimension_var": "scaleDimensionVar",
        "scale_var": "scaleVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultComposite:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCompositeImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        placement: typing.Optional[builtins.str] = None,
        placement_var: typing.Optional[builtins.str] = None,
        scale: typing.Optional[builtins.str] = None,
        scale_dimension: typing.Optional[builtins.str] = None,
        scale_dimension_var: typing.Optional[builtins.str] = None,
        scale_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param placement: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        :param placement_var: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        :param scale: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param scale_dimension: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        :param scale_dimension_var: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        :param scale_var: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        :param x_position: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCompositeImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e4e149f81cfbde3203d34f521cfae6dab959c51b3d6ed0d5e7416c9a60c4cf2a)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument placement", value=placement, expected_type=type_hints["placement"])
            check_type(argname="argument placement_var", value=placement_var, expected_type=type_hints["placement_var"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument scale_dimension", value=scale_dimension, expected_type=type_hints["scale_dimension"])
            check_type(argname="argument scale_dimension_var", value=scale_dimension_var, expected_type=type_hints["scale_dimension_var"])
            check_type(argname="argument scale_var", value=scale_var, expected_type=type_hints["scale_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if placement is not None:
            self._values["placement"] = placement
        if placement_var is not None:
            self._values["placement_var"] = placement_var
        if scale is not None:
            self._values["scale"] = scale
        if scale_dimension is not None:
            self._values["scale_dimension"] = scale_dimension
        if scale_dimension_var is not None:
            self._values["scale_dimension_var"] = scale_dimension_var
        if scale_var is not None:
            self._values["scale_var"] = scale_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCompositeImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCompositeImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        '''
        result = self._values.get("placement")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement_var(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        '''
        result = self._values.get("placement_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        '''
        result = self._values.get("scale_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        '''
        result = self._values.get("scale_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        '''
        result = self._values.get("scale_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultComposite(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCompositeImage",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCompositeImage:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCompositeImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCompositeImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCompositeImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8e4479a7aa044717a05a9ee17d38324daa8b350b66143f9152a60317a1a9c5ae)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCompositeImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCompositeImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ea0ae2f329dcc33107f28958ea7f09163db263b5274d131c64bdc67b9b84562)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCompositeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCompositeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e34c6072f33598859d0ad8b6bdfe1c0b0065d89feb26c2bebddc52a5dc3e3526)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCompositeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ce069063ea79f374c13bc113ebba0618d32a5b3e4048ac144335716f23cf4062)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCompositeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__87d75e0d9383f12d20aa3379a252e792b9d9ae242a231fd1a40f985384ce5280)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0f4ea65342415b5c52455d3799b083cec1fd4e40f1b925e658cef84a8b205f6b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1ebd155434cae380cbb11761cc27596f6846cf2914e62727af89f56f4c2bfa2b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultComposite]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultComposite]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4d051ab95bb4ba3f8a7f6d869e2f090979c0d2fc5516545028df32fa68cc6a02)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCompositeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCompositeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d2d64d63f79b68c7bd1faa0f0b30813cfd74c2110367e5afa643c25f1225fcd0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCompositeImage()

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPlacement")
    def reset_placement(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacement", []))

    @jsii.member(jsii_name="resetPlacementVar")
    def reset_placement_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacementVar", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetScaleDimension")
    def reset_scale_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimension", []))

    @jsii.member(jsii_name="resetScaleDimensionVar")
    def reset_scale_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimensionVar", []))

    @jsii.member(jsii_name="resetScaleVar")
    def reset_scale_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCompositeImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCompositeImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCompositeImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="placementInput")
    def placement_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementInput"))

    @builtins.property
    @jsii.member(jsii_name="placementVarInput")
    def placement_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionInput")
    def scale_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVarInput")
    def scale_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleVarInput")
    def scale_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8133dcd4b6044d7c87b55cc3bda13418b82e09e16a46e4f52e585cc9cdf891b3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__16b7897490aaca046cf82bc0de0567ecd3b24dd15e4aadcb79ff01ed4893ec14)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="placement")
    def placement(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placement"))

    @placement.setter
    def placement(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1401f1a45145017446b37fe435f99a1f5a73855d88ebfaaa2d3c07fc4c9b3d06)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placement", value)

    @builtins.property
    @jsii.member(jsii_name="placementVar")
    def placement_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placementVar"))

    @placement_var.setter
    def placement_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea1b9aa0ad09b83ed528263a543d7ade350b32c22d1a6c5201659ad5de6265cc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placementVar", value)

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scale"))

    @scale.setter
    def scale(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6ae0480a5aec434bef1dfdb6b87721527b575be7f5fb14c0f3390adf2fb7355a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scale", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimension")
    def scale_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimension"))

    @scale_dimension.setter
    def scale_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__50f0cc7f169fb5e7733b9c61523c3e65009bb1f1d12921a3d9c764b9ae25e39f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimension", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVar")
    def scale_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimensionVar"))

    @scale_dimension_var.setter
    def scale_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__342979d9426877f32420ec5a7912ea933806a57b7d0bf3898d905c7ed1e6f896)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="scaleVar")
    def scale_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleVar"))

    @scale_var.setter
    def scale_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__79ea8d2a89e35a0ff59a468a523bd0bccea36bf5fe7a9b832ef80aa1707fd73e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__17a49da3d1e77c834a5e6b05bed4141ed44bcde254b3f23e30113327fef77de3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__92110f82b09f44b8598f647c36133ca779fb7a51138065cd92331b74475aa16a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e164ff4e8967be5ab518380d25e0245b84db739bc7005e51872a3b35ccb6daf8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7e4bff3200bf2ad4d1dd48f1d826575d68eeeae06024eca432ad09a56719ee73)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultComposite]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultComposite]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultComposite]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7024f09a7668968338f57668769e2c6c63ca31d0aeb96b9bdd258ac682d4363e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCompound",
    jsii_struct_bases=[],
    name_mapping={"transformations": "transformations"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCompound:
    def __init__(
        self,
        *,
        transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param transformations: transformations block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9cd75385789c21447f15343651850f85bf1a43905d423e620c7630e4cd66dd85)
            check_type(argname="argument transformations", value=transformations, expected_type=type_hints["transformations"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if transformations is not None:
            self._values["transformations"] = transformations

    @builtins.property
    def transformations(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCompoundTransformations"]]]:
        '''transformations block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        result = self._values.get("transformations")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCompoundTransformations"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCompound(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCompoundList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCompoundList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6957d5c136c1d5e60493b101c04909e2bcf4b2a3e3466004953e7ce8bde012bb)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCompoundOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__078e811962f384d3033a120af6630896ed510c6912e20af2ff56efc4a5109dbe)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCompoundOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1321544fbc2733df9f7980c1b3a0922f43995516dddd3d7b3c9b277709b19c55)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7ab3506ee487e6b644f8446c6aecb934baa2eeddc2e9fadba6e993bb6d8dcf3a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__71feda8adac30d19c6e6bc60a5b6044ecfd6e694f13b4081ae89c599cfb4e6bd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCompound]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCompound]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c9df9099925839203d3b2ee066177391a2e54968fd9003bd6c2c6d6568dfbbd5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCompoundOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCompoundOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3102afbcc95a50dcf6532f67378bb4898350b534498181543e89711725266010)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformations")
    def put_transformations(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c009a9ba1a92eb34c06a23d3153a6cca198b619653b3155d91475b29399d8450)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTransformations", [value]))

    @jsii.member(jsii_name="resetTransformations")
    def reset_transformations(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformations", []))

    @builtins.property
    @jsii.member(jsii_name="transformations")
    def transformations(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCompoundTransformationsList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCompoundTransformationsList", jsii.get(self, "transformations"))

    @builtins.property
    @jsii.member(jsii_name="transformationsInput")
    def transformations_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCompoundTransformations"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCompoundTransformations"]]], jsii.get(self, "transformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCompound]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCompound]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCompound]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__02252783a486b7a45cb01c5d604ec981d2c8b793ef4610fef7975e82d4998f93)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCompoundTransformations",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCompoundTransformations:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCompoundTransformations(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCompoundTransformationsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCompoundTransformationsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f30b74f2df61fe51b49ea4cddc5e9454d9074b16335338e558a3b85dbe268910)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCompoundTransformationsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4793b99850a1b20c03a419fdc2715bb5a786f088ca9216e668bc6919f788a8ac)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCompoundTransformationsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e0e46cf954eecb1e23a52e398f1075a4bd2c0f223dd09ed0d864f02459a93e9a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3b96136cd8057434573d2e3cd0664c0c121ced18b85f564f10e8c0abbdf27418)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__485d428c60ccefa36376ae5d52cc2508ec8f17ca38074e4a4754ab33e0d2d9ad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCompoundTransformations]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCompoundTransformations]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCompoundTransformations]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c17a09e99c471f4d3e3e9507de7b1a061fc1a645dbeb73e814f82a1220061921)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCompoundTransformationsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCompoundTransformationsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__64e2329b64526696b3d082034592ea3ca52282c3ed5291111849060b944265ac)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCompoundTransformations]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCompoundTransformations]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCompoundTransformations]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dd6ef0757c7029092165bb88e83205097dc3d1d5a42d24e77b7eec2951e84cbc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultContrast",
    jsii_struct_bases=[],
    name_mapping={
        "brightness": "brightness",
        "brightness_var": "brightnessVar",
        "contrast": "contrast",
        "contrast_var": "contrastVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultContrast:
    def __init__(
        self,
        *,
        brightness: typing.Optional[builtins.str] = None,
        brightness_var: typing.Optional[builtins.str] = None,
        contrast: typing.Optional[builtins.str] = None,
        contrast_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param brightness: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        :param brightness_var: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        :param contrast: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param contrast_var: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__62da7f918057c24961825a5e385a9fcc88fa4d22929eb1e449ea159ed744be0c)
            check_type(argname="argument brightness", value=brightness, expected_type=type_hints["brightness"])
            check_type(argname="argument brightness_var", value=brightness_var, expected_type=type_hints["brightness_var"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument contrast_var", value=contrast_var, expected_type=type_hints["contrast_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if brightness is not None:
            self._values["brightness"] = brightness
        if brightness_var is not None:
            self._values["brightness_var"] = brightness_var
        if contrast is not None:
            self._values["contrast"] = contrast
        if contrast_var is not None:
            self._values["contrast_var"] = contrast_var

    @builtins.property
    def brightness(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        '''
        result = self._values.get("brightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def brightness_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        '''
        result = self._values.get("brightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        result = self._values.get("contrast_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultContrast(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultContrastList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultContrastList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__00e67bb21776815c8b8f7ce8458c9dbc9e4d7b0e676cc4a445ff776b3da1dc55)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultContrastOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a5a8c4c467b2c3091c265e58368e703f7d5c19006b2aebc373643dda111e8b49)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultContrastOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f0b068164df8540523f4d60f61000bfdf1cb771491239040aa01c0b40916a8e1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d12dc9ed218b1d34b50551f1689a35abe493205daf4551cb6cfce70155c51803)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__361a20bb84a7a617577a1e985887d0dfe1d142e6f51e2c9f7a2c74c0f329db89)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultContrast]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultContrast]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ca4901d0a46acc14b0cf401fbaf30fb95d7d8d1f77bf4f50b0154985f9d05204)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultContrastOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultContrastOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__01ab2074d080e4453170b73a5a451d4227659ad36e904ced86c37ca1cd4c6319)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetBrightness")
    def reset_brightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightness", []))

    @jsii.member(jsii_name="resetBrightnessVar")
    def reset_brightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightnessVar", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetContrastVar")
    def reset_contrast_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrastVar", []))

    @builtins.property
    @jsii.member(jsii_name="brightnessInput")
    def brightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="brightnessVarInput")
    def brightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastVarInput")
    def contrast_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="brightness")
    def brightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightness"))

    @brightness.setter
    def brightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2b7cc460f9ad9631b6de9c458fd478bda5b2b06349dc1808493efe5e93c9926e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightness", value)

    @builtins.property
    @jsii.member(jsii_name="brightnessVar")
    def brightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightnessVar"))

    @brightness_var.setter
    def brightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ee7790079f0298b4e594700b1920fb14b2b95af56bbdfbe861409dc05a67b037)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrast"))

    @contrast.setter
    def contrast(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bede8e0e1a6673cf3ebf4a19b82802dee3c8cec05c639e31b8318435d2c81564)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrast", value)

    @builtins.property
    @jsii.member(jsii_name="contrastVar")
    def contrast_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrastVar"))

    @contrast_var.setter
    def contrast_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5b2e0430bb49832a5a16ab5e17da314ba8c5ccdacb20badf46c712b570537428)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrastVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultContrast]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultContrast]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultContrast]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4b984a8699c2c419d0ec0c221a05dcf2ee71430337463c651212d8ae66e3f297)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCrop",
    jsii_struct_bases=[],
    name_mapping={
        "allow_expansion": "allowExpansion",
        "allow_expansion_var": "allowExpansionVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCrop:
    def __init__(
        self,
        *,
        allow_expansion: typing.Optional[builtins.str] = None,
        allow_expansion_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_expansion: If cropping an area outside of the existing canvas, expands the image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        :param allow_expansion_var: If cropping an area outside of the existing canvas, expands the image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        :param gravity: Frame of reference for X and Y Positions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Frame of reference for X and Y Positions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The number of pixels to crop along the y-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The number of pixels to crop along the y-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The number of pixels to crop along the x-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The number of pixels to crop along the x-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        :param x_position: The x-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ff0195231af6cc367561ad4461344645b0b7bfe8c5496fbcdab655274c3dd6e3)
            check_type(argname="argument allow_expansion", value=allow_expansion, expected_type=type_hints["allow_expansion"])
            check_type(argname="argument allow_expansion_var", value=allow_expansion_var, expected_type=type_hints["allow_expansion_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if allow_expansion is not None:
            self._values["allow_expansion"] = allow_expansion
        if allow_expansion_var is not None:
            self._values["allow_expansion_var"] = allow_expansion_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def allow_expansion(self) -> typing.Optional[builtins.str]:
        '''If cropping an area outside of the existing canvas, expands the image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        '''
        result = self._values.get("allow_expansion")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def allow_expansion_var(self) -> typing.Optional[builtins.str]:
        '''If cropping an area outside of the existing canvas, expands the image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        '''
        result = self._values.get("allow_expansion_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Frame of reference for X and Y Positions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Frame of reference for X and Y Positions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the y-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the y-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the x-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the x-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e7435e40a1063c1db9c60bb2b6c3fb63120d865bf477b01bb70db3e5e14fd955)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6aaa09d9523f895fcf6e95e08a9e5435b35cb0c53bdec69c044cc6532c530030)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3215ba93ff87f3a2d06994e062ad3e5f755cddd05f31af18fcce8879f9984088)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d58c22e2309f0191588d3abbf8a67e1c74dd2984355918dd274e87add61fa5bc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7e146bbcc9129ba09c9e4bcb593b5a817cb740acc9f15496d791481c107b107c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b25e256f11f677fb4665fcd155e2e5f507ce6f89c04e9cc65161281cca727f7e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9b9e5cf573ac051bd83ee1cbe016546caa02652c749102245d74c15abb90f90e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAllowExpansion")
    def reset_allow_expansion(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansion", []))

    @jsii.member(jsii_name="resetAllowExpansionVar")
    def reset_allow_expansion_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansionVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionInput")
    def allow_expansion_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVarInput")
    def allow_expansion_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansion")
    def allow_expansion(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansion"))

    @allow_expansion.setter
    def allow_expansion(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4344b414db08869efd70cb4ea039835da14d73d01ec261ea782beee0b17c50cd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansion", value)

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVar")
    def allow_expansion_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansionVar"))

    @allow_expansion_var.setter
    def allow_expansion_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7070b69beb5fe39a37355472aa54ae3d957f77c8f835d9a9a8cd66224fc1cc96)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansionVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc22faaf9bc62d45f1f066ede99f9427804d942cbc868e216edb9bbf62e75328)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f01ac1b1eb1632fe4b37929f6731b7296b60b27058625795a281502ff64e0fb0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fb39d7af0f041b77cd68a761dc41c1fb9824f6bdaa5687447bdf3a86f689d53d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b60c54ab942fd91b52e769bb1779b257fa50a8842c4e381de11ac995ecfe430f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6d00ed9baf1aca9f51c87f40f5e092693d322adfa7136b28ec1b487ced463171)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dbe766da4ba9b82c9a699e118f333d2d0669504c785486d8c410f8fe98eff77b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__05b6325cfcb04e320752d113edcdfde0b4408b3879aedecc84a3269c292a945d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__835a0c24e31903b0bb1574e5535469a9443ab54e2a57588c563ca6798a30ff7f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1017e358db16aaf915905390a11b61624d022f991fb5848c5f9d4df860158c03)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a0af46731c9f13b8ee4feab0d441ec7bc99abcee8bb1cb8c21ae8b06ff9dd919)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__617c83ee350eb3f65f7aca14c8f2533f3c64cce4083a6c8fedf73c819867f40d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultFaceCrop",
    jsii_struct_bases=[],
    name_mapping={
        "algorithm": "algorithm",
        "algorithm_var": "algorithmVar",
        "confidence": "confidence",
        "confidence_var": "confidenceVar",
        "fail_gravity": "failGravity",
        "fail_gravity_var": "failGravityVar",
        "focus": "focus",
        "focus_var": "focusVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "padding": "padding",
        "padding_var": "paddingVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultFaceCrop:
    def __init__(
        self,
        *,
        algorithm: typing.Optional[builtins.str] = None,
        algorithm_var: typing.Optional[builtins.str] = None,
        confidence: typing.Optional[builtins.str] = None,
        confidence_var: typing.Optional[builtins.str] = None,
        fail_gravity: typing.Optional[builtins.str] = None,
        fail_gravity_var: typing.Optional[builtins.str] = None,
        focus: typing.Optional[builtins.str] = None,
        focus_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param algorithm: Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm DataAkamaiImagingPolicyImage#algorithm}
        :param algorithm_var: Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm_var DataAkamaiImagingPolicyImage#algorithm_var}
        :param confidence: With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image. Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence DataAkamaiImagingPolicyImage#confidence}
        :param confidence_var: With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image. Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence_var DataAkamaiImagingPolicyImage#confidence_var}
        :param fail_gravity: Controls placement of the crop if Image and Video Manager does not detect any faces in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        :param fail_gravity_var: Controls placement of the crop if Image and Video Manager does not detect any faces in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        :param focus: Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus DataAkamaiImagingPolicyImage#focus}
        :param focus_var: Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus_var DataAkamaiImagingPolicyImage#focus_var}
        :param gravity: Controls placement of the crop. Directions are relative to the face(s) plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Controls placement of the crop. Directions are relative to the face(s) plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param padding: The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        :param style: Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__416d1fff8f4c3ead858f3472f07b9a8bdfd68398aa2fc9cc5f15d976735b1cdd)
            check_type(argname="argument algorithm", value=algorithm, expected_type=type_hints["algorithm"])
            check_type(argname="argument algorithm_var", value=algorithm_var, expected_type=type_hints["algorithm_var"])
            check_type(argname="argument confidence", value=confidence, expected_type=type_hints["confidence"])
            check_type(argname="argument confidence_var", value=confidence_var, expected_type=type_hints["confidence_var"])
            check_type(argname="argument fail_gravity", value=fail_gravity, expected_type=type_hints["fail_gravity"])
            check_type(argname="argument fail_gravity_var", value=fail_gravity_var, expected_type=type_hints["fail_gravity_var"])
            check_type(argname="argument focus", value=focus, expected_type=type_hints["focus"])
            check_type(argname="argument focus_var", value=focus_var, expected_type=type_hints["focus_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if algorithm is not None:
            self._values["algorithm"] = algorithm
        if algorithm_var is not None:
            self._values["algorithm_var"] = algorithm_var
        if confidence is not None:
            self._values["confidence"] = confidence
        if confidence_var is not None:
            self._values["confidence_var"] = confidence_var
        if fail_gravity is not None:
            self._values["fail_gravity"] = fail_gravity
        if fail_gravity_var is not None:
            self._values["fail_gravity_var"] = fail_gravity_var
        if focus is not None:
            self._values["focus"] = focus
        if focus_var is not None:
            self._values["focus_var"] = focus_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def algorithm(self) -> typing.Optional[builtins.str]:
        '''Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm DataAkamaiImagingPolicyImage#algorithm}
        '''
        result = self._values.get("algorithm")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def algorithm_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm_var DataAkamaiImagingPolicyImage#algorithm_var}
        '''
        result = self._values.get("algorithm_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def confidence(self) -> typing.Optional[builtins.str]:
        '''With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image.

        Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence DataAkamaiImagingPolicyImage#confidence}
        '''
        result = self._values.get("confidence")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def confidence_var(self) -> typing.Optional[builtins.str]:
        '''With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image.

        Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence_var DataAkamaiImagingPolicyImage#confidence_var}
        '''
        result = self._values.get("confidence_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any faces in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        '''
        result = self._values.get("fail_gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any faces in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        '''
        result = self._values.get("fail_gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def focus(self) -> typing.Optional[builtins.str]:
        '''Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus DataAkamaiImagingPolicyImage#focus}
        '''
        result = self._values.get("focus")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def focus_var(self) -> typing.Optional[builtins.str]:
        '''Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus_var DataAkamaiImagingPolicyImage#focus_var}
        '''
        result = self._values.get("focus_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the face(s) plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the face(s) plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultFaceCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultFaceCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultFaceCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c50838588643af85a9b52e4e99d3dc376af49d9a2116ea9fb76b45ac3e27362a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultFaceCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cad4458c110661e7d038d85915f54b143802145e675b0062d0adebcec0e49021)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultFaceCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__411a951fd9b938ea45e4ef4629477f11ed5fd08577b683c960a358b11f228781)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__52ca728803d64a99b20f9b028e4298e515812d5bd48dccf06224995dfa958373)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__10a0491be21986d4569bd492f4542f53a4bea3e3d53d6fecd1781fe48a7c4279)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultFaceCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultFaceCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultFaceCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__74b68887f3d0b4321d9909b462a86ffcb80b66a2868e072675c3cfd5efd9503c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultFaceCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultFaceCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2539b7acc0e2bd5f809759037952fc0cbc3567da8a8e82fa044f1e8a9b87fa21)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAlgorithm")
    def reset_algorithm(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAlgorithm", []))

    @jsii.member(jsii_name="resetAlgorithmVar")
    def reset_algorithm_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAlgorithmVar", []))

    @jsii.member(jsii_name="resetConfidence")
    def reset_confidence(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetConfidence", []))

    @jsii.member(jsii_name="resetConfidenceVar")
    def reset_confidence_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetConfidenceVar", []))

    @jsii.member(jsii_name="resetFailGravity")
    def reset_fail_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravity", []))

    @jsii.member(jsii_name="resetFailGravityVar")
    def reset_fail_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravityVar", []))

    @jsii.member(jsii_name="resetFocus")
    def reset_focus(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFocus", []))

    @jsii.member(jsii_name="resetFocusVar")
    def reset_focus_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFocusVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="algorithmInput")
    def algorithm_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "algorithmInput"))

    @builtins.property
    @jsii.member(jsii_name="algorithmVarInput")
    def algorithm_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "algorithmVarInput"))

    @builtins.property
    @jsii.member(jsii_name="confidenceInput")
    def confidence_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "confidenceInput"))

    @builtins.property
    @jsii.member(jsii_name="confidenceVarInput")
    def confidence_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "confidenceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityInput")
    def fail_gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityVarInput")
    def fail_gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="focusInput")
    def focus_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "focusInput"))

    @builtins.property
    @jsii.member(jsii_name="focusVarInput")
    def focus_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "focusVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="algorithm")
    def algorithm(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "algorithm"))

    @algorithm.setter
    def algorithm(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0577bc9e48cf154f13a42155bb2548ee17f51de0eb01d3f725919d068655163c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "algorithm", value)

    @builtins.property
    @jsii.member(jsii_name="algorithmVar")
    def algorithm_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "algorithmVar"))

    @algorithm_var.setter
    def algorithm_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__594427f3572a5b4ccebba356717f3014f53f6bd98b5c369baed7bc7d6adff1a4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "algorithmVar", value)

    @builtins.property
    @jsii.member(jsii_name="confidence")
    def confidence(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "confidence"))

    @confidence.setter
    def confidence(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f1e03f020df779480eb95d776bc4fd2ba53ffa037f33341a01c309296913c8b5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "confidence", value)

    @builtins.property
    @jsii.member(jsii_name="confidenceVar")
    def confidence_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "confidenceVar"))

    @confidence_var.setter
    def confidence_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__17bb00f37c09d4ced1c04045d07165a6cf583a54a42c2a536aabab625fdf10c8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "confidenceVar", value)

    @builtins.property
    @jsii.member(jsii_name="failGravity")
    def fail_gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravity"))

    @fail_gravity.setter
    def fail_gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d25e1bdc360477f3a05300989ed29d9080e9a2ca00ce14be692431f05b49e303)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravity", value)

    @builtins.property
    @jsii.member(jsii_name="failGravityVar")
    def fail_gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravityVar"))

    @fail_gravity_var.setter
    def fail_gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a0ffea67a94cfa2564629ef43e57d66b7536a1908a38fc8ed8a85be5923cd29e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="focus")
    def focus(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "focus"))

    @focus.setter
    def focus(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ac011a942b41e4db5add3064af3a2e4ec20b29c004c49da5f5a74783503278b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "focus", value)

    @builtins.property
    @jsii.member(jsii_name="focusVar")
    def focus_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "focusVar"))

    @focus_var.setter
    def focus_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__29c9890dc2f8b54ec17a5531938e0ca1d1d8fa038b156d7d47dd5695f860c909)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "focusVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__469b1687957d95b59af4e67ecc6f17afefe6fbbbfdf9777d8f8729406881ff30)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__780b74ffbd7b85895672574e2b3395771c18df0d96d4a90092e0bfc7791f4e8e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d974345f4c10a1250aa5b6725b00b4e0204bfffd17a9b2703d30160996d68b78)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a54b8c30b654868fa6f3b8cd433924e1daddd8c87e2c5ac40adeb9755d841b24)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dac8658b114f5bfa292bc91e97c95c8bf87cc4d345a1ddf4456ca2eb9405cdd0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__53f9c82f2f7fc7ae70e8ff6bec3faa043a233318c7d38e15c1bc9c0b8f5b6a7d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c12e2a7cfaf30e0b1aa0b240d7eea2cd9dc267037a892c5eccc10d0b05be8367)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f231a5e64d01ed23c55e7a88d865dcb4d40bc597bc8f20b36f6e00d979447e9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__602df44cdf155b9ce7d23fb59394642e70debcd612d91c976adabc572272a408)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c11fd412043a45f292c123c05ea3e7046b83634d45f94293ea372086b361a8d2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultFaceCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultFaceCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultFaceCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__069429a09c4d71a77b973e282ddf24fdb5772acddf258f9367377066bde229aa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultFeatureCrop",
    jsii_struct_bases=[],
    name_mapping={
        "fail_gravity": "failGravity",
        "fail_gravity_var": "failGravityVar",
        "feature_radius": "featureRadius",
        "feature_radius_var": "featureRadiusVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "max_features": "maxFeatures",
        "max_features_var": "maxFeaturesVar",
        "min_feature_quality": "minFeatureQuality",
        "min_feature_quality_var": "minFeatureQualityVar",
        "padding": "padding",
        "padding_var": "paddingVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultFeatureCrop:
    def __init__(
        self,
        *,
        fail_gravity: typing.Optional[builtins.str] = None,
        fail_gravity_var: typing.Optional[builtins.str] = None,
        feature_radius: typing.Optional[builtins.str] = None,
        feature_radius_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        max_features: typing.Optional[builtins.str] = None,
        max_features_var: typing.Optional[builtins.str] = None,
        min_feature_quality: typing.Optional[builtins.str] = None,
        min_feature_quality_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fail_gravity: Controls placement of the crop if Image and Video Manager does not detect any features in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        :param fail_gravity_var: Controls placement of the crop if Image and Video Manager does not detect any features in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        :param feature_radius: The size in pixels of the important features to search for. If identified, two features never appear closer together than this value, ``8.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius DataAkamaiImagingPolicyImage#feature_radius}
        :param feature_radius_var: The size in pixels of the important features to search for. If identified, two features never appear closer together than this value, ``8.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius_var DataAkamaiImagingPolicyImage#feature_radius_var}
        :param gravity: Controls placement of the crop. Directions are relative to the region of interest plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Controls placement of the crop. Directions are relative to the region of interest plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param max_features: The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features DataAkamaiImagingPolicyImage#max_features}
        :param max_features_var: The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features_var DataAkamaiImagingPolicyImage#max_features_var}
        :param min_feature_quality: Determines the minimum quality level of the feature identified. To consider a feature important, the feature needs to surpass this value. Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality DataAkamaiImagingPolicyImage#min_feature_quality}
        :param min_feature_quality_var: Determines the minimum quality level of the feature identified. To consider a feature important, the feature needs to surpass this value. Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality_var DataAkamaiImagingPolicyImage#min_feature_quality_var}
        :param padding: Adds space around the region of interest. The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: Adds space around the region of interest. The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        :param style: Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dd3915174ae5accaf03044cf4c9e6f8a37f3a0a26ca018411db3da086b515b7e)
            check_type(argname="argument fail_gravity", value=fail_gravity, expected_type=type_hints["fail_gravity"])
            check_type(argname="argument fail_gravity_var", value=fail_gravity_var, expected_type=type_hints["fail_gravity_var"])
            check_type(argname="argument feature_radius", value=feature_radius, expected_type=type_hints["feature_radius"])
            check_type(argname="argument feature_radius_var", value=feature_radius_var, expected_type=type_hints["feature_radius_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument max_features", value=max_features, expected_type=type_hints["max_features"])
            check_type(argname="argument max_features_var", value=max_features_var, expected_type=type_hints["max_features_var"])
            check_type(argname="argument min_feature_quality", value=min_feature_quality, expected_type=type_hints["min_feature_quality"])
            check_type(argname="argument min_feature_quality_var", value=min_feature_quality_var, expected_type=type_hints["min_feature_quality_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fail_gravity is not None:
            self._values["fail_gravity"] = fail_gravity
        if fail_gravity_var is not None:
            self._values["fail_gravity_var"] = fail_gravity_var
        if feature_radius is not None:
            self._values["feature_radius"] = feature_radius
        if feature_radius_var is not None:
            self._values["feature_radius_var"] = feature_radius_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if max_features is not None:
            self._values["max_features"] = max_features
        if max_features_var is not None:
            self._values["max_features_var"] = max_features_var
        if min_feature_quality is not None:
            self._values["min_feature_quality"] = min_feature_quality
        if min_feature_quality_var is not None:
            self._values["min_feature_quality_var"] = min_feature_quality_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def fail_gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any features in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        '''
        result = self._values.get("fail_gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any features in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        '''
        result = self._values.get("fail_gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feature_radius(self) -> typing.Optional[builtins.str]:
        '''The size in pixels of the important features to search for.

        If identified, two features never appear closer together than this value, ``8.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius DataAkamaiImagingPolicyImage#feature_radius}
        '''
        result = self._values.get("feature_radius")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feature_radius_var(self) -> typing.Optional[builtins.str]:
        '''The size in pixels of the important features to search for.

        If identified, two features never appear closer together than this value, ``8.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius_var DataAkamaiImagingPolicyImage#feature_radius_var}
        '''
        result = self._values.get("feature_radius_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the region of interest plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the region of interest plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def max_features(self) -> typing.Optional[builtins.str]:
        '''The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features DataAkamaiImagingPolicyImage#max_features}
        '''
        result = self._values.get("max_features")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def max_features_var(self) -> typing.Optional[builtins.str]:
        '''The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features_var DataAkamaiImagingPolicyImage#max_features_var}
        '''
        result = self._values.get("max_features_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def min_feature_quality(self) -> typing.Optional[builtins.str]:
        '''Determines the minimum quality level of the feature identified.

        To consider a feature important, the feature needs to surpass this value.  Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality DataAkamaiImagingPolicyImage#min_feature_quality}
        '''
        result = self._values.get("min_feature_quality")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def min_feature_quality_var(self) -> typing.Optional[builtins.str]:
        '''Determines the minimum quality level of the feature identified.

        To consider a feature important, the feature needs to surpass this value.  Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality_var DataAkamaiImagingPolicyImage#min_feature_quality_var}
        '''
        result = self._values.get("min_feature_quality_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''Adds space around the region of interest.

        The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''Adds space around the region of interest.

        The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultFeatureCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultFeatureCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultFeatureCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__11d970042aaf5b3cffd9f2b85900943eb1794130c01f5c100788035ea9403af2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultFeatureCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__856dc1cfce2e1a9cffeb2439949d308737bd1246a1ff4128830297bd0d142d82)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultFeatureCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__49d0828f2d2b035127c8108595d3c4b500ef3b7d7d36230349b0060b11e8db30)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a46d0dfff7e58eb008f56facc78bf28d31313c00082291f88e45a7e128b368e4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d072ea2cf4054a14d967611c001e3b3683e3ccb5b1938b6c095adb8c88b1c660)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultFeatureCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultFeatureCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultFeatureCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__db8f88b3fb8e7decc7fb142e2734cf4d95e383dd582e3651470ae05e40d26fc9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultFeatureCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultFeatureCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4f7c180d7583bbc7ab3ae57c47136f82a54a922c6700e91f89dc516d1449a7cf)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetFailGravity")
    def reset_fail_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravity", []))

    @jsii.member(jsii_name="resetFailGravityVar")
    def reset_fail_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravityVar", []))

    @jsii.member(jsii_name="resetFeatureRadius")
    def reset_feature_radius(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureRadius", []))

    @jsii.member(jsii_name="resetFeatureRadiusVar")
    def reset_feature_radius_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureRadiusVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetMaxFeatures")
    def reset_max_features(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxFeatures", []))

    @jsii.member(jsii_name="resetMaxFeaturesVar")
    def reset_max_features_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxFeaturesVar", []))

    @jsii.member(jsii_name="resetMinFeatureQuality")
    def reset_min_feature_quality(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMinFeatureQuality", []))

    @jsii.member(jsii_name="resetMinFeatureQualityVar")
    def reset_min_feature_quality_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMinFeatureQualityVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="failGravityInput")
    def fail_gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityVarInput")
    def fail_gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featureRadiusInput")
    def feature_radius_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featureRadiusInput"))

    @builtins.property
    @jsii.member(jsii_name="featureRadiusVarInput")
    def feature_radius_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featureRadiusVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesInput")
    def max_features_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "maxFeaturesInput"))

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesVarInput")
    def max_features_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "maxFeaturesVarInput"))

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityInput")
    def min_feature_quality_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "minFeatureQualityInput"))

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityVarInput")
    def min_feature_quality_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "minFeatureQualityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravity")
    def fail_gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravity"))

    @fail_gravity.setter
    def fail_gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3f063ddab8ada145c59a8a3168e3c28a1af2ede45c79e6476d760d7dbd80234b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravity", value)

    @builtins.property
    @jsii.member(jsii_name="failGravityVar")
    def fail_gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravityVar"))

    @fail_gravity_var.setter
    def fail_gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__20ee6e6350675f09711173b67ae5551553c7de4de3fd88cf3df2753cb469957f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="featureRadius")
    def feature_radius(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featureRadius"))

    @feature_radius.setter
    def feature_radius(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d0d1d2a11dd5b0c0f3a2b61c005e385a43fe75b39a82eab8481741b1a2adb6b5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featureRadius", value)

    @builtins.property
    @jsii.member(jsii_name="featureRadiusVar")
    def feature_radius_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featureRadiusVar"))

    @feature_radius_var.setter
    def feature_radius_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9b25a5001064d4f05264627a23c48d98b24b2272e528328d3beba2dcd79f683e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featureRadiusVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ec5d4be3c65e1ddf576751735f4a7029b500513f5fdc0e598e3e634a6cc37f62)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__57b2f3aa3bf5217adfbad48c53dc638f494d7ce6bc04263a0e706c3f7e90ae74)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d140d63c6b23357326171ab242dea0cb1f2a22f6b571c58947c69abaeb878e14)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e97c778b71bfbbddb0a7f81695a6f01f60a476a2f4dc04526f707a13669fed83)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="maxFeatures")
    def max_features(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "maxFeatures"))

    @max_features.setter
    def max_features(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f3c3f360abedfd6c32daa54d69e28037cd6f9f25f7ef9318478855a4b66f83f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "maxFeatures", value)

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesVar")
    def max_features_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "maxFeaturesVar"))

    @max_features_var.setter
    def max_features_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2068e79c86d7c771504f800021b0da794a3f4b6d9376712472aff5feeb677a88)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "maxFeaturesVar", value)

    @builtins.property
    @jsii.member(jsii_name="minFeatureQuality")
    def min_feature_quality(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "minFeatureQuality"))

    @min_feature_quality.setter
    def min_feature_quality(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a4f64b1350c8ec92aac1fb8b7850e8be94b2ad3fb230812f5cdb855ec42b4245)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "minFeatureQuality", value)

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityVar")
    def min_feature_quality_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "minFeatureQualityVar"))

    @min_feature_quality_var.setter
    def min_feature_quality_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a3d5b9bd8b9caafce77f2b6381e0c28ca7a44041b6209b256c5554840c33113a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "minFeatureQualityVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e59a9dbceddb2d3c201ed1ce3552df5c4852dde073b21f3e05ccc32618fbb44e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9b2c31652a593496c1af692b3a333243cca94f8029556574ad58bd5d46e62cdd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3fb0799af27492bb36709f8cc28a2c68c7f12eca5753f8061112d345cc3df3f1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6667f439ea274ec3ad7333514965477025345ea998d52d681141180d797407f2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8150af825ab6a0a59fff66f6f307c86c41652c114cbe66af25ed469a1083a4e3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b6e8915a52283fa5b3b39f15cb01ee0fab32e55d2b9ce14794347806011b9a66)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultFeatureCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultFeatureCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultFeatureCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8cfad2977ad9a0196e81c03ee10666d49ff1583c0bf651b763e153c42be41814)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultFitAndFill",
    jsii_struct_bases=[],
    name_mapping={
        "fill_transformation": "fillTransformation",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultFitAndFill:
    def __init__(
        self,
        *,
        fill_transformation: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultFitAndFillFillTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fill_transformation: fill_transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_transformation DataAkamaiImagingPolicyImage#fill_transformation}
        :param height: The height value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The width value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(fill_transformation, dict):
            fill_transformation = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultFitAndFillFillTransformation(**fill_transformation)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1aa86df8b155db1f007d7924004556f92b775b5826b79e31ba702e3f3f3e7e0c)
            check_type(argname="argument fill_transformation", value=fill_transformation, expected_type=type_hints["fill_transformation"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fill_transformation is not None:
            self._values["fill_transformation"] = fill_transformation
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def fill_transformation(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultFitAndFillFillTransformation"]:
        '''fill_transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_transformation DataAkamaiImagingPolicyImage#fill_transformation}
        '''
        result = self._values.get("fill_transformation")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultFitAndFillFillTransformation"], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultFitAndFill(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultFitAndFillFillTransformation",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultFitAndFillFillTransformation:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultFitAndFillFillTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultFitAndFillFillTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultFitAndFillFillTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4dbb9e53761b2abee0fa7d50716ef70813e7f51cc8ea38ce0cd2c348da254ade)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultFitAndFillFillTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultFitAndFillFillTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultFitAndFillFillTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dfe51ba3064de0a6a2e37505eabc1a571035a2f72833901ce003ac552b0229c0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultFitAndFillList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultFitAndFillList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8974d4d1d0caabc7233e08a5d4e6c4cc231570a655852d3c5c5444ead2ad3240)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultFitAndFillOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__508a92e68bdbf9537735febacf173b622530612dce6a3be8164060c062573157)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultFitAndFillOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5b3765d492777dc765344554771746c3c360a42a3d5baeb2d95a596a8e29dae0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__920694c497922c0855afddde6978ec9fec995fbcc712d33303628a11c8569ca2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8b2bed57c83eed5c792b997d8a1317f03769dce03756c23a30d012e286577981)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultFitAndFill]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultFitAndFill]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultFitAndFill]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0e03db08f939e2d10852728b673ac515e47da5e5eb5ed6eb8bfecb206f51bc15)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultFitAndFillOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultFitAndFillOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c7467578c7b9ac1548d74edd21f0e714fbcb717cf75c110376884f38092f0b48)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putFillTransformation")
    def put_fill_transformation(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultFitAndFillFillTransformation()

        return typing.cast(None, jsii.invoke(self, "putFillTransformation", [value]))

    @jsii.member(jsii_name="resetFillTransformation")
    def reset_fill_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFillTransformation", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="fillTransformation")
    def fill_transformation(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultFitAndFillFillTransformationOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultFitAndFillFillTransformationOutputReference, jsii.get(self, "fillTransformation"))

    @builtins.property
    @jsii.member(jsii_name="fillTransformationInput")
    def fill_transformation_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultFitAndFillFillTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultFitAndFillFillTransformation], jsii.get(self, "fillTransformationInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__406f66ac423827fe56f9986948fdf3b7626653fe391f0d5bae73574e37eab14f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac0c0b3acfb0c1c2cf6d30732e5f2916231522d0c19d66d0e17847354ea259be)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a816646d4944cdf2e2ee941f645d1f102dba0ad48a81fef6a84022ad486e00f2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__08eea7611b1ba1551ea27ca6857b780960c6d01119b212afa32403e732635911)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultFitAndFill]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultFitAndFill]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultFitAndFill]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f8811b9ddf7fa1733978294b0f72168969a6753e385bbc034fd41acc30c47c7f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultGoop",
    jsii_struct_bases=[],
    name_mapping={
        "chaos": "chaos",
        "chaos_var": "chaosVar",
        "density": "density",
        "density_var": "densityVar",
        "power": "power",
        "power_var": "powerVar",
        "seed": "seed",
        "seed_var": "seedVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultGoop:
    def __init__(
        self,
        *,
        chaos: typing.Optional[builtins.str] = None,
        chaos_var: typing.Optional[builtins.str] = None,
        density: typing.Optional[builtins.str] = None,
        density_var: typing.Optional[builtins.str] = None,
        power: typing.Optional[builtins.str] = None,
        power_var: typing.Optional[builtins.str] = None,
        seed: typing.Optional[builtins.str] = None,
        seed_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param chaos: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        :param chaos_var: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        :param density: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        :param density_var: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        :param power: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        :param power_var: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        :param seed: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        :param seed_var: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d0adfede6438db7afca88d448f5a1d3f5be756262ee3b6278c4481e7d44abc92)
            check_type(argname="argument chaos", value=chaos, expected_type=type_hints["chaos"])
            check_type(argname="argument chaos_var", value=chaos_var, expected_type=type_hints["chaos_var"])
            check_type(argname="argument density", value=density, expected_type=type_hints["density"])
            check_type(argname="argument density_var", value=density_var, expected_type=type_hints["density_var"])
            check_type(argname="argument power", value=power, expected_type=type_hints["power"])
            check_type(argname="argument power_var", value=power_var, expected_type=type_hints["power_var"])
            check_type(argname="argument seed", value=seed, expected_type=type_hints["seed"])
            check_type(argname="argument seed_var", value=seed_var, expected_type=type_hints["seed_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if chaos is not None:
            self._values["chaos"] = chaos
        if chaos_var is not None:
            self._values["chaos_var"] = chaos_var
        if density is not None:
            self._values["density"] = density
        if density_var is not None:
            self._values["density_var"] = density_var
        if power is not None:
            self._values["power"] = power
        if power_var is not None:
            self._values["power_var"] = power_var
        if seed is not None:
            self._values["seed"] = seed
        if seed_var is not None:
            self._values["seed_var"] = seed_var

    @builtins.property
    def chaos(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        '''
        result = self._values.get("chaos")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def chaos_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        '''
        result = self._values.get("chaos_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        '''
        result = self._values.get("density")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density_var(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        '''
        result = self._values.get("density_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        '''
        result = self._values.get("power")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power_var(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        '''
        result = self._values.get("power_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        '''
        result = self._values.get("seed")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed_var(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        result = self._values.get("seed_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultGoop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultGoopList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultGoopList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7786430715e644a17a6c688c99c707e635d169679151a6e135ad887ad7fb390e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultGoopOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__61b6c485cd78f75f69a551e5360f9258ca5a42bb0dd810fbd52e18cff9ad98a2)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultGoopOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e8efa4fb2229676dc2a5e8d38a9a2611cc084ef870890178607b55f60af3204c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__68035c5abde498153392989af40834378c1b6eff6dd09ccdde36fb93dc0e5b5a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4b053531abc882f5be310006514f7362762e22797b13ae397620a97f58b3ee61)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultGoop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultGoop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e756495bddc40e749b792a1a73e26c3a9687ec7f8f1c374b48c02166c6a72ecd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultGoopOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultGoopOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__904fb04911c21e58a06d0a5c3ab7eee4c249b369c97241e9a3ff73fb711e44cc)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetChaos")
    def reset_chaos(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaos", []))

    @jsii.member(jsii_name="resetChaosVar")
    def reset_chaos_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaosVar", []))

    @jsii.member(jsii_name="resetDensity")
    def reset_density(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensity", []))

    @jsii.member(jsii_name="resetDensityVar")
    def reset_density_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensityVar", []))

    @jsii.member(jsii_name="resetPower")
    def reset_power(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPower", []))

    @jsii.member(jsii_name="resetPowerVar")
    def reset_power_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPowerVar", []))

    @jsii.member(jsii_name="resetSeed")
    def reset_seed(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeed", []))

    @jsii.member(jsii_name="resetSeedVar")
    def reset_seed_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeedVar", []))

    @builtins.property
    @jsii.member(jsii_name="chaosInput")
    def chaos_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosInput"))

    @builtins.property
    @jsii.member(jsii_name="chaosVarInput")
    def chaos_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosVarInput"))

    @builtins.property
    @jsii.member(jsii_name="densityInput")
    def density_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityInput"))

    @builtins.property
    @jsii.member(jsii_name="densityVarInput")
    def density_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="powerInput")
    def power_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerInput"))

    @builtins.property
    @jsii.member(jsii_name="powerVarInput")
    def power_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerVarInput"))

    @builtins.property
    @jsii.member(jsii_name="seedInput")
    def seed_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedInput"))

    @builtins.property
    @jsii.member(jsii_name="seedVarInput")
    def seed_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedVarInput"))

    @builtins.property
    @jsii.member(jsii_name="chaos")
    def chaos(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaos"))

    @chaos.setter
    def chaos(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d0c9eb4611b93d2e893f78774b94acc21f51c5e4b56cc34deaeebdb01f0c5038)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaos", value)

    @builtins.property
    @jsii.member(jsii_name="chaosVar")
    def chaos_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaosVar"))

    @chaos_var.setter
    def chaos_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__96db71f55736b88b8e953d67b5bc7cafa17cca08a85a36517c757c92c3220026)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaosVar", value)

    @builtins.property
    @jsii.member(jsii_name="density")
    def density(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "density"))

    @density.setter
    def density(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__db846afe0f9285b75e6a161fe2fa0e0398696e6e0df176bb5b73bac3e22f76c0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "density", value)

    @builtins.property
    @jsii.member(jsii_name="densityVar")
    def density_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "densityVar"))

    @density_var.setter
    def density_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a3e770a883b8140bb59a133f5e8eb62d7e60aacd889b0609ab1b0d7b3a189b05)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "densityVar", value)

    @builtins.property
    @jsii.member(jsii_name="power")
    def power(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "power"))

    @power.setter
    def power(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac276a0b4a4236f1b59a62a9a03b136bc0c37c84eb625135b5e7adbd7552507d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "power", value)

    @builtins.property
    @jsii.member(jsii_name="powerVar")
    def power_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "powerVar"))

    @power_var.setter
    def power_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9321f0bbd283886ed5513717e094c1c6f840eef057366c306aa4e7fa01c6a66a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "powerVar", value)

    @builtins.property
    @jsii.member(jsii_name="seed")
    def seed(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seed"))

    @seed.setter
    def seed(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__463e33902b12a756c0c85210ef3874d4a8f6365217c56ebb51aa9fe0a4eab99d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seed", value)

    @builtins.property
    @jsii.member(jsii_name="seedVar")
    def seed_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seedVar"))

    @seed_var.setter
    def seed_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f8b3776560975c0a01b353bab8157a57469b3d63ad5688e13702c1cb0258bc6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seedVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultGoop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultGoop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultGoop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__34cf45d08b5cff00614323baefc41e5c6d17fb464bd941d0cf6adc544a2b4fc9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultGrayscale",
    jsii_struct_bases=[],
    name_mapping={"type": "type", "type_var": "typeVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultGrayscale:
    def __init__(
        self,
        *,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param type: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__51a4c518b8c620ba12b1cf5729bce68eabad10453190892890c6487deccadcae)
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultGrayscale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultGrayscaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultGrayscaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aece8ea76ae6ef99871b03e74afcc279f2523a08b3d24966ecc19928f5274d5d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultGrayscaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c67e93a0fbcabce5142910e69fb92d7ebaf7c71c7bbe91de8ae6849639251f12)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultGrayscaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__561847ae3ffe0543e1c13ee7267becc46fbd2525e28acea5101f17a333b89d3d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__94ec2450ae324fd4363f6f8dacc85ab2d1fa52d4f49f4358d1f766e7e44b8645)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2628e3bd3c86dd29826d71731904b53cdd9f91b7a5f773cf04bbd5521d01a2d6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultGrayscale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultGrayscale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__932989ccaa87219c1ff4bc5102c90047664ecee280d4112f4c22fd017d21c05a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultGrayscaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultGrayscaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__496e8e528275328d59d0dffff40662bcfa07e9571ba620b16eacac3d3b6a02c5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c2c2cceac8fb75d9e5885207794a1da1160e437dbac52d3ff67c437b3154e743)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__87016e534d4ac9e39be75938a45997e05816f5e9c48fd72118d4101f01d8e27c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultGrayscale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultGrayscale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultGrayscale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ed36341dbac8c47f44fdf8a9c3e9fc0d27c1d654b135334b3e1a2e1f691cd51d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultHsl",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "lightness": "lightness",
        "lightness_var": "lightnessVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultHsl:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness: typing.Optional[builtins.str] = None,
        lightness_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        :param lightness_var: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__96e47a07811655b389d019fde5f7ff787e08a1b2d6778deef6d175f26ac42f02)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness", value=lightness, expected_type=type_hints["lightness"])
            check_type(argname="argument lightness_var", value=lightness_var, expected_type=type_hints["lightness_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness is not None:
            self._values["lightness"] = lightness
        if lightness_var is not None:
            self._values["lightness_var"] = lightness_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        '''
        result = self._values.get("lightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        '''
        result = self._values.get("lightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultHsl(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultHslList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultHslList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dbac36cf9404d904544f66f1e7e80f684a79b78e7539c13ba04951f1ac1749ef)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultHslOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__181ebc5ba0a3308ff4766f5eda8a0f38c588e5d2906686a94da3ff21556519b7)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultHslOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f1a99d5e8f288b11f9324cf16b84d3f15ef678cb80593d64ed42d6db4529b4ab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a7c99d289cb5e16a250586af95823b90e7d8cc3c9d0f06bd6cafcedf789f6211)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cfccdea8e85c35069791c4dc4850ed2caf655ea99af930076d792d695e1071c3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultHsl]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultHsl]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a365e577d239f9aa8f4d3e9aa95f803f303223855892d06081c42f810cd19b41)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultHslOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultHslOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d91830b9591f8801bb720523e217a48389814351a5988f0e120d13f2d8f761ec)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightness")
    def reset_lightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightness", []))

    @jsii.member(jsii_name="resetLightnessVar")
    def reset_lightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessInput")
    def lightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessVarInput")
    def lightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__37d59d50a12973d289c2504615f0428206e592f24a75afde1134e111e19acfda)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__744822b6c995a329f50bb5462771a315e2bebc63244810d664a2d24d4b3f844a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightness")
    def lightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightness"))

    @lightness.setter
    def lightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bcc46776da863a3ccf179340e840f700bffb400b16acf8e3234561c7205bfbb8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightness", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessVar")
    def lightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessVar"))

    @lightness_var.setter
    def lightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f3ae0fbc264e65835e1ffa767eedad0e9ba96431a6d2d1533efdd3b7cc80a12a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1498b1a020a5f3e6160901e873d6d4e49d872c23eae404097d9d00826ba91876)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d1ec04aa98c03b754ff83bc7021cec0131be9f03e3e2c69cdcd6d759aa0abba1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultHsl]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultHsl]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultHsl]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0e4778c0500a2918a3666fdaf44bfeca6e75ca56abacdf6e7b31e11b5f3c4a38)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultHsv",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultHsv:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        :param value: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__402e01c1e85f9d5075928ea7986486e9d8d939be2e8f4ba3e9e09ca12c445e06)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultHsv(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultHsvList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultHsvList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d56dd05e7a4c08065ad0c4f77c71e1e378c0f9990e043e484d2536548560d5c5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultHsvOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1bbb7d34a0648be5c577558a480280ed2cd3d8c2c1a0fd8c6503556a78cf4fc5)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultHsvOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__53df3362dba8ce7bab8170fc2a3c64c23b077e79ea99cd92be7c0d2a58a03ec6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__793215d3c3e801e8f0f0a34279803c4d965d4a4cad28a1fd235e1660b32889d1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__56b4be958d933ca18aac230644c8c28d9b6d2b25a06738d7b2a95534c1c8ec31)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultHsv]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultHsv]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__67413ddf96a9be7e931bde7a1e3509fc9055af285fb6135ade24b4e40d5fc761)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultHsvOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultHsvOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9975328e8db9b97b535a882e799ccfa17e0c9f4bb3a548b919956d647a40dfbe)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f7813dd55d5f1d3238a010ea1a20e553a0b464db210ffa7b1c237f8078f77e33)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fe05e44b7682dbec505ec2b72f6efa8b4b3ebfd271f20ab2d8beca89fd31ac07)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__abdd8c9c78aca936924b12c64bada7560f40ef994209ad8ca7cc37391ac8b5b9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8ba45a450b41089ed323ce05420e5ac5cbdcdb58c1314aea38f203daf6ec8b61)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6c785c4b4d7f0d89e07139f7cb928ccf473c378851bf10bac16350d7910527b2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4d9f6dfd7f9dd2579ab375dffe098b6788f7504337cf1ff0cf831aa949260380)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultHsv]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultHsv]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultHsv]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__91202daee275f5f778b8ff91f1c57db7a68496e129375341d686c7b2b1bc7b29)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimension",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "dimension": "dimension",
        "dimension_var": "dimensionVar",
        "equal": "equal",
        "greater_than": "greaterThan",
        "less_than": "lessThan",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimension:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        dimension: typing.Optional[builtins.str] = None,
        dimension_var: typing.Optional[builtins.str] = None,
        equal: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionEqual", typing.Dict[builtins.str, typing.Any]]] = None,
        greater_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionGreaterThan", typing.Dict[builtins.str, typing.Any]]] = None,
        less_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionLessThan", typing.Dict[builtins.str, typing.Any]]] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param dimension: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        :param dimension_var: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        :param equal: equal block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        :param greater_than: greater_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        :param less_than: less_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        :param value: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionDefault(**default)
        if isinstance(equal, dict):
            equal = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionEqual(**equal)
        if isinstance(greater_than, dict):
            greater_than = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionGreaterThan(**greater_than)
        if isinstance(less_than, dict):
            less_than = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionLessThan(**less_than)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e200b3fb523bbf172c934a24885425eef3b69fd872000c431fb6ab04672baa2a)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument dimension", value=dimension, expected_type=type_hints["dimension"])
            check_type(argname="argument dimension_var", value=dimension_var, expected_type=type_hints["dimension_var"])
            check_type(argname="argument equal", value=equal, expected_type=type_hints["equal"])
            check_type(argname="argument greater_than", value=greater_than, expected_type=type_hints["greater_than"])
            check_type(argname="argument less_than", value=less_than, expected_type=type_hints["less_than"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if dimension is not None:
            self._values["dimension"] = dimension
        if dimension_var is not None:
            self._values["dimension_var"] = dimension_var
        if equal is not None:
            self._values["equal"] = equal
        if greater_than is not None:
            self._values["greater_than"] = greater_than
        if less_than is not None:
            self._values["less_than"] = less_than
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionDefault"], result)

    @builtins.property
    def dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        '''
        result = self._values.get("dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        '''
        result = self._values.get("dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def equal(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionEqual"]:
        '''equal block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        '''
        result = self._values.get("equal")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionEqual"], result)

    @builtins.property
    def greater_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionGreaterThan"]:
        '''greater_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        '''
        result = self._values.get("greater_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionGreaterThan"], result)

    @builtins.property
    def less_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionLessThan"]:
        '''less_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        '''
        result = self._values.get("less_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionLessThan"], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimension(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4e94cac72dca02986dfa5d9c90bec7359da32dd0226df3cf9d7bf3c6ac566de7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f6ce8e9b8df0710b74cc5dbcf608a4c11475cf720f0bccb6af91033105ad7b67)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionEqual",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionEqual:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionEqual(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionEqualOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionEqualOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9fd28a8427399b09fb25938e69a94599ffb1a629f8c661f2df96c6472553a8bc)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionEqual], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionEqual],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__61719e9ce598faeb8395fddeac9c25b4bc0f6fce807b81944049f5d7e08b209c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionGreaterThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionGreaterThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionGreaterThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionGreaterThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionGreaterThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__746d6e8254126df17019d5b56d42e42f2ef51d8070ab5b7d0f097ec35dc6f9aa)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionGreaterThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionGreaterThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__55348c35988bcffea7fa6ccefecc499d562af5523643e55e74090da2f57bea76)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionLessThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionLessThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionLessThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionLessThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionLessThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__617ee04736a405d0fe3d11cde34509664b314e6dda3c3b11c4980175e645d198)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionLessThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionLessThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__128f66ca5dc66465d153bea1121500a3e4bb6d0bd8858e1672dbcf91ef08a550)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea58209ffcc3a85680a0e78923bbc4abed733da701724e220ecbb16a0be4e34c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8d9ce6eb6bb2befe9f7d5df6e1578d49d9656f74d0624408d78aa2c5724b19de)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0db2d1a3da0e7818a3946a44fa83d1cb145d4d27a5952f357b9b72dd11ec8310)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__715ae33d6e4eed34a0732ba1eb77ca8b9d4ed82ece060e4d430f5fceb9c90634)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c63ab775dd6e1b234ba378b6714fa4ad3d1a7f460a5d13ecacff009381fc4aa6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimension]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimension]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a10a141c0bbd47775a06e81851eb2d952821ad08e84b9d03d15045de25937e4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a0c7361ff5515eed89e521590e1030d4a7bb60430d66880a42dcf27ed523d0ce)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putEqual")
    def put_equal(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionEqual()

        return typing.cast(None, jsii.invoke(self, "putEqual", [value]))

    @jsii.member(jsii_name="putGreaterThan")
    def put_greater_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionGreaterThan()

        return typing.cast(None, jsii.invoke(self, "putGreaterThan", [value]))

    @jsii.member(jsii_name="putLessThan")
    def put_less_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionLessThan()

        return typing.cast(None, jsii.invoke(self, "putLessThan", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetDimension")
    def reset_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimension", []))

    @jsii.member(jsii_name="resetDimensionVar")
    def reset_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimensionVar", []))

    @jsii.member(jsii_name="resetEqual")
    def reset_equal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEqual", []))

    @jsii.member(jsii_name="resetGreaterThan")
    def reset_greater_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGreaterThan", []))

    @jsii.member(jsii_name="resetLessThan")
    def reset_less_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLessThan", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="equal")
    def equal(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionEqualOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionEqualOutputReference, jsii.get(self, "equal"))

    @builtins.property
    @jsii.member(jsii_name="greaterThan")
    def greater_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionGreaterThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionGreaterThanOutputReference, jsii.get(self, "greaterThan"))

    @builtins.property
    @jsii.member(jsii_name="lessThan")
    def less_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionLessThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionLessThanOutputReference, jsii.get(self, "lessThan"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionInput")
    def dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionVarInput")
    def dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="equalInput")
    def equal_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionEqual], jsii.get(self, "equalInput"))

    @builtins.property
    @jsii.member(jsii_name="greaterThanInput")
    def greater_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionGreaterThan], jsii.get(self, "greaterThanInput"))

    @builtins.property
    @jsii.member(jsii_name="lessThanInput")
    def less_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionLessThan], jsii.get(self, "lessThanInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="dimension")
    def dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimension"))

    @dimension.setter
    def dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f89747f970896673201f3e4dcdb43549eeb830ae6925b3f47ea74e7d5162862c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimension", value)

    @builtins.property
    @jsii.member(jsii_name="dimensionVar")
    def dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimensionVar"))

    @dimension_var.setter
    def dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab5cf4151defe90ef722e19ce04c53e792a2d9c9f765d0593a45adf14bc3bac8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__06671902dd210a5de4e86a3a4407c078a69848a20fd3709d1d0dcc58a03c6679)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6cd7846db4889900761d08a3204551b1c7e7fb6e27147b39e0a74a18008ccc68)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimension]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimension]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimension]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__638ef0cbd7c4295af747d37cc6bdc1b3df4fbecfffe659bb5eca32fa309b0f80)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientation",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "landscape": "landscape",
        "portrait": "portrait",
        "square": "square",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientation:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        landscape: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationLandscape", typing.Dict[builtins.str, typing.Any]]] = None,
        portrait: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationPortrait", typing.Dict[builtins.str, typing.Any]]] = None,
        square: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationSquare", typing.Dict[builtins.str, typing.Any]]] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param landscape: landscape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        :param portrait: portrait block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        :param square: square block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationDefault(**default)
        if isinstance(landscape, dict):
            landscape = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationLandscape(**landscape)
        if isinstance(portrait, dict):
            portrait = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationPortrait(**portrait)
        if isinstance(square, dict):
            square = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationSquare(**square)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9547d44623d9d9d0c87f5a3fb321100cc3228b8dcf32e8ea575c59bf2107252e)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument landscape", value=landscape, expected_type=type_hints["landscape"])
            check_type(argname="argument portrait", value=portrait, expected_type=type_hints["portrait"])
            check_type(argname="argument square", value=square, expected_type=type_hints["square"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if landscape is not None:
            self._values["landscape"] = landscape
        if portrait is not None:
            self._values["portrait"] = portrait
        if square is not None:
            self._values["square"] = square

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationDefault"], result)

    @builtins.property
    def landscape(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationLandscape"]:
        '''landscape block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        '''
        result = self._values.get("landscape")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationLandscape"], result)

    @builtins.property
    def portrait(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationPortrait"]:
        '''portrait block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        '''
        result = self._values.get("portrait")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationPortrait"], result)

    @builtins.property
    def square(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationSquare"]:
        '''square block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        result = self._values.get("square")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationSquare"], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__edb06c98f6d3cb01a988d2b3566e40ec953336ef9a13a50378756b1eb67c3b98)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f2b53d0055ca19b56990e890b0e1b2a14a4bd484f1c05538206195b79e7b28bd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationLandscape",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationLandscape:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationLandscape(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationLandscapeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationLandscapeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__66ce42cb77ad8181082ea24876d001dbafca188dbc93d2bfb73d8ac4ade0fcee)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationLandscape], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationLandscape],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__380af500b5006e0be0cb812d59dd53541f63fe542f839c4033ef6a2ae898b8b9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__56eb691022a5f9225f85668d5c398b3138c4b12c7b3ece29b24873f4e3fcd6af)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1627051c0558da7b84a58abce273c25eb4b8acfe524bf1fe33f92c18fa8b191a)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__072918b1acc015361e3fc98795d2bb2c8860bd468517e6c71aa8869517968d2c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d8434b58b46acaccaa9499dc1e4d313d2e7f3bdb5b462a03997332650a7062e0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dd0c5c1277ea4c4b09c56c867032e0831bf5397101906dd733d6a40186a07478)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientation]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientation]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__99c9886f9fcb1d8911555d7be3c36aee115e49c2ae159f7a4670c1269391e7ea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__50c49f95fdcdbcd56c5faf1f849d8e88e285004a0dc3886dc452bf08c1d314b8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putLandscape")
    def put_landscape(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationLandscape()

        return typing.cast(None, jsii.invoke(self, "putLandscape", [value]))

    @jsii.member(jsii_name="putPortrait")
    def put_portrait(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationPortrait()

        return typing.cast(None, jsii.invoke(self, "putPortrait", [value]))

    @jsii.member(jsii_name="putSquare")
    def put_square(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationSquare()

        return typing.cast(None, jsii.invoke(self, "putSquare", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetLandscape")
    def reset_landscape(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLandscape", []))

    @jsii.member(jsii_name="resetPortrait")
    def reset_portrait(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPortrait", []))

    @jsii.member(jsii_name="resetSquare")
    def reset_square(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSquare", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="landscape")
    def landscape(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationLandscapeOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationLandscapeOutputReference, jsii.get(self, "landscape"))

    @builtins.property
    @jsii.member(jsii_name="portrait")
    def portrait(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationPortraitOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationPortraitOutputReference", jsii.get(self, "portrait"))

    @builtins.property
    @jsii.member(jsii_name="square")
    def square(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationSquareOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationSquareOutputReference", jsii.get(self, "square"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="landscapeInput")
    def landscape_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationLandscape], jsii.get(self, "landscapeInput"))

    @builtins.property
    @jsii.member(jsii_name="portraitInput")
    def portrait_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationPortrait"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationPortrait"], jsii.get(self, "portraitInput"))

    @builtins.property
    @jsii.member(jsii_name="squareInput")
    def square_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationSquare"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationSquare"], jsii.get(self, "squareInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientation]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientation]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientation]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cadd098198cb56e0c265629184fd48169476f17db010b51ef712b2e1c3c48f19)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationPortrait",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationPortrait:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationPortrait(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationPortraitOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationPortraitOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__215d568aaeb355c47dfabea84901d4792848e4d99ac0ce1a275bee2ab7814943)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationPortrait]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationPortrait], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationPortrait],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ad1c3ba928a78b6def357f797fb0bf7a1bfd8c3f23464ac299b96da4b12962de)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationSquare",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationSquare:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationSquare(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationSquareOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationSquareOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__38460106a3c44a3a5a1ef28a909bb0bbb19c45d5484f37d6f84761497407c4ce)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationSquare]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationSquare], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationSquare],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a3364e891d8d31bb010d4a660fee13149169cdd5e735d1e29ebb5bf140806e93)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultImQuery",
    jsii_struct_bases=[],
    name_mapping={
        "allowed_transformations": "allowedTransformations",
        "query_var": "queryVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultImQuery:
    def __init__(
        self,
        *,
        allowed_transformations: typing.Sequence[builtins.str],
        query_var: builtins.str,
    ) -> None:
        '''
        :param allowed_transformations: Specifies the transformations that can be applied using the query string parameter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allowed_transformations DataAkamaiImagingPolicyImage#allowed_transformations}
        :param query_var: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#query_var DataAkamaiImagingPolicyImage#query_var}.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6126452ef2445288f4581c80512cc004726514f37e44f879a968886d5013620c)
            check_type(argname="argument allowed_transformations", value=allowed_transformations, expected_type=type_hints["allowed_transformations"])
            check_type(argname="argument query_var", value=query_var, expected_type=type_hints["query_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "allowed_transformations": allowed_transformations,
            "query_var": query_var,
        }

    @builtins.property
    def allowed_transformations(self) -> typing.List[builtins.str]:
        '''Specifies the transformations that can be applied using the query string parameter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allowed_transformations DataAkamaiImagingPolicyImage#allowed_transformations}
        '''
        result = self._values.get("allowed_transformations")
        assert result is not None, "Required property 'allowed_transformations' is missing"
        return typing.cast(typing.List[builtins.str], result)

    @builtins.property
    def query_var(self) -> builtins.str:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#query_var DataAkamaiImagingPolicyImage#query_var}.'''
        result = self._values.get("query_var")
        assert result is not None, "Required property 'query_var' is missing"
        return typing.cast(builtins.str, result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultImQuery(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultImQueryList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultImQueryList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e2a181dd8dbd81f872224ab98251e4a2337fef538dc58dcfeee18709e9f0a118)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultImQueryOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6764cc8019ce789c40887db774ef0e4e05a7d3e90e1826613956670d4b9e709b)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultImQueryOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__067586ba4a936bee8da4c0a5096f873dad837459e0c609b4d634a65ea453e414)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7ded7d4fa16105cd99d53cdea3b1aa6b6148f1b89256cbc557a2b29e35739607)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0a82ac498c898f4b7c71cac51931b604fa9b6695c154a84ad2732de5aeb06ce3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultImQuery]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultImQuery]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultImQuery]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__01cd799ade09a6bb78941b094ed33ef551e00ac1912f17bf4477e9b27515feb3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultImQueryOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultImQueryOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__20703fb7762b9d519f88f8d7b190aed76f5a129da180d325f83ffebe56c04c87)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @builtins.property
    @jsii.member(jsii_name="allowedTransformationsInput")
    def allowed_transformations_input(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "allowedTransformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="queryVarInput")
    def query_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "queryVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowedTransformations")
    def allowed_transformations(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "allowedTransformations"))

    @allowed_transformations.setter
    def allowed_transformations(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__290d60ec64fa390166593b80720a1d7c012ee06913f33a84c231748417b91df4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowedTransformations", value)

    @builtins.property
    @jsii.member(jsii_name="queryVar")
    def query_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "queryVar"))

    @query_var.setter
    def query_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__235151b1dd2cc9a078b90ddecc00eb3aa863d79d23171152ad279ef0b5e6aae9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "queryVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultImQuery]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultImQuery]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultImQuery]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9394237cf4c37d76a3f8f49f7734022bea895bb416712e8053aecdcd9d77cc3d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultMaxColors",
    jsii_struct_bases=[],
    name_mapping={"colors": "colors", "colors_var": "colorsVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultMaxColors:
    def __init__(
        self,
        *,
        colors: typing.Optional[builtins.str] = None,
        colors_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param colors: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        :param colors_var: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eb7a9695e7f88ac066e7261552267c913b20dc0dc623d91a87999f6340caabca)
            check_type(argname="argument colors", value=colors, expected_type=type_hints["colors"])
            check_type(argname="argument colors_var", value=colors_var, expected_type=type_hints["colors_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if colors is not None:
            self._values["colors"] = colors
        if colors_var is not None:
            self._values["colors_var"] = colors_var

    @builtins.property
    def colors(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        '''
        result = self._values.get("colors")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def colors_var(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        result = self._values.get("colors_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultMaxColors(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultMaxColorsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultMaxColorsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7e1fae49a7f79f93b2caceb8ddd97b8863c71ad94057a4e9c82f33e75a49c03e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultMaxColorsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af732c1ac75f70826d6150d73ec77490134e99fe4ac6fc89711719cc0d9b0d5c)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultMaxColorsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__730b1f5d52545f17cd8c73ad382a19e251d5df1f864a73ad41b38521a5716515)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f972afeb030e6de11f1622eba32a40a34228ffbfd2f5bb4b35900c259eda47ef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a893eb3b044c1d4cdee87d65d1f07a7733e12b93c2e65ddfd4d1e62e53f8f40)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultMaxColors]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultMaxColors]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a3b0ac5426009b5ca34a144108b188eb518fb373cf7aad7dddec8c8cbc9ac981)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultMaxColorsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultMaxColorsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ccd3b3771cfc636ddbddf92890c129204bb40769ebc1258372785e9b63a1f02f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColors")
    def reset_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColors", []))

    @jsii.member(jsii_name="resetColorsVar")
    def reset_colors_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorsVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorsInput")
    def colors_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsInput"))

    @builtins.property
    @jsii.member(jsii_name="colorsVarInput")
    def colors_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsVarInput"))

    @builtins.property
    @jsii.member(jsii_name="colors")
    def colors(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colors"))

    @colors.setter
    def colors(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b807048ce756a251380fb5c22d94093c6a84c29f9363bf6b73c98148e9cb344d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colors", value)

    @builtins.property
    @jsii.member(jsii_name="colorsVar")
    def colors_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorsVar"))

    @colors_var.setter
    def colors_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__90337644c1d6f4867af781c6ebb9f63a8df506b9126e42c3789c7898c602d4bc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorsVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultMaxColors]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultMaxColors]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultMaxColors]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__81ab84e4b35553abaaa83a97c0b903403cf16d39c1e61a9798dc28d0eec3156d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultMirror",
    jsii_struct_bases=[],
    name_mapping={
        "horizontal": "horizontal",
        "horizontal_var": "horizontalVar",
        "vertical": "vertical",
        "vertical_var": "verticalVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultMirror:
    def __init__(
        self,
        *,
        horizontal: typing.Optional[builtins.str] = None,
        horizontal_var: typing.Optional[builtins.str] = None,
        vertical: typing.Optional[builtins.str] = None,
        vertical_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param horizontal: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        :param horizontal_var: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        :param vertical: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        :param vertical_var: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0b850558b22acef60e1bb15e9ce6a52ab820de26e6b101d62a11ba40b723187d)
            check_type(argname="argument horizontal", value=horizontal, expected_type=type_hints["horizontal"])
            check_type(argname="argument horizontal_var", value=horizontal_var, expected_type=type_hints["horizontal_var"])
            check_type(argname="argument vertical", value=vertical, expected_type=type_hints["vertical"])
            check_type(argname="argument vertical_var", value=vertical_var, expected_type=type_hints["vertical_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if horizontal is not None:
            self._values["horizontal"] = horizontal
        if horizontal_var is not None:
            self._values["horizontal_var"] = horizontal_var
        if vertical is not None:
            self._values["vertical"] = vertical
        if vertical_var is not None:
            self._values["vertical_var"] = vertical_var

    @builtins.property
    def horizontal(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        '''
        result = self._values.get("horizontal")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def horizontal_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        '''
        result = self._values.get("horizontal_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        '''
        result = self._values.get("vertical")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        result = self._values.get("vertical_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultMirror(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultMirrorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultMirrorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f53f668aab2ea34b1ba88279c06e94d833462c83807efcdb2db1f2def3a86c1e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultMirrorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a2aec368dcc05fb37df9dca61687634c171214d3e25fa418a40ee2f97526673)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultMirrorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__def67ca60117ce51e58bd52b61fcae57f90e6e285560bf12f7e758b36ef36e35)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__149f7694a6183b0eb124b279fd4bb147631d4a2e78259368253753a1f2c7fe28)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__193c0722ef04a4213eddd574e399e9eb5e4982abe635ceb690bdab6390b613c6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultMirror]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultMirror]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__636aee2f45ece933c30257718e694533798b15afc387e4852028e83b5d189992)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultMirrorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultMirrorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a3a5fd6b06b8d4abf936df214c21e988af8de565348861611a0219b11c94fed)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHorizontal")
    def reset_horizontal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontal", []))

    @jsii.member(jsii_name="resetHorizontalVar")
    def reset_horizontal_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontalVar", []))

    @jsii.member(jsii_name="resetVertical")
    def reset_vertical(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVertical", []))

    @jsii.member(jsii_name="resetVerticalVar")
    def reset_vertical_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVerticalVar", []))

    @builtins.property
    @jsii.member(jsii_name="horizontalInput")
    def horizontal_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontalVarInput")
    def horizontal_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalInput")
    def vertical_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalVarInput")
    def vertical_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontal")
    def horizontal(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontal"))

    @horizontal.setter
    def horizontal(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__51738e78a309debaac8873c7c0b60eac5e3b7ca9aad1abb4fc840a13ab9154a8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontal", value)

    @builtins.property
    @jsii.member(jsii_name="horizontalVar")
    def horizontal_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontalVar"))

    @horizontal_var.setter
    def horizontal_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1026b18c36ab3f8e24cd2413a55b5fc7fdf32fe491712ae8fe89bd786c66eb7a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontalVar", value)

    @builtins.property
    @jsii.member(jsii_name="vertical")
    def vertical(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "vertical"))

    @vertical.setter
    def vertical(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b2e33e7faa8be7a33935c8d3ce277e5b611f4b1a19a9ea6f52f35b78488bc7a7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "vertical", value)

    @builtins.property
    @jsii.member(jsii_name="verticalVar")
    def vertical_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "verticalVar"))

    @vertical_var.setter
    def vertical_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e76295d7588ec4d99a983e7fe22a929bb2531fab04787dc3f510f92e7877172f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "verticalVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultMirror]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultMirror]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultMirror]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a27f02f3ab60b961165458f8217dae1bf6175c841f84249082af64bcd6c48b62)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultMonoHue",
    jsii_struct_bases=[],
    name_mapping={"hue": "hue", "hue_var": "hueVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultMonoHue:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d6ceed56378391c6bf1a593333aab4ff6d8f4428aca86c229ccdf7f3da56c28c)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultMonoHue(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultMonoHueList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultMonoHueList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5d23359330fe81fff07a17421fc911e59213d886f37ad8f257e9b88dbd05c057)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultMonoHueOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__27f0bbc19547fcc61447b8d27d2699e2d359e4462cb1d7a5abf59e04f618d509)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultMonoHueOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e80f5128613dc9060e3742661999cf43c503eb31a22dc49ffca89e5a3f39e1db)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4560a325c6bd0f431dd8e553b45b46f06fdb1a1edbd90509406f116d14a4a04a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__17dd0e27f20014d9f9c71bb8dcac9a0ab3497c0530fd614bb5d9df36199f9f51)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultMonoHue]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultMonoHue]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc5add8b571fe2eb6cc7c7d8469a54eb56bc8d2b6b0352f897b5b05e5ecfc978)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultMonoHueOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultMonoHueOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__36e76cd828e8eb7c59daa239b356a8acb1c6d399951bad547d5d547dd75d978b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c11ab05d176f4725c3d6ee1bd8b625c9c910096fa24cf2417c1a158fafa75666)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9b4afaed2bf3616d5c62e74429bef830ddfb6a2d7118fea37c0cbe12afa3dd8f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultMonoHue]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultMonoHue]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultMonoHue]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e9618a027805027b04b5a0b643a28342f385ec22944db90725c2e2fdc8e437b1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultOpacity",
    jsii_struct_bases=[],
    name_mapping={"opacity": "opacity", "opacity_var": "opacityVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultOpacity:
    def __init__(
        self,
        *,
        opacity: typing.Optional[builtins.str] = None,
        opacity_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param opacity: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param opacity_var: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e809c0dae073bbdeb4f0b478b20b6cd6debc49ae3194a2297adc930cbb2c521f)
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument opacity_var", value=opacity_var, expected_type=type_hints["opacity_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if opacity is not None:
            self._values["opacity"] = opacity
        if opacity_var is not None:
            self._values["opacity_var"] = opacity_var

    @builtins.property
    def opacity(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def opacity_var(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        result = self._values.get("opacity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultOpacity(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultOpacityList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultOpacityList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__39281b07f55818c4bceb98da41dd89c83000aebeab84a91360cd36866985ad8d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultOpacityOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8fc9cfa03551d028ad6f9327589e95064bdb2a12d3609b129e7dd9fc6fb958bd)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultOpacityOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__34a922c530eff5d9a4b88dbbd76d198fb6a7419cdae6c3304937ae8fad505e14)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__77629c82df09ec0113e9e536c1c9b0a7160c24bf6871eaefcf24c29bedf30aec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a203eefd28a64104c294557c0664469da291f891d9610e82bf6571c0ba7192e0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultOpacity]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultOpacity]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1845ee75df192944bd2046832979e818c37546b1d85ae55f14b2b8e0b03faeb3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultOpacityOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultOpacityOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__526e5f4a6ca9dea751bf65fcb42c1aff0bbf2c58fa7686de596911eaa2ffab99)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetOpacityVar")
    def reset_opacity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacityVar", []))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityVarInput")
    def opacity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacity"))

    @opacity.setter
    def opacity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__583f7d7fcef27a1243e30733c787084ad6f9a1e10263f201bbca3d179b9da520)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacity", value)

    @builtins.property
    @jsii.member(jsii_name="opacityVar")
    def opacity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacityVar"))

    @opacity_var.setter
    def opacity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__01c588781f1803388edb235d16c80d2794476a02aed1df204e249c09751ffe81)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacityVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultOpacity]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultOpacity]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultOpacity]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fbca410a3a50c0d07fe987496df4689084743b1a66a0965530e204c765587e8f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3796d8a99191ab15e9e1b6f6a7ec904dd3fdd09d5c61757073baa4459bad9a2c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putAppend")
    def put_append(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultAppend, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e2c2bb0ec19bc9cb78f75d415e3d26d8727f0bdcc881f0de27ab0aada9bcb8ea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putAppend", [value]))

    @jsii.member(jsii_name="putAspectCrop")
    def put_aspect_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultAspectCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5e1474d9aecb40825eacb54dbf8d9f82435c93b10be56f1fe604e93bff0551e3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putAspectCrop", [value]))

    @jsii.member(jsii_name="putBackgroundColor")
    def put_background_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__732fb6b70786bafc3bcb39cee325ba2a8d358ca483120b947c30cc656b5b72c2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBackgroundColor", [value]))

    @jsii.member(jsii_name="putBlur")
    def put_blur(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultBlur, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7e88d704f3087ee3e2db3f74c65c3a994538a1df77cb7921794b1bf6c409b1cc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBlur", [value]))

    @jsii.member(jsii_name="putChromaKey")
    def put_chroma_key(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultChromaKey, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e2f38f2b51c2011c3b031bb10ed08718ec9b31692877b94c7848980d8eded411)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putChromaKey", [value]))

    @jsii.member(jsii_name="putComposite")
    def put_composite(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultComposite, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__47083c253cdcbf234a3262c44b1f57e2a588d9eb2c36ad6ea306aeed5c789e11)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putComposite", [value]))

    @jsii.member(jsii_name="putCompound")
    def put_compound(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCompound, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7851ef0dc3766b960135c6f2a488e06fb88577b16339fa874c7f13ac11a0d1c2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCompound", [value]))

    @jsii.member(jsii_name="putContrast")
    def put_contrast(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultContrast, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a2db16022dc0769653b45588e80323104e1cb15e2d0b46c2315ec1316139b2af)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putContrast", [value]))

    @jsii.member(jsii_name="putCrop")
    def put_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bfda5b4a23a06d003575e5d40a133f7c8110e253da2a01eece7d9e776bc63f1c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCrop", [value]))

    @jsii.member(jsii_name="putFaceCrop")
    def put_face_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultFaceCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__72ce5b756da36804060337e6d292b53f655166a6ddf511be00570129c3d52f7a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFaceCrop", [value]))

    @jsii.member(jsii_name="putFeatureCrop")
    def put_feature_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultFeatureCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7df7399143f1459d6b67d50d035a05d9aeb29a84700c439f209477cd031c0094)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFeatureCrop", [value]))

    @jsii.member(jsii_name="putFitAndFill")
    def put_fit_and_fill(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultFitAndFill, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ccbcac490bcfae08cf1344d7c4d3260367e4a6d04d891fe7250a7f14b85c5b31)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFitAndFill", [value]))

    @jsii.member(jsii_name="putGoop")
    def put_goop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultGoop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__70cb1413815c1ac797972d8521cf9d7a2c29c2eb87b3b455dfc8110d75b07e7d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGoop", [value]))

    @jsii.member(jsii_name="putGrayscale")
    def put_grayscale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultGrayscale, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3247c4437ec05ef7a0652dd4f3ddd1cc9391d3a4341672c1963cd06e61d9c798)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGrayscale", [value]))

    @jsii.member(jsii_name="putHsl")
    def put_hsl(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultHsl, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5746b7f692ba7db088039605f1511c04c7739fabcb26b29b03824cea9dae17b2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsl", [value]))

    @jsii.member(jsii_name="putHsv")
    def put_hsv(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultHsv, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__de18b9e13b2e82207bd94d7938aac2bffefd153718a8afbbaf517f4b9635ac6d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsv", [value]))

    @jsii.member(jsii_name="putIfDimension")
    def put_if_dimension(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimension, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8deb3f67e07035a1b999171a33e7b10a08315d49868855d37052ce75d81d2c58)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfDimension", [value]))

    @jsii.member(jsii_name="putIfOrientation")
    def put_if_orientation(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__68369c9527d777f775781c5ccfd6cc42f107766a9aa74b2b8e648851d854e21c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfOrientation", [value]))

    @jsii.member(jsii_name="putImQuery")
    def put_im_query(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultImQuery, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__95cd19e52933eabffc6757adc839d1da5178959242c21eb41d3f952559f30c14)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putImQuery", [value]))

    @jsii.member(jsii_name="putMaxColors")
    def put_max_colors(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultMaxColors, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__12aa3398a330462dad69a371b4cbb376775d357688c5a6ea34b79d68ad89eb68)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMaxColors", [value]))

    @jsii.member(jsii_name="putMirror")
    def put_mirror(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultMirror, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a7a7ed9ca99f2796da70038fa6f82bc8e9edd105a92972da0dc3230f0d32bfe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMirror", [value]))

    @jsii.member(jsii_name="putMonoHue")
    def put_mono_hue(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultMonoHue, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9662f95c53ada5822e562daab0abe32cfb59c1eab7c76ff5bce67d3343e584f9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMonoHue", [value]))

    @jsii.member(jsii_name="putOpacity")
    def put_opacity(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultOpacity, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4659e905ab3d66566324cc8f7d6cceebf81bee63f16f21aaf42e6aa9a1bd3008)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putOpacity", [value]))

    @jsii.member(jsii_name="putRegionOfInterestCrop")
    def put_region_of_interest_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRegionOfInterestCrop", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a097ee6b4be8cbed5831f19cc60fd8896099ac2088c3403979d42cd13e71713f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRegionOfInterestCrop", [value]))

    @jsii.member(jsii_name="putRelativeCrop")
    def put_relative_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRelativeCrop", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c13fb2658c8c2994fbf27565cdcb1ef8ea61317691f42a5c8e1ac16c3c0ed69c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRelativeCrop", [value]))

    @jsii.member(jsii_name="putRemoveColor")
    def put_remove_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRemoveColor", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d4f6b616a27a024b009385bcb5e3cae73b237ecde288589b3bc93d5e90cb4c61)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRemoveColor", [value]))

    @jsii.member(jsii_name="putResize")
    def put_resize(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultResize", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__29a88c62ba80ba56e3e0d78266e5862e4b8f60915f1a71a3ad774423ab9cea87)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putResize", [value]))

    @jsii.member(jsii_name="putRotate")
    def put_rotate(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRotate", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a4d388b18cdbc8db3d32bfc943604c473d9c334e188d22932bea83a4329de58f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRotate", [value]))

    @jsii.member(jsii_name="putScale")
    def put_scale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultScale", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5551b7bb804b346af052f982f21b69be0e8cdda81cc2db2d8f495d13de3a83aa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putScale", [value]))

    @jsii.member(jsii_name="putShear")
    def put_shear(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultShear", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d2821754db7c8624c3c75e24640f72b666715e8fb53c9dd12dcd3e31dd029738)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putShear", [value]))

    @jsii.member(jsii_name="putTrim")
    def put_trim(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultTrim", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f80ef10bf2d39d63e0668214fe35080a54f9fb50e6c4e6127c9ad25d599cd7e5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTrim", [value]))

    @jsii.member(jsii_name="putUnsharpMask")
    def put_unsharp_mask(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultUnsharpMask", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5284536c785cb452b1065198e7080b19d5bc0bc3d855839b3acbaea408ef2ae3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putUnsharpMask", [value]))

    @jsii.member(jsii_name="resetAppend")
    def reset_append(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAppend", []))

    @jsii.member(jsii_name="resetAspectCrop")
    def reset_aspect_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspectCrop", []))

    @jsii.member(jsii_name="resetBackgroundColor")
    def reset_background_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBackgroundColor", []))

    @jsii.member(jsii_name="resetBlur")
    def reset_blur(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBlur", []))

    @jsii.member(jsii_name="resetChromaKey")
    def reset_chroma_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChromaKey", []))

    @jsii.member(jsii_name="resetComposite")
    def reset_composite(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetComposite", []))

    @jsii.member(jsii_name="resetCompound")
    def reset_compound(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCompound", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetCrop")
    def reset_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCrop", []))

    @jsii.member(jsii_name="resetFaceCrop")
    def reset_face_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFaceCrop", []))

    @jsii.member(jsii_name="resetFeatureCrop")
    def reset_feature_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureCrop", []))

    @jsii.member(jsii_name="resetFitAndFill")
    def reset_fit_and_fill(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFitAndFill", []))

    @jsii.member(jsii_name="resetGoop")
    def reset_goop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGoop", []))

    @jsii.member(jsii_name="resetGrayscale")
    def reset_grayscale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGrayscale", []))

    @jsii.member(jsii_name="resetHsl")
    def reset_hsl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsl", []))

    @jsii.member(jsii_name="resetHsv")
    def reset_hsv(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsv", []))

    @jsii.member(jsii_name="resetIfDimension")
    def reset_if_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfDimension", []))

    @jsii.member(jsii_name="resetIfOrientation")
    def reset_if_orientation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfOrientation", []))

    @jsii.member(jsii_name="resetImQuery")
    def reset_im_query(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetImQuery", []))

    @jsii.member(jsii_name="resetMaxColors")
    def reset_max_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxColors", []))

    @jsii.member(jsii_name="resetMirror")
    def reset_mirror(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMirror", []))

    @jsii.member(jsii_name="resetMonoHue")
    def reset_mono_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonoHue", []))

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetRegionOfInterestCrop")
    def reset_region_of_interest_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRegionOfInterestCrop", []))

    @jsii.member(jsii_name="resetRelativeCrop")
    def reset_relative_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRelativeCrop", []))

    @jsii.member(jsii_name="resetRemoveColor")
    def reset_remove_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRemoveColor", []))

    @jsii.member(jsii_name="resetResize")
    def reset_resize(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetResize", []))

    @jsii.member(jsii_name="resetRotate")
    def reset_rotate(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRotate", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetShear")
    def reset_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetShear", []))

    @jsii.member(jsii_name="resetTrim")
    def reset_trim(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTrim", []))

    @jsii.member(jsii_name="resetUnsharpMask")
    def reset_unsharp_mask(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUnsharpMask", []))

    @builtins.property
    @jsii.member(jsii_name="append")
    def append(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultAppendList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultAppendList, jsii.get(self, "append"))

    @builtins.property
    @jsii.member(jsii_name="aspectCrop")
    def aspect_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultAspectCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultAspectCropList, jsii.get(self, "aspectCrop"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColor")
    def background_color(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultBackgroundColorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultBackgroundColorList, jsii.get(self, "backgroundColor"))

    @builtins.property
    @jsii.member(jsii_name="blur")
    def blur(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultBlurList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultBlurList, jsii.get(self, "blur"))

    @builtins.property
    @jsii.member(jsii_name="chromaKey")
    def chroma_key(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultChromaKeyList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultChromaKeyList, jsii.get(self, "chromaKey"))

    @builtins.property
    @jsii.member(jsii_name="composite")
    def composite(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCompositeList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCompositeList, jsii.get(self, "composite"))

    @builtins.property
    @jsii.member(jsii_name="compound")
    def compound(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCompoundList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCompoundList, jsii.get(self, "compound"))

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultContrastList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultContrastList, jsii.get(self, "contrast"))

    @builtins.property
    @jsii.member(jsii_name="crop")
    def crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCropList, jsii.get(self, "crop"))

    @builtins.property
    @jsii.member(jsii_name="faceCrop")
    def face_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultFaceCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultFaceCropList, jsii.get(self, "faceCrop"))

    @builtins.property
    @jsii.member(jsii_name="featureCrop")
    def feature_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultFeatureCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultFeatureCropList, jsii.get(self, "featureCrop"))

    @builtins.property
    @jsii.member(jsii_name="fitAndFill")
    def fit_and_fill(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultFitAndFillList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultFitAndFillList, jsii.get(self, "fitAndFill"))

    @builtins.property
    @jsii.member(jsii_name="goop")
    def goop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultGoopList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultGoopList, jsii.get(self, "goop"))

    @builtins.property
    @jsii.member(jsii_name="grayscale")
    def grayscale(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultGrayscaleList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultGrayscaleList, jsii.get(self, "grayscale"))

    @builtins.property
    @jsii.member(jsii_name="hsl")
    def hsl(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultHslList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultHslList, jsii.get(self, "hsl"))

    @builtins.property
    @jsii.member(jsii_name="hsv")
    def hsv(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultHsvList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultHsvList, jsii.get(self, "hsv"))

    @builtins.property
    @jsii.member(jsii_name="ifDimension")
    def if_dimension(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionList, jsii.get(self, "ifDimension"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientation")
    def if_orientation(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationList, jsii.get(self, "ifOrientation"))

    @builtins.property
    @jsii.member(jsii_name="imQuery")
    def im_query(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultImQueryList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultImQueryList, jsii.get(self, "imQuery"))

    @builtins.property
    @jsii.member(jsii_name="maxColors")
    def max_colors(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultMaxColorsList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultMaxColorsList, jsii.get(self, "maxColors"))

    @builtins.property
    @jsii.member(jsii_name="mirror")
    def mirror(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultMirrorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultMirrorList, jsii.get(self, "mirror"))

    @builtins.property
    @jsii.member(jsii_name="monoHue")
    def mono_hue(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultMonoHueList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultMonoHueList, jsii.get(self, "monoHue"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultOpacityList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultOpacityList, jsii.get(self, "opacity"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestCrop")
    def region_of_interest_crop(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRegionOfInterestCropList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRegionOfInterestCropList", jsii.get(self, "regionOfInterestCrop"))

    @builtins.property
    @jsii.member(jsii_name="relativeCrop")
    def relative_crop(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRelativeCropList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRelativeCropList", jsii.get(self, "relativeCrop"))

    @builtins.property
    @jsii.member(jsii_name="removeColor")
    def remove_color(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRemoveColorList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRemoveColorList", jsii.get(self, "removeColor"))

    @builtins.property
    @jsii.member(jsii_name="resize")
    def resize(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultResizeList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultResizeList", jsii.get(self, "resize"))

    @builtins.property
    @jsii.member(jsii_name="rotate")
    def rotate(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRotateList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRotateList", jsii.get(self, "rotate"))

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultScaleList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultScaleList", jsii.get(self, "scale"))

    @builtins.property
    @jsii.member(jsii_name="shear")
    def shear(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultShearList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultShearList", jsii.get(self, "shear"))

    @builtins.property
    @jsii.member(jsii_name="trim")
    def trim(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultTrimList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultTrimList", jsii.get(self, "trim"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMask")
    def unsharp_mask(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultUnsharpMaskList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultUnsharpMaskList", jsii.get(self, "unsharpMask"))

    @builtins.property
    @jsii.member(jsii_name="appendInput")
    def append_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultAppend]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultAppend]]], jsii.get(self, "appendInput"))

    @builtins.property
    @jsii.member(jsii_name="aspectCropInput")
    def aspect_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultAspectCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultAspectCrop]]], jsii.get(self, "aspectCropInput"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColorInput")
    def background_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultBackgroundColor]]], jsii.get(self, "backgroundColorInput"))

    @builtins.property
    @jsii.member(jsii_name="blurInput")
    def blur_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultBlur]]], jsii.get(self, "blurInput"))

    @builtins.property
    @jsii.member(jsii_name="chromaKeyInput")
    def chroma_key_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultChromaKey]]], jsii.get(self, "chromaKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="compositeInput")
    def composite_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultComposite]]], jsii.get(self, "compositeInput"))

    @builtins.property
    @jsii.member(jsii_name="compoundInput")
    def compound_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCompound]]], jsii.get(self, "compoundInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultContrast]]], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="cropInput")
    def crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCrop]]], jsii.get(self, "cropInput"))

    @builtins.property
    @jsii.member(jsii_name="faceCropInput")
    def face_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultFaceCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultFaceCrop]]], jsii.get(self, "faceCropInput"))

    @builtins.property
    @jsii.member(jsii_name="featureCropInput")
    def feature_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultFeatureCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultFeatureCrop]]], jsii.get(self, "featureCropInput"))

    @builtins.property
    @jsii.member(jsii_name="fitAndFillInput")
    def fit_and_fill_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultFitAndFill]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultFitAndFill]]], jsii.get(self, "fitAndFillInput"))

    @builtins.property
    @jsii.member(jsii_name="goopInput")
    def goop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultGoop]]], jsii.get(self, "goopInput"))

    @builtins.property
    @jsii.member(jsii_name="grayscaleInput")
    def grayscale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultGrayscale]]], jsii.get(self, "grayscaleInput"))

    @builtins.property
    @jsii.member(jsii_name="hslInput")
    def hsl_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultHsl]]], jsii.get(self, "hslInput"))

    @builtins.property
    @jsii.member(jsii_name="hsvInput")
    def hsv_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultHsv]]], jsii.get(self, "hsvInput"))

    @builtins.property
    @jsii.member(jsii_name="ifDimensionInput")
    def if_dimension_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimension]]], jsii.get(self, "ifDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientationInput")
    def if_orientation_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientation]]], jsii.get(self, "ifOrientationInput"))

    @builtins.property
    @jsii.member(jsii_name="imQueryInput")
    def im_query_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultImQuery]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultImQuery]]], jsii.get(self, "imQueryInput"))

    @builtins.property
    @jsii.member(jsii_name="maxColorsInput")
    def max_colors_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultMaxColors]]], jsii.get(self, "maxColorsInput"))

    @builtins.property
    @jsii.member(jsii_name="mirrorInput")
    def mirror_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultMirror]]], jsii.get(self, "mirrorInput"))

    @builtins.property
    @jsii.member(jsii_name="monoHueInput")
    def mono_hue_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultMonoHue]]], jsii.get(self, "monoHueInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultOpacity]]], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestCropInput")
    def region_of_interest_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRegionOfInterestCrop"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRegionOfInterestCrop"]]], jsii.get(self, "regionOfInterestCropInput"))

    @builtins.property
    @jsii.member(jsii_name="relativeCropInput")
    def relative_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRelativeCrop"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRelativeCrop"]]], jsii.get(self, "relativeCropInput"))

    @builtins.property
    @jsii.member(jsii_name="removeColorInput")
    def remove_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRemoveColor"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRemoveColor"]]], jsii.get(self, "removeColorInput"))

    @builtins.property
    @jsii.member(jsii_name="resizeInput")
    def resize_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultResize"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultResize"]]], jsii.get(self, "resizeInput"))

    @builtins.property
    @jsii.member(jsii_name="rotateInput")
    def rotate_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRotate"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRotate"]]], jsii.get(self, "rotateInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultScale"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultScale"]]], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="shearInput")
    def shear_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultShear"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultShear"]]], jsii.get(self, "shearInput"))

    @builtins.property
    @jsii.member(jsii_name="trimInput")
    def trim_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultTrim"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultTrim"]]], jsii.get(self, "trimInput"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMaskInput")
    def unsharp_mask_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultUnsharpMask"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultUnsharpMask"]]], jsii.get(self, "unsharpMaskInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__452741125e2b4767f2c6cc4e52d1293d3ce183a6af56b1f49c1022f5956dd50d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRegionOfInterestCrop",
    jsii_struct_bases=[],
    name_mapping={
        "region_of_interest": "regionOfInterest",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRegionOfInterestCrop:
    def __init__(
        self,
        *,
        region_of_interest: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRegionOfInterestCropRegionOfInterest", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param region_of_interest: region_of_interest block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest DataAkamaiImagingPolicyImage#region_of_interest}
        :param gravity: The placement of the crop area relative to the specified area of interest. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: The placement of the crop area relative to the specified area of interest. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param style: Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(region_of_interest, dict):
            region_of_interest = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRegionOfInterestCropRegionOfInterest(**region_of_interest)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6a615b8f93fc23b3258985cb0f1daa77c83b22f33eaf044ddcb172e16655a1fc)
            check_type(argname="argument region_of_interest", value=region_of_interest, expected_type=type_hints["region_of_interest"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "region_of_interest": region_of_interest,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def region_of_interest(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRegionOfInterestCropRegionOfInterest":
        '''region_of_interest block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest DataAkamaiImagingPolicyImage#region_of_interest}
        '''
        result = self._values.get("region_of_interest")
        assert result is not None, "Required property 'region_of_interest' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRegionOfInterestCropRegionOfInterest", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''The placement of the crop area relative to the specified area of interest.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''The placement of the crop area relative to the specified area of interest.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRegionOfInterestCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRegionOfInterestCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRegionOfInterestCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2c10708c725324b40beb44ba1b1af8ad90038387cd925483ae71d82dee741e46)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRegionOfInterestCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8b586cc9cfec36a0baa41c80a28edb748bfdbb4800c293ea0458d1a75e490d0c)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRegionOfInterestCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a2ade57322b33958966cef91473be1def4384ad81408a7a059d98c7d2d7b48ee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c2c4d172c4dfd68a76f676a5987d00e35c85884f2b76663b12533d1fd3b8a3fa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__85065ba83b207c00a99cce2cd869c0f8eadc1cf7643d35f63300be7c30115be5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRegionOfInterestCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRegionOfInterestCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRegionOfInterestCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e89fc8741dfa7627cd02da6fab6853e80133d20c58c2c9519e540dadb327f1a8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRegionOfInterestCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRegionOfInterestCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__62ee1e7137575a87bf735164ba68224907b465afba676d81013dc8aa728ae6f5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putRegionOfInterest")
    def put_region_of_interest(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRegionOfInterestCropRegionOfInterest()

        return typing.cast(None, jsii.invoke(self, "putRegionOfInterest", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterest")
    def region_of_interest(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRegionOfInterestCropRegionOfInterestOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRegionOfInterestCropRegionOfInterestOutputReference", jsii.get(self, "regionOfInterest"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestInput")
    def region_of_interest_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRegionOfInterestCropRegionOfInterest"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRegionOfInterestCropRegionOfInterest"], jsii.get(self, "regionOfInterestInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__becaff26aa2cdbaf884ac51ef59e8bdfb44d61b2294aa6292d3caf2d6643a747)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8ed022076d75092f41054b389a6d2b14a2de5d13bb8d971411ca533f2614f386)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1177ce8e095ac9a83bcfda1fcba4aded8a6495459d28de688e36c0842176673b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6b544c4fd63828fc697ce2c0076262c6b8376d6030a7e64b45b16153fd697e48)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__98518bea98b67f6cf62a7894774d80658e506723ed56ff9a3fb1dec748c50d23)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c33c8eaf7d0061cb32081a2c6674a692b0d0e3f97caabd78e637e3b9292bbc26)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bdb2053eb08d299463c129c13f617b687abfb8051ad7883bade10371c2415689)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__20cd436d6645658bc110ed4ae0730c941dc00f482a5faf2bd8eb7a4627d1cfaa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRegionOfInterestCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRegionOfInterestCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRegionOfInterestCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9283b915825573ab734b089657454d124ab47299dc524795e2f36ec1769e6102)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRegionOfInterestCropRegionOfInterest",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRegionOfInterestCropRegionOfInterest:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRegionOfInterestCropRegionOfInterest(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRegionOfInterestCropRegionOfInterestOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRegionOfInterestCropRegionOfInterestOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8c197a495f00a320d788d7a3c1a4ac714373c46dd977dd4d2ab6cdd58d3bac25)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRegionOfInterestCropRegionOfInterest]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRegionOfInterestCropRegionOfInterest], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRegionOfInterestCropRegionOfInterest],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb8801b42aca3a7c51af5af767cf98d002e9263a1e6a63a25a7ca5c0dd662808)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRelativeCrop",
    jsii_struct_bases=[],
    name_mapping={
        "east": "east",
        "east_var": "eastVar",
        "north": "north",
        "north_var": "northVar",
        "south": "south",
        "south_var": "southVar",
        "west": "west",
        "west_var": "westVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRelativeCrop:
    def __init__(
        self,
        *,
        east: typing.Optional[builtins.str] = None,
        east_var: typing.Optional[builtins.str] = None,
        north: typing.Optional[builtins.str] = None,
        north_var: typing.Optional[builtins.str] = None,
        south: typing.Optional[builtins.str] = None,
        south_var: typing.Optional[builtins.str] = None,
        west: typing.Optional[builtins.str] = None,
        west_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param east: The number of pixels to shrink or expand the right side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east DataAkamaiImagingPolicyImage#east}
        :param east_var: The number of pixels to shrink or expand the right side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east_var DataAkamaiImagingPolicyImage#east_var}
        :param north: The number of pixels to shrink or expand the top side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north DataAkamaiImagingPolicyImage#north}
        :param north_var: The number of pixels to shrink or expand the top side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north_var DataAkamaiImagingPolicyImage#north_var}
        :param south: The number of pixels to shrink or expand the bottom side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south DataAkamaiImagingPolicyImage#south}
        :param south_var: The number of pixels to shrink or expand the bottom side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south_var DataAkamaiImagingPolicyImage#south_var}
        :param west: The number of pixels to shrink or expand the left side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west DataAkamaiImagingPolicyImage#west}
        :param west_var: The number of pixels to shrink or expand the left side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west_var DataAkamaiImagingPolicyImage#west_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d8551527af7bfea9a8da469732bd2efe063cdea6e42dd1a84c2af1c86d2ffb7a)
            check_type(argname="argument east", value=east, expected_type=type_hints["east"])
            check_type(argname="argument east_var", value=east_var, expected_type=type_hints["east_var"])
            check_type(argname="argument north", value=north, expected_type=type_hints["north"])
            check_type(argname="argument north_var", value=north_var, expected_type=type_hints["north_var"])
            check_type(argname="argument south", value=south, expected_type=type_hints["south"])
            check_type(argname="argument south_var", value=south_var, expected_type=type_hints["south_var"])
            check_type(argname="argument west", value=west, expected_type=type_hints["west"])
            check_type(argname="argument west_var", value=west_var, expected_type=type_hints["west_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if east is not None:
            self._values["east"] = east
        if east_var is not None:
            self._values["east_var"] = east_var
        if north is not None:
            self._values["north"] = north
        if north_var is not None:
            self._values["north_var"] = north_var
        if south is not None:
            self._values["south"] = south
        if south_var is not None:
            self._values["south_var"] = south_var
        if west is not None:
            self._values["west"] = west
        if west_var is not None:
            self._values["west_var"] = west_var

    @builtins.property
    def east(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the right side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east DataAkamaiImagingPolicyImage#east}
        '''
        result = self._values.get("east")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def east_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the right side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east_var DataAkamaiImagingPolicyImage#east_var}
        '''
        result = self._values.get("east_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def north(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the top side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north DataAkamaiImagingPolicyImage#north}
        '''
        result = self._values.get("north")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def north_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the top side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north_var DataAkamaiImagingPolicyImage#north_var}
        '''
        result = self._values.get("north_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def south(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the bottom side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south DataAkamaiImagingPolicyImage#south}
        '''
        result = self._values.get("south")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def south_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the bottom side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south_var DataAkamaiImagingPolicyImage#south_var}
        '''
        result = self._values.get("south_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def west(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the left side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west DataAkamaiImagingPolicyImage#west}
        '''
        result = self._values.get("west")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def west_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the left side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west_var DataAkamaiImagingPolicyImage#west_var}
        '''
        result = self._values.get("west_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRelativeCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRelativeCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRelativeCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__27c87df38adcf8a8d2a7521923a2f79325ddee72e1a6eca0a4497fa325926502)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRelativeCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c40dec161aea8d5bdc89a598c888fd0f9287d0203f861d9aad4f960db1f8e1d2)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRelativeCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ece83672389a7a8a98720dd7b0918496f01e4d6b7e1f054ab591853c5ad8ef88)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3255785cfe2aa421e560a541bc5e3225fd3296acdd21f6d05096caa201536083)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cc1deff14191ffc691d0304dce408bb3cacbbec1bc96c61e003396eb929c74de)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRelativeCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRelativeCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRelativeCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7364d94c432c447cfda285f80a4c7cb26360eb47c4ac5cd5a81c20def4c5b7d9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRelativeCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRelativeCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ee8e612a22bfd305ce0d19a17aa7b488356c6ced26725830756ca2ce9739a508)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetEast")
    def reset_east(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEast", []))

    @jsii.member(jsii_name="resetEastVar")
    def reset_east_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEastVar", []))

    @jsii.member(jsii_name="resetNorth")
    def reset_north(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNorth", []))

    @jsii.member(jsii_name="resetNorthVar")
    def reset_north_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNorthVar", []))

    @jsii.member(jsii_name="resetSouth")
    def reset_south(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSouth", []))

    @jsii.member(jsii_name="resetSouthVar")
    def reset_south_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSouthVar", []))

    @jsii.member(jsii_name="resetWest")
    def reset_west(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWest", []))

    @jsii.member(jsii_name="resetWestVar")
    def reset_west_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWestVar", []))

    @builtins.property
    @jsii.member(jsii_name="eastInput")
    def east_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "eastInput"))

    @builtins.property
    @jsii.member(jsii_name="eastVarInput")
    def east_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "eastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="northInput")
    def north_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "northInput"))

    @builtins.property
    @jsii.member(jsii_name="northVarInput")
    def north_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "northVarInput"))

    @builtins.property
    @jsii.member(jsii_name="southInput")
    def south_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "southInput"))

    @builtins.property
    @jsii.member(jsii_name="southVarInput")
    def south_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "southVarInput"))

    @builtins.property
    @jsii.member(jsii_name="westInput")
    def west_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "westInput"))

    @builtins.property
    @jsii.member(jsii_name="westVarInput")
    def west_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "westVarInput"))

    @builtins.property
    @jsii.member(jsii_name="east")
    def east(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "east"))

    @east.setter
    def east(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__66cbaa6023ec9c716dfa01ab1dc7f10cd133b408cd0f719d18227b0dbd6318e9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "east", value)

    @builtins.property
    @jsii.member(jsii_name="eastVar")
    def east_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "eastVar"))

    @east_var.setter
    def east_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__486f8e468cfea16aaa878d1a343def612535720786f06b6395a0419543f47d07)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "eastVar", value)

    @builtins.property
    @jsii.member(jsii_name="north")
    def north(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "north"))

    @north.setter
    def north(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__083ab7939959e924e01d52026546e991f1b3dc30a0efff8dbe564aebd415839f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "north", value)

    @builtins.property
    @jsii.member(jsii_name="northVar")
    def north_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "northVar"))

    @north_var.setter
    def north_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__62e140c5079add2d21ab0a6fecbf2c86629c1eeee39543d4d1943bd23d9b5a6c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "northVar", value)

    @builtins.property
    @jsii.member(jsii_name="south")
    def south(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "south"))

    @south.setter
    def south(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ce1eedcaacd7c2dad4b9856a1e07b1decf0b0e6bb99535b233ddde7f2c0cc1db)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "south", value)

    @builtins.property
    @jsii.member(jsii_name="southVar")
    def south_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "southVar"))

    @south_var.setter
    def south_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b1a93b941c3211e9cf179a19a0c2ac35a645307091285d3b5a35f6d7867708ec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "southVar", value)

    @builtins.property
    @jsii.member(jsii_name="west")
    def west(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "west"))

    @west.setter
    def west(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fd7e352709e56a0b9584545156577eb4605fbb540c685fc129e3a0aa1f708f6d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "west", value)

    @builtins.property
    @jsii.member(jsii_name="westVar")
    def west_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "westVar"))

    @west_var.setter
    def west_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fb68ec3235d78a3d6d4ae16b5e9460bb71ccb435e2187ba105c744f9b5b68b24)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "westVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRelativeCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRelativeCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRelativeCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5d3915531f109dca9fba410b696824621a031651cd5e2f79e217f12d16a9ac36)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRemoveColor",
    jsii_struct_bases=[],
    name_mapping={
        "color": "color",
        "color_var": "colorVar",
        "feather": "feather",
        "feather_var": "featherVar",
        "tolerance": "tolerance",
        "tolerance_var": "toleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRemoveColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
        feather: typing.Optional[builtins.str] = None,
        feather_var: typing.Optional[builtins.str] = None,
        tolerance: typing.Optional[builtins.str] = None,
        tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        :param feather: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        :param feather_var: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        :param tolerance: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        :param tolerance_var: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2892206ff695fa8155d8fa9237488ec7350ea32ed3ee1201e03ea550b09b6f62)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
            check_type(argname="argument feather", value=feather, expected_type=type_hints["feather"])
            check_type(argname="argument feather_var", value=feather_var, expected_type=type_hints["feather_var"])
            check_type(argname="argument tolerance", value=tolerance, expected_type=type_hints["tolerance"])
            check_type(argname="argument tolerance_var", value=tolerance_var, expected_type=type_hints["tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var
        if feather is not None:
            self._values["feather"] = feather
        if feather_var is not None:
            self._values["feather_var"] = feather_var
        if tolerance is not None:
            self._values["tolerance"] = tolerance
        if tolerance_var is not None:
            self._values["tolerance_var"] = tolerance_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        '''
        result = self._values.get("feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather_var(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        '''
        result = self._values.get("feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        '''
        result = self._values.get("tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance_var(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        result = self._values.get("tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRemoveColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRemoveColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRemoveColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1b50bf57a173bf6d907d8a7b98b96c122b6297e2ac693fd4156b827049692872)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRemoveColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__68d2ed45ce1d8db0f80429a754fcae93d9537bf3da93b1cb6c9ae1b2157286d9)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRemoveColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b8f52a642a1e3340a59bd342535cb4d8c608abac8ec2a8e4ac65b66d58b96661)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__58b41d55f6910e469cebde39faf10b916f4337f4fd4350937977016f681a813f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f85888d775453523a0b08ac7fc9269e0d7d8173ea26725d27cfca8cfd6eec6ab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRemoveColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRemoveColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRemoveColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b1218c27b95b77b0deee5370158ee320c59ab0e90ad53e6c2f95cf5b682d5d5e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRemoveColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRemoveColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__20a1c8608b2efb38d07e00bb534fb91458a119beffd3b08b64f19438ace63ce9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @jsii.member(jsii_name="resetFeather")
    def reset_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeather", []))

    @jsii.member(jsii_name="resetFeatherVar")
    def reset_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatherVar", []))

    @jsii.member(jsii_name="resetTolerance")
    def reset_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTolerance", []))

    @jsii.member(jsii_name="resetToleranceVar")
    def reset_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featherInput")
    def feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherInput"))

    @builtins.property
    @jsii.member(jsii_name="featherVarInput")
    def feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceInput")
    def tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceVarInput")
    def tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__23c2db0ea98edb5d89e584a3817544e453afb5164cbef44312a3b1ac7c7f8c1b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dc7ad64e74d404d415112121520e12a04f43c0ec8b41b4c2bd0f26c2c5535124)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="feather")
    def feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "feather"))

    @feather.setter
    def feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__894cfaefe182e3732e117460f4f642f488dc3cd216d53d3d32ad938efa0ab987)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "feather", value)

    @builtins.property
    @jsii.member(jsii_name="featherVar")
    def feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featherVar"))

    @feather_var.setter
    def feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c9a78a7dbe6a3247ef66053ce762fd8b5de832c4ab4c5a292d6924627a830698)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featherVar", value)

    @builtins.property
    @jsii.member(jsii_name="tolerance")
    def tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tolerance"))

    @tolerance.setter
    def tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1d1011aff06e69fda94dd01c180b6caaeb6b6a063494312f2969ffbef534dc77)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tolerance", value)

    @builtins.property
    @jsii.member(jsii_name="toleranceVar")
    def tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "toleranceVar"))

    @tolerance_var.setter
    def tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f06ecc570690b93de64c1917a9901be299c1ebdd14265cccbde8e2a684ed511b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "toleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRemoveColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRemoveColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRemoveColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a0c48d8b068600b63c4f7d362675fe7928553c8457075feabcfdac40a6227055)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultResize",
    jsii_struct_bases=[],
    name_mapping={
        "aspect": "aspect",
        "aspect_var": "aspectVar",
        "height": "height",
        "height_var": "heightVar",
        "type": "type",
        "type_var": "typeVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultResize:
    def __init__(
        self,
        *,
        aspect: typing.Optional[builtins.str] = None,
        aspect_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param aspect: Preserves the aspect ratio. Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect DataAkamaiImagingPolicyImage#aspect}
        :param aspect_var: Preserves the aspect ratio. Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_var DataAkamaiImagingPolicyImage#aspect_var}
        :param height: The height to resize the source image to. Must be set if height is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height to resize the source image to. Must be set if height is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param type: Sets constraints for the image resize. Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: Sets constraints for the image resize. Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        :param width: The width to resize the source image to. Must be set if width is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width to resize the source image to. Must be set if width is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__68ac959e0c6953290fa6367ce231342205fd72cbd78305beebd887c609be55a2)
            check_type(argname="argument aspect", value=aspect, expected_type=type_hints["aspect"])
            check_type(argname="argument aspect_var", value=aspect_var, expected_type=type_hints["aspect_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if aspect is not None:
            self._values["aspect"] = aspect
        if aspect_var is not None:
            self._values["aspect_var"] = aspect_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def aspect(self) -> typing.Optional[builtins.str]:
        '''Preserves the aspect ratio.

        Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect DataAkamaiImagingPolicyImage#aspect}
        '''
        result = self._values.get("aspect")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def aspect_var(self) -> typing.Optional[builtins.str]:
        '''Preserves the aspect ratio.

        Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_var DataAkamaiImagingPolicyImage#aspect_var}
        '''
        result = self._values.get("aspect_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height to resize the source image to. Must be set if height is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height to resize the source image to. Must be set if height is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''Sets constraints for the image resize.

        Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''Sets constraints for the image resize.

        Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width to resize the source image to. Must be set if width is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width to resize the source image to. Must be set if width is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultResize(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultResizeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultResizeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dccc210e331bb60758b0d123715741b8bd14b625bbd88a486e0b65090f6e61ab)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultResizeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ec7690c504becf94517187cc860d8d0a8659d16a47f785cb00453c7d79d9778d)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultResizeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d4efdfa8914d5f3a1ede8832bf3e15dd0015e31722ea1026125822f9a2f48bbb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c48cb6f8fed59021bddb6c02139c0e932397a6b5de4724b99a65d7b62c7b82cd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9dea8d0caf0a88caf8df9686a49b0b0d8a19f9305f8c662af71ce52fd7659d88)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultResize]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultResize]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultResize]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__05080afcfdb4f9bd4f9c408dbb0d47174763134bf31e9f53a01165bbc73d85ce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultResizeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultResizeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__56ced36b74f11d3416daf3c69e6dde25001969776aa1d8763f23501bc8d4675d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAspect")
    def reset_aspect(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspect", []))

    @jsii.member(jsii_name="resetAspectVar")
    def reset_aspect_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspectVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="aspectInput")
    def aspect_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "aspectInput"))

    @builtins.property
    @jsii.member(jsii_name="aspectVarInput")
    def aspect_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "aspectVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="aspect")
    def aspect(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "aspect"))

    @aspect.setter
    def aspect(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8b742e75b3a48f966dd5cedbfe118de75e883eccfcc849c4b6a48e86bee14f55)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "aspect", value)

    @builtins.property
    @jsii.member(jsii_name="aspectVar")
    def aspect_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "aspectVar"))

    @aspect_var.setter
    def aspect_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7dfbfad8e9d0733073f2f2b180dedd465f4d78ab02d182a534ce8707faf0ffdc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "aspectVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__50f45407d14ad173039db308e54a2f4b97d2b065ecee828e0f6e7757e8d6dc10)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dbc84efab6561392d2b7bb8e360301e38742481869d12f171ba1f24d8d781b98)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e81207e3be2547be6f1872634614697feebd10f546e27f72dcc1e117b0a857e1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9388308706f48dd61a29f9f833ea51f9458e7d97b8c7e5639b9e6fd851040057)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__526568cd75813141f1859e8b55c7e8b24bbfc5286ba222754169476802b32cab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1c7b565a9cb31ae8091025398231b999e498e3f7682fe30aa111e82b97692b8b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultResize]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultResize]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultResize]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ee176b72a58925358e69b389b2709e4ed011e80a7f2c39dc3ebd4a05a045754f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRotate",
    jsii_struct_bases=[],
    name_mapping={"degrees": "degrees", "degrees_var": "degreesVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRotate:
    def __init__(
        self,
        *,
        degrees: typing.Optional[builtins.str] = None,
        degrees_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param degrees: The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees DataAkamaiImagingPolicyImage#degrees}
        :param degrees_var: The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees_var DataAkamaiImagingPolicyImage#degrees_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3c3bd08d877e0b56703ffa8186c77746d071817d0ef903cc6368d462f3365e03)
            check_type(argname="argument degrees", value=degrees, expected_type=type_hints["degrees"])
            check_type(argname="argument degrees_var", value=degrees_var, expected_type=type_hints["degrees_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if degrees is not None:
            self._values["degrees"] = degrees
        if degrees_var is not None:
            self._values["degrees_var"] = degrees_var

    @builtins.property
    def degrees(self) -> typing.Optional[builtins.str]:
        '''The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees DataAkamaiImagingPolicyImage#degrees}
        '''
        result = self._values.get("degrees")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def degrees_var(self) -> typing.Optional[builtins.str]:
        '''The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees_var DataAkamaiImagingPolicyImage#degrees_var}
        '''
        result = self._values.get("degrees_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRotate(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRotateList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRotateList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__da2fe12ed3e4914f3d19b40977d37528e26ac58e1c1cd66a700d2b75146040a7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRotateOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a9f2ba45433e01be7b47403fd5115c36fffeed312257e8bcf9577491a92304b9)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRotateOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__96b6ed19121088bf1394c4123f904279224fa7bd84489def73b319430fabaca0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c68629db9dde8998f24fbbf201d660c2334257bf18fb9b17c7fb75d7dca5363e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__de503670c3259f887d2f7ce753555b17113978df1114dcb6a643553d2e8e5d82)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRotate]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRotate]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRotate]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f9c0289242cb56423aa8904d0c4ddeedaa2b434e7796aece6c1b290a4f81e5a6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRotateOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRotateOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4fc9684f32ba6fa443bef76b92400d7a38fd7ea96b029b3f85a97bd07b685f8b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetDegrees")
    def reset_degrees(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDegrees", []))

    @jsii.member(jsii_name="resetDegreesVar")
    def reset_degrees_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDegreesVar", []))

    @builtins.property
    @jsii.member(jsii_name="degreesInput")
    def degrees_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "degreesInput"))

    @builtins.property
    @jsii.member(jsii_name="degreesVarInput")
    def degrees_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "degreesVarInput"))

    @builtins.property
    @jsii.member(jsii_name="degrees")
    def degrees(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "degrees"))

    @degrees.setter
    def degrees(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0a11856fe78b0dfd462ef2e7092b75a527c87bf1e1d98304e01efd9590048a6e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "degrees", value)

    @builtins.property
    @jsii.member(jsii_name="degreesVar")
    def degrees_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "degreesVar"))

    @degrees_var.setter
    def degrees_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f7e6ccfae53bbd771092409ee8265dc372cb5be3c366246a08fe876a6f0ae2e7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "degreesVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRotate]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRotate]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRotate]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a4a47fe6b89650b6c123e933e554ac070ddcf4118f3a768fb16c594296fe0b78)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultScale",
    jsii_struct_bases=[],
    name_mapping={
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultScale:
    def __init__(
        self,
        *,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param height: Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged. Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged. Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bf6c55bee8603ba2adf2cf6d6886f17a3049dd57713de0001dc7d36d3433dee5)
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size.

        Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size.

        Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged.

        Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged.

        Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultScale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultScaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultScaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__56869558d836fcc3b19f925c58508f6f787551ee411de9dbdf91443a955ad634)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultScaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d306b357aa290c5ecdf2dd2dbf9b4441410380e44680ea3465a6c1dfa3da605c)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultScaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab50ed2dc22ab69b244d5813f5ad6160b9c5abf17469102f58fa2ff15b6ea49e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a467f43d51f190f29ccf6f6449f0420044a7fe2f24bc018ad68350978c2188f0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5bb96aad02e91184ab573a7855703b24b789aaffe83e24b9c83b91b044bb357e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultScale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultScale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultScale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c7918820e1087b3e2d5b2781610535985a0151b51ac6ec2cd21ced9197727392)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultScaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultScaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__03a94d90f709b4394f4d8bd23ca9ab448ee6a67e633cfeac0fed1bfedad06d2d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__227aa05fe084e7b541a4d084805fa288d351bbc24f54f33e117c3e869c65df18)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__67fadf23d74702d06626803108e0e08db9ceeb37a04c2582c0fb87ecda9cd463)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__96939b6f55917f35f61bcd006f6834736b5e8bc69d13195fc97528289bea8285)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a3de79cfde4f1840a8415b971a8f9d5dcb6f2b652f76178b79805d8b9c3f9f03)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultScale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultScale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultScale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1db75b4986224c6d0f1b46212cb50f824fe4834f037d0bab373dbd81d7b9e682)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultShear",
    jsii_struct_bases=[],
    name_mapping={
        "x_shear": "xShear",
        "x_shear_var": "xShearVar",
        "y_shear": "yShear",
        "y_shear_var": "yShearVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultShear:
    def __init__(
        self,
        *,
        x_shear: typing.Optional[builtins.str] = None,
        x_shear_var: typing.Optional[builtins.str] = None,
        y_shear: typing.Optional[builtins.str] = None,
        y_shear_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param x_shear: The amount to shear along the x-axis, measured in multiples of the image's width. Must be set if yShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear DataAkamaiImagingPolicyImage#x_shear}
        :param x_shear_var: The amount to shear along the x-axis, measured in multiples of the image's width. Must be set if yShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear_var DataAkamaiImagingPolicyImage#x_shear_var}
        :param y_shear: The amount to shear along the y-axis, measured in multiples of the image's height. Must be set if xShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear DataAkamaiImagingPolicyImage#y_shear}
        :param y_shear_var: The amount to shear along the y-axis, measured in multiples of the image's height. Must be set if xShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear_var DataAkamaiImagingPolicyImage#y_shear_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dc6df20e171924480096a5a0c8a2cc41b1756bf1d418ed0f5d84c26bfe8b927b)
            check_type(argname="argument x_shear", value=x_shear, expected_type=type_hints["x_shear"])
            check_type(argname="argument x_shear_var", value=x_shear_var, expected_type=type_hints["x_shear_var"])
            check_type(argname="argument y_shear", value=y_shear, expected_type=type_hints["y_shear"])
            check_type(argname="argument y_shear_var", value=y_shear_var, expected_type=type_hints["y_shear_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if x_shear is not None:
            self._values["x_shear"] = x_shear
        if x_shear_var is not None:
            self._values["x_shear_var"] = x_shear_var
        if y_shear is not None:
            self._values["y_shear"] = y_shear
        if y_shear_var is not None:
            self._values["y_shear_var"] = y_shear_var

    @builtins.property
    def x_shear(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the x-axis, measured in multiples of the image's width.

        Must be set if yShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear DataAkamaiImagingPolicyImage#x_shear}
        '''
        result = self._values.get("x_shear")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_shear_var(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the x-axis, measured in multiples of the image's width.

        Must be set if yShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear_var DataAkamaiImagingPolicyImage#x_shear_var}
        '''
        result = self._values.get("x_shear_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_shear(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the y-axis, measured in multiples of the image's height.

        Must be set if xShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear DataAkamaiImagingPolicyImage#y_shear}
        '''
        result = self._values.get("y_shear")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_shear_var(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the y-axis, measured in multiples of the image's height.

        Must be set if xShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear_var DataAkamaiImagingPolicyImage#y_shear_var}
        '''
        result = self._values.get("y_shear_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultShear(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultShearList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultShearList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f0846f504e3e69393064dc7ea064f087f6ab76d00027534bbff3177a93870355)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultShearOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__82519363c9024c5c52c56b646d57465f493258c2d12e632c1937ad41fc8108c1)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultShearOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4754b65b0c9b8eb84407cc39455f1ad383c58e08c4a00fe00d707c50bfc078e5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7b9d28fe9771bfeb0c72f2df1cbc8bf2a96a3c82f9fee83f4d0a95c0f5a15410)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__35a6273c743c8fcefe2d4bf4dab072471cb97ba26b46d6e64f2f648877094113)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultShear]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultShear]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultShear]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__91dc4f27553c468fa7b6c3a9188e4e9eee5a8d10e1afccb85257610a4bd8bf3e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultShearOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultShearOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f016e60a9f20f6ac414b093725f0d5349bd58ec5a6c82b415fa9ee10f01ada08)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetXShear")
    def reset_x_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXShear", []))

    @jsii.member(jsii_name="resetXShearVar")
    def reset_x_shear_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXShearVar", []))

    @jsii.member(jsii_name="resetYShear")
    def reset_y_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYShear", []))

    @jsii.member(jsii_name="resetYShearVar")
    def reset_y_shear_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYShearVar", []))

    @builtins.property
    @jsii.member(jsii_name="xShearInput")
    def x_shear_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xShearInput"))

    @builtins.property
    @jsii.member(jsii_name="xShearVarInput")
    def x_shear_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xShearVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yShearInput")
    def y_shear_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yShearInput"))

    @builtins.property
    @jsii.member(jsii_name="yShearVarInput")
    def y_shear_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yShearVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xShear")
    def x_shear(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xShear"))

    @x_shear.setter
    def x_shear(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__12b8d5a46a1b89e653984abd1b2a59b74da3d574769710c99013da70eba36eee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xShear", value)

    @builtins.property
    @jsii.member(jsii_name="xShearVar")
    def x_shear_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xShearVar"))

    @x_shear_var.setter
    def x_shear_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd68156e53c2a3d50007070afdc4519cdf2d0f765eff22ef257ab7d86f0ab6df)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xShearVar", value)

    @builtins.property
    @jsii.member(jsii_name="yShear")
    def y_shear(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yShear"))

    @y_shear.setter
    def y_shear(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__159215add0aa00152efb4ff1fcad573f27bc5eabcc7eec7a0601792319de8e92)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yShear", value)

    @builtins.property
    @jsii.member(jsii_name="yShearVar")
    def y_shear_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yShearVar"))

    @y_shear_var.setter
    def y_shear_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b1426852d004842ad8327533247401e8bcd4befec3495d2eebfc48e4c6033c80)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yShearVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultShear]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultShear]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultShear]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6ac3bc7244c61f0beb5264741983f3a6d471ed485b13c23c44e1f5ef5f570995)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultTrim",
    jsii_struct_bases=[],
    name_mapping={
        "fuzz": "fuzz",
        "fuzz_var": "fuzzVar",
        "padding": "padding",
        "padding_var": "paddingVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultTrim:
    def __init__(
        self,
        *,
        fuzz: typing.Optional[builtins.str] = None,
        fuzz_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fuzz: The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz DataAkamaiImagingPolicyImage#fuzz}
        :param fuzz_var: The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz_var DataAkamaiImagingPolicyImage#fuzz_var}
        :param padding: The amount of padding in pixels to add to the trimmed image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: The amount of padding in pixels to add to the trimmed image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__35749cac25a9bb3e3233bb3d21dc400319c83aa9e8a29e22472abcb14643c638)
            check_type(argname="argument fuzz", value=fuzz, expected_type=type_hints["fuzz"])
            check_type(argname="argument fuzz_var", value=fuzz_var, expected_type=type_hints["fuzz_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fuzz is not None:
            self._values["fuzz"] = fuzz
        if fuzz_var is not None:
            self._values["fuzz_var"] = fuzz_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var

    @builtins.property
    def fuzz(self) -> typing.Optional[builtins.str]:
        '''The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz DataAkamaiImagingPolicyImage#fuzz}
        '''
        result = self._values.get("fuzz")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fuzz_var(self) -> typing.Optional[builtins.str]:
        '''The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz_var DataAkamaiImagingPolicyImage#fuzz_var}
        '''
        result = self._values.get("fuzz_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''The amount of padding in pixels to add to the trimmed image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''The amount of padding in pixels to add to the trimmed image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultTrim(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultTrimList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultTrimList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__297f4c07c2f076c5d9877e34ac71d5eb31059bb8ffe3454cfcff151f8fb7cdac)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultTrimOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d56fa134a5b3d3c00998be94ad8535af7c60273346fa35f2e9179a5e8acc17b6)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultTrimOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1351222772f225e55fa51294b934a5a65c617ba6f00cd92d9f926e0793c2fee0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a311aa9c81c69bd50e99aca76f126a2a8a44fe4d63ee4fd27f8cbd2ff4855067)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2b47cebbe6569a0aa06c14ef87a34e41b6d19a0b5163200a7f072bddd893f4ae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultTrim]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultTrim]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultTrim]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac6aa23371b40ee058c8302500afcf86912049591bc60015f2209729d4e01284)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultTrimOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultTrimOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e540719a90df810bf053f2a3e48818a030102f41d9ae7f6efe99880e7631539e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetFuzz")
    def reset_fuzz(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFuzz", []))

    @jsii.member(jsii_name="resetFuzzVar")
    def reset_fuzz_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFuzzVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @builtins.property
    @jsii.member(jsii_name="fuzzInput")
    def fuzz_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fuzzInput"))

    @builtins.property
    @jsii.member(jsii_name="fuzzVarInput")
    def fuzz_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fuzzVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="fuzz")
    def fuzz(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fuzz"))

    @fuzz.setter
    def fuzz(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6df35c31ae87c2212ea4789e9ea0d839f30665fdae90545273ae871fadf2688f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fuzz", value)

    @builtins.property
    @jsii.member(jsii_name="fuzzVar")
    def fuzz_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fuzzVar"))

    @fuzz_var.setter
    def fuzz_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8d4d36f99219470f4d80fb6f8d40251f3a211ef75a26ade4c7570d3f1a5834c9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fuzzVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__229147dbf4715f97cde3dcf0a0f4363549d1cfd9384c6c27a8b902a832cc982b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__34b6cab3ef0d6f6f8a460a7573506c092c73858699877d7b2cc227d8b1ddfcdc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultTrim]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultTrim]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultTrim]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4fc9a22b9993c7f048f6c6439e55f4e4b21f175a84a07d7b1c6bce0a06b87947)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultUnsharpMask",
    jsii_struct_bases=[],
    name_mapping={
        "gain": "gain",
        "gain_var": "gainVar",
        "sigma": "sigma",
        "sigma_var": "sigmaVar",
        "threshold": "threshold",
        "threshold_var": "thresholdVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultUnsharpMask:
    def __init__(
        self,
        *,
        gain: typing.Optional[builtins.str] = None,
        gain_var: typing.Optional[builtins.str] = None,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
        threshold: typing.Optional[builtins.str] = None,
        threshold_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param gain: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        :param gain_var: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        :param sigma: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        :param threshold: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        :param threshold_var: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__33e8a48f139c2265e5557de2464929c8aa20671378981cf0e8e84ad74c9a5722)
            check_type(argname="argument gain", value=gain, expected_type=type_hints["gain"])
            check_type(argname="argument gain_var", value=gain_var, expected_type=type_hints["gain_var"])
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
            check_type(argname="argument threshold", value=threshold, expected_type=type_hints["threshold"])
            check_type(argname="argument threshold_var", value=threshold_var, expected_type=type_hints["threshold_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if gain is not None:
            self._values["gain"] = gain
        if gain_var is not None:
            self._values["gain_var"] = gain_var
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var
        if threshold is not None:
            self._values["threshold"] = threshold
        if threshold_var is not None:
            self._values["threshold_var"] = threshold_var

    @builtins.property
    def gain(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        '''
        result = self._values.get("gain")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gain_var(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        '''
        result = self._values.get("gain_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        '''
        result = self._values.get("threshold")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold_var(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        result = self._values.get("threshold_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultUnsharpMask(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultUnsharpMaskList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultUnsharpMaskList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2771e505ad05aa9d61cdbe077085f84cdd7a5c6c223db9911e0546c16915519b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultUnsharpMaskOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9f7226f7fcf9de6a829d8e498916dc4b6e06f05fb4cd9b6a1d8036af23c59864)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultUnsharpMaskOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__beb41cda6d99645dc856d87b592db12d9a6c210ee7f69251ad58357cbabc7d5d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0e0619ed06d54aa9e8426f296b31d04bacc34f9fda5d7705a7516c3ebca7b2a8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a9dde09fb2197153ebb46f876d2b083edda822d1046819bdd089e46fe8392d8d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultUnsharpMask]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultUnsharpMask]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultUnsharpMask]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8656586f073d065b1d3c44c4e00c38c26dd2eaa224f43fcde209f80e47b6a8ea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultUnsharpMaskOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultUnsharpMaskOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eed439133edcb413f9471e0086f5037fbf2bc3911bfbbc69ec62adbfc532bc6f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetGain")
    def reset_gain(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGain", []))

    @jsii.member(jsii_name="resetGainVar")
    def reset_gain_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGainVar", []))

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @jsii.member(jsii_name="resetThreshold")
    def reset_threshold(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThreshold", []))

    @jsii.member(jsii_name="resetThresholdVar")
    def reset_threshold_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThresholdVar", []))

    @builtins.property
    @jsii.member(jsii_name="gainInput")
    def gain_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainInput"))

    @builtins.property
    @jsii.member(jsii_name="gainVarInput")
    def gain_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdInput")
    def threshold_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdVarInput")
    def threshold_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gain")
    def gain(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gain"))

    @gain.setter
    def gain(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e16c6c62491db9ab6b459f961af559ae1a5e28349fffbe1d7ae01068d34f2bb8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gain", value)

    @builtins.property
    @jsii.member(jsii_name="gainVar")
    def gain_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gainVar"))

    @gain_var.setter
    def gain_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c744c8ad08b0aad77577f1e3ed7161bca57b62802d173842ae5a58a46359af76)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gainVar", value)

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f40b24beeef5c5c56d5ddfef2539d2ce1efa58bb4069aef8a819ffb296537df4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc5ed41839aa1c27c9f10cfdd48ab974e9f17ea8ace4a4631017af3aabad40bf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="threshold")
    def threshold(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "threshold"))

    @threshold.setter
    def threshold(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e87b8c7317480e08d860e3e8852ffdd42b4f50ce731737c81c07051b6aea21de)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "threshold", value)

    @builtins.property
    @jsii.member(jsii_name="thresholdVar")
    def threshold_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "thresholdVar"))

    @threshold_var.setter
    def threshold_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__17fdfe4b319824204c3768a838eba70f19b9b6a79e588727411b5c5de1e70148)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "thresholdVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultUnsharpMask]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultUnsharpMask]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultUnsharpMask]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6fd1960a2148b81b0327bfb27fd81b645500e54b2cff3e967b4258f5152f0453)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscape",
    jsii_struct_bases=[],
    name_mapping={
        "append": "append",
        "aspect_crop": "aspectCrop",
        "background_color": "backgroundColor",
        "blur": "blur",
        "chroma_key": "chromaKey",
        "composite": "composite",
        "compound": "compound",
        "contrast": "contrast",
        "crop": "crop",
        "face_crop": "faceCrop",
        "feature_crop": "featureCrop",
        "fit_and_fill": "fitAndFill",
        "goop": "goop",
        "grayscale": "grayscale",
        "hsl": "hsl",
        "hsv": "hsv",
        "if_dimension": "ifDimension",
        "if_orientation": "ifOrientation",
        "im_query": "imQuery",
        "max_colors": "maxColors",
        "mirror": "mirror",
        "mono_hue": "monoHue",
        "opacity": "opacity",
        "region_of_interest_crop": "regionOfInterestCrop",
        "relative_crop": "relativeCrop",
        "remove_color": "removeColor",
        "resize": "resize",
        "rotate": "rotate",
        "scale": "scale",
        "shear": "shear",
        "trim": "trim",
        "unsharp_mask": "unsharpMask",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscape:
    def __init__(
        self,
        *,
        append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeAppend", typing.Dict[builtins.str, typing.Any]]]]] = None,
        aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeAspectCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeBackgroundColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeBlur", typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeChromaKey", typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeComposite", typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCompound", typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeContrast", typing.Dict[builtins.str, typing.Any]]]]] = None,
        crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeFaceCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeFeatureCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeFitAndFill", typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeGoop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeGrayscale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeHsl", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeHsv", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimension", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientation", typing.Dict[builtins.str, typing.Any]]]]] = None,
        im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeImQuery", typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeMaxColors", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeMirror", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeMonoHue", typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeOpacity", typing.Dict[builtins.str, typing.Any]]]]] = None,
        region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRegionOfInterestCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRelativeCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRemoveColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeResize", typing.Dict[builtins.str, typing.Any]]]]] = None,
        rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRotate", typing.Dict[builtins.str, typing.Any]]]]] = None,
        scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeScale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeShear", typing.Dict[builtins.str, typing.Any]]]]] = None,
        trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeTrim", typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeUnsharpMask", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param append: append block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        :param aspect_crop: aspect_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param crop: crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        :param face_crop: face_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        :param feature_crop: feature_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        :param fit_and_fill: fit_and_fill block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param im_query: im_query block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param region_of_interest_crop: region_of_interest_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        :param relative_crop: relative_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param resize: resize block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        :param rotate: rotate block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        :param scale: scale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param shear: shear block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        :param trim: trim block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e5d482a9e527f319c7d7f2635f67182908f70417b03a7272e8d8e1d6319073f8)
            check_type(argname="argument append", value=append, expected_type=type_hints["append"])
            check_type(argname="argument aspect_crop", value=aspect_crop, expected_type=type_hints["aspect_crop"])
            check_type(argname="argument background_color", value=background_color, expected_type=type_hints["background_color"])
            check_type(argname="argument blur", value=blur, expected_type=type_hints["blur"])
            check_type(argname="argument chroma_key", value=chroma_key, expected_type=type_hints["chroma_key"])
            check_type(argname="argument composite", value=composite, expected_type=type_hints["composite"])
            check_type(argname="argument compound", value=compound, expected_type=type_hints["compound"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument crop", value=crop, expected_type=type_hints["crop"])
            check_type(argname="argument face_crop", value=face_crop, expected_type=type_hints["face_crop"])
            check_type(argname="argument feature_crop", value=feature_crop, expected_type=type_hints["feature_crop"])
            check_type(argname="argument fit_and_fill", value=fit_and_fill, expected_type=type_hints["fit_and_fill"])
            check_type(argname="argument goop", value=goop, expected_type=type_hints["goop"])
            check_type(argname="argument grayscale", value=grayscale, expected_type=type_hints["grayscale"])
            check_type(argname="argument hsl", value=hsl, expected_type=type_hints["hsl"])
            check_type(argname="argument hsv", value=hsv, expected_type=type_hints["hsv"])
            check_type(argname="argument if_dimension", value=if_dimension, expected_type=type_hints["if_dimension"])
            check_type(argname="argument if_orientation", value=if_orientation, expected_type=type_hints["if_orientation"])
            check_type(argname="argument im_query", value=im_query, expected_type=type_hints["im_query"])
            check_type(argname="argument max_colors", value=max_colors, expected_type=type_hints["max_colors"])
            check_type(argname="argument mirror", value=mirror, expected_type=type_hints["mirror"])
            check_type(argname="argument mono_hue", value=mono_hue, expected_type=type_hints["mono_hue"])
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument region_of_interest_crop", value=region_of_interest_crop, expected_type=type_hints["region_of_interest_crop"])
            check_type(argname="argument relative_crop", value=relative_crop, expected_type=type_hints["relative_crop"])
            check_type(argname="argument remove_color", value=remove_color, expected_type=type_hints["remove_color"])
            check_type(argname="argument resize", value=resize, expected_type=type_hints["resize"])
            check_type(argname="argument rotate", value=rotate, expected_type=type_hints["rotate"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument shear", value=shear, expected_type=type_hints["shear"])
            check_type(argname="argument trim", value=trim, expected_type=type_hints["trim"])
            check_type(argname="argument unsharp_mask", value=unsharp_mask, expected_type=type_hints["unsharp_mask"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if append is not None:
            self._values["append"] = append
        if aspect_crop is not None:
            self._values["aspect_crop"] = aspect_crop
        if background_color is not None:
            self._values["background_color"] = background_color
        if blur is not None:
            self._values["blur"] = blur
        if chroma_key is not None:
            self._values["chroma_key"] = chroma_key
        if composite is not None:
            self._values["composite"] = composite
        if compound is not None:
            self._values["compound"] = compound
        if contrast is not None:
            self._values["contrast"] = contrast
        if crop is not None:
            self._values["crop"] = crop
        if face_crop is not None:
            self._values["face_crop"] = face_crop
        if feature_crop is not None:
            self._values["feature_crop"] = feature_crop
        if fit_and_fill is not None:
            self._values["fit_and_fill"] = fit_and_fill
        if goop is not None:
            self._values["goop"] = goop
        if grayscale is not None:
            self._values["grayscale"] = grayscale
        if hsl is not None:
            self._values["hsl"] = hsl
        if hsv is not None:
            self._values["hsv"] = hsv
        if if_dimension is not None:
            self._values["if_dimension"] = if_dimension
        if if_orientation is not None:
            self._values["if_orientation"] = if_orientation
        if im_query is not None:
            self._values["im_query"] = im_query
        if max_colors is not None:
            self._values["max_colors"] = max_colors
        if mirror is not None:
            self._values["mirror"] = mirror
        if mono_hue is not None:
            self._values["mono_hue"] = mono_hue
        if opacity is not None:
            self._values["opacity"] = opacity
        if region_of_interest_crop is not None:
            self._values["region_of_interest_crop"] = region_of_interest_crop
        if relative_crop is not None:
            self._values["relative_crop"] = relative_crop
        if remove_color is not None:
            self._values["remove_color"] = remove_color
        if resize is not None:
            self._values["resize"] = resize
        if rotate is not None:
            self._values["rotate"] = rotate
        if scale is not None:
            self._values["scale"] = scale
        if shear is not None:
            self._values["shear"] = shear
        if trim is not None:
            self._values["trim"] = trim
        if unsharp_mask is not None:
            self._values["unsharp_mask"] = unsharp_mask

    @builtins.property
    def append(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeAppend"]]]:
        '''append block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        '''
        result = self._values.get("append")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeAppend"]]], result)

    @builtins.property
    def aspect_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeAspectCrop"]]]:
        '''aspect_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        '''
        result = self._values.get("aspect_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeAspectCrop"]]], result)

    @builtins.property
    def background_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeBackgroundColor"]]]:
        '''background_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        '''
        result = self._values.get("background_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeBackgroundColor"]]], result)

    @builtins.property
    def blur(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeBlur"]]]:
        '''blur block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        '''
        result = self._values.get("blur")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeBlur"]]], result)

    @builtins.property
    def chroma_key(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeChromaKey"]]]:
        '''chroma_key block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        '''
        result = self._values.get("chroma_key")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeChromaKey"]]], result)

    @builtins.property
    def composite(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeComposite"]]]:
        '''composite block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        '''
        result = self._values.get("composite")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeComposite"]]], result)

    @builtins.property
    def compound(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCompound"]]]:
        '''compound block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        '''
        result = self._values.get("compound")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCompound"]]], result)

    @builtins.property
    def contrast(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeContrast"]]]:
        '''contrast block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeContrast"]]], result)

    @builtins.property
    def crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCrop"]]]:
        '''crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        '''
        result = self._values.get("crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCrop"]]], result)

    @builtins.property
    def face_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeFaceCrop"]]]:
        '''face_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        '''
        result = self._values.get("face_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeFaceCrop"]]], result)

    @builtins.property
    def feature_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeFeatureCrop"]]]:
        '''feature_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        '''
        result = self._values.get("feature_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeFeatureCrop"]]], result)

    @builtins.property
    def fit_and_fill(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeFitAndFill"]]]:
        '''fit_and_fill block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        '''
        result = self._values.get("fit_and_fill")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeFitAndFill"]]], result)

    @builtins.property
    def goop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeGoop"]]]:
        '''goop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        '''
        result = self._values.get("goop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeGoop"]]], result)

    @builtins.property
    def grayscale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeGrayscale"]]]:
        '''grayscale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        '''
        result = self._values.get("grayscale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeGrayscale"]]], result)

    @builtins.property
    def hsl(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeHsl"]]]:
        '''hsl block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        '''
        result = self._values.get("hsl")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeHsl"]]], result)

    @builtins.property
    def hsv(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeHsv"]]]:
        '''hsv block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        '''
        result = self._values.get("hsv")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeHsv"]]], result)

    @builtins.property
    def if_dimension(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimension"]]]:
        '''if_dimension block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        '''
        result = self._values.get("if_dimension")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimension"]]], result)

    @builtins.property
    def if_orientation(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientation"]]]:
        '''if_orientation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        '''
        result = self._values.get("if_orientation")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientation"]]], result)

    @builtins.property
    def im_query(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeImQuery"]]]:
        '''im_query block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        '''
        result = self._values.get("im_query")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeImQuery"]]], result)

    @builtins.property
    def max_colors(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeMaxColors"]]]:
        '''max_colors block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        '''
        result = self._values.get("max_colors")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeMaxColors"]]], result)

    @builtins.property
    def mirror(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeMirror"]]]:
        '''mirror block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        '''
        result = self._values.get("mirror")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeMirror"]]], result)

    @builtins.property
    def mono_hue(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeMonoHue"]]]:
        '''mono_hue block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        '''
        result = self._values.get("mono_hue")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeMonoHue"]]], result)

    @builtins.property
    def opacity(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeOpacity"]]]:
        '''opacity block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeOpacity"]]], result)

    @builtins.property
    def region_of_interest_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRegionOfInterestCrop"]]]:
        '''region_of_interest_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        '''
        result = self._values.get("region_of_interest_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRegionOfInterestCrop"]]], result)

    @builtins.property
    def relative_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRelativeCrop"]]]:
        '''relative_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        '''
        result = self._values.get("relative_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRelativeCrop"]]], result)

    @builtins.property
    def remove_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRemoveColor"]]]:
        '''remove_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        '''
        result = self._values.get("remove_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRemoveColor"]]], result)

    @builtins.property
    def resize(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeResize"]]]:
        '''resize block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        '''
        result = self._values.get("resize")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeResize"]]], result)

    @builtins.property
    def rotate(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRotate"]]]:
        '''rotate block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        '''
        result = self._values.get("rotate")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRotate"]]], result)

    @builtins.property
    def scale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeScale"]]]:
        '''scale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeScale"]]], result)

    @builtins.property
    def shear(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeShear"]]]:
        '''shear block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        '''
        result = self._values.get("shear")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeShear"]]], result)

    @builtins.property
    def trim(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeTrim"]]]:
        '''trim block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        '''
        result = self._values.get("trim")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeTrim"]]], result)

    @builtins.property
    def unsharp_mask(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeUnsharpMask"]]]:
        '''unsharp_mask block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        result = self._values.get("unsharp_mask")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeUnsharpMask"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscape(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeAppend",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_priority": "gravityPriority",
        "gravity_priority_var": "gravityPriorityVar",
        "gravity_var": "gravityVar",
        "preserve_minor_dimension": "preserveMinorDimension",
        "preserve_minor_dimension_var": "preserveMinorDimensionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeAppend:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeAppendImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_priority: typing.Optional[builtins.str] = None,
        gravity_priority_var: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        preserve_minor_dimension: typing.Optional[builtins.str] = None,
        preserve_minor_dimension_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Specifies where to place the ``image`` relative to the source image. The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_priority: Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal. The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority DataAkamaiImagingPolicyImage#gravity_priority}
        :param gravity_priority_var: Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal. The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority_var DataAkamaiImagingPolicyImage#gravity_priority_var}
        :param gravity_var: Specifies where to place the ``image`` relative to the source image. The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param preserve_minor_dimension: Whether to preserve the source image's minor dimension, ``false`` by default. The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension DataAkamaiImagingPolicyImage#preserve_minor_dimension}
        :param preserve_minor_dimension_var: Whether to preserve the source image's minor dimension, ``false`` by default. The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension_var DataAkamaiImagingPolicyImage#preserve_minor_dimension_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeAppendImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ff01becfe372e9ad39682c01c9d154788adc9e6adb53eec3ef760b67c78d8528)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_priority", value=gravity_priority, expected_type=type_hints["gravity_priority"])
            check_type(argname="argument gravity_priority_var", value=gravity_priority_var, expected_type=type_hints["gravity_priority_var"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument preserve_minor_dimension", value=preserve_minor_dimension, expected_type=type_hints["preserve_minor_dimension"])
            check_type(argname="argument preserve_minor_dimension_var", value=preserve_minor_dimension_var, expected_type=type_hints["preserve_minor_dimension_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_priority is not None:
            self._values["gravity_priority"] = gravity_priority
        if gravity_priority_var is not None:
            self._values["gravity_priority_var"] = gravity_priority_var
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if preserve_minor_dimension is not None:
            self._values["preserve_minor_dimension"] = preserve_minor_dimension
        if preserve_minor_dimension_var is not None:
            self._values["preserve_minor_dimension_var"] = preserve_minor_dimension_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeAppendImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeAppendImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Specifies where to place the ``image`` relative to the source image.

        The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_priority(self) -> typing.Optional[builtins.str]:
        '''Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal.

        The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority DataAkamaiImagingPolicyImage#gravity_priority}
        '''
        result = self._values.get("gravity_priority")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_priority_var(self) -> typing.Optional[builtins.str]:
        '''Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal.

        The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority_var DataAkamaiImagingPolicyImage#gravity_priority_var}
        '''
        result = self._values.get("gravity_priority_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Specifies where to place the ``image`` relative to the source image.

        The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def preserve_minor_dimension(self) -> typing.Optional[builtins.str]:
        '''Whether to preserve the source image's minor dimension, ``false`` by default.

        The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension DataAkamaiImagingPolicyImage#preserve_minor_dimension}
        '''
        result = self._values.get("preserve_minor_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def preserve_minor_dimension_var(self) -> typing.Optional[builtins.str]:
        '''Whether to preserve the source image's minor dimension, ``false`` by default.

        The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension_var DataAkamaiImagingPolicyImage#preserve_minor_dimension_var}
        '''
        result = self._values.get("preserve_minor_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeAppend(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeAppendImage",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeAppendImage:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeAppendImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeAppendImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeAppendImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be84c2b737d44b8009b48311162253b130545b76afd98c00632e8ce0f707ac8a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeAppendImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeAppendImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeAppendImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__941dba240a9d060d08a2ad1a35fe70b3add407d66c1e2456a05573fe0b2f6035)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeAppendList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeAppendList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3f5ef2bc078f36243d97127e82ff5d6c5f581b96eaeebf858181e2b6a04063d4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeAppendOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__400801af964b4de37701b2c50b97f02d6aee90303627a7a1c0cd870e7ffa3e83)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeAppendOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__06c76672cf727b4105c13842f7cba0072f9ffabd50bfeca37bc6706c6c2f2328)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__78f35fd0b37cf84df11884ac9d21928a797d0e3b22805be6a940f3c1b6db7d43)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2b8c6d416ff66f2b150044114d7c9480ff5efae3e7cbe5f5d0a46761c4adf4f5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeAppend]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeAppend]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeAppend]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9e7c89b1aff0d09ce71216389544580d004b7851b67e88bb7db5843c6bd420db)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeAppendOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeAppendOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__360e4e677270140f6e3791da0b3b92d7148ce787034ddbdb13aa38f44655211e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeAppendImage()

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityPriority")
    def reset_gravity_priority(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityPriority", []))

    @jsii.member(jsii_name="resetGravityPriorityVar")
    def reset_gravity_priority_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityPriorityVar", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPreserveMinorDimension")
    def reset_preserve_minor_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPreserveMinorDimension", []))

    @jsii.member(jsii_name="resetPreserveMinorDimensionVar")
    def reset_preserve_minor_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPreserveMinorDimensionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeAppendImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeAppendImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityInput")
    def gravity_priority_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityPriorityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityVarInput")
    def gravity_priority_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityPriorityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeAppendImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeAppendImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionInput")
    def preserve_minor_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "preserveMinorDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionVarInput")
    def preserve_minor_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "preserveMinorDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ce8dd68cfd3db3b1bdcddb6d7d14b4613d52924389d8ae6cb06173d59de28dc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityPriority")
    def gravity_priority(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityPriority"))

    @gravity_priority.setter
    def gravity_priority(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8d35f74b655d1031ef357d6b1ab80935951bf8f4de5ff3a4c55008b54645f36d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityPriority", value)

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityVar")
    def gravity_priority_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityPriorityVar"))

    @gravity_priority_var.setter
    def gravity_priority_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__98dd98f6ca5b9241357c65bf1f0271e6536a9a7c9308b3e3ca3a6b5cda819bf7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityPriorityVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__625eea764617209a3551769b1c27a31cc99ddb0b8cdb5e277b1f28c24cce1f47)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimension")
    def preserve_minor_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "preserveMinorDimension"))

    @preserve_minor_dimension.setter
    def preserve_minor_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d44c024ff9119cba7b593f32e911b316a7bca2ccd459a8b8b837071887acf538)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "preserveMinorDimension", value)

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionVar")
    def preserve_minor_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "preserveMinorDimensionVar"))

    @preserve_minor_dimension_var.setter
    def preserve_minor_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a98e4f80b390eebcfbd61738f50686ae7eb008eb670f542c0cbae8434ec48a52)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "preserveMinorDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeAppend]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeAppend]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeAppend]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__981540215bc44095afe2cab38a4dacb3be6726e27e33c318ef23042b6931f66d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeAspectCrop",
    jsii_struct_bases=[],
    name_mapping={
        "allow_expansion": "allowExpansion",
        "allow_expansion_var": "allowExpansionVar",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeAspectCrop:
    def __init__(
        self,
        *,
        allow_expansion: typing.Optional[builtins.str] = None,
        allow_expansion_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_expansion: Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image. Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        :param allow_expansion_var: Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image. Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        :param height: The height term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The width term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        :param x_position: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3e996735a809f0604401634b31a3f08885b7b0e3fc86a495cbd6ae3e39c8823a)
            check_type(argname="argument allow_expansion", value=allow_expansion, expected_type=type_hints["allow_expansion"])
            check_type(argname="argument allow_expansion_var", value=allow_expansion_var, expected_type=type_hints["allow_expansion_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if allow_expansion is not None:
            self._values["allow_expansion"] = allow_expansion
        if allow_expansion_var is not None:
            self._values["allow_expansion_var"] = allow_expansion_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def allow_expansion(self) -> typing.Optional[builtins.str]:
        '''Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image.

        Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        '''
        result = self._values.get("allow_expansion")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def allow_expansion_var(self) -> typing.Optional[builtins.str]:
        '''Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image.

        Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        '''
        result = self._values.get("allow_expansion_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeAspectCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeAspectCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeAspectCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f96b41e771094fc386f3371abd3d2a45f4d8dfa3ab83a7ab30a6e8c7633afab7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeAspectCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aa9d5d910f3191665d519854f13f2585a0a1891a61544f029a96b2d022c4e069)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeAspectCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ef90ecaccfe09a818f37f0b1bcb08caafcb4ffe0f9208bb3fed4c053a26e090d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c62acca526ee45726b85f4b75ce638defcf3a92772806a4ad92e8a64f408f53e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a1e67af641049041129864b6eb4a01ff02f3bc341dd43988fb96ab019d3334f7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeAspectCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeAspectCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeAspectCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__07db199e297a175283bcf57aad8178558cb802fff2833ef9fa26a35ad2551bcd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeAspectCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeAspectCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac05f33440fda83df7052dde3842e6fe02a2b9420b80c7d3ec68dca04c6f91f1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAllowExpansion")
    def reset_allow_expansion(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansion", []))

    @jsii.member(jsii_name="resetAllowExpansionVar")
    def reset_allow_expansion_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansionVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionInput")
    def allow_expansion_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVarInput")
    def allow_expansion_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansion")
    def allow_expansion(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansion"))

    @allow_expansion.setter
    def allow_expansion(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd0a605505b7441b657cae3de64902d22994e9dfddac44815846e4f5d15eecdc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansion", value)

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVar")
    def allow_expansion_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansionVar"))

    @allow_expansion_var.setter
    def allow_expansion_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bf52bc4fb5deedff1bd199e490a1e2a768af046ebb24771475173e972849498b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansionVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f20e8c9015eabf8b8261f53df05ac661d8e324e248e50254eef4b74909479f2e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__580d337ecc3cfb93abc95ac176de987b9e1363ed419f251df03c437129cb3ea3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f90875a1931484cacd7d176fd36b439a4f3a7ae69ddee34717794a9a8974ad55)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__893dfd93d47c0197ec644b3bf8da85b5c242b54016235061a037317d98446efd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e0edebc6dc839c5e72dda03258ccee24c8f20f667ce92d756756f35772d81a33)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__213def0034af30c184d2e9d2c6e46d7066decfba8b56ac4746116e755b308c26)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__436ca8d1c8a85ae2a7dfe7b2c5c68ae5e28a717026a9e9026d58e4a229180f64)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__051ab1bed0ed1153f09fc09f31079f759512bd0a616c69de7fc292ef319ffe8c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeAspectCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeAspectCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeAspectCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a01d53c778c0ab899e8367a33458a01712538d4d248e7e48fb2cac2d20f9f1fe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeBackgroundColor",
    jsii_struct_bases=[],
    name_mapping={"color": "color", "color_var": "colorVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeBackgroundColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f0a60c161a5dcbb42b824004ab1d183262f999298c224b173cf2edbd03fc45e2)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeBackgroundColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeBackgroundColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeBackgroundColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b98b85a880d767892338f17cd4d9472409a3c61b630566fe86d6597ccd280c88)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeBackgroundColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a874d2564551ddd41b85ade2b2a8df7a98ad5ef5505e722785d049230be5830b)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeBackgroundColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f73cdffdcbadcd131f0bd510fdf60f9ee3b40fa87c1da8b1434c5fa63e5cf112)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__807db3ce998cc0b7e47bbfefcc445e9f86f3ad0b314963ac476e694a1a9dfde6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__77fa6588ea27f4427f59e554555c896005335bfbacb2d021369ec2bad775d946)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeBackgroundColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeBackgroundColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__064b859d7dce48ccbd7ee404b687aaf42dedd702f838e2c6c5c6106694712656)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeBackgroundColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeBackgroundColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4def8898ac2ad99dbcb623541dc7ec27c1c3685116c270397c14c2cb37521326)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__156c67ea9b3a156780babc9e6b2f68650f0ae01de7d16c8e72ad91e3e0738af7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0e103ca59cadee38a893af1410f5366bf28c9940ba75cd2f9b7642045ab99932)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeBackgroundColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeBackgroundColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeBackgroundColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__33ef9c3a5cfbe7873576ed89ef40b3cc7f2c83442810d6477d721def5c3a916d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeBlur",
    jsii_struct_bases=[],
    name_mapping={"sigma": "sigma", "sigma_var": "sigmaVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeBlur:
    def __init__(
        self,
        *,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param sigma: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a7c9ff42cccdf0c15fb78b65859dddb4b18adde21fd0e81bd7ae462bff9220f8)
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeBlur(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeBlurList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeBlurList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d8e3be37ee89b7b5622e064fc1309faae6fbe9e6ef53bca0b844f320f394fc14)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeBlurOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__562af4a2201945c46a5ddf4a499499689d519cf289d88e0b56a859cae877ca20)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeBlurOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3de8f36f9ade97bba64bc9ff3e58aec24080f1d884e257660f79cc761019f21a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b25e82c9c306fadc63209dc267eb14e749e05ac4e09f84605d9d8bf54efd72df)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6d972e0a1a138e864844491d1ab6dab040cce49bfce6f49dab090746dc5fa831)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeBlur]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeBlur]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af7dab2c19cf530a0f7a58d645dc4e54c4104d94c159f0a64ff299596f9abec4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeBlurOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeBlurOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3f330a96ca3796fcf0fd8c13247478b7006c7ab8e036f7df8a9e9e8f9528d499)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__94601bfa00737f11a615265d9ad3409cb9877c8d4db11d08ba182c9b3bb02aa2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dadd628316a34539d5b0577a43096b42f97eca9cb8d3537d747c50211aa438de)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeBlur]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeBlur]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeBlur]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c13e5abf545fa374cc4226ebc7fb0ccb955934ceef73fad3e5ef6cf0955509a9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeChromaKey",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_feather": "hueFeather",
        "hue_feather_var": "hueFeatherVar",
        "hue_tolerance": "hueTolerance",
        "hue_tolerance_var": "hueToleranceVar",
        "hue_var": "hueVar",
        "lightness_feather": "lightnessFeather",
        "lightness_feather_var": "lightnessFeatherVar",
        "lightness_tolerance": "lightnessTolerance",
        "lightness_tolerance_var": "lightnessToleranceVar",
        "saturation_feather": "saturationFeather",
        "saturation_feather_var": "saturationFeatherVar",
        "saturation_tolerance": "saturationTolerance",
        "saturation_tolerance_var": "saturationToleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeChromaKey:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_feather: typing.Optional[builtins.str] = None,
        hue_feather_var: typing.Optional[builtins.str] = None,
        hue_tolerance: typing.Optional[builtins.str] = None,
        hue_tolerance_var: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness_feather: typing.Optional[builtins.str] = None,
        lightness_feather_var: typing.Optional[builtins.str] = None,
        lightness_tolerance: typing.Optional[builtins.str] = None,
        lightness_tolerance_var: typing.Optional[builtins.str] = None,
        saturation_feather: typing.Optional[builtins.str] = None,
        saturation_feather_var: typing.Optional[builtins.str] = None,
        saturation_tolerance: typing.Optional[builtins.str] = None,
        saturation_tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_feather: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        :param hue_feather_var: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        :param hue_tolerance: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        :param hue_tolerance_var: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        :param hue_var: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness_feather: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        :param lightness_feather_var: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        :param lightness_tolerance: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        :param lightness_tolerance_var: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        :param saturation_feather: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        :param saturation_feather_var: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        :param saturation_tolerance: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        :param saturation_tolerance_var: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7060d3fbf3adced13609e3fb0d6477794c9636572455cbcaca2705dd4df8cc0f)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_feather", value=hue_feather, expected_type=type_hints["hue_feather"])
            check_type(argname="argument hue_feather_var", value=hue_feather_var, expected_type=type_hints["hue_feather_var"])
            check_type(argname="argument hue_tolerance", value=hue_tolerance, expected_type=type_hints["hue_tolerance"])
            check_type(argname="argument hue_tolerance_var", value=hue_tolerance_var, expected_type=type_hints["hue_tolerance_var"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness_feather", value=lightness_feather, expected_type=type_hints["lightness_feather"])
            check_type(argname="argument lightness_feather_var", value=lightness_feather_var, expected_type=type_hints["lightness_feather_var"])
            check_type(argname="argument lightness_tolerance", value=lightness_tolerance, expected_type=type_hints["lightness_tolerance"])
            check_type(argname="argument lightness_tolerance_var", value=lightness_tolerance_var, expected_type=type_hints["lightness_tolerance_var"])
            check_type(argname="argument saturation_feather", value=saturation_feather, expected_type=type_hints["saturation_feather"])
            check_type(argname="argument saturation_feather_var", value=saturation_feather_var, expected_type=type_hints["saturation_feather_var"])
            check_type(argname="argument saturation_tolerance", value=saturation_tolerance, expected_type=type_hints["saturation_tolerance"])
            check_type(argname="argument saturation_tolerance_var", value=saturation_tolerance_var, expected_type=type_hints["saturation_tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_feather is not None:
            self._values["hue_feather"] = hue_feather
        if hue_feather_var is not None:
            self._values["hue_feather_var"] = hue_feather_var
        if hue_tolerance is not None:
            self._values["hue_tolerance"] = hue_tolerance
        if hue_tolerance_var is not None:
            self._values["hue_tolerance_var"] = hue_tolerance_var
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness_feather is not None:
            self._values["lightness_feather"] = lightness_feather
        if lightness_feather_var is not None:
            self._values["lightness_feather_var"] = lightness_feather_var
        if lightness_tolerance is not None:
            self._values["lightness_tolerance"] = lightness_tolerance
        if lightness_tolerance_var is not None:
            self._values["lightness_tolerance_var"] = lightness_tolerance_var
        if saturation_feather is not None:
            self._values["saturation_feather"] = saturation_feather
        if saturation_feather_var is not None:
            self._values["saturation_feather_var"] = saturation_feather_var
        if saturation_tolerance is not None:
            self._values["saturation_tolerance"] = saturation_tolerance
        if saturation_tolerance_var is not None:
            self._values["saturation_tolerance_var"] = saturation_tolerance_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        '''
        result = self._values.get("hue_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        '''
        result = self._values.get("hue_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        '''
        result = self._values.get("hue_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        '''
        result = self._values.get("hue_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        '''
        result = self._values.get("lightness_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        '''
        result = self._values.get("lightness_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        '''
        result = self._values.get("lightness_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        '''
        result = self._values.get("lightness_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        '''
        result = self._values.get("saturation_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        '''
        result = self._values.get("saturation_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        '''
        result = self._values.get("saturation_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        result = self._values.get("saturation_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeChromaKey(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeChromaKeyList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeChromaKeyList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__75ef04abc03b3f61204dd75de5504b8e01c607f44c3d070615582051b716179d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeChromaKeyOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__157d4cc837ca57320964b761afcb5a7573b91b5f0774317d359667890f1cfd12)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeChromaKeyOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dd37c381a03ba1c5c6649dff1310c40c431252d394c489acea44d20f718dd618)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ae2364e769fade333b5c3f020a4827108ce1982bc59fd046fe595d37e400e960)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7cfc03d1650142598ce0ceeaa940a21a77f0adb7198264f5d7e7d25a271687c5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeChromaKey]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeChromaKey]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ea3922cd0901c6078e7c250cb599f3f12a973339178ea3a116b684b3a0babc5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeChromaKeyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeChromaKeyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0fd08e800137e5ffb1caa31d25ba9cce13ecf0100e952772e74b94562d80ddf7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueFeather")
    def reset_hue_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeather", []))

    @jsii.member(jsii_name="resetHueFeatherVar")
    def reset_hue_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeatherVar", []))

    @jsii.member(jsii_name="resetHueTolerance")
    def reset_hue_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueTolerance", []))

    @jsii.member(jsii_name="resetHueToleranceVar")
    def reset_hue_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueToleranceVar", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightnessFeather")
    def reset_lightness_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeather", []))

    @jsii.member(jsii_name="resetLightnessFeatherVar")
    def reset_lightness_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeatherVar", []))

    @jsii.member(jsii_name="resetLightnessTolerance")
    def reset_lightness_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessTolerance", []))

    @jsii.member(jsii_name="resetLightnessToleranceVar")
    def reset_lightness_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessToleranceVar", []))

    @jsii.member(jsii_name="resetSaturationFeather")
    def reset_saturation_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeather", []))

    @jsii.member(jsii_name="resetSaturationFeatherVar")
    def reset_saturation_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeatherVar", []))

    @jsii.member(jsii_name="resetSaturationTolerance")
    def reset_saturation_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationTolerance", []))

    @jsii.member(jsii_name="resetSaturationToleranceVar")
    def reset_saturation_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherInput")
    def hue_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVarInput")
    def hue_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceInput")
    def hue_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVarInput")
    def hue_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherInput")
    def lightness_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVarInput")
    def lightness_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceInput")
    def lightness_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVarInput")
    def lightness_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherInput")
    def saturation_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVarInput")
    def saturation_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceInput")
    def saturation_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVarInput")
    def saturation_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3b36f3b6e9a2090b7f00d4fcfedd8a9004b33c14a0aa8d64560108b48ec785e5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeather")
    def hue_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeather"))

    @hue_feather.setter
    def hue_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__17a77b14bb44d7d532cd762f041bf8b99dce462be4680e96c3002f0908a3e1ed)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeather", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVar")
    def hue_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeatherVar"))

    @hue_feather_var.setter
    def hue_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__107389576d16d60dee2083a8e89dd8c0b9cd6a7f69c5c7e855222c79b49bcb7f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueTolerance")
    def hue_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueTolerance"))

    @hue_tolerance.setter
    def hue_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3214755db52ba4155ce98100db8d32817b918396bbeef398d7def6900eb492e3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVar")
    def hue_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueToleranceVar"))

    @hue_tolerance_var.setter
    def hue_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__12da1b311238239b09fc8e01205eacb3fdff8fabdab95d077b821c8ac5655acd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__260943ec119a23a950de8cddb5765c9ed4ad66b7952dad8a5312d1f6cb76d59f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeather")
    def lightness_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeather"))

    @lightness_feather.setter
    def lightness_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b558066b9876c3a9bc61c3af1fd16ce78ad46838fb1ecfb8dbdf0833581a747b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeather", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVar")
    def lightness_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeatherVar"))

    @lightness_feather_var.setter
    def lightness_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0c18b934b40759ae697910f24c82d90787a4656c77e73141dc1a25c917ccf734)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessTolerance")
    def lightness_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessTolerance"))

    @lightness_tolerance.setter
    def lightness_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8c1a192085fcf01a91eb1b63d6f4c57ab66d9682d30795940348dbceb871e1f6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVar")
    def lightness_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessToleranceVar"))

    @lightness_tolerance_var.setter
    def lightness_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac629b893124bfba38ed164fb72a2b09be7ce2ca5979d4672229a1c4791a06a6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeather")
    def saturation_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeather"))

    @saturation_feather.setter
    def saturation_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d896cc239284f7c95fbb3cfaf9aad04e604356ea9bd07e82d6661590f22f5e0c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeather", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVar")
    def saturation_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeatherVar"))

    @saturation_feather_var.setter
    def saturation_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7752b7742d4d1837ddf64e01647c805fe20a8eeacfc31f24ac19dc9e424466ef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationTolerance")
    def saturation_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationTolerance"))

    @saturation_tolerance.setter
    def saturation_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__429ad6587c735ea8194a1851f64ba1eaaf21beee08d5dcec13a0868806e0648b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVar")
    def saturation_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationToleranceVar"))

    @saturation_tolerance_var.setter
    def saturation_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8fd99cd8a7fada08b91e155633e24b2f3dbc465fb3cb23a2bb6ce32e3b9edc36)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeChromaKey]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeChromaKey]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeChromaKey]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ffd80ec5f92e8dd6c1aec29c1a4019392dc3de9a3815cc90533d32a1e70e2eb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeComposite",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "placement": "placement",
        "placement_var": "placementVar",
        "scale": "scale",
        "scale_dimension": "scaleDimension",
        "scale_dimension_var": "scaleDimensionVar",
        "scale_var": "scaleVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeComposite:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCompositeImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        placement: typing.Optional[builtins.str] = None,
        placement_var: typing.Optional[builtins.str] = None,
        scale: typing.Optional[builtins.str] = None,
        scale_dimension: typing.Optional[builtins.str] = None,
        scale_dimension_var: typing.Optional[builtins.str] = None,
        scale_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param placement: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        :param placement_var: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        :param scale: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param scale_dimension: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        :param scale_dimension_var: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        :param scale_var: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        :param x_position: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCompositeImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9fde5dd901c3e269fbc86c441b8e53600f41799f20910a7afaf1690a3f2e3b80)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument placement", value=placement, expected_type=type_hints["placement"])
            check_type(argname="argument placement_var", value=placement_var, expected_type=type_hints["placement_var"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument scale_dimension", value=scale_dimension, expected_type=type_hints["scale_dimension"])
            check_type(argname="argument scale_dimension_var", value=scale_dimension_var, expected_type=type_hints["scale_dimension_var"])
            check_type(argname="argument scale_var", value=scale_var, expected_type=type_hints["scale_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if placement is not None:
            self._values["placement"] = placement
        if placement_var is not None:
            self._values["placement_var"] = placement_var
        if scale is not None:
            self._values["scale"] = scale
        if scale_dimension is not None:
            self._values["scale_dimension"] = scale_dimension
        if scale_dimension_var is not None:
            self._values["scale_dimension_var"] = scale_dimension_var
        if scale_var is not None:
            self._values["scale_var"] = scale_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCompositeImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCompositeImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        '''
        result = self._values.get("placement")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement_var(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        '''
        result = self._values.get("placement_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        '''
        result = self._values.get("scale_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        '''
        result = self._values.get("scale_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        '''
        result = self._values.get("scale_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeComposite(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCompositeImage",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCompositeImage:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCompositeImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCompositeImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCompositeImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2c0160359aa9135f2b4154f464d266f7cb31ff570f6eaa08441edbefe9cff303)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCompositeImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCompositeImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aaee5d922c8d0f6f5a0ee0a032a8d133b51af49f8ddd03ab35711d222869dcf9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCompositeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCompositeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__517118858a7630eba53ccf63198b658359569ce084ab26b8e9486fa7747dac0f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCompositeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8f31476a8d7087dcb4f4a075855bd012758b2c8afe600eb29218566e9268dcae)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCompositeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7ca1985a6591531a35fe8aebde0085de3248f28c8ed47b362d6ee47cdc41f178)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1b22fe09275f02afedb1c1a952e20d549ef35d31d54a83e1c2f663d1ae570273)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cbe416db46a2793eb598b3207b0a059fa926aebab88693a9b1b4f97e04711571)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeComposite]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeComposite]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2414978bf6fd7a08d08374e79ad840a8b70b943c6269f2ede3b41ce915aa5b6d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCompositeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCompositeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7922b73fbf9523a257e47b0525fdad51c02f00dad97179eb2a42e4eaef94e97c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCompositeImage()

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPlacement")
    def reset_placement(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacement", []))

    @jsii.member(jsii_name="resetPlacementVar")
    def reset_placement_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacementVar", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetScaleDimension")
    def reset_scale_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimension", []))

    @jsii.member(jsii_name="resetScaleDimensionVar")
    def reset_scale_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimensionVar", []))

    @jsii.member(jsii_name="resetScaleVar")
    def reset_scale_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCompositeImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCompositeImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCompositeImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="placementInput")
    def placement_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementInput"))

    @builtins.property
    @jsii.member(jsii_name="placementVarInput")
    def placement_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionInput")
    def scale_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVarInput")
    def scale_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleVarInput")
    def scale_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__47dda376bc1a23ce43c2aa4843b1871ce43acdd9b083e5b3cba865179c8608e9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0eeebbb003ff4cd9a6fbbb73dacea10c28de3d64dc8b9eac3b20bdbd53b8e77e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="placement")
    def placement(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placement"))

    @placement.setter
    def placement(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__00cf81de6cf011b90f89dd681e7c30e777432910381f79726d08fa2c282065f1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placement", value)

    @builtins.property
    @jsii.member(jsii_name="placementVar")
    def placement_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placementVar"))

    @placement_var.setter
    def placement_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f5dc7b15cb821d05d54a4bf9142a3194cd2bc709d10cf7f2fcb518685e44dc79)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placementVar", value)

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scale"))

    @scale.setter
    def scale(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__976cb61fecda5cf4897d35ee69e7a007f857b7196ba989826bac655f7780ae2e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scale", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimension")
    def scale_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimension"))

    @scale_dimension.setter
    def scale_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ff9b232d43a5b641d0e73ecbb70193d9499117df6f3c9274d866db6f3de53f59)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimension", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVar")
    def scale_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimensionVar"))

    @scale_dimension_var.setter
    def scale_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__87633327b08266f9df37ff5d98e4868eeb76b4516af19c3b89288d7762839911)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="scaleVar")
    def scale_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleVar"))

    @scale_var.setter
    def scale_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__80a6dc38080efcbbfcd44237f120e27ba34f325394ed45e735e7ff63f95db69a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f28f6416d1f870ebd8466a2366d328f9ea13f76391573c3bb57a100512116c01)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2b15d96100354abe0c135f82385fbca8f8d4daaa0eaa1f582eb5b25ae1763957)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f815f36ab0962c6f4efe6ececa7442140e4e4ec06e36c044dec2e25d7195a02f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__11641f78ab61c6e6c67c01449d5fd016461f20530c3908d42ccf5bcac3c1d1c2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeComposite]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeComposite]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeComposite]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1152abf3f75635abe1708a53faa071ca76892717f5f221be8bcbf262cb6b515d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCompound",
    jsii_struct_bases=[],
    name_mapping={"transformations": "transformations"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCompound:
    def __init__(
        self,
        *,
        transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param transformations: transformations block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7575dc1702c71673b4a62876f235632b02d5607db8a594b19840d37a58b23858)
            check_type(argname="argument transformations", value=transformations, expected_type=type_hints["transformations"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if transformations is not None:
            self._values["transformations"] = transformations

    @builtins.property
    def transformations(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCompoundTransformations"]]]:
        '''transformations block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        result = self._values.get("transformations")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCompoundTransformations"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCompound(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCompoundList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCompoundList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__95134e557e69edd1195d0b48c35e6eb362b06eb2943fa0e48762716b09bad526)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCompoundOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__97fc0c2dcd4434c9677baa38552af40e834fc293bbfc7e05b77bbf6420fee59d)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCompoundOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6478d8dfa5b37dec6028d75839dc5965880e796e7ef2ff613ed3d1f2cd65a5e9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a224266191e37a248a5e63495fe0334478d0a08240dfccef7432429a1169e9b6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b432b1b3436a9016cca37f920f55fc0b6eb2c0b070d42a80b857f7fe2373af7d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCompound]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCompound]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__052e6381ca2787a042cae447c99b3ebfcc8c15078378d14778ba8c471fc02456)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCompoundOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCompoundOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5dede7f24bb1c4d0e68127f80e7ffe4cbaec4741d37010f41e422ee4238d3e1c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformations")
    def put_transformations(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3d1495cdce21a174d695ffbe67a42491fbde3fe6fe32a1bd02e504bcf45dbef1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTransformations", [value]))

    @jsii.member(jsii_name="resetTransformations")
    def reset_transformations(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformations", []))

    @builtins.property
    @jsii.member(jsii_name="transformations")
    def transformations(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCompoundTransformationsList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCompoundTransformationsList", jsii.get(self, "transformations"))

    @builtins.property
    @jsii.member(jsii_name="transformationsInput")
    def transformations_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCompoundTransformations"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCompoundTransformations"]]], jsii.get(self, "transformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCompound]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCompound]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCompound]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7e6a47da05427f5e935f7b9e4f7db09a8a0118de61dd8d2fa43f56f1a81139a8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCompoundTransformations",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCompoundTransformations:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCompoundTransformations(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCompoundTransformationsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCompoundTransformationsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6b4ae988504f85b00dcc4cdccc58a143b4ee9dfebebdc068af7f4609c401ba01)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCompoundTransformationsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__17d776cc5cb37053533ef425c8d02c7af1a8a4521bb4b7c55a41a626cb98bb72)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCompoundTransformationsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9c50728a26179d39cde0a99fa1303a7ac819c853113ecc156545cebd084b6f44)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__81568720fc880b410ad5b94d7af1ba95298aa75610ce5ec2ab20d6ab60f1b9be)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f38576450c847bf01c2a08faa38e5ab9386eb642a9dddac7703ef98110a517bd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCompoundTransformations]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCompoundTransformations]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCompoundTransformations]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__79aa9d4f79dac148cd084da7f44a3e2196999d892c35a3983637bb3e0dda3d82)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCompoundTransformationsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCompoundTransformationsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c38022468de80b84e70f2cc0b493583cac9c1c091819c3a0a1c74e8d4dfb55ce)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCompoundTransformations]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCompoundTransformations]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCompoundTransformations]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1d0f4d4a5078c5e7c8d67bfc946c28b388e66410c2fdc80604e38eff98f93c42)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeContrast",
    jsii_struct_bases=[],
    name_mapping={
        "brightness": "brightness",
        "brightness_var": "brightnessVar",
        "contrast": "contrast",
        "contrast_var": "contrastVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeContrast:
    def __init__(
        self,
        *,
        brightness: typing.Optional[builtins.str] = None,
        brightness_var: typing.Optional[builtins.str] = None,
        contrast: typing.Optional[builtins.str] = None,
        contrast_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param brightness: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        :param brightness_var: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        :param contrast: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param contrast_var: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d7613814b2bc8c6a8bfa941f2804d3ec5c7f61dbc5bccbfeba95a59862c6876d)
            check_type(argname="argument brightness", value=brightness, expected_type=type_hints["brightness"])
            check_type(argname="argument brightness_var", value=brightness_var, expected_type=type_hints["brightness_var"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument contrast_var", value=contrast_var, expected_type=type_hints["contrast_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if brightness is not None:
            self._values["brightness"] = brightness
        if brightness_var is not None:
            self._values["brightness_var"] = brightness_var
        if contrast is not None:
            self._values["contrast"] = contrast
        if contrast_var is not None:
            self._values["contrast_var"] = contrast_var

    @builtins.property
    def brightness(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        '''
        result = self._values.get("brightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def brightness_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        '''
        result = self._values.get("brightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        result = self._values.get("contrast_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeContrast(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeContrastList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeContrastList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__15326b8e494f862cd2e43b0fa6aad9a06caaa2738f850ea6207e082c95506ddf)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeContrastOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ab2e7e5f1624faceaf1cff0b2a6287d88d807642c1f7efe72b6fe6d323d40fb)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeContrastOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2efdae06c917b3fd3bb13fa60db84cb7971f3562e2677fd7e7dab765481da8d0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__27bd40a6c2b3d718545bc28d4b37f7b49bc71d7f5ee41d514d67091f50f06c5f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bd5bc980fc9941ff5cd87393c5056ffc70decdd8a00f4114a6675e00d5b4f399)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeContrast]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeContrast]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9956db1e996c4705f2e7494d4ff2300fafead8cd1b3953427176126ce896cde6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeContrastOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeContrastOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4977118608ed254d1db70ba127f2517563842ee93391f64101cb8f2d07b62ef9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetBrightness")
    def reset_brightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightness", []))

    @jsii.member(jsii_name="resetBrightnessVar")
    def reset_brightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightnessVar", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetContrastVar")
    def reset_contrast_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrastVar", []))

    @builtins.property
    @jsii.member(jsii_name="brightnessInput")
    def brightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="brightnessVarInput")
    def brightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastVarInput")
    def contrast_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="brightness")
    def brightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightness"))

    @brightness.setter
    def brightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__341683765f9a94c1a0e817603064026ab51483723f57b4a4042d6e219a4e0381)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightness", value)

    @builtins.property
    @jsii.member(jsii_name="brightnessVar")
    def brightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightnessVar"))

    @brightness_var.setter
    def brightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__58d135aefee29d4ef1a83f7cb6d91ceb1fe64a85c86881061ad521828d471899)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrast"))

    @contrast.setter
    def contrast(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__418f02179ac9a949cd83c5799359414122327caa7ba54c7ab5515e3ff858f950)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrast", value)

    @builtins.property
    @jsii.member(jsii_name="contrastVar")
    def contrast_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrastVar"))

    @contrast_var.setter
    def contrast_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__617b33ad7b16e6d5623392618c93e233c6fc63a4ffd4052e855159042b1993cc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrastVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeContrast]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeContrast]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeContrast]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__508b0b73406caedf88fb57ba2a2d4c1c3ae816e63b6543b5ed218498bff97f20)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCrop",
    jsii_struct_bases=[],
    name_mapping={
        "allow_expansion": "allowExpansion",
        "allow_expansion_var": "allowExpansionVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCrop:
    def __init__(
        self,
        *,
        allow_expansion: typing.Optional[builtins.str] = None,
        allow_expansion_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_expansion: If cropping an area outside of the existing canvas, expands the image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        :param allow_expansion_var: If cropping an area outside of the existing canvas, expands the image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        :param gravity: Frame of reference for X and Y Positions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Frame of reference for X and Y Positions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The number of pixels to crop along the y-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The number of pixels to crop along the y-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The number of pixels to crop along the x-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The number of pixels to crop along the x-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        :param x_position: The x-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__40c9a288173fd5b95d83c4848d359e2c8b62f0f4d95f298ab03feb3670c4d2dd)
            check_type(argname="argument allow_expansion", value=allow_expansion, expected_type=type_hints["allow_expansion"])
            check_type(argname="argument allow_expansion_var", value=allow_expansion_var, expected_type=type_hints["allow_expansion_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if allow_expansion is not None:
            self._values["allow_expansion"] = allow_expansion
        if allow_expansion_var is not None:
            self._values["allow_expansion_var"] = allow_expansion_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def allow_expansion(self) -> typing.Optional[builtins.str]:
        '''If cropping an area outside of the existing canvas, expands the image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        '''
        result = self._values.get("allow_expansion")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def allow_expansion_var(self) -> typing.Optional[builtins.str]:
        '''If cropping an area outside of the existing canvas, expands the image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        '''
        result = self._values.get("allow_expansion_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Frame of reference for X and Y Positions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Frame of reference for X and Y Positions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the y-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the y-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the x-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the x-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__566b63c28fe3c0aaf59dae02f5c5ebfe8b6296bf9b6f8c4d8073ca4ceff5d6a0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5b50ad40a17d1240c69987765b012c53ef53885310b38d5d8f5b833b31b4a26e)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c18a6412a246b27ebfdc40c6a9a0c3a338a61b259eeaa099b64d5771dd4a9b6b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ff39528735b27ea6524a3cdbd7cd4eeb980854ffc843ca665982a461a480b43)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dec5f88c1e2b45abf1fe21e0f299ca68dd6353336bc4a977afd1ac670ec72c80)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1b1b4b889bec62ee4f6e4925bb978fe06d6c5d95f9989bd870e20037b76b034d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d1293e3f82cff6b574ede4472e3cbe2ba66ccdd63f7d648614bb28b7f065a014)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAllowExpansion")
    def reset_allow_expansion(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansion", []))

    @jsii.member(jsii_name="resetAllowExpansionVar")
    def reset_allow_expansion_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansionVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionInput")
    def allow_expansion_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVarInput")
    def allow_expansion_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansion")
    def allow_expansion(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansion"))

    @allow_expansion.setter
    def allow_expansion(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ffb9a3e1ece6ff5cff310375e2bd929ee7bc634e420ff7f61061c5dd5bd077d1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansion", value)

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVar")
    def allow_expansion_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansionVar"))

    @allow_expansion_var.setter
    def allow_expansion_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b87be9e9ddda37fdd4b4193338a7821d36bfe96f9961f7234b6864919035cbc8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansionVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7f1c2e1158a06569bd5da07e393977348a57d76eb0302303ec7a1e59bdccc19d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6d37d86e46232763e44915ab09acaa59df2e35b04879e1159436da3c9308ea67)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e88da8f0a7fd268b3dc82b0cdf8fbfe2361937143e86032abac271cc35ad8132)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8022fcacb81edf5a6f381b658657d385ccd5884304128e62e60216e0c80041c3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b87260fae7fec88c169db029e058ac00b2712ab5b0d2b02f4df702a868afe9e7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ed4a6e5cd7e9ef166a9c8a167adb949f4bff6a91c0d37fd9b7d5e444ec9ef02)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__39ea75c030fd9241d46752e9935d762ec2eacac5efc5f5f66850ae7395f1d6b4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7f3f64f9e01e10d38bf9d30b9bcfdce1de89cbce6e844fbd6facf4f8f21262dc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7e294aacc4b2906b9202562a5842afdf600db1181ff92a2e636adea08cfcb903)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ffd66fbe5a67c7ba0b1b6fe0015efacb9d7d3591448f22cbb2258142b7dafdd2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3eee6fa80be3b0cd1a6ebba90f0c662b2903d8c65ca3e90b0b821a8cc7193d8c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeFaceCrop",
    jsii_struct_bases=[],
    name_mapping={
        "algorithm": "algorithm",
        "algorithm_var": "algorithmVar",
        "confidence": "confidence",
        "confidence_var": "confidenceVar",
        "fail_gravity": "failGravity",
        "fail_gravity_var": "failGravityVar",
        "focus": "focus",
        "focus_var": "focusVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "padding": "padding",
        "padding_var": "paddingVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeFaceCrop:
    def __init__(
        self,
        *,
        algorithm: typing.Optional[builtins.str] = None,
        algorithm_var: typing.Optional[builtins.str] = None,
        confidence: typing.Optional[builtins.str] = None,
        confidence_var: typing.Optional[builtins.str] = None,
        fail_gravity: typing.Optional[builtins.str] = None,
        fail_gravity_var: typing.Optional[builtins.str] = None,
        focus: typing.Optional[builtins.str] = None,
        focus_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param algorithm: Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm DataAkamaiImagingPolicyImage#algorithm}
        :param algorithm_var: Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm_var DataAkamaiImagingPolicyImage#algorithm_var}
        :param confidence: With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image. Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence DataAkamaiImagingPolicyImage#confidence}
        :param confidence_var: With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image. Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence_var DataAkamaiImagingPolicyImage#confidence_var}
        :param fail_gravity: Controls placement of the crop if Image and Video Manager does not detect any faces in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        :param fail_gravity_var: Controls placement of the crop if Image and Video Manager does not detect any faces in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        :param focus: Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus DataAkamaiImagingPolicyImage#focus}
        :param focus_var: Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus_var DataAkamaiImagingPolicyImage#focus_var}
        :param gravity: Controls placement of the crop. Directions are relative to the face(s) plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Controls placement of the crop. Directions are relative to the face(s) plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param padding: The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        :param style: Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__02dba86b539bba88369de3b8f03361a4feeb335c30ed9013a2ba44f1b2638690)
            check_type(argname="argument algorithm", value=algorithm, expected_type=type_hints["algorithm"])
            check_type(argname="argument algorithm_var", value=algorithm_var, expected_type=type_hints["algorithm_var"])
            check_type(argname="argument confidence", value=confidence, expected_type=type_hints["confidence"])
            check_type(argname="argument confidence_var", value=confidence_var, expected_type=type_hints["confidence_var"])
            check_type(argname="argument fail_gravity", value=fail_gravity, expected_type=type_hints["fail_gravity"])
            check_type(argname="argument fail_gravity_var", value=fail_gravity_var, expected_type=type_hints["fail_gravity_var"])
            check_type(argname="argument focus", value=focus, expected_type=type_hints["focus"])
            check_type(argname="argument focus_var", value=focus_var, expected_type=type_hints["focus_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if algorithm is not None:
            self._values["algorithm"] = algorithm
        if algorithm_var is not None:
            self._values["algorithm_var"] = algorithm_var
        if confidence is not None:
            self._values["confidence"] = confidence
        if confidence_var is not None:
            self._values["confidence_var"] = confidence_var
        if fail_gravity is not None:
            self._values["fail_gravity"] = fail_gravity
        if fail_gravity_var is not None:
            self._values["fail_gravity_var"] = fail_gravity_var
        if focus is not None:
            self._values["focus"] = focus
        if focus_var is not None:
            self._values["focus_var"] = focus_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def algorithm(self) -> typing.Optional[builtins.str]:
        '''Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm DataAkamaiImagingPolicyImage#algorithm}
        '''
        result = self._values.get("algorithm")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def algorithm_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm_var DataAkamaiImagingPolicyImage#algorithm_var}
        '''
        result = self._values.get("algorithm_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def confidence(self) -> typing.Optional[builtins.str]:
        '''With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image.

        Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence DataAkamaiImagingPolicyImage#confidence}
        '''
        result = self._values.get("confidence")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def confidence_var(self) -> typing.Optional[builtins.str]:
        '''With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image.

        Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence_var DataAkamaiImagingPolicyImage#confidence_var}
        '''
        result = self._values.get("confidence_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any faces in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        '''
        result = self._values.get("fail_gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any faces in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        '''
        result = self._values.get("fail_gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def focus(self) -> typing.Optional[builtins.str]:
        '''Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus DataAkamaiImagingPolicyImage#focus}
        '''
        result = self._values.get("focus")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def focus_var(self) -> typing.Optional[builtins.str]:
        '''Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus_var DataAkamaiImagingPolicyImage#focus_var}
        '''
        result = self._values.get("focus_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the face(s) plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the face(s) plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeFaceCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeFaceCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeFaceCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f6dc17bae427b90bbd9c4539f629f0268738f31c0150de1fa05e622e8a7ac54f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeFaceCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f24bf27ea764f7ab23285b28c8004bdd195f1bfefe955c31edc4bbdb5f7e6147)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeFaceCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b50aff8c0d3fc79cbffef401514911a5636b52fcbd899b10fb6a1107e3cfcc05)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9efcd641a0a536f57bcf898fa91879275b4a28c679032c2f918497af1b537ee9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9e195d6f744b455399be14809460974e6beaa3f3eec0c94b65cbd783f9849cf9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeFaceCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeFaceCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeFaceCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dd1ab6404789c21f37fc91a8de149f42cc9c048481dda83d1270489d92571ebb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeFaceCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeFaceCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d1f0b185d57fc428015487af4478170a7ebd913a3eccc4d6906a420f23a68e4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAlgorithm")
    def reset_algorithm(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAlgorithm", []))

    @jsii.member(jsii_name="resetAlgorithmVar")
    def reset_algorithm_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAlgorithmVar", []))

    @jsii.member(jsii_name="resetConfidence")
    def reset_confidence(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetConfidence", []))

    @jsii.member(jsii_name="resetConfidenceVar")
    def reset_confidence_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetConfidenceVar", []))

    @jsii.member(jsii_name="resetFailGravity")
    def reset_fail_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravity", []))

    @jsii.member(jsii_name="resetFailGravityVar")
    def reset_fail_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravityVar", []))

    @jsii.member(jsii_name="resetFocus")
    def reset_focus(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFocus", []))

    @jsii.member(jsii_name="resetFocusVar")
    def reset_focus_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFocusVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="algorithmInput")
    def algorithm_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "algorithmInput"))

    @builtins.property
    @jsii.member(jsii_name="algorithmVarInput")
    def algorithm_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "algorithmVarInput"))

    @builtins.property
    @jsii.member(jsii_name="confidenceInput")
    def confidence_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "confidenceInput"))

    @builtins.property
    @jsii.member(jsii_name="confidenceVarInput")
    def confidence_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "confidenceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityInput")
    def fail_gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityVarInput")
    def fail_gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="focusInput")
    def focus_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "focusInput"))

    @builtins.property
    @jsii.member(jsii_name="focusVarInput")
    def focus_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "focusVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="algorithm")
    def algorithm(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "algorithm"))

    @algorithm.setter
    def algorithm(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e001367bf6b87850d187d85372995e10ed25fc13bb73c8b1d7d70617d14162ce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "algorithm", value)

    @builtins.property
    @jsii.member(jsii_name="algorithmVar")
    def algorithm_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "algorithmVar"))

    @algorithm_var.setter
    def algorithm_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__94145848c59ac2fd96db41f661be0cc9415d2b74acdabce62d426dc3cba8938d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "algorithmVar", value)

    @builtins.property
    @jsii.member(jsii_name="confidence")
    def confidence(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "confidence"))

    @confidence.setter
    def confidence(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__68f5a66c62d1e6f33f409822219294daf2c5d660ea72694178e41a3cc6ba3064)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "confidence", value)

    @builtins.property
    @jsii.member(jsii_name="confidenceVar")
    def confidence_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "confidenceVar"))

    @confidence_var.setter
    def confidence_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__869c36e53596597c815a873188673c60cceb0eccce8fb1c1e6759df7b83f3989)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "confidenceVar", value)

    @builtins.property
    @jsii.member(jsii_name="failGravity")
    def fail_gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravity"))

    @fail_gravity.setter
    def fail_gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__90a3145bad3f69499d30f60f9957e1fcd2f2583e1507c3f164247768b74431bb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravity", value)

    @builtins.property
    @jsii.member(jsii_name="failGravityVar")
    def fail_gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravityVar"))

    @fail_gravity_var.setter
    def fail_gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d74a0274935e9324d159be42667e99c5a26d347cde3b81c33c14aa8536aa8f9a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="focus")
    def focus(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "focus"))

    @focus.setter
    def focus(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9bb4bf261b453c68c9b046586eb054a451c8f67729f6def4a758744a9fc6ca62)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "focus", value)

    @builtins.property
    @jsii.member(jsii_name="focusVar")
    def focus_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "focusVar"))

    @focus_var.setter
    def focus_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5624f9429a8bc2115d346945370d09fb996583c6fbce21c5d4e0485cc480d6c2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "focusVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0f724bb504a00377c54512b2c9f20810a347b775676ffb53aa9cbb531ebeccf4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fd8d5cc5281ef7f4a65e6356933cec07656ff31572ce51f87eaf491e17df735b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0f9b4e7cf0b682a52211f19558bd58f721f38cfb4c9868edf391070540c13838)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__65b6841070f855bbf5780acec405236a4a48d2a5287d20b27a83fdb53a0561ae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a0ad248f0d563ae326bd7a6ed13f2cd6064a0912e73a327153b3b8387fdc0ce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__43a404b333cdc937b23a68cd0295acfd7781809a9596be2bebc445f7428388b2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__146ce369417321c6f7a8c33e5adcf799415e0e8e87575a8cf6b02cad20428a22)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a7cef8edaedf5e124db6406e00a3290b689cb64e30c0128667cb256d72a90b4c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f81a2a90f946bffc7bf0ec54f4c97247c9dad7530c5dd9fec61d7f1ae34842c0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3dd47f7c55d5423dab5b4d4a536d6da90afc20c7ed0965eb8107768c756e293a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeFaceCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeFaceCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeFaceCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bba0132167d0785376c8dcf71be097a6eef3784c65dde53dbd36caceb22531bf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeFeatureCrop",
    jsii_struct_bases=[],
    name_mapping={
        "fail_gravity": "failGravity",
        "fail_gravity_var": "failGravityVar",
        "feature_radius": "featureRadius",
        "feature_radius_var": "featureRadiusVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "max_features": "maxFeatures",
        "max_features_var": "maxFeaturesVar",
        "min_feature_quality": "minFeatureQuality",
        "min_feature_quality_var": "minFeatureQualityVar",
        "padding": "padding",
        "padding_var": "paddingVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeFeatureCrop:
    def __init__(
        self,
        *,
        fail_gravity: typing.Optional[builtins.str] = None,
        fail_gravity_var: typing.Optional[builtins.str] = None,
        feature_radius: typing.Optional[builtins.str] = None,
        feature_radius_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        max_features: typing.Optional[builtins.str] = None,
        max_features_var: typing.Optional[builtins.str] = None,
        min_feature_quality: typing.Optional[builtins.str] = None,
        min_feature_quality_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fail_gravity: Controls placement of the crop if Image and Video Manager does not detect any features in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        :param fail_gravity_var: Controls placement of the crop if Image and Video Manager does not detect any features in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        :param feature_radius: The size in pixels of the important features to search for. If identified, two features never appear closer together than this value, ``8.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius DataAkamaiImagingPolicyImage#feature_radius}
        :param feature_radius_var: The size in pixels of the important features to search for. If identified, two features never appear closer together than this value, ``8.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius_var DataAkamaiImagingPolicyImage#feature_radius_var}
        :param gravity: Controls placement of the crop. Directions are relative to the region of interest plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Controls placement of the crop. Directions are relative to the region of interest plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param max_features: The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features DataAkamaiImagingPolicyImage#max_features}
        :param max_features_var: The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features_var DataAkamaiImagingPolicyImage#max_features_var}
        :param min_feature_quality: Determines the minimum quality level of the feature identified. To consider a feature important, the feature needs to surpass this value. Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality DataAkamaiImagingPolicyImage#min_feature_quality}
        :param min_feature_quality_var: Determines the minimum quality level of the feature identified. To consider a feature important, the feature needs to surpass this value. Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality_var DataAkamaiImagingPolicyImage#min_feature_quality_var}
        :param padding: Adds space around the region of interest. The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: Adds space around the region of interest. The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        :param style: Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a8369dbf0d8a095861e3b449cc78c4c4b6ef4923ed87030a47654f353c6cf47)
            check_type(argname="argument fail_gravity", value=fail_gravity, expected_type=type_hints["fail_gravity"])
            check_type(argname="argument fail_gravity_var", value=fail_gravity_var, expected_type=type_hints["fail_gravity_var"])
            check_type(argname="argument feature_radius", value=feature_radius, expected_type=type_hints["feature_radius"])
            check_type(argname="argument feature_radius_var", value=feature_radius_var, expected_type=type_hints["feature_radius_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument max_features", value=max_features, expected_type=type_hints["max_features"])
            check_type(argname="argument max_features_var", value=max_features_var, expected_type=type_hints["max_features_var"])
            check_type(argname="argument min_feature_quality", value=min_feature_quality, expected_type=type_hints["min_feature_quality"])
            check_type(argname="argument min_feature_quality_var", value=min_feature_quality_var, expected_type=type_hints["min_feature_quality_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fail_gravity is not None:
            self._values["fail_gravity"] = fail_gravity
        if fail_gravity_var is not None:
            self._values["fail_gravity_var"] = fail_gravity_var
        if feature_radius is not None:
            self._values["feature_radius"] = feature_radius
        if feature_radius_var is not None:
            self._values["feature_radius_var"] = feature_radius_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if max_features is not None:
            self._values["max_features"] = max_features
        if max_features_var is not None:
            self._values["max_features_var"] = max_features_var
        if min_feature_quality is not None:
            self._values["min_feature_quality"] = min_feature_quality
        if min_feature_quality_var is not None:
            self._values["min_feature_quality_var"] = min_feature_quality_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def fail_gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any features in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        '''
        result = self._values.get("fail_gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any features in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        '''
        result = self._values.get("fail_gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feature_radius(self) -> typing.Optional[builtins.str]:
        '''The size in pixels of the important features to search for.

        If identified, two features never appear closer together than this value, ``8.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius DataAkamaiImagingPolicyImage#feature_radius}
        '''
        result = self._values.get("feature_radius")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feature_radius_var(self) -> typing.Optional[builtins.str]:
        '''The size in pixels of the important features to search for.

        If identified, two features never appear closer together than this value, ``8.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius_var DataAkamaiImagingPolicyImage#feature_radius_var}
        '''
        result = self._values.get("feature_radius_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the region of interest plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the region of interest plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def max_features(self) -> typing.Optional[builtins.str]:
        '''The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features DataAkamaiImagingPolicyImage#max_features}
        '''
        result = self._values.get("max_features")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def max_features_var(self) -> typing.Optional[builtins.str]:
        '''The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features_var DataAkamaiImagingPolicyImage#max_features_var}
        '''
        result = self._values.get("max_features_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def min_feature_quality(self) -> typing.Optional[builtins.str]:
        '''Determines the minimum quality level of the feature identified.

        To consider a feature important, the feature needs to surpass this value.  Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality DataAkamaiImagingPolicyImage#min_feature_quality}
        '''
        result = self._values.get("min_feature_quality")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def min_feature_quality_var(self) -> typing.Optional[builtins.str]:
        '''Determines the minimum quality level of the feature identified.

        To consider a feature important, the feature needs to surpass this value.  Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality_var DataAkamaiImagingPolicyImage#min_feature_quality_var}
        '''
        result = self._values.get("min_feature_quality_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''Adds space around the region of interest.

        The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''Adds space around the region of interest.

        The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeFeatureCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeFeatureCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeFeatureCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__796b1e16c90363ed6b302818b3e516b25e3b7dd0dddfadc4d88df800b5735cfe)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeFeatureCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__228edb0a9e6870fe76b0d00ae09ba144a4b2dc2683e4fa3d01cb0b34f37155f5)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeFeatureCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9bae6ea6eef1d5e5f6618129d1e7cde4b35ef6b54374a1958e89a1e423004a7d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f436dac2789020ca462ceee4e9d0b9bff44d38676b67ddbb2fa6a37cdd115f7d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a638a42c831c19c81e7150de9e3a092aa26d6a5c85f5d7ec88ab72494001cad6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeFeatureCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeFeatureCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeFeatureCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2b93477f7bfe78f74625e1888f92bef70dccdd18f15dca206442c303666f15bd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeFeatureCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeFeatureCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__201fa171ccaa7dbf6e0f0c7678cab72199bbe63bb93259cb1c24dc4da501837c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetFailGravity")
    def reset_fail_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravity", []))

    @jsii.member(jsii_name="resetFailGravityVar")
    def reset_fail_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravityVar", []))

    @jsii.member(jsii_name="resetFeatureRadius")
    def reset_feature_radius(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureRadius", []))

    @jsii.member(jsii_name="resetFeatureRadiusVar")
    def reset_feature_radius_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureRadiusVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetMaxFeatures")
    def reset_max_features(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxFeatures", []))

    @jsii.member(jsii_name="resetMaxFeaturesVar")
    def reset_max_features_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxFeaturesVar", []))

    @jsii.member(jsii_name="resetMinFeatureQuality")
    def reset_min_feature_quality(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMinFeatureQuality", []))

    @jsii.member(jsii_name="resetMinFeatureQualityVar")
    def reset_min_feature_quality_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMinFeatureQualityVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="failGravityInput")
    def fail_gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityVarInput")
    def fail_gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featureRadiusInput")
    def feature_radius_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featureRadiusInput"))

    @builtins.property
    @jsii.member(jsii_name="featureRadiusVarInput")
    def feature_radius_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featureRadiusVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesInput")
    def max_features_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "maxFeaturesInput"))

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesVarInput")
    def max_features_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "maxFeaturesVarInput"))

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityInput")
    def min_feature_quality_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "minFeatureQualityInput"))

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityVarInput")
    def min_feature_quality_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "minFeatureQualityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravity")
    def fail_gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravity"))

    @fail_gravity.setter
    def fail_gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f50806cb787a5c5b8a9018830a3bf1543c8289fa25e5e092d1795750114e433)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravity", value)

    @builtins.property
    @jsii.member(jsii_name="failGravityVar")
    def fail_gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravityVar"))

    @fail_gravity_var.setter
    def fail_gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__85850860480800a4e62736106a1ec3f99a529021aaf7294c86776504ecf65902)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="featureRadius")
    def feature_radius(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featureRadius"))

    @feature_radius.setter
    def feature_radius(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d9be990feb122d7e9bcc0184e0adb78788d755387d42a7a334fa2d75e0cf7e58)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featureRadius", value)

    @builtins.property
    @jsii.member(jsii_name="featureRadiusVar")
    def feature_radius_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featureRadiusVar"))

    @feature_radius_var.setter
    def feature_radius_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b3283768c85ae5dc1ac98ae82525def8a4ad4fa3fc7daac162da0a182448b535)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featureRadiusVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea62084207520fcc0186bb51e0c5c9956af7e8c3226546058d1ca1fed8b6380e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ce182744eba3c8cb7aed87662ae125e766d8de69cd0601f00e7299e954949f50)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__369bc96eb75118fa1ebbeabe2aef269f62b2173a622f74437b3b9589a79cf440)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0f6e5326c4f00c900890e8fe085001e4199af07c3e705b0285e626c6367d7fc6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="maxFeatures")
    def max_features(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "maxFeatures"))

    @max_features.setter
    def max_features(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__945ab6418f4b1161a16cec14480454b813faf0c517419d9589c51dacd3065962)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "maxFeatures", value)

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesVar")
    def max_features_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "maxFeaturesVar"))

    @max_features_var.setter
    def max_features_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9f1aba658d16fc30b4ad86e41cf52e1d10a4babade8dd4a8fd5491538f53035d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "maxFeaturesVar", value)

    @builtins.property
    @jsii.member(jsii_name="minFeatureQuality")
    def min_feature_quality(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "minFeatureQuality"))

    @min_feature_quality.setter
    def min_feature_quality(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b389e5cdf8e53be730ef89b372d3ce79f21baa01083167ec41f8524307b8c3c4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "minFeatureQuality", value)

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityVar")
    def min_feature_quality_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "minFeatureQualityVar"))

    @min_feature_quality_var.setter
    def min_feature_quality_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__55d444d5124c03f4f4b53eeba10bb1cb6315471ebb47b2f26b670d731c1ac1ed)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "minFeatureQualityVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6428ac5e2713197d2c7689535acae68cb07e7cf8b1775019085448905f6d2c84)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f753641d6f2592bcdbe9429fdfbd6e7097ee67c7aacac8e96cd58a005b2d882)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2e587ac47248ed46eb110a8328add915b45fe924c10be7a88fb4e6912959c411)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3671c864031f00ba78e48b62c975ee4be323194de00d9e9bd311592d4979cc19)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__de8158bb08b582c981aa6ceec4dc2ce1b791b3c5ed2e12696c6f39b4cbfda10c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__468a92edf7104de899b4878abb9a47ce954aa77360d2924a36dc42802264b1c6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeFeatureCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeFeatureCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeFeatureCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__92a51a1242c077288e64a618b7ccb86ea318a89ff50ebe4be71c77162df1bd6a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeFitAndFill",
    jsii_struct_bases=[],
    name_mapping={
        "fill_transformation": "fillTransformation",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeFitAndFill:
    def __init__(
        self,
        *,
        fill_transformation: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeFitAndFillFillTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fill_transformation: fill_transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_transformation DataAkamaiImagingPolicyImage#fill_transformation}
        :param height: The height value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The width value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(fill_transformation, dict):
            fill_transformation = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeFitAndFillFillTransformation(**fill_transformation)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8b74e0f072985b8929f1b76d8e035e5ca0cb906fadd6fe8719d97e0d7bed613b)
            check_type(argname="argument fill_transformation", value=fill_transformation, expected_type=type_hints["fill_transformation"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fill_transformation is not None:
            self._values["fill_transformation"] = fill_transformation
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def fill_transformation(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeFitAndFillFillTransformation"]:
        '''fill_transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_transformation DataAkamaiImagingPolicyImage#fill_transformation}
        '''
        result = self._values.get("fill_transformation")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeFitAndFillFillTransformation"], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeFitAndFill(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeFitAndFillFillTransformation",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeFitAndFillFillTransformation:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeFitAndFillFillTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeFitAndFillFillTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeFitAndFillFillTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d1643d833d524f7174fe93a308f92034d3f943c52d9c0cac0fb95d5dd6beef7b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeFitAndFillFillTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeFitAndFillFillTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeFitAndFillFillTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__19493cb2ee8309aed8c359e0549c269a1b43254e71c3a75b9a961d3bab1d4b33)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeFitAndFillList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeFitAndFillList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__30710c8696c18aa0e1266fd3f7e457e18bf7f116e1259d3dfc0e9b00c0a2b5fa)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeFitAndFillOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1d420719524c1987ad3ced09d47c82cab85f24c38be30c56dea5b9513ee9571f)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeFitAndFillOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5a952586a95aa7041627854a0ad3b8b0af4b5948e681f3ea20f9f451dcdc180a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab645cfe9f66a5d4158397b681dcc5ed99330aa06e133868e40751dfe4684285)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cc4c7d174084b47726d87d55d8201c45bf091d8f082f05bd624b040cc28592a6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeFitAndFill]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeFitAndFill]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeFitAndFill]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1614e0c8cc640b8550fc96b20974906e3ab7277328b79746f44eb52474a1eb76)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeFitAndFillOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeFitAndFillOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ef17ec45a1f399b260ab41fc35f5594568fedd44ca2716a4ff49edaf0b0ecc7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putFillTransformation")
    def put_fill_transformation(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeFitAndFillFillTransformation()

        return typing.cast(None, jsii.invoke(self, "putFillTransformation", [value]))

    @jsii.member(jsii_name="resetFillTransformation")
    def reset_fill_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFillTransformation", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="fillTransformation")
    def fill_transformation(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeFitAndFillFillTransformationOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeFitAndFillFillTransformationOutputReference, jsii.get(self, "fillTransformation"))

    @builtins.property
    @jsii.member(jsii_name="fillTransformationInput")
    def fill_transformation_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeFitAndFillFillTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeFitAndFillFillTransformation], jsii.get(self, "fillTransformationInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b290b3915bc7ec24bcd3d2a8d61fc82941f3d2ac56ea0c692ab885c496aeec1a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e25ab4323b37291148c66bb3a9483277ff2a867e669d39fa065d431572a9c5ca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e5c4b59c6141bd5eaddff479deeb9bd86c669ec6aa3b201eb9f42e4af56e667b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__273b4a2dc0b9271b9aff2d950f465b45008813721f582c2445384ab9c16e66f6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeFitAndFill]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeFitAndFill]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeFitAndFill]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__730c2ca872b33b00a9af7d0219d25718551375d20bd1a851ecff40fb02a4fcee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeGoop",
    jsii_struct_bases=[],
    name_mapping={
        "chaos": "chaos",
        "chaos_var": "chaosVar",
        "density": "density",
        "density_var": "densityVar",
        "power": "power",
        "power_var": "powerVar",
        "seed": "seed",
        "seed_var": "seedVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeGoop:
    def __init__(
        self,
        *,
        chaos: typing.Optional[builtins.str] = None,
        chaos_var: typing.Optional[builtins.str] = None,
        density: typing.Optional[builtins.str] = None,
        density_var: typing.Optional[builtins.str] = None,
        power: typing.Optional[builtins.str] = None,
        power_var: typing.Optional[builtins.str] = None,
        seed: typing.Optional[builtins.str] = None,
        seed_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param chaos: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        :param chaos_var: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        :param density: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        :param density_var: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        :param power: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        :param power_var: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        :param seed: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        :param seed_var: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__93d74f40bd7f3e0d368b742a4b2c4d6b5662a80f7c0e3435475508e8a629ac38)
            check_type(argname="argument chaos", value=chaos, expected_type=type_hints["chaos"])
            check_type(argname="argument chaos_var", value=chaos_var, expected_type=type_hints["chaos_var"])
            check_type(argname="argument density", value=density, expected_type=type_hints["density"])
            check_type(argname="argument density_var", value=density_var, expected_type=type_hints["density_var"])
            check_type(argname="argument power", value=power, expected_type=type_hints["power"])
            check_type(argname="argument power_var", value=power_var, expected_type=type_hints["power_var"])
            check_type(argname="argument seed", value=seed, expected_type=type_hints["seed"])
            check_type(argname="argument seed_var", value=seed_var, expected_type=type_hints["seed_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if chaos is not None:
            self._values["chaos"] = chaos
        if chaos_var is not None:
            self._values["chaos_var"] = chaos_var
        if density is not None:
            self._values["density"] = density
        if density_var is not None:
            self._values["density_var"] = density_var
        if power is not None:
            self._values["power"] = power
        if power_var is not None:
            self._values["power_var"] = power_var
        if seed is not None:
            self._values["seed"] = seed
        if seed_var is not None:
            self._values["seed_var"] = seed_var

    @builtins.property
    def chaos(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        '''
        result = self._values.get("chaos")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def chaos_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        '''
        result = self._values.get("chaos_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        '''
        result = self._values.get("density")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density_var(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        '''
        result = self._values.get("density_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        '''
        result = self._values.get("power")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power_var(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        '''
        result = self._values.get("power_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        '''
        result = self._values.get("seed")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed_var(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        result = self._values.get("seed_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeGoop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeGoopList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeGoopList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3d2796634ac1d799fe06295b6be92b84c71227923528706cf4c5662735e2e742)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeGoopOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e7ffa43b85ca1291e8e47097aa0fb6f11ee1770f48055cd96e3b55b72839ae49)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeGoopOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__706163ede5d48524afff4d1e5f45854b72e5428cd9100c95ffc6c2913ea15e69)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9b0674192c075d6e6dced1ed6e3dc364270f1a64563581a99d21909b856b2bee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4aa353db20f11b60175b6ee2b2d7d5fa944ae624066f8960a8712db3736b56c7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeGoop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeGoop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b274b31f222b410dad801239229e9868cbf707b9bfd9c48928ed2fc068b18dfb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeGoopOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeGoopOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df656a621f5ab83f5c2870f13c49760892a1467d39894e083862243361d32e98)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetChaos")
    def reset_chaos(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaos", []))

    @jsii.member(jsii_name="resetChaosVar")
    def reset_chaos_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaosVar", []))

    @jsii.member(jsii_name="resetDensity")
    def reset_density(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensity", []))

    @jsii.member(jsii_name="resetDensityVar")
    def reset_density_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensityVar", []))

    @jsii.member(jsii_name="resetPower")
    def reset_power(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPower", []))

    @jsii.member(jsii_name="resetPowerVar")
    def reset_power_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPowerVar", []))

    @jsii.member(jsii_name="resetSeed")
    def reset_seed(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeed", []))

    @jsii.member(jsii_name="resetSeedVar")
    def reset_seed_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeedVar", []))

    @builtins.property
    @jsii.member(jsii_name="chaosInput")
    def chaos_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosInput"))

    @builtins.property
    @jsii.member(jsii_name="chaosVarInput")
    def chaos_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosVarInput"))

    @builtins.property
    @jsii.member(jsii_name="densityInput")
    def density_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityInput"))

    @builtins.property
    @jsii.member(jsii_name="densityVarInput")
    def density_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="powerInput")
    def power_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerInput"))

    @builtins.property
    @jsii.member(jsii_name="powerVarInput")
    def power_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerVarInput"))

    @builtins.property
    @jsii.member(jsii_name="seedInput")
    def seed_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedInput"))

    @builtins.property
    @jsii.member(jsii_name="seedVarInput")
    def seed_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedVarInput"))

    @builtins.property
    @jsii.member(jsii_name="chaos")
    def chaos(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaos"))

    @chaos.setter
    def chaos(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e392d866a5735783ce6fb15b04673cc0528a6dd2c2e8c6c44004bbbd70624832)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaos", value)

    @builtins.property
    @jsii.member(jsii_name="chaosVar")
    def chaos_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaosVar"))

    @chaos_var.setter
    def chaos_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1c7e7a35164b26d80429a75270f193ffb8d40ec17ab2b1def439b68959ecf140)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaosVar", value)

    @builtins.property
    @jsii.member(jsii_name="density")
    def density(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "density"))

    @density.setter
    def density(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5bf3a74e799040d4023764f6572875fbee55578395b462f98f9b4fd93ad6b714)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "density", value)

    @builtins.property
    @jsii.member(jsii_name="densityVar")
    def density_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "densityVar"))

    @density_var.setter
    def density_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f817394bdca67aa16f2581e4a2ecc013cb015d563201812509944fa0b52f3029)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "densityVar", value)

    @builtins.property
    @jsii.member(jsii_name="power")
    def power(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "power"))

    @power.setter
    def power(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__caf189bdf0f947061e407d8bc8406a068110f5be4a821af144d01f7ef0bd99f3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "power", value)

    @builtins.property
    @jsii.member(jsii_name="powerVar")
    def power_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "powerVar"))

    @power_var.setter
    def power_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5595d3819c86fdaebc0c321e0096a338cde316d571e09eac8ba243072c965a96)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "powerVar", value)

    @builtins.property
    @jsii.member(jsii_name="seed")
    def seed(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seed"))

    @seed.setter
    def seed(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__24c4d6b5e15f9a3d7a1c9d21f83ca04c07a1830750d5de81792caeb5e05be540)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seed", value)

    @builtins.property
    @jsii.member(jsii_name="seedVar")
    def seed_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seedVar"))

    @seed_var.setter
    def seed_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ef99c8939a80f02856859dff80ca4149e3d323790403eda13d3f9371941ec9ad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seedVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeGoop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeGoop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeGoop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__15672be63a8fe8b73957d0e4838c75120aa5b8980b1592ccbab430f55cdb6dcf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeGrayscale",
    jsii_struct_bases=[],
    name_mapping={"type": "type", "type_var": "typeVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeGrayscale:
    def __init__(
        self,
        *,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param type: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ffedacb3dc4451c9511931dc9ea71e4d53c1917ee5dda97b05c74174184001dc)
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeGrayscale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeGrayscaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeGrayscaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0a89ab5db56f1639fe66e4129e8edf95d8db750689eb311824589277b81895f1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeGrayscaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a927bce86658dd024fa5fb0aa773570eec19e1521fcf4c52770343787e9ad3d)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeGrayscaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a7f76539731fc93b83d98c3d951220f3b79168a27d869fcfd9956f5088eaee8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c9fa31825fc81b9ca85ec3e5a78fee41636626f9792449db761f28677b82878b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d2b48d053c2612af4adf12fba4b76d6f259fed9b7aa6a92495bba73fe82a03cd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeGrayscale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeGrayscale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8f901e74a3ba3bb5cb82ed063a681d1623a88adf17677402ea5f3b3082081e82)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeGrayscaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeGrayscaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__161f95df54483c0b33619b1e6120c123c14a111c052471980a0a85db6542e758)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__86cd9840ee8c4f2a7ae7da84858ed1b2a6e3134eef76297dc67207eefb0e402a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d1e7c075a6d625697f882c95c4f628059b0a43ec8505857f5b780d41b8abe3d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeGrayscale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeGrayscale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeGrayscale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4d81738cb6b0630aa7eb21b9774f33a5160d1a10ab4021a8f47b6dc0608324f5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeHsl",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "lightness": "lightness",
        "lightness_var": "lightnessVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeHsl:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness: typing.Optional[builtins.str] = None,
        lightness_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        :param lightness_var: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8915710c6ebee524b3f218a09d45dbfa822e951e4aa5893316497f31b47b7de0)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness", value=lightness, expected_type=type_hints["lightness"])
            check_type(argname="argument lightness_var", value=lightness_var, expected_type=type_hints["lightness_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness is not None:
            self._values["lightness"] = lightness
        if lightness_var is not None:
            self._values["lightness_var"] = lightness_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        '''
        result = self._values.get("lightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        '''
        result = self._values.get("lightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeHsl(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeHslList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeHslList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d6b0e594d0a5bb34366802058f06df0a08766a64215dffa199e7c2e138980d0d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeHslOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__21e920a4fc64b259e57ec9fd8999e5ade1bc9ddd8d31c0601ca4be501ac7cebe)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeHslOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aa2dcc5c09d7fcc34bc526ff3cdf9baf1d95593f96e359c606499eaad9398ad6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f9f821c2e4c1f012b92c1719a1d7b7401720a63c4fd25a079921425149f0cfa7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7a77fe4ba9577ec80227a2bd83199dc884a1358bf4e1da1917c1231aa24cde4d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeHsl]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeHsl]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ae7c9fe8616a67fb7b527fe71aac5ca456cfbdfd32636e33874a62101e26f9df)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeHslOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeHslOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6aa910af0e0cb6404d69a65733735b9c73b5170d87ada92fe6ecd41437cd2e67)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightness")
    def reset_lightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightness", []))

    @jsii.member(jsii_name="resetLightnessVar")
    def reset_lightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessInput")
    def lightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessVarInput")
    def lightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d708e3657f94ba271160761d02e5eec0a75aac80ec7380bf53750074004185f6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__78e66bd092099275767c8f86fc1ca64dad4f60d84e5b75347d4fac2f65501d85)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightness")
    def lightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightness"))

    @lightness.setter
    def lightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9794df067d5b909e75e62e905db154e5dbb8cfb03861936befd4b28122d45648)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightness", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessVar")
    def lightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessVar"))

    @lightness_var.setter
    def lightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__997143a50ae807cd2c27d0eddb8470062ab7c41aef59905e578d16787bba68f3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5806f3f40286558ad4018a86f2f308f7d16307ebcd1a105b23763c3ad95b9578)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5c2ab1a74abc082cf1eed8b6fb9ace2f6161eef3988a1c875c2b65ec9e9e21f1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeHsl]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeHsl]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeHsl]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f7fa349fb5cc5856668dd4332b019d1122c7b2712196fb745dfe38fbb88df48)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeHsv",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeHsv:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        :param value: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3e91725fa775f1ff3152a79f799bcbaa6f6a1b4ef54cdfe9d4de067fbf32b13b)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeHsv(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeHsvList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeHsvList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eb34e2cf9c11d43cca9228aab7aecf00ac2ad896e8250fe04fc1d200715a3ea5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeHsvOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__56708dac25ba24e72ca5e1839830bd575776a123fb0421bc376588da33c31c18)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeHsvOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ef45a1e16942fe658af24d87ffa7f1b6d19960c133097d3f1e2e1e8ecd9d5ecb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__47c92b4a71c8ebca3229f569f7a8e961c7c4dfa3a96455f36f48a00d907324ef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aa780966dad2894b26b2399196475fa3afca2f3bf22c5f09cd5285e38889a580)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeHsv]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeHsv]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a2aa5e9ef76e29ec1d0cd30f51ffd7d0f743822a99aee64375081407dd20ab0b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeHsvOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeHsvOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f60b19a268e7e106774fda300949fd4c9122ff3ef1801967cbf69e1197643c9c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__00512ba0a46a19752396e2e065cd0e3aa463109606681325fbe0c0ed8856971b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ad39a00c0946ac71e33f6b7171fcc0296fea57dca4bfa03d8b58c5c660cd4306)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6271efb1dc62e5f7518bc6a65e771e7eed2f6124ba9369e4b98ca3849e8edc02)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d58e46f31fed228ade6101af08fa907dc120dee00557c18b678178c7577fe014)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1324119b6f0d81b0cb0ee7c940e9326fb794d6fc23bfdf775fdb9efa336b0bbe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5e34402a52f577b1d9898a77679a79fd0402f0109a2eacd97f28a8c8a98ad0b1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeHsv]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeHsv]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeHsv]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d2722ca71391ca97c5105f9e1d487bbb764ef902e7bdedc1bd408f6847fe93a6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimension",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "dimension": "dimension",
        "dimension_var": "dimensionVar",
        "equal": "equal",
        "greater_than": "greaterThan",
        "less_than": "lessThan",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimension:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        dimension: typing.Optional[builtins.str] = None,
        dimension_var: typing.Optional[builtins.str] = None,
        equal: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionEqual", typing.Dict[builtins.str, typing.Any]]] = None,
        greater_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionGreaterThan", typing.Dict[builtins.str, typing.Any]]] = None,
        less_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionLessThan", typing.Dict[builtins.str, typing.Any]]] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param dimension: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        :param dimension_var: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        :param equal: equal block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        :param greater_than: greater_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        :param less_than: less_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        :param value: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionDefault(**default)
        if isinstance(equal, dict):
            equal = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionEqual(**equal)
        if isinstance(greater_than, dict):
            greater_than = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionGreaterThan(**greater_than)
        if isinstance(less_than, dict):
            less_than = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionLessThan(**less_than)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e6542953453cf0b3334b02e47be9d3fbb2f918b2b1bd209ecd6f08b2951a54cf)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument dimension", value=dimension, expected_type=type_hints["dimension"])
            check_type(argname="argument dimension_var", value=dimension_var, expected_type=type_hints["dimension_var"])
            check_type(argname="argument equal", value=equal, expected_type=type_hints["equal"])
            check_type(argname="argument greater_than", value=greater_than, expected_type=type_hints["greater_than"])
            check_type(argname="argument less_than", value=less_than, expected_type=type_hints["less_than"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if dimension is not None:
            self._values["dimension"] = dimension
        if dimension_var is not None:
            self._values["dimension_var"] = dimension_var
        if equal is not None:
            self._values["equal"] = equal
        if greater_than is not None:
            self._values["greater_than"] = greater_than
        if less_than is not None:
            self._values["less_than"] = less_than
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionDefault"], result)

    @builtins.property
    def dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        '''
        result = self._values.get("dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        '''
        result = self._values.get("dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def equal(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionEqual"]:
        '''equal block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        '''
        result = self._values.get("equal")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionEqual"], result)

    @builtins.property
    def greater_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionGreaterThan"]:
        '''greater_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        '''
        result = self._values.get("greater_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionGreaterThan"], result)

    @builtins.property
    def less_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionLessThan"]:
        '''less_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        '''
        result = self._values.get("less_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionLessThan"], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimension(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__676810e597d0a07c3aff5f021211ad3f8dfa74bde43440b36df614f108f37ac4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7402dc6d64bdbbbf99b40d327fa37b1589508f4eb3480595c9ada70042244e2c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionEqual",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionEqual:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionEqual(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionEqualOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionEqualOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e7b6273b67bba11ce0ac68bca5f70c8a986094818988bb68a85dcdee3e5e1d7e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionEqual], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionEqual],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__15257c96d4495d0fbb581c1cb0c5e3ec7a91ece88ff671396d8a3369b1b40be7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionGreaterThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionGreaterThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionGreaterThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionGreaterThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionGreaterThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__366be2b40407b74532a607d234a7e98dae417c145ffb8d97414378af71eb0061)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionGreaterThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionGreaterThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be87272d8a8c14db57b400d5af2e60279d13bc40471f287061e1ac0641c162b0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionLessThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionLessThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionLessThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionLessThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionLessThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6753b53917933749623dcb9c2618ccd52d805c71f4909f2e66b76d1fd33c260b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionLessThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionLessThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__23f042d605deba748ba4a16ae70ae1a765f3f4b4ed04da7e356dfa8cc51ce028)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4385a0aed635a93f028648b3a41d2f7062903f5398d6c07076df3dff2666b1b2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b97b143b876b806ddf91c93688634e352f5ef1bc91ab318c0140b9013bdab90b)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0654a1438b07a745b356bc784be6485839d7726027ba615308b871850c392e7b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__54c3c612dd7deb90da695cc6fded770391fe5f1e20b5974353b1fd097d262bb0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c0584e60245332cf25f2c33c1742b9209aca300153712b29af066325f1e7f947)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimension]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimension]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1afaa3bc084fad8ae7126cb1202765df7e165358e291f988d0d97b0a5db022e4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c52e23d09eec8923fd608ef72cb3b54676f0605791bab7983e3a53d0a8dabc50)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putEqual")
    def put_equal(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionEqual()

        return typing.cast(None, jsii.invoke(self, "putEqual", [value]))

    @jsii.member(jsii_name="putGreaterThan")
    def put_greater_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionGreaterThan()

        return typing.cast(None, jsii.invoke(self, "putGreaterThan", [value]))

    @jsii.member(jsii_name="putLessThan")
    def put_less_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionLessThan()

        return typing.cast(None, jsii.invoke(self, "putLessThan", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetDimension")
    def reset_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimension", []))

    @jsii.member(jsii_name="resetDimensionVar")
    def reset_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimensionVar", []))

    @jsii.member(jsii_name="resetEqual")
    def reset_equal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEqual", []))

    @jsii.member(jsii_name="resetGreaterThan")
    def reset_greater_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGreaterThan", []))

    @jsii.member(jsii_name="resetLessThan")
    def reset_less_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLessThan", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="equal")
    def equal(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionEqualOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionEqualOutputReference, jsii.get(self, "equal"))

    @builtins.property
    @jsii.member(jsii_name="greaterThan")
    def greater_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionGreaterThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionGreaterThanOutputReference, jsii.get(self, "greaterThan"))

    @builtins.property
    @jsii.member(jsii_name="lessThan")
    def less_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionLessThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionLessThanOutputReference, jsii.get(self, "lessThan"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionInput")
    def dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionVarInput")
    def dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="equalInput")
    def equal_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionEqual], jsii.get(self, "equalInput"))

    @builtins.property
    @jsii.member(jsii_name="greaterThanInput")
    def greater_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionGreaterThan], jsii.get(self, "greaterThanInput"))

    @builtins.property
    @jsii.member(jsii_name="lessThanInput")
    def less_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionLessThan], jsii.get(self, "lessThanInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="dimension")
    def dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimension"))

    @dimension.setter
    def dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__87833af735620bcf9886db25b73417a2567cb4e73fac16b12ec90f961a7808db)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimension", value)

    @builtins.property
    @jsii.member(jsii_name="dimensionVar")
    def dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimensionVar"))

    @dimension_var.setter
    def dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a8e5e8577fdb3d94f57e24d0a282ef6c0b422c0b2dec76b547ec8fde964cbb0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ccb777b668cdf3f71ac632c610e73bb5b8a79a3e29b03ea010186258069d8570)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__23eb64945e432e0b043ac4124f0ed682f3bf047662caf511b6e7e05dcfa26bf6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimension]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimension]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimension]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d020a6bbde77c88741f49f1137a73d0b1649c39d4fdfe18f167e546e521b3b42)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientation",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "landscape": "landscape",
        "portrait": "portrait",
        "square": "square",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientation:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        landscape: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationLandscape", typing.Dict[builtins.str, typing.Any]]] = None,
        portrait: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationPortrait", typing.Dict[builtins.str, typing.Any]]] = None,
        square: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationSquare", typing.Dict[builtins.str, typing.Any]]] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param landscape: landscape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        :param portrait: portrait block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        :param square: square block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationDefault(**default)
        if isinstance(landscape, dict):
            landscape = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationLandscape(**landscape)
        if isinstance(portrait, dict):
            portrait = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationPortrait(**portrait)
        if isinstance(square, dict):
            square = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationSquare(**square)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__72703c488f1891c4f6018e5efcdf0fb334feb4e6addf3b115156830caf0d41c0)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument landscape", value=landscape, expected_type=type_hints["landscape"])
            check_type(argname="argument portrait", value=portrait, expected_type=type_hints["portrait"])
            check_type(argname="argument square", value=square, expected_type=type_hints["square"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if landscape is not None:
            self._values["landscape"] = landscape
        if portrait is not None:
            self._values["portrait"] = portrait
        if square is not None:
            self._values["square"] = square

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationDefault"], result)

    @builtins.property
    def landscape(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationLandscape"]:
        '''landscape block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        '''
        result = self._values.get("landscape")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationLandscape"], result)

    @builtins.property
    def portrait(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationPortrait"]:
        '''portrait block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        '''
        result = self._values.get("portrait")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationPortrait"], result)

    @builtins.property
    def square(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationSquare"]:
        '''square block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        result = self._values.get("square")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationSquare"], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__125f3362fd25b3c8301c111507847a1c4d120107b744f693ec29df8033337cc2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d77eef30bd1cec7c5edcd5cc90d30e0e6e4ed3d8b669175e75c40d03f0bd8158)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationLandscape",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationLandscape:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationLandscape(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationLandscapeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationLandscapeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7cead8ff10a517e9bb8c0eb2a0f543497f6aa9726c2c89cd9b934a8d2f45470b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationLandscape], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationLandscape],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3b8b0358b25fa64ebf753ed25b846ea52812f864a18c87a2d8dd5406c52780df)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__384c4a87f7fb1859afdbe7a15be26b7ef9c88846821c6e82ece48dac9c0551f9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6764722acddae3b22f10f76a2b74abb7fa77a8626d251aec443ebfdd36b7810f)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be9494a3ae3b9bc2af205f77205df6fe1c181222fdfdd49f8880bfc63a3bcffc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__333d2c2f4e983be84667cb8531bbde5f63a4027c67889ffafac1714f93312230)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3b037734feb0fa2d754ad0b7b7e7d5699b1bee93d24cbebbd3588b5cbaa0456f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientation]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientation]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__06957facfd0873af3cccadaa2700117bc7da2426c054dcda62e489d0fc3ab819)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8b15d7a1d1f4774602661b390c5a5cd38a5ef1a7cb4a0cbe172bf201dc3fd2ce)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putLandscape")
    def put_landscape(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationLandscape()

        return typing.cast(None, jsii.invoke(self, "putLandscape", [value]))

    @jsii.member(jsii_name="putPortrait")
    def put_portrait(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationPortrait()

        return typing.cast(None, jsii.invoke(self, "putPortrait", [value]))

    @jsii.member(jsii_name="putSquare")
    def put_square(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationSquare()

        return typing.cast(None, jsii.invoke(self, "putSquare", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetLandscape")
    def reset_landscape(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLandscape", []))

    @jsii.member(jsii_name="resetPortrait")
    def reset_portrait(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPortrait", []))

    @jsii.member(jsii_name="resetSquare")
    def reset_square(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSquare", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="landscape")
    def landscape(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationLandscapeOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationLandscapeOutputReference, jsii.get(self, "landscape"))

    @builtins.property
    @jsii.member(jsii_name="portrait")
    def portrait(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationPortraitOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationPortraitOutputReference", jsii.get(self, "portrait"))

    @builtins.property
    @jsii.member(jsii_name="square")
    def square(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationSquareOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationSquareOutputReference", jsii.get(self, "square"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="landscapeInput")
    def landscape_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationLandscape], jsii.get(self, "landscapeInput"))

    @builtins.property
    @jsii.member(jsii_name="portraitInput")
    def portrait_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationPortrait"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationPortrait"], jsii.get(self, "portraitInput"))

    @builtins.property
    @jsii.member(jsii_name="squareInput")
    def square_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationSquare"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationSquare"], jsii.get(self, "squareInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientation]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientation]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientation]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__599d6b9b22fdbfca32dbbe01717cdbd69ebe13bb51e23f87cf3cf04b54e57fe0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationPortrait",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationPortrait:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationPortrait(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationPortraitOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationPortraitOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7825d65a31f220102b7e5e8b5812900e3f9ac956297f85a1f295c3071559f166)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationPortrait]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationPortrait], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationPortrait],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ccda5fbf558d073dc51febacc26f2f4093afd821bc185e0503ac7ea9872aa01f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationSquare",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationSquare:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationSquare(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationSquareOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationSquareOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bf142d92223495085b0e7df80e8759aabdf6424f255c7c164f0c691c87d226de)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationSquare]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationSquare], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationSquare],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3756ff5cc67c63b84cdd160ebb303f9907dc7c08dce40eeea5a0fb6630e67f86)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeImQuery",
    jsii_struct_bases=[],
    name_mapping={
        "allowed_transformations": "allowedTransformations",
        "query_var": "queryVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeImQuery:
    def __init__(
        self,
        *,
        allowed_transformations: typing.Sequence[builtins.str],
        query_var: builtins.str,
    ) -> None:
        '''
        :param allowed_transformations: Specifies the transformations that can be applied using the query string parameter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allowed_transformations DataAkamaiImagingPolicyImage#allowed_transformations}
        :param query_var: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#query_var DataAkamaiImagingPolicyImage#query_var}.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ede01f3963b6faf82d6ef40baba8c8c37c245871a1a6aa4a49ac8fcd10419a4f)
            check_type(argname="argument allowed_transformations", value=allowed_transformations, expected_type=type_hints["allowed_transformations"])
            check_type(argname="argument query_var", value=query_var, expected_type=type_hints["query_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "allowed_transformations": allowed_transformations,
            "query_var": query_var,
        }

    @builtins.property
    def allowed_transformations(self) -> typing.List[builtins.str]:
        '''Specifies the transformations that can be applied using the query string parameter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allowed_transformations DataAkamaiImagingPolicyImage#allowed_transformations}
        '''
        result = self._values.get("allowed_transformations")
        assert result is not None, "Required property 'allowed_transformations' is missing"
        return typing.cast(typing.List[builtins.str], result)

    @builtins.property
    def query_var(self) -> builtins.str:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#query_var DataAkamaiImagingPolicyImage#query_var}.'''
        result = self._values.get("query_var")
        assert result is not None, "Required property 'query_var' is missing"
        return typing.cast(builtins.str, result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeImQuery(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeImQueryList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeImQueryList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__37d5dfbdad3eb00f19e17edcd7de410059253705f2a58573abe16bef9601f7bf)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeImQueryOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__11696605ce4f33f73970b21c17f2221ff122cfb09d8ac0bbfe6256eee4ebe6b1)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeImQueryOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cf06c3fabbe91c8c28610affb70797d8cc4ab9f4c74b89d41e3022ceb2ddeb2c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f05e96412c495fc400562c2a368a48f5ef6d186c616b033255adf47a9ea8a49f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__678c67bc208f38d5a3e763e28356857bb5ca70f56281e9d7e5c77046947497c5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeImQuery]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeImQuery]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeImQuery]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d4b1e6afb64e6f6defaadc58007c5703a4fb0ff4bdd0fab039a80022836164c4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeImQueryOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeImQueryOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__54574b591e3725218101923348a480916eb4850efee50c9f7bf1c1c893e8f90f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @builtins.property
    @jsii.member(jsii_name="allowedTransformationsInput")
    def allowed_transformations_input(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "allowedTransformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="queryVarInput")
    def query_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "queryVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowedTransformations")
    def allowed_transformations(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "allowedTransformations"))

    @allowed_transformations.setter
    def allowed_transformations(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__915c2e9eb28f7a0f1dbb09fc552ac6bcf17affc0571f909c4ebaf590697d9494)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowedTransformations", value)

    @builtins.property
    @jsii.member(jsii_name="queryVar")
    def query_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "queryVar"))

    @query_var.setter
    def query_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__846f222322ce4094e3bb7b12408aabc59803ba90570097390b24a26126b9e44f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "queryVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeImQuery]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeImQuery]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeImQuery]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dac9b137fb0a55de63506b4a3294c6470d2eb4be27c45d49e94a905c3804f6ff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeMaxColors",
    jsii_struct_bases=[],
    name_mapping={"colors": "colors", "colors_var": "colorsVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeMaxColors:
    def __init__(
        self,
        *,
        colors: typing.Optional[builtins.str] = None,
        colors_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param colors: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        :param colors_var: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__da87048191ac876e11c25158563224befd6502314d419c788593d1cda6cd8162)
            check_type(argname="argument colors", value=colors, expected_type=type_hints["colors"])
            check_type(argname="argument colors_var", value=colors_var, expected_type=type_hints["colors_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if colors is not None:
            self._values["colors"] = colors
        if colors_var is not None:
            self._values["colors_var"] = colors_var

    @builtins.property
    def colors(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        '''
        result = self._values.get("colors")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def colors_var(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        result = self._values.get("colors_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeMaxColors(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeMaxColorsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeMaxColorsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5db9aa82c508796b9a98a25c1bcb8e6c95e0c40bc646e4c85cf30f0693042504)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeMaxColorsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d09b6d8a00f8d621e3a652869b5c2009eb73d3a9e656bd39a7802165b2818ec9)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeMaxColorsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c827745dc380e13d0657257c3c866bbd0c3a614cad35f2a6cb99e85fab823aeb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ad8e7062bd5fe3ebd1f36467fd68c59b394cf93a093a752440c0d7fdddb98bc8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2b3bb190fa67975f376b2ffd5c9c4676a0a9f91088fbf6a63f897c42fcbff4df)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeMaxColors]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeMaxColors]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fcbdcc65a948009be3ecf9af7db8c11d0f92f9923a235ce54d278903d77d3137)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeMaxColorsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeMaxColorsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__793384dc6b90909251e8d0ea87017729d1ab90be92919bf5722786f3980c98c4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColors")
    def reset_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColors", []))

    @jsii.member(jsii_name="resetColorsVar")
    def reset_colors_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorsVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorsInput")
    def colors_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsInput"))

    @builtins.property
    @jsii.member(jsii_name="colorsVarInput")
    def colors_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsVarInput"))

    @builtins.property
    @jsii.member(jsii_name="colors")
    def colors(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colors"))

    @colors.setter
    def colors(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8caaf8ca0afa3444fcb6bbf4d3a86cb48516adb694578dedfd81576fae82ab0f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colors", value)

    @builtins.property
    @jsii.member(jsii_name="colorsVar")
    def colors_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorsVar"))

    @colors_var.setter
    def colors_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0fa13a1d1d83ac3e32a0118bc88ccddad55ecafee7aa3ceb6b6aee65f5fbfc67)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorsVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeMaxColors]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeMaxColors]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeMaxColors]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ef57e0bb2a0c133ba53e35648a1c82efaddeddbf98096ede4e053d423a17433e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeMirror",
    jsii_struct_bases=[],
    name_mapping={
        "horizontal": "horizontal",
        "horizontal_var": "horizontalVar",
        "vertical": "vertical",
        "vertical_var": "verticalVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeMirror:
    def __init__(
        self,
        *,
        horizontal: typing.Optional[builtins.str] = None,
        horizontal_var: typing.Optional[builtins.str] = None,
        vertical: typing.Optional[builtins.str] = None,
        vertical_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param horizontal: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        :param horizontal_var: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        :param vertical: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        :param vertical_var: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d1449fd830b8e25fbcab25e140794750cc136b63a92378699b19912552e2de14)
            check_type(argname="argument horizontal", value=horizontal, expected_type=type_hints["horizontal"])
            check_type(argname="argument horizontal_var", value=horizontal_var, expected_type=type_hints["horizontal_var"])
            check_type(argname="argument vertical", value=vertical, expected_type=type_hints["vertical"])
            check_type(argname="argument vertical_var", value=vertical_var, expected_type=type_hints["vertical_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if horizontal is not None:
            self._values["horizontal"] = horizontal
        if horizontal_var is not None:
            self._values["horizontal_var"] = horizontal_var
        if vertical is not None:
            self._values["vertical"] = vertical
        if vertical_var is not None:
            self._values["vertical_var"] = vertical_var

    @builtins.property
    def horizontal(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        '''
        result = self._values.get("horizontal")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def horizontal_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        '''
        result = self._values.get("horizontal_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        '''
        result = self._values.get("vertical")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        result = self._values.get("vertical_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeMirror(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeMirrorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeMirrorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d65eb2280bffd545ed0038036f742534bda5b5697ddd3c27309765428989aa6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeMirrorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e1b0da8d0e1a56148aa1015aba2e484eb9173d578197a3a43f321b7dc2a1e93e)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeMirrorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d03e1f177301cf526176a103b9ba50ee8d50531084d71312594b6bed65c9a420)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4dcd3269873e3ed34d997e358b3c019f45f8a6f48698d5d2b464edfcf13465e1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df0790a1db5faa1116fcf1315dcfdf86ad91b5ea3ae6584bbae1f53f63d539d7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeMirror]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeMirror]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a659b05c880481b42698ff4d77d89f87f2997440f463630df166dce2f2492c4a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeMirrorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeMirrorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cf010b3157759a6523110f3e613416d0c75381df4a7c8ddc45d940571d8b5112)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHorizontal")
    def reset_horizontal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontal", []))

    @jsii.member(jsii_name="resetHorizontalVar")
    def reset_horizontal_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontalVar", []))

    @jsii.member(jsii_name="resetVertical")
    def reset_vertical(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVertical", []))

    @jsii.member(jsii_name="resetVerticalVar")
    def reset_vertical_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVerticalVar", []))

    @builtins.property
    @jsii.member(jsii_name="horizontalInput")
    def horizontal_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontalVarInput")
    def horizontal_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalInput")
    def vertical_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalVarInput")
    def vertical_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontal")
    def horizontal(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontal"))

    @horizontal.setter
    def horizontal(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4462dd3bedda9c0c2806af0f069fb0072f6bab50f68216bb65f89b4d303f667a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontal", value)

    @builtins.property
    @jsii.member(jsii_name="horizontalVar")
    def horizontal_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontalVar"))

    @horizontal_var.setter
    def horizontal_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4eac925e6140345d6bfafb6060a828edd3635cf332d08cb128b6ce874c38abd1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontalVar", value)

    @builtins.property
    @jsii.member(jsii_name="vertical")
    def vertical(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "vertical"))

    @vertical.setter
    def vertical(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0fc21f957883933aa93b761cc288d4b5147e08890cb1af8f6689689e9340f541)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "vertical", value)

    @builtins.property
    @jsii.member(jsii_name="verticalVar")
    def vertical_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "verticalVar"))

    @vertical_var.setter
    def vertical_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c3b2a849940aafc625cd16875aa967ae1c5d5e40c0f3083093d25fbb82980f5e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "verticalVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeMirror]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeMirror]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeMirror]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ebe7e4845c40e313372f429380e43065bb17183648cd21de26fe9fa92a8e8c52)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeMonoHue",
    jsii_struct_bases=[],
    name_mapping={"hue": "hue", "hue_var": "hueVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeMonoHue:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b47200544d2643fbefc731ba950f2feb43e9c621840dc9de7cc330d1b177ceed)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeMonoHue(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeMonoHueList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeMonoHueList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e7fbf506767c78f11a46314d6881e6beb11c8abfee75263cf788d18b596f321b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeMonoHueOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cc6b8f97a7d3434420cb0fb6186f172c0a63d39778f17628083eb55625ee7354)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeMonoHueOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__29e381274ec20b2e557b8a25623527ee5a320318b9dfd22c74300e2515663fea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9dec2cdbc66f616a9b50414389e121a1b5aebaf421fc65b8c83a81c81b783db9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__60b1e7a3dced1a9745d67d3b0c592f279a1ec0d7565c7f0ff45dde36f982f6d5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeMonoHue]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeMonoHue]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab6ed49c5de4e63f4c7a8c68aee0a3620669b0509719053c6957e11720970b4c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeMonoHueOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeMonoHueOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f56484e2a6d975edfd14b05c92fb88edb32deb29c6ad8a814c3bf4e35aab329e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eca047c2bd65ebe07d3d771bbedb6f2014aba0ac354428d855eff113a5f544e1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8c9f1ce276314b340c0dc935d2fb05bce48d5ee82de43b42b25293d6168676d1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeMonoHue]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeMonoHue]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeMonoHue]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e782184a3c1c9f6aa1a211860c04e23606f3ffec24f6872f02c0181c97dec930)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeOpacity",
    jsii_struct_bases=[],
    name_mapping={"opacity": "opacity", "opacity_var": "opacityVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeOpacity:
    def __init__(
        self,
        *,
        opacity: typing.Optional[builtins.str] = None,
        opacity_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param opacity: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param opacity_var: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a60ca4d7c08195bdefd5be810c436c0329ba2b51e40ddff790cdadf7b82b3e3a)
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument opacity_var", value=opacity_var, expected_type=type_hints["opacity_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if opacity is not None:
            self._values["opacity"] = opacity
        if opacity_var is not None:
            self._values["opacity_var"] = opacity_var

    @builtins.property
    def opacity(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def opacity_var(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        result = self._values.get("opacity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeOpacity(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeOpacityList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeOpacityList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ec1b2a36b7097d4ef4b3d791260dae0c3d858c5a6ca90b350dffe959d592ae6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeOpacityOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f86a85e8f094b4164e5848523ea04127fb42479564bc0a1e96482760768d9818)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeOpacityOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9994a6846e5373354161b26353fb08e26291f20f3e42f9621b60205945439dd8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a2bdc0e22b8f1ea543f68ab36e7d210752f36351b980d6bde8efe9c49ca50d7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__78f2332a95cbd2210a6542a52ac2226925f5e0472d95e56cf85880e973eecfd8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeOpacity]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeOpacity]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6a66b39d8d6a74e6d0f3ceb7de92e0957dba37c499ff5ee63e126aaae8fa3734)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeOpacityOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeOpacityOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2375b99458bccbe5e158e0e00635e6a9195add4e2e4fc0904666ec276794c5dc)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetOpacityVar")
    def reset_opacity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacityVar", []))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityVarInput")
    def opacity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacity"))

    @opacity.setter
    def opacity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__33b49e1e808a7afa1a9faa794ac839635e8e1c845329159fc33f7f1bca680250)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacity", value)

    @builtins.property
    @jsii.member(jsii_name="opacityVar")
    def opacity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacityVar"))

    @opacity_var.setter
    def opacity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__108bf2b13bb23543b4f4e02c7f925973dcf1677655809786638c6ad1525739cb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacityVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeOpacity]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeOpacity]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeOpacity]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4c65955fb34e2933be1dd770ee28cfebc7b52a84d04839d74f8f939e92ff2839)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d874f8ddc8b5137be93313b4878abb6a0ef5ebab9f0d77fb66f098f41f2eff5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putAppend")
    def put_append(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeAppend, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0a2cd4bc0ffd48857cd7b9c7d5071222ce398e88b3a37fc21f5e76139aee4b9e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putAppend", [value]))

    @jsii.member(jsii_name="putAspectCrop")
    def put_aspect_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeAspectCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8d3ad5a1dcab4377c9fc182fc45d6d7d9381df9c980cb19deed104e36909e2b6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putAspectCrop", [value]))

    @jsii.member(jsii_name="putBackgroundColor")
    def put_background_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1aacb542c93b7a723e092d58e648c291913a07ec2e52dc3f23003c1a7e6ce17a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBackgroundColor", [value]))

    @jsii.member(jsii_name="putBlur")
    def put_blur(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeBlur, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a9beb37ada74a95d53a04f9f0010cae12c5b80d8c266cb78c1ab6a24e5f3332)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBlur", [value]))

    @jsii.member(jsii_name="putChromaKey")
    def put_chroma_key(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeChromaKey, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__19997a9ef9c1a2e123725ae52ed475ba6e161c88bcc9299cdb03a5b6d81b29ff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putChromaKey", [value]))

    @jsii.member(jsii_name="putComposite")
    def put_composite(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeComposite, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__413f2057bdcb1b1269c2cbd83c136156352e2240f7dbe5bced5f24b7917918c9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putComposite", [value]))

    @jsii.member(jsii_name="putCompound")
    def put_compound(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCompound, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8088a82caffdf9f68b8a1c4b71beffacb26f11783c59948d5cd87892209ad371)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCompound", [value]))

    @jsii.member(jsii_name="putContrast")
    def put_contrast(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeContrast, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__48a2ebeaec725a9dbe6e3a28814c28ed034f6b8ced08f420e9958fc1101bf44c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putContrast", [value]))

    @jsii.member(jsii_name="putCrop")
    def put_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e8fd570a7b913fd73b7248b8f6c97eb764a3148f1bf6c6b596c1b24c730c49de)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCrop", [value]))

    @jsii.member(jsii_name="putFaceCrop")
    def put_face_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeFaceCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2e6311fee09858beb4897d3846281b3e452672f7eefc7bdaefd4256b9d67f48c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFaceCrop", [value]))

    @jsii.member(jsii_name="putFeatureCrop")
    def put_feature_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeFeatureCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ef26b088c38b8fc523a5138f415d0623ca0a818342a72a06d799338f41f471f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFeatureCrop", [value]))

    @jsii.member(jsii_name="putFitAndFill")
    def put_fit_and_fill(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeFitAndFill, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__32afda9aed8663c21fcdbedaddbea87f0d5c37bcd78f5f34c24a16e68b3577f4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFitAndFill", [value]))

    @jsii.member(jsii_name="putGoop")
    def put_goop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeGoop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cb61b3f12fc8e91a4c705df7aaad5f827f18f9b9a0f0ea8dbced69e362a249ca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGoop", [value]))

    @jsii.member(jsii_name="putGrayscale")
    def put_grayscale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeGrayscale, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a103a81cf3e4b655f5b8ff5fa55f3880d5b9bd878157afc34e4d4159c9a863a9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGrayscale", [value]))

    @jsii.member(jsii_name="putHsl")
    def put_hsl(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeHsl, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__395821951dd177bb2455fc296c9de8b3e689bd06c4336689836aa3dcc89edf3c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsl", [value]))

    @jsii.member(jsii_name="putHsv")
    def put_hsv(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeHsv, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f2564671534d2a2c12b13342c38f2fdb6a71745a40687c2044d8964a574af160)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsv", [value]))

    @jsii.member(jsii_name="putIfDimension")
    def put_if_dimension(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimension, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__688fb7783d4d5bed468791db9971691b3b9194790e04d0b9ba0489aa6d6d94b3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfDimension", [value]))

    @jsii.member(jsii_name="putIfOrientation")
    def put_if_orientation(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__944e94cddddbe3bdb37132e39fd7573b0c92669d405b7dfbbad9f4570d14c082)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfOrientation", [value]))

    @jsii.member(jsii_name="putImQuery")
    def put_im_query(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeImQuery, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dd02b3104b967e057d9e3a7e60e4d4fefe153ab6b7d9eed6a5a72960be3d3e23)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putImQuery", [value]))

    @jsii.member(jsii_name="putMaxColors")
    def put_max_colors(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeMaxColors, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b0b0211971cf682bf6a70f54ced0f35429e6af869f12caf4b806c457b2b1a99f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMaxColors", [value]))

    @jsii.member(jsii_name="putMirror")
    def put_mirror(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeMirror, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__810192d9f33cf538da6030dd1bb8820e456da8609ab0dc6c110bfc785a744165)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMirror", [value]))

    @jsii.member(jsii_name="putMonoHue")
    def put_mono_hue(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeMonoHue, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aee0bafaba45b21e72bb39c7adc7216eec8381d12390c8f2b948bc6474936a2f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMonoHue", [value]))

    @jsii.member(jsii_name="putOpacity")
    def put_opacity(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeOpacity, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eeb366017964067437e979635fc2867456525267b6ce6fe2f9d50798257cce44)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putOpacity", [value]))

    @jsii.member(jsii_name="putRegionOfInterestCrop")
    def put_region_of_interest_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRegionOfInterestCrop", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__51e03e8a382b7b40b8d5410e3a8c8dabb99c3cac3dd8980e273c7f08b4f7f30d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRegionOfInterestCrop", [value]))

    @jsii.member(jsii_name="putRelativeCrop")
    def put_relative_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRelativeCrop", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__76e49700f5ada4ee6fe43afff8b0c0cc7ef6d99cc1ae48c1f9c3531b698cb3cf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRelativeCrop", [value]))

    @jsii.member(jsii_name="putRemoveColor")
    def put_remove_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRemoveColor", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0457a180f277365cc901501e5615872009c54b746660a1bc1c7ac0edf0e58d1d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRemoveColor", [value]))

    @jsii.member(jsii_name="putResize")
    def put_resize(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeResize", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a06aa3fa88008d314a59730a22e8f779e719c9c68f505f6fa20180b8c24c825)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putResize", [value]))

    @jsii.member(jsii_name="putRotate")
    def put_rotate(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRotate", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b76f2be15ade453c729e1ffa414296a164ecf9fc4f6d0970c8ecea3dab9ca2b2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRotate", [value]))

    @jsii.member(jsii_name="putScale")
    def put_scale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeScale", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__66c6ac6625f8fb5f572d0240034a915af842a2064ff8a4c0e6b49abbd1da4c98)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putScale", [value]))

    @jsii.member(jsii_name="putShear")
    def put_shear(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeShear", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a819066b656298f114a2ee2ab46fcfa977b72b28eab1f0771cae026deec7e740)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putShear", [value]))

    @jsii.member(jsii_name="putTrim")
    def put_trim(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeTrim", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d0a383cbd16229475148d1a8f5dc0fd183ea38be1db6b9fdd7288d9fbe34832f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTrim", [value]))

    @jsii.member(jsii_name="putUnsharpMask")
    def put_unsharp_mask(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeUnsharpMask", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0fdbf969cba5675ca0c8c3b0ba6b89df73e6340a56c9384ae7f6b91eaafb83b2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putUnsharpMask", [value]))

    @jsii.member(jsii_name="resetAppend")
    def reset_append(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAppend", []))

    @jsii.member(jsii_name="resetAspectCrop")
    def reset_aspect_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspectCrop", []))

    @jsii.member(jsii_name="resetBackgroundColor")
    def reset_background_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBackgroundColor", []))

    @jsii.member(jsii_name="resetBlur")
    def reset_blur(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBlur", []))

    @jsii.member(jsii_name="resetChromaKey")
    def reset_chroma_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChromaKey", []))

    @jsii.member(jsii_name="resetComposite")
    def reset_composite(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetComposite", []))

    @jsii.member(jsii_name="resetCompound")
    def reset_compound(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCompound", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetCrop")
    def reset_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCrop", []))

    @jsii.member(jsii_name="resetFaceCrop")
    def reset_face_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFaceCrop", []))

    @jsii.member(jsii_name="resetFeatureCrop")
    def reset_feature_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureCrop", []))

    @jsii.member(jsii_name="resetFitAndFill")
    def reset_fit_and_fill(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFitAndFill", []))

    @jsii.member(jsii_name="resetGoop")
    def reset_goop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGoop", []))

    @jsii.member(jsii_name="resetGrayscale")
    def reset_grayscale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGrayscale", []))

    @jsii.member(jsii_name="resetHsl")
    def reset_hsl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsl", []))

    @jsii.member(jsii_name="resetHsv")
    def reset_hsv(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsv", []))

    @jsii.member(jsii_name="resetIfDimension")
    def reset_if_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfDimension", []))

    @jsii.member(jsii_name="resetIfOrientation")
    def reset_if_orientation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfOrientation", []))

    @jsii.member(jsii_name="resetImQuery")
    def reset_im_query(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetImQuery", []))

    @jsii.member(jsii_name="resetMaxColors")
    def reset_max_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxColors", []))

    @jsii.member(jsii_name="resetMirror")
    def reset_mirror(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMirror", []))

    @jsii.member(jsii_name="resetMonoHue")
    def reset_mono_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonoHue", []))

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetRegionOfInterestCrop")
    def reset_region_of_interest_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRegionOfInterestCrop", []))

    @jsii.member(jsii_name="resetRelativeCrop")
    def reset_relative_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRelativeCrop", []))

    @jsii.member(jsii_name="resetRemoveColor")
    def reset_remove_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRemoveColor", []))

    @jsii.member(jsii_name="resetResize")
    def reset_resize(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetResize", []))

    @jsii.member(jsii_name="resetRotate")
    def reset_rotate(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRotate", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetShear")
    def reset_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetShear", []))

    @jsii.member(jsii_name="resetTrim")
    def reset_trim(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTrim", []))

    @jsii.member(jsii_name="resetUnsharpMask")
    def reset_unsharp_mask(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUnsharpMask", []))

    @builtins.property
    @jsii.member(jsii_name="append")
    def append(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeAppendList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeAppendList, jsii.get(self, "append"))

    @builtins.property
    @jsii.member(jsii_name="aspectCrop")
    def aspect_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeAspectCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeAspectCropList, jsii.get(self, "aspectCrop"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColor")
    def background_color(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeBackgroundColorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeBackgroundColorList, jsii.get(self, "backgroundColor"))

    @builtins.property
    @jsii.member(jsii_name="blur")
    def blur(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeBlurList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeBlurList, jsii.get(self, "blur"))

    @builtins.property
    @jsii.member(jsii_name="chromaKey")
    def chroma_key(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeChromaKeyList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeChromaKeyList, jsii.get(self, "chromaKey"))

    @builtins.property
    @jsii.member(jsii_name="composite")
    def composite(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCompositeList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCompositeList, jsii.get(self, "composite"))

    @builtins.property
    @jsii.member(jsii_name="compound")
    def compound(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCompoundList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCompoundList, jsii.get(self, "compound"))

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeContrastList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeContrastList, jsii.get(self, "contrast"))

    @builtins.property
    @jsii.member(jsii_name="crop")
    def crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCropList, jsii.get(self, "crop"))

    @builtins.property
    @jsii.member(jsii_name="faceCrop")
    def face_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeFaceCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeFaceCropList, jsii.get(self, "faceCrop"))

    @builtins.property
    @jsii.member(jsii_name="featureCrop")
    def feature_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeFeatureCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeFeatureCropList, jsii.get(self, "featureCrop"))

    @builtins.property
    @jsii.member(jsii_name="fitAndFill")
    def fit_and_fill(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeFitAndFillList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeFitAndFillList, jsii.get(self, "fitAndFill"))

    @builtins.property
    @jsii.member(jsii_name="goop")
    def goop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeGoopList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeGoopList, jsii.get(self, "goop"))

    @builtins.property
    @jsii.member(jsii_name="grayscale")
    def grayscale(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeGrayscaleList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeGrayscaleList, jsii.get(self, "grayscale"))

    @builtins.property
    @jsii.member(jsii_name="hsl")
    def hsl(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeHslList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeHslList, jsii.get(self, "hsl"))

    @builtins.property
    @jsii.member(jsii_name="hsv")
    def hsv(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeHsvList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeHsvList, jsii.get(self, "hsv"))

    @builtins.property
    @jsii.member(jsii_name="ifDimension")
    def if_dimension(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionList, jsii.get(self, "ifDimension"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientation")
    def if_orientation(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationList, jsii.get(self, "ifOrientation"))

    @builtins.property
    @jsii.member(jsii_name="imQuery")
    def im_query(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeImQueryList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeImQueryList, jsii.get(self, "imQuery"))

    @builtins.property
    @jsii.member(jsii_name="maxColors")
    def max_colors(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeMaxColorsList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeMaxColorsList, jsii.get(self, "maxColors"))

    @builtins.property
    @jsii.member(jsii_name="mirror")
    def mirror(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeMirrorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeMirrorList, jsii.get(self, "mirror"))

    @builtins.property
    @jsii.member(jsii_name="monoHue")
    def mono_hue(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeMonoHueList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeMonoHueList, jsii.get(self, "monoHue"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeOpacityList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeOpacityList, jsii.get(self, "opacity"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestCrop")
    def region_of_interest_crop(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRegionOfInterestCropList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRegionOfInterestCropList", jsii.get(self, "regionOfInterestCrop"))

    @builtins.property
    @jsii.member(jsii_name="relativeCrop")
    def relative_crop(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRelativeCropList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRelativeCropList", jsii.get(self, "relativeCrop"))

    @builtins.property
    @jsii.member(jsii_name="removeColor")
    def remove_color(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRemoveColorList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRemoveColorList", jsii.get(self, "removeColor"))

    @builtins.property
    @jsii.member(jsii_name="resize")
    def resize(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeResizeList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeResizeList", jsii.get(self, "resize"))

    @builtins.property
    @jsii.member(jsii_name="rotate")
    def rotate(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRotateList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRotateList", jsii.get(self, "rotate"))

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeScaleList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeScaleList", jsii.get(self, "scale"))

    @builtins.property
    @jsii.member(jsii_name="shear")
    def shear(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeShearList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeShearList", jsii.get(self, "shear"))

    @builtins.property
    @jsii.member(jsii_name="trim")
    def trim(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeTrimList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeTrimList", jsii.get(self, "trim"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMask")
    def unsharp_mask(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeUnsharpMaskList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeUnsharpMaskList", jsii.get(self, "unsharpMask"))

    @builtins.property
    @jsii.member(jsii_name="appendInput")
    def append_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeAppend]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeAppend]]], jsii.get(self, "appendInput"))

    @builtins.property
    @jsii.member(jsii_name="aspectCropInput")
    def aspect_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeAspectCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeAspectCrop]]], jsii.get(self, "aspectCropInput"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColorInput")
    def background_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeBackgroundColor]]], jsii.get(self, "backgroundColorInput"))

    @builtins.property
    @jsii.member(jsii_name="blurInput")
    def blur_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeBlur]]], jsii.get(self, "blurInput"))

    @builtins.property
    @jsii.member(jsii_name="chromaKeyInput")
    def chroma_key_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeChromaKey]]], jsii.get(self, "chromaKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="compositeInput")
    def composite_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeComposite]]], jsii.get(self, "compositeInput"))

    @builtins.property
    @jsii.member(jsii_name="compoundInput")
    def compound_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCompound]]], jsii.get(self, "compoundInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeContrast]]], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="cropInput")
    def crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCrop]]], jsii.get(self, "cropInput"))

    @builtins.property
    @jsii.member(jsii_name="faceCropInput")
    def face_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeFaceCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeFaceCrop]]], jsii.get(self, "faceCropInput"))

    @builtins.property
    @jsii.member(jsii_name="featureCropInput")
    def feature_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeFeatureCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeFeatureCrop]]], jsii.get(self, "featureCropInput"))

    @builtins.property
    @jsii.member(jsii_name="fitAndFillInput")
    def fit_and_fill_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeFitAndFill]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeFitAndFill]]], jsii.get(self, "fitAndFillInput"))

    @builtins.property
    @jsii.member(jsii_name="goopInput")
    def goop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeGoop]]], jsii.get(self, "goopInput"))

    @builtins.property
    @jsii.member(jsii_name="grayscaleInput")
    def grayscale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeGrayscale]]], jsii.get(self, "grayscaleInput"))

    @builtins.property
    @jsii.member(jsii_name="hslInput")
    def hsl_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeHsl]]], jsii.get(self, "hslInput"))

    @builtins.property
    @jsii.member(jsii_name="hsvInput")
    def hsv_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeHsv]]], jsii.get(self, "hsvInput"))

    @builtins.property
    @jsii.member(jsii_name="ifDimensionInput")
    def if_dimension_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimension]]], jsii.get(self, "ifDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientationInput")
    def if_orientation_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientation]]], jsii.get(self, "ifOrientationInput"))

    @builtins.property
    @jsii.member(jsii_name="imQueryInput")
    def im_query_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeImQuery]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeImQuery]]], jsii.get(self, "imQueryInput"))

    @builtins.property
    @jsii.member(jsii_name="maxColorsInput")
    def max_colors_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeMaxColors]]], jsii.get(self, "maxColorsInput"))

    @builtins.property
    @jsii.member(jsii_name="mirrorInput")
    def mirror_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeMirror]]], jsii.get(self, "mirrorInput"))

    @builtins.property
    @jsii.member(jsii_name="monoHueInput")
    def mono_hue_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeMonoHue]]], jsii.get(self, "monoHueInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeOpacity]]], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestCropInput")
    def region_of_interest_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRegionOfInterestCrop"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRegionOfInterestCrop"]]], jsii.get(self, "regionOfInterestCropInput"))

    @builtins.property
    @jsii.member(jsii_name="relativeCropInput")
    def relative_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRelativeCrop"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRelativeCrop"]]], jsii.get(self, "relativeCropInput"))

    @builtins.property
    @jsii.member(jsii_name="removeColorInput")
    def remove_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRemoveColor"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRemoveColor"]]], jsii.get(self, "removeColorInput"))

    @builtins.property
    @jsii.member(jsii_name="resizeInput")
    def resize_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeResize"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeResize"]]], jsii.get(self, "resizeInput"))

    @builtins.property
    @jsii.member(jsii_name="rotateInput")
    def rotate_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRotate"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRotate"]]], jsii.get(self, "rotateInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeScale"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeScale"]]], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="shearInput")
    def shear_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeShear"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeShear"]]], jsii.get(self, "shearInput"))

    @builtins.property
    @jsii.member(jsii_name="trimInput")
    def trim_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeTrim"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeTrim"]]], jsii.get(self, "trimInput"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMaskInput")
    def unsharp_mask_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeUnsharpMask"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeUnsharpMask"]]], jsii.get(self, "unsharpMaskInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscape], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscape],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d291ed7a78e7333ab84c6d6d1187839c31fb0bd0c55f6a2d027a720232c0c17a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRegionOfInterestCrop",
    jsii_struct_bases=[],
    name_mapping={
        "region_of_interest": "regionOfInterest",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRegionOfInterestCrop:
    def __init__(
        self,
        *,
        region_of_interest: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRegionOfInterestCropRegionOfInterest", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param region_of_interest: region_of_interest block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest DataAkamaiImagingPolicyImage#region_of_interest}
        :param gravity: The placement of the crop area relative to the specified area of interest. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: The placement of the crop area relative to the specified area of interest. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param style: Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(region_of_interest, dict):
            region_of_interest = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRegionOfInterestCropRegionOfInterest(**region_of_interest)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d19b313729c7106fb62fccf0de4c989bcd8c99bb75f904559eab2f1048148e49)
            check_type(argname="argument region_of_interest", value=region_of_interest, expected_type=type_hints["region_of_interest"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "region_of_interest": region_of_interest,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def region_of_interest(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRegionOfInterestCropRegionOfInterest":
        '''region_of_interest block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest DataAkamaiImagingPolicyImage#region_of_interest}
        '''
        result = self._values.get("region_of_interest")
        assert result is not None, "Required property 'region_of_interest' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRegionOfInterestCropRegionOfInterest", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''The placement of the crop area relative to the specified area of interest.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''The placement of the crop area relative to the specified area of interest.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRegionOfInterestCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRegionOfInterestCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRegionOfInterestCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e439214769976fda73953f3301dcea3d3765412a0ef7666f45fad2c0bcb4ff1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRegionOfInterestCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__33f21aa0a482bf490f14db1938aca4f24969589145cfe20ca1d54e87243bb6ef)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRegionOfInterestCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__44e8b0add0acbf5c332fe70a8d378a6797b55a062a99be700606a973e9e28b0f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dc58340484251ee9f8211158d8ffa648b43465eda5944c2b779fe319b6ee31c2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__da0fcc7b5ce0d872a060bcb96df82f64d3f4ba991234637a5a8207d059e791b7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRegionOfInterestCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRegionOfInterestCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRegionOfInterestCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fac1bfbc7819bbbe40028ed6a27b1d06c22e95c14a26ff6080343df12d84e991)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRegionOfInterestCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRegionOfInterestCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__03eb19a972a14091bbf9853d09fcb2be188efff7aab7bbe389f553cc4f4d51d3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putRegionOfInterest")
    def put_region_of_interest(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRegionOfInterestCropRegionOfInterest()

        return typing.cast(None, jsii.invoke(self, "putRegionOfInterest", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterest")
    def region_of_interest(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRegionOfInterestCropRegionOfInterestOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRegionOfInterestCropRegionOfInterestOutputReference", jsii.get(self, "regionOfInterest"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestInput")
    def region_of_interest_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRegionOfInterestCropRegionOfInterest"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRegionOfInterestCropRegionOfInterest"], jsii.get(self, "regionOfInterestInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f0e9611877300bb8f03bf368f0cb7ed4a8bab633d4d9a71cbff3cc9f5d2544e0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6aba9df3cb96b2e6acdeced9c15996407c2baafcb837267a67e6b353b76fa47b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e37d95169a7a16fa5de9cdc41d09be70f7137df9f11d79926834f89e80585fcb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8459071a5c5d39cecd4503520a179f692b23195c3ca2217c8f16b05f1387e139)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ed4338a5c0f3bf70f598d09e2637451db461121e1faa3af499cb93868e0d891)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2b46cb60528de43c7383c9dba466b441781118b655460e97b2fa2d95068bf6ac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4e66b909a0a17d72e75b67bc422f830bbcfc3dcbb1f1c07857a980550d5234b4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__951ce39c25e5a89ca0939befde515abdf08ef24d3cc999d7b8cde934e0fb619f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRegionOfInterestCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRegionOfInterestCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRegionOfInterestCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d2c348d36f558845cea28736dc547626ced178335fb3d8ae28f6f5f372826051)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRegionOfInterestCropRegionOfInterest",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRegionOfInterestCropRegionOfInterest:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRegionOfInterestCropRegionOfInterest(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRegionOfInterestCropRegionOfInterestOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRegionOfInterestCropRegionOfInterestOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__876c9f45e3759808012eb611a38b6c89b51f6321f92a88e048a1697ac80da105)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRegionOfInterestCropRegionOfInterest]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRegionOfInterestCropRegionOfInterest], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRegionOfInterestCropRegionOfInterest],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0dae68ece16834a0cd32e1f31ea2f26d21a78fb7fcd82db3e96fc7242e689a93)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRelativeCrop",
    jsii_struct_bases=[],
    name_mapping={
        "east": "east",
        "east_var": "eastVar",
        "north": "north",
        "north_var": "northVar",
        "south": "south",
        "south_var": "southVar",
        "west": "west",
        "west_var": "westVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRelativeCrop:
    def __init__(
        self,
        *,
        east: typing.Optional[builtins.str] = None,
        east_var: typing.Optional[builtins.str] = None,
        north: typing.Optional[builtins.str] = None,
        north_var: typing.Optional[builtins.str] = None,
        south: typing.Optional[builtins.str] = None,
        south_var: typing.Optional[builtins.str] = None,
        west: typing.Optional[builtins.str] = None,
        west_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param east: The number of pixels to shrink or expand the right side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east DataAkamaiImagingPolicyImage#east}
        :param east_var: The number of pixels to shrink or expand the right side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east_var DataAkamaiImagingPolicyImage#east_var}
        :param north: The number of pixels to shrink or expand the top side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north DataAkamaiImagingPolicyImage#north}
        :param north_var: The number of pixels to shrink or expand the top side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north_var DataAkamaiImagingPolicyImage#north_var}
        :param south: The number of pixels to shrink or expand the bottom side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south DataAkamaiImagingPolicyImage#south}
        :param south_var: The number of pixels to shrink or expand the bottom side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south_var DataAkamaiImagingPolicyImage#south_var}
        :param west: The number of pixels to shrink or expand the left side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west DataAkamaiImagingPolicyImage#west}
        :param west_var: The number of pixels to shrink or expand the left side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west_var DataAkamaiImagingPolicyImage#west_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__63b48e9f91026bd50dd7e12f9f3b29c3b4da420ccd7126e8514760564b0007c7)
            check_type(argname="argument east", value=east, expected_type=type_hints["east"])
            check_type(argname="argument east_var", value=east_var, expected_type=type_hints["east_var"])
            check_type(argname="argument north", value=north, expected_type=type_hints["north"])
            check_type(argname="argument north_var", value=north_var, expected_type=type_hints["north_var"])
            check_type(argname="argument south", value=south, expected_type=type_hints["south"])
            check_type(argname="argument south_var", value=south_var, expected_type=type_hints["south_var"])
            check_type(argname="argument west", value=west, expected_type=type_hints["west"])
            check_type(argname="argument west_var", value=west_var, expected_type=type_hints["west_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if east is not None:
            self._values["east"] = east
        if east_var is not None:
            self._values["east_var"] = east_var
        if north is not None:
            self._values["north"] = north
        if north_var is not None:
            self._values["north_var"] = north_var
        if south is not None:
            self._values["south"] = south
        if south_var is not None:
            self._values["south_var"] = south_var
        if west is not None:
            self._values["west"] = west
        if west_var is not None:
            self._values["west_var"] = west_var

    @builtins.property
    def east(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the right side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east DataAkamaiImagingPolicyImage#east}
        '''
        result = self._values.get("east")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def east_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the right side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east_var DataAkamaiImagingPolicyImage#east_var}
        '''
        result = self._values.get("east_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def north(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the top side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north DataAkamaiImagingPolicyImage#north}
        '''
        result = self._values.get("north")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def north_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the top side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north_var DataAkamaiImagingPolicyImage#north_var}
        '''
        result = self._values.get("north_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def south(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the bottom side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south DataAkamaiImagingPolicyImage#south}
        '''
        result = self._values.get("south")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def south_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the bottom side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south_var DataAkamaiImagingPolicyImage#south_var}
        '''
        result = self._values.get("south_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def west(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the left side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west DataAkamaiImagingPolicyImage#west}
        '''
        result = self._values.get("west")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def west_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the left side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west_var DataAkamaiImagingPolicyImage#west_var}
        '''
        result = self._values.get("west_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRelativeCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRelativeCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRelativeCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__424b4a172385b6cdd57c87b549ca237687f23784f198d56529ebec9c32152e29)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRelativeCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__74b38365b17c6ae883fb64dd5c62b19d77c9c1db8dffcfb522f9bc3267438892)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRelativeCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b93e309305f9944756b245042592a88cf53909cc6d74814d6181ceca5026d250)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f89b5570f582fa7cb098f3bdd51241f57f4ecba925d31afdfd651bde6fff0832)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4e89234d9040c0a8958967686dcac1ce9f8b0e5b12e3ef1d887cae23d8f4da9b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRelativeCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRelativeCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRelativeCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__04ba78c65a87043adac01c8b59cf76bdddbbaaf798f3a2da0a5350c2e3fd61ee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRelativeCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRelativeCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7889a26a129ee2a400f28febacdc773124c04e2d9276a452e47608effec98d03)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetEast")
    def reset_east(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEast", []))

    @jsii.member(jsii_name="resetEastVar")
    def reset_east_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEastVar", []))

    @jsii.member(jsii_name="resetNorth")
    def reset_north(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNorth", []))

    @jsii.member(jsii_name="resetNorthVar")
    def reset_north_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNorthVar", []))

    @jsii.member(jsii_name="resetSouth")
    def reset_south(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSouth", []))

    @jsii.member(jsii_name="resetSouthVar")
    def reset_south_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSouthVar", []))

    @jsii.member(jsii_name="resetWest")
    def reset_west(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWest", []))

    @jsii.member(jsii_name="resetWestVar")
    def reset_west_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWestVar", []))

    @builtins.property
    @jsii.member(jsii_name="eastInput")
    def east_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "eastInput"))

    @builtins.property
    @jsii.member(jsii_name="eastVarInput")
    def east_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "eastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="northInput")
    def north_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "northInput"))

    @builtins.property
    @jsii.member(jsii_name="northVarInput")
    def north_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "northVarInput"))

    @builtins.property
    @jsii.member(jsii_name="southInput")
    def south_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "southInput"))

    @builtins.property
    @jsii.member(jsii_name="southVarInput")
    def south_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "southVarInput"))

    @builtins.property
    @jsii.member(jsii_name="westInput")
    def west_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "westInput"))

    @builtins.property
    @jsii.member(jsii_name="westVarInput")
    def west_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "westVarInput"))

    @builtins.property
    @jsii.member(jsii_name="east")
    def east(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "east"))

    @east.setter
    def east(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d3bf31a1e10786460b4ae882054edd49d89db5d3141fa8c06b7ec95df1fb5620)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "east", value)

    @builtins.property
    @jsii.member(jsii_name="eastVar")
    def east_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "eastVar"))

    @east_var.setter
    def east_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__813b18776886e12aaf59609e140a7c2881c5c0afda42e103961ddd610691d1f1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "eastVar", value)

    @builtins.property
    @jsii.member(jsii_name="north")
    def north(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "north"))

    @north.setter
    def north(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc4e1e85a70e1834c490c1104b3e693b497bcf9e3c87a9919c78efaee2a05336)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "north", value)

    @builtins.property
    @jsii.member(jsii_name="northVar")
    def north_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "northVar"))

    @north_var.setter
    def north_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__847dd962926f25bed1afb9d8a44fb25353aa2e6fc2e726aef9be4e8a76b5eee3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "northVar", value)

    @builtins.property
    @jsii.member(jsii_name="south")
    def south(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "south"))

    @south.setter
    def south(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5a9a23b62497d1ccaecce09f75bb6ec10b7a7a0069d197d9b4033c8700bed1cb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "south", value)

    @builtins.property
    @jsii.member(jsii_name="southVar")
    def south_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "southVar"))

    @south_var.setter
    def south_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f30425674e8efe1ad5da496ec0e87ed20bf4c61c6346eaa80a5ab0da223debb5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "southVar", value)

    @builtins.property
    @jsii.member(jsii_name="west")
    def west(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "west"))

    @west.setter
    def west(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9e559759ad07a86d604977eb0d74ced3ea11b4655aa90788a3ddb1c65091a100)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "west", value)

    @builtins.property
    @jsii.member(jsii_name="westVar")
    def west_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "westVar"))

    @west_var.setter
    def west_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__56e5da182ac56c596f0f338dc83139f0006f6b9b81c61aa34eb5b5c0e6e29c44)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "westVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRelativeCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRelativeCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRelativeCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a9353deecc3c58c84c5734eaf06ecec0080133c3433b776ef2a23f44ba335694)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRemoveColor",
    jsii_struct_bases=[],
    name_mapping={
        "color": "color",
        "color_var": "colorVar",
        "feather": "feather",
        "feather_var": "featherVar",
        "tolerance": "tolerance",
        "tolerance_var": "toleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRemoveColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
        feather: typing.Optional[builtins.str] = None,
        feather_var: typing.Optional[builtins.str] = None,
        tolerance: typing.Optional[builtins.str] = None,
        tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        :param feather: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        :param feather_var: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        :param tolerance: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        :param tolerance_var: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6b16b64339d1fdddc4ce4947b9d8c361758ebddaa24b0f60a76e0949fa2604de)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
            check_type(argname="argument feather", value=feather, expected_type=type_hints["feather"])
            check_type(argname="argument feather_var", value=feather_var, expected_type=type_hints["feather_var"])
            check_type(argname="argument tolerance", value=tolerance, expected_type=type_hints["tolerance"])
            check_type(argname="argument tolerance_var", value=tolerance_var, expected_type=type_hints["tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var
        if feather is not None:
            self._values["feather"] = feather
        if feather_var is not None:
            self._values["feather_var"] = feather_var
        if tolerance is not None:
            self._values["tolerance"] = tolerance
        if tolerance_var is not None:
            self._values["tolerance_var"] = tolerance_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        '''
        result = self._values.get("feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather_var(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        '''
        result = self._values.get("feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        '''
        result = self._values.get("tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance_var(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        result = self._values.get("tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRemoveColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRemoveColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRemoveColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dec0ebd337e7c2ca8d917f3792a241e5117e99e14b9367d0156ecc7bf4369c7b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRemoveColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6457614579da312b1ba8494e50289642c456617d81361aa7d35ecab181980e98)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRemoveColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__26d9f85875bece3b8559bbc4e71f62eb6ea5d22b991b1acd75ded2409632dcfc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f74c95e2b3f376c1f82f374eff87600247daf6ebbcb943d2a5a648ae74b99da)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b4280755a6d85b6aded7050e3b5d0e5199f99eaa1a02b6c6f451e771a139ea11)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRemoveColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRemoveColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRemoveColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__340a27fdd9ff74cf1e4a85aa48e5585f18243b10897683f0684571fc570cbe58)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRemoveColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRemoveColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5b1bc000d3560ff0367cf40f063796647390c436653ea3d11a4bb151958a5fc4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @jsii.member(jsii_name="resetFeather")
    def reset_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeather", []))

    @jsii.member(jsii_name="resetFeatherVar")
    def reset_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatherVar", []))

    @jsii.member(jsii_name="resetTolerance")
    def reset_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTolerance", []))

    @jsii.member(jsii_name="resetToleranceVar")
    def reset_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featherInput")
    def feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherInput"))

    @builtins.property
    @jsii.member(jsii_name="featherVarInput")
    def feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceInput")
    def tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceVarInput")
    def tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__41ad6403b18d1c33d15ed35e121f42191c406d123dea76309434457e95e01c16)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d4064e6572665f124aa33e560b42714c7826903ee5224b1d8f23291c0fb5a117)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="feather")
    def feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "feather"))

    @feather.setter
    def feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__60698623c1dffd3ec50fea41a5fea6f1678c73e8647f7064dda7bacd5669a4dc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "feather", value)

    @builtins.property
    @jsii.member(jsii_name="featherVar")
    def feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featherVar"))

    @feather_var.setter
    def feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__96febee67471235adf6d1181310df424c11af0a560f4e6c6d971f30e340c578b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featherVar", value)

    @builtins.property
    @jsii.member(jsii_name="tolerance")
    def tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tolerance"))

    @tolerance.setter
    def tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dc74ca015c1e35fa2427b18a23f72e698f9028e6e7f5f5d7249ce16eb1171bd6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tolerance", value)

    @builtins.property
    @jsii.member(jsii_name="toleranceVar")
    def tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "toleranceVar"))

    @tolerance_var.setter
    def tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__26c1572c1a9a74711c3ab2a31ac33aa59540c5d673c0b53db4e2f673138c6ce2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "toleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRemoveColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRemoveColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRemoveColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e9a276b3ece32a0f78eee548bff469bc74af9cc26ec24927b23fbf9b5e3a5334)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeResize",
    jsii_struct_bases=[],
    name_mapping={
        "aspect": "aspect",
        "aspect_var": "aspectVar",
        "height": "height",
        "height_var": "heightVar",
        "type": "type",
        "type_var": "typeVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeResize:
    def __init__(
        self,
        *,
        aspect: typing.Optional[builtins.str] = None,
        aspect_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param aspect: Preserves the aspect ratio. Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect DataAkamaiImagingPolicyImage#aspect}
        :param aspect_var: Preserves the aspect ratio. Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_var DataAkamaiImagingPolicyImage#aspect_var}
        :param height: The height to resize the source image to. Must be set if height is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height to resize the source image to. Must be set if height is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param type: Sets constraints for the image resize. Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: Sets constraints for the image resize. Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        :param width: The width to resize the source image to. Must be set if width is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width to resize the source image to. Must be set if width is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d371afc26fdc80a23f4ba7993b15cb21449c6ac246a5e9c92e90da8463eefae6)
            check_type(argname="argument aspect", value=aspect, expected_type=type_hints["aspect"])
            check_type(argname="argument aspect_var", value=aspect_var, expected_type=type_hints["aspect_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if aspect is not None:
            self._values["aspect"] = aspect
        if aspect_var is not None:
            self._values["aspect_var"] = aspect_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def aspect(self) -> typing.Optional[builtins.str]:
        '''Preserves the aspect ratio.

        Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect DataAkamaiImagingPolicyImage#aspect}
        '''
        result = self._values.get("aspect")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def aspect_var(self) -> typing.Optional[builtins.str]:
        '''Preserves the aspect ratio.

        Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_var DataAkamaiImagingPolicyImage#aspect_var}
        '''
        result = self._values.get("aspect_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height to resize the source image to. Must be set if height is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height to resize the source image to. Must be set if height is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''Sets constraints for the image resize.

        Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''Sets constraints for the image resize.

        Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width to resize the source image to. Must be set if width is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width to resize the source image to. Must be set if width is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeResize(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeResizeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeResizeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e45c39da2689f3e80fc6e408f4725e84b0f91deef6d0782b17808e0f95c48d66)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeResizeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0c30a3ac397534d746b3f9f9739cbabf23ae114e5e7b10bee7abf25eb82e49ce)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeResizeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__724d27ded03c8e6681f38f17695f0d4b737b9dce76f0c6dfad9ea6ec47216cb7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1a2e5bb43dc1c8b23615f6d7b690df8b4cd9cccb4da0ea0ae3bef257dfe53a6a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__66c4740c37940df1fcd930d62094c1cfde7c44527a825ed104f5fe6e5315fdf4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeResize]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeResize]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeResize]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__032b2b20140d79f55ac24eae24fb306813ed66771b4dd322717e7ea3e02ca10a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeResizeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeResizeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5491392ca859e16f0b2db95968706a5c3c7c79f2d274323e501b3cb2f1960bac)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAspect")
    def reset_aspect(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspect", []))

    @jsii.member(jsii_name="resetAspectVar")
    def reset_aspect_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspectVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="aspectInput")
    def aspect_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "aspectInput"))

    @builtins.property
    @jsii.member(jsii_name="aspectVarInput")
    def aspect_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "aspectVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="aspect")
    def aspect(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "aspect"))

    @aspect.setter
    def aspect(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__36f01162e672ebf51c1b576ed5fffe864b7fa24e8cbff3014d0daafeaa2c5290)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "aspect", value)

    @builtins.property
    @jsii.member(jsii_name="aspectVar")
    def aspect_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "aspectVar"))

    @aspect_var.setter
    def aspect_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__404598c9ca3ff207effbe79f04cda28e1557a5016f33cb0eef2c2643efa92c06)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "aspectVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9285966f43277a1c3e1287ab788ecd702790c4d7b8e4e3c9532749f878737f63)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3e3a21fdef6324196ae4b2fae397eecaa20dc02713c34621bbf6651814c5fbec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d98a65d224f499457302c6058464ad5a7145795513c765b13ad4f9a84382f2f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__070277b4469eabebfa4a55f425056875b60cd6578ba2d27589780a1aeba7e4be)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f431bd450c75cf7c36ea016f45d4d97c91422d408107e6e29bab9f09bf5cc311)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f93f6120da5231ae64363fe1d2feda250f726e0031d6dc0756d7274b8757dac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeResize]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeResize]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeResize]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9e4aee2f85d7ff0196b42dc8e524ed5e5a68b77cc0dacdb490b08c8f73a45d64)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRotate",
    jsii_struct_bases=[],
    name_mapping={"degrees": "degrees", "degrees_var": "degreesVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRotate:
    def __init__(
        self,
        *,
        degrees: typing.Optional[builtins.str] = None,
        degrees_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param degrees: The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees DataAkamaiImagingPolicyImage#degrees}
        :param degrees_var: The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees_var DataAkamaiImagingPolicyImage#degrees_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__06d6c58b243c15cce5a80d048af5b74f627aa81856cfd75c4ae286fabcc7a5d1)
            check_type(argname="argument degrees", value=degrees, expected_type=type_hints["degrees"])
            check_type(argname="argument degrees_var", value=degrees_var, expected_type=type_hints["degrees_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if degrees is not None:
            self._values["degrees"] = degrees
        if degrees_var is not None:
            self._values["degrees_var"] = degrees_var

    @builtins.property
    def degrees(self) -> typing.Optional[builtins.str]:
        '''The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees DataAkamaiImagingPolicyImage#degrees}
        '''
        result = self._values.get("degrees")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def degrees_var(self) -> typing.Optional[builtins.str]:
        '''The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees_var DataAkamaiImagingPolicyImage#degrees_var}
        '''
        result = self._values.get("degrees_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRotate(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRotateList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRotateList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4b520fd95dec2af9b11fb435a2abf9ca4ed6a5ff3c89346be24e9b5f2e8ed717)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRotateOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4caf7cb8055a4d31ec4c17338eb56194f51b7d790bc3e5b0ca2297581662262b)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRotateOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__599e36e52528e549f1de322a4b05f5c037bcc6b10360cf52f063aae59d972f28)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__876220f8ee4911ae2b5fc8a5ae2bb12e2734f6cbc41fd3ecd89f59848507f62f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__833fcd30a8f2675016395d7581e4e9fb2f4b368fde444abe58f939ebbc181cf2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRotate]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRotate]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRotate]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cab02928c32adc3f2b96d9674b45d1454c3dab6163e0d159968395563a1e7e6f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRotateOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRotateOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ecb9ea3ed019d844652b433f1e3e365f49c2ae8bee8cc15686c800e45c247a4d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetDegrees")
    def reset_degrees(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDegrees", []))

    @jsii.member(jsii_name="resetDegreesVar")
    def reset_degrees_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDegreesVar", []))

    @builtins.property
    @jsii.member(jsii_name="degreesInput")
    def degrees_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "degreesInput"))

    @builtins.property
    @jsii.member(jsii_name="degreesVarInput")
    def degrees_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "degreesVarInput"))

    @builtins.property
    @jsii.member(jsii_name="degrees")
    def degrees(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "degrees"))

    @degrees.setter
    def degrees(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1cf91d585add5bc143576715a922165368918be7bb3c5fc2447216965f583c6a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "degrees", value)

    @builtins.property
    @jsii.member(jsii_name="degreesVar")
    def degrees_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "degreesVar"))

    @degrees_var.setter
    def degrees_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea889c3fa336863c074f39860bd7717d984318ec0daf4cd3a7a3ae3ddcdf1bdd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "degreesVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRotate]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRotate]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRotate]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__92d50e1f1aeb52363732dadb5c3cee3542e3c65baed28a3b8eaf84596d77e635)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeScale",
    jsii_struct_bases=[],
    name_mapping={
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeScale:
    def __init__(
        self,
        *,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param height: Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged. Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged. Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__db525cf1ab92653bb9b406f75ac9b09224edfa174a562b3602ead5621a77d17f)
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size.

        Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size.

        Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged.

        Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged.

        Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeScale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeScaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeScaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__32683bfd1e5b4f3ec4530672a095c713d532b382bebfd55fe14182b2ce5fd12d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeScaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__28cddaefadb14e77bc3fece8f73c6bebac0da060e637c7f1e133c92cb1a56ec8)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeScaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__887f345d1a6c1676fff305fba5ff2455c96902b99b9e75cdd25025426f5b788d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4d7c9679f7e31b32ba74c4727c5761f2e5dde957436cfc32ceb8a2c664bf267c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6ffe0b733c27b28e4fc4aa157e2a9bb0f26a2e58be0338bc0e74b036dfc91afa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeScale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeScale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeScale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__20fe6133ad5a73479c0e406bdc573f717999799d5fc538086a624c12f179bfd2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeScaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeScaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e30bfdda5677ff042531b8d76e875f3977cb8785210303118f1f787f42a8530a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__888b12349a37a447b4ba151c2fbaa2ab0e2bcb6444fc465b2208aa932be52360)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df6ef5491b24f8cee405033f94084025fdf5ddb2a434b3168c91ad27623f3452)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__433fc6aa165f4064c50a65af5728f396e79879f62a917464c25b42a746fbcaab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a237e0521b7d35a631038870a4ac2a8fe90aa82d949493a31e78e02bfe3c0dbf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeScale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeScale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeScale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3faef926b5f4203d03fa4ccf7247aff2792593fd92678958ef111a1a58fc60c7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeShear",
    jsii_struct_bases=[],
    name_mapping={
        "x_shear": "xShear",
        "x_shear_var": "xShearVar",
        "y_shear": "yShear",
        "y_shear_var": "yShearVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeShear:
    def __init__(
        self,
        *,
        x_shear: typing.Optional[builtins.str] = None,
        x_shear_var: typing.Optional[builtins.str] = None,
        y_shear: typing.Optional[builtins.str] = None,
        y_shear_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param x_shear: The amount to shear along the x-axis, measured in multiples of the image's width. Must be set if yShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear DataAkamaiImagingPolicyImage#x_shear}
        :param x_shear_var: The amount to shear along the x-axis, measured in multiples of the image's width. Must be set if yShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear_var DataAkamaiImagingPolicyImage#x_shear_var}
        :param y_shear: The amount to shear along the y-axis, measured in multiples of the image's height. Must be set if xShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear DataAkamaiImagingPolicyImage#y_shear}
        :param y_shear_var: The amount to shear along the y-axis, measured in multiples of the image's height. Must be set if xShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear_var DataAkamaiImagingPolicyImage#y_shear_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6646f32a74ad11e390df8d6f792eefe5d43190e1af555f702dbcba6de9e600b3)
            check_type(argname="argument x_shear", value=x_shear, expected_type=type_hints["x_shear"])
            check_type(argname="argument x_shear_var", value=x_shear_var, expected_type=type_hints["x_shear_var"])
            check_type(argname="argument y_shear", value=y_shear, expected_type=type_hints["y_shear"])
            check_type(argname="argument y_shear_var", value=y_shear_var, expected_type=type_hints["y_shear_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if x_shear is not None:
            self._values["x_shear"] = x_shear
        if x_shear_var is not None:
            self._values["x_shear_var"] = x_shear_var
        if y_shear is not None:
            self._values["y_shear"] = y_shear
        if y_shear_var is not None:
            self._values["y_shear_var"] = y_shear_var

    @builtins.property
    def x_shear(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the x-axis, measured in multiples of the image's width.

        Must be set if yShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear DataAkamaiImagingPolicyImage#x_shear}
        '''
        result = self._values.get("x_shear")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_shear_var(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the x-axis, measured in multiples of the image's width.

        Must be set if yShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear_var DataAkamaiImagingPolicyImage#x_shear_var}
        '''
        result = self._values.get("x_shear_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_shear(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the y-axis, measured in multiples of the image's height.

        Must be set if xShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear DataAkamaiImagingPolicyImage#y_shear}
        '''
        result = self._values.get("y_shear")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_shear_var(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the y-axis, measured in multiples of the image's height.

        Must be set if xShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear_var DataAkamaiImagingPolicyImage#y_shear_var}
        '''
        result = self._values.get("y_shear_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeShear(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeShearList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeShearList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f421c61ad23e9802c81db80234d9ae6541473d0472e89c7244c3f73ceb618b42)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeShearOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__57c6bd955730dbbea8dbc6702fb77ee4a15778d05341c785e5d47d3b2aab0d02)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeShearOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ecd11af24aa45cfc6240e449ed8cb480e2baef9470bd1643eadcb1a923365002)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ff69df0d609ca342d818f97a745fdcd22a13f2cb45fd0cf0fea22183012f0785)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9987dc3b86d64028bb4e14ca774537a28edf5fb6f389ddabec9b4677e8fac99c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeShear]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeShear]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeShear]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4c6c5ada54c7229835fe312b5a61767faa171cee3914c5ac1ae7e203c85b2eac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeShearOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeShearOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fe8f76d000ac21d6751106b547069e641f44cb2e998ad4695f62c1f92b06d617)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetXShear")
    def reset_x_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXShear", []))

    @jsii.member(jsii_name="resetXShearVar")
    def reset_x_shear_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXShearVar", []))

    @jsii.member(jsii_name="resetYShear")
    def reset_y_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYShear", []))

    @jsii.member(jsii_name="resetYShearVar")
    def reset_y_shear_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYShearVar", []))

    @builtins.property
    @jsii.member(jsii_name="xShearInput")
    def x_shear_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xShearInput"))

    @builtins.property
    @jsii.member(jsii_name="xShearVarInput")
    def x_shear_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xShearVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yShearInput")
    def y_shear_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yShearInput"))

    @builtins.property
    @jsii.member(jsii_name="yShearVarInput")
    def y_shear_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yShearVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xShear")
    def x_shear(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xShear"))

    @x_shear.setter
    def x_shear(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__43219a8b83b893bb4b1d26f331c5ef3bdff459b1d3b69f68a20dd5613a5e459c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xShear", value)

    @builtins.property
    @jsii.member(jsii_name="xShearVar")
    def x_shear_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xShearVar"))

    @x_shear_var.setter
    def x_shear_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__581c303a63ca72b17b734eb52c438d5437a4f05b5b7673bc28d820df5abae11b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xShearVar", value)

    @builtins.property
    @jsii.member(jsii_name="yShear")
    def y_shear(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yShear"))

    @y_shear.setter
    def y_shear(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7e27edea8adc5c3ed828b303c75af9bc9a86fef7ff44c841e5a4dbeca16c562c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yShear", value)

    @builtins.property
    @jsii.member(jsii_name="yShearVar")
    def y_shear_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yShearVar"))

    @y_shear_var.setter
    def y_shear_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__91580b17e73716eb5a233defc7d508ffd0a57a08b99eaad86bdc516600eb079a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yShearVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeShear]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeShear]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeShear]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c3dfaf0ca6addd5d4a60c65f3d51690fe042ccf047a98d63f44a421122ddaa5a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeTrim",
    jsii_struct_bases=[],
    name_mapping={
        "fuzz": "fuzz",
        "fuzz_var": "fuzzVar",
        "padding": "padding",
        "padding_var": "paddingVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeTrim:
    def __init__(
        self,
        *,
        fuzz: typing.Optional[builtins.str] = None,
        fuzz_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fuzz: The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz DataAkamaiImagingPolicyImage#fuzz}
        :param fuzz_var: The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz_var DataAkamaiImagingPolicyImage#fuzz_var}
        :param padding: The amount of padding in pixels to add to the trimmed image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: The amount of padding in pixels to add to the trimmed image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__487d2506244a38abb9be0703218899f8baad950bb51e2c5200d66de4339da30a)
            check_type(argname="argument fuzz", value=fuzz, expected_type=type_hints["fuzz"])
            check_type(argname="argument fuzz_var", value=fuzz_var, expected_type=type_hints["fuzz_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fuzz is not None:
            self._values["fuzz"] = fuzz
        if fuzz_var is not None:
            self._values["fuzz_var"] = fuzz_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var

    @builtins.property
    def fuzz(self) -> typing.Optional[builtins.str]:
        '''The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz DataAkamaiImagingPolicyImage#fuzz}
        '''
        result = self._values.get("fuzz")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fuzz_var(self) -> typing.Optional[builtins.str]:
        '''The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz_var DataAkamaiImagingPolicyImage#fuzz_var}
        '''
        result = self._values.get("fuzz_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''The amount of padding in pixels to add to the trimmed image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''The amount of padding in pixels to add to the trimmed image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeTrim(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeTrimList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeTrimList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0301e15f6155cc1cbf52241a27314cfc8dfdd175fbf6795dabd99691d41df6ad)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeTrimOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b9c8a1e4833ba35437c93b7ac722abf0f861a7bc7e9c7c654434173a9f6846b8)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeTrimOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__550c3962d70fc3a2ef098e9267e5731111079483dfe7a9cd1316558edd57082f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__93f039c55be0853fa4fdb95df9591a625da0969353dc199d2a1718002989c8b2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b6f64a9566d685a33dc79704e6b13ec2647833db3115bd5d3140cef19731fe63)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeTrim]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeTrim]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeTrim]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b6d0f9622c942f32c0c56ce2eee3c1623fee608f04cf858b7dc29cacb6642e42)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeTrimOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeTrimOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0bd8fbc5dfac450008adc5a84905c9266de7dbf864e9844d93baea460084a9ac)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetFuzz")
    def reset_fuzz(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFuzz", []))

    @jsii.member(jsii_name="resetFuzzVar")
    def reset_fuzz_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFuzzVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @builtins.property
    @jsii.member(jsii_name="fuzzInput")
    def fuzz_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fuzzInput"))

    @builtins.property
    @jsii.member(jsii_name="fuzzVarInput")
    def fuzz_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fuzzVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="fuzz")
    def fuzz(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fuzz"))

    @fuzz.setter
    def fuzz(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__49f010a27d95e2fcf4be1a96eb0775a045ba301bed5ad18bb2b37f122ca2c6ea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fuzz", value)

    @builtins.property
    @jsii.member(jsii_name="fuzzVar")
    def fuzz_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fuzzVar"))

    @fuzz_var.setter
    def fuzz_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d65d4f90a6fb5c651e2e582aef96580aeb033bb5ea03f9427cd9bbf99a78b251)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fuzzVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a30e7521a4d7caf1f8205c96de304a0a1ea25b197eb5522e23036bcdb7bdb95)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fccdfc078ecd766bd7dc326140d6c0e3736ed2b70bcfb5bae094cd0bacf00324)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeTrim]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeTrim]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeTrim]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d7531010d1c32b72b21e9ccee4451e045f2ac05a6e142f5d46e45c5292280a17)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeUnsharpMask",
    jsii_struct_bases=[],
    name_mapping={
        "gain": "gain",
        "gain_var": "gainVar",
        "sigma": "sigma",
        "sigma_var": "sigmaVar",
        "threshold": "threshold",
        "threshold_var": "thresholdVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeUnsharpMask:
    def __init__(
        self,
        *,
        gain: typing.Optional[builtins.str] = None,
        gain_var: typing.Optional[builtins.str] = None,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
        threshold: typing.Optional[builtins.str] = None,
        threshold_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param gain: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        :param gain_var: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        :param sigma: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        :param threshold: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        :param threshold_var: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__94047b6fd5332a6be91069a48f74475dd1e5c8f3eb4b489ba8d1a8e8f8ed62ec)
            check_type(argname="argument gain", value=gain, expected_type=type_hints["gain"])
            check_type(argname="argument gain_var", value=gain_var, expected_type=type_hints["gain_var"])
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
            check_type(argname="argument threshold", value=threshold, expected_type=type_hints["threshold"])
            check_type(argname="argument threshold_var", value=threshold_var, expected_type=type_hints["threshold_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if gain is not None:
            self._values["gain"] = gain
        if gain_var is not None:
            self._values["gain_var"] = gain_var
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var
        if threshold is not None:
            self._values["threshold"] = threshold
        if threshold_var is not None:
            self._values["threshold_var"] = threshold_var

    @builtins.property
    def gain(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        '''
        result = self._values.get("gain")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gain_var(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        '''
        result = self._values.get("gain_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        '''
        result = self._values.get("threshold")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold_var(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        result = self._values.get("threshold_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeUnsharpMask(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeUnsharpMaskList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeUnsharpMaskList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__912ebd51e05a33fa4d34946ebd4578334d0a91ae013ca6018845d602450be5be)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeUnsharpMaskOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9de9a660cb1e0d2ef522eb33b97851ab3c546d39244efdc569a58d08b40a4d8f)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeUnsharpMaskOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__529196f05959a93373321c60ac1f9d73b6ef386180f18096cbfc51ce4c689209)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a05048b59c87bb522ff3828fa2460854d79dd75d1e9a088f09ef32dd1e8cd842)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__afb9bdb2c2bf065cc30c307163236bbcecce07c8ac60f497e0ab8334936d9bdb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeUnsharpMask]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeUnsharpMask]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeUnsharpMask]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__251fee15e4f2120da2b2ed39eda0f31792a4a8c27e329bdbcf4d9d3231b93915)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeUnsharpMaskOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeUnsharpMaskOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__68353786b7006f42bf8d6f086761762504434f47a52d1e8524017438e44fc248)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetGain")
    def reset_gain(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGain", []))

    @jsii.member(jsii_name="resetGainVar")
    def reset_gain_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGainVar", []))

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @jsii.member(jsii_name="resetThreshold")
    def reset_threshold(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThreshold", []))

    @jsii.member(jsii_name="resetThresholdVar")
    def reset_threshold_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThresholdVar", []))

    @builtins.property
    @jsii.member(jsii_name="gainInput")
    def gain_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainInput"))

    @builtins.property
    @jsii.member(jsii_name="gainVarInput")
    def gain_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdInput")
    def threshold_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdVarInput")
    def threshold_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gain")
    def gain(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gain"))

    @gain.setter
    def gain(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b373e2160580bd200c27503068be69357667c41a581864a905285fd0b416c6b0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gain", value)

    @builtins.property
    @jsii.member(jsii_name="gainVar")
    def gain_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gainVar"))

    @gain_var.setter
    def gain_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1619d815618255e9649538b65f585ed10acb827ef335cb5b74b8f04acbddc5a4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gainVar", value)

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f846201ba4d621033747b74999577b4e46470c5fc8141c886d9c5985afc37a6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be2c53e2b07d3848dd3baed6d676712aba65d146b65c8209abc5b6e8ae415a9c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="threshold")
    def threshold(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "threshold"))

    @threshold.setter
    def threshold(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4baf0706174fe96c20231ae581745697e18a780c8b3ca0ef2c810b4c94309d0b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "threshold", value)

    @builtins.property
    @jsii.member(jsii_name="thresholdVar")
    def threshold_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "thresholdVar"))

    @threshold_var.setter
    def threshold_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ff1a667366cf1fcbd75f06d3a2eacb7558d5a8a81a4fff2aa285f73eaa2c451c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "thresholdVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeUnsharpMask]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeUnsharpMask]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeUnsharpMask]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__800cada0d6952754a7f779d0c89c6b9e3a3518d77d4f053498435dcc84857b6e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__db55b7dc2f7f4335ba250bb27749526513b9145aafc7f15c749c4733f74db324)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__54df2cab5ef352a1d48ab13a7b5e708f0d3939ec96d063dc91b5dcefb944c560)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4d2a9110d522c4db4d5e39186f2804cf6b32bf8e06b5f55374eeb6888b659e9a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7e047e868010723cacf5d69f1f731e0d38cc83e340a832ffdbdf1bfedf1f78de)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__422e27f74a2b96cc2cbd00705535269d606ecea3c16df61e1b698d3a7d0a3c42)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientation]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientation]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2bee49c387a5e5ed2ab6cb6c952d1d4a7c5a035850ad427172b22f8190b5efea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a4bda6a7d6a34a01f08275169cf882cdec1bde00f4f29a3bbc32b6bfdf5f88a8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(
        self,
        *,
        append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultAppend, typing.Dict[builtins.str, typing.Any]]]]] = None,
        aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultAspectCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
        crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultFaceCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultFeatureCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultFitAndFill, typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
        im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultImQuery, typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
        region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRegionOfInterestCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRelativeCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
        resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultResize, typing.Dict[builtins.str, typing.Any]]]]] = None,
        rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRotate, typing.Dict[builtins.str, typing.Any]]]]] = None,
        scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultScale, typing.Dict[builtins.str, typing.Any]]]]] = None,
        shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultShear, typing.Dict[builtins.str, typing.Any]]]]] = None,
        trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultTrim, typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param append: append block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        :param aspect_crop: aspect_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param crop: crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        :param face_crop: face_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        :param feature_crop: feature_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        :param fit_and_fill: fit_and_fill block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param im_query: im_query block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param region_of_interest_crop: region_of_interest_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        :param relative_crop: relative_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param resize: resize block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        :param rotate: rotate block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        :param scale: scale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param shear: shear block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        :param trim: trim block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefault(
            append=append,
            aspect_crop=aspect_crop,
            background_color=background_color,
            blur=blur,
            chroma_key=chroma_key,
            composite=composite,
            compound=compound,
            contrast=contrast,
            crop=crop,
            face_crop=face_crop,
            feature_crop=feature_crop,
            fit_and_fill=fit_and_fill,
            goop=goop,
            grayscale=grayscale,
            hsl=hsl,
            hsv=hsv,
            if_dimension=if_dimension,
            if_orientation=if_orientation,
            im_query=im_query,
            max_colors=max_colors,
            mirror=mirror,
            mono_hue=mono_hue,
            opacity=opacity,
            region_of_interest_crop=region_of_interest_crop,
            relative_crop=relative_crop,
            remove_color=remove_color,
            resize=resize,
            rotate=rotate,
            scale=scale,
            shear=shear,
            trim=trim,
            unsharp_mask=unsharp_mask,
        )

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putLandscape")
    def put_landscape(
        self,
        *,
        append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeAppend, typing.Dict[builtins.str, typing.Any]]]]] = None,
        aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeAspectCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
        crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeFaceCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeFeatureCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeFitAndFill, typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
        im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeImQuery, typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
        region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRegionOfInterestCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRelativeCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
        resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeResize, typing.Dict[builtins.str, typing.Any]]]]] = None,
        rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRotate, typing.Dict[builtins.str, typing.Any]]]]] = None,
        scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeScale, typing.Dict[builtins.str, typing.Any]]]]] = None,
        shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeShear, typing.Dict[builtins.str, typing.Any]]]]] = None,
        trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeTrim, typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param append: append block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        :param aspect_crop: aspect_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param crop: crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        :param face_crop: face_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        :param feature_crop: feature_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        :param fit_and_fill: fit_and_fill block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param im_query: im_query block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param region_of_interest_crop: region_of_interest_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        :param relative_crop: relative_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param resize: resize block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        :param rotate: rotate block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        :param scale: scale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param shear: shear block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        :param trim: trim block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscape(
            append=append,
            aspect_crop=aspect_crop,
            background_color=background_color,
            blur=blur,
            chroma_key=chroma_key,
            composite=composite,
            compound=compound,
            contrast=contrast,
            crop=crop,
            face_crop=face_crop,
            feature_crop=feature_crop,
            fit_and_fill=fit_and_fill,
            goop=goop,
            grayscale=grayscale,
            hsl=hsl,
            hsv=hsv,
            if_dimension=if_dimension,
            if_orientation=if_orientation,
            im_query=im_query,
            max_colors=max_colors,
            mirror=mirror,
            mono_hue=mono_hue,
            opacity=opacity,
            region_of_interest_crop=region_of_interest_crop,
            relative_crop=relative_crop,
            remove_color=remove_color,
            resize=resize,
            rotate=rotate,
            scale=scale,
            shear=shear,
            trim=trim,
            unsharp_mask=unsharp_mask,
        )

        return typing.cast(None, jsii.invoke(self, "putLandscape", [value]))

    @jsii.member(jsii_name="putPortrait")
    def put_portrait(
        self,
        *,
        append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitAppend", typing.Dict[builtins.str, typing.Any]]]]] = None,
        aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitAspectCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitBackgroundColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitBlur", typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitChromaKey", typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitComposite", typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitCompound", typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitContrast", typing.Dict[builtins.str, typing.Any]]]]] = None,
        crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitFaceCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitFeatureCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitFitAndFill", typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitGoop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitGrayscale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitHsl", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitHsv", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfDimension", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientation", typing.Dict[builtins.str, typing.Any]]]]] = None,
        im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitImQuery", typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitMaxColors", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitMirror", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitMonoHue", typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitOpacity", typing.Dict[builtins.str, typing.Any]]]]] = None,
        region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitRegionOfInterestCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitRelativeCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitRemoveColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitResize", typing.Dict[builtins.str, typing.Any]]]]] = None,
        rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitRotate", typing.Dict[builtins.str, typing.Any]]]]] = None,
        scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitScale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitShear", typing.Dict[builtins.str, typing.Any]]]]] = None,
        trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitTrim", typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitUnsharpMask", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param append: append block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        :param aspect_crop: aspect_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param crop: crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        :param face_crop: face_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        :param feature_crop: feature_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        :param fit_and_fill: fit_and_fill block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param im_query: im_query block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param region_of_interest_crop: region_of_interest_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        :param relative_crop: relative_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param resize: resize block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        :param rotate: rotate block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        :param scale: scale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param shear: shear block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        :param trim: trim block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortrait(
            append=append,
            aspect_crop=aspect_crop,
            background_color=background_color,
            blur=blur,
            chroma_key=chroma_key,
            composite=composite,
            compound=compound,
            contrast=contrast,
            crop=crop,
            face_crop=face_crop,
            feature_crop=feature_crop,
            fit_and_fill=fit_and_fill,
            goop=goop,
            grayscale=grayscale,
            hsl=hsl,
            hsv=hsv,
            if_dimension=if_dimension,
            if_orientation=if_orientation,
            im_query=im_query,
            max_colors=max_colors,
            mirror=mirror,
            mono_hue=mono_hue,
            opacity=opacity,
            region_of_interest_crop=region_of_interest_crop,
            relative_crop=relative_crop,
            remove_color=remove_color,
            resize=resize,
            rotate=rotate,
            scale=scale,
            shear=shear,
            trim=trim,
            unsharp_mask=unsharp_mask,
        )

        return typing.cast(None, jsii.invoke(self, "putPortrait", [value]))

    @jsii.member(jsii_name="putSquare")
    def put_square(
        self,
        *,
        append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareAppend", typing.Dict[builtins.str, typing.Any]]]]] = None,
        aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareAspectCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareBackgroundColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareBlur", typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareChromaKey", typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareComposite", typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareCompound", typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareContrast", typing.Dict[builtins.str, typing.Any]]]]] = None,
        crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareFaceCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareFeatureCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareFitAndFill", typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareGoop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareGrayscale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareHsl", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareHsv", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfDimension", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfOrientation", typing.Dict[builtins.str, typing.Any]]]]] = None,
        im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareImQuery", typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareMaxColors", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareMirror", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareMonoHue", typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareOpacity", typing.Dict[builtins.str, typing.Any]]]]] = None,
        region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareRegionOfInterestCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareRelativeCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareRemoveColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareResize", typing.Dict[builtins.str, typing.Any]]]]] = None,
        rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareRotate", typing.Dict[builtins.str, typing.Any]]]]] = None,
        scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareScale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareShear", typing.Dict[builtins.str, typing.Any]]]]] = None,
        trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareTrim", typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareUnsharpMask", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param append: append block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        :param aspect_crop: aspect_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param crop: crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        :param face_crop: face_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        :param feature_crop: feature_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        :param fit_and_fill: fit_and_fill block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param im_query: im_query block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param region_of_interest_crop: region_of_interest_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        :param relative_crop: relative_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param resize: resize block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        :param rotate: rotate block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        :param scale: scale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param shear: shear block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        :param trim: trim block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquare(
            append=append,
            aspect_crop=aspect_crop,
            background_color=background_color,
            blur=blur,
            chroma_key=chroma_key,
            composite=composite,
            compound=compound,
            contrast=contrast,
            crop=crop,
            face_crop=face_crop,
            feature_crop=feature_crop,
            fit_and_fill=fit_and_fill,
            goop=goop,
            grayscale=grayscale,
            hsl=hsl,
            hsv=hsv,
            if_dimension=if_dimension,
            if_orientation=if_orientation,
            im_query=im_query,
            max_colors=max_colors,
            mirror=mirror,
            mono_hue=mono_hue,
            opacity=opacity,
            region_of_interest_crop=region_of_interest_crop,
            relative_crop=relative_crop,
            remove_color=remove_color,
            resize=resize,
            rotate=rotate,
            scale=scale,
            shear=shear,
            trim=trim,
            unsharp_mask=unsharp_mask,
        )

        return typing.cast(None, jsii.invoke(self, "putSquare", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetLandscape")
    def reset_landscape(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLandscape", []))

    @jsii.member(jsii_name="resetPortrait")
    def reset_portrait(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPortrait", []))

    @jsii.member(jsii_name="resetSquare")
    def reset_square(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSquare", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="landscape")
    def landscape(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeOutputReference, jsii.get(self, "landscape"))

    @builtins.property
    @jsii.member(jsii_name="portrait")
    def portrait(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitOutputReference", jsii.get(self, "portrait"))

    @builtins.property
    @jsii.member(jsii_name="square")
    def square(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareOutputReference", jsii.get(self, "square"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="landscapeInput")
    def landscape_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscape], jsii.get(self, "landscapeInput"))

    @builtins.property
    @jsii.member(jsii_name="portraitInput")
    def portrait_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortrait"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortrait"], jsii.get(self, "portraitInput"))

    @builtins.property
    @jsii.member(jsii_name="squareInput")
    def square_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquare"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquare"], jsii.get(self, "squareInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientation]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientation]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientation]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d7d899e267dd0f288522914558d857ecef750dcb68704275d5165b4f35fa2c7a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortrait",
    jsii_struct_bases=[],
    name_mapping={
        "append": "append",
        "aspect_crop": "aspectCrop",
        "background_color": "backgroundColor",
        "blur": "blur",
        "chroma_key": "chromaKey",
        "composite": "composite",
        "compound": "compound",
        "contrast": "contrast",
        "crop": "crop",
        "face_crop": "faceCrop",
        "feature_crop": "featureCrop",
        "fit_and_fill": "fitAndFill",
        "goop": "goop",
        "grayscale": "grayscale",
        "hsl": "hsl",
        "hsv": "hsv",
        "if_dimension": "ifDimension",
        "if_orientation": "ifOrientation",
        "im_query": "imQuery",
        "max_colors": "maxColors",
        "mirror": "mirror",
        "mono_hue": "monoHue",
        "opacity": "opacity",
        "region_of_interest_crop": "regionOfInterestCrop",
        "relative_crop": "relativeCrop",
        "remove_color": "removeColor",
        "resize": "resize",
        "rotate": "rotate",
        "scale": "scale",
        "shear": "shear",
        "trim": "trim",
        "unsharp_mask": "unsharpMask",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortrait:
    def __init__(
        self,
        *,
        append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitAppend", typing.Dict[builtins.str, typing.Any]]]]] = None,
        aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitAspectCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitBackgroundColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitBlur", typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitChromaKey", typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitComposite", typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitCompound", typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitContrast", typing.Dict[builtins.str, typing.Any]]]]] = None,
        crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitFaceCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitFeatureCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitFitAndFill", typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitGoop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitGrayscale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitHsl", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitHsv", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfDimension", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientation", typing.Dict[builtins.str, typing.Any]]]]] = None,
        im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitImQuery", typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitMaxColors", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitMirror", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitMonoHue", typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitOpacity", typing.Dict[builtins.str, typing.Any]]]]] = None,
        region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitRegionOfInterestCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitRelativeCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitRemoveColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitResize", typing.Dict[builtins.str, typing.Any]]]]] = None,
        rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitRotate", typing.Dict[builtins.str, typing.Any]]]]] = None,
        scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitScale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitShear", typing.Dict[builtins.str, typing.Any]]]]] = None,
        trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitTrim", typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitUnsharpMask", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param append: append block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        :param aspect_crop: aspect_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param crop: crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        :param face_crop: face_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        :param feature_crop: feature_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        :param fit_and_fill: fit_and_fill block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param im_query: im_query block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param region_of_interest_crop: region_of_interest_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        :param relative_crop: relative_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param resize: resize block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        :param rotate: rotate block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        :param scale: scale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param shear: shear block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        :param trim: trim block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1dd96070ffc5e5977c32500b45ff9e2de2f4c535e86abb3a8453755f0d978193)
            check_type(argname="argument append", value=append, expected_type=type_hints["append"])
            check_type(argname="argument aspect_crop", value=aspect_crop, expected_type=type_hints["aspect_crop"])
            check_type(argname="argument background_color", value=background_color, expected_type=type_hints["background_color"])
            check_type(argname="argument blur", value=blur, expected_type=type_hints["blur"])
            check_type(argname="argument chroma_key", value=chroma_key, expected_type=type_hints["chroma_key"])
            check_type(argname="argument composite", value=composite, expected_type=type_hints["composite"])
            check_type(argname="argument compound", value=compound, expected_type=type_hints["compound"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument crop", value=crop, expected_type=type_hints["crop"])
            check_type(argname="argument face_crop", value=face_crop, expected_type=type_hints["face_crop"])
            check_type(argname="argument feature_crop", value=feature_crop, expected_type=type_hints["feature_crop"])
            check_type(argname="argument fit_and_fill", value=fit_and_fill, expected_type=type_hints["fit_and_fill"])
            check_type(argname="argument goop", value=goop, expected_type=type_hints["goop"])
            check_type(argname="argument grayscale", value=grayscale, expected_type=type_hints["grayscale"])
            check_type(argname="argument hsl", value=hsl, expected_type=type_hints["hsl"])
            check_type(argname="argument hsv", value=hsv, expected_type=type_hints["hsv"])
            check_type(argname="argument if_dimension", value=if_dimension, expected_type=type_hints["if_dimension"])
            check_type(argname="argument if_orientation", value=if_orientation, expected_type=type_hints["if_orientation"])
            check_type(argname="argument im_query", value=im_query, expected_type=type_hints["im_query"])
            check_type(argname="argument max_colors", value=max_colors, expected_type=type_hints["max_colors"])
            check_type(argname="argument mirror", value=mirror, expected_type=type_hints["mirror"])
            check_type(argname="argument mono_hue", value=mono_hue, expected_type=type_hints["mono_hue"])
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument region_of_interest_crop", value=region_of_interest_crop, expected_type=type_hints["region_of_interest_crop"])
            check_type(argname="argument relative_crop", value=relative_crop, expected_type=type_hints["relative_crop"])
            check_type(argname="argument remove_color", value=remove_color, expected_type=type_hints["remove_color"])
            check_type(argname="argument resize", value=resize, expected_type=type_hints["resize"])
            check_type(argname="argument rotate", value=rotate, expected_type=type_hints["rotate"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument shear", value=shear, expected_type=type_hints["shear"])
            check_type(argname="argument trim", value=trim, expected_type=type_hints["trim"])
            check_type(argname="argument unsharp_mask", value=unsharp_mask, expected_type=type_hints["unsharp_mask"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if append is not None:
            self._values["append"] = append
        if aspect_crop is not None:
            self._values["aspect_crop"] = aspect_crop
        if background_color is not None:
            self._values["background_color"] = background_color
        if blur is not None:
            self._values["blur"] = blur
        if chroma_key is not None:
            self._values["chroma_key"] = chroma_key
        if composite is not None:
            self._values["composite"] = composite
        if compound is not None:
            self._values["compound"] = compound
        if contrast is not None:
            self._values["contrast"] = contrast
        if crop is not None:
            self._values["crop"] = crop
        if face_crop is not None:
            self._values["face_crop"] = face_crop
        if feature_crop is not None:
            self._values["feature_crop"] = feature_crop
        if fit_and_fill is not None:
            self._values["fit_and_fill"] = fit_and_fill
        if goop is not None:
            self._values["goop"] = goop
        if grayscale is not None:
            self._values["grayscale"] = grayscale
        if hsl is not None:
            self._values["hsl"] = hsl
        if hsv is not None:
            self._values["hsv"] = hsv
        if if_dimension is not None:
            self._values["if_dimension"] = if_dimension
        if if_orientation is not None:
            self._values["if_orientation"] = if_orientation
        if im_query is not None:
            self._values["im_query"] = im_query
        if max_colors is not None:
            self._values["max_colors"] = max_colors
        if mirror is not None:
            self._values["mirror"] = mirror
        if mono_hue is not None:
            self._values["mono_hue"] = mono_hue
        if opacity is not None:
            self._values["opacity"] = opacity
        if region_of_interest_crop is not None:
            self._values["region_of_interest_crop"] = region_of_interest_crop
        if relative_crop is not None:
            self._values["relative_crop"] = relative_crop
        if remove_color is not None:
            self._values["remove_color"] = remove_color
        if resize is not None:
            self._values["resize"] = resize
        if rotate is not None:
            self._values["rotate"] = rotate
        if scale is not None:
            self._values["scale"] = scale
        if shear is not None:
            self._values["shear"] = shear
        if trim is not None:
            self._values["trim"] = trim
        if unsharp_mask is not None:
            self._values["unsharp_mask"] = unsharp_mask

    @builtins.property
    def append(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitAppend"]]]:
        '''append block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        '''
        result = self._values.get("append")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitAppend"]]], result)

    @builtins.property
    def aspect_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitAspectCrop"]]]:
        '''aspect_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        '''
        result = self._values.get("aspect_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitAspectCrop"]]], result)

    @builtins.property
    def background_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitBackgroundColor"]]]:
        '''background_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        '''
        result = self._values.get("background_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitBackgroundColor"]]], result)

    @builtins.property
    def blur(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitBlur"]]]:
        '''blur block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        '''
        result = self._values.get("blur")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitBlur"]]], result)

    @builtins.property
    def chroma_key(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitChromaKey"]]]:
        '''chroma_key block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        '''
        result = self._values.get("chroma_key")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitChromaKey"]]], result)

    @builtins.property
    def composite(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitComposite"]]]:
        '''composite block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        '''
        result = self._values.get("composite")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitComposite"]]], result)

    @builtins.property
    def compound(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitCompound"]]]:
        '''compound block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        '''
        result = self._values.get("compound")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitCompound"]]], result)

    @builtins.property
    def contrast(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitContrast"]]]:
        '''contrast block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitContrast"]]], result)

    @builtins.property
    def crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitCrop"]]]:
        '''crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        '''
        result = self._values.get("crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitCrop"]]], result)

    @builtins.property
    def face_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitFaceCrop"]]]:
        '''face_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        '''
        result = self._values.get("face_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitFaceCrop"]]], result)

    @builtins.property
    def feature_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitFeatureCrop"]]]:
        '''feature_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        '''
        result = self._values.get("feature_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitFeatureCrop"]]], result)

    @builtins.property
    def fit_and_fill(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitFitAndFill"]]]:
        '''fit_and_fill block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        '''
        result = self._values.get("fit_and_fill")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitFitAndFill"]]], result)

    @builtins.property
    def goop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitGoop"]]]:
        '''goop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        '''
        result = self._values.get("goop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitGoop"]]], result)

    @builtins.property
    def grayscale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitGrayscale"]]]:
        '''grayscale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        '''
        result = self._values.get("grayscale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitGrayscale"]]], result)

    @builtins.property
    def hsl(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitHsl"]]]:
        '''hsl block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        '''
        result = self._values.get("hsl")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitHsl"]]], result)

    @builtins.property
    def hsv(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitHsv"]]]:
        '''hsv block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        '''
        result = self._values.get("hsv")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitHsv"]]], result)

    @builtins.property
    def if_dimension(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfDimension"]]]:
        '''if_dimension block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        '''
        result = self._values.get("if_dimension")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfDimension"]]], result)

    @builtins.property
    def if_orientation(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientation"]]]:
        '''if_orientation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        '''
        result = self._values.get("if_orientation")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientation"]]], result)

    @builtins.property
    def im_query(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitImQuery"]]]:
        '''im_query block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        '''
        result = self._values.get("im_query")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitImQuery"]]], result)

    @builtins.property
    def max_colors(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitMaxColors"]]]:
        '''max_colors block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        '''
        result = self._values.get("max_colors")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitMaxColors"]]], result)

    @builtins.property
    def mirror(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitMirror"]]]:
        '''mirror block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        '''
        result = self._values.get("mirror")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitMirror"]]], result)

    @builtins.property
    def mono_hue(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitMonoHue"]]]:
        '''mono_hue block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        '''
        result = self._values.get("mono_hue")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitMonoHue"]]], result)

    @builtins.property
    def opacity(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitOpacity"]]]:
        '''opacity block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitOpacity"]]], result)

    @builtins.property
    def region_of_interest_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitRegionOfInterestCrop"]]]:
        '''region_of_interest_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        '''
        result = self._values.get("region_of_interest_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitRegionOfInterestCrop"]]], result)

    @builtins.property
    def relative_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitRelativeCrop"]]]:
        '''relative_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        '''
        result = self._values.get("relative_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitRelativeCrop"]]], result)

    @builtins.property
    def remove_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitRemoveColor"]]]:
        '''remove_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        '''
        result = self._values.get("remove_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitRemoveColor"]]], result)

    @builtins.property
    def resize(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitResize"]]]:
        '''resize block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        '''
        result = self._values.get("resize")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitResize"]]], result)

    @builtins.property
    def rotate(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitRotate"]]]:
        '''rotate block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        '''
        result = self._values.get("rotate")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitRotate"]]], result)

    @builtins.property
    def scale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitScale"]]]:
        '''scale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitScale"]]], result)

    @builtins.property
    def shear(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitShear"]]]:
        '''shear block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        '''
        result = self._values.get("shear")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitShear"]]], result)

    @builtins.property
    def trim(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitTrim"]]]:
        '''trim block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        '''
        result = self._values.get("trim")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitTrim"]]], result)

    @builtins.property
    def unsharp_mask(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitUnsharpMask"]]]:
        '''unsharp_mask block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        result = self._values.get("unsharp_mask")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitUnsharpMask"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortrait(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitAppend",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_priority": "gravityPriority",
        "gravity_priority_var": "gravityPriorityVar",
        "gravity_var": "gravityVar",
        "preserve_minor_dimension": "preserveMinorDimension",
        "preserve_minor_dimension_var": "preserveMinorDimensionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitAppend:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitAppendImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_priority: typing.Optional[builtins.str] = None,
        gravity_priority_var: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        preserve_minor_dimension: typing.Optional[builtins.str] = None,
        preserve_minor_dimension_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Specifies where to place the ``image`` relative to the source image. The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_priority: Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal. The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority DataAkamaiImagingPolicyImage#gravity_priority}
        :param gravity_priority_var: Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal. The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority_var DataAkamaiImagingPolicyImage#gravity_priority_var}
        :param gravity_var: Specifies where to place the ``image`` relative to the source image. The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param preserve_minor_dimension: Whether to preserve the source image's minor dimension, ``false`` by default. The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension DataAkamaiImagingPolicyImage#preserve_minor_dimension}
        :param preserve_minor_dimension_var: Whether to preserve the source image's minor dimension, ``false`` by default. The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension_var DataAkamaiImagingPolicyImage#preserve_minor_dimension_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitAppendImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__825eaee6572291b4ce45d272e39e64f8ecf3606af9c9842311f5996730076da1)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_priority", value=gravity_priority, expected_type=type_hints["gravity_priority"])
            check_type(argname="argument gravity_priority_var", value=gravity_priority_var, expected_type=type_hints["gravity_priority_var"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument preserve_minor_dimension", value=preserve_minor_dimension, expected_type=type_hints["preserve_minor_dimension"])
            check_type(argname="argument preserve_minor_dimension_var", value=preserve_minor_dimension_var, expected_type=type_hints["preserve_minor_dimension_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_priority is not None:
            self._values["gravity_priority"] = gravity_priority
        if gravity_priority_var is not None:
            self._values["gravity_priority_var"] = gravity_priority_var
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if preserve_minor_dimension is not None:
            self._values["preserve_minor_dimension"] = preserve_minor_dimension
        if preserve_minor_dimension_var is not None:
            self._values["preserve_minor_dimension_var"] = preserve_minor_dimension_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitAppendImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitAppendImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Specifies where to place the ``image`` relative to the source image.

        The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_priority(self) -> typing.Optional[builtins.str]:
        '''Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal.

        The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority DataAkamaiImagingPolicyImage#gravity_priority}
        '''
        result = self._values.get("gravity_priority")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_priority_var(self) -> typing.Optional[builtins.str]:
        '''Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal.

        The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority_var DataAkamaiImagingPolicyImage#gravity_priority_var}
        '''
        result = self._values.get("gravity_priority_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Specifies where to place the ``image`` relative to the source image.

        The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def preserve_minor_dimension(self) -> typing.Optional[builtins.str]:
        '''Whether to preserve the source image's minor dimension, ``false`` by default.

        The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension DataAkamaiImagingPolicyImage#preserve_minor_dimension}
        '''
        result = self._values.get("preserve_minor_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def preserve_minor_dimension_var(self) -> typing.Optional[builtins.str]:
        '''Whether to preserve the source image's minor dimension, ``false`` by default.

        The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension_var DataAkamaiImagingPolicyImage#preserve_minor_dimension_var}
        '''
        result = self._values.get("preserve_minor_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitAppend(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitAppendImage",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitAppendImage:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitAppendImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitAppendImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitAppendImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__28c3ed2c0b9da7b5bcdb0d0c9719cd7504d5f5464481919aba99a77ed5ac3f6d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitAppendImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitAppendImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitAppendImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab6e43e312b2ca9075a6e2d3b6a284615a8b06c972aab655ed9c52b4a01a1c78)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitAppendList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitAppendList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3d6d5f54caacd5f6215bba93b9ef37e9791c97753a10cdd6c26b50fa246b125b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitAppendOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8fdcc832b8b5d78299c90d081d83ec5f577fd4954aa9fb80720fc9c9ebe73732)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitAppendOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__01f7faaa53d413f9749d79e123861b6976564033bab6a62d7df4f0af11d4e5fb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__60029ee096a16b9f620d73ab077af2a1a43682ce72a1a03f9d4f80104668112e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__74b19b60598311d8554dd3c8bee502b08a9ea38c282b510172373f8ea18e9f6f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitAppend]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitAppend]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitAppend]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d64a02068133855bb049ff31569a4aeb9f806677c94b6f14ea4698990296d20e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitAppendOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitAppendOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5b5d73e2aa178b3559e6b33c13bf7076b38825c3dc47edfbc9eecc48e9a1962d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitAppendImage()

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityPriority")
    def reset_gravity_priority(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityPriority", []))

    @jsii.member(jsii_name="resetGravityPriorityVar")
    def reset_gravity_priority_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityPriorityVar", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPreserveMinorDimension")
    def reset_preserve_minor_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPreserveMinorDimension", []))

    @jsii.member(jsii_name="resetPreserveMinorDimensionVar")
    def reset_preserve_minor_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPreserveMinorDimensionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitAppendImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitAppendImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityInput")
    def gravity_priority_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityPriorityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityVarInput")
    def gravity_priority_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityPriorityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitAppendImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitAppendImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionInput")
    def preserve_minor_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "preserveMinorDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionVarInput")
    def preserve_minor_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "preserveMinorDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c3dfdeca13ea3ac80d79897bcfc6dd44b1440d37bd05f50862571456c67dba67)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityPriority")
    def gravity_priority(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityPriority"))

    @gravity_priority.setter
    def gravity_priority(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a95ee0e5145ce088caaa8e7aed2b8f5e02be33dafa18dad9f36b10ea5d994e48)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityPriority", value)

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityVar")
    def gravity_priority_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityPriorityVar"))

    @gravity_priority_var.setter
    def gravity_priority_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a89259be9764446d3478325e0858a0a25825c3056d3c5245daf220a5b1318c68)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityPriorityVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4c435920e61fa159021f61e80fe19f6ad4ade36f6ef14ed81ad1061701f6c687)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimension")
    def preserve_minor_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "preserveMinorDimension"))

    @preserve_minor_dimension.setter
    def preserve_minor_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__16243a9fb0f62ec59de488078e439bd259c66beed61118f8044d162ef4dfced5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "preserveMinorDimension", value)

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionVar")
    def preserve_minor_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "preserveMinorDimensionVar"))

    @preserve_minor_dimension_var.setter
    def preserve_minor_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__32813c8fe32a1812fb15ea15684351252ca0924f851d7c21b3dcd2ff9481218b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "preserveMinorDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitAppend]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitAppend]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitAppend]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c85a566bc11dab92ba859b60c43e3a193831806098773184e6ad50e7f59e94d3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitAspectCrop",
    jsii_struct_bases=[],
    name_mapping={
        "allow_expansion": "allowExpansion",
        "allow_expansion_var": "allowExpansionVar",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitAspectCrop:
    def __init__(
        self,
        *,
        allow_expansion: typing.Optional[builtins.str] = None,
        allow_expansion_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_expansion: Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image. Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        :param allow_expansion_var: Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image. Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        :param height: The height term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The width term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        :param x_position: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9af3a6f3ae3970099031da1facf7a8dcf9ccfda7f35f6656d520e52faef1a43f)
            check_type(argname="argument allow_expansion", value=allow_expansion, expected_type=type_hints["allow_expansion"])
            check_type(argname="argument allow_expansion_var", value=allow_expansion_var, expected_type=type_hints["allow_expansion_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if allow_expansion is not None:
            self._values["allow_expansion"] = allow_expansion
        if allow_expansion_var is not None:
            self._values["allow_expansion_var"] = allow_expansion_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def allow_expansion(self) -> typing.Optional[builtins.str]:
        '''Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image.

        Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        '''
        result = self._values.get("allow_expansion")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def allow_expansion_var(self) -> typing.Optional[builtins.str]:
        '''Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image.

        Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        '''
        result = self._values.get("allow_expansion_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitAspectCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitAspectCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitAspectCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f04a59f20560339fd407425613dc970c85969ca59e06d97d3ff6eb9c299e0486)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitAspectCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4230cdbc8b6b820bbbceb3ac89faeeab4c9d353667cddc90098f6b06e6725133)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitAspectCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ebf2d3607cf0be94f993e2c247575a16abf316838f536c923e9aa950ffbfeb50)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__120ef0736e5df187b950ab259b23050654f45dc5240696c3060b534ca7d55937)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cffd30c3d80c5554d02c961d82313107759481d0d8c6ade31ba7cd1e4219d45f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitAspectCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitAspectCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitAspectCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4687052f3b3fdd35ea5c338fc6d5e6c84f36837dab0230f3b3e3fe5d78e3bb7d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitAspectCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitAspectCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0b3d6fb7623006f4b5a833c018ae3e2da71bdfc135fa8b3298da77e5d4ed3c10)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAllowExpansion")
    def reset_allow_expansion(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansion", []))

    @jsii.member(jsii_name="resetAllowExpansionVar")
    def reset_allow_expansion_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansionVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionInput")
    def allow_expansion_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVarInput")
    def allow_expansion_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansion")
    def allow_expansion(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansion"))

    @allow_expansion.setter
    def allow_expansion(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__67dc74ea8db878b69b33f2afbd15f42834bbc459b480c0e52a49f9e8e98de8f6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansion", value)

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVar")
    def allow_expansion_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansionVar"))

    @allow_expansion_var.setter
    def allow_expansion_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f04e2ce8c4734fc78a54de451f549762cc042f441d9ba665d8596f6fc81a4554)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansionVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b71b6aa9b83d468c766c32b944d5f51e7fe85d394ed6390b7fa1e03a4fc1a9b8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__842d0c2cfa15b6dcb07edeaa25f063d06f980ac1a73b132a15b8304579cceb0f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b605e3593cd3d3837799c695f5ed574c739b2fc0eb18ff315f2d7a0421f1122c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ce497f84c9018e1be04452659eb9c5c8c2d20a0f8364da3bd9a6105ee692545c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__571d840ba993b9e6eda6246d354d063a0ef5f2408bf7da2a73741761b490f117)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__80ff1e63d31b60adf50780ca479972298e07b6d99731c0781d502a42bb60db54)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__40d37bac45f8ce0f9869c5b80ec27fa2af6f501230b0b48561c8e5acb70dacac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a81b2b50c973d2be3e61c3f1040e3bcbbeb2ecf6b7515fb0f3d3c0da9a2e6b32)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitAspectCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitAspectCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitAspectCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5797761bcf18047f97fb06ee668a6d99d86e78130d7daa9814e65f9df935dee1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitBackgroundColor",
    jsii_struct_bases=[],
    name_mapping={"color": "color", "color_var": "colorVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitBackgroundColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__837659faede5e441d0c61f53198b259caf954e955dc1acfdebec370c4ec1c67b)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitBackgroundColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitBackgroundColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitBackgroundColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c0489f23188e806fbcece0bb23d33a7ca71d9b75a69c25c9be49408004b322af)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitBackgroundColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c9a10d8b7dc918edd00198a775e5dc55a5e6491094da6919be72308cd6ea6ebf)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitBackgroundColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dd35ff8725dc30884969232b628d563ee223047d8a7c24ddb466172876ad24e7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__32f341f01ce622a0ad081add998b56633cb41c30404d45625bdeca314f6e3f8b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9759698a7ce0ba2f2d4ddd682a8dfab9e82826e40d8059f2053fc36c7ea9daf3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitBackgroundColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitBackgroundColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7bbfcd33091a58740e35d6da8a56eb3f7520990694eeb45c41bf991f659bc8f6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitBackgroundColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitBackgroundColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e6244d5858eabb89357b3f074074a428d20eb89729c09c52d21f4a2bf64d645f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__36542cb654a6edad32433402ef62cc8836045f5f989f5e06c5b93f77d7eefb61)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__acfa43d9e1ad8ee9b18ea6d1ef849863b0ca496aa49c64f30e69d80a75d00e31)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitBackgroundColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitBackgroundColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitBackgroundColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__54bd726d6547c56977aed2fea4405d6fd4babaa199279a030673d23d2157f647)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitBlur",
    jsii_struct_bases=[],
    name_mapping={"sigma": "sigma", "sigma_var": "sigmaVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitBlur:
    def __init__(
        self,
        *,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param sigma: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fd68fa517539bcc2b39fd87ca6d128200d57e36898cf109635b98fabcf57f908)
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitBlur(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitBlurList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitBlurList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a4398d4cd232bbe87a0569ef50a8e91ceb84f5e09ae0645eb3880caa829894c8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitBlurOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__836c6f6943925096c1beb1a308357e213e24721a14dd442c3ebe169813a702f2)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitBlurOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4b65c117a3cef807d6d96a356686f253e74f260d7cdaa5cbba3df35c0d45bc90)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e9eb7803645b8c776927709df01f6e4332567d22896db7ec31453df31922066d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__657755acf55a80f651e6ebda64f89f2e430e888964bed10d3ee9dad0fd9de71d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitBlur]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitBlur]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a7abb73457dbe157ba60497c60800c314025dbd521ced10507529904ae6b73b2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitBlurOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitBlurOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cb99e1a985873183a546a98cd4bdce1be3bf1cefbe7992b077c34507d092ef7d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__89a5c5de53b30770f5a8d8c448d5be8921a3ed89c76442114ee3705d4d9e76ee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aad0ea89ed8f86126be6a111a51021c415b6c3fa98a33d8c25067f2f853c4270)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitBlur]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitBlur]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitBlur]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__80ea9f2984a6fc3b685653d9310a46339dc2f4d8765d0be3f2b02a302b18ba3e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitChromaKey",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_feather": "hueFeather",
        "hue_feather_var": "hueFeatherVar",
        "hue_tolerance": "hueTolerance",
        "hue_tolerance_var": "hueToleranceVar",
        "hue_var": "hueVar",
        "lightness_feather": "lightnessFeather",
        "lightness_feather_var": "lightnessFeatherVar",
        "lightness_tolerance": "lightnessTolerance",
        "lightness_tolerance_var": "lightnessToleranceVar",
        "saturation_feather": "saturationFeather",
        "saturation_feather_var": "saturationFeatherVar",
        "saturation_tolerance": "saturationTolerance",
        "saturation_tolerance_var": "saturationToleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitChromaKey:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_feather: typing.Optional[builtins.str] = None,
        hue_feather_var: typing.Optional[builtins.str] = None,
        hue_tolerance: typing.Optional[builtins.str] = None,
        hue_tolerance_var: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness_feather: typing.Optional[builtins.str] = None,
        lightness_feather_var: typing.Optional[builtins.str] = None,
        lightness_tolerance: typing.Optional[builtins.str] = None,
        lightness_tolerance_var: typing.Optional[builtins.str] = None,
        saturation_feather: typing.Optional[builtins.str] = None,
        saturation_feather_var: typing.Optional[builtins.str] = None,
        saturation_tolerance: typing.Optional[builtins.str] = None,
        saturation_tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_feather: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        :param hue_feather_var: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        :param hue_tolerance: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        :param hue_tolerance_var: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        :param hue_var: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness_feather: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        :param lightness_feather_var: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        :param lightness_tolerance: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        :param lightness_tolerance_var: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        :param saturation_feather: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        :param saturation_feather_var: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        :param saturation_tolerance: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        :param saturation_tolerance_var: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__17be235def210e8e7c3f2f4b9c4d28191ea97a06eb74293531d32df8083c99d6)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_feather", value=hue_feather, expected_type=type_hints["hue_feather"])
            check_type(argname="argument hue_feather_var", value=hue_feather_var, expected_type=type_hints["hue_feather_var"])
            check_type(argname="argument hue_tolerance", value=hue_tolerance, expected_type=type_hints["hue_tolerance"])
            check_type(argname="argument hue_tolerance_var", value=hue_tolerance_var, expected_type=type_hints["hue_tolerance_var"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness_feather", value=lightness_feather, expected_type=type_hints["lightness_feather"])
            check_type(argname="argument lightness_feather_var", value=lightness_feather_var, expected_type=type_hints["lightness_feather_var"])
            check_type(argname="argument lightness_tolerance", value=lightness_tolerance, expected_type=type_hints["lightness_tolerance"])
            check_type(argname="argument lightness_tolerance_var", value=lightness_tolerance_var, expected_type=type_hints["lightness_tolerance_var"])
            check_type(argname="argument saturation_feather", value=saturation_feather, expected_type=type_hints["saturation_feather"])
            check_type(argname="argument saturation_feather_var", value=saturation_feather_var, expected_type=type_hints["saturation_feather_var"])
            check_type(argname="argument saturation_tolerance", value=saturation_tolerance, expected_type=type_hints["saturation_tolerance"])
            check_type(argname="argument saturation_tolerance_var", value=saturation_tolerance_var, expected_type=type_hints["saturation_tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_feather is not None:
            self._values["hue_feather"] = hue_feather
        if hue_feather_var is not None:
            self._values["hue_feather_var"] = hue_feather_var
        if hue_tolerance is not None:
            self._values["hue_tolerance"] = hue_tolerance
        if hue_tolerance_var is not None:
            self._values["hue_tolerance_var"] = hue_tolerance_var
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness_feather is not None:
            self._values["lightness_feather"] = lightness_feather
        if lightness_feather_var is not None:
            self._values["lightness_feather_var"] = lightness_feather_var
        if lightness_tolerance is not None:
            self._values["lightness_tolerance"] = lightness_tolerance
        if lightness_tolerance_var is not None:
            self._values["lightness_tolerance_var"] = lightness_tolerance_var
        if saturation_feather is not None:
            self._values["saturation_feather"] = saturation_feather
        if saturation_feather_var is not None:
            self._values["saturation_feather_var"] = saturation_feather_var
        if saturation_tolerance is not None:
            self._values["saturation_tolerance"] = saturation_tolerance
        if saturation_tolerance_var is not None:
            self._values["saturation_tolerance_var"] = saturation_tolerance_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        '''
        result = self._values.get("hue_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        '''
        result = self._values.get("hue_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        '''
        result = self._values.get("hue_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        '''
        result = self._values.get("hue_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        '''
        result = self._values.get("lightness_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        '''
        result = self._values.get("lightness_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        '''
        result = self._values.get("lightness_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        '''
        result = self._values.get("lightness_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        '''
        result = self._values.get("saturation_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        '''
        result = self._values.get("saturation_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        '''
        result = self._values.get("saturation_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        result = self._values.get("saturation_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitChromaKey(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitChromaKeyList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitChromaKeyList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c3d6ca985dbb92df7ff16c9f6d28a33917ec236ed760ba11c0c1548757ae3686)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitChromaKeyOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1d23ceb69333f136c83ce56567d33e9982620b97b185bc1bdceeb787859c73b9)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitChromaKeyOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f90bb405944e411eabfce00e18dee9eeaf9cbb1596aa248163615b400d0a69a6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e9d4affad6fa0e83a95fef89f55131da102659a1de53b9fed4cf48e1b07a299e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__97ee185c91fb36f5eb2df7f62d7eaffe4588fbe7ff07c8500f701af0a0ad585c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitChromaKey]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitChromaKey]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cb7855b810d5814e7d6dfd1ba54c36a2c5652361799ddeacb3820a4ec5c75d0b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitChromaKeyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitChromaKeyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e4171738427823f26b0a5cf769b1b49b10be3c82cc22662c6260dbabc630b072)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueFeather")
    def reset_hue_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeather", []))

    @jsii.member(jsii_name="resetHueFeatherVar")
    def reset_hue_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeatherVar", []))

    @jsii.member(jsii_name="resetHueTolerance")
    def reset_hue_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueTolerance", []))

    @jsii.member(jsii_name="resetHueToleranceVar")
    def reset_hue_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueToleranceVar", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightnessFeather")
    def reset_lightness_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeather", []))

    @jsii.member(jsii_name="resetLightnessFeatherVar")
    def reset_lightness_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeatherVar", []))

    @jsii.member(jsii_name="resetLightnessTolerance")
    def reset_lightness_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessTolerance", []))

    @jsii.member(jsii_name="resetLightnessToleranceVar")
    def reset_lightness_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessToleranceVar", []))

    @jsii.member(jsii_name="resetSaturationFeather")
    def reset_saturation_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeather", []))

    @jsii.member(jsii_name="resetSaturationFeatherVar")
    def reset_saturation_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeatherVar", []))

    @jsii.member(jsii_name="resetSaturationTolerance")
    def reset_saturation_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationTolerance", []))

    @jsii.member(jsii_name="resetSaturationToleranceVar")
    def reset_saturation_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherInput")
    def hue_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVarInput")
    def hue_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceInput")
    def hue_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVarInput")
    def hue_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherInput")
    def lightness_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVarInput")
    def lightness_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceInput")
    def lightness_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVarInput")
    def lightness_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherInput")
    def saturation_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVarInput")
    def saturation_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceInput")
    def saturation_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVarInput")
    def saturation_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4b1c8cdeb2ab57982bcc58f9aadac36b8c1046c7d542b12228c91eb8b78c87b8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeather")
    def hue_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeather"))

    @hue_feather.setter
    def hue_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__65363e9feb6a2dc7d712b106298da2c909abe51cd26e1f835cdb3a3e70045c4f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeather", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVar")
    def hue_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeatherVar"))

    @hue_feather_var.setter
    def hue_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__237a72c35db7b9e445cffd8ad09c489db4abcc87a5e383ed1cfceec5f94304cd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueTolerance")
    def hue_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueTolerance"))

    @hue_tolerance.setter
    def hue_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4dba8c2f151b78065e64bc0eac056c976979ef9edb32bec3464228c2ed3610e1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVar")
    def hue_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueToleranceVar"))

    @hue_tolerance_var.setter
    def hue_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f18725bc494c12b11702f006d06055ce9688323f7c5d5091126deb585cef9ecd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b1e2989370e881519341b92cf512c17bbbc4049d7d97ff1dbfbfc5ee771a6aba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeather")
    def lightness_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeather"))

    @lightness_feather.setter
    def lightness_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f443846e102e289acddd7d464591ec44fd91ad0a6ee54ffdc63db43cb758a7ac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeather", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVar")
    def lightness_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeatherVar"))

    @lightness_feather_var.setter
    def lightness_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aaab71d2e2083cd8c384b98a980009e4bbb9204dd7534c7273b9e0d8e26fc538)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessTolerance")
    def lightness_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessTolerance"))

    @lightness_tolerance.setter
    def lightness_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__80086c0fa05b40361e7202f802a1672314db71a999e5ff2380e61cb48b9a17cf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVar")
    def lightness_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessToleranceVar"))

    @lightness_tolerance_var.setter
    def lightness_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2513d04ad6dc3760454b16727430bebcf5a9818dca109cb75eae9387cd954783)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeather")
    def saturation_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeather"))

    @saturation_feather.setter
    def saturation_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3635181dcaa0d4596c020cf2944885be3a366db579302c86968c190f8e596254)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeather", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVar")
    def saturation_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeatherVar"))

    @saturation_feather_var.setter
    def saturation_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__80d86b5dcb88e2bb0f3442098797355d5400a9637e68ee673a912b16ec5e00f2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationTolerance")
    def saturation_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationTolerance"))

    @saturation_tolerance.setter
    def saturation_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__36b716c6144ade0f44ac19fa2ae9049683b46bd5782f7dff44ba1247bd3fe58c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVar")
    def saturation_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationToleranceVar"))

    @saturation_tolerance_var.setter
    def saturation_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__88d2073eaca9b1a4270a4de495704ecd0d8c6d8614d0248d19ac98b40cfb8676)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitChromaKey]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitChromaKey]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitChromaKey]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4f0cf62105e4a85fc3f70bd72141b024cd4f584ce0ab459de4b7fae1ddd12003)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitComposite",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "placement": "placement",
        "placement_var": "placementVar",
        "scale": "scale",
        "scale_dimension": "scaleDimension",
        "scale_dimension_var": "scaleDimensionVar",
        "scale_var": "scaleVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitComposite:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitCompositeImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        placement: typing.Optional[builtins.str] = None,
        placement_var: typing.Optional[builtins.str] = None,
        scale: typing.Optional[builtins.str] = None,
        scale_dimension: typing.Optional[builtins.str] = None,
        scale_dimension_var: typing.Optional[builtins.str] = None,
        scale_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param placement: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        :param placement_var: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        :param scale: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param scale_dimension: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        :param scale_dimension_var: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        :param scale_var: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        :param x_position: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitCompositeImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bd960c6b3be2fe66729fbc379f09cce635e9ff50001dc10ee2d6521df8699256)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument placement", value=placement, expected_type=type_hints["placement"])
            check_type(argname="argument placement_var", value=placement_var, expected_type=type_hints["placement_var"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument scale_dimension", value=scale_dimension, expected_type=type_hints["scale_dimension"])
            check_type(argname="argument scale_dimension_var", value=scale_dimension_var, expected_type=type_hints["scale_dimension_var"])
            check_type(argname="argument scale_var", value=scale_var, expected_type=type_hints["scale_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if placement is not None:
            self._values["placement"] = placement
        if placement_var is not None:
            self._values["placement_var"] = placement_var
        if scale is not None:
            self._values["scale"] = scale
        if scale_dimension is not None:
            self._values["scale_dimension"] = scale_dimension
        if scale_dimension_var is not None:
            self._values["scale_dimension_var"] = scale_dimension_var
        if scale_var is not None:
            self._values["scale_var"] = scale_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitCompositeImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitCompositeImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        '''
        result = self._values.get("placement")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement_var(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        '''
        result = self._values.get("placement_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        '''
        result = self._values.get("scale_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        '''
        result = self._values.get("scale_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        '''
        result = self._values.get("scale_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitComposite(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitCompositeImage",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitCompositeImage:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitCompositeImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitCompositeImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitCompositeImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9875a56c18dfa4dc74d8f8e437123c493c52be2186c1c4c3f200257532997a38)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitCompositeImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitCompositeImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2aade5c77fc798155da4f2ae1b03faa8f599a3a4530953f18acd216768abbf09)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitCompositeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitCompositeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9b8d25ea222b8691d5a633cda2d54b42036dfcd7a3bd83b45368c5fd90d7b612)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitCompositeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6679a4cd4f25cc17edeece872d9bde1a7abdd296dcb92a7965237a242bb1c729)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitCompositeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c3b65a58ca08075b96fe3d4681cb0a4e94b82adbe2520efc341a2604e1ebfdd5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8006f696b75f46f5d27c2d2050e6f58ad876fc6be8a3f6a1c0730b8585d5243e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a86b950de3281cd8b655dfa6d0bb89edee7b3bb0f477621d334d21eca04e215)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitComposite]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitComposite]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__733624ee221ebf6a61b31faba5b232e6e7943ad42c1901ee1fe7da847f8d5258)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitCompositeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitCompositeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__de4ca2f2fdbd24653894050217f3b026de453080a63d425c83e5e5c19e84139a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitCompositeImage()

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPlacement")
    def reset_placement(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacement", []))

    @jsii.member(jsii_name="resetPlacementVar")
    def reset_placement_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacementVar", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetScaleDimension")
    def reset_scale_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimension", []))

    @jsii.member(jsii_name="resetScaleDimensionVar")
    def reset_scale_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimensionVar", []))

    @jsii.member(jsii_name="resetScaleVar")
    def reset_scale_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitCompositeImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitCompositeImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitCompositeImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="placementInput")
    def placement_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementInput"))

    @builtins.property
    @jsii.member(jsii_name="placementVarInput")
    def placement_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionInput")
    def scale_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVarInput")
    def scale_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleVarInput")
    def scale_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cb1f4ff5dcd431bf45ea0a71e7056fd3cb833500bdac23053e09f60c2854430a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__001d5b5ed054fe661e593ad8c8775a7aab644b79bc58563523ab502d60f730bf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="placement")
    def placement(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placement"))

    @placement.setter
    def placement(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bec3cbff131c6ae200ed795e63d0317b2cf74a3384b9b83f474872373b573a8a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placement", value)

    @builtins.property
    @jsii.member(jsii_name="placementVar")
    def placement_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placementVar"))

    @placement_var.setter
    def placement_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9eaabf1caebb9352cc89ed8ed253631c8da883c243d1fce808d46e963fa7e67a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placementVar", value)

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scale"))

    @scale.setter
    def scale(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__937ebad510ceee549902dc5fd8ba2fbb4895ef88eceff4eeba6d9ec5c121bab3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scale", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimension")
    def scale_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimension"))

    @scale_dimension.setter
    def scale_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c44dbe0fcaef8f58c648bc5ad6cc7d4bc81337635c64909cf3e180a160ae0036)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimension", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVar")
    def scale_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimensionVar"))

    @scale_dimension_var.setter
    def scale_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6a92100a96f7df36af8d6e64b124707612713cb1e4d0c0453b0e4c0cba9214fd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="scaleVar")
    def scale_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleVar"))

    @scale_var.setter
    def scale_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__49b20d55568b6f577a2a377d9fff1fdf2d6d55a3f087ec96822f18ccb124d2d9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f196489b53cbd98027b62cba7956878b5f70868f3045f11224a87c1e669f6b67)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__64463cf43c242600697637b21e08ae94d6e794f7a5926fe85c97af2b68d8e49d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d6bce3d9232f535ce18be189578969d13119ed10cecddb1dcb3f518dfbcd9a8e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e67747306b59fb017f891b59bf8ba78faae3eb4bfbeed6ba2f6d2bc5b462978e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitComposite]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitComposite]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitComposite]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__601b637b6ea63f62b4dcdd262d7b39f826a36d62938966f679e98af8292c4f16)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitCompound",
    jsii_struct_bases=[],
    name_mapping={"transformations": "transformations"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitCompound:
    def __init__(
        self,
        *,
        transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param transformations: transformations block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d6ed90d96966e669eea9c879d77152b002861f7a54254eeaf049ec71d024fdb)
            check_type(argname="argument transformations", value=transformations, expected_type=type_hints["transformations"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if transformations is not None:
            self._values["transformations"] = transformations

    @builtins.property
    def transformations(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitCompoundTransformations"]]]:
        '''transformations block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        result = self._values.get("transformations")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitCompoundTransformations"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitCompound(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitCompoundList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitCompoundList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6063ad23f19baddb6453d05051fb35ce8627c20faf96539000325a69dac85ded)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitCompoundOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fad01334ad3b674a01d2c483166b7943622969216f7ed2c55c3b7eecfc6db3b4)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitCompoundOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bd4b8ff2d74eb3f5535ff63a24ee05f32d0d3acc9e394319a7df132a901106fa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__581599e1d4471e9000055fc43b59f2aaaaf6bd8fe16a644fa218a116c9241d21)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c1762f429615700482df2eb191ec2e473c0da90b25e338bdda17c724e1d77eea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitCompound]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitCompound]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4beb47f87fc288014c3da11ed3865c3f2b5f9810e7cf06b4b598d373e55aa6f2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitCompoundOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitCompoundOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2e3b51938ec0cab57f21088f1ded25486f8a82a60f9e16e09f52137ca545f891)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformations")
    def put_transformations(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__74a6b43881dab68eefefe96a627a5bef1aaf662ac8df7214cdc3228c6045b823)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTransformations", [value]))

    @jsii.member(jsii_name="resetTransformations")
    def reset_transformations(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformations", []))

    @builtins.property
    @jsii.member(jsii_name="transformations")
    def transformations(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitCompoundTransformationsList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitCompoundTransformationsList", jsii.get(self, "transformations"))

    @builtins.property
    @jsii.member(jsii_name="transformationsInput")
    def transformations_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitCompoundTransformations"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitCompoundTransformations"]]], jsii.get(self, "transformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitCompound]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitCompound]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitCompound]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__55a7dcc8dad0b118e8b8628821ac092ab35342fb6442978630c26b960e3762fe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitCompoundTransformations",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitCompoundTransformations:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitCompoundTransformations(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitCompoundTransformationsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitCompoundTransformationsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9fd2b936d2578a64fd9239a491e2710ca15dc95b1dd0049a9446874a1a2e5cda)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitCompoundTransformationsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__50adf53b3f2b19b96d18b3f597a777d2f63fda3131d7d9730685acd14551d6b8)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitCompoundTransformationsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ce5f0b9421759afa5aa14246fc1c49891236cc9c8cd46002c8fa51f370caf14)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ae312c5d98c1a43f9b0729958dadef74e6533730e374dc3be61f70d3174fffe9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__461caae6d771a0740014fbc41e1638169b96d1997893165ea05c4d9365ce736f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitCompoundTransformations]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitCompoundTransformations]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitCompoundTransformations]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6d174d3f4d34811dace28271217dd90f58ef882ede0448ba4006dd638f393f3a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitCompoundTransformationsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitCompoundTransformationsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__26c2b2a74fb9c178884f3279684321368277ccf84215ba75ecc2a22fc1654fd6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitCompoundTransformations]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitCompoundTransformations]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitCompoundTransformations]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__14ec433d63058fb13ca8fcb667432308520e67738b4d9a60153f906b61c96c77)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitContrast",
    jsii_struct_bases=[],
    name_mapping={
        "brightness": "brightness",
        "brightness_var": "brightnessVar",
        "contrast": "contrast",
        "contrast_var": "contrastVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitContrast:
    def __init__(
        self,
        *,
        brightness: typing.Optional[builtins.str] = None,
        brightness_var: typing.Optional[builtins.str] = None,
        contrast: typing.Optional[builtins.str] = None,
        contrast_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param brightness: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        :param brightness_var: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        :param contrast: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param contrast_var: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2bc7b469aee2d27e82cf8359fd927eb01245078a7cbfc19e4de51c4cf1c454c2)
            check_type(argname="argument brightness", value=brightness, expected_type=type_hints["brightness"])
            check_type(argname="argument brightness_var", value=brightness_var, expected_type=type_hints["brightness_var"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument contrast_var", value=contrast_var, expected_type=type_hints["contrast_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if brightness is not None:
            self._values["brightness"] = brightness
        if brightness_var is not None:
            self._values["brightness_var"] = brightness_var
        if contrast is not None:
            self._values["contrast"] = contrast
        if contrast_var is not None:
            self._values["contrast_var"] = contrast_var

    @builtins.property
    def brightness(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        '''
        result = self._values.get("brightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def brightness_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        '''
        result = self._values.get("brightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        result = self._values.get("contrast_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitContrast(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitContrastList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitContrastList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__87c3ac2d0e5857349e1ce1296f94c138f8a219c52f4e19b1e6dedb6bf045efde)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitContrastOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ad5c286255caa75509ebf459e02f6244544e5459b3f4c630c3d80bfa584c576c)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitContrastOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ed69b21356620b6fee94c4b24cdee8e8026d9366b27f110167559ce5da48d972)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__faa09637fc1133c0b943a53de0d8e8cdf0fc04042280481af51895fc87097384)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b9b5d004c29b631b634a793ceb84db81ffc305c524069edbcb1040806e7baab0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitContrast]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitContrast]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0a646d39a992b13ff9ae3ec69121e60d9d9c6be50892a28bf07e00335d205d4a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitContrastOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitContrastOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7c7159b61c2ce64a5a65e55ad9745a3eebd332c56d8be47ddb9d7ef8622a13fd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetBrightness")
    def reset_brightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightness", []))

    @jsii.member(jsii_name="resetBrightnessVar")
    def reset_brightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightnessVar", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetContrastVar")
    def reset_contrast_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrastVar", []))

    @builtins.property
    @jsii.member(jsii_name="brightnessInput")
    def brightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="brightnessVarInput")
    def brightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastVarInput")
    def contrast_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="brightness")
    def brightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightness"))

    @brightness.setter
    def brightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__034fae1779caa75c4d6710532b7b16e25765e82c48769a2bb9f48de47de93cbe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightness", value)

    @builtins.property
    @jsii.member(jsii_name="brightnessVar")
    def brightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightnessVar"))

    @brightness_var.setter
    def brightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e717ffb2d5b6ca12794b86d2b40b644bb8d7a1ebbc51576839863a26eaeda7b8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrast"))

    @contrast.setter
    def contrast(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e6dfdab6a5d9035cec4913306af2027117683f8bbb87a4ebee8367f3b5405266)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrast", value)

    @builtins.property
    @jsii.member(jsii_name="contrastVar")
    def contrast_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrastVar"))

    @contrast_var.setter
    def contrast_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__578cf866c77945900c867f78ad4ed48709e9eb151ba153bbe149c62221ed1593)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrastVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitContrast]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitContrast]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitContrast]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__baf67115c5831580db58ea54e9b9122f2c0ece4376bfb50565be4500249a4020)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitCrop",
    jsii_struct_bases=[],
    name_mapping={
        "allow_expansion": "allowExpansion",
        "allow_expansion_var": "allowExpansionVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitCrop:
    def __init__(
        self,
        *,
        allow_expansion: typing.Optional[builtins.str] = None,
        allow_expansion_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_expansion: If cropping an area outside of the existing canvas, expands the image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        :param allow_expansion_var: If cropping an area outside of the existing canvas, expands the image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        :param gravity: Frame of reference for X and Y Positions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Frame of reference for X and Y Positions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The number of pixels to crop along the y-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The number of pixels to crop along the y-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The number of pixels to crop along the x-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The number of pixels to crop along the x-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        :param x_position: The x-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7f0c5c2bf1b74c5101ab7b77ebfc366e1b222e9f827862ad2f7850391b8a98f0)
            check_type(argname="argument allow_expansion", value=allow_expansion, expected_type=type_hints["allow_expansion"])
            check_type(argname="argument allow_expansion_var", value=allow_expansion_var, expected_type=type_hints["allow_expansion_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if allow_expansion is not None:
            self._values["allow_expansion"] = allow_expansion
        if allow_expansion_var is not None:
            self._values["allow_expansion_var"] = allow_expansion_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def allow_expansion(self) -> typing.Optional[builtins.str]:
        '''If cropping an area outside of the existing canvas, expands the image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        '''
        result = self._values.get("allow_expansion")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def allow_expansion_var(self) -> typing.Optional[builtins.str]:
        '''If cropping an area outside of the existing canvas, expands the image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        '''
        result = self._values.get("allow_expansion_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Frame of reference for X and Y Positions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Frame of reference for X and Y Positions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the y-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the y-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the x-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the x-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__58101533c9db65adf1d816ec72675b1d5c9324d61413fe66850ef08beeb3ce77)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__de4732c5e645227b2d0f30d7f05396bce972a8d526bf102cbc14ee7f74c8c49c)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5935cd51a55b2924573856499f490af7e52ae21b179d541ed791e56ebe724709)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ab8e94c50305ffe9cc6757fd28b330cdc98f89fe6d5192c4f61accc877df1ad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__10332e0daa6b2d2ff921dbae49fa6958af8f79ed9b7d685838819008bb761295)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7f2e11b61c299d516f4589d81f2f1eac8767143c3ad9c78cc4facb0cb088dd98)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9b2e908bbbcca12d7914f790e65b2a6c82ccab066f86e25e450e225e5aecf518)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAllowExpansion")
    def reset_allow_expansion(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansion", []))

    @jsii.member(jsii_name="resetAllowExpansionVar")
    def reset_allow_expansion_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansionVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionInput")
    def allow_expansion_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVarInput")
    def allow_expansion_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansion")
    def allow_expansion(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansion"))

    @allow_expansion.setter
    def allow_expansion(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5d7b838fa421e5fa6b1938d5e7042c830ecb39dda35f6953eb8d4446e770c642)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansion", value)

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVar")
    def allow_expansion_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansionVar"))

    @allow_expansion_var.setter
    def allow_expansion_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5776c36893fe981414ae65b9c36700fefcab451148c2cbce01aa135015cd7493)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansionVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__58f97c962e297d4da6ff76a950819b28d552d3e430debb6322ebb970c6de4791)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__51b7604b3e81b0fa053387a2647a44f837fd705333c33f7129416b6ac7384af5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c00beb7be6c5fe92c2d7683426ccd1f83f00683e9a305fc0d549ee644bab2632)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b06466c1317ea8cca2a8a8ae774c50e564ba7113f34f10762aaa37a4a3ec56f9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa85c3c4d238dc6c1073bcade5c83ec703b34592212981e3302e8586941a88c4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a0ebf72dce0b92d79cb044a971223c6c230fe57b0e4487b054fe84f14622c0f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__85b35c30276ca41611de662f7f5a3dc0b090ebb22ae07e17991ec51fe7bd90de)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5778832ead3625b8a43179920242c909c5214d39147fc0c0b496d53347cf5d94)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__958c643c06a4869c3cee009199846b1e3ec2a6df04034280aaf2b09c0b3eb560)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a99ee2035cfe20aa683bc8351bcc811e1d74abb93e02cf73de4b3ef7d90e1513)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8ab6b99a210163c80eda3eb605e976202780f1020f03cb1ffcf9618f9b1b0286)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitFaceCrop",
    jsii_struct_bases=[],
    name_mapping={
        "algorithm": "algorithm",
        "algorithm_var": "algorithmVar",
        "confidence": "confidence",
        "confidence_var": "confidenceVar",
        "fail_gravity": "failGravity",
        "fail_gravity_var": "failGravityVar",
        "focus": "focus",
        "focus_var": "focusVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "padding": "padding",
        "padding_var": "paddingVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitFaceCrop:
    def __init__(
        self,
        *,
        algorithm: typing.Optional[builtins.str] = None,
        algorithm_var: typing.Optional[builtins.str] = None,
        confidence: typing.Optional[builtins.str] = None,
        confidence_var: typing.Optional[builtins.str] = None,
        fail_gravity: typing.Optional[builtins.str] = None,
        fail_gravity_var: typing.Optional[builtins.str] = None,
        focus: typing.Optional[builtins.str] = None,
        focus_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param algorithm: Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm DataAkamaiImagingPolicyImage#algorithm}
        :param algorithm_var: Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm_var DataAkamaiImagingPolicyImage#algorithm_var}
        :param confidence: With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image. Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence DataAkamaiImagingPolicyImage#confidence}
        :param confidence_var: With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image. Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence_var DataAkamaiImagingPolicyImage#confidence_var}
        :param fail_gravity: Controls placement of the crop if Image and Video Manager does not detect any faces in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        :param fail_gravity_var: Controls placement of the crop if Image and Video Manager does not detect any faces in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        :param focus: Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus DataAkamaiImagingPolicyImage#focus}
        :param focus_var: Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus_var DataAkamaiImagingPolicyImage#focus_var}
        :param gravity: Controls placement of the crop. Directions are relative to the face(s) plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Controls placement of the crop. Directions are relative to the face(s) plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param padding: The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        :param style: Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1213584f83a5a2d58a4ca5d8a2f51482e9802c38898382ea2ba06f39a6b616a2)
            check_type(argname="argument algorithm", value=algorithm, expected_type=type_hints["algorithm"])
            check_type(argname="argument algorithm_var", value=algorithm_var, expected_type=type_hints["algorithm_var"])
            check_type(argname="argument confidence", value=confidence, expected_type=type_hints["confidence"])
            check_type(argname="argument confidence_var", value=confidence_var, expected_type=type_hints["confidence_var"])
            check_type(argname="argument fail_gravity", value=fail_gravity, expected_type=type_hints["fail_gravity"])
            check_type(argname="argument fail_gravity_var", value=fail_gravity_var, expected_type=type_hints["fail_gravity_var"])
            check_type(argname="argument focus", value=focus, expected_type=type_hints["focus"])
            check_type(argname="argument focus_var", value=focus_var, expected_type=type_hints["focus_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if algorithm is not None:
            self._values["algorithm"] = algorithm
        if algorithm_var is not None:
            self._values["algorithm_var"] = algorithm_var
        if confidence is not None:
            self._values["confidence"] = confidence
        if confidence_var is not None:
            self._values["confidence_var"] = confidence_var
        if fail_gravity is not None:
            self._values["fail_gravity"] = fail_gravity
        if fail_gravity_var is not None:
            self._values["fail_gravity_var"] = fail_gravity_var
        if focus is not None:
            self._values["focus"] = focus
        if focus_var is not None:
            self._values["focus_var"] = focus_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def algorithm(self) -> typing.Optional[builtins.str]:
        '''Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm DataAkamaiImagingPolicyImage#algorithm}
        '''
        result = self._values.get("algorithm")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def algorithm_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm_var DataAkamaiImagingPolicyImage#algorithm_var}
        '''
        result = self._values.get("algorithm_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def confidence(self) -> typing.Optional[builtins.str]:
        '''With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image.

        Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence DataAkamaiImagingPolicyImage#confidence}
        '''
        result = self._values.get("confidence")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def confidence_var(self) -> typing.Optional[builtins.str]:
        '''With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image.

        Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence_var DataAkamaiImagingPolicyImage#confidence_var}
        '''
        result = self._values.get("confidence_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any faces in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        '''
        result = self._values.get("fail_gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any faces in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        '''
        result = self._values.get("fail_gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def focus(self) -> typing.Optional[builtins.str]:
        '''Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus DataAkamaiImagingPolicyImage#focus}
        '''
        result = self._values.get("focus")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def focus_var(self) -> typing.Optional[builtins.str]:
        '''Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus_var DataAkamaiImagingPolicyImage#focus_var}
        '''
        result = self._values.get("focus_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the face(s) plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the face(s) plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitFaceCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitFaceCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitFaceCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d5c48299b60e20325767f2a775884eda6e9333f626b60eaa9f8146c600cdbf0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitFaceCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e17b56c43e72113b9dfc3aec07116ef90ba93a96d7aad40d5481a774cc80acc)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitFaceCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__32e4e764cc583c654c4f4cb1a74599ebe0b3319a65a43ff3d8fbb83f90d9b076)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__675c6aec71c21da7b7958949826551e251cc0cff16b3e132d07ab3b93473bad9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d11c3b26f94bb7ea52023e8a079959e82e67237e72bfa6cf46b67eaecc349a0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitFaceCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitFaceCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitFaceCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2122dd5f0625c39abfbab7131444025c997ac72e863175cb847f2263d8d7d66c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitFaceCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitFaceCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dc330a8e2729949a7a2576e4ae4a883b065b2af43975aad293116b5d26d40f5a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAlgorithm")
    def reset_algorithm(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAlgorithm", []))

    @jsii.member(jsii_name="resetAlgorithmVar")
    def reset_algorithm_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAlgorithmVar", []))

    @jsii.member(jsii_name="resetConfidence")
    def reset_confidence(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetConfidence", []))

    @jsii.member(jsii_name="resetConfidenceVar")
    def reset_confidence_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetConfidenceVar", []))

    @jsii.member(jsii_name="resetFailGravity")
    def reset_fail_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravity", []))

    @jsii.member(jsii_name="resetFailGravityVar")
    def reset_fail_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravityVar", []))

    @jsii.member(jsii_name="resetFocus")
    def reset_focus(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFocus", []))

    @jsii.member(jsii_name="resetFocusVar")
    def reset_focus_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFocusVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="algorithmInput")
    def algorithm_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "algorithmInput"))

    @builtins.property
    @jsii.member(jsii_name="algorithmVarInput")
    def algorithm_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "algorithmVarInput"))

    @builtins.property
    @jsii.member(jsii_name="confidenceInput")
    def confidence_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "confidenceInput"))

    @builtins.property
    @jsii.member(jsii_name="confidenceVarInput")
    def confidence_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "confidenceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityInput")
    def fail_gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityVarInput")
    def fail_gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="focusInput")
    def focus_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "focusInput"))

    @builtins.property
    @jsii.member(jsii_name="focusVarInput")
    def focus_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "focusVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="algorithm")
    def algorithm(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "algorithm"))

    @algorithm.setter
    def algorithm(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d5f03ac16fe549f34edfce768bfb5926081294e7e1a41459a2b3ce90cad1610c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "algorithm", value)

    @builtins.property
    @jsii.member(jsii_name="algorithmVar")
    def algorithm_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "algorithmVar"))

    @algorithm_var.setter
    def algorithm_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b1a56ebf1e88a613a82bdb144cc9c3b11128340ac05022f751342b87f02b2bd0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "algorithmVar", value)

    @builtins.property
    @jsii.member(jsii_name="confidence")
    def confidence(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "confidence"))

    @confidence.setter
    def confidence(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a202159f6390aeb772f5adbf1e6ee66de6ca1eba159fea9e4646493465b76f8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "confidence", value)

    @builtins.property
    @jsii.member(jsii_name="confidenceVar")
    def confidence_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "confidenceVar"))

    @confidence_var.setter
    def confidence_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__843302a2411824dc8183ec7b9c81647d583eb6a9fecfba198cfb6a98622a3222)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "confidenceVar", value)

    @builtins.property
    @jsii.member(jsii_name="failGravity")
    def fail_gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravity"))

    @fail_gravity.setter
    def fail_gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__afef5b60f2c6f6d0b16d2d1eebbc912cb1849201ac512c5e207c4344fca5427b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravity", value)

    @builtins.property
    @jsii.member(jsii_name="failGravityVar")
    def fail_gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravityVar"))

    @fail_gravity_var.setter
    def fail_gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__74cbe153dabdf110b8b0a29cb34a444a0cfc15436a75c39d41b0b3541298a180)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="focus")
    def focus(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "focus"))

    @focus.setter
    def focus(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b008e53dddc1e3f1b42adcd5594901ab1b88fe49d91c54614df9305ccb078ca0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "focus", value)

    @builtins.property
    @jsii.member(jsii_name="focusVar")
    def focus_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "focusVar"))

    @focus_var.setter
    def focus_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__88670fc1bfb9f9fffe0c592545a54e7c014fc34e54a00441311e76f9fbdbb48b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "focusVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__37ae9f79a1fb64d6223218494b407a3b27543be7424c2b7804cb4e10cbcfaeb7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__78ae719bb3fc2daa4ebf9442a9c111b9186f80d398fbaa93b628c322bbbc5c36)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f7c28ff79c24462ad766cbf7f80f8fe1bc15d212d02c2a134043ba1cc960e62e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3be76f1e0b06090d3396fa37319999c5f906aa91fde35f3794f1512c72c676c7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c3236e5d62e560015b9c23f3ec80f292fbf6c70bc780e2582fa534327161c6c4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e9d25530598c99bf42207d8c3c905a79e285aa9e36f9de3e49ee394e0d787623)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f9eb1398e5ca5fa45bd3a302a6f352fd2bc9e6f7c2306273fff1325b00890a1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7653362a56aefd47ab28cd24fb6880bba14c68019d2b34a0ba3fc68a1333e76c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__db72e8b2d06755eb4816fd3f377e3b5a0cf8ffc9f79c60b087fdcb3c704cd50f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6dc4a4a367d5e25342a0471fb07f11abd7f6c1c87d34bc61b8a30b70b96b7031)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitFaceCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitFaceCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitFaceCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be2f3b550c70d115e949be96469839400aa6080e50a6bc15e24893409e92a4cb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitFeatureCrop",
    jsii_struct_bases=[],
    name_mapping={
        "fail_gravity": "failGravity",
        "fail_gravity_var": "failGravityVar",
        "feature_radius": "featureRadius",
        "feature_radius_var": "featureRadiusVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "max_features": "maxFeatures",
        "max_features_var": "maxFeaturesVar",
        "min_feature_quality": "minFeatureQuality",
        "min_feature_quality_var": "minFeatureQualityVar",
        "padding": "padding",
        "padding_var": "paddingVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitFeatureCrop:
    def __init__(
        self,
        *,
        fail_gravity: typing.Optional[builtins.str] = None,
        fail_gravity_var: typing.Optional[builtins.str] = None,
        feature_radius: typing.Optional[builtins.str] = None,
        feature_radius_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        max_features: typing.Optional[builtins.str] = None,
        max_features_var: typing.Optional[builtins.str] = None,
        min_feature_quality: typing.Optional[builtins.str] = None,
        min_feature_quality_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fail_gravity: Controls placement of the crop if Image and Video Manager does not detect any features in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        :param fail_gravity_var: Controls placement of the crop if Image and Video Manager does not detect any features in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        :param feature_radius: The size in pixels of the important features to search for. If identified, two features never appear closer together than this value, ``8.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius DataAkamaiImagingPolicyImage#feature_radius}
        :param feature_radius_var: The size in pixels of the important features to search for. If identified, two features never appear closer together than this value, ``8.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius_var DataAkamaiImagingPolicyImage#feature_radius_var}
        :param gravity: Controls placement of the crop. Directions are relative to the region of interest plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Controls placement of the crop. Directions are relative to the region of interest plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param max_features: The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features DataAkamaiImagingPolicyImage#max_features}
        :param max_features_var: The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features_var DataAkamaiImagingPolicyImage#max_features_var}
        :param min_feature_quality: Determines the minimum quality level of the feature identified. To consider a feature important, the feature needs to surpass this value. Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality DataAkamaiImagingPolicyImage#min_feature_quality}
        :param min_feature_quality_var: Determines the minimum quality level of the feature identified. To consider a feature important, the feature needs to surpass this value. Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality_var DataAkamaiImagingPolicyImage#min_feature_quality_var}
        :param padding: Adds space around the region of interest. The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: Adds space around the region of interest. The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        :param style: Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__63243070147b4496f02879bd8e19eefff6bb27d6f3d0f80e04bebf006854c82e)
            check_type(argname="argument fail_gravity", value=fail_gravity, expected_type=type_hints["fail_gravity"])
            check_type(argname="argument fail_gravity_var", value=fail_gravity_var, expected_type=type_hints["fail_gravity_var"])
            check_type(argname="argument feature_radius", value=feature_radius, expected_type=type_hints["feature_radius"])
            check_type(argname="argument feature_radius_var", value=feature_radius_var, expected_type=type_hints["feature_radius_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument max_features", value=max_features, expected_type=type_hints["max_features"])
            check_type(argname="argument max_features_var", value=max_features_var, expected_type=type_hints["max_features_var"])
            check_type(argname="argument min_feature_quality", value=min_feature_quality, expected_type=type_hints["min_feature_quality"])
            check_type(argname="argument min_feature_quality_var", value=min_feature_quality_var, expected_type=type_hints["min_feature_quality_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fail_gravity is not None:
            self._values["fail_gravity"] = fail_gravity
        if fail_gravity_var is not None:
            self._values["fail_gravity_var"] = fail_gravity_var
        if feature_radius is not None:
            self._values["feature_radius"] = feature_radius
        if feature_radius_var is not None:
            self._values["feature_radius_var"] = feature_radius_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if max_features is not None:
            self._values["max_features"] = max_features
        if max_features_var is not None:
            self._values["max_features_var"] = max_features_var
        if min_feature_quality is not None:
            self._values["min_feature_quality"] = min_feature_quality
        if min_feature_quality_var is not None:
            self._values["min_feature_quality_var"] = min_feature_quality_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def fail_gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any features in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        '''
        result = self._values.get("fail_gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any features in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        '''
        result = self._values.get("fail_gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feature_radius(self) -> typing.Optional[builtins.str]:
        '''The size in pixels of the important features to search for.

        If identified, two features never appear closer together than this value, ``8.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius DataAkamaiImagingPolicyImage#feature_radius}
        '''
        result = self._values.get("feature_radius")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feature_radius_var(self) -> typing.Optional[builtins.str]:
        '''The size in pixels of the important features to search for.

        If identified, two features never appear closer together than this value, ``8.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius_var DataAkamaiImagingPolicyImage#feature_radius_var}
        '''
        result = self._values.get("feature_radius_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the region of interest plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the region of interest plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def max_features(self) -> typing.Optional[builtins.str]:
        '''The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features DataAkamaiImagingPolicyImage#max_features}
        '''
        result = self._values.get("max_features")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def max_features_var(self) -> typing.Optional[builtins.str]:
        '''The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features_var DataAkamaiImagingPolicyImage#max_features_var}
        '''
        result = self._values.get("max_features_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def min_feature_quality(self) -> typing.Optional[builtins.str]:
        '''Determines the minimum quality level of the feature identified.

        To consider a feature important, the feature needs to surpass this value.  Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality DataAkamaiImagingPolicyImage#min_feature_quality}
        '''
        result = self._values.get("min_feature_quality")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def min_feature_quality_var(self) -> typing.Optional[builtins.str]:
        '''Determines the minimum quality level of the feature identified.

        To consider a feature important, the feature needs to surpass this value.  Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality_var DataAkamaiImagingPolicyImage#min_feature_quality_var}
        '''
        result = self._values.get("min_feature_quality_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''Adds space around the region of interest.

        The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''Adds space around the region of interest.

        The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitFeatureCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitFeatureCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitFeatureCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__48b5786d7eaf9951d8b6b4df1f6a41adff716825bd65e6315dc49f514f9a76e8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitFeatureCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2cb15d6fe28d7705cfaf7b3009d70366c3f1c5133def3b8a98eccbd3acc6c503)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitFeatureCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cf7dd8e91f8a05563bc261cad72863f04ac9feacf16f017776f25cf893df024e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c34676098c2fd0bd95f1838b8dacf819c8688a98b6ab7640fed1c7f0b421f02a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2964a5fbab7badb0f2a70e6f07149d50f2619cc1844d84ba3470589c0450e599)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitFeatureCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitFeatureCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitFeatureCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9def685b0336f93840a5403c5b117c397fa808ca31166062d4c49555be84d328)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitFeatureCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitFeatureCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6ff91f827c130596ef28d1ce776f8a6c6dc55a78b1385e7d6aa66902f82ab082)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetFailGravity")
    def reset_fail_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravity", []))

    @jsii.member(jsii_name="resetFailGravityVar")
    def reset_fail_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravityVar", []))

    @jsii.member(jsii_name="resetFeatureRadius")
    def reset_feature_radius(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureRadius", []))

    @jsii.member(jsii_name="resetFeatureRadiusVar")
    def reset_feature_radius_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureRadiusVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetMaxFeatures")
    def reset_max_features(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxFeatures", []))

    @jsii.member(jsii_name="resetMaxFeaturesVar")
    def reset_max_features_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxFeaturesVar", []))

    @jsii.member(jsii_name="resetMinFeatureQuality")
    def reset_min_feature_quality(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMinFeatureQuality", []))

    @jsii.member(jsii_name="resetMinFeatureQualityVar")
    def reset_min_feature_quality_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMinFeatureQualityVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="failGravityInput")
    def fail_gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityVarInput")
    def fail_gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featureRadiusInput")
    def feature_radius_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featureRadiusInput"))

    @builtins.property
    @jsii.member(jsii_name="featureRadiusVarInput")
    def feature_radius_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featureRadiusVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesInput")
    def max_features_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "maxFeaturesInput"))

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesVarInput")
    def max_features_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "maxFeaturesVarInput"))

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityInput")
    def min_feature_quality_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "minFeatureQualityInput"))

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityVarInput")
    def min_feature_quality_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "minFeatureQualityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravity")
    def fail_gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravity"))

    @fail_gravity.setter
    def fail_gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__384766af04f8c2c574f6a870c95f2cd44cdfe5d31d003ecb42a7e49e2dbba735)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravity", value)

    @builtins.property
    @jsii.member(jsii_name="failGravityVar")
    def fail_gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravityVar"))

    @fail_gravity_var.setter
    def fail_gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cfb813f7dccd76db30c47dcfa8c0282ef43c6c0454f77a767e85768a9d801e79)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="featureRadius")
    def feature_radius(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featureRadius"))

    @feature_radius.setter
    def feature_radius(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ae0e2e2fd4e4c4bb0983a02cfce50a8afa1bc1c3e9087c2c66dbee29b55d93e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featureRadius", value)

    @builtins.property
    @jsii.member(jsii_name="featureRadiusVar")
    def feature_radius_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featureRadiusVar"))

    @feature_radius_var.setter
    def feature_radius_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__321ca2650f96b5d214658213f10190d1586cbd33cd53c1133b56c48365306d86)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featureRadiusVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__23b750ca8d377366d66b268363e8091222ca8114fe968f3cf9c12bae25cba471)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8b137079b869148d57872612260f3d37f2bfd5f14a4dc4cf0abf5f93536c016a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d3dfcf72f7b1a089c12364ac29362636428e02fef1aed50270010d2dec316d8c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6afd94e9a714ebb60cad4008bd8dce8cc24e4327209476aaf3a3288125610311)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="maxFeatures")
    def max_features(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "maxFeatures"))

    @max_features.setter
    def max_features(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac8301ae086ae97bcae4e58c4c2bf84797ed4468ed26e4915d597903736f1215)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "maxFeatures", value)

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesVar")
    def max_features_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "maxFeaturesVar"))

    @max_features_var.setter
    def max_features_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__37bca5aa585e6e8c4a45d7e2120ddff9cd320f01fb10c0f26f73a6e1cdfe133d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "maxFeaturesVar", value)

    @builtins.property
    @jsii.member(jsii_name="minFeatureQuality")
    def min_feature_quality(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "minFeatureQuality"))

    @min_feature_quality.setter
    def min_feature_quality(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ba33e94a09e1ffa9920db1ccbdbccea1034b6f49e7767f3310da1b9074ce4e8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "minFeatureQuality", value)

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityVar")
    def min_feature_quality_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "minFeatureQualityVar"))

    @min_feature_quality_var.setter
    def min_feature_quality_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__194c19479e28a2b9c37c5798306a10235ad38e7a430714be0bd595c5dc6caf87)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "minFeatureQualityVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8c61509fc1ab97688f68373f7c55a35ab19ffa9fe8bc660a35c08fe6e0d15c86)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__310a3bebbef38483705cd5c1a6223cd6bde999b1a0aa60dea38b79920fe100c7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f675d9ab062e170365df0b394ffaedfe2f3e04ea70c1a3b5e4391c3b8fd3e593)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__33221a4cf1a57bb058f50b46aac1f7970c7345afb303abb1b0a48ad2f3609ea0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__da060f1712052eeed88a60c810a3e04db6fd03967d01b191e07927a4d39f21ab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__724c117ddd9523af2560258e1b91f2d4ff808ef992e2bf60af1616d46144d3a5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitFeatureCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitFeatureCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitFeatureCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8949f6a70747e195e1600b3cb45b67599c77910d53a0afdf4bd8c8a404bdc6fe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitFitAndFill",
    jsii_struct_bases=[],
    name_mapping={
        "fill_transformation": "fillTransformation",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitFitAndFill:
    def __init__(
        self,
        *,
        fill_transformation: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitFitAndFillFillTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fill_transformation: fill_transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_transformation DataAkamaiImagingPolicyImage#fill_transformation}
        :param height: The height value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The width value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(fill_transformation, dict):
            fill_transformation = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitFitAndFillFillTransformation(**fill_transformation)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d82465299f19a489b09d4a024f01183084664c6ac10451ac4643648dc34dc98a)
            check_type(argname="argument fill_transformation", value=fill_transformation, expected_type=type_hints["fill_transformation"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fill_transformation is not None:
            self._values["fill_transformation"] = fill_transformation
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def fill_transformation(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitFitAndFillFillTransformation"]:
        '''fill_transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_transformation DataAkamaiImagingPolicyImage#fill_transformation}
        '''
        result = self._values.get("fill_transformation")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitFitAndFillFillTransformation"], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitFitAndFill(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitFitAndFillFillTransformation",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitFitAndFillFillTransformation:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitFitAndFillFillTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitFitAndFillFillTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitFitAndFillFillTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ee856e988862b62aa91ab8ba41c413fd5a27a398e2e451c19f46de9f88223470)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitFitAndFillFillTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitFitAndFillFillTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitFitAndFillFillTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__892709c07458e319f9c29cf50e7582248902e58fb63dd48980bd1351511fb183)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitFitAndFillList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitFitAndFillList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3fa30b1c570da1ff8265c6c0fc65a0cf53baf9c775a2738960081b4683d537d7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitFitAndFillOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a8c656211e89e2862cf95c277defd04c2c65696e991992c4301e7e81763452de)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitFitAndFillOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ec7f05f0e0f161dd1e7cf4b335ad19586c05072eed47b7404075c45b21b32510)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__03da463f579a19c20004abfd06d22fe22f21baec5718bd94d216a0a0ba15ac11)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9f5aaeeffa88ffef87b441f609be0fb134f67f76bbf458fc5cf32a0af1d12783)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitFitAndFill]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitFitAndFill]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitFitAndFill]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f279110f3ac1b573e88dcd03c9705ef896dc75a4daf17c5cdd2f2abaa66213dc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitFitAndFillOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitFitAndFillOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__42cda095d26f5cc6d63ae38766fa2e6fa52d5fa439e7a67e3834f34d366bf70e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putFillTransformation")
    def put_fill_transformation(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitFitAndFillFillTransformation()

        return typing.cast(None, jsii.invoke(self, "putFillTransformation", [value]))

    @jsii.member(jsii_name="resetFillTransformation")
    def reset_fill_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFillTransformation", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="fillTransformation")
    def fill_transformation(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitFitAndFillFillTransformationOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitFitAndFillFillTransformationOutputReference, jsii.get(self, "fillTransformation"))

    @builtins.property
    @jsii.member(jsii_name="fillTransformationInput")
    def fill_transformation_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitFitAndFillFillTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitFitAndFillFillTransformation], jsii.get(self, "fillTransformationInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b6ec148b24bd13f7e5835d70a49d62ef6159fd47286d035dd86e7763fa30fbbc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__11362a18e8fdf5245422ea6d14567e6f043fddcbcc76682c97be263f4a21c956)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f9ca1c70439f2cb704e571d87ae1f64d2169cef38a9a3f198fe2d191eab0b739)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7a056bcc88863060e384838f5d91312e283a5f62d265b8a76877b0f8f6859f6b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitFitAndFill]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitFitAndFill]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitFitAndFill]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2aca5f1cf4519550b8edcd01cf4b9567c59e7bcd05760ea6aeb19d6c1e3e5226)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitGoop",
    jsii_struct_bases=[],
    name_mapping={
        "chaos": "chaos",
        "chaos_var": "chaosVar",
        "density": "density",
        "density_var": "densityVar",
        "power": "power",
        "power_var": "powerVar",
        "seed": "seed",
        "seed_var": "seedVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitGoop:
    def __init__(
        self,
        *,
        chaos: typing.Optional[builtins.str] = None,
        chaos_var: typing.Optional[builtins.str] = None,
        density: typing.Optional[builtins.str] = None,
        density_var: typing.Optional[builtins.str] = None,
        power: typing.Optional[builtins.str] = None,
        power_var: typing.Optional[builtins.str] = None,
        seed: typing.Optional[builtins.str] = None,
        seed_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param chaos: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        :param chaos_var: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        :param density: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        :param density_var: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        :param power: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        :param power_var: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        :param seed: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        :param seed_var: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d9f2a1e56ee5886dd872ccde8619f27cab371544eceeea9a06b27cf74a576e4e)
            check_type(argname="argument chaos", value=chaos, expected_type=type_hints["chaos"])
            check_type(argname="argument chaos_var", value=chaos_var, expected_type=type_hints["chaos_var"])
            check_type(argname="argument density", value=density, expected_type=type_hints["density"])
            check_type(argname="argument density_var", value=density_var, expected_type=type_hints["density_var"])
            check_type(argname="argument power", value=power, expected_type=type_hints["power"])
            check_type(argname="argument power_var", value=power_var, expected_type=type_hints["power_var"])
            check_type(argname="argument seed", value=seed, expected_type=type_hints["seed"])
            check_type(argname="argument seed_var", value=seed_var, expected_type=type_hints["seed_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if chaos is not None:
            self._values["chaos"] = chaos
        if chaos_var is not None:
            self._values["chaos_var"] = chaos_var
        if density is not None:
            self._values["density"] = density
        if density_var is not None:
            self._values["density_var"] = density_var
        if power is not None:
            self._values["power"] = power
        if power_var is not None:
            self._values["power_var"] = power_var
        if seed is not None:
            self._values["seed"] = seed
        if seed_var is not None:
            self._values["seed_var"] = seed_var

    @builtins.property
    def chaos(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        '''
        result = self._values.get("chaos")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def chaos_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        '''
        result = self._values.get("chaos_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        '''
        result = self._values.get("density")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density_var(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        '''
        result = self._values.get("density_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        '''
        result = self._values.get("power")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power_var(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        '''
        result = self._values.get("power_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        '''
        result = self._values.get("seed")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed_var(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        result = self._values.get("seed_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitGoop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitGoopList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitGoopList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f5bb267c6eb440a61c3f05c50b974b49a6e11d8083e6d1821b8cd536c3e31148)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitGoopOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0a1d2b7e8a52fd24397adc9b16f42f800bc2e878aed04051c1b1b0e69fc38f4d)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitGoopOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5334583c82b3a66a2cfe1a81da448f5f92ef446a55d4459bfac8e51e72efacce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4537a7781134041809c05c49158ee9e05ca8e003edde30d14ba35b1df069c09c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__174b3d31b64009c5f311179ed7fe535d7a8aba0330c29850f03a1798e5bc3584)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitGoop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitGoop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0385ec67e80f5d16dc60725d7949a55447049e5a6220bda5b70421686cd42e0b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitGoopOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitGoopOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__302a115e075bf5b0538a002335d6b63d9c17a8a40bab6f56944f8f27ccec15e2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetChaos")
    def reset_chaos(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaos", []))

    @jsii.member(jsii_name="resetChaosVar")
    def reset_chaos_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaosVar", []))

    @jsii.member(jsii_name="resetDensity")
    def reset_density(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensity", []))

    @jsii.member(jsii_name="resetDensityVar")
    def reset_density_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensityVar", []))

    @jsii.member(jsii_name="resetPower")
    def reset_power(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPower", []))

    @jsii.member(jsii_name="resetPowerVar")
    def reset_power_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPowerVar", []))

    @jsii.member(jsii_name="resetSeed")
    def reset_seed(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeed", []))

    @jsii.member(jsii_name="resetSeedVar")
    def reset_seed_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeedVar", []))

    @builtins.property
    @jsii.member(jsii_name="chaosInput")
    def chaos_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosInput"))

    @builtins.property
    @jsii.member(jsii_name="chaosVarInput")
    def chaos_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosVarInput"))

    @builtins.property
    @jsii.member(jsii_name="densityInput")
    def density_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityInput"))

    @builtins.property
    @jsii.member(jsii_name="densityVarInput")
    def density_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="powerInput")
    def power_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerInput"))

    @builtins.property
    @jsii.member(jsii_name="powerVarInput")
    def power_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerVarInput"))

    @builtins.property
    @jsii.member(jsii_name="seedInput")
    def seed_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedInput"))

    @builtins.property
    @jsii.member(jsii_name="seedVarInput")
    def seed_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedVarInput"))

    @builtins.property
    @jsii.member(jsii_name="chaos")
    def chaos(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaos"))

    @chaos.setter
    def chaos(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a2b36d2d5ee908245cbd7de06efb67fc91b5c82d32482b6d527fa74122df287a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaos", value)

    @builtins.property
    @jsii.member(jsii_name="chaosVar")
    def chaos_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaosVar"))

    @chaos_var.setter
    def chaos_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f86b74ddc664ce8dcad89860abaa97158beb29f24ed3ae59cef9c4aae2d05431)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaosVar", value)

    @builtins.property
    @jsii.member(jsii_name="density")
    def density(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "density"))

    @density.setter
    def density(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0fa82949739ca8ccd87fe5fa97b76a93351c9e15957472db115d1625acda0cef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "density", value)

    @builtins.property
    @jsii.member(jsii_name="densityVar")
    def density_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "densityVar"))

    @density_var.setter
    def density_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d3b7e1bf1a038a42b489f56ee061da71cc250a3014147beffd80fe932ac21d18)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "densityVar", value)

    @builtins.property
    @jsii.member(jsii_name="power")
    def power(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "power"))

    @power.setter
    def power(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8fc94ed10e706cadad0e855d3ddc54e55fc72155a4752867b9f31edb8131ac39)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "power", value)

    @builtins.property
    @jsii.member(jsii_name="powerVar")
    def power_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "powerVar"))

    @power_var.setter
    def power_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a9f27c8930d8584617027e1ac63c60cedca5e12d2dc427b910cfa7940eef82e1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "powerVar", value)

    @builtins.property
    @jsii.member(jsii_name="seed")
    def seed(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seed"))

    @seed.setter
    def seed(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fbb4935056532195b4752528814479d6549ca08167e10e1e1a42c5cf2d13ba83)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seed", value)

    @builtins.property
    @jsii.member(jsii_name="seedVar")
    def seed_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seedVar"))

    @seed_var.setter
    def seed_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__45b736c5db74bcd5c24c5ad08325273880f91372860fe11121b0c1ac2e742e86)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seedVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitGoop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitGoop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitGoop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1d4a496c8d1311979e5abe8070fcf9fb14bac30def27d279c73111c81da8a2c6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitGrayscale",
    jsii_struct_bases=[],
    name_mapping={"type": "type", "type_var": "typeVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitGrayscale:
    def __init__(
        self,
        *,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param type: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__37387604415e9a83c7fced7e050e1baa3105d3ff815982399d26c990ab155c23)
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitGrayscale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitGrayscaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitGrayscaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__61a100013eefe407965dddc108c47b8fabd7e427259a45de36b6f0d922ee58ec)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitGrayscaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7080f92a921784ee9bc7fd75e2a49918edd2566d94d2f6a64525b2de009423c4)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitGrayscaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3d85fb3d42643268bbefb2829978bde9af683f914c821c6639e43473ff6d283e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0857edd38c95f099644524731557d335ff653f501dedf9969af19d7502b85182)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3e7c07647963ee3bad42e5e23763ab46a3152c5ca08e9dda5ba486091a9a4484)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitGrayscale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitGrayscale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d8a4428facb8d463144aa194ac37ce0f0bc506f54bebe6745706e37f8d6c74e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitGrayscaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitGrayscaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__42b1c91ad00370c0c71c212819d46eea951f10e7564d6d76fcc2ea0dc68e6648)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4c561e8137c9f0cda4c6f5e2310892bdffbe6246f3fa91b2e1608612ef97cef1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__928527e91e64f57a950ae37fde1876807fd71e8c3314631f9b2a7e18e2c8e231)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitGrayscale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitGrayscale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitGrayscale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__de378b51417027c05e7a2eb15f82dbe8ac2ad3bde2c800c0d7af9213628aa6d2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitHsl",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "lightness": "lightness",
        "lightness_var": "lightnessVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitHsl:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness: typing.Optional[builtins.str] = None,
        lightness_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        :param lightness_var: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7db655bcc140333ff9614bd2477f433bd113dc1d57f30d196732c58352fe530e)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness", value=lightness, expected_type=type_hints["lightness"])
            check_type(argname="argument lightness_var", value=lightness_var, expected_type=type_hints["lightness_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness is not None:
            self._values["lightness"] = lightness
        if lightness_var is not None:
            self._values["lightness_var"] = lightness_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        '''
        result = self._values.get("lightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        '''
        result = self._values.get("lightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitHsl(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitHslList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitHslList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e07b86a5bdcc29528c94a9bdf268124c13c0468a87120541121cfa7d0865c063)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitHslOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1bbeed5a896a5c4135918cd8c3e28fea21c3af1d8ef54656c6d83e012978f5fa)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitHslOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8483c97cb25f3b2fea4497f79c6d9de86ee9a64261a71691c1ffbf2cc0b196a8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__373783d0a19b41f1dd772a5b83495b1326f1fb3fc5c90fa3b8c39feca1b0caeb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__588abf953fe213774f93b22c300fa3a42074f09bbfc2fdf67692338864f745a6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitHsl]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitHsl]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a6f23ab41d6289a5d9e9c8aea8da985f28f888cffbfb8a88f8f86ce8d4a3f3ac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitHslOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitHslOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e05dafd236aa1773e3ed406c79c94ebe67179e2ddf5dcad6c63634ea510baa04)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightness")
    def reset_lightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightness", []))

    @jsii.member(jsii_name="resetLightnessVar")
    def reset_lightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessInput")
    def lightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessVarInput")
    def lightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b94aad7930af1258b43239b5e5c954c0d70a36c7bfcd3fe2bb64aba9966135e1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a10fa65849077609bb3ca4c8ed7d23301985f02722f13af881fd68bd3e38b07e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightness")
    def lightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightness"))

    @lightness.setter
    def lightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6492f124a05115b84220016555ebe9942d039ce114414c6df2902a27956f33ec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightness", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessVar")
    def lightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessVar"))

    @lightness_var.setter
    def lightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c242b2d224e1d7eadb9a8257d73472abb4b179ec5d10f1b8b39597b0d9b3b0cc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__491c3929d1579c3f729841636e0526802c86d8ccaa4b1a6a3b997e4c4a714737)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f79aef1adeace03167a6a1104d9c93ba98ccb4f78e3258d1681d486fa6942d23)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitHsl]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitHsl]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitHsl]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0db4affb4332428795b358354b552fc99c8bc226d235e3086c00e87471e103ff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitHsv",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitHsv:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        :param value: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f0aefbb004158ae20d23674ffd38f79d8e78d2f55a7a311d8fc7ef8900ef42c5)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitHsv(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitHsvList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitHsvList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__91b8b310eef828b0b18cf677a071b83af5e21dd89a75830cfd2265213aab2f36)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitHsvOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b3f132626c9870b8cbce2dcce584685293f1a1bc28ff1f3f2611f41464c9d9a9)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitHsvOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7a90db2dd998d0978f11e8ac2786d39ba5075e9d20e3f72a299a6fdd3b3bbab2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ea71b0fbb1bac6fb7035999a7fc64a21db5815b0063ac8d55247b3547a0da72)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b1df57c37e5f4e905786a6f5f40878a0876d303bcba9e606b888b641d91a9fb7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitHsv]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitHsv]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__58deb1d0fdc5f585965f50d147e19f3d76dd58f4e1ee1f627bbfd953291fe387)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitHsvOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitHsvOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__344bb0beb169e2c3f40dfe8736694c675a78fce1a1505684a20c91bc28d4768f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1bf43bf0b9dc4e04bd1d8f298f1464a52f03689b0a54e7be9fdfaae6d9b22803)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__47ef1c77bb1720588451c53af1160cd6eac249f82d0e167a051bd6c54dc9e948)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__857f4208efe234a35a2218ca36643552e47e1c205d4da292ae2f124334719c3a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__076dd896a3d09ac5974aecceaa37e6a156105107bc5dea3e3283b35890ee0785)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9f73b4481ae6f42655afd495199724afdfb0c472b97d240da8d246730ac89df5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a1151a01dd305096c7e04539519add2229f302faff662ef78cef759dd4b7145a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitHsv]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitHsv]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitHsv]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__949dc49bddc42fa117072f53d3ec0d021ec88c80e8cc3f2b55f827f1bc800460)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfDimension",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "dimension": "dimension",
        "dimension_var": "dimensionVar",
        "equal": "equal",
        "greater_than": "greaterThan",
        "less_than": "lessThan",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfDimension:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        dimension: typing.Optional[builtins.str] = None,
        dimension_var: typing.Optional[builtins.str] = None,
        equal: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionEqual", typing.Dict[builtins.str, typing.Any]]] = None,
        greater_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionGreaterThan", typing.Dict[builtins.str, typing.Any]]] = None,
        less_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionLessThan", typing.Dict[builtins.str, typing.Any]]] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param dimension: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        :param dimension_var: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        :param equal: equal block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        :param greater_than: greater_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        :param less_than: less_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        :param value: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionDefault(**default)
        if isinstance(equal, dict):
            equal = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionEqual(**equal)
        if isinstance(greater_than, dict):
            greater_than = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionGreaterThan(**greater_than)
        if isinstance(less_than, dict):
            less_than = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionLessThan(**less_than)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2cc0d54f8082c451256bda4bc6f87445975afb67a4ccc6eb9fdbb1293b09f9cf)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument dimension", value=dimension, expected_type=type_hints["dimension"])
            check_type(argname="argument dimension_var", value=dimension_var, expected_type=type_hints["dimension_var"])
            check_type(argname="argument equal", value=equal, expected_type=type_hints["equal"])
            check_type(argname="argument greater_than", value=greater_than, expected_type=type_hints["greater_than"])
            check_type(argname="argument less_than", value=less_than, expected_type=type_hints["less_than"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if dimension is not None:
            self._values["dimension"] = dimension
        if dimension_var is not None:
            self._values["dimension_var"] = dimension_var
        if equal is not None:
            self._values["equal"] = equal
        if greater_than is not None:
            self._values["greater_than"] = greater_than
        if less_than is not None:
            self._values["less_than"] = less_than
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionDefault"], result)

    @builtins.property
    def dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        '''
        result = self._values.get("dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        '''
        result = self._values.get("dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def equal(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionEqual"]:
        '''equal block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        '''
        result = self._values.get("equal")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionEqual"], result)

    @builtins.property
    def greater_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionGreaterThan"]:
        '''greater_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        '''
        result = self._values.get("greater_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionGreaterThan"], result)

    @builtins.property
    def less_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionLessThan"]:
        '''less_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        '''
        result = self._values.get("less_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionLessThan"], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfDimension(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d4879113ea868ade23b76672803189019c7fd8b588a83a040c0222d6f3bbac85)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d56c6235065d28361cbb51a0847abe4c1f638fbee51249e3af03d7bd581eb150)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionEqual",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionEqual:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionEqual(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionEqualOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionEqualOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__483c72642b862d72a1a7bafb00257d9da1ab1affdd93ebb5abee3372ae665356)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionEqual], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionEqual],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5dc1b3589d19da4a3dbe3d226c011ef06c9ae8ca739b12407b2f605c32e92d80)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionGreaterThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionGreaterThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionGreaterThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionGreaterThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionGreaterThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ce19920186696a4692015ebd9e133ab10dc492904c039cc92639ed67bf5ab99b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionGreaterThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionGreaterThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b71bc2fe84066c89b0397f8c3c0e264e4339c833a930ed04d878b28c012994f1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionLessThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionLessThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionLessThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionLessThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionLessThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c43bfda6f8d23d6d06fe44f33fa85c1b5123c10f3008d602cf699e147b9ccff4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionLessThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionLessThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9771ee907a80f2100e36cb882a0eadc8f31cc9100131eba8c58589fef4c0e419)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a0c2c2535735ff2012af6770ce36d1fd38cf195282472f9741d868fbeebab2d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1cd81653851a076c991bf5c4995814f555bd89c9a8939be3b690da72d6de7e67)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__156e2e5af50cb7a7828b073147801e683c9ab2beab3bc56d64a6656bda6dd6d7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9deea0a0a633f803778d5e02b6d7e1dfd98943d96702850f170aa39d63ef6a64)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__470b42864d5af150f6fbbc3b670db6dc1fdae6c6ec0f24631143de80d4b4f5dc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfDimension]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfDimension]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c10d4ff9423afb9d51c574ba605822e47934acaa42169c65f4a3956908d5b712)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a255720763a5c16be407ad1a82b37fa1e3526bc47e10f3da1df5acca8e40cb2a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putEqual")
    def put_equal(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionEqual()

        return typing.cast(None, jsii.invoke(self, "putEqual", [value]))

    @jsii.member(jsii_name="putGreaterThan")
    def put_greater_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionGreaterThan()

        return typing.cast(None, jsii.invoke(self, "putGreaterThan", [value]))

    @jsii.member(jsii_name="putLessThan")
    def put_less_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionLessThan()

        return typing.cast(None, jsii.invoke(self, "putLessThan", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetDimension")
    def reset_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimension", []))

    @jsii.member(jsii_name="resetDimensionVar")
    def reset_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimensionVar", []))

    @jsii.member(jsii_name="resetEqual")
    def reset_equal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEqual", []))

    @jsii.member(jsii_name="resetGreaterThan")
    def reset_greater_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGreaterThan", []))

    @jsii.member(jsii_name="resetLessThan")
    def reset_less_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLessThan", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="equal")
    def equal(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionEqualOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionEqualOutputReference, jsii.get(self, "equal"))

    @builtins.property
    @jsii.member(jsii_name="greaterThan")
    def greater_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionGreaterThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionGreaterThanOutputReference, jsii.get(self, "greaterThan"))

    @builtins.property
    @jsii.member(jsii_name="lessThan")
    def less_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionLessThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionLessThanOutputReference, jsii.get(self, "lessThan"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionInput")
    def dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionVarInput")
    def dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="equalInput")
    def equal_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionEqual], jsii.get(self, "equalInput"))

    @builtins.property
    @jsii.member(jsii_name="greaterThanInput")
    def greater_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionGreaterThan], jsii.get(self, "greaterThanInput"))

    @builtins.property
    @jsii.member(jsii_name="lessThanInput")
    def less_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionLessThan], jsii.get(self, "lessThanInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="dimension")
    def dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimension"))

    @dimension.setter
    def dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a80957e27e962ac9f7cbd3b7b6781f91ac68f12e8d1ec5088865a8f53760be1c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimension", value)

    @builtins.property
    @jsii.member(jsii_name="dimensionVar")
    def dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimensionVar"))

    @dimension_var.setter
    def dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4d81e56e5871d37ca8b42a41471540140324deec2c5e19ed19cc8a7294dee0de)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__331f5cecac369a57c3ff8864c6fc0ca05c9189241fb208daa6dd2bc50aef13fd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__19d0b490b0a3afbae5e64f3713afcb8b70fe926c3c01500575d6e27311aaacfb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfDimension]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfDimension]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfDimension]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3c59ea2ad328b6763fea4b5ca0521abdd0c3a567c152c4b77f1c5a69b2c4b9e6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientation",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "landscape": "landscape",
        "portrait": "portrait",
        "square": "square",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientation:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        landscape: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationLandscape", typing.Dict[builtins.str, typing.Any]]] = None,
        portrait: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationPortrait", typing.Dict[builtins.str, typing.Any]]] = None,
        square: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationSquare", typing.Dict[builtins.str, typing.Any]]] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param landscape: landscape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        :param portrait: portrait block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        :param square: square block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationDefault(**default)
        if isinstance(landscape, dict):
            landscape = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationLandscape(**landscape)
        if isinstance(portrait, dict):
            portrait = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationPortrait(**portrait)
        if isinstance(square, dict):
            square = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationSquare(**square)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c0266282da21b866731a16437ed11e8e5f6a84f74a8d554080435c41f2ab58bb)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument landscape", value=landscape, expected_type=type_hints["landscape"])
            check_type(argname="argument portrait", value=portrait, expected_type=type_hints["portrait"])
            check_type(argname="argument square", value=square, expected_type=type_hints["square"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if landscape is not None:
            self._values["landscape"] = landscape
        if portrait is not None:
            self._values["portrait"] = portrait
        if square is not None:
            self._values["square"] = square

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationDefault"], result)

    @builtins.property
    def landscape(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationLandscape"]:
        '''landscape block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        '''
        result = self._values.get("landscape")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationLandscape"], result)

    @builtins.property
    def portrait(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationPortrait"]:
        '''portrait block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        '''
        result = self._values.get("portrait")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationPortrait"], result)

    @builtins.property
    def square(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationSquare"]:
        '''square block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        result = self._values.get("square")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationSquare"], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__36bcb1dbe7275406c44a1585e471843981f14c003cf97c36a16912336e5d2e07)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c25329074f3acf5542868f2cc985b2f8cf65fb756915f202b2ca95eb4887a7d1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationLandscape",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationLandscape:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationLandscape(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationLandscapeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationLandscapeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8e4eec947cd1f1d0e021e4da9e3f0d8e1c734706833996db2edaeb416226e882)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationLandscape], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationLandscape],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d9e9da4a256c2f2a3ddc8879431597c6a67d1b26505064d97775a72903cd46c8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__92dd3cfae4594f1a639078cb8ddb3ade95ae9ae200552bd8ba7baae9493eb30b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b962d6a84720ffffc7ae1d1db704c06aafa53a69134c497b407a526a9bc1f0d5)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__14432bfc3747aace0054bd9f6d09272bb1b7e9be561b552cac43288592d1d727)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b303d783c468328d0d7f00391974683284ceb50cf1938c4893bac8b6fe639d98)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9251cdddb89f66b19749d7b9d290668c177efc6b9255a7a3cb3c1d358c3e6d3d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientation]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientation]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a69b84a89bce4993e05383bd1edf63ab179508c456e3d64f73b26bb489f8cb3c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__161c60bad9805396229d623b77d4d9b95e1e649d0a4df3ba2c0caed4a16a37d4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putLandscape")
    def put_landscape(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationLandscape()

        return typing.cast(None, jsii.invoke(self, "putLandscape", [value]))

    @jsii.member(jsii_name="putPortrait")
    def put_portrait(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationPortrait()

        return typing.cast(None, jsii.invoke(self, "putPortrait", [value]))

    @jsii.member(jsii_name="putSquare")
    def put_square(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationSquare()

        return typing.cast(None, jsii.invoke(self, "putSquare", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetLandscape")
    def reset_landscape(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLandscape", []))

    @jsii.member(jsii_name="resetPortrait")
    def reset_portrait(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPortrait", []))

    @jsii.member(jsii_name="resetSquare")
    def reset_square(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSquare", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="landscape")
    def landscape(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationLandscapeOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationLandscapeOutputReference, jsii.get(self, "landscape"))

    @builtins.property
    @jsii.member(jsii_name="portrait")
    def portrait(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationPortraitOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationPortraitOutputReference", jsii.get(self, "portrait"))

    @builtins.property
    @jsii.member(jsii_name="square")
    def square(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationSquareOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationSquareOutputReference", jsii.get(self, "square"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="landscapeInput")
    def landscape_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationLandscape], jsii.get(self, "landscapeInput"))

    @builtins.property
    @jsii.member(jsii_name="portraitInput")
    def portrait_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationPortrait"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationPortrait"], jsii.get(self, "portraitInput"))

    @builtins.property
    @jsii.member(jsii_name="squareInput")
    def square_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationSquare"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationSquare"], jsii.get(self, "squareInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientation]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientation]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientation]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2f2ab8ad8837e9d7d259763a6fe6347e4c77809d86a1aa4ccdd352855ea1481c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationPortrait",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationPortrait:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationPortrait(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationPortraitOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationPortraitOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6d808f83a6b668f59475deebb41806f9dec3416cb57a7dbfec58af3a4387a852)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationPortrait]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationPortrait], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationPortrait],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d30bc4f11469221a73eadb31e9c14dd0c023aa92a9e274370791219a525ca488)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationSquare",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationSquare:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationSquare(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationSquareOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationSquareOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a2c0298d4ff0802b2d9da4b22d80c0b9ddfec60b70f82671d4ae99604a890413)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationSquare]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationSquare], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationSquare],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__92fcb145a18fe9a20c066e3a5a1f23182a351a1b574522a6347d50bc3b96d24e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitImQuery",
    jsii_struct_bases=[],
    name_mapping={
        "allowed_transformations": "allowedTransformations",
        "query_var": "queryVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitImQuery:
    def __init__(
        self,
        *,
        allowed_transformations: typing.Sequence[builtins.str],
        query_var: builtins.str,
    ) -> None:
        '''
        :param allowed_transformations: Specifies the transformations that can be applied using the query string parameter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allowed_transformations DataAkamaiImagingPolicyImage#allowed_transformations}
        :param query_var: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#query_var DataAkamaiImagingPolicyImage#query_var}.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a19303307638404e66adb3299f0f77918e1390b0233ea625034a53394ed5f396)
            check_type(argname="argument allowed_transformations", value=allowed_transformations, expected_type=type_hints["allowed_transformations"])
            check_type(argname="argument query_var", value=query_var, expected_type=type_hints["query_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "allowed_transformations": allowed_transformations,
            "query_var": query_var,
        }

    @builtins.property
    def allowed_transformations(self) -> typing.List[builtins.str]:
        '''Specifies the transformations that can be applied using the query string parameter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allowed_transformations DataAkamaiImagingPolicyImage#allowed_transformations}
        '''
        result = self._values.get("allowed_transformations")
        assert result is not None, "Required property 'allowed_transformations' is missing"
        return typing.cast(typing.List[builtins.str], result)

    @builtins.property
    def query_var(self) -> builtins.str:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#query_var DataAkamaiImagingPolicyImage#query_var}.'''
        result = self._values.get("query_var")
        assert result is not None, "Required property 'query_var' is missing"
        return typing.cast(builtins.str, result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitImQuery(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitImQueryList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitImQueryList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e7ed2b08ab5a6d2898571e9bb6c56cb09cebc0b8627b1ff15bc4a7b9ce396a2d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitImQueryOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__daebf8609c8ba78c49409939acc172bf6bc71bc25f6f9b21890189a22ad68968)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitImQueryOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__45a1edac09ac5569346481285eaa942fb0cc5102377d88712fa71a42eac40e8b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b17698d3d2fef10efeb756a50b175faa560fefcb74627530125514814a98d594)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1477244e823ed2df53745507ab3f3e7b1216c27478e528e7c075d82814c9683d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitImQuery]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitImQuery]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitImQuery]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__43f1dd3ac1d27d4c9bdc90d8314427f8ef3e504e8a4643c415fe8b2e1a9a7614)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitImQueryOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitImQueryOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fd7798844feb409d5f5503cd535ac93798fdafda072139fe2531664cb0b8622a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @builtins.property
    @jsii.member(jsii_name="allowedTransformationsInput")
    def allowed_transformations_input(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "allowedTransformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="queryVarInput")
    def query_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "queryVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowedTransformations")
    def allowed_transformations(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "allowedTransformations"))

    @allowed_transformations.setter
    def allowed_transformations(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f2e2b096bc337af6f7bfc2e2f8be33e370108a49e76af0d4df892156f048728f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowedTransformations", value)

    @builtins.property
    @jsii.member(jsii_name="queryVar")
    def query_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "queryVar"))

    @query_var.setter
    def query_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6baf2fcd618ae9e442e0cc8cc1cae7a9e4a5017fc72e59a165e78769c0790f53)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "queryVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitImQuery]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitImQuery]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitImQuery]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f4b56f7fec5a6eabff0b6fffdf688bc2004d32df616ea09aea1fd44c748a310)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitMaxColors",
    jsii_struct_bases=[],
    name_mapping={"colors": "colors", "colors_var": "colorsVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitMaxColors:
    def __init__(
        self,
        *,
        colors: typing.Optional[builtins.str] = None,
        colors_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param colors: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        :param colors_var: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dd9eecf97cf04a6dbea92a49d9792bfbdf98c01c03b3d709336c393436458a92)
            check_type(argname="argument colors", value=colors, expected_type=type_hints["colors"])
            check_type(argname="argument colors_var", value=colors_var, expected_type=type_hints["colors_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if colors is not None:
            self._values["colors"] = colors
        if colors_var is not None:
            self._values["colors_var"] = colors_var

    @builtins.property
    def colors(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        '''
        result = self._values.get("colors")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def colors_var(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        result = self._values.get("colors_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitMaxColors(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitMaxColorsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitMaxColorsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4242ec6014bdbcbf6eae8f8c8139dffb3d3ce8ad09490735239aeab3cd73520d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitMaxColorsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c34bbc8c08f4eb615063eee9af7edc8edd6ccaccc3a0d35fb3c8c246e93c8b2a)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitMaxColorsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f1b6b02f355bc4dfd82ad48a4b43689e98d10f15026c7548d592b5b9eec40801)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__257a5398c3be5e441b47a57d1f654ad6f9d4e4900519de9a55dcbce28c1648ab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e98530ab6d037412b020f21b76e60943a1d1edb4e91449d4d8db3521ccecf7fb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitMaxColors]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitMaxColors]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3d701602b91e13040d8f1e2b16fcc50f59b30cb364af768946b97c05f8b9541d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitMaxColorsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitMaxColorsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d43fc80daca2c9a3b7b5f0e637740dd58a30d10306c28d4bcbc53c0f3f70be2a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColors")
    def reset_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColors", []))

    @jsii.member(jsii_name="resetColorsVar")
    def reset_colors_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorsVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorsInput")
    def colors_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsInput"))

    @builtins.property
    @jsii.member(jsii_name="colorsVarInput")
    def colors_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsVarInput"))

    @builtins.property
    @jsii.member(jsii_name="colors")
    def colors(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colors"))

    @colors.setter
    def colors(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9057ed934d6786ddc2709be726451f404c9adb5a0913fffa44b8d981b7628588)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colors", value)

    @builtins.property
    @jsii.member(jsii_name="colorsVar")
    def colors_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorsVar"))

    @colors_var.setter
    def colors_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__850cbca3c2fa3054f69a206813fbc017f7a1d3448694b49468bdca0451f48852)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorsVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitMaxColors]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitMaxColors]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitMaxColors]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f3155136ed7ef805c126967039fd6074b0d38f08199dcdcb8a23294c82464d31)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitMirror",
    jsii_struct_bases=[],
    name_mapping={
        "horizontal": "horizontal",
        "horizontal_var": "horizontalVar",
        "vertical": "vertical",
        "vertical_var": "verticalVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitMirror:
    def __init__(
        self,
        *,
        horizontal: typing.Optional[builtins.str] = None,
        horizontal_var: typing.Optional[builtins.str] = None,
        vertical: typing.Optional[builtins.str] = None,
        vertical_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param horizontal: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        :param horizontal_var: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        :param vertical: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        :param vertical_var: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__75553d24d803ef05aae062edb594044c91d0770d5555837501dc131fb3078fb7)
            check_type(argname="argument horizontal", value=horizontal, expected_type=type_hints["horizontal"])
            check_type(argname="argument horizontal_var", value=horizontal_var, expected_type=type_hints["horizontal_var"])
            check_type(argname="argument vertical", value=vertical, expected_type=type_hints["vertical"])
            check_type(argname="argument vertical_var", value=vertical_var, expected_type=type_hints["vertical_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if horizontal is not None:
            self._values["horizontal"] = horizontal
        if horizontal_var is not None:
            self._values["horizontal_var"] = horizontal_var
        if vertical is not None:
            self._values["vertical"] = vertical
        if vertical_var is not None:
            self._values["vertical_var"] = vertical_var

    @builtins.property
    def horizontal(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        '''
        result = self._values.get("horizontal")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def horizontal_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        '''
        result = self._values.get("horizontal_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        '''
        result = self._values.get("vertical")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        result = self._values.get("vertical_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitMirror(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitMirrorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitMirrorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5d00771cf16e6b97a6150007e6d1dc678c509540ae903010ea27b20bb069d514)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitMirrorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c1902af6be03d46ee211646eabb9d6544c3579f48e145a30034bcd593e74430d)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitMirrorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8d67137fbfa864d928e800f87c95fc3f9c2cd1a9374dc9e4b300a95952f37e57)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f2e252afe5d4398b1848111f932b0343015c6620c5609234afc405820213b15f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8e9479448be9eb8ef47fca2b99da0753273081f081121441232729a348eba7f7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitMirror]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitMirror]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2463171ea68b5d4bb46e2af91880aac486f81e5d7ee7d5305e9da01ab35586c8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitMirrorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitMirrorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4f832e8d2ddfdf04a9a9c2b1f71fbd09f9c21184489747824a83e771ebf3c946)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHorizontal")
    def reset_horizontal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontal", []))

    @jsii.member(jsii_name="resetHorizontalVar")
    def reset_horizontal_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontalVar", []))

    @jsii.member(jsii_name="resetVertical")
    def reset_vertical(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVertical", []))

    @jsii.member(jsii_name="resetVerticalVar")
    def reset_vertical_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVerticalVar", []))

    @builtins.property
    @jsii.member(jsii_name="horizontalInput")
    def horizontal_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontalVarInput")
    def horizontal_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalInput")
    def vertical_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalVarInput")
    def vertical_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontal")
    def horizontal(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontal"))

    @horizontal.setter
    def horizontal(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__54f9fa0b9807fc3ff69b48124cc9d18e5a0bca76ee63451eb454f230eb7db49e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontal", value)

    @builtins.property
    @jsii.member(jsii_name="horizontalVar")
    def horizontal_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontalVar"))

    @horizontal_var.setter
    def horizontal_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__110e562b0f224238c8d49d1b220aa8b5ff6163c5b60f0d7ea75c491be90f92cc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontalVar", value)

    @builtins.property
    @jsii.member(jsii_name="vertical")
    def vertical(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "vertical"))

    @vertical.setter
    def vertical(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b0ab9a48499cc6a9086c208b337424e243bfb79c8af689a7b08d61407c42a244)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "vertical", value)

    @builtins.property
    @jsii.member(jsii_name="verticalVar")
    def vertical_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "verticalVar"))

    @vertical_var.setter
    def vertical_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__42018b03365229cd5e03289683a60666fd3ce10839839273bdf2232ea6529ba6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "verticalVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitMirror]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitMirror]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitMirror]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aabc9802e6df1201de89ab659938984e64933cfc93f0904868a89565fdb24bfa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitMonoHue",
    jsii_struct_bases=[],
    name_mapping={"hue": "hue", "hue_var": "hueVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitMonoHue:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0bd782c5a933dce59f35877d78d6baf255ffa464f0efc877f42d49de115487ac)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitMonoHue(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitMonoHueList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitMonoHueList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0fb80d0dabce6aef4bb1a136b0270e0ffa71679a0ace6698fbf55cb862d249f7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitMonoHueOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__32a41579b7f903b3d1d6f2553662da29a3de913c7766e826164218eca286fa07)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitMonoHueOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__58cd63a158464930d1367ccf553495d1fd21caeb05d860b49ac07b3df173644e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__67e9f68666c874b35101c65435dfaf0cd3e7c385db56419ed966478f6adb3131)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b0266b72e836ca98de690d40785e4ab9cbd582c7a5d0a0747b99b37da6416cea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitMonoHue]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitMonoHue]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9adeacbe2f7b69f12ab5a9d7d7a85af710ee4f1ff6eb9e4252f5db59a8fd69e2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitMonoHueOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitMonoHueOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__23a4fe54d2ff3751729de26a081833426df1bf75c188d1788c992ea91bcc3a61)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b247e1954f5ba0e3fe425e1ad2ec535b90cd55b2bae5ec9739d81ae181ae1914)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8702aec26311e57edd62968a0bf424303243b3f8e2e3fd9bfd060a735475d3c8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitMonoHue]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitMonoHue]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitMonoHue]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3b5124dc810287d01363d5467ba0b929b80c9fd69a68de49411288cbf93c413c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitOpacity",
    jsii_struct_bases=[],
    name_mapping={"opacity": "opacity", "opacity_var": "opacityVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitOpacity:
    def __init__(
        self,
        *,
        opacity: typing.Optional[builtins.str] = None,
        opacity_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param opacity: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param opacity_var: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f043cb31c4d235321cdd0117e44ca6aab36baa6c3943ca8fe382dbec74c75fe9)
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument opacity_var", value=opacity_var, expected_type=type_hints["opacity_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if opacity is not None:
            self._values["opacity"] = opacity
        if opacity_var is not None:
            self._values["opacity_var"] = opacity_var

    @builtins.property
    def opacity(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def opacity_var(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        result = self._values.get("opacity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitOpacity(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitOpacityList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitOpacityList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ec586c438967a353b48c783c1ab7e15215dcf402d579000c4490eb38a4eab6f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitOpacityOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1d8eec5939db861f58e8731d1ea24d9b8c5e528a1c4db6dcf3a666f32626520e)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitOpacityOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__147df632acbfab7a22c823cf5d476ca8f135d25d6411b3f596e9afaf7b70639f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8e967d5299c9f5d7e4e4f4d8b179c66377ba9b658774b62c7d968de469d460a0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1578c5d9e9fb6fccb23be1371851a1e223337d4d0aeffd71fb14863711816035)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitOpacity]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitOpacity]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5bc9388836133bbd79450f075dca0f409114c52e27f555337982faf7bd0094b2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitOpacityOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitOpacityOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__43932880c08c8aa7229a4b6c61f878123b96306eb802b3484af890b772f0253a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetOpacityVar")
    def reset_opacity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacityVar", []))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityVarInput")
    def opacity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacity"))

    @opacity.setter
    def opacity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac9b7c62129ec1d9f07417c6726044f291eef75b6c58224968cf8894c0a2fbc2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacity", value)

    @builtins.property
    @jsii.member(jsii_name="opacityVar")
    def opacity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacityVar"))

    @opacity_var.setter
    def opacity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__63f3f9db2423961c57594d2eaab2b0c4cbe10cf90ce3813d68b0af18155fe5e9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacityVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitOpacity]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitOpacity]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitOpacity]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7c1a8eefa59851cd8841be2a432ce664003e43babf6e6f03ef1059cf741c76b7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d9ca0df5392c0ab47673a6f5973813f627ddb8230d3589389496a3cfb8fab6c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putAppend")
    def put_append(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitAppend, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0d642f5241dc15c02a394bc3eaa9d8f40d3a95dfadc00cf974de8150db60bf98)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putAppend", [value]))

    @jsii.member(jsii_name="putAspectCrop")
    def put_aspect_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitAspectCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cc34c5159680a4557df3396a3f047fac436d83825b3c64ead6137601a6b223e2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putAspectCrop", [value]))

    @jsii.member(jsii_name="putBackgroundColor")
    def put_background_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d0fd8a4695f0dd9d4271ca123e666842023dba3ddd7db64196ae8e9d21c9cfdb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBackgroundColor", [value]))

    @jsii.member(jsii_name="putBlur")
    def put_blur(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitBlur, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__55c9c0dcecdc761a1ce85863efdfc999cfa967202c2619eee770b49ab83baaa3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBlur", [value]))

    @jsii.member(jsii_name="putChromaKey")
    def put_chroma_key(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitChromaKey, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a2f8063ad75aff07e8861aa40084427c456da947cf983821f8799b10bed8e08a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putChromaKey", [value]))

    @jsii.member(jsii_name="putComposite")
    def put_composite(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitComposite, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f975c485cd5da9f2c227c72bbffaef22782694435f400e3e822802c5d5966e11)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putComposite", [value]))

    @jsii.member(jsii_name="putCompound")
    def put_compound(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitCompound, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a90813a8b99cc078af85c2f4866bfdb922b329c00472666f1766b8f0af8a3593)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCompound", [value]))

    @jsii.member(jsii_name="putContrast")
    def put_contrast(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitContrast, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e6f20ee6190bf5c7ce729764315d22b440c9fc66463e690b5ecebe2c7f941c39)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putContrast", [value]))

    @jsii.member(jsii_name="putCrop")
    def put_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7efb1eb30dba847c650d080b7c909cb341f517db81a0fd76fd0d806b745cd76b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCrop", [value]))

    @jsii.member(jsii_name="putFaceCrop")
    def put_face_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitFaceCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea55416bf50a49f886fc75613fa32dd99f05eb0de2c996aaaf74ac4947fd83de)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFaceCrop", [value]))

    @jsii.member(jsii_name="putFeatureCrop")
    def put_feature_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitFeatureCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4f17e46e3023f1c43a01c6b571a1abeada2b4bebd515e65d031df6ad5384ea74)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFeatureCrop", [value]))

    @jsii.member(jsii_name="putFitAndFill")
    def put_fit_and_fill(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitFitAndFill, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f51ba58df89c59e86dea3b64758e7b26685e5e289ade81e81bcbf062ee317f84)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFitAndFill", [value]))

    @jsii.member(jsii_name="putGoop")
    def put_goop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitGoop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__90361f0294eb236e581d2da86f1166ab558f1b242f2adaa9dc020a1aaa019784)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGoop", [value]))

    @jsii.member(jsii_name="putGrayscale")
    def put_grayscale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitGrayscale, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8da7e50115d573a0ecd639cb33488aee3e10d38c37eb7e05eeacf2cdc89859a1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGrayscale", [value]))

    @jsii.member(jsii_name="putHsl")
    def put_hsl(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitHsl, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8865cba369e860ec53596fd377731413a4e6fc3e83c1cd2c1e285e3ea91824e5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsl", [value]))

    @jsii.member(jsii_name="putHsv")
    def put_hsv(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitHsv, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a9157a865cd7354b83f277def5e64c42e4f31b189b1387c32c1e13fdad3bddfd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsv", [value]))

    @jsii.member(jsii_name="putIfDimension")
    def put_if_dimension(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfDimension, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e047290696585b29009fdbe30925207135d1d5a765600ca5bc02432680ded7b4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfDimension", [value]))

    @jsii.member(jsii_name="putIfOrientation")
    def put_if_orientation(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__32c21dbc1c6e300a703212ec9bda0ae0e2d181e7622a8fcd2b4c979c5a66e556)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfOrientation", [value]))

    @jsii.member(jsii_name="putImQuery")
    def put_im_query(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitImQuery, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__730851556cd424dedb83ddbbe0fea584824e9feb42214b5cc9d3e99617f0a9fe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putImQuery", [value]))

    @jsii.member(jsii_name="putMaxColors")
    def put_max_colors(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitMaxColors, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__62a8b149f2722e952ec2f8733d8e145472e4f50c96f189b6a708d098352396a7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMaxColors", [value]))

    @jsii.member(jsii_name="putMirror")
    def put_mirror(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitMirror, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d985eb2bd089986efad25b053659a8d691d616be5ea931d9e644234878da1320)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMirror", [value]))

    @jsii.member(jsii_name="putMonoHue")
    def put_mono_hue(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitMonoHue, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__66e660c595d52a104853a9aaacb3f5d6558d0a3b8d76f56045a14b0f194f4f19)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMonoHue", [value]))

    @jsii.member(jsii_name="putOpacity")
    def put_opacity(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitOpacity, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__52ab01fa8e0c6b28efb88689b3c69a7d9dd6c01e59a92bca12488004e0bbb53d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putOpacity", [value]))

    @jsii.member(jsii_name="putRegionOfInterestCrop")
    def put_region_of_interest_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitRegionOfInterestCrop", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f55f971d80ff20579a64b907390acfe329f028e3964c9d2865816638e2fa3a81)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRegionOfInterestCrop", [value]))

    @jsii.member(jsii_name="putRelativeCrop")
    def put_relative_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitRelativeCrop", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ccb36a400b872cb6b7a70082c92b81b3b95a89af028ea2211c8ef39fa9530d9d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRelativeCrop", [value]))

    @jsii.member(jsii_name="putRemoveColor")
    def put_remove_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitRemoveColor", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f3070fc8934d67935ad96916b5d8d8cc1bd0848bfda51452082ae0ecb543386d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRemoveColor", [value]))

    @jsii.member(jsii_name="putResize")
    def put_resize(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitResize", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__11a744244196222ae1d8fd3d1f923ce30c56465417bf936b71a8c0b7a2f107f9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putResize", [value]))

    @jsii.member(jsii_name="putRotate")
    def put_rotate(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitRotate", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__95426e477d38668e3b24eb4b499a7e2004b0e6b34b657848775d657e52ab85a3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRotate", [value]))

    @jsii.member(jsii_name="putScale")
    def put_scale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitScale", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c473037d8a1cba4018d00618ff72f50df559e8f4b53d7971cfccf4e1e06b5913)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putScale", [value]))

    @jsii.member(jsii_name="putShear")
    def put_shear(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitShear", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be6537911f53901e211358bb109803da88e5476bce3a6bd16f42284c321a77cb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putShear", [value]))

    @jsii.member(jsii_name="putTrim")
    def put_trim(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitTrim", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e99f8490eb694e087d2e03973b630450835b1249bd77395a05503efe274d380f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTrim", [value]))

    @jsii.member(jsii_name="putUnsharpMask")
    def put_unsharp_mask(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitUnsharpMask", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__14556d45e2ff617f1d9e85fd297a29b82407efdfa06275777f46e6e1e3e6f87c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putUnsharpMask", [value]))

    @jsii.member(jsii_name="resetAppend")
    def reset_append(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAppend", []))

    @jsii.member(jsii_name="resetAspectCrop")
    def reset_aspect_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspectCrop", []))

    @jsii.member(jsii_name="resetBackgroundColor")
    def reset_background_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBackgroundColor", []))

    @jsii.member(jsii_name="resetBlur")
    def reset_blur(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBlur", []))

    @jsii.member(jsii_name="resetChromaKey")
    def reset_chroma_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChromaKey", []))

    @jsii.member(jsii_name="resetComposite")
    def reset_composite(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetComposite", []))

    @jsii.member(jsii_name="resetCompound")
    def reset_compound(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCompound", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetCrop")
    def reset_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCrop", []))

    @jsii.member(jsii_name="resetFaceCrop")
    def reset_face_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFaceCrop", []))

    @jsii.member(jsii_name="resetFeatureCrop")
    def reset_feature_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureCrop", []))

    @jsii.member(jsii_name="resetFitAndFill")
    def reset_fit_and_fill(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFitAndFill", []))

    @jsii.member(jsii_name="resetGoop")
    def reset_goop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGoop", []))

    @jsii.member(jsii_name="resetGrayscale")
    def reset_grayscale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGrayscale", []))

    @jsii.member(jsii_name="resetHsl")
    def reset_hsl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsl", []))

    @jsii.member(jsii_name="resetHsv")
    def reset_hsv(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsv", []))

    @jsii.member(jsii_name="resetIfDimension")
    def reset_if_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfDimension", []))

    @jsii.member(jsii_name="resetIfOrientation")
    def reset_if_orientation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfOrientation", []))

    @jsii.member(jsii_name="resetImQuery")
    def reset_im_query(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetImQuery", []))

    @jsii.member(jsii_name="resetMaxColors")
    def reset_max_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxColors", []))

    @jsii.member(jsii_name="resetMirror")
    def reset_mirror(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMirror", []))

    @jsii.member(jsii_name="resetMonoHue")
    def reset_mono_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonoHue", []))

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetRegionOfInterestCrop")
    def reset_region_of_interest_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRegionOfInterestCrop", []))

    @jsii.member(jsii_name="resetRelativeCrop")
    def reset_relative_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRelativeCrop", []))

    @jsii.member(jsii_name="resetRemoveColor")
    def reset_remove_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRemoveColor", []))

    @jsii.member(jsii_name="resetResize")
    def reset_resize(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetResize", []))

    @jsii.member(jsii_name="resetRotate")
    def reset_rotate(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRotate", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetShear")
    def reset_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetShear", []))

    @jsii.member(jsii_name="resetTrim")
    def reset_trim(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTrim", []))

    @jsii.member(jsii_name="resetUnsharpMask")
    def reset_unsharp_mask(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUnsharpMask", []))

    @builtins.property
    @jsii.member(jsii_name="append")
    def append(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitAppendList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitAppendList, jsii.get(self, "append"))

    @builtins.property
    @jsii.member(jsii_name="aspectCrop")
    def aspect_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitAspectCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitAspectCropList, jsii.get(self, "aspectCrop"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColor")
    def background_color(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitBackgroundColorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitBackgroundColorList, jsii.get(self, "backgroundColor"))

    @builtins.property
    @jsii.member(jsii_name="blur")
    def blur(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitBlurList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitBlurList, jsii.get(self, "blur"))

    @builtins.property
    @jsii.member(jsii_name="chromaKey")
    def chroma_key(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitChromaKeyList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitChromaKeyList, jsii.get(self, "chromaKey"))

    @builtins.property
    @jsii.member(jsii_name="composite")
    def composite(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitCompositeList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitCompositeList, jsii.get(self, "composite"))

    @builtins.property
    @jsii.member(jsii_name="compound")
    def compound(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitCompoundList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitCompoundList, jsii.get(self, "compound"))

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitContrastList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitContrastList, jsii.get(self, "contrast"))

    @builtins.property
    @jsii.member(jsii_name="crop")
    def crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitCropList, jsii.get(self, "crop"))

    @builtins.property
    @jsii.member(jsii_name="faceCrop")
    def face_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitFaceCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitFaceCropList, jsii.get(self, "faceCrop"))

    @builtins.property
    @jsii.member(jsii_name="featureCrop")
    def feature_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitFeatureCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitFeatureCropList, jsii.get(self, "featureCrop"))

    @builtins.property
    @jsii.member(jsii_name="fitAndFill")
    def fit_and_fill(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitFitAndFillList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitFitAndFillList, jsii.get(self, "fitAndFill"))

    @builtins.property
    @jsii.member(jsii_name="goop")
    def goop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitGoopList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitGoopList, jsii.get(self, "goop"))

    @builtins.property
    @jsii.member(jsii_name="grayscale")
    def grayscale(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitGrayscaleList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitGrayscaleList, jsii.get(self, "grayscale"))

    @builtins.property
    @jsii.member(jsii_name="hsl")
    def hsl(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitHslList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitHslList, jsii.get(self, "hsl"))

    @builtins.property
    @jsii.member(jsii_name="hsv")
    def hsv(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitHsvList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitHsvList, jsii.get(self, "hsv"))

    @builtins.property
    @jsii.member(jsii_name="ifDimension")
    def if_dimension(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionList, jsii.get(self, "ifDimension"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientation")
    def if_orientation(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationList, jsii.get(self, "ifOrientation"))

    @builtins.property
    @jsii.member(jsii_name="imQuery")
    def im_query(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitImQueryList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitImQueryList, jsii.get(self, "imQuery"))

    @builtins.property
    @jsii.member(jsii_name="maxColors")
    def max_colors(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitMaxColorsList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitMaxColorsList, jsii.get(self, "maxColors"))

    @builtins.property
    @jsii.member(jsii_name="mirror")
    def mirror(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitMirrorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitMirrorList, jsii.get(self, "mirror"))

    @builtins.property
    @jsii.member(jsii_name="monoHue")
    def mono_hue(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitMonoHueList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitMonoHueList, jsii.get(self, "monoHue"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitOpacityList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitOpacityList, jsii.get(self, "opacity"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestCrop")
    def region_of_interest_crop(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitRegionOfInterestCropList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitRegionOfInterestCropList", jsii.get(self, "regionOfInterestCrop"))

    @builtins.property
    @jsii.member(jsii_name="relativeCrop")
    def relative_crop(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitRelativeCropList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitRelativeCropList", jsii.get(self, "relativeCrop"))

    @builtins.property
    @jsii.member(jsii_name="removeColor")
    def remove_color(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitRemoveColorList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitRemoveColorList", jsii.get(self, "removeColor"))

    @builtins.property
    @jsii.member(jsii_name="resize")
    def resize(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitResizeList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitResizeList", jsii.get(self, "resize"))

    @builtins.property
    @jsii.member(jsii_name="rotate")
    def rotate(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitRotateList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitRotateList", jsii.get(self, "rotate"))

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitScaleList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitScaleList", jsii.get(self, "scale"))

    @builtins.property
    @jsii.member(jsii_name="shear")
    def shear(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitShearList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitShearList", jsii.get(self, "shear"))

    @builtins.property
    @jsii.member(jsii_name="trim")
    def trim(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitTrimList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitTrimList", jsii.get(self, "trim"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMask")
    def unsharp_mask(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitUnsharpMaskList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitUnsharpMaskList", jsii.get(self, "unsharpMask"))

    @builtins.property
    @jsii.member(jsii_name="appendInput")
    def append_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitAppend]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitAppend]]], jsii.get(self, "appendInput"))

    @builtins.property
    @jsii.member(jsii_name="aspectCropInput")
    def aspect_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitAspectCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitAspectCrop]]], jsii.get(self, "aspectCropInput"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColorInput")
    def background_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitBackgroundColor]]], jsii.get(self, "backgroundColorInput"))

    @builtins.property
    @jsii.member(jsii_name="blurInput")
    def blur_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitBlur]]], jsii.get(self, "blurInput"))

    @builtins.property
    @jsii.member(jsii_name="chromaKeyInput")
    def chroma_key_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitChromaKey]]], jsii.get(self, "chromaKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="compositeInput")
    def composite_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitComposite]]], jsii.get(self, "compositeInput"))

    @builtins.property
    @jsii.member(jsii_name="compoundInput")
    def compound_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitCompound]]], jsii.get(self, "compoundInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitContrast]]], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="cropInput")
    def crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitCrop]]], jsii.get(self, "cropInput"))

    @builtins.property
    @jsii.member(jsii_name="faceCropInput")
    def face_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitFaceCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitFaceCrop]]], jsii.get(self, "faceCropInput"))

    @builtins.property
    @jsii.member(jsii_name="featureCropInput")
    def feature_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitFeatureCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitFeatureCrop]]], jsii.get(self, "featureCropInput"))

    @builtins.property
    @jsii.member(jsii_name="fitAndFillInput")
    def fit_and_fill_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitFitAndFill]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitFitAndFill]]], jsii.get(self, "fitAndFillInput"))

    @builtins.property
    @jsii.member(jsii_name="goopInput")
    def goop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitGoop]]], jsii.get(self, "goopInput"))

    @builtins.property
    @jsii.member(jsii_name="grayscaleInput")
    def grayscale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitGrayscale]]], jsii.get(self, "grayscaleInput"))

    @builtins.property
    @jsii.member(jsii_name="hslInput")
    def hsl_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitHsl]]], jsii.get(self, "hslInput"))

    @builtins.property
    @jsii.member(jsii_name="hsvInput")
    def hsv_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitHsv]]], jsii.get(self, "hsvInput"))

    @builtins.property
    @jsii.member(jsii_name="ifDimensionInput")
    def if_dimension_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfDimension]]], jsii.get(self, "ifDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientationInput")
    def if_orientation_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientation]]], jsii.get(self, "ifOrientationInput"))

    @builtins.property
    @jsii.member(jsii_name="imQueryInput")
    def im_query_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitImQuery]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitImQuery]]], jsii.get(self, "imQueryInput"))

    @builtins.property
    @jsii.member(jsii_name="maxColorsInput")
    def max_colors_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitMaxColors]]], jsii.get(self, "maxColorsInput"))

    @builtins.property
    @jsii.member(jsii_name="mirrorInput")
    def mirror_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitMirror]]], jsii.get(self, "mirrorInput"))

    @builtins.property
    @jsii.member(jsii_name="monoHueInput")
    def mono_hue_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitMonoHue]]], jsii.get(self, "monoHueInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitOpacity]]], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestCropInput")
    def region_of_interest_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitRegionOfInterestCrop"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitRegionOfInterestCrop"]]], jsii.get(self, "regionOfInterestCropInput"))

    @builtins.property
    @jsii.member(jsii_name="relativeCropInput")
    def relative_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitRelativeCrop"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitRelativeCrop"]]], jsii.get(self, "relativeCropInput"))

    @builtins.property
    @jsii.member(jsii_name="removeColorInput")
    def remove_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitRemoveColor"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitRemoveColor"]]], jsii.get(self, "removeColorInput"))

    @builtins.property
    @jsii.member(jsii_name="resizeInput")
    def resize_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitResize"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitResize"]]], jsii.get(self, "resizeInput"))

    @builtins.property
    @jsii.member(jsii_name="rotateInput")
    def rotate_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitRotate"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitRotate"]]], jsii.get(self, "rotateInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitScale"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitScale"]]], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="shearInput")
    def shear_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitShear"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitShear"]]], jsii.get(self, "shearInput"))

    @builtins.property
    @jsii.member(jsii_name="trimInput")
    def trim_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitTrim"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitTrim"]]], jsii.get(self, "trimInput"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMaskInput")
    def unsharp_mask_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitUnsharpMask"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitUnsharpMask"]]], jsii.get(self, "unsharpMaskInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortrait]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortrait], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortrait],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__80defba839c828a27a4dbd819884794d1e6eaefdc2dd3d2bcdbdc2ab9f24cc2f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitRegionOfInterestCrop",
    jsii_struct_bases=[],
    name_mapping={
        "region_of_interest": "regionOfInterest",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitRegionOfInterestCrop:
    def __init__(
        self,
        *,
        region_of_interest: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitRegionOfInterestCropRegionOfInterest", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param region_of_interest: region_of_interest block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest DataAkamaiImagingPolicyImage#region_of_interest}
        :param gravity: The placement of the crop area relative to the specified area of interest. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: The placement of the crop area relative to the specified area of interest. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param style: Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(region_of_interest, dict):
            region_of_interest = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitRegionOfInterestCropRegionOfInterest(**region_of_interest)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__025ec5b34ecb65a799f6c46337621d7f9ea77d7513aa62da3ea7607085648761)
            check_type(argname="argument region_of_interest", value=region_of_interest, expected_type=type_hints["region_of_interest"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "region_of_interest": region_of_interest,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def region_of_interest(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitRegionOfInterestCropRegionOfInterest":
        '''region_of_interest block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest DataAkamaiImagingPolicyImage#region_of_interest}
        '''
        result = self._values.get("region_of_interest")
        assert result is not None, "Required property 'region_of_interest' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitRegionOfInterestCropRegionOfInterest", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''The placement of the crop area relative to the specified area of interest.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''The placement of the crop area relative to the specified area of interest.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitRegionOfInterestCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitRegionOfInterestCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitRegionOfInterestCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__db9dd41225483a5b1cea49186283490c5f13495dbfd57441d5c1911a8def9c3a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitRegionOfInterestCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea5f3ca3e2e0ac650fd361bfd4e22d6d17db7df1ab032ed0f71dcce3a9796675)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitRegionOfInterestCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__10757d4c2b9d904287fc58c5be9a4519d0795837a16f56b6b81698e10d0b6aed)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__325ed05a9136c052291d99f994a46d201dbbf1d89fc5ab931870cd5d074f9fd6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be029b564843d83489bc4f3dc631956f0c691515e7e6a4c3aebcbef1d2a052db)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitRegionOfInterestCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitRegionOfInterestCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitRegionOfInterestCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ed5d0fcf81f023a81cad40e3ce6c1aa4cb362d4df4e33de0dbd2d0891392cc7b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitRegionOfInterestCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitRegionOfInterestCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e9d2bd8ae4a6db395dcfecd2208e19ab6fd9cd0b027c34ac26b53cabb4e011ce)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putRegionOfInterest")
    def put_region_of_interest(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitRegionOfInterestCropRegionOfInterest()

        return typing.cast(None, jsii.invoke(self, "putRegionOfInterest", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterest")
    def region_of_interest(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitRegionOfInterestCropRegionOfInterestOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitRegionOfInterestCropRegionOfInterestOutputReference", jsii.get(self, "regionOfInterest"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestInput")
    def region_of_interest_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitRegionOfInterestCropRegionOfInterest"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitRegionOfInterestCropRegionOfInterest"], jsii.get(self, "regionOfInterestInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df44d79b6fc7bbd4e22cf393bc66cfa156ea68009ebceac6185c7092cc0fad60)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3303b7ada9f57fab0c994c57e7f6bdbc1570cbe77a06a5f77c8ab23b6dd8c4f1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ce8b3d847bebe4fdb98debc53c2db753165fd58973fc95b09a9892605a2e425)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8938141d972f9baf80f64f7162485e2d522770c795ce826c93c043446ab2da4e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b00ef72e692f7b3b6306dc23f36860d95770bc8de8dc984039902ac8546d9b32)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c04b85f5a23e074956fdeb3874c00400b88a692daf7f98187c9dd71feb289780)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1031dbf5aa1e861e291fdaf7d48ed8d566b3f93038353a7ab62fd8874b17cb74)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__527eaafc13404a0cb84333f8e937d952354c265f3a54c826d3c015579d12a715)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitRegionOfInterestCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitRegionOfInterestCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitRegionOfInterestCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__18cd0d7800ef6e575d679db311d4cf061676e3c6d30e96a8dd82b09f7edb2228)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitRegionOfInterestCropRegionOfInterest",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitRegionOfInterestCropRegionOfInterest:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitRegionOfInterestCropRegionOfInterest(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitRegionOfInterestCropRegionOfInterestOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitRegionOfInterestCropRegionOfInterestOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__588cccb546a2ee22ea2194e614ee57251b5cf80da080446595e01ff93061a18c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitRegionOfInterestCropRegionOfInterest]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitRegionOfInterestCropRegionOfInterest], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitRegionOfInterestCropRegionOfInterest],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa5dc50c4fffa41edc2fb4bda56c6685fce3ad4a8f3a0c08ea16b6d941170938)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitRelativeCrop",
    jsii_struct_bases=[],
    name_mapping={
        "east": "east",
        "east_var": "eastVar",
        "north": "north",
        "north_var": "northVar",
        "south": "south",
        "south_var": "southVar",
        "west": "west",
        "west_var": "westVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitRelativeCrop:
    def __init__(
        self,
        *,
        east: typing.Optional[builtins.str] = None,
        east_var: typing.Optional[builtins.str] = None,
        north: typing.Optional[builtins.str] = None,
        north_var: typing.Optional[builtins.str] = None,
        south: typing.Optional[builtins.str] = None,
        south_var: typing.Optional[builtins.str] = None,
        west: typing.Optional[builtins.str] = None,
        west_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param east: The number of pixels to shrink or expand the right side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east DataAkamaiImagingPolicyImage#east}
        :param east_var: The number of pixels to shrink or expand the right side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east_var DataAkamaiImagingPolicyImage#east_var}
        :param north: The number of pixels to shrink or expand the top side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north DataAkamaiImagingPolicyImage#north}
        :param north_var: The number of pixels to shrink or expand the top side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north_var DataAkamaiImagingPolicyImage#north_var}
        :param south: The number of pixels to shrink or expand the bottom side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south DataAkamaiImagingPolicyImage#south}
        :param south_var: The number of pixels to shrink or expand the bottom side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south_var DataAkamaiImagingPolicyImage#south_var}
        :param west: The number of pixels to shrink or expand the left side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west DataAkamaiImagingPolicyImage#west}
        :param west_var: The number of pixels to shrink or expand the left side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west_var DataAkamaiImagingPolicyImage#west_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__139903a553cbff8babe5a859c6e1e61d571dd78a0bbd4e89e46460cbff965912)
            check_type(argname="argument east", value=east, expected_type=type_hints["east"])
            check_type(argname="argument east_var", value=east_var, expected_type=type_hints["east_var"])
            check_type(argname="argument north", value=north, expected_type=type_hints["north"])
            check_type(argname="argument north_var", value=north_var, expected_type=type_hints["north_var"])
            check_type(argname="argument south", value=south, expected_type=type_hints["south"])
            check_type(argname="argument south_var", value=south_var, expected_type=type_hints["south_var"])
            check_type(argname="argument west", value=west, expected_type=type_hints["west"])
            check_type(argname="argument west_var", value=west_var, expected_type=type_hints["west_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if east is not None:
            self._values["east"] = east
        if east_var is not None:
            self._values["east_var"] = east_var
        if north is not None:
            self._values["north"] = north
        if north_var is not None:
            self._values["north_var"] = north_var
        if south is not None:
            self._values["south"] = south
        if south_var is not None:
            self._values["south_var"] = south_var
        if west is not None:
            self._values["west"] = west
        if west_var is not None:
            self._values["west_var"] = west_var

    @builtins.property
    def east(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the right side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east DataAkamaiImagingPolicyImage#east}
        '''
        result = self._values.get("east")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def east_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the right side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east_var DataAkamaiImagingPolicyImage#east_var}
        '''
        result = self._values.get("east_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def north(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the top side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north DataAkamaiImagingPolicyImage#north}
        '''
        result = self._values.get("north")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def north_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the top side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north_var DataAkamaiImagingPolicyImage#north_var}
        '''
        result = self._values.get("north_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def south(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the bottom side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south DataAkamaiImagingPolicyImage#south}
        '''
        result = self._values.get("south")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def south_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the bottom side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south_var DataAkamaiImagingPolicyImage#south_var}
        '''
        result = self._values.get("south_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def west(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the left side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west DataAkamaiImagingPolicyImage#west}
        '''
        result = self._values.get("west")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def west_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the left side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west_var DataAkamaiImagingPolicyImage#west_var}
        '''
        result = self._values.get("west_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitRelativeCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitRelativeCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitRelativeCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2c2a734c29caac34b8c10becd57d2ce9252200f0730a489e66f136aec0eccfe8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitRelativeCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__786b41b389f8dc8d5d325bd9d21cb45a6ffc9b9fd291a7de6b39bf6ef0f20b0a)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitRelativeCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__53080616eb861329a97235ff522b5d980ff24ffd9c3dbe788c3ddac3225d8033)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__11afa09462140a42d21561e6339ad9391226c23cf2b52857873439b86cc713ed)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d5b47d12279bd6e4cd10eb163ab7caab8b48f86c5a20a0362486e1333861097)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitRelativeCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitRelativeCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitRelativeCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c51123ad68aa0590b8449f03269dc8a3157d7cef4ff7d48a0309249e90dc4e36)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitRelativeCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitRelativeCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af8df254a37052c4e4955b18e9c3b757263fe91313259a23e0c6da82fd0bddf9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetEast")
    def reset_east(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEast", []))

    @jsii.member(jsii_name="resetEastVar")
    def reset_east_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEastVar", []))

    @jsii.member(jsii_name="resetNorth")
    def reset_north(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNorth", []))

    @jsii.member(jsii_name="resetNorthVar")
    def reset_north_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNorthVar", []))

    @jsii.member(jsii_name="resetSouth")
    def reset_south(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSouth", []))

    @jsii.member(jsii_name="resetSouthVar")
    def reset_south_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSouthVar", []))

    @jsii.member(jsii_name="resetWest")
    def reset_west(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWest", []))

    @jsii.member(jsii_name="resetWestVar")
    def reset_west_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWestVar", []))

    @builtins.property
    @jsii.member(jsii_name="eastInput")
    def east_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "eastInput"))

    @builtins.property
    @jsii.member(jsii_name="eastVarInput")
    def east_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "eastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="northInput")
    def north_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "northInput"))

    @builtins.property
    @jsii.member(jsii_name="northVarInput")
    def north_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "northVarInput"))

    @builtins.property
    @jsii.member(jsii_name="southInput")
    def south_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "southInput"))

    @builtins.property
    @jsii.member(jsii_name="southVarInput")
    def south_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "southVarInput"))

    @builtins.property
    @jsii.member(jsii_name="westInput")
    def west_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "westInput"))

    @builtins.property
    @jsii.member(jsii_name="westVarInput")
    def west_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "westVarInput"))

    @builtins.property
    @jsii.member(jsii_name="east")
    def east(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "east"))

    @east.setter
    def east(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__14bfed75e3c1afe9bcd76fc03fae79857a843ea367f5016548ef7540281c3e95)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "east", value)

    @builtins.property
    @jsii.member(jsii_name="eastVar")
    def east_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "eastVar"))

    @east_var.setter
    def east_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2aa7ce7e070274ba0d581c3a782224da4ded3d882ce0581958cad9650d8ecd51)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "eastVar", value)

    @builtins.property
    @jsii.member(jsii_name="north")
    def north(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "north"))

    @north.setter
    def north(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__71cec283a83834f00419ca329531d660449a289759ecb2070cca6843f6d6e27a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "north", value)

    @builtins.property
    @jsii.member(jsii_name="northVar")
    def north_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "northVar"))

    @north_var.setter
    def north_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ff5462a58f314d099711c6fa4a2cf329bdd20db8bd9dc5de2bd431442552383d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "northVar", value)

    @builtins.property
    @jsii.member(jsii_name="south")
    def south(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "south"))

    @south.setter
    def south(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__78b49c452b49d343938aeead6b1fbecb1fb82ad749c92ff069159636d6f51375)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "south", value)

    @builtins.property
    @jsii.member(jsii_name="southVar")
    def south_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "southVar"))

    @south_var.setter
    def south_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d6e02f570cbf04320f62b77ccb3f813dd8908d8fde2fd08cbecb7e17a865e429)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "southVar", value)

    @builtins.property
    @jsii.member(jsii_name="west")
    def west(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "west"))

    @west.setter
    def west(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__95a369418b4a3ed6bdaf08b7e5e7a74e07d02e37c124bdd0b5abfe4bf39d1191)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "west", value)

    @builtins.property
    @jsii.member(jsii_name="westVar")
    def west_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "westVar"))

    @west_var.setter
    def west_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e6251d0bd143720d8e280fbcaec12ad1da54604e5aaa7b9ee1996272ebfa4210)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "westVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitRelativeCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitRelativeCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitRelativeCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e261a47afc72c270374b7df0791c11ba193f67c39cdef792f684b7d5a9b19ec6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitRemoveColor",
    jsii_struct_bases=[],
    name_mapping={
        "color": "color",
        "color_var": "colorVar",
        "feather": "feather",
        "feather_var": "featherVar",
        "tolerance": "tolerance",
        "tolerance_var": "toleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitRemoveColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
        feather: typing.Optional[builtins.str] = None,
        feather_var: typing.Optional[builtins.str] = None,
        tolerance: typing.Optional[builtins.str] = None,
        tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        :param feather: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        :param feather_var: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        :param tolerance: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        :param tolerance_var: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f881f25ba99982ad60d4af8bad14d344b602f56f89eb042843d142c0cc4bd3a5)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
            check_type(argname="argument feather", value=feather, expected_type=type_hints["feather"])
            check_type(argname="argument feather_var", value=feather_var, expected_type=type_hints["feather_var"])
            check_type(argname="argument tolerance", value=tolerance, expected_type=type_hints["tolerance"])
            check_type(argname="argument tolerance_var", value=tolerance_var, expected_type=type_hints["tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var
        if feather is not None:
            self._values["feather"] = feather
        if feather_var is not None:
            self._values["feather_var"] = feather_var
        if tolerance is not None:
            self._values["tolerance"] = tolerance
        if tolerance_var is not None:
            self._values["tolerance_var"] = tolerance_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        '''
        result = self._values.get("feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather_var(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        '''
        result = self._values.get("feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        '''
        result = self._values.get("tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance_var(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        result = self._values.get("tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitRemoveColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitRemoveColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitRemoveColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6312351280a5a9ea4d9c948e1a389c8f04d24583455078eebc3e3da168cff63f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitRemoveColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__45e3fac457fc9112025ed3169e2553805edf5796d25aa3ab0c83da40d3d1d3aa)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitRemoveColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__357efd963efd1e476433fbac9e38e18943c92402bc604ca5e8d655560c741e2c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dab523452ec017a57b59154021202722af860bf1b5f3e2cd623acceee9c45f1c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__643763bac4f5944864edb368af70b3b2753df3103f07cc2c39333376c124aa88)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitRemoveColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitRemoveColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitRemoveColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__59b79d492ca7b912652d913eb3ee127a487f2a34046be8d7a31f7400ac1e8633)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitRemoveColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitRemoveColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__68b66c6581072735c0ee2a76f53a006e500f08073a84676e56bcf8b7d1b6bf03)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @jsii.member(jsii_name="resetFeather")
    def reset_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeather", []))

    @jsii.member(jsii_name="resetFeatherVar")
    def reset_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatherVar", []))

    @jsii.member(jsii_name="resetTolerance")
    def reset_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTolerance", []))

    @jsii.member(jsii_name="resetToleranceVar")
    def reset_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featherInput")
    def feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherInput"))

    @builtins.property
    @jsii.member(jsii_name="featherVarInput")
    def feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceInput")
    def tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceVarInput")
    def tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a1a813943bf06bd01c6034df320b698027f8e2bc18a3a2fc86a1877a02efd0a1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__55c91525d17bddf721cfe72a7604bca58248c6f20593e717755e4404a019cd02)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="feather")
    def feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "feather"))

    @feather.setter
    def feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c37f236d02748ffd6f1ea21c310536369814d5b1a7548735312bdedd3969eac5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "feather", value)

    @builtins.property
    @jsii.member(jsii_name="featherVar")
    def feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featherVar"))

    @feather_var.setter
    def feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__669472894c3eb43897ff3aa9e57ba5f79b04fce724c81017f0e36f7e8831b975)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featherVar", value)

    @builtins.property
    @jsii.member(jsii_name="tolerance")
    def tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tolerance"))

    @tolerance.setter
    def tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5accf02a820b4d9510f6106139b3013d0004646c249b3a1b2287132f55746b87)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tolerance", value)

    @builtins.property
    @jsii.member(jsii_name="toleranceVar")
    def tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "toleranceVar"))

    @tolerance_var.setter
    def tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5e2474c6bfc6ce18fef8a1a60ec9e5275b673b889fdf7ab85dfde707cb9ec834)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "toleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitRemoveColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitRemoveColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitRemoveColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__75305fc30bd90694238abbf41ef50e7be93c2d92a245c751e159185890182ed7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitResize",
    jsii_struct_bases=[],
    name_mapping={
        "aspect": "aspect",
        "aspect_var": "aspectVar",
        "height": "height",
        "height_var": "heightVar",
        "type": "type",
        "type_var": "typeVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitResize:
    def __init__(
        self,
        *,
        aspect: typing.Optional[builtins.str] = None,
        aspect_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param aspect: Preserves the aspect ratio. Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect DataAkamaiImagingPolicyImage#aspect}
        :param aspect_var: Preserves the aspect ratio. Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_var DataAkamaiImagingPolicyImage#aspect_var}
        :param height: The height to resize the source image to. Must be set if height is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height to resize the source image to. Must be set if height is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param type: Sets constraints for the image resize. Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: Sets constraints for the image resize. Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        :param width: The width to resize the source image to. Must be set if width is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width to resize the source image to. Must be set if width is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ee35ce07f29f76581c094ccd53d94b3650f0be369d60c8a8b71b2aac2ca5f667)
            check_type(argname="argument aspect", value=aspect, expected_type=type_hints["aspect"])
            check_type(argname="argument aspect_var", value=aspect_var, expected_type=type_hints["aspect_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if aspect is not None:
            self._values["aspect"] = aspect
        if aspect_var is not None:
            self._values["aspect_var"] = aspect_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def aspect(self) -> typing.Optional[builtins.str]:
        '''Preserves the aspect ratio.

        Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect DataAkamaiImagingPolicyImage#aspect}
        '''
        result = self._values.get("aspect")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def aspect_var(self) -> typing.Optional[builtins.str]:
        '''Preserves the aspect ratio.

        Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_var DataAkamaiImagingPolicyImage#aspect_var}
        '''
        result = self._values.get("aspect_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height to resize the source image to. Must be set if height is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height to resize the source image to. Must be set if height is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''Sets constraints for the image resize.

        Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''Sets constraints for the image resize.

        Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width to resize the source image to. Must be set if width is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width to resize the source image to. Must be set if width is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitResize(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitResizeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitResizeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cbeb758fcb0beb851284a684c2d828520279913a5b06abf6ddb28de1815fb2ca)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitResizeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d9fe0edb9c60d23c4ace8da922909f229d1fcb8e1073fb88cc1ef98c6984d7b5)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitResizeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__43971bd5e4f4d4d7335ae6f3732521415d157f6b328c2599981e341aa6790bf9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8cbb9ebdc6c988158faf36362f3ea6f9a32850b0b376381aa8a59e56110d55b5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__62d30af6b4d7c52fed92c511a7c245c4326ee8d54b921837d2dbd2b738dad9bd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitResize]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitResize]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitResize]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2c49d3f8e0388240f2c9dd9ffd16137c1369de873abad939789a358502a870d3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitResizeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitResizeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0a4c432c4d5e99f2688dd6621462640eda23cf178178076e0c9279317e2fce4b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAspect")
    def reset_aspect(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspect", []))

    @jsii.member(jsii_name="resetAspectVar")
    def reset_aspect_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspectVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="aspectInput")
    def aspect_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "aspectInput"))

    @builtins.property
    @jsii.member(jsii_name="aspectVarInput")
    def aspect_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "aspectVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="aspect")
    def aspect(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "aspect"))

    @aspect.setter
    def aspect(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__31931b8ee05352680ff18219f8c267a4a1a7ce4dc24f3c17c0a9a678576d30c2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "aspect", value)

    @builtins.property
    @jsii.member(jsii_name="aspectVar")
    def aspect_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "aspectVar"))

    @aspect_var.setter
    def aspect_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fcab01ef38309b60e01adad52442c3f920b0a54053d68fbfb175b94be0445a23)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "aspectVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e2aff9aaddcbf363035480b1b81ae61ef6c24fd60dfce2dd58892ff482c5703)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__97d5555036882751fc2afbe1874be3b3705dec2406ef5b43e97f9697c2ec6eac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6d682aea1ef7ad19f08b38f2edeb7fc93adb6e39abca779396c953efa54b48a5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__842c8e06599681d2f4612b1a875dd2131dbc04b1ec08f1ea88a10ab27ed50a9f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__438e15b9459bc628f2efac8aed7a38a1e56f388962642dbc541cd086141a9479)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__474f625044563bb47a7fc35eebdf6bad320661eab208be57f286070785dfce08)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitResize]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitResize]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitResize]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a84ace7eafe8d3d2ba8efae7997013469d07e3c517fcc6bba8b3a43b6b76afd6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitRotate",
    jsii_struct_bases=[],
    name_mapping={"degrees": "degrees", "degrees_var": "degreesVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitRotate:
    def __init__(
        self,
        *,
        degrees: typing.Optional[builtins.str] = None,
        degrees_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param degrees: The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees DataAkamaiImagingPolicyImage#degrees}
        :param degrees_var: The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees_var DataAkamaiImagingPolicyImage#degrees_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4d889760d1877790269df37e9d55633a467bcfdeb354f7fae38d760888e412f7)
            check_type(argname="argument degrees", value=degrees, expected_type=type_hints["degrees"])
            check_type(argname="argument degrees_var", value=degrees_var, expected_type=type_hints["degrees_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if degrees is not None:
            self._values["degrees"] = degrees
        if degrees_var is not None:
            self._values["degrees_var"] = degrees_var

    @builtins.property
    def degrees(self) -> typing.Optional[builtins.str]:
        '''The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees DataAkamaiImagingPolicyImage#degrees}
        '''
        result = self._values.get("degrees")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def degrees_var(self) -> typing.Optional[builtins.str]:
        '''The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees_var DataAkamaiImagingPolicyImage#degrees_var}
        '''
        result = self._values.get("degrees_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitRotate(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitRotateList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitRotateList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ef468b595ee6b08e80f953d4ae2c69faf09bd168a690b91e7aa69214814f8dd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitRotateOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__799f4b52e3b1415fa396aa80aae336d53ad8c980492d6c922cd64f9e4ab1f25a)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitRotateOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__32fd1d60b4cd53e462c36db655e12acda9b60db66ce129e42d6077e30a0b1e81)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__80d1d02f4e324d58df27b2bacf167506f83321a5a11c519b90d13c08d5d629c6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f45f7c93d9360667c924fc34c58a39f200547f82fa9bb8a1ed5d9450045561f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitRotate]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitRotate]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitRotate]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__181e3fe05433940933bb48cd81f4eef4ec75d02a6bef3ac2f4139eefbe214a11)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitRotateOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitRotateOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__404d74cf5c62d60a515031e6cfab57db75edcbc914c296cf405a13c3c66d0ff2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetDegrees")
    def reset_degrees(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDegrees", []))

    @jsii.member(jsii_name="resetDegreesVar")
    def reset_degrees_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDegreesVar", []))

    @builtins.property
    @jsii.member(jsii_name="degreesInput")
    def degrees_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "degreesInput"))

    @builtins.property
    @jsii.member(jsii_name="degreesVarInput")
    def degrees_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "degreesVarInput"))

    @builtins.property
    @jsii.member(jsii_name="degrees")
    def degrees(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "degrees"))

    @degrees.setter
    def degrees(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4d80fac3f13af9135fd91ce911021dee7e6f61acef566f9aa3e8097efc6aab2a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "degrees", value)

    @builtins.property
    @jsii.member(jsii_name="degreesVar")
    def degrees_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "degreesVar"))

    @degrees_var.setter
    def degrees_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__087a5f0c59e9b8f648237bf6d77ea14ab3cc351d69e564d2506742c64a1529c3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "degreesVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitRotate]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitRotate]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitRotate]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4d59fdfacfa52ab60198bcd8dcad1447912b8ac0855fc683c823722afaf54613)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitScale",
    jsii_struct_bases=[],
    name_mapping={
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitScale:
    def __init__(
        self,
        *,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param height: Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged. Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged. Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7f96a7141b793580307a2d1d0efe420bc600e8c8106297788b500fd3645723cf)
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size.

        Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size.

        Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged.

        Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged.

        Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitScale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitScaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitScaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0134e63b9cb2a1b60aacb44b6715e96cd067054cd0495114857c7f309dbf62e8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitScaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__62d5ab34dcecc18696ec1619c0f54b404f4f22b0197477bdcb502b069f9f9da9)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitScaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ed433f83c66a579dcfb234939bee2552b30019bd0ba4d0e73e3f20b43f870c31)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ddbfe2d6e23884c25500a417c7d9184d3c082418fd6736ac44aca8773ac8acf1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bf14183de52d6939d0e766d8ffc342424bed244f6de5924fedb2db47d0408b6f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitScale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitScale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitScale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2661c7f96d44461904665a9f3ffc8b869b2b8938876d1fc77e9af703453e9ce7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitScaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitScaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0574f5200458d38c4a01b21dea8e7ccc19713e4d1b8517eb91f6912418418c53)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__350f8888c1da09e69fde87dd0f9dd33333f4ee097ca6085847cb31bc116dcc85)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dec936a978e6d1a1bdd342a082b7b3f021f52964f8f6563761ccfbdf08835ad1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f67db6c2f4e9b5c5bc503b905ac8f00cf386f1a9d4194172b14f8dfb0e1c45b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__61459a70da23ee36c98c071863e267f751c5c600b3e135b3dd22fe74c3f99d3e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitScale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitScale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitScale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__67c1d5df553213519e5bded7247faae6b8962ad0f38bef7d5f097c32d000632e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitShear",
    jsii_struct_bases=[],
    name_mapping={
        "x_shear": "xShear",
        "x_shear_var": "xShearVar",
        "y_shear": "yShear",
        "y_shear_var": "yShearVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitShear:
    def __init__(
        self,
        *,
        x_shear: typing.Optional[builtins.str] = None,
        x_shear_var: typing.Optional[builtins.str] = None,
        y_shear: typing.Optional[builtins.str] = None,
        y_shear_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param x_shear: The amount to shear along the x-axis, measured in multiples of the image's width. Must be set if yShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear DataAkamaiImagingPolicyImage#x_shear}
        :param x_shear_var: The amount to shear along the x-axis, measured in multiples of the image's width. Must be set if yShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear_var DataAkamaiImagingPolicyImage#x_shear_var}
        :param y_shear: The amount to shear along the y-axis, measured in multiples of the image's height. Must be set if xShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear DataAkamaiImagingPolicyImage#y_shear}
        :param y_shear_var: The amount to shear along the y-axis, measured in multiples of the image's height. Must be set if xShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear_var DataAkamaiImagingPolicyImage#y_shear_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a58aafeaaaa0fa0f91a9b22cc21167317d7d51bbe8c30d36d9d241fb47b4e4e9)
            check_type(argname="argument x_shear", value=x_shear, expected_type=type_hints["x_shear"])
            check_type(argname="argument x_shear_var", value=x_shear_var, expected_type=type_hints["x_shear_var"])
            check_type(argname="argument y_shear", value=y_shear, expected_type=type_hints["y_shear"])
            check_type(argname="argument y_shear_var", value=y_shear_var, expected_type=type_hints["y_shear_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if x_shear is not None:
            self._values["x_shear"] = x_shear
        if x_shear_var is not None:
            self._values["x_shear_var"] = x_shear_var
        if y_shear is not None:
            self._values["y_shear"] = y_shear
        if y_shear_var is not None:
            self._values["y_shear_var"] = y_shear_var

    @builtins.property
    def x_shear(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the x-axis, measured in multiples of the image's width.

        Must be set if yShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear DataAkamaiImagingPolicyImage#x_shear}
        '''
        result = self._values.get("x_shear")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_shear_var(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the x-axis, measured in multiples of the image's width.

        Must be set if yShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear_var DataAkamaiImagingPolicyImage#x_shear_var}
        '''
        result = self._values.get("x_shear_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_shear(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the y-axis, measured in multiples of the image's height.

        Must be set if xShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear DataAkamaiImagingPolicyImage#y_shear}
        '''
        result = self._values.get("y_shear")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_shear_var(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the y-axis, measured in multiples of the image's height.

        Must be set if xShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear_var DataAkamaiImagingPolicyImage#y_shear_var}
        '''
        result = self._values.get("y_shear_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitShear(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitShearList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitShearList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__72e1341824d6109d8a17330266dd36811128bc8b23bad7472853dec3bd14d9cf)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitShearOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__52cd5f8d4135af815bfaa8c0b93f1499e149d2508c5a8164eaea7ef3839557a0)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitShearOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ef6dfc48b2c7332ad6e71e97a0358eec074a5f09057d4c748810c68aee60bf4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6b6f111acc2de878d1b4549c66d919d05bef619c9bf8c851a58e36829ce95663)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6942b44e127979f0e4585f1064ef13b51e2ae76543fbae3acbbaa92819a7182d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitShear]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitShear]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitShear]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__596a571e47cc6bb3d5470bcbe02b206d1b870c783e28c17130932954add45eb4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitShearOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitShearOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f2da08866e012e0d3b49ff507dee5709c8c0c37d2cc575222efbb74b36c28f7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetXShear")
    def reset_x_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXShear", []))

    @jsii.member(jsii_name="resetXShearVar")
    def reset_x_shear_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXShearVar", []))

    @jsii.member(jsii_name="resetYShear")
    def reset_y_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYShear", []))

    @jsii.member(jsii_name="resetYShearVar")
    def reset_y_shear_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYShearVar", []))

    @builtins.property
    @jsii.member(jsii_name="xShearInput")
    def x_shear_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xShearInput"))

    @builtins.property
    @jsii.member(jsii_name="xShearVarInput")
    def x_shear_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xShearVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yShearInput")
    def y_shear_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yShearInput"))

    @builtins.property
    @jsii.member(jsii_name="yShearVarInput")
    def y_shear_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yShearVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xShear")
    def x_shear(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xShear"))

    @x_shear.setter
    def x_shear(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c42c3b6cc5a53f07c42572af8873168af31dbcf1f70495fd16ae8b55562ec05d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xShear", value)

    @builtins.property
    @jsii.member(jsii_name="xShearVar")
    def x_shear_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xShearVar"))

    @x_shear_var.setter
    def x_shear_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e1974d1638ecc178f5a62436ebc27b249025aba4ad8aa558f52c5214bd8d8f68)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xShearVar", value)

    @builtins.property
    @jsii.member(jsii_name="yShear")
    def y_shear(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yShear"))

    @y_shear.setter
    def y_shear(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fad9bdb11c13c8a0e6bda443e50b5919fe98f258a8d82b87e8ce813af05ccc87)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yShear", value)

    @builtins.property
    @jsii.member(jsii_name="yShearVar")
    def y_shear_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yShearVar"))

    @y_shear_var.setter
    def y_shear_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__94b8e0b64f5c5137f25e2b1102340b45e481b855016b61a3cefe3e9fc3f5216b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yShearVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitShear]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitShear]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitShear]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a9bed4d344fdf51fd49ba343107056c19851283d22ac1074d9a8167e4861e5d4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitTrim",
    jsii_struct_bases=[],
    name_mapping={
        "fuzz": "fuzz",
        "fuzz_var": "fuzzVar",
        "padding": "padding",
        "padding_var": "paddingVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitTrim:
    def __init__(
        self,
        *,
        fuzz: typing.Optional[builtins.str] = None,
        fuzz_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fuzz: The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz DataAkamaiImagingPolicyImage#fuzz}
        :param fuzz_var: The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz_var DataAkamaiImagingPolicyImage#fuzz_var}
        :param padding: The amount of padding in pixels to add to the trimmed image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: The amount of padding in pixels to add to the trimmed image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d80f4d72f41e8fedf1e6a0b86ff6aa1891b965a4081c2e2ce9141bab2e30ed2)
            check_type(argname="argument fuzz", value=fuzz, expected_type=type_hints["fuzz"])
            check_type(argname="argument fuzz_var", value=fuzz_var, expected_type=type_hints["fuzz_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fuzz is not None:
            self._values["fuzz"] = fuzz
        if fuzz_var is not None:
            self._values["fuzz_var"] = fuzz_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var

    @builtins.property
    def fuzz(self) -> typing.Optional[builtins.str]:
        '''The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz DataAkamaiImagingPolicyImage#fuzz}
        '''
        result = self._values.get("fuzz")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fuzz_var(self) -> typing.Optional[builtins.str]:
        '''The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz_var DataAkamaiImagingPolicyImage#fuzz_var}
        '''
        result = self._values.get("fuzz_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''The amount of padding in pixels to add to the trimmed image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''The amount of padding in pixels to add to the trimmed image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitTrim(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitTrimList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitTrimList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a24b54d6adaf5b9f61420fd0b5e77f35cb6c6dfecca5008e711d4daadd6f187)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitTrimOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cb7fe895553ea19ed87a6a828bbd7455830349e423eb5a298a094f640dbef4b3)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitTrimOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__56f5ebdf2e76d5de9452bc934bf8f06d7bfb16bd2b0fa70eec448880f97d1bfd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c85a5872df89e488c13d7a2fe42c70ab5b88494f4315069216733abe688b368f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__236c9a9863b74b3d341d3a93aab06ce32b77abbb9fcd394c99323893730fcdc2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitTrim]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitTrim]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitTrim]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__830530bce68acf08e5584a340441f68a1436e700cc47059ea3c8a13693136238)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitTrimOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitTrimOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0b88c28e301e530266c6914f799e3d4fc85a3fedf2c17970ea7e1ddde3955cea)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetFuzz")
    def reset_fuzz(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFuzz", []))

    @jsii.member(jsii_name="resetFuzzVar")
    def reset_fuzz_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFuzzVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @builtins.property
    @jsii.member(jsii_name="fuzzInput")
    def fuzz_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fuzzInput"))

    @builtins.property
    @jsii.member(jsii_name="fuzzVarInput")
    def fuzz_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fuzzVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="fuzz")
    def fuzz(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fuzz"))

    @fuzz.setter
    def fuzz(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__14507c264dcdc63449f51a0baea1fbd44be9220229095b7aad398d755a4b017f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fuzz", value)

    @builtins.property
    @jsii.member(jsii_name="fuzzVar")
    def fuzz_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fuzzVar"))

    @fuzz_var.setter
    def fuzz_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__678797ea2d67b29478bbc6523907b364faf269f2a3c8fd9ee69c06b72d21eab4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fuzzVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2651d9037a48169ce893f0408e7e3570a686d0975ef9b1f8e08f3a6f22f563bc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__661e126e7619e157b919e8c2ef9e8543f955890a3eb378a02f3dc4849e00ce3d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitTrim]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitTrim]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitTrim]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c608a9d043bc5bfe6527dfbcbb7ab3232ec37f543b0dde895f7c0d06ad4de827)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitUnsharpMask",
    jsii_struct_bases=[],
    name_mapping={
        "gain": "gain",
        "gain_var": "gainVar",
        "sigma": "sigma",
        "sigma_var": "sigmaVar",
        "threshold": "threshold",
        "threshold_var": "thresholdVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitUnsharpMask:
    def __init__(
        self,
        *,
        gain: typing.Optional[builtins.str] = None,
        gain_var: typing.Optional[builtins.str] = None,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
        threshold: typing.Optional[builtins.str] = None,
        threshold_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param gain: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        :param gain_var: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        :param sigma: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        :param threshold: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        :param threshold_var: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__de1e3f55f54c14bd4197b9fee27789676170b29dedd4fde6138718e5c23f8802)
            check_type(argname="argument gain", value=gain, expected_type=type_hints["gain"])
            check_type(argname="argument gain_var", value=gain_var, expected_type=type_hints["gain_var"])
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
            check_type(argname="argument threshold", value=threshold, expected_type=type_hints["threshold"])
            check_type(argname="argument threshold_var", value=threshold_var, expected_type=type_hints["threshold_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if gain is not None:
            self._values["gain"] = gain
        if gain_var is not None:
            self._values["gain_var"] = gain_var
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var
        if threshold is not None:
            self._values["threshold"] = threshold
        if threshold_var is not None:
            self._values["threshold_var"] = threshold_var

    @builtins.property
    def gain(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        '''
        result = self._values.get("gain")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gain_var(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        '''
        result = self._values.get("gain_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        '''
        result = self._values.get("threshold")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold_var(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        result = self._values.get("threshold_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitUnsharpMask(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitUnsharpMaskList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitUnsharpMaskList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4f76e3e39ffbf20e453cc5e0b70df7dea997e7f65ea4a4e60f90ed086834408d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitUnsharpMaskOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__106079c635c9486e809ef6e1b9710e6fb57e50a5036210c65aa9c269706e9aa4)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitUnsharpMaskOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__66ebbbf74bc335a431815475c2ea19b717dc75aa268239ea80c47709c960c5e3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5c9631e04f221ad0f817f9ab0e74e289814a2a3d787ed232e417efd5f0552839)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b59f90b62734d1bd86fb53e60d19f2e2abd540f84451060e116c1e77d2606240)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitUnsharpMask]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitUnsharpMask]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitUnsharpMask]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__83e642cf9a7034c0920fddae10650e160d5ae01f0284e736e2e21e846afed026)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitUnsharpMaskOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitUnsharpMaskOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e2d9daf99cc8817cee97f7907775bbec7118d2839885c6823e85b85df170d38f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetGain")
    def reset_gain(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGain", []))

    @jsii.member(jsii_name="resetGainVar")
    def reset_gain_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGainVar", []))

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @jsii.member(jsii_name="resetThreshold")
    def reset_threshold(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThreshold", []))

    @jsii.member(jsii_name="resetThresholdVar")
    def reset_threshold_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThresholdVar", []))

    @builtins.property
    @jsii.member(jsii_name="gainInput")
    def gain_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainInput"))

    @builtins.property
    @jsii.member(jsii_name="gainVarInput")
    def gain_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdInput")
    def threshold_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdVarInput")
    def threshold_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gain")
    def gain(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gain"))

    @gain.setter
    def gain(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__06072c06a4e6c12b0def102b35303fd319f95bf908c7717aec5cd39e737008af)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gain", value)

    @builtins.property
    @jsii.member(jsii_name="gainVar")
    def gain_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gainVar"))

    @gain_var.setter
    def gain_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__088c5e5aa639773a00c35a9f8c78d8c8de8aab073e35edb3fdfd24afc6f8524f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gainVar", value)

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__13542aec2fb15caafc7becd06301052161d108800b1101f73944dd90e2ddab89)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__78d8f070517d996f5f7793a00ce1eb21cf6db1449df91ac2a74812d5e94be63d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="threshold")
    def threshold(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "threshold"))

    @threshold.setter
    def threshold(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2e5b8acc12b04ad0dd2853d5ab6ea42d0c94ea9dbf772eb5fae3ff04054cde6c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "threshold", value)

    @builtins.property
    @jsii.member(jsii_name="thresholdVar")
    def threshold_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "thresholdVar"))

    @threshold_var.setter
    def threshold_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a5f5f5dce80307aa6c5a0115cfd8c6a75a262cc7b604cda7db03f5afdf8b6329)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "thresholdVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitUnsharpMask]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitUnsharpMask]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitUnsharpMask]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3348ef5720637c0da3ecff139b3f257d83e4f5c6aaeac60dbd97c8addd0082a2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquare",
    jsii_struct_bases=[],
    name_mapping={
        "append": "append",
        "aspect_crop": "aspectCrop",
        "background_color": "backgroundColor",
        "blur": "blur",
        "chroma_key": "chromaKey",
        "composite": "composite",
        "compound": "compound",
        "contrast": "contrast",
        "crop": "crop",
        "face_crop": "faceCrop",
        "feature_crop": "featureCrop",
        "fit_and_fill": "fitAndFill",
        "goop": "goop",
        "grayscale": "grayscale",
        "hsl": "hsl",
        "hsv": "hsv",
        "if_dimension": "ifDimension",
        "if_orientation": "ifOrientation",
        "im_query": "imQuery",
        "max_colors": "maxColors",
        "mirror": "mirror",
        "mono_hue": "monoHue",
        "opacity": "opacity",
        "region_of_interest_crop": "regionOfInterestCrop",
        "relative_crop": "relativeCrop",
        "remove_color": "removeColor",
        "resize": "resize",
        "rotate": "rotate",
        "scale": "scale",
        "shear": "shear",
        "trim": "trim",
        "unsharp_mask": "unsharpMask",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquare:
    def __init__(
        self,
        *,
        append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareAppend", typing.Dict[builtins.str, typing.Any]]]]] = None,
        aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareAspectCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareBackgroundColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareBlur", typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareChromaKey", typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareComposite", typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareCompound", typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareContrast", typing.Dict[builtins.str, typing.Any]]]]] = None,
        crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareFaceCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareFeatureCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareFitAndFill", typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareGoop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareGrayscale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareHsl", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareHsv", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfDimension", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfOrientation", typing.Dict[builtins.str, typing.Any]]]]] = None,
        im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareImQuery", typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareMaxColors", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareMirror", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareMonoHue", typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareOpacity", typing.Dict[builtins.str, typing.Any]]]]] = None,
        region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareRegionOfInterestCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareRelativeCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareRemoveColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareResize", typing.Dict[builtins.str, typing.Any]]]]] = None,
        rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareRotate", typing.Dict[builtins.str, typing.Any]]]]] = None,
        scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareScale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareShear", typing.Dict[builtins.str, typing.Any]]]]] = None,
        trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareTrim", typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareUnsharpMask", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param append: append block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        :param aspect_crop: aspect_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param crop: crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        :param face_crop: face_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        :param feature_crop: feature_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        :param fit_and_fill: fit_and_fill block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param im_query: im_query block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param region_of_interest_crop: region_of_interest_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        :param relative_crop: relative_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param resize: resize block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        :param rotate: rotate block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        :param scale: scale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param shear: shear block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        :param trim: trim block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__72d07fa171fa2a82fc355b27beaf3653223e459849553f4765e34aa16645426b)
            check_type(argname="argument append", value=append, expected_type=type_hints["append"])
            check_type(argname="argument aspect_crop", value=aspect_crop, expected_type=type_hints["aspect_crop"])
            check_type(argname="argument background_color", value=background_color, expected_type=type_hints["background_color"])
            check_type(argname="argument blur", value=blur, expected_type=type_hints["blur"])
            check_type(argname="argument chroma_key", value=chroma_key, expected_type=type_hints["chroma_key"])
            check_type(argname="argument composite", value=composite, expected_type=type_hints["composite"])
            check_type(argname="argument compound", value=compound, expected_type=type_hints["compound"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument crop", value=crop, expected_type=type_hints["crop"])
            check_type(argname="argument face_crop", value=face_crop, expected_type=type_hints["face_crop"])
            check_type(argname="argument feature_crop", value=feature_crop, expected_type=type_hints["feature_crop"])
            check_type(argname="argument fit_and_fill", value=fit_and_fill, expected_type=type_hints["fit_and_fill"])
            check_type(argname="argument goop", value=goop, expected_type=type_hints["goop"])
            check_type(argname="argument grayscale", value=grayscale, expected_type=type_hints["grayscale"])
            check_type(argname="argument hsl", value=hsl, expected_type=type_hints["hsl"])
            check_type(argname="argument hsv", value=hsv, expected_type=type_hints["hsv"])
            check_type(argname="argument if_dimension", value=if_dimension, expected_type=type_hints["if_dimension"])
            check_type(argname="argument if_orientation", value=if_orientation, expected_type=type_hints["if_orientation"])
            check_type(argname="argument im_query", value=im_query, expected_type=type_hints["im_query"])
            check_type(argname="argument max_colors", value=max_colors, expected_type=type_hints["max_colors"])
            check_type(argname="argument mirror", value=mirror, expected_type=type_hints["mirror"])
            check_type(argname="argument mono_hue", value=mono_hue, expected_type=type_hints["mono_hue"])
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument region_of_interest_crop", value=region_of_interest_crop, expected_type=type_hints["region_of_interest_crop"])
            check_type(argname="argument relative_crop", value=relative_crop, expected_type=type_hints["relative_crop"])
            check_type(argname="argument remove_color", value=remove_color, expected_type=type_hints["remove_color"])
            check_type(argname="argument resize", value=resize, expected_type=type_hints["resize"])
            check_type(argname="argument rotate", value=rotate, expected_type=type_hints["rotate"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument shear", value=shear, expected_type=type_hints["shear"])
            check_type(argname="argument trim", value=trim, expected_type=type_hints["trim"])
            check_type(argname="argument unsharp_mask", value=unsharp_mask, expected_type=type_hints["unsharp_mask"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if append is not None:
            self._values["append"] = append
        if aspect_crop is not None:
            self._values["aspect_crop"] = aspect_crop
        if background_color is not None:
            self._values["background_color"] = background_color
        if blur is not None:
            self._values["blur"] = blur
        if chroma_key is not None:
            self._values["chroma_key"] = chroma_key
        if composite is not None:
            self._values["composite"] = composite
        if compound is not None:
            self._values["compound"] = compound
        if contrast is not None:
            self._values["contrast"] = contrast
        if crop is not None:
            self._values["crop"] = crop
        if face_crop is not None:
            self._values["face_crop"] = face_crop
        if feature_crop is not None:
            self._values["feature_crop"] = feature_crop
        if fit_and_fill is not None:
            self._values["fit_and_fill"] = fit_and_fill
        if goop is not None:
            self._values["goop"] = goop
        if grayscale is not None:
            self._values["grayscale"] = grayscale
        if hsl is not None:
            self._values["hsl"] = hsl
        if hsv is not None:
            self._values["hsv"] = hsv
        if if_dimension is not None:
            self._values["if_dimension"] = if_dimension
        if if_orientation is not None:
            self._values["if_orientation"] = if_orientation
        if im_query is not None:
            self._values["im_query"] = im_query
        if max_colors is not None:
            self._values["max_colors"] = max_colors
        if mirror is not None:
            self._values["mirror"] = mirror
        if mono_hue is not None:
            self._values["mono_hue"] = mono_hue
        if opacity is not None:
            self._values["opacity"] = opacity
        if region_of_interest_crop is not None:
            self._values["region_of_interest_crop"] = region_of_interest_crop
        if relative_crop is not None:
            self._values["relative_crop"] = relative_crop
        if remove_color is not None:
            self._values["remove_color"] = remove_color
        if resize is not None:
            self._values["resize"] = resize
        if rotate is not None:
            self._values["rotate"] = rotate
        if scale is not None:
            self._values["scale"] = scale
        if shear is not None:
            self._values["shear"] = shear
        if trim is not None:
            self._values["trim"] = trim
        if unsharp_mask is not None:
            self._values["unsharp_mask"] = unsharp_mask

    @builtins.property
    def append(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareAppend"]]]:
        '''append block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        '''
        result = self._values.get("append")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareAppend"]]], result)

    @builtins.property
    def aspect_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareAspectCrop"]]]:
        '''aspect_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        '''
        result = self._values.get("aspect_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareAspectCrop"]]], result)

    @builtins.property
    def background_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareBackgroundColor"]]]:
        '''background_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        '''
        result = self._values.get("background_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareBackgroundColor"]]], result)

    @builtins.property
    def blur(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareBlur"]]]:
        '''blur block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        '''
        result = self._values.get("blur")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareBlur"]]], result)

    @builtins.property
    def chroma_key(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareChromaKey"]]]:
        '''chroma_key block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        '''
        result = self._values.get("chroma_key")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareChromaKey"]]], result)

    @builtins.property
    def composite(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareComposite"]]]:
        '''composite block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        '''
        result = self._values.get("composite")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareComposite"]]], result)

    @builtins.property
    def compound(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareCompound"]]]:
        '''compound block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        '''
        result = self._values.get("compound")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareCompound"]]], result)

    @builtins.property
    def contrast(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareContrast"]]]:
        '''contrast block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareContrast"]]], result)

    @builtins.property
    def crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareCrop"]]]:
        '''crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        '''
        result = self._values.get("crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareCrop"]]], result)

    @builtins.property
    def face_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareFaceCrop"]]]:
        '''face_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        '''
        result = self._values.get("face_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareFaceCrop"]]], result)

    @builtins.property
    def feature_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareFeatureCrop"]]]:
        '''feature_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        '''
        result = self._values.get("feature_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareFeatureCrop"]]], result)

    @builtins.property
    def fit_and_fill(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareFitAndFill"]]]:
        '''fit_and_fill block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        '''
        result = self._values.get("fit_and_fill")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareFitAndFill"]]], result)

    @builtins.property
    def goop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareGoop"]]]:
        '''goop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        '''
        result = self._values.get("goop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareGoop"]]], result)

    @builtins.property
    def grayscale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareGrayscale"]]]:
        '''grayscale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        '''
        result = self._values.get("grayscale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareGrayscale"]]], result)

    @builtins.property
    def hsl(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareHsl"]]]:
        '''hsl block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        '''
        result = self._values.get("hsl")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareHsl"]]], result)

    @builtins.property
    def hsv(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareHsv"]]]:
        '''hsv block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        '''
        result = self._values.get("hsv")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareHsv"]]], result)

    @builtins.property
    def if_dimension(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfDimension"]]]:
        '''if_dimension block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        '''
        result = self._values.get("if_dimension")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfDimension"]]], result)

    @builtins.property
    def if_orientation(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfOrientation"]]]:
        '''if_orientation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        '''
        result = self._values.get("if_orientation")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfOrientation"]]], result)

    @builtins.property
    def im_query(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareImQuery"]]]:
        '''im_query block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        '''
        result = self._values.get("im_query")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareImQuery"]]], result)

    @builtins.property
    def max_colors(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareMaxColors"]]]:
        '''max_colors block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        '''
        result = self._values.get("max_colors")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareMaxColors"]]], result)

    @builtins.property
    def mirror(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareMirror"]]]:
        '''mirror block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        '''
        result = self._values.get("mirror")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareMirror"]]], result)

    @builtins.property
    def mono_hue(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareMonoHue"]]]:
        '''mono_hue block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        '''
        result = self._values.get("mono_hue")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareMonoHue"]]], result)

    @builtins.property
    def opacity(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareOpacity"]]]:
        '''opacity block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareOpacity"]]], result)

    @builtins.property
    def region_of_interest_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareRegionOfInterestCrop"]]]:
        '''region_of_interest_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        '''
        result = self._values.get("region_of_interest_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareRegionOfInterestCrop"]]], result)

    @builtins.property
    def relative_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareRelativeCrop"]]]:
        '''relative_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        '''
        result = self._values.get("relative_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareRelativeCrop"]]], result)

    @builtins.property
    def remove_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareRemoveColor"]]]:
        '''remove_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        '''
        result = self._values.get("remove_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareRemoveColor"]]], result)

    @builtins.property
    def resize(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareResize"]]]:
        '''resize block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        '''
        result = self._values.get("resize")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareResize"]]], result)

    @builtins.property
    def rotate(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareRotate"]]]:
        '''rotate block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        '''
        result = self._values.get("rotate")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareRotate"]]], result)

    @builtins.property
    def scale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareScale"]]]:
        '''scale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareScale"]]], result)

    @builtins.property
    def shear(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareShear"]]]:
        '''shear block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        '''
        result = self._values.get("shear")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareShear"]]], result)

    @builtins.property
    def trim(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareTrim"]]]:
        '''trim block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        '''
        result = self._values.get("trim")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareTrim"]]], result)

    @builtins.property
    def unsharp_mask(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareUnsharpMask"]]]:
        '''unsharp_mask block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        result = self._values.get("unsharp_mask")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareUnsharpMask"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquare(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareAppend",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_priority": "gravityPriority",
        "gravity_priority_var": "gravityPriorityVar",
        "gravity_var": "gravityVar",
        "preserve_minor_dimension": "preserveMinorDimension",
        "preserve_minor_dimension_var": "preserveMinorDimensionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareAppend:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareAppendImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_priority: typing.Optional[builtins.str] = None,
        gravity_priority_var: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        preserve_minor_dimension: typing.Optional[builtins.str] = None,
        preserve_minor_dimension_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Specifies where to place the ``image`` relative to the source image. The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_priority: Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal. The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority DataAkamaiImagingPolicyImage#gravity_priority}
        :param gravity_priority_var: Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal. The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority_var DataAkamaiImagingPolicyImage#gravity_priority_var}
        :param gravity_var: Specifies where to place the ``image`` relative to the source image. The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param preserve_minor_dimension: Whether to preserve the source image's minor dimension, ``false`` by default. The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension DataAkamaiImagingPolicyImage#preserve_minor_dimension}
        :param preserve_minor_dimension_var: Whether to preserve the source image's minor dimension, ``false`` by default. The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension_var DataAkamaiImagingPolicyImage#preserve_minor_dimension_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareAppendImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fb1a93e2a5563a1fe4f9c0edc794bfaa85fc15236355a3134e56d57915057bc5)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_priority", value=gravity_priority, expected_type=type_hints["gravity_priority"])
            check_type(argname="argument gravity_priority_var", value=gravity_priority_var, expected_type=type_hints["gravity_priority_var"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument preserve_minor_dimension", value=preserve_minor_dimension, expected_type=type_hints["preserve_minor_dimension"])
            check_type(argname="argument preserve_minor_dimension_var", value=preserve_minor_dimension_var, expected_type=type_hints["preserve_minor_dimension_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_priority is not None:
            self._values["gravity_priority"] = gravity_priority
        if gravity_priority_var is not None:
            self._values["gravity_priority_var"] = gravity_priority_var
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if preserve_minor_dimension is not None:
            self._values["preserve_minor_dimension"] = preserve_minor_dimension
        if preserve_minor_dimension_var is not None:
            self._values["preserve_minor_dimension_var"] = preserve_minor_dimension_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareAppendImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareAppendImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Specifies where to place the ``image`` relative to the source image.

        The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_priority(self) -> typing.Optional[builtins.str]:
        '''Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal.

        The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority DataAkamaiImagingPolicyImage#gravity_priority}
        '''
        result = self._values.get("gravity_priority")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_priority_var(self) -> typing.Optional[builtins.str]:
        '''Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal.

        The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority_var DataAkamaiImagingPolicyImage#gravity_priority_var}
        '''
        result = self._values.get("gravity_priority_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Specifies where to place the ``image`` relative to the source image.

        The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def preserve_minor_dimension(self) -> typing.Optional[builtins.str]:
        '''Whether to preserve the source image's minor dimension, ``false`` by default.

        The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension DataAkamaiImagingPolicyImage#preserve_minor_dimension}
        '''
        result = self._values.get("preserve_minor_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def preserve_minor_dimension_var(self) -> typing.Optional[builtins.str]:
        '''Whether to preserve the source image's minor dimension, ``false`` by default.

        The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension_var DataAkamaiImagingPolicyImage#preserve_minor_dimension_var}
        '''
        result = self._values.get("preserve_minor_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareAppend(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareAppendImage",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareAppendImage:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareAppendImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareAppendImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareAppendImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__058e0471bf8ef700ff737e1cefd9fd708d4fa028ffdeb82626bb1f702a17fe89)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareAppendImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareAppendImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareAppendImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__888d573cf46004f8519878bdaec82df6cf4259bebce87c926cd2cdd4ba8c61a6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareAppendList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareAppendList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0c9c53d0c33fecf8ab10d33325d5a1cf9aebcd812f7ae69aaeb9c1e3afd95035)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareAppendOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c420c94cead23d1f1f9a0b81b219efc13cb954b367ba91eb3f1ae5d7c92d6d83)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareAppendOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__624f43121aaba21b8b01a4ca60b271634f2d7bcb2c0e6ba336f4dbb7f4e46b9d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2cc0418fb481bcc1ec5fdb8e7769b2cd9d40170b5f52fab909e2ae3e9817d987)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2f45fcb43cf0f61d67e7ffe6ac534bac72ccdbf540e0cdb127e67b6837de9997)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareAppend]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareAppend]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareAppend]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b7013f508cae769a06657b80eebdf6d74f6868e63a93139b78a0e540fea35dc4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareAppendOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareAppendOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__24abf36d444da0c7cc058d400558930808029c816d23ad074ee16389230150cc)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareAppendImage()

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityPriority")
    def reset_gravity_priority(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityPriority", []))

    @jsii.member(jsii_name="resetGravityPriorityVar")
    def reset_gravity_priority_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityPriorityVar", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPreserveMinorDimension")
    def reset_preserve_minor_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPreserveMinorDimension", []))

    @jsii.member(jsii_name="resetPreserveMinorDimensionVar")
    def reset_preserve_minor_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPreserveMinorDimensionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareAppendImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareAppendImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityInput")
    def gravity_priority_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityPriorityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityVarInput")
    def gravity_priority_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityPriorityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareAppendImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareAppendImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionInput")
    def preserve_minor_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "preserveMinorDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionVarInput")
    def preserve_minor_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "preserveMinorDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__082de37d42d849094c9532233ae5d39a01e6e32d81f12aff0bd0f5b96509bad8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityPriority")
    def gravity_priority(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityPriority"))

    @gravity_priority.setter
    def gravity_priority(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9bc9d4416ef676a19bf23a1378a8ce46ee13eaee4fae5fa1c1361a4351f65a7e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityPriority", value)

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityVar")
    def gravity_priority_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityPriorityVar"))

    @gravity_priority_var.setter
    def gravity_priority_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6fcd0ae15eab94feee37afda9eb67540ea6b89bf139e94db83100c39bf3135da)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityPriorityVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f8ae4a7b36e4e920c22a88f4fc8f17ac8200ec40a9f97bd415607a15793b5a61)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimension")
    def preserve_minor_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "preserveMinorDimension"))

    @preserve_minor_dimension.setter
    def preserve_minor_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d1630d60607c726c8d7462bb73b8e2f8a8c2f8ac56900e459131228ed13f9262)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "preserveMinorDimension", value)

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionVar")
    def preserve_minor_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "preserveMinorDimensionVar"))

    @preserve_minor_dimension_var.setter
    def preserve_minor_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fd522904343dc1baea95349e817a45e553abc46ff299ad8f978fa96ed1b35432)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "preserveMinorDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareAppend]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareAppend]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareAppend]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fe4828357411f3605f156f43cf90f0f24751386efd8ba604d45d635c53b5ae66)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareAspectCrop",
    jsii_struct_bases=[],
    name_mapping={
        "allow_expansion": "allowExpansion",
        "allow_expansion_var": "allowExpansionVar",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareAspectCrop:
    def __init__(
        self,
        *,
        allow_expansion: typing.Optional[builtins.str] = None,
        allow_expansion_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_expansion: Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image. Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        :param allow_expansion_var: Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image. Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        :param height: The height term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The width term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        :param x_position: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5825af4271e9aed7f380e0dd9d7830980ed54db9f56ba61b7bacd4cc677d5d8b)
            check_type(argname="argument allow_expansion", value=allow_expansion, expected_type=type_hints["allow_expansion"])
            check_type(argname="argument allow_expansion_var", value=allow_expansion_var, expected_type=type_hints["allow_expansion_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if allow_expansion is not None:
            self._values["allow_expansion"] = allow_expansion
        if allow_expansion_var is not None:
            self._values["allow_expansion_var"] = allow_expansion_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def allow_expansion(self) -> typing.Optional[builtins.str]:
        '''Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image.

        Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        '''
        result = self._values.get("allow_expansion")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def allow_expansion_var(self) -> typing.Optional[builtins.str]:
        '''Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image.

        Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        '''
        result = self._values.get("allow_expansion_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareAspectCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareAspectCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareAspectCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7defc05765a2cab951df12dcf8e630ebae0606440a1d7e3e53b01b3facfc32c5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareAspectCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ebacae8398b804a371a586ef2a5397c643dee66ca6fce3d4b656c3f1916f3cee)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareAspectCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__755d040f2deb1f7670b889f285aba144f111bc61dd9919cc19200c79f2e42c1c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__37e75dd84552028e62edcc23f5a60b62af3b75b554741f985a11919ee3e9b6a2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__190666876d0955c0a4b6eb80caeeb5dfcde9e7ffb37a57af128065b5377270ec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareAspectCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareAspectCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareAspectCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac94b36b7470c438691ea6fb0846d1edcaaac14c917c54c9da9241cea795b6cd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareAspectCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareAspectCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc5cff50f12353cab49c19a857ffe3c5d10fc06d4a7a8f18061cd3820f6ac4e4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAllowExpansion")
    def reset_allow_expansion(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansion", []))

    @jsii.member(jsii_name="resetAllowExpansionVar")
    def reset_allow_expansion_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansionVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionInput")
    def allow_expansion_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVarInput")
    def allow_expansion_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansion")
    def allow_expansion(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansion"))

    @allow_expansion.setter
    def allow_expansion(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__82d5a62568a768d48af8752e2866789109d421e6bf55ee573213c4176b8a47ac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansion", value)

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVar")
    def allow_expansion_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansionVar"))

    @allow_expansion_var.setter
    def allow_expansion_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__84f35cdb4878c93d3e9037eab2ee8e9a5e38dc07a783b19d9690cca7a755f812)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansionVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e528c434fbbd079cb9b2cefc668e7ea70fed6be00359dd2954d0855044cc0fa6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__db5e12d2f40198e345de4213efc24ba31d8ad25f31ef690e6df89188d1af82bd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4412416fc5f46f88c8e17363809c3028cf94ac79218463fd3e4039058996945b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5238e1a6906743e39cff3e3f388cd0821dd3d473c019fb8a1de054491e9e9bac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a30f150693898c2990a3af4c93d086353b3de0cade7674aea813815153f2a050)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4cae0df8210f5d7931f5d7f4a6e39cedfb454fe3344648de86338df30db61317)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ade9d121a5559e49dfe221c49d77a7b6c5b1db905b33e6502ead1a2425ca94c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a4657fbbb89881716e30e14795d321d3c7d69c3e8b187c4863e9bf6e8406adc9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareAspectCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareAspectCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareAspectCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__15b1bfdcabcf9b0ce921a39ec7b45ff821a99bc6fce5ddc487786b2638ee7e5e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareBackgroundColor",
    jsii_struct_bases=[],
    name_mapping={"color": "color", "color_var": "colorVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareBackgroundColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__26f8b4e6aad64cfabe9156e82b85a294f4150eaee1ae61ab536bf072cbec99c2)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareBackgroundColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareBackgroundColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareBackgroundColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__810b93c76f5aec4bc4edccd48206e8f46e1fd60184061cc33ad9dd37bffbb805)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareBackgroundColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6a9e0180ffea15e3e9c50916259bfd45f03c56ec0b580dea93ecc4af524abaa6)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareBackgroundColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b2abd164169dd263176289ee28c47f9e556dcd451c53458d43798c6982d35153)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ba50c683d7e5a2dd08b34aff17b43bb7ad53527011cf1e5e13a4b4a212f96aa7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__410caac34282f948dc9e3e507a8ca24af2d33cdd937b5bacd777cdccb7a2174f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareBackgroundColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareBackgroundColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ad1f0a4769d2bf4cf71a96d45330191811219c3fc06946c867f6c142039b5c13)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareBackgroundColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareBackgroundColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0e5d1975feea98fe77895c29b3519b99f5b7b5b2c95d6720a254ad1c7728aea7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b485e2a5edb62a4da226773679b1d1ab1fec3f1c353c4c958146ee3b9f4285ee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1e771ba547e03a730acd80a391406c196ea9a4fc55ec040f475b481201bdf51d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareBackgroundColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareBackgroundColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareBackgroundColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aa097e10a93803447a58ae6ce9d52b920c564e02ebefb16a1074ebf7f22b89ec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareBlur",
    jsii_struct_bases=[],
    name_mapping={"sigma": "sigma", "sigma_var": "sigmaVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareBlur:
    def __init__(
        self,
        *,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param sigma: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__56ecc97b5b3e3f4fe8edd073f12f866459ea1c73241721857d8a9aec0201012b)
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareBlur(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareBlurList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareBlurList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c53bca8a73e99337e6cf7523d72819bf0f0eabef328329396bd2b904e152e2ba)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareBlurOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5738539efbf6582eb7074299b83fffec5019433019b54f0c7a884cb6a0a682f5)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareBlurOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__efdd67eab4452a20268e6b06b11f02591fd05ed601f32ef693775eeb1b6eacfb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a5d1fe12d7963a9b5db85ac36221162970edbbf628d3b6255a11fd7cd7911dd5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__43948f9afd9c2b9570001533409e23a0faffe758d6f70dd43b3b4f348ebf402d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareBlur]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareBlur]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5c8bad657f97d2669cb11eac7631c262182054cd46905530b04bd01277f401aa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareBlurOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareBlurOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__47c23f6209aa20e5deee675351ce85a963b0bfb86c58b8cf7a819aecdf4b8685)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5563dc301f3fa927beb619447e979cd10d1a0729ade93fee7b911d3799d2a2d5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a3f02c0e47e4af0b082a483ef9a207e9a2d0827d67f9db57854dbfd539ce38d2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareBlur]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareBlur]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareBlur]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__47904fc5327ef76882b4cb959dd6f0cdd1f30ce158620a69edce11910197b075)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareChromaKey",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_feather": "hueFeather",
        "hue_feather_var": "hueFeatherVar",
        "hue_tolerance": "hueTolerance",
        "hue_tolerance_var": "hueToleranceVar",
        "hue_var": "hueVar",
        "lightness_feather": "lightnessFeather",
        "lightness_feather_var": "lightnessFeatherVar",
        "lightness_tolerance": "lightnessTolerance",
        "lightness_tolerance_var": "lightnessToleranceVar",
        "saturation_feather": "saturationFeather",
        "saturation_feather_var": "saturationFeatherVar",
        "saturation_tolerance": "saturationTolerance",
        "saturation_tolerance_var": "saturationToleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareChromaKey:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_feather: typing.Optional[builtins.str] = None,
        hue_feather_var: typing.Optional[builtins.str] = None,
        hue_tolerance: typing.Optional[builtins.str] = None,
        hue_tolerance_var: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness_feather: typing.Optional[builtins.str] = None,
        lightness_feather_var: typing.Optional[builtins.str] = None,
        lightness_tolerance: typing.Optional[builtins.str] = None,
        lightness_tolerance_var: typing.Optional[builtins.str] = None,
        saturation_feather: typing.Optional[builtins.str] = None,
        saturation_feather_var: typing.Optional[builtins.str] = None,
        saturation_tolerance: typing.Optional[builtins.str] = None,
        saturation_tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_feather: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        :param hue_feather_var: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        :param hue_tolerance: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        :param hue_tolerance_var: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        :param hue_var: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness_feather: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        :param lightness_feather_var: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        :param lightness_tolerance: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        :param lightness_tolerance_var: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        :param saturation_feather: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        :param saturation_feather_var: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        :param saturation_tolerance: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        :param saturation_tolerance_var: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ba2e011d88876bb24ab40fb9da2dddc70b57e48173344bc31deda979ffada91)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_feather", value=hue_feather, expected_type=type_hints["hue_feather"])
            check_type(argname="argument hue_feather_var", value=hue_feather_var, expected_type=type_hints["hue_feather_var"])
            check_type(argname="argument hue_tolerance", value=hue_tolerance, expected_type=type_hints["hue_tolerance"])
            check_type(argname="argument hue_tolerance_var", value=hue_tolerance_var, expected_type=type_hints["hue_tolerance_var"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness_feather", value=lightness_feather, expected_type=type_hints["lightness_feather"])
            check_type(argname="argument lightness_feather_var", value=lightness_feather_var, expected_type=type_hints["lightness_feather_var"])
            check_type(argname="argument lightness_tolerance", value=lightness_tolerance, expected_type=type_hints["lightness_tolerance"])
            check_type(argname="argument lightness_tolerance_var", value=lightness_tolerance_var, expected_type=type_hints["lightness_tolerance_var"])
            check_type(argname="argument saturation_feather", value=saturation_feather, expected_type=type_hints["saturation_feather"])
            check_type(argname="argument saturation_feather_var", value=saturation_feather_var, expected_type=type_hints["saturation_feather_var"])
            check_type(argname="argument saturation_tolerance", value=saturation_tolerance, expected_type=type_hints["saturation_tolerance"])
            check_type(argname="argument saturation_tolerance_var", value=saturation_tolerance_var, expected_type=type_hints["saturation_tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_feather is not None:
            self._values["hue_feather"] = hue_feather
        if hue_feather_var is not None:
            self._values["hue_feather_var"] = hue_feather_var
        if hue_tolerance is not None:
            self._values["hue_tolerance"] = hue_tolerance
        if hue_tolerance_var is not None:
            self._values["hue_tolerance_var"] = hue_tolerance_var
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness_feather is not None:
            self._values["lightness_feather"] = lightness_feather
        if lightness_feather_var is not None:
            self._values["lightness_feather_var"] = lightness_feather_var
        if lightness_tolerance is not None:
            self._values["lightness_tolerance"] = lightness_tolerance
        if lightness_tolerance_var is not None:
            self._values["lightness_tolerance_var"] = lightness_tolerance_var
        if saturation_feather is not None:
            self._values["saturation_feather"] = saturation_feather
        if saturation_feather_var is not None:
            self._values["saturation_feather_var"] = saturation_feather_var
        if saturation_tolerance is not None:
            self._values["saturation_tolerance"] = saturation_tolerance
        if saturation_tolerance_var is not None:
            self._values["saturation_tolerance_var"] = saturation_tolerance_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        '''
        result = self._values.get("hue_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        '''
        result = self._values.get("hue_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        '''
        result = self._values.get("hue_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        '''
        result = self._values.get("hue_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        '''
        result = self._values.get("lightness_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        '''
        result = self._values.get("lightness_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        '''
        result = self._values.get("lightness_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        '''
        result = self._values.get("lightness_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        '''
        result = self._values.get("saturation_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        '''
        result = self._values.get("saturation_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        '''
        result = self._values.get("saturation_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        result = self._values.get("saturation_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareChromaKey(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareChromaKeyList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareChromaKeyList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__535d0609e3eed6baf2491e677877a9984beee275d12326b28e37da78a2bc8fa0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareChromaKeyOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a6f72665ab351dc77c58d2a337d4bbb3a57593d605f8f97233b1fc710e45e8cc)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareChromaKeyOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__839f889bde8de9e4d91a58e6b79dd9528eaa1517cda8e34287c57e811d1cf70d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3f7b9c239aea981a65878585b8b83bda988eb063e5a52eb6199de9af758b4f25)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3caa417accbf6a364da29ccaf7caa48fc340cad5ddcd19c0c4f81756b93c3abe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareChromaKey]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareChromaKey]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2251479d4d841409a018ce1a0e9767db65c95756dbb6b8e48592762b40da3eff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareChromaKeyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareChromaKeyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1a71b0b090c2b266ec5e97a092a9647c9ca91a66238e2ddfbc4624176d097857)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueFeather")
    def reset_hue_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeather", []))

    @jsii.member(jsii_name="resetHueFeatherVar")
    def reset_hue_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeatherVar", []))

    @jsii.member(jsii_name="resetHueTolerance")
    def reset_hue_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueTolerance", []))

    @jsii.member(jsii_name="resetHueToleranceVar")
    def reset_hue_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueToleranceVar", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightnessFeather")
    def reset_lightness_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeather", []))

    @jsii.member(jsii_name="resetLightnessFeatherVar")
    def reset_lightness_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeatherVar", []))

    @jsii.member(jsii_name="resetLightnessTolerance")
    def reset_lightness_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessTolerance", []))

    @jsii.member(jsii_name="resetLightnessToleranceVar")
    def reset_lightness_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessToleranceVar", []))

    @jsii.member(jsii_name="resetSaturationFeather")
    def reset_saturation_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeather", []))

    @jsii.member(jsii_name="resetSaturationFeatherVar")
    def reset_saturation_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeatherVar", []))

    @jsii.member(jsii_name="resetSaturationTolerance")
    def reset_saturation_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationTolerance", []))

    @jsii.member(jsii_name="resetSaturationToleranceVar")
    def reset_saturation_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherInput")
    def hue_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVarInput")
    def hue_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceInput")
    def hue_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVarInput")
    def hue_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherInput")
    def lightness_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVarInput")
    def lightness_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceInput")
    def lightness_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVarInput")
    def lightness_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherInput")
    def saturation_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVarInput")
    def saturation_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceInput")
    def saturation_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVarInput")
    def saturation_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ed19502226409672942e7eaf5b4358234212566c9de4d5350297f28daa816de1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeather")
    def hue_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeather"))

    @hue_feather.setter
    def hue_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7f7a4ce8912863818e223d6b6e0b699929bed826d346a090223983b644758e09)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeather", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVar")
    def hue_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeatherVar"))

    @hue_feather_var.setter
    def hue_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cbe4b75675a01e593309ed13206f06baeb7cb96cafb22356022bc5a855221757)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueTolerance")
    def hue_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueTolerance"))

    @hue_tolerance.setter
    def hue_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__db831d6ae88d9d7136ecde168f566192b65a6f3439df8d6de3b67c45dc213f6a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVar")
    def hue_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueToleranceVar"))

    @hue_tolerance_var.setter
    def hue_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aa81a02129bc70f5a7107a510aa609d47a6b9664701462163f26cd0626e59cdf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__35ad38b682ac1e21f2c5e82a54cf61f2d8048ad5cfde42eb10ed6c6708708053)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeather")
    def lightness_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeather"))

    @lightness_feather.setter
    def lightness_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__98a30c5d045edf76c1bd53464838d35e4e199f7171719949336f0a89cfbcea59)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeather", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVar")
    def lightness_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeatherVar"))

    @lightness_feather_var.setter
    def lightness_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eb50068d1acaf224c2c7819af0bfb4094df4d89fcffdf3f9d1efdd1c0e5c9161)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessTolerance")
    def lightness_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessTolerance"))

    @lightness_tolerance.setter
    def lightness_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f2b467bb2c430087490c1d666c2dc36400bd9a781223779429dbce7a84b4b2e5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVar")
    def lightness_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessToleranceVar"))

    @lightness_tolerance_var.setter
    def lightness_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dab3ebad8dc0b3632b04261aecd88557c3e7e8c6d0a838870b60e4178ef8606a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeather")
    def saturation_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeather"))

    @saturation_feather.setter
    def saturation_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2548ab5d8f60a82d19d9da662ae6c9e40a510c8668a5746ce3ec29aad6e02ccf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeather", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVar")
    def saturation_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeatherVar"))

    @saturation_feather_var.setter
    def saturation_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f200b58a46ed50ac41de9571f09d5237a131a37659feec0078cdfe2bb2ebafe5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationTolerance")
    def saturation_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationTolerance"))

    @saturation_tolerance.setter
    def saturation_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ec3721be699652cda86c7e33523c012601d8e27b4d94efb9a0d0a004284b0a9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVar")
    def saturation_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationToleranceVar"))

    @saturation_tolerance_var.setter
    def saturation_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0c1f3e8f604d58d7dd3152045d986665148530e4527d1901104f1541a22c54d9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareChromaKey]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareChromaKey]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareChromaKey]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__42354fd08fa921fb75863260ed53a0c1fd0b2a6a4826b3ab9d700ccab9566f95)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareComposite",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "placement": "placement",
        "placement_var": "placementVar",
        "scale": "scale",
        "scale_dimension": "scaleDimension",
        "scale_dimension_var": "scaleDimensionVar",
        "scale_var": "scaleVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareComposite:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareCompositeImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        placement: typing.Optional[builtins.str] = None,
        placement_var: typing.Optional[builtins.str] = None,
        scale: typing.Optional[builtins.str] = None,
        scale_dimension: typing.Optional[builtins.str] = None,
        scale_dimension_var: typing.Optional[builtins.str] = None,
        scale_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param placement: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        :param placement_var: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        :param scale: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param scale_dimension: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        :param scale_dimension_var: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        :param scale_var: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        :param x_position: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareCompositeImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bbdabb9649bca4efe21ef8db5e903f5810908466a580fce1ef9ed7cbdaf5a83e)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument placement", value=placement, expected_type=type_hints["placement"])
            check_type(argname="argument placement_var", value=placement_var, expected_type=type_hints["placement_var"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument scale_dimension", value=scale_dimension, expected_type=type_hints["scale_dimension"])
            check_type(argname="argument scale_dimension_var", value=scale_dimension_var, expected_type=type_hints["scale_dimension_var"])
            check_type(argname="argument scale_var", value=scale_var, expected_type=type_hints["scale_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if placement is not None:
            self._values["placement"] = placement
        if placement_var is not None:
            self._values["placement_var"] = placement_var
        if scale is not None:
            self._values["scale"] = scale
        if scale_dimension is not None:
            self._values["scale_dimension"] = scale_dimension
        if scale_dimension_var is not None:
            self._values["scale_dimension_var"] = scale_dimension_var
        if scale_var is not None:
            self._values["scale_var"] = scale_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareCompositeImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareCompositeImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        '''
        result = self._values.get("placement")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement_var(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        '''
        result = self._values.get("placement_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        '''
        result = self._values.get("scale_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        '''
        result = self._values.get("scale_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        '''
        result = self._values.get("scale_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareComposite(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareCompositeImage",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareCompositeImage:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareCompositeImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareCompositeImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareCompositeImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__34f57904c92bcbb5af943c65914b861d8b796e5bcf5f6295ba4f4b907fff07a4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareCompositeImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareCompositeImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aa9b263b4b7ecd8c187fdc7c9acb44b4445b53653d518c5b445b877c9cb2aa0a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareCompositeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareCompositeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f8a5b1ac2e4d1fda4a2ea57c1381c75beda1bc39c9bfe39962fe8b40570358e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareCompositeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dcd29a7d1f4a36540f60dde2a1882516d3692f5c46fa128e968bd3260843f6d8)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareCompositeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7b28bad3dd958b40e9a3de2c08c8be4472792dd4bad62b4c81168080291994ee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9c84511cdfa824e8168fe5d9aa978f78afc6aa11eb7f75140835246ed22d516f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f0f43c5f4f696907ccf6ee54d323b54045c4e13f6eef8f335c814fad53889aca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareComposite]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareComposite]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3f9e7dd4e1b213f478cd9d4ffd5fae8a4a7fad1e51ec36b7e331bb6b88110a42)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareCompositeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareCompositeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1eb563cc0405c2c7efaaea69c5da98440b77af2aa0f762e07a1e0cf5c58ee986)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareCompositeImage()

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPlacement")
    def reset_placement(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacement", []))

    @jsii.member(jsii_name="resetPlacementVar")
    def reset_placement_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacementVar", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetScaleDimension")
    def reset_scale_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimension", []))

    @jsii.member(jsii_name="resetScaleDimensionVar")
    def reset_scale_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimensionVar", []))

    @jsii.member(jsii_name="resetScaleVar")
    def reset_scale_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareCompositeImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareCompositeImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareCompositeImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="placementInput")
    def placement_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementInput"))

    @builtins.property
    @jsii.member(jsii_name="placementVarInput")
    def placement_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionInput")
    def scale_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVarInput")
    def scale_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleVarInput")
    def scale_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__727f9d7615d0d3ee8fe77722d1a504a81bd5f278af3b9c6fb6ab7d67d86d698b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1feef7eda31f881473d12d4aaa26cd8c5ed000f0aa2f76b7a014a59025d6c9e6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="placement")
    def placement(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placement"))

    @placement.setter
    def placement(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f3b08fd514c8ada32e3c8390b5f7fa0361f051864a6ad53793c69e244161c145)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placement", value)

    @builtins.property
    @jsii.member(jsii_name="placementVar")
    def placement_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placementVar"))

    @placement_var.setter
    def placement_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__823dd8cc6a00d54fcd082029cf9786338ac753aa5f9f445f33f7c883f802016d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placementVar", value)

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scale"))

    @scale.setter
    def scale(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__48cbcc3e633540774a3cc7a3cbb3f3de6f9f7f5957c2cd664ac30b4b57d66b32)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scale", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimension")
    def scale_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimension"))

    @scale_dimension.setter
    def scale_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__86c4b7f857848573d0b5e91b80982af45d9355ded87a03adec54aeb7b2da70ce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimension", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVar")
    def scale_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimensionVar"))

    @scale_dimension_var.setter
    def scale_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__93362b46e96e8dc4a45517f80657e77f1393b38e14e9b2a1256788d631d52af4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="scaleVar")
    def scale_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleVar"))

    @scale_var.setter
    def scale_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__77db55aa2cceeca81d4107f2b50125c27b166fa1be991ed80c69541e480da80f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ed21b694af2c2853022c7d3941ed49d9754b487026e44bb39f50a5e51a615121)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c04e209cb6761d2b5e1017cb484ed7f7a14247caf22639f8cd0d9293332854ba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7c0a6d6b3be2f35e03683e9f64810fe087aa4ecb593760810e7874eba29496ea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__58ce80439ff5597345e138bca61f6fe9a3681c53258f3234c7aebedc9f6f09b9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareComposite]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareComposite]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareComposite]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__185d8d87780dd48e85638c8f9a1e4a34bb7e21333742b57f32114c9b1a9e73cf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareCompound",
    jsii_struct_bases=[],
    name_mapping={"transformations": "transformations"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareCompound:
    def __init__(
        self,
        *,
        transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param transformations: transformations block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__15f2b2a69ee03b21638d4c04b1bf73fb45c65d9984274a13de537811e3a84281)
            check_type(argname="argument transformations", value=transformations, expected_type=type_hints["transformations"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if transformations is not None:
            self._values["transformations"] = transformations

    @builtins.property
    def transformations(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareCompoundTransformations"]]]:
        '''transformations block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        result = self._values.get("transformations")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareCompoundTransformations"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareCompound(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareCompoundList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareCompoundList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__193a0d0c33cf1b53c1312ba0003466a300bcf631215a0cd96db88cf0d83939f1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareCompoundOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cc8a55a527c40b4f2b9f794b0246ba91fc5f8f76ffcf59838ebb0d6cd5e217c1)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareCompoundOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__34e7441ba70152d9d56f90bf73220a4b600fb385c6f4946c5fe45624a7c4af62)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2fa93d19b89effdfc08e2b260eead52ecacf15d76ab81682f97d4c9204b658dd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e8c40b83c49ac93c2b180eb7b64f1e5d52302a227dde39cada60cf15a356ef43)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareCompound]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareCompound]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fb9ef8ca715212c9d5c1cf69bfe0d5500665a6451959297afe4e39e1ecae75bd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareCompoundOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareCompoundOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__130f639420fd43e0a555927117a0a2fd66d5e47105e2fbc8589dc7638db61813)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformations")
    def put_transformations(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8ac1f00e4ae9740023bd96a3bec9590add9dec70173f5d542eaa341f601597d2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTransformations", [value]))

    @jsii.member(jsii_name="resetTransformations")
    def reset_transformations(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformations", []))

    @builtins.property
    @jsii.member(jsii_name="transformations")
    def transformations(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareCompoundTransformationsList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareCompoundTransformationsList", jsii.get(self, "transformations"))

    @builtins.property
    @jsii.member(jsii_name="transformationsInput")
    def transformations_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareCompoundTransformations"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareCompoundTransformations"]]], jsii.get(self, "transformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareCompound]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareCompound]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareCompound]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f0492cdfcd0c1790a9bde36e1df4f7a606b25ebc20890cc3b45c9f8d7483314b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareCompoundTransformations",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareCompoundTransformations:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareCompoundTransformations(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareCompoundTransformationsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareCompoundTransformationsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e3e9f511be5332b6cc7d07d460427431f3ddcb219139b2f0e06a275589f27e1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareCompoundTransformationsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dbeaa89f887d5675e88b84aa951017d999c5671ba3965b425845e6b8803cbcae)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareCompoundTransformationsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fc23e4b04cd5b4305fd6b4c320909898ff18c1a677bcf87c808e4c7e82637fc2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aa3a9c537431ef315623039ca71a7603031797b8d0d91107094dee2677f75327)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5e89f568086f660d8b68e5f7de83f0d3a27f5dc0a1891d0c229c44f86a592ef6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareCompoundTransformations]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareCompoundTransformations]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareCompoundTransformations]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2c1939fbe119674ddc2667d57a8782088b2583797fe4c69dc5b4ed9be6d89888)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareCompoundTransformationsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareCompoundTransformationsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__944830a3988b4ed9a54c65b3b9411ffdba97be73be808cb6a6d25cadf109dd0f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareCompoundTransformations]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareCompoundTransformations]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareCompoundTransformations]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__74311b0327617e28f4c88edd3aa350a85a2ac4a7fc51c4a8520ab8c246ffff12)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareContrast",
    jsii_struct_bases=[],
    name_mapping={
        "brightness": "brightness",
        "brightness_var": "brightnessVar",
        "contrast": "contrast",
        "contrast_var": "contrastVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareContrast:
    def __init__(
        self,
        *,
        brightness: typing.Optional[builtins.str] = None,
        brightness_var: typing.Optional[builtins.str] = None,
        contrast: typing.Optional[builtins.str] = None,
        contrast_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param brightness: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        :param brightness_var: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        :param contrast: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param contrast_var: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a81696e9c50ed76b2c1143afbb3fa33228ec79996f408077ba3c940a9f783e9b)
            check_type(argname="argument brightness", value=brightness, expected_type=type_hints["brightness"])
            check_type(argname="argument brightness_var", value=brightness_var, expected_type=type_hints["brightness_var"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument contrast_var", value=contrast_var, expected_type=type_hints["contrast_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if brightness is not None:
            self._values["brightness"] = brightness
        if brightness_var is not None:
            self._values["brightness_var"] = brightness_var
        if contrast is not None:
            self._values["contrast"] = contrast
        if contrast_var is not None:
            self._values["contrast_var"] = contrast_var

    @builtins.property
    def brightness(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        '''
        result = self._values.get("brightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def brightness_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        '''
        result = self._values.get("brightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        result = self._values.get("contrast_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareContrast(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareContrastList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareContrastList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd700a60184dd92bbbe02ea8077d19660d31413e2e1201e5663ff7e560d6c91e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareContrastOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1b98aebc337657bb1d31df010c8b3b25bcc5f19499aae725a42ff9d8cb93f034)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareContrastOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ddc19dd0e94dab2b5e91aefbf1e536cfb353e1906c15cd33d25d690888b10ad5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d9046a899d7bfc17e08e9148cb78e1788d8f572375d85f2bab0347f63f58ad21)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d2eecccd577c47dde1f80416b2ff4fe5b2c64956fcb6a08da16614f82ae39bd8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareContrast]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareContrast]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__605935a3e3e988653f15f347e3fa61d8609f228154e01b9e6e57029e02ace15f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareContrastOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareContrastOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__731b014ef78b5d3a430317685105e8cda20d5785089c89439d5126fda0a86b23)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetBrightness")
    def reset_brightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightness", []))

    @jsii.member(jsii_name="resetBrightnessVar")
    def reset_brightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightnessVar", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetContrastVar")
    def reset_contrast_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrastVar", []))

    @builtins.property
    @jsii.member(jsii_name="brightnessInput")
    def brightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="brightnessVarInput")
    def brightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastVarInput")
    def contrast_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="brightness")
    def brightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightness"))

    @brightness.setter
    def brightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b2e4199c09bc2f9fda927fe2fae6d1909d4983bbbf302e61d4e009852852c2ce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightness", value)

    @builtins.property
    @jsii.member(jsii_name="brightnessVar")
    def brightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightnessVar"))

    @brightness_var.setter
    def brightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9dc40fc723cca759ac3f390a9d8315456e2080d0a6c8909331c1284319555ed7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrast"))

    @contrast.setter
    def contrast(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__316d95b5f1438657f1627a78ff4d216453416e82aa931062774b3cd36a0859d5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrast", value)

    @builtins.property
    @jsii.member(jsii_name="contrastVar")
    def contrast_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrastVar"))

    @contrast_var.setter
    def contrast_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e9ab652836c9fc2641e23a30b0fdf154137c39bcfc552e699bd151798b1d2435)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrastVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareContrast]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareContrast]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareContrast]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__623dcb2891b723cc467ffda0dde46e3486108c2eaa847c91e5dd322c4ac07246)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareCrop",
    jsii_struct_bases=[],
    name_mapping={
        "allow_expansion": "allowExpansion",
        "allow_expansion_var": "allowExpansionVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareCrop:
    def __init__(
        self,
        *,
        allow_expansion: typing.Optional[builtins.str] = None,
        allow_expansion_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_expansion: If cropping an area outside of the existing canvas, expands the image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        :param allow_expansion_var: If cropping an area outside of the existing canvas, expands the image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        :param gravity: Frame of reference for X and Y Positions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Frame of reference for X and Y Positions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The number of pixels to crop along the y-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The number of pixels to crop along the y-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The number of pixels to crop along the x-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The number of pixels to crop along the x-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        :param x_position: The x-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c1cb0d2266ec4728861941e6e1d99bc171024230c60c812915595d4ec3743489)
            check_type(argname="argument allow_expansion", value=allow_expansion, expected_type=type_hints["allow_expansion"])
            check_type(argname="argument allow_expansion_var", value=allow_expansion_var, expected_type=type_hints["allow_expansion_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if allow_expansion is not None:
            self._values["allow_expansion"] = allow_expansion
        if allow_expansion_var is not None:
            self._values["allow_expansion_var"] = allow_expansion_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def allow_expansion(self) -> typing.Optional[builtins.str]:
        '''If cropping an area outside of the existing canvas, expands the image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        '''
        result = self._values.get("allow_expansion")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def allow_expansion_var(self) -> typing.Optional[builtins.str]:
        '''If cropping an area outside of the existing canvas, expands the image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        '''
        result = self._values.get("allow_expansion_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Frame of reference for X and Y Positions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Frame of reference for X and Y Positions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the y-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the y-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the x-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the x-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0d958f614d81184839e0d76f45a9dbe2ef9d971447fb6cac54fecb5edb7df9b0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3bf2bd7aff4d4d0f8a04bfdf46025e78668b23279d63958091c0f5f1a593138c)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__32338d5037559043a537d4988d5ef9071794ede22652e72df8671f6c87c8c098)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d5add3d2c317b6a27c27e66b330f2bb9d299134091df5b8fac1312adee5d2545)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__209c9fba7308e54cc2674ca269d8446594d692d0a725e7731db0260463aaf83f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__72a23f71a4e525e9429185432e33f5de8be299539e9b636ca4282ae0aa09d9fb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a7762099ee3713b4a8102335ca41ee0e0a6dac2e3e4f357c3fc8e73543d7fd24)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAllowExpansion")
    def reset_allow_expansion(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansion", []))

    @jsii.member(jsii_name="resetAllowExpansionVar")
    def reset_allow_expansion_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansionVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionInput")
    def allow_expansion_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVarInput")
    def allow_expansion_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansion")
    def allow_expansion(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansion"))

    @allow_expansion.setter
    def allow_expansion(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bada41c8665f36c7c0f9e1d3fb89f370a4caa56e46c6e6b1ac2f4e6eb01465dd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansion", value)

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVar")
    def allow_expansion_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansionVar"))

    @allow_expansion_var.setter
    def allow_expansion_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f77cf5b02e1a4b98171d4e08017d73829013b504ea3690b593b4f817bc4451ec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansionVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bd377b803bad01e97a8ab5e725ad8047641f7ef5be3444aef6cbe5e2679ca1b9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ebece1bb0b66c771db1515722510a55d4f12b7f37007ca8c155a93ff7424fdc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6d7f0972afe889d4b88a0f9cd5f48d782e6c90bdaafd9be5bde1dbaf86f9d866)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a03bee96093ad60fd2914dad7223cb782abc66f376e79b353e2aeb1d8298cf2c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__de7b380f9b676aa159ded1bedd3ae4593ccd05b381f3d38b09e1aa2af3a784f1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6010a126a437a2c0663bdfb683af725e087fac5dfa16233882d16ab37582d7ae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d4cac717c0c3afc028663a1ac850e4c6bd603cec8dda351841a2c82fc985ad89)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__45c5161bfaac081caa2512bd8dd7817befd4dd98b3e9672f0e51c849fb1e9f54)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c427a5e60e81d447195e49bb78633e219654863db12a381e5e608ba73263e054)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9e7c5b83bbbf809cef4e458feff46cdee38c331d3d66849dd81601d01829bcb0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__45aca262f102aadfe5c17adb0282ef80f29d7f4db611869ef8c33ea151966dea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareFaceCrop",
    jsii_struct_bases=[],
    name_mapping={
        "algorithm": "algorithm",
        "algorithm_var": "algorithmVar",
        "confidence": "confidence",
        "confidence_var": "confidenceVar",
        "fail_gravity": "failGravity",
        "fail_gravity_var": "failGravityVar",
        "focus": "focus",
        "focus_var": "focusVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "padding": "padding",
        "padding_var": "paddingVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareFaceCrop:
    def __init__(
        self,
        *,
        algorithm: typing.Optional[builtins.str] = None,
        algorithm_var: typing.Optional[builtins.str] = None,
        confidence: typing.Optional[builtins.str] = None,
        confidence_var: typing.Optional[builtins.str] = None,
        fail_gravity: typing.Optional[builtins.str] = None,
        fail_gravity_var: typing.Optional[builtins.str] = None,
        focus: typing.Optional[builtins.str] = None,
        focus_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param algorithm: Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm DataAkamaiImagingPolicyImage#algorithm}
        :param algorithm_var: Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm_var DataAkamaiImagingPolicyImage#algorithm_var}
        :param confidence: With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image. Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence DataAkamaiImagingPolicyImage#confidence}
        :param confidence_var: With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image. Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence_var DataAkamaiImagingPolicyImage#confidence_var}
        :param fail_gravity: Controls placement of the crop if Image and Video Manager does not detect any faces in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        :param fail_gravity_var: Controls placement of the crop if Image and Video Manager does not detect any faces in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        :param focus: Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus DataAkamaiImagingPolicyImage#focus}
        :param focus_var: Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus_var DataAkamaiImagingPolicyImage#focus_var}
        :param gravity: Controls placement of the crop. Directions are relative to the face(s) plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Controls placement of the crop. Directions are relative to the face(s) plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param padding: The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        :param style: Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e09daa0deb77b86ab38e8ca6f8771b52a45b423cc43bf3beb92773c29c7f6629)
            check_type(argname="argument algorithm", value=algorithm, expected_type=type_hints["algorithm"])
            check_type(argname="argument algorithm_var", value=algorithm_var, expected_type=type_hints["algorithm_var"])
            check_type(argname="argument confidence", value=confidence, expected_type=type_hints["confidence"])
            check_type(argname="argument confidence_var", value=confidence_var, expected_type=type_hints["confidence_var"])
            check_type(argname="argument fail_gravity", value=fail_gravity, expected_type=type_hints["fail_gravity"])
            check_type(argname="argument fail_gravity_var", value=fail_gravity_var, expected_type=type_hints["fail_gravity_var"])
            check_type(argname="argument focus", value=focus, expected_type=type_hints["focus"])
            check_type(argname="argument focus_var", value=focus_var, expected_type=type_hints["focus_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if algorithm is not None:
            self._values["algorithm"] = algorithm
        if algorithm_var is not None:
            self._values["algorithm_var"] = algorithm_var
        if confidence is not None:
            self._values["confidence"] = confidence
        if confidence_var is not None:
            self._values["confidence_var"] = confidence_var
        if fail_gravity is not None:
            self._values["fail_gravity"] = fail_gravity
        if fail_gravity_var is not None:
            self._values["fail_gravity_var"] = fail_gravity_var
        if focus is not None:
            self._values["focus"] = focus
        if focus_var is not None:
            self._values["focus_var"] = focus_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def algorithm(self) -> typing.Optional[builtins.str]:
        '''Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm DataAkamaiImagingPolicyImage#algorithm}
        '''
        result = self._values.get("algorithm")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def algorithm_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm_var DataAkamaiImagingPolicyImage#algorithm_var}
        '''
        result = self._values.get("algorithm_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def confidence(self) -> typing.Optional[builtins.str]:
        '''With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image.

        Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence DataAkamaiImagingPolicyImage#confidence}
        '''
        result = self._values.get("confidence")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def confidence_var(self) -> typing.Optional[builtins.str]:
        '''With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image.

        Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence_var DataAkamaiImagingPolicyImage#confidence_var}
        '''
        result = self._values.get("confidence_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any faces in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        '''
        result = self._values.get("fail_gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any faces in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        '''
        result = self._values.get("fail_gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def focus(self) -> typing.Optional[builtins.str]:
        '''Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus DataAkamaiImagingPolicyImage#focus}
        '''
        result = self._values.get("focus")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def focus_var(self) -> typing.Optional[builtins.str]:
        '''Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus_var DataAkamaiImagingPolicyImage#focus_var}
        '''
        result = self._values.get("focus_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the face(s) plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the face(s) plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareFaceCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareFaceCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareFaceCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7a8aec6a01b458689ed1d6057c027ab32914a4552d9bbd72518bc5b5cab27eb8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareFaceCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e4913a67c07c92d4089acde45b4c389154bba218f6ae8c4f663d8c4308d6fba2)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareFaceCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a9a2ad4beb8188aeaf228b041d3247126fd8985a521a66d65761805b598db3b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc28ad7de6dc3ab989defcef50db3e9ea8cb85fc30fb3057d4e6c3418413a719)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d9c8410f9b15c04c9d2a3f9933526497790d7d7c9c59a257d703dbf4a33ae1e5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareFaceCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareFaceCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareFaceCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ef0ffdfeb9f63d87907b620efdf9cc6a063d6f00e5204f48d3ef664adc7dede)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareFaceCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareFaceCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0363bc2d029b8910b6bb3e939724747f45b2b97fc7421812bed4e381cbb9500d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAlgorithm")
    def reset_algorithm(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAlgorithm", []))

    @jsii.member(jsii_name="resetAlgorithmVar")
    def reset_algorithm_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAlgorithmVar", []))

    @jsii.member(jsii_name="resetConfidence")
    def reset_confidence(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetConfidence", []))

    @jsii.member(jsii_name="resetConfidenceVar")
    def reset_confidence_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetConfidenceVar", []))

    @jsii.member(jsii_name="resetFailGravity")
    def reset_fail_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravity", []))

    @jsii.member(jsii_name="resetFailGravityVar")
    def reset_fail_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravityVar", []))

    @jsii.member(jsii_name="resetFocus")
    def reset_focus(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFocus", []))

    @jsii.member(jsii_name="resetFocusVar")
    def reset_focus_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFocusVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="algorithmInput")
    def algorithm_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "algorithmInput"))

    @builtins.property
    @jsii.member(jsii_name="algorithmVarInput")
    def algorithm_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "algorithmVarInput"))

    @builtins.property
    @jsii.member(jsii_name="confidenceInput")
    def confidence_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "confidenceInput"))

    @builtins.property
    @jsii.member(jsii_name="confidenceVarInput")
    def confidence_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "confidenceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityInput")
    def fail_gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityVarInput")
    def fail_gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="focusInput")
    def focus_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "focusInput"))

    @builtins.property
    @jsii.member(jsii_name="focusVarInput")
    def focus_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "focusVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="algorithm")
    def algorithm(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "algorithm"))

    @algorithm.setter
    def algorithm(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a14b369632064c6b87e7588f991a1cbc8faed683285e021cf223f8b9fd7f27af)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "algorithm", value)

    @builtins.property
    @jsii.member(jsii_name="algorithmVar")
    def algorithm_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "algorithmVar"))

    @algorithm_var.setter
    def algorithm_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9af7b7cb277cad3a1d5a18b30014ad4e1b496a0911a297c9f05120200ac7baaf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "algorithmVar", value)

    @builtins.property
    @jsii.member(jsii_name="confidence")
    def confidence(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "confidence"))

    @confidence.setter
    def confidence(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6c1647c45749cde6c667735322beb2ce37b2437d967b6701bb7f182bcc22a8dd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "confidence", value)

    @builtins.property
    @jsii.member(jsii_name="confidenceVar")
    def confidence_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "confidenceVar"))

    @confidence_var.setter
    def confidence_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__29d79a8ebcdda2726ac99717b2c42a14b36a65fa3a1523ae05002c80c1139340)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "confidenceVar", value)

    @builtins.property
    @jsii.member(jsii_name="failGravity")
    def fail_gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravity"))

    @fail_gravity.setter
    def fail_gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5b8f4f8fffc8b8fd96b58dbc85365d7f34207c92ced6ae66dace25132b54768a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravity", value)

    @builtins.property
    @jsii.member(jsii_name="failGravityVar")
    def fail_gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravityVar"))

    @fail_gravity_var.setter
    def fail_gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fea493b759506f2fad004e7938cd31d5199646dd48db1dfcc6e8ffff6e0628ab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="focus")
    def focus(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "focus"))

    @focus.setter
    def focus(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3f43bef5922364f3eeda045f7f8f595c230c0954caa69005621a15928ed63ee2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "focus", value)

    @builtins.property
    @jsii.member(jsii_name="focusVar")
    def focus_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "focusVar"))

    @focus_var.setter
    def focus_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8b4625af7606d8615eb90fe58793c44d6b324afa69095db92bca4b2b02358bd1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "focusVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ee1c100c651ee53f42ccd66a51a9c4bb6815710d7d2eb9d3d5d2ff2069524a7d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d1840f81660e86b5ddea39b58ce5b52329b5c1bd9038af11a3644839962b3e3c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d45e3dde12c6de3492ad8769b6ddcad0e93daf82fdce36e4c4788a5f4ae96c4d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__782edef1045c4c064b1e6fe3c2859110072047b5dd638e57afa6500ec94dff34)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7f6fb1fc307209ade54016f4893a3999499d91aded3545996a3a97fe1c42aacd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ff4e017179752ae3820ff9d9266c2ff73350342715c6aa3aeff17363fdb6ea4f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__84e6e1cd97d8b521f73d613f524710dfd32a4be4fcf51695d70db5f7109f94c1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4229367685e0daed826b0991d63947e076fa56129488bb831934a946a7885c7b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__03e81f895c0f8cf5a2b8ef43599269068766d64d01f9c7e0262feb21ca53284a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__984cedcfe7bd3c9ca355cfea900afc4b82c9c67c44412221905271440a9a7d4a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareFaceCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareFaceCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareFaceCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__00abd42e2d9ce1002af99cc5288cbcffdd01849284cead74216f0c27fd43b0ca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareFeatureCrop",
    jsii_struct_bases=[],
    name_mapping={
        "fail_gravity": "failGravity",
        "fail_gravity_var": "failGravityVar",
        "feature_radius": "featureRadius",
        "feature_radius_var": "featureRadiusVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "max_features": "maxFeatures",
        "max_features_var": "maxFeaturesVar",
        "min_feature_quality": "minFeatureQuality",
        "min_feature_quality_var": "minFeatureQualityVar",
        "padding": "padding",
        "padding_var": "paddingVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareFeatureCrop:
    def __init__(
        self,
        *,
        fail_gravity: typing.Optional[builtins.str] = None,
        fail_gravity_var: typing.Optional[builtins.str] = None,
        feature_radius: typing.Optional[builtins.str] = None,
        feature_radius_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        max_features: typing.Optional[builtins.str] = None,
        max_features_var: typing.Optional[builtins.str] = None,
        min_feature_quality: typing.Optional[builtins.str] = None,
        min_feature_quality_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fail_gravity: Controls placement of the crop if Image and Video Manager does not detect any features in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        :param fail_gravity_var: Controls placement of the crop if Image and Video Manager does not detect any features in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        :param feature_radius: The size in pixels of the important features to search for. If identified, two features never appear closer together than this value, ``8.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius DataAkamaiImagingPolicyImage#feature_radius}
        :param feature_radius_var: The size in pixels of the important features to search for. If identified, two features never appear closer together than this value, ``8.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius_var DataAkamaiImagingPolicyImage#feature_radius_var}
        :param gravity: Controls placement of the crop. Directions are relative to the region of interest plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Controls placement of the crop. Directions are relative to the region of interest plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param max_features: The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features DataAkamaiImagingPolicyImage#max_features}
        :param max_features_var: The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features_var DataAkamaiImagingPolicyImage#max_features_var}
        :param min_feature_quality: Determines the minimum quality level of the feature identified. To consider a feature important, the feature needs to surpass this value. Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality DataAkamaiImagingPolicyImage#min_feature_quality}
        :param min_feature_quality_var: Determines the minimum quality level of the feature identified. To consider a feature important, the feature needs to surpass this value. Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality_var DataAkamaiImagingPolicyImage#min_feature_quality_var}
        :param padding: Adds space around the region of interest. The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: Adds space around the region of interest. The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        :param style: Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__926ea0328b109d56b0086aad1d3d28b8cc729a064da8c31aa7358fc80d55b1d4)
            check_type(argname="argument fail_gravity", value=fail_gravity, expected_type=type_hints["fail_gravity"])
            check_type(argname="argument fail_gravity_var", value=fail_gravity_var, expected_type=type_hints["fail_gravity_var"])
            check_type(argname="argument feature_radius", value=feature_radius, expected_type=type_hints["feature_radius"])
            check_type(argname="argument feature_radius_var", value=feature_radius_var, expected_type=type_hints["feature_radius_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument max_features", value=max_features, expected_type=type_hints["max_features"])
            check_type(argname="argument max_features_var", value=max_features_var, expected_type=type_hints["max_features_var"])
            check_type(argname="argument min_feature_quality", value=min_feature_quality, expected_type=type_hints["min_feature_quality"])
            check_type(argname="argument min_feature_quality_var", value=min_feature_quality_var, expected_type=type_hints["min_feature_quality_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fail_gravity is not None:
            self._values["fail_gravity"] = fail_gravity
        if fail_gravity_var is not None:
            self._values["fail_gravity_var"] = fail_gravity_var
        if feature_radius is not None:
            self._values["feature_radius"] = feature_radius
        if feature_radius_var is not None:
            self._values["feature_radius_var"] = feature_radius_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if max_features is not None:
            self._values["max_features"] = max_features
        if max_features_var is not None:
            self._values["max_features_var"] = max_features_var
        if min_feature_quality is not None:
            self._values["min_feature_quality"] = min_feature_quality
        if min_feature_quality_var is not None:
            self._values["min_feature_quality_var"] = min_feature_quality_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def fail_gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any features in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        '''
        result = self._values.get("fail_gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any features in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        '''
        result = self._values.get("fail_gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feature_radius(self) -> typing.Optional[builtins.str]:
        '''The size in pixels of the important features to search for.

        If identified, two features never appear closer together than this value, ``8.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius DataAkamaiImagingPolicyImage#feature_radius}
        '''
        result = self._values.get("feature_radius")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feature_radius_var(self) -> typing.Optional[builtins.str]:
        '''The size in pixels of the important features to search for.

        If identified, two features never appear closer together than this value, ``8.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius_var DataAkamaiImagingPolicyImage#feature_radius_var}
        '''
        result = self._values.get("feature_radius_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the region of interest plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the region of interest plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def max_features(self) -> typing.Optional[builtins.str]:
        '''The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features DataAkamaiImagingPolicyImage#max_features}
        '''
        result = self._values.get("max_features")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def max_features_var(self) -> typing.Optional[builtins.str]:
        '''The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features_var DataAkamaiImagingPolicyImage#max_features_var}
        '''
        result = self._values.get("max_features_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def min_feature_quality(self) -> typing.Optional[builtins.str]:
        '''Determines the minimum quality level of the feature identified.

        To consider a feature important, the feature needs to surpass this value.  Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality DataAkamaiImagingPolicyImage#min_feature_quality}
        '''
        result = self._values.get("min_feature_quality")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def min_feature_quality_var(self) -> typing.Optional[builtins.str]:
        '''Determines the minimum quality level of the feature identified.

        To consider a feature important, the feature needs to surpass this value.  Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality_var DataAkamaiImagingPolicyImage#min_feature_quality_var}
        '''
        result = self._values.get("min_feature_quality_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''Adds space around the region of interest.

        The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''Adds space around the region of interest.

        The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareFeatureCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareFeatureCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareFeatureCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a19d4770af57f53af202b0cad67d9ea51dbc5998d018cc8c143f26f76dc31626)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareFeatureCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4880880ecdd20610f39267c9d8a12e72bfc3da3892f33a513cd97eee030eaed7)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareFeatureCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b5d817b2e459f52dac4cd02340571c941a295bad32c0e47f5a1071dc629fac35)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df31360d5c3cc6213eb624001c62f14b40aa373aa87a65342bd31f66d8695317)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eefda0cc8f89c0097fbf49f7115ba26ae5b04ebd7f9d1eab33c6bbdd514fe698)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareFeatureCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareFeatureCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareFeatureCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__67c327596d3078de89d07751b751e5ce8df95e4c36b50f92fb1a1599167361fa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareFeatureCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareFeatureCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e753c8e1f3908b07ac8bead598c35c32f432b4d8ae4a493066d407ed347f26f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetFailGravity")
    def reset_fail_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravity", []))

    @jsii.member(jsii_name="resetFailGravityVar")
    def reset_fail_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravityVar", []))

    @jsii.member(jsii_name="resetFeatureRadius")
    def reset_feature_radius(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureRadius", []))

    @jsii.member(jsii_name="resetFeatureRadiusVar")
    def reset_feature_radius_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureRadiusVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetMaxFeatures")
    def reset_max_features(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxFeatures", []))

    @jsii.member(jsii_name="resetMaxFeaturesVar")
    def reset_max_features_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxFeaturesVar", []))

    @jsii.member(jsii_name="resetMinFeatureQuality")
    def reset_min_feature_quality(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMinFeatureQuality", []))

    @jsii.member(jsii_name="resetMinFeatureQualityVar")
    def reset_min_feature_quality_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMinFeatureQualityVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="failGravityInput")
    def fail_gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityVarInput")
    def fail_gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featureRadiusInput")
    def feature_radius_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featureRadiusInput"))

    @builtins.property
    @jsii.member(jsii_name="featureRadiusVarInput")
    def feature_radius_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featureRadiusVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesInput")
    def max_features_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "maxFeaturesInput"))

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesVarInput")
    def max_features_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "maxFeaturesVarInput"))

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityInput")
    def min_feature_quality_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "minFeatureQualityInput"))

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityVarInput")
    def min_feature_quality_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "minFeatureQualityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravity")
    def fail_gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravity"))

    @fail_gravity.setter
    def fail_gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__09ed55f4d908ded2f2f985fe6c84f3eb55f787049604627b259efe8f1ab5057b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravity", value)

    @builtins.property
    @jsii.member(jsii_name="failGravityVar")
    def fail_gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravityVar"))

    @fail_gravity_var.setter
    def fail_gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a7a9e173c03419930e7bf74cc9d57fc12ffdd1234985a01ce484752cebdedd7d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="featureRadius")
    def feature_radius(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featureRadius"))

    @feature_radius.setter
    def feature_radius(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1eaad5532553cced41eca0a8e67ef17b615a7d43046503dbab17306f959fb855)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featureRadius", value)

    @builtins.property
    @jsii.member(jsii_name="featureRadiusVar")
    def feature_radius_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featureRadiusVar"))

    @feature_radius_var.setter
    def feature_radius_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b4b59bb7e3f1d5cd0518c5c0714e4ac55bef37e6c4ded8be18d2364992e523ef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featureRadiusVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b58cbf8980e4ffbae3f47878c4a2a0b9f509338ddda825a34b8e6915486d3614)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a79b30e59397b1c0467efde189c7f546957ac46b8110288d3ac90e44a5fe0ca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b21fa90961dbd4d482664836a98f3f36884b1262a96519345358b0416d2c39f1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__29e0bc67b9d2edd7c8ce92d1456011d5477008e13becb74e880c0e15568c53ea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="maxFeatures")
    def max_features(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "maxFeatures"))

    @max_features.setter
    def max_features(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__30b8470d04f591e1c4c3da9f53a923cf7b7aa5f52d8330020a722e9a3a3bf3cb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "maxFeatures", value)

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesVar")
    def max_features_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "maxFeaturesVar"))

    @max_features_var.setter
    def max_features_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1c50947d80cfb4ebe459827cd09c17697c4368c48b7d59149a3fda63b0be0453)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "maxFeaturesVar", value)

    @builtins.property
    @jsii.member(jsii_name="minFeatureQuality")
    def min_feature_quality(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "minFeatureQuality"))

    @min_feature_quality.setter
    def min_feature_quality(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b2c08161d4fdddceed68e0ab2e5c8e22e0b9cd0bfdca4b331db708e3552eeaed)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "minFeatureQuality", value)

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityVar")
    def min_feature_quality_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "minFeatureQualityVar"))

    @min_feature_quality_var.setter
    def min_feature_quality_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6a6b0bfd71daebb9fc32760b69ab8470b8020107be8b94c298be4228f00e868a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "minFeatureQualityVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ec187370666ded322f431ab260665309792c03553550e0ccb36771657a63976)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d5b63f04f22934079b76d7baafbc0bed07818ab8b48295000121d93515662680)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5be3e32af505d2fecdcc1c11a27188dca1a8d140d94c5b38ff8c016f18706255)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__01e6caab74b8ae2c6f3f10dd112b9eb21bbfe2336d4adef4dd828b2ae851adb6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b875bff9198071038d2d37d33e6efc91b8606d457a14174ba1f0743b36d4b4a6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2faf0ae44dffb90f5f1bb39dec669319500a6bc72752dabe726c99fbde3d9364)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareFeatureCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareFeatureCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareFeatureCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b5512dc71b382ec0f93ff2b0c11d1ce783bf9666240edbc3b6115c1977cf53cd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareFitAndFill",
    jsii_struct_bases=[],
    name_mapping={
        "fill_transformation": "fillTransformation",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareFitAndFill:
    def __init__(
        self,
        *,
        fill_transformation: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareFitAndFillFillTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fill_transformation: fill_transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_transformation DataAkamaiImagingPolicyImage#fill_transformation}
        :param height: The height value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The width value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(fill_transformation, dict):
            fill_transformation = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareFitAndFillFillTransformation(**fill_transformation)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bba08d416d342e911d7c7f48565f6b4dc300f6e863165bc7e613156b60cc13a1)
            check_type(argname="argument fill_transformation", value=fill_transformation, expected_type=type_hints["fill_transformation"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fill_transformation is not None:
            self._values["fill_transformation"] = fill_transformation
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def fill_transformation(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareFitAndFillFillTransformation"]:
        '''fill_transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_transformation DataAkamaiImagingPolicyImage#fill_transformation}
        '''
        result = self._values.get("fill_transformation")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareFitAndFillFillTransformation"], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareFitAndFill(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareFitAndFillFillTransformation",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareFitAndFillFillTransformation:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareFitAndFillFillTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareFitAndFillFillTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareFitAndFillFillTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b99b63bdf559a242602c03854cb7adcd28bb6c58bf40eab221f63f526bf329ae)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareFitAndFillFillTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareFitAndFillFillTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareFitAndFillFillTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ce96fd11c34d209c6dd1c49261b8d2885f09886ca2be8e1fa621dc42f2004b72)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareFitAndFillList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareFitAndFillList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dcab56e542efa7544fec8eb8b23ea2df0cf51387b14a76f529d5d4a979649b71)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareFitAndFillOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2f84745a242ab7e2773a37ac97888981604abcff3fec023762221d3283e005ae)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareFitAndFillOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__01cdc912f55191b46bfbf97b5f604097b15c73dd0180ea1f42613abb47804d7d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__afd9601963b8747d45f7199696343bad9a8d006d4cde823780147dc3865ac513)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ac9a42d37591a1190fe965667a41736a9845ce3b19419125b9c164bd229e218)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareFitAndFill]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareFitAndFill]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareFitAndFill]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a2142415d0478483e923f45dc8bc87e3208e93b03e1e585d46d35b6471e380dc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareFitAndFillOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareFitAndFillOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dc0b327a10af48b132b3a056d02c5594b482f35bca8f8b0c5207a5c9a6ea9d45)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putFillTransformation")
    def put_fill_transformation(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareFitAndFillFillTransformation()

        return typing.cast(None, jsii.invoke(self, "putFillTransformation", [value]))

    @jsii.member(jsii_name="resetFillTransformation")
    def reset_fill_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFillTransformation", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="fillTransformation")
    def fill_transformation(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareFitAndFillFillTransformationOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareFitAndFillFillTransformationOutputReference, jsii.get(self, "fillTransformation"))

    @builtins.property
    @jsii.member(jsii_name="fillTransformationInput")
    def fill_transformation_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareFitAndFillFillTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareFitAndFillFillTransformation], jsii.get(self, "fillTransformationInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1dff430060a8c0b14fdf03fdb00af4db430cedd115a6a20e8ef5fe20c58bafc7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a3197842f8fafe8531bda8628e46db8bf65989c1217445d560fe0d8a02d36327)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9293d96f111c04b1d5e59ff02feb2fbeea21acacdac814433eab1cc03fe5b3b3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6aa74aee0964e69e583bf78f4770384064d975431fd6079becc6f4254acd65d9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareFitAndFill]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareFitAndFill]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareFitAndFill]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9cb16bbd979af06a6573798ce862ea79e5c7e24751d18ddafccfb6042d2d8c05)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareGoop",
    jsii_struct_bases=[],
    name_mapping={
        "chaos": "chaos",
        "chaos_var": "chaosVar",
        "density": "density",
        "density_var": "densityVar",
        "power": "power",
        "power_var": "powerVar",
        "seed": "seed",
        "seed_var": "seedVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareGoop:
    def __init__(
        self,
        *,
        chaos: typing.Optional[builtins.str] = None,
        chaos_var: typing.Optional[builtins.str] = None,
        density: typing.Optional[builtins.str] = None,
        density_var: typing.Optional[builtins.str] = None,
        power: typing.Optional[builtins.str] = None,
        power_var: typing.Optional[builtins.str] = None,
        seed: typing.Optional[builtins.str] = None,
        seed_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param chaos: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        :param chaos_var: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        :param density: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        :param density_var: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        :param power: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        :param power_var: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        :param seed: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        :param seed_var: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0134a60f84b2c910a507e47a14c3b5b3ddb89b241e4185ede273f83974599dc8)
            check_type(argname="argument chaos", value=chaos, expected_type=type_hints["chaos"])
            check_type(argname="argument chaos_var", value=chaos_var, expected_type=type_hints["chaos_var"])
            check_type(argname="argument density", value=density, expected_type=type_hints["density"])
            check_type(argname="argument density_var", value=density_var, expected_type=type_hints["density_var"])
            check_type(argname="argument power", value=power, expected_type=type_hints["power"])
            check_type(argname="argument power_var", value=power_var, expected_type=type_hints["power_var"])
            check_type(argname="argument seed", value=seed, expected_type=type_hints["seed"])
            check_type(argname="argument seed_var", value=seed_var, expected_type=type_hints["seed_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if chaos is not None:
            self._values["chaos"] = chaos
        if chaos_var is not None:
            self._values["chaos_var"] = chaos_var
        if density is not None:
            self._values["density"] = density
        if density_var is not None:
            self._values["density_var"] = density_var
        if power is not None:
            self._values["power"] = power
        if power_var is not None:
            self._values["power_var"] = power_var
        if seed is not None:
            self._values["seed"] = seed
        if seed_var is not None:
            self._values["seed_var"] = seed_var

    @builtins.property
    def chaos(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        '''
        result = self._values.get("chaos")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def chaos_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        '''
        result = self._values.get("chaos_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        '''
        result = self._values.get("density")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density_var(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        '''
        result = self._values.get("density_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        '''
        result = self._values.get("power")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power_var(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        '''
        result = self._values.get("power_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        '''
        result = self._values.get("seed")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed_var(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        result = self._values.get("seed_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareGoop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareGoopList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareGoopList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e02bcdd0936cf2a726fa55b13a910a0800662a1fc2004241b3f27518ebaea56d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareGoopOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b35e6cf96fc5303152a3d278265533d53d416a40e478b6dc4dc20e0541f02e35)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareGoopOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3f8e6a98b6b3947292f4c18f9414abe99cab3b82c63f2a349e774594c60e24af)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0c39d01c5d0836d96b464df1cbd1ef928d67d851871dceb74f28906c34dff6b8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b442d1d9abebdad22395dbe449048dd0d97e143c8da75f738c2ae62d76c61e2e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareGoop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareGoop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__149c210638b0fa5aceb01bd02526df5c9bb5d9f9df6c5d217781180a24379fa5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareGoopOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareGoopOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ed3547f1781f2c2eac2d0e9d1013f10c5ef7e8a121ed3bba5a4bdbc5e4685f94)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetChaos")
    def reset_chaos(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaos", []))

    @jsii.member(jsii_name="resetChaosVar")
    def reset_chaos_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaosVar", []))

    @jsii.member(jsii_name="resetDensity")
    def reset_density(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensity", []))

    @jsii.member(jsii_name="resetDensityVar")
    def reset_density_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensityVar", []))

    @jsii.member(jsii_name="resetPower")
    def reset_power(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPower", []))

    @jsii.member(jsii_name="resetPowerVar")
    def reset_power_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPowerVar", []))

    @jsii.member(jsii_name="resetSeed")
    def reset_seed(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeed", []))

    @jsii.member(jsii_name="resetSeedVar")
    def reset_seed_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeedVar", []))

    @builtins.property
    @jsii.member(jsii_name="chaosInput")
    def chaos_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosInput"))

    @builtins.property
    @jsii.member(jsii_name="chaosVarInput")
    def chaos_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosVarInput"))

    @builtins.property
    @jsii.member(jsii_name="densityInput")
    def density_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityInput"))

    @builtins.property
    @jsii.member(jsii_name="densityVarInput")
    def density_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="powerInput")
    def power_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerInput"))

    @builtins.property
    @jsii.member(jsii_name="powerVarInput")
    def power_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerVarInput"))

    @builtins.property
    @jsii.member(jsii_name="seedInput")
    def seed_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedInput"))

    @builtins.property
    @jsii.member(jsii_name="seedVarInput")
    def seed_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedVarInput"))

    @builtins.property
    @jsii.member(jsii_name="chaos")
    def chaos(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaos"))

    @chaos.setter
    def chaos(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__12d029c939571299b7d34df42ae9e762381962ae98d2e736cbb55c46bc7612e5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaos", value)

    @builtins.property
    @jsii.member(jsii_name="chaosVar")
    def chaos_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaosVar"))

    @chaos_var.setter
    def chaos_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ab224d5d0b344dfd412aae1fe884a577d3e469548e9214e9da0621ef2a08a4c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaosVar", value)

    @builtins.property
    @jsii.member(jsii_name="density")
    def density(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "density"))

    @density.setter
    def density(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2506dc49c4356893e28747c36ab2482e512c9d100d21d4e17df1f136a36dda86)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "density", value)

    @builtins.property
    @jsii.member(jsii_name="densityVar")
    def density_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "densityVar"))

    @density_var.setter
    def density_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__87ce0858039c038aef722cc943876205737d86e51f4ebcffedcaa786c08af51b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "densityVar", value)

    @builtins.property
    @jsii.member(jsii_name="power")
    def power(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "power"))

    @power.setter
    def power(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6613c4f79860ac6fc2c99389cd6e660b72745e894aa1c6f917144bbcf3aca3e0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "power", value)

    @builtins.property
    @jsii.member(jsii_name="powerVar")
    def power_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "powerVar"))

    @power_var.setter
    def power_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ed65833537e7f034c6b86a133c3fe9f09a7bdff28b42b38c7d40e0e4ef5d952b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "powerVar", value)

    @builtins.property
    @jsii.member(jsii_name="seed")
    def seed(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seed"))

    @seed.setter
    def seed(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__95e8293064c05f293ca85b2561b47e45b6d9e9ab45a963c7a68dbe84ad131cd0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seed", value)

    @builtins.property
    @jsii.member(jsii_name="seedVar")
    def seed_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seedVar"))

    @seed_var.setter
    def seed_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a15d9f453b702c13e319555b5847b0e155912a240debcacb05f6850863c9ac6c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seedVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareGoop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareGoop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareGoop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d3102e862b50b8ca4ec60696e71cd68065422b317c746e8d68935875990b1c5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareGrayscale",
    jsii_struct_bases=[],
    name_mapping={"type": "type", "type_var": "typeVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareGrayscale:
    def __init__(
        self,
        *,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param type: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b79047d0a704a3a5f4bfae7fac49bb140316f4d62f4a78bd88d3423de0afdf6b)
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareGrayscale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareGrayscaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareGrayscaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8d16d9476ba1819b7d4015f1d2c4732ac2f7e66149e9cc07a8a17e0a6e6b74f4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareGrayscaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9e9c7251e0846f2e72194437355bfda086fd87d0585c0964a2249cc4e959ec33)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareGrayscaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__948ec6a9269d963b5a2b5259a1de9e911d27296f02ad06842c5b0528dee7d977)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__571e16256d1a8878d272d42152832defb6fc4687a6230147c7cbc368539ef091)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__38d91e6181158597327871c2cb3c83ee74e49b544444a0b4ee4232c13ce466f7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareGrayscale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareGrayscale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__53d119a5dcac08cae5edcc774cc20840dd17281a58d549ae0fc9dfc80da19910)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareGrayscaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareGrayscaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8da7863ab055f05055f83d85f2cb9dc5a4773a5596607b7778742ed2032d3f97)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ac9841840ee62d795357b943f0e39948dcdb59740793a0a2a32140619c03e14)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aa90c2a8bfadb4872c76380160c4a8e4a3d06902ccda4209d9f064a90ea608ba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareGrayscale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareGrayscale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareGrayscale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9afd5a26b871a6ae575e0c9d3e9c997da44f121f3881ca143031abee66b9f5f3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareHsl",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "lightness": "lightness",
        "lightness_var": "lightnessVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareHsl:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness: typing.Optional[builtins.str] = None,
        lightness_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        :param lightness_var: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d2f1077d33460358dc66029b0dbf20730b36f607e667e15d8d9c7f4f7e25b31)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness", value=lightness, expected_type=type_hints["lightness"])
            check_type(argname="argument lightness_var", value=lightness_var, expected_type=type_hints["lightness_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness is not None:
            self._values["lightness"] = lightness
        if lightness_var is not None:
            self._values["lightness_var"] = lightness_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        '''
        result = self._values.get("lightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        '''
        result = self._values.get("lightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareHsl(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareHslList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareHslList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f52ecd512323b34141661a7b9dbefe1d6dd5e6b9eacbb239b8cbb639b444e669)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareHslOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6bd06ffb59dd73c132473232c353fdb6f62e021fa8ca2bc9001479f0734a37d3)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareHslOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1405640738538bf0a509a0ce8146e38bf7a4ef78913f6d17b90fd8e9e2f250b6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7693c08ad1df9cec0833fc413ad9cf711a3a69aa1f5366569a220f285d9c0a2a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dd585301f4275bb1390a9c9aa7c8be3aabfad19bda8fb8766579c4e8379a7ed6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareHsl]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareHsl]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8efbad76bea331e6e8f4b6414bf0949cdd22d845b3b2d7373e4695abc21e93f9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareHslOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareHslOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__79c90fd03203a6e5025772c754b74a82298bdf91ce8552c3ac0287b7614fa054)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightness")
    def reset_lightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightness", []))

    @jsii.member(jsii_name="resetLightnessVar")
    def reset_lightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessInput")
    def lightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessVarInput")
    def lightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7ba1b61761f540636f79a2f4b9430e2c0bc909e2e81daf7a824af94cd682ae8f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__860c0ea09e1b300bf3e5c377fbc4a2bb4455e4a01811d60b03584e5f24711a84)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightness")
    def lightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightness"))

    @lightness.setter
    def lightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e7671f25aa74f7ff80a658f36e8d4a6165c0d03e9477bfd24b7ce5b9c06bec86)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightness", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessVar")
    def lightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessVar"))

    @lightness_var.setter
    def lightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c49f812e989d651cbff162830ecbe5c14bb2fa6ced84d40d248429ebddfbebf6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__69fb5d7ee07198aa55cc7a4e3f215033bb93e7197495106c0f7c9284c4cf6fa0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__833534374d3df6a47eeb8d181a5eb8e847770d144cdd6de23a35bccb78a7e148)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareHsl]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareHsl]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareHsl]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3684cd0b1a34d2b51f9a1147e4b4eb72dae0610277acc11e38fc53ce9ca6ed60)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareHsv",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareHsv:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        :param value: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0f5cfe4633f63d36d2e4fbf96616e77890a93fb7ccad8959789df224871361ca)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareHsv(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareHsvList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareHsvList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0761e5b312fa9ca33f2341815fe14eb4b001e068b4a15121fbee311074b06a60)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareHsvOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a45623c19fe8d2f45ca243618427b5916fcc27a5ef5ef8a81dd8968a7b268dde)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareHsvOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__473dcb067f2c527d0e30f5eb20aea19975ed1981caaed3d849f3b24f2fcb9c30)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dfc45e1ae5e716dd6f327c1808c625fbca5b1b0e8e65ef92ab072e782a06dbbc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1bbda2ee9ea986d38c6ec229eaac2683bba1a6695f0c7ed253b77641c9f223eb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareHsv]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareHsv]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7a77df836f16c252d41c91c15cacee79b8998acf95f5484fdca4901ea17780f5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareHsvOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareHsvOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__18f922af895d02ae4d3897f5c386fda894e288ba75ad129faeeac0e352bcb140)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0aafba36bd46293acb17993ca43bd9a7324a3cdae98899d18df0f0f6e907abac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3d7bb225e1bb16a238a622827f6723fd31bcab8438e5614b6d8c491149f6ae40)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f4d1a36317a4053ef7f997a2ec4f011f69cd58a0201da81fab610794e113aa2b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__690436f27b460c377c2a22a0020032850bd3b9ec3f9427e435123c3611084a04)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__26cdc869d039d5896f9ca58f3c1b456e4eb0800df22a25f085556b4aabec7562)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__23da5acb4c28d10fb8a4a02cb4c7cdf99eff9db198bd024eb1a1e63303419562)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareHsv]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareHsv]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareHsv]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5eec2bf6cf1c951d639532eb511630695cfd1ef0ad9830d4d942b35d549c3f2f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfDimension",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "dimension": "dimension",
        "dimension_var": "dimensionVar",
        "equal": "equal",
        "greater_than": "greaterThan",
        "less_than": "lessThan",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfDimension:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        dimension: typing.Optional[builtins.str] = None,
        dimension_var: typing.Optional[builtins.str] = None,
        equal: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionEqual", typing.Dict[builtins.str, typing.Any]]] = None,
        greater_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionGreaterThan", typing.Dict[builtins.str, typing.Any]]] = None,
        less_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionLessThan", typing.Dict[builtins.str, typing.Any]]] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param dimension: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        :param dimension_var: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        :param equal: equal block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        :param greater_than: greater_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        :param less_than: less_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        :param value: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionDefault(**default)
        if isinstance(equal, dict):
            equal = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionEqual(**equal)
        if isinstance(greater_than, dict):
            greater_than = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionGreaterThan(**greater_than)
        if isinstance(less_than, dict):
            less_than = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionLessThan(**less_than)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__21dce23f094ebcde4408b635f5ffb65103472e2c77138533a88a538672e75305)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument dimension", value=dimension, expected_type=type_hints["dimension"])
            check_type(argname="argument dimension_var", value=dimension_var, expected_type=type_hints["dimension_var"])
            check_type(argname="argument equal", value=equal, expected_type=type_hints["equal"])
            check_type(argname="argument greater_than", value=greater_than, expected_type=type_hints["greater_than"])
            check_type(argname="argument less_than", value=less_than, expected_type=type_hints["less_than"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if dimension is not None:
            self._values["dimension"] = dimension
        if dimension_var is not None:
            self._values["dimension_var"] = dimension_var
        if equal is not None:
            self._values["equal"] = equal
        if greater_than is not None:
            self._values["greater_than"] = greater_than
        if less_than is not None:
            self._values["less_than"] = less_than
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionDefault"], result)

    @builtins.property
    def dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        '''
        result = self._values.get("dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        '''
        result = self._values.get("dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def equal(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionEqual"]:
        '''equal block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        '''
        result = self._values.get("equal")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionEqual"], result)

    @builtins.property
    def greater_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionGreaterThan"]:
        '''greater_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        '''
        result = self._values.get("greater_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionGreaterThan"], result)

    @builtins.property
    def less_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionLessThan"]:
        '''less_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        '''
        result = self._values.get("less_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionLessThan"], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfDimension(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fe397513695c4a0d19a1d05dc857565499e2a01ca776f01c9fa30a6bab69cbd5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a2bdf7203a21af3f1b6b8a78a4994c3816af839e04d04e9b0f0a9a0f33363bab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionEqual",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionEqual:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionEqual(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionEqualOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionEqualOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2b418e412f53cf0ef9f30c3d7cbd9f2c1c4464a7e5c6122ffa3325e1e2fff066)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionEqual], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionEqual],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__beac378e279837a3a37b1cedfd74c4f6641a3e7c564e80bbf483aa3d43f40590)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionGreaterThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionGreaterThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionGreaterThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionGreaterThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionGreaterThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8bd86b1e74b4937d81ea47d8beb8fc9442578094155e7f5b166a3bfd32c25305)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionGreaterThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionGreaterThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__37a64abcc4f7c75550149e70cf857f92f022744d726f02403f525770462fa566)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionLessThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionLessThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionLessThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionLessThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionLessThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__79e0ae43ce4acfe9bc338e277ea03f41a39ca0537f53c9267bca2837d9365524)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionLessThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionLessThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__123e22e77bf2e2bb9eb97e9860e2506e7fa3dbebee2d7ab2f18e23ae8466e797)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__382b7935bb813f4207deea537373eb1259373560cd2d32bd73b8dc67d879dc0b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__928b62d5467d209bf196d39dd4b2cd583008a9349fde529268880e916a5f7efd)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3077ed586054013ec3a1549f2882203fcedd9b0a3c692a114435ef373007dfba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__82c8b6814bed6ffedb78e32e0965b197a0bdd0371099c4e3171b33916649d42c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a0b2b28e066b43184f657a743297c5c1df94aa5f7ee400b383b64459267a4ec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfDimension]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfDimension]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f2eb269b3b211ebdf0bb2b7fabac73031cd4edeb457ea0f7cdafbefc5d100b79)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f7d28db5d88c2e3542c8e7540274ab1c0c7a1da40af71c22a33d8cec4581852f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putEqual")
    def put_equal(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionEqual()

        return typing.cast(None, jsii.invoke(self, "putEqual", [value]))

    @jsii.member(jsii_name="putGreaterThan")
    def put_greater_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionGreaterThan()

        return typing.cast(None, jsii.invoke(self, "putGreaterThan", [value]))

    @jsii.member(jsii_name="putLessThan")
    def put_less_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionLessThan()

        return typing.cast(None, jsii.invoke(self, "putLessThan", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetDimension")
    def reset_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimension", []))

    @jsii.member(jsii_name="resetDimensionVar")
    def reset_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimensionVar", []))

    @jsii.member(jsii_name="resetEqual")
    def reset_equal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEqual", []))

    @jsii.member(jsii_name="resetGreaterThan")
    def reset_greater_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGreaterThan", []))

    @jsii.member(jsii_name="resetLessThan")
    def reset_less_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLessThan", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="equal")
    def equal(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionEqualOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionEqualOutputReference, jsii.get(self, "equal"))

    @builtins.property
    @jsii.member(jsii_name="greaterThan")
    def greater_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionGreaterThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionGreaterThanOutputReference, jsii.get(self, "greaterThan"))

    @builtins.property
    @jsii.member(jsii_name="lessThan")
    def less_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionLessThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionLessThanOutputReference, jsii.get(self, "lessThan"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionInput")
    def dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionVarInput")
    def dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="equalInput")
    def equal_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionEqual], jsii.get(self, "equalInput"))

    @builtins.property
    @jsii.member(jsii_name="greaterThanInput")
    def greater_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionGreaterThan], jsii.get(self, "greaterThanInput"))

    @builtins.property
    @jsii.member(jsii_name="lessThanInput")
    def less_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionLessThan], jsii.get(self, "lessThanInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="dimension")
    def dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimension"))

    @dimension.setter
    def dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__43a242a443848fd0a402b3f6af4e6e1cc092a03512b8c5737e36464696f2a3e9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimension", value)

    @builtins.property
    @jsii.member(jsii_name="dimensionVar")
    def dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimensionVar"))

    @dimension_var.setter
    def dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1e59ecc9ff5fd58ccbb3be961eacde118fa99c9298bc6fd350154e4a40446fec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__879bb8829dcffdceec393aacce11fd49257288a4c92365ee3f1d0ef9737c00d1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c3dac84f0c2194c882ca7f172d0464d293d7c7ba730759c13909f44afcf13287)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfDimension]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfDimension]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfDimension]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__902a49acc880085bbb1ff684b204e5ce1c2b6b026746fdc6be4de676c1898740)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfOrientation",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "landscape": "landscape",
        "portrait": "portrait",
        "square": "square",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfOrientation:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        landscape: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationLandscape", typing.Dict[builtins.str, typing.Any]]] = None,
        portrait: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationPortrait", typing.Dict[builtins.str, typing.Any]]] = None,
        square: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationSquare", typing.Dict[builtins.str, typing.Any]]] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param landscape: landscape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        :param portrait: portrait block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        :param square: square block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationDefault(**default)
        if isinstance(landscape, dict):
            landscape = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationLandscape(**landscape)
        if isinstance(portrait, dict):
            portrait = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationPortrait(**portrait)
        if isinstance(square, dict):
            square = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationSquare(**square)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__35bfa4a716a7af2fab808dc0ef0bf71bdc2f40d590d41570db30d1d0190559dc)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument landscape", value=landscape, expected_type=type_hints["landscape"])
            check_type(argname="argument portrait", value=portrait, expected_type=type_hints["portrait"])
            check_type(argname="argument square", value=square, expected_type=type_hints["square"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if landscape is not None:
            self._values["landscape"] = landscape
        if portrait is not None:
            self._values["portrait"] = portrait
        if square is not None:
            self._values["square"] = square

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationDefault"], result)

    @builtins.property
    def landscape(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationLandscape"]:
        '''landscape block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        '''
        result = self._values.get("landscape")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationLandscape"], result)

    @builtins.property
    def portrait(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationPortrait"]:
        '''portrait block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        '''
        result = self._values.get("portrait")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationPortrait"], result)

    @builtins.property
    def square(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationSquare"]:
        '''square block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        result = self._values.get("square")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationSquare"], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfOrientation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9e7b249f9458f3850b99ec89a87e2cfb9350b16a9462f926c589a48287ac1af1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__67757766e2066add1d993ba633e71abf14e0f3357eda3f795b9c1d47328701c5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationLandscape",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationLandscape:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationLandscape(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationLandscapeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationLandscapeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dd7c8877fd91bbcec1a0d6b0c180aa8e8c344f11271e761fe6d3d90a908a3f88)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationLandscape], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationLandscape],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1537a385f276ac8bd0960ed6ec30b80d32f44625b36da4a993fbcf5f5f8bb4db)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9856237b62a09cbe3bae50a35a82690eeb5533e771a0ba58b18275fa5997c574)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e6664b35445bc9ca0e746c98946d2a4f730701f3c60f8ceb56f73a37c71066e6)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__29c3abd9e9e74bae56030ade6fdd079222f7aea5d24893872a76da557fc19669)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a6729e39860e4c9cc3869f576da76b19595dcb2c2c3559c2998622cd567068b2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1e1ed55a24a99dbe3d4b5a62cd997d176d0409bf3119ec7a7351ded33c2f3ae6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfOrientation]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfOrientation]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__23721e3d737b6106f4ba64334594d67480603c21c1e61408d908e4189b9c2351)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5c89357b3fa3e6c95fe4bf19d1f025d18485d1750b7d0d2db3efa40bf714ff29)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putLandscape")
    def put_landscape(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationLandscape()

        return typing.cast(None, jsii.invoke(self, "putLandscape", [value]))

    @jsii.member(jsii_name="putPortrait")
    def put_portrait(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationPortrait()

        return typing.cast(None, jsii.invoke(self, "putPortrait", [value]))

    @jsii.member(jsii_name="putSquare")
    def put_square(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationSquare()

        return typing.cast(None, jsii.invoke(self, "putSquare", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetLandscape")
    def reset_landscape(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLandscape", []))

    @jsii.member(jsii_name="resetPortrait")
    def reset_portrait(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPortrait", []))

    @jsii.member(jsii_name="resetSquare")
    def reset_square(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSquare", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="landscape")
    def landscape(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationLandscapeOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationLandscapeOutputReference, jsii.get(self, "landscape"))

    @builtins.property
    @jsii.member(jsii_name="portrait")
    def portrait(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationPortraitOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationPortraitOutputReference", jsii.get(self, "portrait"))

    @builtins.property
    @jsii.member(jsii_name="square")
    def square(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationSquareOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationSquareOutputReference", jsii.get(self, "square"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="landscapeInput")
    def landscape_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationLandscape], jsii.get(self, "landscapeInput"))

    @builtins.property
    @jsii.member(jsii_name="portraitInput")
    def portrait_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationPortrait"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationPortrait"], jsii.get(self, "portraitInput"))

    @builtins.property
    @jsii.member(jsii_name="squareInput")
    def square_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationSquare"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationSquare"], jsii.get(self, "squareInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfOrientation]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfOrientation]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfOrientation]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__151eed844e0357af2ac552937aebc7b83799bcbe1b6ceeb2fd82d9d8590b274d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationPortrait",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationPortrait:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationPortrait(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationPortraitOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationPortraitOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b1abd73480599e14f6f40118ee4784a3a9440847b07f92ab3d11e9f769b48c57)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationPortrait]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationPortrait], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationPortrait],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__398d0b5957e472a7acb98808a863ac44afd244d60c17c0e0a15ff569864bbdc7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationSquare",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationSquare:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationSquare(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationSquareOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationSquareOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__66f0968078116aeb3192aa6c09e7996faab55a6bfb9a1c57df84a4440d60626d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationSquare]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationSquare], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationSquare],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b0b450fdcceadeb9e52db6ba1c223a49ef22aec730fa7843850065dbd7bfcf75)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareImQuery",
    jsii_struct_bases=[],
    name_mapping={
        "allowed_transformations": "allowedTransformations",
        "query_var": "queryVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareImQuery:
    def __init__(
        self,
        *,
        allowed_transformations: typing.Sequence[builtins.str],
        query_var: builtins.str,
    ) -> None:
        '''
        :param allowed_transformations: Specifies the transformations that can be applied using the query string parameter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allowed_transformations DataAkamaiImagingPolicyImage#allowed_transformations}
        :param query_var: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#query_var DataAkamaiImagingPolicyImage#query_var}.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f8d006aa1804c7bda610bc639783038b6b0bb0a47e7a1b053d75148fd7344e82)
            check_type(argname="argument allowed_transformations", value=allowed_transformations, expected_type=type_hints["allowed_transformations"])
            check_type(argname="argument query_var", value=query_var, expected_type=type_hints["query_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "allowed_transformations": allowed_transformations,
            "query_var": query_var,
        }

    @builtins.property
    def allowed_transformations(self) -> typing.List[builtins.str]:
        '''Specifies the transformations that can be applied using the query string parameter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allowed_transformations DataAkamaiImagingPolicyImage#allowed_transformations}
        '''
        result = self._values.get("allowed_transformations")
        assert result is not None, "Required property 'allowed_transformations' is missing"
        return typing.cast(typing.List[builtins.str], result)

    @builtins.property
    def query_var(self) -> builtins.str:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#query_var DataAkamaiImagingPolicyImage#query_var}.'''
        result = self._values.get("query_var")
        assert result is not None, "Required property 'query_var' is missing"
        return typing.cast(builtins.str, result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareImQuery(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareImQueryList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareImQueryList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__18ce4a57a374446c88e5d808cb0e25ed9ef0b0003d36ebecdace9feb5e142ab1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareImQueryOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4243f4da027a146928a40d1d2e43597014c68356b257ffa904546bd60c445f0e)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareImQueryOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ff72610e3feb15cc744f8b6d71d374cd2741e3ec0cfa788ba44ad57aebcd12b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ae2d51004dbee160795cb909b6b8e1a01b37d910176a2441ebd73d551b865613)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__74a94bf5af36462a56b522c5e1cefe21dab10403b148bef3dad3a53349873ec2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareImQuery]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareImQuery]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareImQuery]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e60545c0d1d17d914cdf01751b7891d1129533ae4b5f552259c24694e068196d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareImQueryOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareImQueryOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cb0c3b41f8dd1df0fc72a5d1ff5f2e2484ca89b13a6ce65b0880471a70b8780c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @builtins.property
    @jsii.member(jsii_name="allowedTransformationsInput")
    def allowed_transformations_input(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "allowedTransformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="queryVarInput")
    def query_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "queryVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowedTransformations")
    def allowed_transformations(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "allowedTransformations"))

    @allowed_transformations.setter
    def allowed_transformations(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__903bb61b0d25d25c87269bbbbb72b020436d8af2cb98eebe931eb55a485b47b6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowedTransformations", value)

    @builtins.property
    @jsii.member(jsii_name="queryVar")
    def query_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "queryVar"))

    @query_var.setter
    def query_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__43ce54cbd89b64860c4ca905b24926384a0577137a0ca8b3386a554ad8cf771c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "queryVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareImQuery]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareImQuery]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareImQuery]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7625252de4736c4a7d4ff19f3b8774173f147981ff4d9d199b8a78ab019b5528)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareMaxColors",
    jsii_struct_bases=[],
    name_mapping={"colors": "colors", "colors_var": "colorsVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareMaxColors:
    def __init__(
        self,
        *,
        colors: typing.Optional[builtins.str] = None,
        colors_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param colors: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        :param colors_var: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3f00bbe7b3e359bde5fd078b833a4a823124c2990a7f437603c824842ef157f6)
            check_type(argname="argument colors", value=colors, expected_type=type_hints["colors"])
            check_type(argname="argument colors_var", value=colors_var, expected_type=type_hints["colors_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if colors is not None:
            self._values["colors"] = colors
        if colors_var is not None:
            self._values["colors_var"] = colors_var

    @builtins.property
    def colors(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        '''
        result = self._values.get("colors")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def colors_var(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        result = self._values.get("colors_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareMaxColors(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareMaxColorsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareMaxColorsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b5c709b27ef3dcbb902b59537803d46ef80651577e88d1ace037508f572ad77b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareMaxColorsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7f0102212a11bb6fe1984ec6ae6d895d88d6a05e454ad04ffcae599ba1cc3c69)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareMaxColorsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c7839f6949a47a18cd0f2838c10502640afbbc1f5d4885374434871c04962019)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f06cb45aa98aa3bc4e89c31db7b92fcdbd8a978809b335e29a06acf170ee69d9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6066cbc8b07b609f33eba3bbe6d3252ce811b5ed1f71d8ba8519686907ed243f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareMaxColors]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareMaxColors]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7a2b7810587e9e5140e1e1cfe641c2b076ff4b25a4ae2fa8305b17338c9e951e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareMaxColorsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareMaxColorsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__415a68fb01c29dcaa58de1308cf116c521c77272664455dec410fed20fd229bc)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColors")
    def reset_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColors", []))

    @jsii.member(jsii_name="resetColorsVar")
    def reset_colors_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorsVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorsInput")
    def colors_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsInput"))

    @builtins.property
    @jsii.member(jsii_name="colorsVarInput")
    def colors_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsVarInput"))

    @builtins.property
    @jsii.member(jsii_name="colors")
    def colors(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colors"))

    @colors.setter
    def colors(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__41629485bc0bd0a0ee2003d4bad8e41ce10aa8b9d8ad33b7807751b7ee60ebb4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colors", value)

    @builtins.property
    @jsii.member(jsii_name="colorsVar")
    def colors_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorsVar"))

    @colors_var.setter
    def colors_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__25c5d4711be4597b1b5f0f54d62b004842a919def9a187c643244872b748f119)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorsVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareMaxColors]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareMaxColors]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareMaxColors]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6dafcb22f726b4fd656b2bbb0f59dfa0e4a623e03478df042f79a636f54e3415)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareMirror",
    jsii_struct_bases=[],
    name_mapping={
        "horizontal": "horizontal",
        "horizontal_var": "horizontalVar",
        "vertical": "vertical",
        "vertical_var": "verticalVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareMirror:
    def __init__(
        self,
        *,
        horizontal: typing.Optional[builtins.str] = None,
        horizontal_var: typing.Optional[builtins.str] = None,
        vertical: typing.Optional[builtins.str] = None,
        vertical_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param horizontal: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        :param horizontal_var: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        :param vertical: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        :param vertical_var: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f87eec6f5538c3a83a9ffc30fb2670cc2a012838fcf8f5be3ca8cf2a67041f3)
            check_type(argname="argument horizontal", value=horizontal, expected_type=type_hints["horizontal"])
            check_type(argname="argument horizontal_var", value=horizontal_var, expected_type=type_hints["horizontal_var"])
            check_type(argname="argument vertical", value=vertical, expected_type=type_hints["vertical"])
            check_type(argname="argument vertical_var", value=vertical_var, expected_type=type_hints["vertical_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if horizontal is not None:
            self._values["horizontal"] = horizontal
        if horizontal_var is not None:
            self._values["horizontal_var"] = horizontal_var
        if vertical is not None:
            self._values["vertical"] = vertical
        if vertical_var is not None:
            self._values["vertical_var"] = vertical_var

    @builtins.property
    def horizontal(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        '''
        result = self._values.get("horizontal")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def horizontal_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        '''
        result = self._values.get("horizontal_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        '''
        result = self._values.get("vertical")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        result = self._values.get("vertical_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareMirror(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareMirrorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareMirrorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__826c099da80c9039d9ebe5e6c0c2bcefbc309d17d9c6097dc75ad6821a04283e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareMirrorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1b4454b26876246cd1bf521618f82e9d814b9c1c6cef11cef26f60ec76573486)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareMirrorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e3424ea7c4d2b59715ccbd600cfeae48fa4fe4f6663e7a536a97e0546c0e06e3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bcd09bbd7dc2ad89c70995724b2655564e274dceb57ec4b5aec2b16d21eafc3f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5a48a6802da1a24adad948d352f64d1726f7e9955d97e0a7f64b7f9880256b9f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareMirror]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareMirror]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e41e89b05c23fdd43fb87a8e0c215f7bc8d032beee87affc730215e39b83649f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareMirrorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareMirrorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__79fa6ceacc7eb0ae533653b7d8759d0d4a2caa1684c38e32df0d660baeb0796e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHorizontal")
    def reset_horizontal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontal", []))

    @jsii.member(jsii_name="resetHorizontalVar")
    def reset_horizontal_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontalVar", []))

    @jsii.member(jsii_name="resetVertical")
    def reset_vertical(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVertical", []))

    @jsii.member(jsii_name="resetVerticalVar")
    def reset_vertical_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVerticalVar", []))

    @builtins.property
    @jsii.member(jsii_name="horizontalInput")
    def horizontal_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontalVarInput")
    def horizontal_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalInput")
    def vertical_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalVarInput")
    def vertical_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontal")
    def horizontal(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontal"))

    @horizontal.setter
    def horizontal(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__380d9371fa1e1da28ee21e33d3dcb1df89943391bc6536642fe1c70cbad785d9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontal", value)

    @builtins.property
    @jsii.member(jsii_name="horizontalVar")
    def horizontal_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontalVar"))

    @horizontal_var.setter
    def horizontal_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__82cab287ce30e97b89fc3cc1394ca42963b0dc03d08d874deddfa207f2d857c6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontalVar", value)

    @builtins.property
    @jsii.member(jsii_name="vertical")
    def vertical(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "vertical"))

    @vertical.setter
    def vertical(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e3cd578441e65076184d1a661247903b484532924ccdc3712e6eef730f1955b6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "vertical", value)

    @builtins.property
    @jsii.member(jsii_name="verticalVar")
    def vertical_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "verticalVar"))

    @vertical_var.setter
    def vertical_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a09102234299de33f2f19827c1350db3676861475cb2d4f155ffe4aa7f2e14e8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "verticalVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareMirror]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareMirror]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareMirror]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__04c336d896c1438360b0b0c86d22463a4c6ff84bcd27dfd8e724a7de08e10bb2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareMonoHue",
    jsii_struct_bases=[],
    name_mapping={"hue": "hue", "hue_var": "hueVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareMonoHue:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f6a3e5d4cd7308a0ffde4090f6067719d7a5416e194b27d1d3e460054acaa6cb)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareMonoHue(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareMonoHueList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareMonoHueList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0472de4ccad14687e5d3026981c77b290d7bd6f34f243007718cbd0855cdb978)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareMonoHueOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__952ea353036f9609bbb89c37069b3d9a96f8f899b1d2609196e0c4c53fb8abe8)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareMonoHueOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c23593ae3ea3582cb1d54e815622a684229c1dd9c4ceac3ade91936f6de772b8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a96f61d7d6e8f58122c3091c5a927650f066b321b651594cda75780487c238d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e64a661c1915bff668bfab2932a0dacd9d603820cbcb8d025a7b128b3bc0c041)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareMonoHue]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareMonoHue]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cbbe90a636f9e881c8672752d164f0d6e5b5bd0f568fe47af5296ad68bd65203)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareMonoHueOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareMonoHueOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__21c1abdd2f1499fbc26556b709f08826d87d353eacb2be9fde05570dc8e7a662)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__48b847372234cd05f5e2c1a4b6b703c0a09c4a5e8d49e175230486d2e8ee69ee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__44b065e01e27b24475c5daf579daed239068ea7ca94b104adcc563f8b4fec548)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareMonoHue]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareMonoHue]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareMonoHue]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d06763adb1cb12cc3eb0c42300b2d1dd00a84d85cc911d747530deddd54edbaf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareOpacity",
    jsii_struct_bases=[],
    name_mapping={"opacity": "opacity", "opacity_var": "opacityVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareOpacity:
    def __init__(
        self,
        *,
        opacity: typing.Optional[builtins.str] = None,
        opacity_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param opacity: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param opacity_var: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__193d8ab497cd30196a3d891147bb4ec98edde82201161b035d4de2e758b8b8f5)
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument opacity_var", value=opacity_var, expected_type=type_hints["opacity_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if opacity is not None:
            self._values["opacity"] = opacity
        if opacity_var is not None:
            self._values["opacity_var"] = opacity_var

    @builtins.property
    def opacity(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def opacity_var(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        result = self._values.get("opacity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareOpacity(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareOpacityList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareOpacityList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__15c60605d86fc4be07107578664b40790089a0475dca79a842c83c09f87671d7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareOpacityOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__76156b2dae59aa71da20a930d93646236a029bc5e581a6343b5972b9dd0d4107)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareOpacityOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a3889d1820f6e1a29d688425367a1b45e409a6c8e94e1d6b29348001c447b38e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__00f362a4d20c58b61042f68017f572561afd12ee04d2875ae16c35c87356294b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6cf90688d66ca9e0a81f0d73c4a47252723d26b18c43a6d6e83d9c40aaeb060a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareOpacity]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareOpacity]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__442ec6dc8fa4f8642f8d753c0b13bf581979ab5ac1671bb8cefe428176292f3f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareOpacityOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareOpacityOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__87349a0d6a1aa7870aeb40c5de1d84820142b7a8552efdbc156f549820e7ca97)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetOpacityVar")
    def reset_opacity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacityVar", []))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityVarInput")
    def opacity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacity"))

    @opacity.setter
    def opacity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e84aafbfd8fff736d7b2c6f4a3a92f92eefeed51061b6af91f894868e36480f3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacity", value)

    @builtins.property
    @jsii.member(jsii_name="opacityVar")
    def opacity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacityVar"))

    @opacity_var.setter
    def opacity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__84f19faaeb72cd41be209bbdb0e210a0c5a38f012189a97789d87ca03b7530ec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacityVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareOpacity]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareOpacity]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareOpacity]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa3d078c81ddf726f4dd0ccb15480365dbfa3941c44748f84bb26514df08c4e7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__311597d187767cf75594f1a3b6cd2c60d2f5c832a9ba97642c41640787ba2163)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putAppend")
    def put_append(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareAppend, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1a2f49f389e59ba29de022fed9acbc71507c5e86981923da28f6d79711c02722)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putAppend", [value]))

    @jsii.member(jsii_name="putAspectCrop")
    def put_aspect_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareAspectCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a7ed4165e0152d91084a033369413051a14ed20cc5ff6ddd489c0c4de1798bf6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putAspectCrop", [value]))

    @jsii.member(jsii_name="putBackgroundColor")
    def put_background_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2bb0fc5925b2f26478c1f0c68a43591555d6aeb88db71eaeafccf983471dd060)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBackgroundColor", [value]))

    @jsii.member(jsii_name="putBlur")
    def put_blur(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareBlur, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ae25c43dfe3adc172d6947f9eff870c3b8a8a143cf0a4b9c3255c65b5fc219fc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBlur", [value]))

    @jsii.member(jsii_name="putChromaKey")
    def put_chroma_key(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareChromaKey, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d5d3fe171ba425f3c81784552bddc3236815465ae3c3b0b9d5d01768a0d1193a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putChromaKey", [value]))

    @jsii.member(jsii_name="putComposite")
    def put_composite(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareComposite, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__05be48155fcfee9e6016f75551f490f8756a2e3c2eac32dcf4e6c19100c88865)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putComposite", [value]))

    @jsii.member(jsii_name="putCompound")
    def put_compound(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareCompound, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cce6c57f2d321f1cc1f5189285e712577c7e52067040cece05dd8c10e50e90b5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCompound", [value]))

    @jsii.member(jsii_name="putContrast")
    def put_contrast(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareContrast, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e5c4b82cd38ebc17bcb6dd851e5fc37be748f1b008a70fbc7b27fcb3bca250c2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putContrast", [value]))

    @jsii.member(jsii_name="putCrop")
    def put_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ca90a9c990f69d188adcbd9b695eb2d15865b5a6250b69fb444513ebdacbd495)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCrop", [value]))

    @jsii.member(jsii_name="putFaceCrop")
    def put_face_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareFaceCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bffd6a623c437cc87a917e9996dffafae8c270a195ab66a1994f34cee853c141)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFaceCrop", [value]))

    @jsii.member(jsii_name="putFeatureCrop")
    def put_feature_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareFeatureCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ae95aa745497b4282e1f86e115d0569f621e79817d4a3569d3e9499b276e0520)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFeatureCrop", [value]))

    @jsii.member(jsii_name="putFitAndFill")
    def put_fit_and_fill(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareFitAndFill, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df0f92b9cae48651f4e016541d83c21a24927e57ded653757ed6da5fd5e366d4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFitAndFill", [value]))

    @jsii.member(jsii_name="putGoop")
    def put_goop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareGoop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1eadb8a2a3cbd7999da1877f82070c9a7641fa2fe35043328ef3a474506860f1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGoop", [value]))

    @jsii.member(jsii_name="putGrayscale")
    def put_grayscale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareGrayscale, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d88bbc7200f4afd0bf208810cf06358392197578c39b569ccf6094993323f681)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGrayscale", [value]))

    @jsii.member(jsii_name="putHsl")
    def put_hsl(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareHsl, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__47dcbf1e84509b67297142fa09deff4377fb76098eac206bc3e10f604575f6cc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsl", [value]))

    @jsii.member(jsii_name="putHsv")
    def put_hsv(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareHsv, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1c7f78ae5386c776e622fc07db5415c4713435dce1fa6194f6c765eb8457cba8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsv", [value]))

    @jsii.member(jsii_name="putIfDimension")
    def put_if_dimension(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfDimension, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__585469d11bcf0b564a017a033cf84f746fc04c477e6f6c1abb908b9081e6c1de)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfDimension", [value]))

    @jsii.member(jsii_name="putIfOrientation")
    def put_if_orientation(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__48c88e0c4ded7a89416620552c5067f34146757f758055950c995e6e27f0ccdc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfOrientation", [value]))

    @jsii.member(jsii_name="putImQuery")
    def put_im_query(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareImQuery, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__88ad2b8fa076be4b06f97cafd0fa7c82a54b98e01efff8c0058bca2314c5255f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putImQuery", [value]))

    @jsii.member(jsii_name="putMaxColors")
    def put_max_colors(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareMaxColors, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__288ee8f5168f2262b0a652f17aabb0787b07e3e7d63a56cb2809215d29c4465c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMaxColors", [value]))

    @jsii.member(jsii_name="putMirror")
    def put_mirror(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareMirror, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b0749fab3e2ba86302d068a11c9c82eea01b3ddda3b6e5c069f3a8b67845305c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMirror", [value]))

    @jsii.member(jsii_name="putMonoHue")
    def put_mono_hue(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareMonoHue, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0b9626cd79a0056fb1fda4978d2d1dfe3b70762c7f50f633bf9e65429c4ac1d7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMonoHue", [value]))

    @jsii.member(jsii_name="putOpacity")
    def put_opacity(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareOpacity, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d4a3c7a427142f5e077721563974054da786eaa94a41835877c3f65d58bf4a91)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putOpacity", [value]))

    @jsii.member(jsii_name="putRegionOfInterestCrop")
    def put_region_of_interest_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareRegionOfInterestCrop", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e8e18383aadae943785dec21095273a77df46d04b55588fad79b56bf8c779d28)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRegionOfInterestCrop", [value]))

    @jsii.member(jsii_name="putRelativeCrop")
    def put_relative_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareRelativeCrop", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e29c7c4a023364000a00e0700f113d827d2507a4b3549bf8de2424a2c4019785)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRelativeCrop", [value]))

    @jsii.member(jsii_name="putRemoveColor")
    def put_remove_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareRemoveColor", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__74556363f5b64e2f067ab2fbf54f68d66c1529b8b4fef45e2f448beedef051fa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRemoveColor", [value]))

    @jsii.member(jsii_name="putResize")
    def put_resize(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareResize", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__163d799daebfd5b8d5876a7c47ac6948ef8002350e15f30469250d35e83f942f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putResize", [value]))

    @jsii.member(jsii_name="putRotate")
    def put_rotate(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareRotate", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7b33cd50ea9bc34a4d9c1c8a5c29cd0a52f88c00f2fb1d39d8ed7def23a27d95)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRotate", [value]))

    @jsii.member(jsii_name="putScale")
    def put_scale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareScale", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__706716f44695b57ae6707e07cdefb48f8bb707c2db95f8894a5e65e5c9f6a890)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putScale", [value]))

    @jsii.member(jsii_name="putShear")
    def put_shear(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareShear", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9656ec47206e98966aab8a4428ba9d2e13c8b20329ea577581c1d9709e69ab65)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putShear", [value]))

    @jsii.member(jsii_name="putTrim")
    def put_trim(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareTrim", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4896232bcf4222db177eea758524676014890b2d00c0b407bc48532735860c9c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTrim", [value]))

    @jsii.member(jsii_name="putUnsharpMask")
    def put_unsharp_mask(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareUnsharpMask", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1d140623d5d284e43a2b91f4ad8f335021ee9a067ba986fe505b1ce7883bb159)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putUnsharpMask", [value]))

    @jsii.member(jsii_name="resetAppend")
    def reset_append(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAppend", []))

    @jsii.member(jsii_name="resetAspectCrop")
    def reset_aspect_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspectCrop", []))

    @jsii.member(jsii_name="resetBackgroundColor")
    def reset_background_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBackgroundColor", []))

    @jsii.member(jsii_name="resetBlur")
    def reset_blur(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBlur", []))

    @jsii.member(jsii_name="resetChromaKey")
    def reset_chroma_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChromaKey", []))

    @jsii.member(jsii_name="resetComposite")
    def reset_composite(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetComposite", []))

    @jsii.member(jsii_name="resetCompound")
    def reset_compound(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCompound", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetCrop")
    def reset_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCrop", []))

    @jsii.member(jsii_name="resetFaceCrop")
    def reset_face_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFaceCrop", []))

    @jsii.member(jsii_name="resetFeatureCrop")
    def reset_feature_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureCrop", []))

    @jsii.member(jsii_name="resetFitAndFill")
    def reset_fit_and_fill(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFitAndFill", []))

    @jsii.member(jsii_name="resetGoop")
    def reset_goop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGoop", []))

    @jsii.member(jsii_name="resetGrayscale")
    def reset_grayscale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGrayscale", []))

    @jsii.member(jsii_name="resetHsl")
    def reset_hsl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsl", []))

    @jsii.member(jsii_name="resetHsv")
    def reset_hsv(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsv", []))

    @jsii.member(jsii_name="resetIfDimension")
    def reset_if_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfDimension", []))

    @jsii.member(jsii_name="resetIfOrientation")
    def reset_if_orientation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfOrientation", []))

    @jsii.member(jsii_name="resetImQuery")
    def reset_im_query(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetImQuery", []))

    @jsii.member(jsii_name="resetMaxColors")
    def reset_max_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxColors", []))

    @jsii.member(jsii_name="resetMirror")
    def reset_mirror(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMirror", []))

    @jsii.member(jsii_name="resetMonoHue")
    def reset_mono_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonoHue", []))

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetRegionOfInterestCrop")
    def reset_region_of_interest_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRegionOfInterestCrop", []))

    @jsii.member(jsii_name="resetRelativeCrop")
    def reset_relative_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRelativeCrop", []))

    @jsii.member(jsii_name="resetRemoveColor")
    def reset_remove_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRemoveColor", []))

    @jsii.member(jsii_name="resetResize")
    def reset_resize(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetResize", []))

    @jsii.member(jsii_name="resetRotate")
    def reset_rotate(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRotate", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetShear")
    def reset_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetShear", []))

    @jsii.member(jsii_name="resetTrim")
    def reset_trim(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTrim", []))

    @jsii.member(jsii_name="resetUnsharpMask")
    def reset_unsharp_mask(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUnsharpMask", []))

    @builtins.property
    @jsii.member(jsii_name="append")
    def append(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareAppendList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareAppendList, jsii.get(self, "append"))

    @builtins.property
    @jsii.member(jsii_name="aspectCrop")
    def aspect_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareAspectCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareAspectCropList, jsii.get(self, "aspectCrop"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColor")
    def background_color(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareBackgroundColorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareBackgroundColorList, jsii.get(self, "backgroundColor"))

    @builtins.property
    @jsii.member(jsii_name="blur")
    def blur(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareBlurList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareBlurList, jsii.get(self, "blur"))

    @builtins.property
    @jsii.member(jsii_name="chromaKey")
    def chroma_key(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareChromaKeyList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareChromaKeyList, jsii.get(self, "chromaKey"))

    @builtins.property
    @jsii.member(jsii_name="composite")
    def composite(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareCompositeList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareCompositeList, jsii.get(self, "composite"))

    @builtins.property
    @jsii.member(jsii_name="compound")
    def compound(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareCompoundList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareCompoundList, jsii.get(self, "compound"))

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareContrastList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareContrastList, jsii.get(self, "contrast"))

    @builtins.property
    @jsii.member(jsii_name="crop")
    def crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareCropList, jsii.get(self, "crop"))

    @builtins.property
    @jsii.member(jsii_name="faceCrop")
    def face_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareFaceCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareFaceCropList, jsii.get(self, "faceCrop"))

    @builtins.property
    @jsii.member(jsii_name="featureCrop")
    def feature_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareFeatureCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareFeatureCropList, jsii.get(self, "featureCrop"))

    @builtins.property
    @jsii.member(jsii_name="fitAndFill")
    def fit_and_fill(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareFitAndFillList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareFitAndFillList, jsii.get(self, "fitAndFill"))

    @builtins.property
    @jsii.member(jsii_name="goop")
    def goop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareGoopList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareGoopList, jsii.get(self, "goop"))

    @builtins.property
    @jsii.member(jsii_name="grayscale")
    def grayscale(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareGrayscaleList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareGrayscaleList, jsii.get(self, "grayscale"))

    @builtins.property
    @jsii.member(jsii_name="hsl")
    def hsl(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareHslList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareHslList, jsii.get(self, "hsl"))

    @builtins.property
    @jsii.member(jsii_name="hsv")
    def hsv(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareHsvList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareHsvList, jsii.get(self, "hsv"))

    @builtins.property
    @jsii.member(jsii_name="ifDimension")
    def if_dimension(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionList, jsii.get(self, "ifDimension"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientation")
    def if_orientation(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationList, jsii.get(self, "ifOrientation"))

    @builtins.property
    @jsii.member(jsii_name="imQuery")
    def im_query(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareImQueryList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareImQueryList, jsii.get(self, "imQuery"))

    @builtins.property
    @jsii.member(jsii_name="maxColors")
    def max_colors(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareMaxColorsList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareMaxColorsList, jsii.get(self, "maxColors"))

    @builtins.property
    @jsii.member(jsii_name="mirror")
    def mirror(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareMirrorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareMirrorList, jsii.get(self, "mirror"))

    @builtins.property
    @jsii.member(jsii_name="monoHue")
    def mono_hue(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareMonoHueList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareMonoHueList, jsii.get(self, "monoHue"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareOpacityList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareOpacityList, jsii.get(self, "opacity"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestCrop")
    def region_of_interest_crop(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareRegionOfInterestCropList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareRegionOfInterestCropList", jsii.get(self, "regionOfInterestCrop"))

    @builtins.property
    @jsii.member(jsii_name="relativeCrop")
    def relative_crop(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareRelativeCropList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareRelativeCropList", jsii.get(self, "relativeCrop"))

    @builtins.property
    @jsii.member(jsii_name="removeColor")
    def remove_color(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareRemoveColorList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareRemoveColorList", jsii.get(self, "removeColor"))

    @builtins.property
    @jsii.member(jsii_name="resize")
    def resize(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareResizeList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareResizeList", jsii.get(self, "resize"))

    @builtins.property
    @jsii.member(jsii_name="rotate")
    def rotate(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareRotateList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareRotateList", jsii.get(self, "rotate"))

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareScaleList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareScaleList", jsii.get(self, "scale"))

    @builtins.property
    @jsii.member(jsii_name="shear")
    def shear(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareShearList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareShearList", jsii.get(self, "shear"))

    @builtins.property
    @jsii.member(jsii_name="trim")
    def trim(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareTrimList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareTrimList", jsii.get(self, "trim"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMask")
    def unsharp_mask(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareUnsharpMaskList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareUnsharpMaskList", jsii.get(self, "unsharpMask"))

    @builtins.property
    @jsii.member(jsii_name="appendInput")
    def append_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareAppend]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareAppend]]], jsii.get(self, "appendInput"))

    @builtins.property
    @jsii.member(jsii_name="aspectCropInput")
    def aspect_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareAspectCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareAspectCrop]]], jsii.get(self, "aspectCropInput"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColorInput")
    def background_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareBackgroundColor]]], jsii.get(self, "backgroundColorInput"))

    @builtins.property
    @jsii.member(jsii_name="blurInput")
    def blur_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareBlur]]], jsii.get(self, "blurInput"))

    @builtins.property
    @jsii.member(jsii_name="chromaKeyInput")
    def chroma_key_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareChromaKey]]], jsii.get(self, "chromaKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="compositeInput")
    def composite_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareComposite]]], jsii.get(self, "compositeInput"))

    @builtins.property
    @jsii.member(jsii_name="compoundInput")
    def compound_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareCompound]]], jsii.get(self, "compoundInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareContrast]]], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="cropInput")
    def crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareCrop]]], jsii.get(self, "cropInput"))

    @builtins.property
    @jsii.member(jsii_name="faceCropInput")
    def face_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareFaceCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareFaceCrop]]], jsii.get(self, "faceCropInput"))

    @builtins.property
    @jsii.member(jsii_name="featureCropInput")
    def feature_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareFeatureCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareFeatureCrop]]], jsii.get(self, "featureCropInput"))

    @builtins.property
    @jsii.member(jsii_name="fitAndFillInput")
    def fit_and_fill_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareFitAndFill]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareFitAndFill]]], jsii.get(self, "fitAndFillInput"))

    @builtins.property
    @jsii.member(jsii_name="goopInput")
    def goop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareGoop]]], jsii.get(self, "goopInput"))

    @builtins.property
    @jsii.member(jsii_name="grayscaleInput")
    def grayscale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareGrayscale]]], jsii.get(self, "grayscaleInput"))

    @builtins.property
    @jsii.member(jsii_name="hslInput")
    def hsl_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareHsl]]], jsii.get(self, "hslInput"))

    @builtins.property
    @jsii.member(jsii_name="hsvInput")
    def hsv_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareHsv]]], jsii.get(self, "hsvInput"))

    @builtins.property
    @jsii.member(jsii_name="ifDimensionInput")
    def if_dimension_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfDimension]]], jsii.get(self, "ifDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientationInput")
    def if_orientation_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfOrientation]]], jsii.get(self, "ifOrientationInput"))

    @builtins.property
    @jsii.member(jsii_name="imQueryInput")
    def im_query_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareImQuery]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareImQuery]]], jsii.get(self, "imQueryInput"))

    @builtins.property
    @jsii.member(jsii_name="maxColorsInput")
    def max_colors_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareMaxColors]]], jsii.get(self, "maxColorsInput"))

    @builtins.property
    @jsii.member(jsii_name="mirrorInput")
    def mirror_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareMirror]]], jsii.get(self, "mirrorInput"))

    @builtins.property
    @jsii.member(jsii_name="monoHueInput")
    def mono_hue_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareMonoHue]]], jsii.get(self, "monoHueInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareOpacity]]], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestCropInput")
    def region_of_interest_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareRegionOfInterestCrop"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareRegionOfInterestCrop"]]], jsii.get(self, "regionOfInterestCropInput"))

    @builtins.property
    @jsii.member(jsii_name="relativeCropInput")
    def relative_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareRelativeCrop"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareRelativeCrop"]]], jsii.get(self, "relativeCropInput"))

    @builtins.property
    @jsii.member(jsii_name="removeColorInput")
    def remove_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareRemoveColor"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareRemoveColor"]]], jsii.get(self, "removeColorInput"))

    @builtins.property
    @jsii.member(jsii_name="resizeInput")
    def resize_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareResize"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareResize"]]], jsii.get(self, "resizeInput"))

    @builtins.property
    @jsii.member(jsii_name="rotateInput")
    def rotate_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareRotate"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareRotate"]]], jsii.get(self, "rotateInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareScale"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareScale"]]], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="shearInput")
    def shear_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareShear"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareShear"]]], jsii.get(self, "shearInput"))

    @builtins.property
    @jsii.member(jsii_name="trimInput")
    def trim_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareTrim"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareTrim"]]], jsii.get(self, "trimInput"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMaskInput")
    def unsharp_mask_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareUnsharpMask"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareUnsharpMask"]]], jsii.get(self, "unsharpMaskInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquare]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquare], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquare],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__96a1fb92d09328844a744413fe57d8a18aced11b46ff8bee50a694cbe1c550e9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareRegionOfInterestCrop",
    jsii_struct_bases=[],
    name_mapping={
        "region_of_interest": "regionOfInterest",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareRegionOfInterestCrop:
    def __init__(
        self,
        *,
        region_of_interest: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareRegionOfInterestCropRegionOfInterest", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param region_of_interest: region_of_interest block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest DataAkamaiImagingPolicyImage#region_of_interest}
        :param gravity: The placement of the crop area relative to the specified area of interest. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: The placement of the crop area relative to the specified area of interest. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param style: Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(region_of_interest, dict):
            region_of_interest = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareRegionOfInterestCropRegionOfInterest(**region_of_interest)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__24fb38b3f8830b5f0141ef1f36f85575667aaa07da4fd54801c31f25c5a8dbbe)
            check_type(argname="argument region_of_interest", value=region_of_interest, expected_type=type_hints["region_of_interest"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "region_of_interest": region_of_interest,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def region_of_interest(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareRegionOfInterestCropRegionOfInterest":
        '''region_of_interest block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest DataAkamaiImagingPolicyImage#region_of_interest}
        '''
        result = self._values.get("region_of_interest")
        assert result is not None, "Required property 'region_of_interest' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareRegionOfInterestCropRegionOfInterest", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''The placement of the crop area relative to the specified area of interest.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''The placement of the crop area relative to the specified area of interest.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareRegionOfInterestCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareRegionOfInterestCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareRegionOfInterestCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a2e81a65e64eb44b1b5096c8a6caa887ca4984c1542717c90b90ff740ef28432)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareRegionOfInterestCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__026c38491437ab7d09ea4163ad061e2d6238eb31c2bd41e198ff279a1cf71cf4)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareRegionOfInterestCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6cc9548eefee6be58e395bfcf7495ba1f09841dd0db5c48002cb4228a2b608f6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fd1e9ebe4c62d3da1a50531931fcbd18f9b9537235449c230b45e78040dcc963)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4efd5ac344533dbaf47dc29a9f65c0b84d00750d8abd867607ba91ef1cb443cd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareRegionOfInterestCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareRegionOfInterestCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareRegionOfInterestCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5fcba580c49a3d207767eb934722d270ef0c84c0ada38c3183b5b8c23a2f3e2e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareRegionOfInterestCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareRegionOfInterestCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__52a373d4f5543ae391dbe70c8583003a74341d8b3daeef86a54440dbf507a4e8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putRegionOfInterest")
    def put_region_of_interest(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareRegionOfInterestCropRegionOfInterest()

        return typing.cast(None, jsii.invoke(self, "putRegionOfInterest", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterest")
    def region_of_interest(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareRegionOfInterestCropRegionOfInterestOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareRegionOfInterestCropRegionOfInterestOutputReference", jsii.get(self, "regionOfInterest"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestInput")
    def region_of_interest_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareRegionOfInterestCropRegionOfInterest"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareRegionOfInterestCropRegionOfInterest"], jsii.get(self, "regionOfInterestInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8ad337cfc7d47719e33820be1a800f8c63caca7ac27c9e6bf3053cf0f6895da1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e43ddaa9ee101a7b3db1f5f58b26382118b3c7e0335aff998618b06081b25acf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__59c81f0e1f9a34b4fed9cce66a0224c4c52dd3a5aed5d363b2c1ad440dfb94ae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9b8d67685b3f2a01ab4e61e958b8a4d2347fe00b1fb5f8cc784cdc9fca390851)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ecced1954045eeaf9ed1d861f3b044e366ed7192f55e26321cda791431bf4878)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__49c1214d7311fe65db77ee244027e9010b43fa41e463aae401acf5b3fc8d9a1a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__64ab0fd6e8365d109eb908065f485531f577c83a6dd70171bff8386e8eced2ce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b06953a73d011ad9067d7c10b0ba6252706b9eeb12e7d48880a8a2f768a33199)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareRegionOfInterestCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareRegionOfInterestCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareRegionOfInterestCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0327077f99fa101a280166e0edb2bd6e7f41373b868d8d36e81e0889b4373324)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareRegionOfInterestCropRegionOfInterest",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareRegionOfInterestCropRegionOfInterest:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareRegionOfInterestCropRegionOfInterest(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareRegionOfInterestCropRegionOfInterestOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareRegionOfInterestCropRegionOfInterestOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3854cc55aef637d84d952d9755e7e6b45384ed8e1a4014ba61b4f91b1c8e1687)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareRegionOfInterestCropRegionOfInterest]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareRegionOfInterestCropRegionOfInterest], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareRegionOfInterestCropRegionOfInterest],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f4d169d1445afb6a6ac1b4009ec8aae9eca1f84aaad9a729000abdead4a6f60b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareRelativeCrop",
    jsii_struct_bases=[],
    name_mapping={
        "east": "east",
        "east_var": "eastVar",
        "north": "north",
        "north_var": "northVar",
        "south": "south",
        "south_var": "southVar",
        "west": "west",
        "west_var": "westVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareRelativeCrop:
    def __init__(
        self,
        *,
        east: typing.Optional[builtins.str] = None,
        east_var: typing.Optional[builtins.str] = None,
        north: typing.Optional[builtins.str] = None,
        north_var: typing.Optional[builtins.str] = None,
        south: typing.Optional[builtins.str] = None,
        south_var: typing.Optional[builtins.str] = None,
        west: typing.Optional[builtins.str] = None,
        west_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param east: The number of pixels to shrink or expand the right side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east DataAkamaiImagingPolicyImage#east}
        :param east_var: The number of pixels to shrink or expand the right side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east_var DataAkamaiImagingPolicyImage#east_var}
        :param north: The number of pixels to shrink or expand the top side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north DataAkamaiImagingPolicyImage#north}
        :param north_var: The number of pixels to shrink or expand the top side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north_var DataAkamaiImagingPolicyImage#north_var}
        :param south: The number of pixels to shrink or expand the bottom side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south DataAkamaiImagingPolicyImage#south}
        :param south_var: The number of pixels to shrink or expand the bottom side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south_var DataAkamaiImagingPolicyImage#south_var}
        :param west: The number of pixels to shrink or expand the left side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west DataAkamaiImagingPolicyImage#west}
        :param west_var: The number of pixels to shrink or expand the left side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west_var DataAkamaiImagingPolicyImage#west_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__09214f50ea7d7b145e839f2e8973c1f90dbcabf04656424fb3fc51b4dd2da805)
            check_type(argname="argument east", value=east, expected_type=type_hints["east"])
            check_type(argname="argument east_var", value=east_var, expected_type=type_hints["east_var"])
            check_type(argname="argument north", value=north, expected_type=type_hints["north"])
            check_type(argname="argument north_var", value=north_var, expected_type=type_hints["north_var"])
            check_type(argname="argument south", value=south, expected_type=type_hints["south"])
            check_type(argname="argument south_var", value=south_var, expected_type=type_hints["south_var"])
            check_type(argname="argument west", value=west, expected_type=type_hints["west"])
            check_type(argname="argument west_var", value=west_var, expected_type=type_hints["west_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if east is not None:
            self._values["east"] = east
        if east_var is not None:
            self._values["east_var"] = east_var
        if north is not None:
            self._values["north"] = north
        if north_var is not None:
            self._values["north_var"] = north_var
        if south is not None:
            self._values["south"] = south
        if south_var is not None:
            self._values["south_var"] = south_var
        if west is not None:
            self._values["west"] = west
        if west_var is not None:
            self._values["west_var"] = west_var

    @builtins.property
    def east(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the right side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east DataAkamaiImagingPolicyImage#east}
        '''
        result = self._values.get("east")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def east_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the right side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east_var DataAkamaiImagingPolicyImage#east_var}
        '''
        result = self._values.get("east_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def north(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the top side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north DataAkamaiImagingPolicyImage#north}
        '''
        result = self._values.get("north")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def north_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the top side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north_var DataAkamaiImagingPolicyImage#north_var}
        '''
        result = self._values.get("north_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def south(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the bottom side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south DataAkamaiImagingPolicyImage#south}
        '''
        result = self._values.get("south")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def south_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the bottom side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south_var DataAkamaiImagingPolicyImage#south_var}
        '''
        result = self._values.get("south_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def west(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the left side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west DataAkamaiImagingPolicyImage#west}
        '''
        result = self._values.get("west")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def west_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the left side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west_var DataAkamaiImagingPolicyImage#west_var}
        '''
        result = self._values.get("west_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareRelativeCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareRelativeCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareRelativeCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f1eb430f31a205e591552cf97efaa5644b0a8221ad45957906c53fe4cfe3cf08)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareRelativeCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5c7c70bb6cd7a6904967982ab80396b0cc95a4062de6aee2aed399869b47d4fe)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareRelativeCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb21b9918bbb0e939e65d3e13bb700229174f2d6e3f5e2cdf5df0f66427092d0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__48a2fbf0a6407127adabf2cdc1a0ad4a288d4f1853a4ca16e2ecb41324905303)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__73deb140416e79890343f14ed377254bc9caa0ac6235873849d1394cbb968239)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareRelativeCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareRelativeCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareRelativeCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__49b7ae6e5d1a5d3bd3d8fb8c955ccf57e147ea9d9c452d71a6341d5d2ae84796)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareRelativeCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareRelativeCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__34d8afa199f0bf61cbafbb998b51b577897edd9c8c9e23b8bb1981e428e2de0e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetEast")
    def reset_east(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEast", []))

    @jsii.member(jsii_name="resetEastVar")
    def reset_east_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEastVar", []))

    @jsii.member(jsii_name="resetNorth")
    def reset_north(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNorth", []))

    @jsii.member(jsii_name="resetNorthVar")
    def reset_north_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNorthVar", []))

    @jsii.member(jsii_name="resetSouth")
    def reset_south(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSouth", []))

    @jsii.member(jsii_name="resetSouthVar")
    def reset_south_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSouthVar", []))

    @jsii.member(jsii_name="resetWest")
    def reset_west(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWest", []))

    @jsii.member(jsii_name="resetWestVar")
    def reset_west_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWestVar", []))

    @builtins.property
    @jsii.member(jsii_name="eastInput")
    def east_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "eastInput"))

    @builtins.property
    @jsii.member(jsii_name="eastVarInput")
    def east_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "eastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="northInput")
    def north_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "northInput"))

    @builtins.property
    @jsii.member(jsii_name="northVarInput")
    def north_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "northVarInput"))

    @builtins.property
    @jsii.member(jsii_name="southInput")
    def south_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "southInput"))

    @builtins.property
    @jsii.member(jsii_name="southVarInput")
    def south_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "southVarInput"))

    @builtins.property
    @jsii.member(jsii_name="westInput")
    def west_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "westInput"))

    @builtins.property
    @jsii.member(jsii_name="westVarInput")
    def west_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "westVarInput"))

    @builtins.property
    @jsii.member(jsii_name="east")
    def east(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "east"))

    @east.setter
    def east(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bdef3c27d4a95a13853036deb8d8d777a5f76e45d8aa9cca2f8b5d0a8f03689b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "east", value)

    @builtins.property
    @jsii.member(jsii_name="eastVar")
    def east_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "eastVar"))

    @east_var.setter
    def east_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__86f62162aab46663ae4f15183d832d4f103c76c5120dc632348552b9c486eb4b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "eastVar", value)

    @builtins.property
    @jsii.member(jsii_name="north")
    def north(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "north"))

    @north.setter
    def north(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0b104d46d70fcbf87511e2dbc9371a180c9f29fff279c0d1c151652ea83334ff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "north", value)

    @builtins.property
    @jsii.member(jsii_name="northVar")
    def north_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "northVar"))

    @north_var.setter
    def north_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bbb84032f42f9915e940b731dcce70d4c7e764ad60cbec3397453fbccc27e783)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "northVar", value)

    @builtins.property
    @jsii.member(jsii_name="south")
    def south(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "south"))

    @south.setter
    def south(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8387a0a82c39a1a883886f8498f701b769ce78229bc1c47dd68f6ac6a9b4236e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "south", value)

    @builtins.property
    @jsii.member(jsii_name="southVar")
    def south_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "southVar"))

    @south_var.setter
    def south_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__51033a692a34494ea160fe89fdbd508aa3021d4b083090f536c55dc9344f1b08)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "southVar", value)

    @builtins.property
    @jsii.member(jsii_name="west")
    def west(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "west"))

    @west.setter
    def west(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__01106f4e401510c2f97b4ecc95dc64864ce09c2b3d466f19c85c148503248aa6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "west", value)

    @builtins.property
    @jsii.member(jsii_name="westVar")
    def west_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "westVar"))

    @west_var.setter
    def west_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a3736b635bb71e52a4d5a66c5d0f92a92f63f4675cae7f34183540d54de4735e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "westVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareRelativeCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareRelativeCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareRelativeCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__67e224bb6a2c70e6807f5197b9a11463a71a452b942ca2866c1f9faf91576c4c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareRemoveColor",
    jsii_struct_bases=[],
    name_mapping={
        "color": "color",
        "color_var": "colorVar",
        "feather": "feather",
        "feather_var": "featherVar",
        "tolerance": "tolerance",
        "tolerance_var": "toleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareRemoveColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
        feather: typing.Optional[builtins.str] = None,
        feather_var: typing.Optional[builtins.str] = None,
        tolerance: typing.Optional[builtins.str] = None,
        tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        :param feather: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        :param feather_var: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        :param tolerance: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        :param tolerance_var: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c777d7cec6e18316cb62c0da37f789315986cdafa67675d30ba2a895e02c5dd9)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
            check_type(argname="argument feather", value=feather, expected_type=type_hints["feather"])
            check_type(argname="argument feather_var", value=feather_var, expected_type=type_hints["feather_var"])
            check_type(argname="argument tolerance", value=tolerance, expected_type=type_hints["tolerance"])
            check_type(argname="argument tolerance_var", value=tolerance_var, expected_type=type_hints["tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var
        if feather is not None:
            self._values["feather"] = feather
        if feather_var is not None:
            self._values["feather_var"] = feather_var
        if tolerance is not None:
            self._values["tolerance"] = tolerance
        if tolerance_var is not None:
            self._values["tolerance_var"] = tolerance_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        '''
        result = self._values.get("feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather_var(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        '''
        result = self._values.get("feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        '''
        result = self._values.get("tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance_var(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        result = self._values.get("tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareRemoveColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareRemoveColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareRemoveColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7381ed0e94999d27968a32ad93099c840afa323e189c0e08f96145c13758ebb1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareRemoveColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cb5a3240fa18b6f6c0c5a18c4a1b05d3e6232d04d31d4503362281c92ba27ce0)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareRemoveColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__42db017a2058bc4992729ff776a402680d9d4e443b8f9db571b77de99dc91f80)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1af98d9717a4e2f69c22d375f827c9548b4e85550d8ee2be4acf14ed15c5fe09)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8097a0b69922f1941c5d5bdcd2f98e74567409d9fde0eb2128a79fa6fa6a06c9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareRemoveColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareRemoveColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareRemoveColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cf7a26390903d8ea3b47f0f3800aa61a49596ff46fa939662caeb254562afdcf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareRemoveColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareRemoveColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__61cf778482f30688e050e0aa1af69abb7abd4473d5a9ec687d85687180425dfe)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @jsii.member(jsii_name="resetFeather")
    def reset_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeather", []))

    @jsii.member(jsii_name="resetFeatherVar")
    def reset_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatherVar", []))

    @jsii.member(jsii_name="resetTolerance")
    def reset_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTolerance", []))

    @jsii.member(jsii_name="resetToleranceVar")
    def reset_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featherInput")
    def feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherInput"))

    @builtins.property
    @jsii.member(jsii_name="featherVarInput")
    def feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceInput")
    def tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceVarInput")
    def tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2b5106c011b58fc970a7b668c2991891b96644340467974ee874c53a45a70ca0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b1139b814feb2321afae4331e31fe2c7074df04996bf78f8d970578c5719d09c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="feather")
    def feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "feather"))

    @feather.setter
    def feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4fdb88ff3ade2401dddba60e85448ab6e25e88d7c1ea7e03951d21d9d1da2355)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "feather", value)

    @builtins.property
    @jsii.member(jsii_name="featherVar")
    def feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featherVar"))

    @feather_var.setter
    def feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__99d68f435c74a8e3b9a537f39eaa3abec036fc1875f1c0b37f573e138a396290)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featherVar", value)

    @builtins.property
    @jsii.member(jsii_name="tolerance")
    def tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tolerance"))

    @tolerance.setter
    def tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__386fc789132f8023a862d278b65bd2116a26a4cc52ade3a5f6b2d83faae32c6b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tolerance", value)

    @builtins.property
    @jsii.member(jsii_name="toleranceVar")
    def tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "toleranceVar"))

    @tolerance_var.setter
    def tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__47f49b41603b790f1f78aa0d68114841d2c35c5bb91fc2c7713003a1d7998a13)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "toleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareRemoveColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareRemoveColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareRemoveColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5673c7776d669632448aaa878f6aaf6e291fc03b693f6729c9ce97ebedb30f8d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareResize",
    jsii_struct_bases=[],
    name_mapping={
        "aspect": "aspect",
        "aspect_var": "aspectVar",
        "height": "height",
        "height_var": "heightVar",
        "type": "type",
        "type_var": "typeVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareResize:
    def __init__(
        self,
        *,
        aspect: typing.Optional[builtins.str] = None,
        aspect_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param aspect: Preserves the aspect ratio. Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect DataAkamaiImagingPolicyImage#aspect}
        :param aspect_var: Preserves the aspect ratio. Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_var DataAkamaiImagingPolicyImage#aspect_var}
        :param height: The height to resize the source image to. Must be set if height is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height to resize the source image to. Must be set if height is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param type: Sets constraints for the image resize. Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: Sets constraints for the image resize. Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        :param width: The width to resize the source image to. Must be set if width is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width to resize the source image to. Must be set if width is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f807fc13b83d5376666f82791a068198eb7978b8168a07e6f0287845edc74198)
            check_type(argname="argument aspect", value=aspect, expected_type=type_hints["aspect"])
            check_type(argname="argument aspect_var", value=aspect_var, expected_type=type_hints["aspect_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if aspect is not None:
            self._values["aspect"] = aspect
        if aspect_var is not None:
            self._values["aspect_var"] = aspect_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def aspect(self) -> typing.Optional[builtins.str]:
        '''Preserves the aspect ratio.

        Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect DataAkamaiImagingPolicyImage#aspect}
        '''
        result = self._values.get("aspect")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def aspect_var(self) -> typing.Optional[builtins.str]:
        '''Preserves the aspect ratio.

        Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_var DataAkamaiImagingPolicyImage#aspect_var}
        '''
        result = self._values.get("aspect_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height to resize the source image to. Must be set if height is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height to resize the source image to. Must be set if height is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''Sets constraints for the image resize.

        Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''Sets constraints for the image resize.

        Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width to resize the source image to. Must be set if width is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width to resize the source image to. Must be set if width is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareResize(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareResizeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareResizeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f3c10bf8996a8cfd101f97d78967b88ee25c58c9faa928c0ebdafec85370af36)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareResizeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1af4d7d475d9b5143a559259c697ccab9af0b6f0e32c7fc7a3a89a51261a2bd1)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareResizeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__455bb5a333619dfba69b384e6e98744ec86e4cb9dd0722840b6e6fe1e259e18d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c39b6e032651a91d087be29a857c507acae0c36c6bd19f04526cfef9e8d1119e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bdfe6301f65881ca3594fd825b7087b5637276dda8e56a7526cacbbc3e88c523)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareResize]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareResize]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareResize]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__90e452493c35cae341c36920b33a006d2918fdad16e3f58adffdd9bb14cd745b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareResizeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareResizeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__420a8277e50e2a477783bca9de9c78f5c9e0935914eac2851ee11388ad5f0d69)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAspect")
    def reset_aspect(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspect", []))

    @jsii.member(jsii_name="resetAspectVar")
    def reset_aspect_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspectVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="aspectInput")
    def aspect_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "aspectInput"))

    @builtins.property
    @jsii.member(jsii_name="aspectVarInput")
    def aspect_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "aspectVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="aspect")
    def aspect(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "aspect"))

    @aspect.setter
    def aspect(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__221b0da6972467afc57f63e8eb0ebbca705809465f37153fcc877c6d33509834)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "aspect", value)

    @builtins.property
    @jsii.member(jsii_name="aspectVar")
    def aspect_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "aspectVar"))

    @aspect_var.setter
    def aspect_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a8727e23a3bcaf28aedcb3f7b5279b9d01fcb588253d472e817700afc17efdd3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "aspectVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__920032ea036f9261cb9c231fc9e87d794d335d6097aa833a512db2231e8e3768)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ad8c36c6c01480d2c2922f4d298f19a50c4bc103b7a98b3f6bcfba70a620c1ac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__777db85fd76a0d4feceaa43bddfe7ba059923a12ae1782ab507efb147254bbad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bccb0512204ff1a92f2d3717329b6461ae7de36959eecbaee2c0a148284a0456)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4535ce4ec844006a702bfa6ddd814e3ae67cd5b0dda89a769f869585f13b8be2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7578dc7b8a40f1b171a55c4bd61c11fc671166f128b5ffee58e3630545269345)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareResize]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareResize]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareResize]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d703c196d21e916c5f362162fe740fad55d24340580b7763d610bcddc94c41de)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareRotate",
    jsii_struct_bases=[],
    name_mapping={"degrees": "degrees", "degrees_var": "degreesVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareRotate:
    def __init__(
        self,
        *,
        degrees: typing.Optional[builtins.str] = None,
        degrees_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param degrees: The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees DataAkamaiImagingPolicyImage#degrees}
        :param degrees_var: The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees_var DataAkamaiImagingPolicyImage#degrees_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__42dda532fff06bfc4ec33c8ffcf69901b370978581499d28c84dc4f869aee30f)
            check_type(argname="argument degrees", value=degrees, expected_type=type_hints["degrees"])
            check_type(argname="argument degrees_var", value=degrees_var, expected_type=type_hints["degrees_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if degrees is not None:
            self._values["degrees"] = degrees
        if degrees_var is not None:
            self._values["degrees_var"] = degrees_var

    @builtins.property
    def degrees(self) -> typing.Optional[builtins.str]:
        '''The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees DataAkamaiImagingPolicyImage#degrees}
        '''
        result = self._values.get("degrees")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def degrees_var(self) -> typing.Optional[builtins.str]:
        '''The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees_var DataAkamaiImagingPolicyImage#degrees_var}
        '''
        result = self._values.get("degrees_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareRotate(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareRotateList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareRotateList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__90b965a597c5ae70546adfd2f8439a37d81cab9b2a83a9724b398beb03ce6c61)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareRotateOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cc9a15ff2c7a2530d1605c5fb8686c1cafe64e2d047a1a4aebb93007d2ea4283)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareRotateOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a85eddbec546c782c08c1cec9eeb5b3780f5f03c8f939a29088c2fdac044f9fb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c0b563ebb20aee2226889da74993187191267b9ba81d5d70b047c93c4792ba7b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__80215c1e4aa15523e3242f020648657098a63900beb12880d3e440da20b8016e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareRotate]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareRotate]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareRotate]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b74114de0f5dab40a81701925a70c85dbed559a22e9f781fc360b73879a1ce1e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareRotateOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareRotateOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__950dc6551306c6a5352872cdecea479385c1614ada3ad69d306eb604df3448e8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetDegrees")
    def reset_degrees(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDegrees", []))

    @jsii.member(jsii_name="resetDegreesVar")
    def reset_degrees_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDegreesVar", []))

    @builtins.property
    @jsii.member(jsii_name="degreesInput")
    def degrees_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "degreesInput"))

    @builtins.property
    @jsii.member(jsii_name="degreesVarInput")
    def degrees_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "degreesVarInput"))

    @builtins.property
    @jsii.member(jsii_name="degrees")
    def degrees(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "degrees"))

    @degrees.setter
    def degrees(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ce76550ae06fcb82dd9fe006dc103c335dc907647ca764d5a5d499c87feb5ba5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "degrees", value)

    @builtins.property
    @jsii.member(jsii_name="degreesVar")
    def degrees_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "degreesVar"))

    @degrees_var.setter
    def degrees_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f1f01e8808648821caa3a156074e005ce35be2c8a16f27f8e919f6366e900068)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "degreesVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareRotate]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareRotate]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareRotate]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8c82afc4980f71136967f7df40bc144e6d9aea440a0b1ef22bbcb7690d2d43b4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareScale",
    jsii_struct_bases=[],
    name_mapping={
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareScale:
    def __init__(
        self,
        *,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param height: Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged. Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged. Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__791665ae80dc50762358add4e3cfd3d2ae25ec6729c0fbef83a5ae60a9c239eb)
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size.

        Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size.

        Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged.

        Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged.

        Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareScale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareScaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareScaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5341704788b566806099d1fac5889f4165db57e4055cde3c5c53dae703dca59c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareScaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cda4421cfba6c568c759c4d821a047ee3c17114060d1e6a06769f5991ea1ffed)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareScaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__31e73697db91b2c1e1e3c163ff6e7112879ce45e635c633bf51a0186bae46570)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c9f07929cc756d29d3fd1ce654a2f4c9379d58ed9eef77522d9b432e7f93845c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cdf7e48486192a42bc9d8d484e793ef05b72ec631623e498e13328eefc1c96d3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareScale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareScale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareScale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__143007e66970f21a581ba66b22370b274b82f8e4c6b4e10a8b0591c047213344)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareScaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareScaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__76585a3d9d8f86f360a6c82472c954c1cd54c174953a7292b0350a82ec978274)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f88b6a14fea507968f7ba109a9831430bf720384c9d4d9ea6ae87f1b693669f1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__42794e1d6ab910af397c7d80aee764adcafde1d00dfd5d85bd961e80ad634d66)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__856275299d0d63340079b70a9ff2181da3c59944dfb07e6b6e5970e8e045b894)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__24fc75dfa0757292aaa8dd6458da6c2179be6c8e1aea1e9002b609d544b8e37a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareScale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareScale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareScale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__02af3967f37929e8b7507bd387413e449f98585f35af86b83e2d2cf301ee6792)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareShear",
    jsii_struct_bases=[],
    name_mapping={
        "x_shear": "xShear",
        "x_shear_var": "xShearVar",
        "y_shear": "yShear",
        "y_shear_var": "yShearVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareShear:
    def __init__(
        self,
        *,
        x_shear: typing.Optional[builtins.str] = None,
        x_shear_var: typing.Optional[builtins.str] = None,
        y_shear: typing.Optional[builtins.str] = None,
        y_shear_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param x_shear: The amount to shear along the x-axis, measured in multiples of the image's width. Must be set if yShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear DataAkamaiImagingPolicyImage#x_shear}
        :param x_shear_var: The amount to shear along the x-axis, measured in multiples of the image's width. Must be set if yShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear_var DataAkamaiImagingPolicyImage#x_shear_var}
        :param y_shear: The amount to shear along the y-axis, measured in multiples of the image's height. Must be set if xShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear DataAkamaiImagingPolicyImage#y_shear}
        :param y_shear_var: The amount to shear along the y-axis, measured in multiples of the image's height. Must be set if xShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear_var DataAkamaiImagingPolicyImage#y_shear_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac9ceb193c715d551a4d901433181e6f5e6fd77a4df2cdfe0d6ded2344b9df5e)
            check_type(argname="argument x_shear", value=x_shear, expected_type=type_hints["x_shear"])
            check_type(argname="argument x_shear_var", value=x_shear_var, expected_type=type_hints["x_shear_var"])
            check_type(argname="argument y_shear", value=y_shear, expected_type=type_hints["y_shear"])
            check_type(argname="argument y_shear_var", value=y_shear_var, expected_type=type_hints["y_shear_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if x_shear is not None:
            self._values["x_shear"] = x_shear
        if x_shear_var is not None:
            self._values["x_shear_var"] = x_shear_var
        if y_shear is not None:
            self._values["y_shear"] = y_shear
        if y_shear_var is not None:
            self._values["y_shear_var"] = y_shear_var

    @builtins.property
    def x_shear(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the x-axis, measured in multiples of the image's width.

        Must be set if yShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear DataAkamaiImagingPolicyImage#x_shear}
        '''
        result = self._values.get("x_shear")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_shear_var(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the x-axis, measured in multiples of the image's width.

        Must be set if yShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear_var DataAkamaiImagingPolicyImage#x_shear_var}
        '''
        result = self._values.get("x_shear_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_shear(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the y-axis, measured in multiples of the image's height.

        Must be set if xShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear DataAkamaiImagingPolicyImage#y_shear}
        '''
        result = self._values.get("y_shear")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_shear_var(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the y-axis, measured in multiples of the image's height.

        Must be set if xShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear_var DataAkamaiImagingPolicyImage#y_shear_var}
        '''
        result = self._values.get("y_shear_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareShear(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareShearList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareShearList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6015bbb096e6e60205997cc933c49e12081a37051b2a580359db7c97b31c5bfa)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareShearOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__069f1f07422af6e69c5b7426fae2caf54b2c0e0693840818d66657a7f7d9b649)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareShearOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b9d91843436b8b91b3c41d7d537288419bc5d2196da02820bb02e83972dc3d15)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d08bac2d2ad2b6bd1b9866de6b25c083fa89428c74cb7a5efb569a04b6207834)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f54dafb02b09063b1f3d045bddf6b4c06148d45e768bb556a82758e4ce95525)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareShear]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareShear]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareShear]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a9f4967cf472055ea2fea81fd15e9b4e747b75ece80d1d4f86afcadb5b19baaa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareShearOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareShearOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__57e8a56e995b57b4186952bcbf99281c18efd889e62eeffe0ec63d2655352362)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetXShear")
    def reset_x_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXShear", []))

    @jsii.member(jsii_name="resetXShearVar")
    def reset_x_shear_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXShearVar", []))

    @jsii.member(jsii_name="resetYShear")
    def reset_y_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYShear", []))

    @jsii.member(jsii_name="resetYShearVar")
    def reset_y_shear_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYShearVar", []))

    @builtins.property
    @jsii.member(jsii_name="xShearInput")
    def x_shear_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xShearInput"))

    @builtins.property
    @jsii.member(jsii_name="xShearVarInput")
    def x_shear_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xShearVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yShearInput")
    def y_shear_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yShearInput"))

    @builtins.property
    @jsii.member(jsii_name="yShearVarInput")
    def y_shear_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yShearVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xShear")
    def x_shear(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xShear"))

    @x_shear.setter
    def x_shear(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f633156499005f7b3e2c3dfe0cc157bc0a4c0cf32a0be0ca7d63f2c0ace83df)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xShear", value)

    @builtins.property
    @jsii.member(jsii_name="xShearVar")
    def x_shear_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xShearVar"))

    @x_shear_var.setter
    def x_shear_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d72fe6ac764a44ba90f26ffdc6978db5438497812776f81baeda97ae417ea057)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xShearVar", value)

    @builtins.property
    @jsii.member(jsii_name="yShear")
    def y_shear(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yShear"))

    @y_shear.setter
    def y_shear(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea2b878891fb7c1d172a40aa778c13144af7d6ee0e1c264f14ccbd3dfdf88587)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yShear", value)

    @builtins.property
    @jsii.member(jsii_name="yShearVar")
    def y_shear_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yShearVar"))

    @y_shear_var.setter
    def y_shear_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__255aba0b2ea39b91a97ca6ef5260bbb31207662580045563e1f39f676a7e7547)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yShearVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareShear]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareShear]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareShear]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__65bd001d4d3a3f3a4bfb4e8d59d870d1bb7be214b0cbbec42198a040b9753cce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareTrim",
    jsii_struct_bases=[],
    name_mapping={
        "fuzz": "fuzz",
        "fuzz_var": "fuzzVar",
        "padding": "padding",
        "padding_var": "paddingVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareTrim:
    def __init__(
        self,
        *,
        fuzz: typing.Optional[builtins.str] = None,
        fuzz_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fuzz: The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz DataAkamaiImagingPolicyImage#fuzz}
        :param fuzz_var: The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz_var DataAkamaiImagingPolicyImage#fuzz_var}
        :param padding: The amount of padding in pixels to add to the trimmed image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: The amount of padding in pixels to add to the trimmed image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__efbe173d2e832d3b75398c4d015ef5daa81f8a4107a1cdf1b6d7b3617c7020a2)
            check_type(argname="argument fuzz", value=fuzz, expected_type=type_hints["fuzz"])
            check_type(argname="argument fuzz_var", value=fuzz_var, expected_type=type_hints["fuzz_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fuzz is not None:
            self._values["fuzz"] = fuzz
        if fuzz_var is not None:
            self._values["fuzz_var"] = fuzz_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var

    @builtins.property
    def fuzz(self) -> typing.Optional[builtins.str]:
        '''The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz DataAkamaiImagingPolicyImage#fuzz}
        '''
        result = self._values.get("fuzz")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fuzz_var(self) -> typing.Optional[builtins.str]:
        '''The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz_var DataAkamaiImagingPolicyImage#fuzz_var}
        '''
        result = self._values.get("fuzz_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''The amount of padding in pixels to add to the trimmed image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''The amount of padding in pixels to add to the trimmed image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareTrim(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareTrimList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareTrimList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__31eeb9570f1fa0007663aac7a692d974624a5f743340912d981f8fefa6c06a19)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareTrimOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e3c43950e73dc88368f634d5ce01e950d1f4baac650b01631e35f4c0bdd5d8a1)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareTrimOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e6d3160dd2fec19723dfff51400d40933250ac5f320734f16f71a79f39793e6d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a4d34445e916540194184e3711e7804a8930dea245b22ac5d2e75f2f623b9521)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bfe9b28d2097fa0c4dba5160ccca8d89bdee64452065ac592e0c1f7083065f77)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareTrim]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareTrim]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareTrim]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5cd87342f44ff945d65fbef2029cb491832bce7d3ed6bf15418669f6727641eb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareTrimOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareTrimOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c936fc9508a778443f6408accbc0c68d1fb719515afb3f0c8dc52a0d1e82c68b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetFuzz")
    def reset_fuzz(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFuzz", []))

    @jsii.member(jsii_name="resetFuzzVar")
    def reset_fuzz_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFuzzVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @builtins.property
    @jsii.member(jsii_name="fuzzInput")
    def fuzz_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fuzzInput"))

    @builtins.property
    @jsii.member(jsii_name="fuzzVarInput")
    def fuzz_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fuzzVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="fuzz")
    def fuzz(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fuzz"))

    @fuzz.setter
    def fuzz(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__68b71101a953f800cc6b7ab491cba4213acb34427eec52794125f6b0bbd777a5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fuzz", value)

    @builtins.property
    @jsii.member(jsii_name="fuzzVar")
    def fuzz_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fuzzVar"))

    @fuzz_var.setter
    def fuzz_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__18c3e3385f05b215640336f75ced63f7232bcde7cc876e48bc0bbfcdfe80755c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fuzzVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2b2eb16bb723e7dbdbd104eecdb4486a34f9ee7c198c3062cf2625117d0cdd8e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b75540a11aef1fd4d3de447368a6bed87a667a93fe9a554b9805bdc53bf01e6a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareTrim]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareTrim]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareTrim]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dbaae8c27552a215674c65a19ba81b174b76407dedc78d4ff8ddab36ece95f64)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareUnsharpMask",
    jsii_struct_bases=[],
    name_mapping={
        "gain": "gain",
        "gain_var": "gainVar",
        "sigma": "sigma",
        "sigma_var": "sigmaVar",
        "threshold": "threshold",
        "threshold_var": "thresholdVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareUnsharpMask:
    def __init__(
        self,
        *,
        gain: typing.Optional[builtins.str] = None,
        gain_var: typing.Optional[builtins.str] = None,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
        threshold: typing.Optional[builtins.str] = None,
        threshold_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param gain: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        :param gain_var: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        :param sigma: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        :param threshold: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        :param threshold_var: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__07ebff34ed9761110ddbd5665a5baeea4ee7b72325e5cbefae0b479a6d8ecf5c)
            check_type(argname="argument gain", value=gain, expected_type=type_hints["gain"])
            check_type(argname="argument gain_var", value=gain_var, expected_type=type_hints["gain_var"])
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
            check_type(argname="argument threshold", value=threshold, expected_type=type_hints["threshold"])
            check_type(argname="argument threshold_var", value=threshold_var, expected_type=type_hints["threshold_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if gain is not None:
            self._values["gain"] = gain
        if gain_var is not None:
            self._values["gain_var"] = gain_var
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var
        if threshold is not None:
            self._values["threshold"] = threshold
        if threshold_var is not None:
            self._values["threshold_var"] = threshold_var

    @builtins.property
    def gain(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        '''
        result = self._values.get("gain")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gain_var(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        '''
        result = self._values.get("gain_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        '''
        result = self._values.get("threshold")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold_var(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        result = self._values.get("threshold_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareUnsharpMask(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareUnsharpMaskList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareUnsharpMaskList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__75e63523beceaea2b1c25134c3c39c18fc322878d1580e84c47137cfbf0bb09a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareUnsharpMaskOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8f12e081a84c9e1f6e9b5b113cdc9850747fb414355168ed504cd562d839643b)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareUnsharpMaskOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b6574924b371278b84eaf9beedd89b248b5436765de368cca28f2d1c75cb7f2e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be5fb2b066b93c088a853a2ff33f4179a928cdcd2614efaa582e03ef187437ad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ef5f6b4f545555c2fed7e64e2f47fa361a6fe125bfecf0d808ea7b7af7fd177e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareUnsharpMask]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareUnsharpMask]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareUnsharpMask]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9554041d830ed79fe7deba0bd682dd57287b828a597939f74f08a37cd57cb50a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareUnsharpMaskOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareUnsharpMaskOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__167d39cb6e1e2431ad04f4cf00a7e6b1ef41efca26898fd5b9593f655ba6993a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetGain")
    def reset_gain(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGain", []))

    @jsii.member(jsii_name="resetGainVar")
    def reset_gain_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGainVar", []))

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @jsii.member(jsii_name="resetThreshold")
    def reset_threshold(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThreshold", []))

    @jsii.member(jsii_name="resetThresholdVar")
    def reset_threshold_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThresholdVar", []))

    @builtins.property
    @jsii.member(jsii_name="gainInput")
    def gain_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainInput"))

    @builtins.property
    @jsii.member(jsii_name="gainVarInput")
    def gain_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdInput")
    def threshold_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdVarInput")
    def threshold_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gain")
    def gain(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gain"))

    @gain.setter
    def gain(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__82b68c26432c271f3d01f4b52d475c3a2eec9788aeff9921cb1df0d744e036bf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gain", value)

    @builtins.property
    @jsii.member(jsii_name="gainVar")
    def gain_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gainVar"))

    @gain_var.setter
    def gain_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7a980e18fc9124cffe52d5fff93c265d4e386b0808f098811a1140791db78ffa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gainVar", value)

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b24eedfb4f7674887e147570338ddb60c5ece5b40615d3907e50477c527b901e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a2cff4529b182eb384a6c049570077226fedf4f23e5997b401458b8e8ec3ff30)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="threshold")
    def threshold(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "threshold"))

    @threshold.setter
    def threshold(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa6274c24085f8db9a0f40a8457f323b9b92d0011bac680f7c99b1c7ccb447c2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "threshold", value)

    @builtins.property
    @jsii.member(jsii_name="thresholdVar")
    def threshold_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "thresholdVar"))

    @threshold_var.setter
    def threshold_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be6591f94093025e9e4fb4b9b2ffc48118a5defbd1b418d2d606efea57dfd3d2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "thresholdVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareUnsharpMask]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareUnsharpMask]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareUnsharpMask]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__17fc9b885e620f5d8ee7daf7c6748578c6d644fb28a3ed86c26706630686d66b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanImQuery",
    jsii_struct_bases=[],
    name_mapping={
        "allowed_transformations": "allowedTransformations",
        "query_var": "queryVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanImQuery:
    def __init__(
        self,
        *,
        allowed_transformations: typing.Sequence[builtins.str],
        query_var: builtins.str,
    ) -> None:
        '''
        :param allowed_transformations: Specifies the transformations that can be applied using the query string parameter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allowed_transformations DataAkamaiImagingPolicyImage#allowed_transformations}
        :param query_var: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#query_var DataAkamaiImagingPolicyImage#query_var}.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__29dc36ba5447f3dcad023d34186526920dc6e2bb562ad3b2fe5ad8145c93d33c)
            check_type(argname="argument allowed_transformations", value=allowed_transformations, expected_type=type_hints["allowed_transformations"])
            check_type(argname="argument query_var", value=query_var, expected_type=type_hints["query_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "allowed_transformations": allowed_transformations,
            "query_var": query_var,
        }

    @builtins.property
    def allowed_transformations(self) -> typing.List[builtins.str]:
        '''Specifies the transformations that can be applied using the query string parameter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allowed_transformations DataAkamaiImagingPolicyImage#allowed_transformations}
        '''
        result = self._values.get("allowed_transformations")
        assert result is not None, "Required property 'allowed_transformations' is missing"
        return typing.cast(typing.List[builtins.str], result)

    @builtins.property
    def query_var(self) -> builtins.str:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#query_var DataAkamaiImagingPolicyImage#query_var}.'''
        result = self._values.get("query_var")
        assert result is not None, "Required property 'query_var' is missing"
        return typing.cast(builtins.str, result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanImQuery(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanImQueryList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanImQueryList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__08c100b4d6f8bf75f46c7fe9a5a0be52ca3c18126dded5cb52a63240c47652af)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanImQueryOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b04060df682932e22ed6b2e6fc1d101a79defec923787a539daf58c8509a40e1)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanImQueryOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b9f38bc84b757100652b2b3ccede88e57152cd5e3a117eadc05ee7b588457d1e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b21f3d0993580241cec5da44f9cb066b2dbca7274de797087adf0f86aef31c5f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fe935b89c58c3acdec956b856a95c64d446cbd65f90de8a3889ce942119b4751)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanImQuery]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanImQuery]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanImQuery]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5be64ba972e15ee7a39217fd4f841af64335cba98a5e9f72f87c137b33c58e65)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanImQueryOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanImQueryOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a55698f9296141a5bfc0aa43fd0e422e4ac109f95730dbb63ef69e94ec247f40)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @builtins.property
    @jsii.member(jsii_name="allowedTransformationsInput")
    def allowed_transformations_input(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "allowedTransformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="queryVarInput")
    def query_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "queryVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowedTransformations")
    def allowed_transformations(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "allowedTransformations"))

    @allowed_transformations.setter
    def allowed_transformations(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c7b59257f4ab3ceeee3a1840b8abf19d927752bfe43e80bd58027cfc462a9e40)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowedTransformations", value)

    @builtins.property
    @jsii.member(jsii_name="queryVar")
    def query_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "queryVar"))

    @query_var.setter
    def query_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__365c54634a2b83c20900f3ab44284fa2a7bd129beb6a696f7a3f9996ef3be474)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "queryVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanImQuery]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanImQuery]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanImQuery]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1803104c0ff1fd1ccc22609f7d571a557d668cdd38e29ae828fb033622da062f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanMaxColors",
    jsii_struct_bases=[],
    name_mapping={"colors": "colors", "colors_var": "colorsVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanMaxColors:
    def __init__(
        self,
        *,
        colors: typing.Optional[builtins.str] = None,
        colors_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param colors: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        :param colors_var: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1a8c73c42a02f5e53498a6d3e5af28033773772fe449ccea786d0a6251c579a7)
            check_type(argname="argument colors", value=colors, expected_type=type_hints["colors"])
            check_type(argname="argument colors_var", value=colors_var, expected_type=type_hints["colors_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if colors is not None:
            self._values["colors"] = colors
        if colors_var is not None:
            self._values["colors_var"] = colors_var

    @builtins.property
    def colors(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        '''
        result = self._values.get("colors")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def colors_var(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        result = self._values.get("colors_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanMaxColors(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanMaxColorsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanMaxColorsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af0dbc801bc0ec76fcb738c474a317ee77fd312ceb3d60a75311126940a13840)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanMaxColorsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fd474f3bc7c3aec4703e25ee07f7f831982884db1b89b0ef0e37bf2d2fe94e38)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanMaxColorsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c8e5e933a515f25ef0c7cefcf3f8db3480a60872882adbedbe5ae2c57dd69789)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__52f2a7e20d0c5538f871b9af1b116fb4cb699f68eeb79f860ce704abced5188f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9779f5384b602239245669c4ef8375285db4d16ca85dae32ccd9a539bfea8718)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanMaxColors]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanMaxColors]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__36da28f4b8e2a60683a16f315b7470f73895f953f898505d4215c8e550cd5e90)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanMaxColorsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanMaxColorsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__55898952aad3eba341227fc1906317a987b79999918d92e7c183e3cbe578ee6c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColors")
    def reset_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColors", []))

    @jsii.member(jsii_name="resetColorsVar")
    def reset_colors_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorsVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorsInput")
    def colors_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsInput"))

    @builtins.property
    @jsii.member(jsii_name="colorsVarInput")
    def colors_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsVarInput"))

    @builtins.property
    @jsii.member(jsii_name="colors")
    def colors(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colors"))

    @colors.setter
    def colors(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__06a4ae0a07c992f78bc77aa97e47bee3e7f8a8d0a83c76afaf9d12b97d05c2c8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colors", value)

    @builtins.property
    @jsii.member(jsii_name="colorsVar")
    def colors_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorsVar"))

    @colors_var.setter
    def colors_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__210dd40c81c2f9455711cd51a6f6d4b6605d64eda730367df9bfb8051e7c8c21)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorsVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanMaxColors]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanMaxColors]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanMaxColors]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f0330c62ba5bb19de217ac8c6e05c91d8c7f65c2e59fe84264b1cfe4bea27f28)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanMirror",
    jsii_struct_bases=[],
    name_mapping={
        "horizontal": "horizontal",
        "horizontal_var": "horizontalVar",
        "vertical": "vertical",
        "vertical_var": "verticalVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanMirror:
    def __init__(
        self,
        *,
        horizontal: typing.Optional[builtins.str] = None,
        horizontal_var: typing.Optional[builtins.str] = None,
        vertical: typing.Optional[builtins.str] = None,
        vertical_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param horizontal: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        :param horizontal_var: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        :param vertical: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        :param vertical_var: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ff3001177f1218d2082624a6df85f537fc904d00cdc96742dc68bccd0e787726)
            check_type(argname="argument horizontal", value=horizontal, expected_type=type_hints["horizontal"])
            check_type(argname="argument horizontal_var", value=horizontal_var, expected_type=type_hints["horizontal_var"])
            check_type(argname="argument vertical", value=vertical, expected_type=type_hints["vertical"])
            check_type(argname="argument vertical_var", value=vertical_var, expected_type=type_hints["vertical_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if horizontal is not None:
            self._values["horizontal"] = horizontal
        if horizontal_var is not None:
            self._values["horizontal_var"] = horizontal_var
        if vertical is not None:
            self._values["vertical"] = vertical
        if vertical_var is not None:
            self._values["vertical_var"] = vertical_var

    @builtins.property
    def horizontal(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        '''
        result = self._values.get("horizontal")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def horizontal_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        '''
        result = self._values.get("horizontal_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        '''
        result = self._values.get("vertical")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        result = self._values.get("vertical_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanMirror(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanMirrorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanMirrorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eebf0cd6603ab6ce92372a23ed900d49965a0b7c732c2e2d874f41df430aca66)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanMirrorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8fd0bf9d200ced9c51762c4c41e630a5a1cee18f9886300620428a4c7c813645)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanMirrorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e5438eaec35c30bc6d879c4086be3014dda4bcaae8ef2576ce3a8cf745df6309)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8d98392e94313d9165140c8de861f88ff7ed2538637af81eb13b73237d681d5c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__36e82a936f8eda2379d3ba8e4738cfb9a8c48211da28f843744a4d49a18a3667)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanMirror]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanMirror]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__05c1cc3cee1d5c5d42c9286143d6fdc572ec8c9f4aca4a689383a3a92f658ed4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanMirrorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanMirrorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__51f2cecccc181dcd99e47640fd0c552379096ddd76dabd608f3cdec5d30ead35)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHorizontal")
    def reset_horizontal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontal", []))

    @jsii.member(jsii_name="resetHorizontalVar")
    def reset_horizontal_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontalVar", []))

    @jsii.member(jsii_name="resetVertical")
    def reset_vertical(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVertical", []))

    @jsii.member(jsii_name="resetVerticalVar")
    def reset_vertical_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVerticalVar", []))

    @builtins.property
    @jsii.member(jsii_name="horizontalInput")
    def horizontal_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontalVarInput")
    def horizontal_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalInput")
    def vertical_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalVarInput")
    def vertical_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontal")
    def horizontal(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontal"))

    @horizontal.setter
    def horizontal(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aa4a9302b75e970806d6bf4ee99cd50a98eef5f13342caab636c71ff1f459032)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontal", value)

    @builtins.property
    @jsii.member(jsii_name="horizontalVar")
    def horizontal_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontalVar"))

    @horizontal_var.setter
    def horizontal_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5af1ae26c90dac972c3b80a5bf64b56bd61a49787c6f0b8a6f81a6a79e3e6d8d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontalVar", value)

    @builtins.property
    @jsii.member(jsii_name="vertical")
    def vertical(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "vertical"))

    @vertical.setter
    def vertical(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__662e3222753dfb903268f17f5fcdeae868b210174f6591d0fdcf46fa243c9bdf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "vertical", value)

    @builtins.property
    @jsii.member(jsii_name="verticalVar")
    def vertical_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "verticalVar"))

    @vertical_var.setter
    def vertical_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__984d257dd3fbaae3683464f70c45724837bff4b8ad3c25ba081b93678a0f4fc1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "verticalVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanMirror]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanMirror]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanMirror]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__81d7539ab2f73a6ed2ef4f4b230b261e550237d25ad9015262c40c8bd81b436f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanMonoHue",
    jsii_struct_bases=[],
    name_mapping={"hue": "hue", "hue_var": "hueVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanMonoHue:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7f8fdaf46db7620ccc1bf03ec04ada5a74c36d32c893b8fb31689aec3bfd8988)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanMonoHue(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanMonoHueList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanMonoHueList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__edb87af2cc8d9879a679e54c322d3a1072eb7ea2e8c56e37345f2bc954869aa2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanMonoHueOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5e999a98b9bc17630e98685f5b740ae3345b83170a3cee2ce7967200100b6f97)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanMonoHueOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a5bf6b8e8e825b51cfb22fe394ad340a69a2203029e5d1631496c30c60c49497)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__012d4273c956a6d03046e0616592a8c8315b631b6f52e33288f5a9982499b3d7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5d9957f8bd2d55dffc58a5f11b61cc8ffef8cc42ace7db45e913a22ad4dab013)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanMonoHue]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanMonoHue]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3c90390c5123267690c9f88ae2c4861084d11515823231d621c9e83ad750ea60)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanMonoHueOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanMonoHueOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1ba41c1848c3587861f664caf31ec7df53a36b9d37303ae0ea200a5f2f72acc8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c1a8ebb753783d3546457f3cd765058b8d59e467f625b9b6c49a9adcad9062d8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d39ff1874976c18f10ac95e9afe95aa3943d8f0cc01c60660c65380c3089c5aa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanMonoHue]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanMonoHue]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanMonoHue]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b5556458a0054830db367d4d553b6b44ce397ad9f3816d23063168ad502d8287)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanOpacity",
    jsii_struct_bases=[],
    name_mapping={"opacity": "opacity", "opacity_var": "opacityVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanOpacity:
    def __init__(
        self,
        *,
        opacity: typing.Optional[builtins.str] = None,
        opacity_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param opacity: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param opacity_var: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e17dc869292e1fc958ee25c37b0d181ea3c0645cfbde33a1b10ba7ef2985b2da)
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument opacity_var", value=opacity_var, expected_type=type_hints["opacity_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if opacity is not None:
            self._values["opacity"] = opacity
        if opacity_var is not None:
            self._values["opacity_var"] = opacity_var

    @builtins.property
    def opacity(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def opacity_var(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        result = self._values.get("opacity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanOpacity(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanOpacityList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanOpacityList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8862af0d826db83c8c1730c15a9391d9016639614299a3f25bba13be23632e5f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanOpacityOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cb5cc1958ca955b9be92aab51a67fe1469f09445eaa1be369d71a77a6e313915)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanOpacityOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d347af537d5f1c45dd12c9d7da8bf5f776889a68660a30306f3ca76e5c6f5779)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__91347545cada30c627eea4bde304228c79928ad0ee4e63fbdec0380ce3ffa796)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__77c18213335c9aab7bfd902db11af5ae61cbcb4bd628cd75af07171f0b8c9e2f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanOpacity]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanOpacity]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a65fb28e3ccf6725dccbbdb0faf0e7d3b665f8df173405c8fe14b7f563d499b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanOpacityOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanOpacityOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__466d0fcf0cfacff06a24c94d3acfd34c9438a941445c55f8d5120d35cb86b52f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetOpacityVar")
    def reset_opacity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacityVar", []))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityVarInput")
    def opacity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacity"))

    @opacity.setter
    def opacity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__528f6550632591d54304234775025e7a5b0c2269b2230971d727089e05b5b7c3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacity", value)

    @builtins.property
    @jsii.member(jsii_name="opacityVar")
    def opacity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacityVar"))

    @opacity_var.setter
    def opacity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ddb331c0c0a68fda1d0318ae00ce397035b68245d2672893958fbd9819073b80)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacityVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanOpacity]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanOpacity]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanOpacity]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0d1e7b300ab556a3efd676004455b0e95d6767130560e2afd4951bd984fe9569)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a9416b799f5784185287d078b810ca7aca213c33482e6ab3892b83ae3592728e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putAppend")
    def put_append(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppend, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__53e19ed85597a9d5cf3eb99eb9b13b5920f06594e2216050aa1e39ac20b5af0f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putAppend", [value]))

    @jsii.member(jsii_name="putAspectCrop")
    def put_aspect_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAspectCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c7e7a573be2b763cd9f3b46b0fd2ff30235878af6cdd2bbfaffa692baac3ee83)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putAspectCrop", [value]))

    @jsii.member(jsii_name="putBackgroundColor")
    def put_background_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__41666b4cb1469282d09215586a7d0ee8d923619b198f3ab7a596ddf75638ad23)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBackgroundColor", [value]))

    @jsii.member(jsii_name="putBlur")
    def put_blur(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanBlur, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa1776573be70c62c55d1ba1ca185ce5802e6220f5337bb6ef3861fd9fdd24a3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBlur", [value]))

    @jsii.member(jsii_name="putChromaKey")
    def put_chroma_key(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanChromaKey, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__405c84a30bad054771b8271e25baa55cc112dfa1f8afe8a70b758f51ea22b586)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putChromaKey", [value]))

    @jsii.member(jsii_name="putComposite")
    def put_composite(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanComposite, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bbc7d38540ace8185850bb62695528c0fb416a78d89d2f402793a98625514da5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putComposite", [value]))

    @jsii.member(jsii_name="putCompound")
    def put_compound(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompound, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__257e6def7e0c3b4bd543df427d45e7df495ed6c2b2d5e94633e9ff6b21693b73)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCompound", [value]))

    @jsii.member(jsii_name="putContrast")
    def put_contrast(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanContrast, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__010fdd334d904067cd7fb5ec8f1c4e679b454b977d655e9685528b6b7b092ca1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putContrast", [value]))

    @jsii.member(jsii_name="putCrop")
    def put_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__807b4802b215e1023b3d13f9b436369889432765b9997a7163b0415b951713b7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCrop", [value]))

    @jsii.member(jsii_name="putFaceCrop")
    def put_face_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFaceCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a7262216cf1bfb17258cd608f426e4b78b5d5238f9033bd69174a248cacee1f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFaceCrop", [value]))

    @jsii.member(jsii_name="putFeatureCrop")
    def put_feature_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFeatureCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__898c23e76ef0ce8a65e32d407051a215db13fa9a6531849069c6c0cd95004e83)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFeatureCrop", [value]))

    @jsii.member(jsii_name="putFitAndFill")
    def put_fit_and_fill(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFill, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5b8ba0ac1ba6ef5caf6c7a618fd05e213951c53c42dd1aaaf11fe8ed1f53d6cb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFitAndFill", [value]))

    @jsii.member(jsii_name="putGoop")
    def put_goop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanGoop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__44a3edfeebdf76b5234ab2f7a3b285660389e8a59fabec21fe992fb88ad12f49)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGoop", [value]))

    @jsii.member(jsii_name="putGrayscale")
    def put_grayscale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanGrayscale, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__43edfb72422da7d71b057f85b38b905c524ed5968d4b52a7729c3978458ff027)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGrayscale", [value]))

    @jsii.member(jsii_name="putHsl")
    def put_hsl(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanHsl, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__090dd3570a6aba739e24c7a6c515fbf79941a15433dc91a117c093f58b6bb98c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsl", [value]))

    @jsii.member(jsii_name="putHsv")
    def put_hsv(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanHsv, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d32e0f6e7b040ef646248f6762479465457a8f1d95afd1b3face3cede5d5911c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsv", [value]))

    @jsii.member(jsii_name="putIfDimension")
    def put_if_dimension(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimension, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__987d72a11fc11d6c64de617ee79f24148360b33ab5a8fdd5908451970c2ba41d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfDimension", [value]))

    @jsii.member(jsii_name="putIfOrientation")
    def put_if_orientation(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b976e4cec442ef987bb53a2fc5ecb00283b92aa6481a7c696ccd5b1edd3292cf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfOrientation", [value]))

    @jsii.member(jsii_name="putImQuery")
    def put_im_query(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanImQuery, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__63c8932e3246895d75d77cf8c46a9eec4cddf40491c5513f2ac001f1e38024cd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putImQuery", [value]))

    @jsii.member(jsii_name="putMaxColors")
    def put_max_colors(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanMaxColors, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0e4cf7c57ff062727f66f833555c91984420f6da6bc8a13789d1141af5db522b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMaxColors", [value]))

    @jsii.member(jsii_name="putMirror")
    def put_mirror(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanMirror, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__43fea1f8699fddede77f7715eb3275a63262459fc8daac103755910f6f6789d2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMirror", [value]))

    @jsii.member(jsii_name="putMonoHue")
    def put_mono_hue(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanMonoHue, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7db9f872d3e1d6cd0bb9adab7dfec903c3a677f2f2986e9631380e531ac67fa1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMonoHue", [value]))

    @jsii.member(jsii_name="putOpacity")
    def put_opacity(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanOpacity, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b5cf01262c4c74964e16e9b76efe4003cfe8c672db75e1e74092979387c0a03a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putOpacity", [value]))

    @jsii.member(jsii_name="putRegionOfInterestCrop")
    def put_region_of_interest_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCrop", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__96f57fa7d7ba6659e2c2727fe808e60baa4c48a6d12ff5f6bde1b2480906f4f6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRegionOfInterestCrop", [value]))

    @jsii.member(jsii_name="putRelativeCrop")
    def put_relative_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRelativeCrop", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__26051145278dc600eed3cab130dc9e2162489117d65f8a5f76be433a83368b1e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRelativeCrop", [value]))

    @jsii.member(jsii_name="putRemoveColor")
    def put_remove_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRemoveColor", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af066d792e37a27e071b7167e85225e3b07685b64aafb66041d8fea2c336a522)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRemoveColor", [value]))

    @jsii.member(jsii_name="putResize")
    def put_resize(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanResize", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4656ede6cdf5218d94b4f4baa006ba4809077304026037393285bfb56c9b3e82)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putResize", [value]))

    @jsii.member(jsii_name="putRotate")
    def put_rotate(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRotate", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a64cedba4890f672e16ffff56cb1c74b0b40f4dc05971c2b12dcd55918909c67)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRotate", [value]))

    @jsii.member(jsii_name="putScale")
    def put_scale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanScale", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__63ef04d2bf68a5db8f48df0e948dd7f56d2923ed6c2254db50f64fd8b90348bc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putScale", [value]))

    @jsii.member(jsii_name="putShear")
    def put_shear(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanShear", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7bd2b6f2b23c694ddc05f313fc3b4f9cd10861721d641b40fd9f4b67de862e57)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putShear", [value]))

    @jsii.member(jsii_name="putTrim")
    def put_trim(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanTrim", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__960386ff968f6775f6c413c4035642734f2b225c7e24aa5d96d3925e49fa2e81)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTrim", [value]))

    @jsii.member(jsii_name="putUnsharpMask")
    def put_unsharp_mask(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanUnsharpMask", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__663a29897646273297073a53467b44fd3f936e6b2909eeed1662714833f804d7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putUnsharpMask", [value]))

    @jsii.member(jsii_name="resetAppend")
    def reset_append(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAppend", []))

    @jsii.member(jsii_name="resetAspectCrop")
    def reset_aspect_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspectCrop", []))

    @jsii.member(jsii_name="resetBackgroundColor")
    def reset_background_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBackgroundColor", []))

    @jsii.member(jsii_name="resetBlur")
    def reset_blur(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBlur", []))

    @jsii.member(jsii_name="resetChromaKey")
    def reset_chroma_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChromaKey", []))

    @jsii.member(jsii_name="resetComposite")
    def reset_composite(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetComposite", []))

    @jsii.member(jsii_name="resetCompound")
    def reset_compound(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCompound", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetCrop")
    def reset_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCrop", []))

    @jsii.member(jsii_name="resetFaceCrop")
    def reset_face_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFaceCrop", []))

    @jsii.member(jsii_name="resetFeatureCrop")
    def reset_feature_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureCrop", []))

    @jsii.member(jsii_name="resetFitAndFill")
    def reset_fit_and_fill(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFitAndFill", []))

    @jsii.member(jsii_name="resetGoop")
    def reset_goop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGoop", []))

    @jsii.member(jsii_name="resetGrayscale")
    def reset_grayscale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGrayscale", []))

    @jsii.member(jsii_name="resetHsl")
    def reset_hsl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsl", []))

    @jsii.member(jsii_name="resetHsv")
    def reset_hsv(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsv", []))

    @jsii.member(jsii_name="resetIfDimension")
    def reset_if_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfDimension", []))

    @jsii.member(jsii_name="resetIfOrientation")
    def reset_if_orientation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfOrientation", []))

    @jsii.member(jsii_name="resetImQuery")
    def reset_im_query(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetImQuery", []))

    @jsii.member(jsii_name="resetMaxColors")
    def reset_max_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxColors", []))

    @jsii.member(jsii_name="resetMirror")
    def reset_mirror(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMirror", []))

    @jsii.member(jsii_name="resetMonoHue")
    def reset_mono_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonoHue", []))

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetRegionOfInterestCrop")
    def reset_region_of_interest_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRegionOfInterestCrop", []))

    @jsii.member(jsii_name="resetRelativeCrop")
    def reset_relative_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRelativeCrop", []))

    @jsii.member(jsii_name="resetRemoveColor")
    def reset_remove_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRemoveColor", []))

    @jsii.member(jsii_name="resetResize")
    def reset_resize(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetResize", []))

    @jsii.member(jsii_name="resetRotate")
    def reset_rotate(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRotate", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetShear")
    def reset_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetShear", []))

    @jsii.member(jsii_name="resetTrim")
    def reset_trim(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTrim", []))

    @jsii.member(jsii_name="resetUnsharpMask")
    def reset_unsharp_mask(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUnsharpMask", []))

    @builtins.property
    @jsii.member(jsii_name="append")
    def append(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendList, jsii.get(self, "append"))

    @builtins.property
    @jsii.member(jsii_name="aspectCrop")
    def aspect_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAspectCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAspectCropList, jsii.get(self, "aspectCrop"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColor")
    def background_color(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanBackgroundColorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanBackgroundColorList, jsii.get(self, "backgroundColor"))

    @builtins.property
    @jsii.member(jsii_name="blur")
    def blur(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanBlurList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanBlurList, jsii.get(self, "blur"))

    @builtins.property
    @jsii.member(jsii_name="chromaKey")
    def chroma_key(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanChromaKeyList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanChromaKeyList, jsii.get(self, "chromaKey"))

    @builtins.property
    @jsii.member(jsii_name="composite")
    def composite(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeList, jsii.get(self, "composite"))

    @builtins.property
    @jsii.member(jsii_name="compound")
    def compound(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompoundList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompoundList, jsii.get(self, "compound"))

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanContrastList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanContrastList, jsii.get(self, "contrast"))

    @builtins.property
    @jsii.member(jsii_name="crop")
    def crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCropList, jsii.get(self, "crop"))

    @builtins.property
    @jsii.member(jsii_name="faceCrop")
    def face_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFaceCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFaceCropList, jsii.get(self, "faceCrop"))

    @builtins.property
    @jsii.member(jsii_name="featureCrop")
    def feature_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFeatureCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFeatureCropList, jsii.get(self, "featureCrop"))

    @builtins.property
    @jsii.member(jsii_name="fitAndFill")
    def fit_and_fill(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillList, jsii.get(self, "fitAndFill"))

    @builtins.property
    @jsii.member(jsii_name="goop")
    def goop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanGoopList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanGoopList, jsii.get(self, "goop"))

    @builtins.property
    @jsii.member(jsii_name="grayscale")
    def grayscale(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanGrayscaleList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanGrayscaleList, jsii.get(self, "grayscale"))

    @builtins.property
    @jsii.member(jsii_name="hsl")
    def hsl(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanHslList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanHslList, jsii.get(self, "hsl"))

    @builtins.property
    @jsii.member(jsii_name="hsv")
    def hsv(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanHsvList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanHsvList, jsii.get(self, "hsv"))

    @builtins.property
    @jsii.member(jsii_name="ifDimension")
    def if_dimension(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionList", jsii.get(self, "ifDimension"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientation")
    def if_orientation(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationList, jsii.get(self, "ifOrientation"))

    @builtins.property
    @jsii.member(jsii_name="imQuery")
    def im_query(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanImQueryList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanImQueryList, jsii.get(self, "imQuery"))

    @builtins.property
    @jsii.member(jsii_name="maxColors")
    def max_colors(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanMaxColorsList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanMaxColorsList, jsii.get(self, "maxColors"))

    @builtins.property
    @jsii.member(jsii_name="mirror")
    def mirror(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanMirrorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanMirrorList, jsii.get(self, "mirror"))

    @builtins.property
    @jsii.member(jsii_name="monoHue")
    def mono_hue(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanMonoHueList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanMonoHueList, jsii.get(self, "monoHue"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanOpacityList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanOpacityList, jsii.get(self, "opacity"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestCrop")
    def region_of_interest_crop(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropList", jsii.get(self, "regionOfInterestCrop"))

    @builtins.property
    @jsii.member(jsii_name="relativeCrop")
    def relative_crop(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRelativeCropList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRelativeCropList", jsii.get(self, "relativeCrop"))

    @builtins.property
    @jsii.member(jsii_name="removeColor")
    def remove_color(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRemoveColorList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRemoveColorList", jsii.get(self, "removeColor"))

    @builtins.property
    @jsii.member(jsii_name="resize")
    def resize(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanResizeList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanResizeList", jsii.get(self, "resize"))

    @builtins.property
    @jsii.member(jsii_name="rotate")
    def rotate(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRotateList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRotateList", jsii.get(self, "rotate"))

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanScaleList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanScaleList", jsii.get(self, "scale"))

    @builtins.property
    @jsii.member(jsii_name="shear")
    def shear(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanShearList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanShearList", jsii.get(self, "shear"))

    @builtins.property
    @jsii.member(jsii_name="trim")
    def trim(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanTrimList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanTrimList", jsii.get(self, "trim"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMask")
    def unsharp_mask(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanUnsharpMaskList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanUnsharpMaskList", jsii.get(self, "unsharpMask"))

    @builtins.property
    @jsii.member(jsii_name="appendInput")
    def append_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppend]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppend]]], jsii.get(self, "appendInput"))

    @builtins.property
    @jsii.member(jsii_name="aspectCropInput")
    def aspect_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAspectCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAspectCrop]]], jsii.get(self, "aspectCropInput"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColorInput")
    def background_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanBackgroundColor]]], jsii.get(self, "backgroundColorInput"))

    @builtins.property
    @jsii.member(jsii_name="blurInput")
    def blur_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanBlur]]], jsii.get(self, "blurInput"))

    @builtins.property
    @jsii.member(jsii_name="chromaKeyInput")
    def chroma_key_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanChromaKey]]], jsii.get(self, "chromaKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="compositeInput")
    def composite_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanComposite]]], jsii.get(self, "compositeInput"))

    @builtins.property
    @jsii.member(jsii_name="compoundInput")
    def compound_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompound]]], jsii.get(self, "compoundInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanContrast]]], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="cropInput")
    def crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCrop]]], jsii.get(self, "cropInput"))

    @builtins.property
    @jsii.member(jsii_name="faceCropInput")
    def face_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFaceCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFaceCrop]]], jsii.get(self, "faceCropInput"))

    @builtins.property
    @jsii.member(jsii_name="featureCropInput")
    def feature_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFeatureCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFeatureCrop]]], jsii.get(self, "featureCropInput"))

    @builtins.property
    @jsii.member(jsii_name="fitAndFillInput")
    def fit_and_fill_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFill]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFill]]], jsii.get(self, "fitAndFillInput"))

    @builtins.property
    @jsii.member(jsii_name="goopInput")
    def goop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanGoop]]], jsii.get(self, "goopInput"))

    @builtins.property
    @jsii.member(jsii_name="grayscaleInput")
    def grayscale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanGrayscale]]], jsii.get(self, "grayscaleInput"))

    @builtins.property
    @jsii.member(jsii_name="hslInput")
    def hsl_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanHsl]]], jsii.get(self, "hslInput"))

    @builtins.property
    @jsii.member(jsii_name="hsvInput")
    def hsv_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanHsv]]], jsii.get(self, "hsvInput"))

    @builtins.property
    @jsii.member(jsii_name="ifDimensionInput")
    def if_dimension_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimension]]], jsii.get(self, "ifDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientationInput")
    def if_orientation_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientation]]], jsii.get(self, "ifOrientationInput"))

    @builtins.property
    @jsii.member(jsii_name="imQueryInput")
    def im_query_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanImQuery]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanImQuery]]], jsii.get(self, "imQueryInput"))

    @builtins.property
    @jsii.member(jsii_name="maxColorsInput")
    def max_colors_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanMaxColors]]], jsii.get(self, "maxColorsInput"))

    @builtins.property
    @jsii.member(jsii_name="mirrorInput")
    def mirror_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanMirror]]], jsii.get(self, "mirrorInput"))

    @builtins.property
    @jsii.member(jsii_name="monoHueInput")
    def mono_hue_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanMonoHue]]], jsii.get(self, "monoHueInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanOpacity]]], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestCropInput")
    def region_of_interest_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCrop"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCrop"]]], jsii.get(self, "regionOfInterestCropInput"))

    @builtins.property
    @jsii.member(jsii_name="relativeCropInput")
    def relative_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRelativeCrop"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRelativeCrop"]]], jsii.get(self, "relativeCropInput"))

    @builtins.property
    @jsii.member(jsii_name="removeColorInput")
    def remove_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRemoveColor"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRemoveColor"]]], jsii.get(self, "removeColorInput"))

    @builtins.property
    @jsii.member(jsii_name="resizeInput")
    def resize_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanResize"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanResize"]]], jsii.get(self, "resizeInput"))

    @builtins.property
    @jsii.member(jsii_name="rotateInput")
    def rotate_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRotate"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRotate"]]], jsii.get(self, "rotateInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanScale"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanScale"]]], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="shearInput")
    def shear_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanShear"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanShear"]]], jsii.get(self, "shearInput"))

    @builtins.property
    @jsii.member(jsii_name="trimInput")
    def trim_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanTrim"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanTrim"]]], jsii.get(self, "trimInput"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMaskInput")
    def unsharp_mask_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanUnsharpMask"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanUnsharpMask"]]], jsii.get(self, "unsharpMaskInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__777a2dcdd74e55957b3e17ffca9f4c641e3a1761480b42e7c981ebe35f63ea6a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCrop",
    jsii_struct_bases=[],
    name_mapping={
        "region_of_interest": "regionOfInterest",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCrop:
    def __init__(
        self,
        *,
        region_of_interest: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterest", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param region_of_interest: region_of_interest block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest DataAkamaiImagingPolicyImage#region_of_interest}
        :param gravity: The placement of the crop area relative to the specified area of interest. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: The placement of the crop area relative to the specified area of interest. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param style: Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(region_of_interest, dict):
            region_of_interest = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterest(**region_of_interest)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8fa8d706f28e368b9d04e6e4cd63a32d3034bb345563abc26f8ec129e70ca392)
            check_type(argname="argument region_of_interest", value=region_of_interest, expected_type=type_hints["region_of_interest"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "region_of_interest": region_of_interest,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def region_of_interest(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterest":
        '''region_of_interest block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest DataAkamaiImagingPolicyImage#region_of_interest}
        '''
        result = self._values.get("region_of_interest")
        assert result is not None, "Required property 'region_of_interest' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterest", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''The placement of the crop area relative to the specified area of interest.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''The placement of the crop area relative to the specified area of interest.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__987f488b46d66800b730255dbe5bc7cdee55a45f7977038caba1678e4484f0ea)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__17dd8ecd8ebf54f88b6c895d002070edc1e274e3c671ea4ba8f766a2711ac2fa)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__51f09b131178df35c1f90c08db9d74086996b33829a276724b8aea11db3f6d72)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7ce2461f90456e5fbda248615b88aa1c061aa223b0e3bfa045bd83b8c3a8ddcc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2292f19f52498c29ace2cda04554280b1ac21ee992bf0eb6304313c22fb68989)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ac2c6a7ea249b3e32755817c2adc9ff0a1840064839ecdf176dd9367e2a7cbb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3284f615affb54bc68469b150e80825ba1b7c16d1af6116baf2c38aea3ff8fc1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putRegionOfInterest")
    def put_region_of_interest(
        self,
        *,
        circle_shape: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestCircleShape", typing.Dict[builtins.str, typing.Any]]]]] = None,
        point_shape: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestPointShape", typing.Dict[builtins.str, typing.Any]]]]] = None,
        polygon_shape: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestPolygonShape", typing.Dict[builtins.str, typing.Any]]]]] = None,
        rectangle_shape: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestRectangleShape", typing.Dict[builtins.str, typing.Any]]]]] = None,
        union_shape: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestUnionShape", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param circle_shape: circle_shape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#circle_shape DataAkamaiImagingPolicyImage#circle_shape}
        :param point_shape: point_shape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#point_shape DataAkamaiImagingPolicyImage#point_shape}
        :param polygon_shape: polygon_shape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#polygon_shape DataAkamaiImagingPolicyImage#polygon_shape}
        :param rectangle_shape: rectangle_shape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rectangle_shape DataAkamaiImagingPolicyImage#rectangle_shape}
        :param union_shape: union_shape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#union_shape DataAkamaiImagingPolicyImage#union_shape}
        '''
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterest(
            circle_shape=circle_shape,
            point_shape=point_shape,
            polygon_shape=polygon_shape,
            rectangle_shape=rectangle_shape,
            union_shape=union_shape,
        )

        return typing.cast(None, jsii.invoke(self, "putRegionOfInterest", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterest")
    def region_of_interest(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestOutputReference", jsii.get(self, "regionOfInterest"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestInput")
    def region_of_interest_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterest"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterest"], jsii.get(self, "regionOfInterestInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__900b82f1ceaa7242fa69ef664d8d4e1184fe5c1e5e85237a57249b161f4613b3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f2af2de867286010be9e32521cc164f0a9fc2ce4f9f0e9613004e47e99b168dd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__54b7b72c1fc0fea5852944b6c689d1905e18e7db16339429fd70499acf2eb2be)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1caa83d46b95bdddfb7782e9175af08d8c5f178e6f408bd3d13be87f11062f49)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b7f4d2564f7e869c0939666d2bc8cd3c8af59002932cb437baef7ea6e6be2ca3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4b5b5fcb0f06ca4f99596770c0a223ef748e14e77b6121199d248942a8995136)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fedc3db0a0ce25279241d47fbd772b7969e427d036b3ed94ffe337139f265a0d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__322cab7e0c6cc49ab907fdce96351b74f1bd8d33330c865a428a4d53cf059c51)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__44a1e4efd50356384f8d6d4c2377b2383843e2dc09497aa398ad558140deeef1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterest",
    jsii_struct_bases=[],
    name_mapping={
        "circle_shape": "circleShape",
        "point_shape": "pointShape",
        "polygon_shape": "polygonShape",
        "rectangle_shape": "rectangleShape",
        "union_shape": "unionShape",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterest:
    def __init__(
        self,
        *,
        circle_shape: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestCircleShape", typing.Dict[builtins.str, typing.Any]]]]] = None,
        point_shape: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestPointShape", typing.Dict[builtins.str, typing.Any]]]]] = None,
        polygon_shape: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestPolygonShape", typing.Dict[builtins.str, typing.Any]]]]] = None,
        rectangle_shape: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestRectangleShape", typing.Dict[builtins.str, typing.Any]]]]] = None,
        union_shape: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestUnionShape", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param circle_shape: circle_shape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#circle_shape DataAkamaiImagingPolicyImage#circle_shape}
        :param point_shape: point_shape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#point_shape DataAkamaiImagingPolicyImage#point_shape}
        :param polygon_shape: polygon_shape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#polygon_shape DataAkamaiImagingPolicyImage#polygon_shape}
        :param rectangle_shape: rectangle_shape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rectangle_shape DataAkamaiImagingPolicyImage#rectangle_shape}
        :param union_shape: union_shape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#union_shape DataAkamaiImagingPolicyImage#union_shape}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d3a4ec76820717ffe4af4da5da55d0c2a79eb3cb22f9e5dd0c29464658b9a553)
            check_type(argname="argument circle_shape", value=circle_shape, expected_type=type_hints["circle_shape"])
            check_type(argname="argument point_shape", value=point_shape, expected_type=type_hints["point_shape"])
            check_type(argname="argument polygon_shape", value=polygon_shape, expected_type=type_hints["polygon_shape"])
            check_type(argname="argument rectangle_shape", value=rectangle_shape, expected_type=type_hints["rectangle_shape"])
            check_type(argname="argument union_shape", value=union_shape, expected_type=type_hints["union_shape"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if circle_shape is not None:
            self._values["circle_shape"] = circle_shape
        if point_shape is not None:
            self._values["point_shape"] = point_shape
        if polygon_shape is not None:
            self._values["polygon_shape"] = polygon_shape
        if rectangle_shape is not None:
            self._values["rectangle_shape"] = rectangle_shape
        if union_shape is not None:
            self._values["union_shape"] = union_shape

    @builtins.property
    def circle_shape(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestCircleShape"]]]:
        '''circle_shape block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#circle_shape DataAkamaiImagingPolicyImage#circle_shape}
        '''
        result = self._values.get("circle_shape")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestCircleShape"]]], result)

    @builtins.property
    def point_shape(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestPointShape"]]]:
        '''point_shape block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#point_shape DataAkamaiImagingPolicyImage#point_shape}
        '''
        result = self._values.get("point_shape")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestPointShape"]]], result)

    @builtins.property
    def polygon_shape(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestPolygonShape"]]]:
        '''polygon_shape block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#polygon_shape DataAkamaiImagingPolicyImage#polygon_shape}
        '''
        result = self._values.get("polygon_shape")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestPolygonShape"]]], result)

    @builtins.property
    def rectangle_shape(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestRectangleShape"]]]:
        '''rectangle_shape block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rectangle_shape DataAkamaiImagingPolicyImage#rectangle_shape}
        '''
        result = self._values.get("rectangle_shape")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestRectangleShape"]]], result)

    @builtins.property
    def union_shape(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestUnionShape"]]]:
        '''union_shape block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#union_shape DataAkamaiImagingPolicyImage#union_shape}
        '''
        result = self._values.get("union_shape")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestUnionShape"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterest(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestCircleShape",
    jsii_struct_bases=[],
    name_mapping={"center": "center", "radius": "radius", "radius_var": "radiusVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestCircleShape:
    def __init__(
        self,
        *,
        center: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestCircleShapeCenter", typing.Dict[builtins.str, typing.Any]],
        radius: typing.Optional[builtins.str] = None,
        radius_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param center: center block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#center DataAkamaiImagingPolicyImage#center}
        :param radius: The radius of the circle measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#radius DataAkamaiImagingPolicyImage#radius}
        :param radius_var: The radius of the circle measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#radius_var DataAkamaiImagingPolicyImage#radius_var}
        '''
        if isinstance(center, dict):
            center = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestCircleShapeCenter(**center)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__85ba6885d2e2f0efb4c2965b568e3448cd40816184bc953af8aa403741a31bbb)
            check_type(argname="argument center", value=center, expected_type=type_hints["center"])
            check_type(argname="argument radius", value=radius, expected_type=type_hints["radius"])
            check_type(argname="argument radius_var", value=radius_var, expected_type=type_hints["radius_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "center": center,
        }
        if radius is not None:
            self._values["radius"] = radius
        if radius_var is not None:
            self._values["radius_var"] = radius_var

    @builtins.property
    def center(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestCircleShapeCenter":
        '''center block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#center DataAkamaiImagingPolicyImage#center}
        '''
        result = self._values.get("center")
        assert result is not None, "Required property 'center' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestCircleShapeCenter", result)

    @builtins.property
    def radius(self) -> typing.Optional[builtins.str]:
        '''The radius of the circle measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#radius DataAkamaiImagingPolicyImage#radius}
        '''
        result = self._values.get("radius")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def radius_var(self) -> typing.Optional[builtins.str]:
        '''The radius of the circle measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#radius_var DataAkamaiImagingPolicyImage#radius_var}
        '''
        result = self._values.get("radius_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestCircleShape(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestCircleShapeCenter",
    jsii_struct_bases=[],
    name_mapping={"x": "x", "x_var": "xVar", "y": "y", "y_var": "yVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestCircleShapeCenter:
    def __init__(
        self,
        *,
        x: typing.Optional[builtins.str] = None,
        x_var: typing.Optional[builtins.str] = None,
        y: typing.Optional[builtins.str] = None,
        y_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param x: The horizontal position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x DataAkamaiImagingPolicyImage#x}
        :param x_var: The horizontal position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_var DataAkamaiImagingPolicyImage#x_var}
        :param y: The vertical position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y DataAkamaiImagingPolicyImage#y}
        :param y_var: The vertical position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_var DataAkamaiImagingPolicyImage#y_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f0059a4f9153870b0eb0c331bc77c623d2c9d1635f923ed6ece9a432c118875)
            check_type(argname="argument x", value=x, expected_type=type_hints["x"])
            check_type(argname="argument x_var", value=x_var, expected_type=type_hints["x_var"])
            check_type(argname="argument y", value=y, expected_type=type_hints["y"])
            check_type(argname="argument y_var", value=y_var, expected_type=type_hints["y_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if x is not None:
            self._values["x"] = x
        if x_var is not None:
            self._values["x_var"] = x_var
        if y is not None:
            self._values["y"] = y
        if y_var is not None:
            self._values["y_var"] = y_var

    @builtins.property
    def x(self) -> typing.Optional[builtins.str]:
        '''The horizontal position of the point, measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x DataAkamaiImagingPolicyImage#x}
        '''
        result = self._values.get("x")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_var(self) -> typing.Optional[builtins.str]:
        '''The horizontal position of the point, measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_var DataAkamaiImagingPolicyImage#x_var}
        '''
        result = self._values.get("x_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y(self) -> typing.Optional[builtins.str]:
        '''The vertical position of the point, measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y DataAkamaiImagingPolicyImage#y}
        '''
        result = self._values.get("y")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_var(self) -> typing.Optional[builtins.str]:
        '''The vertical position of the point, measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_var DataAkamaiImagingPolicyImage#y_var}
        '''
        result = self._values.get("y_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestCircleShapeCenter(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestCircleShapeCenterOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestCircleShapeCenterOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5af15633527a17ed6b751f81f0107815ec461e72e370ae14e2d0fbbdc2fc4fe2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetX")
    def reset_x(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetX", []))

    @jsii.member(jsii_name="resetXVar")
    def reset_x_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXVar", []))

    @jsii.member(jsii_name="resetY")
    def reset_y(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetY", []))

    @jsii.member(jsii_name="resetYVar")
    def reset_y_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYVar", []))

    @builtins.property
    @jsii.member(jsii_name="xInput")
    def x_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xInput"))

    @builtins.property
    @jsii.member(jsii_name="xVarInput")
    def x_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yInput")
    def y_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yInput"))

    @builtins.property
    @jsii.member(jsii_name="yVarInput")
    def y_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yVarInput"))

    @builtins.property
    @jsii.member(jsii_name="x")
    def x(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "x"))

    @x.setter
    def x(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__91dbc07a42bc441255ca19367172653d17df61f06765a576fdd81668b243acac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "x", value)

    @builtins.property
    @jsii.member(jsii_name="xVar")
    def x_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xVar"))

    @x_var.setter
    def x_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__93299e24b532bf3c570f85057f71e2c0a81bd0d1f60f238c2d9e14ad601faa07)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xVar", value)

    @builtins.property
    @jsii.member(jsii_name="y")
    def y(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "y"))

    @y.setter
    def y(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__20a22e19857409acdffd7245ec440646be730c1cfcfc6d1ba84a1d814892d56e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "y", value)

    @builtins.property
    @jsii.member(jsii_name="yVar")
    def y_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yVar"))

    @y_var.setter
    def y_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c20325253333ca9e1347738feae8740170d8571a3405382b2995e43f5c353ed2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestCircleShapeCenter]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestCircleShapeCenter], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestCircleShapeCenter],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6b5f05346c879aae12034aea15dd1dfb15a29cea265d92649554040deb1c8f1b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestCircleShapeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestCircleShapeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__886ba98911df00a6d282fdcaa1973e9fd037b7d347eabe6d6ed43422a2d04626)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestCircleShapeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1fec2a30b481a6577d217d5aa09e32cf5a8dbed6d86d795bc54d338d39dad682)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestCircleShapeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a768d7519253af2aae19d291f3a49ce7c7bee908fed728545ed373f6f325da8b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d763b1fef952b509259d17510b314911b194ad2d981870b6bb66f3aecd80140c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__87e57985a764472656967a664d74fc58edc4fbbd53a850cb43491fd5846639c2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestCircleShape]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestCircleShape]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestCircleShape]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f55687b06ae2bd1dcab22022f451ad9d5ce6db51e2ea2e1bd4254ea64e031c5e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestCircleShapeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestCircleShapeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c910112eb4983b7e18a784c6124e51004c6f0a54dac01e26e63089b3cf82467c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putCenter")
    def put_center(
        self,
        *,
        x: typing.Optional[builtins.str] = None,
        x_var: typing.Optional[builtins.str] = None,
        y: typing.Optional[builtins.str] = None,
        y_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param x: The horizontal position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x DataAkamaiImagingPolicyImage#x}
        :param x_var: The horizontal position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_var DataAkamaiImagingPolicyImage#x_var}
        :param y: The vertical position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y DataAkamaiImagingPolicyImage#y}
        :param y_var: The vertical position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_var DataAkamaiImagingPolicyImage#y_var}
        '''
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestCircleShapeCenter(
            x=x, x_var=x_var, y=y, y_var=y_var
        )

        return typing.cast(None, jsii.invoke(self, "putCenter", [value]))

    @jsii.member(jsii_name="resetRadius")
    def reset_radius(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRadius", []))

    @jsii.member(jsii_name="resetRadiusVar")
    def reset_radius_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRadiusVar", []))

    @builtins.property
    @jsii.member(jsii_name="center")
    def center(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestCircleShapeCenterOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestCircleShapeCenterOutputReference, jsii.get(self, "center"))

    @builtins.property
    @jsii.member(jsii_name="centerInput")
    def center_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestCircleShapeCenter]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestCircleShapeCenter], jsii.get(self, "centerInput"))

    @builtins.property
    @jsii.member(jsii_name="radiusInput")
    def radius_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "radiusInput"))

    @builtins.property
    @jsii.member(jsii_name="radiusVarInput")
    def radius_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "radiusVarInput"))

    @builtins.property
    @jsii.member(jsii_name="radius")
    def radius(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "radius"))

    @radius.setter
    def radius(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4de3b4f0f3bc06f946f11f9924d952bb270bc8c1794d2d472f53da585b25b029)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "radius", value)

    @builtins.property
    @jsii.member(jsii_name="radiusVar")
    def radius_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "radiusVar"))

    @radius_var.setter
    def radius_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ad5aa707826ca4fa623ec21ba442e97d7e491554e5180212a3eb78344e533b2f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "radiusVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestCircleShape]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestCircleShape]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestCircleShape]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7723c278dbee09fea6499d434dd83834238cb798c5998c70869b93dbc9237038)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cc5c53bda7935108e1a5eea6a4dff3ab76f3db6458e256d8d703d9bceeb9c685)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putCircleShape")
    def put_circle_shape(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestCircleShape, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__12c2af2a3a8b8fba718a99808247c6adfbeab23c2266c71cad3f83bac25d4633)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCircleShape", [value]))

    @jsii.member(jsii_name="putPointShape")
    def put_point_shape(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestPointShape", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__43e4781b28bb863c47e577baf77e11c4fe14e5ed53cc2da54cd3c49c7988416e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putPointShape", [value]))

    @jsii.member(jsii_name="putPolygonShape")
    def put_polygon_shape(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestPolygonShape", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__201a416d1dbbc87da8571d95423a3dbef1045496600d4837049f9bea2380793a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putPolygonShape", [value]))

    @jsii.member(jsii_name="putRectangleShape")
    def put_rectangle_shape(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestRectangleShape", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a1ef3c981979a2ec9765435c220250abf211fcc82fd48f06fbb7b871d7bef93)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRectangleShape", [value]))

    @jsii.member(jsii_name="putUnionShape")
    def put_union_shape(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestUnionShape", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__14cd1568f91264a66eb8cb51062d4f48044e78a4cf98da01f341add56dc45c88)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putUnionShape", [value]))

    @jsii.member(jsii_name="resetCircleShape")
    def reset_circle_shape(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCircleShape", []))

    @jsii.member(jsii_name="resetPointShape")
    def reset_point_shape(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPointShape", []))

    @jsii.member(jsii_name="resetPolygonShape")
    def reset_polygon_shape(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPolygonShape", []))

    @jsii.member(jsii_name="resetRectangleShape")
    def reset_rectangle_shape(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRectangleShape", []))

    @jsii.member(jsii_name="resetUnionShape")
    def reset_union_shape(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUnionShape", []))

    @builtins.property
    @jsii.member(jsii_name="circleShape")
    def circle_shape(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestCircleShapeList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestCircleShapeList, jsii.get(self, "circleShape"))

    @builtins.property
    @jsii.member(jsii_name="pointShape")
    def point_shape(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestPointShapeList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestPointShapeList", jsii.get(self, "pointShape"))

    @builtins.property
    @jsii.member(jsii_name="polygonShape")
    def polygon_shape(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestPolygonShapeList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestPolygonShapeList", jsii.get(self, "polygonShape"))

    @builtins.property
    @jsii.member(jsii_name="rectangleShape")
    def rectangle_shape(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestRectangleShapeList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestRectangleShapeList", jsii.get(self, "rectangleShape"))

    @builtins.property
    @jsii.member(jsii_name="unionShape")
    def union_shape(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestUnionShapeList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestUnionShapeList", jsii.get(self, "unionShape"))

    @builtins.property
    @jsii.member(jsii_name="circleShapeInput")
    def circle_shape_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestCircleShape]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestCircleShape]]], jsii.get(self, "circleShapeInput"))

    @builtins.property
    @jsii.member(jsii_name="pointShapeInput")
    def point_shape_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestPointShape"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestPointShape"]]], jsii.get(self, "pointShapeInput"))

    @builtins.property
    @jsii.member(jsii_name="polygonShapeInput")
    def polygon_shape_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestPolygonShape"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestPolygonShape"]]], jsii.get(self, "polygonShapeInput"))

    @builtins.property
    @jsii.member(jsii_name="rectangleShapeInput")
    def rectangle_shape_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestRectangleShape"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestRectangleShape"]]], jsii.get(self, "rectangleShapeInput"))

    @builtins.property
    @jsii.member(jsii_name="unionShapeInput")
    def union_shape_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestUnionShape"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestUnionShape"]]], jsii.get(self, "unionShapeInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterest]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterest], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterest],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e1f7bd42ec3bf11dfe112206bebb5815abd14ca3811f3d3da22f57fb3b0d973)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestPointShape",
    jsii_struct_bases=[],
    name_mapping={"x": "x", "x_var": "xVar", "y": "y", "y_var": "yVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestPointShape:
    def __init__(
        self,
        *,
        x: typing.Optional[builtins.str] = None,
        x_var: typing.Optional[builtins.str] = None,
        y: typing.Optional[builtins.str] = None,
        y_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param x: The horizontal position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x DataAkamaiImagingPolicyImage#x}
        :param x_var: The horizontal position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_var DataAkamaiImagingPolicyImage#x_var}
        :param y: The vertical position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y DataAkamaiImagingPolicyImage#y}
        :param y_var: The vertical position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_var DataAkamaiImagingPolicyImage#y_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e84abcf42c4516b37de0ae636ea15393d5890b9fef629a3d03743e409b734666)
            check_type(argname="argument x", value=x, expected_type=type_hints["x"])
            check_type(argname="argument x_var", value=x_var, expected_type=type_hints["x_var"])
            check_type(argname="argument y", value=y, expected_type=type_hints["y"])
            check_type(argname="argument y_var", value=y_var, expected_type=type_hints["y_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if x is not None:
            self._values["x"] = x
        if x_var is not None:
            self._values["x_var"] = x_var
        if y is not None:
            self._values["y"] = y
        if y_var is not None:
            self._values["y_var"] = y_var

    @builtins.property
    def x(self) -> typing.Optional[builtins.str]:
        '''The horizontal position of the point, measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x DataAkamaiImagingPolicyImage#x}
        '''
        result = self._values.get("x")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_var(self) -> typing.Optional[builtins.str]:
        '''The horizontal position of the point, measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_var DataAkamaiImagingPolicyImage#x_var}
        '''
        result = self._values.get("x_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y(self) -> typing.Optional[builtins.str]:
        '''The vertical position of the point, measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y DataAkamaiImagingPolicyImage#y}
        '''
        result = self._values.get("y")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_var(self) -> typing.Optional[builtins.str]:
        '''The vertical position of the point, measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_var DataAkamaiImagingPolicyImage#y_var}
        '''
        result = self._values.get("y_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestPointShape(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestPointShapeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestPointShapeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__549de011571865e3bd0a1a29594830cbac98ae42b5c5159816b00ed4a47575b2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestPointShapeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__14163d5fafb01767cf2349de8aa435d881617be9af2fe173decb8e9fd18e29cb)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestPointShapeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__696f37dc0d111a7e9761dafba4d13ed589558d031920ed6ae70bbbaf8ca2a304)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__53a58f5a15e4ac49ed70f341d7e798a0ea316a785d6218998bd172d3e711cea0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9fdf307520c6558621ee817ab246e0b47762d925996bf7781fc7991c3abee510)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestPointShape]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestPointShape]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestPointShape]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__32e4fe207367b83aec9c24dd48a6066a9a7c89bbb1a35a9b47c2f465adbb8633)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestPointShapeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestPointShapeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__19c7de7967e465e59f3ec1c78fa07448c475802297e3a2af41127501ccc31a46)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetX")
    def reset_x(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetX", []))

    @jsii.member(jsii_name="resetXVar")
    def reset_x_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXVar", []))

    @jsii.member(jsii_name="resetY")
    def reset_y(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetY", []))

    @jsii.member(jsii_name="resetYVar")
    def reset_y_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYVar", []))

    @builtins.property
    @jsii.member(jsii_name="xInput")
    def x_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xInput"))

    @builtins.property
    @jsii.member(jsii_name="xVarInput")
    def x_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yInput")
    def y_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yInput"))

    @builtins.property
    @jsii.member(jsii_name="yVarInput")
    def y_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yVarInput"))

    @builtins.property
    @jsii.member(jsii_name="x")
    def x(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "x"))

    @x.setter
    def x(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__78cf7808fa43f16010e978412db70db2c36f8a1242872e606b47f5ab7621a94c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "x", value)

    @builtins.property
    @jsii.member(jsii_name="xVar")
    def x_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xVar"))

    @x_var.setter
    def x_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9e42928bfac9bd89008b7d54704f86bf5814c89d271802691f95cdd46d7cf38b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xVar", value)

    @builtins.property
    @jsii.member(jsii_name="y")
    def y(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "y"))

    @y.setter
    def y(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7223f182e02f4f79222b536da87cb5018ab0a96cead6f3b654a7e62749774909)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "y", value)

    @builtins.property
    @jsii.member(jsii_name="yVar")
    def y_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yVar"))

    @y_var.setter
    def y_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e0d2e46ebc59a5cd263b01a7499f6fbb2e90710ee8bb7ed103c48e04dd4539b0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestPointShape]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestPointShape]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestPointShape]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a63c70345e772ca5983181ef27cc6d1761853904261036f5beaf3beb0d6df97)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestPolygonShape",
    jsii_struct_bases=[],
    name_mapping={"points": "points"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestPolygonShape:
    def __init__(
        self,
        *,
        points: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestPolygonShapePoints", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param points: points block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#points DataAkamaiImagingPolicyImage#points}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cc50df8eaaa3a6cba41b3f1d856be793b3b51fa982f71ea6a6d50207ac54db87)
            check_type(argname="argument points", value=points, expected_type=type_hints["points"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "points": points,
        }

    @builtins.property
    def points(
        self,
    ) -> typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestPolygonShapePoints"]]:
        '''points block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#points DataAkamaiImagingPolicyImage#points}
        '''
        result = self._values.get("points")
        assert result is not None, "Required property 'points' is missing"
        return typing.cast(typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestPolygonShapePoints"]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestPolygonShape(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestPolygonShapeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestPolygonShapeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d2bd7adf741202f464bab3d16cc88613ebbe80f796d78884d01877e325ddf08)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestPolygonShapeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__186583e35038528cda993ed103099a71a1188d824fb1568fb9b647b8d5ce3705)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestPolygonShapeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ddc7336938700cea7f877c983d775142bed5303106e2b117668d51bbf9a87b84)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5701bfcad8517674e3da6275042e944739f133d438d4f0eb1a19be6ea2ffe6de)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8c024ba803946c7975f4a04283063e937c2ef837fc0c72e6a814337386f89f04)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestPolygonShape]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestPolygonShape]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestPolygonShape]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a1dfdf78ab8642952bb7d364ace03d97da9d05bbf2935e1452bbd90a8f339cb0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestPolygonShapeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestPolygonShapeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f27bb3d8298eb69f65e8575730e443a485e287efe6e5b509743d0c2bd2d9b93)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putPoints")
    def put_points(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestPolygonShapePoints", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1b09bdc9c3498d390baea2e7ad3a9531faec038113c54c036945bc4a42c10e2d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putPoints", [value]))

    @builtins.property
    @jsii.member(jsii_name="points")
    def points(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestPolygonShapePointsList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestPolygonShapePointsList", jsii.get(self, "points"))

    @builtins.property
    @jsii.member(jsii_name="pointsInput")
    def points_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestPolygonShapePoints"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestPolygonShapePoints"]]], jsii.get(self, "pointsInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestPolygonShape]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestPolygonShape]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestPolygonShape]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__12f2c1cec8d4619ccef4c4b47455edce6d4f38f1838cbccdc29742684ff90014)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestPolygonShapePoints",
    jsii_struct_bases=[],
    name_mapping={"x": "x", "x_var": "xVar", "y": "y", "y_var": "yVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestPolygonShapePoints:
    def __init__(
        self,
        *,
        x: typing.Optional[builtins.str] = None,
        x_var: typing.Optional[builtins.str] = None,
        y: typing.Optional[builtins.str] = None,
        y_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param x: The horizontal position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x DataAkamaiImagingPolicyImage#x}
        :param x_var: The horizontal position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_var DataAkamaiImagingPolicyImage#x_var}
        :param y: The vertical position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y DataAkamaiImagingPolicyImage#y}
        :param y_var: The vertical position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_var DataAkamaiImagingPolicyImage#y_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d4bfe29b5741c721e50095afd5f37008d330c9525d4f6445f5fe9d44f8b72b5)
            check_type(argname="argument x", value=x, expected_type=type_hints["x"])
            check_type(argname="argument x_var", value=x_var, expected_type=type_hints["x_var"])
            check_type(argname="argument y", value=y, expected_type=type_hints["y"])
            check_type(argname="argument y_var", value=y_var, expected_type=type_hints["y_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if x is not None:
            self._values["x"] = x
        if x_var is not None:
            self._values["x_var"] = x_var
        if y is not None:
            self._values["y"] = y
        if y_var is not None:
            self._values["y_var"] = y_var

    @builtins.property
    def x(self) -> typing.Optional[builtins.str]:
        '''The horizontal position of the point, measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x DataAkamaiImagingPolicyImage#x}
        '''
        result = self._values.get("x")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_var(self) -> typing.Optional[builtins.str]:
        '''The horizontal position of the point, measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_var DataAkamaiImagingPolicyImage#x_var}
        '''
        result = self._values.get("x_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y(self) -> typing.Optional[builtins.str]:
        '''The vertical position of the point, measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y DataAkamaiImagingPolicyImage#y}
        '''
        result = self._values.get("y")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_var(self) -> typing.Optional[builtins.str]:
        '''The vertical position of the point, measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_var DataAkamaiImagingPolicyImage#y_var}
        '''
        result = self._values.get("y_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestPolygonShapePoints(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestPolygonShapePointsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestPolygonShapePointsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7fc042ae3110c4db15bcc8ba9144a05b824987cffcc79a7a031988a80b41b8b4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestPolygonShapePointsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__22087838c73303908e1045fff0897713c929f843f625cb8e48f09b2fd38d0ffc)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestPolygonShapePointsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e026c99ea41ea9e562e26e29959b71ec1ffb7eaa98d46dd9f700cbca8535019c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2c205b61d92fbeab5019711bcb6afd9378320653dbb74a80dad97e00d4200483)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__284e9fffa3a696f968cae12bd6ebda088ce90df74696924f162b83d27df1b538)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestPolygonShapePoints]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestPolygonShapePoints]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestPolygonShapePoints]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7185b66f563b0d43fe385e9480dae1a4a7ceb2c542e804911365c1f770073a8e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestPolygonShapePointsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestPolygonShapePointsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dbda4eafdcaf70fddd108e26fe3fcfa7185d044821d02e8d8a0cfbb359209759)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetX")
    def reset_x(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetX", []))

    @jsii.member(jsii_name="resetXVar")
    def reset_x_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXVar", []))

    @jsii.member(jsii_name="resetY")
    def reset_y(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetY", []))

    @jsii.member(jsii_name="resetYVar")
    def reset_y_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYVar", []))

    @builtins.property
    @jsii.member(jsii_name="xInput")
    def x_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xInput"))

    @builtins.property
    @jsii.member(jsii_name="xVarInput")
    def x_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yInput")
    def y_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yInput"))

    @builtins.property
    @jsii.member(jsii_name="yVarInput")
    def y_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yVarInput"))

    @builtins.property
    @jsii.member(jsii_name="x")
    def x(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "x"))

    @x.setter
    def x(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c97661d93340f88426a2dcc69641fbb633d381cd2161a2e372ce88e6fdfb8971)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "x", value)

    @builtins.property
    @jsii.member(jsii_name="xVar")
    def x_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xVar"))

    @x_var.setter
    def x_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b1f7a6efe8beea8718d23c8c4f8a8260e4987b88a04a3c0f400e8775907baf4e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xVar", value)

    @builtins.property
    @jsii.member(jsii_name="y")
    def y(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "y"))

    @y.setter
    def y(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ac346083cdef474e5d4c24bea1311454c84e291f4458cf7af7399bb17d69050)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "y", value)

    @builtins.property
    @jsii.member(jsii_name="yVar")
    def y_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yVar"))

    @y_var.setter
    def y_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b29f0982bee7a7ca336c321b40059c782f028e0b9aed7b82b431cd7492022d88)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestPolygonShapePoints]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestPolygonShapePoints]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestPolygonShapePoints]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7303a7fc74fba538b6893c16891a7d1894d8e1b4ead70ba157618d86c228312e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestRectangleShape",
    jsii_struct_bases=[],
    name_mapping={
        "anchor": "anchor",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestRectangleShape:
    def __init__(
        self,
        *,
        anchor: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestRectangleShapeAnchor", typing.Dict[builtins.str, typing.Any]],
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param anchor: anchor block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#anchor DataAkamaiImagingPolicyImage#anchor}
        :param height: Extends the rectangle down from the ``anchor`` point. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: Extends the rectangle down from the ``anchor`` point. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: Extends the rectangle right from the ``anchor`` point. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: Extends the rectangle right from the ``anchor`` point. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(anchor, dict):
            anchor = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestRectangleShapeAnchor(**anchor)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ed82a5a32906b12d9da8118c9dda2a9c713ed038a2232ed79407d3eb82462cd5)
            check_type(argname="argument anchor", value=anchor, expected_type=type_hints["anchor"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "anchor": anchor,
        }
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def anchor(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestRectangleShapeAnchor":
        '''anchor block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#anchor DataAkamaiImagingPolicyImage#anchor}
        '''
        result = self._values.get("anchor")
        assert result is not None, "Required property 'anchor' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestRectangleShapeAnchor", result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''Extends the rectangle down from the ``anchor`` point.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''Extends the rectangle down from the ``anchor`` point.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''Extends the rectangle right from the ``anchor`` point.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''Extends the rectangle right from the ``anchor`` point.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestRectangleShape(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestRectangleShapeAnchor",
    jsii_struct_bases=[],
    name_mapping={"x": "x", "x_var": "xVar", "y": "y", "y_var": "yVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestRectangleShapeAnchor:
    def __init__(
        self,
        *,
        x: typing.Optional[builtins.str] = None,
        x_var: typing.Optional[builtins.str] = None,
        y: typing.Optional[builtins.str] = None,
        y_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param x: The horizontal position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x DataAkamaiImagingPolicyImage#x}
        :param x_var: The horizontal position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_var DataAkamaiImagingPolicyImage#x_var}
        :param y: The vertical position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y DataAkamaiImagingPolicyImage#y}
        :param y_var: The vertical position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_var DataAkamaiImagingPolicyImage#y_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__50c139b7b02008ebefb62815b0daa0457012edc5b3ae755c11b324e462d9c134)
            check_type(argname="argument x", value=x, expected_type=type_hints["x"])
            check_type(argname="argument x_var", value=x_var, expected_type=type_hints["x_var"])
            check_type(argname="argument y", value=y, expected_type=type_hints["y"])
            check_type(argname="argument y_var", value=y_var, expected_type=type_hints["y_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if x is not None:
            self._values["x"] = x
        if x_var is not None:
            self._values["x_var"] = x_var
        if y is not None:
            self._values["y"] = y
        if y_var is not None:
            self._values["y_var"] = y_var

    @builtins.property
    def x(self) -> typing.Optional[builtins.str]:
        '''The horizontal position of the point, measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x DataAkamaiImagingPolicyImage#x}
        '''
        result = self._values.get("x")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_var(self) -> typing.Optional[builtins.str]:
        '''The horizontal position of the point, measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_var DataAkamaiImagingPolicyImage#x_var}
        '''
        result = self._values.get("x_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y(self) -> typing.Optional[builtins.str]:
        '''The vertical position of the point, measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y DataAkamaiImagingPolicyImage#y}
        '''
        result = self._values.get("y")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_var(self) -> typing.Optional[builtins.str]:
        '''The vertical position of the point, measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_var DataAkamaiImagingPolicyImage#y_var}
        '''
        result = self._values.get("y_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestRectangleShapeAnchor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestRectangleShapeAnchorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestRectangleShapeAnchorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__57f45cc6df0ff21984bfff9b92b0a11810ce06577c028fa794a29f2c4e8f58d8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetX")
    def reset_x(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetX", []))

    @jsii.member(jsii_name="resetXVar")
    def reset_x_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXVar", []))

    @jsii.member(jsii_name="resetY")
    def reset_y(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetY", []))

    @jsii.member(jsii_name="resetYVar")
    def reset_y_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYVar", []))

    @builtins.property
    @jsii.member(jsii_name="xInput")
    def x_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xInput"))

    @builtins.property
    @jsii.member(jsii_name="xVarInput")
    def x_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yInput")
    def y_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yInput"))

    @builtins.property
    @jsii.member(jsii_name="yVarInput")
    def y_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yVarInput"))

    @builtins.property
    @jsii.member(jsii_name="x")
    def x(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "x"))

    @x.setter
    def x(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__955de3fe5ba21c6127824c4bbf54f5b17e1a113065fb2021c5e33bb2ae8f16fe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "x", value)

    @builtins.property
    @jsii.member(jsii_name="xVar")
    def x_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xVar"))

    @x_var.setter
    def x_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__488f8301cca734fe0e6071272460d2e2e75a86eca89015c2b02e5dae5e0fe920)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xVar", value)

    @builtins.property
    @jsii.member(jsii_name="y")
    def y(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "y"))

    @y.setter
    def y(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9b653b4513983db032874bf21ca1cff330e0204e3543908827091ea7d81d04d3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "y", value)

    @builtins.property
    @jsii.member(jsii_name="yVar")
    def y_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yVar"))

    @y_var.setter
    def y_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c3f17c6ad8751ad0c519bf66af423dea3556868c744dffa29a404c84d0f44d44)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestRectangleShapeAnchor]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestRectangleShapeAnchor], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestRectangleShapeAnchor],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fb42c2632bba8f0a249a6e3dac01b24b9a31b5e211dd456a8c753cbeffda6a7f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestRectangleShapeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestRectangleShapeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3c610b2315fa961a948b7f815684466474914ddacd46c17eba3d856c68e2c677)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestRectangleShapeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f6959915349be75687e105bbe90afe60f28d740777bbe84165746eb54d3084ad)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestRectangleShapeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dda7b911aa29521893907abd3b95577ead2c4444bc77dccd61bacf8ac5c13ab7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1ed652e7c6e176a3e71ccd181122654b87ccf58e63e63ee12d6e40515b482601)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__560d3c53fdf1f9c70d7f5cf8d90d36ab2da390d7c357ae8e50e6392b52d4c83c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestRectangleShape]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestRectangleShape]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestRectangleShape]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f9e5e86ca09bf2c1912c0e956956a12f378f4b5c5df70183a0fa4daca8d6feda)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestRectangleShapeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestRectangleShapeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__00aee23e6744af412ea917852bcd14955185bd4a125f54df2723542d1744eefe)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putAnchor")
    def put_anchor(
        self,
        *,
        x: typing.Optional[builtins.str] = None,
        x_var: typing.Optional[builtins.str] = None,
        y: typing.Optional[builtins.str] = None,
        y_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param x: The horizontal position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x DataAkamaiImagingPolicyImage#x}
        :param x_var: The horizontal position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_var DataAkamaiImagingPolicyImage#x_var}
        :param y: The vertical position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y DataAkamaiImagingPolicyImage#y}
        :param y_var: The vertical position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_var DataAkamaiImagingPolicyImage#y_var}
        '''
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestRectangleShapeAnchor(
            x=x, x_var=x_var, y=y, y_var=y_var
        )

        return typing.cast(None, jsii.invoke(self, "putAnchor", [value]))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="anchor")
    def anchor(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestRectangleShapeAnchorOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestRectangleShapeAnchorOutputReference, jsii.get(self, "anchor"))

    @builtins.property
    @jsii.member(jsii_name="anchorInput")
    def anchor_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestRectangleShapeAnchor]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestRectangleShapeAnchor], jsii.get(self, "anchorInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6eaa95c5ca6cef31f0e003818ea31eac55011cb24addbd4eb87af8c1ef69c5a6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aaa9f4250c8e67dbf694dda220705ae1ed7b9f71cee1fee1e5b3925d84bcc662)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b27c077b2ddb35acb8d18f29298877a1c14a38f211cd5a82536650f3e7d545b2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__24b61c8dd5715d1c6d5e4ec15ae0ebd205b2d9d54147ce5a3eb5c9f42bae4767)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestRectangleShape]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestRectangleShape]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestRectangleShape]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2b0d09c4ca918c5a92e10cca17d825f37657cb2fde2693271c81dd92cfe9a35e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestUnionShape",
    jsii_struct_bases=[],
    name_mapping={"shapes": "shapes"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestUnionShape:
    def __init__(
        self,
        *,
        shapes: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestUnionShapeShapes", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param shapes: shapes block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shapes DataAkamaiImagingPolicyImage#shapes}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__edb1d775c102f48932cf497b2aa581bfaa70bbdcb7e731ff137d7b5430dcc3bc)
            check_type(argname="argument shapes", value=shapes, expected_type=type_hints["shapes"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "shapes": shapes,
        }

    @builtins.property
    def shapes(
        self,
    ) -> typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestUnionShapeShapes"]]:
        '''shapes block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shapes DataAkamaiImagingPolicyImage#shapes}
        '''
        result = self._values.get("shapes")
        assert result is not None, "Required property 'shapes' is missing"
        return typing.cast(typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestUnionShapeShapes"]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestUnionShape(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestUnionShapeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestUnionShapeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0970208e9feafb9427ba1d79a2870e86ea9de3dcdbc8971bee4083ede764ca3d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestUnionShapeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__621da87c837936ddf0ba02afdd5a6c75570a7b3733783d2d289459e8376ddea6)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestUnionShapeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1c64e0b3f98835e452f483de0fd92f166533db02f2ab147bff4e663b5efdaa50)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__25d3b741108e88f8e200758347c7297b1e1bda78fa03e1cee877a2bbe7666ed2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__04cfc72f580098b1923af2f95262afdc5a67116adaef15fa293afa212a9a2f9f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestUnionShape]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestUnionShape]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestUnionShape]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d1dfbd7cef41135b3495580550ac9b64d1fc1d99256b9c102528348aa1615f98)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestUnionShapeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestUnionShapeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__885b088ad086f4c37ec92a8cfe54b8fb99fee01279f77564d1e8e66545a79aba)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putShapes")
    def put_shapes(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestUnionShapeShapes", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3e3af11533d522233203a797d14da44c979f09c91f317a796655126b123e53b8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putShapes", [value]))

    @builtins.property
    @jsii.member(jsii_name="shapes")
    def shapes(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestUnionShapeShapesList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestUnionShapeShapesList", jsii.get(self, "shapes"))

    @builtins.property
    @jsii.member(jsii_name="shapesInput")
    def shapes_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestUnionShapeShapes"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestUnionShapeShapes"]]], jsii.get(self, "shapesInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestUnionShape]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestUnionShape]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestUnionShape]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c5c3abf02a1808b6770320b93391c10a5737e45de6776fa2e38c50150690a51f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestUnionShapeShapes",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestUnionShapeShapes:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestUnionShapeShapes(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestUnionShapeShapesList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestUnionShapeShapesList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ad1465595de7be85c1c937c59cae3403b8a5052859a8380b70462d931ff9d0e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestUnionShapeShapesOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__555e26cc0c85fd3131176482504d7eaee4fdebdd6048a7f004063d22dd50f137)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestUnionShapeShapesOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__03c99ff04f940fd268355d5cb960def9e86430dd697a846a9fee03116578f640)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__854f8f8bf472619fd91561ced49784d0539980392e5fde1b5d25ee8d7291d9ae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f08d4d60faa896bad9754e36a9cfa957ecdad42a94cd7e894d586b58c28abfdd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestUnionShapeShapes]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestUnionShapeShapes]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestUnionShapeShapes]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__70b4720a6f047ef8a0e8d3063abad59e933198bccb6d4f5060c9a3c22020ff7a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestUnionShapeShapesOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestUnionShapeShapesOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__135d13f15e991bf35a0d2d5268f68d1c1ca27a68aeac0410d9d761f4b76b984a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestUnionShapeShapes]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestUnionShapeShapes]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestUnionShapeShapes]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6260ca7a61c8b05b86bd0be9762c9f1fb915e4f9dec6a2c333e52da3d4bb8f93)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRelativeCrop",
    jsii_struct_bases=[],
    name_mapping={
        "east": "east",
        "east_var": "eastVar",
        "north": "north",
        "north_var": "northVar",
        "south": "south",
        "south_var": "southVar",
        "west": "west",
        "west_var": "westVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRelativeCrop:
    def __init__(
        self,
        *,
        east: typing.Optional[builtins.str] = None,
        east_var: typing.Optional[builtins.str] = None,
        north: typing.Optional[builtins.str] = None,
        north_var: typing.Optional[builtins.str] = None,
        south: typing.Optional[builtins.str] = None,
        south_var: typing.Optional[builtins.str] = None,
        west: typing.Optional[builtins.str] = None,
        west_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param east: The number of pixels to shrink or expand the right side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east DataAkamaiImagingPolicyImage#east}
        :param east_var: The number of pixels to shrink or expand the right side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east_var DataAkamaiImagingPolicyImage#east_var}
        :param north: The number of pixels to shrink or expand the top side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north DataAkamaiImagingPolicyImage#north}
        :param north_var: The number of pixels to shrink or expand the top side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north_var DataAkamaiImagingPolicyImage#north_var}
        :param south: The number of pixels to shrink or expand the bottom side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south DataAkamaiImagingPolicyImage#south}
        :param south_var: The number of pixels to shrink or expand the bottom side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south_var DataAkamaiImagingPolicyImage#south_var}
        :param west: The number of pixels to shrink or expand the left side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west DataAkamaiImagingPolicyImage#west}
        :param west_var: The number of pixels to shrink or expand the left side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west_var DataAkamaiImagingPolicyImage#west_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fabd5d34460cc3e24e39a74423725b3dcf26b12c08fee16b8f91f0dc027114d4)
            check_type(argname="argument east", value=east, expected_type=type_hints["east"])
            check_type(argname="argument east_var", value=east_var, expected_type=type_hints["east_var"])
            check_type(argname="argument north", value=north, expected_type=type_hints["north"])
            check_type(argname="argument north_var", value=north_var, expected_type=type_hints["north_var"])
            check_type(argname="argument south", value=south, expected_type=type_hints["south"])
            check_type(argname="argument south_var", value=south_var, expected_type=type_hints["south_var"])
            check_type(argname="argument west", value=west, expected_type=type_hints["west"])
            check_type(argname="argument west_var", value=west_var, expected_type=type_hints["west_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if east is not None:
            self._values["east"] = east
        if east_var is not None:
            self._values["east_var"] = east_var
        if north is not None:
            self._values["north"] = north
        if north_var is not None:
            self._values["north_var"] = north_var
        if south is not None:
            self._values["south"] = south
        if south_var is not None:
            self._values["south_var"] = south_var
        if west is not None:
            self._values["west"] = west
        if west_var is not None:
            self._values["west_var"] = west_var

    @builtins.property
    def east(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the right side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east DataAkamaiImagingPolicyImage#east}
        '''
        result = self._values.get("east")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def east_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the right side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east_var DataAkamaiImagingPolicyImage#east_var}
        '''
        result = self._values.get("east_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def north(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the top side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north DataAkamaiImagingPolicyImage#north}
        '''
        result = self._values.get("north")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def north_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the top side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north_var DataAkamaiImagingPolicyImage#north_var}
        '''
        result = self._values.get("north_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def south(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the bottom side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south DataAkamaiImagingPolicyImage#south}
        '''
        result = self._values.get("south")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def south_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the bottom side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south_var DataAkamaiImagingPolicyImage#south_var}
        '''
        result = self._values.get("south_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def west(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the left side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west DataAkamaiImagingPolicyImage#west}
        '''
        result = self._values.get("west")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def west_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the left side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west_var DataAkamaiImagingPolicyImage#west_var}
        '''
        result = self._values.get("west_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRelativeCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRelativeCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRelativeCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__74862048b1a9b251ac541b4e9fcd88c74d7300ce5be57eaaf4db814f4a593fd6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRelativeCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ca25dfa6cc8af3fbad183dd159623f7ab6725a4350e2bea7234aec014d6fbe61)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRelativeCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__928be2a6dce864e0b0d430bacc153314c13b5230d5fb89c0a1e08dc8a76f37cc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b628b4d0a191a0291cce7a52121bf32f9022a85628c0cfccbc4acc8724e280e8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bbfb0d5f1dec0d94bb1ced523f134deba82ebcb518c9d8b20ad949ee1b69832d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRelativeCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRelativeCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRelativeCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6fa705c7769912e3728c3387bc4a098ff081dfeaf465150f1df26d251b809e4e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRelativeCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRelativeCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e6f715aec2fdf6279bdd65fb6f9e9943713c6da7d2c45b975e9b9bb8c2b1fc3d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetEast")
    def reset_east(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEast", []))

    @jsii.member(jsii_name="resetEastVar")
    def reset_east_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEastVar", []))

    @jsii.member(jsii_name="resetNorth")
    def reset_north(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNorth", []))

    @jsii.member(jsii_name="resetNorthVar")
    def reset_north_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNorthVar", []))

    @jsii.member(jsii_name="resetSouth")
    def reset_south(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSouth", []))

    @jsii.member(jsii_name="resetSouthVar")
    def reset_south_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSouthVar", []))

    @jsii.member(jsii_name="resetWest")
    def reset_west(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWest", []))

    @jsii.member(jsii_name="resetWestVar")
    def reset_west_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWestVar", []))

    @builtins.property
    @jsii.member(jsii_name="eastInput")
    def east_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "eastInput"))

    @builtins.property
    @jsii.member(jsii_name="eastVarInput")
    def east_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "eastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="northInput")
    def north_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "northInput"))

    @builtins.property
    @jsii.member(jsii_name="northVarInput")
    def north_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "northVarInput"))

    @builtins.property
    @jsii.member(jsii_name="southInput")
    def south_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "southInput"))

    @builtins.property
    @jsii.member(jsii_name="southVarInput")
    def south_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "southVarInput"))

    @builtins.property
    @jsii.member(jsii_name="westInput")
    def west_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "westInput"))

    @builtins.property
    @jsii.member(jsii_name="westVarInput")
    def west_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "westVarInput"))

    @builtins.property
    @jsii.member(jsii_name="east")
    def east(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "east"))

    @east.setter
    def east(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__599a30dfd1de97256ea83a0c7181b558cd08e4bbdba2761e2582d4f04e7b23f1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "east", value)

    @builtins.property
    @jsii.member(jsii_name="eastVar")
    def east_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "eastVar"))

    @east_var.setter
    def east_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__773d1bcdc75534e6673a5969080b31eb1fdd05f0ab9991f3e83aa5527b50344e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "eastVar", value)

    @builtins.property
    @jsii.member(jsii_name="north")
    def north(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "north"))

    @north.setter
    def north(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4c5a095dee3ceedfb39832f78fe8005e5e4759553e7d12b9186fb682ff23aa9c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "north", value)

    @builtins.property
    @jsii.member(jsii_name="northVar")
    def north_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "northVar"))

    @north_var.setter
    def north_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9820cb5ba36ffb879c6870f74e00bd17f8e175d00b8a7b77884893de3b06e7ab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "northVar", value)

    @builtins.property
    @jsii.member(jsii_name="south")
    def south(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "south"))

    @south.setter
    def south(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__944f2a143926b2e7af42164380480a6e3f68fbdc38ad21a6bd11db767f8f487c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "south", value)

    @builtins.property
    @jsii.member(jsii_name="southVar")
    def south_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "southVar"))

    @south_var.setter
    def south_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__17a6e48d8f90f33eeab37df7c100e2d488606d211b46007ccbe2072ac741bd31)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "southVar", value)

    @builtins.property
    @jsii.member(jsii_name="west")
    def west(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "west"))

    @west.setter
    def west(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f47cf67da1c9e3b34959df3b678f9f7ffd5b19c49b269a9871bc1263737a8c70)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "west", value)

    @builtins.property
    @jsii.member(jsii_name="westVar")
    def west_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "westVar"))

    @west_var.setter
    def west_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d1d1d87d872e0f6d3fd4b1ac5131e9518f46b62c090a468ed54bfd50bde42a6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "westVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRelativeCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRelativeCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRelativeCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__90640298fdbf66e8e166022740079265bd138824adce501453c80d9a6588f084)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRemoveColor",
    jsii_struct_bases=[],
    name_mapping={
        "color": "color",
        "color_var": "colorVar",
        "feather": "feather",
        "feather_var": "featherVar",
        "tolerance": "tolerance",
        "tolerance_var": "toleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRemoveColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
        feather: typing.Optional[builtins.str] = None,
        feather_var: typing.Optional[builtins.str] = None,
        tolerance: typing.Optional[builtins.str] = None,
        tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        :param feather: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        :param feather_var: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        :param tolerance: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        :param tolerance_var: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1545c624ba8e69b517286582c9db36a693f538fea26778c4c775333deb583c30)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
            check_type(argname="argument feather", value=feather, expected_type=type_hints["feather"])
            check_type(argname="argument feather_var", value=feather_var, expected_type=type_hints["feather_var"])
            check_type(argname="argument tolerance", value=tolerance, expected_type=type_hints["tolerance"])
            check_type(argname="argument tolerance_var", value=tolerance_var, expected_type=type_hints["tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var
        if feather is not None:
            self._values["feather"] = feather
        if feather_var is not None:
            self._values["feather_var"] = feather_var
        if tolerance is not None:
            self._values["tolerance"] = tolerance
        if tolerance_var is not None:
            self._values["tolerance_var"] = tolerance_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        '''
        result = self._values.get("feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather_var(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        '''
        result = self._values.get("feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        '''
        result = self._values.get("tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance_var(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        result = self._values.get("tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRemoveColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRemoveColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRemoveColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2e19ac195754c75d7374675212c57e11208fbbe8efae95e94dbc288e65be9d7d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRemoveColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c077d4d930e1f1592363ff45b79b1317321a87b392d6efb40f6bc8f83b621a21)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRemoveColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f3043330152d11fc071dfce32020a80d8c38383ff767c0c467b89173ab8e85b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__010bf0adff401a03b6b92180d3cd7f118f8eef77d4bd431359b714de60dd8d61)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1c5d340c6de31a4b37267f8b443eea8f1cc03c939838b6dc79309ba576419681)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRemoveColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRemoveColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRemoveColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b8acd07fa418be45538da7f7ebfdf6d861d7e5cab322db89fbf24472e2b42b53)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRemoveColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRemoveColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8b3c7c8d2e4fa8965b5387121b9c682c18428bd46804dfcf171175591ac388a7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @jsii.member(jsii_name="resetFeather")
    def reset_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeather", []))

    @jsii.member(jsii_name="resetFeatherVar")
    def reset_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatherVar", []))

    @jsii.member(jsii_name="resetTolerance")
    def reset_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTolerance", []))

    @jsii.member(jsii_name="resetToleranceVar")
    def reset_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featherInput")
    def feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherInput"))

    @builtins.property
    @jsii.member(jsii_name="featherVarInput")
    def feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceInput")
    def tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceVarInput")
    def tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ec58071c4c9d75cc17a89afcf4d5b7117703809d2f21a5a7b6b5181b8faf3be)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__60b918cabab6b67a381d04b5d10afb931dc925c529a1031e10808870e0ebf3de)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="feather")
    def feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "feather"))

    @feather.setter
    def feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7408f395285ae983873b8a74f6305333593b550eed877258a66e6e6f4181bd35)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "feather", value)

    @builtins.property
    @jsii.member(jsii_name="featherVar")
    def feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featherVar"))

    @feather_var.setter
    def feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__85c21509d449db35ed1ad901f231fc41e310674af26b0e9ecb590cd31cb50146)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featherVar", value)

    @builtins.property
    @jsii.member(jsii_name="tolerance")
    def tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tolerance"))

    @tolerance.setter
    def tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f2ba94d59b4c90ebe42d49d106ed057158837e8647626ec12025873a8199eb09)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tolerance", value)

    @builtins.property
    @jsii.member(jsii_name="toleranceVar")
    def tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "toleranceVar"))

    @tolerance_var.setter
    def tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ef89ed7e5b8de01e5dd0c8de6199d4775bf6312210028e842390459e75d741a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "toleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRemoveColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRemoveColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRemoveColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__addf4234f915d44d2bb661383665c4e6b1a57f6ea9f66d310654898547cf943a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanResize",
    jsii_struct_bases=[],
    name_mapping={
        "aspect": "aspect",
        "aspect_var": "aspectVar",
        "height": "height",
        "height_var": "heightVar",
        "type": "type",
        "type_var": "typeVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanResize:
    def __init__(
        self,
        *,
        aspect: typing.Optional[builtins.str] = None,
        aspect_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param aspect: Preserves the aspect ratio. Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect DataAkamaiImagingPolicyImage#aspect}
        :param aspect_var: Preserves the aspect ratio. Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_var DataAkamaiImagingPolicyImage#aspect_var}
        :param height: The height to resize the source image to. Must be set if height is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height to resize the source image to. Must be set if height is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param type: Sets constraints for the image resize. Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: Sets constraints for the image resize. Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        :param width: The width to resize the source image to. Must be set if width is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width to resize the source image to. Must be set if width is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__571ad5e9e213deda4195471c7800b318023274741db17356359587b3fe88b06d)
            check_type(argname="argument aspect", value=aspect, expected_type=type_hints["aspect"])
            check_type(argname="argument aspect_var", value=aspect_var, expected_type=type_hints["aspect_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if aspect is not None:
            self._values["aspect"] = aspect
        if aspect_var is not None:
            self._values["aspect_var"] = aspect_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def aspect(self) -> typing.Optional[builtins.str]:
        '''Preserves the aspect ratio.

        Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect DataAkamaiImagingPolicyImage#aspect}
        '''
        result = self._values.get("aspect")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def aspect_var(self) -> typing.Optional[builtins.str]:
        '''Preserves the aspect ratio.

        Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_var DataAkamaiImagingPolicyImage#aspect_var}
        '''
        result = self._values.get("aspect_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height to resize the source image to. Must be set if height is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height to resize the source image to. Must be set if height is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''Sets constraints for the image resize.

        Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''Sets constraints for the image resize.

        Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width to resize the source image to. Must be set if width is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width to resize the source image to. Must be set if width is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanResize(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanResizeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanResizeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7321d2fd2373f278c8f7d1165e5a86329210e556a794dc327d1e805ff3c963f3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanResizeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a8845fb7a1b0936fd6d57817db6ffe247b980276a5ece2dfb8b046f35c4f8749)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanResizeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ae7a51660d0270e3a6099d72b6ad9625512f6ff5fd5dd7acf436dc5a1cf5647a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4df64d4a666cdff8f27a6781da1a77a533bc2909bff985fb5eaa90019896bbf1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0c64f637fe011b41aebac99cd2b3e1de5578fc019c79181ced2a209216ce82ec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanResize]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanResize]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanResize]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4d36750400dbfbb77d7c2b993eb2f566632957bab66a804d0b7b4da716dcc08f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanResizeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanResizeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b500f43730fd6f2308504f4464b94f66ab58409f08fde8b6f41f4f90e5461ac0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAspect")
    def reset_aspect(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspect", []))

    @jsii.member(jsii_name="resetAspectVar")
    def reset_aspect_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspectVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="aspectInput")
    def aspect_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "aspectInput"))

    @builtins.property
    @jsii.member(jsii_name="aspectVarInput")
    def aspect_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "aspectVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="aspect")
    def aspect(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "aspect"))

    @aspect.setter
    def aspect(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__798766f3b213a11a9e74cc9582207447fb10f3e3048fe8dac660ce87e9f3f740)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "aspect", value)

    @builtins.property
    @jsii.member(jsii_name="aspectVar")
    def aspect_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "aspectVar"))

    @aspect_var.setter
    def aspect_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__41205e654c7210b5ebafd9096f98dba6cc9931709b6eda58ad3aaab6ad5dc60b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "aspectVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ed67c9197a3ea9715785365aff959c4e1449a3fd497a545035d7fa17269a6a95)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a089f21012b775a7d0522b20074205daab9559085326748015992a8fb310f14)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1b9e2784680bbf46a636f36240f0327c494a1664169a11a1270600e05acdb5cc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2e7887f61775a45a321af6345c6d77b2f5a5d96b7777d954c08ccd11d213b858)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__448a8524e19a9ffa94842daa24e539766df0eaa552d06c39a49b5ed9d14b6d88)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8d4c758592751f866c1d97c4278068cae07a1c4b49c81a399552a647ed225257)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanResize]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanResize]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanResize]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d25454365c1f5649e2aef80fcbd6ad7d27e38a2724fb1c1c9cc3ebb8b33ec1e1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRotate",
    jsii_struct_bases=[],
    name_mapping={"degrees": "degrees", "degrees_var": "degreesVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRotate:
    def __init__(
        self,
        *,
        degrees: typing.Optional[builtins.str] = None,
        degrees_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param degrees: The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees DataAkamaiImagingPolicyImage#degrees}
        :param degrees_var: The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees_var DataAkamaiImagingPolicyImage#degrees_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ee2ab90bebd370b0d1165b722f17afc62429f693f45c3c4f9c76cba057ea7514)
            check_type(argname="argument degrees", value=degrees, expected_type=type_hints["degrees"])
            check_type(argname="argument degrees_var", value=degrees_var, expected_type=type_hints["degrees_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if degrees is not None:
            self._values["degrees"] = degrees
        if degrees_var is not None:
            self._values["degrees_var"] = degrees_var

    @builtins.property
    def degrees(self) -> typing.Optional[builtins.str]:
        '''The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees DataAkamaiImagingPolicyImage#degrees}
        '''
        result = self._values.get("degrees")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def degrees_var(self) -> typing.Optional[builtins.str]:
        '''The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees_var DataAkamaiImagingPolicyImage#degrees_var}
        '''
        result = self._values.get("degrees_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRotate(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRotateList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRotateList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6c87830e4f1cde0dc653b12afc67d51c34343f0828619481b6479de6afa5a9fe)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRotateOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4b2a96320f26a63ccbebd004907ebe5c26adbb5327d45b123d4b39129ce717d8)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRotateOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d7218a67913cd1ea1434e4de2f7591b264b17f3dbcf3a8406f2fac903d387856)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6d7f4a962f908d8a1675ebae9c80129c81eada9096ce45de33922b9f72a909e2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0e7473f41eed83f53ac1a3ee08798cae4a10d21cbd1b42c6030e27d8b093b114)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRotate]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRotate]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRotate]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e22a6ebdeb49ad4f2b329dd08f41b7cdfbcf551cafda0deec9fe6bae0e3fec4d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRotateOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRotateOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ecd9e85bfc33b43c844be5f494a4fbbe5ebfa9bbe99422128719dc444b7916cc)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetDegrees")
    def reset_degrees(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDegrees", []))

    @jsii.member(jsii_name="resetDegreesVar")
    def reset_degrees_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDegreesVar", []))

    @builtins.property
    @jsii.member(jsii_name="degreesInput")
    def degrees_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "degreesInput"))

    @builtins.property
    @jsii.member(jsii_name="degreesVarInput")
    def degrees_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "degreesVarInput"))

    @builtins.property
    @jsii.member(jsii_name="degrees")
    def degrees(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "degrees"))

    @degrees.setter
    def degrees(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d473b96d9862795daa9cb731e66df0e448916b46db6177846511d6b7941f679)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "degrees", value)

    @builtins.property
    @jsii.member(jsii_name="degreesVar")
    def degrees_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "degreesVar"))

    @degrees_var.setter
    def degrees_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e35dc5e33cdb1c759c60205e5ec117835436a4970fe93879da8087b78924fbdf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "degreesVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRotate]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRotate]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRotate]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__afe41b4104e7a70a051f4de01762e6081d3678b80b20d94d8aed3df0d3f561d0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanScale",
    jsii_struct_bases=[],
    name_mapping={
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanScale:
    def __init__(
        self,
        *,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param height: Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged. Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged. Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e87465a456379cb81faa8488c4c0c9825a2b664bbd18a8e5f40c44a4cbd4dc05)
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size.

        Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size.

        Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged.

        Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged.

        Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanScale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanScaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanScaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ca3cfec96b1ea161dcd333d1d3864fc571f0d5ba43bb652f502591c62c3252bc)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanScaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__25b44e1b0e1a8217573fee883e7b96b45b3dbb0c93d91ed4e7c8f5ea8d87ee56)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanScaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__270ea01315f409caeea7843db686206650a14499ab8debed73546d2ffc47b660)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d8f3422a042c11faea4803772fdf0ba45446758fd66e73e46011c6376d4b450b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1318c88da4237549aadf91bb52bf6a1afe9e4c4d04e383f32ee05bf2107fcab7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanScale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanScale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanScale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0c2ae7d28cb97b60e631fd8872d9aa0f37cced86daf50e0d4eedd4d2afaad027)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanScaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanScaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__505a003e9181d8052ac3848252374b60317d0e086c995fc2df7a02ead2b32ffe)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c4f53eae3ec9705c1520f0b4e34edf0f675c0e55b62d0ee89d5edd6b32076665)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__54eb85aa86d77e288cb43ef05add56dea53e08c98d98e992027c29805115aa90)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dc1ca702e9ba48e9c1211a094d3022638e362a7cdd33fead6e2317b8ff9bc95b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5a8f430ad1437b06fd4148023a0d6b3ee4c84eeb1851d44b6f8ce08514d7695a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanScale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanScale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanScale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__43c9d02c12b60ba0af6249ce90b2ab048f75bb4fe4e2bc9b53b66cb458b7fbff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanShear",
    jsii_struct_bases=[],
    name_mapping={
        "x_shear": "xShear",
        "x_shear_var": "xShearVar",
        "y_shear": "yShear",
        "y_shear_var": "yShearVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanShear:
    def __init__(
        self,
        *,
        x_shear: typing.Optional[builtins.str] = None,
        x_shear_var: typing.Optional[builtins.str] = None,
        y_shear: typing.Optional[builtins.str] = None,
        y_shear_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param x_shear: The amount to shear along the x-axis, measured in multiples of the image's width. Must be set if yShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear DataAkamaiImagingPolicyImage#x_shear}
        :param x_shear_var: The amount to shear along the x-axis, measured in multiples of the image's width. Must be set if yShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear_var DataAkamaiImagingPolicyImage#x_shear_var}
        :param y_shear: The amount to shear along the y-axis, measured in multiples of the image's height. Must be set if xShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear DataAkamaiImagingPolicyImage#y_shear}
        :param y_shear_var: The amount to shear along the y-axis, measured in multiples of the image's height. Must be set if xShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear_var DataAkamaiImagingPolicyImage#y_shear_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f7f90f301c0a528fc85f44df06f901332ef01673f45c53c9a81427605e7dc6e1)
            check_type(argname="argument x_shear", value=x_shear, expected_type=type_hints["x_shear"])
            check_type(argname="argument x_shear_var", value=x_shear_var, expected_type=type_hints["x_shear_var"])
            check_type(argname="argument y_shear", value=y_shear, expected_type=type_hints["y_shear"])
            check_type(argname="argument y_shear_var", value=y_shear_var, expected_type=type_hints["y_shear_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if x_shear is not None:
            self._values["x_shear"] = x_shear
        if x_shear_var is not None:
            self._values["x_shear_var"] = x_shear_var
        if y_shear is not None:
            self._values["y_shear"] = y_shear
        if y_shear_var is not None:
            self._values["y_shear_var"] = y_shear_var

    @builtins.property
    def x_shear(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the x-axis, measured in multiples of the image's width.

        Must be set if yShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear DataAkamaiImagingPolicyImage#x_shear}
        '''
        result = self._values.get("x_shear")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_shear_var(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the x-axis, measured in multiples of the image's width.

        Must be set if yShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear_var DataAkamaiImagingPolicyImage#x_shear_var}
        '''
        result = self._values.get("x_shear_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_shear(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the y-axis, measured in multiples of the image's height.

        Must be set if xShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear DataAkamaiImagingPolicyImage#y_shear}
        '''
        result = self._values.get("y_shear")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_shear_var(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the y-axis, measured in multiples of the image's height.

        Must be set if xShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear_var DataAkamaiImagingPolicyImage#y_shear_var}
        '''
        result = self._values.get("y_shear_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanShear(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanShearList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanShearList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7dad6962927da96ed789ee4a97526e7451dfe21fe606efe8a94dd08ab0f21260)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanShearOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab53b55d7207659528488cf476daf2fc426388f42108e0e4ce12a2dcbaa0440e)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanShearOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__79f5e0a9c48f1171bfb9892bf79ebb883f08a67a510f1f9b9437ad18a0e712da)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__57fa7f8fa41c346e28f13d5d8d4a306b2f3d03b96bdec75aa8f824cb829df5a4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__820e8a79435d0ce4602cc388e726961e505c8db4a90d48903cd481e9be598786)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanShear]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanShear]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanShear]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a458a93f5f2d4ebca9b043a528fa8d2193261f16b8db7c16924a7acc1f960dc6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanShearOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanShearOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__301d85601d7365f5a8cee7c95b7f7b899015f625eaf92b3d84ed85da8e1ee76f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetXShear")
    def reset_x_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXShear", []))

    @jsii.member(jsii_name="resetXShearVar")
    def reset_x_shear_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXShearVar", []))

    @jsii.member(jsii_name="resetYShear")
    def reset_y_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYShear", []))

    @jsii.member(jsii_name="resetYShearVar")
    def reset_y_shear_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYShearVar", []))

    @builtins.property
    @jsii.member(jsii_name="xShearInput")
    def x_shear_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xShearInput"))

    @builtins.property
    @jsii.member(jsii_name="xShearVarInput")
    def x_shear_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xShearVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yShearInput")
    def y_shear_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yShearInput"))

    @builtins.property
    @jsii.member(jsii_name="yShearVarInput")
    def y_shear_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yShearVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xShear")
    def x_shear(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xShear"))

    @x_shear.setter
    def x_shear(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ca06f61d47e18fa62fef298b2945de4a5b1968c1d20188579d47d044557d77b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xShear", value)

    @builtins.property
    @jsii.member(jsii_name="xShearVar")
    def x_shear_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xShearVar"))

    @x_shear_var.setter
    def x_shear_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d1231e73482d81a48020def0d5cee9e4f8b1848d8618d80313181567dd3c50a0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xShearVar", value)

    @builtins.property
    @jsii.member(jsii_name="yShear")
    def y_shear(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yShear"))

    @y_shear.setter
    def y_shear(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6014dd61eb8e6e5cbfc49448c18e4599ca910bd3fd0e2c98f7831700d31bf97e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yShear", value)

    @builtins.property
    @jsii.member(jsii_name="yShearVar")
    def y_shear_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yShearVar"))

    @y_shear_var.setter
    def y_shear_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cab36f0c3eb811c94792119c9b7714551a4c0fff9269c0b21c26463708ea363e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yShearVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanShear]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanShear]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanShear]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eb86817814453a4c9a520e93f671d650867513c8bea8f14f745cbef5742f767a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanTrim",
    jsii_struct_bases=[],
    name_mapping={
        "fuzz": "fuzz",
        "fuzz_var": "fuzzVar",
        "padding": "padding",
        "padding_var": "paddingVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanTrim:
    def __init__(
        self,
        *,
        fuzz: typing.Optional[builtins.str] = None,
        fuzz_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fuzz: The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz DataAkamaiImagingPolicyImage#fuzz}
        :param fuzz_var: The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz_var DataAkamaiImagingPolicyImage#fuzz_var}
        :param padding: The amount of padding in pixels to add to the trimmed image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: The amount of padding in pixels to add to the trimmed image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d88fdc604ea5add0886a2ad6f0b50fa5ca72deff1ac0552802bc2d001f14d39)
            check_type(argname="argument fuzz", value=fuzz, expected_type=type_hints["fuzz"])
            check_type(argname="argument fuzz_var", value=fuzz_var, expected_type=type_hints["fuzz_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fuzz is not None:
            self._values["fuzz"] = fuzz
        if fuzz_var is not None:
            self._values["fuzz_var"] = fuzz_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var

    @builtins.property
    def fuzz(self) -> typing.Optional[builtins.str]:
        '''The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz DataAkamaiImagingPolicyImage#fuzz}
        '''
        result = self._values.get("fuzz")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fuzz_var(self) -> typing.Optional[builtins.str]:
        '''The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz_var DataAkamaiImagingPolicyImage#fuzz_var}
        '''
        result = self._values.get("fuzz_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''The amount of padding in pixels to add to the trimmed image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''The amount of padding in pixels to add to the trimmed image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanTrim(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanTrimList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanTrimList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5dcac4a0cbb004162836ff458626466400e82e1c3f6ab171e728b2287556b15d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanTrimOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__76c20ebd098e6587aa82ce2742a14ae815bc164e2ea90701208a07849faf65c7)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanTrimOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1236167d7d35cfea8f9f26c64c2bf397cb420b34895da57c046cc4af0a0eee7c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6cbdba98dbb00366a51e0198add3865c5a2689180213fe3e961f664be6bfc150)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5a5963365380e1e39169014d605c95fd279c880af03f16cb7d65b68127160e46)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanTrim]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanTrim]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanTrim]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3562fe4b94e3fd1e9178596d81a96ac569e1facf3d4f2abac936bd779984cc67)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanTrimOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanTrimOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__96164d7b295aa27743eb4cbe6d7ae1bf9b136a283a6415d0f9590e2394bcec44)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetFuzz")
    def reset_fuzz(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFuzz", []))

    @jsii.member(jsii_name="resetFuzzVar")
    def reset_fuzz_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFuzzVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @builtins.property
    @jsii.member(jsii_name="fuzzInput")
    def fuzz_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fuzzInput"))

    @builtins.property
    @jsii.member(jsii_name="fuzzVarInput")
    def fuzz_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fuzzVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="fuzz")
    def fuzz(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fuzz"))

    @fuzz.setter
    def fuzz(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__69e3fe6f06f75b83bf3709eb5248de3e4e793bd13012c0a4e79824faf4b5fcb7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fuzz", value)

    @builtins.property
    @jsii.member(jsii_name="fuzzVar")
    def fuzz_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fuzzVar"))

    @fuzz_var.setter
    def fuzz_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d7c7b8e525f126abea59e94ff8e4f4bb0b6d257b0dbab3e2caf659a8caebcbe7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fuzzVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b0b5ca3688796eb062dff64a66bb02a2bfa63fc36825420921afd79c7ce1e196)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f458bd34bf7664d3f7d109e0ec0c379a4f4a2ac98c74308d28b7eb0af852edf4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanTrim]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanTrim]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanTrim]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8841eefdd3d1c9bd1689de21202cad1a7d05f4cbd0054126f942b332c64998b7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanUnsharpMask",
    jsii_struct_bases=[],
    name_mapping={
        "gain": "gain",
        "gain_var": "gainVar",
        "sigma": "sigma",
        "sigma_var": "sigmaVar",
        "threshold": "threshold",
        "threshold_var": "thresholdVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanUnsharpMask:
    def __init__(
        self,
        *,
        gain: typing.Optional[builtins.str] = None,
        gain_var: typing.Optional[builtins.str] = None,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
        threshold: typing.Optional[builtins.str] = None,
        threshold_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param gain: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        :param gain_var: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        :param sigma: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        :param threshold: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        :param threshold_var: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__997153cbcb879401defa8ac07be9a9651839f11827ce1366be68d3205adb794a)
            check_type(argname="argument gain", value=gain, expected_type=type_hints["gain"])
            check_type(argname="argument gain_var", value=gain_var, expected_type=type_hints["gain_var"])
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
            check_type(argname="argument threshold", value=threshold, expected_type=type_hints["threshold"])
            check_type(argname="argument threshold_var", value=threshold_var, expected_type=type_hints["threshold_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if gain is not None:
            self._values["gain"] = gain
        if gain_var is not None:
            self._values["gain_var"] = gain_var
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var
        if threshold is not None:
            self._values["threshold"] = threshold
        if threshold_var is not None:
            self._values["threshold_var"] = threshold_var

    @builtins.property
    def gain(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        '''
        result = self._values.get("gain")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gain_var(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        '''
        result = self._values.get("gain_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        '''
        result = self._values.get("threshold")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold_var(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        result = self._values.get("threshold_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanUnsharpMask(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanUnsharpMaskList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanUnsharpMaskList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__68cef7cbb8824c94f80d47409ad47dc03c5612dea4db6a689191c5c94fdee381)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanUnsharpMaskOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9b50a2783f5b78a6ab68793c36545f8ae2f8541feceef3e452ee2c7f396eb41f)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanUnsharpMaskOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b616d4a1a6a7fc024b1f365467a316beb05bd24cec34143fab532bfde738bce5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__003d9a9d5b8bd0ae7c7831807531c3835fe64891d156c45f3f701bd4837ab5d4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__607ce1aabd44c4e2acc8f72546242168e00a54d626dcdaa7da209b6da24598c7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanUnsharpMask]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanUnsharpMask]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanUnsharpMask]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a47e99a32226ac73339f79e4fb9817fc1a0a1208feb74590aedad0da22943af4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanUnsharpMaskOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanUnsharpMaskOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af89995afc6135d744c94bf6cb06beb3b43547b456afbf23118fc4626af2deb9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetGain")
    def reset_gain(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGain", []))

    @jsii.member(jsii_name="resetGainVar")
    def reset_gain_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGainVar", []))

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @jsii.member(jsii_name="resetThreshold")
    def reset_threshold(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThreshold", []))

    @jsii.member(jsii_name="resetThresholdVar")
    def reset_threshold_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThresholdVar", []))

    @builtins.property
    @jsii.member(jsii_name="gainInput")
    def gain_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainInput"))

    @builtins.property
    @jsii.member(jsii_name="gainVarInput")
    def gain_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdInput")
    def threshold_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdVarInput")
    def threshold_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gain")
    def gain(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gain"))

    @gain.setter
    def gain(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__80555cf9df9018baf281e379be07905c7c86c3ac7c1052b166c1e1c1df0040b4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gain", value)

    @builtins.property
    @jsii.member(jsii_name="gainVar")
    def gain_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gainVar"))

    @gain_var.setter
    def gain_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0dc2bbaf7b6c8c3a55037bbc5ff13c14612aa86aadf0ea8a0dd24b64a182e0e8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gainVar", value)

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6b14709e6e5ebb264c8461858352e5f75994750b7a55e6af23d382e6de8f2594)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__642212ff8249185343f03ea852a20bf1a361a908576868c1aabb3d8ba8d79984)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="threshold")
    def threshold(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "threshold"))

    @threshold.setter
    def threshold(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__31b185e0fc8856fc6db9de53c78c0507958d96685546b7c41cbbd66b69113c07)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "threshold", value)

    @builtins.property
    @jsii.member(jsii_name="thresholdVar")
    def threshold_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "thresholdVar"))

    @threshold_var.setter
    def threshold_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__29f535d1a86b9c642b44951e3ba8cae53a08b214e31d4e6fddd3ebd8bad4d0b7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "thresholdVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanUnsharpMask]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanUnsharpMask]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanUnsharpMask]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__26bcefc79978bb00f5524ef6f023c20a213c9e8bd5a7e3a168225a42f6e44c98)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c342980778dbd6c9710f8628d1a480613846bc87e0b589ae1da552fb2920748e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e628f60190f38c0bbe25dc9466bc689a4433e7be6bec058832dc98db62f4e0e6)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4d502dff037c981d52d818c5817b6078ed8013de8f30d529b8586cc10d502f25)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b44f85755873924ee37bb0a7e4e4d5705b11f4fe93d2c2e16c2d998b96ac14bc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__921822b0cfa20447d35cf6486335849b8dfa557df222557353c0c6bc9c5dd1ea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimension]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimension]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__37b0640b205ce78045b883a74b056cb75c7213f05386faa81405000f9433fc74)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__de51f4cfc987e4584ae0883f1f4237367043126e91394fc43d411c66836092df)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(
        self,
        *,
        append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppend, typing.Dict[builtins.str, typing.Any]]]]] = None,
        aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAspectCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
        crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFaceCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFeatureCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFill, typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
        im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultImQuery, typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
        region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRelativeCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
        resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultResize, typing.Dict[builtins.str, typing.Any]]]]] = None,
        rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRotate, typing.Dict[builtins.str, typing.Any]]]]] = None,
        scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultScale, typing.Dict[builtins.str, typing.Any]]]]] = None,
        shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultShear, typing.Dict[builtins.str, typing.Any]]]]] = None,
        trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultTrim, typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param append: append block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        :param aspect_crop: aspect_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param crop: crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        :param face_crop: face_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        :param feature_crop: feature_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        :param fit_and_fill: fit_and_fill block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param im_query: im_query block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param region_of_interest_crop: region_of_interest_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        :param relative_crop: relative_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param resize: resize block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        :param rotate: rotate block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        :param scale: scale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param shear: shear block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        :param trim: trim block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefault(
            append=append,
            aspect_crop=aspect_crop,
            background_color=background_color,
            blur=blur,
            chroma_key=chroma_key,
            composite=composite,
            compound=compound,
            contrast=contrast,
            crop=crop,
            face_crop=face_crop,
            feature_crop=feature_crop,
            fit_and_fill=fit_and_fill,
            goop=goop,
            grayscale=grayscale,
            hsl=hsl,
            hsv=hsv,
            if_dimension=if_dimension,
            if_orientation=if_orientation,
            im_query=im_query,
            max_colors=max_colors,
            mirror=mirror,
            mono_hue=mono_hue,
            opacity=opacity,
            region_of_interest_crop=region_of_interest_crop,
            relative_crop=relative_crop,
            remove_color=remove_color,
            resize=resize,
            rotate=rotate,
            scale=scale,
            shear=shear,
            trim=trim,
            unsharp_mask=unsharp_mask,
        )

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putEqual")
    def put_equal(
        self,
        *,
        append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppend, typing.Dict[builtins.str, typing.Any]]]]] = None,
        aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAspectCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
        crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFaceCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFeatureCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFill, typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
        im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualImQuery, typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
        region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRelativeCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
        resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualResize, typing.Dict[builtins.str, typing.Any]]]]] = None,
        rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRotate, typing.Dict[builtins.str, typing.Any]]]]] = None,
        scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualScale, typing.Dict[builtins.str, typing.Any]]]]] = None,
        shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualShear, typing.Dict[builtins.str, typing.Any]]]]] = None,
        trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualTrim, typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param append: append block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        :param aspect_crop: aspect_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param crop: crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        :param face_crop: face_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        :param feature_crop: feature_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        :param fit_and_fill: fit_and_fill block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param im_query: im_query block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param region_of_interest_crop: region_of_interest_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        :param relative_crop: relative_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param resize: resize block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        :param rotate: rotate block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        :param scale: scale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param shear: shear block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        :param trim: trim block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqual(
            append=append,
            aspect_crop=aspect_crop,
            background_color=background_color,
            blur=blur,
            chroma_key=chroma_key,
            composite=composite,
            compound=compound,
            contrast=contrast,
            crop=crop,
            face_crop=face_crop,
            feature_crop=feature_crop,
            fit_and_fill=fit_and_fill,
            goop=goop,
            grayscale=grayscale,
            hsl=hsl,
            hsv=hsv,
            if_dimension=if_dimension,
            if_orientation=if_orientation,
            im_query=im_query,
            max_colors=max_colors,
            mirror=mirror,
            mono_hue=mono_hue,
            opacity=opacity,
            region_of_interest_crop=region_of_interest_crop,
            relative_crop=relative_crop,
            remove_color=remove_color,
            resize=resize,
            rotate=rotate,
            scale=scale,
            shear=shear,
            trim=trim,
            unsharp_mask=unsharp_mask,
        )

        return typing.cast(None, jsii.invoke(self, "putEqual", [value]))

    @jsii.member(jsii_name="putGreaterThan")
    def put_greater_than(
        self,
        *,
        append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppend, typing.Dict[builtins.str, typing.Any]]]]] = None,
        aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAspectCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
        crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFaceCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFeatureCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFill, typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
        im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanImQuery, typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
        region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRelativeCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
        resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanResize, typing.Dict[builtins.str, typing.Any]]]]] = None,
        rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRotate, typing.Dict[builtins.str, typing.Any]]]]] = None,
        scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanScale, typing.Dict[builtins.str, typing.Any]]]]] = None,
        shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanShear, typing.Dict[builtins.str, typing.Any]]]]] = None,
        trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanTrim, typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param append: append block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        :param aspect_crop: aspect_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param crop: crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        :param face_crop: face_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        :param feature_crop: feature_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        :param fit_and_fill: fit_and_fill block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param im_query: im_query block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param region_of_interest_crop: region_of_interest_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        :param relative_crop: relative_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param resize: resize block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        :param rotate: rotate block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        :param scale: scale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param shear: shear block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        :param trim: trim block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThan(
            append=append,
            aspect_crop=aspect_crop,
            background_color=background_color,
            blur=blur,
            chroma_key=chroma_key,
            composite=composite,
            compound=compound,
            contrast=contrast,
            crop=crop,
            face_crop=face_crop,
            feature_crop=feature_crop,
            fit_and_fill=fit_and_fill,
            goop=goop,
            grayscale=grayscale,
            hsl=hsl,
            hsv=hsv,
            if_dimension=if_dimension,
            if_orientation=if_orientation,
            im_query=im_query,
            max_colors=max_colors,
            mirror=mirror,
            mono_hue=mono_hue,
            opacity=opacity,
            region_of_interest_crop=region_of_interest_crop,
            relative_crop=relative_crop,
            remove_color=remove_color,
            resize=resize,
            rotate=rotate,
            scale=scale,
            shear=shear,
            trim=trim,
            unsharp_mask=unsharp_mask,
        )

        return typing.cast(None, jsii.invoke(self, "putGreaterThan", [value]))

    @jsii.member(jsii_name="putLessThan")
    def put_less_than(
        self,
        *,
        append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppend, typing.Dict[builtins.str, typing.Any]]]]] = None,
        aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAspectCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
        crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFaceCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFeatureCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFill, typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
        im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanImQuery, typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
        region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRelativeCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
        resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanResize, typing.Dict[builtins.str, typing.Any]]]]] = None,
        rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRotate, typing.Dict[builtins.str, typing.Any]]]]] = None,
        scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanScale, typing.Dict[builtins.str, typing.Any]]]]] = None,
        shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanShear, typing.Dict[builtins.str, typing.Any]]]]] = None,
        trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanTrim, typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param append: append block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        :param aspect_crop: aspect_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param crop: crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        :param face_crop: face_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        :param feature_crop: feature_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        :param fit_and_fill: fit_and_fill block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param im_query: im_query block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param region_of_interest_crop: region_of_interest_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        :param relative_crop: relative_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param resize: resize block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        :param rotate: rotate block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        :param scale: scale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param shear: shear block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        :param trim: trim block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThan(
            append=append,
            aspect_crop=aspect_crop,
            background_color=background_color,
            blur=blur,
            chroma_key=chroma_key,
            composite=composite,
            compound=compound,
            contrast=contrast,
            crop=crop,
            face_crop=face_crop,
            feature_crop=feature_crop,
            fit_and_fill=fit_and_fill,
            goop=goop,
            grayscale=grayscale,
            hsl=hsl,
            hsv=hsv,
            if_dimension=if_dimension,
            if_orientation=if_orientation,
            im_query=im_query,
            max_colors=max_colors,
            mirror=mirror,
            mono_hue=mono_hue,
            opacity=opacity,
            region_of_interest_crop=region_of_interest_crop,
            relative_crop=relative_crop,
            remove_color=remove_color,
            resize=resize,
            rotate=rotate,
            scale=scale,
            shear=shear,
            trim=trim,
            unsharp_mask=unsharp_mask,
        )

        return typing.cast(None, jsii.invoke(self, "putLessThan", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetDimension")
    def reset_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimension", []))

    @jsii.member(jsii_name="resetDimensionVar")
    def reset_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimensionVar", []))

    @jsii.member(jsii_name="resetEqual")
    def reset_equal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEqual", []))

    @jsii.member(jsii_name="resetGreaterThan")
    def reset_greater_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGreaterThan", []))

    @jsii.member(jsii_name="resetLessThan")
    def reset_less_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLessThan", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="equal")
    def equal(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualOutputReference, jsii.get(self, "equal"))

    @builtins.property
    @jsii.member(jsii_name="greaterThan")
    def greater_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanOutputReference, jsii.get(self, "greaterThan"))

    @builtins.property
    @jsii.member(jsii_name="lessThan")
    def less_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanOutputReference, jsii.get(self, "lessThan"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionInput")
    def dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionVarInput")
    def dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="equalInput")
    def equal_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqual], jsii.get(self, "equalInput"))

    @builtins.property
    @jsii.member(jsii_name="greaterThanInput")
    def greater_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThan], jsii.get(self, "greaterThanInput"))

    @builtins.property
    @jsii.member(jsii_name="lessThanInput")
    def less_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThan], jsii.get(self, "lessThanInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="dimension")
    def dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimension"))

    @dimension.setter
    def dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c5a1eeda09bc13eeba03878d9cfe0de05508159e1be99c8dcd696448c38153ce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimension", value)

    @builtins.property
    @jsii.member(jsii_name="dimensionVar")
    def dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimensionVar"))

    @dimension_var.setter
    def dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9051fa9401e8e441d2d1165431fdac37a6afd9d328263ceb5ee945a600880d98)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6db07881d044dfa622e1573de8cc215b826d303ceaffcb7b7f50165c7571c925)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d1e71c3c8811b42408bc918f83a1dca9c096f4f5faf781d3eae9530d32a01e8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimension]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimension]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimension]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e485f6db59164cf3deea813981b1344d5b2b796ab29f856a2264192defd72880)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientation",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "landscape": "landscape",
        "portrait": "portrait",
        "square": "square",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientation:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        landscape: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscape", typing.Dict[builtins.str, typing.Any]]] = None,
        portrait: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortrait", typing.Dict[builtins.str, typing.Any]]] = None,
        square: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquare", typing.Dict[builtins.str, typing.Any]]] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param landscape: landscape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        :param portrait: portrait block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        :param square: square block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefault(**default)
        if isinstance(landscape, dict):
            landscape = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscape(**landscape)
        if isinstance(portrait, dict):
            portrait = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortrait(**portrait)
        if isinstance(square, dict):
            square = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquare(**square)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__67fd777829d0449e19955f8002167982b4f02923d1fb675f762131b3bb3fa0db)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument landscape", value=landscape, expected_type=type_hints["landscape"])
            check_type(argname="argument portrait", value=portrait, expected_type=type_hints["portrait"])
            check_type(argname="argument square", value=square, expected_type=type_hints["square"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if landscape is not None:
            self._values["landscape"] = landscape
        if portrait is not None:
            self._values["portrait"] = portrait
        if square is not None:
            self._values["square"] = square

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefault"], result)

    @builtins.property
    def landscape(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscape"]:
        '''landscape block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        '''
        result = self._values.get("landscape")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscape"], result)

    @builtins.property
    def portrait(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortrait"]:
        '''portrait block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        '''
        result = self._values.get("portrait")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortrait"], result)

    @builtins.property
    def square(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquare"]:
        '''square block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        result = self._values.get("square")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquare"], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefault",
    jsii_struct_bases=[],
    name_mapping={
        "append": "append",
        "aspect_crop": "aspectCrop",
        "background_color": "backgroundColor",
        "blur": "blur",
        "chroma_key": "chromaKey",
        "composite": "composite",
        "compound": "compound",
        "contrast": "contrast",
        "crop": "crop",
        "face_crop": "faceCrop",
        "feature_crop": "featureCrop",
        "fit_and_fill": "fitAndFill",
        "goop": "goop",
        "grayscale": "grayscale",
        "hsl": "hsl",
        "hsv": "hsv",
        "if_dimension": "ifDimension",
        "if_orientation": "ifOrientation",
        "im_query": "imQuery",
        "max_colors": "maxColors",
        "mirror": "mirror",
        "mono_hue": "monoHue",
        "opacity": "opacity",
        "region_of_interest_crop": "regionOfInterestCrop",
        "relative_crop": "relativeCrop",
        "remove_color": "removeColor",
        "resize": "resize",
        "rotate": "rotate",
        "scale": "scale",
        "shear": "shear",
        "trim": "trim",
        "unsharp_mask": "unsharpMask",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefault:
    def __init__(
        self,
        *,
        append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppend", typing.Dict[builtins.str, typing.Any]]]]] = None,
        aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAspectCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultBackgroundColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultBlur", typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultChromaKey", typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultComposite", typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompound", typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultContrast", typing.Dict[builtins.str, typing.Any]]]]] = None,
        crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFaceCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFeatureCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFill", typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultGoop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultGrayscale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultHsl", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultHsv", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimension", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
        im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultImQuery", typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultMaxColors", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultMirror", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultMonoHue", typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultOpacity", typing.Dict[builtins.str, typing.Any]]]]] = None,
        region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRelativeCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRemoveColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultResize", typing.Dict[builtins.str, typing.Any]]]]] = None,
        rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRotate", typing.Dict[builtins.str, typing.Any]]]]] = None,
        scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultScale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultShear", typing.Dict[builtins.str, typing.Any]]]]] = None,
        trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultTrim", typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultUnsharpMask", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param append: append block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        :param aspect_crop: aspect_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param crop: crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        :param face_crop: face_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        :param feature_crop: feature_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        :param fit_and_fill: fit_and_fill block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param im_query: im_query block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param region_of_interest_crop: region_of_interest_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        :param relative_crop: relative_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param resize: resize block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        :param rotate: rotate block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        :param scale: scale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param shear: shear block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        :param trim: trim block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d065a9463c60fe14ce0f03182533bb4cd0fffa0444189f14b9f8559be8efd9e5)
            check_type(argname="argument append", value=append, expected_type=type_hints["append"])
            check_type(argname="argument aspect_crop", value=aspect_crop, expected_type=type_hints["aspect_crop"])
            check_type(argname="argument background_color", value=background_color, expected_type=type_hints["background_color"])
            check_type(argname="argument blur", value=blur, expected_type=type_hints["blur"])
            check_type(argname="argument chroma_key", value=chroma_key, expected_type=type_hints["chroma_key"])
            check_type(argname="argument composite", value=composite, expected_type=type_hints["composite"])
            check_type(argname="argument compound", value=compound, expected_type=type_hints["compound"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument crop", value=crop, expected_type=type_hints["crop"])
            check_type(argname="argument face_crop", value=face_crop, expected_type=type_hints["face_crop"])
            check_type(argname="argument feature_crop", value=feature_crop, expected_type=type_hints["feature_crop"])
            check_type(argname="argument fit_and_fill", value=fit_and_fill, expected_type=type_hints["fit_and_fill"])
            check_type(argname="argument goop", value=goop, expected_type=type_hints["goop"])
            check_type(argname="argument grayscale", value=grayscale, expected_type=type_hints["grayscale"])
            check_type(argname="argument hsl", value=hsl, expected_type=type_hints["hsl"])
            check_type(argname="argument hsv", value=hsv, expected_type=type_hints["hsv"])
            check_type(argname="argument if_dimension", value=if_dimension, expected_type=type_hints["if_dimension"])
            check_type(argname="argument if_orientation", value=if_orientation, expected_type=type_hints["if_orientation"])
            check_type(argname="argument im_query", value=im_query, expected_type=type_hints["im_query"])
            check_type(argname="argument max_colors", value=max_colors, expected_type=type_hints["max_colors"])
            check_type(argname="argument mirror", value=mirror, expected_type=type_hints["mirror"])
            check_type(argname="argument mono_hue", value=mono_hue, expected_type=type_hints["mono_hue"])
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument region_of_interest_crop", value=region_of_interest_crop, expected_type=type_hints["region_of_interest_crop"])
            check_type(argname="argument relative_crop", value=relative_crop, expected_type=type_hints["relative_crop"])
            check_type(argname="argument remove_color", value=remove_color, expected_type=type_hints["remove_color"])
            check_type(argname="argument resize", value=resize, expected_type=type_hints["resize"])
            check_type(argname="argument rotate", value=rotate, expected_type=type_hints["rotate"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument shear", value=shear, expected_type=type_hints["shear"])
            check_type(argname="argument trim", value=trim, expected_type=type_hints["trim"])
            check_type(argname="argument unsharp_mask", value=unsharp_mask, expected_type=type_hints["unsharp_mask"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if append is not None:
            self._values["append"] = append
        if aspect_crop is not None:
            self._values["aspect_crop"] = aspect_crop
        if background_color is not None:
            self._values["background_color"] = background_color
        if blur is not None:
            self._values["blur"] = blur
        if chroma_key is not None:
            self._values["chroma_key"] = chroma_key
        if composite is not None:
            self._values["composite"] = composite
        if compound is not None:
            self._values["compound"] = compound
        if contrast is not None:
            self._values["contrast"] = contrast
        if crop is not None:
            self._values["crop"] = crop
        if face_crop is not None:
            self._values["face_crop"] = face_crop
        if feature_crop is not None:
            self._values["feature_crop"] = feature_crop
        if fit_and_fill is not None:
            self._values["fit_and_fill"] = fit_and_fill
        if goop is not None:
            self._values["goop"] = goop
        if grayscale is not None:
            self._values["grayscale"] = grayscale
        if hsl is not None:
            self._values["hsl"] = hsl
        if hsv is not None:
            self._values["hsv"] = hsv
        if if_dimension is not None:
            self._values["if_dimension"] = if_dimension
        if if_orientation is not None:
            self._values["if_orientation"] = if_orientation
        if im_query is not None:
            self._values["im_query"] = im_query
        if max_colors is not None:
            self._values["max_colors"] = max_colors
        if mirror is not None:
            self._values["mirror"] = mirror
        if mono_hue is not None:
            self._values["mono_hue"] = mono_hue
        if opacity is not None:
            self._values["opacity"] = opacity
        if region_of_interest_crop is not None:
            self._values["region_of_interest_crop"] = region_of_interest_crop
        if relative_crop is not None:
            self._values["relative_crop"] = relative_crop
        if remove_color is not None:
            self._values["remove_color"] = remove_color
        if resize is not None:
            self._values["resize"] = resize
        if rotate is not None:
            self._values["rotate"] = rotate
        if scale is not None:
            self._values["scale"] = scale
        if shear is not None:
            self._values["shear"] = shear
        if trim is not None:
            self._values["trim"] = trim
        if unsharp_mask is not None:
            self._values["unsharp_mask"] = unsharp_mask

    @builtins.property
    def append(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppend"]]]:
        '''append block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        '''
        result = self._values.get("append")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppend"]]], result)

    @builtins.property
    def aspect_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAspectCrop"]]]:
        '''aspect_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        '''
        result = self._values.get("aspect_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAspectCrop"]]], result)

    @builtins.property
    def background_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultBackgroundColor"]]]:
        '''background_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        '''
        result = self._values.get("background_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultBackgroundColor"]]], result)

    @builtins.property
    def blur(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultBlur"]]]:
        '''blur block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        '''
        result = self._values.get("blur")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultBlur"]]], result)

    @builtins.property
    def chroma_key(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultChromaKey"]]]:
        '''chroma_key block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        '''
        result = self._values.get("chroma_key")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultChromaKey"]]], result)

    @builtins.property
    def composite(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultComposite"]]]:
        '''composite block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        '''
        result = self._values.get("composite")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultComposite"]]], result)

    @builtins.property
    def compound(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompound"]]]:
        '''compound block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        '''
        result = self._values.get("compound")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompound"]]], result)

    @builtins.property
    def contrast(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultContrast"]]]:
        '''contrast block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultContrast"]]], result)

    @builtins.property
    def crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCrop"]]]:
        '''crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        '''
        result = self._values.get("crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCrop"]]], result)

    @builtins.property
    def face_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFaceCrop"]]]:
        '''face_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        '''
        result = self._values.get("face_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFaceCrop"]]], result)

    @builtins.property
    def feature_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFeatureCrop"]]]:
        '''feature_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        '''
        result = self._values.get("feature_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFeatureCrop"]]], result)

    @builtins.property
    def fit_and_fill(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFill"]]]:
        '''fit_and_fill block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        '''
        result = self._values.get("fit_and_fill")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFill"]]], result)

    @builtins.property
    def goop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultGoop"]]]:
        '''goop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        '''
        result = self._values.get("goop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultGoop"]]], result)

    @builtins.property
    def grayscale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultGrayscale"]]]:
        '''grayscale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        '''
        result = self._values.get("grayscale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultGrayscale"]]], result)

    @builtins.property
    def hsl(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultHsl"]]]:
        '''hsl block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        '''
        result = self._values.get("hsl")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultHsl"]]], result)

    @builtins.property
    def hsv(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultHsv"]]]:
        '''hsv block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        '''
        result = self._values.get("hsv")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultHsv"]]], result)

    @builtins.property
    def if_dimension(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimension"]]]:
        '''if_dimension block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        '''
        result = self._values.get("if_dimension")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimension"]]], result)

    @builtins.property
    def if_orientation(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientation]]]:
        '''if_orientation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        '''
        result = self._values.get("if_orientation")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientation]]], result)

    @builtins.property
    def im_query(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultImQuery"]]]:
        '''im_query block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        '''
        result = self._values.get("im_query")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultImQuery"]]], result)

    @builtins.property
    def max_colors(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultMaxColors"]]]:
        '''max_colors block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        '''
        result = self._values.get("max_colors")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultMaxColors"]]], result)

    @builtins.property
    def mirror(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultMirror"]]]:
        '''mirror block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        '''
        result = self._values.get("mirror")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultMirror"]]], result)

    @builtins.property
    def mono_hue(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultMonoHue"]]]:
        '''mono_hue block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        '''
        result = self._values.get("mono_hue")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultMonoHue"]]], result)

    @builtins.property
    def opacity(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultOpacity"]]]:
        '''opacity block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultOpacity"]]], result)

    @builtins.property
    def region_of_interest_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCrop"]]]:
        '''region_of_interest_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        '''
        result = self._values.get("region_of_interest_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCrop"]]], result)

    @builtins.property
    def relative_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRelativeCrop"]]]:
        '''relative_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        '''
        result = self._values.get("relative_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRelativeCrop"]]], result)

    @builtins.property
    def remove_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRemoveColor"]]]:
        '''remove_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        '''
        result = self._values.get("remove_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRemoveColor"]]], result)

    @builtins.property
    def resize(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultResize"]]]:
        '''resize block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        '''
        result = self._values.get("resize")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultResize"]]], result)

    @builtins.property
    def rotate(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRotate"]]]:
        '''rotate block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        '''
        result = self._values.get("rotate")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRotate"]]], result)

    @builtins.property
    def scale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultScale"]]]:
        '''scale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultScale"]]], result)

    @builtins.property
    def shear(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultShear"]]]:
        '''shear block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        '''
        result = self._values.get("shear")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultShear"]]], result)

    @builtins.property
    def trim(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultTrim"]]]:
        '''trim block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        '''
        result = self._values.get("trim")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultTrim"]]], result)

    @builtins.property
    def unsharp_mask(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultUnsharpMask"]]]:
        '''unsharp_mask block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        result = self._values.get("unsharp_mask")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultUnsharpMask"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppend",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_priority": "gravityPriority",
        "gravity_priority_var": "gravityPriorityVar",
        "gravity_var": "gravityVar",
        "preserve_minor_dimension": "preserveMinorDimension",
        "preserve_minor_dimension_var": "preserveMinorDimensionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppend:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_priority: typing.Optional[builtins.str] = None,
        gravity_priority_var: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        preserve_minor_dimension: typing.Optional[builtins.str] = None,
        preserve_minor_dimension_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Specifies where to place the ``image`` relative to the source image. The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_priority: Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal. The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority DataAkamaiImagingPolicyImage#gravity_priority}
        :param gravity_priority_var: Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal. The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority_var DataAkamaiImagingPolicyImage#gravity_priority_var}
        :param gravity_var: Specifies where to place the ``image`` relative to the source image. The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param preserve_minor_dimension: Whether to preserve the source image's minor dimension, ``false`` by default. The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension DataAkamaiImagingPolicyImage#preserve_minor_dimension}
        :param preserve_minor_dimension_var: Whether to preserve the source image's minor dimension, ``false`` by default. The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension_var DataAkamaiImagingPolicyImage#preserve_minor_dimension_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__58b8d68ceae0e2c7aa3d5066b2f851177722de1d39190573aa5c9c550084d5d6)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_priority", value=gravity_priority, expected_type=type_hints["gravity_priority"])
            check_type(argname="argument gravity_priority_var", value=gravity_priority_var, expected_type=type_hints["gravity_priority_var"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument preserve_minor_dimension", value=preserve_minor_dimension, expected_type=type_hints["preserve_minor_dimension"])
            check_type(argname="argument preserve_minor_dimension_var", value=preserve_minor_dimension_var, expected_type=type_hints["preserve_minor_dimension_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_priority is not None:
            self._values["gravity_priority"] = gravity_priority
        if gravity_priority_var is not None:
            self._values["gravity_priority_var"] = gravity_priority_var
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if preserve_minor_dimension is not None:
            self._values["preserve_minor_dimension"] = preserve_minor_dimension
        if preserve_minor_dimension_var is not None:
            self._values["preserve_minor_dimension_var"] = preserve_minor_dimension_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Specifies where to place the ``image`` relative to the source image.

        The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_priority(self) -> typing.Optional[builtins.str]:
        '''Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal.

        The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority DataAkamaiImagingPolicyImage#gravity_priority}
        '''
        result = self._values.get("gravity_priority")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_priority_var(self) -> typing.Optional[builtins.str]:
        '''Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal.

        The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority_var DataAkamaiImagingPolicyImage#gravity_priority_var}
        '''
        result = self._values.get("gravity_priority_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Specifies where to place the ``image`` relative to the source image.

        The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def preserve_minor_dimension(self) -> typing.Optional[builtins.str]:
        '''Whether to preserve the source image's minor dimension, ``false`` by default.

        The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension DataAkamaiImagingPolicyImage#preserve_minor_dimension}
        '''
        result = self._values.get("preserve_minor_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def preserve_minor_dimension_var(self) -> typing.Optional[builtins.str]:
        '''Whether to preserve the source image's minor dimension, ``false`` by default.

        The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension_var DataAkamaiImagingPolicyImage#preserve_minor_dimension_var}
        '''
        result = self._values.get("preserve_minor_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppend(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImage",
    jsii_struct_bases=[],
    name_mapping={
        "box_image": "boxImage",
        "circle_image": "circleImage",
        "text_image": "textImage",
        "url_image": "urlImage",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImage:
    def __init__(
        self,
        *,
        box_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageBoxImage", typing.Dict[builtins.str, typing.Any]]]]] = None,
        circle_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageCircleImage", typing.Dict[builtins.str, typing.Any]]]]] = None,
        text_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageTextImage", typing.Dict[builtins.str, typing.Any]]]]] = None,
        url_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageUrlImage", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param box_image: box_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#box_image DataAkamaiImagingPolicyImage#box_image}
        :param circle_image: circle_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#circle_image DataAkamaiImagingPolicyImage#circle_image}
        :param text_image: text_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text_image DataAkamaiImagingPolicyImage#text_image}
        :param url_image: url_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url_image DataAkamaiImagingPolicyImage#url_image}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__485649bf59bd1911b53543c70afe73eb859457b8121c8e0db53d0b54318568b9)
            check_type(argname="argument box_image", value=box_image, expected_type=type_hints["box_image"])
            check_type(argname="argument circle_image", value=circle_image, expected_type=type_hints["circle_image"])
            check_type(argname="argument text_image", value=text_image, expected_type=type_hints["text_image"])
            check_type(argname="argument url_image", value=url_image, expected_type=type_hints["url_image"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if box_image is not None:
            self._values["box_image"] = box_image
        if circle_image is not None:
            self._values["circle_image"] = circle_image
        if text_image is not None:
            self._values["text_image"] = text_image
        if url_image is not None:
            self._values["url_image"] = url_image

    @builtins.property
    def box_image(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageBoxImage"]]]:
        '''box_image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#box_image DataAkamaiImagingPolicyImage#box_image}
        '''
        result = self._values.get("box_image")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageBoxImage"]]], result)

    @builtins.property
    def circle_image(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageCircleImage"]]]:
        '''circle_image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#circle_image DataAkamaiImagingPolicyImage#circle_image}
        '''
        result = self._values.get("circle_image")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageCircleImage"]]], result)

    @builtins.property
    def text_image(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageTextImage"]]]:
        '''text_image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text_image DataAkamaiImagingPolicyImage#text_image}
        '''
        result = self._values.get("text_image")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageTextImage"]]], result)

    @builtins.property
    def url_image(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageUrlImage"]]]:
        '''url_image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url_image DataAkamaiImagingPolicyImage#url_image}
        '''
        result = self._values.get("url_image")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageUrlImage"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageBoxImage",
    jsii_struct_bases=[],
    name_mapping={
        "color": "color",
        "color_var": "colorVar",
        "height": "height",
        "height_var": "heightVar",
        "transformation": "transformation",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageBoxImage:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        transformation: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageBoxImageTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The fill color of the box, not the edge of the box. The API supports hexadecimal representation and CSS hexadecimal color values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The fill color of the box, not the edge of the box. The API supports hexadecimal representation and CSS hexadecimal color values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        :param height: The height of the box in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height of the box in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param transformation: transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        :param width: The width of the box in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width of the box in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(transformation, dict):
            transformation = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageBoxImageTransformation(**transformation)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__867e848258ee775928727567d80022bd7d1042443dd6f159f1af258df67da060)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument transformation", value=transformation, expected_type=type_hints["transformation"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if transformation is not None:
            self._values["transformation"] = transformation
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The fill color of the box, not the edge of the box.

        The API supports hexadecimal representation and CSS hexadecimal color values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The fill color of the box, not the edge of the box.

        The API supports hexadecimal representation and CSS hexadecimal color values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height of the box in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height of the box in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def transformation(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageBoxImageTransformation"]:
        '''transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        '''
        result = self._values.get("transformation")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageBoxImageTransformation"], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width of the box in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width of the box in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageBoxImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageBoxImageList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageBoxImageList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d0b85b12ae022477c98fd0c0b3a38abb992820391481071c2d6850ab49e8215)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageBoxImageOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__46b2d086ec829d455440a04e1a5974f5bbdee9fb48ea8a283362e79bcba010cb)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageBoxImageOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__508d10e912b01ca344175f4ee997fe23049a008a941c2c22c9db9d25d8cf729f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__372e1651bcb25be943bc6b75c63537411621a49bb445b5b879eedf87a29eab71)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e7a71dfd573b0dd535f97280ddf8c19f5f7c901a0b04caf1b4c41d724394fd27)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageBoxImage]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageBoxImage]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageBoxImage]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1e1e7eb114584ed3344a69a3b88769b56cfa9b0736c279e5ed979ec65300b5fe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageBoxImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageBoxImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__063189bb0b1cf7583d72d1d2103ddaa0db84d80598a52ef4eff7e0e8704f5dd4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformation")
    def put_transformation(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageBoxImageTransformation()

        return typing.cast(None, jsii.invoke(self, "putTransformation", [value]))

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetTransformation")
    def reset_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformation", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="transformation")
    def transformation(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageBoxImageTransformationOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageBoxImageTransformationOutputReference", jsii.get(self, "transformation"))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="transformationInput")
    def transformation_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageBoxImageTransformation"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageBoxImageTransformation"], jsii.get(self, "transformationInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab9b7f857d26cdb5328251f3a0ce2e793c74c2c5aefd484310e14d2fae2abb08)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__97baebd78341a63e4dbd9099cc3bc2a6304c13faeb2fd77bf91311205ac62102)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b1375890627c00fc77a6e96f36693221d63d325434991648058df1d267ec4947)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3c4a7ac20ff9524e33a95d6c5185125fc02098acd1826e058cea85ea7d7c6929)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__674ac92722895eb101eb4b318e76e4bdbe9e64dc63f30f62234932e813e3ceda)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c895526ec697f38a66465458f1535d2758ac625e9707659a46b82e6596d86cc1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageBoxImage]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageBoxImage]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageBoxImage]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__773a9da8daf5b317cfde80e4c9df562911a05956476b628d50aaf08aa58ef4b6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageBoxImageTransformation",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageBoxImageTransformation:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageBoxImageTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageBoxImageTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageBoxImageTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af2be35cb6a7c60bbd964e230b0b2f78725a852f52c28b35941a2d5c53207bc9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageBoxImageTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageBoxImageTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageBoxImageTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1072e2d0077fc4282add2d05bad3fae10d6cc483437f82d57a3ef3d77b6b7ab2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageCircleImage",
    jsii_struct_bases=[],
    name_mapping={
        "color": "color",
        "color_var": "colorVar",
        "diameter": "diameter",
        "diameter_var": "diameterVar",
        "transformation": "transformation",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageCircleImage:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
        diameter: typing.Optional[builtins.str] = None,
        diameter_var: typing.Optional[builtins.str] = None,
        transformation: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageCircleImageTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The fill color of the circle. The API supports hexadecimal representation and CSS hexadecimal color values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The fill color of the circle. The API supports hexadecimal representation and CSS hexadecimal color values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        :param diameter: The diameter of the circle. The diameter will be the width and the height of the image in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#diameter DataAkamaiImagingPolicyImage#diameter}
        :param diameter_var: The diameter of the circle. The diameter will be the width and the height of the image in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#diameter_var DataAkamaiImagingPolicyImage#diameter_var}
        :param transformation: transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        :param width: The width of the box in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width of the box in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(transformation, dict):
            transformation = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageCircleImageTransformation(**transformation)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d91480f35601beaf983e38ae064366e5a251188ed88b4b8d218a307869db9bbd)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
            check_type(argname="argument diameter", value=diameter, expected_type=type_hints["diameter"])
            check_type(argname="argument diameter_var", value=diameter_var, expected_type=type_hints["diameter_var"])
            check_type(argname="argument transformation", value=transformation, expected_type=type_hints["transformation"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var
        if diameter is not None:
            self._values["diameter"] = diameter
        if diameter_var is not None:
            self._values["diameter_var"] = diameter_var
        if transformation is not None:
            self._values["transformation"] = transformation
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The fill color of the circle. The API supports hexadecimal representation and CSS hexadecimal color values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The fill color of the circle. The API supports hexadecimal representation and CSS hexadecimal color values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def diameter(self) -> typing.Optional[builtins.str]:
        '''The diameter of the circle. The diameter will be the width and the height of the image in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#diameter DataAkamaiImagingPolicyImage#diameter}
        '''
        result = self._values.get("diameter")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def diameter_var(self) -> typing.Optional[builtins.str]:
        '''The diameter of the circle. The diameter will be the width and the height of the image in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#diameter_var DataAkamaiImagingPolicyImage#diameter_var}
        '''
        result = self._values.get("diameter_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def transformation(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageCircleImageTransformation"]:
        '''transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        '''
        result = self._values.get("transformation")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageCircleImageTransformation"], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width of the box in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width of the box in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageCircleImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageCircleImageList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageCircleImageList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a7f1681d740505c5013377f1a46631b9bf685861409f39647cde4216d3bfead7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageCircleImageOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0369bb25838af1abec991a010810aaf06d124aec152a01fc7fa40c0492446628)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageCircleImageOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b377764b1965f360b0bfa6da7768e86208a0ab5e01b7ab29be3245d222a10dac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ee9dd3039939996ec987535e3bd427882840368dacff771e434b45b21d34c5f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e8820fb9e1cd89a05ef77918cbdc1274aae975f06cf52235240a20897289092f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageCircleImage]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageCircleImage]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageCircleImage]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3e61a7a660d243f603a87a727fddcde9209ec44c1dccb2e3669cd79b484a0f9e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageCircleImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageCircleImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c045a9b176a92c27b698abb618479956cf8d6e1a27dda89e860f7ba863a98618)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformation")
    def put_transformation(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageCircleImageTransformation()

        return typing.cast(None, jsii.invoke(self, "putTransformation", [value]))

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @jsii.member(jsii_name="resetDiameter")
    def reset_diameter(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDiameter", []))

    @jsii.member(jsii_name="resetDiameterVar")
    def reset_diameter_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDiameterVar", []))

    @jsii.member(jsii_name="resetTransformation")
    def reset_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformation", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="transformation")
    def transformation(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageCircleImageTransformationOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageCircleImageTransformationOutputReference", jsii.get(self, "transformation"))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="diameterInput")
    def diameter_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "diameterInput"))

    @builtins.property
    @jsii.member(jsii_name="diameterVarInput")
    def diameter_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "diameterVarInput"))

    @builtins.property
    @jsii.member(jsii_name="transformationInput")
    def transformation_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageCircleImageTransformation"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageCircleImageTransformation"], jsii.get(self, "transformationInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c4bb5dfdcc5bdfc1ee835c560897028d462b08596d0fcf61b6c52e07365a7bd7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a6d4a5b6330ff3dfde189d6c194f9a9ace30f6b6e44dfa24a7c132df9b861310)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="diameter")
    def diameter(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "diameter"))

    @diameter.setter
    def diameter(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b401766e25bdc220f369e9470d78a68ec113e64c1ac11339b67dc4804de4670e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "diameter", value)

    @builtins.property
    @jsii.member(jsii_name="diameterVar")
    def diameter_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "diameterVar"))

    @diameter_var.setter
    def diameter_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2af9fa2bafa9ee38cca9645336770cb18a4bda354520e6a3b462747b2f210da5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "diameterVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__596ab5f6afaea19dc8d84fae53439e126bfde5ed4d15e24239035bd6dff3f3db)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be8a168ed9ce61597f519460268ff7bc4c13adabc3bfa9b49714121f85a769eb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageCircleImage]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageCircleImage]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageCircleImage]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6d2e42918715e3d67d95af8b94175a864a597be6d87fa2fe20426a60f1556816)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageCircleImageTransformation",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageCircleImageTransformation:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageCircleImageTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageCircleImageTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageCircleImageTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__24c523868bf7db6ba069a94460ac4b6af67fc10a6162f40d97504ae40386449f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageCircleImageTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageCircleImageTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageCircleImageTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3080c460cdd0d0690a66c62a3c0b3733d7d3457567956b2d29262e877960cf0d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d9f4238689530b95c606bc0f103312d322aa98a8152bc5921cc5adfe5b40acc1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putBoxImage")
    def put_box_image(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageBoxImage, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8d56d97e0fa38425a4a49d5dd2320d1e530e5d87a30aa9bc626176a82f7f695d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBoxImage", [value]))

    @jsii.member(jsii_name="putCircleImage")
    def put_circle_image(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageCircleImage, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d07fe99bd2a3704b179c8b20ef2a02d79f7390c8c7e7b945f7f1f9d52b8403c2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCircleImage", [value]))

    @jsii.member(jsii_name="putTextImage")
    def put_text_image(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageTextImage", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8f30e0ce9a78a5bdf41a3fb97f99c8061529f63af951107dba30190004f66bc6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTextImage", [value]))

    @jsii.member(jsii_name="putUrlImage")
    def put_url_image(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageUrlImage", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b564b38951ddfa296ec53fd981e4fef4a3943bd9d4bfe47447a8fa96f8b99ff1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putUrlImage", [value]))

    @jsii.member(jsii_name="resetBoxImage")
    def reset_box_image(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBoxImage", []))

    @jsii.member(jsii_name="resetCircleImage")
    def reset_circle_image(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCircleImage", []))

    @jsii.member(jsii_name="resetTextImage")
    def reset_text_image(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTextImage", []))

    @jsii.member(jsii_name="resetUrlImage")
    def reset_url_image(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUrlImage", []))

    @builtins.property
    @jsii.member(jsii_name="boxImage")
    def box_image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageBoxImageList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageBoxImageList, jsii.get(self, "boxImage"))

    @builtins.property
    @jsii.member(jsii_name="circleImage")
    def circle_image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageCircleImageList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageCircleImageList, jsii.get(self, "circleImage"))

    @builtins.property
    @jsii.member(jsii_name="textImage")
    def text_image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageTextImageList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageTextImageList", jsii.get(self, "textImage"))

    @builtins.property
    @jsii.member(jsii_name="urlImage")
    def url_image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageUrlImageList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageUrlImageList", jsii.get(self, "urlImage"))

    @builtins.property
    @jsii.member(jsii_name="boxImageInput")
    def box_image_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageBoxImage]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageBoxImage]]], jsii.get(self, "boxImageInput"))

    @builtins.property
    @jsii.member(jsii_name="circleImageInput")
    def circle_image_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageCircleImage]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageCircleImage]]], jsii.get(self, "circleImageInput"))

    @builtins.property
    @jsii.member(jsii_name="textImageInput")
    def text_image_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageTextImage"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageTextImage"]]], jsii.get(self, "textImageInput"))

    @builtins.property
    @jsii.member(jsii_name="urlImageInput")
    def url_image_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageUrlImage"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageUrlImage"]]], jsii.get(self, "urlImageInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0150553f83799616d5ea2a75e19cf08306f10c959b5120aacc09146289ec2078)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageTextImage",
    jsii_struct_bases=[],
    name_mapping={
        "fill": "fill",
        "fill_var": "fillVar",
        "size": "size",
        "size_var": "sizeVar",
        "stroke": "stroke",
        "stroke_size": "strokeSize",
        "stroke_size_var": "strokeSizeVar",
        "stroke_var": "strokeVar",
        "text": "text",
        "text_var": "textVar",
        "transformation": "transformation",
        "typeface": "typeface",
        "typeface_var": "typefaceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageTextImage:
    def __init__(
        self,
        *,
        fill: typing.Optional[builtins.str] = None,
        fill_var: typing.Optional[builtins.str] = None,
        size: typing.Optional[builtins.str] = None,
        size_var: typing.Optional[builtins.str] = None,
        stroke: typing.Optional[builtins.str] = None,
        stroke_size: typing.Optional[builtins.str] = None,
        stroke_size_var: typing.Optional[builtins.str] = None,
        stroke_var: typing.Optional[builtins.str] = None,
        text: typing.Optional[builtins.str] = None,
        text_var: typing.Optional[builtins.str] = None,
        transformation: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageTextImageTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        typeface: typing.Optional[builtins.str] = None,
        typeface_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fill: The main fill color of the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill DataAkamaiImagingPolicyImage#fill}
        :param fill_var: The main fill color of the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_var DataAkamaiImagingPolicyImage#fill_var}
        :param size: The size in pixels to render the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#size DataAkamaiImagingPolicyImage#size}
        :param size_var: The size in pixels to render the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#size_var DataAkamaiImagingPolicyImage#size_var}
        :param stroke: The color for the outline of the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke DataAkamaiImagingPolicyImage#stroke}
        :param stroke_size: The thickness in points for the outline of the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_size DataAkamaiImagingPolicyImage#stroke_size}
        :param stroke_size_var: The thickness in points for the outline of the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_size_var DataAkamaiImagingPolicyImage#stroke_size_var}
        :param stroke_var: The color for the outline of the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_var DataAkamaiImagingPolicyImage#stroke_var}
        :param text: The line of text to render. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text DataAkamaiImagingPolicyImage#text}
        :param text_var: The line of text to render. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text_var DataAkamaiImagingPolicyImage#text_var}
        :param transformation: transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        :param typeface: The font family to apply to the text image. This may be a URL to a TrueType or WOFF (v1) typeface, or a string that refers to one of the standard built-in browser fonts. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#typeface DataAkamaiImagingPolicyImage#typeface}
        :param typeface_var: The font family to apply to the text image. This may be a URL to a TrueType or WOFF (v1) typeface, or a string that refers to one of the standard built-in browser fonts. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#typeface_var DataAkamaiImagingPolicyImage#typeface_var}
        '''
        if isinstance(transformation, dict):
            transformation = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageTextImageTransformation(**transformation)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b1e5131e73964cd8979fbb4fc4f8accd851c7408cabb5bcd1a9a2877af8c72d7)
            check_type(argname="argument fill", value=fill, expected_type=type_hints["fill"])
            check_type(argname="argument fill_var", value=fill_var, expected_type=type_hints["fill_var"])
            check_type(argname="argument size", value=size, expected_type=type_hints["size"])
            check_type(argname="argument size_var", value=size_var, expected_type=type_hints["size_var"])
            check_type(argname="argument stroke", value=stroke, expected_type=type_hints["stroke"])
            check_type(argname="argument stroke_size", value=stroke_size, expected_type=type_hints["stroke_size"])
            check_type(argname="argument stroke_size_var", value=stroke_size_var, expected_type=type_hints["stroke_size_var"])
            check_type(argname="argument stroke_var", value=stroke_var, expected_type=type_hints["stroke_var"])
            check_type(argname="argument text", value=text, expected_type=type_hints["text"])
            check_type(argname="argument text_var", value=text_var, expected_type=type_hints["text_var"])
            check_type(argname="argument transformation", value=transformation, expected_type=type_hints["transformation"])
            check_type(argname="argument typeface", value=typeface, expected_type=type_hints["typeface"])
            check_type(argname="argument typeface_var", value=typeface_var, expected_type=type_hints["typeface_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fill is not None:
            self._values["fill"] = fill
        if fill_var is not None:
            self._values["fill_var"] = fill_var
        if size is not None:
            self._values["size"] = size
        if size_var is not None:
            self._values["size_var"] = size_var
        if stroke is not None:
            self._values["stroke"] = stroke
        if stroke_size is not None:
            self._values["stroke_size"] = stroke_size
        if stroke_size_var is not None:
            self._values["stroke_size_var"] = stroke_size_var
        if stroke_var is not None:
            self._values["stroke_var"] = stroke_var
        if text is not None:
            self._values["text"] = text
        if text_var is not None:
            self._values["text_var"] = text_var
        if transformation is not None:
            self._values["transformation"] = transformation
        if typeface is not None:
            self._values["typeface"] = typeface
        if typeface_var is not None:
            self._values["typeface_var"] = typeface_var

    @builtins.property
    def fill(self) -> typing.Optional[builtins.str]:
        '''The main fill color of the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill DataAkamaiImagingPolicyImage#fill}
        '''
        result = self._values.get("fill")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fill_var(self) -> typing.Optional[builtins.str]:
        '''The main fill color of the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_var DataAkamaiImagingPolicyImage#fill_var}
        '''
        result = self._values.get("fill_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def size(self) -> typing.Optional[builtins.str]:
        '''The size in pixels to render the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#size DataAkamaiImagingPolicyImage#size}
        '''
        result = self._values.get("size")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def size_var(self) -> typing.Optional[builtins.str]:
        '''The size in pixels to render the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#size_var DataAkamaiImagingPolicyImage#size_var}
        '''
        result = self._values.get("size_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def stroke(self) -> typing.Optional[builtins.str]:
        '''The color for the outline of the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke DataAkamaiImagingPolicyImage#stroke}
        '''
        result = self._values.get("stroke")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def stroke_size(self) -> typing.Optional[builtins.str]:
        '''The thickness in points for the outline of the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_size DataAkamaiImagingPolicyImage#stroke_size}
        '''
        result = self._values.get("stroke_size")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def stroke_size_var(self) -> typing.Optional[builtins.str]:
        '''The thickness in points for the outline of the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_size_var DataAkamaiImagingPolicyImage#stroke_size_var}
        '''
        result = self._values.get("stroke_size_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def stroke_var(self) -> typing.Optional[builtins.str]:
        '''The color for the outline of the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_var DataAkamaiImagingPolicyImage#stroke_var}
        '''
        result = self._values.get("stroke_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def text(self) -> typing.Optional[builtins.str]:
        '''The line of text to render.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text DataAkamaiImagingPolicyImage#text}
        '''
        result = self._values.get("text")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def text_var(self) -> typing.Optional[builtins.str]:
        '''The line of text to render.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text_var DataAkamaiImagingPolicyImage#text_var}
        '''
        result = self._values.get("text_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def transformation(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageTextImageTransformation"]:
        '''transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        '''
        result = self._values.get("transformation")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageTextImageTransformation"], result)

    @builtins.property
    def typeface(self) -> typing.Optional[builtins.str]:
        '''The font family to apply to the text image.

        This may be a URL to a TrueType or WOFF (v1) typeface, or a string that refers to one of the standard built-in browser fonts.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#typeface DataAkamaiImagingPolicyImage#typeface}
        '''
        result = self._values.get("typeface")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def typeface_var(self) -> typing.Optional[builtins.str]:
        '''The font family to apply to the text image.

        This may be a URL to a TrueType or WOFF (v1) typeface, or a string that refers to one of the standard built-in browser fonts.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#typeface_var DataAkamaiImagingPolicyImage#typeface_var}
        '''
        result = self._values.get("typeface_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageTextImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageTextImageList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageTextImageList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f05866aae17b851cbb61956f480b564ea7e201d257f9d7d0a6918a3baebd1e24)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageTextImageOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b18b45b8b68958f9237ce6c24cd933ccda2b55498290a869c36356b4a8365345)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageTextImageOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8dbfbb8acc2fcf65ec1d2849acd6eec7003c15eec00b74fbbcb7f46f46fbf2da)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c6ec047b8f0442d4f0c354119dc0cb0faaf43939698ad82a4758547fad060ca0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__67862584b83ddbbc0b4958829108cc632435fbb727da80da8cecd8c29eed698b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageTextImage]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageTextImage]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageTextImage]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c9f7b6a07306f5a90fde274114f471bb3b8f5efcc960df0f00b0a4b70bd55388)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageTextImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageTextImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aa3ae81b5800bab7f7f0332b1fd32edcd4862ffe340ea7e3280ad2977f24da0e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformation")
    def put_transformation(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageTextImageTransformation()

        return typing.cast(None, jsii.invoke(self, "putTransformation", [value]))

    @jsii.member(jsii_name="resetFill")
    def reset_fill(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFill", []))

    @jsii.member(jsii_name="resetFillVar")
    def reset_fill_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFillVar", []))

    @jsii.member(jsii_name="resetSize")
    def reset_size(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSize", []))

    @jsii.member(jsii_name="resetSizeVar")
    def reset_size_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSizeVar", []))

    @jsii.member(jsii_name="resetStroke")
    def reset_stroke(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStroke", []))

    @jsii.member(jsii_name="resetStrokeSize")
    def reset_stroke_size(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStrokeSize", []))

    @jsii.member(jsii_name="resetStrokeSizeVar")
    def reset_stroke_size_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStrokeSizeVar", []))

    @jsii.member(jsii_name="resetStrokeVar")
    def reset_stroke_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStrokeVar", []))

    @jsii.member(jsii_name="resetText")
    def reset_text(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetText", []))

    @jsii.member(jsii_name="resetTextVar")
    def reset_text_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTextVar", []))

    @jsii.member(jsii_name="resetTransformation")
    def reset_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformation", []))

    @jsii.member(jsii_name="resetTypeface")
    def reset_typeface(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeface", []))

    @jsii.member(jsii_name="resetTypefaceVar")
    def reset_typeface_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypefaceVar", []))

    @builtins.property
    @jsii.member(jsii_name="transformation")
    def transformation(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageTextImageTransformationOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageTextImageTransformationOutputReference", jsii.get(self, "transformation"))

    @builtins.property
    @jsii.member(jsii_name="fillInput")
    def fill_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fillInput"))

    @builtins.property
    @jsii.member(jsii_name="fillVarInput")
    def fill_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fillVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sizeInput")
    def size_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sizeInput"))

    @builtins.property
    @jsii.member(jsii_name="sizeVarInput")
    def size_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sizeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="strokeInput")
    def stroke_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "strokeInput"))

    @builtins.property
    @jsii.member(jsii_name="strokeSizeInput")
    def stroke_size_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "strokeSizeInput"))

    @builtins.property
    @jsii.member(jsii_name="strokeSizeVarInput")
    def stroke_size_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "strokeSizeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="strokeVarInput")
    def stroke_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "strokeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="textInput")
    def text_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "textInput"))

    @builtins.property
    @jsii.member(jsii_name="textVarInput")
    def text_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "textVarInput"))

    @builtins.property
    @jsii.member(jsii_name="transformationInput")
    def transformation_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageTextImageTransformation"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageTextImageTransformation"], jsii.get(self, "transformationInput"))

    @builtins.property
    @jsii.member(jsii_name="typefaceInput")
    def typeface_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typefaceInput"))

    @builtins.property
    @jsii.member(jsii_name="typefaceVarInput")
    def typeface_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typefaceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="fill")
    def fill(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fill"))

    @fill.setter
    def fill(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4c6157083a481865b42e90b139a1ccf74f83f8553a3ab178d0cb4a920ad5856f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fill", value)

    @builtins.property
    @jsii.member(jsii_name="fillVar")
    def fill_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fillVar"))

    @fill_var.setter
    def fill_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__512982faaf3940593abe36616be789777dcca0becaa6a51fc610460c50d2595a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fillVar", value)

    @builtins.property
    @jsii.member(jsii_name="size")
    def size(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "size"))

    @size.setter
    def size(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__92625abae591b29b4a43fedcbac4557ecb02c4ab8f36ab6ed2dd106587ba62b9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "size", value)

    @builtins.property
    @jsii.member(jsii_name="sizeVar")
    def size_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sizeVar"))

    @size_var.setter
    def size_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8b31da39248a40117c2c9b15a8758eabf0e5a0753bce4e7fc517421e1a2d746f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sizeVar", value)

    @builtins.property
    @jsii.member(jsii_name="stroke")
    def stroke(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "stroke"))

    @stroke.setter
    def stroke(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bac653d29788bc8242fe94cf3244df4bae882d829a03e4836e8837e2a08b7d30)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "stroke", value)

    @builtins.property
    @jsii.member(jsii_name="strokeSize")
    def stroke_size(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "strokeSize"))

    @stroke_size.setter
    def stroke_size(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e56da251d969ee7510a43e1b0a1c45d14493d80b253839168a7cd676fec6c4db)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "strokeSize", value)

    @builtins.property
    @jsii.member(jsii_name="strokeSizeVar")
    def stroke_size_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "strokeSizeVar"))

    @stroke_size_var.setter
    def stroke_size_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a84a08e21c0c2be6eb62df6b81ef428f66ea71baa1c5fcc16a9ae286c2b1ed05)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "strokeSizeVar", value)

    @builtins.property
    @jsii.member(jsii_name="strokeVar")
    def stroke_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "strokeVar"))

    @stroke_var.setter
    def stroke_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7bdde6a5ed5618b81c2ed31ade5c2102d928a04a30feaf68c7879fc978f5f870)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "strokeVar", value)

    @builtins.property
    @jsii.member(jsii_name="text")
    def text(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "text"))

    @text.setter
    def text(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__de4af25e46bbe518b46748b8e9737cd51321f1b30038c75275c3db8e82cc5898)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "text", value)

    @builtins.property
    @jsii.member(jsii_name="textVar")
    def text_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "textVar"))

    @text_var.setter
    def text_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e704c06b1646f4bcb76cc8bf1d82d76db0c83a8bcbb8eade7709c16c5ed3ef54)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "textVar", value)

    @builtins.property
    @jsii.member(jsii_name="typeface")
    def typeface(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeface"))

    @typeface.setter
    def typeface(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6881979f0974d54f495199589b4519532e9bf3fd31b77d396def59c5cb652604)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeface", value)

    @builtins.property
    @jsii.member(jsii_name="typefaceVar")
    def typeface_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typefaceVar"))

    @typeface_var.setter
    def typeface_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f07ac0351d2baa6733084b83793db2e5327a1b462996c10cfdef5c81255983df)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typefaceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageTextImage]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageTextImage]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageTextImage]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__65488662abe871bf996f0e948133986ac43e7dbb5e453c133c1cfa33b0506d65)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageTextImageTransformation",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageTextImageTransformation:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageTextImageTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageTextImageTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageTextImageTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4f586cef21b0fc93b1fbbe93960d4fe46105f38ec17848b3700a0536d9687302)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageTextImageTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageTextImageTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageTextImageTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__17cd02e28366b52b2b156730217a1a129eb029cfc099cf93e40ae1b403b4bd53)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageUrlImage",
    jsii_struct_bases=[],
    name_mapping={
        "transformation": "transformation",
        "url": "url",
        "url_var": "urlVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageUrlImage:
    def __init__(
        self,
        *,
        transformation: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageUrlImageTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        url: typing.Optional[builtins.str] = None,
        url_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param transformation: transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        :param url: The URL of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url DataAkamaiImagingPolicyImage#url}
        :param url_var: The URL of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url_var DataAkamaiImagingPolicyImage#url_var}
        '''
        if isinstance(transformation, dict):
            transformation = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageUrlImageTransformation(**transformation)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__05c1822d900d0a636ff3a46462480554573c8953eacf4f51a3cca9fb3128764a)
            check_type(argname="argument transformation", value=transformation, expected_type=type_hints["transformation"])
            check_type(argname="argument url", value=url, expected_type=type_hints["url"])
            check_type(argname="argument url_var", value=url_var, expected_type=type_hints["url_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if transformation is not None:
            self._values["transformation"] = transformation
        if url is not None:
            self._values["url"] = url
        if url_var is not None:
            self._values["url_var"] = url_var

    @builtins.property
    def transformation(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageUrlImageTransformation"]:
        '''transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        '''
        result = self._values.get("transformation")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageUrlImageTransformation"], result)

    @builtins.property
    def url(self) -> typing.Optional[builtins.str]:
        '''The URL of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url DataAkamaiImagingPolicyImage#url}
        '''
        result = self._values.get("url")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def url_var(self) -> typing.Optional[builtins.str]:
        '''The URL of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url_var DataAkamaiImagingPolicyImage#url_var}
        '''
        result = self._values.get("url_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageUrlImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageUrlImageList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageUrlImageList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d7f13da10b86fe8dc2087322fd593be602bb58a4f203a684b7dd8da8194a87ce)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageUrlImageOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f093916a8de9a702825e7aa6f9d38b28a753ede139ca37b33eabccdeb30fc546)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageUrlImageOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__167077b8ff8aeefba1d36bf9528ec1be9a2fe453b496c878fe6fea65e98d02f3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cced31cf7dc66321b56ee3baff433adf2381e4f84f666f9f53e704de3f0833e3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ccf1839a0ad4f61dda892eca594acd0ea154abc3cdfb26a7f2ffabd919b423ea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageUrlImage]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageUrlImage]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageUrlImage]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6380984965b1bd555d5d2a684799f383dabe0935bf7e49f174176bcdab923a15)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageUrlImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageUrlImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__53ed0bfc3144daadabe4c9c38133c221a16e9257a3a2baafadf96465afd8b901)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformation")
    def put_transformation(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageUrlImageTransformation()

        return typing.cast(None, jsii.invoke(self, "putTransformation", [value]))

    @jsii.member(jsii_name="resetTransformation")
    def reset_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformation", []))

    @jsii.member(jsii_name="resetUrl")
    def reset_url(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUrl", []))

    @jsii.member(jsii_name="resetUrlVar")
    def reset_url_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUrlVar", []))

    @builtins.property
    @jsii.member(jsii_name="transformation")
    def transformation(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageUrlImageTransformationOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageUrlImageTransformationOutputReference", jsii.get(self, "transformation"))

    @builtins.property
    @jsii.member(jsii_name="transformationInput")
    def transformation_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageUrlImageTransformation"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageUrlImageTransformation"], jsii.get(self, "transformationInput"))

    @builtins.property
    @jsii.member(jsii_name="urlInput")
    def url_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "urlInput"))

    @builtins.property
    @jsii.member(jsii_name="urlVarInput")
    def url_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "urlVarInput"))

    @builtins.property
    @jsii.member(jsii_name="url")
    def url(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "url"))

    @url.setter
    def url(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d1fd9eaa00958ed25d27637b9e1b2f42e20e59045a91e2ed50846a6ff3d7723e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "url", value)

    @builtins.property
    @jsii.member(jsii_name="urlVar")
    def url_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "urlVar"))

    @url_var.setter
    def url_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1bd78f0971306df501b8241a952ea2fa1523ea88f23f5cced69c4469ba2fb63b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "urlVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageUrlImage]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageUrlImage]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageUrlImage]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0bb740755739e369a1d539863f248877c2a23c529986e68d97865fae49b206d3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageUrlImageTransformation",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageUrlImageTransformation:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageUrlImageTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageUrlImageTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageUrlImageTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__555039e91cfa42c1ff61cf3ac23101a4dd5b8066de2d19e63c66238cf357753b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageUrlImageTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageUrlImageTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageUrlImageTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f223e52d67c3d61ebf15257d5719d46a9bc86c38be12d2cc71b15a3feaa21980)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__02b604154ae3985819f21cac506efefddf9164795b2bc3891c3283bd76af69a6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3240bff910ea9c65ecf40136daecf69f21e3c9cab8d408bcd3056289a7411bc3)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9c6ba871da9d5b232e3aeab7289e73d4fb5c6636055c2d40e7b9fb630cd356fc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fd00c271a6294f9d313615308bf73380bef9aa7b9ec7fc87fa3a85c121fbf3c4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3e281041eda6d60db902bb54f3f7a31a3a80f16115a1a56880d366522853a18a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppend]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppend]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppend]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b7a621af861cda8cf2f751aa1c7ae09532e380e90e336b388acb937e9bda0951)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__76fd0813b6e979c76e3b9c214b444a4cc4e3c3bf175025c33048746854fa6067)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(
        self,
        *,
        box_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageBoxImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
        circle_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageCircleImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
        text_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageTextImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
        url_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageUrlImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param box_image: box_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#box_image DataAkamaiImagingPolicyImage#box_image}
        :param circle_image: circle_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#circle_image DataAkamaiImagingPolicyImage#circle_image}
        :param text_image: text_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text_image DataAkamaiImagingPolicyImage#text_image}
        :param url_image: url_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url_image DataAkamaiImagingPolicyImage#url_image}
        '''
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImage(
            box_image=box_image,
            circle_image=circle_image,
            text_image=text_image,
            url_image=url_image,
        )

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityPriority")
    def reset_gravity_priority(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityPriority", []))

    @jsii.member(jsii_name="resetGravityPriorityVar")
    def reset_gravity_priority_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityPriorityVar", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPreserveMinorDimension")
    def reset_preserve_minor_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPreserveMinorDimension", []))

    @jsii.member(jsii_name="resetPreserveMinorDimensionVar")
    def reset_preserve_minor_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPreserveMinorDimensionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityInput")
    def gravity_priority_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityPriorityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityVarInput")
    def gravity_priority_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityPriorityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionInput")
    def preserve_minor_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "preserveMinorDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionVarInput")
    def preserve_minor_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "preserveMinorDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__57b2d5aff2c0000d2453dec76d6f767f9a5b59ef4526639844ee58c4fb5d6e7b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityPriority")
    def gravity_priority(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityPriority"))

    @gravity_priority.setter
    def gravity_priority(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b8d7fd055d72f992b1c02b57a3b897bd0b96b9fdca2d3c0b1c4fceef8150420b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityPriority", value)

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityVar")
    def gravity_priority_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityPriorityVar"))

    @gravity_priority_var.setter
    def gravity_priority_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4518b00d266d1f2959ea4d6a1ef36a1bce1edac9d69f24162f2ab047ab58e134)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityPriorityVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3c98c2852868e999d955a0ed39b2acb62216860446bf701beb14d35befb3380b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimension")
    def preserve_minor_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "preserveMinorDimension"))

    @preserve_minor_dimension.setter
    def preserve_minor_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c1b7ab7de1884708bf37c0208c72c17778c38c0568dcd6e83a76df798487577c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "preserveMinorDimension", value)

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionVar")
    def preserve_minor_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "preserveMinorDimensionVar"))

    @preserve_minor_dimension_var.setter
    def preserve_minor_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cfec35aa73fd5dc2acb8790688d2d5a66b6802339cd1cbfed72ad7b2fbf3b387)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "preserveMinorDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppend]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppend]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppend]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__471c9caf845a8261aeea90466b77729de174d7cfcce85ffe9c6393367471dc42)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAspectCrop",
    jsii_struct_bases=[],
    name_mapping={
        "allow_expansion": "allowExpansion",
        "allow_expansion_var": "allowExpansionVar",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAspectCrop:
    def __init__(
        self,
        *,
        allow_expansion: typing.Optional[builtins.str] = None,
        allow_expansion_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_expansion: Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image. Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        :param allow_expansion_var: Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image. Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        :param height: The height term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The width term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        :param x_position: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5b8c5d0d2ada91699070c52ba092675dcbe6ce24ae6398a7acfc61bb4b70c5bc)
            check_type(argname="argument allow_expansion", value=allow_expansion, expected_type=type_hints["allow_expansion"])
            check_type(argname="argument allow_expansion_var", value=allow_expansion_var, expected_type=type_hints["allow_expansion_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if allow_expansion is not None:
            self._values["allow_expansion"] = allow_expansion
        if allow_expansion_var is not None:
            self._values["allow_expansion_var"] = allow_expansion_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def allow_expansion(self) -> typing.Optional[builtins.str]:
        '''Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image.

        Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        '''
        result = self._values.get("allow_expansion")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def allow_expansion_var(self) -> typing.Optional[builtins.str]:
        '''Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image.

        Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        '''
        result = self._values.get("allow_expansion_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAspectCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAspectCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAspectCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__868caa5a324cbc0c174519275b73f51a32cb20939e071fc48d61deb6b545740d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAspectCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__45d2fb9174179836bf88a202e4ba8ca911870b5901b289a440f59a10a9a4291e)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAspectCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__de24584e15df8153cae0075a8d09571dd42bb75bd4712f7a57ee56370df3bf1d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__77343bcb9baf0f2821c4686b0a37b243a5cc99cd42088e3c8345f8b2ab90385a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e4e2e842a51e48984cdd3ab3a5cc0f85e86b77505bf2ada93e47c43841d9d1ef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAspectCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAspectCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAspectCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__271d20b08f5cd300501a6ef7768d96ef083ed0247cd7cce162a955b6596a8936)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAspectCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAspectCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__37a3f1f2d7d52c0def405a3225c0ddf0857ec38e28b0639a41b9b2c7c26925ec)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAllowExpansion")
    def reset_allow_expansion(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansion", []))

    @jsii.member(jsii_name="resetAllowExpansionVar")
    def reset_allow_expansion_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansionVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionInput")
    def allow_expansion_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVarInput")
    def allow_expansion_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansion")
    def allow_expansion(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansion"))

    @allow_expansion.setter
    def allow_expansion(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__110c9d6abcb2a40767ceb4313e9609777d97d1aeb2a27ce1dbe52444bb194a4e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansion", value)

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVar")
    def allow_expansion_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansionVar"))

    @allow_expansion_var.setter
    def allow_expansion_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac13a5832a1f4abfcf1cc7d3c4ad2719ad816bbedcfb8738e4e3268c0847bf03)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansionVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f32844407a515202b734de6c9827039fe2df35880d10ccb08b6489d98c4e7f52)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dbc35436f95c4712b5845f31b7c3ded7b1bf3b19db3fb4b11608083234c67787)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa27ecc6f9d4c6da73be9ed341fca089e76eee0cfa2aebb9d50cc17977d88ff3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af075e557042189c39def23893df1b171030d383c6700cc1b4a908bf3175a989)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__63412c91e9df840f610c72292d6805d6b129c08f879aab1720da6553b4627efb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__12161ee77a96ee5f948ae608c0c611a23a7b74a03f58f2643219806b781e6466)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__133c92930fad5e4722ac042f215293ba4be1195fbe837091948822ceecea09c2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f492a28a8148571fcd65dddc1f57e67b82381a3f77c6aa7f1323ff015e5fcee8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAspectCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAspectCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAspectCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8355d3de896b963421fc6788b6f552ddd89efe4ece303422afe9cc714a4211ee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultBackgroundColor",
    jsii_struct_bases=[],
    name_mapping={"color": "color", "color_var": "colorVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultBackgroundColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a344d93aab526a779c089e2fd5debcc3fcad2af873fcedd19db6346cf452835)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultBackgroundColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultBackgroundColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultBackgroundColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__08cfdd99c4001fd75a98bda67400e00e9bf39eef057dd464449154a01dcfe24d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultBackgroundColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__64b540181187bc11a44cf083643de4c11021e58c1deaba08cd60b96b3ea479ad)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultBackgroundColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9e24ce531a78ec572f2aea80a7d565d164a41de272ccb21f1c19348263fcf1e8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__34e62f80919ac5cc08e0e7723032ce4197468698df1b3a7be889a9a21d858684)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6825a041fcc5e1d8a48e3873ab0b427113240e0caf95553f805811b1118541ec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultBackgroundColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultBackgroundColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f3ba2da7d38182ef7cd5a86e74ec5b00055c13ff6771b792dfc7e2a53ae1a62)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultBackgroundColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultBackgroundColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b6204e2d533ed73a06dc51adc6c94c3a082d20a5e7153424328b95ee585559d7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9705bd0a09f2eec10bb6aba6e78804afab73de52b622b73e2b43ab174e6d9097)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__354673e429d2dc9b29ad2b5fcb1d959635ab6850458a9129bb5ded9fbb654f3c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultBackgroundColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultBackgroundColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultBackgroundColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d796b38cbf821133bdcb2be021dc69cb36c68df1c118b653476aa80e208e1c76)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultBlur",
    jsii_struct_bases=[],
    name_mapping={"sigma": "sigma", "sigma_var": "sigmaVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultBlur:
    def __init__(
        self,
        *,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param sigma: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__96281f592b2421fd8174ac8ca0ffcdbef4d3ea4572e08baa00c0d2330333e1c3)
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultBlur(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultBlurList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultBlurList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fb75a5d4a0fabda40cc855e194128f1382a2345a035b62b73ff75b41a418e871)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultBlurOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b948ed31c01dab403274631b2b45086b600fee367d537db49924e4e5d8094b52)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultBlurOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0c9d0b80a70cc17f27423e6cb9116474e3c0da580c11af87e7cc41a273291df8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__673e75d7472aa2b89bddea8fc3fd619cf0fd1b960e2e1e3bd10bee996f5060fc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__062cbb6749e2946919e4f5b531bd2f3fed6b2793e8470e49aedb978ac3c098b9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultBlur]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultBlur]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ece0abfe320f14fb9ced03cb1ddbbece1b4046bd06f27b4e904dff457eeecdc1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultBlurOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultBlurOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8f50c6b5ec4a3009a76efc2ed9896c4827eb1a2babf50de8ede18e97ece6df15)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dc79c1e2b99b50fdea5b499f752eb2a8aabba483b099df293003437a019f0fca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8005af9a09677b1d0bbb7a44838514790d60e7cc280569e30ca32cba194e1ec7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultBlur]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultBlur]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultBlur]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cf5aaf9e55dc1746af0b606fae6608ffbefd75266eba03279b8fb3c0f9c27ed5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultChromaKey",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_feather": "hueFeather",
        "hue_feather_var": "hueFeatherVar",
        "hue_tolerance": "hueTolerance",
        "hue_tolerance_var": "hueToleranceVar",
        "hue_var": "hueVar",
        "lightness_feather": "lightnessFeather",
        "lightness_feather_var": "lightnessFeatherVar",
        "lightness_tolerance": "lightnessTolerance",
        "lightness_tolerance_var": "lightnessToleranceVar",
        "saturation_feather": "saturationFeather",
        "saturation_feather_var": "saturationFeatherVar",
        "saturation_tolerance": "saturationTolerance",
        "saturation_tolerance_var": "saturationToleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultChromaKey:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_feather: typing.Optional[builtins.str] = None,
        hue_feather_var: typing.Optional[builtins.str] = None,
        hue_tolerance: typing.Optional[builtins.str] = None,
        hue_tolerance_var: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness_feather: typing.Optional[builtins.str] = None,
        lightness_feather_var: typing.Optional[builtins.str] = None,
        lightness_tolerance: typing.Optional[builtins.str] = None,
        lightness_tolerance_var: typing.Optional[builtins.str] = None,
        saturation_feather: typing.Optional[builtins.str] = None,
        saturation_feather_var: typing.Optional[builtins.str] = None,
        saturation_tolerance: typing.Optional[builtins.str] = None,
        saturation_tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_feather: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        :param hue_feather_var: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        :param hue_tolerance: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        :param hue_tolerance_var: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        :param hue_var: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness_feather: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        :param lightness_feather_var: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        :param lightness_tolerance: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        :param lightness_tolerance_var: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        :param saturation_feather: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        :param saturation_feather_var: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        :param saturation_tolerance: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        :param saturation_tolerance_var: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b9207fdbfe9d57521d09d922cc84bfa00ba9d84e41346119a9e6ddbe2adf9aed)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_feather", value=hue_feather, expected_type=type_hints["hue_feather"])
            check_type(argname="argument hue_feather_var", value=hue_feather_var, expected_type=type_hints["hue_feather_var"])
            check_type(argname="argument hue_tolerance", value=hue_tolerance, expected_type=type_hints["hue_tolerance"])
            check_type(argname="argument hue_tolerance_var", value=hue_tolerance_var, expected_type=type_hints["hue_tolerance_var"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness_feather", value=lightness_feather, expected_type=type_hints["lightness_feather"])
            check_type(argname="argument lightness_feather_var", value=lightness_feather_var, expected_type=type_hints["lightness_feather_var"])
            check_type(argname="argument lightness_tolerance", value=lightness_tolerance, expected_type=type_hints["lightness_tolerance"])
            check_type(argname="argument lightness_tolerance_var", value=lightness_tolerance_var, expected_type=type_hints["lightness_tolerance_var"])
            check_type(argname="argument saturation_feather", value=saturation_feather, expected_type=type_hints["saturation_feather"])
            check_type(argname="argument saturation_feather_var", value=saturation_feather_var, expected_type=type_hints["saturation_feather_var"])
            check_type(argname="argument saturation_tolerance", value=saturation_tolerance, expected_type=type_hints["saturation_tolerance"])
            check_type(argname="argument saturation_tolerance_var", value=saturation_tolerance_var, expected_type=type_hints["saturation_tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_feather is not None:
            self._values["hue_feather"] = hue_feather
        if hue_feather_var is not None:
            self._values["hue_feather_var"] = hue_feather_var
        if hue_tolerance is not None:
            self._values["hue_tolerance"] = hue_tolerance
        if hue_tolerance_var is not None:
            self._values["hue_tolerance_var"] = hue_tolerance_var
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness_feather is not None:
            self._values["lightness_feather"] = lightness_feather
        if lightness_feather_var is not None:
            self._values["lightness_feather_var"] = lightness_feather_var
        if lightness_tolerance is not None:
            self._values["lightness_tolerance"] = lightness_tolerance
        if lightness_tolerance_var is not None:
            self._values["lightness_tolerance_var"] = lightness_tolerance_var
        if saturation_feather is not None:
            self._values["saturation_feather"] = saturation_feather
        if saturation_feather_var is not None:
            self._values["saturation_feather_var"] = saturation_feather_var
        if saturation_tolerance is not None:
            self._values["saturation_tolerance"] = saturation_tolerance
        if saturation_tolerance_var is not None:
            self._values["saturation_tolerance_var"] = saturation_tolerance_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        '''
        result = self._values.get("hue_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        '''
        result = self._values.get("hue_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        '''
        result = self._values.get("hue_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        '''
        result = self._values.get("hue_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        '''
        result = self._values.get("lightness_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        '''
        result = self._values.get("lightness_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        '''
        result = self._values.get("lightness_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        '''
        result = self._values.get("lightness_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        '''
        result = self._values.get("saturation_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        '''
        result = self._values.get("saturation_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        '''
        result = self._values.get("saturation_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        result = self._values.get("saturation_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultChromaKey(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultChromaKeyList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultChromaKeyList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2e9e61398ae349cbf0c64186a2ee3730afece8eb960b4763ba71f1738274a121)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultChromaKeyOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6c09254ae5de76a7af740dcb97ae717b4e00b064000c467c04ee377415c80ed9)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultChromaKeyOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f110c738143ff5e5f8d638b7a6fe15c4fc719bea2dda8949031e2b8d21564592)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0dd6971fb5296e4b4948be2aed6c384b091b4eaa593f4e75c933db0e9526d8d5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a0dd39145b507404eda2084b954abc47e49e15643a328f61f8cac72b260a2d1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultChromaKey]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultChromaKey]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2f9981fdc5c8ddb830df50d2c1be2e4b5ba43b0d4d4683036210d50a1a74444e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultChromaKeyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultChromaKeyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6acc7a0e257abd9d9499754377dfef8d686df4288cd6b14b3de1e6765b29161c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueFeather")
    def reset_hue_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeather", []))

    @jsii.member(jsii_name="resetHueFeatherVar")
    def reset_hue_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeatherVar", []))

    @jsii.member(jsii_name="resetHueTolerance")
    def reset_hue_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueTolerance", []))

    @jsii.member(jsii_name="resetHueToleranceVar")
    def reset_hue_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueToleranceVar", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightnessFeather")
    def reset_lightness_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeather", []))

    @jsii.member(jsii_name="resetLightnessFeatherVar")
    def reset_lightness_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeatherVar", []))

    @jsii.member(jsii_name="resetLightnessTolerance")
    def reset_lightness_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessTolerance", []))

    @jsii.member(jsii_name="resetLightnessToleranceVar")
    def reset_lightness_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessToleranceVar", []))

    @jsii.member(jsii_name="resetSaturationFeather")
    def reset_saturation_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeather", []))

    @jsii.member(jsii_name="resetSaturationFeatherVar")
    def reset_saturation_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeatherVar", []))

    @jsii.member(jsii_name="resetSaturationTolerance")
    def reset_saturation_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationTolerance", []))

    @jsii.member(jsii_name="resetSaturationToleranceVar")
    def reset_saturation_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherInput")
    def hue_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVarInput")
    def hue_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceInput")
    def hue_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVarInput")
    def hue_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherInput")
    def lightness_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVarInput")
    def lightness_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceInput")
    def lightness_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVarInput")
    def lightness_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherInput")
    def saturation_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVarInput")
    def saturation_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceInput")
    def saturation_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVarInput")
    def saturation_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a3c8dd20b6e5d2780525ebd2e4ee8b6f170b55e52aa6d8e8dab01f27baf090ec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeather")
    def hue_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeather"))

    @hue_feather.setter
    def hue_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1ea39248ac8e02203d58197319ce268fd79624f666e308a61dd215192d2de2a2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeather", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVar")
    def hue_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeatherVar"))

    @hue_feather_var.setter
    def hue_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__81f07cd9ece8b4ae4db8995042c78d666508479452bb6d24af5e65d627832f48)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueTolerance")
    def hue_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueTolerance"))

    @hue_tolerance.setter
    def hue_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e9466a572cf747649d50c884a8ce538ac08314de24ae3dbe0f3dc134e161cccf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVar")
    def hue_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueToleranceVar"))

    @hue_tolerance_var.setter
    def hue_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__88677b5ee952dc5130f7b6fabb0d3047e687a35fb9eb9687d6386ee23195feb7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d144a7204559fcd867504eeaf675af55878e8b0df0336e06deb027b710b6673b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeather")
    def lightness_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeather"))

    @lightness_feather.setter
    def lightness_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5e2d83a14568ede867753a88dbcd4af74e3982035b7f88885a68dba63f51e7d5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeather", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVar")
    def lightness_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeatherVar"))

    @lightness_feather_var.setter
    def lightness_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8e2a4c055960d6418fe060cfa11372b9edf54c794599323ea17baa665ded4876)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessTolerance")
    def lightness_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessTolerance"))

    @lightness_tolerance.setter
    def lightness_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__54be8886afed7630ae4767d776db0427cbbb69b96a17a280dc7f5a1b2f751828)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVar")
    def lightness_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessToleranceVar"))

    @lightness_tolerance_var.setter
    def lightness_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ce13628ef34f861a820ef2b6c5b6478988f895a356668a279243e0da2865681)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeather")
    def saturation_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeather"))

    @saturation_feather.setter
    def saturation_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a2184b4e79d2452871385f8b3240010c95190d5b1d9e3b3a3b45b009e5b0b70)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeather", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVar")
    def saturation_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeatherVar"))

    @saturation_feather_var.setter
    def saturation_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c231ad3a75a2b8b4e74a608451a27c7f22368914e2462abee8acdaef106bbdb6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationTolerance")
    def saturation_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationTolerance"))

    @saturation_tolerance.setter
    def saturation_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__89411b37604a00aefbf4c46327aee07bce9f74a5bb66f44c1ec9675f36783429)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVar")
    def saturation_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationToleranceVar"))

    @saturation_tolerance_var.setter
    def saturation_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__75accd146405d4b3dcb7b358bbb45853812e858f35f8fa2bec21b65c415a688a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultChromaKey]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultChromaKey]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultChromaKey]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3136ecbaf4f2382d9d5bfefed4ff7fd1a596752efe6572bfec4d1b46115a576f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultComposite",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "placement": "placement",
        "placement_var": "placementVar",
        "scale": "scale",
        "scale_dimension": "scaleDimension",
        "scale_dimension_var": "scaleDimensionVar",
        "scale_var": "scaleVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultComposite:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        placement: typing.Optional[builtins.str] = None,
        placement_var: typing.Optional[builtins.str] = None,
        scale: typing.Optional[builtins.str] = None,
        scale_dimension: typing.Optional[builtins.str] = None,
        scale_dimension_var: typing.Optional[builtins.str] = None,
        scale_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param placement: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        :param placement_var: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        :param scale: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param scale_dimension: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        :param scale_dimension_var: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        :param scale_var: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        :param x_position: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__77b121bb89ee564604f9ad8bb0df393692d344cb4d7efe6848ad57e63b393cc5)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument placement", value=placement, expected_type=type_hints["placement"])
            check_type(argname="argument placement_var", value=placement_var, expected_type=type_hints["placement_var"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument scale_dimension", value=scale_dimension, expected_type=type_hints["scale_dimension"])
            check_type(argname="argument scale_dimension_var", value=scale_dimension_var, expected_type=type_hints["scale_dimension_var"])
            check_type(argname="argument scale_var", value=scale_var, expected_type=type_hints["scale_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if placement is not None:
            self._values["placement"] = placement
        if placement_var is not None:
            self._values["placement_var"] = placement_var
        if scale is not None:
            self._values["scale"] = scale
        if scale_dimension is not None:
            self._values["scale_dimension"] = scale_dimension
        if scale_dimension_var is not None:
            self._values["scale_dimension_var"] = scale_dimension_var
        if scale_var is not None:
            self._values["scale_var"] = scale_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        '''
        result = self._values.get("placement")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement_var(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        '''
        result = self._values.get("placement_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        '''
        result = self._values.get("scale_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        '''
        result = self._values.get("scale_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        '''
        result = self._values.get("scale_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultComposite(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImage",
    jsii_struct_bases=[],
    name_mapping={
        "box_image": "boxImage",
        "circle_image": "circleImage",
        "text_image": "textImage",
        "url_image": "urlImage",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImage:
    def __init__(
        self,
        *,
        box_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageBoxImage", typing.Dict[builtins.str, typing.Any]]]]] = None,
        circle_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageCircleImage", typing.Dict[builtins.str, typing.Any]]]]] = None,
        text_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageTextImage", typing.Dict[builtins.str, typing.Any]]]]] = None,
        url_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageUrlImage", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param box_image: box_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#box_image DataAkamaiImagingPolicyImage#box_image}
        :param circle_image: circle_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#circle_image DataAkamaiImagingPolicyImage#circle_image}
        :param text_image: text_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text_image DataAkamaiImagingPolicyImage#text_image}
        :param url_image: url_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url_image DataAkamaiImagingPolicyImage#url_image}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__49e49b7a919a74d63bbb358ba960fcb49cb05493464c190463115c1b7a786e2a)
            check_type(argname="argument box_image", value=box_image, expected_type=type_hints["box_image"])
            check_type(argname="argument circle_image", value=circle_image, expected_type=type_hints["circle_image"])
            check_type(argname="argument text_image", value=text_image, expected_type=type_hints["text_image"])
            check_type(argname="argument url_image", value=url_image, expected_type=type_hints["url_image"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if box_image is not None:
            self._values["box_image"] = box_image
        if circle_image is not None:
            self._values["circle_image"] = circle_image
        if text_image is not None:
            self._values["text_image"] = text_image
        if url_image is not None:
            self._values["url_image"] = url_image

    @builtins.property
    def box_image(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageBoxImage"]]]:
        '''box_image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#box_image DataAkamaiImagingPolicyImage#box_image}
        '''
        result = self._values.get("box_image")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageBoxImage"]]], result)

    @builtins.property
    def circle_image(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageCircleImage"]]]:
        '''circle_image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#circle_image DataAkamaiImagingPolicyImage#circle_image}
        '''
        result = self._values.get("circle_image")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageCircleImage"]]], result)

    @builtins.property
    def text_image(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageTextImage"]]]:
        '''text_image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text_image DataAkamaiImagingPolicyImage#text_image}
        '''
        result = self._values.get("text_image")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageTextImage"]]], result)

    @builtins.property
    def url_image(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageUrlImage"]]]:
        '''url_image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url_image DataAkamaiImagingPolicyImage#url_image}
        '''
        result = self._values.get("url_image")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageUrlImage"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageBoxImage",
    jsii_struct_bases=[],
    name_mapping={
        "color": "color",
        "color_var": "colorVar",
        "height": "height",
        "height_var": "heightVar",
        "transformation": "transformation",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageBoxImage:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        transformation: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageBoxImageTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The fill color of the box, not the edge of the box. The API supports hexadecimal representation and CSS hexadecimal color values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The fill color of the box, not the edge of the box. The API supports hexadecimal representation and CSS hexadecimal color values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        :param height: The height of the box in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height of the box in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param transformation: transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        :param width: The width of the box in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width of the box in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(transformation, dict):
            transformation = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageBoxImageTransformation(**transformation)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f0471f097a26856e49bb132e774ed041e8b65a49eab4be23d5334d12a278c9d5)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument transformation", value=transformation, expected_type=type_hints["transformation"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if transformation is not None:
            self._values["transformation"] = transformation
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The fill color of the box, not the edge of the box.

        The API supports hexadecimal representation and CSS hexadecimal color values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The fill color of the box, not the edge of the box.

        The API supports hexadecimal representation and CSS hexadecimal color values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height of the box in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height of the box in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def transformation(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageBoxImageTransformation"]:
        '''transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        '''
        result = self._values.get("transformation")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageBoxImageTransformation"], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width of the box in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width of the box in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageBoxImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageBoxImageList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageBoxImageList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__46c8798cbaee8c680b49ad92f271f0f5af4510ace93bbce652d64508151e5e70)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageBoxImageOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f4eff886245cf576d9e7daafb1db7ad1d5ce8495ee64c31bfe8f97f754ef72be)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageBoxImageOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__678d98873896f5d9c913f2ceaababae303a0f9ccd223f0ee3d2bc29f6e57a0c3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8de56f8583c4a77d85b4bc75a51d66c584a56362a40f11ec61d9fc56ca459b41)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__09f506c9b593d6c0025b90ad11dfb9489175939824ff165e48965a8d399252f4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageBoxImage]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageBoxImage]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageBoxImage]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dceb6ae6fce5ac4260563d9210281f86786e999c4c96603108705025a6c71c51)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageBoxImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageBoxImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d28a9e86bfc3ac5adf5c4758191c7f0f00dec9aa1964e9bd713ab3633f935bd5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformation")
    def put_transformation(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageBoxImageTransformation()

        return typing.cast(None, jsii.invoke(self, "putTransformation", [value]))

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetTransformation")
    def reset_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformation", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="transformation")
    def transformation(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageBoxImageTransformationOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageBoxImageTransformationOutputReference", jsii.get(self, "transformation"))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="transformationInput")
    def transformation_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageBoxImageTransformation"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageBoxImageTransformation"], jsii.get(self, "transformationInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3bb38b68e5e3b07d2fda7388190dc1cecd69e69d3832adb1420160b364286d1f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e6ca81523c4418e0af5041b2243fe349bffc2b20ecc5e4897dc8fb714cfbdb81)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c35518b8e8e7a4c2fd1e7f7a0add3e491d1936692692928198793ee39cd0c736)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0e06adc237509d54ed8f9b1099562f3274979b4d2d7780c87de7995337f2346a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f9482c601eeb0dee1ee92cf9707ef5ad2bd5a5df6b4a0fe8f7c8e59d808b8587)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bef4e3e96f7e4d0c2585e7d00f37ea2d9fe758167a77fdf05a7a2cf613cf3e52)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageBoxImage]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageBoxImage]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageBoxImage]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a6cab00d0436645a17be8af45377119f6912a3987147f82eb69e7640c297b1a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageBoxImageTransformation",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageBoxImageTransformation:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageBoxImageTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageBoxImageTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageBoxImageTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e22e44583bc06bbd98968bf8a3f56621b99b61d45bcdf6425af44b0b1ea3033d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageBoxImageTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageBoxImageTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageBoxImageTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0d7f84ba917a99eb861800f1430524327f20f9a4d8110ef52cfb67f25c7ddf7c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageCircleImage",
    jsii_struct_bases=[],
    name_mapping={
        "color": "color",
        "color_var": "colorVar",
        "diameter": "diameter",
        "diameter_var": "diameterVar",
        "transformation": "transformation",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageCircleImage:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
        diameter: typing.Optional[builtins.str] = None,
        diameter_var: typing.Optional[builtins.str] = None,
        transformation: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageCircleImageTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The fill color of the circle. The API supports hexadecimal representation and CSS hexadecimal color values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The fill color of the circle. The API supports hexadecimal representation and CSS hexadecimal color values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        :param diameter: The diameter of the circle. The diameter will be the width and the height of the image in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#diameter DataAkamaiImagingPolicyImage#diameter}
        :param diameter_var: The diameter of the circle. The diameter will be the width and the height of the image in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#diameter_var DataAkamaiImagingPolicyImage#diameter_var}
        :param transformation: transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        :param width: The width of the box in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width of the box in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(transformation, dict):
            transformation = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageCircleImageTransformation(**transformation)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__efb876d2c50e9cfbb132d83dc2008c874ea7e81714bc7b95a854c195366aa154)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
            check_type(argname="argument diameter", value=diameter, expected_type=type_hints["diameter"])
            check_type(argname="argument diameter_var", value=diameter_var, expected_type=type_hints["diameter_var"])
            check_type(argname="argument transformation", value=transformation, expected_type=type_hints["transformation"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var
        if diameter is not None:
            self._values["diameter"] = diameter
        if diameter_var is not None:
            self._values["diameter_var"] = diameter_var
        if transformation is not None:
            self._values["transformation"] = transformation
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The fill color of the circle. The API supports hexadecimal representation and CSS hexadecimal color values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The fill color of the circle. The API supports hexadecimal representation and CSS hexadecimal color values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def diameter(self) -> typing.Optional[builtins.str]:
        '''The diameter of the circle. The diameter will be the width and the height of the image in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#diameter DataAkamaiImagingPolicyImage#diameter}
        '''
        result = self._values.get("diameter")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def diameter_var(self) -> typing.Optional[builtins.str]:
        '''The diameter of the circle. The diameter will be the width and the height of the image in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#diameter_var DataAkamaiImagingPolicyImage#diameter_var}
        '''
        result = self._values.get("diameter_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def transformation(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageCircleImageTransformation"]:
        '''transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        '''
        result = self._values.get("transformation")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageCircleImageTransformation"], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width of the box in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width of the box in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageCircleImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageCircleImageList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageCircleImageList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab3718eef9faf23e2e8738976313365b823bab56fecf460864e1976d293c87eb)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageCircleImageOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6cb38a59f094828eb106346480f0a31d2402c12059f5d3163d06463d58171cdf)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageCircleImageOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7e122fd0c70bd30b04d1711e56fd099f7a518931f9e6eef80f30acadf805f381)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__76382d8ef343a98c9be9ebb1d9307f80abc45bba772bff6c37804e5b9ea71268)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7e2a9813df89c11961cbaf520e260c4ea8d58685f2d90fb90217684fbcdc354f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageCircleImage]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageCircleImage]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageCircleImage]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4847f73f7bdb6bedc1044a70039f4f403eac5de4a2c8b947020ef3f4a8215e72)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageCircleImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageCircleImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0cec26377ced672c7e66ef0403996748695ac961ad5d249db6f4cc36bbd56d45)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformation")
    def put_transformation(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageCircleImageTransformation()

        return typing.cast(None, jsii.invoke(self, "putTransformation", [value]))

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @jsii.member(jsii_name="resetDiameter")
    def reset_diameter(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDiameter", []))

    @jsii.member(jsii_name="resetDiameterVar")
    def reset_diameter_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDiameterVar", []))

    @jsii.member(jsii_name="resetTransformation")
    def reset_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformation", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="transformation")
    def transformation(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageCircleImageTransformationOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageCircleImageTransformationOutputReference", jsii.get(self, "transformation"))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="diameterInput")
    def diameter_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "diameterInput"))

    @builtins.property
    @jsii.member(jsii_name="diameterVarInput")
    def diameter_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "diameterVarInput"))

    @builtins.property
    @jsii.member(jsii_name="transformationInput")
    def transformation_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageCircleImageTransformation"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageCircleImageTransformation"], jsii.get(self, "transformationInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__53c49c4e1d7568c137f9bea729d497034e1219176101e52e9cd19e177f6d555f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__762488e36918497ad3c6cbda175c5060eb82438ae1911efb96c73b1392bc7fa6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="diameter")
    def diameter(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "diameter"))

    @diameter.setter
    def diameter(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3e963ada675ae2c4318bbf7c9446555d4e3a0e5d52428ac5bd3a53dd135c2acc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "diameter", value)

    @builtins.property
    @jsii.member(jsii_name="diameterVar")
    def diameter_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "diameterVar"))

    @diameter_var.setter
    def diameter_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b8e164d09f210465fa5bcee4795b401ac2055cfd91a19bd71069271752c3b4ff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "diameterVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a71064dadc1ecab31c38870d3e3a19c34f2113f7e9056ba56b9a4389c4f1dd5d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1a7ffca4b6ce3baebf8198323e19ee5b4f33e336a3fc85bb706072e2fcff5af2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageCircleImage]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageCircleImage]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageCircleImage]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__138d5b73623b055511ae4ee48f8b20f2bed62b3e5b04bb89cb28d71a792a4a8d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageCircleImageTransformation",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageCircleImageTransformation:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageCircleImageTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageCircleImageTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageCircleImageTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d51ff5b736fdf8a84725899d5757b12d0a6d32ae7ea24b9a806a30cfaf181de)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageCircleImageTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageCircleImageTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageCircleImageTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fac0e8401e4132e5c5dfc4ab3916a7d3aa514affc623b467c357e5a0dc717071)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8db6b832565bd72a4e4651061812a5fc7a7d59731a18bd2834596ae126f8f90a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putBoxImage")
    def put_box_image(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageBoxImage, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__53a4e7965db444a120051af520877986499b7d225260f76eed5051bb09cc7a1d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBoxImage", [value]))

    @jsii.member(jsii_name="putCircleImage")
    def put_circle_image(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageCircleImage, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__43011235bc0b400e7776b3cac9ba28eec0f483fd0e0c26aee95347974d5f93ad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCircleImage", [value]))

    @jsii.member(jsii_name="putTextImage")
    def put_text_image(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageTextImage", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c9c6af80190b36d82eb5e6e91a2e911a12e206b3e46bb74092e9d3ee81fcbbdc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTextImage", [value]))

    @jsii.member(jsii_name="putUrlImage")
    def put_url_image(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageUrlImage", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__88b6657cc0e0cdba13789b1d747ccdce4ef51e0779ccf4e037534a039790ceea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putUrlImage", [value]))

    @jsii.member(jsii_name="resetBoxImage")
    def reset_box_image(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBoxImage", []))

    @jsii.member(jsii_name="resetCircleImage")
    def reset_circle_image(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCircleImage", []))

    @jsii.member(jsii_name="resetTextImage")
    def reset_text_image(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTextImage", []))

    @jsii.member(jsii_name="resetUrlImage")
    def reset_url_image(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUrlImage", []))

    @builtins.property
    @jsii.member(jsii_name="boxImage")
    def box_image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageBoxImageList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageBoxImageList, jsii.get(self, "boxImage"))

    @builtins.property
    @jsii.member(jsii_name="circleImage")
    def circle_image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageCircleImageList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageCircleImageList, jsii.get(self, "circleImage"))

    @builtins.property
    @jsii.member(jsii_name="textImage")
    def text_image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageTextImageList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageTextImageList", jsii.get(self, "textImage"))

    @builtins.property
    @jsii.member(jsii_name="urlImage")
    def url_image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageUrlImageList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageUrlImageList", jsii.get(self, "urlImage"))

    @builtins.property
    @jsii.member(jsii_name="boxImageInput")
    def box_image_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageBoxImage]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageBoxImage]]], jsii.get(self, "boxImageInput"))

    @builtins.property
    @jsii.member(jsii_name="circleImageInput")
    def circle_image_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageCircleImage]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageCircleImage]]], jsii.get(self, "circleImageInput"))

    @builtins.property
    @jsii.member(jsii_name="textImageInput")
    def text_image_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageTextImage"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageTextImage"]]], jsii.get(self, "textImageInput"))

    @builtins.property
    @jsii.member(jsii_name="urlImageInput")
    def url_image_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageUrlImage"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageUrlImage"]]], jsii.get(self, "urlImageInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__25123d4b4c0a3e3fa1c1e675a400a38db85bb0b612270f223ae1d79ab334f2e8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageTextImage",
    jsii_struct_bases=[],
    name_mapping={
        "fill": "fill",
        "fill_var": "fillVar",
        "size": "size",
        "size_var": "sizeVar",
        "stroke": "stroke",
        "stroke_size": "strokeSize",
        "stroke_size_var": "strokeSizeVar",
        "stroke_var": "strokeVar",
        "text": "text",
        "text_var": "textVar",
        "transformation": "transformation",
        "typeface": "typeface",
        "typeface_var": "typefaceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageTextImage:
    def __init__(
        self,
        *,
        fill: typing.Optional[builtins.str] = None,
        fill_var: typing.Optional[builtins.str] = None,
        size: typing.Optional[builtins.str] = None,
        size_var: typing.Optional[builtins.str] = None,
        stroke: typing.Optional[builtins.str] = None,
        stroke_size: typing.Optional[builtins.str] = None,
        stroke_size_var: typing.Optional[builtins.str] = None,
        stroke_var: typing.Optional[builtins.str] = None,
        text: typing.Optional[builtins.str] = None,
        text_var: typing.Optional[builtins.str] = None,
        transformation: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageTextImageTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        typeface: typing.Optional[builtins.str] = None,
        typeface_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fill: The main fill color of the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill DataAkamaiImagingPolicyImage#fill}
        :param fill_var: The main fill color of the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_var DataAkamaiImagingPolicyImage#fill_var}
        :param size: The size in pixels to render the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#size DataAkamaiImagingPolicyImage#size}
        :param size_var: The size in pixels to render the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#size_var DataAkamaiImagingPolicyImage#size_var}
        :param stroke: The color for the outline of the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke DataAkamaiImagingPolicyImage#stroke}
        :param stroke_size: The thickness in points for the outline of the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_size DataAkamaiImagingPolicyImage#stroke_size}
        :param stroke_size_var: The thickness in points for the outline of the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_size_var DataAkamaiImagingPolicyImage#stroke_size_var}
        :param stroke_var: The color for the outline of the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_var DataAkamaiImagingPolicyImage#stroke_var}
        :param text: The line of text to render. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text DataAkamaiImagingPolicyImage#text}
        :param text_var: The line of text to render. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text_var DataAkamaiImagingPolicyImage#text_var}
        :param transformation: transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        :param typeface: The font family to apply to the text image. This may be a URL to a TrueType or WOFF (v1) typeface, or a string that refers to one of the standard built-in browser fonts. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#typeface DataAkamaiImagingPolicyImage#typeface}
        :param typeface_var: The font family to apply to the text image. This may be a URL to a TrueType or WOFF (v1) typeface, or a string that refers to one of the standard built-in browser fonts. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#typeface_var DataAkamaiImagingPolicyImage#typeface_var}
        '''
        if isinstance(transformation, dict):
            transformation = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageTextImageTransformation(**transformation)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f37341e9b21a40a4025ad23ceb2967bd191f045ceb629b3128874409bc23e884)
            check_type(argname="argument fill", value=fill, expected_type=type_hints["fill"])
            check_type(argname="argument fill_var", value=fill_var, expected_type=type_hints["fill_var"])
            check_type(argname="argument size", value=size, expected_type=type_hints["size"])
            check_type(argname="argument size_var", value=size_var, expected_type=type_hints["size_var"])
            check_type(argname="argument stroke", value=stroke, expected_type=type_hints["stroke"])
            check_type(argname="argument stroke_size", value=stroke_size, expected_type=type_hints["stroke_size"])
            check_type(argname="argument stroke_size_var", value=stroke_size_var, expected_type=type_hints["stroke_size_var"])
            check_type(argname="argument stroke_var", value=stroke_var, expected_type=type_hints["stroke_var"])
            check_type(argname="argument text", value=text, expected_type=type_hints["text"])
            check_type(argname="argument text_var", value=text_var, expected_type=type_hints["text_var"])
            check_type(argname="argument transformation", value=transformation, expected_type=type_hints["transformation"])
            check_type(argname="argument typeface", value=typeface, expected_type=type_hints["typeface"])
            check_type(argname="argument typeface_var", value=typeface_var, expected_type=type_hints["typeface_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fill is not None:
            self._values["fill"] = fill
        if fill_var is not None:
            self._values["fill_var"] = fill_var
        if size is not None:
            self._values["size"] = size
        if size_var is not None:
            self._values["size_var"] = size_var
        if stroke is not None:
            self._values["stroke"] = stroke
        if stroke_size is not None:
            self._values["stroke_size"] = stroke_size
        if stroke_size_var is not None:
            self._values["stroke_size_var"] = stroke_size_var
        if stroke_var is not None:
            self._values["stroke_var"] = stroke_var
        if text is not None:
            self._values["text"] = text
        if text_var is not None:
            self._values["text_var"] = text_var
        if transformation is not None:
            self._values["transformation"] = transformation
        if typeface is not None:
            self._values["typeface"] = typeface
        if typeface_var is not None:
            self._values["typeface_var"] = typeface_var

    @builtins.property
    def fill(self) -> typing.Optional[builtins.str]:
        '''The main fill color of the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill DataAkamaiImagingPolicyImage#fill}
        '''
        result = self._values.get("fill")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fill_var(self) -> typing.Optional[builtins.str]:
        '''The main fill color of the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_var DataAkamaiImagingPolicyImage#fill_var}
        '''
        result = self._values.get("fill_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def size(self) -> typing.Optional[builtins.str]:
        '''The size in pixels to render the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#size DataAkamaiImagingPolicyImage#size}
        '''
        result = self._values.get("size")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def size_var(self) -> typing.Optional[builtins.str]:
        '''The size in pixels to render the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#size_var DataAkamaiImagingPolicyImage#size_var}
        '''
        result = self._values.get("size_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def stroke(self) -> typing.Optional[builtins.str]:
        '''The color for the outline of the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke DataAkamaiImagingPolicyImage#stroke}
        '''
        result = self._values.get("stroke")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def stroke_size(self) -> typing.Optional[builtins.str]:
        '''The thickness in points for the outline of the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_size DataAkamaiImagingPolicyImage#stroke_size}
        '''
        result = self._values.get("stroke_size")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def stroke_size_var(self) -> typing.Optional[builtins.str]:
        '''The thickness in points for the outline of the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_size_var DataAkamaiImagingPolicyImage#stroke_size_var}
        '''
        result = self._values.get("stroke_size_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def stroke_var(self) -> typing.Optional[builtins.str]:
        '''The color for the outline of the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_var DataAkamaiImagingPolicyImage#stroke_var}
        '''
        result = self._values.get("stroke_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def text(self) -> typing.Optional[builtins.str]:
        '''The line of text to render.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text DataAkamaiImagingPolicyImage#text}
        '''
        result = self._values.get("text")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def text_var(self) -> typing.Optional[builtins.str]:
        '''The line of text to render.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text_var DataAkamaiImagingPolicyImage#text_var}
        '''
        result = self._values.get("text_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def transformation(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageTextImageTransformation"]:
        '''transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        '''
        result = self._values.get("transformation")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageTextImageTransformation"], result)

    @builtins.property
    def typeface(self) -> typing.Optional[builtins.str]:
        '''The font family to apply to the text image.

        This may be a URL to a TrueType or WOFF (v1) typeface, or a string that refers to one of the standard built-in browser fonts.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#typeface DataAkamaiImagingPolicyImage#typeface}
        '''
        result = self._values.get("typeface")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def typeface_var(self) -> typing.Optional[builtins.str]:
        '''The font family to apply to the text image.

        This may be a URL to a TrueType or WOFF (v1) typeface, or a string that refers to one of the standard built-in browser fonts.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#typeface_var DataAkamaiImagingPolicyImage#typeface_var}
        '''
        result = self._values.get("typeface_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageTextImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageTextImageList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageTextImageList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9f5c5d47fb736abb527dbc829817557c2bd9822fbd953b6bdf318ed28882f29c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageTextImageOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__73742de9f64dc71d718cd7facc7fcc6f659bfcf00f8a88fd2e3e1972da7a82e7)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageTextImageOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb4b1356f72f85d7703d17ee9fd64c45432317ea9bce6ed688288fd8de91570e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d70163febcc00b4e52c9977e40886afa33086bfcc8b35e10c5f484b00262d371)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9800838f1f6f9dab04ba59fa448efc114c54c33e349f49c423758e527b1bc3d2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageTextImage]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageTextImage]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageTextImage]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0110e6b664ed4a656c22174443a745187b4743bf9110fc3d5b74d964b6fbb230)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageTextImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageTextImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a22a3cfb4f3ffb6575ff8453bd8ef0d306c9b78a4aa8ff237ccfd9ba0ea82e2e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformation")
    def put_transformation(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageTextImageTransformation()

        return typing.cast(None, jsii.invoke(self, "putTransformation", [value]))

    @jsii.member(jsii_name="resetFill")
    def reset_fill(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFill", []))

    @jsii.member(jsii_name="resetFillVar")
    def reset_fill_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFillVar", []))

    @jsii.member(jsii_name="resetSize")
    def reset_size(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSize", []))

    @jsii.member(jsii_name="resetSizeVar")
    def reset_size_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSizeVar", []))

    @jsii.member(jsii_name="resetStroke")
    def reset_stroke(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStroke", []))

    @jsii.member(jsii_name="resetStrokeSize")
    def reset_stroke_size(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStrokeSize", []))

    @jsii.member(jsii_name="resetStrokeSizeVar")
    def reset_stroke_size_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStrokeSizeVar", []))

    @jsii.member(jsii_name="resetStrokeVar")
    def reset_stroke_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStrokeVar", []))

    @jsii.member(jsii_name="resetText")
    def reset_text(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetText", []))

    @jsii.member(jsii_name="resetTextVar")
    def reset_text_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTextVar", []))

    @jsii.member(jsii_name="resetTransformation")
    def reset_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformation", []))

    @jsii.member(jsii_name="resetTypeface")
    def reset_typeface(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeface", []))

    @jsii.member(jsii_name="resetTypefaceVar")
    def reset_typeface_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypefaceVar", []))

    @builtins.property
    @jsii.member(jsii_name="transformation")
    def transformation(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageTextImageTransformationOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageTextImageTransformationOutputReference", jsii.get(self, "transformation"))

    @builtins.property
    @jsii.member(jsii_name="fillInput")
    def fill_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fillInput"))

    @builtins.property
    @jsii.member(jsii_name="fillVarInput")
    def fill_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fillVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sizeInput")
    def size_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sizeInput"))

    @builtins.property
    @jsii.member(jsii_name="sizeVarInput")
    def size_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sizeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="strokeInput")
    def stroke_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "strokeInput"))

    @builtins.property
    @jsii.member(jsii_name="strokeSizeInput")
    def stroke_size_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "strokeSizeInput"))

    @builtins.property
    @jsii.member(jsii_name="strokeSizeVarInput")
    def stroke_size_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "strokeSizeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="strokeVarInput")
    def stroke_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "strokeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="textInput")
    def text_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "textInput"))

    @builtins.property
    @jsii.member(jsii_name="textVarInput")
    def text_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "textVarInput"))

    @builtins.property
    @jsii.member(jsii_name="transformationInput")
    def transformation_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageTextImageTransformation"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageTextImageTransformation"], jsii.get(self, "transformationInput"))

    @builtins.property
    @jsii.member(jsii_name="typefaceInput")
    def typeface_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typefaceInput"))

    @builtins.property
    @jsii.member(jsii_name="typefaceVarInput")
    def typeface_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typefaceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="fill")
    def fill(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fill"))

    @fill.setter
    def fill(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0664d25f9a7c52e630da552efdef8dcf9e557a604e1c0bd8ae005fcd703d3cf3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fill", value)

    @builtins.property
    @jsii.member(jsii_name="fillVar")
    def fill_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fillVar"))

    @fill_var.setter
    def fill_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dd1ceef0f8147d1c8487ab1efe523f79e4eb0326670237e117c2bee7b3622690)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fillVar", value)

    @builtins.property
    @jsii.member(jsii_name="size")
    def size(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "size"))

    @size.setter
    def size(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8d1207b3a5e2b30d0051c1eee6d613f9c442aa4649564a255969130ba9d1e8c8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "size", value)

    @builtins.property
    @jsii.member(jsii_name="sizeVar")
    def size_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sizeVar"))

    @size_var.setter
    def size_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f52ceabd375211d68ee423d4255f21e0627f2ddcc460dfaae031782e06bdd44c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sizeVar", value)

    @builtins.property
    @jsii.member(jsii_name="stroke")
    def stroke(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "stroke"))

    @stroke.setter
    def stroke(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__516a9f263e70f2464414d85b2f973ef744407c5fcde365a264460be8c326aa8f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "stroke", value)

    @builtins.property
    @jsii.member(jsii_name="strokeSize")
    def stroke_size(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "strokeSize"))

    @stroke_size.setter
    def stroke_size(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e9118a38df77d11ca5cbb0d3295fc9083885fcce74073eedb03116da15589afd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "strokeSize", value)

    @builtins.property
    @jsii.member(jsii_name="strokeSizeVar")
    def stroke_size_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "strokeSizeVar"))

    @stroke_size_var.setter
    def stroke_size_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0f82b064fd31b6ba5ad778b399e28a5779ad693b8775a22f194f1d800bc9ed86)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "strokeSizeVar", value)

    @builtins.property
    @jsii.member(jsii_name="strokeVar")
    def stroke_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "strokeVar"))

    @stroke_var.setter
    def stroke_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__496ea46b949726cf790292962338cc4dcb982aa730450b7a6eae9914e43f6c2a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "strokeVar", value)

    @builtins.property
    @jsii.member(jsii_name="text")
    def text(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "text"))

    @text.setter
    def text(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b6be2ed90a9aac273b9e6574dab2d7fb98795cc6ad0eee8dfa91107e2c75d0fd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "text", value)

    @builtins.property
    @jsii.member(jsii_name="textVar")
    def text_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "textVar"))

    @text_var.setter
    def text_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__92441dc73c719b29a3d2daefd028f6626f77d4ef8432e38b8013e0bc3c3aadb1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "textVar", value)

    @builtins.property
    @jsii.member(jsii_name="typeface")
    def typeface(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeface"))

    @typeface.setter
    def typeface(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__561bb0e1f8200c0de0c7ec306abc0a1a8f3d62a225fef0b5e7bba1a31acf34aa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeface", value)

    @builtins.property
    @jsii.member(jsii_name="typefaceVar")
    def typeface_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typefaceVar"))

    @typeface_var.setter
    def typeface_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e9fb4c9764cfc71b6d5246b9929853b1f9a36a29c913c46f60666d949b2c6e24)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typefaceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageTextImage]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageTextImage]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageTextImage]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3fa412da968ba5c0b8719af6b48f3c29b4351ef71079460d4d245b403e532e0a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageTextImageTransformation",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageTextImageTransformation:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageTextImageTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageTextImageTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageTextImageTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__741d50ec97403566c90938d16f65c0dee122a48922295fd2445016c31ad50f7b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageTextImageTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageTextImageTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageTextImageTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e74535fcc25eb4814f3eda67947aa17d1d6f359b47c4cc2ace1ac27327ae6c42)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageUrlImage",
    jsii_struct_bases=[],
    name_mapping={
        "transformation": "transformation",
        "url": "url",
        "url_var": "urlVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageUrlImage:
    def __init__(
        self,
        *,
        transformation: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageUrlImageTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        url: typing.Optional[builtins.str] = None,
        url_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param transformation: transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        :param url: The URL of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url DataAkamaiImagingPolicyImage#url}
        :param url_var: The URL of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url_var DataAkamaiImagingPolicyImage#url_var}
        '''
        if isinstance(transformation, dict):
            transformation = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageUrlImageTransformation(**transformation)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__508d7ad811d30371b401164153e03dbf7e42b6285a40efbebc1896f73c973fbe)
            check_type(argname="argument transformation", value=transformation, expected_type=type_hints["transformation"])
            check_type(argname="argument url", value=url, expected_type=type_hints["url"])
            check_type(argname="argument url_var", value=url_var, expected_type=type_hints["url_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if transformation is not None:
            self._values["transformation"] = transformation
        if url is not None:
            self._values["url"] = url
        if url_var is not None:
            self._values["url_var"] = url_var

    @builtins.property
    def transformation(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageUrlImageTransformation"]:
        '''transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        '''
        result = self._values.get("transformation")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageUrlImageTransformation"], result)

    @builtins.property
    def url(self) -> typing.Optional[builtins.str]:
        '''The URL of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url DataAkamaiImagingPolicyImage#url}
        '''
        result = self._values.get("url")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def url_var(self) -> typing.Optional[builtins.str]:
        '''The URL of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url_var DataAkamaiImagingPolicyImage#url_var}
        '''
        result = self._values.get("url_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageUrlImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageUrlImageList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageUrlImageList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a2f34e7034c9117d1b1929c22101302dc0a0ef2c162eff846cce5b8848f8bd7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageUrlImageOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5133ef9ec2303bdba0dc52dccea8f01bbf770abab4ca4e7a4b3fe80e5e511111)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageUrlImageOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d8e2516dca7ef7ade218398b4bd72882a5d183472bc51114820f1000f56c8f95)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__709c9ee620775260a111812939d28ff82d528511be71624596b6771f8a1ee3e3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0053e3a65142e1f520e7291babc63a69c9f982d76349e8b0a15c05c09954b405)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageUrlImage]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageUrlImage]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageUrlImage]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__09ee06b8429a9039e83f35555ce287ad9516cdc8c16fdc9f33dc82d8e0be94d8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageUrlImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageUrlImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__02e15d8a7ada71d252b6b4aed91a08e60b5dc4e032af2e67502027db2e1447fb)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformation")
    def put_transformation(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageUrlImageTransformation()

        return typing.cast(None, jsii.invoke(self, "putTransformation", [value]))

    @jsii.member(jsii_name="resetTransformation")
    def reset_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformation", []))

    @jsii.member(jsii_name="resetUrl")
    def reset_url(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUrl", []))

    @jsii.member(jsii_name="resetUrlVar")
    def reset_url_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUrlVar", []))

    @builtins.property
    @jsii.member(jsii_name="transformation")
    def transformation(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageUrlImageTransformationOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageUrlImageTransformationOutputReference", jsii.get(self, "transformation"))

    @builtins.property
    @jsii.member(jsii_name="transformationInput")
    def transformation_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageUrlImageTransformation"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageUrlImageTransformation"], jsii.get(self, "transformationInput"))

    @builtins.property
    @jsii.member(jsii_name="urlInput")
    def url_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "urlInput"))

    @builtins.property
    @jsii.member(jsii_name="urlVarInput")
    def url_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "urlVarInput"))

    @builtins.property
    @jsii.member(jsii_name="url")
    def url(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "url"))

    @url.setter
    def url(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8fcf2091cf78f0436d063de0d07d104e49349ebf70d2ac93c0a2e2609995b295)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "url", value)

    @builtins.property
    @jsii.member(jsii_name="urlVar")
    def url_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "urlVar"))

    @url_var.setter
    def url_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__403dc96beac1d74735560c6a6ccff4c5481d8e720413c333be59faa5101f9185)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "urlVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageUrlImage]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageUrlImage]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageUrlImage]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ec9e4daefbfea1e672dd656e12d513f727484b36ce61c3303f5c676e6fa36891)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageUrlImageTransformation",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageUrlImageTransformation:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageUrlImageTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageUrlImageTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageUrlImageTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4e099429fe2bd4159929de6ffd9e457f14e44785054fa3955711c8eb7ad3cdfd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageUrlImageTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageUrlImageTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageUrlImageTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c2e85a7211ae65478932a581d95c03beda20ae55a24bf450a263d3dec198d26b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__93e753bc234795c769429f9fab8d83fb18f1afad7a4ef2288b0a0db68a364b78)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__26ef51e95f6a6dfeb6cab721ac9797741991c7792008e84ebe46a437e1862c0a)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4c95902cdad16f6e962fd022a7c81122c14cc7d5b7f0f3ace706c1f4aca618e8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__361de6648c470a4169f3ccd41edf925c1a3427aa6ac813907d27e5c729832000)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ce75b12ae4010ade7510eb3713359509750ce5f8de66a5e1d6c26e46317fd2a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultComposite]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultComposite]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__13c789edded22f8b1d8f340057bbffd5223209a0876b9cc301c7a8b412cd07f9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3c5d806a545b6f1f1cea57f1426634178736daa6809af89a977702dd814b027b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(
        self,
        *,
        box_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageBoxImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
        circle_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageCircleImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
        text_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageTextImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
        url_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageUrlImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param box_image: box_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#box_image DataAkamaiImagingPolicyImage#box_image}
        :param circle_image: circle_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#circle_image DataAkamaiImagingPolicyImage#circle_image}
        :param text_image: text_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text_image DataAkamaiImagingPolicyImage#text_image}
        :param url_image: url_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url_image DataAkamaiImagingPolicyImage#url_image}
        '''
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImage(
            box_image=box_image,
            circle_image=circle_image,
            text_image=text_image,
            url_image=url_image,
        )

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPlacement")
    def reset_placement(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacement", []))

    @jsii.member(jsii_name="resetPlacementVar")
    def reset_placement_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacementVar", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetScaleDimension")
    def reset_scale_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimension", []))

    @jsii.member(jsii_name="resetScaleDimensionVar")
    def reset_scale_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimensionVar", []))

    @jsii.member(jsii_name="resetScaleVar")
    def reset_scale_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="placementInput")
    def placement_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementInput"))

    @builtins.property
    @jsii.member(jsii_name="placementVarInput")
    def placement_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionInput")
    def scale_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVarInput")
    def scale_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleVarInput")
    def scale_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d8b12120816ea7440446af855072c074f8d49a612147d61f2643c261bbf8e7c8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ccefae8c8849e9582c7c65deb0d646921548a451e074b452871654a41235ec4c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="placement")
    def placement(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placement"))

    @placement.setter
    def placement(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__60e9740a130cbad09789cc60bcd14c947d92870dc15ae34b2b031d827221b04d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placement", value)

    @builtins.property
    @jsii.member(jsii_name="placementVar")
    def placement_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placementVar"))

    @placement_var.setter
    def placement_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0b9d15b7fdece5b0736a846fc044ae862de6f00607adcbfdce569da3bb23baf2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placementVar", value)

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scale"))

    @scale.setter
    def scale(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5d426a938b61a62ff99432a46658797e18c3f966abe791f6af3feceb580e4cc0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scale", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimension")
    def scale_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimension"))

    @scale_dimension.setter
    def scale_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5d76a35f659a6d96396060954fcfe691b98a9be51c1cae4eef89089ad39c9b9f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimension", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVar")
    def scale_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimensionVar"))

    @scale_dimension_var.setter
    def scale_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__20a296e55769437f88966323230d2ee74da2552accbd50447fcf61b4fe9f125c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="scaleVar")
    def scale_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleVar"))

    @scale_var.setter
    def scale_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9f71fe0908f88283d4c1f6fcd0fc9391610c0cdfcd8db0b2fc1243f3147aacd5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3541b2b767e44cdfab247c5db51ffb5494ced85667d48e67b649bc431d4bbd14)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a5f1c4c5f797c28077f31ffdf8b82fb29084bbf87026f9439a1523b7506445e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1bb77fa83f3a2eafeae7da67ef30cf88728a475e13644b88dd8d48070db80068)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f89d57e0b6b4c98ff25fbc157673f6ea18a878e3caa16cffea1880d39a17e40)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultComposite]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultComposite]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultComposite]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7f553ba1799ace935f3ded47989e3ca77640bdb22374e79ce95fd59cbd127642)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompound",
    jsii_struct_bases=[],
    name_mapping={"transformations": "transformations"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompound:
    def __init__(
        self,
        *,
        transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformations, typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param transformations: transformations block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0959c4edef2265eda310e94073d59c5935bdfcdca486d4ce9d2190e8ed6866bf)
            check_type(argname="argument transformations", value=transformations, expected_type=type_hints["transformations"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if transformations is not None:
            self._values["transformations"] = transformations

    @builtins.property
    def transformations(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformations]]]:
        '''transformations block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        result = self._values.get("transformations")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformations]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompound(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompoundList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompoundList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4f16f6766b22cb9260773393cf7635ce59de3bd5bb4daf9abdc2ec68c12720d3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompoundOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1e8855828daa5dc1922fe6d0caa16d4fa41450163d4e37de1dd7f9ea43aaafb5)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompoundOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__98a1fc6b7e5337352b5ba1f50a05c9c2de28fdf793b1e3b359312c22cee77220)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e2ab643bde66f765f3b660be0cc9168eb4625e420b9e4d0b689063724274b459)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__73c9280fd6474d3cb48ef0e22810f827a4d4446482cb672520d22e65580fbdaa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompound]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompound]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b714d8dd06f10571819bf29392c18d66f8704b9e442bad637f9f8a3d201b1775)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompoundOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompoundOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6c907debf08de640424733b5c328c7d4993a15b673d85cee157ed4ed891196f7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformations")
    def put_transformations(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformations, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2548d4899e980e4813bd7744d51fd2c1e355be491cd139904b29ab873cdf3b76)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTransformations", [value]))

    @jsii.member(jsii_name="resetTransformations")
    def reset_transformations(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformations", []))

    @builtins.property
    @jsii.member(jsii_name="transformations")
    def transformations(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsList", jsii.get(self, "transformations"))

    @builtins.property
    @jsii.member(jsii_name="transformationsInput")
    def transformations_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformations]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformations]]], jsii.get(self, "transformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompound]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompound]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompound]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0568e5e28116eae377c079357c17069e72a4bcc355a2547d9d3004904a592a8e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultContrast",
    jsii_struct_bases=[],
    name_mapping={
        "brightness": "brightness",
        "brightness_var": "brightnessVar",
        "contrast": "contrast",
        "contrast_var": "contrastVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultContrast:
    def __init__(
        self,
        *,
        brightness: typing.Optional[builtins.str] = None,
        brightness_var: typing.Optional[builtins.str] = None,
        contrast: typing.Optional[builtins.str] = None,
        contrast_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param brightness: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        :param brightness_var: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        :param contrast: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param contrast_var: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d12dd4cc4ff8583e23be8f877fce1ee2437cb592b53582b713aae8e8e7296589)
            check_type(argname="argument brightness", value=brightness, expected_type=type_hints["brightness"])
            check_type(argname="argument brightness_var", value=brightness_var, expected_type=type_hints["brightness_var"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument contrast_var", value=contrast_var, expected_type=type_hints["contrast_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if brightness is not None:
            self._values["brightness"] = brightness
        if brightness_var is not None:
            self._values["brightness_var"] = brightness_var
        if contrast is not None:
            self._values["contrast"] = contrast
        if contrast_var is not None:
            self._values["contrast_var"] = contrast_var

    @builtins.property
    def brightness(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        '''
        result = self._values.get("brightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def brightness_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        '''
        result = self._values.get("brightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        result = self._values.get("contrast_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultContrast(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultContrastList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultContrastList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1152c65387a7e268dc9f45b5f07512a3d57b112defe58f71c1dfa4b90ce84745)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultContrastOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__174412e3555b1176771f150baf31f403252b356fd483b86726f277f2c26e2ffc)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultContrastOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c44a013ed4525418c11eb948ad34808720ff1033f20f0bd57fb75eb3a691df26)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d41cae4253608764b647a62ebb94031243d91e046680ccab561650479a855766)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d7bf18665df14eeff20bee0a807f337d42cba1c5b94443a39b538fcc0f8d5bff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultContrast]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultContrast]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bafef35facd0174a23081724cf91c601d8aa0fd0377f3c3ad8652069ba6241d5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultContrastOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultContrastOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f4d0318943da5983e9615c630ccc520f04eb3d614ddb89ac435768c85572209f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetBrightness")
    def reset_brightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightness", []))

    @jsii.member(jsii_name="resetBrightnessVar")
    def reset_brightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightnessVar", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetContrastVar")
    def reset_contrast_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrastVar", []))

    @builtins.property
    @jsii.member(jsii_name="brightnessInput")
    def brightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="brightnessVarInput")
    def brightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastVarInput")
    def contrast_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="brightness")
    def brightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightness"))

    @brightness.setter
    def brightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__709e487d8a9e98efa15fade2cb86b60dd4cb72a1a40834cc2d54bd374c1b3fb5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightness", value)

    @builtins.property
    @jsii.member(jsii_name="brightnessVar")
    def brightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightnessVar"))

    @brightness_var.setter
    def brightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__273c36235d5cabffb0b73c9021837f46c604a34626f7fd1be5f9601f56213e7a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrast"))

    @contrast.setter
    def contrast(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__61a6666fe5072457e8dd51bba67db23d1cc13dae0ed233f1e1274db91dd559ba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrast", value)

    @builtins.property
    @jsii.member(jsii_name="contrastVar")
    def contrast_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrastVar"))

    @contrast_var.setter
    def contrast_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0b5b099b2209a35725f086e03f251619286bccc77f76c078c1353f04d9ca29c8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrastVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultContrast]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultContrast]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultContrast]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c9640304606064583990c2b071572d2d6a2b0dbd69e6f61036b0f85e15fd4f9c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCrop",
    jsii_struct_bases=[],
    name_mapping={
        "allow_expansion": "allowExpansion",
        "allow_expansion_var": "allowExpansionVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCrop:
    def __init__(
        self,
        *,
        allow_expansion: typing.Optional[builtins.str] = None,
        allow_expansion_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_expansion: If cropping an area outside of the existing canvas, expands the image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        :param allow_expansion_var: If cropping an area outside of the existing canvas, expands the image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        :param gravity: Frame of reference for X and Y Positions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Frame of reference for X and Y Positions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The number of pixels to crop along the y-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The number of pixels to crop along the y-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The number of pixels to crop along the x-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The number of pixels to crop along the x-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        :param x_position: The x-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c5069472a1e6bb388fba6255bce579cf4bd5491b4402d4c2a3d3a213d984757d)
            check_type(argname="argument allow_expansion", value=allow_expansion, expected_type=type_hints["allow_expansion"])
            check_type(argname="argument allow_expansion_var", value=allow_expansion_var, expected_type=type_hints["allow_expansion_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if allow_expansion is not None:
            self._values["allow_expansion"] = allow_expansion
        if allow_expansion_var is not None:
            self._values["allow_expansion_var"] = allow_expansion_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def allow_expansion(self) -> typing.Optional[builtins.str]:
        '''If cropping an area outside of the existing canvas, expands the image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        '''
        result = self._values.get("allow_expansion")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def allow_expansion_var(self) -> typing.Optional[builtins.str]:
        '''If cropping an area outside of the existing canvas, expands the image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        '''
        result = self._values.get("allow_expansion_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Frame of reference for X and Y Positions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Frame of reference for X and Y Positions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the y-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the y-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the x-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the x-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6fbd30797bcc478af8a061e6254f81ba06ed9201a56825ce337b065e1df1b321)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6d6c02721a6e25d2c2300921be0b17c2668246edb14275a44427fc27ba6b1f8d)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__822185c0b234758bee19fe38e1b7e8413cd7d0ee310efd17dae659ee47fb87f5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5785f3fcb57567ced8db89ae292a23aaa61b0cd127abd11a8eb97ae441235011)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df639977eb44cf1b4b03e1b1fd0f1aa98aa91e4d4c710f469694f8349b8594fa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__67ec15ea959cac0794caa19a515956cdc740e398d131c933dde71f8388a8e22b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e828548db49dcec74e6dc1cddfc75753dbec0b7cbb3de4714ce3b83b218ec556)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAllowExpansion")
    def reset_allow_expansion(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansion", []))

    @jsii.member(jsii_name="resetAllowExpansionVar")
    def reset_allow_expansion_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansionVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionInput")
    def allow_expansion_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVarInput")
    def allow_expansion_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansion")
    def allow_expansion(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansion"))

    @allow_expansion.setter
    def allow_expansion(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8cce40bded062e12650e54207f9c39dd67b543b4fee607542f2ffe1c9f033258)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansion", value)

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVar")
    def allow_expansion_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansionVar"))

    @allow_expansion_var.setter
    def allow_expansion_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a4a43552574f74e657efc1b3282376bbbac5d5bfc682060b3d7d3163fc4f60f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansionVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__72d80f3929ade457b0362241eed8700d12a7ee01c7ad63c54088ca25d866c0e1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c39dcc6067c7072b96d316a815447160ff412953e545533d6f01cccd7079e283)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__77cd023620018c5d96bf0778f0c6b7dd88f2f6c61e2481ed146e8eff30a495f2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__812c61a995ba9ad7b61a5bd2db2c67bac2834c0821bd0ca9cd53642bc5de911f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d3711e16cd7ef908ba72cb167cac7139b7e4eb20a70ee435e834bea65409be9c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7fd2a04c3889f9b2dcab315cc102ab3000ece057e59d8d6f2d7701054d272f66)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__89c711712ff71fefa055f02b7dda139bcb60e1ad0627467f0d73f78e83cfff07)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6b5ac820463ebca3f56cabe571194d0ac1e707081b2def3ca9161bc5443e90e8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ceeb21a2a75d38d87b4f6d195eda668f06ce26a2cb8591cc7d8b9f2e092b3e5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__94dbc8c2880100d7bb6dbedc39473e032019f5506f25743967f074d12daec4b6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__42d6e37c1514f8e2745edc341e9c96d81cb4463591081bdf7a7d45f470ac6e7c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFaceCrop",
    jsii_struct_bases=[],
    name_mapping={
        "algorithm": "algorithm",
        "algorithm_var": "algorithmVar",
        "confidence": "confidence",
        "confidence_var": "confidenceVar",
        "fail_gravity": "failGravity",
        "fail_gravity_var": "failGravityVar",
        "focus": "focus",
        "focus_var": "focusVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "padding": "padding",
        "padding_var": "paddingVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFaceCrop:
    def __init__(
        self,
        *,
        algorithm: typing.Optional[builtins.str] = None,
        algorithm_var: typing.Optional[builtins.str] = None,
        confidence: typing.Optional[builtins.str] = None,
        confidence_var: typing.Optional[builtins.str] = None,
        fail_gravity: typing.Optional[builtins.str] = None,
        fail_gravity_var: typing.Optional[builtins.str] = None,
        focus: typing.Optional[builtins.str] = None,
        focus_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param algorithm: Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm DataAkamaiImagingPolicyImage#algorithm}
        :param algorithm_var: Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm_var DataAkamaiImagingPolicyImage#algorithm_var}
        :param confidence: With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image. Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence DataAkamaiImagingPolicyImage#confidence}
        :param confidence_var: With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image. Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence_var DataAkamaiImagingPolicyImage#confidence_var}
        :param fail_gravity: Controls placement of the crop if Image and Video Manager does not detect any faces in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        :param fail_gravity_var: Controls placement of the crop if Image and Video Manager does not detect any faces in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        :param focus: Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus DataAkamaiImagingPolicyImage#focus}
        :param focus_var: Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus_var DataAkamaiImagingPolicyImage#focus_var}
        :param gravity: Controls placement of the crop. Directions are relative to the face(s) plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Controls placement of the crop. Directions are relative to the face(s) plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param padding: The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        :param style: Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__92630dc30eb5629174d45ddd391a37233f600cc70b1c29b96bf1882d6764fea4)
            check_type(argname="argument algorithm", value=algorithm, expected_type=type_hints["algorithm"])
            check_type(argname="argument algorithm_var", value=algorithm_var, expected_type=type_hints["algorithm_var"])
            check_type(argname="argument confidence", value=confidence, expected_type=type_hints["confidence"])
            check_type(argname="argument confidence_var", value=confidence_var, expected_type=type_hints["confidence_var"])
            check_type(argname="argument fail_gravity", value=fail_gravity, expected_type=type_hints["fail_gravity"])
            check_type(argname="argument fail_gravity_var", value=fail_gravity_var, expected_type=type_hints["fail_gravity_var"])
            check_type(argname="argument focus", value=focus, expected_type=type_hints["focus"])
            check_type(argname="argument focus_var", value=focus_var, expected_type=type_hints["focus_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if algorithm is not None:
            self._values["algorithm"] = algorithm
        if algorithm_var is not None:
            self._values["algorithm_var"] = algorithm_var
        if confidence is not None:
            self._values["confidence"] = confidence
        if confidence_var is not None:
            self._values["confidence_var"] = confidence_var
        if fail_gravity is not None:
            self._values["fail_gravity"] = fail_gravity
        if fail_gravity_var is not None:
            self._values["fail_gravity_var"] = fail_gravity_var
        if focus is not None:
            self._values["focus"] = focus
        if focus_var is not None:
            self._values["focus_var"] = focus_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def algorithm(self) -> typing.Optional[builtins.str]:
        '''Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm DataAkamaiImagingPolicyImage#algorithm}
        '''
        result = self._values.get("algorithm")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def algorithm_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm_var DataAkamaiImagingPolicyImage#algorithm_var}
        '''
        result = self._values.get("algorithm_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def confidence(self) -> typing.Optional[builtins.str]:
        '''With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image.

        Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence DataAkamaiImagingPolicyImage#confidence}
        '''
        result = self._values.get("confidence")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def confidence_var(self) -> typing.Optional[builtins.str]:
        '''With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image.

        Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence_var DataAkamaiImagingPolicyImage#confidence_var}
        '''
        result = self._values.get("confidence_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any faces in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        '''
        result = self._values.get("fail_gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any faces in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        '''
        result = self._values.get("fail_gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def focus(self) -> typing.Optional[builtins.str]:
        '''Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus DataAkamaiImagingPolicyImage#focus}
        '''
        result = self._values.get("focus")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def focus_var(self) -> typing.Optional[builtins.str]:
        '''Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus_var DataAkamaiImagingPolicyImage#focus_var}
        '''
        result = self._values.get("focus_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the face(s) plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the face(s) plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFaceCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFaceCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFaceCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ad5a0fb3cf8c09d6d8df8382416e003c76e408faae210599e4de409b83e9f491)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFaceCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__025ee506f1c269c657151870dc48cd8e2464ef65c8b53f08724bade7b6f42fe2)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFaceCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d8440c24e608c0ad7eecb4a6c7cd4034eab3186c171f9950c21deb5c74196873)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__23a11d4a7add0e51b2e9f6e53999df54d45110614b102978c4994d1ffa309d49)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__662077df276baa03e3bf123110278a89d76570772d80825faec9bbe7c8ab9afd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFaceCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFaceCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFaceCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4b94cf1aabb7d839c01a1c681574aa5c6d4b15ce3f713985c4ee2a2df685f138)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFaceCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFaceCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__73adcd14b6c749a4659fbd745d1238bfaaf0a2cca9b7886f7d0d1164ddf415dc)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAlgorithm")
    def reset_algorithm(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAlgorithm", []))

    @jsii.member(jsii_name="resetAlgorithmVar")
    def reset_algorithm_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAlgorithmVar", []))

    @jsii.member(jsii_name="resetConfidence")
    def reset_confidence(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetConfidence", []))

    @jsii.member(jsii_name="resetConfidenceVar")
    def reset_confidence_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetConfidenceVar", []))

    @jsii.member(jsii_name="resetFailGravity")
    def reset_fail_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravity", []))

    @jsii.member(jsii_name="resetFailGravityVar")
    def reset_fail_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravityVar", []))

    @jsii.member(jsii_name="resetFocus")
    def reset_focus(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFocus", []))

    @jsii.member(jsii_name="resetFocusVar")
    def reset_focus_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFocusVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="algorithmInput")
    def algorithm_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "algorithmInput"))

    @builtins.property
    @jsii.member(jsii_name="algorithmVarInput")
    def algorithm_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "algorithmVarInput"))

    @builtins.property
    @jsii.member(jsii_name="confidenceInput")
    def confidence_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "confidenceInput"))

    @builtins.property
    @jsii.member(jsii_name="confidenceVarInput")
    def confidence_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "confidenceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityInput")
    def fail_gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityVarInput")
    def fail_gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="focusInput")
    def focus_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "focusInput"))

    @builtins.property
    @jsii.member(jsii_name="focusVarInput")
    def focus_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "focusVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="algorithm")
    def algorithm(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "algorithm"))

    @algorithm.setter
    def algorithm(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1c3e2157532f7f698c8610f38b72d5020e32eca8681a9559a97948d0c70b988e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "algorithm", value)

    @builtins.property
    @jsii.member(jsii_name="algorithmVar")
    def algorithm_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "algorithmVar"))

    @algorithm_var.setter
    def algorithm_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7b7cf06f05d6efe791a17d71aa0d2d2c16e1328f6266e592e58d1a241d9d420e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "algorithmVar", value)

    @builtins.property
    @jsii.member(jsii_name="confidence")
    def confidence(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "confidence"))

    @confidence.setter
    def confidence(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af08ff43a530a1a66ffcc00132aac30e27bb4d96e2dab895d8985b8492e66534)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "confidence", value)

    @builtins.property
    @jsii.member(jsii_name="confidenceVar")
    def confidence_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "confidenceVar"))

    @confidence_var.setter
    def confidence_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cb940557d7993ff51e0b9c23cdda7f97f9a580d9e358705660a2357ef1ee502c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "confidenceVar", value)

    @builtins.property
    @jsii.member(jsii_name="failGravity")
    def fail_gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravity"))

    @fail_gravity.setter
    def fail_gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__64e1f7d29997ba5bf9a2fe6ff40d3322289956c7589cb15b665e42ae1848d2b2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravity", value)

    @builtins.property
    @jsii.member(jsii_name="failGravityVar")
    def fail_gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravityVar"))

    @fail_gravity_var.setter
    def fail_gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0cc59d857769540b1056e12b33600fd63ca3a4f12013355063e3a6ace434ef4c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="focus")
    def focus(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "focus"))

    @focus.setter
    def focus(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__70192c254a76c9f9a8b0d8303b1c116ed096ca43a223d90f72b759af054e1a5b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "focus", value)

    @builtins.property
    @jsii.member(jsii_name="focusVar")
    def focus_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "focusVar"))

    @focus_var.setter
    def focus_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f745c836966dd2c2eccc89411281f36b7e4fa4a487ed9509e565f64f03602fe3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "focusVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__17a0a3daa6b84556012d127463759c983fd4d01cca35757131d398d7395b18d0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e42f7e858163cb80d1b9d2425cfbfa54696c2f50c265582de252d674b2bb274e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__20234ce1068319bfd1c36c013c16bea9bf93e581174872875bf352043110151a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__76c3653c3e46d653786339e6a43238a69eb8cea588c77011d7ffcf84c6d0fd8c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e2b703ef99309d6ee4734ee48ced0441c3c97e95cec173a15a275ddfeaf19900)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e8c53ca2da9bed135aaaae8fb03de40ac9f8015b805602336f351508605a9392)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__158ee9f2dacae777a7760d07b0f4ed01dd7c2dc5bf9de6cab7b2df83d901642d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__79b015ae0fa0c1971519d3ae3082d7fcbb5bea800d00a00da6503d24eae29fd7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c179c24bd336fb74a2c1ea7400871c5604b41430c0b98838b0c032047885485e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f3432f5d591b5baa5fc15d1beffc8d494c1dec660ee14f129b6b6167fcdf118a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFaceCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFaceCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFaceCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1c9bc4721679446c3693644e3979e1ce4bb39933723ad1069b1f63c9339794b4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFeatureCrop",
    jsii_struct_bases=[],
    name_mapping={
        "fail_gravity": "failGravity",
        "fail_gravity_var": "failGravityVar",
        "feature_radius": "featureRadius",
        "feature_radius_var": "featureRadiusVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "max_features": "maxFeatures",
        "max_features_var": "maxFeaturesVar",
        "min_feature_quality": "minFeatureQuality",
        "min_feature_quality_var": "minFeatureQualityVar",
        "padding": "padding",
        "padding_var": "paddingVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFeatureCrop:
    def __init__(
        self,
        *,
        fail_gravity: typing.Optional[builtins.str] = None,
        fail_gravity_var: typing.Optional[builtins.str] = None,
        feature_radius: typing.Optional[builtins.str] = None,
        feature_radius_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        max_features: typing.Optional[builtins.str] = None,
        max_features_var: typing.Optional[builtins.str] = None,
        min_feature_quality: typing.Optional[builtins.str] = None,
        min_feature_quality_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fail_gravity: Controls placement of the crop if Image and Video Manager does not detect any features in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        :param fail_gravity_var: Controls placement of the crop if Image and Video Manager does not detect any features in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        :param feature_radius: The size in pixels of the important features to search for. If identified, two features never appear closer together than this value, ``8.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius DataAkamaiImagingPolicyImage#feature_radius}
        :param feature_radius_var: The size in pixels of the important features to search for. If identified, two features never appear closer together than this value, ``8.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius_var DataAkamaiImagingPolicyImage#feature_radius_var}
        :param gravity: Controls placement of the crop. Directions are relative to the region of interest plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Controls placement of the crop. Directions are relative to the region of interest plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param max_features: The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features DataAkamaiImagingPolicyImage#max_features}
        :param max_features_var: The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features_var DataAkamaiImagingPolicyImage#max_features_var}
        :param min_feature_quality: Determines the minimum quality level of the feature identified. To consider a feature important, the feature needs to surpass this value. Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality DataAkamaiImagingPolicyImage#min_feature_quality}
        :param min_feature_quality_var: Determines the minimum quality level of the feature identified. To consider a feature important, the feature needs to surpass this value. Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality_var DataAkamaiImagingPolicyImage#min_feature_quality_var}
        :param padding: Adds space around the region of interest. The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: Adds space around the region of interest. The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        :param style: Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e96221b2ddf4e95cd70b1d6d520250be309d5046578573f084d5975b39792572)
            check_type(argname="argument fail_gravity", value=fail_gravity, expected_type=type_hints["fail_gravity"])
            check_type(argname="argument fail_gravity_var", value=fail_gravity_var, expected_type=type_hints["fail_gravity_var"])
            check_type(argname="argument feature_radius", value=feature_radius, expected_type=type_hints["feature_radius"])
            check_type(argname="argument feature_radius_var", value=feature_radius_var, expected_type=type_hints["feature_radius_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument max_features", value=max_features, expected_type=type_hints["max_features"])
            check_type(argname="argument max_features_var", value=max_features_var, expected_type=type_hints["max_features_var"])
            check_type(argname="argument min_feature_quality", value=min_feature_quality, expected_type=type_hints["min_feature_quality"])
            check_type(argname="argument min_feature_quality_var", value=min_feature_quality_var, expected_type=type_hints["min_feature_quality_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fail_gravity is not None:
            self._values["fail_gravity"] = fail_gravity
        if fail_gravity_var is not None:
            self._values["fail_gravity_var"] = fail_gravity_var
        if feature_radius is not None:
            self._values["feature_radius"] = feature_radius
        if feature_radius_var is not None:
            self._values["feature_radius_var"] = feature_radius_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if max_features is not None:
            self._values["max_features"] = max_features
        if max_features_var is not None:
            self._values["max_features_var"] = max_features_var
        if min_feature_quality is not None:
            self._values["min_feature_quality"] = min_feature_quality
        if min_feature_quality_var is not None:
            self._values["min_feature_quality_var"] = min_feature_quality_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def fail_gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any features in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        '''
        result = self._values.get("fail_gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any features in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        '''
        result = self._values.get("fail_gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feature_radius(self) -> typing.Optional[builtins.str]:
        '''The size in pixels of the important features to search for.

        If identified, two features never appear closer together than this value, ``8.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius DataAkamaiImagingPolicyImage#feature_radius}
        '''
        result = self._values.get("feature_radius")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feature_radius_var(self) -> typing.Optional[builtins.str]:
        '''The size in pixels of the important features to search for.

        If identified, two features never appear closer together than this value, ``8.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius_var DataAkamaiImagingPolicyImage#feature_radius_var}
        '''
        result = self._values.get("feature_radius_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the region of interest plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the region of interest plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def max_features(self) -> typing.Optional[builtins.str]:
        '''The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features DataAkamaiImagingPolicyImage#max_features}
        '''
        result = self._values.get("max_features")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def max_features_var(self) -> typing.Optional[builtins.str]:
        '''The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features_var DataAkamaiImagingPolicyImage#max_features_var}
        '''
        result = self._values.get("max_features_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def min_feature_quality(self) -> typing.Optional[builtins.str]:
        '''Determines the minimum quality level of the feature identified.

        To consider a feature important, the feature needs to surpass this value.  Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality DataAkamaiImagingPolicyImage#min_feature_quality}
        '''
        result = self._values.get("min_feature_quality")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def min_feature_quality_var(self) -> typing.Optional[builtins.str]:
        '''Determines the minimum quality level of the feature identified.

        To consider a feature important, the feature needs to surpass this value.  Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality_var DataAkamaiImagingPolicyImage#min_feature_quality_var}
        '''
        result = self._values.get("min_feature_quality_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''Adds space around the region of interest.

        The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''Adds space around the region of interest.

        The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFeatureCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFeatureCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFeatureCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__97c3793820c7692a4d9ccb5ff817dbac74d1347412db8084ca6ea4e3b4e543fa)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFeatureCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cc3c48bfdbd5c66543000503e521469217ed0447a6d5f37ce6e164a27f23b19b)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFeatureCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7186407da0ed72525fa26494a5aa4eef36bbe9ade27e2f5c9c7913b4e490d340)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7056e4dd45d05bf05f6d2a41da737d83f8d8b70492fb341ad94b628b01bdd447)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8c73858a53c910da406d6d827f731641940da3822a031d42511c98fc3eab46ce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFeatureCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFeatureCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFeatureCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ae9399ca66a6604466d9b8f3f3b3922b5d94bcc63398b02b870c50e3d4508886)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFeatureCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFeatureCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__13d1ca7568379beb3307377c0c9efafa588837636d94978d14d891f69f82a67e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetFailGravity")
    def reset_fail_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravity", []))

    @jsii.member(jsii_name="resetFailGravityVar")
    def reset_fail_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravityVar", []))

    @jsii.member(jsii_name="resetFeatureRadius")
    def reset_feature_radius(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureRadius", []))

    @jsii.member(jsii_name="resetFeatureRadiusVar")
    def reset_feature_radius_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureRadiusVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetMaxFeatures")
    def reset_max_features(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxFeatures", []))

    @jsii.member(jsii_name="resetMaxFeaturesVar")
    def reset_max_features_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxFeaturesVar", []))

    @jsii.member(jsii_name="resetMinFeatureQuality")
    def reset_min_feature_quality(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMinFeatureQuality", []))

    @jsii.member(jsii_name="resetMinFeatureQualityVar")
    def reset_min_feature_quality_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMinFeatureQualityVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="failGravityInput")
    def fail_gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityVarInput")
    def fail_gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featureRadiusInput")
    def feature_radius_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featureRadiusInput"))

    @builtins.property
    @jsii.member(jsii_name="featureRadiusVarInput")
    def feature_radius_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featureRadiusVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesInput")
    def max_features_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "maxFeaturesInput"))

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesVarInput")
    def max_features_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "maxFeaturesVarInput"))

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityInput")
    def min_feature_quality_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "minFeatureQualityInput"))

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityVarInput")
    def min_feature_quality_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "minFeatureQualityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravity")
    def fail_gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravity"))

    @fail_gravity.setter
    def fail_gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__33b160eeadae9d519230ad73e46a70e08c1957cca7597a25e1930ca24623a933)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravity", value)

    @builtins.property
    @jsii.member(jsii_name="failGravityVar")
    def fail_gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravityVar"))

    @fail_gravity_var.setter
    def fail_gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__478c5e886e566d5ba88a60d1fca26e19ff25b5478844ec226d46bf748a78ea66)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="featureRadius")
    def feature_radius(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featureRadius"))

    @feature_radius.setter
    def feature_radius(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f5cb1bbeb05731956062bc5c289383f98b7672d2fdc28edc30b917b11fe115ec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featureRadius", value)

    @builtins.property
    @jsii.member(jsii_name="featureRadiusVar")
    def feature_radius_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featureRadiusVar"))

    @feature_radius_var.setter
    def feature_radius_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__26434c7505a77782eb1e44838c8656a2a7004a70bb2aa710f2612904156494d9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featureRadiusVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__295729232680c47acafacaaa0544b2f95f81fc261af011fcaa0e4111b70ad324)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__414cae6faf403add51dff093bcd9abbaaa6a41d547da24179ba2763c6c526c9a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5069d9d8885ebec910335a4af8a4115e186831c7fc7ec2bed70b480a56236093)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6b99e77a280a8461072a81e4f13089d2f48da64d3c13635841effc9a9c1a5d4d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="maxFeatures")
    def max_features(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "maxFeatures"))

    @max_features.setter
    def max_features(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ffbb795b1cba8d019a4e60d0c111212338f6b2ca4d2b6084010c9b6dbe030cc5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "maxFeatures", value)

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesVar")
    def max_features_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "maxFeaturesVar"))

    @max_features_var.setter
    def max_features_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8bd71badc13a2638bc68d1a5bbd302d35056a6425e66a7cddc97f44de33e6c66)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "maxFeaturesVar", value)

    @builtins.property
    @jsii.member(jsii_name="minFeatureQuality")
    def min_feature_quality(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "minFeatureQuality"))

    @min_feature_quality.setter
    def min_feature_quality(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__22c9f54d605b76d2cae3c18f20dc2037b69dca962519fba7a2dc80438a8f7676)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "minFeatureQuality", value)

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityVar")
    def min_feature_quality_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "minFeatureQualityVar"))

    @min_feature_quality_var.setter
    def min_feature_quality_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__66268b3e3a62e8fb4e8401b3d2fbe232955ddb1f5bd71ef22cc5e30f7e429fbb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "minFeatureQualityVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d98dd3eb056dcf8ff24dad0b9fca2865bdc4fa05dbf47e8c30f907b4e187e71e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__809c72119f258256ea1585217ce37fec6fb316eefcfd90fa3ed4afd94576e315)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__844c244fe7ef568d7a4832603a161f66c87139da307b5250f62034e62c63a9d5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__23a6175c85261b9c7cb57c7ca82ad4a5b661d8f230ccef8078add96ca6d92c89)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b58771d829319c30a4ee62c4153e2f11fa13ad7b3481f2ecbfdb5a9a85edb31a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d51d6914459a9006dc174dbfb47a9bc8f233a7fc49bbba8ae6e8f23cbc2f198d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFeatureCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFeatureCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFeatureCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__23949b15c857282382391ac8264ed9d3c306a19910630ffc4157834717a1729c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFill",
    jsii_struct_bases=[],
    name_mapping={
        "fill_transformation": "fillTransformation",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFill:
    def __init__(
        self,
        *,
        fill_transformation: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fill_transformation: fill_transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_transformation DataAkamaiImagingPolicyImage#fill_transformation}
        :param height: The height value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The width value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(fill_transformation, dict):
            fill_transformation = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformation(**fill_transformation)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e4fc45264cdccc405cf6b33e00d6667a3f808612bb202bf3a847d3757f7943ce)
            check_type(argname="argument fill_transformation", value=fill_transformation, expected_type=type_hints["fill_transformation"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fill_transformation is not None:
            self._values["fill_transformation"] = fill_transformation
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def fill_transformation(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformation"]:
        '''fill_transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_transformation DataAkamaiImagingPolicyImage#fill_transformation}
        '''
        result = self._values.get("fill_transformation")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformation"], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFill(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformation",
    jsii_struct_bases=[],
    name_mapping={
        "append": "append",
        "aspect_crop": "aspectCrop",
        "background_color": "backgroundColor",
        "blur": "blur",
        "chroma_key": "chromaKey",
        "composite": "composite",
        "compound": "compound",
        "contrast": "contrast",
        "crop": "crop",
        "face_crop": "faceCrop",
        "feature_crop": "featureCrop",
        "fit_and_fill": "fitAndFill",
        "goop": "goop",
        "grayscale": "grayscale",
        "hsl": "hsl",
        "hsv": "hsv",
        "if_dimension": "ifDimension",
        "if_orientation": "ifOrientation",
        "im_query": "imQuery",
        "max_colors": "maxColors",
        "mirror": "mirror",
        "mono_hue": "monoHue",
        "opacity": "opacity",
        "region_of_interest_crop": "regionOfInterestCrop",
        "relative_crop": "relativeCrop",
        "remove_color": "removeColor",
        "resize": "resize",
        "rotate": "rotate",
        "scale": "scale",
        "shear": "shear",
        "trim": "trim",
        "unsharp_mask": "unsharpMask",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformation:
    def __init__(
        self,
        *,
        append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationAppend", typing.Dict[builtins.str, typing.Any]]]]] = None,
        aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationAspectCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationBackgroundColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationBlur", typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationChromaKey", typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationComposite", typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationCompound", typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationContrast", typing.Dict[builtins.str, typing.Any]]]]] = None,
        crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationFaceCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationFeatureCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationFitAndFill", typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationGoop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationGrayscale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationHsl", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationHsv", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfDimension", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfOrientation", typing.Dict[builtins.str, typing.Any]]]]] = None,
        im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationImQuery", typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationMaxColors", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationMirror", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationMonoHue", typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationOpacity", typing.Dict[builtins.str, typing.Any]]]]] = None,
        region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationRegionOfInterestCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationRelativeCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationRemoveColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationResize", typing.Dict[builtins.str, typing.Any]]]]] = None,
        rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationRotate", typing.Dict[builtins.str, typing.Any]]]]] = None,
        scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationScale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationShear", typing.Dict[builtins.str, typing.Any]]]]] = None,
        trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationTrim", typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationUnsharpMask", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param append: append block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        :param aspect_crop: aspect_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param crop: crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        :param face_crop: face_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        :param feature_crop: feature_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        :param fit_and_fill: fit_and_fill block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param im_query: im_query block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param region_of_interest_crop: region_of_interest_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        :param relative_crop: relative_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param resize: resize block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        :param rotate: rotate block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        :param scale: scale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param shear: shear block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        :param trim: trim block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ef4d6def8b6a6f5ef81424eac417fec82c4c6c46e26eab3c86c28f6dc0468ed)
            check_type(argname="argument append", value=append, expected_type=type_hints["append"])
            check_type(argname="argument aspect_crop", value=aspect_crop, expected_type=type_hints["aspect_crop"])
            check_type(argname="argument background_color", value=background_color, expected_type=type_hints["background_color"])
            check_type(argname="argument blur", value=blur, expected_type=type_hints["blur"])
            check_type(argname="argument chroma_key", value=chroma_key, expected_type=type_hints["chroma_key"])
            check_type(argname="argument composite", value=composite, expected_type=type_hints["composite"])
            check_type(argname="argument compound", value=compound, expected_type=type_hints["compound"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument crop", value=crop, expected_type=type_hints["crop"])
            check_type(argname="argument face_crop", value=face_crop, expected_type=type_hints["face_crop"])
            check_type(argname="argument feature_crop", value=feature_crop, expected_type=type_hints["feature_crop"])
            check_type(argname="argument fit_and_fill", value=fit_and_fill, expected_type=type_hints["fit_and_fill"])
            check_type(argname="argument goop", value=goop, expected_type=type_hints["goop"])
            check_type(argname="argument grayscale", value=grayscale, expected_type=type_hints["grayscale"])
            check_type(argname="argument hsl", value=hsl, expected_type=type_hints["hsl"])
            check_type(argname="argument hsv", value=hsv, expected_type=type_hints["hsv"])
            check_type(argname="argument if_dimension", value=if_dimension, expected_type=type_hints["if_dimension"])
            check_type(argname="argument if_orientation", value=if_orientation, expected_type=type_hints["if_orientation"])
            check_type(argname="argument im_query", value=im_query, expected_type=type_hints["im_query"])
            check_type(argname="argument max_colors", value=max_colors, expected_type=type_hints["max_colors"])
            check_type(argname="argument mirror", value=mirror, expected_type=type_hints["mirror"])
            check_type(argname="argument mono_hue", value=mono_hue, expected_type=type_hints["mono_hue"])
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument region_of_interest_crop", value=region_of_interest_crop, expected_type=type_hints["region_of_interest_crop"])
            check_type(argname="argument relative_crop", value=relative_crop, expected_type=type_hints["relative_crop"])
            check_type(argname="argument remove_color", value=remove_color, expected_type=type_hints["remove_color"])
            check_type(argname="argument resize", value=resize, expected_type=type_hints["resize"])
            check_type(argname="argument rotate", value=rotate, expected_type=type_hints["rotate"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument shear", value=shear, expected_type=type_hints["shear"])
            check_type(argname="argument trim", value=trim, expected_type=type_hints["trim"])
            check_type(argname="argument unsharp_mask", value=unsharp_mask, expected_type=type_hints["unsharp_mask"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if append is not None:
            self._values["append"] = append
        if aspect_crop is not None:
            self._values["aspect_crop"] = aspect_crop
        if background_color is not None:
            self._values["background_color"] = background_color
        if blur is not None:
            self._values["blur"] = blur
        if chroma_key is not None:
            self._values["chroma_key"] = chroma_key
        if composite is not None:
            self._values["composite"] = composite
        if compound is not None:
            self._values["compound"] = compound
        if contrast is not None:
            self._values["contrast"] = contrast
        if crop is not None:
            self._values["crop"] = crop
        if face_crop is not None:
            self._values["face_crop"] = face_crop
        if feature_crop is not None:
            self._values["feature_crop"] = feature_crop
        if fit_and_fill is not None:
            self._values["fit_and_fill"] = fit_and_fill
        if goop is not None:
            self._values["goop"] = goop
        if grayscale is not None:
            self._values["grayscale"] = grayscale
        if hsl is not None:
            self._values["hsl"] = hsl
        if hsv is not None:
            self._values["hsv"] = hsv
        if if_dimension is not None:
            self._values["if_dimension"] = if_dimension
        if if_orientation is not None:
            self._values["if_orientation"] = if_orientation
        if im_query is not None:
            self._values["im_query"] = im_query
        if max_colors is not None:
            self._values["max_colors"] = max_colors
        if mirror is not None:
            self._values["mirror"] = mirror
        if mono_hue is not None:
            self._values["mono_hue"] = mono_hue
        if opacity is not None:
            self._values["opacity"] = opacity
        if region_of_interest_crop is not None:
            self._values["region_of_interest_crop"] = region_of_interest_crop
        if relative_crop is not None:
            self._values["relative_crop"] = relative_crop
        if remove_color is not None:
            self._values["remove_color"] = remove_color
        if resize is not None:
            self._values["resize"] = resize
        if rotate is not None:
            self._values["rotate"] = rotate
        if scale is not None:
            self._values["scale"] = scale
        if shear is not None:
            self._values["shear"] = shear
        if trim is not None:
            self._values["trim"] = trim
        if unsharp_mask is not None:
            self._values["unsharp_mask"] = unsharp_mask

    @builtins.property
    def append(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationAppend"]]]:
        '''append block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        '''
        result = self._values.get("append")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationAppend"]]], result)

    @builtins.property
    def aspect_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationAspectCrop"]]]:
        '''aspect_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        '''
        result = self._values.get("aspect_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationAspectCrop"]]], result)

    @builtins.property
    def background_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationBackgroundColor"]]]:
        '''background_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        '''
        result = self._values.get("background_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationBackgroundColor"]]], result)

    @builtins.property
    def blur(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationBlur"]]]:
        '''blur block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        '''
        result = self._values.get("blur")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationBlur"]]], result)

    @builtins.property
    def chroma_key(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationChromaKey"]]]:
        '''chroma_key block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        '''
        result = self._values.get("chroma_key")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationChromaKey"]]], result)

    @builtins.property
    def composite(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationComposite"]]]:
        '''composite block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        '''
        result = self._values.get("composite")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationComposite"]]], result)

    @builtins.property
    def compound(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationCompound"]]]:
        '''compound block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        '''
        result = self._values.get("compound")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationCompound"]]], result)

    @builtins.property
    def contrast(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationContrast"]]]:
        '''contrast block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationContrast"]]], result)

    @builtins.property
    def crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationCrop"]]]:
        '''crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        '''
        result = self._values.get("crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationCrop"]]], result)

    @builtins.property
    def face_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationFaceCrop"]]]:
        '''face_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        '''
        result = self._values.get("face_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationFaceCrop"]]], result)

    @builtins.property
    def feature_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationFeatureCrop"]]]:
        '''feature_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        '''
        result = self._values.get("feature_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationFeatureCrop"]]], result)

    @builtins.property
    def fit_and_fill(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationFitAndFill"]]]:
        '''fit_and_fill block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        '''
        result = self._values.get("fit_and_fill")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationFitAndFill"]]], result)

    @builtins.property
    def goop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationGoop"]]]:
        '''goop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        '''
        result = self._values.get("goop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationGoop"]]], result)

    @builtins.property
    def grayscale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationGrayscale"]]]:
        '''grayscale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        '''
        result = self._values.get("grayscale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationGrayscale"]]], result)

    @builtins.property
    def hsl(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationHsl"]]]:
        '''hsl block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        '''
        result = self._values.get("hsl")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationHsl"]]], result)

    @builtins.property
    def hsv(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationHsv"]]]:
        '''hsv block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        '''
        result = self._values.get("hsv")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationHsv"]]], result)

    @builtins.property
    def if_dimension(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfDimension"]]]:
        '''if_dimension block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        '''
        result = self._values.get("if_dimension")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfDimension"]]], result)

    @builtins.property
    def if_orientation(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfOrientation"]]]:
        '''if_orientation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        '''
        result = self._values.get("if_orientation")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfOrientation"]]], result)

    @builtins.property
    def im_query(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationImQuery"]]]:
        '''im_query block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        '''
        result = self._values.get("im_query")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationImQuery"]]], result)

    @builtins.property
    def max_colors(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationMaxColors"]]]:
        '''max_colors block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        '''
        result = self._values.get("max_colors")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationMaxColors"]]], result)

    @builtins.property
    def mirror(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationMirror"]]]:
        '''mirror block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        '''
        result = self._values.get("mirror")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationMirror"]]], result)

    @builtins.property
    def mono_hue(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationMonoHue"]]]:
        '''mono_hue block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        '''
        result = self._values.get("mono_hue")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationMonoHue"]]], result)

    @builtins.property
    def opacity(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationOpacity"]]]:
        '''opacity block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationOpacity"]]], result)

    @builtins.property
    def region_of_interest_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationRegionOfInterestCrop"]]]:
        '''region_of_interest_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        '''
        result = self._values.get("region_of_interest_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationRegionOfInterestCrop"]]], result)

    @builtins.property
    def relative_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationRelativeCrop"]]]:
        '''relative_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        '''
        result = self._values.get("relative_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationRelativeCrop"]]], result)

    @builtins.property
    def remove_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationRemoveColor"]]]:
        '''remove_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        '''
        result = self._values.get("remove_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationRemoveColor"]]], result)

    @builtins.property
    def resize(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationResize"]]]:
        '''resize block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        '''
        result = self._values.get("resize")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationResize"]]], result)

    @builtins.property
    def rotate(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationRotate"]]]:
        '''rotate block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        '''
        result = self._values.get("rotate")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationRotate"]]], result)

    @builtins.property
    def scale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationScale"]]]:
        '''scale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationScale"]]], result)

    @builtins.property
    def shear(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationShear"]]]:
        '''shear block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        '''
        result = self._values.get("shear")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationShear"]]], result)

    @builtins.property
    def trim(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationTrim"]]]:
        '''trim block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        '''
        result = self._values.get("trim")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationTrim"]]], result)

    @builtins.property
    def unsharp_mask(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationUnsharpMask"]]]:
        '''unsharp_mask block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        result = self._values.get("unsharp_mask")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationUnsharpMask"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationAppend",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_priority": "gravityPriority",
        "gravity_priority_var": "gravityPriorityVar",
        "gravity_var": "gravityVar",
        "preserve_minor_dimension": "preserveMinorDimension",
        "preserve_minor_dimension_var": "preserveMinorDimensionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationAppend:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationAppendImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_priority: typing.Optional[builtins.str] = None,
        gravity_priority_var: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        preserve_minor_dimension: typing.Optional[builtins.str] = None,
        preserve_minor_dimension_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Specifies where to place the ``image`` relative to the source image. The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_priority: Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal. The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority DataAkamaiImagingPolicyImage#gravity_priority}
        :param gravity_priority_var: Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal. The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority_var DataAkamaiImagingPolicyImage#gravity_priority_var}
        :param gravity_var: Specifies where to place the ``image`` relative to the source image. The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param preserve_minor_dimension: Whether to preserve the source image's minor dimension, ``false`` by default. The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension DataAkamaiImagingPolicyImage#preserve_minor_dimension}
        :param preserve_minor_dimension_var: Whether to preserve the source image's minor dimension, ``false`` by default. The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension_var DataAkamaiImagingPolicyImage#preserve_minor_dimension_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationAppendImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6ca27d8768d8e66fee35a0bc25cc7c9831de094b6f730d72eb896f486e01cdc7)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_priority", value=gravity_priority, expected_type=type_hints["gravity_priority"])
            check_type(argname="argument gravity_priority_var", value=gravity_priority_var, expected_type=type_hints["gravity_priority_var"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument preserve_minor_dimension", value=preserve_minor_dimension, expected_type=type_hints["preserve_minor_dimension"])
            check_type(argname="argument preserve_minor_dimension_var", value=preserve_minor_dimension_var, expected_type=type_hints["preserve_minor_dimension_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_priority is not None:
            self._values["gravity_priority"] = gravity_priority
        if gravity_priority_var is not None:
            self._values["gravity_priority_var"] = gravity_priority_var
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if preserve_minor_dimension is not None:
            self._values["preserve_minor_dimension"] = preserve_minor_dimension
        if preserve_minor_dimension_var is not None:
            self._values["preserve_minor_dimension_var"] = preserve_minor_dimension_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationAppendImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationAppendImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Specifies where to place the ``image`` relative to the source image.

        The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_priority(self) -> typing.Optional[builtins.str]:
        '''Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal.

        The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority DataAkamaiImagingPolicyImage#gravity_priority}
        '''
        result = self._values.get("gravity_priority")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_priority_var(self) -> typing.Optional[builtins.str]:
        '''Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal.

        The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority_var DataAkamaiImagingPolicyImage#gravity_priority_var}
        '''
        result = self._values.get("gravity_priority_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Specifies where to place the ``image`` relative to the source image.

        The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def preserve_minor_dimension(self) -> typing.Optional[builtins.str]:
        '''Whether to preserve the source image's minor dimension, ``false`` by default.

        The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension DataAkamaiImagingPolicyImage#preserve_minor_dimension}
        '''
        result = self._values.get("preserve_minor_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def preserve_minor_dimension_var(self) -> typing.Optional[builtins.str]:
        '''Whether to preserve the source image's minor dimension, ``false`` by default.

        The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension_var DataAkamaiImagingPolicyImage#preserve_minor_dimension_var}
        '''
        result = self._values.get("preserve_minor_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationAppend(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationAppendImage",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationAppendImage:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationAppendImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationAppendImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationAppendImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__30c92f19e6513270e61160fb3a8bdd564323fd1324059a46c8b3fa22f421c5a2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationAppendImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationAppendImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationAppendImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e05dd5710b878b7f6cce913966dbee77b7c1800b186037a943cdc3168d29a6ac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationAppendList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationAppendList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6400609d54c77541bfc722b0951988aebefd10c133f72002fa21f55b9d54e112)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationAppendOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__13135d8aba204809bbda63c5c0d66611750ab8b883f2fbb268bf3248443481cf)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationAppendOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b32a967e780079908c1f02ea04fb5fecd94a920b5b96a2ed64209336c07fffff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c4fa20cefe2c894ed166366c9ade0e674c269a956f84616748a05ed365bfd5be)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cb08c0d5713095b029b5bb8ce8e645908376244db83f9abaad39bfcc768e3682)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationAppend]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationAppend]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationAppend]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f4a86cbd564b05d60cb150d6a8d7e06bc7c5256cfd2c8cbd45774ae0d205122f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationAppendOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationAppendOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab3db10d7c2d7cb477ea28f6be00a74144652ef17df08b20c0e7dc119a33966b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationAppendImage()

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityPriority")
    def reset_gravity_priority(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityPriority", []))

    @jsii.member(jsii_name="resetGravityPriorityVar")
    def reset_gravity_priority_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityPriorityVar", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPreserveMinorDimension")
    def reset_preserve_minor_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPreserveMinorDimension", []))

    @jsii.member(jsii_name="resetPreserveMinorDimensionVar")
    def reset_preserve_minor_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPreserveMinorDimensionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationAppendImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationAppendImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityInput")
    def gravity_priority_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityPriorityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityVarInput")
    def gravity_priority_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityPriorityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationAppendImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationAppendImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionInput")
    def preserve_minor_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "preserveMinorDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionVarInput")
    def preserve_minor_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "preserveMinorDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4f0a9f77a5869953702c91c390774062a0aedf058f072540fba73abfaead7fd5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityPriority")
    def gravity_priority(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityPriority"))

    @gravity_priority.setter
    def gravity_priority(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8669783d3027835789bf279c9bd07d39c76d9132700a625137eb565b601390fe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityPriority", value)

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityVar")
    def gravity_priority_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityPriorityVar"))

    @gravity_priority_var.setter
    def gravity_priority_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__17a84838b694ffe8e65a6caf3e8bd6768be3f0449fb36cbc2daff8e7cc26c5bd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityPriorityVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9f3d1fd03788beb4d663278c17c4ff9dc6e56a2d7865a4e37884a01847d98092)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimension")
    def preserve_minor_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "preserveMinorDimension"))

    @preserve_minor_dimension.setter
    def preserve_minor_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__648e80bc202704890c81b43e72f87118b75838618ab15a9ae70b61da3802e878)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "preserveMinorDimension", value)

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionVar")
    def preserve_minor_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "preserveMinorDimensionVar"))

    @preserve_minor_dimension_var.setter
    def preserve_minor_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__55cfb799dd0ce1c7672a674f74455a392774a4e7b0ff68862e06d86a199e0a85)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "preserveMinorDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationAppend]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationAppend]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationAppend]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f89ebda3b9d5d5a4258a3cabaa34096c29c6de31616866674b046ddf59c3ffa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationAspectCrop",
    jsii_struct_bases=[],
    name_mapping={
        "allow_expansion": "allowExpansion",
        "allow_expansion_var": "allowExpansionVar",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationAspectCrop:
    def __init__(
        self,
        *,
        allow_expansion: typing.Optional[builtins.str] = None,
        allow_expansion_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_expansion: Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image. Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        :param allow_expansion_var: Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image. Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        :param height: The height term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The width term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        :param x_position: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f67125bcafb9d8deefd693fcfb3a059972aa289c53ce34c8316c2f4b460a05fc)
            check_type(argname="argument allow_expansion", value=allow_expansion, expected_type=type_hints["allow_expansion"])
            check_type(argname="argument allow_expansion_var", value=allow_expansion_var, expected_type=type_hints["allow_expansion_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if allow_expansion is not None:
            self._values["allow_expansion"] = allow_expansion
        if allow_expansion_var is not None:
            self._values["allow_expansion_var"] = allow_expansion_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def allow_expansion(self) -> typing.Optional[builtins.str]:
        '''Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image.

        Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        '''
        result = self._values.get("allow_expansion")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def allow_expansion_var(self) -> typing.Optional[builtins.str]:
        '''Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image.

        Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        '''
        result = self._values.get("allow_expansion_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationAspectCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationAspectCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationAspectCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8c798748227da8159db0799ca0d8f3e526f360d8ecfba97abf77fe7cc7878629)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationAspectCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2f60798798538e64d34f9621148f9886ea8026dc507a863bf1b94d27cc215055)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationAspectCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d1e5d040f9a21b7cbcf80e41379751a537cd34f44197cb4474fb772d442c3092)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__548672d7416f7c5b6433516618b4dad1f45a5e1d41bf122f478a212c1333386e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea7197617ef24531dab9937fc9103c878c2d1b5bd892ab4fa04fa285f348f662)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationAspectCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationAspectCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationAspectCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f94decca908f207bbd8d213b7f434e258a5efac114cc9c1a414a3c320ce2bee3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationAspectCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationAspectCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a84e39b81bf838ac9becbbafc960507d50ee395927071aaddf2c40965e9422f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAllowExpansion")
    def reset_allow_expansion(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansion", []))

    @jsii.member(jsii_name="resetAllowExpansionVar")
    def reset_allow_expansion_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansionVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionInput")
    def allow_expansion_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVarInput")
    def allow_expansion_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansion")
    def allow_expansion(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansion"))

    @allow_expansion.setter
    def allow_expansion(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a90b2581c214b91affb4de17c5b23bf3bf0520f2c5e97f52dfc2cd82f872c203)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansion", value)

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVar")
    def allow_expansion_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansionVar"))

    @allow_expansion_var.setter
    def allow_expansion_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__371134fa7912984d6b9675c98c78240e3fd5e2b59acda015e3547fff1a94fbf5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansionVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__48d19159036bad8dc9496e197570215abf79636aede8727042381c841983bd99)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cc5d166bb6b218fbbeac3b903ecac51d97579155de11e73a5222020d5ed95d98)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0083bce46c7d64fb4d66d5c44978db1f6ce84c87c133c7cb265b378acaff6e2f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__786f105622a6cd61b5d344b64ea98280271954adff641a9eba7e3fa63abfb230)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__27944b9669d7972e922f9b1503a8069b0e8cfe77d2dae4b5456f386df9c81534)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7a54cb2da53d68419ac1bce644e6c580e684c472102fc171f04a7f58a4242528)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cbf6016ad8e56451b12753a1cacee4e990cd28e50f02e8263eb6e80c7cb8ca3f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eb6c01a061881632e0c1134abf78de08e8bf203cab67ecb68a8395daa48035b2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationAspectCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationAspectCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationAspectCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1b1b1bfd3d867a4e264c114fbf494309b732387545eb051a7eec4fd832249094)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationBackgroundColor",
    jsii_struct_bases=[],
    name_mapping={"color": "color", "color_var": "colorVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationBackgroundColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__de3433c67072d63c17cd690b5be94c3e4ae94e8bb6dd0e2493b537dad862b997)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationBackgroundColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationBackgroundColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationBackgroundColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__65dcaa785155823ca45a0bf5654e35566e6753e5f7e9296f391652ea01e6f662)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationBackgroundColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__85cdc64a47be91ac697fe5d26e5ec3167b30be937b011c99c5ba758c142d9dda)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationBackgroundColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__51b3f348db8c2e0b056ba316a63a4b3764b052d7ba0672c1e03219db73568c29)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__02ed464b3249f879836f415b9321e7014922ad3c1a9f51891a7a9e7527479eae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b9e8e00ca09ace2c1f28957282ec7abafbab947fa3feb861254f68095e80f03c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationBackgroundColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationBackgroundColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c3609072836f1405714452f12d6a3e198fc647ff94fd5efcfff6bb46a84c544e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationBackgroundColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationBackgroundColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fe167bd0b1a8c6d11234aec8672fa3d640d9f19620ccd370fce6b36bd0f2ded5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b3aec684fb532dbb1339227d31e92c8c214ae072f1a0965be23b1a0b95c1fa70)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6d9f3281aeb5a171bb4dafa680ce6104c904e1985b3a18c3c1a06a250fa1c10f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationBackgroundColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationBackgroundColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationBackgroundColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c9cb348ce67ae6e0b891eec5e8828da67d3d99ae40f35daaafe02bac033c98c4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationBlur",
    jsii_struct_bases=[],
    name_mapping={"sigma": "sigma", "sigma_var": "sigmaVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationBlur:
    def __init__(
        self,
        *,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param sigma: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__88eca306f127e5751379de8b31e76e4807033117a9559ab6734afcc53bf23d56)
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationBlur(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationBlurList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationBlurList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9891f52365e48ca6fff5c4b7e20281686f3e13972c435de073341a44a463b9bc)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationBlurOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6868c1690d7d4d755bd325448da5a2f44eb320188eb0ca48f2202c9185de4619)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationBlurOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d36715be9ad939f856289025328523f1435dd43b2869e61c08610e1f1d3bed6b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__891a8cad8fe5cfb7c266780ef78140028691b43b9d4f0236592cd9dd387cf37e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__23f481be2de0dd93b42b91a62aaacc366f4c4d71129e6ef3b8f3c4c01945636b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationBlur]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationBlur]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__77c0fe173f38a8355c05f6355a2807a66ac01076e58f18657c264c6c2e26153e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationBlurOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationBlurOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8d8c6969810963c3f9140734f53f9568d5552bc9df2fb42e96c003e9a40be6f0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b28f55364be7ff044aa4f505aa8c3a84c9247b54cdab9e5d1474fff7438f5914)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e7865ed029cc90d4a62d6c62d1a132a7b67901cfe50a779203a2c4ec76bf6961)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationBlur]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationBlur]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationBlur]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cb66fe69a5a5662484e849612787328214e5b29c1a20c92ca6c8a3fde8581c6e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationChromaKey",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_feather": "hueFeather",
        "hue_feather_var": "hueFeatherVar",
        "hue_tolerance": "hueTolerance",
        "hue_tolerance_var": "hueToleranceVar",
        "hue_var": "hueVar",
        "lightness_feather": "lightnessFeather",
        "lightness_feather_var": "lightnessFeatherVar",
        "lightness_tolerance": "lightnessTolerance",
        "lightness_tolerance_var": "lightnessToleranceVar",
        "saturation_feather": "saturationFeather",
        "saturation_feather_var": "saturationFeatherVar",
        "saturation_tolerance": "saturationTolerance",
        "saturation_tolerance_var": "saturationToleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationChromaKey:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_feather: typing.Optional[builtins.str] = None,
        hue_feather_var: typing.Optional[builtins.str] = None,
        hue_tolerance: typing.Optional[builtins.str] = None,
        hue_tolerance_var: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness_feather: typing.Optional[builtins.str] = None,
        lightness_feather_var: typing.Optional[builtins.str] = None,
        lightness_tolerance: typing.Optional[builtins.str] = None,
        lightness_tolerance_var: typing.Optional[builtins.str] = None,
        saturation_feather: typing.Optional[builtins.str] = None,
        saturation_feather_var: typing.Optional[builtins.str] = None,
        saturation_tolerance: typing.Optional[builtins.str] = None,
        saturation_tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_feather: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        :param hue_feather_var: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        :param hue_tolerance: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        :param hue_tolerance_var: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        :param hue_var: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness_feather: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        :param lightness_feather_var: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        :param lightness_tolerance: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        :param lightness_tolerance_var: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        :param saturation_feather: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        :param saturation_feather_var: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        :param saturation_tolerance: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        :param saturation_tolerance_var: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f3a442d1c38e08bfbd6bc63a8cd786b9af593f51707590545e80fe8e1285bb1b)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_feather", value=hue_feather, expected_type=type_hints["hue_feather"])
            check_type(argname="argument hue_feather_var", value=hue_feather_var, expected_type=type_hints["hue_feather_var"])
            check_type(argname="argument hue_tolerance", value=hue_tolerance, expected_type=type_hints["hue_tolerance"])
            check_type(argname="argument hue_tolerance_var", value=hue_tolerance_var, expected_type=type_hints["hue_tolerance_var"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness_feather", value=lightness_feather, expected_type=type_hints["lightness_feather"])
            check_type(argname="argument lightness_feather_var", value=lightness_feather_var, expected_type=type_hints["lightness_feather_var"])
            check_type(argname="argument lightness_tolerance", value=lightness_tolerance, expected_type=type_hints["lightness_tolerance"])
            check_type(argname="argument lightness_tolerance_var", value=lightness_tolerance_var, expected_type=type_hints["lightness_tolerance_var"])
            check_type(argname="argument saturation_feather", value=saturation_feather, expected_type=type_hints["saturation_feather"])
            check_type(argname="argument saturation_feather_var", value=saturation_feather_var, expected_type=type_hints["saturation_feather_var"])
            check_type(argname="argument saturation_tolerance", value=saturation_tolerance, expected_type=type_hints["saturation_tolerance"])
            check_type(argname="argument saturation_tolerance_var", value=saturation_tolerance_var, expected_type=type_hints["saturation_tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_feather is not None:
            self._values["hue_feather"] = hue_feather
        if hue_feather_var is not None:
            self._values["hue_feather_var"] = hue_feather_var
        if hue_tolerance is not None:
            self._values["hue_tolerance"] = hue_tolerance
        if hue_tolerance_var is not None:
            self._values["hue_tolerance_var"] = hue_tolerance_var
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness_feather is not None:
            self._values["lightness_feather"] = lightness_feather
        if lightness_feather_var is not None:
            self._values["lightness_feather_var"] = lightness_feather_var
        if lightness_tolerance is not None:
            self._values["lightness_tolerance"] = lightness_tolerance
        if lightness_tolerance_var is not None:
            self._values["lightness_tolerance_var"] = lightness_tolerance_var
        if saturation_feather is not None:
            self._values["saturation_feather"] = saturation_feather
        if saturation_feather_var is not None:
            self._values["saturation_feather_var"] = saturation_feather_var
        if saturation_tolerance is not None:
            self._values["saturation_tolerance"] = saturation_tolerance
        if saturation_tolerance_var is not None:
            self._values["saturation_tolerance_var"] = saturation_tolerance_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        '''
        result = self._values.get("hue_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        '''
        result = self._values.get("hue_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        '''
        result = self._values.get("hue_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        '''
        result = self._values.get("hue_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        '''
        result = self._values.get("lightness_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        '''
        result = self._values.get("lightness_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        '''
        result = self._values.get("lightness_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        '''
        result = self._values.get("lightness_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        '''
        result = self._values.get("saturation_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        '''
        result = self._values.get("saturation_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        '''
        result = self._values.get("saturation_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        result = self._values.get("saturation_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationChromaKey(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationChromaKeyList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationChromaKeyList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__38617b01278d50e7723dd957ff2e78cde9f9681c5040f50fa6fd0d7158ef8798)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationChromaKeyOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__78ee240e47d3cd9f628cb009f47a30bfad866eb344577d244900f45d263f1dbc)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationChromaKeyOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4c89bea9809e2f7c81a4193a65511ac54127d23439e9dcae330212f8875f2fd5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1a803bdcd286f84d9953117cb42122c171587ca600c252b9326cc790c9058c0f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ab20e0357335826f351b80784d531b46cb41a4daa39cb954709731b804c87dd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationChromaKey]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationChromaKey]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a53817c8ccebe620ae7518c695857dd4b30190ebfceb8805dd915a14a428256f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationChromaKeyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationChromaKeyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a034e2f7c5bdd989ad98e9f2fa502ebc4cf039db42adac1a004ba9f61258ea2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueFeather")
    def reset_hue_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeather", []))

    @jsii.member(jsii_name="resetHueFeatherVar")
    def reset_hue_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeatherVar", []))

    @jsii.member(jsii_name="resetHueTolerance")
    def reset_hue_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueTolerance", []))

    @jsii.member(jsii_name="resetHueToleranceVar")
    def reset_hue_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueToleranceVar", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightnessFeather")
    def reset_lightness_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeather", []))

    @jsii.member(jsii_name="resetLightnessFeatherVar")
    def reset_lightness_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeatherVar", []))

    @jsii.member(jsii_name="resetLightnessTolerance")
    def reset_lightness_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessTolerance", []))

    @jsii.member(jsii_name="resetLightnessToleranceVar")
    def reset_lightness_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessToleranceVar", []))

    @jsii.member(jsii_name="resetSaturationFeather")
    def reset_saturation_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeather", []))

    @jsii.member(jsii_name="resetSaturationFeatherVar")
    def reset_saturation_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeatherVar", []))

    @jsii.member(jsii_name="resetSaturationTolerance")
    def reset_saturation_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationTolerance", []))

    @jsii.member(jsii_name="resetSaturationToleranceVar")
    def reset_saturation_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherInput")
    def hue_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVarInput")
    def hue_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceInput")
    def hue_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVarInput")
    def hue_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherInput")
    def lightness_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVarInput")
    def lightness_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceInput")
    def lightness_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVarInput")
    def lightness_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherInput")
    def saturation_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVarInput")
    def saturation_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceInput")
    def saturation_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVarInput")
    def saturation_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ad02eb06c511b7092127414752abaf31448d9a6bc4f5ccd177bf50841b35294)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeather")
    def hue_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeather"))

    @hue_feather.setter
    def hue_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__669a3346ca4fe03000aead4267fdaf4b533812f2a5994bd77dfc71be41eb0184)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeather", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVar")
    def hue_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeatherVar"))

    @hue_feather_var.setter
    def hue_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6530be3b0b59d05fa210cdf2590e0544c02ee1feb14ed194a89452860a53b7aa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueTolerance")
    def hue_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueTolerance"))

    @hue_tolerance.setter
    def hue_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9e5e5a5ff7664232f2576b552845bc566673a8bf70a9045b633bda8cd0c6339a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVar")
    def hue_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueToleranceVar"))

    @hue_tolerance_var.setter
    def hue_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6ace11900273ffbde701725661fdd3e2d5b7714350354cc3d21cea7c9f994590)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__19517d29782b4b97e1c713a07acbbad58ed1a0bd75f6a64f1274d97247ee5549)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeather")
    def lightness_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeather"))

    @lightness_feather.setter
    def lightness_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8ce5c115fe3034dc0da33be0f68a36df3166b0608b7862e0387aea9157c854ee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeather", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVar")
    def lightness_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeatherVar"))

    @lightness_feather_var.setter
    def lightness_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e378014fcfd1a634d272629a31244030635c53ed49cbb39a42dcd3388e11ec10)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessTolerance")
    def lightness_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessTolerance"))

    @lightness_tolerance.setter
    def lightness_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__730a592b7ac9020f46908fa69e75cd180871d9c586972a352b995f0fc1b76bc2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVar")
    def lightness_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessToleranceVar"))

    @lightness_tolerance_var.setter
    def lightness_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fc7a9a6094602a2e8d8cfa6584dc93e3099e84ee30bbab535bc0fc11378af335)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeather")
    def saturation_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeather"))

    @saturation_feather.setter
    def saturation_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fdd211bbd5bfed879d0272f39dccfa3d90e0d50af0710db56745db28a3268467)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeather", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVar")
    def saturation_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeatherVar"))

    @saturation_feather_var.setter
    def saturation_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__97f4d6234163b6c2a9693dd45bfc46c68f5d90edeffe35348c23c2ed93b8c7e6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationTolerance")
    def saturation_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationTolerance"))

    @saturation_tolerance.setter
    def saturation_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b0fc198c63298df35640d607a069fdc623b02e120f610d395256f63a443ff313)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVar")
    def saturation_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationToleranceVar"))

    @saturation_tolerance_var.setter
    def saturation_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__445a0d5852884591e7dc53e251b57eefa0e143979bfaa1c109fbec9794f1fa2e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationChromaKey]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationChromaKey]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationChromaKey]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__27f5b946db5e59d2e490d1cbeada1712faec0cf3c1a439dbd2c8f7125a1318be)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationComposite",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "placement": "placement",
        "placement_var": "placementVar",
        "scale": "scale",
        "scale_dimension": "scaleDimension",
        "scale_dimension_var": "scaleDimensionVar",
        "scale_var": "scaleVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationComposite:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationCompositeImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        placement: typing.Optional[builtins.str] = None,
        placement_var: typing.Optional[builtins.str] = None,
        scale: typing.Optional[builtins.str] = None,
        scale_dimension: typing.Optional[builtins.str] = None,
        scale_dimension_var: typing.Optional[builtins.str] = None,
        scale_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param placement: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        :param placement_var: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        :param scale: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param scale_dimension: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        :param scale_dimension_var: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        :param scale_var: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        :param x_position: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationCompositeImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d82874694244a300126d9861ff844720dd00b0e9cda5a5203bc302879644ecf)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument placement", value=placement, expected_type=type_hints["placement"])
            check_type(argname="argument placement_var", value=placement_var, expected_type=type_hints["placement_var"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument scale_dimension", value=scale_dimension, expected_type=type_hints["scale_dimension"])
            check_type(argname="argument scale_dimension_var", value=scale_dimension_var, expected_type=type_hints["scale_dimension_var"])
            check_type(argname="argument scale_var", value=scale_var, expected_type=type_hints["scale_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if placement is not None:
            self._values["placement"] = placement
        if placement_var is not None:
            self._values["placement_var"] = placement_var
        if scale is not None:
            self._values["scale"] = scale
        if scale_dimension is not None:
            self._values["scale_dimension"] = scale_dimension
        if scale_dimension_var is not None:
            self._values["scale_dimension_var"] = scale_dimension_var
        if scale_var is not None:
            self._values["scale_var"] = scale_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationCompositeImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationCompositeImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        '''
        result = self._values.get("placement")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement_var(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        '''
        result = self._values.get("placement_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        '''
        result = self._values.get("scale_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        '''
        result = self._values.get("scale_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        '''
        result = self._values.get("scale_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationComposite(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationCompositeImage",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationCompositeImage:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationCompositeImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationCompositeImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationCompositeImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa6aab16b85b5916f44c37fdc12c1c071f7bfc5ae191da985988cdb186c0af0d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationCompositeImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationCompositeImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dfb0d445e77b354053df5810a4a81f1e93b93d976b62cfa1eab3c5e1663a4e78)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationCompositeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationCompositeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__607216669f58a7fd09309a855ee4088b9fe92833f8874b362569f67888c4a8b8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationCompositeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__719da351bb7d38aec11d32538854293eb53471773368e172a29b7b28a39a7d5f)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationCompositeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__edd87665541c2bbb61288f8d18d56bbfe3b77bca59a7a834cc84e26fba21e1e0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__227ce7eea00b8a3773226edd4f4dc4a5d211a93df1809daefbd1d0253672b007)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__589221dd7a2ffc1468421f482e76346cbceec5cab77d38d5ee612c6b6bb19d0e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationComposite]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationComposite]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__564dc9c77786123e9e5de1f11050bc0cd90a1108c0373f25831df062292edff8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationCompositeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationCompositeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fd36e3a5358f3b0f2927067366b3407621f0dbbf00c90a21a393e02db7961ac5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationCompositeImage()

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPlacement")
    def reset_placement(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacement", []))

    @jsii.member(jsii_name="resetPlacementVar")
    def reset_placement_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacementVar", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetScaleDimension")
    def reset_scale_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimension", []))

    @jsii.member(jsii_name="resetScaleDimensionVar")
    def reset_scale_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimensionVar", []))

    @jsii.member(jsii_name="resetScaleVar")
    def reset_scale_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationCompositeImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationCompositeImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationCompositeImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="placementInput")
    def placement_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementInput"))

    @builtins.property
    @jsii.member(jsii_name="placementVarInput")
    def placement_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionInput")
    def scale_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVarInput")
    def scale_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleVarInput")
    def scale_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2128d09a89c2f56a6f36799085b2527c5d74451194989487c06fe0750bade740)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fe3273bbeb758af9a690064ea5c979c3dc82cf3e2c4aec8254d146447bbdb133)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="placement")
    def placement(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placement"))

    @placement.setter
    def placement(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__82fe394286a4080d3d85dd18d11e191a9cbcdeee036107468abd3f1657e884bf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placement", value)

    @builtins.property
    @jsii.member(jsii_name="placementVar")
    def placement_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placementVar"))

    @placement_var.setter
    def placement_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__893a45523f019eb39c3dc86de5dd98497cb39dfb23f171080d4ba45bf8389c09)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placementVar", value)

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scale"))

    @scale.setter
    def scale(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e1c55852cfb458380a79c27d2c99ccb0633bf4d37f31c2d19f95ca06f500554a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scale", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimension")
    def scale_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimension"))

    @scale_dimension.setter
    def scale_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__10d131cd73398017051979a51bbb6b75fc574c3ab3aeeae1e1eb0542b76142de)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimension", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVar")
    def scale_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimensionVar"))

    @scale_dimension_var.setter
    def scale_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b83f4e336ebbbaab918cb9fa934129afe6bf2c232b425d08fa6546353418a8f2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="scaleVar")
    def scale_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleVar"))

    @scale_var.setter
    def scale_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c7b0645a31877ddbf58b14bace694553f2a0c4d304bb3d1eb7c7ecf66052dced)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__15498965b3d6ff57801965e2f9b28423469dbd9270d7d56e9329e3c22c088a7e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__91aeeecd763081b794f1e3a82368a90d1f146dc0f9735b90941a3dcbc7dacd14)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ba133994bfe822b4ac7f70818522d8452aa58cfef6693d22f9304469ee44f25d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c6a454c028eb54c9557435825500eb4ad91cf53ba8ae4f3d6a67e89a8253eed7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationComposite]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationComposite]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationComposite]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1eeca2e47461df7925f930eb3a1cb30832c428b4ff62fb2d2947b1dbae62fcda)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationCompound",
    jsii_struct_bases=[],
    name_mapping={"transformations": "transformations"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationCompound:
    def __init__(
        self,
        *,
        transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param transformations: transformations block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__07d1f2298a32aad5989b003b50f50c974fbf14f9ca80b9f5688009452df127ad)
            check_type(argname="argument transformations", value=transformations, expected_type=type_hints["transformations"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if transformations is not None:
            self._values["transformations"] = transformations

    @builtins.property
    def transformations(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationCompoundTransformations"]]]:
        '''transformations block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        result = self._values.get("transformations")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationCompoundTransformations"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationCompound(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationCompoundList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationCompoundList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a2e4d30cb0bb926dcdb883366997352d6ac511f94c235faeadd4371b7f00da57)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationCompoundOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8bf6af5d97edb0eef55d9f3a302bd2772fa1bde864efea27218f2a170a44476b)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationCompoundOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__88716f3692a90181e5c038f2062cc460a3f3b8603b3cf70154e71855266320f4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a600b482bde75c1e0cfcd92de649e787f4702c304aef6642929e893f25e70f57)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__80401637dfe37ed654b4bf261815c9d642f551c0a592092b8ae65bd40d1780d3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationCompound]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationCompound]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6af5cc01fc250b48f897f156de6e162a850ef57e9862b827d9c7c22b2d648fbc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationCompoundOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationCompoundOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__16c721c53ce648207efa0646ba05dc4c09968896fa8af01a8a26f92ca88d3620)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformations")
    def put_transformations(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0512f9419689b99425912e91ed74e87ea659e1acc402081f5ba810e3b55def7d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTransformations", [value]))

    @jsii.member(jsii_name="resetTransformations")
    def reset_transformations(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformations", []))

    @builtins.property
    @jsii.member(jsii_name="transformations")
    def transformations(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationCompoundTransformationsList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationCompoundTransformationsList", jsii.get(self, "transformations"))

    @builtins.property
    @jsii.member(jsii_name="transformationsInput")
    def transformations_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationCompoundTransformations"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationCompoundTransformations"]]], jsii.get(self, "transformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationCompound]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationCompound]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationCompound]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c5ed7909d7b0081e2ae62e293001c268fd29d2a5091f21d4af8259bd5e653a20)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationCompoundTransformations",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationCompoundTransformations:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationCompoundTransformations(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationCompoundTransformationsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationCompoundTransformationsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eb3e1431ae8feedcbc5cd0699b1be637aa12c85ec31f9bf9014d45d505e7f312)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationCompoundTransformationsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2cd33e3143f64d2582bc0fe3a9398b018c150a452464cb85abd4f9d109ae2d33)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationCompoundTransformationsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4cc1211ae7bcb68f766217be5117af555c43797e3064756f698efba08ed03003)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e2a2d278c568469061b5e7bec4e5682ee1c710ef3c0f83a393c00e85a2647035)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bce1cdb3b941f128628d396a52df4bfc903220b13218f9a5b84d869a17787f14)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationCompoundTransformations]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationCompoundTransformations]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationCompoundTransformations]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a823fba7aa6bdf7d299e0527716b328ecbad91cf47fed3aa52ac8edad66a20c2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationCompoundTransformationsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationCompoundTransformationsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__52db3870fcf906b691ffdfac32aac07a03043c306a4fb65c86d3ac3a51316964)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationCompoundTransformations]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationCompoundTransformations]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationCompoundTransformations]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ab5772b253d3c38b8c3854091e8938e1d92025d929e4e9e059042446c6ba54e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationContrast",
    jsii_struct_bases=[],
    name_mapping={
        "brightness": "brightness",
        "brightness_var": "brightnessVar",
        "contrast": "contrast",
        "contrast_var": "contrastVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationContrast:
    def __init__(
        self,
        *,
        brightness: typing.Optional[builtins.str] = None,
        brightness_var: typing.Optional[builtins.str] = None,
        contrast: typing.Optional[builtins.str] = None,
        contrast_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param brightness: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        :param brightness_var: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        :param contrast: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param contrast_var: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__12df38ebcf38ae15843070954470e4144de95323d5aa4a0742c5ab6795698b4e)
            check_type(argname="argument brightness", value=brightness, expected_type=type_hints["brightness"])
            check_type(argname="argument brightness_var", value=brightness_var, expected_type=type_hints["brightness_var"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument contrast_var", value=contrast_var, expected_type=type_hints["contrast_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if brightness is not None:
            self._values["brightness"] = brightness
        if brightness_var is not None:
            self._values["brightness_var"] = brightness_var
        if contrast is not None:
            self._values["contrast"] = contrast
        if contrast_var is not None:
            self._values["contrast_var"] = contrast_var

    @builtins.property
    def brightness(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        '''
        result = self._values.get("brightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def brightness_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        '''
        result = self._values.get("brightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        result = self._values.get("contrast_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationContrast(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationContrastList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationContrastList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__928566c583ab40cbb52a4f673f8f6f698a1d7177041c56ba91a96927906391ac)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationContrastOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a18c6cec3e7dceab6e192192bd7533ff855702b0293ae9edd345d994f1481df6)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationContrastOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c3557bec93ec4dc62e2c871d8e2664a63ca2f417a30e43a3611c181fd4d3eb44)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3aa543ad48ac769ca95940ee20335b7877963f9294b41384abeb1c93cfeb515d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a88c007631b9286bbefc86d8ba7fd5f3238da5dfea5f6c170121b4b1ae9c2308)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationContrast]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationContrast]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__96596e2d9dafc550fdbeb402c414c502a5abc03239eb6feae858e4ced96a94d0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationContrastOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationContrastOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0296668f0de35151668d75cdb77a576b701ccc99a9bb2f7950feaef606a9db12)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetBrightness")
    def reset_brightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightness", []))

    @jsii.member(jsii_name="resetBrightnessVar")
    def reset_brightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightnessVar", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetContrastVar")
    def reset_contrast_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrastVar", []))

    @builtins.property
    @jsii.member(jsii_name="brightnessInput")
    def brightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="brightnessVarInput")
    def brightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastVarInput")
    def contrast_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="brightness")
    def brightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightness"))

    @brightness.setter
    def brightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb569cd4b95fdb7c5a731954c51d8a5f13e98e51479acf64a226182dbbb60a22)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightness", value)

    @builtins.property
    @jsii.member(jsii_name="brightnessVar")
    def brightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightnessVar"))

    @brightness_var.setter
    def brightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__50c62ee340fb54e1cd8ec28b09c381355c6e447e369d69715df79310f5d0ae22)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrast"))

    @contrast.setter
    def contrast(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0814ebc4d4abd9952d8dc374e05f4f86ea3192da51eefb762dc56bc5a805af7e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrast", value)

    @builtins.property
    @jsii.member(jsii_name="contrastVar")
    def contrast_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrastVar"))

    @contrast_var.setter
    def contrast_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7169fd0c461b07c9a376b1c70a5cc755bea8d96579d3932550aeaa9815d9467d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrastVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationContrast]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationContrast]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationContrast]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e14389f8b3164813bbb843a7101029136c8b54ae840488adb54a90c578a0d53d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationCrop",
    jsii_struct_bases=[],
    name_mapping={
        "allow_expansion": "allowExpansion",
        "allow_expansion_var": "allowExpansionVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationCrop:
    def __init__(
        self,
        *,
        allow_expansion: typing.Optional[builtins.str] = None,
        allow_expansion_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_expansion: If cropping an area outside of the existing canvas, expands the image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        :param allow_expansion_var: If cropping an area outside of the existing canvas, expands the image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        :param gravity: Frame of reference for X and Y Positions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Frame of reference for X and Y Positions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The number of pixels to crop along the y-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The number of pixels to crop along the y-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The number of pixels to crop along the x-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The number of pixels to crop along the x-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        :param x_position: The x-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__32c951d2146257cc5cf712bbfd6b4e3bb9d131aca8d2a0d89fc95bef3322bf6d)
            check_type(argname="argument allow_expansion", value=allow_expansion, expected_type=type_hints["allow_expansion"])
            check_type(argname="argument allow_expansion_var", value=allow_expansion_var, expected_type=type_hints["allow_expansion_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if allow_expansion is not None:
            self._values["allow_expansion"] = allow_expansion
        if allow_expansion_var is not None:
            self._values["allow_expansion_var"] = allow_expansion_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def allow_expansion(self) -> typing.Optional[builtins.str]:
        '''If cropping an area outside of the existing canvas, expands the image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        '''
        result = self._values.get("allow_expansion")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def allow_expansion_var(self) -> typing.Optional[builtins.str]:
        '''If cropping an area outside of the existing canvas, expands the image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        '''
        result = self._values.get("allow_expansion_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Frame of reference for X and Y Positions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Frame of reference for X and Y Positions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the y-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the y-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the x-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the x-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__55d098a75e5ff4bd39bf6bb1acf53dcab4a7e2967bab9d7fbf91f8dca2a95fde)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__79fe6fa6d0362daafc56fc0a86432af5d8ba212db798afa2bd8728ca0c6da57e)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8271b5c0afcd7bb5e0ed9df91755bef5f664aea9488fb788ec83e76408420d1e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2499168cd210feca94dd7dc9f84cf05d014a9d57f893ca5246e2fd8972782182)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0bcbf64b78c770875df2cb4c99420542d68bc4ae210f629ef444a250ae92dc30)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__81e74c75c57b34d64de1ecc2dbbcaa8475a0c56f3fefd7f214e5e9d2cb67d24a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8e22c2fe4708323a5c8f27d7e197f580db3f349a7210c19ac8edf3b6697b9de5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAllowExpansion")
    def reset_allow_expansion(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansion", []))

    @jsii.member(jsii_name="resetAllowExpansionVar")
    def reset_allow_expansion_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansionVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionInput")
    def allow_expansion_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVarInput")
    def allow_expansion_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansion")
    def allow_expansion(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansion"))

    @allow_expansion.setter
    def allow_expansion(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e02549a95f2f830919bb90c9caf135c4ee7b34fe56d757900ef89b665ceb5cf0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansion", value)

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVar")
    def allow_expansion_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansionVar"))

    @allow_expansion_var.setter
    def allow_expansion_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0993447a675b9ea95e57edee40d59607852ca9cc755023d044d171e178238af5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansionVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__24d1a963662ac2de424c2f17d1512450f0798d750d6837ecc8f9604e05d4f97a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b89d6cd7056f0f3f6bc98e954b5066cb846cb970f8a8c845794e9d4e1b79c02f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__31d89e8f5e95411ba28a98359ae7d20a01ecb99ce08d5cbccfa0719a1dc34684)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c45375c87e0315740f4d8b5104bae471c94bf8c44b41b184ff175cae633ab2bd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ecd8eb3816966730f57bc9c450cac286cf85780d92589e0c78088b62192c0f03)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6a94c8bff70ce03b56048ddefbfbfa83c3c433617c3e92c39b932d446c48ca7f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__14f7ddffb796f8704c86c7f3f19742c0009fd4ead3f3c8d9579e0c26261e49e6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8b93f5721ad0e4c03c7f2e868dc9c710fa59baff239dfa15887bcac448eb3277)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a28e5b3b871f52e053c2439385626abacda3057ac8066044664c2b67e8498634)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4c5a23697458be1ad632487d255fa2c20890e0d8b1c6ee840593b7352344299c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0b1961a4626400ff577cea7dd66dc22ea5f333d021cd599d73130deebbc0ff91)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationFaceCrop",
    jsii_struct_bases=[],
    name_mapping={
        "algorithm": "algorithm",
        "algorithm_var": "algorithmVar",
        "confidence": "confidence",
        "confidence_var": "confidenceVar",
        "fail_gravity": "failGravity",
        "fail_gravity_var": "failGravityVar",
        "focus": "focus",
        "focus_var": "focusVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "padding": "padding",
        "padding_var": "paddingVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationFaceCrop:
    def __init__(
        self,
        *,
        algorithm: typing.Optional[builtins.str] = None,
        algorithm_var: typing.Optional[builtins.str] = None,
        confidence: typing.Optional[builtins.str] = None,
        confidence_var: typing.Optional[builtins.str] = None,
        fail_gravity: typing.Optional[builtins.str] = None,
        fail_gravity_var: typing.Optional[builtins.str] = None,
        focus: typing.Optional[builtins.str] = None,
        focus_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param algorithm: Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm DataAkamaiImagingPolicyImage#algorithm}
        :param algorithm_var: Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm_var DataAkamaiImagingPolicyImage#algorithm_var}
        :param confidence: With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image. Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence DataAkamaiImagingPolicyImage#confidence}
        :param confidence_var: With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image. Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence_var DataAkamaiImagingPolicyImage#confidence_var}
        :param fail_gravity: Controls placement of the crop if Image and Video Manager does not detect any faces in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        :param fail_gravity_var: Controls placement of the crop if Image and Video Manager does not detect any faces in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        :param focus: Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus DataAkamaiImagingPolicyImage#focus}
        :param focus_var: Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus_var DataAkamaiImagingPolicyImage#focus_var}
        :param gravity: Controls placement of the crop. Directions are relative to the face(s) plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Controls placement of the crop. Directions are relative to the face(s) plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param padding: The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        :param style: Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dda4409e0bf93518e452d7090ad5c4a17ff09246f886d07188015d14dbcc3a87)
            check_type(argname="argument algorithm", value=algorithm, expected_type=type_hints["algorithm"])
            check_type(argname="argument algorithm_var", value=algorithm_var, expected_type=type_hints["algorithm_var"])
            check_type(argname="argument confidence", value=confidence, expected_type=type_hints["confidence"])
            check_type(argname="argument confidence_var", value=confidence_var, expected_type=type_hints["confidence_var"])
            check_type(argname="argument fail_gravity", value=fail_gravity, expected_type=type_hints["fail_gravity"])
            check_type(argname="argument fail_gravity_var", value=fail_gravity_var, expected_type=type_hints["fail_gravity_var"])
            check_type(argname="argument focus", value=focus, expected_type=type_hints["focus"])
            check_type(argname="argument focus_var", value=focus_var, expected_type=type_hints["focus_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if algorithm is not None:
            self._values["algorithm"] = algorithm
        if algorithm_var is not None:
            self._values["algorithm_var"] = algorithm_var
        if confidence is not None:
            self._values["confidence"] = confidence
        if confidence_var is not None:
            self._values["confidence_var"] = confidence_var
        if fail_gravity is not None:
            self._values["fail_gravity"] = fail_gravity
        if fail_gravity_var is not None:
            self._values["fail_gravity_var"] = fail_gravity_var
        if focus is not None:
            self._values["focus"] = focus
        if focus_var is not None:
            self._values["focus_var"] = focus_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def algorithm(self) -> typing.Optional[builtins.str]:
        '''Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm DataAkamaiImagingPolicyImage#algorithm}
        '''
        result = self._values.get("algorithm")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def algorithm_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm_var DataAkamaiImagingPolicyImage#algorithm_var}
        '''
        result = self._values.get("algorithm_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def confidence(self) -> typing.Optional[builtins.str]:
        '''With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image.

        Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence DataAkamaiImagingPolicyImage#confidence}
        '''
        result = self._values.get("confidence")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def confidence_var(self) -> typing.Optional[builtins.str]:
        '''With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image.

        Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence_var DataAkamaiImagingPolicyImage#confidence_var}
        '''
        result = self._values.get("confidence_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any faces in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        '''
        result = self._values.get("fail_gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any faces in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        '''
        result = self._values.get("fail_gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def focus(self) -> typing.Optional[builtins.str]:
        '''Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus DataAkamaiImagingPolicyImage#focus}
        '''
        result = self._values.get("focus")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def focus_var(self) -> typing.Optional[builtins.str]:
        '''Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus_var DataAkamaiImagingPolicyImage#focus_var}
        '''
        result = self._values.get("focus_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the face(s) plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the face(s) plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationFaceCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationFaceCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationFaceCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__295fb93e790599c137a6d99fe948b556b4ac181400a7a397c1b7458ef889665a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationFaceCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__380a655c734e00502fd75ce3a727e02d6dee40808c3799cdb0f0d9c67ac6253d)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationFaceCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f7eccae1187a7c1d2085ce0416a0a95c29e0eb9f75aebb90b8d33f3d8c883966)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b7d1497958c220390e60763408f4a3fbde3001d0cb278b279c24bc0b9e7cb71b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3dae1f70980ccfcbdbe40de1219e26d65b40be1e88c63c885c3717f43a7bfd7a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationFaceCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationFaceCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationFaceCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a1459eb8df3f2f1b0fdcd26dfacb0505f4414874d451ec7cc59e5c3c3be6ecc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationFaceCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationFaceCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f323aa86dff2f856739ba628d73927cc0e0ccc5fef183927170e6f26e4a526bc)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAlgorithm")
    def reset_algorithm(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAlgorithm", []))

    @jsii.member(jsii_name="resetAlgorithmVar")
    def reset_algorithm_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAlgorithmVar", []))

    @jsii.member(jsii_name="resetConfidence")
    def reset_confidence(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetConfidence", []))

    @jsii.member(jsii_name="resetConfidenceVar")
    def reset_confidence_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetConfidenceVar", []))

    @jsii.member(jsii_name="resetFailGravity")
    def reset_fail_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravity", []))

    @jsii.member(jsii_name="resetFailGravityVar")
    def reset_fail_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravityVar", []))

    @jsii.member(jsii_name="resetFocus")
    def reset_focus(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFocus", []))

    @jsii.member(jsii_name="resetFocusVar")
    def reset_focus_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFocusVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="algorithmInput")
    def algorithm_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "algorithmInput"))

    @builtins.property
    @jsii.member(jsii_name="algorithmVarInput")
    def algorithm_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "algorithmVarInput"))

    @builtins.property
    @jsii.member(jsii_name="confidenceInput")
    def confidence_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "confidenceInput"))

    @builtins.property
    @jsii.member(jsii_name="confidenceVarInput")
    def confidence_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "confidenceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityInput")
    def fail_gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityVarInput")
    def fail_gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="focusInput")
    def focus_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "focusInput"))

    @builtins.property
    @jsii.member(jsii_name="focusVarInput")
    def focus_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "focusVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="algorithm")
    def algorithm(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "algorithm"))

    @algorithm.setter
    def algorithm(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e719c4c7178b2c5ae98b2b44145e4c035770cbb788dda2309ce993fdd052dfe5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "algorithm", value)

    @builtins.property
    @jsii.member(jsii_name="algorithmVar")
    def algorithm_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "algorithmVar"))

    @algorithm_var.setter
    def algorithm_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1abdc458406d5a3e40fe05cd00b8968a94f91e5c00bbde085730fdbf782cc56b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "algorithmVar", value)

    @builtins.property
    @jsii.member(jsii_name="confidence")
    def confidence(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "confidence"))

    @confidence.setter
    def confidence(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa28b25139ac7828bc574c3ab653eead13f6f0688e1721a25c1a9f75f556d13c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "confidence", value)

    @builtins.property
    @jsii.member(jsii_name="confidenceVar")
    def confidence_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "confidenceVar"))

    @confidence_var.setter
    def confidence_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0503dbac3b5dafe73f35174c196e39b3216ea1897d4b9b7e6a6aba616df684da)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "confidenceVar", value)

    @builtins.property
    @jsii.member(jsii_name="failGravity")
    def fail_gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravity"))

    @fail_gravity.setter
    def fail_gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b9b5ee34195fc2999e8f21f1408c5bbd54a2c5e4d556124746a6026cb7e93068)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravity", value)

    @builtins.property
    @jsii.member(jsii_name="failGravityVar")
    def fail_gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravityVar"))

    @fail_gravity_var.setter
    def fail_gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ff4eb009d4dcca92768ce6104756dcbeb37107a10ba9b2158bcc2041ab328ff9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="focus")
    def focus(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "focus"))

    @focus.setter
    def focus(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a72bcf908d7b084a3932f19499cdaf351086b025a41422208b8c0fd216c3e04)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "focus", value)

    @builtins.property
    @jsii.member(jsii_name="focusVar")
    def focus_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "focusVar"))

    @focus_var.setter
    def focus_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a5679d938691a39641a556444bdfaf35fd7c958c3c2e186e4809eba7e73981e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "focusVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ead662b498a82860b2ba6a31a9bf0f075978526a02f50d87ecda536c644475b5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7cb5321498e5fa5b7d284b8319e6f806690b125c93f469323513d1726e193d43)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__162bdc3234b3c076098b791f294ec6543c1a9d016e12cc4a599575e165b855b6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__739bb31d88c99b263a543d8c30ad0a8c65554419d1e76d0f09516c07b6c15742)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__67e86541d78a1d4e4045e03283b4407472aba02b03f726eba321ff7dcf11fdf1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aac9235e879137bad105eb4ec440636e90797465dbcabaef0a340d20260aa1de)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__314e7382896754bef037fb90e8bf959b800be1f787105a8bc1d78bb0507176b8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__411f2329c618d11b8729fb9cdfd6a19b288c3763a686646040db3532ee9a6424)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__85802681cc6eaac4eb059119b8d0ac605ccf04923c9e6431dbb752ca7eca811b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ad3fc1237fff3e083b32838fa737179888b35adaec28691c4a577316d6cca05b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationFaceCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationFaceCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationFaceCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__55e9b3d19149ef7703bd4c976354d9c1fb1157ae1f2da0c2b583fbb684b2ae5e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationFeatureCrop",
    jsii_struct_bases=[],
    name_mapping={
        "fail_gravity": "failGravity",
        "fail_gravity_var": "failGravityVar",
        "feature_radius": "featureRadius",
        "feature_radius_var": "featureRadiusVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "max_features": "maxFeatures",
        "max_features_var": "maxFeaturesVar",
        "min_feature_quality": "minFeatureQuality",
        "min_feature_quality_var": "minFeatureQualityVar",
        "padding": "padding",
        "padding_var": "paddingVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationFeatureCrop:
    def __init__(
        self,
        *,
        fail_gravity: typing.Optional[builtins.str] = None,
        fail_gravity_var: typing.Optional[builtins.str] = None,
        feature_radius: typing.Optional[builtins.str] = None,
        feature_radius_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        max_features: typing.Optional[builtins.str] = None,
        max_features_var: typing.Optional[builtins.str] = None,
        min_feature_quality: typing.Optional[builtins.str] = None,
        min_feature_quality_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fail_gravity: Controls placement of the crop if Image and Video Manager does not detect any features in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        :param fail_gravity_var: Controls placement of the crop if Image and Video Manager does not detect any features in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        :param feature_radius: The size in pixels of the important features to search for. If identified, two features never appear closer together than this value, ``8.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius DataAkamaiImagingPolicyImage#feature_radius}
        :param feature_radius_var: The size in pixels of the important features to search for. If identified, two features never appear closer together than this value, ``8.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius_var DataAkamaiImagingPolicyImage#feature_radius_var}
        :param gravity: Controls placement of the crop. Directions are relative to the region of interest plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Controls placement of the crop. Directions are relative to the region of interest plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param max_features: The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features DataAkamaiImagingPolicyImage#max_features}
        :param max_features_var: The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features_var DataAkamaiImagingPolicyImage#max_features_var}
        :param min_feature_quality: Determines the minimum quality level of the feature identified. To consider a feature important, the feature needs to surpass this value. Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality DataAkamaiImagingPolicyImage#min_feature_quality}
        :param min_feature_quality_var: Determines the minimum quality level of the feature identified. To consider a feature important, the feature needs to surpass this value. Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality_var DataAkamaiImagingPolicyImage#min_feature_quality_var}
        :param padding: Adds space around the region of interest. The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: Adds space around the region of interest. The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        :param style: Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cb06197d065465e82f5b55d776997b47018e66d3d9eff61cd948e63021b2d744)
            check_type(argname="argument fail_gravity", value=fail_gravity, expected_type=type_hints["fail_gravity"])
            check_type(argname="argument fail_gravity_var", value=fail_gravity_var, expected_type=type_hints["fail_gravity_var"])
            check_type(argname="argument feature_radius", value=feature_radius, expected_type=type_hints["feature_radius"])
            check_type(argname="argument feature_radius_var", value=feature_radius_var, expected_type=type_hints["feature_radius_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument max_features", value=max_features, expected_type=type_hints["max_features"])
            check_type(argname="argument max_features_var", value=max_features_var, expected_type=type_hints["max_features_var"])
            check_type(argname="argument min_feature_quality", value=min_feature_quality, expected_type=type_hints["min_feature_quality"])
            check_type(argname="argument min_feature_quality_var", value=min_feature_quality_var, expected_type=type_hints["min_feature_quality_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fail_gravity is not None:
            self._values["fail_gravity"] = fail_gravity
        if fail_gravity_var is not None:
            self._values["fail_gravity_var"] = fail_gravity_var
        if feature_radius is not None:
            self._values["feature_radius"] = feature_radius
        if feature_radius_var is not None:
            self._values["feature_radius_var"] = feature_radius_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if max_features is not None:
            self._values["max_features"] = max_features
        if max_features_var is not None:
            self._values["max_features_var"] = max_features_var
        if min_feature_quality is not None:
            self._values["min_feature_quality"] = min_feature_quality
        if min_feature_quality_var is not None:
            self._values["min_feature_quality_var"] = min_feature_quality_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def fail_gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any features in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        '''
        result = self._values.get("fail_gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any features in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        '''
        result = self._values.get("fail_gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feature_radius(self) -> typing.Optional[builtins.str]:
        '''The size in pixels of the important features to search for.

        If identified, two features never appear closer together than this value, ``8.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius DataAkamaiImagingPolicyImage#feature_radius}
        '''
        result = self._values.get("feature_radius")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feature_radius_var(self) -> typing.Optional[builtins.str]:
        '''The size in pixels of the important features to search for.

        If identified, two features never appear closer together than this value, ``8.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius_var DataAkamaiImagingPolicyImage#feature_radius_var}
        '''
        result = self._values.get("feature_radius_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the region of interest plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the region of interest plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def max_features(self) -> typing.Optional[builtins.str]:
        '''The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features DataAkamaiImagingPolicyImage#max_features}
        '''
        result = self._values.get("max_features")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def max_features_var(self) -> typing.Optional[builtins.str]:
        '''The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features_var DataAkamaiImagingPolicyImage#max_features_var}
        '''
        result = self._values.get("max_features_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def min_feature_quality(self) -> typing.Optional[builtins.str]:
        '''Determines the minimum quality level of the feature identified.

        To consider a feature important, the feature needs to surpass this value.  Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality DataAkamaiImagingPolicyImage#min_feature_quality}
        '''
        result = self._values.get("min_feature_quality")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def min_feature_quality_var(self) -> typing.Optional[builtins.str]:
        '''Determines the minimum quality level of the feature identified.

        To consider a feature important, the feature needs to surpass this value.  Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality_var DataAkamaiImagingPolicyImage#min_feature_quality_var}
        '''
        result = self._values.get("min_feature_quality_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''Adds space around the region of interest.

        The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''Adds space around the region of interest.

        The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationFeatureCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationFeatureCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationFeatureCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4aa099cc87d780efb297e06b82ee911cf4f3b7b293a1656f45d7cf03ec2bb449)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationFeatureCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fbe6a2f9698f33c49f8828ac3206bee405ee2d88e8c79ae64622d542bfc18080)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationFeatureCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e0e6dac4e17a8e9526dba417bbde7b5e82c340414e791358affe10ec0515f9e0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__140d112197a9540a0edd7b4ad42b710f8d0741669ae6c13064ac99ffa713f6df)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1b258dc5cadbeb0115ce57a76b813a31c753e4684eeb46c1aa0aa3204261b803)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationFeatureCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationFeatureCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationFeatureCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c2cfec875a8fa5040fbecfcf034896fe87074575aa4a5af47a75fd6d6600eaa6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationFeatureCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationFeatureCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__428af7b6cc361cd124742c03d5ef1880310a478052de9e7611b49a321f66bac3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetFailGravity")
    def reset_fail_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravity", []))

    @jsii.member(jsii_name="resetFailGravityVar")
    def reset_fail_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravityVar", []))

    @jsii.member(jsii_name="resetFeatureRadius")
    def reset_feature_radius(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureRadius", []))

    @jsii.member(jsii_name="resetFeatureRadiusVar")
    def reset_feature_radius_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureRadiusVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetMaxFeatures")
    def reset_max_features(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxFeatures", []))

    @jsii.member(jsii_name="resetMaxFeaturesVar")
    def reset_max_features_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxFeaturesVar", []))

    @jsii.member(jsii_name="resetMinFeatureQuality")
    def reset_min_feature_quality(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMinFeatureQuality", []))

    @jsii.member(jsii_name="resetMinFeatureQualityVar")
    def reset_min_feature_quality_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMinFeatureQualityVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="failGravityInput")
    def fail_gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityVarInput")
    def fail_gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featureRadiusInput")
    def feature_radius_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featureRadiusInput"))

    @builtins.property
    @jsii.member(jsii_name="featureRadiusVarInput")
    def feature_radius_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featureRadiusVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesInput")
    def max_features_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "maxFeaturesInput"))

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesVarInput")
    def max_features_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "maxFeaturesVarInput"))

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityInput")
    def min_feature_quality_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "minFeatureQualityInput"))

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityVarInput")
    def min_feature_quality_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "minFeatureQualityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravity")
    def fail_gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravity"))

    @fail_gravity.setter
    def fail_gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c7731b397a63e4421d59080ccbcce1cf7a872f9712913707fc8ef971f1772fc3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravity", value)

    @builtins.property
    @jsii.member(jsii_name="failGravityVar")
    def fail_gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravityVar"))

    @fail_gravity_var.setter
    def fail_gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f6cdc31c7200dcc24ab5dd769c59b9618432ed378f760a7bbfa90cd7cb7db82)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="featureRadius")
    def feature_radius(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featureRadius"))

    @feature_radius.setter
    def feature_radius(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ae6d2bd47da123edbf9118a8597121f335e7b7e80a3ad29d2509626e24d4926)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featureRadius", value)

    @builtins.property
    @jsii.member(jsii_name="featureRadiusVar")
    def feature_radius_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featureRadiusVar"))

    @feature_radius_var.setter
    def feature_radius_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6153e268c7373769ec9e30f292d10ed5270b81093a4a3c91289ad5c80f4dfd01)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featureRadiusVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5660b0fee3cff7807bb47fcba5d12eadf8ac09809a9b1259d20ad7f81ec7dfc1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__02320d14817267d58800b39042adff2ae46eeccbd5e34823ea6f589079287538)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__51765abb59ab9dd6ce09bd45eb02291c18959d370587e780df9a3b29a262715b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af44cd422baa84a811eea81d1d6478830d6f8ee371c1d270236040680b9e4208)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="maxFeatures")
    def max_features(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "maxFeatures"))

    @max_features.setter
    def max_features(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__072c7f0b9a9e7e2b52acfc543f68516e9c3d4d3005fb0419f66d65b583805706)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "maxFeatures", value)

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesVar")
    def max_features_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "maxFeaturesVar"))

    @max_features_var.setter
    def max_features_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7f1717937a1e6f07c333f5d4660233fc0c39661fc6e82de4a5bd78e870931518)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "maxFeaturesVar", value)

    @builtins.property
    @jsii.member(jsii_name="minFeatureQuality")
    def min_feature_quality(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "minFeatureQuality"))

    @min_feature_quality.setter
    def min_feature_quality(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__61046f408dbcf13a58ab0f7e0bed0b66bc43ee67bfdeca3854b26c4b2860f723)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "minFeatureQuality", value)

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityVar")
    def min_feature_quality_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "minFeatureQualityVar"))

    @min_feature_quality_var.setter
    def min_feature_quality_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aa4dc1d559a280a428d0d1783dbf28a73748015bb705d02d5b6252ec18761157)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "minFeatureQualityVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__740ef65c08da66ed4c39821c91cc3cbb379362bfc54d904fd1c4f4c298201761)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dee2b471f45ae838b7bba46f8e0b40f6eed1f04d48f3d40c6eea4db383e1cd6b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9bc9fe8319a8dcc3f55f54a39a8c95fbed0d19010ea9810cdbdb5455018c9ca4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__83cdb1484cb95b18b47f8e134fa88df51207382e8f37f8ee54151e4ec619e233)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6659f4f4cc0e661b3a36bb62dcfa5275d444af940406c7e59a80a40494b014ac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8f85244a68c102be16a629b9cda14d97adca1d979eb640d8c164e194641c38c0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationFeatureCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationFeatureCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationFeatureCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8bc98befcd78ca0e306fd2bd13c8b4934df45d0ef4b7f5e653d493536c5c8df9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationFitAndFill",
    jsii_struct_bases=[],
    name_mapping={
        "fill_transformation": "fillTransformation",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationFitAndFill:
    def __init__(
        self,
        *,
        fill_transformation: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationFitAndFillFillTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fill_transformation: fill_transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_transformation DataAkamaiImagingPolicyImage#fill_transformation}
        :param height: The height value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The width value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(fill_transformation, dict):
            fill_transformation = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationFitAndFillFillTransformation(**fill_transformation)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6345259a647f51f62e906d2aab10017d4226aa90d8aeddd42b6ef28aeb5cd0aa)
            check_type(argname="argument fill_transformation", value=fill_transformation, expected_type=type_hints["fill_transformation"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fill_transformation is not None:
            self._values["fill_transformation"] = fill_transformation
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def fill_transformation(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationFitAndFillFillTransformation"]:
        '''fill_transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_transformation DataAkamaiImagingPolicyImage#fill_transformation}
        '''
        result = self._values.get("fill_transformation")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationFitAndFillFillTransformation"], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationFitAndFill(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationFitAndFillFillTransformation",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationFitAndFillFillTransformation:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationFitAndFillFillTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationFitAndFillFillTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationFitAndFillFillTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cc63d37c6bc5a523b61e128eb26e7aa61177e88a61345e36924f651d2283a584)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationFitAndFillFillTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationFitAndFillFillTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationFitAndFillFillTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7070ba76830bf897f9e54915e9b27219ef7813797f62b9991f0164f524f07326)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationFitAndFillList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationFitAndFillList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__85e8c7b368595478f54194fb352000be1853aa45c9b542b721655e62733f08ff)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationFitAndFillOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__43ec639002a693e2713a987546c4bc5ef4d30f64f5dbcd9e3fd5bc90bb952a1f)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationFitAndFillOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f6321361b8ecfbb5f16f736cb71cfd07a2ef69bd721f91130f1351cf0d45ded8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6810a4fed3051c9b7e02e3c78bbc777f56d257e0fc9f350bd12abdae90e435b3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e82738c2512912936838f6abf980f863836a5e3eb9a5cc1bd40a2e81b63010ad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationFitAndFill]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationFitAndFill]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationFitAndFill]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a4edfe58dc4fab136a5d140f4704ecb9c09f80ee13827673489e8c92e50cce4d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationFitAndFillOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationFitAndFillOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__61c3dcbebb887853d4a48934904d9c49249283893468b4d9b8d32379224a4b06)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putFillTransformation")
    def put_fill_transformation(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationFitAndFillFillTransformation()

        return typing.cast(None, jsii.invoke(self, "putFillTransformation", [value]))

    @jsii.member(jsii_name="resetFillTransformation")
    def reset_fill_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFillTransformation", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="fillTransformation")
    def fill_transformation(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationFitAndFillFillTransformationOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationFitAndFillFillTransformationOutputReference, jsii.get(self, "fillTransformation"))

    @builtins.property
    @jsii.member(jsii_name="fillTransformationInput")
    def fill_transformation_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationFitAndFillFillTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationFitAndFillFillTransformation], jsii.get(self, "fillTransformationInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0f1ab7e9420a222ffbd5086f6eb40f5d4ddd634c10d6b7c609d5c61b469636b5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7f4a9561c7f4bb85d05761e8262df561bd97e90682cc44cc9264352e447ae583)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3b84bfbd7c44729b270309e4981b355f15379a5d93ae7d73dadbfe3ad5c16dd7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__beecfcb1a0bac5471ea8af68415c5170383b1489f11cb8db0e2493ba534481be)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationFitAndFill]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationFitAndFill]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationFitAndFill]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__361b5a52b9b517bd934c9058e4e5cf543737f255cd803bf6a1faa053a73d99de)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationGoop",
    jsii_struct_bases=[],
    name_mapping={
        "chaos": "chaos",
        "chaos_var": "chaosVar",
        "density": "density",
        "density_var": "densityVar",
        "power": "power",
        "power_var": "powerVar",
        "seed": "seed",
        "seed_var": "seedVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationGoop:
    def __init__(
        self,
        *,
        chaos: typing.Optional[builtins.str] = None,
        chaos_var: typing.Optional[builtins.str] = None,
        density: typing.Optional[builtins.str] = None,
        density_var: typing.Optional[builtins.str] = None,
        power: typing.Optional[builtins.str] = None,
        power_var: typing.Optional[builtins.str] = None,
        seed: typing.Optional[builtins.str] = None,
        seed_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param chaos: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        :param chaos_var: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        :param density: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        :param density_var: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        :param power: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        :param power_var: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        :param seed: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        :param seed_var: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f143f4f6a01aaf04d4c78f76d20e9e5b446be783a49f1dd89406055d728472b1)
            check_type(argname="argument chaos", value=chaos, expected_type=type_hints["chaos"])
            check_type(argname="argument chaos_var", value=chaos_var, expected_type=type_hints["chaos_var"])
            check_type(argname="argument density", value=density, expected_type=type_hints["density"])
            check_type(argname="argument density_var", value=density_var, expected_type=type_hints["density_var"])
            check_type(argname="argument power", value=power, expected_type=type_hints["power"])
            check_type(argname="argument power_var", value=power_var, expected_type=type_hints["power_var"])
            check_type(argname="argument seed", value=seed, expected_type=type_hints["seed"])
            check_type(argname="argument seed_var", value=seed_var, expected_type=type_hints["seed_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if chaos is not None:
            self._values["chaos"] = chaos
        if chaos_var is not None:
            self._values["chaos_var"] = chaos_var
        if density is not None:
            self._values["density"] = density
        if density_var is not None:
            self._values["density_var"] = density_var
        if power is not None:
            self._values["power"] = power
        if power_var is not None:
            self._values["power_var"] = power_var
        if seed is not None:
            self._values["seed"] = seed
        if seed_var is not None:
            self._values["seed_var"] = seed_var

    @builtins.property
    def chaos(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        '''
        result = self._values.get("chaos")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def chaos_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        '''
        result = self._values.get("chaos_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        '''
        result = self._values.get("density")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density_var(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        '''
        result = self._values.get("density_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        '''
        result = self._values.get("power")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power_var(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        '''
        result = self._values.get("power_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        '''
        result = self._values.get("seed")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed_var(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        result = self._values.get("seed_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationGoop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationGoopList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationGoopList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6cef692757bee2b4cd1f6c224dc8f64e1adca8ee4a95a0a76f9957c4c1285805)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationGoopOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eaafad3712ff2d6677d1bcb05800ad2c721e6d0f88aef2323d1e1e46e4b506e3)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationGoopOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a52b636bd0848fb3fe96c706a583f6e4974f9125288727f49eea91784e9ee851)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e64a0d248b81f3280e1e7936f0d1cc6fc18c6e1b338499755b9c540f260f3c7c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e8fd2c9b8f054f79e2f0dd612d2377e5e84ddd74779b38087000a56d62d11568)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationGoop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationGoop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cda6800262027924714f4d72002778a7e11420fa6dc1b3d334985c50708a53f7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationGoopOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationGoopOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7ebaeb2f33a6892ca61e6669be07b668416c13c61f22b27632ae3d93754468c9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetChaos")
    def reset_chaos(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaos", []))

    @jsii.member(jsii_name="resetChaosVar")
    def reset_chaos_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaosVar", []))

    @jsii.member(jsii_name="resetDensity")
    def reset_density(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensity", []))

    @jsii.member(jsii_name="resetDensityVar")
    def reset_density_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensityVar", []))

    @jsii.member(jsii_name="resetPower")
    def reset_power(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPower", []))

    @jsii.member(jsii_name="resetPowerVar")
    def reset_power_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPowerVar", []))

    @jsii.member(jsii_name="resetSeed")
    def reset_seed(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeed", []))

    @jsii.member(jsii_name="resetSeedVar")
    def reset_seed_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeedVar", []))

    @builtins.property
    @jsii.member(jsii_name="chaosInput")
    def chaos_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosInput"))

    @builtins.property
    @jsii.member(jsii_name="chaosVarInput")
    def chaos_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosVarInput"))

    @builtins.property
    @jsii.member(jsii_name="densityInput")
    def density_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityInput"))

    @builtins.property
    @jsii.member(jsii_name="densityVarInput")
    def density_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="powerInput")
    def power_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerInput"))

    @builtins.property
    @jsii.member(jsii_name="powerVarInput")
    def power_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerVarInput"))

    @builtins.property
    @jsii.member(jsii_name="seedInput")
    def seed_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedInput"))

    @builtins.property
    @jsii.member(jsii_name="seedVarInput")
    def seed_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedVarInput"))

    @builtins.property
    @jsii.member(jsii_name="chaos")
    def chaos(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaos"))

    @chaos.setter
    def chaos(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__14d5bc909e0b75f52d5b9641e974ed1c100b50beca66a68ee95cb08c5878083a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaos", value)

    @builtins.property
    @jsii.member(jsii_name="chaosVar")
    def chaos_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaosVar"))

    @chaos_var.setter
    def chaos_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__84cbcce25971afc312315722a1294517cbdd3f3896ee86f9709ef83e62a50009)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaosVar", value)

    @builtins.property
    @jsii.member(jsii_name="density")
    def density(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "density"))

    @density.setter
    def density(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aee601e14a01a2f92447203504fb66803ea3c5347f5995d7b290e79fdec0321c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "density", value)

    @builtins.property
    @jsii.member(jsii_name="densityVar")
    def density_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "densityVar"))

    @density_var.setter
    def density_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd30f9fce850021be298e246788ecfd98714523697adf32db4a416b7d1a6b76d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "densityVar", value)

    @builtins.property
    @jsii.member(jsii_name="power")
    def power(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "power"))

    @power.setter
    def power(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cdf80b5f090f6c5ede704d4de1b308800065ba3395246b445d48f90d092fe76d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "power", value)

    @builtins.property
    @jsii.member(jsii_name="powerVar")
    def power_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "powerVar"))

    @power_var.setter
    def power_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6423b5d8ead7995402b87270b97eb09b182175b549e7843b6c972e676ba3a776)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "powerVar", value)

    @builtins.property
    @jsii.member(jsii_name="seed")
    def seed(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seed"))

    @seed.setter
    def seed(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f25af921185540a05af994fd67f032b7ed7e5977ad1c7a42ef0636417a76796)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seed", value)

    @builtins.property
    @jsii.member(jsii_name="seedVar")
    def seed_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seedVar"))

    @seed_var.setter
    def seed_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a879d4dddd6bf1e95742fbdac3011ad006aa47bb4c872e6ce4efc5f7b2bf53eb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seedVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationGoop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationGoop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationGoop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d9c2504b644de98f96beb4668a1d66a5c497af67ee1aa8b2459d64f9fd26b5d0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationGrayscale",
    jsii_struct_bases=[],
    name_mapping={"type": "type", "type_var": "typeVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationGrayscale:
    def __init__(
        self,
        *,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param type: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__faf3d9cde18b6a92670dc7f48a8a0df6220baef313acc8b9e3676b948f880771)
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationGrayscale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationGrayscaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationGrayscaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0f0e1840a742a7c0ccc23638dc84e4e381fef857cc004b0d08c01479455e3f5b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationGrayscaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a58c482a1b864921611c2a4d2ad94c95d61f7514b6f39dcb1db24cb48984611f)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationGrayscaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c28ee838b7d00d070a91e4d9d2acbad572348dfb7cd22db4c9dac0a3193f4535)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__97a17f0a14530c7975f2dc00debbb3f5657ff052b1d57cde2613fd42ee92b1db)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1aac2c464b9b9500b45894e94f8566e9e9d27918e2b2fcaa5d894d347f230dfc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationGrayscale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationGrayscale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0e232020debe7b9db04c17798f67782d9b47f750627823df544dc130756d8e99)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationGrayscaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationGrayscaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7ad7df69cdf67ad53098a5fad17bc30a566c6a901ab92488b4ddbf7241e3cd16)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e23ce80bae6e45066f66565cfa553a912edbc79900b103c23013f30d31ba614b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__74c0476f71c01463a7bba3c2121a27553194665cc2c5cb22446edc19564ca50b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationGrayscale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationGrayscale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationGrayscale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d83093d474f5d4751b92144809c5af1453d0d60ee2e7cf4a05be339e3bd0bd6e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationHsl",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "lightness": "lightness",
        "lightness_var": "lightnessVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationHsl:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness: typing.Optional[builtins.str] = None,
        lightness_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        :param lightness_var: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3c9fa6144e6ff57615139fe2c8d9cdccf4c6bfb53f3da194c005656f035886aa)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness", value=lightness, expected_type=type_hints["lightness"])
            check_type(argname="argument lightness_var", value=lightness_var, expected_type=type_hints["lightness_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness is not None:
            self._values["lightness"] = lightness
        if lightness_var is not None:
            self._values["lightness_var"] = lightness_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        '''
        result = self._values.get("lightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        '''
        result = self._values.get("lightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationHsl(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationHslList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationHslList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e0f72b0e833d885df17ccff92989f23c306ceb43e406c4011f765d4d6d9ee5ff)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationHslOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f1268e500585af8a9ef8be446da8c48350f2c48d4724de3cb7c8337dd89b1ff5)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationHslOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__372b5bf0d09d9d1c5359bc41e301cb5ee3e2ec19bd1e8d94bced05ee5140d99e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea536a1dea3f5e237e4134f8babec804f8a2064c4634d96ff8f6f6a53a0540af)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__63cf47004310c7e82eb9bc107d58fc25a2e65039b1d87a8ca26a81322292fab3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationHsl]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationHsl]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__61d544cd46cee0d272dda550eb1553339b3ffb40f2f5a1f4f1849e4311433312)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationHslOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationHslOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4cfdaf9bd65fde4bc54876693767a115810043cbf8e7459742e68be158664ae3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightness")
    def reset_lightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightness", []))

    @jsii.member(jsii_name="resetLightnessVar")
    def reset_lightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessInput")
    def lightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessVarInput")
    def lightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c006670cbfedf5d09a32d67e8ae48cb95f367ec084f64be41c024d1e6002207e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4e92a243ade6a61182ba1a5dd5b6a23de97bed750ba6aeac8e0615f58c11b9b9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightness")
    def lightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightness"))

    @lightness.setter
    def lightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2385b369094ad0d48402e10f6e9fe34d11ebf0c63727096abc26652441745e54)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightness", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessVar")
    def lightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessVar"))

    @lightness_var.setter
    def lightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__68653a7cbebd5fe41bb4c07c1f8ab4ffff5402a524923da424c235918aaa9c8b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__16d61ebe52849af9b45f095f72d999a3e74f380bde97095b023021674e9792b5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__507e06d34432a42032196d8316ad9b34c36c4c8c9a2b556a6c2177ab338c7b43)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationHsl]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationHsl]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationHsl]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6c6173b55bc8dbe974cf8af817d4ac43a233c91052f564146c3287a0275dd23a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationHsv",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationHsv:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        :param value: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c4ed61c6b40cdd035159912f3096aa7d5d23cce55668d8ab03b9784de26be4e8)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationHsv(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationHsvList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationHsvList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0c3e3a0559e721b569b64f8c4f8cf9d3f5947ca194b62460147326811e5bbcd4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationHsvOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0d1aef373e1216370b94d875c9cbcfec8a489b85dc662c1d062945cc3c87ba19)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationHsvOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__16a777b766dc10dcbfa1acac5dab456bee5f9a403d9e0c5f6dd02f4db8d689a6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__642f7df336e43a7bfd611b3e5bf1f929c2c9ef920c1d3ecfd4df2e615cc603b7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e6ef7948e697acd8189d11e213996702c9b9624c1fa60940d77f27e591952fe1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationHsv]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationHsv]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d3c73a215f14908b784db02f6c124acb188ffa480e717e6368d81be21a92637)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationHsvOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationHsvOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8247e18684ecab05e0123240cfeba078e4f92beed04d348943cefdd6ba086fbf)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1aa69771f71474f3e1df4ea6f4d353a4c28b338d010b15e4b1a15bd4b82239f8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d20513e3e4b2e04183ddaae2e76d5e475fa429fb60bcba3421e14cdefd391d30)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__180f3d90ef2b2dce9158292568adaa283feaf2f376e7e8d8f998e559ab22f0a0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6790de8b878b5c246731cda22cf9ed4d4354f6f0edc45cf581ffb516a0b4b730)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4da79aa8ab880ba6c64605465a1a351c12a2c9a76a2a11856ac9ef964958f2fc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e1ffe47d377de607fe0221d34f7900946d98b0f9a4c694d4bab4ba1ac900ea3b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationHsv]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationHsv]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationHsv]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__91230d6628310ca3604127978cda77827093d1492af8f1d66f7568318b93db80)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfDimension",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "dimension": "dimension",
        "dimension_var": "dimensionVar",
        "equal": "equal",
        "greater_than": "greaterThan",
        "less_than": "lessThan",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfDimension:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfDimensionDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        dimension: typing.Optional[builtins.str] = None,
        dimension_var: typing.Optional[builtins.str] = None,
        equal: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfDimensionEqual", typing.Dict[builtins.str, typing.Any]]] = None,
        greater_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfDimensionGreaterThan", typing.Dict[builtins.str, typing.Any]]] = None,
        less_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfDimensionLessThan", typing.Dict[builtins.str, typing.Any]]] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param dimension: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        :param dimension_var: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        :param equal: equal block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        :param greater_than: greater_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        :param less_than: less_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        :param value: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfDimensionDefault(**default)
        if isinstance(equal, dict):
            equal = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfDimensionEqual(**equal)
        if isinstance(greater_than, dict):
            greater_than = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfDimensionGreaterThan(**greater_than)
        if isinstance(less_than, dict):
            less_than = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfDimensionLessThan(**less_than)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__063b70650bf2af06f92dbf909109919b54e04f696a0519adbd4a2c0633477315)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument dimension", value=dimension, expected_type=type_hints["dimension"])
            check_type(argname="argument dimension_var", value=dimension_var, expected_type=type_hints["dimension_var"])
            check_type(argname="argument equal", value=equal, expected_type=type_hints["equal"])
            check_type(argname="argument greater_than", value=greater_than, expected_type=type_hints["greater_than"])
            check_type(argname="argument less_than", value=less_than, expected_type=type_hints["less_than"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if dimension is not None:
            self._values["dimension"] = dimension
        if dimension_var is not None:
            self._values["dimension_var"] = dimension_var
        if equal is not None:
            self._values["equal"] = equal
        if greater_than is not None:
            self._values["greater_than"] = greater_than
        if less_than is not None:
            self._values["less_than"] = less_than
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfDimensionDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfDimensionDefault"], result)

    @builtins.property
    def dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        '''
        result = self._values.get("dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        '''
        result = self._values.get("dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def equal(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfDimensionEqual"]:
        '''equal block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        '''
        result = self._values.get("equal")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfDimensionEqual"], result)

    @builtins.property
    def greater_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfDimensionGreaterThan"]:
        '''greater_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        '''
        result = self._values.get("greater_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfDimensionGreaterThan"], result)

    @builtins.property
    def less_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfDimensionLessThan"]:
        '''less_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        '''
        result = self._values.get("less_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfDimensionLessThan"], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfDimension(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfDimensionDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfDimensionDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfDimensionDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfDimensionDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfDimensionDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d35d062d3657dad8af44f310c6f1adf97d77924dbcdd28caf390192f3a2612dc)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfDimensionDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfDimensionDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__57a9919a7300711e45d27a8a2c78348c17fbdf5d134bd97f68b5618e54fb91b6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfDimensionEqual",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfDimensionEqual:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfDimensionEqual(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfDimensionEqualOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfDimensionEqualOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__de324d0604bb04515478daf94ef789f2ae2ee6ab2641ac8ca1452810f1440aad)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfDimensionEqual], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfDimensionEqual],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__87d006811b56c025d08ed9d85154d81fe7fb606b25590f22b0e228779558230e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfDimensionGreaterThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfDimensionGreaterThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfDimensionGreaterThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfDimensionGreaterThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfDimensionGreaterThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3cb7fa2ab499480865b8d381d34183afb63182c24054a0ff3190b00f1af6abf5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfDimensionGreaterThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfDimensionGreaterThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__42d842beb87894efbd4ed81e9038bcecad84778c595cc62161a97559d1f3439b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfDimensionLessThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfDimensionLessThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfDimensionLessThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfDimensionLessThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfDimensionLessThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__308da57216e2239ae08c81d7f590867b0e15c541ac0109f00c71991d1c8351e9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfDimensionLessThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfDimensionLessThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c3ce9cccc5b72b084a4229663c71d988970491d1eb99af54a0b5085ca8ddfbb1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfDimensionList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfDimensionList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4291abf0b63a0263600424531c8b672a623cb066f17de42a9ab5c348c9855a30)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfDimensionOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a5789d8a2bc4b72a79d9c87f555eb2b7ebfc52c344eaf71d6f4a176bbbd92b4)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfDimensionOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aaa0c9f9fadf82dcef41ab31c84a3e1273caecd778d4ad1b1c955a880782cd6a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__125dc3f5302027cc0638016f2a4af939387483f70059d77f7d9c59f937dd1c3b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ffc2e0906ce0715a5cefaa39e7a8eb43391a54d102fef47d6342aebed438585c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfDimension]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfDimension]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1faf384aa45849a7d9246edb02fc3d5d6ef726a677dd42687a6d4c92f0788dc0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfDimensionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfDimensionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__06f33d93ef763533eda2214eb48edab9553b800adb1e2d1df12fcb3ac4404c0d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfDimensionDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putEqual")
    def put_equal(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfDimensionEqual()

        return typing.cast(None, jsii.invoke(self, "putEqual", [value]))

    @jsii.member(jsii_name="putGreaterThan")
    def put_greater_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfDimensionGreaterThan()

        return typing.cast(None, jsii.invoke(self, "putGreaterThan", [value]))

    @jsii.member(jsii_name="putLessThan")
    def put_less_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfDimensionLessThan()

        return typing.cast(None, jsii.invoke(self, "putLessThan", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetDimension")
    def reset_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimension", []))

    @jsii.member(jsii_name="resetDimensionVar")
    def reset_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimensionVar", []))

    @jsii.member(jsii_name="resetEqual")
    def reset_equal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEqual", []))

    @jsii.member(jsii_name="resetGreaterThan")
    def reset_greater_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGreaterThan", []))

    @jsii.member(jsii_name="resetLessThan")
    def reset_less_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLessThan", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfDimensionDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfDimensionDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="equal")
    def equal(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfDimensionEqualOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfDimensionEqualOutputReference, jsii.get(self, "equal"))

    @builtins.property
    @jsii.member(jsii_name="greaterThan")
    def greater_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfDimensionGreaterThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfDimensionGreaterThanOutputReference, jsii.get(self, "greaterThan"))

    @builtins.property
    @jsii.member(jsii_name="lessThan")
    def less_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfDimensionLessThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfDimensionLessThanOutputReference, jsii.get(self, "lessThan"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfDimensionDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionInput")
    def dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionVarInput")
    def dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="equalInput")
    def equal_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfDimensionEqual], jsii.get(self, "equalInput"))

    @builtins.property
    @jsii.member(jsii_name="greaterThanInput")
    def greater_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfDimensionGreaterThan], jsii.get(self, "greaterThanInput"))

    @builtins.property
    @jsii.member(jsii_name="lessThanInput")
    def less_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfDimensionLessThan], jsii.get(self, "lessThanInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="dimension")
    def dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimension"))

    @dimension.setter
    def dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__65168f3d58f0eed9106857b594246f68e1d3fc08e5751ab4e3aed3127171ff5f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimension", value)

    @builtins.property
    @jsii.member(jsii_name="dimensionVar")
    def dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimensionVar"))

    @dimension_var.setter
    def dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9f8321396eedf90200129dee0a074bb4fee37c493b1a19dbb5dc315d12d4de75)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2e64ebc17c4539c6a0fccfc17afb30e12cd99b926717c4c7e986edb0816d3601)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e7bb0165f0f7722ca9ab221ba807881ce7b096dc5a893767118f53f348ee4337)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfDimension]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfDimension]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfDimension]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__79c31dc682e7a0c4845eafa57c2ee557817cbe56e63c2c52827da5e73ae0d477)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfOrientation",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "landscape": "landscape",
        "portrait": "portrait",
        "square": "square",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfOrientation:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfOrientationDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        landscape: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfOrientationLandscape", typing.Dict[builtins.str, typing.Any]]] = None,
        portrait: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfOrientationPortrait", typing.Dict[builtins.str, typing.Any]]] = None,
        square: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfOrientationSquare", typing.Dict[builtins.str, typing.Any]]] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param landscape: landscape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        :param portrait: portrait block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        :param square: square block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfOrientationDefault(**default)
        if isinstance(landscape, dict):
            landscape = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfOrientationLandscape(**landscape)
        if isinstance(portrait, dict):
            portrait = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfOrientationPortrait(**portrait)
        if isinstance(square, dict):
            square = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfOrientationSquare(**square)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7e646d32144f70fca5132092eeac203460de7851695327cddfaee6d7b3781239)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument landscape", value=landscape, expected_type=type_hints["landscape"])
            check_type(argname="argument portrait", value=portrait, expected_type=type_hints["portrait"])
            check_type(argname="argument square", value=square, expected_type=type_hints["square"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if landscape is not None:
            self._values["landscape"] = landscape
        if portrait is not None:
            self._values["portrait"] = portrait
        if square is not None:
            self._values["square"] = square

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfOrientationDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfOrientationDefault"], result)

    @builtins.property
    def landscape(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfOrientationLandscape"]:
        '''landscape block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        '''
        result = self._values.get("landscape")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfOrientationLandscape"], result)

    @builtins.property
    def portrait(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfOrientationPortrait"]:
        '''portrait block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        '''
        result = self._values.get("portrait")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfOrientationPortrait"], result)

    @builtins.property
    def square(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfOrientationSquare"]:
        '''square block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        result = self._values.get("square")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfOrientationSquare"], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfOrientation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfOrientationDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfOrientationDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfOrientationDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfOrientationDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfOrientationDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fca4ee2d7c9b40366f0f0caced0025f9605d9bbc45fbecab5ba74d8e892e7718)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfOrientationDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfOrientationDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1ec4c2aa1898c01d035b289bea6ccaff437ff5083dc577dd29fb0f7281d1c50d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfOrientationLandscape",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfOrientationLandscape:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfOrientationLandscape(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfOrientationLandscapeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfOrientationLandscapeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1cb740e831679cd376124d2c9c120cb07c01c45f6627ed90e3423e3a4af35c89)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfOrientationLandscape], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfOrientationLandscape],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ff08660544f952ba0372c1127e40a5c63386e71eda84fe23016e48a0ed47dd80)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfOrientationList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfOrientationList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f8e54711ab0c816238053959e6d2b7add0f566a3998fcbfdf5caecc308c4fc50)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfOrientationOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0eb460b1cbd0a37c57bf266898235f6f2ba47646bcd4422305e11cd9dd193426)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfOrientationOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e7b83d2a21fd454da03d4ed82b95a6b171810e2a82223033a62b71ec510b2846)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__85bae094e9205a2a0acd89107b3d68c8fec8dc49af2836a077a258fbb0d2caba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b1f914ca24ae54f0b3b785000046bfe2ef898a8224e46dc26c461f0b062fe9bb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfOrientation]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfOrientation]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dda6dc4e5a98318ce9a6b547720fd2faf2699b27daa2b633d23dc31d3bf3a438)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfOrientationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfOrientationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ff5879152e41e298610d11b14b42165751d96dcba22ea22961390f55bc2cffbc)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfOrientationDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putLandscape")
    def put_landscape(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfOrientationLandscape()

        return typing.cast(None, jsii.invoke(self, "putLandscape", [value]))

    @jsii.member(jsii_name="putPortrait")
    def put_portrait(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfOrientationPortrait()

        return typing.cast(None, jsii.invoke(self, "putPortrait", [value]))

    @jsii.member(jsii_name="putSquare")
    def put_square(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfOrientationSquare()

        return typing.cast(None, jsii.invoke(self, "putSquare", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetLandscape")
    def reset_landscape(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLandscape", []))

    @jsii.member(jsii_name="resetPortrait")
    def reset_portrait(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPortrait", []))

    @jsii.member(jsii_name="resetSquare")
    def reset_square(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSquare", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfOrientationDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfOrientationDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="landscape")
    def landscape(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfOrientationLandscapeOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfOrientationLandscapeOutputReference, jsii.get(self, "landscape"))

    @builtins.property
    @jsii.member(jsii_name="portrait")
    def portrait(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfOrientationPortraitOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfOrientationPortraitOutputReference", jsii.get(self, "portrait"))

    @builtins.property
    @jsii.member(jsii_name="square")
    def square(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfOrientationSquareOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfOrientationSquareOutputReference", jsii.get(self, "square"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfOrientationDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="landscapeInput")
    def landscape_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfOrientationLandscape], jsii.get(self, "landscapeInput"))

    @builtins.property
    @jsii.member(jsii_name="portraitInput")
    def portrait_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfOrientationPortrait"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfOrientationPortrait"], jsii.get(self, "portraitInput"))

    @builtins.property
    @jsii.member(jsii_name="squareInput")
    def square_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfOrientationSquare"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfOrientationSquare"], jsii.get(self, "squareInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfOrientation]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfOrientation]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfOrientation]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c07c0e3eaac2efa61d1be7622ba41f083c0e9849e1fe00477ae876af56c49a39)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfOrientationPortrait",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfOrientationPortrait:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfOrientationPortrait(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfOrientationPortraitOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfOrientationPortraitOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a303a0b7c60bebb05958d959888444379c07765e428538b632697b1587cfeb8d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfOrientationPortrait]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfOrientationPortrait], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfOrientationPortrait],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__99e7228ff0b3db393687e5ca2766bedee7ba4d1be2e3f4c0028441d4cbdc4c71)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfOrientationSquare",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfOrientationSquare:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfOrientationSquare(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfOrientationSquareOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfOrientationSquareOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__446fc3625ea411d792d7ae395c836b6334c7519f16c60f0658d40510ede48e3d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfOrientationSquare]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfOrientationSquare], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfOrientationSquare],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3784ea72b610529396d00cadf02e99843064a967ea93dab912c06de5b37c4f5e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationImQuery",
    jsii_struct_bases=[],
    name_mapping={
        "allowed_transformations": "allowedTransformations",
        "query_var": "queryVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationImQuery:
    def __init__(
        self,
        *,
        allowed_transformations: typing.Sequence[builtins.str],
        query_var: builtins.str,
    ) -> None:
        '''
        :param allowed_transformations: Specifies the transformations that can be applied using the query string parameter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allowed_transformations DataAkamaiImagingPolicyImage#allowed_transformations}
        :param query_var: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#query_var DataAkamaiImagingPolicyImage#query_var}.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d266fdbf9c6cde82469cdc368c45004a56f4ee0f2680fbd0b9e7d5c4d7558424)
            check_type(argname="argument allowed_transformations", value=allowed_transformations, expected_type=type_hints["allowed_transformations"])
            check_type(argname="argument query_var", value=query_var, expected_type=type_hints["query_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "allowed_transformations": allowed_transformations,
            "query_var": query_var,
        }

    @builtins.property
    def allowed_transformations(self) -> typing.List[builtins.str]:
        '''Specifies the transformations that can be applied using the query string parameter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allowed_transformations DataAkamaiImagingPolicyImage#allowed_transformations}
        '''
        result = self._values.get("allowed_transformations")
        assert result is not None, "Required property 'allowed_transformations' is missing"
        return typing.cast(typing.List[builtins.str], result)

    @builtins.property
    def query_var(self) -> builtins.str:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#query_var DataAkamaiImagingPolicyImage#query_var}.'''
        result = self._values.get("query_var")
        assert result is not None, "Required property 'query_var' is missing"
        return typing.cast(builtins.str, result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationImQuery(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationImQueryList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationImQueryList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ef3c498d89b0630f2123bad14f0d84180bc18f2de093538b20e71339e63169d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationImQueryOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__169f9dfbe3e977fb4b38c2da05c81d10800d5fea92d1655cb98494e96e0b09e2)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationImQueryOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ee0588fb736ed4a99a176436af4b42f4c3d97338873aceeb81031e6b2a4d947a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e603f3bad41bae26a1104448fac4edf1b64fd0c3cc4e383c4826c0de05ec6eae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d27173e55240fae82f7257904cb89a470f197a62c3d21fc43891fbc5e3e7f0a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationImQuery]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationImQuery]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationImQuery]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__de3447e35c7d4014c0cdf28881dd3a7ad2467fa57db71ebd5871233e79272e03)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationImQueryOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationImQueryOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5b1cd225936cf27aa24d023652757f7e14a8bfaa78aad58b6e6455e58c4a9706)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @builtins.property
    @jsii.member(jsii_name="allowedTransformationsInput")
    def allowed_transformations_input(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "allowedTransformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="queryVarInput")
    def query_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "queryVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowedTransformations")
    def allowed_transformations(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "allowedTransformations"))

    @allowed_transformations.setter
    def allowed_transformations(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8c8d7ac487ce79ac3c8804c4cfe6cc2d2602129e0c248e7708838c72e682c69d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowedTransformations", value)

    @builtins.property
    @jsii.member(jsii_name="queryVar")
    def query_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "queryVar"))

    @query_var.setter
    def query_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__835a8d6475487b0b216c97ced9947ef2682cb248d9bd81edfb236b971ec6a6ad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "queryVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationImQuery]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationImQuery]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationImQuery]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e4710da2126279202dcbe9a1c8a766227590db04aa5beb0d60bb8bc4c1e16491)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationMaxColors",
    jsii_struct_bases=[],
    name_mapping={"colors": "colors", "colors_var": "colorsVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationMaxColors:
    def __init__(
        self,
        *,
        colors: typing.Optional[builtins.str] = None,
        colors_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param colors: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        :param colors_var: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5de927aa7c6d444c61b19679b7816432be61c2aedf526e41ff6150354bcb7e13)
            check_type(argname="argument colors", value=colors, expected_type=type_hints["colors"])
            check_type(argname="argument colors_var", value=colors_var, expected_type=type_hints["colors_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if colors is not None:
            self._values["colors"] = colors
        if colors_var is not None:
            self._values["colors_var"] = colors_var

    @builtins.property
    def colors(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        '''
        result = self._values.get("colors")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def colors_var(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        result = self._values.get("colors_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationMaxColors(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationMaxColorsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationMaxColorsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7555a81cc09fc34acaa279d4721842076f94548898389bfda49b74f1562ce29c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationMaxColorsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7f2aeac0354fff2b759d26982c79651d1450e5a88e87349766e569225b4ac6f9)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationMaxColorsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e2c1354e13c94fc2c041db356d19c980601a268a6bc5464f2a4b1380bd8a1cca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e7719802e1e7cda762a7602de58e50c3a0ddcce36bc5b81173460cf019042405)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__06b6bf3c1af96168204355185975c5b0effcf8be00bab1afb5834e667b3e90c2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationMaxColors]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationMaxColors]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4be38511cfbbaed979d00f2d5f6c411a15f4bd78b81ccbada93d48d5b1ed982b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationMaxColorsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationMaxColorsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b906d62725adabe4ab192fb64f325d98929ae19624580b644f8adc2266c8019a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColors")
    def reset_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColors", []))

    @jsii.member(jsii_name="resetColorsVar")
    def reset_colors_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorsVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorsInput")
    def colors_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsInput"))

    @builtins.property
    @jsii.member(jsii_name="colorsVarInput")
    def colors_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsVarInput"))

    @builtins.property
    @jsii.member(jsii_name="colors")
    def colors(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colors"))

    @colors.setter
    def colors(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__159e6bcb8b9c7a60fe86e64f854c81f9225fe49ede3186d32f4699ac13ea4d45)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colors", value)

    @builtins.property
    @jsii.member(jsii_name="colorsVar")
    def colors_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorsVar"))

    @colors_var.setter
    def colors_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__98d54e95f172a0d54c227e7c3110dbf24d25c4e8d9d6e967f2e032a5007a32ca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorsVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationMaxColors]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationMaxColors]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationMaxColors]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a0246d900dccb0b8335a7c70dcab34f78ee8f73756c68aa43b637f34b942f42d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationMirror",
    jsii_struct_bases=[],
    name_mapping={
        "horizontal": "horizontal",
        "horizontal_var": "horizontalVar",
        "vertical": "vertical",
        "vertical_var": "verticalVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationMirror:
    def __init__(
        self,
        *,
        horizontal: typing.Optional[builtins.str] = None,
        horizontal_var: typing.Optional[builtins.str] = None,
        vertical: typing.Optional[builtins.str] = None,
        vertical_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param horizontal: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        :param horizontal_var: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        :param vertical: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        :param vertical_var: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2fc3616c4e4b68cd15665c746edbb616d2103eddd69d77b4e695ea8e67ac1d90)
            check_type(argname="argument horizontal", value=horizontal, expected_type=type_hints["horizontal"])
            check_type(argname="argument horizontal_var", value=horizontal_var, expected_type=type_hints["horizontal_var"])
            check_type(argname="argument vertical", value=vertical, expected_type=type_hints["vertical"])
            check_type(argname="argument vertical_var", value=vertical_var, expected_type=type_hints["vertical_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if horizontal is not None:
            self._values["horizontal"] = horizontal
        if horizontal_var is not None:
            self._values["horizontal_var"] = horizontal_var
        if vertical is not None:
            self._values["vertical"] = vertical
        if vertical_var is not None:
            self._values["vertical_var"] = vertical_var

    @builtins.property
    def horizontal(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        '''
        result = self._values.get("horizontal")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def horizontal_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        '''
        result = self._values.get("horizontal_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        '''
        result = self._values.get("vertical")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        result = self._values.get("vertical_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationMirror(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationMirrorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationMirrorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc6680ddd1ef8515862b586517b943694f86892c86d045542b24ae5ef1525625)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationMirrorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__70417aba3f31221b56ce0fc662313e6d9339809dabacf709770f18de7f485436)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationMirrorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b319a7c8cf1f2e11969da24539c0a9d0655c161483d5082cfb4543a7e04f0ff5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__070f53c58a3ffab9163a427b201016cd8d2acb31a928cc5cf2953ed45d4d59ae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e8e1c1971a18a1c11c2d23d0d1036644851a73c04837a11b01bebfc7da35426c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationMirror]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationMirror]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__33e6b54fbdd5e4b80ac99d263ee6ab25e22daf7fb236e7791c15e47e338600d1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationMirrorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationMirrorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__60aec8f2ab864c5f1508032397ca33d08395c0ae85e122333257cbf8fa332560)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHorizontal")
    def reset_horizontal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontal", []))

    @jsii.member(jsii_name="resetHorizontalVar")
    def reset_horizontal_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontalVar", []))

    @jsii.member(jsii_name="resetVertical")
    def reset_vertical(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVertical", []))

    @jsii.member(jsii_name="resetVerticalVar")
    def reset_vertical_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVerticalVar", []))

    @builtins.property
    @jsii.member(jsii_name="horizontalInput")
    def horizontal_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontalVarInput")
    def horizontal_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalInput")
    def vertical_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalVarInput")
    def vertical_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontal")
    def horizontal(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontal"))

    @horizontal.setter
    def horizontal(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac7c7c666301e148be3c82c0a31b930b0b5b3fe7e7a93226bf6d493964d798b2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontal", value)

    @builtins.property
    @jsii.member(jsii_name="horizontalVar")
    def horizontal_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontalVar"))

    @horizontal_var.setter
    def horizontal_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ec10531800c145a3893c92ecc14a0195f3834265c6a47340ae75142e963488c9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontalVar", value)

    @builtins.property
    @jsii.member(jsii_name="vertical")
    def vertical(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "vertical"))

    @vertical.setter
    def vertical(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5142880c543a70d1bcde68595943d5ce4a2412fd2cac6f1bbe4a447508a3837d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "vertical", value)

    @builtins.property
    @jsii.member(jsii_name="verticalVar")
    def vertical_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "verticalVar"))

    @vertical_var.setter
    def vertical_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7818d8f8d02e96f03cbca044fa47f71e9d095998dbb467ce5cba83c8cd120308)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "verticalVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationMirror]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationMirror]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationMirror]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__85a6a58b466889c2c4b48501748739a89628979455aac2ace08b4412e30a0ec2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationMonoHue",
    jsii_struct_bases=[],
    name_mapping={"hue": "hue", "hue_var": "hueVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationMonoHue:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__310815b323f089e3656b10dd59c02b7ee5f31c19f41e64c770e7797961914d1d)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationMonoHue(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationMonoHueList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationMonoHueList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c747aca73028f818738536647e2cdde74deb4a297efb15ec40cea4e527b72b38)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationMonoHueOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__31814ef29fa29fcd5bb5703240853166415136d9d326ee4088a1a7d671fde305)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationMonoHueOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__921a7d861250c5d886f94d73a9a2c4a6c5dea4c6e809cff812d961e44f5108e2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ade078668de6a1bd8c7527eb58da2c68494bef422c4603f5a54e3a73e2d868b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__329103296f94cfb2dea8d9146c567669089d3f1006ee3f135473e2360f52dea9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationMonoHue]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationMonoHue]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cdf0e7a94d3ddd3da70e5125470d6ea7c0af9d463a546af50f707b8802204c13)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationMonoHueOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationMonoHueOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__71fa2867059b6477995dd422d7228c7c92a8d2c6f3c2911c276df287a5d3ad17)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1bc690221803b6f98989cef07fc7a8d402332903fe2182e72afe1bb24470459b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eb62c8bd68e3b42dd35d97057936df5f400e205e85206b7d8795d35ee923c35c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationMonoHue]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationMonoHue]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationMonoHue]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__65c0efde290d0cae91d99288712d1ee90a2ff94cda216560d9dc02f8da69808e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationOpacity",
    jsii_struct_bases=[],
    name_mapping={"opacity": "opacity", "opacity_var": "opacityVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationOpacity:
    def __init__(
        self,
        *,
        opacity: typing.Optional[builtins.str] = None,
        opacity_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param opacity: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param opacity_var: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f55b089cf359e50e30e6f911c793ddd75f64bb212c6a26b80e4f547193bd9e2b)
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument opacity_var", value=opacity_var, expected_type=type_hints["opacity_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if opacity is not None:
            self._values["opacity"] = opacity
        if opacity_var is not None:
            self._values["opacity_var"] = opacity_var

    @builtins.property
    def opacity(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def opacity_var(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        result = self._values.get("opacity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationOpacity(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationOpacityList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationOpacityList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fe0aed013539d4a6d0e87f5600b4e42a49916508d33d2917f4fd810c682f084a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationOpacityOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__51cdb42c3454334f3f056b42fb054a1481edcac096ec97469284fe8832bb7e67)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationOpacityOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3eda1b6cb66e6740d8622a0d31ae5b7f3b86faa26118a6e48d547c611b71247b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e284ec368516cac0fe8608e9dd427e044bf04723041d10b386a0648b71142b2e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4e08e475152ad13b3c94581f1adc7f179f1785daeaefa53cbda862f7dfca8738)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationOpacity]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationOpacity]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c3a2d83b94240a8034b99546847aa43fc73a086a68f54dcc6f662a3099f2a1a8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationOpacityOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationOpacityOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a1e0309ccedfbc1fc49c000585019bee42c5bd0f0a8577881de192565e39b77b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetOpacityVar")
    def reset_opacity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacityVar", []))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityVarInput")
    def opacity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacity"))

    @opacity.setter
    def opacity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f125d21047d808b1a24d348722f8d44eb4ab18f7de02603f11274115a6c12946)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacity", value)

    @builtins.property
    @jsii.member(jsii_name="opacityVar")
    def opacity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacityVar"))

    @opacity_var.setter
    def opacity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__905985175ea9843ef4ca2e5113740121b2d39caaba8e48cd2276ce61a6b26376)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacityVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationOpacity]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationOpacity]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationOpacity]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6905aa5760e1bf5583ef13274e4c7f11a5e85243d09663a40c56fad463338673)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1614f522e1633d086c498f077b3e7ebbc7690231b95619ec9ad5b9929039e962)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putAppend")
    def put_append(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationAppend, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3975f030f6e615bfcb5b52e6c31d337e3ee69166921f6eb15b21a66d0e673bf0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putAppend", [value]))

    @jsii.member(jsii_name="putAspectCrop")
    def put_aspect_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationAspectCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4dfccfe4712cf3a25be6626a009cfca8c0e4dd3e73d2ab378d9a57312f73cf9f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putAspectCrop", [value]))

    @jsii.member(jsii_name="putBackgroundColor")
    def put_background_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b9067e71e816b4f69651fdb6e9d12d131d2bb04219559474bfdc8b218c0a085d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBackgroundColor", [value]))

    @jsii.member(jsii_name="putBlur")
    def put_blur(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationBlur, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6d55a59ceb5beba3f990f45aea450f7417b98d2a90f8ecc4dce7ce40c5a354ce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBlur", [value]))

    @jsii.member(jsii_name="putChromaKey")
    def put_chroma_key(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationChromaKey, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1245a56a370ce2eceffb922cd6599be1ed6d59c434d64906206666d7d1df4972)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putChromaKey", [value]))

    @jsii.member(jsii_name="putComposite")
    def put_composite(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationComposite, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__14acac0b16f2fc71c02fc0d7e6b2312cf7bb1f1e268f1e80ea0d0822bb6fe9e7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putComposite", [value]))

    @jsii.member(jsii_name="putCompound")
    def put_compound(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationCompound, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__64aa6f51a7b5c71ba48cde08198abb4efbc44a69c7cebf451fba2e45468ff490)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCompound", [value]))

    @jsii.member(jsii_name="putContrast")
    def put_contrast(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationContrast, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__842a5aca9cf6b265b2ef05fcdb7f7b3e6ea622b8d19cbe9b8dd2305cbfd825be)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putContrast", [value]))

    @jsii.member(jsii_name="putCrop")
    def put_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1dfbb41b3b146f68244f5e447e6f2a4386b555a3c675c15a3d26874c17fdfacf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCrop", [value]))

    @jsii.member(jsii_name="putFaceCrop")
    def put_face_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationFaceCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1de20bcf04ada1b1673c74d24f623debdb554ddff7c2e3d2b6794d991963b0fe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFaceCrop", [value]))

    @jsii.member(jsii_name="putFeatureCrop")
    def put_feature_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationFeatureCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3f2c71b9b765ebc93bb506a2ffc91a3a27b7a6181f892b4e582bf5b2622c9b96)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFeatureCrop", [value]))

    @jsii.member(jsii_name="putFitAndFill")
    def put_fit_and_fill(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationFitAndFill, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eaa109edd33ace4b8711e422f81485fa14de91301ea51c05ae51180112c06e79)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFitAndFill", [value]))

    @jsii.member(jsii_name="putGoop")
    def put_goop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationGoop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__07da6745b54025e6061e2f54735a43e83bfe10ee9df9717131e57746fe2314ab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGoop", [value]))

    @jsii.member(jsii_name="putGrayscale")
    def put_grayscale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationGrayscale, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__391437e337c7be89846540137e7f2d4911d1110cfb9c0b5430dd8d170694503c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGrayscale", [value]))

    @jsii.member(jsii_name="putHsl")
    def put_hsl(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationHsl, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__918ea183c9e4d3fdb2e6b6d6bf6a8d54dbbe25f2ce75e86f48c63464acf522dd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsl", [value]))

    @jsii.member(jsii_name="putHsv")
    def put_hsv(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationHsv, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a4228ec19a7a508fce2e55ef35253ef9be5adfcdd1b5ee14563c0cd3187b4d2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsv", [value]))

    @jsii.member(jsii_name="putIfDimension")
    def put_if_dimension(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfDimension, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0e124881217f5cf703afa9bc9601ad5a7385b380a174fc54ecabc33218baafe7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfDimension", [value]))

    @jsii.member(jsii_name="putIfOrientation")
    def put_if_orientation(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8cb492c3395c1cad1e48bc59574fb7fa32db90a90e5baa337092ae8597064446)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfOrientation", [value]))

    @jsii.member(jsii_name="putImQuery")
    def put_im_query(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationImQuery, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1d94905f9f612ed8e71c5387ce88697c2ea634be91c910e5b43f86144bfb3be6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putImQuery", [value]))

    @jsii.member(jsii_name="putMaxColors")
    def put_max_colors(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationMaxColors, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d8cf6d640da4c4e31daf788c12d80327461adb4c5b073895891c0825f082fbe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMaxColors", [value]))

    @jsii.member(jsii_name="putMirror")
    def put_mirror(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationMirror, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a2071b9f5ba34bcf2616583ab66f842088a3c0773b22d2e2a29259922571b65)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMirror", [value]))

    @jsii.member(jsii_name="putMonoHue")
    def put_mono_hue(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationMonoHue, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab515adff441e84255375f69644b7c086ca976a5b323caddbe7a07805d837686)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMonoHue", [value]))

    @jsii.member(jsii_name="putOpacity")
    def put_opacity(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationOpacity, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__34474b8fdf640ca1f6e5d0119c957dcb525ea3e8d91f1a68fd595004fd0ca1db)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putOpacity", [value]))

    @jsii.member(jsii_name="putRegionOfInterestCrop")
    def put_region_of_interest_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationRegionOfInterestCrop", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4f82f98e71007181ed50e9e9522ea7b724bc697b064b16ec75ae11ee505c18db)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRegionOfInterestCrop", [value]))

    @jsii.member(jsii_name="putRelativeCrop")
    def put_relative_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationRelativeCrop", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bd1e767d7a917af2aadd476f48c4edc4fcd009e25ffafcb72c9ef0a0be43a468)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRelativeCrop", [value]))

    @jsii.member(jsii_name="putRemoveColor")
    def put_remove_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationRemoveColor", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__54ac4f60a5b0bf8ccae1a2488418c78dafe8e82862e894a4473fc8634192f56a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRemoveColor", [value]))

    @jsii.member(jsii_name="putResize")
    def put_resize(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationResize", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__269574320c3de0cfe5ca2584d9534aa8328c0718905a98897c0f93746355097b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putResize", [value]))

    @jsii.member(jsii_name="putRotate")
    def put_rotate(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationRotate", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__99ef445639ed334c1a55c967a9b7dbea1418a614c00cfc133d3973d6c2196cfc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRotate", [value]))

    @jsii.member(jsii_name="putScale")
    def put_scale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationScale", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9e5069d11bf523e618f25f79e97eea4436d3aa665657c7235ee15db2558c77a4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putScale", [value]))

    @jsii.member(jsii_name="putShear")
    def put_shear(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationShear", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ec86d6d2681ac9edcdc0270eac8aecd13e6f0db4ec7ebfd59c75fa460290c3ff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putShear", [value]))

    @jsii.member(jsii_name="putTrim")
    def put_trim(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationTrim", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__99046a71f54d22d22b81ccbe8ec5b8d3804e03a95ac53cb44f2859162ba3ef71)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTrim", [value]))

    @jsii.member(jsii_name="putUnsharpMask")
    def put_unsharp_mask(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationUnsharpMask", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d09094420f28533bc01da2d38ea58193034d565f1a82e21fb27003586493a72)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putUnsharpMask", [value]))

    @jsii.member(jsii_name="resetAppend")
    def reset_append(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAppend", []))

    @jsii.member(jsii_name="resetAspectCrop")
    def reset_aspect_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspectCrop", []))

    @jsii.member(jsii_name="resetBackgroundColor")
    def reset_background_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBackgroundColor", []))

    @jsii.member(jsii_name="resetBlur")
    def reset_blur(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBlur", []))

    @jsii.member(jsii_name="resetChromaKey")
    def reset_chroma_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChromaKey", []))

    @jsii.member(jsii_name="resetComposite")
    def reset_composite(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetComposite", []))

    @jsii.member(jsii_name="resetCompound")
    def reset_compound(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCompound", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetCrop")
    def reset_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCrop", []))

    @jsii.member(jsii_name="resetFaceCrop")
    def reset_face_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFaceCrop", []))

    @jsii.member(jsii_name="resetFeatureCrop")
    def reset_feature_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureCrop", []))

    @jsii.member(jsii_name="resetFitAndFill")
    def reset_fit_and_fill(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFitAndFill", []))

    @jsii.member(jsii_name="resetGoop")
    def reset_goop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGoop", []))

    @jsii.member(jsii_name="resetGrayscale")
    def reset_grayscale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGrayscale", []))

    @jsii.member(jsii_name="resetHsl")
    def reset_hsl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsl", []))

    @jsii.member(jsii_name="resetHsv")
    def reset_hsv(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsv", []))

    @jsii.member(jsii_name="resetIfDimension")
    def reset_if_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfDimension", []))

    @jsii.member(jsii_name="resetIfOrientation")
    def reset_if_orientation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfOrientation", []))

    @jsii.member(jsii_name="resetImQuery")
    def reset_im_query(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetImQuery", []))

    @jsii.member(jsii_name="resetMaxColors")
    def reset_max_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxColors", []))

    @jsii.member(jsii_name="resetMirror")
    def reset_mirror(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMirror", []))

    @jsii.member(jsii_name="resetMonoHue")
    def reset_mono_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonoHue", []))

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetRegionOfInterestCrop")
    def reset_region_of_interest_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRegionOfInterestCrop", []))

    @jsii.member(jsii_name="resetRelativeCrop")
    def reset_relative_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRelativeCrop", []))

    @jsii.member(jsii_name="resetRemoveColor")
    def reset_remove_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRemoveColor", []))

    @jsii.member(jsii_name="resetResize")
    def reset_resize(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetResize", []))

    @jsii.member(jsii_name="resetRotate")
    def reset_rotate(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRotate", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetShear")
    def reset_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetShear", []))

    @jsii.member(jsii_name="resetTrim")
    def reset_trim(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTrim", []))

    @jsii.member(jsii_name="resetUnsharpMask")
    def reset_unsharp_mask(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUnsharpMask", []))

    @builtins.property
    @jsii.member(jsii_name="append")
    def append(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationAppendList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationAppendList, jsii.get(self, "append"))

    @builtins.property
    @jsii.member(jsii_name="aspectCrop")
    def aspect_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationAspectCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationAspectCropList, jsii.get(self, "aspectCrop"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColor")
    def background_color(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationBackgroundColorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationBackgroundColorList, jsii.get(self, "backgroundColor"))

    @builtins.property
    @jsii.member(jsii_name="blur")
    def blur(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationBlurList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationBlurList, jsii.get(self, "blur"))

    @builtins.property
    @jsii.member(jsii_name="chromaKey")
    def chroma_key(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationChromaKeyList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationChromaKeyList, jsii.get(self, "chromaKey"))

    @builtins.property
    @jsii.member(jsii_name="composite")
    def composite(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationCompositeList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationCompositeList, jsii.get(self, "composite"))

    @builtins.property
    @jsii.member(jsii_name="compound")
    def compound(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationCompoundList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationCompoundList, jsii.get(self, "compound"))

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationContrastList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationContrastList, jsii.get(self, "contrast"))

    @builtins.property
    @jsii.member(jsii_name="crop")
    def crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationCropList, jsii.get(self, "crop"))

    @builtins.property
    @jsii.member(jsii_name="faceCrop")
    def face_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationFaceCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationFaceCropList, jsii.get(self, "faceCrop"))

    @builtins.property
    @jsii.member(jsii_name="featureCrop")
    def feature_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationFeatureCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationFeatureCropList, jsii.get(self, "featureCrop"))

    @builtins.property
    @jsii.member(jsii_name="fitAndFill")
    def fit_and_fill(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationFitAndFillList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationFitAndFillList, jsii.get(self, "fitAndFill"))

    @builtins.property
    @jsii.member(jsii_name="goop")
    def goop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationGoopList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationGoopList, jsii.get(self, "goop"))

    @builtins.property
    @jsii.member(jsii_name="grayscale")
    def grayscale(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationGrayscaleList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationGrayscaleList, jsii.get(self, "grayscale"))

    @builtins.property
    @jsii.member(jsii_name="hsl")
    def hsl(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationHslList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationHslList, jsii.get(self, "hsl"))

    @builtins.property
    @jsii.member(jsii_name="hsv")
    def hsv(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationHsvList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationHsvList, jsii.get(self, "hsv"))

    @builtins.property
    @jsii.member(jsii_name="ifDimension")
    def if_dimension(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfDimensionList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfDimensionList, jsii.get(self, "ifDimension"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientation")
    def if_orientation(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfOrientationList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfOrientationList, jsii.get(self, "ifOrientation"))

    @builtins.property
    @jsii.member(jsii_name="imQuery")
    def im_query(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationImQueryList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationImQueryList, jsii.get(self, "imQuery"))

    @builtins.property
    @jsii.member(jsii_name="maxColors")
    def max_colors(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationMaxColorsList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationMaxColorsList, jsii.get(self, "maxColors"))

    @builtins.property
    @jsii.member(jsii_name="mirror")
    def mirror(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationMirrorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationMirrorList, jsii.get(self, "mirror"))

    @builtins.property
    @jsii.member(jsii_name="monoHue")
    def mono_hue(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationMonoHueList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationMonoHueList, jsii.get(self, "monoHue"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationOpacityList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationOpacityList, jsii.get(self, "opacity"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestCrop")
    def region_of_interest_crop(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationRegionOfInterestCropList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationRegionOfInterestCropList", jsii.get(self, "regionOfInterestCrop"))

    @builtins.property
    @jsii.member(jsii_name="relativeCrop")
    def relative_crop(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationRelativeCropList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationRelativeCropList", jsii.get(self, "relativeCrop"))

    @builtins.property
    @jsii.member(jsii_name="removeColor")
    def remove_color(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationRemoveColorList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationRemoveColorList", jsii.get(self, "removeColor"))

    @builtins.property
    @jsii.member(jsii_name="resize")
    def resize(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationResizeList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationResizeList", jsii.get(self, "resize"))

    @builtins.property
    @jsii.member(jsii_name="rotate")
    def rotate(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationRotateList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationRotateList", jsii.get(self, "rotate"))

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationScaleList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationScaleList", jsii.get(self, "scale"))

    @builtins.property
    @jsii.member(jsii_name="shear")
    def shear(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationShearList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationShearList", jsii.get(self, "shear"))

    @builtins.property
    @jsii.member(jsii_name="trim")
    def trim(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationTrimList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationTrimList", jsii.get(self, "trim"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMask")
    def unsharp_mask(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationUnsharpMaskList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationUnsharpMaskList", jsii.get(self, "unsharpMask"))

    @builtins.property
    @jsii.member(jsii_name="appendInput")
    def append_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationAppend]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationAppend]]], jsii.get(self, "appendInput"))

    @builtins.property
    @jsii.member(jsii_name="aspectCropInput")
    def aspect_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationAspectCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationAspectCrop]]], jsii.get(self, "aspectCropInput"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColorInput")
    def background_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationBackgroundColor]]], jsii.get(self, "backgroundColorInput"))

    @builtins.property
    @jsii.member(jsii_name="blurInput")
    def blur_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationBlur]]], jsii.get(self, "blurInput"))

    @builtins.property
    @jsii.member(jsii_name="chromaKeyInput")
    def chroma_key_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationChromaKey]]], jsii.get(self, "chromaKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="compositeInput")
    def composite_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationComposite]]], jsii.get(self, "compositeInput"))

    @builtins.property
    @jsii.member(jsii_name="compoundInput")
    def compound_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationCompound]]], jsii.get(self, "compoundInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationContrast]]], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="cropInput")
    def crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationCrop]]], jsii.get(self, "cropInput"))

    @builtins.property
    @jsii.member(jsii_name="faceCropInput")
    def face_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationFaceCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationFaceCrop]]], jsii.get(self, "faceCropInput"))

    @builtins.property
    @jsii.member(jsii_name="featureCropInput")
    def feature_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationFeatureCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationFeatureCrop]]], jsii.get(self, "featureCropInput"))

    @builtins.property
    @jsii.member(jsii_name="fitAndFillInput")
    def fit_and_fill_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationFitAndFill]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationFitAndFill]]], jsii.get(self, "fitAndFillInput"))

    @builtins.property
    @jsii.member(jsii_name="goopInput")
    def goop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationGoop]]], jsii.get(self, "goopInput"))

    @builtins.property
    @jsii.member(jsii_name="grayscaleInput")
    def grayscale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationGrayscale]]], jsii.get(self, "grayscaleInput"))

    @builtins.property
    @jsii.member(jsii_name="hslInput")
    def hsl_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationHsl]]], jsii.get(self, "hslInput"))

    @builtins.property
    @jsii.member(jsii_name="hsvInput")
    def hsv_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationHsv]]], jsii.get(self, "hsvInput"))

    @builtins.property
    @jsii.member(jsii_name="ifDimensionInput")
    def if_dimension_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfDimension]]], jsii.get(self, "ifDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientationInput")
    def if_orientation_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfOrientation]]], jsii.get(self, "ifOrientationInput"))

    @builtins.property
    @jsii.member(jsii_name="imQueryInput")
    def im_query_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationImQuery]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationImQuery]]], jsii.get(self, "imQueryInput"))

    @builtins.property
    @jsii.member(jsii_name="maxColorsInput")
    def max_colors_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationMaxColors]]], jsii.get(self, "maxColorsInput"))

    @builtins.property
    @jsii.member(jsii_name="mirrorInput")
    def mirror_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationMirror]]], jsii.get(self, "mirrorInput"))

    @builtins.property
    @jsii.member(jsii_name="monoHueInput")
    def mono_hue_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationMonoHue]]], jsii.get(self, "monoHueInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationOpacity]]], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestCropInput")
    def region_of_interest_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationRegionOfInterestCrop"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationRegionOfInterestCrop"]]], jsii.get(self, "regionOfInterestCropInput"))

    @builtins.property
    @jsii.member(jsii_name="relativeCropInput")
    def relative_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationRelativeCrop"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationRelativeCrop"]]], jsii.get(self, "relativeCropInput"))

    @builtins.property
    @jsii.member(jsii_name="removeColorInput")
    def remove_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationRemoveColor"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationRemoveColor"]]], jsii.get(self, "removeColorInput"))

    @builtins.property
    @jsii.member(jsii_name="resizeInput")
    def resize_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationResize"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationResize"]]], jsii.get(self, "resizeInput"))

    @builtins.property
    @jsii.member(jsii_name="rotateInput")
    def rotate_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationRotate"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationRotate"]]], jsii.get(self, "rotateInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationScale"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationScale"]]], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="shearInput")
    def shear_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationShear"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationShear"]]], jsii.get(self, "shearInput"))

    @builtins.property
    @jsii.member(jsii_name="trimInput")
    def trim_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationTrim"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationTrim"]]], jsii.get(self, "trimInput"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMaskInput")
    def unsharp_mask_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationUnsharpMask"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationUnsharpMask"]]], jsii.get(self, "unsharpMaskInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1034067a47cd5958a3d77f46fb7379a47349408a9d22548ea32aa4dc98fe49cb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationRegionOfInterestCrop",
    jsii_struct_bases=[],
    name_mapping={
        "region_of_interest": "regionOfInterest",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationRegionOfInterestCrop:
    def __init__(
        self,
        *,
        region_of_interest: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationRegionOfInterestCropRegionOfInterest", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param region_of_interest: region_of_interest block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest DataAkamaiImagingPolicyImage#region_of_interest}
        :param gravity: The placement of the crop area relative to the specified area of interest. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: The placement of the crop area relative to the specified area of interest. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param style: Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(region_of_interest, dict):
            region_of_interest = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationRegionOfInterestCropRegionOfInterest(**region_of_interest)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa62cdd77eab2d7872d1643088691d8aa24326230fd4dcd561a9e861c5e8fdc9)
            check_type(argname="argument region_of_interest", value=region_of_interest, expected_type=type_hints["region_of_interest"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "region_of_interest": region_of_interest,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def region_of_interest(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationRegionOfInterestCropRegionOfInterest":
        '''region_of_interest block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest DataAkamaiImagingPolicyImage#region_of_interest}
        '''
        result = self._values.get("region_of_interest")
        assert result is not None, "Required property 'region_of_interest' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationRegionOfInterestCropRegionOfInterest", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''The placement of the crop area relative to the specified area of interest.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''The placement of the crop area relative to the specified area of interest.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationRegionOfInterestCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationRegionOfInterestCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationRegionOfInterestCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__649cf2f3b6da3eebe2a4a980e93f968bc58926ea234c1f67659956bb24573392)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationRegionOfInterestCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aa87d0643afe313036db09ac1fc36fc3a86ccd25aadfb5dcd8646069f0bd8f8a)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationRegionOfInterestCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6421b24b55ad48376294378516a3a2b040509d7e2bac6178b76fe93242bf7c24)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__de5c853f41591edb544c379a93442b9373bdbd3e77df79dcabbd624fc26d973c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__078aa99eafb2a0bb2e7c6d37edd9d0c48feec282308b191c8ad12cb6a8fcae5f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationRegionOfInterestCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationRegionOfInterestCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationRegionOfInterestCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8d4357616eb1d1b19452fc08d748746623f37cfbc89cd48df43335d733313d97)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationRegionOfInterestCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationRegionOfInterestCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e4e38f9301bb95d8cbe0d759af1c7ec6938fb423b51d7ee0193e6d7e39d8cdc0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putRegionOfInterest")
    def put_region_of_interest(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationRegionOfInterestCropRegionOfInterest()

        return typing.cast(None, jsii.invoke(self, "putRegionOfInterest", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterest")
    def region_of_interest(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestOutputReference", jsii.get(self, "regionOfInterest"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestInput")
    def region_of_interest_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationRegionOfInterestCropRegionOfInterest"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationRegionOfInterestCropRegionOfInterest"], jsii.get(self, "regionOfInterestInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d8e090eeacff1a714d06567c249169a857a604a94d582b41296579215d3a74ac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ef094650c2fd880110d358184350550d93310127964569e386af5107fe46b391)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f8c44f20317e423534215e1b252c3da22e7f0d95235e9f268efce60fc463efb4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ca0015c1b83e155b3147fe3cca6fd4b66bcd044fc9a660ce1652fc0dcac4010)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d066c176d5cfae1735f572d99df47735f3d827011a50fbdf0ac90ccbac4a9d7d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f9aab27efe2e534f1ebbf351325bdaae4ad221842367b13fec148ac09db4e9d5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a8d71db536939d4ab3dbc7d437605b11659649620f91dc382bda86c5bb2959ab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7f194e8c86cae0ac8ac6818dea2ee2de815cd6a05ef1bffed0ebb39657635194)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationRegionOfInterestCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationRegionOfInterestCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationRegionOfInterestCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8eb7e19772e4e6e9b74f5dadf659c3e83e03bcfade8a695fa07f8bee30069602)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationRegionOfInterestCropRegionOfInterest",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationRegionOfInterestCropRegionOfInterest:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationRegionOfInterestCropRegionOfInterest(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__25429ec36ff7265b782edc382414459e4ea7db2260ad118d73e2c85e8ced6126)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationRegionOfInterestCropRegionOfInterest]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationRegionOfInterestCropRegionOfInterest], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationRegionOfInterestCropRegionOfInterest],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__223781d124294673e2db1c4f36752037b290c7c4846d3689a055eaf6a03a686c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationRelativeCrop",
    jsii_struct_bases=[],
    name_mapping={
        "east": "east",
        "east_var": "eastVar",
        "north": "north",
        "north_var": "northVar",
        "south": "south",
        "south_var": "southVar",
        "west": "west",
        "west_var": "westVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationRelativeCrop:
    def __init__(
        self,
        *,
        east: typing.Optional[builtins.str] = None,
        east_var: typing.Optional[builtins.str] = None,
        north: typing.Optional[builtins.str] = None,
        north_var: typing.Optional[builtins.str] = None,
        south: typing.Optional[builtins.str] = None,
        south_var: typing.Optional[builtins.str] = None,
        west: typing.Optional[builtins.str] = None,
        west_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param east: The number of pixels to shrink or expand the right side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east DataAkamaiImagingPolicyImage#east}
        :param east_var: The number of pixels to shrink or expand the right side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east_var DataAkamaiImagingPolicyImage#east_var}
        :param north: The number of pixels to shrink or expand the top side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north DataAkamaiImagingPolicyImage#north}
        :param north_var: The number of pixels to shrink or expand the top side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north_var DataAkamaiImagingPolicyImage#north_var}
        :param south: The number of pixels to shrink or expand the bottom side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south DataAkamaiImagingPolicyImage#south}
        :param south_var: The number of pixels to shrink or expand the bottom side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south_var DataAkamaiImagingPolicyImage#south_var}
        :param west: The number of pixels to shrink or expand the left side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west DataAkamaiImagingPolicyImage#west}
        :param west_var: The number of pixels to shrink or expand the left side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west_var DataAkamaiImagingPolicyImage#west_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b598c450bd8c584fbcb96c435f63d2bd7271e1bc0671ff400a8882eed4a0f3fd)
            check_type(argname="argument east", value=east, expected_type=type_hints["east"])
            check_type(argname="argument east_var", value=east_var, expected_type=type_hints["east_var"])
            check_type(argname="argument north", value=north, expected_type=type_hints["north"])
            check_type(argname="argument north_var", value=north_var, expected_type=type_hints["north_var"])
            check_type(argname="argument south", value=south, expected_type=type_hints["south"])
            check_type(argname="argument south_var", value=south_var, expected_type=type_hints["south_var"])
            check_type(argname="argument west", value=west, expected_type=type_hints["west"])
            check_type(argname="argument west_var", value=west_var, expected_type=type_hints["west_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if east is not None:
            self._values["east"] = east
        if east_var is not None:
            self._values["east_var"] = east_var
        if north is not None:
            self._values["north"] = north
        if north_var is not None:
            self._values["north_var"] = north_var
        if south is not None:
            self._values["south"] = south
        if south_var is not None:
            self._values["south_var"] = south_var
        if west is not None:
            self._values["west"] = west
        if west_var is not None:
            self._values["west_var"] = west_var

    @builtins.property
    def east(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the right side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east DataAkamaiImagingPolicyImage#east}
        '''
        result = self._values.get("east")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def east_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the right side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east_var DataAkamaiImagingPolicyImage#east_var}
        '''
        result = self._values.get("east_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def north(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the top side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north DataAkamaiImagingPolicyImage#north}
        '''
        result = self._values.get("north")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def north_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the top side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north_var DataAkamaiImagingPolicyImage#north_var}
        '''
        result = self._values.get("north_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def south(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the bottom side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south DataAkamaiImagingPolicyImage#south}
        '''
        result = self._values.get("south")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def south_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the bottom side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south_var DataAkamaiImagingPolicyImage#south_var}
        '''
        result = self._values.get("south_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def west(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the left side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west DataAkamaiImagingPolicyImage#west}
        '''
        result = self._values.get("west")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def west_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the left side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west_var DataAkamaiImagingPolicyImage#west_var}
        '''
        result = self._values.get("west_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationRelativeCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationRelativeCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationRelativeCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__045a507a45584773083ec4e4c07d6c6fcb3b44312990a3076931b11e826b00dd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationRelativeCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__47692a1f3c95d7077a2fda2d2ca5ecf9881d2cdd0c57770921d3f50eeb3e0599)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationRelativeCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__39b41ca5463bf92c5bc211119231b44c516255620eb47445e4d8c12a68be47b2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af9296696f2351a797667e339b020d22f04530a279b76f8b2c8c1ceb7069caec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c312cdcb641b25f93b4d17439b6f174cc3a623876054cbf6538d2a8108673b08)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationRelativeCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationRelativeCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationRelativeCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__87a07bb83e608fa0a83db8629c19d5903afa74bc7235ced0ca051adf09604323)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationRelativeCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationRelativeCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eef1fd6d18f1972b8a6b9a620708ea80744441deae8c438fddcfe3bbb98aded7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetEast")
    def reset_east(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEast", []))

    @jsii.member(jsii_name="resetEastVar")
    def reset_east_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEastVar", []))

    @jsii.member(jsii_name="resetNorth")
    def reset_north(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNorth", []))

    @jsii.member(jsii_name="resetNorthVar")
    def reset_north_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNorthVar", []))

    @jsii.member(jsii_name="resetSouth")
    def reset_south(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSouth", []))

    @jsii.member(jsii_name="resetSouthVar")
    def reset_south_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSouthVar", []))

    @jsii.member(jsii_name="resetWest")
    def reset_west(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWest", []))

    @jsii.member(jsii_name="resetWestVar")
    def reset_west_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWestVar", []))

    @builtins.property
    @jsii.member(jsii_name="eastInput")
    def east_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "eastInput"))

    @builtins.property
    @jsii.member(jsii_name="eastVarInput")
    def east_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "eastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="northInput")
    def north_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "northInput"))

    @builtins.property
    @jsii.member(jsii_name="northVarInput")
    def north_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "northVarInput"))

    @builtins.property
    @jsii.member(jsii_name="southInput")
    def south_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "southInput"))

    @builtins.property
    @jsii.member(jsii_name="southVarInput")
    def south_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "southVarInput"))

    @builtins.property
    @jsii.member(jsii_name="westInput")
    def west_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "westInput"))

    @builtins.property
    @jsii.member(jsii_name="westVarInput")
    def west_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "westVarInput"))

    @builtins.property
    @jsii.member(jsii_name="east")
    def east(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "east"))

    @east.setter
    def east(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__247937f36d03a10c2c1d8694c2c8f04e32c1a45b1fbcd6a1683f7eb87735eb26)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "east", value)

    @builtins.property
    @jsii.member(jsii_name="eastVar")
    def east_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "eastVar"))

    @east_var.setter
    def east_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__16d2b02db50afb8381ad0e8ffc9850c8455874eda3b1550ae2cfcd6bf2137df0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "eastVar", value)

    @builtins.property
    @jsii.member(jsii_name="north")
    def north(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "north"))

    @north.setter
    def north(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9c302418f7b5d908f9a07dd134745531d7a7d1b490784704e79f71bb7da1be26)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "north", value)

    @builtins.property
    @jsii.member(jsii_name="northVar")
    def north_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "northVar"))

    @north_var.setter
    def north_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7f709318290b82c3d0420a6c5ffedc16c04f081bb80ffcbc9ef0b6bb31024052)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "northVar", value)

    @builtins.property
    @jsii.member(jsii_name="south")
    def south(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "south"))

    @south.setter
    def south(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__72d001862c22463529182f8991b7cde80dc4d29e8de412faaa7776bb9b8fee43)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "south", value)

    @builtins.property
    @jsii.member(jsii_name="southVar")
    def south_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "southVar"))

    @south_var.setter
    def south_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ec8019f576e3a9c13ff2d21ca9444aa63f7376ff962b6ca623c923b37cfd2fa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "southVar", value)

    @builtins.property
    @jsii.member(jsii_name="west")
    def west(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "west"))

    @west.setter
    def west(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e6bfd7813d36285fefb7cd01c83c18647bca3afbc96f412aa5a984492c355bba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "west", value)

    @builtins.property
    @jsii.member(jsii_name="westVar")
    def west_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "westVar"))

    @west_var.setter
    def west_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4f3373bbbda5d9599e9e4114bc8576ee19542b4b7c14010071dcec18861ba840)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "westVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationRelativeCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationRelativeCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationRelativeCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5b0fa0c6b32e0fb4dd2fcdee8485648d2e85ab776a6c24ee07a166ec9cbec243)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationRemoveColor",
    jsii_struct_bases=[],
    name_mapping={
        "color": "color",
        "color_var": "colorVar",
        "feather": "feather",
        "feather_var": "featherVar",
        "tolerance": "tolerance",
        "tolerance_var": "toleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationRemoveColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
        feather: typing.Optional[builtins.str] = None,
        feather_var: typing.Optional[builtins.str] = None,
        tolerance: typing.Optional[builtins.str] = None,
        tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        :param feather: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        :param feather_var: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        :param tolerance: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        :param tolerance_var: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4407ccca39da027c94a72b0637b0158b61e07efec719a46e370c65df14e86c51)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
            check_type(argname="argument feather", value=feather, expected_type=type_hints["feather"])
            check_type(argname="argument feather_var", value=feather_var, expected_type=type_hints["feather_var"])
            check_type(argname="argument tolerance", value=tolerance, expected_type=type_hints["tolerance"])
            check_type(argname="argument tolerance_var", value=tolerance_var, expected_type=type_hints["tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var
        if feather is not None:
            self._values["feather"] = feather
        if feather_var is not None:
            self._values["feather_var"] = feather_var
        if tolerance is not None:
            self._values["tolerance"] = tolerance
        if tolerance_var is not None:
            self._values["tolerance_var"] = tolerance_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        '''
        result = self._values.get("feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather_var(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        '''
        result = self._values.get("feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        '''
        result = self._values.get("tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance_var(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        result = self._values.get("tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationRemoveColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationRemoveColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationRemoveColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__15610cd90eb9881a77c33ebacac217fc3e2b0103d15fcc46b51f3716f277af78)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationRemoveColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__37ae125fcd444c9d148c554d54341ce0016ab035151cd2b11cc7733b333d827a)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationRemoveColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__109d9d4ea4a6e6c16535d7a01170cd4c51b21bb75ed246f98571d653d8c3d8fc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__55f87c5777a705ecfa1ec18762183583d46638cde24d3a3fb01a89c12c78ee32)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__385ec00c5b3d5f2dada54b86e47530015dd9dd06a2310221536500d6aaa5d5eb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationRemoveColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationRemoveColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationRemoveColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b6390f94f7b1329da533917211e3370de84bd544a8f366f5eb4268f1d4835514)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationRemoveColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationRemoveColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__207dd3f7ce889393039a96877aa7356a62c4de2094dc104ae2b6061c8bd5cf1b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @jsii.member(jsii_name="resetFeather")
    def reset_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeather", []))

    @jsii.member(jsii_name="resetFeatherVar")
    def reset_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatherVar", []))

    @jsii.member(jsii_name="resetTolerance")
    def reset_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTolerance", []))

    @jsii.member(jsii_name="resetToleranceVar")
    def reset_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featherInput")
    def feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherInput"))

    @builtins.property
    @jsii.member(jsii_name="featherVarInput")
    def feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceInput")
    def tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceVarInput")
    def tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ea9ef7d94f29bd6c8cd7de4c6ce904c5c26980331e53cff74c27aba70ce882c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c8880aff40acbc4c75674e90b6f6546368f7b059efb2a9bd96855628074e8c70)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="feather")
    def feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "feather"))

    @feather.setter
    def feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dd8cf53b0050b5d01bd6ef3d97ab40eff8b0e2f17c9593794f59e7f69c1209b0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "feather", value)

    @builtins.property
    @jsii.member(jsii_name="featherVar")
    def feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featherVar"))

    @feather_var.setter
    def feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bcabb9b2e2f74f025bf831758e2ab3b0b3d68ce4c65f0ef1bc9db7e1da8ec661)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featherVar", value)

    @builtins.property
    @jsii.member(jsii_name="tolerance")
    def tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tolerance"))

    @tolerance.setter
    def tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8f53ad08be62d5cfe766f298e7a08cecae343b7d49e59ab506e4da51d80f3bd4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tolerance", value)

    @builtins.property
    @jsii.member(jsii_name="toleranceVar")
    def tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "toleranceVar"))

    @tolerance_var.setter
    def tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__08bceae15810928ad7b0f312fcc7e3a3d19466b8bed27f436d9301337d5f87ce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "toleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationRemoveColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationRemoveColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationRemoveColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4bf42ab73091df7ac822f6dce88df028fc908a3a51bb97a334c0ba6fd4a1f67e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationResize",
    jsii_struct_bases=[],
    name_mapping={
        "aspect": "aspect",
        "aspect_var": "aspectVar",
        "height": "height",
        "height_var": "heightVar",
        "type": "type",
        "type_var": "typeVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationResize:
    def __init__(
        self,
        *,
        aspect: typing.Optional[builtins.str] = None,
        aspect_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param aspect: Preserves the aspect ratio. Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect DataAkamaiImagingPolicyImage#aspect}
        :param aspect_var: Preserves the aspect ratio. Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_var DataAkamaiImagingPolicyImage#aspect_var}
        :param height: The height to resize the source image to. Must be set if height is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height to resize the source image to. Must be set if height is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param type: Sets constraints for the image resize. Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: Sets constraints for the image resize. Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        :param width: The width to resize the source image to. Must be set if width is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width to resize the source image to. Must be set if width is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__392a72503c68e4b1520d810824cd2f727f5c0b5f39cac53975c0a8d731060ce9)
            check_type(argname="argument aspect", value=aspect, expected_type=type_hints["aspect"])
            check_type(argname="argument aspect_var", value=aspect_var, expected_type=type_hints["aspect_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if aspect is not None:
            self._values["aspect"] = aspect
        if aspect_var is not None:
            self._values["aspect_var"] = aspect_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def aspect(self) -> typing.Optional[builtins.str]:
        '''Preserves the aspect ratio.

        Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect DataAkamaiImagingPolicyImage#aspect}
        '''
        result = self._values.get("aspect")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def aspect_var(self) -> typing.Optional[builtins.str]:
        '''Preserves the aspect ratio.

        Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_var DataAkamaiImagingPolicyImage#aspect_var}
        '''
        result = self._values.get("aspect_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height to resize the source image to. Must be set if height is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height to resize the source image to. Must be set if height is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''Sets constraints for the image resize.

        Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''Sets constraints for the image resize.

        Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width to resize the source image to. Must be set if width is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width to resize the source image to. Must be set if width is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationResize(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationResizeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationResizeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__41b2b5bc673967b6e5b63618203fbfa6b33550dec1b064e44ad806d4738aa91a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationResizeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__028b053bd240faba894dd9af2509c95c0745bc00524e64816a84b62a211d6863)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationResizeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c4770935d33a8ecadb424e8cfeac92dcb0add7a10b2aa4872a38d87f0b1500df)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7b967aa2524c56ca8c364a6bc748d2da48fbe1913494bae7ea426fedbebdebe2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1ab7b93ba3f7a9d26f0fc930297a68ea2cdf3fc9a0bc8c8a2f45fd2a17d13622)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationResize]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationResize]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationResize]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__afdb3412a6cbb0f2da07ad36f443f463c16c3a1f1e6c4fc0f104e1184091e19c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationResizeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationResizeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d439cd0bf4080e7a1ef1304ed517f6a265ddb57511815530bac3750590e97cf2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAspect")
    def reset_aspect(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspect", []))

    @jsii.member(jsii_name="resetAspectVar")
    def reset_aspect_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspectVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="aspectInput")
    def aspect_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "aspectInput"))

    @builtins.property
    @jsii.member(jsii_name="aspectVarInput")
    def aspect_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "aspectVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="aspect")
    def aspect(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "aspect"))

    @aspect.setter
    def aspect(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__750fded5322c9eca7cdca862b766277d31d261edb0f94ada88e2f437f36954a6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "aspect", value)

    @builtins.property
    @jsii.member(jsii_name="aspectVar")
    def aspect_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "aspectVar"))

    @aspect_var.setter
    def aspect_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d3605ff717ba88d7eeb644f96fe98bdf7d8ea7aa70194f2202690b1de6d10c6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "aspectVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__62d563cfaa15b55ef91269f2a8e23b069b96a34cdd139d1e3ae960d74d04f7b3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__da4eb0a8a3be645efb103a4506301d8106554d543d0b445ae09f52926127c575)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__953044a093ecf0e6c08ca278a2179067539aa21bf5013e1ef7742100d38148af)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f159ddf63b462a52dd664f1b851c9175483cb37e3ca064a7aededbd2bc1c8838)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eb65100f19b9cd79a1820f97b5d5aea5dc2c217de25aed429eec9674371ed729)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7497eaacc002dc1653c537227bf786854dfb3e16af8eccf8686309d8921a9dd5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationResize]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationResize]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationResize]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d8c1e004bbaaf33a6a3333108e29cc1a106279270a15d9d942b7d664693368f2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationRotate",
    jsii_struct_bases=[],
    name_mapping={"degrees": "degrees", "degrees_var": "degreesVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationRotate:
    def __init__(
        self,
        *,
        degrees: typing.Optional[builtins.str] = None,
        degrees_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param degrees: The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees DataAkamaiImagingPolicyImage#degrees}
        :param degrees_var: The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees_var DataAkamaiImagingPolicyImage#degrees_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dd6732cb0a96803e91de293712350a539dfd871898dd050e67e3979c8a554f0c)
            check_type(argname="argument degrees", value=degrees, expected_type=type_hints["degrees"])
            check_type(argname="argument degrees_var", value=degrees_var, expected_type=type_hints["degrees_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if degrees is not None:
            self._values["degrees"] = degrees
        if degrees_var is not None:
            self._values["degrees_var"] = degrees_var

    @builtins.property
    def degrees(self) -> typing.Optional[builtins.str]:
        '''The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees DataAkamaiImagingPolicyImage#degrees}
        '''
        result = self._values.get("degrees")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def degrees_var(self) -> typing.Optional[builtins.str]:
        '''The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees_var DataAkamaiImagingPolicyImage#degrees_var}
        '''
        result = self._values.get("degrees_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationRotate(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationRotateList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationRotateList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2372b0ce8ad1eb9448cb20b14ec5a3236d6488bac7c8f6f77a3c987fb2bafaef)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationRotateOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b0d050f401dc67944d4e277d16610045022c50542286580d92f12a6a3f5d020c)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationRotateOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d6867f2134556aa982ea21c51719effff3cd892d00f1d868f8dc105a1126eea0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__06b45bbea199499f93627fea385e2f60e29595cb744769c70d41a9389268bde8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__909f165699ee1778c657b5e20b142094c08c18e75602e0c8722c2ae47ee22e3d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationRotate]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationRotate]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationRotate]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cabd600cab129c3d2f256391a21867624e8a85ebf0f77c61cf5f12823b35571a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationRotateOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationRotateOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__309ba4b3ad0e0e60a69671305d1cc8a079eea15bdc1c96e02f3fe49d092a0ba9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetDegrees")
    def reset_degrees(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDegrees", []))

    @jsii.member(jsii_name="resetDegreesVar")
    def reset_degrees_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDegreesVar", []))

    @builtins.property
    @jsii.member(jsii_name="degreesInput")
    def degrees_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "degreesInput"))

    @builtins.property
    @jsii.member(jsii_name="degreesVarInput")
    def degrees_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "degreesVarInput"))

    @builtins.property
    @jsii.member(jsii_name="degrees")
    def degrees(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "degrees"))

    @degrees.setter
    def degrees(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__49d4bb72a51c413ab719f519e241776c225dad9acbf114fe1c78bb0aba69756f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "degrees", value)

    @builtins.property
    @jsii.member(jsii_name="degreesVar")
    def degrees_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "degreesVar"))

    @degrees_var.setter
    def degrees_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5370c1335ea69d961d2e0315cb91c3be4cecb14998f9b3f3aa998a35e8a349e3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "degreesVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationRotate]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationRotate]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationRotate]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d90ed89bbf6f56324a769785af5e5cee7919c3392fa2a6e588b9f4fe5441c88)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationScale",
    jsii_struct_bases=[],
    name_mapping={
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationScale:
    def __init__(
        self,
        *,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param height: Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged. Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged. Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3381704e57e830be7ee9778a82d0683daaf05ae3d4b0ca967bfcdd028584ed85)
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size.

        Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size.

        Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged.

        Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged.

        Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationScale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationScaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationScaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__61239b00b874f580368bbd0db83249ef9308ee886ac33467f469739c373a1049)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationScaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1c74804438de00967345e8c89ccab4ed1f5f9470a348c02256b7e8c998f5a268)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationScaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c683bbf8c15e0d3d50901e1ef359672456cd9d7f09c2eb68396b10334eadb432)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b0eb7137ac8c691838cd28fec5b66440097950e5ba2d50b1beff60cc556a4b31)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__540f25c925067a21dd27a809153f9a028ec601b97a8952c0fbe70fe05d2965b2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationScale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationScale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationScale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a40b7b089962c7a3ba5cab0d35ca57d143ed6ec782af5edc7f5ead0e1b1d0a4f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationScaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationScaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e9cbdb5c949ee0ba5605ef93fea70be86a775eb66af83cdd0d89b98aaa66d9a4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8f47a0c8ba5b6eb0492f1a836cd3c7f2ae440abf82722da2728b6686704d6356)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4cd13b3483b127863e7f897edccf26975926828c2f7a9d8038a62c2e57535382)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d016ff16660508363566d42ab262816228234c0cd9c9fc91b4af9bfcb2ffbede)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ac6182bbdbbd0727c52a86673699527be51fefb8bf6e447ab790ec6f7cc631a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationScale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationScale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationScale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ee20f27ea3c949bf98b52417a5a648932da6e466c99dec3f34081293d88ab248)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationShear",
    jsii_struct_bases=[],
    name_mapping={
        "x_shear": "xShear",
        "x_shear_var": "xShearVar",
        "y_shear": "yShear",
        "y_shear_var": "yShearVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationShear:
    def __init__(
        self,
        *,
        x_shear: typing.Optional[builtins.str] = None,
        x_shear_var: typing.Optional[builtins.str] = None,
        y_shear: typing.Optional[builtins.str] = None,
        y_shear_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param x_shear: The amount to shear along the x-axis, measured in multiples of the image's width. Must be set if yShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear DataAkamaiImagingPolicyImage#x_shear}
        :param x_shear_var: The amount to shear along the x-axis, measured in multiples of the image's width. Must be set if yShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear_var DataAkamaiImagingPolicyImage#x_shear_var}
        :param y_shear: The amount to shear along the y-axis, measured in multiples of the image's height. Must be set if xShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear DataAkamaiImagingPolicyImage#y_shear}
        :param y_shear_var: The amount to shear along the y-axis, measured in multiples of the image's height. Must be set if xShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear_var DataAkamaiImagingPolicyImage#y_shear_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a02ad13a64bc477ed553b601e7d6a25e0c728a3bd15e0475c86822c114d30574)
            check_type(argname="argument x_shear", value=x_shear, expected_type=type_hints["x_shear"])
            check_type(argname="argument x_shear_var", value=x_shear_var, expected_type=type_hints["x_shear_var"])
            check_type(argname="argument y_shear", value=y_shear, expected_type=type_hints["y_shear"])
            check_type(argname="argument y_shear_var", value=y_shear_var, expected_type=type_hints["y_shear_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if x_shear is not None:
            self._values["x_shear"] = x_shear
        if x_shear_var is not None:
            self._values["x_shear_var"] = x_shear_var
        if y_shear is not None:
            self._values["y_shear"] = y_shear
        if y_shear_var is not None:
            self._values["y_shear_var"] = y_shear_var

    @builtins.property
    def x_shear(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the x-axis, measured in multiples of the image's width.

        Must be set if yShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear DataAkamaiImagingPolicyImage#x_shear}
        '''
        result = self._values.get("x_shear")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_shear_var(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the x-axis, measured in multiples of the image's width.

        Must be set if yShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear_var DataAkamaiImagingPolicyImage#x_shear_var}
        '''
        result = self._values.get("x_shear_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_shear(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the y-axis, measured in multiples of the image's height.

        Must be set if xShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear DataAkamaiImagingPolicyImage#y_shear}
        '''
        result = self._values.get("y_shear")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_shear_var(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the y-axis, measured in multiples of the image's height.

        Must be set if xShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear_var DataAkamaiImagingPolicyImage#y_shear_var}
        '''
        result = self._values.get("y_shear_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationShear(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationShearList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationShearList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b73f1cc966dec28593e4928f40718fc11fd14abbc07116fa0a08d1030a51615a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationShearOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0b43677c25b34ca6706913e554e80f512b333626f16a8e6314044805891f2a78)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationShearOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__875ff3a1c517ba7aff8d5dc2d62bb0ab24b25ce1e599bb7bb25fd02445febc7a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__541900a6825f9a6c121b691c08b7db35a1309432fb29207b889bfd2665e9edb7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a8abd0f47f07b41fbc24c89c5a7e9d03d97e1dc7c3b2bcefe19be1a560cde113)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationShear]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationShear]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationShear]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a57dbce64de02d47c535bfe2807a52e0126d714155ea2e98f2b82ea943aaf9c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationShearOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationShearOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6668c225b18d028ee1b0363f3e720e07872f53bee801876e5b1d5fc581b53649)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetXShear")
    def reset_x_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXShear", []))

    @jsii.member(jsii_name="resetXShearVar")
    def reset_x_shear_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXShearVar", []))

    @jsii.member(jsii_name="resetYShear")
    def reset_y_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYShear", []))

    @jsii.member(jsii_name="resetYShearVar")
    def reset_y_shear_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYShearVar", []))

    @builtins.property
    @jsii.member(jsii_name="xShearInput")
    def x_shear_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xShearInput"))

    @builtins.property
    @jsii.member(jsii_name="xShearVarInput")
    def x_shear_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xShearVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yShearInput")
    def y_shear_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yShearInput"))

    @builtins.property
    @jsii.member(jsii_name="yShearVarInput")
    def y_shear_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yShearVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xShear")
    def x_shear(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xShear"))

    @x_shear.setter
    def x_shear(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f757f75c99f1f4df4d15e506fe01cd2559eb5128afe272211c925f0aed81a96d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xShear", value)

    @builtins.property
    @jsii.member(jsii_name="xShearVar")
    def x_shear_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xShearVar"))

    @x_shear_var.setter
    def x_shear_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c28abbccf18e3787e390e48c3092f87529057974443cab5b4b575c5cbea0e640)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xShearVar", value)

    @builtins.property
    @jsii.member(jsii_name="yShear")
    def y_shear(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yShear"))

    @y_shear.setter
    def y_shear(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__27eb774d090ad6357ef133723e2221227eaddf4e0d4e65dd58827a5040d2851c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yShear", value)

    @builtins.property
    @jsii.member(jsii_name="yShearVar")
    def y_shear_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yShearVar"))

    @y_shear_var.setter
    def y_shear_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__286743c966f89ecdf0ef134235161448699590a5de650b37fa90dd338501fca0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yShearVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationShear]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationShear]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationShear]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b2c5668304dc209019e39ff4d3b72bf047988c42a1502e20d990bb4ce84bff2c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationTrim",
    jsii_struct_bases=[],
    name_mapping={
        "fuzz": "fuzz",
        "fuzz_var": "fuzzVar",
        "padding": "padding",
        "padding_var": "paddingVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationTrim:
    def __init__(
        self,
        *,
        fuzz: typing.Optional[builtins.str] = None,
        fuzz_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fuzz: The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz DataAkamaiImagingPolicyImage#fuzz}
        :param fuzz_var: The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz_var DataAkamaiImagingPolicyImage#fuzz_var}
        :param padding: The amount of padding in pixels to add to the trimmed image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: The amount of padding in pixels to add to the trimmed image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d3faa512cb7c1c2cef7fbfce547f1f9d6049dfb241d2e52dc42ca6c0f7943713)
            check_type(argname="argument fuzz", value=fuzz, expected_type=type_hints["fuzz"])
            check_type(argname="argument fuzz_var", value=fuzz_var, expected_type=type_hints["fuzz_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fuzz is not None:
            self._values["fuzz"] = fuzz
        if fuzz_var is not None:
            self._values["fuzz_var"] = fuzz_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var

    @builtins.property
    def fuzz(self) -> typing.Optional[builtins.str]:
        '''The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz DataAkamaiImagingPolicyImage#fuzz}
        '''
        result = self._values.get("fuzz")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fuzz_var(self) -> typing.Optional[builtins.str]:
        '''The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz_var DataAkamaiImagingPolicyImage#fuzz_var}
        '''
        result = self._values.get("fuzz_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''The amount of padding in pixels to add to the trimmed image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''The amount of padding in pixels to add to the trimmed image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationTrim(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationTrimList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationTrimList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__867341506dd4af07b7845b00f8c3bf2cc7ca4cd266c8531d4446eaa9729d5a41)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationTrimOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d2244fec3efccabe17212b3636d9bdd944ac1d945bd36152f0c20c07c8f8624e)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationTrimOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3e6d83b659b47f82a4e82eac934cea0abbdb1328e16f01731ee7a41b0576c296)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7425a77799f4cc5486ed3a8fccd5c0165bc3da1eba2d437e3fe237e97cba9731)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a6b747c4844e4941fd4ef968c90e04b3a14323cad8bf5adc823ddf895438128)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationTrim]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationTrim]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationTrim]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__92fda9da8cd2fbae1e7bdbc06d072b3a87f25fdf77f3f39e44871e2254487c7e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationTrimOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationTrimOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__38f78fc1a05ebe82d8e0614de95d8b0a4e6ef92f48a6787e5adcacd3a8a9ecc3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetFuzz")
    def reset_fuzz(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFuzz", []))

    @jsii.member(jsii_name="resetFuzzVar")
    def reset_fuzz_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFuzzVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @builtins.property
    @jsii.member(jsii_name="fuzzInput")
    def fuzz_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fuzzInput"))

    @builtins.property
    @jsii.member(jsii_name="fuzzVarInput")
    def fuzz_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fuzzVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="fuzz")
    def fuzz(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fuzz"))

    @fuzz.setter
    def fuzz(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__921375c720400748003905ce7889a5951d2c23c540b1f1c7ae5af2c0bc0e87f1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fuzz", value)

    @builtins.property
    @jsii.member(jsii_name="fuzzVar")
    def fuzz_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fuzzVar"))

    @fuzz_var.setter
    def fuzz_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fbba21170e39a34e4412cbb27eb8c721d728c57767504531d308ae05f3c1ec5d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fuzzVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__91a021a7e73cc41a4d6c5fc74b977893905bbb1bf46af2afa58eebf73298d4c9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0da77ebcfc70007d6364c42370f8e0a161d3f6d8971f99a28dfa66fd4f651742)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationTrim]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationTrim]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationTrim]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c6a8fdcaaad2e9c4629df1c7781bbb63115d870f1d8df23924711285cd5ab7b3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationUnsharpMask",
    jsii_struct_bases=[],
    name_mapping={
        "gain": "gain",
        "gain_var": "gainVar",
        "sigma": "sigma",
        "sigma_var": "sigmaVar",
        "threshold": "threshold",
        "threshold_var": "thresholdVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationUnsharpMask:
    def __init__(
        self,
        *,
        gain: typing.Optional[builtins.str] = None,
        gain_var: typing.Optional[builtins.str] = None,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
        threshold: typing.Optional[builtins.str] = None,
        threshold_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param gain: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        :param gain_var: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        :param sigma: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        :param threshold: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        :param threshold_var: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4c24d0a5f4488596e4bda502e22eb1932123cec411a3830779af08a113ddf15a)
            check_type(argname="argument gain", value=gain, expected_type=type_hints["gain"])
            check_type(argname="argument gain_var", value=gain_var, expected_type=type_hints["gain_var"])
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
            check_type(argname="argument threshold", value=threshold, expected_type=type_hints["threshold"])
            check_type(argname="argument threshold_var", value=threshold_var, expected_type=type_hints["threshold_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if gain is not None:
            self._values["gain"] = gain
        if gain_var is not None:
            self._values["gain_var"] = gain_var
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var
        if threshold is not None:
            self._values["threshold"] = threshold
        if threshold_var is not None:
            self._values["threshold_var"] = threshold_var

    @builtins.property
    def gain(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        '''
        result = self._values.get("gain")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gain_var(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        '''
        result = self._values.get("gain_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        '''
        result = self._values.get("threshold")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold_var(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        result = self._values.get("threshold_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationUnsharpMask(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationUnsharpMaskList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationUnsharpMaskList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4778b1a96301df5db5981f78621f0d454c91fc9090df4dbe974d7509d848a9bb)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationUnsharpMaskOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4fd048dabee61ac6babe40fb4addb9f99547b51aeabfb4e4ad132698cd10760f)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationUnsharpMaskOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__24d6b3c5d35e93a03b41ad9b5867fe87cbbe658e77d086b9e914818ae5f83a4c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a7cdaf008184f771f813560b71e32f0d1a5ddbc8af8c248d28a7f5fbfa60780)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__07388add1cd06061af560487760375e7e3a46eef001ff2d7419ea1ecacf92955)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationUnsharpMask]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationUnsharpMask]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationUnsharpMask]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4f4c5a868343b5d94ab2762baa7c14728a25ccf1d877b362503ac1d427dd3b91)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationUnsharpMaskOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationUnsharpMaskOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__85ca2034c27589f284ee80452ec831de8e80675b1da728a0596071a00f227456)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetGain")
    def reset_gain(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGain", []))

    @jsii.member(jsii_name="resetGainVar")
    def reset_gain_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGainVar", []))

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @jsii.member(jsii_name="resetThreshold")
    def reset_threshold(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThreshold", []))

    @jsii.member(jsii_name="resetThresholdVar")
    def reset_threshold_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThresholdVar", []))

    @builtins.property
    @jsii.member(jsii_name="gainInput")
    def gain_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainInput"))

    @builtins.property
    @jsii.member(jsii_name="gainVarInput")
    def gain_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdInput")
    def threshold_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdVarInput")
    def threshold_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gain")
    def gain(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gain"))

    @gain.setter
    def gain(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__37445717a84f4763a8b940020f00afac05e318c012347d238469195960ca9932)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gain", value)

    @builtins.property
    @jsii.member(jsii_name="gainVar")
    def gain_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gainVar"))

    @gain_var.setter
    def gain_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9b81d0989bc785abed89c2c7e1ca10477b8c8e1a6c5322d6b8e6faa4ea5d85d8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gainVar", value)

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a02ea2131b5d1924fa9cec18ef15f920bbe7dd6418c84269adc4287fdacf98ed)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5897e0e8319b077812acd496118aa7272471bf07a205159a988f32059018ab06)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="threshold")
    def threshold(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "threshold"))

    @threshold.setter
    def threshold(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ea1c8995503569098d0c5b6d763a1513ff2e42feb86238d61fdbbf32e6d3727)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "threshold", value)

    @builtins.property
    @jsii.member(jsii_name="thresholdVar")
    def threshold_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "thresholdVar"))

    @threshold_var.setter
    def threshold_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4c27a27297e7063757f788dcca3494f8fc10b96e718ac01e540a553237a62c5b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "thresholdVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationUnsharpMask]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationUnsharpMask]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationUnsharpMask]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e801de9f4ff07c0559e5d88233cacc08752a5fa4fc7dd3dcf1142cfc048c94a1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0e04d0bb9f9c858f100683c4ecc044f9d2c7f187b861584a3f100cbb5d9a53a9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__59dfaa151012f3d7f8e8d2ec4876884244f381aea97f1a0ee5dca12b6c423f3e)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ffd76edab97b59be8bbb2f630ea1473eb2fa0bbd2ccd69f493bb8f80c7a6031d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a5b0f4f9db0bb619deb33c745143aa87eb781ee2e6e93fecdb033528b4ee17a0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e43bfe9a91162bfd6d3c7e773e4d601d2f2ce7effcfa3bcf01826da85f034d35)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFill]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFill]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFill]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0dbc4bc5cafd9f3504c880ed06bb777d2822ce3fe3f83e9f42fddbb78ae706f0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1e4d653eedfb6447da5051d33c54df37ea6fc1205d325f06b14a9d49a5fca0e8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putFillTransformation")
    def put_fill_transformation(
        self,
        *,
        append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationAppend, typing.Dict[builtins.str, typing.Any]]]]] = None,
        aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationAspectCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
        crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationFaceCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationFeatureCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationFitAndFill, typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
        im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationImQuery, typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
        region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationRegionOfInterestCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationRelativeCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
        resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationResize, typing.Dict[builtins.str, typing.Any]]]]] = None,
        rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationRotate, typing.Dict[builtins.str, typing.Any]]]]] = None,
        scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationScale, typing.Dict[builtins.str, typing.Any]]]]] = None,
        shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationShear, typing.Dict[builtins.str, typing.Any]]]]] = None,
        trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationTrim, typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param append: append block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        :param aspect_crop: aspect_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param crop: crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        :param face_crop: face_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        :param feature_crop: feature_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        :param fit_and_fill: fit_and_fill block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param im_query: im_query block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param region_of_interest_crop: region_of_interest_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        :param relative_crop: relative_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param resize: resize block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        :param rotate: rotate block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        :param scale: scale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param shear: shear block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        :param trim: trim block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformation(
            append=append,
            aspect_crop=aspect_crop,
            background_color=background_color,
            blur=blur,
            chroma_key=chroma_key,
            composite=composite,
            compound=compound,
            contrast=contrast,
            crop=crop,
            face_crop=face_crop,
            feature_crop=feature_crop,
            fit_and_fill=fit_and_fill,
            goop=goop,
            grayscale=grayscale,
            hsl=hsl,
            hsv=hsv,
            if_dimension=if_dimension,
            if_orientation=if_orientation,
            im_query=im_query,
            max_colors=max_colors,
            mirror=mirror,
            mono_hue=mono_hue,
            opacity=opacity,
            region_of_interest_crop=region_of_interest_crop,
            relative_crop=relative_crop,
            remove_color=remove_color,
            resize=resize,
            rotate=rotate,
            scale=scale,
            shear=shear,
            trim=trim,
            unsharp_mask=unsharp_mask,
        )

        return typing.cast(None, jsii.invoke(self, "putFillTransformation", [value]))

    @jsii.member(jsii_name="resetFillTransformation")
    def reset_fill_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFillTransformation", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="fillTransformation")
    def fill_transformation(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationOutputReference, jsii.get(self, "fillTransformation"))

    @builtins.property
    @jsii.member(jsii_name="fillTransformationInput")
    def fill_transformation_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformation], jsii.get(self, "fillTransformationInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c71517f7b83b8f7195f90a5e6ee6667beafd7172207b45c3121be6c133b57be8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cdc0ec6e24254857091930f224262e9b4deab128834a6a29f7758f4bc0bb7cdf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a8a1126bc140a930d3f1d74346eb63cda9fef6e45fc5512223c01c690c898779)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__41928a6e3775e8d7c59f6ff5d5e59b4823de9da8ee7cd2786768e51d6a7aa54c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFill]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFill]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFill]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__83652ba233fe078bb92636b702f5cb3413cc982938ca8201b81e8429e566e0d3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultGoop",
    jsii_struct_bases=[],
    name_mapping={
        "chaos": "chaos",
        "chaos_var": "chaosVar",
        "density": "density",
        "density_var": "densityVar",
        "power": "power",
        "power_var": "powerVar",
        "seed": "seed",
        "seed_var": "seedVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultGoop:
    def __init__(
        self,
        *,
        chaos: typing.Optional[builtins.str] = None,
        chaos_var: typing.Optional[builtins.str] = None,
        density: typing.Optional[builtins.str] = None,
        density_var: typing.Optional[builtins.str] = None,
        power: typing.Optional[builtins.str] = None,
        power_var: typing.Optional[builtins.str] = None,
        seed: typing.Optional[builtins.str] = None,
        seed_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param chaos: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        :param chaos_var: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        :param density: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        :param density_var: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        :param power: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        :param power_var: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        :param seed: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        :param seed_var: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ca50491c818f8dcd736d194839b4f73c1eaec06daaf2c3f477fa1564dd3cd0f)
            check_type(argname="argument chaos", value=chaos, expected_type=type_hints["chaos"])
            check_type(argname="argument chaos_var", value=chaos_var, expected_type=type_hints["chaos_var"])
            check_type(argname="argument density", value=density, expected_type=type_hints["density"])
            check_type(argname="argument density_var", value=density_var, expected_type=type_hints["density_var"])
            check_type(argname="argument power", value=power, expected_type=type_hints["power"])
            check_type(argname="argument power_var", value=power_var, expected_type=type_hints["power_var"])
            check_type(argname="argument seed", value=seed, expected_type=type_hints["seed"])
            check_type(argname="argument seed_var", value=seed_var, expected_type=type_hints["seed_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if chaos is not None:
            self._values["chaos"] = chaos
        if chaos_var is not None:
            self._values["chaos_var"] = chaos_var
        if density is not None:
            self._values["density"] = density
        if density_var is not None:
            self._values["density_var"] = density_var
        if power is not None:
            self._values["power"] = power
        if power_var is not None:
            self._values["power_var"] = power_var
        if seed is not None:
            self._values["seed"] = seed
        if seed_var is not None:
            self._values["seed_var"] = seed_var

    @builtins.property
    def chaos(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        '''
        result = self._values.get("chaos")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def chaos_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        '''
        result = self._values.get("chaos_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        '''
        result = self._values.get("density")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density_var(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        '''
        result = self._values.get("density_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        '''
        result = self._values.get("power")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power_var(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        '''
        result = self._values.get("power_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        '''
        result = self._values.get("seed")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed_var(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        result = self._values.get("seed_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultGoop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultGoopList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultGoopList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__01f4df024e452803bbfb1c53b1e0b4e518d6ff30afffb51f93712f0348d7cb67)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultGoopOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bcf7c0e6714588a4011a5c170e0441fbc8bfcef6cd472a7c18ad53a2d78eb7de)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultGoopOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__492d2fd371026aaf4dd25c572ee44a058b4223c8dd9f7314f0783e41a9e3886f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e3b53fd9f6b55bd7d163334dfef494aeec54fd1ca499225a975cf103960cbecc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fb352745f8cacfd6940da5aa6b1276c54e61db1653bb1cd5f6084a13f5122811)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultGoop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultGoop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f489d0cc825e4a275d522a6c6d415c29a8abc65942c4f8932d2334775ebd5bc9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultGoopOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultGoopOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4cfe4f2f0ad28a02526c257dca9d07fbbebdf013781fede45567b4da4b107c34)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetChaos")
    def reset_chaos(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaos", []))

    @jsii.member(jsii_name="resetChaosVar")
    def reset_chaos_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaosVar", []))

    @jsii.member(jsii_name="resetDensity")
    def reset_density(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensity", []))

    @jsii.member(jsii_name="resetDensityVar")
    def reset_density_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensityVar", []))

    @jsii.member(jsii_name="resetPower")
    def reset_power(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPower", []))

    @jsii.member(jsii_name="resetPowerVar")
    def reset_power_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPowerVar", []))

    @jsii.member(jsii_name="resetSeed")
    def reset_seed(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeed", []))

    @jsii.member(jsii_name="resetSeedVar")
    def reset_seed_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeedVar", []))

    @builtins.property
    @jsii.member(jsii_name="chaosInput")
    def chaos_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosInput"))

    @builtins.property
    @jsii.member(jsii_name="chaosVarInput")
    def chaos_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosVarInput"))

    @builtins.property
    @jsii.member(jsii_name="densityInput")
    def density_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityInput"))

    @builtins.property
    @jsii.member(jsii_name="densityVarInput")
    def density_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="powerInput")
    def power_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerInput"))

    @builtins.property
    @jsii.member(jsii_name="powerVarInput")
    def power_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerVarInput"))

    @builtins.property
    @jsii.member(jsii_name="seedInput")
    def seed_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedInput"))

    @builtins.property
    @jsii.member(jsii_name="seedVarInput")
    def seed_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedVarInput"))

    @builtins.property
    @jsii.member(jsii_name="chaos")
    def chaos(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaos"))

    @chaos.setter
    def chaos(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ae6044d3f0834551a9cf3c523b363b32c9b8b4ed377123b902b58f19d88ebeac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaos", value)

    @builtins.property
    @jsii.member(jsii_name="chaosVar")
    def chaos_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaosVar"))

    @chaos_var.setter
    def chaos_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4f74dcf622ddda131a4ae9975e3aa406a997aeba134124f022eb14f63377f998)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaosVar", value)

    @builtins.property
    @jsii.member(jsii_name="density")
    def density(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "density"))

    @density.setter
    def density(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__45808d45099794d23f5496657308e4f625aae75046fe9e3f5471ffc0a49097c4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "density", value)

    @builtins.property
    @jsii.member(jsii_name="densityVar")
    def density_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "densityVar"))

    @density_var.setter
    def density_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c50e504bcf6b89ab71108b69a72e7f4d457dfd89b1ef47d11afc29dbeb796c01)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "densityVar", value)

    @builtins.property
    @jsii.member(jsii_name="power")
    def power(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "power"))

    @power.setter
    def power(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9067f0b79480cea07b7557ecc9003713a1ec14ba621688b968ce62974f3dd238)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "power", value)

    @builtins.property
    @jsii.member(jsii_name="powerVar")
    def power_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "powerVar"))

    @power_var.setter
    def power_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__888f36cd490c2a4120065e28a864da55768f04078074c7aceaa258b403b5486b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "powerVar", value)

    @builtins.property
    @jsii.member(jsii_name="seed")
    def seed(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seed"))

    @seed.setter
    def seed(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__69c0930939f2b0131a2513cf802d13f17984deb4c2daea0c26390dbb9cefffc9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seed", value)

    @builtins.property
    @jsii.member(jsii_name="seedVar")
    def seed_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seedVar"))

    @seed_var.setter
    def seed_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b78cca253a97d345819253b9c17f87ab3576c18f21a04a91fd732c321d6ed015)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seedVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultGoop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultGoop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultGoop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4afc758b32488e0d720b4db09f19d473f65a5862178414b692d5f2971a88bfb7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultGrayscale",
    jsii_struct_bases=[],
    name_mapping={"type": "type", "type_var": "typeVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultGrayscale:
    def __init__(
        self,
        *,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param type: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__83f4af5e0c50591fb828d83243fdf35dfebda65ed6b9396159f4c2b493fdc359)
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultGrayscale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultGrayscaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultGrayscaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__521c473303a34985eee782061d6e5b595180fa0d12629ef04571e0b1b1019f54)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultGrayscaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1389e98a5fba9ddf7ee56cd831b5770a2e3b786b9f7616ff9d31081161bdc326)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultGrayscaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__19f981763a326b4780e2adaea0697416b35d7575ad41f942fea9937d00020f80)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__450768aa262b46b174d2a15624097d22d353575368bc37ff31f3c515dcb50913)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__756624238c633c516ed388206a69bf405de5bbb57755d34896e7ede2336bfd76)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultGrayscale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultGrayscale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__467c0313bac9d2dfef5a836b62f62a5bcde63a5848cc47cecbcaa8b8607f6aad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultGrayscaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultGrayscaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a8908b60a8bb6d8a3e0744ead192f089af357a154ee614dcd690ab5d740a1f84)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__20e4abe3bdddcc6f6b3a506a476b8061b8ee27d624b9a1eee86e45a916e61f17)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cb0da14867cefa0036f603627ed65574828430af68c7099ab5eeee48a467d302)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultGrayscale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultGrayscale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultGrayscale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__937561af44d0d6a6d0e09f494161caa2ec5f075423af82fc3099ee11d5f88c75)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultHsl",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "lightness": "lightness",
        "lightness_var": "lightnessVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultHsl:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness: typing.Optional[builtins.str] = None,
        lightness_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        :param lightness_var: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e87c56388cb20d60c10a0aeb2f7ad2ddfbdef6d2413ec97dead4a8f76f36d495)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness", value=lightness, expected_type=type_hints["lightness"])
            check_type(argname="argument lightness_var", value=lightness_var, expected_type=type_hints["lightness_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness is not None:
            self._values["lightness"] = lightness
        if lightness_var is not None:
            self._values["lightness_var"] = lightness_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        '''
        result = self._values.get("lightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        '''
        result = self._values.get("lightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultHsl(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultHslList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultHslList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8311ffd966305cd87d1b76bd801395e466244e4f0cbd6c419f0cbc5624bae966)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultHslOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c986ee5efb29ed23fcb20ecedff6e56c05af70d7d1c1e31b57d3034dc016b101)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultHslOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fc2b7ca8c638406b5d09c4cd12f5518800d8d76a4c61ce7ec12de9e68bab466a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__84275501cc81843f2e6c23ae07cf231a13376e2fc96a3a5ebc82c452ce4430e7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea62a661aff2a6192bd2900c2623572cf8331f09a2235ab9bc895a5a03e85c4e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultHsl]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultHsl]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__da4dd9f00081a6f38b3c4d866ab84516136392024a15501546501620bf5f783c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultHslOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultHslOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b38a53f093788a88fd2045ce19d73533589796a0a9e7f04024ac73ef06c37b9f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightness")
    def reset_lightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightness", []))

    @jsii.member(jsii_name="resetLightnessVar")
    def reset_lightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessInput")
    def lightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessVarInput")
    def lightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7e144df10c8c6fe7736ab78c26e791032a534ea02aa6c84eef5e5e4b61b64e86)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ad8116c62676986cbe2c34f5b48f0187ec68ae4b78ba5b3b2d76312d408149a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightness")
    def lightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightness"))

    @lightness.setter
    def lightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__765e31dd608d53e3806085d1fbbd098f405903f72d30ccb8700a646b4db5e09c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightness", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessVar")
    def lightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessVar"))

    @lightness_var.setter
    def lightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fbcb10a056a915402f61b7aeff570752e8505dd7b6a322ee763b3fc83a7448b6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9bb704a4e7df798b311a8edda050ac064fe53ff6777b990733bab3c3255849de)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dbcb04c75fd6a3866a8a9669366be9d318983147116988262f9cc5bf728950c4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultHsl]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultHsl]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultHsl]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f4112e360a7549c4862a21fc07cd992455fb453d54400eb461fd11f939b744c7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultHsv",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultHsv:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        :param value: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__01467b5009cb606bc2c14b4d7d5b558248bff543b815f0eb91a32adfd12f7ae8)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultHsv(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultHsvList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultHsvList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f5e093486cec633611f81b5e353f90f6b52cf2c1b0839c7dd829bb6320f58e0d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultHsvOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__25af9605092e129b7256c8e4dfb57d224e000e1dbcba458657706c8bfafaf073)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultHsvOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e0733be5eb8cdbfd0ca35e1d719403640195c686c2867618ad1ed92596e346ab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cc2a934ce264c01762db1d260a58f7ff0c90b0ffabd5fbdeefc6c6954e1ebbeb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8ba10685610c6c68992bccd9916b3dec9f41b8f938004c108e6d68e8bcf9b111)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultHsv]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultHsv]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ef4bd2e598dbe088e1e80de6da1cf6a0b2df46b654597468ac716c72bbb8e06)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultHsvOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultHsvOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__47de0517187912237558419d09bf7c89ca0ddf4e7e280584b24fa93938425599)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0cd011f90a6df4b727b0053ab7d3eec2b12045f674f1583c68842e2f22aef64e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__02d2cf1366bd638a22032d67e8bb1192e99254ae5132e9123225a3a2ddd7964f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bd6494ef5aec3d6e942014e94fd1d96ebe5b07293c193189fc4ad0bf0bb8a586)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__23c189d0d93dbec7af48f49daa7c6c9a779d5398f6ff4e20df5965975de86267)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d49ccf01c4d8c22cc3888081c8a4335c0935b47387a5a34a11333ec049917555)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bed031f4242f5f181e9b1f8c9f7e888e6c7479c68be35c29bcd89189d66e32ca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultHsv]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultHsv]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultHsv]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0a862378938e8ce619040d7d7b4fe64feb3fb07f8352063a44a3c71076c77955)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimension",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "dimension": "dimension",
        "dimension_var": "dimensionVar",
        "equal": "equal",
        "greater_than": "greaterThan",
        "less_than": "lessThan",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimension:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefault, typing.Dict[builtins.str, typing.Any]]] = None,
        dimension: typing.Optional[builtins.str] = None,
        dimension_var: typing.Optional[builtins.str] = None,
        equal: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqual", typing.Dict[builtins.str, typing.Any]]] = None,
        greater_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThan", typing.Dict[builtins.str, typing.Any]]] = None,
        less_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThan", typing.Dict[builtins.str, typing.Any]]] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param dimension: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        :param dimension_var: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        :param equal: equal block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        :param greater_than: greater_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        :param less_than: less_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        :param value: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefault(**default)
        if isinstance(equal, dict):
            equal = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqual(**equal)
        if isinstance(greater_than, dict):
            greater_than = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThan(**greater_than)
        if isinstance(less_than, dict):
            less_than = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThan(**less_than)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e89ce6dc97f1069235e5c7e0f353a092a77aaa5efce8dbaeda71a878201dace8)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument dimension", value=dimension, expected_type=type_hints["dimension"])
            check_type(argname="argument dimension_var", value=dimension_var, expected_type=type_hints["dimension_var"])
            check_type(argname="argument equal", value=equal, expected_type=type_hints["equal"])
            check_type(argname="argument greater_than", value=greater_than, expected_type=type_hints["greater_than"])
            check_type(argname="argument less_than", value=less_than, expected_type=type_hints["less_than"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if dimension is not None:
            self._values["dimension"] = dimension
        if dimension_var is not None:
            self._values["dimension_var"] = dimension_var
        if equal is not None:
            self._values["equal"] = equal
        if greater_than is not None:
            self._values["greater_than"] = greater_than
        if less_than is not None:
            self._values["less_than"] = less_than
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def default(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefault]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefault], result)

    @builtins.property
    def dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        '''
        result = self._values.get("dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        '''
        result = self._values.get("dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def equal(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqual"]:
        '''equal block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        '''
        result = self._values.get("equal")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqual"], result)

    @builtins.property
    def greater_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThan"]:
        '''greater_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        '''
        result = self._values.get("greater_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThan"], result)

    @builtins.property
    def less_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThan"]:
        '''less_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        '''
        result = self._values.get("less_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThan"], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimension(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqual",
    jsii_struct_bases=[],
    name_mapping={
        "append": "append",
        "aspect_crop": "aspectCrop",
        "background_color": "backgroundColor",
        "blur": "blur",
        "chroma_key": "chromaKey",
        "composite": "composite",
        "compound": "compound",
        "contrast": "contrast",
        "crop": "crop",
        "face_crop": "faceCrop",
        "feature_crop": "featureCrop",
        "fit_and_fill": "fitAndFill",
        "goop": "goop",
        "grayscale": "grayscale",
        "hsl": "hsl",
        "hsv": "hsv",
        "if_dimension": "ifDimension",
        "if_orientation": "ifOrientation",
        "im_query": "imQuery",
        "max_colors": "maxColors",
        "mirror": "mirror",
        "mono_hue": "monoHue",
        "opacity": "opacity",
        "region_of_interest_crop": "regionOfInterestCrop",
        "relative_crop": "relativeCrop",
        "remove_color": "removeColor",
        "resize": "resize",
        "rotate": "rotate",
        "scale": "scale",
        "shear": "shear",
        "trim": "trim",
        "unsharp_mask": "unsharpMask",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqual:
    def __init__(
        self,
        *,
        append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualAppend", typing.Dict[builtins.str, typing.Any]]]]] = None,
        aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualAspectCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualBackgroundColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualBlur", typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualChromaKey", typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualComposite", typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualCompound", typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualContrast", typing.Dict[builtins.str, typing.Any]]]]] = None,
        crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualFaceCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualFeatureCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualFitAndFill", typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualGoop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualGrayscale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualHsl", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualHsv", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfDimension", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfOrientation", typing.Dict[builtins.str, typing.Any]]]]] = None,
        im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualImQuery", typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualMaxColors", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualMirror", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualMonoHue", typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualOpacity", typing.Dict[builtins.str, typing.Any]]]]] = None,
        region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualRegionOfInterestCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualRelativeCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualRemoveColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualResize", typing.Dict[builtins.str, typing.Any]]]]] = None,
        rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualRotate", typing.Dict[builtins.str, typing.Any]]]]] = None,
        scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualScale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualShear", typing.Dict[builtins.str, typing.Any]]]]] = None,
        trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualTrim", typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualUnsharpMask", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param append: append block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        :param aspect_crop: aspect_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param crop: crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        :param face_crop: face_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        :param feature_crop: feature_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        :param fit_and_fill: fit_and_fill block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param im_query: im_query block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param region_of_interest_crop: region_of_interest_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        :param relative_crop: relative_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param resize: resize block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        :param rotate: rotate block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        :param scale: scale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param shear: shear block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        :param trim: trim block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__33af459ec804194378bce40da9503708c69180c3989a1c9fc750d23892dcdb73)
            check_type(argname="argument append", value=append, expected_type=type_hints["append"])
            check_type(argname="argument aspect_crop", value=aspect_crop, expected_type=type_hints["aspect_crop"])
            check_type(argname="argument background_color", value=background_color, expected_type=type_hints["background_color"])
            check_type(argname="argument blur", value=blur, expected_type=type_hints["blur"])
            check_type(argname="argument chroma_key", value=chroma_key, expected_type=type_hints["chroma_key"])
            check_type(argname="argument composite", value=composite, expected_type=type_hints["composite"])
            check_type(argname="argument compound", value=compound, expected_type=type_hints["compound"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument crop", value=crop, expected_type=type_hints["crop"])
            check_type(argname="argument face_crop", value=face_crop, expected_type=type_hints["face_crop"])
            check_type(argname="argument feature_crop", value=feature_crop, expected_type=type_hints["feature_crop"])
            check_type(argname="argument fit_and_fill", value=fit_and_fill, expected_type=type_hints["fit_and_fill"])
            check_type(argname="argument goop", value=goop, expected_type=type_hints["goop"])
            check_type(argname="argument grayscale", value=grayscale, expected_type=type_hints["grayscale"])
            check_type(argname="argument hsl", value=hsl, expected_type=type_hints["hsl"])
            check_type(argname="argument hsv", value=hsv, expected_type=type_hints["hsv"])
            check_type(argname="argument if_dimension", value=if_dimension, expected_type=type_hints["if_dimension"])
            check_type(argname="argument if_orientation", value=if_orientation, expected_type=type_hints["if_orientation"])
            check_type(argname="argument im_query", value=im_query, expected_type=type_hints["im_query"])
            check_type(argname="argument max_colors", value=max_colors, expected_type=type_hints["max_colors"])
            check_type(argname="argument mirror", value=mirror, expected_type=type_hints["mirror"])
            check_type(argname="argument mono_hue", value=mono_hue, expected_type=type_hints["mono_hue"])
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument region_of_interest_crop", value=region_of_interest_crop, expected_type=type_hints["region_of_interest_crop"])
            check_type(argname="argument relative_crop", value=relative_crop, expected_type=type_hints["relative_crop"])
            check_type(argname="argument remove_color", value=remove_color, expected_type=type_hints["remove_color"])
            check_type(argname="argument resize", value=resize, expected_type=type_hints["resize"])
            check_type(argname="argument rotate", value=rotate, expected_type=type_hints["rotate"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument shear", value=shear, expected_type=type_hints["shear"])
            check_type(argname="argument trim", value=trim, expected_type=type_hints["trim"])
            check_type(argname="argument unsharp_mask", value=unsharp_mask, expected_type=type_hints["unsharp_mask"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if append is not None:
            self._values["append"] = append
        if aspect_crop is not None:
            self._values["aspect_crop"] = aspect_crop
        if background_color is not None:
            self._values["background_color"] = background_color
        if blur is not None:
            self._values["blur"] = blur
        if chroma_key is not None:
            self._values["chroma_key"] = chroma_key
        if composite is not None:
            self._values["composite"] = composite
        if compound is not None:
            self._values["compound"] = compound
        if contrast is not None:
            self._values["contrast"] = contrast
        if crop is not None:
            self._values["crop"] = crop
        if face_crop is not None:
            self._values["face_crop"] = face_crop
        if feature_crop is not None:
            self._values["feature_crop"] = feature_crop
        if fit_and_fill is not None:
            self._values["fit_and_fill"] = fit_and_fill
        if goop is not None:
            self._values["goop"] = goop
        if grayscale is not None:
            self._values["grayscale"] = grayscale
        if hsl is not None:
            self._values["hsl"] = hsl
        if hsv is not None:
            self._values["hsv"] = hsv
        if if_dimension is not None:
            self._values["if_dimension"] = if_dimension
        if if_orientation is not None:
            self._values["if_orientation"] = if_orientation
        if im_query is not None:
            self._values["im_query"] = im_query
        if max_colors is not None:
            self._values["max_colors"] = max_colors
        if mirror is not None:
            self._values["mirror"] = mirror
        if mono_hue is not None:
            self._values["mono_hue"] = mono_hue
        if opacity is not None:
            self._values["opacity"] = opacity
        if region_of_interest_crop is not None:
            self._values["region_of_interest_crop"] = region_of_interest_crop
        if relative_crop is not None:
            self._values["relative_crop"] = relative_crop
        if remove_color is not None:
            self._values["remove_color"] = remove_color
        if resize is not None:
            self._values["resize"] = resize
        if rotate is not None:
            self._values["rotate"] = rotate
        if scale is not None:
            self._values["scale"] = scale
        if shear is not None:
            self._values["shear"] = shear
        if trim is not None:
            self._values["trim"] = trim
        if unsharp_mask is not None:
            self._values["unsharp_mask"] = unsharp_mask

    @builtins.property
    def append(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualAppend"]]]:
        '''append block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        '''
        result = self._values.get("append")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualAppend"]]], result)

    @builtins.property
    def aspect_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualAspectCrop"]]]:
        '''aspect_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        '''
        result = self._values.get("aspect_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualAspectCrop"]]], result)

    @builtins.property
    def background_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualBackgroundColor"]]]:
        '''background_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        '''
        result = self._values.get("background_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualBackgroundColor"]]], result)

    @builtins.property
    def blur(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualBlur"]]]:
        '''blur block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        '''
        result = self._values.get("blur")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualBlur"]]], result)

    @builtins.property
    def chroma_key(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualChromaKey"]]]:
        '''chroma_key block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        '''
        result = self._values.get("chroma_key")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualChromaKey"]]], result)

    @builtins.property
    def composite(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualComposite"]]]:
        '''composite block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        '''
        result = self._values.get("composite")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualComposite"]]], result)

    @builtins.property
    def compound(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualCompound"]]]:
        '''compound block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        '''
        result = self._values.get("compound")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualCompound"]]], result)

    @builtins.property
    def contrast(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualContrast"]]]:
        '''contrast block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualContrast"]]], result)

    @builtins.property
    def crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualCrop"]]]:
        '''crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        '''
        result = self._values.get("crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualCrop"]]], result)

    @builtins.property
    def face_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualFaceCrop"]]]:
        '''face_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        '''
        result = self._values.get("face_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualFaceCrop"]]], result)

    @builtins.property
    def feature_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualFeatureCrop"]]]:
        '''feature_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        '''
        result = self._values.get("feature_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualFeatureCrop"]]], result)

    @builtins.property
    def fit_and_fill(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualFitAndFill"]]]:
        '''fit_and_fill block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        '''
        result = self._values.get("fit_and_fill")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualFitAndFill"]]], result)

    @builtins.property
    def goop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualGoop"]]]:
        '''goop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        '''
        result = self._values.get("goop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualGoop"]]], result)

    @builtins.property
    def grayscale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualGrayscale"]]]:
        '''grayscale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        '''
        result = self._values.get("grayscale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualGrayscale"]]], result)

    @builtins.property
    def hsl(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualHsl"]]]:
        '''hsl block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        '''
        result = self._values.get("hsl")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualHsl"]]], result)

    @builtins.property
    def hsv(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualHsv"]]]:
        '''hsv block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        '''
        result = self._values.get("hsv")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualHsv"]]], result)

    @builtins.property
    def if_dimension(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfDimension"]]]:
        '''if_dimension block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        '''
        result = self._values.get("if_dimension")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfDimension"]]], result)

    @builtins.property
    def if_orientation(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfOrientation"]]]:
        '''if_orientation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        '''
        result = self._values.get("if_orientation")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfOrientation"]]], result)

    @builtins.property
    def im_query(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualImQuery"]]]:
        '''im_query block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        '''
        result = self._values.get("im_query")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualImQuery"]]], result)

    @builtins.property
    def max_colors(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualMaxColors"]]]:
        '''max_colors block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        '''
        result = self._values.get("max_colors")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualMaxColors"]]], result)

    @builtins.property
    def mirror(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualMirror"]]]:
        '''mirror block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        '''
        result = self._values.get("mirror")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualMirror"]]], result)

    @builtins.property
    def mono_hue(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualMonoHue"]]]:
        '''mono_hue block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        '''
        result = self._values.get("mono_hue")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualMonoHue"]]], result)

    @builtins.property
    def opacity(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualOpacity"]]]:
        '''opacity block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualOpacity"]]], result)

    @builtins.property
    def region_of_interest_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualRegionOfInterestCrop"]]]:
        '''region_of_interest_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        '''
        result = self._values.get("region_of_interest_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualRegionOfInterestCrop"]]], result)

    @builtins.property
    def relative_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualRelativeCrop"]]]:
        '''relative_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        '''
        result = self._values.get("relative_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualRelativeCrop"]]], result)

    @builtins.property
    def remove_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualRemoveColor"]]]:
        '''remove_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        '''
        result = self._values.get("remove_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualRemoveColor"]]], result)

    @builtins.property
    def resize(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualResize"]]]:
        '''resize block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        '''
        result = self._values.get("resize")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualResize"]]], result)

    @builtins.property
    def rotate(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualRotate"]]]:
        '''rotate block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        '''
        result = self._values.get("rotate")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualRotate"]]], result)

    @builtins.property
    def scale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualScale"]]]:
        '''scale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualScale"]]], result)

    @builtins.property
    def shear(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualShear"]]]:
        '''shear block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        '''
        result = self._values.get("shear")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualShear"]]], result)

    @builtins.property
    def trim(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualTrim"]]]:
        '''trim block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        '''
        result = self._values.get("trim")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualTrim"]]], result)

    @builtins.property
    def unsharp_mask(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualUnsharpMask"]]]:
        '''unsharp_mask block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        result = self._values.get("unsharp_mask")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualUnsharpMask"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqual(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualAppend",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_priority": "gravityPriority",
        "gravity_priority_var": "gravityPriorityVar",
        "gravity_var": "gravityVar",
        "preserve_minor_dimension": "preserveMinorDimension",
        "preserve_minor_dimension_var": "preserveMinorDimensionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualAppend:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualAppendImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_priority: typing.Optional[builtins.str] = None,
        gravity_priority_var: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        preserve_minor_dimension: typing.Optional[builtins.str] = None,
        preserve_minor_dimension_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Specifies where to place the ``image`` relative to the source image. The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_priority: Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal. The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority DataAkamaiImagingPolicyImage#gravity_priority}
        :param gravity_priority_var: Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal. The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority_var DataAkamaiImagingPolicyImage#gravity_priority_var}
        :param gravity_var: Specifies where to place the ``image`` relative to the source image. The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param preserve_minor_dimension: Whether to preserve the source image's minor dimension, ``false`` by default. The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension DataAkamaiImagingPolicyImage#preserve_minor_dimension}
        :param preserve_minor_dimension_var: Whether to preserve the source image's minor dimension, ``false`` by default. The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension_var DataAkamaiImagingPolicyImage#preserve_minor_dimension_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualAppendImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f3ae053353b71f91f3fe7c5534b2bad52fb5526bd599fd7a0959913123a505a)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_priority", value=gravity_priority, expected_type=type_hints["gravity_priority"])
            check_type(argname="argument gravity_priority_var", value=gravity_priority_var, expected_type=type_hints["gravity_priority_var"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument preserve_minor_dimension", value=preserve_minor_dimension, expected_type=type_hints["preserve_minor_dimension"])
            check_type(argname="argument preserve_minor_dimension_var", value=preserve_minor_dimension_var, expected_type=type_hints["preserve_minor_dimension_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_priority is not None:
            self._values["gravity_priority"] = gravity_priority
        if gravity_priority_var is not None:
            self._values["gravity_priority_var"] = gravity_priority_var
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if preserve_minor_dimension is not None:
            self._values["preserve_minor_dimension"] = preserve_minor_dimension
        if preserve_minor_dimension_var is not None:
            self._values["preserve_minor_dimension_var"] = preserve_minor_dimension_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualAppendImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualAppendImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Specifies where to place the ``image`` relative to the source image.

        The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_priority(self) -> typing.Optional[builtins.str]:
        '''Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal.

        The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority DataAkamaiImagingPolicyImage#gravity_priority}
        '''
        result = self._values.get("gravity_priority")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_priority_var(self) -> typing.Optional[builtins.str]:
        '''Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal.

        The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority_var DataAkamaiImagingPolicyImage#gravity_priority_var}
        '''
        result = self._values.get("gravity_priority_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Specifies where to place the ``image`` relative to the source image.

        The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def preserve_minor_dimension(self) -> typing.Optional[builtins.str]:
        '''Whether to preserve the source image's minor dimension, ``false`` by default.

        The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension DataAkamaiImagingPolicyImage#preserve_minor_dimension}
        '''
        result = self._values.get("preserve_minor_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def preserve_minor_dimension_var(self) -> typing.Optional[builtins.str]:
        '''Whether to preserve the source image's minor dimension, ``false`` by default.

        The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension_var DataAkamaiImagingPolicyImage#preserve_minor_dimension_var}
        '''
        result = self._values.get("preserve_minor_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualAppend(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualAppendImage",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualAppendImage:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualAppendImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualAppendImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualAppendImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7db5ef7d5099bce32f33ca529cab41830eefbd1ce417ccd09e60a2f6fb0c0707)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualAppendImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualAppendImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualAppendImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__711ba361843f83c3cba7f0915ba704e848963be6b929bebe1f2a29d3f2fefe97)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualAppendList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualAppendList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6da99d97141aba7055337b1a5dad0c6de72af6fffa0dc62711083eca27b1bab9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualAppendOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__26e63129ae5c5c0fd717d7d009080d157054d8054e5f117c17ebdd423b7ef09d)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualAppendOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__204e089c2734ba7390c813e0091061b5cf0c6c44492ba67353efe23a90df700b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8f1fde5f046759813f5c8c3a0e18d85cf28d11565539fd4dd2c955c59ca8c5f1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__08804662d52a9f237af2da2c5928aa8123d122eb0ae8f934de643b54680cd846)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualAppend]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualAppend]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualAppend]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d9ad2e5aa830c0cb4574d0504a2af83fe769c9d83b505fdd94a773f73aa0ea4b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualAppendOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualAppendOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1aacca43e1d4e7737e69e039386f769411336b8a99402550cd33ecfb560082ab)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualAppendImage()

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityPriority")
    def reset_gravity_priority(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityPriority", []))

    @jsii.member(jsii_name="resetGravityPriorityVar")
    def reset_gravity_priority_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityPriorityVar", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPreserveMinorDimension")
    def reset_preserve_minor_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPreserveMinorDimension", []))

    @jsii.member(jsii_name="resetPreserveMinorDimensionVar")
    def reset_preserve_minor_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPreserveMinorDimensionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualAppendImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualAppendImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityInput")
    def gravity_priority_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityPriorityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityVarInput")
    def gravity_priority_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityPriorityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualAppendImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualAppendImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionInput")
    def preserve_minor_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "preserveMinorDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionVarInput")
    def preserve_minor_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "preserveMinorDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0329cc7b56cf5425415d05d788e95ba47d3b64fff252f98b7f1cae4c409a97f7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityPriority")
    def gravity_priority(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityPriority"))

    @gravity_priority.setter
    def gravity_priority(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e36c8a9ef0e7d19ab2074c363a4d245e8a604343870449a230957f0ebf475ae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityPriority", value)

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityVar")
    def gravity_priority_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityPriorityVar"))

    @gravity_priority_var.setter
    def gravity_priority_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1bbf7d6e6cd9989a1fb90d21f286bd697501e8e0c4417fec1b7e3422a89d9e9a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityPriorityVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__50218a86fac527e8a78ebb9929b0b73185b4ef43540d72385ab1e506d19540ff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimension")
    def preserve_minor_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "preserveMinorDimension"))

    @preserve_minor_dimension.setter
    def preserve_minor_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e3a56749fba2608bf921c0cf85f0f7ff4e0942b88471a3a18a4e373a9aaf6561)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "preserveMinorDimension", value)

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionVar")
    def preserve_minor_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "preserveMinorDimensionVar"))

    @preserve_minor_dimension_var.setter
    def preserve_minor_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a91b0a3d1840bd31df230061ca07a5c87dff2b5afe1c78d257b450e5f4c78a49)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "preserveMinorDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualAppend]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualAppend]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualAppend]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb815167a13923a613e9b57073bbdd32af81697942cf27b03de2ede77e2f7ac9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualAspectCrop",
    jsii_struct_bases=[],
    name_mapping={
        "allow_expansion": "allowExpansion",
        "allow_expansion_var": "allowExpansionVar",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualAspectCrop:
    def __init__(
        self,
        *,
        allow_expansion: typing.Optional[builtins.str] = None,
        allow_expansion_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_expansion: Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image. Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        :param allow_expansion_var: Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image. Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        :param height: The height term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The width term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        :param x_position: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c2d6de784de48aa9e9a5a402ef8b4635d489e118302681ebc038913be82e3add)
            check_type(argname="argument allow_expansion", value=allow_expansion, expected_type=type_hints["allow_expansion"])
            check_type(argname="argument allow_expansion_var", value=allow_expansion_var, expected_type=type_hints["allow_expansion_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if allow_expansion is not None:
            self._values["allow_expansion"] = allow_expansion
        if allow_expansion_var is not None:
            self._values["allow_expansion_var"] = allow_expansion_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def allow_expansion(self) -> typing.Optional[builtins.str]:
        '''Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image.

        Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        '''
        result = self._values.get("allow_expansion")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def allow_expansion_var(self) -> typing.Optional[builtins.str]:
        '''Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image.

        Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        '''
        result = self._values.get("allow_expansion_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualAspectCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualAspectCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualAspectCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6b7b58c8f0bd98100b643e71cc7008476dc9df8432c2bd8af4431403f7dd99a2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualAspectCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b9e6974a5411ae26cd06aa96f6f0c046e4c7e01ec79b0071101a796d17360f8a)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualAspectCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ec510c1d3859cfe0bf25bf61f4a41328f81a66524b310213251bea3b0100353)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__467e624132ec811a0c967aae67d5a64f694e8ea3a47b8c3f343a0cad194031a7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e78cef18c6fa9a070dac3e6610d41c221e0159cd2a17bc0dfd9b8aa958ed97bc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualAspectCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualAspectCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualAspectCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d49df900387b935fd956f2a3737ca5faad5ec4baed908794c83d2cbb5ed77d61)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualAspectCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualAspectCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bf94aff384c619cec02d7b2e63b9c361cffd06924c46292a13d5eade5dbd66fd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAllowExpansion")
    def reset_allow_expansion(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansion", []))

    @jsii.member(jsii_name="resetAllowExpansionVar")
    def reset_allow_expansion_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansionVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionInput")
    def allow_expansion_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVarInput")
    def allow_expansion_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansion")
    def allow_expansion(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansion"))

    @allow_expansion.setter
    def allow_expansion(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e0907d30082e0592d251d00f041a944c6fcf735f4a6f80a096d0d2da32dff4a1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansion", value)

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVar")
    def allow_expansion_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansionVar"))

    @allow_expansion_var.setter
    def allow_expansion_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4950c8871a6203fc9bce0a5f51aaa854cbd8a0d6efc53b368925edc0d7ac381b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansionVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__52181450f4b60ca33e45e62fe0d697d2fe8b6cfc80663b4b016a316100ba13ef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__db4857dd4f8cc5e1f0663be508698b4d1795ec9422783540073fe3b94d8e19b5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6febc198f1cd768ab24f8e240597562620bb70e42dab8c5750c503d61a52aa84)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a8cf1b65a579b96e17de6986e8bf5dd287cedcd71a771c1791606e47cfe0858f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__863a1b02c3ac555868917452824cba655dd5a8405cd2e23a397c4b9f0402d2e6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__93b66fac8ca1736b55cdea5411e769e76e2fd7c29ed81e080e35c3421784ed12)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bdb309d5a3cba3f60da60ed65ae83d7b7138f7035a866d666707ff53ca7e9687)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ff8155ba239a0b289b463b244af20e9292cde65750bbc2bc0f4b8c12c2341404)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualAspectCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualAspectCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualAspectCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0e66760c362394deb6c390a9b23ae1e3664a31917bacb8a5589b4e6c2b3d2b00)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualBackgroundColor",
    jsii_struct_bases=[],
    name_mapping={"color": "color", "color_var": "colorVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualBackgroundColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e319784383d25811128f42974559e1ffa2d358a8f11c4bad1e670ad647a2d352)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualBackgroundColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualBackgroundColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualBackgroundColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__36c9f0ec4434666991e3d97344970987f1bf33abfc1859045a89553bca3418bc)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualBackgroundColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ca347711a8e25b55bb4e2482943b7e3517a2e2bbbdddadd98ec720c65274d5e)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualBackgroundColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0a0a74d51062400c862872489b0ad2c930ca0e83a47a49f3c9b0f07f60b17b93)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dbcc81c56df4c52e1589eff9c9211c7b57d301fe2b00ee68cb4682ef5c8f6b51)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4de0e15301e8df8f860eb7d19a3796679084cf3efe01c748d17252ffd4b1febc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualBackgroundColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualBackgroundColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f79d3413dedb05922c5c46187cba4c6a0674dba25503c5982a0273ac3e018174)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualBackgroundColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualBackgroundColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4f2b468717ac51a578614e5d06ec3078b370f39720408028ddeba4c1e72fa9f6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__95276e32493a348a74df99dbaaa19ec9f5ea0a534325c9733eb84db09650a86f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6deac07bc99057a9acfd0cf65aa811d388b77f834f97766b5304ca7f057bc842)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualBackgroundColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualBackgroundColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualBackgroundColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b813b48c22ff77981f136c37cb821085eec5055d2c76518fae0765953a7d5faf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualBlur",
    jsii_struct_bases=[],
    name_mapping={"sigma": "sigma", "sigma_var": "sigmaVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualBlur:
    def __init__(
        self,
        *,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param sigma: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1e677dba8e90254f68c8bdc8557d88595584d4c2b07d80182edff7159f733e19)
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualBlur(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualBlurList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualBlurList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__93264bc440c9befbfb500ef9430187b75d5be7a4416cb96504eccd94a8954cfd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualBlurOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e7f180fbfca7d42aba8def455567bbb2c2f3afdbf64323005d549e7b7f87a03b)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualBlurOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__57ccd64d59c5ac662c5d5f681897548c1e44665c7cd669be58ec8644e6e85c82)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d938149f58109c12dcd163deee513eb213613a35ae8f705fae1773763c8eed6d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df7dc4c253b634cc5b9244a8649a8bb9956acc889acf7cf63066a12fbc0caeca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualBlur]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualBlur]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ba32845d74f7ccaf694dd93d34569bdc8321b6c4a361a551b63397b8ae18e72)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualBlurOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualBlurOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7ca3dfbde7eb35e08c5ae31b858836defd7bc7e5cc5126932454def0fd2f518d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e8607651bbe418f1289abb73eca9b4525c6f9a1491241b2b1ba1e57abc77cf79)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__06df82dcc574f4da250f4362cbc6901e49541f2e27c3cff44f26b97bda894334)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualBlur]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualBlur]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualBlur]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7c5083ae2ea8734a8080af2aec3ed348bc97204dba0b0f5b2fc1acf611eb2da5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualChromaKey",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_feather": "hueFeather",
        "hue_feather_var": "hueFeatherVar",
        "hue_tolerance": "hueTolerance",
        "hue_tolerance_var": "hueToleranceVar",
        "hue_var": "hueVar",
        "lightness_feather": "lightnessFeather",
        "lightness_feather_var": "lightnessFeatherVar",
        "lightness_tolerance": "lightnessTolerance",
        "lightness_tolerance_var": "lightnessToleranceVar",
        "saturation_feather": "saturationFeather",
        "saturation_feather_var": "saturationFeatherVar",
        "saturation_tolerance": "saturationTolerance",
        "saturation_tolerance_var": "saturationToleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualChromaKey:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_feather: typing.Optional[builtins.str] = None,
        hue_feather_var: typing.Optional[builtins.str] = None,
        hue_tolerance: typing.Optional[builtins.str] = None,
        hue_tolerance_var: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness_feather: typing.Optional[builtins.str] = None,
        lightness_feather_var: typing.Optional[builtins.str] = None,
        lightness_tolerance: typing.Optional[builtins.str] = None,
        lightness_tolerance_var: typing.Optional[builtins.str] = None,
        saturation_feather: typing.Optional[builtins.str] = None,
        saturation_feather_var: typing.Optional[builtins.str] = None,
        saturation_tolerance: typing.Optional[builtins.str] = None,
        saturation_tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_feather: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        :param hue_feather_var: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        :param hue_tolerance: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        :param hue_tolerance_var: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        :param hue_var: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness_feather: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        :param lightness_feather_var: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        :param lightness_tolerance: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        :param lightness_tolerance_var: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        :param saturation_feather: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        :param saturation_feather_var: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        :param saturation_tolerance: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        :param saturation_tolerance_var: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab094b01e5c0696b9d58868a6a3c9b441f56e28b3b18d4b123e7a7eaaaa0e9d6)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_feather", value=hue_feather, expected_type=type_hints["hue_feather"])
            check_type(argname="argument hue_feather_var", value=hue_feather_var, expected_type=type_hints["hue_feather_var"])
            check_type(argname="argument hue_tolerance", value=hue_tolerance, expected_type=type_hints["hue_tolerance"])
            check_type(argname="argument hue_tolerance_var", value=hue_tolerance_var, expected_type=type_hints["hue_tolerance_var"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness_feather", value=lightness_feather, expected_type=type_hints["lightness_feather"])
            check_type(argname="argument lightness_feather_var", value=lightness_feather_var, expected_type=type_hints["lightness_feather_var"])
            check_type(argname="argument lightness_tolerance", value=lightness_tolerance, expected_type=type_hints["lightness_tolerance"])
            check_type(argname="argument lightness_tolerance_var", value=lightness_tolerance_var, expected_type=type_hints["lightness_tolerance_var"])
            check_type(argname="argument saturation_feather", value=saturation_feather, expected_type=type_hints["saturation_feather"])
            check_type(argname="argument saturation_feather_var", value=saturation_feather_var, expected_type=type_hints["saturation_feather_var"])
            check_type(argname="argument saturation_tolerance", value=saturation_tolerance, expected_type=type_hints["saturation_tolerance"])
            check_type(argname="argument saturation_tolerance_var", value=saturation_tolerance_var, expected_type=type_hints["saturation_tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_feather is not None:
            self._values["hue_feather"] = hue_feather
        if hue_feather_var is not None:
            self._values["hue_feather_var"] = hue_feather_var
        if hue_tolerance is not None:
            self._values["hue_tolerance"] = hue_tolerance
        if hue_tolerance_var is not None:
            self._values["hue_tolerance_var"] = hue_tolerance_var
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness_feather is not None:
            self._values["lightness_feather"] = lightness_feather
        if lightness_feather_var is not None:
            self._values["lightness_feather_var"] = lightness_feather_var
        if lightness_tolerance is not None:
            self._values["lightness_tolerance"] = lightness_tolerance
        if lightness_tolerance_var is not None:
            self._values["lightness_tolerance_var"] = lightness_tolerance_var
        if saturation_feather is not None:
            self._values["saturation_feather"] = saturation_feather
        if saturation_feather_var is not None:
            self._values["saturation_feather_var"] = saturation_feather_var
        if saturation_tolerance is not None:
            self._values["saturation_tolerance"] = saturation_tolerance
        if saturation_tolerance_var is not None:
            self._values["saturation_tolerance_var"] = saturation_tolerance_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        '''
        result = self._values.get("hue_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        '''
        result = self._values.get("hue_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        '''
        result = self._values.get("hue_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        '''
        result = self._values.get("hue_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        '''
        result = self._values.get("lightness_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        '''
        result = self._values.get("lightness_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        '''
        result = self._values.get("lightness_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        '''
        result = self._values.get("lightness_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        '''
        result = self._values.get("saturation_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        '''
        result = self._values.get("saturation_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        '''
        result = self._values.get("saturation_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        result = self._values.get("saturation_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualChromaKey(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualChromaKeyList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualChromaKeyList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__31c70c5b98fedc325c746a1d672ae6303b2fe470ed3af2b49ad424213081685a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualChromaKeyOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f4af3ccd5e858761ca75809d22852125461b7dc0d1482fb4cc09e173a1b2716d)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualChromaKeyOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a2d16b99ad795ae4fe0c1f76988f7946315d2a3b34ea23feab9c215583155f9d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ee84c9d32f57c06b3041f6e7168b0a29b66b5f640f065eb1457fb0651724ca1e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a1ddfffdace415b699b3ee61d5e02062dfeedf4b9bba25f415381e56c7ee86d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualChromaKey]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualChromaKey]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4775c3ff995232aef6901b955e4e38ecf51f0eb542a4fc8b32c8f85f7747e0a5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualChromaKeyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualChromaKeyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f36332b57c092f6fb2d7848b78f0c1f387d16a3a16cf014f83a9718265a32e4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueFeather")
    def reset_hue_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeather", []))

    @jsii.member(jsii_name="resetHueFeatherVar")
    def reset_hue_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeatherVar", []))

    @jsii.member(jsii_name="resetHueTolerance")
    def reset_hue_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueTolerance", []))

    @jsii.member(jsii_name="resetHueToleranceVar")
    def reset_hue_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueToleranceVar", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightnessFeather")
    def reset_lightness_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeather", []))

    @jsii.member(jsii_name="resetLightnessFeatherVar")
    def reset_lightness_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeatherVar", []))

    @jsii.member(jsii_name="resetLightnessTolerance")
    def reset_lightness_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessTolerance", []))

    @jsii.member(jsii_name="resetLightnessToleranceVar")
    def reset_lightness_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessToleranceVar", []))

    @jsii.member(jsii_name="resetSaturationFeather")
    def reset_saturation_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeather", []))

    @jsii.member(jsii_name="resetSaturationFeatherVar")
    def reset_saturation_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeatherVar", []))

    @jsii.member(jsii_name="resetSaturationTolerance")
    def reset_saturation_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationTolerance", []))

    @jsii.member(jsii_name="resetSaturationToleranceVar")
    def reset_saturation_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherInput")
    def hue_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVarInput")
    def hue_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceInput")
    def hue_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVarInput")
    def hue_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherInput")
    def lightness_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVarInput")
    def lightness_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceInput")
    def lightness_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVarInput")
    def lightness_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherInput")
    def saturation_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVarInput")
    def saturation_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceInput")
    def saturation_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVarInput")
    def saturation_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4735d44f33170b982200bb1af9b42d73834148b0599d9b8c5ec7aa8e01df2dbd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeather")
    def hue_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeather"))

    @hue_feather.setter
    def hue_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__874967ce6d31175f1c66a612ac08aec57230e3f3cce3ea5e5f397c7884927baf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeather", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVar")
    def hue_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeatherVar"))

    @hue_feather_var.setter
    def hue_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c358d25cbe3141cb6d7914d5c30ba26a481615594a3a336c0da316f7649048bd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueTolerance")
    def hue_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueTolerance"))

    @hue_tolerance.setter
    def hue_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__24b59bd857d5239dd6c9ea3a84434cd31751141a30926479313410c78079b028)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVar")
    def hue_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueToleranceVar"))

    @hue_tolerance_var.setter
    def hue_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bee9f12186396d976479969613ad3ba0ed60914fd4429fad8f4096f14cbb0934)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dede8e5375029e65653dc1d9be56fcc060bd49ab5c236f06aeb13af68aa1c100)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeather")
    def lightness_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeather"))

    @lightness_feather.setter
    def lightness_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e4259e1f6fbf7c1cdb6b82f7afb3b1cdbb88bbd941d575d3c7dc76066d6c57bb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeather", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVar")
    def lightness_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeatherVar"))

    @lightness_feather_var.setter
    def lightness_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac5ede70cdb61f1a75b85aa274cefd9eb0744067522c719c1c5e9adac39dd591)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessTolerance")
    def lightness_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessTolerance"))

    @lightness_tolerance.setter
    def lightness_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__93b52c66f4eb5a029a66ca3cbfa536307ccde519370162090d8da696a99562b5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVar")
    def lightness_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessToleranceVar"))

    @lightness_tolerance_var.setter
    def lightness_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e0d2ef0f252adaab8e592d79c5ab70157a9c0e45b1351f070e648248ae4f6e30)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeather")
    def saturation_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeather"))

    @saturation_feather.setter
    def saturation_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc067de5b791089043fce4e53cf73942f5984eb67d1deb99efdffe3d7a377937)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeather", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVar")
    def saturation_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeatherVar"))

    @saturation_feather_var.setter
    def saturation_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e0f222ad6fa933951a6360604632302df2f4ad7f62b0a82db7a8a32cdd90c456)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationTolerance")
    def saturation_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationTolerance"))

    @saturation_tolerance.setter
    def saturation_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a70a58f2e81d9c93314aa3056028579b77f216d916170f7b44c6389ab5f906fc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVar")
    def saturation_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationToleranceVar"))

    @saturation_tolerance_var.setter
    def saturation_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d5c65c53cf13a6f85898aea7ad3b82167535133049037f2aad9474b5205e157)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualChromaKey]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualChromaKey]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualChromaKey]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea7fab6b4af3b050009f04057082a238ab39e2ffa4f231ca2cce5c67c8809f21)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualComposite",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "placement": "placement",
        "placement_var": "placementVar",
        "scale": "scale",
        "scale_dimension": "scaleDimension",
        "scale_dimension_var": "scaleDimensionVar",
        "scale_var": "scaleVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualComposite:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualCompositeImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        placement: typing.Optional[builtins.str] = None,
        placement_var: typing.Optional[builtins.str] = None,
        scale: typing.Optional[builtins.str] = None,
        scale_dimension: typing.Optional[builtins.str] = None,
        scale_dimension_var: typing.Optional[builtins.str] = None,
        scale_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param placement: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        :param placement_var: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        :param scale: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param scale_dimension: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        :param scale_dimension_var: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        :param scale_var: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        :param x_position: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualCompositeImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0576d6677d759a45138eb09529142403e40c4d5f10f4bb864b2a40bc969345af)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument placement", value=placement, expected_type=type_hints["placement"])
            check_type(argname="argument placement_var", value=placement_var, expected_type=type_hints["placement_var"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument scale_dimension", value=scale_dimension, expected_type=type_hints["scale_dimension"])
            check_type(argname="argument scale_dimension_var", value=scale_dimension_var, expected_type=type_hints["scale_dimension_var"])
            check_type(argname="argument scale_var", value=scale_var, expected_type=type_hints["scale_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if placement is not None:
            self._values["placement"] = placement
        if placement_var is not None:
            self._values["placement_var"] = placement_var
        if scale is not None:
            self._values["scale"] = scale
        if scale_dimension is not None:
            self._values["scale_dimension"] = scale_dimension
        if scale_dimension_var is not None:
            self._values["scale_dimension_var"] = scale_dimension_var
        if scale_var is not None:
            self._values["scale_var"] = scale_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualCompositeImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualCompositeImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        '''
        result = self._values.get("placement")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement_var(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        '''
        result = self._values.get("placement_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        '''
        result = self._values.get("scale_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        '''
        result = self._values.get("scale_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        '''
        result = self._values.get("scale_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualComposite(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualCompositeImage",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualCompositeImage:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualCompositeImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualCompositeImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualCompositeImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b92a1b69ebf193160c3b7faa3de357ea5edf52e78edda423dfe1954b29b236bf)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualCompositeImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualCompositeImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__84da9e2f7f6dea53c55920e88569eb00e163a3d4e5355e18df13e29f18ba0151)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualCompositeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualCompositeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7b7ff0ca432a06524f456d89cab739dc9ea7071130c00a69d3c41385f95fe9d2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualCompositeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__39b2afed1d17dc9f44e6276e8a2380e5afe38b145c1cec3cd9c40e3ff64be5a7)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualCompositeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__22765aeaf8e0ad343a3898644e8c91130ef4cf2fbd78281bf1940c565cfab6e5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__94df929ab93a692c89ac9757837297b3f52f298843a7fde1c70bea641be8744d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1c039ebb3dde0c554ba9074350c0fe003c31d56c0ea623d073c832a41d1a1ca7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualComposite]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualComposite]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__637adb533084eba6a5c08af8ab54e5dc1b138c415710767e356e187ce671e594)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualCompositeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualCompositeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e565a5c5b4a5fec50e065c0627f5c983b6c4f2530ce998488274830cc3f070fd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualCompositeImage()

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPlacement")
    def reset_placement(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacement", []))

    @jsii.member(jsii_name="resetPlacementVar")
    def reset_placement_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacementVar", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetScaleDimension")
    def reset_scale_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimension", []))

    @jsii.member(jsii_name="resetScaleDimensionVar")
    def reset_scale_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimensionVar", []))

    @jsii.member(jsii_name="resetScaleVar")
    def reset_scale_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualCompositeImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualCompositeImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualCompositeImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="placementInput")
    def placement_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementInput"))

    @builtins.property
    @jsii.member(jsii_name="placementVarInput")
    def placement_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionInput")
    def scale_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVarInput")
    def scale_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleVarInput")
    def scale_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__26ef5479ea85a9f6548a636c30e37dc87642756a17163e6c2222f92fafe9e1d6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b76d1b4be9317600a1cf6c24509dbb716a65e58673d0df3ef722ad4fd54a6599)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="placement")
    def placement(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placement"))

    @placement.setter
    def placement(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af99e5f153db6abb535d1c7cf14591536c1450b8c07d919e63ff4784126d48c4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placement", value)

    @builtins.property
    @jsii.member(jsii_name="placementVar")
    def placement_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placementVar"))

    @placement_var.setter
    def placement_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d24761d38e81a403d1973b2dc3ac23f566d65f0d6f5cfc7f4f7e8c266cee8e4b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placementVar", value)

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scale"))

    @scale.setter
    def scale(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__38bf09ecd3cbc0a65f93415b36b51961c396a37c59b3c76e9b90f2d26f729da6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scale", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimension")
    def scale_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimension"))

    @scale_dimension.setter
    def scale_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e3ca9734bddf37b5255a5835171b51209523f2c7d90d169b976efffc4e029847)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimension", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVar")
    def scale_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimensionVar"))

    @scale_dimension_var.setter
    def scale_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__883c5eac16159dc65dfa89b17db7342762c11ec1e046cc1adec869d4e0912431)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="scaleVar")
    def scale_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleVar"))

    @scale_var.setter
    def scale_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__85491606524d4b380b253c76036bb02cab746b5883a8c62cb624145e653b96ca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bee015a16198b67f880e9820ec9801933fe4fbf02a54ebe2ee7b944c7cd3fbc9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__025cf0d3f12004e40ce5a227974bd13d5b954b2e8c450dc0c6383716926fb7e1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6eb288d60937efcf7424bf7e27debf0c158d272dfbe7244054a22f64b794b04e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9287aa61c4e05d1f5485bc5872316f997f00bda12f6d179fdd51bf597753c615)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualComposite]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualComposite]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualComposite]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a7c3e37fa804c99ea3d70a5da2e64bffcfc7c14fc218b3ff3fb66d346d5fb882)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualCompound",
    jsii_struct_bases=[],
    name_mapping={"transformations": "transformations"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualCompound:
    def __init__(
        self,
        *,
        transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param transformations: transformations block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0bcab30afaec0408b2795097d5825d74d74b5de55804225bf97fac677dfe369d)
            check_type(argname="argument transformations", value=transformations, expected_type=type_hints["transformations"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if transformations is not None:
            self._values["transformations"] = transformations

    @builtins.property
    def transformations(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualCompoundTransformations"]]]:
        '''transformations block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        result = self._values.get("transformations")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualCompoundTransformations"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualCompound(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualCompoundList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualCompoundList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__49b8174be20cb93762f83fbe5bbf373eb76e5d542c7afbc3add650d8c441622b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualCompoundOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__036d6429ea95763e23d57e22460ecef15e79b103686fcdb3216a2e5835ae27b6)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualCompoundOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c04a6a91b345414a5c1405127dcf83525f9b8b908f2c88bbcc7eb78a1ba84e2f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7fea41ab63038f0f06cd1eefea341380c4cf8a21e88e6b0267eaac93063c7a29)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__95a225af31e41743f2a13f95a4b0b90d9d76cbffde7e20e3f26ac392e47596e8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualCompound]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualCompound]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0fc5cb5b5dfa50b13769a0cc8eec24e5ec31b50301c2603d429d582603f95528)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualCompoundOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualCompoundOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__28f6c8907475a580bd224ff56731ef93ca8fd93621cf5e908a736ce957c46e2c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformations")
    def put_transformations(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b33807d6c94ac0e1c2ae34b1930d2364ed834d632ef9bfa76e3c5b0b718ad309)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTransformations", [value]))

    @jsii.member(jsii_name="resetTransformations")
    def reset_transformations(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformations", []))

    @builtins.property
    @jsii.member(jsii_name="transformations")
    def transformations(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualCompoundTransformationsList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualCompoundTransformationsList", jsii.get(self, "transformations"))

    @builtins.property
    @jsii.member(jsii_name="transformationsInput")
    def transformations_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualCompoundTransformations"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualCompoundTransformations"]]], jsii.get(self, "transformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualCompound]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualCompound]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualCompound]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d78ac6c2ab01aafcbec0c94af52e9772781e7b3cc746648a014c5f8fe745fd3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualCompoundTransformations",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualCompoundTransformations:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualCompoundTransformations(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualCompoundTransformationsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualCompoundTransformationsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__58288d22fbc670189bd3fb0d7ad5150cb65deb0026431969e7fbe780373aeac6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualCompoundTransformationsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8e3b8a69b7210874d37541514433557180d2adb473aa8644f096538687168fc9)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualCompoundTransformationsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__799004f1d8d405e7b4e45e74a641676c3ae7d40f440551de0aaae4840ff8d6e5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__35e7fd2fcd63bb1c4ec88557b861b66e0b897c6c4dc55cfb644cd6069a63a969)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__49cfe69485a238c8dc8c28e93e73496ec07a2f8641f2bd10930f93dcc20d73f0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualCompoundTransformations]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualCompoundTransformations]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualCompoundTransformations]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dbd84175ca9e6a42f66a2c3be739a8f3bb57d04e72f291586a79806ff326275f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualCompoundTransformationsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualCompoundTransformationsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0cd6c4d519bcb44d80f6271ff0de8c404ab514448bcbb16785ac93dac033ca98)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualCompoundTransformations]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualCompoundTransformations]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualCompoundTransformations]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__32194b37810957a89aa9d7e5a1db61011694a24050850b3b68244b6098cda88c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualContrast",
    jsii_struct_bases=[],
    name_mapping={
        "brightness": "brightness",
        "brightness_var": "brightnessVar",
        "contrast": "contrast",
        "contrast_var": "contrastVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualContrast:
    def __init__(
        self,
        *,
        brightness: typing.Optional[builtins.str] = None,
        brightness_var: typing.Optional[builtins.str] = None,
        contrast: typing.Optional[builtins.str] = None,
        contrast_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param brightness: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        :param brightness_var: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        :param contrast: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param contrast_var: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9648b9039fcf994da1ae7f05c0e06069c78b139dc0f0e2e6dca98124e1f57770)
            check_type(argname="argument brightness", value=brightness, expected_type=type_hints["brightness"])
            check_type(argname="argument brightness_var", value=brightness_var, expected_type=type_hints["brightness_var"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument contrast_var", value=contrast_var, expected_type=type_hints["contrast_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if brightness is not None:
            self._values["brightness"] = brightness
        if brightness_var is not None:
            self._values["brightness_var"] = brightness_var
        if contrast is not None:
            self._values["contrast"] = contrast
        if contrast_var is not None:
            self._values["contrast_var"] = contrast_var

    @builtins.property
    def brightness(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        '''
        result = self._values.get("brightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def brightness_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        '''
        result = self._values.get("brightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        result = self._values.get("contrast_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualContrast(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualContrastList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualContrastList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0661b432cb71263badca0b16a5fe4f09868a0ebf521ab4efcce0b3c33bbc10b5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualContrastOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__27254e9a7c6f17959795832dc43a3f4fe856072720534d73db54ff2abc34f905)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualContrastOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7c971b43e7583ce32a641b3c59eed6ca8acdacaab6f3b5b9c46cabbcfb0edcbb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__822e5f09c55ce1b682dcc999a7dd56c5e979a80391a6d24e6415203c2e2060d7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7c7f8c05f922f772e11952afb388790923be60340c505076eb4b2ec5b0d14087)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualContrast]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualContrast]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__76c5a6e30ae7fd06586ec582bdbe239ba065b7ad4b996bda604971d4f273ef54)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualContrastOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualContrastOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7b0a37d1c26d3f865b6fa5dd0d913afd3b689d01bcd5f309f57047e24287cfec)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetBrightness")
    def reset_brightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightness", []))

    @jsii.member(jsii_name="resetBrightnessVar")
    def reset_brightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightnessVar", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetContrastVar")
    def reset_contrast_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrastVar", []))

    @builtins.property
    @jsii.member(jsii_name="brightnessInput")
    def brightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="brightnessVarInput")
    def brightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastVarInput")
    def contrast_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="brightness")
    def brightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightness"))

    @brightness.setter
    def brightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9bfb2771461151de7245c762695e6f1e950de4b660cfa0e9c3c154be1e96b8bb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightness", value)

    @builtins.property
    @jsii.member(jsii_name="brightnessVar")
    def brightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightnessVar"))

    @brightness_var.setter
    def brightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f3884a3ff5ca6edb34ec71cb98d79692fb5518770113057b92b464ea4a190d0a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrast"))

    @contrast.setter
    def contrast(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7026e528a445831b3f8ddc3438632d06840de44c64a8753f7dd02b33178e138b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrast", value)

    @builtins.property
    @jsii.member(jsii_name="contrastVar")
    def contrast_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrastVar"))

    @contrast_var.setter
    def contrast_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b2f616e1ea016bcace0828f656a67a017112cf5a8b000d4556327a4b1d39d77a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrastVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualContrast]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualContrast]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualContrast]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b4676f9865f2f55e631d2b4b29c70f8a8cee67d9509152f2ec28bff5e9787af7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualCrop",
    jsii_struct_bases=[],
    name_mapping={
        "allow_expansion": "allowExpansion",
        "allow_expansion_var": "allowExpansionVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualCrop:
    def __init__(
        self,
        *,
        allow_expansion: typing.Optional[builtins.str] = None,
        allow_expansion_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_expansion: If cropping an area outside of the existing canvas, expands the image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        :param allow_expansion_var: If cropping an area outside of the existing canvas, expands the image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        :param gravity: Frame of reference for X and Y Positions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Frame of reference for X and Y Positions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The number of pixels to crop along the y-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The number of pixels to crop along the y-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The number of pixels to crop along the x-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The number of pixels to crop along the x-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        :param x_position: The x-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a7481a15d09571058e180ad475a87692fe88da3828f5ed9d4dccdb6e668111ca)
            check_type(argname="argument allow_expansion", value=allow_expansion, expected_type=type_hints["allow_expansion"])
            check_type(argname="argument allow_expansion_var", value=allow_expansion_var, expected_type=type_hints["allow_expansion_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if allow_expansion is not None:
            self._values["allow_expansion"] = allow_expansion
        if allow_expansion_var is not None:
            self._values["allow_expansion_var"] = allow_expansion_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def allow_expansion(self) -> typing.Optional[builtins.str]:
        '''If cropping an area outside of the existing canvas, expands the image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        '''
        result = self._values.get("allow_expansion")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def allow_expansion_var(self) -> typing.Optional[builtins.str]:
        '''If cropping an area outside of the existing canvas, expands the image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        '''
        result = self._values.get("allow_expansion_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Frame of reference for X and Y Positions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Frame of reference for X and Y Positions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the y-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the y-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the x-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the x-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__30fda12cd09d5d8a20f5d89b04da4a3a9a05e79ffa444cd953373d3d0dcb8137)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0467cb2cd5b126d7efa1523821e2d9e2994b2132b4e2d61b41d64bda5e697963)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e3d9ac52b1498d321aa2db03f955e450c4829a36c8207aa144916e81a2677634)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc4abfbde0865ff6c8947770a844388ab3e210815de8ca6d77ed3f829ce11384)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ae4fe4265092fea6001584d027d67011dbe112b80ade93388c7e2d69bf66b936)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ffe2dcc6b70dd088587af2bb224d859c79fb50e2fbeefbea3af875c9f890c6d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__931554e42b8df0dfd37e7083f3439cda248339bb3a73e52167935dd3b0a8d9bc)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAllowExpansion")
    def reset_allow_expansion(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansion", []))

    @jsii.member(jsii_name="resetAllowExpansionVar")
    def reset_allow_expansion_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansionVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionInput")
    def allow_expansion_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVarInput")
    def allow_expansion_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansion")
    def allow_expansion(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansion"))

    @allow_expansion.setter
    def allow_expansion(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1472f6e8364a44fa2be78c7c65ee93b7e1098273c6ebe545ac73718928c3c698)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansion", value)

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVar")
    def allow_expansion_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansionVar"))

    @allow_expansion_var.setter
    def allow_expansion_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7463a36760cb2b75a66c27933ff230b4c3785157a7ce1f73e4360884f6e28cb2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansionVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4706d503c671248f9c5258be3cafc91ec6e9fd38dc3ec9f733a8a0b8f48e2aa9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__baab86847f536c7f31861de92ecbb306a60fcbff049d9538cb3ebb18b10a02c5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fcb92d36532ba7f701f8ce0eb4d68a73acf965673091f30fadacfe06c5edd955)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a02478b15c90f030f77d8299e7f41aa6fdd3c361e8f27c9ef57f506a351aa7fa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6fc17e6937b806b3ecae6f95fee6f18ffa7f2d324641316ff04c1779a0cf9acd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__89794df9fcd6adb5c1025128b0fb36b47ba4ce8386a69e5993127307add35546)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2cfef1b0152ad8aa868633e97c6e569a2e7c3149ce113b33a0cf81956b810bf7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc90ff92ca9d71ccd262eb6ea4982aa1ed0be0b47820f02c54a2e9c574017cee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__532c396386b900db4512df229a34e169fd6c7afab803089b8b102a3388ea6bfe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__771fddf92c132594143838a2ad072d1cf98ee6bd70cff13f37779e51ca94595e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a954b7d3ad91b80d8b0c295f452901a1402a214687e8a8e6cf518cd67e968692)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualFaceCrop",
    jsii_struct_bases=[],
    name_mapping={
        "algorithm": "algorithm",
        "algorithm_var": "algorithmVar",
        "confidence": "confidence",
        "confidence_var": "confidenceVar",
        "fail_gravity": "failGravity",
        "fail_gravity_var": "failGravityVar",
        "focus": "focus",
        "focus_var": "focusVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "padding": "padding",
        "padding_var": "paddingVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualFaceCrop:
    def __init__(
        self,
        *,
        algorithm: typing.Optional[builtins.str] = None,
        algorithm_var: typing.Optional[builtins.str] = None,
        confidence: typing.Optional[builtins.str] = None,
        confidence_var: typing.Optional[builtins.str] = None,
        fail_gravity: typing.Optional[builtins.str] = None,
        fail_gravity_var: typing.Optional[builtins.str] = None,
        focus: typing.Optional[builtins.str] = None,
        focus_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param algorithm: Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm DataAkamaiImagingPolicyImage#algorithm}
        :param algorithm_var: Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm_var DataAkamaiImagingPolicyImage#algorithm_var}
        :param confidence: With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image. Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence DataAkamaiImagingPolicyImage#confidence}
        :param confidence_var: With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image. Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence_var DataAkamaiImagingPolicyImage#confidence_var}
        :param fail_gravity: Controls placement of the crop if Image and Video Manager does not detect any faces in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        :param fail_gravity_var: Controls placement of the crop if Image and Video Manager does not detect any faces in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        :param focus: Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus DataAkamaiImagingPolicyImage#focus}
        :param focus_var: Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus_var DataAkamaiImagingPolicyImage#focus_var}
        :param gravity: Controls placement of the crop. Directions are relative to the face(s) plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Controls placement of the crop. Directions are relative to the face(s) plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param padding: The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        :param style: Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__946b8d89ecc5627aedcb12863de6c225a5b376180d68cc06b04cf77153e99c22)
            check_type(argname="argument algorithm", value=algorithm, expected_type=type_hints["algorithm"])
            check_type(argname="argument algorithm_var", value=algorithm_var, expected_type=type_hints["algorithm_var"])
            check_type(argname="argument confidence", value=confidence, expected_type=type_hints["confidence"])
            check_type(argname="argument confidence_var", value=confidence_var, expected_type=type_hints["confidence_var"])
            check_type(argname="argument fail_gravity", value=fail_gravity, expected_type=type_hints["fail_gravity"])
            check_type(argname="argument fail_gravity_var", value=fail_gravity_var, expected_type=type_hints["fail_gravity_var"])
            check_type(argname="argument focus", value=focus, expected_type=type_hints["focus"])
            check_type(argname="argument focus_var", value=focus_var, expected_type=type_hints["focus_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if algorithm is not None:
            self._values["algorithm"] = algorithm
        if algorithm_var is not None:
            self._values["algorithm_var"] = algorithm_var
        if confidence is not None:
            self._values["confidence"] = confidence
        if confidence_var is not None:
            self._values["confidence_var"] = confidence_var
        if fail_gravity is not None:
            self._values["fail_gravity"] = fail_gravity
        if fail_gravity_var is not None:
            self._values["fail_gravity_var"] = fail_gravity_var
        if focus is not None:
            self._values["focus"] = focus
        if focus_var is not None:
            self._values["focus_var"] = focus_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def algorithm(self) -> typing.Optional[builtins.str]:
        '''Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm DataAkamaiImagingPolicyImage#algorithm}
        '''
        result = self._values.get("algorithm")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def algorithm_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm_var DataAkamaiImagingPolicyImage#algorithm_var}
        '''
        result = self._values.get("algorithm_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def confidence(self) -> typing.Optional[builtins.str]:
        '''With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image.

        Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence DataAkamaiImagingPolicyImage#confidence}
        '''
        result = self._values.get("confidence")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def confidence_var(self) -> typing.Optional[builtins.str]:
        '''With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image.

        Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence_var DataAkamaiImagingPolicyImage#confidence_var}
        '''
        result = self._values.get("confidence_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any faces in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        '''
        result = self._values.get("fail_gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any faces in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        '''
        result = self._values.get("fail_gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def focus(self) -> typing.Optional[builtins.str]:
        '''Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus DataAkamaiImagingPolicyImage#focus}
        '''
        result = self._values.get("focus")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def focus_var(self) -> typing.Optional[builtins.str]:
        '''Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus_var DataAkamaiImagingPolicyImage#focus_var}
        '''
        result = self._values.get("focus_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the face(s) plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the face(s) plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualFaceCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualFaceCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualFaceCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__381e7f94bd398a6362e3f8c6a75f46c0afdd1dbf9c7c9420d2f70ee1aace6c50)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualFaceCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ffee8d3dfb2b4df7a34d59ace63a873c50de0bf0d4fc2d2a3914e4571e9dc4b5)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualFaceCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__522be3da2f0e56af09bbfd5ffeb9369067cda506cd61c2c7e16bd248471025cd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__92b292251f28d6d36fb7c0954cf77d16fe60d573bc9828a8f96a8e06227645ea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0a28ac1c9a6c0f8817fcb0ce21c4a5aed30b599cc3dac681f176f80c5b470a14)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualFaceCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualFaceCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualFaceCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea0e841beebf488c614e5ba1630b1eee301f1526c35c5d19809f2d62b6bef7d0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualFaceCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualFaceCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e490e5ab2cbe3392971e9f1de31b5f6bba83a5262b626f8471aba0f32f9aea35)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAlgorithm")
    def reset_algorithm(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAlgorithm", []))

    @jsii.member(jsii_name="resetAlgorithmVar")
    def reset_algorithm_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAlgorithmVar", []))

    @jsii.member(jsii_name="resetConfidence")
    def reset_confidence(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetConfidence", []))

    @jsii.member(jsii_name="resetConfidenceVar")
    def reset_confidence_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetConfidenceVar", []))

    @jsii.member(jsii_name="resetFailGravity")
    def reset_fail_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravity", []))

    @jsii.member(jsii_name="resetFailGravityVar")
    def reset_fail_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravityVar", []))

    @jsii.member(jsii_name="resetFocus")
    def reset_focus(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFocus", []))

    @jsii.member(jsii_name="resetFocusVar")
    def reset_focus_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFocusVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="algorithmInput")
    def algorithm_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "algorithmInput"))

    @builtins.property
    @jsii.member(jsii_name="algorithmVarInput")
    def algorithm_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "algorithmVarInput"))

    @builtins.property
    @jsii.member(jsii_name="confidenceInput")
    def confidence_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "confidenceInput"))

    @builtins.property
    @jsii.member(jsii_name="confidenceVarInput")
    def confidence_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "confidenceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityInput")
    def fail_gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityVarInput")
    def fail_gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="focusInput")
    def focus_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "focusInput"))

    @builtins.property
    @jsii.member(jsii_name="focusVarInput")
    def focus_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "focusVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="algorithm")
    def algorithm(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "algorithm"))

    @algorithm.setter
    def algorithm(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e9bee470f6e053d8dc54a653bf94ec67b75f552e9278fc0ee76a51dd58c2c723)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "algorithm", value)

    @builtins.property
    @jsii.member(jsii_name="algorithmVar")
    def algorithm_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "algorithmVar"))

    @algorithm_var.setter
    def algorithm_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4c6980fa75666309a2d914486ab3a0a23c60aef5f5017296eedc319e37d40bbc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "algorithmVar", value)

    @builtins.property
    @jsii.member(jsii_name="confidence")
    def confidence(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "confidence"))

    @confidence.setter
    def confidence(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a1b705409df4e508318f94247c684f010866186356f2ff6c67436c303dbadd45)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "confidence", value)

    @builtins.property
    @jsii.member(jsii_name="confidenceVar")
    def confidence_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "confidenceVar"))

    @confidence_var.setter
    def confidence_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__68f22bd03d76d73aecf3b8864d58796fd1eb664cc764d471b5102a19800692c2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "confidenceVar", value)

    @builtins.property
    @jsii.member(jsii_name="failGravity")
    def fail_gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravity"))

    @fail_gravity.setter
    def fail_gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8f5656893e8c74094c1a4248c930f52f460feed3b54f0111eb7020a60a6ec376)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravity", value)

    @builtins.property
    @jsii.member(jsii_name="failGravityVar")
    def fail_gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravityVar"))

    @fail_gravity_var.setter
    def fail_gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be6733896b1d9b8eb02167e10a54f6d1b0b10ac32705faddabc37649fa1d4fd3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="focus")
    def focus(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "focus"))

    @focus.setter
    def focus(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b86bb468fc5f7fbfedebe507e61b615fedf91ed4a5eb594a18870ba7578d56c5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "focus", value)

    @builtins.property
    @jsii.member(jsii_name="focusVar")
    def focus_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "focusVar"))

    @focus_var.setter
    def focus_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__17effee62cf0625149533dc55f94962764034dd08d3a8d369007770ad4cf6731)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "focusVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__056e9b02bddb7c78d7d8aee2619c5b61610117b1e703bf502843800dc57c62af)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c141f9121e9d5afe624838270f0af5ddb5f7688d19c8771fb9f47287a7def5b5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e98224ae3f94ad6c0e6150833698aa2c2b483132b62a435c81e91448d3526516)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ee004ce2a2b0a53dc3a310a2215ec9b9b90f71b00135ffb673c38be0c029b1c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4f5fabdaeb1b25ea5b53942ed7ef8b4eb791754e7390c8ac11cf9e758b3b1824)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e0ce6209c6ef4ab5e590940d707e8b47582bfb03d4bf871f8da2363e6af92a65)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d54908b3bd071e2de9b175a9a5a877495f6684744f5490199f77d66186fe1ab7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__36eb837aa2f8f2383a05b6b3a25bb80cbed82bedd605472e0d9245550e0ef046)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__90b2f6d534367b2b6628974da02418dadc4884b5f596a0bf17e9ae2f5e3ea19a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4e30846be5c3267c82d585ea4b244d5faa6aa0bb2679a825a333697dc8b79437)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualFaceCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualFaceCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualFaceCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd817c034a2b4c7b0a691111cb0aeb07a375b5efe237a69ef3ac1ff7f7055bc0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualFeatureCrop",
    jsii_struct_bases=[],
    name_mapping={
        "fail_gravity": "failGravity",
        "fail_gravity_var": "failGravityVar",
        "feature_radius": "featureRadius",
        "feature_radius_var": "featureRadiusVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "max_features": "maxFeatures",
        "max_features_var": "maxFeaturesVar",
        "min_feature_quality": "minFeatureQuality",
        "min_feature_quality_var": "minFeatureQualityVar",
        "padding": "padding",
        "padding_var": "paddingVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualFeatureCrop:
    def __init__(
        self,
        *,
        fail_gravity: typing.Optional[builtins.str] = None,
        fail_gravity_var: typing.Optional[builtins.str] = None,
        feature_radius: typing.Optional[builtins.str] = None,
        feature_radius_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        max_features: typing.Optional[builtins.str] = None,
        max_features_var: typing.Optional[builtins.str] = None,
        min_feature_quality: typing.Optional[builtins.str] = None,
        min_feature_quality_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fail_gravity: Controls placement of the crop if Image and Video Manager does not detect any features in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        :param fail_gravity_var: Controls placement of the crop if Image and Video Manager does not detect any features in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        :param feature_radius: The size in pixels of the important features to search for. If identified, two features never appear closer together than this value, ``8.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius DataAkamaiImagingPolicyImage#feature_radius}
        :param feature_radius_var: The size in pixels of the important features to search for. If identified, two features never appear closer together than this value, ``8.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius_var DataAkamaiImagingPolicyImage#feature_radius_var}
        :param gravity: Controls placement of the crop. Directions are relative to the region of interest plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Controls placement of the crop. Directions are relative to the region of interest plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param max_features: The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features DataAkamaiImagingPolicyImage#max_features}
        :param max_features_var: The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features_var DataAkamaiImagingPolicyImage#max_features_var}
        :param min_feature_quality: Determines the minimum quality level of the feature identified. To consider a feature important, the feature needs to surpass this value. Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality DataAkamaiImagingPolicyImage#min_feature_quality}
        :param min_feature_quality_var: Determines the minimum quality level of the feature identified. To consider a feature important, the feature needs to surpass this value. Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality_var DataAkamaiImagingPolicyImage#min_feature_quality_var}
        :param padding: Adds space around the region of interest. The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: Adds space around the region of interest. The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        :param style: Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__12dca8aef8d0a93f7687323e23696bc16b214a5bdd8c83e8be09805fb14a77a6)
            check_type(argname="argument fail_gravity", value=fail_gravity, expected_type=type_hints["fail_gravity"])
            check_type(argname="argument fail_gravity_var", value=fail_gravity_var, expected_type=type_hints["fail_gravity_var"])
            check_type(argname="argument feature_radius", value=feature_radius, expected_type=type_hints["feature_radius"])
            check_type(argname="argument feature_radius_var", value=feature_radius_var, expected_type=type_hints["feature_radius_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument max_features", value=max_features, expected_type=type_hints["max_features"])
            check_type(argname="argument max_features_var", value=max_features_var, expected_type=type_hints["max_features_var"])
            check_type(argname="argument min_feature_quality", value=min_feature_quality, expected_type=type_hints["min_feature_quality"])
            check_type(argname="argument min_feature_quality_var", value=min_feature_quality_var, expected_type=type_hints["min_feature_quality_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fail_gravity is not None:
            self._values["fail_gravity"] = fail_gravity
        if fail_gravity_var is not None:
            self._values["fail_gravity_var"] = fail_gravity_var
        if feature_radius is not None:
            self._values["feature_radius"] = feature_radius
        if feature_radius_var is not None:
            self._values["feature_radius_var"] = feature_radius_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if max_features is not None:
            self._values["max_features"] = max_features
        if max_features_var is not None:
            self._values["max_features_var"] = max_features_var
        if min_feature_quality is not None:
            self._values["min_feature_quality"] = min_feature_quality
        if min_feature_quality_var is not None:
            self._values["min_feature_quality_var"] = min_feature_quality_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def fail_gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any features in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        '''
        result = self._values.get("fail_gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any features in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        '''
        result = self._values.get("fail_gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feature_radius(self) -> typing.Optional[builtins.str]:
        '''The size in pixels of the important features to search for.

        If identified, two features never appear closer together than this value, ``8.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius DataAkamaiImagingPolicyImage#feature_radius}
        '''
        result = self._values.get("feature_radius")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feature_radius_var(self) -> typing.Optional[builtins.str]:
        '''The size in pixels of the important features to search for.

        If identified, two features never appear closer together than this value, ``8.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius_var DataAkamaiImagingPolicyImage#feature_radius_var}
        '''
        result = self._values.get("feature_radius_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the region of interest plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the region of interest plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def max_features(self) -> typing.Optional[builtins.str]:
        '''The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features DataAkamaiImagingPolicyImage#max_features}
        '''
        result = self._values.get("max_features")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def max_features_var(self) -> typing.Optional[builtins.str]:
        '''The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features_var DataAkamaiImagingPolicyImage#max_features_var}
        '''
        result = self._values.get("max_features_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def min_feature_quality(self) -> typing.Optional[builtins.str]:
        '''Determines the minimum quality level of the feature identified.

        To consider a feature important, the feature needs to surpass this value.  Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality DataAkamaiImagingPolicyImage#min_feature_quality}
        '''
        result = self._values.get("min_feature_quality")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def min_feature_quality_var(self) -> typing.Optional[builtins.str]:
        '''Determines the minimum quality level of the feature identified.

        To consider a feature important, the feature needs to surpass this value.  Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality_var DataAkamaiImagingPolicyImage#min_feature_quality_var}
        '''
        result = self._values.get("min_feature_quality_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''Adds space around the region of interest.

        The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''Adds space around the region of interest.

        The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualFeatureCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualFeatureCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualFeatureCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__890f6e4ead0dbcbf5a051a42fc563b7816e521a42ae1015195dabfae494d3f54)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualFeatureCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__97257a124d87f194b3ddd11efaa4c456e7bff8472be83dd872f024e4e22ac176)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualFeatureCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f45d5466c414517bc8b1ad56466e4318ffca6ea9cd963dc953df4387221c8444)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dbff536b603de2aea765b95d6611e3830d0c2ec73ad1cc629d8d38feca377cce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__13197949e2546e4dba50a4bc5c69dd6d8350965a4615af1877586a8ceaafd2d6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualFeatureCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualFeatureCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualFeatureCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c146fddb6b388e811c307f4cdaa7aa49f826c15c41189cf13a0cf51ab3c3f408)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualFeatureCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualFeatureCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__169e049eacec4a28b726c5f5802eec9d028979b6bc74a888f815f2b7fd71a559)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetFailGravity")
    def reset_fail_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravity", []))

    @jsii.member(jsii_name="resetFailGravityVar")
    def reset_fail_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravityVar", []))

    @jsii.member(jsii_name="resetFeatureRadius")
    def reset_feature_radius(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureRadius", []))

    @jsii.member(jsii_name="resetFeatureRadiusVar")
    def reset_feature_radius_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureRadiusVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetMaxFeatures")
    def reset_max_features(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxFeatures", []))

    @jsii.member(jsii_name="resetMaxFeaturesVar")
    def reset_max_features_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxFeaturesVar", []))

    @jsii.member(jsii_name="resetMinFeatureQuality")
    def reset_min_feature_quality(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMinFeatureQuality", []))

    @jsii.member(jsii_name="resetMinFeatureQualityVar")
    def reset_min_feature_quality_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMinFeatureQualityVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="failGravityInput")
    def fail_gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityVarInput")
    def fail_gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featureRadiusInput")
    def feature_radius_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featureRadiusInput"))

    @builtins.property
    @jsii.member(jsii_name="featureRadiusVarInput")
    def feature_radius_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featureRadiusVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesInput")
    def max_features_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "maxFeaturesInput"))

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesVarInput")
    def max_features_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "maxFeaturesVarInput"))

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityInput")
    def min_feature_quality_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "minFeatureQualityInput"))

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityVarInput")
    def min_feature_quality_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "minFeatureQualityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravity")
    def fail_gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravity"))

    @fail_gravity.setter
    def fail_gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b4686e06da31261a3884aaf8e21483b5826cf70c229f7f4d527552f8610d56a3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravity", value)

    @builtins.property
    @jsii.member(jsii_name="failGravityVar")
    def fail_gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravityVar"))

    @fail_gravity_var.setter
    def fail_gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8298c5c6bad6f19a4dd404c5727b0c306ca59e3fea4407fd4942564881e8cfc3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="featureRadius")
    def feature_radius(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featureRadius"))

    @feature_radius.setter
    def feature_radius(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0a7db42a0d79569f64cebc8a982de74bd82e98e139d1ca34096b6ea94cd696bc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featureRadius", value)

    @builtins.property
    @jsii.member(jsii_name="featureRadiusVar")
    def feature_radius_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featureRadiusVar"))

    @feature_radius_var.setter
    def feature_radius_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5e6f5eb9cff5050e9638bdefeef4b0f7198049de15e10afc65e697eeef272692)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featureRadiusVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e7893aa3d9b6d0443262d3b2821e0c460c6ef070e01df1ef76e21c0005255b86)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1375bda7c294ebc3456c88d69bf6c790834cf463345404eb3f2cc3f7199625a0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ca21806d30e8adb1b82604f8580b4231d10409e18867b2dbb85c797cdb642faf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cbf3446ae9806fc56f73c340656172ed631c416fad517df8d7124ad4651a4793)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="maxFeatures")
    def max_features(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "maxFeatures"))

    @max_features.setter
    def max_features(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bfef93649f13e8848700dc0ce0972f3ddd8bc8a1842bb0d5bac63401c3d7f5e0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "maxFeatures", value)

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesVar")
    def max_features_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "maxFeaturesVar"))

    @max_features_var.setter
    def max_features_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d0f4664d1a6ab2e55c2b3bf0b37f81ea5aca2290b237e71797ba7668a6bdd08d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "maxFeaturesVar", value)

    @builtins.property
    @jsii.member(jsii_name="minFeatureQuality")
    def min_feature_quality(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "minFeatureQuality"))

    @min_feature_quality.setter
    def min_feature_quality(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cc9cf17d7f425503fc4c5af35b73ae070c4126f5e04d7fec2844747f1705b054)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "minFeatureQuality", value)

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityVar")
    def min_feature_quality_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "minFeatureQualityVar"))

    @min_feature_quality_var.setter
    def min_feature_quality_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6df7cbc1672ea4b0bb6e45733524603001ebb7a527e7cd6ac0101e4993ea7ad1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "minFeatureQualityVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__825b6264748ea7efca2960976459b4933605306fc41edf0d5f281506f2f6ad35)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c2a7556086f2e152bbaae4dfa0257ae41907faba186ed81b7fa86e371fd1f359)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__735e023236b0406e3a31abc34959f10499b283bf9113f68605ee102f9de5d418)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__39e0ef1c4f166170966d4aa2fa56fea6b74379d6f9f6b69497a7726851fb4df4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5fe34fdc791c71c1eed95b0b57d8cd3576bc56e937a6c3f0c0ce6f475ad53ae5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2990e84848d53a105638b41c58f0282e5ceefda40d4402cf2b5ec5a7aebec787)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualFeatureCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualFeatureCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualFeatureCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab964e398cd7ac5d6dbb00a00ab4fddee2bdade0206103d6bf974bd6b51104d8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualFitAndFill",
    jsii_struct_bases=[],
    name_mapping={
        "fill_transformation": "fillTransformation",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualFitAndFill:
    def __init__(
        self,
        *,
        fill_transformation: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualFitAndFillFillTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fill_transformation: fill_transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_transformation DataAkamaiImagingPolicyImage#fill_transformation}
        :param height: The height value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The width value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(fill_transformation, dict):
            fill_transformation = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualFitAndFillFillTransformation(**fill_transformation)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cce766e65e1a4dcf8946bfd0c53134ea112c3c3a5ed372028e107b50f60ca29b)
            check_type(argname="argument fill_transformation", value=fill_transformation, expected_type=type_hints["fill_transformation"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fill_transformation is not None:
            self._values["fill_transformation"] = fill_transformation
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def fill_transformation(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualFitAndFillFillTransformation"]:
        '''fill_transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_transformation DataAkamaiImagingPolicyImage#fill_transformation}
        '''
        result = self._values.get("fill_transformation")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualFitAndFillFillTransformation"], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualFitAndFill(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualFitAndFillFillTransformation",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualFitAndFillFillTransformation:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualFitAndFillFillTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualFitAndFillFillTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualFitAndFillFillTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0300df5ae22a994bccb1c9a1d5965844b0b48749da7cfc58ccd7cb8723b24319)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualFitAndFillFillTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualFitAndFillFillTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualFitAndFillFillTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__133ec91843d5cbca7db8ca409b2c112fa0352ecce582002521c92c290d26b460)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualFitAndFillList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualFitAndFillList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__92f1b0cd92d9467f8d57f37fff69ac9aba04a149b41ec202502dbe4d2638524e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualFitAndFillOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3692d18361125e955077417d50f6092c3654bc9929106904387a36e1c2b56291)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualFitAndFillOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__624521e8a406f9bf262485e36b2516d046f98d938e1e53b26b9ba2356f10cc1d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3fcd816ba5c51ee6dd8f0b7b940952da523d4c2acee0293b971d42b6ec400971)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eafd3a604061b6b5eb0e6e773ad87d7b0809eec526b1618afaca6d7186b83628)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualFitAndFill]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualFitAndFill]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualFitAndFill]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__18191b3c3bfae5a1f814e6112bf0d02245633f4a1b972c1947387e905d6ace25)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualFitAndFillOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualFitAndFillOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cda73e05ed7fe2d65b90630fcbeb3a8cb6ee6bad6f07d11a9aab230852fa7249)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putFillTransformation")
    def put_fill_transformation(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualFitAndFillFillTransformation()

        return typing.cast(None, jsii.invoke(self, "putFillTransformation", [value]))

    @jsii.member(jsii_name="resetFillTransformation")
    def reset_fill_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFillTransformation", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="fillTransformation")
    def fill_transformation(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualFitAndFillFillTransformationOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualFitAndFillFillTransformationOutputReference, jsii.get(self, "fillTransformation"))

    @builtins.property
    @jsii.member(jsii_name="fillTransformationInput")
    def fill_transformation_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualFitAndFillFillTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualFitAndFillFillTransformation], jsii.get(self, "fillTransformationInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d6afab1086aca3fb99ac6253b65e114e38b9f6d223c74eb8e17ee6a82fcee568)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c6e01ad3000f1c360994c7ae2f252cfcc24ac6ab3ad3d9e77db29eb7bcc49c55)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab23ab9f7c0ade115ee377ac1ce0271cd6d7ae1a0fdcb38e68b96462b96d051c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__63de707ae3540cd2d6bbc69865107d29e2e9d31aaf4925ddcad0aae68a5f19db)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualFitAndFill]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualFitAndFill]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualFitAndFill]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__729de2f6bf346c773648b087fb7922321703729edf6c02174337c51be660a2e2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualGoop",
    jsii_struct_bases=[],
    name_mapping={
        "chaos": "chaos",
        "chaos_var": "chaosVar",
        "density": "density",
        "density_var": "densityVar",
        "power": "power",
        "power_var": "powerVar",
        "seed": "seed",
        "seed_var": "seedVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualGoop:
    def __init__(
        self,
        *,
        chaos: typing.Optional[builtins.str] = None,
        chaos_var: typing.Optional[builtins.str] = None,
        density: typing.Optional[builtins.str] = None,
        density_var: typing.Optional[builtins.str] = None,
        power: typing.Optional[builtins.str] = None,
        power_var: typing.Optional[builtins.str] = None,
        seed: typing.Optional[builtins.str] = None,
        seed_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param chaos: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        :param chaos_var: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        :param density: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        :param density_var: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        :param power: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        :param power_var: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        :param seed: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        :param seed_var: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9c1de2307452672ad3f6f7f8a51c577f77a67bf3c283ec73ef09fcffb3e10d9a)
            check_type(argname="argument chaos", value=chaos, expected_type=type_hints["chaos"])
            check_type(argname="argument chaos_var", value=chaos_var, expected_type=type_hints["chaos_var"])
            check_type(argname="argument density", value=density, expected_type=type_hints["density"])
            check_type(argname="argument density_var", value=density_var, expected_type=type_hints["density_var"])
            check_type(argname="argument power", value=power, expected_type=type_hints["power"])
            check_type(argname="argument power_var", value=power_var, expected_type=type_hints["power_var"])
            check_type(argname="argument seed", value=seed, expected_type=type_hints["seed"])
            check_type(argname="argument seed_var", value=seed_var, expected_type=type_hints["seed_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if chaos is not None:
            self._values["chaos"] = chaos
        if chaos_var is not None:
            self._values["chaos_var"] = chaos_var
        if density is not None:
            self._values["density"] = density
        if density_var is not None:
            self._values["density_var"] = density_var
        if power is not None:
            self._values["power"] = power
        if power_var is not None:
            self._values["power_var"] = power_var
        if seed is not None:
            self._values["seed"] = seed
        if seed_var is not None:
            self._values["seed_var"] = seed_var

    @builtins.property
    def chaos(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        '''
        result = self._values.get("chaos")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def chaos_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        '''
        result = self._values.get("chaos_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        '''
        result = self._values.get("density")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density_var(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        '''
        result = self._values.get("density_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        '''
        result = self._values.get("power")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power_var(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        '''
        result = self._values.get("power_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        '''
        result = self._values.get("seed")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed_var(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        result = self._values.get("seed_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualGoop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualGoopList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualGoopList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7b0d7d2ad142c1066622f82c4a62dcdac2673e1d1f98b60640be6b9694cd0827)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualGoopOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__628969c490766c6d9fa0b18bbf2ac3c8f5e228cb9e22e57e7f9e7370cddf1c35)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualGoopOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a82c60aa36afeb6b58ac60ebe5e5a0a97aac33524cd7da3a20bf9cc30ab4d767)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__47db2a04eb2bc1faee767e9c912ffa3ff9dd69a2172b901e3ab0580d023eff8f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__46a7e3b9274202e5410f2e3b76f8ce31976017ee0f7cf53f6da697750e84ab8a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualGoop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualGoop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__61672be948cafc3d114ae444b05b4a87a2955d32eadcf8495dd95765a9d210fe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualGoopOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualGoopOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f21a7a2d429cdf55d4d41c363263009e45de98b293f930d5217ab1c76955aafa)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetChaos")
    def reset_chaos(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaos", []))

    @jsii.member(jsii_name="resetChaosVar")
    def reset_chaos_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaosVar", []))

    @jsii.member(jsii_name="resetDensity")
    def reset_density(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensity", []))

    @jsii.member(jsii_name="resetDensityVar")
    def reset_density_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensityVar", []))

    @jsii.member(jsii_name="resetPower")
    def reset_power(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPower", []))

    @jsii.member(jsii_name="resetPowerVar")
    def reset_power_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPowerVar", []))

    @jsii.member(jsii_name="resetSeed")
    def reset_seed(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeed", []))

    @jsii.member(jsii_name="resetSeedVar")
    def reset_seed_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeedVar", []))

    @builtins.property
    @jsii.member(jsii_name="chaosInput")
    def chaos_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosInput"))

    @builtins.property
    @jsii.member(jsii_name="chaosVarInput")
    def chaos_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosVarInput"))

    @builtins.property
    @jsii.member(jsii_name="densityInput")
    def density_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityInput"))

    @builtins.property
    @jsii.member(jsii_name="densityVarInput")
    def density_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="powerInput")
    def power_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerInput"))

    @builtins.property
    @jsii.member(jsii_name="powerVarInput")
    def power_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerVarInput"))

    @builtins.property
    @jsii.member(jsii_name="seedInput")
    def seed_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedInput"))

    @builtins.property
    @jsii.member(jsii_name="seedVarInput")
    def seed_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedVarInput"))

    @builtins.property
    @jsii.member(jsii_name="chaos")
    def chaos(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaos"))

    @chaos.setter
    def chaos(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e951779d59b3c11453e080cfc9dc153ff4b294ec1096b22f3ca3ffb58e2d0a33)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaos", value)

    @builtins.property
    @jsii.member(jsii_name="chaosVar")
    def chaos_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaosVar"))

    @chaos_var.setter
    def chaos_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bfed32f575478aee0b62e0a42fb14dc6d3b75a67382f8cd830fe200a2b7c768f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaosVar", value)

    @builtins.property
    @jsii.member(jsii_name="density")
    def density(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "density"))

    @density.setter
    def density(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__395da5d84730c2ad91e0096dacdec655b1ff448ad9708846f6eeb8aa13232f45)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "density", value)

    @builtins.property
    @jsii.member(jsii_name="densityVar")
    def density_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "densityVar"))

    @density_var.setter
    def density_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a1c4704aad540ffae5c301c9f6689c5ba0827440e0dfd1a7d1a45b1045caa329)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "densityVar", value)

    @builtins.property
    @jsii.member(jsii_name="power")
    def power(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "power"))

    @power.setter
    def power(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f4754e9f8819d4b5b87ec470252e5adc70f777e11d62c53f777a7be8ffd51380)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "power", value)

    @builtins.property
    @jsii.member(jsii_name="powerVar")
    def power_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "powerVar"))

    @power_var.setter
    def power_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fc4f0bfd33158e7272aa5f1c5dc4cbed17a7170fa89c51a35465f58dc79894e5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "powerVar", value)

    @builtins.property
    @jsii.member(jsii_name="seed")
    def seed(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seed"))

    @seed.setter
    def seed(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dd6102c4d088d3bcca4c955a8da4930c01afd77a7294b90148b8be6c4f200171)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seed", value)

    @builtins.property
    @jsii.member(jsii_name="seedVar")
    def seed_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seedVar"))

    @seed_var.setter
    def seed_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0efda4bf15703ba4856e341c5ac449672689d6d86e3d0d58a62f709350c80167)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seedVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualGoop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualGoop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualGoop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__805ff426ce103f103eb10182e0aed2c46548609d503ee05f33f42fcf52de425a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualGrayscale",
    jsii_struct_bases=[],
    name_mapping={"type": "type", "type_var": "typeVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualGrayscale:
    def __init__(
        self,
        *,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param type: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1fb68e2b021159b43d76c6a84398ddea3598993c98b0e5e28b3cd77c4994e028)
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualGrayscale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualGrayscaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualGrayscaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f58b3c69da7a2ae0d428da8fc16fdd3a6b5d88b015563f52256763e70df9b9e1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualGrayscaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d7afb431dd439aceb00b9798e8e1e7077dc23cb9d93e3c85e32948bbf91ca6e2)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualGrayscaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1ae547eaaa2525a8a3639aff819c94c8daf339602b2125f91a922f3adb98062e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8eabbbe4ff438140dfbee1a2c6363953791e6b4d6bf8074d3826ad68bdb1a9ea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__29d5fa874983e8460bd8d93513a39ba7544bf780f225189a8cf321d680d1c947)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualGrayscale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualGrayscale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__84e8891dd68a592f2b8b583195cdb0b9c16fd1d41419de7cffb4bd01cc1577ae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualGrayscaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualGrayscaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__269e55e61a6b3ecc04a549cbe7e51d95a998867f9543178c557014632fcae32f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dc475ba9920efa914298d371d03557d9c2de07d170b62eb7a51c0f6ea8995042)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__50dc614b8f849500bf33ad62e00b13dce3da50e91d78ad1243fbdbec1e8c12fc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualGrayscale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualGrayscale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualGrayscale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cf93f65e4e3cc7ec78d665d3b53c1f80817cfa69db4dee9591de5b3c600d55b3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualHsl",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "lightness": "lightness",
        "lightness_var": "lightnessVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualHsl:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness: typing.Optional[builtins.str] = None,
        lightness_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        :param lightness_var: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2c2703d954cc34e9b0aa4ef21291252f8422be4780609ce2308e1a9e7adfa7c7)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness", value=lightness, expected_type=type_hints["lightness"])
            check_type(argname="argument lightness_var", value=lightness_var, expected_type=type_hints["lightness_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness is not None:
            self._values["lightness"] = lightness
        if lightness_var is not None:
            self._values["lightness_var"] = lightness_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        '''
        result = self._values.get("lightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        '''
        result = self._values.get("lightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualHsl(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualHslList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualHslList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9f43d7840ae1c08a69581d8df4b3a693d3186ba35fd711a2a5fb78b9b8287268)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualHslOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__98f34f82ee633cecec3a30c3058dd658eef9327a2d2be363edbae866b76316c4)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualHslOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__869e7668f43d58cf7a3fa3d3f48b5d166e137003f30b0bb016e5e6ceeef13d63)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c9f369765193742c43aba42bd29fe12df39e8b3429e181532eef77e1cf80d744)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__73ca897b5835dfea32ef019e3f92e0162ad0745f8410534eec558dea653bc51e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualHsl]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualHsl]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__acf59468c2f8940dd3f69481ad777c5ad26a5dfcb61dc07ca24071a8a3663004)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualHslOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualHslOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cade1faf01af3708a24ea232c68316dc3bc7003b1e040967663b1d966fbd7106)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightness")
    def reset_lightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightness", []))

    @jsii.member(jsii_name="resetLightnessVar")
    def reset_lightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessInput")
    def lightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessVarInput")
    def lightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__86df0e6890450af1728771c36a79e851879f7c239135724834f764cb64705064)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__36ab7d3abf5aaa47c93dcdfe5ba7e9060cbe30c23c60e3300e6917a5b64ad4da)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightness")
    def lightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightness"))

    @lightness.setter
    def lightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b2eda72e33bdfc5f73ba1b18106fe4d1c517b12e8c181b88bed7948d81094860)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightness", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessVar")
    def lightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessVar"))

    @lightness_var.setter
    def lightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e207a4f29e446a939147c41370ed4cff41a45890369cd4c3e2c8cf01b48cab6d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__296188425126d3412ca5e17bde0772449ef9de02d709b0dc15fd0ed413e26c62)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9cc3da01771faa60f1ba77cbf7e3246fe1ec23e6d2d70bcda42eb7b7c89f1699)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualHsl]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualHsl]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualHsl]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a0d5f49799db22c65c3cebcbaf510ec88ff26209f7d5acad7983bbd5440deda6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualHsv",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualHsv:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        :param value: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b523ab066a494a16a34c0b0652606101ddff0f7687c3c44da2b51cae56f2c4bc)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualHsv(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualHsvList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualHsvList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c12ef2ede1f13657a42b2744303d06e6ae94049d6318db93e53436d92ac68279)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualHsvOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5721d0ec7c92ac25027ced821b6d627445264372db1294342852c39724ada208)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualHsvOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2696080891e2a5559697c20d8f1a92ab3170d573ffbb7068ef5d44d87fea6629)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__65dc6e91a69f90fe4d9bbadf6f3b2c321c3bcb3c43f5521128544bdea9ddebae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__48c4520b3a2e5457a37da0ebd677f5483c9b0fe88b2f85977b9883c97a66a566)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualHsv]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualHsv]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ad2c478ba11e4f89a2dee993c1c29e662aa365e8cb41965894c44350ce9355a4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualHsvOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualHsvOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b778299da2227bb77ebb9bf4d5c82245f34c1bc393d606ef36419a48ebfcb982)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a2fd8c523568740f62f3a0174dac824a8055bceaa060179ffeef64b346d5b597)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__451184f0c32d63ea2f98eee5ff2e23fcbf0a3d7345906c3b8c2a7e864fc360f7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f96b9cb299e6f47cf10320435e5d3a7d2a1f79c9a2cf5d7ed681f0b8d9af4a54)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__41b8fb9cdc14b7299a717461cbb95e6c9427a90b4bc605c3a5aec449d09d712d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aa1fa4eb016e4384f5720068d789664bd72abd483305e05a4f1101a9f66483a6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5d885e2c73ac2eb156122e3868453b2928cb9c22ab65ec757a7cc046a3ae02b0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualHsv]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualHsv]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualHsv]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__830ac777100bba4c4f7d888d8282cc700bd621f3f2ff34a6b514153b4028b684)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfDimension",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "dimension": "dimension",
        "dimension_var": "dimensionVar",
        "equal": "equal",
        "greater_than": "greaterThan",
        "less_than": "lessThan",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfDimension:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        dimension: typing.Optional[builtins.str] = None,
        dimension_var: typing.Optional[builtins.str] = None,
        equal: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionEqual", typing.Dict[builtins.str, typing.Any]]] = None,
        greater_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionGreaterThan", typing.Dict[builtins.str, typing.Any]]] = None,
        less_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionLessThan", typing.Dict[builtins.str, typing.Any]]] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param dimension: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        :param dimension_var: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        :param equal: equal block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        :param greater_than: greater_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        :param less_than: less_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        :param value: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionDefault(**default)
        if isinstance(equal, dict):
            equal = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionEqual(**equal)
        if isinstance(greater_than, dict):
            greater_than = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionGreaterThan(**greater_than)
        if isinstance(less_than, dict):
            less_than = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionLessThan(**less_than)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__34dc0e25270a747138637641dddddd30923fa5a893a6bc6d00299d88cf89b961)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument dimension", value=dimension, expected_type=type_hints["dimension"])
            check_type(argname="argument dimension_var", value=dimension_var, expected_type=type_hints["dimension_var"])
            check_type(argname="argument equal", value=equal, expected_type=type_hints["equal"])
            check_type(argname="argument greater_than", value=greater_than, expected_type=type_hints["greater_than"])
            check_type(argname="argument less_than", value=less_than, expected_type=type_hints["less_than"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if dimension is not None:
            self._values["dimension"] = dimension
        if dimension_var is not None:
            self._values["dimension_var"] = dimension_var
        if equal is not None:
            self._values["equal"] = equal
        if greater_than is not None:
            self._values["greater_than"] = greater_than
        if less_than is not None:
            self._values["less_than"] = less_than
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionDefault"], result)

    @builtins.property
    def dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        '''
        result = self._values.get("dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        '''
        result = self._values.get("dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def equal(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionEqual"]:
        '''equal block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        '''
        result = self._values.get("equal")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionEqual"], result)

    @builtins.property
    def greater_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionGreaterThan"]:
        '''greater_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        '''
        result = self._values.get("greater_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionGreaterThan"], result)

    @builtins.property
    def less_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionLessThan"]:
        '''less_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        '''
        result = self._values.get("less_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionLessThan"], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfDimension(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0bc09856835900e37a408262181568126ce35f471b92a6141d1ef3dff21af03c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e95737e0a9118b52f670f0479c743ea14123dcbb5392c83a908699905ebef4b6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionEqual",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionEqual:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionEqual(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionEqualOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionEqualOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__02383ff240d855adc4ca517dfb55341d2e8b0a70bc6272880d42044c4afe56f7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionEqual], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionEqual],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be64b1f700b09a9451eb053514aec3019652022f54a570a16b1ab665b2cafc78)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionGreaterThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionGreaterThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionGreaterThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionGreaterThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionGreaterThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a3832a79673c8a446ff64d025c55e744e6cc36f38f6cba8702db282bc2013073)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionGreaterThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionGreaterThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__025dcd1a76e875a6f422f17cad74be14e18a9535f9854587ec4927332715a254)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionLessThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionLessThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionLessThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionLessThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionLessThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1b94e34d7f9d1eb7f7314eb331ffc72c44349f75b552fc9393349db68d90285f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionLessThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionLessThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d2efc62f64f026dfac4be13e7a992b05fcca468081ae103cd1e7eb350c2f020)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d5e5a80a41229a380a5e3070a7d7706da2ad0186a9e31c21acb74bf46440f897)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__468b19e809b62af056bbf0e716d9e27a519747c348c45f3a5d4e6dca32d99402)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9cd82319909fdb5b0dfc06abffff786784349f595d84256552a87134e53ae5cb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac8aec8c2fecff0e4b8007e20dde75edf44be0e4c260a25bbf30ff1b8c76c8cb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__91e40a4d2829216b293f76bb7e843ce4f369a220a6b83eb2ca58f2a8c00c7793)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfDimension]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfDimension]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1cd38d451baf714fea50c920488fac6a28cd81225f1bf0b8a2d0d109249189db)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__34c99aa1e2713fcd86e4cb68011fe818113bdb36e15cad8f8143391bb669fa83)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putEqual")
    def put_equal(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionEqual()

        return typing.cast(None, jsii.invoke(self, "putEqual", [value]))

    @jsii.member(jsii_name="putGreaterThan")
    def put_greater_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionGreaterThan()

        return typing.cast(None, jsii.invoke(self, "putGreaterThan", [value]))

    @jsii.member(jsii_name="putLessThan")
    def put_less_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionLessThan()

        return typing.cast(None, jsii.invoke(self, "putLessThan", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetDimension")
    def reset_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimension", []))

    @jsii.member(jsii_name="resetDimensionVar")
    def reset_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimensionVar", []))

    @jsii.member(jsii_name="resetEqual")
    def reset_equal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEqual", []))

    @jsii.member(jsii_name="resetGreaterThan")
    def reset_greater_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGreaterThan", []))

    @jsii.member(jsii_name="resetLessThan")
    def reset_less_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLessThan", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="equal")
    def equal(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionEqualOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionEqualOutputReference, jsii.get(self, "equal"))

    @builtins.property
    @jsii.member(jsii_name="greaterThan")
    def greater_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionGreaterThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionGreaterThanOutputReference, jsii.get(self, "greaterThan"))

    @builtins.property
    @jsii.member(jsii_name="lessThan")
    def less_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionLessThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionLessThanOutputReference, jsii.get(self, "lessThan"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionInput")
    def dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionVarInput")
    def dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="equalInput")
    def equal_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionEqual], jsii.get(self, "equalInput"))

    @builtins.property
    @jsii.member(jsii_name="greaterThanInput")
    def greater_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionGreaterThan], jsii.get(self, "greaterThanInput"))

    @builtins.property
    @jsii.member(jsii_name="lessThanInput")
    def less_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionLessThan], jsii.get(self, "lessThanInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="dimension")
    def dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimension"))

    @dimension.setter
    def dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d904082d54060fda683b3bd30996694887b7c5e58bfcc1da0a0b4c66fedeeba8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimension", value)

    @builtins.property
    @jsii.member(jsii_name="dimensionVar")
    def dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimensionVar"))

    @dimension_var.setter
    def dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1307536e65b4d8298ba95cedb6599e0c1974f969a19b64e322eeaa9dfa760f5c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f753763881fc1b0e7638b7226616326d05b6fab8c137eeb9e09aa98b32fda9ee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__110560bd0b4dde83b0e421dee75973373b6c76cbcb63496698973ea7a12a5fa0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfDimension]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfDimension]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfDimension]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__de3d11ca0db6cd35f282c77da7de897f5086b061a1ea10b97da2a8a471eff9af)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfOrientation",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "landscape": "landscape",
        "portrait": "portrait",
        "square": "square",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfOrientation:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        landscape: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationLandscape", typing.Dict[builtins.str, typing.Any]]] = None,
        portrait: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationPortrait", typing.Dict[builtins.str, typing.Any]]] = None,
        square: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationSquare", typing.Dict[builtins.str, typing.Any]]] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param landscape: landscape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        :param portrait: portrait block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        :param square: square block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationDefault(**default)
        if isinstance(landscape, dict):
            landscape = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationLandscape(**landscape)
        if isinstance(portrait, dict):
            portrait = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationPortrait(**portrait)
        if isinstance(square, dict):
            square = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationSquare(**square)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__939581f3e2f951df9803e7f2fd85c9496cf199585e24138baab49e7823cc0cbb)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument landscape", value=landscape, expected_type=type_hints["landscape"])
            check_type(argname="argument portrait", value=portrait, expected_type=type_hints["portrait"])
            check_type(argname="argument square", value=square, expected_type=type_hints["square"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if landscape is not None:
            self._values["landscape"] = landscape
        if portrait is not None:
            self._values["portrait"] = portrait
        if square is not None:
            self._values["square"] = square

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationDefault"], result)

    @builtins.property
    def landscape(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationLandscape"]:
        '''landscape block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        '''
        result = self._values.get("landscape")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationLandscape"], result)

    @builtins.property
    def portrait(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationPortrait"]:
        '''portrait block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        '''
        result = self._values.get("portrait")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationPortrait"], result)

    @builtins.property
    def square(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationSquare"]:
        '''square block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        result = self._values.get("square")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationSquare"], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfOrientation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ed99de404abd1b0d97af31bd183101cbc8376abccee11af70300b67fc4e4d716)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__609a4a13b66a8a4197a461bb846fd1c7e147e81f349c241deb4e850ce39e8000)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationLandscape",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationLandscape:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationLandscape(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationLandscapeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationLandscapeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__592550cfae8b0342dda2770073c81aa8c9fc4cc638c8af89bb81850ccfdad089)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationLandscape], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationLandscape],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e79395d5a775a5dea093f6e0594034ed05de69471a01eaf1ddbf6181765c662f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2f5c86f3a5e9dbab3924f7ba6b3b6ca728dfe360342f9e0d458fabfd7a6a7dbf)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__877f3791c6994a6bddb726e4423e179c809c5b01508f15be523a3e5b6999a795)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__44da169f1578b0ceffb5bf2630b6ebb164cebe19d8539851dfd7e854ae1510cc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1d664c347a9983c49e0f8c4ebc67cb61f20d7cc024f2fe55e825b6ae70d71838)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__54b3152d2872a23e5f4eba6922a31b6528c180fd415ea17876ce00d88db44978)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfOrientation]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfOrientation]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__baea373d4d5c856a288f953fec57d9690ee7df1bda8b7f8312f7b5c837a67a61)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__46368327bb824b552796bbdb8136d363983e2848ae55f6a5098986db2a961921)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putLandscape")
    def put_landscape(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationLandscape()

        return typing.cast(None, jsii.invoke(self, "putLandscape", [value]))

    @jsii.member(jsii_name="putPortrait")
    def put_portrait(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationPortrait()

        return typing.cast(None, jsii.invoke(self, "putPortrait", [value]))

    @jsii.member(jsii_name="putSquare")
    def put_square(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationSquare()

        return typing.cast(None, jsii.invoke(self, "putSquare", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetLandscape")
    def reset_landscape(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLandscape", []))

    @jsii.member(jsii_name="resetPortrait")
    def reset_portrait(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPortrait", []))

    @jsii.member(jsii_name="resetSquare")
    def reset_square(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSquare", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="landscape")
    def landscape(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationLandscapeOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationLandscapeOutputReference, jsii.get(self, "landscape"))

    @builtins.property
    @jsii.member(jsii_name="portrait")
    def portrait(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationPortraitOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationPortraitOutputReference", jsii.get(self, "portrait"))

    @builtins.property
    @jsii.member(jsii_name="square")
    def square(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationSquareOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationSquareOutputReference", jsii.get(self, "square"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="landscapeInput")
    def landscape_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationLandscape], jsii.get(self, "landscapeInput"))

    @builtins.property
    @jsii.member(jsii_name="portraitInput")
    def portrait_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationPortrait"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationPortrait"], jsii.get(self, "portraitInput"))

    @builtins.property
    @jsii.member(jsii_name="squareInput")
    def square_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationSquare"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationSquare"], jsii.get(self, "squareInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfOrientation]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfOrientation]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfOrientation]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ecafaeb7fbe2cf887037ee82cd615ac0ac4c103a6dd787284ecd6d60bb2484e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationPortrait",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationPortrait:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationPortrait(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationPortraitOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationPortraitOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__87015c934ddab471fedd429fa19ac7811e813b8f257f24ec97630564a6e09f64)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationPortrait]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationPortrait], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationPortrait],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a624d007c33faa66da2db978c9bb5c2d01bef846c09921db688b7d8bd27a9dac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationSquare",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationSquare:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationSquare(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationSquareOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationSquareOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__39efdce86e0d966bbf895b5f8c95dee02e6f7cc18d56b06e1bf7847a2286ae58)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationSquare]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationSquare], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationSquare],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__357432ca5f969ad048a880f85a2bd3c2f89ff5e7eb0531e1f5428c7de600fe61)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualImQuery",
    jsii_struct_bases=[],
    name_mapping={
        "allowed_transformations": "allowedTransformations",
        "query_var": "queryVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualImQuery:
    def __init__(
        self,
        *,
        allowed_transformations: typing.Sequence[builtins.str],
        query_var: builtins.str,
    ) -> None:
        '''
        :param allowed_transformations: Specifies the transformations that can be applied using the query string parameter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allowed_transformations DataAkamaiImagingPolicyImage#allowed_transformations}
        :param query_var: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#query_var DataAkamaiImagingPolicyImage#query_var}.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f6f7d00203c9e97c5a6b10f6a19574b8ba1bdaf5fc665e5685f5c911bd303bc7)
            check_type(argname="argument allowed_transformations", value=allowed_transformations, expected_type=type_hints["allowed_transformations"])
            check_type(argname="argument query_var", value=query_var, expected_type=type_hints["query_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "allowed_transformations": allowed_transformations,
            "query_var": query_var,
        }

    @builtins.property
    def allowed_transformations(self) -> typing.List[builtins.str]:
        '''Specifies the transformations that can be applied using the query string parameter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allowed_transformations DataAkamaiImagingPolicyImage#allowed_transformations}
        '''
        result = self._values.get("allowed_transformations")
        assert result is not None, "Required property 'allowed_transformations' is missing"
        return typing.cast(typing.List[builtins.str], result)

    @builtins.property
    def query_var(self) -> builtins.str:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#query_var DataAkamaiImagingPolicyImage#query_var}.'''
        result = self._values.get("query_var")
        assert result is not None, "Required property 'query_var' is missing"
        return typing.cast(builtins.str, result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualImQuery(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualImQueryList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualImQueryList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ffd0e8b63de202c2a2a90c9e9774056a3933607843b913a99db87bb53ef6f0dc)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualImQueryOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c80434e28118e63db4f7da63164bb74608a172d09e72d2f40d6b46bdd9a7c3af)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualImQueryOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a27d99049d2e97278280ff363ca8d7ad5bd9054a0055f3c6e503a7ee0e955026)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__65f45d5a9ee72c379ed0d9ae1d5c88bacb4b2a1d8cb235a2fde34e5bbc19af5d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ee81d9e509b5196127fe4bb54d3ed0bdc7a6067abd116eff5eede627a9b43415)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualImQuery]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualImQuery]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualImQuery]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0adcb9452f9cfd1edeef3e5a8aa6e935ad6b4b575a2562ea93ef0745d1ede2ab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualImQueryOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualImQueryOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__04a812c62ef8e4481e6392e28f7e855fafd64a2d3890ee3bec9f3bbbb35c8208)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @builtins.property
    @jsii.member(jsii_name="allowedTransformationsInput")
    def allowed_transformations_input(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "allowedTransformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="queryVarInput")
    def query_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "queryVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowedTransformations")
    def allowed_transformations(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "allowedTransformations"))

    @allowed_transformations.setter
    def allowed_transformations(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fee0d64bbad46b2d2c6186014a897156d4a815af7670a9692de9041f4891b178)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowedTransformations", value)

    @builtins.property
    @jsii.member(jsii_name="queryVar")
    def query_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "queryVar"))

    @query_var.setter
    def query_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1d78f49c2a0c6746b74a96e94f3de3ab9c55dc1c292c32aaf5a8584cf6311600)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "queryVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualImQuery]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualImQuery]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualImQuery]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__96028f8854624f844027e8c64146e5523cf0167c9050f078617d5530035d6ea0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualMaxColors",
    jsii_struct_bases=[],
    name_mapping={"colors": "colors", "colors_var": "colorsVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualMaxColors:
    def __init__(
        self,
        *,
        colors: typing.Optional[builtins.str] = None,
        colors_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param colors: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        :param colors_var: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f0a262d8304a82dc0ba1bf7c78dcd420c7eda4ccc7537aecc9250b07911699c9)
            check_type(argname="argument colors", value=colors, expected_type=type_hints["colors"])
            check_type(argname="argument colors_var", value=colors_var, expected_type=type_hints["colors_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if colors is not None:
            self._values["colors"] = colors
        if colors_var is not None:
            self._values["colors_var"] = colors_var

    @builtins.property
    def colors(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        '''
        result = self._values.get("colors")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def colors_var(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        result = self._values.get("colors_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualMaxColors(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualMaxColorsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualMaxColorsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5724cf9d958d52b09f89139ceeb6ff43795bd06c510cf038513e32afa27c7a61)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualMaxColorsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__469f7f0536ff3edf6d1c549d44ff854e358f925075b0b2490e5a33ea3657c699)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualMaxColorsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b98f372b9ce366d556cd0cc07736e83971662a249d3daa9e186a14bd4a6c1332)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__96f3b4fc7446939a90edb42d9715132cf8e69c7da45b7b51b78576af554a5d17)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2b402d79567b4caf0edecd4493ee28740828cff0ed35e2c9eb05a50f8d10624b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualMaxColors]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualMaxColors]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f1095dced9cd62b54184f2df81e1b76440d82b4b1deb85d3f68e036fc981deb7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualMaxColorsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualMaxColorsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__97e8991fdd317d7da68546e8a1a395e72f4f6fcae1018b6a15b9b402bd3622ff)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColors")
    def reset_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColors", []))

    @jsii.member(jsii_name="resetColorsVar")
    def reset_colors_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorsVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorsInput")
    def colors_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsInput"))

    @builtins.property
    @jsii.member(jsii_name="colorsVarInput")
    def colors_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsVarInput"))

    @builtins.property
    @jsii.member(jsii_name="colors")
    def colors(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colors"))

    @colors.setter
    def colors(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a6f68a5b3aa09fe82b18f899a80abd7660df2ab0046bde95f84ab542954a2ff6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colors", value)

    @builtins.property
    @jsii.member(jsii_name="colorsVar")
    def colors_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorsVar"))

    @colors_var.setter
    def colors_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__98becb2623f2ece77171c906948124630672c41387cab6e03ff4e16d3cf05ad6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorsVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualMaxColors]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualMaxColors]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualMaxColors]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__160882eacc29e7c12277086f752a11c2e8e6bef367a9e2246fad4e728ea30d7d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualMirror",
    jsii_struct_bases=[],
    name_mapping={
        "horizontal": "horizontal",
        "horizontal_var": "horizontalVar",
        "vertical": "vertical",
        "vertical_var": "verticalVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualMirror:
    def __init__(
        self,
        *,
        horizontal: typing.Optional[builtins.str] = None,
        horizontal_var: typing.Optional[builtins.str] = None,
        vertical: typing.Optional[builtins.str] = None,
        vertical_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param horizontal: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        :param horizontal_var: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        :param vertical: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        :param vertical_var: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1d6d2c2c5097187f1715c83d6c4b802c1a3f8fe6f73284378d7e1a9e6fd2b654)
            check_type(argname="argument horizontal", value=horizontal, expected_type=type_hints["horizontal"])
            check_type(argname="argument horizontal_var", value=horizontal_var, expected_type=type_hints["horizontal_var"])
            check_type(argname="argument vertical", value=vertical, expected_type=type_hints["vertical"])
            check_type(argname="argument vertical_var", value=vertical_var, expected_type=type_hints["vertical_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if horizontal is not None:
            self._values["horizontal"] = horizontal
        if horizontal_var is not None:
            self._values["horizontal_var"] = horizontal_var
        if vertical is not None:
            self._values["vertical"] = vertical
        if vertical_var is not None:
            self._values["vertical_var"] = vertical_var

    @builtins.property
    def horizontal(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        '''
        result = self._values.get("horizontal")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def horizontal_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        '''
        result = self._values.get("horizontal_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        '''
        result = self._values.get("vertical")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        result = self._values.get("vertical_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualMirror(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualMirrorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualMirrorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__21ab2fa88c99cfda1494f48d4d68a6a53562ed0bc39c16472390e44b9596c15b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualMirrorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a5fff246dab1980a2facb98a6fe15c7c1c3b2f673638530cf2dea97a16cabb6c)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualMirrorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fbcf64624a2ea729a3a92d1ea0a86589d669bf99902c83348e33c30f6b59b653)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4984a2386fc360eb92fc161ae5c46a90a814d0c5d840e07d1b3b5dcdfbbf3a0a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd8523a6e0907d4f193e5660f19f096a74e216e6a0aed2b7e53317ea1a543dc9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualMirror]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualMirror]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4e073bb44865b99b8ba5ff9c935407ee719a4725441d7ffd332a27c67d862076)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualMirrorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualMirrorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e4a63b7371814e44d406c90fa319b2ef8de4795ec6758c16979bf4c54733e9db)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHorizontal")
    def reset_horizontal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontal", []))

    @jsii.member(jsii_name="resetHorizontalVar")
    def reset_horizontal_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontalVar", []))

    @jsii.member(jsii_name="resetVertical")
    def reset_vertical(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVertical", []))

    @jsii.member(jsii_name="resetVerticalVar")
    def reset_vertical_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVerticalVar", []))

    @builtins.property
    @jsii.member(jsii_name="horizontalInput")
    def horizontal_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontalVarInput")
    def horizontal_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalInput")
    def vertical_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalVarInput")
    def vertical_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontal")
    def horizontal(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontal"))

    @horizontal.setter
    def horizontal(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b1264df8e00322d7f8feb1de950068125502604bb99f6f41082217008e732e52)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontal", value)

    @builtins.property
    @jsii.member(jsii_name="horizontalVar")
    def horizontal_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontalVar"))

    @horizontal_var.setter
    def horizontal_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3b3bd4fbff3571769de8272ce61de76bf9930686b22713e1d4c8222f2f490050)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontalVar", value)

    @builtins.property
    @jsii.member(jsii_name="vertical")
    def vertical(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "vertical"))

    @vertical.setter
    def vertical(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1ebd967b51bfec95b118ffce768f6674120eda9f828294cef46657dc20fb9712)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "vertical", value)

    @builtins.property
    @jsii.member(jsii_name="verticalVar")
    def vertical_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "verticalVar"))

    @vertical_var.setter
    def vertical_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__32587431093d96c732951d195c4c47e53c5a99a7e0061cc9a51e59ee834bbd57)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "verticalVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualMirror]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualMirror]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualMirror]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__76884f2f52c3093dd279417c5790b9d1b0ae8ccfb7d7aaadceba6937256f2711)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualMonoHue",
    jsii_struct_bases=[],
    name_mapping={"hue": "hue", "hue_var": "hueVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualMonoHue:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__197749df0edf3bf4d1277a627639a0bcbad991a72798222d634a2bbcf5f9305c)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualMonoHue(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualMonoHueList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualMonoHueList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5954fbac6c7e266f9d4bf3c51d2242e30bc48d063a8b9849d7db425d65626e45)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualMonoHueOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0656423e3e1360827cb67de5771a0492a92567055278aabc020a313064f750a1)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualMonoHueOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__70902b0c9daf90d3e1b07b9725e3ad349623b35daf17cc5004677abd6e4eda3e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ce48c2ae54dcb46fa22101c6a87d534761a66b2d3bedf4483a6d16a281be2b15)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f612da743db71576b143afd5f9f58ff3eeb7a85e05237b5d617a00dc8ed26d38)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualMonoHue]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualMonoHue]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__62eb83f4503eac205b4a4ab0ce2bc09cc13e76f030dd0cc85b4bfac7b80e96f4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualMonoHueOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualMonoHueOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__efb57d735cff17bd2fac188a8d321fd06554045bd63d8c832c87825c5a6a1816)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dacae530e8f2b35c8b95b38721d589ab0d3451a24dc8eb9655a0cd890392ad14)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6b052880a1e98df5c71b731218a66fb7f9c76129ba545612e68015a94d23df21)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualMonoHue]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualMonoHue]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualMonoHue]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__767238ad237dac6146ac3b2a268ba8d66438d3fcd33734892d375e99c881cc38)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualOpacity",
    jsii_struct_bases=[],
    name_mapping={"opacity": "opacity", "opacity_var": "opacityVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualOpacity:
    def __init__(
        self,
        *,
        opacity: typing.Optional[builtins.str] = None,
        opacity_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param opacity: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param opacity_var: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9e42075b69af8f7e84c6ac11f625b6d89484218431171d00344dfbd13f0a1698)
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument opacity_var", value=opacity_var, expected_type=type_hints["opacity_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if opacity is not None:
            self._values["opacity"] = opacity
        if opacity_var is not None:
            self._values["opacity_var"] = opacity_var

    @builtins.property
    def opacity(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def opacity_var(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        result = self._values.get("opacity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualOpacity(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualOpacityList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualOpacityList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d65c4cfcde9a6c8639cadc34e23ade764678389102a5d8af7d21c11bc640f0f4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualOpacityOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a2e2a0fb34ba93d10e19e9e2a931937fd06503bb22192547d94a53c858c8c9f7)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualOpacityOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c68cb9b00278ef9116f31353c172a1d8d094bc0f28bc8fddf4209da257316d1e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b4dda96e5e0520a0b4e994c950351aae4eff251f1be9c499743aaf39cf4f1593)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ed7c9212e1661ce03c145a198ad149969ec1263aac11a385b558e1dd3272abb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualOpacity]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualOpacity]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b45b95f875361739c5416f4bd68128ddcfc2d58ab21af61fc734014a89454ad8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualOpacityOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualOpacityOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__687c754650d1ead6d6d40ca85fd3806cb9fa8ed80d0c112178b7aeec1aebeb8f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetOpacityVar")
    def reset_opacity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacityVar", []))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityVarInput")
    def opacity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacity"))

    @opacity.setter
    def opacity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b77a68cf477c4f5319f35411bfdaf5f1a3cad0f41522d24d843382f057c498e3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacity", value)

    @builtins.property
    @jsii.member(jsii_name="opacityVar")
    def opacity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacityVar"))

    @opacity_var.setter
    def opacity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d30c766b4c5af6018ac0dc738b646840c3f7ae67af6ed6980affb338e1859646)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacityVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualOpacity]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualOpacity]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualOpacity]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ba2ad41f2ce4f73d64d393383f86458c7f9973240b7798ce58308f78d3325cd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__947c7c72490f2e6e691720a2794bd3c8cfd5985cc847f9cb1c2dbcb3e05193b1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putAppend")
    def put_append(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualAppend, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1e00f375c6a28cf7efc1de27d1e41677a141f5d89bd0437abb6f95c391b5108c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putAppend", [value]))

    @jsii.member(jsii_name="putAspectCrop")
    def put_aspect_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualAspectCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea9d0b0b03840c51d55c55c7f2400d8137439dd76908250af8fa497bc9ff1259)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putAspectCrop", [value]))

    @jsii.member(jsii_name="putBackgroundColor")
    def put_background_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a5b1f1572b1fa67b286ae7cdfb1ca20ce8c72f39fe101635f7bc535df5b3b4b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBackgroundColor", [value]))

    @jsii.member(jsii_name="putBlur")
    def put_blur(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualBlur, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3d6b7fec39e8f1636218e758fb122f791e395fc568397b88eabc49109d5ab1b1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBlur", [value]))

    @jsii.member(jsii_name="putChromaKey")
    def put_chroma_key(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualChromaKey, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__96245b5bf6fe371b8b1942a614dd201ce9f52a502a0cf594ce3e27585d13f2f3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putChromaKey", [value]))

    @jsii.member(jsii_name="putComposite")
    def put_composite(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualComposite, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c76692e699eed03708520385f4f89f9fd0ace1bb8ea9fc6337e87e85dd03a94d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putComposite", [value]))

    @jsii.member(jsii_name="putCompound")
    def put_compound(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualCompound, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__09e7f81dd56f5b8cb43796ffb507a2a8266c810aa6381d9d2588812812e9b5df)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCompound", [value]))

    @jsii.member(jsii_name="putContrast")
    def put_contrast(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualContrast, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__65a5d6d4d4af88c5e8cf05da66bdb79bfdd2f93e8b1a4b6d88ab9b5edd13a6df)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putContrast", [value]))

    @jsii.member(jsii_name="putCrop")
    def put_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0f8e471c06b8a022decd68098f9ab61d1a892f3a224375805605e341c41d4796)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCrop", [value]))

    @jsii.member(jsii_name="putFaceCrop")
    def put_face_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualFaceCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6a43e98b21a97d28e51715cc21f9e9b14ce119d4111a005518295a8f48fffd2a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFaceCrop", [value]))

    @jsii.member(jsii_name="putFeatureCrop")
    def put_feature_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualFeatureCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5c014a76abbb68d71a3cdaa60d73ff1b8654123731287a1bb528eb523803c814)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFeatureCrop", [value]))

    @jsii.member(jsii_name="putFitAndFill")
    def put_fit_and_fill(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualFitAndFill, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__023d9de287f4c717a644c77e67c9bbe5af3947fd1d00053b863adcce1cc649fa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFitAndFill", [value]))

    @jsii.member(jsii_name="putGoop")
    def put_goop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualGoop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1373332044ad3c617da39ac63f3783788fe373bc5ba626fca128b2fb47ee3bf9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGoop", [value]))

    @jsii.member(jsii_name="putGrayscale")
    def put_grayscale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualGrayscale, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__288bcd431ee8d22c2910a8f256a84b60284c93e30e9cdddaf4274d712b71e45a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGrayscale", [value]))

    @jsii.member(jsii_name="putHsl")
    def put_hsl(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualHsl, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__64b3abe76e268c2d5b70d564d7315496a73af925ae347c69c280da31dd8c164c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsl", [value]))

    @jsii.member(jsii_name="putHsv")
    def put_hsv(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualHsv, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__33f3c14c9c558df2b25b117d7386cdd9c58af7750f3087082dc8822568097e6f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsv", [value]))

    @jsii.member(jsii_name="putIfDimension")
    def put_if_dimension(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfDimension, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9310369f5b9ca3978e68c60ddd09b6d6b71693c4ac5843f01d82f8ec646f7faa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfDimension", [value]))

    @jsii.member(jsii_name="putIfOrientation")
    def put_if_orientation(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__55263b052e52141ab056ed4e524b19116dc675dfb7496bcb522d1a1ed42233b6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfOrientation", [value]))

    @jsii.member(jsii_name="putImQuery")
    def put_im_query(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualImQuery, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__14a0fe4e08b04c04eeae4c2dfcd01aa2708b0bf534517d43a23a8d71c3dc780c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putImQuery", [value]))

    @jsii.member(jsii_name="putMaxColors")
    def put_max_colors(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualMaxColors, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__24211910b4ca0afe0c131e2b4c14eff24abe42119529a97129d28981374c087b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMaxColors", [value]))

    @jsii.member(jsii_name="putMirror")
    def put_mirror(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualMirror, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__78231dbdbf7cf38ee5fbb6e75cbb8513f7ba8025a949c0f4e947a630bdbcb73f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMirror", [value]))

    @jsii.member(jsii_name="putMonoHue")
    def put_mono_hue(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualMonoHue, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1da8421dbf0950e79abe09d023ff18f03a07aacd39402f3e734d73a5ca2c7b77)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMonoHue", [value]))

    @jsii.member(jsii_name="putOpacity")
    def put_opacity(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualOpacity, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d607130d92204fd5174ddb5baec9ef7d6768f221cc5d6481110e6a99da1ce436)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putOpacity", [value]))

    @jsii.member(jsii_name="putRegionOfInterestCrop")
    def put_region_of_interest_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualRegionOfInterestCrop", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ca43f77e5188343eeb237400e681793e67c377158834280cb3e6eb1c8ea8e0f3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRegionOfInterestCrop", [value]))

    @jsii.member(jsii_name="putRelativeCrop")
    def put_relative_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualRelativeCrop", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__210dec21d79cda41f5631c43aa8f297a36063995c1c45305278e24a07957d75c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRelativeCrop", [value]))

    @jsii.member(jsii_name="putRemoveColor")
    def put_remove_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualRemoveColor", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ff69fa88b05fa86967d8c6dc82dff3a65a94bfd6d16dc467fa10c6216105452)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRemoveColor", [value]))

    @jsii.member(jsii_name="putResize")
    def put_resize(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualResize", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__133b5c61e4eb98cf88eed67ff9cc4149cbf6c12464f08e775ee57bb95e598e35)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putResize", [value]))

    @jsii.member(jsii_name="putRotate")
    def put_rotate(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualRotate", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fed975329dc3590680e9a0cb348ff3717e8507c028000cc22c2d050f154b8438)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRotate", [value]))

    @jsii.member(jsii_name="putScale")
    def put_scale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualScale", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__892ff28f547f10001d64566c0075ad44f7e18466b1376f36fef249d4f3cd52b8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putScale", [value]))

    @jsii.member(jsii_name="putShear")
    def put_shear(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualShear", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__45dcfd4eaed5299997d7d0f8ccbdba4ed7dd1ac1c8756ee8eb5d2ee6578ca71b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putShear", [value]))

    @jsii.member(jsii_name="putTrim")
    def put_trim(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualTrim", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0152b8475eff6fc00648c9062586fa025bfdcdfba4bdb3fda03f8119704a1953)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTrim", [value]))

    @jsii.member(jsii_name="putUnsharpMask")
    def put_unsharp_mask(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualUnsharpMask", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__93790f5258d4b08a115b386c00c6ae042ec7cd3db1b5e106c3b856dfa07c7967)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putUnsharpMask", [value]))

    @jsii.member(jsii_name="resetAppend")
    def reset_append(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAppend", []))

    @jsii.member(jsii_name="resetAspectCrop")
    def reset_aspect_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspectCrop", []))

    @jsii.member(jsii_name="resetBackgroundColor")
    def reset_background_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBackgroundColor", []))

    @jsii.member(jsii_name="resetBlur")
    def reset_blur(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBlur", []))

    @jsii.member(jsii_name="resetChromaKey")
    def reset_chroma_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChromaKey", []))

    @jsii.member(jsii_name="resetComposite")
    def reset_composite(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetComposite", []))

    @jsii.member(jsii_name="resetCompound")
    def reset_compound(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCompound", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetCrop")
    def reset_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCrop", []))

    @jsii.member(jsii_name="resetFaceCrop")
    def reset_face_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFaceCrop", []))

    @jsii.member(jsii_name="resetFeatureCrop")
    def reset_feature_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureCrop", []))

    @jsii.member(jsii_name="resetFitAndFill")
    def reset_fit_and_fill(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFitAndFill", []))

    @jsii.member(jsii_name="resetGoop")
    def reset_goop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGoop", []))

    @jsii.member(jsii_name="resetGrayscale")
    def reset_grayscale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGrayscale", []))

    @jsii.member(jsii_name="resetHsl")
    def reset_hsl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsl", []))

    @jsii.member(jsii_name="resetHsv")
    def reset_hsv(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsv", []))

    @jsii.member(jsii_name="resetIfDimension")
    def reset_if_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfDimension", []))

    @jsii.member(jsii_name="resetIfOrientation")
    def reset_if_orientation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfOrientation", []))

    @jsii.member(jsii_name="resetImQuery")
    def reset_im_query(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetImQuery", []))

    @jsii.member(jsii_name="resetMaxColors")
    def reset_max_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxColors", []))

    @jsii.member(jsii_name="resetMirror")
    def reset_mirror(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMirror", []))

    @jsii.member(jsii_name="resetMonoHue")
    def reset_mono_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonoHue", []))

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetRegionOfInterestCrop")
    def reset_region_of_interest_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRegionOfInterestCrop", []))

    @jsii.member(jsii_name="resetRelativeCrop")
    def reset_relative_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRelativeCrop", []))

    @jsii.member(jsii_name="resetRemoveColor")
    def reset_remove_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRemoveColor", []))

    @jsii.member(jsii_name="resetResize")
    def reset_resize(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetResize", []))

    @jsii.member(jsii_name="resetRotate")
    def reset_rotate(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRotate", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetShear")
    def reset_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetShear", []))

    @jsii.member(jsii_name="resetTrim")
    def reset_trim(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTrim", []))

    @jsii.member(jsii_name="resetUnsharpMask")
    def reset_unsharp_mask(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUnsharpMask", []))

    @builtins.property
    @jsii.member(jsii_name="append")
    def append(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualAppendList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualAppendList, jsii.get(self, "append"))

    @builtins.property
    @jsii.member(jsii_name="aspectCrop")
    def aspect_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualAspectCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualAspectCropList, jsii.get(self, "aspectCrop"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColor")
    def background_color(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualBackgroundColorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualBackgroundColorList, jsii.get(self, "backgroundColor"))

    @builtins.property
    @jsii.member(jsii_name="blur")
    def blur(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualBlurList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualBlurList, jsii.get(self, "blur"))

    @builtins.property
    @jsii.member(jsii_name="chromaKey")
    def chroma_key(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualChromaKeyList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualChromaKeyList, jsii.get(self, "chromaKey"))

    @builtins.property
    @jsii.member(jsii_name="composite")
    def composite(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualCompositeList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualCompositeList, jsii.get(self, "composite"))

    @builtins.property
    @jsii.member(jsii_name="compound")
    def compound(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualCompoundList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualCompoundList, jsii.get(self, "compound"))

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualContrastList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualContrastList, jsii.get(self, "contrast"))

    @builtins.property
    @jsii.member(jsii_name="crop")
    def crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualCropList, jsii.get(self, "crop"))

    @builtins.property
    @jsii.member(jsii_name="faceCrop")
    def face_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualFaceCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualFaceCropList, jsii.get(self, "faceCrop"))

    @builtins.property
    @jsii.member(jsii_name="featureCrop")
    def feature_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualFeatureCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualFeatureCropList, jsii.get(self, "featureCrop"))

    @builtins.property
    @jsii.member(jsii_name="fitAndFill")
    def fit_and_fill(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualFitAndFillList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualFitAndFillList, jsii.get(self, "fitAndFill"))

    @builtins.property
    @jsii.member(jsii_name="goop")
    def goop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualGoopList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualGoopList, jsii.get(self, "goop"))

    @builtins.property
    @jsii.member(jsii_name="grayscale")
    def grayscale(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualGrayscaleList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualGrayscaleList, jsii.get(self, "grayscale"))

    @builtins.property
    @jsii.member(jsii_name="hsl")
    def hsl(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualHslList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualHslList, jsii.get(self, "hsl"))

    @builtins.property
    @jsii.member(jsii_name="hsv")
    def hsv(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualHsvList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualHsvList, jsii.get(self, "hsv"))

    @builtins.property
    @jsii.member(jsii_name="ifDimension")
    def if_dimension(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionList, jsii.get(self, "ifDimension"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientation")
    def if_orientation(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationList, jsii.get(self, "ifOrientation"))

    @builtins.property
    @jsii.member(jsii_name="imQuery")
    def im_query(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualImQueryList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualImQueryList, jsii.get(self, "imQuery"))

    @builtins.property
    @jsii.member(jsii_name="maxColors")
    def max_colors(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualMaxColorsList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualMaxColorsList, jsii.get(self, "maxColors"))

    @builtins.property
    @jsii.member(jsii_name="mirror")
    def mirror(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualMirrorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualMirrorList, jsii.get(self, "mirror"))

    @builtins.property
    @jsii.member(jsii_name="monoHue")
    def mono_hue(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualMonoHueList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualMonoHueList, jsii.get(self, "monoHue"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualOpacityList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualOpacityList, jsii.get(self, "opacity"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestCrop")
    def region_of_interest_crop(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualRegionOfInterestCropList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualRegionOfInterestCropList", jsii.get(self, "regionOfInterestCrop"))

    @builtins.property
    @jsii.member(jsii_name="relativeCrop")
    def relative_crop(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualRelativeCropList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualRelativeCropList", jsii.get(self, "relativeCrop"))

    @builtins.property
    @jsii.member(jsii_name="removeColor")
    def remove_color(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualRemoveColorList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualRemoveColorList", jsii.get(self, "removeColor"))

    @builtins.property
    @jsii.member(jsii_name="resize")
    def resize(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualResizeList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualResizeList", jsii.get(self, "resize"))

    @builtins.property
    @jsii.member(jsii_name="rotate")
    def rotate(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualRotateList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualRotateList", jsii.get(self, "rotate"))

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualScaleList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualScaleList", jsii.get(self, "scale"))

    @builtins.property
    @jsii.member(jsii_name="shear")
    def shear(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualShearList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualShearList", jsii.get(self, "shear"))

    @builtins.property
    @jsii.member(jsii_name="trim")
    def trim(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualTrimList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualTrimList", jsii.get(self, "trim"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMask")
    def unsharp_mask(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualUnsharpMaskList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualUnsharpMaskList", jsii.get(self, "unsharpMask"))

    @builtins.property
    @jsii.member(jsii_name="appendInput")
    def append_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualAppend]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualAppend]]], jsii.get(self, "appendInput"))

    @builtins.property
    @jsii.member(jsii_name="aspectCropInput")
    def aspect_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualAspectCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualAspectCrop]]], jsii.get(self, "aspectCropInput"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColorInput")
    def background_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualBackgroundColor]]], jsii.get(self, "backgroundColorInput"))

    @builtins.property
    @jsii.member(jsii_name="blurInput")
    def blur_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualBlur]]], jsii.get(self, "blurInput"))

    @builtins.property
    @jsii.member(jsii_name="chromaKeyInput")
    def chroma_key_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualChromaKey]]], jsii.get(self, "chromaKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="compositeInput")
    def composite_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualComposite]]], jsii.get(self, "compositeInput"))

    @builtins.property
    @jsii.member(jsii_name="compoundInput")
    def compound_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualCompound]]], jsii.get(self, "compoundInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualContrast]]], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="cropInput")
    def crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualCrop]]], jsii.get(self, "cropInput"))

    @builtins.property
    @jsii.member(jsii_name="faceCropInput")
    def face_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualFaceCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualFaceCrop]]], jsii.get(self, "faceCropInput"))

    @builtins.property
    @jsii.member(jsii_name="featureCropInput")
    def feature_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualFeatureCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualFeatureCrop]]], jsii.get(self, "featureCropInput"))

    @builtins.property
    @jsii.member(jsii_name="fitAndFillInput")
    def fit_and_fill_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualFitAndFill]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualFitAndFill]]], jsii.get(self, "fitAndFillInput"))

    @builtins.property
    @jsii.member(jsii_name="goopInput")
    def goop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualGoop]]], jsii.get(self, "goopInput"))

    @builtins.property
    @jsii.member(jsii_name="grayscaleInput")
    def grayscale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualGrayscale]]], jsii.get(self, "grayscaleInput"))

    @builtins.property
    @jsii.member(jsii_name="hslInput")
    def hsl_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualHsl]]], jsii.get(self, "hslInput"))

    @builtins.property
    @jsii.member(jsii_name="hsvInput")
    def hsv_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualHsv]]], jsii.get(self, "hsvInput"))

    @builtins.property
    @jsii.member(jsii_name="ifDimensionInput")
    def if_dimension_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfDimension]]], jsii.get(self, "ifDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientationInput")
    def if_orientation_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfOrientation]]], jsii.get(self, "ifOrientationInput"))

    @builtins.property
    @jsii.member(jsii_name="imQueryInput")
    def im_query_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualImQuery]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualImQuery]]], jsii.get(self, "imQueryInput"))

    @builtins.property
    @jsii.member(jsii_name="maxColorsInput")
    def max_colors_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualMaxColors]]], jsii.get(self, "maxColorsInput"))

    @builtins.property
    @jsii.member(jsii_name="mirrorInput")
    def mirror_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualMirror]]], jsii.get(self, "mirrorInput"))

    @builtins.property
    @jsii.member(jsii_name="monoHueInput")
    def mono_hue_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualMonoHue]]], jsii.get(self, "monoHueInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualOpacity]]], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestCropInput")
    def region_of_interest_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualRegionOfInterestCrop"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualRegionOfInterestCrop"]]], jsii.get(self, "regionOfInterestCropInput"))

    @builtins.property
    @jsii.member(jsii_name="relativeCropInput")
    def relative_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualRelativeCrop"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualRelativeCrop"]]], jsii.get(self, "relativeCropInput"))

    @builtins.property
    @jsii.member(jsii_name="removeColorInput")
    def remove_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualRemoveColor"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualRemoveColor"]]], jsii.get(self, "removeColorInput"))

    @builtins.property
    @jsii.member(jsii_name="resizeInput")
    def resize_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualResize"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualResize"]]], jsii.get(self, "resizeInput"))

    @builtins.property
    @jsii.member(jsii_name="rotateInput")
    def rotate_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualRotate"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualRotate"]]], jsii.get(self, "rotateInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualScale"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualScale"]]], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="shearInput")
    def shear_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualShear"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualShear"]]], jsii.get(self, "shearInput"))

    @builtins.property
    @jsii.member(jsii_name="trimInput")
    def trim_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualTrim"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualTrim"]]], jsii.get(self, "trimInput"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMaskInput")
    def unsharp_mask_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualUnsharpMask"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualUnsharpMask"]]], jsii.get(self, "unsharpMaskInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqual], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqual],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f9f4fbc0ea133d883d4d93330aa6139f5a5776b61b2b6a555cbf9015b346e8c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualRegionOfInterestCrop",
    jsii_struct_bases=[],
    name_mapping={
        "region_of_interest": "regionOfInterest",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualRegionOfInterestCrop:
    def __init__(
        self,
        *,
        region_of_interest: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualRegionOfInterestCropRegionOfInterest", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param region_of_interest: region_of_interest block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest DataAkamaiImagingPolicyImage#region_of_interest}
        :param gravity: The placement of the crop area relative to the specified area of interest. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: The placement of the crop area relative to the specified area of interest. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param style: Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(region_of_interest, dict):
            region_of_interest = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualRegionOfInterestCropRegionOfInterest(**region_of_interest)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c737c4334bf6537d22ba715ceac35b0a7e0ab05902a9af79b473d2e9024258bc)
            check_type(argname="argument region_of_interest", value=region_of_interest, expected_type=type_hints["region_of_interest"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "region_of_interest": region_of_interest,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def region_of_interest(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualRegionOfInterestCropRegionOfInterest":
        '''region_of_interest block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest DataAkamaiImagingPolicyImage#region_of_interest}
        '''
        result = self._values.get("region_of_interest")
        assert result is not None, "Required property 'region_of_interest' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualRegionOfInterestCropRegionOfInterest", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''The placement of the crop area relative to the specified area of interest.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''The placement of the crop area relative to the specified area of interest.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualRegionOfInterestCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualRegionOfInterestCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualRegionOfInterestCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e61da0f36cd13d0e569732fc6edf695245a8f621a7e8338295fca75aa29838fd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualRegionOfInterestCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__43deea58ca5fbde320239ff96ae56f3791c21d9894221573fcc55f4a60f2da75)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualRegionOfInterestCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c9374481091bb1ee2ab09f0ffe09a59d91200ac950cb1925bcf3731ce7bd6fa7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c487682bad9e59262aec9c3eb84d53a9397b0f1cf0915a7d9afd35731276c91a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__91f1a4f9c28275c667cdd8800302cb7883cd5e62d88a56a7f5bfb90adcbba5dd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualRegionOfInterestCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualRegionOfInterestCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualRegionOfInterestCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ea9f2895adaaed7d6c7eae498c1e10e38a494e534c186f22ed13ab303bac49a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualRegionOfInterestCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualRegionOfInterestCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ee5f83866c9600b1760781cb81982facde6beeca683497f60030cf01c558f94a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putRegionOfInterest")
    def put_region_of_interest(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualRegionOfInterestCropRegionOfInterest()

        return typing.cast(None, jsii.invoke(self, "putRegionOfInterest", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterest")
    def region_of_interest(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualRegionOfInterestCropRegionOfInterestOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualRegionOfInterestCropRegionOfInterestOutputReference", jsii.get(self, "regionOfInterest"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestInput")
    def region_of_interest_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualRegionOfInterestCropRegionOfInterest"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualRegionOfInterestCropRegionOfInterest"], jsii.get(self, "regionOfInterestInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__25e0434438991eb759f3221d92d7f103331df829f394cd2f3dae3b7259b1ee76)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__99a0921257cbfe774d8b02e77642d726605a3f2f1fa3e2c7c8f64c05705f916c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7bae63fb0a36b2355efffefd5e11c6a6fa9fa2fdc72b8bb82389065bfdbd2965)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__569ffc1d54a36242c6ccd14a7c4cf559f23cb54b4ec80bbe93529c1ba26e557d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5c45d7a16286071e7dc2b9cc2176199f02bf472a2e5280f7b69995d48072f9ad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c729cd513869e7bb32a104b8c850424db5cd60059cf3984397e770ceb6e6ba69)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d4bdde50a36d092536ba64124488c4856bab4d007ace77c54dcdcd19fc89e1f9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be3ca742ffd58a8fb2967271a7ad2b59a6075f6baf3f7fb40ccb31a13d7aed3b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualRegionOfInterestCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualRegionOfInterestCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualRegionOfInterestCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5414376330465c86c1239772f52295a51d083132fb883a2669362e43b0c6b273)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualRegionOfInterestCropRegionOfInterest",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualRegionOfInterestCropRegionOfInterest:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualRegionOfInterestCropRegionOfInterest(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualRegionOfInterestCropRegionOfInterestOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualRegionOfInterestCropRegionOfInterestOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fd211a154296666addbf0f0957a3230e8ef25e9cfa4f642d8f0cf9aa902c10a3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualRegionOfInterestCropRegionOfInterest]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualRegionOfInterestCropRegionOfInterest], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualRegionOfInterestCropRegionOfInterest],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__474ec2554cb2f09a78bd32047dcbd3e6ce0039e757db08f865bfbe9d70a4ee46)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualRelativeCrop",
    jsii_struct_bases=[],
    name_mapping={
        "east": "east",
        "east_var": "eastVar",
        "north": "north",
        "north_var": "northVar",
        "south": "south",
        "south_var": "southVar",
        "west": "west",
        "west_var": "westVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualRelativeCrop:
    def __init__(
        self,
        *,
        east: typing.Optional[builtins.str] = None,
        east_var: typing.Optional[builtins.str] = None,
        north: typing.Optional[builtins.str] = None,
        north_var: typing.Optional[builtins.str] = None,
        south: typing.Optional[builtins.str] = None,
        south_var: typing.Optional[builtins.str] = None,
        west: typing.Optional[builtins.str] = None,
        west_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param east: The number of pixels to shrink or expand the right side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east DataAkamaiImagingPolicyImage#east}
        :param east_var: The number of pixels to shrink or expand the right side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east_var DataAkamaiImagingPolicyImage#east_var}
        :param north: The number of pixels to shrink or expand the top side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north DataAkamaiImagingPolicyImage#north}
        :param north_var: The number of pixels to shrink or expand the top side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north_var DataAkamaiImagingPolicyImage#north_var}
        :param south: The number of pixels to shrink or expand the bottom side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south DataAkamaiImagingPolicyImage#south}
        :param south_var: The number of pixels to shrink or expand the bottom side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south_var DataAkamaiImagingPolicyImage#south_var}
        :param west: The number of pixels to shrink or expand the left side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west DataAkamaiImagingPolicyImage#west}
        :param west_var: The number of pixels to shrink or expand the left side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west_var DataAkamaiImagingPolicyImage#west_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a6549a382bdfc9e7f223fa8a23bc02476bb32e82259f1ac71fcb8005820c3997)
            check_type(argname="argument east", value=east, expected_type=type_hints["east"])
            check_type(argname="argument east_var", value=east_var, expected_type=type_hints["east_var"])
            check_type(argname="argument north", value=north, expected_type=type_hints["north"])
            check_type(argname="argument north_var", value=north_var, expected_type=type_hints["north_var"])
            check_type(argname="argument south", value=south, expected_type=type_hints["south"])
            check_type(argname="argument south_var", value=south_var, expected_type=type_hints["south_var"])
            check_type(argname="argument west", value=west, expected_type=type_hints["west"])
            check_type(argname="argument west_var", value=west_var, expected_type=type_hints["west_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if east is not None:
            self._values["east"] = east
        if east_var is not None:
            self._values["east_var"] = east_var
        if north is not None:
            self._values["north"] = north
        if north_var is not None:
            self._values["north_var"] = north_var
        if south is not None:
            self._values["south"] = south
        if south_var is not None:
            self._values["south_var"] = south_var
        if west is not None:
            self._values["west"] = west
        if west_var is not None:
            self._values["west_var"] = west_var

    @builtins.property
    def east(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the right side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east DataAkamaiImagingPolicyImage#east}
        '''
        result = self._values.get("east")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def east_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the right side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east_var DataAkamaiImagingPolicyImage#east_var}
        '''
        result = self._values.get("east_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def north(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the top side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north DataAkamaiImagingPolicyImage#north}
        '''
        result = self._values.get("north")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def north_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the top side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north_var DataAkamaiImagingPolicyImage#north_var}
        '''
        result = self._values.get("north_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def south(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the bottom side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south DataAkamaiImagingPolicyImage#south}
        '''
        result = self._values.get("south")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def south_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the bottom side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south_var DataAkamaiImagingPolicyImage#south_var}
        '''
        result = self._values.get("south_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def west(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the left side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west DataAkamaiImagingPolicyImage#west}
        '''
        result = self._values.get("west")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def west_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the left side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west_var DataAkamaiImagingPolicyImage#west_var}
        '''
        result = self._values.get("west_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualRelativeCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualRelativeCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualRelativeCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__415fcd473bb1a8cbfa35193ca635538d1b4915771b6e5e68a97546693ca3ac28)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualRelativeCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__907b64cc7c05783777f62422ac2a7ebfa2a8d113694fe6bf48174de9e1c3f274)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualRelativeCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bd1f9dea802f04a042718e6fc94c6a7b4ae1d7ad6afad090b7fe2e6154abd285)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b69c0d1aecf531114fd55eba92beef8e8eba9faa0258177a6444be06dbb61db7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1c99415f703efb4db7561c6b143df6ae9baa3a6e07482370de58dea65cdd5f95)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualRelativeCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualRelativeCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualRelativeCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__960bfa3dd3dae3aab9ebaad17d640271112eed500f44f950ac5b78c83940b071)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualRelativeCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualRelativeCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__38c6c75cbaaf0a1ffe69d6b052a174569fe45a3688a01289a24a3eb5212d3473)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetEast")
    def reset_east(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEast", []))

    @jsii.member(jsii_name="resetEastVar")
    def reset_east_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEastVar", []))

    @jsii.member(jsii_name="resetNorth")
    def reset_north(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNorth", []))

    @jsii.member(jsii_name="resetNorthVar")
    def reset_north_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNorthVar", []))

    @jsii.member(jsii_name="resetSouth")
    def reset_south(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSouth", []))

    @jsii.member(jsii_name="resetSouthVar")
    def reset_south_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSouthVar", []))

    @jsii.member(jsii_name="resetWest")
    def reset_west(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWest", []))

    @jsii.member(jsii_name="resetWestVar")
    def reset_west_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWestVar", []))

    @builtins.property
    @jsii.member(jsii_name="eastInput")
    def east_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "eastInput"))

    @builtins.property
    @jsii.member(jsii_name="eastVarInput")
    def east_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "eastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="northInput")
    def north_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "northInput"))

    @builtins.property
    @jsii.member(jsii_name="northVarInput")
    def north_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "northVarInput"))

    @builtins.property
    @jsii.member(jsii_name="southInput")
    def south_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "southInput"))

    @builtins.property
    @jsii.member(jsii_name="southVarInput")
    def south_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "southVarInput"))

    @builtins.property
    @jsii.member(jsii_name="westInput")
    def west_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "westInput"))

    @builtins.property
    @jsii.member(jsii_name="westVarInput")
    def west_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "westVarInput"))

    @builtins.property
    @jsii.member(jsii_name="east")
    def east(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "east"))

    @east.setter
    def east(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__40429fe45e68c317025e431d2ebf2563911d074e529f472e1a255e949cf1f92e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "east", value)

    @builtins.property
    @jsii.member(jsii_name="eastVar")
    def east_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "eastVar"))

    @east_var.setter
    def east_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2c870f694f14215f07b36e3ff54458357a788c48607e0d38ad5708ad041fb14f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "eastVar", value)

    @builtins.property
    @jsii.member(jsii_name="north")
    def north(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "north"))

    @north.setter
    def north(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__91a89cdc30e3cdb482ed7f3fc00d4573aa6fa0d5faa4c0a01761cd743d58b46d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "north", value)

    @builtins.property
    @jsii.member(jsii_name="northVar")
    def north_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "northVar"))

    @north_var.setter
    def north_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9050d9f2255befd3f19c4bc1c90d61762faae5adc34a851f039ea3106ee21bd8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "northVar", value)

    @builtins.property
    @jsii.member(jsii_name="south")
    def south(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "south"))

    @south.setter
    def south(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cdf56b03ebe06562853788a67fc51bf05792f4a39e53c6a2c05e322e95f8b5b9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "south", value)

    @builtins.property
    @jsii.member(jsii_name="southVar")
    def south_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "southVar"))

    @south_var.setter
    def south_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1bd25e9443394b419835cd7185309640bd85f19888f5411b39db8e48621c8d8c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "southVar", value)

    @builtins.property
    @jsii.member(jsii_name="west")
    def west(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "west"))

    @west.setter
    def west(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__73d7839f23f44f82aed853edb5d9d7fb8f9032d532ecefcc58de9d6a97e295f4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "west", value)

    @builtins.property
    @jsii.member(jsii_name="westVar")
    def west_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "westVar"))

    @west_var.setter
    def west_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__23a580fbf4836540d12d23400060a248458ebefb8e564837be5480ec98a8f1f0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "westVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualRelativeCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualRelativeCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualRelativeCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9dfc45c093d1aedc47543926bd6a904a6c9ec5ceee5344c584ef57dd2968e000)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualRemoveColor",
    jsii_struct_bases=[],
    name_mapping={
        "color": "color",
        "color_var": "colorVar",
        "feather": "feather",
        "feather_var": "featherVar",
        "tolerance": "tolerance",
        "tolerance_var": "toleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualRemoveColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
        feather: typing.Optional[builtins.str] = None,
        feather_var: typing.Optional[builtins.str] = None,
        tolerance: typing.Optional[builtins.str] = None,
        tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        :param feather: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        :param feather_var: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        :param tolerance: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        :param tolerance_var: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__46cd2d62fd1123dee181a459c4d0598390501c455bc3ad0db722f478ab28ad7f)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
            check_type(argname="argument feather", value=feather, expected_type=type_hints["feather"])
            check_type(argname="argument feather_var", value=feather_var, expected_type=type_hints["feather_var"])
            check_type(argname="argument tolerance", value=tolerance, expected_type=type_hints["tolerance"])
            check_type(argname="argument tolerance_var", value=tolerance_var, expected_type=type_hints["tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var
        if feather is not None:
            self._values["feather"] = feather
        if feather_var is not None:
            self._values["feather_var"] = feather_var
        if tolerance is not None:
            self._values["tolerance"] = tolerance
        if tolerance_var is not None:
            self._values["tolerance_var"] = tolerance_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        '''
        result = self._values.get("feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather_var(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        '''
        result = self._values.get("feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        '''
        result = self._values.get("tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance_var(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        result = self._values.get("tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualRemoveColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualRemoveColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualRemoveColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__83957a939c64b2f716349023496c087742cde96c9d654519c1384a51d8836d73)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualRemoveColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__40c37a2dc087e6f677f9e0e83a9d2af9f841b5f4af9d36194146756040d8f5e1)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualRemoveColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__500298a13ecaa74a96dadfe02fef2972fc3b06b6458ab0d982f0698f7d76dc68)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b0799a3ff231c156535d014670c0b3882bf4c76295786de24b72999759898d1c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bcfd17f03ac0601b95130d54bd716736fde3b7b47fb89a2ec1fc390f28d84ca6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualRemoveColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualRemoveColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualRemoveColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f98df9d1cb6320cf189f1b066062dd92b8b87985e4fd95c312ef041d32a94196)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualRemoveColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualRemoveColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1a0f5c8d9431ab7994f917263363b5b4f2c5c61c3cbc26eaa2f7125514b77d4f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @jsii.member(jsii_name="resetFeather")
    def reset_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeather", []))

    @jsii.member(jsii_name="resetFeatherVar")
    def reset_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatherVar", []))

    @jsii.member(jsii_name="resetTolerance")
    def reset_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTolerance", []))

    @jsii.member(jsii_name="resetToleranceVar")
    def reset_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featherInput")
    def feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherInput"))

    @builtins.property
    @jsii.member(jsii_name="featherVarInput")
    def feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceInput")
    def tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceVarInput")
    def tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__46b880aeb675421c862c793c8c769a491f7e506ee81733c8cecb86daa71c6bc3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__edf26d780d93a9ace8fabad5347eb837572806c04ce169378206f1532f9690fe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="feather")
    def feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "feather"))

    @feather.setter
    def feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1a10a315898c9c44b8fea02504b0d7da8276611932f9a4bfe729f67c884cfec9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "feather", value)

    @builtins.property
    @jsii.member(jsii_name="featherVar")
    def feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featherVar"))

    @feather_var.setter
    def feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dfaf632ad35b20bae0d5dc4c1d4408d58d68e67854d6aa95285eb59e46f1f53e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featherVar", value)

    @builtins.property
    @jsii.member(jsii_name="tolerance")
    def tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tolerance"))

    @tolerance.setter
    def tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2569d3eaee64de48580e229c3cb525b9e6641b336357fba2de4e9525192f8316)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tolerance", value)

    @builtins.property
    @jsii.member(jsii_name="toleranceVar")
    def tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "toleranceVar"))

    @tolerance_var.setter
    def tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3f0ed9e1a9756e717688d4424be320731a98a5eb588d40d6b60eafc87d337395)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "toleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualRemoveColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualRemoveColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualRemoveColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2c50fcd97302ceeda639bb11847894b2666b6bf4561c0c8455b2ff2e1baef9d3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualResize",
    jsii_struct_bases=[],
    name_mapping={
        "aspect": "aspect",
        "aspect_var": "aspectVar",
        "height": "height",
        "height_var": "heightVar",
        "type": "type",
        "type_var": "typeVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualResize:
    def __init__(
        self,
        *,
        aspect: typing.Optional[builtins.str] = None,
        aspect_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param aspect: Preserves the aspect ratio. Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect DataAkamaiImagingPolicyImage#aspect}
        :param aspect_var: Preserves the aspect ratio. Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_var DataAkamaiImagingPolicyImage#aspect_var}
        :param height: The height to resize the source image to. Must be set if height is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height to resize the source image to. Must be set if height is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param type: Sets constraints for the image resize. Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: Sets constraints for the image resize. Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        :param width: The width to resize the source image to. Must be set if width is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width to resize the source image to. Must be set if width is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab53e29fd7be3f8d85ec1f0de2f6771580b8440c807615fee6135aea8dc7df75)
            check_type(argname="argument aspect", value=aspect, expected_type=type_hints["aspect"])
            check_type(argname="argument aspect_var", value=aspect_var, expected_type=type_hints["aspect_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if aspect is not None:
            self._values["aspect"] = aspect
        if aspect_var is not None:
            self._values["aspect_var"] = aspect_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def aspect(self) -> typing.Optional[builtins.str]:
        '''Preserves the aspect ratio.

        Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect DataAkamaiImagingPolicyImage#aspect}
        '''
        result = self._values.get("aspect")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def aspect_var(self) -> typing.Optional[builtins.str]:
        '''Preserves the aspect ratio.

        Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_var DataAkamaiImagingPolicyImage#aspect_var}
        '''
        result = self._values.get("aspect_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height to resize the source image to. Must be set if height is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height to resize the source image to. Must be set if height is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''Sets constraints for the image resize.

        Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''Sets constraints for the image resize.

        Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width to resize the source image to. Must be set if width is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width to resize the source image to. Must be set if width is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualResize(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualResizeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualResizeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a5f78bd4f4eacf7071908c25e0eeb469651adb422ad94ed345de4360217a61d6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualResizeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__28bad7e58578fca1f329f776c36f63f7af9d543325be7200d6931e77660a7831)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualResizeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b4875b8e216ffd65274141b7e86afa4207148a079502f367907808d961f382d0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0cbf09f842859cd977f4224110d32966b97a290a043470288f1ac5bcad0f6688)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7b6b52e84b38b1d66f74205a95b8996e20f74e0d936c717065cfff4fbdfe21e6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualResize]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualResize]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualResize]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9b9a51c4d6da3ae478c81d3793adaa78f020f44a7fb61909ae9e57f90f26edc5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualResizeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualResizeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__47f7c422078f1e04ab705ec94f4f8cc6c3352aed572f88abbc6b710e91b9b7c3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAspect")
    def reset_aspect(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspect", []))

    @jsii.member(jsii_name="resetAspectVar")
    def reset_aspect_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspectVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="aspectInput")
    def aspect_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "aspectInput"))

    @builtins.property
    @jsii.member(jsii_name="aspectVarInput")
    def aspect_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "aspectVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="aspect")
    def aspect(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "aspect"))

    @aspect.setter
    def aspect(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d6c13b33254da071d0e14a5319cb876a6f7ac8e6884a5522d0fffba182b6eed4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "aspect", value)

    @builtins.property
    @jsii.member(jsii_name="aspectVar")
    def aspect_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "aspectVar"))

    @aspect_var.setter
    def aspect_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e54b250d603a2078e8f21c8804f316cdf6f4b0442f5ea77deb1f059bf6996485)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "aspectVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0f9ca5f9731738cbb8e2602cdb4cd64f1d0971114ababbf8e999b7e2af4ece41)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__db2886a486fc08501c9f41e6d03292370a3db54cc7fd25abc24bce63e2393957)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8f5d82f9bbfd86291078aea86fbd0ae25b3187e4e62d50051aea23c27f2379c9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c6105f976c06ea3f2a0c2c6e391b67669a8f3215a43f1fb9f3beade6d6f9ab22)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__404ff1af5471ab1365bae0a8cc652c14cd4e415e05c1867dd6884bc9858581ab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__18daa1a2823ca93c8c762db86075689431e7ad040af79554e37e144d4fbffc1e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualResize]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualResize]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualResize]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__de6a7a6c3c316655e6a8b714423add32e1fa41cee22d04d23061f4f326799fbd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualRotate",
    jsii_struct_bases=[],
    name_mapping={"degrees": "degrees", "degrees_var": "degreesVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualRotate:
    def __init__(
        self,
        *,
        degrees: typing.Optional[builtins.str] = None,
        degrees_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param degrees: The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees DataAkamaiImagingPolicyImage#degrees}
        :param degrees_var: The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees_var DataAkamaiImagingPolicyImage#degrees_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6afefa96650be8f2a2f70956c12838dee9a3b66953d83b43527e0ca02ab8eda1)
            check_type(argname="argument degrees", value=degrees, expected_type=type_hints["degrees"])
            check_type(argname="argument degrees_var", value=degrees_var, expected_type=type_hints["degrees_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if degrees is not None:
            self._values["degrees"] = degrees
        if degrees_var is not None:
            self._values["degrees_var"] = degrees_var

    @builtins.property
    def degrees(self) -> typing.Optional[builtins.str]:
        '''The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees DataAkamaiImagingPolicyImage#degrees}
        '''
        result = self._values.get("degrees")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def degrees_var(self) -> typing.Optional[builtins.str]:
        '''The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees_var DataAkamaiImagingPolicyImage#degrees_var}
        '''
        result = self._values.get("degrees_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualRotate(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualRotateList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualRotateList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__11313f798ecf6b5ff02aa2e15a07ce0ee9bebc04ebcf4b5c5be3615aecf0ab9a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualRotateOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bf5746d4ad8a000464d63fe3324320972f7fcbf1ae54ddcdd8ea9efdfa5bbd31)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualRotateOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ec0269851251e318e5f43c71ee37a7b5960b6937e34f625be6c91acc9f5aa395)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__613ae38443d22fa9933f8db111f6236c64d2edce585a062114418fafe8f76d1c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__73ea7253ae7a533f9962f16a948e8bd229b5385a2e135155a15038a958663016)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualRotate]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualRotate]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualRotate]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f9afb14f739ad06229f9e102c3019b869c2cbefb18c63c441445427991566a47)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualRotateOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualRotateOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6ca5d0848a6d9bed7e0eb0251cda1ff806794ad5ab9a4e80515ed33749dfcc58)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetDegrees")
    def reset_degrees(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDegrees", []))

    @jsii.member(jsii_name="resetDegreesVar")
    def reset_degrees_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDegreesVar", []))

    @builtins.property
    @jsii.member(jsii_name="degreesInput")
    def degrees_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "degreesInput"))

    @builtins.property
    @jsii.member(jsii_name="degreesVarInput")
    def degrees_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "degreesVarInput"))

    @builtins.property
    @jsii.member(jsii_name="degrees")
    def degrees(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "degrees"))

    @degrees.setter
    def degrees(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af686b20316befb956d857f49449f1551830b06e6cb26b6f905627209fc5d927)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "degrees", value)

    @builtins.property
    @jsii.member(jsii_name="degreesVar")
    def degrees_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "degreesVar"))

    @degrees_var.setter
    def degrees_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__87a9a0dce2c6af47245f627b47e9732bb34e85b94c1712b2c6a499ed3c45b8f2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "degreesVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualRotate]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualRotate]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualRotate]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d85c805e58763b494925dc2cf8d9596bc6720fae19c5f0a1b33de2d101fa9d54)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualScale",
    jsii_struct_bases=[],
    name_mapping={
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualScale:
    def __init__(
        self,
        *,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param height: Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged. Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged. Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__37759fc7756320533af5edaff5161614f54763ee5ea3a3156acc04d3274ab8a0)
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size.

        Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size.

        Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged.

        Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged.

        Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualScale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualScaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualScaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fd01d6f373325fbaa3c4e7d7be53181d34669c5ae51d8f3c47e939d08c15bdf0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualScaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4fb14f8178266d441b8543617ff66a8ecf8c1326ba8164a29719c8c04b2c48b6)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualScaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e07ec4d96e26c84b605c4ef0fd80b6e71118ef28effbf97f820f25c15fc70e05)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__72d6732b5947233082ca529835aaaf93412d370cbd7f0d5aa696f47115ce4007)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f39c26026ee8412fc5eb47715daf2816580a39d9c616d1ee6c73da305dc24228)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualScale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualScale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualScale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d6e415c65360c5425b899c10fc210f8a7285ce2ef31014ba74ee1849420855eb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualScaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualScaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__563bd08ffe6aadcaf9e5718be4849589117d6c9394f145496c0f30c75039afee)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__07ae1a2c0fe61383e9bf54b42f6e070480b49be50a1202becd9f0f14ef0eb21c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a9df3dd102af20edb2724acc1d26efcee1a4058b5c815d9b213babd105aad62d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__69eb4df080850268cdbc4375e76b2a0a1ce1c3695bede4b506a3dbbc9626c064)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__136a0c0e1d274dbf84a246bfcaf04a4bf81e4a3ca0b27b379ac5b04afb90be62)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualScale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualScale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualScale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c72a212b98770fb0567df30c1f1cd0cb34685ef62768f13c0f2ee87b1bbc6143)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualShear",
    jsii_struct_bases=[],
    name_mapping={
        "x_shear": "xShear",
        "x_shear_var": "xShearVar",
        "y_shear": "yShear",
        "y_shear_var": "yShearVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualShear:
    def __init__(
        self,
        *,
        x_shear: typing.Optional[builtins.str] = None,
        x_shear_var: typing.Optional[builtins.str] = None,
        y_shear: typing.Optional[builtins.str] = None,
        y_shear_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param x_shear: The amount to shear along the x-axis, measured in multiples of the image's width. Must be set if yShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear DataAkamaiImagingPolicyImage#x_shear}
        :param x_shear_var: The amount to shear along the x-axis, measured in multiples of the image's width. Must be set if yShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear_var DataAkamaiImagingPolicyImage#x_shear_var}
        :param y_shear: The amount to shear along the y-axis, measured in multiples of the image's height. Must be set if xShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear DataAkamaiImagingPolicyImage#y_shear}
        :param y_shear_var: The amount to shear along the y-axis, measured in multiples of the image's height. Must be set if xShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear_var DataAkamaiImagingPolicyImage#y_shear_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e9ea4f5a7fbeb919443ccf5764231a9b03f8842ac1c1cad7f045a8ff78a6ec6b)
            check_type(argname="argument x_shear", value=x_shear, expected_type=type_hints["x_shear"])
            check_type(argname="argument x_shear_var", value=x_shear_var, expected_type=type_hints["x_shear_var"])
            check_type(argname="argument y_shear", value=y_shear, expected_type=type_hints["y_shear"])
            check_type(argname="argument y_shear_var", value=y_shear_var, expected_type=type_hints["y_shear_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if x_shear is not None:
            self._values["x_shear"] = x_shear
        if x_shear_var is not None:
            self._values["x_shear_var"] = x_shear_var
        if y_shear is not None:
            self._values["y_shear"] = y_shear
        if y_shear_var is not None:
            self._values["y_shear_var"] = y_shear_var

    @builtins.property
    def x_shear(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the x-axis, measured in multiples of the image's width.

        Must be set if yShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear DataAkamaiImagingPolicyImage#x_shear}
        '''
        result = self._values.get("x_shear")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_shear_var(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the x-axis, measured in multiples of the image's width.

        Must be set if yShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear_var DataAkamaiImagingPolicyImage#x_shear_var}
        '''
        result = self._values.get("x_shear_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_shear(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the y-axis, measured in multiples of the image's height.

        Must be set if xShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear DataAkamaiImagingPolicyImage#y_shear}
        '''
        result = self._values.get("y_shear")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_shear_var(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the y-axis, measured in multiples of the image's height.

        Must be set if xShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear_var DataAkamaiImagingPolicyImage#y_shear_var}
        '''
        result = self._values.get("y_shear_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualShear(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualShearList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualShearList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a631d58113888a162832dddb6c0533edd76ac3f29e4e8be095f7032f0dd788ad)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualShearOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5896c53807180e7e148e989e42c2b65735499b4ae23f238fd924d7fd9933a7d9)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualShearOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__75e25cb71de62d480e49df5d6a5adeef7bbaa5c1247b2a33feab580205672f30)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ff2724f2dcb5b050b24bc2fd3e3d3c4270f0b20cb9e8c3d7d0544d568ade653)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__832e84715d24670c5f7ed232487df546923598c7b4b35e4531cec0cef0211980)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualShear]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualShear]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualShear]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dcd4d18a3efd8d86250badb58d6531cc879e30b6fb9e330388ee784c2525da6b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualShearOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualShearOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__57209e447f5b25965ec1d1351dc3486140a143b72017fcee58de4323797a1007)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetXShear")
    def reset_x_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXShear", []))

    @jsii.member(jsii_name="resetXShearVar")
    def reset_x_shear_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXShearVar", []))

    @jsii.member(jsii_name="resetYShear")
    def reset_y_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYShear", []))

    @jsii.member(jsii_name="resetYShearVar")
    def reset_y_shear_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYShearVar", []))

    @builtins.property
    @jsii.member(jsii_name="xShearInput")
    def x_shear_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xShearInput"))

    @builtins.property
    @jsii.member(jsii_name="xShearVarInput")
    def x_shear_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xShearVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yShearInput")
    def y_shear_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yShearInput"))

    @builtins.property
    @jsii.member(jsii_name="yShearVarInput")
    def y_shear_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yShearVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xShear")
    def x_shear(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xShear"))

    @x_shear.setter
    def x_shear(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e957bea3163d7c361461a4a7c277ee9316edbf88b9e483b6b0bb6b53a420d13a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xShear", value)

    @builtins.property
    @jsii.member(jsii_name="xShearVar")
    def x_shear_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xShearVar"))

    @x_shear_var.setter
    def x_shear_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__849c1d46c61f2da61255f249c8052d40414cd6bf7dc1d4d5c1bceec049c4a453)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xShearVar", value)

    @builtins.property
    @jsii.member(jsii_name="yShear")
    def y_shear(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yShear"))

    @y_shear.setter
    def y_shear(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__65fed47e8a19be336f30ce571f66bc7c08cfedd13efb9393748a6b08a9bd92f5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yShear", value)

    @builtins.property
    @jsii.member(jsii_name="yShearVar")
    def y_shear_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yShearVar"))

    @y_shear_var.setter
    def y_shear_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3231a0c6b200464364330aa11aef5467f2034ad75b8c2004c50d85fa464d4a84)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yShearVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualShear]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualShear]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualShear]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6b14d950d0a38eed198e4ff3cb1ddf66293f4722c75267875339c64e145136f3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualTrim",
    jsii_struct_bases=[],
    name_mapping={
        "fuzz": "fuzz",
        "fuzz_var": "fuzzVar",
        "padding": "padding",
        "padding_var": "paddingVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualTrim:
    def __init__(
        self,
        *,
        fuzz: typing.Optional[builtins.str] = None,
        fuzz_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fuzz: The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz DataAkamaiImagingPolicyImage#fuzz}
        :param fuzz_var: The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz_var DataAkamaiImagingPolicyImage#fuzz_var}
        :param padding: The amount of padding in pixels to add to the trimmed image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: The amount of padding in pixels to add to the trimmed image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__28166d905582924764adddcf82da4f31597fb0d114c9c0d6e8fc435b79cf37a7)
            check_type(argname="argument fuzz", value=fuzz, expected_type=type_hints["fuzz"])
            check_type(argname="argument fuzz_var", value=fuzz_var, expected_type=type_hints["fuzz_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fuzz is not None:
            self._values["fuzz"] = fuzz
        if fuzz_var is not None:
            self._values["fuzz_var"] = fuzz_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var

    @builtins.property
    def fuzz(self) -> typing.Optional[builtins.str]:
        '''The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz DataAkamaiImagingPolicyImage#fuzz}
        '''
        result = self._values.get("fuzz")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fuzz_var(self) -> typing.Optional[builtins.str]:
        '''The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz_var DataAkamaiImagingPolicyImage#fuzz_var}
        '''
        result = self._values.get("fuzz_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''The amount of padding in pixels to add to the trimmed image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''The amount of padding in pixels to add to the trimmed image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualTrim(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualTrimList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualTrimList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4fb7c87e8a563d225e4917537bfa13dafc92bcb8c590c8a7d6bebe5737eee37e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualTrimOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__880fb326d129e945ed6f6a6f94d492d1065cbbf38eac7cd13888634d29ab2845)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualTrimOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fd6b5e5b3fe5bf86897705cfeee6c450e660ee781e77f233aacf924dd916e54c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2c5229140443ddb027649d2448d4f56fb555f04f34873ab956f5aafaef582817)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__61f2e8c27c500710ecae0546d73cc011f3ea20770b422839560b29f5d8e0eadf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualTrim]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualTrim]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualTrim]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__02626a0d05d7676ccd29104361cef1c94ef4a0d231dc0495c5e145d60024de59)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualTrimOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualTrimOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f49aec4d7236076a8e5bf0f16b2733e668a4562c79f8008d4fce6ce5bfbaf824)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetFuzz")
    def reset_fuzz(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFuzz", []))

    @jsii.member(jsii_name="resetFuzzVar")
    def reset_fuzz_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFuzzVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @builtins.property
    @jsii.member(jsii_name="fuzzInput")
    def fuzz_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fuzzInput"))

    @builtins.property
    @jsii.member(jsii_name="fuzzVarInput")
    def fuzz_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fuzzVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="fuzz")
    def fuzz(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fuzz"))

    @fuzz.setter
    def fuzz(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f00ac13db8874a9e33b01d9c0b73f3d7b1e206fb307fe6abd01dfd6bb357398f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fuzz", value)

    @builtins.property
    @jsii.member(jsii_name="fuzzVar")
    def fuzz_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fuzzVar"))

    @fuzz_var.setter
    def fuzz_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e7a41f12b07b9367ee79c2d0e147e3837c674562ce7257c9893b5d60fb8ce5ee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fuzzVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2e3722a0751da385a6d1f6b5770a7744cfd62465f591fe4178beea08f21f9e34)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8d01627bf02bce609b54e9b512eee3c5d46f584229994880b00f7fb4f8a2b0d6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualTrim]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualTrim]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualTrim]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b616b478ca345c6f06273075ed8841949466c59b05d517bfcca88a908fdda664)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualUnsharpMask",
    jsii_struct_bases=[],
    name_mapping={
        "gain": "gain",
        "gain_var": "gainVar",
        "sigma": "sigma",
        "sigma_var": "sigmaVar",
        "threshold": "threshold",
        "threshold_var": "thresholdVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualUnsharpMask:
    def __init__(
        self,
        *,
        gain: typing.Optional[builtins.str] = None,
        gain_var: typing.Optional[builtins.str] = None,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
        threshold: typing.Optional[builtins.str] = None,
        threshold_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param gain: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        :param gain_var: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        :param sigma: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        :param threshold: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        :param threshold_var: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0b6f3eef6f629e8162b44e1ed99dbce9c31ad2ccf96e0c0fb8233ae861382218)
            check_type(argname="argument gain", value=gain, expected_type=type_hints["gain"])
            check_type(argname="argument gain_var", value=gain_var, expected_type=type_hints["gain_var"])
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
            check_type(argname="argument threshold", value=threshold, expected_type=type_hints["threshold"])
            check_type(argname="argument threshold_var", value=threshold_var, expected_type=type_hints["threshold_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if gain is not None:
            self._values["gain"] = gain
        if gain_var is not None:
            self._values["gain_var"] = gain_var
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var
        if threshold is not None:
            self._values["threshold"] = threshold
        if threshold_var is not None:
            self._values["threshold_var"] = threshold_var

    @builtins.property
    def gain(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        '''
        result = self._values.get("gain")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gain_var(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        '''
        result = self._values.get("gain_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        '''
        result = self._values.get("threshold")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold_var(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        result = self._values.get("threshold_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualUnsharpMask(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualUnsharpMaskList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualUnsharpMaskList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ed0a5d004c87459fe00b4429572b207a3a4e328ffac5d906092c1a06e1a2b5e4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualUnsharpMaskOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__815d623b8f21b368c749ad0b967ad067ab58619954eeaa547f0ca5f709ee4de2)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualUnsharpMaskOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__676062a69d7c9c401f68cecbd80899dd8c9d7a00f17ead0dbd83dd634f1c1b21)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ae7ad84ea014533fdcf81e9200f54aa507f84ae3aaf621e5b3e71129e95d55ee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b78c80cce26d66ef5fea32a36737f8a16881fb148063ccdd9650eb3af4f7b3a5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualUnsharpMask]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualUnsharpMask]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualUnsharpMask]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8c13f52abe1377fd6d55717e67a0397f988fdf2d90cf848bab0fac86984d72fa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualUnsharpMaskOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualUnsharpMaskOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3906992880d0e6482b45b83371cf573a674593acd24404c9fc66ca12827fb604)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetGain")
    def reset_gain(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGain", []))

    @jsii.member(jsii_name="resetGainVar")
    def reset_gain_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGainVar", []))

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @jsii.member(jsii_name="resetThreshold")
    def reset_threshold(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThreshold", []))

    @jsii.member(jsii_name="resetThresholdVar")
    def reset_threshold_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThresholdVar", []))

    @builtins.property
    @jsii.member(jsii_name="gainInput")
    def gain_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainInput"))

    @builtins.property
    @jsii.member(jsii_name="gainVarInput")
    def gain_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdInput")
    def threshold_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdVarInput")
    def threshold_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gain")
    def gain(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gain"))

    @gain.setter
    def gain(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bf89761faff1a469794dfdd1f971f8129e9ee7f32be30a7c792ea56c8fcf4c07)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gain", value)

    @builtins.property
    @jsii.member(jsii_name="gainVar")
    def gain_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gainVar"))

    @gain_var.setter
    def gain_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__93f5dbfc9e552fb1ebd49ef5d0943b7b6a0f3258b208d8a0176fd43757c6be53)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gainVar", value)

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c3f1ee640d603922116105bb5301938a7725cc196f0efdf090abc434726b5cc0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__34f70ab3fdc8aca44d376b84853e065f0da19c04123666f3a70132bdf4f972ec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="threshold")
    def threshold(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "threshold"))

    @threshold.setter
    def threshold(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7a5fcf462730b2782d22c7b28be17e3b76bd0216133642fdf37f1ef06812e03a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "threshold", value)

    @builtins.property
    @jsii.member(jsii_name="thresholdVar")
    def threshold_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "thresholdVar"))

    @threshold_var.setter
    def threshold_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8cf365f8e057d69f4aa1fa1cb1feb0c36c183348eec236b25e84aa88c8f4f5b7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "thresholdVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualUnsharpMask]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualUnsharpMask]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualUnsharpMask]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__13d891fe2263f72f6daeb2eebf9724ec4960bf347e8e0c1b91d3280332cac8f5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThan",
    jsii_struct_bases=[],
    name_mapping={
        "append": "append",
        "aspect_crop": "aspectCrop",
        "background_color": "backgroundColor",
        "blur": "blur",
        "chroma_key": "chromaKey",
        "composite": "composite",
        "compound": "compound",
        "contrast": "contrast",
        "crop": "crop",
        "face_crop": "faceCrop",
        "feature_crop": "featureCrop",
        "fit_and_fill": "fitAndFill",
        "goop": "goop",
        "grayscale": "grayscale",
        "hsl": "hsl",
        "hsv": "hsv",
        "if_dimension": "ifDimension",
        "if_orientation": "ifOrientation",
        "im_query": "imQuery",
        "max_colors": "maxColors",
        "mirror": "mirror",
        "mono_hue": "monoHue",
        "opacity": "opacity",
        "region_of_interest_crop": "regionOfInterestCrop",
        "relative_crop": "relativeCrop",
        "remove_color": "removeColor",
        "resize": "resize",
        "rotate": "rotate",
        "scale": "scale",
        "shear": "shear",
        "trim": "trim",
        "unsharp_mask": "unsharpMask",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThan:
    def __init__(
        self,
        *,
        append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanAppend", typing.Dict[builtins.str, typing.Any]]]]] = None,
        aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanAspectCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanBackgroundColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanBlur", typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanChromaKey", typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanComposite", typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanCompound", typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanContrast", typing.Dict[builtins.str, typing.Any]]]]] = None,
        crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanFaceCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanFeatureCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanFitAndFill", typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanGoop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanGrayscale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanHsl", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanHsv", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimension", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientation", typing.Dict[builtins.str, typing.Any]]]]] = None,
        im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanImQuery", typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanMaxColors", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanMirror", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanMonoHue", typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanOpacity", typing.Dict[builtins.str, typing.Any]]]]] = None,
        region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanRegionOfInterestCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanRelativeCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanRemoveColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanResize", typing.Dict[builtins.str, typing.Any]]]]] = None,
        rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanRotate", typing.Dict[builtins.str, typing.Any]]]]] = None,
        scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanScale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanShear", typing.Dict[builtins.str, typing.Any]]]]] = None,
        trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanTrim", typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanUnsharpMask", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param append: append block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        :param aspect_crop: aspect_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param crop: crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        :param face_crop: face_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        :param feature_crop: feature_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        :param fit_and_fill: fit_and_fill block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param im_query: im_query block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param region_of_interest_crop: region_of_interest_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        :param relative_crop: relative_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param resize: resize block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        :param rotate: rotate block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        :param scale: scale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param shear: shear block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        :param trim: trim block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a7ac5e999d9a47352a900b51e03abbd053b774096c0b6659e3dbf4bc06311b73)
            check_type(argname="argument append", value=append, expected_type=type_hints["append"])
            check_type(argname="argument aspect_crop", value=aspect_crop, expected_type=type_hints["aspect_crop"])
            check_type(argname="argument background_color", value=background_color, expected_type=type_hints["background_color"])
            check_type(argname="argument blur", value=blur, expected_type=type_hints["blur"])
            check_type(argname="argument chroma_key", value=chroma_key, expected_type=type_hints["chroma_key"])
            check_type(argname="argument composite", value=composite, expected_type=type_hints["composite"])
            check_type(argname="argument compound", value=compound, expected_type=type_hints["compound"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument crop", value=crop, expected_type=type_hints["crop"])
            check_type(argname="argument face_crop", value=face_crop, expected_type=type_hints["face_crop"])
            check_type(argname="argument feature_crop", value=feature_crop, expected_type=type_hints["feature_crop"])
            check_type(argname="argument fit_and_fill", value=fit_and_fill, expected_type=type_hints["fit_and_fill"])
            check_type(argname="argument goop", value=goop, expected_type=type_hints["goop"])
            check_type(argname="argument grayscale", value=grayscale, expected_type=type_hints["grayscale"])
            check_type(argname="argument hsl", value=hsl, expected_type=type_hints["hsl"])
            check_type(argname="argument hsv", value=hsv, expected_type=type_hints["hsv"])
            check_type(argname="argument if_dimension", value=if_dimension, expected_type=type_hints["if_dimension"])
            check_type(argname="argument if_orientation", value=if_orientation, expected_type=type_hints["if_orientation"])
            check_type(argname="argument im_query", value=im_query, expected_type=type_hints["im_query"])
            check_type(argname="argument max_colors", value=max_colors, expected_type=type_hints["max_colors"])
            check_type(argname="argument mirror", value=mirror, expected_type=type_hints["mirror"])
            check_type(argname="argument mono_hue", value=mono_hue, expected_type=type_hints["mono_hue"])
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument region_of_interest_crop", value=region_of_interest_crop, expected_type=type_hints["region_of_interest_crop"])
            check_type(argname="argument relative_crop", value=relative_crop, expected_type=type_hints["relative_crop"])
            check_type(argname="argument remove_color", value=remove_color, expected_type=type_hints["remove_color"])
            check_type(argname="argument resize", value=resize, expected_type=type_hints["resize"])
            check_type(argname="argument rotate", value=rotate, expected_type=type_hints["rotate"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument shear", value=shear, expected_type=type_hints["shear"])
            check_type(argname="argument trim", value=trim, expected_type=type_hints["trim"])
            check_type(argname="argument unsharp_mask", value=unsharp_mask, expected_type=type_hints["unsharp_mask"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if append is not None:
            self._values["append"] = append
        if aspect_crop is not None:
            self._values["aspect_crop"] = aspect_crop
        if background_color is not None:
            self._values["background_color"] = background_color
        if blur is not None:
            self._values["blur"] = blur
        if chroma_key is not None:
            self._values["chroma_key"] = chroma_key
        if composite is not None:
            self._values["composite"] = composite
        if compound is not None:
            self._values["compound"] = compound
        if contrast is not None:
            self._values["contrast"] = contrast
        if crop is not None:
            self._values["crop"] = crop
        if face_crop is not None:
            self._values["face_crop"] = face_crop
        if feature_crop is not None:
            self._values["feature_crop"] = feature_crop
        if fit_and_fill is not None:
            self._values["fit_and_fill"] = fit_and_fill
        if goop is not None:
            self._values["goop"] = goop
        if grayscale is not None:
            self._values["grayscale"] = grayscale
        if hsl is not None:
            self._values["hsl"] = hsl
        if hsv is not None:
            self._values["hsv"] = hsv
        if if_dimension is not None:
            self._values["if_dimension"] = if_dimension
        if if_orientation is not None:
            self._values["if_orientation"] = if_orientation
        if im_query is not None:
            self._values["im_query"] = im_query
        if max_colors is not None:
            self._values["max_colors"] = max_colors
        if mirror is not None:
            self._values["mirror"] = mirror
        if mono_hue is not None:
            self._values["mono_hue"] = mono_hue
        if opacity is not None:
            self._values["opacity"] = opacity
        if region_of_interest_crop is not None:
            self._values["region_of_interest_crop"] = region_of_interest_crop
        if relative_crop is not None:
            self._values["relative_crop"] = relative_crop
        if remove_color is not None:
            self._values["remove_color"] = remove_color
        if resize is not None:
            self._values["resize"] = resize
        if rotate is not None:
            self._values["rotate"] = rotate
        if scale is not None:
            self._values["scale"] = scale
        if shear is not None:
            self._values["shear"] = shear
        if trim is not None:
            self._values["trim"] = trim
        if unsharp_mask is not None:
            self._values["unsharp_mask"] = unsharp_mask

    @builtins.property
    def append(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanAppend"]]]:
        '''append block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        '''
        result = self._values.get("append")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanAppend"]]], result)

    @builtins.property
    def aspect_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanAspectCrop"]]]:
        '''aspect_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        '''
        result = self._values.get("aspect_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanAspectCrop"]]], result)

    @builtins.property
    def background_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanBackgroundColor"]]]:
        '''background_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        '''
        result = self._values.get("background_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanBackgroundColor"]]], result)

    @builtins.property
    def blur(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanBlur"]]]:
        '''blur block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        '''
        result = self._values.get("blur")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanBlur"]]], result)

    @builtins.property
    def chroma_key(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanChromaKey"]]]:
        '''chroma_key block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        '''
        result = self._values.get("chroma_key")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanChromaKey"]]], result)

    @builtins.property
    def composite(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanComposite"]]]:
        '''composite block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        '''
        result = self._values.get("composite")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanComposite"]]], result)

    @builtins.property
    def compound(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanCompound"]]]:
        '''compound block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        '''
        result = self._values.get("compound")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanCompound"]]], result)

    @builtins.property
    def contrast(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanContrast"]]]:
        '''contrast block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanContrast"]]], result)

    @builtins.property
    def crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanCrop"]]]:
        '''crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        '''
        result = self._values.get("crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanCrop"]]], result)

    @builtins.property
    def face_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanFaceCrop"]]]:
        '''face_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        '''
        result = self._values.get("face_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanFaceCrop"]]], result)

    @builtins.property
    def feature_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanFeatureCrop"]]]:
        '''feature_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        '''
        result = self._values.get("feature_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanFeatureCrop"]]], result)

    @builtins.property
    def fit_and_fill(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanFitAndFill"]]]:
        '''fit_and_fill block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        '''
        result = self._values.get("fit_and_fill")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanFitAndFill"]]], result)

    @builtins.property
    def goop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanGoop"]]]:
        '''goop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        '''
        result = self._values.get("goop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanGoop"]]], result)

    @builtins.property
    def grayscale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanGrayscale"]]]:
        '''grayscale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        '''
        result = self._values.get("grayscale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanGrayscale"]]], result)

    @builtins.property
    def hsl(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanHsl"]]]:
        '''hsl block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        '''
        result = self._values.get("hsl")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanHsl"]]], result)

    @builtins.property
    def hsv(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanHsv"]]]:
        '''hsv block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        '''
        result = self._values.get("hsv")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanHsv"]]], result)

    @builtins.property
    def if_dimension(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimension"]]]:
        '''if_dimension block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        '''
        result = self._values.get("if_dimension")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimension"]]], result)

    @builtins.property
    def if_orientation(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientation"]]]:
        '''if_orientation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        '''
        result = self._values.get("if_orientation")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientation"]]], result)

    @builtins.property
    def im_query(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanImQuery"]]]:
        '''im_query block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        '''
        result = self._values.get("im_query")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanImQuery"]]], result)

    @builtins.property
    def max_colors(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanMaxColors"]]]:
        '''max_colors block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        '''
        result = self._values.get("max_colors")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanMaxColors"]]], result)

    @builtins.property
    def mirror(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanMirror"]]]:
        '''mirror block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        '''
        result = self._values.get("mirror")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanMirror"]]], result)

    @builtins.property
    def mono_hue(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanMonoHue"]]]:
        '''mono_hue block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        '''
        result = self._values.get("mono_hue")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanMonoHue"]]], result)

    @builtins.property
    def opacity(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanOpacity"]]]:
        '''opacity block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanOpacity"]]], result)

    @builtins.property
    def region_of_interest_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanRegionOfInterestCrop"]]]:
        '''region_of_interest_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        '''
        result = self._values.get("region_of_interest_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanRegionOfInterestCrop"]]], result)

    @builtins.property
    def relative_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanRelativeCrop"]]]:
        '''relative_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        '''
        result = self._values.get("relative_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanRelativeCrop"]]], result)

    @builtins.property
    def remove_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanRemoveColor"]]]:
        '''remove_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        '''
        result = self._values.get("remove_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanRemoveColor"]]], result)

    @builtins.property
    def resize(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanResize"]]]:
        '''resize block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        '''
        result = self._values.get("resize")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanResize"]]], result)

    @builtins.property
    def rotate(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanRotate"]]]:
        '''rotate block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        '''
        result = self._values.get("rotate")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanRotate"]]], result)

    @builtins.property
    def scale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanScale"]]]:
        '''scale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanScale"]]], result)

    @builtins.property
    def shear(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanShear"]]]:
        '''shear block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        '''
        result = self._values.get("shear")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanShear"]]], result)

    @builtins.property
    def trim(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanTrim"]]]:
        '''trim block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        '''
        result = self._values.get("trim")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanTrim"]]], result)

    @builtins.property
    def unsharp_mask(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanUnsharpMask"]]]:
        '''unsharp_mask block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        result = self._values.get("unsharp_mask")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanUnsharpMask"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanAppend",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_priority": "gravityPriority",
        "gravity_priority_var": "gravityPriorityVar",
        "gravity_var": "gravityVar",
        "preserve_minor_dimension": "preserveMinorDimension",
        "preserve_minor_dimension_var": "preserveMinorDimensionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanAppend:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanAppendImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_priority: typing.Optional[builtins.str] = None,
        gravity_priority_var: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        preserve_minor_dimension: typing.Optional[builtins.str] = None,
        preserve_minor_dimension_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Specifies where to place the ``image`` relative to the source image. The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_priority: Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal. The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority DataAkamaiImagingPolicyImage#gravity_priority}
        :param gravity_priority_var: Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal. The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority_var DataAkamaiImagingPolicyImage#gravity_priority_var}
        :param gravity_var: Specifies where to place the ``image`` relative to the source image. The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param preserve_minor_dimension: Whether to preserve the source image's minor dimension, ``false`` by default. The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension DataAkamaiImagingPolicyImage#preserve_minor_dimension}
        :param preserve_minor_dimension_var: Whether to preserve the source image's minor dimension, ``false`` by default. The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension_var DataAkamaiImagingPolicyImage#preserve_minor_dimension_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanAppendImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb80d97906bb2f2040869e6531ca774c4a33c6ff9f393d3a403444639bf3697d)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_priority", value=gravity_priority, expected_type=type_hints["gravity_priority"])
            check_type(argname="argument gravity_priority_var", value=gravity_priority_var, expected_type=type_hints["gravity_priority_var"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument preserve_minor_dimension", value=preserve_minor_dimension, expected_type=type_hints["preserve_minor_dimension"])
            check_type(argname="argument preserve_minor_dimension_var", value=preserve_minor_dimension_var, expected_type=type_hints["preserve_minor_dimension_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_priority is not None:
            self._values["gravity_priority"] = gravity_priority
        if gravity_priority_var is not None:
            self._values["gravity_priority_var"] = gravity_priority_var
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if preserve_minor_dimension is not None:
            self._values["preserve_minor_dimension"] = preserve_minor_dimension
        if preserve_minor_dimension_var is not None:
            self._values["preserve_minor_dimension_var"] = preserve_minor_dimension_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanAppendImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanAppendImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Specifies where to place the ``image`` relative to the source image.

        The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_priority(self) -> typing.Optional[builtins.str]:
        '''Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal.

        The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority DataAkamaiImagingPolicyImage#gravity_priority}
        '''
        result = self._values.get("gravity_priority")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_priority_var(self) -> typing.Optional[builtins.str]:
        '''Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal.

        The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority_var DataAkamaiImagingPolicyImage#gravity_priority_var}
        '''
        result = self._values.get("gravity_priority_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Specifies where to place the ``image`` relative to the source image.

        The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def preserve_minor_dimension(self) -> typing.Optional[builtins.str]:
        '''Whether to preserve the source image's minor dimension, ``false`` by default.

        The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension DataAkamaiImagingPolicyImage#preserve_minor_dimension}
        '''
        result = self._values.get("preserve_minor_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def preserve_minor_dimension_var(self) -> typing.Optional[builtins.str]:
        '''Whether to preserve the source image's minor dimension, ``false`` by default.

        The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension_var DataAkamaiImagingPolicyImage#preserve_minor_dimension_var}
        '''
        result = self._values.get("preserve_minor_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanAppend(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanAppendImage",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanAppendImage:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanAppendImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanAppendImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanAppendImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c5315a2039af813aab762d2e867f116315ff0315654749589536a256bec48b89)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanAppendImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanAppendImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanAppendImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__91fbb93c347dad80f1b5d56676c6ab5d9e3a2b075650cd5937d1d5ebd75f1227)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanAppendList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanAppendList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b0ac4939f02e8f4627ada2e6ce6eec3312efa906ce36496f2fd8925c031614d4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanAppendOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9c737238d5fe34234abe057dbc62159ed6967ecdb408e986bed66ab80a075d6d)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanAppendOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0d0979d2d663a2d478e07dbdc10427397a5a7a920e78420854f152bf64a4227f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4d0c34a7c395ea0d65b539c0f5708fdfc82420046f5155ffe38286ba38d22102)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__816bc4c0c46baa4a8d3432196e676d55edd6a0661f1a11a41ba9d9fe434f5344)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanAppend]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanAppend]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanAppend]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c33e5e071f2a0962552e3f72fb9ec655d35d2271e5f1e4c2b97e63aae1e74792)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanAppendOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanAppendOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3d7e5873abbbd1742677ebbe3fed01d86f1c07ec9eaf6107af216b039efd828e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanAppendImage()

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityPriority")
    def reset_gravity_priority(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityPriority", []))

    @jsii.member(jsii_name="resetGravityPriorityVar")
    def reset_gravity_priority_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityPriorityVar", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPreserveMinorDimension")
    def reset_preserve_minor_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPreserveMinorDimension", []))

    @jsii.member(jsii_name="resetPreserveMinorDimensionVar")
    def reset_preserve_minor_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPreserveMinorDimensionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanAppendImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanAppendImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityInput")
    def gravity_priority_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityPriorityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityVarInput")
    def gravity_priority_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityPriorityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanAppendImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanAppendImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionInput")
    def preserve_minor_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "preserveMinorDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionVarInput")
    def preserve_minor_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "preserveMinorDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab8b54dc7a69d9eb840262bb5085d68d8329323c5e1aca12809ed3663e536761)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityPriority")
    def gravity_priority(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityPriority"))

    @gravity_priority.setter
    def gravity_priority(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c51d29072090411057467c4d64eb65cc0ea7b29c7043822b877d599cb718e1e5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityPriority", value)

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityVar")
    def gravity_priority_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityPriorityVar"))

    @gravity_priority_var.setter
    def gravity_priority_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac7d55d1802982aef7dc027b9e078128e2c0167be4785a76a5fd057398d82e87)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityPriorityVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__415991b2d77b6a73da671621c3c5b29cf2a8ab531dee8775784481fa0f440857)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimension")
    def preserve_minor_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "preserveMinorDimension"))

    @preserve_minor_dimension.setter
    def preserve_minor_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0fe800f042161afecebe2b0f03990ac2690b6e864c63f4ce830ed142aedb27f5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "preserveMinorDimension", value)

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionVar")
    def preserve_minor_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "preserveMinorDimensionVar"))

    @preserve_minor_dimension_var.setter
    def preserve_minor_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0c4a0f97fe87320985f95f9f96e573ac2b55a9e317e0159eb96831158427ac39)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "preserveMinorDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanAppend]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanAppend]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanAppend]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4f6c910a5f6a71982be430ba19a9d623950899e76c96b0368038d3ef3ce4bea2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanAspectCrop",
    jsii_struct_bases=[],
    name_mapping={
        "allow_expansion": "allowExpansion",
        "allow_expansion_var": "allowExpansionVar",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanAspectCrop:
    def __init__(
        self,
        *,
        allow_expansion: typing.Optional[builtins.str] = None,
        allow_expansion_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_expansion: Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image. Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        :param allow_expansion_var: Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image. Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        :param height: The height term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The width term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        :param x_position: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c41c636f895939c22d97522a636a3cca941cda01c69a38e96fd68c7dc47d9a5d)
            check_type(argname="argument allow_expansion", value=allow_expansion, expected_type=type_hints["allow_expansion"])
            check_type(argname="argument allow_expansion_var", value=allow_expansion_var, expected_type=type_hints["allow_expansion_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if allow_expansion is not None:
            self._values["allow_expansion"] = allow_expansion
        if allow_expansion_var is not None:
            self._values["allow_expansion_var"] = allow_expansion_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def allow_expansion(self) -> typing.Optional[builtins.str]:
        '''Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image.

        Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        '''
        result = self._values.get("allow_expansion")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def allow_expansion_var(self) -> typing.Optional[builtins.str]:
        '''Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image.

        Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        '''
        result = self._values.get("allow_expansion_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanAspectCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanAspectCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanAspectCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__07ad1cbf6d03c59738d0f211b27b6a4cb0f4a0fb939ce97435dc3aa8d9086ff6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanAspectCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a9dc8a847fcb3ce84cbf21cca3303084bdc19e60316922445b9a994990b0d058)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanAspectCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__88e3fa0177c5785532a08ff2b42ed6c9df37e41872981876fe4ea78ad6e498bc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__26aabea78020d89735f4d687b6251af93705ff356929b7ac7367edea0ee00528)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d9037039afb953d29a6371c56f56c7cdf40237ecba361183d4e7bceda6ee200)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanAspectCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanAspectCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanAspectCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ede34826be6e9ba3977bf493936758dd0b42b57c534de1195a50fd923d7536a8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanAspectCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanAspectCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cf26ecdcce88e18bbbb5d0a02903aebf5c715f1de89b88df97d0cf104a376a6b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAllowExpansion")
    def reset_allow_expansion(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansion", []))

    @jsii.member(jsii_name="resetAllowExpansionVar")
    def reset_allow_expansion_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansionVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionInput")
    def allow_expansion_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVarInput")
    def allow_expansion_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansion")
    def allow_expansion(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansion"))

    @allow_expansion.setter
    def allow_expansion(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__70bd13adc739957bf916f4e8c640e62898b0c6730fa6115c17b829390d385a01)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansion", value)

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVar")
    def allow_expansion_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansionVar"))

    @allow_expansion_var.setter
    def allow_expansion_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__643fa1cb59873b45e16e7815330dbfcf44b12425a649d71d39e89ecd4c00927d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansionVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3039fcbea11a46b1119930fd3876c1a6f03ef08d1cf117fd5be6044557afa58c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__81590eec40b0cb8cee08d98dcb8961263e3d707f44e21d9b93515d07bbbc27ae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ed2b8913523d78a8758cd8be94baeb52893c1f90e86af9f8e542059e5f725f39)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__511276667ee40aabb58397f830b1b67a86037836b01979a5cd96bdaedede5479)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aebf2989182573d1e2e9aec7795b075ead7ddceef06e4ff5a0eec285183b4a3b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__410509a1b0f945790fe70300b5781f05ecbb434eddebe354ed9c1246305720b6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c1b197309991dab812a89cd7d6b881372c4afbecbb25de9f4caeaa982a2ddd93)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__21f4ff701aa457c334caef18dc1703ed3b7ef30908d0ccc9817a48ce9f41700d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanAspectCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanAspectCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanAspectCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b0ba0795ad00a083a6000fbe10bb5e6f1096c2a36ecf262831459d8ce260596c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanBackgroundColor",
    jsii_struct_bases=[],
    name_mapping={"color": "color", "color_var": "colorVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanBackgroundColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aef22a8aa13e09136bc86d48cc710b1ab13243728a4ecb8913f34c42bb515634)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanBackgroundColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanBackgroundColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanBackgroundColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d013ea2b149ade2ccb08b84f58458190ad1264e6043611848d3c403339fb9cc)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanBackgroundColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__18e99ec14642f3c61fb013db47f6841b3c29bdb3e43b907ef3ef6dc3a29a1890)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanBackgroundColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ec55815c60a7bbd463a0af00152f318ffdce227b2529b14207b71cc2da2473f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__313777e4bf05c8531c7216678d64bd9f4f3859bf40f891e47714fcedfb81841a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a1cd5b976aa13e40220466202fe5a3ad1a723d3585f0f47c4a83285ec892a7e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanBackgroundColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanBackgroundColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f98adb1f6626773cad7801fead82afec8a8ab9155ebbb8ebc5e285253aecd7f3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanBackgroundColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanBackgroundColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__debf0bd29bfd0ce381e7dcf4156094af35a3a590b1e01b279ff4eb3b4995d6a4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f45eb8e28d2889cce547a3c7037f73cd8b30d697def7a687192b3721842962ec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d4def1cf5109f948f1fa91331b080ce55343ede60aac5a91344dd05f95858463)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanBackgroundColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanBackgroundColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanBackgroundColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__984a6151c9fc0eb37828653f97124084eea42be1390f3a347e5c8b5e65fba05e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanBlur",
    jsii_struct_bases=[],
    name_mapping={"sigma": "sigma", "sigma_var": "sigmaVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanBlur:
    def __init__(
        self,
        *,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param sigma: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5426ddfc889b671004c8a3c3cf4367cead5f1c4ae4294a60fc691e6df26a1e98)
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanBlur(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanBlurList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanBlurList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d9620dc845a27c36e00ed2e31d9b4ea3ecb3e1bcdb05ca93bb8ef2772c7e4b5c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanBlurOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9b17f5de548d45882f3dfda8a036b96f52fbe341a60ee05ebff07f4726912d39)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanBlurOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__659a381deae46fc72ed8af1d3bc5e2f5e7bc6251794dd1eb67334a249f20be38)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4d46064cb51bd2396076a08ec20909d3a7d8b0646300fcdc426ec3ce0dbbabc1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0777f4e6c01a17dd858dab5860621c66f519a09aa5532dcdf2d24a049c8b74cc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanBlur]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanBlur]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__db1390fdc1dc21b86413ebe8fa13d57c15d16a4f589248c7895e176a24d1ed7e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanBlurOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanBlurOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__15f7ee577a2935f6ce5a957e712d7a9b42c1532e48588969b0bd2e250518740b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__93b0ea0c75801a6c566e7f09ba156b5b90ffe4eaf0ff8e57ffe9470bb13384f7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e3e3cf995ad2f90220a3b6969f78f15b02c8b0f7c6115b307014e8fe4830ca5c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanBlur]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanBlur]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanBlur]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6b5e15993a69b54aabd776b1a85be2220d3ee77941196bc682df24adadcbcace)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanChromaKey",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_feather": "hueFeather",
        "hue_feather_var": "hueFeatherVar",
        "hue_tolerance": "hueTolerance",
        "hue_tolerance_var": "hueToleranceVar",
        "hue_var": "hueVar",
        "lightness_feather": "lightnessFeather",
        "lightness_feather_var": "lightnessFeatherVar",
        "lightness_tolerance": "lightnessTolerance",
        "lightness_tolerance_var": "lightnessToleranceVar",
        "saturation_feather": "saturationFeather",
        "saturation_feather_var": "saturationFeatherVar",
        "saturation_tolerance": "saturationTolerance",
        "saturation_tolerance_var": "saturationToleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanChromaKey:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_feather: typing.Optional[builtins.str] = None,
        hue_feather_var: typing.Optional[builtins.str] = None,
        hue_tolerance: typing.Optional[builtins.str] = None,
        hue_tolerance_var: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness_feather: typing.Optional[builtins.str] = None,
        lightness_feather_var: typing.Optional[builtins.str] = None,
        lightness_tolerance: typing.Optional[builtins.str] = None,
        lightness_tolerance_var: typing.Optional[builtins.str] = None,
        saturation_feather: typing.Optional[builtins.str] = None,
        saturation_feather_var: typing.Optional[builtins.str] = None,
        saturation_tolerance: typing.Optional[builtins.str] = None,
        saturation_tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_feather: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        :param hue_feather_var: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        :param hue_tolerance: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        :param hue_tolerance_var: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        :param hue_var: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness_feather: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        :param lightness_feather_var: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        :param lightness_tolerance: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        :param lightness_tolerance_var: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        :param saturation_feather: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        :param saturation_feather_var: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        :param saturation_tolerance: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        :param saturation_tolerance_var: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3467b4addb07bad8a050b07811e2ab17cddba97580605f101cd1f25a4ff1b203)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_feather", value=hue_feather, expected_type=type_hints["hue_feather"])
            check_type(argname="argument hue_feather_var", value=hue_feather_var, expected_type=type_hints["hue_feather_var"])
            check_type(argname="argument hue_tolerance", value=hue_tolerance, expected_type=type_hints["hue_tolerance"])
            check_type(argname="argument hue_tolerance_var", value=hue_tolerance_var, expected_type=type_hints["hue_tolerance_var"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness_feather", value=lightness_feather, expected_type=type_hints["lightness_feather"])
            check_type(argname="argument lightness_feather_var", value=lightness_feather_var, expected_type=type_hints["lightness_feather_var"])
            check_type(argname="argument lightness_tolerance", value=lightness_tolerance, expected_type=type_hints["lightness_tolerance"])
            check_type(argname="argument lightness_tolerance_var", value=lightness_tolerance_var, expected_type=type_hints["lightness_tolerance_var"])
            check_type(argname="argument saturation_feather", value=saturation_feather, expected_type=type_hints["saturation_feather"])
            check_type(argname="argument saturation_feather_var", value=saturation_feather_var, expected_type=type_hints["saturation_feather_var"])
            check_type(argname="argument saturation_tolerance", value=saturation_tolerance, expected_type=type_hints["saturation_tolerance"])
            check_type(argname="argument saturation_tolerance_var", value=saturation_tolerance_var, expected_type=type_hints["saturation_tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_feather is not None:
            self._values["hue_feather"] = hue_feather
        if hue_feather_var is not None:
            self._values["hue_feather_var"] = hue_feather_var
        if hue_tolerance is not None:
            self._values["hue_tolerance"] = hue_tolerance
        if hue_tolerance_var is not None:
            self._values["hue_tolerance_var"] = hue_tolerance_var
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness_feather is not None:
            self._values["lightness_feather"] = lightness_feather
        if lightness_feather_var is not None:
            self._values["lightness_feather_var"] = lightness_feather_var
        if lightness_tolerance is not None:
            self._values["lightness_tolerance"] = lightness_tolerance
        if lightness_tolerance_var is not None:
            self._values["lightness_tolerance_var"] = lightness_tolerance_var
        if saturation_feather is not None:
            self._values["saturation_feather"] = saturation_feather
        if saturation_feather_var is not None:
            self._values["saturation_feather_var"] = saturation_feather_var
        if saturation_tolerance is not None:
            self._values["saturation_tolerance"] = saturation_tolerance
        if saturation_tolerance_var is not None:
            self._values["saturation_tolerance_var"] = saturation_tolerance_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        '''
        result = self._values.get("hue_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        '''
        result = self._values.get("hue_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        '''
        result = self._values.get("hue_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        '''
        result = self._values.get("hue_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        '''
        result = self._values.get("lightness_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        '''
        result = self._values.get("lightness_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        '''
        result = self._values.get("lightness_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        '''
        result = self._values.get("lightness_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        '''
        result = self._values.get("saturation_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        '''
        result = self._values.get("saturation_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        '''
        result = self._values.get("saturation_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        result = self._values.get("saturation_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanChromaKey(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanChromaKeyList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanChromaKeyList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c7fc18666145f3396a2a480e21687734b6bdf0a0f4adcbc0361f41ce27e0d897)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanChromaKeyOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3e05b8a502feab186c62b1b9a54b30985355fc70db4757af2cf431f02a9bed28)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanChromaKeyOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__149a52d904d974ea1cac7cd97677efa6e6e45906b169bd53f7f8895d2e5e1848)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f6ae69077b1f6e75a07c78c64451d8f951b544a845080de9ad9f53a5a5c73321)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__69b3427387ed930b6b91ee0abd2f40d2d0cc73ebf865c26a17fe9a18718b341d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanChromaKey]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanChromaKey]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5412a774cd0fb633406c39e20165e6fcdf43ced2aa9a5855e8d4fd2f4d22d861)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanChromaKeyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanChromaKeyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4c512f8650e005b5d0c9b001777428b29aad5054deacc57ef5d17c66e421ca21)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueFeather")
    def reset_hue_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeather", []))

    @jsii.member(jsii_name="resetHueFeatherVar")
    def reset_hue_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeatherVar", []))

    @jsii.member(jsii_name="resetHueTolerance")
    def reset_hue_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueTolerance", []))

    @jsii.member(jsii_name="resetHueToleranceVar")
    def reset_hue_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueToleranceVar", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightnessFeather")
    def reset_lightness_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeather", []))

    @jsii.member(jsii_name="resetLightnessFeatherVar")
    def reset_lightness_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeatherVar", []))

    @jsii.member(jsii_name="resetLightnessTolerance")
    def reset_lightness_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessTolerance", []))

    @jsii.member(jsii_name="resetLightnessToleranceVar")
    def reset_lightness_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessToleranceVar", []))

    @jsii.member(jsii_name="resetSaturationFeather")
    def reset_saturation_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeather", []))

    @jsii.member(jsii_name="resetSaturationFeatherVar")
    def reset_saturation_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeatherVar", []))

    @jsii.member(jsii_name="resetSaturationTolerance")
    def reset_saturation_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationTolerance", []))

    @jsii.member(jsii_name="resetSaturationToleranceVar")
    def reset_saturation_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherInput")
    def hue_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVarInput")
    def hue_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceInput")
    def hue_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVarInput")
    def hue_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherInput")
    def lightness_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVarInput")
    def lightness_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceInput")
    def lightness_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVarInput")
    def lightness_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherInput")
    def saturation_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVarInput")
    def saturation_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceInput")
    def saturation_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVarInput")
    def saturation_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5e71a8b3d85d9b7484e76fd1387ff1aebc24fb6a05aa70f394b60266f2daef5c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeather")
    def hue_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeather"))

    @hue_feather.setter
    def hue_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4bcc52c9c0c867cad16141b7d9dee72e052155c8e578f655dc11f1139180e4d5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeather", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVar")
    def hue_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeatherVar"))

    @hue_feather_var.setter
    def hue_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fe114b95ef133949c1a31f169d5c46dcc6fa618686dd3c4f8ae3ee39cb161f55)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueTolerance")
    def hue_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueTolerance"))

    @hue_tolerance.setter
    def hue_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5e1abf13044d2455f8060ba7a2503e6a58649027fb192621e2b08b024bc1b718)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVar")
    def hue_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueToleranceVar"))

    @hue_tolerance_var.setter
    def hue_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2485e268addc128c15fe5d20af62d1a83fee9c90a7792167282689040e0d4b86)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__036e0e779aa9d4eaff2c75a5c937ad7f39db7b2871e8bf66790f7c585e7ed1ef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeather")
    def lightness_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeather"))

    @lightness_feather.setter
    def lightness_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2e8ddda59d08e6f4aec0058bd2e35385f3157fc116145f74c735614a8ea43907)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeather", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVar")
    def lightness_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeatherVar"))

    @lightness_feather_var.setter
    def lightness_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f3c3aff36d633f2e03e0fe48c463944a47a6ecf24ea3ada8e33a1019ddddc965)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessTolerance")
    def lightness_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessTolerance"))

    @lightness_tolerance.setter
    def lightness_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ddf2c368f909e68e9a84d6d7bc0962cf3270dba1894c6108814c42c3dfb665dd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVar")
    def lightness_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessToleranceVar"))

    @lightness_tolerance_var.setter
    def lightness_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__222bec223dd01074b97e6acd317f5fab2818d9d79f6847af28678df9752cb750)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeather")
    def saturation_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeather"))

    @saturation_feather.setter
    def saturation_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__45b7d1dfeda09fdb8f09ea15180b372150653a51470153af1c8073b2481a8e80)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeather", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVar")
    def saturation_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeatherVar"))

    @saturation_feather_var.setter
    def saturation_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__035baba163519d566c1d4220739a61ef6df432c452b8382d7521d9e04eb33af0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationTolerance")
    def saturation_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationTolerance"))

    @saturation_tolerance.setter
    def saturation_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ff36c84a24d61223905d71e215dc0bba19f5e8c61bb9261cdff9b571ef7a417)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVar")
    def saturation_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationToleranceVar"))

    @saturation_tolerance_var.setter
    def saturation_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5260d653c298611cbaaa9c9677ec56c8e23347350c633bc0a33b8a9abf04f950)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanChromaKey]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanChromaKey]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanChromaKey]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b93311ee4e541b935a6c49d7ddd3ee775b8f9988f3d600e96f5fdbf4c24fecba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanComposite",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "placement": "placement",
        "placement_var": "placementVar",
        "scale": "scale",
        "scale_dimension": "scaleDimension",
        "scale_dimension_var": "scaleDimensionVar",
        "scale_var": "scaleVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanComposite:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanCompositeImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        placement: typing.Optional[builtins.str] = None,
        placement_var: typing.Optional[builtins.str] = None,
        scale: typing.Optional[builtins.str] = None,
        scale_dimension: typing.Optional[builtins.str] = None,
        scale_dimension_var: typing.Optional[builtins.str] = None,
        scale_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param placement: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        :param placement_var: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        :param scale: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param scale_dimension: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        :param scale_dimension_var: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        :param scale_var: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        :param x_position: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanCompositeImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__da44ae5c8a1c283ac7bd297ada40b1d156830d54fed70cc83436a0566a015ac1)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument placement", value=placement, expected_type=type_hints["placement"])
            check_type(argname="argument placement_var", value=placement_var, expected_type=type_hints["placement_var"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument scale_dimension", value=scale_dimension, expected_type=type_hints["scale_dimension"])
            check_type(argname="argument scale_dimension_var", value=scale_dimension_var, expected_type=type_hints["scale_dimension_var"])
            check_type(argname="argument scale_var", value=scale_var, expected_type=type_hints["scale_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if placement is not None:
            self._values["placement"] = placement
        if placement_var is not None:
            self._values["placement_var"] = placement_var
        if scale is not None:
            self._values["scale"] = scale
        if scale_dimension is not None:
            self._values["scale_dimension"] = scale_dimension
        if scale_dimension_var is not None:
            self._values["scale_dimension_var"] = scale_dimension_var
        if scale_var is not None:
            self._values["scale_var"] = scale_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanCompositeImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanCompositeImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        '''
        result = self._values.get("placement")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement_var(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        '''
        result = self._values.get("placement_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        '''
        result = self._values.get("scale_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        '''
        result = self._values.get("scale_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        '''
        result = self._values.get("scale_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanComposite(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanCompositeImage",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanCompositeImage:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanCompositeImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanCompositeImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanCompositeImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7f204ade8b37e71763705cd7cd5a12cef6311f8f9322a8c99630f3787b108f8c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanCompositeImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanCompositeImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__74bb3f5aa5c28dcbdbf033ed55a52f0783df0a6f24004d4d76d6803f200cf530)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanCompositeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanCompositeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d89fcd0e45e804f173cd370428f96c774e3e62620564a5b2e1a1befaad20fbc)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanCompositeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ed61a9158496cebbd7a639588e6f58cd95b6d2ac30eb5a5ff97fcc5a17f5f73)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanCompositeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f198d86b361c545227661c24bb3ab10c46b2484bb828f5c716b901f9bc824321)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__218293be1005fdf1ebb5c6ba179fbd0bb5f419661ae76a932eed5464cb2ca8c0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__702392f70cea6af4bbfaeccd17243195a3e4f39fa55c573f6167cf0f878aefd0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanComposite]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanComposite]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0a0ada1e9ebf2ce66cf204741e52d28c7224dcbc6d501b49d83f09593eeb482b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanCompositeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanCompositeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__229ade5fe06cd1bf0aa0860f3c271befc56309ace2bb8c13a4719c7618f24046)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanCompositeImage()

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPlacement")
    def reset_placement(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacement", []))

    @jsii.member(jsii_name="resetPlacementVar")
    def reset_placement_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacementVar", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetScaleDimension")
    def reset_scale_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimension", []))

    @jsii.member(jsii_name="resetScaleDimensionVar")
    def reset_scale_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimensionVar", []))

    @jsii.member(jsii_name="resetScaleVar")
    def reset_scale_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanCompositeImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanCompositeImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanCompositeImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="placementInput")
    def placement_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementInput"))

    @builtins.property
    @jsii.member(jsii_name="placementVarInput")
    def placement_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionInput")
    def scale_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVarInput")
    def scale_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleVarInput")
    def scale_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__40d4a6858fe5b2ae94567721739655ecb00dbf586343fbd3bebb135f71988390)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__22dbddebcf3f84f9242eaed66b9f6d25789b655e49863c64ff386bd68c6541f2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="placement")
    def placement(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placement"))

    @placement.setter
    def placement(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5bf4420b3def86f4b90dd0548fad5092f7a019f6ac8f54d0f66496cd0e3cbf98)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placement", value)

    @builtins.property
    @jsii.member(jsii_name="placementVar")
    def placement_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placementVar"))

    @placement_var.setter
    def placement_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__215881249e2a78e1483a5cbec1ed67853dbe55452d705ef0748e608a3bde771c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placementVar", value)

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scale"))

    @scale.setter
    def scale(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fcf6a39e812a69ae40c5a8a313d32c12b2739d985785734087502e76b6624f54)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scale", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimension")
    def scale_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimension"))

    @scale_dimension.setter
    def scale_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7a03890230d01c37f6758bc79b7105a462346faee51a341ddb015ad854b6e5b2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimension", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVar")
    def scale_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimensionVar"))

    @scale_dimension_var.setter
    def scale_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2f1498b64bf20bbf8f1d9a1a1a6431665c79b466bca53efb323a5747d9e8063e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="scaleVar")
    def scale_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleVar"))

    @scale_var.setter
    def scale_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__88167b76f2014712e64bc20a8d24cbedcc47ed56b4ae132a1c34434fee2508d8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__70383cf9b4145f1ccb27b460dd72b4b3b852c0db37e2b6f2ae9b9afb6e3943d2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8cf48f2f41c63c6591874bc63744ed07b37207cc8d3ed3bbddc8786ba08aac87)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__85f4145c25813bc3b14f922d4d83eed2fd337f08750324ed0436634186bd4f41)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__975150e445ea2558d7908f4c419db19598599783f95f511d7f392c05c2750ab6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanComposite]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanComposite]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanComposite]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__29393eb9ec7c7f76f7d08b7fc7af47e607661c831d1e22a59f4d8f38606026c5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanCompound",
    jsii_struct_bases=[],
    name_mapping={"transformations": "transformations"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanCompound:
    def __init__(
        self,
        *,
        transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param transformations: transformations block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb8c01512c746d40ed01c26b794863ec3e1bd8b3b30cbebb773f2b02b0f9f92c)
            check_type(argname="argument transformations", value=transformations, expected_type=type_hints["transformations"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if transformations is not None:
            self._values["transformations"] = transformations

    @builtins.property
    def transformations(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanCompoundTransformations"]]]:
        '''transformations block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        result = self._values.get("transformations")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanCompoundTransformations"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanCompound(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanCompoundList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanCompoundList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b99a47e00726a8cd5db0ac24448382fc21a706b0b7a1af04946d8171281c21a6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanCompoundOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4f4ce01b95b612563c89b1dad9c84cecb5aa7f5e23e2947849610d5624573f2b)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanCompoundOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c6c01054fdc6afcc92994acdc204fe91bdb5c644baf7ece009b628b4a83539f3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b983ee6da5777a4076d50472333aacc44f993f73e22540ab046036544f2c145c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1447e2b4c412b574a37bfff85247a949e895f6a625da855f8a3a6db927dfc6d2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanCompound]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanCompound]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__24b3457366e31318fb7701bb56c53c5749a8c731e68583d16267eb19fe0ce5f4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanCompoundOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanCompoundOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bf312d47bda72a1fdf358b29a1e158381c001ece23202a3706962cf7df503498)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformations")
    def put_transformations(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d136deca0eebf236c337c1bd705e8f47676228bc2bb4c727c5b8fc30c6117eca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTransformations", [value]))

    @jsii.member(jsii_name="resetTransformations")
    def reset_transformations(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformations", []))

    @builtins.property
    @jsii.member(jsii_name="transformations")
    def transformations(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanCompoundTransformationsList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanCompoundTransformationsList", jsii.get(self, "transformations"))

    @builtins.property
    @jsii.member(jsii_name="transformationsInput")
    def transformations_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanCompoundTransformations"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanCompoundTransformations"]]], jsii.get(self, "transformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanCompound]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanCompound]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanCompound]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2154763641d4efca3962c402436baae824e13ef0daf9bb9e24a43b2aad3a612e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanCompoundTransformations",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanCompoundTransformations:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanCompoundTransformations(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanCompoundTransformationsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanCompoundTransformationsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ba82d06888c5287c5e7b5630f1e23411a3b1f9052b8baf1f08ac6872e0b72aae)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanCompoundTransformationsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c2a42379d801ca888cf735eb555e8203ed29908c89814b0537bc98607472270c)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanCompoundTransformationsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0b64e282d97c975932fd97aa05b548d94c4edf5997491b722b8cafcbf968733a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aca5ddebad150199befc3c1b31fe175f9899dc259eb73e93574580b2aac0d3e2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be9dc2703d44c06cf9a72b53c94b4ce0934b9cc001914fbe908ed1a0fc90a8e0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanCompoundTransformations]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanCompoundTransformations]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanCompoundTransformations]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fc8d3864cdae75fe232663ccffec628705671b4f27ce87d8359cdf9349b865b9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanCompoundTransformationsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanCompoundTransformationsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c3e37b3c5b7792eb5d11068c9994a7fdc5fbd57e35801681465f729f31ced960)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanCompoundTransformations]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanCompoundTransformations]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanCompoundTransformations]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__25637efa0d3dd9656e2b6a2f5dc382b9a57b978f403a5d963d5d99783a1000dc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanContrast",
    jsii_struct_bases=[],
    name_mapping={
        "brightness": "brightness",
        "brightness_var": "brightnessVar",
        "contrast": "contrast",
        "contrast_var": "contrastVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanContrast:
    def __init__(
        self,
        *,
        brightness: typing.Optional[builtins.str] = None,
        brightness_var: typing.Optional[builtins.str] = None,
        contrast: typing.Optional[builtins.str] = None,
        contrast_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param brightness: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        :param brightness_var: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        :param contrast: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param contrast_var: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cca8ff9724c9a54cd5c0a6878f1c62a1c26a472cabc9d5202e50eafc9b0e89f5)
            check_type(argname="argument brightness", value=brightness, expected_type=type_hints["brightness"])
            check_type(argname="argument brightness_var", value=brightness_var, expected_type=type_hints["brightness_var"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument contrast_var", value=contrast_var, expected_type=type_hints["contrast_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if brightness is not None:
            self._values["brightness"] = brightness
        if brightness_var is not None:
            self._values["brightness_var"] = brightness_var
        if contrast is not None:
            self._values["contrast"] = contrast
        if contrast_var is not None:
            self._values["contrast_var"] = contrast_var

    @builtins.property
    def brightness(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        '''
        result = self._values.get("brightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def brightness_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        '''
        result = self._values.get("brightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        result = self._values.get("contrast_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanContrast(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanContrastList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanContrastList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e9722929ae97ad26841601011d020fc88894067105209d915c97b203f597bb0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanContrastOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4175af0cffc3f46a3bb9e3ef297639e517981b4dc9c52d89d0b3f92bdb4bad4c)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanContrastOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b9cd01e9a22dcc5a8b2e55ebe6fa749e9ed62fe69674dd242cd54deef51d517b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__97ac13439aabc5606f1ccb69f31afe0c0edbfe60c38b180ee481d854ee1b761f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea3ba0bd6547f9f6ff9b576d81ef251efbc585da2aec6e7600874814859750ab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanContrast]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanContrast]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6db6603789fd9e4ae0c15788e010189057321b84ebdbc1b1b97b1ac130ac886a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanContrastOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanContrastOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d77002381d657bfca98bd9d8dc47daf23dc0167576b0925342a3c50ed8bb842c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetBrightness")
    def reset_brightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightness", []))

    @jsii.member(jsii_name="resetBrightnessVar")
    def reset_brightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightnessVar", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetContrastVar")
    def reset_contrast_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrastVar", []))

    @builtins.property
    @jsii.member(jsii_name="brightnessInput")
    def brightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="brightnessVarInput")
    def brightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastVarInput")
    def contrast_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="brightness")
    def brightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightness"))

    @brightness.setter
    def brightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb3900116393ece3f119627236a59cd2913e09ec44e76ec4be983a4d286bc724)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightness", value)

    @builtins.property
    @jsii.member(jsii_name="brightnessVar")
    def brightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightnessVar"))

    @brightness_var.setter
    def brightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c9be37594de155a8d0513f75f6165dcfe58379a8287165c4aa6deb336c0706c2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrast"))

    @contrast.setter
    def contrast(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cb2673d645c15f8f10c1eb8af4cea86a32a32c19fd8a158debace17ba27055cc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrast", value)

    @builtins.property
    @jsii.member(jsii_name="contrastVar")
    def contrast_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrastVar"))

    @contrast_var.setter
    def contrast_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4df3ad7919197ea486491572789b1f6c6fd7664edf7bb796d35ada37b9d0d23a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrastVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanContrast]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanContrast]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanContrast]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__012d5e8acbdb8595ad92d6c72a185aaeb7e564bba46d2054e6434c7e4ca7c85b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanCrop",
    jsii_struct_bases=[],
    name_mapping={
        "allow_expansion": "allowExpansion",
        "allow_expansion_var": "allowExpansionVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanCrop:
    def __init__(
        self,
        *,
        allow_expansion: typing.Optional[builtins.str] = None,
        allow_expansion_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_expansion: If cropping an area outside of the existing canvas, expands the image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        :param allow_expansion_var: If cropping an area outside of the existing canvas, expands the image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        :param gravity: Frame of reference for X and Y Positions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Frame of reference for X and Y Positions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The number of pixels to crop along the y-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The number of pixels to crop along the y-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The number of pixels to crop along the x-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The number of pixels to crop along the x-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        :param x_position: The x-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d36bf1265f73c627cddc24caa8803a5f33a9c743ff1aaca6644fa9d6b2cf034f)
            check_type(argname="argument allow_expansion", value=allow_expansion, expected_type=type_hints["allow_expansion"])
            check_type(argname="argument allow_expansion_var", value=allow_expansion_var, expected_type=type_hints["allow_expansion_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if allow_expansion is not None:
            self._values["allow_expansion"] = allow_expansion
        if allow_expansion_var is not None:
            self._values["allow_expansion_var"] = allow_expansion_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def allow_expansion(self) -> typing.Optional[builtins.str]:
        '''If cropping an area outside of the existing canvas, expands the image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        '''
        result = self._values.get("allow_expansion")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def allow_expansion_var(self) -> typing.Optional[builtins.str]:
        '''If cropping an area outside of the existing canvas, expands the image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        '''
        result = self._values.get("allow_expansion_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Frame of reference for X and Y Positions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Frame of reference for X and Y Positions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the y-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the y-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the x-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the x-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8d14635314f88de13fdba616a32589816bfc1502ff1428c4c8b66bd9214a1b58)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8040fb0769d9aafa9a2dc3d24b2ecf6d1d809bd7322ed5c4057cf86da1cc4818)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__077afd6e41504bb50cd98eb7ba35590457272ef4c2deecdf9bae366e982e50bb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__255cad0d02232693b066c0426f674959a77924cf7b0e77c24691d7ac412e0f91)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f7633c9ad2996c2c17b6c2e90328ac1174132fbecbb52d9eb6f941c9d119b913)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__36216fcb021b66e556f3766d560a96318e83c3e7bde6cdbc9af028624dc8a4ac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c6b998f14b6c61295853f006af6775b3c5d468820ef3a8c458df934770cdb3cd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAllowExpansion")
    def reset_allow_expansion(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansion", []))

    @jsii.member(jsii_name="resetAllowExpansionVar")
    def reset_allow_expansion_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansionVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionInput")
    def allow_expansion_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVarInput")
    def allow_expansion_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansion")
    def allow_expansion(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansion"))

    @allow_expansion.setter
    def allow_expansion(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8860af0698f6094849499bb35ac537a0cb952b4762c6f5636d935d4fa0b12adf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansion", value)

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVar")
    def allow_expansion_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansionVar"))

    @allow_expansion_var.setter
    def allow_expansion_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a9d26cc5a6d9ab4c296502e34ea251ffb6f142126d048042e50860b49be320ba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansionVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f1d57287e8628c3e1e5e767c7ecfaefdd4d8494d2c6d8a8225f52b2447c92d1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__141b9bc07eaa87d2c44afb94bca2e6706802868e134993b6c322f6dc73e1aab0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c80d8cca0dc52170f24062450892b8be3ade25fb32cf9a9c640e048b722bf282)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1b003b68ba4ed0e60ea1c2ca9b21fd747f9d694923938d803c5ac4ddc43514a2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aff5ab34edf5b3c17a06c0d3d0a6ef373c460dc32d0b4f144ffe206d48fd3e8a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1a9576bc094f10719ae95f93dee339aab07ed1e8a3935330e04a953ef34d5bc1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cf91b7102a860f981307bc72fbd1083ab32c422f1c8a311d4aedc05d5f8f2a21)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9c13d4833a8926fdd681ed0d75bf4c78bffac0265b9f1f089d215ddb57146e00)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ee0eab0ada0d85e475397a91c230cdc720836e967092c26ea2fa776ff948c60a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4035a58a4c6635f78465cca662892c92b77e03c6fa7d9d853d9676b184714ac6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__408d06a3634a59adc9dbb49a4344fffcd07432d3bf95cdcc393b83096a447b80)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanFaceCrop",
    jsii_struct_bases=[],
    name_mapping={
        "algorithm": "algorithm",
        "algorithm_var": "algorithmVar",
        "confidence": "confidence",
        "confidence_var": "confidenceVar",
        "fail_gravity": "failGravity",
        "fail_gravity_var": "failGravityVar",
        "focus": "focus",
        "focus_var": "focusVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "padding": "padding",
        "padding_var": "paddingVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanFaceCrop:
    def __init__(
        self,
        *,
        algorithm: typing.Optional[builtins.str] = None,
        algorithm_var: typing.Optional[builtins.str] = None,
        confidence: typing.Optional[builtins.str] = None,
        confidence_var: typing.Optional[builtins.str] = None,
        fail_gravity: typing.Optional[builtins.str] = None,
        fail_gravity_var: typing.Optional[builtins.str] = None,
        focus: typing.Optional[builtins.str] = None,
        focus_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param algorithm: Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm DataAkamaiImagingPolicyImage#algorithm}
        :param algorithm_var: Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm_var DataAkamaiImagingPolicyImage#algorithm_var}
        :param confidence: With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image. Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence DataAkamaiImagingPolicyImage#confidence}
        :param confidence_var: With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image. Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence_var DataAkamaiImagingPolicyImage#confidence_var}
        :param fail_gravity: Controls placement of the crop if Image and Video Manager does not detect any faces in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        :param fail_gravity_var: Controls placement of the crop if Image and Video Manager does not detect any faces in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        :param focus: Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus DataAkamaiImagingPolicyImage#focus}
        :param focus_var: Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus_var DataAkamaiImagingPolicyImage#focus_var}
        :param gravity: Controls placement of the crop. Directions are relative to the face(s) plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Controls placement of the crop. Directions are relative to the face(s) plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param padding: The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        :param style: Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af088cdfd596685ab52703f912aa06808683c124f90864f2bef0363ba1dc2892)
            check_type(argname="argument algorithm", value=algorithm, expected_type=type_hints["algorithm"])
            check_type(argname="argument algorithm_var", value=algorithm_var, expected_type=type_hints["algorithm_var"])
            check_type(argname="argument confidence", value=confidence, expected_type=type_hints["confidence"])
            check_type(argname="argument confidence_var", value=confidence_var, expected_type=type_hints["confidence_var"])
            check_type(argname="argument fail_gravity", value=fail_gravity, expected_type=type_hints["fail_gravity"])
            check_type(argname="argument fail_gravity_var", value=fail_gravity_var, expected_type=type_hints["fail_gravity_var"])
            check_type(argname="argument focus", value=focus, expected_type=type_hints["focus"])
            check_type(argname="argument focus_var", value=focus_var, expected_type=type_hints["focus_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if algorithm is not None:
            self._values["algorithm"] = algorithm
        if algorithm_var is not None:
            self._values["algorithm_var"] = algorithm_var
        if confidence is not None:
            self._values["confidence"] = confidence
        if confidence_var is not None:
            self._values["confidence_var"] = confidence_var
        if fail_gravity is not None:
            self._values["fail_gravity"] = fail_gravity
        if fail_gravity_var is not None:
            self._values["fail_gravity_var"] = fail_gravity_var
        if focus is not None:
            self._values["focus"] = focus
        if focus_var is not None:
            self._values["focus_var"] = focus_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def algorithm(self) -> typing.Optional[builtins.str]:
        '''Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm DataAkamaiImagingPolicyImage#algorithm}
        '''
        result = self._values.get("algorithm")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def algorithm_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm_var DataAkamaiImagingPolicyImage#algorithm_var}
        '''
        result = self._values.get("algorithm_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def confidence(self) -> typing.Optional[builtins.str]:
        '''With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image.

        Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence DataAkamaiImagingPolicyImage#confidence}
        '''
        result = self._values.get("confidence")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def confidence_var(self) -> typing.Optional[builtins.str]:
        '''With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image.

        Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence_var DataAkamaiImagingPolicyImage#confidence_var}
        '''
        result = self._values.get("confidence_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any faces in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        '''
        result = self._values.get("fail_gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any faces in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        '''
        result = self._values.get("fail_gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def focus(self) -> typing.Optional[builtins.str]:
        '''Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus DataAkamaiImagingPolicyImage#focus}
        '''
        result = self._values.get("focus")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def focus_var(self) -> typing.Optional[builtins.str]:
        '''Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus_var DataAkamaiImagingPolicyImage#focus_var}
        '''
        result = self._values.get("focus_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the face(s) plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the face(s) plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanFaceCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanFaceCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanFaceCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ff71cbb7edd1a404806709a45c4d86c58103d5e0631e3feffe23719687d91bb9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanFaceCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5cc38d74b54f4848e45c7c47a3093a7323b3be2fb5579425abbbb4d402490362)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanFaceCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b597a19046987ab2c80c2c9fdb7e741ed8f13b42be101c913b13f852a6ff0ee4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__162733a27eefa3d0a6a046d26086f0c737ba11318a946dd2fa27f06919a2454b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__903035a335883ba89c69f369b38764b2e89661b34da591fb709a08271a716e32)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanFaceCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanFaceCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanFaceCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__377f0ee7f3f76da2361241d9f4b71427ba8c6f45dcab7bf643705bad74a39d82)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanFaceCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanFaceCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6a442bd6c49c3f0ccc7f1f70b663745f541a8e484c606458c273ed7d6175a42e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAlgorithm")
    def reset_algorithm(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAlgorithm", []))

    @jsii.member(jsii_name="resetAlgorithmVar")
    def reset_algorithm_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAlgorithmVar", []))

    @jsii.member(jsii_name="resetConfidence")
    def reset_confidence(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetConfidence", []))

    @jsii.member(jsii_name="resetConfidenceVar")
    def reset_confidence_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetConfidenceVar", []))

    @jsii.member(jsii_name="resetFailGravity")
    def reset_fail_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravity", []))

    @jsii.member(jsii_name="resetFailGravityVar")
    def reset_fail_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravityVar", []))

    @jsii.member(jsii_name="resetFocus")
    def reset_focus(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFocus", []))

    @jsii.member(jsii_name="resetFocusVar")
    def reset_focus_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFocusVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="algorithmInput")
    def algorithm_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "algorithmInput"))

    @builtins.property
    @jsii.member(jsii_name="algorithmVarInput")
    def algorithm_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "algorithmVarInput"))

    @builtins.property
    @jsii.member(jsii_name="confidenceInput")
    def confidence_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "confidenceInput"))

    @builtins.property
    @jsii.member(jsii_name="confidenceVarInput")
    def confidence_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "confidenceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityInput")
    def fail_gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityVarInput")
    def fail_gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="focusInput")
    def focus_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "focusInput"))

    @builtins.property
    @jsii.member(jsii_name="focusVarInput")
    def focus_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "focusVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="algorithm")
    def algorithm(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "algorithm"))

    @algorithm.setter
    def algorithm(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8725cc6166d3bf1ef85fc2c0e7526e7b483401d95cba2bd3b61be04f5e982af0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "algorithm", value)

    @builtins.property
    @jsii.member(jsii_name="algorithmVar")
    def algorithm_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "algorithmVar"))

    @algorithm_var.setter
    def algorithm_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5e312696fccdc2462da79fef5e18d8b92fecff6ca24c028bc75b76bed080cb72)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "algorithmVar", value)

    @builtins.property
    @jsii.member(jsii_name="confidence")
    def confidence(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "confidence"))

    @confidence.setter
    def confidence(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f55f53be313f3bccab71a82190c72bdef946d718f829a8813d7bd5925d3e22b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "confidence", value)

    @builtins.property
    @jsii.member(jsii_name="confidenceVar")
    def confidence_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "confidenceVar"))

    @confidence_var.setter
    def confidence_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e9f103c4f1679c902dd99cf6e6d55308cae086dcef749d558b5923560e1b01c3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "confidenceVar", value)

    @builtins.property
    @jsii.member(jsii_name="failGravity")
    def fail_gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravity"))

    @fail_gravity.setter
    def fail_gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7cfa8d7102808786b9305411aa2377984878208c6c5942d7d07230f5ccdd6f4c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravity", value)

    @builtins.property
    @jsii.member(jsii_name="failGravityVar")
    def fail_gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravityVar"))

    @fail_gravity_var.setter
    def fail_gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2e3896707780f230c903427bef5bec45c6c5453d3bbc151330644ebd0789a123)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="focus")
    def focus(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "focus"))

    @focus.setter
    def focus(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f8c95ae0f4749a8df2a16c08a58b4eaab6813f4a1b122ea0e529699045492f66)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "focus", value)

    @builtins.property
    @jsii.member(jsii_name="focusVar")
    def focus_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "focusVar"))

    @focus_var.setter
    def focus_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__11a1c766dbc7f069e4ee1d5194d666811dbcdd2f36eaa773f632af2db89df97a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "focusVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ce779c14222c65ab2520b7d752fa0f56afbfd685611f829bb30a7540266d6cf3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__280acc59da78673fe0ccb995f34c640158a69a4408bdd2a0211d627868395b0f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3c0fdfb37cdb6108d0b16949ec9902d566d1cc3a99220877430b32d6b21eb2e6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__81a8462050ccb035cfcf2b9c74ea5e99b25db3c2f549f2a5119be63f3c8bd725)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d8a39960ed8db2b981dff6a587c9863176287893c42d2e7b87f3d15eade856d1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6c51895d07f76bf90bc120db257d672d37567bee2f30445c014b3931efaebd48)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__867a9749be4ee7df58bb75e1614bd1b6ddf183844bf18853474b791444d9cbf9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__408558fa0ec02d51e63589f09539831ab9dbdc0f63b980a698bf83e38ec57970)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__310570f7383c31a25352c2ab244ced5d94aff68bf13667eac51eed79784bf9d0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ca76af575ac19e778b1d71d8d3cf1955260680c1ba25df1b97a6543ceef2529)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanFaceCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanFaceCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanFaceCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9dd278b5257e505ac6e8b52ac2ea90df34b5c612522c7a8cb7d685b9d9370761)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanFeatureCrop",
    jsii_struct_bases=[],
    name_mapping={
        "fail_gravity": "failGravity",
        "fail_gravity_var": "failGravityVar",
        "feature_radius": "featureRadius",
        "feature_radius_var": "featureRadiusVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "max_features": "maxFeatures",
        "max_features_var": "maxFeaturesVar",
        "min_feature_quality": "minFeatureQuality",
        "min_feature_quality_var": "minFeatureQualityVar",
        "padding": "padding",
        "padding_var": "paddingVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanFeatureCrop:
    def __init__(
        self,
        *,
        fail_gravity: typing.Optional[builtins.str] = None,
        fail_gravity_var: typing.Optional[builtins.str] = None,
        feature_radius: typing.Optional[builtins.str] = None,
        feature_radius_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        max_features: typing.Optional[builtins.str] = None,
        max_features_var: typing.Optional[builtins.str] = None,
        min_feature_quality: typing.Optional[builtins.str] = None,
        min_feature_quality_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fail_gravity: Controls placement of the crop if Image and Video Manager does not detect any features in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        :param fail_gravity_var: Controls placement of the crop if Image and Video Manager does not detect any features in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        :param feature_radius: The size in pixels of the important features to search for. If identified, two features never appear closer together than this value, ``8.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius DataAkamaiImagingPolicyImage#feature_radius}
        :param feature_radius_var: The size in pixels of the important features to search for. If identified, two features never appear closer together than this value, ``8.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius_var DataAkamaiImagingPolicyImage#feature_radius_var}
        :param gravity: Controls placement of the crop. Directions are relative to the region of interest plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Controls placement of the crop. Directions are relative to the region of interest plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param max_features: The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features DataAkamaiImagingPolicyImage#max_features}
        :param max_features_var: The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features_var DataAkamaiImagingPolicyImage#max_features_var}
        :param min_feature_quality: Determines the minimum quality level of the feature identified. To consider a feature important, the feature needs to surpass this value. Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality DataAkamaiImagingPolicyImage#min_feature_quality}
        :param min_feature_quality_var: Determines the minimum quality level of the feature identified. To consider a feature important, the feature needs to surpass this value. Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality_var DataAkamaiImagingPolicyImage#min_feature_quality_var}
        :param padding: Adds space around the region of interest. The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: Adds space around the region of interest. The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        :param style: Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c0f63abce03d6b8de46fc173041f1c7f67834ffc0b60dff657671421e4908995)
            check_type(argname="argument fail_gravity", value=fail_gravity, expected_type=type_hints["fail_gravity"])
            check_type(argname="argument fail_gravity_var", value=fail_gravity_var, expected_type=type_hints["fail_gravity_var"])
            check_type(argname="argument feature_radius", value=feature_radius, expected_type=type_hints["feature_radius"])
            check_type(argname="argument feature_radius_var", value=feature_radius_var, expected_type=type_hints["feature_radius_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument max_features", value=max_features, expected_type=type_hints["max_features"])
            check_type(argname="argument max_features_var", value=max_features_var, expected_type=type_hints["max_features_var"])
            check_type(argname="argument min_feature_quality", value=min_feature_quality, expected_type=type_hints["min_feature_quality"])
            check_type(argname="argument min_feature_quality_var", value=min_feature_quality_var, expected_type=type_hints["min_feature_quality_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fail_gravity is not None:
            self._values["fail_gravity"] = fail_gravity
        if fail_gravity_var is not None:
            self._values["fail_gravity_var"] = fail_gravity_var
        if feature_radius is not None:
            self._values["feature_radius"] = feature_radius
        if feature_radius_var is not None:
            self._values["feature_radius_var"] = feature_radius_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if max_features is not None:
            self._values["max_features"] = max_features
        if max_features_var is not None:
            self._values["max_features_var"] = max_features_var
        if min_feature_quality is not None:
            self._values["min_feature_quality"] = min_feature_quality
        if min_feature_quality_var is not None:
            self._values["min_feature_quality_var"] = min_feature_quality_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def fail_gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any features in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        '''
        result = self._values.get("fail_gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any features in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        '''
        result = self._values.get("fail_gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feature_radius(self) -> typing.Optional[builtins.str]:
        '''The size in pixels of the important features to search for.

        If identified, two features never appear closer together than this value, ``8.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius DataAkamaiImagingPolicyImage#feature_radius}
        '''
        result = self._values.get("feature_radius")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feature_radius_var(self) -> typing.Optional[builtins.str]:
        '''The size in pixels of the important features to search for.

        If identified, two features never appear closer together than this value, ``8.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius_var DataAkamaiImagingPolicyImage#feature_radius_var}
        '''
        result = self._values.get("feature_radius_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the region of interest plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the region of interest plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def max_features(self) -> typing.Optional[builtins.str]:
        '''The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features DataAkamaiImagingPolicyImage#max_features}
        '''
        result = self._values.get("max_features")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def max_features_var(self) -> typing.Optional[builtins.str]:
        '''The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features_var DataAkamaiImagingPolicyImage#max_features_var}
        '''
        result = self._values.get("max_features_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def min_feature_quality(self) -> typing.Optional[builtins.str]:
        '''Determines the minimum quality level of the feature identified.

        To consider a feature important, the feature needs to surpass this value.  Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality DataAkamaiImagingPolicyImage#min_feature_quality}
        '''
        result = self._values.get("min_feature_quality")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def min_feature_quality_var(self) -> typing.Optional[builtins.str]:
        '''Determines the minimum quality level of the feature identified.

        To consider a feature important, the feature needs to surpass this value.  Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality_var DataAkamaiImagingPolicyImage#min_feature_quality_var}
        '''
        result = self._values.get("min_feature_quality_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''Adds space around the region of interest.

        The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''Adds space around the region of interest.

        The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanFeatureCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanFeatureCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanFeatureCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be4c51ca984e0a7c713ea24c3585b66022da1db1525ea688296ac4f5df4f9d83)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanFeatureCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d546b494b7b5364d6f2204b1a98be89b75780b889c61116e4dc9a48a2d61d791)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanFeatureCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f21f120b7e846131d0d842d88b20ec3de72e82add51c18e9fc66d7d805b8e8cd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__04e42771612f67ffe8af6b1f2177efdd987b67ece572668ddcb80056c4ef81ac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d05d88fb6717791a2e8e478a967d0a4571a56cd4a33916c71551ccb1267b3a4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanFeatureCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanFeatureCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanFeatureCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f328d9affba24a6763ba66f3d49c27acfc92b7037b90eb5cfd4fdb375d5bee50)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanFeatureCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanFeatureCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7e9489a4ecbaad59f7a21317a2db7d8a9e82395e51a9bf7d9c732f4e97aa526f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetFailGravity")
    def reset_fail_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravity", []))

    @jsii.member(jsii_name="resetFailGravityVar")
    def reset_fail_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravityVar", []))

    @jsii.member(jsii_name="resetFeatureRadius")
    def reset_feature_radius(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureRadius", []))

    @jsii.member(jsii_name="resetFeatureRadiusVar")
    def reset_feature_radius_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureRadiusVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetMaxFeatures")
    def reset_max_features(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxFeatures", []))

    @jsii.member(jsii_name="resetMaxFeaturesVar")
    def reset_max_features_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxFeaturesVar", []))

    @jsii.member(jsii_name="resetMinFeatureQuality")
    def reset_min_feature_quality(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMinFeatureQuality", []))

    @jsii.member(jsii_name="resetMinFeatureQualityVar")
    def reset_min_feature_quality_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMinFeatureQualityVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="failGravityInput")
    def fail_gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityVarInput")
    def fail_gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featureRadiusInput")
    def feature_radius_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featureRadiusInput"))

    @builtins.property
    @jsii.member(jsii_name="featureRadiusVarInput")
    def feature_radius_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featureRadiusVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesInput")
    def max_features_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "maxFeaturesInput"))

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesVarInput")
    def max_features_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "maxFeaturesVarInput"))

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityInput")
    def min_feature_quality_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "minFeatureQualityInput"))

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityVarInput")
    def min_feature_quality_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "minFeatureQualityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravity")
    def fail_gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravity"))

    @fail_gravity.setter
    def fail_gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd4c10d4b1a0944e970b6e2ba607b1783128f39830742d739ecaaa22b32b43e3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravity", value)

    @builtins.property
    @jsii.member(jsii_name="failGravityVar")
    def fail_gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravityVar"))

    @fail_gravity_var.setter
    def fail_gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__998ded4ea9f97a78a2ab851dde92c427bc165defb913f19dc7c3070551fabefb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="featureRadius")
    def feature_radius(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featureRadius"))

    @feature_radius.setter
    def feature_radius(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a0323a446afd5c2322c62c322f3cd48122868b65fce6a77a718a688a32a78855)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featureRadius", value)

    @builtins.property
    @jsii.member(jsii_name="featureRadiusVar")
    def feature_radius_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featureRadiusVar"))

    @feature_radius_var.setter
    def feature_radius_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__88bc631a2b04bc51197a97c2703bdb9e011d35dff4648f6d379325f98eaf5029)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featureRadiusVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7bcec227037c8c553b44f74bf1264d7b92c52e2eee09d74a81497443637e57cb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__982b0b46da092493b854cfc269262e547f77ad4a5f49df9e59a9ef7cf38f2bec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__728d271a02c470266a9c5a6c6ab992bb993cbe0284b4ba3884771d2ccef3e44e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e3ae50fc63565bdcb384e21032412645f5bce938da71b865f70ba478203e7927)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="maxFeatures")
    def max_features(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "maxFeatures"))

    @max_features.setter
    def max_features(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__81ab4362e06d4178e978de9b5c45d38c28f7667f997154818423eea6ae9d9f8d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "maxFeatures", value)

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesVar")
    def max_features_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "maxFeaturesVar"))

    @max_features_var.setter
    def max_features_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1b9b8cd4ab5cef5f0777ae0d470828692abce860aa691daa64c5a700c2c35582)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "maxFeaturesVar", value)

    @builtins.property
    @jsii.member(jsii_name="minFeatureQuality")
    def min_feature_quality(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "minFeatureQuality"))

    @min_feature_quality.setter
    def min_feature_quality(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f76477f2d96b4a823642fd9ba0df9bb41b3e7e9e68ee7a01e5a382e78cfc6c58)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "minFeatureQuality", value)

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityVar")
    def min_feature_quality_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "minFeatureQualityVar"))

    @min_feature_quality_var.setter
    def min_feature_quality_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__de37378fda43ae6c5f7404bc7f076fba517f8d8d0da6ab6d5d0fe3bd3de09a7a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "minFeatureQualityVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f124e611c4a424d0a34183ae7ca06210b25cb8d10ee80f4187c838f5aa482590)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd0e60bf0a31feda43a11b0c8f886efbcac28a218a8ec6611f0346aa24471f7b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__716a70d5b52732ebbb6071c96d4cf23f75a5599895b315afb421404613268e2c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5c593ab3784b2c415aa3530d9a8470b8cb2294548a265396ebec52f622e08ea0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2798026c5a86613f510f40f9bb950aea3f2df8657b1d4fd4d30e26e141a97a02)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f7a4ad75868e5dab4e1aae6d95ab08a08924fb25a084c07f2594b65aab11cbfe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanFeatureCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanFeatureCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanFeatureCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__900cef3b71980cbc5ff6abf70f50cdb660d26577d642126d036ae62706118cf0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanFitAndFill",
    jsii_struct_bases=[],
    name_mapping={
        "fill_transformation": "fillTransformation",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanFitAndFill:
    def __init__(
        self,
        *,
        fill_transformation: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanFitAndFillFillTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fill_transformation: fill_transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_transformation DataAkamaiImagingPolicyImage#fill_transformation}
        :param height: The height value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The width value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(fill_transformation, dict):
            fill_transformation = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanFitAndFillFillTransformation(**fill_transformation)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac134dd81c5c0f2ae3b4f05d8e5e820ad752a379cd333aeaae2efa7184ac293a)
            check_type(argname="argument fill_transformation", value=fill_transformation, expected_type=type_hints["fill_transformation"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fill_transformation is not None:
            self._values["fill_transformation"] = fill_transformation
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def fill_transformation(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanFitAndFillFillTransformation"]:
        '''fill_transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_transformation DataAkamaiImagingPolicyImage#fill_transformation}
        '''
        result = self._values.get("fill_transformation")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanFitAndFillFillTransformation"], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanFitAndFill(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanFitAndFillFillTransformation",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanFitAndFillFillTransformation:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanFitAndFillFillTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanFitAndFillFillTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanFitAndFillFillTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0beee10a29f9277d0188ad2107e902e6c9facf755e20b4df4b837be0b3abd1f2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanFitAndFillFillTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanFitAndFillFillTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanFitAndFillFillTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b9be605112845108d2c9c4c1542e275eb31dd38c6e1d8a204b067a914b6bc558)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanFitAndFillList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanFitAndFillList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__60321b96bf4829e30b0de4b848481fd9e6b015f6bcd34b4386898a2b0b6210a8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanFitAndFillOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b2490a885c07e1a68dedc87683edc8885f30241b55b256d22fe31da8573a2f90)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanFitAndFillOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1381f5552e96b00d51ee9724ad30cc739dbebdc7bb1c3dbcd450467eeab0cd9b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9e068d362d14287553a7bbc824f9023d6070bb48a6f08c7dd2b9816625e604d6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__afe9f430d116dd7229b1e91ee7b9c47e42fe98df973f3acddff1479f6af15a74)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanFitAndFill]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanFitAndFill]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanFitAndFill]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5fae174a04a652151e10188a436c4da5c045e3e1edcc3bd8b39b6ffe804d7e4c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanFitAndFillOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanFitAndFillOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__92fcade27de9e70dc03ef02051b9c3c2d7d7275cf92c63644d3e15a668357bce)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putFillTransformation")
    def put_fill_transformation(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanFitAndFillFillTransformation()

        return typing.cast(None, jsii.invoke(self, "putFillTransformation", [value]))

    @jsii.member(jsii_name="resetFillTransformation")
    def reset_fill_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFillTransformation", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="fillTransformation")
    def fill_transformation(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanFitAndFillFillTransformationOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanFitAndFillFillTransformationOutputReference, jsii.get(self, "fillTransformation"))

    @builtins.property
    @jsii.member(jsii_name="fillTransformationInput")
    def fill_transformation_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanFitAndFillFillTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanFitAndFillFillTransformation], jsii.get(self, "fillTransformationInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e14e5e8b6215d8b2636d4d07932b10f57654c10db17a788a4770991c42e5afc2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f8be6252078af0384eabbb92325c867cad0f78e3ad5072b123b9686cfca8e3c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__70452798793d8f2be4d763fa468401b2e64ce730c96403cdaa8c642b0e94f936)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__08570382f36c33cef71a652772e05b3aed21b6c044842688a72529ee3efe6f10)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanFitAndFill]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanFitAndFill]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanFitAndFill]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f68db25f8a486b592de857e56fa660b2355c1adb4bb3d59463ab1a2951f85e6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanGoop",
    jsii_struct_bases=[],
    name_mapping={
        "chaos": "chaos",
        "chaos_var": "chaosVar",
        "density": "density",
        "density_var": "densityVar",
        "power": "power",
        "power_var": "powerVar",
        "seed": "seed",
        "seed_var": "seedVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanGoop:
    def __init__(
        self,
        *,
        chaos: typing.Optional[builtins.str] = None,
        chaos_var: typing.Optional[builtins.str] = None,
        density: typing.Optional[builtins.str] = None,
        density_var: typing.Optional[builtins.str] = None,
        power: typing.Optional[builtins.str] = None,
        power_var: typing.Optional[builtins.str] = None,
        seed: typing.Optional[builtins.str] = None,
        seed_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param chaos: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        :param chaos_var: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        :param density: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        :param density_var: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        :param power: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        :param power_var: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        :param seed: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        :param seed_var: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d66646da57447ce369d7c9a4872f913631670dbbff12500da01a8108df320016)
            check_type(argname="argument chaos", value=chaos, expected_type=type_hints["chaos"])
            check_type(argname="argument chaos_var", value=chaos_var, expected_type=type_hints["chaos_var"])
            check_type(argname="argument density", value=density, expected_type=type_hints["density"])
            check_type(argname="argument density_var", value=density_var, expected_type=type_hints["density_var"])
            check_type(argname="argument power", value=power, expected_type=type_hints["power"])
            check_type(argname="argument power_var", value=power_var, expected_type=type_hints["power_var"])
            check_type(argname="argument seed", value=seed, expected_type=type_hints["seed"])
            check_type(argname="argument seed_var", value=seed_var, expected_type=type_hints["seed_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if chaos is not None:
            self._values["chaos"] = chaos
        if chaos_var is not None:
            self._values["chaos_var"] = chaos_var
        if density is not None:
            self._values["density"] = density
        if density_var is not None:
            self._values["density_var"] = density_var
        if power is not None:
            self._values["power"] = power
        if power_var is not None:
            self._values["power_var"] = power_var
        if seed is not None:
            self._values["seed"] = seed
        if seed_var is not None:
            self._values["seed_var"] = seed_var

    @builtins.property
    def chaos(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        '''
        result = self._values.get("chaos")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def chaos_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        '''
        result = self._values.get("chaos_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        '''
        result = self._values.get("density")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density_var(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        '''
        result = self._values.get("density_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        '''
        result = self._values.get("power")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power_var(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        '''
        result = self._values.get("power_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        '''
        result = self._values.get("seed")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed_var(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        result = self._values.get("seed_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanGoop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanGoopList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanGoopList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dd5fc14f60fca5a060cabbd2aa11e6ccc1ca34a236b1244cec71d2922d18a5b5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanGoopOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e5f35f25012c0cb2ed74c7fdcfaf679076f5a7d5fc3bbdcd3f6c0d0b46b3140c)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanGoopOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__006cf1880f459ad475e0d8725b4320562b3072abcfdc6de1a85b03a3ad581611)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fb1228083c8c41ecc980e72d498d6930167225dbda731ecb4194baf5dc197fde)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__505a52a5c4a88d69de2f1cdb767c7d23a14ab5908044f45ade504b7b29101ad6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanGoop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanGoop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9b1eaf56438a58dab57db8d9a6e6133d8c3fe89a3aad1d47769f096bc9c3ff73)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanGoopOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanGoopOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__64d492732a75a6715c8d2bbbecb73c7fd92c3dd68ca9fbdd4efba9c67856a083)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetChaos")
    def reset_chaos(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaos", []))

    @jsii.member(jsii_name="resetChaosVar")
    def reset_chaos_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaosVar", []))

    @jsii.member(jsii_name="resetDensity")
    def reset_density(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensity", []))

    @jsii.member(jsii_name="resetDensityVar")
    def reset_density_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensityVar", []))

    @jsii.member(jsii_name="resetPower")
    def reset_power(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPower", []))

    @jsii.member(jsii_name="resetPowerVar")
    def reset_power_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPowerVar", []))

    @jsii.member(jsii_name="resetSeed")
    def reset_seed(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeed", []))

    @jsii.member(jsii_name="resetSeedVar")
    def reset_seed_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeedVar", []))

    @builtins.property
    @jsii.member(jsii_name="chaosInput")
    def chaos_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosInput"))

    @builtins.property
    @jsii.member(jsii_name="chaosVarInput")
    def chaos_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosVarInput"))

    @builtins.property
    @jsii.member(jsii_name="densityInput")
    def density_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityInput"))

    @builtins.property
    @jsii.member(jsii_name="densityVarInput")
    def density_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="powerInput")
    def power_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerInput"))

    @builtins.property
    @jsii.member(jsii_name="powerVarInput")
    def power_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerVarInput"))

    @builtins.property
    @jsii.member(jsii_name="seedInput")
    def seed_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedInput"))

    @builtins.property
    @jsii.member(jsii_name="seedVarInput")
    def seed_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedVarInput"))

    @builtins.property
    @jsii.member(jsii_name="chaos")
    def chaos(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaos"))

    @chaos.setter
    def chaos(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__55a61bb3dac06b8c5ab6a6d21293f65233326817726a33ed9b28a57aea649a25)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaos", value)

    @builtins.property
    @jsii.member(jsii_name="chaosVar")
    def chaos_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaosVar"))

    @chaos_var.setter
    def chaos_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a119ae5dc4869988f1a8c81ef80e9b2a5013759800e19e35df7f0f7781619070)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaosVar", value)

    @builtins.property
    @jsii.member(jsii_name="density")
    def density(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "density"))

    @density.setter
    def density(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d646485aa0674dcd103a08c62012d3b7b65eecc97130a1ee4cca43775826a294)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "density", value)

    @builtins.property
    @jsii.member(jsii_name="densityVar")
    def density_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "densityVar"))

    @density_var.setter
    def density_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d51ee8d241d5955fb72a96e58d814c4aed5787aabd53d977277afb208ee4789)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "densityVar", value)

    @builtins.property
    @jsii.member(jsii_name="power")
    def power(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "power"))

    @power.setter
    def power(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__68d201054c7c17b33596ee13bca439bb80bce96375aea1b0bf244e413d7261cd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "power", value)

    @builtins.property
    @jsii.member(jsii_name="powerVar")
    def power_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "powerVar"))

    @power_var.setter
    def power_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__51c839b2ee6c2b146cf133f4257d423d2d688814183c5d4f1d185c34d6a68a23)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "powerVar", value)

    @builtins.property
    @jsii.member(jsii_name="seed")
    def seed(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seed"))

    @seed.setter
    def seed(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6c9a46d1e09036ced03a51f1784a6635f9b1c098190b57a6a7c303f46167608d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seed", value)

    @builtins.property
    @jsii.member(jsii_name="seedVar")
    def seed_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seedVar"))

    @seed_var.setter
    def seed_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9355d19a59ee72f3545804133b3c2e657888311296967b526ddf360f35c48b36)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seedVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanGoop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanGoop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanGoop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3bdd696442790048002ef89e02c160203278f4caf28f11246d0634cfa4a80c32)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanGrayscale",
    jsii_struct_bases=[],
    name_mapping={"type": "type", "type_var": "typeVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanGrayscale:
    def __init__(
        self,
        *,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param type: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c7c608e604a6d072df4914fdb0369b065560fdf0f0b9feb4b50773051caff7a9)
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanGrayscale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanGrayscaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanGrayscaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8fc360d82c2e7663cb7130d7027bd4c689ad3dcc42e689c3d50575e35227b963)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanGrayscaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6b293a904dc120ddaa5156753e44b2ffdd620b43310bcdc47f032e3e9522819c)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanGrayscaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b2b1729969d7c87b9073668a4d7c29ef4fbcfb1f7748c0923ba739b3e9bc6a90)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a6826278b743ff9865e1fac1424e15a7b1588e1bd470ad7b24fafabd856e04a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__32760fc7a3f66b237f126c0c24e1f28b3dba7bd9189ba73387a447cef58fdd42)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanGrayscale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanGrayscale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d99641246a8a1fa8990005251f7e374dbb92900b6866e4b2d4dc5197868a1619)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanGrayscaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanGrayscaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f4c5ca7cb5704cd5e080768daeb19e6fdb8d401470b07eb2d7047b2d0a6149a4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e111af595a1acc0b6dabcd15fe0bf1591e5805e33931c0cd9d4120f2a00d9f2d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ab899971cd5b7f78544155703b8163935e68f69896c23542bcd3eb18127c47b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanGrayscale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanGrayscale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanGrayscale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__84e18bdee3d808c53ed8b7e5ae4d3642a5e9410685b68d4c82e1a887b4cef2c9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanHsl",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "lightness": "lightness",
        "lightness_var": "lightnessVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanHsl:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness: typing.Optional[builtins.str] = None,
        lightness_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        :param lightness_var: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a3ef3776ecd02fde81f630bca7b537f264d342df1e0079127dd1d8ba141bf97a)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness", value=lightness, expected_type=type_hints["lightness"])
            check_type(argname="argument lightness_var", value=lightness_var, expected_type=type_hints["lightness_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness is not None:
            self._values["lightness"] = lightness
        if lightness_var is not None:
            self._values["lightness_var"] = lightness_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        '''
        result = self._values.get("lightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        '''
        result = self._values.get("lightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanHsl(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanHslList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanHslList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__653d4b9fdb3eb498a54076ffd676c9a261f69c929e54c55e1fb4fecf1a10d384)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanHslOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ad7d9bbd487dd773034c5280bca279ca574fbd845f22e233e0b305e1c83214c3)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanHslOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f24bade351d68d9b81cd5e7268a8c0c3085180872c721b32412b4ea1ad8f6ac0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb52dcfbf876588df669c5af4631ad8235e3d823dc3090e36d51fc9be919c012)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__46a869f2f483af3b5ee3b2701250b37a69a194180ee98573447437983069b738)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanHsl]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanHsl]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4feef101ad8f62e5c8f4c46f29fea37bed5814985408cba3b2aedff46f22d1a8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanHslOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanHslOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4af812701b9da41935b5b54467471cc8233023a0aebbf00f9142cdcba2e8b398)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightness")
    def reset_lightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightness", []))

    @jsii.member(jsii_name="resetLightnessVar")
    def reset_lightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessInput")
    def lightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessVarInput")
    def lightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__620c00fded33d34daacfbbb6209c04043bda3c1f05d62c983b894eb5a2653a8f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ee5831580f400c85a05e830939f4e72b5f99d6863cc42ffd4f4b7489487429b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightness")
    def lightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightness"))

    @lightness.setter
    def lightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb91215eac605626d1ac912c66c3b9fb3f8a047ed41c8650bb3c513620e3291c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightness", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessVar")
    def lightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessVar"))

    @lightness_var.setter
    def lightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__90a42ea4ad368f113e1b9a0d0b0f66f070c6100d6b3c95e656f19ea5537f0ff9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7e4e313621236657d035d41f654e7d5e3ec097739920136e3812416a20144046)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__80cd3ded4f00cc56bb12c7943ef2a36c4e35f6a541af82db9d18613781c74be8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanHsl]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanHsl]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanHsl]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a893ff3438b06dfb734c3d2607f527fb1c2353c1126d2cea980d4554ffe8f24)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanHsv",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanHsv:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        :param value: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c66298976f09f79db832c6ecd1ef7d20039b4dc036e8a9b55ef2d4bed711cf6c)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanHsv(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanHsvList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanHsvList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__89357340bfcf34a109195712aed32710378c72eb50db446450cda0cd74c9bbdf)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanHsvOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e30bb484aae9a1430bfef44ed14dbea5e6ad723b85d6e9ec11779770b06178ce)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanHsvOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__155c19d8726421bf33443b0761c3fc9cf698c63eeab72e649776314c717b3763)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__910590f1e42ef2f77da087b8b45d6e98a7df48a902dcd00c36aad0d45900b578)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__beff01555530fda9ea275e58617717646ccbd1f148e18a2904d88596a1b78384)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanHsv]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanHsv]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a3f4653e665f64afe5828cf85f86c7bf30c4548e4ef7533844f91fc314dd2f51)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanHsvOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanHsvOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b71f8287efb3dcfaa6dbd769f159ba6287ff8844855021ff73dfaa37dceb0f2b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ca954c94226f7a0b0d1daf639126f79ccd9c425e9ecf6aa02a66344be1467d44)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c8bbb9cd29cdae42ddd8d30e328f10a567345529edca01d73072305ee3932757)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__77b7bb37af6a7848db93509b03d82d41a6b4dc5b0c2c336cf38e43fe822ad44f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__03088f69779eeb0a1f9c0be7d167af69ea08a611062ea4a9f10c232f52e02843)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__069d6b5f2e43917290ac1f5b5a1784ff036a3fccd78ef9bc05258effe1e9b9a8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__49ebed6bb96e87129a19c6c7511bd9251453ffc1ed8621f40afb0a7ce875508b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanHsv]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanHsv]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanHsv]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8fb2eb430092617c5329214cc0147af35e636d2b49f607c7f6c91148dc4153a1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimension",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "dimension": "dimension",
        "dimension_var": "dimensionVar",
        "equal": "equal",
        "greater_than": "greaterThan",
        "less_than": "lessThan",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimension:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        dimension: typing.Optional[builtins.str] = None,
        dimension_var: typing.Optional[builtins.str] = None,
        equal: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionEqual", typing.Dict[builtins.str, typing.Any]]] = None,
        greater_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionGreaterThan", typing.Dict[builtins.str, typing.Any]]] = None,
        less_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionLessThan", typing.Dict[builtins.str, typing.Any]]] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param dimension: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        :param dimension_var: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        :param equal: equal block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        :param greater_than: greater_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        :param less_than: less_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        :param value: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionDefault(**default)
        if isinstance(equal, dict):
            equal = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionEqual(**equal)
        if isinstance(greater_than, dict):
            greater_than = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionGreaterThan(**greater_than)
        if isinstance(less_than, dict):
            less_than = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionLessThan(**less_than)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8b7cec99ec555373b9272783ec0d1ec23ad05a040615d1e267d30ae0c03a8c34)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument dimension", value=dimension, expected_type=type_hints["dimension"])
            check_type(argname="argument dimension_var", value=dimension_var, expected_type=type_hints["dimension_var"])
            check_type(argname="argument equal", value=equal, expected_type=type_hints["equal"])
            check_type(argname="argument greater_than", value=greater_than, expected_type=type_hints["greater_than"])
            check_type(argname="argument less_than", value=less_than, expected_type=type_hints["less_than"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if dimension is not None:
            self._values["dimension"] = dimension
        if dimension_var is not None:
            self._values["dimension_var"] = dimension_var
        if equal is not None:
            self._values["equal"] = equal
        if greater_than is not None:
            self._values["greater_than"] = greater_than
        if less_than is not None:
            self._values["less_than"] = less_than
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionDefault"], result)

    @builtins.property
    def dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        '''
        result = self._values.get("dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        '''
        result = self._values.get("dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def equal(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionEqual"]:
        '''equal block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        '''
        result = self._values.get("equal")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionEqual"], result)

    @builtins.property
    def greater_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionGreaterThan"]:
        '''greater_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        '''
        result = self._values.get("greater_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionGreaterThan"], result)

    @builtins.property
    def less_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionLessThan"]:
        '''less_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        '''
        result = self._values.get("less_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionLessThan"], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimension(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5d916420542b8e47dc34c15a7ea3eb6e65113d096d358bc8bd1c69efbb41557a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__babd3b0eacc1ba76a9411a43ae0f93530207aafc549201c4312b7876cb520545)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionEqual",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionEqual:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionEqual(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionEqualOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionEqualOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__978b95f43df5ae22f04aa61f4bcbfb0b3cd55f91fdfbf8aff71480015c9dc633)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionEqual], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionEqual],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1bb2d12eb1bad2593aa069a78fa597ff6ded85fa4e0cadcb07af5ebe582d0b86)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionGreaterThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionGreaterThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionGreaterThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionGreaterThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionGreaterThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__66df83a06635d9258788e9a313c4ba0fc0d22112cd25f1ac571fe4e4314251a2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionGreaterThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionGreaterThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f0f20da7e229472f1cb40298ad87ca977a72ddd0d4b099c08448d85307b87a17)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionLessThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionLessThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionLessThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionLessThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionLessThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3829c53160770751ef848ef53aeb602b03d8ac86a28c90a9e1374ae904947549)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionLessThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionLessThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d659cba7b0ccef138e9a61d6e238f869594348b80fe80e60c2aaa8fbb82ef2ff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a1cf66d731075c78ba895bfb127cc4562722c14fecd0b25dd9218f9b8c19c2b8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__39d6e606bcad592892fbce84031954958dd2d9c64f28b9b50f8e25a2d54b1781)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c02044a1eadae616afd6f6f817f8b4fc772803def3f3d8f071acc0aa7034e292)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cc765b5e875a0a79ed32b3be08d5164872a70a6eaeaf0aae7bf20d2649df639e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1db285669511a749a82f983bd551ceb5ea181eccb4b948f19a35084e9d1a8897)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimension]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimension]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5b97c263a087d050615d06033dbffd557bacbf314b2d3fb03be4976e2552607a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__65f15643ba90ff4e3ddb6f063770c39ae77c2c23c5d5eaa1008aded597f1f1f8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putEqual")
    def put_equal(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionEqual()

        return typing.cast(None, jsii.invoke(self, "putEqual", [value]))

    @jsii.member(jsii_name="putGreaterThan")
    def put_greater_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionGreaterThan()

        return typing.cast(None, jsii.invoke(self, "putGreaterThan", [value]))

    @jsii.member(jsii_name="putLessThan")
    def put_less_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionLessThan()

        return typing.cast(None, jsii.invoke(self, "putLessThan", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetDimension")
    def reset_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimension", []))

    @jsii.member(jsii_name="resetDimensionVar")
    def reset_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimensionVar", []))

    @jsii.member(jsii_name="resetEqual")
    def reset_equal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEqual", []))

    @jsii.member(jsii_name="resetGreaterThan")
    def reset_greater_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGreaterThan", []))

    @jsii.member(jsii_name="resetLessThan")
    def reset_less_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLessThan", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="equal")
    def equal(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionEqualOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionEqualOutputReference, jsii.get(self, "equal"))

    @builtins.property
    @jsii.member(jsii_name="greaterThan")
    def greater_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionGreaterThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionGreaterThanOutputReference, jsii.get(self, "greaterThan"))

    @builtins.property
    @jsii.member(jsii_name="lessThan")
    def less_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionLessThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionLessThanOutputReference, jsii.get(self, "lessThan"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionInput")
    def dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionVarInput")
    def dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="equalInput")
    def equal_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionEqual], jsii.get(self, "equalInput"))

    @builtins.property
    @jsii.member(jsii_name="greaterThanInput")
    def greater_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionGreaterThan], jsii.get(self, "greaterThanInput"))

    @builtins.property
    @jsii.member(jsii_name="lessThanInput")
    def less_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionLessThan], jsii.get(self, "lessThanInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="dimension")
    def dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimension"))

    @dimension.setter
    def dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b5c798baf6bf17cb29b9942df14bbdf2318cc9ac64e4f884a596506af40af2bc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimension", value)

    @builtins.property
    @jsii.member(jsii_name="dimensionVar")
    def dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimensionVar"))

    @dimension_var.setter
    def dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__25f0a8e04adb3bca21b243b5e92350a72031d15320f03f556804ae460b39ba77)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fec5ab7443c5be65a1d09b639cddfb5876ec65c0b17e02263f2ebf56f6a18190)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7028e00f8e9d11353e77beec154db57b808ab22dfd0488ef63231456c5c32b70)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimension]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimension]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimension]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__313961869b45dfc23cdfc917b460630e3397dc840c851304cabebb2e5c168b96)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientation",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "landscape": "landscape",
        "portrait": "portrait",
        "square": "square",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientation:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        landscape: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationLandscape", typing.Dict[builtins.str, typing.Any]]] = None,
        portrait: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationPortrait", typing.Dict[builtins.str, typing.Any]]] = None,
        square: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationSquare", typing.Dict[builtins.str, typing.Any]]] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param landscape: landscape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        :param portrait: portrait block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        :param square: square block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationDefault(**default)
        if isinstance(landscape, dict):
            landscape = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationLandscape(**landscape)
        if isinstance(portrait, dict):
            portrait = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationPortrait(**portrait)
        if isinstance(square, dict):
            square = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationSquare(**square)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f11b2c2a9fc198233f2a91c5b57d10d37365d244441c0d131ae3b71f9b61d6f6)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument landscape", value=landscape, expected_type=type_hints["landscape"])
            check_type(argname="argument portrait", value=portrait, expected_type=type_hints["portrait"])
            check_type(argname="argument square", value=square, expected_type=type_hints["square"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if landscape is not None:
            self._values["landscape"] = landscape
        if portrait is not None:
            self._values["portrait"] = portrait
        if square is not None:
            self._values["square"] = square

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationDefault"], result)

    @builtins.property
    def landscape(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationLandscape"]:
        '''landscape block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        '''
        result = self._values.get("landscape")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationLandscape"], result)

    @builtins.property
    def portrait(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationPortrait"]:
        '''portrait block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        '''
        result = self._values.get("portrait")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationPortrait"], result)

    @builtins.property
    def square(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationSquare"]:
        '''square block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        result = self._values.get("square")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationSquare"], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6ce429ca7d848300ec1bc88833d335b5da9693201a83efc7007118e9c0534dd8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__93e05e8658a891e5707ad5a8cd866045131d9209ebe642f0694db523732d97c0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationLandscape",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationLandscape:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationLandscape(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationLandscapeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationLandscapeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__92cf08420f4f9d04f8ef09c6d92344581e41faef90fd845f51bc070d1f379a00)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationLandscape], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationLandscape],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c06fe251e68082b1939b98e099c935471d670002faf73e1df943ee9d26fe170d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6a05aac33c1657eb92bd8d6732286a7e2bb6dee5690992432ca674668e07d099)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__58eb164096e7a0c01d7a7823f7713394015a0d88ff8664f5b8c39273c1ca60b8)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__599954ed7244b1a1989425e6a6eaab87bccd6b46611e2fd7e76e0ad3e4e037c5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0843284cce9ef809ab061c7bf90023cd9dad0b96970573a531528e999314dcfe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4bd236e952cd65f0e3bdea906d045451813905b2bcabfc6061c58156ebfa3233)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientation]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientation]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__193737dcbb10458a58ac9111ad58a28cffa2a4c72f06bcdc3da26173733d6297)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__75299f57986368db71db74a5a87eabfe377a917784c93cd346134e82b59bea26)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putLandscape")
    def put_landscape(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationLandscape()

        return typing.cast(None, jsii.invoke(self, "putLandscape", [value]))

    @jsii.member(jsii_name="putPortrait")
    def put_portrait(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationPortrait()

        return typing.cast(None, jsii.invoke(self, "putPortrait", [value]))

    @jsii.member(jsii_name="putSquare")
    def put_square(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationSquare()

        return typing.cast(None, jsii.invoke(self, "putSquare", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetLandscape")
    def reset_landscape(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLandscape", []))

    @jsii.member(jsii_name="resetPortrait")
    def reset_portrait(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPortrait", []))

    @jsii.member(jsii_name="resetSquare")
    def reset_square(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSquare", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="landscape")
    def landscape(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationLandscapeOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationLandscapeOutputReference, jsii.get(self, "landscape"))

    @builtins.property
    @jsii.member(jsii_name="portrait")
    def portrait(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationPortraitOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationPortraitOutputReference", jsii.get(self, "portrait"))

    @builtins.property
    @jsii.member(jsii_name="square")
    def square(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationSquareOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationSquareOutputReference", jsii.get(self, "square"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="landscapeInput")
    def landscape_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationLandscape], jsii.get(self, "landscapeInput"))

    @builtins.property
    @jsii.member(jsii_name="portraitInput")
    def portrait_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationPortrait"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationPortrait"], jsii.get(self, "portraitInput"))

    @builtins.property
    @jsii.member(jsii_name="squareInput")
    def square_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationSquare"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationSquare"], jsii.get(self, "squareInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientation]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientation]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientation]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__61ffc357de8a0f08842d97340904816351a92153ebd7d5d2178ef9e39fec9fcf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationPortrait",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationPortrait:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationPortrait(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationPortraitOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationPortraitOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__03bcb08dd8325af741d4b98011057a23978c8c90170fa84b2a59add6ec0b65d0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationPortrait]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationPortrait], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationPortrait],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b857dee9e366f4c5ea72ddade733322e829d5c6a25b9b28f86d29f83d1bb9fd6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationSquare",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationSquare:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationSquare(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationSquareOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationSquareOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f01275c7d33755e8c68a81fdee339752d3b2a2ed343134bde760530ff8d3587)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationSquare]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationSquare], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationSquare],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3540aa669eaf71b946f6cb22903edd3226366335f6076528b30f10225942f2c9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanImQuery",
    jsii_struct_bases=[],
    name_mapping={
        "allowed_transformations": "allowedTransformations",
        "query_var": "queryVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanImQuery:
    def __init__(
        self,
        *,
        allowed_transformations: typing.Sequence[builtins.str],
        query_var: builtins.str,
    ) -> None:
        '''
        :param allowed_transformations: Specifies the transformations that can be applied using the query string parameter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allowed_transformations DataAkamaiImagingPolicyImage#allowed_transformations}
        :param query_var: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#query_var DataAkamaiImagingPolicyImage#query_var}.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__87767ed93ec81a0cd28c8829f11eda404b10ac92cf54745f9ea19e9400234316)
            check_type(argname="argument allowed_transformations", value=allowed_transformations, expected_type=type_hints["allowed_transformations"])
            check_type(argname="argument query_var", value=query_var, expected_type=type_hints["query_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "allowed_transformations": allowed_transformations,
            "query_var": query_var,
        }

    @builtins.property
    def allowed_transformations(self) -> typing.List[builtins.str]:
        '''Specifies the transformations that can be applied using the query string parameter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allowed_transformations DataAkamaiImagingPolicyImage#allowed_transformations}
        '''
        result = self._values.get("allowed_transformations")
        assert result is not None, "Required property 'allowed_transformations' is missing"
        return typing.cast(typing.List[builtins.str], result)

    @builtins.property
    def query_var(self) -> builtins.str:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#query_var DataAkamaiImagingPolicyImage#query_var}.'''
        result = self._values.get("query_var")
        assert result is not None, "Required property 'query_var' is missing"
        return typing.cast(builtins.str, result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanImQuery(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanImQueryList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanImQueryList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f2e4339518a2b67fb1ef56015d78cf7081dda99a0fc702226c7f9a6ad5d1da8d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanImQueryOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f7838ec826f4beddfb4c8c21595d953a2587d7422d09b960a500cb153bf9d24e)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanImQueryOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2e1238a134904821153fc161d95d9bafe24d72be2204367115d333379b5abe86)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f74ecd67ee2c5a2aec3881100c3605332ec42ee4c076ce05c648591de0b09c6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c20267d2446d86a954e39afada279eea907fe8fc448a0d3a7792c67497f0ec9b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanImQuery]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanImQuery]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanImQuery]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1d22012f6f7d1b08d7049177af2f5430967a068c6577a9910d3342134d824eb7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanImQueryOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanImQueryOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__afa2911c397e0f237474e613b3caa1b00a1802cbe5b6e6737c518de785aad42f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @builtins.property
    @jsii.member(jsii_name="allowedTransformationsInput")
    def allowed_transformations_input(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "allowedTransformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="queryVarInput")
    def query_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "queryVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowedTransformations")
    def allowed_transformations(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "allowedTransformations"))

    @allowed_transformations.setter
    def allowed_transformations(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e4157c8742a33ef51acfef9ede53ebda474ca745ea9540ebc3fe73bc81cb8f53)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowedTransformations", value)

    @builtins.property
    @jsii.member(jsii_name="queryVar")
    def query_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "queryVar"))

    @query_var.setter
    def query_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__adfc557b0ad8b773b588cb37c32e4af339f49d1e55b3b04f0f9b5c2561a4d352)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "queryVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanImQuery]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanImQuery]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanImQuery]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa2b4c70624101d63f804ffbf465b05e937ae8c19cac018656763ac58cc481dd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanMaxColors",
    jsii_struct_bases=[],
    name_mapping={"colors": "colors", "colors_var": "colorsVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanMaxColors:
    def __init__(
        self,
        *,
        colors: typing.Optional[builtins.str] = None,
        colors_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param colors: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        :param colors_var: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7f5d654b89205f04d43fe44f1b137d814af47548a88ba4ea7e0a271e87c61217)
            check_type(argname="argument colors", value=colors, expected_type=type_hints["colors"])
            check_type(argname="argument colors_var", value=colors_var, expected_type=type_hints["colors_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if colors is not None:
            self._values["colors"] = colors
        if colors_var is not None:
            self._values["colors_var"] = colors_var

    @builtins.property
    def colors(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        '''
        result = self._values.get("colors")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def colors_var(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        result = self._values.get("colors_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanMaxColors(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanMaxColorsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanMaxColorsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3c29edee6294340e5431f3900325c87907e6100aa2a13ee33f06357bc8a22708)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanMaxColorsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5c8c1a0c3a3f405e61ee9acf08b3deb888d2dbf5e3b187d6333b6e2dca0abf7a)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanMaxColorsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5e45c4b31a7353d6a49d9c1f9b3e7453c58a9f63f219dc4c461f0989734417a2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e8e0ca9e41e3143e8eb10874f10f4368b22778d20dd77fd41bc0e6095d41e73)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dea103672acf53906c00e7eeafea7b776d8b9aad46871280323c8fc3c5557512)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanMaxColors]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanMaxColors]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d3468f1cf823b8344b0a3177381a370875da5851bba9cc8db7de07256290c9c5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanMaxColorsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanMaxColorsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4012e347fe35bd3532e5aa346b9ae1395a661b8dd5000213a0f74edb3f6f1161)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColors")
    def reset_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColors", []))

    @jsii.member(jsii_name="resetColorsVar")
    def reset_colors_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorsVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorsInput")
    def colors_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsInput"))

    @builtins.property
    @jsii.member(jsii_name="colorsVarInput")
    def colors_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsVarInput"))

    @builtins.property
    @jsii.member(jsii_name="colors")
    def colors(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colors"))

    @colors.setter
    def colors(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e9c4124d9717b3e086cfd9857270e193398021ec2f58b4f9220841c93418664e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colors", value)

    @builtins.property
    @jsii.member(jsii_name="colorsVar")
    def colors_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorsVar"))

    @colors_var.setter
    def colors_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5d9225e02a1853f83334792a535faa2beb3399fcad53d3dab0b2d21d55e9ff46)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorsVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanMaxColors]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanMaxColors]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanMaxColors]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a24a2335e37089e4aa78067fa7c2492fdd9ac7c737e9110a6bf5fefc21498461)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanMirror",
    jsii_struct_bases=[],
    name_mapping={
        "horizontal": "horizontal",
        "horizontal_var": "horizontalVar",
        "vertical": "vertical",
        "vertical_var": "verticalVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanMirror:
    def __init__(
        self,
        *,
        horizontal: typing.Optional[builtins.str] = None,
        horizontal_var: typing.Optional[builtins.str] = None,
        vertical: typing.Optional[builtins.str] = None,
        vertical_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param horizontal: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        :param horizontal_var: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        :param vertical: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        :param vertical_var: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e34cc903ccda66d0c3d7c4cd8aec083aae5d968b8e81ae1f8667ceffc4765644)
            check_type(argname="argument horizontal", value=horizontal, expected_type=type_hints["horizontal"])
            check_type(argname="argument horizontal_var", value=horizontal_var, expected_type=type_hints["horizontal_var"])
            check_type(argname="argument vertical", value=vertical, expected_type=type_hints["vertical"])
            check_type(argname="argument vertical_var", value=vertical_var, expected_type=type_hints["vertical_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if horizontal is not None:
            self._values["horizontal"] = horizontal
        if horizontal_var is not None:
            self._values["horizontal_var"] = horizontal_var
        if vertical is not None:
            self._values["vertical"] = vertical
        if vertical_var is not None:
            self._values["vertical_var"] = vertical_var

    @builtins.property
    def horizontal(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        '''
        result = self._values.get("horizontal")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def horizontal_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        '''
        result = self._values.get("horizontal_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        '''
        result = self._values.get("vertical")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        result = self._values.get("vertical_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanMirror(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanMirrorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanMirrorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a2423314fe3dec471cec4ac68b23b1ff7780fd53440c93ec7fe1c2e46f84237)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanMirrorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2154baf50fae1147b26492584fd91538da8445adaff9ee96a6db712d6673b03e)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanMirrorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__35f0d66d5065f84a393d9919dc77305136dcae2ca7ee51a36f80105eaedf02e8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9168d220c3a08c8e310d8955392676524a664a836c26bba1dfb90d34569f849d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8d397419e712c31a2ed194707db6b667696e623ee049757f5ae071c7de7350bf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanMirror]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanMirror]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__86adc6902f79dfc98c944236b8b110dea1b64173fd4beb3911cf13c1c749caf7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanMirrorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanMirrorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b55ca6006975e92e86fecb403a6b3920512b55adcef72f29d3808a88128267d5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHorizontal")
    def reset_horizontal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontal", []))

    @jsii.member(jsii_name="resetHorizontalVar")
    def reset_horizontal_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontalVar", []))

    @jsii.member(jsii_name="resetVertical")
    def reset_vertical(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVertical", []))

    @jsii.member(jsii_name="resetVerticalVar")
    def reset_vertical_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVerticalVar", []))

    @builtins.property
    @jsii.member(jsii_name="horizontalInput")
    def horizontal_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontalVarInput")
    def horizontal_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalInput")
    def vertical_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalVarInput")
    def vertical_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontal")
    def horizontal(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontal"))

    @horizontal.setter
    def horizontal(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__612aa993622141e72a31d2afb481e7fcea76cc5f532e4b5a2f14317f753548f0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontal", value)

    @builtins.property
    @jsii.member(jsii_name="horizontalVar")
    def horizontal_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontalVar"))

    @horizontal_var.setter
    def horizontal_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__56e46492a2e33c9f5dc1a0459cc7050e77e397ddaeaa035ff19366fe010f5d80)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontalVar", value)

    @builtins.property
    @jsii.member(jsii_name="vertical")
    def vertical(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "vertical"))

    @vertical.setter
    def vertical(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2744551f880de4e677aae420071b8da2a4e08ddf36f4f2544a8d492dbec90031)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "vertical", value)

    @builtins.property
    @jsii.member(jsii_name="verticalVar")
    def vertical_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "verticalVar"))

    @vertical_var.setter
    def vertical_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__048a1e07e71abc7a28a6a7182bde7a87a44c6c20e10ee6f4910b4f51907ca5ea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "verticalVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanMirror]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanMirror]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanMirror]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__201153b9ef53c83e96a1a26c5b09b2020cf8cb9d99c323ce7b730d205a3f2bd1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanMonoHue",
    jsii_struct_bases=[],
    name_mapping={"hue": "hue", "hue_var": "hueVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanMonoHue:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__98d1964c43b396dbca41faaeadc1cbf7a062b37aabd6b7c63922afc083d38ff0)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanMonoHue(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanMonoHueList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanMonoHueList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5befc0212198de273319314925fd99c5019d1538b4de534b00a4108131d3c89e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanMonoHueOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3260a8c103dd2cae545f33f822cc855e950efa5edc65206ec58e093ac7fb736a)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanMonoHueOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea4bc3a235ea647b3a628677409dce8c2340ef385f31b81c3b769deabf610df7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2415825bf68cac76051b95018393114af18da3e083a41b6572da6c1c295d9931)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__75b86c7f4cd9c0e94446db9679af44f67beb8742df3e4b367f07b87eb03a3094)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanMonoHue]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanMonoHue]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__68f30f46879831c37efced176dc6b81d1df10472337751c990dd4ac54abb8709)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanMonoHueOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanMonoHueOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f24c973be026b2edd2516783efcbe648ed482c4309fa27fe82b541629404c493)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ea7d12e809701c4f2c7c00ba0ec1d68a8a1ee581961063a845684b41456e903)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a2baff6f9e2ac102b6c824e1457bec4afb6954205fa3e0edb8c50051c3ea98ed)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanMonoHue]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanMonoHue]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanMonoHue]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__182994359720fa2899bf21d56f748e207b7db65a265925b65d86055461dd30d2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanOpacity",
    jsii_struct_bases=[],
    name_mapping={"opacity": "opacity", "opacity_var": "opacityVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanOpacity:
    def __init__(
        self,
        *,
        opacity: typing.Optional[builtins.str] = None,
        opacity_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param opacity: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param opacity_var: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6d739f930886a8556397d7013297fc2c30ab19aa6ef8953fd48b1c49cc2a93a7)
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument opacity_var", value=opacity_var, expected_type=type_hints["opacity_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if opacity is not None:
            self._values["opacity"] = opacity
        if opacity_var is not None:
            self._values["opacity_var"] = opacity_var

    @builtins.property
    def opacity(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def opacity_var(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        result = self._values.get("opacity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanOpacity(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanOpacityList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanOpacityList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4e92000cdfa2dddec741b7535a5c2609ad56938e22e22f84efcba4103bbaab2a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanOpacityOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__57e77a331612d828f25c2c07fab59c3913d059f0bedeec1b63a760772c5b232c)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanOpacityOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a383c22e7347f8f450c266723aeb341034d62663dcc1939c011311c6cf9b2927)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0aaffe3938d3d20d02ff8816e940f3ac5bdbbff68bd1237415c66330fb059d90)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__15b46b324120388a37cc845e743dd26f179617da38750bf2a54dd0b17cfa9904)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanOpacity]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanOpacity]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__19af99f9bd728579624dfd620da29a8893e73ec3b574503ef6b6895c46706454)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanOpacityOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanOpacityOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f41ac9c55e192a72fb749a2678f3f70eed0d4d9b4d1500e88f23a5e728ca96ce)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetOpacityVar")
    def reset_opacity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacityVar", []))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityVarInput")
    def opacity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacity"))

    @opacity.setter
    def opacity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c14b79c17ce17de01ef927d5ff383f2daf398ef91c152590754ec2315cefee46)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacity", value)

    @builtins.property
    @jsii.member(jsii_name="opacityVar")
    def opacity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacityVar"))

    @opacity_var.setter
    def opacity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3470d025c28a332615956d23306a695ba20a5c0a696015bd2027f8cb9324fa9e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacityVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanOpacity]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanOpacity]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanOpacity]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c87620fa6893d3ba926882e50e3e97904904840bae5f930602c3750d80b9f275)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d0d83e6bd5c008f2680fc4e04a2ebb8926209662508589d42f976037957c56a4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putAppend")
    def put_append(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanAppend, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9b446e16977c86ab81628517839411386820aa17e409f59ae6f1ba3726a6d455)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putAppend", [value]))

    @jsii.member(jsii_name="putAspectCrop")
    def put_aspect_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanAspectCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__84a13a8e5221e9b719c38c4a29f0a27c117d61237678d0b8e7e6e7ff8503b894)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putAspectCrop", [value]))

    @jsii.member(jsii_name="putBackgroundColor")
    def put_background_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__52ffb0a7896b18362e8a1f5b103af6b622de550bc7539f23d2d59364cc09d079)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBackgroundColor", [value]))

    @jsii.member(jsii_name="putBlur")
    def put_blur(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanBlur, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7fbb3b4668775c8c2098946ef2b91a237fb983e769efafec97a0dc6d45e692f9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBlur", [value]))

    @jsii.member(jsii_name="putChromaKey")
    def put_chroma_key(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanChromaKey, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__71197d26fc7b0a1f54b5eede1944a37dea19f545a47c0e4c5d61afeca924e7d1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putChromaKey", [value]))

    @jsii.member(jsii_name="putComposite")
    def put_composite(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanComposite, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__80c565e1d8804dcd19ee26d71343f344a38b070cfa91a7b5fd96a8041d22950f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putComposite", [value]))

    @jsii.member(jsii_name="putCompound")
    def put_compound(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanCompound, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4b18efd51c3df88910dda86ea4a086ddd9477f6c29ed52c03c75ba3e626a5e74)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCompound", [value]))

    @jsii.member(jsii_name="putContrast")
    def put_contrast(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanContrast, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__333c5c2f4ceb6ba0e9ee3fcf5ec72ab38fe17839dedffd8b8b65d8f37706d123)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putContrast", [value]))

    @jsii.member(jsii_name="putCrop")
    def put_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd8f8899cdf253f8cbab53c777fbf8d7e70ee236b16553f1e5c034a487b24904)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCrop", [value]))

    @jsii.member(jsii_name="putFaceCrop")
    def put_face_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanFaceCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__659c2c85a8af3c5b49aa6b09f364abf59330d521015472a4a2ba2d8f730c97b8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFaceCrop", [value]))

    @jsii.member(jsii_name="putFeatureCrop")
    def put_feature_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanFeatureCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6b67bbd880cbf0809be0871dc436ef6e5b7c15f55da56cabe8bd5eef3db7ee1a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFeatureCrop", [value]))

    @jsii.member(jsii_name="putFitAndFill")
    def put_fit_and_fill(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanFitAndFill, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2b765793992a63cb58ee10b4c5098a62b76a79f3be4b381af4aabfd8f877197c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFitAndFill", [value]))

    @jsii.member(jsii_name="putGoop")
    def put_goop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanGoop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__192f3a75b5a7b3b48734ef70b16bbe70bc1ec886849b4c07f1cb71fe33fca523)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGoop", [value]))

    @jsii.member(jsii_name="putGrayscale")
    def put_grayscale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanGrayscale, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e84f952e3ac530a688a98f0a07f27d9a8e0f9a5f77de3841e90e368ca99d2327)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGrayscale", [value]))

    @jsii.member(jsii_name="putHsl")
    def put_hsl(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanHsl, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fd80f5dd6d1fc276b3f85682813a47df8d1d32c8ba58fbe6ff5dd1b6b4228514)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsl", [value]))

    @jsii.member(jsii_name="putHsv")
    def put_hsv(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanHsv, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2044cea3ed383c4959374c32af91bab071cc188c99f041e4bfb1583a45ecf37f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsv", [value]))

    @jsii.member(jsii_name="putIfDimension")
    def put_if_dimension(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimension, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e69d8ea7d5e4173f668432a887865f8dd2db19c23acd88320f494b6a3c93804c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfDimension", [value]))

    @jsii.member(jsii_name="putIfOrientation")
    def put_if_orientation(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8fedbd798a9ecca629660467662b7bfe71168115360008daadf33b0f3dce2dc9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfOrientation", [value]))

    @jsii.member(jsii_name="putImQuery")
    def put_im_query(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanImQuery, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__017301af56ad452bbc32c7feaca8545ef7b1a8fe923d5e7af976ba98aede4441)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putImQuery", [value]))

    @jsii.member(jsii_name="putMaxColors")
    def put_max_colors(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanMaxColors, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__72ebc7f5b92c09fd70be50f645020125eaeb7150cc21bd3f4c90d167096c8145)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMaxColors", [value]))

    @jsii.member(jsii_name="putMirror")
    def put_mirror(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanMirror, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9890869e137c7037fe0006b87845eda94390b4889e92f3c934dc30ac8322d33a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMirror", [value]))

    @jsii.member(jsii_name="putMonoHue")
    def put_mono_hue(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanMonoHue, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__22ce9e196a7dcb751d8cd4d3d971f36d9e618be2c13fca702a2f88db35146780)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMonoHue", [value]))

    @jsii.member(jsii_name="putOpacity")
    def put_opacity(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanOpacity, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__00b1c34bbfe24d8ed82d7539d88c3dc505fff14fcad522cffe71357c32557543)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putOpacity", [value]))

    @jsii.member(jsii_name="putRegionOfInterestCrop")
    def put_region_of_interest_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanRegionOfInterestCrop", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b2ad5c5d39785ba283239ccbf4a06ea2281c745feb8bfaf3ea3d3c3f58634537)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRegionOfInterestCrop", [value]))

    @jsii.member(jsii_name="putRelativeCrop")
    def put_relative_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanRelativeCrop", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5c196b1b03423c63fa656293df57f2d78d1003c9213c0d0d19c1a3d94705765a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRelativeCrop", [value]))

    @jsii.member(jsii_name="putRemoveColor")
    def put_remove_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanRemoveColor", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ae2bd8a985395b6face41fa884d28b4e83b22401c443e3be9b797e5c80e46472)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRemoveColor", [value]))

    @jsii.member(jsii_name="putResize")
    def put_resize(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanResize", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8b3245d2bcd5808ac0b4c4b341e777e6f3949b3163ed2fbde8e2e3dc96092c60)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putResize", [value]))

    @jsii.member(jsii_name="putRotate")
    def put_rotate(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanRotate", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__38d4ff61553dcbef243de8507b5d57b43f6203786acff26fd7d38d7f4de2fd65)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRotate", [value]))

    @jsii.member(jsii_name="putScale")
    def put_scale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanScale", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7b9a4f47dffeae143a279329360335bf6f04dc673e4a7c88bd267a7e36203e2f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putScale", [value]))

    @jsii.member(jsii_name="putShear")
    def put_shear(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanShear", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac253050f5f9a6d336dc8013f2e10917c057cf8a4d5e87657dd074c7275b1c27)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putShear", [value]))

    @jsii.member(jsii_name="putTrim")
    def put_trim(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanTrim", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5dce8d697687e393004f12451d8d7b5f33152651556179f487f09107287fa642)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTrim", [value]))

    @jsii.member(jsii_name="putUnsharpMask")
    def put_unsharp_mask(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanUnsharpMask", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c2645b7056ca92b8cff5e3b5f2c99cddac797f2c19cb2eba1cf6a1b740e391ff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putUnsharpMask", [value]))

    @jsii.member(jsii_name="resetAppend")
    def reset_append(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAppend", []))

    @jsii.member(jsii_name="resetAspectCrop")
    def reset_aspect_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspectCrop", []))

    @jsii.member(jsii_name="resetBackgroundColor")
    def reset_background_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBackgroundColor", []))

    @jsii.member(jsii_name="resetBlur")
    def reset_blur(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBlur", []))

    @jsii.member(jsii_name="resetChromaKey")
    def reset_chroma_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChromaKey", []))

    @jsii.member(jsii_name="resetComposite")
    def reset_composite(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetComposite", []))

    @jsii.member(jsii_name="resetCompound")
    def reset_compound(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCompound", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetCrop")
    def reset_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCrop", []))

    @jsii.member(jsii_name="resetFaceCrop")
    def reset_face_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFaceCrop", []))

    @jsii.member(jsii_name="resetFeatureCrop")
    def reset_feature_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureCrop", []))

    @jsii.member(jsii_name="resetFitAndFill")
    def reset_fit_and_fill(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFitAndFill", []))

    @jsii.member(jsii_name="resetGoop")
    def reset_goop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGoop", []))

    @jsii.member(jsii_name="resetGrayscale")
    def reset_grayscale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGrayscale", []))

    @jsii.member(jsii_name="resetHsl")
    def reset_hsl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsl", []))

    @jsii.member(jsii_name="resetHsv")
    def reset_hsv(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsv", []))

    @jsii.member(jsii_name="resetIfDimension")
    def reset_if_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfDimension", []))

    @jsii.member(jsii_name="resetIfOrientation")
    def reset_if_orientation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfOrientation", []))

    @jsii.member(jsii_name="resetImQuery")
    def reset_im_query(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetImQuery", []))

    @jsii.member(jsii_name="resetMaxColors")
    def reset_max_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxColors", []))

    @jsii.member(jsii_name="resetMirror")
    def reset_mirror(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMirror", []))

    @jsii.member(jsii_name="resetMonoHue")
    def reset_mono_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonoHue", []))

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetRegionOfInterestCrop")
    def reset_region_of_interest_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRegionOfInterestCrop", []))

    @jsii.member(jsii_name="resetRelativeCrop")
    def reset_relative_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRelativeCrop", []))

    @jsii.member(jsii_name="resetRemoveColor")
    def reset_remove_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRemoveColor", []))

    @jsii.member(jsii_name="resetResize")
    def reset_resize(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetResize", []))

    @jsii.member(jsii_name="resetRotate")
    def reset_rotate(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRotate", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetShear")
    def reset_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetShear", []))

    @jsii.member(jsii_name="resetTrim")
    def reset_trim(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTrim", []))

    @jsii.member(jsii_name="resetUnsharpMask")
    def reset_unsharp_mask(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUnsharpMask", []))

    @builtins.property
    @jsii.member(jsii_name="append")
    def append(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanAppendList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanAppendList, jsii.get(self, "append"))

    @builtins.property
    @jsii.member(jsii_name="aspectCrop")
    def aspect_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanAspectCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanAspectCropList, jsii.get(self, "aspectCrop"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColor")
    def background_color(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanBackgroundColorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanBackgroundColorList, jsii.get(self, "backgroundColor"))

    @builtins.property
    @jsii.member(jsii_name="blur")
    def blur(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanBlurList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanBlurList, jsii.get(self, "blur"))

    @builtins.property
    @jsii.member(jsii_name="chromaKey")
    def chroma_key(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanChromaKeyList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanChromaKeyList, jsii.get(self, "chromaKey"))

    @builtins.property
    @jsii.member(jsii_name="composite")
    def composite(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanCompositeList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanCompositeList, jsii.get(self, "composite"))

    @builtins.property
    @jsii.member(jsii_name="compound")
    def compound(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanCompoundList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanCompoundList, jsii.get(self, "compound"))

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanContrastList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanContrastList, jsii.get(self, "contrast"))

    @builtins.property
    @jsii.member(jsii_name="crop")
    def crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanCropList, jsii.get(self, "crop"))

    @builtins.property
    @jsii.member(jsii_name="faceCrop")
    def face_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanFaceCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanFaceCropList, jsii.get(self, "faceCrop"))

    @builtins.property
    @jsii.member(jsii_name="featureCrop")
    def feature_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanFeatureCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanFeatureCropList, jsii.get(self, "featureCrop"))

    @builtins.property
    @jsii.member(jsii_name="fitAndFill")
    def fit_and_fill(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanFitAndFillList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanFitAndFillList, jsii.get(self, "fitAndFill"))

    @builtins.property
    @jsii.member(jsii_name="goop")
    def goop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanGoopList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanGoopList, jsii.get(self, "goop"))

    @builtins.property
    @jsii.member(jsii_name="grayscale")
    def grayscale(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanGrayscaleList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanGrayscaleList, jsii.get(self, "grayscale"))

    @builtins.property
    @jsii.member(jsii_name="hsl")
    def hsl(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanHslList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanHslList, jsii.get(self, "hsl"))

    @builtins.property
    @jsii.member(jsii_name="hsv")
    def hsv(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanHsvList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanHsvList, jsii.get(self, "hsv"))

    @builtins.property
    @jsii.member(jsii_name="ifDimension")
    def if_dimension(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionList, jsii.get(self, "ifDimension"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientation")
    def if_orientation(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationList, jsii.get(self, "ifOrientation"))

    @builtins.property
    @jsii.member(jsii_name="imQuery")
    def im_query(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanImQueryList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanImQueryList, jsii.get(self, "imQuery"))

    @builtins.property
    @jsii.member(jsii_name="maxColors")
    def max_colors(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanMaxColorsList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanMaxColorsList, jsii.get(self, "maxColors"))

    @builtins.property
    @jsii.member(jsii_name="mirror")
    def mirror(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanMirrorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanMirrorList, jsii.get(self, "mirror"))

    @builtins.property
    @jsii.member(jsii_name="monoHue")
    def mono_hue(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanMonoHueList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanMonoHueList, jsii.get(self, "monoHue"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanOpacityList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanOpacityList, jsii.get(self, "opacity"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestCrop")
    def region_of_interest_crop(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanRegionOfInterestCropList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanRegionOfInterestCropList", jsii.get(self, "regionOfInterestCrop"))

    @builtins.property
    @jsii.member(jsii_name="relativeCrop")
    def relative_crop(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanRelativeCropList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanRelativeCropList", jsii.get(self, "relativeCrop"))

    @builtins.property
    @jsii.member(jsii_name="removeColor")
    def remove_color(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanRemoveColorList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanRemoveColorList", jsii.get(self, "removeColor"))

    @builtins.property
    @jsii.member(jsii_name="resize")
    def resize(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanResizeList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanResizeList", jsii.get(self, "resize"))

    @builtins.property
    @jsii.member(jsii_name="rotate")
    def rotate(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanRotateList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanRotateList", jsii.get(self, "rotate"))

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanScaleList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanScaleList", jsii.get(self, "scale"))

    @builtins.property
    @jsii.member(jsii_name="shear")
    def shear(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanShearList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanShearList", jsii.get(self, "shear"))

    @builtins.property
    @jsii.member(jsii_name="trim")
    def trim(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanTrimList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanTrimList", jsii.get(self, "trim"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMask")
    def unsharp_mask(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanUnsharpMaskList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanUnsharpMaskList", jsii.get(self, "unsharpMask"))

    @builtins.property
    @jsii.member(jsii_name="appendInput")
    def append_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanAppend]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanAppend]]], jsii.get(self, "appendInput"))

    @builtins.property
    @jsii.member(jsii_name="aspectCropInput")
    def aspect_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanAspectCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanAspectCrop]]], jsii.get(self, "aspectCropInput"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColorInput")
    def background_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanBackgroundColor]]], jsii.get(self, "backgroundColorInput"))

    @builtins.property
    @jsii.member(jsii_name="blurInput")
    def blur_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanBlur]]], jsii.get(self, "blurInput"))

    @builtins.property
    @jsii.member(jsii_name="chromaKeyInput")
    def chroma_key_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanChromaKey]]], jsii.get(self, "chromaKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="compositeInput")
    def composite_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanComposite]]], jsii.get(self, "compositeInput"))

    @builtins.property
    @jsii.member(jsii_name="compoundInput")
    def compound_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanCompound]]], jsii.get(self, "compoundInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanContrast]]], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="cropInput")
    def crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanCrop]]], jsii.get(self, "cropInput"))

    @builtins.property
    @jsii.member(jsii_name="faceCropInput")
    def face_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanFaceCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanFaceCrop]]], jsii.get(self, "faceCropInput"))

    @builtins.property
    @jsii.member(jsii_name="featureCropInput")
    def feature_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanFeatureCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanFeatureCrop]]], jsii.get(self, "featureCropInput"))

    @builtins.property
    @jsii.member(jsii_name="fitAndFillInput")
    def fit_and_fill_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanFitAndFill]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanFitAndFill]]], jsii.get(self, "fitAndFillInput"))

    @builtins.property
    @jsii.member(jsii_name="goopInput")
    def goop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanGoop]]], jsii.get(self, "goopInput"))

    @builtins.property
    @jsii.member(jsii_name="grayscaleInput")
    def grayscale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanGrayscale]]], jsii.get(self, "grayscaleInput"))

    @builtins.property
    @jsii.member(jsii_name="hslInput")
    def hsl_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanHsl]]], jsii.get(self, "hslInput"))

    @builtins.property
    @jsii.member(jsii_name="hsvInput")
    def hsv_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanHsv]]], jsii.get(self, "hsvInput"))

    @builtins.property
    @jsii.member(jsii_name="ifDimensionInput")
    def if_dimension_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimension]]], jsii.get(self, "ifDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientationInput")
    def if_orientation_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientation]]], jsii.get(self, "ifOrientationInput"))

    @builtins.property
    @jsii.member(jsii_name="imQueryInput")
    def im_query_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanImQuery]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanImQuery]]], jsii.get(self, "imQueryInput"))

    @builtins.property
    @jsii.member(jsii_name="maxColorsInput")
    def max_colors_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanMaxColors]]], jsii.get(self, "maxColorsInput"))

    @builtins.property
    @jsii.member(jsii_name="mirrorInput")
    def mirror_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanMirror]]], jsii.get(self, "mirrorInput"))

    @builtins.property
    @jsii.member(jsii_name="monoHueInput")
    def mono_hue_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanMonoHue]]], jsii.get(self, "monoHueInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanOpacity]]], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestCropInput")
    def region_of_interest_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanRegionOfInterestCrop"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanRegionOfInterestCrop"]]], jsii.get(self, "regionOfInterestCropInput"))

    @builtins.property
    @jsii.member(jsii_name="relativeCropInput")
    def relative_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanRelativeCrop"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanRelativeCrop"]]], jsii.get(self, "relativeCropInput"))

    @builtins.property
    @jsii.member(jsii_name="removeColorInput")
    def remove_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanRemoveColor"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanRemoveColor"]]], jsii.get(self, "removeColorInput"))

    @builtins.property
    @jsii.member(jsii_name="resizeInput")
    def resize_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanResize"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanResize"]]], jsii.get(self, "resizeInput"))

    @builtins.property
    @jsii.member(jsii_name="rotateInput")
    def rotate_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanRotate"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanRotate"]]], jsii.get(self, "rotateInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanScale"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanScale"]]], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="shearInput")
    def shear_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanShear"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanShear"]]], jsii.get(self, "shearInput"))

    @builtins.property
    @jsii.member(jsii_name="trimInput")
    def trim_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanTrim"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanTrim"]]], jsii.get(self, "trimInput"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMaskInput")
    def unsharp_mask_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanUnsharpMask"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanUnsharpMask"]]], jsii.get(self, "unsharpMaskInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3669f82812485ab56a81c6e3d91aad76f6b86d4a191b3f6819000b5e915e49e7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanRegionOfInterestCrop",
    jsii_struct_bases=[],
    name_mapping={
        "region_of_interest": "regionOfInterest",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanRegionOfInterestCrop:
    def __init__(
        self,
        *,
        region_of_interest: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanRegionOfInterestCropRegionOfInterest", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param region_of_interest: region_of_interest block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest DataAkamaiImagingPolicyImage#region_of_interest}
        :param gravity: The placement of the crop area relative to the specified area of interest. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: The placement of the crop area relative to the specified area of interest. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param style: Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(region_of_interest, dict):
            region_of_interest = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanRegionOfInterestCropRegionOfInterest(**region_of_interest)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a0317a11a97ff293242de88363885ef3d63970d4a8307981980fd63e00099507)
            check_type(argname="argument region_of_interest", value=region_of_interest, expected_type=type_hints["region_of_interest"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "region_of_interest": region_of_interest,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def region_of_interest(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanRegionOfInterestCropRegionOfInterest":
        '''region_of_interest block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest DataAkamaiImagingPolicyImage#region_of_interest}
        '''
        result = self._values.get("region_of_interest")
        assert result is not None, "Required property 'region_of_interest' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanRegionOfInterestCropRegionOfInterest", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''The placement of the crop area relative to the specified area of interest.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''The placement of the crop area relative to the specified area of interest.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanRegionOfInterestCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanRegionOfInterestCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanRegionOfInterestCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0701a4cd6c1903f95222c97c934182da2c5a4705072305feec569b6217343aed)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanRegionOfInterestCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0e5c984c73ace35e8a01b8b925048e6fe1b766ab304dc50561e055c1446e13c9)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanRegionOfInterestCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__32c1985376727a98d0cd763fcf88732a063d578c16651713c8a7c269857e1d9a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__87d7e3accae0f60c00b38bf876325d89ee20ce403280e6f398fdc1fc2a9bdb4f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a13f60ec985fa5dc7cef2b8bdc2b36f016c1115655f3774ebc18a75f035f833)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanRegionOfInterestCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanRegionOfInterestCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanRegionOfInterestCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__949940a79391ead5f08629deafb3530c76168dcfb140cf72b671c6b3d7675a9b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanRegionOfInterestCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanRegionOfInterestCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2e1e5e36be54f9cad51e3819abcf166ebd794d18b17a231c3f67a402a71a0981)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putRegionOfInterest")
    def put_region_of_interest(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanRegionOfInterestCropRegionOfInterest()

        return typing.cast(None, jsii.invoke(self, "putRegionOfInterest", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterest")
    def region_of_interest(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestOutputReference", jsii.get(self, "regionOfInterest"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestInput")
    def region_of_interest_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanRegionOfInterestCropRegionOfInterest"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanRegionOfInterestCropRegionOfInterest"], jsii.get(self, "regionOfInterestInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fdb931501b6b40dd7c4269d1a0b1da14069337270d90c108a6de28131bef642d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0a56b0ac22a996c90efd510963c49166a8b53290ff452f22f2915336eb5ae762)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__324fba164969d2dbf2fff962b28f00ee0b60576f96288029ab0c5c00f503a36b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3d94c0ba5d3568aa33eabf6e2313b5b54afdc620dc8141e06489dd0c022a0930)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__99d976d2d4ead70654f8c4f178e69f59d862809218a1f62e21c7cca123c9767d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__01ede2d2556b423fbbba480e6d41fc78428cfc382e93533e1b998cd7b83c9b51)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__347ca6801eca6f09a67baf5a9f2542a93cc8f191679efd2dfd1ef4982531c3f9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3c523fa9c784d49263c817085b1988e907234bac8451781b2dd5122608d66c97)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanRegionOfInterestCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanRegionOfInterestCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanRegionOfInterestCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__348b7740a17c104d11d818b411755f5714ca4f1f4db7b9488216f93168bcfab6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanRegionOfInterestCropRegionOfInterest",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanRegionOfInterestCropRegionOfInterest:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanRegionOfInterestCropRegionOfInterest(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__214a1f55451edd88a96adaa2101163e7ffa11c7e57b227385cf7455c2962d7c4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanRegionOfInterestCropRegionOfInterest]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanRegionOfInterestCropRegionOfInterest], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanRegionOfInterestCropRegionOfInterest],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__66b74d811fc88458f4a717001a15e29a436f9ed5d0d9c1d0d508fd2f93b61c69)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanRelativeCrop",
    jsii_struct_bases=[],
    name_mapping={
        "east": "east",
        "east_var": "eastVar",
        "north": "north",
        "north_var": "northVar",
        "south": "south",
        "south_var": "southVar",
        "west": "west",
        "west_var": "westVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanRelativeCrop:
    def __init__(
        self,
        *,
        east: typing.Optional[builtins.str] = None,
        east_var: typing.Optional[builtins.str] = None,
        north: typing.Optional[builtins.str] = None,
        north_var: typing.Optional[builtins.str] = None,
        south: typing.Optional[builtins.str] = None,
        south_var: typing.Optional[builtins.str] = None,
        west: typing.Optional[builtins.str] = None,
        west_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param east: The number of pixels to shrink or expand the right side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east DataAkamaiImagingPolicyImage#east}
        :param east_var: The number of pixels to shrink or expand the right side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east_var DataAkamaiImagingPolicyImage#east_var}
        :param north: The number of pixels to shrink or expand the top side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north DataAkamaiImagingPolicyImage#north}
        :param north_var: The number of pixels to shrink or expand the top side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north_var DataAkamaiImagingPolicyImage#north_var}
        :param south: The number of pixels to shrink or expand the bottom side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south DataAkamaiImagingPolicyImage#south}
        :param south_var: The number of pixels to shrink or expand the bottom side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south_var DataAkamaiImagingPolicyImage#south_var}
        :param west: The number of pixels to shrink or expand the left side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west DataAkamaiImagingPolicyImage#west}
        :param west_var: The number of pixels to shrink or expand the left side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west_var DataAkamaiImagingPolicyImage#west_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__acad3b342f7e5d0e268ba2738cd23cc1d3341ea354524d4037932a8bfa74bd46)
            check_type(argname="argument east", value=east, expected_type=type_hints["east"])
            check_type(argname="argument east_var", value=east_var, expected_type=type_hints["east_var"])
            check_type(argname="argument north", value=north, expected_type=type_hints["north"])
            check_type(argname="argument north_var", value=north_var, expected_type=type_hints["north_var"])
            check_type(argname="argument south", value=south, expected_type=type_hints["south"])
            check_type(argname="argument south_var", value=south_var, expected_type=type_hints["south_var"])
            check_type(argname="argument west", value=west, expected_type=type_hints["west"])
            check_type(argname="argument west_var", value=west_var, expected_type=type_hints["west_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if east is not None:
            self._values["east"] = east
        if east_var is not None:
            self._values["east_var"] = east_var
        if north is not None:
            self._values["north"] = north
        if north_var is not None:
            self._values["north_var"] = north_var
        if south is not None:
            self._values["south"] = south
        if south_var is not None:
            self._values["south_var"] = south_var
        if west is not None:
            self._values["west"] = west
        if west_var is not None:
            self._values["west_var"] = west_var

    @builtins.property
    def east(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the right side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east DataAkamaiImagingPolicyImage#east}
        '''
        result = self._values.get("east")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def east_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the right side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east_var DataAkamaiImagingPolicyImage#east_var}
        '''
        result = self._values.get("east_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def north(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the top side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north DataAkamaiImagingPolicyImage#north}
        '''
        result = self._values.get("north")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def north_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the top side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north_var DataAkamaiImagingPolicyImage#north_var}
        '''
        result = self._values.get("north_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def south(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the bottom side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south DataAkamaiImagingPolicyImage#south}
        '''
        result = self._values.get("south")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def south_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the bottom side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south_var DataAkamaiImagingPolicyImage#south_var}
        '''
        result = self._values.get("south_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def west(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the left side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west DataAkamaiImagingPolicyImage#west}
        '''
        result = self._values.get("west")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def west_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the left side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west_var DataAkamaiImagingPolicyImage#west_var}
        '''
        result = self._values.get("west_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanRelativeCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanRelativeCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanRelativeCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b60c0b28d25536148c1837d0e7c670899eb50378ec0464c54b5e40f4c353ac2b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanRelativeCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__05c645149cef70851ba4fd0e0b089d48d130aeefea22da4b5cd0ca93f2e85e11)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanRelativeCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8496cf7159287e1bec12e815a0bf54ce2f4a6b7477c035bbf64b64b377e77d36)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__019c48034c5d4c6025a0c53425d5ae2906426fd64b1e5949bdc564a6931b7556)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__062138285967ff38e202baa2e0344c48f365aa7f7f0f3eb936c808ed523ea2f8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanRelativeCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanRelativeCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanRelativeCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bba2e15d1b8fa9663c22898f7cbd7f88493a546900643a5293636d58adf405bc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanRelativeCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanRelativeCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__255767ccb8cc37c2a4ad66d1c073d5c92d10efb501e3ca865e071485304c6910)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetEast")
    def reset_east(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEast", []))

    @jsii.member(jsii_name="resetEastVar")
    def reset_east_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEastVar", []))

    @jsii.member(jsii_name="resetNorth")
    def reset_north(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNorth", []))

    @jsii.member(jsii_name="resetNorthVar")
    def reset_north_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNorthVar", []))

    @jsii.member(jsii_name="resetSouth")
    def reset_south(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSouth", []))

    @jsii.member(jsii_name="resetSouthVar")
    def reset_south_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSouthVar", []))

    @jsii.member(jsii_name="resetWest")
    def reset_west(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWest", []))

    @jsii.member(jsii_name="resetWestVar")
    def reset_west_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWestVar", []))

    @builtins.property
    @jsii.member(jsii_name="eastInput")
    def east_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "eastInput"))

    @builtins.property
    @jsii.member(jsii_name="eastVarInput")
    def east_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "eastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="northInput")
    def north_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "northInput"))

    @builtins.property
    @jsii.member(jsii_name="northVarInput")
    def north_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "northVarInput"))

    @builtins.property
    @jsii.member(jsii_name="southInput")
    def south_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "southInput"))

    @builtins.property
    @jsii.member(jsii_name="southVarInput")
    def south_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "southVarInput"))

    @builtins.property
    @jsii.member(jsii_name="westInput")
    def west_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "westInput"))

    @builtins.property
    @jsii.member(jsii_name="westVarInput")
    def west_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "westVarInput"))

    @builtins.property
    @jsii.member(jsii_name="east")
    def east(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "east"))

    @east.setter
    def east(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__85e7cb17336fa6cdca5e9290388f099538fe7119821549ece26d2a5d4578cc0f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "east", value)

    @builtins.property
    @jsii.member(jsii_name="eastVar")
    def east_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "eastVar"))

    @east_var.setter
    def east_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e7634e6c79a27d6d06014415f98dcec0374ff8e2272b68d55b40581cb0365139)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "eastVar", value)

    @builtins.property
    @jsii.member(jsii_name="north")
    def north(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "north"))

    @north.setter
    def north(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__102d6be5b9bc061d994f52cabca5e8a89c846209b059f9bc456423d8fc5eb046)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "north", value)

    @builtins.property
    @jsii.member(jsii_name="northVar")
    def north_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "northVar"))

    @north_var.setter
    def north_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a9af2ef11da1db17278cd18762d1d630908ddb616c86ef64023bddc3e565bcf3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "northVar", value)

    @builtins.property
    @jsii.member(jsii_name="south")
    def south(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "south"))

    @south.setter
    def south(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ecd45d1750008aa4fa5f852617b6adbfe7f7a9ab5f51dac2d82726ae423e8050)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "south", value)

    @builtins.property
    @jsii.member(jsii_name="southVar")
    def south_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "southVar"))

    @south_var.setter
    def south_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8430c98b18ca4c3789a41355a12fd96170425efa1b6ea7fe4584780dae8b2228)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "southVar", value)

    @builtins.property
    @jsii.member(jsii_name="west")
    def west(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "west"))

    @west.setter
    def west(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3321509a870dfafba69c030730912ba3d3335e2b8c25750dffad8e50163ca78f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "west", value)

    @builtins.property
    @jsii.member(jsii_name="westVar")
    def west_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "westVar"))

    @west_var.setter
    def west_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a40a88302e89f325f575f5382f85f1a76aeb8d25ecaff7f6e590392316b32d78)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "westVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanRelativeCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanRelativeCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanRelativeCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9903304ca91347ac0ef73a40e351722e8c99e9460d8e2c74d80932cba0cc6882)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanRemoveColor",
    jsii_struct_bases=[],
    name_mapping={
        "color": "color",
        "color_var": "colorVar",
        "feather": "feather",
        "feather_var": "featherVar",
        "tolerance": "tolerance",
        "tolerance_var": "toleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanRemoveColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
        feather: typing.Optional[builtins.str] = None,
        feather_var: typing.Optional[builtins.str] = None,
        tolerance: typing.Optional[builtins.str] = None,
        tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        :param feather: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        :param feather_var: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        :param tolerance: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        :param tolerance_var: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be94b57f4c774af08b9c137e35e9a16867239c6b5f2bbd36b079db1ce0a53c5c)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
            check_type(argname="argument feather", value=feather, expected_type=type_hints["feather"])
            check_type(argname="argument feather_var", value=feather_var, expected_type=type_hints["feather_var"])
            check_type(argname="argument tolerance", value=tolerance, expected_type=type_hints["tolerance"])
            check_type(argname="argument tolerance_var", value=tolerance_var, expected_type=type_hints["tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var
        if feather is not None:
            self._values["feather"] = feather
        if feather_var is not None:
            self._values["feather_var"] = feather_var
        if tolerance is not None:
            self._values["tolerance"] = tolerance
        if tolerance_var is not None:
            self._values["tolerance_var"] = tolerance_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        '''
        result = self._values.get("feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather_var(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        '''
        result = self._values.get("feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        '''
        result = self._values.get("tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance_var(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        result = self._values.get("tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanRemoveColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanRemoveColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanRemoveColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ddb2fcd607fcc88dc99103e9be8284f931cf8492e7bcd8c47ee562d4e267d1a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanRemoveColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ad7d20d180f631538d0f201be47cfde1cf7496a551e832161003d82f03848fe)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanRemoveColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eb63a8d3743499efabaeebb9b8e5854f648bf6f67a084522a79d8daecc6ebb2e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__10bfa0c4e4a5859e374c3f576760c300df0a2b1003b9b59d1495db9ce7477bef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__800ad0e5d9c975b40e65b40770e3b12846431bec27a5326d2ace1a32528c4d7e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanRemoveColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanRemoveColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanRemoveColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__101c6f36361de14c1f0b086a190567d5f0d8265e9cef0545972e1dacada9ea55)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanRemoveColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanRemoveColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ff98292b5986a6c258a81bf6cb3e9b3b6202f0aba60fc7d69bc3f82a90234100)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @jsii.member(jsii_name="resetFeather")
    def reset_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeather", []))

    @jsii.member(jsii_name="resetFeatherVar")
    def reset_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatherVar", []))

    @jsii.member(jsii_name="resetTolerance")
    def reset_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTolerance", []))

    @jsii.member(jsii_name="resetToleranceVar")
    def reset_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featherInput")
    def feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherInput"))

    @builtins.property
    @jsii.member(jsii_name="featherVarInput")
    def feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceInput")
    def tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceVarInput")
    def tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ebc12590e84c96962741d7a841c0945ff6d8ed5b2d1262b54cd86d3c85265cd6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__77fcc3b09669bfb70a5a0a8186c2aedcc71d32f0dcfd9163a34aea0e9eaa0cb7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="feather")
    def feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "feather"))

    @feather.setter
    def feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__66000410e79c85460e04e2763de3444bb4201b255a6cf69d74a20276b924626a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "feather", value)

    @builtins.property
    @jsii.member(jsii_name="featherVar")
    def feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featherVar"))

    @feather_var.setter
    def feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__108d819a743fe64eeec41217df44ff06017719788f128fec0c8be4472c620aae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featherVar", value)

    @builtins.property
    @jsii.member(jsii_name="tolerance")
    def tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tolerance"))

    @tolerance.setter
    def tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4bde779f0a951902932355dacbba51f1004949e8dee43feebed672af6c030dff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tolerance", value)

    @builtins.property
    @jsii.member(jsii_name="toleranceVar")
    def tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "toleranceVar"))

    @tolerance_var.setter
    def tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc1b967403e731e69305fd2fff74f62471d345718fefee4aeeeedaebdd9a629b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "toleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanRemoveColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanRemoveColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanRemoveColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9cbdb369baac5b46fcc657cf1cf6b8a6a6d1ee2040d7daaa53b4c7e384f78038)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanResize",
    jsii_struct_bases=[],
    name_mapping={
        "aspect": "aspect",
        "aspect_var": "aspectVar",
        "height": "height",
        "height_var": "heightVar",
        "type": "type",
        "type_var": "typeVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanResize:
    def __init__(
        self,
        *,
        aspect: typing.Optional[builtins.str] = None,
        aspect_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param aspect: Preserves the aspect ratio. Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect DataAkamaiImagingPolicyImage#aspect}
        :param aspect_var: Preserves the aspect ratio. Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_var DataAkamaiImagingPolicyImage#aspect_var}
        :param height: The height to resize the source image to. Must be set if height is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height to resize the source image to. Must be set if height is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param type: Sets constraints for the image resize. Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: Sets constraints for the image resize. Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        :param width: The width to resize the source image to. Must be set if width is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width to resize the source image to. Must be set if width is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fcd01d98fe02a1d97f8c831439e4fae1855aabdf15856a04a0b9bbb09b01741a)
            check_type(argname="argument aspect", value=aspect, expected_type=type_hints["aspect"])
            check_type(argname="argument aspect_var", value=aspect_var, expected_type=type_hints["aspect_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if aspect is not None:
            self._values["aspect"] = aspect
        if aspect_var is not None:
            self._values["aspect_var"] = aspect_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def aspect(self) -> typing.Optional[builtins.str]:
        '''Preserves the aspect ratio.

        Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect DataAkamaiImagingPolicyImage#aspect}
        '''
        result = self._values.get("aspect")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def aspect_var(self) -> typing.Optional[builtins.str]:
        '''Preserves the aspect ratio.

        Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_var DataAkamaiImagingPolicyImage#aspect_var}
        '''
        result = self._values.get("aspect_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height to resize the source image to. Must be set if height is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height to resize the source image to. Must be set if height is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''Sets constraints for the image resize.

        Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''Sets constraints for the image resize.

        Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width to resize the source image to. Must be set if width is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width to resize the source image to. Must be set if width is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanResize(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanResizeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanResizeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8d960ee8bafe713ddcc55b8731d8b5549edb72f0f59cac82dde92464b804d93a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanResizeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d7f1b791a2b3cebc84c6b1080e69deeaef8b8746336b69ff48bda3dd8b972b5c)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanResizeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0db6e2eadfb4ae8077a6134928299d06ed3bf3eadc2681a7d28bb21fe97f3692)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__33b4cc14c294ec29ebb2ed3ef58f6f6e8190ccdce10ccde49e71769ba81208bc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7a9ed38b8b580ee3f4d5ac0891da219e61aa7959ebc30ea3488f2081abae9cb5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanResize]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanResize]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanResize]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b4602ab9fbc19b8937c15f0300ae86a50afa85126bde848617804ba8908e063d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanResizeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanResizeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dd204fcef96aa599fde4a411909cfbfb78ed7d34d078949c882b59af306c3c0f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAspect")
    def reset_aspect(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspect", []))

    @jsii.member(jsii_name="resetAspectVar")
    def reset_aspect_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspectVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="aspectInput")
    def aspect_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "aspectInput"))

    @builtins.property
    @jsii.member(jsii_name="aspectVarInput")
    def aspect_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "aspectVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="aspect")
    def aspect(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "aspect"))

    @aspect.setter
    def aspect(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f4c17bc3a1b392a49d5a2bf03805dca56e00bb1d74fb848b3394584383cc2386)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "aspect", value)

    @builtins.property
    @jsii.member(jsii_name="aspectVar")
    def aspect_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "aspectVar"))

    @aspect_var.setter
    def aspect_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__62c005f90c4ea03035c068344dab2e761245d763f6cb5deba7caada8fa79d944)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "aspectVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__32a1bee5cd84d5f93483b71fffa70cbe08b4315200f0ad6dff5207c63eed2522)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__07f36059aebe1d592d869553fe4ac60fb394d7d4132a191fbd5d2ceb829e8bf8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__badde2deb316d1c53fee3110425cb6182399714f0eae6ac47d4a800f6309643b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4965ac3e31218d857a99071964506db37efc1e4bac4fae3f7f288ef29899c858)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3c6687ab3e01c0beb1b554274c3b3a4fc33491b7f4d4cacef6734a570795dd64)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__79acbba57a2cef807039b640c738a4612a680f3034b51fe08861b5d59c7f919c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanResize]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanResize]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanResize]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__247ba5bd56b2976840ba622929ba388f28ceb28c9cac234637e7ce443530878f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanRotate",
    jsii_struct_bases=[],
    name_mapping={"degrees": "degrees", "degrees_var": "degreesVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanRotate:
    def __init__(
        self,
        *,
        degrees: typing.Optional[builtins.str] = None,
        degrees_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param degrees: The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees DataAkamaiImagingPolicyImage#degrees}
        :param degrees_var: The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees_var DataAkamaiImagingPolicyImage#degrees_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e819d68c3cfc64248f0b328713c3433e1ec17145e70edd61bfdcc94aac02f787)
            check_type(argname="argument degrees", value=degrees, expected_type=type_hints["degrees"])
            check_type(argname="argument degrees_var", value=degrees_var, expected_type=type_hints["degrees_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if degrees is not None:
            self._values["degrees"] = degrees
        if degrees_var is not None:
            self._values["degrees_var"] = degrees_var

    @builtins.property
    def degrees(self) -> typing.Optional[builtins.str]:
        '''The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees DataAkamaiImagingPolicyImage#degrees}
        '''
        result = self._values.get("degrees")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def degrees_var(self) -> typing.Optional[builtins.str]:
        '''The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees_var DataAkamaiImagingPolicyImage#degrees_var}
        '''
        result = self._values.get("degrees_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanRotate(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanRotateList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanRotateList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4337d1840d6600cffbc1c35cad497cf6a8205fbb3702f3154eeac944da8a4a21)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanRotateOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f6e33bcd2b49fcbf3ea15619b8923e94b2cb324b59a1d35a6e0ac7175fc1623)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanRotateOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1a78f9bff7e2603bb21190b4a500af19861b9af1c34524f4291e42d33577315b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cf2cf1a52c41d884eb1105e01fe37aaa0305aa9a80d17d10bed4591b7d2dc459)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__741708271ad28af9978aed807438901461505af761fc5d34e0b13230fa5ed8e4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanRotate]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanRotate]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanRotate]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2415556734efe8201be83d1b2de0882b03427553daffd32d06e165521c24aad9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanRotateOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanRotateOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a82bcf738e1b3ed0655f6f4c1631575ff455c8ae2c2d0e06e85bf2bcf08e3f8b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetDegrees")
    def reset_degrees(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDegrees", []))

    @jsii.member(jsii_name="resetDegreesVar")
    def reset_degrees_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDegreesVar", []))

    @builtins.property
    @jsii.member(jsii_name="degreesInput")
    def degrees_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "degreesInput"))

    @builtins.property
    @jsii.member(jsii_name="degreesVarInput")
    def degrees_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "degreesVarInput"))

    @builtins.property
    @jsii.member(jsii_name="degrees")
    def degrees(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "degrees"))

    @degrees.setter
    def degrees(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__db28b4f17f17ea4c7166461e561926521df47ce78e8b2630fbd4dea3e483893a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "degrees", value)

    @builtins.property
    @jsii.member(jsii_name="degreesVar")
    def degrees_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "degreesVar"))

    @degrees_var.setter
    def degrees_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__07b61b3787e8a53ac153064a6aaa14dabf59e00b87ae7f4d1aec1a5e73a930ae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "degreesVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanRotate]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanRotate]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanRotate]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ca7be71b85a58a29022be9e1d23f30fc799bcce7b656ad2a9a086a2f115b2664)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanScale",
    jsii_struct_bases=[],
    name_mapping={
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanScale:
    def __init__(
        self,
        *,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param height: Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged. Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged. Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c8358470e97e40ea66957495d0a4928987ed8b64040b88010eebceffd640f8a4)
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size.

        Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size.

        Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged.

        Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged.

        Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanScale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanScaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanScaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be5302f2c2fae51249b70f8de7ee3c87b68fdbd87457f8dfcbdfc45aa7c6e5b8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanScaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af41f17edbc37cc0b6a1821c522880ea368d6c1f672083e99f60ea3dff8eefbd)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanScaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__01f70941a4aa2dc9cbdb9b2f00660736b89edb6820e17c37799efc1bd369eac0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__20b3ca836b282765a20285b416cb2a34f7620f58e2ad8ba23a4039e76db2c15b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f9364fc542d059349545bdf3504507c2663294e3c37bec537fa301e31baca7e6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanScale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanScale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanScale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__11f27f4c047c318fc0d466d9c1124f2d884516ca5b706079db47ada2bdcac259)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanScaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanScaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f1a3b09df8ea54de89a0db5d0f1f1d3f2db8d6a42066d74ddcfc514ebb375e01)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e83eda73619778ff0fdab3593f29ee9408571d2a8a7e0975dc0f43ec181b0f0f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7ce5d5131789528004911311ca997c5a79bc55640dd75777bf1d361195900c05)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4fb183fefc0fe9c79a1650910220c4660f17b5ad354ca88e98bfd74edba8e9f6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__26b120dfaf83448d33aa3206239cefa761914f7dc96728796a564fe8a88f5e16)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanScale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanScale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanScale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8fb5e6e0f006ed2e93c04094d7065a213092e70b288afe495f7938ca9a5e6c95)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanShear",
    jsii_struct_bases=[],
    name_mapping={
        "x_shear": "xShear",
        "x_shear_var": "xShearVar",
        "y_shear": "yShear",
        "y_shear_var": "yShearVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanShear:
    def __init__(
        self,
        *,
        x_shear: typing.Optional[builtins.str] = None,
        x_shear_var: typing.Optional[builtins.str] = None,
        y_shear: typing.Optional[builtins.str] = None,
        y_shear_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param x_shear: The amount to shear along the x-axis, measured in multiples of the image's width. Must be set if yShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear DataAkamaiImagingPolicyImage#x_shear}
        :param x_shear_var: The amount to shear along the x-axis, measured in multiples of the image's width. Must be set if yShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear_var DataAkamaiImagingPolicyImage#x_shear_var}
        :param y_shear: The amount to shear along the y-axis, measured in multiples of the image's height. Must be set if xShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear DataAkamaiImagingPolicyImage#y_shear}
        :param y_shear_var: The amount to shear along the y-axis, measured in multiples of the image's height. Must be set if xShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear_var DataAkamaiImagingPolicyImage#y_shear_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__01a9f667a5fdcd2901dde60bf83ab155b33ef2850f715a3e15ad7f5681b0a9dc)
            check_type(argname="argument x_shear", value=x_shear, expected_type=type_hints["x_shear"])
            check_type(argname="argument x_shear_var", value=x_shear_var, expected_type=type_hints["x_shear_var"])
            check_type(argname="argument y_shear", value=y_shear, expected_type=type_hints["y_shear"])
            check_type(argname="argument y_shear_var", value=y_shear_var, expected_type=type_hints["y_shear_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if x_shear is not None:
            self._values["x_shear"] = x_shear
        if x_shear_var is not None:
            self._values["x_shear_var"] = x_shear_var
        if y_shear is not None:
            self._values["y_shear"] = y_shear
        if y_shear_var is not None:
            self._values["y_shear_var"] = y_shear_var

    @builtins.property
    def x_shear(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the x-axis, measured in multiples of the image's width.

        Must be set if yShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear DataAkamaiImagingPolicyImage#x_shear}
        '''
        result = self._values.get("x_shear")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_shear_var(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the x-axis, measured in multiples of the image's width.

        Must be set if yShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear_var DataAkamaiImagingPolicyImage#x_shear_var}
        '''
        result = self._values.get("x_shear_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_shear(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the y-axis, measured in multiples of the image's height.

        Must be set if xShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear DataAkamaiImagingPolicyImage#y_shear}
        '''
        result = self._values.get("y_shear")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_shear_var(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the y-axis, measured in multiples of the image's height.

        Must be set if xShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear_var DataAkamaiImagingPolicyImage#y_shear_var}
        '''
        result = self._values.get("y_shear_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanShear(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanShearList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanShearList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a13a67817d06350ac06a173ed051b9af532b051f04fea945cedd1b389f0a4b2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanShearOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9600b97d090dfd472fab0530a63be33d1d155af0fa7b5dd673d49de4a1c294b9)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanShearOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6eed0c7e704f446604e99916e9be5082ae768d89a91da1725aeac63f76330682)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__131bd9b46c9c8f7e591b1448f7fd4dcd7b1f89193abec80d00320fa4b14d61b8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ff9d067b1e3965559985ae782cc7f704a18da0a91e4876db70425f1c125c3d0a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanShear]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanShear]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanShear]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e54a6bbb03b8c351b729a900a8892a846a65571fa22d27aa11d1bfc8010b6fee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanShearOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanShearOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dfa11773879740a8c73ec93e7d9a3c1ab0a5bdaf3b01f42eceba4b11b4b98daa)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetXShear")
    def reset_x_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXShear", []))

    @jsii.member(jsii_name="resetXShearVar")
    def reset_x_shear_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXShearVar", []))

    @jsii.member(jsii_name="resetYShear")
    def reset_y_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYShear", []))

    @jsii.member(jsii_name="resetYShearVar")
    def reset_y_shear_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYShearVar", []))

    @builtins.property
    @jsii.member(jsii_name="xShearInput")
    def x_shear_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xShearInput"))

    @builtins.property
    @jsii.member(jsii_name="xShearVarInput")
    def x_shear_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xShearVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yShearInput")
    def y_shear_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yShearInput"))

    @builtins.property
    @jsii.member(jsii_name="yShearVarInput")
    def y_shear_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yShearVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xShear")
    def x_shear(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xShear"))

    @x_shear.setter
    def x_shear(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f3c2e9f72fccdb73f27687d7429ad7aa1b8c472467696dfad3b6fdf4cacea9a3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xShear", value)

    @builtins.property
    @jsii.member(jsii_name="xShearVar")
    def x_shear_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xShearVar"))

    @x_shear_var.setter
    def x_shear_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f8c388479fb6c9cbd119144dc631932c3a9532f2208d10fc8a4873df3f5c306)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xShearVar", value)

    @builtins.property
    @jsii.member(jsii_name="yShear")
    def y_shear(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yShear"))

    @y_shear.setter
    def y_shear(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d4b8efb46499440fef080e85029afcdc8c206106a1f387bc909d6ebe76c9712f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yShear", value)

    @builtins.property
    @jsii.member(jsii_name="yShearVar")
    def y_shear_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yShearVar"))

    @y_shear_var.setter
    def y_shear_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e4c6a6fef7cc794be3ee1fce6a0c1904e54b1a25f14b43d240b2cf8bb6791ecc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yShearVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanShear]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanShear]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanShear]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e19fd800a84899284f65c7c788d1e442e6dbc81cf0f7ed79c5023a1bd5ae5eef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanTrim",
    jsii_struct_bases=[],
    name_mapping={
        "fuzz": "fuzz",
        "fuzz_var": "fuzzVar",
        "padding": "padding",
        "padding_var": "paddingVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanTrim:
    def __init__(
        self,
        *,
        fuzz: typing.Optional[builtins.str] = None,
        fuzz_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fuzz: The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz DataAkamaiImagingPolicyImage#fuzz}
        :param fuzz_var: The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz_var DataAkamaiImagingPolicyImage#fuzz_var}
        :param padding: The amount of padding in pixels to add to the trimmed image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: The amount of padding in pixels to add to the trimmed image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d417b20ce75e94d695469ae8cbfc194dcb9c488f541a0247d76781600f1075b)
            check_type(argname="argument fuzz", value=fuzz, expected_type=type_hints["fuzz"])
            check_type(argname="argument fuzz_var", value=fuzz_var, expected_type=type_hints["fuzz_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fuzz is not None:
            self._values["fuzz"] = fuzz
        if fuzz_var is not None:
            self._values["fuzz_var"] = fuzz_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var

    @builtins.property
    def fuzz(self) -> typing.Optional[builtins.str]:
        '''The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz DataAkamaiImagingPolicyImage#fuzz}
        '''
        result = self._values.get("fuzz")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fuzz_var(self) -> typing.Optional[builtins.str]:
        '''The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz_var DataAkamaiImagingPolicyImage#fuzz_var}
        '''
        result = self._values.get("fuzz_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''The amount of padding in pixels to add to the trimmed image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''The amount of padding in pixels to add to the trimmed image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanTrim(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanTrimList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanTrimList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1b2d1e97d445d074eecdcb259a526f52dd4351ed2426f8a8befd2deb2e077703)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanTrimOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9f4b2f45d85149bab9ca6efc91ed92adce0612c0be504d5e683a785749e0b8d3)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanTrimOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1c4700d25fabeb9280f13ad8e7e071ebfaf38853ca2c974a467cd188b23f4f8c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e5b86627aeae6c1e96717db9af421bff54734ee61dce725ea430b15af5cd98b9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1fbbbd7edc69f55627cb7f5960ab0f09bb57bbb6d936ddc7dc65ef01a59b0987)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanTrim]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanTrim]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanTrim]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a9690be42f59b313438d1ab1e0fb4309962202de685ca5d7495b36c0d94b719)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanTrimOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanTrimOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0c0618a106cd99f17e2e2055c865391ef85182346a213c55346f20247f73f3c0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetFuzz")
    def reset_fuzz(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFuzz", []))

    @jsii.member(jsii_name="resetFuzzVar")
    def reset_fuzz_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFuzzVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @builtins.property
    @jsii.member(jsii_name="fuzzInput")
    def fuzz_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fuzzInput"))

    @builtins.property
    @jsii.member(jsii_name="fuzzVarInput")
    def fuzz_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fuzzVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="fuzz")
    def fuzz(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fuzz"))

    @fuzz.setter
    def fuzz(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e4f60e59c1de4ec63ecafad1b19ee8d99bdba762292b07c2ced0772b5d4ffec5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fuzz", value)

    @builtins.property
    @jsii.member(jsii_name="fuzzVar")
    def fuzz_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fuzzVar"))

    @fuzz_var.setter
    def fuzz_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dd1d0d0f050d5dc36abb00350bac7f64f2259ec9705d379c950860f836b6dd42)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fuzzVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3431f848ab55e5662bbc79f7a1db5514b2e217970be07a2a4334d1b5a47becc6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cee92f117850f7028ee104f3c49290204d3804961775d103a06427af6c00ade3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanTrim]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanTrim]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanTrim]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__077e44ee2024416728ee2e81c49bac855632d8d71480878418bfdb381c23d737)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanUnsharpMask",
    jsii_struct_bases=[],
    name_mapping={
        "gain": "gain",
        "gain_var": "gainVar",
        "sigma": "sigma",
        "sigma_var": "sigmaVar",
        "threshold": "threshold",
        "threshold_var": "thresholdVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanUnsharpMask:
    def __init__(
        self,
        *,
        gain: typing.Optional[builtins.str] = None,
        gain_var: typing.Optional[builtins.str] = None,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
        threshold: typing.Optional[builtins.str] = None,
        threshold_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param gain: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        :param gain_var: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        :param sigma: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        :param threshold: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        :param threshold_var: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d47ee71e745cb249f99be3cea28b3ff5f0667ccd4a8315c4fcbeb8ff8f68be4b)
            check_type(argname="argument gain", value=gain, expected_type=type_hints["gain"])
            check_type(argname="argument gain_var", value=gain_var, expected_type=type_hints["gain_var"])
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
            check_type(argname="argument threshold", value=threshold, expected_type=type_hints["threshold"])
            check_type(argname="argument threshold_var", value=threshold_var, expected_type=type_hints["threshold_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if gain is not None:
            self._values["gain"] = gain
        if gain_var is not None:
            self._values["gain_var"] = gain_var
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var
        if threshold is not None:
            self._values["threshold"] = threshold
        if threshold_var is not None:
            self._values["threshold_var"] = threshold_var

    @builtins.property
    def gain(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        '''
        result = self._values.get("gain")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gain_var(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        '''
        result = self._values.get("gain_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        '''
        result = self._values.get("threshold")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold_var(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        result = self._values.get("threshold_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanUnsharpMask(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanUnsharpMaskList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanUnsharpMaskList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ccf75116573735dccbdb50b5aef9f601d4e5878980402ef72d1beafdf3f0f48)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanUnsharpMaskOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__87a41395d0753cc907c699062fc2b9494f03a941af49c5f88c5eb50979dcca51)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanUnsharpMaskOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__68993fc182e7ec5bbff8e4ed2894750fd0124b14b867d7c0570ef4040a29e32c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f3971259e0bbb0c7e230506385108b70e85358186d1eb6f9749e4a7f0b2beb35)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2594b75f7204ba59d809c947234f817b42110d4d9727db48cf60bb6342516007)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanUnsharpMask]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanUnsharpMask]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanUnsharpMask]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__020a4f4389047c9152d203dd6472d910bfe552fa0ab010b6bb5247ea8f1598fe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanUnsharpMaskOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanUnsharpMaskOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__09cc9554883865cee99b0013fc0835e5809b3fcf6e2d706a1be2dfb607b83a1c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetGain")
    def reset_gain(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGain", []))

    @jsii.member(jsii_name="resetGainVar")
    def reset_gain_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGainVar", []))

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @jsii.member(jsii_name="resetThreshold")
    def reset_threshold(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThreshold", []))

    @jsii.member(jsii_name="resetThresholdVar")
    def reset_threshold_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThresholdVar", []))

    @builtins.property
    @jsii.member(jsii_name="gainInput")
    def gain_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainInput"))

    @builtins.property
    @jsii.member(jsii_name="gainVarInput")
    def gain_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdInput")
    def threshold_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdVarInput")
    def threshold_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gain")
    def gain(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gain"))

    @gain.setter
    def gain(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f0ac987932977833b735d317f506b3e4aac6e8cf21c7858f5ef4c1a2a6730637)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gain", value)

    @builtins.property
    @jsii.member(jsii_name="gainVar")
    def gain_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gainVar"))

    @gain_var.setter
    def gain_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8ce037ff7858dbea38212c874697e915b3cf7fa89bd4b992208c62ede2e878c3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gainVar", value)

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dd05039c799042e080588ddf7975c8ac2861975fcc5eadbe08b8bd925031d4b0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__332eeeebdcba1dc8384cbea7c4e821e4c472d81b064acc784863844da695a96a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="threshold")
    def threshold(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "threshold"))

    @threshold.setter
    def threshold(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ead5471a6fb1c1bb6e51f10d973959eb188dd953199fd74fcce60dc827d273cc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "threshold", value)

    @builtins.property
    @jsii.member(jsii_name="thresholdVar")
    def threshold_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "thresholdVar"))

    @threshold_var.setter
    def threshold_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f8abeaae2c3f450b6b41620a414a2bdeb53ea63f283e728aaa78657e2958a5f3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "thresholdVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanUnsharpMask]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanUnsharpMask]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanUnsharpMask]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5d45c642c5430ad6cff0329046344be53b6cd0f7d5f9030654d6da7b99e8e40a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThan",
    jsii_struct_bases=[],
    name_mapping={
        "append": "append",
        "aspect_crop": "aspectCrop",
        "background_color": "backgroundColor",
        "blur": "blur",
        "chroma_key": "chromaKey",
        "composite": "composite",
        "compound": "compound",
        "contrast": "contrast",
        "crop": "crop",
        "face_crop": "faceCrop",
        "feature_crop": "featureCrop",
        "fit_and_fill": "fitAndFill",
        "goop": "goop",
        "grayscale": "grayscale",
        "hsl": "hsl",
        "hsv": "hsv",
        "if_dimension": "ifDimension",
        "if_orientation": "ifOrientation",
        "im_query": "imQuery",
        "max_colors": "maxColors",
        "mirror": "mirror",
        "mono_hue": "monoHue",
        "opacity": "opacity",
        "region_of_interest_crop": "regionOfInterestCrop",
        "relative_crop": "relativeCrop",
        "remove_color": "removeColor",
        "resize": "resize",
        "rotate": "rotate",
        "scale": "scale",
        "shear": "shear",
        "trim": "trim",
        "unsharp_mask": "unsharpMask",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThan:
    def __init__(
        self,
        *,
        append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanAppend", typing.Dict[builtins.str, typing.Any]]]]] = None,
        aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanAspectCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanBackgroundColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanBlur", typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanChromaKey", typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanComposite", typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanCompound", typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanContrast", typing.Dict[builtins.str, typing.Any]]]]] = None,
        crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanFaceCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanFeatureCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanFitAndFill", typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanGoop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanGrayscale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanHsl", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanHsv", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfDimension", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientation", typing.Dict[builtins.str, typing.Any]]]]] = None,
        im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanImQuery", typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanMaxColors", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanMirror", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanMonoHue", typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanOpacity", typing.Dict[builtins.str, typing.Any]]]]] = None,
        region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanRegionOfInterestCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanRelativeCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanRemoveColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanResize", typing.Dict[builtins.str, typing.Any]]]]] = None,
        rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanRotate", typing.Dict[builtins.str, typing.Any]]]]] = None,
        scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanScale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanShear", typing.Dict[builtins.str, typing.Any]]]]] = None,
        trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanTrim", typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanUnsharpMask", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param append: append block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        :param aspect_crop: aspect_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param crop: crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        :param face_crop: face_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        :param feature_crop: feature_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        :param fit_and_fill: fit_and_fill block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param im_query: im_query block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param region_of_interest_crop: region_of_interest_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        :param relative_crop: relative_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param resize: resize block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        :param rotate: rotate block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        :param scale: scale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param shear: shear block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        :param trim: trim block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__35f91d790b78a9938ad792ba7bc4d8d18e3cfa92f366e1ab4a50669db603f24b)
            check_type(argname="argument append", value=append, expected_type=type_hints["append"])
            check_type(argname="argument aspect_crop", value=aspect_crop, expected_type=type_hints["aspect_crop"])
            check_type(argname="argument background_color", value=background_color, expected_type=type_hints["background_color"])
            check_type(argname="argument blur", value=blur, expected_type=type_hints["blur"])
            check_type(argname="argument chroma_key", value=chroma_key, expected_type=type_hints["chroma_key"])
            check_type(argname="argument composite", value=composite, expected_type=type_hints["composite"])
            check_type(argname="argument compound", value=compound, expected_type=type_hints["compound"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument crop", value=crop, expected_type=type_hints["crop"])
            check_type(argname="argument face_crop", value=face_crop, expected_type=type_hints["face_crop"])
            check_type(argname="argument feature_crop", value=feature_crop, expected_type=type_hints["feature_crop"])
            check_type(argname="argument fit_and_fill", value=fit_and_fill, expected_type=type_hints["fit_and_fill"])
            check_type(argname="argument goop", value=goop, expected_type=type_hints["goop"])
            check_type(argname="argument grayscale", value=grayscale, expected_type=type_hints["grayscale"])
            check_type(argname="argument hsl", value=hsl, expected_type=type_hints["hsl"])
            check_type(argname="argument hsv", value=hsv, expected_type=type_hints["hsv"])
            check_type(argname="argument if_dimension", value=if_dimension, expected_type=type_hints["if_dimension"])
            check_type(argname="argument if_orientation", value=if_orientation, expected_type=type_hints["if_orientation"])
            check_type(argname="argument im_query", value=im_query, expected_type=type_hints["im_query"])
            check_type(argname="argument max_colors", value=max_colors, expected_type=type_hints["max_colors"])
            check_type(argname="argument mirror", value=mirror, expected_type=type_hints["mirror"])
            check_type(argname="argument mono_hue", value=mono_hue, expected_type=type_hints["mono_hue"])
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument region_of_interest_crop", value=region_of_interest_crop, expected_type=type_hints["region_of_interest_crop"])
            check_type(argname="argument relative_crop", value=relative_crop, expected_type=type_hints["relative_crop"])
            check_type(argname="argument remove_color", value=remove_color, expected_type=type_hints["remove_color"])
            check_type(argname="argument resize", value=resize, expected_type=type_hints["resize"])
            check_type(argname="argument rotate", value=rotate, expected_type=type_hints["rotate"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument shear", value=shear, expected_type=type_hints["shear"])
            check_type(argname="argument trim", value=trim, expected_type=type_hints["trim"])
            check_type(argname="argument unsharp_mask", value=unsharp_mask, expected_type=type_hints["unsharp_mask"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if append is not None:
            self._values["append"] = append
        if aspect_crop is not None:
            self._values["aspect_crop"] = aspect_crop
        if background_color is not None:
            self._values["background_color"] = background_color
        if blur is not None:
            self._values["blur"] = blur
        if chroma_key is not None:
            self._values["chroma_key"] = chroma_key
        if composite is not None:
            self._values["composite"] = composite
        if compound is not None:
            self._values["compound"] = compound
        if contrast is not None:
            self._values["contrast"] = contrast
        if crop is not None:
            self._values["crop"] = crop
        if face_crop is not None:
            self._values["face_crop"] = face_crop
        if feature_crop is not None:
            self._values["feature_crop"] = feature_crop
        if fit_and_fill is not None:
            self._values["fit_and_fill"] = fit_and_fill
        if goop is not None:
            self._values["goop"] = goop
        if grayscale is not None:
            self._values["grayscale"] = grayscale
        if hsl is not None:
            self._values["hsl"] = hsl
        if hsv is not None:
            self._values["hsv"] = hsv
        if if_dimension is not None:
            self._values["if_dimension"] = if_dimension
        if if_orientation is not None:
            self._values["if_orientation"] = if_orientation
        if im_query is not None:
            self._values["im_query"] = im_query
        if max_colors is not None:
            self._values["max_colors"] = max_colors
        if mirror is not None:
            self._values["mirror"] = mirror
        if mono_hue is not None:
            self._values["mono_hue"] = mono_hue
        if opacity is not None:
            self._values["opacity"] = opacity
        if region_of_interest_crop is not None:
            self._values["region_of_interest_crop"] = region_of_interest_crop
        if relative_crop is not None:
            self._values["relative_crop"] = relative_crop
        if remove_color is not None:
            self._values["remove_color"] = remove_color
        if resize is not None:
            self._values["resize"] = resize
        if rotate is not None:
            self._values["rotate"] = rotate
        if scale is not None:
            self._values["scale"] = scale
        if shear is not None:
            self._values["shear"] = shear
        if trim is not None:
            self._values["trim"] = trim
        if unsharp_mask is not None:
            self._values["unsharp_mask"] = unsharp_mask

    @builtins.property
    def append(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanAppend"]]]:
        '''append block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        '''
        result = self._values.get("append")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanAppend"]]], result)

    @builtins.property
    def aspect_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanAspectCrop"]]]:
        '''aspect_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        '''
        result = self._values.get("aspect_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanAspectCrop"]]], result)

    @builtins.property
    def background_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanBackgroundColor"]]]:
        '''background_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        '''
        result = self._values.get("background_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanBackgroundColor"]]], result)

    @builtins.property
    def blur(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanBlur"]]]:
        '''blur block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        '''
        result = self._values.get("blur")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanBlur"]]], result)

    @builtins.property
    def chroma_key(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanChromaKey"]]]:
        '''chroma_key block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        '''
        result = self._values.get("chroma_key")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanChromaKey"]]], result)

    @builtins.property
    def composite(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanComposite"]]]:
        '''composite block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        '''
        result = self._values.get("composite")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanComposite"]]], result)

    @builtins.property
    def compound(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanCompound"]]]:
        '''compound block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        '''
        result = self._values.get("compound")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanCompound"]]], result)

    @builtins.property
    def contrast(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanContrast"]]]:
        '''contrast block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanContrast"]]], result)

    @builtins.property
    def crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanCrop"]]]:
        '''crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        '''
        result = self._values.get("crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanCrop"]]], result)

    @builtins.property
    def face_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanFaceCrop"]]]:
        '''face_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        '''
        result = self._values.get("face_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanFaceCrop"]]], result)

    @builtins.property
    def feature_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanFeatureCrop"]]]:
        '''feature_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        '''
        result = self._values.get("feature_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanFeatureCrop"]]], result)

    @builtins.property
    def fit_and_fill(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanFitAndFill"]]]:
        '''fit_and_fill block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        '''
        result = self._values.get("fit_and_fill")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanFitAndFill"]]], result)

    @builtins.property
    def goop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanGoop"]]]:
        '''goop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        '''
        result = self._values.get("goop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanGoop"]]], result)

    @builtins.property
    def grayscale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanGrayscale"]]]:
        '''grayscale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        '''
        result = self._values.get("grayscale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanGrayscale"]]], result)

    @builtins.property
    def hsl(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanHsl"]]]:
        '''hsl block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        '''
        result = self._values.get("hsl")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanHsl"]]], result)

    @builtins.property
    def hsv(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanHsv"]]]:
        '''hsv block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        '''
        result = self._values.get("hsv")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanHsv"]]], result)

    @builtins.property
    def if_dimension(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfDimension"]]]:
        '''if_dimension block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        '''
        result = self._values.get("if_dimension")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfDimension"]]], result)

    @builtins.property
    def if_orientation(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientation"]]]:
        '''if_orientation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        '''
        result = self._values.get("if_orientation")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientation"]]], result)

    @builtins.property
    def im_query(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanImQuery"]]]:
        '''im_query block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        '''
        result = self._values.get("im_query")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanImQuery"]]], result)

    @builtins.property
    def max_colors(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanMaxColors"]]]:
        '''max_colors block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        '''
        result = self._values.get("max_colors")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanMaxColors"]]], result)

    @builtins.property
    def mirror(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanMirror"]]]:
        '''mirror block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        '''
        result = self._values.get("mirror")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanMirror"]]], result)

    @builtins.property
    def mono_hue(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanMonoHue"]]]:
        '''mono_hue block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        '''
        result = self._values.get("mono_hue")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanMonoHue"]]], result)

    @builtins.property
    def opacity(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanOpacity"]]]:
        '''opacity block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanOpacity"]]], result)

    @builtins.property
    def region_of_interest_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanRegionOfInterestCrop"]]]:
        '''region_of_interest_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        '''
        result = self._values.get("region_of_interest_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanRegionOfInterestCrop"]]], result)

    @builtins.property
    def relative_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanRelativeCrop"]]]:
        '''relative_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        '''
        result = self._values.get("relative_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanRelativeCrop"]]], result)

    @builtins.property
    def remove_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanRemoveColor"]]]:
        '''remove_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        '''
        result = self._values.get("remove_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanRemoveColor"]]], result)

    @builtins.property
    def resize(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanResize"]]]:
        '''resize block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        '''
        result = self._values.get("resize")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanResize"]]], result)

    @builtins.property
    def rotate(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanRotate"]]]:
        '''rotate block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        '''
        result = self._values.get("rotate")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanRotate"]]], result)

    @builtins.property
    def scale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanScale"]]]:
        '''scale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanScale"]]], result)

    @builtins.property
    def shear(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanShear"]]]:
        '''shear block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        '''
        result = self._values.get("shear")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanShear"]]], result)

    @builtins.property
    def trim(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanTrim"]]]:
        '''trim block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        '''
        result = self._values.get("trim")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanTrim"]]], result)

    @builtins.property
    def unsharp_mask(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanUnsharpMask"]]]:
        '''unsharp_mask block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        result = self._values.get("unsharp_mask")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanUnsharpMask"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanAppend",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_priority": "gravityPriority",
        "gravity_priority_var": "gravityPriorityVar",
        "gravity_var": "gravityVar",
        "preserve_minor_dimension": "preserveMinorDimension",
        "preserve_minor_dimension_var": "preserveMinorDimensionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanAppend:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanAppendImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_priority: typing.Optional[builtins.str] = None,
        gravity_priority_var: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        preserve_minor_dimension: typing.Optional[builtins.str] = None,
        preserve_minor_dimension_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Specifies where to place the ``image`` relative to the source image. The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_priority: Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal. The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority DataAkamaiImagingPolicyImage#gravity_priority}
        :param gravity_priority_var: Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal. The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority_var DataAkamaiImagingPolicyImage#gravity_priority_var}
        :param gravity_var: Specifies where to place the ``image`` relative to the source image. The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param preserve_minor_dimension: Whether to preserve the source image's minor dimension, ``false`` by default. The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension DataAkamaiImagingPolicyImage#preserve_minor_dimension}
        :param preserve_minor_dimension_var: Whether to preserve the source image's minor dimension, ``false`` by default. The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension_var DataAkamaiImagingPolicyImage#preserve_minor_dimension_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanAppendImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__421fc0e00f0f96fba5c06293658314b8da342a32239cb82752d9586b11877a3b)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_priority", value=gravity_priority, expected_type=type_hints["gravity_priority"])
            check_type(argname="argument gravity_priority_var", value=gravity_priority_var, expected_type=type_hints["gravity_priority_var"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument preserve_minor_dimension", value=preserve_minor_dimension, expected_type=type_hints["preserve_minor_dimension"])
            check_type(argname="argument preserve_minor_dimension_var", value=preserve_minor_dimension_var, expected_type=type_hints["preserve_minor_dimension_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_priority is not None:
            self._values["gravity_priority"] = gravity_priority
        if gravity_priority_var is not None:
            self._values["gravity_priority_var"] = gravity_priority_var
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if preserve_minor_dimension is not None:
            self._values["preserve_minor_dimension"] = preserve_minor_dimension
        if preserve_minor_dimension_var is not None:
            self._values["preserve_minor_dimension_var"] = preserve_minor_dimension_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanAppendImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanAppendImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Specifies where to place the ``image`` relative to the source image.

        The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_priority(self) -> typing.Optional[builtins.str]:
        '''Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal.

        The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority DataAkamaiImagingPolicyImage#gravity_priority}
        '''
        result = self._values.get("gravity_priority")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_priority_var(self) -> typing.Optional[builtins.str]:
        '''Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal.

        The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority_var DataAkamaiImagingPolicyImage#gravity_priority_var}
        '''
        result = self._values.get("gravity_priority_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Specifies where to place the ``image`` relative to the source image.

        The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def preserve_minor_dimension(self) -> typing.Optional[builtins.str]:
        '''Whether to preserve the source image's minor dimension, ``false`` by default.

        The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension DataAkamaiImagingPolicyImage#preserve_minor_dimension}
        '''
        result = self._values.get("preserve_minor_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def preserve_minor_dimension_var(self) -> typing.Optional[builtins.str]:
        '''Whether to preserve the source image's minor dimension, ``false`` by default.

        The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension_var DataAkamaiImagingPolicyImage#preserve_minor_dimension_var}
        '''
        result = self._values.get("preserve_minor_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanAppend(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanAppendImage",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanAppendImage:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanAppendImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanAppendImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanAppendImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2179cd03550a384ab0589707dad1588b88e35ec13a9c2dd423cb1d67e7db63e5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanAppendImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanAppendImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanAppendImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9cea033f22c14e069e59fcf1e89166b3a23b66e166102056da6c8072d9aedd1f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanAppendList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanAppendList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__87b1f329502b854db4fd156ebc2f701445e428ff27d30c229babf83aacf3a665)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanAppendOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8710829de35447f1698eaba1104259859c069deb8d6769965dcd77a2a59bd73c)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanAppendOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__03af0330f9c1d6e969e1ce0de1d13d86dc52e51ec8115dc4fb48c0d83766939d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0cb93459114e3ef138af218fcdd1e1f43da1a0c41a293e6ed73fccc61f7071f7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e1748c1d310a5332108f0215ae15bc925034ed44413031c24da17c421a64b13)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanAppend]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanAppend]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanAppend]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__48c627e02d35b3509db8e2824d3e09f9ea5ad38766c096ad7a820513e3f87be0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanAppendOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanAppendOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e22d04119da61feeb8cc57035464ef8522019714957e58f507933b65cb726cce)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanAppendImage()

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityPriority")
    def reset_gravity_priority(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityPriority", []))

    @jsii.member(jsii_name="resetGravityPriorityVar")
    def reset_gravity_priority_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityPriorityVar", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPreserveMinorDimension")
    def reset_preserve_minor_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPreserveMinorDimension", []))

    @jsii.member(jsii_name="resetPreserveMinorDimensionVar")
    def reset_preserve_minor_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPreserveMinorDimensionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanAppendImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanAppendImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityInput")
    def gravity_priority_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityPriorityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityVarInput")
    def gravity_priority_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityPriorityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanAppendImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanAppendImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionInput")
    def preserve_minor_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "preserveMinorDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionVarInput")
    def preserve_minor_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "preserveMinorDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cb2d2427e03a6b28333148b2ffaa4411edb5a6fd42635d2b3f01a55f63bb13c3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityPriority")
    def gravity_priority(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityPriority"))

    @gravity_priority.setter
    def gravity_priority(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1df1c4bf0c28204f8121ca2894d7b1fea71c92398aea9ad67bce7367927cde58)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityPriority", value)

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityVar")
    def gravity_priority_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityPriorityVar"))

    @gravity_priority_var.setter
    def gravity_priority_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0bbf6e7eb310e374383678cf9a8fe3ec146ec97b1258a258b8429c28cda124b0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityPriorityVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a37d4b2e20c2810def8b4f26c2b71a671b90eb9e0325d6f97cf4159b5f926a7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimension")
    def preserve_minor_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "preserveMinorDimension"))

    @preserve_minor_dimension.setter
    def preserve_minor_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8207db6b1dd3ec330b44da8e0258628e03afe2f8d06de130c08c9c5432ce3de4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "preserveMinorDimension", value)

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionVar")
    def preserve_minor_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "preserveMinorDimensionVar"))

    @preserve_minor_dimension_var.setter
    def preserve_minor_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__768113e539a83066ec54c4f076c75e79a6823b43b8ff560b1eafa8f51838844d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "preserveMinorDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanAppend]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanAppend]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanAppend]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__acd397f9bea773ec72dc419a57933c36a6bf6541be33dbb19de3b276719dd048)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanAspectCrop",
    jsii_struct_bases=[],
    name_mapping={
        "allow_expansion": "allowExpansion",
        "allow_expansion_var": "allowExpansionVar",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanAspectCrop:
    def __init__(
        self,
        *,
        allow_expansion: typing.Optional[builtins.str] = None,
        allow_expansion_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_expansion: Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image. Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        :param allow_expansion_var: Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image. Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        :param height: The height term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The width term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        :param x_position: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__04c102de7c560badb466050df9249ae8af01c3c3430a32ab4922867b5f32d875)
            check_type(argname="argument allow_expansion", value=allow_expansion, expected_type=type_hints["allow_expansion"])
            check_type(argname="argument allow_expansion_var", value=allow_expansion_var, expected_type=type_hints["allow_expansion_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if allow_expansion is not None:
            self._values["allow_expansion"] = allow_expansion
        if allow_expansion_var is not None:
            self._values["allow_expansion_var"] = allow_expansion_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def allow_expansion(self) -> typing.Optional[builtins.str]:
        '''Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image.

        Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        '''
        result = self._values.get("allow_expansion")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def allow_expansion_var(self) -> typing.Optional[builtins.str]:
        '''Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image.

        Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        '''
        result = self._values.get("allow_expansion_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanAspectCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanAspectCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanAspectCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__515166ad7c47abc634fe1c2674328b5c2c1e6c98eec40622a04db067cf90a699)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanAspectCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d27124a6f9d75ea935622111362438f4199f3c16d020b6fd73b9a0a4fbc1d5d5)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanAspectCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a5c9d08e4fab54ed945ef2f48dc53a9043701248d330301fd3476d70f737de4c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__42c2ab972d8f52f02e80b3f8439abcf4e3afbdbfee675766d8081f60ade3e465)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__987437193c08895f401881466d59c06a02268feb8719771d3422bb8b7d864d48)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanAspectCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanAspectCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanAspectCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ba74ce87712f9cd80594cc3d9a9473232ddd241f1162bc0d091c1eba67979e4e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanAspectCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanAspectCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3b1d66eaf3995d36cb4d5a3e3e3bcb95910d3fe5d31b04478143d50d61b676d8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAllowExpansion")
    def reset_allow_expansion(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansion", []))

    @jsii.member(jsii_name="resetAllowExpansionVar")
    def reset_allow_expansion_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansionVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionInput")
    def allow_expansion_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVarInput")
    def allow_expansion_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansion")
    def allow_expansion(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansion"))

    @allow_expansion.setter
    def allow_expansion(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ead2be744ffdb09462ed930cc751297d8cb41460d9afedf23baf4cbd6c0359f3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansion", value)

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVar")
    def allow_expansion_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansionVar"))

    @allow_expansion_var.setter
    def allow_expansion_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f9e649d0426dc9f2322cfc3bd4368407fcb128ec34a6838c6edcebd6d3d31472)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansionVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6949f5014e546a0edd52f83d69a78912ef1bdcabb7774a01d87f5e4504bae651)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b3ca1ed4fbd429caea5898ff3cf8a9ab2fa191a1a19b1380b4a599dfb39e833b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__28744fbf1bef8058d7aa7abb451a9fc963de88ff95926c17f1490ee3b7fb2734)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__81f4ad22e80d8ee5e7a90ce3f60ae216dcacb37f476bf2825d19bb75220ffe09)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__98cd17df027e9d2fe84154ba822c446c5f89bc8df3e7d6cbd99cef7f258dcd72)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f0161d5e44ff3c7e870f43f082097495ab420ddd67a36d849f745cce3ed2bc82)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0b334dce5cac7e5e7f08dd4c30d28716e0e977aeed9c248f5c8359586c50b882)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__023124732951fca602631bb0aef6666c0e1e390757ee9f2d917135426ca76d3f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanAspectCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanAspectCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanAspectCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e9c4c381723a7a0b22217e3bf4336bf4d19ee4544e00129453cacd77fb3949f2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanBackgroundColor",
    jsii_struct_bases=[],
    name_mapping={"color": "color", "color_var": "colorVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanBackgroundColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb4c172db1eb57861600c5fe6892eca8284d32e51eb52b7b280418fc2dd9047e)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanBackgroundColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanBackgroundColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanBackgroundColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__113a80aca18b3a264bb31590d6cf7531e180d23477ad467b081198297c7ba28d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanBackgroundColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2172d99aec54d7a009880be45f7d872c21a89b1164d0f28b85f4c0df25c5b0a4)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanBackgroundColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6d20278a5b4d4e4d47570eae4a146140264ba79bdf9ce0b68e58be4a88a96ed3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a9b1e7fe454bed803b2516fdfdb753a6a9112c3118af50c1d0fd3f3391131902)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cba4afbe50aa2ac63a63f46ca624b18f21d411dd023025b82677ffaffd05f907)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanBackgroundColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanBackgroundColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7cec40b465d990ba03fa19a93c40b40d511e40915ea7a792aa2f10002623aec6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanBackgroundColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanBackgroundColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__875bf651526417a4ab96b6e60c223b782bc10a7814d50a8d2d75b8575611cbe5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4101e9f41131dfe0851e93579a53e7939fdff212295f3afdce3e6b43b6962a79)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ead22fb8ac031e3bf36a98bac8588e284c49234780b173575db268d679cc6a70)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanBackgroundColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanBackgroundColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanBackgroundColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ab1fe6f2bc99311d0bb855acd5ef7f158e23fccd90d24214b2a61f3c4c4f3d9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanBlur",
    jsii_struct_bases=[],
    name_mapping={"sigma": "sigma", "sigma_var": "sigmaVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanBlur:
    def __init__(
        self,
        *,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param sigma: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f73559cd1c830f3254ff912f77cdfa88eb732a59f89cdbbd5058ff47047f2d47)
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanBlur(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanBlurList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanBlurList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__63582afbb8b7a979afed724e0457fd0e722590db6baee10e87aa1d46835fd6be)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanBlurOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7876889f863b0cac784c938df474bda404ac1218e2b6071f76ea5f4df0f04221)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanBlurOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0851abeab8236e04c3d4c7e1a3be3b794d1a57c9ac29ab09d61aa5b939be6b04)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__332523cd94758de32cdeb20847fb9304fa5bd48ade061271a8953d6d67a22ca6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9c977dcf35d51060b9d5289279b00b1e24c0515ef899b80dabcab0662152dc50)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanBlur]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanBlur]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__27516726244a96b931a8598e96c5140b55b81c4484fa17626725b8ae2683d497)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanBlurOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanBlurOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bd700a30fc82243c41b9d073b4dea6490f5a808f7ebdb18490a3831ed1558dfd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__845a1c2dfe5d6ffa77515e57b59a4eb59c6be5a28272b4a991d351b6aaac59b5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f0ec6f09ed99a6bd482cacc2e3f7e8715aff72252e6077fb20c3d170a08a1203)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanBlur]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanBlur]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanBlur]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a883782eed253ac4570c2f1c1fb4ee1e4def6652fe54956df425b03400fa080d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanChromaKey",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_feather": "hueFeather",
        "hue_feather_var": "hueFeatherVar",
        "hue_tolerance": "hueTolerance",
        "hue_tolerance_var": "hueToleranceVar",
        "hue_var": "hueVar",
        "lightness_feather": "lightnessFeather",
        "lightness_feather_var": "lightnessFeatherVar",
        "lightness_tolerance": "lightnessTolerance",
        "lightness_tolerance_var": "lightnessToleranceVar",
        "saturation_feather": "saturationFeather",
        "saturation_feather_var": "saturationFeatherVar",
        "saturation_tolerance": "saturationTolerance",
        "saturation_tolerance_var": "saturationToleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanChromaKey:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_feather: typing.Optional[builtins.str] = None,
        hue_feather_var: typing.Optional[builtins.str] = None,
        hue_tolerance: typing.Optional[builtins.str] = None,
        hue_tolerance_var: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness_feather: typing.Optional[builtins.str] = None,
        lightness_feather_var: typing.Optional[builtins.str] = None,
        lightness_tolerance: typing.Optional[builtins.str] = None,
        lightness_tolerance_var: typing.Optional[builtins.str] = None,
        saturation_feather: typing.Optional[builtins.str] = None,
        saturation_feather_var: typing.Optional[builtins.str] = None,
        saturation_tolerance: typing.Optional[builtins.str] = None,
        saturation_tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_feather: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        :param hue_feather_var: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        :param hue_tolerance: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        :param hue_tolerance_var: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        :param hue_var: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness_feather: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        :param lightness_feather_var: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        :param lightness_tolerance: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        :param lightness_tolerance_var: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        :param saturation_feather: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        :param saturation_feather_var: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        :param saturation_tolerance: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        :param saturation_tolerance_var: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ca45c3f16f305c4267c7561ad545772d67e80aae83e5fc0a0d73e88c9c7dd8e8)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_feather", value=hue_feather, expected_type=type_hints["hue_feather"])
            check_type(argname="argument hue_feather_var", value=hue_feather_var, expected_type=type_hints["hue_feather_var"])
            check_type(argname="argument hue_tolerance", value=hue_tolerance, expected_type=type_hints["hue_tolerance"])
            check_type(argname="argument hue_tolerance_var", value=hue_tolerance_var, expected_type=type_hints["hue_tolerance_var"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness_feather", value=lightness_feather, expected_type=type_hints["lightness_feather"])
            check_type(argname="argument lightness_feather_var", value=lightness_feather_var, expected_type=type_hints["lightness_feather_var"])
            check_type(argname="argument lightness_tolerance", value=lightness_tolerance, expected_type=type_hints["lightness_tolerance"])
            check_type(argname="argument lightness_tolerance_var", value=lightness_tolerance_var, expected_type=type_hints["lightness_tolerance_var"])
            check_type(argname="argument saturation_feather", value=saturation_feather, expected_type=type_hints["saturation_feather"])
            check_type(argname="argument saturation_feather_var", value=saturation_feather_var, expected_type=type_hints["saturation_feather_var"])
            check_type(argname="argument saturation_tolerance", value=saturation_tolerance, expected_type=type_hints["saturation_tolerance"])
            check_type(argname="argument saturation_tolerance_var", value=saturation_tolerance_var, expected_type=type_hints["saturation_tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_feather is not None:
            self._values["hue_feather"] = hue_feather
        if hue_feather_var is not None:
            self._values["hue_feather_var"] = hue_feather_var
        if hue_tolerance is not None:
            self._values["hue_tolerance"] = hue_tolerance
        if hue_tolerance_var is not None:
            self._values["hue_tolerance_var"] = hue_tolerance_var
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness_feather is not None:
            self._values["lightness_feather"] = lightness_feather
        if lightness_feather_var is not None:
            self._values["lightness_feather_var"] = lightness_feather_var
        if lightness_tolerance is not None:
            self._values["lightness_tolerance"] = lightness_tolerance
        if lightness_tolerance_var is not None:
            self._values["lightness_tolerance_var"] = lightness_tolerance_var
        if saturation_feather is not None:
            self._values["saturation_feather"] = saturation_feather
        if saturation_feather_var is not None:
            self._values["saturation_feather_var"] = saturation_feather_var
        if saturation_tolerance is not None:
            self._values["saturation_tolerance"] = saturation_tolerance
        if saturation_tolerance_var is not None:
            self._values["saturation_tolerance_var"] = saturation_tolerance_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        '''
        result = self._values.get("hue_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        '''
        result = self._values.get("hue_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        '''
        result = self._values.get("hue_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        '''
        result = self._values.get("hue_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        '''
        result = self._values.get("lightness_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        '''
        result = self._values.get("lightness_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        '''
        result = self._values.get("lightness_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        '''
        result = self._values.get("lightness_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        '''
        result = self._values.get("saturation_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        '''
        result = self._values.get("saturation_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        '''
        result = self._values.get("saturation_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        result = self._values.get("saturation_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanChromaKey(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanChromaKeyList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanChromaKeyList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ca4f6f73ae92ecad9c1b5861c87449a95da26c0f9b240369c00ffbdc1688f793)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanChromaKeyOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6440434a956cbd0a69b70699088ff09caa693ccb5e7dbe9b8a8d4dac42159329)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanChromaKeyOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bac076d48fa8362788991b915bdd593a268e2f942ee66e78d27de94848a4035a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__50bd42863aa1062b3bfbef80fb1dcd0c7860f61934963909f36b210b8e763aeb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ba65f4059cd4ae3659eab5613995bb2d26fc6cd35f796df20a6149c92bcfaeec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanChromaKey]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanChromaKey]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__23553e7f5e0c18e4117208241644d039f825fb8b7f92d804c5a64403882dd65f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanChromaKeyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanChromaKeyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b40e5eb1886995c007a3d34b0c797dba38ce4c98b9a71059168cd998a6399c82)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueFeather")
    def reset_hue_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeather", []))

    @jsii.member(jsii_name="resetHueFeatherVar")
    def reset_hue_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeatherVar", []))

    @jsii.member(jsii_name="resetHueTolerance")
    def reset_hue_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueTolerance", []))

    @jsii.member(jsii_name="resetHueToleranceVar")
    def reset_hue_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueToleranceVar", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightnessFeather")
    def reset_lightness_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeather", []))

    @jsii.member(jsii_name="resetLightnessFeatherVar")
    def reset_lightness_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeatherVar", []))

    @jsii.member(jsii_name="resetLightnessTolerance")
    def reset_lightness_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessTolerance", []))

    @jsii.member(jsii_name="resetLightnessToleranceVar")
    def reset_lightness_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessToleranceVar", []))

    @jsii.member(jsii_name="resetSaturationFeather")
    def reset_saturation_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeather", []))

    @jsii.member(jsii_name="resetSaturationFeatherVar")
    def reset_saturation_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeatherVar", []))

    @jsii.member(jsii_name="resetSaturationTolerance")
    def reset_saturation_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationTolerance", []))

    @jsii.member(jsii_name="resetSaturationToleranceVar")
    def reset_saturation_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherInput")
    def hue_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVarInput")
    def hue_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceInput")
    def hue_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVarInput")
    def hue_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherInput")
    def lightness_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVarInput")
    def lightness_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceInput")
    def lightness_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVarInput")
    def lightness_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherInput")
    def saturation_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVarInput")
    def saturation_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceInput")
    def saturation_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVarInput")
    def saturation_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3557f97f9a24cbde628f1b10aa6ab5cdea78964fedac9b06bea8e1422a5182c1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeather")
    def hue_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeather"))

    @hue_feather.setter
    def hue_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5a48af198220116329ac97d69dc74a25a59e3fab95c7eb92996cc4a157144a0b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeather", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVar")
    def hue_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeatherVar"))

    @hue_feather_var.setter
    def hue_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__64cb926afa9c9f02c3be72c41ee0a9351cd54906046f23f945a4f4cac7b2ee0a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueTolerance")
    def hue_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueTolerance"))

    @hue_tolerance.setter
    def hue_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__68969668d06c6025305341f7e7a30d8f6bd04aa886c671e746c080fc7d7ffe7c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVar")
    def hue_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueToleranceVar"))

    @hue_tolerance_var.setter
    def hue_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9078151307e3ea841a6e1879f35a00a9d17b2304a124fdf84f5d619f9b5d1a9b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9fc3447287bfb57f0a17075f6d42cf9ed79c3eadbb049de23d3108c3e71147d2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeather")
    def lightness_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeather"))

    @lightness_feather.setter
    def lightness_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c0a8592108ed0e000e016c447af96571f80f571130bfe19591a26972441c6adb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeather", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVar")
    def lightness_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeatherVar"))

    @lightness_feather_var.setter
    def lightness_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1597c0a7d2dc0b800967241f56759ed25211cf640ea57d2bb11122d0da6fe42f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessTolerance")
    def lightness_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessTolerance"))

    @lightness_tolerance.setter
    def lightness_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a78c7ec973d1800edd7d727ddc0b1a342f02a1259a67946727a3d383b0b58890)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVar")
    def lightness_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessToleranceVar"))

    @lightness_tolerance_var.setter
    def lightness_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6fa0a05d456fc8bf4d96b1f4cde86664ba3d5933727710af75b0170e9fa948ae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeather")
    def saturation_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeather"))

    @saturation_feather.setter
    def saturation_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a63c9a27d04acd31d7d2f75c938c6244b52e3fe6a69b7d2e0f79ae117e0e56b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeather", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVar")
    def saturation_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeatherVar"))

    @saturation_feather_var.setter
    def saturation_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb634d557be1f9fd88f8ce597cd0dae903b83695d9a98a0b590f6aaf2d232284)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationTolerance")
    def saturation_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationTolerance"))

    @saturation_tolerance.setter
    def saturation_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dba63bd98f6c355eb26d607d3c3f1380f12d5b7db8782bfe3b2927ab79b7c550)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVar")
    def saturation_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationToleranceVar"))

    @saturation_tolerance_var.setter
    def saturation_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ce6afbcdcb59dfc705ffc582a8a10195bde1022d8988fab1fa67574e8363d5a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanChromaKey]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanChromaKey]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanChromaKey]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__119e8912ffb7c163f69caf540e735e0ad8fe645b2cb52240eb7ba6236866038b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanComposite",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "placement": "placement",
        "placement_var": "placementVar",
        "scale": "scale",
        "scale_dimension": "scaleDimension",
        "scale_dimension_var": "scaleDimensionVar",
        "scale_var": "scaleVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanComposite:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanCompositeImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        placement: typing.Optional[builtins.str] = None,
        placement_var: typing.Optional[builtins.str] = None,
        scale: typing.Optional[builtins.str] = None,
        scale_dimension: typing.Optional[builtins.str] = None,
        scale_dimension_var: typing.Optional[builtins.str] = None,
        scale_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param placement: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        :param placement_var: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        :param scale: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param scale_dimension: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        :param scale_dimension_var: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        :param scale_var: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        :param x_position: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanCompositeImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__19336eb70a2ad43cbbbceb97c4d679c30e806d51c6a3959fa71783572d118997)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument placement", value=placement, expected_type=type_hints["placement"])
            check_type(argname="argument placement_var", value=placement_var, expected_type=type_hints["placement_var"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument scale_dimension", value=scale_dimension, expected_type=type_hints["scale_dimension"])
            check_type(argname="argument scale_dimension_var", value=scale_dimension_var, expected_type=type_hints["scale_dimension_var"])
            check_type(argname="argument scale_var", value=scale_var, expected_type=type_hints["scale_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if placement is not None:
            self._values["placement"] = placement
        if placement_var is not None:
            self._values["placement_var"] = placement_var
        if scale is not None:
            self._values["scale"] = scale
        if scale_dimension is not None:
            self._values["scale_dimension"] = scale_dimension
        if scale_dimension_var is not None:
            self._values["scale_dimension_var"] = scale_dimension_var
        if scale_var is not None:
            self._values["scale_var"] = scale_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanCompositeImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanCompositeImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        '''
        result = self._values.get("placement")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement_var(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        '''
        result = self._values.get("placement_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        '''
        result = self._values.get("scale_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        '''
        result = self._values.get("scale_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        '''
        result = self._values.get("scale_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanComposite(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanCompositeImage",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanCompositeImage:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanCompositeImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanCompositeImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanCompositeImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c26c00d8f9fad4230a663a3d7f58cc73343fe238b546d9c281c7f04d207d892c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanCompositeImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanCompositeImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5a8f3a97918b657048c31d2a176b7d51566cef3073049bef4f193df437c03e4d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanCompositeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanCompositeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__84755dc4339504d39773ebbba43f6f89ba296ad2def95960b2cb82349afc1ccc)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanCompositeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__110de76179e10a95c3d964b7648519a55f9d30d92e657687184f5254fe07b493)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanCompositeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__039a29eb25a79fe6a872f4791ccfdc60cda86a7c18377ece81eb24a8a5b825e3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7b5144d22c726fdab51b4ce8053ead37fdbe9a391cd689f9dd3e2dc76a1e1619)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a1ee5dc6c2808bf809ed44f52f2c5bca0d817029fe70bcdaafd3357b08ca31d3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanComposite]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanComposite]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__607bdd6975f4ddd5be3dc7d2c7dbdb84eaab7e2b57f5663a234ef6a15d365c82)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanCompositeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanCompositeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b1845a4bda9b317e81096b3f26feaed819cf4beb0eb013a5e770dea5b190b759)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanCompositeImage()

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPlacement")
    def reset_placement(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacement", []))

    @jsii.member(jsii_name="resetPlacementVar")
    def reset_placement_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacementVar", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetScaleDimension")
    def reset_scale_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimension", []))

    @jsii.member(jsii_name="resetScaleDimensionVar")
    def reset_scale_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimensionVar", []))

    @jsii.member(jsii_name="resetScaleVar")
    def reset_scale_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanCompositeImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanCompositeImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanCompositeImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="placementInput")
    def placement_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementInput"))

    @builtins.property
    @jsii.member(jsii_name="placementVarInput")
    def placement_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionInput")
    def scale_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVarInput")
    def scale_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleVarInput")
    def scale_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__64627cb9037477dec5c871f5f200f87cee58f3b8df174152d032b3c9492a9a51)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5158565c8d200ecb8d4710c1473ba755f9b15a62ba0f430b719338edfe3b610b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="placement")
    def placement(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placement"))

    @placement.setter
    def placement(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a7aa6d7f22fdb9d928ceb91431dbd63fbaf3c13ebec119f5be752be5c2ffe3d9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placement", value)

    @builtins.property
    @jsii.member(jsii_name="placementVar")
    def placement_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placementVar"))

    @placement_var.setter
    def placement_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__90c7e415af94fba941968b417cbde22ba4163f9b67b8208dc611a1ee58218e42)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placementVar", value)

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scale"))

    @scale.setter
    def scale(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8cb297f125beccf7387eb0e6370b317290bdf9b83df743ccde82a9c0e5e8ef21)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scale", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimension")
    def scale_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimension"))

    @scale_dimension.setter
    def scale_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4e8ee043406a9d045f3f4cc87ad8d8808f885d0d7f540905fc2c93a01d8bedef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimension", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVar")
    def scale_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimensionVar"))

    @scale_dimension_var.setter
    def scale_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__72eb0a5e6df826ed0f1a8f37ba2fe8ac7e342ca7f0ca000ea7d69688b888c6f3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="scaleVar")
    def scale_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleVar"))

    @scale_var.setter
    def scale_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7fef08df87ae1a56ce793efd9470e842e128bbc939c8e68dfcc3ac482509b4a2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fe0fc8ae78490bfcfc1f98fa88686f1e8b272bd61511b715aa4f5fbf924c1532)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4c44777256307e16033535b4f72850f914713aeca5bb49ce8d748edce8973cfc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__76773450c5612feca18c7b71c5d73c9c154f60cb14d20e848a110b3f9993b86b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__472e6f7046d42c614ce249fcdcf0b8268f58b227f75f119b3d0ffe2f60cea167)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanComposite]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanComposite]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanComposite]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__86010e9d865dc2746bdb95a1c2776967cc2640af40a3ee1b5b23d9e1623684d8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanCompound",
    jsii_struct_bases=[],
    name_mapping={"transformations": "transformations"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanCompound:
    def __init__(
        self,
        *,
        transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param transformations: transformations block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d2d0073f4b23844e1c4ea7536dcce5b93cedee9f0ef32730c34550976ad7d4d)
            check_type(argname="argument transformations", value=transformations, expected_type=type_hints["transformations"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if transformations is not None:
            self._values["transformations"] = transformations

    @builtins.property
    def transformations(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanCompoundTransformations"]]]:
        '''transformations block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        result = self._values.get("transformations")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanCompoundTransformations"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanCompound(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanCompoundList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanCompoundList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__abbd2937c616ec0dee9cdfc483f0c2268384cbeda987e5702c8feac3a3d173bc)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanCompoundOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b8ae4c704443bd26273c88aff0e696a797aa90a2a825fe6dd320dfe28d2c7acb)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanCompoundOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aaa5a5c4339d64cfb88780e7e60c0ec876f0b5a0ab6401723cb2cf955e12a7cf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3c769567ff2b05b88b3a2784336b1cf620e5b3e06ef3b34b5575c7b09d9e8dcc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f825b4f56fdd849c9899120284cf85de8e105fe7ffdee1ba41f8b2aa2ba7b0bb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanCompound]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanCompound]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ffa454719dd057a0b2a35b5a9258b59af12e92113073e7c07133524b2b41603f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanCompoundOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanCompoundOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__04c839d25f7a02dfa2b3daf420d6596533b3b5ae7e40b10081d7463a7a957595)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformations")
    def put_transformations(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__231d7ef38f52d4c21edbb0e3d80d40839a8bde67321b5ead066a99f0ca14cb69)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTransformations", [value]))

    @jsii.member(jsii_name="resetTransformations")
    def reset_transformations(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformations", []))

    @builtins.property
    @jsii.member(jsii_name="transformations")
    def transformations(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanCompoundTransformationsList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanCompoundTransformationsList", jsii.get(self, "transformations"))

    @builtins.property
    @jsii.member(jsii_name="transformationsInput")
    def transformations_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanCompoundTransformations"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanCompoundTransformations"]]], jsii.get(self, "transformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanCompound]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanCompound]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanCompound]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__336216b7e3c38822f7dcb8b775b1327cb7a2556dd87a1766bfdce25dc6f19db5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanCompoundTransformations",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanCompoundTransformations:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanCompoundTransformations(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanCompoundTransformationsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanCompoundTransformationsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df3c3a36ff64fe1bfb301645da4371557d74b4b7ec756ccd283f40df1ed16bae)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanCompoundTransformationsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__71497abdee9bed09224684dbb9cbdd5dd2ec5d97c262876817d0398053bfb514)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanCompoundTransformationsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cdd5c26e30e032bfd6b9b95b868171a7f2b6b44db54c62a5b888e4cb0bdbe1fa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4561b2ac916126a21375bacbb5bf161c72a2279d74024054e496c3942bc1056c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6d5fd8cb6fb369de3a2c1f78b0df4fa94829af977ac2bf41f5fe2875a55666bf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanCompoundTransformations]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanCompoundTransformations]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanCompoundTransformations]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fece84d7ee2286ac2956186bbc5f54c432cde39f1128c70355de35fe9af29499)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanCompoundTransformationsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanCompoundTransformationsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e1cac0e3a3ccce95a1e4542d905e8cc9beaba9a789691157136972a69e4edcdd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanCompoundTransformations]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanCompoundTransformations]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanCompoundTransformations]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__115afe171c2de01168003a1871f04df54ad6e032e56b0a0f7304a48f25910f50)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanContrast",
    jsii_struct_bases=[],
    name_mapping={
        "brightness": "brightness",
        "brightness_var": "brightnessVar",
        "contrast": "contrast",
        "contrast_var": "contrastVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanContrast:
    def __init__(
        self,
        *,
        brightness: typing.Optional[builtins.str] = None,
        brightness_var: typing.Optional[builtins.str] = None,
        contrast: typing.Optional[builtins.str] = None,
        contrast_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param brightness: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        :param brightness_var: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        :param contrast: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param contrast_var: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9437db7237b5406bec0d2cd33b1fbcb3dfff7a84f3b7c5caeba8c7f9a454aabc)
            check_type(argname="argument brightness", value=brightness, expected_type=type_hints["brightness"])
            check_type(argname="argument brightness_var", value=brightness_var, expected_type=type_hints["brightness_var"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument contrast_var", value=contrast_var, expected_type=type_hints["contrast_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if brightness is not None:
            self._values["brightness"] = brightness
        if brightness_var is not None:
            self._values["brightness_var"] = brightness_var
        if contrast is not None:
            self._values["contrast"] = contrast
        if contrast_var is not None:
            self._values["contrast_var"] = contrast_var

    @builtins.property
    def brightness(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        '''
        result = self._values.get("brightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def brightness_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        '''
        result = self._values.get("brightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        result = self._values.get("contrast_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanContrast(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanContrastList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanContrastList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c6881b081abef48e14db8ddfaf8f70113c1ef7351725a7b142fbdc2ef4bcbe49)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanContrastOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__450f3bf492b644d9c8b8e6f0b1ce9d4a1e232007b0375d0549b0e7a9d8344e4d)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanContrastOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9dd906684a5fe5f69c2e7d2ef99feb27fea9d7743ecd241dd44202e64663bcb8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e6e9de702af0ea09d89cbfe5c8f06912545f13e75ba8ea6d4575b3fd448ce99e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1a220da33105692bbf2540cc29b6eac9902afd995e7b5a93b5b5532205d87e3e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanContrast]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanContrast]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7f73fe37b31f8e794c53b7cac289ada4487bcf940a5b02eabba51ce04695fc8f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanContrastOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanContrastOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__88b33c1ab90d4cebd5ae136c8f84b7ebbcaffc9e363febe20b291bc2eb158dde)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetBrightness")
    def reset_brightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightness", []))

    @jsii.member(jsii_name="resetBrightnessVar")
    def reset_brightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightnessVar", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetContrastVar")
    def reset_contrast_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrastVar", []))

    @builtins.property
    @jsii.member(jsii_name="brightnessInput")
    def brightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="brightnessVarInput")
    def brightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastVarInput")
    def contrast_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="brightness")
    def brightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightness"))

    @brightness.setter
    def brightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b87807764f7fa68fb8f6f8eecd640c5e1f7fa7c0ed6254661c2de1e1cc8fac1d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightness", value)

    @builtins.property
    @jsii.member(jsii_name="brightnessVar")
    def brightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightnessVar"))

    @brightness_var.setter
    def brightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ff0e4e51e2534675a081771bbbe1e3c9987046294107b6a4f54330269857fc1e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrast"))

    @contrast.setter
    def contrast(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f504c944b60623db6a32d1d39e72e6c081a38e11e9dffd8bc9028e120188fb31)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrast", value)

    @builtins.property
    @jsii.member(jsii_name="contrastVar")
    def contrast_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrastVar"))

    @contrast_var.setter
    def contrast_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6cc98655373aab540893af7fb7778ab71aa83dc86f6def1380f654f3dd688480)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrastVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanContrast]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanContrast]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanContrast]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1c6e399c33ca79e78bd6e42e3dbe617bd91b830a9e9fd9072a735cc327ee6b37)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanCrop",
    jsii_struct_bases=[],
    name_mapping={
        "allow_expansion": "allowExpansion",
        "allow_expansion_var": "allowExpansionVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanCrop:
    def __init__(
        self,
        *,
        allow_expansion: typing.Optional[builtins.str] = None,
        allow_expansion_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_expansion: If cropping an area outside of the existing canvas, expands the image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        :param allow_expansion_var: If cropping an area outside of the existing canvas, expands the image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        :param gravity: Frame of reference for X and Y Positions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Frame of reference for X and Y Positions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The number of pixels to crop along the y-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The number of pixels to crop along the y-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The number of pixels to crop along the x-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The number of pixels to crop along the x-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        :param x_position: The x-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__143484a2dab280c78bf7779b5caadc607bc7cf46fcf8566a8316a3d3067f244b)
            check_type(argname="argument allow_expansion", value=allow_expansion, expected_type=type_hints["allow_expansion"])
            check_type(argname="argument allow_expansion_var", value=allow_expansion_var, expected_type=type_hints["allow_expansion_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if allow_expansion is not None:
            self._values["allow_expansion"] = allow_expansion
        if allow_expansion_var is not None:
            self._values["allow_expansion_var"] = allow_expansion_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def allow_expansion(self) -> typing.Optional[builtins.str]:
        '''If cropping an area outside of the existing canvas, expands the image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        '''
        result = self._values.get("allow_expansion")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def allow_expansion_var(self) -> typing.Optional[builtins.str]:
        '''If cropping an area outside of the existing canvas, expands the image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        '''
        result = self._values.get("allow_expansion_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Frame of reference for X and Y Positions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Frame of reference for X and Y Positions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the y-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the y-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the x-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the x-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c15714fc6879864fbd976d51119a18f71f2b1ca17641df37622b8081b2f74775)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ec74872c670e68c4b49308e7babaca15adf29568d1fa7036e16a95a13d809c3b)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b3269eabcbadebc3eff96a3955f301d1d191d8650a3502e4548e3f2905ee4f4f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c66e4493ec783a3add27aa7adca07a402d87dffb5e4a53d44b25f0ebf8e664d9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__edec1f5cc6f66b84f2e85eab634d6b082358f842a0f9d24335a9c13bf87cccec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__acc4936ceda0e830f3abb418d1a4b1eb8f0d7ab9f9d7331575d8beb6ff500de7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4d0784445dcb7de63c2ff9af5b08099c0c818f35d7e46781600035697000ae50)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAllowExpansion")
    def reset_allow_expansion(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansion", []))

    @jsii.member(jsii_name="resetAllowExpansionVar")
    def reset_allow_expansion_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansionVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionInput")
    def allow_expansion_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVarInput")
    def allow_expansion_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansion")
    def allow_expansion(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansion"))

    @allow_expansion.setter
    def allow_expansion(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2dd9fe72782ea7b814268e70ef3bd5044187e3c149bd553004b1d3ce30b40622)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansion", value)

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVar")
    def allow_expansion_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansionVar"))

    @allow_expansion_var.setter
    def allow_expansion_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b1bcf6058bfacab8ca3e4c94da5f0f90b34633812f522002cc7decaa70a91f80)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansionVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__56e9771419afbb4e638ab16e4577e41fb73fc0ed1ee715ea477f397a005c015b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__36e24e331502d64aeef5db38feed37d7ba36a045e25f8f471daed93f6dcc269f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3d4a925c413ff9c857c64ff0e6f255255a9547263dd0dfb0983793f054665d18)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1a954db8c1318010a8c0b1eda795f8b2723f82ca06a1ef9e47e237f0653ddd38)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__02cb7162d094fbefb5a80a940e5dc2637e6e60374accd6f514b8fbbb062663e1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f92de6b831316754012faf0cb858c8c1c099105ab3dd8b2d01e85426a2bf489d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5a4ad86bccbd614319da2b859c8110e54eb901256bce006db76c2138c6747e8e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2433bf0ae60fdb93a3a50176a07526831b3437aeeee597cf8671f8dc0a65e0e9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__86f79e638093a226d37b5787b5911f841219b4ae6b8927127d4e96b01a363545)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__694cceb406abd17cabbe267bcd7b37943cf8498527f75352c4ab370acc7b3b02)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5d52a912e08e3114ec09843ad086e56d1c831f16f96ec1e2c52841118171ed3f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanFaceCrop",
    jsii_struct_bases=[],
    name_mapping={
        "algorithm": "algorithm",
        "algorithm_var": "algorithmVar",
        "confidence": "confidence",
        "confidence_var": "confidenceVar",
        "fail_gravity": "failGravity",
        "fail_gravity_var": "failGravityVar",
        "focus": "focus",
        "focus_var": "focusVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "padding": "padding",
        "padding_var": "paddingVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanFaceCrop:
    def __init__(
        self,
        *,
        algorithm: typing.Optional[builtins.str] = None,
        algorithm_var: typing.Optional[builtins.str] = None,
        confidence: typing.Optional[builtins.str] = None,
        confidence_var: typing.Optional[builtins.str] = None,
        fail_gravity: typing.Optional[builtins.str] = None,
        fail_gravity_var: typing.Optional[builtins.str] = None,
        focus: typing.Optional[builtins.str] = None,
        focus_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param algorithm: Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm DataAkamaiImagingPolicyImage#algorithm}
        :param algorithm_var: Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm_var DataAkamaiImagingPolicyImage#algorithm_var}
        :param confidence: With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image. Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence DataAkamaiImagingPolicyImage#confidence}
        :param confidence_var: With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image. Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence_var DataAkamaiImagingPolicyImage#confidence_var}
        :param fail_gravity: Controls placement of the crop if Image and Video Manager does not detect any faces in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        :param fail_gravity_var: Controls placement of the crop if Image and Video Manager does not detect any faces in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        :param focus: Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus DataAkamaiImagingPolicyImage#focus}
        :param focus_var: Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus_var DataAkamaiImagingPolicyImage#focus_var}
        :param gravity: Controls placement of the crop. Directions are relative to the face(s) plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Controls placement of the crop. Directions are relative to the face(s) plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param padding: The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        :param style: Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ee0897898a43e430867d4b62e816be28679a68c86897105511f0e1f9ff57b477)
            check_type(argname="argument algorithm", value=algorithm, expected_type=type_hints["algorithm"])
            check_type(argname="argument algorithm_var", value=algorithm_var, expected_type=type_hints["algorithm_var"])
            check_type(argname="argument confidence", value=confidence, expected_type=type_hints["confidence"])
            check_type(argname="argument confidence_var", value=confidence_var, expected_type=type_hints["confidence_var"])
            check_type(argname="argument fail_gravity", value=fail_gravity, expected_type=type_hints["fail_gravity"])
            check_type(argname="argument fail_gravity_var", value=fail_gravity_var, expected_type=type_hints["fail_gravity_var"])
            check_type(argname="argument focus", value=focus, expected_type=type_hints["focus"])
            check_type(argname="argument focus_var", value=focus_var, expected_type=type_hints["focus_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if algorithm is not None:
            self._values["algorithm"] = algorithm
        if algorithm_var is not None:
            self._values["algorithm_var"] = algorithm_var
        if confidence is not None:
            self._values["confidence"] = confidence
        if confidence_var is not None:
            self._values["confidence_var"] = confidence_var
        if fail_gravity is not None:
            self._values["fail_gravity"] = fail_gravity
        if fail_gravity_var is not None:
            self._values["fail_gravity_var"] = fail_gravity_var
        if focus is not None:
            self._values["focus"] = focus
        if focus_var is not None:
            self._values["focus_var"] = focus_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def algorithm(self) -> typing.Optional[builtins.str]:
        '''Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm DataAkamaiImagingPolicyImage#algorithm}
        '''
        result = self._values.get("algorithm")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def algorithm_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm_var DataAkamaiImagingPolicyImage#algorithm_var}
        '''
        result = self._values.get("algorithm_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def confidence(self) -> typing.Optional[builtins.str]:
        '''With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image.

        Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence DataAkamaiImagingPolicyImage#confidence}
        '''
        result = self._values.get("confidence")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def confidence_var(self) -> typing.Optional[builtins.str]:
        '''With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image.

        Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence_var DataAkamaiImagingPolicyImage#confidence_var}
        '''
        result = self._values.get("confidence_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any faces in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        '''
        result = self._values.get("fail_gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any faces in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        '''
        result = self._values.get("fail_gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def focus(self) -> typing.Optional[builtins.str]:
        '''Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus DataAkamaiImagingPolicyImage#focus}
        '''
        result = self._values.get("focus")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def focus_var(self) -> typing.Optional[builtins.str]:
        '''Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus_var DataAkamaiImagingPolicyImage#focus_var}
        '''
        result = self._values.get("focus_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the face(s) plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the face(s) plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanFaceCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanFaceCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanFaceCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ad0b82d46083dd3e27f92a167f72d3c2ad77fa1d4e763cbe36b574cb207bb930)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanFaceCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e058601f3640e27c6f01628d2a37359080819733531775f908f5a3981e7387df)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanFaceCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__969c2c45c1a7ed32b806c08cc2e037a9748710e4fa1064b6acd10e361e140f30)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ffd2636d3686dcf17093c58e1279e20f5626b9c2758e448ec9241b852b518d6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3419b33e0d677133abdd457563ca3d0ff2f5b87df12dddb98bd7c0ba7ad06fcc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanFaceCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanFaceCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanFaceCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7e7cd6e426f4dd57c191aa901c8794139f70b0f2aed6ca631d0672779cf706ac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanFaceCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanFaceCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e788961e3d65baa627859d028f82b136f95177cb3b2eee73795a22d57096cf0c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAlgorithm")
    def reset_algorithm(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAlgorithm", []))

    @jsii.member(jsii_name="resetAlgorithmVar")
    def reset_algorithm_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAlgorithmVar", []))

    @jsii.member(jsii_name="resetConfidence")
    def reset_confidence(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetConfidence", []))

    @jsii.member(jsii_name="resetConfidenceVar")
    def reset_confidence_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetConfidenceVar", []))

    @jsii.member(jsii_name="resetFailGravity")
    def reset_fail_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravity", []))

    @jsii.member(jsii_name="resetFailGravityVar")
    def reset_fail_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravityVar", []))

    @jsii.member(jsii_name="resetFocus")
    def reset_focus(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFocus", []))

    @jsii.member(jsii_name="resetFocusVar")
    def reset_focus_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFocusVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="algorithmInput")
    def algorithm_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "algorithmInput"))

    @builtins.property
    @jsii.member(jsii_name="algorithmVarInput")
    def algorithm_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "algorithmVarInput"))

    @builtins.property
    @jsii.member(jsii_name="confidenceInput")
    def confidence_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "confidenceInput"))

    @builtins.property
    @jsii.member(jsii_name="confidenceVarInput")
    def confidence_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "confidenceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityInput")
    def fail_gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityVarInput")
    def fail_gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="focusInput")
    def focus_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "focusInput"))

    @builtins.property
    @jsii.member(jsii_name="focusVarInput")
    def focus_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "focusVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="algorithm")
    def algorithm(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "algorithm"))

    @algorithm.setter
    def algorithm(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a668059d392d06a3b379e172817e0ae0a15909c18918e6a733ea88f4b9ef8e15)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "algorithm", value)

    @builtins.property
    @jsii.member(jsii_name="algorithmVar")
    def algorithm_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "algorithmVar"))

    @algorithm_var.setter
    def algorithm_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7da89de49707a540cf5143ed7237908367a90b7450f47dc1530eab4f12aac4eb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "algorithmVar", value)

    @builtins.property
    @jsii.member(jsii_name="confidence")
    def confidence(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "confidence"))

    @confidence.setter
    def confidence(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f6e0ec71f580441e96f923fbc4ebd8aca7b635e80d55ea03036b886ba5750b54)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "confidence", value)

    @builtins.property
    @jsii.member(jsii_name="confidenceVar")
    def confidence_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "confidenceVar"))

    @confidence_var.setter
    def confidence_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7ca3f72ac85a1c7bf6cb4b62c830f12d05c71b639fe1949ce1046408e90eaa31)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "confidenceVar", value)

    @builtins.property
    @jsii.member(jsii_name="failGravity")
    def fail_gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravity"))

    @fail_gravity.setter
    def fail_gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3773e7453ef88c552a37523fb1c86465f35dfc2c9b7433518d56a0a71ed1254f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravity", value)

    @builtins.property
    @jsii.member(jsii_name="failGravityVar")
    def fail_gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravityVar"))

    @fail_gravity_var.setter
    def fail_gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c1e5d86def3d8600fbb1c73123f67c03b8c442d43f346951610a3b38182d98da)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="focus")
    def focus(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "focus"))

    @focus.setter
    def focus(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__791e1743e85fa43d55351930589ed93ff8828c350b944fd1c927671773767ed8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "focus", value)

    @builtins.property
    @jsii.member(jsii_name="focusVar")
    def focus_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "focusVar"))

    @focus_var.setter
    def focus_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a0c090fc4e053376ce1a6045cf5272ffc32843568995bd7a8bca94862a73102c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "focusVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9294c6cca21c8e9368622db90b5034166415731d650ec60ceef7d08eab8c2f86)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__85bd0974374323630a32e185bc707fcd1fc22833a5f4dbaf2d3390886e9bb1ee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__de47197628e379f5fd525a0810bfff21c9796c9c7af6147546cd3b1229fca11d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__018d5da3722c81d59d954e0f05517aba80c8e88014cd505aef700de3f754bb04)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a52aa8f3be8c2d96609e5dd7a01e9cfb6afeef0729ccb5497734fe9bce9beb7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__687cbbc25134066ca527fd39589319b68deb789cea9ec507cd3de4be17e83c07)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f433347b18920090a99694d3aba2e2fb7797227ca9075d570a7c163559140274)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__36e88544e824531a080d175680bee3083c5b374a89bb300ccd308fbb089f233c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__81242a317ebccd9d611b17d8e07fb21898aee947d2c417026b4b8945cc4dcba5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__287b20ec150751bb4abeaf8936628e298408c3e535ef1a90ba99262b7208c19d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanFaceCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanFaceCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanFaceCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__04d9d7d6b8023b49c8f3a07e3ca56b340cce8b80ca93ab65a34ca9da0cb9b02e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanFeatureCrop",
    jsii_struct_bases=[],
    name_mapping={
        "fail_gravity": "failGravity",
        "fail_gravity_var": "failGravityVar",
        "feature_radius": "featureRadius",
        "feature_radius_var": "featureRadiusVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "max_features": "maxFeatures",
        "max_features_var": "maxFeaturesVar",
        "min_feature_quality": "minFeatureQuality",
        "min_feature_quality_var": "minFeatureQualityVar",
        "padding": "padding",
        "padding_var": "paddingVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanFeatureCrop:
    def __init__(
        self,
        *,
        fail_gravity: typing.Optional[builtins.str] = None,
        fail_gravity_var: typing.Optional[builtins.str] = None,
        feature_radius: typing.Optional[builtins.str] = None,
        feature_radius_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        max_features: typing.Optional[builtins.str] = None,
        max_features_var: typing.Optional[builtins.str] = None,
        min_feature_quality: typing.Optional[builtins.str] = None,
        min_feature_quality_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fail_gravity: Controls placement of the crop if Image and Video Manager does not detect any features in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        :param fail_gravity_var: Controls placement of the crop if Image and Video Manager does not detect any features in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        :param feature_radius: The size in pixels of the important features to search for. If identified, two features never appear closer together than this value, ``8.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius DataAkamaiImagingPolicyImage#feature_radius}
        :param feature_radius_var: The size in pixels of the important features to search for. If identified, two features never appear closer together than this value, ``8.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius_var DataAkamaiImagingPolicyImage#feature_radius_var}
        :param gravity: Controls placement of the crop. Directions are relative to the region of interest plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Controls placement of the crop. Directions are relative to the region of interest plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param max_features: The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features DataAkamaiImagingPolicyImage#max_features}
        :param max_features_var: The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features_var DataAkamaiImagingPolicyImage#max_features_var}
        :param min_feature_quality: Determines the minimum quality level of the feature identified. To consider a feature important, the feature needs to surpass this value. Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality DataAkamaiImagingPolicyImage#min_feature_quality}
        :param min_feature_quality_var: Determines the minimum quality level of the feature identified. To consider a feature important, the feature needs to surpass this value. Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality_var DataAkamaiImagingPolicyImage#min_feature_quality_var}
        :param padding: Adds space around the region of interest. The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: Adds space around the region of interest. The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        :param style: Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c3e64d2eac7b46e96231b0c41eb8d2d0ecd147becf9cbd584032f25f67666d42)
            check_type(argname="argument fail_gravity", value=fail_gravity, expected_type=type_hints["fail_gravity"])
            check_type(argname="argument fail_gravity_var", value=fail_gravity_var, expected_type=type_hints["fail_gravity_var"])
            check_type(argname="argument feature_radius", value=feature_radius, expected_type=type_hints["feature_radius"])
            check_type(argname="argument feature_radius_var", value=feature_radius_var, expected_type=type_hints["feature_radius_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument max_features", value=max_features, expected_type=type_hints["max_features"])
            check_type(argname="argument max_features_var", value=max_features_var, expected_type=type_hints["max_features_var"])
            check_type(argname="argument min_feature_quality", value=min_feature_quality, expected_type=type_hints["min_feature_quality"])
            check_type(argname="argument min_feature_quality_var", value=min_feature_quality_var, expected_type=type_hints["min_feature_quality_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fail_gravity is not None:
            self._values["fail_gravity"] = fail_gravity
        if fail_gravity_var is not None:
            self._values["fail_gravity_var"] = fail_gravity_var
        if feature_radius is not None:
            self._values["feature_radius"] = feature_radius
        if feature_radius_var is not None:
            self._values["feature_radius_var"] = feature_radius_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if max_features is not None:
            self._values["max_features"] = max_features
        if max_features_var is not None:
            self._values["max_features_var"] = max_features_var
        if min_feature_quality is not None:
            self._values["min_feature_quality"] = min_feature_quality
        if min_feature_quality_var is not None:
            self._values["min_feature_quality_var"] = min_feature_quality_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def fail_gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any features in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        '''
        result = self._values.get("fail_gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any features in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        '''
        result = self._values.get("fail_gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feature_radius(self) -> typing.Optional[builtins.str]:
        '''The size in pixels of the important features to search for.

        If identified, two features never appear closer together than this value, ``8.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius DataAkamaiImagingPolicyImage#feature_radius}
        '''
        result = self._values.get("feature_radius")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feature_radius_var(self) -> typing.Optional[builtins.str]:
        '''The size in pixels of the important features to search for.

        If identified, two features never appear closer together than this value, ``8.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius_var DataAkamaiImagingPolicyImage#feature_radius_var}
        '''
        result = self._values.get("feature_radius_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the region of interest plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the region of interest plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def max_features(self) -> typing.Optional[builtins.str]:
        '''The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features DataAkamaiImagingPolicyImage#max_features}
        '''
        result = self._values.get("max_features")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def max_features_var(self) -> typing.Optional[builtins.str]:
        '''The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features_var DataAkamaiImagingPolicyImage#max_features_var}
        '''
        result = self._values.get("max_features_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def min_feature_quality(self) -> typing.Optional[builtins.str]:
        '''Determines the minimum quality level of the feature identified.

        To consider a feature important, the feature needs to surpass this value.  Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality DataAkamaiImagingPolicyImage#min_feature_quality}
        '''
        result = self._values.get("min_feature_quality")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def min_feature_quality_var(self) -> typing.Optional[builtins.str]:
        '''Determines the minimum quality level of the feature identified.

        To consider a feature important, the feature needs to surpass this value.  Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality_var DataAkamaiImagingPolicyImage#min_feature_quality_var}
        '''
        result = self._values.get("min_feature_quality_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''Adds space around the region of interest.

        The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''Adds space around the region of interest.

        The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanFeatureCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanFeatureCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanFeatureCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a141110860d29e850aee40305b94f7990bda80c445b9244727af02244f1e1e88)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanFeatureCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f2bd194a05d53cb6f9c98cf81e33b20bc33f4f027440a8c440bce9976cb59117)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanFeatureCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6390075f74b8823ec338353e48c49f3052643081181f8273d4086a5c6024c095)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__28cfdf9ee0766591b6b798c5c947ec3a4d88b0ff2d73e0647970bcdf21badd58)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc44707daf1fb81b3335335b91e6a354506f36221cbc10c6d1c445bde7108d2e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanFeatureCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanFeatureCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanFeatureCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d284b51f3323b1056036d98dd0cc6d1e27437e697522e1c9806384a125b35685)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanFeatureCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanFeatureCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c22c5cf2ca9b6fdb886fef9c01deca21770e377b5070c7a29ffe6826ce122aab)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetFailGravity")
    def reset_fail_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravity", []))

    @jsii.member(jsii_name="resetFailGravityVar")
    def reset_fail_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravityVar", []))

    @jsii.member(jsii_name="resetFeatureRadius")
    def reset_feature_radius(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureRadius", []))

    @jsii.member(jsii_name="resetFeatureRadiusVar")
    def reset_feature_radius_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureRadiusVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetMaxFeatures")
    def reset_max_features(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxFeatures", []))

    @jsii.member(jsii_name="resetMaxFeaturesVar")
    def reset_max_features_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxFeaturesVar", []))

    @jsii.member(jsii_name="resetMinFeatureQuality")
    def reset_min_feature_quality(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMinFeatureQuality", []))

    @jsii.member(jsii_name="resetMinFeatureQualityVar")
    def reset_min_feature_quality_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMinFeatureQualityVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="failGravityInput")
    def fail_gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityVarInput")
    def fail_gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featureRadiusInput")
    def feature_radius_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featureRadiusInput"))

    @builtins.property
    @jsii.member(jsii_name="featureRadiusVarInput")
    def feature_radius_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featureRadiusVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesInput")
    def max_features_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "maxFeaturesInput"))

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesVarInput")
    def max_features_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "maxFeaturesVarInput"))

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityInput")
    def min_feature_quality_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "minFeatureQualityInput"))

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityVarInput")
    def min_feature_quality_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "minFeatureQualityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravity")
    def fail_gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravity"))

    @fail_gravity.setter
    def fail_gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f67d5eb9876d84d185a0e23cb3b295d4633e437d39d0ac417f23eef0aa2bd8e7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravity", value)

    @builtins.property
    @jsii.member(jsii_name="failGravityVar")
    def fail_gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravityVar"))

    @fail_gravity_var.setter
    def fail_gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9fc4122a6c1ee5f7a659fdad9bb14ec3ab8244156915504dc2844b4b9cbf3cfa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="featureRadius")
    def feature_radius(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featureRadius"))

    @feature_radius.setter
    def feature_radius(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5d6df78443de80145cde0aec33cd1db53e58763571c1848620e4e118d1446afb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featureRadius", value)

    @builtins.property
    @jsii.member(jsii_name="featureRadiusVar")
    def feature_radius_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featureRadiusVar"))

    @feature_radius_var.setter
    def feature_radius_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bcf4aabc26bef0c12154632de2498b081518c1b7215ac429e60313a38f88a517)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featureRadiusVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4e38c2a8c431645de74c3c0a8e717df5d09382e510219fd9aa0aee2d9b5db178)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fc3bc402c8b141e89f8539cefb9f9851e3eb4c637808328ebc9432eeb230d4de)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__26bd59940605874133c7e75ffb2e56f34403204a4715fba5b6f0fb87a613a71d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fca5d4291e797075b54eee74dfbd50e5b5d4e3f0bab3a44871b03743272fa2f0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="maxFeatures")
    def max_features(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "maxFeatures"))

    @max_features.setter
    def max_features(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__89d6948e9dd70e9ffba862236cccef55a686d38cb9eef3c21911f3ae53fe7d71)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "maxFeatures", value)

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesVar")
    def max_features_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "maxFeaturesVar"))

    @max_features_var.setter
    def max_features_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6a8cb503f8b53d1ff5e650114549129a95fd1785f0de73dedc411fdbf0f78424)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "maxFeaturesVar", value)

    @builtins.property
    @jsii.member(jsii_name="minFeatureQuality")
    def min_feature_quality(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "minFeatureQuality"))

    @min_feature_quality.setter
    def min_feature_quality(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0351d10e8096dcb4713f70ff28bf36a69567332b1fd45a8cd536aec7fff6cd45)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "minFeatureQuality", value)

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityVar")
    def min_feature_quality_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "minFeatureQualityVar"))

    @min_feature_quality_var.setter
    def min_feature_quality_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__34c3181e203816845109c1aaa2a1bbcd49d7f105eabadbde21a51611eec93623)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "minFeatureQualityVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fb9453c6ef573619493017c5c6dd3ba4a5097338cebce3ec194e144f802ccf4b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__36bc9c54b483bc7927c3d1beff340c9d70f7dac3f3d322f0dabf74237dbc3524)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__217be86fc4159aee86f572cff58119cd0fdbdbcd70fb6ac063e7fab378d41240)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__85f0f06c598b68f8e6d438fdba299691f2f24475de20f82100c8d78e21e8f7f1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__639a052d3b3ff97e39b3c1e267bad0649ec38c2b5c8de7d69f8efcc423821ce4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e8725c03a52d191c13b48547c2b9750684afb2a4f4a106c543f26576d93a3ed8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanFeatureCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanFeatureCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanFeatureCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e2c271474f43c4eeb8f989c5a03a90a5829e7d4152abecaa8d025963ef81b17a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanFitAndFill",
    jsii_struct_bases=[],
    name_mapping={
        "fill_transformation": "fillTransformation",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanFitAndFill:
    def __init__(
        self,
        *,
        fill_transformation: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanFitAndFillFillTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fill_transformation: fill_transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_transformation DataAkamaiImagingPolicyImage#fill_transformation}
        :param height: The height value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The width value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(fill_transformation, dict):
            fill_transformation = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanFitAndFillFillTransformation(**fill_transformation)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__07ea1811a2696ea92c488a415ed12c38fb3b9f3b0907d15eec0db301453aa438)
            check_type(argname="argument fill_transformation", value=fill_transformation, expected_type=type_hints["fill_transformation"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fill_transformation is not None:
            self._values["fill_transformation"] = fill_transformation
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def fill_transformation(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanFitAndFillFillTransformation"]:
        '''fill_transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_transformation DataAkamaiImagingPolicyImage#fill_transformation}
        '''
        result = self._values.get("fill_transformation")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanFitAndFillFillTransformation"], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanFitAndFill(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanFitAndFillFillTransformation",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanFitAndFillFillTransformation:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanFitAndFillFillTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanFitAndFillFillTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanFitAndFillFillTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b62847c5182860f42d5355eaaa35ea36c227dd745d4d015a01952cc2bceb3bc8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanFitAndFillFillTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanFitAndFillFillTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanFitAndFillFillTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__50412b5d167239adc7b4f65a7674a9b572f42df9e03d7f2064b393b8a8b993cc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanFitAndFillList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanFitAndFillList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5b34d40e360bdc42f051f8663c0cd4251f12cf1fceaa7b6a65ecbe500ece37d4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanFitAndFillOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8b8f18e477eb7c28d1af3b42bf574d7235d2e7a74b879db5326e7627e370618a)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanFitAndFillOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cc426f6688947d4a75eebd2a7d952b73ce7bc71527dc2ff5eab71fc3b2c10f47)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ae9f0ba67e7a3efe556a52027ffefe349ba842da4e3d10dfed96839f9439a295)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ba1eb26af1eb462fecaee5c067f1f87f0dc4d74dfcff2033c4b1965d96876e5a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanFitAndFill]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanFitAndFill]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanFitAndFill]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__93a59de5b352c9a67442f7708390a1d0eb515fffaf5e64c8206fccc22000b385)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanFitAndFillOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanFitAndFillOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5a1930b818054584936f673324bd9f2beeb04a915c0ddd96283939cc00a260a6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putFillTransformation")
    def put_fill_transformation(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanFitAndFillFillTransformation()

        return typing.cast(None, jsii.invoke(self, "putFillTransformation", [value]))

    @jsii.member(jsii_name="resetFillTransformation")
    def reset_fill_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFillTransformation", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="fillTransformation")
    def fill_transformation(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanFitAndFillFillTransformationOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanFitAndFillFillTransformationOutputReference, jsii.get(self, "fillTransformation"))

    @builtins.property
    @jsii.member(jsii_name="fillTransformationInput")
    def fill_transformation_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanFitAndFillFillTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanFitAndFillFillTransformation], jsii.get(self, "fillTransformationInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dd5ebba771abdb78bb425ffde6e621891f162f46ea8dd3f1bf5a3ab75a021d7a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__27af54cc61620ec7aa4041628a7c4914704d939f1cc94107de4328e5efe60514)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d53a066b6c49350898cb02c1e439e5d75c6cfa07c60d3bb8634f220b11d31fd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__845f6ea251cab14d5860d75b58244d20db6d358890b279edc146bb921b1ff170)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanFitAndFill]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanFitAndFill]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanFitAndFill]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__23e70c23b255807cd1b3cbfe723fbbe97971c6b798055b0c09a11e5f4c6d9e0b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanGoop",
    jsii_struct_bases=[],
    name_mapping={
        "chaos": "chaos",
        "chaos_var": "chaosVar",
        "density": "density",
        "density_var": "densityVar",
        "power": "power",
        "power_var": "powerVar",
        "seed": "seed",
        "seed_var": "seedVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanGoop:
    def __init__(
        self,
        *,
        chaos: typing.Optional[builtins.str] = None,
        chaos_var: typing.Optional[builtins.str] = None,
        density: typing.Optional[builtins.str] = None,
        density_var: typing.Optional[builtins.str] = None,
        power: typing.Optional[builtins.str] = None,
        power_var: typing.Optional[builtins.str] = None,
        seed: typing.Optional[builtins.str] = None,
        seed_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param chaos: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        :param chaos_var: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        :param density: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        :param density_var: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        :param power: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        :param power_var: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        :param seed: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        :param seed_var: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8f4258e8c56d31bcaecd162fc445df8beb367a90462cf3305774e6f3ffa834fc)
            check_type(argname="argument chaos", value=chaos, expected_type=type_hints["chaos"])
            check_type(argname="argument chaos_var", value=chaos_var, expected_type=type_hints["chaos_var"])
            check_type(argname="argument density", value=density, expected_type=type_hints["density"])
            check_type(argname="argument density_var", value=density_var, expected_type=type_hints["density_var"])
            check_type(argname="argument power", value=power, expected_type=type_hints["power"])
            check_type(argname="argument power_var", value=power_var, expected_type=type_hints["power_var"])
            check_type(argname="argument seed", value=seed, expected_type=type_hints["seed"])
            check_type(argname="argument seed_var", value=seed_var, expected_type=type_hints["seed_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if chaos is not None:
            self._values["chaos"] = chaos
        if chaos_var is not None:
            self._values["chaos_var"] = chaos_var
        if density is not None:
            self._values["density"] = density
        if density_var is not None:
            self._values["density_var"] = density_var
        if power is not None:
            self._values["power"] = power
        if power_var is not None:
            self._values["power_var"] = power_var
        if seed is not None:
            self._values["seed"] = seed
        if seed_var is not None:
            self._values["seed_var"] = seed_var

    @builtins.property
    def chaos(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        '''
        result = self._values.get("chaos")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def chaos_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        '''
        result = self._values.get("chaos_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        '''
        result = self._values.get("density")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density_var(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        '''
        result = self._values.get("density_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        '''
        result = self._values.get("power")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power_var(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        '''
        result = self._values.get("power_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        '''
        result = self._values.get("seed")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed_var(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        result = self._values.get("seed_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanGoop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanGoopList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanGoopList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__caf680c2f8db592f377329f01380a06ea4280438e20bc8348bc530c246e4e0d0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanGoopOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f28e7ca6cf3f2d05d82c202ef8a1bb3372379d1f2508bdaca887443996a3c863)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanGoopOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ad4944299141ecf54ea81aedc69058496da6431fbf19b58aa2da7b673c5aa475)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a5c5802cedc5839d0135ff3239e706cd255e27d8295d40f463306f52c6c3cdb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a772955589be29b64086192a9cf03ff34dc343beb9218e8f617dee9f1ebed6bb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanGoop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanGoop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4745c11e327f018c6b593047ce1584a60e7bd1489f99e34797d15aa3fbfcdc14)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanGoopOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanGoopOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d51fa60ee70e106c4304aadb160984596796c8a95c237b094b7d19fdef4650d0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetChaos")
    def reset_chaos(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaos", []))

    @jsii.member(jsii_name="resetChaosVar")
    def reset_chaos_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaosVar", []))

    @jsii.member(jsii_name="resetDensity")
    def reset_density(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensity", []))

    @jsii.member(jsii_name="resetDensityVar")
    def reset_density_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensityVar", []))

    @jsii.member(jsii_name="resetPower")
    def reset_power(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPower", []))

    @jsii.member(jsii_name="resetPowerVar")
    def reset_power_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPowerVar", []))

    @jsii.member(jsii_name="resetSeed")
    def reset_seed(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeed", []))

    @jsii.member(jsii_name="resetSeedVar")
    def reset_seed_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeedVar", []))

    @builtins.property
    @jsii.member(jsii_name="chaosInput")
    def chaos_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosInput"))

    @builtins.property
    @jsii.member(jsii_name="chaosVarInput")
    def chaos_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosVarInput"))

    @builtins.property
    @jsii.member(jsii_name="densityInput")
    def density_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityInput"))

    @builtins.property
    @jsii.member(jsii_name="densityVarInput")
    def density_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="powerInput")
    def power_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerInput"))

    @builtins.property
    @jsii.member(jsii_name="powerVarInput")
    def power_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerVarInput"))

    @builtins.property
    @jsii.member(jsii_name="seedInput")
    def seed_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedInput"))

    @builtins.property
    @jsii.member(jsii_name="seedVarInput")
    def seed_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedVarInput"))

    @builtins.property
    @jsii.member(jsii_name="chaos")
    def chaos(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaos"))

    @chaos.setter
    def chaos(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cdcebf9e5989bb0fbe6848a395de53a6921cda1253b7b75d3495a03bed38859b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaos", value)

    @builtins.property
    @jsii.member(jsii_name="chaosVar")
    def chaos_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaosVar"))

    @chaos_var.setter
    def chaos_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__02ae2bd18653561d5b30c0bac659d337baa47d88489d407c9d138e3ad9c10f49)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaosVar", value)

    @builtins.property
    @jsii.member(jsii_name="density")
    def density(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "density"))

    @density.setter
    def density(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__db9591dd1abec9f1e60d37d31c057543a311c68f71f1fd0a1d5687c64f99e286)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "density", value)

    @builtins.property
    @jsii.member(jsii_name="densityVar")
    def density_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "densityVar"))

    @density_var.setter
    def density_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b35eba1f8f0f047de6da73bc4f9b3b2ed0806be0581ddabec7928a95634b44d0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "densityVar", value)

    @builtins.property
    @jsii.member(jsii_name="power")
    def power(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "power"))

    @power.setter
    def power(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__78ad34033557868b951de2692eff59493b4f49c7926c4c670599974531fa8939)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "power", value)

    @builtins.property
    @jsii.member(jsii_name="powerVar")
    def power_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "powerVar"))

    @power_var.setter
    def power_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__83ee62bfb5539c0bd5469d876bd8c6357f2b1e80c019bd4095c1107a15898a4a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "powerVar", value)

    @builtins.property
    @jsii.member(jsii_name="seed")
    def seed(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seed"))

    @seed.setter
    def seed(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dff063310ab1ce598e300bd8ac06cb3f81beb5a58c9851895c315c7ac712f1e5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seed", value)

    @builtins.property
    @jsii.member(jsii_name="seedVar")
    def seed_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seedVar"))

    @seed_var.setter
    def seed_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c0a36868f1b24d5996c6a255a30f7da6b1b3fb7593990dae51b5ee9b8e4a6626)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seedVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanGoop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanGoop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanGoop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f34b0f6e234503aad4b50a9fd9f819d114396ac9c9626dbb3590121eb45a7f2c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanGrayscale",
    jsii_struct_bases=[],
    name_mapping={"type": "type", "type_var": "typeVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanGrayscale:
    def __init__(
        self,
        *,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param type: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__57a1d4a4dd7919a3d8504663625b1842b06b0a9ebabd33e6c217d92c898b0410)
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanGrayscale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanGrayscaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanGrayscaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d0438a001a427fbddd91581b777aaa951308a7538cb846d3e299727516fe83fd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanGrayscaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7bcf06c3642e90d0cdf3809060ee93633e113594f6762caf2550920b4a6d1f14)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanGrayscaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7e1f39f32d04f7457558d4403907c1f5536ff5b61f5bf517df3282f9962c7770)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a5f76e56c1be8b18f9b78cc95a1020b0793692d558a37b2c7cd1045c6968e646)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3c5c027f545a9c5789b280e3e2a909da8866c1b9d295f068a58f6c974c737eaa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanGrayscale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanGrayscale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0c7b34b1319cd8ca110c456bbf45682d5c04a5dca01912c03260c7c93b7aca04)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanGrayscaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanGrayscaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__02a9807f75f971f5d1cb79b28bd73dbc0f45dca066826f02710ca586429f6ad7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b8a447e99e633fef7f1feaadede96af60661bf4ef64b2e1b1dbd73d6d1bea81f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__66d0bd4f217d7a53b5ed4af0fdca3fe81a2f99547191ef2dff21b21e670a36a5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanGrayscale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanGrayscale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanGrayscale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bddaa85b00b5f9213e8c28352452ecfda5ad2def7153871c73a3a5418b6d9d63)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanHsl",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "lightness": "lightness",
        "lightness_var": "lightnessVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanHsl:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness: typing.Optional[builtins.str] = None,
        lightness_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        :param lightness_var: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f0c299f2ea2383252edca965acac6df54830587c69b103caf329150797eaaa0e)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness", value=lightness, expected_type=type_hints["lightness"])
            check_type(argname="argument lightness_var", value=lightness_var, expected_type=type_hints["lightness_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness is not None:
            self._values["lightness"] = lightness
        if lightness_var is not None:
            self._values["lightness_var"] = lightness_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        '''
        result = self._values.get("lightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        '''
        result = self._values.get("lightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanHsl(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanHslList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanHslList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__118bd444505c8db08cd3bd7b916e6600a1d4349901e8f6f20220e66d110e56b1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanHslOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d7857553a488780898b973b59c2c0aa478679227ff4deabfefb0701fc3f10ed1)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanHslOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__89f70bcf9465e4f59a33bb82bfb240340a9dd8583fedb0bd3b54e39c07e33683)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9f96c2f32a05d1cec7a1831089e2cc4b7a8e2babac18d33cfb0bb40c8cfdcb53)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__326edf1603e2e8940ecee72da140b85563aa02c2b0fef151b8a69cb12492f616)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanHsl]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanHsl]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8bd85530c4d4abbe1920370762b17e1bd75f8974f83ff2ce6fb74babc704327b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanHslOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanHslOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b1364ec796ee600d5da9fc37575e9c360dbee09efa178816a96b77641cf2d182)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightness")
    def reset_lightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightness", []))

    @jsii.member(jsii_name="resetLightnessVar")
    def reset_lightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessInput")
    def lightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessVarInput")
    def lightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a74ab62e42b08792038eed4efce9eaec2ebdd16f056d1639c7f96c160bbf19b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2326cec0c473e9652cf027137805e8030c2d17dc2f8a173ca160c6432e9c00a5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightness")
    def lightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightness"))

    @lightness.setter
    def lightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aebbf3995f20fffccf71210487da5fcc67afb5ce075b1dd62ef46c924e2f180c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightness", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessVar")
    def lightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessVar"))

    @lightness_var.setter
    def lightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__039403b43ecf27165b0f012ecf62e761e1ce9057b55e8d6c3639b1fa81bdbe3e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0d1677c87fd240905904c92669fcca32d5310322ae9f220577dbe93083507ddd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3dd02dd555008dcb03f67a4c3e06b46c664eeed413d3ffe00d5ce657fbb8f772)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanHsl]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanHsl]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanHsl]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__64a46f0514aea901434f3f70f238f1d325ad64f5083027f5f30ff31e37b8ace3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanHsv",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanHsv:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        :param value: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__06c75d491d87bf89e8626e8366dae2ef99e5e497508740a6a59fdd79eadbbe0b)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanHsv(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanHsvList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanHsvList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c4b03999dc49f01e1d4c6161f54e292c87063276e0f70f54427a1671a7ccc220)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanHsvOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6488e8d7c83bcb6a31a0f025abb3b26487f6b47e90933e70646eab7b2f00d982)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanHsvOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f46dce10c14008483a7348bd624636e3b89468a0ee32dde307c5882d83213867)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__637a2d738928d84bb8ed230c615dc306e0d85ee2aff34f2c13669639e488aef7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__360a9382163666b120cba3b8a90c0f0b2884cf7b63d3f2313f81ae7ea3633586)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanHsv]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanHsv]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e02c13a824dc20ff69d52c386e3cb58ea9e85c5ee9ba4e8676f49d2b5411b02c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanHsvOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanHsvOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c736b306377212acd720b57670b07471e69b52b8c41142d3b02efbfaede08194)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b7cc0d5a2f4fd53d053ec813ad26383ba94cec36f4ef0badb8bd0913d7acc671)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fda8433a00b3d8259ddf157a0950b18f33fef32841dcedec94fec79895480da9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dd7ffa7a7923495421fe0182844585d7c2375fd942aed1354b305adb901d76e3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ae26fdd6f41de2255fc4f9948017b7b1918077c7d7b8ac056848da64ef8e4f7e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea1f1bc308cb66ed14b6944a77760404401f39b38be597f0bd446fa1c05dadf2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__20e887fd927c386f87322ec0ccb5c15372681bc3918fbbfe85d43a04a68696d4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanHsv]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanHsv]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanHsv]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a7c96d90d79e80f28348edd81757832bcf9e40545ee2f56e35f3aa3a66c75da2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfDimension",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "dimension": "dimension",
        "dimension_var": "dimensionVar",
        "equal": "equal",
        "greater_than": "greaterThan",
        "less_than": "lessThan",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfDimension:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        dimension: typing.Optional[builtins.str] = None,
        dimension_var: typing.Optional[builtins.str] = None,
        equal: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionEqual", typing.Dict[builtins.str, typing.Any]]] = None,
        greater_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionGreaterThan", typing.Dict[builtins.str, typing.Any]]] = None,
        less_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionLessThan", typing.Dict[builtins.str, typing.Any]]] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param dimension: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        :param dimension_var: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        :param equal: equal block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        :param greater_than: greater_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        :param less_than: less_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        :param value: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionDefault(**default)
        if isinstance(equal, dict):
            equal = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionEqual(**equal)
        if isinstance(greater_than, dict):
            greater_than = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionGreaterThan(**greater_than)
        if isinstance(less_than, dict):
            less_than = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionLessThan(**less_than)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c1e97c15d756c9dc1f9a719d397ba4ba5271671430d5e218f8d8d466029a21e2)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument dimension", value=dimension, expected_type=type_hints["dimension"])
            check_type(argname="argument dimension_var", value=dimension_var, expected_type=type_hints["dimension_var"])
            check_type(argname="argument equal", value=equal, expected_type=type_hints["equal"])
            check_type(argname="argument greater_than", value=greater_than, expected_type=type_hints["greater_than"])
            check_type(argname="argument less_than", value=less_than, expected_type=type_hints["less_than"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if dimension is not None:
            self._values["dimension"] = dimension
        if dimension_var is not None:
            self._values["dimension_var"] = dimension_var
        if equal is not None:
            self._values["equal"] = equal
        if greater_than is not None:
            self._values["greater_than"] = greater_than
        if less_than is not None:
            self._values["less_than"] = less_than
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionDefault"], result)

    @builtins.property
    def dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        '''
        result = self._values.get("dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        '''
        result = self._values.get("dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def equal(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionEqual"]:
        '''equal block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        '''
        result = self._values.get("equal")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionEqual"], result)

    @builtins.property
    def greater_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionGreaterThan"]:
        '''greater_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        '''
        result = self._values.get("greater_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionGreaterThan"], result)

    @builtins.property
    def less_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionLessThan"]:
        '''less_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        '''
        result = self._values.get("less_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionLessThan"], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfDimension(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5a4132236ec8021ae075e81bd53588d31a381af873b1b47a33f28715a2082842)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b5f89cff60e7b3135a301973c4ec20f09930632122b3c579f5a85de66b8ca465)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionEqual",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionEqual:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionEqual(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionEqualOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionEqualOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6d31191453e73659ad5c9165a44be5a6bf07c27b9b226ab70f205fcbfc0f6082)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionEqual], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionEqual],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__91328589e64f5d6fe5c1a8a5c194c6a3b23bee2e610579774a67c88d75edba63)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionGreaterThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionGreaterThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionGreaterThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionGreaterThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionGreaterThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fdc875728300c289188023888da01aaa819059bcd92c736c1b07e59692164fce)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionGreaterThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionGreaterThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2bddad28fe4bfe0862795d46602dca16032b71ab1df8cfa6bb8a3babc3cfee3c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionLessThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionLessThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionLessThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionLessThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionLessThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b92a64b79a2029c6771fdd24bb9b6d98866513e6090d79264652d9f0e5377584)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionLessThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionLessThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__821e9778883a2ca3424383461bf6725513cfeb095a9a26babfaa380653964b18)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__20747d3e84149c7ecb16788d694554288c51908d24db4284b865a1216a49f7d5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e48e13710f5bdc9249952da1c8c84f53a36508a95470a6689728eb6ec86182d4)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__981409a6d0e2fdbd229eb321a9d22865d8da26579f7003948a5bba81fc20875c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6375792d98a976907b9edfe2cdb43a77e460a68618cbde449a01b24293e14902)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e8ee67d1ac928ba9b654d060f953568f59446a2bb50705cb3ae62046428bc153)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfDimension]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfDimension]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6ed73bd60938bb9517e2aa986de89cde1047bb60312fb6f5c46d86e84b98830d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2dac666dd083ea610e8e1179ad01369de9a8ac0712f345f1a67dd1ed418c431e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putEqual")
    def put_equal(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionEqual()

        return typing.cast(None, jsii.invoke(self, "putEqual", [value]))

    @jsii.member(jsii_name="putGreaterThan")
    def put_greater_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionGreaterThan()

        return typing.cast(None, jsii.invoke(self, "putGreaterThan", [value]))

    @jsii.member(jsii_name="putLessThan")
    def put_less_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionLessThan()

        return typing.cast(None, jsii.invoke(self, "putLessThan", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetDimension")
    def reset_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimension", []))

    @jsii.member(jsii_name="resetDimensionVar")
    def reset_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimensionVar", []))

    @jsii.member(jsii_name="resetEqual")
    def reset_equal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEqual", []))

    @jsii.member(jsii_name="resetGreaterThan")
    def reset_greater_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGreaterThan", []))

    @jsii.member(jsii_name="resetLessThan")
    def reset_less_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLessThan", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="equal")
    def equal(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionEqualOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionEqualOutputReference, jsii.get(self, "equal"))

    @builtins.property
    @jsii.member(jsii_name="greaterThan")
    def greater_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionGreaterThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionGreaterThanOutputReference, jsii.get(self, "greaterThan"))

    @builtins.property
    @jsii.member(jsii_name="lessThan")
    def less_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionLessThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionLessThanOutputReference, jsii.get(self, "lessThan"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionInput")
    def dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionVarInput")
    def dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="equalInput")
    def equal_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionEqual], jsii.get(self, "equalInput"))

    @builtins.property
    @jsii.member(jsii_name="greaterThanInput")
    def greater_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionGreaterThan], jsii.get(self, "greaterThanInput"))

    @builtins.property
    @jsii.member(jsii_name="lessThanInput")
    def less_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionLessThan], jsii.get(self, "lessThanInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="dimension")
    def dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimension"))

    @dimension.setter
    def dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__316b15922ed1645ae6ccdd8b9c70403896aa8484b991ae2e80c589703ba6a779)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimension", value)

    @builtins.property
    @jsii.member(jsii_name="dimensionVar")
    def dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimensionVar"))

    @dimension_var.setter
    def dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f57d74a8b89b948666f60df8ac1f5a4a3da072ce9febdc83fa7883fea75c34d2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aec189757796e35469fc6cb470b3772dac6cc1730d5dd81ead1879dee52bc9ee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__de3831b5b48902411bd45aaee21a8151dde272f0ebbba7ab39b8486af3236736)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfDimension]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfDimension]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfDimension]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7c1882e16e60c417f036f5a37d3a3fd5d1abf55666ddf9e08d19c5eb4bec5d8e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientation",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "landscape": "landscape",
        "portrait": "portrait",
        "square": "square",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientation:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        landscape: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationLandscape", typing.Dict[builtins.str, typing.Any]]] = None,
        portrait: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationPortrait", typing.Dict[builtins.str, typing.Any]]] = None,
        square: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationSquare", typing.Dict[builtins.str, typing.Any]]] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param landscape: landscape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        :param portrait: portrait block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        :param square: square block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationDefault(**default)
        if isinstance(landscape, dict):
            landscape = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationLandscape(**landscape)
        if isinstance(portrait, dict):
            portrait = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationPortrait(**portrait)
        if isinstance(square, dict):
            square = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationSquare(**square)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__02685605acc891e8cb2f56e2a3f0aceafa2fc168b0c56c2034ea3298b7ac66d0)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument landscape", value=landscape, expected_type=type_hints["landscape"])
            check_type(argname="argument portrait", value=portrait, expected_type=type_hints["portrait"])
            check_type(argname="argument square", value=square, expected_type=type_hints["square"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if landscape is not None:
            self._values["landscape"] = landscape
        if portrait is not None:
            self._values["portrait"] = portrait
        if square is not None:
            self._values["square"] = square

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationDefault"], result)

    @builtins.property
    def landscape(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationLandscape"]:
        '''landscape block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        '''
        result = self._values.get("landscape")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationLandscape"], result)

    @builtins.property
    def portrait(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationPortrait"]:
        '''portrait block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        '''
        result = self._values.get("portrait")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationPortrait"], result)

    @builtins.property
    def square(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationSquare"]:
        '''square block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        result = self._values.get("square")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationSquare"], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0c1a2d7a14b9de076f73a218b4a3ec92ce6445f077c2774b38612509f97ab2a4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__716db8737b0dfb196d224d06b53a59ce35abede667968a8e7e7ffe2333108617)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationLandscape",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationLandscape:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationLandscape(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationLandscapeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationLandscapeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__00b4fd3da5c71afb72c6399cda3c6cb9868d16d5658371abd51ab3556018ce0b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationLandscape], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationLandscape],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fbc3f4245a4849858a90357f2c9d5753cae705540d860b625c190509d981fe44)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8d2d47838f9820d5660a72be086c6e6ee618bc49d41625b485bbeae5ebc4dd14)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aab211fb6a6f3dfd99d70b4d31d34f4eeb45a937b3ccd267a7a9dc7d8758bbe1)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d6b25e17652bbbfad298d3c8600f8ad1059495109cb60131d755c6153830ebb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3f85e3cb9e9fe2c08248a5222ce4cd6a5cd8a48af8b1046aafc369d8cbca4d23)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__57e2365b1b222835fcbdac2c527405c8a0069d78d2bd9095ad4bc1c47b5bf008)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientation]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientation]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__84b4249795a3fefcf92db05c09351974314d17b2e98e7b195eb255a644bf13e0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a7293b21f8f3c7334c98d52de99eb2c246517dd6961e2b002ee29b55e998676)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putLandscape")
    def put_landscape(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationLandscape()

        return typing.cast(None, jsii.invoke(self, "putLandscape", [value]))

    @jsii.member(jsii_name="putPortrait")
    def put_portrait(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationPortrait()

        return typing.cast(None, jsii.invoke(self, "putPortrait", [value]))

    @jsii.member(jsii_name="putSquare")
    def put_square(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationSquare()

        return typing.cast(None, jsii.invoke(self, "putSquare", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetLandscape")
    def reset_landscape(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLandscape", []))

    @jsii.member(jsii_name="resetPortrait")
    def reset_portrait(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPortrait", []))

    @jsii.member(jsii_name="resetSquare")
    def reset_square(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSquare", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="landscape")
    def landscape(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationLandscapeOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationLandscapeOutputReference, jsii.get(self, "landscape"))

    @builtins.property
    @jsii.member(jsii_name="portrait")
    def portrait(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationPortraitOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationPortraitOutputReference", jsii.get(self, "portrait"))

    @builtins.property
    @jsii.member(jsii_name="square")
    def square(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationSquareOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationSquareOutputReference", jsii.get(self, "square"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="landscapeInput")
    def landscape_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationLandscape], jsii.get(self, "landscapeInput"))

    @builtins.property
    @jsii.member(jsii_name="portraitInput")
    def portrait_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationPortrait"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationPortrait"], jsii.get(self, "portraitInput"))

    @builtins.property
    @jsii.member(jsii_name="squareInput")
    def square_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationSquare"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationSquare"], jsii.get(self, "squareInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientation]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientation]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientation]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3657383989294b26b4eb338f519418867e5188f024baa682f88de71e8c325b00)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationPortrait",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationPortrait:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationPortrait(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationPortraitOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationPortraitOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__487c81ea66437593864621cf51822363e62b1853a65ac6e05545fbb606c53937)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationPortrait]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationPortrait], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationPortrait],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3113064702c86993835e39609995e20ac604cc7882c3b495eb99bdab3bb72312)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationSquare",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationSquare:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationSquare(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationSquareOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationSquareOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b9515824c3c20e38194b3067c40b681fe663140bdd1f814b8bdcc7ebd1403fc6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationSquare]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationSquare], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationSquare],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1c935d542ad7afe0a0f9d94b45fd487b8243bb9ee9e93f4a940827b130db559e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanImQuery",
    jsii_struct_bases=[],
    name_mapping={
        "allowed_transformations": "allowedTransformations",
        "query_var": "queryVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanImQuery:
    def __init__(
        self,
        *,
        allowed_transformations: typing.Sequence[builtins.str],
        query_var: builtins.str,
    ) -> None:
        '''
        :param allowed_transformations: Specifies the transformations that can be applied using the query string parameter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allowed_transformations DataAkamaiImagingPolicyImage#allowed_transformations}
        :param query_var: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#query_var DataAkamaiImagingPolicyImage#query_var}.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__791364a4f8601481265ba64f0f97afd153c5c7fd13a67719080f973c5ee35f32)
            check_type(argname="argument allowed_transformations", value=allowed_transformations, expected_type=type_hints["allowed_transformations"])
            check_type(argname="argument query_var", value=query_var, expected_type=type_hints["query_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "allowed_transformations": allowed_transformations,
            "query_var": query_var,
        }

    @builtins.property
    def allowed_transformations(self) -> typing.List[builtins.str]:
        '''Specifies the transformations that can be applied using the query string parameter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allowed_transformations DataAkamaiImagingPolicyImage#allowed_transformations}
        '''
        result = self._values.get("allowed_transformations")
        assert result is not None, "Required property 'allowed_transformations' is missing"
        return typing.cast(typing.List[builtins.str], result)

    @builtins.property
    def query_var(self) -> builtins.str:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#query_var DataAkamaiImagingPolicyImage#query_var}.'''
        result = self._values.get("query_var")
        assert result is not None, "Required property 'query_var' is missing"
        return typing.cast(builtins.str, result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanImQuery(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanImQueryList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanImQueryList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8b5614af595fc1ae990ae2508b89d973564f63667f6b1a06efc3721ad6b83849)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanImQueryOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__756881915e12d0867c7b328ea1b9505752d69d82270cfc7d4c4ab4c7220758b8)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanImQueryOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c5e1d418deca77c20de9671876bb3229a0d2bfa7d92d34443a59ea9d135e51a5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f8afd4ef66d75c0c26a3b574731ea46f8605d7fe2472ea65bc469c0566428cc3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5b3c1680e2a1ed58f2dc2797978bb106fe782d4696ebb8165f0f9c1ff1917c35)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanImQuery]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanImQuery]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanImQuery]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__14d7b4bbfc614e015c77f1e6f094518ac1dc71caead724278823a3aad9854a6f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanImQueryOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanImQueryOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__91c60c6d4673c3f2de283bd27768b1c1042ded7eb4681ef36caf44851572e871)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @builtins.property
    @jsii.member(jsii_name="allowedTransformationsInput")
    def allowed_transformations_input(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "allowedTransformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="queryVarInput")
    def query_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "queryVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowedTransformations")
    def allowed_transformations(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "allowedTransformations"))

    @allowed_transformations.setter
    def allowed_transformations(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a9d914abad2ce0a08dfd2379ef4fd7d2e6372a7519242c7d059868c76515cc26)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowedTransformations", value)

    @builtins.property
    @jsii.member(jsii_name="queryVar")
    def query_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "queryVar"))

    @query_var.setter
    def query_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__86059611d2df92091abccea8a68812611463f4e8d60ceabc6ef236945e397115)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "queryVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanImQuery]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanImQuery]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanImQuery]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3397cd9cfb6ef734ea6a72ca3faa6eb137643d781bbf47e52128b021b11f9060)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanMaxColors",
    jsii_struct_bases=[],
    name_mapping={"colors": "colors", "colors_var": "colorsVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanMaxColors:
    def __init__(
        self,
        *,
        colors: typing.Optional[builtins.str] = None,
        colors_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param colors: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        :param colors_var: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6a320a4a76f31daa7796d3a0dd0a5b6001892e80515810e35775d75ef3473c1d)
            check_type(argname="argument colors", value=colors, expected_type=type_hints["colors"])
            check_type(argname="argument colors_var", value=colors_var, expected_type=type_hints["colors_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if colors is not None:
            self._values["colors"] = colors
        if colors_var is not None:
            self._values["colors_var"] = colors_var

    @builtins.property
    def colors(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        '''
        result = self._values.get("colors")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def colors_var(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        result = self._values.get("colors_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanMaxColors(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanMaxColorsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanMaxColorsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6b3edb865f58fde4d95aed5b97529e714897df21ba66b350e59ba1420bc74e00)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanMaxColorsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be663b20eeae7dd917a098ee9785da94dec465f56b3de3d84a7d618ffff45386)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanMaxColorsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__135f8ac0320dba8f92ca314b0a33998e7f347eaf53e135c3231d6491ef038edb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b61963a009157f289d199825bbcf05eec61f1c00bd2736b3e37eb10963a4931b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__102f62c5b1d6403070f71c0a0692d7de2102e3067dc17897ea478d7743d64981)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanMaxColors]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanMaxColors]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a5396b49a404d68fe0786f9c10d84da33c1fc58f9e0a5d0e2fde04eb3d02b5a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanMaxColorsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanMaxColorsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__607b1b49dde4d872a13ea938aea71b2eb6ec412efd2155e73cf1718d9857e595)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColors")
    def reset_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColors", []))

    @jsii.member(jsii_name="resetColorsVar")
    def reset_colors_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorsVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorsInput")
    def colors_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsInput"))

    @builtins.property
    @jsii.member(jsii_name="colorsVarInput")
    def colors_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsVarInput"))

    @builtins.property
    @jsii.member(jsii_name="colors")
    def colors(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colors"))

    @colors.setter
    def colors(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aa8198a70fd42ee066bdb1406875d2cc401cd6532f5880ec6623ea83dfda3bbe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colors", value)

    @builtins.property
    @jsii.member(jsii_name="colorsVar")
    def colors_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorsVar"))

    @colors_var.setter
    def colors_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0aed7beb116e9bb2d35a85db29a64d5c812c8c0190236037758aedd5ec111f21)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorsVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanMaxColors]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanMaxColors]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanMaxColors]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__92c6bbe952961812edf8ed353b8f7aa10358e6ac5eb11763152cded3fe9d2c12)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanMirror",
    jsii_struct_bases=[],
    name_mapping={
        "horizontal": "horizontal",
        "horizontal_var": "horizontalVar",
        "vertical": "vertical",
        "vertical_var": "verticalVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanMirror:
    def __init__(
        self,
        *,
        horizontal: typing.Optional[builtins.str] = None,
        horizontal_var: typing.Optional[builtins.str] = None,
        vertical: typing.Optional[builtins.str] = None,
        vertical_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param horizontal: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        :param horizontal_var: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        :param vertical: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        :param vertical_var: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__31ff611591d6d25ce3d34feaf622475fe6c39f2eaf1a26684d589af558af670f)
            check_type(argname="argument horizontal", value=horizontal, expected_type=type_hints["horizontal"])
            check_type(argname="argument horizontal_var", value=horizontal_var, expected_type=type_hints["horizontal_var"])
            check_type(argname="argument vertical", value=vertical, expected_type=type_hints["vertical"])
            check_type(argname="argument vertical_var", value=vertical_var, expected_type=type_hints["vertical_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if horizontal is not None:
            self._values["horizontal"] = horizontal
        if horizontal_var is not None:
            self._values["horizontal_var"] = horizontal_var
        if vertical is not None:
            self._values["vertical"] = vertical
        if vertical_var is not None:
            self._values["vertical_var"] = vertical_var

    @builtins.property
    def horizontal(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        '''
        result = self._values.get("horizontal")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def horizontal_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        '''
        result = self._values.get("horizontal_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        '''
        result = self._values.get("vertical")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        result = self._values.get("vertical_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanMirror(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanMirrorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanMirrorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__716779fc807199d04a242ecfa97ab39bb3d1e5f23276a182cd1e0d0af08107ce)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanMirrorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c7a28efe2136b8f596f4904d2e8c380a42bd6d75a96b4924a40f2680b0975e23)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanMirrorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c2e962ef79e28faf1743f42ea09bd6efc8597e4aa9945c9dadb2cfb36d16cac2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d43179c28446036ea5814a84b6612481efba4c5122a95fc6738e7bfb0ac4bd0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0c864da4fafbb0d960519afcd617c9f0d112f1e0248708154b50fd18c49979ed)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanMirror]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanMirror]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6d7b398d7cbc0365c385ae1c779767a898de77b0c6d774e8fefa3a19abd8ede4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanMirrorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanMirrorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__43dc5e9b131f43489bdc4aa53356b4b4dc90d8cf55371ae5a0ebf9bde3f5ca51)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHorizontal")
    def reset_horizontal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontal", []))

    @jsii.member(jsii_name="resetHorizontalVar")
    def reset_horizontal_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontalVar", []))

    @jsii.member(jsii_name="resetVertical")
    def reset_vertical(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVertical", []))

    @jsii.member(jsii_name="resetVerticalVar")
    def reset_vertical_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVerticalVar", []))

    @builtins.property
    @jsii.member(jsii_name="horizontalInput")
    def horizontal_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontalVarInput")
    def horizontal_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalInput")
    def vertical_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalVarInput")
    def vertical_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontal")
    def horizontal(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontal"))

    @horizontal.setter
    def horizontal(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a40dccdc5ac2b14216ff3f3554f80e462cde5d438ea78608aa09fcc7a278b4d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontal", value)

    @builtins.property
    @jsii.member(jsii_name="horizontalVar")
    def horizontal_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontalVar"))

    @horizontal_var.setter
    def horizontal_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d9c3b094147a07899d6b96b7896370909ff3b54a8ab4e283f92846681e6bc5d7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontalVar", value)

    @builtins.property
    @jsii.member(jsii_name="vertical")
    def vertical(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "vertical"))

    @vertical.setter
    def vertical(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__032b1a95ff8bb08374bdb77d884f1744687381d982dfaa8491d4dbb901f9e772)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "vertical", value)

    @builtins.property
    @jsii.member(jsii_name="verticalVar")
    def vertical_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "verticalVar"))

    @vertical_var.setter
    def vertical_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d07736e3f96e88331a89fb4ccdbab382b6158590ffa5372a6d71041bf4acb2a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "verticalVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanMirror]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanMirror]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanMirror]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9e4652ee499e6bd8d698ed1e221bfcf1ac1417618d88ec1e2123a129def19e10)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanMonoHue",
    jsii_struct_bases=[],
    name_mapping={"hue": "hue", "hue_var": "hueVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanMonoHue:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0e9b45088cf31c8c3b4670be85e3d0fd7227653fc038b7c9558f6db466d1a100)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanMonoHue(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanMonoHueList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanMonoHueList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f15d9da4f208c16e7215a23cfd91c4501ca721173ceaf2960af4d088d991c0df)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanMonoHueOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aa3b3e913e4a93457d69f8159c88462035b51a5126ab2bad4633bdb21bcf8495)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanMonoHueOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1a865ab04c18c8c594112ef6343ec62e011695b09c23f8bee431099e692a44f8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c1fb40ebf9c6f2cf2207fe719d3890d713252769349ae74f86c789de456dfa60)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__16fe0b2bbf8a415c3040690522f4bff5c1a93db0a703c22acea8f6e140286f52)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanMonoHue]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanMonoHue]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__039415590999c37aa00a59a47ce6cba6992914dab59e5cd7733ea02841f1b394)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanMonoHueOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanMonoHueOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7b52841b03dfa51ac2b11770f817c41a7d9c35e48bc2b746ac6b938bd4f1f591)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__330f4df8f24523f568e6f31ca18eacf7c6a20a1068094881739f198c72729323)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__84b20ffa7edad5e4cd582c56efc0374617ead8058a9346d153ca46c5611d2b1c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanMonoHue]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanMonoHue]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanMonoHue]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__28793bdcd317645afbbf25e1a1dc615fbc4dfe7ed32bc3e5c3da22a619d7d704)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanOpacity",
    jsii_struct_bases=[],
    name_mapping={"opacity": "opacity", "opacity_var": "opacityVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanOpacity:
    def __init__(
        self,
        *,
        opacity: typing.Optional[builtins.str] = None,
        opacity_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param opacity: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param opacity_var: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__06d280803d48d82212394e834e9c93b53f9d66eb8e064a992dda2eaa3f64d242)
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument opacity_var", value=opacity_var, expected_type=type_hints["opacity_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if opacity is not None:
            self._values["opacity"] = opacity
        if opacity_var is not None:
            self._values["opacity_var"] = opacity_var

    @builtins.property
    def opacity(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def opacity_var(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        result = self._values.get("opacity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanOpacity(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanOpacityList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanOpacityList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__72fe210198934b8adcc5f00aa6a78292df6ac49b16dc4c9d0e718422254aa02c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanOpacityOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__665479508ca41ba408b5f3e325b72e29c981af40d40c4f79e5e3fe2264559ccd)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanOpacityOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6de4f141043b5f59b59cf90e67e2509a3aba36cceca28fe1262bb5077e745323)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d66587541b38f5e4287daceb45e45e41a32a927d28b8b0a2b3af717448f58a74)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ab86b7f694aa6316082989c3b0bc18bd0b0f46a7acf7af376b6c032bb54bebd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanOpacity]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanOpacity]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__065ea64b08dd3be823c80fb419308e6c78236efb1f5e5bbd69dfa752e6083cee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanOpacityOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanOpacityOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4664f4f497f3948dde2ab6ad66805560e43239917dd727667581f4991b992b3c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetOpacityVar")
    def reset_opacity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacityVar", []))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityVarInput")
    def opacity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacity"))

    @opacity.setter
    def opacity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5d44182c5f473f8f9f77b607cc2b059c604a10b0df53bf3470fc4a3cac35a599)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacity", value)

    @builtins.property
    @jsii.member(jsii_name="opacityVar")
    def opacity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacityVar"))

    @opacity_var.setter
    def opacity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3260e02146b8fe360480645eb5a61f83f6d02b176a6dc7c17aa4cf805ec2d046)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacityVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanOpacity]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanOpacity]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanOpacity]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__22d8b0fc127c802b9e609b0edb2af491ac4d45a02721992b4d5428e477eba6fe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__48df0fcf987e438fa174b53dc24fc7659d4b4347f4b4787eda0ca24fad497743)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putAppend")
    def put_append(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanAppend, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__24f02bc7e561fcbd247ee6437543cd92ce0e4846e7c075711cdcd291d2c7ca7c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putAppend", [value]))

    @jsii.member(jsii_name="putAspectCrop")
    def put_aspect_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanAspectCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__44b59a351e3d938343d90a8464d5ea69a6194907df4ef2ec44059df85386f3a5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putAspectCrop", [value]))

    @jsii.member(jsii_name="putBackgroundColor")
    def put_background_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b0f0691f2004976e4e16cda9b9cbe7d77ed8bb5f7b44a1cae5777bf3d3ed53a5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBackgroundColor", [value]))

    @jsii.member(jsii_name="putBlur")
    def put_blur(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanBlur, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2cfa25f04de6b33d7c4114060299ba1231d81e65ddfdc4a33d45c9405d01e75e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBlur", [value]))

    @jsii.member(jsii_name="putChromaKey")
    def put_chroma_key(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanChromaKey, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eb63367f12ff028bedfa2251b2aa7e8ce9d5a28938ec4c906cb0a940b9d36347)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putChromaKey", [value]))

    @jsii.member(jsii_name="putComposite")
    def put_composite(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanComposite, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__de2f066f1d81c09a037b3bafeac10fbca5e39ea9bb82b59685a4e81974c8c0b0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putComposite", [value]))

    @jsii.member(jsii_name="putCompound")
    def put_compound(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanCompound, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d214bfe14edfb50f969db5cc326bcfc3f98b47dd9147f34ffd338ebf47f48825)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCompound", [value]))

    @jsii.member(jsii_name="putContrast")
    def put_contrast(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanContrast, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a1330a81f860488da6d27c683d0db4dc87499922ca0315e5112352f2a8807923)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putContrast", [value]))

    @jsii.member(jsii_name="putCrop")
    def put_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d859ce0cad1a7caa87fb4e3e5d22d88286598f72216b987b1d8312f077f0dc3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCrop", [value]))

    @jsii.member(jsii_name="putFaceCrop")
    def put_face_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanFaceCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d8888f518489b8ffddd28575ea2c90e540a7c6f31ecb5f198df167ef512ae01b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFaceCrop", [value]))

    @jsii.member(jsii_name="putFeatureCrop")
    def put_feature_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanFeatureCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f9290a6b79dbd94d4dfab9d64c988661e1865a875a199553aeba8a1035f26ab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFeatureCrop", [value]))

    @jsii.member(jsii_name="putFitAndFill")
    def put_fit_and_fill(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanFitAndFill, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__619557934d18f9f6b1316940ddfac1d59022242c19efc669858b087bf8997ebf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFitAndFill", [value]))

    @jsii.member(jsii_name="putGoop")
    def put_goop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanGoop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bf13cff9da5bbdcc48481f0899669bd1e93ca1b08553a226257c0d9e9fa485ee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGoop", [value]))

    @jsii.member(jsii_name="putGrayscale")
    def put_grayscale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanGrayscale, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ab973293e7ccdb500119c3dfac9cdd9edd9a4a231b8b6fa49374af8966a70bf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGrayscale", [value]))

    @jsii.member(jsii_name="putHsl")
    def put_hsl(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanHsl, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fc3b45a4b752674bc296ccbf1c8cf7b0953117063d906d39e888ed6a63b2748e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsl", [value]))

    @jsii.member(jsii_name="putHsv")
    def put_hsv(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanHsv, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__222e0839c306f86b022a32e67dcef10f3888a173bcbe2e80476a55a472c6488b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsv", [value]))

    @jsii.member(jsii_name="putIfDimension")
    def put_if_dimension(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfDimension, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__08d9432d79c1547c9ab7635e4a60acb8a1403a7ca3cba020bb7a6bf151ab365c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfDimension", [value]))

    @jsii.member(jsii_name="putIfOrientation")
    def put_if_orientation(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7551a65d4ad379f1e0710bed54afb348b20cd20d30751ae596cd60afff821062)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfOrientation", [value]))

    @jsii.member(jsii_name="putImQuery")
    def put_im_query(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanImQuery, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__03b65020988610986ff41dbec34b2e3e0b16d2a641d14cd48e9d170a4f798eee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putImQuery", [value]))

    @jsii.member(jsii_name="putMaxColors")
    def put_max_colors(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanMaxColors, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a8c21ac48c075892deb7ad3a06d4ceba01b3b0a54044912c098845b198869a12)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMaxColors", [value]))

    @jsii.member(jsii_name="putMirror")
    def put_mirror(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanMirror, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b91a359d29a1d924ffbb8f9ca855434a41df894ce90e06b75b34ad2cb804a73f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMirror", [value]))

    @jsii.member(jsii_name="putMonoHue")
    def put_mono_hue(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanMonoHue, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8e9789a58a1aab77ecf0daa803beffce0e9d9ea565bb1c0c1b86fedc88253e58)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMonoHue", [value]))

    @jsii.member(jsii_name="putOpacity")
    def put_opacity(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanOpacity, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dd6daa6e40e42e7856d1c7351ce927b9cca7565a656558afd0538cbe2b6d9503)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putOpacity", [value]))

    @jsii.member(jsii_name="putRegionOfInterestCrop")
    def put_region_of_interest_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanRegionOfInterestCrop", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6d9583c02a7cbd14db527e1f99e556f6c1874946f96a6cfc055cc61c7915f129)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRegionOfInterestCrop", [value]))

    @jsii.member(jsii_name="putRelativeCrop")
    def put_relative_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanRelativeCrop", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f5bf08567f2037002d1fa2ebf9b23278fb94b16affa9ee665e7b6885e7172e88)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRelativeCrop", [value]))

    @jsii.member(jsii_name="putRemoveColor")
    def put_remove_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanRemoveColor", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__acad82e9f490534d8f65ef6dab719ca605168e3de45721ffd000c3afdfbeec14)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRemoveColor", [value]))

    @jsii.member(jsii_name="putResize")
    def put_resize(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanResize", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6d7064c1c1d268f0cea4d316f584764df60337977d70535418fdbd97123b0ae2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putResize", [value]))

    @jsii.member(jsii_name="putRotate")
    def put_rotate(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanRotate", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9f74da4217700f17845cc3c3d304e5f45f3f6fc3cbd69f88809c8873d78b1b3f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRotate", [value]))

    @jsii.member(jsii_name="putScale")
    def put_scale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanScale", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e5fd374b51aa17e00778ce34e29a067deb821a96f02627ac8083479f1d1c178c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putScale", [value]))

    @jsii.member(jsii_name="putShear")
    def put_shear(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanShear", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__28ccba77ffe8f8632f6dedbb365d46137719f33ff151699b7787345e03d0291b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putShear", [value]))

    @jsii.member(jsii_name="putTrim")
    def put_trim(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanTrim", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fe987eccda79dbf30bb57f9dc5f74a12d7aa762fbf70df3378d82f0e234b3022)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTrim", [value]))

    @jsii.member(jsii_name="putUnsharpMask")
    def put_unsharp_mask(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanUnsharpMask", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__09759d0288db6dae8c21b9a1c747b4116fd820b30e0eb97831df2f0684bb76d4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putUnsharpMask", [value]))

    @jsii.member(jsii_name="resetAppend")
    def reset_append(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAppend", []))

    @jsii.member(jsii_name="resetAspectCrop")
    def reset_aspect_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspectCrop", []))

    @jsii.member(jsii_name="resetBackgroundColor")
    def reset_background_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBackgroundColor", []))

    @jsii.member(jsii_name="resetBlur")
    def reset_blur(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBlur", []))

    @jsii.member(jsii_name="resetChromaKey")
    def reset_chroma_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChromaKey", []))

    @jsii.member(jsii_name="resetComposite")
    def reset_composite(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetComposite", []))

    @jsii.member(jsii_name="resetCompound")
    def reset_compound(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCompound", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetCrop")
    def reset_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCrop", []))

    @jsii.member(jsii_name="resetFaceCrop")
    def reset_face_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFaceCrop", []))

    @jsii.member(jsii_name="resetFeatureCrop")
    def reset_feature_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureCrop", []))

    @jsii.member(jsii_name="resetFitAndFill")
    def reset_fit_and_fill(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFitAndFill", []))

    @jsii.member(jsii_name="resetGoop")
    def reset_goop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGoop", []))

    @jsii.member(jsii_name="resetGrayscale")
    def reset_grayscale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGrayscale", []))

    @jsii.member(jsii_name="resetHsl")
    def reset_hsl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsl", []))

    @jsii.member(jsii_name="resetHsv")
    def reset_hsv(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsv", []))

    @jsii.member(jsii_name="resetIfDimension")
    def reset_if_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfDimension", []))

    @jsii.member(jsii_name="resetIfOrientation")
    def reset_if_orientation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfOrientation", []))

    @jsii.member(jsii_name="resetImQuery")
    def reset_im_query(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetImQuery", []))

    @jsii.member(jsii_name="resetMaxColors")
    def reset_max_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxColors", []))

    @jsii.member(jsii_name="resetMirror")
    def reset_mirror(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMirror", []))

    @jsii.member(jsii_name="resetMonoHue")
    def reset_mono_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonoHue", []))

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetRegionOfInterestCrop")
    def reset_region_of_interest_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRegionOfInterestCrop", []))

    @jsii.member(jsii_name="resetRelativeCrop")
    def reset_relative_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRelativeCrop", []))

    @jsii.member(jsii_name="resetRemoveColor")
    def reset_remove_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRemoveColor", []))

    @jsii.member(jsii_name="resetResize")
    def reset_resize(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetResize", []))

    @jsii.member(jsii_name="resetRotate")
    def reset_rotate(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRotate", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetShear")
    def reset_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetShear", []))

    @jsii.member(jsii_name="resetTrim")
    def reset_trim(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTrim", []))

    @jsii.member(jsii_name="resetUnsharpMask")
    def reset_unsharp_mask(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUnsharpMask", []))

    @builtins.property
    @jsii.member(jsii_name="append")
    def append(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanAppendList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanAppendList, jsii.get(self, "append"))

    @builtins.property
    @jsii.member(jsii_name="aspectCrop")
    def aspect_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanAspectCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanAspectCropList, jsii.get(self, "aspectCrop"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColor")
    def background_color(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanBackgroundColorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanBackgroundColorList, jsii.get(self, "backgroundColor"))

    @builtins.property
    @jsii.member(jsii_name="blur")
    def blur(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanBlurList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanBlurList, jsii.get(self, "blur"))

    @builtins.property
    @jsii.member(jsii_name="chromaKey")
    def chroma_key(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanChromaKeyList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanChromaKeyList, jsii.get(self, "chromaKey"))

    @builtins.property
    @jsii.member(jsii_name="composite")
    def composite(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanCompositeList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanCompositeList, jsii.get(self, "composite"))

    @builtins.property
    @jsii.member(jsii_name="compound")
    def compound(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanCompoundList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanCompoundList, jsii.get(self, "compound"))

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanContrastList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanContrastList, jsii.get(self, "contrast"))

    @builtins.property
    @jsii.member(jsii_name="crop")
    def crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanCropList, jsii.get(self, "crop"))

    @builtins.property
    @jsii.member(jsii_name="faceCrop")
    def face_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanFaceCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanFaceCropList, jsii.get(self, "faceCrop"))

    @builtins.property
    @jsii.member(jsii_name="featureCrop")
    def feature_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanFeatureCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanFeatureCropList, jsii.get(self, "featureCrop"))

    @builtins.property
    @jsii.member(jsii_name="fitAndFill")
    def fit_and_fill(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanFitAndFillList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanFitAndFillList, jsii.get(self, "fitAndFill"))

    @builtins.property
    @jsii.member(jsii_name="goop")
    def goop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanGoopList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanGoopList, jsii.get(self, "goop"))

    @builtins.property
    @jsii.member(jsii_name="grayscale")
    def grayscale(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanGrayscaleList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanGrayscaleList, jsii.get(self, "grayscale"))

    @builtins.property
    @jsii.member(jsii_name="hsl")
    def hsl(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanHslList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanHslList, jsii.get(self, "hsl"))

    @builtins.property
    @jsii.member(jsii_name="hsv")
    def hsv(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanHsvList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanHsvList, jsii.get(self, "hsv"))

    @builtins.property
    @jsii.member(jsii_name="ifDimension")
    def if_dimension(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionList, jsii.get(self, "ifDimension"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientation")
    def if_orientation(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationList, jsii.get(self, "ifOrientation"))

    @builtins.property
    @jsii.member(jsii_name="imQuery")
    def im_query(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanImQueryList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanImQueryList, jsii.get(self, "imQuery"))

    @builtins.property
    @jsii.member(jsii_name="maxColors")
    def max_colors(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanMaxColorsList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanMaxColorsList, jsii.get(self, "maxColors"))

    @builtins.property
    @jsii.member(jsii_name="mirror")
    def mirror(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanMirrorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanMirrorList, jsii.get(self, "mirror"))

    @builtins.property
    @jsii.member(jsii_name="monoHue")
    def mono_hue(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanMonoHueList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanMonoHueList, jsii.get(self, "monoHue"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanOpacityList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanOpacityList, jsii.get(self, "opacity"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestCrop")
    def region_of_interest_crop(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanRegionOfInterestCropList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanRegionOfInterestCropList", jsii.get(self, "regionOfInterestCrop"))

    @builtins.property
    @jsii.member(jsii_name="relativeCrop")
    def relative_crop(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanRelativeCropList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanRelativeCropList", jsii.get(self, "relativeCrop"))

    @builtins.property
    @jsii.member(jsii_name="removeColor")
    def remove_color(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanRemoveColorList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanRemoveColorList", jsii.get(self, "removeColor"))

    @builtins.property
    @jsii.member(jsii_name="resize")
    def resize(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanResizeList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanResizeList", jsii.get(self, "resize"))

    @builtins.property
    @jsii.member(jsii_name="rotate")
    def rotate(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanRotateList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanRotateList", jsii.get(self, "rotate"))

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanScaleList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanScaleList", jsii.get(self, "scale"))

    @builtins.property
    @jsii.member(jsii_name="shear")
    def shear(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanShearList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanShearList", jsii.get(self, "shear"))

    @builtins.property
    @jsii.member(jsii_name="trim")
    def trim(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanTrimList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanTrimList", jsii.get(self, "trim"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMask")
    def unsharp_mask(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanUnsharpMaskList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanUnsharpMaskList", jsii.get(self, "unsharpMask"))

    @builtins.property
    @jsii.member(jsii_name="appendInput")
    def append_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanAppend]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanAppend]]], jsii.get(self, "appendInput"))

    @builtins.property
    @jsii.member(jsii_name="aspectCropInput")
    def aspect_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanAspectCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanAspectCrop]]], jsii.get(self, "aspectCropInput"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColorInput")
    def background_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanBackgroundColor]]], jsii.get(self, "backgroundColorInput"))

    @builtins.property
    @jsii.member(jsii_name="blurInput")
    def blur_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanBlur]]], jsii.get(self, "blurInput"))

    @builtins.property
    @jsii.member(jsii_name="chromaKeyInput")
    def chroma_key_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanChromaKey]]], jsii.get(self, "chromaKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="compositeInput")
    def composite_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanComposite]]], jsii.get(self, "compositeInput"))

    @builtins.property
    @jsii.member(jsii_name="compoundInput")
    def compound_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanCompound]]], jsii.get(self, "compoundInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanContrast]]], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="cropInput")
    def crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanCrop]]], jsii.get(self, "cropInput"))

    @builtins.property
    @jsii.member(jsii_name="faceCropInput")
    def face_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanFaceCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanFaceCrop]]], jsii.get(self, "faceCropInput"))

    @builtins.property
    @jsii.member(jsii_name="featureCropInput")
    def feature_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanFeatureCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanFeatureCrop]]], jsii.get(self, "featureCropInput"))

    @builtins.property
    @jsii.member(jsii_name="fitAndFillInput")
    def fit_and_fill_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanFitAndFill]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanFitAndFill]]], jsii.get(self, "fitAndFillInput"))

    @builtins.property
    @jsii.member(jsii_name="goopInput")
    def goop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanGoop]]], jsii.get(self, "goopInput"))

    @builtins.property
    @jsii.member(jsii_name="grayscaleInput")
    def grayscale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanGrayscale]]], jsii.get(self, "grayscaleInput"))

    @builtins.property
    @jsii.member(jsii_name="hslInput")
    def hsl_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanHsl]]], jsii.get(self, "hslInput"))

    @builtins.property
    @jsii.member(jsii_name="hsvInput")
    def hsv_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanHsv]]], jsii.get(self, "hsvInput"))

    @builtins.property
    @jsii.member(jsii_name="ifDimensionInput")
    def if_dimension_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfDimension]]], jsii.get(self, "ifDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientationInput")
    def if_orientation_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientation]]], jsii.get(self, "ifOrientationInput"))

    @builtins.property
    @jsii.member(jsii_name="imQueryInput")
    def im_query_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanImQuery]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanImQuery]]], jsii.get(self, "imQueryInput"))

    @builtins.property
    @jsii.member(jsii_name="maxColorsInput")
    def max_colors_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanMaxColors]]], jsii.get(self, "maxColorsInput"))

    @builtins.property
    @jsii.member(jsii_name="mirrorInput")
    def mirror_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanMirror]]], jsii.get(self, "mirrorInput"))

    @builtins.property
    @jsii.member(jsii_name="monoHueInput")
    def mono_hue_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanMonoHue]]], jsii.get(self, "monoHueInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanOpacity]]], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestCropInput")
    def region_of_interest_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanRegionOfInterestCrop"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanRegionOfInterestCrop"]]], jsii.get(self, "regionOfInterestCropInput"))

    @builtins.property
    @jsii.member(jsii_name="relativeCropInput")
    def relative_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanRelativeCrop"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanRelativeCrop"]]], jsii.get(self, "relativeCropInput"))

    @builtins.property
    @jsii.member(jsii_name="removeColorInput")
    def remove_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanRemoveColor"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanRemoveColor"]]], jsii.get(self, "removeColorInput"))

    @builtins.property
    @jsii.member(jsii_name="resizeInput")
    def resize_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanResize"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanResize"]]], jsii.get(self, "resizeInput"))

    @builtins.property
    @jsii.member(jsii_name="rotateInput")
    def rotate_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanRotate"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanRotate"]]], jsii.get(self, "rotateInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanScale"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanScale"]]], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="shearInput")
    def shear_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanShear"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanShear"]]], jsii.get(self, "shearInput"))

    @builtins.property
    @jsii.member(jsii_name="trimInput")
    def trim_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanTrim"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanTrim"]]], jsii.get(self, "trimInput"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMaskInput")
    def unsharp_mask_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanUnsharpMask"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanUnsharpMask"]]], jsii.get(self, "unsharpMaskInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0e8cd38d614f3ef6f186bb1b02bb60bd418e3bf9d9358df185a81e6cd66ee297)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanRegionOfInterestCrop",
    jsii_struct_bases=[],
    name_mapping={
        "region_of_interest": "regionOfInterest",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanRegionOfInterestCrop:
    def __init__(
        self,
        *,
        region_of_interest: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanRegionOfInterestCropRegionOfInterest", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param region_of_interest: region_of_interest block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest DataAkamaiImagingPolicyImage#region_of_interest}
        :param gravity: The placement of the crop area relative to the specified area of interest. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: The placement of the crop area relative to the specified area of interest. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param style: Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(region_of_interest, dict):
            region_of_interest = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanRegionOfInterestCropRegionOfInterest(**region_of_interest)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__36e28f38f8482f46b0bad15e6046ad784259be09512f5943a6b34d7e01cad5ad)
            check_type(argname="argument region_of_interest", value=region_of_interest, expected_type=type_hints["region_of_interest"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "region_of_interest": region_of_interest,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def region_of_interest(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanRegionOfInterestCropRegionOfInterest":
        '''region_of_interest block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest DataAkamaiImagingPolicyImage#region_of_interest}
        '''
        result = self._values.get("region_of_interest")
        assert result is not None, "Required property 'region_of_interest' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanRegionOfInterestCropRegionOfInterest", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''The placement of the crop area relative to the specified area of interest.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''The placement of the crop area relative to the specified area of interest.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanRegionOfInterestCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanRegionOfInterestCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanRegionOfInterestCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__14bf1a168e87e29c2cbea8285b325822eb0f776713b33707d5f1e4019a94f57e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanRegionOfInterestCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a2d70fb31d2ab7603853fb62dcede9aa3d922dfd958d00ece4a2d2423b9a9f83)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanRegionOfInterestCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bbcde3c7c212bc4f15f2db8bffd9b21a4796c6aea99e97d0d589dc6d5e564be2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cabd73e417344877aa95caf700639487299104c1f4d8d69af12cd9aa07dd7aa0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__64a7f96f060014bd8609e8fec9ad3fdb96d5693fa3326698a676d95aefcb20dd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanRegionOfInterestCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanRegionOfInterestCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanRegionOfInterestCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__05bcaca709eaf0ae54872903b8f92012171c4ac882118547d739f7345a5e72c2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanRegionOfInterestCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanRegionOfInterestCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8dff1376f5bfdb3876f37174caf1a779738318290f416ab94276adc41a0f1f34)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putRegionOfInterest")
    def put_region_of_interest(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanRegionOfInterestCropRegionOfInterest()

        return typing.cast(None, jsii.invoke(self, "putRegionOfInterest", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterest")
    def region_of_interest(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanRegionOfInterestCropRegionOfInterestOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanRegionOfInterestCropRegionOfInterestOutputReference", jsii.get(self, "regionOfInterest"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestInput")
    def region_of_interest_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanRegionOfInterestCropRegionOfInterest"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanRegionOfInterestCropRegionOfInterest"], jsii.get(self, "regionOfInterestInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__589864e208b876141e87390e245f5550b3e926ab2d5ccf60bb39c410edb0c675)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8969549fc2d6b85f633844f9b53ad7d8bd68cdbe524b1a08249fff4c89e7435a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__57ebce5cfed0caafc70b207516332aceb9d954ee930a0c4bdb32a9b27995021d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cf667e8172cf0874991e691d99e55a147baa899f8aa67175ca39bc1ae04e01c6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__938935626d5c7043dcc328aaec5d47c43984dd6dc7a4066d05cf47eb2601e9c2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3c8b7cc8a6a46d33fc10c50aa38da4aa8c909b8630f0004a00415617782aa82d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f1d16bd2a05cfe2f05424bd7c34e47cb316657905820c7d3f701faacef38ff1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f411c37a2c1c8fda77473e66c3485029cf1e68ac8e120cd1571f789750aacea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanRegionOfInterestCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanRegionOfInterestCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanRegionOfInterestCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__631fdbb015ea01d47ecaebb372e37098ed42dde2d4adc17c414448dba4161ed6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanRegionOfInterestCropRegionOfInterest",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanRegionOfInterestCropRegionOfInterest:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanRegionOfInterestCropRegionOfInterest(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanRegionOfInterestCropRegionOfInterestOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanRegionOfInterestCropRegionOfInterestOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f1be3762e5e52ae63f2cefd61c2d1392ff329b730ec4bd5560501f816141132)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanRegionOfInterestCropRegionOfInterest]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanRegionOfInterestCropRegionOfInterest], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanRegionOfInterestCropRegionOfInterest],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fd6e7611d0bf29403410870a5163776682671b1a11b2833a20ecf4883a8a33e6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanRelativeCrop",
    jsii_struct_bases=[],
    name_mapping={
        "east": "east",
        "east_var": "eastVar",
        "north": "north",
        "north_var": "northVar",
        "south": "south",
        "south_var": "southVar",
        "west": "west",
        "west_var": "westVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanRelativeCrop:
    def __init__(
        self,
        *,
        east: typing.Optional[builtins.str] = None,
        east_var: typing.Optional[builtins.str] = None,
        north: typing.Optional[builtins.str] = None,
        north_var: typing.Optional[builtins.str] = None,
        south: typing.Optional[builtins.str] = None,
        south_var: typing.Optional[builtins.str] = None,
        west: typing.Optional[builtins.str] = None,
        west_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param east: The number of pixels to shrink or expand the right side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east DataAkamaiImagingPolicyImage#east}
        :param east_var: The number of pixels to shrink or expand the right side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east_var DataAkamaiImagingPolicyImage#east_var}
        :param north: The number of pixels to shrink or expand the top side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north DataAkamaiImagingPolicyImage#north}
        :param north_var: The number of pixels to shrink or expand the top side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north_var DataAkamaiImagingPolicyImage#north_var}
        :param south: The number of pixels to shrink or expand the bottom side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south DataAkamaiImagingPolicyImage#south}
        :param south_var: The number of pixels to shrink or expand the bottom side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south_var DataAkamaiImagingPolicyImage#south_var}
        :param west: The number of pixels to shrink or expand the left side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west DataAkamaiImagingPolicyImage#west}
        :param west_var: The number of pixels to shrink or expand the left side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west_var DataAkamaiImagingPolicyImage#west_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ffd7b9baf25b9965be7475c509bc2590110d1a997deffa1fe2684ad71e3fa17)
            check_type(argname="argument east", value=east, expected_type=type_hints["east"])
            check_type(argname="argument east_var", value=east_var, expected_type=type_hints["east_var"])
            check_type(argname="argument north", value=north, expected_type=type_hints["north"])
            check_type(argname="argument north_var", value=north_var, expected_type=type_hints["north_var"])
            check_type(argname="argument south", value=south, expected_type=type_hints["south"])
            check_type(argname="argument south_var", value=south_var, expected_type=type_hints["south_var"])
            check_type(argname="argument west", value=west, expected_type=type_hints["west"])
            check_type(argname="argument west_var", value=west_var, expected_type=type_hints["west_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if east is not None:
            self._values["east"] = east
        if east_var is not None:
            self._values["east_var"] = east_var
        if north is not None:
            self._values["north"] = north
        if north_var is not None:
            self._values["north_var"] = north_var
        if south is not None:
            self._values["south"] = south
        if south_var is not None:
            self._values["south_var"] = south_var
        if west is not None:
            self._values["west"] = west
        if west_var is not None:
            self._values["west_var"] = west_var

    @builtins.property
    def east(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the right side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east DataAkamaiImagingPolicyImage#east}
        '''
        result = self._values.get("east")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def east_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the right side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east_var DataAkamaiImagingPolicyImage#east_var}
        '''
        result = self._values.get("east_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def north(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the top side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north DataAkamaiImagingPolicyImage#north}
        '''
        result = self._values.get("north")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def north_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the top side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north_var DataAkamaiImagingPolicyImage#north_var}
        '''
        result = self._values.get("north_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def south(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the bottom side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south DataAkamaiImagingPolicyImage#south}
        '''
        result = self._values.get("south")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def south_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the bottom side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south_var DataAkamaiImagingPolicyImage#south_var}
        '''
        result = self._values.get("south_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def west(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the left side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west DataAkamaiImagingPolicyImage#west}
        '''
        result = self._values.get("west")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def west_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the left side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west_var DataAkamaiImagingPolicyImage#west_var}
        '''
        result = self._values.get("west_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanRelativeCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanRelativeCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanRelativeCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6c19e45463b55ef5dc04fe0edf3d6747a2f3bb42d75702932522b5c9f618bd86)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanRelativeCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__016b0077428c181e9937289b721d25a87bdc63b436eb94c6dbbd7c76306e1e29)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanRelativeCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6bb8331dfc7bccc1a78ec706956dd1456b44041a3158612ed6690a4568c76098)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__47b5fb524b181719790234eed2d670397f40e4eebbe36bc9fa7613dc826a1d5f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ef92c9e4f954eb153f853d6c3e951e50e943746f278871acbc9bb0ae9d366366)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanRelativeCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanRelativeCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanRelativeCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__998e50493b59fa6c68c3d85cbb40d56697cbb33335bcfb4402460e1222cc8d8e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanRelativeCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanRelativeCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__17c92d014d3affc87818e8fa9a6d62a6cae551bfb31310b45f24382b21fcf306)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetEast")
    def reset_east(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEast", []))

    @jsii.member(jsii_name="resetEastVar")
    def reset_east_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEastVar", []))

    @jsii.member(jsii_name="resetNorth")
    def reset_north(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNorth", []))

    @jsii.member(jsii_name="resetNorthVar")
    def reset_north_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNorthVar", []))

    @jsii.member(jsii_name="resetSouth")
    def reset_south(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSouth", []))

    @jsii.member(jsii_name="resetSouthVar")
    def reset_south_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSouthVar", []))

    @jsii.member(jsii_name="resetWest")
    def reset_west(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWest", []))

    @jsii.member(jsii_name="resetWestVar")
    def reset_west_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWestVar", []))

    @builtins.property
    @jsii.member(jsii_name="eastInput")
    def east_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "eastInput"))

    @builtins.property
    @jsii.member(jsii_name="eastVarInput")
    def east_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "eastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="northInput")
    def north_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "northInput"))

    @builtins.property
    @jsii.member(jsii_name="northVarInput")
    def north_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "northVarInput"))

    @builtins.property
    @jsii.member(jsii_name="southInput")
    def south_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "southInput"))

    @builtins.property
    @jsii.member(jsii_name="southVarInput")
    def south_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "southVarInput"))

    @builtins.property
    @jsii.member(jsii_name="westInput")
    def west_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "westInput"))

    @builtins.property
    @jsii.member(jsii_name="westVarInput")
    def west_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "westVarInput"))

    @builtins.property
    @jsii.member(jsii_name="east")
    def east(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "east"))

    @east.setter
    def east(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4964d2801a5c453e7fb53748d8b8ae32b2f1acb8b6681c68f4a7890135f7465b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "east", value)

    @builtins.property
    @jsii.member(jsii_name="eastVar")
    def east_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "eastVar"))

    @east_var.setter
    def east_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d0c9595b7c2af05a9f4a0c7f395176ec68e7e3847bec732c1a0f8343edf16703)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "eastVar", value)

    @builtins.property
    @jsii.member(jsii_name="north")
    def north(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "north"))

    @north.setter
    def north(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e17bf81df1a64b766763e0530f2f66fdc4e65eb376de1fdda01406e73a89f490)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "north", value)

    @builtins.property
    @jsii.member(jsii_name="northVar")
    def north_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "northVar"))

    @north_var.setter
    def north_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__29a2e3f338a03d70f53f2388ebb3051b94e9d377035eee8e38069d935d80e595)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "northVar", value)

    @builtins.property
    @jsii.member(jsii_name="south")
    def south(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "south"))

    @south.setter
    def south(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__20b825fac47cd9e8880dbbe6166fe8b2fef3f09239a4234149d6f4b55e87a714)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "south", value)

    @builtins.property
    @jsii.member(jsii_name="southVar")
    def south_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "southVar"))

    @south_var.setter
    def south_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6317e35a72beb1b6d419797fc4787e611acf9ce8f3d15d602e893061bd4520bd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "southVar", value)

    @builtins.property
    @jsii.member(jsii_name="west")
    def west(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "west"))

    @west.setter
    def west(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__18b529980d960b688a5f6ea6e2bff74dcf24b72443d62cb64b31c06bb8c281da)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "west", value)

    @builtins.property
    @jsii.member(jsii_name="westVar")
    def west_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "westVar"))

    @west_var.setter
    def west_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2aff793c60c5974e5a92aac007888d6bac2c2a9e1773de12d422aa7801e019e9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "westVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanRelativeCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanRelativeCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanRelativeCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6d72b56b0d1dbfa9b643140cc6d793f02f3a5188138c970f57e4c36abc2ad570)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanRemoveColor",
    jsii_struct_bases=[],
    name_mapping={
        "color": "color",
        "color_var": "colorVar",
        "feather": "feather",
        "feather_var": "featherVar",
        "tolerance": "tolerance",
        "tolerance_var": "toleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanRemoveColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
        feather: typing.Optional[builtins.str] = None,
        feather_var: typing.Optional[builtins.str] = None,
        tolerance: typing.Optional[builtins.str] = None,
        tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        :param feather: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        :param feather_var: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        :param tolerance: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        :param tolerance_var: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ff9481d8dfb562d66c9feaa33252846970c9d8f6b94220beb1af32f8a7651365)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
            check_type(argname="argument feather", value=feather, expected_type=type_hints["feather"])
            check_type(argname="argument feather_var", value=feather_var, expected_type=type_hints["feather_var"])
            check_type(argname="argument tolerance", value=tolerance, expected_type=type_hints["tolerance"])
            check_type(argname="argument tolerance_var", value=tolerance_var, expected_type=type_hints["tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var
        if feather is not None:
            self._values["feather"] = feather
        if feather_var is not None:
            self._values["feather_var"] = feather_var
        if tolerance is not None:
            self._values["tolerance"] = tolerance
        if tolerance_var is not None:
            self._values["tolerance_var"] = tolerance_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        '''
        result = self._values.get("feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather_var(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        '''
        result = self._values.get("feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        '''
        result = self._values.get("tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance_var(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        result = self._values.get("tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanRemoveColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanRemoveColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanRemoveColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__47898ec9c8d5a6e1c56f7488f29a753748ab620d9cc8220d0719faaeec0ec2bf)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanRemoveColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__25c64d0fce9cf03f708273e95eb7782da01f7e152c33c67f330771eedc372762)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanRemoveColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9f4de338b3a7eadfee53ff0467bcc6ad720a4adceab12f2d7c6acf6fd6b0c057)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2694248fdf531c37418114e9687a44b55f0023fb02ae0525a0c0dacd6842c918)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0d89eca4bdbe1ebf540f4a381d9f280d74207accca5148128dcbd37c07316429)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanRemoveColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanRemoveColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanRemoveColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__185cda3c3220353d9d3242c61323ced014087f373d8d7b4af82f4ae4722b57e9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanRemoveColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanRemoveColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__44374e6df552e574476d31a678b65bb94a37b9f3b74a31d36f3263955be8cecb)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @jsii.member(jsii_name="resetFeather")
    def reset_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeather", []))

    @jsii.member(jsii_name="resetFeatherVar")
    def reset_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatherVar", []))

    @jsii.member(jsii_name="resetTolerance")
    def reset_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTolerance", []))

    @jsii.member(jsii_name="resetToleranceVar")
    def reset_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featherInput")
    def feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherInput"))

    @builtins.property
    @jsii.member(jsii_name="featherVarInput")
    def feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceInput")
    def tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceVarInput")
    def tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a768b48bf8890962028e02ff6f2f0d1cbb01538a1b5485c5e7c5a5bdb8d34d37)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e874260feedda8f37fd38cb4718ffee4c2c0997a4a7045c3d4d84ffcec3fb16f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="feather")
    def feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "feather"))

    @feather.setter
    def feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ff3db0029aaeb843da1219dfe5de1ebd2b812a6d4612c1e87ef10a966005f9d2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "feather", value)

    @builtins.property
    @jsii.member(jsii_name="featherVar")
    def feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featherVar"))

    @feather_var.setter
    def feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__67a02e0b9f8fc199a1c31d3c7d8dfd3b1c638e503a799b5bd186c6a0137e7bdd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featherVar", value)

    @builtins.property
    @jsii.member(jsii_name="tolerance")
    def tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tolerance"))

    @tolerance.setter
    def tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2f45dea66900d3377c3ae8e9ee0c6d8fa896cfb36f94668e5fdd3d06e18dcec0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tolerance", value)

    @builtins.property
    @jsii.member(jsii_name="toleranceVar")
    def tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "toleranceVar"))

    @tolerance_var.setter
    def tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d553746ace42ae6252d0d157cfeee78504598c37e9058e2c489e77b476e2f5bc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "toleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanRemoveColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanRemoveColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanRemoveColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4adb8163ad326f261f96562c481578463762f87063ecc7638ec66f382aa293dc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanResize",
    jsii_struct_bases=[],
    name_mapping={
        "aspect": "aspect",
        "aspect_var": "aspectVar",
        "height": "height",
        "height_var": "heightVar",
        "type": "type",
        "type_var": "typeVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanResize:
    def __init__(
        self,
        *,
        aspect: typing.Optional[builtins.str] = None,
        aspect_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param aspect: Preserves the aspect ratio. Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect DataAkamaiImagingPolicyImage#aspect}
        :param aspect_var: Preserves the aspect ratio. Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_var DataAkamaiImagingPolicyImage#aspect_var}
        :param height: The height to resize the source image to. Must be set if height is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height to resize the source image to. Must be set if height is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param type: Sets constraints for the image resize. Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: Sets constraints for the image resize. Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        :param width: The width to resize the source image to. Must be set if width is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width to resize the source image to. Must be set if width is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8990bfa3cceac7295be6100400dc355faa25683a1bf227914a4cd44b08abbedf)
            check_type(argname="argument aspect", value=aspect, expected_type=type_hints["aspect"])
            check_type(argname="argument aspect_var", value=aspect_var, expected_type=type_hints["aspect_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if aspect is not None:
            self._values["aspect"] = aspect
        if aspect_var is not None:
            self._values["aspect_var"] = aspect_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def aspect(self) -> typing.Optional[builtins.str]:
        '''Preserves the aspect ratio.

        Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect DataAkamaiImagingPolicyImage#aspect}
        '''
        result = self._values.get("aspect")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def aspect_var(self) -> typing.Optional[builtins.str]:
        '''Preserves the aspect ratio.

        Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_var DataAkamaiImagingPolicyImage#aspect_var}
        '''
        result = self._values.get("aspect_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height to resize the source image to. Must be set if height is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height to resize the source image to. Must be set if height is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''Sets constraints for the image resize.

        Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''Sets constraints for the image resize.

        Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width to resize the source image to. Must be set if width is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width to resize the source image to. Must be set if width is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanResize(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanResizeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanResizeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a9c0f1a01f00fd702454af70e4e47e5494c85f5d68a1feaa558353554a8d2f1d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanResizeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7b725ec12dbb95bfa0faa3b34f3177cb7a4b1c61e3f797c8077af3214b70ce5b)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanResizeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8d340f49b15c200f4035cbbb8d21c967d09a18ae038182b70e937b453a170644)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__80d98a13dec1151a177fb7a304379cfbf5b4a20c9447590d215f5f334857b1e6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__02886803b752e181d869afbfe4e7236878f5b56aab4062e7922e731e3dc21670)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanResize]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanResize]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanResize]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8077e6cc428671eec3ff2894f577e853183b98295907d4b50e4206971a0ae702)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanResizeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanResizeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d1abca284cd77fe1b08ffc17b6c630eec217151b5508465d3b524d120c946935)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAspect")
    def reset_aspect(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspect", []))

    @jsii.member(jsii_name="resetAspectVar")
    def reset_aspect_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspectVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="aspectInput")
    def aspect_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "aspectInput"))

    @builtins.property
    @jsii.member(jsii_name="aspectVarInput")
    def aspect_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "aspectVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="aspect")
    def aspect(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "aspect"))

    @aspect.setter
    def aspect(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__68a1a45fd2945953f32349611300f1a5449c0310194d62ed32885c5582830a70)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "aspect", value)

    @builtins.property
    @jsii.member(jsii_name="aspectVar")
    def aspect_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "aspectVar"))

    @aspect_var.setter
    def aspect_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b36fc3916f6dc8c4b80a7a227d41119d137ddee2f0fd2a5ca08dd7cfd39edbb4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "aspectVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bdd9553449a0673671452223d915db745b7f6a7c2acf45d1841386627560fa71)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3eda6655649f8c4a982538547236730f00139a3522b9f10108147d7313580565)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea2911a6c16d8bfbedf17ae871a7c11c981cf333b30c6bb7789cd1a1712ae678)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a2a997dc39a6510cf55f9fd3eb86ff60c42c9a4668496e927c60555cc0512f9f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ae4ef10bf37b3f2cdc7dca84015f63b7606225c83b103b6f8fefd52bf70f385)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a322e265c1fb3e18c9f2eff2b930114b57bdd1ccaacf16e0fe7ad93c8773f1c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanResize]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanResize]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanResize]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f825764250de8af43dbfe87d6d1dcc2627ae1e755d8d5f1528715bedebd77b05)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanRotate",
    jsii_struct_bases=[],
    name_mapping={"degrees": "degrees", "degrees_var": "degreesVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanRotate:
    def __init__(
        self,
        *,
        degrees: typing.Optional[builtins.str] = None,
        degrees_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param degrees: The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees DataAkamaiImagingPolicyImage#degrees}
        :param degrees_var: The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees_var DataAkamaiImagingPolicyImage#degrees_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__29506c208dc70fa5e3265ed161e87306a353e4eae7b98bd418a4c99324d5fa51)
            check_type(argname="argument degrees", value=degrees, expected_type=type_hints["degrees"])
            check_type(argname="argument degrees_var", value=degrees_var, expected_type=type_hints["degrees_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if degrees is not None:
            self._values["degrees"] = degrees
        if degrees_var is not None:
            self._values["degrees_var"] = degrees_var

    @builtins.property
    def degrees(self) -> typing.Optional[builtins.str]:
        '''The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees DataAkamaiImagingPolicyImage#degrees}
        '''
        result = self._values.get("degrees")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def degrees_var(self) -> typing.Optional[builtins.str]:
        '''The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees_var DataAkamaiImagingPolicyImage#degrees_var}
        '''
        result = self._values.get("degrees_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanRotate(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanRotateList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanRotateList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__72f8d496bedca5e8d73ce96d3d9007e9967ed9a266bc160fe7c575c766d654a7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanRotateOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d0df962718c79accd8667faab460793787a772b0606b14c097e498b53f0c17c0)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanRotateOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7eaac367cf61aa8b828929ef67d870b9c30a8b62e654ba52daf89eddd3925d1f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5832ae1e3b0c25f15cb4dd49a48226a36f7bb1234bf5fc5e5f810b4452a1c9f2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a0ed01e8248f19951b551bcc468117df9250ac30dec70ceba0c4b7a3bd69caac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanRotate]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanRotate]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanRotate]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a8f9ff3e5d2053c25e4164842a968fb442ec7854cbd7c8cdc7569efeb0ca0808)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanRotateOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanRotateOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b2a3504bdb0c0a550f5b5250bf4b824dc70a83cd423da1d6233ccf15ca640290)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetDegrees")
    def reset_degrees(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDegrees", []))

    @jsii.member(jsii_name="resetDegreesVar")
    def reset_degrees_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDegreesVar", []))

    @builtins.property
    @jsii.member(jsii_name="degreesInput")
    def degrees_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "degreesInput"))

    @builtins.property
    @jsii.member(jsii_name="degreesVarInput")
    def degrees_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "degreesVarInput"))

    @builtins.property
    @jsii.member(jsii_name="degrees")
    def degrees(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "degrees"))

    @degrees.setter
    def degrees(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b89c39169eef452298e723afd39a5718e9e80fa0173445bb07bc052f4c790c3b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "degrees", value)

    @builtins.property
    @jsii.member(jsii_name="degreesVar")
    def degrees_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "degreesVar"))

    @degrees_var.setter
    def degrees_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a3d636075628dea42b8725c4d2d1183e89e546ab831a71e4335086e17ed098de)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "degreesVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanRotate]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanRotate]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanRotate]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__14c84f595b9122f3e522e78351ff41809c9ffb804e8cced0f16a707868a6be1a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanScale",
    jsii_struct_bases=[],
    name_mapping={
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanScale:
    def __init__(
        self,
        *,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param height: Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged. Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged. Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6ab97c776b5b991948e819c3acfe37f2c4e974f2153e6654443e38c64db2b622)
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size.

        Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size.

        Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged.

        Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged.

        Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanScale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanScaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanScaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__00c832ec3f91ac0c76e69d8ff2b4bef1a1870dfe5f909eb452a14900d4451a99)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanScaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__03dae2307acec346df6609bbeef078140014441a08f128b3530b0a2fa49c9fd1)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanScaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a24be8ed7609b6ee1d1dc3815aac0ca49db2cd07cab6510f97668c9179172f1c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e54a11e2fcce42392f727dde2ed528441b017efca680a838c47073e0616e62be)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8918116fc95941c63b5606f69ed648cb5d397daf7472e338cc37a245237811a2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanScale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanScale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanScale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__11089c42be933e552c5bb4e86b60a33ad71e99249d9f5fc49380012c12d62b34)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanScaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanScaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__65459e9e9c7a20532db38d50692a1424742522a05b40faddeed8270956689b12)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4e6b2dfe831f820fe6e37eadc91ff6ca4bcf4877a5b07910993f58545346a434)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b73a2741b3f4d67e2ade559abe0849a75d60ee8d2ee53e3b7c7a15faad10ca53)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__55ba0d407321f9b0e61f6d1d28cf3707cecdd24ff59367f235ffc28fdbd1070d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d89c3cd1246bbed3e69a9ad1a15114a2406396ff9db1fb69dd51c01d6f45aae0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanScale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanScale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanScale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e784b91d4fcabdaa5eac6917240821818d9f9ebeb06a4f6036c16c0c72e29c14)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanShear",
    jsii_struct_bases=[],
    name_mapping={
        "x_shear": "xShear",
        "x_shear_var": "xShearVar",
        "y_shear": "yShear",
        "y_shear_var": "yShearVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanShear:
    def __init__(
        self,
        *,
        x_shear: typing.Optional[builtins.str] = None,
        x_shear_var: typing.Optional[builtins.str] = None,
        y_shear: typing.Optional[builtins.str] = None,
        y_shear_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param x_shear: The amount to shear along the x-axis, measured in multiples of the image's width. Must be set if yShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear DataAkamaiImagingPolicyImage#x_shear}
        :param x_shear_var: The amount to shear along the x-axis, measured in multiples of the image's width. Must be set if yShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear_var DataAkamaiImagingPolicyImage#x_shear_var}
        :param y_shear: The amount to shear along the y-axis, measured in multiples of the image's height. Must be set if xShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear DataAkamaiImagingPolicyImage#y_shear}
        :param y_shear_var: The amount to shear along the y-axis, measured in multiples of the image's height. Must be set if xShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear_var DataAkamaiImagingPolicyImage#y_shear_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fb6cd4b5c467bd4c76d0695c2ff529ff7fb001fc254b2789a4f7aab05d20a57b)
            check_type(argname="argument x_shear", value=x_shear, expected_type=type_hints["x_shear"])
            check_type(argname="argument x_shear_var", value=x_shear_var, expected_type=type_hints["x_shear_var"])
            check_type(argname="argument y_shear", value=y_shear, expected_type=type_hints["y_shear"])
            check_type(argname="argument y_shear_var", value=y_shear_var, expected_type=type_hints["y_shear_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if x_shear is not None:
            self._values["x_shear"] = x_shear
        if x_shear_var is not None:
            self._values["x_shear_var"] = x_shear_var
        if y_shear is not None:
            self._values["y_shear"] = y_shear
        if y_shear_var is not None:
            self._values["y_shear_var"] = y_shear_var

    @builtins.property
    def x_shear(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the x-axis, measured in multiples of the image's width.

        Must be set if yShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear DataAkamaiImagingPolicyImage#x_shear}
        '''
        result = self._values.get("x_shear")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_shear_var(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the x-axis, measured in multiples of the image's width.

        Must be set if yShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear_var DataAkamaiImagingPolicyImage#x_shear_var}
        '''
        result = self._values.get("x_shear_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_shear(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the y-axis, measured in multiples of the image's height.

        Must be set if xShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear DataAkamaiImagingPolicyImage#y_shear}
        '''
        result = self._values.get("y_shear")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_shear_var(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the y-axis, measured in multiples of the image's height.

        Must be set if xShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear_var DataAkamaiImagingPolicyImage#y_shear_var}
        '''
        result = self._values.get("y_shear_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanShear(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanShearList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanShearList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__76379ea590a351fa8c1d33a5c06f46f34504c6ff80d5c99caeddc8016b0e17d9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanShearOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cef5723d57a44194fb0294c108baa9c5e63caedbb6c22c64031175d3f3934d40)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanShearOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c354dfd752ed41f04737d2471d2f845c2d92392cae26bf3c7a31976eebcd0f2f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__162d49a700f554944469ed46fc285d9151cb481c86d16374af84188f9a740473)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6b5efa2144ac03659c199520034756ad290a916879db924a3bc8e54e335e4401)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanShear]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanShear]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanShear]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__59c9dce2c9cf2a6bab6ffee76a575fad424cad3d6404ce9997c4041414f9aaca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanShearOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanShearOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a202175966739dee4b84a16fcadbbfe55e8d86fdb1e1650d940da6be066db223)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetXShear")
    def reset_x_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXShear", []))

    @jsii.member(jsii_name="resetXShearVar")
    def reset_x_shear_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXShearVar", []))

    @jsii.member(jsii_name="resetYShear")
    def reset_y_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYShear", []))

    @jsii.member(jsii_name="resetYShearVar")
    def reset_y_shear_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYShearVar", []))

    @builtins.property
    @jsii.member(jsii_name="xShearInput")
    def x_shear_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xShearInput"))

    @builtins.property
    @jsii.member(jsii_name="xShearVarInput")
    def x_shear_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xShearVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yShearInput")
    def y_shear_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yShearInput"))

    @builtins.property
    @jsii.member(jsii_name="yShearVarInput")
    def y_shear_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yShearVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xShear")
    def x_shear(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xShear"))

    @x_shear.setter
    def x_shear(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__09a865d548b5863f2b96fec1a13f94a88a7870b370832e0ca8874ecb2386347b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xShear", value)

    @builtins.property
    @jsii.member(jsii_name="xShearVar")
    def x_shear_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xShearVar"))

    @x_shear_var.setter
    def x_shear_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__32f80827e8f41ebddff6d2d4183a589e738467c89e4d8bf5a7454b41d9a15454)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xShearVar", value)

    @builtins.property
    @jsii.member(jsii_name="yShear")
    def y_shear(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yShear"))

    @y_shear.setter
    def y_shear(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df74c710216a22220a1b3e4165cf7a2a333f4d3becb2df7006e6bad6f0b4ca34)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yShear", value)

    @builtins.property
    @jsii.member(jsii_name="yShearVar")
    def y_shear_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yShearVar"))

    @y_shear_var.setter
    def y_shear_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__842499ef1cf42a730914964eea70e8f53befacfd6de1faee6d8be9ef34a9f862)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yShearVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanShear]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanShear]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanShear]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__422a8b95dd8f1bb7b3192d211cdd216a374e46e5b0a34a480f8c370055875ac1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanTrim",
    jsii_struct_bases=[],
    name_mapping={
        "fuzz": "fuzz",
        "fuzz_var": "fuzzVar",
        "padding": "padding",
        "padding_var": "paddingVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanTrim:
    def __init__(
        self,
        *,
        fuzz: typing.Optional[builtins.str] = None,
        fuzz_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fuzz: The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz DataAkamaiImagingPolicyImage#fuzz}
        :param fuzz_var: The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz_var DataAkamaiImagingPolicyImage#fuzz_var}
        :param padding: The amount of padding in pixels to add to the trimmed image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: The amount of padding in pixels to add to the trimmed image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d9eee1942a2673e651870834550d87a699221853ca75db7539d51880df3306ee)
            check_type(argname="argument fuzz", value=fuzz, expected_type=type_hints["fuzz"])
            check_type(argname="argument fuzz_var", value=fuzz_var, expected_type=type_hints["fuzz_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fuzz is not None:
            self._values["fuzz"] = fuzz
        if fuzz_var is not None:
            self._values["fuzz_var"] = fuzz_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var

    @builtins.property
    def fuzz(self) -> typing.Optional[builtins.str]:
        '''The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz DataAkamaiImagingPolicyImage#fuzz}
        '''
        result = self._values.get("fuzz")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fuzz_var(self) -> typing.Optional[builtins.str]:
        '''The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz_var DataAkamaiImagingPolicyImage#fuzz_var}
        '''
        result = self._values.get("fuzz_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''The amount of padding in pixels to add to the trimmed image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''The amount of padding in pixels to add to the trimmed image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanTrim(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanTrimList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanTrimList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__44de1a3f8bc651d19bfa3683cef63e9588c29a0a35ec179397c9b7b5984475d0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanTrimOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__63cf0ed2b3090fbc24876f25a7d8ee572cfb893af96bad61d2d9464da43cc0ab)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanTrimOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e16b83d1402b2123cba5003c4d6943e1442eb94987fa1c5f55c6970549038157)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a82d8cf8abe1145fa1e30918618a96185a96f9ae7292e02e40def24f012e02c4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3cc8fdfd0d2627fe46d29eccc6668d1b7f38d84174c82836cf14fc124234db07)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanTrim]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanTrim]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanTrim]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__484b833f8b21dde87c9e9a54145b201accb2e01a5b9c94aed8f78adcb3272f1d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanTrimOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanTrimOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__327f9f13cc69fcf2afd2670e3b4d9c2204d2977e8277ffe80ad36cc1ef50edba)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetFuzz")
    def reset_fuzz(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFuzz", []))

    @jsii.member(jsii_name="resetFuzzVar")
    def reset_fuzz_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFuzzVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @builtins.property
    @jsii.member(jsii_name="fuzzInput")
    def fuzz_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fuzzInput"))

    @builtins.property
    @jsii.member(jsii_name="fuzzVarInput")
    def fuzz_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fuzzVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="fuzz")
    def fuzz(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fuzz"))

    @fuzz.setter
    def fuzz(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2e5ee5e646ae77fbff8292e8e3efa4bf2405bbdf1f1a793b67ecf06c6221766e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fuzz", value)

    @builtins.property
    @jsii.member(jsii_name="fuzzVar")
    def fuzz_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fuzzVar"))

    @fuzz_var.setter
    def fuzz_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e244c1ac00e9be86e71ba888b61703d6cf60923ddcb405ed3b0da0407f5df28a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fuzzVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6de7237d73afd512ff47354097b4bf8d80faa07196b5a975a0dcbb15b58eab4e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a72791e78cd2b4d38bf57616aa9f6969cecc7641c94e9b69fba43e378bc22bb9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanTrim]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanTrim]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanTrim]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d719d8eb5df7e40aec6003ac842a84244be80f8ad945650117b216cb2b9cd48)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanUnsharpMask",
    jsii_struct_bases=[],
    name_mapping={
        "gain": "gain",
        "gain_var": "gainVar",
        "sigma": "sigma",
        "sigma_var": "sigmaVar",
        "threshold": "threshold",
        "threshold_var": "thresholdVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanUnsharpMask:
    def __init__(
        self,
        *,
        gain: typing.Optional[builtins.str] = None,
        gain_var: typing.Optional[builtins.str] = None,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
        threshold: typing.Optional[builtins.str] = None,
        threshold_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param gain: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        :param gain_var: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        :param sigma: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        :param threshold: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        :param threshold_var: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6ec8ceb17979ad784cb9556bebd0eef0c45113da7eaaaa8d3ffdb06248a32225)
            check_type(argname="argument gain", value=gain, expected_type=type_hints["gain"])
            check_type(argname="argument gain_var", value=gain_var, expected_type=type_hints["gain_var"])
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
            check_type(argname="argument threshold", value=threshold, expected_type=type_hints["threshold"])
            check_type(argname="argument threshold_var", value=threshold_var, expected_type=type_hints["threshold_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if gain is not None:
            self._values["gain"] = gain
        if gain_var is not None:
            self._values["gain_var"] = gain_var
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var
        if threshold is not None:
            self._values["threshold"] = threshold
        if threshold_var is not None:
            self._values["threshold_var"] = threshold_var

    @builtins.property
    def gain(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        '''
        result = self._values.get("gain")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gain_var(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        '''
        result = self._values.get("gain_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        '''
        result = self._values.get("threshold")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold_var(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        result = self._values.get("threshold_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanUnsharpMask(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanUnsharpMaskList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanUnsharpMaskList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8d04274d8fb03efa2eafd75896d28ae64563d67411e765fac1605a450eeb077b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanUnsharpMaskOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bd8e8d910730d760f7481a080f316ded93d5a47b5175491fdfdd5611c258495a)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanUnsharpMaskOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__407631ddaae9004feaab3ed6a9370384df871ee4f18c51350ebc96d8d939feef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df24433913d4e9469e6a669ce1a329f346fd1cc939799bb3f2763ca12be7d928)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__448b100e43d55f8ef54ac959f3b5e23a1888fc796f8b47ed380cd499b75b2423)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanUnsharpMask]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanUnsharpMask]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanUnsharpMask]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d73c4bae227edf96f752bfda0eae00541b01d6226f0acc0d00c9ba6b0d40f5ef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanUnsharpMaskOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanUnsharpMaskOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__936ea00db4b8e6e6fdcecbbc8d4fa27bd11e73f41a9491642d890d8b3ff833c3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetGain")
    def reset_gain(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGain", []))

    @jsii.member(jsii_name="resetGainVar")
    def reset_gain_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGainVar", []))

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @jsii.member(jsii_name="resetThreshold")
    def reset_threshold(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThreshold", []))

    @jsii.member(jsii_name="resetThresholdVar")
    def reset_threshold_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThresholdVar", []))

    @builtins.property
    @jsii.member(jsii_name="gainInput")
    def gain_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainInput"))

    @builtins.property
    @jsii.member(jsii_name="gainVarInput")
    def gain_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdInput")
    def threshold_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdVarInput")
    def threshold_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gain")
    def gain(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gain"))

    @gain.setter
    def gain(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__66ad8f79ce5c5fb8b3ccfce914b4caac6ccc58ef890fdf05365caa1a80407467)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gain", value)

    @builtins.property
    @jsii.member(jsii_name="gainVar")
    def gain_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gainVar"))

    @gain_var.setter
    def gain_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a8877307e78aec3088507456f266230609c13a231dc657a7bd5fb37b2b5ad55d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gainVar", value)

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__06da939ce8de83eaa5caebc49aa0793c92fbd2372d92d0dfec29f318ed6cf4ea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__18f672bf8b7a1663c87089ff566da0b699827b6b38f44ffb1a6d899d5db7bcc5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="threshold")
    def threshold(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "threshold"))

    @threshold.setter
    def threshold(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ef7eff019b51b9f7a24b04859bfcefa8466079ecb280b3ce499bb0aaf520497a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "threshold", value)

    @builtins.property
    @jsii.member(jsii_name="thresholdVar")
    def threshold_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "thresholdVar"))

    @threshold_var.setter
    def threshold_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__caa6c472be5c74c264649554512f8cc8562825e4df4d00e9937b502a4939534c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "thresholdVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanUnsharpMask]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanUnsharpMask]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanUnsharpMask]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ec85905b11c9af691e3d67ceaaf2878b4bf18850a4030a146f5fd17e5a3b088)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__20e00fbf4b3bd5f8bf8c80b1c770442e18cc12cf3f81d73687f62ad9239f9b31)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cf2246557c2cac40cee83f0f1dcc337d118c9c2ba6aaf03b218b40c80055a3e1)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__94724700d1e2ba7a62b5bbda68e3b2c0507c99ea43f001456a9e99aa6d981571)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__169ff1885a07f17766d196254e3070c42690970024fd6e19825d02f02826e905)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__988c1656fa7670b5d8f351ada4754f3ec6e8313909658ebe2587fe513d5bc265)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimension]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimension]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__816abe51425a77e327b6222d52084e8479f1e813243a91dab6357184845df1a8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ace2ecd31dd905c2b4c43d178bda245b5141f52995a6489cb9acc35350727c6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(
        self,
        *,
        append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppend, typing.Dict[builtins.str, typing.Any]]]]] = None,
        aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAspectCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
        crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFaceCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFeatureCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFill, typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
        im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultImQuery", typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultMaxColors", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultMirror", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultMonoHue", typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultOpacity", typing.Dict[builtins.str, typing.Any]]]]] = None,
        region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRelativeCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRemoveColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultResize", typing.Dict[builtins.str, typing.Any]]]]] = None,
        rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRotate", typing.Dict[builtins.str, typing.Any]]]]] = None,
        scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultScale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultShear", typing.Dict[builtins.str, typing.Any]]]]] = None,
        trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultTrim", typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultUnsharpMask", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param append: append block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        :param aspect_crop: aspect_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param crop: crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        :param face_crop: face_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        :param feature_crop: feature_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        :param fit_and_fill: fit_and_fill block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param im_query: im_query block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param region_of_interest_crop: region_of_interest_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        :param relative_crop: relative_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param resize: resize block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        :param rotate: rotate block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        :param scale: scale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param shear: shear block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        :param trim: trim block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefault(
            append=append,
            aspect_crop=aspect_crop,
            background_color=background_color,
            blur=blur,
            chroma_key=chroma_key,
            composite=composite,
            compound=compound,
            contrast=contrast,
            crop=crop,
            face_crop=face_crop,
            feature_crop=feature_crop,
            fit_and_fill=fit_and_fill,
            goop=goop,
            grayscale=grayscale,
            hsl=hsl,
            hsv=hsv,
            if_dimension=if_dimension,
            if_orientation=if_orientation,
            im_query=im_query,
            max_colors=max_colors,
            mirror=mirror,
            mono_hue=mono_hue,
            opacity=opacity,
            region_of_interest_crop=region_of_interest_crop,
            relative_crop=relative_crop,
            remove_color=remove_color,
            resize=resize,
            rotate=rotate,
            scale=scale,
            shear=shear,
            trim=trim,
            unsharp_mask=unsharp_mask,
        )

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putEqual")
    def put_equal(
        self,
        *,
        append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualAppend, typing.Dict[builtins.str, typing.Any]]]]] = None,
        aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualAspectCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
        crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualFaceCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualFeatureCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualFitAndFill, typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
        im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualImQuery, typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
        region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualRegionOfInterestCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualRelativeCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
        resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualResize, typing.Dict[builtins.str, typing.Any]]]]] = None,
        rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualRotate, typing.Dict[builtins.str, typing.Any]]]]] = None,
        scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualScale, typing.Dict[builtins.str, typing.Any]]]]] = None,
        shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualShear, typing.Dict[builtins.str, typing.Any]]]]] = None,
        trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualTrim, typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param append: append block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        :param aspect_crop: aspect_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param crop: crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        :param face_crop: face_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        :param feature_crop: feature_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        :param fit_and_fill: fit_and_fill block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param im_query: im_query block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param region_of_interest_crop: region_of_interest_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        :param relative_crop: relative_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param resize: resize block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        :param rotate: rotate block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        :param scale: scale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param shear: shear block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        :param trim: trim block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqual(
            append=append,
            aspect_crop=aspect_crop,
            background_color=background_color,
            blur=blur,
            chroma_key=chroma_key,
            composite=composite,
            compound=compound,
            contrast=contrast,
            crop=crop,
            face_crop=face_crop,
            feature_crop=feature_crop,
            fit_and_fill=fit_and_fill,
            goop=goop,
            grayscale=grayscale,
            hsl=hsl,
            hsv=hsv,
            if_dimension=if_dimension,
            if_orientation=if_orientation,
            im_query=im_query,
            max_colors=max_colors,
            mirror=mirror,
            mono_hue=mono_hue,
            opacity=opacity,
            region_of_interest_crop=region_of_interest_crop,
            relative_crop=relative_crop,
            remove_color=remove_color,
            resize=resize,
            rotate=rotate,
            scale=scale,
            shear=shear,
            trim=trim,
            unsharp_mask=unsharp_mask,
        )

        return typing.cast(None, jsii.invoke(self, "putEqual", [value]))

    @jsii.member(jsii_name="putGreaterThan")
    def put_greater_than(
        self,
        *,
        append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanAppend, typing.Dict[builtins.str, typing.Any]]]]] = None,
        aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanAspectCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
        crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanFaceCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanFeatureCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanFitAndFill, typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
        im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanImQuery, typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
        region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanRegionOfInterestCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanRelativeCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
        resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanResize, typing.Dict[builtins.str, typing.Any]]]]] = None,
        rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanRotate, typing.Dict[builtins.str, typing.Any]]]]] = None,
        scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanScale, typing.Dict[builtins.str, typing.Any]]]]] = None,
        shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanShear, typing.Dict[builtins.str, typing.Any]]]]] = None,
        trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanTrim, typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param append: append block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        :param aspect_crop: aspect_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param crop: crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        :param face_crop: face_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        :param feature_crop: feature_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        :param fit_and_fill: fit_and_fill block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param im_query: im_query block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param region_of_interest_crop: region_of_interest_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        :param relative_crop: relative_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param resize: resize block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        :param rotate: rotate block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        :param scale: scale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param shear: shear block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        :param trim: trim block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThan(
            append=append,
            aspect_crop=aspect_crop,
            background_color=background_color,
            blur=blur,
            chroma_key=chroma_key,
            composite=composite,
            compound=compound,
            contrast=contrast,
            crop=crop,
            face_crop=face_crop,
            feature_crop=feature_crop,
            fit_and_fill=fit_and_fill,
            goop=goop,
            grayscale=grayscale,
            hsl=hsl,
            hsv=hsv,
            if_dimension=if_dimension,
            if_orientation=if_orientation,
            im_query=im_query,
            max_colors=max_colors,
            mirror=mirror,
            mono_hue=mono_hue,
            opacity=opacity,
            region_of_interest_crop=region_of_interest_crop,
            relative_crop=relative_crop,
            remove_color=remove_color,
            resize=resize,
            rotate=rotate,
            scale=scale,
            shear=shear,
            trim=trim,
            unsharp_mask=unsharp_mask,
        )

        return typing.cast(None, jsii.invoke(self, "putGreaterThan", [value]))

    @jsii.member(jsii_name="putLessThan")
    def put_less_than(
        self,
        *,
        append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanAppend, typing.Dict[builtins.str, typing.Any]]]]] = None,
        aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanAspectCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
        crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanFaceCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanFeatureCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanFitAndFill, typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
        im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanImQuery, typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
        region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanRegionOfInterestCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanRelativeCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
        resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanResize, typing.Dict[builtins.str, typing.Any]]]]] = None,
        rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanRotate, typing.Dict[builtins.str, typing.Any]]]]] = None,
        scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanScale, typing.Dict[builtins.str, typing.Any]]]]] = None,
        shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanShear, typing.Dict[builtins.str, typing.Any]]]]] = None,
        trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanTrim, typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param append: append block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        :param aspect_crop: aspect_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param crop: crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        :param face_crop: face_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        :param feature_crop: feature_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        :param fit_and_fill: fit_and_fill block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param im_query: im_query block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param region_of_interest_crop: region_of_interest_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        :param relative_crop: relative_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param resize: resize block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        :param rotate: rotate block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        :param scale: scale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param shear: shear block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        :param trim: trim block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThan(
            append=append,
            aspect_crop=aspect_crop,
            background_color=background_color,
            blur=blur,
            chroma_key=chroma_key,
            composite=composite,
            compound=compound,
            contrast=contrast,
            crop=crop,
            face_crop=face_crop,
            feature_crop=feature_crop,
            fit_and_fill=fit_and_fill,
            goop=goop,
            grayscale=grayscale,
            hsl=hsl,
            hsv=hsv,
            if_dimension=if_dimension,
            if_orientation=if_orientation,
            im_query=im_query,
            max_colors=max_colors,
            mirror=mirror,
            mono_hue=mono_hue,
            opacity=opacity,
            region_of_interest_crop=region_of_interest_crop,
            relative_crop=relative_crop,
            remove_color=remove_color,
            resize=resize,
            rotate=rotate,
            scale=scale,
            shear=shear,
            trim=trim,
            unsharp_mask=unsharp_mask,
        )

        return typing.cast(None, jsii.invoke(self, "putLessThan", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetDimension")
    def reset_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimension", []))

    @jsii.member(jsii_name="resetDimensionVar")
    def reset_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimensionVar", []))

    @jsii.member(jsii_name="resetEqual")
    def reset_equal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEqual", []))

    @jsii.member(jsii_name="resetGreaterThan")
    def reset_greater_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGreaterThan", []))

    @jsii.member(jsii_name="resetLessThan")
    def reset_less_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLessThan", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultOutputReference", jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="equal")
    def equal(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualOutputReference, jsii.get(self, "equal"))

    @builtins.property
    @jsii.member(jsii_name="greaterThan")
    def greater_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanOutputReference, jsii.get(self, "greaterThan"))

    @builtins.property
    @jsii.member(jsii_name="lessThan")
    def less_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanOutputReference, jsii.get(self, "lessThan"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionInput")
    def dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionVarInput")
    def dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="equalInput")
    def equal_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqual], jsii.get(self, "equalInput"))

    @builtins.property
    @jsii.member(jsii_name="greaterThanInput")
    def greater_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThan], jsii.get(self, "greaterThanInput"))

    @builtins.property
    @jsii.member(jsii_name="lessThanInput")
    def less_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThan], jsii.get(self, "lessThanInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="dimension")
    def dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimension"))

    @dimension.setter
    def dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2b26fef01d1adf9af2a06cca96b6d822602c8c6b15e4330861c1947c2d82d65d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimension", value)

    @builtins.property
    @jsii.member(jsii_name="dimensionVar")
    def dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimensionVar"))

    @dimension_var.setter
    def dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__260ff008bf3e2852a58416c914c2e8d2c36d6eaf8c7b02d753b84fce2a468755)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8d165b303901f68e9f58f839d961d9059b0da0795111f5e15d71a6415d3da4c1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__27c99bc7149e1d7242af12613fe9108ea0af83ce9ba7116b0468880b5bd232d9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimension]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimension]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimension]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ff995e3e0571a8a6411ac0d932af7288f4a7566d43582945727163165cd0611)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultImQuery",
    jsii_struct_bases=[],
    name_mapping={
        "allowed_transformations": "allowedTransformations",
        "query_var": "queryVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultImQuery:
    def __init__(
        self,
        *,
        allowed_transformations: typing.Sequence[builtins.str],
        query_var: builtins.str,
    ) -> None:
        '''
        :param allowed_transformations: Specifies the transformations that can be applied using the query string parameter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allowed_transformations DataAkamaiImagingPolicyImage#allowed_transformations}
        :param query_var: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#query_var DataAkamaiImagingPolicyImage#query_var}.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__afc4034e356cd58b665859f900ea3887334fa4a32ef9b1e862dc3b3a9e33107f)
            check_type(argname="argument allowed_transformations", value=allowed_transformations, expected_type=type_hints["allowed_transformations"])
            check_type(argname="argument query_var", value=query_var, expected_type=type_hints["query_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "allowed_transformations": allowed_transformations,
            "query_var": query_var,
        }

    @builtins.property
    def allowed_transformations(self) -> typing.List[builtins.str]:
        '''Specifies the transformations that can be applied using the query string parameter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allowed_transformations DataAkamaiImagingPolicyImage#allowed_transformations}
        '''
        result = self._values.get("allowed_transformations")
        assert result is not None, "Required property 'allowed_transformations' is missing"
        return typing.cast(typing.List[builtins.str], result)

    @builtins.property
    def query_var(self) -> builtins.str:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#query_var DataAkamaiImagingPolicyImage#query_var}.'''
        result = self._values.get("query_var")
        assert result is not None, "Required property 'query_var' is missing"
        return typing.cast(builtins.str, result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultImQuery(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultImQueryList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultImQueryList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e3b30373dc9c11d2d2cffa40e005727e0c6b16c55590707f63c6b1fd96b45fbe)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultImQueryOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ffa8bb6b44f37d65222e3f0da59f10aaa4811d90e4d559d6f7cc9f5d51a5ad81)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultImQueryOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1e2d49e7733f1d9f1f5629b6ffa7be657f308472f390816d52833ed5d9ebab47)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d003026075aa1c93f8eaad2adf4ab03abc469c6a9889e72e4847f1c2f4e49083)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9b5a215443de1ac588da24ca09ad1224e8b0a4c47360c5cb865beaf5aafcfd2e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultImQuery]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultImQuery]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultImQuery]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6641fd59e5653dfeb20d2a104e7cdff55ed2eff45a757964b12d085bff7d3f62)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultImQueryOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultImQueryOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__25e556b6c135ec5023f6308f42c9cb693817dca4bca54399d5e5d821f4b5fa21)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @builtins.property
    @jsii.member(jsii_name="allowedTransformationsInput")
    def allowed_transformations_input(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "allowedTransformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="queryVarInput")
    def query_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "queryVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowedTransformations")
    def allowed_transformations(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "allowedTransformations"))

    @allowed_transformations.setter
    def allowed_transformations(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b696be15f61f16021580c30fa55cefd216d1ba8ae7b0f0968330992b6090daa8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowedTransformations", value)

    @builtins.property
    @jsii.member(jsii_name="queryVar")
    def query_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "queryVar"))

    @query_var.setter
    def query_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__904f5566fc048c663430b5d4bc84a33af78cde094b1eb79ca7aa3bb676f2fbf9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "queryVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultImQuery]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultImQuery]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultImQuery]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__25cf0202cf85fbc82c50d634ebb017cb3d34560eb3d5b0e07ea89554a1136cc9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultMaxColors",
    jsii_struct_bases=[],
    name_mapping={"colors": "colors", "colors_var": "colorsVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultMaxColors:
    def __init__(
        self,
        *,
        colors: typing.Optional[builtins.str] = None,
        colors_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param colors: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        :param colors_var: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__17ebdb21ce1247cb7af31a556257bc4b8553c39578243a190dd380305513ef6e)
            check_type(argname="argument colors", value=colors, expected_type=type_hints["colors"])
            check_type(argname="argument colors_var", value=colors_var, expected_type=type_hints["colors_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if colors is not None:
            self._values["colors"] = colors
        if colors_var is not None:
            self._values["colors_var"] = colors_var

    @builtins.property
    def colors(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        '''
        result = self._values.get("colors")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def colors_var(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        result = self._values.get("colors_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultMaxColors(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultMaxColorsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultMaxColorsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a8f34a42d952a5de5a160a6996879a566a30b6495c3ad3cd2be94302d2a5d72c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultMaxColorsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cead1e6b36cbb6de9b9faf372d47a8fdf836fad98803f356ee799b61258821b2)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultMaxColorsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__06034ed34aa9e45ea20078c5c5ee7e301da62e115482b6b90c26275d82256c2b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__87404038ebd01230802b5c16b3a0e0ae072a8f31dc12c5cbe8392820ba540eca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__27215f6167458e5a8215749c3910a406018988f0e357dafad812df0068af9ae8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultMaxColors]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultMaxColors]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e84120c40929b0698e3fd0f51c9582681024eaf6e095367b8ff996b160accf90)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultMaxColorsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultMaxColorsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__97e7b909440364e97dbd38409d0fe1e6baf0d8ebf81488a89a243fe2c487b77c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColors")
    def reset_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColors", []))

    @jsii.member(jsii_name="resetColorsVar")
    def reset_colors_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorsVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorsInput")
    def colors_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsInput"))

    @builtins.property
    @jsii.member(jsii_name="colorsVarInput")
    def colors_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsVarInput"))

    @builtins.property
    @jsii.member(jsii_name="colors")
    def colors(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colors"))

    @colors.setter
    def colors(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7450e19182905d85e13156e55ec7209fe63aca4a0622431f3859104b7826b1cc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colors", value)

    @builtins.property
    @jsii.member(jsii_name="colorsVar")
    def colors_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorsVar"))

    @colors_var.setter
    def colors_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__13f0abfd5cd8d59e1f053750f35e25fb6d430686d9e3842534af264676950ebc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorsVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultMaxColors]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultMaxColors]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultMaxColors]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6ab14cb96701e2c1c1b275301207e8bb96d07ecfaca854ba44bb02ba15e2850a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultMirror",
    jsii_struct_bases=[],
    name_mapping={
        "horizontal": "horizontal",
        "horizontal_var": "horizontalVar",
        "vertical": "vertical",
        "vertical_var": "verticalVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultMirror:
    def __init__(
        self,
        *,
        horizontal: typing.Optional[builtins.str] = None,
        horizontal_var: typing.Optional[builtins.str] = None,
        vertical: typing.Optional[builtins.str] = None,
        vertical_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param horizontal: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        :param horizontal_var: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        :param vertical: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        :param vertical_var: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c15630eac0dfa36b744a86cdced6bd40e180125dc687b3ec5c1449bf5abe80de)
            check_type(argname="argument horizontal", value=horizontal, expected_type=type_hints["horizontal"])
            check_type(argname="argument horizontal_var", value=horizontal_var, expected_type=type_hints["horizontal_var"])
            check_type(argname="argument vertical", value=vertical, expected_type=type_hints["vertical"])
            check_type(argname="argument vertical_var", value=vertical_var, expected_type=type_hints["vertical_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if horizontal is not None:
            self._values["horizontal"] = horizontal
        if horizontal_var is not None:
            self._values["horizontal_var"] = horizontal_var
        if vertical is not None:
            self._values["vertical"] = vertical
        if vertical_var is not None:
            self._values["vertical_var"] = vertical_var

    @builtins.property
    def horizontal(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        '''
        result = self._values.get("horizontal")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def horizontal_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        '''
        result = self._values.get("horizontal_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        '''
        result = self._values.get("vertical")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        result = self._values.get("vertical_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultMirror(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultMirrorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultMirrorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__66a535b460103e14dc0b1e96fbc70302c703c8b7556ccf0cff2066eaeafe6e90)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultMirrorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6bbf72c2e0a3bf0bc1ee6666918344bd5eb0291d8ada458798c570bfa036899e)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultMirrorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a624fe964750559e3b1a63f42f6f393f8dd9f125f873deb6122ef0a5049fe70)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0b3e1842b482609251b31307286964efad36c9ff7e84fb5f0b02fd55c20e300b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f830c76b934c9e8cbb321b34ffff6d194d3cf434e2c3db165b1ce2fe6ef34b0c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultMirror]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultMirror]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__da3f39bb5d0ff54a06e03d88d14941087d24be12800bb5f8c7e2adacabdadff0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultMirrorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultMirrorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4f8a77773cecad65d255445ce45343319d2ceccab518eabd0a1b044a7bfa39cc)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHorizontal")
    def reset_horizontal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontal", []))

    @jsii.member(jsii_name="resetHorizontalVar")
    def reset_horizontal_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontalVar", []))

    @jsii.member(jsii_name="resetVertical")
    def reset_vertical(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVertical", []))

    @jsii.member(jsii_name="resetVerticalVar")
    def reset_vertical_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVerticalVar", []))

    @builtins.property
    @jsii.member(jsii_name="horizontalInput")
    def horizontal_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontalVarInput")
    def horizontal_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalInput")
    def vertical_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalVarInput")
    def vertical_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontal")
    def horizontal(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontal"))

    @horizontal.setter
    def horizontal(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e7eadff284b6e9d3555a5a51c599cc59978c0963c7aadfd1cf5bbdd2d18805c9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontal", value)

    @builtins.property
    @jsii.member(jsii_name="horizontalVar")
    def horizontal_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontalVar"))

    @horizontal_var.setter
    def horizontal_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__73c3d75b6a06cda9c2d408857ba0e6fc2dbe370826aa968d82305042216f0356)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontalVar", value)

    @builtins.property
    @jsii.member(jsii_name="vertical")
    def vertical(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "vertical"))

    @vertical.setter
    def vertical(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac09a1d7e901dacae5a15e242a967707aaea1462fa0ddd17e70ddaa48306a8c2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "vertical", value)

    @builtins.property
    @jsii.member(jsii_name="verticalVar")
    def vertical_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "verticalVar"))

    @vertical_var.setter
    def vertical_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d0dc44e56796417ee54392830e7174c54b443a516d19ab18fb4c8901a5657c33)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "verticalVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultMirror]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultMirror]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultMirror]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3adc05c3ea41db72d769fd31fe18578f9f6b3b66f8a1589d32834ba58753ad3d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultMonoHue",
    jsii_struct_bases=[],
    name_mapping={"hue": "hue", "hue_var": "hueVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultMonoHue:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__19fd453fd2627705701bb9a7dca46389daca9bc5711013fe043c4d59bf7ed5b2)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultMonoHue(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultMonoHueList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultMonoHueList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa829a7022dc810a21a8494f6df66e3118fe1d8e614af8b077016db2d9c99682)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultMonoHueOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fe189923c890a4cdc152394521d64c664e3c3b6d020ca2734d45fdd0a7a4e472)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultMonoHueOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7e7d133cef46f01e3ea53a6308ecd012557344d710d6c525c775d3f8248a8a08)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eb9378eb54bfcc0a1873cc8ceb7ee8aef9fc03b3ade9f6158a9031e9b3f09ed9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1ba1f3249976a7207cab2588909c9cf26f8459f78ea95398e4a00c8c14890322)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultMonoHue]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultMonoHue]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8cdedfae87847254f4955abf16c6f6e17da15c0b8cfc76474d040f828a8b9163)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultMonoHueOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultMonoHueOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__04d030ca96c30b6e291663760eb34ae0d71e492ace74987c17903e8615960182)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5960163e206e31cd20e32631839e6b74eea7ef787496fcf887c473a31a9f2ec1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c3eae159c8bd238c5427f2057556a3eb8d02d52d44d78e64f61f9b74fc205448)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultMonoHue]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultMonoHue]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultMonoHue]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__03b9627985890c6e6a89b35073ac20987549973217b447b22cc01731746a875d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultOpacity",
    jsii_struct_bases=[],
    name_mapping={"opacity": "opacity", "opacity_var": "opacityVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultOpacity:
    def __init__(
        self,
        *,
        opacity: typing.Optional[builtins.str] = None,
        opacity_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param opacity: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param opacity_var: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__50c100a4917b28ebeacc4040ee9a40567379eca7a73fb8cd38dca518b57c6039)
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument opacity_var", value=opacity_var, expected_type=type_hints["opacity_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if opacity is not None:
            self._values["opacity"] = opacity
        if opacity_var is not None:
            self._values["opacity_var"] = opacity_var

    @builtins.property
    def opacity(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def opacity_var(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        result = self._values.get("opacity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultOpacity(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultOpacityList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultOpacityList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__63945eee0b4e46fd2de00df7c25ca193e6ecf2a340709a05e21eefaa93651570)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultOpacityOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__453bb147f4db4a31181108d1c12067a14bb6ea4390ed823d8f7048eee2c6f231)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultOpacityOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__604b3bcbca6115bcca8a8bd6c6caabd92601ab8168988cff5c65a0f7d01397ce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__03f44e840d501e3ac255d51fddb54fdaef2b5d0a07f5e8764af5939dde2ce7c1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__21f829764c7ab232227e281538e1bb4f652142c466218a87eb12ee95cd400a5f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultOpacity]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultOpacity]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ff2a87e95113d4824a1c43b12930b1a4337d3fcc3303f3f5857e8ff5780e1fe9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultOpacityOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultOpacityOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__379c0c2b8e4271fa84c2bcd20ed62ae5a698af3e278c24209fa00b5f5597f0e4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetOpacityVar")
    def reset_opacity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacityVar", []))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityVarInput")
    def opacity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacity"))

    @opacity.setter
    def opacity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__91d7816b16c9d09a159c321553ab678aff70b02f8052768cdff2715ff5d137c6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacity", value)

    @builtins.property
    @jsii.member(jsii_name="opacityVar")
    def opacity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacityVar"))

    @opacity_var.setter
    def opacity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e7d15207207039aa0716d59f2a44b19441da4ce729c2ac294d328d3b7e2d7cff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacityVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultOpacity]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultOpacity]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultOpacity]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9f81362451902a3e6689bd0d78557e63cc0a89204e2f14eea9b94483434f1081)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__56eba93aa97ec2afb3b86ce7106cfa7669e0eecb52dc9e1b34eb325cfcbf4d93)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putAppend")
    def put_append(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppend, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5756940b458d96d18b22722a1e9d59f6d0ecc1d6af070f59dc6f70fd02042cf6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putAppend", [value]))

    @jsii.member(jsii_name="putAspectCrop")
    def put_aspect_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAspectCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a9301ff0071c33b3aaed60f806a12e0ec2048df0dc3f1023d43cbbfa95f44391)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putAspectCrop", [value]))

    @jsii.member(jsii_name="putBackgroundColor")
    def put_background_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aee68df212b37c4c03e8c845c4de7f4a9457f221c36240d22350a657ccc1d539)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBackgroundColor", [value]))

    @jsii.member(jsii_name="putBlur")
    def put_blur(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultBlur, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cfd013a1b1eb077d598bfea870c3003884f9837375c36c5e37ed5591b78e6810)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBlur", [value]))

    @jsii.member(jsii_name="putChromaKey")
    def put_chroma_key(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultChromaKey, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7427504a071d4eaa4dbb4a1e00db9ec1a50f7fd8149c999aff98db1f57d9f294)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putChromaKey", [value]))

    @jsii.member(jsii_name="putComposite")
    def put_composite(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultComposite, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c53753df4c6a2ab2dbd5d6f9f9169363043613e109fd2e03ff3bd63754d935df)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putComposite", [value]))

    @jsii.member(jsii_name="putCompound")
    def put_compound(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompound, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__db148fe48f72677cf24285655bf9d9ceaa1f40e811e68fe7388a31b143e7700e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCompound", [value]))

    @jsii.member(jsii_name="putContrast")
    def put_contrast(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultContrast, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a721620f7addbc9ff517e83d532716e0d4757c059dbbf5a7e95e7e8147e65d1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putContrast", [value]))

    @jsii.member(jsii_name="putCrop")
    def put_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2efda1a4d1a0af22fbbd9d496e02051135cb9473608ea883e2dea1dc5d02ba0e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCrop", [value]))

    @jsii.member(jsii_name="putFaceCrop")
    def put_face_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFaceCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__29727760a652eeb89afc2fbda1de9b8074676376f3f69ba41ba6c0e7b2282e0a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFaceCrop", [value]))

    @jsii.member(jsii_name="putFeatureCrop")
    def put_feature_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFeatureCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__89e3ff44c98aff183fc412e2705a9829e687c9bbd92c1662d902c2d240bac2c3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFeatureCrop", [value]))

    @jsii.member(jsii_name="putFitAndFill")
    def put_fit_and_fill(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFill, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e10d852196df03b6f97b0d952b11961ec9b9efc073b1334940578e2da1c6c0c5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFitAndFill", [value]))

    @jsii.member(jsii_name="putGoop")
    def put_goop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultGoop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e63d513091fc8590482801bd0a58af760945fd1d2d06e71f714a8ffa91475ff9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGoop", [value]))

    @jsii.member(jsii_name="putGrayscale")
    def put_grayscale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultGrayscale, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1e750550e15a1f77f25988eb922dd7f7bfbf59a4dc6dc9fb5c1032834b0823b8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGrayscale", [value]))

    @jsii.member(jsii_name="putHsl")
    def put_hsl(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultHsl, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3f42fa73f716a9f717a2b2a040215021f979cdebba2360129135f826db101e88)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsl", [value]))

    @jsii.member(jsii_name="putHsv")
    def put_hsv(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultHsv, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b09111cf44b205328bae8b3185919f0abd4fb9b66f3aee1782713c8ccd7b1319)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsv", [value]))

    @jsii.member(jsii_name="putIfDimension")
    def put_if_dimension(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimension, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9c0b6c552832d534f984a762e109680d989f38b04b33e6370b4d8c1e6ace021d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfDimension", [value]))

    @jsii.member(jsii_name="putIfOrientation")
    def put_if_orientation(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3f197eb21953bc36ea900615bd7deaaaa99f91032538af0b38d6fddb52d53f08)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfOrientation", [value]))

    @jsii.member(jsii_name="putImQuery")
    def put_im_query(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultImQuery, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4c51e8becb96cf4ddb2950f23301ede035245e0a9ccdeba8ec2e681a13b06a40)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putImQuery", [value]))

    @jsii.member(jsii_name="putMaxColors")
    def put_max_colors(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultMaxColors, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__061c7dbf189d299589844c2522268c7a80c84b53ee0b7446ca48db5953c2752d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMaxColors", [value]))

    @jsii.member(jsii_name="putMirror")
    def put_mirror(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultMirror, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d02537ee809c9f469bdda73e5152f32376a7097713b00fffc5e423e3add798d6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMirror", [value]))

    @jsii.member(jsii_name="putMonoHue")
    def put_mono_hue(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultMonoHue, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e093bd6fb996543022837e4eb5c0574484ba9b6e82dec4be5776756d7a274fbb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMonoHue", [value]))

    @jsii.member(jsii_name="putOpacity")
    def put_opacity(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultOpacity, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5224fd32b17b35ab6d0f67a57de12b638f56c7d52307250e0db858dc22275f15)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putOpacity", [value]))

    @jsii.member(jsii_name="putRegionOfInterestCrop")
    def put_region_of_interest_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCrop", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__154e4a9a123021e088ae41f543b0763a52e13ff89ac0c3062fe1f73f4b8f19e7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRegionOfInterestCrop", [value]))

    @jsii.member(jsii_name="putRelativeCrop")
    def put_relative_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRelativeCrop", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dd2b12739f6c9905e9d2fe60bad2f5e32852b0f46f3b1d67649e3e8e7a02f87a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRelativeCrop", [value]))

    @jsii.member(jsii_name="putRemoveColor")
    def put_remove_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRemoveColor", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d96d9c641f2bc1804c3489f06af65c7c9633f7273c9ef5d7dd30b951169e1152)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRemoveColor", [value]))

    @jsii.member(jsii_name="putResize")
    def put_resize(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultResize", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a9afe775f681bb9ca322042c452d2022040afb89d89a19025de1a6b34c59181)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putResize", [value]))

    @jsii.member(jsii_name="putRotate")
    def put_rotate(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRotate", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3d7a931f986b19db6a78f5bf263082643f22833f3890e8976574cc576483b5a4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRotate", [value]))

    @jsii.member(jsii_name="putScale")
    def put_scale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultScale", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__84db3eb6bc43b27aa007aed09f7a3c9cba668a8571f3998aaea2d6d866ec5171)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putScale", [value]))

    @jsii.member(jsii_name="putShear")
    def put_shear(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultShear", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1eab9daf191ccc088c913eeef7111ab3cf02c2a0c1cd333213770e7834547565)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putShear", [value]))

    @jsii.member(jsii_name="putTrim")
    def put_trim(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultTrim", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d4b78a2e60c34443195cb5c42b68906fa86e31283b2cb47713c91cc32fe5c0e6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTrim", [value]))

    @jsii.member(jsii_name="putUnsharpMask")
    def put_unsharp_mask(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultUnsharpMask", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb3c8e6e780e52466d4e05313db12fee177ba7375a4e931cae8a185367a66d55)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putUnsharpMask", [value]))

    @jsii.member(jsii_name="resetAppend")
    def reset_append(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAppend", []))

    @jsii.member(jsii_name="resetAspectCrop")
    def reset_aspect_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspectCrop", []))

    @jsii.member(jsii_name="resetBackgroundColor")
    def reset_background_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBackgroundColor", []))

    @jsii.member(jsii_name="resetBlur")
    def reset_blur(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBlur", []))

    @jsii.member(jsii_name="resetChromaKey")
    def reset_chroma_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChromaKey", []))

    @jsii.member(jsii_name="resetComposite")
    def reset_composite(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetComposite", []))

    @jsii.member(jsii_name="resetCompound")
    def reset_compound(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCompound", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetCrop")
    def reset_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCrop", []))

    @jsii.member(jsii_name="resetFaceCrop")
    def reset_face_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFaceCrop", []))

    @jsii.member(jsii_name="resetFeatureCrop")
    def reset_feature_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureCrop", []))

    @jsii.member(jsii_name="resetFitAndFill")
    def reset_fit_and_fill(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFitAndFill", []))

    @jsii.member(jsii_name="resetGoop")
    def reset_goop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGoop", []))

    @jsii.member(jsii_name="resetGrayscale")
    def reset_grayscale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGrayscale", []))

    @jsii.member(jsii_name="resetHsl")
    def reset_hsl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsl", []))

    @jsii.member(jsii_name="resetHsv")
    def reset_hsv(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsv", []))

    @jsii.member(jsii_name="resetIfDimension")
    def reset_if_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfDimension", []))

    @jsii.member(jsii_name="resetIfOrientation")
    def reset_if_orientation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfOrientation", []))

    @jsii.member(jsii_name="resetImQuery")
    def reset_im_query(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetImQuery", []))

    @jsii.member(jsii_name="resetMaxColors")
    def reset_max_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxColors", []))

    @jsii.member(jsii_name="resetMirror")
    def reset_mirror(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMirror", []))

    @jsii.member(jsii_name="resetMonoHue")
    def reset_mono_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonoHue", []))

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetRegionOfInterestCrop")
    def reset_region_of_interest_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRegionOfInterestCrop", []))

    @jsii.member(jsii_name="resetRelativeCrop")
    def reset_relative_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRelativeCrop", []))

    @jsii.member(jsii_name="resetRemoveColor")
    def reset_remove_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRemoveColor", []))

    @jsii.member(jsii_name="resetResize")
    def reset_resize(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetResize", []))

    @jsii.member(jsii_name="resetRotate")
    def reset_rotate(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRotate", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetShear")
    def reset_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetShear", []))

    @jsii.member(jsii_name="resetTrim")
    def reset_trim(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTrim", []))

    @jsii.member(jsii_name="resetUnsharpMask")
    def reset_unsharp_mask(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUnsharpMask", []))

    @builtins.property
    @jsii.member(jsii_name="append")
    def append(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendList, jsii.get(self, "append"))

    @builtins.property
    @jsii.member(jsii_name="aspectCrop")
    def aspect_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAspectCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAspectCropList, jsii.get(self, "aspectCrop"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColor")
    def background_color(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultBackgroundColorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultBackgroundColorList, jsii.get(self, "backgroundColor"))

    @builtins.property
    @jsii.member(jsii_name="blur")
    def blur(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultBlurList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultBlurList, jsii.get(self, "blur"))

    @builtins.property
    @jsii.member(jsii_name="chromaKey")
    def chroma_key(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultChromaKeyList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultChromaKeyList, jsii.get(self, "chromaKey"))

    @builtins.property
    @jsii.member(jsii_name="composite")
    def composite(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeList, jsii.get(self, "composite"))

    @builtins.property
    @jsii.member(jsii_name="compound")
    def compound(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompoundList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompoundList, jsii.get(self, "compound"))

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultContrastList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultContrastList, jsii.get(self, "contrast"))

    @builtins.property
    @jsii.member(jsii_name="crop")
    def crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCropList, jsii.get(self, "crop"))

    @builtins.property
    @jsii.member(jsii_name="faceCrop")
    def face_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFaceCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFaceCropList, jsii.get(self, "faceCrop"))

    @builtins.property
    @jsii.member(jsii_name="featureCrop")
    def feature_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFeatureCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFeatureCropList, jsii.get(self, "featureCrop"))

    @builtins.property
    @jsii.member(jsii_name="fitAndFill")
    def fit_and_fill(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillList, jsii.get(self, "fitAndFill"))

    @builtins.property
    @jsii.member(jsii_name="goop")
    def goop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultGoopList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultGoopList, jsii.get(self, "goop"))

    @builtins.property
    @jsii.member(jsii_name="grayscale")
    def grayscale(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultGrayscaleList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultGrayscaleList, jsii.get(self, "grayscale"))

    @builtins.property
    @jsii.member(jsii_name="hsl")
    def hsl(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultHslList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultHslList, jsii.get(self, "hsl"))

    @builtins.property
    @jsii.member(jsii_name="hsv")
    def hsv(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultHsvList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultHsvList, jsii.get(self, "hsv"))

    @builtins.property
    @jsii.member(jsii_name="ifDimension")
    def if_dimension(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionList, jsii.get(self, "ifDimension"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientation")
    def if_orientation(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationList", jsii.get(self, "ifOrientation"))

    @builtins.property
    @jsii.member(jsii_name="imQuery")
    def im_query(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultImQueryList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultImQueryList, jsii.get(self, "imQuery"))

    @builtins.property
    @jsii.member(jsii_name="maxColors")
    def max_colors(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultMaxColorsList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultMaxColorsList, jsii.get(self, "maxColors"))

    @builtins.property
    @jsii.member(jsii_name="mirror")
    def mirror(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultMirrorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultMirrorList, jsii.get(self, "mirror"))

    @builtins.property
    @jsii.member(jsii_name="monoHue")
    def mono_hue(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultMonoHueList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultMonoHueList, jsii.get(self, "monoHue"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultOpacityList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultOpacityList, jsii.get(self, "opacity"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestCrop")
    def region_of_interest_crop(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropList", jsii.get(self, "regionOfInterestCrop"))

    @builtins.property
    @jsii.member(jsii_name="relativeCrop")
    def relative_crop(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRelativeCropList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRelativeCropList", jsii.get(self, "relativeCrop"))

    @builtins.property
    @jsii.member(jsii_name="removeColor")
    def remove_color(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRemoveColorList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRemoveColorList", jsii.get(self, "removeColor"))

    @builtins.property
    @jsii.member(jsii_name="resize")
    def resize(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultResizeList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultResizeList", jsii.get(self, "resize"))

    @builtins.property
    @jsii.member(jsii_name="rotate")
    def rotate(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRotateList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRotateList", jsii.get(self, "rotate"))

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultScaleList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultScaleList", jsii.get(self, "scale"))

    @builtins.property
    @jsii.member(jsii_name="shear")
    def shear(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultShearList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultShearList", jsii.get(self, "shear"))

    @builtins.property
    @jsii.member(jsii_name="trim")
    def trim(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultTrimList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultTrimList", jsii.get(self, "trim"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMask")
    def unsharp_mask(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultUnsharpMaskList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultUnsharpMaskList", jsii.get(self, "unsharpMask"))

    @builtins.property
    @jsii.member(jsii_name="appendInput")
    def append_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppend]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppend]]], jsii.get(self, "appendInput"))

    @builtins.property
    @jsii.member(jsii_name="aspectCropInput")
    def aspect_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAspectCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAspectCrop]]], jsii.get(self, "aspectCropInput"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColorInput")
    def background_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultBackgroundColor]]], jsii.get(self, "backgroundColorInput"))

    @builtins.property
    @jsii.member(jsii_name="blurInput")
    def blur_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultBlur]]], jsii.get(self, "blurInput"))

    @builtins.property
    @jsii.member(jsii_name="chromaKeyInput")
    def chroma_key_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultChromaKey]]], jsii.get(self, "chromaKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="compositeInput")
    def composite_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultComposite]]], jsii.get(self, "compositeInput"))

    @builtins.property
    @jsii.member(jsii_name="compoundInput")
    def compound_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompound]]], jsii.get(self, "compoundInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultContrast]]], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="cropInput")
    def crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCrop]]], jsii.get(self, "cropInput"))

    @builtins.property
    @jsii.member(jsii_name="faceCropInput")
    def face_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFaceCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFaceCrop]]], jsii.get(self, "faceCropInput"))

    @builtins.property
    @jsii.member(jsii_name="featureCropInput")
    def feature_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFeatureCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFeatureCrop]]], jsii.get(self, "featureCropInput"))

    @builtins.property
    @jsii.member(jsii_name="fitAndFillInput")
    def fit_and_fill_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFill]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFill]]], jsii.get(self, "fitAndFillInput"))

    @builtins.property
    @jsii.member(jsii_name="goopInput")
    def goop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultGoop]]], jsii.get(self, "goopInput"))

    @builtins.property
    @jsii.member(jsii_name="grayscaleInput")
    def grayscale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultGrayscale]]], jsii.get(self, "grayscaleInput"))

    @builtins.property
    @jsii.member(jsii_name="hslInput")
    def hsl_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultHsl]]], jsii.get(self, "hslInput"))

    @builtins.property
    @jsii.member(jsii_name="hsvInput")
    def hsv_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultHsv]]], jsii.get(self, "hsvInput"))

    @builtins.property
    @jsii.member(jsii_name="ifDimensionInput")
    def if_dimension_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimension]]], jsii.get(self, "ifDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientationInput")
    def if_orientation_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientation]]], jsii.get(self, "ifOrientationInput"))

    @builtins.property
    @jsii.member(jsii_name="imQueryInput")
    def im_query_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultImQuery]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultImQuery]]], jsii.get(self, "imQueryInput"))

    @builtins.property
    @jsii.member(jsii_name="maxColorsInput")
    def max_colors_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultMaxColors]]], jsii.get(self, "maxColorsInput"))

    @builtins.property
    @jsii.member(jsii_name="mirrorInput")
    def mirror_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultMirror]]], jsii.get(self, "mirrorInput"))

    @builtins.property
    @jsii.member(jsii_name="monoHueInput")
    def mono_hue_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultMonoHue]]], jsii.get(self, "monoHueInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultOpacity]]], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestCropInput")
    def region_of_interest_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCrop"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCrop"]]], jsii.get(self, "regionOfInterestCropInput"))

    @builtins.property
    @jsii.member(jsii_name="relativeCropInput")
    def relative_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRelativeCrop"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRelativeCrop"]]], jsii.get(self, "relativeCropInput"))

    @builtins.property
    @jsii.member(jsii_name="removeColorInput")
    def remove_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRemoveColor"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRemoveColor"]]], jsii.get(self, "removeColorInput"))

    @builtins.property
    @jsii.member(jsii_name="resizeInput")
    def resize_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultResize"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultResize"]]], jsii.get(self, "resizeInput"))

    @builtins.property
    @jsii.member(jsii_name="rotateInput")
    def rotate_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRotate"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRotate"]]], jsii.get(self, "rotateInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultScale"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultScale"]]], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="shearInput")
    def shear_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultShear"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultShear"]]], jsii.get(self, "shearInput"))

    @builtins.property
    @jsii.member(jsii_name="trimInput")
    def trim_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultTrim"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultTrim"]]], jsii.get(self, "trimInput"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMaskInput")
    def unsharp_mask_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultUnsharpMask"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultUnsharpMask"]]], jsii.get(self, "unsharpMaskInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6774f5d6d6100cd638acd2c3b1b18a768dd15a71cbf58d862fcd36fd7a11605e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCrop",
    jsii_struct_bases=[],
    name_mapping={
        "region_of_interest": "regionOfInterest",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCrop:
    def __init__(
        self,
        *,
        region_of_interest: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterest", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param region_of_interest: region_of_interest block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest DataAkamaiImagingPolicyImage#region_of_interest}
        :param gravity: The placement of the crop area relative to the specified area of interest. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: The placement of the crop area relative to the specified area of interest. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param style: Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(region_of_interest, dict):
            region_of_interest = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterest(**region_of_interest)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9f760e3d8b54cc5bf4be81f413334af154946e921d39e0725d15d300be8099bb)
            check_type(argname="argument region_of_interest", value=region_of_interest, expected_type=type_hints["region_of_interest"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "region_of_interest": region_of_interest,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def region_of_interest(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterest":
        '''region_of_interest block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest DataAkamaiImagingPolicyImage#region_of_interest}
        '''
        result = self._values.get("region_of_interest")
        assert result is not None, "Required property 'region_of_interest' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterest", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''The placement of the crop area relative to the specified area of interest.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''The placement of the crop area relative to the specified area of interest.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f505c959c419643dd2fa196aa991a826c313e99a4dfa56e0d249f92a6a53bcf0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__51665e6407ef39f544efbea813a06c821cf2b20e7a69b113a3f221b4d4bf2acc)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3d8ca41f4a57c0d4e6cf4634c6445854433ea8fda40564344274ee24f22046c9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aef2e28c3aadcfbdb6174426cab9e12ddff49c976d524f1ce8e6ad73013204d0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__215546ec5455ffe8ae4e86feed6fb73eca775ce9a043bee6a793346c37cbb514)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1e1ab5de5f98695c1c49f2b242e6e0dd455c01a49877ed492cce7935ef19ff1d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__785592a26d1f13f4e099502391d592173254bad91b03e9eba6cfdc07f8c82b16)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putRegionOfInterest")
    def put_region_of_interest(
        self,
        *,
        circle_shape: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestCircleShape", typing.Dict[builtins.str, typing.Any]]]]] = None,
        point_shape: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestPointShape", typing.Dict[builtins.str, typing.Any]]]]] = None,
        polygon_shape: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestPolygonShape", typing.Dict[builtins.str, typing.Any]]]]] = None,
        rectangle_shape: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestRectangleShape", typing.Dict[builtins.str, typing.Any]]]]] = None,
        union_shape: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestUnionShape", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param circle_shape: circle_shape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#circle_shape DataAkamaiImagingPolicyImage#circle_shape}
        :param point_shape: point_shape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#point_shape DataAkamaiImagingPolicyImage#point_shape}
        :param polygon_shape: polygon_shape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#polygon_shape DataAkamaiImagingPolicyImage#polygon_shape}
        :param rectangle_shape: rectangle_shape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rectangle_shape DataAkamaiImagingPolicyImage#rectangle_shape}
        :param union_shape: union_shape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#union_shape DataAkamaiImagingPolicyImage#union_shape}
        '''
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterest(
            circle_shape=circle_shape,
            point_shape=point_shape,
            polygon_shape=polygon_shape,
            rectangle_shape=rectangle_shape,
            union_shape=union_shape,
        )

        return typing.cast(None, jsii.invoke(self, "putRegionOfInterest", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterest")
    def region_of_interest(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestOutputReference", jsii.get(self, "regionOfInterest"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestInput")
    def region_of_interest_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterest"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterest"], jsii.get(self, "regionOfInterestInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a9d7010f8878b15fd158aa17cd34ba51e32cfb8049657dbdfe3a17e90eda8442)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ae7a816b4b3c3db63e985d633ad1f4385cede0e9feee19cd53bf9c9993256ec1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__330903e2c82d5eebbaa76f218807543b70a387b8e322f76bf7ccae663ee10e98)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1894f78e7b84d8a5d117a749445304cbcce7ed2bed9cba632d195600a144d518)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__49ea12a3e61371f4dcd86277b8a41cbd6ebe654748db2dea8b5858590f27b82b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7bbab95abbb295786aad1797a4d34714cba5594453b5e5bc4d756acfa0a96414)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ec3276ff329ac1004b90b57d77f750b8bb6bdee855cfed2b7e81412249e6b234)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a01d792c74669fbf4d010ed53c1f41ec5eb77d5675c3a1f7e8fd8895858da5a0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8ede58a53c06a799112b5a686c1cdae6025d1e124060808a6f7b125d3e45d928)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterest",
    jsii_struct_bases=[],
    name_mapping={
        "circle_shape": "circleShape",
        "point_shape": "pointShape",
        "polygon_shape": "polygonShape",
        "rectangle_shape": "rectangleShape",
        "union_shape": "unionShape",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterest:
    def __init__(
        self,
        *,
        circle_shape: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestCircleShape", typing.Dict[builtins.str, typing.Any]]]]] = None,
        point_shape: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestPointShape", typing.Dict[builtins.str, typing.Any]]]]] = None,
        polygon_shape: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestPolygonShape", typing.Dict[builtins.str, typing.Any]]]]] = None,
        rectangle_shape: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestRectangleShape", typing.Dict[builtins.str, typing.Any]]]]] = None,
        union_shape: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestUnionShape", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param circle_shape: circle_shape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#circle_shape DataAkamaiImagingPolicyImage#circle_shape}
        :param point_shape: point_shape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#point_shape DataAkamaiImagingPolicyImage#point_shape}
        :param polygon_shape: polygon_shape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#polygon_shape DataAkamaiImagingPolicyImage#polygon_shape}
        :param rectangle_shape: rectangle_shape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rectangle_shape DataAkamaiImagingPolicyImage#rectangle_shape}
        :param union_shape: union_shape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#union_shape DataAkamaiImagingPolicyImage#union_shape}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e4dddc77dd2fc86628c177653f864e830ec2441467232e5bcc5b7bf50009a099)
            check_type(argname="argument circle_shape", value=circle_shape, expected_type=type_hints["circle_shape"])
            check_type(argname="argument point_shape", value=point_shape, expected_type=type_hints["point_shape"])
            check_type(argname="argument polygon_shape", value=polygon_shape, expected_type=type_hints["polygon_shape"])
            check_type(argname="argument rectangle_shape", value=rectangle_shape, expected_type=type_hints["rectangle_shape"])
            check_type(argname="argument union_shape", value=union_shape, expected_type=type_hints["union_shape"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if circle_shape is not None:
            self._values["circle_shape"] = circle_shape
        if point_shape is not None:
            self._values["point_shape"] = point_shape
        if polygon_shape is not None:
            self._values["polygon_shape"] = polygon_shape
        if rectangle_shape is not None:
            self._values["rectangle_shape"] = rectangle_shape
        if union_shape is not None:
            self._values["union_shape"] = union_shape

    @builtins.property
    def circle_shape(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestCircleShape"]]]:
        '''circle_shape block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#circle_shape DataAkamaiImagingPolicyImage#circle_shape}
        '''
        result = self._values.get("circle_shape")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestCircleShape"]]], result)

    @builtins.property
    def point_shape(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestPointShape"]]]:
        '''point_shape block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#point_shape DataAkamaiImagingPolicyImage#point_shape}
        '''
        result = self._values.get("point_shape")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestPointShape"]]], result)

    @builtins.property
    def polygon_shape(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestPolygonShape"]]]:
        '''polygon_shape block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#polygon_shape DataAkamaiImagingPolicyImage#polygon_shape}
        '''
        result = self._values.get("polygon_shape")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestPolygonShape"]]], result)

    @builtins.property
    def rectangle_shape(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestRectangleShape"]]]:
        '''rectangle_shape block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rectangle_shape DataAkamaiImagingPolicyImage#rectangle_shape}
        '''
        result = self._values.get("rectangle_shape")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestRectangleShape"]]], result)

    @builtins.property
    def union_shape(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestUnionShape"]]]:
        '''union_shape block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#union_shape DataAkamaiImagingPolicyImage#union_shape}
        '''
        result = self._values.get("union_shape")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestUnionShape"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterest(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestCircleShape",
    jsii_struct_bases=[],
    name_mapping={"center": "center", "radius": "radius", "radius_var": "radiusVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestCircleShape:
    def __init__(
        self,
        *,
        center: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestCircleShapeCenter", typing.Dict[builtins.str, typing.Any]],
        radius: typing.Optional[builtins.str] = None,
        radius_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param center: center block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#center DataAkamaiImagingPolicyImage#center}
        :param radius: The radius of the circle measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#radius DataAkamaiImagingPolicyImage#radius}
        :param radius_var: The radius of the circle measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#radius_var DataAkamaiImagingPolicyImage#radius_var}
        '''
        if isinstance(center, dict):
            center = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestCircleShapeCenter(**center)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6fddadc9e0aa00a7aafc8cbd138506ba99da1ae5deac9c6e4614ed91986b6803)
            check_type(argname="argument center", value=center, expected_type=type_hints["center"])
            check_type(argname="argument radius", value=radius, expected_type=type_hints["radius"])
            check_type(argname="argument radius_var", value=radius_var, expected_type=type_hints["radius_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "center": center,
        }
        if radius is not None:
            self._values["radius"] = radius
        if radius_var is not None:
            self._values["radius_var"] = radius_var

    @builtins.property
    def center(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestCircleShapeCenter":
        '''center block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#center DataAkamaiImagingPolicyImage#center}
        '''
        result = self._values.get("center")
        assert result is not None, "Required property 'center' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestCircleShapeCenter", result)

    @builtins.property
    def radius(self) -> typing.Optional[builtins.str]:
        '''The radius of the circle measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#radius DataAkamaiImagingPolicyImage#radius}
        '''
        result = self._values.get("radius")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def radius_var(self) -> typing.Optional[builtins.str]:
        '''The radius of the circle measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#radius_var DataAkamaiImagingPolicyImage#radius_var}
        '''
        result = self._values.get("radius_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestCircleShape(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestCircleShapeCenter",
    jsii_struct_bases=[],
    name_mapping={"x": "x", "x_var": "xVar", "y": "y", "y_var": "yVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestCircleShapeCenter:
    def __init__(
        self,
        *,
        x: typing.Optional[builtins.str] = None,
        x_var: typing.Optional[builtins.str] = None,
        y: typing.Optional[builtins.str] = None,
        y_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param x: The horizontal position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x DataAkamaiImagingPolicyImage#x}
        :param x_var: The horizontal position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_var DataAkamaiImagingPolicyImage#x_var}
        :param y: The vertical position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y DataAkamaiImagingPolicyImage#y}
        :param y_var: The vertical position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_var DataAkamaiImagingPolicyImage#y_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fbf8d9b14acf3912d42e2aea14a420e2c961711b844c67961ab6580b7a075562)
            check_type(argname="argument x", value=x, expected_type=type_hints["x"])
            check_type(argname="argument x_var", value=x_var, expected_type=type_hints["x_var"])
            check_type(argname="argument y", value=y, expected_type=type_hints["y"])
            check_type(argname="argument y_var", value=y_var, expected_type=type_hints["y_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if x is not None:
            self._values["x"] = x
        if x_var is not None:
            self._values["x_var"] = x_var
        if y is not None:
            self._values["y"] = y
        if y_var is not None:
            self._values["y_var"] = y_var

    @builtins.property
    def x(self) -> typing.Optional[builtins.str]:
        '''The horizontal position of the point, measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x DataAkamaiImagingPolicyImage#x}
        '''
        result = self._values.get("x")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_var(self) -> typing.Optional[builtins.str]:
        '''The horizontal position of the point, measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_var DataAkamaiImagingPolicyImage#x_var}
        '''
        result = self._values.get("x_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y(self) -> typing.Optional[builtins.str]:
        '''The vertical position of the point, measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y DataAkamaiImagingPolicyImage#y}
        '''
        result = self._values.get("y")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_var(self) -> typing.Optional[builtins.str]:
        '''The vertical position of the point, measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_var DataAkamaiImagingPolicyImage#y_var}
        '''
        result = self._values.get("y_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestCircleShapeCenter(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestCircleShapeCenterOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestCircleShapeCenterOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__82c5ff70b6204fc64b0170c1c8937fe263b0bebb1f22a3b38cdda8a654db2eba)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetX")
    def reset_x(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetX", []))

    @jsii.member(jsii_name="resetXVar")
    def reset_x_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXVar", []))

    @jsii.member(jsii_name="resetY")
    def reset_y(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetY", []))

    @jsii.member(jsii_name="resetYVar")
    def reset_y_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYVar", []))

    @builtins.property
    @jsii.member(jsii_name="xInput")
    def x_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xInput"))

    @builtins.property
    @jsii.member(jsii_name="xVarInput")
    def x_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yInput")
    def y_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yInput"))

    @builtins.property
    @jsii.member(jsii_name="yVarInput")
    def y_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yVarInput"))

    @builtins.property
    @jsii.member(jsii_name="x")
    def x(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "x"))

    @x.setter
    def x(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9e591400688c489369eb60a92a541ff0b57c29e84d55eef5cc73c334f52b51f1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "x", value)

    @builtins.property
    @jsii.member(jsii_name="xVar")
    def x_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xVar"))

    @x_var.setter
    def x_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1e986e05d1a9e19336932cbcd7f7f18020cf4d44389f523ae3a3c69eb55324da)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xVar", value)

    @builtins.property
    @jsii.member(jsii_name="y")
    def y(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "y"))

    @y.setter
    def y(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6b316ef4dfdc8e3877ef560443ba503f3bc1f5789898201d9669b6e6e51b425f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "y", value)

    @builtins.property
    @jsii.member(jsii_name="yVar")
    def y_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yVar"))

    @y_var.setter
    def y_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__116c2d4d8bb6c3758056ed52d3a10fe8475a0edb6d1239a6b40a9425abfe61ac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestCircleShapeCenter]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestCircleShapeCenter], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestCircleShapeCenter],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__146fbd382881beb9004676a20a26d1314e2bfe09a733cfc3071aff03dd7d9269)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestCircleShapeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestCircleShapeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d577ad0f8705c01b57a41b11472fab5d446ddee32778c5465a8c059ee6c80448)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestCircleShapeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4e814ea2e5453905287c77191d32ba7434212bf403d6a0f67ff93ed63526a4e9)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestCircleShapeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__375a337394d16a25c2ee12c61e72ed35dc71a4a9607439b633bda47fc005d8fc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb31350038fe076ce9db4f722995ee28157b3d4664e11aca68f65bc496ab0d34)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ceeea2a1b3bc7137a1f10512342cdee947cf4d50e701557f4cc16a337725540)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestCircleShape]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestCircleShape]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestCircleShape]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__79b75af677b633fa7cafc3681a84f1ec534e503aeb1087e9d376851a2316a9c2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestCircleShapeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestCircleShapeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3087bfe84b4058b8897c4454dbb16acfc535ab272fe55d4266773ae55122f5be)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putCenter")
    def put_center(
        self,
        *,
        x: typing.Optional[builtins.str] = None,
        x_var: typing.Optional[builtins.str] = None,
        y: typing.Optional[builtins.str] = None,
        y_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param x: The horizontal position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x DataAkamaiImagingPolicyImage#x}
        :param x_var: The horizontal position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_var DataAkamaiImagingPolicyImage#x_var}
        :param y: The vertical position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y DataAkamaiImagingPolicyImage#y}
        :param y_var: The vertical position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_var DataAkamaiImagingPolicyImage#y_var}
        '''
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestCircleShapeCenter(
            x=x, x_var=x_var, y=y, y_var=y_var
        )

        return typing.cast(None, jsii.invoke(self, "putCenter", [value]))

    @jsii.member(jsii_name="resetRadius")
    def reset_radius(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRadius", []))

    @jsii.member(jsii_name="resetRadiusVar")
    def reset_radius_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRadiusVar", []))

    @builtins.property
    @jsii.member(jsii_name="center")
    def center(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestCircleShapeCenterOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestCircleShapeCenterOutputReference, jsii.get(self, "center"))

    @builtins.property
    @jsii.member(jsii_name="centerInput")
    def center_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestCircleShapeCenter]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestCircleShapeCenter], jsii.get(self, "centerInput"))

    @builtins.property
    @jsii.member(jsii_name="radiusInput")
    def radius_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "radiusInput"))

    @builtins.property
    @jsii.member(jsii_name="radiusVarInput")
    def radius_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "radiusVarInput"))

    @builtins.property
    @jsii.member(jsii_name="radius")
    def radius(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "radius"))

    @radius.setter
    def radius(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__64860d3d199c922886ddcbc39452ae8fa72191f73f18a220ef3c3f241019d460)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "radius", value)

    @builtins.property
    @jsii.member(jsii_name="radiusVar")
    def radius_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "radiusVar"))

    @radius_var.setter
    def radius_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__679a276aa77f58de7f1003c71700310a0453891ac745705d9669251d1c31c1d8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "radiusVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestCircleShape]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestCircleShape]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestCircleShape]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b99d02a31a7b9391dcabaabba2d94d340f75e452e094c56b97dd3b8eca790303)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__345085f74a19a19e540d23f566e9135bbc83da3dc7d87b6b646e668e7777c20a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putCircleShape")
    def put_circle_shape(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestCircleShape, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa4f17a43098d4cccfd181deca0885a6e01e57089bda08281a3497b6dab1dd87)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCircleShape", [value]))

    @jsii.member(jsii_name="putPointShape")
    def put_point_shape(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestPointShape", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__484733ae8a15b0b57111e806a3c29a87672f015ea3a00a57b1f9e9c0bbcb21c9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putPointShape", [value]))

    @jsii.member(jsii_name="putPolygonShape")
    def put_polygon_shape(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestPolygonShape", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__60a5e5417aa5dd5f95cb2dd133d89857f6b3239b4ef28141f66d7daf7e05777f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putPolygonShape", [value]))

    @jsii.member(jsii_name="putRectangleShape")
    def put_rectangle_shape(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestRectangleShape", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__697f52cbbc38a2f90cdca301b3aea97b1a4735e7113bb9af4cde041cef15a5c1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRectangleShape", [value]))

    @jsii.member(jsii_name="putUnionShape")
    def put_union_shape(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestUnionShape", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__52b4774c184ace0c68f41a5fcefd3fee82d9b779ffe5ae379298afaafe2e6a96)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putUnionShape", [value]))

    @jsii.member(jsii_name="resetCircleShape")
    def reset_circle_shape(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCircleShape", []))

    @jsii.member(jsii_name="resetPointShape")
    def reset_point_shape(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPointShape", []))

    @jsii.member(jsii_name="resetPolygonShape")
    def reset_polygon_shape(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPolygonShape", []))

    @jsii.member(jsii_name="resetRectangleShape")
    def reset_rectangle_shape(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRectangleShape", []))

    @jsii.member(jsii_name="resetUnionShape")
    def reset_union_shape(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUnionShape", []))

    @builtins.property
    @jsii.member(jsii_name="circleShape")
    def circle_shape(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestCircleShapeList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestCircleShapeList, jsii.get(self, "circleShape"))

    @builtins.property
    @jsii.member(jsii_name="pointShape")
    def point_shape(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestPointShapeList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestPointShapeList", jsii.get(self, "pointShape"))

    @builtins.property
    @jsii.member(jsii_name="polygonShape")
    def polygon_shape(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestPolygonShapeList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestPolygonShapeList", jsii.get(self, "polygonShape"))

    @builtins.property
    @jsii.member(jsii_name="rectangleShape")
    def rectangle_shape(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestRectangleShapeList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestRectangleShapeList", jsii.get(self, "rectangleShape"))

    @builtins.property
    @jsii.member(jsii_name="unionShape")
    def union_shape(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestUnionShapeList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestUnionShapeList", jsii.get(self, "unionShape"))

    @builtins.property
    @jsii.member(jsii_name="circleShapeInput")
    def circle_shape_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestCircleShape]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestCircleShape]]], jsii.get(self, "circleShapeInput"))

    @builtins.property
    @jsii.member(jsii_name="pointShapeInput")
    def point_shape_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestPointShape"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestPointShape"]]], jsii.get(self, "pointShapeInput"))

    @builtins.property
    @jsii.member(jsii_name="polygonShapeInput")
    def polygon_shape_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestPolygonShape"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestPolygonShape"]]], jsii.get(self, "polygonShapeInput"))

    @builtins.property
    @jsii.member(jsii_name="rectangleShapeInput")
    def rectangle_shape_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestRectangleShape"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestRectangleShape"]]], jsii.get(self, "rectangleShapeInput"))

    @builtins.property
    @jsii.member(jsii_name="unionShapeInput")
    def union_shape_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestUnionShape"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestUnionShape"]]], jsii.get(self, "unionShapeInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterest]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterest], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterest],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ea4ca7557507beb0a7218670f978f3ca44dea6a542d6f13feb130ffa1b53bb9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestPointShape",
    jsii_struct_bases=[],
    name_mapping={"x": "x", "x_var": "xVar", "y": "y", "y_var": "yVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestPointShape:
    def __init__(
        self,
        *,
        x: typing.Optional[builtins.str] = None,
        x_var: typing.Optional[builtins.str] = None,
        y: typing.Optional[builtins.str] = None,
        y_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param x: The horizontal position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x DataAkamaiImagingPolicyImage#x}
        :param x_var: The horizontal position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_var DataAkamaiImagingPolicyImage#x_var}
        :param y: The vertical position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y DataAkamaiImagingPolicyImage#y}
        :param y_var: The vertical position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_var DataAkamaiImagingPolicyImage#y_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ae26a46285247a399534f7aa97868b6ae7bcacb0abb3138577636791c8f22ca)
            check_type(argname="argument x", value=x, expected_type=type_hints["x"])
            check_type(argname="argument x_var", value=x_var, expected_type=type_hints["x_var"])
            check_type(argname="argument y", value=y, expected_type=type_hints["y"])
            check_type(argname="argument y_var", value=y_var, expected_type=type_hints["y_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if x is not None:
            self._values["x"] = x
        if x_var is not None:
            self._values["x_var"] = x_var
        if y is not None:
            self._values["y"] = y
        if y_var is not None:
            self._values["y_var"] = y_var

    @builtins.property
    def x(self) -> typing.Optional[builtins.str]:
        '''The horizontal position of the point, measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x DataAkamaiImagingPolicyImage#x}
        '''
        result = self._values.get("x")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_var(self) -> typing.Optional[builtins.str]:
        '''The horizontal position of the point, measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_var DataAkamaiImagingPolicyImage#x_var}
        '''
        result = self._values.get("x_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y(self) -> typing.Optional[builtins.str]:
        '''The vertical position of the point, measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y DataAkamaiImagingPolicyImage#y}
        '''
        result = self._values.get("y")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_var(self) -> typing.Optional[builtins.str]:
        '''The vertical position of the point, measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_var DataAkamaiImagingPolicyImage#y_var}
        '''
        result = self._values.get("y_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestPointShape(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestPointShapeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestPointShapeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__41bb7bc5700b6addad0ee54647d2dfef33fe8e2ca91239b865fabb6ea977142d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestPointShapeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2e6bb22177c9a35cbce92863eeca00474344cb7bd75a165e857b58e30f88ed71)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestPointShapeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a063274104d2e0ed873358db10c8769a6ea58ddad7f3b724f9f836af6b3e8629)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fc08d14eb22434b8556ac87fdc0cd7f675ea657d629e784afcba8eab858ce56f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b5b380a9af71c254d99609cf469e290c77c58f72f5d52803806513f721e16392)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestPointShape]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestPointShape]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestPointShape]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1efdab680dcef8e37357c4856e06bb0223ba2d74249a4baf019641c9478efa0a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestPointShapeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestPointShapeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a8d2341532c7238895d4eec72a1585c7a7dcb5590c2363613226a406129288c5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetX")
    def reset_x(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetX", []))

    @jsii.member(jsii_name="resetXVar")
    def reset_x_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXVar", []))

    @jsii.member(jsii_name="resetY")
    def reset_y(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetY", []))

    @jsii.member(jsii_name="resetYVar")
    def reset_y_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYVar", []))

    @builtins.property
    @jsii.member(jsii_name="xInput")
    def x_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xInput"))

    @builtins.property
    @jsii.member(jsii_name="xVarInput")
    def x_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yInput")
    def y_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yInput"))

    @builtins.property
    @jsii.member(jsii_name="yVarInput")
    def y_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yVarInput"))

    @builtins.property
    @jsii.member(jsii_name="x")
    def x(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "x"))

    @x.setter
    def x(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__879b8d0032cb771a3277dc9270e645f6cc749a562599e5238ca2835efb8833de)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "x", value)

    @builtins.property
    @jsii.member(jsii_name="xVar")
    def x_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xVar"))

    @x_var.setter
    def x_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1b4283b13e7aa4a16a57792d6e1177149df4cec89b5d0350daf5e45b6ce90987)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xVar", value)

    @builtins.property
    @jsii.member(jsii_name="y")
    def y(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "y"))

    @y.setter
    def y(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aa36a8b668f99565fb6a755bfb752dc301e767a85e54cecd82abcf71ce16a16a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "y", value)

    @builtins.property
    @jsii.member(jsii_name="yVar")
    def y_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yVar"))

    @y_var.setter
    def y_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e690fe75b12fe6f9115e35319ff5b3451ca343170a46b89dd48e9d86267b4726)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestPointShape]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestPointShape]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestPointShape]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7260a075ebfa827df52e8ad9c3adc9f8da84f9e6a26874a19d950bd8881d0ccc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestPolygonShape",
    jsii_struct_bases=[],
    name_mapping={"points": "points"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestPolygonShape:
    def __init__(
        self,
        *,
        points: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestPolygonShapePoints", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param points: points block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#points DataAkamaiImagingPolicyImage#points}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__93634d59d2ee344184b569aaa720354dfeadd243cb1648004a75c39286292f93)
            check_type(argname="argument points", value=points, expected_type=type_hints["points"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "points": points,
        }

    @builtins.property
    def points(
        self,
    ) -> typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestPolygonShapePoints"]]:
        '''points block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#points DataAkamaiImagingPolicyImage#points}
        '''
        result = self._values.get("points")
        assert result is not None, "Required property 'points' is missing"
        return typing.cast(typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestPolygonShapePoints"]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestPolygonShape(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestPolygonShapeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestPolygonShapeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__beaa6aed757d24768507a6f6aa2c653c65847eb705ec2e4344bf399865a04035)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestPolygonShapeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5d947e9f398d0335ae00e713f2e0d0bcc5d2a602e0ed1b1bd35bb3891330dbfb)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestPolygonShapeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8ca8ac877e30801fedbbe422a4786d61f6438c74ecd71bc3896d3fb0bc1e4529)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__93965184a9e410f329492d0adb23b4fd71cd331caaa4521e7bc961b44b8213fb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__280b712969c2d823e7e551397329c865e6231b64345b126df1b516e21538aed7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestPolygonShape]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestPolygonShape]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestPolygonShape]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__721015222f0e7acc19543d73994f9d9bf49e5793a9da7b31dc739efceb2279ab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestPolygonShapeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestPolygonShapeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c7745a6a2f6f087fd2d37ae41c1e42c28e42455061e0494a748561469bb3e0a1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putPoints")
    def put_points(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestPolygonShapePoints", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__990f2d4a76e98fda5b6fea7f0dbde85f99d2da8fc652191e08f032a22d284525)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putPoints", [value]))

    @builtins.property
    @jsii.member(jsii_name="points")
    def points(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestPolygonShapePointsList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestPolygonShapePointsList", jsii.get(self, "points"))

    @builtins.property
    @jsii.member(jsii_name="pointsInput")
    def points_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestPolygonShapePoints"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestPolygonShapePoints"]]], jsii.get(self, "pointsInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestPolygonShape]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestPolygonShape]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestPolygonShape]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a54262d7d4c6e123f99f6c48c9d6fe28fbd9bdf98dab01b84d4c95d114d19f29)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestPolygonShapePoints",
    jsii_struct_bases=[],
    name_mapping={"x": "x", "x_var": "xVar", "y": "y", "y_var": "yVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestPolygonShapePoints:
    def __init__(
        self,
        *,
        x: typing.Optional[builtins.str] = None,
        x_var: typing.Optional[builtins.str] = None,
        y: typing.Optional[builtins.str] = None,
        y_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param x: The horizontal position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x DataAkamaiImagingPolicyImage#x}
        :param x_var: The horizontal position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_var DataAkamaiImagingPolicyImage#x_var}
        :param y: The vertical position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y DataAkamaiImagingPolicyImage#y}
        :param y_var: The vertical position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_var DataAkamaiImagingPolicyImage#y_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e4327a069337ade9b3d6049aaa0ef200b5592ee04058687f25a4b470648074c)
            check_type(argname="argument x", value=x, expected_type=type_hints["x"])
            check_type(argname="argument x_var", value=x_var, expected_type=type_hints["x_var"])
            check_type(argname="argument y", value=y, expected_type=type_hints["y"])
            check_type(argname="argument y_var", value=y_var, expected_type=type_hints["y_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if x is not None:
            self._values["x"] = x
        if x_var is not None:
            self._values["x_var"] = x_var
        if y is not None:
            self._values["y"] = y
        if y_var is not None:
            self._values["y_var"] = y_var

    @builtins.property
    def x(self) -> typing.Optional[builtins.str]:
        '''The horizontal position of the point, measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x DataAkamaiImagingPolicyImage#x}
        '''
        result = self._values.get("x")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_var(self) -> typing.Optional[builtins.str]:
        '''The horizontal position of the point, measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_var DataAkamaiImagingPolicyImage#x_var}
        '''
        result = self._values.get("x_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y(self) -> typing.Optional[builtins.str]:
        '''The vertical position of the point, measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y DataAkamaiImagingPolicyImage#y}
        '''
        result = self._values.get("y")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_var(self) -> typing.Optional[builtins.str]:
        '''The vertical position of the point, measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_var DataAkamaiImagingPolicyImage#y_var}
        '''
        result = self._values.get("y_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestPolygonShapePoints(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestPolygonShapePointsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestPolygonShapePointsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bfeae411540eb19c4ecb5fc1398287ba6caeb4dc83f0653d30b7c4a2fa566b8f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestPolygonShapePointsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b1246b818bbef01e7f449ebc97880aeaf783c96364aae7d93509b32fd620f309)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestPolygonShapePointsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__49ee322eaa38fcd4357ee3bfffe573e8e6875ff020d369185f4321c4f0229e81)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4380d7187bd8ecd07371b165d83652db854777495746df0f6c553753a2aec749)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d801c52f5835e73a5feedbe8831629faeed9e0ed042034553c06dd9811d5a732)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestPolygonShapePoints]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestPolygonShapePoints]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestPolygonShapePoints]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ee09cca48455bbe95688c61b2ce684c0266bdd11ae42d4eef74d6a1f26169b72)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestPolygonShapePointsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestPolygonShapePointsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a022233ceb804b6f245ddffdf94d8afd23feb5a96ce05dd06480f16ba2fb69c2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetX")
    def reset_x(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetX", []))

    @jsii.member(jsii_name="resetXVar")
    def reset_x_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXVar", []))

    @jsii.member(jsii_name="resetY")
    def reset_y(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetY", []))

    @jsii.member(jsii_name="resetYVar")
    def reset_y_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYVar", []))

    @builtins.property
    @jsii.member(jsii_name="xInput")
    def x_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xInput"))

    @builtins.property
    @jsii.member(jsii_name="xVarInput")
    def x_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yInput")
    def y_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yInput"))

    @builtins.property
    @jsii.member(jsii_name="yVarInput")
    def y_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yVarInput"))

    @builtins.property
    @jsii.member(jsii_name="x")
    def x(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "x"))

    @x.setter
    def x(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7050d8136df8178233d25daa1e04af020772b8beccf678eee98e03963c4e8914)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "x", value)

    @builtins.property
    @jsii.member(jsii_name="xVar")
    def x_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xVar"))

    @x_var.setter
    def x_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2bcf3c02a385dfb80a58de337a9264f57ba7a82f42a871f1d93a07c4eed19bc7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xVar", value)

    @builtins.property
    @jsii.member(jsii_name="y")
    def y(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "y"))

    @y.setter
    def y(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4be5fc549f350162728248ac23bf78fa6486159d776716fb800a47661c540548)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "y", value)

    @builtins.property
    @jsii.member(jsii_name="yVar")
    def y_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yVar"))

    @y_var.setter
    def y_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a580c7fd6df8f0046c61608c6af709679cbfb8e9528a6f91eec3134adfa90415)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestPolygonShapePoints]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestPolygonShapePoints]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestPolygonShapePoints]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__09e2f42938bb07e7710c0be92eaf1aa218b49a04f5b438c2e39cdfd4ec3cc340)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestRectangleShape",
    jsii_struct_bases=[],
    name_mapping={
        "anchor": "anchor",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestRectangleShape:
    def __init__(
        self,
        *,
        anchor: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestRectangleShapeAnchor", typing.Dict[builtins.str, typing.Any]],
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param anchor: anchor block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#anchor DataAkamaiImagingPolicyImage#anchor}
        :param height: Extends the rectangle down from the ``anchor`` point. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: Extends the rectangle down from the ``anchor`` point. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: Extends the rectangle right from the ``anchor`` point. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: Extends the rectangle right from the ``anchor`` point. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(anchor, dict):
            anchor = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestRectangleShapeAnchor(**anchor)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__13e6f6d362b148eebe5a174765858afc564b4640e56be1f4baa5dbebe114443c)
            check_type(argname="argument anchor", value=anchor, expected_type=type_hints["anchor"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "anchor": anchor,
        }
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def anchor(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestRectangleShapeAnchor":
        '''anchor block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#anchor DataAkamaiImagingPolicyImage#anchor}
        '''
        result = self._values.get("anchor")
        assert result is not None, "Required property 'anchor' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestRectangleShapeAnchor", result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''Extends the rectangle down from the ``anchor`` point.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''Extends the rectangle down from the ``anchor`` point.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''Extends the rectangle right from the ``anchor`` point.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''Extends the rectangle right from the ``anchor`` point.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestRectangleShape(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestRectangleShapeAnchor",
    jsii_struct_bases=[],
    name_mapping={"x": "x", "x_var": "xVar", "y": "y", "y_var": "yVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestRectangleShapeAnchor:
    def __init__(
        self,
        *,
        x: typing.Optional[builtins.str] = None,
        x_var: typing.Optional[builtins.str] = None,
        y: typing.Optional[builtins.str] = None,
        y_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param x: The horizontal position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x DataAkamaiImagingPolicyImage#x}
        :param x_var: The horizontal position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_var DataAkamaiImagingPolicyImage#x_var}
        :param y: The vertical position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y DataAkamaiImagingPolicyImage#y}
        :param y_var: The vertical position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_var DataAkamaiImagingPolicyImage#y_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dd187953302af98b086d240442114e7a11fe57a588c58ddda9f47bc3bd3eef8e)
            check_type(argname="argument x", value=x, expected_type=type_hints["x"])
            check_type(argname="argument x_var", value=x_var, expected_type=type_hints["x_var"])
            check_type(argname="argument y", value=y, expected_type=type_hints["y"])
            check_type(argname="argument y_var", value=y_var, expected_type=type_hints["y_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if x is not None:
            self._values["x"] = x
        if x_var is not None:
            self._values["x_var"] = x_var
        if y is not None:
            self._values["y"] = y
        if y_var is not None:
            self._values["y_var"] = y_var

    @builtins.property
    def x(self) -> typing.Optional[builtins.str]:
        '''The horizontal position of the point, measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x DataAkamaiImagingPolicyImage#x}
        '''
        result = self._values.get("x")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_var(self) -> typing.Optional[builtins.str]:
        '''The horizontal position of the point, measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_var DataAkamaiImagingPolicyImage#x_var}
        '''
        result = self._values.get("x_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y(self) -> typing.Optional[builtins.str]:
        '''The vertical position of the point, measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y DataAkamaiImagingPolicyImage#y}
        '''
        result = self._values.get("y")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_var(self) -> typing.Optional[builtins.str]:
        '''The vertical position of the point, measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_var DataAkamaiImagingPolicyImage#y_var}
        '''
        result = self._values.get("y_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestRectangleShapeAnchor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestRectangleShapeAnchorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestRectangleShapeAnchorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__62deebb6f496ae51280ef723c8e0fb6682508ddb57e602e7119eec23f36d57b3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetX")
    def reset_x(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetX", []))

    @jsii.member(jsii_name="resetXVar")
    def reset_x_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXVar", []))

    @jsii.member(jsii_name="resetY")
    def reset_y(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetY", []))

    @jsii.member(jsii_name="resetYVar")
    def reset_y_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYVar", []))

    @builtins.property
    @jsii.member(jsii_name="xInput")
    def x_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xInput"))

    @builtins.property
    @jsii.member(jsii_name="xVarInput")
    def x_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yInput")
    def y_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yInput"))

    @builtins.property
    @jsii.member(jsii_name="yVarInput")
    def y_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yVarInput"))

    @builtins.property
    @jsii.member(jsii_name="x")
    def x(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "x"))

    @x.setter
    def x(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__832442c901ec5562d1a8c46a58ec010bf6659990f8a9638d539fddf0cfd90bab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "x", value)

    @builtins.property
    @jsii.member(jsii_name="xVar")
    def x_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xVar"))

    @x_var.setter
    def x_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5a8eeb79351ba6ff15fc53690972880b03f790f4539a24da2081907e585407a1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xVar", value)

    @builtins.property
    @jsii.member(jsii_name="y")
    def y(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "y"))

    @y.setter
    def y(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd090227ba9ce54513528e576138c787cf105a272ff2edcd160657c12eece59b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "y", value)

    @builtins.property
    @jsii.member(jsii_name="yVar")
    def y_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yVar"))

    @y_var.setter
    def y_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8747adab2956244eac6a25e21be309937b25065dce187319b1a8e35a054c8617)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestRectangleShapeAnchor]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestRectangleShapeAnchor], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestRectangleShapeAnchor],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__05ab8a1f3f634b41db3f54593c721092904c5f24956d4f3785037e090509b3a0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestRectangleShapeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestRectangleShapeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e1691f5c972531866079caa4706b014ec7228c9503ec14a9d2908c181cf7188e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestRectangleShapeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__344d323be215f2d486dff902606d04f2a07636bf13c50df173a45ce1c6ea3a59)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestRectangleShapeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b7fc0913156d165a0e73d73e0e9633f83a8ad17d57e06e99e8c58a2c9b656bd4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b89f18a12a0e5bbb9e5cd8451684348d466ed5a4321284e893305430be26a356)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__817cda64b74588098bdb7b8c3fc003b28df8b0a69bfb60fdc2d50eb79dd56ea2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestRectangleShape]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestRectangleShape]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestRectangleShape]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__92db64106b89f0145541615e1d18a4fe763337bb926c7ffb9760148ad9b606dc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestRectangleShapeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestRectangleShapeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f0576eb60c637330c77721127f455fd3f2890fb3feaa8839a174e7e18471d3a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putAnchor")
    def put_anchor(
        self,
        *,
        x: typing.Optional[builtins.str] = None,
        x_var: typing.Optional[builtins.str] = None,
        y: typing.Optional[builtins.str] = None,
        y_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param x: The horizontal position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x DataAkamaiImagingPolicyImage#x}
        :param x_var: The horizontal position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_var DataAkamaiImagingPolicyImage#x_var}
        :param y: The vertical position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y DataAkamaiImagingPolicyImage#y}
        :param y_var: The vertical position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_var DataAkamaiImagingPolicyImage#y_var}
        '''
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestRectangleShapeAnchor(
            x=x, x_var=x_var, y=y, y_var=y_var
        )

        return typing.cast(None, jsii.invoke(self, "putAnchor", [value]))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="anchor")
    def anchor(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestRectangleShapeAnchorOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestRectangleShapeAnchorOutputReference, jsii.get(self, "anchor"))

    @builtins.property
    @jsii.member(jsii_name="anchorInput")
    def anchor_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestRectangleShapeAnchor]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestRectangleShapeAnchor], jsii.get(self, "anchorInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b4305c13077713be8288eab8e4816e09f0ec2cc9f87b844a490c39f438ec3922)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__92891bbae509901b1071af18b2943d13c1335cb3cbe21d1bda84c2e96e257c43)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f3547416a86ad475bab1927ba13c6a1ea63cdcf97a8df68b0dd0e2ff08c1e6d5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4dd366a9acc646f1fae09fac5d4553a7456ae2b615d3320217db8f4e8191caf9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestRectangleShape]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestRectangleShape]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestRectangleShape]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__afc4c715427dff25c26dbef369298ca5c4cdca2b692b9cbce217eec84c9c8649)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestUnionShape",
    jsii_struct_bases=[],
    name_mapping={"shapes": "shapes"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestUnionShape:
    def __init__(
        self,
        *,
        shapes: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestUnionShapeShapes", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param shapes: shapes block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shapes DataAkamaiImagingPolicyImage#shapes}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c98ac0266ce105c21e363f75a63daf2f4226033c11f12fc006d8d3cb6ab05939)
            check_type(argname="argument shapes", value=shapes, expected_type=type_hints["shapes"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "shapes": shapes,
        }

    @builtins.property
    def shapes(
        self,
    ) -> typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestUnionShapeShapes"]]:
        '''shapes block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shapes DataAkamaiImagingPolicyImage#shapes}
        '''
        result = self._values.get("shapes")
        assert result is not None, "Required property 'shapes' is missing"
        return typing.cast(typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestUnionShapeShapes"]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestUnionShape(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestUnionShapeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestUnionShapeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__db1e246a455a721b06445fb501b85692e5ee84f5813fd5e5843b7f001d6676e1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestUnionShapeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aaad41aa9d627b7c769d34162f8ee87ab59f87507241faffeb8951ea57b5b07c)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestUnionShapeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__65451f62d87438cd9814dc813188e3cc5eb2d4de3a8dca48b04e6c535908e563)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__03e9180206fcd77170126b9cb177e5528dffb0a0e0eeed9bfe2e613dcaf0930a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c859719c0bd4e6da9174b6cde749bbf3d8174ad72932d99aa804143777467816)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestUnionShape]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestUnionShape]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestUnionShape]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8779a8b28c55b5f8eb619fe0b9734646c54a171d873b0844d64a6d38792c51c3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestUnionShapeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestUnionShapeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a7fe5e6e413e26a808c5c5ad1dab69c7fe17c0e5f3a075cac8ed84c59e1fce6f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putShapes")
    def put_shapes(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestUnionShapeShapes", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f7ff0cb6ae54c1fb2306009e8de8c2683a1656fd5a47a6119f9852093eaa265f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putShapes", [value]))

    @builtins.property
    @jsii.member(jsii_name="shapes")
    def shapes(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestUnionShapeShapesList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestUnionShapeShapesList", jsii.get(self, "shapes"))

    @builtins.property
    @jsii.member(jsii_name="shapesInput")
    def shapes_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestUnionShapeShapes"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestUnionShapeShapes"]]], jsii.get(self, "shapesInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestUnionShape]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestUnionShape]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestUnionShape]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__16e762cdc05e94da75c49464ff907ec4142ad27a28919a9546f0a984a4cf7ccd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestUnionShapeShapes",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestUnionShapeShapes:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestUnionShapeShapes(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestUnionShapeShapesList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestUnionShapeShapesList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__214d7021ff41b8d6f01b9e126b1074e886d4c3d86bae41f332a1cfed184e4623)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestUnionShapeShapesOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dce3be4994abc9ebdf35685c262dd59c8c53145dae6a986376f3d7e2ef7deaca)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestUnionShapeShapesOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8fe975a90a2e1a116b3e42e504aded99671b292d4d185343f19865325b3e37d9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc643afc3a86a6c9c0659e011db179908234ee707d8ca07c7fa4d02fc7807ade)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__51ce5cdb1c5185c5afba8c9ea5af5bf0e00100678522f87cc4643452ef536a99)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestUnionShapeShapes]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestUnionShapeShapes]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestUnionShapeShapes]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__12bf32fea45b4f8a33aa60884dee641b1941c52a6885db7dbea3a30c21af9bde)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestUnionShapeShapesOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestUnionShapeShapesOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__db57c12b1773f46bc8ce03ba72d1abf321962e96e0268842210d89af838c1b15)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestUnionShapeShapes]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestUnionShapeShapes]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestUnionShapeShapes]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5fb0946a599a4aa19a7399a687aac5cda6305eac81db7a5e8649ad32b423767f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRelativeCrop",
    jsii_struct_bases=[],
    name_mapping={
        "east": "east",
        "east_var": "eastVar",
        "north": "north",
        "north_var": "northVar",
        "south": "south",
        "south_var": "southVar",
        "west": "west",
        "west_var": "westVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRelativeCrop:
    def __init__(
        self,
        *,
        east: typing.Optional[builtins.str] = None,
        east_var: typing.Optional[builtins.str] = None,
        north: typing.Optional[builtins.str] = None,
        north_var: typing.Optional[builtins.str] = None,
        south: typing.Optional[builtins.str] = None,
        south_var: typing.Optional[builtins.str] = None,
        west: typing.Optional[builtins.str] = None,
        west_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param east: The number of pixels to shrink or expand the right side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east DataAkamaiImagingPolicyImage#east}
        :param east_var: The number of pixels to shrink or expand the right side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east_var DataAkamaiImagingPolicyImage#east_var}
        :param north: The number of pixels to shrink or expand the top side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north DataAkamaiImagingPolicyImage#north}
        :param north_var: The number of pixels to shrink or expand the top side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north_var DataAkamaiImagingPolicyImage#north_var}
        :param south: The number of pixels to shrink or expand the bottom side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south DataAkamaiImagingPolicyImage#south}
        :param south_var: The number of pixels to shrink or expand the bottom side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south_var DataAkamaiImagingPolicyImage#south_var}
        :param west: The number of pixels to shrink or expand the left side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west DataAkamaiImagingPolicyImage#west}
        :param west_var: The number of pixels to shrink or expand the left side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west_var DataAkamaiImagingPolicyImage#west_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f2ee164f6062d65ff3160abfafaea905241f8b7d20e15a794b14a37798de8a4)
            check_type(argname="argument east", value=east, expected_type=type_hints["east"])
            check_type(argname="argument east_var", value=east_var, expected_type=type_hints["east_var"])
            check_type(argname="argument north", value=north, expected_type=type_hints["north"])
            check_type(argname="argument north_var", value=north_var, expected_type=type_hints["north_var"])
            check_type(argname="argument south", value=south, expected_type=type_hints["south"])
            check_type(argname="argument south_var", value=south_var, expected_type=type_hints["south_var"])
            check_type(argname="argument west", value=west, expected_type=type_hints["west"])
            check_type(argname="argument west_var", value=west_var, expected_type=type_hints["west_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if east is not None:
            self._values["east"] = east
        if east_var is not None:
            self._values["east_var"] = east_var
        if north is not None:
            self._values["north"] = north
        if north_var is not None:
            self._values["north_var"] = north_var
        if south is not None:
            self._values["south"] = south
        if south_var is not None:
            self._values["south_var"] = south_var
        if west is not None:
            self._values["west"] = west
        if west_var is not None:
            self._values["west_var"] = west_var

    @builtins.property
    def east(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the right side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east DataAkamaiImagingPolicyImage#east}
        '''
        result = self._values.get("east")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def east_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the right side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east_var DataAkamaiImagingPolicyImage#east_var}
        '''
        result = self._values.get("east_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def north(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the top side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north DataAkamaiImagingPolicyImage#north}
        '''
        result = self._values.get("north")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def north_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the top side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north_var DataAkamaiImagingPolicyImage#north_var}
        '''
        result = self._values.get("north_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def south(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the bottom side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south DataAkamaiImagingPolicyImage#south}
        '''
        result = self._values.get("south")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def south_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the bottom side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south_var DataAkamaiImagingPolicyImage#south_var}
        '''
        result = self._values.get("south_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def west(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the left side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west DataAkamaiImagingPolicyImage#west}
        '''
        result = self._values.get("west")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def west_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the left side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west_var DataAkamaiImagingPolicyImage#west_var}
        '''
        result = self._values.get("west_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRelativeCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRelativeCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRelativeCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__478d19acd1d8d9e2a5cb565285b37ff9a54bf9e600395e0ac6fc40fba1a60457)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRelativeCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ff8474c930f6ba757a4f33aeaf386adf3f15441d2244c2655401ee4a00cb1a37)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRelativeCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5e77508ea6ca415cfc9eccfe13dad698c01c1d2e8bc30e60c1fb8d14f69922ae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ef7de1219b5424893564282450d02eb7bd2bb956ef0915ab5aa0a72b04142c5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d3d413c94a05ba5fe2893e7f3010e365ec47d9b5868269a38102f3e4f271fb4e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRelativeCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRelativeCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRelativeCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__09f960261dbfd492cea0156a31c256eda83af89f5ccd5d39a02f43007717c1ba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRelativeCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRelativeCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__500c492833e069f2bed61ca800186d7333fa25dfa830ebadd671a482b2e79c76)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetEast")
    def reset_east(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEast", []))

    @jsii.member(jsii_name="resetEastVar")
    def reset_east_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEastVar", []))

    @jsii.member(jsii_name="resetNorth")
    def reset_north(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNorth", []))

    @jsii.member(jsii_name="resetNorthVar")
    def reset_north_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNorthVar", []))

    @jsii.member(jsii_name="resetSouth")
    def reset_south(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSouth", []))

    @jsii.member(jsii_name="resetSouthVar")
    def reset_south_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSouthVar", []))

    @jsii.member(jsii_name="resetWest")
    def reset_west(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWest", []))

    @jsii.member(jsii_name="resetWestVar")
    def reset_west_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWestVar", []))

    @builtins.property
    @jsii.member(jsii_name="eastInput")
    def east_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "eastInput"))

    @builtins.property
    @jsii.member(jsii_name="eastVarInput")
    def east_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "eastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="northInput")
    def north_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "northInput"))

    @builtins.property
    @jsii.member(jsii_name="northVarInput")
    def north_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "northVarInput"))

    @builtins.property
    @jsii.member(jsii_name="southInput")
    def south_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "southInput"))

    @builtins.property
    @jsii.member(jsii_name="southVarInput")
    def south_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "southVarInput"))

    @builtins.property
    @jsii.member(jsii_name="westInput")
    def west_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "westInput"))

    @builtins.property
    @jsii.member(jsii_name="westVarInput")
    def west_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "westVarInput"))

    @builtins.property
    @jsii.member(jsii_name="east")
    def east(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "east"))

    @east.setter
    def east(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f469e97c6a8d40907202bd83f6889900408e7a68c983be140509d37d5bbec420)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "east", value)

    @builtins.property
    @jsii.member(jsii_name="eastVar")
    def east_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "eastVar"))

    @east_var.setter
    def east_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c610764fe39c9480743bc19cd8e2452736922068ebfe78f877843c8984547f87)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "eastVar", value)

    @builtins.property
    @jsii.member(jsii_name="north")
    def north(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "north"))

    @north.setter
    def north(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a88889ec9c27f9e361227ade439ace23b9e1a98dd5f6206c499ec41279dea1c3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "north", value)

    @builtins.property
    @jsii.member(jsii_name="northVar")
    def north_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "northVar"))

    @north_var.setter
    def north_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__691f6b00ad4eb6b596683b89bda795deb0ef5f1b3c4abc64334831f5c2f4093d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "northVar", value)

    @builtins.property
    @jsii.member(jsii_name="south")
    def south(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "south"))

    @south.setter
    def south(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__975a02907c022548b33be78f6780cc6c1f8114a080c33b9534530885ffed7f1b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "south", value)

    @builtins.property
    @jsii.member(jsii_name="southVar")
    def south_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "southVar"))

    @south_var.setter
    def south_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ae22361522f0b6912d91fa805f8ca94bdbb787907b87ce97f6d44b2faff5a505)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "southVar", value)

    @builtins.property
    @jsii.member(jsii_name="west")
    def west(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "west"))

    @west.setter
    def west(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__83c73c5a099b5e0777131b7c11de4432349f5871a7278b3a6e091ff7c2a6dabd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "west", value)

    @builtins.property
    @jsii.member(jsii_name="westVar")
    def west_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "westVar"))

    @west_var.setter
    def west_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__49156fe88c949da9554269c81abfd2957952e313706bfc616171e1618a05927d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "westVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRelativeCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRelativeCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRelativeCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__95eb5637f17186b8bbadc73a16c80c40251cc4aa3b280272735890f50d6e3912)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRemoveColor",
    jsii_struct_bases=[],
    name_mapping={
        "color": "color",
        "color_var": "colorVar",
        "feather": "feather",
        "feather_var": "featherVar",
        "tolerance": "tolerance",
        "tolerance_var": "toleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRemoveColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
        feather: typing.Optional[builtins.str] = None,
        feather_var: typing.Optional[builtins.str] = None,
        tolerance: typing.Optional[builtins.str] = None,
        tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        :param feather: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        :param feather_var: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        :param tolerance: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        :param tolerance_var: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b384430779697eb1676fabb4e8c9c5bd5b65d0e00af89c701e3ac3f16083db16)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
            check_type(argname="argument feather", value=feather, expected_type=type_hints["feather"])
            check_type(argname="argument feather_var", value=feather_var, expected_type=type_hints["feather_var"])
            check_type(argname="argument tolerance", value=tolerance, expected_type=type_hints["tolerance"])
            check_type(argname="argument tolerance_var", value=tolerance_var, expected_type=type_hints["tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var
        if feather is not None:
            self._values["feather"] = feather
        if feather_var is not None:
            self._values["feather_var"] = feather_var
        if tolerance is not None:
            self._values["tolerance"] = tolerance
        if tolerance_var is not None:
            self._values["tolerance_var"] = tolerance_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        '''
        result = self._values.get("feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather_var(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        '''
        result = self._values.get("feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        '''
        result = self._values.get("tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance_var(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        result = self._values.get("tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRemoveColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRemoveColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRemoveColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ebafe08ee9c0e42af8181be057ebc3e3d8f549ee8432dbc971c909b432205d4b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRemoveColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b4174b4155334d083f9407e52b143ee9ae4b168febe8f4dab8139d5be25562e1)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRemoveColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5791ceea7af19fa289b6d9217dffacf804cccbb0f6978dcfd251ba51fd9f76da)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cdcec6c9e8b771cc7cb3655ce8d66876354769a89b2373a9d5d656e2d1c17d29)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__944a9b1770e5d78b6d4ae903ad296f1b08c5090a2d33b0b2b7d3f7f0a8d2096d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRemoveColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRemoveColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRemoveColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7f94b02300ff80e0a106ac05a17b2faf646074a7dcb0c0eaedc929b5e4173426)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRemoveColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRemoveColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__42cf3a1987114072f1101cf7c4be708e97544fec3082ec5ffbf48a2d8ccc59c0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @jsii.member(jsii_name="resetFeather")
    def reset_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeather", []))

    @jsii.member(jsii_name="resetFeatherVar")
    def reset_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatherVar", []))

    @jsii.member(jsii_name="resetTolerance")
    def reset_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTolerance", []))

    @jsii.member(jsii_name="resetToleranceVar")
    def reset_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featherInput")
    def feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherInput"))

    @builtins.property
    @jsii.member(jsii_name="featherVarInput")
    def feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceInput")
    def tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceVarInput")
    def tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e87403dbbbd57d75c3feb29e060f008e31eebcca8d1bd81c73de1f8b8f03f7cf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea057225137fa6fe2914da4d8f9880a8c50f887699b11c8aa8546d01956964ed)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="feather")
    def feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "feather"))

    @feather.setter
    def feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__26def1b475e39276b2ed3edd83486c503e94b3b9470c82af25f7a8593d4f6bce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "feather", value)

    @builtins.property
    @jsii.member(jsii_name="featherVar")
    def feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featherVar"))

    @feather_var.setter
    def feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__426ad7e5914a1e886b53e28ba4ca18d90af87f50aa4011897e5642b5dc1460be)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featherVar", value)

    @builtins.property
    @jsii.member(jsii_name="tolerance")
    def tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tolerance"))

    @tolerance.setter
    def tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3294d4c6e53075e904f09da96820eecc935cb8ccc9fee24682c827f53e34547e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tolerance", value)

    @builtins.property
    @jsii.member(jsii_name="toleranceVar")
    def tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "toleranceVar"))

    @tolerance_var.setter
    def tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3e9b5649f3002a1b981dafac03b3a40c7ce752caee538e393ddfada5ee1c623d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "toleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRemoveColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRemoveColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRemoveColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__44d1d7e380d0dd181adb22c62675634d6fadb30ba7ecf068035efc1899e5a553)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultResize",
    jsii_struct_bases=[],
    name_mapping={
        "aspect": "aspect",
        "aspect_var": "aspectVar",
        "height": "height",
        "height_var": "heightVar",
        "type": "type",
        "type_var": "typeVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultResize:
    def __init__(
        self,
        *,
        aspect: typing.Optional[builtins.str] = None,
        aspect_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param aspect: Preserves the aspect ratio. Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect DataAkamaiImagingPolicyImage#aspect}
        :param aspect_var: Preserves the aspect ratio. Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_var DataAkamaiImagingPolicyImage#aspect_var}
        :param height: The height to resize the source image to. Must be set if height is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height to resize the source image to. Must be set if height is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param type: Sets constraints for the image resize. Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: Sets constraints for the image resize. Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        :param width: The width to resize the source image to. Must be set if width is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width to resize the source image to. Must be set if width is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3b8b64fca741f64b1384749609632ee18f43fdc98818c82ffa70739af3f2d95f)
            check_type(argname="argument aspect", value=aspect, expected_type=type_hints["aspect"])
            check_type(argname="argument aspect_var", value=aspect_var, expected_type=type_hints["aspect_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if aspect is not None:
            self._values["aspect"] = aspect
        if aspect_var is not None:
            self._values["aspect_var"] = aspect_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def aspect(self) -> typing.Optional[builtins.str]:
        '''Preserves the aspect ratio.

        Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect DataAkamaiImagingPolicyImage#aspect}
        '''
        result = self._values.get("aspect")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def aspect_var(self) -> typing.Optional[builtins.str]:
        '''Preserves the aspect ratio.

        Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_var DataAkamaiImagingPolicyImage#aspect_var}
        '''
        result = self._values.get("aspect_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height to resize the source image to. Must be set if height is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height to resize the source image to. Must be set if height is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''Sets constraints for the image resize.

        Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''Sets constraints for the image resize.

        Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width to resize the source image to. Must be set if width is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width to resize the source image to. Must be set if width is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultResize(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultResizeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultResizeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eb014d1838839bdb19de58a6c0d8775af2c9e01e3050af01517d7924954d787c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultResizeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0bd51dc7304cb7e9142f3fa6d6e97440f81a83632348854dabfc8acbefe1d944)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultResizeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0982dfbd79e0d0e6c3dbcd9886f14c53ff2a09981d1c95c4f0b84e85f35f937a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ede6030b77014dc40ad1697292da2a316b2d138a6a356ccd647ac5b3475f9745)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8ae5bb7501c4c6cabc471c6e745b436ab1b1d58c2da5de53e5c9a7930ae11b5b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultResize]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultResize]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultResize]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7de696de49b2c92fe228e72ca3f5112fe50a9625e6620be74c439ea7fe99d37c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultResizeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultResizeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fd007786bdf6aef5b8925a7a994291a21efaff82906a05fbec0b649353c5a9e3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAspect")
    def reset_aspect(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspect", []))

    @jsii.member(jsii_name="resetAspectVar")
    def reset_aspect_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspectVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="aspectInput")
    def aspect_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "aspectInput"))

    @builtins.property
    @jsii.member(jsii_name="aspectVarInput")
    def aspect_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "aspectVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="aspect")
    def aspect(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "aspect"))

    @aspect.setter
    def aspect(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ba052963617fbba29bab5d63bea4589f9265f31e23b0326811284c385fbe11b9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "aspect", value)

    @builtins.property
    @jsii.member(jsii_name="aspectVar")
    def aspect_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "aspectVar"))

    @aspect_var.setter
    def aspect_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4052b643b2796fa531e6efe8a333acf1347a0f27373c4234a7199fbdba978bda)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "aspectVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__204f2a5afd18510c097672487af5e8f9980e3d3a26f13f7d9a8da258a254ab6a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ded04dcb180ee592d229428a39c50eb5b7ce6f74d8cfc1964d255e215ba256f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__364b1d0ad6091cb6feb4a43f9a2ea78819d0d6cf98bff491b122829628afb504)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0428b31a9eb456f55ab254fb44274aae6dcf22f8c8b9a7397bd887d1ec0652ed)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__044509477d1119ba7c5f64a07da29b049ac3301433fd46eacbed2ef7cabb04b2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__28d0b397cece354414961ae4379c51368f354e6feed8ffdc36fc4bfba76defa1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultResize]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultResize]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultResize]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d678bf7ab67d2a80a1a1cc756871d7104e604bad419d54695e28ae3338bb4259)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRotate",
    jsii_struct_bases=[],
    name_mapping={"degrees": "degrees", "degrees_var": "degreesVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRotate:
    def __init__(
        self,
        *,
        degrees: typing.Optional[builtins.str] = None,
        degrees_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param degrees: The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees DataAkamaiImagingPolicyImage#degrees}
        :param degrees_var: The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees_var DataAkamaiImagingPolicyImage#degrees_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b17c287ff929c4bfb53dd27efbc582e4712c71267bea13f4a9bf9e70c004ed31)
            check_type(argname="argument degrees", value=degrees, expected_type=type_hints["degrees"])
            check_type(argname="argument degrees_var", value=degrees_var, expected_type=type_hints["degrees_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if degrees is not None:
            self._values["degrees"] = degrees
        if degrees_var is not None:
            self._values["degrees_var"] = degrees_var

    @builtins.property
    def degrees(self) -> typing.Optional[builtins.str]:
        '''The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees DataAkamaiImagingPolicyImage#degrees}
        '''
        result = self._values.get("degrees")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def degrees_var(self) -> typing.Optional[builtins.str]:
        '''The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees_var DataAkamaiImagingPolicyImage#degrees_var}
        '''
        result = self._values.get("degrees_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRotate(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRotateList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRotateList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a8f4e3a832df6c7fd6f522a06c8fb54b365d62995c0f84372d2fca1eaed43fe)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRotateOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__79f4156e7c1b4f5d9cc434aa6ad8e6d2c4652dbb1ff309a7b16aa47a9829eee1)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRotateOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f10a72c31f339355b8542b12103e61358df3fa8391777271efdecca094347587)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d8002ada5c9fd3e256292cb853d7d720fa1d92aa4f749210d00747cee7757961)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__22806718c2308f5934d1bfc3aebbc5a7a03fc0132b7c1eb6f96c709aca55450a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRotate]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRotate]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRotate]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ee56d47046163efd7e17c7cbe563ac4ccbcdc445918799a90d8d01372b9c844d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRotateOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRotateOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d758e2fea2e841b2fee30baee919b019d23ed53a9923b5fb2624ce52a18fa0f1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetDegrees")
    def reset_degrees(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDegrees", []))

    @jsii.member(jsii_name="resetDegreesVar")
    def reset_degrees_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDegreesVar", []))

    @builtins.property
    @jsii.member(jsii_name="degreesInput")
    def degrees_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "degreesInput"))

    @builtins.property
    @jsii.member(jsii_name="degreesVarInput")
    def degrees_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "degreesVarInput"))

    @builtins.property
    @jsii.member(jsii_name="degrees")
    def degrees(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "degrees"))

    @degrees.setter
    def degrees(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a96681423724175320f6e09b896ef737020911c60f8180538c6711fd20d9a4d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "degrees", value)

    @builtins.property
    @jsii.member(jsii_name="degreesVar")
    def degrees_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "degreesVar"))

    @degrees_var.setter
    def degrees_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9620ad16295414e2182cd60d26eab017bafc04c772b637f0517d1a96e7ccf1fd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "degreesVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRotate]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRotate]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRotate]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__363fe1c869311e996793019f3387907ab24d9275058001a0aeb967255f23af11)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultScale",
    jsii_struct_bases=[],
    name_mapping={
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultScale:
    def __init__(
        self,
        *,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param height: Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged. Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged. Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f4c196c373836988ce84f70667e70418b72208b5ae3087613b5c2bf614cd2ea8)
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size.

        Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size.

        Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged.

        Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged.

        Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultScale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultScaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultScaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f276d6e6bf149d85422ec2e2028d8620a139cca5926dd4a3961eb0c2c68e5238)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultScaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__442e445b4e61b45c955e48105eba62d69732a3a5cb00bd059cdd4e30c7a7a9d6)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultScaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4f6a1256c899526472caba3b802410b2165aac6928e90e4685d2198522a33d96)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6afb05cbd2ad728ccf31f3d1e36ae7a54f8d5b11828c9094b5c176559bcb05f0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__33d3a17b2d465c80c506c0e226e29e441b4a41a3e947899f5f2ec7dd7cca4a43)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultScale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultScale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultScale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d1a82193805d6e555a69d38c61190c0a45ff6eda2988968bf0a7a21b9ef72e9b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultScaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultScaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5419a787ea232b1bdfef078390c580a8916e8a2083ce362fcd88e8fcf9676a04)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8664acf4491a639ce26d442fefb503bdfdecffeb29cfa524b645f961880bc218)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d7f4278a028d369ab49638ed887504b07c9f1d9e4699598be4d222d2fe4e75b9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__396e7bc4d37f0e25152baf9e078f719730ca0941d04e97b891d2b1def3cf1b7a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f01395730d1ae57b7b299f77cbad2a0fcf9ac7d88fb4c96c44b0c77336ecbe56)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultScale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultScale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultScale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c64f260844636bd886637401a8f326bef640b40ed4e48a1a41b2bc8dcc54d8c8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultShear",
    jsii_struct_bases=[],
    name_mapping={
        "x_shear": "xShear",
        "x_shear_var": "xShearVar",
        "y_shear": "yShear",
        "y_shear_var": "yShearVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultShear:
    def __init__(
        self,
        *,
        x_shear: typing.Optional[builtins.str] = None,
        x_shear_var: typing.Optional[builtins.str] = None,
        y_shear: typing.Optional[builtins.str] = None,
        y_shear_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param x_shear: The amount to shear along the x-axis, measured in multiples of the image's width. Must be set if yShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear DataAkamaiImagingPolicyImage#x_shear}
        :param x_shear_var: The amount to shear along the x-axis, measured in multiples of the image's width. Must be set if yShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear_var DataAkamaiImagingPolicyImage#x_shear_var}
        :param y_shear: The amount to shear along the y-axis, measured in multiples of the image's height. Must be set if xShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear DataAkamaiImagingPolicyImage#y_shear}
        :param y_shear_var: The amount to shear along the y-axis, measured in multiples of the image's height. Must be set if xShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear_var DataAkamaiImagingPolicyImage#y_shear_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ed9be389b087ca01fd6317e13e47b2120848fb70075c7e7d32bdb32f798853a)
            check_type(argname="argument x_shear", value=x_shear, expected_type=type_hints["x_shear"])
            check_type(argname="argument x_shear_var", value=x_shear_var, expected_type=type_hints["x_shear_var"])
            check_type(argname="argument y_shear", value=y_shear, expected_type=type_hints["y_shear"])
            check_type(argname="argument y_shear_var", value=y_shear_var, expected_type=type_hints["y_shear_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if x_shear is not None:
            self._values["x_shear"] = x_shear
        if x_shear_var is not None:
            self._values["x_shear_var"] = x_shear_var
        if y_shear is not None:
            self._values["y_shear"] = y_shear
        if y_shear_var is not None:
            self._values["y_shear_var"] = y_shear_var

    @builtins.property
    def x_shear(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the x-axis, measured in multiples of the image's width.

        Must be set if yShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear DataAkamaiImagingPolicyImage#x_shear}
        '''
        result = self._values.get("x_shear")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_shear_var(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the x-axis, measured in multiples of the image's width.

        Must be set if yShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear_var DataAkamaiImagingPolicyImage#x_shear_var}
        '''
        result = self._values.get("x_shear_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_shear(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the y-axis, measured in multiples of the image's height.

        Must be set if xShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear DataAkamaiImagingPolicyImage#y_shear}
        '''
        result = self._values.get("y_shear")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_shear_var(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the y-axis, measured in multiples of the image's height.

        Must be set if xShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear_var DataAkamaiImagingPolicyImage#y_shear_var}
        '''
        result = self._values.get("y_shear_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultShear(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultShearList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultShearList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__33f08ff0314c2319379ce33af0a4957d346af676aeec433392ea3e18a6480d4a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultShearOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c447cb9ccf1cef4febfada315d7f4ec5f08c4b2f06c7f44dbbd81524fa58bea4)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultShearOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5a8d4b1611fd020ed519a5a0e75c5c1696c666abdce3e10eb261477fb37e1c9b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cad6c6d15b003f9f2d61951c7fa3b371083c801261465d99ce3d700dfc80b66b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__40aa8f0f9d927ab1fd8d40a5c662a0e9bad8848aff0e942c21e0948dca47ecad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultShear]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultShear]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultShear]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a9f8e8d2e7dd2a69710411dfd762437301696395459753c078c1b7c7f75e7c1c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultShearOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultShearOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__455c1226c34cafdb57300028003c5e4c4c05f35af46d1c8e9acb35310519c685)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetXShear")
    def reset_x_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXShear", []))

    @jsii.member(jsii_name="resetXShearVar")
    def reset_x_shear_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXShearVar", []))

    @jsii.member(jsii_name="resetYShear")
    def reset_y_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYShear", []))

    @jsii.member(jsii_name="resetYShearVar")
    def reset_y_shear_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYShearVar", []))

    @builtins.property
    @jsii.member(jsii_name="xShearInput")
    def x_shear_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xShearInput"))

    @builtins.property
    @jsii.member(jsii_name="xShearVarInput")
    def x_shear_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xShearVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yShearInput")
    def y_shear_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yShearInput"))

    @builtins.property
    @jsii.member(jsii_name="yShearVarInput")
    def y_shear_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yShearVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xShear")
    def x_shear(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xShear"))

    @x_shear.setter
    def x_shear(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2e4495606931ed56dca9331100325fe83605d670e069d7fe752e0d0ef670e72c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xShear", value)

    @builtins.property
    @jsii.member(jsii_name="xShearVar")
    def x_shear_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xShearVar"))

    @x_shear_var.setter
    def x_shear_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0281fd5dc3635b2415bafd9d4e89c041f0f5d7b188f49b68803e3b447260a0a5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xShearVar", value)

    @builtins.property
    @jsii.member(jsii_name="yShear")
    def y_shear(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yShear"))

    @y_shear.setter
    def y_shear(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e17ca18df97e76b0dddb6142af36e8082a19029284a37e0c4592d449dbbcfc47)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yShear", value)

    @builtins.property
    @jsii.member(jsii_name="yShearVar")
    def y_shear_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yShearVar"))

    @y_shear_var.setter
    def y_shear_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1398c493da1779667c5b6cbcea73d84df08f76c044f9e13ec924fd70f86b5ca1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yShearVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultShear]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultShear]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultShear]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5bcd57a8072270da6669bf538c528db37bdb3df357e8831aada4b8b166975a9f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultTrim",
    jsii_struct_bases=[],
    name_mapping={
        "fuzz": "fuzz",
        "fuzz_var": "fuzzVar",
        "padding": "padding",
        "padding_var": "paddingVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultTrim:
    def __init__(
        self,
        *,
        fuzz: typing.Optional[builtins.str] = None,
        fuzz_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fuzz: The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz DataAkamaiImagingPolicyImage#fuzz}
        :param fuzz_var: The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz_var DataAkamaiImagingPolicyImage#fuzz_var}
        :param padding: The amount of padding in pixels to add to the trimmed image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: The amount of padding in pixels to add to the trimmed image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f0e85e509b48354dc6ba00e9f66998b83a3ee947bd3fbf8dee7209b5701be96)
            check_type(argname="argument fuzz", value=fuzz, expected_type=type_hints["fuzz"])
            check_type(argname="argument fuzz_var", value=fuzz_var, expected_type=type_hints["fuzz_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fuzz is not None:
            self._values["fuzz"] = fuzz
        if fuzz_var is not None:
            self._values["fuzz_var"] = fuzz_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var

    @builtins.property
    def fuzz(self) -> typing.Optional[builtins.str]:
        '''The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz DataAkamaiImagingPolicyImage#fuzz}
        '''
        result = self._values.get("fuzz")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fuzz_var(self) -> typing.Optional[builtins.str]:
        '''The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz_var DataAkamaiImagingPolicyImage#fuzz_var}
        '''
        result = self._values.get("fuzz_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''The amount of padding in pixels to add to the trimmed image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''The amount of padding in pixels to add to the trimmed image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultTrim(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultTrimList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultTrimList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a62d90858eecaafde05c25199f8a4ccc8d4e9e40830c7eb6e968571136e11c58)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultTrimOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ad62a004803f07efd5f41d0bff14478a43bba8b6020a6fdafdf7a592b849c5c)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultTrimOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__711ce4f3971df5efddf12b6bb092796b653911d15a8a9e21650301c1ce83680c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a4940a0bcfb9f51ef7df736c8134efd42547d5b167c19dc0ba787c8618a7f559)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ea4a0823736d629f67e7181639bf1358aeaf3069aa48b1aa0b21d027cdd3244)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultTrim]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultTrim]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultTrim]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7c6035e99cad1485b5c45db0372b1fcd376b5705310027d13fb6daa1445d2b67)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultTrimOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultTrimOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f8ad91929435a1b50a739eb583fa9ecb2a6d9b46876e92a145cc12187a735958)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetFuzz")
    def reset_fuzz(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFuzz", []))

    @jsii.member(jsii_name="resetFuzzVar")
    def reset_fuzz_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFuzzVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @builtins.property
    @jsii.member(jsii_name="fuzzInput")
    def fuzz_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fuzzInput"))

    @builtins.property
    @jsii.member(jsii_name="fuzzVarInput")
    def fuzz_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fuzzVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="fuzz")
    def fuzz(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fuzz"))

    @fuzz.setter
    def fuzz(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c44d9ed4b3b95f1b0490bf81bfb9e1b1963967722ff5fe9e319af977ae1a53a5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fuzz", value)

    @builtins.property
    @jsii.member(jsii_name="fuzzVar")
    def fuzz_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fuzzVar"))

    @fuzz_var.setter
    def fuzz_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__19095fd3b62bfbbd4aa1df0130d42ef741ff651ffd6276e5f90d577aa1973db4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fuzzVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a130a2ed77ccf584ed47dbb519574f7e472337f930e9d0980c1e66de4481d34)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d5f6e0aab5d5c1e5550f4d7e6c458671710acd8d2f40d5f8c414eae00e864320)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultTrim]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultTrim]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultTrim]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8c3743e77901d8852c130acf8be5580fa432cd014ba77c7c089c664c717e59e2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultUnsharpMask",
    jsii_struct_bases=[],
    name_mapping={
        "gain": "gain",
        "gain_var": "gainVar",
        "sigma": "sigma",
        "sigma_var": "sigmaVar",
        "threshold": "threshold",
        "threshold_var": "thresholdVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultUnsharpMask:
    def __init__(
        self,
        *,
        gain: typing.Optional[builtins.str] = None,
        gain_var: typing.Optional[builtins.str] = None,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
        threshold: typing.Optional[builtins.str] = None,
        threshold_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param gain: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        :param gain_var: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        :param sigma: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        :param threshold: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        :param threshold_var: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a30273d26b87c52886a1d054cb82b1f86a8f27542b46e6a8534acbc1aa2b0a73)
            check_type(argname="argument gain", value=gain, expected_type=type_hints["gain"])
            check_type(argname="argument gain_var", value=gain_var, expected_type=type_hints["gain_var"])
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
            check_type(argname="argument threshold", value=threshold, expected_type=type_hints["threshold"])
            check_type(argname="argument threshold_var", value=threshold_var, expected_type=type_hints["threshold_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if gain is not None:
            self._values["gain"] = gain
        if gain_var is not None:
            self._values["gain_var"] = gain_var
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var
        if threshold is not None:
            self._values["threshold"] = threshold
        if threshold_var is not None:
            self._values["threshold_var"] = threshold_var

    @builtins.property
    def gain(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        '''
        result = self._values.get("gain")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gain_var(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        '''
        result = self._values.get("gain_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        '''
        result = self._values.get("threshold")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold_var(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        result = self._values.get("threshold_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultUnsharpMask(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultUnsharpMaskList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultUnsharpMaskList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6b1e4f84bcdb86377df2cf2824a120b102ab50850ce097d1d198322fd31a88f4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultUnsharpMaskOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5eb1576e505767ee56ad5876061154413073421e367403f8833e07a46665ec52)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultUnsharpMaskOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c0eab2ae383c57c592f2c05fccb0f5f68f7310e5626e6b7e7339b78273911ac7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c7d2b80f882bda1f836d59143501cde3baac80b981c64e49f82d1fde5f6eaa61)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__51f450665a1509f312ced16b17a1defe1340c2725611ebb00df9e1bf3c20fc65)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultUnsharpMask]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultUnsharpMask]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultUnsharpMask]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ed12a34254dbc38e510e4a949bfc62308f02b25114e80f30e1e75b5da04b0abf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultUnsharpMaskOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultUnsharpMaskOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a9f6eb0c79c93829000724caef77a9e54c7f3d95d22c1ea157f86b1092f4dc8c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetGain")
    def reset_gain(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGain", []))

    @jsii.member(jsii_name="resetGainVar")
    def reset_gain_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGainVar", []))

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @jsii.member(jsii_name="resetThreshold")
    def reset_threshold(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThreshold", []))

    @jsii.member(jsii_name="resetThresholdVar")
    def reset_threshold_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThresholdVar", []))

    @builtins.property
    @jsii.member(jsii_name="gainInput")
    def gain_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainInput"))

    @builtins.property
    @jsii.member(jsii_name="gainVarInput")
    def gain_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdInput")
    def threshold_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdVarInput")
    def threshold_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gain")
    def gain(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gain"))

    @gain.setter
    def gain(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__31aa50287e586f61f805e00648498503ebb465a95da6d1e9e934f3e89bbd8665)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gain", value)

    @builtins.property
    @jsii.member(jsii_name="gainVar")
    def gain_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gainVar"))

    @gain_var.setter
    def gain_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aef530c3e845b88c29281e4e4d1d9d71936e35d3e8f55c950d67abd33d3707b9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gainVar", value)

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__05c650e55335ed007283305e2bbae2deb7136dde047096b232019f8122c1884f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1bee169209e66adae64943bcce6bb768f3acf0326d5eed1a87cad722f2970ace)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="threshold")
    def threshold(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "threshold"))

    @threshold.setter
    def threshold(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3047f32cb1e227cd5cce4fd4261ecef489f2d61e3298d0dc7cc95179ec6c5da5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "threshold", value)

    @builtins.property
    @jsii.member(jsii_name="thresholdVar")
    def threshold_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "thresholdVar"))

    @threshold_var.setter
    def threshold_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d7d4b439b95db6d61a6e1d6e27b57a5f96e813280635e826d23fef0752a5984a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "thresholdVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultUnsharpMask]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultUnsharpMask]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultUnsharpMask]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__76797bb16d2c5fa1cd931f7b118263d66f0ee7e02c61f6cb6f6a4505d09209d4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscape",
    jsii_struct_bases=[],
    name_mapping={
        "append": "append",
        "aspect_crop": "aspectCrop",
        "background_color": "backgroundColor",
        "blur": "blur",
        "chroma_key": "chromaKey",
        "composite": "composite",
        "compound": "compound",
        "contrast": "contrast",
        "crop": "crop",
        "face_crop": "faceCrop",
        "feature_crop": "featureCrop",
        "fit_and_fill": "fitAndFill",
        "goop": "goop",
        "grayscale": "grayscale",
        "hsl": "hsl",
        "hsv": "hsv",
        "if_dimension": "ifDimension",
        "if_orientation": "ifOrientation",
        "im_query": "imQuery",
        "max_colors": "maxColors",
        "mirror": "mirror",
        "mono_hue": "monoHue",
        "opacity": "opacity",
        "region_of_interest_crop": "regionOfInterestCrop",
        "relative_crop": "relativeCrop",
        "remove_color": "removeColor",
        "resize": "resize",
        "rotate": "rotate",
        "scale": "scale",
        "shear": "shear",
        "trim": "trim",
        "unsharp_mask": "unsharpMask",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscape:
    def __init__(
        self,
        *,
        append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppend", typing.Dict[builtins.str, typing.Any]]]]] = None,
        aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAspectCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeBackgroundColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeBlur", typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeChromaKey", typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeComposite", typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompound", typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeContrast", typing.Dict[builtins.str, typing.Any]]]]] = None,
        crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFaceCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFeatureCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFill", typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeGoop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeGrayscale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeHsl", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeHsv", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimension", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
        im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeImQuery", typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeMaxColors", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeMirror", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeMonoHue", typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeOpacity", typing.Dict[builtins.str, typing.Any]]]]] = None,
        region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRelativeCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRemoveColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeResize", typing.Dict[builtins.str, typing.Any]]]]] = None,
        rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRotate", typing.Dict[builtins.str, typing.Any]]]]] = None,
        scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeScale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeShear", typing.Dict[builtins.str, typing.Any]]]]] = None,
        trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeTrim", typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeUnsharpMask", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param append: append block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        :param aspect_crop: aspect_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param crop: crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        :param face_crop: face_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        :param feature_crop: feature_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        :param fit_and_fill: fit_and_fill block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param im_query: im_query block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param region_of_interest_crop: region_of_interest_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        :param relative_crop: relative_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param resize: resize block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        :param rotate: rotate block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        :param scale: scale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param shear: shear block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        :param trim: trim block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c789e8d3960e7772d852aaff1d2ecd7af25e4609b5d4a3a9880e2f0cdaed7ee2)
            check_type(argname="argument append", value=append, expected_type=type_hints["append"])
            check_type(argname="argument aspect_crop", value=aspect_crop, expected_type=type_hints["aspect_crop"])
            check_type(argname="argument background_color", value=background_color, expected_type=type_hints["background_color"])
            check_type(argname="argument blur", value=blur, expected_type=type_hints["blur"])
            check_type(argname="argument chroma_key", value=chroma_key, expected_type=type_hints["chroma_key"])
            check_type(argname="argument composite", value=composite, expected_type=type_hints["composite"])
            check_type(argname="argument compound", value=compound, expected_type=type_hints["compound"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument crop", value=crop, expected_type=type_hints["crop"])
            check_type(argname="argument face_crop", value=face_crop, expected_type=type_hints["face_crop"])
            check_type(argname="argument feature_crop", value=feature_crop, expected_type=type_hints["feature_crop"])
            check_type(argname="argument fit_and_fill", value=fit_and_fill, expected_type=type_hints["fit_and_fill"])
            check_type(argname="argument goop", value=goop, expected_type=type_hints["goop"])
            check_type(argname="argument grayscale", value=grayscale, expected_type=type_hints["grayscale"])
            check_type(argname="argument hsl", value=hsl, expected_type=type_hints["hsl"])
            check_type(argname="argument hsv", value=hsv, expected_type=type_hints["hsv"])
            check_type(argname="argument if_dimension", value=if_dimension, expected_type=type_hints["if_dimension"])
            check_type(argname="argument if_orientation", value=if_orientation, expected_type=type_hints["if_orientation"])
            check_type(argname="argument im_query", value=im_query, expected_type=type_hints["im_query"])
            check_type(argname="argument max_colors", value=max_colors, expected_type=type_hints["max_colors"])
            check_type(argname="argument mirror", value=mirror, expected_type=type_hints["mirror"])
            check_type(argname="argument mono_hue", value=mono_hue, expected_type=type_hints["mono_hue"])
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument region_of_interest_crop", value=region_of_interest_crop, expected_type=type_hints["region_of_interest_crop"])
            check_type(argname="argument relative_crop", value=relative_crop, expected_type=type_hints["relative_crop"])
            check_type(argname="argument remove_color", value=remove_color, expected_type=type_hints["remove_color"])
            check_type(argname="argument resize", value=resize, expected_type=type_hints["resize"])
            check_type(argname="argument rotate", value=rotate, expected_type=type_hints["rotate"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument shear", value=shear, expected_type=type_hints["shear"])
            check_type(argname="argument trim", value=trim, expected_type=type_hints["trim"])
            check_type(argname="argument unsharp_mask", value=unsharp_mask, expected_type=type_hints["unsharp_mask"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if append is not None:
            self._values["append"] = append
        if aspect_crop is not None:
            self._values["aspect_crop"] = aspect_crop
        if background_color is not None:
            self._values["background_color"] = background_color
        if blur is not None:
            self._values["blur"] = blur
        if chroma_key is not None:
            self._values["chroma_key"] = chroma_key
        if composite is not None:
            self._values["composite"] = composite
        if compound is not None:
            self._values["compound"] = compound
        if contrast is not None:
            self._values["contrast"] = contrast
        if crop is not None:
            self._values["crop"] = crop
        if face_crop is not None:
            self._values["face_crop"] = face_crop
        if feature_crop is not None:
            self._values["feature_crop"] = feature_crop
        if fit_and_fill is not None:
            self._values["fit_and_fill"] = fit_and_fill
        if goop is not None:
            self._values["goop"] = goop
        if grayscale is not None:
            self._values["grayscale"] = grayscale
        if hsl is not None:
            self._values["hsl"] = hsl
        if hsv is not None:
            self._values["hsv"] = hsv
        if if_dimension is not None:
            self._values["if_dimension"] = if_dimension
        if if_orientation is not None:
            self._values["if_orientation"] = if_orientation
        if im_query is not None:
            self._values["im_query"] = im_query
        if max_colors is not None:
            self._values["max_colors"] = max_colors
        if mirror is not None:
            self._values["mirror"] = mirror
        if mono_hue is not None:
            self._values["mono_hue"] = mono_hue
        if opacity is not None:
            self._values["opacity"] = opacity
        if region_of_interest_crop is not None:
            self._values["region_of_interest_crop"] = region_of_interest_crop
        if relative_crop is not None:
            self._values["relative_crop"] = relative_crop
        if remove_color is not None:
            self._values["remove_color"] = remove_color
        if resize is not None:
            self._values["resize"] = resize
        if rotate is not None:
            self._values["rotate"] = rotate
        if scale is not None:
            self._values["scale"] = scale
        if shear is not None:
            self._values["shear"] = shear
        if trim is not None:
            self._values["trim"] = trim
        if unsharp_mask is not None:
            self._values["unsharp_mask"] = unsharp_mask

    @builtins.property
    def append(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppend"]]]:
        '''append block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        '''
        result = self._values.get("append")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppend"]]], result)

    @builtins.property
    def aspect_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAspectCrop"]]]:
        '''aspect_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        '''
        result = self._values.get("aspect_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAspectCrop"]]], result)

    @builtins.property
    def background_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeBackgroundColor"]]]:
        '''background_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        '''
        result = self._values.get("background_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeBackgroundColor"]]], result)

    @builtins.property
    def blur(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeBlur"]]]:
        '''blur block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        '''
        result = self._values.get("blur")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeBlur"]]], result)

    @builtins.property
    def chroma_key(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeChromaKey"]]]:
        '''chroma_key block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        '''
        result = self._values.get("chroma_key")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeChromaKey"]]], result)

    @builtins.property
    def composite(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeComposite"]]]:
        '''composite block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        '''
        result = self._values.get("composite")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeComposite"]]], result)

    @builtins.property
    def compound(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompound"]]]:
        '''compound block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        '''
        result = self._values.get("compound")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompound"]]], result)

    @builtins.property
    def contrast(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeContrast"]]]:
        '''contrast block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeContrast"]]], result)

    @builtins.property
    def crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCrop"]]]:
        '''crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        '''
        result = self._values.get("crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCrop"]]], result)

    @builtins.property
    def face_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFaceCrop"]]]:
        '''face_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        '''
        result = self._values.get("face_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFaceCrop"]]], result)

    @builtins.property
    def feature_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFeatureCrop"]]]:
        '''feature_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        '''
        result = self._values.get("feature_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFeatureCrop"]]], result)

    @builtins.property
    def fit_and_fill(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFill"]]]:
        '''fit_and_fill block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        '''
        result = self._values.get("fit_and_fill")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFill"]]], result)

    @builtins.property
    def goop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeGoop"]]]:
        '''goop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        '''
        result = self._values.get("goop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeGoop"]]], result)

    @builtins.property
    def grayscale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeGrayscale"]]]:
        '''grayscale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        '''
        result = self._values.get("grayscale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeGrayscale"]]], result)

    @builtins.property
    def hsl(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeHsl"]]]:
        '''hsl block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        '''
        result = self._values.get("hsl")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeHsl"]]], result)

    @builtins.property
    def hsv(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeHsv"]]]:
        '''hsv block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        '''
        result = self._values.get("hsv")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeHsv"]]], result)

    @builtins.property
    def if_dimension(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimension"]]]:
        '''if_dimension block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        '''
        result = self._values.get("if_dimension")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimension"]]], result)

    @builtins.property
    def if_orientation(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientation]]]:
        '''if_orientation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        '''
        result = self._values.get("if_orientation")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientation]]], result)

    @builtins.property
    def im_query(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeImQuery"]]]:
        '''im_query block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        '''
        result = self._values.get("im_query")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeImQuery"]]], result)

    @builtins.property
    def max_colors(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeMaxColors"]]]:
        '''max_colors block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        '''
        result = self._values.get("max_colors")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeMaxColors"]]], result)

    @builtins.property
    def mirror(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeMirror"]]]:
        '''mirror block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        '''
        result = self._values.get("mirror")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeMirror"]]], result)

    @builtins.property
    def mono_hue(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeMonoHue"]]]:
        '''mono_hue block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        '''
        result = self._values.get("mono_hue")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeMonoHue"]]], result)

    @builtins.property
    def opacity(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeOpacity"]]]:
        '''opacity block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeOpacity"]]], result)

    @builtins.property
    def region_of_interest_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCrop"]]]:
        '''region_of_interest_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        '''
        result = self._values.get("region_of_interest_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCrop"]]], result)

    @builtins.property
    def relative_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRelativeCrop"]]]:
        '''relative_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        '''
        result = self._values.get("relative_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRelativeCrop"]]], result)

    @builtins.property
    def remove_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRemoveColor"]]]:
        '''remove_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        '''
        result = self._values.get("remove_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRemoveColor"]]], result)

    @builtins.property
    def resize(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeResize"]]]:
        '''resize block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        '''
        result = self._values.get("resize")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeResize"]]], result)

    @builtins.property
    def rotate(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRotate"]]]:
        '''rotate block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        '''
        result = self._values.get("rotate")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRotate"]]], result)

    @builtins.property
    def scale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeScale"]]]:
        '''scale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeScale"]]], result)

    @builtins.property
    def shear(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeShear"]]]:
        '''shear block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        '''
        result = self._values.get("shear")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeShear"]]], result)

    @builtins.property
    def trim(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeTrim"]]]:
        '''trim block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        '''
        result = self._values.get("trim")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeTrim"]]], result)

    @builtins.property
    def unsharp_mask(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeUnsharpMask"]]]:
        '''unsharp_mask block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        result = self._values.get("unsharp_mask")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeUnsharpMask"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscape(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppend",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_priority": "gravityPriority",
        "gravity_priority_var": "gravityPriorityVar",
        "gravity_var": "gravityVar",
        "preserve_minor_dimension": "preserveMinorDimension",
        "preserve_minor_dimension_var": "preserveMinorDimensionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppend:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_priority: typing.Optional[builtins.str] = None,
        gravity_priority_var: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        preserve_minor_dimension: typing.Optional[builtins.str] = None,
        preserve_minor_dimension_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Specifies where to place the ``image`` relative to the source image. The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_priority: Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal. The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority DataAkamaiImagingPolicyImage#gravity_priority}
        :param gravity_priority_var: Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal. The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority_var DataAkamaiImagingPolicyImage#gravity_priority_var}
        :param gravity_var: Specifies where to place the ``image`` relative to the source image. The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param preserve_minor_dimension: Whether to preserve the source image's minor dimension, ``false`` by default. The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension DataAkamaiImagingPolicyImage#preserve_minor_dimension}
        :param preserve_minor_dimension_var: Whether to preserve the source image's minor dimension, ``false`` by default. The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension_var DataAkamaiImagingPolicyImage#preserve_minor_dimension_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9c3c21db7f0fb94e19bf546c2f3a484869c7b533b1be1f212875ea3fb856a7d0)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_priority", value=gravity_priority, expected_type=type_hints["gravity_priority"])
            check_type(argname="argument gravity_priority_var", value=gravity_priority_var, expected_type=type_hints["gravity_priority_var"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument preserve_minor_dimension", value=preserve_minor_dimension, expected_type=type_hints["preserve_minor_dimension"])
            check_type(argname="argument preserve_minor_dimension_var", value=preserve_minor_dimension_var, expected_type=type_hints["preserve_minor_dimension_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_priority is not None:
            self._values["gravity_priority"] = gravity_priority
        if gravity_priority_var is not None:
            self._values["gravity_priority_var"] = gravity_priority_var
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if preserve_minor_dimension is not None:
            self._values["preserve_minor_dimension"] = preserve_minor_dimension
        if preserve_minor_dimension_var is not None:
            self._values["preserve_minor_dimension_var"] = preserve_minor_dimension_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Specifies where to place the ``image`` relative to the source image.

        The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_priority(self) -> typing.Optional[builtins.str]:
        '''Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal.

        The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority DataAkamaiImagingPolicyImage#gravity_priority}
        '''
        result = self._values.get("gravity_priority")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_priority_var(self) -> typing.Optional[builtins.str]:
        '''Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal.

        The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority_var DataAkamaiImagingPolicyImage#gravity_priority_var}
        '''
        result = self._values.get("gravity_priority_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Specifies where to place the ``image`` relative to the source image.

        The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def preserve_minor_dimension(self) -> typing.Optional[builtins.str]:
        '''Whether to preserve the source image's minor dimension, ``false`` by default.

        The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension DataAkamaiImagingPolicyImage#preserve_minor_dimension}
        '''
        result = self._values.get("preserve_minor_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def preserve_minor_dimension_var(self) -> typing.Optional[builtins.str]:
        '''Whether to preserve the source image's minor dimension, ``false`` by default.

        The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension_var DataAkamaiImagingPolicyImage#preserve_minor_dimension_var}
        '''
        result = self._values.get("preserve_minor_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppend(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImage",
    jsii_struct_bases=[],
    name_mapping={
        "box_image": "boxImage",
        "circle_image": "circleImage",
        "text_image": "textImage",
        "url_image": "urlImage",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImage:
    def __init__(
        self,
        *,
        box_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageBoxImage", typing.Dict[builtins.str, typing.Any]]]]] = None,
        circle_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageCircleImage", typing.Dict[builtins.str, typing.Any]]]]] = None,
        text_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageTextImage", typing.Dict[builtins.str, typing.Any]]]]] = None,
        url_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageUrlImage", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param box_image: box_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#box_image DataAkamaiImagingPolicyImage#box_image}
        :param circle_image: circle_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#circle_image DataAkamaiImagingPolicyImage#circle_image}
        :param text_image: text_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text_image DataAkamaiImagingPolicyImage#text_image}
        :param url_image: url_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url_image DataAkamaiImagingPolicyImage#url_image}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__138d7cae731a7ca1c530e523c406dd8b0bbdd3b612414175a2e7126737b4abbe)
            check_type(argname="argument box_image", value=box_image, expected_type=type_hints["box_image"])
            check_type(argname="argument circle_image", value=circle_image, expected_type=type_hints["circle_image"])
            check_type(argname="argument text_image", value=text_image, expected_type=type_hints["text_image"])
            check_type(argname="argument url_image", value=url_image, expected_type=type_hints["url_image"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if box_image is not None:
            self._values["box_image"] = box_image
        if circle_image is not None:
            self._values["circle_image"] = circle_image
        if text_image is not None:
            self._values["text_image"] = text_image
        if url_image is not None:
            self._values["url_image"] = url_image

    @builtins.property
    def box_image(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageBoxImage"]]]:
        '''box_image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#box_image DataAkamaiImagingPolicyImage#box_image}
        '''
        result = self._values.get("box_image")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageBoxImage"]]], result)

    @builtins.property
    def circle_image(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageCircleImage"]]]:
        '''circle_image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#circle_image DataAkamaiImagingPolicyImage#circle_image}
        '''
        result = self._values.get("circle_image")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageCircleImage"]]], result)

    @builtins.property
    def text_image(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageTextImage"]]]:
        '''text_image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text_image DataAkamaiImagingPolicyImage#text_image}
        '''
        result = self._values.get("text_image")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageTextImage"]]], result)

    @builtins.property
    def url_image(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageUrlImage"]]]:
        '''url_image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url_image DataAkamaiImagingPolicyImage#url_image}
        '''
        result = self._values.get("url_image")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageUrlImage"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageBoxImage",
    jsii_struct_bases=[],
    name_mapping={
        "color": "color",
        "color_var": "colorVar",
        "height": "height",
        "height_var": "heightVar",
        "transformation": "transformation",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageBoxImage:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        transformation: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageBoxImageTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The fill color of the box, not the edge of the box. The API supports hexadecimal representation and CSS hexadecimal color values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The fill color of the box, not the edge of the box. The API supports hexadecimal representation and CSS hexadecimal color values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        :param height: The height of the box in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height of the box in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param transformation: transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        :param width: The width of the box in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width of the box in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(transformation, dict):
            transformation = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageBoxImageTransformation(**transformation)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e317de903a2045af8d0386e4daf1a1f837b6156f6adc2e5531bd4c432a75a18b)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument transformation", value=transformation, expected_type=type_hints["transformation"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if transformation is not None:
            self._values["transformation"] = transformation
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The fill color of the box, not the edge of the box.

        The API supports hexadecimal representation and CSS hexadecimal color values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The fill color of the box, not the edge of the box.

        The API supports hexadecimal representation and CSS hexadecimal color values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height of the box in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height of the box in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def transformation(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageBoxImageTransformation"]:
        '''transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        '''
        result = self._values.get("transformation")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageBoxImageTransformation"], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width of the box in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width of the box in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageBoxImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageBoxImageList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageBoxImageList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0e4a746c10405c6568022d5d7bb89f20aefbb9c3673d5c6bb4e4886b8c887768)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageBoxImageOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1117185aa751130cee61935a22d0ef880157a6b5e6c2e9f68b3b0ca0df24d25a)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageBoxImageOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b8417251b2a6f2de77e1f7bd786ec29572ffb04dffd17fb97554accec141b1ab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e89711ade664770318e3515a4503da3371d7ae6342da130513cc96b813d161b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__36e8645778a91d5425c475a88b96faa87521cf617194234c85c2682bc0a25ef3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageBoxImage]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageBoxImage]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageBoxImage]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b4457fe5e5dfe54f459d796f5be64f13ca240af533e574b5f2c19498d6075ebd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageBoxImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageBoxImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0d9300912d1de5eeb073991c804d3ff4f48016c8a535f1445cfee5b35aabb0a5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformation")
    def put_transformation(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageBoxImageTransformation()

        return typing.cast(None, jsii.invoke(self, "putTransformation", [value]))

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetTransformation")
    def reset_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformation", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="transformation")
    def transformation(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageBoxImageTransformationOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageBoxImageTransformationOutputReference", jsii.get(self, "transformation"))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="transformationInput")
    def transformation_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageBoxImageTransformation"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageBoxImageTransformation"], jsii.get(self, "transformationInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f99afd7ac2b6e973da60d3e3775c6aeeb4b5af0d6529b003045292487e9f1831)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c6b75522db10fe519db4a426c3e25c707b2195bc49c89a6ce4ddd9f0a5e0230f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d65c8aa5ed1e84814d282456482f388054df9eaf364689eed71e404ba3a429fa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4e102d8daf46b96e5b57546c46e7ebc49ebb649484cfea2772232178fa2a9020)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d55779cbb696aba4c7f403ea02d13cf0da28da58cfb0f8168db6da515adfa2aa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7b7ca934878397a31f18c580ca4f40c3cfbc34d71d10fdf1c745093eae26e5a1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageBoxImage]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageBoxImage]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageBoxImage]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2fce3515faedba2d6e6de9b128ffd68d837603104f7711f4189f0606092d76bd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageBoxImageTransformation",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageBoxImageTransformation:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageBoxImageTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageBoxImageTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageBoxImageTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__529043b8f2484282df1d43a510b63308002de4e019b59a99f09e5ead05fdcbf8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageBoxImageTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageBoxImageTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageBoxImageTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e96d08f4bf62088d5d126399bb645a151c5b3171ce32d0c052102a879122a1b2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageCircleImage",
    jsii_struct_bases=[],
    name_mapping={
        "color": "color",
        "color_var": "colorVar",
        "diameter": "diameter",
        "diameter_var": "diameterVar",
        "transformation": "transformation",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageCircleImage:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
        diameter: typing.Optional[builtins.str] = None,
        diameter_var: typing.Optional[builtins.str] = None,
        transformation: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageCircleImageTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The fill color of the circle. The API supports hexadecimal representation and CSS hexadecimal color values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The fill color of the circle. The API supports hexadecimal representation and CSS hexadecimal color values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        :param diameter: The diameter of the circle. The diameter will be the width and the height of the image in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#diameter DataAkamaiImagingPolicyImage#diameter}
        :param diameter_var: The diameter of the circle. The diameter will be the width and the height of the image in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#diameter_var DataAkamaiImagingPolicyImage#diameter_var}
        :param transformation: transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        :param width: The width of the box in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width of the box in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(transformation, dict):
            transformation = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageCircleImageTransformation(**transformation)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__211dbbf5d9dbc1f430ed43cea894a0239c0b4794abcc90a33097e2bc565a63a0)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
            check_type(argname="argument diameter", value=diameter, expected_type=type_hints["diameter"])
            check_type(argname="argument diameter_var", value=diameter_var, expected_type=type_hints["diameter_var"])
            check_type(argname="argument transformation", value=transformation, expected_type=type_hints["transformation"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var
        if diameter is not None:
            self._values["diameter"] = diameter
        if diameter_var is not None:
            self._values["diameter_var"] = diameter_var
        if transformation is not None:
            self._values["transformation"] = transformation
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The fill color of the circle. The API supports hexadecimal representation and CSS hexadecimal color values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The fill color of the circle. The API supports hexadecimal representation and CSS hexadecimal color values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def diameter(self) -> typing.Optional[builtins.str]:
        '''The diameter of the circle. The diameter will be the width and the height of the image in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#diameter DataAkamaiImagingPolicyImage#diameter}
        '''
        result = self._values.get("diameter")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def diameter_var(self) -> typing.Optional[builtins.str]:
        '''The diameter of the circle. The diameter will be the width and the height of the image in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#diameter_var DataAkamaiImagingPolicyImage#diameter_var}
        '''
        result = self._values.get("diameter_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def transformation(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageCircleImageTransformation"]:
        '''transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        '''
        result = self._values.get("transformation")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageCircleImageTransformation"], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width of the box in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width of the box in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageCircleImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageCircleImageList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageCircleImageList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1658a85b677fd2e8c21e5ea6efd3155795da83fc1f486463c375ea5881a84a0e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageCircleImageOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__73a8f131db3affa896bac41c99e5fd5213fa363cbff6ecee04328c989c3120b4)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageCircleImageOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bbb2e20a679566d6df99c85ccecac88de910bd6ad31f92543b595422675df458)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5b261ed0105bea07c843d09a8684ed5f6a32018a1d216548ef58168d4b5a5de5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__915810c0cde4fd662673edba5dd5804a182dec72a1f417bff6e77490545b5dce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageCircleImage]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageCircleImage]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageCircleImage]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bbe5f1bdfb41c4f7b8f4d80a9417ca64b5e82134c7f0045875dbadf78af10914)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageCircleImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageCircleImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4b170408e258b8f27d93f912fd12755c82ac9e973948f2e08479628f0944efdf)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformation")
    def put_transformation(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageCircleImageTransformation()

        return typing.cast(None, jsii.invoke(self, "putTransformation", [value]))

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @jsii.member(jsii_name="resetDiameter")
    def reset_diameter(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDiameter", []))

    @jsii.member(jsii_name="resetDiameterVar")
    def reset_diameter_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDiameterVar", []))

    @jsii.member(jsii_name="resetTransformation")
    def reset_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformation", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="transformation")
    def transformation(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageCircleImageTransformationOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageCircleImageTransformationOutputReference", jsii.get(self, "transformation"))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="diameterInput")
    def diameter_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "diameterInput"))

    @builtins.property
    @jsii.member(jsii_name="diameterVarInput")
    def diameter_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "diameterVarInput"))

    @builtins.property
    @jsii.member(jsii_name="transformationInput")
    def transformation_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageCircleImageTransformation"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageCircleImageTransformation"], jsii.get(self, "transformationInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b3b790e0627ea008f0361357f6bad0bd0b288fd5eba8cee6d4406f8d329c2b75)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d6ef31f0d5e20c7313d4a85f166e9c5f14eb4748845e5227f0209acfdf45b6b7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="diameter")
    def diameter(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "diameter"))

    @diameter.setter
    def diameter(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__58a8e84ba3465954c1f415c80609971910038ab6515ae6d2e879968ba0775be8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "diameter", value)

    @builtins.property
    @jsii.member(jsii_name="diameterVar")
    def diameter_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "diameterVar"))

    @diameter_var.setter
    def diameter_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a7ea492ba1d2d5e27caf8e4d390f2a09b3863b026901b87acc619ef4000f6c7f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "diameterVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9e950ddb6eea8f3743ebd246ad53825644f02a108f5ddb109901a07227431694)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0e2991638da70bf6ce776a91745e8dc3b3605d261b56c438ce2763c82bc2f113)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageCircleImage]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageCircleImage]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageCircleImage]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__22afee6de61ebf46cc7edb9fc838e55dfdb21df7b85bb977707df775d03bb4dc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageCircleImageTransformation",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageCircleImageTransformation:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageCircleImageTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageCircleImageTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageCircleImageTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8f7227cce100f11d9060a33415c8e00157b8325c8b84f3b4d3b7e9aa3c8a26f6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageCircleImageTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageCircleImageTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageCircleImageTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b2ea794892197600077ccf60d3e42ecfc9091dc4241171725a8b40e536e175c2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__63ef68122b883dd3900a1dadf5dbc2e5119821b286b33cd64ad74c5bd3cd45da)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putBoxImage")
    def put_box_image(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageBoxImage, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__768a90499d8466556654707d5a0a8d701f7f16fb272c4b1df241ba1168158a6d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBoxImage", [value]))

    @jsii.member(jsii_name="putCircleImage")
    def put_circle_image(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageCircleImage, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cabbf37fc746d13f1873faf4bac19f0a5a0ec369d3d351091a9dd2ba79d0d273)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCircleImage", [value]))

    @jsii.member(jsii_name="putTextImage")
    def put_text_image(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageTextImage", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__19ad0214662727653db0fc488a2bfbbaaee364e71d35a72b339404585ca3ce6f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTextImage", [value]))

    @jsii.member(jsii_name="putUrlImage")
    def put_url_image(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageUrlImage", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1081d7fc2f4f4e062f3acf2b62a467ee4ddcf4fba8b8e98b1e819e3d85f7d443)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putUrlImage", [value]))

    @jsii.member(jsii_name="resetBoxImage")
    def reset_box_image(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBoxImage", []))

    @jsii.member(jsii_name="resetCircleImage")
    def reset_circle_image(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCircleImage", []))

    @jsii.member(jsii_name="resetTextImage")
    def reset_text_image(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTextImage", []))

    @jsii.member(jsii_name="resetUrlImage")
    def reset_url_image(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUrlImage", []))

    @builtins.property
    @jsii.member(jsii_name="boxImage")
    def box_image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageBoxImageList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageBoxImageList, jsii.get(self, "boxImage"))

    @builtins.property
    @jsii.member(jsii_name="circleImage")
    def circle_image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageCircleImageList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageCircleImageList, jsii.get(self, "circleImage"))

    @builtins.property
    @jsii.member(jsii_name="textImage")
    def text_image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageTextImageList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageTextImageList", jsii.get(self, "textImage"))

    @builtins.property
    @jsii.member(jsii_name="urlImage")
    def url_image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageUrlImageList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageUrlImageList", jsii.get(self, "urlImage"))

    @builtins.property
    @jsii.member(jsii_name="boxImageInput")
    def box_image_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageBoxImage]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageBoxImage]]], jsii.get(self, "boxImageInput"))

    @builtins.property
    @jsii.member(jsii_name="circleImageInput")
    def circle_image_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageCircleImage]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageCircleImage]]], jsii.get(self, "circleImageInput"))

    @builtins.property
    @jsii.member(jsii_name="textImageInput")
    def text_image_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageTextImage"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageTextImage"]]], jsii.get(self, "textImageInput"))

    @builtins.property
    @jsii.member(jsii_name="urlImageInput")
    def url_image_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageUrlImage"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageUrlImage"]]], jsii.get(self, "urlImageInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cb1ebe06ea82b1d7510ba2ddd9874754fab7b583b8187435c4e08546c977e1c4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageTextImage",
    jsii_struct_bases=[],
    name_mapping={
        "fill": "fill",
        "fill_var": "fillVar",
        "size": "size",
        "size_var": "sizeVar",
        "stroke": "stroke",
        "stroke_size": "strokeSize",
        "stroke_size_var": "strokeSizeVar",
        "stroke_var": "strokeVar",
        "text": "text",
        "text_var": "textVar",
        "transformation": "transformation",
        "typeface": "typeface",
        "typeface_var": "typefaceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageTextImage:
    def __init__(
        self,
        *,
        fill: typing.Optional[builtins.str] = None,
        fill_var: typing.Optional[builtins.str] = None,
        size: typing.Optional[builtins.str] = None,
        size_var: typing.Optional[builtins.str] = None,
        stroke: typing.Optional[builtins.str] = None,
        stroke_size: typing.Optional[builtins.str] = None,
        stroke_size_var: typing.Optional[builtins.str] = None,
        stroke_var: typing.Optional[builtins.str] = None,
        text: typing.Optional[builtins.str] = None,
        text_var: typing.Optional[builtins.str] = None,
        transformation: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageTextImageTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        typeface: typing.Optional[builtins.str] = None,
        typeface_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fill: The main fill color of the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill DataAkamaiImagingPolicyImage#fill}
        :param fill_var: The main fill color of the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_var DataAkamaiImagingPolicyImage#fill_var}
        :param size: The size in pixels to render the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#size DataAkamaiImagingPolicyImage#size}
        :param size_var: The size in pixels to render the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#size_var DataAkamaiImagingPolicyImage#size_var}
        :param stroke: The color for the outline of the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke DataAkamaiImagingPolicyImage#stroke}
        :param stroke_size: The thickness in points for the outline of the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_size DataAkamaiImagingPolicyImage#stroke_size}
        :param stroke_size_var: The thickness in points for the outline of the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_size_var DataAkamaiImagingPolicyImage#stroke_size_var}
        :param stroke_var: The color for the outline of the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_var DataAkamaiImagingPolicyImage#stroke_var}
        :param text: The line of text to render. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text DataAkamaiImagingPolicyImage#text}
        :param text_var: The line of text to render. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text_var DataAkamaiImagingPolicyImage#text_var}
        :param transformation: transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        :param typeface: The font family to apply to the text image. This may be a URL to a TrueType or WOFF (v1) typeface, or a string that refers to one of the standard built-in browser fonts. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#typeface DataAkamaiImagingPolicyImage#typeface}
        :param typeface_var: The font family to apply to the text image. This may be a URL to a TrueType or WOFF (v1) typeface, or a string that refers to one of the standard built-in browser fonts. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#typeface_var DataAkamaiImagingPolicyImage#typeface_var}
        '''
        if isinstance(transformation, dict):
            transformation = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageTextImageTransformation(**transformation)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dd801fe133137d862e621be8fde303f52d71f66256febcb71d242b7808ec6ce7)
            check_type(argname="argument fill", value=fill, expected_type=type_hints["fill"])
            check_type(argname="argument fill_var", value=fill_var, expected_type=type_hints["fill_var"])
            check_type(argname="argument size", value=size, expected_type=type_hints["size"])
            check_type(argname="argument size_var", value=size_var, expected_type=type_hints["size_var"])
            check_type(argname="argument stroke", value=stroke, expected_type=type_hints["stroke"])
            check_type(argname="argument stroke_size", value=stroke_size, expected_type=type_hints["stroke_size"])
            check_type(argname="argument stroke_size_var", value=stroke_size_var, expected_type=type_hints["stroke_size_var"])
            check_type(argname="argument stroke_var", value=stroke_var, expected_type=type_hints["stroke_var"])
            check_type(argname="argument text", value=text, expected_type=type_hints["text"])
            check_type(argname="argument text_var", value=text_var, expected_type=type_hints["text_var"])
            check_type(argname="argument transformation", value=transformation, expected_type=type_hints["transformation"])
            check_type(argname="argument typeface", value=typeface, expected_type=type_hints["typeface"])
            check_type(argname="argument typeface_var", value=typeface_var, expected_type=type_hints["typeface_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fill is not None:
            self._values["fill"] = fill
        if fill_var is not None:
            self._values["fill_var"] = fill_var
        if size is not None:
            self._values["size"] = size
        if size_var is not None:
            self._values["size_var"] = size_var
        if stroke is not None:
            self._values["stroke"] = stroke
        if stroke_size is not None:
            self._values["stroke_size"] = stroke_size
        if stroke_size_var is not None:
            self._values["stroke_size_var"] = stroke_size_var
        if stroke_var is not None:
            self._values["stroke_var"] = stroke_var
        if text is not None:
            self._values["text"] = text
        if text_var is not None:
            self._values["text_var"] = text_var
        if transformation is not None:
            self._values["transformation"] = transformation
        if typeface is not None:
            self._values["typeface"] = typeface
        if typeface_var is not None:
            self._values["typeface_var"] = typeface_var

    @builtins.property
    def fill(self) -> typing.Optional[builtins.str]:
        '''The main fill color of the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill DataAkamaiImagingPolicyImage#fill}
        '''
        result = self._values.get("fill")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fill_var(self) -> typing.Optional[builtins.str]:
        '''The main fill color of the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_var DataAkamaiImagingPolicyImage#fill_var}
        '''
        result = self._values.get("fill_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def size(self) -> typing.Optional[builtins.str]:
        '''The size in pixels to render the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#size DataAkamaiImagingPolicyImage#size}
        '''
        result = self._values.get("size")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def size_var(self) -> typing.Optional[builtins.str]:
        '''The size in pixels to render the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#size_var DataAkamaiImagingPolicyImage#size_var}
        '''
        result = self._values.get("size_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def stroke(self) -> typing.Optional[builtins.str]:
        '''The color for the outline of the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke DataAkamaiImagingPolicyImage#stroke}
        '''
        result = self._values.get("stroke")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def stroke_size(self) -> typing.Optional[builtins.str]:
        '''The thickness in points for the outline of the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_size DataAkamaiImagingPolicyImage#stroke_size}
        '''
        result = self._values.get("stroke_size")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def stroke_size_var(self) -> typing.Optional[builtins.str]:
        '''The thickness in points for the outline of the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_size_var DataAkamaiImagingPolicyImage#stroke_size_var}
        '''
        result = self._values.get("stroke_size_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def stroke_var(self) -> typing.Optional[builtins.str]:
        '''The color for the outline of the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_var DataAkamaiImagingPolicyImage#stroke_var}
        '''
        result = self._values.get("stroke_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def text(self) -> typing.Optional[builtins.str]:
        '''The line of text to render.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text DataAkamaiImagingPolicyImage#text}
        '''
        result = self._values.get("text")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def text_var(self) -> typing.Optional[builtins.str]:
        '''The line of text to render.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text_var DataAkamaiImagingPolicyImage#text_var}
        '''
        result = self._values.get("text_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def transformation(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageTextImageTransformation"]:
        '''transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        '''
        result = self._values.get("transformation")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageTextImageTransformation"], result)

    @builtins.property
    def typeface(self) -> typing.Optional[builtins.str]:
        '''The font family to apply to the text image.

        This may be a URL to a TrueType or WOFF (v1) typeface, or a string that refers to one of the standard built-in browser fonts.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#typeface DataAkamaiImagingPolicyImage#typeface}
        '''
        result = self._values.get("typeface")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def typeface_var(self) -> typing.Optional[builtins.str]:
        '''The font family to apply to the text image.

        This may be a URL to a TrueType or WOFF (v1) typeface, or a string that refers to one of the standard built-in browser fonts.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#typeface_var DataAkamaiImagingPolicyImage#typeface_var}
        '''
        result = self._values.get("typeface_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageTextImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageTextImageList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageTextImageList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__717953a89ec7d70cc6ef67c64aa64f2882726ff50c8ec741c504b34e0cd99825)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageTextImageOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__91b7cd649b8668126d166ac65c02c25046d548b086ea19f393eb25e1dbd53f2f)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageTextImageOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__007cd8ebe0c39afc05651488dd1df3f32198bede22754d18a23eb26295f1e725)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c2bacb0b85f510812e6536dea772125cf2b435e82a99583f0dc45d014084ac34)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__507c5146721772bd0086dc4de0a9b0fa40d2a9512fa10d3fc9a00998c999f46c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageTextImage]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageTextImage]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageTextImage]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c676e199cdac5a7eee7af50473e64863e0b8b252273c22cc40c4902d2201c122)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageTextImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageTextImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__22e2d54afdc2ab6433bb765ea3d8999d483f8c8438efd2ed422089d44e918fc9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformation")
    def put_transformation(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageTextImageTransformation()

        return typing.cast(None, jsii.invoke(self, "putTransformation", [value]))

    @jsii.member(jsii_name="resetFill")
    def reset_fill(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFill", []))

    @jsii.member(jsii_name="resetFillVar")
    def reset_fill_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFillVar", []))

    @jsii.member(jsii_name="resetSize")
    def reset_size(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSize", []))

    @jsii.member(jsii_name="resetSizeVar")
    def reset_size_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSizeVar", []))

    @jsii.member(jsii_name="resetStroke")
    def reset_stroke(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStroke", []))

    @jsii.member(jsii_name="resetStrokeSize")
    def reset_stroke_size(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStrokeSize", []))

    @jsii.member(jsii_name="resetStrokeSizeVar")
    def reset_stroke_size_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStrokeSizeVar", []))

    @jsii.member(jsii_name="resetStrokeVar")
    def reset_stroke_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStrokeVar", []))

    @jsii.member(jsii_name="resetText")
    def reset_text(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetText", []))

    @jsii.member(jsii_name="resetTextVar")
    def reset_text_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTextVar", []))

    @jsii.member(jsii_name="resetTransformation")
    def reset_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformation", []))

    @jsii.member(jsii_name="resetTypeface")
    def reset_typeface(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeface", []))

    @jsii.member(jsii_name="resetTypefaceVar")
    def reset_typeface_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypefaceVar", []))

    @builtins.property
    @jsii.member(jsii_name="transformation")
    def transformation(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageTextImageTransformationOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageTextImageTransformationOutputReference", jsii.get(self, "transformation"))

    @builtins.property
    @jsii.member(jsii_name="fillInput")
    def fill_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fillInput"))

    @builtins.property
    @jsii.member(jsii_name="fillVarInput")
    def fill_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fillVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sizeInput")
    def size_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sizeInput"))

    @builtins.property
    @jsii.member(jsii_name="sizeVarInput")
    def size_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sizeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="strokeInput")
    def stroke_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "strokeInput"))

    @builtins.property
    @jsii.member(jsii_name="strokeSizeInput")
    def stroke_size_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "strokeSizeInput"))

    @builtins.property
    @jsii.member(jsii_name="strokeSizeVarInput")
    def stroke_size_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "strokeSizeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="strokeVarInput")
    def stroke_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "strokeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="textInput")
    def text_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "textInput"))

    @builtins.property
    @jsii.member(jsii_name="textVarInput")
    def text_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "textVarInput"))

    @builtins.property
    @jsii.member(jsii_name="transformationInput")
    def transformation_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageTextImageTransformation"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageTextImageTransformation"], jsii.get(self, "transformationInput"))

    @builtins.property
    @jsii.member(jsii_name="typefaceInput")
    def typeface_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typefaceInput"))

    @builtins.property
    @jsii.member(jsii_name="typefaceVarInput")
    def typeface_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typefaceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="fill")
    def fill(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fill"))

    @fill.setter
    def fill(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b04877b204125cd508cf06608f28cc6a7b372e919b3f0f3eea2a8739611534d6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fill", value)

    @builtins.property
    @jsii.member(jsii_name="fillVar")
    def fill_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fillVar"))

    @fill_var.setter
    def fill_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__37a3015fdbb61323697b6664b43548f19113911ed94d8af565f8bc281baeda1b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fillVar", value)

    @builtins.property
    @jsii.member(jsii_name="size")
    def size(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "size"))

    @size.setter
    def size(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7628eaa8e2b2a569c56e1d273949a95ff3805023b8825a5dee316fc6e3540056)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "size", value)

    @builtins.property
    @jsii.member(jsii_name="sizeVar")
    def size_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sizeVar"))

    @size_var.setter
    def size_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2e6e5da695ff2455444269b5c5b1d6dd9278c27ee8a83dc079d33b4abc40efd8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sizeVar", value)

    @builtins.property
    @jsii.member(jsii_name="stroke")
    def stroke(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "stroke"))

    @stroke.setter
    def stroke(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__98384c72914dc5ef67d6af6d3aaf4c91e102f8c0ea5d3d3b08b5cba0195bacd6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "stroke", value)

    @builtins.property
    @jsii.member(jsii_name="strokeSize")
    def stroke_size(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "strokeSize"))

    @stroke_size.setter
    def stroke_size(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fe60bc2b6039fa21012f39d5f9cac789c385b7ea8ee49de0a1a7e7f791437abf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "strokeSize", value)

    @builtins.property
    @jsii.member(jsii_name="strokeSizeVar")
    def stroke_size_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "strokeSizeVar"))

    @stroke_size_var.setter
    def stroke_size_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__90723d46e5ac8847b9e9a1c1dbde514e1e381ef62436054c58a36fde22a63a1a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "strokeSizeVar", value)

    @builtins.property
    @jsii.member(jsii_name="strokeVar")
    def stroke_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "strokeVar"))

    @stroke_var.setter
    def stroke_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c4ac2c12ca99f467dfb8ca8d0455adb90c78452cfa32366da17344d2869836ed)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "strokeVar", value)

    @builtins.property
    @jsii.member(jsii_name="text")
    def text(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "text"))

    @text.setter
    def text(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d7bf17e66534e3f7f3a25523cd3b3d18bc5ffb93cbbb405f88fcaa162430406)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "text", value)

    @builtins.property
    @jsii.member(jsii_name="textVar")
    def text_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "textVar"))

    @text_var.setter
    def text_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f53581ee1e8e3636f4599d6ca26d66dcf6d71ead37ea6556cf34df37d925475b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "textVar", value)

    @builtins.property
    @jsii.member(jsii_name="typeface")
    def typeface(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeface"))

    @typeface.setter
    def typeface(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e12731f90de41a216615931aaa9656aebf4dc41df729dbf296e980dc8d7baade)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeface", value)

    @builtins.property
    @jsii.member(jsii_name="typefaceVar")
    def typeface_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typefaceVar"))

    @typeface_var.setter
    def typeface_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cb13f4f6753853f2b321661b00ba292896abce6f99a9a8ce84fbe023f2b1df5f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typefaceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageTextImage]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageTextImage]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageTextImage]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__29280966d38924804ba4cfd21022b16ddfe8248f1e8886e640c7eaedcbe8d9a5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageTextImageTransformation",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageTextImageTransformation:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageTextImageTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageTextImageTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageTextImageTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__44635caeeda840eb4dcae441bc393744db571c13112e9d9d17db7fde726ff1ab)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageTextImageTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageTextImageTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageTextImageTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e248b03ebc2483c899beb66d36994f16100bd2b0b96a2131a29002fa02ab948)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageUrlImage",
    jsii_struct_bases=[],
    name_mapping={
        "transformation": "transformation",
        "url": "url",
        "url_var": "urlVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageUrlImage:
    def __init__(
        self,
        *,
        transformation: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageUrlImageTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        url: typing.Optional[builtins.str] = None,
        url_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param transformation: transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        :param url: The URL of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url DataAkamaiImagingPolicyImage#url}
        :param url_var: The URL of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url_var DataAkamaiImagingPolicyImage#url_var}
        '''
        if isinstance(transformation, dict):
            transformation = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageUrlImageTransformation(**transformation)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__305b74d34a7a4c175f7b79feae90f041226a5b18908e740bfdba70f9e0022d9c)
            check_type(argname="argument transformation", value=transformation, expected_type=type_hints["transformation"])
            check_type(argname="argument url", value=url, expected_type=type_hints["url"])
            check_type(argname="argument url_var", value=url_var, expected_type=type_hints["url_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if transformation is not None:
            self._values["transformation"] = transformation
        if url is not None:
            self._values["url"] = url
        if url_var is not None:
            self._values["url_var"] = url_var

    @builtins.property
    def transformation(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageUrlImageTransformation"]:
        '''transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        '''
        result = self._values.get("transformation")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageUrlImageTransformation"], result)

    @builtins.property
    def url(self) -> typing.Optional[builtins.str]:
        '''The URL of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url DataAkamaiImagingPolicyImage#url}
        '''
        result = self._values.get("url")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def url_var(self) -> typing.Optional[builtins.str]:
        '''The URL of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url_var DataAkamaiImagingPolicyImage#url_var}
        '''
        result = self._values.get("url_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageUrlImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageUrlImageList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageUrlImageList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7edac14ae97f3621e72ee73f74e16adcaf1743d54459d021723a30bbb7fb9ea5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageUrlImageOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3c10e21822bfe4aaaef3514aaad4256888a78030cbf496dc0accb86d270338ea)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageUrlImageOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4e6505390b82b81b719bf45ed4cabd9abd23246616ceeb69ca9d8434664d7434)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__86e705e949fd2851ed7713a60588740c66e2ec5f612da594db03cfc6f2efc21b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__321777786853f4dcdd221b86b7443790090280759654e853bda456607e6e7da0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageUrlImage]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageUrlImage]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageUrlImage]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__60c591ee057657f84415527263f4494efed16a28298be23538f46b8328c0c045)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageUrlImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageUrlImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__059e5f3e7e792f4ccab15e080f2cf1fd27fa374322ade4c4b0058ac4b63b8d47)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformation")
    def put_transformation(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageUrlImageTransformation()

        return typing.cast(None, jsii.invoke(self, "putTransformation", [value]))

    @jsii.member(jsii_name="resetTransformation")
    def reset_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformation", []))

    @jsii.member(jsii_name="resetUrl")
    def reset_url(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUrl", []))

    @jsii.member(jsii_name="resetUrlVar")
    def reset_url_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUrlVar", []))

    @builtins.property
    @jsii.member(jsii_name="transformation")
    def transformation(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageUrlImageTransformationOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageUrlImageTransformationOutputReference", jsii.get(self, "transformation"))

    @builtins.property
    @jsii.member(jsii_name="transformationInput")
    def transformation_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageUrlImageTransformation"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageUrlImageTransformation"], jsii.get(self, "transformationInput"))

    @builtins.property
    @jsii.member(jsii_name="urlInput")
    def url_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "urlInput"))

    @builtins.property
    @jsii.member(jsii_name="urlVarInput")
    def url_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "urlVarInput"))

    @builtins.property
    @jsii.member(jsii_name="url")
    def url(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "url"))

    @url.setter
    def url(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9726a27a9b5f24206ea1a0c0503d2d4708e5868db14704e59c2a6813d16016f2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "url", value)

    @builtins.property
    @jsii.member(jsii_name="urlVar")
    def url_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "urlVar"))

    @url_var.setter
    def url_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a2e1e409d100887dd4426e9edf3dcad07d8035605eb4711c0e355e8f0ad578ce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "urlVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageUrlImage]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageUrlImage]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageUrlImage]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb320934af56ee8f7b4aca76ca072eb4d17c028057b36ab21b1ffc7735fdc3bb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageUrlImageTransformation",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageUrlImageTransformation:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageUrlImageTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageUrlImageTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageUrlImageTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9eb7ebaf91b65b4805f8b72c62108707f25d96b290e0fbba594fb036a8232189)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageUrlImageTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageUrlImageTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageUrlImageTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fe16e836d6f6ef3e1d1ac9878ab1a460c1181ac242091a7e954158218cd19026)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a145f9cdfe1775916735fb341b431e0e5581e446b70c6de214516f01b8eef2a0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8be208cd999864a3a979aeb0785b027a111d1f48e51326e32277bf6db61267b0)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8b5f2e5d73f84c8d00041da7f094ef4f5d3a5d18264f0e0f47b9b7342fa33801)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8c8091e3164ee4ab1ff5eb77cdcffc2279c37c33d2f4fc6628b4559269cb3798)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5e7d4d735a04cb777b9e3c7aa181556b5aea382914a0f6235160a076a8ae0654)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppend]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppend]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppend]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c4e4bf87fe5aea1a1fbbfed6e604b20791590d67bda10b33ca8542a8307f23bc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__948b77b5ab8f8a6bdbbb11ff22bcb1c54bdb3554fc9ab5744c4a9a7ec89bc99a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(
        self,
        *,
        box_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageBoxImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
        circle_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageCircleImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
        text_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageTextImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
        url_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageUrlImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param box_image: box_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#box_image DataAkamaiImagingPolicyImage#box_image}
        :param circle_image: circle_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#circle_image DataAkamaiImagingPolicyImage#circle_image}
        :param text_image: text_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text_image DataAkamaiImagingPolicyImage#text_image}
        :param url_image: url_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url_image DataAkamaiImagingPolicyImage#url_image}
        '''
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImage(
            box_image=box_image,
            circle_image=circle_image,
            text_image=text_image,
            url_image=url_image,
        )

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityPriority")
    def reset_gravity_priority(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityPriority", []))

    @jsii.member(jsii_name="resetGravityPriorityVar")
    def reset_gravity_priority_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityPriorityVar", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPreserveMinorDimension")
    def reset_preserve_minor_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPreserveMinorDimension", []))

    @jsii.member(jsii_name="resetPreserveMinorDimensionVar")
    def reset_preserve_minor_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPreserveMinorDimensionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityInput")
    def gravity_priority_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityPriorityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityVarInput")
    def gravity_priority_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityPriorityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionInput")
    def preserve_minor_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "preserveMinorDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionVarInput")
    def preserve_minor_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "preserveMinorDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__da100d9871ebac1e761c3221ae6ed8e2924bbacd71ad1e4b3eb7c8880c7a90b4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityPriority")
    def gravity_priority(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityPriority"))

    @gravity_priority.setter
    def gravity_priority(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bbaafded85b9de8d78d10f27f80f9462ab3d2459a76baa3d822f7d46df2315e8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityPriority", value)

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityVar")
    def gravity_priority_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityPriorityVar"))

    @gravity_priority_var.setter
    def gravity_priority_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0f4181971938be1646c668c06bf02a899dc662808335d87aa9b17fef089bc4d9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityPriorityVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6397316421e73fe67bbff260be5dc5993452f0b1b4385b5c43ac1f6cab2ec5bf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimension")
    def preserve_minor_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "preserveMinorDimension"))

    @preserve_minor_dimension.setter
    def preserve_minor_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e20d2792542e27a485b6e0d35cdf646b5ced19c53402ad3043a1cb4043f89e20)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "preserveMinorDimension", value)

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionVar")
    def preserve_minor_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "preserveMinorDimensionVar"))

    @preserve_minor_dimension_var.setter
    def preserve_minor_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__79ea90ad41f56fb91ff13566ded23d0210e9d13ce77eafeb2efcb516a32e821d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "preserveMinorDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppend]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppend]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppend]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b12b8556e1ac8b2a119098a4d851f13b5f64fd1a7808646148049fbfd8c12da5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAspectCrop",
    jsii_struct_bases=[],
    name_mapping={
        "allow_expansion": "allowExpansion",
        "allow_expansion_var": "allowExpansionVar",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAspectCrop:
    def __init__(
        self,
        *,
        allow_expansion: typing.Optional[builtins.str] = None,
        allow_expansion_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_expansion: Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image. Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        :param allow_expansion_var: Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image. Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        :param height: The height term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The width term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        :param x_position: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3aa9c77821efba2deea7968e24e910747b30949c1c3c6128232020594197d1e0)
            check_type(argname="argument allow_expansion", value=allow_expansion, expected_type=type_hints["allow_expansion"])
            check_type(argname="argument allow_expansion_var", value=allow_expansion_var, expected_type=type_hints["allow_expansion_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if allow_expansion is not None:
            self._values["allow_expansion"] = allow_expansion
        if allow_expansion_var is not None:
            self._values["allow_expansion_var"] = allow_expansion_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def allow_expansion(self) -> typing.Optional[builtins.str]:
        '''Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image.

        Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        '''
        result = self._values.get("allow_expansion")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def allow_expansion_var(self) -> typing.Optional[builtins.str]:
        '''Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image.

        Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        '''
        result = self._values.get("allow_expansion_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAspectCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAspectCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAspectCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b40688d8cdaac7143644ab8a87e7e19d714ffed65c492ab7b3a3a33ee19ae6e5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAspectCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__545118fb1c2b184a71a66540cae6885ddb80aad4279e657de0fc0da1cc46fb6f)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAspectCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__53697166a46714b5a2967886e437761cd686181dd08bbea934dcc46d9ce7bdbc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f4620f8b2ec13514d48ae8212a9501689094a15ccc8add366227bcc7de3fd7dc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__72bb5b2463639766d4c9da32ee430c08031a6edc7e3b7d306a7db17af5b656c3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAspectCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAspectCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAspectCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__83349da6a0942acdee018505d3908da2d14bcccc6e6304e029818168a900b858)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAspectCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAspectCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__240b8bfffb145937b3e90ca4e3713cc5f90deb1ff4b59bef7b09f28d689f96b5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAllowExpansion")
    def reset_allow_expansion(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansion", []))

    @jsii.member(jsii_name="resetAllowExpansionVar")
    def reset_allow_expansion_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansionVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionInput")
    def allow_expansion_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVarInput")
    def allow_expansion_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansion")
    def allow_expansion(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansion"))

    @allow_expansion.setter
    def allow_expansion(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e19a9bcd7a65f64d07cae63a6ac474f6099230f8d631abbbc33463c4603b578a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansion", value)

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVar")
    def allow_expansion_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansionVar"))

    @allow_expansion_var.setter
    def allow_expansion_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1abd37b2cf21405471e1a03d783a1265fe2747ea553982de6541b374cad6daf7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansionVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d1887e55dda13515c60e77b49bd13f5d8d95c89382d1b66840829badcce717b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5e857f903e5ce28fb63e41e1fa6e4d3c50fc0a7572804e94114aac20292aa48d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9f7d21d5fa6510847fb80776a8a00df90708235bd20a41f815218dc50015f1eb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7512e22de8a0a83d9a5626b79e2b9e9c4582243d494b8bf54f04bfef25a42c29)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__11b547124869b77399d0beaa0027f2f1e376e3c764a9a50437d09965bca05052)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2977639a39722e0b97f2879ee7bd48e67448d06604557707a0ac4b048ad0c508)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e2f97dd57f85089cd4078eb6c09c62b10636b488d1ffa45dd2b5cbf4e2240d9d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4febac126a870f5eac4a1a861392434fd5e9d8925f43fc6021999a984020219a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAspectCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAspectCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAspectCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d253d92bf1edbbd0b0a1906ed64c50c469458c54c9563944f9c1c5ad548947cc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeBackgroundColor",
    jsii_struct_bases=[],
    name_mapping={"color": "color", "color_var": "colorVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeBackgroundColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4445a5b41ec3b9c39dbbf9075614c878708d808103634c6e00a1464c9e1e2ed1)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeBackgroundColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeBackgroundColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeBackgroundColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc343ba06f455a7ba05f5e482706e6e6dc7793047cd67224a1190266b0afb574)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeBackgroundColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5c1b63c827f85de218d0ef371b0fb638401e7ee136be8f0705c1763478d5b84e)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeBackgroundColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a8d1b5288a90653efc88e5fe1fc3fa1521530fc021180a78f4838d60606e054)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__91bee0d4b0cf9e300161c96331ce0fead283a1e00e9e560c457fbd8803e957cc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__db3e00fb6d291028f040d9249a54d1fbf16ebe7febf79b144d2494ab2c92b1d9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeBackgroundColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeBackgroundColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5aef126749268c7eb37f7a57c19c4f75859e253cd4fb0bd6192b19e6e8884dbd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeBackgroundColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeBackgroundColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e8d26ce59afb25434f7c0391c97766833cd68561e0c7347091d449a71de35471)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f5921310dbb1e8503fe938af4ad4e64581e92e3068b58e2bb25da50413ec8d0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8f082c3d88b79c03128de7894e325e3a4156c12f83021c474c7927ce68efaa8b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeBackgroundColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeBackgroundColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeBackgroundColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f30574c7fb98a3c66a8be6da850ccf068b6390970862b850437230f9e140422d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeBlur",
    jsii_struct_bases=[],
    name_mapping={"sigma": "sigma", "sigma_var": "sigmaVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeBlur:
    def __init__(
        self,
        *,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param sigma: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d7c31b66d70d80dde4dd45414fd72473875569aab49cdd9d6803c40e140eec64)
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeBlur(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeBlurList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeBlurList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__86a1a16f12aed0f896cdd4d1d90c15209e248fd24bae575833aca084f53106db)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeBlurOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2b2d8cf22d8ae42056808ad3999acbc5649b74ebff6ab28507ab431723bad078)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeBlurOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3d5681e3218e5ee13b605aa4adf610a8827bb0a61c422f3c5f1d254d33251264)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9138f68a8b1a63656f62899c1672264e66ae8e989a7e6e88655ddd3e1bca2ed8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1814450cf00579ddb0ebf23c2e72823bf8a9c309b63c2b6d8d6a77c546dc8c32)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeBlur]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeBlur]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f955cc811d15e2d0e5f8cf65b35a0f8283ad36248430f15db699a137677ec7e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeBlurOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeBlurOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d0218546fc752cf383d88af31c6ef7e518feac3e5744ec0ca066c2912ff0b56)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__34055bb8799e55603f9765f44fe36f62ba594140e13d387f47640371b78157a9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__edcad0e0d608aeb16d18746d587f63d951c092641494bb77d58faeaf0ba8c59b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeBlur]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeBlur]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeBlur]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f9cd1384c746826a6f399fe611ef1a2ef76de047615ef11947055b87b281872)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeChromaKey",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_feather": "hueFeather",
        "hue_feather_var": "hueFeatherVar",
        "hue_tolerance": "hueTolerance",
        "hue_tolerance_var": "hueToleranceVar",
        "hue_var": "hueVar",
        "lightness_feather": "lightnessFeather",
        "lightness_feather_var": "lightnessFeatherVar",
        "lightness_tolerance": "lightnessTolerance",
        "lightness_tolerance_var": "lightnessToleranceVar",
        "saturation_feather": "saturationFeather",
        "saturation_feather_var": "saturationFeatherVar",
        "saturation_tolerance": "saturationTolerance",
        "saturation_tolerance_var": "saturationToleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeChromaKey:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_feather: typing.Optional[builtins.str] = None,
        hue_feather_var: typing.Optional[builtins.str] = None,
        hue_tolerance: typing.Optional[builtins.str] = None,
        hue_tolerance_var: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness_feather: typing.Optional[builtins.str] = None,
        lightness_feather_var: typing.Optional[builtins.str] = None,
        lightness_tolerance: typing.Optional[builtins.str] = None,
        lightness_tolerance_var: typing.Optional[builtins.str] = None,
        saturation_feather: typing.Optional[builtins.str] = None,
        saturation_feather_var: typing.Optional[builtins.str] = None,
        saturation_tolerance: typing.Optional[builtins.str] = None,
        saturation_tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_feather: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        :param hue_feather_var: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        :param hue_tolerance: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        :param hue_tolerance_var: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        :param hue_var: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness_feather: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        :param lightness_feather_var: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        :param lightness_tolerance: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        :param lightness_tolerance_var: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        :param saturation_feather: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        :param saturation_feather_var: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        :param saturation_tolerance: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        :param saturation_tolerance_var: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bf32c94a5638bdb7dea2e6baff1c70059ad4e247948ce470df56658b74916cc7)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_feather", value=hue_feather, expected_type=type_hints["hue_feather"])
            check_type(argname="argument hue_feather_var", value=hue_feather_var, expected_type=type_hints["hue_feather_var"])
            check_type(argname="argument hue_tolerance", value=hue_tolerance, expected_type=type_hints["hue_tolerance"])
            check_type(argname="argument hue_tolerance_var", value=hue_tolerance_var, expected_type=type_hints["hue_tolerance_var"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness_feather", value=lightness_feather, expected_type=type_hints["lightness_feather"])
            check_type(argname="argument lightness_feather_var", value=lightness_feather_var, expected_type=type_hints["lightness_feather_var"])
            check_type(argname="argument lightness_tolerance", value=lightness_tolerance, expected_type=type_hints["lightness_tolerance"])
            check_type(argname="argument lightness_tolerance_var", value=lightness_tolerance_var, expected_type=type_hints["lightness_tolerance_var"])
            check_type(argname="argument saturation_feather", value=saturation_feather, expected_type=type_hints["saturation_feather"])
            check_type(argname="argument saturation_feather_var", value=saturation_feather_var, expected_type=type_hints["saturation_feather_var"])
            check_type(argname="argument saturation_tolerance", value=saturation_tolerance, expected_type=type_hints["saturation_tolerance"])
            check_type(argname="argument saturation_tolerance_var", value=saturation_tolerance_var, expected_type=type_hints["saturation_tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_feather is not None:
            self._values["hue_feather"] = hue_feather
        if hue_feather_var is not None:
            self._values["hue_feather_var"] = hue_feather_var
        if hue_tolerance is not None:
            self._values["hue_tolerance"] = hue_tolerance
        if hue_tolerance_var is not None:
            self._values["hue_tolerance_var"] = hue_tolerance_var
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness_feather is not None:
            self._values["lightness_feather"] = lightness_feather
        if lightness_feather_var is not None:
            self._values["lightness_feather_var"] = lightness_feather_var
        if lightness_tolerance is not None:
            self._values["lightness_tolerance"] = lightness_tolerance
        if lightness_tolerance_var is not None:
            self._values["lightness_tolerance_var"] = lightness_tolerance_var
        if saturation_feather is not None:
            self._values["saturation_feather"] = saturation_feather
        if saturation_feather_var is not None:
            self._values["saturation_feather_var"] = saturation_feather_var
        if saturation_tolerance is not None:
            self._values["saturation_tolerance"] = saturation_tolerance
        if saturation_tolerance_var is not None:
            self._values["saturation_tolerance_var"] = saturation_tolerance_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        '''
        result = self._values.get("hue_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        '''
        result = self._values.get("hue_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        '''
        result = self._values.get("hue_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        '''
        result = self._values.get("hue_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        '''
        result = self._values.get("lightness_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        '''
        result = self._values.get("lightness_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        '''
        result = self._values.get("lightness_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        '''
        result = self._values.get("lightness_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        '''
        result = self._values.get("saturation_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        '''
        result = self._values.get("saturation_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        '''
        result = self._values.get("saturation_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        result = self._values.get("saturation_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeChromaKey(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeChromaKeyList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeChromaKeyList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a733381e689278f8c6572b2586549367659d1324bae4691e683a09a7318e714d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeChromaKeyOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e5f64acb267e79632329dc7bb72063e1ee677033abb4ec8fa72780d500c0537e)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeChromaKeyOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e7e6048f3a53760230e895997593ddb3402f821dc005b94a746b0775c8592b4e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6421f9f98f28b2ce0ccb5cabdeb8d62158d70fac01da21dbecf479f4831dd3c4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fd470396bdc110edee487f5edd9cea30511d54bb402061886dbbbfcb7fca471d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeChromaKey]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeChromaKey]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a5f304440facd5148bfdaf98d613245759dd46fa4e5abffa452c8c7ae84b045b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeChromaKeyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeChromaKeyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0311471503f3a56ab9b65d63b1e743f2b0e8e5dd9449bb33c0931e0338169df2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueFeather")
    def reset_hue_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeather", []))

    @jsii.member(jsii_name="resetHueFeatherVar")
    def reset_hue_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeatherVar", []))

    @jsii.member(jsii_name="resetHueTolerance")
    def reset_hue_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueTolerance", []))

    @jsii.member(jsii_name="resetHueToleranceVar")
    def reset_hue_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueToleranceVar", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightnessFeather")
    def reset_lightness_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeather", []))

    @jsii.member(jsii_name="resetLightnessFeatherVar")
    def reset_lightness_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeatherVar", []))

    @jsii.member(jsii_name="resetLightnessTolerance")
    def reset_lightness_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessTolerance", []))

    @jsii.member(jsii_name="resetLightnessToleranceVar")
    def reset_lightness_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessToleranceVar", []))

    @jsii.member(jsii_name="resetSaturationFeather")
    def reset_saturation_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeather", []))

    @jsii.member(jsii_name="resetSaturationFeatherVar")
    def reset_saturation_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeatherVar", []))

    @jsii.member(jsii_name="resetSaturationTolerance")
    def reset_saturation_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationTolerance", []))

    @jsii.member(jsii_name="resetSaturationToleranceVar")
    def reset_saturation_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherInput")
    def hue_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVarInput")
    def hue_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceInput")
    def hue_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVarInput")
    def hue_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherInput")
    def lightness_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVarInput")
    def lightness_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceInput")
    def lightness_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVarInput")
    def lightness_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherInput")
    def saturation_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVarInput")
    def saturation_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceInput")
    def saturation_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVarInput")
    def saturation_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__49671c4656d91adb8528e28faf1fa242e7bb225fc3c38c7dcb5f696765182dfc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeather")
    def hue_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeather"))

    @hue_feather.setter
    def hue_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__055a1e47b87fa02195b30a76f13809974e035858764461bc010a08d49c5cfe42)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeather", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVar")
    def hue_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeatherVar"))

    @hue_feather_var.setter
    def hue_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__02ec72950414a1e2d51f1f97389a20d05ad78915657bd65927c5008fe3233661)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueTolerance")
    def hue_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueTolerance"))

    @hue_tolerance.setter
    def hue_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cfcf099b56527c9cb72b99e029599cebb78f2976884be325a6e24b6a0846b110)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVar")
    def hue_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueToleranceVar"))

    @hue_tolerance_var.setter
    def hue_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9f185e8ee2f3f999731c438ea677de8bd6f24f71e909111df3fa59c1d5d0a211)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0782e427ce9bcd54f81d41f8c2bc7a5db62b04153bcf3b57d4ae179fc5b850ba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeather")
    def lightness_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeather"))

    @lightness_feather.setter
    def lightness_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e59207d49339ca0ca2c486138db85955fa848a26b54816a2596342ab2b9144cf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeather", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVar")
    def lightness_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeatherVar"))

    @lightness_feather_var.setter
    def lightness_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__658e15c613db523ac260dcc6b4f4a0c7f365ef054648abc0de03896a62a0990c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessTolerance")
    def lightness_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessTolerance"))

    @lightness_tolerance.setter
    def lightness_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2506e98fd88767e30c221452d8ee2f9852c21b9b2332ce8fb78778ad9ba38874)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVar")
    def lightness_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessToleranceVar"))

    @lightness_tolerance_var.setter
    def lightness_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__83f34cf9872d5a646ab2375f9a3d5c4638a483bd7f1fbeeccbcce39cae9c90ee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeather")
    def saturation_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeather"))

    @saturation_feather.setter
    def saturation_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9e2fe5c7da08fb17fd6fb6284aec666c83c4e4b9305ffc3780a4fcc9212b3203)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeather", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVar")
    def saturation_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeatherVar"))

    @saturation_feather_var.setter
    def saturation_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dc49940bc0a33d5e474033b85f6625b65620c420e5343d87d97a014805c572fc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationTolerance")
    def saturation_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationTolerance"))

    @saturation_tolerance.setter
    def saturation_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e71eff7ac07fc122cede19e021ecb54dd13f36c98c123af286cfca30ec42ae1e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVar")
    def saturation_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationToleranceVar"))

    @saturation_tolerance_var.setter
    def saturation_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__afac040bb70494c2bb82c3e24018dd19d87fc3a85a7382f2a226647ee71cc30c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeChromaKey]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeChromaKey]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeChromaKey]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4bcf83bc83aadb6ee236221355dd0dc6d0d5274f953605127518d757539faadc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeComposite",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "placement": "placement",
        "placement_var": "placementVar",
        "scale": "scale",
        "scale_dimension": "scaleDimension",
        "scale_dimension_var": "scaleDimensionVar",
        "scale_var": "scaleVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeComposite:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        placement: typing.Optional[builtins.str] = None,
        placement_var: typing.Optional[builtins.str] = None,
        scale: typing.Optional[builtins.str] = None,
        scale_dimension: typing.Optional[builtins.str] = None,
        scale_dimension_var: typing.Optional[builtins.str] = None,
        scale_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param placement: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        :param placement_var: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        :param scale: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param scale_dimension: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        :param scale_dimension_var: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        :param scale_var: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        :param x_position: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c270d53f0868f100cb45c92ad68f7dbf70e890367bef53743e4e63a49b9d0878)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument placement", value=placement, expected_type=type_hints["placement"])
            check_type(argname="argument placement_var", value=placement_var, expected_type=type_hints["placement_var"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument scale_dimension", value=scale_dimension, expected_type=type_hints["scale_dimension"])
            check_type(argname="argument scale_dimension_var", value=scale_dimension_var, expected_type=type_hints["scale_dimension_var"])
            check_type(argname="argument scale_var", value=scale_var, expected_type=type_hints["scale_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if placement is not None:
            self._values["placement"] = placement
        if placement_var is not None:
            self._values["placement_var"] = placement_var
        if scale is not None:
            self._values["scale"] = scale
        if scale_dimension is not None:
            self._values["scale_dimension"] = scale_dimension
        if scale_dimension_var is not None:
            self._values["scale_dimension_var"] = scale_dimension_var
        if scale_var is not None:
            self._values["scale_var"] = scale_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        '''
        result = self._values.get("placement")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement_var(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        '''
        result = self._values.get("placement_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        '''
        result = self._values.get("scale_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        '''
        result = self._values.get("scale_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        '''
        result = self._values.get("scale_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeComposite(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImage",
    jsii_struct_bases=[],
    name_mapping={
        "box_image": "boxImage",
        "circle_image": "circleImage",
        "text_image": "textImage",
        "url_image": "urlImage",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImage:
    def __init__(
        self,
        *,
        box_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageBoxImage", typing.Dict[builtins.str, typing.Any]]]]] = None,
        circle_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageCircleImage", typing.Dict[builtins.str, typing.Any]]]]] = None,
        text_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageTextImage", typing.Dict[builtins.str, typing.Any]]]]] = None,
        url_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageUrlImage", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param box_image: box_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#box_image DataAkamaiImagingPolicyImage#box_image}
        :param circle_image: circle_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#circle_image DataAkamaiImagingPolicyImage#circle_image}
        :param text_image: text_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text_image DataAkamaiImagingPolicyImage#text_image}
        :param url_image: url_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url_image DataAkamaiImagingPolicyImage#url_image}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b659221b733eadc78f01ee0da7d8893e7db19b08e2ac4116f595ba0811335836)
            check_type(argname="argument box_image", value=box_image, expected_type=type_hints["box_image"])
            check_type(argname="argument circle_image", value=circle_image, expected_type=type_hints["circle_image"])
            check_type(argname="argument text_image", value=text_image, expected_type=type_hints["text_image"])
            check_type(argname="argument url_image", value=url_image, expected_type=type_hints["url_image"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if box_image is not None:
            self._values["box_image"] = box_image
        if circle_image is not None:
            self._values["circle_image"] = circle_image
        if text_image is not None:
            self._values["text_image"] = text_image
        if url_image is not None:
            self._values["url_image"] = url_image

    @builtins.property
    def box_image(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageBoxImage"]]]:
        '''box_image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#box_image DataAkamaiImagingPolicyImage#box_image}
        '''
        result = self._values.get("box_image")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageBoxImage"]]], result)

    @builtins.property
    def circle_image(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageCircleImage"]]]:
        '''circle_image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#circle_image DataAkamaiImagingPolicyImage#circle_image}
        '''
        result = self._values.get("circle_image")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageCircleImage"]]], result)

    @builtins.property
    def text_image(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageTextImage"]]]:
        '''text_image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text_image DataAkamaiImagingPolicyImage#text_image}
        '''
        result = self._values.get("text_image")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageTextImage"]]], result)

    @builtins.property
    def url_image(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageUrlImage"]]]:
        '''url_image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url_image DataAkamaiImagingPolicyImage#url_image}
        '''
        result = self._values.get("url_image")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageUrlImage"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageBoxImage",
    jsii_struct_bases=[],
    name_mapping={
        "color": "color",
        "color_var": "colorVar",
        "height": "height",
        "height_var": "heightVar",
        "transformation": "transformation",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageBoxImage:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        transformation: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageBoxImageTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The fill color of the box, not the edge of the box. The API supports hexadecimal representation and CSS hexadecimal color values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The fill color of the box, not the edge of the box. The API supports hexadecimal representation and CSS hexadecimal color values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        :param height: The height of the box in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height of the box in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param transformation: transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        :param width: The width of the box in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width of the box in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(transformation, dict):
            transformation = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageBoxImageTransformation(**transformation)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__71dedafba9c5b47fd9eba623e2d7976134f396a3984d04f14137e8edef8a550c)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument transformation", value=transformation, expected_type=type_hints["transformation"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if transformation is not None:
            self._values["transformation"] = transformation
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The fill color of the box, not the edge of the box.

        The API supports hexadecimal representation and CSS hexadecimal color values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The fill color of the box, not the edge of the box.

        The API supports hexadecimal representation and CSS hexadecimal color values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height of the box in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height of the box in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def transformation(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageBoxImageTransformation"]:
        '''transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        '''
        result = self._values.get("transformation")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageBoxImageTransformation"], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width of the box in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width of the box in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageBoxImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageBoxImageList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageBoxImageList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7791a5d00d13c96ba8bbb8ad939dfd864cb3427b2e549d18bf373eb6b3bf2d97)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageBoxImageOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1326836e024ad3fead55846359f3ceeb0b0d4fad5b94a482afa3e4e68bd92e5f)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageBoxImageOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__10db5f0f470016475aa1eaa4896dadcd680de0597651a1c8f92fa47fe73598dd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__de8038e305661dce266551f00343d4ca8d7f3ccdedf39302a877af6ffd94f8ee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b8e2aae20f293d4d897b4e20910f6e000f5fd29e4f66bbe5fd047c5bd8c79f4c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageBoxImage]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageBoxImage]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageBoxImage]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c4c90411abc4791b12a56d1f914d6b630dc6fa846f0472a9ea8cf1e5ca0b945c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageBoxImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageBoxImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ec476633822d3cf245b03348df1929f1828248cc1740419fd08736795dcfc43)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformation")
    def put_transformation(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageBoxImageTransformation()

        return typing.cast(None, jsii.invoke(self, "putTransformation", [value]))

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetTransformation")
    def reset_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformation", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="transformation")
    def transformation(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageBoxImageTransformationOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageBoxImageTransformationOutputReference", jsii.get(self, "transformation"))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="transformationInput")
    def transformation_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageBoxImageTransformation"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageBoxImageTransformation"], jsii.get(self, "transformationInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__56068a7fef8268d2daffea3abb94672c6bc0d1ac8255746913e90bb106f06e9d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__66ee6802c827aa59314e929492840b58ea1bbef4984d31a6fc624994224f21ce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac3f4c623eb55c0c801984a3f932dc58d452c821c3c9e37399560a0b172955e1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__286d58cb77ed094928288dd830e6f3d5850325cc8f1d85b7036b82406d2ef840)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3fedfee659297697fee72fbbfc1ba2c5599b1062853e8b2dc11257351c90f94f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__447ddbae711dffd0fa84761dc010b0a825f194f29e0667177d0f4f3e9959e93e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageBoxImage]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageBoxImage]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageBoxImage]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__92f6bbcdb9485bd2818b46200cd414e2d140bc2179a9c1e4daaf0f1c166965ee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageBoxImageTransformation",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageBoxImageTransformation:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageBoxImageTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageBoxImageTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageBoxImageTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__777011a7d78e6d15befb793d717ce612e548148edd4bd2f46a69edb28901c2be)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageBoxImageTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageBoxImageTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageBoxImageTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a5684e40ad025556c392f508d461ba1333e8e17fba0917f9815cf9243a6ed3d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageCircleImage",
    jsii_struct_bases=[],
    name_mapping={
        "color": "color",
        "color_var": "colorVar",
        "diameter": "diameter",
        "diameter_var": "diameterVar",
        "transformation": "transformation",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageCircleImage:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
        diameter: typing.Optional[builtins.str] = None,
        diameter_var: typing.Optional[builtins.str] = None,
        transformation: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageCircleImageTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The fill color of the circle. The API supports hexadecimal representation and CSS hexadecimal color values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The fill color of the circle. The API supports hexadecimal representation and CSS hexadecimal color values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        :param diameter: The diameter of the circle. The diameter will be the width and the height of the image in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#diameter DataAkamaiImagingPolicyImage#diameter}
        :param diameter_var: The diameter of the circle. The diameter will be the width and the height of the image in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#diameter_var DataAkamaiImagingPolicyImage#diameter_var}
        :param transformation: transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        :param width: The width of the box in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width of the box in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(transformation, dict):
            transformation = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageCircleImageTransformation(**transformation)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ba036943a1c2a51a339715c49fd934fd6bc94f1512567794eccbc8ad0b2f8f7)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
            check_type(argname="argument diameter", value=diameter, expected_type=type_hints["diameter"])
            check_type(argname="argument diameter_var", value=diameter_var, expected_type=type_hints["diameter_var"])
            check_type(argname="argument transformation", value=transformation, expected_type=type_hints["transformation"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var
        if diameter is not None:
            self._values["diameter"] = diameter
        if diameter_var is not None:
            self._values["diameter_var"] = diameter_var
        if transformation is not None:
            self._values["transformation"] = transformation
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The fill color of the circle. The API supports hexadecimal representation and CSS hexadecimal color values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The fill color of the circle. The API supports hexadecimal representation and CSS hexadecimal color values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def diameter(self) -> typing.Optional[builtins.str]:
        '''The diameter of the circle. The diameter will be the width and the height of the image in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#diameter DataAkamaiImagingPolicyImage#diameter}
        '''
        result = self._values.get("diameter")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def diameter_var(self) -> typing.Optional[builtins.str]:
        '''The diameter of the circle. The diameter will be the width and the height of the image in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#diameter_var DataAkamaiImagingPolicyImage#diameter_var}
        '''
        result = self._values.get("diameter_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def transformation(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageCircleImageTransformation"]:
        '''transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        '''
        result = self._values.get("transformation")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageCircleImageTransformation"], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width of the box in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width of the box in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageCircleImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageCircleImageList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageCircleImageList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dc2f42a1aceea9ebc6b3d721eb9e3e7b4d6b573919c2936fc1cea5c9f794fc73)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageCircleImageOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__50139f7e6e8f07e82ef98520d32148c15f8711b38ac47af5e488aa023792ee04)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageCircleImageOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2edd601759c6b0d4176fe72de439c99f2ed91b0853ab736e8507f5e63968a48e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__994152d284d6137a005f3824c7ed4edf7193bdafa4f3c1fc9e215ed6f6b25e7a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7112a0d01c6f07e1ea0e6b6f14a2125408d17064ea52957e613f14018e7c7d75)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageCircleImage]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageCircleImage]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageCircleImage]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f3c6365df8a6e1d1cd0541ba6495e667cbea06c9276544dc2e61ec750a8578ac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageCircleImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageCircleImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__33a9c298961810f5a8aebcfafd9668e74274c75c849abc18e379285fbae9d56c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformation")
    def put_transformation(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageCircleImageTransformation()

        return typing.cast(None, jsii.invoke(self, "putTransformation", [value]))

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @jsii.member(jsii_name="resetDiameter")
    def reset_diameter(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDiameter", []))

    @jsii.member(jsii_name="resetDiameterVar")
    def reset_diameter_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDiameterVar", []))

    @jsii.member(jsii_name="resetTransformation")
    def reset_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformation", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="transformation")
    def transformation(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageCircleImageTransformationOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageCircleImageTransformationOutputReference", jsii.get(self, "transformation"))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="diameterInput")
    def diameter_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "diameterInput"))

    @builtins.property
    @jsii.member(jsii_name="diameterVarInput")
    def diameter_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "diameterVarInput"))

    @builtins.property
    @jsii.member(jsii_name="transformationInput")
    def transformation_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageCircleImageTransformation"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageCircleImageTransformation"], jsii.get(self, "transformationInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6fe0e1b6665c9ca2d5bd5141aec128c0ab80d87c245d8faef83ea90d96b1cd13)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__06efc05a848b537613b8beb04590466a36a2936ef0724d49369fd93e36f808a4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="diameter")
    def diameter(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "diameter"))

    @diameter.setter
    def diameter(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__898cdf0d0fc47ff0d5d6b6b13098788d4190ce5c960207b16b8003ce6917e1d4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "diameter", value)

    @builtins.property
    @jsii.member(jsii_name="diameterVar")
    def diameter_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "diameterVar"))

    @diameter_var.setter
    def diameter_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__97c7ff12f65a3c1213ea673825b6d75b03d60508d9ee4595c3bec46782274d97)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "diameterVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ffa714696fc986ed7ed1ddb7e3ddac2923e6bd7430b5f6bf24d04bb1d435ba4c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e147a765cd86850ef232c49e27c83131015f02f94c1171aa0de8667778fe27e8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageCircleImage]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageCircleImage]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageCircleImage]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c67f1fa4f5128dbaed66e70771a3deb16d70df8b50087861619941b7f733e634)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageCircleImageTransformation",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageCircleImageTransformation:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageCircleImageTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageCircleImageTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageCircleImageTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__354c90a890a27a730b1a69c4689eda3d9a36c070594c45f37aaaef84ae26e25c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageCircleImageTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageCircleImageTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageCircleImageTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__784898b8bb766d1eaca12b95ed68b6d8dbed31ceff120da579df78c9d55d7dba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e169e3f34626c6971a54196b3b5785f0434ca51d7c18750d3db63845b8325583)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putBoxImage")
    def put_box_image(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageBoxImage, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9c7650ff6a7e4f03996cb2cc50406cca3d00e5bc029cd3a1c211e70ddfe912a8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBoxImage", [value]))

    @jsii.member(jsii_name="putCircleImage")
    def put_circle_image(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageCircleImage, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__795061f34690aa32b1701de8acb5de7cfba3cb3b527edbd6a785bf0b6b0563b8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCircleImage", [value]))

    @jsii.member(jsii_name="putTextImage")
    def put_text_image(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageTextImage", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3d0543f8f8eb4c9f9d06fb415ce83c9b78b170e855cf596638478303a4143a63)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTextImage", [value]))

    @jsii.member(jsii_name="putUrlImage")
    def put_url_image(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageUrlImage", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__35d21f837eba1432cf708495a99144d2a1fdc066a8a814482e3f3622526f2060)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putUrlImage", [value]))

    @jsii.member(jsii_name="resetBoxImage")
    def reset_box_image(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBoxImage", []))

    @jsii.member(jsii_name="resetCircleImage")
    def reset_circle_image(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCircleImage", []))

    @jsii.member(jsii_name="resetTextImage")
    def reset_text_image(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTextImage", []))

    @jsii.member(jsii_name="resetUrlImage")
    def reset_url_image(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUrlImage", []))

    @builtins.property
    @jsii.member(jsii_name="boxImage")
    def box_image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageBoxImageList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageBoxImageList, jsii.get(self, "boxImage"))

    @builtins.property
    @jsii.member(jsii_name="circleImage")
    def circle_image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageCircleImageList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageCircleImageList, jsii.get(self, "circleImage"))

    @builtins.property
    @jsii.member(jsii_name="textImage")
    def text_image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageTextImageList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageTextImageList", jsii.get(self, "textImage"))

    @builtins.property
    @jsii.member(jsii_name="urlImage")
    def url_image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageUrlImageList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageUrlImageList", jsii.get(self, "urlImage"))

    @builtins.property
    @jsii.member(jsii_name="boxImageInput")
    def box_image_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageBoxImage]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageBoxImage]]], jsii.get(self, "boxImageInput"))

    @builtins.property
    @jsii.member(jsii_name="circleImageInput")
    def circle_image_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageCircleImage]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageCircleImage]]], jsii.get(self, "circleImageInput"))

    @builtins.property
    @jsii.member(jsii_name="textImageInput")
    def text_image_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageTextImage"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageTextImage"]]], jsii.get(self, "textImageInput"))

    @builtins.property
    @jsii.member(jsii_name="urlImageInput")
    def url_image_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageUrlImage"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageUrlImage"]]], jsii.get(self, "urlImageInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__88174996ae5050c47902282d78e057ae6119a504b5413adfba4798d470db6570)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageTextImage",
    jsii_struct_bases=[],
    name_mapping={
        "fill": "fill",
        "fill_var": "fillVar",
        "size": "size",
        "size_var": "sizeVar",
        "stroke": "stroke",
        "stroke_size": "strokeSize",
        "stroke_size_var": "strokeSizeVar",
        "stroke_var": "strokeVar",
        "text": "text",
        "text_var": "textVar",
        "transformation": "transformation",
        "typeface": "typeface",
        "typeface_var": "typefaceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageTextImage:
    def __init__(
        self,
        *,
        fill: typing.Optional[builtins.str] = None,
        fill_var: typing.Optional[builtins.str] = None,
        size: typing.Optional[builtins.str] = None,
        size_var: typing.Optional[builtins.str] = None,
        stroke: typing.Optional[builtins.str] = None,
        stroke_size: typing.Optional[builtins.str] = None,
        stroke_size_var: typing.Optional[builtins.str] = None,
        stroke_var: typing.Optional[builtins.str] = None,
        text: typing.Optional[builtins.str] = None,
        text_var: typing.Optional[builtins.str] = None,
        transformation: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageTextImageTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        typeface: typing.Optional[builtins.str] = None,
        typeface_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fill: The main fill color of the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill DataAkamaiImagingPolicyImage#fill}
        :param fill_var: The main fill color of the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_var DataAkamaiImagingPolicyImage#fill_var}
        :param size: The size in pixels to render the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#size DataAkamaiImagingPolicyImage#size}
        :param size_var: The size in pixels to render the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#size_var DataAkamaiImagingPolicyImage#size_var}
        :param stroke: The color for the outline of the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke DataAkamaiImagingPolicyImage#stroke}
        :param stroke_size: The thickness in points for the outline of the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_size DataAkamaiImagingPolicyImage#stroke_size}
        :param stroke_size_var: The thickness in points for the outline of the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_size_var DataAkamaiImagingPolicyImage#stroke_size_var}
        :param stroke_var: The color for the outline of the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_var DataAkamaiImagingPolicyImage#stroke_var}
        :param text: The line of text to render. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text DataAkamaiImagingPolicyImage#text}
        :param text_var: The line of text to render. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text_var DataAkamaiImagingPolicyImage#text_var}
        :param transformation: transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        :param typeface: The font family to apply to the text image. This may be a URL to a TrueType or WOFF (v1) typeface, or a string that refers to one of the standard built-in browser fonts. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#typeface DataAkamaiImagingPolicyImage#typeface}
        :param typeface_var: The font family to apply to the text image. This may be a URL to a TrueType or WOFF (v1) typeface, or a string that refers to one of the standard built-in browser fonts. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#typeface_var DataAkamaiImagingPolicyImage#typeface_var}
        '''
        if isinstance(transformation, dict):
            transformation = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageTextImageTransformation(**transformation)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__03b3ab3bd49f5c24830d9409e19ba6476cfc7570d1fa2095099413bf25385a10)
            check_type(argname="argument fill", value=fill, expected_type=type_hints["fill"])
            check_type(argname="argument fill_var", value=fill_var, expected_type=type_hints["fill_var"])
            check_type(argname="argument size", value=size, expected_type=type_hints["size"])
            check_type(argname="argument size_var", value=size_var, expected_type=type_hints["size_var"])
            check_type(argname="argument stroke", value=stroke, expected_type=type_hints["stroke"])
            check_type(argname="argument stroke_size", value=stroke_size, expected_type=type_hints["stroke_size"])
            check_type(argname="argument stroke_size_var", value=stroke_size_var, expected_type=type_hints["stroke_size_var"])
            check_type(argname="argument stroke_var", value=stroke_var, expected_type=type_hints["stroke_var"])
            check_type(argname="argument text", value=text, expected_type=type_hints["text"])
            check_type(argname="argument text_var", value=text_var, expected_type=type_hints["text_var"])
            check_type(argname="argument transformation", value=transformation, expected_type=type_hints["transformation"])
            check_type(argname="argument typeface", value=typeface, expected_type=type_hints["typeface"])
            check_type(argname="argument typeface_var", value=typeface_var, expected_type=type_hints["typeface_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fill is not None:
            self._values["fill"] = fill
        if fill_var is not None:
            self._values["fill_var"] = fill_var
        if size is not None:
            self._values["size"] = size
        if size_var is not None:
            self._values["size_var"] = size_var
        if stroke is not None:
            self._values["stroke"] = stroke
        if stroke_size is not None:
            self._values["stroke_size"] = stroke_size
        if stroke_size_var is not None:
            self._values["stroke_size_var"] = stroke_size_var
        if stroke_var is not None:
            self._values["stroke_var"] = stroke_var
        if text is not None:
            self._values["text"] = text
        if text_var is not None:
            self._values["text_var"] = text_var
        if transformation is not None:
            self._values["transformation"] = transformation
        if typeface is not None:
            self._values["typeface"] = typeface
        if typeface_var is not None:
            self._values["typeface_var"] = typeface_var

    @builtins.property
    def fill(self) -> typing.Optional[builtins.str]:
        '''The main fill color of the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill DataAkamaiImagingPolicyImage#fill}
        '''
        result = self._values.get("fill")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fill_var(self) -> typing.Optional[builtins.str]:
        '''The main fill color of the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_var DataAkamaiImagingPolicyImage#fill_var}
        '''
        result = self._values.get("fill_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def size(self) -> typing.Optional[builtins.str]:
        '''The size in pixels to render the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#size DataAkamaiImagingPolicyImage#size}
        '''
        result = self._values.get("size")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def size_var(self) -> typing.Optional[builtins.str]:
        '''The size in pixels to render the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#size_var DataAkamaiImagingPolicyImage#size_var}
        '''
        result = self._values.get("size_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def stroke(self) -> typing.Optional[builtins.str]:
        '''The color for the outline of the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke DataAkamaiImagingPolicyImage#stroke}
        '''
        result = self._values.get("stroke")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def stroke_size(self) -> typing.Optional[builtins.str]:
        '''The thickness in points for the outline of the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_size DataAkamaiImagingPolicyImage#stroke_size}
        '''
        result = self._values.get("stroke_size")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def stroke_size_var(self) -> typing.Optional[builtins.str]:
        '''The thickness in points for the outline of the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_size_var DataAkamaiImagingPolicyImage#stroke_size_var}
        '''
        result = self._values.get("stroke_size_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def stroke_var(self) -> typing.Optional[builtins.str]:
        '''The color for the outline of the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_var DataAkamaiImagingPolicyImage#stroke_var}
        '''
        result = self._values.get("stroke_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def text(self) -> typing.Optional[builtins.str]:
        '''The line of text to render.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text DataAkamaiImagingPolicyImage#text}
        '''
        result = self._values.get("text")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def text_var(self) -> typing.Optional[builtins.str]:
        '''The line of text to render.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text_var DataAkamaiImagingPolicyImage#text_var}
        '''
        result = self._values.get("text_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def transformation(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageTextImageTransformation"]:
        '''transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        '''
        result = self._values.get("transformation")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageTextImageTransformation"], result)

    @builtins.property
    def typeface(self) -> typing.Optional[builtins.str]:
        '''The font family to apply to the text image.

        This may be a URL to a TrueType or WOFF (v1) typeface, or a string that refers to one of the standard built-in browser fonts.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#typeface DataAkamaiImagingPolicyImage#typeface}
        '''
        result = self._values.get("typeface")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def typeface_var(self) -> typing.Optional[builtins.str]:
        '''The font family to apply to the text image.

        This may be a URL to a TrueType or WOFF (v1) typeface, or a string that refers to one of the standard built-in browser fonts.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#typeface_var DataAkamaiImagingPolicyImage#typeface_var}
        '''
        result = self._values.get("typeface_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageTextImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageTextImageList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageTextImageList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d597dfc98ddaf2380a5ed439954f40193c22995e125dcfd196685a7b108b97a5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageTextImageOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd182291084d9488084ae427f5266c61bbe44cb1a228b653b3c347c618ab56a8)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageTextImageOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b5e962eaf7c833cdfbbf4000607685418811f9bf048eb8a5a65fc856ae521c3a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__03eeb3c2000dedebeefa985f3d9f58e4f76c67e4595af8a566bd177f3ca09b39)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d5752b53df1232fe40d504325ebb6c0b5fc2862ce7ff01605c1a9999039fa14e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageTextImage]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageTextImage]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageTextImage]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e64870d0e3d8f876caa9e094609a6d0785ecb6c775ec77c6c7dd66e5fd00341a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageTextImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageTextImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7c5bcb1418abf26354cf8e51312402fcec3b92c862b7fa92cc28e3910b7de12d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformation")
    def put_transformation(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageTextImageTransformation()

        return typing.cast(None, jsii.invoke(self, "putTransformation", [value]))

    @jsii.member(jsii_name="resetFill")
    def reset_fill(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFill", []))

    @jsii.member(jsii_name="resetFillVar")
    def reset_fill_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFillVar", []))

    @jsii.member(jsii_name="resetSize")
    def reset_size(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSize", []))

    @jsii.member(jsii_name="resetSizeVar")
    def reset_size_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSizeVar", []))

    @jsii.member(jsii_name="resetStroke")
    def reset_stroke(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStroke", []))

    @jsii.member(jsii_name="resetStrokeSize")
    def reset_stroke_size(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStrokeSize", []))

    @jsii.member(jsii_name="resetStrokeSizeVar")
    def reset_stroke_size_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStrokeSizeVar", []))

    @jsii.member(jsii_name="resetStrokeVar")
    def reset_stroke_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStrokeVar", []))

    @jsii.member(jsii_name="resetText")
    def reset_text(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetText", []))

    @jsii.member(jsii_name="resetTextVar")
    def reset_text_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTextVar", []))

    @jsii.member(jsii_name="resetTransformation")
    def reset_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformation", []))

    @jsii.member(jsii_name="resetTypeface")
    def reset_typeface(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeface", []))

    @jsii.member(jsii_name="resetTypefaceVar")
    def reset_typeface_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypefaceVar", []))

    @builtins.property
    @jsii.member(jsii_name="transformation")
    def transformation(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageTextImageTransformationOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageTextImageTransformationOutputReference", jsii.get(self, "transformation"))

    @builtins.property
    @jsii.member(jsii_name="fillInput")
    def fill_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fillInput"))

    @builtins.property
    @jsii.member(jsii_name="fillVarInput")
    def fill_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fillVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sizeInput")
    def size_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sizeInput"))

    @builtins.property
    @jsii.member(jsii_name="sizeVarInput")
    def size_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sizeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="strokeInput")
    def stroke_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "strokeInput"))

    @builtins.property
    @jsii.member(jsii_name="strokeSizeInput")
    def stroke_size_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "strokeSizeInput"))

    @builtins.property
    @jsii.member(jsii_name="strokeSizeVarInput")
    def stroke_size_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "strokeSizeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="strokeVarInput")
    def stroke_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "strokeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="textInput")
    def text_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "textInput"))

    @builtins.property
    @jsii.member(jsii_name="textVarInput")
    def text_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "textVarInput"))

    @builtins.property
    @jsii.member(jsii_name="transformationInput")
    def transformation_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageTextImageTransformation"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageTextImageTransformation"], jsii.get(self, "transformationInput"))

    @builtins.property
    @jsii.member(jsii_name="typefaceInput")
    def typeface_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typefaceInput"))

    @builtins.property
    @jsii.member(jsii_name="typefaceVarInput")
    def typeface_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typefaceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="fill")
    def fill(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fill"))

    @fill.setter
    def fill(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2e5755a80246d6bc548e66f6104e8cf506714ae77bbff5ee752e14ed631c7c99)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fill", value)

    @builtins.property
    @jsii.member(jsii_name="fillVar")
    def fill_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fillVar"))

    @fill_var.setter
    def fill_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__02f660f302e3929444aa523d94a340e85805a14e243f6fb42b6f944b6d77cf1c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fillVar", value)

    @builtins.property
    @jsii.member(jsii_name="size")
    def size(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "size"))

    @size.setter
    def size(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__90398af8773879248a2743183b671e78583b85c8d6dd3146a8e3f0802538b959)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "size", value)

    @builtins.property
    @jsii.member(jsii_name="sizeVar")
    def size_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sizeVar"))

    @size_var.setter
    def size_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__06ecea74c5a8e5fa02bd793bdade0f0b61b08403fba0824624b80934baaea503)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sizeVar", value)

    @builtins.property
    @jsii.member(jsii_name="stroke")
    def stroke(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "stroke"))

    @stroke.setter
    def stroke(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__643605d3a1e7a928a36118275defd4c1bf7dd8af66044c6a6d96e784adec2e32)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "stroke", value)

    @builtins.property
    @jsii.member(jsii_name="strokeSize")
    def stroke_size(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "strokeSize"))

    @stroke_size.setter
    def stroke_size(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dbf6e36bc8c0cb72303378ea94b7b87eac2b51d7405880fbbef83d1188ed8c9a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "strokeSize", value)

    @builtins.property
    @jsii.member(jsii_name="strokeSizeVar")
    def stroke_size_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "strokeSizeVar"))

    @stroke_size_var.setter
    def stroke_size_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cfcd0aea79ba92e3489ce542111d0557c6dcf0a7b4a61b4f340d249a9628b118)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "strokeSizeVar", value)

    @builtins.property
    @jsii.member(jsii_name="strokeVar")
    def stroke_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "strokeVar"))

    @stroke_var.setter
    def stroke_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab3531ef96bc3a379856028251ca3992320cc0d8281cf6116bc0050ea293b668)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "strokeVar", value)

    @builtins.property
    @jsii.member(jsii_name="text")
    def text(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "text"))

    @text.setter
    def text(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__87d107e5f23f8f86e835fb308ae9b7320295529c71490483a0f36b7f967e5a2b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "text", value)

    @builtins.property
    @jsii.member(jsii_name="textVar")
    def text_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "textVar"))

    @text_var.setter
    def text_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e7acee9e261a3e043e1a4d2bfa3b8fd195bb3cb5e5816c7602726c1d47d8e28e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "textVar", value)

    @builtins.property
    @jsii.member(jsii_name="typeface")
    def typeface(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeface"))

    @typeface.setter
    def typeface(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cb772291f262fffa3ea1645e1f5b03dff07dbe815692e46e31d046df5412b677)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeface", value)

    @builtins.property
    @jsii.member(jsii_name="typefaceVar")
    def typeface_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typefaceVar"))

    @typeface_var.setter
    def typeface_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0c3db787835ca660ad4929681365fbd3c7c48b86633de57a1a4ba894d368a21d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typefaceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageTextImage]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageTextImage]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageTextImage]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1e2e3a3b147f56dc455df0d67036089e0c786a5a26a8908f69e4a661456e95c3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageTextImageTransformation",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageTextImageTransformation:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageTextImageTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageTextImageTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageTextImageTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6fc1537ab4e0f90ae760f3449bf4d9073d08fc380e31697d803be8226cb31988)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageTextImageTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageTextImageTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageTextImageTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__90952c7bd1cf040d1c4c2e2f9e56fe8465d4c0eb5168eddd2c00f2805093c977)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageUrlImage",
    jsii_struct_bases=[],
    name_mapping={
        "transformation": "transformation",
        "url": "url",
        "url_var": "urlVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageUrlImage:
    def __init__(
        self,
        *,
        transformation: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageUrlImageTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        url: typing.Optional[builtins.str] = None,
        url_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param transformation: transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        :param url: The URL of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url DataAkamaiImagingPolicyImage#url}
        :param url_var: The URL of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url_var DataAkamaiImagingPolicyImage#url_var}
        '''
        if isinstance(transformation, dict):
            transformation = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageUrlImageTransformation(**transformation)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ccf85fd4cc66b61bd6b1cc5a355338304659b5aba92e38be93a98e770af4932)
            check_type(argname="argument transformation", value=transformation, expected_type=type_hints["transformation"])
            check_type(argname="argument url", value=url, expected_type=type_hints["url"])
            check_type(argname="argument url_var", value=url_var, expected_type=type_hints["url_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if transformation is not None:
            self._values["transformation"] = transformation
        if url is not None:
            self._values["url"] = url
        if url_var is not None:
            self._values["url_var"] = url_var

    @builtins.property
    def transformation(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageUrlImageTransformation"]:
        '''transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        '''
        result = self._values.get("transformation")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageUrlImageTransformation"], result)

    @builtins.property
    def url(self) -> typing.Optional[builtins.str]:
        '''The URL of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url DataAkamaiImagingPolicyImage#url}
        '''
        result = self._values.get("url")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def url_var(self) -> typing.Optional[builtins.str]:
        '''The URL of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url_var DataAkamaiImagingPolicyImage#url_var}
        '''
        result = self._values.get("url_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageUrlImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageUrlImageList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageUrlImageList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b85037f1531e0a2ede0c9ba0bed8db60f6ae0d31b1c126077faae3029aee1e4c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageUrlImageOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__85d89210f44c724f248702bdafe72838f4b2f05ce200bb28cadc7de1cf0edb67)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageUrlImageOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d9795272b759bd565261a103f26bdadab2d9dce9a7a3b441e1d8ce4d97eec9af)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ed22cbdc00123b4aee053b15383758bf72587eff07c421e47d0d93ce7066cb3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__660f6d7130126b25c23994aa1163ddfbd186b2524d71930d5e49e39f04110c11)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageUrlImage]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageUrlImage]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageUrlImage]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c662d504575f247e045d4ef3a678d2a696593e9920f2e3053b864eb688126c16)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageUrlImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageUrlImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__04d69cdc82a57b6f9a1631af674ee8b790328dca30b969ab04d0aeec8904c560)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformation")
    def put_transformation(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageUrlImageTransformation()

        return typing.cast(None, jsii.invoke(self, "putTransformation", [value]))

    @jsii.member(jsii_name="resetTransformation")
    def reset_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformation", []))

    @jsii.member(jsii_name="resetUrl")
    def reset_url(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUrl", []))

    @jsii.member(jsii_name="resetUrlVar")
    def reset_url_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUrlVar", []))

    @builtins.property
    @jsii.member(jsii_name="transformation")
    def transformation(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageUrlImageTransformationOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageUrlImageTransformationOutputReference", jsii.get(self, "transformation"))

    @builtins.property
    @jsii.member(jsii_name="transformationInput")
    def transformation_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageUrlImageTransformation"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageUrlImageTransformation"], jsii.get(self, "transformationInput"))

    @builtins.property
    @jsii.member(jsii_name="urlInput")
    def url_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "urlInput"))

    @builtins.property
    @jsii.member(jsii_name="urlVarInput")
    def url_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "urlVarInput"))

    @builtins.property
    @jsii.member(jsii_name="url")
    def url(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "url"))

    @url.setter
    def url(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__89b36d22436aaf66c898093e1516cfcc1a08cc9a23b1c1e93ffe8b373e481767)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "url", value)

    @builtins.property
    @jsii.member(jsii_name="urlVar")
    def url_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "urlVar"))

    @url_var.setter
    def url_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1eda8d6f4587f2130e2b316d4d485f5e45929802d3a859c5e9e8c2d6420360d0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "urlVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageUrlImage]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageUrlImage]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageUrlImage]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d82bdbc5f9b38d6436f6d3010831b2f8dada6ac001414aa6506a53fb550b604)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageUrlImageTransformation",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageUrlImageTransformation:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageUrlImageTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageUrlImageTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageUrlImageTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__77d40b266577b312b3ab81a27a123e40823aa665fca1bde6b0ea7061a6198d43)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageUrlImageTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageUrlImageTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageUrlImageTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fe999c891c04ec39787e63ef1fa1e0181faee189236590b9f198bad4b200eedc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__39bb9cd948b41da10659fb643786c27f3780967ddfbebba4b3d16a92f5f1b5eb)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7614229c1dcee83228cf75c2f1513cb465770553074ed905839755bab5a45076)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d12ae54a82022577ad342b7e8d46113aa7d975fcf435977c388ed5778ea4314e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d2460ab4fce854c14e4a51ba928ae69ab495cb26846480755a91aed3c1be2f3f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e41cdc1a4ccf581902ca7f3586c69627f659337c971f84fb938fef7959572d02)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeComposite]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeComposite]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__89daa7bd40c8aedff3ab883556d7780216cdc9caf32721a062777b5e07b6dc9c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__52c02bb6555495f9b52e7f344ea8642fb01f0cd770a1cf93bba8d5e475681e1a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(
        self,
        *,
        box_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageBoxImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
        circle_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageCircleImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
        text_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageTextImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
        url_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageUrlImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param box_image: box_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#box_image DataAkamaiImagingPolicyImage#box_image}
        :param circle_image: circle_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#circle_image DataAkamaiImagingPolicyImage#circle_image}
        :param text_image: text_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text_image DataAkamaiImagingPolicyImage#text_image}
        :param url_image: url_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url_image DataAkamaiImagingPolicyImage#url_image}
        '''
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImage(
            box_image=box_image,
            circle_image=circle_image,
            text_image=text_image,
            url_image=url_image,
        )

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPlacement")
    def reset_placement(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacement", []))

    @jsii.member(jsii_name="resetPlacementVar")
    def reset_placement_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacementVar", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetScaleDimension")
    def reset_scale_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimension", []))

    @jsii.member(jsii_name="resetScaleDimensionVar")
    def reset_scale_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimensionVar", []))

    @jsii.member(jsii_name="resetScaleVar")
    def reset_scale_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="placementInput")
    def placement_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementInput"))

    @builtins.property
    @jsii.member(jsii_name="placementVarInput")
    def placement_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionInput")
    def scale_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVarInput")
    def scale_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleVarInput")
    def scale_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__548b7e750991123c29c3b5a8768ffeed993e6f26153738522573adfc71f8cdcc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0cf704f951b87855cd5165cb15ffd525bdff98116e997678430413d280a163a2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="placement")
    def placement(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placement"))

    @placement.setter
    def placement(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a787b6b17e2e371ec6e4f7e5cf9ef535911146b007deaaec5dbcd80d0a47da41)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placement", value)

    @builtins.property
    @jsii.member(jsii_name="placementVar")
    def placement_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placementVar"))

    @placement_var.setter
    def placement_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9c43a56bdfcf18b27e3eb549589d992d2e0a5b8eb07d18ee382ab96a6821a704)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placementVar", value)

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scale"))

    @scale.setter
    def scale(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__05d26847662775dddf6f0e76f6a23f877306e557e1fce5bc615048d723f1ccff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scale", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimension")
    def scale_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimension"))

    @scale_dimension.setter
    def scale_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0175157f214db7636e72973e2690f32de244ea59621a87a7d7285d238eed7604)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimension", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVar")
    def scale_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimensionVar"))

    @scale_dimension_var.setter
    def scale_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ecde6206272349d5f4f52166609a8eb3588940295308c3ee696dd28357cb2c17)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="scaleVar")
    def scale_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleVar"))

    @scale_var.setter
    def scale_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6b63267d67573eecc3588b67e24fc5931f74372dd9104cb5225647a4638040e4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e198832ba8f468e5b368554f97938056783eb36d4b2ca682c07437a31e8a8b1c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dcb257ae4e8e128ff431d3d1d7f8dd4cc3d68cda0679f1b25539132f065c11a7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__77ef13f998556e1c4ec33b29aec6b2ebde21a9a68b4e56506df18c6ffd0e263f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2030780cae5d28d9ee243c287f74b3e0bc6613b5349fa8c94efc1f069b3773be)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeComposite]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeComposite]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeComposite]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1023b0ebd6d0a7f084f1c73699786241bdf2ad67a47708163c86d6f7ce08c60d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompound",
    jsii_struct_bases=[],
    name_mapping={"transformations": "transformations"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompound:
    def __init__(
        self,
        *,
        transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformations, typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param transformations: transformations block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5022599a275018422f49d11ff91a6be0af4719ef6f729249ab71153eb89708ae)
            check_type(argname="argument transformations", value=transformations, expected_type=type_hints["transformations"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if transformations is not None:
            self._values["transformations"] = transformations

    @builtins.property
    def transformations(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformations]]]:
        '''transformations block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        result = self._values.get("transformations")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformations]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompound(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompoundList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompoundList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c0ebb57a341e72179c2d6069ffd9017d23156e69ae5992c750836540f83ad85b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompoundOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f992252c79c0ef6dbc935a6fc9feff7e04b0dfb17b7567edd0ed90743aa128ef)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompoundOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e240c957625178c2534e353f3f03eed4baa179b3ffcbf11996b90976d1284e14)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bf618b5fa71cd5b8ff3ef4b940daa859d75ce776425497777f4ba5fd24c7da3c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dc1ba8aa1d2b463e6b49d32756197641023ebc338de1306f1c3770b5ab8af251)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompound]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompound]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__268618992c46db6943a4abb37220e9530490184bc8b77d5e02e67ed790fc8b8f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompoundOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompoundOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9f3f0678504caa815f2827f71b007362f9bc849b6797e8a991834cdc4dafc16c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformations")
    def put_transformations(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformations, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f74a8e42beba6829c68bbeadd3e997fd586a917e00c5063559ada7126290a77c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTransformations", [value]))

    @jsii.member(jsii_name="resetTransformations")
    def reset_transformations(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformations", []))

    @builtins.property
    @jsii.member(jsii_name="transformations")
    def transformations(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsList", jsii.get(self, "transformations"))

    @builtins.property
    @jsii.member(jsii_name="transformationsInput")
    def transformations_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformations]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformations]]], jsii.get(self, "transformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompound]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompound]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompound]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b3996b259ec53dea32b9e5ad90f155a9bfc2c57c27a3cf2753063b33bf9c4f56)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeContrast",
    jsii_struct_bases=[],
    name_mapping={
        "brightness": "brightness",
        "brightness_var": "brightnessVar",
        "contrast": "contrast",
        "contrast_var": "contrastVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeContrast:
    def __init__(
        self,
        *,
        brightness: typing.Optional[builtins.str] = None,
        brightness_var: typing.Optional[builtins.str] = None,
        contrast: typing.Optional[builtins.str] = None,
        contrast_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param brightness: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        :param brightness_var: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        :param contrast: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param contrast_var: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__17d4b7ef206004a6a3e73f9e2e1dde31bbf340cbaa71941e13ed04f49b7f1baf)
            check_type(argname="argument brightness", value=brightness, expected_type=type_hints["brightness"])
            check_type(argname="argument brightness_var", value=brightness_var, expected_type=type_hints["brightness_var"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument contrast_var", value=contrast_var, expected_type=type_hints["contrast_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if brightness is not None:
            self._values["brightness"] = brightness
        if brightness_var is not None:
            self._values["brightness_var"] = brightness_var
        if contrast is not None:
            self._values["contrast"] = contrast
        if contrast_var is not None:
            self._values["contrast_var"] = contrast_var

    @builtins.property
    def brightness(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        '''
        result = self._values.get("brightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def brightness_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        '''
        result = self._values.get("brightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        result = self._values.get("contrast_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeContrast(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeContrastList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeContrastList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c34b651ae7d5019bc28c876219da0e45c47971430931af97dc2b19cf7d5bf826)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeContrastOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e46d765e6bff28f4c8f9a931a15854200d8c260f36b5f9b8bf522589051d0cda)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeContrastOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8e3ee5791aca5fa79ca8f0d248a09d1296329b123f1fcf89d18c8b0bb5c74a39)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7b90e7b57451d690271f657ba2ebca4e83506c536ed6c8ff265465ccbe697b41)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e84586a73d46645d4f2aff8b4677a25a6cc7cb9c3032a0faba3ba2e31ef1ed04)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeContrast]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeContrast]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__188974b45b4a55f7f3ae2e0da4cd18e0bd7b7c73268a86be62568845e174caf0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeContrastOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeContrastOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1d03d2394ac6194e7d1bb06f042c1746784ee921952398fe76cddf8cf23448de)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetBrightness")
    def reset_brightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightness", []))

    @jsii.member(jsii_name="resetBrightnessVar")
    def reset_brightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightnessVar", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetContrastVar")
    def reset_contrast_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrastVar", []))

    @builtins.property
    @jsii.member(jsii_name="brightnessInput")
    def brightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="brightnessVarInput")
    def brightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastVarInput")
    def contrast_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="brightness")
    def brightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightness"))

    @brightness.setter
    def brightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f245ac192a309fffec0f0e186b276adc4b6ae0d238df1513674fe129d102b11e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightness", value)

    @builtins.property
    @jsii.member(jsii_name="brightnessVar")
    def brightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightnessVar"))

    @brightness_var.setter
    def brightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d5df5b2a7c4d46bdb912578e28a14ec33c7929f4f9d29da77a423281435ed426)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrast"))

    @contrast.setter
    def contrast(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e2bed25f0ffee318e48299af8745ab721efbb6d3891bf2580d42cb0478fd1ef2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrast", value)

    @builtins.property
    @jsii.member(jsii_name="contrastVar")
    def contrast_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrastVar"))

    @contrast_var.setter
    def contrast_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__02113cb1c4acf34d1ff0a56e62ef00db83e1cb3256f91998093cbfddcb5ae25c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrastVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeContrast]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeContrast]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeContrast]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__06288db82333209243e3910f01ef99d063e6f9a0c0638cb3383a488c7e360f6d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCrop",
    jsii_struct_bases=[],
    name_mapping={
        "allow_expansion": "allowExpansion",
        "allow_expansion_var": "allowExpansionVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCrop:
    def __init__(
        self,
        *,
        allow_expansion: typing.Optional[builtins.str] = None,
        allow_expansion_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_expansion: If cropping an area outside of the existing canvas, expands the image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        :param allow_expansion_var: If cropping an area outside of the existing canvas, expands the image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        :param gravity: Frame of reference for X and Y Positions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Frame of reference for X and Y Positions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The number of pixels to crop along the y-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The number of pixels to crop along the y-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The number of pixels to crop along the x-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The number of pixels to crop along the x-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        :param x_position: The x-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__88e5ee21c61729664f47729989c4c92583f237899f5622a7a06883a8972322b9)
            check_type(argname="argument allow_expansion", value=allow_expansion, expected_type=type_hints["allow_expansion"])
            check_type(argname="argument allow_expansion_var", value=allow_expansion_var, expected_type=type_hints["allow_expansion_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if allow_expansion is not None:
            self._values["allow_expansion"] = allow_expansion
        if allow_expansion_var is not None:
            self._values["allow_expansion_var"] = allow_expansion_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def allow_expansion(self) -> typing.Optional[builtins.str]:
        '''If cropping an area outside of the existing canvas, expands the image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        '''
        result = self._values.get("allow_expansion")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def allow_expansion_var(self) -> typing.Optional[builtins.str]:
        '''If cropping an area outside of the existing canvas, expands the image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        '''
        result = self._values.get("allow_expansion_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Frame of reference for X and Y Positions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Frame of reference for X and Y Positions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the y-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the y-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the x-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the x-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d39bcb5eac1edf558c44fea1050ef59dded4ae794d65906fc6032a458abbd8ee)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cb8ce4422424006016caad1b68ea91da47d25964eb2eb5139f3ec2933ae618ae)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a8f31d9bc0723a545fb63de53750885030e1d6ab345341e551a652ea15eccaa5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__352a3384b2dd245a07cee87ff39fb3775c7caccf28c913474a177e0c433dd055)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__80cf8325144fead7db907e5a0dc02d2d7bd91d4d8cf7becd4788aad7dd58894f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__762c7e897de7e064801a03db88e407830e9dc1d1b00dfc1494c7587f49df9c95)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a7892402db7e5398ead3bad3042a523e20743aead1464ecb8d7a7757bcf72f97)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAllowExpansion")
    def reset_allow_expansion(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansion", []))

    @jsii.member(jsii_name="resetAllowExpansionVar")
    def reset_allow_expansion_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansionVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionInput")
    def allow_expansion_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVarInput")
    def allow_expansion_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansion")
    def allow_expansion(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansion"))

    @allow_expansion.setter
    def allow_expansion(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7931a972488da7b7d55d0675aae9dd2239cb7ebfb6cc8d8e0f035152ef5ca521)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansion", value)

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVar")
    def allow_expansion_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansionVar"))

    @allow_expansion_var.setter
    def allow_expansion_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a03f6b2fe46a58d86a605f3f472e26887752947acf49aecf8fead6a2e9e1ef67)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansionVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1dc7a08013aec71b8fb5449cf8de72744a01974ed22ea5011d7946d790eca656)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a736144e80df4b4efc1984c14b254c19c75c5cfd8951bedc43146e23c217943)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__86a8094a1c4dbcde9e0f9e3464d8d313ff750d56fbf5ba0c196e64546fa91f2a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0c88177a8e87bcee893bf874df5404323b0f1b120a92e20f0611ed2b5b269fbb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5b361c561d89f16400d51c17d5432551565279a5abdec5b9ef4cd4bb3b650567)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__147a0a3b1307efe696d91f7b8a5f41be5a79724fb7e44f30bfb9eb2341f435e3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ce87bf6866db6eeb5695062b2a96ed50941e8476dcb1b75c6bab9f5971377e1e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea853c18c8a1961fdf5648d00cc8cb46fae3847dc35019ec768d647544427e6b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__80fa28ba3192213f192bf9585aba6d0f3ec4b17862c26765518adabeb247ad60)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__979f37450afb1b9923146f54ecec9ccea092a7667fdc8df7dcd5cba8a85157fe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__56381aa2fdf98e50da6636eafc5769c8453f1432968cdddbd12103342d93d243)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFaceCrop",
    jsii_struct_bases=[],
    name_mapping={
        "algorithm": "algorithm",
        "algorithm_var": "algorithmVar",
        "confidence": "confidence",
        "confidence_var": "confidenceVar",
        "fail_gravity": "failGravity",
        "fail_gravity_var": "failGravityVar",
        "focus": "focus",
        "focus_var": "focusVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "padding": "padding",
        "padding_var": "paddingVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFaceCrop:
    def __init__(
        self,
        *,
        algorithm: typing.Optional[builtins.str] = None,
        algorithm_var: typing.Optional[builtins.str] = None,
        confidence: typing.Optional[builtins.str] = None,
        confidence_var: typing.Optional[builtins.str] = None,
        fail_gravity: typing.Optional[builtins.str] = None,
        fail_gravity_var: typing.Optional[builtins.str] = None,
        focus: typing.Optional[builtins.str] = None,
        focus_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param algorithm: Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm DataAkamaiImagingPolicyImage#algorithm}
        :param algorithm_var: Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm_var DataAkamaiImagingPolicyImage#algorithm_var}
        :param confidence: With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image. Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence DataAkamaiImagingPolicyImage#confidence}
        :param confidence_var: With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image. Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence_var DataAkamaiImagingPolicyImage#confidence_var}
        :param fail_gravity: Controls placement of the crop if Image and Video Manager does not detect any faces in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        :param fail_gravity_var: Controls placement of the crop if Image and Video Manager does not detect any faces in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        :param focus: Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus DataAkamaiImagingPolicyImage#focus}
        :param focus_var: Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus_var DataAkamaiImagingPolicyImage#focus_var}
        :param gravity: Controls placement of the crop. Directions are relative to the face(s) plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Controls placement of the crop. Directions are relative to the face(s) plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param padding: The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        :param style: Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__efeeadcece06c6295bffe95207d831a073af79d738aad38c4b3366746eccaa59)
            check_type(argname="argument algorithm", value=algorithm, expected_type=type_hints["algorithm"])
            check_type(argname="argument algorithm_var", value=algorithm_var, expected_type=type_hints["algorithm_var"])
            check_type(argname="argument confidence", value=confidence, expected_type=type_hints["confidence"])
            check_type(argname="argument confidence_var", value=confidence_var, expected_type=type_hints["confidence_var"])
            check_type(argname="argument fail_gravity", value=fail_gravity, expected_type=type_hints["fail_gravity"])
            check_type(argname="argument fail_gravity_var", value=fail_gravity_var, expected_type=type_hints["fail_gravity_var"])
            check_type(argname="argument focus", value=focus, expected_type=type_hints["focus"])
            check_type(argname="argument focus_var", value=focus_var, expected_type=type_hints["focus_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if algorithm is not None:
            self._values["algorithm"] = algorithm
        if algorithm_var is not None:
            self._values["algorithm_var"] = algorithm_var
        if confidence is not None:
            self._values["confidence"] = confidence
        if confidence_var is not None:
            self._values["confidence_var"] = confidence_var
        if fail_gravity is not None:
            self._values["fail_gravity"] = fail_gravity
        if fail_gravity_var is not None:
            self._values["fail_gravity_var"] = fail_gravity_var
        if focus is not None:
            self._values["focus"] = focus
        if focus_var is not None:
            self._values["focus_var"] = focus_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def algorithm(self) -> typing.Optional[builtins.str]:
        '''Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm DataAkamaiImagingPolicyImage#algorithm}
        '''
        result = self._values.get("algorithm")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def algorithm_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm_var DataAkamaiImagingPolicyImage#algorithm_var}
        '''
        result = self._values.get("algorithm_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def confidence(self) -> typing.Optional[builtins.str]:
        '''With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image.

        Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence DataAkamaiImagingPolicyImage#confidence}
        '''
        result = self._values.get("confidence")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def confidence_var(self) -> typing.Optional[builtins.str]:
        '''With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image.

        Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence_var DataAkamaiImagingPolicyImage#confidence_var}
        '''
        result = self._values.get("confidence_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any faces in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        '''
        result = self._values.get("fail_gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any faces in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        '''
        result = self._values.get("fail_gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def focus(self) -> typing.Optional[builtins.str]:
        '''Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus DataAkamaiImagingPolicyImage#focus}
        '''
        result = self._values.get("focus")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def focus_var(self) -> typing.Optional[builtins.str]:
        '''Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus_var DataAkamaiImagingPolicyImage#focus_var}
        '''
        result = self._values.get("focus_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the face(s) plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the face(s) plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFaceCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFaceCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFaceCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ba59a4e00a263047e2d5b282551d1adb42229b8a572aea19ab0c1cf59052ece1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFaceCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__70ffd88cd9ac731d7b1986fa9229ef0a5ed46bbb5cd5e7b922183c80364ee09f)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFaceCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ddb463a1b44b393ffe8ebd9fce5e954ef22e3621261f438081cb6f62b1ce785)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2c1f4e5b95e23ddef47f5a8b9f5f654cc03e8320f05c85b74bcd5d08e3774b2f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ae6aef54e7637ab6710ba0ccc63faf9062b4e143375241247e3952990f7f1646)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFaceCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFaceCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFaceCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bf766801bf9b42835d238e997d1524260fcb62c3ac8336e1ed2e0d700ce30a0a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFaceCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFaceCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f7924d05f6c87f3a4e6fceee9a0a8ee9c95e3068d255b1ece26f2d51c10d9f2b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAlgorithm")
    def reset_algorithm(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAlgorithm", []))

    @jsii.member(jsii_name="resetAlgorithmVar")
    def reset_algorithm_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAlgorithmVar", []))

    @jsii.member(jsii_name="resetConfidence")
    def reset_confidence(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetConfidence", []))

    @jsii.member(jsii_name="resetConfidenceVar")
    def reset_confidence_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetConfidenceVar", []))

    @jsii.member(jsii_name="resetFailGravity")
    def reset_fail_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravity", []))

    @jsii.member(jsii_name="resetFailGravityVar")
    def reset_fail_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravityVar", []))

    @jsii.member(jsii_name="resetFocus")
    def reset_focus(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFocus", []))

    @jsii.member(jsii_name="resetFocusVar")
    def reset_focus_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFocusVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="algorithmInput")
    def algorithm_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "algorithmInput"))

    @builtins.property
    @jsii.member(jsii_name="algorithmVarInput")
    def algorithm_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "algorithmVarInput"))

    @builtins.property
    @jsii.member(jsii_name="confidenceInput")
    def confidence_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "confidenceInput"))

    @builtins.property
    @jsii.member(jsii_name="confidenceVarInput")
    def confidence_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "confidenceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityInput")
    def fail_gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityVarInput")
    def fail_gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="focusInput")
    def focus_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "focusInput"))

    @builtins.property
    @jsii.member(jsii_name="focusVarInput")
    def focus_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "focusVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="algorithm")
    def algorithm(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "algorithm"))

    @algorithm.setter
    def algorithm(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8b6572a2d22a2fa6a66d4db4d20566f0bf5c26b4294744f5eaa71f87ded7325b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "algorithm", value)

    @builtins.property
    @jsii.member(jsii_name="algorithmVar")
    def algorithm_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "algorithmVar"))

    @algorithm_var.setter
    def algorithm_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__928775aaf586eed1f29b46b554245afd1d525e0a869c091bbc5756ec1c7762e4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "algorithmVar", value)

    @builtins.property
    @jsii.member(jsii_name="confidence")
    def confidence(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "confidence"))

    @confidence.setter
    def confidence(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__356cfc85a9fa8be72105fcc906e585c41aa3ef37a76b29b47802a151c347a366)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "confidence", value)

    @builtins.property
    @jsii.member(jsii_name="confidenceVar")
    def confidence_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "confidenceVar"))

    @confidence_var.setter
    def confidence_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7bc6a5746a1cadd92aa631c52d7e913e5fa4ef5a586c4d011f0cc4ea9cc4db1d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "confidenceVar", value)

    @builtins.property
    @jsii.member(jsii_name="failGravity")
    def fail_gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravity"))

    @fail_gravity.setter
    def fail_gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__08c78f0830716acc54d96c3742b5886b0a7949dd32d27a0b650a8b296fcc091c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravity", value)

    @builtins.property
    @jsii.member(jsii_name="failGravityVar")
    def fail_gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravityVar"))

    @fail_gravity_var.setter
    def fail_gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7ebd7da8162cd101b22fa1856eb06cffab78efb77f15193adad72143f51839af)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="focus")
    def focus(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "focus"))

    @focus.setter
    def focus(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__05395bd7449c74a4854bb8806e27712e920722d30d56d1bde428b007daf89882)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "focus", value)

    @builtins.property
    @jsii.member(jsii_name="focusVar")
    def focus_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "focusVar"))

    @focus_var.setter
    def focus_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c5838a3c41568fd083f35396aa946251986ef2ffa9fbce67b2a8bc949baebe3d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "focusVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2121f58f6faec72c9c2832215b338eddfd13a1abca7a0a8192e62ffc73706a41)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__da36c33c6c899b221f506ac2c79d7d8f8f531a755c885f8689e8e32e0848f788)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7a12718447893dae223f3b33920d2b289a3dddeb9ba92ab45bbefae7ab5b549d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8d8a331e25392dfa52af2aca4959989b1dbfec78a19ad8873d17855e0859de8e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9df3bad9dba909320a7fc539910c8b83dbf06ec7843191759ae2877e1d90c3fe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d4a9cec555d04524099c54f573f806aa488aed4a3f3b81bc716c7b75564b095b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a017714dfedd7ed2992d139486c98e6205281a5f76d6a228af888c442eeed61)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__05a43bcd1bf2d5248229ddba9b1397aa9cc287ea82818512fc99e2212713fe1e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c342f65b3bf735daf7b6661cf051207665a59038d8e47201310f6c9e65b5ae86)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa3decfb050b5e3450959932af1ffabb7ae48942098f240322b8b110b4b95c94)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFaceCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFaceCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFaceCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__81d68275e91300c2d60d455dcbd44e8e7759972985d74c11d65c82e2636f5ecc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFeatureCrop",
    jsii_struct_bases=[],
    name_mapping={
        "fail_gravity": "failGravity",
        "fail_gravity_var": "failGravityVar",
        "feature_radius": "featureRadius",
        "feature_radius_var": "featureRadiusVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "max_features": "maxFeatures",
        "max_features_var": "maxFeaturesVar",
        "min_feature_quality": "minFeatureQuality",
        "min_feature_quality_var": "minFeatureQualityVar",
        "padding": "padding",
        "padding_var": "paddingVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFeatureCrop:
    def __init__(
        self,
        *,
        fail_gravity: typing.Optional[builtins.str] = None,
        fail_gravity_var: typing.Optional[builtins.str] = None,
        feature_radius: typing.Optional[builtins.str] = None,
        feature_radius_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        max_features: typing.Optional[builtins.str] = None,
        max_features_var: typing.Optional[builtins.str] = None,
        min_feature_quality: typing.Optional[builtins.str] = None,
        min_feature_quality_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fail_gravity: Controls placement of the crop if Image and Video Manager does not detect any features in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        :param fail_gravity_var: Controls placement of the crop if Image and Video Manager does not detect any features in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        :param feature_radius: The size in pixels of the important features to search for. If identified, two features never appear closer together than this value, ``8.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius DataAkamaiImagingPolicyImage#feature_radius}
        :param feature_radius_var: The size in pixels of the important features to search for. If identified, two features never appear closer together than this value, ``8.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius_var DataAkamaiImagingPolicyImage#feature_radius_var}
        :param gravity: Controls placement of the crop. Directions are relative to the region of interest plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Controls placement of the crop. Directions are relative to the region of interest plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param max_features: The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features DataAkamaiImagingPolicyImage#max_features}
        :param max_features_var: The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features_var DataAkamaiImagingPolicyImage#max_features_var}
        :param min_feature_quality: Determines the minimum quality level of the feature identified. To consider a feature important, the feature needs to surpass this value. Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality DataAkamaiImagingPolicyImage#min_feature_quality}
        :param min_feature_quality_var: Determines the minimum quality level of the feature identified. To consider a feature important, the feature needs to surpass this value. Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality_var DataAkamaiImagingPolicyImage#min_feature_quality_var}
        :param padding: Adds space around the region of interest. The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: Adds space around the region of interest. The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        :param style: Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3d30af5034f5375bd22e1754e1646510e5dcbfc8232e7ee51ce943f8e99c93bc)
            check_type(argname="argument fail_gravity", value=fail_gravity, expected_type=type_hints["fail_gravity"])
            check_type(argname="argument fail_gravity_var", value=fail_gravity_var, expected_type=type_hints["fail_gravity_var"])
            check_type(argname="argument feature_radius", value=feature_radius, expected_type=type_hints["feature_radius"])
            check_type(argname="argument feature_radius_var", value=feature_radius_var, expected_type=type_hints["feature_radius_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument max_features", value=max_features, expected_type=type_hints["max_features"])
            check_type(argname="argument max_features_var", value=max_features_var, expected_type=type_hints["max_features_var"])
            check_type(argname="argument min_feature_quality", value=min_feature_quality, expected_type=type_hints["min_feature_quality"])
            check_type(argname="argument min_feature_quality_var", value=min_feature_quality_var, expected_type=type_hints["min_feature_quality_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fail_gravity is not None:
            self._values["fail_gravity"] = fail_gravity
        if fail_gravity_var is not None:
            self._values["fail_gravity_var"] = fail_gravity_var
        if feature_radius is not None:
            self._values["feature_radius"] = feature_radius
        if feature_radius_var is not None:
            self._values["feature_radius_var"] = feature_radius_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if max_features is not None:
            self._values["max_features"] = max_features
        if max_features_var is not None:
            self._values["max_features_var"] = max_features_var
        if min_feature_quality is not None:
            self._values["min_feature_quality"] = min_feature_quality
        if min_feature_quality_var is not None:
            self._values["min_feature_quality_var"] = min_feature_quality_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def fail_gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any features in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        '''
        result = self._values.get("fail_gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any features in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        '''
        result = self._values.get("fail_gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feature_radius(self) -> typing.Optional[builtins.str]:
        '''The size in pixels of the important features to search for.

        If identified, two features never appear closer together than this value, ``8.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius DataAkamaiImagingPolicyImage#feature_radius}
        '''
        result = self._values.get("feature_radius")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feature_radius_var(self) -> typing.Optional[builtins.str]:
        '''The size in pixels of the important features to search for.

        If identified, two features never appear closer together than this value, ``8.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius_var DataAkamaiImagingPolicyImage#feature_radius_var}
        '''
        result = self._values.get("feature_radius_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the region of interest plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the region of interest plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def max_features(self) -> typing.Optional[builtins.str]:
        '''The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features DataAkamaiImagingPolicyImage#max_features}
        '''
        result = self._values.get("max_features")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def max_features_var(self) -> typing.Optional[builtins.str]:
        '''The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features_var DataAkamaiImagingPolicyImage#max_features_var}
        '''
        result = self._values.get("max_features_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def min_feature_quality(self) -> typing.Optional[builtins.str]:
        '''Determines the minimum quality level of the feature identified.

        To consider a feature important, the feature needs to surpass this value.  Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality DataAkamaiImagingPolicyImage#min_feature_quality}
        '''
        result = self._values.get("min_feature_quality")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def min_feature_quality_var(self) -> typing.Optional[builtins.str]:
        '''Determines the minimum quality level of the feature identified.

        To consider a feature important, the feature needs to surpass this value.  Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality_var DataAkamaiImagingPolicyImage#min_feature_quality_var}
        '''
        result = self._values.get("min_feature_quality_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''Adds space around the region of interest.

        The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''Adds space around the region of interest.

        The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFeatureCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFeatureCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFeatureCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__129a0cc51ae67af8d5c2566656ba320cfafd1d48ff64546fe33460411695739c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFeatureCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__19f4f9b14f8dc20841c6e2fb399a56ec1c4b25a56d0f3db3310261b40847bf08)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFeatureCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__703fcc7ddf94233e65697d7e95c6aa9cdeeeabcc6221cff1b039c28272c2b420)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cdc6dceca9a5ed53d19f90db80a5ae05f46c7211a37d9fb4a906a36e855a5224)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__43435163e22ffa7a7a472b94e1ac46196c46c17fd59563d303bae5dbfd790210)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFeatureCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFeatureCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFeatureCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6b81d8ef786739298ab5dce238186d4bd413d620e5449bf3ee260f9f5c82365c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFeatureCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFeatureCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fb1df20dd311ecd09bacb4849807fc446ab5262773ea93b69c31c55f7a90d4ac)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetFailGravity")
    def reset_fail_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravity", []))

    @jsii.member(jsii_name="resetFailGravityVar")
    def reset_fail_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravityVar", []))

    @jsii.member(jsii_name="resetFeatureRadius")
    def reset_feature_radius(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureRadius", []))

    @jsii.member(jsii_name="resetFeatureRadiusVar")
    def reset_feature_radius_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureRadiusVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetMaxFeatures")
    def reset_max_features(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxFeatures", []))

    @jsii.member(jsii_name="resetMaxFeaturesVar")
    def reset_max_features_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxFeaturesVar", []))

    @jsii.member(jsii_name="resetMinFeatureQuality")
    def reset_min_feature_quality(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMinFeatureQuality", []))

    @jsii.member(jsii_name="resetMinFeatureQualityVar")
    def reset_min_feature_quality_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMinFeatureQualityVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="failGravityInput")
    def fail_gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityVarInput")
    def fail_gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featureRadiusInput")
    def feature_radius_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featureRadiusInput"))

    @builtins.property
    @jsii.member(jsii_name="featureRadiusVarInput")
    def feature_radius_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featureRadiusVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesInput")
    def max_features_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "maxFeaturesInput"))

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesVarInput")
    def max_features_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "maxFeaturesVarInput"))

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityInput")
    def min_feature_quality_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "minFeatureQualityInput"))

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityVarInput")
    def min_feature_quality_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "minFeatureQualityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravity")
    def fail_gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravity"))

    @fail_gravity.setter
    def fail_gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1e2ee0534579cd79d33bd098b22287825d541ea2b3686e156e0dfac981660230)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravity", value)

    @builtins.property
    @jsii.member(jsii_name="failGravityVar")
    def fail_gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravityVar"))

    @fail_gravity_var.setter
    def fail_gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d81ae023d2830cec076c3b65e1e6706bcf6c040c511cbe160f1eff354a33a656)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="featureRadius")
    def feature_radius(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featureRadius"))

    @feature_radius.setter
    def feature_radius(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ee705a92e4ccb21cb3c3a5118bb925e6b076490cb9c671840319abf50bcbf200)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featureRadius", value)

    @builtins.property
    @jsii.member(jsii_name="featureRadiusVar")
    def feature_radius_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featureRadiusVar"))

    @feature_radius_var.setter
    def feature_radius_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__420f5d470cd1f44b796bc9e6716cc18ef52e9331ceb23592278b0ecddb87d537)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featureRadiusVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__21f9795da44603d0e4f40ac1f7272a5adc468e2d909e6bab9d85181ff763ddc4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__67652a5d123aed7a69a5dc9f239fd67558d8b6c4c08fb94cd8087af9889fce6e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f6e51a3c07bc5df15fa3b414624940fba9720dc5f24677dc1a83012c5cac2db0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b11d4a43169eb964b3f37a1dc7fff15218930ea88261875773669d8ad2d56f9f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="maxFeatures")
    def max_features(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "maxFeatures"))

    @max_features.setter
    def max_features(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c0fe9c1c14e7dae1a6608ec3b7acac503f2db9780ded7414d337e833dacafb2c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "maxFeatures", value)

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesVar")
    def max_features_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "maxFeaturesVar"))

    @max_features_var.setter
    def max_features_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b111dc1c61002c52d38aa418cf926fd0c3a9f77f7a738f4601a4f4593d35c9f8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "maxFeaturesVar", value)

    @builtins.property
    @jsii.member(jsii_name="minFeatureQuality")
    def min_feature_quality(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "minFeatureQuality"))

    @min_feature_quality.setter
    def min_feature_quality(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__27089a0535ba74a72ae9e7211c0a36de10b5d8e2bc673d1b201cd57da5f967e2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "minFeatureQuality", value)

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityVar")
    def min_feature_quality_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "minFeatureQualityVar"))

    @min_feature_quality_var.setter
    def min_feature_quality_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1e837d680492fb0deee3d1bf8146783ec0eb52c8e44f8b4021c5eb49fbf1ee1b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "minFeatureQualityVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7b7b0add31db1f477666a70d9ea293ed73ab5daf192b7a1f971f7930e1b20ead)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__46fa2e9ed3425bd28bb619f7a7b5a4317f84be465a35046d7499150926a62e27)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0dbcbcde22651d8eaf2e5022743465d2de8a0e469aa0ac4ff3a4ee3f71f74b72)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__db9df7eb8567f208ca7cda940e4a9a31ebe408dad3bd294f087fa7aa28e81da7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f5bc415e15315dd089bcf80cf482d2a1966e8de2cc0829ec4764ee89a643b305)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b6ba770ac33f725db169e4195e725a5ca4fd4dfbb06e0758dadfdc9f262ba5c5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFeatureCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFeatureCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFeatureCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5c586b878d987e9920c13e18b16a00433ad9c4a2306d658839bd3be0bfc8a989)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFill",
    jsii_struct_bases=[],
    name_mapping={
        "fill_transformation": "fillTransformation",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFill:
    def __init__(
        self,
        *,
        fill_transformation: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fill_transformation: fill_transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_transformation DataAkamaiImagingPolicyImage#fill_transformation}
        :param height: The height value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The width value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(fill_transformation, dict):
            fill_transformation = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformation(**fill_transformation)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__278d39d332ee2aac2ac31bc90693246c2b2dc08061fffa217e7da22c40e98f2a)
            check_type(argname="argument fill_transformation", value=fill_transformation, expected_type=type_hints["fill_transformation"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fill_transformation is not None:
            self._values["fill_transformation"] = fill_transformation
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def fill_transformation(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformation"]:
        '''fill_transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_transformation DataAkamaiImagingPolicyImage#fill_transformation}
        '''
        result = self._values.get("fill_transformation")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformation"], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFill(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformation",
    jsii_struct_bases=[],
    name_mapping={
        "append": "append",
        "aspect_crop": "aspectCrop",
        "background_color": "backgroundColor",
        "blur": "blur",
        "chroma_key": "chromaKey",
        "composite": "composite",
        "compound": "compound",
        "contrast": "contrast",
        "crop": "crop",
        "face_crop": "faceCrop",
        "feature_crop": "featureCrop",
        "fit_and_fill": "fitAndFill",
        "goop": "goop",
        "grayscale": "grayscale",
        "hsl": "hsl",
        "hsv": "hsv",
        "if_dimension": "ifDimension",
        "if_orientation": "ifOrientation",
        "im_query": "imQuery",
        "max_colors": "maxColors",
        "mirror": "mirror",
        "mono_hue": "monoHue",
        "opacity": "opacity",
        "region_of_interest_crop": "regionOfInterestCrop",
        "relative_crop": "relativeCrop",
        "remove_color": "removeColor",
        "resize": "resize",
        "rotate": "rotate",
        "scale": "scale",
        "shear": "shear",
        "trim": "trim",
        "unsharp_mask": "unsharpMask",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformation:
    def __init__(
        self,
        *,
        append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationAppend", typing.Dict[builtins.str, typing.Any]]]]] = None,
        aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationAspectCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationBackgroundColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationBlur", typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationChromaKey", typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationComposite", typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationCompound", typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationContrast", typing.Dict[builtins.str, typing.Any]]]]] = None,
        crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationFaceCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationFeatureCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationFitAndFill", typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationGoop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationGrayscale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationHsl", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationHsv", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfDimension", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfOrientation", typing.Dict[builtins.str, typing.Any]]]]] = None,
        im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationImQuery", typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationMaxColors", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationMirror", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationMonoHue", typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationOpacity", typing.Dict[builtins.str, typing.Any]]]]] = None,
        region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationRegionOfInterestCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationRelativeCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationRemoveColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationResize", typing.Dict[builtins.str, typing.Any]]]]] = None,
        rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationRotate", typing.Dict[builtins.str, typing.Any]]]]] = None,
        scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationScale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationShear", typing.Dict[builtins.str, typing.Any]]]]] = None,
        trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationTrim", typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationUnsharpMask", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param append: append block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        :param aspect_crop: aspect_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param crop: crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        :param face_crop: face_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        :param feature_crop: feature_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        :param fit_and_fill: fit_and_fill block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param im_query: im_query block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param region_of_interest_crop: region_of_interest_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        :param relative_crop: relative_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param resize: resize block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        :param rotate: rotate block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        :param scale: scale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param shear: shear block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        :param trim: trim block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__692c06a1460c765a47b33eafcee729a9dec2479a6719fd1369400563b3210608)
            check_type(argname="argument append", value=append, expected_type=type_hints["append"])
            check_type(argname="argument aspect_crop", value=aspect_crop, expected_type=type_hints["aspect_crop"])
            check_type(argname="argument background_color", value=background_color, expected_type=type_hints["background_color"])
            check_type(argname="argument blur", value=blur, expected_type=type_hints["blur"])
            check_type(argname="argument chroma_key", value=chroma_key, expected_type=type_hints["chroma_key"])
            check_type(argname="argument composite", value=composite, expected_type=type_hints["composite"])
            check_type(argname="argument compound", value=compound, expected_type=type_hints["compound"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument crop", value=crop, expected_type=type_hints["crop"])
            check_type(argname="argument face_crop", value=face_crop, expected_type=type_hints["face_crop"])
            check_type(argname="argument feature_crop", value=feature_crop, expected_type=type_hints["feature_crop"])
            check_type(argname="argument fit_and_fill", value=fit_and_fill, expected_type=type_hints["fit_and_fill"])
            check_type(argname="argument goop", value=goop, expected_type=type_hints["goop"])
            check_type(argname="argument grayscale", value=grayscale, expected_type=type_hints["grayscale"])
            check_type(argname="argument hsl", value=hsl, expected_type=type_hints["hsl"])
            check_type(argname="argument hsv", value=hsv, expected_type=type_hints["hsv"])
            check_type(argname="argument if_dimension", value=if_dimension, expected_type=type_hints["if_dimension"])
            check_type(argname="argument if_orientation", value=if_orientation, expected_type=type_hints["if_orientation"])
            check_type(argname="argument im_query", value=im_query, expected_type=type_hints["im_query"])
            check_type(argname="argument max_colors", value=max_colors, expected_type=type_hints["max_colors"])
            check_type(argname="argument mirror", value=mirror, expected_type=type_hints["mirror"])
            check_type(argname="argument mono_hue", value=mono_hue, expected_type=type_hints["mono_hue"])
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument region_of_interest_crop", value=region_of_interest_crop, expected_type=type_hints["region_of_interest_crop"])
            check_type(argname="argument relative_crop", value=relative_crop, expected_type=type_hints["relative_crop"])
            check_type(argname="argument remove_color", value=remove_color, expected_type=type_hints["remove_color"])
            check_type(argname="argument resize", value=resize, expected_type=type_hints["resize"])
            check_type(argname="argument rotate", value=rotate, expected_type=type_hints["rotate"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument shear", value=shear, expected_type=type_hints["shear"])
            check_type(argname="argument trim", value=trim, expected_type=type_hints["trim"])
            check_type(argname="argument unsharp_mask", value=unsharp_mask, expected_type=type_hints["unsharp_mask"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if append is not None:
            self._values["append"] = append
        if aspect_crop is not None:
            self._values["aspect_crop"] = aspect_crop
        if background_color is not None:
            self._values["background_color"] = background_color
        if blur is not None:
            self._values["blur"] = blur
        if chroma_key is not None:
            self._values["chroma_key"] = chroma_key
        if composite is not None:
            self._values["composite"] = composite
        if compound is not None:
            self._values["compound"] = compound
        if contrast is not None:
            self._values["contrast"] = contrast
        if crop is not None:
            self._values["crop"] = crop
        if face_crop is not None:
            self._values["face_crop"] = face_crop
        if feature_crop is not None:
            self._values["feature_crop"] = feature_crop
        if fit_and_fill is not None:
            self._values["fit_and_fill"] = fit_and_fill
        if goop is not None:
            self._values["goop"] = goop
        if grayscale is not None:
            self._values["grayscale"] = grayscale
        if hsl is not None:
            self._values["hsl"] = hsl
        if hsv is not None:
            self._values["hsv"] = hsv
        if if_dimension is not None:
            self._values["if_dimension"] = if_dimension
        if if_orientation is not None:
            self._values["if_orientation"] = if_orientation
        if im_query is not None:
            self._values["im_query"] = im_query
        if max_colors is not None:
            self._values["max_colors"] = max_colors
        if mirror is not None:
            self._values["mirror"] = mirror
        if mono_hue is not None:
            self._values["mono_hue"] = mono_hue
        if opacity is not None:
            self._values["opacity"] = opacity
        if region_of_interest_crop is not None:
            self._values["region_of_interest_crop"] = region_of_interest_crop
        if relative_crop is not None:
            self._values["relative_crop"] = relative_crop
        if remove_color is not None:
            self._values["remove_color"] = remove_color
        if resize is not None:
            self._values["resize"] = resize
        if rotate is not None:
            self._values["rotate"] = rotate
        if scale is not None:
            self._values["scale"] = scale
        if shear is not None:
            self._values["shear"] = shear
        if trim is not None:
            self._values["trim"] = trim
        if unsharp_mask is not None:
            self._values["unsharp_mask"] = unsharp_mask

    @builtins.property
    def append(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationAppend"]]]:
        '''append block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        '''
        result = self._values.get("append")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationAppend"]]], result)

    @builtins.property
    def aspect_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationAspectCrop"]]]:
        '''aspect_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        '''
        result = self._values.get("aspect_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationAspectCrop"]]], result)

    @builtins.property
    def background_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationBackgroundColor"]]]:
        '''background_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        '''
        result = self._values.get("background_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationBackgroundColor"]]], result)

    @builtins.property
    def blur(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationBlur"]]]:
        '''blur block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        '''
        result = self._values.get("blur")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationBlur"]]], result)

    @builtins.property
    def chroma_key(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationChromaKey"]]]:
        '''chroma_key block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        '''
        result = self._values.get("chroma_key")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationChromaKey"]]], result)

    @builtins.property
    def composite(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationComposite"]]]:
        '''composite block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        '''
        result = self._values.get("composite")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationComposite"]]], result)

    @builtins.property
    def compound(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationCompound"]]]:
        '''compound block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        '''
        result = self._values.get("compound")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationCompound"]]], result)

    @builtins.property
    def contrast(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationContrast"]]]:
        '''contrast block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationContrast"]]], result)

    @builtins.property
    def crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationCrop"]]]:
        '''crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        '''
        result = self._values.get("crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationCrop"]]], result)

    @builtins.property
    def face_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationFaceCrop"]]]:
        '''face_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        '''
        result = self._values.get("face_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationFaceCrop"]]], result)

    @builtins.property
    def feature_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationFeatureCrop"]]]:
        '''feature_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        '''
        result = self._values.get("feature_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationFeatureCrop"]]], result)

    @builtins.property
    def fit_and_fill(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationFitAndFill"]]]:
        '''fit_and_fill block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        '''
        result = self._values.get("fit_and_fill")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationFitAndFill"]]], result)

    @builtins.property
    def goop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationGoop"]]]:
        '''goop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        '''
        result = self._values.get("goop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationGoop"]]], result)

    @builtins.property
    def grayscale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationGrayscale"]]]:
        '''grayscale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        '''
        result = self._values.get("grayscale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationGrayscale"]]], result)

    @builtins.property
    def hsl(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationHsl"]]]:
        '''hsl block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        '''
        result = self._values.get("hsl")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationHsl"]]], result)

    @builtins.property
    def hsv(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationHsv"]]]:
        '''hsv block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        '''
        result = self._values.get("hsv")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationHsv"]]], result)

    @builtins.property
    def if_dimension(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfDimension"]]]:
        '''if_dimension block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        '''
        result = self._values.get("if_dimension")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfDimension"]]], result)

    @builtins.property
    def if_orientation(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfOrientation"]]]:
        '''if_orientation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        '''
        result = self._values.get("if_orientation")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfOrientation"]]], result)

    @builtins.property
    def im_query(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationImQuery"]]]:
        '''im_query block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        '''
        result = self._values.get("im_query")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationImQuery"]]], result)

    @builtins.property
    def max_colors(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationMaxColors"]]]:
        '''max_colors block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        '''
        result = self._values.get("max_colors")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationMaxColors"]]], result)

    @builtins.property
    def mirror(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationMirror"]]]:
        '''mirror block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        '''
        result = self._values.get("mirror")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationMirror"]]], result)

    @builtins.property
    def mono_hue(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationMonoHue"]]]:
        '''mono_hue block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        '''
        result = self._values.get("mono_hue")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationMonoHue"]]], result)

    @builtins.property
    def opacity(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationOpacity"]]]:
        '''opacity block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationOpacity"]]], result)

    @builtins.property
    def region_of_interest_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationRegionOfInterestCrop"]]]:
        '''region_of_interest_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        '''
        result = self._values.get("region_of_interest_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationRegionOfInterestCrop"]]], result)

    @builtins.property
    def relative_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationRelativeCrop"]]]:
        '''relative_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        '''
        result = self._values.get("relative_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationRelativeCrop"]]], result)

    @builtins.property
    def remove_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationRemoveColor"]]]:
        '''remove_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        '''
        result = self._values.get("remove_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationRemoveColor"]]], result)

    @builtins.property
    def resize(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationResize"]]]:
        '''resize block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        '''
        result = self._values.get("resize")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationResize"]]], result)

    @builtins.property
    def rotate(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationRotate"]]]:
        '''rotate block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        '''
        result = self._values.get("rotate")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationRotate"]]], result)

    @builtins.property
    def scale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationScale"]]]:
        '''scale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationScale"]]], result)

    @builtins.property
    def shear(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationShear"]]]:
        '''shear block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        '''
        result = self._values.get("shear")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationShear"]]], result)

    @builtins.property
    def trim(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationTrim"]]]:
        '''trim block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        '''
        result = self._values.get("trim")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationTrim"]]], result)

    @builtins.property
    def unsharp_mask(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationUnsharpMask"]]]:
        '''unsharp_mask block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        result = self._values.get("unsharp_mask")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationUnsharpMask"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationAppend",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_priority": "gravityPriority",
        "gravity_priority_var": "gravityPriorityVar",
        "gravity_var": "gravityVar",
        "preserve_minor_dimension": "preserveMinorDimension",
        "preserve_minor_dimension_var": "preserveMinorDimensionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationAppend:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationAppendImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_priority: typing.Optional[builtins.str] = None,
        gravity_priority_var: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        preserve_minor_dimension: typing.Optional[builtins.str] = None,
        preserve_minor_dimension_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Specifies where to place the ``image`` relative to the source image. The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_priority: Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal. The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority DataAkamaiImagingPolicyImage#gravity_priority}
        :param gravity_priority_var: Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal. The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority_var DataAkamaiImagingPolicyImage#gravity_priority_var}
        :param gravity_var: Specifies where to place the ``image`` relative to the source image. The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param preserve_minor_dimension: Whether to preserve the source image's minor dimension, ``false`` by default. The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension DataAkamaiImagingPolicyImage#preserve_minor_dimension}
        :param preserve_minor_dimension_var: Whether to preserve the source image's minor dimension, ``false`` by default. The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension_var DataAkamaiImagingPolicyImage#preserve_minor_dimension_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationAppendImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c98271854a1087eae226680b9f16200df448c48260f6ce47a265670c1589f633)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_priority", value=gravity_priority, expected_type=type_hints["gravity_priority"])
            check_type(argname="argument gravity_priority_var", value=gravity_priority_var, expected_type=type_hints["gravity_priority_var"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument preserve_minor_dimension", value=preserve_minor_dimension, expected_type=type_hints["preserve_minor_dimension"])
            check_type(argname="argument preserve_minor_dimension_var", value=preserve_minor_dimension_var, expected_type=type_hints["preserve_minor_dimension_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_priority is not None:
            self._values["gravity_priority"] = gravity_priority
        if gravity_priority_var is not None:
            self._values["gravity_priority_var"] = gravity_priority_var
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if preserve_minor_dimension is not None:
            self._values["preserve_minor_dimension"] = preserve_minor_dimension
        if preserve_minor_dimension_var is not None:
            self._values["preserve_minor_dimension_var"] = preserve_minor_dimension_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationAppendImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationAppendImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Specifies where to place the ``image`` relative to the source image.

        The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_priority(self) -> typing.Optional[builtins.str]:
        '''Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal.

        The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority DataAkamaiImagingPolicyImage#gravity_priority}
        '''
        result = self._values.get("gravity_priority")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_priority_var(self) -> typing.Optional[builtins.str]:
        '''Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal.

        The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority_var DataAkamaiImagingPolicyImage#gravity_priority_var}
        '''
        result = self._values.get("gravity_priority_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Specifies where to place the ``image`` relative to the source image.

        The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def preserve_minor_dimension(self) -> typing.Optional[builtins.str]:
        '''Whether to preserve the source image's minor dimension, ``false`` by default.

        The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension DataAkamaiImagingPolicyImage#preserve_minor_dimension}
        '''
        result = self._values.get("preserve_minor_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def preserve_minor_dimension_var(self) -> typing.Optional[builtins.str]:
        '''Whether to preserve the source image's minor dimension, ``false`` by default.

        The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension_var DataAkamaiImagingPolicyImage#preserve_minor_dimension_var}
        '''
        result = self._values.get("preserve_minor_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationAppend(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationAppendImage",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationAppendImage:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationAppendImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationAppendImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationAppendImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f4088ca3ca7b632549aa28594193fe3d436f3d7666b703543fc381bd93d71f6a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationAppendImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationAppendImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationAppendImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__14fbf27e858e7c425801b4e1c60fe579517f2e80a453bfa7458d42e539efee6f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationAppendList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationAppendList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c231a94920a5042bbd74c9dd0fb3a33d2043adfdfeae5bf5de05458600cb73a2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationAppendOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b8813f20ed8acd1e0d8282d7f66ef6566ebc0d075b725af89b920c322ceeedf3)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationAppendOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fc53848029a664f052aed1a23fbf9674f022e7a0e1f97848c8cbe6eaf16e6a6e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__30709edb39e3013683d257ad1ef17b4f7fc9d3e2c2cf4db37181764dc2072788)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d7d7cdcd1c8cfb63f04d730e3524bb179ac7b0c05859327f22c4a8ff2945106a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationAppend]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationAppend]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationAppend]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ec90e97e391314d499cb02fb1d1310dbc1142b273a44b8b39e1f000a3504807e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationAppendOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationAppendOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fde996f5a2d3e6891d1aef66c1ac7e6203d124876b467079c521a0371e002955)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationAppendImage()

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityPriority")
    def reset_gravity_priority(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityPriority", []))

    @jsii.member(jsii_name="resetGravityPriorityVar")
    def reset_gravity_priority_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityPriorityVar", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPreserveMinorDimension")
    def reset_preserve_minor_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPreserveMinorDimension", []))

    @jsii.member(jsii_name="resetPreserveMinorDimensionVar")
    def reset_preserve_minor_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPreserveMinorDimensionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationAppendImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationAppendImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityInput")
    def gravity_priority_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityPriorityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityVarInput")
    def gravity_priority_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityPriorityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationAppendImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationAppendImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionInput")
    def preserve_minor_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "preserveMinorDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionVarInput")
    def preserve_minor_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "preserveMinorDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9504aae7e2b294d0bb50767f169a46331b5c3bb7b6093c293da359ba8b4c1ce5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityPriority")
    def gravity_priority(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityPriority"))

    @gravity_priority.setter
    def gravity_priority(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f425a174184521428ef46f1f242ce5466e2180edb9401f0b30af40b44588bb5a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityPriority", value)

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityVar")
    def gravity_priority_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityPriorityVar"))

    @gravity_priority_var.setter
    def gravity_priority_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1d4ae628cad6c219b8a72c0072af6c7c1a35d7712ff8e4b7baf63014bf940cf1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityPriorityVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c33c25cbef998ae2ea6b19729eac6e165f3488ea10c86c5471b6be0e09da0811)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimension")
    def preserve_minor_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "preserveMinorDimension"))

    @preserve_minor_dimension.setter
    def preserve_minor_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e44d3dd5acb6e6ac288cad97f73eb69f9e1cc6e2d0a21a284adb326d0d22af00)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "preserveMinorDimension", value)

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionVar")
    def preserve_minor_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "preserveMinorDimensionVar"))

    @preserve_minor_dimension_var.setter
    def preserve_minor_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7269efeb85a7c54f807623500269ceee8fe1f23ae75ad698f4b414f49c288b4b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "preserveMinorDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationAppend]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationAppend]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationAppend]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__34dd3e29a0ee79d698f53ff2db418f6029f4989747610382e6f83531eaa084ef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationAspectCrop",
    jsii_struct_bases=[],
    name_mapping={
        "allow_expansion": "allowExpansion",
        "allow_expansion_var": "allowExpansionVar",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationAspectCrop:
    def __init__(
        self,
        *,
        allow_expansion: typing.Optional[builtins.str] = None,
        allow_expansion_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_expansion: Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image. Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        :param allow_expansion_var: Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image. Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        :param height: The height term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The width term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        :param x_position: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c252570ba4a99e0b52ef7a29fcd64dd5536b1b56a1c7cfa141c8ca435562d97f)
            check_type(argname="argument allow_expansion", value=allow_expansion, expected_type=type_hints["allow_expansion"])
            check_type(argname="argument allow_expansion_var", value=allow_expansion_var, expected_type=type_hints["allow_expansion_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if allow_expansion is not None:
            self._values["allow_expansion"] = allow_expansion
        if allow_expansion_var is not None:
            self._values["allow_expansion_var"] = allow_expansion_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def allow_expansion(self) -> typing.Optional[builtins.str]:
        '''Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image.

        Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        '''
        result = self._values.get("allow_expansion")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def allow_expansion_var(self) -> typing.Optional[builtins.str]:
        '''Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image.

        Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        '''
        result = self._values.get("allow_expansion_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationAspectCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationAspectCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationAspectCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9e602c786c680ba48d352ff5198c078a45c2021737c016e7489db5b434355b8b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationAspectCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1a43f4b5da5aeb77f46d28a364306df870340e157c07fc8571b2c84d0c55233a)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationAspectCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3e3b4e9b906b37f6be1b39ba14f40ad82825295f34b837069360ad9af13a9566)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cc1de9ee3013141cfd00ccf1f4850b148971e31973bc12e5da1f7de8d1a10e06)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__adc8059989dbdf3a3f529dce629d4f7112e4222cb748aee06f7c644e447cd9eb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationAspectCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationAspectCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationAspectCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d6b7bfe2afe54156cb2fe0b268fe00be2c9c311e170ca861a89cfc500ae62e0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationAspectCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationAspectCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c644a7f36ac8c08ea188d92cd9dbeb38b2df5f049cf1199662dec105b8fe6e12)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAllowExpansion")
    def reset_allow_expansion(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansion", []))

    @jsii.member(jsii_name="resetAllowExpansionVar")
    def reset_allow_expansion_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansionVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionInput")
    def allow_expansion_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVarInput")
    def allow_expansion_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansion")
    def allow_expansion(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansion"))

    @allow_expansion.setter
    def allow_expansion(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a60b6fdbf551e3f63c31ad5a6779e2ec5ddaa6b1c442ce2bff4907f63500e2dd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansion", value)

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVar")
    def allow_expansion_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansionVar"))

    @allow_expansion_var.setter
    def allow_expansion_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__34a11631d999f184d93878e4751cae72cb373f9eba7e62336af3b383c1671380)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansionVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b456b490a59dd0645bbb8b8cd4fce64456183b674a116ac45a3dafc8b6e744b6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2e6a7ecfe6a41d322e0b9adf19b4e50684efd2fe9e566bb4ccb144d3e8474ce0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__98fd8f5b1bbaaba1a89f4016045e5fbe7ee6df640eadc1788d36627cf5c9d4ee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__71e36ced39c18b494e07013d751292c5379adf56ffbf68977ab00d1cbecf95e0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ca05c522533818c76b626640657ac8e727e06d4815c519971f3716e261ec4656)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eee9026f6fd3e30da79756fd0db6c51bde43ece7ca79e676383b229e16c1d145)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1791570a282ff5c425aba826c6b6f67e05546311134ea5f4fe72f54958102e81)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8aac031cbe36b1fb50955099299e1502ba2fba728e145aa1f4433fb844ac630d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationAspectCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationAspectCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationAspectCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__94d2a15b901d32da23eb819f3172179a4f4995206c8d05a01a37c80a8b49b5ac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationBackgroundColor",
    jsii_struct_bases=[],
    name_mapping={"color": "color", "color_var": "colorVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationBackgroundColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__16226827cfaccc423b87e33d39c1af1f5d91e4cc6257fc5278d0d8699ba20482)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationBackgroundColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationBackgroundColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationBackgroundColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__46865a261806070bbf7b83584c22ca30abf5db9422aa160b6efed9b111a71d3a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationBackgroundColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5a03c0f9d8294f18d1efc65e8233de752c04c5705abbe21a4aafc134727443bd)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationBackgroundColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__da179cbb9eaf0a03fcc6104212dcb29e299b69e270a63dc59c0b05a864e4a49c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7e150c8b87f34e169a91436dce631303ade96dc78258ce644b36281ba58fdd7c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__76df48f247278e5d3e3c22165afcb4c901ae21539894fdf3d2b078a52c93f1b1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationBackgroundColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationBackgroundColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6293b6c399a8cebb8fbf7e27dc0133834e22fb17f6475a36472358aadda9129f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationBackgroundColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationBackgroundColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__66e761d7a7cc803654bf76693c9c6a0efda7c4726648d6b07c4785b751be4b50)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6386e26860554ac67788dd331da50f65488197fe46959f7805411e67ea6b1e7f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a15857fbf1b56eee0915d4dd7f9daefdf18c39c22be28d4da2fabd0275c2408e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationBackgroundColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationBackgroundColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationBackgroundColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__251c39465e923c1c9c1bd6385b1d0d32d9d32ff176e8dc0f6f23e3b5e63c4180)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationBlur",
    jsii_struct_bases=[],
    name_mapping={"sigma": "sigma", "sigma_var": "sigmaVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationBlur:
    def __init__(
        self,
        *,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param sigma: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__701c0d5bd4cb10a0a4909d06b7a20bc04b717e52c19151e245bf15e2acc700c8)
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationBlur(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationBlurList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationBlurList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__86e151fd67750782a1cb18ef4ec2fd531532f17cebf7da185f836ca60d5029f5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationBlurOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eba567becc579926feb6134b45d6862a28b44a26d69979d37e5a6eef314b800d)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationBlurOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9f427be7c2bdc6144f61fc3500d5ab6e44a154f1d51ef55277f37ef81cd0ff72)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d42cbdcd364d5c7a022d0565290077151825fa42fcecb3487b83dc6b10437db6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__47653a638b48195df200f76bc094986b38938783509683e849c69e18783c6629)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationBlur]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationBlur]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4e8a3f375eefdce5391b14a5f5e78c9fb83a5a87f492416926ec66c0ad70286b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationBlurOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationBlurOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6236e4bd4fc608b75e2d339b340657b5a80a2f7139892b61c9ae3896af859613)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bd3c85159afcd0ba7ee0c86c034cb8011654606dd5f245682d528412089fd2fb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__05a75e6704e671f4cbd2b77f15c6a9e0c808beef0d59089416d5d1a8c710f947)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationBlur]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationBlur]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationBlur]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4e05bf498af4f922ae9a87831b86e1694c861b3d7a9565277217629b95b6225c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationChromaKey",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_feather": "hueFeather",
        "hue_feather_var": "hueFeatherVar",
        "hue_tolerance": "hueTolerance",
        "hue_tolerance_var": "hueToleranceVar",
        "hue_var": "hueVar",
        "lightness_feather": "lightnessFeather",
        "lightness_feather_var": "lightnessFeatherVar",
        "lightness_tolerance": "lightnessTolerance",
        "lightness_tolerance_var": "lightnessToleranceVar",
        "saturation_feather": "saturationFeather",
        "saturation_feather_var": "saturationFeatherVar",
        "saturation_tolerance": "saturationTolerance",
        "saturation_tolerance_var": "saturationToleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationChromaKey:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_feather: typing.Optional[builtins.str] = None,
        hue_feather_var: typing.Optional[builtins.str] = None,
        hue_tolerance: typing.Optional[builtins.str] = None,
        hue_tolerance_var: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness_feather: typing.Optional[builtins.str] = None,
        lightness_feather_var: typing.Optional[builtins.str] = None,
        lightness_tolerance: typing.Optional[builtins.str] = None,
        lightness_tolerance_var: typing.Optional[builtins.str] = None,
        saturation_feather: typing.Optional[builtins.str] = None,
        saturation_feather_var: typing.Optional[builtins.str] = None,
        saturation_tolerance: typing.Optional[builtins.str] = None,
        saturation_tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_feather: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        :param hue_feather_var: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        :param hue_tolerance: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        :param hue_tolerance_var: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        :param hue_var: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness_feather: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        :param lightness_feather_var: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        :param lightness_tolerance: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        :param lightness_tolerance_var: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        :param saturation_feather: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        :param saturation_feather_var: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        :param saturation_tolerance: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        :param saturation_tolerance_var: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb9bdd4f4a6402fb643b69e392965f5120be2bc5787d749e00c4e5ec0f9d5865)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_feather", value=hue_feather, expected_type=type_hints["hue_feather"])
            check_type(argname="argument hue_feather_var", value=hue_feather_var, expected_type=type_hints["hue_feather_var"])
            check_type(argname="argument hue_tolerance", value=hue_tolerance, expected_type=type_hints["hue_tolerance"])
            check_type(argname="argument hue_tolerance_var", value=hue_tolerance_var, expected_type=type_hints["hue_tolerance_var"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness_feather", value=lightness_feather, expected_type=type_hints["lightness_feather"])
            check_type(argname="argument lightness_feather_var", value=lightness_feather_var, expected_type=type_hints["lightness_feather_var"])
            check_type(argname="argument lightness_tolerance", value=lightness_tolerance, expected_type=type_hints["lightness_tolerance"])
            check_type(argname="argument lightness_tolerance_var", value=lightness_tolerance_var, expected_type=type_hints["lightness_tolerance_var"])
            check_type(argname="argument saturation_feather", value=saturation_feather, expected_type=type_hints["saturation_feather"])
            check_type(argname="argument saturation_feather_var", value=saturation_feather_var, expected_type=type_hints["saturation_feather_var"])
            check_type(argname="argument saturation_tolerance", value=saturation_tolerance, expected_type=type_hints["saturation_tolerance"])
            check_type(argname="argument saturation_tolerance_var", value=saturation_tolerance_var, expected_type=type_hints["saturation_tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_feather is not None:
            self._values["hue_feather"] = hue_feather
        if hue_feather_var is not None:
            self._values["hue_feather_var"] = hue_feather_var
        if hue_tolerance is not None:
            self._values["hue_tolerance"] = hue_tolerance
        if hue_tolerance_var is not None:
            self._values["hue_tolerance_var"] = hue_tolerance_var
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness_feather is not None:
            self._values["lightness_feather"] = lightness_feather
        if lightness_feather_var is not None:
            self._values["lightness_feather_var"] = lightness_feather_var
        if lightness_tolerance is not None:
            self._values["lightness_tolerance"] = lightness_tolerance
        if lightness_tolerance_var is not None:
            self._values["lightness_tolerance_var"] = lightness_tolerance_var
        if saturation_feather is not None:
            self._values["saturation_feather"] = saturation_feather
        if saturation_feather_var is not None:
            self._values["saturation_feather_var"] = saturation_feather_var
        if saturation_tolerance is not None:
            self._values["saturation_tolerance"] = saturation_tolerance
        if saturation_tolerance_var is not None:
            self._values["saturation_tolerance_var"] = saturation_tolerance_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        '''
        result = self._values.get("hue_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        '''
        result = self._values.get("hue_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        '''
        result = self._values.get("hue_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        '''
        result = self._values.get("hue_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        '''
        result = self._values.get("lightness_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        '''
        result = self._values.get("lightness_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        '''
        result = self._values.get("lightness_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        '''
        result = self._values.get("lightness_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        '''
        result = self._values.get("saturation_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        '''
        result = self._values.get("saturation_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        '''
        result = self._values.get("saturation_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        result = self._values.get("saturation_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationChromaKey(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationChromaKeyList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationChromaKeyList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0bd4182083ccf7474112a8f84a9cd4e040b8da20dd5d9c21193a19c880e0473a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationChromaKeyOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b535d8ac7ebf914514bec8971981aef4bf5eaf80194216c6e63105935f39e99f)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationChromaKeyOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f826da330ec1d25ebc72b2267645d0d2f36ed7daff6e6bf93a99f907226a0a7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__66b249ba5924229af00992c2756bb8e48346525c7a7e51e38f375469a565e771)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac2d19312598266c628562575a35bc49ae9cd416945f55be5f5c6606d2b0d27d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationChromaKey]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationChromaKey]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ffd264330d41387401a01a5369a0a27101b6974ffd405b6f085877723c44ba99)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationChromaKeyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationChromaKeyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e8ff1f33ff483dfe12fe7ae9193548cb71ba359f1108f7804ef86573741f7029)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueFeather")
    def reset_hue_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeather", []))

    @jsii.member(jsii_name="resetHueFeatherVar")
    def reset_hue_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeatherVar", []))

    @jsii.member(jsii_name="resetHueTolerance")
    def reset_hue_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueTolerance", []))

    @jsii.member(jsii_name="resetHueToleranceVar")
    def reset_hue_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueToleranceVar", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightnessFeather")
    def reset_lightness_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeather", []))

    @jsii.member(jsii_name="resetLightnessFeatherVar")
    def reset_lightness_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeatherVar", []))

    @jsii.member(jsii_name="resetLightnessTolerance")
    def reset_lightness_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessTolerance", []))

    @jsii.member(jsii_name="resetLightnessToleranceVar")
    def reset_lightness_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessToleranceVar", []))

    @jsii.member(jsii_name="resetSaturationFeather")
    def reset_saturation_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeather", []))

    @jsii.member(jsii_name="resetSaturationFeatherVar")
    def reset_saturation_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeatherVar", []))

    @jsii.member(jsii_name="resetSaturationTolerance")
    def reset_saturation_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationTolerance", []))

    @jsii.member(jsii_name="resetSaturationToleranceVar")
    def reset_saturation_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherInput")
    def hue_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVarInput")
    def hue_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceInput")
    def hue_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVarInput")
    def hue_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherInput")
    def lightness_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVarInput")
    def lightness_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceInput")
    def lightness_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVarInput")
    def lightness_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherInput")
    def saturation_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVarInput")
    def saturation_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceInput")
    def saturation_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVarInput")
    def saturation_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__61e39fdbbb080eaf07f0ebf25858926d744382c95db0985eaa5a87f283df33ac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeather")
    def hue_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeather"))

    @hue_feather.setter
    def hue_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bf7f2ef822e7cef3a483fecf554f737f950ceff77bf4aec3aecd4a79f6ae04c5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeather", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVar")
    def hue_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeatherVar"))

    @hue_feather_var.setter
    def hue_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ce3acd49c07fb6114000cff48ba16f6a2b97a406a382e980bef396eaa2504050)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueTolerance")
    def hue_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueTolerance"))

    @hue_tolerance.setter
    def hue_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8f993dbcd00f2ea7766a8b5692a8d4a98a3f7b7ac5cc4ed2d4373cdbc5460a94)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVar")
    def hue_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueToleranceVar"))

    @hue_tolerance_var.setter
    def hue_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ff4471ed9b21e07d89d86a240a0cc7a00560c26b41e158545f0ca56300b0aea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__30cbf6bf25b1374684ffb3c108342974fa3b9e07cf2278f2b2cf19ff0f94af3d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeather")
    def lightness_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeather"))

    @lightness_feather.setter
    def lightness_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2b91dc2d22230c0cb3edd6e81b59f581b1ca75f06288e0f94a9f5fd801e751e8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeather", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVar")
    def lightness_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeatherVar"))

    @lightness_feather_var.setter
    def lightness_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b0c2554dab3c5b8d3df1a1cd1c2e450459c56586491afd9d2d6559c039882b4a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessTolerance")
    def lightness_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessTolerance"))

    @lightness_tolerance.setter
    def lightness_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__97bab305d4a780dddf6bc3e188db732164fd56f184fe4ec533e2b53ae2913c42)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVar")
    def lightness_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessToleranceVar"))

    @lightness_tolerance_var.setter
    def lightness_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8d10085226827436b9f3e5745e223ebf4702e30ace7c1ced09ade9a47ee7b361)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeather")
    def saturation_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeather"))

    @saturation_feather.setter
    def saturation_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b17e91ad64a4bd3448641dbe8fed7ce8b2155bc65603fed9d74a18de02dc8d20)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeather", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVar")
    def saturation_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeatherVar"))

    @saturation_feather_var.setter
    def saturation_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6dd5cca9eb37c5e57ca32cb908b6bd8f98ebcc7a49e335f237044d834dc633db)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationTolerance")
    def saturation_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationTolerance"))

    @saturation_tolerance.setter
    def saturation_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__092a66d1b0256a2bca6cb1eb84e6948313520912a96efc7592434082bf55b4f9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVar")
    def saturation_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationToleranceVar"))

    @saturation_tolerance_var.setter
    def saturation_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6c524a1d215eee3383e257617dd8d14dc453846113813f38dfa403b52e9269e2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationChromaKey]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationChromaKey]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationChromaKey]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__478e91cb06ebff918a5094e88a545402c06e615aeb397080c31f0ba5b8753a2a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationComposite",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "placement": "placement",
        "placement_var": "placementVar",
        "scale": "scale",
        "scale_dimension": "scaleDimension",
        "scale_dimension_var": "scaleDimensionVar",
        "scale_var": "scaleVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationComposite:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationCompositeImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        placement: typing.Optional[builtins.str] = None,
        placement_var: typing.Optional[builtins.str] = None,
        scale: typing.Optional[builtins.str] = None,
        scale_dimension: typing.Optional[builtins.str] = None,
        scale_dimension_var: typing.Optional[builtins.str] = None,
        scale_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param placement: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        :param placement_var: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        :param scale: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param scale_dimension: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        :param scale_dimension_var: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        :param scale_var: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        :param x_position: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationCompositeImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b2b5de646cb20c95e499cf503db3ca6c449f223b9322e62367a4688f12cc11e7)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument placement", value=placement, expected_type=type_hints["placement"])
            check_type(argname="argument placement_var", value=placement_var, expected_type=type_hints["placement_var"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument scale_dimension", value=scale_dimension, expected_type=type_hints["scale_dimension"])
            check_type(argname="argument scale_dimension_var", value=scale_dimension_var, expected_type=type_hints["scale_dimension_var"])
            check_type(argname="argument scale_var", value=scale_var, expected_type=type_hints["scale_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if placement is not None:
            self._values["placement"] = placement
        if placement_var is not None:
            self._values["placement_var"] = placement_var
        if scale is not None:
            self._values["scale"] = scale
        if scale_dimension is not None:
            self._values["scale_dimension"] = scale_dimension
        if scale_dimension_var is not None:
            self._values["scale_dimension_var"] = scale_dimension_var
        if scale_var is not None:
            self._values["scale_var"] = scale_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationCompositeImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationCompositeImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        '''
        result = self._values.get("placement")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement_var(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        '''
        result = self._values.get("placement_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        '''
        result = self._values.get("scale_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        '''
        result = self._values.get("scale_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        '''
        result = self._values.get("scale_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationComposite(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationCompositeImage",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationCompositeImage:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationCompositeImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationCompositeImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationCompositeImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2835cb33ef130af592d7528f387148787eac75e5dee6b97ae1a497a075163aa5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationCompositeImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationCompositeImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__900fb515ce3f7ec0572be3bde22870c974914e0c88e5301f235f849d3c61a262)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationCompositeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationCompositeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6cc078a575a988b92eb31bc7dd9ec37d5c7c397571e9a45127d23edd856e5a69)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationCompositeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b1c369bd71cee0d29beb7778c14b66408c325b38052cca0c00bcd1755a80b948)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationCompositeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1fec5ce6d19aebf206248e9e88e9fc0bb23ee9c5e130db0bee59981777c839e1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d9e6a12762ba818ef0d5c55630d754159a880dad116241c8cecc08adb33bbc9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__91a5ba72f71f191a7f194e2282173acd28099dbcae3d487d8247fa797a758882)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationComposite]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationComposite]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__09f7425d1a93060123162845213a221879271e23d8dc5abc8eb1f1e3e02716a3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationCompositeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationCompositeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7179ca65e397a557f5fdf8a772af70b3d9b2569e4606b8a54d701416fc75f754)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationCompositeImage()

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPlacement")
    def reset_placement(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacement", []))

    @jsii.member(jsii_name="resetPlacementVar")
    def reset_placement_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacementVar", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetScaleDimension")
    def reset_scale_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimension", []))

    @jsii.member(jsii_name="resetScaleDimensionVar")
    def reset_scale_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimensionVar", []))

    @jsii.member(jsii_name="resetScaleVar")
    def reset_scale_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationCompositeImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationCompositeImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationCompositeImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="placementInput")
    def placement_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementInput"))

    @builtins.property
    @jsii.member(jsii_name="placementVarInput")
    def placement_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionInput")
    def scale_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVarInput")
    def scale_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleVarInput")
    def scale_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f2fdd1a905e5060c2d5bd2004832affc1101130c109906a0b2bd6c53cd59c06f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e070243030c3e417d21a24b91d445d688ec0bee9c05d6d4e6a843e9f7f339fdc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="placement")
    def placement(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placement"))

    @placement.setter
    def placement(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__17ce910310ab736733068f854c0c067f982ff7b97d6609fb215127df41a4e71d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placement", value)

    @builtins.property
    @jsii.member(jsii_name="placementVar")
    def placement_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placementVar"))

    @placement_var.setter
    def placement_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bef07264d0b3c6d94ddf84a706450050d7e1856603122f7c9043e5147e6df42a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placementVar", value)

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scale"))

    @scale.setter
    def scale(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e383c9d64318341fe18e6050b17573f8db630fba06e82e9fbe74423cddee2d8a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scale", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimension")
    def scale_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimension"))

    @scale_dimension.setter
    def scale_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__15af78e8618423d83d8b48786cf6661f5be6f4b6d39d853ec2df648c2d1157d8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimension", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVar")
    def scale_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimensionVar"))

    @scale_dimension_var.setter
    def scale_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__981cb57d8aa81951522f2f49601add52b85601f30e7ffa9d99eb453fb683298e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="scaleVar")
    def scale_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleVar"))

    @scale_var.setter
    def scale_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a9480d7c751ad9fe053aa0e6ff283a5a27fd4005130e652ac3720b1d352047eb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ba456eab0b31377b3caa0068753dc74ce1360cabe4a1cbdd40d20f645f6b2778)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__12ab8aa465b50da4e92e08faf69df90afae97cd9bbed51e7504bfe3dabb09b55)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb8009695b6100b0045a52d540870ca223e73d065c580285a632e8ef8d245c8c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f9f94b6eac514a7b3da08b6c6c08f45f96f24eb7aaffa5e2b38bb59ceb4b83bf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationComposite]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationComposite]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationComposite]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fb2f8b0aa04dd98fc810e5033f68b3d680a935a2ab573026c8f2711b0f81a7ea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationCompound",
    jsii_struct_bases=[],
    name_mapping={"transformations": "transformations"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationCompound:
    def __init__(
        self,
        *,
        transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param transformations: transformations block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e11cf0f215bdb360fd1166dd841baceaf4059e6ee6552961a0046dd2ec480598)
            check_type(argname="argument transformations", value=transformations, expected_type=type_hints["transformations"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if transformations is not None:
            self._values["transformations"] = transformations

    @builtins.property
    def transformations(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationCompoundTransformations"]]]:
        '''transformations block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        result = self._values.get("transformations")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationCompoundTransformations"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationCompound(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationCompoundList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationCompoundList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b6ffba19236a2d069b2bd8b1d68e04e8283bc52ca2f3c1cc54c35b73772bfff6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationCompoundOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f8e7cfab01e65d12edccfeb8f1551237ee5cb56328c99a114e532f762098579c)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationCompoundOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__94daa6435fb0cdc838ec85d7945e70c95589abeb1e91c75cc61418cdb7aa6fbe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9b4dc2c4769f018599df6e0b4e53dc4f40072e5dc81acc62664ab8a30c8308b4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8eb8aeb09b6296ec14704b4286761500fe42217f4817e8bd64c005c15c5880c4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationCompound]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationCompound]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__77bdae18390716cd15f53a5e7534107810edbbebf483de652cfd00a4101db332)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationCompoundOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationCompoundOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__32e23c3ee8fd7009ac0faf750a33ab617e430f614911507371df0a195248e96d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformations")
    def put_transformations(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__63b00f9233e9fe572ad26cc5351f494e5740818ddb78598d408c8e1ad50a792f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTransformations", [value]))

    @jsii.member(jsii_name="resetTransformations")
    def reset_transformations(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformations", []))

    @builtins.property
    @jsii.member(jsii_name="transformations")
    def transformations(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationCompoundTransformationsList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationCompoundTransformationsList", jsii.get(self, "transformations"))

    @builtins.property
    @jsii.member(jsii_name="transformationsInput")
    def transformations_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationCompoundTransformations"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationCompoundTransformations"]]], jsii.get(self, "transformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationCompound]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationCompound]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationCompound]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1a16935e4aa3c1763c283fe8f9b131ea8b2e57fd986e53a87db3bf56673423df)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationCompoundTransformations",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationCompoundTransformations:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationCompoundTransformations(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationCompoundTransformationsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationCompoundTransformationsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__56cf33705b1c020300d4445b9b78ef4b637d445c58861fc10b7f77cbab53ce88)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationCompoundTransformationsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__795eb894d8aae007687a38422ad9e7cacf4a7c744ab1e68d0c842c32838ffac2)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationCompoundTransformationsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1d485b70dfa305ab09154357dc8f655f5b26ce51989e17372a6c1e8205467b6c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__02048c25eea9736e6fc2e2e1b534593979aedc815f7fe08855222b89a2a5c8fc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e1cfaae297b74d33f30ae2ff27db0495c5537aa68673a9afb0943463e70a355f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationCompoundTransformations]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationCompoundTransformations]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationCompoundTransformations]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__83d73ba9f7c43c8c86cdf6f409ea9d9fd3a9f6792602329716b3bb8cb1118b3f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationCompoundTransformationsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationCompoundTransformationsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f88ed9f566d9af35153f36e27d755b23e34310a1c63fe61222cc96faab3f50f1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationCompoundTransformations]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationCompoundTransformations]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationCompoundTransformations]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ec43c5e2d0556f842100aec7a7de8a4513503ecb4ed8bf5fe9f36a3bebf1755f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationContrast",
    jsii_struct_bases=[],
    name_mapping={
        "brightness": "brightness",
        "brightness_var": "brightnessVar",
        "contrast": "contrast",
        "contrast_var": "contrastVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationContrast:
    def __init__(
        self,
        *,
        brightness: typing.Optional[builtins.str] = None,
        brightness_var: typing.Optional[builtins.str] = None,
        contrast: typing.Optional[builtins.str] = None,
        contrast_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param brightness: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        :param brightness_var: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        :param contrast: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param contrast_var: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0a767cfd951e7d337389a6150cef65ef3956866b6ae9282a4b93c2fde0a2d53e)
            check_type(argname="argument brightness", value=brightness, expected_type=type_hints["brightness"])
            check_type(argname="argument brightness_var", value=brightness_var, expected_type=type_hints["brightness_var"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument contrast_var", value=contrast_var, expected_type=type_hints["contrast_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if brightness is not None:
            self._values["brightness"] = brightness
        if brightness_var is not None:
            self._values["brightness_var"] = brightness_var
        if contrast is not None:
            self._values["contrast"] = contrast
        if contrast_var is not None:
            self._values["contrast_var"] = contrast_var

    @builtins.property
    def brightness(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        '''
        result = self._values.get("brightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def brightness_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        '''
        result = self._values.get("brightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        result = self._values.get("contrast_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationContrast(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationContrastList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationContrastList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__526a23b95e99c29c28e25d7a8a9ee0613f86ebe4bab1a270b59a063b5addf353)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationContrastOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__05265f04e06f81cb01bcec6ff99b04eb235e4dd6717bbeb0f8cb40bc6f7ee23e)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationContrastOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ee802d1121c081db1c0bd53ef499defcd63f4c51c373bffd030fb908af4a1660)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b2881cc0714c7ab98d9d83723e04abe4e0edac86695c61c0287c45c2c701fdd0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__953198da7042b639392c7308c7840028a5f5e2c1fc1046d6c75e5311f1f784b2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationContrast]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationContrast]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__77f22d523455412084deba5e7acd417e8a59449545ccd8569e21758fbd4c0aa3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationContrastOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationContrastOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c3f544c1a8e400cbb2c1b6267b659cf0418e56ec3e689f7b25c5129fd84c2cc0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetBrightness")
    def reset_brightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightness", []))

    @jsii.member(jsii_name="resetBrightnessVar")
    def reset_brightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightnessVar", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetContrastVar")
    def reset_contrast_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrastVar", []))

    @builtins.property
    @jsii.member(jsii_name="brightnessInput")
    def brightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="brightnessVarInput")
    def brightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastVarInput")
    def contrast_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="brightness")
    def brightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightness"))

    @brightness.setter
    def brightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__050982edcb8c4a373c3aa2e7b2cf646deb796060f5714d061374a20d80df2518)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightness", value)

    @builtins.property
    @jsii.member(jsii_name="brightnessVar")
    def brightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightnessVar"))

    @brightness_var.setter
    def brightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0a71433ba02d62ab0f99617f3cd907617473a5088a4f2c8880ecb7c8549d087d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrast"))

    @contrast.setter
    def contrast(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e4379409f246c4c53e7f3a5e05a1186a82a9c5de068827f6d764e9605be06e3f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrast", value)

    @builtins.property
    @jsii.member(jsii_name="contrastVar")
    def contrast_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrastVar"))

    @contrast_var.setter
    def contrast_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c037cd8e17b784c8baa4309e98d7ddec362940556ab6a7922dab4f6720ddf55f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrastVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationContrast]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationContrast]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationContrast]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7ece11dbf993952d6a487219f8afba94598e93556f3e3393fd52ac0436c048e2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationCrop",
    jsii_struct_bases=[],
    name_mapping={
        "allow_expansion": "allowExpansion",
        "allow_expansion_var": "allowExpansionVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationCrop:
    def __init__(
        self,
        *,
        allow_expansion: typing.Optional[builtins.str] = None,
        allow_expansion_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_expansion: If cropping an area outside of the existing canvas, expands the image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        :param allow_expansion_var: If cropping an area outside of the existing canvas, expands the image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        :param gravity: Frame of reference for X and Y Positions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Frame of reference for X and Y Positions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The number of pixels to crop along the y-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The number of pixels to crop along the y-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The number of pixels to crop along the x-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The number of pixels to crop along the x-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        :param x_position: The x-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e5ac9b89c2f6840890e3d71e13812634d4796780811951315e7efb40c1205754)
            check_type(argname="argument allow_expansion", value=allow_expansion, expected_type=type_hints["allow_expansion"])
            check_type(argname="argument allow_expansion_var", value=allow_expansion_var, expected_type=type_hints["allow_expansion_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if allow_expansion is not None:
            self._values["allow_expansion"] = allow_expansion
        if allow_expansion_var is not None:
            self._values["allow_expansion_var"] = allow_expansion_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def allow_expansion(self) -> typing.Optional[builtins.str]:
        '''If cropping an area outside of the existing canvas, expands the image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        '''
        result = self._values.get("allow_expansion")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def allow_expansion_var(self) -> typing.Optional[builtins.str]:
        '''If cropping an area outside of the existing canvas, expands the image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        '''
        result = self._values.get("allow_expansion_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Frame of reference for X and Y Positions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Frame of reference for X and Y Positions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the y-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the y-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the x-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the x-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__706fd56a9acf6557501cfc834451b577a3e16e62f52757a2bac015596331cdd8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__84c1e08e7a69bbe3a03c8b4dc10e9ac3ab23c43050148d55811686bac8ed7ff5)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__69fefb40270fbfc7db28d3ad0f9643c4578f64c598e679869ab98d7da9a74a44)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7e6bea646e6af224474a887f0db823379b79eb1cefb33b61bab77a6c5d2e1a14)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__199fff057d371fadce3b055d1b28474a079031617f9ddda4c5702c374aa009e8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f5dbbbeb2bd63d19a8d29a68c377597707b236ca47985cb68d2d5dc77ab190cc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aad0eba3a20bad8704a1f6abb64e1db66fa9adc2bd567aea6ce0d7d69b74746a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAllowExpansion")
    def reset_allow_expansion(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansion", []))

    @jsii.member(jsii_name="resetAllowExpansionVar")
    def reset_allow_expansion_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansionVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionInput")
    def allow_expansion_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVarInput")
    def allow_expansion_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansion")
    def allow_expansion(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansion"))

    @allow_expansion.setter
    def allow_expansion(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d809bd62455442d1bcf9f7d3d5bcbeb610e735765878b4ffb3cb71012844949d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansion", value)

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVar")
    def allow_expansion_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansionVar"))

    @allow_expansion_var.setter
    def allow_expansion_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af289a7602e7602e929b19a1ce4cd38b713032b9b5b4dbdd770b99415125aaf2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansionVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8210333772b8b802557fb66ab7960533f25d84c1ab3305f683195f42d1738ea4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f54cc042f42b758f774ecbf6653884f43bc7d1ec5dcd303cd8e141b5ef7ee15a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e06e2d2d342119e2e9fceeb1188703658f0d6960fc7afac6cbb5e028c5f64cab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a7570242b6c2438289a92ab7d149e7495cb5e8096a4c9d1232b85e898753a53)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2f36f5cb21180fde7432b7b7b3fbc440508dd72ccf080cdc18df6189c6142f01)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6aa33fbc476b0b592d6e88d01cb99a4915b75604d04e5e15e54befcd12fa75f3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a0621af6b460105ceefc8eddd7b7598a89042cdaf653e66d12042e093a58b15)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6b515cd5270bff2a456f485ef17e171d3bc28caf085c7ecad77b1bcfe2015ec2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0b0755efba9f0e5d31f1ad76ef51c7c28006e642c8bd8f000f87aad073a0bed1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__64e0a59d0439794740a35ffb87af3c5de8d165b7f653a1351fc7e8bb39a9cca7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__de601002aff75dc00c209a7d90ce3214a23f990d508de5c8dcb53431353ed027)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationFaceCrop",
    jsii_struct_bases=[],
    name_mapping={
        "algorithm": "algorithm",
        "algorithm_var": "algorithmVar",
        "confidence": "confidence",
        "confidence_var": "confidenceVar",
        "fail_gravity": "failGravity",
        "fail_gravity_var": "failGravityVar",
        "focus": "focus",
        "focus_var": "focusVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "padding": "padding",
        "padding_var": "paddingVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationFaceCrop:
    def __init__(
        self,
        *,
        algorithm: typing.Optional[builtins.str] = None,
        algorithm_var: typing.Optional[builtins.str] = None,
        confidence: typing.Optional[builtins.str] = None,
        confidence_var: typing.Optional[builtins.str] = None,
        fail_gravity: typing.Optional[builtins.str] = None,
        fail_gravity_var: typing.Optional[builtins.str] = None,
        focus: typing.Optional[builtins.str] = None,
        focus_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param algorithm: Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm DataAkamaiImagingPolicyImage#algorithm}
        :param algorithm_var: Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm_var DataAkamaiImagingPolicyImage#algorithm_var}
        :param confidence: With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image. Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence DataAkamaiImagingPolicyImage#confidence}
        :param confidence_var: With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image. Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence_var DataAkamaiImagingPolicyImage#confidence_var}
        :param fail_gravity: Controls placement of the crop if Image and Video Manager does not detect any faces in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        :param fail_gravity_var: Controls placement of the crop if Image and Video Manager does not detect any faces in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        :param focus: Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus DataAkamaiImagingPolicyImage#focus}
        :param focus_var: Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus_var DataAkamaiImagingPolicyImage#focus_var}
        :param gravity: Controls placement of the crop. Directions are relative to the face(s) plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Controls placement of the crop. Directions are relative to the face(s) plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param padding: The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        :param style: Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f5292f465c0e8ba01ed1a8ce9c31833a15846ddd7d58f8db504ca36b905aff7c)
            check_type(argname="argument algorithm", value=algorithm, expected_type=type_hints["algorithm"])
            check_type(argname="argument algorithm_var", value=algorithm_var, expected_type=type_hints["algorithm_var"])
            check_type(argname="argument confidence", value=confidence, expected_type=type_hints["confidence"])
            check_type(argname="argument confidence_var", value=confidence_var, expected_type=type_hints["confidence_var"])
            check_type(argname="argument fail_gravity", value=fail_gravity, expected_type=type_hints["fail_gravity"])
            check_type(argname="argument fail_gravity_var", value=fail_gravity_var, expected_type=type_hints["fail_gravity_var"])
            check_type(argname="argument focus", value=focus, expected_type=type_hints["focus"])
            check_type(argname="argument focus_var", value=focus_var, expected_type=type_hints["focus_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if algorithm is not None:
            self._values["algorithm"] = algorithm
        if algorithm_var is not None:
            self._values["algorithm_var"] = algorithm_var
        if confidence is not None:
            self._values["confidence"] = confidence
        if confidence_var is not None:
            self._values["confidence_var"] = confidence_var
        if fail_gravity is not None:
            self._values["fail_gravity"] = fail_gravity
        if fail_gravity_var is not None:
            self._values["fail_gravity_var"] = fail_gravity_var
        if focus is not None:
            self._values["focus"] = focus
        if focus_var is not None:
            self._values["focus_var"] = focus_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def algorithm(self) -> typing.Optional[builtins.str]:
        '''Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm DataAkamaiImagingPolicyImage#algorithm}
        '''
        result = self._values.get("algorithm")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def algorithm_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm_var DataAkamaiImagingPolicyImage#algorithm_var}
        '''
        result = self._values.get("algorithm_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def confidence(self) -> typing.Optional[builtins.str]:
        '''With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image.

        Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence DataAkamaiImagingPolicyImage#confidence}
        '''
        result = self._values.get("confidence")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def confidence_var(self) -> typing.Optional[builtins.str]:
        '''With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image.

        Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence_var DataAkamaiImagingPolicyImage#confidence_var}
        '''
        result = self._values.get("confidence_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any faces in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        '''
        result = self._values.get("fail_gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any faces in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        '''
        result = self._values.get("fail_gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def focus(self) -> typing.Optional[builtins.str]:
        '''Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus DataAkamaiImagingPolicyImage#focus}
        '''
        result = self._values.get("focus")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def focus_var(self) -> typing.Optional[builtins.str]:
        '''Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus_var DataAkamaiImagingPolicyImage#focus_var}
        '''
        result = self._values.get("focus_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the face(s) plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the face(s) plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationFaceCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationFaceCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationFaceCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7c69e964f7e6d3b9788eebb6cbeef71a36bda39c178e9d01e9a84783f06fa930)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationFaceCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__16205dd5857c1f4169502aee8ee6d4f914ff01e523f765f7cd14c5087f78f04b)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationFaceCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eb047f466928c33b1d414cba6cf94dc2fc6149bac7c5499a6b4fbae2c9dd76d8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__26c7f866399a3158ab258384d44c7e26a2c33cfc78d588876cc186762ab2499b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2845ca9f41b7b4e09683a8646803f3c38d2ea877a7f26bbe1bb1ba278c8d82e6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationFaceCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationFaceCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationFaceCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5c652c05c57d7c3c7d668d4a667e7c92f626db0b4c489225bb74c9b5b6c3c2da)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationFaceCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationFaceCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__27f3d7d17709093da27888e2aad89f646fcbf077ff303783504ca94ab818b099)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAlgorithm")
    def reset_algorithm(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAlgorithm", []))

    @jsii.member(jsii_name="resetAlgorithmVar")
    def reset_algorithm_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAlgorithmVar", []))

    @jsii.member(jsii_name="resetConfidence")
    def reset_confidence(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetConfidence", []))

    @jsii.member(jsii_name="resetConfidenceVar")
    def reset_confidence_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetConfidenceVar", []))

    @jsii.member(jsii_name="resetFailGravity")
    def reset_fail_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravity", []))

    @jsii.member(jsii_name="resetFailGravityVar")
    def reset_fail_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravityVar", []))

    @jsii.member(jsii_name="resetFocus")
    def reset_focus(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFocus", []))

    @jsii.member(jsii_name="resetFocusVar")
    def reset_focus_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFocusVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="algorithmInput")
    def algorithm_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "algorithmInput"))

    @builtins.property
    @jsii.member(jsii_name="algorithmVarInput")
    def algorithm_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "algorithmVarInput"))

    @builtins.property
    @jsii.member(jsii_name="confidenceInput")
    def confidence_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "confidenceInput"))

    @builtins.property
    @jsii.member(jsii_name="confidenceVarInput")
    def confidence_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "confidenceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityInput")
    def fail_gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityVarInput")
    def fail_gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="focusInput")
    def focus_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "focusInput"))

    @builtins.property
    @jsii.member(jsii_name="focusVarInput")
    def focus_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "focusVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="algorithm")
    def algorithm(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "algorithm"))

    @algorithm.setter
    def algorithm(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f26e21d4f82cc70ee768554f204ac04737df087ae5ada97cdca887c813d99b93)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "algorithm", value)

    @builtins.property
    @jsii.member(jsii_name="algorithmVar")
    def algorithm_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "algorithmVar"))

    @algorithm_var.setter
    def algorithm_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9dab16f470ba216cc1b4ae7f039788fa6b63dc47abb1d553f1c4498b65668328)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "algorithmVar", value)

    @builtins.property
    @jsii.member(jsii_name="confidence")
    def confidence(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "confidence"))

    @confidence.setter
    def confidence(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d8f99efe55a1fc2b7a143c688879893089e736f7b8f12fa35bd9290721f30a24)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "confidence", value)

    @builtins.property
    @jsii.member(jsii_name="confidenceVar")
    def confidence_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "confidenceVar"))

    @confidence_var.setter
    def confidence_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5eb670e6de9e34f76964f2cdc8b32d78ba2e3a06df59348726644cbbfee0de34)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "confidenceVar", value)

    @builtins.property
    @jsii.member(jsii_name="failGravity")
    def fail_gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravity"))

    @fail_gravity.setter
    def fail_gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8e55a473d86e4a3c028832d4206b32128d3bf24e8d33acdee51d16911c2fa790)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravity", value)

    @builtins.property
    @jsii.member(jsii_name="failGravityVar")
    def fail_gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravityVar"))

    @fail_gravity_var.setter
    def fail_gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__368610ce8633bdae4b4826034c81bc282ee5d7d80544ec5c5c2b7bd2972f33d5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="focus")
    def focus(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "focus"))

    @focus.setter
    def focus(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__61ad68d5d4415319c884491b93ae06539e61a94182836ee819cad0fa21a3d9fe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "focus", value)

    @builtins.property
    @jsii.member(jsii_name="focusVar")
    def focus_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "focusVar"))

    @focus_var.setter
    def focus_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3287d31f9a845f6ad31884a762750ce27e44e000bab1d288693fd845b1afca96)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "focusVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__76311398a830bd23375987c5474b6d29b2224fe70aaebbd68cb03c21e756a216)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__190e0822679aeb3a491914d1571101931d43c6b541a374361104f73fb67dac8f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d623cdc7646d140f444359f3caf921ba4fa4ddb58bece6a621a1019678f8395)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5a7fc19f80a5a78d0c4dc6ede63e25c7b12e3e9298cfebbd7c953c84a4706323)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__15ed442ce046c1712d6a18d6c804ac0954ad6d8c2d6414c12dfdb482bd3bf4f2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__17b1be40d3392108a3eaeed5627dc2a8961181b7cc6375ef8b7dcb95cf266dd7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__501e096dd302c243354699bf66f8762c629a85e77567f293ef59855b2b960c69)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac663e79cba5618b21121f0f4a5dfb9eee41ecc550ce38ee213bfaf2795b0b26)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5efaec5123a8652b5c66f75102f2b80d1e1c8546be3cf8d3e25586a1b957b5c0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__190732c9e59744096124665210c16dc85468e20e650c88669c99b66ace2b84f5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationFaceCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationFaceCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationFaceCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa2d0f126b8bf54745a2f2e4d9c8971f97f838ed26f6076911443bde00e388da)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationFeatureCrop",
    jsii_struct_bases=[],
    name_mapping={
        "fail_gravity": "failGravity",
        "fail_gravity_var": "failGravityVar",
        "feature_radius": "featureRadius",
        "feature_radius_var": "featureRadiusVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "max_features": "maxFeatures",
        "max_features_var": "maxFeaturesVar",
        "min_feature_quality": "minFeatureQuality",
        "min_feature_quality_var": "minFeatureQualityVar",
        "padding": "padding",
        "padding_var": "paddingVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationFeatureCrop:
    def __init__(
        self,
        *,
        fail_gravity: typing.Optional[builtins.str] = None,
        fail_gravity_var: typing.Optional[builtins.str] = None,
        feature_radius: typing.Optional[builtins.str] = None,
        feature_radius_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        max_features: typing.Optional[builtins.str] = None,
        max_features_var: typing.Optional[builtins.str] = None,
        min_feature_quality: typing.Optional[builtins.str] = None,
        min_feature_quality_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fail_gravity: Controls placement of the crop if Image and Video Manager does not detect any features in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        :param fail_gravity_var: Controls placement of the crop if Image and Video Manager does not detect any features in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        :param feature_radius: The size in pixels of the important features to search for. If identified, two features never appear closer together than this value, ``8.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius DataAkamaiImagingPolicyImage#feature_radius}
        :param feature_radius_var: The size in pixels of the important features to search for. If identified, two features never appear closer together than this value, ``8.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius_var DataAkamaiImagingPolicyImage#feature_radius_var}
        :param gravity: Controls placement of the crop. Directions are relative to the region of interest plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Controls placement of the crop. Directions are relative to the region of interest plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param max_features: The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features DataAkamaiImagingPolicyImage#max_features}
        :param max_features_var: The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features_var DataAkamaiImagingPolicyImage#max_features_var}
        :param min_feature_quality: Determines the minimum quality level of the feature identified. To consider a feature important, the feature needs to surpass this value. Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality DataAkamaiImagingPolicyImage#min_feature_quality}
        :param min_feature_quality_var: Determines the minimum quality level of the feature identified. To consider a feature important, the feature needs to surpass this value. Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality_var DataAkamaiImagingPolicyImage#min_feature_quality_var}
        :param padding: Adds space around the region of interest. The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: Adds space around the region of interest. The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        :param style: Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__74ae04cf7b5f64f556f6781b708aecf1ef6759b4d7136978ff94f3c4f176b1e7)
            check_type(argname="argument fail_gravity", value=fail_gravity, expected_type=type_hints["fail_gravity"])
            check_type(argname="argument fail_gravity_var", value=fail_gravity_var, expected_type=type_hints["fail_gravity_var"])
            check_type(argname="argument feature_radius", value=feature_radius, expected_type=type_hints["feature_radius"])
            check_type(argname="argument feature_radius_var", value=feature_radius_var, expected_type=type_hints["feature_radius_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument max_features", value=max_features, expected_type=type_hints["max_features"])
            check_type(argname="argument max_features_var", value=max_features_var, expected_type=type_hints["max_features_var"])
            check_type(argname="argument min_feature_quality", value=min_feature_quality, expected_type=type_hints["min_feature_quality"])
            check_type(argname="argument min_feature_quality_var", value=min_feature_quality_var, expected_type=type_hints["min_feature_quality_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fail_gravity is not None:
            self._values["fail_gravity"] = fail_gravity
        if fail_gravity_var is not None:
            self._values["fail_gravity_var"] = fail_gravity_var
        if feature_radius is not None:
            self._values["feature_radius"] = feature_radius
        if feature_radius_var is not None:
            self._values["feature_radius_var"] = feature_radius_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if max_features is not None:
            self._values["max_features"] = max_features
        if max_features_var is not None:
            self._values["max_features_var"] = max_features_var
        if min_feature_quality is not None:
            self._values["min_feature_quality"] = min_feature_quality
        if min_feature_quality_var is not None:
            self._values["min_feature_quality_var"] = min_feature_quality_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def fail_gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any features in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        '''
        result = self._values.get("fail_gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any features in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        '''
        result = self._values.get("fail_gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feature_radius(self) -> typing.Optional[builtins.str]:
        '''The size in pixels of the important features to search for.

        If identified, two features never appear closer together than this value, ``8.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius DataAkamaiImagingPolicyImage#feature_radius}
        '''
        result = self._values.get("feature_radius")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feature_radius_var(self) -> typing.Optional[builtins.str]:
        '''The size in pixels of the important features to search for.

        If identified, two features never appear closer together than this value, ``8.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius_var DataAkamaiImagingPolicyImage#feature_radius_var}
        '''
        result = self._values.get("feature_radius_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the region of interest plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the region of interest plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def max_features(self) -> typing.Optional[builtins.str]:
        '''The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features DataAkamaiImagingPolicyImage#max_features}
        '''
        result = self._values.get("max_features")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def max_features_var(self) -> typing.Optional[builtins.str]:
        '''The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features_var DataAkamaiImagingPolicyImage#max_features_var}
        '''
        result = self._values.get("max_features_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def min_feature_quality(self) -> typing.Optional[builtins.str]:
        '''Determines the minimum quality level of the feature identified.

        To consider a feature important, the feature needs to surpass this value.  Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality DataAkamaiImagingPolicyImage#min_feature_quality}
        '''
        result = self._values.get("min_feature_quality")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def min_feature_quality_var(self) -> typing.Optional[builtins.str]:
        '''Determines the minimum quality level of the feature identified.

        To consider a feature important, the feature needs to surpass this value.  Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality_var DataAkamaiImagingPolicyImage#min_feature_quality_var}
        '''
        result = self._values.get("min_feature_quality_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''Adds space around the region of interest.

        The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''Adds space around the region of interest.

        The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationFeatureCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationFeatureCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationFeatureCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aa223e136b8503df00e142a26ce79554bd17ff8fe32d31d502bd5de46d7ebbb3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationFeatureCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ae3146cfaebf4b29173b7d7f389d8c837d7bf6959119fbadd18674f1aee9be70)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationFeatureCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__03cb9a806c56073d661e3eb81ee1978539546d274f2b20dd98758c9641aec982)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb0ecba38cd3b8e0380ac91bf0c7d7d9b7c9f0e986dc35d982dcae50058538df)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ad48e4baae7f871ac8684089da16ca582ee7104e08d0fb26cf0a7d1a71cfe4f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationFeatureCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationFeatureCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationFeatureCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__18415842ef36631f602dabbc9d85910874729679fe1f7708b9e1608268df3b01)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationFeatureCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationFeatureCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__57fbdea4338f0a39cf11ec3b79b530849cc1b91e01416657690d88ed977e0146)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetFailGravity")
    def reset_fail_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravity", []))

    @jsii.member(jsii_name="resetFailGravityVar")
    def reset_fail_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravityVar", []))

    @jsii.member(jsii_name="resetFeatureRadius")
    def reset_feature_radius(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureRadius", []))

    @jsii.member(jsii_name="resetFeatureRadiusVar")
    def reset_feature_radius_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureRadiusVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetMaxFeatures")
    def reset_max_features(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxFeatures", []))

    @jsii.member(jsii_name="resetMaxFeaturesVar")
    def reset_max_features_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxFeaturesVar", []))

    @jsii.member(jsii_name="resetMinFeatureQuality")
    def reset_min_feature_quality(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMinFeatureQuality", []))

    @jsii.member(jsii_name="resetMinFeatureQualityVar")
    def reset_min_feature_quality_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMinFeatureQualityVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="failGravityInput")
    def fail_gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityVarInput")
    def fail_gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featureRadiusInput")
    def feature_radius_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featureRadiusInput"))

    @builtins.property
    @jsii.member(jsii_name="featureRadiusVarInput")
    def feature_radius_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featureRadiusVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesInput")
    def max_features_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "maxFeaturesInput"))

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesVarInput")
    def max_features_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "maxFeaturesVarInput"))

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityInput")
    def min_feature_quality_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "minFeatureQualityInput"))

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityVarInput")
    def min_feature_quality_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "minFeatureQualityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravity")
    def fail_gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravity"))

    @fail_gravity.setter
    def fail_gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9046874a6cb11210204ab786b5787270b3e43b07c93300e5cba6bde3d5fee017)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravity", value)

    @builtins.property
    @jsii.member(jsii_name="failGravityVar")
    def fail_gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravityVar"))

    @fail_gravity_var.setter
    def fail_gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__62ff7d159964eddeb7b1aea27c3dd7d5ab610e1cee1db692bd291af3771bc36f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="featureRadius")
    def feature_radius(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featureRadius"))

    @feature_radius.setter
    def feature_radius(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__efa80b9d8a6a23e50b7911229237d214557a1a2d162ac1d403f42ffa431e4da8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featureRadius", value)

    @builtins.property
    @jsii.member(jsii_name="featureRadiusVar")
    def feature_radius_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featureRadiusVar"))

    @feature_radius_var.setter
    def feature_radius_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__30414c2d152e2798c1ea6a4225f99f49189cc48fd7c3a809c02bb9160b9e02e9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featureRadiusVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__42e8344bb53839a86e397cf3f08e2a792f3c3c99efd74b0c24570e50ae6a191f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ef1461a365ed95053284b791d1add7a5ad206340e651add24ed28000fafc2049)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f7f0356771d5433069e25dd12bc3f6a157245ba8ffddb4336b0adb8262df5c99)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1e65e07a2003a15aea5c2eaf962ee4b243c5354527a180727526b36068c0a96f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="maxFeatures")
    def max_features(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "maxFeatures"))

    @max_features.setter
    def max_features(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__137ad7de66c8b0b48469630c17ca9b0f6d3c80a16792135cbfcf83863add01e6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "maxFeatures", value)

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesVar")
    def max_features_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "maxFeaturesVar"))

    @max_features_var.setter
    def max_features_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a86ff243de079c76aaacecfc57800fc1e8aeaf3e57c1fda416856c3817e5baa2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "maxFeaturesVar", value)

    @builtins.property
    @jsii.member(jsii_name="minFeatureQuality")
    def min_feature_quality(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "minFeatureQuality"))

    @min_feature_quality.setter
    def min_feature_quality(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3be0060ba4805730e0b784d2abfdbe8ddfe594876216a99b7669f94c43f184b0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "minFeatureQuality", value)

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityVar")
    def min_feature_quality_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "minFeatureQualityVar"))

    @min_feature_quality_var.setter
    def min_feature_quality_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6269024d1e2d0670ff5a0b868aac5d64866f6d4f6be4ed52fee2bbae9029201b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "minFeatureQualityVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__03e269b6e389734ae810be94e9b965a7b6546fc944aa1d2c5af46a83d0d9b84d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b142222d4b959a0b3a1fa183a297bfd0894a35056e37e677494cdf8ef89c7dbc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ca91790e98ca27be0daf24a13a2a9a337a8d9667f740519f9c08a6be69d5eeba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__16ce7406e268a885ae17cbadb22386007e288b225edd52d3c9fd9837fbcb0084)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ec803b61243a6f04b1788e3306d23636b01d107a1eb32b62eedca384f751efde)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e5843fa0394d865a87391df7da2ff5eb6c97f57ccd3d3b6a0986386f769dc0e0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationFeatureCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationFeatureCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationFeatureCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__42a0aa8dba60e5797413c29cf4eb66899dbbb780c223b1ac78ad1b4788e40ccd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationFitAndFill",
    jsii_struct_bases=[],
    name_mapping={
        "fill_transformation": "fillTransformation",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationFitAndFill:
    def __init__(
        self,
        *,
        fill_transformation: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationFitAndFillFillTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fill_transformation: fill_transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_transformation DataAkamaiImagingPolicyImage#fill_transformation}
        :param height: The height value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The width value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(fill_transformation, dict):
            fill_transformation = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationFitAndFillFillTransformation(**fill_transformation)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5509c1892b3bbb15d5118286f283839a44c34af9417cbf440c53e7b6af030850)
            check_type(argname="argument fill_transformation", value=fill_transformation, expected_type=type_hints["fill_transformation"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fill_transformation is not None:
            self._values["fill_transformation"] = fill_transformation
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def fill_transformation(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationFitAndFillFillTransformation"]:
        '''fill_transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_transformation DataAkamaiImagingPolicyImage#fill_transformation}
        '''
        result = self._values.get("fill_transformation")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationFitAndFillFillTransformation"], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationFitAndFill(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationFitAndFillFillTransformation",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationFitAndFillFillTransformation:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationFitAndFillFillTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationFitAndFillFillTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationFitAndFillFillTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a49562c834ec4b78289a68682d0f42d5597b29d98fcc7c94752aff4e136974c2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationFitAndFillFillTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationFitAndFillFillTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationFitAndFillFillTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0a0cc740a5c2aa29b03321ddf9cd01098bcdfb6bcd9a64c00b09ea05970633e0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationFitAndFillList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationFitAndFillList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__544c85f41fa0a6557efaa71512eb5a856a75f9e9dbd45783bab3c3d2d9c901b7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationFitAndFillOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__86b54c70ee3d90ac08e0c0d5e845b1319c52bb2a415fb4045781f7ae4cc35b33)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationFitAndFillOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e05de25853b2f27e8143c8f4c66ac1e75274c32237fcc0158c2470091ce1e6f8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__523bc58af61e47b568fbd9e4c2c44e765f0dd5e8ec19aee5010d8817538bdec5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f78caa1c6a2d03e8cf5fa45a3681f10760ee75384736fe5098776888138cd88e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationFitAndFill]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationFitAndFill]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationFitAndFill]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a064b57aa78397cd7974a3148464208624ba088373fe1f949e0573be3329a71a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationFitAndFillOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationFitAndFillOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3f64b2c2ad93ab19bfdc6e3512a0d3449578c2bd9853515d31e98ffb316d4a50)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putFillTransformation")
    def put_fill_transformation(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationFitAndFillFillTransformation()

        return typing.cast(None, jsii.invoke(self, "putFillTransformation", [value]))

    @jsii.member(jsii_name="resetFillTransformation")
    def reset_fill_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFillTransformation", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="fillTransformation")
    def fill_transformation(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationFitAndFillFillTransformationOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationFitAndFillFillTransformationOutputReference, jsii.get(self, "fillTransformation"))

    @builtins.property
    @jsii.member(jsii_name="fillTransformationInput")
    def fill_transformation_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationFitAndFillFillTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationFitAndFillFillTransformation], jsii.get(self, "fillTransformationInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ba278c4229158225982d3b874c0e0879722590d51a869784589d6bd3b2db09e7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c0c326199c2c5f1ee8f0eb76c9677adab488609ed917ecf16c2e29f9fccf8568)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0a04d10fe49b29566978b5e17f4ab8533121d44370276592ba5039ce2e31a555)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c601d89829fa453bbb7fad761af2d531f046b77139ad9cdfe21ce5ae89619f03)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationFitAndFill]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationFitAndFill]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationFitAndFill]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__17eae66930836d0efd3950a21e0f80b80e4905770747b4937e5a622353d724c4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationGoop",
    jsii_struct_bases=[],
    name_mapping={
        "chaos": "chaos",
        "chaos_var": "chaosVar",
        "density": "density",
        "density_var": "densityVar",
        "power": "power",
        "power_var": "powerVar",
        "seed": "seed",
        "seed_var": "seedVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationGoop:
    def __init__(
        self,
        *,
        chaos: typing.Optional[builtins.str] = None,
        chaos_var: typing.Optional[builtins.str] = None,
        density: typing.Optional[builtins.str] = None,
        density_var: typing.Optional[builtins.str] = None,
        power: typing.Optional[builtins.str] = None,
        power_var: typing.Optional[builtins.str] = None,
        seed: typing.Optional[builtins.str] = None,
        seed_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param chaos: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        :param chaos_var: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        :param density: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        :param density_var: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        :param power: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        :param power_var: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        :param seed: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        :param seed_var: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dc42b7178286688525a25e571cba0db6c59c01a95047bbf2262cb796f15e2f62)
            check_type(argname="argument chaos", value=chaos, expected_type=type_hints["chaos"])
            check_type(argname="argument chaos_var", value=chaos_var, expected_type=type_hints["chaos_var"])
            check_type(argname="argument density", value=density, expected_type=type_hints["density"])
            check_type(argname="argument density_var", value=density_var, expected_type=type_hints["density_var"])
            check_type(argname="argument power", value=power, expected_type=type_hints["power"])
            check_type(argname="argument power_var", value=power_var, expected_type=type_hints["power_var"])
            check_type(argname="argument seed", value=seed, expected_type=type_hints["seed"])
            check_type(argname="argument seed_var", value=seed_var, expected_type=type_hints["seed_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if chaos is not None:
            self._values["chaos"] = chaos
        if chaos_var is not None:
            self._values["chaos_var"] = chaos_var
        if density is not None:
            self._values["density"] = density
        if density_var is not None:
            self._values["density_var"] = density_var
        if power is not None:
            self._values["power"] = power
        if power_var is not None:
            self._values["power_var"] = power_var
        if seed is not None:
            self._values["seed"] = seed
        if seed_var is not None:
            self._values["seed_var"] = seed_var

    @builtins.property
    def chaos(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        '''
        result = self._values.get("chaos")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def chaos_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        '''
        result = self._values.get("chaos_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        '''
        result = self._values.get("density")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density_var(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        '''
        result = self._values.get("density_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        '''
        result = self._values.get("power")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power_var(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        '''
        result = self._values.get("power_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        '''
        result = self._values.get("seed")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed_var(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        result = self._values.get("seed_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationGoop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationGoopList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationGoopList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb9c04cacb2e36d15a304967c9636a8b56f367f8a34975f38d582dbb4c591d93)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationGoopOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f058e08cc30a89ec4f531a41cac695997714bf27a6f6acd24ae8d8e6fe2fb94)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationGoopOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a6926f226e843f671ae4be3d34fae2282407ee5417931ef6b4afd3bd2569c970)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2559f5e53a1607f4d18e1c913f3b2fc2b67a3b3a28a6f0fb4f0c6392414a746d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3459d6262bc1907b3b0402db72eed6eac7523b7b639c14c8fb1ad7ef44d4121e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationGoop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationGoop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__36dd3d0a6c714f94742bf8967bc77904730bd486c8aef331055820835f5a13b5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationGoopOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationGoopOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2b91f3e6c83227ba3e6fd0459cfa051dc020812d5635b10e3f7b74e153c45bbc)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetChaos")
    def reset_chaos(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaos", []))

    @jsii.member(jsii_name="resetChaosVar")
    def reset_chaos_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaosVar", []))

    @jsii.member(jsii_name="resetDensity")
    def reset_density(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensity", []))

    @jsii.member(jsii_name="resetDensityVar")
    def reset_density_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensityVar", []))

    @jsii.member(jsii_name="resetPower")
    def reset_power(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPower", []))

    @jsii.member(jsii_name="resetPowerVar")
    def reset_power_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPowerVar", []))

    @jsii.member(jsii_name="resetSeed")
    def reset_seed(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeed", []))

    @jsii.member(jsii_name="resetSeedVar")
    def reset_seed_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeedVar", []))

    @builtins.property
    @jsii.member(jsii_name="chaosInput")
    def chaos_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosInput"))

    @builtins.property
    @jsii.member(jsii_name="chaosVarInput")
    def chaos_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosVarInput"))

    @builtins.property
    @jsii.member(jsii_name="densityInput")
    def density_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityInput"))

    @builtins.property
    @jsii.member(jsii_name="densityVarInput")
    def density_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="powerInput")
    def power_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerInput"))

    @builtins.property
    @jsii.member(jsii_name="powerVarInput")
    def power_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerVarInput"))

    @builtins.property
    @jsii.member(jsii_name="seedInput")
    def seed_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedInput"))

    @builtins.property
    @jsii.member(jsii_name="seedVarInput")
    def seed_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedVarInput"))

    @builtins.property
    @jsii.member(jsii_name="chaos")
    def chaos(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaos"))

    @chaos.setter
    def chaos(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__46fbca9639479c3623294fd4c6efa6689845ccf02abb0eb55ea5341d3661b130)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaos", value)

    @builtins.property
    @jsii.member(jsii_name="chaosVar")
    def chaos_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaosVar"))

    @chaos_var.setter
    def chaos_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__60d11e9907bde56118333b41a4e20c0d379e7d4825eac88afb5fb220193c562e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaosVar", value)

    @builtins.property
    @jsii.member(jsii_name="density")
    def density(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "density"))

    @density.setter
    def density(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f832c57cee52b232c26540daa2e60d5ad528df951b3bcc642deaa404987c76f8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "density", value)

    @builtins.property
    @jsii.member(jsii_name="densityVar")
    def density_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "densityVar"))

    @density_var.setter
    def density_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7b3bd66c5cad4096cc384d2b2a897be0fb7fb57ab43fd78115c14143a895ada5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "densityVar", value)

    @builtins.property
    @jsii.member(jsii_name="power")
    def power(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "power"))

    @power.setter
    def power(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac540b2ed4eb41ed28b34764ce20af32476e37fb63b28a5a001619c9e28bb2c9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "power", value)

    @builtins.property
    @jsii.member(jsii_name="powerVar")
    def power_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "powerVar"))

    @power_var.setter
    def power_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__208812f33611856fdb86b7ac287e7d88b02ccc79bb662066a30dbec41768f898)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "powerVar", value)

    @builtins.property
    @jsii.member(jsii_name="seed")
    def seed(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seed"))

    @seed.setter
    def seed(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9351c80dc0fe7cb706d32f70987f9ed2d472c8b422a8274d0e6e7064224a5f4f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seed", value)

    @builtins.property
    @jsii.member(jsii_name="seedVar")
    def seed_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seedVar"))

    @seed_var.setter
    def seed_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c5e61684d3af11031b3065889d07587d8a7181c48f99872ced64d3eb0202c5a4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seedVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationGoop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationGoop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationGoop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eb06c15804595ff578c2b3b2593bafb9e337006047685c200b295ae1f65eb8f6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationGrayscale",
    jsii_struct_bases=[],
    name_mapping={"type": "type", "type_var": "typeVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationGrayscale:
    def __init__(
        self,
        *,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param type: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8e2e2ba010e5ebcbc59a7cc79575f0f0ac2fa69a0759cd407b8c67785ed0ec4e)
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationGrayscale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationGrayscaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationGrayscaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__646a02820029306eb3f5854cded57eb7524dd72c66470c357c60f426c0fb0c53)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationGrayscaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__75197fcdc74335034f8f73d81766c3c765615b6ab420939afc7db42dd9156baf)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationGrayscaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f3a60a0d2e7159c416ac038345618f9422458922b1b67cffc3d2456b36844e09)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3af763954c9ebbd5a9e8877932d9591a09d2028962cc83a73dc5103b82f5650b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ca5a95e322f65ac9cf27efe80c88eb2269985a772ac0fee06e12bfa1721fc0c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationGrayscale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationGrayscale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f5bccfc35e5b618c1d90908a54cd30559ecfaef72954db9167e5278633ed8793)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationGrayscaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationGrayscaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e094923fc261051a1ce0546178725b778095cc767700bad92804bd5036d0ad53)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5bec26b1176775f9e72e3d5b6e4c41cb71d876c196b55f556f08bd11a9874ac5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__42c87ac46e8ee32c9dc0d16290391f7b6683d27be42067d39f6bdf08b52db4ed)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationGrayscale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationGrayscale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationGrayscale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7e9b5dfbde8bcb5a2c93a6d17aace81644bdfc64b6916cb0da8e882c03088df1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationHsl",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "lightness": "lightness",
        "lightness_var": "lightnessVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationHsl:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness: typing.Optional[builtins.str] = None,
        lightness_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        :param lightness_var: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b5c455529f840073204dfc62f78b3b7e845b0bc471dce6e6f698f7331b1a4a30)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness", value=lightness, expected_type=type_hints["lightness"])
            check_type(argname="argument lightness_var", value=lightness_var, expected_type=type_hints["lightness_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness is not None:
            self._values["lightness"] = lightness
        if lightness_var is not None:
            self._values["lightness_var"] = lightness_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        '''
        result = self._values.get("lightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        '''
        result = self._values.get("lightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationHsl(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationHslList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationHslList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3fa08e9fb83e2d95673514a032303e25722cd004b6b789722e96d2fe19fbd39f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationHslOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6a3acd535b4ebf3189c5ef95e8946b1a3f6756878210779fae21033488c63e60)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationHslOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1a0902a24826801c9ac5ea1b8c10f99b3b06850d5efffdc262b0dc248f49b552)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e9a5a471e7518a1ce895584adc54fa1b9b3dcb65d68972bc4d679c24222866d0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__52072666866530394aff9b5fe2926f2a72215abcdf6d106d8013877bb5197a8d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationHsl]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationHsl]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8735de1951b1dab34bbb3229b0918603de5c28cb35c6dff7b6f6653b14dbc201)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationHslOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationHslOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7310b8c2d998cdb4e6967c8c48d646b0a50df371e635ae2037aa47a1346e8a78)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightness")
    def reset_lightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightness", []))

    @jsii.member(jsii_name="resetLightnessVar")
    def reset_lightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessInput")
    def lightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessVarInput")
    def lightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d593e5c5b47dee4fa5c670f5134bd8798b34927749c92fb39bb8045f69286b61)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0afb8e51556a16bfc65476fff952a1abc0ef7798cf382c1794398f2a84c8f6e4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightness")
    def lightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightness"))

    @lightness.setter
    def lightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aadb2378b7ee0a42cb161898cb738af118f577b0fe2dc7d3ba8f30ea797d6643)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightness", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessVar")
    def lightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessVar"))

    @lightness_var.setter
    def lightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ce8b30db8abb138cdb328ca39327289e7bc392d5b4067e4c44149ea01d8f5f8d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4febbec846cec1eb39e61f3a4667a5eb855fce582d41dc9cbd3eb4ee54cf8a60)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d0ce64053db7a0de30cee9582d7b143a0d75cf5c6e8eb043a506450d2c21d572)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationHsl]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationHsl]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationHsl]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c3ab81b167ffc1ed4f655af9fab7df2f02fb4d0e5db0ffa2c4fc4e97e8b9c15b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationHsv",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationHsv:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        :param value: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d1bb842cdf10cff41c6b820e9127673c0ba69a61fd7d3ea9b43f38a254533c91)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationHsv(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationHsvList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationHsvList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f24961516fcda437886d612900a7d37efa365f424af39ad9e2801c72e655c063)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationHsvOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__467354c30d954d185b140f3c6fbcb5505307be831701764523b4d3d040239e9e)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationHsvOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d138ed74096a15e4ff19269d356359109cee5ac3329d8fc1a691164580c8c34)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__719dcca4cb4916152e1fdbfb5ef677071489b860b38b872da9f7b4943e8c3a71)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__682bbd4796d20143752ff6c25f6d883b89af405e89f1671a340d25ba5c9b7723)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationHsv]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationHsv]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ff643bad4340b524fe10aee6f9077c81232889b4147f84b916bf32603bca70f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationHsvOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationHsvOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__30516c09cbeb6878b3ef41e8c52ddc055be99ab4536c29798a93fdbd7608e831)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fe1d3841cf7031ca33262033168ab6a594470c757bd0356e0290d32e370b8612)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eaa0c4895be4d2c0e0edff89476dc92e9372e46adc0b3f005b717e8c55a36d9b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6cd2095cb1b7e11f978355af6ef5ca78570813ecf6dfd6495b4d6ee3ee17e982)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__20e41ae2ec2204f37d3e7aada4c314361ce7743adc56e188a420c97885fb2bd6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__82da30249579f5926285327b4ac2221dff4dbaa3161ceda3409b5751c45c26d3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be72f72d375ef4e4a1315f6f819454d384fd52b0a9ef7062f6b543dd3e806d12)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationHsv]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationHsv]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationHsv]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__75f5b84db3834ef03196c17eb580ebb11d9c4717e39095769a4184fb2945b41b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfDimension",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "dimension": "dimension",
        "dimension_var": "dimensionVar",
        "equal": "equal",
        "greater_than": "greaterThan",
        "less_than": "lessThan",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfDimension:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfDimensionDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        dimension: typing.Optional[builtins.str] = None,
        dimension_var: typing.Optional[builtins.str] = None,
        equal: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfDimensionEqual", typing.Dict[builtins.str, typing.Any]]] = None,
        greater_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfDimensionGreaterThan", typing.Dict[builtins.str, typing.Any]]] = None,
        less_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfDimensionLessThan", typing.Dict[builtins.str, typing.Any]]] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param dimension: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        :param dimension_var: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        :param equal: equal block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        :param greater_than: greater_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        :param less_than: less_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        :param value: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfDimensionDefault(**default)
        if isinstance(equal, dict):
            equal = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfDimensionEqual(**equal)
        if isinstance(greater_than, dict):
            greater_than = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfDimensionGreaterThan(**greater_than)
        if isinstance(less_than, dict):
            less_than = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfDimensionLessThan(**less_than)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7b3e094ab7160435f2fef1347e54184845f82e050b7be3d9b3cd37853cf05a91)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument dimension", value=dimension, expected_type=type_hints["dimension"])
            check_type(argname="argument dimension_var", value=dimension_var, expected_type=type_hints["dimension_var"])
            check_type(argname="argument equal", value=equal, expected_type=type_hints["equal"])
            check_type(argname="argument greater_than", value=greater_than, expected_type=type_hints["greater_than"])
            check_type(argname="argument less_than", value=less_than, expected_type=type_hints["less_than"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if dimension is not None:
            self._values["dimension"] = dimension
        if dimension_var is not None:
            self._values["dimension_var"] = dimension_var
        if equal is not None:
            self._values["equal"] = equal
        if greater_than is not None:
            self._values["greater_than"] = greater_than
        if less_than is not None:
            self._values["less_than"] = less_than
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfDimensionDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfDimensionDefault"], result)

    @builtins.property
    def dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        '''
        result = self._values.get("dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        '''
        result = self._values.get("dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def equal(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfDimensionEqual"]:
        '''equal block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        '''
        result = self._values.get("equal")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfDimensionEqual"], result)

    @builtins.property
    def greater_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfDimensionGreaterThan"]:
        '''greater_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        '''
        result = self._values.get("greater_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfDimensionGreaterThan"], result)

    @builtins.property
    def less_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfDimensionLessThan"]:
        '''less_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        '''
        result = self._values.get("less_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfDimensionLessThan"], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfDimension(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfDimensionDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfDimensionDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfDimensionDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfDimensionDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfDimensionDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1695e8a0dc9c4e685221e65299eb860fa82511acf4aee1f4611cb49b01e3ca04)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfDimensionDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfDimensionDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__34e046110969d2772991d7c13c256c983bf21bc6952d14cf3c98bdf2a09991a0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfDimensionEqual",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfDimensionEqual:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfDimensionEqual(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfDimensionEqualOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfDimensionEqualOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__32ed4de4dad8772743b9b79294068895d580dcdc160b42638467f55133e76751)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfDimensionEqual], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfDimensionEqual],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1b48a58a9e07ad932c0e14af8a56a8307a15ab7bbc873d7d259e895320d568f7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfDimensionGreaterThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfDimensionGreaterThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfDimensionGreaterThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfDimensionGreaterThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfDimensionGreaterThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__06ff4c035d4f65900e85fc696e5f31c2c4629e283538ba2c1b5d9df31d92b228)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfDimensionGreaterThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfDimensionGreaterThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__909e1edabd9d4fc7b0bc166f26c11ad5bb9aca0c78406aa1a3f471d2ffb318d7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfDimensionLessThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfDimensionLessThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfDimensionLessThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfDimensionLessThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfDimensionLessThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eebd88ca5ffa1556dbdb16c1d4ed6651e791549466071ee52137e32f9dd22193)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfDimensionLessThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfDimensionLessThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ae7dfc1a15533268016b8f00abb5f7e9f1068ab75ad4d0d1031a816bc3ca177c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfDimensionList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfDimensionList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__193eb677ad80210be7ab885b97535e5a37d0945420c046140cf0baccd06d1a3b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfDimensionOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2508dc79fa22e2f647dbe21386044c61d15a611dfff5cd73211262bbbd3e6c3f)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfDimensionOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__effcf802f0780d2a42d41060e7138cfb62015c78692e432bf4ada664edc2da76)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc05fc6d1c900c642660b2cb67f68ce2017baf614fb50b6a1f1942ab8013d36b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__895d2a3e04c71523bd665c4d6616cd6b72d836ac28670fdcc04702810b2d178e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfDimension]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfDimension]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc97f2e890f7c64a7c8de52054938bd174a645c1d4b9fad69ddcca732f68d535)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfDimensionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfDimensionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fd0eac5472e3a20b869087e41be5d0b5644719c06f225f049c6be52285aa1c68)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfDimensionDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putEqual")
    def put_equal(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfDimensionEqual()

        return typing.cast(None, jsii.invoke(self, "putEqual", [value]))

    @jsii.member(jsii_name="putGreaterThan")
    def put_greater_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfDimensionGreaterThan()

        return typing.cast(None, jsii.invoke(self, "putGreaterThan", [value]))

    @jsii.member(jsii_name="putLessThan")
    def put_less_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfDimensionLessThan()

        return typing.cast(None, jsii.invoke(self, "putLessThan", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetDimension")
    def reset_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimension", []))

    @jsii.member(jsii_name="resetDimensionVar")
    def reset_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimensionVar", []))

    @jsii.member(jsii_name="resetEqual")
    def reset_equal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEqual", []))

    @jsii.member(jsii_name="resetGreaterThan")
    def reset_greater_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGreaterThan", []))

    @jsii.member(jsii_name="resetLessThan")
    def reset_less_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLessThan", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfDimensionDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfDimensionDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="equal")
    def equal(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfDimensionEqualOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfDimensionEqualOutputReference, jsii.get(self, "equal"))

    @builtins.property
    @jsii.member(jsii_name="greaterThan")
    def greater_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfDimensionGreaterThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfDimensionGreaterThanOutputReference, jsii.get(self, "greaterThan"))

    @builtins.property
    @jsii.member(jsii_name="lessThan")
    def less_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfDimensionLessThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfDimensionLessThanOutputReference, jsii.get(self, "lessThan"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfDimensionDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionInput")
    def dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionVarInput")
    def dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="equalInput")
    def equal_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfDimensionEqual], jsii.get(self, "equalInput"))

    @builtins.property
    @jsii.member(jsii_name="greaterThanInput")
    def greater_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfDimensionGreaterThan], jsii.get(self, "greaterThanInput"))

    @builtins.property
    @jsii.member(jsii_name="lessThanInput")
    def less_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfDimensionLessThan], jsii.get(self, "lessThanInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="dimension")
    def dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimension"))

    @dimension.setter
    def dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__22d1474168a5feebf236de5cbadb44e25a14de2269cbc934a5e6983f7e16fe26)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimension", value)

    @builtins.property
    @jsii.member(jsii_name="dimensionVar")
    def dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimensionVar"))

    @dimension_var.setter
    def dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a9d2a4b6e9c1c8f4c831552183426f56e05c08045fd481cf4a3c31154e7a9d95)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__337d5f0598b3d14f7c5b506fcfee9ff1e498dea6439e864210ce69fb2f7d52d5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__80f7afa86b6247d9ccab567f0fb10ff4a51f68b0d3e6d26f75f61e0cd6f90790)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfDimension]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfDimension]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfDimension]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__82c16ba369629bcf37397891bf12074970fb9efdc936883794e4a2925fd625a8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfOrientation",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "landscape": "landscape",
        "portrait": "portrait",
        "square": "square",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfOrientation:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfOrientationDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        landscape: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfOrientationLandscape", typing.Dict[builtins.str, typing.Any]]] = None,
        portrait: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfOrientationPortrait", typing.Dict[builtins.str, typing.Any]]] = None,
        square: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfOrientationSquare", typing.Dict[builtins.str, typing.Any]]] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param landscape: landscape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        :param portrait: portrait block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        :param square: square block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfOrientationDefault(**default)
        if isinstance(landscape, dict):
            landscape = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfOrientationLandscape(**landscape)
        if isinstance(portrait, dict):
            portrait = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfOrientationPortrait(**portrait)
        if isinstance(square, dict):
            square = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfOrientationSquare(**square)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f984bfa9ff5613981fb5592aad304e37dd519a5c0a31330fb4991387602eb7f5)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument landscape", value=landscape, expected_type=type_hints["landscape"])
            check_type(argname="argument portrait", value=portrait, expected_type=type_hints["portrait"])
            check_type(argname="argument square", value=square, expected_type=type_hints["square"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if landscape is not None:
            self._values["landscape"] = landscape
        if portrait is not None:
            self._values["portrait"] = portrait
        if square is not None:
            self._values["square"] = square

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfOrientationDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfOrientationDefault"], result)

    @builtins.property
    def landscape(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfOrientationLandscape"]:
        '''landscape block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        '''
        result = self._values.get("landscape")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfOrientationLandscape"], result)

    @builtins.property
    def portrait(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfOrientationPortrait"]:
        '''portrait block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        '''
        result = self._values.get("portrait")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfOrientationPortrait"], result)

    @builtins.property
    def square(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfOrientationSquare"]:
        '''square block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        result = self._values.get("square")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfOrientationSquare"], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfOrientation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfOrientationDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfOrientationDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfOrientationDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfOrientationDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfOrientationDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c6f1071124da723ff47ffbc6488b4e780b463014b834e1fa001c18016b7cc32c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfOrientationDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfOrientationDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__505049babe08942c5894a5095e9cdb081aecbf9716eb191a0b27c72f2825ee4c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfOrientationLandscape",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfOrientationLandscape:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfOrientationLandscape(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfOrientationLandscapeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfOrientationLandscapeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ce544554ba9a18b8e1dd11e5e5b3bbea7825ec046592f4e1ef05e28d090f9bf)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfOrientationLandscape], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfOrientationLandscape],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__15f2688c4224694cfb24519d8f138023b0017dcac2c966b1656009ea6f9a91af)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfOrientationList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfOrientationList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ed9c281d509f3de8e2c613a6c645a7cce33486b1ece1f060c9d8e8ffde0725ff)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfOrientationOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5fdc0d10b4ac27c16295678db005ed8ed0689b5f7db7dd54c238c2887f55f372)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfOrientationOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2770831e31e011b9e0baadb91c37b253a3bd135a250dca7bf28a50c395880a5c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f81ddd8c79020223d1fb19d01d33d6775d8a21f1a00899fb03ad03f4dec3e5b4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__76b9ecab61c09a44d46a07b1ef10963361e7372c0da7ee87300e8471f3ac9ffd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfOrientation]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfOrientation]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e1f938680bf8dfec907aba14e025ce379d35ea99893064e9d82365ff042d6e2a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfOrientationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfOrientationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__65e1c44d3cce0f77b4c06b0d04a9651b9a199dc8d8383956ffb792e2da04ec0d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfOrientationDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putLandscape")
    def put_landscape(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfOrientationLandscape()

        return typing.cast(None, jsii.invoke(self, "putLandscape", [value]))

    @jsii.member(jsii_name="putPortrait")
    def put_portrait(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfOrientationPortrait()

        return typing.cast(None, jsii.invoke(self, "putPortrait", [value]))

    @jsii.member(jsii_name="putSquare")
    def put_square(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfOrientationSquare()

        return typing.cast(None, jsii.invoke(self, "putSquare", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetLandscape")
    def reset_landscape(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLandscape", []))

    @jsii.member(jsii_name="resetPortrait")
    def reset_portrait(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPortrait", []))

    @jsii.member(jsii_name="resetSquare")
    def reset_square(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSquare", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfOrientationDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfOrientationDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="landscape")
    def landscape(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfOrientationLandscapeOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfOrientationLandscapeOutputReference, jsii.get(self, "landscape"))

    @builtins.property
    @jsii.member(jsii_name="portrait")
    def portrait(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfOrientationPortraitOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfOrientationPortraitOutputReference", jsii.get(self, "portrait"))

    @builtins.property
    @jsii.member(jsii_name="square")
    def square(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfOrientationSquareOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfOrientationSquareOutputReference", jsii.get(self, "square"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfOrientationDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="landscapeInput")
    def landscape_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfOrientationLandscape], jsii.get(self, "landscapeInput"))

    @builtins.property
    @jsii.member(jsii_name="portraitInput")
    def portrait_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfOrientationPortrait"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfOrientationPortrait"], jsii.get(self, "portraitInput"))

    @builtins.property
    @jsii.member(jsii_name="squareInput")
    def square_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfOrientationSquare"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfOrientationSquare"], jsii.get(self, "squareInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfOrientation]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfOrientation]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfOrientation]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6169e9a1d3a7b2dd04041214ffe9d45e61dc38f6d6d8458b78dfd20200afffb5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfOrientationPortrait",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfOrientationPortrait:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfOrientationPortrait(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfOrientationPortraitOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfOrientationPortraitOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d244d3e0195c74668f2e0aa949e91d04ea5056ccfb65a1734267ea20b104c0b4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfOrientationPortrait]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfOrientationPortrait], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfOrientationPortrait],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__47278c866dde4b84bd0d2519ece15067c0fc0490299278f75cc43a6125bc9d3e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfOrientationSquare",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfOrientationSquare:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfOrientationSquare(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfOrientationSquareOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfOrientationSquareOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d31515636c65af6ea970eabe8bd3f21220ccb52d3de5a03ba1e4582bbafea0d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfOrientationSquare]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfOrientationSquare], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfOrientationSquare],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__02272a0aaf0e77619697d83122540d85fe361674e1ecffd88c78ac141cad84f6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationImQuery",
    jsii_struct_bases=[],
    name_mapping={
        "allowed_transformations": "allowedTransformations",
        "query_var": "queryVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationImQuery:
    def __init__(
        self,
        *,
        allowed_transformations: typing.Sequence[builtins.str],
        query_var: builtins.str,
    ) -> None:
        '''
        :param allowed_transformations: Specifies the transformations that can be applied using the query string parameter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allowed_transformations DataAkamaiImagingPolicyImage#allowed_transformations}
        :param query_var: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#query_var DataAkamaiImagingPolicyImage#query_var}.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f5e36dc83f2a6211527b625f76d25e3e2bb4158926b0818dbd2d5b067421f764)
            check_type(argname="argument allowed_transformations", value=allowed_transformations, expected_type=type_hints["allowed_transformations"])
            check_type(argname="argument query_var", value=query_var, expected_type=type_hints["query_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "allowed_transformations": allowed_transformations,
            "query_var": query_var,
        }

    @builtins.property
    def allowed_transformations(self) -> typing.List[builtins.str]:
        '''Specifies the transformations that can be applied using the query string parameter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allowed_transformations DataAkamaiImagingPolicyImage#allowed_transformations}
        '''
        result = self._values.get("allowed_transformations")
        assert result is not None, "Required property 'allowed_transformations' is missing"
        return typing.cast(typing.List[builtins.str], result)

    @builtins.property
    def query_var(self) -> builtins.str:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#query_var DataAkamaiImagingPolicyImage#query_var}.'''
        result = self._values.get("query_var")
        assert result is not None, "Required property 'query_var' is missing"
        return typing.cast(builtins.str, result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationImQuery(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationImQueryList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationImQueryList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fefe9d6c6efdae9d00f00c253e7b57440bdc0c87f25dddc6524616ef135f753c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationImQueryOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__078ca7c32cefed03f078ab05dc377b677f40b54a2ac770d972789b709c7bc3ea)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationImQueryOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__823ec6afc6085be711db5473cac4fff4cae36c6b5ca6cce56b61dee81ebe4e7a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__696f5408a6ef476b93cc21a0dcab813ff59b6908740052a22738a699888d01b5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6c662778960bc0ffc91770c6cbf52e09c8a65b2c2ad8315f4e3b101c1beade01)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationImQuery]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationImQuery]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationImQuery]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cff0b810d9490db197a51a0838dc34e4464fabcc06a9cc4573197b95e369ccfe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationImQueryOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationImQueryOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5aaa2a93057cbd30320e0c135482b1b738433f72f89f9e1f530d5506428f35a9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @builtins.property
    @jsii.member(jsii_name="allowedTransformationsInput")
    def allowed_transformations_input(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "allowedTransformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="queryVarInput")
    def query_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "queryVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowedTransformations")
    def allowed_transformations(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "allowedTransformations"))

    @allowed_transformations.setter
    def allowed_transformations(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1cf887571d6b91160e7c9e00246e9d90f0f8c87a8fde58c1d69193ead9112494)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowedTransformations", value)

    @builtins.property
    @jsii.member(jsii_name="queryVar")
    def query_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "queryVar"))

    @query_var.setter
    def query_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e9b80d3d7d45c6d427e626577ce61427e6b5dbd5655f684cc0d419ab833c2a1c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "queryVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationImQuery]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationImQuery]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationImQuery]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5fb9874e8e2e0c29f44df592ef425569c0c7b18607796376e5a1e5075117e7a5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationMaxColors",
    jsii_struct_bases=[],
    name_mapping={"colors": "colors", "colors_var": "colorsVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationMaxColors:
    def __init__(
        self,
        *,
        colors: typing.Optional[builtins.str] = None,
        colors_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param colors: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        :param colors_var: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a19865360ee47b222e9947d31f0d9dd5c01e402fcabc3bc28c020c86382c4846)
            check_type(argname="argument colors", value=colors, expected_type=type_hints["colors"])
            check_type(argname="argument colors_var", value=colors_var, expected_type=type_hints["colors_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if colors is not None:
            self._values["colors"] = colors
        if colors_var is not None:
            self._values["colors_var"] = colors_var

    @builtins.property
    def colors(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        '''
        result = self._values.get("colors")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def colors_var(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        result = self._values.get("colors_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationMaxColors(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationMaxColorsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationMaxColorsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ac96346ae75291801dff0d046c34859a616a050e478f6f6741ae967237d0624)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationMaxColorsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a2761edccd82d44370a416524a4fbd7ffe108709cfe852b0fa9f8162a48345d9)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationMaxColorsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c531771334bffa714caf220e8cfaed61b1e3bf2283af980631821af0124c5d8b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__04dc905310df91de95afeb23a6ccf77d3482d40e4ad69b64c7c455ef6ed2209a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e0082092847ec7d0eca2d5dca6b5fcdefb49a63aa07fd2ee35c2909a6c313afe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationMaxColors]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationMaxColors]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a220fa2a44e79be66544556c166a19a8bcc79ea4dd8c732a8368a8356bd7be7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationMaxColorsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationMaxColorsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a97e4265a09346f569345b30958150871e75a5edb0af325614f9485724a5308)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColors")
    def reset_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColors", []))

    @jsii.member(jsii_name="resetColorsVar")
    def reset_colors_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorsVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorsInput")
    def colors_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsInput"))

    @builtins.property
    @jsii.member(jsii_name="colorsVarInput")
    def colors_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsVarInput"))

    @builtins.property
    @jsii.member(jsii_name="colors")
    def colors(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colors"))

    @colors.setter
    def colors(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__97142677d199d250bbffb05debda7b9cba8aaffd57d678f00b52c5369503268d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colors", value)

    @builtins.property
    @jsii.member(jsii_name="colorsVar")
    def colors_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorsVar"))

    @colors_var.setter
    def colors_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea36b09147efac8d41ad352e9436303b65679fdf03770c9d64edcdbc83698343)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorsVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationMaxColors]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationMaxColors]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationMaxColors]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a16d0880fdcc5fcbb503f44b27dd1f6bde4866f487c61849be87cff3ffbcd0a7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationMirror",
    jsii_struct_bases=[],
    name_mapping={
        "horizontal": "horizontal",
        "horizontal_var": "horizontalVar",
        "vertical": "vertical",
        "vertical_var": "verticalVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationMirror:
    def __init__(
        self,
        *,
        horizontal: typing.Optional[builtins.str] = None,
        horizontal_var: typing.Optional[builtins.str] = None,
        vertical: typing.Optional[builtins.str] = None,
        vertical_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param horizontal: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        :param horizontal_var: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        :param vertical: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        :param vertical_var: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__740df00e408d6daa17b96f4b19373721ae1f161bf47ec80b8f144901d609edd5)
            check_type(argname="argument horizontal", value=horizontal, expected_type=type_hints["horizontal"])
            check_type(argname="argument horizontal_var", value=horizontal_var, expected_type=type_hints["horizontal_var"])
            check_type(argname="argument vertical", value=vertical, expected_type=type_hints["vertical"])
            check_type(argname="argument vertical_var", value=vertical_var, expected_type=type_hints["vertical_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if horizontal is not None:
            self._values["horizontal"] = horizontal
        if horizontal_var is not None:
            self._values["horizontal_var"] = horizontal_var
        if vertical is not None:
            self._values["vertical"] = vertical
        if vertical_var is not None:
            self._values["vertical_var"] = vertical_var

    @builtins.property
    def horizontal(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        '''
        result = self._values.get("horizontal")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def horizontal_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        '''
        result = self._values.get("horizontal_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        '''
        result = self._values.get("vertical")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        result = self._values.get("vertical_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationMirror(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationMirrorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationMirrorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d6c479ff1df8dd338f75edc901a977846bb827a575414f3ffb78238885cf5973)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationMirrorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9bb07f4d17ddcf8e686f670938ff64cd48e4395e012fe7dfce52265b54cd869f)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationMirrorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bf543648c9a08cb50f64f9fbf6bdb8b0419420fa4d6ea77b8352466c8c26742f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__223a0710e4095ecef9d64c0ae73990295ca808d858e8d5a85950ba4ed8e0567d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__81d537ffde89eebe8d8c84e603f590b2e451173e5448e995a2d39155180a824d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationMirror]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationMirror]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bea7fc57e9bc37551ad1ae32d7bbb4c6cc7d83d1371720589b0c42386a416e53)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationMirrorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationMirrorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e1231913f774442b0d036ff694be595c235d2972b1a9c630788ae4bbcf226020)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHorizontal")
    def reset_horizontal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontal", []))

    @jsii.member(jsii_name="resetHorizontalVar")
    def reset_horizontal_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontalVar", []))

    @jsii.member(jsii_name="resetVertical")
    def reset_vertical(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVertical", []))

    @jsii.member(jsii_name="resetVerticalVar")
    def reset_vertical_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVerticalVar", []))

    @builtins.property
    @jsii.member(jsii_name="horizontalInput")
    def horizontal_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontalVarInput")
    def horizontal_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalInput")
    def vertical_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalVarInput")
    def vertical_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontal")
    def horizontal(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontal"))

    @horizontal.setter
    def horizontal(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f3b1ebfa8e1707a6321308b034c4f11d2228b7dca0aa2e792a32ece097fdecbf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontal", value)

    @builtins.property
    @jsii.member(jsii_name="horizontalVar")
    def horizontal_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontalVar"))

    @horizontal_var.setter
    def horizontal_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__81b1531f2ac517a5b65984d9bb839f64e8314c1b2f71a34945fadc9903c597c2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontalVar", value)

    @builtins.property
    @jsii.member(jsii_name="vertical")
    def vertical(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "vertical"))

    @vertical.setter
    def vertical(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7b0232d767e8e9ce92f60032efe0115734a90561e127ba3f3262b057d1530518)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "vertical", value)

    @builtins.property
    @jsii.member(jsii_name="verticalVar")
    def vertical_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "verticalVar"))

    @vertical_var.setter
    def vertical_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__15c7ab66f3b7390c1e5500238f05329c702f2db66cdb581b51e359355fc8577d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "verticalVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationMirror]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationMirror]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationMirror]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__974a4de758e54f0b8cb07ffd941346bd943b835dacd01585f78ed08cce33e238)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationMonoHue",
    jsii_struct_bases=[],
    name_mapping={"hue": "hue", "hue_var": "hueVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationMonoHue:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c804fa5cf509b6a8381dad75ebed85a05d88ecd0cab54d22c41b10894d1e9e56)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationMonoHue(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationMonoHueList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationMonoHueList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__99d47670c8758eabfd00407b7c9bfeb47e21dfe3bc07fa1339fa81008cf7ecc0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationMonoHueOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__30baf74e4c914a9f51d27c41147f3311d308b651ab10a3332dc8c16f961d1177)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationMonoHueOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a0f6c1cb65a1121d6ecd6822b84252eb4872c8d9a64bffe3ba1b952c88eab716)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__73a1e6e893fae8b2cd011e5a800d318620ac1969a1259302a9e4e2a294768571)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__780cfcedc6731cad0cdef8f6091b90c595eb495a0848db43daeaf297ce957389)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationMonoHue]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationMonoHue]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__18e8c3e3ade0c928e3d7c7b113b7dae95881841734ad03e01790a34983b13d92)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationMonoHueOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationMonoHueOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__53a78dce828d38c6c039c3405f68b1f4f420c38ab4a4101204fb7605304c8185)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__960cec6db6a13467aea175176b7441238dae36814f44dfa68eb325ee23753875)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c883e90a514a28407d84932e045de415d6477a8033b4e4b07b5dbb26bbe7d0fc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationMonoHue]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationMonoHue]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationMonoHue]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b2774cb66a65ea0f4636dbcd3e763644308883119fe23a1a34e13043afba56ab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationOpacity",
    jsii_struct_bases=[],
    name_mapping={"opacity": "opacity", "opacity_var": "opacityVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationOpacity:
    def __init__(
        self,
        *,
        opacity: typing.Optional[builtins.str] = None,
        opacity_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param opacity: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param opacity_var: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__615f44ddd553c14004627374fea250290c10e4cb850d4560f09905824b0a737f)
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument opacity_var", value=opacity_var, expected_type=type_hints["opacity_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if opacity is not None:
            self._values["opacity"] = opacity
        if opacity_var is not None:
            self._values["opacity_var"] = opacity_var

    @builtins.property
    def opacity(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def opacity_var(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        result = self._values.get("opacity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationOpacity(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationOpacityList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationOpacityList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__582f93db2006f4818498e107cfce807f865b97d798e2950c30bcd0a48238b195)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationOpacityOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__10664065449246900b0f1d27c4397116130a145bc146e16d93df7bf4002b08e1)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationOpacityOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d6367c0b1e44dede77b6eeb6c70239c776019157e3ece5650b43b15d464b305)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__89fe16f2531f76cd4e8501082089c854807dc215502739ab496ad30ac03bd9a0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fb32f0bab0e2a9550572d27b56744be03b93490800441c3d3a4c12f38f85ea82)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationOpacity]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationOpacity]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0593c582013b6983a67c8e3c5b7654baf9f67f71a80a7694b7cc0fd3a3294ed7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationOpacityOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationOpacityOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__43d04d2c3325a6129a970abbb04773efab1189f4857114643fd4a4f66ad2607e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetOpacityVar")
    def reset_opacity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacityVar", []))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityVarInput")
    def opacity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacity"))

    @opacity.setter
    def opacity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e4471f3d3e674fa92672c90ad63d119458c715caa3ab6342a105e51c08701228)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacity", value)

    @builtins.property
    @jsii.member(jsii_name="opacityVar")
    def opacity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacityVar"))

    @opacity_var.setter
    def opacity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__289e202a43c64a8feae14a2eedf17cf37a1f17a312b4e97eec08ac181948ad98)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacityVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationOpacity]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationOpacity]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationOpacity]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__79430d615fb025539b30b567bfc0ae1674f0ecf268e2a8d4f4b02d468fa2fe62)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__18a5e279a4f80e6bce0ae546f8254adb048248736271e083cf024bad2971571e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putAppend")
    def put_append(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationAppend, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__387a9d0532e9fb14d7299d1ed8e9fce08fd71a607b08aa4b1be8107599ff89f7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putAppend", [value]))

    @jsii.member(jsii_name="putAspectCrop")
    def put_aspect_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationAspectCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ff0c58c3935a2abb6346c125168b8722858cecee408097e8196610fecebefa43)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putAspectCrop", [value]))

    @jsii.member(jsii_name="putBackgroundColor")
    def put_background_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__40c6858573451379f8cb3805abda6ebd53a1c5f92afa2e2e7463ede0b9d34fb0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBackgroundColor", [value]))

    @jsii.member(jsii_name="putBlur")
    def put_blur(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationBlur, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__54843a58bdb976ab3574b95d931065180f3777871191720343ae8f50ba536a1f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBlur", [value]))

    @jsii.member(jsii_name="putChromaKey")
    def put_chroma_key(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationChromaKey, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b1d037dbad36a432abc0522d1b6a52ed2837097fb4924d8117d10265ca58bb38)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putChromaKey", [value]))

    @jsii.member(jsii_name="putComposite")
    def put_composite(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationComposite, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__22498983e3578f88f42a6dc6582333a82c854e6db61257153fd5156240d12526)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putComposite", [value]))

    @jsii.member(jsii_name="putCompound")
    def put_compound(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationCompound, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__880368031566aeb5e841aa990d047a86401970e415d644f1490246242291c5c9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCompound", [value]))

    @jsii.member(jsii_name="putContrast")
    def put_contrast(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationContrast, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a2e082b936ed4dd6ffef93e803dd6a61adbf0aa6f8ea8ed8c386c69632b1858)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putContrast", [value]))

    @jsii.member(jsii_name="putCrop")
    def put_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7df764f826c8ea5a83bccdad9776eeb1f00da5a0c23d0b524296dcb0e2f39492)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCrop", [value]))

    @jsii.member(jsii_name="putFaceCrop")
    def put_face_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationFaceCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b1bfe7c1457951e2130c77e7d683b476e8b6883ac96a4ef22222765155205990)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFaceCrop", [value]))

    @jsii.member(jsii_name="putFeatureCrop")
    def put_feature_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationFeatureCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e9e89902058f5bf2313456937c4070ac81f3a4086f1af0193067c265407adc02)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFeatureCrop", [value]))

    @jsii.member(jsii_name="putFitAndFill")
    def put_fit_and_fill(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationFitAndFill, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cc867bfcce68e6ecdd0d26fe9e9f1b08fa2adabd62c903682f782296ee2cb253)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFitAndFill", [value]))

    @jsii.member(jsii_name="putGoop")
    def put_goop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationGoop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__437d8d717343c535aadd87b726aed22690c4c94c4ff01bc870528a8aa667dbac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGoop", [value]))

    @jsii.member(jsii_name="putGrayscale")
    def put_grayscale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationGrayscale, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3563e979562ed51eacd3dc7a66963c3f2271ad891b927f11a4867bdc5318fa0d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGrayscale", [value]))

    @jsii.member(jsii_name="putHsl")
    def put_hsl(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationHsl, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c9765d8315203e952463b3ae8c0b24cdb50971b89464b410f0afd1cadc0f311c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsl", [value]))

    @jsii.member(jsii_name="putHsv")
    def put_hsv(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationHsv, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2467a8631bb176db9ae7273ed5ca6c13a741f50fd71f17094a7d9ed497154d33)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsv", [value]))

    @jsii.member(jsii_name="putIfDimension")
    def put_if_dimension(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfDimension, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3bd3564b31bf2b08e7b56e3ce0b7ece429bc89dce0e1a0f2fff8034a1b2d5678)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfDimension", [value]))

    @jsii.member(jsii_name="putIfOrientation")
    def put_if_orientation(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__711bd2052b157af47ff61e5693eac85101ca1806a99dd250199d14ddab6cd4f7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfOrientation", [value]))

    @jsii.member(jsii_name="putImQuery")
    def put_im_query(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationImQuery, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3409631b6d51043cd663fa8ec4db28b3e67f4208619639387f53d709051fc528)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putImQuery", [value]))

    @jsii.member(jsii_name="putMaxColors")
    def put_max_colors(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationMaxColors, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2fc5ed0558af9eedd8b51b5110829cfc4ff2d755927157bf53fe8dfd6406ab3a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMaxColors", [value]))

    @jsii.member(jsii_name="putMirror")
    def put_mirror(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationMirror, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4780e37c0d94e6c5e835edf72d542bb866e640a44ec80f3ec2b298f2cd29e526)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMirror", [value]))

    @jsii.member(jsii_name="putMonoHue")
    def put_mono_hue(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationMonoHue, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7139b30461226335c2bd5e798e4bfae7fa0ad7a01a0a5f2d0e18c1d5f198254a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMonoHue", [value]))

    @jsii.member(jsii_name="putOpacity")
    def put_opacity(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationOpacity, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c299c0c246303d6acc2eba3f3f4d089de801aa50b991ce583e7dbc2ad36ad1a0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putOpacity", [value]))

    @jsii.member(jsii_name="putRegionOfInterestCrop")
    def put_region_of_interest_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationRegionOfInterestCrop", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c75cecf4d979d9b7fa90fc3b3ebfd536e9d339a39ffe85131e7172570a5a7abe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRegionOfInterestCrop", [value]))

    @jsii.member(jsii_name="putRelativeCrop")
    def put_relative_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationRelativeCrop", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__62564f57ff4fdf18546703da10e50b13c70d927fe45e3b3d9bdfb118e020e9d2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRelativeCrop", [value]))

    @jsii.member(jsii_name="putRemoveColor")
    def put_remove_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationRemoveColor", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__42c3ec636ee87c052149361e4b483d319c02c4aac898802ec11002da4e2c0517)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRemoveColor", [value]))

    @jsii.member(jsii_name="putResize")
    def put_resize(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationResize", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a83933e57549000460d350a8117ebce190ce6c1e88f607a54efa6237a77fdffc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putResize", [value]))

    @jsii.member(jsii_name="putRotate")
    def put_rotate(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationRotate", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ba18edd9db246f5c05a94ee38aa68f7f41c1707c705fa1fe1a192288ca2203f3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRotate", [value]))

    @jsii.member(jsii_name="putScale")
    def put_scale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationScale", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d9eaf08964d1ab43139c7586c782ca1df5f1ad566f32113eaca56948b981a33a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putScale", [value]))

    @jsii.member(jsii_name="putShear")
    def put_shear(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationShear", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__03e66193d72a7876e98f3fe5fb504829ec4a8c03924d52f8ee995651dbc8130e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putShear", [value]))

    @jsii.member(jsii_name="putTrim")
    def put_trim(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationTrim", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8491e7ea5aff2cbdb7f9bbac9fbd50d8c29c574b0e8446fc665028b4e02325a0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTrim", [value]))

    @jsii.member(jsii_name="putUnsharpMask")
    def put_unsharp_mask(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationUnsharpMask", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3f0c59545d2e7508f025504aa62e9af6c604b5581580013456931bcfa48e78d1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putUnsharpMask", [value]))

    @jsii.member(jsii_name="resetAppend")
    def reset_append(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAppend", []))

    @jsii.member(jsii_name="resetAspectCrop")
    def reset_aspect_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspectCrop", []))

    @jsii.member(jsii_name="resetBackgroundColor")
    def reset_background_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBackgroundColor", []))

    @jsii.member(jsii_name="resetBlur")
    def reset_blur(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBlur", []))

    @jsii.member(jsii_name="resetChromaKey")
    def reset_chroma_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChromaKey", []))

    @jsii.member(jsii_name="resetComposite")
    def reset_composite(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetComposite", []))

    @jsii.member(jsii_name="resetCompound")
    def reset_compound(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCompound", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetCrop")
    def reset_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCrop", []))

    @jsii.member(jsii_name="resetFaceCrop")
    def reset_face_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFaceCrop", []))

    @jsii.member(jsii_name="resetFeatureCrop")
    def reset_feature_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureCrop", []))

    @jsii.member(jsii_name="resetFitAndFill")
    def reset_fit_and_fill(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFitAndFill", []))

    @jsii.member(jsii_name="resetGoop")
    def reset_goop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGoop", []))

    @jsii.member(jsii_name="resetGrayscale")
    def reset_grayscale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGrayscale", []))

    @jsii.member(jsii_name="resetHsl")
    def reset_hsl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsl", []))

    @jsii.member(jsii_name="resetHsv")
    def reset_hsv(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsv", []))

    @jsii.member(jsii_name="resetIfDimension")
    def reset_if_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfDimension", []))

    @jsii.member(jsii_name="resetIfOrientation")
    def reset_if_orientation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfOrientation", []))

    @jsii.member(jsii_name="resetImQuery")
    def reset_im_query(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetImQuery", []))

    @jsii.member(jsii_name="resetMaxColors")
    def reset_max_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxColors", []))

    @jsii.member(jsii_name="resetMirror")
    def reset_mirror(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMirror", []))

    @jsii.member(jsii_name="resetMonoHue")
    def reset_mono_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonoHue", []))

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetRegionOfInterestCrop")
    def reset_region_of_interest_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRegionOfInterestCrop", []))

    @jsii.member(jsii_name="resetRelativeCrop")
    def reset_relative_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRelativeCrop", []))

    @jsii.member(jsii_name="resetRemoveColor")
    def reset_remove_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRemoveColor", []))

    @jsii.member(jsii_name="resetResize")
    def reset_resize(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetResize", []))

    @jsii.member(jsii_name="resetRotate")
    def reset_rotate(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRotate", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetShear")
    def reset_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetShear", []))

    @jsii.member(jsii_name="resetTrim")
    def reset_trim(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTrim", []))

    @jsii.member(jsii_name="resetUnsharpMask")
    def reset_unsharp_mask(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUnsharpMask", []))

    @builtins.property
    @jsii.member(jsii_name="append")
    def append(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationAppendList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationAppendList, jsii.get(self, "append"))

    @builtins.property
    @jsii.member(jsii_name="aspectCrop")
    def aspect_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationAspectCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationAspectCropList, jsii.get(self, "aspectCrop"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColor")
    def background_color(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationBackgroundColorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationBackgroundColorList, jsii.get(self, "backgroundColor"))

    @builtins.property
    @jsii.member(jsii_name="blur")
    def blur(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationBlurList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationBlurList, jsii.get(self, "blur"))

    @builtins.property
    @jsii.member(jsii_name="chromaKey")
    def chroma_key(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationChromaKeyList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationChromaKeyList, jsii.get(self, "chromaKey"))

    @builtins.property
    @jsii.member(jsii_name="composite")
    def composite(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationCompositeList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationCompositeList, jsii.get(self, "composite"))

    @builtins.property
    @jsii.member(jsii_name="compound")
    def compound(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationCompoundList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationCompoundList, jsii.get(self, "compound"))

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationContrastList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationContrastList, jsii.get(self, "contrast"))

    @builtins.property
    @jsii.member(jsii_name="crop")
    def crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationCropList, jsii.get(self, "crop"))

    @builtins.property
    @jsii.member(jsii_name="faceCrop")
    def face_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationFaceCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationFaceCropList, jsii.get(self, "faceCrop"))

    @builtins.property
    @jsii.member(jsii_name="featureCrop")
    def feature_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationFeatureCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationFeatureCropList, jsii.get(self, "featureCrop"))

    @builtins.property
    @jsii.member(jsii_name="fitAndFill")
    def fit_and_fill(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationFitAndFillList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationFitAndFillList, jsii.get(self, "fitAndFill"))

    @builtins.property
    @jsii.member(jsii_name="goop")
    def goop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationGoopList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationGoopList, jsii.get(self, "goop"))

    @builtins.property
    @jsii.member(jsii_name="grayscale")
    def grayscale(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationGrayscaleList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationGrayscaleList, jsii.get(self, "grayscale"))

    @builtins.property
    @jsii.member(jsii_name="hsl")
    def hsl(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationHslList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationHslList, jsii.get(self, "hsl"))

    @builtins.property
    @jsii.member(jsii_name="hsv")
    def hsv(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationHsvList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationHsvList, jsii.get(self, "hsv"))

    @builtins.property
    @jsii.member(jsii_name="ifDimension")
    def if_dimension(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfDimensionList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfDimensionList, jsii.get(self, "ifDimension"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientation")
    def if_orientation(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfOrientationList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfOrientationList, jsii.get(self, "ifOrientation"))

    @builtins.property
    @jsii.member(jsii_name="imQuery")
    def im_query(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationImQueryList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationImQueryList, jsii.get(self, "imQuery"))

    @builtins.property
    @jsii.member(jsii_name="maxColors")
    def max_colors(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationMaxColorsList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationMaxColorsList, jsii.get(self, "maxColors"))

    @builtins.property
    @jsii.member(jsii_name="mirror")
    def mirror(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationMirrorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationMirrorList, jsii.get(self, "mirror"))

    @builtins.property
    @jsii.member(jsii_name="monoHue")
    def mono_hue(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationMonoHueList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationMonoHueList, jsii.get(self, "monoHue"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationOpacityList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationOpacityList, jsii.get(self, "opacity"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestCrop")
    def region_of_interest_crop(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationRegionOfInterestCropList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationRegionOfInterestCropList", jsii.get(self, "regionOfInterestCrop"))

    @builtins.property
    @jsii.member(jsii_name="relativeCrop")
    def relative_crop(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationRelativeCropList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationRelativeCropList", jsii.get(self, "relativeCrop"))

    @builtins.property
    @jsii.member(jsii_name="removeColor")
    def remove_color(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationRemoveColorList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationRemoveColorList", jsii.get(self, "removeColor"))

    @builtins.property
    @jsii.member(jsii_name="resize")
    def resize(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationResizeList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationResizeList", jsii.get(self, "resize"))

    @builtins.property
    @jsii.member(jsii_name="rotate")
    def rotate(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationRotateList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationRotateList", jsii.get(self, "rotate"))

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationScaleList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationScaleList", jsii.get(self, "scale"))

    @builtins.property
    @jsii.member(jsii_name="shear")
    def shear(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationShearList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationShearList", jsii.get(self, "shear"))

    @builtins.property
    @jsii.member(jsii_name="trim")
    def trim(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationTrimList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationTrimList", jsii.get(self, "trim"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMask")
    def unsharp_mask(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationUnsharpMaskList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationUnsharpMaskList", jsii.get(self, "unsharpMask"))

    @builtins.property
    @jsii.member(jsii_name="appendInput")
    def append_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationAppend]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationAppend]]], jsii.get(self, "appendInput"))

    @builtins.property
    @jsii.member(jsii_name="aspectCropInput")
    def aspect_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationAspectCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationAspectCrop]]], jsii.get(self, "aspectCropInput"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColorInput")
    def background_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationBackgroundColor]]], jsii.get(self, "backgroundColorInput"))

    @builtins.property
    @jsii.member(jsii_name="blurInput")
    def blur_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationBlur]]], jsii.get(self, "blurInput"))

    @builtins.property
    @jsii.member(jsii_name="chromaKeyInput")
    def chroma_key_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationChromaKey]]], jsii.get(self, "chromaKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="compositeInput")
    def composite_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationComposite]]], jsii.get(self, "compositeInput"))

    @builtins.property
    @jsii.member(jsii_name="compoundInput")
    def compound_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationCompound]]], jsii.get(self, "compoundInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationContrast]]], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="cropInput")
    def crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationCrop]]], jsii.get(self, "cropInput"))

    @builtins.property
    @jsii.member(jsii_name="faceCropInput")
    def face_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationFaceCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationFaceCrop]]], jsii.get(self, "faceCropInput"))

    @builtins.property
    @jsii.member(jsii_name="featureCropInput")
    def feature_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationFeatureCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationFeatureCrop]]], jsii.get(self, "featureCropInput"))

    @builtins.property
    @jsii.member(jsii_name="fitAndFillInput")
    def fit_and_fill_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationFitAndFill]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationFitAndFill]]], jsii.get(self, "fitAndFillInput"))

    @builtins.property
    @jsii.member(jsii_name="goopInput")
    def goop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationGoop]]], jsii.get(self, "goopInput"))

    @builtins.property
    @jsii.member(jsii_name="grayscaleInput")
    def grayscale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationGrayscale]]], jsii.get(self, "grayscaleInput"))

    @builtins.property
    @jsii.member(jsii_name="hslInput")
    def hsl_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationHsl]]], jsii.get(self, "hslInput"))

    @builtins.property
    @jsii.member(jsii_name="hsvInput")
    def hsv_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationHsv]]], jsii.get(self, "hsvInput"))

    @builtins.property
    @jsii.member(jsii_name="ifDimensionInput")
    def if_dimension_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfDimension]]], jsii.get(self, "ifDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientationInput")
    def if_orientation_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfOrientation]]], jsii.get(self, "ifOrientationInput"))

    @builtins.property
    @jsii.member(jsii_name="imQueryInput")
    def im_query_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationImQuery]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationImQuery]]], jsii.get(self, "imQueryInput"))

    @builtins.property
    @jsii.member(jsii_name="maxColorsInput")
    def max_colors_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationMaxColors]]], jsii.get(self, "maxColorsInput"))

    @builtins.property
    @jsii.member(jsii_name="mirrorInput")
    def mirror_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationMirror]]], jsii.get(self, "mirrorInput"))

    @builtins.property
    @jsii.member(jsii_name="monoHueInput")
    def mono_hue_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationMonoHue]]], jsii.get(self, "monoHueInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationOpacity]]], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestCropInput")
    def region_of_interest_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationRegionOfInterestCrop"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationRegionOfInterestCrop"]]], jsii.get(self, "regionOfInterestCropInput"))

    @builtins.property
    @jsii.member(jsii_name="relativeCropInput")
    def relative_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationRelativeCrop"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationRelativeCrop"]]], jsii.get(self, "relativeCropInput"))

    @builtins.property
    @jsii.member(jsii_name="removeColorInput")
    def remove_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationRemoveColor"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationRemoveColor"]]], jsii.get(self, "removeColorInput"))

    @builtins.property
    @jsii.member(jsii_name="resizeInput")
    def resize_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationResize"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationResize"]]], jsii.get(self, "resizeInput"))

    @builtins.property
    @jsii.member(jsii_name="rotateInput")
    def rotate_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationRotate"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationRotate"]]], jsii.get(self, "rotateInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationScale"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationScale"]]], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="shearInput")
    def shear_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationShear"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationShear"]]], jsii.get(self, "shearInput"))

    @builtins.property
    @jsii.member(jsii_name="trimInput")
    def trim_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationTrim"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationTrim"]]], jsii.get(self, "trimInput"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMaskInput")
    def unsharp_mask_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationUnsharpMask"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationUnsharpMask"]]], jsii.get(self, "unsharpMaskInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__51161a8bc01fcab25cedf694c1a51170cc234b4db98224c127ad11c68c47ad97)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationRegionOfInterestCrop",
    jsii_struct_bases=[],
    name_mapping={
        "region_of_interest": "regionOfInterest",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationRegionOfInterestCrop:
    def __init__(
        self,
        *,
        region_of_interest: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationRegionOfInterestCropRegionOfInterest", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param region_of_interest: region_of_interest block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest DataAkamaiImagingPolicyImage#region_of_interest}
        :param gravity: The placement of the crop area relative to the specified area of interest. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: The placement of the crop area relative to the specified area of interest. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param style: Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(region_of_interest, dict):
            region_of_interest = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationRegionOfInterestCropRegionOfInterest(**region_of_interest)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f6a2739cf0b0ad7b6a6c75023c4ff84d05def753d2a4807c14837092ed62d67c)
            check_type(argname="argument region_of_interest", value=region_of_interest, expected_type=type_hints["region_of_interest"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "region_of_interest": region_of_interest,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def region_of_interest(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationRegionOfInterestCropRegionOfInterest":
        '''region_of_interest block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest DataAkamaiImagingPolicyImage#region_of_interest}
        '''
        result = self._values.get("region_of_interest")
        assert result is not None, "Required property 'region_of_interest' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationRegionOfInterestCropRegionOfInterest", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''The placement of the crop area relative to the specified area of interest.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''The placement of the crop area relative to the specified area of interest.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationRegionOfInterestCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationRegionOfInterestCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationRegionOfInterestCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bcb7c87aacdf6e0cf158a523714471aa519237f8e037a8c34e1cc1087d6585fb)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationRegionOfInterestCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__994c7608e591a6fac3210c75c2aca646710b386f31280da6f4ab1c8f81515353)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationRegionOfInterestCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__120b49dd6a210f98fefe3ce7168959bf84e9a30845febb020410f78178e10fbe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d6f1f69d20a3ae91bb348d1992ee2208301ac19cd7f2c4f711c47a30a5a7369a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1db1251867eac77d3bf2d812cd73e9b8ca84d69500a7e44a00dd4fb0304bec8a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationRegionOfInterestCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationRegionOfInterestCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationRegionOfInterestCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0e2b61826f25fdcdd8d8aa87d10d63cf48aef656dbed64e05b4c39da13404966)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationRegionOfInterestCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationRegionOfInterestCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a6e0bb617e29608de4c865db684796852c806c587d98cca9f9138e5d106ecce0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putRegionOfInterest")
    def put_region_of_interest(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationRegionOfInterestCropRegionOfInterest()

        return typing.cast(None, jsii.invoke(self, "putRegionOfInterest", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterest")
    def region_of_interest(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestOutputReference", jsii.get(self, "regionOfInterest"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestInput")
    def region_of_interest_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationRegionOfInterestCropRegionOfInterest"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationRegionOfInterestCropRegionOfInterest"], jsii.get(self, "regionOfInterestInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d27de2ea1867004514273de53d0a7bd429a3dbee91ea9f334f5502ede1069a3f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__238e718327ac1861f1435b4cfffa7d4e25526923af8a648f9c87da7d54f4feb9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fe90b70b4a087a6c2ffc7051d45e567b803f19761fee789ca961d643b3d3b40e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e745026e7b4c369c298d39ba7de06fca0c55bc7451c8a739f06965086118cbd8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f073314769a22da6a114454ab40d38a5d7834ae52d7ceb44bf23beeb82b941e2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__20de8e3458b3eb7c790d166eb448e9d20c33ce18a47cf373fd03abffc4545e9a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b3489486149c59f7f0c33cf3c32cec2424a1ea4eb269be60626e7054cea11e37)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f32e4b59bf0589fce2d60bcc43b6f6b94f7c04f4bb0742aced97ab7beeaaa1af)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationRegionOfInterestCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationRegionOfInterestCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationRegionOfInterestCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__935944ed0735c3f1696aba9ab11405fc1a7ed639784bdb46ef82d5b0384296ea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationRegionOfInterestCropRegionOfInterest",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationRegionOfInterestCropRegionOfInterest:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationRegionOfInterestCropRegionOfInterest(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5727fdf684806a0e5393633b90c0061f1f92c6107bdd5df74565b756a29b0236)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationRegionOfInterestCropRegionOfInterest]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationRegionOfInterestCropRegionOfInterest], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationRegionOfInterestCropRegionOfInterest],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__28f69e46931fec65207682389869eb8d0a0619039c25aedb1234d09d15f4944c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationRelativeCrop",
    jsii_struct_bases=[],
    name_mapping={
        "east": "east",
        "east_var": "eastVar",
        "north": "north",
        "north_var": "northVar",
        "south": "south",
        "south_var": "southVar",
        "west": "west",
        "west_var": "westVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationRelativeCrop:
    def __init__(
        self,
        *,
        east: typing.Optional[builtins.str] = None,
        east_var: typing.Optional[builtins.str] = None,
        north: typing.Optional[builtins.str] = None,
        north_var: typing.Optional[builtins.str] = None,
        south: typing.Optional[builtins.str] = None,
        south_var: typing.Optional[builtins.str] = None,
        west: typing.Optional[builtins.str] = None,
        west_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param east: The number of pixels to shrink or expand the right side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east DataAkamaiImagingPolicyImage#east}
        :param east_var: The number of pixels to shrink or expand the right side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east_var DataAkamaiImagingPolicyImage#east_var}
        :param north: The number of pixels to shrink or expand the top side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north DataAkamaiImagingPolicyImage#north}
        :param north_var: The number of pixels to shrink or expand the top side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north_var DataAkamaiImagingPolicyImage#north_var}
        :param south: The number of pixels to shrink or expand the bottom side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south DataAkamaiImagingPolicyImage#south}
        :param south_var: The number of pixels to shrink or expand the bottom side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south_var DataAkamaiImagingPolicyImage#south_var}
        :param west: The number of pixels to shrink or expand the left side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west DataAkamaiImagingPolicyImage#west}
        :param west_var: The number of pixels to shrink or expand the left side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west_var DataAkamaiImagingPolicyImage#west_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__33924f75ac9bff26a0a84d7af926077641796e42b43a9c5e2bd6bce0142060e3)
            check_type(argname="argument east", value=east, expected_type=type_hints["east"])
            check_type(argname="argument east_var", value=east_var, expected_type=type_hints["east_var"])
            check_type(argname="argument north", value=north, expected_type=type_hints["north"])
            check_type(argname="argument north_var", value=north_var, expected_type=type_hints["north_var"])
            check_type(argname="argument south", value=south, expected_type=type_hints["south"])
            check_type(argname="argument south_var", value=south_var, expected_type=type_hints["south_var"])
            check_type(argname="argument west", value=west, expected_type=type_hints["west"])
            check_type(argname="argument west_var", value=west_var, expected_type=type_hints["west_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if east is not None:
            self._values["east"] = east
        if east_var is not None:
            self._values["east_var"] = east_var
        if north is not None:
            self._values["north"] = north
        if north_var is not None:
            self._values["north_var"] = north_var
        if south is not None:
            self._values["south"] = south
        if south_var is not None:
            self._values["south_var"] = south_var
        if west is not None:
            self._values["west"] = west
        if west_var is not None:
            self._values["west_var"] = west_var

    @builtins.property
    def east(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the right side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east DataAkamaiImagingPolicyImage#east}
        '''
        result = self._values.get("east")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def east_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the right side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east_var DataAkamaiImagingPolicyImage#east_var}
        '''
        result = self._values.get("east_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def north(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the top side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north DataAkamaiImagingPolicyImage#north}
        '''
        result = self._values.get("north")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def north_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the top side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north_var DataAkamaiImagingPolicyImage#north_var}
        '''
        result = self._values.get("north_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def south(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the bottom side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south DataAkamaiImagingPolicyImage#south}
        '''
        result = self._values.get("south")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def south_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the bottom side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south_var DataAkamaiImagingPolicyImage#south_var}
        '''
        result = self._values.get("south_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def west(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the left side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west DataAkamaiImagingPolicyImage#west}
        '''
        result = self._values.get("west")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def west_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the left side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west_var DataAkamaiImagingPolicyImage#west_var}
        '''
        result = self._values.get("west_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationRelativeCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationRelativeCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationRelativeCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ed827636a0ba2f4a3229b25c01b2ad6618c5357481dd7232f1a3522c054b9490)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationRelativeCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__198e3388843cc7d55de13f46d982010d1645b1a1cb6cb9f1099765435086271a)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationRelativeCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__57b27b55830daf7981b41a3aaa8bfa08d73e8115da96a7c19518a3ac142e8bf6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9aae4c9625a9ef57b6d1adec5640cc61ef1347077ad91c82c71225679c1d03ae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c5ac886917e67b0854e285fd28101199f1385b1244cc676f75eaf9e761070225)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationRelativeCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationRelativeCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationRelativeCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b531f558dd65212194933c8838ea5f0683823b7a0723ea060b2ecfd1931f239d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationRelativeCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationRelativeCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__990898938b5a79403c3a1ad6b394ef790f0328f01683add9dcd19e7dd156f32e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetEast")
    def reset_east(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEast", []))

    @jsii.member(jsii_name="resetEastVar")
    def reset_east_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEastVar", []))

    @jsii.member(jsii_name="resetNorth")
    def reset_north(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNorth", []))

    @jsii.member(jsii_name="resetNorthVar")
    def reset_north_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNorthVar", []))

    @jsii.member(jsii_name="resetSouth")
    def reset_south(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSouth", []))

    @jsii.member(jsii_name="resetSouthVar")
    def reset_south_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSouthVar", []))

    @jsii.member(jsii_name="resetWest")
    def reset_west(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWest", []))

    @jsii.member(jsii_name="resetWestVar")
    def reset_west_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWestVar", []))

    @builtins.property
    @jsii.member(jsii_name="eastInput")
    def east_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "eastInput"))

    @builtins.property
    @jsii.member(jsii_name="eastVarInput")
    def east_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "eastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="northInput")
    def north_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "northInput"))

    @builtins.property
    @jsii.member(jsii_name="northVarInput")
    def north_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "northVarInput"))

    @builtins.property
    @jsii.member(jsii_name="southInput")
    def south_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "southInput"))

    @builtins.property
    @jsii.member(jsii_name="southVarInput")
    def south_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "southVarInput"))

    @builtins.property
    @jsii.member(jsii_name="westInput")
    def west_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "westInput"))

    @builtins.property
    @jsii.member(jsii_name="westVarInput")
    def west_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "westVarInput"))

    @builtins.property
    @jsii.member(jsii_name="east")
    def east(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "east"))

    @east.setter
    def east(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a8e2951ed560657f021ad8f4e69a7ebd14e5e5b4657b47c65e5a7f0cc7385e60)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "east", value)

    @builtins.property
    @jsii.member(jsii_name="eastVar")
    def east_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "eastVar"))

    @east_var.setter
    def east_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ca29a3066bfe4774068412eed97d9444379072f8c920a9690587226a365ad396)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "eastVar", value)

    @builtins.property
    @jsii.member(jsii_name="north")
    def north(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "north"))

    @north.setter
    def north(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8caa56c2c8115178e8a848e8a1aa6d62beb09775cd764ba1bb41979582bcb037)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "north", value)

    @builtins.property
    @jsii.member(jsii_name="northVar")
    def north_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "northVar"))

    @north_var.setter
    def north_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__49a19532221286c9379d3e446022956807a9d9cd1fc290583f34c39642201bed)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "northVar", value)

    @builtins.property
    @jsii.member(jsii_name="south")
    def south(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "south"))

    @south.setter
    def south(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a69c3d9aec22667c88fc9bdce8a07c035ee04152122f7d7f07818fc33dbe6b25)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "south", value)

    @builtins.property
    @jsii.member(jsii_name="southVar")
    def south_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "southVar"))

    @south_var.setter
    def south_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__545cef8272be90ce3078d14432fae90af37b51940ecaa79eb508ef5ef72cb772)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "southVar", value)

    @builtins.property
    @jsii.member(jsii_name="west")
    def west(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "west"))

    @west.setter
    def west(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3530abe8c20977e6273678e29569d6d3b6aba46b12a05d72052a0c1f6ac6fc39)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "west", value)

    @builtins.property
    @jsii.member(jsii_name="westVar")
    def west_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "westVar"))

    @west_var.setter
    def west_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eeb0166366e3ab05d152a0ffc8ed0fb9e54c968e69f3c7400c8a8de4364b5dce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "westVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationRelativeCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationRelativeCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationRelativeCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ffc9dedded0342682c60b034aba42852e65a23e396e9abd143f95061944d7534)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationRemoveColor",
    jsii_struct_bases=[],
    name_mapping={
        "color": "color",
        "color_var": "colorVar",
        "feather": "feather",
        "feather_var": "featherVar",
        "tolerance": "tolerance",
        "tolerance_var": "toleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationRemoveColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
        feather: typing.Optional[builtins.str] = None,
        feather_var: typing.Optional[builtins.str] = None,
        tolerance: typing.Optional[builtins.str] = None,
        tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        :param feather: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        :param feather_var: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        :param tolerance: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        :param tolerance_var: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__598e8a365bf3eb13ecff7018093ddb2d148205f6c9963ad4ff48bb799c88bb6b)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
            check_type(argname="argument feather", value=feather, expected_type=type_hints["feather"])
            check_type(argname="argument feather_var", value=feather_var, expected_type=type_hints["feather_var"])
            check_type(argname="argument tolerance", value=tolerance, expected_type=type_hints["tolerance"])
            check_type(argname="argument tolerance_var", value=tolerance_var, expected_type=type_hints["tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var
        if feather is not None:
            self._values["feather"] = feather
        if feather_var is not None:
            self._values["feather_var"] = feather_var
        if tolerance is not None:
            self._values["tolerance"] = tolerance
        if tolerance_var is not None:
            self._values["tolerance_var"] = tolerance_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        '''
        result = self._values.get("feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather_var(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        '''
        result = self._values.get("feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        '''
        result = self._values.get("tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance_var(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        result = self._values.get("tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationRemoveColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationRemoveColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationRemoveColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9043ae880a14904411630c898ee4a602fe07988a49e7475782cd6c69d43ef330)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationRemoveColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__22908dba3ab2517de22cb41c239a35c034699f0336655453251cec79059d1e53)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationRemoveColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1ebfb721d0812e69dee7176e6406b42df3e06beb8f85302ca95c7de3c4b16fca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ccb9e28c4ee0a3254066210c2ec7de8b1e9f9e3c981613f9cef0dede9e508201)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f22400e9d8f2b5ebcd8f8a2c0c5f06fbad43021c8f797b9d51276bade4d75ff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationRemoveColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationRemoveColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationRemoveColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6fd969979a28cb14cf9685edfc7ef46a87ab80b9dde0df2bae36a1cd06a73196)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationRemoveColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationRemoveColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7cb12b3d320b02bc4e0c25702e99d2f050c3bc3d29cec6f64aa9da8c2eb72e8e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @jsii.member(jsii_name="resetFeather")
    def reset_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeather", []))

    @jsii.member(jsii_name="resetFeatherVar")
    def reset_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatherVar", []))

    @jsii.member(jsii_name="resetTolerance")
    def reset_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTolerance", []))

    @jsii.member(jsii_name="resetToleranceVar")
    def reset_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featherInput")
    def feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherInput"))

    @builtins.property
    @jsii.member(jsii_name="featherVarInput")
    def feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceInput")
    def tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceVarInput")
    def tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d92e2d809b38e5c00ddfe2c951fdfcf5592b2f50149b270e8c5a8bcb7836192)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e4a3fbb6d7fa59d38e31003c4db29b40da9734d02b4eb970b4961a647e5a9f7a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="feather")
    def feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "feather"))

    @feather.setter
    def feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1e503e9d65bccb958da2906d3a92fc046f387686b41f990c6a61cf4fdfdb2a18)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "feather", value)

    @builtins.property
    @jsii.member(jsii_name="featherVar")
    def feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featherVar"))

    @feather_var.setter
    def feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2e777112ab9c7129ff3736695f77fbba53f3942e3e454b150d33705a04a5b913)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featherVar", value)

    @builtins.property
    @jsii.member(jsii_name="tolerance")
    def tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tolerance"))

    @tolerance.setter
    def tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c1ebaef286438762338d938821aee3ba1fdb741f26cec09fd27340704e1cedbe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tolerance", value)

    @builtins.property
    @jsii.member(jsii_name="toleranceVar")
    def tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "toleranceVar"))

    @tolerance_var.setter
    def tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fad1a9268a310559aedbde583fd0faa3ec2a140f6025aceb4ab12ad4ff0bae7a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "toleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationRemoveColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationRemoveColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationRemoveColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__47ab895d75f2a3253936d839f5becdea9d2fdd7cc0a0708a9ab6cd4736176db0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationResize",
    jsii_struct_bases=[],
    name_mapping={
        "aspect": "aspect",
        "aspect_var": "aspectVar",
        "height": "height",
        "height_var": "heightVar",
        "type": "type",
        "type_var": "typeVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationResize:
    def __init__(
        self,
        *,
        aspect: typing.Optional[builtins.str] = None,
        aspect_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param aspect: Preserves the aspect ratio. Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect DataAkamaiImagingPolicyImage#aspect}
        :param aspect_var: Preserves the aspect ratio. Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_var DataAkamaiImagingPolicyImage#aspect_var}
        :param height: The height to resize the source image to. Must be set if height is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height to resize the source image to. Must be set if height is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param type: Sets constraints for the image resize. Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: Sets constraints for the image resize. Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        :param width: The width to resize the source image to. Must be set if width is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width to resize the source image to. Must be set if width is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7af760938fecaf35b95610383a63b6a507e23e1e65e8985c2255301d93b21acb)
            check_type(argname="argument aspect", value=aspect, expected_type=type_hints["aspect"])
            check_type(argname="argument aspect_var", value=aspect_var, expected_type=type_hints["aspect_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if aspect is not None:
            self._values["aspect"] = aspect
        if aspect_var is not None:
            self._values["aspect_var"] = aspect_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def aspect(self) -> typing.Optional[builtins.str]:
        '''Preserves the aspect ratio.

        Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect DataAkamaiImagingPolicyImage#aspect}
        '''
        result = self._values.get("aspect")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def aspect_var(self) -> typing.Optional[builtins.str]:
        '''Preserves the aspect ratio.

        Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_var DataAkamaiImagingPolicyImage#aspect_var}
        '''
        result = self._values.get("aspect_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height to resize the source image to. Must be set if height is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height to resize the source image to. Must be set if height is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''Sets constraints for the image resize.

        Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''Sets constraints for the image resize.

        Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width to resize the source image to. Must be set if width is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width to resize the source image to. Must be set if width is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationResize(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationResizeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationResizeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0522fb08aa32698d9a5f07b28d6c47efe6a54498a6ab23e292328d7f103bc93c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationResizeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a59cb5ff0aea2bbe8c27d1de2cfff8c996a5e9b01c568355838a5090a4ccd3da)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationResizeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ed89ad550d1b92b13d99911832df6ed37fc44a80427677a8f474dcd1f4c3db45)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9af422a89782a042dd839e525f2b109fc23280e0dcf69d0550bb8dbca73b63b7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ca9a280343b61c764ef9569cca531efd0bd9bdcd56499d6665816764ab698767)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationResize]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationResize]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationResize]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ef645e328611e3aee93699055df0991350a1e0cb02f5218bf0bc444b84dd2856)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationResizeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationResizeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6db2d6094f22af29a54eb07f1cf1cd4222befbe03989cd4295d62aeb94609f17)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAspect")
    def reset_aspect(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspect", []))

    @jsii.member(jsii_name="resetAspectVar")
    def reset_aspect_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspectVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="aspectInput")
    def aspect_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "aspectInput"))

    @builtins.property
    @jsii.member(jsii_name="aspectVarInput")
    def aspect_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "aspectVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="aspect")
    def aspect(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "aspect"))

    @aspect.setter
    def aspect(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fc88b4fa4f5dcdd027f4d724b04475c554015a306e6b7f195e03ef19f62b32e9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "aspect", value)

    @builtins.property
    @jsii.member(jsii_name="aspectVar")
    def aspect_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "aspectVar"))

    @aspect_var.setter
    def aspect_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a6734b9024f1f07c44e70535399cae3fca34c32c9a326e752dcc7cf3bbeeefcb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "aspectVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f4da01ae08351dc7ca094977ec458ea802c89b4370ba08ab0250402c5cd72aeb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__652ec74498f9d16a859ce64ea0a6dfe0652b10e1da556ff184948f7f8e3032e0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8b2c5232e2700a09491aacd1f9d5bd611214b6855c91a5fbdbabc525c10dbee3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e5ba3df9d5f61c30dd1d6b5a001c8920175023f4abcf54a49ab93eb0f16252d5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7fd958053a09e511ca0f7c90d4f20fbe1d1018d983e80ff02d1ce85776937e35)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__709c1da4cf0a2780fc953f7fc4ad6ff74bb75dca2a5221a9287d7b217bd93c07)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationResize]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationResize]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationResize]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__19d7f5e9cc6ac942c1e1c074412037a4f9f9c17b52062c8832e83a89485ad4ff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationRotate",
    jsii_struct_bases=[],
    name_mapping={"degrees": "degrees", "degrees_var": "degreesVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationRotate:
    def __init__(
        self,
        *,
        degrees: typing.Optional[builtins.str] = None,
        degrees_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param degrees: The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees DataAkamaiImagingPolicyImage#degrees}
        :param degrees_var: The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees_var DataAkamaiImagingPolicyImage#degrees_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__653040577070f939531e9827a4149d7395403535fdae7ffd276f2145eece9a58)
            check_type(argname="argument degrees", value=degrees, expected_type=type_hints["degrees"])
            check_type(argname="argument degrees_var", value=degrees_var, expected_type=type_hints["degrees_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if degrees is not None:
            self._values["degrees"] = degrees
        if degrees_var is not None:
            self._values["degrees_var"] = degrees_var

    @builtins.property
    def degrees(self) -> typing.Optional[builtins.str]:
        '''The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees DataAkamaiImagingPolicyImage#degrees}
        '''
        result = self._values.get("degrees")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def degrees_var(self) -> typing.Optional[builtins.str]:
        '''The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees_var DataAkamaiImagingPolicyImage#degrees_var}
        '''
        result = self._values.get("degrees_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationRotate(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationRotateList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationRotateList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e582006784489d6215ad6cf65833fceb7ac8f95f3c1758f5d7cab6aa747e368a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationRotateOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__39bf13272e2edbf8a4520bd307904491db4c58f58fca40fa63bb052acee91e12)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationRotateOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ffa0bce3f75e31fed3ca1d623b62f5f869e83c2903fcbb2e17f9841476068650)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d1cf2ffba0dec419f4069bf47389b7ecf89cd8c1ecb70e28a006a1fecc472225)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f5045c95fccaa8ece63ad48c2f4fbe7f2835375138a97d6770b985d13234933a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationRotate]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationRotate]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationRotate]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2788886856ac5d093a15fd8f1a3878c03bbc5f3ee475a7a5a8bfad9f9bb431e7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationRotateOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationRotateOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d359f1b84c5c26ccad493f1583450b7377fd551ac421cde141dcf29f39e1d2bd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetDegrees")
    def reset_degrees(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDegrees", []))

    @jsii.member(jsii_name="resetDegreesVar")
    def reset_degrees_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDegreesVar", []))

    @builtins.property
    @jsii.member(jsii_name="degreesInput")
    def degrees_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "degreesInput"))

    @builtins.property
    @jsii.member(jsii_name="degreesVarInput")
    def degrees_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "degreesVarInput"))

    @builtins.property
    @jsii.member(jsii_name="degrees")
    def degrees(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "degrees"))

    @degrees.setter
    def degrees(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ebcc22562736ebdc4d17b39f558e3f27a2e055bcec34cee13cbface2d3a00572)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "degrees", value)

    @builtins.property
    @jsii.member(jsii_name="degreesVar")
    def degrees_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "degreesVar"))

    @degrees_var.setter
    def degrees_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dd424a0489c3a047ecf04cc184f9a114359e6084c250fc5955cf64c995ea513e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "degreesVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationRotate]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationRotate]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationRotate]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__75ee744a08b63c5ed2261dcf40723575b1d64cf42aea3bb3cd9c9cc5a5bf6734)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationScale",
    jsii_struct_bases=[],
    name_mapping={
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationScale:
    def __init__(
        self,
        *,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param height: Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged. Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged. Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__31c224859f2aa7d6ed39dbaa48a4c1a7fd0b19b4ac4333f29727bdb644b03b5b)
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size.

        Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size.

        Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged.

        Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged.

        Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationScale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationScaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationScaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__49c7da4b884b5904a81b4e326afa8df0776a00adfbc0bc5bda55394797a19733)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationScaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6ec6ba134b1cc98c8d933e8fdc7ffe0b8bddaa1b05d0ae07fc6b6584c8e266dd)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationScaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__77c560010a6168cfaf9592873056cb95890ed4dba491bed21eba432509164c62)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9dfab1d1db4b3df6608d76ae7d641f54d2a220d1518ec4be5da83a54b112e172)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3c8b70ebda439a0236b8327ccfcb93377e271396fef91e1c56ede908ae6c0a60)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationScale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationScale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationScale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__db1dd7f9df26bdc19f82385dda1862d0087e9caad007a4bbb20dc649f4c1f1d2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationScaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationScaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f817dc2bc7bd3cc5b81d08f9ff492f0a3100d857a50575ac11bd971763da0bb1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__513ab919b70a31bc033afa35837d691e09005a3b673345f9a7cd9b88326b16e2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__340dc7dab4a95bb940aaa67f4e779022d7e3a38cb05be550545fbca1bd029785)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__71d1e116868ed1fd2f61c22822faa8a165e7c572d5cd2f46c37fe1e850f079b8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7de19ae79267adc7e430a8c6f5ddb3cd989db6599071a410a069ea4a46ef8d01)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationScale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationScale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationScale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__381b9516967069cb9d3c32d409d71bc01e386a828a827dfb6f5f3051003a82fe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationShear",
    jsii_struct_bases=[],
    name_mapping={
        "x_shear": "xShear",
        "x_shear_var": "xShearVar",
        "y_shear": "yShear",
        "y_shear_var": "yShearVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationShear:
    def __init__(
        self,
        *,
        x_shear: typing.Optional[builtins.str] = None,
        x_shear_var: typing.Optional[builtins.str] = None,
        y_shear: typing.Optional[builtins.str] = None,
        y_shear_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param x_shear: The amount to shear along the x-axis, measured in multiples of the image's width. Must be set if yShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear DataAkamaiImagingPolicyImage#x_shear}
        :param x_shear_var: The amount to shear along the x-axis, measured in multiples of the image's width. Must be set if yShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear_var DataAkamaiImagingPolicyImage#x_shear_var}
        :param y_shear: The amount to shear along the y-axis, measured in multiples of the image's height. Must be set if xShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear DataAkamaiImagingPolicyImage#y_shear}
        :param y_shear_var: The amount to shear along the y-axis, measured in multiples of the image's height. Must be set if xShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear_var DataAkamaiImagingPolicyImage#y_shear_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1b7867afaf2c1ead3cb6acd97c2c22d5ba4e043a3b21617f4e396ce4d6403604)
            check_type(argname="argument x_shear", value=x_shear, expected_type=type_hints["x_shear"])
            check_type(argname="argument x_shear_var", value=x_shear_var, expected_type=type_hints["x_shear_var"])
            check_type(argname="argument y_shear", value=y_shear, expected_type=type_hints["y_shear"])
            check_type(argname="argument y_shear_var", value=y_shear_var, expected_type=type_hints["y_shear_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if x_shear is not None:
            self._values["x_shear"] = x_shear
        if x_shear_var is not None:
            self._values["x_shear_var"] = x_shear_var
        if y_shear is not None:
            self._values["y_shear"] = y_shear
        if y_shear_var is not None:
            self._values["y_shear_var"] = y_shear_var

    @builtins.property
    def x_shear(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the x-axis, measured in multiples of the image's width.

        Must be set if yShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear DataAkamaiImagingPolicyImage#x_shear}
        '''
        result = self._values.get("x_shear")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_shear_var(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the x-axis, measured in multiples of the image's width.

        Must be set if yShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear_var DataAkamaiImagingPolicyImage#x_shear_var}
        '''
        result = self._values.get("x_shear_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_shear(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the y-axis, measured in multiples of the image's height.

        Must be set if xShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear DataAkamaiImagingPolicyImage#y_shear}
        '''
        result = self._values.get("y_shear")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_shear_var(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the y-axis, measured in multiples of the image's height.

        Must be set if xShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear_var DataAkamaiImagingPolicyImage#y_shear_var}
        '''
        result = self._values.get("y_shear_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationShear(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationShearList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationShearList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1876065f0ad735cbc7be9bc8d28c21a23814b5d8f40302074c3f1785c169ea50)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationShearOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c80fe9dcca77972536b445355818ecfd5e4950e7435a0fe0a2a87c6d52bc3090)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationShearOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b602d16526f0b66155c2107814bea02062ee05e191ce9acabb5a9a169192f343)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__407c758ae48f3614e6ce78e58e2e57236a7da90e582685ac1b3fab29e2b3bc31)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a9e3f431d01637714553bc39a61fbdb1df78725af68b9a68ac15909c624d4f66)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationShear]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationShear]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationShear]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3398b42240b2a42a4809b538d95775b499a0a99e0324d9189a251f25ab3bfdc5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationShearOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationShearOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f460162324c9e700fa04eaa5579ca61d5129680b3be2595a686895a9d5f38457)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetXShear")
    def reset_x_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXShear", []))

    @jsii.member(jsii_name="resetXShearVar")
    def reset_x_shear_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXShearVar", []))

    @jsii.member(jsii_name="resetYShear")
    def reset_y_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYShear", []))

    @jsii.member(jsii_name="resetYShearVar")
    def reset_y_shear_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYShearVar", []))

    @builtins.property
    @jsii.member(jsii_name="xShearInput")
    def x_shear_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xShearInput"))

    @builtins.property
    @jsii.member(jsii_name="xShearVarInput")
    def x_shear_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xShearVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yShearInput")
    def y_shear_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yShearInput"))

    @builtins.property
    @jsii.member(jsii_name="yShearVarInput")
    def y_shear_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yShearVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xShear")
    def x_shear(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xShear"))

    @x_shear.setter
    def x_shear(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a92d0892313197cd4cd0cc790035e4feaf3d32141afbbcafa517aaa9ed97cd3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xShear", value)

    @builtins.property
    @jsii.member(jsii_name="xShearVar")
    def x_shear_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xShearVar"))

    @x_shear_var.setter
    def x_shear_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f7171893302a39448697d84c750de629669bb5953ee19794af0de031aed1c36c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xShearVar", value)

    @builtins.property
    @jsii.member(jsii_name="yShear")
    def y_shear(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yShear"))

    @y_shear.setter
    def y_shear(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__efe23c46efb7701227a52bc455700fe1a7e43dcc7394365a12420fcff1765d98)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yShear", value)

    @builtins.property
    @jsii.member(jsii_name="yShearVar")
    def y_shear_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yShearVar"))

    @y_shear_var.setter
    def y_shear_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__31f8fc97aa29ead53511864a1650d7f124427f453be6d146491b4ede0db91150)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yShearVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationShear]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationShear]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationShear]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__20a801f3261076d86dddb2b9ef86119d6d548902c56f7b7034a2d74cb75f5b2b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationTrim",
    jsii_struct_bases=[],
    name_mapping={
        "fuzz": "fuzz",
        "fuzz_var": "fuzzVar",
        "padding": "padding",
        "padding_var": "paddingVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationTrim:
    def __init__(
        self,
        *,
        fuzz: typing.Optional[builtins.str] = None,
        fuzz_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fuzz: The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz DataAkamaiImagingPolicyImage#fuzz}
        :param fuzz_var: The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz_var DataAkamaiImagingPolicyImage#fuzz_var}
        :param padding: The amount of padding in pixels to add to the trimmed image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: The amount of padding in pixels to add to the trimmed image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d777ad431a4de9fb6d9947408c0337339b1cf8e9858316e3101a56bb9f2a93f5)
            check_type(argname="argument fuzz", value=fuzz, expected_type=type_hints["fuzz"])
            check_type(argname="argument fuzz_var", value=fuzz_var, expected_type=type_hints["fuzz_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fuzz is not None:
            self._values["fuzz"] = fuzz
        if fuzz_var is not None:
            self._values["fuzz_var"] = fuzz_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var

    @builtins.property
    def fuzz(self) -> typing.Optional[builtins.str]:
        '''The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz DataAkamaiImagingPolicyImage#fuzz}
        '''
        result = self._values.get("fuzz")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fuzz_var(self) -> typing.Optional[builtins.str]:
        '''The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz_var DataAkamaiImagingPolicyImage#fuzz_var}
        '''
        result = self._values.get("fuzz_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''The amount of padding in pixels to add to the trimmed image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''The amount of padding in pixels to add to the trimmed image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationTrim(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationTrimList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationTrimList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b9d228fe2fe89e0eb05a6a69786afbfdd37084ecfc5e9fc191b039eefc907905)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationTrimOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ee23e7d40d9a021b48b54ad20a82562334ab9239c78e8ce1f895924ebca102ed)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationTrimOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1e4c912bbfb94f1c1b17863b2f524a72268a0347d107d25b8c80799a897212db)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f5c98919fb92aae3caeb150476ad50df0c86df351e747a0b4c5527a92d79c798)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__22fbd5397eeeacc6d05447824f5ebf099d4446141cdf3f63ae9604f8399f666e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationTrim]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationTrim]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationTrim]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__035cb8b17d182f2dccd858a6e882d57f01e0aa99e6283bac94405a993d8629ba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationTrimOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationTrimOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1b36b599ef0d9f30bb2d9b4f43c695648bc4dc38c21d52a9b1008b0e9c5445c3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetFuzz")
    def reset_fuzz(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFuzz", []))

    @jsii.member(jsii_name="resetFuzzVar")
    def reset_fuzz_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFuzzVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @builtins.property
    @jsii.member(jsii_name="fuzzInput")
    def fuzz_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fuzzInput"))

    @builtins.property
    @jsii.member(jsii_name="fuzzVarInput")
    def fuzz_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fuzzVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="fuzz")
    def fuzz(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fuzz"))

    @fuzz.setter
    def fuzz(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d50be40d3d3bc202b94359a3148d552f75401a96c24c2e3fd843377053f3e3a6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fuzz", value)

    @builtins.property
    @jsii.member(jsii_name="fuzzVar")
    def fuzz_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fuzzVar"))

    @fuzz_var.setter
    def fuzz_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0b729344ca3f99c4d0b08bbc8c3bd12df5bd05dc5c5bddf34b177e04f7884e5a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fuzzVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bdc2ee6042e15c085468aa919d40a5e678c538d8dc2a95035eca0c1733162d8b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ed8cd53175b114b54c20a82ffa9777863c334a27593491a7fe815ceeee52a8fc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationTrim]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationTrim]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationTrim]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7ea1a1ca7cd0d74bac3ce2a9bfff4cdc65814d9c64dc7db95933b99eb9ab6575)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationUnsharpMask",
    jsii_struct_bases=[],
    name_mapping={
        "gain": "gain",
        "gain_var": "gainVar",
        "sigma": "sigma",
        "sigma_var": "sigmaVar",
        "threshold": "threshold",
        "threshold_var": "thresholdVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationUnsharpMask:
    def __init__(
        self,
        *,
        gain: typing.Optional[builtins.str] = None,
        gain_var: typing.Optional[builtins.str] = None,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
        threshold: typing.Optional[builtins.str] = None,
        threshold_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param gain: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        :param gain_var: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        :param sigma: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        :param threshold: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        :param threshold_var: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fb85e442395c6e4ee8d78f8c6a5037548de4c78e24910acbb42061ea020033c0)
            check_type(argname="argument gain", value=gain, expected_type=type_hints["gain"])
            check_type(argname="argument gain_var", value=gain_var, expected_type=type_hints["gain_var"])
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
            check_type(argname="argument threshold", value=threshold, expected_type=type_hints["threshold"])
            check_type(argname="argument threshold_var", value=threshold_var, expected_type=type_hints["threshold_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if gain is not None:
            self._values["gain"] = gain
        if gain_var is not None:
            self._values["gain_var"] = gain_var
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var
        if threshold is not None:
            self._values["threshold"] = threshold
        if threshold_var is not None:
            self._values["threshold_var"] = threshold_var

    @builtins.property
    def gain(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        '''
        result = self._values.get("gain")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gain_var(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        '''
        result = self._values.get("gain_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        '''
        result = self._values.get("threshold")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold_var(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        result = self._values.get("threshold_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationUnsharpMask(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationUnsharpMaskList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationUnsharpMaskList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8518725be245b4fe02b9bfbba794bfd3a3fec3def4f36fb50ae5ddd59764575a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationUnsharpMaskOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__824b2beb59aae37c60f589e6f956db252d55f64d503db208add22e3a9fa182c0)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationUnsharpMaskOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6079738df140ba9aaf651b20ea591c7918e58684880828abc42e3d20dd82cff6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d7d489dea6c742917ab362d425519828c3b8211345f4f6d22b80b9502ccc061)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6b44831e8af8ef35c3955b2e747ee12bb32b38cf37c9f0c0ce63dab49a0a0f9a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationUnsharpMask]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationUnsharpMask]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationUnsharpMask]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4227befcf4755668ae9690c8ab55c0107b2a15148d084a332802e86d89ce4424)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationUnsharpMaskOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationUnsharpMaskOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__51a5a53b681bb62c4a01aed3f0694ab97a00eda78a2283172254481993cf75e4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetGain")
    def reset_gain(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGain", []))

    @jsii.member(jsii_name="resetGainVar")
    def reset_gain_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGainVar", []))

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @jsii.member(jsii_name="resetThreshold")
    def reset_threshold(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThreshold", []))

    @jsii.member(jsii_name="resetThresholdVar")
    def reset_threshold_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThresholdVar", []))

    @builtins.property
    @jsii.member(jsii_name="gainInput")
    def gain_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainInput"))

    @builtins.property
    @jsii.member(jsii_name="gainVarInput")
    def gain_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdInput")
    def threshold_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdVarInput")
    def threshold_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gain")
    def gain(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gain"))

    @gain.setter
    def gain(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__162f4314ba7ea2691dd1279c63bea72a8fc56bf7af1c5b01906ea007384cbe8c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gain", value)

    @builtins.property
    @jsii.member(jsii_name="gainVar")
    def gain_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gainVar"))

    @gain_var.setter
    def gain_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__52f8a69c6b9ae8dbf29c21db8982a1f46ff3c6829ffa5b7098344df0e9c4ddf4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gainVar", value)

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__208a7e3fe271c52a2a6f49fa69b574b15264e2dc13f19398e95e3e35af19a81f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c8de63a8c557d633d24a8241631b7e5c2eac2c77e72d707909ce5eeee4d8665c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="threshold")
    def threshold(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "threshold"))

    @threshold.setter
    def threshold(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4b802924afdc07a1e49fc71262200f73ceb3c8361ecdda18953179f84d8a8368)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "threshold", value)

    @builtins.property
    @jsii.member(jsii_name="thresholdVar")
    def threshold_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "thresholdVar"))

    @threshold_var.setter
    def threshold_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6bb92c9a06d3e5d434dfb718e2125b53567876aadc97edb306a251b751360fc9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "thresholdVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationUnsharpMask]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationUnsharpMask]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationUnsharpMask]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__37d36380eb42e8ea5a94d62d29c0c2e64d1ce66fc0cb74a7770929ce8f0d6414)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__28eda456e8d6d73bd440c7330abb9e117cb378f9fb5612ffdced717a06d05620)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3f760c019fbe0496a45a70e4b5ad0b3a7e6becfc9a6e85dbc111154f0bb50635)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__98660f5cb5a16872130420d9f73f7a55603f30992a9b4ff56d038509006f8f6d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__04251d5082ad60df9954535d690624b3bae21ceddc5e741afc0f1bd5ba047daa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4cdba1c27b6efd41bf836397645ec5495aaee892af143bb8580d2be9ace81538)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFill]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFill]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFill]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__67e4a9394d697dd913f5f2cc7dcbe68dcf2a7b3de16476b12865eb29f52ac38f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b5bc46b49d3d90a53515cc545fb9418448922994a59de8ed03b49eadb107c203)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putFillTransformation")
    def put_fill_transformation(
        self,
        *,
        append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationAppend, typing.Dict[builtins.str, typing.Any]]]]] = None,
        aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationAspectCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
        crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationFaceCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationFeatureCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationFitAndFill, typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
        im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationImQuery, typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
        region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationRegionOfInterestCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationRelativeCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
        resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationResize, typing.Dict[builtins.str, typing.Any]]]]] = None,
        rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationRotate, typing.Dict[builtins.str, typing.Any]]]]] = None,
        scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationScale, typing.Dict[builtins.str, typing.Any]]]]] = None,
        shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationShear, typing.Dict[builtins.str, typing.Any]]]]] = None,
        trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationTrim, typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param append: append block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        :param aspect_crop: aspect_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param crop: crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        :param face_crop: face_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        :param feature_crop: feature_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        :param fit_and_fill: fit_and_fill block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param im_query: im_query block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param region_of_interest_crop: region_of_interest_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        :param relative_crop: relative_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param resize: resize block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        :param rotate: rotate block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        :param scale: scale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param shear: shear block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        :param trim: trim block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformation(
            append=append,
            aspect_crop=aspect_crop,
            background_color=background_color,
            blur=blur,
            chroma_key=chroma_key,
            composite=composite,
            compound=compound,
            contrast=contrast,
            crop=crop,
            face_crop=face_crop,
            feature_crop=feature_crop,
            fit_and_fill=fit_and_fill,
            goop=goop,
            grayscale=grayscale,
            hsl=hsl,
            hsv=hsv,
            if_dimension=if_dimension,
            if_orientation=if_orientation,
            im_query=im_query,
            max_colors=max_colors,
            mirror=mirror,
            mono_hue=mono_hue,
            opacity=opacity,
            region_of_interest_crop=region_of_interest_crop,
            relative_crop=relative_crop,
            remove_color=remove_color,
            resize=resize,
            rotate=rotate,
            scale=scale,
            shear=shear,
            trim=trim,
            unsharp_mask=unsharp_mask,
        )

        return typing.cast(None, jsii.invoke(self, "putFillTransformation", [value]))

    @jsii.member(jsii_name="resetFillTransformation")
    def reset_fill_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFillTransformation", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="fillTransformation")
    def fill_transformation(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationOutputReference, jsii.get(self, "fillTransformation"))

    @builtins.property
    @jsii.member(jsii_name="fillTransformationInput")
    def fill_transformation_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformation], jsii.get(self, "fillTransformationInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f49f8d25d9aaf67e9f8ac4562ed77a04260c76b23d2c52ac4e00f0dfcf19f186)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8cfb2d2752bff87ea187c2b203089dc85d5d470221a05028521ffb01db5b3a24)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__975cadb012b037f3abab01406f9d3a4967054c31e2313ad1fa2445c38291d708)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a1065fb8d54a4afc039f616577ceebb0e6478e8d7b2788c833de95f04e8e69ae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFill]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFill]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFill]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f417aeb31bf33c90801fa3dc84c4bcde6a5d1ac24213db7ead96a8f2db72675e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeGoop",
    jsii_struct_bases=[],
    name_mapping={
        "chaos": "chaos",
        "chaos_var": "chaosVar",
        "density": "density",
        "density_var": "densityVar",
        "power": "power",
        "power_var": "powerVar",
        "seed": "seed",
        "seed_var": "seedVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeGoop:
    def __init__(
        self,
        *,
        chaos: typing.Optional[builtins.str] = None,
        chaos_var: typing.Optional[builtins.str] = None,
        density: typing.Optional[builtins.str] = None,
        density_var: typing.Optional[builtins.str] = None,
        power: typing.Optional[builtins.str] = None,
        power_var: typing.Optional[builtins.str] = None,
        seed: typing.Optional[builtins.str] = None,
        seed_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param chaos: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        :param chaos_var: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        :param density: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        :param density_var: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        :param power: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        :param power_var: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        :param seed: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        :param seed_var: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__361e124e3af5cb3316a44a3aca0ae03e389ab409b53470038e675cfd9b755156)
            check_type(argname="argument chaos", value=chaos, expected_type=type_hints["chaos"])
            check_type(argname="argument chaos_var", value=chaos_var, expected_type=type_hints["chaos_var"])
            check_type(argname="argument density", value=density, expected_type=type_hints["density"])
            check_type(argname="argument density_var", value=density_var, expected_type=type_hints["density_var"])
            check_type(argname="argument power", value=power, expected_type=type_hints["power"])
            check_type(argname="argument power_var", value=power_var, expected_type=type_hints["power_var"])
            check_type(argname="argument seed", value=seed, expected_type=type_hints["seed"])
            check_type(argname="argument seed_var", value=seed_var, expected_type=type_hints["seed_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if chaos is not None:
            self._values["chaos"] = chaos
        if chaos_var is not None:
            self._values["chaos_var"] = chaos_var
        if density is not None:
            self._values["density"] = density
        if density_var is not None:
            self._values["density_var"] = density_var
        if power is not None:
            self._values["power"] = power
        if power_var is not None:
            self._values["power_var"] = power_var
        if seed is not None:
            self._values["seed"] = seed
        if seed_var is not None:
            self._values["seed_var"] = seed_var

    @builtins.property
    def chaos(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        '''
        result = self._values.get("chaos")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def chaos_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        '''
        result = self._values.get("chaos_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        '''
        result = self._values.get("density")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density_var(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        '''
        result = self._values.get("density_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        '''
        result = self._values.get("power")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power_var(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        '''
        result = self._values.get("power_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        '''
        result = self._values.get("seed")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed_var(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        result = self._values.get("seed_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeGoop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeGoopList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeGoopList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9876809fba4858a359a260de86d8ab8d499cbec64f5f83a455e7c1066f83e80f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeGoopOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__71774ed15bd27dbfc5d2920b3c23b99248d35efc7fa5c70715103eba8aa90008)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeGoopOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4338b49e25c9617c958b5a80b7bc5897cfa9bbf086e12948972331d941b13356)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c8267b34ee2427606691fec26c19a0536d243e9b332956c06d3f29969f195097)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__66fb5b8a05460229d90ea6a0076ebfb646f452003f6c040d4e3a2145a61bc283)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeGoop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeGoop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7ba3329e9ca29d258258f0ba87c43f3e5e45f55dc769b2f66e5546e67da4e7ca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeGoopOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeGoopOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__438558568cc6cad3c93d05f291b3be3c29dc7c553b93ee2739ab3f866c79a9bd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetChaos")
    def reset_chaos(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaos", []))

    @jsii.member(jsii_name="resetChaosVar")
    def reset_chaos_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaosVar", []))

    @jsii.member(jsii_name="resetDensity")
    def reset_density(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensity", []))

    @jsii.member(jsii_name="resetDensityVar")
    def reset_density_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensityVar", []))

    @jsii.member(jsii_name="resetPower")
    def reset_power(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPower", []))

    @jsii.member(jsii_name="resetPowerVar")
    def reset_power_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPowerVar", []))

    @jsii.member(jsii_name="resetSeed")
    def reset_seed(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeed", []))

    @jsii.member(jsii_name="resetSeedVar")
    def reset_seed_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeedVar", []))

    @builtins.property
    @jsii.member(jsii_name="chaosInput")
    def chaos_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosInput"))

    @builtins.property
    @jsii.member(jsii_name="chaosVarInput")
    def chaos_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosVarInput"))

    @builtins.property
    @jsii.member(jsii_name="densityInput")
    def density_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityInput"))

    @builtins.property
    @jsii.member(jsii_name="densityVarInput")
    def density_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="powerInput")
    def power_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerInput"))

    @builtins.property
    @jsii.member(jsii_name="powerVarInput")
    def power_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerVarInput"))

    @builtins.property
    @jsii.member(jsii_name="seedInput")
    def seed_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedInput"))

    @builtins.property
    @jsii.member(jsii_name="seedVarInput")
    def seed_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedVarInput"))

    @builtins.property
    @jsii.member(jsii_name="chaos")
    def chaos(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaos"))

    @chaos.setter
    def chaos(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b29c1c16fb9a098cf913a076a0db6bf4fd9e52dcdd0d41a856a0540c88927568)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaos", value)

    @builtins.property
    @jsii.member(jsii_name="chaosVar")
    def chaos_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaosVar"))

    @chaos_var.setter
    def chaos_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__90eb3e66559df6f20da068c21228aebc3f0d3d4e7eb836d91cbfa1d440e9f938)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaosVar", value)

    @builtins.property
    @jsii.member(jsii_name="density")
    def density(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "density"))

    @density.setter
    def density(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e16179ffe6f8eecc540bdd7e677266ea5973df577917b9bed3fbc030641e74f2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "density", value)

    @builtins.property
    @jsii.member(jsii_name="densityVar")
    def density_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "densityVar"))

    @density_var.setter
    def density_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bceddf6f891da482ee883d230f2326b5cefc203310b2c76ddc429ebf4dce770a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "densityVar", value)

    @builtins.property
    @jsii.member(jsii_name="power")
    def power(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "power"))

    @power.setter
    def power(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__16d83931d546c872fa199c26d21fa200a2606cac68cf9f55e97bbf79557989a1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "power", value)

    @builtins.property
    @jsii.member(jsii_name="powerVar")
    def power_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "powerVar"))

    @power_var.setter
    def power_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__47001fa6a3b24187f35734d94f3a37049eab2e7934bf79926a0a2e7b65c4c7e4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "powerVar", value)

    @builtins.property
    @jsii.member(jsii_name="seed")
    def seed(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seed"))

    @seed.setter
    def seed(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a53cee59200e0eadc0d7547d6d80f92bf7ef1950cbb924426b5d056619577c73)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seed", value)

    @builtins.property
    @jsii.member(jsii_name="seedVar")
    def seed_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seedVar"))

    @seed_var.setter
    def seed_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__217335da1fa53dbe1babb16d3a21559fd15956462c5cd88cd0bc3735db9b0d4a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seedVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeGoop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeGoop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeGoop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__04f4fb6d51c410d357a61dcea122f8c361e91707ffb42ddf8387b1d8835669c1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeGrayscale",
    jsii_struct_bases=[],
    name_mapping={"type": "type", "type_var": "typeVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeGrayscale:
    def __init__(
        self,
        *,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param type: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__393e29f04c49c230689a365b6721b8ada846119b54b8189996a9511ee58c56eb)
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeGrayscale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeGrayscaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeGrayscaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3b69bc79be9e650a04ca4024424de7a2ab038d90d0139d5f50daaa27dcd37f29)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeGrayscaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__834ffe69b49998fb3fc32636ecb7bd4209fc366f3860a744eafd0efba90c82d9)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeGrayscaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__53c60145641ca9b5fb15f8fcbaa32422d61cd8891f92cdd961c7181d5f3e0063)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__27fe660e141c553df1fdc7146eaa95876521852008a1ed3d0d4948d8c6e0cdbb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__95d488dbf92e8cefd57bc92322ed5abe3e6ad2d54c66cd559472c2c73b3e1d97)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeGrayscale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeGrayscale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6b1902298ca5183b02112f385cc79babb39e415e6379ef1b65c238322b078d1f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeGrayscaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeGrayscaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c112fcabd5b9922b08a3e21e65d9a1d60479a4ec2eae294ccdbfa6a0993fd561)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0bfda121bd962e32a7986a3e748a4f22b524b9d6afc6d313d31a5074a59e9a65)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4081592f4c919c10dfd6f7b9c0fd08eec2d6cbe0f2ca558a7bc222335801322e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeGrayscale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeGrayscale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeGrayscale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a042833393438bfa78e44a43f705a09789a7058f1c5ddb456077e1469d3ffbc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeHsl",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "lightness": "lightness",
        "lightness_var": "lightnessVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeHsl:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness: typing.Optional[builtins.str] = None,
        lightness_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        :param lightness_var: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a71325f6601991847482119ae2a960f674e9534d93f8db6337a55fa0cecc032f)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness", value=lightness, expected_type=type_hints["lightness"])
            check_type(argname="argument lightness_var", value=lightness_var, expected_type=type_hints["lightness_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness is not None:
            self._values["lightness"] = lightness
        if lightness_var is not None:
            self._values["lightness_var"] = lightness_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        '''
        result = self._values.get("lightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        '''
        result = self._values.get("lightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeHsl(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeHslList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeHslList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__12ea983b3e5a293bfc31511ee0dc169270fd8988fd7c9b0773627fcaf7422c7d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeHslOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__339483f59b72564dedae20c7a4896494ee055c3f59e09c35102b6ebfeaca126a)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeHslOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__52232c055b19beda46569ca27809c28045107c5440759ca5fd0c0b39eba087e2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fd937d1d78230c232b2f9bd8ac90f4bf3167db8db3756739b46ec2ec9a9432e4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__376aee33799d576b596dffc672d68184ef96068c9bda726a080585e23c045219)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeHsl]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeHsl]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e998cc7e39c564017edda1ce337c836fb845cc9c99cfab22554b8378ef5c9dab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeHslOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeHslOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5afd51f31e49ac901b64f542d213fa858ac17fdf57ab23a51abb790a0a3d6c87)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightness")
    def reset_lightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightness", []))

    @jsii.member(jsii_name="resetLightnessVar")
    def reset_lightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessInput")
    def lightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessVarInput")
    def lightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c932cd14b01d2a71dc6910434fa92c969cb39bcce94143c1f498c8f8f2d4576e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4411e09d799ee71236464ee80ff394ffa41a5ac9c9fff75ce5a96c63917fba81)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightness")
    def lightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightness"))

    @lightness.setter
    def lightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a5c54a79a0eb7ea2fdff10e7521feca52fcc67eec6600bbeb79e21563e50dff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightness", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessVar")
    def lightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessVar"))

    @lightness_var.setter
    def lightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1775b5c21267cbaca887cb955572b23b73812ba82549e6c770550d54e4b5fd5d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__94a2d0973c095da481267359d76914f7b863f0fd4035fb69202433e65117a0d2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d2b665acb8801a64ef7bc2af93aec5a0c3bd598f048b4d548741b380bda7d06)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeHsl]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeHsl]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeHsl]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__95b89fa36563f969f252e95d70f726dab34beda9fb783afb9b5147154a3dc95f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeHsv",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeHsv:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        :param value: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f9bdee8161a670e5aa39b24753f21b241f3f6648374723702bba89129b5aae67)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeHsv(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeHsvList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeHsvList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0581fb07c8783ef89175b94b7724c819b409e48ead5b2342db4b78cec658419b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeHsvOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7a741198baf64c977a3edccc23bdedbf3e1edc1724f886fd0b82efb95b108922)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeHsvOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__db5c048e76d6cc40363c9dbf725c0ee4e76d72c4b8defe377ed9e43c7c23573b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac782774bdfa91ff8d87b00ec22525999643a7dc8176cb39ba8c2fa40d9722c5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac413d51d4b7512cb588d2761bdb472c8689169de3013b1993b4c370cc0c86d2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeHsv]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeHsv]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e4c1ddcb28954a75708c1ca27e59ea081f787e83d4b5da73624a1e568f2c5ee3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeHsvOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeHsvOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4e30f56510d689a94226c11899ad7c0cd2e3632d5d393f6ba6569fa43722e30b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dc4311d9f5bc5985ce5a2fecee9d58e0b26eba070146301957d23c31102d6ab9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0401167bc0ae0e3fc1e5aadc347373549f72b4c0ec9c51642779908debde28a2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7afee1b9a3dc46384cf93f7517001a71f96651a80823715c78e1fe91fba2b2da)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e9f83df03b828bd7c5d17891b0e5962d87f53143c4f7fde67cd46f406b395e5a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d310f3bde69149baeebc2d8342a6d2c95f6e38c4361735087d7919ec377fc1ba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1066227f02693c0a21725ba2106d60b9bd94b732276501197dbfcf4e99f16956)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeHsv]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeHsv]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeHsv]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fd324ba7cdeb29f254a3ba2abd98c60e0ca3fe8be5c6d248b0f807c47f241043)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimension",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "dimension": "dimension",
        "dimension_var": "dimensionVar",
        "equal": "equal",
        "greater_than": "greaterThan",
        "less_than": "lessThan",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimension:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        dimension: typing.Optional[builtins.str] = None,
        dimension_var: typing.Optional[builtins.str] = None,
        equal: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqual", typing.Dict[builtins.str, typing.Any]]] = None,
        greater_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThan", typing.Dict[builtins.str, typing.Any]]] = None,
        less_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThan", typing.Dict[builtins.str, typing.Any]]] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param dimension: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        :param dimension_var: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        :param equal: equal block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        :param greater_than: greater_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        :param less_than: less_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        :param value: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefault(**default)
        if isinstance(equal, dict):
            equal = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqual(**equal)
        if isinstance(greater_than, dict):
            greater_than = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThan(**greater_than)
        if isinstance(less_than, dict):
            less_than = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThan(**less_than)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__760da82b64ed2f9dc1d8b827f3e469c45d42eed9115468f6c5b2a43b1ce7f967)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument dimension", value=dimension, expected_type=type_hints["dimension"])
            check_type(argname="argument dimension_var", value=dimension_var, expected_type=type_hints["dimension_var"])
            check_type(argname="argument equal", value=equal, expected_type=type_hints["equal"])
            check_type(argname="argument greater_than", value=greater_than, expected_type=type_hints["greater_than"])
            check_type(argname="argument less_than", value=less_than, expected_type=type_hints["less_than"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if dimension is not None:
            self._values["dimension"] = dimension
        if dimension_var is not None:
            self._values["dimension_var"] = dimension_var
        if equal is not None:
            self._values["equal"] = equal
        if greater_than is not None:
            self._values["greater_than"] = greater_than
        if less_than is not None:
            self._values["less_than"] = less_than
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefault"], result)

    @builtins.property
    def dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        '''
        result = self._values.get("dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        '''
        result = self._values.get("dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def equal(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqual"]:
        '''equal block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        '''
        result = self._values.get("equal")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqual"], result)

    @builtins.property
    def greater_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThan"]:
        '''greater_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        '''
        result = self._values.get("greater_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThan"], result)

    @builtins.property
    def less_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThan"]:
        '''less_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        '''
        result = self._values.get("less_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThan"], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimension(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefault",
    jsii_struct_bases=[],
    name_mapping={
        "append": "append",
        "aspect_crop": "aspectCrop",
        "background_color": "backgroundColor",
        "blur": "blur",
        "chroma_key": "chromaKey",
        "composite": "composite",
        "compound": "compound",
        "contrast": "contrast",
        "crop": "crop",
        "face_crop": "faceCrop",
        "feature_crop": "featureCrop",
        "fit_and_fill": "fitAndFill",
        "goop": "goop",
        "grayscale": "grayscale",
        "hsl": "hsl",
        "hsv": "hsv",
        "if_dimension": "ifDimension",
        "if_orientation": "ifOrientation",
        "im_query": "imQuery",
        "max_colors": "maxColors",
        "mirror": "mirror",
        "mono_hue": "monoHue",
        "opacity": "opacity",
        "region_of_interest_crop": "regionOfInterestCrop",
        "relative_crop": "relativeCrop",
        "remove_color": "removeColor",
        "resize": "resize",
        "rotate": "rotate",
        "scale": "scale",
        "shear": "shear",
        "trim": "trim",
        "unsharp_mask": "unsharpMask",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefault:
    def __init__(
        self,
        *,
        append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultAppend", typing.Dict[builtins.str, typing.Any]]]]] = None,
        aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultAspectCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultBackgroundColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultBlur", typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultChromaKey", typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultComposite", typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCompound", typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultContrast", typing.Dict[builtins.str, typing.Any]]]]] = None,
        crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultFaceCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultFeatureCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultFitAndFill", typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultGoop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultGrayscale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultHsl", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultHsv", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimension", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientation", typing.Dict[builtins.str, typing.Any]]]]] = None,
        im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultImQuery", typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultMaxColors", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultMirror", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultMonoHue", typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultOpacity", typing.Dict[builtins.str, typing.Any]]]]] = None,
        region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRegionOfInterestCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRelativeCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRemoveColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultResize", typing.Dict[builtins.str, typing.Any]]]]] = None,
        rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRotate", typing.Dict[builtins.str, typing.Any]]]]] = None,
        scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultScale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultShear", typing.Dict[builtins.str, typing.Any]]]]] = None,
        trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultTrim", typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultUnsharpMask", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param append: append block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        :param aspect_crop: aspect_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param crop: crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        :param face_crop: face_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        :param feature_crop: feature_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        :param fit_and_fill: fit_and_fill block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param im_query: im_query block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param region_of_interest_crop: region_of_interest_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        :param relative_crop: relative_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param resize: resize block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        :param rotate: rotate block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        :param scale: scale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param shear: shear block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        :param trim: trim block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0da5edb8cda18b7cc6a9e4ea2bf0f55375688ddd572c8effec15ae0e86ec7faa)
            check_type(argname="argument append", value=append, expected_type=type_hints["append"])
            check_type(argname="argument aspect_crop", value=aspect_crop, expected_type=type_hints["aspect_crop"])
            check_type(argname="argument background_color", value=background_color, expected_type=type_hints["background_color"])
            check_type(argname="argument blur", value=blur, expected_type=type_hints["blur"])
            check_type(argname="argument chroma_key", value=chroma_key, expected_type=type_hints["chroma_key"])
            check_type(argname="argument composite", value=composite, expected_type=type_hints["composite"])
            check_type(argname="argument compound", value=compound, expected_type=type_hints["compound"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument crop", value=crop, expected_type=type_hints["crop"])
            check_type(argname="argument face_crop", value=face_crop, expected_type=type_hints["face_crop"])
            check_type(argname="argument feature_crop", value=feature_crop, expected_type=type_hints["feature_crop"])
            check_type(argname="argument fit_and_fill", value=fit_and_fill, expected_type=type_hints["fit_and_fill"])
            check_type(argname="argument goop", value=goop, expected_type=type_hints["goop"])
            check_type(argname="argument grayscale", value=grayscale, expected_type=type_hints["grayscale"])
            check_type(argname="argument hsl", value=hsl, expected_type=type_hints["hsl"])
            check_type(argname="argument hsv", value=hsv, expected_type=type_hints["hsv"])
            check_type(argname="argument if_dimension", value=if_dimension, expected_type=type_hints["if_dimension"])
            check_type(argname="argument if_orientation", value=if_orientation, expected_type=type_hints["if_orientation"])
            check_type(argname="argument im_query", value=im_query, expected_type=type_hints["im_query"])
            check_type(argname="argument max_colors", value=max_colors, expected_type=type_hints["max_colors"])
            check_type(argname="argument mirror", value=mirror, expected_type=type_hints["mirror"])
            check_type(argname="argument mono_hue", value=mono_hue, expected_type=type_hints["mono_hue"])
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument region_of_interest_crop", value=region_of_interest_crop, expected_type=type_hints["region_of_interest_crop"])
            check_type(argname="argument relative_crop", value=relative_crop, expected_type=type_hints["relative_crop"])
            check_type(argname="argument remove_color", value=remove_color, expected_type=type_hints["remove_color"])
            check_type(argname="argument resize", value=resize, expected_type=type_hints["resize"])
            check_type(argname="argument rotate", value=rotate, expected_type=type_hints["rotate"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument shear", value=shear, expected_type=type_hints["shear"])
            check_type(argname="argument trim", value=trim, expected_type=type_hints["trim"])
            check_type(argname="argument unsharp_mask", value=unsharp_mask, expected_type=type_hints["unsharp_mask"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if append is not None:
            self._values["append"] = append
        if aspect_crop is not None:
            self._values["aspect_crop"] = aspect_crop
        if background_color is not None:
            self._values["background_color"] = background_color
        if blur is not None:
            self._values["blur"] = blur
        if chroma_key is not None:
            self._values["chroma_key"] = chroma_key
        if composite is not None:
            self._values["composite"] = composite
        if compound is not None:
            self._values["compound"] = compound
        if contrast is not None:
            self._values["contrast"] = contrast
        if crop is not None:
            self._values["crop"] = crop
        if face_crop is not None:
            self._values["face_crop"] = face_crop
        if feature_crop is not None:
            self._values["feature_crop"] = feature_crop
        if fit_and_fill is not None:
            self._values["fit_and_fill"] = fit_and_fill
        if goop is not None:
            self._values["goop"] = goop
        if grayscale is not None:
            self._values["grayscale"] = grayscale
        if hsl is not None:
            self._values["hsl"] = hsl
        if hsv is not None:
            self._values["hsv"] = hsv
        if if_dimension is not None:
            self._values["if_dimension"] = if_dimension
        if if_orientation is not None:
            self._values["if_orientation"] = if_orientation
        if im_query is not None:
            self._values["im_query"] = im_query
        if max_colors is not None:
            self._values["max_colors"] = max_colors
        if mirror is not None:
            self._values["mirror"] = mirror
        if mono_hue is not None:
            self._values["mono_hue"] = mono_hue
        if opacity is not None:
            self._values["opacity"] = opacity
        if region_of_interest_crop is not None:
            self._values["region_of_interest_crop"] = region_of_interest_crop
        if relative_crop is not None:
            self._values["relative_crop"] = relative_crop
        if remove_color is not None:
            self._values["remove_color"] = remove_color
        if resize is not None:
            self._values["resize"] = resize
        if rotate is not None:
            self._values["rotate"] = rotate
        if scale is not None:
            self._values["scale"] = scale
        if shear is not None:
            self._values["shear"] = shear
        if trim is not None:
            self._values["trim"] = trim
        if unsharp_mask is not None:
            self._values["unsharp_mask"] = unsharp_mask

    @builtins.property
    def append(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultAppend"]]]:
        '''append block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        '''
        result = self._values.get("append")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultAppend"]]], result)

    @builtins.property
    def aspect_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultAspectCrop"]]]:
        '''aspect_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        '''
        result = self._values.get("aspect_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultAspectCrop"]]], result)

    @builtins.property
    def background_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultBackgroundColor"]]]:
        '''background_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        '''
        result = self._values.get("background_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultBackgroundColor"]]], result)

    @builtins.property
    def blur(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultBlur"]]]:
        '''blur block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        '''
        result = self._values.get("blur")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultBlur"]]], result)

    @builtins.property
    def chroma_key(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultChromaKey"]]]:
        '''chroma_key block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        '''
        result = self._values.get("chroma_key")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultChromaKey"]]], result)

    @builtins.property
    def composite(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultComposite"]]]:
        '''composite block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        '''
        result = self._values.get("composite")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultComposite"]]], result)

    @builtins.property
    def compound(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCompound"]]]:
        '''compound block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        '''
        result = self._values.get("compound")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCompound"]]], result)

    @builtins.property
    def contrast(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultContrast"]]]:
        '''contrast block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultContrast"]]], result)

    @builtins.property
    def crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCrop"]]]:
        '''crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        '''
        result = self._values.get("crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCrop"]]], result)

    @builtins.property
    def face_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultFaceCrop"]]]:
        '''face_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        '''
        result = self._values.get("face_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultFaceCrop"]]], result)

    @builtins.property
    def feature_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultFeatureCrop"]]]:
        '''feature_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        '''
        result = self._values.get("feature_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultFeatureCrop"]]], result)

    @builtins.property
    def fit_and_fill(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultFitAndFill"]]]:
        '''fit_and_fill block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        '''
        result = self._values.get("fit_and_fill")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultFitAndFill"]]], result)

    @builtins.property
    def goop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultGoop"]]]:
        '''goop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        '''
        result = self._values.get("goop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultGoop"]]], result)

    @builtins.property
    def grayscale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultGrayscale"]]]:
        '''grayscale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        '''
        result = self._values.get("grayscale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultGrayscale"]]], result)

    @builtins.property
    def hsl(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultHsl"]]]:
        '''hsl block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        '''
        result = self._values.get("hsl")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultHsl"]]], result)

    @builtins.property
    def hsv(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultHsv"]]]:
        '''hsv block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        '''
        result = self._values.get("hsv")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultHsv"]]], result)

    @builtins.property
    def if_dimension(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimension"]]]:
        '''if_dimension block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        '''
        result = self._values.get("if_dimension")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimension"]]], result)

    @builtins.property
    def if_orientation(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientation"]]]:
        '''if_orientation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        '''
        result = self._values.get("if_orientation")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientation"]]], result)

    @builtins.property
    def im_query(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultImQuery"]]]:
        '''im_query block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        '''
        result = self._values.get("im_query")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultImQuery"]]], result)

    @builtins.property
    def max_colors(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultMaxColors"]]]:
        '''max_colors block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        '''
        result = self._values.get("max_colors")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultMaxColors"]]], result)

    @builtins.property
    def mirror(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultMirror"]]]:
        '''mirror block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        '''
        result = self._values.get("mirror")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultMirror"]]], result)

    @builtins.property
    def mono_hue(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultMonoHue"]]]:
        '''mono_hue block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        '''
        result = self._values.get("mono_hue")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultMonoHue"]]], result)

    @builtins.property
    def opacity(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultOpacity"]]]:
        '''opacity block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultOpacity"]]], result)

    @builtins.property
    def region_of_interest_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRegionOfInterestCrop"]]]:
        '''region_of_interest_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        '''
        result = self._values.get("region_of_interest_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRegionOfInterestCrop"]]], result)

    @builtins.property
    def relative_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRelativeCrop"]]]:
        '''relative_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        '''
        result = self._values.get("relative_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRelativeCrop"]]], result)

    @builtins.property
    def remove_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRemoveColor"]]]:
        '''remove_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        '''
        result = self._values.get("remove_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRemoveColor"]]], result)

    @builtins.property
    def resize(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultResize"]]]:
        '''resize block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        '''
        result = self._values.get("resize")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultResize"]]], result)

    @builtins.property
    def rotate(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRotate"]]]:
        '''rotate block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        '''
        result = self._values.get("rotate")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRotate"]]], result)

    @builtins.property
    def scale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultScale"]]]:
        '''scale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultScale"]]], result)

    @builtins.property
    def shear(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultShear"]]]:
        '''shear block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        '''
        result = self._values.get("shear")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultShear"]]], result)

    @builtins.property
    def trim(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultTrim"]]]:
        '''trim block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        '''
        result = self._values.get("trim")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultTrim"]]], result)

    @builtins.property
    def unsharp_mask(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultUnsharpMask"]]]:
        '''unsharp_mask block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        result = self._values.get("unsharp_mask")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultUnsharpMask"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultAppend",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_priority": "gravityPriority",
        "gravity_priority_var": "gravityPriorityVar",
        "gravity_var": "gravityVar",
        "preserve_minor_dimension": "preserveMinorDimension",
        "preserve_minor_dimension_var": "preserveMinorDimensionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultAppend:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultAppendImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_priority: typing.Optional[builtins.str] = None,
        gravity_priority_var: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        preserve_minor_dimension: typing.Optional[builtins.str] = None,
        preserve_minor_dimension_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Specifies where to place the ``image`` relative to the source image. The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_priority: Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal. The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority DataAkamaiImagingPolicyImage#gravity_priority}
        :param gravity_priority_var: Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal. The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority_var DataAkamaiImagingPolicyImage#gravity_priority_var}
        :param gravity_var: Specifies where to place the ``image`` relative to the source image. The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param preserve_minor_dimension: Whether to preserve the source image's minor dimension, ``false`` by default. The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension DataAkamaiImagingPolicyImage#preserve_minor_dimension}
        :param preserve_minor_dimension_var: Whether to preserve the source image's minor dimension, ``false`` by default. The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension_var DataAkamaiImagingPolicyImage#preserve_minor_dimension_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultAppendImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e24415166b45d16b02ad391715bed61d04d171b16c2931dda0e10659915b3583)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_priority", value=gravity_priority, expected_type=type_hints["gravity_priority"])
            check_type(argname="argument gravity_priority_var", value=gravity_priority_var, expected_type=type_hints["gravity_priority_var"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument preserve_minor_dimension", value=preserve_minor_dimension, expected_type=type_hints["preserve_minor_dimension"])
            check_type(argname="argument preserve_minor_dimension_var", value=preserve_minor_dimension_var, expected_type=type_hints["preserve_minor_dimension_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_priority is not None:
            self._values["gravity_priority"] = gravity_priority
        if gravity_priority_var is not None:
            self._values["gravity_priority_var"] = gravity_priority_var
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if preserve_minor_dimension is not None:
            self._values["preserve_minor_dimension"] = preserve_minor_dimension
        if preserve_minor_dimension_var is not None:
            self._values["preserve_minor_dimension_var"] = preserve_minor_dimension_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultAppendImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultAppendImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Specifies where to place the ``image`` relative to the source image.

        The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_priority(self) -> typing.Optional[builtins.str]:
        '''Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal.

        The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority DataAkamaiImagingPolicyImage#gravity_priority}
        '''
        result = self._values.get("gravity_priority")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_priority_var(self) -> typing.Optional[builtins.str]:
        '''Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal.

        The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority_var DataAkamaiImagingPolicyImage#gravity_priority_var}
        '''
        result = self._values.get("gravity_priority_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Specifies where to place the ``image`` relative to the source image.

        The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def preserve_minor_dimension(self) -> typing.Optional[builtins.str]:
        '''Whether to preserve the source image's minor dimension, ``false`` by default.

        The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension DataAkamaiImagingPolicyImage#preserve_minor_dimension}
        '''
        result = self._values.get("preserve_minor_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def preserve_minor_dimension_var(self) -> typing.Optional[builtins.str]:
        '''Whether to preserve the source image's minor dimension, ``false`` by default.

        The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension_var DataAkamaiImagingPolicyImage#preserve_minor_dimension_var}
        '''
        result = self._values.get("preserve_minor_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultAppend(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultAppendImage",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultAppendImage:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultAppendImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultAppendImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultAppendImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f9df30420666ccff3fbc8e7585bf6333afbe8ecafe51f205b8b12e74df13a57b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultAppendImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultAppendImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultAppendImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__422d540a0fb84fb38af2daf201f2d8fcc90df3fbb53b87f80bee007b6fa924f7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultAppendList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultAppendList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__18a153893876acbb29d1b198d7667c604a43efa0948f1e0139e0cf1bb81ec6df)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultAppendOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6ad5ad533c90319e700d6c5868218064dca219ccaa0f5c20953a29ee16605c0a)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultAppendOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__71494a60bbf84d6ffb04dd1249bf06471165c4697a4b3b8007490287119e9508)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3f69cc523b5d6725b2854495c3845ce1d389c99219bf0e4615934b0411036faf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0046637766713534b2ab2f3553c052ef6fb795e548ffb8ddaae631a505bc8eb4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultAppend]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultAppend]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultAppend]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f56b68ddae5d4a2cb6b81ffd3cdf2952aa6cc8b83d233bd3e8c0356c4a583186)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultAppendOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultAppendOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__248e623c4073321a7c0aac41124e53db2dc0b5bb12f49d8f659dedb8f2aad5a5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultAppendImage()

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityPriority")
    def reset_gravity_priority(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityPriority", []))

    @jsii.member(jsii_name="resetGravityPriorityVar")
    def reset_gravity_priority_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityPriorityVar", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPreserveMinorDimension")
    def reset_preserve_minor_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPreserveMinorDimension", []))

    @jsii.member(jsii_name="resetPreserveMinorDimensionVar")
    def reset_preserve_minor_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPreserveMinorDimensionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultAppendImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultAppendImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityInput")
    def gravity_priority_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityPriorityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityVarInput")
    def gravity_priority_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityPriorityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultAppendImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultAppendImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionInput")
    def preserve_minor_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "preserveMinorDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionVarInput")
    def preserve_minor_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "preserveMinorDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cbb7096a56797e18141fd828514005c9a6b38384efa425a6315acc795213f0dc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityPriority")
    def gravity_priority(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityPriority"))

    @gravity_priority.setter
    def gravity_priority(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0d4ac36f6b4e4a44bf9e4defff8340b93120776238a2c7594e985a5c54607b2b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityPriority", value)

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityVar")
    def gravity_priority_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityPriorityVar"))

    @gravity_priority_var.setter
    def gravity_priority_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0cf43d4a56abc3f30fc0c0cc1791437f6debdf79e08ede026257876393948375)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityPriorityVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9e23a181f430839d42ebb6e59859ca9395efe19e35b83cf4cb07281c84d38f1c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimension")
    def preserve_minor_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "preserveMinorDimension"))

    @preserve_minor_dimension.setter
    def preserve_minor_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__70442da4135fba536ff57f5bf4e7f417049da64deef88384f3e5c999e202535a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "preserveMinorDimension", value)

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionVar")
    def preserve_minor_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "preserveMinorDimensionVar"))

    @preserve_minor_dimension_var.setter
    def preserve_minor_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d440a0b9318c3e4c5104ed02d3bf4be2cde8a1b78b50e74c3f10d0d72aeae2f2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "preserveMinorDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultAppend]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultAppend]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultAppend]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af9bad56eb3991842ef5f898862b91eade980005c310030600a692fe5ec96fc0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultAspectCrop",
    jsii_struct_bases=[],
    name_mapping={
        "allow_expansion": "allowExpansion",
        "allow_expansion_var": "allowExpansionVar",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultAspectCrop:
    def __init__(
        self,
        *,
        allow_expansion: typing.Optional[builtins.str] = None,
        allow_expansion_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_expansion: Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image. Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        :param allow_expansion_var: Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image. Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        :param height: The height term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The width term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        :param x_position: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8d56b49eb4dcf6c2c40162250d7e43479800812454cfd9f1c766a7d42ee30522)
            check_type(argname="argument allow_expansion", value=allow_expansion, expected_type=type_hints["allow_expansion"])
            check_type(argname="argument allow_expansion_var", value=allow_expansion_var, expected_type=type_hints["allow_expansion_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if allow_expansion is not None:
            self._values["allow_expansion"] = allow_expansion
        if allow_expansion_var is not None:
            self._values["allow_expansion_var"] = allow_expansion_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def allow_expansion(self) -> typing.Optional[builtins.str]:
        '''Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image.

        Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        '''
        result = self._values.get("allow_expansion")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def allow_expansion_var(self) -> typing.Optional[builtins.str]:
        '''Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image.

        Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        '''
        result = self._values.get("allow_expansion_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultAspectCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultAspectCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultAspectCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__665c686279ced5a0d15f64eca26044a65d8fed1fcc3ede4084d4671164861b75)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultAspectCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b9ef4d997e09c326e8571e8e50388b44b53c046337623caf22a57be066e74f19)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultAspectCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cfbea17da6078f0a55a8d1577c108c71093135f1ff440a1d7940a6024a879087)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__08a23de240aabae2d27664aef59692c547fbb2398963cd31b5f850a2f7998fe1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__70f699a3f1a3f59ff7136df8313c398132cf73c0d9f4abd9774f9aedb8ae13dc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultAspectCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultAspectCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultAspectCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a5988594ae3b43f65dd28601cca28911de998d7f3db454c61c9c2f70a8455a4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultAspectCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultAspectCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6d091f647e2594aa18483c522f92b05e6ba5165d546ba53ff7c941b32d246f4f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAllowExpansion")
    def reset_allow_expansion(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansion", []))

    @jsii.member(jsii_name="resetAllowExpansionVar")
    def reset_allow_expansion_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansionVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionInput")
    def allow_expansion_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVarInput")
    def allow_expansion_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansion")
    def allow_expansion(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansion"))

    @allow_expansion.setter
    def allow_expansion(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab33b03d0018b51defcf7bc89f825a362d6852dd551538490908cfbec9e479a4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansion", value)

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVar")
    def allow_expansion_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansionVar"))

    @allow_expansion_var.setter
    def allow_expansion_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__39a7b509cc69752cb69e8e465dd167e488b13c5d509f6a7b827a8fac451a7216)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansionVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__730c87f098a08c6308c6007e3e0a7038572531f38bddd73f62e9c5077bf827bd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__66021133ca05ac3b3083c62427b7e17001f24aca7156f485b921bc34753c6e3a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8bb095bfb1306b30fdf73682552f34388b68846e1f0dff3aaa824873f5f1838d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d4bc3f06ad5624f715dbafa8e5e16b5c1c124038cf85553620b9917d69b80f67)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__23a10847fdf717a6719216cb1afaa24a342aada1256bde26fdde13cd594ef148)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3fa4b2c7a6184528f80b31bb1135f1dd9b08636028904220e13b1206e4b7dcca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b3548e44a7e58302c5b1b4d7e710b6b152b66ea899ce18c0570ecfc698ea6553)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e6478793fe391b38c516944946ad7b3d90dd7e9ee5fcb93d7c690c6dae0c704b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultAspectCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultAspectCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultAspectCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eb7bdd0c4bf52fca07999411a235d541fb064a8637385b9895c6635d5a9443f5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultBackgroundColor",
    jsii_struct_bases=[],
    name_mapping={"color": "color", "color_var": "colorVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultBackgroundColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d8d84384ed11edc3753a9bc626ab9baa31ff37a03e55653c73986c7c99500218)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultBackgroundColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultBackgroundColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultBackgroundColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc95c79981b383c1c537a571ec26addd347b2a9bd9145f32d3d0022ada3ee61a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultBackgroundColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d6cffecb3bdfa9d607b343899fe4b20116a3fe33e7e016c423811cc26e777ca)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultBackgroundColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b74839674074dfdc1935a44f0dd16db64eaae5eafaa34a9503587dab0592e6aa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d33c49c839b54733a1a75fae23f4269cf4cfebf3eb00343d78335d4891b572c3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8268666673fe79197d83bf729f08e0e3613435ba259e68671e31f3ec7d700e7a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultBackgroundColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultBackgroundColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7a69a193649b02c6e43999a82167c344e2173ab56d738a86f8babc000abaaf7c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultBackgroundColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultBackgroundColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c74c401205cb8f1b8b547c9116ad8164c351bd57e8ca72a7dff78e6c7c9ae743)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f5bdb73ab8e0fcc4c52637f107c0a060dd710493064539244950ecadc58c93ef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__76034c9b2547154b4ba035cfd3f7cd545033ba90e8bd61cf6d143ccf85f15424)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultBackgroundColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultBackgroundColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultBackgroundColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__91f603bc8d28c72536202214484e7fd3def96a63f6c746a8cf46603b1fa56727)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultBlur",
    jsii_struct_bases=[],
    name_mapping={"sigma": "sigma", "sigma_var": "sigmaVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultBlur:
    def __init__(
        self,
        *,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param sigma: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f71875715c314aa6cc26b8cb88230bdcf13c0ed882311352d92dc4397ae0287f)
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultBlur(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultBlurList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultBlurList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__10257335c3c04c1c929012f69d82400518186d14f928ec54ddfba1ad832820c0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultBlurOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ee1158124e8546d56ca428c405c57fee8c06888881292cd98b28657f4747220e)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultBlurOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2474d87a43cd5dbe7ed285feb8bda4973f4d5339dcd206b296678079b6eb4650)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc8793a71442cbc1bb0daf93fd9fba8660f4263032ad3ec9fd1c8890aab837f6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3d40b55b6c5a5232cb8fb24ceea8c2619e30499edc28508129df7df8597276d6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultBlur]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultBlur]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e177ced32ee8f69523cb1bcdd6331aab619d499dd13d7cfe14dd0e00f6cabde5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultBlurOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultBlurOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__28510704b45d3aa872c67413590c61c96d2ef093b66af40ba43e80a736525d6f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a4f97eaf5633a93d0568b3ca886235a7f8c9f9ad9fa03b69244af7062fd039fa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7f61a00886cad8ebbab52fd56ddaca9b96d11bf0e35d56619be2fc2de7f0ab2c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultBlur]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultBlur]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultBlur]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__50d89af12637a964eb79212af2c223df6261aeaf7030f50aa9b79dcfd3a7d216)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultChromaKey",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_feather": "hueFeather",
        "hue_feather_var": "hueFeatherVar",
        "hue_tolerance": "hueTolerance",
        "hue_tolerance_var": "hueToleranceVar",
        "hue_var": "hueVar",
        "lightness_feather": "lightnessFeather",
        "lightness_feather_var": "lightnessFeatherVar",
        "lightness_tolerance": "lightnessTolerance",
        "lightness_tolerance_var": "lightnessToleranceVar",
        "saturation_feather": "saturationFeather",
        "saturation_feather_var": "saturationFeatherVar",
        "saturation_tolerance": "saturationTolerance",
        "saturation_tolerance_var": "saturationToleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultChromaKey:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_feather: typing.Optional[builtins.str] = None,
        hue_feather_var: typing.Optional[builtins.str] = None,
        hue_tolerance: typing.Optional[builtins.str] = None,
        hue_tolerance_var: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness_feather: typing.Optional[builtins.str] = None,
        lightness_feather_var: typing.Optional[builtins.str] = None,
        lightness_tolerance: typing.Optional[builtins.str] = None,
        lightness_tolerance_var: typing.Optional[builtins.str] = None,
        saturation_feather: typing.Optional[builtins.str] = None,
        saturation_feather_var: typing.Optional[builtins.str] = None,
        saturation_tolerance: typing.Optional[builtins.str] = None,
        saturation_tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_feather: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        :param hue_feather_var: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        :param hue_tolerance: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        :param hue_tolerance_var: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        :param hue_var: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness_feather: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        :param lightness_feather_var: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        :param lightness_tolerance: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        :param lightness_tolerance_var: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        :param saturation_feather: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        :param saturation_feather_var: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        :param saturation_tolerance: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        :param saturation_tolerance_var: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__efa12900220c59ea3e0bfa79c6406ffe9bd82e030741e1f1fb0922db272ea003)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_feather", value=hue_feather, expected_type=type_hints["hue_feather"])
            check_type(argname="argument hue_feather_var", value=hue_feather_var, expected_type=type_hints["hue_feather_var"])
            check_type(argname="argument hue_tolerance", value=hue_tolerance, expected_type=type_hints["hue_tolerance"])
            check_type(argname="argument hue_tolerance_var", value=hue_tolerance_var, expected_type=type_hints["hue_tolerance_var"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness_feather", value=lightness_feather, expected_type=type_hints["lightness_feather"])
            check_type(argname="argument lightness_feather_var", value=lightness_feather_var, expected_type=type_hints["lightness_feather_var"])
            check_type(argname="argument lightness_tolerance", value=lightness_tolerance, expected_type=type_hints["lightness_tolerance"])
            check_type(argname="argument lightness_tolerance_var", value=lightness_tolerance_var, expected_type=type_hints["lightness_tolerance_var"])
            check_type(argname="argument saturation_feather", value=saturation_feather, expected_type=type_hints["saturation_feather"])
            check_type(argname="argument saturation_feather_var", value=saturation_feather_var, expected_type=type_hints["saturation_feather_var"])
            check_type(argname="argument saturation_tolerance", value=saturation_tolerance, expected_type=type_hints["saturation_tolerance"])
            check_type(argname="argument saturation_tolerance_var", value=saturation_tolerance_var, expected_type=type_hints["saturation_tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_feather is not None:
            self._values["hue_feather"] = hue_feather
        if hue_feather_var is not None:
            self._values["hue_feather_var"] = hue_feather_var
        if hue_tolerance is not None:
            self._values["hue_tolerance"] = hue_tolerance
        if hue_tolerance_var is not None:
            self._values["hue_tolerance_var"] = hue_tolerance_var
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness_feather is not None:
            self._values["lightness_feather"] = lightness_feather
        if lightness_feather_var is not None:
            self._values["lightness_feather_var"] = lightness_feather_var
        if lightness_tolerance is not None:
            self._values["lightness_tolerance"] = lightness_tolerance
        if lightness_tolerance_var is not None:
            self._values["lightness_tolerance_var"] = lightness_tolerance_var
        if saturation_feather is not None:
            self._values["saturation_feather"] = saturation_feather
        if saturation_feather_var is not None:
            self._values["saturation_feather_var"] = saturation_feather_var
        if saturation_tolerance is not None:
            self._values["saturation_tolerance"] = saturation_tolerance
        if saturation_tolerance_var is not None:
            self._values["saturation_tolerance_var"] = saturation_tolerance_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        '''
        result = self._values.get("hue_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        '''
        result = self._values.get("hue_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        '''
        result = self._values.get("hue_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        '''
        result = self._values.get("hue_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        '''
        result = self._values.get("lightness_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        '''
        result = self._values.get("lightness_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        '''
        result = self._values.get("lightness_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        '''
        result = self._values.get("lightness_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        '''
        result = self._values.get("saturation_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        '''
        result = self._values.get("saturation_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        '''
        result = self._values.get("saturation_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        result = self._values.get("saturation_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultChromaKey(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultChromaKeyList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultChromaKeyList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dc43b6ee1ecfef75785e5c7481ebe1594cc069cd5b14314b749c994440766612)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultChromaKeyOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a2f4d0b9b942b091da99993be663663a6f68c321fafafd664c3edc47c92a634)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultChromaKeyOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__505722e1aa131b66fd0de93c82176aafc03c1a657466a275d92430e94214183a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a1f4f96bec6f0a3c0aa65d6664d7f097d39255d098f23a2e6b505b9f3c1ac271)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a4b1be3e442ae590c89257c88292bd6df366d42f6cec138c63e63887bd6ee55)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultChromaKey]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultChromaKey]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0cbd81d238a9d4f05dbd4313f723e20716adcc4791f2dde1a5e70c6ac447220f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultChromaKeyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultChromaKeyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__373f8e7c91d001ea52d90cb588d4e727f4ad4e8025710785958a03c3aaf6f3b5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueFeather")
    def reset_hue_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeather", []))

    @jsii.member(jsii_name="resetHueFeatherVar")
    def reset_hue_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeatherVar", []))

    @jsii.member(jsii_name="resetHueTolerance")
    def reset_hue_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueTolerance", []))

    @jsii.member(jsii_name="resetHueToleranceVar")
    def reset_hue_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueToleranceVar", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightnessFeather")
    def reset_lightness_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeather", []))

    @jsii.member(jsii_name="resetLightnessFeatherVar")
    def reset_lightness_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeatherVar", []))

    @jsii.member(jsii_name="resetLightnessTolerance")
    def reset_lightness_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessTolerance", []))

    @jsii.member(jsii_name="resetLightnessToleranceVar")
    def reset_lightness_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessToleranceVar", []))

    @jsii.member(jsii_name="resetSaturationFeather")
    def reset_saturation_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeather", []))

    @jsii.member(jsii_name="resetSaturationFeatherVar")
    def reset_saturation_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeatherVar", []))

    @jsii.member(jsii_name="resetSaturationTolerance")
    def reset_saturation_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationTolerance", []))

    @jsii.member(jsii_name="resetSaturationToleranceVar")
    def reset_saturation_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherInput")
    def hue_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVarInput")
    def hue_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceInput")
    def hue_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVarInput")
    def hue_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherInput")
    def lightness_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVarInput")
    def lightness_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceInput")
    def lightness_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVarInput")
    def lightness_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherInput")
    def saturation_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVarInput")
    def saturation_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceInput")
    def saturation_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVarInput")
    def saturation_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7f98d3a543ca094a77127bc7ddf2743d06254e77790744eeb5dce775da6606a8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeather")
    def hue_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeather"))

    @hue_feather.setter
    def hue_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a7cb0c27a5fa14fd903792bd02fe26501a9acb15f3a5ed7e169831b7ce512ed2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeather", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVar")
    def hue_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeatherVar"))

    @hue_feather_var.setter
    def hue_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__20c63ef69e76469243d6f9a1070bb5f2ae81aaa6c1845a397242b806febd65d7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueTolerance")
    def hue_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueTolerance"))

    @hue_tolerance.setter
    def hue_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bcdeee5a4ee70cc5a28f7659e22490a2e87b2eb503fd0ba14472bbb507682c12)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVar")
    def hue_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueToleranceVar"))

    @hue_tolerance_var.setter
    def hue_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3e9e24a6d8abefe0e11bd00f19e2a981b699404b196f54f8dd5735a5409fdd93)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8e230e874740c7ca79f19a7e49bbfc7c3270fdde7fa7db1d0a059782fa25c015)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeather")
    def lightness_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeather"))

    @lightness_feather.setter
    def lightness_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a41d2e1467cefcf812cce2acec739ccbd8e8eafa76d8fef02fdfe8a5e4a53a3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeather", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVar")
    def lightness_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeatherVar"))

    @lightness_feather_var.setter
    def lightness_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__23f1da873e6f7d05f66bbd033a1a191d2f7bdca6b153317d9afa0e823afa0061)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessTolerance")
    def lightness_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessTolerance"))

    @lightness_tolerance.setter
    def lightness_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__abff7bd17074a0694c95739b0106533641542c94d0925d730a361da36ba40b72)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVar")
    def lightness_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessToleranceVar"))

    @lightness_tolerance_var.setter
    def lightness_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f3e09675849966ae3696426ba8deb49af9325db2f97bfd70dff49b23b702c931)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeather")
    def saturation_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeather"))

    @saturation_feather.setter
    def saturation_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4462cba455bbba4eb52adc1779397aedccb81e22649f126744f812b77714ceb9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeather", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVar")
    def saturation_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeatherVar"))

    @saturation_feather_var.setter
    def saturation_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d8aa4eda60d97754cca86d5820bf51a9bbc63670dbdaa4273c0655dfaaeda4b9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationTolerance")
    def saturation_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationTolerance"))

    @saturation_tolerance.setter
    def saturation_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a2295268262b95d185809586549e79a7b3214d0f09f484ba8b1487ccaf79831a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVar")
    def saturation_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationToleranceVar"))

    @saturation_tolerance_var.setter
    def saturation_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7e0295cdd5c25410c4f3528434bb735ad38de17eb7f1609d83b079ff4e25964c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultChromaKey]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultChromaKey]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultChromaKey]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b124b28f3e60c9c9440a57ffd42e2203056da0cc0f9c3593a0c113855062a9e9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultComposite",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "placement": "placement",
        "placement_var": "placementVar",
        "scale": "scale",
        "scale_dimension": "scaleDimension",
        "scale_dimension_var": "scaleDimensionVar",
        "scale_var": "scaleVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultComposite:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCompositeImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        placement: typing.Optional[builtins.str] = None,
        placement_var: typing.Optional[builtins.str] = None,
        scale: typing.Optional[builtins.str] = None,
        scale_dimension: typing.Optional[builtins.str] = None,
        scale_dimension_var: typing.Optional[builtins.str] = None,
        scale_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param placement: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        :param placement_var: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        :param scale: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param scale_dimension: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        :param scale_dimension_var: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        :param scale_var: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        :param x_position: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCompositeImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4e3dc8ef0d7b59e34ef701974ef8f62919ca113b9c7124384d6eb4133110e378)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument placement", value=placement, expected_type=type_hints["placement"])
            check_type(argname="argument placement_var", value=placement_var, expected_type=type_hints["placement_var"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument scale_dimension", value=scale_dimension, expected_type=type_hints["scale_dimension"])
            check_type(argname="argument scale_dimension_var", value=scale_dimension_var, expected_type=type_hints["scale_dimension_var"])
            check_type(argname="argument scale_var", value=scale_var, expected_type=type_hints["scale_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if placement is not None:
            self._values["placement"] = placement
        if placement_var is not None:
            self._values["placement_var"] = placement_var
        if scale is not None:
            self._values["scale"] = scale
        if scale_dimension is not None:
            self._values["scale_dimension"] = scale_dimension
        if scale_dimension_var is not None:
            self._values["scale_dimension_var"] = scale_dimension_var
        if scale_var is not None:
            self._values["scale_var"] = scale_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCompositeImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCompositeImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        '''
        result = self._values.get("placement")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement_var(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        '''
        result = self._values.get("placement_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        '''
        result = self._values.get("scale_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        '''
        result = self._values.get("scale_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        '''
        result = self._values.get("scale_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultComposite(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCompositeImage",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCompositeImage:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCompositeImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCompositeImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCompositeImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7f81e6b4c911fe57bc7c70b52ca95f35e8fdceaf03f7da6c1d8b7d4724a254a3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCompositeImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCompositeImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__946c9b9b51a25a9e95ff6affe226b18c1e9fd7decd30962490311f358824e698)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCompositeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCompositeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7796e6dd1977e6bd115aea74b17eac6369d45824608ca6355691e07f15c7764d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCompositeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4683d6da6594ec5b7e5e62d10e83c4bb26c4ab1126a1fdcef1dd657a7869aea9)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCompositeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e5c169e6bdb1936b8e10337eb54da05ebcd1b8055222375336bade79dbded067)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aede1ed5e555e1d5fc2e06b1fea40b6cd64ca4b01a3da1e8f118dca09eb661ac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5441334df47872068f26791e08e7b6fe7b775e0d453c77866e13a25ef9099496)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultComposite]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultComposite]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__946465b5bf075162779645cd29cf5c0913e89d70b1a8ebb7b3aa73856100396a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCompositeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCompositeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d6c860ae1fc9373fd4a3e9326b64910808b8843b96ee5b1cc637ddef65473f5a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCompositeImage()

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPlacement")
    def reset_placement(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacement", []))

    @jsii.member(jsii_name="resetPlacementVar")
    def reset_placement_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacementVar", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetScaleDimension")
    def reset_scale_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimension", []))

    @jsii.member(jsii_name="resetScaleDimensionVar")
    def reset_scale_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimensionVar", []))

    @jsii.member(jsii_name="resetScaleVar")
    def reset_scale_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCompositeImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCompositeImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCompositeImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="placementInput")
    def placement_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementInput"))

    @builtins.property
    @jsii.member(jsii_name="placementVarInput")
    def placement_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionInput")
    def scale_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVarInput")
    def scale_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleVarInput")
    def scale_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5c650c6a4db6a2caed06c8a1de46755340b358648ec8f3ab8a3a93772b403a7c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__066f5bccf8c23adba17f761457a506a81349bdd331617d8f9b74b7d8722141ce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="placement")
    def placement(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placement"))

    @placement.setter
    def placement(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f2566d6dc0499560a00cc5a8ee912c5399cf6a1ceabcbd9ba1e1c252b8751bc5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placement", value)

    @builtins.property
    @jsii.member(jsii_name="placementVar")
    def placement_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placementVar"))

    @placement_var.setter
    def placement_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__93596e4014c2b72e8d39b39e64024f5003756a4e11b4a5285e8fad0066e7b9d2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placementVar", value)

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scale"))

    @scale.setter
    def scale(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__935200e1bdc19838bbc8dae4fa4fa103c8e3079ec3503382802773313bd7af31)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scale", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimension")
    def scale_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimension"))

    @scale_dimension.setter
    def scale_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c017eea8ad845e68a9e61ef20913f4fc34df80cf48a50c2c5acbe5b104c7b97f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimension", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVar")
    def scale_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimensionVar"))

    @scale_dimension_var.setter
    def scale_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa89ffab67a6c3ad63af19f8c38fb48a307f0fd2d204e8f872f2db11c34a1fc5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="scaleVar")
    def scale_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleVar"))

    @scale_var.setter
    def scale_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bea3f171440ff854963fba57700050da9b8f973d73313c4a809705dd6e835462)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cfdf9b2f4ec122996ed07679973c8612d4948195fa42ca40b028b87c48166a74)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5e516c629efd4677850681ea6ddf4927576ed6eedaf34151206a82499e8b43e6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b9a229f9e95f96bff61bdaa70973b4ed0caddd5c51fd933429fbc270622072f2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__71d6c86d41b9ced249f11402dead6680cd520422ed42b640d3b1d398e5efcfac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultComposite]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultComposite]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultComposite]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__61cf0fb5726ea389b5ac4de10f45e93b3b1e84ef542596e6900713301376b20e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCompound",
    jsii_struct_bases=[],
    name_mapping={"transformations": "transformations"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCompound:
    def __init__(
        self,
        *,
        transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param transformations: transformations block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b61b079db3445a8327cdcf32f4f1311207f5bc3535fa44fad3193bc8e40a61ca)
            check_type(argname="argument transformations", value=transformations, expected_type=type_hints["transformations"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if transformations is not None:
            self._values["transformations"] = transformations

    @builtins.property
    def transformations(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCompoundTransformations"]]]:
        '''transformations block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        result = self._values.get("transformations")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCompoundTransformations"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCompound(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCompoundList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCompoundList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4478ed71d4f25571b68d0d0b55423715b9986b5a3a7f58233906a66b28b99f95)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCompoundOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d91b9ffb117d61f8370b7cee19018d2b07fe6a53da49226fe5160177b350090)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCompoundOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e065dde0b0f69ccdb1dbc93fe88b5dbd27876dccde3789215857f4cec9f7157d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__35613f16983734498fcf14ea2c250182a4581b171d77f05bdf3120be4b47c75b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5144641dd9a42879f6f69cdbe408bd4d535bf85d6ceebd37683744afdb72a960)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCompound]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCompound]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5066c447ca03390480345f221618f42c208cfdcf44e9e437842edf24720c4784)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCompoundOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCompoundOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b75d724ec5a2032eef35359826a3d1e9420c1f373acbf175f967a0527917ec69)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformations")
    def put_transformations(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a6505762686a53718863279427dcc32572bc27e88a46b01978223f2105c3b231)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTransformations", [value]))

    @jsii.member(jsii_name="resetTransformations")
    def reset_transformations(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformations", []))

    @builtins.property
    @jsii.member(jsii_name="transformations")
    def transformations(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCompoundTransformationsList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCompoundTransformationsList", jsii.get(self, "transformations"))

    @builtins.property
    @jsii.member(jsii_name="transformationsInput")
    def transformations_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCompoundTransformations"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCompoundTransformations"]]], jsii.get(self, "transformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCompound]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCompound]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCompound]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f2d10212e849c530ccb86ca61fed785c03b3177ecd0674a0d60bb037d9126e89)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCompoundTransformations",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCompoundTransformations:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCompoundTransformations(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCompoundTransformationsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCompoundTransformationsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3776eeff2cf80fe8895a0d0fb182ead34c8f86f5eb996e91e37d7802bb5d70c4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCompoundTransformationsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0716c14439dad2e549d4a26239d50c3a5c7cd6989784d04969f2dc0144ce7856)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCompoundTransformationsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__62b98346a074dbbc1aac361446fbe9594b71f0a1c0f65e61a958cffb6134f339)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__757b717f9327fd9dbab8bd98d8fa5f05c87f4d2ff9a8c131ed5005f4834c6102)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b271ab102222e755f4e5391b0408ec17a1191b91261bceccc272e8f26cb71782)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCompoundTransformations]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCompoundTransformations]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCompoundTransformations]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f5cc0616150a295f5c652843bed3c23fc00d94ad81dcee63cdb705a2a6e7702)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCompoundTransformationsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCompoundTransformationsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f2ef953fce1476db57c8eccdb654e42a16b7e5245a4e1f93fb32af2d40336084)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCompoundTransformations]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCompoundTransformations]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCompoundTransformations]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f7da7b17f0e5686dd7b89e4bb13be724d642d4e662038a20eacfdba9d871b61)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultContrast",
    jsii_struct_bases=[],
    name_mapping={
        "brightness": "brightness",
        "brightness_var": "brightnessVar",
        "contrast": "contrast",
        "contrast_var": "contrastVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultContrast:
    def __init__(
        self,
        *,
        brightness: typing.Optional[builtins.str] = None,
        brightness_var: typing.Optional[builtins.str] = None,
        contrast: typing.Optional[builtins.str] = None,
        contrast_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param brightness: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        :param brightness_var: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        :param contrast: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param contrast_var: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__20e9491b7bf74f78b990184babbeae5c6f105f9c20c99adc22653a894cbcbe4b)
            check_type(argname="argument brightness", value=brightness, expected_type=type_hints["brightness"])
            check_type(argname="argument brightness_var", value=brightness_var, expected_type=type_hints["brightness_var"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument contrast_var", value=contrast_var, expected_type=type_hints["contrast_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if brightness is not None:
            self._values["brightness"] = brightness
        if brightness_var is not None:
            self._values["brightness_var"] = brightness_var
        if contrast is not None:
            self._values["contrast"] = contrast
        if contrast_var is not None:
            self._values["contrast_var"] = contrast_var

    @builtins.property
    def brightness(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        '''
        result = self._values.get("brightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def brightness_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        '''
        result = self._values.get("brightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        result = self._values.get("contrast_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultContrast(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultContrastList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultContrastList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__46c70ef42fabe8aa010a63d7d30067c2394f7eb97faa39226209782ecf4806d0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultContrastOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1b485bd61e69460187a8063e7bbe141ea32b228c56b71d142829b3bc2236b604)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultContrastOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0fe288ba0723e0817a519443e804adc3f502517d38820098c35702b64ca36719)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fb5c67572dca82353b8163a2b66eedbd2bb885416f70ad07eb631bdedbeca6c6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fcdd3e8997e7575bfbe5bea19228fd8caa061029999204566258c44f17ea2bbb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultContrast]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultContrast]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__564ba9a59c3483c5593dd94aebdd120c6b87d9ff8d5dc8bcd09954a96ec5b9d6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultContrastOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultContrastOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fec093ac74f6358ce30caa3485f06ae336c715021a844d8e2799dec9743591b9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetBrightness")
    def reset_brightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightness", []))

    @jsii.member(jsii_name="resetBrightnessVar")
    def reset_brightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightnessVar", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetContrastVar")
    def reset_contrast_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrastVar", []))

    @builtins.property
    @jsii.member(jsii_name="brightnessInput")
    def brightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="brightnessVarInput")
    def brightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastVarInput")
    def contrast_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="brightness")
    def brightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightness"))

    @brightness.setter
    def brightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cb93858370585e92b7febf18ee0bda0920e2386f0a9a4225813b24e946ea4547)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightness", value)

    @builtins.property
    @jsii.member(jsii_name="brightnessVar")
    def brightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightnessVar"))

    @brightness_var.setter
    def brightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df5a1eb8f34f3936e1b50e93cada078fbc9a4b96777b2149813dcb91a83892cf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrast"))

    @contrast.setter
    def contrast(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c5712a8ea11c3e1802a27356eca83aa0bf36856c79ac0d83d3ebb361daf04ed9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrast", value)

    @builtins.property
    @jsii.member(jsii_name="contrastVar")
    def contrast_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrastVar"))

    @contrast_var.setter
    def contrast_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ec87728c0ea721d646f2b705c7268d0290b1db2a35dff212163eaa57f1162364)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrastVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultContrast]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultContrast]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultContrast]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0304b9d49a3478d9b5fd944019593932182f94e2165eb51f465b472614e4fa1a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCrop",
    jsii_struct_bases=[],
    name_mapping={
        "allow_expansion": "allowExpansion",
        "allow_expansion_var": "allowExpansionVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCrop:
    def __init__(
        self,
        *,
        allow_expansion: typing.Optional[builtins.str] = None,
        allow_expansion_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_expansion: If cropping an area outside of the existing canvas, expands the image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        :param allow_expansion_var: If cropping an area outside of the existing canvas, expands the image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        :param gravity: Frame of reference for X and Y Positions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Frame of reference for X and Y Positions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The number of pixels to crop along the y-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The number of pixels to crop along the y-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The number of pixels to crop along the x-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The number of pixels to crop along the x-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        :param x_position: The x-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ec912eb0c894330c1977108a0cf161674abed696ae884cc88f2296b05fe7946b)
            check_type(argname="argument allow_expansion", value=allow_expansion, expected_type=type_hints["allow_expansion"])
            check_type(argname="argument allow_expansion_var", value=allow_expansion_var, expected_type=type_hints["allow_expansion_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if allow_expansion is not None:
            self._values["allow_expansion"] = allow_expansion
        if allow_expansion_var is not None:
            self._values["allow_expansion_var"] = allow_expansion_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def allow_expansion(self) -> typing.Optional[builtins.str]:
        '''If cropping an area outside of the existing canvas, expands the image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        '''
        result = self._values.get("allow_expansion")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def allow_expansion_var(self) -> typing.Optional[builtins.str]:
        '''If cropping an area outside of the existing canvas, expands the image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        '''
        result = self._values.get("allow_expansion_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Frame of reference for X and Y Positions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Frame of reference for X and Y Positions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the y-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the y-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the x-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the x-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e1c077cee0d466cea2271eb08c94a7a945c9772f4b60024eb92306c6705c8b7a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c02438fae7ff5693a64afc24b762a2b12eefbb38c6a4826bd978eb2a13736c4f)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a551434b43f0699f3a83208aea2712eac2d2a9083d218062d2a8e57a1b7c15a9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__327c122609f184151d6747fd056b3445bee741f0e0caa9dfaa7933cb125223ee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f61d2a6505cf9be114315e8c27923b0ae1d003a809e861fdb13c917af4b72ad6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fafd001fc6b5038e9e88e2f18643f9788f60454c1a64ba3086013cc9c8bd50a5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f1122ac33460db648fd8151f679a87acb38226f7a20d8c81775c74eae6f5fcb)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAllowExpansion")
    def reset_allow_expansion(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansion", []))

    @jsii.member(jsii_name="resetAllowExpansionVar")
    def reset_allow_expansion_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansionVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionInput")
    def allow_expansion_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVarInput")
    def allow_expansion_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansion")
    def allow_expansion(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansion"))

    @allow_expansion.setter
    def allow_expansion(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d05c0b5cde69fbfe1beb249eac11d8f585588a1093b82ad416c03fffc517f909)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansion", value)

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVar")
    def allow_expansion_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansionVar"))

    @allow_expansion_var.setter
    def allow_expansion_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c2fc4fbfbaf95cb37a8e99d251bdc55867d767e3cc94e0702e59d7ea79acdf73)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansionVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1bafc96ff5a5241af481d22444ca5c57ed9478075ef95f2520004b677a2d882d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bca65562f2ba459e0c6e5ef6368d8c1a35b3186fd1199545ca08239e3392280e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ac24c746ba4b457f38e9d9d7f506cb2153a4ce99d4085e159800d5e0c250687)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b51c644fb6104071154abc3663db6ded9d91ce77e58c44b77fca00b39657ccd4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e74d75392ddc22ccf5644efcf472956d3e69ac4c789054020538958aa9ca07e2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__52112b24b2ce5bd1073eb506225b3ebf24ed66899447e2059b8c105c62d81059)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5022c095cc62d0aa435e5a4db2e8eb11b0819ddd292eff60b0f16913e37fa25e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__063149f18a83302d29e92d2e527356ac4fb25e5541b5bb1cd1a597ca2356fd0a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a5faa3d80890a7a7f351147b7314e17538be70e1ebcb6f0bd454386808d8cedb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1726cbe713b0bd411dbdd6bf8f33aa67951d457f4c4507e8d85fe1c136c0b11e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ece0d6229b1e3dba7658f836db751aa1192d44b5b1a20d026d6a6d04422179dd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultFaceCrop",
    jsii_struct_bases=[],
    name_mapping={
        "algorithm": "algorithm",
        "algorithm_var": "algorithmVar",
        "confidence": "confidence",
        "confidence_var": "confidenceVar",
        "fail_gravity": "failGravity",
        "fail_gravity_var": "failGravityVar",
        "focus": "focus",
        "focus_var": "focusVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "padding": "padding",
        "padding_var": "paddingVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultFaceCrop:
    def __init__(
        self,
        *,
        algorithm: typing.Optional[builtins.str] = None,
        algorithm_var: typing.Optional[builtins.str] = None,
        confidence: typing.Optional[builtins.str] = None,
        confidence_var: typing.Optional[builtins.str] = None,
        fail_gravity: typing.Optional[builtins.str] = None,
        fail_gravity_var: typing.Optional[builtins.str] = None,
        focus: typing.Optional[builtins.str] = None,
        focus_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param algorithm: Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm DataAkamaiImagingPolicyImage#algorithm}
        :param algorithm_var: Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm_var DataAkamaiImagingPolicyImage#algorithm_var}
        :param confidence: With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image. Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence DataAkamaiImagingPolicyImage#confidence}
        :param confidence_var: With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image. Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence_var DataAkamaiImagingPolicyImage#confidence_var}
        :param fail_gravity: Controls placement of the crop if Image and Video Manager does not detect any faces in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        :param fail_gravity_var: Controls placement of the crop if Image and Video Manager does not detect any faces in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        :param focus: Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus DataAkamaiImagingPolicyImage#focus}
        :param focus_var: Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus_var DataAkamaiImagingPolicyImage#focus_var}
        :param gravity: Controls placement of the crop. Directions are relative to the face(s) plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Controls placement of the crop. Directions are relative to the face(s) plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param padding: The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        :param style: Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__09e4c39c2bc80496e3525858a86151c4dc0052de278dd8b72bcca5b69accdf38)
            check_type(argname="argument algorithm", value=algorithm, expected_type=type_hints["algorithm"])
            check_type(argname="argument algorithm_var", value=algorithm_var, expected_type=type_hints["algorithm_var"])
            check_type(argname="argument confidence", value=confidence, expected_type=type_hints["confidence"])
            check_type(argname="argument confidence_var", value=confidence_var, expected_type=type_hints["confidence_var"])
            check_type(argname="argument fail_gravity", value=fail_gravity, expected_type=type_hints["fail_gravity"])
            check_type(argname="argument fail_gravity_var", value=fail_gravity_var, expected_type=type_hints["fail_gravity_var"])
            check_type(argname="argument focus", value=focus, expected_type=type_hints["focus"])
            check_type(argname="argument focus_var", value=focus_var, expected_type=type_hints["focus_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if algorithm is not None:
            self._values["algorithm"] = algorithm
        if algorithm_var is not None:
            self._values["algorithm_var"] = algorithm_var
        if confidence is not None:
            self._values["confidence"] = confidence
        if confidence_var is not None:
            self._values["confidence_var"] = confidence_var
        if fail_gravity is not None:
            self._values["fail_gravity"] = fail_gravity
        if fail_gravity_var is not None:
            self._values["fail_gravity_var"] = fail_gravity_var
        if focus is not None:
            self._values["focus"] = focus
        if focus_var is not None:
            self._values["focus_var"] = focus_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def algorithm(self) -> typing.Optional[builtins.str]:
        '''Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm DataAkamaiImagingPolicyImage#algorithm}
        '''
        result = self._values.get("algorithm")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def algorithm_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm_var DataAkamaiImagingPolicyImage#algorithm_var}
        '''
        result = self._values.get("algorithm_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def confidence(self) -> typing.Optional[builtins.str]:
        '''With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image.

        Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence DataAkamaiImagingPolicyImage#confidence}
        '''
        result = self._values.get("confidence")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def confidence_var(self) -> typing.Optional[builtins.str]:
        '''With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image.

        Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence_var DataAkamaiImagingPolicyImage#confidence_var}
        '''
        result = self._values.get("confidence_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any faces in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        '''
        result = self._values.get("fail_gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any faces in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        '''
        result = self._values.get("fail_gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def focus(self) -> typing.Optional[builtins.str]:
        '''Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus DataAkamaiImagingPolicyImage#focus}
        '''
        result = self._values.get("focus")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def focus_var(self) -> typing.Optional[builtins.str]:
        '''Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus_var DataAkamaiImagingPolicyImage#focus_var}
        '''
        result = self._values.get("focus_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the face(s) plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the face(s) plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultFaceCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultFaceCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultFaceCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e877c71c93a7a4112c7d1ee504eee24410f750cd2be17765ed4ba05a4ab7135a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultFaceCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f216b8070835767ed8650b5472dcb1ae14b430282d008d370405d950a574fa1b)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultFaceCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__29959f264ae3aad992ba79331218cda6d967f7d50971ec13c3eb931b48011c91)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__606eaa20a3b3164e8031f618450f8204602283d664642bd2c69eab71c674ba37)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f8d5d2eb5860342f73ed3dfafc58c09a29c2dbe88a260e5a18571a41dff62588)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultFaceCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultFaceCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultFaceCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4137fb43ac0f991f5e1dd52a17c22b10f3776a1e9b326dfa397423dcded068b7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultFaceCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultFaceCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8fcdb7c445d5e8a3b57512a82f57a7b8d3220075e802884ed3b54055a39e4f69)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAlgorithm")
    def reset_algorithm(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAlgorithm", []))

    @jsii.member(jsii_name="resetAlgorithmVar")
    def reset_algorithm_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAlgorithmVar", []))

    @jsii.member(jsii_name="resetConfidence")
    def reset_confidence(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetConfidence", []))

    @jsii.member(jsii_name="resetConfidenceVar")
    def reset_confidence_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetConfidenceVar", []))

    @jsii.member(jsii_name="resetFailGravity")
    def reset_fail_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravity", []))

    @jsii.member(jsii_name="resetFailGravityVar")
    def reset_fail_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravityVar", []))

    @jsii.member(jsii_name="resetFocus")
    def reset_focus(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFocus", []))

    @jsii.member(jsii_name="resetFocusVar")
    def reset_focus_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFocusVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="algorithmInput")
    def algorithm_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "algorithmInput"))

    @builtins.property
    @jsii.member(jsii_name="algorithmVarInput")
    def algorithm_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "algorithmVarInput"))

    @builtins.property
    @jsii.member(jsii_name="confidenceInput")
    def confidence_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "confidenceInput"))

    @builtins.property
    @jsii.member(jsii_name="confidenceVarInput")
    def confidence_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "confidenceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityInput")
    def fail_gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityVarInput")
    def fail_gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="focusInput")
    def focus_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "focusInput"))

    @builtins.property
    @jsii.member(jsii_name="focusVarInput")
    def focus_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "focusVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="algorithm")
    def algorithm(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "algorithm"))

    @algorithm.setter
    def algorithm(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d041cc8d074ef77a705b82d0af864ae21536a8b1ba406a60d1c5d72f526f50ff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "algorithm", value)

    @builtins.property
    @jsii.member(jsii_name="algorithmVar")
    def algorithm_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "algorithmVar"))

    @algorithm_var.setter
    def algorithm_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0c5bb352f7a8466522caf06d81804cd5a0461be47f956cc45313553257f87198)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "algorithmVar", value)

    @builtins.property
    @jsii.member(jsii_name="confidence")
    def confidence(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "confidence"))

    @confidence.setter
    def confidence(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f116c547fbbae423ef1ac999b73cc4cdbe4eba1e1cd6a058d5bc5eda9e8ead3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "confidence", value)

    @builtins.property
    @jsii.member(jsii_name="confidenceVar")
    def confidence_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "confidenceVar"))

    @confidence_var.setter
    def confidence_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0411d2fc89237d5917e8c299c66a061ee71d73021b3f3887697b44fa80dbc143)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "confidenceVar", value)

    @builtins.property
    @jsii.member(jsii_name="failGravity")
    def fail_gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravity"))

    @fail_gravity.setter
    def fail_gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e80ad6533f687eb6c5a66df8051a3c0d6e2c699cfef0cbf5f7bab99d7c434ab6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravity", value)

    @builtins.property
    @jsii.member(jsii_name="failGravityVar")
    def fail_gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravityVar"))

    @fail_gravity_var.setter
    def fail_gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fe2db1bb91cf86a57cb63e8dace0a27f5fc7207aebb3ce414a1f8087d1a79ad3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="focus")
    def focus(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "focus"))

    @focus.setter
    def focus(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6dd4adb6e960eab5c14446db97d129590d04bf492e260c4860038c0012106fe8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "focus", value)

    @builtins.property
    @jsii.member(jsii_name="focusVar")
    def focus_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "focusVar"))

    @focus_var.setter
    def focus_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__10374b32da6a79ee0e8c3a489a7d3cd4740b0636f026c80f3a5ef654c2d2270c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "focusVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f93e1718f3a6c85615065e78c69c139afadce355c3ed3b689655362c59baa2c4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f3dfd7dae7f95fd9af3af9be2ff1622e3ba010f28bd28f42212f4df57b51212)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f2f97961fb443fb09d370464a89cdcf522795160e0e051d1f6dece1e91355f16)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cba8993465dbfd9bad316f51e52972a5f466c4a22c581e35a4dac7baee6840fc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5c37c099602db9558ee2d490075dfbc1def7c1f25df4f40bfec04f41d7ef0ce6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cb38536eac62d0e15019ffce9adf8a6e569b465b4baf51781f3f3d06ccd08fd5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0002edd538700350be36a864060656db060fe9dfc916d58d8c56818ee0bbdb84)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__53f1fac3c14aca7c64191f914bdd236b24f1cd10a93b9d8c641a2d095dc7c764)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc58fdaeea8c879f62e5d13d63ebbadc7c827cd334bda4ac9eb4efe56aeb1279)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__061634290d021d95f2030a9a655bad5a33039bc11521976776852ac489f0936f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultFaceCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultFaceCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultFaceCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f8e637e3c685d128e8c2ad10baec6d826a5467ae4aee67c54cb92d328498eaca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultFeatureCrop",
    jsii_struct_bases=[],
    name_mapping={
        "fail_gravity": "failGravity",
        "fail_gravity_var": "failGravityVar",
        "feature_radius": "featureRadius",
        "feature_radius_var": "featureRadiusVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "max_features": "maxFeatures",
        "max_features_var": "maxFeaturesVar",
        "min_feature_quality": "minFeatureQuality",
        "min_feature_quality_var": "minFeatureQualityVar",
        "padding": "padding",
        "padding_var": "paddingVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultFeatureCrop:
    def __init__(
        self,
        *,
        fail_gravity: typing.Optional[builtins.str] = None,
        fail_gravity_var: typing.Optional[builtins.str] = None,
        feature_radius: typing.Optional[builtins.str] = None,
        feature_radius_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        max_features: typing.Optional[builtins.str] = None,
        max_features_var: typing.Optional[builtins.str] = None,
        min_feature_quality: typing.Optional[builtins.str] = None,
        min_feature_quality_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fail_gravity: Controls placement of the crop if Image and Video Manager does not detect any features in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        :param fail_gravity_var: Controls placement of the crop if Image and Video Manager does not detect any features in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        :param feature_radius: The size in pixels of the important features to search for. If identified, two features never appear closer together than this value, ``8.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius DataAkamaiImagingPolicyImage#feature_radius}
        :param feature_radius_var: The size in pixels of the important features to search for. If identified, two features never appear closer together than this value, ``8.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius_var DataAkamaiImagingPolicyImage#feature_radius_var}
        :param gravity: Controls placement of the crop. Directions are relative to the region of interest plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Controls placement of the crop. Directions are relative to the region of interest plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param max_features: The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features DataAkamaiImagingPolicyImage#max_features}
        :param max_features_var: The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features_var DataAkamaiImagingPolicyImage#max_features_var}
        :param min_feature_quality: Determines the minimum quality level of the feature identified. To consider a feature important, the feature needs to surpass this value. Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality DataAkamaiImagingPolicyImage#min_feature_quality}
        :param min_feature_quality_var: Determines the minimum quality level of the feature identified. To consider a feature important, the feature needs to surpass this value. Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality_var DataAkamaiImagingPolicyImage#min_feature_quality_var}
        :param padding: Adds space around the region of interest. The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: Adds space around the region of interest. The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        :param style: Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0a72cc9e2a10c3aeb54ed5646a69308feb76a436b321d62cfe55a885471d470e)
            check_type(argname="argument fail_gravity", value=fail_gravity, expected_type=type_hints["fail_gravity"])
            check_type(argname="argument fail_gravity_var", value=fail_gravity_var, expected_type=type_hints["fail_gravity_var"])
            check_type(argname="argument feature_radius", value=feature_radius, expected_type=type_hints["feature_radius"])
            check_type(argname="argument feature_radius_var", value=feature_radius_var, expected_type=type_hints["feature_radius_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument max_features", value=max_features, expected_type=type_hints["max_features"])
            check_type(argname="argument max_features_var", value=max_features_var, expected_type=type_hints["max_features_var"])
            check_type(argname="argument min_feature_quality", value=min_feature_quality, expected_type=type_hints["min_feature_quality"])
            check_type(argname="argument min_feature_quality_var", value=min_feature_quality_var, expected_type=type_hints["min_feature_quality_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fail_gravity is not None:
            self._values["fail_gravity"] = fail_gravity
        if fail_gravity_var is not None:
            self._values["fail_gravity_var"] = fail_gravity_var
        if feature_radius is not None:
            self._values["feature_radius"] = feature_radius
        if feature_radius_var is not None:
            self._values["feature_radius_var"] = feature_radius_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if max_features is not None:
            self._values["max_features"] = max_features
        if max_features_var is not None:
            self._values["max_features_var"] = max_features_var
        if min_feature_quality is not None:
            self._values["min_feature_quality"] = min_feature_quality
        if min_feature_quality_var is not None:
            self._values["min_feature_quality_var"] = min_feature_quality_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def fail_gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any features in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        '''
        result = self._values.get("fail_gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any features in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        '''
        result = self._values.get("fail_gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feature_radius(self) -> typing.Optional[builtins.str]:
        '''The size in pixels of the important features to search for.

        If identified, two features never appear closer together than this value, ``8.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius DataAkamaiImagingPolicyImage#feature_radius}
        '''
        result = self._values.get("feature_radius")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feature_radius_var(self) -> typing.Optional[builtins.str]:
        '''The size in pixels of the important features to search for.

        If identified, two features never appear closer together than this value, ``8.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius_var DataAkamaiImagingPolicyImage#feature_radius_var}
        '''
        result = self._values.get("feature_radius_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the region of interest plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the region of interest plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def max_features(self) -> typing.Optional[builtins.str]:
        '''The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features DataAkamaiImagingPolicyImage#max_features}
        '''
        result = self._values.get("max_features")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def max_features_var(self) -> typing.Optional[builtins.str]:
        '''The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features_var DataAkamaiImagingPolicyImage#max_features_var}
        '''
        result = self._values.get("max_features_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def min_feature_quality(self) -> typing.Optional[builtins.str]:
        '''Determines the minimum quality level of the feature identified.

        To consider a feature important, the feature needs to surpass this value.  Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality DataAkamaiImagingPolicyImage#min_feature_quality}
        '''
        result = self._values.get("min_feature_quality")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def min_feature_quality_var(self) -> typing.Optional[builtins.str]:
        '''Determines the minimum quality level of the feature identified.

        To consider a feature important, the feature needs to surpass this value.  Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality_var DataAkamaiImagingPolicyImage#min_feature_quality_var}
        '''
        result = self._values.get("min_feature_quality_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''Adds space around the region of interest.

        The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''Adds space around the region of interest.

        The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultFeatureCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultFeatureCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultFeatureCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ca675066d7a8f2ea674a3e3601a49dc12ac0178b6dcf141bd006dfc3f461084)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultFeatureCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af6bc780ff8c46931aec09331aeb8ac4ccedc1ea16512dbd01ad60b3c7544df5)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultFeatureCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__209b54251119aa6dada09f128889c6846dea9f5d9adfba45d9942b97d1a064ec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5684e1f253d21859f6219a63d9c1439821aaf5719d679daac8c1a84d2f603b0b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__223fc97ffec6bf19f43c02905a04879a22e229d4144455f7957b992cd48f2861)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultFeatureCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultFeatureCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultFeatureCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__54e3b25a44e84ce4e06483e68e7524b302c84a2963071cc2878ee46470c6d88d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultFeatureCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultFeatureCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4570a3a7d5ff15b8d678f862e696f7cadd357d8485ac9bf582ca67ea47b31b50)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetFailGravity")
    def reset_fail_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravity", []))

    @jsii.member(jsii_name="resetFailGravityVar")
    def reset_fail_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravityVar", []))

    @jsii.member(jsii_name="resetFeatureRadius")
    def reset_feature_radius(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureRadius", []))

    @jsii.member(jsii_name="resetFeatureRadiusVar")
    def reset_feature_radius_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureRadiusVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetMaxFeatures")
    def reset_max_features(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxFeatures", []))

    @jsii.member(jsii_name="resetMaxFeaturesVar")
    def reset_max_features_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxFeaturesVar", []))

    @jsii.member(jsii_name="resetMinFeatureQuality")
    def reset_min_feature_quality(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMinFeatureQuality", []))

    @jsii.member(jsii_name="resetMinFeatureQualityVar")
    def reset_min_feature_quality_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMinFeatureQualityVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="failGravityInput")
    def fail_gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityVarInput")
    def fail_gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featureRadiusInput")
    def feature_radius_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featureRadiusInput"))

    @builtins.property
    @jsii.member(jsii_name="featureRadiusVarInput")
    def feature_radius_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featureRadiusVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesInput")
    def max_features_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "maxFeaturesInput"))

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesVarInput")
    def max_features_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "maxFeaturesVarInput"))

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityInput")
    def min_feature_quality_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "minFeatureQualityInput"))

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityVarInput")
    def min_feature_quality_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "minFeatureQualityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravity")
    def fail_gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravity"))

    @fail_gravity.setter
    def fail_gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af1f48eb4ee624d9339eeae503758da36c5b7f2fa79769e572d2e1a5c4d87b3d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravity", value)

    @builtins.property
    @jsii.member(jsii_name="failGravityVar")
    def fail_gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravityVar"))

    @fail_gravity_var.setter
    def fail_gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ef10eab1897f8578ec3875737fa719d737e0b8a60dc01ed43d638575253f716e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="featureRadius")
    def feature_radius(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featureRadius"))

    @feature_radius.setter
    def feature_radius(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e55bfdbd8664810b1598877590c9a9fd39d8e81e9c63a81498338f47651e9e3e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featureRadius", value)

    @builtins.property
    @jsii.member(jsii_name="featureRadiusVar")
    def feature_radius_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featureRadiusVar"))

    @feature_radius_var.setter
    def feature_radius_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__35ee025fc49a45b0a8bd0273cb6c49e46c1c16c57c9e3c5cfa9e068973cabe3f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featureRadiusVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ba1dc833301876eb7805d9cc6d8d2673de13cf68f4851337befdefc4d5b37dea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aedc104140b9432c754f45205b15dc36c921644e25d030641c3056a61f330b6e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8b9c5f0e091d7f98dd5629df50e1664d2453f38e5ce5a76d37bf58b3ea26de1e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__94aa2fa2aaaf9c1a04cb28f16a060c8fe83083f4fdb985dba8f0547ebf0dddd4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="maxFeatures")
    def max_features(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "maxFeatures"))

    @max_features.setter
    def max_features(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7c66bc645fac71f8450ec071b81ba24baf598144e46e3845e56afa80c5f94376)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "maxFeatures", value)

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesVar")
    def max_features_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "maxFeaturesVar"))

    @max_features_var.setter
    def max_features_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__52dd4d9b47d9de2a7cd76059ca94b12c7567ffdebfed5a81f173a0fde4623afb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "maxFeaturesVar", value)

    @builtins.property
    @jsii.member(jsii_name="minFeatureQuality")
    def min_feature_quality(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "minFeatureQuality"))

    @min_feature_quality.setter
    def min_feature_quality(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__06055b847c075c422c9574fd8b65fa86b98bddb3e8bb14e4cd3c7a3e7c169a98)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "minFeatureQuality", value)

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityVar")
    def min_feature_quality_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "minFeatureQualityVar"))

    @min_feature_quality_var.setter
    def min_feature_quality_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a17652aa6522aead12ea0d3e00baf30ce24abfc48e95154c20be519b785c96e6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "minFeatureQualityVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d9e6f78a2449b7cd2204c94ba5da7fdfa2b4ac42cc8a00faa0a9fc865d40c5e9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4bd4eff6a2393d05b9f4b5173003a796e8f967b6ead825742dda6b62b947024e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a46c9030f159e46682cd426e516c78f288d401bdae69a3560cafb78fa7343b86)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__712f1b82e15db2ff0068b24339ec808e092a568e03b92758d0f73fed344d5163)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3e6101a196934d07af69cabd906e071264422b9c17d65fcab1805e3fe8dd3f9d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e8d86de36f64d887da8ea93ddc3339792911a7063f794ef32e0a29ed5bd065f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultFeatureCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultFeatureCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultFeatureCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8cfa8057230710ea9f6ee206133d9b3d8cb4b54919c938ed76cc039a72ec9b8d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultFitAndFill",
    jsii_struct_bases=[],
    name_mapping={
        "fill_transformation": "fillTransformation",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultFitAndFill:
    def __init__(
        self,
        *,
        fill_transformation: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultFitAndFillFillTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fill_transformation: fill_transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_transformation DataAkamaiImagingPolicyImage#fill_transformation}
        :param height: The height value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The width value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(fill_transformation, dict):
            fill_transformation = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultFitAndFillFillTransformation(**fill_transformation)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a03d009b2d55134e8e91d2676772edddb877827ff29aa7ee33cbcd7773938624)
            check_type(argname="argument fill_transformation", value=fill_transformation, expected_type=type_hints["fill_transformation"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fill_transformation is not None:
            self._values["fill_transformation"] = fill_transformation
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def fill_transformation(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultFitAndFillFillTransformation"]:
        '''fill_transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_transformation DataAkamaiImagingPolicyImage#fill_transformation}
        '''
        result = self._values.get("fill_transformation")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultFitAndFillFillTransformation"], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultFitAndFill(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultFitAndFillFillTransformation",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultFitAndFillFillTransformation:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultFitAndFillFillTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultFitAndFillFillTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultFitAndFillFillTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0c36cf1b30c55a4ea44d272ef89cca6c3606ed6a40ab287118f3c37a1ba090c4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultFitAndFillFillTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultFitAndFillFillTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultFitAndFillFillTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fbfe925cf87999fc52efaf1ff49dd6fb78859b1bd44dc4c8b3c2091be35b4dc2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultFitAndFillList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultFitAndFillList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5d072ab5ec207199c9874e2c08b03107aebc32ef059dea062ed7721b99311e19)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultFitAndFillOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__40e385357a03dfdcfba6dade814da6f62861b1d5e61099138a3cc9a4dd3d54f0)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultFitAndFillOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7c8a39b0f377124c82baf50f4649aecf2b6922c52998660a1b0d47f6e8096f81)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e49f9c2fefacc424446d815409adc1d94bcd14c67cb4a74252b063e79e009e3e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d9c2a5b4e10223aa90714fb1680f4b7a379e2e3f02abb34f7f1c3963472c05cf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultFitAndFill]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultFitAndFill]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultFitAndFill]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5dc274e002e52efcf5701423e7eecf9de54429f421ce167a67f2b0e82a168c5f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultFitAndFillOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultFitAndFillOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__605a68a6ee388de726d40a215d7027b2d67afb919b425e80975dd8e7610f94b0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putFillTransformation")
    def put_fill_transformation(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultFitAndFillFillTransformation()

        return typing.cast(None, jsii.invoke(self, "putFillTransformation", [value]))

    @jsii.member(jsii_name="resetFillTransformation")
    def reset_fill_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFillTransformation", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="fillTransformation")
    def fill_transformation(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultFitAndFillFillTransformationOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultFitAndFillFillTransformationOutputReference, jsii.get(self, "fillTransformation"))

    @builtins.property
    @jsii.member(jsii_name="fillTransformationInput")
    def fill_transformation_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultFitAndFillFillTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultFitAndFillFillTransformation], jsii.get(self, "fillTransformationInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3644f28d9aca73f9c2bad1485081de9e38cc01b9ef4b88efd73c6f7117fc68ad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d237fa5c2d9222ebe2d48e7870b5fdc8e4555414269d6b9d2e68b28e14c2cde2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a235d89aea545c49591a463d47efe601882594178e39f2e595700e2b0cde502)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__21d5143e7044932ed9f589f34290cf6bc2408e6b9f02b2d0de1efca5129d14cb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultFitAndFill]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultFitAndFill]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultFitAndFill]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c9c27279c6a0a3d226f121710e2c40e32224070307950c99d9ae85355db0a4f1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultGoop",
    jsii_struct_bases=[],
    name_mapping={
        "chaos": "chaos",
        "chaos_var": "chaosVar",
        "density": "density",
        "density_var": "densityVar",
        "power": "power",
        "power_var": "powerVar",
        "seed": "seed",
        "seed_var": "seedVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultGoop:
    def __init__(
        self,
        *,
        chaos: typing.Optional[builtins.str] = None,
        chaos_var: typing.Optional[builtins.str] = None,
        density: typing.Optional[builtins.str] = None,
        density_var: typing.Optional[builtins.str] = None,
        power: typing.Optional[builtins.str] = None,
        power_var: typing.Optional[builtins.str] = None,
        seed: typing.Optional[builtins.str] = None,
        seed_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param chaos: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        :param chaos_var: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        :param density: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        :param density_var: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        :param power: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        :param power_var: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        :param seed: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        :param seed_var: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1e9131b6308eabaa4efe184defbd59dead986e8a70736c4c35641cc0c07c998b)
            check_type(argname="argument chaos", value=chaos, expected_type=type_hints["chaos"])
            check_type(argname="argument chaos_var", value=chaos_var, expected_type=type_hints["chaos_var"])
            check_type(argname="argument density", value=density, expected_type=type_hints["density"])
            check_type(argname="argument density_var", value=density_var, expected_type=type_hints["density_var"])
            check_type(argname="argument power", value=power, expected_type=type_hints["power"])
            check_type(argname="argument power_var", value=power_var, expected_type=type_hints["power_var"])
            check_type(argname="argument seed", value=seed, expected_type=type_hints["seed"])
            check_type(argname="argument seed_var", value=seed_var, expected_type=type_hints["seed_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if chaos is not None:
            self._values["chaos"] = chaos
        if chaos_var is not None:
            self._values["chaos_var"] = chaos_var
        if density is not None:
            self._values["density"] = density
        if density_var is not None:
            self._values["density_var"] = density_var
        if power is not None:
            self._values["power"] = power
        if power_var is not None:
            self._values["power_var"] = power_var
        if seed is not None:
            self._values["seed"] = seed
        if seed_var is not None:
            self._values["seed_var"] = seed_var

    @builtins.property
    def chaos(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        '''
        result = self._values.get("chaos")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def chaos_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        '''
        result = self._values.get("chaos_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        '''
        result = self._values.get("density")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density_var(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        '''
        result = self._values.get("density_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        '''
        result = self._values.get("power")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power_var(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        '''
        result = self._values.get("power_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        '''
        result = self._values.get("seed")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed_var(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        result = self._values.get("seed_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultGoop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultGoopList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultGoopList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2fa3ea6a391e588dea53bbeeec4c8537ba4feb71976ef5b97c679ad854d951c1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultGoopOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac5c65d6373f9690fbf066dc9db1ac3a2bd3abe4ef254ead63ca374762d983ee)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultGoopOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d14b04100b509fef7ccc1750690d031d25e73e423f5c01f669db836054c9d93e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c5a9f6ba0916af36a41a2b9c5c98266854814cbeeb5a2233ebc6db0821ea7458)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f0d5126913205fafd39ae33b26ec6cf62e62a9d7f7bd953253d4a4185d573139)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultGoop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultGoop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cb6914cbb53f626fd0f12c1a1e4e1e78cc5908a590b7d487c27728babb06ae40)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultGoopOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultGoopOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a2da0c724e0753f2f89eec949e15f28e5f6d00d26b47a0a64bc1d53b74fbd65)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetChaos")
    def reset_chaos(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaos", []))

    @jsii.member(jsii_name="resetChaosVar")
    def reset_chaos_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaosVar", []))

    @jsii.member(jsii_name="resetDensity")
    def reset_density(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensity", []))

    @jsii.member(jsii_name="resetDensityVar")
    def reset_density_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensityVar", []))

    @jsii.member(jsii_name="resetPower")
    def reset_power(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPower", []))

    @jsii.member(jsii_name="resetPowerVar")
    def reset_power_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPowerVar", []))

    @jsii.member(jsii_name="resetSeed")
    def reset_seed(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeed", []))

    @jsii.member(jsii_name="resetSeedVar")
    def reset_seed_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeedVar", []))

    @builtins.property
    @jsii.member(jsii_name="chaosInput")
    def chaos_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosInput"))

    @builtins.property
    @jsii.member(jsii_name="chaosVarInput")
    def chaos_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosVarInput"))

    @builtins.property
    @jsii.member(jsii_name="densityInput")
    def density_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityInput"))

    @builtins.property
    @jsii.member(jsii_name="densityVarInput")
    def density_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="powerInput")
    def power_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerInput"))

    @builtins.property
    @jsii.member(jsii_name="powerVarInput")
    def power_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerVarInput"))

    @builtins.property
    @jsii.member(jsii_name="seedInput")
    def seed_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedInput"))

    @builtins.property
    @jsii.member(jsii_name="seedVarInput")
    def seed_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedVarInput"))

    @builtins.property
    @jsii.member(jsii_name="chaos")
    def chaos(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaos"))

    @chaos.setter
    def chaos(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1569d22a5e085ff296e6a34b123a45f373423353fbd02e8cee2cd2107a7f61be)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaos", value)

    @builtins.property
    @jsii.member(jsii_name="chaosVar")
    def chaos_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaosVar"))

    @chaos_var.setter
    def chaos_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a1101926d35fee0f33c4b29b01e39ef41ac6bc2f6f9f09dbfafcedb5117aa65)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaosVar", value)

    @builtins.property
    @jsii.member(jsii_name="density")
    def density(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "density"))

    @density.setter
    def density(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d227329833b49b6619173e606f3f6c48efaad9f94d399faf73196ab574d8d1e8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "density", value)

    @builtins.property
    @jsii.member(jsii_name="densityVar")
    def density_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "densityVar"))

    @density_var.setter
    def density_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__86c4586cb15147ff546012d160e2317f3b30e3bb584bff057c896f2c2c09f264)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "densityVar", value)

    @builtins.property
    @jsii.member(jsii_name="power")
    def power(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "power"))

    @power.setter
    def power(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d049bcbc02c7183087addf11d99bc04391f94c3066fa3d58f6616986dbcfaf7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "power", value)

    @builtins.property
    @jsii.member(jsii_name="powerVar")
    def power_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "powerVar"))

    @power_var.setter
    def power_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__62725d57a8753805fea19b511a216ea988e9a4a9edd9ae87b91ba247b81e43e8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "powerVar", value)

    @builtins.property
    @jsii.member(jsii_name="seed")
    def seed(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seed"))

    @seed.setter
    def seed(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__29e2f40e39e768b5a22ae8b7c92d19030976c2009ef05ec6d46afae3dfabcdea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seed", value)

    @builtins.property
    @jsii.member(jsii_name="seedVar")
    def seed_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seedVar"))

    @seed_var.setter
    def seed_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df7ebca49e17bce5e48bc44920e4921fe92d26e6ee675247068af7de2393a886)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seedVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultGoop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultGoop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultGoop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6368b8b6166683cb57d6c4dbc9edd782d96325c47d6aee9ee7455104541bcb26)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultGrayscale",
    jsii_struct_bases=[],
    name_mapping={"type": "type", "type_var": "typeVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultGrayscale:
    def __init__(
        self,
        *,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param type: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__29edce05350d7d67b6dc10dfb98fc7496317e875c796b5af7992d298cf0fe243)
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultGrayscale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultGrayscaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultGrayscaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__282fe64c74d17e66a2aed36aad3de040ce779fcb3983a0b613d8994a978198a2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultGrayscaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7a4efc2d5d86e9d1580362bc83e120199ab28f65f0bca4f1589ae8729aa53514)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultGrayscaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0f05b8c539ca4e1ab2cd5794dcccc2a6bb9f100f79f05e5dae48692c419c991b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e0aa54a1727d1840b4dbeed31d9141fa234eb70b4f48da2173326113ea05e8e9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__46bedfde93bbeb87b2caf49c4899ff01452f9ea5c93c8394416706f6ad429c3d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultGrayscale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultGrayscale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9af3f9d04927e7133a6b8bd33f403a4f426a948e1bdfdfd6fa4f5610fd095819)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultGrayscaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultGrayscaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__88f26add08918be28761d66dc087d05aaef9ff35e5792073f7270d39d2207902)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eb6fa08c4e1e37c4d85b74f8490e19ac7f1ef80705f1f1ab3dc0683da07ea588)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__05eed565fd0ae138d9266e98e04a455fb8e4af07b4c8e91b2e1abcf208ae9271)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultGrayscale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultGrayscale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultGrayscale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8c05eca535373c301b50ad7d583ce89e4cee64624ff300b59bb5c3dabc12ce1b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultHsl",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "lightness": "lightness",
        "lightness_var": "lightnessVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultHsl:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness: typing.Optional[builtins.str] = None,
        lightness_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        :param lightness_var: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__302415bb0ce04a3e33b84676ac1ac9ad691af1dc014579b69ef36056d6c3f346)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness", value=lightness, expected_type=type_hints["lightness"])
            check_type(argname="argument lightness_var", value=lightness_var, expected_type=type_hints["lightness_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness is not None:
            self._values["lightness"] = lightness
        if lightness_var is not None:
            self._values["lightness_var"] = lightness_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        '''
        result = self._values.get("lightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        '''
        result = self._values.get("lightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultHsl(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultHslList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultHslList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ce1c413cabc8cc51538166dea2d9cb48c68ca9c1fb7b7d372eba31860ab92d47)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultHslOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__62a311e92ff71bfb4c765de44089df8314778df62e52cc1703f6390e7d67250e)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultHslOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__197d2a8dcaa1350e653e3811b7a7aa332c0a8f541122fd790a3a91e9d8984310)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__65c2d24a28665072187bfeb2c1d21b60490de479298ce7c91c7e0ea1eeafa3a1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7f4f1974d1487316018a81da2d9fc155623d8b58550ab59677ef6fa5c87e0d76)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultHsl]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultHsl]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c229582ded5d5011a91fb76cc514aec7774559d0431d0d2765d8e43ccb334b75)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultHslOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultHslOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ad40fa63f45b458d7fa0766d7f8e4eb791cd4aa4b8480a2f3d914396ccbb433)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightness")
    def reset_lightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightness", []))

    @jsii.member(jsii_name="resetLightnessVar")
    def reset_lightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessInput")
    def lightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessVarInput")
    def lightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a4cab5274b845639243b173de31a2f8ed5783943ce5be2920924484d2d76fa9f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fd24dbce7962c3f91fb65f9882aff4b464224e8a7a9c6d823ca4ffd8d1d92ad5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightness")
    def lightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightness"))

    @lightness.setter
    def lightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f8e05a96a74399ca21bbaea81a533b0500f60991c7ef1cd309c2f1d9135fbe0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightness", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessVar")
    def lightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessVar"))

    @lightness_var.setter
    def lightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__941db332b6e98c0243f05c679ddace1f505003084e13ed8bfde70711eef7ccf7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7b504becb3a9378dc341579d607e2243c16ed41bee31ac5795c22a39eaa12f41)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b041d56d5c69af6236ddfcae112ba93b94dfc14301a5be77a8242c9c628bf0db)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultHsl]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultHsl]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultHsl]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0b9ee6cf9973363eda4330203baad05ba7655c935ac390d78e9474c060212b2d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultHsv",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultHsv:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        :param value: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__99b251fee153e48265ffa5df6e1a45a131bffc4efcf88ffe09cbbe23690be835)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultHsv(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultHsvList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultHsvList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0c1c56e98f20dc37765b0753842ca84c22be3611cc3c10a8603021a817c71984)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultHsvOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__45813dfce5338556d21e66a3fd18e84e9be1d365fa52cf362034efd1640fb517)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultHsvOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c5c5060a5cd910bb966656b962ec19154056ed5d98684a25a4f4f0d3cf79548a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f5e4ab0ffcdb3994bb8e6dfb5287931f3d736d69e424f4fe95357e14567d9922)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a048d5fbf74268d2a4428c1f76f8dbd3929c315add73a6d3d7069e8f4a07cae5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultHsv]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultHsv]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d36891ff95ad46df089f7da8353057b063d9e077dad9bc6482b8e3ba9e23e0bd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultHsvOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultHsvOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9f49fa9f918368fbf81ae7800962e20e3f636b8ef2be7cd2a475243ea1efbfc3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e817eb445c2b26a26244f005b04b418be9480eaeceaa7477c8ef56b3e5581f24)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cf37f257dfa266ac6b8da67700a4d9b43e16ed0deecd25d051ab0c823402bda4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2140ef64a24341839f0b60ec40cfd51d76e960ecb36097f054bdd503a7ff3787)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd37218c77ad30b9f250398d44f5b9ab5c13357960b597cd34fe93da4244eda8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a1934fefcc5f06dc69c6e16a049c28a8274f5ec0bbd684074fd50938f3c6afa4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6cf5515a50b2ad76731453798cdb6ce4927e922b17a19b09f4c96b720f0ddbeb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultHsv]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultHsv]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultHsv]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__decdbb00c6c34d40e84640657e8d63ca5a2c3f4ce26be544741839821fdd75b0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimension",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "dimension": "dimension",
        "dimension_var": "dimensionVar",
        "equal": "equal",
        "greater_than": "greaterThan",
        "less_than": "lessThan",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimension:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        dimension: typing.Optional[builtins.str] = None,
        dimension_var: typing.Optional[builtins.str] = None,
        equal: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionEqual", typing.Dict[builtins.str, typing.Any]]] = None,
        greater_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionGreaterThan", typing.Dict[builtins.str, typing.Any]]] = None,
        less_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionLessThan", typing.Dict[builtins.str, typing.Any]]] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param dimension: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        :param dimension_var: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        :param equal: equal block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        :param greater_than: greater_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        :param less_than: less_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        :param value: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionDefault(**default)
        if isinstance(equal, dict):
            equal = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionEqual(**equal)
        if isinstance(greater_than, dict):
            greater_than = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionGreaterThan(**greater_than)
        if isinstance(less_than, dict):
            less_than = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionLessThan(**less_than)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3c6487ce862bbd19c258c6becbb645427a1415fa8571728baa7af5081c3f9ae1)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument dimension", value=dimension, expected_type=type_hints["dimension"])
            check_type(argname="argument dimension_var", value=dimension_var, expected_type=type_hints["dimension_var"])
            check_type(argname="argument equal", value=equal, expected_type=type_hints["equal"])
            check_type(argname="argument greater_than", value=greater_than, expected_type=type_hints["greater_than"])
            check_type(argname="argument less_than", value=less_than, expected_type=type_hints["less_than"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if dimension is not None:
            self._values["dimension"] = dimension
        if dimension_var is not None:
            self._values["dimension_var"] = dimension_var
        if equal is not None:
            self._values["equal"] = equal
        if greater_than is not None:
            self._values["greater_than"] = greater_than
        if less_than is not None:
            self._values["less_than"] = less_than
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionDefault"], result)

    @builtins.property
    def dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        '''
        result = self._values.get("dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        '''
        result = self._values.get("dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def equal(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionEqual"]:
        '''equal block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        '''
        result = self._values.get("equal")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionEqual"], result)

    @builtins.property
    def greater_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionGreaterThan"]:
        '''greater_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        '''
        result = self._values.get("greater_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionGreaterThan"], result)

    @builtins.property
    def less_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionLessThan"]:
        '''less_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        '''
        result = self._values.get("less_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionLessThan"], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimension(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fd5ffaa4c1d32805f5b525f1e748f9c69697e26e7aaa6c0fc1f54e095489b17f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cb0a83606ccf6f8cfd7267c44568419105cc6df6e9eb2869cc9f5a025fd57ccc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionEqual",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionEqual:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionEqual(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionEqualOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionEqualOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b89c730f1fbe4f23c38989fbaaac255fd4e16454c52384c0818b1afd7ba6f1bc)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionEqual], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionEqual],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2135b915dfef4572110fd38b696d40f4469df0547d7a8f6e8c3fe65ee43d3f3b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionGreaterThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionGreaterThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionGreaterThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionGreaterThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionGreaterThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fb77719653215ee27bcc5eeb95f1b77a80ae4db965279541ea261de43541026c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionGreaterThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionGreaterThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__173cc76b12eea5eb56968a957f855356cca92bb0cc512a10d3dcec23653304b5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionLessThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionLessThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionLessThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionLessThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionLessThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ce4b35294913c37834572a46348ae94fa741dc156a0997ee9253cd09b62435ba)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionLessThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionLessThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b4e8d21af7c5418f27844e7111d5e74d1254aec468282a4dad3711b4e1c1e7fa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f45b678871c820587092bb56ac999bfcff64042bb30b41251274e6aec57b734b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e4978bfdd2463fcd394bd60651855846fcba7bddcdf4175f3e66058807521427)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__275cba8d019c9f6acb10b99bd25b8b705e5ed23ed367d40f3e7156a5dfcb3dc5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a6e633f1431434e0b9062c40cf67f943cfc3c36f50bd98f0429389ef06d9a12c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4c41fcb41e9e062b01f6ff679dee5ea41dd5ed46319f6345a8353a07563c01fe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimension]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimension]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e8a3931570b3e5934b8a4fa5fe84f6ffb92c5ddf109679c0a85e2f423e33be4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f2bb121f0c0cefd06140b4c66cacb78727fc399e287c2294034d1fb75b419982)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putEqual")
    def put_equal(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionEqual()

        return typing.cast(None, jsii.invoke(self, "putEqual", [value]))

    @jsii.member(jsii_name="putGreaterThan")
    def put_greater_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionGreaterThan()

        return typing.cast(None, jsii.invoke(self, "putGreaterThan", [value]))

    @jsii.member(jsii_name="putLessThan")
    def put_less_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionLessThan()

        return typing.cast(None, jsii.invoke(self, "putLessThan", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetDimension")
    def reset_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimension", []))

    @jsii.member(jsii_name="resetDimensionVar")
    def reset_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimensionVar", []))

    @jsii.member(jsii_name="resetEqual")
    def reset_equal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEqual", []))

    @jsii.member(jsii_name="resetGreaterThan")
    def reset_greater_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGreaterThan", []))

    @jsii.member(jsii_name="resetLessThan")
    def reset_less_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLessThan", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="equal")
    def equal(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionEqualOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionEqualOutputReference, jsii.get(self, "equal"))

    @builtins.property
    @jsii.member(jsii_name="greaterThan")
    def greater_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionGreaterThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionGreaterThanOutputReference, jsii.get(self, "greaterThan"))

    @builtins.property
    @jsii.member(jsii_name="lessThan")
    def less_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionLessThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionLessThanOutputReference, jsii.get(self, "lessThan"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionInput")
    def dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionVarInput")
    def dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="equalInput")
    def equal_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionEqual], jsii.get(self, "equalInput"))

    @builtins.property
    @jsii.member(jsii_name="greaterThanInput")
    def greater_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionGreaterThan], jsii.get(self, "greaterThanInput"))

    @builtins.property
    @jsii.member(jsii_name="lessThanInput")
    def less_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionLessThan], jsii.get(self, "lessThanInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="dimension")
    def dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimension"))

    @dimension.setter
    def dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa5b40e18458e4f879c15c55234c76bf25167e3471118d2ed326cf551b60cee0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimension", value)

    @builtins.property
    @jsii.member(jsii_name="dimensionVar")
    def dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimensionVar"))

    @dimension_var.setter
    def dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__674d92496929a73f63d3fb17f198f12850a21fb6d4ae1b6d323e6c00aefb60cf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f1d3fae5eefbbc1e3a0ed8ee37513a48063233c5d821e82c157641997754377d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__576c1fd8e8a9838a3773bd2b1653bcc403d6df3453296963d6704c3cd8a1e888)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimension]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimension]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimension]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0bac1a6d1cc105ab16e8f72351545f17a1018b712c5598f5789f7ea1db7f7244)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientation",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "landscape": "landscape",
        "portrait": "portrait",
        "square": "square",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientation:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        landscape: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationLandscape", typing.Dict[builtins.str, typing.Any]]] = None,
        portrait: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationPortrait", typing.Dict[builtins.str, typing.Any]]] = None,
        square: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationSquare", typing.Dict[builtins.str, typing.Any]]] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param landscape: landscape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        :param portrait: portrait block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        :param square: square block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationDefault(**default)
        if isinstance(landscape, dict):
            landscape = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationLandscape(**landscape)
        if isinstance(portrait, dict):
            portrait = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationPortrait(**portrait)
        if isinstance(square, dict):
            square = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationSquare(**square)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0c24ccf10dc38a86276ab0605417781a9e98794226427815a7e5ab876657aab9)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument landscape", value=landscape, expected_type=type_hints["landscape"])
            check_type(argname="argument portrait", value=portrait, expected_type=type_hints["portrait"])
            check_type(argname="argument square", value=square, expected_type=type_hints["square"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if landscape is not None:
            self._values["landscape"] = landscape
        if portrait is not None:
            self._values["portrait"] = portrait
        if square is not None:
            self._values["square"] = square

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationDefault"], result)

    @builtins.property
    def landscape(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationLandscape"]:
        '''landscape block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        '''
        result = self._values.get("landscape")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationLandscape"], result)

    @builtins.property
    def portrait(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationPortrait"]:
        '''portrait block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        '''
        result = self._values.get("portrait")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationPortrait"], result)

    @builtins.property
    def square(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationSquare"]:
        '''square block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        result = self._values.get("square")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationSquare"], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4175896eff41410337d77f421f6dfdc5ce399051c1232db3f5223188b7fe0262)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e67a034f3fd1d9eb273f11be92038179b2f84331b566d6ff3a6fd3355dd2c58)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationLandscape",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationLandscape:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationLandscape(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationLandscapeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationLandscapeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e6b0fabd4c2ed64c1cabb44814ae1719bdfba1388ced71db0ab7b54dd3598e5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationLandscape], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationLandscape],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__551a5643b94b53471052fe7c9de02bd8fbb7c976ce67f9ba84265a5cb16175df)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__831e26e7b9278c142e2ba3a1d84f6b70694f7f327d02687dd2d2485a0a145779)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f6106450c9959d8491b1159e0d372943b973f206e80fc59bc669e7951c2b6d34)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5c0937d9463a5f19e0d5e1eb5e106f87c2ac90f2acdb96b24fe2182f0f6d6767)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__44d4cc3d7e9df23b1151df580cf7ac7bdc3373e19cae3c4f0b2cf56e01c6d1bd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eddd4fa2f5c8f3b80c33b5cae76c36b4c2f92b0e3b9daa89d78027f539ac2e4e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientation]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientation]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__406afd476763876e538d8aa46e8dd893f5d48b6ad6c5516287b319ea85c584fa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f6a28ffdbbaafdca5f445b2af1c01e568fdef9e0a4ac36f5521da9d4338ca2c0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putLandscape")
    def put_landscape(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationLandscape()

        return typing.cast(None, jsii.invoke(self, "putLandscape", [value]))

    @jsii.member(jsii_name="putPortrait")
    def put_portrait(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationPortrait()

        return typing.cast(None, jsii.invoke(self, "putPortrait", [value]))

    @jsii.member(jsii_name="putSquare")
    def put_square(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationSquare()

        return typing.cast(None, jsii.invoke(self, "putSquare", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetLandscape")
    def reset_landscape(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLandscape", []))

    @jsii.member(jsii_name="resetPortrait")
    def reset_portrait(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPortrait", []))

    @jsii.member(jsii_name="resetSquare")
    def reset_square(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSquare", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="landscape")
    def landscape(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationLandscapeOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationLandscapeOutputReference, jsii.get(self, "landscape"))

    @builtins.property
    @jsii.member(jsii_name="portrait")
    def portrait(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationPortraitOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationPortraitOutputReference", jsii.get(self, "portrait"))

    @builtins.property
    @jsii.member(jsii_name="square")
    def square(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationSquareOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationSquareOutputReference", jsii.get(self, "square"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="landscapeInput")
    def landscape_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationLandscape], jsii.get(self, "landscapeInput"))

    @builtins.property
    @jsii.member(jsii_name="portraitInput")
    def portrait_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationPortrait"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationPortrait"], jsii.get(self, "portraitInput"))

    @builtins.property
    @jsii.member(jsii_name="squareInput")
    def square_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationSquare"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationSquare"], jsii.get(self, "squareInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientation]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientation]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientation]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e5f81ecb7b29d7866c6022f2b00eeab66b317463645d0f877cd1d27c32917cc0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationPortrait",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationPortrait:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationPortrait(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationPortraitOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationPortraitOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d7fe725db5d1e4439084dec62e52871dc867bac83402d68d0416e7f44a7ad039)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationPortrait]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationPortrait], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationPortrait],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__42af8e9aa31d351907d5dd4aaeb85cc4553aa1d6f32376628cf710b09e512a4f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationSquare",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationSquare:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationSquare(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationSquareOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationSquareOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__65edc1af5ea7dea3a89f18c8ee603726a6d06832667314f947b16bd70e0d973a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationSquare]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationSquare], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationSquare],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__73f34d8173fde8ada8285cf7407df5ed5820d4ff97ea87121212be9ac3e6b304)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultImQuery",
    jsii_struct_bases=[],
    name_mapping={
        "allowed_transformations": "allowedTransformations",
        "query_var": "queryVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultImQuery:
    def __init__(
        self,
        *,
        allowed_transformations: typing.Sequence[builtins.str],
        query_var: builtins.str,
    ) -> None:
        '''
        :param allowed_transformations: Specifies the transformations that can be applied using the query string parameter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allowed_transformations DataAkamaiImagingPolicyImage#allowed_transformations}
        :param query_var: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#query_var DataAkamaiImagingPolicyImage#query_var}.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8755d50c853f5b952fd83b5403e4ada18bf017dfd47a9a18c7cd6157402a1868)
            check_type(argname="argument allowed_transformations", value=allowed_transformations, expected_type=type_hints["allowed_transformations"])
            check_type(argname="argument query_var", value=query_var, expected_type=type_hints["query_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "allowed_transformations": allowed_transformations,
            "query_var": query_var,
        }

    @builtins.property
    def allowed_transformations(self) -> typing.List[builtins.str]:
        '''Specifies the transformations that can be applied using the query string parameter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allowed_transformations DataAkamaiImagingPolicyImage#allowed_transformations}
        '''
        result = self._values.get("allowed_transformations")
        assert result is not None, "Required property 'allowed_transformations' is missing"
        return typing.cast(typing.List[builtins.str], result)

    @builtins.property
    def query_var(self) -> builtins.str:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#query_var DataAkamaiImagingPolicyImage#query_var}.'''
        result = self._values.get("query_var")
        assert result is not None, "Required property 'query_var' is missing"
        return typing.cast(builtins.str, result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultImQuery(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultImQueryList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultImQueryList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__16d1531aab1cdd782ebb85c52afda046ae8dd69dbb99a0f163d42fbdab18d70b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultImQueryOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__214228b1339946621ace7cd3403f82d85c677bf7c2d0691a19845e83332cb25a)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultImQueryOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6b078e8bcc0362131373170de1ba1c912845125690027d1295e347c3993d4e9a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d10e89a0299363f7612ba82bdb04ff9323d127572c43b699a6c106a7042dc13e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__75a4f7ed5aa568fb838205f59f35910fe4972cb831adf71fdfcb9b0c260b52c3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultImQuery]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultImQuery]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultImQuery]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__708dceae7aa14b823e32da5fd82e7b2a0b2f2800956137863ca12177a285e0a9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultImQueryOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultImQueryOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__28c310f64185161140415bd806d98ef0ff742d8d23e1cb05352d0fc7d89885c6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @builtins.property
    @jsii.member(jsii_name="allowedTransformationsInput")
    def allowed_transformations_input(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "allowedTransformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="queryVarInput")
    def query_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "queryVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowedTransformations")
    def allowed_transformations(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "allowedTransformations"))

    @allowed_transformations.setter
    def allowed_transformations(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__da637b42733f9acbb782d948f5ffbc8b609d13d8e126dc1556e678011757f74d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowedTransformations", value)

    @builtins.property
    @jsii.member(jsii_name="queryVar")
    def query_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "queryVar"))

    @query_var.setter
    def query_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__647f8d2e9a6af5da645786d92dc9338b142df5f0ce7025eab422c752e6e8e820)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "queryVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultImQuery]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultImQuery]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultImQuery]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2622a76df8f88b3b6459c19073930acd091405791a3ac79b07f6eb37a9e51001)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultMaxColors",
    jsii_struct_bases=[],
    name_mapping={"colors": "colors", "colors_var": "colorsVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultMaxColors:
    def __init__(
        self,
        *,
        colors: typing.Optional[builtins.str] = None,
        colors_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param colors: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        :param colors_var: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f6f99a9cc4d8c756808e75803e329a568e425242a73c3cc215348165319616e)
            check_type(argname="argument colors", value=colors, expected_type=type_hints["colors"])
            check_type(argname="argument colors_var", value=colors_var, expected_type=type_hints["colors_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if colors is not None:
            self._values["colors"] = colors
        if colors_var is not None:
            self._values["colors_var"] = colors_var

    @builtins.property
    def colors(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        '''
        result = self._values.get("colors")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def colors_var(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        result = self._values.get("colors_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultMaxColors(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultMaxColorsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultMaxColorsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4e527fdacf2ce4798f16989d0551c99cdacf83fc71d2bfb3ba470ad3bd2725b1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultMaxColorsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8bbeaaa0aec092a5a074aa192fcf849ee759a1af21d37223f19350eaae30bef8)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultMaxColorsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0f93046644b19098206a256bf336455220810a413b2cd97dec184ee49a922207)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6ed5d0f70104ff88e0c94aa849694c5fd4f0b5d02c59cd05e324ffe479602376)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__049c672e327c0d5f61ec856b6de84f7ef7dcdadd3be57efa062483db191437db)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultMaxColors]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultMaxColors]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3abb7db32d40154347f5358f297d95f9252d5137d8cc7c5853beab13409b4fd7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultMaxColorsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultMaxColorsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__473ab3b60b49a257fc7a788a0890b78661f7207020786ad3cdf615f7f9bdf4c9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColors")
    def reset_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColors", []))

    @jsii.member(jsii_name="resetColorsVar")
    def reset_colors_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorsVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorsInput")
    def colors_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsInput"))

    @builtins.property
    @jsii.member(jsii_name="colorsVarInput")
    def colors_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsVarInput"))

    @builtins.property
    @jsii.member(jsii_name="colors")
    def colors(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colors"))

    @colors.setter
    def colors(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8c1e79558c0b8980da75a0183ea448606db4752820b2795fb2ec84c5399fe007)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colors", value)

    @builtins.property
    @jsii.member(jsii_name="colorsVar")
    def colors_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorsVar"))

    @colors_var.setter
    def colors_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__16401bbc7c20eaf4df240448a49d621cfa1dd7e2bc77b25e136bd526b92b16f1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorsVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultMaxColors]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultMaxColors]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultMaxColors]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9172fc1e9fc2b820346b60b0fcc2bc3d307290da6a8a3daf6c54bc61b398cd6c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultMirror",
    jsii_struct_bases=[],
    name_mapping={
        "horizontal": "horizontal",
        "horizontal_var": "horizontalVar",
        "vertical": "vertical",
        "vertical_var": "verticalVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultMirror:
    def __init__(
        self,
        *,
        horizontal: typing.Optional[builtins.str] = None,
        horizontal_var: typing.Optional[builtins.str] = None,
        vertical: typing.Optional[builtins.str] = None,
        vertical_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param horizontal: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        :param horizontal_var: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        :param vertical: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        :param vertical_var: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__da1fd64a2fa5bcd7c27348588e822d1822c1f80b772ab9a2b5869ba85aa0805c)
            check_type(argname="argument horizontal", value=horizontal, expected_type=type_hints["horizontal"])
            check_type(argname="argument horizontal_var", value=horizontal_var, expected_type=type_hints["horizontal_var"])
            check_type(argname="argument vertical", value=vertical, expected_type=type_hints["vertical"])
            check_type(argname="argument vertical_var", value=vertical_var, expected_type=type_hints["vertical_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if horizontal is not None:
            self._values["horizontal"] = horizontal
        if horizontal_var is not None:
            self._values["horizontal_var"] = horizontal_var
        if vertical is not None:
            self._values["vertical"] = vertical
        if vertical_var is not None:
            self._values["vertical_var"] = vertical_var

    @builtins.property
    def horizontal(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        '''
        result = self._values.get("horizontal")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def horizontal_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        '''
        result = self._values.get("horizontal_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        '''
        result = self._values.get("vertical")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        result = self._values.get("vertical_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultMirror(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultMirrorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultMirrorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__49cb25c0f8613e0c9ea62437e1e92afa77d1839dc8386938a52c20d5bc7d355a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultMirrorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7386cc574b610e68ed4b8af37dd4b15e2186eab5c0fe93b0e4ddd0b75ef1a329)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultMirrorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9f9bf6a1e120b408179dd2485f2028dd776778faf495441fe250755a7af0edab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__325a3af13e36cc0c58c67782cabca3b14f3496428642e822eac14a514183ff70)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4f548b7f53c68f1878bc88974ed3e49bbc1408ffa500f6c7ca9a3eef5f107844)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultMirror]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultMirror]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__601b3125b81886a73f47e2ef7e9bfd48d1b8f6a090249d1cc1fc40bfaf01d3ac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultMirrorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultMirrorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1888405c0ce6d3d1ff64125e8fbdf5ddf61a7432b210ffd5553ec9ed2374b60e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHorizontal")
    def reset_horizontal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontal", []))

    @jsii.member(jsii_name="resetHorizontalVar")
    def reset_horizontal_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontalVar", []))

    @jsii.member(jsii_name="resetVertical")
    def reset_vertical(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVertical", []))

    @jsii.member(jsii_name="resetVerticalVar")
    def reset_vertical_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVerticalVar", []))

    @builtins.property
    @jsii.member(jsii_name="horizontalInput")
    def horizontal_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontalVarInput")
    def horizontal_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalInput")
    def vertical_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalVarInput")
    def vertical_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontal")
    def horizontal(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontal"))

    @horizontal.setter
    def horizontal(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a76fd625e18623de2fcc9fcbd49b0a13860f669ed3596f046ec0ca2299244e1c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontal", value)

    @builtins.property
    @jsii.member(jsii_name="horizontalVar")
    def horizontal_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontalVar"))

    @horizontal_var.setter
    def horizontal_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d6f710d4fc92b4c4822207631eda78d2b11b8e12e34551b79776db0109aa01ba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontalVar", value)

    @builtins.property
    @jsii.member(jsii_name="vertical")
    def vertical(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "vertical"))

    @vertical.setter
    def vertical(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__203ba0851eed6cae28fdf4d9e5746c8504d239371844c25ec21e7c57fd7fff25)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "vertical", value)

    @builtins.property
    @jsii.member(jsii_name="verticalVar")
    def vertical_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "verticalVar"))

    @vertical_var.setter
    def vertical_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a149a198ff3909c616df79ee3b5456e7fed9c8c1ebb05b6363baceebea8ab6d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "verticalVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultMirror]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultMirror]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultMirror]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0782614cb7002e2257d76731301b690684bae9dff665842fb9f8364600f2d3f3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultMonoHue",
    jsii_struct_bases=[],
    name_mapping={"hue": "hue", "hue_var": "hueVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultMonoHue:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__830a27838c71f7edac3714137c47358038866888516acb7c86d26badd74e7aea)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultMonoHue(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultMonoHueList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultMonoHueList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9436bef05fcd3bc7b8ab6b1d04eb6ad29ef9e89e407dfa7886154ef5aa0ac7c2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultMonoHueOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__814faccc53b36bc4a03fcbbb321d83b2c3f9a0ee3e883ebb962712fa81f78c27)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultMonoHueOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__44307cf164a2a549028c638c2daa0f8ff5fe75244f734decc8f08fb6b48d21f8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__312861dcd837e14cfab636e63df36def89b4e96ac243436e83fd4b2bd4d3caad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a9927ef1b1fc50b9ab38d6709d3410210661e06ee2f5d170b001a65bff3dcdab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultMonoHue]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultMonoHue]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0f9b8f72b6cefe9b6c4483c3eb25fe3ed4ebfd8c0e0b4818fbf97ade4b0eff79)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultMonoHueOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultMonoHueOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d3d8be1ceafa95605fbebb3f0a074d9de32045052e7d861f4df38f4a0814577a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5da1e9509344928d95914edbcb182f79258c50b46ebb43493bd688c3ce1dab53)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac786c1efa14ac13dae2cf4f1e393a147ae82ef984ecaccf5713269de4964a4a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultMonoHue]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultMonoHue]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultMonoHue]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__db375be75d45482d783517329788e3b7180278d576ee818562aad0a615305dcd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultOpacity",
    jsii_struct_bases=[],
    name_mapping={"opacity": "opacity", "opacity_var": "opacityVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultOpacity:
    def __init__(
        self,
        *,
        opacity: typing.Optional[builtins.str] = None,
        opacity_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param opacity: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param opacity_var: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc119bc2c48264db1a88c01d9bfe5e6dbc0322ae32014a9d52de053a2b670fb4)
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument opacity_var", value=opacity_var, expected_type=type_hints["opacity_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if opacity is not None:
            self._values["opacity"] = opacity
        if opacity_var is not None:
            self._values["opacity_var"] = opacity_var

    @builtins.property
    def opacity(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def opacity_var(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        result = self._values.get("opacity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultOpacity(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultOpacityList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultOpacityList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__42359f026e04760a7b7236b45846bcb5808b3b62020317ef45b398f884cc10cc)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultOpacityOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__241b25a03d46c34fbe3cf3971bb969d9dd4e2b92407465e387128da00adc7614)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultOpacityOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__419288ddef1e2f6c6dc8f4a5e5d669d9bf04d558ed6ac9e8dbafa7a112e0080e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ffac7f16534109f7edb3e2efff2c89bfcd9350a10cf8bd980890a206e19772ef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__46676bd499664c7ce061b875d7a0e06199346b5f7837fa31d1ef7b6be9dc7fbb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultOpacity]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultOpacity]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__438330fb4c486d015d3046da7f7224f701ac0c447e444719e475b42d577bc34f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultOpacityOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultOpacityOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3c4ee927ead8bb5ff01819d81ae73d21e7501112e4d66adb6cf2ebcc47d431fa)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetOpacityVar")
    def reset_opacity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacityVar", []))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityVarInput")
    def opacity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacity"))

    @opacity.setter
    def opacity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f28ec25ce1fb8b92ba6fcaa2e1c80f8acabbf3a6cc6e936c64ec513fc94e836d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacity", value)

    @builtins.property
    @jsii.member(jsii_name="opacityVar")
    def opacity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacityVar"))

    @opacity_var.setter
    def opacity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__65f859da519e9b91e7bc57f102d600309b79892967a5724299d29910f96952c4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacityVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultOpacity]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultOpacity]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultOpacity]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__70fb011ca06305901eca00ed2d6eeb5a744a59952e03028a3f1e2b34865f6a53)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__893a4197615c74accdbde134092256a15753089715e17d66429c587736e06de3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putAppend")
    def put_append(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultAppend, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f17672a71fcaabd1d6447c18611920547457e8bf14fda840c672475b1deb4e83)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putAppend", [value]))

    @jsii.member(jsii_name="putAspectCrop")
    def put_aspect_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultAspectCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dcc487b96268b2eb32be4c82492b70bc2ca926f8a0d686cd5453fea6870db319)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putAspectCrop", [value]))

    @jsii.member(jsii_name="putBackgroundColor")
    def put_background_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c6b4ab85cc3fc2e8e40b1e80154bbfdb2025faff5bb03d91acc5ef089527e113)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBackgroundColor", [value]))

    @jsii.member(jsii_name="putBlur")
    def put_blur(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultBlur, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a11b910ad26b86803f76630324e6c0a0a35910fbd50082196ed12d05eb753d5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBlur", [value]))

    @jsii.member(jsii_name="putChromaKey")
    def put_chroma_key(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultChromaKey, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1a0288daecca3db9a7874c74f3f1d633d5adcc369f2fca0086b967ca8cace341)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putChromaKey", [value]))

    @jsii.member(jsii_name="putComposite")
    def put_composite(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultComposite, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__893d8af11016dc16297e530e1e540e90d8c78988c632cb857915fe6e47a98c46)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putComposite", [value]))

    @jsii.member(jsii_name="putCompound")
    def put_compound(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCompound, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4afe3e24280cdebdf7812f0894bfb050f37be1501e1cea212a32d061e94d5ca5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCompound", [value]))

    @jsii.member(jsii_name="putContrast")
    def put_contrast(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultContrast, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a52d2bd0a3e1bbc20d11e59333bc3ca81b87801b632c46ed774957fc89e3521)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putContrast", [value]))

    @jsii.member(jsii_name="putCrop")
    def put_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__73a9a472fbee34aa6f2e61e8989b66b495f72adba8c592227ceb55bda29658e0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCrop", [value]))

    @jsii.member(jsii_name="putFaceCrop")
    def put_face_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultFaceCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__03c2613e5924d25b672d541522239d0806b083eaa5a2325f6f80f816b7a57276)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFaceCrop", [value]))

    @jsii.member(jsii_name="putFeatureCrop")
    def put_feature_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultFeatureCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc65286d29f472b16774bb0bed64cc9dad4d49e2fb3d6f389947f506c8ef7f6b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFeatureCrop", [value]))

    @jsii.member(jsii_name="putFitAndFill")
    def put_fit_and_fill(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultFitAndFill, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f900ea439e777e0d9ed71473c3d1c54505510be546f11a5b420de5f8dcc93314)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFitAndFill", [value]))

    @jsii.member(jsii_name="putGoop")
    def put_goop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultGoop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ebfa4cc4d95b8f21b3da3356332fa0d0ad98f54b66d13681b8eca45683357ce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGoop", [value]))

    @jsii.member(jsii_name="putGrayscale")
    def put_grayscale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultGrayscale, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3d2be84ebf0ebefa7f5ee309ea5f0395f3e7d2b8ffd2cf218bc310fc50491c0d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGrayscale", [value]))

    @jsii.member(jsii_name="putHsl")
    def put_hsl(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultHsl, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a29c9e9de77a0d62f40bd6b4d9ac2f018b5dd44e9cc68fcd6fc12cd279b967b6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsl", [value]))

    @jsii.member(jsii_name="putHsv")
    def put_hsv(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultHsv, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__51b4782ac3eb1382ba32f5eff4c9b5a6acf0ee7e80d7a591191154b4d88e8a05)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsv", [value]))

    @jsii.member(jsii_name="putIfDimension")
    def put_if_dimension(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimension, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dbebe462ab43d25ebe5ea5e4a15e3b2db8e0a9c8ee4c5b607d4a644e47103f27)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfDimension", [value]))

    @jsii.member(jsii_name="putIfOrientation")
    def put_if_orientation(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c956798c50e015a4f8980fd996c06881f2f553c2fa308e5f1bd58c037b95bb05)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfOrientation", [value]))

    @jsii.member(jsii_name="putImQuery")
    def put_im_query(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultImQuery, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d9644fe9b0c926980f0600854aaf29fe9fc5b4fb18a8ec36ddbd15e17033a156)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putImQuery", [value]))

    @jsii.member(jsii_name="putMaxColors")
    def put_max_colors(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultMaxColors, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__40ab83fd655c2aaf99cc10f80f66825985620caa252c78e286a5cfb481891e91)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMaxColors", [value]))

    @jsii.member(jsii_name="putMirror")
    def put_mirror(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultMirror, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8de09bc61647d4cf10d2d020516272bb2c9291918a175e6290adeb3b6a17c792)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMirror", [value]))

    @jsii.member(jsii_name="putMonoHue")
    def put_mono_hue(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultMonoHue, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b4f0a0810129f1290196a9916b48176bdb681c3a84c9957950fb353fe4f3daeb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMonoHue", [value]))

    @jsii.member(jsii_name="putOpacity")
    def put_opacity(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultOpacity, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f478b80abe1f3243da61a1ad2cf7efcd552192c61d94faf05cf5e59dde03b922)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putOpacity", [value]))

    @jsii.member(jsii_name="putRegionOfInterestCrop")
    def put_region_of_interest_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRegionOfInterestCrop", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab28dd730740c1444fa6bd267c2dfb76a6b4c43b90329653cce7876611b87671)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRegionOfInterestCrop", [value]))

    @jsii.member(jsii_name="putRelativeCrop")
    def put_relative_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRelativeCrop", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a917d8a6230c68a2f2317ff97070936a1ee466a176c30f39ee4d96e00a0d4ebd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRelativeCrop", [value]))

    @jsii.member(jsii_name="putRemoveColor")
    def put_remove_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRemoveColor", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3bdfc5a5d616b09c7302dc39fa581d329174338b44efb7393be5aece4d92ba14)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRemoveColor", [value]))

    @jsii.member(jsii_name="putResize")
    def put_resize(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultResize", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b090dc5fed38c1c49cd19cbf2de1be009d1f6e809100995a9b3d4745a210ce4c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putResize", [value]))

    @jsii.member(jsii_name="putRotate")
    def put_rotate(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRotate", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__64f258140c3149a58e402c894aeaae771a40d8ef8e017e1720a6460bd65a211a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRotate", [value]))

    @jsii.member(jsii_name="putScale")
    def put_scale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultScale", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__34c7a9c89d8d5d0adb2f51e9be2861bcdf516ec59afee71cf1b80d92b6304ea4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putScale", [value]))

    @jsii.member(jsii_name="putShear")
    def put_shear(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultShear", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__56bfb93bbd8fb05031ef6b3792efcaacae344b76f86f34283f88168b4ee9dc77)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putShear", [value]))

    @jsii.member(jsii_name="putTrim")
    def put_trim(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultTrim", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__999661e5d29e5eba5107ee41e23de23071a5a4afebd584360769e404b3ef1ee3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTrim", [value]))

    @jsii.member(jsii_name="putUnsharpMask")
    def put_unsharp_mask(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultUnsharpMask", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cc796741ddd1356d874d47cd51440169e5639a5d3319740e7dd797cdd6a50e32)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putUnsharpMask", [value]))

    @jsii.member(jsii_name="resetAppend")
    def reset_append(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAppend", []))

    @jsii.member(jsii_name="resetAspectCrop")
    def reset_aspect_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspectCrop", []))

    @jsii.member(jsii_name="resetBackgroundColor")
    def reset_background_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBackgroundColor", []))

    @jsii.member(jsii_name="resetBlur")
    def reset_blur(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBlur", []))

    @jsii.member(jsii_name="resetChromaKey")
    def reset_chroma_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChromaKey", []))

    @jsii.member(jsii_name="resetComposite")
    def reset_composite(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetComposite", []))

    @jsii.member(jsii_name="resetCompound")
    def reset_compound(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCompound", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetCrop")
    def reset_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCrop", []))

    @jsii.member(jsii_name="resetFaceCrop")
    def reset_face_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFaceCrop", []))

    @jsii.member(jsii_name="resetFeatureCrop")
    def reset_feature_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureCrop", []))

    @jsii.member(jsii_name="resetFitAndFill")
    def reset_fit_and_fill(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFitAndFill", []))

    @jsii.member(jsii_name="resetGoop")
    def reset_goop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGoop", []))

    @jsii.member(jsii_name="resetGrayscale")
    def reset_grayscale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGrayscale", []))

    @jsii.member(jsii_name="resetHsl")
    def reset_hsl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsl", []))

    @jsii.member(jsii_name="resetHsv")
    def reset_hsv(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsv", []))

    @jsii.member(jsii_name="resetIfDimension")
    def reset_if_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfDimension", []))

    @jsii.member(jsii_name="resetIfOrientation")
    def reset_if_orientation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfOrientation", []))

    @jsii.member(jsii_name="resetImQuery")
    def reset_im_query(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetImQuery", []))

    @jsii.member(jsii_name="resetMaxColors")
    def reset_max_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxColors", []))

    @jsii.member(jsii_name="resetMirror")
    def reset_mirror(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMirror", []))

    @jsii.member(jsii_name="resetMonoHue")
    def reset_mono_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonoHue", []))

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetRegionOfInterestCrop")
    def reset_region_of_interest_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRegionOfInterestCrop", []))

    @jsii.member(jsii_name="resetRelativeCrop")
    def reset_relative_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRelativeCrop", []))

    @jsii.member(jsii_name="resetRemoveColor")
    def reset_remove_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRemoveColor", []))

    @jsii.member(jsii_name="resetResize")
    def reset_resize(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetResize", []))

    @jsii.member(jsii_name="resetRotate")
    def reset_rotate(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRotate", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetShear")
    def reset_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetShear", []))

    @jsii.member(jsii_name="resetTrim")
    def reset_trim(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTrim", []))

    @jsii.member(jsii_name="resetUnsharpMask")
    def reset_unsharp_mask(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUnsharpMask", []))

    @builtins.property
    @jsii.member(jsii_name="append")
    def append(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultAppendList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultAppendList, jsii.get(self, "append"))

    @builtins.property
    @jsii.member(jsii_name="aspectCrop")
    def aspect_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultAspectCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultAspectCropList, jsii.get(self, "aspectCrop"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColor")
    def background_color(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultBackgroundColorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultBackgroundColorList, jsii.get(self, "backgroundColor"))

    @builtins.property
    @jsii.member(jsii_name="blur")
    def blur(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultBlurList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultBlurList, jsii.get(self, "blur"))

    @builtins.property
    @jsii.member(jsii_name="chromaKey")
    def chroma_key(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultChromaKeyList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultChromaKeyList, jsii.get(self, "chromaKey"))

    @builtins.property
    @jsii.member(jsii_name="composite")
    def composite(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCompositeList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCompositeList, jsii.get(self, "composite"))

    @builtins.property
    @jsii.member(jsii_name="compound")
    def compound(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCompoundList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCompoundList, jsii.get(self, "compound"))

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultContrastList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultContrastList, jsii.get(self, "contrast"))

    @builtins.property
    @jsii.member(jsii_name="crop")
    def crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCropList, jsii.get(self, "crop"))

    @builtins.property
    @jsii.member(jsii_name="faceCrop")
    def face_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultFaceCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultFaceCropList, jsii.get(self, "faceCrop"))

    @builtins.property
    @jsii.member(jsii_name="featureCrop")
    def feature_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultFeatureCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultFeatureCropList, jsii.get(self, "featureCrop"))

    @builtins.property
    @jsii.member(jsii_name="fitAndFill")
    def fit_and_fill(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultFitAndFillList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultFitAndFillList, jsii.get(self, "fitAndFill"))

    @builtins.property
    @jsii.member(jsii_name="goop")
    def goop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultGoopList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultGoopList, jsii.get(self, "goop"))

    @builtins.property
    @jsii.member(jsii_name="grayscale")
    def grayscale(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultGrayscaleList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultGrayscaleList, jsii.get(self, "grayscale"))

    @builtins.property
    @jsii.member(jsii_name="hsl")
    def hsl(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultHslList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultHslList, jsii.get(self, "hsl"))

    @builtins.property
    @jsii.member(jsii_name="hsv")
    def hsv(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultHsvList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultHsvList, jsii.get(self, "hsv"))

    @builtins.property
    @jsii.member(jsii_name="ifDimension")
    def if_dimension(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionList, jsii.get(self, "ifDimension"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientation")
    def if_orientation(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationList, jsii.get(self, "ifOrientation"))

    @builtins.property
    @jsii.member(jsii_name="imQuery")
    def im_query(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultImQueryList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultImQueryList, jsii.get(self, "imQuery"))

    @builtins.property
    @jsii.member(jsii_name="maxColors")
    def max_colors(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultMaxColorsList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultMaxColorsList, jsii.get(self, "maxColors"))

    @builtins.property
    @jsii.member(jsii_name="mirror")
    def mirror(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultMirrorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultMirrorList, jsii.get(self, "mirror"))

    @builtins.property
    @jsii.member(jsii_name="monoHue")
    def mono_hue(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultMonoHueList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultMonoHueList, jsii.get(self, "monoHue"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultOpacityList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultOpacityList, jsii.get(self, "opacity"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestCrop")
    def region_of_interest_crop(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRegionOfInterestCropList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRegionOfInterestCropList", jsii.get(self, "regionOfInterestCrop"))

    @builtins.property
    @jsii.member(jsii_name="relativeCrop")
    def relative_crop(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRelativeCropList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRelativeCropList", jsii.get(self, "relativeCrop"))

    @builtins.property
    @jsii.member(jsii_name="removeColor")
    def remove_color(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRemoveColorList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRemoveColorList", jsii.get(self, "removeColor"))

    @builtins.property
    @jsii.member(jsii_name="resize")
    def resize(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultResizeList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultResizeList", jsii.get(self, "resize"))

    @builtins.property
    @jsii.member(jsii_name="rotate")
    def rotate(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRotateList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRotateList", jsii.get(self, "rotate"))

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultScaleList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultScaleList", jsii.get(self, "scale"))

    @builtins.property
    @jsii.member(jsii_name="shear")
    def shear(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultShearList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultShearList", jsii.get(self, "shear"))

    @builtins.property
    @jsii.member(jsii_name="trim")
    def trim(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultTrimList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultTrimList", jsii.get(self, "trim"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMask")
    def unsharp_mask(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultUnsharpMaskList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultUnsharpMaskList", jsii.get(self, "unsharpMask"))

    @builtins.property
    @jsii.member(jsii_name="appendInput")
    def append_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultAppend]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultAppend]]], jsii.get(self, "appendInput"))

    @builtins.property
    @jsii.member(jsii_name="aspectCropInput")
    def aspect_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultAspectCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultAspectCrop]]], jsii.get(self, "aspectCropInput"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColorInput")
    def background_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultBackgroundColor]]], jsii.get(self, "backgroundColorInput"))

    @builtins.property
    @jsii.member(jsii_name="blurInput")
    def blur_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultBlur]]], jsii.get(self, "blurInput"))

    @builtins.property
    @jsii.member(jsii_name="chromaKeyInput")
    def chroma_key_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultChromaKey]]], jsii.get(self, "chromaKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="compositeInput")
    def composite_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultComposite]]], jsii.get(self, "compositeInput"))

    @builtins.property
    @jsii.member(jsii_name="compoundInput")
    def compound_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCompound]]], jsii.get(self, "compoundInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultContrast]]], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="cropInput")
    def crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCrop]]], jsii.get(self, "cropInput"))

    @builtins.property
    @jsii.member(jsii_name="faceCropInput")
    def face_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultFaceCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultFaceCrop]]], jsii.get(self, "faceCropInput"))

    @builtins.property
    @jsii.member(jsii_name="featureCropInput")
    def feature_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultFeatureCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultFeatureCrop]]], jsii.get(self, "featureCropInput"))

    @builtins.property
    @jsii.member(jsii_name="fitAndFillInput")
    def fit_and_fill_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultFitAndFill]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultFitAndFill]]], jsii.get(self, "fitAndFillInput"))

    @builtins.property
    @jsii.member(jsii_name="goopInput")
    def goop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultGoop]]], jsii.get(self, "goopInput"))

    @builtins.property
    @jsii.member(jsii_name="grayscaleInput")
    def grayscale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultGrayscale]]], jsii.get(self, "grayscaleInput"))

    @builtins.property
    @jsii.member(jsii_name="hslInput")
    def hsl_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultHsl]]], jsii.get(self, "hslInput"))

    @builtins.property
    @jsii.member(jsii_name="hsvInput")
    def hsv_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultHsv]]], jsii.get(self, "hsvInput"))

    @builtins.property
    @jsii.member(jsii_name="ifDimensionInput")
    def if_dimension_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimension]]], jsii.get(self, "ifDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientationInput")
    def if_orientation_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientation]]], jsii.get(self, "ifOrientationInput"))

    @builtins.property
    @jsii.member(jsii_name="imQueryInput")
    def im_query_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultImQuery]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultImQuery]]], jsii.get(self, "imQueryInput"))

    @builtins.property
    @jsii.member(jsii_name="maxColorsInput")
    def max_colors_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultMaxColors]]], jsii.get(self, "maxColorsInput"))

    @builtins.property
    @jsii.member(jsii_name="mirrorInput")
    def mirror_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultMirror]]], jsii.get(self, "mirrorInput"))

    @builtins.property
    @jsii.member(jsii_name="monoHueInput")
    def mono_hue_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultMonoHue]]], jsii.get(self, "monoHueInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultOpacity]]], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestCropInput")
    def region_of_interest_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRegionOfInterestCrop"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRegionOfInterestCrop"]]], jsii.get(self, "regionOfInterestCropInput"))

    @builtins.property
    @jsii.member(jsii_name="relativeCropInput")
    def relative_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRelativeCrop"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRelativeCrop"]]], jsii.get(self, "relativeCropInput"))

    @builtins.property
    @jsii.member(jsii_name="removeColorInput")
    def remove_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRemoveColor"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRemoveColor"]]], jsii.get(self, "removeColorInput"))

    @builtins.property
    @jsii.member(jsii_name="resizeInput")
    def resize_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultResize"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultResize"]]], jsii.get(self, "resizeInput"))

    @builtins.property
    @jsii.member(jsii_name="rotateInput")
    def rotate_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRotate"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRotate"]]], jsii.get(self, "rotateInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultScale"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultScale"]]], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="shearInput")
    def shear_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultShear"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultShear"]]], jsii.get(self, "shearInput"))

    @builtins.property
    @jsii.member(jsii_name="trimInput")
    def trim_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultTrim"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultTrim"]]], jsii.get(self, "trimInput"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMaskInput")
    def unsharp_mask_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultUnsharpMask"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultUnsharpMask"]]], jsii.get(self, "unsharpMaskInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__330209aa8e20ab3550addb0a239befe76a34df39976f75ac69f83d53c3c05261)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRegionOfInterestCrop",
    jsii_struct_bases=[],
    name_mapping={
        "region_of_interest": "regionOfInterest",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRegionOfInterestCrop:
    def __init__(
        self,
        *,
        region_of_interest: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRegionOfInterestCropRegionOfInterest", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param region_of_interest: region_of_interest block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest DataAkamaiImagingPolicyImage#region_of_interest}
        :param gravity: The placement of the crop area relative to the specified area of interest. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: The placement of the crop area relative to the specified area of interest. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param style: Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(region_of_interest, dict):
            region_of_interest = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRegionOfInterestCropRegionOfInterest(**region_of_interest)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d77bd4e3906b1b809b81f52667b46b4d7c9bc3456b19da8245a0ee8daac8801)
            check_type(argname="argument region_of_interest", value=region_of_interest, expected_type=type_hints["region_of_interest"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "region_of_interest": region_of_interest,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def region_of_interest(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRegionOfInterestCropRegionOfInterest":
        '''region_of_interest block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest DataAkamaiImagingPolicyImage#region_of_interest}
        '''
        result = self._values.get("region_of_interest")
        assert result is not None, "Required property 'region_of_interest' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRegionOfInterestCropRegionOfInterest", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''The placement of the crop area relative to the specified area of interest.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''The placement of the crop area relative to the specified area of interest.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRegionOfInterestCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRegionOfInterestCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRegionOfInterestCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9f681b7ba14a9b95b6e614981391f877b6b3cef9fe3ea53ca5f1f374686712fd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRegionOfInterestCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ddecc14242bfbe700a0413a7dd29b99d4bfe35adc379226d83b2c7330b9e71b)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRegionOfInterestCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5dc22b8a3a3e15b9e8704086d7673aa3b3755c73725778b55488db4f2da78295)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__75cee3c5b0d34ae3632f2edd2b2c672e2f291bdf181560fb9fb9c812a2accc3e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d7187ae10a7da3bcec5495bc5a79a05ad1f700ad9458f5696be91d9f6c57079f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRegionOfInterestCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRegionOfInterestCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRegionOfInterestCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__abb51ab61664f9b1dab3fdc1c4f28a3ea84180b6fec6313bbee95e13ff8dea9b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRegionOfInterestCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRegionOfInterestCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a156d79c2f48ff0fdaebeec43cd797e89c4d48d28cb959caeee6f4598aea0a0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putRegionOfInterest")
    def put_region_of_interest(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRegionOfInterestCropRegionOfInterest()

        return typing.cast(None, jsii.invoke(self, "putRegionOfInterest", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterest")
    def region_of_interest(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRegionOfInterestCropRegionOfInterestOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRegionOfInterestCropRegionOfInterestOutputReference", jsii.get(self, "regionOfInterest"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestInput")
    def region_of_interest_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRegionOfInterestCropRegionOfInterest"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRegionOfInterestCropRegionOfInterest"], jsii.get(self, "regionOfInterestInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac078922004f6a81c4d2c16ee69626d3cda8d2a5dd71777bacf72707fc6017dc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__69490047c38a6ce54d5c6fe3b3b40d7b9f8b0268c78f3a8bf98778c2fa1595cc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8b344a38ffbcd32fef54bc7eef7127f289d939c7aa43f6a48e35c04ae4cd712c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9fbb5cbb01cfae32a41b64759e41cc874ab99dbbb5c54d6ba470572b3bccc8a7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea79511a89825135a3aad611da80cbe177d212811ed5bb35fb18ff75ba3f7d63)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb4be0e0ece9a98a2c9f81ecbe3e98148842f47e2a8c10682c059390304e32c4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0433291b3fa2ee92232af940d03be212302a97ce6df0b986ee370291d7481ad8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__60370bb18b71035e147bdd8e21ec5f6f733b9926ba8980d2c0be36b42f21a521)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRegionOfInterestCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRegionOfInterestCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRegionOfInterestCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__283328e2a437f2e697323f497be964c5350977ec32fd0c59afe3fa8d5ff87625)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRegionOfInterestCropRegionOfInterest",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRegionOfInterestCropRegionOfInterest:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRegionOfInterestCropRegionOfInterest(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRegionOfInterestCropRegionOfInterestOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRegionOfInterestCropRegionOfInterestOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ba2d6c3f80d29504a5a1896b00ba33611abce71d4dc5224cadf27c4003590fe1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRegionOfInterestCropRegionOfInterest]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRegionOfInterestCropRegionOfInterest], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRegionOfInterestCropRegionOfInterest],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__55d7ae17a22bcb04fccea2cf14a292c3186166270be7b7cac60da4dcb72db5ff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRelativeCrop",
    jsii_struct_bases=[],
    name_mapping={
        "east": "east",
        "east_var": "eastVar",
        "north": "north",
        "north_var": "northVar",
        "south": "south",
        "south_var": "southVar",
        "west": "west",
        "west_var": "westVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRelativeCrop:
    def __init__(
        self,
        *,
        east: typing.Optional[builtins.str] = None,
        east_var: typing.Optional[builtins.str] = None,
        north: typing.Optional[builtins.str] = None,
        north_var: typing.Optional[builtins.str] = None,
        south: typing.Optional[builtins.str] = None,
        south_var: typing.Optional[builtins.str] = None,
        west: typing.Optional[builtins.str] = None,
        west_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param east: The number of pixels to shrink or expand the right side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east DataAkamaiImagingPolicyImage#east}
        :param east_var: The number of pixels to shrink or expand the right side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east_var DataAkamaiImagingPolicyImage#east_var}
        :param north: The number of pixels to shrink or expand the top side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north DataAkamaiImagingPolicyImage#north}
        :param north_var: The number of pixels to shrink or expand the top side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north_var DataAkamaiImagingPolicyImage#north_var}
        :param south: The number of pixels to shrink or expand the bottom side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south DataAkamaiImagingPolicyImage#south}
        :param south_var: The number of pixels to shrink or expand the bottom side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south_var DataAkamaiImagingPolicyImage#south_var}
        :param west: The number of pixels to shrink or expand the left side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west DataAkamaiImagingPolicyImage#west}
        :param west_var: The number of pixels to shrink or expand the left side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west_var DataAkamaiImagingPolicyImage#west_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__62a0003db5aac8ee19b2b0c78ee0b40444751b35e404a208047f746c78836494)
            check_type(argname="argument east", value=east, expected_type=type_hints["east"])
            check_type(argname="argument east_var", value=east_var, expected_type=type_hints["east_var"])
            check_type(argname="argument north", value=north, expected_type=type_hints["north"])
            check_type(argname="argument north_var", value=north_var, expected_type=type_hints["north_var"])
            check_type(argname="argument south", value=south, expected_type=type_hints["south"])
            check_type(argname="argument south_var", value=south_var, expected_type=type_hints["south_var"])
            check_type(argname="argument west", value=west, expected_type=type_hints["west"])
            check_type(argname="argument west_var", value=west_var, expected_type=type_hints["west_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if east is not None:
            self._values["east"] = east
        if east_var is not None:
            self._values["east_var"] = east_var
        if north is not None:
            self._values["north"] = north
        if north_var is not None:
            self._values["north_var"] = north_var
        if south is not None:
            self._values["south"] = south
        if south_var is not None:
            self._values["south_var"] = south_var
        if west is not None:
            self._values["west"] = west
        if west_var is not None:
            self._values["west_var"] = west_var

    @builtins.property
    def east(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the right side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east DataAkamaiImagingPolicyImage#east}
        '''
        result = self._values.get("east")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def east_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the right side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east_var DataAkamaiImagingPolicyImage#east_var}
        '''
        result = self._values.get("east_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def north(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the top side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north DataAkamaiImagingPolicyImage#north}
        '''
        result = self._values.get("north")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def north_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the top side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north_var DataAkamaiImagingPolicyImage#north_var}
        '''
        result = self._values.get("north_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def south(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the bottom side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south DataAkamaiImagingPolicyImage#south}
        '''
        result = self._values.get("south")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def south_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the bottom side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south_var DataAkamaiImagingPolicyImage#south_var}
        '''
        result = self._values.get("south_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def west(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the left side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west DataAkamaiImagingPolicyImage#west}
        '''
        result = self._values.get("west")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def west_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the left side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west_var DataAkamaiImagingPolicyImage#west_var}
        '''
        result = self._values.get("west_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRelativeCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRelativeCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRelativeCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ff15787931ae1c298427f1f6383a17c0e72dd54bc7b1731cb06881e8b7c6cbd5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRelativeCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__279907c72d52ec4a0e63b2fa33cc9dc033e21447774849574c4682eb71679a1d)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRelativeCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9c3821d343c0e221efb570219a19837d43936c019f587355ad74b36facc6fbc1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f17f57c7ddfdc275f3cb47736cddcd52c02f264d07f4b33241d1d98f03df743e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7aabcaa77c2e8199d155a9adb30da92522cf4742f78bd425438f645e330e1340)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRelativeCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRelativeCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRelativeCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2986d85850e781708e57b01b0785ab2e0bc916a50bb0fcbbf0f626050bc790fe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRelativeCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRelativeCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__15189306ae820f17bbeafdf47227c8db86d68f0ba581d8bce1aab04656224fef)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetEast")
    def reset_east(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEast", []))

    @jsii.member(jsii_name="resetEastVar")
    def reset_east_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEastVar", []))

    @jsii.member(jsii_name="resetNorth")
    def reset_north(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNorth", []))

    @jsii.member(jsii_name="resetNorthVar")
    def reset_north_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNorthVar", []))

    @jsii.member(jsii_name="resetSouth")
    def reset_south(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSouth", []))

    @jsii.member(jsii_name="resetSouthVar")
    def reset_south_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSouthVar", []))

    @jsii.member(jsii_name="resetWest")
    def reset_west(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWest", []))

    @jsii.member(jsii_name="resetWestVar")
    def reset_west_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWestVar", []))

    @builtins.property
    @jsii.member(jsii_name="eastInput")
    def east_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "eastInput"))

    @builtins.property
    @jsii.member(jsii_name="eastVarInput")
    def east_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "eastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="northInput")
    def north_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "northInput"))

    @builtins.property
    @jsii.member(jsii_name="northVarInput")
    def north_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "northVarInput"))

    @builtins.property
    @jsii.member(jsii_name="southInput")
    def south_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "southInput"))

    @builtins.property
    @jsii.member(jsii_name="southVarInput")
    def south_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "southVarInput"))

    @builtins.property
    @jsii.member(jsii_name="westInput")
    def west_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "westInput"))

    @builtins.property
    @jsii.member(jsii_name="westVarInput")
    def west_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "westVarInput"))

    @builtins.property
    @jsii.member(jsii_name="east")
    def east(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "east"))

    @east.setter
    def east(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8622cbce0d91c74bf510c183b079247c94ab31bc4b743ee851376e48899c80ac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "east", value)

    @builtins.property
    @jsii.member(jsii_name="eastVar")
    def east_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "eastVar"))

    @east_var.setter
    def east_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ce058992d324d5e36fba6779b12d8a43dd242e4e12602791a8da6067de0edc3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "eastVar", value)

    @builtins.property
    @jsii.member(jsii_name="north")
    def north(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "north"))

    @north.setter
    def north(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2b1e1a335f4383c7fe76f8bc5adf06679a743bb5159a9ac196063bb21ebaca2b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "north", value)

    @builtins.property
    @jsii.member(jsii_name="northVar")
    def north_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "northVar"))

    @north_var.setter
    def north_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e4b2e80dc9a4fab90f9ad0f6111fe60612c4de4bc5f3024ec9c1584a2ddb5ce7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "northVar", value)

    @builtins.property
    @jsii.member(jsii_name="south")
    def south(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "south"))

    @south.setter
    def south(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__875e5e704c735716535e78c17b77c09433de5b660178111766c8727599c61bfc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "south", value)

    @builtins.property
    @jsii.member(jsii_name="southVar")
    def south_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "southVar"))

    @south_var.setter
    def south_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e58050a4f689ee21707064b273769f2bebfdccda289c595ec9a47ef26d4f7d5f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "southVar", value)

    @builtins.property
    @jsii.member(jsii_name="west")
    def west(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "west"))

    @west.setter
    def west(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__77c655ace4a9c0b192dc0eb3e8efe78a355d467bbe41f0d438cf43ca6a8612b6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "west", value)

    @builtins.property
    @jsii.member(jsii_name="westVar")
    def west_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "westVar"))

    @west_var.setter
    def west_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6d235fc6d2cf1efbfc267f800407969f4a9102c3f7feb18fd837f5f016ce90c9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "westVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRelativeCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRelativeCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRelativeCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3d6665233aea9adf758faf25f40391067a6a01425a65b831cc4635582cc1b6f1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRemoveColor",
    jsii_struct_bases=[],
    name_mapping={
        "color": "color",
        "color_var": "colorVar",
        "feather": "feather",
        "feather_var": "featherVar",
        "tolerance": "tolerance",
        "tolerance_var": "toleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRemoveColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
        feather: typing.Optional[builtins.str] = None,
        feather_var: typing.Optional[builtins.str] = None,
        tolerance: typing.Optional[builtins.str] = None,
        tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        :param feather: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        :param feather_var: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        :param tolerance: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        :param tolerance_var: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__86fa97e804690d4c8b08bcbaca1cbbf61718e4067ee96f6b02482efbae1491ef)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
            check_type(argname="argument feather", value=feather, expected_type=type_hints["feather"])
            check_type(argname="argument feather_var", value=feather_var, expected_type=type_hints["feather_var"])
            check_type(argname="argument tolerance", value=tolerance, expected_type=type_hints["tolerance"])
            check_type(argname="argument tolerance_var", value=tolerance_var, expected_type=type_hints["tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var
        if feather is not None:
            self._values["feather"] = feather
        if feather_var is not None:
            self._values["feather_var"] = feather_var
        if tolerance is not None:
            self._values["tolerance"] = tolerance
        if tolerance_var is not None:
            self._values["tolerance_var"] = tolerance_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        '''
        result = self._values.get("feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather_var(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        '''
        result = self._values.get("feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        '''
        result = self._values.get("tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance_var(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        result = self._values.get("tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRemoveColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRemoveColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRemoveColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3831e0ff472105ea5fbea630b83eedbd92e85d5a18caf85ce7a2cd0c63192f5f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRemoveColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2fdc5190fd1d3a878a29d7954082153ae22ccd40dea32148a07c9ac79db7888e)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRemoveColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f359d0459b5641b41c567570d10d2abe2381167cc77d3706ac3001b9509f0fe3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__317d86bb4920e15e573dcf028e86f8c6d40aae61a54189514bd3bbe99a008770)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1ce3558316131244fd3846e0f5e6a2133c0cc9c322995d603833b994d94de9df)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRemoveColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRemoveColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRemoveColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a00e56b9eaae6279402b055e7a309363e80a3182bc085bc3cdca3fb330a8510c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRemoveColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRemoveColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c320d65a39f9150ef1333fb5c55b9c26035dbaf57afab9dfa79c5a146eb73897)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @jsii.member(jsii_name="resetFeather")
    def reset_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeather", []))

    @jsii.member(jsii_name="resetFeatherVar")
    def reset_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatherVar", []))

    @jsii.member(jsii_name="resetTolerance")
    def reset_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTolerance", []))

    @jsii.member(jsii_name="resetToleranceVar")
    def reset_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featherInput")
    def feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherInput"))

    @builtins.property
    @jsii.member(jsii_name="featherVarInput")
    def feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceInput")
    def tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceVarInput")
    def tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd27be184c1627d41c64434677feb49a9abfeb6d3be180fcbc744779d861e1bf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__649e560179d115422bdb74065106fbf4edd7ae1cc2d05a908a390a4cc0435ec3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="feather")
    def feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "feather"))

    @feather.setter
    def feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9321c51b1058dfc7c3b4ce11feaf60fda7cf6bf2931de95caba542111774e212)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "feather", value)

    @builtins.property
    @jsii.member(jsii_name="featherVar")
    def feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featherVar"))

    @feather_var.setter
    def feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__22657a8ff3115f1784506dbc08e5f86861c9a94daa1276ae0dbf22bd1b072399)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featherVar", value)

    @builtins.property
    @jsii.member(jsii_name="tolerance")
    def tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tolerance"))

    @tolerance.setter
    def tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__14377699befb02f6969dc72e7665daad9efd32a444b897de4ae00c82c4ca9931)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tolerance", value)

    @builtins.property
    @jsii.member(jsii_name="toleranceVar")
    def tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "toleranceVar"))

    @tolerance_var.setter
    def tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__51c9ec666cf9ea4308251817ff8cfdbe13148d76c60e98dfe48cc4365626ae1b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "toleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRemoveColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRemoveColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRemoveColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3688c3cef9e00642236725a247ed14e0b5b70314bc810fa4b3eab6b6a4a28cd7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultResize",
    jsii_struct_bases=[],
    name_mapping={
        "aspect": "aspect",
        "aspect_var": "aspectVar",
        "height": "height",
        "height_var": "heightVar",
        "type": "type",
        "type_var": "typeVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultResize:
    def __init__(
        self,
        *,
        aspect: typing.Optional[builtins.str] = None,
        aspect_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param aspect: Preserves the aspect ratio. Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect DataAkamaiImagingPolicyImage#aspect}
        :param aspect_var: Preserves the aspect ratio. Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_var DataAkamaiImagingPolicyImage#aspect_var}
        :param height: The height to resize the source image to. Must be set if height is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height to resize the source image to. Must be set if height is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param type: Sets constraints for the image resize. Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: Sets constraints for the image resize. Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        :param width: The width to resize the source image to. Must be set if width is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width to resize the source image to. Must be set if width is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af00159db0ad7d3bd30a80155b273667762ee7e5a203c33ff53c4414f00946c7)
            check_type(argname="argument aspect", value=aspect, expected_type=type_hints["aspect"])
            check_type(argname="argument aspect_var", value=aspect_var, expected_type=type_hints["aspect_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if aspect is not None:
            self._values["aspect"] = aspect
        if aspect_var is not None:
            self._values["aspect_var"] = aspect_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def aspect(self) -> typing.Optional[builtins.str]:
        '''Preserves the aspect ratio.

        Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect DataAkamaiImagingPolicyImage#aspect}
        '''
        result = self._values.get("aspect")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def aspect_var(self) -> typing.Optional[builtins.str]:
        '''Preserves the aspect ratio.

        Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_var DataAkamaiImagingPolicyImage#aspect_var}
        '''
        result = self._values.get("aspect_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height to resize the source image to. Must be set if height is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height to resize the source image to. Must be set if height is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''Sets constraints for the image resize.

        Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''Sets constraints for the image resize.

        Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width to resize the source image to. Must be set if width is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width to resize the source image to. Must be set if width is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultResize(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultResizeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultResizeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__59aa0506a739de1f6fb4c818d988f3edbec1749ae1016feea623b34f59c88a04)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultResizeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__07a587b8573ddf3aa0e31b0e38406f4c1674cbd4bf8d0691f47e737f3f08c4c9)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultResizeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0c6b35ff14fea653ebfc4568c42b28a5f8da3f8334b34e5f733a500c8095e710)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ff3112155420d7c93369ff94b20c0b49520596825e774bdef91b2c0032cc9637)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e8a931c012473736c75362dc15548157d9039ef2d34126a48c7d8c5be9fdbf68)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultResize]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultResize]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultResize]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__950872a2bd51a5edd4981ff90f2643a0f48e6b58e80a409b49df4d7ea905df22)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultResizeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultResizeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3878485a90f6106ee7bfb5f241ae82f2e30e23ed837d3ee0789b306074919ee4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAspect")
    def reset_aspect(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspect", []))

    @jsii.member(jsii_name="resetAspectVar")
    def reset_aspect_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspectVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="aspectInput")
    def aspect_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "aspectInput"))

    @builtins.property
    @jsii.member(jsii_name="aspectVarInput")
    def aspect_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "aspectVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="aspect")
    def aspect(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "aspect"))

    @aspect.setter
    def aspect(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b725d75ebaf28f56ec11613af2d7d4ca21fa12da7dd954b0b2ea16e80b3a4e68)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "aspect", value)

    @builtins.property
    @jsii.member(jsii_name="aspectVar")
    def aspect_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "aspectVar"))

    @aspect_var.setter
    def aspect_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ecedddcb9fba344d8ad46b51da280297a5cd56150f7f7b119e8e50af0e2894b6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "aspectVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9de3061ab7a2464e2b77dec1450d6a68aefe3034d4743dc6014accc661db112d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2c2df5fe82a8227372c8e3474545e19f7a10a454bdac469f895bedf5b39eccbb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0d1128b68fed5ffb06aad752c161c91af08e34dee483394b08a79a6ef749d232)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__443073f2c13707921d704d96e312ba26b0e209bbf474685bb0433c5b5fb8eb59)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ed7b8f60902625abc3afbc5eee6e060f2b5ffdd1593f1759cdfdaacb5c5784b6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dd0471fd233606d3712756bef60e7757fe9210fa5197c4c74c36c0224233e069)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultResize]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultResize]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultResize]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3eff0e5945a688f06121e868893c4e40b2c6f2376f9bcc6400495177e73012fd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRotate",
    jsii_struct_bases=[],
    name_mapping={"degrees": "degrees", "degrees_var": "degreesVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRotate:
    def __init__(
        self,
        *,
        degrees: typing.Optional[builtins.str] = None,
        degrees_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param degrees: The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees DataAkamaiImagingPolicyImage#degrees}
        :param degrees_var: The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees_var DataAkamaiImagingPolicyImage#degrees_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8f5f92f0a64be10d6f53ff57b724dddf6410a318b94704169b51509955df2788)
            check_type(argname="argument degrees", value=degrees, expected_type=type_hints["degrees"])
            check_type(argname="argument degrees_var", value=degrees_var, expected_type=type_hints["degrees_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if degrees is not None:
            self._values["degrees"] = degrees
        if degrees_var is not None:
            self._values["degrees_var"] = degrees_var

    @builtins.property
    def degrees(self) -> typing.Optional[builtins.str]:
        '''The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees DataAkamaiImagingPolicyImage#degrees}
        '''
        result = self._values.get("degrees")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def degrees_var(self) -> typing.Optional[builtins.str]:
        '''The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees_var DataAkamaiImagingPolicyImage#degrees_var}
        '''
        result = self._values.get("degrees_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRotate(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRotateList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRotateList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__66f015e6811de0a43cc7be8311573b160b85e7b3f0bc5a2a3aa239a78b7b29d9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRotateOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__89d14f48d8c7fe65054cc1340b0518113afe89f8e9744b641c7e580a47a0e64e)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRotateOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fcb7b89f9dfdafc6ebe0582359973521f6a408a29b74ddfbccd00742978d0996)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ebf22ec498af851d898bd7c81a0693c46ffd7b9ec84e54a922c2e4928f8163c6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9b67109c47eb4fdaf200ef6b27014eaaeb47f6115ba1905b7cca8dd61b1b2965)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRotate]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRotate]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRotate]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__60810eae70227eb9e32a6cc7d076418acde89e5c15859d3a5ea95f5fdcc814b7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRotateOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRotateOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__64ba67e3e56de27e1b596b21cf2bf74dd0c16510eaabadb8c4a936b74172c313)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetDegrees")
    def reset_degrees(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDegrees", []))

    @jsii.member(jsii_name="resetDegreesVar")
    def reset_degrees_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDegreesVar", []))

    @builtins.property
    @jsii.member(jsii_name="degreesInput")
    def degrees_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "degreesInput"))

    @builtins.property
    @jsii.member(jsii_name="degreesVarInput")
    def degrees_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "degreesVarInput"))

    @builtins.property
    @jsii.member(jsii_name="degrees")
    def degrees(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "degrees"))

    @degrees.setter
    def degrees(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2372a635ffaf3ddc81c6fe60d6613d87a5aad784a038647b257821eca03792fd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "degrees", value)

    @builtins.property
    @jsii.member(jsii_name="degreesVar")
    def degrees_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "degreesVar"))

    @degrees_var.setter
    def degrees_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__531af07620967d0b1104a331d145bcbbded78edd440d5003fca24331652aad9a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "degreesVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRotate]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRotate]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRotate]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__076790bf7910cfa61c7831b32487b85a871fb1a8f73e5882f2b7ed8ce312bc68)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultScale",
    jsii_struct_bases=[],
    name_mapping={
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultScale:
    def __init__(
        self,
        *,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param height: Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged. Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged. Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__de5e35c3e1a33c15674305409096adf8ffaa2bc6a0853c22444f386d749d3db3)
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size.

        Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size.

        Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged.

        Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged.

        Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultScale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultScaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultScaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ae3e3e718ab02c104ced4e88ced64d9d0455531002c51b76ffdd7b7bbee8760d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultScaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8cf50371e1bc8bf90083fc1b0e4fc881c8ffff66c143a7fa19c1323a3cb801c6)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultScaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b4adb2eee036782d7c0548855e03ff32fd3aad986613a5fa26c4b61437f525e7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f0a0b072989fe931678275138114b93df89edc17e97882e29b2be6032019e2a2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8172ef21f2902db37531c2e9e35439d080ce8b24982e898a7ae5330e7883ef69)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultScale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultScale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultScale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9b2f72462d002bc99f8f7b8d0078f642dafd2db742edb47d71c40449ec7b2fc7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultScaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultScaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dca04e535fa13aa8959d8a9478b5ddaef8971624a4589d0b853fe0bf834f3056)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cf61d881e86283fad0ef0814aadc584836231ab332415ef7494bae640c741be0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__67fdde5fb8b065d3af165d19c85f205d523c0f276a36d09f6af2b4046306e9a4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f848397d74db7f74065b922587677ec994607187ce4024aa07b0fd3c4dbffd32)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__260d3b7f3eb39ed3ad673a00ad9b1f8ba445f8313025c3cd2673df5a55ced955)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultScale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultScale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultScale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eedef18c30a6a3543f20a3979de8e1c7fe4477a70da1a2a5bbebf4694dcea44d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultShear",
    jsii_struct_bases=[],
    name_mapping={
        "x_shear": "xShear",
        "x_shear_var": "xShearVar",
        "y_shear": "yShear",
        "y_shear_var": "yShearVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultShear:
    def __init__(
        self,
        *,
        x_shear: typing.Optional[builtins.str] = None,
        x_shear_var: typing.Optional[builtins.str] = None,
        y_shear: typing.Optional[builtins.str] = None,
        y_shear_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param x_shear: The amount to shear along the x-axis, measured in multiples of the image's width. Must be set if yShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear DataAkamaiImagingPolicyImage#x_shear}
        :param x_shear_var: The amount to shear along the x-axis, measured in multiples of the image's width. Must be set if yShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear_var DataAkamaiImagingPolicyImage#x_shear_var}
        :param y_shear: The amount to shear along the y-axis, measured in multiples of the image's height. Must be set if xShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear DataAkamaiImagingPolicyImage#y_shear}
        :param y_shear_var: The amount to shear along the y-axis, measured in multiples of the image's height. Must be set if xShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear_var DataAkamaiImagingPolicyImage#y_shear_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ba6edc2fc904c9bcac2a515fddc96d786c354709c6ca459b99f4c0d34d0fbab8)
            check_type(argname="argument x_shear", value=x_shear, expected_type=type_hints["x_shear"])
            check_type(argname="argument x_shear_var", value=x_shear_var, expected_type=type_hints["x_shear_var"])
            check_type(argname="argument y_shear", value=y_shear, expected_type=type_hints["y_shear"])
            check_type(argname="argument y_shear_var", value=y_shear_var, expected_type=type_hints["y_shear_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if x_shear is not None:
            self._values["x_shear"] = x_shear
        if x_shear_var is not None:
            self._values["x_shear_var"] = x_shear_var
        if y_shear is not None:
            self._values["y_shear"] = y_shear
        if y_shear_var is not None:
            self._values["y_shear_var"] = y_shear_var

    @builtins.property
    def x_shear(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the x-axis, measured in multiples of the image's width.

        Must be set if yShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear DataAkamaiImagingPolicyImage#x_shear}
        '''
        result = self._values.get("x_shear")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_shear_var(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the x-axis, measured in multiples of the image's width.

        Must be set if yShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear_var DataAkamaiImagingPolicyImage#x_shear_var}
        '''
        result = self._values.get("x_shear_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_shear(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the y-axis, measured in multiples of the image's height.

        Must be set if xShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear DataAkamaiImagingPolicyImage#y_shear}
        '''
        result = self._values.get("y_shear")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_shear_var(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the y-axis, measured in multiples of the image's height.

        Must be set if xShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear_var DataAkamaiImagingPolicyImage#y_shear_var}
        '''
        result = self._values.get("y_shear_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultShear(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultShearList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultShearList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__33294a6c77edc0a044e83a97f6c105f7de1025795aca62f0518b8aa1cc4d4b12)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultShearOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0df12a90272c98c7e3c6f631963a142aabb2e15a84b55683c55218745db190e0)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultShearOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__82ed00876ce1546be86d26514f698ddb0a5fc73a1ecd8d06d55ca9132853865b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af82aab5fd93ef9cd2bd9980bafa784567cc5ef7d90361b94371f5afa981a8f2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__69eedce31fd5df5ddd7e33be6548f7c334a63c83810bd1a3acbcac321c93e653)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultShear]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultShear]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultShear]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aa9c0710052dd51ec687c1f730282e4fa76de9836f671bac46ebcae4a5774323)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultShearOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultShearOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6b7ea4fd374fb0c1d01d8a772cb98acdf3c13ca89022ada2ee09917398422140)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetXShear")
    def reset_x_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXShear", []))

    @jsii.member(jsii_name="resetXShearVar")
    def reset_x_shear_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXShearVar", []))

    @jsii.member(jsii_name="resetYShear")
    def reset_y_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYShear", []))

    @jsii.member(jsii_name="resetYShearVar")
    def reset_y_shear_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYShearVar", []))

    @builtins.property
    @jsii.member(jsii_name="xShearInput")
    def x_shear_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xShearInput"))

    @builtins.property
    @jsii.member(jsii_name="xShearVarInput")
    def x_shear_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xShearVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yShearInput")
    def y_shear_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yShearInput"))

    @builtins.property
    @jsii.member(jsii_name="yShearVarInput")
    def y_shear_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yShearVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xShear")
    def x_shear(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xShear"))

    @x_shear.setter
    def x_shear(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f64987313ab782b4f6934524f8bd3049ad72ad15dfa964cca5fc5e13c57ee16a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xShear", value)

    @builtins.property
    @jsii.member(jsii_name="xShearVar")
    def x_shear_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xShearVar"))

    @x_shear_var.setter
    def x_shear_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3c3faaa7c4293fd3f3d2f2ef24053a23fa5aadc89963798e13d6a9215308a3a7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xShearVar", value)

    @builtins.property
    @jsii.member(jsii_name="yShear")
    def y_shear(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yShear"))

    @y_shear.setter
    def y_shear(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2add1022551c845864cf3df66870c7db058da64c9484407888013a5a347a3fc1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yShear", value)

    @builtins.property
    @jsii.member(jsii_name="yShearVar")
    def y_shear_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yShearVar"))

    @y_shear_var.setter
    def y_shear_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cad5f592ce0c5a82e81dfa843139a269d193fc63f83f6441080f38d2e9f9b0aa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yShearVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultShear]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultShear]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultShear]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5953df70859de8e67232b8ff6ca9a435fc85d26b0466d6ba9087bfbf2790bd86)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultTrim",
    jsii_struct_bases=[],
    name_mapping={
        "fuzz": "fuzz",
        "fuzz_var": "fuzzVar",
        "padding": "padding",
        "padding_var": "paddingVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultTrim:
    def __init__(
        self,
        *,
        fuzz: typing.Optional[builtins.str] = None,
        fuzz_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fuzz: The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz DataAkamaiImagingPolicyImage#fuzz}
        :param fuzz_var: The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz_var DataAkamaiImagingPolicyImage#fuzz_var}
        :param padding: The amount of padding in pixels to add to the trimmed image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: The amount of padding in pixels to add to the trimmed image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4d5d26be2bf1600110c68f443d552d3207cbf3664b71013c23ad4f8d62b2ba82)
            check_type(argname="argument fuzz", value=fuzz, expected_type=type_hints["fuzz"])
            check_type(argname="argument fuzz_var", value=fuzz_var, expected_type=type_hints["fuzz_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fuzz is not None:
            self._values["fuzz"] = fuzz
        if fuzz_var is not None:
            self._values["fuzz_var"] = fuzz_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var

    @builtins.property
    def fuzz(self) -> typing.Optional[builtins.str]:
        '''The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz DataAkamaiImagingPolicyImage#fuzz}
        '''
        result = self._values.get("fuzz")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fuzz_var(self) -> typing.Optional[builtins.str]:
        '''The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz_var DataAkamaiImagingPolicyImage#fuzz_var}
        '''
        result = self._values.get("fuzz_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''The amount of padding in pixels to add to the trimmed image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''The amount of padding in pixels to add to the trimmed image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultTrim(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultTrimList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultTrimList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f4afe3231c7443c524de6c9915f38bf91d7fae3ce09763155330f2e036d76f1b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultTrimOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__483741aecb7349f0b97311374493ff8451fc4da482c06a93a5cc07b3c0bd1270)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultTrimOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f505f588398e246a3757ba8d10cfea8ec622ee81ff76160633488b9eae9ceb48)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1dec1ba66933920b79dd5e15069e5b667aa47dcecdf0fb324aaabd430705813c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__81aa16ed0df8ead77ab5e218edb57c8852d220bc75639a2e1634891b551750e5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultTrim]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultTrim]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultTrim]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ceadc1a57df66081790302c6da45261288ace46eafaba156c5c12afe591a13c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultTrimOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultTrimOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a373ab5bd6d19c14ba7aba301567629513400657a51afb30bd8bc989b0a18f3e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetFuzz")
    def reset_fuzz(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFuzz", []))

    @jsii.member(jsii_name="resetFuzzVar")
    def reset_fuzz_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFuzzVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @builtins.property
    @jsii.member(jsii_name="fuzzInput")
    def fuzz_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fuzzInput"))

    @builtins.property
    @jsii.member(jsii_name="fuzzVarInput")
    def fuzz_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fuzzVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="fuzz")
    def fuzz(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fuzz"))

    @fuzz.setter
    def fuzz(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__075c4c9c176bb7306a9bf02f44faa296a12a72b222c3ee13365f455ca0b2f0a9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fuzz", value)

    @builtins.property
    @jsii.member(jsii_name="fuzzVar")
    def fuzz_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fuzzVar"))

    @fuzz_var.setter
    def fuzz_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__120fe96f93e4bfc6e3cbf4cbce7509ed65c6277372112cf1aa3b12f9d0e7f430)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fuzzVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a1f72bd4e6fdf01bf60faa9e7557945b035fc8027f0d4f5865d095dec851e6b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__765a563fbe71edb5819f8104061d0b4f5cafa80a615d93fbf423bd2b72c44cf8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultTrim]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultTrim]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultTrim]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e30954ad3eef341c589e3ab0bd02116945b2f7f5ba3b084bf632b18110a838c2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultUnsharpMask",
    jsii_struct_bases=[],
    name_mapping={
        "gain": "gain",
        "gain_var": "gainVar",
        "sigma": "sigma",
        "sigma_var": "sigmaVar",
        "threshold": "threshold",
        "threshold_var": "thresholdVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultUnsharpMask:
    def __init__(
        self,
        *,
        gain: typing.Optional[builtins.str] = None,
        gain_var: typing.Optional[builtins.str] = None,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
        threshold: typing.Optional[builtins.str] = None,
        threshold_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param gain: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        :param gain_var: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        :param sigma: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        :param threshold: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        :param threshold_var: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__faf69a0cb695d47e01e5d054d6084ec39db75e770366d972d92d1f2f197248bb)
            check_type(argname="argument gain", value=gain, expected_type=type_hints["gain"])
            check_type(argname="argument gain_var", value=gain_var, expected_type=type_hints["gain_var"])
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
            check_type(argname="argument threshold", value=threshold, expected_type=type_hints["threshold"])
            check_type(argname="argument threshold_var", value=threshold_var, expected_type=type_hints["threshold_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if gain is not None:
            self._values["gain"] = gain
        if gain_var is not None:
            self._values["gain_var"] = gain_var
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var
        if threshold is not None:
            self._values["threshold"] = threshold
        if threshold_var is not None:
            self._values["threshold_var"] = threshold_var

    @builtins.property
    def gain(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        '''
        result = self._values.get("gain")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gain_var(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        '''
        result = self._values.get("gain_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        '''
        result = self._values.get("threshold")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold_var(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        result = self._values.get("threshold_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultUnsharpMask(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultUnsharpMaskList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultUnsharpMaskList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__49c270c517c8fa679da0808d25f47da17e4e6ff0d7efdab81757da8f270b1770)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultUnsharpMaskOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1d9184404a41767e02c329a23ed38832562b8810f99344a108d74f3786a0d72b)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultUnsharpMaskOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8280b63a23318507b2aa4c05e1244802421e60b2e6a05b30d566e7d486ba1803)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d5d97b284427ffecd873230759508a6f2d4e3def921cdd49cf8e8df2e93c2c91)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__03748d8f6004b6cedaa8f31735edc872978aa218e4cb403c925896dc063944d0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultUnsharpMask]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultUnsharpMask]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultUnsharpMask]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cc9f5fa18d497e93a8507ccae88c666986eb34f480d1d4b668e0a2f5bfc4ed08)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultUnsharpMaskOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultUnsharpMaskOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cec4a213bf72d8605772343a4303b1cbe9e8ee5fe1b0b9b557d4802e68dda64d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetGain")
    def reset_gain(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGain", []))

    @jsii.member(jsii_name="resetGainVar")
    def reset_gain_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGainVar", []))

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @jsii.member(jsii_name="resetThreshold")
    def reset_threshold(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThreshold", []))

    @jsii.member(jsii_name="resetThresholdVar")
    def reset_threshold_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThresholdVar", []))

    @builtins.property
    @jsii.member(jsii_name="gainInput")
    def gain_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainInput"))

    @builtins.property
    @jsii.member(jsii_name="gainVarInput")
    def gain_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdInput")
    def threshold_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdVarInput")
    def threshold_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gain")
    def gain(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gain"))

    @gain.setter
    def gain(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__04bd1a2b36910a72bb6fc2b57cf262df24470f7c6af774451758972ff7c74429)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gain", value)

    @builtins.property
    @jsii.member(jsii_name="gainVar")
    def gain_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gainVar"))

    @gain_var.setter
    def gain_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ca445651d3a5b702793077907c3a024ace3f628b17bb0a152ab989d41dd67a97)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gainVar", value)

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d2f9c5bd842af6b5f5c1d49a636a25d6de5fa2edf6b6643a68d19f7b37afef47)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0a7f833b7a26420f244ac25aa1eda90ad48eebfef6e395d3f6d71ebe80cbf8a6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="threshold")
    def threshold(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "threshold"))

    @threshold.setter
    def threshold(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__09ac4b4bc2e75912384ab0d06d550850122d9b663c1d932b0111719863f0e84f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "threshold", value)

    @builtins.property
    @jsii.member(jsii_name="thresholdVar")
    def threshold_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "thresholdVar"))

    @threshold_var.setter
    def threshold_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__15202d0e1b21ebf484d6618947f7222bc67f331ea38afe199a8b7a70c97c5d7f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "thresholdVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultUnsharpMask]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultUnsharpMask]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultUnsharpMask]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aacb76fdd5e7640f8f00ecf466e91c98bb9e1dc61f7b37fc60c47839afcb4d9d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqual",
    jsii_struct_bases=[],
    name_mapping={
        "append": "append",
        "aspect_crop": "aspectCrop",
        "background_color": "backgroundColor",
        "blur": "blur",
        "chroma_key": "chromaKey",
        "composite": "composite",
        "compound": "compound",
        "contrast": "contrast",
        "crop": "crop",
        "face_crop": "faceCrop",
        "feature_crop": "featureCrop",
        "fit_and_fill": "fitAndFill",
        "goop": "goop",
        "grayscale": "grayscale",
        "hsl": "hsl",
        "hsv": "hsv",
        "if_dimension": "ifDimension",
        "if_orientation": "ifOrientation",
        "im_query": "imQuery",
        "max_colors": "maxColors",
        "mirror": "mirror",
        "mono_hue": "monoHue",
        "opacity": "opacity",
        "region_of_interest_crop": "regionOfInterestCrop",
        "relative_crop": "relativeCrop",
        "remove_color": "removeColor",
        "resize": "resize",
        "rotate": "rotate",
        "scale": "scale",
        "shear": "shear",
        "trim": "trim",
        "unsharp_mask": "unsharpMask",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqual:
    def __init__(
        self,
        *,
        append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualAppend", typing.Dict[builtins.str, typing.Any]]]]] = None,
        aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualAspectCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualBackgroundColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualBlur", typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualChromaKey", typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualComposite", typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCompound", typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualContrast", typing.Dict[builtins.str, typing.Any]]]]] = None,
        crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualFaceCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualFeatureCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualFitAndFill", typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualGoop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualGrayscale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualHsl", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualHsv", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimension", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientation", typing.Dict[builtins.str, typing.Any]]]]] = None,
        im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualImQuery", typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualMaxColors", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualMirror", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualMonoHue", typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualOpacity", typing.Dict[builtins.str, typing.Any]]]]] = None,
        region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRegionOfInterestCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRelativeCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRemoveColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualResize", typing.Dict[builtins.str, typing.Any]]]]] = None,
        rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRotate", typing.Dict[builtins.str, typing.Any]]]]] = None,
        scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualScale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualShear", typing.Dict[builtins.str, typing.Any]]]]] = None,
        trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualTrim", typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualUnsharpMask", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param append: append block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        :param aspect_crop: aspect_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param crop: crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        :param face_crop: face_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        :param feature_crop: feature_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        :param fit_and_fill: fit_and_fill block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param im_query: im_query block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param region_of_interest_crop: region_of_interest_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        :param relative_crop: relative_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param resize: resize block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        :param rotate: rotate block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        :param scale: scale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param shear: shear block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        :param trim: trim block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__896acbaac17a1d6319d2aeb48c7d7de779ea9726dd690c39d9af1b17b36368f0)
            check_type(argname="argument append", value=append, expected_type=type_hints["append"])
            check_type(argname="argument aspect_crop", value=aspect_crop, expected_type=type_hints["aspect_crop"])
            check_type(argname="argument background_color", value=background_color, expected_type=type_hints["background_color"])
            check_type(argname="argument blur", value=blur, expected_type=type_hints["blur"])
            check_type(argname="argument chroma_key", value=chroma_key, expected_type=type_hints["chroma_key"])
            check_type(argname="argument composite", value=composite, expected_type=type_hints["composite"])
            check_type(argname="argument compound", value=compound, expected_type=type_hints["compound"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument crop", value=crop, expected_type=type_hints["crop"])
            check_type(argname="argument face_crop", value=face_crop, expected_type=type_hints["face_crop"])
            check_type(argname="argument feature_crop", value=feature_crop, expected_type=type_hints["feature_crop"])
            check_type(argname="argument fit_and_fill", value=fit_and_fill, expected_type=type_hints["fit_and_fill"])
            check_type(argname="argument goop", value=goop, expected_type=type_hints["goop"])
            check_type(argname="argument grayscale", value=grayscale, expected_type=type_hints["grayscale"])
            check_type(argname="argument hsl", value=hsl, expected_type=type_hints["hsl"])
            check_type(argname="argument hsv", value=hsv, expected_type=type_hints["hsv"])
            check_type(argname="argument if_dimension", value=if_dimension, expected_type=type_hints["if_dimension"])
            check_type(argname="argument if_orientation", value=if_orientation, expected_type=type_hints["if_orientation"])
            check_type(argname="argument im_query", value=im_query, expected_type=type_hints["im_query"])
            check_type(argname="argument max_colors", value=max_colors, expected_type=type_hints["max_colors"])
            check_type(argname="argument mirror", value=mirror, expected_type=type_hints["mirror"])
            check_type(argname="argument mono_hue", value=mono_hue, expected_type=type_hints["mono_hue"])
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument region_of_interest_crop", value=region_of_interest_crop, expected_type=type_hints["region_of_interest_crop"])
            check_type(argname="argument relative_crop", value=relative_crop, expected_type=type_hints["relative_crop"])
            check_type(argname="argument remove_color", value=remove_color, expected_type=type_hints["remove_color"])
            check_type(argname="argument resize", value=resize, expected_type=type_hints["resize"])
            check_type(argname="argument rotate", value=rotate, expected_type=type_hints["rotate"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument shear", value=shear, expected_type=type_hints["shear"])
            check_type(argname="argument trim", value=trim, expected_type=type_hints["trim"])
            check_type(argname="argument unsharp_mask", value=unsharp_mask, expected_type=type_hints["unsharp_mask"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if append is not None:
            self._values["append"] = append
        if aspect_crop is not None:
            self._values["aspect_crop"] = aspect_crop
        if background_color is not None:
            self._values["background_color"] = background_color
        if blur is not None:
            self._values["blur"] = blur
        if chroma_key is not None:
            self._values["chroma_key"] = chroma_key
        if composite is not None:
            self._values["composite"] = composite
        if compound is not None:
            self._values["compound"] = compound
        if contrast is not None:
            self._values["contrast"] = contrast
        if crop is not None:
            self._values["crop"] = crop
        if face_crop is not None:
            self._values["face_crop"] = face_crop
        if feature_crop is not None:
            self._values["feature_crop"] = feature_crop
        if fit_and_fill is not None:
            self._values["fit_and_fill"] = fit_and_fill
        if goop is not None:
            self._values["goop"] = goop
        if grayscale is not None:
            self._values["grayscale"] = grayscale
        if hsl is not None:
            self._values["hsl"] = hsl
        if hsv is not None:
            self._values["hsv"] = hsv
        if if_dimension is not None:
            self._values["if_dimension"] = if_dimension
        if if_orientation is not None:
            self._values["if_orientation"] = if_orientation
        if im_query is not None:
            self._values["im_query"] = im_query
        if max_colors is not None:
            self._values["max_colors"] = max_colors
        if mirror is not None:
            self._values["mirror"] = mirror
        if mono_hue is not None:
            self._values["mono_hue"] = mono_hue
        if opacity is not None:
            self._values["opacity"] = opacity
        if region_of_interest_crop is not None:
            self._values["region_of_interest_crop"] = region_of_interest_crop
        if relative_crop is not None:
            self._values["relative_crop"] = relative_crop
        if remove_color is not None:
            self._values["remove_color"] = remove_color
        if resize is not None:
            self._values["resize"] = resize
        if rotate is not None:
            self._values["rotate"] = rotate
        if scale is not None:
            self._values["scale"] = scale
        if shear is not None:
            self._values["shear"] = shear
        if trim is not None:
            self._values["trim"] = trim
        if unsharp_mask is not None:
            self._values["unsharp_mask"] = unsharp_mask

    @builtins.property
    def append(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualAppend"]]]:
        '''append block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        '''
        result = self._values.get("append")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualAppend"]]], result)

    @builtins.property
    def aspect_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualAspectCrop"]]]:
        '''aspect_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        '''
        result = self._values.get("aspect_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualAspectCrop"]]], result)

    @builtins.property
    def background_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualBackgroundColor"]]]:
        '''background_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        '''
        result = self._values.get("background_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualBackgroundColor"]]], result)

    @builtins.property
    def blur(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualBlur"]]]:
        '''blur block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        '''
        result = self._values.get("blur")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualBlur"]]], result)

    @builtins.property
    def chroma_key(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualChromaKey"]]]:
        '''chroma_key block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        '''
        result = self._values.get("chroma_key")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualChromaKey"]]], result)

    @builtins.property
    def composite(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualComposite"]]]:
        '''composite block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        '''
        result = self._values.get("composite")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualComposite"]]], result)

    @builtins.property
    def compound(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCompound"]]]:
        '''compound block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        '''
        result = self._values.get("compound")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCompound"]]], result)

    @builtins.property
    def contrast(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualContrast"]]]:
        '''contrast block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualContrast"]]], result)

    @builtins.property
    def crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCrop"]]]:
        '''crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        '''
        result = self._values.get("crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCrop"]]], result)

    @builtins.property
    def face_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualFaceCrop"]]]:
        '''face_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        '''
        result = self._values.get("face_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualFaceCrop"]]], result)

    @builtins.property
    def feature_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualFeatureCrop"]]]:
        '''feature_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        '''
        result = self._values.get("feature_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualFeatureCrop"]]], result)

    @builtins.property
    def fit_and_fill(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualFitAndFill"]]]:
        '''fit_and_fill block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        '''
        result = self._values.get("fit_and_fill")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualFitAndFill"]]], result)

    @builtins.property
    def goop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualGoop"]]]:
        '''goop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        '''
        result = self._values.get("goop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualGoop"]]], result)

    @builtins.property
    def grayscale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualGrayscale"]]]:
        '''grayscale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        '''
        result = self._values.get("grayscale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualGrayscale"]]], result)

    @builtins.property
    def hsl(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualHsl"]]]:
        '''hsl block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        '''
        result = self._values.get("hsl")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualHsl"]]], result)

    @builtins.property
    def hsv(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualHsv"]]]:
        '''hsv block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        '''
        result = self._values.get("hsv")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualHsv"]]], result)

    @builtins.property
    def if_dimension(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimension"]]]:
        '''if_dimension block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        '''
        result = self._values.get("if_dimension")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimension"]]], result)

    @builtins.property
    def if_orientation(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientation"]]]:
        '''if_orientation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        '''
        result = self._values.get("if_orientation")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientation"]]], result)

    @builtins.property
    def im_query(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualImQuery"]]]:
        '''im_query block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        '''
        result = self._values.get("im_query")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualImQuery"]]], result)

    @builtins.property
    def max_colors(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualMaxColors"]]]:
        '''max_colors block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        '''
        result = self._values.get("max_colors")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualMaxColors"]]], result)

    @builtins.property
    def mirror(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualMirror"]]]:
        '''mirror block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        '''
        result = self._values.get("mirror")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualMirror"]]], result)

    @builtins.property
    def mono_hue(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualMonoHue"]]]:
        '''mono_hue block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        '''
        result = self._values.get("mono_hue")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualMonoHue"]]], result)

    @builtins.property
    def opacity(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualOpacity"]]]:
        '''opacity block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualOpacity"]]], result)

    @builtins.property
    def region_of_interest_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRegionOfInterestCrop"]]]:
        '''region_of_interest_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        '''
        result = self._values.get("region_of_interest_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRegionOfInterestCrop"]]], result)

    @builtins.property
    def relative_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRelativeCrop"]]]:
        '''relative_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        '''
        result = self._values.get("relative_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRelativeCrop"]]], result)

    @builtins.property
    def remove_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRemoveColor"]]]:
        '''remove_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        '''
        result = self._values.get("remove_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRemoveColor"]]], result)

    @builtins.property
    def resize(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualResize"]]]:
        '''resize block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        '''
        result = self._values.get("resize")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualResize"]]], result)

    @builtins.property
    def rotate(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRotate"]]]:
        '''rotate block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        '''
        result = self._values.get("rotate")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRotate"]]], result)

    @builtins.property
    def scale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualScale"]]]:
        '''scale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualScale"]]], result)

    @builtins.property
    def shear(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualShear"]]]:
        '''shear block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        '''
        result = self._values.get("shear")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualShear"]]], result)

    @builtins.property
    def trim(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualTrim"]]]:
        '''trim block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        '''
        result = self._values.get("trim")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualTrim"]]], result)

    @builtins.property
    def unsharp_mask(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualUnsharpMask"]]]:
        '''unsharp_mask block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        result = self._values.get("unsharp_mask")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualUnsharpMask"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqual(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualAppend",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_priority": "gravityPriority",
        "gravity_priority_var": "gravityPriorityVar",
        "gravity_var": "gravityVar",
        "preserve_minor_dimension": "preserveMinorDimension",
        "preserve_minor_dimension_var": "preserveMinorDimensionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualAppend:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualAppendImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_priority: typing.Optional[builtins.str] = None,
        gravity_priority_var: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        preserve_minor_dimension: typing.Optional[builtins.str] = None,
        preserve_minor_dimension_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Specifies where to place the ``image`` relative to the source image. The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_priority: Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal. The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority DataAkamaiImagingPolicyImage#gravity_priority}
        :param gravity_priority_var: Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal. The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority_var DataAkamaiImagingPolicyImage#gravity_priority_var}
        :param gravity_var: Specifies where to place the ``image`` relative to the source image. The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param preserve_minor_dimension: Whether to preserve the source image's minor dimension, ``false`` by default. The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension DataAkamaiImagingPolicyImage#preserve_minor_dimension}
        :param preserve_minor_dimension_var: Whether to preserve the source image's minor dimension, ``false`` by default. The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension_var DataAkamaiImagingPolicyImage#preserve_minor_dimension_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualAppendImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a99002a1a86e1b14e9956368854af7bb52f19cf6aec24c7a9eb6074e2051f1ae)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_priority", value=gravity_priority, expected_type=type_hints["gravity_priority"])
            check_type(argname="argument gravity_priority_var", value=gravity_priority_var, expected_type=type_hints["gravity_priority_var"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument preserve_minor_dimension", value=preserve_minor_dimension, expected_type=type_hints["preserve_minor_dimension"])
            check_type(argname="argument preserve_minor_dimension_var", value=preserve_minor_dimension_var, expected_type=type_hints["preserve_minor_dimension_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_priority is not None:
            self._values["gravity_priority"] = gravity_priority
        if gravity_priority_var is not None:
            self._values["gravity_priority_var"] = gravity_priority_var
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if preserve_minor_dimension is not None:
            self._values["preserve_minor_dimension"] = preserve_minor_dimension
        if preserve_minor_dimension_var is not None:
            self._values["preserve_minor_dimension_var"] = preserve_minor_dimension_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualAppendImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualAppendImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Specifies where to place the ``image`` relative to the source image.

        The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_priority(self) -> typing.Optional[builtins.str]:
        '''Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal.

        The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority DataAkamaiImagingPolicyImage#gravity_priority}
        '''
        result = self._values.get("gravity_priority")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_priority_var(self) -> typing.Optional[builtins.str]:
        '''Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal.

        The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority_var DataAkamaiImagingPolicyImage#gravity_priority_var}
        '''
        result = self._values.get("gravity_priority_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Specifies where to place the ``image`` relative to the source image.

        The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def preserve_minor_dimension(self) -> typing.Optional[builtins.str]:
        '''Whether to preserve the source image's minor dimension, ``false`` by default.

        The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension DataAkamaiImagingPolicyImage#preserve_minor_dimension}
        '''
        result = self._values.get("preserve_minor_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def preserve_minor_dimension_var(self) -> typing.Optional[builtins.str]:
        '''Whether to preserve the source image's minor dimension, ``false`` by default.

        The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension_var DataAkamaiImagingPolicyImage#preserve_minor_dimension_var}
        '''
        result = self._values.get("preserve_minor_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualAppend(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualAppendImage",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualAppendImage:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualAppendImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualAppendImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualAppendImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5b0a0502cfd09703b69441df3e1243a45d00a722ba45a799b5b427d05bfd39f5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualAppendImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualAppendImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualAppendImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__22fcc1d738dd9f763ed978555a60665e5a2c796e849053bd88ff5369c264e55b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualAppendList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualAppendList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__31a99e5bb8fb39292787f3ac1b5b2336dd1dea494f8eb784b204cc3149463db3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualAppendOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1c8b431d5f9b6188e3b1996cb7cc00cf5db0dde0f91bfb0c83bcf70ee007089e)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualAppendOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9b30afefad3d9b6d6a5796f62ef8494de9d7890a164be4d1cc4e2c3751dfaa47)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__512759423a1bfcc9a36f45125c04a4b0b7016a7b5bf7a79dd21e17443a17372a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__451065a716767b29a792c5f02b2c16736245c9217879aa3561107fecb780977a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualAppend]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualAppend]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualAppend]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ef53913c7da88d61071a698caf6e8965585ae5af264e4d900cf0dd6f553b77a5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualAppendOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualAppendOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4c7eaad37ca011f16587e63634ab02bf8eb9f54ec8cc99638ff769f43866795a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualAppendImage()

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityPriority")
    def reset_gravity_priority(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityPriority", []))

    @jsii.member(jsii_name="resetGravityPriorityVar")
    def reset_gravity_priority_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityPriorityVar", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPreserveMinorDimension")
    def reset_preserve_minor_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPreserveMinorDimension", []))

    @jsii.member(jsii_name="resetPreserveMinorDimensionVar")
    def reset_preserve_minor_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPreserveMinorDimensionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualAppendImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualAppendImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityInput")
    def gravity_priority_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityPriorityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityVarInput")
    def gravity_priority_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityPriorityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualAppendImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualAppendImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionInput")
    def preserve_minor_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "preserveMinorDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionVarInput")
    def preserve_minor_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "preserveMinorDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5993afb13b04d338d70b08cdec84be5fd4e5141cbda016c906c17ea8ef4c0968)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityPriority")
    def gravity_priority(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityPriority"))

    @gravity_priority.setter
    def gravity_priority(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cb7590d633504a6bb8b032c4b9cf8c35dba789f927e1097080ecc06936a04617)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityPriority", value)

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityVar")
    def gravity_priority_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityPriorityVar"))

    @gravity_priority_var.setter
    def gravity_priority_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2b65d5f769632c7b5112ede38c9bf7538ec7e220b5be4f8cb2e2969407fbf5e7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityPriorityVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6cb94f1b9c82a091f2d001e49f965421e47fdbfe1254adf4a51bbf40ae53fe0b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimension")
    def preserve_minor_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "preserveMinorDimension"))

    @preserve_minor_dimension.setter
    def preserve_minor_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ee3cd84ded6220fc5404635674155dec272cff649943b0b7e61979931cd555a3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "preserveMinorDimension", value)

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionVar")
    def preserve_minor_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "preserveMinorDimensionVar"))

    @preserve_minor_dimension_var.setter
    def preserve_minor_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ed50d8e69989f2a25b706bac87c19b5c8c356b4776e95422ecc3f344361b189a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "preserveMinorDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualAppend]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualAppend]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualAppend]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__53cc501fa9f26fa744ea440c64f9645325cfa78fcb60e623628f2f4d5e705ea9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualAspectCrop",
    jsii_struct_bases=[],
    name_mapping={
        "allow_expansion": "allowExpansion",
        "allow_expansion_var": "allowExpansionVar",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualAspectCrop:
    def __init__(
        self,
        *,
        allow_expansion: typing.Optional[builtins.str] = None,
        allow_expansion_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_expansion: Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image. Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        :param allow_expansion_var: Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image. Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        :param height: The height term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The width term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        :param x_position: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__64fb42abc5230b0f6e9fb169dee08ab8cf1b26f8242b377886fbd146e09db10f)
            check_type(argname="argument allow_expansion", value=allow_expansion, expected_type=type_hints["allow_expansion"])
            check_type(argname="argument allow_expansion_var", value=allow_expansion_var, expected_type=type_hints["allow_expansion_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if allow_expansion is not None:
            self._values["allow_expansion"] = allow_expansion
        if allow_expansion_var is not None:
            self._values["allow_expansion_var"] = allow_expansion_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def allow_expansion(self) -> typing.Optional[builtins.str]:
        '''Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image.

        Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        '''
        result = self._values.get("allow_expansion")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def allow_expansion_var(self) -> typing.Optional[builtins.str]:
        '''Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image.

        Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        '''
        result = self._values.get("allow_expansion_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualAspectCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualAspectCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualAspectCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb41d1e87a21007d637f4a2b6bf9bd543447bf65d5546ef1302e75e55fd53710)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualAspectCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__64c3b5966963e7d6074edfc62fd60f394aadee2c939640e785902de4744040c9)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualAspectCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cdafe1e36829f2572288f6a9edea2117e5e9073edfcea96e447b023ca92262eb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2510751ac8f727f356287040fb5aebe1cb41ea49a38e011a07a661d77584f70b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ecc84918b47cce479aaedb22121320dac75446139327baae8703f82eb199a7fb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualAspectCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualAspectCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualAspectCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cedcff973e0ecb3bc0029bc87cf8b7bffdeb07dbf0f055b32dd60132ba68f83f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualAspectCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualAspectCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6cea9ec484f435b285a999a3c83a32453ae8be4fa6de4ab7e2b415d74ce49299)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAllowExpansion")
    def reset_allow_expansion(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansion", []))

    @jsii.member(jsii_name="resetAllowExpansionVar")
    def reset_allow_expansion_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansionVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionInput")
    def allow_expansion_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVarInput")
    def allow_expansion_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansion")
    def allow_expansion(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansion"))

    @allow_expansion.setter
    def allow_expansion(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b195a9420d6d63f5acda865dcafa12c2e3fb875634829074e3d7431630f1bb07)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansion", value)

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVar")
    def allow_expansion_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansionVar"))

    @allow_expansion_var.setter
    def allow_expansion_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__60171638e71a021495eff6019e42c5eb5bfe838d1878335fc3f248969e478f3e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansionVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__023889e9cb99d9ef58ba2de1ccd265a2e8432e5c698dac43b6a68b732225c6bb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c325c79412430e9e20569e97890804c60fecd751ce346ee586148077a5096fb2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af8793ccdc1b4c4a00d7c3df12fdd162bd4183255c5008d86ab36da1a9861365)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5950a1adab972cc9848bae1d0c7ec820b0f9c178aaa4aa2b5195b6954d58e151)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__918e2e4fb36cbcf8cea73173a53b1463bda44377de68181644504f2d643980aa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__31b3baa1133c1243f4a0c85a0ba95422963df2d2d3f58580face8a9c22a15e0f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1d425e987fd65f853ac0845a13363630e26f430a6a68890722ccce95b8395523)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__11cf126a50f6b300f34d0a1a9637142aeecca56c61eca28ff67967140a433ae9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualAspectCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualAspectCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualAspectCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__71b86dcfff988a9fc370016f21c82c5fc141143501a01f3ddc1f2c2059fe7a12)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualBackgroundColor",
    jsii_struct_bases=[],
    name_mapping={"color": "color", "color_var": "colorVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualBackgroundColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__db05dd254e5653447f969fa3ec78d6ddb64cb47d89494bd1c21cfde61faaa2a5)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualBackgroundColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualBackgroundColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualBackgroundColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fd0b45267adc54fd69049c701087bf8e491890ed2bf9f31401f3c20f4f08585a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualBackgroundColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cb41de051b0660f65dea905958e32b03f9d4ba1fc83e5973c44ea8853ca378fe)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualBackgroundColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__39617ffed87ec12087b9cd05081cd32b578abda650262963126c34568c5d1f06)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__76db98bd0a04c4fc788aef0f68665d439fb226f1a781eb761552ae1bb281ff29)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__780b7b7e0b7156074c8c893a79633b6aa93a466b090453acca4641bc851b4566)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualBackgroundColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualBackgroundColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__64772ce2018f1c72ad016d90b3095a05f8d1d130202869e19a942cedf3eb2550)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualBackgroundColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualBackgroundColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c0523558e0537a8dacd2c77a26b38281e4f8f704db60e62fc1ec70bcfe3e877a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be9d9d8e0d469bd0c25764a58aa897f5b898f265080e4d554bdb33874bb5bfb7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a90e1ede13ccba9f52207a8e14d1d48ea9ff241332554880b1264f8be90a0c47)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualBackgroundColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualBackgroundColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualBackgroundColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bf80f48488653d74387f659aa2c774e1d2612f7cfe5225f547a2d281c60a3f98)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualBlur",
    jsii_struct_bases=[],
    name_mapping={"sigma": "sigma", "sigma_var": "sigmaVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualBlur:
    def __init__(
        self,
        *,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param sigma: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aaa23fd924d16e127572e069b487f4a6f8d6b9578027b172e5c421ed37f613e7)
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualBlur(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualBlurList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualBlurList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__420f0179e4d8b06542db43e7969fd178607c8446d5743b9cf7626df7bb90d3b7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualBlurOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b540918b647bfa05c65d7c16baec61134b89aa9fc69a71e92c215c3cfa25c744)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualBlurOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d092f650d38dda28df8a64784cfebc9856709e40d344e8761fd93e3b74d57253)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6b8fcde1d0d70edc9abf741d64381b33af7609a45f4f423be7ee2e12c785a937)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__01ced7d066508b973f2b32a7a304f7d37491ac3d0f496f7cf3608f28003638bc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualBlur]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualBlur]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__36e511daefefd6741932af06709a36ce952deaa3ba2cbaecbb767c7b346bed8e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualBlurOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualBlurOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c27ca03b84c58a0b39612394eb0d62a3ce5b07d09bcfd69f7801344aa28548ed)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ce31d1bb3457cc0ecfc76bb88483d435d447e7a138b8d86de9786d3469ab1c9a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a3dd813fa14d12ee0b4f443acd83aebbb547baf7d6dd2b0e8a3784eaeb7ef664)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualBlur]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualBlur]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualBlur]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__820fe4b04f217ea083a3e62b6223e110d9f1f8e62393995704a43f988c20e0a3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualChromaKey",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_feather": "hueFeather",
        "hue_feather_var": "hueFeatherVar",
        "hue_tolerance": "hueTolerance",
        "hue_tolerance_var": "hueToleranceVar",
        "hue_var": "hueVar",
        "lightness_feather": "lightnessFeather",
        "lightness_feather_var": "lightnessFeatherVar",
        "lightness_tolerance": "lightnessTolerance",
        "lightness_tolerance_var": "lightnessToleranceVar",
        "saturation_feather": "saturationFeather",
        "saturation_feather_var": "saturationFeatherVar",
        "saturation_tolerance": "saturationTolerance",
        "saturation_tolerance_var": "saturationToleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualChromaKey:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_feather: typing.Optional[builtins.str] = None,
        hue_feather_var: typing.Optional[builtins.str] = None,
        hue_tolerance: typing.Optional[builtins.str] = None,
        hue_tolerance_var: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness_feather: typing.Optional[builtins.str] = None,
        lightness_feather_var: typing.Optional[builtins.str] = None,
        lightness_tolerance: typing.Optional[builtins.str] = None,
        lightness_tolerance_var: typing.Optional[builtins.str] = None,
        saturation_feather: typing.Optional[builtins.str] = None,
        saturation_feather_var: typing.Optional[builtins.str] = None,
        saturation_tolerance: typing.Optional[builtins.str] = None,
        saturation_tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_feather: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        :param hue_feather_var: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        :param hue_tolerance: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        :param hue_tolerance_var: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        :param hue_var: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness_feather: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        :param lightness_feather_var: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        :param lightness_tolerance: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        :param lightness_tolerance_var: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        :param saturation_feather: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        :param saturation_feather_var: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        :param saturation_tolerance: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        :param saturation_tolerance_var: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7725dadd90ad8a6195fa35c1e3a5992c447806b248f966ff6c7416bb748c8dd0)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_feather", value=hue_feather, expected_type=type_hints["hue_feather"])
            check_type(argname="argument hue_feather_var", value=hue_feather_var, expected_type=type_hints["hue_feather_var"])
            check_type(argname="argument hue_tolerance", value=hue_tolerance, expected_type=type_hints["hue_tolerance"])
            check_type(argname="argument hue_tolerance_var", value=hue_tolerance_var, expected_type=type_hints["hue_tolerance_var"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness_feather", value=lightness_feather, expected_type=type_hints["lightness_feather"])
            check_type(argname="argument lightness_feather_var", value=lightness_feather_var, expected_type=type_hints["lightness_feather_var"])
            check_type(argname="argument lightness_tolerance", value=lightness_tolerance, expected_type=type_hints["lightness_tolerance"])
            check_type(argname="argument lightness_tolerance_var", value=lightness_tolerance_var, expected_type=type_hints["lightness_tolerance_var"])
            check_type(argname="argument saturation_feather", value=saturation_feather, expected_type=type_hints["saturation_feather"])
            check_type(argname="argument saturation_feather_var", value=saturation_feather_var, expected_type=type_hints["saturation_feather_var"])
            check_type(argname="argument saturation_tolerance", value=saturation_tolerance, expected_type=type_hints["saturation_tolerance"])
            check_type(argname="argument saturation_tolerance_var", value=saturation_tolerance_var, expected_type=type_hints["saturation_tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_feather is not None:
            self._values["hue_feather"] = hue_feather
        if hue_feather_var is not None:
            self._values["hue_feather_var"] = hue_feather_var
        if hue_tolerance is not None:
            self._values["hue_tolerance"] = hue_tolerance
        if hue_tolerance_var is not None:
            self._values["hue_tolerance_var"] = hue_tolerance_var
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness_feather is not None:
            self._values["lightness_feather"] = lightness_feather
        if lightness_feather_var is not None:
            self._values["lightness_feather_var"] = lightness_feather_var
        if lightness_tolerance is not None:
            self._values["lightness_tolerance"] = lightness_tolerance
        if lightness_tolerance_var is not None:
            self._values["lightness_tolerance_var"] = lightness_tolerance_var
        if saturation_feather is not None:
            self._values["saturation_feather"] = saturation_feather
        if saturation_feather_var is not None:
            self._values["saturation_feather_var"] = saturation_feather_var
        if saturation_tolerance is not None:
            self._values["saturation_tolerance"] = saturation_tolerance
        if saturation_tolerance_var is not None:
            self._values["saturation_tolerance_var"] = saturation_tolerance_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        '''
        result = self._values.get("hue_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        '''
        result = self._values.get("hue_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        '''
        result = self._values.get("hue_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        '''
        result = self._values.get("hue_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        '''
        result = self._values.get("lightness_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        '''
        result = self._values.get("lightness_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        '''
        result = self._values.get("lightness_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        '''
        result = self._values.get("lightness_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        '''
        result = self._values.get("saturation_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        '''
        result = self._values.get("saturation_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        '''
        result = self._values.get("saturation_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        result = self._values.get("saturation_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualChromaKey(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualChromaKeyList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualChromaKeyList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fc0652dfda7db16fbf52a6a3b6e3fe678bfbc8958fd77ced8aee62cb96026356)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualChromaKeyOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__92d89a66707a011c1d49907d7ad846997c14f7fa3116d63b193d32a5a18332d1)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualChromaKeyOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__30682470f9050892f0323d01a4e8a0acf13c765b4745f5e3c7370e7f36f5fa9e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d3beb810a0568f3109be7a7f069d2608684730162b9da2c22c44482ecc29ca35)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b7fe6c03a7e760784b9472caaf950d1183a0a581983b39db41d02fb534447591)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualChromaKey]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualChromaKey]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8f87dfebdc014aaed2b79dc624f48e713ce536f22af9466f57329a1f6d5d5938)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualChromaKeyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualChromaKeyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3974c5d652380030a870ba925fc8e318d6fd0c1da7747de46656d3d0c7162a3c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueFeather")
    def reset_hue_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeather", []))

    @jsii.member(jsii_name="resetHueFeatherVar")
    def reset_hue_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeatherVar", []))

    @jsii.member(jsii_name="resetHueTolerance")
    def reset_hue_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueTolerance", []))

    @jsii.member(jsii_name="resetHueToleranceVar")
    def reset_hue_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueToleranceVar", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightnessFeather")
    def reset_lightness_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeather", []))

    @jsii.member(jsii_name="resetLightnessFeatherVar")
    def reset_lightness_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeatherVar", []))

    @jsii.member(jsii_name="resetLightnessTolerance")
    def reset_lightness_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessTolerance", []))

    @jsii.member(jsii_name="resetLightnessToleranceVar")
    def reset_lightness_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessToleranceVar", []))

    @jsii.member(jsii_name="resetSaturationFeather")
    def reset_saturation_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeather", []))

    @jsii.member(jsii_name="resetSaturationFeatherVar")
    def reset_saturation_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeatherVar", []))

    @jsii.member(jsii_name="resetSaturationTolerance")
    def reset_saturation_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationTolerance", []))

    @jsii.member(jsii_name="resetSaturationToleranceVar")
    def reset_saturation_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherInput")
    def hue_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVarInput")
    def hue_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceInput")
    def hue_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVarInput")
    def hue_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherInput")
    def lightness_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVarInput")
    def lightness_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceInput")
    def lightness_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVarInput")
    def lightness_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherInput")
    def saturation_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVarInput")
    def saturation_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceInput")
    def saturation_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVarInput")
    def saturation_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c63a3059246f93cb695f25495a899d7c34d1fecbf3bed356bb5b8015594f096e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeather")
    def hue_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeather"))

    @hue_feather.setter
    def hue_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__23c03e983a558fc5079b883bf8f5eddcebed88c5a3cfe80dd576dc5da49d50fb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeather", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVar")
    def hue_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeatherVar"))

    @hue_feather_var.setter
    def hue_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7ee7a8b9a32ed86c072d8233e5cf16f7b6fec56185edac1bc305d000bd369809)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueTolerance")
    def hue_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueTolerance"))

    @hue_tolerance.setter
    def hue_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cc95f820469320fce5234888e92639f59a2d9af5db4c86a4ce2bb4fdbdce7fad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVar")
    def hue_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueToleranceVar"))

    @hue_tolerance_var.setter
    def hue_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__133360321bdd1b57f84f52bd44143525c52c3cb34aead3ba3b5b4da9a6f62b8e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__beec198d1934fc81f60f9cbb61262a411bf55de737c8eca8d9ff5a2f3ee0aa9f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeather")
    def lightness_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeather"))

    @lightness_feather.setter
    def lightness_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__28ff389002668d6288d51b3af1a5d69c098769c57056d4ad6e324e47cf0ddef0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeather", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVar")
    def lightness_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeatherVar"))

    @lightness_feather_var.setter
    def lightness_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__537a05ab9fd29476c4049d2c71b7573be58b1d6bcd83b26d654ba0a40c3b21f8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessTolerance")
    def lightness_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessTolerance"))

    @lightness_tolerance.setter
    def lightness_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c1923e850bc5fad04ef15e7b8d93b9dc23ee491f4cf71ff6047a3dae2df268cd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVar")
    def lightness_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessToleranceVar"))

    @lightness_tolerance_var.setter
    def lightness_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6258c6aa838c84c8ca990efa0bb66d13a54e62c5c526fbc782fe40be98defe86)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeather")
    def saturation_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeather"))

    @saturation_feather.setter
    def saturation_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__817711b956e4e9c096a89b356e0136518e81d20352c0b1674197c5ef8ebd49ae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeather", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVar")
    def saturation_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeatherVar"))

    @saturation_feather_var.setter
    def saturation_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3474db205ff03ed8f040ed2688da297fe2bff3af1ac391879aee1b28242b756e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationTolerance")
    def saturation_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationTolerance"))

    @saturation_tolerance.setter
    def saturation_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__398f0113654d9329ec685588420875168581afcecdad37e5272c6e41efa44ca3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVar")
    def saturation_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationToleranceVar"))

    @saturation_tolerance_var.setter
    def saturation_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a421221b5598f3038ff78d65fc4c3a56ef93e54e7bc2d84de6e877ca2b5b9f19)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualChromaKey]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualChromaKey]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualChromaKey]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ce76d20a60147ece096a15372f5975ad1da39a71ed935461f0ff03aaad375ef1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualComposite",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "placement": "placement",
        "placement_var": "placementVar",
        "scale": "scale",
        "scale_dimension": "scaleDimension",
        "scale_dimension_var": "scaleDimensionVar",
        "scale_var": "scaleVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualComposite:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCompositeImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        placement: typing.Optional[builtins.str] = None,
        placement_var: typing.Optional[builtins.str] = None,
        scale: typing.Optional[builtins.str] = None,
        scale_dimension: typing.Optional[builtins.str] = None,
        scale_dimension_var: typing.Optional[builtins.str] = None,
        scale_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param placement: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        :param placement_var: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        :param scale: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param scale_dimension: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        :param scale_dimension_var: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        :param scale_var: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        :param x_position: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCompositeImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__504c0c950e4b4379695d782e16ccfbe0f36907d8d30bd6e9cda34f8d0fdee376)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument placement", value=placement, expected_type=type_hints["placement"])
            check_type(argname="argument placement_var", value=placement_var, expected_type=type_hints["placement_var"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument scale_dimension", value=scale_dimension, expected_type=type_hints["scale_dimension"])
            check_type(argname="argument scale_dimension_var", value=scale_dimension_var, expected_type=type_hints["scale_dimension_var"])
            check_type(argname="argument scale_var", value=scale_var, expected_type=type_hints["scale_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if placement is not None:
            self._values["placement"] = placement
        if placement_var is not None:
            self._values["placement_var"] = placement_var
        if scale is not None:
            self._values["scale"] = scale
        if scale_dimension is not None:
            self._values["scale_dimension"] = scale_dimension
        if scale_dimension_var is not None:
            self._values["scale_dimension_var"] = scale_dimension_var
        if scale_var is not None:
            self._values["scale_var"] = scale_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCompositeImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCompositeImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        '''
        result = self._values.get("placement")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement_var(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        '''
        result = self._values.get("placement_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        '''
        result = self._values.get("scale_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        '''
        result = self._values.get("scale_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        '''
        result = self._values.get("scale_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualComposite(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCompositeImage",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCompositeImage:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCompositeImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCompositeImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCompositeImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b38c757a6dc4619d472d809bc9009a998986cdd638261f373cb37f316603e046)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCompositeImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCompositeImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ed50286f9b76cb267a5d8668823f26bf381556ac63005538293732704d85cac4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCompositeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCompositeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__884dfc458cead6368c0d3295c28772ff5cf61dde0cf5b5af3229e29941e1751d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCompositeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6eb1fa4aa3e7fb6bc8989fd60c541fe0826ad898621e5feaa6770256b045865e)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCompositeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__02846aa03fe1f7ea2f033394f59484566271fe43a5d4ab6005a43e03265743c0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__27760722cb3aef917ed758c10a8d131382333327bb1cbfd7089bdf5a8de5b2cb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cef069ddb8d7a3715299fc3ca5461d6982ba769e577bf976dcc8ab2c1c207ea3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualComposite]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualComposite]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a93298db41df07b102e99b8617af87e579dd34c0ffe8655a5dd7d36f15ccf81b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCompositeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCompositeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d4b029f10412d432c6ec31f0a522b0225c45b0b9a671c7f61088e31c36cd3199)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCompositeImage()

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPlacement")
    def reset_placement(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacement", []))

    @jsii.member(jsii_name="resetPlacementVar")
    def reset_placement_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacementVar", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetScaleDimension")
    def reset_scale_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimension", []))

    @jsii.member(jsii_name="resetScaleDimensionVar")
    def reset_scale_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimensionVar", []))

    @jsii.member(jsii_name="resetScaleVar")
    def reset_scale_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCompositeImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCompositeImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCompositeImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="placementInput")
    def placement_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementInput"))

    @builtins.property
    @jsii.member(jsii_name="placementVarInput")
    def placement_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionInput")
    def scale_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVarInput")
    def scale_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleVarInput")
    def scale_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b6694859a08439663a129fac0816b4c048a4fefac288c2438c41fd8e566c4b4e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__11e8f55f8d9d6f567d91a1014a1b70bc4f990fec1b9d2240fbf31e5c474f12d1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="placement")
    def placement(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placement"))

    @placement.setter
    def placement(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8c3dc41050d04c96fc07c9970ade3522a07b9262ff8a7f29a63dd17bc0c2f855)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placement", value)

    @builtins.property
    @jsii.member(jsii_name="placementVar")
    def placement_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placementVar"))

    @placement_var.setter
    def placement_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__79a86fea719a780c06fc3105d23bdc29d3d65c7c2d698f8fbb7a5ea2e65a07bc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placementVar", value)

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scale"))

    @scale.setter
    def scale(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f71ed66bfd290cf90292413757cd7c6e86902b91946516ba7df57c8f0ed98367)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scale", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimension")
    def scale_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimension"))

    @scale_dimension.setter
    def scale_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__10586a148b7c53e6e12ba562ba9b6dcea96c40e41c840ccad3aef329f5151dc5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimension", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVar")
    def scale_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimensionVar"))

    @scale_dimension_var.setter
    def scale_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__69d9a4fc9c010b27cb8df42bcad10c758ce8872c0dd981f1201ab86456ef2893)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="scaleVar")
    def scale_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleVar"))

    @scale_var.setter
    def scale_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__75413ce5f027e3d3cf9ab43e48702f47bd37758f02c801bb4314a7215ede209a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__95cf7ca4719161f1823f2103d559537e1a5cb2f09783d782a30b16a8047ad80c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__882c4bfaf376e41aa525d343ce825ddfba20f3e50e11140ad117c77c1f2c2725)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a4869aff12459ad66ac899abfb2eda31eb13247e4ef485176594db05493866ca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__017af668fd329921f33914432a8da6a90bccebee01bd1cb46275506acc4e4f36)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualComposite]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualComposite]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualComposite]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c1b91055eeca7a1c357e32408f94f196482ffc9c5b307c5bc10f76069543d61c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCompound",
    jsii_struct_bases=[],
    name_mapping={"transformations": "transformations"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCompound:
    def __init__(
        self,
        *,
        transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param transformations: transformations block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c6fc6444e51a41637dd516adab4ca518c2c11378b3398d42acf6d0075edf0da3)
            check_type(argname="argument transformations", value=transformations, expected_type=type_hints["transformations"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if transformations is not None:
            self._values["transformations"] = transformations

    @builtins.property
    def transformations(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCompoundTransformations"]]]:
        '''transformations block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        result = self._values.get("transformations")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCompoundTransformations"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCompound(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCompoundList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCompoundList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9fa0301080d2e2016382b1d12041e4286e5121129bdd64b55044abf742b50cee)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCompoundOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e33d3d6f18392765e60c203b0d0fc96750a7e5e0ebf3dc3972758882fc521e6e)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCompoundOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__029ef8bf813b8cac894e12c0e164e66aee0f89ad9067268db83416d0459fee3a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__20143dacd8bdfbd04c82fc2c13f579f900322f0b4f18b5844c24ba5a4859e621)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f441956c4037b2c588ee94669b03bc37e927e76e300e92a82ada51d5589c0e8a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCompound]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCompound]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__62bb4357a4a291b8c3cbcd82fc36506aba95bbf8bbe7bf2bb0483aa5e2c2b9e8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCompoundOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCompoundOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1ee59d83fe2673b5743eefaa6691f6e7814f714561d01b90c064875c2f657ea0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformations")
    def put_transformations(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fb00dcd4c1635fbc339b567a039ab6f0c82ac69a72b3eea63bf95ff7f5dd26c3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTransformations", [value]))

    @jsii.member(jsii_name="resetTransformations")
    def reset_transformations(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformations", []))

    @builtins.property
    @jsii.member(jsii_name="transformations")
    def transformations(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCompoundTransformationsList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCompoundTransformationsList", jsii.get(self, "transformations"))

    @builtins.property
    @jsii.member(jsii_name="transformationsInput")
    def transformations_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCompoundTransformations"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCompoundTransformations"]]], jsii.get(self, "transformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCompound]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCompound]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCompound]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__386837ffdffa798a5066d995e1eadf2306b9e81f655d9671318bbfb4e35fbde7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCompoundTransformations",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCompoundTransformations:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCompoundTransformations(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCompoundTransformationsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCompoundTransformationsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6ac7e898f71db0a68528d1900165ea45a75b3ab30fb4a22d26b333ca6faec48e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCompoundTransformationsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__05ec826909bb81f99131702bfa93a23afd692a5fde3ad4d45581bbf310025bcd)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCompoundTransformationsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb8b227515d1253d1531e2dab991060bd7f6c80efa85eb34bce7380855267e8a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__98a3c36d9bab92337b8a99ca3b6acd0c05ad7157a82e3f426ccb22a9c4355cdf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__603597283f5e08f31c278d49af8b83d8e331c30cdc02094427e9302bdbaf2780)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCompoundTransformations]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCompoundTransformations]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCompoundTransformations]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f7b85fc69b17e629bfa4542f7db60376e6204cf35ec2a2e5bf028e36be90f730)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCompoundTransformationsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCompoundTransformationsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1c59ad070326af3ba3fba5ff934d20fef9b4c709a1ef13dbbdee1b5fc429b397)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCompoundTransformations]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCompoundTransformations]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCompoundTransformations]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dbe724eaa950117f14e201b909e41a54a6a1da226277943d9d069cc483accd09)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualContrast",
    jsii_struct_bases=[],
    name_mapping={
        "brightness": "brightness",
        "brightness_var": "brightnessVar",
        "contrast": "contrast",
        "contrast_var": "contrastVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualContrast:
    def __init__(
        self,
        *,
        brightness: typing.Optional[builtins.str] = None,
        brightness_var: typing.Optional[builtins.str] = None,
        contrast: typing.Optional[builtins.str] = None,
        contrast_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param brightness: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        :param brightness_var: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        :param contrast: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param contrast_var: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0657400718ae053660d513ba4f6a779d085e74d3fe26045791ab502b64ab2b46)
            check_type(argname="argument brightness", value=brightness, expected_type=type_hints["brightness"])
            check_type(argname="argument brightness_var", value=brightness_var, expected_type=type_hints["brightness_var"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument contrast_var", value=contrast_var, expected_type=type_hints["contrast_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if brightness is not None:
            self._values["brightness"] = brightness
        if brightness_var is not None:
            self._values["brightness_var"] = brightness_var
        if contrast is not None:
            self._values["contrast"] = contrast
        if contrast_var is not None:
            self._values["contrast_var"] = contrast_var

    @builtins.property
    def brightness(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        '''
        result = self._values.get("brightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def brightness_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        '''
        result = self._values.get("brightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        result = self._values.get("contrast_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualContrast(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualContrastList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualContrastList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__efc866ae6cee126475e27df74ea02aa20b134a148fc0a43ade306c07b0a85cb5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualContrastOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5bd58c6a245636df398489572e9456b6841cf3f892ae10d3967f49ded7388fb5)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualContrastOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d7491777962e60b74d09335f15a1bdbff5f8cffc50f6aaeeb6adde3cdde3097)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f2867ff1ab65497aa846f41c7be012b48ed5dfa650efc3c183254e3926466835)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac5785b89459e3910dcc9b5748f2c43a7a7d29c7b8f1c8547a4613b928d767a3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualContrast]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualContrast]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8947337432732497c7c15a82028dabe17e67315713facffb1c0b7d0e0a41acd7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualContrastOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualContrastOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__64a760fdd64a58ba7d1eabc547e1e2ce2be2967320a999e88a89a42ede86c3ee)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetBrightness")
    def reset_brightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightness", []))

    @jsii.member(jsii_name="resetBrightnessVar")
    def reset_brightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightnessVar", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetContrastVar")
    def reset_contrast_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrastVar", []))

    @builtins.property
    @jsii.member(jsii_name="brightnessInput")
    def brightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="brightnessVarInput")
    def brightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastVarInput")
    def contrast_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="brightness")
    def brightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightness"))

    @brightness.setter
    def brightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2dad63779cbf8cc2c252b310b4349070e2052f902b31e878304a3eb30dd489dc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightness", value)

    @builtins.property
    @jsii.member(jsii_name="brightnessVar")
    def brightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightnessVar"))

    @brightness_var.setter
    def brightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c11204f919111e303dbbf366376d14fc044100e63ee71a3760369e1f34a7d370)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrast"))

    @contrast.setter
    def contrast(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a5ff3d0c6e64f3ab572b44f9f726416b9902cbc159dcc674c4236ef128826b0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrast", value)

    @builtins.property
    @jsii.member(jsii_name="contrastVar")
    def contrast_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrastVar"))

    @contrast_var.setter
    def contrast_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__64fe47a7408bc82dc2b41c9a91d1576d99bec7443d013b91c6d2db29e80491ad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrastVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualContrast]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualContrast]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualContrast]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5e000b334841225758dda2dfa276074b34c1c42ff2f54b6da90c01a52a466f20)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCrop",
    jsii_struct_bases=[],
    name_mapping={
        "allow_expansion": "allowExpansion",
        "allow_expansion_var": "allowExpansionVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCrop:
    def __init__(
        self,
        *,
        allow_expansion: typing.Optional[builtins.str] = None,
        allow_expansion_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_expansion: If cropping an area outside of the existing canvas, expands the image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        :param allow_expansion_var: If cropping an area outside of the existing canvas, expands the image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        :param gravity: Frame of reference for X and Y Positions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Frame of reference for X and Y Positions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The number of pixels to crop along the y-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The number of pixels to crop along the y-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The number of pixels to crop along the x-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The number of pixels to crop along the x-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        :param x_position: The x-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b101ea9274b414c864fd8e711d04c42f3ea8ee9367e4e8baa0e8134cb8f69e9d)
            check_type(argname="argument allow_expansion", value=allow_expansion, expected_type=type_hints["allow_expansion"])
            check_type(argname="argument allow_expansion_var", value=allow_expansion_var, expected_type=type_hints["allow_expansion_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if allow_expansion is not None:
            self._values["allow_expansion"] = allow_expansion
        if allow_expansion_var is not None:
            self._values["allow_expansion_var"] = allow_expansion_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def allow_expansion(self) -> typing.Optional[builtins.str]:
        '''If cropping an area outside of the existing canvas, expands the image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        '''
        result = self._values.get("allow_expansion")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def allow_expansion_var(self) -> typing.Optional[builtins.str]:
        '''If cropping an area outside of the existing canvas, expands the image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        '''
        result = self._values.get("allow_expansion_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Frame of reference for X and Y Positions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Frame of reference for X and Y Positions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the y-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the y-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the x-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the x-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c8dbe9b6160ec357048bb53d61a74811eb9c6244b2639955d63f8dce74ba2f5c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8ff51ce524b7f3b717979f7e69bd7b909afa1af864a167c504085dfaeadf6cca)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__04efd5155cdf5482fda3fd0e829d91bc93c66d007f592b0b962f7282351d1c1f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__41be9fe8bba1f316b2a87db1235a645995554d825979b6e97e85d74e63c10550)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__193c066870123bd3699d72141e8eea1a1dbc3d29c0ae7f9ba11c1eed3f7df416)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b8b49dea8a020ddb714154535b52ea5e4e136313134c198a40bf87abc3c77850)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a99319306827fd69b19340b09041df4f057facf9f467093dea9733d642d80918)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAllowExpansion")
    def reset_allow_expansion(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansion", []))

    @jsii.member(jsii_name="resetAllowExpansionVar")
    def reset_allow_expansion_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansionVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionInput")
    def allow_expansion_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVarInput")
    def allow_expansion_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansion")
    def allow_expansion(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansion"))

    @allow_expansion.setter
    def allow_expansion(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3aabb4da866bf7ab3ca07653e5e64261105d2b671eff01d74ab7979a1e85a7a9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansion", value)

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVar")
    def allow_expansion_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansionVar"))

    @allow_expansion_var.setter
    def allow_expansion_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c7c9f523dd9af868000c9d187347dde4b2b35162541aa46bbce2ed2eec9cb4fc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansionVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__da013f8774dd937cd5d72927acb8b72e17a551c1a7acfab56ef1d63447f770c0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9c12fa7b85444e9e90aa24040e5a2588fa11e6850acb0b2d2c4937755f7ce073)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__08fd594a5f800b48835f5d6ceeebfa1cf987bd79d499346853e7335cb0b30de0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e344177f7237246874c7f47272beb834cd2d22d89d00cacacd63e9783c80adcf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__30e2109678bd14ce5e3e0614338885be6c2668f9c50f19bdd83d09fa7f8e6f3c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__02e4a0c10d3d916c148405f03dc6f1cb3fca0ae29e5d69e1d1a5a0e419401b50)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1a1316448b16b6057faaf2091845226dd51ca0a2dd056d75fcc7c03541d1c26b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dc578b402fef1b3b20da8e49135af3d1597ad7f892de4eb69d9eb3aa3b51f5e5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c71880ea7ed48267c12eea49b7dd88a2f4f2100534123dfde5b2d063892fc3d7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__28bd35cdebf6650c4a4c3a4ed91fa890ef2a5725ed4fd04a5193042917b99bcb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__082965841fc795867462b4d403e2acc020aeb9d34c0424029104d6bdeba929aa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualFaceCrop",
    jsii_struct_bases=[],
    name_mapping={
        "algorithm": "algorithm",
        "algorithm_var": "algorithmVar",
        "confidence": "confidence",
        "confidence_var": "confidenceVar",
        "fail_gravity": "failGravity",
        "fail_gravity_var": "failGravityVar",
        "focus": "focus",
        "focus_var": "focusVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "padding": "padding",
        "padding_var": "paddingVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualFaceCrop:
    def __init__(
        self,
        *,
        algorithm: typing.Optional[builtins.str] = None,
        algorithm_var: typing.Optional[builtins.str] = None,
        confidence: typing.Optional[builtins.str] = None,
        confidence_var: typing.Optional[builtins.str] = None,
        fail_gravity: typing.Optional[builtins.str] = None,
        fail_gravity_var: typing.Optional[builtins.str] = None,
        focus: typing.Optional[builtins.str] = None,
        focus_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param algorithm: Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm DataAkamaiImagingPolicyImage#algorithm}
        :param algorithm_var: Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm_var DataAkamaiImagingPolicyImage#algorithm_var}
        :param confidence: With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image. Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence DataAkamaiImagingPolicyImage#confidence}
        :param confidence_var: With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image. Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence_var DataAkamaiImagingPolicyImage#confidence_var}
        :param fail_gravity: Controls placement of the crop if Image and Video Manager does not detect any faces in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        :param fail_gravity_var: Controls placement of the crop if Image and Video Manager does not detect any faces in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        :param focus: Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus DataAkamaiImagingPolicyImage#focus}
        :param focus_var: Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus_var DataAkamaiImagingPolicyImage#focus_var}
        :param gravity: Controls placement of the crop. Directions are relative to the face(s) plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Controls placement of the crop. Directions are relative to the face(s) plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param padding: The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        :param style: Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__913429a05fe7f7d2ff4c1ff5ebe63b2864020fc1429d59e7a00b60ed9089c2a1)
            check_type(argname="argument algorithm", value=algorithm, expected_type=type_hints["algorithm"])
            check_type(argname="argument algorithm_var", value=algorithm_var, expected_type=type_hints["algorithm_var"])
            check_type(argname="argument confidence", value=confidence, expected_type=type_hints["confidence"])
            check_type(argname="argument confidence_var", value=confidence_var, expected_type=type_hints["confidence_var"])
            check_type(argname="argument fail_gravity", value=fail_gravity, expected_type=type_hints["fail_gravity"])
            check_type(argname="argument fail_gravity_var", value=fail_gravity_var, expected_type=type_hints["fail_gravity_var"])
            check_type(argname="argument focus", value=focus, expected_type=type_hints["focus"])
            check_type(argname="argument focus_var", value=focus_var, expected_type=type_hints["focus_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if algorithm is not None:
            self._values["algorithm"] = algorithm
        if algorithm_var is not None:
            self._values["algorithm_var"] = algorithm_var
        if confidence is not None:
            self._values["confidence"] = confidence
        if confidence_var is not None:
            self._values["confidence_var"] = confidence_var
        if fail_gravity is not None:
            self._values["fail_gravity"] = fail_gravity
        if fail_gravity_var is not None:
            self._values["fail_gravity_var"] = fail_gravity_var
        if focus is not None:
            self._values["focus"] = focus
        if focus_var is not None:
            self._values["focus_var"] = focus_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def algorithm(self) -> typing.Optional[builtins.str]:
        '''Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm DataAkamaiImagingPolicyImage#algorithm}
        '''
        result = self._values.get("algorithm")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def algorithm_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm_var DataAkamaiImagingPolicyImage#algorithm_var}
        '''
        result = self._values.get("algorithm_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def confidence(self) -> typing.Optional[builtins.str]:
        '''With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image.

        Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence DataAkamaiImagingPolicyImage#confidence}
        '''
        result = self._values.get("confidence")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def confidence_var(self) -> typing.Optional[builtins.str]:
        '''With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image.

        Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence_var DataAkamaiImagingPolicyImage#confidence_var}
        '''
        result = self._values.get("confidence_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any faces in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        '''
        result = self._values.get("fail_gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any faces in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        '''
        result = self._values.get("fail_gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def focus(self) -> typing.Optional[builtins.str]:
        '''Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus DataAkamaiImagingPolicyImage#focus}
        '''
        result = self._values.get("focus")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def focus_var(self) -> typing.Optional[builtins.str]:
        '''Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus_var DataAkamaiImagingPolicyImage#focus_var}
        '''
        result = self._values.get("focus_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the face(s) plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the face(s) plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualFaceCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualFaceCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualFaceCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c588bbe65024642868a15a509a184005ac034a68d2293da5f6c0c71e7511d9f3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualFaceCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8ea70b8a2c3ccea53a229eb947ec945ff012fde7be0ad75983349d480572379b)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualFaceCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__295ba740e60087e4ec9ad8dd60472885856931ca868921452e06aac890c9a36c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f3de24a296e8bb9be08b3b22615dd9217f5c0523bcd367300005b75f368f999c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ccec7e0d657c19ac2a27be9718a897c1c06ea5d83ae8dcb86104ca5c143e95c1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualFaceCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualFaceCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualFaceCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b6b217390fc34ccc1308e95350e752043626f4a7dee2b563a3047222c22d2051)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualFaceCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualFaceCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6b0e43997aded465e00beb098748c37835da7cea613ebca2fd7b0f2dca76754d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAlgorithm")
    def reset_algorithm(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAlgorithm", []))

    @jsii.member(jsii_name="resetAlgorithmVar")
    def reset_algorithm_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAlgorithmVar", []))

    @jsii.member(jsii_name="resetConfidence")
    def reset_confidence(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetConfidence", []))

    @jsii.member(jsii_name="resetConfidenceVar")
    def reset_confidence_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetConfidenceVar", []))

    @jsii.member(jsii_name="resetFailGravity")
    def reset_fail_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravity", []))

    @jsii.member(jsii_name="resetFailGravityVar")
    def reset_fail_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravityVar", []))

    @jsii.member(jsii_name="resetFocus")
    def reset_focus(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFocus", []))

    @jsii.member(jsii_name="resetFocusVar")
    def reset_focus_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFocusVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="algorithmInput")
    def algorithm_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "algorithmInput"))

    @builtins.property
    @jsii.member(jsii_name="algorithmVarInput")
    def algorithm_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "algorithmVarInput"))

    @builtins.property
    @jsii.member(jsii_name="confidenceInput")
    def confidence_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "confidenceInput"))

    @builtins.property
    @jsii.member(jsii_name="confidenceVarInput")
    def confidence_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "confidenceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityInput")
    def fail_gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityVarInput")
    def fail_gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="focusInput")
    def focus_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "focusInput"))

    @builtins.property
    @jsii.member(jsii_name="focusVarInput")
    def focus_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "focusVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="algorithm")
    def algorithm(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "algorithm"))

    @algorithm.setter
    def algorithm(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ad63fb6895d447b36eb1a2bcc10ed7bc5f08597db81d842676dc5b5f721fc00f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "algorithm", value)

    @builtins.property
    @jsii.member(jsii_name="algorithmVar")
    def algorithm_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "algorithmVar"))

    @algorithm_var.setter
    def algorithm_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bbb9c780a6bbe7c7c3b95bc2be11761bc0cc9f829b92846122aeeb90c0191ecb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "algorithmVar", value)

    @builtins.property
    @jsii.member(jsii_name="confidence")
    def confidence(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "confidence"))

    @confidence.setter
    def confidence(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__64bb27de8f56e845a8ca410d5ac8e8a6a5acea62e6d5089c3d7f7671dc2321b5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "confidence", value)

    @builtins.property
    @jsii.member(jsii_name="confidenceVar")
    def confidence_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "confidenceVar"))

    @confidence_var.setter
    def confidence_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__24e040f772a31be836f5114c4f366c4998a34df7c2fddc34f112f6126821f9c1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "confidenceVar", value)

    @builtins.property
    @jsii.member(jsii_name="failGravity")
    def fail_gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravity"))

    @fail_gravity.setter
    def fail_gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__523989044a2eb31c23ea0ad069c712a080fab159e97c1abbf544dcec947be50f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravity", value)

    @builtins.property
    @jsii.member(jsii_name="failGravityVar")
    def fail_gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravityVar"))

    @fail_gravity_var.setter
    def fail_gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ba1fee9b363e71e652a070dbb4bd81cf63a9e6238d1cdc99b61db95b678a988)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="focus")
    def focus(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "focus"))

    @focus.setter
    def focus(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7ece9f511c970a104b7bf6ae101db82060e9956e3b2b7e4e9030c70849fcdcfd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "focus", value)

    @builtins.property
    @jsii.member(jsii_name="focusVar")
    def focus_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "focusVar"))

    @focus_var.setter
    def focus_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eb5e2b1ff3e373cdc92ed5d088e136831057326db1443dde9e0a2a4d8bad0cf0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "focusVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d42ed26ec0840b39f616bdbb27bc71dd8135b1841ee7321c0c84ccf98247dbf2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a2528f7185e2b81766329357a301c865d88b8f3e091d911b35a69eaae41a428)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__14620255319b1741e467f6e6879ba1275ebbf693731f9b3c8fa139715100b716)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a9387c1e4a46b749262a325e33899530b45dc9c61030ce83d58997bb046feb87)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eeaa4e73f59df9f0704c216233d390cfd0acf2ed84b03248ce332ea048341c66)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__614843cf6588c92ea8f757e530e1e873905ffa677ba282c66eb79c9ec8afd9a8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c5a6e0870d1e8b95604a01d15ff6439b1c2f30e4274b7fbc8a9a2382ea26c413)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ab4014d16eb77213610694b0a1088c321212adcb7577d9b6cab900ea5244a4e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__39e8bd223964e87b525e25b9d1d947afd05f92d3d97f8820d57948d266c69ffd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ecd36b74cd1d147f5dad45116849362a2a293e9d2ba8373c7a4c3d7b3619bfa5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualFaceCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualFaceCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualFaceCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab24950bd8bb2e66fa1cf2dfe3136ac1ab8249621ac55e406324f8be8174faff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualFeatureCrop",
    jsii_struct_bases=[],
    name_mapping={
        "fail_gravity": "failGravity",
        "fail_gravity_var": "failGravityVar",
        "feature_radius": "featureRadius",
        "feature_radius_var": "featureRadiusVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "max_features": "maxFeatures",
        "max_features_var": "maxFeaturesVar",
        "min_feature_quality": "minFeatureQuality",
        "min_feature_quality_var": "minFeatureQualityVar",
        "padding": "padding",
        "padding_var": "paddingVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualFeatureCrop:
    def __init__(
        self,
        *,
        fail_gravity: typing.Optional[builtins.str] = None,
        fail_gravity_var: typing.Optional[builtins.str] = None,
        feature_radius: typing.Optional[builtins.str] = None,
        feature_radius_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        max_features: typing.Optional[builtins.str] = None,
        max_features_var: typing.Optional[builtins.str] = None,
        min_feature_quality: typing.Optional[builtins.str] = None,
        min_feature_quality_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fail_gravity: Controls placement of the crop if Image and Video Manager does not detect any features in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        :param fail_gravity_var: Controls placement of the crop if Image and Video Manager does not detect any features in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        :param feature_radius: The size in pixels of the important features to search for. If identified, two features never appear closer together than this value, ``8.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius DataAkamaiImagingPolicyImage#feature_radius}
        :param feature_radius_var: The size in pixels of the important features to search for. If identified, two features never appear closer together than this value, ``8.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius_var DataAkamaiImagingPolicyImage#feature_radius_var}
        :param gravity: Controls placement of the crop. Directions are relative to the region of interest plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Controls placement of the crop. Directions are relative to the region of interest plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param max_features: The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features DataAkamaiImagingPolicyImage#max_features}
        :param max_features_var: The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features_var DataAkamaiImagingPolicyImage#max_features_var}
        :param min_feature_quality: Determines the minimum quality level of the feature identified. To consider a feature important, the feature needs to surpass this value. Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality DataAkamaiImagingPolicyImage#min_feature_quality}
        :param min_feature_quality_var: Determines the minimum quality level of the feature identified. To consider a feature important, the feature needs to surpass this value. Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality_var DataAkamaiImagingPolicyImage#min_feature_quality_var}
        :param padding: Adds space around the region of interest. The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: Adds space around the region of interest. The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        :param style: Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ac432d43e8c4ffdcbd54ca4956a644446a7539c4cefcb0f1bbaf83f769f6bcc)
            check_type(argname="argument fail_gravity", value=fail_gravity, expected_type=type_hints["fail_gravity"])
            check_type(argname="argument fail_gravity_var", value=fail_gravity_var, expected_type=type_hints["fail_gravity_var"])
            check_type(argname="argument feature_radius", value=feature_radius, expected_type=type_hints["feature_radius"])
            check_type(argname="argument feature_radius_var", value=feature_radius_var, expected_type=type_hints["feature_radius_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument max_features", value=max_features, expected_type=type_hints["max_features"])
            check_type(argname="argument max_features_var", value=max_features_var, expected_type=type_hints["max_features_var"])
            check_type(argname="argument min_feature_quality", value=min_feature_quality, expected_type=type_hints["min_feature_quality"])
            check_type(argname="argument min_feature_quality_var", value=min_feature_quality_var, expected_type=type_hints["min_feature_quality_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fail_gravity is not None:
            self._values["fail_gravity"] = fail_gravity
        if fail_gravity_var is not None:
            self._values["fail_gravity_var"] = fail_gravity_var
        if feature_radius is not None:
            self._values["feature_radius"] = feature_radius
        if feature_radius_var is not None:
            self._values["feature_radius_var"] = feature_radius_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if max_features is not None:
            self._values["max_features"] = max_features
        if max_features_var is not None:
            self._values["max_features_var"] = max_features_var
        if min_feature_quality is not None:
            self._values["min_feature_quality"] = min_feature_quality
        if min_feature_quality_var is not None:
            self._values["min_feature_quality_var"] = min_feature_quality_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def fail_gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any features in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        '''
        result = self._values.get("fail_gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any features in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        '''
        result = self._values.get("fail_gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feature_radius(self) -> typing.Optional[builtins.str]:
        '''The size in pixels of the important features to search for.

        If identified, two features never appear closer together than this value, ``8.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius DataAkamaiImagingPolicyImage#feature_radius}
        '''
        result = self._values.get("feature_radius")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feature_radius_var(self) -> typing.Optional[builtins.str]:
        '''The size in pixels of the important features to search for.

        If identified, two features never appear closer together than this value, ``8.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius_var DataAkamaiImagingPolicyImage#feature_radius_var}
        '''
        result = self._values.get("feature_radius_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the region of interest plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the region of interest plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def max_features(self) -> typing.Optional[builtins.str]:
        '''The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features DataAkamaiImagingPolicyImage#max_features}
        '''
        result = self._values.get("max_features")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def max_features_var(self) -> typing.Optional[builtins.str]:
        '''The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features_var DataAkamaiImagingPolicyImage#max_features_var}
        '''
        result = self._values.get("max_features_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def min_feature_quality(self) -> typing.Optional[builtins.str]:
        '''Determines the minimum quality level of the feature identified.

        To consider a feature important, the feature needs to surpass this value.  Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality DataAkamaiImagingPolicyImage#min_feature_quality}
        '''
        result = self._values.get("min_feature_quality")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def min_feature_quality_var(self) -> typing.Optional[builtins.str]:
        '''Determines the minimum quality level of the feature identified.

        To consider a feature important, the feature needs to surpass this value.  Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality_var DataAkamaiImagingPolicyImage#min_feature_quality_var}
        '''
        result = self._values.get("min_feature_quality_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''Adds space around the region of interest.

        The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''Adds space around the region of interest.

        The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualFeatureCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualFeatureCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualFeatureCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac62d1321e4a9d9dcc858d706ee6b883ba04b902d3f1156ed0c424204b201db0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualFeatureCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__092f65170fcd327c0cd05230fcce507b1a6b6bf5cd929d9d5d62f5b8c344223f)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualFeatureCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__172e66b1c578b95611835850134cac49ecf27b64c89acf7eedf7163b531dbe92)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c245da6993f0b60d3b52e6ca6afbba26d0812af9266bd65bfce01d70f15090d5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ca53644d95ebfd0532f221c77dc69f66c5db63e7ec37624db8d2ad6250d021f7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualFeatureCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualFeatureCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualFeatureCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af91941a1d062f11e976f7f5e07714025b50e61b94ef99a68cb917be23b5459d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualFeatureCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualFeatureCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ef4d0ebf307d83537efdb0eab804534ac06f473bfcd8536585802e8dfbf59eb5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetFailGravity")
    def reset_fail_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravity", []))

    @jsii.member(jsii_name="resetFailGravityVar")
    def reset_fail_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravityVar", []))

    @jsii.member(jsii_name="resetFeatureRadius")
    def reset_feature_radius(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureRadius", []))

    @jsii.member(jsii_name="resetFeatureRadiusVar")
    def reset_feature_radius_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureRadiusVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetMaxFeatures")
    def reset_max_features(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxFeatures", []))

    @jsii.member(jsii_name="resetMaxFeaturesVar")
    def reset_max_features_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxFeaturesVar", []))

    @jsii.member(jsii_name="resetMinFeatureQuality")
    def reset_min_feature_quality(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMinFeatureQuality", []))

    @jsii.member(jsii_name="resetMinFeatureQualityVar")
    def reset_min_feature_quality_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMinFeatureQualityVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="failGravityInput")
    def fail_gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityVarInput")
    def fail_gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featureRadiusInput")
    def feature_radius_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featureRadiusInput"))

    @builtins.property
    @jsii.member(jsii_name="featureRadiusVarInput")
    def feature_radius_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featureRadiusVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesInput")
    def max_features_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "maxFeaturesInput"))

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesVarInput")
    def max_features_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "maxFeaturesVarInput"))

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityInput")
    def min_feature_quality_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "minFeatureQualityInput"))

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityVarInput")
    def min_feature_quality_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "minFeatureQualityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravity")
    def fail_gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravity"))

    @fail_gravity.setter
    def fail_gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2fca1134eab43d61988c2bc4630eb1ae139f5eb9531b2fbccc3b85cc0e5183b9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravity", value)

    @builtins.property
    @jsii.member(jsii_name="failGravityVar")
    def fail_gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravityVar"))

    @fail_gravity_var.setter
    def fail_gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d86c5a5d49e29aeca39e44ae8db57bc9623cefedd7d237d40226f7b703f5ae2b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="featureRadius")
    def feature_radius(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featureRadius"))

    @feature_radius.setter
    def feature_radius(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__94eae676bde88c27cd6aa9b5e40d0ad710d902a1fd8862ed88123f8cb5498528)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featureRadius", value)

    @builtins.property
    @jsii.member(jsii_name="featureRadiusVar")
    def feature_radius_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featureRadiusVar"))

    @feature_radius_var.setter
    def feature_radius_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__30704495f8692afd5760cb661b251ac0db027051594ce55754f3a7560a809d60)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featureRadiusVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e9823bcb619409cf6016eb40e31d96772de2438903999ae0ad0f1493f6c22ab1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e5e8f07b1c4436aacb94f9c8d3a1c35cd72106b0c6d89b18329ec09049ab55fc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d740c1172ef83b4635afb1bb9bbfd431f14267ab00bc77ccbe86b9647083a9d0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__33e4ccce970f4f5bcbc08d3d87f7b4fbafc8bcc344ffbd521bb734f16088ae91)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="maxFeatures")
    def max_features(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "maxFeatures"))

    @max_features.setter
    def max_features(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a37e24dd85f3ce66efed62776ab98b50ab973c1992c4b2d961afacd64da6d260)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "maxFeatures", value)

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesVar")
    def max_features_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "maxFeaturesVar"))

    @max_features_var.setter
    def max_features_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1ef2812bd2b150b6f07d1bca1135c441f0dbb8190dff8a1df6f3e3d93695b91b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "maxFeaturesVar", value)

    @builtins.property
    @jsii.member(jsii_name="minFeatureQuality")
    def min_feature_quality(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "minFeatureQuality"))

    @min_feature_quality.setter
    def min_feature_quality(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be32d450b3de1dcbc7e8deee03aae7d9da83ba3010b905a77e83228eb4af8ae7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "minFeatureQuality", value)

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityVar")
    def min_feature_quality_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "minFeatureQualityVar"))

    @min_feature_quality_var.setter
    def min_feature_quality_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__94f9c24a54960c5d37a4fb94b5a5211407ff96ce0aa9ff131b9041728c0969fe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "minFeatureQualityVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__33862e075713324e229a9f062b9e986e90fc555e331685e2472aede72694dee8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5e6c927ec47d9aa78bb50cbba14d7a3dccce9663cba12b817f525902b0bee63e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a03e0a7a0c1ab0e8d7bd9533057f7253f3efd99b059fa711bb5d529e9d35c57)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8d9be60d0707203f63e6f384f2f923c7674b51863bab01911aa85e7e85af24a9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__954a8a598de54a83cf88b5bf07db3000b1ad8c80d62f3e7519eb0ebdd7bdeaa6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__85a2d9b9faadf19615be3bad1305eaa98273777963f0099af4c7ffc40110c336)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualFeatureCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualFeatureCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualFeatureCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5d608bcd469eeb8bf56944bbfdebd86c543724c28be666e8f7806fc6805626d6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualFitAndFill",
    jsii_struct_bases=[],
    name_mapping={
        "fill_transformation": "fillTransformation",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualFitAndFill:
    def __init__(
        self,
        *,
        fill_transformation: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualFitAndFillFillTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fill_transformation: fill_transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_transformation DataAkamaiImagingPolicyImage#fill_transformation}
        :param height: The height value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The width value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(fill_transformation, dict):
            fill_transformation = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualFitAndFillFillTransformation(**fill_transformation)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__11d74ab87fdac53a60cccf278aeb52c482f2a1005031a64f53b543ab9865795e)
            check_type(argname="argument fill_transformation", value=fill_transformation, expected_type=type_hints["fill_transformation"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fill_transformation is not None:
            self._values["fill_transformation"] = fill_transformation
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def fill_transformation(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualFitAndFillFillTransformation"]:
        '''fill_transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_transformation DataAkamaiImagingPolicyImage#fill_transformation}
        '''
        result = self._values.get("fill_transformation")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualFitAndFillFillTransformation"], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualFitAndFill(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualFitAndFillFillTransformation",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualFitAndFillFillTransformation:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualFitAndFillFillTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualFitAndFillFillTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualFitAndFillFillTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__63c2b7e46a4c0091d8b5b3e27f3ada364cdf603bac2a7fd25a1ed7bd40321224)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualFitAndFillFillTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualFitAndFillFillTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualFitAndFillFillTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__74bea156973eb3bd724deea0615d49ef9855ebdd6b4ab4ec06d07abc5ef9bf41)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualFitAndFillList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualFitAndFillList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c633d30613e9ed8226feef4940ba520775be15fbe10d5d35b60fe3c92154079a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualFitAndFillOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__62fa49a382a12e366a981296455e95b290e9298ae879cbfa849b0be721b1af11)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualFitAndFillOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__61148d2c9e32d4c633afcafaf858a8ed99968b64a9eb0410cf7eb82480ecb2c4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2c38cb32851abb4a763160857e24550e4e5c8bb8718ec95038c61e79bbc6391e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e5eac248e21ed4dbe69287a8c1f06a933ebb6df1a14cd7aad566e6c9decd43dd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualFitAndFill]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualFitAndFill]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualFitAndFill]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc759e327deebe82f1e2399d10d77e3a3de12b4095ef2498740cf49f5c524dba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualFitAndFillOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualFitAndFillOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4589349279b5f4bcac5c1176d2c95e36049b5902d38794f659eadcb784d90ed8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putFillTransformation")
    def put_fill_transformation(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualFitAndFillFillTransformation()

        return typing.cast(None, jsii.invoke(self, "putFillTransformation", [value]))

    @jsii.member(jsii_name="resetFillTransformation")
    def reset_fill_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFillTransformation", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="fillTransformation")
    def fill_transformation(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualFitAndFillFillTransformationOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualFitAndFillFillTransformationOutputReference, jsii.get(self, "fillTransformation"))

    @builtins.property
    @jsii.member(jsii_name="fillTransformationInput")
    def fill_transformation_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualFitAndFillFillTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualFitAndFillFillTransformation], jsii.get(self, "fillTransformationInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f6de729243cc95387bf7deef52b1636dab7ba2e34258bc306fb19772b4e9e15)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e53ddd94157bd026e04e05e73b3889f9cb46ac70095b1bed2e62a87489ddb660)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3d97017cc2de5be4380a3e180cf53366b91f4af83023409f4c65d182c29a1e1c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a924fa82d28cd5ab1f06f9874c49ee33339974ee55e9da8e6832ee1709cfd079)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualFitAndFill]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualFitAndFill]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualFitAndFill]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e5cc42902f476291962f05e08b022bd690032e710245f4fd27897c1c984f0ba6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualGoop",
    jsii_struct_bases=[],
    name_mapping={
        "chaos": "chaos",
        "chaos_var": "chaosVar",
        "density": "density",
        "density_var": "densityVar",
        "power": "power",
        "power_var": "powerVar",
        "seed": "seed",
        "seed_var": "seedVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualGoop:
    def __init__(
        self,
        *,
        chaos: typing.Optional[builtins.str] = None,
        chaos_var: typing.Optional[builtins.str] = None,
        density: typing.Optional[builtins.str] = None,
        density_var: typing.Optional[builtins.str] = None,
        power: typing.Optional[builtins.str] = None,
        power_var: typing.Optional[builtins.str] = None,
        seed: typing.Optional[builtins.str] = None,
        seed_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param chaos: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        :param chaos_var: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        :param density: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        :param density_var: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        :param power: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        :param power_var: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        :param seed: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        :param seed_var: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7f614eff8842d2ce1b1417609853e08538600d32edbdb9f45e9b7c468a21e240)
            check_type(argname="argument chaos", value=chaos, expected_type=type_hints["chaos"])
            check_type(argname="argument chaos_var", value=chaos_var, expected_type=type_hints["chaos_var"])
            check_type(argname="argument density", value=density, expected_type=type_hints["density"])
            check_type(argname="argument density_var", value=density_var, expected_type=type_hints["density_var"])
            check_type(argname="argument power", value=power, expected_type=type_hints["power"])
            check_type(argname="argument power_var", value=power_var, expected_type=type_hints["power_var"])
            check_type(argname="argument seed", value=seed, expected_type=type_hints["seed"])
            check_type(argname="argument seed_var", value=seed_var, expected_type=type_hints["seed_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if chaos is not None:
            self._values["chaos"] = chaos
        if chaos_var is not None:
            self._values["chaos_var"] = chaos_var
        if density is not None:
            self._values["density"] = density
        if density_var is not None:
            self._values["density_var"] = density_var
        if power is not None:
            self._values["power"] = power
        if power_var is not None:
            self._values["power_var"] = power_var
        if seed is not None:
            self._values["seed"] = seed
        if seed_var is not None:
            self._values["seed_var"] = seed_var

    @builtins.property
    def chaos(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        '''
        result = self._values.get("chaos")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def chaos_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        '''
        result = self._values.get("chaos_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        '''
        result = self._values.get("density")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density_var(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        '''
        result = self._values.get("density_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        '''
        result = self._values.get("power")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power_var(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        '''
        result = self._values.get("power_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        '''
        result = self._values.get("seed")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed_var(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        result = self._values.get("seed_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualGoop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualGoopList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualGoopList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b40d8ab48eb484bdc3497ef99d40e7720bcbd6856bb0d44dece0be73e339e886)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualGoopOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__56b05107731b39f744fbdef71e961d2dc4657920175bce02b5a735178b0b27f4)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualGoopOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__acb5cf78978131c09f2feffc9abee4a7067d2efc9e97deb8d22bd10db62782a0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fcfda43af128731f6ad2ec899a866aa0e813e02b0c84772d08cedd87f2918d66)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8b323c47bd388237be4854b5d8d4a2d22c136f95961c47888ef135d4d0f10b1a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualGoop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualGoop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__431dc82bdbe7243eaa88aeecf1765380c096b16709ae82db5e1b4baa37c5d1e4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualGoopOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualGoopOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3b6d405c717cf59ce0a3d59e8a4b920a80c081c4f3a343819ec1d06d1b8e990a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetChaos")
    def reset_chaos(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaos", []))

    @jsii.member(jsii_name="resetChaosVar")
    def reset_chaos_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaosVar", []))

    @jsii.member(jsii_name="resetDensity")
    def reset_density(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensity", []))

    @jsii.member(jsii_name="resetDensityVar")
    def reset_density_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensityVar", []))

    @jsii.member(jsii_name="resetPower")
    def reset_power(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPower", []))

    @jsii.member(jsii_name="resetPowerVar")
    def reset_power_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPowerVar", []))

    @jsii.member(jsii_name="resetSeed")
    def reset_seed(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeed", []))

    @jsii.member(jsii_name="resetSeedVar")
    def reset_seed_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeedVar", []))

    @builtins.property
    @jsii.member(jsii_name="chaosInput")
    def chaos_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosInput"))

    @builtins.property
    @jsii.member(jsii_name="chaosVarInput")
    def chaos_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosVarInput"))

    @builtins.property
    @jsii.member(jsii_name="densityInput")
    def density_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityInput"))

    @builtins.property
    @jsii.member(jsii_name="densityVarInput")
    def density_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="powerInput")
    def power_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerInput"))

    @builtins.property
    @jsii.member(jsii_name="powerVarInput")
    def power_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerVarInput"))

    @builtins.property
    @jsii.member(jsii_name="seedInput")
    def seed_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedInput"))

    @builtins.property
    @jsii.member(jsii_name="seedVarInput")
    def seed_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedVarInput"))

    @builtins.property
    @jsii.member(jsii_name="chaos")
    def chaos(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaos"))

    @chaos.setter
    def chaos(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f8a65ee2a83ed4b431b4541bf99aa8a33b3782a2e186d4231df6a35709e087f2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaos", value)

    @builtins.property
    @jsii.member(jsii_name="chaosVar")
    def chaos_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaosVar"))

    @chaos_var.setter
    def chaos_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fe66465abb362f8ac3ff62449c214eeb0b742725ad1b561a064a82e3abd0a1c1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaosVar", value)

    @builtins.property
    @jsii.member(jsii_name="density")
    def density(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "density"))

    @density.setter
    def density(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5e223257207ab9919d6ca3d65339c5502def75f4db21185f8e60dc45e53cc8aa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "density", value)

    @builtins.property
    @jsii.member(jsii_name="densityVar")
    def density_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "densityVar"))

    @density_var.setter
    def density_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3901747e87fce7271419d42ab138ba8908de39f2490ba9cb071554972aaf318b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "densityVar", value)

    @builtins.property
    @jsii.member(jsii_name="power")
    def power(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "power"))

    @power.setter
    def power(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f15c61ec718977f527a4ad6e26fae631b9fbb35ffb10742a53bf40a30d0efab3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "power", value)

    @builtins.property
    @jsii.member(jsii_name="powerVar")
    def power_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "powerVar"))

    @power_var.setter
    def power_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d8b0ae5e3363a09b66952cd34d7834ab46003f2a8b95c6934fdd4140a43f18b2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "powerVar", value)

    @builtins.property
    @jsii.member(jsii_name="seed")
    def seed(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seed"))

    @seed.setter
    def seed(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f8185b3efbbe62a8cafa374a35b03bad6b4a86429bd41601c929979c9b03d80)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seed", value)

    @builtins.property
    @jsii.member(jsii_name="seedVar")
    def seed_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seedVar"))

    @seed_var.setter
    def seed_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aa80603583a52487c066d7a3048431865bfc961ac6b3dea284fc25344271dce9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seedVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualGoop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualGoop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualGoop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__46786b28766173a898ca35f94e62798337e41b1b487e159af51fd60f3128150d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualGrayscale",
    jsii_struct_bases=[],
    name_mapping={"type": "type", "type_var": "typeVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualGrayscale:
    def __init__(
        self,
        *,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param type: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e34fcfe621b8ede713b8b30beb275c3c8b4feea9e9fc9668c58e9ae079499245)
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualGrayscale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualGrayscaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualGrayscaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__00735450cbf8d8875b7efceed8195ae6f5181b520b997fb12d4458c2fce00c38)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualGrayscaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__24f06fc2980e462abe41f4782a02acb755d132a54df49f4b1697e5b895efcc37)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualGrayscaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9f74cb3ba90dfe9bdaac2bc01b7fce63e28a7f909d228657a55a55424d85950e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2f122bdeeadbc7057046cb0721bc1d5340f95b7863cf5d8ef7ae50b0db4d3d6f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a6e299eca28702c79e9dd4eb038ce59cb3e47c1ab5ecdc8647ddc081101bc8b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualGrayscale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualGrayscale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__58625344d9a342e4c964c0a455219dc6db9a867612bdbca536bcf5c52acdfb86)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualGrayscaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualGrayscaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6d41aa8d9860d2a02e3130d5bfc195f5cdc8d7c816935c2eb1a10237d8f1b4a9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0f318a06f45009659f1c1266f9d99c46f7aad01b73741e2a051dc5d621587356)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d04089243bb4d1576e5d4b9d461b17ab57ac0d199ceb0c6262472bc5a4f22b38)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualGrayscale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualGrayscale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualGrayscale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4333cb74fcbc31ca829856032914199440878cdff7115bea7512289d8d1786bb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualHsl",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "lightness": "lightness",
        "lightness_var": "lightnessVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualHsl:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness: typing.Optional[builtins.str] = None,
        lightness_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        :param lightness_var: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bcbfae6daad9f328c5194de4b1f3cae78d4674c4b432e7828a3b17f45509708e)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness", value=lightness, expected_type=type_hints["lightness"])
            check_type(argname="argument lightness_var", value=lightness_var, expected_type=type_hints["lightness_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness is not None:
            self._values["lightness"] = lightness
        if lightness_var is not None:
            self._values["lightness_var"] = lightness_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        '''
        result = self._values.get("lightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        '''
        result = self._values.get("lightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualHsl(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualHslList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualHslList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__257c9566dd8ebaa9fdf80d5710e4467c67a66488584d247c2bad552563f2fbed)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualHslOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0f3418dc824034c084fc6844684eb947bf909932bfe8e55d9f34a4dfa97a87b3)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualHslOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__89ee06a575e506865d31a90068e8f108865612da30aec2f08ea05174a65fd608)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__892f8a12e64c870ed5806b0beb6690daae4eddbfc1f336ebfb9f47b5c5941384)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__602ad1ea5890cc6c054e4024a78e277d86c01038ac5fc98f57fdbc84e732d039)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualHsl]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualHsl]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c11693f9b9cf2bcdaa5e4ffb692387058d60ff192fbfc7431eec973a61085ebf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualHslOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualHslOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c0cd16c4d0e156c03c0643d4ad966dac92b3d2130a918bd1e81948aec91457a9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightness")
    def reset_lightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightness", []))

    @jsii.member(jsii_name="resetLightnessVar")
    def reset_lightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessInput")
    def lightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessVarInput")
    def lightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__78041b25aff184382264d4ba38fd9fa0a11596179709752a05fa8e8a726c7a34)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__61d4fda29dfa89bff9fd6a23cea23ea2f31b43c0e6ba710ad194b69829b01f64)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightness")
    def lightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightness"))

    @lightness.setter
    def lightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__31fac27093d8c2b626b727dc47a9a3518beae5ae1557c6197f9e3c13cd6e532a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightness", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessVar")
    def lightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessVar"))

    @lightness_var.setter
    def lightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5a757e8f9195d1162917b58bc292d8c82b391debf130f7729fe4c0ea78fb8d61)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f19223c9cfec1158bbf7ee72eba584a5c2459eaa67e0493c5f3285c6fcd1d7fe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__927be7a5de6fc60c448caa655e4e8bc1eb93b3f3938516d7e688bd1807143481)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualHsl]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualHsl]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualHsl]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d0036f37e4da711ebaae42e5afa6e24cc03c2c686799f04df0ce6b9fb6036f77)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualHsv",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualHsv:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        :param value: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e43dcceb022ecc0e3220ac4300b636f7975a654d202506366982d4dd8779336b)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualHsv(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualHsvList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualHsvList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c859b14f9296c049b7d077bb8ba8248d3f29f92ad5ca52643a4f304c4e2304d6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualHsvOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__97471137c796afce0717d1604672209db4bb1763a685b6a93e2e342b56652524)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualHsvOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__447e466b2ad19e38e7a09b8597e8a521d2967e1d67e473881d3bed0baae4b683)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9442a21c74c24f5d6fcf643ce36de7349e339ffe13d763b0462732226a18d05d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bcbfd210005f561e4c59a872a30d5b5960ab946ad1acfd2487c54c67c4cbb620)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualHsv]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualHsv]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8247d4b185239c597dccf2d42ba3e2a6285fc24b6253c8c772b392c1b90b986d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualHsvOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualHsvOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__61f3153a442cd944cc1c7eca4b10903c6199d712ba5fe1a2a0ebe7dbb15b9b56)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7fb0e4f748e892f67a6bb799185f1e00346d82b480141e6094cefa36b74d1bde)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b2d1d22e596a3a6e14f04c332f10e01e5713702f6519741e9ddae1728e35540a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__45efe3fa99ad9cae199969cc56c4dfbaa0cab4614fea161d4b513d4b217d80cc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ff8dfd6d200eea76b4e4b6792deb715d3e7b80e0d4e03b5905c8c84b716dafd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7572ab4325128044c440f05aed6e6c8d5b5cc2e90c0b890b2db785450188a0f4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__414f2098545842af79cbb87be50c79718d9595f30d32cc93d3b37097076dc695)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualHsv]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualHsv]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualHsv]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__69e3fa90ceab2a51324a24e29a21722277bdc9a69268f7add5184105a18228f2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimension",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "dimension": "dimension",
        "dimension_var": "dimensionVar",
        "equal": "equal",
        "greater_than": "greaterThan",
        "less_than": "lessThan",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimension:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        dimension: typing.Optional[builtins.str] = None,
        dimension_var: typing.Optional[builtins.str] = None,
        equal: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionEqual", typing.Dict[builtins.str, typing.Any]]] = None,
        greater_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionGreaterThan", typing.Dict[builtins.str, typing.Any]]] = None,
        less_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionLessThan", typing.Dict[builtins.str, typing.Any]]] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param dimension: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        :param dimension_var: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        :param equal: equal block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        :param greater_than: greater_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        :param less_than: less_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        :param value: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionDefault(**default)
        if isinstance(equal, dict):
            equal = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionEqual(**equal)
        if isinstance(greater_than, dict):
            greater_than = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionGreaterThan(**greater_than)
        if isinstance(less_than, dict):
            less_than = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionLessThan(**less_than)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e65459ea32ba420773e5bf611b939d246a1342f64b624143159fbb64dc31c1d4)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument dimension", value=dimension, expected_type=type_hints["dimension"])
            check_type(argname="argument dimension_var", value=dimension_var, expected_type=type_hints["dimension_var"])
            check_type(argname="argument equal", value=equal, expected_type=type_hints["equal"])
            check_type(argname="argument greater_than", value=greater_than, expected_type=type_hints["greater_than"])
            check_type(argname="argument less_than", value=less_than, expected_type=type_hints["less_than"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if dimension is not None:
            self._values["dimension"] = dimension
        if dimension_var is not None:
            self._values["dimension_var"] = dimension_var
        if equal is not None:
            self._values["equal"] = equal
        if greater_than is not None:
            self._values["greater_than"] = greater_than
        if less_than is not None:
            self._values["less_than"] = less_than
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionDefault"], result)

    @builtins.property
    def dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        '''
        result = self._values.get("dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        '''
        result = self._values.get("dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def equal(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionEqual"]:
        '''equal block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        '''
        result = self._values.get("equal")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionEqual"], result)

    @builtins.property
    def greater_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionGreaterThan"]:
        '''greater_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        '''
        result = self._values.get("greater_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionGreaterThan"], result)

    @builtins.property
    def less_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionLessThan"]:
        '''less_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        '''
        result = self._values.get("less_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionLessThan"], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimension(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e4b86d18903a8ef64be20c88e5e110cac128f3576d1fdd0be56d437869ee26d7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d0b53efd31c81053d55e4e8d0863b1d803ca0dd57ccb61fa0584884f8963865c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionEqual",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionEqual:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionEqual(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionEqualOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionEqualOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5fa73177aaedbc48555f0a010899c3074d0d0598e7fcf21ecff537f88c7a2f82)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionEqual], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionEqual],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__264336f1276d47928a14c58d9c1fa5b10fa05b739a6f353c90430755ab62a457)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionGreaterThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionGreaterThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionGreaterThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionGreaterThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionGreaterThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ac278e46280b98ea8ce7a04963de10e52c847d651d58714b7d8d11ecba73e26)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionGreaterThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionGreaterThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b00f882a370321149cedc2288de55a72dfa2384acdc7f8529380fbaeeda7aee6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionLessThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionLessThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionLessThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionLessThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionLessThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7c6404fc40b90d4b39a3176f2f8e08e4f76a0650533ade25b36534648275e700)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionLessThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionLessThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__106a4ff967a4c4c259789263f4792a7843a18fd42b327ffaa0a94092067e63d4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a808448383938f494e708bdd9606717690aeb4ecd11ae38bf97442983f03bf38)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e5805f79dc96303e70ce8de1a0952bb61d350fcb1660f000edcf6a7f4ba8b439)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6dea6640ed563d23bedf413699f392ff11ecdbdc3548f3e364e4ccbba030a0b9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4961f72953e25b679c1853076fd16a6491e2f0f710f9c52c0457c8cede3853a1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__26fa9a22d90cc4a4147a946ab8c52208bdfc4de7f64c6ddbae225d6a6c5a1d00)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimension]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimension]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aacff1d121c0279338ac2c07a45c0f0f82747095bff2c95da90889c2d197b7bb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1817d9c29e10977d3ea97dd4d523e3a037935ba294d5982654f5891d505bccb5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putEqual")
    def put_equal(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionEqual()

        return typing.cast(None, jsii.invoke(self, "putEqual", [value]))

    @jsii.member(jsii_name="putGreaterThan")
    def put_greater_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionGreaterThan()

        return typing.cast(None, jsii.invoke(self, "putGreaterThan", [value]))

    @jsii.member(jsii_name="putLessThan")
    def put_less_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionLessThan()

        return typing.cast(None, jsii.invoke(self, "putLessThan", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetDimension")
    def reset_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimension", []))

    @jsii.member(jsii_name="resetDimensionVar")
    def reset_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimensionVar", []))

    @jsii.member(jsii_name="resetEqual")
    def reset_equal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEqual", []))

    @jsii.member(jsii_name="resetGreaterThan")
    def reset_greater_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGreaterThan", []))

    @jsii.member(jsii_name="resetLessThan")
    def reset_less_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLessThan", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="equal")
    def equal(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionEqualOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionEqualOutputReference, jsii.get(self, "equal"))

    @builtins.property
    @jsii.member(jsii_name="greaterThan")
    def greater_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionGreaterThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionGreaterThanOutputReference, jsii.get(self, "greaterThan"))

    @builtins.property
    @jsii.member(jsii_name="lessThan")
    def less_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionLessThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionLessThanOutputReference, jsii.get(self, "lessThan"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionInput")
    def dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionVarInput")
    def dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="equalInput")
    def equal_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionEqual], jsii.get(self, "equalInput"))

    @builtins.property
    @jsii.member(jsii_name="greaterThanInput")
    def greater_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionGreaterThan], jsii.get(self, "greaterThanInput"))

    @builtins.property
    @jsii.member(jsii_name="lessThanInput")
    def less_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionLessThan], jsii.get(self, "lessThanInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="dimension")
    def dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimension"))

    @dimension.setter
    def dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9f41860a0d9a031965ff93124b3be37cfe93d7f719efb7112fd0e6a88efd90bd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimension", value)

    @builtins.property
    @jsii.member(jsii_name="dimensionVar")
    def dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimensionVar"))

    @dimension_var.setter
    def dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d8ea79bf701ec3dc36b19a600dd7ef92f69acc869d0c5e2016d34d3c74a26f1d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bca296f943c02bce1cf6bae2c7c1c1560f93842ed23f2bd62db8ecb221d7ad7b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2b8ab3291421edc8efc3143c61d54fc0393365a01edabf0489ec9d41aa17a266)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimension]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimension]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimension]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3d2e3024125979b2b2b2f1b9cfb877a21477c7a1c584e7699403d3fd8e9d2a4b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientation",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "landscape": "landscape",
        "portrait": "portrait",
        "square": "square",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientation:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        landscape: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationLandscape", typing.Dict[builtins.str, typing.Any]]] = None,
        portrait: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationPortrait", typing.Dict[builtins.str, typing.Any]]] = None,
        square: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationSquare", typing.Dict[builtins.str, typing.Any]]] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param landscape: landscape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        :param portrait: portrait block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        :param square: square block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationDefault(**default)
        if isinstance(landscape, dict):
            landscape = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationLandscape(**landscape)
        if isinstance(portrait, dict):
            portrait = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationPortrait(**portrait)
        if isinstance(square, dict):
            square = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationSquare(**square)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e0776259e92548d80ac79b93502dc3b17428cb33610b881314b489f43202ef6c)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument landscape", value=landscape, expected_type=type_hints["landscape"])
            check_type(argname="argument portrait", value=portrait, expected_type=type_hints["portrait"])
            check_type(argname="argument square", value=square, expected_type=type_hints["square"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if landscape is not None:
            self._values["landscape"] = landscape
        if portrait is not None:
            self._values["portrait"] = portrait
        if square is not None:
            self._values["square"] = square

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationDefault"], result)

    @builtins.property
    def landscape(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationLandscape"]:
        '''landscape block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        '''
        result = self._values.get("landscape")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationLandscape"], result)

    @builtins.property
    def portrait(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationPortrait"]:
        '''portrait block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        '''
        result = self._values.get("portrait")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationPortrait"], result)

    @builtins.property
    def square(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationSquare"]:
        '''square block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        result = self._values.get("square")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationSquare"], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1eb223b555cb2228c5a3e27332560e827c38dce16fb0b4d9650fe5db86d82ef3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f6d51b8973e35cfc3ce3ed7d1bc857c9802b764c474602e9191ebe3939405c1c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationLandscape",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationLandscape:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationLandscape(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationLandscapeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationLandscapeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__44ef2a23dee0e12af07ac2209db3219ea1aaff596127cdf4743a0db02ef545ec)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationLandscape], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationLandscape],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b54db1c9619ecd838cce007931bfe5eca31c79d96ddb7db041e86cf9ba75b178)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fafa081704c88a7ff526d03df5123cb09264e8ff9b81b175a04425c97c1adfce)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__86bad2eb1cc1e9e0889fe02d9720ff9889d469c60357399c90af637909317e5c)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a64732f108e1f62d33ceabdef57f58ebb2b2fe155f59d6aade35b8d14969b2d8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__881725b2dfea53e88a452ea02f6e8cee9b845057eee84568b41e09ae6a8c7da5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b7dbac51b434ab2cf97941c6019b291969bd657b728f3f25d4f2e2f454b9257e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientation]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientation]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a10b3d0666e90c78b9cc2d6c8dddbbe0f021f2136cc31e5221ce62f00f395c8e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ecc981f6acdec296e5d2b4e3a4625054cac691aa9ab8c2feec10526cb3965b64)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putLandscape")
    def put_landscape(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationLandscape()

        return typing.cast(None, jsii.invoke(self, "putLandscape", [value]))

    @jsii.member(jsii_name="putPortrait")
    def put_portrait(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationPortrait()

        return typing.cast(None, jsii.invoke(self, "putPortrait", [value]))

    @jsii.member(jsii_name="putSquare")
    def put_square(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationSquare()

        return typing.cast(None, jsii.invoke(self, "putSquare", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetLandscape")
    def reset_landscape(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLandscape", []))

    @jsii.member(jsii_name="resetPortrait")
    def reset_portrait(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPortrait", []))

    @jsii.member(jsii_name="resetSquare")
    def reset_square(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSquare", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="landscape")
    def landscape(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationLandscapeOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationLandscapeOutputReference, jsii.get(self, "landscape"))

    @builtins.property
    @jsii.member(jsii_name="portrait")
    def portrait(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationPortraitOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationPortraitOutputReference", jsii.get(self, "portrait"))

    @builtins.property
    @jsii.member(jsii_name="square")
    def square(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationSquareOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationSquareOutputReference", jsii.get(self, "square"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="landscapeInput")
    def landscape_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationLandscape], jsii.get(self, "landscapeInput"))

    @builtins.property
    @jsii.member(jsii_name="portraitInput")
    def portrait_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationPortrait"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationPortrait"], jsii.get(self, "portraitInput"))

    @builtins.property
    @jsii.member(jsii_name="squareInput")
    def square_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationSquare"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationSquare"], jsii.get(self, "squareInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientation]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientation]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientation]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f06d49e95cb2aad65eb66056b752d072a801142cdad1c41bc853670a91a41af9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationPortrait",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationPortrait:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationPortrait(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationPortraitOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationPortraitOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c2a40d560cc7d37bdc3d7de0292b862c5b938d9bb231151158f745072a61ffcb)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationPortrait]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationPortrait], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationPortrait],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5e53f826867ee16548f24ab7c5cd37c9cec0002fb2118d036bbdc209e6fadd19)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationSquare",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationSquare:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationSquare(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationSquareOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationSquareOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0fd847abd58055b8667baadaf93d787fc26b04415f5fa0de624d4bf08d238c26)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationSquare]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationSquare], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationSquare],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b86619ddc45b8c9d2b8efdfff7c6e038506263ebf11960d1deb3eabbc7d00402)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualImQuery",
    jsii_struct_bases=[],
    name_mapping={
        "allowed_transformations": "allowedTransformations",
        "query_var": "queryVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualImQuery:
    def __init__(
        self,
        *,
        allowed_transformations: typing.Sequence[builtins.str],
        query_var: builtins.str,
    ) -> None:
        '''
        :param allowed_transformations: Specifies the transformations that can be applied using the query string parameter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allowed_transformations DataAkamaiImagingPolicyImage#allowed_transformations}
        :param query_var: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#query_var DataAkamaiImagingPolicyImage#query_var}.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d5b9b7451f53402b2cc3a820eaa4555da390f7f051a4265228d61fbe0a668a64)
            check_type(argname="argument allowed_transformations", value=allowed_transformations, expected_type=type_hints["allowed_transformations"])
            check_type(argname="argument query_var", value=query_var, expected_type=type_hints["query_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "allowed_transformations": allowed_transformations,
            "query_var": query_var,
        }

    @builtins.property
    def allowed_transformations(self) -> typing.List[builtins.str]:
        '''Specifies the transformations that can be applied using the query string parameter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allowed_transformations DataAkamaiImagingPolicyImage#allowed_transformations}
        '''
        result = self._values.get("allowed_transformations")
        assert result is not None, "Required property 'allowed_transformations' is missing"
        return typing.cast(typing.List[builtins.str], result)

    @builtins.property
    def query_var(self) -> builtins.str:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#query_var DataAkamaiImagingPolicyImage#query_var}.'''
        result = self._values.get("query_var")
        assert result is not None, "Required property 'query_var' is missing"
        return typing.cast(builtins.str, result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualImQuery(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualImQueryList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualImQueryList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9f1c2bd517715e735a62e892f57527a7c10a5d71d227b2e4c4b012039c70e96a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualImQueryOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__65152a1d4ae7771ed55f2d68fa576fb70bf4289efb46c4eb255d841193dc8b61)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualImQueryOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__070d94e7128ceec1131f3631e28ddbbf74ec634b5766567268b3019af71febad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d5b87178a07f5b07c2214426c1accf35b3fc83180a0f2d0a146d8afc40596467)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__382f8149f3a2cb572fa588b7aee4051b87cb2229729c884358ef792e0a0f002d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualImQuery]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualImQuery]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualImQuery]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ee0c380c1a29dee3233170e7efd4fee3ff6bae8e8c9ce0e281fa7a3ef2772cb5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualImQueryOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualImQueryOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__74f322b57a2705fc37a22adb108497dd933aca34dbd0e83c46f04740fc55e910)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @builtins.property
    @jsii.member(jsii_name="allowedTransformationsInput")
    def allowed_transformations_input(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "allowedTransformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="queryVarInput")
    def query_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "queryVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowedTransformations")
    def allowed_transformations(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "allowedTransformations"))

    @allowed_transformations.setter
    def allowed_transformations(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__757c3d4ab1e26b3f7e8ae5586c1d1562f1027011c16cb12f734b9e0d474f3919)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowedTransformations", value)

    @builtins.property
    @jsii.member(jsii_name="queryVar")
    def query_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "queryVar"))

    @query_var.setter
    def query_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__201bd8fb0c01197c3920408389e0c9e658c617d7714de5d709fb0bcdb5fe0ff4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "queryVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualImQuery]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualImQuery]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualImQuery]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a8f6a7e010f26e4be2378171950db1159feeb9fb4ca69f91d88ea287305c4764)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualMaxColors",
    jsii_struct_bases=[],
    name_mapping={"colors": "colors", "colors_var": "colorsVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualMaxColors:
    def __init__(
        self,
        *,
        colors: typing.Optional[builtins.str] = None,
        colors_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param colors: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        :param colors_var: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a24d40aa1b4b0b1458edf1617468e993712baa32956954ab9721f3038a8ef9ed)
            check_type(argname="argument colors", value=colors, expected_type=type_hints["colors"])
            check_type(argname="argument colors_var", value=colors_var, expected_type=type_hints["colors_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if colors is not None:
            self._values["colors"] = colors
        if colors_var is not None:
            self._values["colors_var"] = colors_var

    @builtins.property
    def colors(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        '''
        result = self._values.get("colors")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def colors_var(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        result = self._values.get("colors_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualMaxColors(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualMaxColorsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualMaxColorsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__56b4b27a3388e1b981e994d3c8c9de77032ff70b92ef7ecc00143272708db720)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualMaxColorsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__72425e0c3c12cadf93e2dd2e32fb3a60fedf9cf8a68557fdafa8c5e02eb6acde)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualMaxColorsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__78acf79deeec6e67c020015cfa1a8c8d76fc96850211cf3f725b17ea871a2943)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3946b4ed6be224137a9528429282759717bc481ce65856de6d65d8d1532f1c29)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f1de8528ccc7aa4f18c2f08a942a522abb9caf723df4f244754b870b0231c63)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualMaxColors]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualMaxColors]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dcdbea235bb20cfb986ed964571661e89fc9a54044a1e537fc898090c7723a8f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualMaxColorsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualMaxColorsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aeb69389916fb090f23961171637d063c2bd337195fea6fb61f0e60230037a28)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColors")
    def reset_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColors", []))

    @jsii.member(jsii_name="resetColorsVar")
    def reset_colors_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorsVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorsInput")
    def colors_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsInput"))

    @builtins.property
    @jsii.member(jsii_name="colorsVarInput")
    def colors_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsVarInput"))

    @builtins.property
    @jsii.member(jsii_name="colors")
    def colors(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colors"))

    @colors.setter
    def colors(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b53c781bd24440711a26419297ec7a29f29b93a4c8896026debd62921efe0ed4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colors", value)

    @builtins.property
    @jsii.member(jsii_name="colorsVar")
    def colors_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorsVar"))

    @colors_var.setter
    def colors_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7b7660c769bdaf7156a29a7ea3874d4303f6dbd0c793c20699fbd0093de7eb00)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorsVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualMaxColors]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualMaxColors]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualMaxColors]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0d805c5ad81f78442ffa1b63f3b71d6c236d2dd0fecc8a5e9f11103f40d51df6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualMirror",
    jsii_struct_bases=[],
    name_mapping={
        "horizontal": "horizontal",
        "horizontal_var": "horizontalVar",
        "vertical": "vertical",
        "vertical_var": "verticalVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualMirror:
    def __init__(
        self,
        *,
        horizontal: typing.Optional[builtins.str] = None,
        horizontal_var: typing.Optional[builtins.str] = None,
        vertical: typing.Optional[builtins.str] = None,
        vertical_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param horizontal: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        :param horizontal_var: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        :param vertical: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        :param vertical_var: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ec6f957e3fefe188175bb9078b4f95d7e21648bc9f148718aae0e32e66fc5a2)
            check_type(argname="argument horizontal", value=horizontal, expected_type=type_hints["horizontal"])
            check_type(argname="argument horizontal_var", value=horizontal_var, expected_type=type_hints["horizontal_var"])
            check_type(argname="argument vertical", value=vertical, expected_type=type_hints["vertical"])
            check_type(argname="argument vertical_var", value=vertical_var, expected_type=type_hints["vertical_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if horizontal is not None:
            self._values["horizontal"] = horizontal
        if horizontal_var is not None:
            self._values["horizontal_var"] = horizontal_var
        if vertical is not None:
            self._values["vertical"] = vertical
        if vertical_var is not None:
            self._values["vertical_var"] = vertical_var

    @builtins.property
    def horizontal(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        '''
        result = self._values.get("horizontal")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def horizontal_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        '''
        result = self._values.get("horizontal_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        '''
        result = self._values.get("vertical")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        result = self._values.get("vertical_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualMirror(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualMirrorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualMirrorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__02918fdc69e68f4bc06c55337e2da9faf3e9521309bc66633ca6871b0e4c9490)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualMirrorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__41aad57ce339d0f8359b15d3c2dc01bad6ee9f0ca5b06df970693063c37d9b95)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualMirrorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0062b9874416c545ba338010262ca44cd319480be698c49d387f94a8e23ee142)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__546d775639ad805c8031c7c24f0bf2909557818af62f25078520b039591d12ad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c1121302b988b038008f00f4c65aac491884a18e67e064d6f8a0917838096946)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualMirror]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualMirror]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f828a948e5cae110c4af20c5da252fb4ed4a86e9ff5abadd96f29dedec4e20f2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualMirrorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualMirrorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1b4448131987987609f8d4c6af27c3e27ddd0a41227bf1cc3dba4d5e07bec98f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHorizontal")
    def reset_horizontal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontal", []))

    @jsii.member(jsii_name="resetHorizontalVar")
    def reset_horizontal_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontalVar", []))

    @jsii.member(jsii_name="resetVertical")
    def reset_vertical(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVertical", []))

    @jsii.member(jsii_name="resetVerticalVar")
    def reset_vertical_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVerticalVar", []))

    @builtins.property
    @jsii.member(jsii_name="horizontalInput")
    def horizontal_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontalVarInput")
    def horizontal_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalInput")
    def vertical_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalVarInput")
    def vertical_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontal")
    def horizontal(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontal"))

    @horizontal.setter
    def horizontal(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d39e7dd84f41e2afc7447d358413fd50bd7cd60f6a4d88c6170bd641978be150)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontal", value)

    @builtins.property
    @jsii.member(jsii_name="horizontalVar")
    def horizontal_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontalVar"))

    @horizontal_var.setter
    def horizontal_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0da6e9a08b378ffcd86c03131ffc76134ee8f963a0aabf5772601190e37f6ffb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontalVar", value)

    @builtins.property
    @jsii.member(jsii_name="vertical")
    def vertical(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "vertical"))

    @vertical.setter
    def vertical(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__385bc584aabc3d8279e267c0e6c784de8cac8ce9c0d6cf202d8f5ae40f8aa535)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "vertical", value)

    @builtins.property
    @jsii.member(jsii_name="verticalVar")
    def vertical_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "verticalVar"))

    @vertical_var.setter
    def vertical_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ad8ff24d59ecf295459ded8aec7d6805df8df40c033aa89c0b445162e12fc4e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "verticalVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualMirror]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualMirror]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualMirror]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ebf7e966d68b6a170b08dbcf3521710373c67aed1ba43a50f71e581abd3d77e5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualMonoHue",
    jsii_struct_bases=[],
    name_mapping={"hue": "hue", "hue_var": "hueVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualMonoHue:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__02742b553efa9cdc5f662b7c2ccda68bc4e30b8b1a0c0215091f0db9eaa8f317)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualMonoHue(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualMonoHueList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualMonoHueList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__042563087b55e3750f9b19f3bfce4f6551e59e2caa15db9dd25d1916f689ea1d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualMonoHueOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__681e96d28c70ad2573a86750ea7ec79b172b266607459ce6c59c03ff61368be8)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualMonoHueOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__00dfc11ff9821d94b851d9181d0fd38038f5b4e78a2371e2c3e3fc974f6b8c96)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c85306b0cd940711fad5821a0e36e628a569705d4d8f38fff811cc3375494b23)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__105646ef3af15d2e1554e381e305387c37da0fe93c8c54433a1dafc2b0b5ebd8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualMonoHue]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualMonoHue]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__18b41c7f4ec0e1828be119779e53ae8b5b24131dedc80fbdfb307687f50b55b8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualMonoHueOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualMonoHueOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ccd5152aca49e1cf9d5e8c3f56cbb29bb627d36ce25823dda31cf483ee701687)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__749626dd396fa897a01c2c4caa376ef9b24ef03194127d88dc720aff5070aaec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac6bb00ab29d5b5e62359ce5ad523e4600fc6e6552b7bb2b3286abab7d85dded)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualMonoHue]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualMonoHue]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualMonoHue]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ab8b679a08358d95c7e8657cf523fcc1643df4eb49b1dc10379bdfa95dc9f04)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualOpacity",
    jsii_struct_bases=[],
    name_mapping={"opacity": "opacity", "opacity_var": "opacityVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualOpacity:
    def __init__(
        self,
        *,
        opacity: typing.Optional[builtins.str] = None,
        opacity_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param opacity: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param opacity_var: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b0baa10bc65c662bdbe33db14c1bcaeabdcde27a2765ef2d0dad302bd83b718b)
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument opacity_var", value=opacity_var, expected_type=type_hints["opacity_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if opacity is not None:
            self._values["opacity"] = opacity
        if opacity_var is not None:
            self._values["opacity_var"] = opacity_var

    @builtins.property
    def opacity(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def opacity_var(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        result = self._values.get("opacity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualOpacity(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualOpacityList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualOpacityList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__49a4ac49b87bee8b76ea06c4f908c95c67b7d6c5eb4ca2f361a8d160a946a646)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualOpacityOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6d09e1dd63405145710189ad4bf25517b1e3bd18dbcae6051c0419a452f250aa)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualOpacityOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__abac1b8f6bc5b87c7a605fcad53db97a7e25a6b98783c5abad1df74537c654f7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ad684f2fcebdc402df32218fff7df79467ad5eb2e1f4b0be6ad1187cbf4d327b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8271b4bfe2eee213877f5340753997715e907131ef424d9891f8679b36674c84)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualOpacity]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualOpacity]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__632a319f3552f364a2a654aab80a13edf2f1ed7ba3f420d3ccf58fa52559bfcf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualOpacityOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualOpacityOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dc31a536605e6e9dd6eaa02d81b8bad44e9ed56849170213238757994864029d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetOpacityVar")
    def reset_opacity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacityVar", []))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityVarInput")
    def opacity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacity"))

    @opacity.setter
    def opacity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3db17205869d9763c0806e33369f5f7b379ca8f2eba30b236c16bae4392e5c12)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacity", value)

    @builtins.property
    @jsii.member(jsii_name="opacityVar")
    def opacity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacityVar"))

    @opacity_var.setter
    def opacity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2cff6b89364e969cc4028b1b8df9f5503469a480b7c7b9f5360fcfef908ad313)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacityVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualOpacity]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualOpacity]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualOpacity]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8f1520e836e0bad54cd065ef54dd6e21ba4c8e1a24cd3ce8ae33317f0af12ab7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eb581cc1dec203e334a9e11313a8fa040776a3a2147653ce230cc7bb8af8e798)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putAppend")
    def put_append(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualAppend, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6ee059c3ba3bd910d68f8e1198ceabd3db5bf2a0bfca41685e2a118bb7a4e9bf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putAppend", [value]))

    @jsii.member(jsii_name="putAspectCrop")
    def put_aspect_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualAspectCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__48c5e845e3b9d421d9a3723138d58ddf7b91809c5c45d1693b3fe1740c62aa9a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putAspectCrop", [value]))

    @jsii.member(jsii_name="putBackgroundColor")
    def put_background_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__964f987b1a5aed930f7f88c90e30dbdd304ac1c7c90f47ba2d66ebc867c85860)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBackgroundColor", [value]))

    @jsii.member(jsii_name="putBlur")
    def put_blur(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualBlur, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__30527d820ab2ce866328b121a960c1f9531864bc82b3f9ae70de4b85d6ac2213)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBlur", [value]))

    @jsii.member(jsii_name="putChromaKey")
    def put_chroma_key(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualChromaKey, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2c7dc62fc07927f535c1c5856f03e6827cec52ec61011eda21ecac9f399eace6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putChromaKey", [value]))

    @jsii.member(jsii_name="putComposite")
    def put_composite(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualComposite, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__801d201feaf5fb543fa66dbc1e63b39fe4c4c719c1639e8e4e7b9a6af0039285)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putComposite", [value]))

    @jsii.member(jsii_name="putCompound")
    def put_compound(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCompound, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__685ef8fa90a8b1ed4eb7556ba1eed951dbd99c8cfb5cea1d2f991b143c2019d0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCompound", [value]))

    @jsii.member(jsii_name="putContrast")
    def put_contrast(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualContrast, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a2431a1587315e2d31baf4dfdbd9b08df1b03ca5a6ca12c692d63835b07049cd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putContrast", [value]))

    @jsii.member(jsii_name="putCrop")
    def put_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__826bc515973d783521de00bb8f557538ada2ca1c2b36e88bad0d3a46f01be51f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCrop", [value]))

    @jsii.member(jsii_name="putFaceCrop")
    def put_face_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualFaceCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4b6fc924d62b3d87217f7d458d47846e63ad97f4c7ee2bc66bc875f2bca9b30c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFaceCrop", [value]))

    @jsii.member(jsii_name="putFeatureCrop")
    def put_feature_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualFeatureCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a90d5f4a826879fa6899b37fde73f863c6fd9364755030db756815294d2ee202)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFeatureCrop", [value]))

    @jsii.member(jsii_name="putFitAndFill")
    def put_fit_and_fill(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualFitAndFill, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ec0e991264ad6de9d6473b4eb47cba3d37726cfb9261ae53ca82eb619321b3f0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFitAndFill", [value]))

    @jsii.member(jsii_name="putGoop")
    def put_goop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualGoop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d42a41b49eea9d17b0a7765b6b8d65e2e98c26e2a9208a38ebbc0989e9167f1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGoop", [value]))

    @jsii.member(jsii_name="putGrayscale")
    def put_grayscale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualGrayscale, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__51e40e9a9c9da426ec647bdb605410ec4b91389db19e4fce116f657afefd4a2d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGrayscale", [value]))

    @jsii.member(jsii_name="putHsl")
    def put_hsl(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualHsl, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a073984861cb7c586c9f599012515f0b92f353c958ecba8ac71b4327bcfee28d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsl", [value]))

    @jsii.member(jsii_name="putHsv")
    def put_hsv(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualHsv, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4926e8c9cfba4bf955ba7accbe4a4e309ebd7cfeda34a52f4c79658c9b3f06f6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsv", [value]))

    @jsii.member(jsii_name="putIfDimension")
    def put_if_dimension(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimension, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__92f1f86432e0d7b2f83a8773ad7b04a3381439d378f30f04c639859c3fb4df84)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfDimension", [value]))

    @jsii.member(jsii_name="putIfOrientation")
    def put_if_orientation(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a1c6f4da98cb2ccf7d56f91115d3eb067b2ffa879b9e03cce45d825a69413896)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfOrientation", [value]))

    @jsii.member(jsii_name="putImQuery")
    def put_im_query(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualImQuery, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__057994b3d3b3c4aacbc19cade73b8dc9dc02b857ff25946e3127069248566b28)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putImQuery", [value]))

    @jsii.member(jsii_name="putMaxColors")
    def put_max_colors(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualMaxColors, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__71b0c524e69f18d612aa30b31800c0291dd75baf1e0e51fb77f28daefbaccf4e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMaxColors", [value]))

    @jsii.member(jsii_name="putMirror")
    def put_mirror(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualMirror, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c2afc576be5b6015d7e12c5d014224f2c8d8d5d20eab8ea4aafa4cb7ad3fb47b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMirror", [value]))

    @jsii.member(jsii_name="putMonoHue")
    def put_mono_hue(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualMonoHue, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3fb0deb686470ea2c72f454394a269a33294a9d43609eec55710e7b435ae7465)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMonoHue", [value]))

    @jsii.member(jsii_name="putOpacity")
    def put_opacity(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualOpacity, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bab032c1a8a1b24dcdd5be7ff02fc3f9c2e9c2115dfda016f7ad44d53d496408)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putOpacity", [value]))

    @jsii.member(jsii_name="putRegionOfInterestCrop")
    def put_region_of_interest_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRegionOfInterestCrop", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4d4beac110adb1046105fa0e3b6ef8e724c6f1a9c5c3d01c407b4da3cdde0ab6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRegionOfInterestCrop", [value]))

    @jsii.member(jsii_name="putRelativeCrop")
    def put_relative_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRelativeCrop", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eb379d099aae867d06ca4f4bff269bd9fe8f0dc15e9b7cc49207e3d8b06fbb23)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRelativeCrop", [value]))

    @jsii.member(jsii_name="putRemoveColor")
    def put_remove_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRemoveColor", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dc097084828fb38b2921e629592b9d184b45f8e9d4efd33eb23e18138a4715cc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRemoveColor", [value]))

    @jsii.member(jsii_name="putResize")
    def put_resize(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualResize", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__edc9726b8e1bdcef7e893707e2cb946517fbed7fc641780bed0faeea43121e91)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putResize", [value]))

    @jsii.member(jsii_name="putRotate")
    def put_rotate(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRotate", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9b93943ea33451f8ddab917168287206728bb86958e81b89317ab64ec1f01400)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRotate", [value]))

    @jsii.member(jsii_name="putScale")
    def put_scale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualScale", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__884e416d5ccae99cae0d376e41ac22ad9a8a6d72b9ee3ca970509086e8c76a67)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putScale", [value]))

    @jsii.member(jsii_name="putShear")
    def put_shear(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualShear", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f7e9d01472c7aa289e92255fd7a71193b2056971d8c6147df537af3b19fe6555)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putShear", [value]))

    @jsii.member(jsii_name="putTrim")
    def put_trim(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualTrim", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f80e54974c08d0462f9f68e6638713a4d96e086653fe5df7bb40e3451269e23)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTrim", [value]))

    @jsii.member(jsii_name="putUnsharpMask")
    def put_unsharp_mask(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualUnsharpMask", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5634dd6fa6fa5e52a5197b312e8fda3629c738e6d962cc281137219b8969aa67)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putUnsharpMask", [value]))

    @jsii.member(jsii_name="resetAppend")
    def reset_append(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAppend", []))

    @jsii.member(jsii_name="resetAspectCrop")
    def reset_aspect_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspectCrop", []))

    @jsii.member(jsii_name="resetBackgroundColor")
    def reset_background_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBackgroundColor", []))

    @jsii.member(jsii_name="resetBlur")
    def reset_blur(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBlur", []))

    @jsii.member(jsii_name="resetChromaKey")
    def reset_chroma_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChromaKey", []))

    @jsii.member(jsii_name="resetComposite")
    def reset_composite(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetComposite", []))

    @jsii.member(jsii_name="resetCompound")
    def reset_compound(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCompound", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetCrop")
    def reset_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCrop", []))

    @jsii.member(jsii_name="resetFaceCrop")
    def reset_face_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFaceCrop", []))

    @jsii.member(jsii_name="resetFeatureCrop")
    def reset_feature_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureCrop", []))

    @jsii.member(jsii_name="resetFitAndFill")
    def reset_fit_and_fill(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFitAndFill", []))

    @jsii.member(jsii_name="resetGoop")
    def reset_goop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGoop", []))

    @jsii.member(jsii_name="resetGrayscale")
    def reset_grayscale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGrayscale", []))

    @jsii.member(jsii_name="resetHsl")
    def reset_hsl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsl", []))

    @jsii.member(jsii_name="resetHsv")
    def reset_hsv(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsv", []))

    @jsii.member(jsii_name="resetIfDimension")
    def reset_if_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfDimension", []))

    @jsii.member(jsii_name="resetIfOrientation")
    def reset_if_orientation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfOrientation", []))

    @jsii.member(jsii_name="resetImQuery")
    def reset_im_query(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetImQuery", []))

    @jsii.member(jsii_name="resetMaxColors")
    def reset_max_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxColors", []))

    @jsii.member(jsii_name="resetMirror")
    def reset_mirror(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMirror", []))

    @jsii.member(jsii_name="resetMonoHue")
    def reset_mono_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonoHue", []))

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetRegionOfInterestCrop")
    def reset_region_of_interest_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRegionOfInterestCrop", []))

    @jsii.member(jsii_name="resetRelativeCrop")
    def reset_relative_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRelativeCrop", []))

    @jsii.member(jsii_name="resetRemoveColor")
    def reset_remove_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRemoveColor", []))

    @jsii.member(jsii_name="resetResize")
    def reset_resize(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetResize", []))

    @jsii.member(jsii_name="resetRotate")
    def reset_rotate(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRotate", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetShear")
    def reset_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetShear", []))

    @jsii.member(jsii_name="resetTrim")
    def reset_trim(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTrim", []))

    @jsii.member(jsii_name="resetUnsharpMask")
    def reset_unsharp_mask(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUnsharpMask", []))

    @builtins.property
    @jsii.member(jsii_name="append")
    def append(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualAppendList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualAppendList, jsii.get(self, "append"))

    @builtins.property
    @jsii.member(jsii_name="aspectCrop")
    def aspect_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualAspectCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualAspectCropList, jsii.get(self, "aspectCrop"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColor")
    def background_color(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualBackgroundColorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualBackgroundColorList, jsii.get(self, "backgroundColor"))

    @builtins.property
    @jsii.member(jsii_name="blur")
    def blur(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualBlurList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualBlurList, jsii.get(self, "blur"))

    @builtins.property
    @jsii.member(jsii_name="chromaKey")
    def chroma_key(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualChromaKeyList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualChromaKeyList, jsii.get(self, "chromaKey"))

    @builtins.property
    @jsii.member(jsii_name="composite")
    def composite(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCompositeList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCompositeList, jsii.get(self, "composite"))

    @builtins.property
    @jsii.member(jsii_name="compound")
    def compound(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCompoundList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCompoundList, jsii.get(self, "compound"))

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualContrastList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualContrastList, jsii.get(self, "contrast"))

    @builtins.property
    @jsii.member(jsii_name="crop")
    def crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCropList, jsii.get(self, "crop"))

    @builtins.property
    @jsii.member(jsii_name="faceCrop")
    def face_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualFaceCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualFaceCropList, jsii.get(self, "faceCrop"))

    @builtins.property
    @jsii.member(jsii_name="featureCrop")
    def feature_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualFeatureCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualFeatureCropList, jsii.get(self, "featureCrop"))

    @builtins.property
    @jsii.member(jsii_name="fitAndFill")
    def fit_and_fill(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualFitAndFillList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualFitAndFillList, jsii.get(self, "fitAndFill"))

    @builtins.property
    @jsii.member(jsii_name="goop")
    def goop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualGoopList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualGoopList, jsii.get(self, "goop"))

    @builtins.property
    @jsii.member(jsii_name="grayscale")
    def grayscale(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualGrayscaleList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualGrayscaleList, jsii.get(self, "grayscale"))

    @builtins.property
    @jsii.member(jsii_name="hsl")
    def hsl(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualHslList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualHslList, jsii.get(self, "hsl"))

    @builtins.property
    @jsii.member(jsii_name="hsv")
    def hsv(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualHsvList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualHsvList, jsii.get(self, "hsv"))

    @builtins.property
    @jsii.member(jsii_name="ifDimension")
    def if_dimension(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionList, jsii.get(self, "ifDimension"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientation")
    def if_orientation(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationList, jsii.get(self, "ifOrientation"))

    @builtins.property
    @jsii.member(jsii_name="imQuery")
    def im_query(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualImQueryList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualImQueryList, jsii.get(self, "imQuery"))

    @builtins.property
    @jsii.member(jsii_name="maxColors")
    def max_colors(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualMaxColorsList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualMaxColorsList, jsii.get(self, "maxColors"))

    @builtins.property
    @jsii.member(jsii_name="mirror")
    def mirror(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualMirrorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualMirrorList, jsii.get(self, "mirror"))

    @builtins.property
    @jsii.member(jsii_name="monoHue")
    def mono_hue(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualMonoHueList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualMonoHueList, jsii.get(self, "monoHue"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualOpacityList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualOpacityList, jsii.get(self, "opacity"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestCrop")
    def region_of_interest_crop(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRegionOfInterestCropList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRegionOfInterestCropList", jsii.get(self, "regionOfInterestCrop"))

    @builtins.property
    @jsii.member(jsii_name="relativeCrop")
    def relative_crop(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRelativeCropList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRelativeCropList", jsii.get(self, "relativeCrop"))

    @builtins.property
    @jsii.member(jsii_name="removeColor")
    def remove_color(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRemoveColorList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRemoveColorList", jsii.get(self, "removeColor"))

    @builtins.property
    @jsii.member(jsii_name="resize")
    def resize(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualResizeList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualResizeList", jsii.get(self, "resize"))

    @builtins.property
    @jsii.member(jsii_name="rotate")
    def rotate(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRotateList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRotateList", jsii.get(self, "rotate"))

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualScaleList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualScaleList", jsii.get(self, "scale"))

    @builtins.property
    @jsii.member(jsii_name="shear")
    def shear(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualShearList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualShearList", jsii.get(self, "shear"))

    @builtins.property
    @jsii.member(jsii_name="trim")
    def trim(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualTrimList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualTrimList", jsii.get(self, "trim"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMask")
    def unsharp_mask(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualUnsharpMaskList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualUnsharpMaskList", jsii.get(self, "unsharpMask"))

    @builtins.property
    @jsii.member(jsii_name="appendInput")
    def append_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualAppend]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualAppend]]], jsii.get(self, "appendInput"))

    @builtins.property
    @jsii.member(jsii_name="aspectCropInput")
    def aspect_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualAspectCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualAspectCrop]]], jsii.get(self, "aspectCropInput"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColorInput")
    def background_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualBackgroundColor]]], jsii.get(self, "backgroundColorInput"))

    @builtins.property
    @jsii.member(jsii_name="blurInput")
    def blur_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualBlur]]], jsii.get(self, "blurInput"))

    @builtins.property
    @jsii.member(jsii_name="chromaKeyInput")
    def chroma_key_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualChromaKey]]], jsii.get(self, "chromaKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="compositeInput")
    def composite_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualComposite]]], jsii.get(self, "compositeInput"))

    @builtins.property
    @jsii.member(jsii_name="compoundInput")
    def compound_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCompound]]], jsii.get(self, "compoundInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualContrast]]], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="cropInput")
    def crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCrop]]], jsii.get(self, "cropInput"))

    @builtins.property
    @jsii.member(jsii_name="faceCropInput")
    def face_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualFaceCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualFaceCrop]]], jsii.get(self, "faceCropInput"))

    @builtins.property
    @jsii.member(jsii_name="featureCropInput")
    def feature_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualFeatureCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualFeatureCrop]]], jsii.get(self, "featureCropInput"))

    @builtins.property
    @jsii.member(jsii_name="fitAndFillInput")
    def fit_and_fill_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualFitAndFill]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualFitAndFill]]], jsii.get(self, "fitAndFillInput"))

    @builtins.property
    @jsii.member(jsii_name="goopInput")
    def goop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualGoop]]], jsii.get(self, "goopInput"))

    @builtins.property
    @jsii.member(jsii_name="grayscaleInput")
    def grayscale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualGrayscale]]], jsii.get(self, "grayscaleInput"))

    @builtins.property
    @jsii.member(jsii_name="hslInput")
    def hsl_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualHsl]]], jsii.get(self, "hslInput"))

    @builtins.property
    @jsii.member(jsii_name="hsvInput")
    def hsv_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualHsv]]], jsii.get(self, "hsvInput"))

    @builtins.property
    @jsii.member(jsii_name="ifDimensionInput")
    def if_dimension_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimension]]], jsii.get(self, "ifDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientationInput")
    def if_orientation_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientation]]], jsii.get(self, "ifOrientationInput"))

    @builtins.property
    @jsii.member(jsii_name="imQueryInput")
    def im_query_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualImQuery]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualImQuery]]], jsii.get(self, "imQueryInput"))

    @builtins.property
    @jsii.member(jsii_name="maxColorsInput")
    def max_colors_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualMaxColors]]], jsii.get(self, "maxColorsInput"))

    @builtins.property
    @jsii.member(jsii_name="mirrorInput")
    def mirror_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualMirror]]], jsii.get(self, "mirrorInput"))

    @builtins.property
    @jsii.member(jsii_name="monoHueInput")
    def mono_hue_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualMonoHue]]], jsii.get(self, "monoHueInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualOpacity]]], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestCropInput")
    def region_of_interest_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRegionOfInterestCrop"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRegionOfInterestCrop"]]], jsii.get(self, "regionOfInterestCropInput"))

    @builtins.property
    @jsii.member(jsii_name="relativeCropInput")
    def relative_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRelativeCrop"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRelativeCrop"]]], jsii.get(self, "relativeCropInput"))

    @builtins.property
    @jsii.member(jsii_name="removeColorInput")
    def remove_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRemoveColor"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRemoveColor"]]], jsii.get(self, "removeColorInput"))

    @builtins.property
    @jsii.member(jsii_name="resizeInput")
    def resize_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualResize"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualResize"]]], jsii.get(self, "resizeInput"))

    @builtins.property
    @jsii.member(jsii_name="rotateInput")
    def rotate_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRotate"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRotate"]]], jsii.get(self, "rotateInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualScale"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualScale"]]], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="shearInput")
    def shear_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualShear"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualShear"]]], jsii.get(self, "shearInput"))

    @builtins.property
    @jsii.member(jsii_name="trimInput")
    def trim_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualTrim"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualTrim"]]], jsii.get(self, "trimInput"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMaskInput")
    def unsharp_mask_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualUnsharpMask"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualUnsharpMask"]]], jsii.get(self, "unsharpMaskInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqual], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqual],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8760d9e8733b954e8ce67c66c03468745d14ad57e058eb1364111b304a881853)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRegionOfInterestCrop",
    jsii_struct_bases=[],
    name_mapping={
        "region_of_interest": "regionOfInterest",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRegionOfInterestCrop:
    def __init__(
        self,
        *,
        region_of_interest: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRegionOfInterestCropRegionOfInterest", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param region_of_interest: region_of_interest block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest DataAkamaiImagingPolicyImage#region_of_interest}
        :param gravity: The placement of the crop area relative to the specified area of interest. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: The placement of the crop area relative to the specified area of interest. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param style: Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(region_of_interest, dict):
            region_of_interest = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRegionOfInterestCropRegionOfInterest(**region_of_interest)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d85421fa94398d983320d3b6ed1b6912faeab22bad313237d92bd15c808f3cf0)
            check_type(argname="argument region_of_interest", value=region_of_interest, expected_type=type_hints["region_of_interest"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "region_of_interest": region_of_interest,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def region_of_interest(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRegionOfInterestCropRegionOfInterest":
        '''region_of_interest block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest DataAkamaiImagingPolicyImage#region_of_interest}
        '''
        result = self._values.get("region_of_interest")
        assert result is not None, "Required property 'region_of_interest' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRegionOfInterestCropRegionOfInterest", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''The placement of the crop area relative to the specified area of interest.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''The placement of the crop area relative to the specified area of interest.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRegionOfInterestCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRegionOfInterestCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRegionOfInterestCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__003b517fc8b44ffd7e8e9c915377349d1d67ba889d0559610e8ce76de5d86c79)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRegionOfInterestCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__28faf30a718c5379c487221e0c26cfdc9bb27be8ef87073b81226a3efaaadb3d)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRegionOfInterestCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af7cc83fd84e18608e1ec72d4aa377418b3eb19c93912fd710b65419512af677)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1946e60807a6b5fadbfb140b1a578ce68a320153dc0f49333602907d065e2d12)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f6196a3671c094a34c6d0be463cb2e36c7ffc73c1058504f28ff1e21ce2717d2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRegionOfInterestCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRegionOfInterestCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRegionOfInterestCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__949b295ced84874a66775638e28dc03dd638df71d25decba1fdf87d49ff056c7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRegionOfInterestCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRegionOfInterestCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__afec68c2cfb45d1e789137f529ed5ef6aecbaa7fed7b184d91e1750a525b9829)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putRegionOfInterest")
    def put_region_of_interest(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRegionOfInterestCropRegionOfInterest()

        return typing.cast(None, jsii.invoke(self, "putRegionOfInterest", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterest")
    def region_of_interest(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRegionOfInterestCropRegionOfInterestOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRegionOfInterestCropRegionOfInterestOutputReference", jsii.get(self, "regionOfInterest"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestInput")
    def region_of_interest_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRegionOfInterestCropRegionOfInterest"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRegionOfInterestCropRegionOfInterest"], jsii.get(self, "regionOfInterestInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df70b700c264e4e376f434a08a8863ca9a0fc6eed69497660a05f91c23d94f2d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4fcbe3049e0a26420ad29dcd5090688de274ce86ca0ae43b4c3247f2c717e12a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0185291d986656c2688b98632a2bdd87236f89d97ba063b741adcf5d0dc1c419)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d53dd2d59ee0f48d33beae9bf1d9b019628fdf2914463d7ac3e53b09c4fd6153)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7551444a868d25405e7a53c970ed856ce3352690180feb08cb986ad52cf43f14)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__86c40c902f551293bae91d3577b0a3ea404ab3c6f76bdadebd9c821cff58430c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb20d9859cc139847f85aee6f548af40413b8b8e07247b72c984fc08c7fe57ab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6bfafde838841a34e140f5e5531d33274902d2de76bf2d97fb3fd064f3cfce48)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRegionOfInterestCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRegionOfInterestCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRegionOfInterestCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__148c47f37e982b2e32acfead59c88b482ff2d810776fbb9d369e77bc43dde28e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRegionOfInterestCropRegionOfInterest",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRegionOfInterestCropRegionOfInterest:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRegionOfInterestCropRegionOfInterest(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRegionOfInterestCropRegionOfInterestOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRegionOfInterestCropRegionOfInterestOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__59662e8205bee603b280cd78c750d4335eff0a5caa278a8c2e7b7308a7ed9a3c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRegionOfInterestCropRegionOfInterest]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRegionOfInterestCropRegionOfInterest], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRegionOfInterestCropRegionOfInterest],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d26a45dfbff32f55051f8219f1707998f67d6b05e431e771d1590511e07d973b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRelativeCrop",
    jsii_struct_bases=[],
    name_mapping={
        "east": "east",
        "east_var": "eastVar",
        "north": "north",
        "north_var": "northVar",
        "south": "south",
        "south_var": "southVar",
        "west": "west",
        "west_var": "westVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRelativeCrop:
    def __init__(
        self,
        *,
        east: typing.Optional[builtins.str] = None,
        east_var: typing.Optional[builtins.str] = None,
        north: typing.Optional[builtins.str] = None,
        north_var: typing.Optional[builtins.str] = None,
        south: typing.Optional[builtins.str] = None,
        south_var: typing.Optional[builtins.str] = None,
        west: typing.Optional[builtins.str] = None,
        west_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param east: The number of pixels to shrink or expand the right side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east DataAkamaiImagingPolicyImage#east}
        :param east_var: The number of pixels to shrink or expand the right side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east_var DataAkamaiImagingPolicyImage#east_var}
        :param north: The number of pixels to shrink or expand the top side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north DataAkamaiImagingPolicyImage#north}
        :param north_var: The number of pixels to shrink or expand the top side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north_var DataAkamaiImagingPolicyImage#north_var}
        :param south: The number of pixels to shrink or expand the bottom side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south DataAkamaiImagingPolicyImage#south}
        :param south_var: The number of pixels to shrink or expand the bottom side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south_var DataAkamaiImagingPolicyImage#south_var}
        :param west: The number of pixels to shrink or expand the left side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west DataAkamaiImagingPolicyImage#west}
        :param west_var: The number of pixels to shrink or expand the left side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west_var DataAkamaiImagingPolicyImage#west_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a6dfdc407aed4fbabe181062079feda1e9ba4131d4d69885fdad6d9e226657f0)
            check_type(argname="argument east", value=east, expected_type=type_hints["east"])
            check_type(argname="argument east_var", value=east_var, expected_type=type_hints["east_var"])
            check_type(argname="argument north", value=north, expected_type=type_hints["north"])
            check_type(argname="argument north_var", value=north_var, expected_type=type_hints["north_var"])
            check_type(argname="argument south", value=south, expected_type=type_hints["south"])
            check_type(argname="argument south_var", value=south_var, expected_type=type_hints["south_var"])
            check_type(argname="argument west", value=west, expected_type=type_hints["west"])
            check_type(argname="argument west_var", value=west_var, expected_type=type_hints["west_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if east is not None:
            self._values["east"] = east
        if east_var is not None:
            self._values["east_var"] = east_var
        if north is not None:
            self._values["north"] = north
        if north_var is not None:
            self._values["north_var"] = north_var
        if south is not None:
            self._values["south"] = south
        if south_var is not None:
            self._values["south_var"] = south_var
        if west is not None:
            self._values["west"] = west
        if west_var is not None:
            self._values["west_var"] = west_var

    @builtins.property
    def east(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the right side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east DataAkamaiImagingPolicyImage#east}
        '''
        result = self._values.get("east")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def east_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the right side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east_var DataAkamaiImagingPolicyImage#east_var}
        '''
        result = self._values.get("east_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def north(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the top side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north DataAkamaiImagingPolicyImage#north}
        '''
        result = self._values.get("north")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def north_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the top side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north_var DataAkamaiImagingPolicyImage#north_var}
        '''
        result = self._values.get("north_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def south(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the bottom side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south DataAkamaiImagingPolicyImage#south}
        '''
        result = self._values.get("south")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def south_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the bottom side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south_var DataAkamaiImagingPolicyImage#south_var}
        '''
        result = self._values.get("south_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def west(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the left side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west DataAkamaiImagingPolicyImage#west}
        '''
        result = self._values.get("west")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def west_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the left side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west_var DataAkamaiImagingPolicyImage#west_var}
        '''
        result = self._values.get("west_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRelativeCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRelativeCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRelativeCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__809045b429efe5bda2cb1bea2548cd2564c46bd57f852d1615d348f89b79099a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRelativeCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d689a6f627612a38b0821c298c87eeaa5ae9b1178e368a7baf10723f807c79cb)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRelativeCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__34fc0811aaa599fda2f91a6b82ed2b2c14e6b5d76ba6637c26961608a43074e5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__adb657fad8c026ff56acc2b8eec3aad87bcf6286e854262be3ae361d4ca52e64)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2e9845d483caf15f3ca1a92eeacb959138ae21aa0a3a16565b58fff1045780d0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRelativeCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRelativeCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRelativeCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__559954f7795fea66fca35fe037890b8a99840d1b386b08e56c95edce66a29b1b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRelativeCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRelativeCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__485bf41447e2cae16f6256fd17457d0838387dbc20905e34a15b87eb6c1b2455)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetEast")
    def reset_east(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEast", []))

    @jsii.member(jsii_name="resetEastVar")
    def reset_east_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEastVar", []))

    @jsii.member(jsii_name="resetNorth")
    def reset_north(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNorth", []))

    @jsii.member(jsii_name="resetNorthVar")
    def reset_north_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNorthVar", []))

    @jsii.member(jsii_name="resetSouth")
    def reset_south(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSouth", []))

    @jsii.member(jsii_name="resetSouthVar")
    def reset_south_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSouthVar", []))

    @jsii.member(jsii_name="resetWest")
    def reset_west(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWest", []))

    @jsii.member(jsii_name="resetWestVar")
    def reset_west_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWestVar", []))

    @builtins.property
    @jsii.member(jsii_name="eastInput")
    def east_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "eastInput"))

    @builtins.property
    @jsii.member(jsii_name="eastVarInput")
    def east_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "eastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="northInput")
    def north_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "northInput"))

    @builtins.property
    @jsii.member(jsii_name="northVarInput")
    def north_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "northVarInput"))

    @builtins.property
    @jsii.member(jsii_name="southInput")
    def south_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "southInput"))

    @builtins.property
    @jsii.member(jsii_name="southVarInput")
    def south_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "southVarInput"))

    @builtins.property
    @jsii.member(jsii_name="westInput")
    def west_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "westInput"))

    @builtins.property
    @jsii.member(jsii_name="westVarInput")
    def west_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "westVarInput"))

    @builtins.property
    @jsii.member(jsii_name="east")
    def east(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "east"))

    @east.setter
    def east(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__444dae43fdf5e1ac813fda820d9e1f1ad4bc9e16ecc5d067927868b5c5ccf2bc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "east", value)

    @builtins.property
    @jsii.member(jsii_name="eastVar")
    def east_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "eastVar"))

    @east_var.setter
    def east_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e8f1e7cb693fb17ea8073fb0302344d3e78293ff037ea2cd57206032d6d228e8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "eastVar", value)

    @builtins.property
    @jsii.member(jsii_name="north")
    def north(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "north"))

    @north.setter
    def north(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__096ab6ed1e2026d3faecd68755a7e4edbaaace4c9dc63939485fa9c4f52a24b8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "north", value)

    @builtins.property
    @jsii.member(jsii_name="northVar")
    def north_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "northVar"))

    @north_var.setter
    def north_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6ac1e3eeecdb1a3a3bbbe358995833bb85fe4b8548cafa46c1621588d6ec6f07)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "northVar", value)

    @builtins.property
    @jsii.member(jsii_name="south")
    def south(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "south"))

    @south.setter
    def south(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cece6006ba791c367b902ada41b18749fd646c67687ea00571ba40fb4fc7b2fa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "south", value)

    @builtins.property
    @jsii.member(jsii_name="southVar")
    def south_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "southVar"))

    @south_var.setter
    def south_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c483eb9fcca9960b6263572284dc3fb4605a7cf7bbe6be2f104cbc5b90670eb3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "southVar", value)

    @builtins.property
    @jsii.member(jsii_name="west")
    def west(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "west"))

    @west.setter
    def west(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9b9f1034278740c6b339d7716579ce3d2806161ac940834716c35e6994603da9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "west", value)

    @builtins.property
    @jsii.member(jsii_name="westVar")
    def west_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "westVar"))

    @west_var.setter
    def west_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f972489ec137547ace4e5e5bddf89704d6ccc5d1dc5320ead32acc118cb35f2d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "westVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRelativeCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRelativeCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRelativeCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a685d60111d6afd26ddce6061cdb864ab15f7d8bd2eb2779d82aa790d1622c53)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRemoveColor",
    jsii_struct_bases=[],
    name_mapping={
        "color": "color",
        "color_var": "colorVar",
        "feather": "feather",
        "feather_var": "featherVar",
        "tolerance": "tolerance",
        "tolerance_var": "toleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRemoveColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
        feather: typing.Optional[builtins.str] = None,
        feather_var: typing.Optional[builtins.str] = None,
        tolerance: typing.Optional[builtins.str] = None,
        tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        :param feather: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        :param feather_var: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        :param tolerance: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        :param tolerance_var: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__25a47225d62594387aac3fb23fc5553d45fd35c657fc93dd7e88a5ba9244f4ce)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
            check_type(argname="argument feather", value=feather, expected_type=type_hints["feather"])
            check_type(argname="argument feather_var", value=feather_var, expected_type=type_hints["feather_var"])
            check_type(argname="argument tolerance", value=tolerance, expected_type=type_hints["tolerance"])
            check_type(argname="argument tolerance_var", value=tolerance_var, expected_type=type_hints["tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var
        if feather is not None:
            self._values["feather"] = feather
        if feather_var is not None:
            self._values["feather_var"] = feather_var
        if tolerance is not None:
            self._values["tolerance"] = tolerance
        if tolerance_var is not None:
            self._values["tolerance_var"] = tolerance_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        '''
        result = self._values.get("feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather_var(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        '''
        result = self._values.get("feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        '''
        result = self._values.get("tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance_var(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        result = self._values.get("tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRemoveColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRemoveColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRemoveColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__072feeb00e4863c8122b9a196dd5de816694b03e8952f40546f95234ed9f1399)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRemoveColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__539827b7ecc0bd82ddd7144c7f693a7e3f06eaa5b1494cdc100192aa81419654)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRemoveColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__63323ae34d525e4449f36d1582d5f9be3288df16fd4cf34733df703492f4be08)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e4eb98ccb82f8f577472b4294e43aeaf316461e7452257eb49048b82f911ef99)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__55a5e9d34edbc2bdf47ab060fc38ec2b8b4368dd528f3e943c08eb813e56aba0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRemoveColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRemoveColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRemoveColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b76bc9c5996b1575f70a0e6fe2633eb619eb23f0e9a71408d8b15439a555b1d1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRemoveColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRemoveColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fbe870a59d0d0d3e70fdf8421e6e689b7715ddb753383e7b07b8470ea3464622)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @jsii.member(jsii_name="resetFeather")
    def reset_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeather", []))

    @jsii.member(jsii_name="resetFeatherVar")
    def reset_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatherVar", []))

    @jsii.member(jsii_name="resetTolerance")
    def reset_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTolerance", []))

    @jsii.member(jsii_name="resetToleranceVar")
    def reset_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featherInput")
    def feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherInput"))

    @builtins.property
    @jsii.member(jsii_name="featherVarInput")
    def feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceInput")
    def tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceVarInput")
    def tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5bbf1962da14be9fb63ebd8a0b4ce366dbf21d9f3c4dc15d8c6e09346ccbd031)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ec96c888f009e4bb9c479214485d999f8650cec341095dcee16b2939316b83da)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="feather")
    def feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "feather"))

    @feather.setter
    def feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dfe4c9b33a1ab147d701542a28b2b3f436190360400309f4827acb0679f9db87)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "feather", value)

    @builtins.property
    @jsii.member(jsii_name="featherVar")
    def feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featherVar"))

    @feather_var.setter
    def feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c617bd98a3165e8e921e2346ed7eeff44790d8462fbe345c2ee6cd3e165dc356)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featherVar", value)

    @builtins.property
    @jsii.member(jsii_name="tolerance")
    def tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tolerance"))

    @tolerance.setter
    def tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__199a7936ef0929879500e201cc5b2f6d8daeebcc7141d121d1b3be6078df9ef0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tolerance", value)

    @builtins.property
    @jsii.member(jsii_name="toleranceVar")
    def tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "toleranceVar"))

    @tolerance_var.setter
    def tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__972bd8e331acf7bb0251b28a6bc4a247eef858aec31d9020d7db836d40a10ea7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "toleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRemoveColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRemoveColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRemoveColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__136b5f37ae352f46038d84c2d42b43314eed8a825586b6fca4e65c8d48aeb9b5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualResize",
    jsii_struct_bases=[],
    name_mapping={
        "aspect": "aspect",
        "aspect_var": "aspectVar",
        "height": "height",
        "height_var": "heightVar",
        "type": "type",
        "type_var": "typeVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualResize:
    def __init__(
        self,
        *,
        aspect: typing.Optional[builtins.str] = None,
        aspect_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param aspect: Preserves the aspect ratio. Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect DataAkamaiImagingPolicyImage#aspect}
        :param aspect_var: Preserves the aspect ratio. Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_var DataAkamaiImagingPolicyImage#aspect_var}
        :param height: The height to resize the source image to. Must be set if height is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height to resize the source image to. Must be set if height is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param type: Sets constraints for the image resize. Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: Sets constraints for the image resize. Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        :param width: The width to resize the source image to. Must be set if width is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width to resize the source image to. Must be set if width is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1b4d9e2ab47f6722cc777946ace81495bb2d1de926d05f6ec8ceb8e394aa24fc)
            check_type(argname="argument aspect", value=aspect, expected_type=type_hints["aspect"])
            check_type(argname="argument aspect_var", value=aspect_var, expected_type=type_hints["aspect_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if aspect is not None:
            self._values["aspect"] = aspect
        if aspect_var is not None:
            self._values["aspect_var"] = aspect_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def aspect(self) -> typing.Optional[builtins.str]:
        '''Preserves the aspect ratio.

        Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect DataAkamaiImagingPolicyImage#aspect}
        '''
        result = self._values.get("aspect")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def aspect_var(self) -> typing.Optional[builtins.str]:
        '''Preserves the aspect ratio.

        Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_var DataAkamaiImagingPolicyImage#aspect_var}
        '''
        result = self._values.get("aspect_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height to resize the source image to. Must be set if height is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height to resize the source image to. Must be set if height is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''Sets constraints for the image resize.

        Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''Sets constraints for the image resize.

        Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width to resize the source image to. Must be set if width is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width to resize the source image to. Must be set if width is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualResize(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualResizeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualResizeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d908f289fcc20f954115fe4ea279ff0c405b1d57254ff47f038f68dbf6de9b66)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualResizeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dc7b7747fc4c583a32dd46a6216615f700531b030e53e72aa9c53f5bf39d5b3d)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualResizeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c792c1bce879c657286fbda0d492e3b94aa5b24fec3d931cf237117755809132)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__77000ed3289e0554ad672caf49fcf09e98744abd0d051fb1a59fdc5dc23faa2a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__27c7c682f82a7504428c0c4718ab9f04d9fc3276aed2a214c1aae1d52c87aab3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualResize]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualResize]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualResize]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__647d8145b7d1d8472c02cae2cbda485b2864080215af932c2a244956fec88212)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualResizeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualResizeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1573320bb8bf6d02de186363aa9a88ffe0ede524ef1fdba4bc996e8c58f4db97)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAspect")
    def reset_aspect(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspect", []))

    @jsii.member(jsii_name="resetAspectVar")
    def reset_aspect_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspectVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="aspectInput")
    def aspect_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "aspectInput"))

    @builtins.property
    @jsii.member(jsii_name="aspectVarInput")
    def aspect_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "aspectVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="aspect")
    def aspect(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "aspect"))

    @aspect.setter
    def aspect(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__36b9d514a02f32f9af711e5e04e762b142dc06660ac3479d12d1aff8617b70fc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "aspect", value)

    @builtins.property
    @jsii.member(jsii_name="aspectVar")
    def aspect_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "aspectVar"))

    @aspect_var.setter
    def aspect_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e1d3752272b45016e87764798e9a65839adffe01299da1192343bab4afcca909)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "aspectVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f0f0da81e5f042d558802df029aba7e4c5cfc791bffaa645367ebf2188de51a1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6407e446737ce197fd69bbef4029ec9a5a6dca189c8994bccc8f674b40d576dc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__24eb034af6609a33908349e335a63808089e6ad01a40967dc09578b149e83bf2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b5d607a10ff2b30272d301e746bd794da5f7f8d0a395650b8724a62caddb45f9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__82c14da8da42bda7104151d332e54897a984e5a0910897b99aef5cd02de2474f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6c8019b33383adf24084311012e027796327b5c11346ed534800e2aef89fa191)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualResize]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualResize]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualResize]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5cee79b11649bd6db5e099fb8fcf48f6034a6ca43411bb705cbdbb1d8fbb3c37)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRotate",
    jsii_struct_bases=[],
    name_mapping={"degrees": "degrees", "degrees_var": "degreesVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRotate:
    def __init__(
        self,
        *,
        degrees: typing.Optional[builtins.str] = None,
        degrees_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param degrees: The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees DataAkamaiImagingPolicyImage#degrees}
        :param degrees_var: The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees_var DataAkamaiImagingPolicyImage#degrees_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__54293c1693575b281fd7d3eb415420ac385543fe4e83db34c81dd92a89c02b1a)
            check_type(argname="argument degrees", value=degrees, expected_type=type_hints["degrees"])
            check_type(argname="argument degrees_var", value=degrees_var, expected_type=type_hints["degrees_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if degrees is not None:
            self._values["degrees"] = degrees
        if degrees_var is not None:
            self._values["degrees_var"] = degrees_var

    @builtins.property
    def degrees(self) -> typing.Optional[builtins.str]:
        '''The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees DataAkamaiImagingPolicyImage#degrees}
        '''
        result = self._values.get("degrees")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def degrees_var(self) -> typing.Optional[builtins.str]:
        '''The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees_var DataAkamaiImagingPolicyImage#degrees_var}
        '''
        result = self._values.get("degrees_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRotate(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRotateList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRotateList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2654b8b19387d7e83273b7063163b47039526951407942070ebbd2b037b5261c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRotateOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ee6fb11737e142ad3f64b36064eccb4960f431ce898f5fef0d4a8154150e6ffb)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRotateOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d2e812a73d82b5a76f0f024ceac23d9eb31e77b4254c6db8c9043ab44707299b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__597c9e7bdbc348bc9eaeb9fd8d34a3543da04755533e6360c1f73b7729bb3f94)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea8689d5896c2e906472a24ed6230c77d9ff73f452e5ccc015dac07cc85d9152)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRotate]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRotate]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRotate]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c98631e654decb11d1e210289347019a4702ac8aa56baffdd0db7101262280a4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRotateOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRotateOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c41afe6e938be36aab755ec3001a550ea0a3b0ecb00313db2bcfb70d07cd8a65)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetDegrees")
    def reset_degrees(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDegrees", []))

    @jsii.member(jsii_name="resetDegreesVar")
    def reset_degrees_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDegreesVar", []))

    @builtins.property
    @jsii.member(jsii_name="degreesInput")
    def degrees_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "degreesInput"))

    @builtins.property
    @jsii.member(jsii_name="degreesVarInput")
    def degrees_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "degreesVarInput"))

    @builtins.property
    @jsii.member(jsii_name="degrees")
    def degrees(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "degrees"))

    @degrees.setter
    def degrees(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3d6b88a9df6f5a27a1820bcfea4bbac29449b86f0bd82a90544de2048bdbe63d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "degrees", value)

    @builtins.property
    @jsii.member(jsii_name="degreesVar")
    def degrees_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "degreesVar"))

    @degrees_var.setter
    def degrees_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ff2ecd0b1e660c9c4213aa2a7055fd8cc87d49a3366e7132384dfdfaa1718322)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "degreesVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRotate]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRotate]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRotate]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__53050dda0ace72170920d2b674dff4cc6ec89a7498a6f941579be67d642cdbaa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualScale",
    jsii_struct_bases=[],
    name_mapping={
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualScale:
    def __init__(
        self,
        *,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param height: Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged. Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged. Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7858f74fb428f54f4e1b0409d50766512e7e23333b7200038c293f79ef2d649f)
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size.

        Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size.

        Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged.

        Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged.

        Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualScale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualScaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualScaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8c378e80dd8fdc5a595d36b0bc3a886fd0307e5eb294a78eaccb09093d2ada2e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualScaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7b809dae8008735779ed86a86a547f85516687fe563ecd14eaa7a42fb1e13b04)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualScaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__50dc94a874a45d51f7afcd9e0d0e1ce7382b19f569c918b45e47678ae2d8880b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ee3043d83989923495a6ea4aa7ba55af2fcb1decc0c2e521fdac10e6f1b154d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea88ebc1a11b42b3a852c4ee7284fb951b809af2497dd55604e758ffe445acae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualScale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualScale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualScale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__71645baccc504d2694942d3acbd75d85e47319cb457bc7223e0fb621d8715474)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualScaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualScaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f658f0c19c016ddc95a0361d11d5fae91fe62f018f2aba1df5abac99ba0b9322)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f0987d4380c7ce49dc72112e217db6effdf5c6cd694e44ebe18421208ce9428)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea22882c88ebf2103fbefeefd8fe65d527b8973aae77ee2a3aa74c180a0da2f1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1119f20d79db95c79975afebca1c8bd496a540f6d2f6e5a547e4486bb890664f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b7857dddc42ca3c2dae4e0aa12dec9bd21436b9f46666fe7b3f552b47b15ff2f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualScale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualScale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualScale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cdd3c33723d431ca30ac908fa0b2332c9d84a64178a7c33b6745fa220ee70d00)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualShear",
    jsii_struct_bases=[],
    name_mapping={
        "x_shear": "xShear",
        "x_shear_var": "xShearVar",
        "y_shear": "yShear",
        "y_shear_var": "yShearVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualShear:
    def __init__(
        self,
        *,
        x_shear: typing.Optional[builtins.str] = None,
        x_shear_var: typing.Optional[builtins.str] = None,
        y_shear: typing.Optional[builtins.str] = None,
        y_shear_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param x_shear: The amount to shear along the x-axis, measured in multiples of the image's width. Must be set if yShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear DataAkamaiImagingPolicyImage#x_shear}
        :param x_shear_var: The amount to shear along the x-axis, measured in multiples of the image's width. Must be set if yShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear_var DataAkamaiImagingPolicyImage#x_shear_var}
        :param y_shear: The amount to shear along the y-axis, measured in multiples of the image's height. Must be set if xShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear DataAkamaiImagingPolicyImage#y_shear}
        :param y_shear_var: The amount to shear along the y-axis, measured in multiples of the image's height. Must be set if xShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear_var DataAkamaiImagingPolicyImage#y_shear_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__42d5a707236943d4533cdc195f63553725214609a2487bab204b6b264b8e5425)
            check_type(argname="argument x_shear", value=x_shear, expected_type=type_hints["x_shear"])
            check_type(argname="argument x_shear_var", value=x_shear_var, expected_type=type_hints["x_shear_var"])
            check_type(argname="argument y_shear", value=y_shear, expected_type=type_hints["y_shear"])
            check_type(argname="argument y_shear_var", value=y_shear_var, expected_type=type_hints["y_shear_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if x_shear is not None:
            self._values["x_shear"] = x_shear
        if x_shear_var is not None:
            self._values["x_shear_var"] = x_shear_var
        if y_shear is not None:
            self._values["y_shear"] = y_shear
        if y_shear_var is not None:
            self._values["y_shear_var"] = y_shear_var

    @builtins.property
    def x_shear(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the x-axis, measured in multiples of the image's width.

        Must be set if yShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear DataAkamaiImagingPolicyImage#x_shear}
        '''
        result = self._values.get("x_shear")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_shear_var(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the x-axis, measured in multiples of the image's width.

        Must be set if yShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear_var DataAkamaiImagingPolicyImage#x_shear_var}
        '''
        result = self._values.get("x_shear_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_shear(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the y-axis, measured in multiples of the image's height.

        Must be set if xShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear DataAkamaiImagingPolicyImage#y_shear}
        '''
        result = self._values.get("y_shear")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_shear_var(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the y-axis, measured in multiples of the image's height.

        Must be set if xShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear_var DataAkamaiImagingPolicyImage#y_shear_var}
        '''
        result = self._values.get("y_shear_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualShear(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualShearList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualShearList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__66264d96f3b3fd3c61003257fb4b5fb874921b2e56952a6725a89d2b4de42249)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualShearOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__84090657121726f232e81795463032d5c32dad897f27ee615e9af7b0a56a8d98)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualShearOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ca25edc5adeec3d47e115f3926675a4375935d4b635f59e96334bd6bb57318f4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__343e672430f50a0e49463b2aeb34f50663c5f5257c156c2c181fbd2a78f9e2b4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0fba43e2a13b728b7ca6f1cdad75a08033a24a96b5bccc5c02438fa343499568)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualShear]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualShear]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualShear]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__313a4d28d6ec5dbd334544f730d4d0c2880a7654fdf7f38ff14580cc5937ce47)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualShearOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualShearOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d1cb86ecc18543525fb68fb6a1ff99f9a79c43e8cdf8ceacb93610328446b83)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetXShear")
    def reset_x_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXShear", []))

    @jsii.member(jsii_name="resetXShearVar")
    def reset_x_shear_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXShearVar", []))

    @jsii.member(jsii_name="resetYShear")
    def reset_y_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYShear", []))

    @jsii.member(jsii_name="resetYShearVar")
    def reset_y_shear_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYShearVar", []))

    @builtins.property
    @jsii.member(jsii_name="xShearInput")
    def x_shear_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xShearInput"))

    @builtins.property
    @jsii.member(jsii_name="xShearVarInput")
    def x_shear_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xShearVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yShearInput")
    def y_shear_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yShearInput"))

    @builtins.property
    @jsii.member(jsii_name="yShearVarInput")
    def y_shear_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yShearVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xShear")
    def x_shear(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xShear"))

    @x_shear.setter
    def x_shear(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c7c72d7fb2013fdf8c4bcd3cf1fc98677256c659f43680391063dcb9ff2638e5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xShear", value)

    @builtins.property
    @jsii.member(jsii_name="xShearVar")
    def x_shear_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xShearVar"))

    @x_shear_var.setter
    def x_shear_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d8d8686791a5bce94e60b5c2d0a8148b73c799a627bf0a80bd45d0156d924f52)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xShearVar", value)

    @builtins.property
    @jsii.member(jsii_name="yShear")
    def y_shear(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yShear"))

    @y_shear.setter
    def y_shear(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c508fc0a27523f383450e627278686fee91dd088bad42f28edf557e7b38e5efa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yShear", value)

    @builtins.property
    @jsii.member(jsii_name="yShearVar")
    def y_shear_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yShearVar"))

    @y_shear_var.setter
    def y_shear_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e0486cd3c6c7528f8857a1858bdc080837693f868399358afe0b771900c786a2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yShearVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualShear]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualShear]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualShear]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d1b73bc5949f7a189056ebf9b8be6af6edb92a3b615359fa7faaa24249c58721)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualTrim",
    jsii_struct_bases=[],
    name_mapping={
        "fuzz": "fuzz",
        "fuzz_var": "fuzzVar",
        "padding": "padding",
        "padding_var": "paddingVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualTrim:
    def __init__(
        self,
        *,
        fuzz: typing.Optional[builtins.str] = None,
        fuzz_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fuzz: The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz DataAkamaiImagingPolicyImage#fuzz}
        :param fuzz_var: The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz_var DataAkamaiImagingPolicyImage#fuzz_var}
        :param padding: The amount of padding in pixels to add to the trimmed image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: The amount of padding in pixels to add to the trimmed image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1e4d444b4a1e30a4a1c4ad884a6e80c3142f25bb84db82b64d08b39665325170)
            check_type(argname="argument fuzz", value=fuzz, expected_type=type_hints["fuzz"])
            check_type(argname="argument fuzz_var", value=fuzz_var, expected_type=type_hints["fuzz_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fuzz is not None:
            self._values["fuzz"] = fuzz
        if fuzz_var is not None:
            self._values["fuzz_var"] = fuzz_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var

    @builtins.property
    def fuzz(self) -> typing.Optional[builtins.str]:
        '''The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz DataAkamaiImagingPolicyImage#fuzz}
        '''
        result = self._values.get("fuzz")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fuzz_var(self) -> typing.Optional[builtins.str]:
        '''The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz_var DataAkamaiImagingPolicyImage#fuzz_var}
        '''
        result = self._values.get("fuzz_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''The amount of padding in pixels to add to the trimmed image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''The amount of padding in pixels to add to the trimmed image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualTrim(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualTrimList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualTrimList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f89790a159287e423cdba1f3fa04b75ae309c98f27120a662580dcf398d4c8b8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualTrimOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e2842d1ad3bd7e03f08061eb7613eefcae67a602819b52b529ca2a15685957cb)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualTrimOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__69e75af1b454d3608770d5b3ae50a31fe567eea7c39a032598c9d5a27405fb68)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8e72137fa152154068f37bb1904349eeaa04b13e2cc1627f3ec14fe3ff5fe60a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8e2849a91792e7f5a919c7b6ae951c38fef40e37f9855bc8cad2561d8d50ca4e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualTrim]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualTrim]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualTrim]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6de592cc1a45160b776ab12ed4b7995c0a3ee95d235fddc1007ca710c360bca8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualTrimOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualTrimOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4f6d004652ae0c3d80e39177e5db6e5110ee00a324ccc9616efe8d5225d517b8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetFuzz")
    def reset_fuzz(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFuzz", []))

    @jsii.member(jsii_name="resetFuzzVar")
    def reset_fuzz_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFuzzVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @builtins.property
    @jsii.member(jsii_name="fuzzInput")
    def fuzz_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fuzzInput"))

    @builtins.property
    @jsii.member(jsii_name="fuzzVarInput")
    def fuzz_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fuzzVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="fuzz")
    def fuzz(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fuzz"))

    @fuzz.setter
    def fuzz(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__66756101024501b9098f88d26216d2e65d5d79d1618b047abddf98f77041f6c1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fuzz", value)

    @builtins.property
    @jsii.member(jsii_name="fuzzVar")
    def fuzz_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fuzzVar"))

    @fuzz_var.setter
    def fuzz_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9f03b16091537722871483e6b4d14b5d8bf1ca5c382430250dc6ec64caa23110)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fuzzVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3d2233c79b85f3254e252b0809dd84499a9b934e17c6929ac6b3baa4eaa993ac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__057fae40e4a52d0a1182b30a52df064db67c7bd5174aae5b7ae190d34170b989)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualTrim]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualTrim]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualTrim]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__70a2049ba666f36c066249f0e4319ee95b6204ef1e3dce1951460917d176a69a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualUnsharpMask",
    jsii_struct_bases=[],
    name_mapping={
        "gain": "gain",
        "gain_var": "gainVar",
        "sigma": "sigma",
        "sigma_var": "sigmaVar",
        "threshold": "threshold",
        "threshold_var": "thresholdVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualUnsharpMask:
    def __init__(
        self,
        *,
        gain: typing.Optional[builtins.str] = None,
        gain_var: typing.Optional[builtins.str] = None,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
        threshold: typing.Optional[builtins.str] = None,
        threshold_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param gain: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        :param gain_var: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        :param sigma: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        :param threshold: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        :param threshold_var: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c2bdced9787f61a1aadb12ea24212b0b68ecf571e318effe8d38be0b833c8415)
            check_type(argname="argument gain", value=gain, expected_type=type_hints["gain"])
            check_type(argname="argument gain_var", value=gain_var, expected_type=type_hints["gain_var"])
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
            check_type(argname="argument threshold", value=threshold, expected_type=type_hints["threshold"])
            check_type(argname="argument threshold_var", value=threshold_var, expected_type=type_hints["threshold_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if gain is not None:
            self._values["gain"] = gain
        if gain_var is not None:
            self._values["gain_var"] = gain_var
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var
        if threshold is not None:
            self._values["threshold"] = threshold
        if threshold_var is not None:
            self._values["threshold_var"] = threshold_var

    @builtins.property
    def gain(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        '''
        result = self._values.get("gain")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gain_var(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        '''
        result = self._values.get("gain_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        '''
        result = self._values.get("threshold")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold_var(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        result = self._values.get("threshold_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualUnsharpMask(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualUnsharpMaskList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualUnsharpMaskList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7a534521b10ddfc874d24ec5767eeb4791f3f2cfe6bc164d7bb975dac27771cb)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualUnsharpMaskOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6482ad352372319a5a6593e9d8439fa538adf6b946afb3ed33685a2f0c714535)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualUnsharpMaskOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__16a564274f58bd1746fca3dce958c237680c677d3a56a279b09c7873e0635854)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b31ed05c4f9e3931580ac8f5d37970b9f876f0c2df1b378fe488f27ba76ee041)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__64d553105843ac7975e60ee06990357ed99f92e546d1b11dfa344dc4347260f0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualUnsharpMask]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualUnsharpMask]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualUnsharpMask]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a3f3f9fe05a7fca62b37fbde2df62062217bb94ad80d3b03776be9435a421a40)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualUnsharpMaskOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualUnsharpMaskOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4edf8be591fb0fc9793b28e68c3ba55ab7ccda619418661396967b434fe7f101)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetGain")
    def reset_gain(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGain", []))

    @jsii.member(jsii_name="resetGainVar")
    def reset_gain_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGainVar", []))

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @jsii.member(jsii_name="resetThreshold")
    def reset_threshold(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThreshold", []))

    @jsii.member(jsii_name="resetThresholdVar")
    def reset_threshold_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThresholdVar", []))

    @builtins.property
    @jsii.member(jsii_name="gainInput")
    def gain_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainInput"))

    @builtins.property
    @jsii.member(jsii_name="gainVarInput")
    def gain_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdInput")
    def threshold_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdVarInput")
    def threshold_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gain")
    def gain(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gain"))

    @gain.setter
    def gain(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bda65ea8124c7aff17bd4c8c4e20f5cf9b764fe4544bb24873c06649ee280b01)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gain", value)

    @builtins.property
    @jsii.member(jsii_name="gainVar")
    def gain_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gainVar"))

    @gain_var.setter
    def gain_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__46d4a9d3cc5312d7c975758ad9e3562417d95627126dec81dbd03d14000db316)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gainVar", value)

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2695085e0a9a8a7e00756782ebd09561ba4eaf4e10f30a12c7471bfaa219fb04)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f428a1cea5a75dab79e22d3edd678e66079a93c0ae088292b0bc265622084204)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="threshold")
    def threshold(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "threshold"))

    @threshold.setter
    def threshold(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e1f951e6d095199523fbd6b2ca2206c43af56086af37249b7a5f2bad743cfed1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "threshold", value)

    @builtins.property
    @jsii.member(jsii_name="thresholdVar")
    def threshold_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "thresholdVar"))

    @threshold_var.setter
    def threshold_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__99d30199be54fbea3f2cec418edf28f5c10feb723dee2d64c6b074e3c59fc4ce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "thresholdVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualUnsharpMask]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualUnsharpMask]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualUnsharpMask]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ff30c334b2944a1a85e15235ea59e9ef9497b635cddeb049c85beda2a84dfb6e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThan",
    jsii_struct_bases=[],
    name_mapping={
        "append": "append",
        "aspect_crop": "aspectCrop",
        "background_color": "backgroundColor",
        "blur": "blur",
        "chroma_key": "chromaKey",
        "composite": "composite",
        "compound": "compound",
        "contrast": "contrast",
        "crop": "crop",
        "face_crop": "faceCrop",
        "feature_crop": "featureCrop",
        "fit_and_fill": "fitAndFill",
        "goop": "goop",
        "grayscale": "grayscale",
        "hsl": "hsl",
        "hsv": "hsv",
        "if_dimension": "ifDimension",
        "if_orientation": "ifOrientation",
        "im_query": "imQuery",
        "max_colors": "maxColors",
        "mirror": "mirror",
        "mono_hue": "monoHue",
        "opacity": "opacity",
        "region_of_interest_crop": "regionOfInterestCrop",
        "relative_crop": "relativeCrop",
        "remove_color": "removeColor",
        "resize": "resize",
        "rotate": "rotate",
        "scale": "scale",
        "shear": "shear",
        "trim": "trim",
        "unsharp_mask": "unsharpMask",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThan:
    def __init__(
        self,
        *,
        append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanAppend", typing.Dict[builtins.str, typing.Any]]]]] = None,
        aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanAspectCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanBackgroundColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanBlur", typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanChromaKey", typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanComposite", typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompound", typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanContrast", typing.Dict[builtins.str, typing.Any]]]]] = None,
        crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanFaceCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanFeatureCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanFitAndFill", typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanGoop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanGrayscale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanHsl", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanHsv", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimension", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientation", typing.Dict[builtins.str, typing.Any]]]]] = None,
        im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanImQuery", typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanMaxColors", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanMirror", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanMonoHue", typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanOpacity", typing.Dict[builtins.str, typing.Any]]]]] = None,
        region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanRegionOfInterestCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanRelativeCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanRemoveColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanResize", typing.Dict[builtins.str, typing.Any]]]]] = None,
        rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanRotate", typing.Dict[builtins.str, typing.Any]]]]] = None,
        scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanScale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanShear", typing.Dict[builtins.str, typing.Any]]]]] = None,
        trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanTrim", typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanUnsharpMask", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param append: append block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        :param aspect_crop: aspect_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param crop: crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        :param face_crop: face_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        :param feature_crop: feature_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        :param fit_and_fill: fit_and_fill block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param im_query: im_query block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param region_of_interest_crop: region_of_interest_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        :param relative_crop: relative_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param resize: resize block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        :param rotate: rotate block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        :param scale: scale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param shear: shear block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        :param trim: trim block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c3f7c322578a73b7c27cc79e06f0b33465020c3b9504f7ad9dba68b95779bab6)
            check_type(argname="argument append", value=append, expected_type=type_hints["append"])
            check_type(argname="argument aspect_crop", value=aspect_crop, expected_type=type_hints["aspect_crop"])
            check_type(argname="argument background_color", value=background_color, expected_type=type_hints["background_color"])
            check_type(argname="argument blur", value=blur, expected_type=type_hints["blur"])
            check_type(argname="argument chroma_key", value=chroma_key, expected_type=type_hints["chroma_key"])
            check_type(argname="argument composite", value=composite, expected_type=type_hints["composite"])
            check_type(argname="argument compound", value=compound, expected_type=type_hints["compound"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument crop", value=crop, expected_type=type_hints["crop"])
            check_type(argname="argument face_crop", value=face_crop, expected_type=type_hints["face_crop"])
            check_type(argname="argument feature_crop", value=feature_crop, expected_type=type_hints["feature_crop"])
            check_type(argname="argument fit_and_fill", value=fit_and_fill, expected_type=type_hints["fit_and_fill"])
            check_type(argname="argument goop", value=goop, expected_type=type_hints["goop"])
            check_type(argname="argument grayscale", value=grayscale, expected_type=type_hints["grayscale"])
            check_type(argname="argument hsl", value=hsl, expected_type=type_hints["hsl"])
            check_type(argname="argument hsv", value=hsv, expected_type=type_hints["hsv"])
            check_type(argname="argument if_dimension", value=if_dimension, expected_type=type_hints["if_dimension"])
            check_type(argname="argument if_orientation", value=if_orientation, expected_type=type_hints["if_orientation"])
            check_type(argname="argument im_query", value=im_query, expected_type=type_hints["im_query"])
            check_type(argname="argument max_colors", value=max_colors, expected_type=type_hints["max_colors"])
            check_type(argname="argument mirror", value=mirror, expected_type=type_hints["mirror"])
            check_type(argname="argument mono_hue", value=mono_hue, expected_type=type_hints["mono_hue"])
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument region_of_interest_crop", value=region_of_interest_crop, expected_type=type_hints["region_of_interest_crop"])
            check_type(argname="argument relative_crop", value=relative_crop, expected_type=type_hints["relative_crop"])
            check_type(argname="argument remove_color", value=remove_color, expected_type=type_hints["remove_color"])
            check_type(argname="argument resize", value=resize, expected_type=type_hints["resize"])
            check_type(argname="argument rotate", value=rotate, expected_type=type_hints["rotate"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument shear", value=shear, expected_type=type_hints["shear"])
            check_type(argname="argument trim", value=trim, expected_type=type_hints["trim"])
            check_type(argname="argument unsharp_mask", value=unsharp_mask, expected_type=type_hints["unsharp_mask"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if append is not None:
            self._values["append"] = append
        if aspect_crop is not None:
            self._values["aspect_crop"] = aspect_crop
        if background_color is not None:
            self._values["background_color"] = background_color
        if blur is not None:
            self._values["blur"] = blur
        if chroma_key is not None:
            self._values["chroma_key"] = chroma_key
        if composite is not None:
            self._values["composite"] = composite
        if compound is not None:
            self._values["compound"] = compound
        if contrast is not None:
            self._values["contrast"] = contrast
        if crop is not None:
            self._values["crop"] = crop
        if face_crop is not None:
            self._values["face_crop"] = face_crop
        if feature_crop is not None:
            self._values["feature_crop"] = feature_crop
        if fit_and_fill is not None:
            self._values["fit_and_fill"] = fit_and_fill
        if goop is not None:
            self._values["goop"] = goop
        if grayscale is not None:
            self._values["grayscale"] = grayscale
        if hsl is not None:
            self._values["hsl"] = hsl
        if hsv is not None:
            self._values["hsv"] = hsv
        if if_dimension is not None:
            self._values["if_dimension"] = if_dimension
        if if_orientation is not None:
            self._values["if_orientation"] = if_orientation
        if im_query is not None:
            self._values["im_query"] = im_query
        if max_colors is not None:
            self._values["max_colors"] = max_colors
        if mirror is not None:
            self._values["mirror"] = mirror
        if mono_hue is not None:
            self._values["mono_hue"] = mono_hue
        if opacity is not None:
            self._values["opacity"] = opacity
        if region_of_interest_crop is not None:
            self._values["region_of_interest_crop"] = region_of_interest_crop
        if relative_crop is not None:
            self._values["relative_crop"] = relative_crop
        if remove_color is not None:
            self._values["remove_color"] = remove_color
        if resize is not None:
            self._values["resize"] = resize
        if rotate is not None:
            self._values["rotate"] = rotate
        if scale is not None:
            self._values["scale"] = scale
        if shear is not None:
            self._values["shear"] = shear
        if trim is not None:
            self._values["trim"] = trim
        if unsharp_mask is not None:
            self._values["unsharp_mask"] = unsharp_mask

    @builtins.property
    def append(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanAppend"]]]:
        '''append block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        '''
        result = self._values.get("append")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanAppend"]]], result)

    @builtins.property
    def aspect_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanAspectCrop"]]]:
        '''aspect_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        '''
        result = self._values.get("aspect_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanAspectCrop"]]], result)

    @builtins.property
    def background_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanBackgroundColor"]]]:
        '''background_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        '''
        result = self._values.get("background_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanBackgroundColor"]]], result)

    @builtins.property
    def blur(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanBlur"]]]:
        '''blur block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        '''
        result = self._values.get("blur")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanBlur"]]], result)

    @builtins.property
    def chroma_key(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanChromaKey"]]]:
        '''chroma_key block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        '''
        result = self._values.get("chroma_key")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanChromaKey"]]], result)

    @builtins.property
    def composite(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanComposite"]]]:
        '''composite block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        '''
        result = self._values.get("composite")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanComposite"]]], result)

    @builtins.property
    def compound(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompound"]]]:
        '''compound block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        '''
        result = self._values.get("compound")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompound"]]], result)

    @builtins.property
    def contrast(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanContrast"]]]:
        '''contrast block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanContrast"]]], result)

    @builtins.property
    def crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanCrop"]]]:
        '''crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        '''
        result = self._values.get("crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanCrop"]]], result)

    @builtins.property
    def face_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanFaceCrop"]]]:
        '''face_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        '''
        result = self._values.get("face_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanFaceCrop"]]], result)

    @builtins.property
    def feature_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanFeatureCrop"]]]:
        '''feature_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        '''
        result = self._values.get("feature_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanFeatureCrop"]]], result)

    @builtins.property
    def fit_and_fill(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanFitAndFill"]]]:
        '''fit_and_fill block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        '''
        result = self._values.get("fit_and_fill")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanFitAndFill"]]], result)

    @builtins.property
    def goop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanGoop"]]]:
        '''goop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        '''
        result = self._values.get("goop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanGoop"]]], result)

    @builtins.property
    def grayscale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanGrayscale"]]]:
        '''grayscale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        '''
        result = self._values.get("grayscale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanGrayscale"]]], result)

    @builtins.property
    def hsl(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanHsl"]]]:
        '''hsl block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        '''
        result = self._values.get("hsl")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanHsl"]]], result)

    @builtins.property
    def hsv(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanHsv"]]]:
        '''hsv block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        '''
        result = self._values.get("hsv")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanHsv"]]], result)

    @builtins.property
    def if_dimension(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimension"]]]:
        '''if_dimension block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        '''
        result = self._values.get("if_dimension")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimension"]]], result)

    @builtins.property
    def if_orientation(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientation"]]]:
        '''if_orientation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        '''
        result = self._values.get("if_orientation")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientation"]]], result)

    @builtins.property
    def im_query(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanImQuery"]]]:
        '''im_query block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        '''
        result = self._values.get("im_query")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanImQuery"]]], result)

    @builtins.property
    def max_colors(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanMaxColors"]]]:
        '''max_colors block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        '''
        result = self._values.get("max_colors")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanMaxColors"]]], result)

    @builtins.property
    def mirror(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanMirror"]]]:
        '''mirror block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        '''
        result = self._values.get("mirror")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanMirror"]]], result)

    @builtins.property
    def mono_hue(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanMonoHue"]]]:
        '''mono_hue block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        '''
        result = self._values.get("mono_hue")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanMonoHue"]]], result)

    @builtins.property
    def opacity(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanOpacity"]]]:
        '''opacity block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanOpacity"]]], result)

    @builtins.property
    def region_of_interest_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanRegionOfInterestCrop"]]]:
        '''region_of_interest_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        '''
        result = self._values.get("region_of_interest_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanRegionOfInterestCrop"]]], result)

    @builtins.property
    def relative_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanRelativeCrop"]]]:
        '''relative_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        '''
        result = self._values.get("relative_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanRelativeCrop"]]], result)

    @builtins.property
    def remove_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanRemoveColor"]]]:
        '''remove_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        '''
        result = self._values.get("remove_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanRemoveColor"]]], result)

    @builtins.property
    def resize(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanResize"]]]:
        '''resize block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        '''
        result = self._values.get("resize")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanResize"]]], result)

    @builtins.property
    def rotate(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanRotate"]]]:
        '''rotate block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        '''
        result = self._values.get("rotate")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanRotate"]]], result)

    @builtins.property
    def scale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanScale"]]]:
        '''scale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanScale"]]], result)

    @builtins.property
    def shear(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanShear"]]]:
        '''shear block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        '''
        result = self._values.get("shear")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanShear"]]], result)

    @builtins.property
    def trim(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanTrim"]]]:
        '''trim block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        '''
        result = self._values.get("trim")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanTrim"]]], result)

    @builtins.property
    def unsharp_mask(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanUnsharpMask"]]]:
        '''unsharp_mask block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        result = self._values.get("unsharp_mask")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanUnsharpMask"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanAppend",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_priority": "gravityPriority",
        "gravity_priority_var": "gravityPriorityVar",
        "gravity_var": "gravityVar",
        "preserve_minor_dimension": "preserveMinorDimension",
        "preserve_minor_dimension_var": "preserveMinorDimensionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanAppend:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanAppendImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_priority: typing.Optional[builtins.str] = None,
        gravity_priority_var: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        preserve_minor_dimension: typing.Optional[builtins.str] = None,
        preserve_minor_dimension_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Specifies where to place the ``image`` relative to the source image. The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_priority: Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal. The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority DataAkamaiImagingPolicyImage#gravity_priority}
        :param gravity_priority_var: Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal. The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority_var DataAkamaiImagingPolicyImage#gravity_priority_var}
        :param gravity_var: Specifies where to place the ``image`` relative to the source image. The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param preserve_minor_dimension: Whether to preserve the source image's minor dimension, ``false`` by default. The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension DataAkamaiImagingPolicyImage#preserve_minor_dimension}
        :param preserve_minor_dimension_var: Whether to preserve the source image's minor dimension, ``false`` by default. The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension_var DataAkamaiImagingPolicyImage#preserve_minor_dimension_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanAppendImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac295f3e1b065c47b4f39484a7dc1247bfb31d7166b5f406fbbae3e5a5aec5a7)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_priority", value=gravity_priority, expected_type=type_hints["gravity_priority"])
            check_type(argname="argument gravity_priority_var", value=gravity_priority_var, expected_type=type_hints["gravity_priority_var"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument preserve_minor_dimension", value=preserve_minor_dimension, expected_type=type_hints["preserve_minor_dimension"])
            check_type(argname="argument preserve_minor_dimension_var", value=preserve_minor_dimension_var, expected_type=type_hints["preserve_minor_dimension_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_priority is not None:
            self._values["gravity_priority"] = gravity_priority
        if gravity_priority_var is not None:
            self._values["gravity_priority_var"] = gravity_priority_var
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if preserve_minor_dimension is not None:
            self._values["preserve_minor_dimension"] = preserve_minor_dimension
        if preserve_minor_dimension_var is not None:
            self._values["preserve_minor_dimension_var"] = preserve_minor_dimension_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanAppendImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanAppendImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Specifies where to place the ``image`` relative to the source image.

        The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_priority(self) -> typing.Optional[builtins.str]:
        '''Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal.

        The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority DataAkamaiImagingPolicyImage#gravity_priority}
        '''
        result = self._values.get("gravity_priority")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_priority_var(self) -> typing.Optional[builtins.str]:
        '''Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal.

        The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority_var DataAkamaiImagingPolicyImage#gravity_priority_var}
        '''
        result = self._values.get("gravity_priority_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Specifies where to place the ``image`` relative to the source image.

        The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def preserve_minor_dimension(self) -> typing.Optional[builtins.str]:
        '''Whether to preserve the source image's minor dimension, ``false`` by default.

        The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension DataAkamaiImagingPolicyImage#preserve_minor_dimension}
        '''
        result = self._values.get("preserve_minor_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def preserve_minor_dimension_var(self) -> typing.Optional[builtins.str]:
        '''Whether to preserve the source image's minor dimension, ``false`` by default.

        The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension_var DataAkamaiImagingPolicyImage#preserve_minor_dimension_var}
        '''
        result = self._values.get("preserve_minor_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanAppend(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanAppendImage",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanAppendImage:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanAppendImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanAppendImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanAppendImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a8c504eca4126b52b6b20fced054ce642352185ccd8a268635142a5d0bf1ed1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanAppendImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanAppendImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanAppendImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0fc8a51a7cd67083393c2a3ccea7e4c148b319c1430020819412e4d63bff0b8f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanAppendList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanAppendList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__49babbf5b4b0190acf2bf633de4cfb1a05c48b0547de79dd3290dafb888873a9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanAppendOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b737eb50669c67886cf767ea03b63de5a23f344a07fe5a9574ba55afa864550d)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanAppendOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__21d842e49eb00784234c40886a854f44043b1a181c934a669968c7a9cf124175)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7c37fc8ea6a787c1c69a47ec6f4fcfdec169abcaafd71972a9d89687e512df85)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__daf43c43e878d00b7ff192e06ec7780b547b8c27b53bb63cb4c7883150ed7f16)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanAppend]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanAppend]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanAppend]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d23a2e325b21d29a88f0d0ac805935992f92281d19e351519daa147f5b8b287)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanAppendOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanAppendOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6881e22bcc5341633e137a6a3c3c2ea01e3eafc402557ccb42521987038bdaaa)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanAppendImage()

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityPriority")
    def reset_gravity_priority(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityPriority", []))

    @jsii.member(jsii_name="resetGravityPriorityVar")
    def reset_gravity_priority_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityPriorityVar", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPreserveMinorDimension")
    def reset_preserve_minor_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPreserveMinorDimension", []))

    @jsii.member(jsii_name="resetPreserveMinorDimensionVar")
    def reset_preserve_minor_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPreserveMinorDimensionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanAppendImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanAppendImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityInput")
    def gravity_priority_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityPriorityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityVarInput")
    def gravity_priority_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityPriorityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanAppendImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanAppendImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionInput")
    def preserve_minor_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "preserveMinorDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionVarInput")
    def preserve_minor_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "preserveMinorDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a8596efad5556180beba6feec547dcfb4b6431ca68e0beeab56563b009cd3c20)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityPriority")
    def gravity_priority(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityPriority"))

    @gravity_priority.setter
    def gravity_priority(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ca9fbfe9bf272aeebaef52e254f1569d42daf10fbb4516d4a81fd67cd81eb0c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityPriority", value)

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityVar")
    def gravity_priority_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityPriorityVar"))

    @gravity_priority_var.setter
    def gravity_priority_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6c4c34899ea568531908171d1cef3a9ebd2209425ce2af650f09ec3f53bf7201)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityPriorityVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a73751336b04091f5cef74b24bef8ec1de917c8715d0721df71820ab4c4e34ec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimension")
    def preserve_minor_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "preserveMinorDimension"))

    @preserve_minor_dimension.setter
    def preserve_minor_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8bd5a12cad4197872391ea017e957e0037110852cfaea00530f92a39dd8e43e9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "preserveMinorDimension", value)

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionVar")
    def preserve_minor_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "preserveMinorDimensionVar"))

    @preserve_minor_dimension_var.setter
    def preserve_minor_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f364de457d0e13dc885cc2f8a2ea7cf2c6d22afa117abe1c59e042f7b4431058)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "preserveMinorDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanAppend]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanAppend]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanAppend]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f0e9e71c3dc466a1b77e2cbfb5ef1820dd655e56441ab8b198a232385a04d8a4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanAspectCrop",
    jsii_struct_bases=[],
    name_mapping={
        "allow_expansion": "allowExpansion",
        "allow_expansion_var": "allowExpansionVar",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanAspectCrop:
    def __init__(
        self,
        *,
        allow_expansion: typing.Optional[builtins.str] = None,
        allow_expansion_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_expansion: Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image. Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        :param allow_expansion_var: Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image. Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        :param height: The height term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The width term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        :param x_position: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6d9af00ffc80707376aa67b2340a01b1e4c63ff29497208b4e96a453990681e7)
            check_type(argname="argument allow_expansion", value=allow_expansion, expected_type=type_hints["allow_expansion"])
            check_type(argname="argument allow_expansion_var", value=allow_expansion_var, expected_type=type_hints["allow_expansion_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if allow_expansion is not None:
            self._values["allow_expansion"] = allow_expansion
        if allow_expansion_var is not None:
            self._values["allow_expansion_var"] = allow_expansion_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def allow_expansion(self) -> typing.Optional[builtins.str]:
        '''Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image.

        Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        '''
        result = self._values.get("allow_expansion")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def allow_expansion_var(self) -> typing.Optional[builtins.str]:
        '''Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image.

        Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        '''
        result = self._values.get("allow_expansion_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanAspectCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanAspectCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanAspectCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__deb43b065a8957ab7477f9c7bb56d9f10edc3aefaaefcfacee37ab96578bfe98)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanAspectCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dc40fe1ecc2bde3f544f1b62c8f628828f3c10a596c577e1ead3e6c77f2c2e0b)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanAspectCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c20b6cd0b05e9354845049a8513c52f94593eb8eccb405f0c128c09734cb7863)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9587094b96487e70b65317a092bc5622bf58d3f8a771ccf8ac8918faa845c92c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f693d4c14d18e2d57c37b91a2102b35474d3c2e2fc2cca6c6a443cba68d3221e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanAspectCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanAspectCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanAspectCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5e01c0c4fb34f2b1c7a1fa6bfaa8fccac6799ab74431077357f7e64469a789f9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanAspectCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanAspectCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3116457729123c9d7b02a1e3f7b0c2d32a353b63a96073732c8e70eef5fc06c7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAllowExpansion")
    def reset_allow_expansion(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansion", []))

    @jsii.member(jsii_name="resetAllowExpansionVar")
    def reset_allow_expansion_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansionVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionInput")
    def allow_expansion_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVarInput")
    def allow_expansion_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansion")
    def allow_expansion(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansion"))

    @allow_expansion.setter
    def allow_expansion(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__74328b6b5b0623cc4c01f3535c7ea96bc3e08e835373342011846e25d2481826)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansion", value)

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVar")
    def allow_expansion_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansionVar"))

    @allow_expansion_var.setter
    def allow_expansion_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1e11c597de42771c0f3cbe93753fef16c945dbe0a7196d529c7c162661fbdcdc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansionVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__897f03445ae863f161647dbe86fe07895d34db8e0bc296e292cae8eb6ef12623)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__44c3c8d1baf4f48c871c39d82a2b35622a97f91ed924a87994b58452caa0da5f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1b566c5565d8b8f39e418d7c791d4ef6f03466a50a37231ce08916b895e51daa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__508b02d9de46f3882813cdfabf809bf541a8e2e563a3f3c897e96751806a964e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__03e21bb72c8dd94afe59ea99ee4dcecb43b2e2806ca5495f88762681d18487d5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__064388c01b0f9ab1979344cb17e54895b3fe3d270fa9a8ff3d14d3311b4e262a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2381c7c74015516b469d8210201c61da0674a5aff4cbcc36d6f7a482ea874c27)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a4acc8a4389edf149b60249d561421d963b3a91d753dc1c122d05cc205262faa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanAspectCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanAspectCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanAspectCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6d21c6ce64b88e2c66e00d991592ecd30a23aee419146becd7a67a2abf035328)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanBackgroundColor",
    jsii_struct_bases=[],
    name_mapping={"color": "color", "color_var": "colorVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanBackgroundColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__47efde38404d3c381dbb2e147883a76501b251f5761497cb25f818c498b152ae)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanBackgroundColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanBackgroundColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanBackgroundColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ae8214c44e889ddb3d801e7cc6a364c852467c4dea427a609901f27e3b068e32)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanBackgroundColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3f5eb6f1ff4ec1fa1a0a05d7d81ae68beed39c72eb662662a676bb352dd367ec)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanBackgroundColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e5b4d5a6524c6a082b1dab0ca41868fb102acc2c05231e691b698c8f093b9683)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__916d0071328d809eed4ecbda37ad2c19a4c2fd9318631afc557128975559e2da)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__abd472f4d814c7b060acaa78b2a500b4b1e83c57448f7da36f9de0137f53338a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanBackgroundColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanBackgroundColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__40eb124cc343a4c98311ba32b6cc230cf1a77914ca5e8307d7db659bd19cb38c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanBackgroundColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanBackgroundColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c53305de4f6162e74cee62c5ce34ee6256058be70372efba6c3074e8643040c2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2e39d2f049d20cc294d8570a5383a78bb4bca71a9031011ff4e7f5eff1248415)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__72aaed0393e9975ccf3f5c67b34a550fd07533c4e6ca29a5d279c3a8395fe880)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanBackgroundColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanBackgroundColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanBackgroundColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__847c16a4c1d28db2cd754c5463921dcb0142e1b70e31397e9095a94751f816da)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanBlur",
    jsii_struct_bases=[],
    name_mapping={"sigma": "sigma", "sigma_var": "sigmaVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanBlur:
    def __init__(
        self,
        *,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param sigma: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ceec65761b1a855076ac5806439c77c8c61edd6fdf9d6b29f3cf3ade336c7412)
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanBlur(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanBlurList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanBlurList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb1c80316f31c139bd51b652b86ba439c429b7bfe82200d31cd5aab6785d9efe)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanBlurOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d677f81384633cbc5050bf1c2e2979fc941b11bf607c45159a50dd5926132c20)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanBlurOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6d1f94643d75acdd2b6b7475a642651c7b5fb80ab75ec269ebf82c65a0015af4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d18366e5b9b9a10d311b525669d4604761858dbc426e59a5f7c66a0436611c98)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__263d7f8ecd86451b5fa4ad3cdd7faad9399011acb7262ca3e23c1cb86b27c5da)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanBlur]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanBlur]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8ca4ca6211132b3029956c4f3eb38671c54d117b932ba3853ece356ee9226a99)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanBlurOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanBlurOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__84f282300be3f16236b0deb46d2235ed8e4c14a1f9a8d1ffe3ed4392652ee79b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eafad2b44364f8cecbac1ddc7e83349932a6512569c534ae6082f823e02509e0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1513c0dd144326aeca616e4fadfbce2075ed2bacebe9b78a44f6f5cbc1b9516c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanBlur]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanBlur]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanBlur]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f005551175afb4827a63679dd461c250a680139dcff60c1ca1647efc1b148782)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanChromaKey",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_feather": "hueFeather",
        "hue_feather_var": "hueFeatherVar",
        "hue_tolerance": "hueTolerance",
        "hue_tolerance_var": "hueToleranceVar",
        "hue_var": "hueVar",
        "lightness_feather": "lightnessFeather",
        "lightness_feather_var": "lightnessFeatherVar",
        "lightness_tolerance": "lightnessTolerance",
        "lightness_tolerance_var": "lightnessToleranceVar",
        "saturation_feather": "saturationFeather",
        "saturation_feather_var": "saturationFeatherVar",
        "saturation_tolerance": "saturationTolerance",
        "saturation_tolerance_var": "saturationToleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanChromaKey:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_feather: typing.Optional[builtins.str] = None,
        hue_feather_var: typing.Optional[builtins.str] = None,
        hue_tolerance: typing.Optional[builtins.str] = None,
        hue_tolerance_var: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness_feather: typing.Optional[builtins.str] = None,
        lightness_feather_var: typing.Optional[builtins.str] = None,
        lightness_tolerance: typing.Optional[builtins.str] = None,
        lightness_tolerance_var: typing.Optional[builtins.str] = None,
        saturation_feather: typing.Optional[builtins.str] = None,
        saturation_feather_var: typing.Optional[builtins.str] = None,
        saturation_tolerance: typing.Optional[builtins.str] = None,
        saturation_tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_feather: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        :param hue_feather_var: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        :param hue_tolerance: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        :param hue_tolerance_var: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        :param hue_var: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness_feather: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        :param lightness_feather_var: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        :param lightness_tolerance: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        :param lightness_tolerance_var: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        :param saturation_feather: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        :param saturation_feather_var: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        :param saturation_tolerance: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        :param saturation_tolerance_var: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c506888b1f1433f6286fbd956c82d591c80d7e4209798a2da54d0a79c8bff89c)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_feather", value=hue_feather, expected_type=type_hints["hue_feather"])
            check_type(argname="argument hue_feather_var", value=hue_feather_var, expected_type=type_hints["hue_feather_var"])
            check_type(argname="argument hue_tolerance", value=hue_tolerance, expected_type=type_hints["hue_tolerance"])
            check_type(argname="argument hue_tolerance_var", value=hue_tolerance_var, expected_type=type_hints["hue_tolerance_var"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness_feather", value=lightness_feather, expected_type=type_hints["lightness_feather"])
            check_type(argname="argument lightness_feather_var", value=lightness_feather_var, expected_type=type_hints["lightness_feather_var"])
            check_type(argname="argument lightness_tolerance", value=lightness_tolerance, expected_type=type_hints["lightness_tolerance"])
            check_type(argname="argument lightness_tolerance_var", value=lightness_tolerance_var, expected_type=type_hints["lightness_tolerance_var"])
            check_type(argname="argument saturation_feather", value=saturation_feather, expected_type=type_hints["saturation_feather"])
            check_type(argname="argument saturation_feather_var", value=saturation_feather_var, expected_type=type_hints["saturation_feather_var"])
            check_type(argname="argument saturation_tolerance", value=saturation_tolerance, expected_type=type_hints["saturation_tolerance"])
            check_type(argname="argument saturation_tolerance_var", value=saturation_tolerance_var, expected_type=type_hints["saturation_tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_feather is not None:
            self._values["hue_feather"] = hue_feather
        if hue_feather_var is not None:
            self._values["hue_feather_var"] = hue_feather_var
        if hue_tolerance is not None:
            self._values["hue_tolerance"] = hue_tolerance
        if hue_tolerance_var is not None:
            self._values["hue_tolerance_var"] = hue_tolerance_var
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness_feather is not None:
            self._values["lightness_feather"] = lightness_feather
        if lightness_feather_var is not None:
            self._values["lightness_feather_var"] = lightness_feather_var
        if lightness_tolerance is not None:
            self._values["lightness_tolerance"] = lightness_tolerance
        if lightness_tolerance_var is not None:
            self._values["lightness_tolerance_var"] = lightness_tolerance_var
        if saturation_feather is not None:
            self._values["saturation_feather"] = saturation_feather
        if saturation_feather_var is not None:
            self._values["saturation_feather_var"] = saturation_feather_var
        if saturation_tolerance is not None:
            self._values["saturation_tolerance"] = saturation_tolerance
        if saturation_tolerance_var is not None:
            self._values["saturation_tolerance_var"] = saturation_tolerance_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        '''
        result = self._values.get("hue_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        '''
        result = self._values.get("hue_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        '''
        result = self._values.get("hue_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        '''
        result = self._values.get("hue_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        '''
        result = self._values.get("lightness_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        '''
        result = self._values.get("lightness_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        '''
        result = self._values.get("lightness_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        '''
        result = self._values.get("lightness_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        '''
        result = self._values.get("saturation_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        '''
        result = self._values.get("saturation_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        '''
        result = self._values.get("saturation_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        result = self._values.get("saturation_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanChromaKey(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanChromaKeyList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanChromaKeyList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e6491c05f42a25fdf81a63b236c8676a2a1d99da224113b21e65cdd9c0b6691d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanChromaKeyOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__827ffbd2a4a839d819962d789c611e8e252fa24aac708d9a425d82047ae0e6e0)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanChromaKeyOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__42bdba22468cd996f580c93677d2fcb7f2169be3be99a81ada528f398a1c0469)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1a300d604b35676d4b6bb2b4fc3f04d01a4780a49f694e3aa2475021d4b0a30f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__450be5a4622c2a34007f7b1000d5af8b7085ca7e7313ac166f0dba363d3b9d9e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanChromaKey]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanChromaKey]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2fd1b68492415f3fff0122615cd01817fa7ade417cb1be0fffb2a383997cbbd7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanChromaKeyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanChromaKeyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__111f01a9fb07904bd452aa3157d7426da5d49b9f9e3595b7a6ec63f2a1e9f915)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueFeather")
    def reset_hue_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeather", []))

    @jsii.member(jsii_name="resetHueFeatherVar")
    def reset_hue_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeatherVar", []))

    @jsii.member(jsii_name="resetHueTolerance")
    def reset_hue_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueTolerance", []))

    @jsii.member(jsii_name="resetHueToleranceVar")
    def reset_hue_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueToleranceVar", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightnessFeather")
    def reset_lightness_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeather", []))

    @jsii.member(jsii_name="resetLightnessFeatherVar")
    def reset_lightness_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeatherVar", []))

    @jsii.member(jsii_name="resetLightnessTolerance")
    def reset_lightness_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessTolerance", []))

    @jsii.member(jsii_name="resetLightnessToleranceVar")
    def reset_lightness_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessToleranceVar", []))

    @jsii.member(jsii_name="resetSaturationFeather")
    def reset_saturation_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeather", []))

    @jsii.member(jsii_name="resetSaturationFeatherVar")
    def reset_saturation_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeatherVar", []))

    @jsii.member(jsii_name="resetSaturationTolerance")
    def reset_saturation_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationTolerance", []))

    @jsii.member(jsii_name="resetSaturationToleranceVar")
    def reset_saturation_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherInput")
    def hue_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVarInput")
    def hue_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceInput")
    def hue_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVarInput")
    def hue_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherInput")
    def lightness_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVarInput")
    def lightness_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceInput")
    def lightness_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVarInput")
    def lightness_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherInput")
    def saturation_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVarInput")
    def saturation_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceInput")
    def saturation_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVarInput")
    def saturation_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1ad6c89cfff8f8ba8ea5c7d23caf4610f9ea3ea37f124a85f3164c5f9de0dfc9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeather")
    def hue_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeather"))

    @hue_feather.setter
    def hue_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__90a1c58300d7fc28a30cadb097c12fa601ffa37b2cb96843c223d0938858c015)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeather", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVar")
    def hue_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeatherVar"))

    @hue_feather_var.setter
    def hue_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd9d602389360b244cbfe570f1b09ab3c926fd296dd5662dca0b8a7f0769b2f9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueTolerance")
    def hue_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueTolerance"))

    @hue_tolerance.setter
    def hue_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__265a99fb2b7d03cd4e3cce49dfdb493c0a4d77e017da68de6881744bee7fc092)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVar")
    def hue_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueToleranceVar"))

    @hue_tolerance_var.setter
    def hue_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3f89acd2c6de036b302398d53cc4b226c944fb858cffaf3ff0bdd1187a3fa6c5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4c7ca29121a720d5f1efe85b60119a7984f99d1591e6a00d90a63abc4a0e23b7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeather")
    def lightness_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeather"))

    @lightness_feather.setter
    def lightness_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3e16d60189344df3d51a0796aae249556a8ddfda66a49441ce679aa464db67eb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeather", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVar")
    def lightness_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeatherVar"))

    @lightness_feather_var.setter
    def lightness_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ddbb636d00bad578d599b278437119f0b420c6003a64c3c802523f6eff6234f6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessTolerance")
    def lightness_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessTolerance"))

    @lightness_tolerance.setter
    def lightness_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b914bcbb462b2048e547c629c7023b324a4c1675ff748531e37c1abe4cee70ae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVar")
    def lightness_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessToleranceVar"))

    @lightness_tolerance_var.setter
    def lightness_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__404ec2d7de3cd56c1d80ea70677941f3cb7aa0cafa7593df3bf817d251f10aaa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeather")
    def saturation_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeather"))

    @saturation_feather.setter
    def saturation_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__30eae86fd3be86bfd4e6ebe2e19c3e62cf9b199296ef1c45c043cd2d51a9d594)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeather", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVar")
    def saturation_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeatherVar"))

    @saturation_feather_var.setter
    def saturation_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6dfc7bee3f43cb40ae7ddd30f457e02dd44850764026c5ab1a3043bd1743821b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationTolerance")
    def saturation_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationTolerance"))

    @saturation_tolerance.setter
    def saturation_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f9f1a29057a9ab4a6eb512dd26c64567825a2a336553596276dfe831a02dd3d5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVar")
    def saturation_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationToleranceVar"))

    @saturation_tolerance_var.setter
    def saturation_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa189c1e01db028cf5f7b983ce161fa8e5a1d4a71e50d31fe6142d5d87cf5a7e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanChromaKey]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanChromaKey]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanChromaKey]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab3e3cf798bcbe06fae71d436e97916e4ad4a3d27cbf7c5451337ef751919a38)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanComposite",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "placement": "placement",
        "placement_var": "placementVar",
        "scale": "scale",
        "scale_dimension": "scaleDimension",
        "scale_dimension_var": "scaleDimensionVar",
        "scale_var": "scaleVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanComposite:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompositeImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        placement: typing.Optional[builtins.str] = None,
        placement_var: typing.Optional[builtins.str] = None,
        scale: typing.Optional[builtins.str] = None,
        scale_dimension: typing.Optional[builtins.str] = None,
        scale_dimension_var: typing.Optional[builtins.str] = None,
        scale_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param placement: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        :param placement_var: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        :param scale: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param scale_dimension: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        :param scale_dimension_var: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        :param scale_var: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        :param x_position: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompositeImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0e3a5adaa9ec0a9b86a5d35c74fe6d3e2abecbaf3f68359f791a92fe7a9d5acb)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument placement", value=placement, expected_type=type_hints["placement"])
            check_type(argname="argument placement_var", value=placement_var, expected_type=type_hints["placement_var"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument scale_dimension", value=scale_dimension, expected_type=type_hints["scale_dimension"])
            check_type(argname="argument scale_dimension_var", value=scale_dimension_var, expected_type=type_hints["scale_dimension_var"])
            check_type(argname="argument scale_var", value=scale_var, expected_type=type_hints["scale_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if placement is not None:
            self._values["placement"] = placement
        if placement_var is not None:
            self._values["placement_var"] = placement_var
        if scale is not None:
            self._values["scale"] = scale
        if scale_dimension is not None:
            self._values["scale_dimension"] = scale_dimension
        if scale_dimension_var is not None:
            self._values["scale_dimension_var"] = scale_dimension_var
        if scale_var is not None:
            self._values["scale_var"] = scale_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompositeImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompositeImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        '''
        result = self._values.get("placement")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement_var(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        '''
        result = self._values.get("placement_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        '''
        result = self._values.get("scale_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        '''
        result = self._values.get("scale_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        '''
        result = self._values.get("scale_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanComposite(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompositeImage",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompositeImage:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompositeImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompositeImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompositeImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b14596e1c65ddf802881d7bc4adae0bdd97a9f218c4b844576197d7b44378013)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompositeImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompositeImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4b0aeba68ac0774751b95e325bca913af41ad501fc4f36282d0423749e6aa76a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompositeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompositeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6a0e99c9ecd5d5e256b1616300850346a30ae2ac38b2d108bfe8ca05db57d964)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompositeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2f8c8b9d68d9907d455b427fcd88bfebf2c9ff5a54cba5d7b27cda20aaef7eca)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompositeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8ebb27fb058468ac6c5e77e8462b9a48e0ffd88de3ceffbe8feaa3349c8a7727)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5a332585d33c455e6b1dd7bf8a4d144321f09f729e72c2082aff1bf420748753)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea009b1b035f7c4af066b53a48ef4662c55eb36e1e07f7234763c229f226b5ce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanComposite]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanComposite]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__362ad8ebbc9b4294e6582ade96d326d7f58b58ec2080840f3d5c1e20339b85a6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompositeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompositeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bdf1708e49d26d23bc83fc66d5242ee3092475f04f1fabfa9a1ca4bb07d33f54)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompositeImage()

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPlacement")
    def reset_placement(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacement", []))

    @jsii.member(jsii_name="resetPlacementVar")
    def reset_placement_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacementVar", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetScaleDimension")
    def reset_scale_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimension", []))

    @jsii.member(jsii_name="resetScaleDimensionVar")
    def reset_scale_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimensionVar", []))

    @jsii.member(jsii_name="resetScaleVar")
    def reset_scale_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompositeImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompositeImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompositeImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="placementInput")
    def placement_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementInput"))

    @builtins.property
    @jsii.member(jsii_name="placementVarInput")
    def placement_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionInput")
    def scale_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVarInput")
    def scale_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleVarInput")
    def scale_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ba6a5e7bc085b8bf60bfe65622db5ebd55abb2aebc3e55c7eac4f88572763d46)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af6f1873184215224d5e9a6dd74700acdd25488aef6bde6b4801bb5464676e49)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="placement")
    def placement(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placement"))

    @placement.setter
    def placement(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dfa5f908b447f268971e78d909dfa54cf1b9e39fede5c7d98cfd8339d75d3878)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placement", value)

    @builtins.property
    @jsii.member(jsii_name="placementVar")
    def placement_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placementVar"))

    @placement_var.setter
    def placement_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1570ca956b81b1b05fe5b6af10951c8ba385757a63ce22d7d47c3a6e74d60f9e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placementVar", value)

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scale"))

    @scale.setter
    def scale(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__192a7e08f478f311976171f953e1ac1fe5f6b7cf72cd8b343f7b8fda89e3b9cc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scale", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimension")
    def scale_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimension"))

    @scale_dimension.setter
    def scale_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__039bb6406234e65c2b50d9806674ab222e2125a68e9f7e3ffff874df5f784183)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimension", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVar")
    def scale_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimensionVar"))

    @scale_dimension_var.setter
    def scale_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2dad50e8868bbe62d59865ac2a3e401b0edd708792fb2b2cafa2625ec06c2d6f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="scaleVar")
    def scale_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleVar"))

    @scale_var.setter
    def scale_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1220d1f4e0b48b267638aa9170aa9009306045a4ca161f32445c79fb0afb7957)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__239bcfa325011b0b0e2b65840985a50f1fcec6326f6cf0744e4d047f2ed9f3a0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d147a312b78e6d30c91b00bf86c1fc5233d48aa09ec6601c24a14cafd62d14ae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e36d861983c14a57b472c18cc6f02a8d439f43d567a641daddce1e72fd4c4d69)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__372407e9732d24d6a57268ea196087976f5ebb7568a4410ff055c9e6730ad8fc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanComposite]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanComposite]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanComposite]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__81f2abb7a967eabd5a2a8717e863d3e767647625ab7c47243615b9c1c62f3b1e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompound",
    jsii_struct_bases=[],
    name_mapping={"transformations": "transformations"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompound:
    def __init__(
        self,
        *,
        transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param transformations: transformations block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eca37f7ffae53369c61cff6e3635646955e8253ee540717a3dafe9529729d912)
            check_type(argname="argument transformations", value=transformations, expected_type=type_hints["transformations"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if transformations is not None:
            self._values["transformations"] = transformations

    @builtins.property
    def transformations(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompoundTransformations"]]]:
        '''transformations block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        result = self._values.get("transformations")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompoundTransformations"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompound(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompoundList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompoundList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3da8603cc141e578f3d216d51bae3185176f6d65387549307eec111fc4a31ae5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompoundOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e5829331387f39f08d84f67bc9e1c8527686929492d1ceb18b94ecb3b5211912)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompoundOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__573c348b7391928508d506b61cb430197934068761f9ea6d77c9a60f67a1baf0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ce9288cd56b781d221cd0a4cd8c489460bbaf2609a261e52d27673b80d9b479a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a101db5835acb49777cf7ae97fa9f9232098b38b29f5c062a3a05476e6bdc569)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompound]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompound]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3c0d145131bbb0a03caf8352bd264c822da34fc2aee482672c141f20f2565af9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompoundOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompoundOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9838be647589c059d83c252349e4e4fb850f98499db6ec884d7a001c9eeeb3d6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformations")
    def put_transformations(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__91490c51b4636d4cfdb1028c49503c1978edc4f51c1037e154ede132f897d7a5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTransformations", [value]))

    @jsii.member(jsii_name="resetTransformations")
    def reset_transformations(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformations", []))

    @builtins.property
    @jsii.member(jsii_name="transformations")
    def transformations(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompoundTransformationsList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompoundTransformationsList", jsii.get(self, "transformations"))

    @builtins.property
    @jsii.member(jsii_name="transformationsInput")
    def transformations_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompoundTransformations"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompoundTransformations"]]], jsii.get(self, "transformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompound]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompound]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompound]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d9c918add0504af971472bb4945344fb25fe94b028d1f2c347f99c8a70cb0173)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompoundTransformations",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompoundTransformations:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompoundTransformations(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompoundTransformationsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompoundTransformationsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1091664ed842d0d1562c9984d06b7d5e71f5f0538bac65ef381e40c619bb8742)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompoundTransformationsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__74fbad5a033e9c4ef0a333a9aa85d9b75a9c536d18962d923b72225cace8579d)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompoundTransformationsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b95965bf8a29dd0caf940fcf4c458d5391fb76058571f7c1d9571d22b7862f13)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9cd40a3fc908c94ac136b6a1e505518e87a2f399e57a798b0c7308e655886879)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a447e4c1cd74ae424841a25728e984e54901e6c44a52ef52e38ccc9efdc17fa0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompoundTransformations]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompoundTransformations]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompoundTransformations]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1e053ab26207fa2bf6c914dc27847fdbe119ccc58da649bf97fe0f98ee0d765a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompoundTransformationsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompoundTransformationsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aa999f33e998afd4e1bbc2df5f6e41854dfbe4b242226bd6280aa29e787e2fec)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompoundTransformations]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompoundTransformations]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompoundTransformations]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f6e6f7fc46d9a15cc12499fe5473cf9c7f7c8e93dfdeee003ff9fbd4454b772b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanContrast",
    jsii_struct_bases=[],
    name_mapping={
        "brightness": "brightness",
        "brightness_var": "brightnessVar",
        "contrast": "contrast",
        "contrast_var": "contrastVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanContrast:
    def __init__(
        self,
        *,
        brightness: typing.Optional[builtins.str] = None,
        brightness_var: typing.Optional[builtins.str] = None,
        contrast: typing.Optional[builtins.str] = None,
        contrast_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param brightness: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        :param brightness_var: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        :param contrast: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param contrast_var: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e4b4575bff57aac8e68be51a18f978d6831369d0183a6778cc87f4af91c90381)
            check_type(argname="argument brightness", value=brightness, expected_type=type_hints["brightness"])
            check_type(argname="argument brightness_var", value=brightness_var, expected_type=type_hints["brightness_var"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument contrast_var", value=contrast_var, expected_type=type_hints["contrast_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if brightness is not None:
            self._values["brightness"] = brightness
        if brightness_var is not None:
            self._values["brightness_var"] = brightness_var
        if contrast is not None:
            self._values["contrast"] = contrast
        if contrast_var is not None:
            self._values["contrast_var"] = contrast_var

    @builtins.property
    def brightness(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        '''
        result = self._values.get("brightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def brightness_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        '''
        result = self._values.get("brightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        result = self._values.get("contrast_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanContrast(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanContrastList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanContrastList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e373328a6f3548a704e0769fbb7585eb2a045f29f6c08686b321ac63de730912)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanContrastOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3c167976b20f39ea7e9cd40ca493ddf2cfc471aabee67fc6c174821619fc95b6)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanContrastOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dd0ece2c90ded991e2b59d61329e6cd00d1ad02551dce3c22b16012c7b612c54)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1d8f36eecaccc18e496a2ae2bed575066fdc26175b518b93ff3da55c98a460de)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2b3bf2103ac4cd0bf395df3b28d4cd8407a9c92d80d5df9f144b61db5c37a7d5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanContrast]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanContrast]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__64329e49dda770c90cef43b10d3c9115ccfdb14e80c2605cf77cc93fc9e32412)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanContrastOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanContrastOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4752e97a902584d0d86d7379071b3ead2cb691a4acecdfa7bffbccfe87248cea)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetBrightness")
    def reset_brightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightness", []))

    @jsii.member(jsii_name="resetBrightnessVar")
    def reset_brightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightnessVar", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetContrastVar")
    def reset_contrast_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrastVar", []))

    @builtins.property
    @jsii.member(jsii_name="brightnessInput")
    def brightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="brightnessVarInput")
    def brightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastVarInput")
    def contrast_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="brightness")
    def brightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightness"))

    @brightness.setter
    def brightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e640e8cbf82677aa2037c7bfe40bbc42ea8210b6ecb1cddd4c0b7a2aeaa95cc4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightness", value)

    @builtins.property
    @jsii.member(jsii_name="brightnessVar")
    def brightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightnessVar"))

    @brightness_var.setter
    def brightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ca19a04a4201e5df06aa6ca1b9cf3fda7e019fbf35858e5590b2c58ed2f7a26)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrast"))

    @contrast.setter
    def contrast(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aac951f8e8b012a3807772d664bec54ef702d0c95b61a396064ccdb77dd51243)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrast", value)

    @builtins.property
    @jsii.member(jsii_name="contrastVar")
    def contrast_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrastVar"))

    @contrast_var.setter
    def contrast_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fbfa7c204e3472d5840338d18ae7bbe691453d32bf83a2771993344af9dff78c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrastVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanContrast]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanContrast]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanContrast]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8612e694df6b0b6f76b27888805a603a8ad644e0efae23ded58e38f6d70e72db)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanCrop",
    jsii_struct_bases=[],
    name_mapping={
        "allow_expansion": "allowExpansion",
        "allow_expansion_var": "allowExpansionVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanCrop:
    def __init__(
        self,
        *,
        allow_expansion: typing.Optional[builtins.str] = None,
        allow_expansion_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_expansion: If cropping an area outside of the existing canvas, expands the image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        :param allow_expansion_var: If cropping an area outside of the existing canvas, expands the image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        :param gravity: Frame of reference for X and Y Positions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Frame of reference for X and Y Positions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The number of pixels to crop along the y-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The number of pixels to crop along the y-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The number of pixels to crop along the x-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The number of pixels to crop along the x-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        :param x_position: The x-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0755ca76daa7e589d8964c5b0e3e12d2b7f2f513a3c79bbaf7dd4938ea1466b1)
            check_type(argname="argument allow_expansion", value=allow_expansion, expected_type=type_hints["allow_expansion"])
            check_type(argname="argument allow_expansion_var", value=allow_expansion_var, expected_type=type_hints["allow_expansion_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if allow_expansion is not None:
            self._values["allow_expansion"] = allow_expansion
        if allow_expansion_var is not None:
            self._values["allow_expansion_var"] = allow_expansion_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def allow_expansion(self) -> typing.Optional[builtins.str]:
        '''If cropping an area outside of the existing canvas, expands the image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        '''
        result = self._values.get("allow_expansion")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def allow_expansion_var(self) -> typing.Optional[builtins.str]:
        '''If cropping an area outside of the existing canvas, expands the image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        '''
        result = self._values.get("allow_expansion_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Frame of reference for X and Y Positions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Frame of reference for X and Y Positions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the y-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the y-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the x-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the x-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__299e615397e48b136a2d13efd8f6bf30369a9126b2b52041050641cda56d6d4b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b5e3f5354dd5c106660e74434194271929237819b2a7f26004086aafadeca57f)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aa26b57e4f28736f8146f178947a0cdd93b84d1cfc7609c971786bc6491a78b0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a3253669e121b77663a99ba7bbc7487f524b7d7a13b1fed56cec52d9f8aa9bda)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__52e736b7685468b5a17fdeb1f9de737d1accf27458fbf302e581fdebf0cd08e7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__089a179380445b49b2df4f444960c8fde5d573f9722cb10c042b515abf827bcf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a632f48fd12e2bb6116302d0be2b20423fe07f62b04ab8723ed3140daf01b63)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAllowExpansion")
    def reset_allow_expansion(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansion", []))

    @jsii.member(jsii_name="resetAllowExpansionVar")
    def reset_allow_expansion_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansionVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionInput")
    def allow_expansion_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVarInput")
    def allow_expansion_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansion")
    def allow_expansion(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansion"))

    @allow_expansion.setter
    def allow_expansion(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1c39e6634de35a37efb7978bed9eb806939e60a76e8c4398cf0b101b7c4d4df3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansion", value)

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVar")
    def allow_expansion_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansionVar"))

    @allow_expansion_var.setter
    def allow_expansion_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__72938fc174873577ecec2277e8511284b6fbc23cffff7686dabe7212807be6de)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansionVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fd9b553e45ef20de176c0be90f535d16a4d590aa0a14eaf9a9a0d04b540d11a0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6ef503dc71eaef217d4095b7a2a36f5ae25fea1248e6d219b615887c106b6c5d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__769f2a241176db5fc380313780d89ca3e8f9b21e5402fbd28acd00b735509831)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dc477c83f2d04aed00304a8ad8e0f2f4ae7b936b0d8d6f0c60634abe2fd51d9d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8af37198bd77442dd8c61c3c5a73fb06c6e4963d4549c1d16e030d59019d9d91)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd17861fb96795a9d7c33d2df46251257c4537086158307f89f5c026b687a3d6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a54c8b8b73f71e5338900c9b68d0af7e5732b3f6605100b4470e451882b72fbb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6508b15e577e2c3847a2b6f667287d98931941f557aa156ebfbf6837035442ea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f44fe8825feece745251963dd60f3740401013b24a847b7a39b6c5974f205493)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3e555b6ba7e82ee5c48b958385611d79ef82d4cd15975e60a1f96a9aa7e6b555)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e24c972049fa198758446a3132442fbc24ac625a3293afcfc95dc841c930cab2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanFaceCrop",
    jsii_struct_bases=[],
    name_mapping={
        "algorithm": "algorithm",
        "algorithm_var": "algorithmVar",
        "confidence": "confidence",
        "confidence_var": "confidenceVar",
        "fail_gravity": "failGravity",
        "fail_gravity_var": "failGravityVar",
        "focus": "focus",
        "focus_var": "focusVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "padding": "padding",
        "padding_var": "paddingVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanFaceCrop:
    def __init__(
        self,
        *,
        algorithm: typing.Optional[builtins.str] = None,
        algorithm_var: typing.Optional[builtins.str] = None,
        confidence: typing.Optional[builtins.str] = None,
        confidence_var: typing.Optional[builtins.str] = None,
        fail_gravity: typing.Optional[builtins.str] = None,
        fail_gravity_var: typing.Optional[builtins.str] = None,
        focus: typing.Optional[builtins.str] = None,
        focus_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param algorithm: Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm DataAkamaiImagingPolicyImage#algorithm}
        :param algorithm_var: Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm_var DataAkamaiImagingPolicyImage#algorithm_var}
        :param confidence: With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image. Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence DataAkamaiImagingPolicyImage#confidence}
        :param confidence_var: With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image. Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence_var DataAkamaiImagingPolicyImage#confidence_var}
        :param fail_gravity: Controls placement of the crop if Image and Video Manager does not detect any faces in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        :param fail_gravity_var: Controls placement of the crop if Image and Video Manager does not detect any faces in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        :param focus: Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus DataAkamaiImagingPolicyImage#focus}
        :param focus_var: Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus_var DataAkamaiImagingPolicyImage#focus_var}
        :param gravity: Controls placement of the crop. Directions are relative to the face(s) plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Controls placement of the crop. Directions are relative to the face(s) plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param padding: The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        :param style: Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aaa2ee0144b641f29a8e43abb453b45399106015a7750fab2887f54d8fa344ca)
            check_type(argname="argument algorithm", value=algorithm, expected_type=type_hints["algorithm"])
            check_type(argname="argument algorithm_var", value=algorithm_var, expected_type=type_hints["algorithm_var"])
            check_type(argname="argument confidence", value=confidence, expected_type=type_hints["confidence"])
            check_type(argname="argument confidence_var", value=confidence_var, expected_type=type_hints["confidence_var"])
            check_type(argname="argument fail_gravity", value=fail_gravity, expected_type=type_hints["fail_gravity"])
            check_type(argname="argument fail_gravity_var", value=fail_gravity_var, expected_type=type_hints["fail_gravity_var"])
            check_type(argname="argument focus", value=focus, expected_type=type_hints["focus"])
            check_type(argname="argument focus_var", value=focus_var, expected_type=type_hints["focus_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if algorithm is not None:
            self._values["algorithm"] = algorithm
        if algorithm_var is not None:
            self._values["algorithm_var"] = algorithm_var
        if confidence is not None:
            self._values["confidence"] = confidence
        if confidence_var is not None:
            self._values["confidence_var"] = confidence_var
        if fail_gravity is not None:
            self._values["fail_gravity"] = fail_gravity
        if fail_gravity_var is not None:
            self._values["fail_gravity_var"] = fail_gravity_var
        if focus is not None:
            self._values["focus"] = focus
        if focus_var is not None:
            self._values["focus_var"] = focus_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def algorithm(self) -> typing.Optional[builtins.str]:
        '''Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm DataAkamaiImagingPolicyImage#algorithm}
        '''
        result = self._values.get("algorithm")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def algorithm_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm_var DataAkamaiImagingPolicyImage#algorithm_var}
        '''
        result = self._values.get("algorithm_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def confidence(self) -> typing.Optional[builtins.str]:
        '''With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image.

        Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence DataAkamaiImagingPolicyImage#confidence}
        '''
        result = self._values.get("confidence")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def confidence_var(self) -> typing.Optional[builtins.str]:
        '''With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image.

        Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence_var DataAkamaiImagingPolicyImage#confidence_var}
        '''
        result = self._values.get("confidence_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any faces in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        '''
        result = self._values.get("fail_gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any faces in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        '''
        result = self._values.get("fail_gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def focus(self) -> typing.Optional[builtins.str]:
        '''Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus DataAkamaiImagingPolicyImage#focus}
        '''
        result = self._values.get("focus")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def focus_var(self) -> typing.Optional[builtins.str]:
        '''Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus_var DataAkamaiImagingPolicyImage#focus_var}
        '''
        result = self._values.get("focus_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the face(s) plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the face(s) plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanFaceCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanFaceCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanFaceCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a1ec4d3a2d06a7ba3e6875504411749784584ce93476d9540d59fb18484754d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanFaceCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a6b4c4d370852e1fd9c7dc563555923cc9c5a7f168225beea60fcc3756bbb35)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanFaceCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f54fb694c44f8c4795205b3c873582dfeabf38c821bc72660b2bdc7d03d58e73)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9f0192b9c75d96c6e44cd136ff9df122530b78d3603354c3b22218b8a93525f5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__641eec2648d3197f2142d226ff43fa801cdb1020bc36e06d74a2f6f08238a449)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanFaceCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanFaceCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanFaceCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ee989d65f6b1aad968146bb0ee7b7acddb1a9321517aeaf1249c2199b43824e5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanFaceCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanFaceCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fb21b6baf8518390091906cd57f2c2ed027e7b215ed9c298ad59e47f202325f1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAlgorithm")
    def reset_algorithm(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAlgorithm", []))

    @jsii.member(jsii_name="resetAlgorithmVar")
    def reset_algorithm_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAlgorithmVar", []))

    @jsii.member(jsii_name="resetConfidence")
    def reset_confidence(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetConfidence", []))

    @jsii.member(jsii_name="resetConfidenceVar")
    def reset_confidence_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetConfidenceVar", []))

    @jsii.member(jsii_name="resetFailGravity")
    def reset_fail_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravity", []))

    @jsii.member(jsii_name="resetFailGravityVar")
    def reset_fail_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravityVar", []))

    @jsii.member(jsii_name="resetFocus")
    def reset_focus(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFocus", []))

    @jsii.member(jsii_name="resetFocusVar")
    def reset_focus_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFocusVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="algorithmInput")
    def algorithm_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "algorithmInput"))

    @builtins.property
    @jsii.member(jsii_name="algorithmVarInput")
    def algorithm_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "algorithmVarInput"))

    @builtins.property
    @jsii.member(jsii_name="confidenceInput")
    def confidence_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "confidenceInput"))

    @builtins.property
    @jsii.member(jsii_name="confidenceVarInput")
    def confidence_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "confidenceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityInput")
    def fail_gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityVarInput")
    def fail_gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="focusInput")
    def focus_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "focusInput"))

    @builtins.property
    @jsii.member(jsii_name="focusVarInput")
    def focus_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "focusVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="algorithm")
    def algorithm(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "algorithm"))

    @algorithm.setter
    def algorithm(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d4f23de75ee23a54520db9f975fbe36b1f3cd210788d910f4c3fdab4e135cf19)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "algorithm", value)

    @builtins.property
    @jsii.member(jsii_name="algorithmVar")
    def algorithm_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "algorithmVar"))

    @algorithm_var.setter
    def algorithm_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7c3dea8876cf29cb82e37e99db51eb267035482510f1feeb0ca12d9216cd871b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "algorithmVar", value)

    @builtins.property
    @jsii.member(jsii_name="confidence")
    def confidence(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "confidence"))

    @confidence.setter
    def confidence(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c5321e7b625b87f1e98ee0c1a5cb767b83363e8d86e019f37fd57306a244084e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "confidence", value)

    @builtins.property
    @jsii.member(jsii_name="confidenceVar")
    def confidence_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "confidenceVar"))

    @confidence_var.setter
    def confidence_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7a03ee1921ced9fcb9559df65be6568237997232f6f90ad6e27c06a5a5a01bac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "confidenceVar", value)

    @builtins.property
    @jsii.member(jsii_name="failGravity")
    def fail_gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravity"))

    @fail_gravity.setter
    def fail_gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0461d4f9e6530b2b0d7178da09de71ad5a94b1b2db02fc1f5653abf2e0859906)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravity", value)

    @builtins.property
    @jsii.member(jsii_name="failGravityVar")
    def fail_gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravityVar"))

    @fail_gravity_var.setter
    def fail_gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ad4a0138879686d5f2a2a695ccb20e82f10b42165dff74f2e342ce4f23492bc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="focus")
    def focus(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "focus"))

    @focus.setter
    def focus(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3551b1f8d7c999a1c989afb9253f0492b42034ac304bb55a61099b75aec9b9a4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "focus", value)

    @builtins.property
    @jsii.member(jsii_name="focusVar")
    def focus_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "focusVar"))

    @focus_var.setter
    def focus_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__038f768fb7c5084fcb3fdb7a25561b86ffe75dd5656c0f56b70fb24c15b8ba5e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "focusVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9e2cd30344bd1c7db025adb2fc996fb16b772a6db8a24f6c7bd711c339bf7d0b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fd0c2ce287100041a5c1afa99135ac7f34d7f176b69282196fedc2a4b413151e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8d9fc3321b2eeab88cd3a9b24205db817c9ee5b66c19e36d23f009a0771411ca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4934c4b55585324fd893c699c6b55d7ad1b900a3f9db576e5ceadf443ef13c9a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2887bbf5618a65a10fd5b1ce3478e8fe4217dbb36aca95e18c4b1eaa705e5b6a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d9e54abe1b038d6cd8c4f590451ba7ac52a32e028c386584fc68f4ed7c9e1438)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1a94539c7194b1b7b14c93420e9a9da6dc84a723d0b4a5dfe27ef8d581bfcf6c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__47d4d5a266a0dc598dc917ecd692600547e90a0afeeb5954a242dfb3ea72ca13)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__622507b2ca38b248d0054a7b734e2bb38bfeec72e6a19cc58b31908da5ab8fae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d464e2ef1574c170d4b5740c28f48c4714ba1fcd3a0618b2358440ecf2bab53)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanFaceCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanFaceCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanFaceCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a02f58ff3a19c6f94e68f44559f6e6a1e26f52adb0d49872c26b8f16a72691d1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanFeatureCrop",
    jsii_struct_bases=[],
    name_mapping={
        "fail_gravity": "failGravity",
        "fail_gravity_var": "failGravityVar",
        "feature_radius": "featureRadius",
        "feature_radius_var": "featureRadiusVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "max_features": "maxFeatures",
        "max_features_var": "maxFeaturesVar",
        "min_feature_quality": "minFeatureQuality",
        "min_feature_quality_var": "minFeatureQualityVar",
        "padding": "padding",
        "padding_var": "paddingVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanFeatureCrop:
    def __init__(
        self,
        *,
        fail_gravity: typing.Optional[builtins.str] = None,
        fail_gravity_var: typing.Optional[builtins.str] = None,
        feature_radius: typing.Optional[builtins.str] = None,
        feature_radius_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        max_features: typing.Optional[builtins.str] = None,
        max_features_var: typing.Optional[builtins.str] = None,
        min_feature_quality: typing.Optional[builtins.str] = None,
        min_feature_quality_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fail_gravity: Controls placement of the crop if Image and Video Manager does not detect any features in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        :param fail_gravity_var: Controls placement of the crop if Image and Video Manager does not detect any features in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        :param feature_radius: The size in pixels of the important features to search for. If identified, two features never appear closer together than this value, ``8.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius DataAkamaiImagingPolicyImage#feature_radius}
        :param feature_radius_var: The size in pixels of the important features to search for. If identified, two features never appear closer together than this value, ``8.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius_var DataAkamaiImagingPolicyImage#feature_radius_var}
        :param gravity: Controls placement of the crop. Directions are relative to the region of interest plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Controls placement of the crop. Directions are relative to the region of interest plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param max_features: The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features DataAkamaiImagingPolicyImage#max_features}
        :param max_features_var: The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features_var DataAkamaiImagingPolicyImage#max_features_var}
        :param min_feature_quality: Determines the minimum quality level of the feature identified. To consider a feature important, the feature needs to surpass this value. Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality DataAkamaiImagingPolicyImage#min_feature_quality}
        :param min_feature_quality_var: Determines the minimum quality level of the feature identified. To consider a feature important, the feature needs to surpass this value. Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality_var DataAkamaiImagingPolicyImage#min_feature_quality_var}
        :param padding: Adds space around the region of interest. The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: Adds space around the region of interest. The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        :param style: Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bd1d761fd960bdc38e368d1e9cf0ec8d720d80b90617ebc444a085c1a7c4fd5d)
            check_type(argname="argument fail_gravity", value=fail_gravity, expected_type=type_hints["fail_gravity"])
            check_type(argname="argument fail_gravity_var", value=fail_gravity_var, expected_type=type_hints["fail_gravity_var"])
            check_type(argname="argument feature_radius", value=feature_radius, expected_type=type_hints["feature_radius"])
            check_type(argname="argument feature_radius_var", value=feature_radius_var, expected_type=type_hints["feature_radius_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument max_features", value=max_features, expected_type=type_hints["max_features"])
            check_type(argname="argument max_features_var", value=max_features_var, expected_type=type_hints["max_features_var"])
            check_type(argname="argument min_feature_quality", value=min_feature_quality, expected_type=type_hints["min_feature_quality"])
            check_type(argname="argument min_feature_quality_var", value=min_feature_quality_var, expected_type=type_hints["min_feature_quality_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fail_gravity is not None:
            self._values["fail_gravity"] = fail_gravity
        if fail_gravity_var is not None:
            self._values["fail_gravity_var"] = fail_gravity_var
        if feature_radius is not None:
            self._values["feature_radius"] = feature_radius
        if feature_radius_var is not None:
            self._values["feature_radius_var"] = feature_radius_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if max_features is not None:
            self._values["max_features"] = max_features
        if max_features_var is not None:
            self._values["max_features_var"] = max_features_var
        if min_feature_quality is not None:
            self._values["min_feature_quality"] = min_feature_quality
        if min_feature_quality_var is not None:
            self._values["min_feature_quality_var"] = min_feature_quality_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def fail_gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any features in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        '''
        result = self._values.get("fail_gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any features in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        '''
        result = self._values.get("fail_gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feature_radius(self) -> typing.Optional[builtins.str]:
        '''The size in pixels of the important features to search for.

        If identified, two features never appear closer together than this value, ``8.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius DataAkamaiImagingPolicyImage#feature_radius}
        '''
        result = self._values.get("feature_radius")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feature_radius_var(self) -> typing.Optional[builtins.str]:
        '''The size in pixels of the important features to search for.

        If identified, two features never appear closer together than this value, ``8.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius_var DataAkamaiImagingPolicyImage#feature_radius_var}
        '''
        result = self._values.get("feature_radius_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the region of interest plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the region of interest plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def max_features(self) -> typing.Optional[builtins.str]:
        '''The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features DataAkamaiImagingPolicyImage#max_features}
        '''
        result = self._values.get("max_features")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def max_features_var(self) -> typing.Optional[builtins.str]:
        '''The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features_var DataAkamaiImagingPolicyImage#max_features_var}
        '''
        result = self._values.get("max_features_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def min_feature_quality(self) -> typing.Optional[builtins.str]:
        '''Determines the minimum quality level of the feature identified.

        To consider a feature important, the feature needs to surpass this value.  Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality DataAkamaiImagingPolicyImage#min_feature_quality}
        '''
        result = self._values.get("min_feature_quality")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def min_feature_quality_var(self) -> typing.Optional[builtins.str]:
        '''Determines the minimum quality level of the feature identified.

        To consider a feature important, the feature needs to surpass this value.  Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality_var DataAkamaiImagingPolicyImage#min_feature_quality_var}
        '''
        result = self._values.get("min_feature_quality_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''Adds space around the region of interest.

        The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''Adds space around the region of interest.

        The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanFeatureCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanFeatureCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanFeatureCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__61ec07b142ab1063df08af7975b986a70fb9a18923d1b5d1eb3a3ebf1111c424)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanFeatureCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ae64bf1690f9177ed95262c57c59383fae519c7eb2598fdcbb70cd4fd0e0f510)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanFeatureCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9f7fc3e967da7f638784e4733be2dfd26038f47eb15cbcf6f600fdfa84e245f6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3567d09dce7e31b086fb923c4a4c11d4e07fda725c1ffa412300de1b51546fa5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c139067dbae1dbbbe31dcb0fe92ed31c3afe72f3c103b805935f8151c19b14f8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanFeatureCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanFeatureCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanFeatureCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3f9c9c8f7294fa01cafe257626618c949270815f164427b7476ae639db16a2f1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanFeatureCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanFeatureCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d35c93511e69489444f4e662b2bb44b8262fefec35bad885109fa60685c85be4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetFailGravity")
    def reset_fail_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravity", []))

    @jsii.member(jsii_name="resetFailGravityVar")
    def reset_fail_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravityVar", []))

    @jsii.member(jsii_name="resetFeatureRadius")
    def reset_feature_radius(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureRadius", []))

    @jsii.member(jsii_name="resetFeatureRadiusVar")
    def reset_feature_radius_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureRadiusVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetMaxFeatures")
    def reset_max_features(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxFeatures", []))

    @jsii.member(jsii_name="resetMaxFeaturesVar")
    def reset_max_features_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxFeaturesVar", []))

    @jsii.member(jsii_name="resetMinFeatureQuality")
    def reset_min_feature_quality(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMinFeatureQuality", []))

    @jsii.member(jsii_name="resetMinFeatureQualityVar")
    def reset_min_feature_quality_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMinFeatureQualityVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="failGravityInput")
    def fail_gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityVarInput")
    def fail_gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featureRadiusInput")
    def feature_radius_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featureRadiusInput"))

    @builtins.property
    @jsii.member(jsii_name="featureRadiusVarInput")
    def feature_radius_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featureRadiusVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesInput")
    def max_features_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "maxFeaturesInput"))

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesVarInput")
    def max_features_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "maxFeaturesVarInput"))

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityInput")
    def min_feature_quality_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "minFeatureQualityInput"))

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityVarInput")
    def min_feature_quality_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "minFeatureQualityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravity")
    def fail_gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravity"))

    @fail_gravity.setter
    def fail_gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a89906d2284a66fd7818dde620605c60c0e2e5234c5090bd28ce44cb0623fe80)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravity", value)

    @builtins.property
    @jsii.member(jsii_name="failGravityVar")
    def fail_gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravityVar"))

    @fail_gravity_var.setter
    def fail_gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c30ccd6c455afa003be65f416ed014547722a548dfc6c8f86ed03a1c5a9082a2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="featureRadius")
    def feature_radius(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featureRadius"))

    @feature_radius.setter
    def feature_radius(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a5bf8158d55337e1cf58daf80aa04ba3d58cb0ce6d4db9082e1e42300e402fc6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featureRadius", value)

    @builtins.property
    @jsii.member(jsii_name="featureRadiusVar")
    def feature_radius_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featureRadiusVar"))

    @feature_radius_var.setter
    def feature_radius_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1764fe92440dddcbe466f219b79cc7b1f4df757641fdb61221c8c0fb0cb42ad2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featureRadiusVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a22efc81478b6b482f34190a3dca36a4267df0686747bfacd23222f47fd4fe1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0c56e96f989c12c00df24935911b2c6503af407fb6226ded4e3578b3239e47a4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__228a108f40e93fa1bec0dca7714e3743187cc437779a3ef9583c5b5d03a13f6c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9087b68b1814182fc669157a7c4c403147e42a074d2a62adf5249a3ead8fef8c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="maxFeatures")
    def max_features(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "maxFeatures"))

    @max_features.setter
    def max_features(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f1bada8b8af10d11487a2657ed5848c791b86ae264ad8b454941fdc0e9d8e03)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "maxFeatures", value)

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesVar")
    def max_features_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "maxFeaturesVar"))

    @max_features_var.setter
    def max_features_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6932a54f0dbe01e7f4fcef5d9ea63fb90a5fcefdc08f3bd45a79b1c872491190)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "maxFeaturesVar", value)

    @builtins.property
    @jsii.member(jsii_name="minFeatureQuality")
    def min_feature_quality(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "minFeatureQuality"))

    @min_feature_quality.setter
    def min_feature_quality(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d22c5d5693046a3b3f6bc084f13e26c079ac70e56bb516e182f2c739b645a172)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "minFeatureQuality", value)

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityVar")
    def min_feature_quality_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "minFeatureQualityVar"))

    @min_feature_quality_var.setter
    def min_feature_quality_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__111bce30bb3e6cb6142f70f191e245c2e82a8bc1af9fd99e00d1b5348fb2bb3a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "minFeatureQualityVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab61b5cbe049c71afa1b9ca592f010ffa68d2a440819fe7cf8707adaf3c55220)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__408ef2c213b672e30a4d1d2dc3d1ff59ee5fc3e22486c22d55a888830b230a45)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d93045ba6a8d5925527545904c1100391205ea5483e8209e9b99ab05b4d48a55)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b7407b0b3aa8e8dcbca4f7c27fe09a65737bb9c6137837dc8bd11e226542968d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6c376444b02abd8b7568b763cd34c96255284539dd2c6aaf12c22cde74019b10)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6933f2eaee3177dd5a00164aff2155996852ccd70a750eda59fdac63bd5e4224)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanFeatureCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanFeatureCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanFeatureCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c9791c5fc0d3378b085259657ea4a4847a289e38429feb4dfbad1a4eda1cb0fa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanFitAndFill",
    jsii_struct_bases=[],
    name_mapping={
        "fill_transformation": "fillTransformation",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanFitAndFill:
    def __init__(
        self,
        *,
        fill_transformation: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanFitAndFillFillTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fill_transformation: fill_transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_transformation DataAkamaiImagingPolicyImage#fill_transformation}
        :param height: The height value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The width value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(fill_transformation, dict):
            fill_transformation = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanFitAndFillFillTransformation(**fill_transformation)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6da111157af06ab91c377a1810f7936606ac7f0fd0e54c5a9e9e41aa901a08bb)
            check_type(argname="argument fill_transformation", value=fill_transformation, expected_type=type_hints["fill_transformation"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fill_transformation is not None:
            self._values["fill_transformation"] = fill_transformation
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def fill_transformation(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanFitAndFillFillTransformation"]:
        '''fill_transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_transformation DataAkamaiImagingPolicyImage#fill_transformation}
        '''
        result = self._values.get("fill_transformation")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanFitAndFillFillTransformation"], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanFitAndFill(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanFitAndFillFillTransformation",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanFitAndFillFillTransformation:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanFitAndFillFillTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanFitAndFillFillTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanFitAndFillFillTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ca4b137431ac6a8a6eb6ac24c3bb5066b3ec89414dcc8e1928c8346201836a8e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanFitAndFillFillTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanFitAndFillFillTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanFitAndFillFillTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cac4f2515b563d48a86880768b282ae8c2af4a4d18f46be9be6ad96e178f2ae3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanFitAndFillList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanFitAndFillList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__54724af77812b7314619d319798d31bb7fcfdb957a413e91fead433f5a604adc)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanFitAndFillOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0481ece2052eb8e4caccc85f0e1d18b14c436a88a690013331fc45fd5d959e7b)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanFitAndFillOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__abc9a79f94aaa6698e0d1eb5d13e738f710a8f65475c475621eb3060379993f4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__83c44078e04b9317b77cd41e8404e2d1ecb3563316faf3d91165ff5b59d19a6e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__33656c750447429d3ecaced97b528fed1eba68caa2601d1b0b59b20fe743f83e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanFitAndFill]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanFitAndFill]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanFitAndFill]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9622021aaa942aeaa3a1ad57198afda9a207c42f0983ba12afa5eb9af3baf3b3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanFitAndFillOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanFitAndFillOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__018ae9a10c561d88a64c5ffa2c37923165072ea06fda862a121c66860121fc8a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putFillTransformation")
    def put_fill_transformation(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanFitAndFillFillTransformation()

        return typing.cast(None, jsii.invoke(self, "putFillTransformation", [value]))

    @jsii.member(jsii_name="resetFillTransformation")
    def reset_fill_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFillTransformation", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="fillTransformation")
    def fill_transformation(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanFitAndFillFillTransformationOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanFitAndFillFillTransformationOutputReference, jsii.get(self, "fillTransformation"))

    @builtins.property
    @jsii.member(jsii_name="fillTransformationInput")
    def fill_transformation_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanFitAndFillFillTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanFitAndFillFillTransformation], jsii.get(self, "fillTransformationInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0e081bf5b8291f28e8d49f4ac8f8bc8a6841f47ee353258e9a1ef80d82f319cb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6086edb80fdb1ebe4173ba594315c7c86541b0875d70f819a7929f845dda6dc9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5c8d3fd2de73261d3002b1cc4c90adbc8c4e387c0049aaf457a55cd16630d95a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__87afc16b9a734f7642e8cff682f11df74118eeb4085064c1557fd409131c6ac3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanFitAndFill]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanFitAndFill]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanFitAndFill]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__23ee8840e28d22160c501db35fb1e3d0d58944e3a83fd5006e07f9af586b2b16)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanGoop",
    jsii_struct_bases=[],
    name_mapping={
        "chaos": "chaos",
        "chaos_var": "chaosVar",
        "density": "density",
        "density_var": "densityVar",
        "power": "power",
        "power_var": "powerVar",
        "seed": "seed",
        "seed_var": "seedVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanGoop:
    def __init__(
        self,
        *,
        chaos: typing.Optional[builtins.str] = None,
        chaos_var: typing.Optional[builtins.str] = None,
        density: typing.Optional[builtins.str] = None,
        density_var: typing.Optional[builtins.str] = None,
        power: typing.Optional[builtins.str] = None,
        power_var: typing.Optional[builtins.str] = None,
        seed: typing.Optional[builtins.str] = None,
        seed_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param chaos: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        :param chaos_var: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        :param density: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        :param density_var: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        :param power: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        :param power_var: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        :param seed: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        :param seed_var: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aa2e6e30d59da953eceef2814b2b6c2c4812d9abdd387ea9953e5eb288cdc208)
            check_type(argname="argument chaos", value=chaos, expected_type=type_hints["chaos"])
            check_type(argname="argument chaos_var", value=chaos_var, expected_type=type_hints["chaos_var"])
            check_type(argname="argument density", value=density, expected_type=type_hints["density"])
            check_type(argname="argument density_var", value=density_var, expected_type=type_hints["density_var"])
            check_type(argname="argument power", value=power, expected_type=type_hints["power"])
            check_type(argname="argument power_var", value=power_var, expected_type=type_hints["power_var"])
            check_type(argname="argument seed", value=seed, expected_type=type_hints["seed"])
            check_type(argname="argument seed_var", value=seed_var, expected_type=type_hints["seed_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if chaos is not None:
            self._values["chaos"] = chaos
        if chaos_var is not None:
            self._values["chaos_var"] = chaos_var
        if density is not None:
            self._values["density"] = density
        if density_var is not None:
            self._values["density_var"] = density_var
        if power is not None:
            self._values["power"] = power
        if power_var is not None:
            self._values["power_var"] = power_var
        if seed is not None:
            self._values["seed"] = seed
        if seed_var is not None:
            self._values["seed_var"] = seed_var

    @builtins.property
    def chaos(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        '''
        result = self._values.get("chaos")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def chaos_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        '''
        result = self._values.get("chaos_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        '''
        result = self._values.get("density")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density_var(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        '''
        result = self._values.get("density_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        '''
        result = self._values.get("power")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power_var(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        '''
        result = self._values.get("power_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        '''
        result = self._values.get("seed")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed_var(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        result = self._values.get("seed_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanGoop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanGoopList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanGoopList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4149ef526c9c301ddfb1d8d4e61054cc997bc9987e075a69c34334a100e56f56)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanGoopOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a79a5ab653f7c0d11a663c61a67a58354c7021761834c38ab411db530e314bac)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanGoopOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e24ccac50ae5085cc33121499d10f4a626ba5b7acf084af52f8dc487d8d66185)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__75c1ac0ee7ea277618b6f77dff4f954a6640bd31da74708a6225da9f31c6ed00)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ca1d28cb4b882f76454354b9c78cd69c7daf7b4b34162b715331bbaa5647fb7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanGoop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanGoop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5a271018f5bad74c443fa3c8c00608f9581b63fe9e67ef507007c8764aa1b1cc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanGoopOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanGoopOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e36a68b18726de19cc3fbeeb9af97dcf415af6b3d5e9d4a66305fc0b23a0d246)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetChaos")
    def reset_chaos(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaos", []))

    @jsii.member(jsii_name="resetChaosVar")
    def reset_chaos_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaosVar", []))

    @jsii.member(jsii_name="resetDensity")
    def reset_density(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensity", []))

    @jsii.member(jsii_name="resetDensityVar")
    def reset_density_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensityVar", []))

    @jsii.member(jsii_name="resetPower")
    def reset_power(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPower", []))

    @jsii.member(jsii_name="resetPowerVar")
    def reset_power_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPowerVar", []))

    @jsii.member(jsii_name="resetSeed")
    def reset_seed(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeed", []))

    @jsii.member(jsii_name="resetSeedVar")
    def reset_seed_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeedVar", []))

    @builtins.property
    @jsii.member(jsii_name="chaosInput")
    def chaos_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosInput"))

    @builtins.property
    @jsii.member(jsii_name="chaosVarInput")
    def chaos_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosVarInput"))

    @builtins.property
    @jsii.member(jsii_name="densityInput")
    def density_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityInput"))

    @builtins.property
    @jsii.member(jsii_name="densityVarInput")
    def density_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="powerInput")
    def power_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerInput"))

    @builtins.property
    @jsii.member(jsii_name="powerVarInput")
    def power_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerVarInput"))

    @builtins.property
    @jsii.member(jsii_name="seedInput")
    def seed_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedInput"))

    @builtins.property
    @jsii.member(jsii_name="seedVarInput")
    def seed_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedVarInput"))

    @builtins.property
    @jsii.member(jsii_name="chaos")
    def chaos(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaos"))

    @chaos.setter
    def chaos(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__538247d40f9fbd35940df742eb8aeb317c1b215352c8ddeb1098fd729425f54b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaos", value)

    @builtins.property
    @jsii.member(jsii_name="chaosVar")
    def chaos_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaosVar"))

    @chaos_var.setter
    def chaos_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__abb345d95e1a4b32d5c7369b2a266a600642c62adad8366bdf61a5648c40cd42)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaosVar", value)

    @builtins.property
    @jsii.member(jsii_name="density")
    def density(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "density"))

    @density.setter
    def density(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__59c99acb3b0a20910b196ea300f3bc40061fac56863df759c61c599c363bcc17)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "density", value)

    @builtins.property
    @jsii.member(jsii_name="densityVar")
    def density_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "densityVar"))

    @density_var.setter
    def density_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__83da3c4adaf0e4de94f3d8ce282147d214c91ea242a77585448919098ea39982)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "densityVar", value)

    @builtins.property
    @jsii.member(jsii_name="power")
    def power(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "power"))

    @power.setter
    def power(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__93db98d73e51ef5fa8ef76a1a432c75882fd5d57e4e0e6c3d88022c7d0b0da9b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "power", value)

    @builtins.property
    @jsii.member(jsii_name="powerVar")
    def power_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "powerVar"))

    @power_var.setter
    def power_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__75110daa58ec01538c0f4e86534255ceb7f8c7bad39edcacb79485acba11953a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "powerVar", value)

    @builtins.property
    @jsii.member(jsii_name="seed")
    def seed(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seed"))

    @seed.setter
    def seed(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__94d5275119217c0cfc7d48c8f469ed201881e3a6aa9f951d8496b75307ef2775)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seed", value)

    @builtins.property
    @jsii.member(jsii_name="seedVar")
    def seed_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seedVar"))

    @seed_var.setter
    def seed_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__289b417ba7843c197603d0d5febbbc37a25c398558905df4be61f4d1321192bd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seedVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanGoop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanGoop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanGoop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9b9f6f78f0fda1c68a3ab85e1a0b447b3950208826a0bff84598cb0bf1cc7d12)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanGrayscale",
    jsii_struct_bases=[],
    name_mapping={"type": "type", "type_var": "typeVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanGrayscale:
    def __init__(
        self,
        *,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param type: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__859e005a2e4f276a099c0fef237a57f9184343e10e411ee9aff6264dbe9172cb)
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanGrayscale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanGrayscaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanGrayscaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__493da320f403e6f2625ac81ad3a0fbefdb144e6d35c78ca858c9b51580d624af)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanGrayscaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b9d2743ad178c6cd64abf302a8e1611fc6e0a41a204a8768f8f495dd5339365c)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanGrayscaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__37b5c40182eda2b9e810265bc6b5a0b6579e7d7f7f979ba3c6856f5a689d7956)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__40ac1da4483b40f8922701836dadef35816463ceadf8d57d88c1f572fe3d47c3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5bd389bb49abfc6507259ba09b28b2ab80c58c2920722a5e369c605ca39f8833)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanGrayscale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanGrayscale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c2ce5cb86b989316348c5d04456aeaffb15b771cc1d741073fb278c984d6a47b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanGrayscaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanGrayscaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__863b776fd9e0448259bd20ac3140a761e456b61a6075b177928b10b710633e8c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3457146cb5ad0c2de87ad29441e11461e297a190c3af200dd2c5975d332d1768)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea89b30ac158cb10dd977bc5a68722edec623de8cf59fafc8adc47387c4703e1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanGrayscale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanGrayscale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanGrayscale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__525ef5f9a29f1d944918cc3f5fa389191806a9ee1a837ab349caaa98ae6aba71)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanHsl",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "lightness": "lightness",
        "lightness_var": "lightnessVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanHsl:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness: typing.Optional[builtins.str] = None,
        lightness_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        :param lightness_var: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e1dc175b9a55aecfb27aeecf31f05fc1955901619192a8fdca73609e1d385785)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness", value=lightness, expected_type=type_hints["lightness"])
            check_type(argname="argument lightness_var", value=lightness_var, expected_type=type_hints["lightness_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness is not None:
            self._values["lightness"] = lightness
        if lightness_var is not None:
            self._values["lightness_var"] = lightness_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        '''
        result = self._values.get("lightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        '''
        result = self._values.get("lightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanHsl(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanHslList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanHslList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a6af9188bbcee899fd1b6bb12417feda057c2038412aabe5dadf7f3abc571a8e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanHslOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__99d21684a54f43348ea7a228255651d35923d1f9c6b86f0460b1776aadb1d5b0)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanHslOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3514ec49141980f499fa7fe2b887213b3f4f88341d6584339f70aab1e6f99aa9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__38929b92befba458371fe44c8f1d88062b022f4b86284ab2ad439358d98f5b62)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5b20405263c4a107478289e78f599784343cab56848a828044592b6ce5039b14)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanHsl]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanHsl]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7fe9c331945ad958d9f0800b32efd7f5b25762747817513d524206cce0b3722a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanHslOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanHslOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d6b41871c31a406f7e287f1e0a668e0931a26afdd71488760471949ca8b0cbca)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightness")
    def reset_lightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightness", []))

    @jsii.member(jsii_name="resetLightnessVar")
    def reset_lightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessInput")
    def lightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessVarInput")
    def lightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fd8e650e1d3299aa709221d4c31104c9400ec14c404e03255fb524d4dc2cd088)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3c1458828e0465b9e7232232cf3fd377f2d94e85df9de618ea0f079e042d7877)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightness")
    def lightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightness"))

    @lightness.setter
    def lightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a0304c90cc68a86a566226497eb019985ba0e7b136210d3ad275008202d0fd39)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightness", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessVar")
    def lightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessVar"))

    @lightness_var.setter
    def lightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa18998a79026f1c273b6621be0e7fed8d106ff7c4a654fe18a29022d5755863)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f6d83af28627d656c40748ffb6eb959a80de9e9c28e3f7120c6964c1344228ba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8929db8cc6ec2bd1587ab441972e300010cc94a179deb7af342a6a1b12a12b6c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanHsl]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanHsl]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanHsl]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8e169d9419809897cdd5cf8157212310000972118e95c564d020181c1d200fe3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanHsv",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanHsv:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        :param value: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1cd9f94ba7f61215e83f13e5873a1126f2213705a2b97b860fb42c41100e2355)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanHsv(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanHsvList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanHsvList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2c414eaf8d81a4160d3021adc9980288e1b420fb8068c6389ab90e736d2f15cb)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanHsvOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__37e2e49d80be6a4bbebbc9ee33a229053730ab79fe088d2c52151d07a6f3e5d1)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanHsvOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f8a231644e5b1bd328608c77416639ed6a24fc0ecf79aeb48d7bc0d2d28469ce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__acdf6584ef227b654af86adaf21b2b4e89c6c135b8f5631b215472599b8de791)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__da599f31417e19fc7190fadfbef94523cd6eda523c12d6fbbbc5c1747ffcc156)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanHsv]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanHsv]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ae94d5cd948805cd54bb3013bf418b6bc5e2b552b512697d0c8d8420c7961888)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanHsvOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanHsvOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f8d62b296f2eb1b276f435f4675e2f8b53e30f6b11836af83f08e1d7d040a511)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__746b15522cdbb2cffa7063f2f47f2b5b2588b26199c2d732416cbde14edcacdb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__398db44e9eb4d3deb23e8d25a9fd4df2906f0ae53677a974259c33195c92c7ca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d8eec055c75297652f7e8fc1c1189fbc6ee8d1e30ca76a10f218de0090a4fc4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a572ffb2a039015872f668e59848e4144d952812716130ef9f59a74e03cb4e8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__50f108d37c551c15511d818a2ef07ebb6da5f053e19a2b1367f66c8fab64b7eb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0b6f7eb20147634eb5f3e83d2a1a0efcd7dca3add9915729bc11ad927f17a0d0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanHsv]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanHsv]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanHsv]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6db127f50891b8aaf11deb89a1762367891fda79a3891c5dae947a7f6e58e4cd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimension",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "dimension": "dimension",
        "dimension_var": "dimensionVar",
        "equal": "equal",
        "greater_than": "greaterThan",
        "less_than": "lessThan",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimension:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        dimension: typing.Optional[builtins.str] = None,
        dimension_var: typing.Optional[builtins.str] = None,
        equal: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionEqual", typing.Dict[builtins.str, typing.Any]]] = None,
        greater_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionGreaterThan", typing.Dict[builtins.str, typing.Any]]] = None,
        less_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionLessThan", typing.Dict[builtins.str, typing.Any]]] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param dimension: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        :param dimension_var: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        :param equal: equal block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        :param greater_than: greater_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        :param less_than: less_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        :param value: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionDefault(**default)
        if isinstance(equal, dict):
            equal = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionEqual(**equal)
        if isinstance(greater_than, dict):
            greater_than = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionGreaterThan(**greater_than)
        if isinstance(less_than, dict):
            less_than = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionLessThan(**less_than)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__59327faa965260e92a2a7d8f6f876aeb53c6aaaa171c053f770192c5bfc3ccc2)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument dimension", value=dimension, expected_type=type_hints["dimension"])
            check_type(argname="argument dimension_var", value=dimension_var, expected_type=type_hints["dimension_var"])
            check_type(argname="argument equal", value=equal, expected_type=type_hints["equal"])
            check_type(argname="argument greater_than", value=greater_than, expected_type=type_hints["greater_than"])
            check_type(argname="argument less_than", value=less_than, expected_type=type_hints["less_than"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if dimension is not None:
            self._values["dimension"] = dimension
        if dimension_var is not None:
            self._values["dimension_var"] = dimension_var
        if equal is not None:
            self._values["equal"] = equal
        if greater_than is not None:
            self._values["greater_than"] = greater_than
        if less_than is not None:
            self._values["less_than"] = less_than
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionDefault"], result)

    @builtins.property
    def dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        '''
        result = self._values.get("dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        '''
        result = self._values.get("dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def equal(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionEqual"]:
        '''equal block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        '''
        result = self._values.get("equal")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionEqual"], result)

    @builtins.property
    def greater_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionGreaterThan"]:
        '''greater_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        '''
        result = self._values.get("greater_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionGreaterThan"], result)

    @builtins.property
    def less_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionLessThan"]:
        '''less_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        '''
        result = self._values.get("less_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionLessThan"], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimension(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__89ae8e4899d03ebc17cbb2b9671270506d6dace8e7b271a377398e77e78cb367)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0600ea1aba19a2b9d05080fe04cc9ed79ba9d092837a88e46acc1d505e311646)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionEqual",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionEqual:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionEqual(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionEqualOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionEqualOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cf9627acdcb36c45810bdffa36e5b4a18b2d22dd7eee7c7630e153393a62118a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionEqual], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionEqual],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__74c49131d46de1bf2933c3804547403f0c20e54d3c098214a4ce8a51d628fe48)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionGreaterThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionGreaterThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionGreaterThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionGreaterThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionGreaterThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3f275e78e4e8dc8385ae715e44366ea9fddc6abccf267fd1629c825647451669)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionGreaterThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionGreaterThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f6d3af6442647aacfa6c806fe5c4f74aef86e2e2c70d9139bd0a225956eabd5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionLessThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionLessThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionLessThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionLessThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionLessThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f4f2d81039b31c7549c2ed62144d8b0a7b5bc0fd0535aa3f1fc4d6df8fc29459)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionLessThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionLessThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4c2423c83bd667886dd054fbc50070e37ce48297cd1f2aa6f01a26a03938b3d1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8c96643030f4cbacbb7ce926d800f0e6305df8bae5b4f3a3acabe8368fe9bd5c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__54aefc2d5a29503015fe52a121cbbe2143f6abe0d16f97afa0e1449dac2adf8e)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b7bdd3f3f3706dab17c7adecd224fef9d372c348b8415871fdc1967766265b68)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b51668cd9682c7d454ac5dab5654d4e1f1f167a81fe96d41a7bee2d8400788d6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f414118ad35263fc5ec98c3362fa9e32ee00602255dc66da8ccca45e4dcb4860)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimension]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimension]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a2ffcae3f47bcef27589744935a3cdc8e8d3e12abd4898220d6ac31022613070)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e53731ea76ca6109f7a05c51673f05f41c9a7e0d4a8b07448fd3504ad20ac7db)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putEqual")
    def put_equal(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionEqual()

        return typing.cast(None, jsii.invoke(self, "putEqual", [value]))

    @jsii.member(jsii_name="putGreaterThan")
    def put_greater_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionGreaterThan()

        return typing.cast(None, jsii.invoke(self, "putGreaterThan", [value]))

    @jsii.member(jsii_name="putLessThan")
    def put_less_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionLessThan()

        return typing.cast(None, jsii.invoke(self, "putLessThan", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetDimension")
    def reset_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimension", []))

    @jsii.member(jsii_name="resetDimensionVar")
    def reset_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimensionVar", []))

    @jsii.member(jsii_name="resetEqual")
    def reset_equal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEqual", []))

    @jsii.member(jsii_name="resetGreaterThan")
    def reset_greater_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGreaterThan", []))

    @jsii.member(jsii_name="resetLessThan")
    def reset_less_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLessThan", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="equal")
    def equal(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionEqualOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionEqualOutputReference, jsii.get(self, "equal"))

    @builtins.property
    @jsii.member(jsii_name="greaterThan")
    def greater_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionGreaterThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionGreaterThanOutputReference, jsii.get(self, "greaterThan"))

    @builtins.property
    @jsii.member(jsii_name="lessThan")
    def less_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionLessThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionLessThanOutputReference, jsii.get(self, "lessThan"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionInput")
    def dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionVarInput")
    def dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="equalInput")
    def equal_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionEqual], jsii.get(self, "equalInput"))

    @builtins.property
    @jsii.member(jsii_name="greaterThanInput")
    def greater_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionGreaterThan], jsii.get(self, "greaterThanInput"))

    @builtins.property
    @jsii.member(jsii_name="lessThanInput")
    def less_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionLessThan], jsii.get(self, "lessThanInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="dimension")
    def dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimension"))

    @dimension.setter
    def dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5beccdcbe550e4350c6789fcd117cbcc473ff792b1682919247c1cef27061835)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimension", value)

    @builtins.property
    @jsii.member(jsii_name="dimensionVar")
    def dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimensionVar"))

    @dimension_var.setter
    def dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eb5890e16e868fd8be3d44e2e7613b10b3644063ecc2be9ce5d756d8ef5aa0e9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9b635c78cd17c2a90ff62798ec816e1539c28983fa1d69310ad448147626a650)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f521b0a8bebdf96346501dde4feb134c23ed24015b9391c8551f8227c687f928)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimension]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimension]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimension]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f5b0597e3181ac99c240433ee1f9e4693a02c03aea4c382b73af178898ea01bd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientation",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "landscape": "landscape",
        "portrait": "portrait",
        "square": "square",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientation:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        landscape: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationLandscape", typing.Dict[builtins.str, typing.Any]]] = None,
        portrait: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationPortrait", typing.Dict[builtins.str, typing.Any]]] = None,
        square: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationSquare", typing.Dict[builtins.str, typing.Any]]] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param landscape: landscape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        :param portrait: portrait block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        :param square: square block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationDefault(**default)
        if isinstance(landscape, dict):
            landscape = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationLandscape(**landscape)
        if isinstance(portrait, dict):
            portrait = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationPortrait(**portrait)
        if isinstance(square, dict):
            square = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationSquare(**square)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8eed34490df5540b9b59a2b101cb7ee61395c0c1da6aee75273b2f61fa94d4e0)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument landscape", value=landscape, expected_type=type_hints["landscape"])
            check_type(argname="argument portrait", value=portrait, expected_type=type_hints["portrait"])
            check_type(argname="argument square", value=square, expected_type=type_hints["square"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if landscape is not None:
            self._values["landscape"] = landscape
        if portrait is not None:
            self._values["portrait"] = portrait
        if square is not None:
            self._values["square"] = square

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationDefault"], result)

    @builtins.property
    def landscape(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationLandscape"]:
        '''landscape block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        '''
        result = self._values.get("landscape")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationLandscape"], result)

    @builtins.property
    def portrait(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationPortrait"]:
        '''portrait block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        '''
        result = self._values.get("portrait")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationPortrait"], result)

    @builtins.property
    def square(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationSquare"]:
        '''square block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        result = self._values.get("square")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationSquare"], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__47a7765867d5261e19280acca74e91b2190e8d3cab9fa45ce7d3991f2cde00df)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__05da4c6706542a6405d40f617ef085c07039c62392b3f23813ae5ebcf5207879)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationLandscape",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationLandscape:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationLandscape(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationLandscapeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationLandscapeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__252c90fa566b139e4241879b15f0d76ee282c1071e63a1a66f4e64cb6fb0d8cd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationLandscape], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationLandscape],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__18a30bb99052f0300ad2cf7f06cfce672a63d27564a88843411c5d211f4e7442)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__888c68dff814756fca19c0d4bdf79308f0b6044cd9d3e2fc8565308f3c8d3b2f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7895da964a694f478093076fdecb9d39d2e380923f3370bd35cbac15371c5185)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__69c2084a43243c125e52036f2f2323b3a895d955071479ed6f34a72487e0aa76)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__232af27652698e320107fc9f0070e9addf1bc177692046f706d7299d4adaf112)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7156d8d865cc64bb1afb159228cb91f43d8df10d5a5b4f77ba94128a30d6f26f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientation]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientation]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__06c8762124e3a97130df4b787c86ca70b5ab6c9ae8d915d9e9b2d48eb02eef5d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e8a51405c62dbd7a4d8e996e2c9f88d86d742845e0d811b850b374ca998daa8f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putLandscape")
    def put_landscape(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationLandscape()

        return typing.cast(None, jsii.invoke(self, "putLandscape", [value]))

    @jsii.member(jsii_name="putPortrait")
    def put_portrait(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationPortrait()

        return typing.cast(None, jsii.invoke(self, "putPortrait", [value]))

    @jsii.member(jsii_name="putSquare")
    def put_square(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationSquare()

        return typing.cast(None, jsii.invoke(self, "putSquare", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetLandscape")
    def reset_landscape(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLandscape", []))

    @jsii.member(jsii_name="resetPortrait")
    def reset_portrait(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPortrait", []))

    @jsii.member(jsii_name="resetSquare")
    def reset_square(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSquare", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="landscape")
    def landscape(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationLandscapeOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationLandscapeOutputReference, jsii.get(self, "landscape"))

    @builtins.property
    @jsii.member(jsii_name="portrait")
    def portrait(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationPortraitOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationPortraitOutputReference", jsii.get(self, "portrait"))

    @builtins.property
    @jsii.member(jsii_name="square")
    def square(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationSquareOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationSquareOutputReference", jsii.get(self, "square"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="landscapeInput")
    def landscape_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationLandscape], jsii.get(self, "landscapeInput"))

    @builtins.property
    @jsii.member(jsii_name="portraitInput")
    def portrait_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationPortrait"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationPortrait"], jsii.get(self, "portraitInput"))

    @builtins.property
    @jsii.member(jsii_name="squareInput")
    def square_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationSquare"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationSquare"], jsii.get(self, "squareInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientation]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientation]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientation]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f4c0f35e59c357951472e4b36ea1cdd5440ccddd6d7951f0b5b3ec3dcf8af329)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationPortrait",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationPortrait:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationPortrait(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationPortraitOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationPortraitOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a427a580d836b7f19721ea1cbdd790193ffa22c8153502e3d5e1a537f4e7b94a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationPortrait]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationPortrait], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationPortrait],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__02e03fd7d7bb891507b168d615be2a7e4c6dae63d38db1cbff239a390332371e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationSquare",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationSquare:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationSquare(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationSquareOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationSquareOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e294049ddbdc9ca0bf3ab7677b13637d476b5712aaf2fc3feb0a883c910de6fa)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationSquare]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationSquare], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationSquare],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__565fc56fc655c8e40c8e376a163af78888101c434e01e4f1cdfd0da1f9309cc1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanImQuery",
    jsii_struct_bases=[],
    name_mapping={
        "allowed_transformations": "allowedTransformations",
        "query_var": "queryVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanImQuery:
    def __init__(
        self,
        *,
        allowed_transformations: typing.Sequence[builtins.str],
        query_var: builtins.str,
    ) -> None:
        '''
        :param allowed_transformations: Specifies the transformations that can be applied using the query string parameter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allowed_transformations DataAkamaiImagingPolicyImage#allowed_transformations}
        :param query_var: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#query_var DataAkamaiImagingPolicyImage#query_var}.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6af1e31441f0665baf614e6cb26a548b785c43f9b30c16da7744cffb1d464e20)
            check_type(argname="argument allowed_transformations", value=allowed_transformations, expected_type=type_hints["allowed_transformations"])
            check_type(argname="argument query_var", value=query_var, expected_type=type_hints["query_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "allowed_transformations": allowed_transformations,
            "query_var": query_var,
        }

    @builtins.property
    def allowed_transformations(self) -> typing.List[builtins.str]:
        '''Specifies the transformations that can be applied using the query string parameter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allowed_transformations DataAkamaiImagingPolicyImage#allowed_transformations}
        '''
        result = self._values.get("allowed_transformations")
        assert result is not None, "Required property 'allowed_transformations' is missing"
        return typing.cast(typing.List[builtins.str], result)

    @builtins.property
    def query_var(self) -> builtins.str:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#query_var DataAkamaiImagingPolicyImage#query_var}.'''
        result = self._values.get("query_var")
        assert result is not None, "Required property 'query_var' is missing"
        return typing.cast(builtins.str, result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanImQuery(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanImQueryList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanImQueryList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__841cd3bbfe59d7686d390feb353d01c40534f5c4fa635db051cd2147d13b4ae3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanImQueryOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3821b5cab55cd171afacde65205e1dc77d231b62eb34362f16bc52af731988e7)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanImQueryOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5438f7c602e2e0f7401e3408eea921785188d67f5cbfb7df037b0da120920852)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8fc4e7184c6b896ed43eec882e81485705eb003cd86e96a0830838aebe586f92)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dfe8a0456296cb530a545c6f832204fd2545e845ab319a06677db27158a6d90e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanImQuery]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanImQuery]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanImQuery]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__65557a7c83ba26e6b334a2989823e488d6f38bfaa7a2057ee6cb719f9f51bf8a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanImQueryOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanImQueryOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bf356a9df19d75ee67535339155cea5577cedca56c2b3b81265951ee3180f39c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @builtins.property
    @jsii.member(jsii_name="allowedTransformationsInput")
    def allowed_transformations_input(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "allowedTransformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="queryVarInput")
    def query_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "queryVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowedTransformations")
    def allowed_transformations(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "allowedTransformations"))

    @allowed_transformations.setter
    def allowed_transformations(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1142a4487b085970cac4446e2ca76e97b6f7096ccb67a7d79984146bb2738abf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowedTransformations", value)

    @builtins.property
    @jsii.member(jsii_name="queryVar")
    def query_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "queryVar"))

    @query_var.setter
    def query_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ef4c5d98806d63efcb8b0ecb13d7b880613783f70e184f308a6ab9ef4ad853a0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "queryVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanImQuery]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanImQuery]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanImQuery]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__487103b59902f8cff5fee50437b791cceb0d8c2df5632d9879ce1ae743ac64ae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanMaxColors",
    jsii_struct_bases=[],
    name_mapping={"colors": "colors", "colors_var": "colorsVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanMaxColors:
    def __init__(
        self,
        *,
        colors: typing.Optional[builtins.str] = None,
        colors_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param colors: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        :param colors_var: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d4d36aae16eb076631f13ff4da2cf109e455e4247a00b95b3d0efa50141ae596)
            check_type(argname="argument colors", value=colors, expected_type=type_hints["colors"])
            check_type(argname="argument colors_var", value=colors_var, expected_type=type_hints["colors_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if colors is not None:
            self._values["colors"] = colors
        if colors_var is not None:
            self._values["colors_var"] = colors_var

    @builtins.property
    def colors(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        '''
        result = self._values.get("colors")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def colors_var(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        result = self._values.get("colors_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanMaxColors(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanMaxColorsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanMaxColorsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fd937f520fc46478e676d7cb3c5dc294c231e45bc1c7374a2d0b5f5091f2ceb8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanMaxColorsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ef1db9e9449b1f232f64fed7a1891d0d4606f6fd8bcb50411a30a8b5f689b89)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanMaxColorsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c090d8c01c368e2d6c6c3cb5e07ee20971fcca046084fb7e8805b887b1d75706)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8e84ebb272429fa8d01c3c6977854e14eaf3885f4246fc915320426f306130ae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__366ad2b90443df8cb3b8e646320cba8c7b875154cee8a8f60b2f15be46addb54)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanMaxColors]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanMaxColors]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__537742178a64a0c54d9445ffeaaf196ce7c3bd788a57f032a4aa2126dd82b7c5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanMaxColorsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanMaxColorsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__efbca6ab83f34219d19b56177b1b0db20efea9ebe8a140fe7f52c92a761c8af4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColors")
    def reset_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColors", []))

    @jsii.member(jsii_name="resetColorsVar")
    def reset_colors_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorsVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorsInput")
    def colors_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsInput"))

    @builtins.property
    @jsii.member(jsii_name="colorsVarInput")
    def colors_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsVarInput"))

    @builtins.property
    @jsii.member(jsii_name="colors")
    def colors(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colors"))

    @colors.setter
    def colors(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__39f26dcdcc3141e19a56bf8a0fbd88083e64adc6de2f684e16aa523b94c58cfc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colors", value)

    @builtins.property
    @jsii.member(jsii_name="colorsVar")
    def colors_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorsVar"))

    @colors_var.setter
    def colors_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__10fafab6891f574eb35ad70e65ee74e582a54725efcfaec896c1d18118e102b2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorsVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanMaxColors]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanMaxColors]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanMaxColors]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2093fb2331bdc48c4bce1afad00d78a04461fcac3f3f8e5b82c24056447386ef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanMirror",
    jsii_struct_bases=[],
    name_mapping={
        "horizontal": "horizontal",
        "horizontal_var": "horizontalVar",
        "vertical": "vertical",
        "vertical_var": "verticalVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanMirror:
    def __init__(
        self,
        *,
        horizontal: typing.Optional[builtins.str] = None,
        horizontal_var: typing.Optional[builtins.str] = None,
        vertical: typing.Optional[builtins.str] = None,
        vertical_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param horizontal: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        :param horizontal_var: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        :param vertical: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        :param vertical_var: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ed371a787ccaf2561574752570a1ccec74ae78be33dd986a3be41dc495336041)
            check_type(argname="argument horizontal", value=horizontal, expected_type=type_hints["horizontal"])
            check_type(argname="argument horizontal_var", value=horizontal_var, expected_type=type_hints["horizontal_var"])
            check_type(argname="argument vertical", value=vertical, expected_type=type_hints["vertical"])
            check_type(argname="argument vertical_var", value=vertical_var, expected_type=type_hints["vertical_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if horizontal is not None:
            self._values["horizontal"] = horizontal
        if horizontal_var is not None:
            self._values["horizontal_var"] = horizontal_var
        if vertical is not None:
            self._values["vertical"] = vertical
        if vertical_var is not None:
            self._values["vertical_var"] = vertical_var

    @builtins.property
    def horizontal(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        '''
        result = self._values.get("horizontal")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def horizontal_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        '''
        result = self._values.get("horizontal_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        '''
        result = self._values.get("vertical")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        result = self._values.get("vertical_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanMirror(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanMirrorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanMirrorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__58f833abb6b5aa28917e44bbf73ee0c175e37da0ac89b077a4b39e8f300dd748)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanMirrorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1a0bd2261aa781dbea31c041f8dfa2fce49f62f49f10fc4f447967d7529e278f)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanMirrorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e0cf4e377573474c44dbc8b1a3c5e4342b5f2598dd12f7f20967048ea07c218d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7427ea8e308b34f9b03265ceee7944a5c7af4e127a149614f9e495b2167ca144)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__02d86c6ce2ce7427516af7c9bacf09a4992131c42eeb7723197a8b304e95b7ce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanMirror]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanMirror]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a3fcd3291aac42c57f68b6de9eddd88ca66eaeef796d6a6c7303f094055e1749)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanMirrorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanMirrorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__52693129cd0142800dbba56db4508dd99a6df547a9159b145928dac0fe8c97c2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHorizontal")
    def reset_horizontal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontal", []))

    @jsii.member(jsii_name="resetHorizontalVar")
    def reset_horizontal_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontalVar", []))

    @jsii.member(jsii_name="resetVertical")
    def reset_vertical(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVertical", []))

    @jsii.member(jsii_name="resetVerticalVar")
    def reset_vertical_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVerticalVar", []))

    @builtins.property
    @jsii.member(jsii_name="horizontalInput")
    def horizontal_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontalVarInput")
    def horizontal_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalInput")
    def vertical_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalVarInput")
    def vertical_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontal")
    def horizontal(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontal"))

    @horizontal.setter
    def horizontal(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9527267b4e5a38e64ab466d3344a6582615865b290a5cd2b72e168d95e11225f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontal", value)

    @builtins.property
    @jsii.member(jsii_name="horizontalVar")
    def horizontal_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontalVar"))

    @horizontal_var.setter
    def horizontal_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8e5f8f92d4e62ea8c58456c406699467369235b05d2a3a3f433b1abc1d265757)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontalVar", value)

    @builtins.property
    @jsii.member(jsii_name="vertical")
    def vertical(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "vertical"))

    @vertical.setter
    def vertical(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__71ee61740f7798e01fcd51b5c620159ef9bf972f9a568b762df95728ad8cb2d5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "vertical", value)

    @builtins.property
    @jsii.member(jsii_name="verticalVar")
    def vertical_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "verticalVar"))

    @vertical_var.setter
    def vertical_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__11d2cceb1729c0121a81d58721b86efe26a9e12a92cfbc6f8d273c6737ba81fd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "verticalVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanMirror]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanMirror]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanMirror]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9508839e3d51f531a83e5705217df6a64c6e06f2c8c08ee6393f8e784c4ced94)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanMonoHue",
    jsii_struct_bases=[],
    name_mapping={"hue": "hue", "hue_var": "hueVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanMonoHue:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3919499dd51e042aed161baaffff32ab38120ead252d0dd827381dd34a27b246)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanMonoHue(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanMonoHueList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanMonoHueList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__51bf78a81de319974a734b21a5f3187b6f64addc39ff8c91d7262b8de2ec1ca6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanMonoHueOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0f89ad867eeaa74c22a481bb1bae85dbf92332f808a9a21c0c6abff444252dbe)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanMonoHueOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__019848b27b32df3e0836b9a07e97dcff7e9356ff88b326b22b7b9a8a1f5ed964)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4e88b0fc3b7f3548382bb064f18dfcdb4be499a044ce2ef2f1509592a00c682a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f01f55c6102b3de3679551e7a414a566aa0e91f4cf77bfc888790dedc4a66658)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanMonoHue]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanMonoHue]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__81f12a0913648bdc202e01ed35ca0a39610abf31f61fc16d352090478010a917)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanMonoHueOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanMonoHueOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__25fa63922d884bec571c6acf1f6fdc52620584cfca8f043e3414ef6ddf026140)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cb293255feef649cde1b60ec1f2e530ae7043b44060f47328bf00e0fee7db6ec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3c385303a38bd59f83572500da45f54ea5725f325c9163361187b1f891fc1f2d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanMonoHue]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanMonoHue]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanMonoHue]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__856f46bb01f2c929e5da7ad442e749dfff85539f0fd383d644b629f3c75343d7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanOpacity",
    jsii_struct_bases=[],
    name_mapping={"opacity": "opacity", "opacity_var": "opacityVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanOpacity:
    def __init__(
        self,
        *,
        opacity: typing.Optional[builtins.str] = None,
        opacity_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param opacity: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param opacity_var: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a1bf1daeabb6a3fe01a751213512994fe36b51909af1b3257a2645b896a9bab)
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument opacity_var", value=opacity_var, expected_type=type_hints["opacity_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if opacity is not None:
            self._values["opacity"] = opacity
        if opacity_var is not None:
            self._values["opacity_var"] = opacity_var

    @builtins.property
    def opacity(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def opacity_var(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        result = self._values.get("opacity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanOpacity(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanOpacityList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanOpacityList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fbfca91ea1616584c6af7e54c791547fcf24974eb805f3f940a85937d138a353)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanOpacityOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2039c1892959eabe5d1e8170afd727381eb48c511d74e7a0db2cd8408aa6f257)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanOpacityOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ed908e7c2e35a6c7866053d41b90cdb98f923dea6fd237b771a58a4d3dad9cca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b2b6e13225c2a1d323f5a0c61de13e218b36c6e2b8ab54efff5c899c8c329640)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4b370d79b89edc778b97ac9ac35f9093a57a6946f62f4643f73659cb99deec80)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanOpacity]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanOpacity]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9119c69b7ba59b4204d33e403fcf76f0cd51e8fdc42bc91b9665347318b94d21)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanOpacityOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanOpacityOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d99a7e7cfd0a0b6c89050343a6cc2771bbac87abb9ff7ee22c84ab141de3b4d5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetOpacityVar")
    def reset_opacity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacityVar", []))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityVarInput")
    def opacity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacity"))

    @opacity.setter
    def opacity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6191b4e43a3da42885d5ec457a1622508c57037a4feac442a899f3440f132233)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacity", value)

    @builtins.property
    @jsii.member(jsii_name="opacityVar")
    def opacity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacityVar"))

    @opacity_var.setter
    def opacity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2033f06478eac03f5bc35d7e7bdbd4d2b381ebdd5a1f7823a678eeaee7c820bb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacityVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanOpacity]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanOpacity]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanOpacity]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c4bd2e6b2703578c878cfb28daff5fa0b8c10ffe978670625350d0032c4345e0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__caafbd89e69ffaa3b5d5d23aea8a0173c70947aa9fea3a7025a20ad870072f46)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putAppend")
    def put_append(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanAppend, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8ffce10a7f807e5717d8b57821a5cb35e9df50b254d35dd0c7932f2ed4d44eca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putAppend", [value]))

    @jsii.member(jsii_name="putAspectCrop")
    def put_aspect_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanAspectCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1eacee1c33b9858c9cfa1c4134fa8100350ff4dd397dfc19b3797fe6cb796f07)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putAspectCrop", [value]))

    @jsii.member(jsii_name="putBackgroundColor")
    def put_background_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0e3ac4f981087c839eb1eeb15df6487000b6cf820274bb87d4ac2df8fbb96ebd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBackgroundColor", [value]))

    @jsii.member(jsii_name="putBlur")
    def put_blur(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanBlur, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__653fae656f1ab019d4ad2885ddb80d736d4ffebab8baac89e8cba2fc15cf6908)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBlur", [value]))

    @jsii.member(jsii_name="putChromaKey")
    def put_chroma_key(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanChromaKey, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0864b1e20680723ee80fade0421afa86d95b91ec51f151f42496af6a15f63afd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putChromaKey", [value]))

    @jsii.member(jsii_name="putComposite")
    def put_composite(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanComposite, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d88498c351d5d86782b051d38aad8b88f334eb8e8f6cc12ddcdd041e5b5772fd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putComposite", [value]))

    @jsii.member(jsii_name="putCompound")
    def put_compound(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompound, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__58eb11a6b946148a692a1dbb3a84814ae9f92e7f9adf32b6c6a35b9b7c0bb14f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCompound", [value]))

    @jsii.member(jsii_name="putContrast")
    def put_contrast(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanContrast, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fffb06ab37bc57a2f3086820327d445d43b8a40bd1144f2f1ce6026591936b31)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putContrast", [value]))

    @jsii.member(jsii_name="putCrop")
    def put_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8f306c0234c8bf22e3e6d1f8e9573455f8b28c8e847ece127a0234cdd9bbe3cb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCrop", [value]))

    @jsii.member(jsii_name="putFaceCrop")
    def put_face_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanFaceCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6d681981636f4a037239db52c6cdfa20f3d8b3eaa186ac921a6863ccc74a93cb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFaceCrop", [value]))

    @jsii.member(jsii_name="putFeatureCrop")
    def put_feature_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanFeatureCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bcf3f9177aa2936586f48d938d30bcf562bb2911572a13b7696d136b149f3e71)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFeatureCrop", [value]))

    @jsii.member(jsii_name="putFitAndFill")
    def put_fit_and_fill(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanFitAndFill, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0cfe3ee5a0b37b2eafef728118935119cb0dcb064bee20806bc3039911115767)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFitAndFill", [value]))

    @jsii.member(jsii_name="putGoop")
    def put_goop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanGoop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cfc02049aa6209082f8adf5a1512c0865f4b63483142caaa9fc499d42d767de1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGoop", [value]))

    @jsii.member(jsii_name="putGrayscale")
    def put_grayscale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanGrayscale, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9beb3412604a281f554968606334b5b18e5be1b1b1a090fd9d645e182d0a8fee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGrayscale", [value]))

    @jsii.member(jsii_name="putHsl")
    def put_hsl(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanHsl, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__75186ec970d40d0f489376e420a52e7d8f2edb10bb97036a2efceb3f51d83e30)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsl", [value]))

    @jsii.member(jsii_name="putHsv")
    def put_hsv(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanHsv, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c144bd9a4c532e9623422280d11bef77741e5ca0e9cf2d6208bb5d3fc722daa2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsv", [value]))

    @jsii.member(jsii_name="putIfDimension")
    def put_if_dimension(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimension, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ebf78d301bfd46959d9efca2938ea0533a72b5dea17c4fd69645d3e26c8b6f5f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfDimension", [value]))

    @jsii.member(jsii_name="putIfOrientation")
    def put_if_orientation(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a71a971c698eefa6e460e0c5a8a849b96787ca620cb59945cc7026d56138f6d5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfOrientation", [value]))

    @jsii.member(jsii_name="putImQuery")
    def put_im_query(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanImQuery, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dde13db3ba9c393b6e8e882212184e10cc6d00d82c421b27b67618ae86947038)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putImQuery", [value]))

    @jsii.member(jsii_name="putMaxColors")
    def put_max_colors(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanMaxColors, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2304a8f9aa256f20b9fce4f36d4761c9be95e98c56d032efb74d8d2abd0cd2b2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMaxColors", [value]))

    @jsii.member(jsii_name="putMirror")
    def put_mirror(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanMirror, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__09e2cfc1028f6766c394020b1d99a0383133d08729ac5fdfe67f5aa47f22f22a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMirror", [value]))

    @jsii.member(jsii_name="putMonoHue")
    def put_mono_hue(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanMonoHue, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c81cd669d7ca5a7b7cecaa5c7de57b3b4e328ec19c898c11b1e66b717358eaf7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMonoHue", [value]))

    @jsii.member(jsii_name="putOpacity")
    def put_opacity(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanOpacity, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__703e6cb32ce51b2584d2ab8066b0c52776e7d07943311b5e52af67a633223265)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putOpacity", [value]))

    @jsii.member(jsii_name="putRegionOfInterestCrop")
    def put_region_of_interest_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanRegionOfInterestCrop", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c9459eef80b9ca0d6e4be8610c08c468f008ffbd8af5c20daf5eb10937383fe0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRegionOfInterestCrop", [value]))

    @jsii.member(jsii_name="putRelativeCrop")
    def put_relative_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanRelativeCrop", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d93909a891faf3df70bda5ef1d84cb6efe2858df81f9e664e1fb69bce929d86e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRelativeCrop", [value]))

    @jsii.member(jsii_name="putRemoveColor")
    def put_remove_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanRemoveColor", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eb37ae8e377048e484b3b84102f0128e814d07364f58e5b964946791d7cdfbf2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRemoveColor", [value]))

    @jsii.member(jsii_name="putResize")
    def put_resize(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanResize", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c5a6b934f88483fab9dcbc46fc41820650409b9778836b7d311859177feadba6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putResize", [value]))

    @jsii.member(jsii_name="putRotate")
    def put_rotate(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanRotate", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__50a5f7a5d1882156f9b5a3c64cfac3cf47add89da6d2e77082de113d9d84a98a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRotate", [value]))

    @jsii.member(jsii_name="putScale")
    def put_scale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanScale", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0fa02d05f86d5515e5392e88a2b417c5d2c7e1126cb21e4cf80d1316e08c548e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putScale", [value]))

    @jsii.member(jsii_name="putShear")
    def put_shear(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanShear", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e779f5716a096dc22db6c4f24f4b7639c2e294de0942d57a4572d4bc42d56bcd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putShear", [value]))

    @jsii.member(jsii_name="putTrim")
    def put_trim(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanTrim", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f8cb8645c96bfad34f6e97e3a57b4109aecc23d6c8c9b23f100bdbc0084dc7a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTrim", [value]))

    @jsii.member(jsii_name="putUnsharpMask")
    def put_unsharp_mask(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanUnsharpMask", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bcc48f5e2f0a823411ad0e28fb08b63e486b0afd91fbbc0332b802e1a902fb22)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putUnsharpMask", [value]))

    @jsii.member(jsii_name="resetAppend")
    def reset_append(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAppend", []))

    @jsii.member(jsii_name="resetAspectCrop")
    def reset_aspect_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspectCrop", []))

    @jsii.member(jsii_name="resetBackgroundColor")
    def reset_background_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBackgroundColor", []))

    @jsii.member(jsii_name="resetBlur")
    def reset_blur(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBlur", []))

    @jsii.member(jsii_name="resetChromaKey")
    def reset_chroma_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChromaKey", []))

    @jsii.member(jsii_name="resetComposite")
    def reset_composite(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetComposite", []))

    @jsii.member(jsii_name="resetCompound")
    def reset_compound(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCompound", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetCrop")
    def reset_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCrop", []))

    @jsii.member(jsii_name="resetFaceCrop")
    def reset_face_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFaceCrop", []))

    @jsii.member(jsii_name="resetFeatureCrop")
    def reset_feature_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureCrop", []))

    @jsii.member(jsii_name="resetFitAndFill")
    def reset_fit_and_fill(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFitAndFill", []))

    @jsii.member(jsii_name="resetGoop")
    def reset_goop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGoop", []))

    @jsii.member(jsii_name="resetGrayscale")
    def reset_grayscale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGrayscale", []))

    @jsii.member(jsii_name="resetHsl")
    def reset_hsl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsl", []))

    @jsii.member(jsii_name="resetHsv")
    def reset_hsv(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsv", []))

    @jsii.member(jsii_name="resetIfDimension")
    def reset_if_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfDimension", []))

    @jsii.member(jsii_name="resetIfOrientation")
    def reset_if_orientation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfOrientation", []))

    @jsii.member(jsii_name="resetImQuery")
    def reset_im_query(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetImQuery", []))

    @jsii.member(jsii_name="resetMaxColors")
    def reset_max_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxColors", []))

    @jsii.member(jsii_name="resetMirror")
    def reset_mirror(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMirror", []))

    @jsii.member(jsii_name="resetMonoHue")
    def reset_mono_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonoHue", []))

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetRegionOfInterestCrop")
    def reset_region_of_interest_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRegionOfInterestCrop", []))

    @jsii.member(jsii_name="resetRelativeCrop")
    def reset_relative_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRelativeCrop", []))

    @jsii.member(jsii_name="resetRemoveColor")
    def reset_remove_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRemoveColor", []))

    @jsii.member(jsii_name="resetResize")
    def reset_resize(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetResize", []))

    @jsii.member(jsii_name="resetRotate")
    def reset_rotate(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRotate", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetShear")
    def reset_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetShear", []))

    @jsii.member(jsii_name="resetTrim")
    def reset_trim(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTrim", []))

    @jsii.member(jsii_name="resetUnsharpMask")
    def reset_unsharp_mask(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUnsharpMask", []))

    @builtins.property
    @jsii.member(jsii_name="append")
    def append(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanAppendList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanAppendList, jsii.get(self, "append"))

    @builtins.property
    @jsii.member(jsii_name="aspectCrop")
    def aspect_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanAspectCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanAspectCropList, jsii.get(self, "aspectCrop"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColor")
    def background_color(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanBackgroundColorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanBackgroundColorList, jsii.get(self, "backgroundColor"))

    @builtins.property
    @jsii.member(jsii_name="blur")
    def blur(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanBlurList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanBlurList, jsii.get(self, "blur"))

    @builtins.property
    @jsii.member(jsii_name="chromaKey")
    def chroma_key(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanChromaKeyList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanChromaKeyList, jsii.get(self, "chromaKey"))

    @builtins.property
    @jsii.member(jsii_name="composite")
    def composite(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompositeList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompositeList, jsii.get(self, "composite"))

    @builtins.property
    @jsii.member(jsii_name="compound")
    def compound(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompoundList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompoundList, jsii.get(self, "compound"))

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanContrastList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanContrastList, jsii.get(self, "contrast"))

    @builtins.property
    @jsii.member(jsii_name="crop")
    def crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanCropList, jsii.get(self, "crop"))

    @builtins.property
    @jsii.member(jsii_name="faceCrop")
    def face_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanFaceCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanFaceCropList, jsii.get(self, "faceCrop"))

    @builtins.property
    @jsii.member(jsii_name="featureCrop")
    def feature_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanFeatureCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanFeatureCropList, jsii.get(self, "featureCrop"))

    @builtins.property
    @jsii.member(jsii_name="fitAndFill")
    def fit_and_fill(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanFitAndFillList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanFitAndFillList, jsii.get(self, "fitAndFill"))

    @builtins.property
    @jsii.member(jsii_name="goop")
    def goop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanGoopList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanGoopList, jsii.get(self, "goop"))

    @builtins.property
    @jsii.member(jsii_name="grayscale")
    def grayscale(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanGrayscaleList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanGrayscaleList, jsii.get(self, "grayscale"))

    @builtins.property
    @jsii.member(jsii_name="hsl")
    def hsl(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanHslList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanHslList, jsii.get(self, "hsl"))

    @builtins.property
    @jsii.member(jsii_name="hsv")
    def hsv(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanHsvList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanHsvList, jsii.get(self, "hsv"))

    @builtins.property
    @jsii.member(jsii_name="ifDimension")
    def if_dimension(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionList, jsii.get(self, "ifDimension"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientation")
    def if_orientation(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationList, jsii.get(self, "ifOrientation"))

    @builtins.property
    @jsii.member(jsii_name="imQuery")
    def im_query(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanImQueryList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanImQueryList, jsii.get(self, "imQuery"))

    @builtins.property
    @jsii.member(jsii_name="maxColors")
    def max_colors(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanMaxColorsList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanMaxColorsList, jsii.get(self, "maxColors"))

    @builtins.property
    @jsii.member(jsii_name="mirror")
    def mirror(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanMirrorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanMirrorList, jsii.get(self, "mirror"))

    @builtins.property
    @jsii.member(jsii_name="monoHue")
    def mono_hue(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanMonoHueList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanMonoHueList, jsii.get(self, "monoHue"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanOpacityList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanOpacityList, jsii.get(self, "opacity"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestCrop")
    def region_of_interest_crop(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanRegionOfInterestCropList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanRegionOfInterestCropList", jsii.get(self, "regionOfInterestCrop"))

    @builtins.property
    @jsii.member(jsii_name="relativeCrop")
    def relative_crop(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanRelativeCropList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanRelativeCropList", jsii.get(self, "relativeCrop"))

    @builtins.property
    @jsii.member(jsii_name="removeColor")
    def remove_color(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanRemoveColorList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanRemoveColorList", jsii.get(self, "removeColor"))

    @builtins.property
    @jsii.member(jsii_name="resize")
    def resize(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanResizeList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanResizeList", jsii.get(self, "resize"))

    @builtins.property
    @jsii.member(jsii_name="rotate")
    def rotate(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanRotateList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanRotateList", jsii.get(self, "rotate"))

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanScaleList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanScaleList", jsii.get(self, "scale"))

    @builtins.property
    @jsii.member(jsii_name="shear")
    def shear(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanShearList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanShearList", jsii.get(self, "shear"))

    @builtins.property
    @jsii.member(jsii_name="trim")
    def trim(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanTrimList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanTrimList", jsii.get(self, "trim"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMask")
    def unsharp_mask(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanUnsharpMaskList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanUnsharpMaskList", jsii.get(self, "unsharpMask"))

    @builtins.property
    @jsii.member(jsii_name="appendInput")
    def append_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanAppend]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanAppend]]], jsii.get(self, "appendInput"))

    @builtins.property
    @jsii.member(jsii_name="aspectCropInput")
    def aspect_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanAspectCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanAspectCrop]]], jsii.get(self, "aspectCropInput"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColorInput")
    def background_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanBackgroundColor]]], jsii.get(self, "backgroundColorInput"))

    @builtins.property
    @jsii.member(jsii_name="blurInput")
    def blur_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanBlur]]], jsii.get(self, "blurInput"))

    @builtins.property
    @jsii.member(jsii_name="chromaKeyInput")
    def chroma_key_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanChromaKey]]], jsii.get(self, "chromaKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="compositeInput")
    def composite_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanComposite]]], jsii.get(self, "compositeInput"))

    @builtins.property
    @jsii.member(jsii_name="compoundInput")
    def compound_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompound]]], jsii.get(self, "compoundInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanContrast]]], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="cropInput")
    def crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanCrop]]], jsii.get(self, "cropInput"))

    @builtins.property
    @jsii.member(jsii_name="faceCropInput")
    def face_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanFaceCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanFaceCrop]]], jsii.get(self, "faceCropInput"))

    @builtins.property
    @jsii.member(jsii_name="featureCropInput")
    def feature_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanFeatureCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanFeatureCrop]]], jsii.get(self, "featureCropInput"))

    @builtins.property
    @jsii.member(jsii_name="fitAndFillInput")
    def fit_and_fill_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanFitAndFill]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanFitAndFill]]], jsii.get(self, "fitAndFillInput"))

    @builtins.property
    @jsii.member(jsii_name="goopInput")
    def goop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanGoop]]], jsii.get(self, "goopInput"))

    @builtins.property
    @jsii.member(jsii_name="grayscaleInput")
    def grayscale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanGrayscale]]], jsii.get(self, "grayscaleInput"))

    @builtins.property
    @jsii.member(jsii_name="hslInput")
    def hsl_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanHsl]]], jsii.get(self, "hslInput"))

    @builtins.property
    @jsii.member(jsii_name="hsvInput")
    def hsv_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanHsv]]], jsii.get(self, "hsvInput"))

    @builtins.property
    @jsii.member(jsii_name="ifDimensionInput")
    def if_dimension_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimension]]], jsii.get(self, "ifDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientationInput")
    def if_orientation_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientation]]], jsii.get(self, "ifOrientationInput"))

    @builtins.property
    @jsii.member(jsii_name="imQueryInput")
    def im_query_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanImQuery]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanImQuery]]], jsii.get(self, "imQueryInput"))

    @builtins.property
    @jsii.member(jsii_name="maxColorsInput")
    def max_colors_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanMaxColors]]], jsii.get(self, "maxColorsInput"))

    @builtins.property
    @jsii.member(jsii_name="mirrorInput")
    def mirror_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanMirror]]], jsii.get(self, "mirrorInput"))

    @builtins.property
    @jsii.member(jsii_name="monoHueInput")
    def mono_hue_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanMonoHue]]], jsii.get(self, "monoHueInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanOpacity]]], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestCropInput")
    def region_of_interest_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanRegionOfInterestCrop"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanRegionOfInterestCrop"]]], jsii.get(self, "regionOfInterestCropInput"))

    @builtins.property
    @jsii.member(jsii_name="relativeCropInput")
    def relative_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanRelativeCrop"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanRelativeCrop"]]], jsii.get(self, "relativeCropInput"))

    @builtins.property
    @jsii.member(jsii_name="removeColorInput")
    def remove_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanRemoveColor"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanRemoveColor"]]], jsii.get(self, "removeColorInput"))

    @builtins.property
    @jsii.member(jsii_name="resizeInput")
    def resize_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanResize"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanResize"]]], jsii.get(self, "resizeInput"))

    @builtins.property
    @jsii.member(jsii_name="rotateInput")
    def rotate_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanRotate"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanRotate"]]], jsii.get(self, "rotateInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanScale"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanScale"]]], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="shearInput")
    def shear_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanShear"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanShear"]]], jsii.get(self, "shearInput"))

    @builtins.property
    @jsii.member(jsii_name="trimInput")
    def trim_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanTrim"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanTrim"]]], jsii.get(self, "trimInput"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMaskInput")
    def unsharp_mask_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanUnsharpMask"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanUnsharpMask"]]], jsii.get(self, "unsharpMaskInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1faf6cc8ef359f419f031bef180013fccbb8ab8faff3c194b9002d4c584247f5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanRegionOfInterestCrop",
    jsii_struct_bases=[],
    name_mapping={
        "region_of_interest": "regionOfInterest",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanRegionOfInterestCrop:
    def __init__(
        self,
        *,
        region_of_interest: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanRegionOfInterestCropRegionOfInterest", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param region_of_interest: region_of_interest block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest DataAkamaiImagingPolicyImage#region_of_interest}
        :param gravity: The placement of the crop area relative to the specified area of interest. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: The placement of the crop area relative to the specified area of interest. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param style: Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(region_of_interest, dict):
            region_of_interest = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanRegionOfInterestCropRegionOfInterest(**region_of_interest)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cc986a4dbf0ab924986b4cb5cc83b09fcc02ce4b1cad80fe5014041f8c3e248a)
            check_type(argname="argument region_of_interest", value=region_of_interest, expected_type=type_hints["region_of_interest"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "region_of_interest": region_of_interest,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def region_of_interest(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanRegionOfInterestCropRegionOfInterest":
        '''region_of_interest block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest DataAkamaiImagingPolicyImage#region_of_interest}
        '''
        result = self._values.get("region_of_interest")
        assert result is not None, "Required property 'region_of_interest' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanRegionOfInterestCropRegionOfInterest", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''The placement of the crop area relative to the specified area of interest.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''The placement of the crop area relative to the specified area of interest.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanRegionOfInterestCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanRegionOfInterestCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanRegionOfInterestCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__816d02c21a4516ed827807fa2dfee7ac86b3fba3ac337bd04b2035456dad0efa)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanRegionOfInterestCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f182b5f0cdb31bd20e1a428dd1b61eaa0b092bf6d634e5938960a9805351cd90)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanRegionOfInterestCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0dcab713c1b6754928f544e698fd08e90adf4c6649e08b86658b69c3238a29c2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f773504e7f187858c2ce473066dcbf119b4530f231b0e44305879747c5528312)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4f924da116ebbded354c108f1f163bd37db7a33b89b1dfcdaa3171c120455a2c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanRegionOfInterestCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanRegionOfInterestCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanRegionOfInterestCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7244f4638ed16704e07cfb4395d84fb5fce1c17cefaa8cafac9da4e4d81c0c26)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanRegionOfInterestCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanRegionOfInterestCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__33fe4e463fddf9266f8cc05a1821d0ac5c9205c9b4667c20f5ffa7d173d75c29)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putRegionOfInterest")
    def put_region_of_interest(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanRegionOfInterestCropRegionOfInterest()

        return typing.cast(None, jsii.invoke(self, "putRegionOfInterest", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterest")
    def region_of_interest(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestOutputReference", jsii.get(self, "regionOfInterest"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestInput")
    def region_of_interest_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanRegionOfInterestCropRegionOfInterest"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanRegionOfInterestCropRegionOfInterest"], jsii.get(self, "regionOfInterestInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5d1119170c719b0df747b791dd974bc669560982a45af14c71a2d7fee23f47d0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__12f4cb20b7fb8e660f64377b38e6fe5409377c1f01069358a01e2ff1fc748395)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bec991886b0dcd6a57147eedf440ce09e9a455e51fdee686b30e43faccd4487c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3715cf93573277b26a69850f7dbffce9ee8959f0fba9662355681430cfc67a8d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__107f208b551f707f07a4b768a4b085015c217f2617a4725eb85f660831d2f6cc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c42e12049a2cab92f4af136bb51a40c5c3f423d1c359ee7664b60984dcf50390)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__94aa86cc893878ad4613f9025addbd8211c1f01b70e3ed8fb94af7d14b5d14b0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4f58431ae67c8fb76b3202cb66e6f7187cbafd9a9f7783f0120eb0d25e989a5a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanRegionOfInterestCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanRegionOfInterestCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanRegionOfInterestCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd51a691434e6e2db2a5e3c6bf803ec8b0bda3b017619bf3c4dcb5535c2d7019)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanRegionOfInterestCropRegionOfInterest",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanRegionOfInterestCropRegionOfInterest:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanRegionOfInterestCropRegionOfInterest(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__025ff8f1cbca61ed6d62807d4372123053eaaba155444a280862d8d4bcc84150)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanRegionOfInterestCropRegionOfInterest]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanRegionOfInterestCropRegionOfInterest], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanRegionOfInterestCropRegionOfInterest],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b0ba8c30e87a27109de166965ae55b8efce42bc08cd336cd83680c42937d0536)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanRelativeCrop",
    jsii_struct_bases=[],
    name_mapping={
        "east": "east",
        "east_var": "eastVar",
        "north": "north",
        "north_var": "northVar",
        "south": "south",
        "south_var": "southVar",
        "west": "west",
        "west_var": "westVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanRelativeCrop:
    def __init__(
        self,
        *,
        east: typing.Optional[builtins.str] = None,
        east_var: typing.Optional[builtins.str] = None,
        north: typing.Optional[builtins.str] = None,
        north_var: typing.Optional[builtins.str] = None,
        south: typing.Optional[builtins.str] = None,
        south_var: typing.Optional[builtins.str] = None,
        west: typing.Optional[builtins.str] = None,
        west_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param east: The number of pixels to shrink or expand the right side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east DataAkamaiImagingPolicyImage#east}
        :param east_var: The number of pixels to shrink or expand the right side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east_var DataAkamaiImagingPolicyImage#east_var}
        :param north: The number of pixels to shrink or expand the top side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north DataAkamaiImagingPolicyImage#north}
        :param north_var: The number of pixels to shrink or expand the top side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north_var DataAkamaiImagingPolicyImage#north_var}
        :param south: The number of pixels to shrink or expand the bottom side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south DataAkamaiImagingPolicyImage#south}
        :param south_var: The number of pixels to shrink or expand the bottom side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south_var DataAkamaiImagingPolicyImage#south_var}
        :param west: The number of pixels to shrink or expand the left side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west DataAkamaiImagingPolicyImage#west}
        :param west_var: The number of pixels to shrink or expand the left side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west_var DataAkamaiImagingPolicyImage#west_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f65ef6f5590bf7c241c573c476b2073d437efbd326516bf94c5cc7a320533c7c)
            check_type(argname="argument east", value=east, expected_type=type_hints["east"])
            check_type(argname="argument east_var", value=east_var, expected_type=type_hints["east_var"])
            check_type(argname="argument north", value=north, expected_type=type_hints["north"])
            check_type(argname="argument north_var", value=north_var, expected_type=type_hints["north_var"])
            check_type(argname="argument south", value=south, expected_type=type_hints["south"])
            check_type(argname="argument south_var", value=south_var, expected_type=type_hints["south_var"])
            check_type(argname="argument west", value=west, expected_type=type_hints["west"])
            check_type(argname="argument west_var", value=west_var, expected_type=type_hints["west_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if east is not None:
            self._values["east"] = east
        if east_var is not None:
            self._values["east_var"] = east_var
        if north is not None:
            self._values["north"] = north
        if north_var is not None:
            self._values["north_var"] = north_var
        if south is not None:
            self._values["south"] = south
        if south_var is not None:
            self._values["south_var"] = south_var
        if west is not None:
            self._values["west"] = west
        if west_var is not None:
            self._values["west_var"] = west_var

    @builtins.property
    def east(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the right side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east DataAkamaiImagingPolicyImage#east}
        '''
        result = self._values.get("east")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def east_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the right side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east_var DataAkamaiImagingPolicyImage#east_var}
        '''
        result = self._values.get("east_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def north(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the top side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north DataAkamaiImagingPolicyImage#north}
        '''
        result = self._values.get("north")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def north_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the top side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north_var DataAkamaiImagingPolicyImage#north_var}
        '''
        result = self._values.get("north_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def south(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the bottom side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south DataAkamaiImagingPolicyImage#south}
        '''
        result = self._values.get("south")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def south_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the bottom side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south_var DataAkamaiImagingPolicyImage#south_var}
        '''
        result = self._values.get("south_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def west(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the left side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west DataAkamaiImagingPolicyImage#west}
        '''
        result = self._values.get("west")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def west_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the left side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west_var DataAkamaiImagingPolicyImage#west_var}
        '''
        result = self._values.get("west_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanRelativeCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanRelativeCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanRelativeCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b4c4581fe60c4be1cbe78a7664d370996199dfabbcafbfc37efe5c00a108c8f3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanRelativeCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2f1e69911b8761fe2fe617fa30e49b8d6d9d3210fe3193de6f666d4a20830423)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanRelativeCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bccf54111138e34203974cb0c12ec60f63d93f4f85af28e2ba77cef9e489d230)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1973e1feabebe6f24e259cf731bdcb9cc30697ca17110eb49c43900bdcb6ba85)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__396e72ac50c171c09981cd0dd84f821768ec29a3d1fb3c647d199ef4a173a633)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanRelativeCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanRelativeCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanRelativeCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__99c5bbbb811b222514f8153d741d02e1c5cc43eda83570a49b346a8e2515612d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanRelativeCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanRelativeCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f3c63f0a2c7a9a9195b2dbab281168704c9c8a5d13db13d612a2215d01f5dc17)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetEast")
    def reset_east(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEast", []))

    @jsii.member(jsii_name="resetEastVar")
    def reset_east_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEastVar", []))

    @jsii.member(jsii_name="resetNorth")
    def reset_north(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNorth", []))

    @jsii.member(jsii_name="resetNorthVar")
    def reset_north_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNorthVar", []))

    @jsii.member(jsii_name="resetSouth")
    def reset_south(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSouth", []))

    @jsii.member(jsii_name="resetSouthVar")
    def reset_south_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSouthVar", []))

    @jsii.member(jsii_name="resetWest")
    def reset_west(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWest", []))

    @jsii.member(jsii_name="resetWestVar")
    def reset_west_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWestVar", []))

    @builtins.property
    @jsii.member(jsii_name="eastInput")
    def east_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "eastInput"))

    @builtins.property
    @jsii.member(jsii_name="eastVarInput")
    def east_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "eastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="northInput")
    def north_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "northInput"))

    @builtins.property
    @jsii.member(jsii_name="northVarInput")
    def north_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "northVarInput"))

    @builtins.property
    @jsii.member(jsii_name="southInput")
    def south_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "southInput"))

    @builtins.property
    @jsii.member(jsii_name="southVarInput")
    def south_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "southVarInput"))

    @builtins.property
    @jsii.member(jsii_name="westInput")
    def west_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "westInput"))

    @builtins.property
    @jsii.member(jsii_name="westVarInput")
    def west_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "westVarInput"))

    @builtins.property
    @jsii.member(jsii_name="east")
    def east(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "east"))

    @east.setter
    def east(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d009f988a23a39cc51f5ea5f53c5f4ff59711dc1343a34f9b097bf536d65f11b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "east", value)

    @builtins.property
    @jsii.member(jsii_name="eastVar")
    def east_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "eastVar"))

    @east_var.setter
    def east_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a751b7447ac6bb0d6e2e5ab669ba61bb98e57a77cd032b7d3009844c4e17f563)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "eastVar", value)

    @builtins.property
    @jsii.member(jsii_name="north")
    def north(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "north"))

    @north.setter
    def north(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d9822150619b5c42920c54f6ee19c2fbec0020e6445925fead40d7d7e431562)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "north", value)

    @builtins.property
    @jsii.member(jsii_name="northVar")
    def north_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "northVar"))

    @north_var.setter
    def north_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9241f8991ac3681f1a0023f34563d6a68e6461d33f64f333bfa18383896e94dc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "northVar", value)

    @builtins.property
    @jsii.member(jsii_name="south")
    def south(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "south"))

    @south.setter
    def south(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fcf01a8f441ccbfe78df0ae1902e24ad87fd274ca59f696106737367c762a11a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "south", value)

    @builtins.property
    @jsii.member(jsii_name="southVar")
    def south_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "southVar"))

    @south_var.setter
    def south_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__98cea97cf4d4c90926e7a0838964849c2675d0ab26bc3c2b8c81885c4dfdef4f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "southVar", value)

    @builtins.property
    @jsii.member(jsii_name="west")
    def west(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "west"))

    @west.setter
    def west(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__980448668703183050c5db9f063fecad3a83fe835520591d5b8da786741d169c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "west", value)

    @builtins.property
    @jsii.member(jsii_name="westVar")
    def west_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "westVar"))

    @west_var.setter
    def west_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a00b3accc5208f23345b52d3b52ac7f5b1a5e22419f65b310e8c87d6970c7434)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "westVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanRelativeCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanRelativeCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanRelativeCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7339bb2a02bff2f726134982d377beadfd164a4281c0862ec95e4c81b63970ef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanRemoveColor",
    jsii_struct_bases=[],
    name_mapping={
        "color": "color",
        "color_var": "colorVar",
        "feather": "feather",
        "feather_var": "featherVar",
        "tolerance": "tolerance",
        "tolerance_var": "toleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanRemoveColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
        feather: typing.Optional[builtins.str] = None,
        feather_var: typing.Optional[builtins.str] = None,
        tolerance: typing.Optional[builtins.str] = None,
        tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        :param feather: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        :param feather_var: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        :param tolerance: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        :param tolerance_var: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__afc4118fb00b308edcef80464974ca7c4ee50959629198eb780e5ab641d82fc5)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
            check_type(argname="argument feather", value=feather, expected_type=type_hints["feather"])
            check_type(argname="argument feather_var", value=feather_var, expected_type=type_hints["feather_var"])
            check_type(argname="argument tolerance", value=tolerance, expected_type=type_hints["tolerance"])
            check_type(argname="argument tolerance_var", value=tolerance_var, expected_type=type_hints["tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var
        if feather is not None:
            self._values["feather"] = feather
        if feather_var is not None:
            self._values["feather_var"] = feather_var
        if tolerance is not None:
            self._values["tolerance"] = tolerance
        if tolerance_var is not None:
            self._values["tolerance_var"] = tolerance_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        '''
        result = self._values.get("feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather_var(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        '''
        result = self._values.get("feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        '''
        result = self._values.get("tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance_var(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        result = self._values.get("tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanRemoveColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanRemoveColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanRemoveColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6ea34766552c97e35d0b8688cf661eb3d230087a5e9c6e9378740e5622892c5b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanRemoveColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8d6498ca30c2810d4a0a8a3247135f87108db94e0c46f9243674288ca11f7a49)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanRemoveColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__60b7f9cab022ecf86f23b930005bae6a1f1d13fc57f7fbee2f1ba0687c6e049d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__53e633a956b470fab4669b1ce0dbc3d3aa4b5a89024e13dc659e5cd310aeea5e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f6483a8a753e2b01d449cfa50623fa3b315e8fb3c3f7006a5d70c051c2599d2a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanRemoveColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanRemoveColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanRemoveColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5088e9882cf6bdb493ef1148b9d838bd6180dce3a27040e2c730ff12fc243b42)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanRemoveColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanRemoveColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a3465c7acb44c0d7f0f0f8f927099118f8bf73e2356f5dd44940fe7edd01576)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @jsii.member(jsii_name="resetFeather")
    def reset_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeather", []))

    @jsii.member(jsii_name="resetFeatherVar")
    def reset_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatherVar", []))

    @jsii.member(jsii_name="resetTolerance")
    def reset_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTolerance", []))

    @jsii.member(jsii_name="resetToleranceVar")
    def reset_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featherInput")
    def feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherInput"))

    @builtins.property
    @jsii.member(jsii_name="featherVarInput")
    def feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceInput")
    def tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceVarInput")
    def tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e92fa34f8c3054b4c4bfb607ea6775d1b1d6597d47dbf93a4b3fee5b80615d55)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0b80fb9a6eef7597eb912e4c0b6747c857f2705449610fa9285f7b52be8d0ce0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="feather")
    def feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "feather"))

    @feather.setter
    def feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6bd577450cef55212c602d7ac9cd150352f66bd6d4d5a4bf42e19345eecda869)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "feather", value)

    @builtins.property
    @jsii.member(jsii_name="featherVar")
    def feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featherVar"))

    @feather_var.setter
    def feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__09516ab9bd4380b1d6d10eafbf950f14497a3f0c857d031fa1f9e0a3d75143d2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featherVar", value)

    @builtins.property
    @jsii.member(jsii_name="tolerance")
    def tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tolerance"))

    @tolerance.setter
    def tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1c56c7eace245746b0d87999f17ce148efdcc0d3622097d1dbeee0a104ec661e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tolerance", value)

    @builtins.property
    @jsii.member(jsii_name="toleranceVar")
    def tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "toleranceVar"))

    @tolerance_var.setter
    def tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6fa5fcdad9239074e01f3fc14bd69c0ca5b62a378f2ff1df74854579a4eb3bb5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "toleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanRemoveColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanRemoveColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanRemoveColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f7f98c8158926d996a0e4c2dee2ecb5da3a868bd735f948b842e598a40a28dec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanResize",
    jsii_struct_bases=[],
    name_mapping={
        "aspect": "aspect",
        "aspect_var": "aspectVar",
        "height": "height",
        "height_var": "heightVar",
        "type": "type",
        "type_var": "typeVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanResize:
    def __init__(
        self,
        *,
        aspect: typing.Optional[builtins.str] = None,
        aspect_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param aspect: Preserves the aspect ratio. Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect DataAkamaiImagingPolicyImage#aspect}
        :param aspect_var: Preserves the aspect ratio. Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_var DataAkamaiImagingPolicyImage#aspect_var}
        :param height: The height to resize the source image to. Must be set if height is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height to resize the source image to. Must be set if height is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param type: Sets constraints for the image resize. Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: Sets constraints for the image resize. Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        :param width: The width to resize the source image to. Must be set if width is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width to resize the source image to. Must be set if width is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__68e3e9dbe79ec719e5455e35efa40dd1a32bb58850c7f644c73269a5c6e9dda3)
            check_type(argname="argument aspect", value=aspect, expected_type=type_hints["aspect"])
            check_type(argname="argument aspect_var", value=aspect_var, expected_type=type_hints["aspect_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if aspect is not None:
            self._values["aspect"] = aspect
        if aspect_var is not None:
            self._values["aspect_var"] = aspect_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def aspect(self) -> typing.Optional[builtins.str]:
        '''Preserves the aspect ratio.

        Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect DataAkamaiImagingPolicyImage#aspect}
        '''
        result = self._values.get("aspect")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def aspect_var(self) -> typing.Optional[builtins.str]:
        '''Preserves the aspect ratio.

        Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_var DataAkamaiImagingPolicyImage#aspect_var}
        '''
        result = self._values.get("aspect_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height to resize the source image to. Must be set if height is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height to resize the source image to. Must be set if height is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''Sets constraints for the image resize.

        Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''Sets constraints for the image resize.

        Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width to resize the source image to. Must be set if width is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width to resize the source image to. Must be set if width is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanResize(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanResizeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanResizeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cf78e48ccc8632096079fb71c770c59eb78923ef8ff8a7e519b4cd5410a8ad3f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanResizeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bea465fcb7a7d83c54b0cfc31a9fa7e478046076ed386cf510a6b308fd19a6e1)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanResizeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__44508c8bfcb7744c569695dbeac1c0cc3328370a484739a42741767a2ad1442e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__28e2498dd77279b6614051f569214f9d35dbb6c43b3df8388447ce5b407ff898)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5eb1a407dda1b9d89657db3d325064a13068cd7e8e091aa90a860318bd5a2965)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanResize]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanResize]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanResize]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6fe8922423b6ccd9f22ff786d67a92a93091158ed61d0833b5c531d8dcb85137)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanResizeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanResizeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6a7a9d302435013174fc5e4fd076823e0b32387d03e1ab7de7f9d4cb5e62f65a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAspect")
    def reset_aspect(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspect", []))

    @jsii.member(jsii_name="resetAspectVar")
    def reset_aspect_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspectVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="aspectInput")
    def aspect_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "aspectInput"))

    @builtins.property
    @jsii.member(jsii_name="aspectVarInput")
    def aspect_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "aspectVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="aspect")
    def aspect(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "aspect"))

    @aspect.setter
    def aspect(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__21206a1f156544ff2dd6bdb72f3c9896b8895c105ad936731f67121278ce8ada)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "aspect", value)

    @builtins.property
    @jsii.member(jsii_name="aspectVar")
    def aspect_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "aspectVar"))

    @aspect_var.setter
    def aspect_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f02587a9e55c1fe28a4cb15a51dfc8083d7743b2c507bd600feb33a5a96f8516)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "aspectVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__593f44e3af11694923acb1234127958ceaa8c00b97c5f7ba270f37fdf0765dca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__edc567ba3cee534c80ca9fb1e08676b50e8c5519bbd0494c7505f5d7ee301fc6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b7807d0e35b3e64225373e964ef88f5ad0e25116b1dbc5d44da99eb055e51d4f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e9d569bf13b659ea8ba21cc305c8fd3c0b1efe87779e563c476c4f6789061dd1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c814bce5d9ef747ce35dc78e82378f54a59e88ac960397b74a75e8a4e93e763a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb9477432419ad87e19b5d4d4d0cd45a692b5e773e65eefe0cf416753c1ecf43)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanResize]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanResize]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanResize]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__92ea02c95b004cb12d41337641f7bbccdc317ec20c9d024113052ce0104b0476)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanRotate",
    jsii_struct_bases=[],
    name_mapping={"degrees": "degrees", "degrees_var": "degreesVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanRotate:
    def __init__(
        self,
        *,
        degrees: typing.Optional[builtins.str] = None,
        degrees_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param degrees: The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees DataAkamaiImagingPolicyImage#degrees}
        :param degrees_var: The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees_var DataAkamaiImagingPolicyImage#degrees_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__18198b0d67aa12b1584a1ea367f4a4edd9b018709c968cb507a34bef07dddb51)
            check_type(argname="argument degrees", value=degrees, expected_type=type_hints["degrees"])
            check_type(argname="argument degrees_var", value=degrees_var, expected_type=type_hints["degrees_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if degrees is not None:
            self._values["degrees"] = degrees
        if degrees_var is not None:
            self._values["degrees_var"] = degrees_var

    @builtins.property
    def degrees(self) -> typing.Optional[builtins.str]:
        '''The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees DataAkamaiImagingPolicyImage#degrees}
        '''
        result = self._values.get("degrees")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def degrees_var(self) -> typing.Optional[builtins.str]:
        '''The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees_var DataAkamaiImagingPolicyImage#degrees_var}
        '''
        result = self._values.get("degrees_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanRotate(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanRotateList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanRotateList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3108cfe1a66b3c290f575ab602f5c10febd6c072181fdda69a017646b24648bc)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanRotateOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c8154e1ac52e7e24d456ee0f96f61150c09fc86d1cc253fd466f43eee50c532d)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanRotateOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__da748700da9e0ea58a0f7a6f072cbae2d1066c692a54b5a2aac65ca4d575fd5e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c17000bb10e30d91188b2add7654bf8af80e67a917d3d91adbcf6067ea559b04)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3784010f2c8332ebc5e79cb8a5b0404d0c2d6575d85cf38110c867fe559dbb90)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanRotate]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanRotate]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanRotate]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a244389006d4619e73ddfff003ec0242b711df265a6c49bfd0a00d37d1665f3a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanRotateOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanRotateOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d40d8e6f9d95763da2338f2f9ca91fc6f92f995f3361cf6765f73aabe4393a54)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetDegrees")
    def reset_degrees(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDegrees", []))

    @jsii.member(jsii_name="resetDegreesVar")
    def reset_degrees_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDegreesVar", []))

    @builtins.property
    @jsii.member(jsii_name="degreesInput")
    def degrees_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "degreesInput"))

    @builtins.property
    @jsii.member(jsii_name="degreesVarInput")
    def degrees_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "degreesVarInput"))

    @builtins.property
    @jsii.member(jsii_name="degrees")
    def degrees(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "degrees"))

    @degrees.setter
    def degrees(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a03644de2ad59109db399e945351e04903c4142af55784d1d6bf498465947e36)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "degrees", value)

    @builtins.property
    @jsii.member(jsii_name="degreesVar")
    def degrees_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "degreesVar"))

    @degrees_var.setter
    def degrees_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0117b699f1391b195da45b326471a485bb323b292828c416728fead6d57fcc24)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "degreesVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanRotate]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanRotate]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanRotate]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5cc6b65058391276db6292d3d5619ccb142b803caa0908c5801b087aa5270082)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanScale",
    jsii_struct_bases=[],
    name_mapping={
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanScale:
    def __init__(
        self,
        *,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param height: Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged. Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged. Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__414b91c6b20a11f49c2faa33cfebb0db2503392c5e87ef71a23acd80512d3773)
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size.

        Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size.

        Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged.

        Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged.

        Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanScale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanScaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanScaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8505a8de304ba523d38b57897637962d7fc45bf6135616eb94d3ef4ceaccb9d8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanScaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8fb0f408ad5a04cb39a4c10a5c4e2e2c259d994c8a15e0410059735dde2a7533)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanScaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fca6c6e14de029093d7f75a7f08c317c2ac141dc64d462d7b088b7b647ffef05)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__76364c307923ad91a8375a6fce9802df497ac2136116a19f2b219da1adc61890)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__663a5d9ecae7b1610ce8ef5b2be4a3d2883bc48bd841bce23daf7963b410bb21)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanScale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanScale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanScale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4cb797957e1c8d8344a3dc96018f2feef7cae38d5ce6a6d195231f61eee5102a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanScaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanScaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bddfa4706298a51499e6efc51e2cfb16a6f90201c21a39dad2b454fe936b1440)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b81cd128a5d49a32b9d47771c9db008dd1a9fd127ef906367d7e39fea811f98a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b8cbd40d2f0bd1aa0bc81f62bc485fcaf15e0d75829325ce4462b6eef4033be9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__664cf0d13ae4714dd956b7c68d91731624a97bf2af80e2df0dee91b8b44cacd3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0d7e2b3cbd3cb67cd098f223507c0fa0457a917e1e7fb811e8d7700c1dbd271d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanScale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanScale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanScale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2bad020d4923300537b92c4c913e0a9504246e5264b7177dd935ad3f1c0acdfc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanShear",
    jsii_struct_bases=[],
    name_mapping={
        "x_shear": "xShear",
        "x_shear_var": "xShearVar",
        "y_shear": "yShear",
        "y_shear_var": "yShearVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanShear:
    def __init__(
        self,
        *,
        x_shear: typing.Optional[builtins.str] = None,
        x_shear_var: typing.Optional[builtins.str] = None,
        y_shear: typing.Optional[builtins.str] = None,
        y_shear_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param x_shear: The amount to shear along the x-axis, measured in multiples of the image's width. Must be set if yShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear DataAkamaiImagingPolicyImage#x_shear}
        :param x_shear_var: The amount to shear along the x-axis, measured in multiples of the image's width. Must be set if yShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear_var DataAkamaiImagingPolicyImage#x_shear_var}
        :param y_shear: The amount to shear along the y-axis, measured in multiples of the image's height. Must be set if xShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear DataAkamaiImagingPolicyImage#y_shear}
        :param y_shear_var: The amount to shear along the y-axis, measured in multiples of the image's height. Must be set if xShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear_var DataAkamaiImagingPolicyImage#y_shear_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__01eac30623891a1a869a2f44899365e0ada2b9b0c42577273eefd7e116756e55)
            check_type(argname="argument x_shear", value=x_shear, expected_type=type_hints["x_shear"])
            check_type(argname="argument x_shear_var", value=x_shear_var, expected_type=type_hints["x_shear_var"])
            check_type(argname="argument y_shear", value=y_shear, expected_type=type_hints["y_shear"])
            check_type(argname="argument y_shear_var", value=y_shear_var, expected_type=type_hints["y_shear_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if x_shear is not None:
            self._values["x_shear"] = x_shear
        if x_shear_var is not None:
            self._values["x_shear_var"] = x_shear_var
        if y_shear is not None:
            self._values["y_shear"] = y_shear
        if y_shear_var is not None:
            self._values["y_shear_var"] = y_shear_var

    @builtins.property
    def x_shear(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the x-axis, measured in multiples of the image's width.

        Must be set if yShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear DataAkamaiImagingPolicyImage#x_shear}
        '''
        result = self._values.get("x_shear")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_shear_var(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the x-axis, measured in multiples of the image's width.

        Must be set if yShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear_var DataAkamaiImagingPolicyImage#x_shear_var}
        '''
        result = self._values.get("x_shear_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_shear(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the y-axis, measured in multiples of the image's height.

        Must be set if xShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear DataAkamaiImagingPolicyImage#y_shear}
        '''
        result = self._values.get("y_shear")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_shear_var(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the y-axis, measured in multiples of the image's height.

        Must be set if xShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear_var DataAkamaiImagingPolicyImage#y_shear_var}
        '''
        result = self._values.get("y_shear_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanShear(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanShearList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanShearList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c5b9396845fcf200b7cc36e559ee975559aedd7b8d717e9f7cd4219a4db06b56)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanShearOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2abcc7c43f4298f059a0671bf542daf6722ee288838587274c9b255f322a4c59)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanShearOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__42e39a3d42ae5a9c52ecdb67e2442dc4eb377f89865a3f73c56a5a86c88249aa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3de670934bfa6dbe72c7b46a5793d2f37fa73a21bff9c0058c9000e3e7dc0e4b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f667e2b3a1a000cf0229f50c785acc16d3b08c77e0f9ec56c1a661da5dd350a0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanShear]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanShear]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanShear]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0773955d7e19c9575e8a1009d7eb124e4239a224a34fa715c0b7369bd45f0bb5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanShearOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanShearOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb455c3f491a4bf252eadefeff0a122820a3e46fb7e9dfaaca44e97640d4d626)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetXShear")
    def reset_x_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXShear", []))

    @jsii.member(jsii_name="resetXShearVar")
    def reset_x_shear_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXShearVar", []))

    @jsii.member(jsii_name="resetYShear")
    def reset_y_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYShear", []))

    @jsii.member(jsii_name="resetYShearVar")
    def reset_y_shear_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYShearVar", []))

    @builtins.property
    @jsii.member(jsii_name="xShearInput")
    def x_shear_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xShearInput"))

    @builtins.property
    @jsii.member(jsii_name="xShearVarInput")
    def x_shear_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xShearVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yShearInput")
    def y_shear_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yShearInput"))

    @builtins.property
    @jsii.member(jsii_name="yShearVarInput")
    def y_shear_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yShearVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xShear")
    def x_shear(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xShear"))

    @x_shear.setter
    def x_shear(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__55eb3b337e77703add877688da64150779d00c7af5e30f19e2ef9235adc3ffa5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xShear", value)

    @builtins.property
    @jsii.member(jsii_name="xShearVar")
    def x_shear_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xShearVar"))

    @x_shear_var.setter
    def x_shear_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__acfc1e761369bc901d750127ee2511b78e03406d8c41a95c4a0b387612fdf761)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xShearVar", value)

    @builtins.property
    @jsii.member(jsii_name="yShear")
    def y_shear(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yShear"))

    @y_shear.setter
    def y_shear(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__378082281e2f312985c6ece0b1d4e944a51710d5bfecc6cf1f51e274cc360292)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yShear", value)

    @builtins.property
    @jsii.member(jsii_name="yShearVar")
    def y_shear_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yShearVar"))

    @y_shear_var.setter
    def y_shear_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__59251dc699d7433ee84e3e15c8c8fa64e766e03dd3f0f246a4408ecdcb792a4a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yShearVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanShear]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanShear]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanShear]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__76faf462faa61536479bc8e5697d4bb2bd3d1f53cfe76dc5f28b2208c458758f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanTrim",
    jsii_struct_bases=[],
    name_mapping={
        "fuzz": "fuzz",
        "fuzz_var": "fuzzVar",
        "padding": "padding",
        "padding_var": "paddingVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanTrim:
    def __init__(
        self,
        *,
        fuzz: typing.Optional[builtins.str] = None,
        fuzz_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fuzz: The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz DataAkamaiImagingPolicyImage#fuzz}
        :param fuzz_var: The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz_var DataAkamaiImagingPolicyImage#fuzz_var}
        :param padding: The amount of padding in pixels to add to the trimmed image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: The amount of padding in pixels to add to the trimmed image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__339024a6f532bdabe824d829997224c376d07feac439e2a527847d00835c0132)
            check_type(argname="argument fuzz", value=fuzz, expected_type=type_hints["fuzz"])
            check_type(argname="argument fuzz_var", value=fuzz_var, expected_type=type_hints["fuzz_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fuzz is not None:
            self._values["fuzz"] = fuzz
        if fuzz_var is not None:
            self._values["fuzz_var"] = fuzz_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var

    @builtins.property
    def fuzz(self) -> typing.Optional[builtins.str]:
        '''The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz DataAkamaiImagingPolicyImage#fuzz}
        '''
        result = self._values.get("fuzz")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fuzz_var(self) -> typing.Optional[builtins.str]:
        '''The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz_var DataAkamaiImagingPolicyImage#fuzz_var}
        '''
        result = self._values.get("fuzz_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''The amount of padding in pixels to add to the trimmed image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''The amount of padding in pixels to add to the trimmed image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanTrim(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanTrimList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanTrimList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__427b6b0265e13b263154822f84536087b203cce241f914caf78669b2f1a5ee5f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanTrimOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f7de82a220216e068c57b4b11c6dcb5030ab0d76a0e7cf39e8b628cd2ef594e3)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanTrimOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__11addc5ba6c809506b1265de827342588f7ef06083b3702c4fb576ecf67de8bc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6fb65997481200ca69dab54ad735e13d58a4ce4481b26e568fa11dde9f5db325)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b61bc887f1e20b50cf6e91f8c86355c0d9a1a95a378dc37000d972510872286a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanTrim]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanTrim]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanTrim]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dec1ce621c3262f09ed67a498d1ea588c3124b8aa64d94281cae091e32b4bd2a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanTrimOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanTrimOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__35e17e06cfb0f0459ebb7e7990d2d76bf00b51907e3d9b32d278bc3e68ff28a5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetFuzz")
    def reset_fuzz(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFuzz", []))

    @jsii.member(jsii_name="resetFuzzVar")
    def reset_fuzz_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFuzzVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @builtins.property
    @jsii.member(jsii_name="fuzzInput")
    def fuzz_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fuzzInput"))

    @builtins.property
    @jsii.member(jsii_name="fuzzVarInput")
    def fuzz_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fuzzVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="fuzz")
    def fuzz(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fuzz"))

    @fuzz.setter
    def fuzz(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__61056b7699f97688951c0eb6ac91d37f6cf4f63af4b53e9ba67d2680c75cc3b4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fuzz", value)

    @builtins.property
    @jsii.member(jsii_name="fuzzVar")
    def fuzz_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fuzzVar"))

    @fuzz_var.setter
    def fuzz_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea1b7e6f801834a001b9940d90276b3a6a44fc75ef8c088436576c88b118ee21)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fuzzVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0050898f864926930bb2df05d2acf8358ec5645770ddc587ba1b85dc4d066355)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__444c159f6da9e18b6944aa4d8102682808f64b59d33460bb7580d0d5bffc4302)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanTrim]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanTrim]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanTrim]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5188ce0b28e93aac252b4d7bd615f349592c1f1973865b7f76799ae06506704f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanUnsharpMask",
    jsii_struct_bases=[],
    name_mapping={
        "gain": "gain",
        "gain_var": "gainVar",
        "sigma": "sigma",
        "sigma_var": "sigmaVar",
        "threshold": "threshold",
        "threshold_var": "thresholdVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanUnsharpMask:
    def __init__(
        self,
        *,
        gain: typing.Optional[builtins.str] = None,
        gain_var: typing.Optional[builtins.str] = None,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
        threshold: typing.Optional[builtins.str] = None,
        threshold_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param gain: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        :param gain_var: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        :param sigma: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        :param threshold: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        :param threshold_var: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a714c2d19d2a8264f0f248d351e75763fe04be345cb2fc53648cbc24795f5cc)
            check_type(argname="argument gain", value=gain, expected_type=type_hints["gain"])
            check_type(argname="argument gain_var", value=gain_var, expected_type=type_hints["gain_var"])
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
            check_type(argname="argument threshold", value=threshold, expected_type=type_hints["threshold"])
            check_type(argname="argument threshold_var", value=threshold_var, expected_type=type_hints["threshold_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if gain is not None:
            self._values["gain"] = gain
        if gain_var is not None:
            self._values["gain_var"] = gain_var
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var
        if threshold is not None:
            self._values["threshold"] = threshold
        if threshold_var is not None:
            self._values["threshold_var"] = threshold_var

    @builtins.property
    def gain(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        '''
        result = self._values.get("gain")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gain_var(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        '''
        result = self._values.get("gain_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        '''
        result = self._values.get("threshold")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold_var(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        result = self._values.get("threshold_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanUnsharpMask(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanUnsharpMaskList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanUnsharpMaskList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7655b95867157dd83131c19f24ef125ba4be38319b518d7bc85f6166beeaa081)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanUnsharpMaskOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7acb8c59da251e84ec0474613c8ec41b6f1faaf98a6be3c50e4484e2dcce4b4a)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanUnsharpMaskOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f640092379d5811d69f63457ff360ffd1f1e44ae1701ab7b1d44bc4bde7218c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9be813ac136d4a6f5585215dd99f7befe64112a92369ea6dbf5521ed220373b0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f4d262aa37a3833c072aafd359322cc920af47c3c7908ff72d5e7fd445162af3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanUnsharpMask]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanUnsharpMask]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanUnsharpMask]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e9d7a12cee7eeb1f70faf521bc3858decdbd30e5ccf55673dffc45ce18bfd9be)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanUnsharpMaskOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanUnsharpMaskOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c5dfc7ab4d377e2f9ce92bacf55d0d0be59981f3da196a76a08d3aa604799929)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetGain")
    def reset_gain(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGain", []))

    @jsii.member(jsii_name="resetGainVar")
    def reset_gain_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGainVar", []))

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @jsii.member(jsii_name="resetThreshold")
    def reset_threshold(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThreshold", []))

    @jsii.member(jsii_name="resetThresholdVar")
    def reset_threshold_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThresholdVar", []))

    @builtins.property
    @jsii.member(jsii_name="gainInput")
    def gain_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainInput"))

    @builtins.property
    @jsii.member(jsii_name="gainVarInput")
    def gain_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdInput")
    def threshold_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdVarInput")
    def threshold_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gain")
    def gain(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gain"))

    @gain.setter
    def gain(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__74c9bd148df0817925b5d8812cf4d343af5287d68aa8a11ff1cabb60c960b2c4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gain", value)

    @builtins.property
    @jsii.member(jsii_name="gainVar")
    def gain_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gainVar"))

    @gain_var.setter
    def gain_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__97e326adc639d547e919aaa2688612631578cd90c8c38ca193e49859c08f2b7b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gainVar", value)

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a703554da6a3432b02033edcf234ac1b5e2ac1b60cf9b0572f18af4cf28dc631)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a6129400c60bd8a4aed1b7931c274e87cd9ed13623144dedd502c933083756d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="threshold")
    def threshold(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "threshold"))

    @threshold.setter
    def threshold(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5673af764e2a0bd651e60f15ea090df89bef83760e5751b6ddc2fc9399e24ad4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "threshold", value)

    @builtins.property
    @jsii.member(jsii_name="thresholdVar")
    def threshold_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "thresholdVar"))

    @threshold_var.setter
    def threshold_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1686a5375ef580d88818f44e271e0b4c8b893c7e336557b36da42389c4da09bc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "thresholdVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanUnsharpMask]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanUnsharpMask]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanUnsharpMask]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a6804d17a48ea96ecad997aa201740d35d3b3bf6f831917024073da2408e2f0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThan",
    jsii_struct_bases=[],
    name_mapping={
        "append": "append",
        "aspect_crop": "aspectCrop",
        "background_color": "backgroundColor",
        "blur": "blur",
        "chroma_key": "chromaKey",
        "composite": "composite",
        "compound": "compound",
        "contrast": "contrast",
        "crop": "crop",
        "face_crop": "faceCrop",
        "feature_crop": "featureCrop",
        "fit_and_fill": "fitAndFill",
        "goop": "goop",
        "grayscale": "grayscale",
        "hsl": "hsl",
        "hsv": "hsv",
        "if_dimension": "ifDimension",
        "if_orientation": "ifOrientation",
        "im_query": "imQuery",
        "max_colors": "maxColors",
        "mirror": "mirror",
        "mono_hue": "monoHue",
        "opacity": "opacity",
        "region_of_interest_crop": "regionOfInterestCrop",
        "relative_crop": "relativeCrop",
        "remove_color": "removeColor",
        "resize": "resize",
        "rotate": "rotate",
        "scale": "scale",
        "shear": "shear",
        "trim": "trim",
        "unsharp_mask": "unsharpMask",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThan:
    def __init__(
        self,
        *,
        append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanAppend", typing.Dict[builtins.str, typing.Any]]]]] = None,
        aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanAspectCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanBackgroundColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanBlur", typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanChromaKey", typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanComposite", typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanCompound", typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanContrast", typing.Dict[builtins.str, typing.Any]]]]] = None,
        crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanFaceCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanFeatureCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanFitAndFill", typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanGoop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanGrayscale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanHsl", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanHsv", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimension", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientation", typing.Dict[builtins.str, typing.Any]]]]] = None,
        im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanImQuery", typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanMaxColors", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanMirror", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanMonoHue", typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanOpacity", typing.Dict[builtins.str, typing.Any]]]]] = None,
        region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanRegionOfInterestCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanRelativeCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanRemoveColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanResize", typing.Dict[builtins.str, typing.Any]]]]] = None,
        rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanRotate", typing.Dict[builtins.str, typing.Any]]]]] = None,
        scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanScale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanShear", typing.Dict[builtins.str, typing.Any]]]]] = None,
        trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanTrim", typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanUnsharpMask", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param append: append block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        :param aspect_crop: aspect_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param crop: crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        :param face_crop: face_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        :param feature_crop: feature_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        :param fit_and_fill: fit_and_fill block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param im_query: im_query block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param region_of_interest_crop: region_of_interest_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        :param relative_crop: relative_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param resize: resize block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        :param rotate: rotate block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        :param scale: scale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param shear: shear block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        :param trim: trim block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9b6b724372b7315faf8576e575635077b56eea060930073fafc8fb82f8cfeac2)
            check_type(argname="argument append", value=append, expected_type=type_hints["append"])
            check_type(argname="argument aspect_crop", value=aspect_crop, expected_type=type_hints["aspect_crop"])
            check_type(argname="argument background_color", value=background_color, expected_type=type_hints["background_color"])
            check_type(argname="argument blur", value=blur, expected_type=type_hints["blur"])
            check_type(argname="argument chroma_key", value=chroma_key, expected_type=type_hints["chroma_key"])
            check_type(argname="argument composite", value=composite, expected_type=type_hints["composite"])
            check_type(argname="argument compound", value=compound, expected_type=type_hints["compound"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument crop", value=crop, expected_type=type_hints["crop"])
            check_type(argname="argument face_crop", value=face_crop, expected_type=type_hints["face_crop"])
            check_type(argname="argument feature_crop", value=feature_crop, expected_type=type_hints["feature_crop"])
            check_type(argname="argument fit_and_fill", value=fit_and_fill, expected_type=type_hints["fit_and_fill"])
            check_type(argname="argument goop", value=goop, expected_type=type_hints["goop"])
            check_type(argname="argument grayscale", value=grayscale, expected_type=type_hints["grayscale"])
            check_type(argname="argument hsl", value=hsl, expected_type=type_hints["hsl"])
            check_type(argname="argument hsv", value=hsv, expected_type=type_hints["hsv"])
            check_type(argname="argument if_dimension", value=if_dimension, expected_type=type_hints["if_dimension"])
            check_type(argname="argument if_orientation", value=if_orientation, expected_type=type_hints["if_orientation"])
            check_type(argname="argument im_query", value=im_query, expected_type=type_hints["im_query"])
            check_type(argname="argument max_colors", value=max_colors, expected_type=type_hints["max_colors"])
            check_type(argname="argument mirror", value=mirror, expected_type=type_hints["mirror"])
            check_type(argname="argument mono_hue", value=mono_hue, expected_type=type_hints["mono_hue"])
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument region_of_interest_crop", value=region_of_interest_crop, expected_type=type_hints["region_of_interest_crop"])
            check_type(argname="argument relative_crop", value=relative_crop, expected_type=type_hints["relative_crop"])
            check_type(argname="argument remove_color", value=remove_color, expected_type=type_hints["remove_color"])
            check_type(argname="argument resize", value=resize, expected_type=type_hints["resize"])
            check_type(argname="argument rotate", value=rotate, expected_type=type_hints["rotate"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument shear", value=shear, expected_type=type_hints["shear"])
            check_type(argname="argument trim", value=trim, expected_type=type_hints["trim"])
            check_type(argname="argument unsharp_mask", value=unsharp_mask, expected_type=type_hints["unsharp_mask"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if append is not None:
            self._values["append"] = append
        if aspect_crop is not None:
            self._values["aspect_crop"] = aspect_crop
        if background_color is not None:
            self._values["background_color"] = background_color
        if blur is not None:
            self._values["blur"] = blur
        if chroma_key is not None:
            self._values["chroma_key"] = chroma_key
        if composite is not None:
            self._values["composite"] = composite
        if compound is not None:
            self._values["compound"] = compound
        if contrast is not None:
            self._values["contrast"] = contrast
        if crop is not None:
            self._values["crop"] = crop
        if face_crop is not None:
            self._values["face_crop"] = face_crop
        if feature_crop is not None:
            self._values["feature_crop"] = feature_crop
        if fit_and_fill is not None:
            self._values["fit_and_fill"] = fit_and_fill
        if goop is not None:
            self._values["goop"] = goop
        if grayscale is not None:
            self._values["grayscale"] = grayscale
        if hsl is not None:
            self._values["hsl"] = hsl
        if hsv is not None:
            self._values["hsv"] = hsv
        if if_dimension is not None:
            self._values["if_dimension"] = if_dimension
        if if_orientation is not None:
            self._values["if_orientation"] = if_orientation
        if im_query is not None:
            self._values["im_query"] = im_query
        if max_colors is not None:
            self._values["max_colors"] = max_colors
        if mirror is not None:
            self._values["mirror"] = mirror
        if mono_hue is not None:
            self._values["mono_hue"] = mono_hue
        if opacity is not None:
            self._values["opacity"] = opacity
        if region_of_interest_crop is not None:
            self._values["region_of_interest_crop"] = region_of_interest_crop
        if relative_crop is not None:
            self._values["relative_crop"] = relative_crop
        if remove_color is not None:
            self._values["remove_color"] = remove_color
        if resize is not None:
            self._values["resize"] = resize
        if rotate is not None:
            self._values["rotate"] = rotate
        if scale is not None:
            self._values["scale"] = scale
        if shear is not None:
            self._values["shear"] = shear
        if trim is not None:
            self._values["trim"] = trim
        if unsharp_mask is not None:
            self._values["unsharp_mask"] = unsharp_mask

    @builtins.property
    def append(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanAppend"]]]:
        '''append block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        '''
        result = self._values.get("append")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanAppend"]]], result)

    @builtins.property
    def aspect_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanAspectCrop"]]]:
        '''aspect_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        '''
        result = self._values.get("aspect_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanAspectCrop"]]], result)

    @builtins.property
    def background_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanBackgroundColor"]]]:
        '''background_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        '''
        result = self._values.get("background_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanBackgroundColor"]]], result)

    @builtins.property
    def blur(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanBlur"]]]:
        '''blur block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        '''
        result = self._values.get("blur")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanBlur"]]], result)

    @builtins.property
    def chroma_key(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanChromaKey"]]]:
        '''chroma_key block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        '''
        result = self._values.get("chroma_key")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanChromaKey"]]], result)

    @builtins.property
    def composite(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanComposite"]]]:
        '''composite block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        '''
        result = self._values.get("composite")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanComposite"]]], result)

    @builtins.property
    def compound(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanCompound"]]]:
        '''compound block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        '''
        result = self._values.get("compound")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanCompound"]]], result)

    @builtins.property
    def contrast(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanContrast"]]]:
        '''contrast block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanContrast"]]], result)

    @builtins.property
    def crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanCrop"]]]:
        '''crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        '''
        result = self._values.get("crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanCrop"]]], result)

    @builtins.property
    def face_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanFaceCrop"]]]:
        '''face_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        '''
        result = self._values.get("face_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanFaceCrop"]]], result)

    @builtins.property
    def feature_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanFeatureCrop"]]]:
        '''feature_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        '''
        result = self._values.get("feature_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanFeatureCrop"]]], result)

    @builtins.property
    def fit_and_fill(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanFitAndFill"]]]:
        '''fit_and_fill block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        '''
        result = self._values.get("fit_and_fill")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanFitAndFill"]]], result)

    @builtins.property
    def goop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanGoop"]]]:
        '''goop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        '''
        result = self._values.get("goop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanGoop"]]], result)

    @builtins.property
    def grayscale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanGrayscale"]]]:
        '''grayscale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        '''
        result = self._values.get("grayscale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanGrayscale"]]], result)

    @builtins.property
    def hsl(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanHsl"]]]:
        '''hsl block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        '''
        result = self._values.get("hsl")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanHsl"]]], result)

    @builtins.property
    def hsv(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanHsv"]]]:
        '''hsv block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        '''
        result = self._values.get("hsv")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanHsv"]]], result)

    @builtins.property
    def if_dimension(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimension"]]]:
        '''if_dimension block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        '''
        result = self._values.get("if_dimension")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimension"]]], result)

    @builtins.property
    def if_orientation(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientation"]]]:
        '''if_orientation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        '''
        result = self._values.get("if_orientation")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientation"]]], result)

    @builtins.property
    def im_query(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanImQuery"]]]:
        '''im_query block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        '''
        result = self._values.get("im_query")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanImQuery"]]], result)

    @builtins.property
    def max_colors(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanMaxColors"]]]:
        '''max_colors block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        '''
        result = self._values.get("max_colors")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanMaxColors"]]], result)

    @builtins.property
    def mirror(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanMirror"]]]:
        '''mirror block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        '''
        result = self._values.get("mirror")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanMirror"]]], result)

    @builtins.property
    def mono_hue(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanMonoHue"]]]:
        '''mono_hue block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        '''
        result = self._values.get("mono_hue")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanMonoHue"]]], result)

    @builtins.property
    def opacity(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanOpacity"]]]:
        '''opacity block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanOpacity"]]], result)

    @builtins.property
    def region_of_interest_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanRegionOfInterestCrop"]]]:
        '''region_of_interest_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        '''
        result = self._values.get("region_of_interest_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanRegionOfInterestCrop"]]], result)

    @builtins.property
    def relative_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanRelativeCrop"]]]:
        '''relative_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        '''
        result = self._values.get("relative_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanRelativeCrop"]]], result)

    @builtins.property
    def remove_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanRemoveColor"]]]:
        '''remove_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        '''
        result = self._values.get("remove_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanRemoveColor"]]], result)

    @builtins.property
    def resize(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanResize"]]]:
        '''resize block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        '''
        result = self._values.get("resize")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanResize"]]], result)

    @builtins.property
    def rotate(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanRotate"]]]:
        '''rotate block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        '''
        result = self._values.get("rotate")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanRotate"]]], result)

    @builtins.property
    def scale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanScale"]]]:
        '''scale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanScale"]]], result)

    @builtins.property
    def shear(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanShear"]]]:
        '''shear block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        '''
        result = self._values.get("shear")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanShear"]]], result)

    @builtins.property
    def trim(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanTrim"]]]:
        '''trim block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        '''
        result = self._values.get("trim")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanTrim"]]], result)

    @builtins.property
    def unsharp_mask(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanUnsharpMask"]]]:
        '''unsharp_mask block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        result = self._values.get("unsharp_mask")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanUnsharpMask"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanAppend",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_priority": "gravityPriority",
        "gravity_priority_var": "gravityPriorityVar",
        "gravity_var": "gravityVar",
        "preserve_minor_dimension": "preserveMinorDimension",
        "preserve_minor_dimension_var": "preserveMinorDimensionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanAppend:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanAppendImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_priority: typing.Optional[builtins.str] = None,
        gravity_priority_var: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        preserve_minor_dimension: typing.Optional[builtins.str] = None,
        preserve_minor_dimension_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Specifies where to place the ``image`` relative to the source image. The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_priority: Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal. The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority DataAkamaiImagingPolicyImage#gravity_priority}
        :param gravity_priority_var: Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal. The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority_var DataAkamaiImagingPolicyImage#gravity_priority_var}
        :param gravity_var: Specifies where to place the ``image`` relative to the source image. The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param preserve_minor_dimension: Whether to preserve the source image's minor dimension, ``false`` by default. The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension DataAkamaiImagingPolicyImage#preserve_minor_dimension}
        :param preserve_minor_dimension_var: Whether to preserve the source image's minor dimension, ``false`` by default. The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension_var DataAkamaiImagingPolicyImage#preserve_minor_dimension_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanAppendImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b0529bd2ac1efdf4c0644d5fa581bbc040c5b3a4821a5cb278535d3e9467de54)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_priority", value=gravity_priority, expected_type=type_hints["gravity_priority"])
            check_type(argname="argument gravity_priority_var", value=gravity_priority_var, expected_type=type_hints["gravity_priority_var"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument preserve_minor_dimension", value=preserve_minor_dimension, expected_type=type_hints["preserve_minor_dimension"])
            check_type(argname="argument preserve_minor_dimension_var", value=preserve_minor_dimension_var, expected_type=type_hints["preserve_minor_dimension_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_priority is not None:
            self._values["gravity_priority"] = gravity_priority
        if gravity_priority_var is not None:
            self._values["gravity_priority_var"] = gravity_priority_var
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if preserve_minor_dimension is not None:
            self._values["preserve_minor_dimension"] = preserve_minor_dimension
        if preserve_minor_dimension_var is not None:
            self._values["preserve_minor_dimension_var"] = preserve_minor_dimension_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanAppendImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanAppendImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Specifies where to place the ``image`` relative to the source image.

        The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_priority(self) -> typing.Optional[builtins.str]:
        '''Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal.

        The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority DataAkamaiImagingPolicyImage#gravity_priority}
        '''
        result = self._values.get("gravity_priority")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_priority_var(self) -> typing.Optional[builtins.str]:
        '''Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal.

        The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority_var DataAkamaiImagingPolicyImage#gravity_priority_var}
        '''
        result = self._values.get("gravity_priority_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Specifies where to place the ``image`` relative to the source image.

        The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def preserve_minor_dimension(self) -> typing.Optional[builtins.str]:
        '''Whether to preserve the source image's minor dimension, ``false`` by default.

        The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension DataAkamaiImagingPolicyImage#preserve_minor_dimension}
        '''
        result = self._values.get("preserve_minor_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def preserve_minor_dimension_var(self) -> typing.Optional[builtins.str]:
        '''Whether to preserve the source image's minor dimension, ``false`` by default.

        The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension_var DataAkamaiImagingPolicyImage#preserve_minor_dimension_var}
        '''
        result = self._values.get("preserve_minor_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanAppend(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanAppendImage",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanAppendImage:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanAppendImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanAppendImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanAppendImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d2b5c9b4398c4535737103ab9ebb9f7c2950cecb45f8a93bf6309fb7f28b1b1c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanAppendImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanAppendImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanAppendImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b9654c6e4e0ee37990cbb264d3fcd230d790eec57930a5584dd7dfae2612fc0b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanAppendList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanAppendList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__92e115213b9ea18db04b9131a0b1a63d013b4a20a63e528f7bf7e7e81eb263dd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanAppendOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__835d869b942f0adfd23a4f497c658c68b3e301e1d9da1ef869d1f665c80d3179)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanAppendOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0308647608d51c74e907b18c46714cb81d2957f742c207076c6141f5122cc006)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5a80cf1e843b6c294cc0adcfc6664103506aae22e76adb86a4de6a25404f4487)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9898fb5aea30cf5229dec8e858aed89d9d69dbdf541d7960234d58725b64ad80)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanAppend]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanAppend]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanAppend]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__48fe93687a85af8455e5f9db3fc2475d05e0e8f742240889f145660f341cb40e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanAppendOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanAppendOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ca08247896cb4754aa2459705f7b3e79d711e3d1bfa4cb2fae24e9a71ef6c290)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanAppendImage()

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityPriority")
    def reset_gravity_priority(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityPriority", []))

    @jsii.member(jsii_name="resetGravityPriorityVar")
    def reset_gravity_priority_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityPriorityVar", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPreserveMinorDimension")
    def reset_preserve_minor_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPreserveMinorDimension", []))

    @jsii.member(jsii_name="resetPreserveMinorDimensionVar")
    def reset_preserve_minor_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPreserveMinorDimensionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanAppendImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanAppendImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityInput")
    def gravity_priority_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityPriorityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityVarInput")
    def gravity_priority_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityPriorityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanAppendImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanAppendImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionInput")
    def preserve_minor_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "preserveMinorDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionVarInput")
    def preserve_minor_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "preserveMinorDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d03fe6d838d67338de1d3afe672983746bb53418039a71e6736d1f9cb17568bf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityPriority")
    def gravity_priority(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityPriority"))

    @gravity_priority.setter
    def gravity_priority(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__045d1993a6ed1c5c2fb726981cafa59280eb3676779906648e4c405e3728f9cc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityPriority", value)

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityVar")
    def gravity_priority_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityPriorityVar"))

    @gravity_priority_var.setter
    def gravity_priority_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__155ffac8b8644edb526d0d23387ba06ba70c2190e344da02f67909c0d012f07c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityPriorityVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9c409ea66dd729ddcab996271ca7feef5a49ca29109b31a58d5b409513e634a0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimension")
    def preserve_minor_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "preserveMinorDimension"))

    @preserve_minor_dimension.setter
    def preserve_minor_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a2604b5f93d3c28fd9e302f368b4c7693c96ec457c498c39c8bb2b829ae19328)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "preserveMinorDimension", value)

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionVar")
    def preserve_minor_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "preserveMinorDimensionVar"))

    @preserve_minor_dimension_var.setter
    def preserve_minor_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5e7cc4442004ecb26ca8db97b81e04293dd8ab0ea7983043773da6e057030476)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "preserveMinorDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanAppend]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanAppend]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanAppend]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d38d01eb4d217f2932f1e54c3358283c1941daa071dbe0304872bcf4311fd98a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanAspectCrop",
    jsii_struct_bases=[],
    name_mapping={
        "allow_expansion": "allowExpansion",
        "allow_expansion_var": "allowExpansionVar",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanAspectCrop:
    def __init__(
        self,
        *,
        allow_expansion: typing.Optional[builtins.str] = None,
        allow_expansion_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_expansion: Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image. Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        :param allow_expansion_var: Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image. Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        :param height: The height term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The width term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        :param x_position: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__774f424cab3e0843c5320855dd8a75846e1232b1ca8cb36e744a27a669bfa4c9)
            check_type(argname="argument allow_expansion", value=allow_expansion, expected_type=type_hints["allow_expansion"])
            check_type(argname="argument allow_expansion_var", value=allow_expansion_var, expected_type=type_hints["allow_expansion_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if allow_expansion is not None:
            self._values["allow_expansion"] = allow_expansion
        if allow_expansion_var is not None:
            self._values["allow_expansion_var"] = allow_expansion_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def allow_expansion(self) -> typing.Optional[builtins.str]:
        '''Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image.

        Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        '''
        result = self._values.get("allow_expansion")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def allow_expansion_var(self) -> typing.Optional[builtins.str]:
        '''Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image.

        Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        '''
        result = self._values.get("allow_expansion_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanAspectCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanAspectCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanAspectCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a259dfec6f12153ea482a22b0ecd821c7fe50ea026f9fe68d6d085d75129a5a9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanAspectCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bf57f8f33581de351aa0e891ec406f6033f87ad13ef071cb00d9c904ae5b2e2f)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanAspectCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cea69f57b45075c37878b026fdb530d70d7f40cd0095844cd9633272fcaa4c49)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__44239932506e7f011e6ff57323e871cd8e6284bbd6e81e34cbb6d33b3244cd66)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aba6678759e179c18cbb750eda7e960f2a54d15ced4e458320f0cf6278db0825)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanAspectCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanAspectCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanAspectCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cac090c06e95d85088eda9d5da33ea6b9d07c11b5f999f0d85be794bbf5caedc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanAspectCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanAspectCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__845c0473dc39ade4f00129089d5492073c63070f7b978e95018c9a18c1cbcebb)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAllowExpansion")
    def reset_allow_expansion(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansion", []))

    @jsii.member(jsii_name="resetAllowExpansionVar")
    def reset_allow_expansion_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansionVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionInput")
    def allow_expansion_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVarInput")
    def allow_expansion_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansion")
    def allow_expansion(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansion"))

    @allow_expansion.setter
    def allow_expansion(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e740f93906f37448da4d4fef2cd41d2fa16c2d94643877886da4e12b4c63bb93)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansion", value)

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVar")
    def allow_expansion_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansionVar"))

    @allow_expansion_var.setter
    def allow_expansion_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b8456cd947c70bd6e56cf98d3e2a24ab963b110c3c3e9372e74d8dc155c60de8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansionVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1a7263013279b26ccab7171b774a78618c4136c6221af2da56a5a00da7ada9ce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3cce2a23ac75a1f971113cffcdb2e44c80843c9c5c094c81e8dd7f56a89bdc2a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ea84dd49cd6e0a2528abf7f275c856ded2167eb20a8f3afb348c3aa5dda1038)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ffbbbc3d6ab4b262536c2574ecbae2c75fb9fe5f5617c5448559879427fb1f8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5b2fb3ea2a87f1868e6c0993188eaa254c583288d3f5c8ce2a33f3c76203f77b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__46746295493e668201be0c4fa13b353ad58e1268d4e0e0fcf1a586719bb13d82)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__314502fe6fd61826019452f59a04bd4222166277b4bd4725cc662c6f121387eb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7cd531e74f0e1b714cec82cb8c4255bdd048a59265489ede4c5c9a56414fd98f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanAspectCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanAspectCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanAspectCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3120473ee6af33f3948d929feea8cf1c979984d94812edc8388bc46be3591900)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanBackgroundColor",
    jsii_struct_bases=[],
    name_mapping={"color": "color", "color_var": "colorVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanBackgroundColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5e7c3f8c8bfc7d35f64478983006c5e8da8ef6fce54468b2bef3d7273418e3fb)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanBackgroundColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanBackgroundColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanBackgroundColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f5ead3e5068262da60c6eeff22b6e4b712bd10dd068a5840051d36a3712e847c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanBackgroundColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4dad543fa4a7997cf64e926fdc92439928fad366c5d8746cc1f55c90f5ddae37)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanBackgroundColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5b846ff8f68d63c95dcc3c196ed71c5211c99f5fa5f9695e09bd4bcf19ee7546)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__91bcb2491309b175c68d9777eadc135cea42baca2c7b545d63daa77235a8e829)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f10740092a71511fbf1e985ef6d84dca8cf9c86942323adf1c18f73d97906cc5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanBackgroundColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanBackgroundColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e8a01270227d62f041c441a271106f5c694c26a1d2837ce55f09f1eaf81687f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanBackgroundColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanBackgroundColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ff94d356a91afb627a9ace4f9853dee71d4faa06ba1cec233d6140da9f580b80)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6ebd68a08980f6ebc58c6b3201f09c355a733d10b11c7882b801f870ece6cd59)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4444cf5ce02646d0b1851651400ec4de78269ace9930d9fd9dd9375494d2b0c0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanBackgroundColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanBackgroundColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanBackgroundColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d5feca942145a6d0d978656775c09c4a18c984fb5ee790322959ec6c5f116de7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanBlur",
    jsii_struct_bases=[],
    name_mapping={"sigma": "sigma", "sigma_var": "sigmaVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanBlur:
    def __init__(
        self,
        *,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param sigma: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__958e2324dcc485ec7f98aafc9b7f5475826d8b95bc65607184dc4f1e1ff58932)
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanBlur(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanBlurList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanBlurList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8e6a4f997b887d2b0b4cdca81c71d9f8388581f400b25b72e284487acc8456cf)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanBlurOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2b917662e82b0ffc48bd970b2636cbb7fdfb0e335cc6037d2aa363e66379d89a)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanBlurOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__89eac3fc0f636bcef4e37711bf8b5cad184a024f8d954b4ca140d347eaa388a5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb80e11f7572c99460f87a9c339313f78254f21fffbc9d9a7af80bf9923e31c2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2df1d96ea8181311e2f908e52ac69340004a50633cbe43110c573539a2e1d0fe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanBlur]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanBlur]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5a7144d6b02dfc669d4d3265657e124026a78623a402f0deb580916b7cded449)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanBlurOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanBlurOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e0c6d6d811863c0f431c9f46525922729c5462c4466b6e27b87a9fd826d28066)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9f034409798b9feb8d41095b2f4a220f34d9986180c44047a420ad3e47329feb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c24ba9806c92e31d8682770664d790a64a1477a5b2d2f829cf3fb979836fd55b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanBlur]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanBlur]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanBlur]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fb9d5021f0fc7c183a547c3ff7559f765750c64465fd3fc1c91b149b2069a0e4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanChromaKey",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_feather": "hueFeather",
        "hue_feather_var": "hueFeatherVar",
        "hue_tolerance": "hueTolerance",
        "hue_tolerance_var": "hueToleranceVar",
        "hue_var": "hueVar",
        "lightness_feather": "lightnessFeather",
        "lightness_feather_var": "lightnessFeatherVar",
        "lightness_tolerance": "lightnessTolerance",
        "lightness_tolerance_var": "lightnessToleranceVar",
        "saturation_feather": "saturationFeather",
        "saturation_feather_var": "saturationFeatherVar",
        "saturation_tolerance": "saturationTolerance",
        "saturation_tolerance_var": "saturationToleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanChromaKey:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_feather: typing.Optional[builtins.str] = None,
        hue_feather_var: typing.Optional[builtins.str] = None,
        hue_tolerance: typing.Optional[builtins.str] = None,
        hue_tolerance_var: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness_feather: typing.Optional[builtins.str] = None,
        lightness_feather_var: typing.Optional[builtins.str] = None,
        lightness_tolerance: typing.Optional[builtins.str] = None,
        lightness_tolerance_var: typing.Optional[builtins.str] = None,
        saturation_feather: typing.Optional[builtins.str] = None,
        saturation_feather_var: typing.Optional[builtins.str] = None,
        saturation_tolerance: typing.Optional[builtins.str] = None,
        saturation_tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_feather: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        :param hue_feather_var: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        :param hue_tolerance: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        :param hue_tolerance_var: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        :param hue_var: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness_feather: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        :param lightness_feather_var: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        :param lightness_tolerance: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        :param lightness_tolerance_var: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        :param saturation_feather: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        :param saturation_feather_var: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        :param saturation_tolerance: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        :param saturation_tolerance_var: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d316c0294fd1f907eb0ebaa73dacb3f4f942ef58594b5668d8075e11d1b53c49)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_feather", value=hue_feather, expected_type=type_hints["hue_feather"])
            check_type(argname="argument hue_feather_var", value=hue_feather_var, expected_type=type_hints["hue_feather_var"])
            check_type(argname="argument hue_tolerance", value=hue_tolerance, expected_type=type_hints["hue_tolerance"])
            check_type(argname="argument hue_tolerance_var", value=hue_tolerance_var, expected_type=type_hints["hue_tolerance_var"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness_feather", value=lightness_feather, expected_type=type_hints["lightness_feather"])
            check_type(argname="argument lightness_feather_var", value=lightness_feather_var, expected_type=type_hints["lightness_feather_var"])
            check_type(argname="argument lightness_tolerance", value=lightness_tolerance, expected_type=type_hints["lightness_tolerance"])
            check_type(argname="argument lightness_tolerance_var", value=lightness_tolerance_var, expected_type=type_hints["lightness_tolerance_var"])
            check_type(argname="argument saturation_feather", value=saturation_feather, expected_type=type_hints["saturation_feather"])
            check_type(argname="argument saturation_feather_var", value=saturation_feather_var, expected_type=type_hints["saturation_feather_var"])
            check_type(argname="argument saturation_tolerance", value=saturation_tolerance, expected_type=type_hints["saturation_tolerance"])
            check_type(argname="argument saturation_tolerance_var", value=saturation_tolerance_var, expected_type=type_hints["saturation_tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_feather is not None:
            self._values["hue_feather"] = hue_feather
        if hue_feather_var is not None:
            self._values["hue_feather_var"] = hue_feather_var
        if hue_tolerance is not None:
            self._values["hue_tolerance"] = hue_tolerance
        if hue_tolerance_var is not None:
            self._values["hue_tolerance_var"] = hue_tolerance_var
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness_feather is not None:
            self._values["lightness_feather"] = lightness_feather
        if lightness_feather_var is not None:
            self._values["lightness_feather_var"] = lightness_feather_var
        if lightness_tolerance is not None:
            self._values["lightness_tolerance"] = lightness_tolerance
        if lightness_tolerance_var is not None:
            self._values["lightness_tolerance_var"] = lightness_tolerance_var
        if saturation_feather is not None:
            self._values["saturation_feather"] = saturation_feather
        if saturation_feather_var is not None:
            self._values["saturation_feather_var"] = saturation_feather_var
        if saturation_tolerance is not None:
            self._values["saturation_tolerance"] = saturation_tolerance
        if saturation_tolerance_var is not None:
            self._values["saturation_tolerance_var"] = saturation_tolerance_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        '''
        result = self._values.get("hue_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        '''
        result = self._values.get("hue_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        '''
        result = self._values.get("hue_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        '''
        result = self._values.get("hue_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        '''
        result = self._values.get("lightness_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        '''
        result = self._values.get("lightness_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        '''
        result = self._values.get("lightness_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        '''
        result = self._values.get("lightness_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        '''
        result = self._values.get("saturation_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        '''
        result = self._values.get("saturation_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        '''
        result = self._values.get("saturation_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        result = self._values.get("saturation_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanChromaKey(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanChromaKeyList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanChromaKeyList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__56a279b91fbe772c228b46e0d4e56c4715182dd944f323789fb1459db23878a3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanChromaKeyOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__133269471f09ad994de529ce1a4cb1c259aac69dfe30d3887973078054bf13eb)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanChromaKeyOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f624b3c9cbcc349ad5acd4a00702577f1fbeb3dadc21ad7b9aa1b43207b93ec7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c6671b6c52eea298cdc84c32f6e9c9a2a17d1a4ed7043252282dab721523d8a9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a5a0742231df5da1eeb672ad1a27a5b1dd0cf88a8b447ed7b4e0ed8dba4dbe6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanChromaKey]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanChromaKey]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4afec55aa50fe4fa19579e196b94c72979b71091627be6479ff5a195b8f9715a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanChromaKeyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanChromaKeyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e1c90aa4c982a78a4a57f3425ee41844f78ae8c65d9a9bcefc05ad4369c469f7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueFeather")
    def reset_hue_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeather", []))

    @jsii.member(jsii_name="resetHueFeatherVar")
    def reset_hue_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeatherVar", []))

    @jsii.member(jsii_name="resetHueTolerance")
    def reset_hue_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueTolerance", []))

    @jsii.member(jsii_name="resetHueToleranceVar")
    def reset_hue_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueToleranceVar", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightnessFeather")
    def reset_lightness_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeather", []))

    @jsii.member(jsii_name="resetLightnessFeatherVar")
    def reset_lightness_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeatherVar", []))

    @jsii.member(jsii_name="resetLightnessTolerance")
    def reset_lightness_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessTolerance", []))

    @jsii.member(jsii_name="resetLightnessToleranceVar")
    def reset_lightness_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessToleranceVar", []))

    @jsii.member(jsii_name="resetSaturationFeather")
    def reset_saturation_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeather", []))

    @jsii.member(jsii_name="resetSaturationFeatherVar")
    def reset_saturation_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeatherVar", []))

    @jsii.member(jsii_name="resetSaturationTolerance")
    def reset_saturation_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationTolerance", []))

    @jsii.member(jsii_name="resetSaturationToleranceVar")
    def reset_saturation_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherInput")
    def hue_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVarInput")
    def hue_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceInput")
    def hue_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVarInput")
    def hue_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherInput")
    def lightness_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVarInput")
    def lightness_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceInput")
    def lightness_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVarInput")
    def lightness_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherInput")
    def saturation_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVarInput")
    def saturation_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceInput")
    def saturation_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVarInput")
    def saturation_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7e29f75686875788377b20758bc806a901c579eed72649617cc11e39029cd4b3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeather")
    def hue_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeather"))

    @hue_feather.setter
    def hue_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__429efd1a2737e2d32ed03f7a84940ebf60ed0ec8f5011fe6b921b8eb2d9adc0d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeather", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVar")
    def hue_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeatherVar"))

    @hue_feather_var.setter
    def hue_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b932691491842d5b6fe3ff28b787b30c8de563919a797b5650fafb9d5eef689a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueTolerance")
    def hue_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueTolerance"))

    @hue_tolerance.setter
    def hue_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__39bad9764ff6bd1d307980958bc067ef5cbea8b735101473378225f86e2dcbc8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVar")
    def hue_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueToleranceVar"))

    @hue_tolerance_var.setter
    def hue_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fd14960e5a240602755938f8ea0108d98f8521478f03390388bbad9b15da3e3c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f44d5694a3dbfe006704f64fb8de913a22cf43981c1db2a9e622dbb2789bb7d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeather")
    def lightness_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeather"))

    @lightness_feather.setter
    def lightness_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a12079d530f9b080d994b7cf9629d52b8e0871be99c87a5a1efb73a50aaaf620)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeather", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVar")
    def lightness_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeatherVar"))

    @lightness_feather_var.setter
    def lightness_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__558c69812862dea770458092a081166146ba7ff6c8f60e8d5caea898f83e12b9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessTolerance")
    def lightness_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessTolerance"))

    @lightness_tolerance.setter
    def lightness_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__970f59084cb7b0bc21e114c7cfd7762e1bca94482c6eb517b08c57c8cdc34d3b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVar")
    def lightness_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessToleranceVar"))

    @lightness_tolerance_var.setter
    def lightness_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d03600ad45b047ddd52d1dd1d236e68d99306c5ffc1c8c5043a7436240024abd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeather")
    def saturation_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeather"))

    @saturation_feather.setter
    def saturation_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5a71a33671c3a7e423413504e1c324fb8e991bcf4d92c0c5ebf994f86e59aafc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeather", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVar")
    def saturation_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeatherVar"))

    @saturation_feather_var.setter
    def saturation_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4bbbf230f78c28d105dda66218c7c83947df4a10a8f494aaf467677d4bcf1c8f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationTolerance")
    def saturation_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationTolerance"))

    @saturation_tolerance.setter
    def saturation_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9db0f4110d1f5529d8e8598bd22e1ec05052127b59b60edc48c0f839c6dbcb0b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVar")
    def saturation_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationToleranceVar"))

    @saturation_tolerance_var.setter
    def saturation_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c1f4478a57427121cb3d9801b402523a749dd579fa90c33fb8392ecd380ac0d1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanChromaKey]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanChromaKey]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanChromaKey]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f3ae401d4ab815910a375adb0cefb56b109de7adc85979a23ff055d85ae935ce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanComposite",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "placement": "placement",
        "placement_var": "placementVar",
        "scale": "scale",
        "scale_dimension": "scaleDimension",
        "scale_dimension_var": "scaleDimensionVar",
        "scale_var": "scaleVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanComposite:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanCompositeImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        placement: typing.Optional[builtins.str] = None,
        placement_var: typing.Optional[builtins.str] = None,
        scale: typing.Optional[builtins.str] = None,
        scale_dimension: typing.Optional[builtins.str] = None,
        scale_dimension_var: typing.Optional[builtins.str] = None,
        scale_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param placement: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        :param placement_var: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        :param scale: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param scale_dimension: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        :param scale_dimension_var: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        :param scale_var: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        :param x_position: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanCompositeImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4b8ad2df589c3c9e480af3552e2f63900346a129220fafcc3816ef87e75988df)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument placement", value=placement, expected_type=type_hints["placement"])
            check_type(argname="argument placement_var", value=placement_var, expected_type=type_hints["placement_var"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument scale_dimension", value=scale_dimension, expected_type=type_hints["scale_dimension"])
            check_type(argname="argument scale_dimension_var", value=scale_dimension_var, expected_type=type_hints["scale_dimension_var"])
            check_type(argname="argument scale_var", value=scale_var, expected_type=type_hints["scale_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if placement is not None:
            self._values["placement"] = placement
        if placement_var is not None:
            self._values["placement_var"] = placement_var
        if scale is not None:
            self._values["scale"] = scale
        if scale_dimension is not None:
            self._values["scale_dimension"] = scale_dimension
        if scale_dimension_var is not None:
            self._values["scale_dimension_var"] = scale_dimension_var
        if scale_var is not None:
            self._values["scale_var"] = scale_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanCompositeImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanCompositeImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        '''
        result = self._values.get("placement")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement_var(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        '''
        result = self._values.get("placement_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        '''
        result = self._values.get("scale_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        '''
        result = self._values.get("scale_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        '''
        result = self._values.get("scale_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanComposite(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanCompositeImage",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanCompositeImage:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanCompositeImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanCompositeImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanCompositeImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a04d2df68fdaeaf80a3307f3b2b489d2324209995f2597c49af1d313fac762b0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanCompositeImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanCompositeImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3450c20fcf422c059473580c9d9682761b5f9d40ee7acd344cfcd60004863589)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanCompositeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanCompositeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5d907be745d9eb993885b42296472d7023dfad5051f1f2314ae7707a73b807c0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanCompositeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2003cc41312bce9179489de93acd562627a94f687d57fb8c224622f0e1c0b8bb)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanCompositeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ce303ff5eebb30f9fa040135807e4d1f6a850b3997ae1c03878f8e44d8a27092)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea4f9e9eb6cf9cb6f0b8a08c633df2077830e21682c15f05a2e4cae34d1eaff7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b83b09c2183ecfa7c81f075028a101efb26e41912d9434a3b07a59becba03101)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanComposite]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanComposite]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__684ca8e2f430ce8c6817d7f99ead19d1d8764b1ccb7eb871b4a627153f055822)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanCompositeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanCompositeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ef73f1c8e531d3a229de7c4c9e63daff310e42e23a5acd60e2101fcf726e62f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanCompositeImage()

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPlacement")
    def reset_placement(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacement", []))

    @jsii.member(jsii_name="resetPlacementVar")
    def reset_placement_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacementVar", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetScaleDimension")
    def reset_scale_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimension", []))

    @jsii.member(jsii_name="resetScaleDimensionVar")
    def reset_scale_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimensionVar", []))

    @jsii.member(jsii_name="resetScaleVar")
    def reset_scale_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanCompositeImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanCompositeImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanCompositeImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="placementInput")
    def placement_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementInput"))

    @builtins.property
    @jsii.member(jsii_name="placementVarInput")
    def placement_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionInput")
    def scale_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVarInput")
    def scale_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleVarInput")
    def scale_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__115fa99fa0252f00cd39d3597f6f7899554175b3aa5ce8f42349b94fa21d8078)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9336116985b06af7131306fa165bf7faa89aadee974e615af42a2dd8d86cde7f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="placement")
    def placement(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placement"))

    @placement.setter
    def placement(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d490a618c3a39c913f955ebdfe529042f94c15f820e1ae441b1ae86892ad889)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placement", value)

    @builtins.property
    @jsii.member(jsii_name="placementVar")
    def placement_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placementVar"))

    @placement_var.setter
    def placement_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__19feef45bc5302d68edbbd44509281184e683f6198dd505a35e7b8008ff35f28)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placementVar", value)

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scale"))

    @scale.setter
    def scale(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__01bd62df5808de0d2df251b4e00c9622e2de7f3d5ad8031ab0f427d3169c07d3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scale", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimension")
    def scale_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimension"))

    @scale_dimension.setter
    def scale_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6296a34176d61cfe0c81fddb6481d0b5ebd65a0c9f93860d7de73590046a680d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimension", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVar")
    def scale_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimensionVar"))

    @scale_dimension_var.setter
    def scale_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__821725068da91f3752205402f0ca873cc062b287940e08f77fb6b50845669dc5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="scaleVar")
    def scale_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleVar"))

    @scale_var.setter
    def scale_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1c059354cc0649f2fa01e34c3ca15455e1f1abaedba4b68ec8ed55c5457cb01d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ef2db8de286873603da01d6af729d0f014fcc250327d05ada42c5fe3f273c5d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dd024459463bbb99a6419586950ca00a1cbc80edbcdf4768a8526fb2fde300c2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cde29b2d4caee60e9e6f9f42f07a3046b0a927b7798d227a38ab07308f102047)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0a6636bfce2b5a70c379a5298578b36ca2a53de9e749dbfead0e0a5f9c7438e3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanComposite]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanComposite]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanComposite]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__74b2116d188cbad585ced20089d7d468b0a9524c4f2d56d6d8ffa4de5148ef2d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanCompound",
    jsii_struct_bases=[],
    name_mapping={"transformations": "transformations"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanCompound:
    def __init__(
        self,
        *,
        transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param transformations: transformations block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__238495b04a8f8303be527f188bd6b833fd34123a599c887da9049fdaef15bfec)
            check_type(argname="argument transformations", value=transformations, expected_type=type_hints["transformations"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if transformations is not None:
            self._values["transformations"] = transformations

    @builtins.property
    def transformations(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanCompoundTransformations"]]]:
        '''transformations block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        result = self._values.get("transformations")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanCompoundTransformations"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanCompound(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanCompoundList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanCompoundList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1529a1cface0253d383d5cc41ec8107dae5359584b5d065b08fd9e8bd629ab89)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanCompoundOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f0552e806327ce5afb1db7f73f11af14c49f718dd4e25ca52d67685f6da2cdf8)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanCompoundOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e7edf126f56b1c8130ac34f05c08811ae7a3cf60e6d50984d6c3b44c260fdc8c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ce10b247411568556e85f5b32ef36585b871f35325a78936009008fad6d08013)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__974575af38ea3d2e7681ccaa514d1cc959308bca653facf033ca189d418a0cfb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanCompound]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanCompound]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c795a0b965790fc5aec98295c0c40fa03611824735538dbe51bad92abdd00ced)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanCompoundOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanCompoundOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__25ef08035168481b989c5b230ba0aee5b3ca7325b29629bcb6addd3266d8db58)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformations")
    def put_transformations(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eb2030bc80fd4abae01d58d6a3fbbf44ba258ec08eec28d681d92731662893b7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTransformations", [value]))

    @jsii.member(jsii_name="resetTransformations")
    def reset_transformations(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformations", []))

    @builtins.property
    @jsii.member(jsii_name="transformations")
    def transformations(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanCompoundTransformationsList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanCompoundTransformationsList", jsii.get(self, "transformations"))

    @builtins.property
    @jsii.member(jsii_name="transformationsInput")
    def transformations_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanCompoundTransformations"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanCompoundTransformations"]]], jsii.get(self, "transformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanCompound]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanCompound]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanCompound]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__43019f488a54dd6a110885ff8003ea211ba7415c01d69f434705f72cbb6ed9a6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanCompoundTransformations",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanCompoundTransformations:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanCompoundTransformations(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanCompoundTransformationsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanCompoundTransformationsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cc0d39360f12e1c6f752daf59b90ce61c4a79b2a315aaa0edf26d8f686c64caa)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanCompoundTransformationsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0997e089367875fbecdd63d4e97c8b9f399b37ee760091ea84cb9b41b4e54d5a)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanCompoundTransformationsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9bb446f0e1882056f5f424832aa7a4e72263d2d5b70114276aa76cfedd578486)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0c37231232c03c92f3affcbb46528ef0851cf6aab80bd39c2ae36bef1a1779f0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e6bba85e4738490f8cacbc79eb937aef9989d4c50c1bdea85578f40dd4ef9ee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanCompoundTransformations]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanCompoundTransformations]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanCompoundTransformations]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f46125f620a2380c050a4b873f8cc310baf326b0f9907ac7a4594197ecc4939)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanCompoundTransformationsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanCompoundTransformationsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d857bb9ce5e116e16697a21e44458db9dcb17993e2b179679290bfde32751b33)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanCompoundTransformations]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanCompoundTransformations]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanCompoundTransformations]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__764f69bd099ebbe624790ca4bcef0db2a9a67e226e930df4a13b356d77fcf7e2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanContrast",
    jsii_struct_bases=[],
    name_mapping={
        "brightness": "brightness",
        "brightness_var": "brightnessVar",
        "contrast": "contrast",
        "contrast_var": "contrastVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanContrast:
    def __init__(
        self,
        *,
        brightness: typing.Optional[builtins.str] = None,
        brightness_var: typing.Optional[builtins.str] = None,
        contrast: typing.Optional[builtins.str] = None,
        contrast_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param brightness: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        :param brightness_var: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        :param contrast: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param contrast_var: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f7fd1507fc8502d6d05b1af73b46f104fcff72c8c01464e9250086f5576b37b1)
            check_type(argname="argument brightness", value=brightness, expected_type=type_hints["brightness"])
            check_type(argname="argument brightness_var", value=brightness_var, expected_type=type_hints["brightness_var"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument contrast_var", value=contrast_var, expected_type=type_hints["contrast_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if brightness is not None:
            self._values["brightness"] = brightness
        if brightness_var is not None:
            self._values["brightness_var"] = brightness_var
        if contrast is not None:
            self._values["contrast"] = contrast
        if contrast_var is not None:
            self._values["contrast_var"] = contrast_var

    @builtins.property
    def brightness(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        '''
        result = self._values.get("brightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def brightness_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        '''
        result = self._values.get("brightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        result = self._values.get("contrast_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanContrast(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanContrastList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanContrastList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5da8747de766bb7ef30bbc874611e2f56198fae275f86204619ab413c8bfeef1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanContrastOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__67f6cdd7ae447837b088b39c0b9e0b3764de6a52d0ae8745454570efa9b87cf5)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanContrastOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1fd394242c8919a388ba675f649af6f846d15fbf2da2f08d57cb311c94b722ee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e34dd11b1ec3eb58db8507f8abf94fb4fdf9bbdb93e2fc6ef06c58b62dcbedde)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__65979fd5e0c927c726a0edad3f69199c22e3d354c64eb1d3bda9e67d7b74f9a8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanContrast]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanContrast]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ba7a0f80611140746f2f394ed239efc2feb86d5b758cc1f739bf82e7e59e2097)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanContrastOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanContrastOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__127a0d3d2276fd5976737b051226050b3def232af7b6ef3536fb54f27a3c592f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetBrightness")
    def reset_brightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightness", []))

    @jsii.member(jsii_name="resetBrightnessVar")
    def reset_brightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightnessVar", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetContrastVar")
    def reset_contrast_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrastVar", []))

    @builtins.property
    @jsii.member(jsii_name="brightnessInput")
    def brightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="brightnessVarInput")
    def brightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastVarInput")
    def contrast_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="brightness")
    def brightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightness"))

    @brightness.setter
    def brightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__efdaaa49e9258434b8bd631b45d27cd053d07d2519616ebffd68b2d5c5bd7833)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightness", value)

    @builtins.property
    @jsii.member(jsii_name="brightnessVar")
    def brightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightnessVar"))

    @brightness_var.setter
    def brightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2b17fdfe73884e58783d38cf3f52bed597f7846422cbff1538025da8e90a4f70)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrast"))

    @contrast.setter
    def contrast(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a2f70e874e8bc1b922c001e306fdd1ae009938203f5ceb4375ea4cb5b0605f37)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrast", value)

    @builtins.property
    @jsii.member(jsii_name="contrastVar")
    def contrast_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrastVar"))

    @contrast_var.setter
    def contrast_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d4f7e64b305681a3e96bdcd3ab86f6a42b996b2198e7beeb2c0b561963477c0f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrastVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanContrast]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanContrast]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanContrast]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d1fa9b3c57c20ab86ac3fa440a4ab0902055ea1ed5d91d70c006c20edd88d93)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanCrop",
    jsii_struct_bases=[],
    name_mapping={
        "allow_expansion": "allowExpansion",
        "allow_expansion_var": "allowExpansionVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanCrop:
    def __init__(
        self,
        *,
        allow_expansion: typing.Optional[builtins.str] = None,
        allow_expansion_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_expansion: If cropping an area outside of the existing canvas, expands the image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        :param allow_expansion_var: If cropping an area outside of the existing canvas, expands the image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        :param gravity: Frame of reference for X and Y Positions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Frame of reference for X and Y Positions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The number of pixels to crop along the y-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The number of pixels to crop along the y-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The number of pixels to crop along the x-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The number of pixels to crop along the x-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        :param x_position: The x-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3fc42a60fe06870c9246ed5e6a550ffea0493e59f8d81af186324ca9c2310ee4)
            check_type(argname="argument allow_expansion", value=allow_expansion, expected_type=type_hints["allow_expansion"])
            check_type(argname="argument allow_expansion_var", value=allow_expansion_var, expected_type=type_hints["allow_expansion_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if allow_expansion is not None:
            self._values["allow_expansion"] = allow_expansion
        if allow_expansion_var is not None:
            self._values["allow_expansion_var"] = allow_expansion_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def allow_expansion(self) -> typing.Optional[builtins.str]:
        '''If cropping an area outside of the existing canvas, expands the image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        '''
        result = self._values.get("allow_expansion")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def allow_expansion_var(self) -> typing.Optional[builtins.str]:
        '''If cropping an area outside of the existing canvas, expands the image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        '''
        result = self._values.get("allow_expansion_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Frame of reference for X and Y Positions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Frame of reference for X and Y Positions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the y-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the y-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the x-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the x-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fe9803cf97db93c9f06022406eb5e64a1f57ba640e0481ffd807863782a25ae7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__48bd57648fdbd980f7764ad49e35dc3ee9be502c145e73fb466bba58a9d12f1e)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__76e0f5f76380ee675854b7fdf0c5b7fcd136342345619311ebdbdfeef458995d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__49c0f699de70a0aca8333b48f7d5e2fa8e64ce5d6540d82f0e9b4bea6e6b8962)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__28e3614fe44561090e3063e7a14b8d743f5d4964e1963b34d2ed57dfefe7b411)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e3b906ce4e91eed4147d3e063fa32c6f663544b1bdb1aba6cd662a7317d664d6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df5832d09ba288ef52afc8262e2d69b5c221166508dd6be39689e72aac97cf84)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAllowExpansion")
    def reset_allow_expansion(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansion", []))

    @jsii.member(jsii_name="resetAllowExpansionVar")
    def reset_allow_expansion_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansionVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionInput")
    def allow_expansion_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVarInput")
    def allow_expansion_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansion")
    def allow_expansion(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansion"))

    @allow_expansion.setter
    def allow_expansion(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__132be510eed46153649a2bec03f59ffc6b85fca9df90ea8f4c502f9c6e9110e9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansion", value)

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVar")
    def allow_expansion_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansionVar"))

    @allow_expansion_var.setter
    def allow_expansion_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b4a8da753464af34912131489361f3e72c997c05456e10c8be7fa4700d3e447f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansionVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6c9eab9e32417139d119df7650c6450da3f7c11248343d4f222c0d9e24bac657)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b67705a4b915e1949d1ed649b97d65d1949807a0f301289aae3f89ebdfac215b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cb64d73ca37b01b967926a9ff5e6aa30e047203a1e5417c781be99eb6db8776c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b7a565508833c5a97ca87bdb73d0fb68a890dc1422a67e1b4f5ab861e90d0bae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1673927669dc7a31af072eb092721759dccf34a25597095d76a1b1001d64c3ce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a7e40fd1a0827546e6643404ac5409341c821483a95e9caa6ba121a2df960a52)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f5b57464fe233ee274ad9bfc997786afb1913b0dcaea2dc6232553b5e78b28b5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b2267b61ab02d63268817d01aca326a48cf1b0c6911c5e5544131a0992bf1734)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__72a640e6061ac04a94a36139b482e58bf08894acb0fc64e4b9344b9c002ac811)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__42bd74f276abaeeea0c6dbfd77b05e2927044f9b0af6874883ae1a7a9b0b929c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0f5a946c3f4c9af6c6b1b45d4c8b9fa8c9376f24c81a169d9abed5c89e01444c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanFaceCrop",
    jsii_struct_bases=[],
    name_mapping={
        "algorithm": "algorithm",
        "algorithm_var": "algorithmVar",
        "confidence": "confidence",
        "confidence_var": "confidenceVar",
        "fail_gravity": "failGravity",
        "fail_gravity_var": "failGravityVar",
        "focus": "focus",
        "focus_var": "focusVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "padding": "padding",
        "padding_var": "paddingVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanFaceCrop:
    def __init__(
        self,
        *,
        algorithm: typing.Optional[builtins.str] = None,
        algorithm_var: typing.Optional[builtins.str] = None,
        confidence: typing.Optional[builtins.str] = None,
        confidence_var: typing.Optional[builtins.str] = None,
        fail_gravity: typing.Optional[builtins.str] = None,
        fail_gravity_var: typing.Optional[builtins.str] = None,
        focus: typing.Optional[builtins.str] = None,
        focus_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param algorithm: Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm DataAkamaiImagingPolicyImage#algorithm}
        :param algorithm_var: Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm_var DataAkamaiImagingPolicyImage#algorithm_var}
        :param confidence: With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image. Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence DataAkamaiImagingPolicyImage#confidence}
        :param confidence_var: With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image. Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence_var DataAkamaiImagingPolicyImage#confidence_var}
        :param fail_gravity: Controls placement of the crop if Image and Video Manager does not detect any faces in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        :param fail_gravity_var: Controls placement of the crop if Image and Video Manager does not detect any faces in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        :param focus: Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus DataAkamaiImagingPolicyImage#focus}
        :param focus_var: Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus_var DataAkamaiImagingPolicyImage#focus_var}
        :param gravity: Controls placement of the crop. Directions are relative to the face(s) plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Controls placement of the crop. Directions are relative to the face(s) plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param padding: The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        :param style: Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c4a1178bc9d56dc5027320215b93dcd4252b1ce851aef4c23c7aa35756f13470)
            check_type(argname="argument algorithm", value=algorithm, expected_type=type_hints["algorithm"])
            check_type(argname="argument algorithm_var", value=algorithm_var, expected_type=type_hints["algorithm_var"])
            check_type(argname="argument confidence", value=confidence, expected_type=type_hints["confidence"])
            check_type(argname="argument confidence_var", value=confidence_var, expected_type=type_hints["confidence_var"])
            check_type(argname="argument fail_gravity", value=fail_gravity, expected_type=type_hints["fail_gravity"])
            check_type(argname="argument fail_gravity_var", value=fail_gravity_var, expected_type=type_hints["fail_gravity_var"])
            check_type(argname="argument focus", value=focus, expected_type=type_hints["focus"])
            check_type(argname="argument focus_var", value=focus_var, expected_type=type_hints["focus_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if algorithm is not None:
            self._values["algorithm"] = algorithm
        if algorithm_var is not None:
            self._values["algorithm_var"] = algorithm_var
        if confidence is not None:
            self._values["confidence"] = confidence
        if confidence_var is not None:
            self._values["confidence_var"] = confidence_var
        if fail_gravity is not None:
            self._values["fail_gravity"] = fail_gravity
        if fail_gravity_var is not None:
            self._values["fail_gravity_var"] = fail_gravity_var
        if focus is not None:
            self._values["focus"] = focus
        if focus_var is not None:
            self._values["focus_var"] = focus_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def algorithm(self) -> typing.Optional[builtins.str]:
        '''Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm DataAkamaiImagingPolicyImage#algorithm}
        '''
        result = self._values.get("algorithm")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def algorithm_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm_var DataAkamaiImagingPolicyImage#algorithm_var}
        '''
        result = self._values.get("algorithm_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def confidence(self) -> typing.Optional[builtins.str]:
        '''With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image.

        Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence DataAkamaiImagingPolicyImage#confidence}
        '''
        result = self._values.get("confidence")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def confidence_var(self) -> typing.Optional[builtins.str]:
        '''With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image.

        Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence_var DataAkamaiImagingPolicyImage#confidence_var}
        '''
        result = self._values.get("confidence_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any faces in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        '''
        result = self._values.get("fail_gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any faces in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        '''
        result = self._values.get("fail_gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def focus(self) -> typing.Optional[builtins.str]:
        '''Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus DataAkamaiImagingPolicyImage#focus}
        '''
        result = self._values.get("focus")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def focus_var(self) -> typing.Optional[builtins.str]:
        '''Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus_var DataAkamaiImagingPolicyImage#focus_var}
        '''
        result = self._values.get("focus_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the face(s) plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the face(s) plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanFaceCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanFaceCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanFaceCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4017694418c10fc72956c9b74cdb341f5a8dff6bcde3f0c9d052a0ae77301d95)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanFaceCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b428764f224d466907b0507e03aa3a8138114b6c71227dd099447a59c8cab8ec)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanFaceCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__20bbf6e57f64336d5a47329fefd678afbc2b132dd355d1d982da59c8f39a3665)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e0fbbc9acb6b13172b50ec323b83848289b87c9ea40c490cff7368fae31375f9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__80920fc71249b9bc7135f65a587ebba46a57abbcbb93d2fc988d485a89816b08)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanFaceCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanFaceCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanFaceCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f81fab5cb695f6cd376ab7bc1227079dc6e0dfdda0078385c04f4e7ed2303096)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanFaceCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanFaceCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__84e7e82ace88df8f5221fb013b221a28e7b3f43cc6b0648c9c46dd8c61045c73)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAlgorithm")
    def reset_algorithm(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAlgorithm", []))

    @jsii.member(jsii_name="resetAlgorithmVar")
    def reset_algorithm_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAlgorithmVar", []))

    @jsii.member(jsii_name="resetConfidence")
    def reset_confidence(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetConfidence", []))

    @jsii.member(jsii_name="resetConfidenceVar")
    def reset_confidence_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetConfidenceVar", []))

    @jsii.member(jsii_name="resetFailGravity")
    def reset_fail_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravity", []))

    @jsii.member(jsii_name="resetFailGravityVar")
    def reset_fail_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravityVar", []))

    @jsii.member(jsii_name="resetFocus")
    def reset_focus(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFocus", []))

    @jsii.member(jsii_name="resetFocusVar")
    def reset_focus_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFocusVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="algorithmInput")
    def algorithm_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "algorithmInput"))

    @builtins.property
    @jsii.member(jsii_name="algorithmVarInput")
    def algorithm_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "algorithmVarInput"))

    @builtins.property
    @jsii.member(jsii_name="confidenceInput")
    def confidence_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "confidenceInput"))

    @builtins.property
    @jsii.member(jsii_name="confidenceVarInput")
    def confidence_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "confidenceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityInput")
    def fail_gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityVarInput")
    def fail_gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="focusInput")
    def focus_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "focusInput"))

    @builtins.property
    @jsii.member(jsii_name="focusVarInput")
    def focus_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "focusVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="algorithm")
    def algorithm(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "algorithm"))

    @algorithm.setter
    def algorithm(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ded0d1dfb0454e52e73e965b0cd0e8d17728a9782d43799974f8ee93459f6c07)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "algorithm", value)

    @builtins.property
    @jsii.member(jsii_name="algorithmVar")
    def algorithm_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "algorithmVar"))

    @algorithm_var.setter
    def algorithm_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9cc25b4cebeffb2330e7b70417ab312450e74a43c30ae6ad1ea1f69d66d91db2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "algorithmVar", value)

    @builtins.property
    @jsii.member(jsii_name="confidence")
    def confidence(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "confidence"))

    @confidence.setter
    def confidence(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1c96c34e68f71a7ccdd0b847fc1ac2dd6fe898bfca769217d93b7bbe2ee6a32d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "confidence", value)

    @builtins.property
    @jsii.member(jsii_name="confidenceVar")
    def confidence_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "confidenceVar"))

    @confidence_var.setter
    def confidence_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2e5e4b48de215eb72ae89721ced65eb4f872d189fb9104c163f7ca5af91d7508)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "confidenceVar", value)

    @builtins.property
    @jsii.member(jsii_name="failGravity")
    def fail_gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravity"))

    @fail_gravity.setter
    def fail_gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3c66fbb8fe8c3d40bb3a09cf16e40edcafc46dd7ee84995196ad822bf3468452)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravity", value)

    @builtins.property
    @jsii.member(jsii_name="failGravityVar")
    def fail_gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravityVar"))

    @fail_gravity_var.setter
    def fail_gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9321950812a485b9af268cfc3dd8aeedcd2b3c864a401aadb61bf8fe28dfde29)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="focus")
    def focus(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "focus"))

    @focus.setter
    def focus(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__663958387ac891ac1c0bfb802dc6217964d323cbfc1da49b59ca7845c490dcec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "focus", value)

    @builtins.property
    @jsii.member(jsii_name="focusVar")
    def focus_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "focusVar"))

    @focus_var.setter
    def focus_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__12dead64fa311c38e073b7bcb3336d0c82c617f2a08e8fafd6da928e2c2c91d6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "focusVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__74ef29963e73fd3d8c7bc2144bcfc13a9a5992b47ccd24fba1b43d67176a4d2b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e7b935fa897d5f1f4c1c6b9f2679686e4b847dd1f104859714a480aa69d873b7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7fc7859daef2a4351561798e498078ebaf46e5620fda468b3711c8ff9d65dd03)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e3d92a021ce619a9781de58b7be31a60c807b8cc017e167771bd7bc01210e4da)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f56a10a432ef4887753a5901731beb39030256bfe07ed7d69e12a3f196382f43)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__08bf41f7cf885510b09155763914edf74fa22660e49f89788e5d72831263f51c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__523bab9ae03544d8557f2c845c3d3294bccf060a5c2fc969f2c0181af625308c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7ad1804a95111a2468d8dcb4e84fb47235b30ee193459629aa27f12a5513625a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2f466df3f4e5698100d6b10f3a235700f5499b5910eb47a46e3090fa7c114262)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0193fbedcf78177b22610b6b16fd67b390e88ccbee4d88e931f576fe531753f3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanFaceCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanFaceCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanFaceCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fee0e4fe25e2ea29760d88e828f66b1635dbf5dc277ad0b0e828b965f466e011)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanFeatureCrop",
    jsii_struct_bases=[],
    name_mapping={
        "fail_gravity": "failGravity",
        "fail_gravity_var": "failGravityVar",
        "feature_radius": "featureRadius",
        "feature_radius_var": "featureRadiusVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "max_features": "maxFeatures",
        "max_features_var": "maxFeaturesVar",
        "min_feature_quality": "minFeatureQuality",
        "min_feature_quality_var": "minFeatureQualityVar",
        "padding": "padding",
        "padding_var": "paddingVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanFeatureCrop:
    def __init__(
        self,
        *,
        fail_gravity: typing.Optional[builtins.str] = None,
        fail_gravity_var: typing.Optional[builtins.str] = None,
        feature_radius: typing.Optional[builtins.str] = None,
        feature_radius_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        max_features: typing.Optional[builtins.str] = None,
        max_features_var: typing.Optional[builtins.str] = None,
        min_feature_quality: typing.Optional[builtins.str] = None,
        min_feature_quality_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fail_gravity: Controls placement of the crop if Image and Video Manager does not detect any features in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        :param fail_gravity_var: Controls placement of the crop if Image and Video Manager does not detect any features in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        :param feature_radius: The size in pixels of the important features to search for. If identified, two features never appear closer together than this value, ``8.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius DataAkamaiImagingPolicyImage#feature_radius}
        :param feature_radius_var: The size in pixels of the important features to search for. If identified, two features never appear closer together than this value, ``8.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius_var DataAkamaiImagingPolicyImage#feature_radius_var}
        :param gravity: Controls placement of the crop. Directions are relative to the region of interest plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Controls placement of the crop. Directions are relative to the region of interest plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param max_features: The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features DataAkamaiImagingPolicyImage#max_features}
        :param max_features_var: The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features_var DataAkamaiImagingPolicyImage#max_features_var}
        :param min_feature_quality: Determines the minimum quality level of the feature identified. To consider a feature important, the feature needs to surpass this value. Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality DataAkamaiImagingPolicyImage#min_feature_quality}
        :param min_feature_quality_var: Determines the minimum quality level of the feature identified. To consider a feature important, the feature needs to surpass this value. Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality_var DataAkamaiImagingPolicyImage#min_feature_quality_var}
        :param padding: Adds space around the region of interest. The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: Adds space around the region of interest. The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        :param style: Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ed1688744c32ad3d7b680a02d73a7c139ae4c26e654119f10faaded221edd9df)
            check_type(argname="argument fail_gravity", value=fail_gravity, expected_type=type_hints["fail_gravity"])
            check_type(argname="argument fail_gravity_var", value=fail_gravity_var, expected_type=type_hints["fail_gravity_var"])
            check_type(argname="argument feature_radius", value=feature_radius, expected_type=type_hints["feature_radius"])
            check_type(argname="argument feature_radius_var", value=feature_radius_var, expected_type=type_hints["feature_radius_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument max_features", value=max_features, expected_type=type_hints["max_features"])
            check_type(argname="argument max_features_var", value=max_features_var, expected_type=type_hints["max_features_var"])
            check_type(argname="argument min_feature_quality", value=min_feature_quality, expected_type=type_hints["min_feature_quality"])
            check_type(argname="argument min_feature_quality_var", value=min_feature_quality_var, expected_type=type_hints["min_feature_quality_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fail_gravity is not None:
            self._values["fail_gravity"] = fail_gravity
        if fail_gravity_var is not None:
            self._values["fail_gravity_var"] = fail_gravity_var
        if feature_radius is not None:
            self._values["feature_radius"] = feature_radius
        if feature_radius_var is not None:
            self._values["feature_radius_var"] = feature_radius_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if max_features is not None:
            self._values["max_features"] = max_features
        if max_features_var is not None:
            self._values["max_features_var"] = max_features_var
        if min_feature_quality is not None:
            self._values["min_feature_quality"] = min_feature_quality
        if min_feature_quality_var is not None:
            self._values["min_feature_quality_var"] = min_feature_quality_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def fail_gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any features in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        '''
        result = self._values.get("fail_gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any features in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        '''
        result = self._values.get("fail_gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feature_radius(self) -> typing.Optional[builtins.str]:
        '''The size in pixels of the important features to search for.

        If identified, two features never appear closer together than this value, ``8.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius DataAkamaiImagingPolicyImage#feature_radius}
        '''
        result = self._values.get("feature_radius")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feature_radius_var(self) -> typing.Optional[builtins.str]:
        '''The size in pixels of the important features to search for.

        If identified, two features never appear closer together than this value, ``8.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius_var DataAkamaiImagingPolicyImage#feature_radius_var}
        '''
        result = self._values.get("feature_radius_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the region of interest plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the region of interest plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def max_features(self) -> typing.Optional[builtins.str]:
        '''The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features DataAkamaiImagingPolicyImage#max_features}
        '''
        result = self._values.get("max_features")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def max_features_var(self) -> typing.Optional[builtins.str]:
        '''The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features_var DataAkamaiImagingPolicyImage#max_features_var}
        '''
        result = self._values.get("max_features_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def min_feature_quality(self) -> typing.Optional[builtins.str]:
        '''Determines the minimum quality level of the feature identified.

        To consider a feature important, the feature needs to surpass this value.  Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality DataAkamaiImagingPolicyImage#min_feature_quality}
        '''
        result = self._values.get("min_feature_quality")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def min_feature_quality_var(self) -> typing.Optional[builtins.str]:
        '''Determines the minimum quality level of the feature identified.

        To consider a feature important, the feature needs to surpass this value.  Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality_var DataAkamaiImagingPolicyImage#min_feature_quality_var}
        '''
        result = self._values.get("min_feature_quality_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''Adds space around the region of interest.

        The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''Adds space around the region of interest.

        The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanFeatureCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanFeatureCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanFeatureCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1a3e2570efcb72754b6258010ae83abdc45087840d4b02ec620680a152616382)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanFeatureCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__71b93c5b545529496ae798728789651ac0407a472af9ea5fb1bb9f93a2410bba)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanFeatureCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2df658480efb2be23171c50daaea14cce2b4a2017a01eba4aa306555dfe146f2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2bc64106534d2ca0a885e9901e1854a638f67b7c705f240463f264f1aa519d63)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bafe1b16a0be4ec45052ea0edf57cf73e20937aa0e6ecec2c7da159e7c8dd24e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanFeatureCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanFeatureCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanFeatureCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dbbbe8409a30fa8b3dcb1cfdcd30341d2a5e4e53c61e6c0d3a20f67afa0cd857)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanFeatureCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanFeatureCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__79f0f983d98c66beb28b0af8817f4e7c3fad4830fd4462f5719ac9faec772fde)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetFailGravity")
    def reset_fail_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravity", []))

    @jsii.member(jsii_name="resetFailGravityVar")
    def reset_fail_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravityVar", []))

    @jsii.member(jsii_name="resetFeatureRadius")
    def reset_feature_radius(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureRadius", []))

    @jsii.member(jsii_name="resetFeatureRadiusVar")
    def reset_feature_radius_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureRadiusVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetMaxFeatures")
    def reset_max_features(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxFeatures", []))

    @jsii.member(jsii_name="resetMaxFeaturesVar")
    def reset_max_features_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxFeaturesVar", []))

    @jsii.member(jsii_name="resetMinFeatureQuality")
    def reset_min_feature_quality(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMinFeatureQuality", []))

    @jsii.member(jsii_name="resetMinFeatureQualityVar")
    def reset_min_feature_quality_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMinFeatureQualityVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="failGravityInput")
    def fail_gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityVarInput")
    def fail_gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featureRadiusInput")
    def feature_radius_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featureRadiusInput"))

    @builtins.property
    @jsii.member(jsii_name="featureRadiusVarInput")
    def feature_radius_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featureRadiusVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesInput")
    def max_features_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "maxFeaturesInput"))

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesVarInput")
    def max_features_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "maxFeaturesVarInput"))

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityInput")
    def min_feature_quality_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "minFeatureQualityInput"))

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityVarInput")
    def min_feature_quality_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "minFeatureQualityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravity")
    def fail_gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravity"))

    @fail_gravity.setter
    def fail_gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4535356f67f8505d546c3d4335bc5e82abd9fdf3060ffe2d39427faeae4667e9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravity", value)

    @builtins.property
    @jsii.member(jsii_name="failGravityVar")
    def fail_gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravityVar"))

    @fail_gravity_var.setter
    def fail_gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a816d51ba9772d192a37e5a8196c7b83e4c19996fdba5e24857b65942c6c3d6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="featureRadius")
    def feature_radius(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featureRadius"))

    @feature_radius.setter
    def feature_radius(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__06f32dfb0242eb72b49be66cddb4317dcb54b867d621966c95979726f4dc377b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featureRadius", value)

    @builtins.property
    @jsii.member(jsii_name="featureRadiusVar")
    def feature_radius_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featureRadiusVar"))

    @feature_radius_var.setter
    def feature_radius_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__38b9dc82329499464fe302b91e892f82d088cf9abf6ccf86ded5fafad19d02a6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featureRadiusVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b6a9dd92b1988861aae42d8d6fbde8e2670ffef5d6f3b81ab93ec8dbf528a1be)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__38711158b10cf87ae5b6ab361f07732098d67047c9504d9592bb02f965e60519)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a06ca2c6a1e144de40056e2aa156203d516813465fdcbe9bc0e704786130d47f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ec272d7068666545b259acb463ed2ba906f1263326fd43cb4631687cbbd9f7a4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="maxFeatures")
    def max_features(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "maxFeatures"))

    @max_features.setter
    def max_features(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9c379d89e474445b7f58f486b2f78a6e7847ab27177a4b856017683f72a60988)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "maxFeatures", value)

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesVar")
    def max_features_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "maxFeaturesVar"))

    @max_features_var.setter
    def max_features_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c5ca666d9ac30fffd9562b1927f4628a0ee2fd1805934d45648a72f80d202145)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "maxFeaturesVar", value)

    @builtins.property
    @jsii.member(jsii_name="minFeatureQuality")
    def min_feature_quality(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "minFeatureQuality"))

    @min_feature_quality.setter
    def min_feature_quality(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__29f46a0d6f16e934e2f3fa33b7414291509351305a4bc9c89398a1b17c331e99)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "minFeatureQuality", value)

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityVar")
    def min_feature_quality_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "minFeatureQualityVar"))

    @min_feature_quality_var.setter
    def min_feature_quality_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__59ea3036608db25d1a71143dd4f1663e524b7cb98e877008757ffaaf64fca53e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "minFeatureQualityVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__00cdf449c280747f39700d880369de0d182a82aad2c4cc6135b0959bd3ef67b6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__31e999e9b17adca328fde3ac234903dbdc792fc4ae237708e6aab7043f9fe203)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ec523d7d1776cf32237be3ea3f9ea6c05d8fcd9d4d37df96d3a3dc7690803c9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__02c5d58798d00ac7cedd551dc6ec61b55cacddbd8e53498282d91d8b6d070bf7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e9bc6834e487c373b0e9efccdbbc29bb1d5beddc284dc26341f36560d875c26b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cf3da6b1bebecfeecdd192c7941238bfca60951fa694d871ffc84dbb35291d5b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanFeatureCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanFeatureCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanFeatureCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a2346dad6741f8fa1eae24d32f56e8effeb0052e2dcdff92c0834719dbfba45)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanFitAndFill",
    jsii_struct_bases=[],
    name_mapping={
        "fill_transformation": "fillTransformation",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanFitAndFill:
    def __init__(
        self,
        *,
        fill_transformation: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanFitAndFillFillTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fill_transformation: fill_transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_transformation DataAkamaiImagingPolicyImage#fill_transformation}
        :param height: The height value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The width value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(fill_transformation, dict):
            fill_transformation = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanFitAndFillFillTransformation(**fill_transformation)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__983b7aa4f723b8c91c4cec291ad27a577301a82713f7d5acb6bd05c1e26222d6)
            check_type(argname="argument fill_transformation", value=fill_transformation, expected_type=type_hints["fill_transformation"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fill_transformation is not None:
            self._values["fill_transformation"] = fill_transformation
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def fill_transformation(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanFitAndFillFillTransformation"]:
        '''fill_transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_transformation DataAkamaiImagingPolicyImage#fill_transformation}
        '''
        result = self._values.get("fill_transformation")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanFitAndFillFillTransformation"], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanFitAndFill(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanFitAndFillFillTransformation",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanFitAndFillFillTransformation:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanFitAndFillFillTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanFitAndFillFillTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanFitAndFillFillTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__365e558033fff06b75541782918dce2273aaa25e9f6416e1c5ee768a83b1a62a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanFitAndFillFillTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanFitAndFillFillTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanFitAndFillFillTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9dc713775498a1425fa89e07641da22ffc48c5f9ca9e7ab3c58f053ce56721b7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanFitAndFillList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanFitAndFillList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab26bff4ceda1fba7d95cb80d0352dfbe552157a171aa789cb28c0d531c3517c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanFitAndFillOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6eda11c09a03e80858f9c056d69bc60e0b11f28d22ee5c7ebb0b5fba96f4aeaf)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanFitAndFillOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__293190615b86cf2b66dcf63132078584805cd839f7fa53b8f614d17a1a21f569)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__147a5f8816894d2cdbc8aaceb59a8d466461c684131e85b0a89832ac50a42b74)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__62b9a7bea321fc078815ee4705143fc812dd5088909d64568191b3d8c73c8589)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanFitAndFill]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanFitAndFill]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanFitAndFill]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__16c414720869b7d7dee34d5bab79e4beb571c4d8049e1dcdc4452b088d3829f1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanFitAndFillOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanFitAndFillOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f5d9192007ec1b8cd8ebeb628ee140806219064ec6258dea64c1f2bfcde7ae71)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putFillTransformation")
    def put_fill_transformation(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanFitAndFillFillTransformation()

        return typing.cast(None, jsii.invoke(self, "putFillTransformation", [value]))

    @jsii.member(jsii_name="resetFillTransformation")
    def reset_fill_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFillTransformation", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="fillTransformation")
    def fill_transformation(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanFitAndFillFillTransformationOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanFitAndFillFillTransformationOutputReference, jsii.get(self, "fillTransformation"))

    @builtins.property
    @jsii.member(jsii_name="fillTransformationInput")
    def fill_transformation_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanFitAndFillFillTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanFitAndFillFillTransformation], jsii.get(self, "fillTransformationInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e4c919f486e82dcee9d14ec97a1de8107cc7360d02fe8759c856cda5da983ed4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e27fc5856f07dc6b7c63a57b519e72cad34eef14d0467061cdbf3b87f3ee4d4e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7f7f54c40068cf55d96ed9f3db310bec4ac3e14bc46159cae422ae64fbf33218)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df193d2fa15d11832f3e8f084fba2968296ee47c6e1855e7261ad98a888839e6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanFitAndFill]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanFitAndFill]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanFitAndFill]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__84b53d0c96f7cd12349fd3e54e2a15746e0b37f247d2e5af8eac52877542d7ae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanGoop",
    jsii_struct_bases=[],
    name_mapping={
        "chaos": "chaos",
        "chaos_var": "chaosVar",
        "density": "density",
        "density_var": "densityVar",
        "power": "power",
        "power_var": "powerVar",
        "seed": "seed",
        "seed_var": "seedVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanGoop:
    def __init__(
        self,
        *,
        chaos: typing.Optional[builtins.str] = None,
        chaos_var: typing.Optional[builtins.str] = None,
        density: typing.Optional[builtins.str] = None,
        density_var: typing.Optional[builtins.str] = None,
        power: typing.Optional[builtins.str] = None,
        power_var: typing.Optional[builtins.str] = None,
        seed: typing.Optional[builtins.str] = None,
        seed_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param chaos: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        :param chaos_var: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        :param density: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        :param density_var: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        :param power: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        :param power_var: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        :param seed: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        :param seed_var: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8fe3324db31a88792d00c68454cc2e28385b960d59d1f3b823c50e27b9aaabd7)
            check_type(argname="argument chaos", value=chaos, expected_type=type_hints["chaos"])
            check_type(argname="argument chaos_var", value=chaos_var, expected_type=type_hints["chaos_var"])
            check_type(argname="argument density", value=density, expected_type=type_hints["density"])
            check_type(argname="argument density_var", value=density_var, expected_type=type_hints["density_var"])
            check_type(argname="argument power", value=power, expected_type=type_hints["power"])
            check_type(argname="argument power_var", value=power_var, expected_type=type_hints["power_var"])
            check_type(argname="argument seed", value=seed, expected_type=type_hints["seed"])
            check_type(argname="argument seed_var", value=seed_var, expected_type=type_hints["seed_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if chaos is not None:
            self._values["chaos"] = chaos
        if chaos_var is not None:
            self._values["chaos_var"] = chaos_var
        if density is not None:
            self._values["density"] = density
        if density_var is not None:
            self._values["density_var"] = density_var
        if power is not None:
            self._values["power"] = power
        if power_var is not None:
            self._values["power_var"] = power_var
        if seed is not None:
            self._values["seed"] = seed
        if seed_var is not None:
            self._values["seed_var"] = seed_var

    @builtins.property
    def chaos(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        '''
        result = self._values.get("chaos")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def chaos_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        '''
        result = self._values.get("chaos_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        '''
        result = self._values.get("density")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density_var(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        '''
        result = self._values.get("density_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        '''
        result = self._values.get("power")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power_var(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        '''
        result = self._values.get("power_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        '''
        result = self._values.get("seed")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed_var(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        result = self._values.get("seed_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanGoop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanGoopList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanGoopList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1481f65a852ce9947163359cd3060501107539e66b0cd87152dd471e39361c31)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanGoopOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__11e5e6540dccdcd59ea9f70068df3186da02522738e5da9c49f71a99bc248d10)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanGoopOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b1fe3afa010571043ac0e02f78e5221fbff108bf405998e014db2733d7c1e15d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5d3d01da2641a3c7793b8547173cbb21c465ab745647941fac1e42610206d826)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f82b12f9ea1f98e0580b9eb28edf927045316031390537131e4fd6198c334036)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanGoop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanGoop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1ddd2c83286dd9694b38428d5d9e3b223a5cf34b776d9a88083318fc8df59912)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanGoopOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanGoopOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d624301bfa3c6320bc1e4d612386003bdd9a48dab943814eb001cb764855f1aa)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetChaos")
    def reset_chaos(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaos", []))

    @jsii.member(jsii_name="resetChaosVar")
    def reset_chaos_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaosVar", []))

    @jsii.member(jsii_name="resetDensity")
    def reset_density(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensity", []))

    @jsii.member(jsii_name="resetDensityVar")
    def reset_density_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensityVar", []))

    @jsii.member(jsii_name="resetPower")
    def reset_power(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPower", []))

    @jsii.member(jsii_name="resetPowerVar")
    def reset_power_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPowerVar", []))

    @jsii.member(jsii_name="resetSeed")
    def reset_seed(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeed", []))

    @jsii.member(jsii_name="resetSeedVar")
    def reset_seed_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeedVar", []))

    @builtins.property
    @jsii.member(jsii_name="chaosInput")
    def chaos_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosInput"))

    @builtins.property
    @jsii.member(jsii_name="chaosVarInput")
    def chaos_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosVarInput"))

    @builtins.property
    @jsii.member(jsii_name="densityInput")
    def density_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityInput"))

    @builtins.property
    @jsii.member(jsii_name="densityVarInput")
    def density_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="powerInput")
    def power_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerInput"))

    @builtins.property
    @jsii.member(jsii_name="powerVarInput")
    def power_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerVarInput"))

    @builtins.property
    @jsii.member(jsii_name="seedInput")
    def seed_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedInput"))

    @builtins.property
    @jsii.member(jsii_name="seedVarInput")
    def seed_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedVarInput"))

    @builtins.property
    @jsii.member(jsii_name="chaos")
    def chaos(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaos"))

    @chaos.setter
    def chaos(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dfa052e3fcbcb99471edbefca05061543909906e6b758f070254e1a7d0b2aefe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaos", value)

    @builtins.property
    @jsii.member(jsii_name="chaosVar")
    def chaos_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaosVar"))

    @chaos_var.setter
    def chaos_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__43bd53848ebbb3b66dbf14a6c6199cbecb8aceff120a477655b665afff4231a9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaosVar", value)

    @builtins.property
    @jsii.member(jsii_name="density")
    def density(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "density"))

    @density.setter
    def density(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9fa3f3fd038ad048cb684a26d0f7b4fa1aac7ec139273b8407f860b2149ff26f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "density", value)

    @builtins.property
    @jsii.member(jsii_name="densityVar")
    def density_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "densityVar"))

    @density_var.setter
    def density_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c642fe6bb63614f5cc444a855c19b832975b39365db2b9b4bf73201e71b45294)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "densityVar", value)

    @builtins.property
    @jsii.member(jsii_name="power")
    def power(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "power"))

    @power.setter
    def power(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6996b3cece66006848bf2195f1727a698407a94211ccfb42a4742456961c0fca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "power", value)

    @builtins.property
    @jsii.member(jsii_name="powerVar")
    def power_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "powerVar"))

    @power_var.setter
    def power_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bd8cafe3522cb97dab49b4660c75f7446ec30f842f538154e07ddbafdbde344f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "powerVar", value)

    @builtins.property
    @jsii.member(jsii_name="seed")
    def seed(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seed"))

    @seed.setter
    def seed(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__658be11a227496adc27b79a2a0ab9d258b0a157664c61c63dca18c069caf126f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seed", value)

    @builtins.property
    @jsii.member(jsii_name="seedVar")
    def seed_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seedVar"))

    @seed_var.setter
    def seed_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__008cac81182098b147228120a5e5acaafb09ce07c01163181afe7550b3cb1ccf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seedVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanGoop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanGoop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanGoop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__da1bb90e84b986f8236e338fa6798960fea962775d7740e5d480c6e810853591)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanGrayscale",
    jsii_struct_bases=[],
    name_mapping={"type": "type", "type_var": "typeVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanGrayscale:
    def __init__(
        self,
        *,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param type: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b6050f82a77b6c879861271ebc0b656aed846c3c12831fe61dd679b9ac0c46f4)
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanGrayscale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanGrayscaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanGrayscaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ffcb6497981692e23ce025b126841ef09077a58f01f7e323434681fa456219fc)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanGrayscaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e9c3d2d747325c510e3c6464c5389b52186fab9ac5f2b45b50f83630550558ae)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanGrayscaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__315a17d1a45fd10c634d05da31107b45812ebc792a3ffae1b6c793fcd6f176fd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aa9c486a3fbab70f5ab2ddfc612a3c1f7713dd3983a398bc42c3c8d29358fefd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cf796e883a4dab6bff752077365559e037bd0577274aab99fc3769a2c038e160)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanGrayscale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanGrayscale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b83a2e65fa3907f62f7fcd4069d3200d7d758b990a1c6a43cafb35f36a1bba8e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanGrayscaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanGrayscaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__85801151719521a02f733bc980000861f5a86d0318f27d00e82976da38ca81a3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__770e67ba2bcef5c2f4f67549bc4b0a56975b1e1a746166ee7f0e72799bac71f8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__42b55bcd2015105e7466c361275e35ab25c14b5b47486209864004245cf3c832)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanGrayscale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanGrayscale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanGrayscale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__151b750644d010d5fc4381a6e1731b9f369e5b2627d3a923f1158a3c665efc38)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanHsl",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "lightness": "lightness",
        "lightness_var": "lightnessVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanHsl:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness: typing.Optional[builtins.str] = None,
        lightness_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        :param lightness_var: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c7a1981d3500242d327f49075d39413ba1b25ff10bf690458d85b002962b3145)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness", value=lightness, expected_type=type_hints["lightness"])
            check_type(argname="argument lightness_var", value=lightness_var, expected_type=type_hints["lightness_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness is not None:
            self._values["lightness"] = lightness
        if lightness_var is not None:
            self._values["lightness_var"] = lightness_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        '''
        result = self._values.get("lightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        '''
        result = self._values.get("lightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanHsl(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanHslList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanHslList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b657e308bd06784569f0139e362bcccf7184069d7a3e602990a384508f37ec8f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanHslOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__36df53ddae759bf9d053d72cf17c845ac6b750f9b5a1265968932780aa355096)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanHslOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__67568b662efc1a9e90dbdf5c1f1dffdb20afc9acbe19db75ff88e49f2d833099)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9bf7c51acf9509d424f835df7542013b5df9b11e11eec35c093973cd537ddada)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5aec5f70ab07d82ec41f1df36208a630e903cd7250f4b2a2a3439be4571f2485)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanHsl]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanHsl]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2e27e6d0549cf200df2cb534d74dc43f90f5704235b8395ea3872942d4caa68e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanHslOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanHslOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__762a155c3cc96c5f67fd5ae14cc60e8c9ae1df4c165776806649788c5dc63681)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightness")
    def reset_lightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightness", []))

    @jsii.member(jsii_name="resetLightnessVar")
    def reset_lightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessInput")
    def lightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessVarInput")
    def lightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e1a07f5392ceb4077c3d1a982c74401b6bf897b83a456b2029a47411c5d4e1df)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5854199f30a813527cd0407c21f31a661a9b5b2c884285782a251ebe9bfef9b3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightness")
    def lightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightness"))

    @lightness.setter
    def lightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b8b02f3527982bc8d2e5fd8062edc88d00b45e0240f1e563c74f78947ebc242b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightness", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessVar")
    def lightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessVar"))

    @lightness_var.setter
    def lightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__449172553fd3b56067de478f23f10b3203ee5b19053ce2b1dacf0be6ae187449)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c6a71f73a7f21e8635f07fb63f2cd50b1cc841aa04cf991da7ef71e263dc647c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8927114d1554c07af086107d594de17eb43fe430653e97e000af4837ae25a398)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanHsl]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanHsl]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanHsl]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4500dd4cd4f72d169b7ef6648d5d4b6f44679c1f81b8a80cd02b2810263e6030)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanHsv",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanHsv:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        :param value: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__995fa6930d268e835a1c0af761bdc077bae50b277800dd66b1b3cbea5f68ba42)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanHsv(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanHsvList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanHsvList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b738ad421fd9be886f766ed6da2fe1ac54f82a5baa3402460dac2f193b4044a4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanHsvOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8dfb3bbae331e6b6cd9f3993a0e5e4d65bc41f0c4dd9e1364f2f454941082047)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanHsvOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac4534add46aa2a576561cc16c3cf262813c75f941e9c3f348c117d56e821c16)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__43aca8e85a058d8f0e3c4ab74c6d4c67979804d37c566bc1f9e56abceb916fa9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c179742704dab54c1bc4d061ff1b51aa0485962e2ec71d0b0572ba161608d715)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanHsv]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanHsv]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d9518f0d0ea360fec391ace3ae02dfee2cb964c3f0bd53ec5538e3a66b02d6ff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanHsvOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanHsvOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9daba8d433b08d2f6d7f1751ce172e90aa512ad53d8353af03f6f1d86c897707)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__01d869b9396edfae7b80d112db743589e8fc108302e44c0758a5b9bb122ae107)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__96cc133988afcdc06028891bee4897ba74570af6f8315675cafb79492e8f814b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a3aa71a48aa97fa09c5253dce2e274ea7c1996e14d13464dfd07142f2cce832a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__01f2ba13bae2c0465d40ef653e6fee7686d3e9819970f9f2427445d64184233e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9f733ac989ac8cff0c396b6f240292286fa0d99a3fe52b471ac5c48046dd4a84)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__05920f75d7b700be75adca7b435766c2a1d0d7e77394b753c5b30e627da3499e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanHsv]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanHsv]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanHsv]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__882a1aade3c559b72795cbff86d35f6f58a72729908aff461b876d209afb3a32)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimension",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "dimension": "dimension",
        "dimension_var": "dimensionVar",
        "equal": "equal",
        "greater_than": "greaterThan",
        "less_than": "lessThan",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimension:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        dimension: typing.Optional[builtins.str] = None,
        dimension_var: typing.Optional[builtins.str] = None,
        equal: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionEqual", typing.Dict[builtins.str, typing.Any]]] = None,
        greater_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionGreaterThan", typing.Dict[builtins.str, typing.Any]]] = None,
        less_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionLessThan", typing.Dict[builtins.str, typing.Any]]] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param dimension: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        :param dimension_var: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        :param equal: equal block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        :param greater_than: greater_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        :param less_than: less_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        :param value: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionDefault(**default)
        if isinstance(equal, dict):
            equal = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionEqual(**equal)
        if isinstance(greater_than, dict):
            greater_than = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionGreaterThan(**greater_than)
        if isinstance(less_than, dict):
            less_than = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionLessThan(**less_than)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8aa5620d7a9428ef14e2cd25419d052c92d093734c2894780229a0516ccd9a97)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument dimension", value=dimension, expected_type=type_hints["dimension"])
            check_type(argname="argument dimension_var", value=dimension_var, expected_type=type_hints["dimension_var"])
            check_type(argname="argument equal", value=equal, expected_type=type_hints["equal"])
            check_type(argname="argument greater_than", value=greater_than, expected_type=type_hints["greater_than"])
            check_type(argname="argument less_than", value=less_than, expected_type=type_hints["less_than"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if dimension is not None:
            self._values["dimension"] = dimension
        if dimension_var is not None:
            self._values["dimension_var"] = dimension_var
        if equal is not None:
            self._values["equal"] = equal
        if greater_than is not None:
            self._values["greater_than"] = greater_than
        if less_than is not None:
            self._values["less_than"] = less_than
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionDefault"], result)

    @builtins.property
    def dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        '''
        result = self._values.get("dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        '''
        result = self._values.get("dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def equal(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionEqual"]:
        '''equal block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        '''
        result = self._values.get("equal")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionEqual"], result)

    @builtins.property
    def greater_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionGreaterThan"]:
        '''greater_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        '''
        result = self._values.get("greater_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionGreaterThan"], result)

    @builtins.property
    def less_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionLessThan"]:
        '''less_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        '''
        result = self._values.get("less_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionLessThan"], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimension(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4e2328eda9f32537064f94a4dde58634988df979b3dabec526adb6984bde2b1d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b0d677f0432c4d7a51b2d356338b85a0a5bad2a1790e56f86e95be52bf4a10a7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionEqual",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionEqual:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionEqual(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionEqualOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionEqualOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6d7070c5919da7e8ea1d5e2298397451c1235afaa90371629da6547288828e1c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionEqual], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionEqual],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8eb69a904b37774022b2f738c2847da07af872c9329131507bf71d6a46309a55)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionGreaterThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionGreaterThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionGreaterThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionGreaterThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionGreaterThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__004f8e9c71ffdbfc6b3387c7a18e062dff1d5756896ad78c9698173fae8b0d75)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionGreaterThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionGreaterThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab41197c61657a01252d92fe5950eca95516c0696bded1dbd491c5a810b43f06)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionLessThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionLessThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionLessThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionLessThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionLessThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cdfa6dbeafe35a52a596d0006f9f2793d7a07641a5b2d508055b3b87adb677ea)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionLessThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionLessThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0e06c2617116212979385e118fced8c236915a786a9fd5f9c68ae3ee284b1430)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ad97897e6fe846d70a6035976d1ee9e81349fa446851cb056a0d6f938b958ed)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__118e5836bdddf63f40ccb6a368dfd47427dbec2f541809aa00358f129ffded58)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__76d40202ed90e7e9ebe179ac776bbeb3d66355de9cd1daaef74d54357db12997)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2019ff6f2af3e4d092ef1591274bbaf5f7fa28388735ca5bf68ccc4929c62b76)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ddfe2929e25c84848b4786bd7eccd09e1e0458e16a0e3cd16e4e53420392f1c5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimension]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimension]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f63a640ed7bdcabc5940cf4ef17ea380879a5e073f3c45acb174ff5c3f2872fa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5354f0232477fb468197b5b2431f086ba169495b0cab27e1f1d42111c02a95b4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putEqual")
    def put_equal(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionEqual()

        return typing.cast(None, jsii.invoke(self, "putEqual", [value]))

    @jsii.member(jsii_name="putGreaterThan")
    def put_greater_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionGreaterThan()

        return typing.cast(None, jsii.invoke(self, "putGreaterThan", [value]))

    @jsii.member(jsii_name="putLessThan")
    def put_less_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionLessThan()

        return typing.cast(None, jsii.invoke(self, "putLessThan", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetDimension")
    def reset_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimension", []))

    @jsii.member(jsii_name="resetDimensionVar")
    def reset_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimensionVar", []))

    @jsii.member(jsii_name="resetEqual")
    def reset_equal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEqual", []))

    @jsii.member(jsii_name="resetGreaterThan")
    def reset_greater_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGreaterThan", []))

    @jsii.member(jsii_name="resetLessThan")
    def reset_less_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLessThan", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="equal")
    def equal(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionEqualOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionEqualOutputReference, jsii.get(self, "equal"))

    @builtins.property
    @jsii.member(jsii_name="greaterThan")
    def greater_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionGreaterThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionGreaterThanOutputReference, jsii.get(self, "greaterThan"))

    @builtins.property
    @jsii.member(jsii_name="lessThan")
    def less_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionLessThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionLessThanOutputReference, jsii.get(self, "lessThan"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionInput")
    def dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionVarInput")
    def dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="equalInput")
    def equal_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionEqual], jsii.get(self, "equalInput"))

    @builtins.property
    @jsii.member(jsii_name="greaterThanInput")
    def greater_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionGreaterThan], jsii.get(self, "greaterThanInput"))

    @builtins.property
    @jsii.member(jsii_name="lessThanInput")
    def less_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionLessThan], jsii.get(self, "lessThanInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="dimension")
    def dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimension"))

    @dimension.setter
    def dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d3fa7d9718e7a771076a8032de3f647b189c64ba070e75b2e57ffab0259c328)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimension", value)

    @builtins.property
    @jsii.member(jsii_name="dimensionVar")
    def dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimensionVar"))

    @dimension_var.setter
    def dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aef2a1212646146e41302ccc677941baf7c1c3a4b7e72529606677f0b3b85dca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d55482b96e4c42f949fa4468178420d979699722b82ec5cb1822b5b7ec56ad7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__834ea0976c6c550ed4668141a5c09ef39ca2b89c7b677034147c7391ce040637)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimension]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimension]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimension]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5c89fdbe64e8c511eaa93d3a8ade2480ea9ea2e05ef8e4199342e12c0860d3d9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientation",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "landscape": "landscape",
        "portrait": "portrait",
        "square": "square",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientation:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        landscape: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationLandscape", typing.Dict[builtins.str, typing.Any]]] = None,
        portrait: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationPortrait", typing.Dict[builtins.str, typing.Any]]] = None,
        square: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationSquare", typing.Dict[builtins.str, typing.Any]]] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param landscape: landscape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        :param portrait: portrait block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        :param square: square block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationDefault(**default)
        if isinstance(landscape, dict):
            landscape = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationLandscape(**landscape)
        if isinstance(portrait, dict):
            portrait = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationPortrait(**portrait)
        if isinstance(square, dict):
            square = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationSquare(**square)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__17a00d59acaf8603669b52ce0fd8acff86482823c45c2a255ff70648bbeb14da)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument landscape", value=landscape, expected_type=type_hints["landscape"])
            check_type(argname="argument portrait", value=portrait, expected_type=type_hints["portrait"])
            check_type(argname="argument square", value=square, expected_type=type_hints["square"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if landscape is not None:
            self._values["landscape"] = landscape
        if portrait is not None:
            self._values["portrait"] = portrait
        if square is not None:
            self._values["square"] = square

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationDefault"], result)

    @builtins.property
    def landscape(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationLandscape"]:
        '''landscape block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        '''
        result = self._values.get("landscape")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationLandscape"], result)

    @builtins.property
    def portrait(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationPortrait"]:
        '''portrait block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        '''
        result = self._values.get("portrait")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationPortrait"], result)

    @builtins.property
    def square(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationSquare"]:
        '''square block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        result = self._values.get("square")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationSquare"], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__146ad96a52ed7058aabd1b1ce10e4c3bc5e4bc2514ac34bfaec7705e6c193fae)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4c5ff8025c356c98e0a521972ec961bdbe1767c0ca1194573d652bd64372df06)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationLandscape",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationLandscape:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationLandscape(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationLandscapeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationLandscapeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2f094d74419dfe6f43d81e460bce51a435e832917302841f910e5b23e44aefc8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationLandscape], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationLandscape],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__95ea93ead7969dc81ea1e3df34d23db5b6f4e48e309a3dbe6ae3cbab4684b9a8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a24eb14ec88ae739c7b6f25aeacac9d25531965a07873040f78b779bfdbda1ec)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e3e44e735bcd0fa3d37e47d12d2a0e885527a4902e482edaab21e2b97f4ce4ca)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2b5f24987c2d5bdfae6e04d6cdb44b05d1f814f67549eed5b5dd23b9f46faea0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__61c92d16eb824f7bd3747cf84e85ad5fd36c929a37cc40438a831b6ff33acd3b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__01b0de6553d8a09bcfbb956e1fbc0a631adda403809145d5e7597794b6237581)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientation]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientation]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__170752faf8462083ecc9da25e1f0e2af40c79bebc0b88eff846b8fff6132ae9d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a7d49e623b04377220e7497420683f7721e2ecd132d5a8eaebdbc4cd96af5a3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putLandscape")
    def put_landscape(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationLandscape()

        return typing.cast(None, jsii.invoke(self, "putLandscape", [value]))

    @jsii.member(jsii_name="putPortrait")
    def put_portrait(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationPortrait()

        return typing.cast(None, jsii.invoke(self, "putPortrait", [value]))

    @jsii.member(jsii_name="putSquare")
    def put_square(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationSquare()

        return typing.cast(None, jsii.invoke(self, "putSquare", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetLandscape")
    def reset_landscape(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLandscape", []))

    @jsii.member(jsii_name="resetPortrait")
    def reset_portrait(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPortrait", []))

    @jsii.member(jsii_name="resetSquare")
    def reset_square(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSquare", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="landscape")
    def landscape(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationLandscapeOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationLandscapeOutputReference, jsii.get(self, "landscape"))

    @builtins.property
    @jsii.member(jsii_name="portrait")
    def portrait(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationPortraitOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationPortraitOutputReference", jsii.get(self, "portrait"))

    @builtins.property
    @jsii.member(jsii_name="square")
    def square(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationSquareOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationSquareOutputReference", jsii.get(self, "square"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="landscapeInput")
    def landscape_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationLandscape], jsii.get(self, "landscapeInput"))

    @builtins.property
    @jsii.member(jsii_name="portraitInput")
    def portrait_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationPortrait"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationPortrait"], jsii.get(self, "portraitInput"))

    @builtins.property
    @jsii.member(jsii_name="squareInput")
    def square_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationSquare"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationSquare"], jsii.get(self, "squareInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientation]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientation]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientation]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__44afb53915c45d806c6091e3510e7f310e266cab84aea3817cc01991cbc46ae4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationPortrait",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationPortrait:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationPortrait(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationPortraitOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationPortraitOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__955a452ee1d1f52ae31d9a23d9458dd651dd832efa938676cbcdf506e8196f19)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationPortrait]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationPortrait], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationPortrait],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd142b39c9a81b35f3ab93145a7d62043011d65d1918a7d3c96094d9db13b68e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationSquare",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationSquare:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationSquare(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationSquareOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationSquareOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__76e1c7c83cb4278aba9510078c92dc81fc8662ed3657ea4310d4dfa928f1eb57)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationSquare]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationSquare], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationSquare],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__64275b2376ae2136f80df3aa9f9354402c95961f4b9ecbb6f5f15943a6c78a60)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanImQuery",
    jsii_struct_bases=[],
    name_mapping={
        "allowed_transformations": "allowedTransformations",
        "query_var": "queryVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanImQuery:
    def __init__(
        self,
        *,
        allowed_transformations: typing.Sequence[builtins.str],
        query_var: builtins.str,
    ) -> None:
        '''
        :param allowed_transformations: Specifies the transformations that can be applied using the query string parameter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allowed_transformations DataAkamaiImagingPolicyImage#allowed_transformations}
        :param query_var: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#query_var DataAkamaiImagingPolicyImage#query_var}.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__341563970763ebedab7e50be1403a69190763ab2fdcf58563955a704619a1716)
            check_type(argname="argument allowed_transformations", value=allowed_transformations, expected_type=type_hints["allowed_transformations"])
            check_type(argname="argument query_var", value=query_var, expected_type=type_hints["query_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "allowed_transformations": allowed_transformations,
            "query_var": query_var,
        }

    @builtins.property
    def allowed_transformations(self) -> typing.List[builtins.str]:
        '''Specifies the transformations that can be applied using the query string parameter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allowed_transformations DataAkamaiImagingPolicyImage#allowed_transformations}
        '''
        result = self._values.get("allowed_transformations")
        assert result is not None, "Required property 'allowed_transformations' is missing"
        return typing.cast(typing.List[builtins.str], result)

    @builtins.property
    def query_var(self) -> builtins.str:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#query_var DataAkamaiImagingPolicyImage#query_var}.'''
        result = self._values.get("query_var")
        assert result is not None, "Required property 'query_var' is missing"
        return typing.cast(builtins.str, result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanImQuery(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanImQueryList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanImQueryList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c2f12144126f351386a5b5497655c19b93e562da243f389dde43a290dde667f7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanImQueryOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4cad77ccd3ad9c8e01fa39576010cfdf4b7a3784829854be17d83cd8ac092d74)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanImQueryOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5495e3ebde351d37dec485c2513b96c02dc5229dec7edfa226f2ca2c7e9fd68a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ad826bd126783caa52f9328e1e712bc5ed038e72923730cd991d1688ef95aea5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a9360e737b38775d51049102365c5f76116518c301f5179edfa23b57ab9a6557)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanImQuery]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanImQuery]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanImQuery]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0894f3f18b8c9984de7e431fda942a5a3ebab48da8a29866dd3354a77630ec1f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanImQueryOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanImQueryOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__290ace199be97e64bfa33c3bb0392ffa2ba34ce6968f9d96c445cadc7e6aa807)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @builtins.property
    @jsii.member(jsii_name="allowedTransformationsInput")
    def allowed_transformations_input(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "allowedTransformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="queryVarInput")
    def query_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "queryVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowedTransformations")
    def allowed_transformations(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "allowedTransformations"))

    @allowed_transformations.setter
    def allowed_transformations(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e0ddc3795d5e8ab97cb690cb58d09c55706905344015333b7ca77b73f880c971)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowedTransformations", value)

    @builtins.property
    @jsii.member(jsii_name="queryVar")
    def query_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "queryVar"))

    @query_var.setter
    def query_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4b97a7ff2946efe95e1cece08c5c5cda8209ea5b3f3e38920f70883cdbe02f6d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "queryVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanImQuery]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanImQuery]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanImQuery]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eb9950bf833ec99a94c940e7fbaaa55505e23137592a99601c92779ca2dae02b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanMaxColors",
    jsii_struct_bases=[],
    name_mapping={"colors": "colors", "colors_var": "colorsVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanMaxColors:
    def __init__(
        self,
        *,
        colors: typing.Optional[builtins.str] = None,
        colors_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param colors: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        :param colors_var: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4f889f25b6a75e05ef4815954f86918dfc8b16a97cfb7b5da940483bb42f5fdf)
            check_type(argname="argument colors", value=colors, expected_type=type_hints["colors"])
            check_type(argname="argument colors_var", value=colors_var, expected_type=type_hints["colors_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if colors is not None:
            self._values["colors"] = colors
        if colors_var is not None:
            self._values["colors_var"] = colors_var

    @builtins.property
    def colors(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        '''
        result = self._values.get("colors")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def colors_var(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        result = self._values.get("colors_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanMaxColors(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanMaxColorsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanMaxColorsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5bfa8f5a7126a5f7751ba58534ee6d0c74a2bb8359f37c43d880760b04542415)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanMaxColorsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1293701ba50f016d7486b4d08696b9e696ea6b9e65b233c4c37cf4844a01b1d3)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanMaxColorsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df0d59a4626f07a26fdb02b079e3d0df15ee6a9882f5d7552a25e20ff4460082)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7a851ea7ea6e984be238c8bb18aa9036e8887c0b2b47659f65f54a755d7c50b0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__57b63f2d4b3925b4680a26672f0ddc69bd7d52194854c94a2471319e692830a0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanMaxColors]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanMaxColors]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ed8b6bbd231a85a2e25f2d630719e05e2ddbea4fc877e83d7244231f25b74173)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanMaxColorsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanMaxColorsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e9a4d6384e6ac7e0b3af01e165c7c24828a23d2334da7aff9aa25980e35a06c6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColors")
    def reset_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColors", []))

    @jsii.member(jsii_name="resetColorsVar")
    def reset_colors_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorsVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorsInput")
    def colors_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsInput"))

    @builtins.property
    @jsii.member(jsii_name="colorsVarInput")
    def colors_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsVarInput"))

    @builtins.property
    @jsii.member(jsii_name="colors")
    def colors(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colors"))

    @colors.setter
    def colors(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1b0db445a408eade68a03b758909aa0d1402865989a0ca101ecf7844a5b20b99)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colors", value)

    @builtins.property
    @jsii.member(jsii_name="colorsVar")
    def colors_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorsVar"))

    @colors_var.setter
    def colors_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e773b5e2c0a668414eebdcd394c70e6ade7b233fae8427e5ae4ba2a7f4bc1485)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorsVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanMaxColors]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanMaxColors]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanMaxColors]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__61d94d5859dced80e77207d523f0fa71d591a6507bc8f3655259134cae871ffd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanMirror",
    jsii_struct_bases=[],
    name_mapping={
        "horizontal": "horizontal",
        "horizontal_var": "horizontalVar",
        "vertical": "vertical",
        "vertical_var": "verticalVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanMirror:
    def __init__(
        self,
        *,
        horizontal: typing.Optional[builtins.str] = None,
        horizontal_var: typing.Optional[builtins.str] = None,
        vertical: typing.Optional[builtins.str] = None,
        vertical_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param horizontal: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        :param horizontal_var: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        :param vertical: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        :param vertical_var: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__753d6f80e251ea761f2fa5262055a8f402aea31bba10b8471e3521170431d3dd)
            check_type(argname="argument horizontal", value=horizontal, expected_type=type_hints["horizontal"])
            check_type(argname="argument horizontal_var", value=horizontal_var, expected_type=type_hints["horizontal_var"])
            check_type(argname="argument vertical", value=vertical, expected_type=type_hints["vertical"])
            check_type(argname="argument vertical_var", value=vertical_var, expected_type=type_hints["vertical_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if horizontal is not None:
            self._values["horizontal"] = horizontal
        if horizontal_var is not None:
            self._values["horizontal_var"] = horizontal_var
        if vertical is not None:
            self._values["vertical"] = vertical
        if vertical_var is not None:
            self._values["vertical_var"] = vertical_var

    @builtins.property
    def horizontal(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        '''
        result = self._values.get("horizontal")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def horizontal_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        '''
        result = self._values.get("horizontal_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        '''
        result = self._values.get("vertical")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        result = self._values.get("vertical_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanMirror(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanMirrorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanMirrorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__59d9ce71838ba811575dae073d03039193d493217a852da6d692e20b28b6f6fb)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanMirrorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a291f9868fc7e0dc160191a39b963fbf4cad05d71b58d5f52effeb65e4ae9261)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanMirrorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1e65a4038cc34e6bb317f7a5f8c2096a4723e6093d4079754674a5b220952130)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__271fffbea2d5dea038ab4fed9d83da2c950df685b5e2a38ea3ded701e8dba51c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cc9ce35cb50dc9a7e781c515ca0680523180a3eff1649e48b540930de77e8ed1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanMirror]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanMirror]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6bb9374fc00d519a9a2cf8a713cc817444869dd112903d5a045b68179b4806a5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanMirrorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanMirrorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f84298d369f21868532ae60b1cd2b59a62d97107c3a5384bcbb52855115cffcd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHorizontal")
    def reset_horizontal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontal", []))

    @jsii.member(jsii_name="resetHorizontalVar")
    def reset_horizontal_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontalVar", []))

    @jsii.member(jsii_name="resetVertical")
    def reset_vertical(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVertical", []))

    @jsii.member(jsii_name="resetVerticalVar")
    def reset_vertical_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVerticalVar", []))

    @builtins.property
    @jsii.member(jsii_name="horizontalInput")
    def horizontal_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontalVarInput")
    def horizontal_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalInput")
    def vertical_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalVarInput")
    def vertical_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontal")
    def horizontal(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontal"))

    @horizontal.setter
    def horizontal(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3c82f1bb00b0ec280f7add9e605cacf1b352cf5e385e25fafa8e3bcc033a49b5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontal", value)

    @builtins.property
    @jsii.member(jsii_name="horizontalVar")
    def horizontal_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontalVar"))

    @horizontal_var.setter
    def horizontal_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5dbaf6f3c57968c5f46cccc60b40a18d91632e8378f52fe204d1f58b31142971)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontalVar", value)

    @builtins.property
    @jsii.member(jsii_name="vertical")
    def vertical(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "vertical"))

    @vertical.setter
    def vertical(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__993fc90e19e2ef94b1c953ca026df56fea8864d7f7e4ad8b729bb40e5af5e303)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "vertical", value)

    @builtins.property
    @jsii.member(jsii_name="verticalVar")
    def vertical_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "verticalVar"))

    @vertical_var.setter
    def vertical_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d7b670cf9c509960a90443d8058d1f7131fc7b1b3d2741d54b839ff5b32fe12c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "verticalVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanMirror]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanMirror]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanMirror]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ca29f582c64a3e78f79453c4a0c74cd9950abc1030e60eb6daf407b142946bed)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanMonoHue",
    jsii_struct_bases=[],
    name_mapping={"hue": "hue", "hue_var": "hueVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanMonoHue:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6be69ef89972c98468daa2f26118bda804ac16e48e13ffc87701fe0b10c19478)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanMonoHue(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanMonoHueList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanMonoHueList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6899d1201684116935f3fd16171dc8e806b8649776cd4f158d8f87c6416573e5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanMonoHueOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e20e8b2e9166460e4b310585a18ccaf5181dd835cb7fe14c2a0dc817517bcd0)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanMonoHueOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8b604dbda5ac18781ae73fb49ad117d7c5d1e15481328684e80c392e1531f54c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6ab6624d787453be7ce317661b646af83dc81f4626adadcd7ac5b7d8d04662e8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af06b259e651e0e7443fe5cfd29f034574f4357e900ada170dab8c7b62089890)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanMonoHue]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanMonoHue]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__511c3e881b4bd63a2e889415677036bd4dffacba12bc01fdf1de3082067a6ca0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanMonoHueOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanMonoHueOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cf9b5ea855d1dc7b1b0814d0fd16ddc25d7f713555f07df646b65096870e79ac)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__11cc5b96a9d0948d97e8604af580c0725578878135ec1b38a1d1ce83cb1098e6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__147ca8df970850dd47d7e27a8ab312949ed29b9fc41271954d6714adeecbec45)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanMonoHue]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanMonoHue]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanMonoHue]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1959e659acd857fbd44dbf0fe555b65905f729abf9cb9d90e2864484d392cca4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanOpacity",
    jsii_struct_bases=[],
    name_mapping={"opacity": "opacity", "opacity_var": "opacityVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanOpacity:
    def __init__(
        self,
        *,
        opacity: typing.Optional[builtins.str] = None,
        opacity_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param opacity: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param opacity_var: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7b30227fa98d2d35f06a29ccb2a901783d08844f1bb8642e4ab9e3fff4e0e5cc)
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument opacity_var", value=opacity_var, expected_type=type_hints["opacity_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if opacity is not None:
            self._values["opacity"] = opacity
        if opacity_var is not None:
            self._values["opacity_var"] = opacity_var

    @builtins.property
    def opacity(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def opacity_var(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        result = self._values.get("opacity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanOpacity(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanOpacityList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanOpacityList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__58caeca59dbc65dd2ae7c402cc051aa0328a59d413f13cc610bceef6e58a01e9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanOpacityOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6b19099a21bad3dcc9ae43235bb56197ee8f78968bfd297d7d245e54a7c82a84)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanOpacityOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__95c086257b8b2ec3290ee898c9a360e2b8bba8b3eb0a3774bd29c4a8b2e5f8e7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__346b67a2aefbdb847052f51a561e51293095782ae18b2955157b6abf81722347)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5384d9fea65cc218fdef488fa198607966c55c5c6f355578ce0212f6a2f67530)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanOpacity]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanOpacity]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__46963d9472b0a55c318415a197fa11b3afcc027311c15301b0c6793d26136c4f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanOpacityOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanOpacityOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a471bd3d84eec9dcfb21b0b56ba193278220fdeb18891bbdee81538d04145c8c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetOpacityVar")
    def reset_opacity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacityVar", []))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityVarInput")
    def opacity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacity"))

    @opacity.setter
    def opacity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ba9aa9bc6502845abbb9f01498a5dd107fb1671bc39409a0da5d61c38047f55c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacity", value)

    @builtins.property
    @jsii.member(jsii_name="opacityVar")
    def opacity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacityVar"))

    @opacity_var.setter
    def opacity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4d1c57c5a8129b63b704a5e141c793627e40e6a30feef8f61483511a6f374d94)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacityVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanOpacity]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanOpacity]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanOpacity]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__89fef8f1498f2eedadd921661e522d660d285f282aba779b55fb5953f9f92631)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5031c803cc1bf89f71fb14531c2f8b31e27f621f8cc6cd62a6a5e72dad38586c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putAppend")
    def put_append(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanAppend, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__790e444b8f88641bff7c59e139c132dd640a888a20bd006d24dd61e5ca73f833)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putAppend", [value]))

    @jsii.member(jsii_name="putAspectCrop")
    def put_aspect_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanAspectCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__40424133f60e50770f4e55757052079df6c31b841dd6f5929e02ed70a724eff4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putAspectCrop", [value]))

    @jsii.member(jsii_name="putBackgroundColor")
    def put_background_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bbc110618f6898c24ce1d4959513219dacac63cfaf7295b5446421f73d80d933)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBackgroundColor", [value]))

    @jsii.member(jsii_name="putBlur")
    def put_blur(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanBlur, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7786b4549b0546d75053d277f5ee6b93b9b3901a4e2ac2cd2711f333cf298899)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBlur", [value]))

    @jsii.member(jsii_name="putChromaKey")
    def put_chroma_key(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanChromaKey, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d1c0173f2cdb067cc10561dd7083615c14761b7ef8e055a4db12503823b0c081)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putChromaKey", [value]))

    @jsii.member(jsii_name="putComposite")
    def put_composite(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanComposite, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f277ae7b36184d28a2e9fe5d84a1bb0950be9488f488bc27c273f4ad4be898bd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putComposite", [value]))

    @jsii.member(jsii_name="putCompound")
    def put_compound(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanCompound, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__96b561cb3e511340f3701ac5e0816994c2db6505cabb0bbe7ca2700a7638de1f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCompound", [value]))

    @jsii.member(jsii_name="putContrast")
    def put_contrast(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanContrast, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6de2f033c50416429c145350e714e3e0eca55c23e86726980b151d0d915c57f2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putContrast", [value]))

    @jsii.member(jsii_name="putCrop")
    def put_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b88baec4d6481e79d470a2301908d57e6517294304ed9b0625f08d9f26d25d57)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCrop", [value]))

    @jsii.member(jsii_name="putFaceCrop")
    def put_face_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanFaceCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a8bd90b7a123990e91e5dc7e686b5373fb42298f17a0fea507e3c366c373832b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFaceCrop", [value]))

    @jsii.member(jsii_name="putFeatureCrop")
    def put_feature_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanFeatureCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d0718013fa9ee4b09c7b26988d379156fe3b0f05ef8c76bfbad5763adf416c7f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFeatureCrop", [value]))

    @jsii.member(jsii_name="putFitAndFill")
    def put_fit_and_fill(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanFitAndFill, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c0f3c39a1bea26eb0bb7ac0903ebafe104f3485f8d21e6b38f5dca8d302d8a8b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFitAndFill", [value]))

    @jsii.member(jsii_name="putGoop")
    def put_goop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanGoop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2134c42c3aa4ea087c99695450649148f8efeac87da0f5d4ae912e8d3f452fa6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGoop", [value]))

    @jsii.member(jsii_name="putGrayscale")
    def put_grayscale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanGrayscale, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e3cc573e6413a39d0e7b7a43f80230801ea840d09cbc54fc54f803bb9705dc55)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGrayscale", [value]))

    @jsii.member(jsii_name="putHsl")
    def put_hsl(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanHsl, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d3c753ed06ff8ce1ca052fc27030f2b3cca165695d8d6c40ac6c4ad82570985)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsl", [value]))

    @jsii.member(jsii_name="putHsv")
    def put_hsv(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanHsv, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3d43740dcaaacb62ea72863cfef974a5b4850190da3a21cd4242a1b753d48232)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsv", [value]))

    @jsii.member(jsii_name="putIfDimension")
    def put_if_dimension(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimension, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c530f7fdaf26d8d089558c52f58f8045e34b553fb1ec799529a8a58c3ab7d8f3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfDimension", [value]))

    @jsii.member(jsii_name="putIfOrientation")
    def put_if_orientation(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__492099b1693f351ae7d413ff96627567f17554920cf23d290bf3ce3beb836e44)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfOrientation", [value]))

    @jsii.member(jsii_name="putImQuery")
    def put_im_query(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanImQuery, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__86620685be116c0aa5c98f16ceb61b4057df5923ec101695da0fccb091450d51)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putImQuery", [value]))

    @jsii.member(jsii_name="putMaxColors")
    def put_max_colors(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanMaxColors, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9f17ccc40c6cae2b268eb2561588aefbf51cd7b62c1926c6207a314c4bece1ce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMaxColors", [value]))

    @jsii.member(jsii_name="putMirror")
    def put_mirror(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanMirror, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ef30b9736d5ec138d2fcbcaf8e6904b7720d086f1003b2ecf1f1d0cdbd7c0c9d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMirror", [value]))

    @jsii.member(jsii_name="putMonoHue")
    def put_mono_hue(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanMonoHue, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bae92d1a543ce908d7f6ccd37a785e0327b3514664d7b1ecdfa6576a080d79d3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMonoHue", [value]))

    @jsii.member(jsii_name="putOpacity")
    def put_opacity(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanOpacity, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab8dbaa28c2eb33f8fab1b2bb81cdc06c2c32a2b09703132e8c034f537c2ec03)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putOpacity", [value]))

    @jsii.member(jsii_name="putRegionOfInterestCrop")
    def put_region_of_interest_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanRegionOfInterestCrop", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6ab5249e1a056c1a9c54977a262685807160636e6c4141bfef58d205c81c14ee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRegionOfInterestCrop", [value]))

    @jsii.member(jsii_name="putRelativeCrop")
    def put_relative_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanRelativeCrop", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7df5d6b81cdcc859680c8801eaef0e4582d7d7ab45921673102a56c73edd32d9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRelativeCrop", [value]))

    @jsii.member(jsii_name="putRemoveColor")
    def put_remove_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanRemoveColor", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__18d0b83df68b22511bfdafdc1108346999d650a03935dc43f2529bab8048ebc2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRemoveColor", [value]))

    @jsii.member(jsii_name="putResize")
    def put_resize(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanResize", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3bcee46615910be01dfdc1125de5cb16299d1dc9602ac5879cc3a2f925349eb7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putResize", [value]))

    @jsii.member(jsii_name="putRotate")
    def put_rotate(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanRotate", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e02dc24106a76726ecd9e37439a6ee99257b2bcdb6865ae7e271bee569053c37)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRotate", [value]))

    @jsii.member(jsii_name="putScale")
    def put_scale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanScale", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b17c0d05fae179e867936cbd91fe68b65644f358ecc8767187d91ec06af45511)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putScale", [value]))

    @jsii.member(jsii_name="putShear")
    def put_shear(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanShear", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e911b4940c50e5917ba9c5b34d0c43d447638401a5d11a72d6b5a8c148667d47)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putShear", [value]))

    @jsii.member(jsii_name="putTrim")
    def put_trim(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanTrim", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a6bff755bdd549fd2b43808991a482e730a4251ba022b84e539844f2ca59db81)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTrim", [value]))

    @jsii.member(jsii_name="putUnsharpMask")
    def put_unsharp_mask(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanUnsharpMask", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab9ba4db362043fc8fdc4f16130592f6f03018a50389ce27fe5a2abc2e3d4332)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putUnsharpMask", [value]))

    @jsii.member(jsii_name="resetAppend")
    def reset_append(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAppend", []))

    @jsii.member(jsii_name="resetAspectCrop")
    def reset_aspect_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspectCrop", []))

    @jsii.member(jsii_name="resetBackgroundColor")
    def reset_background_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBackgroundColor", []))

    @jsii.member(jsii_name="resetBlur")
    def reset_blur(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBlur", []))

    @jsii.member(jsii_name="resetChromaKey")
    def reset_chroma_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChromaKey", []))

    @jsii.member(jsii_name="resetComposite")
    def reset_composite(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetComposite", []))

    @jsii.member(jsii_name="resetCompound")
    def reset_compound(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCompound", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetCrop")
    def reset_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCrop", []))

    @jsii.member(jsii_name="resetFaceCrop")
    def reset_face_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFaceCrop", []))

    @jsii.member(jsii_name="resetFeatureCrop")
    def reset_feature_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureCrop", []))

    @jsii.member(jsii_name="resetFitAndFill")
    def reset_fit_and_fill(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFitAndFill", []))

    @jsii.member(jsii_name="resetGoop")
    def reset_goop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGoop", []))

    @jsii.member(jsii_name="resetGrayscale")
    def reset_grayscale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGrayscale", []))

    @jsii.member(jsii_name="resetHsl")
    def reset_hsl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsl", []))

    @jsii.member(jsii_name="resetHsv")
    def reset_hsv(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsv", []))

    @jsii.member(jsii_name="resetIfDimension")
    def reset_if_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfDimension", []))

    @jsii.member(jsii_name="resetIfOrientation")
    def reset_if_orientation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfOrientation", []))

    @jsii.member(jsii_name="resetImQuery")
    def reset_im_query(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetImQuery", []))

    @jsii.member(jsii_name="resetMaxColors")
    def reset_max_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxColors", []))

    @jsii.member(jsii_name="resetMirror")
    def reset_mirror(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMirror", []))

    @jsii.member(jsii_name="resetMonoHue")
    def reset_mono_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonoHue", []))

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetRegionOfInterestCrop")
    def reset_region_of_interest_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRegionOfInterestCrop", []))

    @jsii.member(jsii_name="resetRelativeCrop")
    def reset_relative_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRelativeCrop", []))

    @jsii.member(jsii_name="resetRemoveColor")
    def reset_remove_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRemoveColor", []))

    @jsii.member(jsii_name="resetResize")
    def reset_resize(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetResize", []))

    @jsii.member(jsii_name="resetRotate")
    def reset_rotate(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRotate", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetShear")
    def reset_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetShear", []))

    @jsii.member(jsii_name="resetTrim")
    def reset_trim(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTrim", []))

    @jsii.member(jsii_name="resetUnsharpMask")
    def reset_unsharp_mask(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUnsharpMask", []))

    @builtins.property
    @jsii.member(jsii_name="append")
    def append(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanAppendList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanAppendList, jsii.get(self, "append"))

    @builtins.property
    @jsii.member(jsii_name="aspectCrop")
    def aspect_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanAspectCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanAspectCropList, jsii.get(self, "aspectCrop"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColor")
    def background_color(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanBackgroundColorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanBackgroundColorList, jsii.get(self, "backgroundColor"))

    @builtins.property
    @jsii.member(jsii_name="blur")
    def blur(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanBlurList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanBlurList, jsii.get(self, "blur"))

    @builtins.property
    @jsii.member(jsii_name="chromaKey")
    def chroma_key(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanChromaKeyList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanChromaKeyList, jsii.get(self, "chromaKey"))

    @builtins.property
    @jsii.member(jsii_name="composite")
    def composite(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanCompositeList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanCompositeList, jsii.get(self, "composite"))

    @builtins.property
    @jsii.member(jsii_name="compound")
    def compound(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanCompoundList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanCompoundList, jsii.get(self, "compound"))

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanContrastList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanContrastList, jsii.get(self, "contrast"))

    @builtins.property
    @jsii.member(jsii_name="crop")
    def crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanCropList, jsii.get(self, "crop"))

    @builtins.property
    @jsii.member(jsii_name="faceCrop")
    def face_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanFaceCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanFaceCropList, jsii.get(self, "faceCrop"))

    @builtins.property
    @jsii.member(jsii_name="featureCrop")
    def feature_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanFeatureCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanFeatureCropList, jsii.get(self, "featureCrop"))

    @builtins.property
    @jsii.member(jsii_name="fitAndFill")
    def fit_and_fill(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanFitAndFillList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanFitAndFillList, jsii.get(self, "fitAndFill"))

    @builtins.property
    @jsii.member(jsii_name="goop")
    def goop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanGoopList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanGoopList, jsii.get(self, "goop"))

    @builtins.property
    @jsii.member(jsii_name="grayscale")
    def grayscale(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanGrayscaleList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanGrayscaleList, jsii.get(self, "grayscale"))

    @builtins.property
    @jsii.member(jsii_name="hsl")
    def hsl(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanHslList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanHslList, jsii.get(self, "hsl"))

    @builtins.property
    @jsii.member(jsii_name="hsv")
    def hsv(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanHsvList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanHsvList, jsii.get(self, "hsv"))

    @builtins.property
    @jsii.member(jsii_name="ifDimension")
    def if_dimension(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionList, jsii.get(self, "ifDimension"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientation")
    def if_orientation(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationList, jsii.get(self, "ifOrientation"))

    @builtins.property
    @jsii.member(jsii_name="imQuery")
    def im_query(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanImQueryList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanImQueryList, jsii.get(self, "imQuery"))

    @builtins.property
    @jsii.member(jsii_name="maxColors")
    def max_colors(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanMaxColorsList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanMaxColorsList, jsii.get(self, "maxColors"))

    @builtins.property
    @jsii.member(jsii_name="mirror")
    def mirror(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanMirrorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanMirrorList, jsii.get(self, "mirror"))

    @builtins.property
    @jsii.member(jsii_name="monoHue")
    def mono_hue(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanMonoHueList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanMonoHueList, jsii.get(self, "monoHue"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanOpacityList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanOpacityList, jsii.get(self, "opacity"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestCrop")
    def region_of_interest_crop(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanRegionOfInterestCropList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanRegionOfInterestCropList", jsii.get(self, "regionOfInterestCrop"))

    @builtins.property
    @jsii.member(jsii_name="relativeCrop")
    def relative_crop(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanRelativeCropList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanRelativeCropList", jsii.get(self, "relativeCrop"))

    @builtins.property
    @jsii.member(jsii_name="removeColor")
    def remove_color(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanRemoveColorList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanRemoveColorList", jsii.get(self, "removeColor"))

    @builtins.property
    @jsii.member(jsii_name="resize")
    def resize(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanResizeList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanResizeList", jsii.get(self, "resize"))

    @builtins.property
    @jsii.member(jsii_name="rotate")
    def rotate(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanRotateList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanRotateList", jsii.get(self, "rotate"))

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanScaleList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanScaleList", jsii.get(self, "scale"))

    @builtins.property
    @jsii.member(jsii_name="shear")
    def shear(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanShearList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanShearList", jsii.get(self, "shear"))

    @builtins.property
    @jsii.member(jsii_name="trim")
    def trim(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanTrimList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanTrimList", jsii.get(self, "trim"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMask")
    def unsharp_mask(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanUnsharpMaskList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanUnsharpMaskList", jsii.get(self, "unsharpMask"))

    @builtins.property
    @jsii.member(jsii_name="appendInput")
    def append_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanAppend]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanAppend]]], jsii.get(self, "appendInput"))

    @builtins.property
    @jsii.member(jsii_name="aspectCropInput")
    def aspect_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanAspectCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanAspectCrop]]], jsii.get(self, "aspectCropInput"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColorInput")
    def background_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanBackgroundColor]]], jsii.get(self, "backgroundColorInput"))

    @builtins.property
    @jsii.member(jsii_name="blurInput")
    def blur_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanBlur]]], jsii.get(self, "blurInput"))

    @builtins.property
    @jsii.member(jsii_name="chromaKeyInput")
    def chroma_key_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanChromaKey]]], jsii.get(self, "chromaKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="compositeInput")
    def composite_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanComposite]]], jsii.get(self, "compositeInput"))

    @builtins.property
    @jsii.member(jsii_name="compoundInput")
    def compound_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanCompound]]], jsii.get(self, "compoundInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanContrast]]], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="cropInput")
    def crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanCrop]]], jsii.get(self, "cropInput"))

    @builtins.property
    @jsii.member(jsii_name="faceCropInput")
    def face_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanFaceCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanFaceCrop]]], jsii.get(self, "faceCropInput"))

    @builtins.property
    @jsii.member(jsii_name="featureCropInput")
    def feature_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanFeatureCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanFeatureCrop]]], jsii.get(self, "featureCropInput"))

    @builtins.property
    @jsii.member(jsii_name="fitAndFillInput")
    def fit_and_fill_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanFitAndFill]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanFitAndFill]]], jsii.get(self, "fitAndFillInput"))

    @builtins.property
    @jsii.member(jsii_name="goopInput")
    def goop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanGoop]]], jsii.get(self, "goopInput"))

    @builtins.property
    @jsii.member(jsii_name="grayscaleInput")
    def grayscale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanGrayscale]]], jsii.get(self, "grayscaleInput"))

    @builtins.property
    @jsii.member(jsii_name="hslInput")
    def hsl_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanHsl]]], jsii.get(self, "hslInput"))

    @builtins.property
    @jsii.member(jsii_name="hsvInput")
    def hsv_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanHsv]]], jsii.get(self, "hsvInput"))

    @builtins.property
    @jsii.member(jsii_name="ifDimensionInput")
    def if_dimension_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimension]]], jsii.get(self, "ifDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientationInput")
    def if_orientation_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientation]]], jsii.get(self, "ifOrientationInput"))

    @builtins.property
    @jsii.member(jsii_name="imQueryInput")
    def im_query_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanImQuery]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanImQuery]]], jsii.get(self, "imQueryInput"))

    @builtins.property
    @jsii.member(jsii_name="maxColorsInput")
    def max_colors_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanMaxColors]]], jsii.get(self, "maxColorsInput"))

    @builtins.property
    @jsii.member(jsii_name="mirrorInput")
    def mirror_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanMirror]]], jsii.get(self, "mirrorInput"))

    @builtins.property
    @jsii.member(jsii_name="monoHueInput")
    def mono_hue_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanMonoHue]]], jsii.get(self, "monoHueInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanOpacity]]], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestCropInput")
    def region_of_interest_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanRegionOfInterestCrop"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanRegionOfInterestCrop"]]], jsii.get(self, "regionOfInterestCropInput"))

    @builtins.property
    @jsii.member(jsii_name="relativeCropInput")
    def relative_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanRelativeCrop"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanRelativeCrop"]]], jsii.get(self, "relativeCropInput"))

    @builtins.property
    @jsii.member(jsii_name="removeColorInput")
    def remove_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanRemoveColor"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanRemoveColor"]]], jsii.get(self, "removeColorInput"))

    @builtins.property
    @jsii.member(jsii_name="resizeInput")
    def resize_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanResize"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanResize"]]], jsii.get(self, "resizeInput"))

    @builtins.property
    @jsii.member(jsii_name="rotateInput")
    def rotate_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanRotate"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanRotate"]]], jsii.get(self, "rotateInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanScale"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanScale"]]], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="shearInput")
    def shear_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanShear"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanShear"]]], jsii.get(self, "shearInput"))

    @builtins.property
    @jsii.member(jsii_name="trimInput")
    def trim_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanTrim"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanTrim"]]], jsii.get(self, "trimInput"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMaskInput")
    def unsharp_mask_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanUnsharpMask"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanUnsharpMask"]]], jsii.get(self, "unsharpMaskInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__90342fdf71587e30af416464c265f57dc5de23b9237c46ce9e36f358a9c36e01)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanRegionOfInterestCrop",
    jsii_struct_bases=[],
    name_mapping={
        "region_of_interest": "regionOfInterest",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanRegionOfInterestCrop:
    def __init__(
        self,
        *,
        region_of_interest: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanRegionOfInterestCropRegionOfInterest", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param region_of_interest: region_of_interest block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest DataAkamaiImagingPolicyImage#region_of_interest}
        :param gravity: The placement of the crop area relative to the specified area of interest. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: The placement of the crop area relative to the specified area of interest. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param style: Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(region_of_interest, dict):
            region_of_interest = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanRegionOfInterestCropRegionOfInterest(**region_of_interest)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__112fe2f1a57cf016fc6999b7004c088902420bab46eaba1f8eeadf54c72dd4b7)
            check_type(argname="argument region_of_interest", value=region_of_interest, expected_type=type_hints["region_of_interest"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "region_of_interest": region_of_interest,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def region_of_interest(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanRegionOfInterestCropRegionOfInterest":
        '''region_of_interest block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest DataAkamaiImagingPolicyImage#region_of_interest}
        '''
        result = self._values.get("region_of_interest")
        assert result is not None, "Required property 'region_of_interest' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanRegionOfInterestCropRegionOfInterest", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''The placement of the crop area relative to the specified area of interest.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''The placement of the crop area relative to the specified area of interest.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanRegionOfInterestCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanRegionOfInterestCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanRegionOfInterestCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2fd4e4bf11615ffa1e65e4fed9b0b81a5916b4b3e2ee76b7bdbaec8a52949fcb)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanRegionOfInterestCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__120d2dd102d9c563dc5197cfda71c4327bd7ef1fd76aa5a8548c2d9a905064d9)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanRegionOfInterestCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4f8cf9b1d9a81c7907bca8ebd1797fa0a057c8596ef1a7d8e5815aa2d78318c1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb9dc515ec9e8e3dc4b10ba657230e827b5c9a220ce71abde9ce989fa3da7ae7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2793948fa739566813bb42ffe1b7cd6c043a9a69b71880162124e7997a59bdcc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanRegionOfInterestCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanRegionOfInterestCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanRegionOfInterestCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5d5b371280f72156d3799f2fc43c409e7cb4ca3a62ca57dbaadba6d366a10dfc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanRegionOfInterestCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanRegionOfInterestCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__edcc65c3d930f2e42167b783a872517cf75e3ba995d885a980475ccc29e029db)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putRegionOfInterest")
    def put_region_of_interest(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanRegionOfInterestCropRegionOfInterest()

        return typing.cast(None, jsii.invoke(self, "putRegionOfInterest", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterest")
    def region_of_interest(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanRegionOfInterestCropRegionOfInterestOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanRegionOfInterestCropRegionOfInterestOutputReference", jsii.get(self, "regionOfInterest"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestInput")
    def region_of_interest_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanRegionOfInterestCropRegionOfInterest"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanRegionOfInterestCropRegionOfInterest"], jsii.get(self, "regionOfInterestInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b032ed2a76c53430e104cc9fde4fd74924ceae3fe9a735dffb219057620fbdaf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ce6ac5be47fa39649a9b570510abe1c5dc3539ad7a453ac4d2b70749f2ff4e08)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__abd1bef88d4a2fa8e67530dafda01c457d71e9c8136534a0a30967866c5a4c00)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__60f5f20f835706519a7fd0e3e0d4ba72db41c0b4382d7c39a17c4728a785e102)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__79a44ac10240508bc63c286f607df22a8149201e2a96b2c899885135b0b727c6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e7de1813c2acc27eaa79a0c12a332901cfbba6a9e49cee75ee74c0ddcaf9f2ea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__231843bd07dc089d21d99be343be8c6ae6da6028f79f529467ae2e3729b11547)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__83499f520ad63a44e617785b4a8a8a75a9ee9805e6213349ba7bc409d45c45e0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanRegionOfInterestCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanRegionOfInterestCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanRegionOfInterestCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6048ce4f591cb510b140218c5d5653b634a408134cd4d933e25e9333ad3ae00b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanRegionOfInterestCropRegionOfInterest",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanRegionOfInterestCropRegionOfInterest:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanRegionOfInterestCropRegionOfInterest(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanRegionOfInterestCropRegionOfInterestOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanRegionOfInterestCropRegionOfInterestOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ec90342f9654ec9f3d38d57be41bd43fce3e5336a57c49ee49d23e301458e54)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanRegionOfInterestCropRegionOfInterest]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanRegionOfInterestCropRegionOfInterest], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanRegionOfInterestCropRegionOfInterest],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c9b3eb96ab67ff930d56a1bc4942cbee791d456405d65fe9d8ee6392987d880a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanRelativeCrop",
    jsii_struct_bases=[],
    name_mapping={
        "east": "east",
        "east_var": "eastVar",
        "north": "north",
        "north_var": "northVar",
        "south": "south",
        "south_var": "southVar",
        "west": "west",
        "west_var": "westVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanRelativeCrop:
    def __init__(
        self,
        *,
        east: typing.Optional[builtins.str] = None,
        east_var: typing.Optional[builtins.str] = None,
        north: typing.Optional[builtins.str] = None,
        north_var: typing.Optional[builtins.str] = None,
        south: typing.Optional[builtins.str] = None,
        south_var: typing.Optional[builtins.str] = None,
        west: typing.Optional[builtins.str] = None,
        west_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param east: The number of pixels to shrink or expand the right side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east DataAkamaiImagingPolicyImage#east}
        :param east_var: The number of pixels to shrink or expand the right side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east_var DataAkamaiImagingPolicyImage#east_var}
        :param north: The number of pixels to shrink or expand the top side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north DataAkamaiImagingPolicyImage#north}
        :param north_var: The number of pixels to shrink or expand the top side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north_var DataAkamaiImagingPolicyImage#north_var}
        :param south: The number of pixels to shrink or expand the bottom side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south DataAkamaiImagingPolicyImage#south}
        :param south_var: The number of pixels to shrink or expand the bottom side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south_var DataAkamaiImagingPolicyImage#south_var}
        :param west: The number of pixels to shrink or expand the left side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west DataAkamaiImagingPolicyImage#west}
        :param west_var: The number of pixels to shrink or expand the left side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west_var DataAkamaiImagingPolicyImage#west_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e33756a471a5d58227a927e599b6343a89529e8459a55d380d920979b77cf274)
            check_type(argname="argument east", value=east, expected_type=type_hints["east"])
            check_type(argname="argument east_var", value=east_var, expected_type=type_hints["east_var"])
            check_type(argname="argument north", value=north, expected_type=type_hints["north"])
            check_type(argname="argument north_var", value=north_var, expected_type=type_hints["north_var"])
            check_type(argname="argument south", value=south, expected_type=type_hints["south"])
            check_type(argname="argument south_var", value=south_var, expected_type=type_hints["south_var"])
            check_type(argname="argument west", value=west, expected_type=type_hints["west"])
            check_type(argname="argument west_var", value=west_var, expected_type=type_hints["west_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if east is not None:
            self._values["east"] = east
        if east_var is not None:
            self._values["east_var"] = east_var
        if north is not None:
            self._values["north"] = north
        if north_var is not None:
            self._values["north_var"] = north_var
        if south is not None:
            self._values["south"] = south
        if south_var is not None:
            self._values["south_var"] = south_var
        if west is not None:
            self._values["west"] = west
        if west_var is not None:
            self._values["west_var"] = west_var

    @builtins.property
    def east(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the right side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east DataAkamaiImagingPolicyImage#east}
        '''
        result = self._values.get("east")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def east_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the right side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east_var DataAkamaiImagingPolicyImage#east_var}
        '''
        result = self._values.get("east_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def north(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the top side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north DataAkamaiImagingPolicyImage#north}
        '''
        result = self._values.get("north")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def north_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the top side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north_var DataAkamaiImagingPolicyImage#north_var}
        '''
        result = self._values.get("north_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def south(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the bottom side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south DataAkamaiImagingPolicyImage#south}
        '''
        result = self._values.get("south")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def south_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the bottom side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south_var DataAkamaiImagingPolicyImage#south_var}
        '''
        result = self._values.get("south_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def west(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the left side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west DataAkamaiImagingPolicyImage#west}
        '''
        result = self._values.get("west")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def west_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the left side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west_var DataAkamaiImagingPolicyImage#west_var}
        '''
        result = self._values.get("west_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanRelativeCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanRelativeCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanRelativeCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d83ed5d81240e7e8144f7ccaa92f3cffb4089511448870a3910af205fb93ccd4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanRelativeCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6cad93a9f9380d7cf98c244dba74776ac6ac310c123c52e1cb1770668e06d9e7)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanRelativeCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__113f59c0f816b89c98c643f397300dd0b1d0490743d569b235856e2337ecf209)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5684e813cd012b67ae8507ff2d6db11d6cad791d5869281ea21678cc7af88d92)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4e8cd87e4b595069630d7c86f166251a18fd7ed3024ff46a3a51de791307884f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanRelativeCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanRelativeCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanRelativeCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__708cec71edecb55e48110d7470e0bd1a57eae456812a194a9ac250891dddbc49)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanRelativeCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanRelativeCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a0b9054c20cabb6ab9e8a16918f1847044a0b059e45a118864bb9b70f4bb4e3d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetEast")
    def reset_east(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEast", []))

    @jsii.member(jsii_name="resetEastVar")
    def reset_east_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEastVar", []))

    @jsii.member(jsii_name="resetNorth")
    def reset_north(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNorth", []))

    @jsii.member(jsii_name="resetNorthVar")
    def reset_north_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNorthVar", []))

    @jsii.member(jsii_name="resetSouth")
    def reset_south(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSouth", []))

    @jsii.member(jsii_name="resetSouthVar")
    def reset_south_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSouthVar", []))

    @jsii.member(jsii_name="resetWest")
    def reset_west(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWest", []))

    @jsii.member(jsii_name="resetWestVar")
    def reset_west_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWestVar", []))

    @builtins.property
    @jsii.member(jsii_name="eastInput")
    def east_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "eastInput"))

    @builtins.property
    @jsii.member(jsii_name="eastVarInput")
    def east_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "eastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="northInput")
    def north_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "northInput"))

    @builtins.property
    @jsii.member(jsii_name="northVarInput")
    def north_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "northVarInput"))

    @builtins.property
    @jsii.member(jsii_name="southInput")
    def south_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "southInput"))

    @builtins.property
    @jsii.member(jsii_name="southVarInput")
    def south_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "southVarInput"))

    @builtins.property
    @jsii.member(jsii_name="westInput")
    def west_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "westInput"))

    @builtins.property
    @jsii.member(jsii_name="westVarInput")
    def west_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "westVarInput"))

    @builtins.property
    @jsii.member(jsii_name="east")
    def east(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "east"))

    @east.setter
    def east(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1fa25109dd3fd27f443a77194db8be54e89747c98d3e3966d8775a94d63a6992)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "east", value)

    @builtins.property
    @jsii.member(jsii_name="eastVar")
    def east_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "eastVar"))

    @east_var.setter
    def east_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d2b44d1a416b3da364ecbbceda2abceb7f5abccb8c11519a204e0d537847ae6b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "eastVar", value)

    @builtins.property
    @jsii.member(jsii_name="north")
    def north(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "north"))

    @north.setter
    def north(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__38edc64cd66ae9794b635b632fb63360bba979e0ac93ea13b0fdf089759218a2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "north", value)

    @builtins.property
    @jsii.member(jsii_name="northVar")
    def north_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "northVar"))

    @north_var.setter
    def north_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0bda69fe6b1bb047ee7ad1d24b68f7b9a19162882bfb5aff81f2b3216dce2d26)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "northVar", value)

    @builtins.property
    @jsii.member(jsii_name="south")
    def south(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "south"))

    @south.setter
    def south(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0eb8cae39503881a89dfa5363d3bbfa532e513f986a7be32dd693f9846d0aa01)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "south", value)

    @builtins.property
    @jsii.member(jsii_name="southVar")
    def south_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "southVar"))

    @south_var.setter
    def south_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df45286b9c5b6fda3f74edcd9cc8465cc783d8c176aaaaaf18ae425da41da7f4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "southVar", value)

    @builtins.property
    @jsii.member(jsii_name="west")
    def west(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "west"))

    @west.setter
    def west(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c003e3eeb21ba15be85f17229e01d2f21227ea4a79f0660b8f2913d4e025b55a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "west", value)

    @builtins.property
    @jsii.member(jsii_name="westVar")
    def west_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "westVar"))

    @west_var.setter
    def west_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4bcea3d26a59a3ae2595f28015950c69249fb86d86dc5c00be98e3960145cac2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "westVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanRelativeCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanRelativeCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanRelativeCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__898a04b479a2e39e56eab9c9e69059b0edeeb4b00afe940fb30dee9d0edac296)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanRemoveColor",
    jsii_struct_bases=[],
    name_mapping={
        "color": "color",
        "color_var": "colorVar",
        "feather": "feather",
        "feather_var": "featherVar",
        "tolerance": "tolerance",
        "tolerance_var": "toleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanRemoveColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
        feather: typing.Optional[builtins.str] = None,
        feather_var: typing.Optional[builtins.str] = None,
        tolerance: typing.Optional[builtins.str] = None,
        tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        :param feather: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        :param feather_var: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        :param tolerance: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        :param tolerance_var: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6bc2ea7da49144ef5b6b75635032909ead8e4ba4fcb9386fcce573c1d07f797e)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
            check_type(argname="argument feather", value=feather, expected_type=type_hints["feather"])
            check_type(argname="argument feather_var", value=feather_var, expected_type=type_hints["feather_var"])
            check_type(argname="argument tolerance", value=tolerance, expected_type=type_hints["tolerance"])
            check_type(argname="argument tolerance_var", value=tolerance_var, expected_type=type_hints["tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var
        if feather is not None:
            self._values["feather"] = feather
        if feather_var is not None:
            self._values["feather_var"] = feather_var
        if tolerance is not None:
            self._values["tolerance"] = tolerance
        if tolerance_var is not None:
            self._values["tolerance_var"] = tolerance_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        '''
        result = self._values.get("feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather_var(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        '''
        result = self._values.get("feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        '''
        result = self._values.get("tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance_var(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        result = self._values.get("tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanRemoveColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanRemoveColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanRemoveColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd81d9416a2ded861cf8139d52244fbc6dc4ed047938cefd201de361b980f8d4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanRemoveColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5af6d269421d0a8148cec07ece0817a024c851568521f58fe8f4261eadf7ae7c)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanRemoveColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__234d0d33caeea5c9148699fc3cf719d73af5a0b2f02e10acddaafc780e850959)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f5a52cd15cf50da9d35f799dd1a7be42d209310cfe7ea506f9aa81bbc5b471a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__21323fd544c85db1d34ac10cce48eb6f16afb8db27c2ffa20cb1fcc6f679897c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanRemoveColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanRemoveColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanRemoveColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ec85d7e17f997c114d842ed5582bda622c70b1b0f7a149385fe84759fb305931)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanRemoveColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanRemoveColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8cfce94b1ac0baffdc018f5dbb03622490a86b0078fc8bb55cfac59103fb90c9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @jsii.member(jsii_name="resetFeather")
    def reset_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeather", []))

    @jsii.member(jsii_name="resetFeatherVar")
    def reset_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatherVar", []))

    @jsii.member(jsii_name="resetTolerance")
    def reset_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTolerance", []))

    @jsii.member(jsii_name="resetToleranceVar")
    def reset_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featherInput")
    def feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherInput"))

    @builtins.property
    @jsii.member(jsii_name="featherVarInput")
    def feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceInput")
    def tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceVarInput")
    def tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3342c198e8bab9b763560dbd140827c7416c97b4028a230b2419cbfb2c445b86)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9c393c9ceeb9ca0b2fcb63a0871a7100222f97e8dd84d8fa409d889d04b8864f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="feather")
    def feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "feather"))

    @feather.setter
    def feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1af4f73fcbc48a1841069b58f5c6d2dd6404b6136d6cdd0118ec8af5ef649466)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "feather", value)

    @builtins.property
    @jsii.member(jsii_name="featherVar")
    def feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featherVar"))

    @feather_var.setter
    def feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d03a2a0619531288f54ef44a8c69b7aca0f47c738714333c2b081d6758925460)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featherVar", value)

    @builtins.property
    @jsii.member(jsii_name="tolerance")
    def tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tolerance"))

    @tolerance.setter
    def tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eaed0771b6614564c572a36c56de3f86b6c4d95e35676eeac75397f576c8fa57)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tolerance", value)

    @builtins.property
    @jsii.member(jsii_name="toleranceVar")
    def tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "toleranceVar"))

    @tolerance_var.setter
    def tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aa808b8d32a380e96af2f52390715afffe3e5b0800f6eb75a5662f89e7fe49bb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "toleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanRemoveColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanRemoveColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanRemoveColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__582759e385c99daa22ab55e7ac0b51923a32e3694555658f82e4317d12f364a8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanResize",
    jsii_struct_bases=[],
    name_mapping={
        "aspect": "aspect",
        "aspect_var": "aspectVar",
        "height": "height",
        "height_var": "heightVar",
        "type": "type",
        "type_var": "typeVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanResize:
    def __init__(
        self,
        *,
        aspect: typing.Optional[builtins.str] = None,
        aspect_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param aspect: Preserves the aspect ratio. Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect DataAkamaiImagingPolicyImage#aspect}
        :param aspect_var: Preserves the aspect ratio. Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_var DataAkamaiImagingPolicyImage#aspect_var}
        :param height: The height to resize the source image to. Must be set if height is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height to resize the source image to. Must be set if height is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param type: Sets constraints for the image resize. Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: Sets constraints for the image resize. Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        :param width: The width to resize the source image to. Must be set if width is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width to resize the source image to. Must be set if width is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bac0511d8aae8de96dce9d56a4b524b967914a741916df0e6e84531dcdbd4fa3)
            check_type(argname="argument aspect", value=aspect, expected_type=type_hints["aspect"])
            check_type(argname="argument aspect_var", value=aspect_var, expected_type=type_hints["aspect_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if aspect is not None:
            self._values["aspect"] = aspect
        if aspect_var is not None:
            self._values["aspect_var"] = aspect_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def aspect(self) -> typing.Optional[builtins.str]:
        '''Preserves the aspect ratio.

        Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect DataAkamaiImagingPolicyImage#aspect}
        '''
        result = self._values.get("aspect")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def aspect_var(self) -> typing.Optional[builtins.str]:
        '''Preserves the aspect ratio.

        Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_var DataAkamaiImagingPolicyImage#aspect_var}
        '''
        result = self._values.get("aspect_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height to resize the source image to. Must be set if height is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height to resize the source image to. Must be set if height is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''Sets constraints for the image resize.

        Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''Sets constraints for the image resize.

        Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width to resize the source image to. Must be set if width is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width to resize the source image to. Must be set if width is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanResize(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanResizeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanResizeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cb79dbd1e9d23b38cffce53348eccb848a9621e72d7883ff64615b5e86535d97)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanResizeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__22fc784fc2ad2bf811d15f97bddf661bf6aaccb8be672fda505713e72a478db5)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanResizeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__76c44db54b2bb9e564fd5cb60578511c0ae99f611a79857e3da0e099bbd29a07)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c202e4b05f1ec85d64285900919225cffa227177fd5a0c923da36604f18898d4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ee339f38bcc186df3975e1621a5d67336b5cff1f688720c9bfb5ef76618cd87)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanResize]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanResize]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanResize]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9981bf8bc603546102fbbb8fedae96e9b69ea2a8a5089333da4ec9ee8053c2c8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanResizeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanResizeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fe86e6a6ea7e692fd95d387c78fe71202d37d89c5b1343dbb391f8087c1ffeb6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAspect")
    def reset_aspect(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspect", []))

    @jsii.member(jsii_name="resetAspectVar")
    def reset_aspect_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspectVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="aspectInput")
    def aspect_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "aspectInput"))

    @builtins.property
    @jsii.member(jsii_name="aspectVarInput")
    def aspect_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "aspectVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="aspect")
    def aspect(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "aspect"))

    @aspect.setter
    def aspect(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cc83e4bbc14391152e183e9812b3d2bd2febed59252511c3b11e7c8c40ba0056)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "aspect", value)

    @builtins.property
    @jsii.member(jsii_name="aspectVar")
    def aspect_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "aspectVar"))

    @aspect_var.setter
    def aspect_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5c232dcb4dc231356ea64f03038637e10f5d8b37ea5aa4a1bf4156dfa5fda824)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "aspectVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__75ef90d35e4b63ecbc35c26c6e660ce30daa2ee458736b38fd451c916a4f6cb1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c1945e0203eff1d7d793082b96dedf18bd10836078e1cf362de5b2b1bf661d23)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4569ec5a396e54775cf6c854a73781337b1e2f8d1409c945a1d63072e54d72a6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__37ba317f75f9544c058a912082cfc746614fe10c837b7794bc32e5f68c0ad1d0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5cd4ad79a0c21d231d3b99ff9f060d0c17079e021a56038fbcae202bba3d746c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__811cc2ab605adc05736300cf6676cf386a9e4b49efbbdc04f40b3cdaf2186e7d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanResize]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanResize]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanResize]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0be10d20b4f504d6f72c2b562fdb30f6109dff5e9acbda46f9514f268a63f4a6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanRotate",
    jsii_struct_bases=[],
    name_mapping={"degrees": "degrees", "degrees_var": "degreesVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanRotate:
    def __init__(
        self,
        *,
        degrees: typing.Optional[builtins.str] = None,
        degrees_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param degrees: The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees DataAkamaiImagingPolicyImage#degrees}
        :param degrees_var: The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees_var DataAkamaiImagingPolicyImage#degrees_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5439423a6313e1e07de48662ee287bbe58d0115f0d1d31fcafeef359fb7327de)
            check_type(argname="argument degrees", value=degrees, expected_type=type_hints["degrees"])
            check_type(argname="argument degrees_var", value=degrees_var, expected_type=type_hints["degrees_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if degrees is not None:
            self._values["degrees"] = degrees
        if degrees_var is not None:
            self._values["degrees_var"] = degrees_var

    @builtins.property
    def degrees(self) -> typing.Optional[builtins.str]:
        '''The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees DataAkamaiImagingPolicyImage#degrees}
        '''
        result = self._values.get("degrees")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def degrees_var(self) -> typing.Optional[builtins.str]:
        '''The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees_var DataAkamaiImagingPolicyImage#degrees_var}
        '''
        result = self._values.get("degrees_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanRotate(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanRotateList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanRotateList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__25d14fce64a5d2e7a60aa6253967d33aa810c4aa12e68d944518f596cf53fe0e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanRotateOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d8764f5bd2ce381f0029cb908376700bd463225a7a20f42ca615a9898ddeb6c)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanRotateOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9550878e4af4a86e7e95c16de9a99d3370dfe4a0999e9322928404793beb23fa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1d8dc105f74621042745f8f822ad4e8aefa6bbba40d2d5e4606c57f81054aa9b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__94bd377ced12018742d6019c374ad734b513b79cce36400af3c15e03c2faf74e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanRotate]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanRotate]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanRotate]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ca9dd9303a394e9aeafef1e9bc95e4eed594c5d0f995bc69dd3aa2fedf9e9acc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanRotateOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanRotateOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8da66bfe4426f71409c129fcf6cc3c1b093057f1166e7865b603eac22c45e32e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetDegrees")
    def reset_degrees(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDegrees", []))

    @jsii.member(jsii_name="resetDegreesVar")
    def reset_degrees_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDegreesVar", []))

    @builtins.property
    @jsii.member(jsii_name="degreesInput")
    def degrees_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "degreesInput"))

    @builtins.property
    @jsii.member(jsii_name="degreesVarInput")
    def degrees_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "degreesVarInput"))

    @builtins.property
    @jsii.member(jsii_name="degrees")
    def degrees(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "degrees"))

    @degrees.setter
    def degrees(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eb0e2f91573c67a2f61ac623877590ed987ddce184f9401e26a21a9bd391c8b7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "degrees", value)

    @builtins.property
    @jsii.member(jsii_name="degreesVar")
    def degrees_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "degreesVar"))

    @degrees_var.setter
    def degrees_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a681127ca5dd17554f6173c7984328031196ecad77dee5a31ac1b992da56ae65)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "degreesVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanRotate]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanRotate]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanRotate]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e3ec509a5c05bd2a63ab3701eb47503f96adf245aed6734eadb29cb4d86d7728)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanScale",
    jsii_struct_bases=[],
    name_mapping={
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanScale:
    def __init__(
        self,
        *,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param height: Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged. Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged. Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ec6451a773c61f208d1478c774d4248630f2af57dcf419f367613e04abb9b04e)
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size.

        Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size.

        Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged.

        Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged.

        Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanScale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanScaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanScaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6ec96f644f92deaaeaca324cd15378a345ff8f3de837ac3a1c65a3e0f103d4ec)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanScaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6b36469360447d6d33d495ca10736a56a75a46d6f898b0ed0fe42cc64551f445)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanScaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f950f12fccfdda39c4219f217c14af4f97df164189cc21c0887edc7986af6627)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__398610db9360450f4a29019e969c027ef5643cc354dbc93d949558eaa599ca8b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__997c342fa73ec94d1a4f250c8d4e160d2efd350d3758c87d83070d703fd955bc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanScale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanScale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanScale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__037e809c7a7d7ea40e3bdb5eff26f2653c6719cf24a8522cd19647e85ae1bc2d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanScaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanScaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6c666cf58f2d47d6f039c9be98ef4a547a51a3a5b9e0376ef321a8a75dd36d9b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__379977c1007eea9b5a639243d360a54b120854b7ee82ca4271d1fc6cd51c43bd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d16f07eab29a1356ff1917c673ec7576cf4d72acfd6ae945039dd4b303e3f2e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a13cdea1f0c23b6cc2c9dbc55a369c38a374f6ebcfeed66bcf7fea6da1ea3ef9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__96cccfa44bfa6de31b8538362b84115dfc27df86fd70e6237e6a5a64b3a94cd4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanScale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanScale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanScale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d577e8dbba7fa8895fc7073541f98ac67c8d0ed9b7832943e4e0e4f9a8a12386)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanShear",
    jsii_struct_bases=[],
    name_mapping={
        "x_shear": "xShear",
        "x_shear_var": "xShearVar",
        "y_shear": "yShear",
        "y_shear_var": "yShearVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanShear:
    def __init__(
        self,
        *,
        x_shear: typing.Optional[builtins.str] = None,
        x_shear_var: typing.Optional[builtins.str] = None,
        y_shear: typing.Optional[builtins.str] = None,
        y_shear_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param x_shear: The amount to shear along the x-axis, measured in multiples of the image's width. Must be set if yShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear DataAkamaiImagingPolicyImage#x_shear}
        :param x_shear_var: The amount to shear along the x-axis, measured in multiples of the image's width. Must be set if yShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear_var DataAkamaiImagingPolicyImage#x_shear_var}
        :param y_shear: The amount to shear along the y-axis, measured in multiples of the image's height. Must be set if xShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear DataAkamaiImagingPolicyImage#y_shear}
        :param y_shear_var: The amount to shear along the y-axis, measured in multiples of the image's height. Must be set if xShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear_var DataAkamaiImagingPolicyImage#y_shear_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__790e376e55f21874b7279459a35ee0b311254373422adfe8fc7731559825a816)
            check_type(argname="argument x_shear", value=x_shear, expected_type=type_hints["x_shear"])
            check_type(argname="argument x_shear_var", value=x_shear_var, expected_type=type_hints["x_shear_var"])
            check_type(argname="argument y_shear", value=y_shear, expected_type=type_hints["y_shear"])
            check_type(argname="argument y_shear_var", value=y_shear_var, expected_type=type_hints["y_shear_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if x_shear is not None:
            self._values["x_shear"] = x_shear
        if x_shear_var is not None:
            self._values["x_shear_var"] = x_shear_var
        if y_shear is not None:
            self._values["y_shear"] = y_shear
        if y_shear_var is not None:
            self._values["y_shear_var"] = y_shear_var

    @builtins.property
    def x_shear(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the x-axis, measured in multiples of the image's width.

        Must be set if yShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear DataAkamaiImagingPolicyImage#x_shear}
        '''
        result = self._values.get("x_shear")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_shear_var(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the x-axis, measured in multiples of the image's width.

        Must be set if yShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear_var DataAkamaiImagingPolicyImage#x_shear_var}
        '''
        result = self._values.get("x_shear_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_shear(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the y-axis, measured in multiples of the image's height.

        Must be set if xShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear DataAkamaiImagingPolicyImage#y_shear}
        '''
        result = self._values.get("y_shear")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_shear_var(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the y-axis, measured in multiples of the image's height.

        Must be set if xShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear_var DataAkamaiImagingPolicyImage#y_shear_var}
        '''
        result = self._values.get("y_shear_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanShear(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanShearList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanShearList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e61581365d9b407a102e46b917512194f63093ad6267cc7e85b634cc24504615)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanShearOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__04e8cca49a3838bb9e9e00b19a361d299dbeb676690d549bf873fdedccc54928)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanShearOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__492b32b62a3cb4ed2ce0b134b694ea9461c221e270118e0b5788302c27ed5b4c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fbed2a64892b36d452e98c84fb519e23769bdc90957a2c7a68779709401dd3e7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__60c77bb017d78e60e3e260fa9586a2b80d84cf51ea14c4efb73844f8fd506f6c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanShear]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanShear]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanShear]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4f1d1fb5c4828034fd0812130310e248b2a7f44fe54c932faa30642194b3ee21)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanShearOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanShearOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6092a482f97383a94abdc6b5b67d8f0c12e4c4f8c88947b487d090160d127ade)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetXShear")
    def reset_x_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXShear", []))

    @jsii.member(jsii_name="resetXShearVar")
    def reset_x_shear_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXShearVar", []))

    @jsii.member(jsii_name="resetYShear")
    def reset_y_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYShear", []))

    @jsii.member(jsii_name="resetYShearVar")
    def reset_y_shear_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYShearVar", []))

    @builtins.property
    @jsii.member(jsii_name="xShearInput")
    def x_shear_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xShearInput"))

    @builtins.property
    @jsii.member(jsii_name="xShearVarInput")
    def x_shear_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xShearVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yShearInput")
    def y_shear_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yShearInput"))

    @builtins.property
    @jsii.member(jsii_name="yShearVarInput")
    def y_shear_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yShearVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xShear")
    def x_shear(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xShear"))

    @x_shear.setter
    def x_shear(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aabc2fbb3af7dd361169c446e0bfc09958ed8ba309e34b758546e21832e8d7de)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xShear", value)

    @builtins.property
    @jsii.member(jsii_name="xShearVar")
    def x_shear_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xShearVar"))

    @x_shear_var.setter
    def x_shear_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c16d849c53469cc07a5e47db8b5760866e6a6b207d45d2203ede1f31154cb43e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xShearVar", value)

    @builtins.property
    @jsii.member(jsii_name="yShear")
    def y_shear(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yShear"))

    @y_shear.setter
    def y_shear(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1da9e05164fcd110e6c0e1cea7422e35a865e94d941e7a152ee1bcde97ec693b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yShear", value)

    @builtins.property
    @jsii.member(jsii_name="yShearVar")
    def y_shear_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yShearVar"))

    @y_shear_var.setter
    def y_shear_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aed7aae7d233789a0619813ec92fbbf66fe35233a4f505f1a2e459b77647925d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yShearVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanShear]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanShear]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanShear]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ae08e84d33d91d70fe8dff5ccb23107ec2765d3af95ee4325c97c8fae9284d27)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanTrim",
    jsii_struct_bases=[],
    name_mapping={
        "fuzz": "fuzz",
        "fuzz_var": "fuzzVar",
        "padding": "padding",
        "padding_var": "paddingVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanTrim:
    def __init__(
        self,
        *,
        fuzz: typing.Optional[builtins.str] = None,
        fuzz_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fuzz: The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz DataAkamaiImagingPolicyImage#fuzz}
        :param fuzz_var: The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz_var DataAkamaiImagingPolicyImage#fuzz_var}
        :param padding: The amount of padding in pixels to add to the trimmed image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: The amount of padding in pixels to add to the trimmed image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__91488b165d6791bd9c5f58a0489221bbd476853895c9e4c26c723c7ff050b575)
            check_type(argname="argument fuzz", value=fuzz, expected_type=type_hints["fuzz"])
            check_type(argname="argument fuzz_var", value=fuzz_var, expected_type=type_hints["fuzz_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fuzz is not None:
            self._values["fuzz"] = fuzz
        if fuzz_var is not None:
            self._values["fuzz_var"] = fuzz_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var

    @builtins.property
    def fuzz(self) -> typing.Optional[builtins.str]:
        '''The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz DataAkamaiImagingPolicyImage#fuzz}
        '''
        result = self._values.get("fuzz")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fuzz_var(self) -> typing.Optional[builtins.str]:
        '''The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz_var DataAkamaiImagingPolicyImage#fuzz_var}
        '''
        result = self._values.get("fuzz_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''The amount of padding in pixels to add to the trimmed image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''The amount of padding in pixels to add to the trimmed image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanTrim(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanTrimList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanTrimList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1910f3c6940adba3e7c9b4cd1e7d63edca25ce639b0b3ffd167b3cc25cd0881c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanTrimOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f276fd8f67852fe067b99e51415bcfff23dbf78474a05d77d1df6b83d78a89f)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanTrimOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3c647c671d5330051700a6f16ce78c1ba01896f04d642637aa7f8a235dc13cbc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2939a6232178ecd1d7ad1e4e132a3934bce6343d71f1a449bb15af24de835240)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8112cb7255a8c719c6809a325cf6adcd9d247e854d94712cda3b4d84c4f8ca32)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanTrim]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanTrim]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanTrim]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__199faa788cf7c34216e2a424e0e56a71b7673d822b8ecc0b72c9c86043be1533)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanTrimOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanTrimOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__963d5f778f1c77ef402fa0322fe7b328d170be19b55c8864483d41a00066ec44)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetFuzz")
    def reset_fuzz(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFuzz", []))

    @jsii.member(jsii_name="resetFuzzVar")
    def reset_fuzz_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFuzzVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @builtins.property
    @jsii.member(jsii_name="fuzzInput")
    def fuzz_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fuzzInput"))

    @builtins.property
    @jsii.member(jsii_name="fuzzVarInput")
    def fuzz_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fuzzVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="fuzz")
    def fuzz(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fuzz"))

    @fuzz.setter
    def fuzz(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__195bc367655eed0de85316fb8a093a013836f5c0a667619103452826de3de741)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fuzz", value)

    @builtins.property
    @jsii.member(jsii_name="fuzzVar")
    def fuzz_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fuzzVar"))

    @fuzz_var.setter
    def fuzz_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__36c81633bce2e179b0d818c686eb09d29deb9a82c48391afbf7222c70a72968a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fuzzVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8531bb8d756c3f903f109602a54b28d1a4b2b00d96d6c5ea8cfc30afedca87a7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6fd75007a8a838c31e25d4ef168f502fd08aa056192815915577bd77a5ea7536)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanTrim]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanTrim]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanTrim]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__497722f8d6b0d34f477c140ac3b6cd143472fd47d3f5f15157d60c8417de5786)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanUnsharpMask",
    jsii_struct_bases=[],
    name_mapping={
        "gain": "gain",
        "gain_var": "gainVar",
        "sigma": "sigma",
        "sigma_var": "sigmaVar",
        "threshold": "threshold",
        "threshold_var": "thresholdVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanUnsharpMask:
    def __init__(
        self,
        *,
        gain: typing.Optional[builtins.str] = None,
        gain_var: typing.Optional[builtins.str] = None,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
        threshold: typing.Optional[builtins.str] = None,
        threshold_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param gain: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        :param gain_var: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        :param sigma: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        :param threshold: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        :param threshold_var: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__34729cb02733946c6f344714462848f82e456b05f3bbde2d78a915dccdf2c55c)
            check_type(argname="argument gain", value=gain, expected_type=type_hints["gain"])
            check_type(argname="argument gain_var", value=gain_var, expected_type=type_hints["gain_var"])
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
            check_type(argname="argument threshold", value=threshold, expected_type=type_hints["threshold"])
            check_type(argname="argument threshold_var", value=threshold_var, expected_type=type_hints["threshold_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if gain is not None:
            self._values["gain"] = gain
        if gain_var is not None:
            self._values["gain_var"] = gain_var
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var
        if threshold is not None:
            self._values["threshold"] = threshold
        if threshold_var is not None:
            self._values["threshold_var"] = threshold_var

    @builtins.property
    def gain(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        '''
        result = self._values.get("gain")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gain_var(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        '''
        result = self._values.get("gain_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        '''
        result = self._values.get("threshold")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold_var(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        result = self._values.get("threshold_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanUnsharpMask(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanUnsharpMaskList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanUnsharpMaskList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a403b0bcddaca83e73b41b73d7171e536da7b789da59f9e23057640904a335f4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanUnsharpMaskOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab1b41559ba398227622d7f703a35f62c7def6c0623ac1f61cce81df33b44a75)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanUnsharpMaskOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c6aa6ae9d8ec75a197612c3b31d96d582bc00e788d12adc8254bb045669dbb3b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dd17e1d05e359fe89f27c4603ee71081315ce1230862914267154acaba4c0a20)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__725185bb0059bfbf2a70e71b05ed992732e8094dec3183ad0e431c858f37fccb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanUnsharpMask]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanUnsharpMask]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanUnsharpMask]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eb529bfb584ccf943ccbb5b62c351043fb316b83875ecb87734271a69d69e738)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanUnsharpMaskOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanUnsharpMaskOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0c8f0ecce0466f4358c516a6800e8ecac3ded87af3a41db21fb7a59d59bc595a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetGain")
    def reset_gain(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGain", []))

    @jsii.member(jsii_name="resetGainVar")
    def reset_gain_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGainVar", []))

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @jsii.member(jsii_name="resetThreshold")
    def reset_threshold(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThreshold", []))

    @jsii.member(jsii_name="resetThresholdVar")
    def reset_threshold_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThresholdVar", []))

    @builtins.property
    @jsii.member(jsii_name="gainInput")
    def gain_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainInput"))

    @builtins.property
    @jsii.member(jsii_name="gainVarInput")
    def gain_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdInput")
    def threshold_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdVarInput")
    def threshold_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gain")
    def gain(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gain"))

    @gain.setter
    def gain(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c3316681491b4da8aa483f00e0691bcd10d625f70c47d4c72105afe6cec6012f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gain", value)

    @builtins.property
    @jsii.member(jsii_name="gainVar")
    def gain_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gainVar"))

    @gain_var.setter
    def gain_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a896d18ff21ecd57bcd6f8e0a01dddca5eeb4969eee2806cf75c1f2e8266ea32)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gainVar", value)

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b752de2e352dbdf3aee8f171797e9dcf1059899969c47eb7d6b81047a1ab03f4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bf2410c96e92fe2f69790d9323dad1536e7b43dfbdb2c63ac2edb1dd545e0b48)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="threshold")
    def threshold(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "threshold"))

    @threshold.setter
    def threshold(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__782533f6d01ef1d69f59c7584cf3ab133855e394065603cb78b505eb1d0a55c2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "threshold", value)

    @builtins.property
    @jsii.member(jsii_name="thresholdVar")
    def threshold_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "thresholdVar"))

    @threshold_var.setter
    def threshold_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5bec97ee9bcaa26775252bc27bfd50c75bec7d32abf556a065fbd4459718fdb0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "thresholdVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanUnsharpMask]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanUnsharpMask]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanUnsharpMask]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f7a091474dcdef4b2a901d12bf46a3edbee9f522df009e702ddd008feed15a57)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7f53736e660f5f24b574b1ae31e026d0592dad07e9d3acb607797136f19c05e1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fb3b0a8eeceba48ed74ffcfbefa0990534b7e130d9110a13510409b2da459a5e)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6560b4043d8763aabb1b28070efbbe6f29aefb58302439248e32f25516184db5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e0f48d8ae401f5a053be242d1965619cc023ab216e1563d59891e355601345d0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__db97b3accc35e21d068142fe9ed39fdef162ca21d4da6700c731eb32b52b250d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimension]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimension]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1ffd89966101ec8d623269f05d5f4caf4931936abc7d1220bdd890ed018ca7d9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e88a8da00056f82497031ccb696ed7ed62103bcd375393daa16e9fb2baa13c5c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(
        self,
        *,
        append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultAppend, typing.Dict[builtins.str, typing.Any]]]]] = None,
        aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultAspectCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
        crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultFaceCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultFeatureCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultFitAndFill, typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
        im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultImQuery, typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
        region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRegionOfInterestCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRelativeCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
        resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultResize, typing.Dict[builtins.str, typing.Any]]]]] = None,
        rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRotate, typing.Dict[builtins.str, typing.Any]]]]] = None,
        scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultScale, typing.Dict[builtins.str, typing.Any]]]]] = None,
        shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultShear, typing.Dict[builtins.str, typing.Any]]]]] = None,
        trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultTrim, typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param append: append block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        :param aspect_crop: aspect_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param crop: crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        :param face_crop: face_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        :param feature_crop: feature_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        :param fit_and_fill: fit_and_fill block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param im_query: im_query block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param region_of_interest_crop: region_of_interest_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        :param relative_crop: relative_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param resize: resize block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        :param rotate: rotate block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        :param scale: scale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param shear: shear block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        :param trim: trim block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefault(
            append=append,
            aspect_crop=aspect_crop,
            background_color=background_color,
            blur=blur,
            chroma_key=chroma_key,
            composite=composite,
            compound=compound,
            contrast=contrast,
            crop=crop,
            face_crop=face_crop,
            feature_crop=feature_crop,
            fit_and_fill=fit_and_fill,
            goop=goop,
            grayscale=grayscale,
            hsl=hsl,
            hsv=hsv,
            if_dimension=if_dimension,
            if_orientation=if_orientation,
            im_query=im_query,
            max_colors=max_colors,
            mirror=mirror,
            mono_hue=mono_hue,
            opacity=opacity,
            region_of_interest_crop=region_of_interest_crop,
            relative_crop=relative_crop,
            remove_color=remove_color,
            resize=resize,
            rotate=rotate,
            scale=scale,
            shear=shear,
            trim=trim,
            unsharp_mask=unsharp_mask,
        )

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putEqual")
    def put_equal(
        self,
        *,
        append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualAppend, typing.Dict[builtins.str, typing.Any]]]]] = None,
        aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualAspectCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
        crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualFaceCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualFeatureCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualFitAndFill, typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
        im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualImQuery, typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
        region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRegionOfInterestCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRelativeCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
        resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualResize, typing.Dict[builtins.str, typing.Any]]]]] = None,
        rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRotate, typing.Dict[builtins.str, typing.Any]]]]] = None,
        scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualScale, typing.Dict[builtins.str, typing.Any]]]]] = None,
        shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualShear, typing.Dict[builtins.str, typing.Any]]]]] = None,
        trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualTrim, typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param append: append block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        :param aspect_crop: aspect_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param crop: crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        :param face_crop: face_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        :param feature_crop: feature_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        :param fit_and_fill: fit_and_fill block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param im_query: im_query block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param region_of_interest_crop: region_of_interest_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        :param relative_crop: relative_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param resize: resize block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        :param rotate: rotate block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        :param scale: scale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param shear: shear block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        :param trim: trim block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqual(
            append=append,
            aspect_crop=aspect_crop,
            background_color=background_color,
            blur=blur,
            chroma_key=chroma_key,
            composite=composite,
            compound=compound,
            contrast=contrast,
            crop=crop,
            face_crop=face_crop,
            feature_crop=feature_crop,
            fit_and_fill=fit_and_fill,
            goop=goop,
            grayscale=grayscale,
            hsl=hsl,
            hsv=hsv,
            if_dimension=if_dimension,
            if_orientation=if_orientation,
            im_query=im_query,
            max_colors=max_colors,
            mirror=mirror,
            mono_hue=mono_hue,
            opacity=opacity,
            region_of_interest_crop=region_of_interest_crop,
            relative_crop=relative_crop,
            remove_color=remove_color,
            resize=resize,
            rotate=rotate,
            scale=scale,
            shear=shear,
            trim=trim,
            unsharp_mask=unsharp_mask,
        )

        return typing.cast(None, jsii.invoke(self, "putEqual", [value]))

    @jsii.member(jsii_name="putGreaterThan")
    def put_greater_than(
        self,
        *,
        append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanAppend, typing.Dict[builtins.str, typing.Any]]]]] = None,
        aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanAspectCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
        crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanFaceCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanFeatureCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanFitAndFill, typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
        im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanImQuery, typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
        region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanRegionOfInterestCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanRelativeCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
        resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanResize, typing.Dict[builtins.str, typing.Any]]]]] = None,
        rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanRotate, typing.Dict[builtins.str, typing.Any]]]]] = None,
        scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanScale, typing.Dict[builtins.str, typing.Any]]]]] = None,
        shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanShear, typing.Dict[builtins.str, typing.Any]]]]] = None,
        trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanTrim, typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param append: append block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        :param aspect_crop: aspect_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param crop: crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        :param face_crop: face_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        :param feature_crop: feature_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        :param fit_and_fill: fit_and_fill block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param im_query: im_query block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param region_of_interest_crop: region_of_interest_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        :param relative_crop: relative_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param resize: resize block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        :param rotate: rotate block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        :param scale: scale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param shear: shear block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        :param trim: trim block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThan(
            append=append,
            aspect_crop=aspect_crop,
            background_color=background_color,
            blur=blur,
            chroma_key=chroma_key,
            composite=composite,
            compound=compound,
            contrast=contrast,
            crop=crop,
            face_crop=face_crop,
            feature_crop=feature_crop,
            fit_and_fill=fit_and_fill,
            goop=goop,
            grayscale=grayscale,
            hsl=hsl,
            hsv=hsv,
            if_dimension=if_dimension,
            if_orientation=if_orientation,
            im_query=im_query,
            max_colors=max_colors,
            mirror=mirror,
            mono_hue=mono_hue,
            opacity=opacity,
            region_of_interest_crop=region_of_interest_crop,
            relative_crop=relative_crop,
            remove_color=remove_color,
            resize=resize,
            rotate=rotate,
            scale=scale,
            shear=shear,
            trim=trim,
            unsharp_mask=unsharp_mask,
        )

        return typing.cast(None, jsii.invoke(self, "putGreaterThan", [value]))

    @jsii.member(jsii_name="putLessThan")
    def put_less_than(
        self,
        *,
        append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanAppend, typing.Dict[builtins.str, typing.Any]]]]] = None,
        aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanAspectCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
        crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanFaceCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanFeatureCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanFitAndFill, typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
        im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanImQuery, typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
        region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanRegionOfInterestCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanRelativeCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
        resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanResize, typing.Dict[builtins.str, typing.Any]]]]] = None,
        rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanRotate, typing.Dict[builtins.str, typing.Any]]]]] = None,
        scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanScale, typing.Dict[builtins.str, typing.Any]]]]] = None,
        shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanShear, typing.Dict[builtins.str, typing.Any]]]]] = None,
        trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanTrim, typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param append: append block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        :param aspect_crop: aspect_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param crop: crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        :param face_crop: face_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        :param feature_crop: feature_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        :param fit_and_fill: fit_and_fill block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param im_query: im_query block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param region_of_interest_crop: region_of_interest_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        :param relative_crop: relative_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param resize: resize block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        :param rotate: rotate block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        :param scale: scale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param shear: shear block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        :param trim: trim block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThan(
            append=append,
            aspect_crop=aspect_crop,
            background_color=background_color,
            blur=blur,
            chroma_key=chroma_key,
            composite=composite,
            compound=compound,
            contrast=contrast,
            crop=crop,
            face_crop=face_crop,
            feature_crop=feature_crop,
            fit_and_fill=fit_and_fill,
            goop=goop,
            grayscale=grayscale,
            hsl=hsl,
            hsv=hsv,
            if_dimension=if_dimension,
            if_orientation=if_orientation,
            im_query=im_query,
            max_colors=max_colors,
            mirror=mirror,
            mono_hue=mono_hue,
            opacity=opacity,
            region_of_interest_crop=region_of_interest_crop,
            relative_crop=relative_crop,
            remove_color=remove_color,
            resize=resize,
            rotate=rotate,
            scale=scale,
            shear=shear,
            trim=trim,
            unsharp_mask=unsharp_mask,
        )

        return typing.cast(None, jsii.invoke(self, "putLessThan", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetDimension")
    def reset_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimension", []))

    @jsii.member(jsii_name="resetDimensionVar")
    def reset_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimensionVar", []))

    @jsii.member(jsii_name="resetEqual")
    def reset_equal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEqual", []))

    @jsii.member(jsii_name="resetGreaterThan")
    def reset_greater_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGreaterThan", []))

    @jsii.member(jsii_name="resetLessThan")
    def reset_less_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLessThan", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="equal")
    def equal(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualOutputReference, jsii.get(self, "equal"))

    @builtins.property
    @jsii.member(jsii_name="greaterThan")
    def greater_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanOutputReference, jsii.get(self, "greaterThan"))

    @builtins.property
    @jsii.member(jsii_name="lessThan")
    def less_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanOutputReference, jsii.get(self, "lessThan"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionInput")
    def dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionVarInput")
    def dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="equalInput")
    def equal_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqual], jsii.get(self, "equalInput"))

    @builtins.property
    @jsii.member(jsii_name="greaterThanInput")
    def greater_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThan], jsii.get(self, "greaterThanInput"))

    @builtins.property
    @jsii.member(jsii_name="lessThanInput")
    def less_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThan], jsii.get(self, "lessThanInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="dimension")
    def dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimension"))

    @dimension.setter
    def dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1bf67c770d5197ffc9cf055226317396f8a71e558c4d976fbdc205a5e8ee2da2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimension", value)

    @builtins.property
    @jsii.member(jsii_name="dimensionVar")
    def dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimensionVar"))

    @dimension_var.setter
    def dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6d10ffc86df6894527a1b56bf898b279b3d02cfc6d0c4055e63795191bf63ba3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac6c13a137e1c48cd943e59213c81bfd4ee568d46306a42741c2f6a0cf7b7b89)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__572258bc7559313307e8bc575fddeafc9fd518f226338efadb5fa9e8f602216f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimension]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimension]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimension]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b2897a3dd89c663575b5bd2f69c1e752d3aac34d754c20ee7f74207e11ba4414)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeImQuery",
    jsii_struct_bases=[],
    name_mapping={
        "allowed_transformations": "allowedTransformations",
        "query_var": "queryVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeImQuery:
    def __init__(
        self,
        *,
        allowed_transformations: typing.Sequence[builtins.str],
        query_var: builtins.str,
    ) -> None:
        '''
        :param allowed_transformations: Specifies the transformations that can be applied using the query string parameter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allowed_transformations DataAkamaiImagingPolicyImage#allowed_transformations}
        :param query_var: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#query_var DataAkamaiImagingPolicyImage#query_var}.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2f415f041048e6b5b2b518a549e970b4c8bb03f0f253c4088b9d1796dfdf2a38)
            check_type(argname="argument allowed_transformations", value=allowed_transformations, expected_type=type_hints["allowed_transformations"])
            check_type(argname="argument query_var", value=query_var, expected_type=type_hints["query_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "allowed_transformations": allowed_transformations,
            "query_var": query_var,
        }

    @builtins.property
    def allowed_transformations(self) -> typing.List[builtins.str]:
        '''Specifies the transformations that can be applied using the query string parameter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allowed_transformations DataAkamaiImagingPolicyImage#allowed_transformations}
        '''
        result = self._values.get("allowed_transformations")
        assert result is not None, "Required property 'allowed_transformations' is missing"
        return typing.cast(typing.List[builtins.str], result)

    @builtins.property
    def query_var(self) -> builtins.str:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#query_var DataAkamaiImagingPolicyImage#query_var}.'''
        result = self._values.get("query_var")
        assert result is not None, "Required property 'query_var' is missing"
        return typing.cast(builtins.str, result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeImQuery(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeImQueryList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeImQueryList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a3f04cd23dde606242eda1be425b28bcc4bfaaae280fe5fa85ec0cdfbc984f25)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeImQueryOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5b205c27dbbaa9103a491187ed566db4754ff4dbb3c5ed94e4849ca90c9e4bee)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeImQueryOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d583288e3087acb31e51ad38e6e8401c811b71296d8a7cbcfe7fc5f687c7ff79)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d89daefa61d35a722c8e04b86180698ac265dd6169ceb4f8260bf543e7297d5c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7c08b2d08e80d621bb3fb28bc7ef1f46e78e9fba92bfc823e275efc3a979118b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeImQuery]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeImQuery]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeImQuery]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d61b05a14aaad261c1f1b7d5ee50cb5bb68c16d0b33030fd600578f5003a9d26)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeImQueryOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeImQueryOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__71ad68e0d1a25b44f57e18b3475007bf954ef0a31277581fbf0f8d1835d98c49)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @builtins.property
    @jsii.member(jsii_name="allowedTransformationsInput")
    def allowed_transformations_input(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "allowedTransformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="queryVarInput")
    def query_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "queryVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowedTransformations")
    def allowed_transformations(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "allowedTransformations"))

    @allowed_transformations.setter
    def allowed_transformations(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9b0af7ea833e691a83a54e7d39c211a0eeef897c1ef88e80604e515dcba1db5c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowedTransformations", value)

    @builtins.property
    @jsii.member(jsii_name="queryVar")
    def query_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "queryVar"))

    @query_var.setter
    def query_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ff81a0f22030649c26592067d65911108c9c9c92d971ffd3c32ae0b9139d5ba3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "queryVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeImQuery]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeImQuery]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeImQuery]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__50342dd5bcb0e4eadc1e742b5727a53582cb821ab1ee465e21000b893a006972)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeMaxColors",
    jsii_struct_bases=[],
    name_mapping={"colors": "colors", "colors_var": "colorsVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeMaxColors:
    def __init__(
        self,
        *,
        colors: typing.Optional[builtins.str] = None,
        colors_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param colors: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        :param colors_var: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c51796c18b70afc166121de7074440fc51267efd9779443133628326e33acd5c)
            check_type(argname="argument colors", value=colors, expected_type=type_hints["colors"])
            check_type(argname="argument colors_var", value=colors_var, expected_type=type_hints["colors_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if colors is not None:
            self._values["colors"] = colors
        if colors_var is not None:
            self._values["colors_var"] = colors_var

    @builtins.property
    def colors(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        '''
        result = self._values.get("colors")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def colors_var(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        result = self._values.get("colors_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeMaxColors(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeMaxColorsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeMaxColorsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ac16aaf9760f0c07cb237494ab716a2fa326d29c99de128b5e58f7053e7f58d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeMaxColorsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__980b5ce765c629dadfd9fbffebad930c0bf1657c2e6f884c8061da60f2251bf2)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeMaxColorsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__78e73f9061d3e803aee27fe6d25c1b9652ea2546bd70f49caa88a75832491398)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea5d35869e4a49cc339cadf2bee5b99c286a75167cf5f1c5a1792aa2e05fbfba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c2eb5e0dde5d96c3551ae24d4ec2e8874774d42fdb4277b4d43ed5aab35449d6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeMaxColors]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeMaxColors]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3c1f1c1bad4650d71cc1592557a6c50e25444a62694108b3c1218d84c8dc93b1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeMaxColorsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeMaxColorsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__32bd582176f7ec72e3f4c7cdf7166a3074b9df0fb463366b2646dc1199e55aa8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColors")
    def reset_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColors", []))

    @jsii.member(jsii_name="resetColorsVar")
    def reset_colors_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorsVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorsInput")
    def colors_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsInput"))

    @builtins.property
    @jsii.member(jsii_name="colorsVarInput")
    def colors_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsVarInput"))

    @builtins.property
    @jsii.member(jsii_name="colors")
    def colors(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colors"))

    @colors.setter
    def colors(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a40a0ca0fe8aa4709327120e5b8b658020682950de7acc03985fd637736e7a8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colors", value)

    @builtins.property
    @jsii.member(jsii_name="colorsVar")
    def colors_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorsVar"))

    @colors_var.setter
    def colors_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3f5afdd038d4dac99fc00bd693d2b11451c7c3168175461b16503a0cdd077700)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorsVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeMaxColors]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeMaxColors]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeMaxColors]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__301d008b83b327621de341f1f434f7618b618dc0d7475d952ad3bd586904fb21)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeMirror",
    jsii_struct_bases=[],
    name_mapping={
        "horizontal": "horizontal",
        "horizontal_var": "horizontalVar",
        "vertical": "vertical",
        "vertical_var": "verticalVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeMirror:
    def __init__(
        self,
        *,
        horizontal: typing.Optional[builtins.str] = None,
        horizontal_var: typing.Optional[builtins.str] = None,
        vertical: typing.Optional[builtins.str] = None,
        vertical_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param horizontal: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        :param horizontal_var: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        :param vertical: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        :param vertical_var: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6bd59fa5533003511a28f4f912d8c40570d5e18947b20aa0a44dfb8242cd9217)
            check_type(argname="argument horizontal", value=horizontal, expected_type=type_hints["horizontal"])
            check_type(argname="argument horizontal_var", value=horizontal_var, expected_type=type_hints["horizontal_var"])
            check_type(argname="argument vertical", value=vertical, expected_type=type_hints["vertical"])
            check_type(argname="argument vertical_var", value=vertical_var, expected_type=type_hints["vertical_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if horizontal is not None:
            self._values["horizontal"] = horizontal
        if horizontal_var is not None:
            self._values["horizontal_var"] = horizontal_var
        if vertical is not None:
            self._values["vertical"] = vertical
        if vertical_var is not None:
            self._values["vertical_var"] = vertical_var

    @builtins.property
    def horizontal(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        '''
        result = self._values.get("horizontal")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def horizontal_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        '''
        result = self._values.get("horizontal_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        '''
        result = self._values.get("vertical")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        result = self._values.get("vertical_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeMirror(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeMirrorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeMirrorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2edd5d2ebf299ee6fb1847bb444f8732fcc1617d02d14a305887a2b7110aad4f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeMirrorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ca6ba0872041be30c6bb81f676490c30bab133b222e4cd853619204b98c48e03)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeMirrorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e0600adad89a168c83edc93049b495bda11fdb643fc0b8c06213a2b7252b293f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b1268145f1ed46662a28ff37acd0ecdc9053f0af2fdad627d12481d5a1727feb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d7ea8bd33f333b8d42758ce854a7cf2e89f1026adcf2eebf52db96f665007e11)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeMirror]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeMirror]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3bf3d28245b2187e679c2256ee4d69ff2ad6203b26148c522cc98541b6dd1f99)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeMirrorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeMirrorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0c16a62e3a7c6b7bb7f033f33d5eb661ee918bf3f52ca2bf82ea428f152cdd3a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHorizontal")
    def reset_horizontal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontal", []))

    @jsii.member(jsii_name="resetHorizontalVar")
    def reset_horizontal_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontalVar", []))

    @jsii.member(jsii_name="resetVertical")
    def reset_vertical(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVertical", []))

    @jsii.member(jsii_name="resetVerticalVar")
    def reset_vertical_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVerticalVar", []))

    @builtins.property
    @jsii.member(jsii_name="horizontalInput")
    def horizontal_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontalVarInput")
    def horizontal_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalInput")
    def vertical_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalVarInput")
    def vertical_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontal")
    def horizontal(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontal"))

    @horizontal.setter
    def horizontal(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6cc751bf668b9b6f1b22c0991fe2fd771868989e181a3d3f06af921575f80f31)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontal", value)

    @builtins.property
    @jsii.member(jsii_name="horizontalVar")
    def horizontal_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontalVar"))

    @horizontal_var.setter
    def horizontal_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa4dcb466dd9622c622fe712e2b9f5bbc5ec1fda8a30c2fba0682f58b62405ea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontalVar", value)

    @builtins.property
    @jsii.member(jsii_name="vertical")
    def vertical(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "vertical"))

    @vertical.setter
    def vertical(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__35d7cda5a57ba07cb8b351c8f70e1dfbf3c1aaeb80ebd5de63887c079393b5e7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "vertical", value)

    @builtins.property
    @jsii.member(jsii_name="verticalVar")
    def vertical_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "verticalVar"))

    @vertical_var.setter
    def vertical_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bd2e09e704d4d29e8fa9befba3e7a2f946fa8239072f1de48c9d86534f667c05)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "verticalVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeMirror]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeMirror]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeMirror]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ce3416e5a73b8eb1d2d571ff4624f66f1c0c061cd1cf4fa335be5c84390f10fd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeMonoHue",
    jsii_struct_bases=[],
    name_mapping={"hue": "hue", "hue_var": "hueVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeMonoHue:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aef30ebd450d34a29664167da920ed97bf33bc7f1e7cc14fd218a24f5ba59584)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeMonoHue(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeMonoHueList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeMonoHueList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d009388168220141f178aa5288b0c33deb663f5027dd1362bc9da64187b8fc84)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeMonoHueOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab5610a5102afe13c370b589e8f8cd0c1639cb7b18fa9fb58d6d75715baae22c)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeMonoHueOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bf78790c309810a4729a22bf0544e5fa63b579b56ccdf9c0a11b82d82cdf049a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__41be4f7cad203c6df9fc9b76faa4f7ce956d4f3a2d89c536e39336c9b48ada26)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0a383f05d635857bb7db17ebc390fa25c3a2dd93e76b307ce70d07916f81f099)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeMonoHue]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeMonoHue]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9f0c14f337ca5e482e44385d9e7a798221fa5f278ddff8d3d3d9f445f8d1e414)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeMonoHueOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeMonoHueOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__226f45444ebd2f8200fad59752df1c1776148f74a6c84fd8b4303a33195bf184)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4576b5b35f552828cef880bcf583ec5923adff62a7d4c79687fef8662a1aaa4c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3dd93a9a3bd04f0ef462f3e9d93497d3d33a272b44d3b7d0fb13afe8affff85c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeMonoHue]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeMonoHue]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeMonoHue]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f11768013ecce076539ceb31b18bbb1ca9772fb684b4b4c1908ad92c80e06e7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeOpacity",
    jsii_struct_bases=[],
    name_mapping={"opacity": "opacity", "opacity_var": "opacityVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeOpacity:
    def __init__(
        self,
        *,
        opacity: typing.Optional[builtins.str] = None,
        opacity_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param opacity: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param opacity_var: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__48d3af527612ed1b038ab100efa79cd0591c69b1369a6234ae69e7d4ef070ff0)
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument opacity_var", value=opacity_var, expected_type=type_hints["opacity_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if opacity is not None:
            self._values["opacity"] = opacity
        if opacity_var is not None:
            self._values["opacity_var"] = opacity_var

    @builtins.property
    def opacity(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def opacity_var(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        result = self._values.get("opacity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeOpacity(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeOpacityList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeOpacityList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e5345248ee6b30e28c4fd4241b2659545a147584afb9a24de6c66b9e1b05d47)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeOpacityOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__760baa55f209a0e901042adca91028bbe98faf4147c53e1a1425d0307cfe33d0)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeOpacityOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4e2b35c393de2437f76f6bc9f57d799181f43a1ad23b22b728e5b0d6b42523a2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7a29a698ccc356b48d45265d675ed32994f390e1d32f30066318916a0bf1fed2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f0166754703faddb3dc17ba8ef11e45d898002e4425a2f9c999b2f9bbdd3161b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeOpacity]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeOpacity]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af542a6c1acf417cb7da17d79bac36fe6c1268edea9f371b5fe6311b6e850777)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeOpacityOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeOpacityOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eb4803b7a315e719725b506030aeb706dc035a857933c25665f594d1a59bc662)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetOpacityVar")
    def reset_opacity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacityVar", []))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityVarInput")
    def opacity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacity"))

    @opacity.setter
    def opacity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e39413c74c27434d7df61b3e9815f4d34df89a1ebb2fb32e628a010a9f5c274b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacity", value)

    @builtins.property
    @jsii.member(jsii_name="opacityVar")
    def opacity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacityVar"))

    @opacity_var.setter
    def opacity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a2c9f488235d6116bb298accb384c728d677f202b6d571a7d64c72dcc0eef576)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacityVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeOpacity]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeOpacity]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeOpacity]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__453f151deacc28ab43b56a7258eb8501bd006684084708ec35fb19cbc973a09c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1b302cc872fca26411b44157aae80320760e3c22757b22613ce9b80203b97dcd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putAppend")
    def put_append(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppend, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__128430f26a6e6429155a605a364c41e8b632da2fc54dfdb6050be8198f4bf46e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putAppend", [value]))

    @jsii.member(jsii_name="putAspectCrop")
    def put_aspect_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAspectCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7956ff23a1039a6af147e2098f641ff23eb1c85e9758499aacdfb7690f117b39)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putAspectCrop", [value]))

    @jsii.member(jsii_name="putBackgroundColor")
    def put_background_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6268f6a33900a359cb7de9e282a4d12b5c7de2e9b50599584235ef0589e5ece2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBackgroundColor", [value]))

    @jsii.member(jsii_name="putBlur")
    def put_blur(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeBlur, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__29aa661667d7a65bd704f31f346997a92309d77f0c4857c698658927b673b40e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBlur", [value]))

    @jsii.member(jsii_name="putChromaKey")
    def put_chroma_key(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeChromaKey, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__189201c35aac031e666a7c71fdf5d190f4c753d82b210c4c54133abb3ca99b50)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putChromaKey", [value]))

    @jsii.member(jsii_name="putComposite")
    def put_composite(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeComposite, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d64b6c4ad7ca708264b87cd9d82761d07b53316909a67825ced8da3b61305b7b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putComposite", [value]))

    @jsii.member(jsii_name="putCompound")
    def put_compound(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompound, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d05a2c155263b6ca4e66c81fd2e6066360564aa85ab6b00ddc947c1d623f59b5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCompound", [value]))

    @jsii.member(jsii_name="putContrast")
    def put_contrast(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeContrast, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c21618b789d6255222aa4a504089d2c25d07736583fb5e47fc5c1163b040ac4c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putContrast", [value]))

    @jsii.member(jsii_name="putCrop")
    def put_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ef16d20cca2edf1851ac52e317d7dc835bfe5349d9a79b4cc254ca2039999f50)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCrop", [value]))

    @jsii.member(jsii_name="putFaceCrop")
    def put_face_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFaceCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__04d94877e6c9c358e8d54d61b0c0f30f1827b3b4937ba08e98cd14226055ce26)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFaceCrop", [value]))

    @jsii.member(jsii_name="putFeatureCrop")
    def put_feature_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFeatureCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0b1af3f0297a7d7c7fedba51c83c5eaa576e8210bfb36ff9d706873b982340b6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFeatureCrop", [value]))

    @jsii.member(jsii_name="putFitAndFill")
    def put_fit_and_fill(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFill, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ae16b6dbd88f0f1d99d2f25154bd9e02e85a2eebc8740aa95ba80a5752a29032)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFitAndFill", [value]))

    @jsii.member(jsii_name="putGoop")
    def put_goop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeGoop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c6eb2c2fe7949978d2584b3567a581f3a960938d0c6964b445f4d54053cb5d78)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGoop", [value]))

    @jsii.member(jsii_name="putGrayscale")
    def put_grayscale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeGrayscale, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f0153f0d54fea8946f12ad0162487b78a583506b060f0a7b75f878505326968e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGrayscale", [value]))

    @jsii.member(jsii_name="putHsl")
    def put_hsl(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeHsl, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eb4b4570cfaf0e4a875cb7ea56d59c073c053054f99471849016172b8d422b47)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsl", [value]))

    @jsii.member(jsii_name="putHsv")
    def put_hsv(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeHsv, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__818e115aa67a2ae1d7542a4b9817c7c41aa8da72d9867befc81fc533fa773fee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsv", [value]))

    @jsii.member(jsii_name="putIfDimension")
    def put_if_dimension(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimension, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d67a67d5b75c7273617517b26c2be78f3e4d1e0a353c053f5dd5ddeb67f7df1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfDimension", [value]))

    @jsii.member(jsii_name="putIfOrientation")
    def put_if_orientation(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab19b2719458465c9e9e5f97d01902d560cb2efc57f31685f85bab71f1ee89cd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfOrientation", [value]))

    @jsii.member(jsii_name="putImQuery")
    def put_im_query(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeImQuery, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__01ac5fab241dcdfb7c9959553deb11fa9a4e689b8eea783dee9b40fe6173b100)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putImQuery", [value]))

    @jsii.member(jsii_name="putMaxColors")
    def put_max_colors(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeMaxColors, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1e03406cd1b83f3e42b25df2b50a04b75e7004600c5d635942e95aa1d18bed43)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMaxColors", [value]))

    @jsii.member(jsii_name="putMirror")
    def put_mirror(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeMirror, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8ab1a27c1434066d9198da23d8c294cd1bd5241833bfc108b159beed2a2c1152)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMirror", [value]))

    @jsii.member(jsii_name="putMonoHue")
    def put_mono_hue(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeMonoHue, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__227ff7adc15c5bc61b0eea74e1723514dc247493a2dd37c3370a8b36e47fe0f8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMonoHue", [value]))

    @jsii.member(jsii_name="putOpacity")
    def put_opacity(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeOpacity, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a7b9783d847a895216406c13b5eed45e108408f25d76bff70c16ec9e0373a424)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putOpacity", [value]))

    @jsii.member(jsii_name="putRegionOfInterestCrop")
    def put_region_of_interest_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCrop", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6031d29700d529472004924659f155b0a09d70905b2d025f425b6394142a538e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRegionOfInterestCrop", [value]))

    @jsii.member(jsii_name="putRelativeCrop")
    def put_relative_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRelativeCrop", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__26a7e99ac832a75971d79822aa0f14315abfa3ffd684606aa41364dfe0349cdd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRelativeCrop", [value]))

    @jsii.member(jsii_name="putRemoveColor")
    def put_remove_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRemoveColor", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5458f12f1bfc0971c28a35385ac0ba80e5db8e130f79616437ea5c5c7bee3380)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRemoveColor", [value]))

    @jsii.member(jsii_name="putResize")
    def put_resize(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeResize", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c7483e6efc6206687e57fa47529d1d7cd3dfed6d043a8d7b933011c9a274287d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putResize", [value]))

    @jsii.member(jsii_name="putRotate")
    def put_rotate(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRotate", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__78884975b6c5b4aad3df944fa302ccb9e6bc00561bfd544feca5238f1f8cda8e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRotate", [value]))

    @jsii.member(jsii_name="putScale")
    def put_scale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeScale", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__05ce895b7b824e538a4d6061b63e43faf4a673cfd8d61c8daba3154093293b23)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putScale", [value]))

    @jsii.member(jsii_name="putShear")
    def put_shear(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeShear", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4062b9075254556aaad46e4b23207249197dc4ae83fcd7afb4f77510fee2909f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putShear", [value]))

    @jsii.member(jsii_name="putTrim")
    def put_trim(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeTrim", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__de7998793fde77bfa6b7d1f07ce0ff5d08c98b47f8a6ee1937a3166443218d08)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTrim", [value]))

    @jsii.member(jsii_name="putUnsharpMask")
    def put_unsharp_mask(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeUnsharpMask", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f1237ab2037978984becd22873a43651c26f086674551e88c10045ff1e5031a4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putUnsharpMask", [value]))

    @jsii.member(jsii_name="resetAppend")
    def reset_append(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAppend", []))

    @jsii.member(jsii_name="resetAspectCrop")
    def reset_aspect_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspectCrop", []))

    @jsii.member(jsii_name="resetBackgroundColor")
    def reset_background_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBackgroundColor", []))

    @jsii.member(jsii_name="resetBlur")
    def reset_blur(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBlur", []))

    @jsii.member(jsii_name="resetChromaKey")
    def reset_chroma_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChromaKey", []))

    @jsii.member(jsii_name="resetComposite")
    def reset_composite(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetComposite", []))

    @jsii.member(jsii_name="resetCompound")
    def reset_compound(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCompound", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetCrop")
    def reset_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCrop", []))

    @jsii.member(jsii_name="resetFaceCrop")
    def reset_face_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFaceCrop", []))

    @jsii.member(jsii_name="resetFeatureCrop")
    def reset_feature_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureCrop", []))

    @jsii.member(jsii_name="resetFitAndFill")
    def reset_fit_and_fill(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFitAndFill", []))

    @jsii.member(jsii_name="resetGoop")
    def reset_goop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGoop", []))

    @jsii.member(jsii_name="resetGrayscale")
    def reset_grayscale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGrayscale", []))

    @jsii.member(jsii_name="resetHsl")
    def reset_hsl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsl", []))

    @jsii.member(jsii_name="resetHsv")
    def reset_hsv(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsv", []))

    @jsii.member(jsii_name="resetIfDimension")
    def reset_if_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfDimension", []))

    @jsii.member(jsii_name="resetIfOrientation")
    def reset_if_orientation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfOrientation", []))

    @jsii.member(jsii_name="resetImQuery")
    def reset_im_query(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetImQuery", []))

    @jsii.member(jsii_name="resetMaxColors")
    def reset_max_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxColors", []))

    @jsii.member(jsii_name="resetMirror")
    def reset_mirror(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMirror", []))

    @jsii.member(jsii_name="resetMonoHue")
    def reset_mono_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonoHue", []))

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetRegionOfInterestCrop")
    def reset_region_of_interest_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRegionOfInterestCrop", []))

    @jsii.member(jsii_name="resetRelativeCrop")
    def reset_relative_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRelativeCrop", []))

    @jsii.member(jsii_name="resetRemoveColor")
    def reset_remove_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRemoveColor", []))

    @jsii.member(jsii_name="resetResize")
    def reset_resize(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetResize", []))

    @jsii.member(jsii_name="resetRotate")
    def reset_rotate(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRotate", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetShear")
    def reset_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetShear", []))

    @jsii.member(jsii_name="resetTrim")
    def reset_trim(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTrim", []))

    @jsii.member(jsii_name="resetUnsharpMask")
    def reset_unsharp_mask(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUnsharpMask", []))

    @builtins.property
    @jsii.member(jsii_name="append")
    def append(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendList, jsii.get(self, "append"))

    @builtins.property
    @jsii.member(jsii_name="aspectCrop")
    def aspect_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAspectCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAspectCropList, jsii.get(self, "aspectCrop"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColor")
    def background_color(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeBackgroundColorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeBackgroundColorList, jsii.get(self, "backgroundColor"))

    @builtins.property
    @jsii.member(jsii_name="blur")
    def blur(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeBlurList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeBlurList, jsii.get(self, "blur"))

    @builtins.property
    @jsii.member(jsii_name="chromaKey")
    def chroma_key(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeChromaKeyList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeChromaKeyList, jsii.get(self, "chromaKey"))

    @builtins.property
    @jsii.member(jsii_name="composite")
    def composite(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeList, jsii.get(self, "composite"))

    @builtins.property
    @jsii.member(jsii_name="compound")
    def compound(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompoundList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompoundList, jsii.get(self, "compound"))

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeContrastList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeContrastList, jsii.get(self, "contrast"))

    @builtins.property
    @jsii.member(jsii_name="crop")
    def crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCropList, jsii.get(self, "crop"))

    @builtins.property
    @jsii.member(jsii_name="faceCrop")
    def face_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFaceCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFaceCropList, jsii.get(self, "faceCrop"))

    @builtins.property
    @jsii.member(jsii_name="featureCrop")
    def feature_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFeatureCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFeatureCropList, jsii.get(self, "featureCrop"))

    @builtins.property
    @jsii.member(jsii_name="fitAndFill")
    def fit_and_fill(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillList, jsii.get(self, "fitAndFill"))

    @builtins.property
    @jsii.member(jsii_name="goop")
    def goop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeGoopList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeGoopList, jsii.get(self, "goop"))

    @builtins.property
    @jsii.member(jsii_name="grayscale")
    def grayscale(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeGrayscaleList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeGrayscaleList, jsii.get(self, "grayscale"))

    @builtins.property
    @jsii.member(jsii_name="hsl")
    def hsl(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeHslList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeHslList, jsii.get(self, "hsl"))

    @builtins.property
    @jsii.member(jsii_name="hsv")
    def hsv(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeHsvList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeHsvList, jsii.get(self, "hsv"))

    @builtins.property
    @jsii.member(jsii_name="ifDimension")
    def if_dimension(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionList, jsii.get(self, "ifDimension"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientation")
    def if_orientation(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationList", jsii.get(self, "ifOrientation"))

    @builtins.property
    @jsii.member(jsii_name="imQuery")
    def im_query(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeImQueryList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeImQueryList, jsii.get(self, "imQuery"))

    @builtins.property
    @jsii.member(jsii_name="maxColors")
    def max_colors(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeMaxColorsList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeMaxColorsList, jsii.get(self, "maxColors"))

    @builtins.property
    @jsii.member(jsii_name="mirror")
    def mirror(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeMirrorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeMirrorList, jsii.get(self, "mirror"))

    @builtins.property
    @jsii.member(jsii_name="monoHue")
    def mono_hue(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeMonoHueList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeMonoHueList, jsii.get(self, "monoHue"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeOpacityList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeOpacityList, jsii.get(self, "opacity"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestCrop")
    def region_of_interest_crop(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropList", jsii.get(self, "regionOfInterestCrop"))

    @builtins.property
    @jsii.member(jsii_name="relativeCrop")
    def relative_crop(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRelativeCropList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRelativeCropList", jsii.get(self, "relativeCrop"))

    @builtins.property
    @jsii.member(jsii_name="removeColor")
    def remove_color(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRemoveColorList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRemoveColorList", jsii.get(self, "removeColor"))

    @builtins.property
    @jsii.member(jsii_name="resize")
    def resize(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeResizeList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeResizeList", jsii.get(self, "resize"))

    @builtins.property
    @jsii.member(jsii_name="rotate")
    def rotate(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRotateList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRotateList", jsii.get(self, "rotate"))

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeScaleList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeScaleList", jsii.get(self, "scale"))

    @builtins.property
    @jsii.member(jsii_name="shear")
    def shear(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeShearList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeShearList", jsii.get(self, "shear"))

    @builtins.property
    @jsii.member(jsii_name="trim")
    def trim(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeTrimList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeTrimList", jsii.get(self, "trim"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMask")
    def unsharp_mask(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeUnsharpMaskList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeUnsharpMaskList", jsii.get(self, "unsharpMask"))

    @builtins.property
    @jsii.member(jsii_name="appendInput")
    def append_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppend]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppend]]], jsii.get(self, "appendInput"))

    @builtins.property
    @jsii.member(jsii_name="aspectCropInput")
    def aspect_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAspectCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAspectCrop]]], jsii.get(self, "aspectCropInput"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColorInput")
    def background_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeBackgroundColor]]], jsii.get(self, "backgroundColorInput"))

    @builtins.property
    @jsii.member(jsii_name="blurInput")
    def blur_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeBlur]]], jsii.get(self, "blurInput"))

    @builtins.property
    @jsii.member(jsii_name="chromaKeyInput")
    def chroma_key_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeChromaKey]]], jsii.get(self, "chromaKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="compositeInput")
    def composite_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeComposite]]], jsii.get(self, "compositeInput"))

    @builtins.property
    @jsii.member(jsii_name="compoundInput")
    def compound_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompound]]], jsii.get(self, "compoundInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeContrast]]], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="cropInput")
    def crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCrop]]], jsii.get(self, "cropInput"))

    @builtins.property
    @jsii.member(jsii_name="faceCropInput")
    def face_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFaceCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFaceCrop]]], jsii.get(self, "faceCropInput"))

    @builtins.property
    @jsii.member(jsii_name="featureCropInput")
    def feature_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFeatureCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFeatureCrop]]], jsii.get(self, "featureCropInput"))

    @builtins.property
    @jsii.member(jsii_name="fitAndFillInput")
    def fit_and_fill_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFill]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFill]]], jsii.get(self, "fitAndFillInput"))

    @builtins.property
    @jsii.member(jsii_name="goopInput")
    def goop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeGoop]]], jsii.get(self, "goopInput"))

    @builtins.property
    @jsii.member(jsii_name="grayscaleInput")
    def grayscale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeGrayscale]]], jsii.get(self, "grayscaleInput"))

    @builtins.property
    @jsii.member(jsii_name="hslInput")
    def hsl_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeHsl]]], jsii.get(self, "hslInput"))

    @builtins.property
    @jsii.member(jsii_name="hsvInput")
    def hsv_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeHsv]]], jsii.get(self, "hsvInput"))

    @builtins.property
    @jsii.member(jsii_name="ifDimensionInput")
    def if_dimension_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimension]]], jsii.get(self, "ifDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientationInput")
    def if_orientation_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientation]]], jsii.get(self, "ifOrientationInput"))

    @builtins.property
    @jsii.member(jsii_name="imQueryInput")
    def im_query_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeImQuery]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeImQuery]]], jsii.get(self, "imQueryInput"))

    @builtins.property
    @jsii.member(jsii_name="maxColorsInput")
    def max_colors_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeMaxColors]]], jsii.get(self, "maxColorsInput"))

    @builtins.property
    @jsii.member(jsii_name="mirrorInput")
    def mirror_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeMirror]]], jsii.get(self, "mirrorInput"))

    @builtins.property
    @jsii.member(jsii_name="monoHueInput")
    def mono_hue_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeMonoHue]]], jsii.get(self, "monoHueInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeOpacity]]], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestCropInput")
    def region_of_interest_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCrop"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCrop"]]], jsii.get(self, "regionOfInterestCropInput"))

    @builtins.property
    @jsii.member(jsii_name="relativeCropInput")
    def relative_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRelativeCrop"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRelativeCrop"]]], jsii.get(self, "relativeCropInput"))

    @builtins.property
    @jsii.member(jsii_name="removeColorInput")
    def remove_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRemoveColor"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRemoveColor"]]], jsii.get(self, "removeColorInput"))

    @builtins.property
    @jsii.member(jsii_name="resizeInput")
    def resize_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeResize"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeResize"]]], jsii.get(self, "resizeInput"))

    @builtins.property
    @jsii.member(jsii_name="rotateInput")
    def rotate_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRotate"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRotate"]]], jsii.get(self, "rotateInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeScale"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeScale"]]], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="shearInput")
    def shear_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeShear"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeShear"]]], jsii.get(self, "shearInput"))

    @builtins.property
    @jsii.member(jsii_name="trimInput")
    def trim_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeTrim"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeTrim"]]], jsii.get(self, "trimInput"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMaskInput")
    def unsharp_mask_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeUnsharpMask"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeUnsharpMask"]]], jsii.get(self, "unsharpMaskInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscape], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscape],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c9686a83ac851e3589bb3075ce1a4f7714c1a97c7432a1f2fd575c3619639de6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCrop",
    jsii_struct_bases=[],
    name_mapping={
        "region_of_interest": "regionOfInterest",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCrop:
    def __init__(
        self,
        *,
        region_of_interest: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterest", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param region_of_interest: region_of_interest block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest DataAkamaiImagingPolicyImage#region_of_interest}
        :param gravity: The placement of the crop area relative to the specified area of interest. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: The placement of the crop area relative to the specified area of interest. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param style: Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(region_of_interest, dict):
            region_of_interest = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterest(**region_of_interest)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f53b730267f5c27c7e75cac2267dedd2e6750eaf41d0941be07daa7b37fafc42)
            check_type(argname="argument region_of_interest", value=region_of_interest, expected_type=type_hints["region_of_interest"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "region_of_interest": region_of_interest,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def region_of_interest(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterest":
        '''region_of_interest block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest DataAkamaiImagingPolicyImage#region_of_interest}
        '''
        result = self._values.get("region_of_interest")
        assert result is not None, "Required property 'region_of_interest' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterest", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''The placement of the crop area relative to the specified area of interest.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''The placement of the crop area relative to the specified area of interest.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__67f63eb335a9b445dc466324e4e9337996ba15d303eca30eb7262e6d9d87a6a3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__555429dd1b95ad1da9ab2dbce3c89342c4f3c1a3f6d5f0337febe3fc59cec26b)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b8d7b194a2a1de634ce89ca511cc7b1cda5b53bd6956413462cc4035dcf75302)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__13cf18f070fdf08f5aa026cd5994e9c2093f42d4b65073f6d0f57aa41a30899e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__893e9e8545e10662e8959f33e66a2efb89ebc27039e7af8e5be3c559121514e1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bcd19d61937296b94e16be0826af8471bfe6e2cf7e378c3293f443644dc667c0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3dfbed782a1d9ccf10e44f42cd61fddc383bcc9886134ae6f55b9eea2d8c6cad)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putRegionOfInterest")
    def put_region_of_interest(
        self,
        *,
        circle_shape: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestCircleShape", typing.Dict[builtins.str, typing.Any]]]]] = None,
        point_shape: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestPointShape", typing.Dict[builtins.str, typing.Any]]]]] = None,
        polygon_shape: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestPolygonShape", typing.Dict[builtins.str, typing.Any]]]]] = None,
        rectangle_shape: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestRectangleShape", typing.Dict[builtins.str, typing.Any]]]]] = None,
        union_shape: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestUnionShape", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param circle_shape: circle_shape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#circle_shape DataAkamaiImagingPolicyImage#circle_shape}
        :param point_shape: point_shape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#point_shape DataAkamaiImagingPolicyImage#point_shape}
        :param polygon_shape: polygon_shape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#polygon_shape DataAkamaiImagingPolicyImage#polygon_shape}
        :param rectangle_shape: rectangle_shape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rectangle_shape DataAkamaiImagingPolicyImage#rectangle_shape}
        :param union_shape: union_shape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#union_shape DataAkamaiImagingPolicyImage#union_shape}
        '''
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterest(
            circle_shape=circle_shape,
            point_shape=point_shape,
            polygon_shape=polygon_shape,
            rectangle_shape=rectangle_shape,
            union_shape=union_shape,
        )

        return typing.cast(None, jsii.invoke(self, "putRegionOfInterest", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterest")
    def region_of_interest(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestOutputReference", jsii.get(self, "regionOfInterest"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestInput")
    def region_of_interest_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterest"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterest"], jsii.get(self, "regionOfInterestInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__edbb358e0d598a5d079ea2a0c0c4773991dcd7655c7d96fccb1259d6f4944eea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0db098dd95aa94d73b13aca1af5a2100fc34fee9115fe3c59ccde5c68f73ee3d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cc9ba2ea6af43abc6463982088099d31810911ed5c13fc6fc400592f89506b32)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__89391082dc97f228344ade111c9d07be1d4f884af3afac2e35f680bfbcdbda6d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__10a6b9f80c0fe363dfe8d977206d9299b56cca197ce860cb5d4d7fd01488741b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__15c94f75636303a6c3d7263ccd9f377b999f5b6679866d966c004ca0ee1d9704)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__62b349cbbd24d40a1a05863364f16480afa03e467a61afc0912852563e95a9b1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__20203f8fe5cc2d5f50716754bb248c20acbde0107e8762f5279977225d6c4979)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__87649769592377476fe6a2cb664d6e7065883b2c638e11ebf7015b0c6cf030fd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterest",
    jsii_struct_bases=[],
    name_mapping={
        "circle_shape": "circleShape",
        "point_shape": "pointShape",
        "polygon_shape": "polygonShape",
        "rectangle_shape": "rectangleShape",
        "union_shape": "unionShape",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterest:
    def __init__(
        self,
        *,
        circle_shape: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestCircleShape", typing.Dict[builtins.str, typing.Any]]]]] = None,
        point_shape: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestPointShape", typing.Dict[builtins.str, typing.Any]]]]] = None,
        polygon_shape: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestPolygonShape", typing.Dict[builtins.str, typing.Any]]]]] = None,
        rectangle_shape: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestRectangleShape", typing.Dict[builtins.str, typing.Any]]]]] = None,
        union_shape: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestUnionShape", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param circle_shape: circle_shape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#circle_shape DataAkamaiImagingPolicyImage#circle_shape}
        :param point_shape: point_shape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#point_shape DataAkamaiImagingPolicyImage#point_shape}
        :param polygon_shape: polygon_shape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#polygon_shape DataAkamaiImagingPolicyImage#polygon_shape}
        :param rectangle_shape: rectangle_shape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rectangle_shape DataAkamaiImagingPolicyImage#rectangle_shape}
        :param union_shape: union_shape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#union_shape DataAkamaiImagingPolicyImage#union_shape}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ca534218b2b0ab2cba2999e49a4346f639eaaebbddd5016667292242cd25cf82)
            check_type(argname="argument circle_shape", value=circle_shape, expected_type=type_hints["circle_shape"])
            check_type(argname="argument point_shape", value=point_shape, expected_type=type_hints["point_shape"])
            check_type(argname="argument polygon_shape", value=polygon_shape, expected_type=type_hints["polygon_shape"])
            check_type(argname="argument rectangle_shape", value=rectangle_shape, expected_type=type_hints["rectangle_shape"])
            check_type(argname="argument union_shape", value=union_shape, expected_type=type_hints["union_shape"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if circle_shape is not None:
            self._values["circle_shape"] = circle_shape
        if point_shape is not None:
            self._values["point_shape"] = point_shape
        if polygon_shape is not None:
            self._values["polygon_shape"] = polygon_shape
        if rectangle_shape is not None:
            self._values["rectangle_shape"] = rectangle_shape
        if union_shape is not None:
            self._values["union_shape"] = union_shape

    @builtins.property
    def circle_shape(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestCircleShape"]]]:
        '''circle_shape block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#circle_shape DataAkamaiImagingPolicyImage#circle_shape}
        '''
        result = self._values.get("circle_shape")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestCircleShape"]]], result)

    @builtins.property
    def point_shape(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestPointShape"]]]:
        '''point_shape block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#point_shape DataAkamaiImagingPolicyImage#point_shape}
        '''
        result = self._values.get("point_shape")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestPointShape"]]], result)

    @builtins.property
    def polygon_shape(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestPolygonShape"]]]:
        '''polygon_shape block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#polygon_shape DataAkamaiImagingPolicyImage#polygon_shape}
        '''
        result = self._values.get("polygon_shape")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestPolygonShape"]]], result)

    @builtins.property
    def rectangle_shape(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestRectangleShape"]]]:
        '''rectangle_shape block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rectangle_shape DataAkamaiImagingPolicyImage#rectangle_shape}
        '''
        result = self._values.get("rectangle_shape")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestRectangleShape"]]], result)

    @builtins.property
    def union_shape(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestUnionShape"]]]:
        '''union_shape block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#union_shape DataAkamaiImagingPolicyImage#union_shape}
        '''
        result = self._values.get("union_shape")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestUnionShape"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterest(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestCircleShape",
    jsii_struct_bases=[],
    name_mapping={"center": "center", "radius": "radius", "radius_var": "radiusVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestCircleShape:
    def __init__(
        self,
        *,
        center: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestCircleShapeCenter", typing.Dict[builtins.str, typing.Any]],
        radius: typing.Optional[builtins.str] = None,
        radius_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param center: center block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#center DataAkamaiImagingPolicyImage#center}
        :param radius: The radius of the circle measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#radius DataAkamaiImagingPolicyImage#radius}
        :param radius_var: The radius of the circle measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#radius_var DataAkamaiImagingPolicyImage#radius_var}
        '''
        if isinstance(center, dict):
            center = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestCircleShapeCenter(**center)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a0b64bac235db1c9c0a7f1475364d6f02a9e27fe630987ae099189bd8a0d9e72)
            check_type(argname="argument center", value=center, expected_type=type_hints["center"])
            check_type(argname="argument radius", value=radius, expected_type=type_hints["radius"])
            check_type(argname="argument radius_var", value=radius_var, expected_type=type_hints["radius_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "center": center,
        }
        if radius is not None:
            self._values["radius"] = radius
        if radius_var is not None:
            self._values["radius_var"] = radius_var

    @builtins.property
    def center(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestCircleShapeCenter":
        '''center block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#center DataAkamaiImagingPolicyImage#center}
        '''
        result = self._values.get("center")
        assert result is not None, "Required property 'center' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestCircleShapeCenter", result)

    @builtins.property
    def radius(self) -> typing.Optional[builtins.str]:
        '''The radius of the circle measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#radius DataAkamaiImagingPolicyImage#radius}
        '''
        result = self._values.get("radius")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def radius_var(self) -> typing.Optional[builtins.str]:
        '''The radius of the circle measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#radius_var DataAkamaiImagingPolicyImage#radius_var}
        '''
        result = self._values.get("radius_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestCircleShape(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestCircleShapeCenter",
    jsii_struct_bases=[],
    name_mapping={"x": "x", "x_var": "xVar", "y": "y", "y_var": "yVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestCircleShapeCenter:
    def __init__(
        self,
        *,
        x: typing.Optional[builtins.str] = None,
        x_var: typing.Optional[builtins.str] = None,
        y: typing.Optional[builtins.str] = None,
        y_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param x: The horizontal position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x DataAkamaiImagingPolicyImage#x}
        :param x_var: The horizontal position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_var DataAkamaiImagingPolicyImage#x_var}
        :param y: The vertical position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y DataAkamaiImagingPolicyImage#y}
        :param y_var: The vertical position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_var DataAkamaiImagingPolicyImage#y_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b565f1f96019052c2f90a43b318e6631a71494b84a203b43763434f56d2622c4)
            check_type(argname="argument x", value=x, expected_type=type_hints["x"])
            check_type(argname="argument x_var", value=x_var, expected_type=type_hints["x_var"])
            check_type(argname="argument y", value=y, expected_type=type_hints["y"])
            check_type(argname="argument y_var", value=y_var, expected_type=type_hints["y_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if x is not None:
            self._values["x"] = x
        if x_var is not None:
            self._values["x_var"] = x_var
        if y is not None:
            self._values["y"] = y
        if y_var is not None:
            self._values["y_var"] = y_var

    @builtins.property
    def x(self) -> typing.Optional[builtins.str]:
        '''The horizontal position of the point, measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x DataAkamaiImagingPolicyImage#x}
        '''
        result = self._values.get("x")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_var(self) -> typing.Optional[builtins.str]:
        '''The horizontal position of the point, measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_var DataAkamaiImagingPolicyImage#x_var}
        '''
        result = self._values.get("x_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y(self) -> typing.Optional[builtins.str]:
        '''The vertical position of the point, measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y DataAkamaiImagingPolicyImage#y}
        '''
        result = self._values.get("y")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_var(self) -> typing.Optional[builtins.str]:
        '''The vertical position of the point, measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_var DataAkamaiImagingPolicyImage#y_var}
        '''
        result = self._values.get("y_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestCircleShapeCenter(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestCircleShapeCenterOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestCircleShapeCenterOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a90d75f672c27aa459bac4c48f5210d3efed7dd0ee4085aa04ac5c3005fcc78)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetX")
    def reset_x(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetX", []))

    @jsii.member(jsii_name="resetXVar")
    def reset_x_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXVar", []))

    @jsii.member(jsii_name="resetY")
    def reset_y(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetY", []))

    @jsii.member(jsii_name="resetYVar")
    def reset_y_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYVar", []))

    @builtins.property
    @jsii.member(jsii_name="xInput")
    def x_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xInput"))

    @builtins.property
    @jsii.member(jsii_name="xVarInput")
    def x_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yInput")
    def y_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yInput"))

    @builtins.property
    @jsii.member(jsii_name="yVarInput")
    def y_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yVarInput"))

    @builtins.property
    @jsii.member(jsii_name="x")
    def x(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "x"))

    @x.setter
    def x(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d4f542e8eb3c6e3345ff82faeb2baceda72e737599a0fa43281ff01a82e41fd7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "x", value)

    @builtins.property
    @jsii.member(jsii_name="xVar")
    def x_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xVar"))

    @x_var.setter
    def x_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f64ca88e7b55c0b47bd6d4596629b385e00865f5d3af9ecf050e8ec88178570f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xVar", value)

    @builtins.property
    @jsii.member(jsii_name="y")
    def y(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "y"))

    @y.setter
    def y(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d7604998be42a8be17fcda7eed63448e128cbccb2a2a92274723f0535f59cc5d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "y", value)

    @builtins.property
    @jsii.member(jsii_name="yVar")
    def y_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yVar"))

    @y_var.setter
    def y_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dc852c6edcd403252e8f1a7099ecd5b6c34243af256e729dfba66825aa15e5fa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestCircleShapeCenter]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestCircleShapeCenter], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestCircleShapeCenter],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__67214c6f45665f279321ca5c0b45f20d5f641834b4aa5bce5d120da082d0e657)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestCircleShapeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestCircleShapeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc143ce7f1321750fa18bf727dd06cae81351bde2e7f221a45accd2d595a25b1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestCircleShapeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ce1d8ca5c861f3a73500791226ee2fadc9a332893afa895a9c09a5c20f518349)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestCircleShapeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e4e27447c5afa9c76bc666484a83da7ad565577486163497c3c2af8bd69d27a9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fe5f37960a90c7c619c32262bd785e7ceb57afe91838a19c073f53e9823bd096)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__04b7bfb88747065c97af2b29ddc562574b1babef9c11cd409bcb98e2852d6c19)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestCircleShape]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestCircleShape]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestCircleShape]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a1321deb68539344cdf50dc4a5e4b8869e842a637810dc8e39f16431ee29999)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestCircleShapeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestCircleShapeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__24bc2a219ab5f4a08ecc19caeb8fd2577314db15d8ccd4ba82c0ab5018613120)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putCenter")
    def put_center(
        self,
        *,
        x: typing.Optional[builtins.str] = None,
        x_var: typing.Optional[builtins.str] = None,
        y: typing.Optional[builtins.str] = None,
        y_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param x: The horizontal position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x DataAkamaiImagingPolicyImage#x}
        :param x_var: The horizontal position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_var DataAkamaiImagingPolicyImage#x_var}
        :param y: The vertical position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y DataAkamaiImagingPolicyImage#y}
        :param y_var: The vertical position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_var DataAkamaiImagingPolicyImage#y_var}
        '''
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestCircleShapeCenter(
            x=x, x_var=x_var, y=y, y_var=y_var
        )

        return typing.cast(None, jsii.invoke(self, "putCenter", [value]))

    @jsii.member(jsii_name="resetRadius")
    def reset_radius(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRadius", []))

    @jsii.member(jsii_name="resetRadiusVar")
    def reset_radius_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRadiusVar", []))

    @builtins.property
    @jsii.member(jsii_name="center")
    def center(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestCircleShapeCenterOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestCircleShapeCenterOutputReference, jsii.get(self, "center"))

    @builtins.property
    @jsii.member(jsii_name="centerInput")
    def center_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestCircleShapeCenter]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestCircleShapeCenter], jsii.get(self, "centerInput"))

    @builtins.property
    @jsii.member(jsii_name="radiusInput")
    def radius_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "radiusInput"))

    @builtins.property
    @jsii.member(jsii_name="radiusVarInput")
    def radius_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "radiusVarInput"))

    @builtins.property
    @jsii.member(jsii_name="radius")
    def radius(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "radius"))

    @radius.setter
    def radius(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f14192d3aa537beaeb10a6a0bf7a4dd498096866fbd0d168ea3ab89d08656f55)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "radius", value)

    @builtins.property
    @jsii.member(jsii_name="radiusVar")
    def radius_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "radiusVar"))

    @radius_var.setter
    def radius_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6c370f787dc466930a317c5ac206608a8f419faea0b682ea2c6b887c209aaf10)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "radiusVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestCircleShape]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestCircleShape]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestCircleShape]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7cb1eed0018deaf3d58e3af8523fab57acd320b0d1b8157e1af8c617185cb573)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ee9a123872bbc4105c34875d0cdbe7c9e8600946358dd13ff60be2db93c004af)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putCircleShape")
    def put_circle_shape(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestCircleShape, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e35ee61ba7bcc16edf242d10a3555bcedeeaeddfa565e1894e696fd2e50bb252)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCircleShape", [value]))

    @jsii.member(jsii_name="putPointShape")
    def put_point_shape(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestPointShape", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6ed6d9857b8229555573c5d8865c5f5533b171afbe14489bba616a858b90ea3b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putPointShape", [value]))

    @jsii.member(jsii_name="putPolygonShape")
    def put_polygon_shape(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestPolygonShape", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4e70d2cb74f58f25878c59110ba43df2a7500c4626da0bae5eba22b555e2a7f6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putPolygonShape", [value]))

    @jsii.member(jsii_name="putRectangleShape")
    def put_rectangle_shape(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestRectangleShape", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__690dc760264919a0f62fd0984502db6af560e023f0cea45d06b1975649d888c3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRectangleShape", [value]))

    @jsii.member(jsii_name="putUnionShape")
    def put_union_shape(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestUnionShape", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__240d92cee9e357a0f9175008709671df3d0b5f9f78394e1723e7ee429f1c3598)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putUnionShape", [value]))

    @jsii.member(jsii_name="resetCircleShape")
    def reset_circle_shape(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCircleShape", []))

    @jsii.member(jsii_name="resetPointShape")
    def reset_point_shape(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPointShape", []))

    @jsii.member(jsii_name="resetPolygonShape")
    def reset_polygon_shape(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPolygonShape", []))

    @jsii.member(jsii_name="resetRectangleShape")
    def reset_rectangle_shape(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRectangleShape", []))

    @jsii.member(jsii_name="resetUnionShape")
    def reset_union_shape(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUnionShape", []))

    @builtins.property
    @jsii.member(jsii_name="circleShape")
    def circle_shape(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestCircleShapeList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestCircleShapeList, jsii.get(self, "circleShape"))

    @builtins.property
    @jsii.member(jsii_name="pointShape")
    def point_shape(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestPointShapeList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestPointShapeList", jsii.get(self, "pointShape"))

    @builtins.property
    @jsii.member(jsii_name="polygonShape")
    def polygon_shape(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestPolygonShapeList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestPolygonShapeList", jsii.get(self, "polygonShape"))

    @builtins.property
    @jsii.member(jsii_name="rectangleShape")
    def rectangle_shape(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestRectangleShapeList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestRectangleShapeList", jsii.get(self, "rectangleShape"))

    @builtins.property
    @jsii.member(jsii_name="unionShape")
    def union_shape(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestUnionShapeList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestUnionShapeList", jsii.get(self, "unionShape"))

    @builtins.property
    @jsii.member(jsii_name="circleShapeInput")
    def circle_shape_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestCircleShape]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestCircleShape]]], jsii.get(self, "circleShapeInput"))

    @builtins.property
    @jsii.member(jsii_name="pointShapeInput")
    def point_shape_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestPointShape"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestPointShape"]]], jsii.get(self, "pointShapeInput"))

    @builtins.property
    @jsii.member(jsii_name="polygonShapeInput")
    def polygon_shape_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestPolygonShape"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestPolygonShape"]]], jsii.get(self, "polygonShapeInput"))

    @builtins.property
    @jsii.member(jsii_name="rectangleShapeInput")
    def rectangle_shape_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestRectangleShape"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestRectangleShape"]]], jsii.get(self, "rectangleShapeInput"))

    @builtins.property
    @jsii.member(jsii_name="unionShapeInput")
    def union_shape_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestUnionShape"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestUnionShape"]]], jsii.get(self, "unionShapeInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterest]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterest], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterest],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ccce24d6d5307ca714fad6a8d86c3c99fd24ce7d7c02029830ce8a4692192745)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestPointShape",
    jsii_struct_bases=[],
    name_mapping={"x": "x", "x_var": "xVar", "y": "y", "y_var": "yVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestPointShape:
    def __init__(
        self,
        *,
        x: typing.Optional[builtins.str] = None,
        x_var: typing.Optional[builtins.str] = None,
        y: typing.Optional[builtins.str] = None,
        y_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param x: The horizontal position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x DataAkamaiImagingPolicyImage#x}
        :param x_var: The horizontal position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_var DataAkamaiImagingPolicyImage#x_var}
        :param y: The vertical position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y DataAkamaiImagingPolicyImage#y}
        :param y_var: The vertical position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_var DataAkamaiImagingPolicyImage#y_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__32301f6567fdf3c6991a9f3d8e2c1559e62073fc2c59bbc101f768f86bc3128c)
            check_type(argname="argument x", value=x, expected_type=type_hints["x"])
            check_type(argname="argument x_var", value=x_var, expected_type=type_hints["x_var"])
            check_type(argname="argument y", value=y, expected_type=type_hints["y"])
            check_type(argname="argument y_var", value=y_var, expected_type=type_hints["y_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if x is not None:
            self._values["x"] = x
        if x_var is not None:
            self._values["x_var"] = x_var
        if y is not None:
            self._values["y"] = y
        if y_var is not None:
            self._values["y_var"] = y_var

    @builtins.property
    def x(self) -> typing.Optional[builtins.str]:
        '''The horizontal position of the point, measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x DataAkamaiImagingPolicyImage#x}
        '''
        result = self._values.get("x")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_var(self) -> typing.Optional[builtins.str]:
        '''The horizontal position of the point, measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_var DataAkamaiImagingPolicyImage#x_var}
        '''
        result = self._values.get("x_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y(self) -> typing.Optional[builtins.str]:
        '''The vertical position of the point, measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y DataAkamaiImagingPolicyImage#y}
        '''
        result = self._values.get("y")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_var(self) -> typing.Optional[builtins.str]:
        '''The vertical position of the point, measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_var DataAkamaiImagingPolicyImage#y_var}
        '''
        result = self._values.get("y_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestPointShape(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestPointShapeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestPointShapeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__662a3fd4eb0ebf518cca6f3e9d6c98c8d9586ad4128b76543e985a3e8a1a7052)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestPointShapeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__abeaf3d4889687d0bf2e4738fa77b92a6914cda657ea17587544e55aa3f46368)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestPointShapeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ea32aab99a4f546253dad990f5a422c3baec079286cf085e3c657b9ebaf2464)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e8021436848edc1b1234a2c4f79ed73626511899183a2dff248446ad87713c01)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__81c862aaa676363b8567aa1955615bf159297b34a408371369ff77ca92c2c27c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestPointShape]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestPointShape]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestPointShape]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c5ba9da9c808fd9df34f8e6067346f319c150c9b44ec4ce7dfac0c32b5d44ecb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestPointShapeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestPointShapeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b7fa5045e755614c94e5b61fecbefe52361f8e2fd41d84c21ec3bf78ff9db3fb)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetX")
    def reset_x(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetX", []))

    @jsii.member(jsii_name="resetXVar")
    def reset_x_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXVar", []))

    @jsii.member(jsii_name="resetY")
    def reset_y(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetY", []))

    @jsii.member(jsii_name="resetYVar")
    def reset_y_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYVar", []))

    @builtins.property
    @jsii.member(jsii_name="xInput")
    def x_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xInput"))

    @builtins.property
    @jsii.member(jsii_name="xVarInput")
    def x_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yInput")
    def y_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yInput"))

    @builtins.property
    @jsii.member(jsii_name="yVarInput")
    def y_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yVarInput"))

    @builtins.property
    @jsii.member(jsii_name="x")
    def x(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "x"))

    @x.setter
    def x(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a84d07e08603a4bb167caf4eaa8aa08e620d1c30661526227127b9bb0cf5d0fa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "x", value)

    @builtins.property
    @jsii.member(jsii_name="xVar")
    def x_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xVar"))

    @x_var.setter
    def x_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1a6a58d4eb821d4bc5b4b4c85647fa61cf44ce6e718193850e2f0a377a353577)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xVar", value)

    @builtins.property
    @jsii.member(jsii_name="y")
    def y(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "y"))

    @y.setter
    def y(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d835d121e0dbfe95fdf3c73168daf23b9810f919498e9bc5aabe0a79b3a26883)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "y", value)

    @builtins.property
    @jsii.member(jsii_name="yVar")
    def y_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yVar"))

    @y_var.setter
    def y_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__760641b57fe8ab3ce954fa5dca8260879dbbe14624d3f3889ec5e52aa6b202d8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestPointShape]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestPointShape]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestPointShape]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__51e3fee64372f48c5dc57f9257d037ec85e49883c518064647726468bb11b274)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestPolygonShape",
    jsii_struct_bases=[],
    name_mapping={"points": "points"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestPolygonShape:
    def __init__(
        self,
        *,
        points: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestPolygonShapePoints", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param points: points block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#points DataAkamaiImagingPolicyImage#points}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dbd4449e7fa56996b3f1e671807e4434c23cf6670140bdd508769a5a8929d503)
            check_type(argname="argument points", value=points, expected_type=type_hints["points"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "points": points,
        }

    @builtins.property
    def points(
        self,
    ) -> typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestPolygonShapePoints"]]:
        '''points block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#points DataAkamaiImagingPolicyImage#points}
        '''
        result = self._values.get("points")
        assert result is not None, "Required property 'points' is missing"
        return typing.cast(typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestPolygonShapePoints"]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestPolygonShape(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestPolygonShapeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestPolygonShapeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c8e0a78e0a47a88c8b91cee7287964d2b814260604f1da445215f3925460c542)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestPolygonShapeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8271340332012c59cb4e2cef90c3e9830dc057c4ba3fcb3cb0e05b5adfafa184)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestPolygonShapeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa009802c7868570f53c9be1dae07430f0a8876cfc6b9bf471618de616417da2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__130afcc86ada340b9f684d3d1b596b01368bd7ea5342ab8c2b43d15ef9838349)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d19d9c4b37ab95b8d6235fd0a0c9a6db53c846a188b2310713e9ab2a60589378)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestPolygonShape]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestPolygonShape]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestPolygonShape]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a6b2d74cf7568042f263d5955f506dc2567b339e42f08373a942aba31d23ca07)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestPolygonShapeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestPolygonShapeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b0e3c2f2462a2a43de8e66616460f30fedff5b27fac609d523a0e06268830f8c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putPoints")
    def put_points(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestPolygonShapePoints", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5d36a70e3560adfe1a6095ae475bf8be443c8a5b4ba4dd098578b2e8f0262291)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putPoints", [value]))

    @builtins.property
    @jsii.member(jsii_name="points")
    def points(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestPolygonShapePointsList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestPolygonShapePointsList", jsii.get(self, "points"))

    @builtins.property
    @jsii.member(jsii_name="pointsInput")
    def points_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestPolygonShapePoints"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestPolygonShapePoints"]]], jsii.get(self, "pointsInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestPolygonShape]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestPolygonShape]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestPolygonShape]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b10fe190a63142d1d8f9560cd3d4e8476ae6d191b4ea6f9241868d72e7d69f55)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestPolygonShapePoints",
    jsii_struct_bases=[],
    name_mapping={"x": "x", "x_var": "xVar", "y": "y", "y_var": "yVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestPolygonShapePoints:
    def __init__(
        self,
        *,
        x: typing.Optional[builtins.str] = None,
        x_var: typing.Optional[builtins.str] = None,
        y: typing.Optional[builtins.str] = None,
        y_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param x: The horizontal position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x DataAkamaiImagingPolicyImage#x}
        :param x_var: The horizontal position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_var DataAkamaiImagingPolicyImage#x_var}
        :param y: The vertical position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y DataAkamaiImagingPolicyImage#y}
        :param y_var: The vertical position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_var DataAkamaiImagingPolicyImage#y_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__38d60cf813de6924c9926bb0a4258bd09dcb07f9af38eb5dfa4af33ba9791e52)
            check_type(argname="argument x", value=x, expected_type=type_hints["x"])
            check_type(argname="argument x_var", value=x_var, expected_type=type_hints["x_var"])
            check_type(argname="argument y", value=y, expected_type=type_hints["y"])
            check_type(argname="argument y_var", value=y_var, expected_type=type_hints["y_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if x is not None:
            self._values["x"] = x
        if x_var is not None:
            self._values["x_var"] = x_var
        if y is not None:
            self._values["y"] = y
        if y_var is not None:
            self._values["y_var"] = y_var

    @builtins.property
    def x(self) -> typing.Optional[builtins.str]:
        '''The horizontal position of the point, measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x DataAkamaiImagingPolicyImage#x}
        '''
        result = self._values.get("x")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_var(self) -> typing.Optional[builtins.str]:
        '''The horizontal position of the point, measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_var DataAkamaiImagingPolicyImage#x_var}
        '''
        result = self._values.get("x_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y(self) -> typing.Optional[builtins.str]:
        '''The vertical position of the point, measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y DataAkamaiImagingPolicyImage#y}
        '''
        result = self._values.get("y")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_var(self) -> typing.Optional[builtins.str]:
        '''The vertical position of the point, measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_var DataAkamaiImagingPolicyImage#y_var}
        '''
        result = self._values.get("y_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestPolygonShapePoints(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestPolygonShapePointsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestPolygonShapePointsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__36249b2bcb714669c9f2c8bd3d5c8e7a140338855e92cd99d1d5c334b1d9018e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestPolygonShapePointsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9f4778d4f619bf63ca7ab8511a7cded1ef7dd731bf52c7021d9681d94ab2794e)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestPolygonShapePointsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__13f6af38e0c50dfd21b3bd052fbda5186c9dc9e1cca71fdfd6b0dfabd758be60)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c90f8dd7f48d6b9c009a666f20b1778d90ef35b7d743b042f051ba504245afd2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ea1223dd17e10638cf0ffabad074ce8b500360fd9593555bcf2e9a7d6bf64f1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestPolygonShapePoints]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestPolygonShapePoints]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestPolygonShapePoints]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__08f2ffe182a67cfb66d77f30a4a2cd977c7eb870335607a38d50c48febc1f29b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestPolygonShapePointsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestPolygonShapePointsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__67a665990b2ada36f73fc880732f326c3a48f72e128e834391920bb5c778c40c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetX")
    def reset_x(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetX", []))

    @jsii.member(jsii_name="resetXVar")
    def reset_x_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXVar", []))

    @jsii.member(jsii_name="resetY")
    def reset_y(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetY", []))

    @jsii.member(jsii_name="resetYVar")
    def reset_y_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYVar", []))

    @builtins.property
    @jsii.member(jsii_name="xInput")
    def x_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xInput"))

    @builtins.property
    @jsii.member(jsii_name="xVarInput")
    def x_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yInput")
    def y_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yInput"))

    @builtins.property
    @jsii.member(jsii_name="yVarInput")
    def y_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yVarInput"))

    @builtins.property
    @jsii.member(jsii_name="x")
    def x(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "x"))

    @x.setter
    def x(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__095ac57c17af74f53f37fb725097f356cfe01c7bd2598aa8536ba91c06d83f51)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "x", value)

    @builtins.property
    @jsii.member(jsii_name="xVar")
    def x_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xVar"))

    @x_var.setter
    def x_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f59b0ad5275eb0ac159a3fabbfce702a169f8d488b9c072481449432dd69900d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xVar", value)

    @builtins.property
    @jsii.member(jsii_name="y")
    def y(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "y"))

    @y.setter
    def y(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c5e251e39ba3b4fb6f79fce178dcefb87dc19d9cbef153ff15bf95a4694a2bef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "y", value)

    @builtins.property
    @jsii.member(jsii_name="yVar")
    def y_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yVar"))

    @y_var.setter
    def y_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ee1ee84b607ba9e5ed691481386c09719da19bd148c5c4cf3acf480fd040097)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestPolygonShapePoints]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestPolygonShapePoints]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestPolygonShapePoints]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__65716cbfbe41495e9dcc959bfb2e1e54e47f184c3bc3490c5f7c6d8ca1fa7341)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestRectangleShape",
    jsii_struct_bases=[],
    name_mapping={
        "anchor": "anchor",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestRectangleShape:
    def __init__(
        self,
        *,
        anchor: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestRectangleShapeAnchor", typing.Dict[builtins.str, typing.Any]],
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param anchor: anchor block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#anchor DataAkamaiImagingPolicyImage#anchor}
        :param height: Extends the rectangle down from the ``anchor`` point. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: Extends the rectangle down from the ``anchor`` point. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: Extends the rectangle right from the ``anchor`` point. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: Extends the rectangle right from the ``anchor`` point. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(anchor, dict):
            anchor = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestRectangleShapeAnchor(**anchor)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cbc296c506f3a4af2d2be2e57f7d81346843ca67de032f6cddf980545694798f)
            check_type(argname="argument anchor", value=anchor, expected_type=type_hints["anchor"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "anchor": anchor,
        }
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def anchor(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestRectangleShapeAnchor":
        '''anchor block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#anchor DataAkamaiImagingPolicyImage#anchor}
        '''
        result = self._values.get("anchor")
        assert result is not None, "Required property 'anchor' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestRectangleShapeAnchor", result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''Extends the rectangle down from the ``anchor`` point.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''Extends the rectangle down from the ``anchor`` point.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''Extends the rectangle right from the ``anchor`` point.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''Extends the rectangle right from the ``anchor`` point.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestRectangleShape(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestRectangleShapeAnchor",
    jsii_struct_bases=[],
    name_mapping={"x": "x", "x_var": "xVar", "y": "y", "y_var": "yVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestRectangleShapeAnchor:
    def __init__(
        self,
        *,
        x: typing.Optional[builtins.str] = None,
        x_var: typing.Optional[builtins.str] = None,
        y: typing.Optional[builtins.str] = None,
        y_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param x: The horizontal position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x DataAkamaiImagingPolicyImage#x}
        :param x_var: The horizontal position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_var DataAkamaiImagingPolicyImage#x_var}
        :param y: The vertical position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y DataAkamaiImagingPolicyImage#y}
        :param y_var: The vertical position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_var DataAkamaiImagingPolicyImage#y_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1bdcbffbadff950bf3004b832cd903dbe1b29e745cd598a608c1b9b0586b4661)
            check_type(argname="argument x", value=x, expected_type=type_hints["x"])
            check_type(argname="argument x_var", value=x_var, expected_type=type_hints["x_var"])
            check_type(argname="argument y", value=y, expected_type=type_hints["y"])
            check_type(argname="argument y_var", value=y_var, expected_type=type_hints["y_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if x is not None:
            self._values["x"] = x
        if x_var is not None:
            self._values["x_var"] = x_var
        if y is not None:
            self._values["y"] = y
        if y_var is not None:
            self._values["y_var"] = y_var

    @builtins.property
    def x(self) -> typing.Optional[builtins.str]:
        '''The horizontal position of the point, measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x DataAkamaiImagingPolicyImage#x}
        '''
        result = self._values.get("x")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_var(self) -> typing.Optional[builtins.str]:
        '''The horizontal position of the point, measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_var DataAkamaiImagingPolicyImage#x_var}
        '''
        result = self._values.get("x_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y(self) -> typing.Optional[builtins.str]:
        '''The vertical position of the point, measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y DataAkamaiImagingPolicyImage#y}
        '''
        result = self._values.get("y")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_var(self) -> typing.Optional[builtins.str]:
        '''The vertical position of the point, measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_var DataAkamaiImagingPolicyImage#y_var}
        '''
        result = self._values.get("y_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestRectangleShapeAnchor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestRectangleShapeAnchorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestRectangleShapeAnchorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4052c732cdb02b3368dc041a8866a0c647e163878bb07c44a2a8d3c9c1ddddc3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetX")
    def reset_x(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetX", []))

    @jsii.member(jsii_name="resetXVar")
    def reset_x_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXVar", []))

    @jsii.member(jsii_name="resetY")
    def reset_y(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetY", []))

    @jsii.member(jsii_name="resetYVar")
    def reset_y_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYVar", []))

    @builtins.property
    @jsii.member(jsii_name="xInput")
    def x_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xInput"))

    @builtins.property
    @jsii.member(jsii_name="xVarInput")
    def x_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yInput")
    def y_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yInput"))

    @builtins.property
    @jsii.member(jsii_name="yVarInput")
    def y_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yVarInput"))

    @builtins.property
    @jsii.member(jsii_name="x")
    def x(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "x"))

    @x.setter
    def x(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__21f2e6071156654065f6353e0ede83b50f79ee8348d0acdbdfa1014c1bc92e28)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "x", value)

    @builtins.property
    @jsii.member(jsii_name="xVar")
    def x_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xVar"))

    @x_var.setter
    def x_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__62e285ca6ffccc04933785599e628dda6b3f43766d31ec4acc0ed874f7fff06f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xVar", value)

    @builtins.property
    @jsii.member(jsii_name="y")
    def y(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "y"))

    @y.setter
    def y(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d0d5d3fe112c017584ca078fad1fc3ce5601be99b5dc2951ca006b03939c66db)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "y", value)

    @builtins.property
    @jsii.member(jsii_name="yVar")
    def y_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yVar"))

    @y_var.setter
    def y_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e7af1c68bf2645cda3f4192ff23f1a20b7802a937c98637e712afcca7f612769)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestRectangleShapeAnchor]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestRectangleShapeAnchor], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestRectangleShapeAnchor],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9c08069e788ce1cd15013a5cd11aceedc70a7324f569d6d525a8db93d591b4df)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestRectangleShapeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestRectangleShapeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5c885052149c00f73f7c95a5d63f204516035b143b6744e638c20ffc25f09149)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestRectangleShapeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab1c0566e8d767780a495ab083c94df34f6bba4b7e4e8dcf6dd584afd33ba052)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestRectangleShapeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__076fa3f7e930e9374f230735101ef54b41a9d283353af439dca6b07a7ba62cf9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ce06e6c0b83beb05a10fd80770739e3e707cd9244b8984a12d0bccff8f32e693)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__463e172d1b3c18d123f0e17c641b79cb06b00efec1494dfa2f2af773b5265ac7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestRectangleShape]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestRectangleShape]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestRectangleShape]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__200f6de323acdf70fa7cb1e08e871089a13838ff2e3f85c3e5aa4885d16a0e12)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestRectangleShapeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestRectangleShapeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c8ddb6d7fca5518297110c8abc1541e3a8e0be060142afa32b08fab395368f09)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putAnchor")
    def put_anchor(
        self,
        *,
        x: typing.Optional[builtins.str] = None,
        x_var: typing.Optional[builtins.str] = None,
        y: typing.Optional[builtins.str] = None,
        y_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param x: The horizontal position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x DataAkamaiImagingPolicyImage#x}
        :param x_var: The horizontal position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_var DataAkamaiImagingPolicyImage#x_var}
        :param y: The vertical position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y DataAkamaiImagingPolicyImage#y}
        :param y_var: The vertical position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_var DataAkamaiImagingPolicyImage#y_var}
        '''
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestRectangleShapeAnchor(
            x=x, x_var=x_var, y=y, y_var=y_var
        )

        return typing.cast(None, jsii.invoke(self, "putAnchor", [value]))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="anchor")
    def anchor(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestRectangleShapeAnchorOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestRectangleShapeAnchorOutputReference, jsii.get(self, "anchor"))

    @builtins.property
    @jsii.member(jsii_name="anchorInput")
    def anchor_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestRectangleShapeAnchor]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestRectangleShapeAnchor], jsii.get(self, "anchorInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a99e98550c40d8b7efb6947a34eea21df3c36064a65164d85cf9966e299f0b9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9be3a15f35d786b8c7ab61cc305b466a77a0eb2d9bbeb3e96adb0bc5226fd52e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7b02937e54a816d164e23c2de13213f3241f3c7007736bcadc41b3417d437a0a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__23c78e9e742c75e8543369df5f930bfa3b45b21fd2f884080e5462a78fc273d9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestRectangleShape]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestRectangleShape]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestRectangleShape]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__61561e43362a1c3d6e15a9feb84d1a095e5ffc4d5abe636db21ad7171da19652)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestUnionShape",
    jsii_struct_bases=[],
    name_mapping={"shapes": "shapes"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestUnionShape:
    def __init__(
        self,
        *,
        shapes: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestUnionShapeShapes", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param shapes: shapes block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shapes DataAkamaiImagingPolicyImage#shapes}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ef704029a34c3a8826856021893636e6fcfeb8acc982db8bca2dda664a7c2cd3)
            check_type(argname="argument shapes", value=shapes, expected_type=type_hints["shapes"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "shapes": shapes,
        }

    @builtins.property
    def shapes(
        self,
    ) -> typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestUnionShapeShapes"]]:
        '''shapes block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shapes DataAkamaiImagingPolicyImage#shapes}
        '''
        result = self._values.get("shapes")
        assert result is not None, "Required property 'shapes' is missing"
        return typing.cast(typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestUnionShapeShapes"]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestUnionShape(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestUnionShapeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestUnionShapeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__411f1bb8132b6dfec0ab6620b0a7d6c1302f9108773959de56da7995ffb39f3a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestUnionShapeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3e7373d466576ca9e6bfa18e6380a9f01bb555d74e395a32023fb8994929ef21)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestUnionShapeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ee5195a0615db86da2e3706733b644e48e7d62cec85023dfedc375205035b84)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__808ddf6d34d4895671d51e80789a1dcc2a87411f6182e23a63d1801fe5ad569e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__151becb4edbdd293fe2e474c92aee24d83a1f8d0811498c3cde12d16b2400800)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestUnionShape]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestUnionShape]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestUnionShape]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a5397c586f958afffba101a5b60371f680cb7b4a1a31ff2d3de7d3b1693532b1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestUnionShapeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestUnionShapeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4e4f58dfe7f30a268c5c9009078d8b609e8a0cdfe7f1794a9457ac74ae28d833)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putShapes")
    def put_shapes(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestUnionShapeShapes", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7fc753d82c4de531bef4db5b0551e25f3ba1393d7cd9e6d5eb20469899f4f8e3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putShapes", [value]))

    @builtins.property
    @jsii.member(jsii_name="shapes")
    def shapes(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestUnionShapeShapesList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestUnionShapeShapesList", jsii.get(self, "shapes"))

    @builtins.property
    @jsii.member(jsii_name="shapesInput")
    def shapes_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestUnionShapeShapes"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestUnionShapeShapes"]]], jsii.get(self, "shapesInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestUnionShape]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestUnionShape]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestUnionShape]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a2b44777f4595952763a933d0f219fec98fed7584565920a00abfd9f92f27401)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestUnionShapeShapes",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestUnionShapeShapes:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestUnionShapeShapes(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestUnionShapeShapesList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestUnionShapeShapesList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0266a80e77367e1963dcddfa9220861f50427a9d0cf40bd915e98c9568190efc)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestUnionShapeShapesOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7be8aad9c834096db4dd77611ee17326006d0799f927f824e7723ff2d0dc3a7f)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestUnionShapeShapesOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c8345d6e1d7c36d0c1b825243982632e3438a19a851156b1f4020f6e16c2cdfa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1c6ed0335395c9ffac1ebecd796a9421f31549c7ae219db158fb27a3892aaeac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7476a9a08af04e7b9b896592f204a3aa4b22ef180b1fd6afe5401b6f81a00ba2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestUnionShapeShapes]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestUnionShapeShapes]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestUnionShapeShapes]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__da91e5cda8dc3b65f601af5fd2ebd3b3fadc6b5943045a4f237bfa75fbf473d6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestUnionShapeShapesOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestUnionShapeShapesOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c7465022523b37acfd655346f20ce264f3b13d08b24c844205215a6213ee0d47)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestUnionShapeShapes]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestUnionShapeShapes]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestUnionShapeShapes]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ba92f877461ab9073bade99501c5f445843e4060b38f54ebbb6d0c5a3bf4e01)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRelativeCrop",
    jsii_struct_bases=[],
    name_mapping={
        "east": "east",
        "east_var": "eastVar",
        "north": "north",
        "north_var": "northVar",
        "south": "south",
        "south_var": "southVar",
        "west": "west",
        "west_var": "westVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRelativeCrop:
    def __init__(
        self,
        *,
        east: typing.Optional[builtins.str] = None,
        east_var: typing.Optional[builtins.str] = None,
        north: typing.Optional[builtins.str] = None,
        north_var: typing.Optional[builtins.str] = None,
        south: typing.Optional[builtins.str] = None,
        south_var: typing.Optional[builtins.str] = None,
        west: typing.Optional[builtins.str] = None,
        west_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param east: The number of pixels to shrink or expand the right side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east DataAkamaiImagingPolicyImage#east}
        :param east_var: The number of pixels to shrink or expand the right side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east_var DataAkamaiImagingPolicyImage#east_var}
        :param north: The number of pixels to shrink or expand the top side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north DataAkamaiImagingPolicyImage#north}
        :param north_var: The number of pixels to shrink or expand the top side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north_var DataAkamaiImagingPolicyImage#north_var}
        :param south: The number of pixels to shrink or expand the bottom side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south DataAkamaiImagingPolicyImage#south}
        :param south_var: The number of pixels to shrink or expand the bottom side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south_var DataAkamaiImagingPolicyImage#south_var}
        :param west: The number of pixels to shrink or expand the left side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west DataAkamaiImagingPolicyImage#west}
        :param west_var: The number of pixels to shrink or expand the left side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west_var DataAkamaiImagingPolicyImage#west_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c84d0b1af8a468f4836bdf76b7752c2e86c14c92e0f6289b9a805761ac25177f)
            check_type(argname="argument east", value=east, expected_type=type_hints["east"])
            check_type(argname="argument east_var", value=east_var, expected_type=type_hints["east_var"])
            check_type(argname="argument north", value=north, expected_type=type_hints["north"])
            check_type(argname="argument north_var", value=north_var, expected_type=type_hints["north_var"])
            check_type(argname="argument south", value=south, expected_type=type_hints["south"])
            check_type(argname="argument south_var", value=south_var, expected_type=type_hints["south_var"])
            check_type(argname="argument west", value=west, expected_type=type_hints["west"])
            check_type(argname="argument west_var", value=west_var, expected_type=type_hints["west_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if east is not None:
            self._values["east"] = east
        if east_var is not None:
            self._values["east_var"] = east_var
        if north is not None:
            self._values["north"] = north
        if north_var is not None:
            self._values["north_var"] = north_var
        if south is not None:
            self._values["south"] = south
        if south_var is not None:
            self._values["south_var"] = south_var
        if west is not None:
            self._values["west"] = west
        if west_var is not None:
            self._values["west_var"] = west_var

    @builtins.property
    def east(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the right side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east DataAkamaiImagingPolicyImage#east}
        '''
        result = self._values.get("east")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def east_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the right side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east_var DataAkamaiImagingPolicyImage#east_var}
        '''
        result = self._values.get("east_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def north(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the top side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north DataAkamaiImagingPolicyImage#north}
        '''
        result = self._values.get("north")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def north_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the top side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north_var DataAkamaiImagingPolicyImage#north_var}
        '''
        result = self._values.get("north_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def south(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the bottom side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south DataAkamaiImagingPolicyImage#south}
        '''
        result = self._values.get("south")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def south_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the bottom side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south_var DataAkamaiImagingPolicyImage#south_var}
        '''
        result = self._values.get("south_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def west(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the left side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west DataAkamaiImagingPolicyImage#west}
        '''
        result = self._values.get("west")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def west_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the left side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west_var DataAkamaiImagingPolicyImage#west_var}
        '''
        result = self._values.get("west_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRelativeCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRelativeCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRelativeCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__578e79a6a38373ca089587826ce2b7f10e212476b779a6b344c6d7639d895d23)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRelativeCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c867e7a378a9d57bbc5f525aaaad1faca21c4a698a15c21e590d6ecb28bc9961)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRelativeCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7f627e4defe252b50c3935abd88404a5711961aaf29918cd17af9a3972a99bdb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a48845415c5e390680080870be45b058838178f7d20f78e9bd6a2caf16e951d7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__554ffc430d8bbb0cec678518f96928c8b3304b6845a55d616bb31626eb6d6fe0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRelativeCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRelativeCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRelativeCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7ece8ddf6d77fe9837813048f29a78dfb3a7f657965bdc5833b554235fbca7b4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRelativeCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRelativeCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5fea192cc584a51e3b1bf9679a3360dc9085e9e9a35b612211053243c44c1a19)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetEast")
    def reset_east(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEast", []))

    @jsii.member(jsii_name="resetEastVar")
    def reset_east_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEastVar", []))

    @jsii.member(jsii_name="resetNorth")
    def reset_north(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNorth", []))

    @jsii.member(jsii_name="resetNorthVar")
    def reset_north_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNorthVar", []))

    @jsii.member(jsii_name="resetSouth")
    def reset_south(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSouth", []))

    @jsii.member(jsii_name="resetSouthVar")
    def reset_south_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSouthVar", []))

    @jsii.member(jsii_name="resetWest")
    def reset_west(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWest", []))

    @jsii.member(jsii_name="resetWestVar")
    def reset_west_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWestVar", []))

    @builtins.property
    @jsii.member(jsii_name="eastInput")
    def east_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "eastInput"))

    @builtins.property
    @jsii.member(jsii_name="eastVarInput")
    def east_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "eastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="northInput")
    def north_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "northInput"))

    @builtins.property
    @jsii.member(jsii_name="northVarInput")
    def north_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "northVarInput"))

    @builtins.property
    @jsii.member(jsii_name="southInput")
    def south_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "southInput"))

    @builtins.property
    @jsii.member(jsii_name="southVarInput")
    def south_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "southVarInput"))

    @builtins.property
    @jsii.member(jsii_name="westInput")
    def west_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "westInput"))

    @builtins.property
    @jsii.member(jsii_name="westVarInput")
    def west_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "westVarInput"))

    @builtins.property
    @jsii.member(jsii_name="east")
    def east(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "east"))

    @east.setter
    def east(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c0cc6de82ec3c0cb1502e7b6ad218e846e7c6ea55de6e607dd100f71940c6554)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "east", value)

    @builtins.property
    @jsii.member(jsii_name="eastVar")
    def east_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "eastVar"))

    @east_var.setter
    def east_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__906dafc1fc5bd04c847fbcd1a841c3fd9d38c90691594be9f3c7b81168eaa47c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "eastVar", value)

    @builtins.property
    @jsii.member(jsii_name="north")
    def north(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "north"))

    @north.setter
    def north(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__524728413039a8c15ad7119a17330021c4fd90a6c589ce61929a8618cc88329f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "north", value)

    @builtins.property
    @jsii.member(jsii_name="northVar")
    def north_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "northVar"))

    @north_var.setter
    def north_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__07b314deae1671b4b9667fe00b88f0c2637b5b44cf01439ec19a529f1f947956)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "northVar", value)

    @builtins.property
    @jsii.member(jsii_name="south")
    def south(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "south"))

    @south.setter
    def south(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__05ea6e976399363b0c9b2975b6819bb9d8885c2c3891bd9da448360d323d7db1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "south", value)

    @builtins.property
    @jsii.member(jsii_name="southVar")
    def south_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "southVar"))

    @south_var.setter
    def south_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f76e418bd80eba18d8a514065cbb4b95a172fdcdfac37bb438d75ea9eef02642)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "southVar", value)

    @builtins.property
    @jsii.member(jsii_name="west")
    def west(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "west"))

    @west.setter
    def west(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5da0ec4a4b6379ae599bf42d1a5dff9da3191168f74b1302f5abce2e55638710)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "west", value)

    @builtins.property
    @jsii.member(jsii_name="westVar")
    def west_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "westVar"))

    @west_var.setter
    def west_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b0066e94713cdf7324bf6fcdc3e44786c051ac94acb213501fd15034f4cc2f15)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "westVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRelativeCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRelativeCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRelativeCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__28528aad30d9e574356f4c7cca3fceca67abd8ffc193a3c881d76d82ec8e36df)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRemoveColor",
    jsii_struct_bases=[],
    name_mapping={
        "color": "color",
        "color_var": "colorVar",
        "feather": "feather",
        "feather_var": "featherVar",
        "tolerance": "tolerance",
        "tolerance_var": "toleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRemoveColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
        feather: typing.Optional[builtins.str] = None,
        feather_var: typing.Optional[builtins.str] = None,
        tolerance: typing.Optional[builtins.str] = None,
        tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        :param feather: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        :param feather_var: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        :param tolerance: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        :param tolerance_var: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ee141f5d80aab3c445417e243c2609802928cec43c1b4832a99c25f6bf12b65)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
            check_type(argname="argument feather", value=feather, expected_type=type_hints["feather"])
            check_type(argname="argument feather_var", value=feather_var, expected_type=type_hints["feather_var"])
            check_type(argname="argument tolerance", value=tolerance, expected_type=type_hints["tolerance"])
            check_type(argname="argument tolerance_var", value=tolerance_var, expected_type=type_hints["tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var
        if feather is not None:
            self._values["feather"] = feather
        if feather_var is not None:
            self._values["feather_var"] = feather_var
        if tolerance is not None:
            self._values["tolerance"] = tolerance
        if tolerance_var is not None:
            self._values["tolerance_var"] = tolerance_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        '''
        result = self._values.get("feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather_var(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        '''
        result = self._values.get("feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        '''
        result = self._values.get("tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance_var(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        result = self._values.get("tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRemoveColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRemoveColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRemoveColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__454a67aa9f5abc1d5da0d00ad04a94213372e2c1aadcbf29f428d6dddc38d8dd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRemoveColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__79cf3afa9a88b676a5006c23d1bb102510ca1bfd60670b1bbfdb12b469ab6d1a)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRemoveColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f426d1eb04411ffc746ecccb11b539dbcbf44e907c89211d34b415ea554f5909)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ff48c132ff4daf46421f3211db62d0d14c701d54928739b324aef768be7b2b4f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1240625da5f88628dba68e225f8d0a050bb9b3b7a2be928ffa4d5878e1c44b17)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRemoveColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRemoveColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRemoveColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cdeae8f83136a33f9ab2c5fadb72efd03d7bd17d509916e03e5cb19b83c47530)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRemoveColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRemoveColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5719424c44539df84e21a31bfce8ea5fc8bd9a4cb9cef2be9bc1ed20ad60b0f3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @jsii.member(jsii_name="resetFeather")
    def reset_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeather", []))

    @jsii.member(jsii_name="resetFeatherVar")
    def reset_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatherVar", []))

    @jsii.member(jsii_name="resetTolerance")
    def reset_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTolerance", []))

    @jsii.member(jsii_name="resetToleranceVar")
    def reset_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featherInput")
    def feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherInput"))

    @builtins.property
    @jsii.member(jsii_name="featherVarInput")
    def feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceInput")
    def tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceVarInput")
    def tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fbe05f5abfb6e923af3ee1bea557de6ccb5fde9f49a6a645d15122e079ed037a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cc82a1f967c7f69f75ed60429ff3ba9b6dca242082060a5e7d8f184325360788)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="feather")
    def feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "feather"))

    @feather.setter
    def feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8c8cf14d794ae514118e95b7d53937456a8cf8ba6a3ca3c78c94413d4691ac21)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "feather", value)

    @builtins.property
    @jsii.member(jsii_name="featherVar")
    def feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featherVar"))

    @feather_var.setter
    def feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__45a096eac0af916928cdebf6f7a515031d36e595abf0f1c6508ba05d5bdee1f8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featherVar", value)

    @builtins.property
    @jsii.member(jsii_name="tolerance")
    def tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tolerance"))

    @tolerance.setter
    def tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__441d6d40fa4015bfef0e9efc0762d56db4f3169b9b0fdfd9817d7f8616fa6ba4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tolerance", value)

    @builtins.property
    @jsii.member(jsii_name="toleranceVar")
    def tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "toleranceVar"))

    @tolerance_var.setter
    def tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__28b6c11ac9b0e8e3af491912a8fa33477d39075aaf053734d023b418ffeb1d55)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "toleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRemoveColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRemoveColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRemoveColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__82d16265e5705b6efcfd8b9bc2b61dd9071373bfdbbe7bb8e8aebc481ab459da)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeResize",
    jsii_struct_bases=[],
    name_mapping={
        "aspect": "aspect",
        "aspect_var": "aspectVar",
        "height": "height",
        "height_var": "heightVar",
        "type": "type",
        "type_var": "typeVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeResize:
    def __init__(
        self,
        *,
        aspect: typing.Optional[builtins.str] = None,
        aspect_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param aspect: Preserves the aspect ratio. Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect DataAkamaiImagingPolicyImage#aspect}
        :param aspect_var: Preserves the aspect ratio. Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_var DataAkamaiImagingPolicyImage#aspect_var}
        :param height: The height to resize the source image to. Must be set if height is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height to resize the source image to. Must be set if height is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param type: Sets constraints for the image resize. Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: Sets constraints for the image resize. Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        :param width: The width to resize the source image to. Must be set if width is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width to resize the source image to. Must be set if width is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e490dd30101ea2bdf4dbbb5e5e65acee9444d42994ea3ff7f2b9e743a337e5a0)
            check_type(argname="argument aspect", value=aspect, expected_type=type_hints["aspect"])
            check_type(argname="argument aspect_var", value=aspect_var, expected_type=type_hints["aspect_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if aspect is not None:
            self._values["aspect"] = aspect
        if aspect_var is not None:
            self._values["aspect_var"] = aspect_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def aspect(self) -> typing.Optional[builtins.str]:
        '''Preserves the aspect ratio.

        Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect DataAkamaiImagingPolicyImage#aspect}
        '''
        result = self._values.get("aspect")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def aspect_var(self) -> typing.Optional[builtins.str]:
        '''Preserves the aspect ratio.

        Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_var DataAkamaiImagingPolicyImage#aspect_var}
        '''
        result = self._values.get("aspect_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height to resize the source image to. Must be set if height is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height to resize the source image to. Must be set if height is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''Sets constraints for the image resize.

        Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''Sets constraints for the image resize.

        Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width to resize the source image to. Must be set if width is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width to resize the source image to. Must be set if width is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeResize(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeResizeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeResizeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3de35fc469c8861afb0aa53145e6a2fe6948c886f27295f608bfb431837c749b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeResizeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8bf940fcc26342fca651aa87ea58d5f24efe374ff6e012e4ae8fd3b84a103c50)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeResizeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__98e9c764f057b937b8d3c9826fc25a6e6f3dd531f5b516498e946d1903d37240)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be2ee74acb026b55fcb35b2822efa933be5ba085d21afffe39e9f9598745ce62)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d46750af60e77289ef57127c84b54d84fe5a199aaa96f5b7a3c0f8e36ed88ae7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeResize]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeResize]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeResize]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eb6df3b34f627dee2e0fc18cecb2a022716896027fef873fa27c403b16491eac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeResizeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeResizeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2bd3ed97729d2ce08db5947c668273af51d44f68f0de8ec8c5bf35c0651fee7d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAspect")
    def reset_aspect(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspect", []))

    @jsii.member(jsii_name="resetAspectVar")
    def reset_aspect_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspectVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="aspectInput")
    def aspect_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "aspectInput"))

    @builtins.property
    @jsii.member(jsii_name="aspectVarInput")
    def aspect_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "aspectVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="aspect")
    def aspect(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "aspect"))

    @aspect.setter
    def aspect(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0a90f27eb837f9facf12bbc86b9af22b0af8f33866a6c6c53e30fa8c24e70cbc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "aspect", value)

    @builtins.property
    @jsii.member(jsii_name="aspectVar")
    def aspect_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "aspectVar"))

    @aspect_var.setter
    def aspect_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c1386977736432d756c2213f5e7c2f2904d76079c8b67fe37130540d6327e84b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "aspectVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6fa7fc5704d5a152d254d947e357047d63e70ae3eafa096e615d3196bc9b02d9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dfb9883ad44d9545d1f3ebec632b2dddeecb4a8f00ba229d9550fb1238ed7ec5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f9512f12e4af42631b4d18edd0c6ea2dad792fc683a29b99d9e4af4009a75f90)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__03b176e58e99cf198a8838c1d41709d80f7486ad8df6c7d519733e81831e6243)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a3dde60d42a1d43199f1a3be762ae36f40dbda81c5c1152ef9638fb92ef4fcb9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__24d89e9bf1634404c004e9e5d324bce0d9f17ef0c11770841fd7399fd43da990)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeResize]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeResize]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeResize]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__239795c2aa79927ccc663c27f49e0315279553b1fc207f8fbd425b3cf83ec647)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRotate",
    jsii_struct_bases=[],
    name_mapping={"degrees": "degrees", "degrees_var": "degreesVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRotate:
    def __init__(
        self,
        *,
        degrees: typing.Optional[builtins.str] = None,
        degrees_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param degrees: The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees DataAkamaiImagingPolicyImage#degrees}
        :param degrees_var: The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees_var DataAkamaiImagingPolicyImage#degrees_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__828f747d710ac0e4b87d31021dc54238137fbcea2aec2f77d624a126f8b7e108)
            check_type(argname="argument degrees", value=degrees, expected_type=type_hints["degrees"])
            check_type(argname="argument degrees_var", value=degrees_var, expected_type=type_hints["degrees_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if degrees is not None:
            self._values["degrees"] = degrees
        if degrees_var is not None:
            self._values["degrees_var"] = degrees_var

    @builtins.property
    def degrees(self) -> typing.Optional[builtins.str]:
        '''The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees DataAkamaiImagingPolicyImage#degrees}
        '''
        result = self._values.get("degrees")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def degrees_var(self) -> typing.Optional[builtins.str]:
        '''The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees_var DataAkamaiImagingPolicyImage#degrees_var}
        '''
        result = self._values.get("degrees_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRotate(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRotateList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRotateList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__060b3f2db3ecebb9f89bb885e7c8c96fdbb03abd5c8f59aa8a38027a21163144)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRotateOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6fb65fe62e5e89ef0ebfc52bb0fde0370db3c5c1abb5d6b37cf79c1cd0ce935c)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRotateOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea54d4658879649d8d6943704e8711fd2ffb81250fcfed9203589b7848f62ed2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ffd46f957d4e5dc4c51f8703b35101baa55648e175bf9779fc2200d53090ad78)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6fc6501fa3b23285b4de9e2cb42bea6dfaa4d69f9acddbb2547fc673d1a7ef5e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRotate]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRotate]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRotate]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3c2e5ebdc3ddfe9980f107271036e3cd101cfd4162b9d7abc3de742f565238e0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRotateOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRotateOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__66ef47c6a84edd0b8ed9a6aa93f4d02e4514d5cb866da571fd972d921329dba8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetDegrees")
    def reset_degrees(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDegrees", []))

    @jsii.member(jsii_name="resetDegreesVar")
    def reset_degrees_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDegreesVar", []))

    @builtins.property
    @jsii.member(jsii_name="degreesInput")
    def degrees_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "degreesInput"))

    @builtins.property
    @jsii.member(jsii_name="degreesVarInput")
    def degrees_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "degreesVarInput"))

    @builtins.property
    @jsii.member(jsii_name="degrees")
    def degrees(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "degrees"))

    @degrees.setter
    def degrees(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6d7f1d2a226a4521f13c3e4dc43bfcffb228117d0ce38d57777baa59b896eb12)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "degrees", value)

    @builtins.property
    @jsii.member(jsii_name="degreesVar")
    def degrees_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "degreesVar"))

    @degrees_var.setter
    def degrees_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f289b39c88af1f6f84ddbf914f6b6847faaff3b0bb8f2c2f1eaaebbf88ffff45)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "degreesVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRotate]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRotate]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRotate]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e7c53c8c464bc40d505d9089c2f5307c1ba92dfdcdf9e1f222a0db40b1ecea7e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeScale",
    jsii_struct_bases=[],
    name_mapping={
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeScale:
    def __init__(
        self,
        *,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param height: Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged. Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged. Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__22cb5a98ca853aae5138c8b8577390ea035412e68e65bb2cc292483a71030cf0)
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size.

        Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size.

        Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged.

        Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged.

        Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeScale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeScaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeScaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9191b4832d8a5fc0cb69297d00071992f7b05cc49e53eee2def3b7af6a098fc7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeScaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__99630ced9607d3ac6eb675769d3bf2a84fe2a20bd2d06eeb221510b1c1804bc8)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeScaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd16b994e665dae674af39880e4adef4c4954292eac7ca9b1a8dbdaf0121b9fe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8fcd70538da0c28b12fada917668712ef12c2e156e6c7f7804a312967d73595c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ffc2dd81fe57802c747eea630fcc4a67cd628bf4e1fa8011c1ef20f5511c3a8e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeScale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeScale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeScale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b6896d613c550c71f05770e4955f719ec917b43243292c3f92a615993b7f5743)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeScaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeScaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7e1f9ca44feddb39f59edd0924fb0658dedc4e6730f4a6d3e8b6c898c93dd07e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f06633a293c89f04d86e303af2a78a9d115c326a3ca8c87e75395d41dd193688)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aeb6e8c9e6b7b0d6e6db8e86a77eacddd67fd1f7707d23b9f0b930e4cc6b8809)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3437b623fee09746ac7adf9990acacc53bacf54a87e86e598803d8dd3280f794)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d1947be176fab503c6768df5d99e7bf2de663d5141965e7229c0cd48bcf82fe7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeScale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeScale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeScale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e6482356a08bc5eecc22d296063f1a938487d78b47d5b2f910358caa99b85ebe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeShear",
    jsii_struct_bases=[],
    name_mapping={
        "x_shear": "xShear",
        "x_shear_var": "xShearVar",
        "y_shear": "yShear",
        "y_shear_var": "yShearVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeShear:
    def __init__(
        self,
        *,
        x_shear: typing.Optional[builtins.str] = None,
        x_shear_var: typing.Optional[builtins.str] = None,
        y_shear: typing.Optional[builtins.str] = None,
        y_shear_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param x_shear: The amount to shear along the x-axis, measured in multiples of the image's width. Must be set if yShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear DataAkamaiImagingPolicyImage#x_shear}
        :param x_shear_var: The amount to shear along the x-axis, measured in multiples of the image's width. Must be set if yShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear_var DataAkamaiImagingPolicyImage#x_shear_var}
        :param y_shear: The amount to shear along the y-axis, measured in multiples of the image's height. Must be set if xShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear DataAkamaiImagingPolicyImage#y_shear}
        :param y_shear_var: The amount to shear along the y-axis, measured in multiples of the image's height. Must be set if xShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear_var DataAkamaiImagingPolicyImage#y_shear_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a3e51c560fbf9790dece201bf2ccd5dd11af7199a76b0944f46520df83905757)
            check_type(argname="argument x_shear", value=x_shear, expected_type=type_hints["x_shear"])
            check_type(argname="argument x_shear_var", value=x_shear_var, expected_type=type_hints["x_shear_var"])
            check_type(argname="argument y_shear", value=y_shear, expected_type=type_hints["y_shear"])
            check_type(argname="argument y_shear_var", value=y_shear_var, expected_type=type_hints["y_shear_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if x_shear is not None:
            self._values["x_shear"] = x_shear
        if x_shear_var is not None:
            self._values["x_shear_var"] = x_shear_var
        if y_shear is not None:
            self._values["y_shear"] = y_shear
        if y_shear_var is not None:
            self._values["y_shear_var"] = y_shear_var

    @builtins.property
    def x_shear(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the x-axis, measured in multiples of the image's width.

        Must be set if yShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear DataAkamaiImagingPolicyImage#x_shear}
        '''
        result = self._values.get("x_shear")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_shear_var(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the x-axis, measured in multiples of the image's width.

        Must be set if yShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear_var DataAkamaiImagingPolicyImage#x_shear_var}
        '''
        result = self._values.get("x_shear_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_shear(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the y-axis, measured in multiples of the image's height.

        Must be set if xShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear DataAkamaiImagingPolicyImage#y_shear}
        '''
        result = self._values.get("y_shear")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_shear_var(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the y-axis, measured in multiples of the image's height.

        Must be set if xShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear_var DataAkamaiImagingPolicyImage#y_shear_var}
        '''
        result = self._values.get("y_shear_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeShear(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeShearList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeShearList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__10f57e13783fcaadd2b9d6dc6577629c31e935d5fefe5bae1293492fef87adc7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeShearOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2f438cbcf0c2a44aaa003a6c74f14409c534ce91bbbf0aa74092ab857e5be51e)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeShearOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ede77e96cf58bcbe827721e12b35f4507760c39236e5d52c25cf109143fe3e49)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3c2bce8c2157c923d6d2ad3d1ee8be1e997c57041ee56e6dd9890d187b49fad5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__79d6d96c1aaf1d157f1ca8a31eef6062e5645fee5b59a13b567a67f7505947f7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeShear]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeShear]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeShear]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3c3109966dd986671509e9ec9a66444a27c62b04eec8c49b4bcb1d382a1868e6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeShearOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeShearOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a40ad68592042daf158dfd32a9a42e264ab08518840b94005ce7b81fcd0149c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetXShear")
    def reset_x_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXShear", []))

    @jsii.member(jsii_name="resetXShearVar")
    def reset_x_shear_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXShearVar", []))

    @jsii.member(jsii_name="resetYShear")
    def reset_y_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYShear", []))

    @jsii.member(jsii_name="resetYShearVar")
    def reset_y_shear_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYShearVar", []))

    @builtins.property
    @jsii.member(jsii_name="xShearInput")
    def x_shear_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xShearInput"))

    @builtins.property
    @jsii.member(jsii_name="xShearVarInput")
    def x_shear_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xShearVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yShearInput")
    def y_shear_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yShearInput"))

    @builtins.property
    @jsii.member(jsii_name="yShearVarInput")
    def y_shear_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yShearVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xShear")
    def x_shear(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xShear"))

    @x_shear.setter
    def x_shear(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0b001f40e5a5571d9bbddec97d7551906a9f9be3ddbbe0d39c124005f4350911)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xShear", value)

    @builtins.property
    @jsii.member(jsii_name="xShearVar")
    def x_shear_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xShearVar"))

    @x_shear_var.setter
    def x_shear_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5a8bebdf4d0caea74cdcd3ed22a8e5f0240ffc8334af4c2cb240428b3208d5b1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xShearVar", value)

    @builtins.property
    @jsii.member(jsii_name="yShear")
    def y_shear(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yShear"))

    @y_shear.setter
    def y_shear(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3896837289cb135ab74d71f8eee55046d9b324ac3cbbe7c2c475af6ed34bd8ff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yShear", value)

    @builtins.property
    @jsii.member(jsii_name="yShearVar")
    def y_shear_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yShearVar"))

    @y_shear_var.setter
    def y_shear_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dd3d254cd95910eb963cadbab28f778721140a5f5a0551891832bd647ae0604e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yShearVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeShear]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeShear]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeShear]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f129fa225b98eceea272b3cb899be14bbb6e8b87770bbafd33b8e5c4cfe06e78)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeTrim",
    jsii_struct_bases=[],
    name_mapping={
        "fuzz": "fuzz",
        "fuzz_var": "fuzzVar",
        "padding": "padding",
        "padding_var": "paddingVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeTrim:
    def __init__(
        self,
        *,
        fuzz: typing.Optional[builtins.str] = None,
        fuzz_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fuzz: The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz DataAkamaiImagingPolicyImage#fuzz}
        :param fuzz_var: The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz_var DataAkamaiImagingPolicyImage#fuzz_var}
        :param padding: The amount of padding in pixels to add to the trimmed image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: The amount of padding in pixels to add to the trimmed image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9991f8ae3cef51456ef7a5dd7c779ebd2429f0aa885a573a5e8418a54a703b2f)
            check_type(argname="argument fuzz", value=fuzz, expected_type=type_hints["fuzz"])
            check_type(argname="argument fuzz_var", value=fuzz_var, expected_type=type_hints["fuzz_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fuzz is not None:
            self._values["fuzz"] = fuzz
        if fuzz_var is not None:
            self._values["fuzz_var"] = fuzz_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var

    @builtins.property
    def fuzz(self) -> typing.Optional[builtins.str]:
        '''The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz DataAkamaiImagingPolicyImage#fuzz}
        '''
        result = self._values.get("fuzz")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fuzz_var(self) -> typing.Optional[builtins.str]:
        '''The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz_var DataAkamaiImagingPolicyImage#fuzz_var}
        '''
        result = self._values.get("fuzz_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''The amount of padding in pixels to add to the trimmed image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''The amount of padding in pixels to add to the trimmed image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeTrim(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeTrimList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeTrimList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__75ceaee74deffd73e251a6b52c5123439e1e95d17d2e76894c34a23917d88ab5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeTrimOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb17aafb8a84d54cce78898ca605853cee07c3e5ddb31ec0f41a4e61fcbcee66)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeTrimOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af12ffc49e6cee1ae16e65533d92b2de5f5e8b351b6c27fd7207bedd11c3b8ca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__234591fc442f248639aad3791af80e951032dd2f3844221b0448c8cae56759ef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9dd3ddbb539afc5a7b970672d62c15cc070673a76174c1e53111079bffd7cc97)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeTrim]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeTrim]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeTrim]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa959b756853f8509cb08a8f0c19090a43891d3a3b75168299fc99a2f1a1c822)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeTrimOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeTrimOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__19bc2a28b2dfc517ce928f34d71b91c12161c06a686c56846e8c6c04e5a0b3e5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetFuzz")
    def reset_fuzz(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFuzz", []))

    @jsii.member(jsii_name="resetFuzzVar")
    def reset_fuzz_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFuzzVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @builtins.property
    @jsii.member(jsii_name="fuzzInput")
    def fuzz_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fuzzInput"))

    @builtins.property
    @jsii.member(jsii_name="fuzzVarInput")
    def fuzz_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fuzzVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="fuzz")
    def fuzz(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fuzz"))

    @fuzz.setter
    def fuzz(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c7ac7bc3e0a206704a09930841f6f22f6a7276eabcac61ecd9e39341c90841a8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fuzz", value)

    @builtins.property
    @jsii.member(jsii_name="fuzzVar")
    def fuzz_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fuzzVar"))

    @fuzz_var.setter
    def fuzz_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea2cae5249b434edfc096114c9197895d1eb2d3708651df59d2b99faa407bc09)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fuzzVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7048a3956c38bcf9810938198806b9612de5de0667e00acd277e45a66b695cb4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df14a9406dd834440529c60dfc46a46badf3b472e6cc1410d69d9000af216066)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeTrim]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeTrim]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeTrim]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__28791a9a47e885bfa27905e4a82cbf9f7c9d0b8c6eb344322010ad87380bd6c1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeUnsharpMask",
    jsii_struct_bases=[],
    name_mapping={
        "gain": "gain",
        "gain_var": "gainVar",
        "sigma": "sigma",
        "sigma_var": "sigmaVar",
        "threshold": "threshold",
        "threshold_var": "thresholdVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeUnsharpMask:
    def __init__(
        self,
        *,
        gain: typing.Optional[builtins.str] = None,
        gain_var: typing.Optional[builtins.str] = None,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
        threshold: typing.Optional[builtins.str] = None,
        threshold_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param gain: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        :param gain_var: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        :param sigma: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        :param threshold: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        :param threshold_var: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a45bf18363eb3425ad2336c18654adaade8ee88c2f35770614eb127247fb56bc)
            check_type(argname="argument gain", value=gain, expected_type=type_hints["gain"])
            check_type(argname="argument gain_var", value=gain_var, expected_type=type_hints["gain_var"])
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
            check_type(argname="argument threshold", value=threshold, expected_type=type_hints["threshold"])
            check_type(argname="argument threshold_var", value=threshold_var, expected_type=type_hints["threshold_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if gain is not None:
            self._values["gain"] = gain
        if gain_var is not None:
            self._values["gain_var"] = gain_var
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var
        if threshold is not None:
            self._values["threshold"] = threshold
        if threshold_var is not None:
            self._values["threshold_var"] = threshold_var

    @builtins.property
    def gain(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        '''
        result = self._values.get("gain")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gain_var(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        '''
        result = self._values.get("gain_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        '''
        result = self._values.get("threshold")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold_var(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        result = self._values.get("threshold_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeUnsharpMask(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeUnsharpMaskList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeUnsharpMaskList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5790d09904ac2cdd1c11fe00a8f1d166971df0bf3774f1a2cfaec2113e27e904)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeUnsharpMaskOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__761d82845d1f84f14aec12f5c3192f4361c050d6a4ed3f7a8adcec71f06db8e6)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeUnsharpMaskOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__498deed130f42564c924f051e745224325dac7d211df26264c64b764e9823e36)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5185172fed23d8bffb9727f725146f97a93f38340e57bc6feef9413df02c0fef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e7c39e97d5d7b33c1b4a17111623fbaa4d2859bee4b56f441b47e429ac86e5d2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeUnsharpMask]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeUnsharpMask]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeUnsharpMask]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__56f7ea2990307d887e91349adec4ff992d55eacb8c9bb145ac903fd642f0749e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeUnsharpMaskOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeUnsharpMaskOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b4ed0ec744ce6f9f9b9dbfcc58eb96b07b7082430689313973013cd3d075fb7a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetGain")
    def reset_gain(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGain", []))

    @jsii.member(jsii_name="resetGainVar")
    def reset_gain_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGainVar", []))

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @jsii.member(jsii_name="resetThreshold")
    def reset_threshold(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThreshold", []))

    @jsii.member(jsii_name="resetThresholdVar")
    def reset_threshold_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThresholdVar", []))

    @builtins.property
    @jsii.member(jsii_name="gainInput")
    def gain_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainInput"))

    @builtins.property
    @jsii.member(jsii_name="gainVarInput")
    def gain_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdInput")
    def threshold_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdVarInput")
    def threshold_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gain")
    def gain(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gain"))

    @gain.setter
    def gain(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e19d0b5762ef10d0a3b959aad4bb95f456f0f9e0f49371307796242c715f9a8a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gain", value)

    @builtins.property
    @jsii.member(jsii_name="gainVar")
    def gain_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gainVar"))

    @gain_var.setter
    def gain_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7cca2cea884afdd1bb6420ff542b8c0fdf53293a150b4f3225e9d249dd242776)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gainVar", value)

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ff1f27a485b7bee232b18e5283766c96856ff359a7a0c46bcebf337b6fc6ae4c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0b9fb6244d920318e1e33093f37fec0d6f3742c6823541e1fd7673a364eacbec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="threshold")
    def threshold(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "threshold"))

    @threshold.setter
    def threshold(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c0c85d0dfc3f6f6cdd8db6c6eda3193afd38280a7a90e27c7beb13520cc57c36)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "threshold", value)

    @builtins.property
    @jsii.member(jsii_name="thresholdVar")
    def threshold_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "thresholdVar"))

    @threshold_var.setter
    def threshold_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__db82488da60a42f05a7ded38d60074dbb9dfca8570b184203f0369a825a1ecda)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "thresholdVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeUnsharpMask]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeUnsharpMask]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeUnsharpMask]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__221fcffb54c8c88a257d75c8407eb065fd3dc7815926daeef61f3858f5d3aeba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2c328c2dac820b09a1326d3f918dc59f40caef950c6c2125d1e6f08fbb45d8d8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bf0b2a61b575117e979719d7ee2f7c33f52ff749d636b2919e1646d682732f9c)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ba9e870efb9c993182fdd0fc3c6f9eb5a0f020c9447ba509e1b6bc90cb60956)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df1c44a3f7033de1eb4a6f7a002f7c2046d470f18186e39e6b668f581135b904)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ba9760bf417c48e6e8f2eced4052a08a9a9cc6d1e20690514969ff1005c874d1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientation]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientation]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__26ff159ea3dd89983a723aadaec51cdcaca73242788e77b109d9b9da13b56526)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__030a320ea60d0008df0a477ed3c719e86fbd854ba7e265804a897286eabe4389)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(
        self,
        *,
        append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppend, typing.Dict[builtins.str, typing.Any]]]]] = None,
        aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAspectCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
        crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFaceCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFeatureCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFill, typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
        im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultImQuery, typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
        region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRelativeCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
        resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultResize, typing.Dict[builtins.str, typing.Any]]]]] = None,
        rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRotate, typing.Dict[builtins.str, typing.Any]]]]] = None,
        scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultScale, typing.Dict[builtins.str, typing.Any]]]]] = None,
        shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultShear, typing.Dict[builtins.str, typing.Any]]]]] = None,
        trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultTrim, typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param append: append block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        :param aspect_crop: aspect_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param crop: crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        :param face_crop: face_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        :param feature_crop: feature_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        :param fit_and_fill: fit_and_fill block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param im_query: im_query block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param region_of_interest_crop: region_of_interest_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        :param relative_crop: relative_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param resize: resize block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        :param rotate: rotate block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        :param scale: scale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param shear: shear block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        :param trim: trim block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefault(
            append=append,
            aspect_crop=aspect_crop,
            background_color=background_color,
            blur=blur,
            chroma_key=chroma_key,
            composite=composite,
            compound=compound,
            contrast=contrast,
            crop=crop,
            face_crop=face_crop,
            feature_crop=feature_crop,
            fit_and_fill=fit_and_fill,
            goop=goop,
            grayscale=grayscale,
            hsl=hsl,
            hsv=hsv,
            if_dimension=if_dimension,
            if_orientation=if_orientation,
            im_query=im_query,
            max_colors=max_colors,
            mirror=mirror,
            mono_hue=mono_hue,
            opacity=opacity,
            region_of_interest_crop=region_of_interest_crop,
            relative_crop=relative_crop,
            remove_color=remove_color,
            resize=resize,
            rotate=rotate,
            scale=scale,
            shear=shear,
            trim=trim,
            unsharp_mask=unsharp_mask,
        )

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putLandscape")
    def put_landscape(
        self,
        *,
        append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppend, typing.Dict[builtins.str, typing.Any]]]]] = None,
        aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAspectCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
        crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFaceCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFeatureCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFill, typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
        im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeImQuery, typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
        region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRelativeCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
        resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeResize, typing.Dict[builtins.str, typing.Any]]]]] = None,
        rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRotate, typing.Dict[builtins.str, typing.Any]]]]] = None,
        scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeScale, typing.Dict[builtins.str, typing.Any]]]]] = None,
        shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeShear, typing.Dict[builtins.str, typing.Any]]]]] = None,
        trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeTrim, typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param append: append block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        :param aspect_crop: aspect_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param crop: crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        :param face_crop: face_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        :param feature_crop: feature_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        :param fit_and_fill: fit_and_fill block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param im_query: im_query block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param region_of_interest_crop: region_of_interest_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        :param relative_crop: relative_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param resize: resize block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        :param rotate: rotate block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        :param scale: scale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param shear: shear block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        :param trim: trim block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscape(
            append=append,
            aspect_crop=aspect_crop,
            background_color=background_color,
            blur=blur,
            chroma_key=chroma_key,
            composite=composite,
            compound=compound,
            contrast=contrast,
            crop=crop,
            face_crop=face_crop,
            feature_crop=feature_crop,
            fit_and_fill=fit_and_fill,
            goop=goop,
            grayscale=grayscale,
            hsl=hsl,
            hsv=hsv,
            if_dimension=if_dimension,
            if_orientation=if_orientation,
            im_query=im_query,
            max_colors=max_colors,
            mirror=mirror,
            mono_hue=mono_hue,
            opacity=opacity,
            region_of_interest_crop=region_of_interest_crop,
            relative_crop=relative_crop,
            remove_color=remove_color,
            resize=resize,
            rotate=rotate,
            scale=scale,
            shear=shear,
            trim=trim,
            unsharp_mask=unsharp_mask,
        )

        return typing.cast(None, jsii.invoke(self, "putLandscape", [value]))

    @jsii.member(jsii_name="putPortrait")
    def put_portrait(
        self,
        *,
        append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppend", typing.Dict[builtins.str, typing.Any]]]]] = None,
        aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAspectCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitBackgroundColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitBlur", typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitChromaKey", typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitComposite", typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompound", typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitContrast", typing.Dict[builtins.str, typing.Any]]]]] = None,
        crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFaceCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFeatureCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFill", typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitGoop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitGrayscale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitHsl", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitHsv", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimension", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
        im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitImQuery", typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitMaxColors", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitMirror", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitMonoHue", typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitOpacity", typing.Dict[builtins.str, typing.Any]]]]] = None,
        region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRelativeCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRemoveColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitResize", typing.Dict[builtins.str, typing.Any]]]]] = None,
        rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRotate", typing.Dict[builtins.str, typing.Any]]]]] = None,
        scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitScale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitShear", typing.Dict[builtins.str, typing.Any]]]]] = None,
        trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitTrim", typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitUnsharpMask", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param append: append block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        :param aspect_crop: aspect_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param crop: crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        :param face_crop: face_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        :param feature_crop: feature_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        :param fit_and_fill: fit_and_fill block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param im_query: im_query block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param region_of_interest_crop: region_of_interest_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        :param relative_crop: relative_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param resize: resize block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        :param rotate: rotate block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        :param scale: scale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param shear: shear block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        :param trim: trim block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortrait(
            append=append,
            aspect_crop=aspect_crop,
            background_color=background_color,
            blur=blur,
            chroma_key=chroma_key,
            composite=composite,
            compound=compound,
            contrast=contrast,
            crop=crop,
            face_crop=face_crop,
            feature_crop=feature_crop,
            fit_and_fill=fit_and_fill,
            goop=goop,
            grayscale=grayscale,
            hsl=hsl,
            hsv=hsv,
            if_dimension=if_dimension,
            if_orientation=if_orientation,
            im_query=im_query,
            max_colors=max_colors,
            mirror=mirror,
            mono_hue=mono_hue,
            opacity=opacity,
            region_of_interest_crop=region_of_interest_crop,
            relative_crop=relative_crop,
            remove_color=remove_color,
            resize=resize,
            rotate=rotate,
            scale=scale,
            shear=shear,
            trim=trim,
            unsharp_mask=unsharp_mask,
        )

        return typing.cast(None, jsii.invoke(self, "putPortrait", [value]))

    @jsii.member(jsii_name="putSquare")
    def put_square(
        self,
        *,
        append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppend", typing.Dict[builtins.str, typing.Any]]]]] = None,
        aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAspectCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareBackgroundColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareBlur", typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareChromaKey", typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareComposite", typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompound", typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareContrast", typing.Dict[builtins.str, typing.Any]]]]] = None,
        crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFaceCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFeatureCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFill", typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareGoop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareGrayscale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareHsl", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareHsv", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimension", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
        im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareImQuery", typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareMaxColors", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareMirror", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareMonoHue", typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareOpacity", typing.Dict[builtins.str, typing.Any]]]]] = None,
        region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRelativeCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRemoveColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareResize", typing.Dict[builtins.str, typing.Any]]]]] = None,
        rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRotate", typing.Dict[builtins.str, typing.Any]]]]] = None,
        scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareScale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareShear", typing.Dict[builtins.str, typing.Any]]]]] = None,
        trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareTrim", typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareUnsharpMask", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param append: append block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        :param aspect_crop: aspect_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param crop: crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        :param face_crop: face_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        :param feature_crop: feature_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        :param fit_and_fill: fit_and_fill block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param im_query: im_query block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param region_of_interest_crop: region_of_interest_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        :param relative_crop: relative_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param resize: resize block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        :param rotate: rotate block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        :param scale: scale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param shear: shear block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        :param trim: trim block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquare(
            append=append,
            aspect_crop=aspect_crop,
            background_color=background_color,
            blur=blur,
            chroma_key=chroma_key,
            composite=composite,
            compound=compound,
            contrast=contrast,
            crop=crop,
            face_crop=face_crop,
            feature_crop=feature_crop,
            fit_and_fill=fit_and_fill,
            goop=goop,
            grayscale=grayscale,
            hsl=hsl,
            hsv=hsv,
            if_dimension=if_dimension,
            if_orientation=if_orientation,
            im_query=im_query,
            max_colors=max_colors,
            mirror=mirror,
            mono_hue=mono_hue,
            opacity=opacity,
            region_of_interest_crop=region_of_interest_crop,
            relative_crop=relative_crop,
            remove_color=remove_color,
            resize=resize,
            rotate=rotate,
            scale=scale,
            shear=shear,
            trim=trim,
            unsharp_mask=unsharp_mask,
        )

        return typing.cast(None, jsii.invoke(self, "putSquare", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetLandscape")
    def reset_landscape(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLandscape", []))

    @jsii.member(jsii_name="resetPortrait")
    def reset_portrait(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPortrait", []))

    @jsii.member(jsii_name="resetSquare")
    def reset_square(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSquare", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="landscape")
    def landscape(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeOutputReference, jsii.get(self, "landscape"))

    @builtins.property
    @jsii.member(jsii_name="portrait")
    def portrait(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitOutputReference", jsii.get(self, "portrait"))

    @builtins.property
    @jsii.member(jsii_name="square")
    def square(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareOutputReference", jsii.get(self, "square"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="landscapeInput")
    def landscape_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscape], jsii.get(self, "landscapeInput"))

    @builtins.property
    @jsii.member(jsii_name="portraitInput")
    def portrait_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortrait"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortrait"], jsii.get(self, "portraitInput"))

    @builtins.property
    @jsii.member(jsii_name="squareInput")
    def square_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquare"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquare"], jsii.get(self, "squareInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientation]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientation]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientation]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__98a8f823b4c5a7733752c66f9062e8ccc17f3f08575479738ae11cb79a43c83f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortrait",
    jsii_struct_bases=[],
    name_mapping={
        "append": "append",
        "aspect_crop": "aspectCrop",
        "background_color": "backgroundColor",
        "blur": "blur",
        "chroma_key": "chromaKey",
        "composite": "composite",
        "compound": "compound",
        "contrast": "contrast",
        "crop": "crop",
        "face_crop": "faceCrop",
        "feature_crop": "featureCrop",
        "fit_and_fill": "fitAndFill",
        "goop": "goop",
        "grayscale": "grayscale",
        "hsl": "hsl",
        "hsv": "hsv",
        "if_dimension": "ifDimension",
        "if_orientation": "ifOrientation",
        "im_query": "imQuery",
        "max_colors": "maxColors",
        "mirror": "mirror",
        "mono_hue": "monoHue",
        "opacity": "opacity",
        "region_of_interest_crop": "regionOfInterestCrop",
        "relative_crop": "relativeCrop",
        "remove_color": "removeColor",
        "resize": "resize",
        "rotate": "rotate",
        "scale": "scale",
        "shear": "shear",
        "trim": "trim",
        "unsharp_mask": "unsharpMask",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortrait:
    def __init__(
        self,
        *,
        append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppend", typing.Dict[builtins.str, typing.Any]]]]] = None,
        aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAspectCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitBackgroundColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitBlur", typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitChromaKey", typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitComposite", typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompound", typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitContrast", typing.Dict[builtins.str, typing.Any]]]]] = None,
        crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFaceCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFeatureCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFill", typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitGoop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitGrayscale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitHsl", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitHsv", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimension", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
        im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitImQuery", typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitMaxColors", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitMirror", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitMonoHue", typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitOpacity", typing.Dict[builtins.str, typing.Any]]]]] = None,
        region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRelativeCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRemoveColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitResize", typing.Dict[builtins.str, typing.Any]]]]] = None,
        rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRotate", typing.Dict[builtins.str, typing.Any]]]]] = None,
        scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitScale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitShear", typing.Dict[builtins.str, typing.Any]]]]] = None,
        trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitTrim", typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitUnsharpMask", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param append: append block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        :param aspect_crop: aspect_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param crop: crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        :param face_crop: face_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        :param feature_crop: feature_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        :param fit_and_fill: fit_and_fill block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param im_query: im_query block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param region_of_interest_crop: region_of_interest_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        :param relative_crop: relative_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param resize: resize block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        :param rotate: rotate block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        :param scale: scale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param shear: shear block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        :param trim: trim block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b0217708f21a5f8ef0254c33c5d86bdf30dae56a1ddf618313f36db4e8d340b7)
            check_type(argname="argument append", value=append, expected_type=type_hints["append"])
            check_type(argname="argument aspect_crop", value=aspect_crop, expected_type=type_hints["aspect_crop"])
            check_type(argname="argument background_color", value=background_color, expected_type=type_hints["background_color"])
            check_type(argname="argument blur", value=blur, expected_type=type_hints["blur"])
            check_type(argname="argument chroma_key", value=chroma_key, expected_type=type_hints["chroma_key"])
            check_type(argname="argument composite", value=composite, expected_type=type_hints["composite"])
            check_type(argname="argument compound", value=compound, expected_type=type_hints["compound"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument crop", value=crop, expected_type=type_hints["crop"])
            check_type(argname="argument face_crop", value=face_crop, expected_type=type_hints["face_crop"])
            check_type(argname="argument feature_crop", value=feature_crop, expected_type=type_hints["feature_crop"])
            check_type(argname="argument fit_and_fill", value=fit_and_fill, expected_type=type_hints["fit_and_fill"])
            check_type(argname="argument goop", value=goop, expected_type=type_hints["goop"])
            check_type(argname="argument grayscale", value=grayscale, expected_type=type_hints["grayscale"])
            check_type(argname="argument hsl", value=hsl, expected_type=type_hints["hsl"])
            check_type(argname="argument hsv", value=hsv, expected_type=type_hints["hsv"])
            check_type(argname="argument if_dimension", value=if_dimension, expected_type=type_hints["if_dimension"])
            check_type(argname="argument if_orientation", value=if_orientation, expected_type=type_hints["if_orientation"])
            check_type(argname="argument im_query", value=im_query, expected_type=type_hints["im_query"])
            check_type(argname="argument max_colors", value=max_colors, expected_type=type_hints["max_colors"])
            check_type(argname="argument mirror", value=mirror, expected_type=type_hints["mirror"])
            check_type(argname="argument mono_hue", value=mono_hue, expected_type=type_hints["mono_hue"])
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument region_of_interest_crop", value=region_of_interest_crop, expected_type=type_hints["region_of_interest_crop"])
            check_type(argname="argument relative_crop", value=relative_crop, expected_type=type_hints["relative_crop"])
            check_type(argname="argument remove_color", value=remove_color, expected_type=type_hints["remove_color"])
            check_type(argname="argument resize", value=resize, expected_type=type_hints["resize"])
            check_type(argname="argument rotate", value=rotate, expected_type=type_hints["rotate"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument shear", value=shear, expected_type=type_hints["shear"])
            check_type(argname="argument trim", value=trim, expected_type=type_hints["trim"])
            check_type(argname="argument unsharp_mask", value=unsharp_mask, expected_type=type_hints["unsharp_mask"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if append is not None:
            self._values["append"] = append
        if aspect_crop is not None:
            self._values["aspect_crop"] = aspect_crop
        if background_color is not None:
            self._values["background_color"] = background_color
        if blur is not None:
            self._values["blur"] = blur
        if chroma_key is not None:
            self._values["chroma_key"] = chroma_key
        if composite is not None:
            self._values["composite"] = composite
        if compound is not None:
            self._values["compound"] = compound
        if contrast is not None:
            self._values["contrast"] = contrast
        if crop is not None:
            self._values["crop"] = crop
        if face_crop is not None:
            self._values["face_crop"] = face_crop
        if feature_crop is not None:
            self._values["feature_crop"] = feature_crop
        if fit_and_fill is not None:
            self._values["fit_and_fill"] = fit_and_fill
        if goop is not None:
            self._values["goop"] = goop
        if grayscale is not None:
            self._values["grayscale"] = grayscale
        if hsl is not None:
            self._values["hsl"] = hsl
        if hsv is not None:
            self._values["hsv"] = hsv
        if if_dimension is not None:
            self._values["if_dimension"] = if_dimension
        if if_orientation is not None:
            self._values["if_orientation"] = if_orientation
        if im_query is not None:
            self._values["im_query"] = im_query
        if max_colors is not None:
            self._values["max_colors"] = max_colors
        if mirror is not None:
            self._values["mirror"] = mirror
        if mono_hue is not None:
            self._values["mono_hue"] = mono_hue
        if opacity is not None:
            self._values["opacity"] = opacity
        if region_of_interest_crop is not None:
            self._values["region_of_interest_crop"] = region_of_interest_crop
        if relative_crop is not None:
            self._values["relative_crop"] = relative_crop
        if remove_color is not None:
            self._values["remove_color"] = remove_color
        if resize is not None:
            self._values["resize"] = resize
        if rotate is not None:
            self._values["rotate"] = rotate
        if scale is not None:
            self._values["scale"] = scale
        if shear is not None:
            self._values["shear"] = shear
        if trim is not None:
            self._values["trim"] = trim
        if unsharp_mask is not None:
            self._values["unsharp_mask"] = unsharp_mask

    @builtins.property
    def append(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppend"]]]:
        '''append block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        '''
        result = self._values.get("append")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppend"]]], result)

    @builtins.property
    def aspect_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAspectCrop"]]]:
        '''aspect_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        '''
        result = self._values.get("aspect_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAspectCrop"]]], result)

    @builtins.property
    def background_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitBackgroundColor"]]]:
        '''background_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        '''
        result = self._values.get("background_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitBackgroundColor"]]], result)

    @builtins.property
    def blur(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitBlur"]]]:
        '''blur block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        '''
        result = self._values.get("blur")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitBlur"]]], result)

    @builtins.property
    def chroma_key(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitChromaKey"]]]:
        '''chroma_key block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        '''
        result = self._values.get("chroma_key")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitChromaKey"]]], result)

    @builtins.property
    def composite(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitComposite"]]]:
        '''composite block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        '''
        result = self._values.get("composite")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitComposite"]]], result)

    @builtins.property
    def compound(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompound"]]]:
        '''compound block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        '''
        result = self._values.get("compound")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompound"]]], result)

    @builtins.property
    def contrast(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitContrast"]]]:
        '''contrast block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitContrast"]]], result)

    @builtins.property
    def crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCrop"]]]:
        '''crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        '''
        result = self._values.get("crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCrop"]]], result)

    @builtins.property
    def face_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFaceCrop"]]]:
        '''face_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        '''
        result = self._values.get("face_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFaceCrop"]]], result)

    @builtins.property
    def feature_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFeatureCrop"]]]:
        '''feature_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        '''
        result = self._values.get("feature_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFeatureCrop"]]], result)

    @builtins.property
    def fit_and_fill(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFill"]]]:
        '''fit_and_fill block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        '''
        result = self._values.get("fit_and_fill")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFill"]]], result)

    @builtins.property
    def goop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitGoop"]]]:
        '''goop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        '''
        result = self._values.get("goop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitGoop"]]], result)

    @builtins.property
    def grayscale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitGrayscale"]]]:
        '''grayscale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        '''
        result = self._values.get("grayscale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitGrayscale"]]], result)

    @builtins.property
    def hsl(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitHsl"]]]:
        '''hsl block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        '''
        result = self._values.get("hsl")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitHsl"]]], result)

    @builtins.property
    def hsv(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitHsv"]]]:
        '''hsv block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        '''
        result = self._values.get("hsv")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitHsv"]]], result)

    @builtins.property
    def if_dimension(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimension"]]]:
        '''if_dimension block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        '''
        result = self._values.get("if_dimension")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimension"]]], result)

    @builtins.property
    def if_orientation(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientation]]]:
        '''if_orientation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        '''
        result = self._values.get("if_orientation")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientation]]], result)

    @builtins.property
    def im_query(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitImQuery"]]]:
        '''im_query block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        '''
        result = self._values.get("im_query")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitImQuery"]]], result)

    @builtins.property
    def max_colors(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitMaxColors"]]]:
        '''max_colors block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        '''
        result = self._values.get("max_colors")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitMaxColors"]]], result)

    @builtins.property
    def mirror(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitMirror"]]]:
        '''mirror block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        '''
        result = self._values.get("mirror")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitMirror"]]], result)

    @builtins.property
    def mono_hue(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitMonoHue"]]]:
        '''mono_hue block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        '''
        result = self._values.get("mono_hue")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitMonoHue"]]], result)

    @builtins.property
    def opacity(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitOpacity"]]]:
        '''opacity block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitOpacity"]]], result)

    @builtins.property
    def region_of_interest_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCrop"]]]:
        '''region_of_interest_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        '''
        result = self._values.get("region_of_interest_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCrop"]]], result)

    @builtins.property
    def relative_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRelativeCrop"]]]:
        '''relative_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        '''
        result = self._values.get("relative_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRelativeCrop"]]], result)

    @builtins.property
    def remove_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRemoveColor"]]]:
        '''remove_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        '''
        result = self._values.get("remove_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRemoveColor"]]], result)

    @builtins.property
    def resize(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitResize"]]]:
        '''resize block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        '''
        result = self._values.get("resize")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitResize"]]], result)

    @builtins.property
    def rotate(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRotate"]]]:
        '''rotate block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        '''
        result = self._values.get("rotate")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRotate"]]], result)

    @builtins.property
    def scale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitScale"]]]:
        '''scale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitScale"]]], result)

    @builtins.property
    def shear(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitShear"]]]:
        '''shear block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        '''
        result = self._values.get("shear")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitShear"]]], result)

    @builtins.property
    def trim(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitTrim"]]]:
        '''trim block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        '''
        result = self._values.get("trim")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitTrim"]]], result)

    @builtins.property
    def unsharp_mask(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitUnsharpMask"]]]:
        '''unsharp_mask block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        result = self._values.get("unsharp_mask")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitUnsharpMask"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortrait(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppend",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_priority": "gravityPriority",
        "gravity_priority_var": "gravityPriorityVar",
        "gravity_var": "gravityVar",
        "preserve_minor_dimension": "preserveMinorDimension",
        "preserve_minor_dimension_var": "preserveMinorDimensionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppend:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_priority: typing.Optional[builtins.str] = None,
        gravity_priority_var: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        preserve_minor_dimension: typing.Optional[builtins.str] = None,
        preserve_minor_dimension_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Specifies where to place the ``image`` relative to the source image. The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_priority: Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal. The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority DataAkamaiImagingPolicyImage#gravity_priority}
        :param gravity_priority_var: Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal. The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority_var DataAkamaiImagingPolicyImage#gravity_priority_var}
        :param gravity_var: Specifies where to place the ``image`` relative to the source image. The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param preserve_minor_dimension: Whether to preserve the source image's minor dimension, ``false`` by default. The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension DataAkamaiImagingPolicyImage#preserve_minor_dimension}
        :param preserve_minor_dimension_var: Whether to preserve the source image's minor dimension, ``false`` by default. The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension_var DataAkamaiImagingPolicyImage#preserve_minor_dimension_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9046e539d3296384a498d8a44eced2a888aea0b929db39981a611d7dc311f0e0)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_priority", value=gravity_priority, expected_type=type_hints["gravity_priority"])
            check_type(argname="argument gravity_priority_var", value=gravity_priority_var, expected_type=type_hints["gravity_priority_var"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument preserve_minor_dimension", value=preserve_minor_dimension, expected_type=type_hints["preserve_minor_dimension"])
            check_type(argname="argument preserve_minor_dimension_var", value=preserve_minor_dimension_var, expected_type=type_hints["preserve_minor_dimension_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_priority is not None:
            self._values["gravity_priority"] = gravity_priority
        if gravity_priority_var is not None:
            self._values["gravity_priority_var"] = gravity_priority_var
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if preserve_minor_dimension is not None:
            self._values["preserve_minor_dimension"] = preserve_minor_dimension
        if preserve_minor_dimension_var is not None:
            self._values["preserve_minor_dimension_var"] = preserve_minor_dimension_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Specifies where to place the ``image`` relative to the source image.

        The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_priority(self) -> typing.Optional[builtins.str]:
        '''Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal.

        The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority DataAkamaiImagingPolicyImage#gravity_priority}
        '''
        result = self._values.get("gravity_priority")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_priority_var(self) -> typing.Optional[builtins.str]:
        '''Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal.

        The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority_var DataAkamaiImagingPolicyImage#gravity_priority_var}
        '''
        result = self._values.get("gravity_priority_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Specifies where to place the ``image`` relative to the source image.

        The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def preserve_minor_dimension(self) -> typing.Optional[builtins.str]:
        '''Whether to preserve the source image's minor dimension, ``false`` by default.

        The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension DataAkamaiImagingPolicyImage#preserve_minor_dimension}
        '''
        result = self._values.get("preserve_minor_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def preserve_minor_dimension_var(self) -> typing.Optional[builtins.str]:
        '''Whether to preserve the source image's minor dimension, ``false`` by default.

        The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension_var DataAkamaiImagingPolicyImage#preserve_minor_dimension_var}
        '''
        result = self._values.get("preserve_minor_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppend(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImage",
    jsii_struct_bases=[],
    name_mapping={
        "box_image": "boxImage",
        "circle_image": "circleImage",
        "text_image": "textImage",
        "url_image": "urlImage",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImage:
    def __init__(
        self,
        *,
        box_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageBoxImage", typing.Dict[builtins.str, typing.Any]]]]] = None,
        circle_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageCircleImage", typing.Dict[builtins.str, typing.Any]]]]] = None,
        text_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageTextImage", typing.Dict[builtins.str, typing.Any]]]]] = None,
        url_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageUrlImage", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param box_image: box_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#box_image DataAkamaiImagingPolicyImage#box_image}
        :param circle_image: circle_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#circle_image DataAkamaiImagingPolicyImage#circle_image}
        :param text_image: text_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text_image DataAkamaiImagingPolicyImage#text_image}
        :param url_image: url_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url_image DataAkamaiImagingPolicyImage#url_image}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9302e8375269b5ea80799a12bfca97043ab6bf39edbcc4f72ae739e5809df5c2)
            check_type(argname="argument box_image", value=box_image, expected_type=type_hints["box_image"])
            check_type(argname="argument circle_image", value=circle_image, expected_type=type_hints["circle_image"])
            check_type(argname="argument text_image", value=text_image, expected_type=type_hints["text_image"])
            check_type(argname="argument url_image", value=url_image, expected_type=type_hints["url_image"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if box_image is not None:
            self._values["box_image"] = box_image
        if circle_image is not None:
            self._values["circle_image"] = circle_image
        if text_image is not None:
            self._values["text_image"] = text_image
        if url_image is not None:
            self._values["url_image"] = url_image

    @builtins.property
    def box_image(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageBoxImage"]]]:
        '''box_image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#box_image DataAkamaiImagingPolicyImage#box_image}
        '''
        result = self._values.get("box_image")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageBoxImage"]]], result)

    @builtins.property
    def circle_image(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageCircleImage"]]]:
        '''circle_image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#circle_image DataAkamaiImagingPolicyImage#circle_image}
        '''
        result = self._values.get("circle_image")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageCircleImage"]]], result)

    @builtins.property
    def text_image(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageTextImage"]]]:
        '''text_image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text_image DataAkamaiImagingPolicyImage#text_image}
        '''
        result = self._values.get("text_image")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageTextImage"]]], result)

    @builtins.property
    def url_image(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageUrlImage"]]]:
        '''url_image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url_image DataAkamaiImagingPolicyImage#url_image}
        '''
        result = self._values.get("url_image")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageUrlImage"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageBoxImage",
    jsii_struct_bases=[],
    name_mapping={
        "color": "color",
        "color_var": "colorVar",
        "height": "height",
        "height_var": "heightVar",
        "transformation": "transformation",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageBoxImage:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        transformation: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageBoxImageTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The fill color of the box, not the edge of the box. The API supports hexadecimal representation and CSS hexadecimal color values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The fill color of the box, not the edge of the box. The API supports hexadecimal representation and CSS hexadecimal color values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        :param height: The height of the box in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height of the box in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param transformation: transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        :param width: The width of the box in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width of the box in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(transformation, dict):
            transformation = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageBoxImageTransformation(**transformation)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__086797e724079ab07b34817bd4f2139a0d7619a13946212ff1cae5f2353043b6)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument transformation", value=transformation, expected_type=type_hints["transformation"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if transformation is not None:
            self._values["transformation"] = transformation
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The fill color of the box, not the edge of the box.

        The API supports hexadecimal representation and CSS hexadecimal color values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The fill color of the box, not the edge of the box.

        The API supports hexadecimal representation and CSS hexadecimal color values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height of the box in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height of the box in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def transformation(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageBoxImageTransformation"]:
        '''transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        '''
        result = self._values.get("transformation")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageBoxImageTransformation"], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width of the box in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width of the box in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageBoxImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageBoxImageList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageBoxImageList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c5b6c71e8334d74b334d06c95bd84bd397b6cc37604bce2da6d9cfb4f6febd2d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageBoxImageOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8ad242b35ce070e527febcafb7239c065fb701e789797c1681995789afe5422b)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageBoxImageOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c8caa2a9819e49385527c6b3ec7acdf77b5469e03487c7f15fcc926d57d131de)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4be5970358fe46b110d9582d1ec5c1740d7215e65fc7e49c2d2aad76a12935be)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__33b98d4ac09034695350d3f324e198a2b34846f31d8fd01e39af50ff598df5fe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageBoxImage]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageBoxImage]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageBoxImage]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__53201602a04c155b20a32b9ff268478fef40b1a6764b1b4c8444654d28611d37)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageBoxImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageBoxImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__99968210b4bc518358707966413f44fa8704aa0c1862cd7116af53e11217c348)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformation")
    def put_transformation(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageBoxImageTransformation()

        return typing.cast(None, jsii.invoke(self, "putTransformation", [value]))

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetTransformation")
    def reset_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformation", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="transformation")
    def transformation(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageBoxImageTransformationOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageBoxImageTransformationOutputReference", jsii.get(self, "transformation"))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="transformationInput")
    def transformation_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageBoxImageTransformation"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageBoxImageTransformation"], jsii.get(self, "transformationInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__84b0a265717289f8382330a98088eddf8362a81c54d0f3937027f5e4a9a0edd9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__97251e6e2ed1dbe1d59d1b5990d260d2ec1d7b169662aa5cefac7689a7d5a94f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f54728e078f314a75fc45910d155a9b8df9b5e0707e171f6e7d74303f034956)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9e479a61160cd6ab7e1a1443d240f655f49b9915c4105fe588f76e37c17dff5f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6b0c9c20084a2bfda6462f90c366b2e48e0d7f3f6b1fc1b1956053618a0aa74b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__85fee67c0b08c4dee84161fb39d0c7988c0e548ef001d44de9e94a5d679ae2bc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageBoxImage]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageBoxImage]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageBoxImage]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f557cd2b6d1b6eb39aff127cfef885507e73eae3c49c8e247aa494680f2f6811)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageBoxImageTransformation",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageBoxImageTransformation:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageBoxImageTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageBoxImageTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageBoxImageTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__db737fc28f3c0dc3325790d956e8025fde4c939132668a5d409cb5caab63125e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageBoxImageTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageBoxImageTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageBoxImageTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e0cecb6cb15343b5097cce12addcaf56f27d2261dde57d1d35550a70094df5db)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageCircleImage",
    jsii_struct_bases=[],
    name_mapping={
        "color": "color",
        "color_var": "colorVar",
        "diameter": "diameter",
        "diameter_var": "diameterVar",
        "transformation": "transformation",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageCircleImage:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
        diameter: typing.Optional[builtins.str] = None,
        diameter_var: typing.Optional[builtins.str] = None,
        transformation: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageCircleImageTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The fill color of the circle. The API supports hexadecimal representation and CSS hexadecimal color values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The fill color of the circle. The API supports hexadecimal representation and CSS hexadecimal color values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        :param diameter: The diameter of the circle. The diameter will be the width and the height of the image in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#diameter DataAkamaiImagingPolicyImage#diameter}
        :param diameter_var: The diameter of the circle. The diameter will be the width and the height of the image in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#diameter_var DataAkamaiImagingPolicyImage#diameter_var}
        :param transformation: transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        :param width: The width of the box in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width of the box in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(transformation, dict):
            transformation = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageCircleImageTransformation(**transformation)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a5084a6aa8c6c66c079a6d1b475632e3d7bf83044d4c7ef4341d0fa2ce1af6e4)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
            check_type(argname="argument diameter", value=diameter, expected_type=type_hints["diameter"])
            check_type(argname="argument diameter_var", value=diameter_var, expected_type=type_hints["diameter_var"])
            check_type(argname="argument transformation", value=transformation, expected_type=type_hints["transformation"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var
        if diameter is not None:
            self._values["diameter"] = diameter
        if diameter_var is not None:
            self._values["diameter_var"] = diameter_var
        if transformation is not None:
            self._values["transformation"] = transformation
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The fill color of the circle. The API supports hexadecimal representation and CSS hexadecimal color values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The fill color of the circle. The API supports hexadecimal representation and CSS hexadecimal color values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def diameter(self) -> typing.Optional[builtins.str]:
        '''The diameter of the circle. The diameter will be the width and the height of the image in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#diameter DataAkamaiImagingPolicyImage#diameter}
        '''
        result = self._values.get("diameter")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def diameter_var(self) -> typing.Optional[builtins.str]:
        '''The diameter of the circle. The diameter will be the width and the height of the image in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#diameter_var DataAkamaiImagingPolicyImage#diameter_var}
        '''
        result = self._values.get("diameter_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def transformation(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageCircleImageTransformation"]:
        '''transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        '''
        result = self._values.get("transformation")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageCircleImageTransformation"], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width of the box in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width of the box in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageCircleImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageCircleImageList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageCircleImageList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__952f4c22f5cd87b8357facf912455bf2275ec9bf7d0b1d671b044712680e1d02)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageCircleImageOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__77c358c7bf60fd414b89b8f5ed3d70965db36a1b4c0c8bc1b6c35fbee9bf635f)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageCircleImageOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b1f5c73b7633088892a8e807433fdae895f65eea460bf8462ca5a9cf146c6281)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be92debccb11d044eae4bc38fcbd3d71c41936fa5ce7707c2a7616fcb3bf37f6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2b50cd1121c715ee9c4b5fea13e8c9e34bee616651fd0f9f24598c62fc6ed53f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageCircleImage]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageCircleImage]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageCircleImage]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1746b08f5a0add3328b97e6bc5fc7c697287298acedaadbb8177746d67d7ad74)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageCircleImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageCircleImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bbc3ee39594504fb0ab4afcef08ecacde5efc2ca0a7be4dbbe79faee3769153f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformation")
    def put_transformation(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageCircleImageTransformation()

        return typing.cast(None, jsii.invoke(self, "putTransformation", [value]))

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @jsii.member(jsii_name="resetDiameter")
    def reset_diameter(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDiameter", []))

    @jsii.member(jsii_name="resetDiameterVar")
    def reset_diameter_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDiameterVar", []))

    @jsii.member(jsii_name="resetTransformation")
    def reset_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformation", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="transformation")
    def transformation(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageCircleImageTransformationOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageCircleImageTransformationOutputReference", jsii.get(self, "transformation"))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="diameterInput")
    def diameter_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "diameterInput"))

    @builtins.property
    @jsii.member(jsii_name="diameterVarInput")
    def diameter_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "diameterVarInput"))

    @builtins.property
    @jsii.member(jsii_name="transformationInput")
    def transformation_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageCircleImageTransformation"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageCircleImageTransformation"], jsii.get(self, "transformationInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f1856b325db7cf9b32a8b4b3cb5e3917372e13e00c6a8fa3c5b00c40adacefe0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bad8317d8639c0f9146666ad14de5000e9925a736ef2ef5a3a02969bda1623ce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="diameter")
    def diameter(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "diameter"))

    @diameter.setter
    def diameter(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b52b18dec51a211c64f0c23bc46eb72e280b4aa418c801ee838f1e4337aa9d93)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "diameter", value)

    @builtins.property
    @jsii.member(jsii_name="diameterVar")
    def diameter_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "diameterVar"))

    @diameter_var.setter
    def diameter_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__439dc1b1b7eb619ac94e6e0ed9d6040107a230f020a7d31e12dfa904aff7f490)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "diameterVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cb7944a0c458cfa92c9a2ee054b498a05ff270ceeab1e314d0cb6e8b7c675111)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ecdd97b9e51555401fcd0a97fb08439df0a97d2c0e20e2e752ad4e551bd0bdb7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageCircleImage]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageCircleImage]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageCircleImage]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__71e801207ae3fd98223eb85245697def43e917f280eccca5e526aabd9be743d4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageCircleImageTransformation",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageCircleImageTransformation:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageCircleImageTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageCircleImageTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageCircleImageTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b2082b379cd6b5452f41cbb72571e3364c90543399c08369af218885cc9f70df)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageCircleImageTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageCircleImageTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageCircleImageTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__31899acf10757044b44ccf4fc15a39399b8d11da79741241b84ee660cf1aaa88)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4af2a81ceb6f2033bd9d8ea7e37ba1ed943f784d99067be22064a7e952a257d3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putBoxImage")
    def put_box_image(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageBoxImage, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__829dab17f3592a76bc1fe2c6ba83f689b06147f8d7e723ffb35cd0cb8c2ae587)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBoxImage", [value]))

    @jsii.member(jsii_name="putCircleImage")
    def put_circle_image(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageCircleImage, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6dba988098f1cd9cdc1cdd6b074f4890ffe099250f1555f68ed0ba6e90dc69e9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCircleImage", [value]))

    @jsii.member(jsii_name="putTextImage")
    def put_text_image(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageTextImage", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ee6336268d3ce5e7ff1de61bb2d89210fa6288585f531c418e2ed920b31c3fca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTextImage", [value]))

    @jsii.member(jsii_name="putUrlImage")
    def put_url_image(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageUrlImage", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__419be713c1b869fc6c274f45230eb11ec102f978b8fd647b0e409e25a6c5b3e1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putUrlImage", [value]))

    @jsii.member(jsii_name="resetBoxImage")
    def reset_box_image(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBoxImage", []))

    @jsii.member(jsii_name="resetCircleImage")
    def reset_circle_image(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCircleImage", []))

    @jsii.member(jsii_name="resetTextImage")
    def reset_text_image(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTextImage", []))

    @jsii.member(jsii_name="resetUrlImage")
    def reset_url_image(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUrlImage", []))

    @builtins.property
    @jsii.member(jsii_name="boxImage")
    def box_image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageBoxImageList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageBoxImageList, jsii.get(self, "boxImage"))

    @builtins.property
    @jsii.member(jsii_name="circleImage")
    def circle_image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageCircleImageList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageCircleImageList, jsii.get(self, "circleImage"))

    @builtins.property
    @jsii.member(jsii_name="textImage")
    def text_image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageTextImageList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageTextImageList", jsii.get(self, "textImage"))

    @builtins.property
    @jsii.member(jsii_name="urlImage")
    def url_image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageUrlImageList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageUrlImageList", jsii.get(self, "urlImage"))

    @builtins.property
    @jsii.member(jsii_name="boxImageInput")
    def box_image_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageBoxImage]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageBoxImage]]], jsii.get(self, "boxImageInput"))

    @builtins.property
    @jsii.member(jsii_name="circleImageInput")
    def circle_image_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageCircleImage]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageCircleImage]]], jsii.get(self, "circleImageInput"))

    @builtins.property
    @jsii.member(jsii_name="textImageInput")
    def text_image_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageTextImage"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageTextImage"]]], jsii.get(self, "textImageInput"))

    @builtins.property
    @jsii.member(jsii_name="urlImageInput")
    def url_image_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageUrlImage"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageUrlImage"]]], jsii.get(self, "urlImageInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a7c1fc65da1834ce48d3f0919762fdad91ef0f8961169a37c3b342f645229bc0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageTextImage",
    jsii_struct_bases=[],
    name_mapping={
        "fill": "fill",
        "fill_var": "fillVar",
        "size": "size",
        "size_var": "sizeVar",
        "stroke": "stroke",
        "stroke_size": "strokeSize",
        "stroke_size_var": "strokeSizeVar",
        "stroke_var": "strokeVar",
        "text": "text",
        "text_var": "textVar",
        "transformation": "transformation",
        "typeface": "typeface",
        "typeface_var": "typefaceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageTextImage:
    def __init__(
        self,
        *,
        fill: typing.Optional[builtins.str] = None,
        fill_var: typing.Optional[builtins.str] = None,
        size: typing.Optional[builtins.str] = None,
        size_var: typing.Optional[builtins.str] = None,
        stroke: typing.Optional[builtins.str] = None,
        stroke_size: typing.Optional[builtins.str] = None,
        stroke_size_var: typing.Optional[builtins.str] = None,
        stroke_var: typing.Optional[builtins.str] = None,
        text: typing.Optional[builtins.str] = None,
        text_var: typing.Optional[builtins.str] = None,
        transformation: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageTextImageTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        typeface: typing.Optional[builtins.str] = None,
        typeface_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fill: The main fill color of the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill DataAkamaiImagingPolicyImage#fill}
        :param fill_var: The main fill color of the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_var DataAkamaiImagingPolicyImage#fill_var}
        :param size: The size in pixels to render the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#size DataAkamaiImagingPolicyImage#size}
        :param size_var: The size in pixels to render the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#size_var DataAkamaiImagingPolicyImage#size_var}
        :param stroke: The color for the outline of the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke DataAkamaiImagingPolicyImage#stroke}
        :param stroke_size: The thickness in points for the outline of the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_size DataAkamaiImagingPolicyImage#stroke_size}
        :param stroke_size_var: The thickness in points for the outline of the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_size_var DataAkamaiImagingPolicyImage#stroke_size_var}
        :param stroke_var: The color for the outline of the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_var DataAkamaiImagingPolicyImage#stroke_var}
        :param text: The line of text to render. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text DataAkamaiImagingPolicyImage#text}
        :param text_var: The line of text to render. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text_var DataAkamaiImagingPolicyImage#text_var}
        :param transformation: transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        :param typeface: The font family to apply to the text image. This may be a URL to a TrueType or WOFF (v1) typeface, or a string that refers to one of the standard built-in browser fonts. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#typeface DataAkamaiImagingPolicyImage#typeface}
        :param typeface_var: The font family to apply to the text image. This may be a URL to a TrueType or WOFF (v1) typeface, or a string that refers to one of the standard built-in browser fonts. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#typeface_var DataAkamaiImagingPolicyImage#typeface_var}
        '''
        if isinstance(transformation, dict):
            transformation = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageTextImageTransformation(**transformation)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0121f80f12efc377ea664c7f2a310955dc499d5210491bf45751099c0862686c)
            check_type(argname="argument fill", value=fill, expected_type=type_hints["fill"])
            check_type(argname="argument fill_var", value=fill_var, expected_type=type_hints["fill_var"])
            check_type(argname="argument size", value=size, expected_type=type_hints["size"])
            check_type(argname="argument size_var", value=size_var, expected_type=type_hints["size_var"])
            check_type(argname="argument stroke", value=stroke, expected_type=type_hints["stroke"])
            check_type(argname="argument stroke_size", value=stroke_size, expected_type=type_hints["stroke_size"])
            check_type(argname="argument stroke_size_var", value=stroke_size_var, expected_type=type_hints["stroke_size_var"])
            check_type(argname="argument stroke_var", value=stroke_var, expected_type=type_hints["stroke_var"])
            check_type(argname="argument text", value=text, expected_type=type_hints["text"])
            check_type(argname="argument text_var", value=text_var, expected_type=type_hints["text_var"])
            check_type(argname="argument transformation", value=transformation, expected_type=type_hints["transformation"])
            check_type(argname="argument typeface", value=typeface, expected_type=type_hints["typeface"])
            check_type(argname="argument typeface_var", value=typeface_var, expected_type=type_hints["typeface_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fill is not None:
            self._values["fill"] = fill
        if fill_var is not None:
            self._values["fill_var"] = fill_var
        if size is not None:
            self._values["size"] = size
        if size_var is not None:
            self._values["size_var"] = size_var
        if stroke is not None:
            self._values["stroke"] = stroke
        if stroke_size is not None:
            self._values["stroke_size"] = stroke_size
        if stroke_size_var is not None:
            self._values["stroke_size_var"] = stroke_size_var
        if stroke_var is not None:
            self._values["stroke_var"] = stroke_var
        if text is not None:
            self._values["text"] = text
        if text_var is not None:
            self._values["text_var"] = text_var
        if transformation is not None:
            self._values["transformation"] = transformation
        if typeface is not None:
            self._values["typeface"] = typeface
        if typeface_var is not None:
            self._values["typeface_var"] = typeface_var

    @builtins.property
    def fill(self) -> typing.Optional[builtins.str]:
        '''The main fill color of the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill DataAkamaiImagingPolicyImage#fill}
        '''
        result = self._values.get("fill")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fill_var(self) -> typing.Optional[builtins.str]:
        '''The main fill color of the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_var DataAkamaiImagingPolicyImage#fill_var}
        '''
        result = self._values.get("fill_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def size(self) -> typing.Optional[builtins.str]:
        '''The size in pixels to render the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#size DataAkamaiImagingPolicyImage#size}
        '''
        result = self._values.get("size")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def size_var(self) -> typing.Optional[builtins.str]:
        '''The size in pixels to render the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#size_var DataAkamaiImagingPolicyImage#size_var}
        '''
        result = self._values.get("size_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def stroke(self) -> typing.Optional[builtins.str]:
        '''The color for the outline of the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke DataAkamaiImagingPolicyImage#stroke}
        '''
        result = self._values.get("stroke")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def stroke_size(self) -> typing.Optional[builtins.str]:
        '''The thickness in points for the outline of the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_size DataAkamaiImagingPolicyImage#stroke_size}
        '''
        result = self._values.get("stroke_size")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def stroke_size_var(self) -> typing.Optional[builtins.str]:
        '''The thickness in points for the outline of the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_size_var DataAkamaiImagingPolicyImage#stroke_size_var}
        '''
        result = self._values.get("stroke_size_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def stroke_var(self) -> typing.Optional[builtins.str]:
        '''The color for the outline of the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_var DataAkamaiImagingPolicyImage#stroke_var}
        '''
        result = self._values.get("stroke_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def text(self) -> typing.Optional[builtins.str]:
        '''The line of text to render.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text DataAkamaiImagingPolicyImage#text}
        '''
        result = self._values.get("text")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def text_var(self) -> typing.Optional[builtins.str]:
        '''The line of text to render.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text_var DataAkamaiImagingPolicyImage#text_var}
        '''
        result = self._values.get("text_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def transformation(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageTextImageTransformation"]:
        '''transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        '''
        result = self._values.get("transformation")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageTextImageTransformation"], result)

    @builtins.property
    def typeface(self) -> typing.Optional[builtins.str]:
        '''The font family to apply to the text image.

        This may be a URL to a TrueType or WOFF (v1) typeface, or a string that refers to one of the standard built-in browser fonts.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#typeface DataAkamaiImagingPolicyImage#typeface}
        '''
        result = self._values.get("typeface")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def typeface_var(self) -> typing.Optional[builtins.str]:
        '''The font family to apply to the text image.

        This may be a URL to a TrueType or WOFF (v1) typeface, or a string that refers to one of the standard built-in browser fonts.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#typeface_var DataAkamaiImagingPolicyImage#typeface_var}
        '''
        result = self._values.get("typeface_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageTextImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageTextImageList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageTextImageList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__70bc722470cfca80eb719002fe5d9c64cbe6ff2394923aea0145e2c2f59b883a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageTextImageOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f420c0e01b467a7fab31e84d53b9f5ce863952c662f53f4421a027ba769e1b25)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageTextImageOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d755d0ed069e7dac78f0c6d8ed043aa9c3448a5d06bc3f151c78b37237f96537)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ce23036bc9dcc50ebd6505c740e8563c48d0f52cbd076d244b8c9ce11fb94c1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__597ab0bd71c9c0bfa3b94e46bbbe470b34ba174a86f900c5a5ad0f5469b6ac50)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageTextImage]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageTextImage]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageTextImage]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bfb40dc592e7142a4ca5524ee48c6055c8caedbe9cc60310c8dbcb3917858435)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageTextImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageTextImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e81957b2ee3fc69c70cea6a1f536195afc4b352c7c8a2aebfcfc1230a7df522e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformation")
    def put_transformation(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageTextImageTransformation()

        return typing.cast(None, jsii.invoke(self, "putTransformation", [value]))

    @jsii.member(jsii_name="resetFill")
    def reset_fill(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFill", []))

    @jsii.member(jsii_name="resetFillVar")
    def reset_fill_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFillVar", []))

    @jsii.member(jsii_name="resetSize")
    def reset_size(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSize", []))

    @jsii.member(jsii_name="resetSizeVar")
    def reset_size_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSizeVar", []))

    @jsii.member(jsii_name="resetStroke")
    def reset_stroke(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStroke", []))

    @jsii.member(jsii_name="resetStrokeSize")
    def reset_stroke_size(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStrokeSize", []))

    @jsii.member(jsii_name="resetStrokeSizeVar")
    def reset_stroke_size_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStrokeSizeVar", []))

    @jsii.member(jsii_name="resetStrokeVar")
    def reset_stroke_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStrokeVar", []))

    @jsii.member(jsii_name="resetText")
    def reset_text(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetText", []))

    @jsii.member(jsii_name="resetTextVar")
    def reset_text_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTextVar", []))

    @jsii.member(jsii_name="resetTransformation")
    def reset_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformation", []))

    @jsii.member(jsii_name="resetTypeface")
    def reset_typeface(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeface", []))

    @jsii.member(jsii_name="resetTypefaceVar")
    def reset_typeface_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypefaceVar", []))

    @builtins.property
    @jsii.member(jsii_name="transformation")
    def transformation(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageTextImageTransformationOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageTextImageTransformationOutputReference", jsii.get(self, "transformation"))

    @builtins.property
    @jsii.member(jsii_name="fillInput")
    def fill_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fillInput"))

    @builtins.property
    @jsii.member(jsii_name="fillVarInput")
    def fill_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fillVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sizeInput")
    def size_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sizeInput"))

    @builtins.property
    @jsii.member(jsii_name="sizeVarInput")
    def size_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sizeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="strokeInput")
    def stroke_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "strokeInput"))

    @builtins.property
    @jsii.member(jsii_name="strokeSizeInput")
    def stroke_size_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "strokeSizeInput"))

    @builtins.property
    @jsii.member(jsii_name="strokeSizeVarInput")
    def stroke_size_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "strokeSizeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="strokeVarInput")
    def stroke_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "strokeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="textInput")
    def text_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "textInput"))

    @builtins.property
    @jsii.member(jsii_name="textVarInput")
    def text_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "textVarInput"))

    @builtins.property
    @jsii.member(jsii_name="transformationInput")
    def transformation_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageTextImageTransformation"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageTextImageTransformation"], jsii.get(self, "transformationInput"))

    @builtins.property
    @jsii.member(jsii_name="typefaceInput")
    def typeface_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typefaceInput"))

    @builtins.property
    @jsii.member(jsii_name="typefaceVarInput")
    def typeface_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typefaceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="fill")
    def fill(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fill"))

    @fill.setter
    def fill(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a160c34ecdaf70fdc750f9a841f19efef1169ec63bb943c3648fd0a1bd5d11ce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fill", value)

    @builtins.property
    @jsii.member(jsii_name="fillVar")
    def fill_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fillVar"))

    @fill_var.setter
    def fill_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bdc40646bfdeedde6cee6495415e6b96b98a68a2663c3c2d475e751d0a333edb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fillVar", value)

    @builtins.property
    @jsii.member(jsii_name="size")
    def size(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "size"))

    @size.setter
    def size(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__94b63c113eeaad1a2522f431f35fe74d9f15c7c0d11ae5bc9b42f36854a58afc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "size", value)

    @builtins.property
    @jsii.member(jsii_name="sizeVar")
    def size_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sizeVar"))

    @size_var.setter
    def size_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d4d4f947e0f687f3fa49c1837804ecadf796cca54c9e1a47f8543d6df7c4b804)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sizeVar", value)

    @builtins.property
    @jsii.member(jsii_name="stroke")
    def stroke(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "stroke"))

    @stroke.setter
    def stroke(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5364bcdf07cbc36c6a1dc79d27e12a8e5faa28653e79186522936755f55cf9ed)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "stroke", value)

    @builtins.property
    @jsii.member(jsii_name="strokeSize")
    def stroke_size(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "strokeSize"))

    @stroke_size.setter
    def stroke_size(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__04d240e854c1d8bbf34d8f72896f0d7add0ddd083eba24bcb542224e3b3a4ec2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "strokeSize", value)

    @builtins.property
    @jsii.member(jsii_name="strokeSizeVar")
    def stroke_size_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "strokeSizeVar"))

    @stroke_size_var.setter
    def stroke_size_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e25f7a7a96408f7f581fc3054817f441e3d0e7b961f089ce9c26bc7e63cc6ec0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "strokeSizeVar", value)

    @builtins.property
    @jsii.member(jsii_name="strokeVar")
    def stroke_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "strokeVar"))

    @stroke_var.setter
    def stroke_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e40a42025a9135d7b835a205646c851ea3fd8844a96af5115043eb257b07fd30)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "strokeVar", value)

    @builtins.property
    @jsii.member(jsii_name="text")
    def text(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "text"))

    @text.setter
    def text(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d53c850bae75adb8d941a77148b2729443299f81ed8809ec3ac65d0c7fc8712e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "text", value)

    @builtins.property
    @jsii.member(jsii_name="textVar")
    def text_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "textVar"))

    @text_var.setter
    def text_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7a9952450fc1f48b1b71510e42cc69d8206a6b17ba0b40f0a7b54dd0c7dbc4e0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "textVar", value)

    @builtins.property
    @jsii.member(jsii_name="typeface")
    def typeface(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeface"))

    @typeface.setter
    def typeface(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__132b8b2bf997bcb3da7e1dabec44de478d25ff243e81d24ba251146ac52ed962)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeface", value)

    @builtins.property
    @jsii.member(jsii_name="typefaceVar")
    def typeface_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typefaceVar"))

    @typeface_var.setter
    def typeface_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2b1d9d41dc6482a7e53e12e489175f208a4f70c04bf0a0e5e8998e1ad6a600a3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typefaceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageTextImage]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageTextImage]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageTextImage]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a8e5ea2df26923af8d20e6bdf754691a0cb5d8b6d6cffaf3ae8773926f5f504)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageTextImageTransformation",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageTextImageTransformation:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageTextImageTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageTextImageTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageTextImageTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__610fa56e383441f33cfa59e9ac16db9d0d2c029ced0d4a228b209be3706b908e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageTextImageTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageTextImageTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageTextImageTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__228969ffbb8253dc6a481167e2088570f8dff1ed5d4d891d0f274351b6235841)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageUrlImage",
    jsii_struct_bases=[],
    name_mapping={
        "transformation": "transformation",
        "url": "url",
        "url_var": "urlVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageUrlImage:
    def __init__(
        self,
        *,
        transformation: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageUrlImageTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        url: typing.Optional[builtins.str] = None,
        url_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param transformation: transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        :param url: The URL of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url DataAkamaiImagingPolicyImage#url}
        :param url_var: The URL of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url_var DataAkamaiImagingPolicyImage#url_var}
        '''
        if isinstance(transformation, dict):
            transformation = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageUrlImageTransformation(**transformation)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7e48e234b9c3f4944a53820d92caf9eb060f1618d5a88ec7a1112f96ca86c017)
            check_type(argname="argument transformation", value=transformation, expected_type=type_hints["transformation"])
            check_type(argname="argument url", value=url, expected_type=type_hints["url"])
            check_type(argname="argument url_var", value=url_var, expected_type=type_hints["url_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if transformation is not None:
            self._values["transformation"] = transformation
        if url is not None:
            self._values["url"] = url
        if url_var is not None:
            self._values["url_var"] = url_var

    @builtins.property
    def transformation(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageUrlImageTransformation"]:
        '''transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        '''
        result = self._values.get("transformation")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageUrlImageTransformation"], result)

    @builtins.property
    def url(self) -> typing.Optional[builtins.str]:
        '''The URL of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url DataAkamaiImagingPolicyImage#url}
        '''
        result = self._values.get("url")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def url_var(self) -> typing.Optional[builtins.str]:
        '''The URL of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url_var DataAkamaiImagingPolicyImage#url_var}
        '''
        result = self._values.get("url_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageUrlImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageUrlImageList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageUrlImageList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f390a51674166272c1eb553d473ca39c7cacfcb4f1b2d7d9187695e9607d577)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageUrlImageOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a47a784bc6123af8bb97c69fd373521ec83520b4b13161dcf7233f28dbbbeef)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageUrlImageOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cb90913f40bb9a490b41e33e29614a16ecd07584e0a7c5dd770c3c1dad7a9343)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2bac0cbea7c69a8d42ddf1e85e717df7696a2e5a8e74e03e22cf99fa7f9fe3cf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8d856fc8ff6f8605ff8095f545142b7c04d05794750a5fe8ce782578b5840ddf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageUrlImage]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageUrlImage]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageUrlImage]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__38e9483bb0067d46dbdfc53f2e17d79db6e1280f1f5adc61387dad44206f9d1b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageUrlImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageUrlImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__577fa3a43cf67b4cb0292929ed44ecbe2d0ea4fc9c2d6cdc60f2e48a9d695147)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformation")
    def put_transformation(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageUrlImageTransformation()

        return typing.cast(None, jsii.invoke(self, "putTransformation", [value]))

    @jsii.member(jsii_name="resetTransformation")
    def reset_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformation", []))

    @jsii.member(jsii_name="resetUrl")
    def reset_url(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUrl", []))

    @jsii.member(jsii_name="resetUrlVar")
    def reset_url_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUrlVar", []))

    @builtins.property
    @jsii.member(jsii_name="transformation")
    def transformation(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageUrlImageTransformationOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageUrlImageTransformationOutputReference", jsii.get(self, "transformation"))

    @builtins.property
    @jsii.member(jsii_name="transformationInput")
    def transformation_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageUrlImageTransformation"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageUrlImageTransformation"], jsii.get(self, "transformationInput"))

    @builtins.property
    @jsii.member(jsii_name="urlInput")
    def url_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "urlInput"))

    @builtins.property
    @jsii.member(jsii_name="urlVarInput")
    def url_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "urlVarInput"))

    @builtins.property
    @jsii.member(jsii_name="url")
    def url(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "url"))

    @url.setter
    def url(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__02a1b45486d30c65a06c3c6036919125611fc1d822adfb537898eacba259874f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "url", value)

    @builtins.property
    @jsii.member(jsii_name="urlVar")
    def url_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "urlVar"))

    @url_var.setter
    def url_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__137ebc7c824c9564e190188f45314b300350e3e7a8f7510b03ff479918770737)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "urlVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageUrlImage]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageUrlImage]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageUrlImage]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa2635d501d67916b99e6f135cc3a28a8f6317b876351ace7a1ef6e332b1b91a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageUrlImageTransformation",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageUrlImageTransformation:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageUrlImageTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageUrlImageTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageUrlImageTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fed97e11ef527dfc766a45c6c78d43513856f94fc8154a44e2e6f4d6bb2a205f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageUrlImageTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageUrlImageTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageUrlImageTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4c11c3864031c970c7a7c1624164187206ca7470612a5f187ac0c2fe7fec9104)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__db124ffaa5febaba56a3520cbbd8a2f06e72346fdec3d69f83bedef326151d37)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0874f0fca4a1b9ad4a6e5698336fcf21fd968cccd51e0954ccf689d2644553d7)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0751e99df96cb122f51e1662388c35cc4c842bd9e9d75c044f7d35adc44daaed)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__596af7501bfb7ba8f700b98e0d167873e53c5e240f67463a663eab443cc5ad59)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8f43bf2629f73915ff7889e926dc03ab44ff21df973cef1469054678b9cdeec1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppend]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppend]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppend]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d0a2cc4bf88acc451084372aab9c07636f8bbccb30a80c33da31e9212f7b7e6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8b4fc57dd69b5bf51ba84cb36ba82ed87fb8a42795751754241096abfb70f6c1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(
        self,
        *,
        box_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageBoxImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
        circle_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageCircleImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
        text_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageTextImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
        url_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageUrlImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param box_image: box_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#box_image DataAkamaiImagingPolicyImage#box_image}
        :param circle_image: circle_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#circle_image DataAkamaiImagingPolicyImage#circle_image}
        :param text_image: text_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text_image DataAkamaiImagingPolicyImage#text_image}
        :param url_image: url_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url_image DataAkamaiImagingPolicyImage#url_image}
        '''
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImage(
            box_image=box_image,
            circle_image=circle_image,
            text_image=text_image,
            url_image=url_image,
        )

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityPriority")
    def reset_gravity_priority(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityPriority", []))

    @jsii.member(jsii_name="resetGravityPriorityVar")
    def reset_gravity_priority_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityPriorityVar", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPreserveMinorDimension")
    def reset_preserve_minor_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPreserveMinorDimension", []))

    @jsii.member(jsii_name="resetPreserveMinorDimensionVar")
    def reset_preserve_minor_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPreserveMinorDimensionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityInput")
    def gravity_priority_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityPriorityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityVarInput")
    def gravity_priority_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityPriorityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionInput")
    def preserve_minor_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "preserveMinorDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionVarInput")
    def preserve_minor_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "preserveMinorDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a95e19754dfdc103f133426ebe17b3eb29c099024af459e2292ad5b77ab69e05)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityPriority")
    def gravity_priority(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityPriority"))

    @gravity_priority.setter
    def gravity_priority(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2599993406c9e5aafba713dc72400e196b60759bbca30439d8693e436a9ff7a2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityPriority", value)

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityVar")
    def gravity_priority_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityPriorityVar"))

    @gravity_priority_var.setter
    def gravity_priority_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a6d6d5f8fd423882b576e228688bb61529b09a154b29cac45fdd5a28bbc546c0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityPriorityVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5772659fac2e15c850da269e5f93266092c0f616ec98f976054ea6061fac1be1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimension")
    def preserve_minor_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "preserveMinorDimension"))

    @preserve_minor_dimension.setter
    def preserve_minor_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2e2c8eb3599629cab888e941e3e9c39e3cb8ee17d9da35f0e50c0b593a37ccba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "preserveMinorDimension", value)

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionVar")
    def preserve_minor_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "preserveMinorDimensionVar"))

    @preserve_minor_dimension_var.setter
    def preserve_minor_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac49886390861d35c84837463210555443f3409babc79b5bf412bdc050cd8561)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "preserveMinorDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppend]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppend]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppend]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c576284713a570b7c69703e51ff163d2ed4d58f75951be612661c6b15ccef8ae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAspectCrop",
    jsii_struct_bases=[],
    name_mapping={
        "allow_expansion": "allowExpansion",
        "allow_expansion_var": "allowExpansionVar",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAspectCrop:
    def __init__(
        self,
        *,
        allow_expansion: typing.Optional[builtins.str] = None,
        allow_expansion_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_expansion: Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image. Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        :param allow_expansion_var: Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image. Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        :param height: The height term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The width term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        :param x_position: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__15258aba1345328c9cf99ab269309a4906d16ce9f4c36a7aa1ee1c125edf0d9b)
            check_type(argname="argument allow_expansion", value=allow_expansion, expected_type=type_hints["allow_expansion"])
            check_type(argname="argument allow_expansion_var", value=allow_expansion_var, expected_type=type_hints["allow_expansion_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if allow_expansion is not None:
            self._values["allow_expansion"] = allow_expansion
        if allow_expansion_var is not None:
            self._values["allow_expansion_var"] = allow_expansion_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def allow_expansion(self) -> typing.Optional[builtins.str]:
        '''Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image.

        Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        '''
        result = self._values.get("allow_expansion")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def allow_expansion_var(self) -> typing.Optional[builtins.str]:
        '''Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image.

        Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        '''
        result = self._values.get("allow_expansion_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAspectCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAspectCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAspectCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__926f630143ff5e875423521ec90c06e1098315c8b1eef8ed7f46632c6d62253a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAspectCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bf8b165d0c03f4577eceda4b4f63fadc22786a329a24354211af55c21e19d59f)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAspectCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__847560856a799cc7496e0373b6485d2f33d3963d1b2e069aec4ff9cf6129ea20)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b0068a5a6f659bbdbd43044eb9b058ec6d7ff72ab8095022131bf1e92b3039d0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2f5bd6b047855ea3e43c28641ef7e2488d08904ef7033ba94ca2e88f8e4463d0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAspectCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAspectCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAspectCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__513a4c4b0fbcb9ce7abd120cab608a86c81b7b8f26dbd391887d9202d2f4990d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAspectCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAspectCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d8bf2aad5cd7491635214781bc42c28d0006477e16e11627a8e1ea69527c4bec)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAllowExpansion")
    def reset_allow_expansion(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansion", []))

    @jsii.member(jsii_name="resetAllowExpansionVar")
    def reset_allow_expansion_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansionVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionInput")
    def allow_expansion_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVarInput")
    def allow_expansion_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansion")
    def allow_expansion(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansion"))

    @allow_expansion.setter
    def allow_expansion(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9b115fed1e7e38543c252d7264f009830c7af1a8029f44f5149e91a6c30d981f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansion", value)

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVar")
    def allow_expansion_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansionVar"))

    @allow_expansion_var.setter
    def allow_expansion_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c25331e1a44a71382947876c1a3f2eef58952ee8a50283f0e7032e4ed65c0de1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansionVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8645d1f8a8fb7c07bb7f6fb4a295a5f1c662911513b31b20a887f986c3585602)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d7a9e943a1770f0493754ce1915ddf025d03604ca3f1af0156bcba29cee1ff2e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__63fc064d97782889367294942bac6c6d7afa8cb977368c08867932f2e0c513e2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__baf32d4df16868a7fb5c1d42bf51b6bab975a6bece71994a1c0c1a9700dba084)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1eeffe202b03e1dc5d5b69443ac018eebf5ea16b3ee15d97b09909c4149d363f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__512ddb9f248c06efd268eafe534e5a3682fe7cd1a64ba4aa64ded527e2776981)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fffecc08f0c33cc8389046be110e86fe85264e7d00f6fe2d8f82eeb66235efec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c97f995c033efe1bb847fd69659c619fee3f872d3c524ec2e7308637480fae20)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAspectCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAspectCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAspectCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__03675cd212614de663f50185d67de8f7fc6ba48e8c3fd84d85f93a3947294b24)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitBackgroundColor",
    jsii_struct_bases=[],
    name_mapping={"color": "color", "color_var": "colorVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitBackgroundColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__486aae863acbba1cc3877ed00397363820a9afe02a3a4344d0b29568003f3aaa)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitBackgroundColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitBackgroundColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitBackgroundColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__94cc974d576f2b444d7fa45f0704af4e634ba238a95e67b6409c5e851fbaa12e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitBackgroundColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8b1fa57ddb385f2a0e5767ebb61512460c81e7c0e779c75b1af181a581d68608)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitBackgroundColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1208acc7c0863df92c191ec75130f02a4a297c6c2a37a10e33858aa6668557bd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d44ea81650bcf4154daca10d6fd8acbe5a02ba9c74c33634b0c42736e27eace7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cfde58fdbb8e382ca45e1f08c040e6c12ea36daab3309385ab05e1422250068e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitBackgroundColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitBackgroundColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b684314e990fc1ac77793a74e62a28f5a50660c8b760145a2b17cc46f03b573c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitBackgroundColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitBackgroundColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4b17eac164cf8bd0f224d6b7d9515ac1e3938061cbb0629ba3ef942e41bedf4e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__177afc7082ea5d12ddeb1bbeb7e2a02dc51ebe0f1274c1c75666688dca364270)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__87f1d43c9635b044ded0db18d88c451855ea9ca04e1ecb224dc81a11491012d2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitBackgroundColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitBackgroundColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitBackgroundColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__db0cd4987d2092a66415b4c7ac2926de2540a9f6fe1576e0aee4b4b0542ddfd6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitBlur",
    jsii_struct_bases=[],
    name_mapping={"sigma": "sigma", "sigma_var": "sigmaVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitBlur:
    def __init__(
        self,
        *,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param sigma: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__350555065edabd094fcc576cce0ec350726e6891ce93994ef98503fad757e063)
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitBlur(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitBlurList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitBlurList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__37d27c44ac181cf28a3a4a813c27725a52eb685916d0868a04bdbab18824b356)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitBlurOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__76c6011420d824fa1358905d5c393e86c8d0480fc680960ed9581a7e08ea22ff)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitBlurOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b7cd4747a239d28647bdb349d92fd8a23d31e108d0023f568d7be40a861a76c9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f5f68721ec40c21d2ee6feb978e7fbf0e274dd96f2e61087d960b7af6e29ec7a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__02e6decb210c27cb75fdd3bb0571073563675f86cdbe576be25c444bb22eea9f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitBlur]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitBlur]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__02b1c5a794fade1a40ab38611b9c5f0a18d511003602f61459a6741dbbbca58b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitBlurOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitBlurOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__abcf96ac168e0443a7ff648cde5e15e780da7ab9445c1aa507082156ee7962d4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__86b9ad2a5a4cdd7af36a277eadf60bb4ce9d7b2fda65c3d6cdd3f6621860533a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3b6cc918d1c217f0b85bdb1822a684267102e6c7d281755583d30b8b2580dacd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitBlur]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitBlur]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitBlur]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__482cb87b8195b60d660a6aa872b74472c7c27b8fc99805f93f72ceb6d758e797)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitChromaKey",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_feather": "hueFeather",
        "hue_feather_var": "hueFeatherVar",
        "hue_tolerance": "hueTolerance",
        "hue_tolerance_var": "hueToleranceVar",
        "hue_var": "hueVar",
        "lightness_feather": "lightnessFeather",
        "lightness_feather_var": "lightnessFeatherVar",
        "lightness_tolerance": "lightnessTolerance",
        "lightness_tolerance_var": "lightnessToleranceVar",
        "saturation_feather": "saturationFeather",
        "saturation_feather_var": "saturationFeatherVar",
        "saturation_tolerance": "saturationTolerance",
        "saturation_tolerance_var": "saturationToleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitChromaKey:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_feather: typing.Optional[builtins.str] = None,
        hue_feather_var: typing.Optional[builtins.str] = None,
        hue_tolerance: typing.Optional[builtins.str] = None,
        hue_tolerance_var: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness_feather: typing.Optional[builtins.str] = None,
        lightness_feather_var: typing.Optional[builtins.str] = None,
        lightness_tolerance: typing.Optional[builtins.str] = None,
        lightness_tolerance_var: typing.Optional[builtins.str] = None,
        saturation_feather: typing.Optional[builtins.str] = None,
        saturation_feather_var: typing.Optional[builtins.str] = None,
        saturation_tolerance: typing.Optional[builtins.str] = None,
        saturation_tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_feather: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        :param hue_feather_var: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        :param hue_tolerance: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        :param hue_tolerance_var: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        :param hue_var: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness_feather: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        :param lightness_feather_var: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        :param lightness_tolerance: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        :param lightness_tolerance_var: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        :param saturation_feather: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        :param saturation_feather_var: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        :param saturation_tolerance: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        :param saturation_tolerance_var: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d991f473f46347083ed8e70ca1b327cf7eca6f132bfe6657244b882a67f07d18)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_feather", value=hue_feather, expected_type=type_hints["hue_feather"])
            check_type(argname="argument hue_feather_var", value=hue_feather_var, expected_type=type_hints["hue_feather_var"])
            check_type(argname="argument hue_tolerance", value=hue_tolerance, expected_type=type_hints["hue_tolerance"])
            check_type(argname="argument hue_tolerance_var", value=hue_tolerance_var, expected_type=type_hints["hue_tolerance_var"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness_feather", value=lightness_feather, expected_type=type_hints["lightness_feather"])
            check_type(argname="argument lightness_feather_var", value=lightness_feather_var, expected_type=type_hints["lightness_feather_var"])
            check_type(argname="argument lightness_tolerance", value=lightness_tolerance, expected_type=type_hints["lightness_tolerance"])
            check_type(argname="argument lightness_tolerance_var", value=lightness_tolerance_var, expected_type=type_hints["lightness_tolerance_var"])
            check_type(argname="argument saturation_feather", value=saturation_feather, expected_type=type_hints["saturation_feather"])
            check_type(argname="argument saturation_feather_var", value=saturation_feather_var, expected_type=type_hints["saturation_feather_var"])
            check_type(argname="argument saturation_tolerance", value=saturation_tolerance, expected_type=type_hints["saturation_tolerance"])
            check_type(argname="argument saturation_tolerance_var", value=saturation_tolerance_var, expected_type=type_hints["saturation_tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_feather is not None:
            self._values["hue_feather"] = hue_feather
        if hue_feather_var is not None:
            self._values["hue_feather_var"] = hue_feather_var
        if hue_tolerance is not None:
            self._values["hue_tolerance"] = hue_tolerance
        if hue_tolerance_var is not None:
            self._values["hue_tolerance_var"] = hue_tolerance_var
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness_feather is not None:
            self._values["lightness_feather"] = lightness_feather
        if lightness_feather_var is not None:
            self._values["lightness_feather_var"] = lightness_feather_var
        if lightness_tolerance is not None:
            self._values["lightness_tolerance"] = lightness_tolerance
        if lightness_tolerance_var is not None:
            self._values["lightness_tolerance_var"] = lightness_tolerance_var
        if saturation_feather is not None:
            self._values["saturation_feather"] = saturation_feather
        if saturation_feather_var is not None:
            self._values["saturation_feather_var"] = saturation_feather_var
        if saturation_tolerance is not None:
            self._values["saturation_tolerance"] = saturation_tolerance
        if saturation_tolerance_var is not None:
            self._values["saturation_tolerance_var"] = saturation_tolerance_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        '''
        result = self._values.get("hue_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        '''
        result = self._values.get("hue_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        '''
        result = self._values.get("hue_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        '''
        result = self._values.get("hue_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        '''
        result = self._values.get("lightness_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        '''
        result = self._values.get("lightness_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        '''
        result = self._values.get("lightness_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        '''
        result = self._values.get("lightness_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        '''
        result = self._values.get("saturation_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        '''
        result = self._values.get("saturation_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        '''
        result = self._values.get("saturation_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        result = self._values.get("saturation_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitChromaKey(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitChromaKeyList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitChromaKeyList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__afb025d40d79d0cc4efc783aee0e7b6c042bd741e3deefddbcbee578be414f22)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitChromaKeyOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ade38d414fd9e32dd6a3661f62602a29d141a27f94ef69280144444998de239a)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitChromaKeyOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__defdf0491338863de55b15926461a0611543b46cc1e7c04594798bd48b59aeb5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d0a292115aab1571f728ef734eac6f4e45b4fdc4f953208fa9c7947c442466f6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e18c83c538f93dd7c42bf744ae57f6c76a4872aee82fc69c4649809748c35231)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitChromaKey]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitChromaKey]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c0cf83002f05c1169ad49c4811ff5fb2f6587137887e655500883dff2f357f5e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitChromaKeyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitChromaKeyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__14f2f361e3df0a288e58b04c359da9b89f4083fab8bb768a07987730a24de9a1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueFeather")
    def reset_hue_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeather", []))

    @jsii.member(jsii_name="resetHueFeatherVar")
    def reset_hue_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeatherVar", []))

    @jsii.member(jsii_name="resetHueTolerance")
    def reset_hue_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueTolerance", []))

    @jsii.member(jsii_name="resetHueToleranceVar")
    def reset_hue_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueToleranceVar", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightnessFeather")
    def reset_lightness_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeather", []))

    @jsii.member(jsii_name="resetLightnessFeatherVar")
    def reset_lightness_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeatherVar", []))

    @jsii.member(jsii_name="resetLightnessTolerance")
    def reset_lightness_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessTolerance", []))

    @jsii.member(jsii_name="resetLightnessToleranceVar")
    def reset_lightness_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessToleranceVar", []))

    @jsii.member(jsii_name="resetSaturationFeather")
    def reset_saturation_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeather", []))

    @jsii.member(jsii_name="resetSaturationFeatherVar")
    def reset_saturation_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeatherVar", []))

    @jsii.member(jsii_name="resetSaturationTolerance")
    def reset_saturation_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationTolerance", []))

    @jsii.member(jsii_name="resetSaturationToleranceVar")
    def reset_saturation_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherInput")
    def hue_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVarInput")
    def hue_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceInput")
    def hue_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVarInput")
    def hue_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherInput")
    def lightness_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVarInput")
    def lightness_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceInput")
    def lightness_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVarInput")
    def lightness_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherInput")
    def saturation_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVarInput")
    def saturation_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceInput")
    def saturation_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVarInput")
    def saturation_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a31b3e17b62d6176af3a228f154569eab6aab9d1932d027ddf29750f22e727f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeather")
    def hue_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeather"))

    @hue_feather.setter
    def hue_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a8585d67a31589141a44fbb22d25422c5f0fb47311dd69ab66d369aae20560ef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeather", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVar")
    def hue_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeatherVar"))

    @hue_feather_var.setter
    def hue_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f98ef4f63c9e1f01c1744167bb73f081983d0e961283f47d17c2ec2e328e08e4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueTolerance")
    def hue_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueTolerance"))

    @hue_tolerance.setter
    def hue_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__04748bdc3f7893eaa61ba3fd710b09b1d640a0b1b3348db8190b24c2576476f6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVar")
    def hue_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueToleranceVar"))

    @hue_tolerance_var.setter
    def hue_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e3563782bb2255011152d60896a4d9c76c4815a638ca60bbb916485004daa5d2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__16810f15669ff0f53018230f12c9daa03684d96723a00a4f21b67b1403fdb011)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeather")
    def lightness_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeather"))

    @lightness_feather.setter
    def lightness_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fe7387f0f4aad7d53ed644eabf37f5f23e9edd0070c34e77b5ce5782eff1e822)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeather", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVar")
    def lightness_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeatherVar"))

    @lightness_feather_var.setter
    def lightness_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a81d8eaf025d6720136b42694c39ca0c6d81c1caf80a520af7201e552e1f0691)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessTolerance")
    def lightness_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessTolerance"))

    @lightness_tolerance.setter
    def lightness_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__876f33e39037ec9628e69449158db5ba4b34ecec4e6bf6ca8501b1a9c34db9af)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVar")
    def lightness_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessToleranceVar"))

    @lightness_tolerance_var.setter
    def lightness_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__81a4bcb6dc4d6b98d325e8cde1703ca5fc905ca0ecad4bc7a954935117aa2036)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeather")
    def saturation_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeather"))

    @saturation_feather.setter
    def saturation_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fec13e7a27681abd8f7cac6c169f856e61fdcc1a46771d22ee48c390795c738c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeather", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVar")
    def saturation_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeatherVar"))

    @saturation_feather_var.setter
    def saturation_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__984ffe81a16bad0256759baab2cad8fbb63114cd9ae25903cc25cb9efca5ca97)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationTolerance")
    def saturation_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationTolerance"))

    @saturation_tolerance.setter
    def saturation_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5af2699808e31032dedf973d957dd214dc1ac3020de948398f4e7932f0f3da56)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVar")
    def saturation_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationToleranceVar"))

    @saturation_tolerance_var.setter
    def saturation_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d7a814a49e8923dda2db1cbfc900af5dafa11481013af0bbeb16f68554d43fa9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitChromaKey]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitChromaKey]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitChromaKey]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__601b38f75575f6dfac363168554fbab0574cb684473120be0f055c0901178039)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitComposite",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "placement": "placement",
        "placement_var": "placementVar",
        "scale": "scale",
        "scale_dimension": "scaleDimension",
        "scale_dimension_var": "scaleDimensionVar",
        "scale_var": "scaleVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitComposite:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        placement: typing.Optional[builtins.str] = None,
        placement_var: typing.Optional[builtins.str] = None,
        scale: typing.Optional[builtins.str] = None,
        scale_dimension: typing.Optional[builtins.str] = None,
        scale_dimension_var: typing.Optional[builtins.str] = None,
        scale_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param placement: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        :param placement_var: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        :param scale: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param scale_dimension: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        :param scale_dimension_var: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        :param scale_var: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        :param x_position: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c208c342733e5a289f886d8e9fad3e3e377b5390c69e92eb8525da33e2ebf8d6)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument placement", value=placement, expected_type=type_hints["placement"])
            check_type(argname="argument placement_var", value=placement_var, expected_type=type_hints["placement_var"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument scale_dimension", value=scale_dimension, expected_type=type_hints["scale_dimension"])
            check_type(argname="argument scale_dimension_var", value=scale_dimension_var, expected_type=type_hints["scale_dimension_var"])
            check_type(argname="argument scale_var", value=scale_var, expected_type=type_hints["scale_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if placement is not None:
            self._values["placement"] = placement
        if placement_var is not None:
            self._values["placement_var"] = placement_var
        if scale is not None:
            self._values["scale"] = scale
        if scale_dimension is not None:
            self._values["scale_dimension"] = scale_dimension
        if scale_dimension_var is not None:
            self._values["scale_dimension_var"] = scale_dimension_var
        if scale_var is not None:
            self._values["scale_var"] = scale_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        '''
        result = self._values.get("placement")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement_var(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        '''
        result = self._values.get("placement_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        '''
        result = self._values.get("scale_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        '''
        result = self._values.get("scale_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        '''
        result = self._values.get("scale_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitComposite(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImage",
    jsii_struct_bases=[],
    name_mapping={
        "box_image": "boxImage",
        "circle_image": "circleImage",
        "text_image": "textImage",
        "url_image": "urlImage",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImage:
    def __init__(
        self,
        *,
        box_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageBoxImage", typing.Dict[builtins.str, typing.Any]]]]] = None,
        circle_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageCircleImage", typing.Dict[builtins.str, typing.Any]]]]] = None,
        text_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageTextImage", typing.Dict[builtins.str, typing.Any]]]]] = None,
        url_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageUrlImage", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param box_image: box_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#box_image DataAkamaiImagingPolicyImage#box_image}
        :param circle_image: circle_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#circle_image DataAkamaiImagingPolicyImage#circle_image}
        :param text_image: text_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text_image DataAkamaiImagingPolicyImage#text_image}
        :param url_image: url_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url_image DataAkamaiImagingPolicyImage#url_image}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cae468f6855e0d9e115517644e856859b6408c05d84c77222c64c2109817f785)
            check_type(argname="argument box_image", value=box_image, expected_type=type_hints["box_image"])
            check_type(argname="argument circle_image", value=circle_image, expected_type=type_hints["circle_image"])
            check_type(argname="argument text_image", value=text_image, expected_type=type_hints["text_image"])
            check_type(argname="argument url_image", value=url_image, expected_type=type_hints["url_image"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if box_image is not None:
            self._values["box_image"] = box_image
        if circle_image is not None:
            self._values["circle_image"] = circle_image
        if text_image is not None:
            self._values["text_image"] = text_image
        if url_image is not None:
            self._values["url_image"] = url_image

    @builtins.property
    def box_image(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageBoxImage"]]]:
        '''box_image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#box_image DataAkamaiImagingPolicyImage#box_image}
        '''
        result = self._values.get("box_image")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageBoxImage"]]], result)

    @builtins.property
    def circle_image(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageCircleImage"]]]:
        '''circle_image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#circle_image DataAkamaiImagingPolicyImage#circle_image}
        '''
        result = self._values.get("circle_image")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageCircleImage"]]], result)

    @builtins.property
    def text_image(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageTextImage"]]]:
        '''text_image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text_image DataAkamaiImagingPolicyImage#text_image}
        '''
        result = self._values.get("text_image")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageTextImage"]]], result)

    @builtins.property
    def url_image(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageUrlImage"]]]:
        '''url_image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url_image DataAkamaiImagingPolicyImage#url_image}
        '''
        result = self._values.get("url_image")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageUrlImage"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageBoxImage",
    jsii_struct_bases=[],
    name_mapping={
        "color": "color",
        "color_var": "colorVar",
        "height": "height",
        "height_var": "heightVar",
        "transformation": "transformation",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageBoxImage:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        transformation: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageBoxImageTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The fill color of the box, not the edge of the box. The API supports hexadecimal representation and CSS hexadecimal color values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The fill color of the box, not the edge of the box. The API supports hexadecimal representation and CSS hexadecimal color values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        :param height: The height of the box in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height of the box in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param transformation: transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        :param width: The width of the box in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width of the box in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(transformation, dict):
            transformation = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageBoxImageTransformation(**transformation)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d5300404b256dfbba4c40e2ae1631b7acc14cb497951dcad90e6f06a9df810d)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument transformation", value=transformation, expected_type=type_hints["transformation"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if transformation is not None:
            self._values["transformation"] = transformation
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The fill color of the box, not the edge of the box.

        The API supports hexadecimal representation and CSS hexadecimal color values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The fill color of the box, not the edge of the box.

        The API supports hexadecimal representation and CSS hexadecimal color values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height of the box in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height of the box in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def transformation(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageBoxImageTransformation"]:
        '''transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        '''
        result = self._values.get("transformation")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageBoxImageTransformation"], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width of the box in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width of the box in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageBoxImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageBoxImageList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageBoxImageList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4fbd9be1e347b8d919f1ad89e8be0388c8005eb7f3f4074ad2d6faf0a0fa5ea0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageBoxImageOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0c6ff46c96ecb37d26f310434c445df696ff607d09244207101ee2d2384f493d)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageBoxImageOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6dee489306a666cd1f938120636f624b4eeeb6778e8425b557a29196562fe76c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f4c0536cdd337c35827b7e40fb24595b7c4b0a47a789000d0bc03f56349c8cab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ed53f67786c97330b6ad36cd5c5da927d400ee775266ee20a51c89b724c8234e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageBoxImage]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageBoxImage]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageBoxImage]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__99bc146c8fdb9cdc2c1f6f9ba84e4f92bef8c45ef2269cd39992dc301543432a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageBoxImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageBoxImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__91354b3a4c59ccf398ce8437692a0a98621c2e08fdefc296f572bd85ef7ebd88)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformation")
    def put_transformation(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageBoxImageTransformation()

        return typing.cast(None, jsii.invoke(self, "putTransformation", [value]))

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetTransformation")
    def reset_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformation", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="transformation")
    def transformation(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageBoxImageTransformationOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageBoxImageTransformationOutputReference", jsii.get(self, "transformation"))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="transformationInput")
    def transformation_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageBoxImageTransformation"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageBoxImageTransformation"], jsii.get(self, "transformationInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__edbe0d22ed27234dc56b2d8357d646bd09a280451f49975779bb99e6e4b611e9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a81306b385ecc2c4025925c8d239e50a918881f6e3c75bbb4826240fcf6134e1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fdaa20591fdd4bc0c645b84d98b4a439293d8dcfb73b0b2d6c498f315ad21e1e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3065f3824c3a4601fcb0a3cf521e8de8ca3faa22443e635c35032e23bd423afb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__edc0f34f7a075393e732618263a8af74a92f615905710a9c367b318bcf97df1e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__329caa263abffe9458f8145c8910864c4cc9a65c608f636212d9cee69eb30768)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageBoxImage]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageBoxImage]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageBoxImage]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__605253723e1552fee22d727d9c7332106fd7e85a835eb98e4c2eccda153f0115)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageBoxImageTransformation",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageBoxImageTransformation:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageBoxImageTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageBoxImageTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageBoxImageTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0a8d3ed6c17c7d31cfba7976ff085f746bcb6c20ce373ccfdd1fcfe6915c34f4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageBoxImageTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageBoxImageTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageBoxImageTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c5f02b733c696cb3167d7148268fb8d5f0e434a55cd4655cbf8ab709e7823e6f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageCircleImage",
    jsii_struct_bases=[],
    name_mapping={
        "color": "color",
        "color_var": "colorVar",
        "diameter": "diameter",
        "diameter_var": "diameterVar",
        "transformation": "transformation",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageCircleImage:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
        diameter: typing.Optional[builtins.str] = None,
        diameter_var: typing.Optional[builtins.str] = None,
        transformation: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageCircleImageTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The fill color of the circle. The API supports hexadecimal representation and CSS hexadecimal color values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The fill color of the circle. The API supports hexadecimal representation and CSS hexadecimal color values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        :param diameter: The diameter of the circle. The diameter will be the width and the height of the image in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#diameter DataAkamaiImagingPolicyImage#diameter}
        :param diameter_var: The diameter of the circle. The diameter will be the width and the height of the image in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#diameter_var DataAkamaiImagingPolicyImage#diameter_var}
        :param transformation: transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        :param width: The width of the box in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width of the box in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(transformation, dict):
            transformation = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageCircleImageTransformation(**transformation)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__139782fb9457dc6623ea442d23f8ceb90701804b944624e4491c705e891ac2ed)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
            check_type(argname="argument diameter", value=diameter, expected_type=type_hints["diameter"])
            check_type(argname="argument diameter_var", value=diameter_var, expected_type=type_hints["diameter_var"])
            check_type(argname="argument transformation", value=transformation, expected_type=type_hints["transformation"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var
        if diameter is not None:
            self._values["diameter"] = diameter
        if diameter_var is not None:
            self._values["diameter_var"] = diameter_var
        if transformation is not None:
            self._values["transformation"] = transformation
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The fill color of the circle. The API supports hexadecimal representation and CSS hexadecimal color values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The fill color of the circle. The API supports hexadecimal representation and CSS hexadecimal color values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def diameter(self) -> typing.Optional[builtins.str]:
        '''The diameter of the circle. The diameter will be the width and the height of the image in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#diameter DataAkamaiImagingPolicyImage#diameter}
        '''
        result = self._values.get("diameter")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def diameter_var(self) -> typing.Optional[builtins.str]:
        '''The diameter of the circle. The diameter will be the width and the height of the image in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#diameter_var DataAkamaiImagingPolicyImage#diameter_var}
        '''
        result = self._values.get("diameter_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def transformation(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageCircleImageTransformation"]:
        '''transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        '''
        result = self._values.get("transformation")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageCircleImageTransformation"], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width of the box in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width of the box in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageCircleImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageCircleImageList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageCircleImageList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e2ee3d03742d6e84f5648f2bd26e60fdff61c6c01c21b26f9719248717cd77df)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageCircleImageOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__64b03a2fdd020dab5c4b9dcd2e7716f6568b1dfefcd82536568fd5df245df11f)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageCircleImageOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3f67d030c2cae4af4bf20c277ddbaf336d2a6c99669825966ba2abd116246bd1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__afb0c3299280febcc84173e893c0a2d61df652a649f8505ca47d94f04b8b8755)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a24069aa82296946a4faed2d2af1cd01959a8b1f6296b7c4d550658a203f91d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageCircleImage]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageCircleImage]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageCircleImage]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__35fcd0f15b2cf96e7cc291dd5792dc1b7ad4022c9b0b0d0732780709151404fb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageCircleImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageCircleImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dae538aa41169b00828c92bafe2018b939f63ad4d21871fd4157461a5dcb0417)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformation")
    def put_transformation(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageCircleImageTransformation()

        return typing.cast(None, jsii.invoke(self, "putTransformation", [value]))

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @jsii.member(jsii_name="resetDiameter")
    def reset_diameter(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDiameter", []))

    @jsii.member(jsii_name="resetDiameterVar")
    def reset_diameter_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDiameterVar", []))

    @jsii.member(jsii_name="resetTransformation")
    def reset_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformation", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="transformation")
    def transformation(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageCircleImageTransformationOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageCircleImageTransformationOutputReference", jsii.get(self, "transformation"))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="diameterInput")
    def diameter_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "diameterInput"))

    @builtins.property
    @jsii.member(jsii_name="diameterVarInput")
    def diameter_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "diameterVarInput"))

    @builtins.property
    @jsii.member(jsii_name="transformationInput")
    def transformation_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageCircleImageTransformation"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageCircleImageTransformation"], jsii.get(self, "transformationInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a8f207df9a2434155f54bd9c30c0cb550852176184f1762abedfb9392479396a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__16f4130124748cf9c13dcebc3dfff893d0e787c5a41c142ac322801bb0ed2000)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="diameter")
    def diameter(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "diameter"))

    @diameter.setter
    def diameter(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e050d2fad0c41529b7dc767103e9ad271639c1002de77881ed350edc2d97662c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "diameter", value)

    @builtins.property
    @jsii.member(jsii_name="diameterVar")
    def diameter_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "diameterVar"))

    @diameter_var.setter
    def diameter_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cf86ccbc93dff1d65a4793a674147c4232e0b5295f2f1d4f3be3ae1ae6cc2081)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "diameterVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c2005699a0c0645813b0d78c32a164bafb1ba74431e2022cc188d49bf8a7ff71)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be4551f547991d7c2019c4539cdc520066bad1e5a15bc5333be881d3541f9c5d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageCircleImage]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageCircleImage]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageCircleImage]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dc1b3a260e35b5e2ededa15a8ccd988d70902d4c714199d4063842eda80760aa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageCircleImageTransformation",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageCircleImageTransformation:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageCircleImageTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageCircleImageTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageCircleImageTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__901ee316cf390bd0ee8695fcf79841e7e613635f6d992c0a68a4765a71588008)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageCircleImageTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageCircleImageTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageCircleImageTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__513522b4a16644a5370b80823f04bc8f1c2f0b2c7247b07c219e3088a0225aec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ed5262a484303b3178dcf1fffc48c843a7803461f5216ed6dbab524af749b576)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putBoxImage")
    def put_box_image(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageBoxImage, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6d45948da3cf5b11c1a324ca17b95f11d12032bb4bd8589d4557b0b8c497096f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBoxImage", [value]))

    @jsii.member(jsii_name="putCircleImage")
    def put_circle_image(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageCircleImage, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f29c141525389d2e1f5798cfaca4b76f3c9cbbc927d5e4344ac8cd402a93d5e6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCircleImage", [value]))

    @jsii.member(jsii_name="putTextImage")
    def put_text_image(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageTextImage", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__77ce746cb0f84e3b92ccc22e7ccbb9b339c7802ee2d4ffa334f9f49aeb091e9b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTextImage", [value]))

    @jsii.member(jsii_name="putUrlImage")
    def put_url_image(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageUrlImage", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__34cacba3756354450c41a158ddaeb1ebdb7cb4c8734864e13de19ae2eecac230)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putUrlImage", [value]))

    @jsii.member(jsii_name="resetBoxImage")
    def reset_box_image(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBoxImage", []))

    @jsii.member(jsii_name="resetCircleImage")
    def reset_circle_image(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCircleImage", []))

    @jsii.member(jsii_name="resetTextImage")
    def reset_text_image(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTextImage", []))

    @jsii.member(jsii_name="resetUrlImage")
    def reset_url_image(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUrlImage", []))

    @builtins.property
    @jsii.member(jsii_name="boxImage")
    def box_image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageBoxImageList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageBoxImageList, jsii.get(self, "boxImage"))

    @builtins.property
    @jsii.member(jsii_name="circleImage")
    def circle_image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageCircleImageList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageCircleImageList, jsii.get(self, "circleImage"))

    @builtins.property
    @jsii.member(jsii_name="textImage")
    def text_image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageTextImageList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageTextImageList", jsii.get(self, "textImage"))

    @builtins.property
    @jsii.member(jsii_name="urlImage")
    def url_image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageUrlImageList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageUrlImageList", jsii.get(self, "urlImage"))

    @builtins.property
    @jsii.member(jsii_name="boxImageInput")
    def box_image_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageBoxImage]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageBoxImage]]], jsii.get(self, "boxImageInput"))

    @builtins.property
    @jsii.member(jsii_name="circleImageInput")
    def circle_image_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageCircleImage]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageCircleImage]]], jsii.get(self, "circleImageInput"))

    @builtins.property
    @jsii.member(jsii_name="textImageInput")
    def text_image_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageTextImage"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageTextImage"]]], jsii.get(self, "textImageInput"))

    @builtins.property
    @jsii.member(jsii_name="urlImageInput")
    def url_image_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageUrlImage"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageUrlImage"]]], jsii.get(self, "urlImageInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa928fbe6cbbd963f27b33a49e977badb8131fff3d0a31b1e56fef29f98bec38)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageTextImage",
    jsii_struct_bases=[],
    name_mapping={
        "fill": "fill",
        "fill_var": "fillVar",
        "size": "size",
        "size_var": "sizeVar",
        "stroke": "stroke",
        "stroke_size": "strokeSize",
        "stroke_size_var": "strokeSizeVar",
        "stroke_var": "strokeVar",
        "text": "text",
        "text_var": "textVar",
        "transformation": "transformation",
        "typeface": "typeface",
        "typeface_var": "typefaceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageTextImage:
    def __init__(
        self,
        *,
        fill: typing.Optional[builtins.str] = None,
        fill_var: typing.Optional[builtins.str] = None,
        size: typing.Optional[builtins.str] = None,
        size_var: typing.Optional[builtins.str] = None,
        stroke: typing.Optional[builtins.str] = None,
        stroke_size: typing.Optional[builtins.str] = None,
        stroke_size_var: typing.Optional[builtins.str] = None,
        stroke_var: typing.Optional[builtins.str] = None,
        text: typing.Optional[builtins.str] = None,
        text_var: typing.Optional[builtins.str] = None,
        transformation: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageTextImageTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        typeface: typing.Optional[builtins.str] = None,
        typeface_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fill: The main fill color of the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill DataAkamaiImagingPolicyImage#fill}
        :param fill_var: The main fill color of the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_var DataAkamaiImagingPolicyImage#fill_var}
        :param size: The size in pixels to render the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#size DataAkamaiImagingPolicyImage#size}
        :param size_var: The size in pixels to render the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#size_var DataAkamaiImagingPolicyImage#size_var}
        :param stroke: The color for the outline of the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke DataAkamaiImagingPolicyImage#stroke}
        :param stroke_size: The thickness in points for the outline of the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_size DataAkamaiImagingPolicyImage#stroke_size}
        :param stroke_size_var: The thickness in points for the outline of the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_size_var DataAkamaiImagingPolicyImage#stroke_size_var}
        :param stroke_var: The color for the outline of the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_var DataAkamaiImagingPolicyImage#stroke_var}
        :param text: The line of text to render. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text DataAkamaiImagingPolicyImage#text}
        :param text_var: The line of text to render. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text_var DataAkamaiImagingPolicyImage#text_var}
        :param transformation: transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        :param typeface: The font family to apply to the text image. This may be a URL to a TrueType or WOFF (v1) typeface, or a string that refers to one of the standard built-in browser fonts. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#typeface DataAkamaiImagingPolicyImage#typeface}
        :param typeface_var: The font family to apply to the text image. This may be a URL to a TrueType or WOFF (v1) typeface, or a string that refers to one of the standard built-in browser fonts. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#typeface_var DataAkamaiImagingPolicyImage#typeface_var}
        '''
        if isinstance(transformation, dict):
            transformation = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageTextImageTransformation(**transformation)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c93963496418b3a6ba7cf1c10a7882d133c7349dee867d0248eded527693397e)
            check_type(argname="argument fill", value=fill, expected_type=type_hints["fill"])
            check_type(argname="argument fill_var", value=fill_var, expected_type=type_hints["fill_var"])
            check_type(argname="argument size", value=size, expected_type=type_hints["size"])
            check_type(argname="argument size_var", value=size_var, expected_type=type_hints["size_var"])
            check_type(argname="argument stroke", value=stroke, expected_type=type_hints["stroke"])
            check_type(argname="argument stroke_size", value=stroke_size, expected_type=type_hints["stroke_size"])
            check_type(argname="argument stroke_size_var", value=stroke_size_var, expected_type=type_hints["stroke_size_var"])
            check_type(argname="argument stroke_var", value=stroke_var, expected_type=type_hints["stroke_var"])
            check_type(argname="argument text", value=text, expected_type=type_hints["text"])
            check_type(argname="argument text_var", value=text_var, expected_type=type_hints["text_var"])
            check_type(argname="argument transformation", value=transformation, expected_type=type_hints["transformation"])
            check_type(argname="argument typeface", value=typeface, expected_type=type_hints["typeface"])
            check_type(argname="argument typeface_var", value=typeface_var, expected_type=type_hints["typeface_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fill is not None:
            self._values["fill"] = fill
        if fill_var is not None:
            self._values["fill_var"] = fill_var
        if size is not None:
            self._values["size"] = size
        if size_var is not None:
            self._values["size_var"] = size_var
        if stroke is not None:
            self._values["stroke"] = stroke
        if stroke_size is not None:
            self._values["stroke_size"] = stroke_size
        if stroke_size_var is not None:
            self._values["stroke_size_var"] = stroke_size_var
        if stroke_var is not None:
            self._values["stroke_var"] = stroke_var
        if text is not None:
            self._values["text"] = text
        if text_var is not None:
            self._values["text_var"] = text_var
        if transformation is not None:
            self._values["transformation"] = transformation
        if typeface is not None:
            self._values["typeface"] = typeface
        if typeface_var is not None:
            self._values["typeface_var"] = typeface_var

    @builtins.property
    def fill(self) -> typing.Optional[builtins.str]:
        '''The main fill color of the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill DataAkamaiImagingPolicyImage#fill}
        '''
        result = self._values.get("fill")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fill_var(self) -> typing.Optional[builtins.str]:
        '''The main fill color of the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_var DataAkamaiImagingPolicyImage#fill_var}
        '''
        result = self._values.get("fill_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def size(self) -> typing.Optional[builtins.str]:
        '''The size in pixels to render the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#size DataAkamaiImagingPolicyImage#size}
        '''
        result = self._values.get("size")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def size_var(self) -> typing.Optional[builtins.str]:
        '''The size in pixels to render the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#size_var DataAkamaiImagingPolicyImage#size_var}
        '''
        result = self._values.get("size_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def stroke(self) -> typing.Optional[builtins.str]:
        '''The color for the outline of the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke DataAkamaiImagingPolicyImage#stroke}
        '''
        result = self._values.get("stroke")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def stroke_size(self) -> typing.Optional[builtins.str]:
        '''The thickness in points for the outline of the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_size DataAkamaiImagingPolicyImage#stroke_size}
        '''
        result = self._values.get("stroke_size")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def stroke_size_var(self) -> typing.Optional[builtins.str]:
        '''The thickness in points for the outline of the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_size_var DataAkamaiImagingPolicyImage#stroke_size_var}
        '''
        result = self._values.get("stroke_size_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def stroke_var(self) -> typing.Optional[builtins.str]:
        '''The color for the outline of the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_var DataAkamaiImagingPolicyImage#stroke_var}
        '''
        result = self._values.get("stroke_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def text(self) -> typing.Optional[builtins.str]:
        '''The line of text to render.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text DataAkamaiImagingPolicyImage#text}
        '''
        result = self._values.get("text")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def text_var(self) -> typing.Optional[builtins.str]:
        '''The line of text to render.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text_var DataAkamaiImagingPolicyImage#text_var}
        '''
        result = self._values.get("text_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def transformation(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageTextImageTransformation"]:
        '''transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        '''
        result = self._values.get("transformation")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageTextImageTransformation"], result)

    @builtins.property
    def typeface(self) -> typing.Optional[builtins.str]:
        '''The font family to apply to the text image.

        This may be a URL to a TrueType or WOFF (v1) typeface, or a string that refers to one of the standard built-in browser fonts.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#typeface DataAkamaiImagingPolicyImage#typeface}
        '''
        result = self._values.get("typeface")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def typeface_var(self) -> typing.Optional[builtins.str]:
        '''The font family to apply to the text image.

        This may be a URL to a TrueType or WOFF (v1) typeface, or a string that refers to one of the standard built-in browser fonts.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#typeface_var DataAkamaiImagingPolicyImage#typeface_var}
        '''
        result = self._values.get("typeface_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageTextImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageTextImageList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageTextImageList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4b5efd9b9cb0af9da2287f0409036d22c9047e75a083013edeb64488225e1e2c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageTextImageOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__037b8cfc1eae87a9ffc974b005e9ac82d1a0d63b0bdadf144d4b79c753d00d9e)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageTextImageOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__769b207ae6ddd459d58152167fcf408d17c54ffa1298eb332943387f2e0761a7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5165085460e583ea2ce958dd9edd839431d3b1057235d82138c7c6776e751c21)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c4d98ab163bd233a13966f57143e2827f274abffe251b7eb850dd74ace097a20)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageTextImage]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageTextImage]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageTextImage]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__520159d02de6cf738469672ebe9b066900a00d78fb83e911fffd9191465bee89)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageTextImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageTextImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b2a5b5231211911d5182ea61745cb09656207c196f3b687cd24e5560e8c14d3e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformation")
    def put_transformation(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageTextImageTransformation()

        return typing.cast(None, jsii.invoke(self, "putTransformation", [value]))

    @jsii.member(jsii_name="resetFill")
    def reset_fill(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFill", []))

    @jsii.member(jsii_name="resetFillVar")
    def reset_fill_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFillVar", []))

    @jsii.member(jsii_name="resetSize")
    def reset_size(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSize", []))

    @jsii.member(jsii_name="resetSizeVar")
    def reset_size_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSizeVar", []))

    @jsii.member(jsii_name="resetStroke")
    def reset_stroke(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStroke", []))

    @jsii.member(jsii_name="resetStrokeSize")
    def reset_stroke_size(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStrokeSize", []))

    @jsii.member(jsii_name="resetStrokeSizeVar")
    def reset_stroke_size_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStrokeSizeVar", []))

    @jsii.member(jsii_name="resetStrokeVar")
    def reset_stroke_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStrokeVar", []))

    @jsii.member(jsii_name="resetText")
    def reset_text(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetText", []))

    @jsii.member(jsii_name="resetTextVar")
    def reset_text_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTextVar", []))

    @jsii.member(jsii_name="resetTransformation")
    def reset_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformation", []))

    @jsii.member(jsii_name="resetTypeface")
    def reset_typeface(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeface", []))

    @jsii.member(jsii_name="resetTypefaceVar")
    def reset_typeface_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypefaceVar", []))

    @builtins.property
    @jsii.member(jsii_name="transformation")
    def transformation(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageTextImageTransformationOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageTextImageTransformationOutputReference", jsii.get(self, "transformation"))

    @builtins.property
    @jsii.member(jsii_name="fillInput")
    def fill_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fillInput"))

    @builtins.property
    @jsii.member(jsii_name="fillVarInput")
    def fill_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fillVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sizeInput")
    def size_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sizeInput"))

    @builtins.property
    @jsii.member(jsii_name="sizeVarInput")
    def size_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sizeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="strokeInput")
    def stroke_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "strokeInput"))

    @builtins.property
    @jsii.member(jsii_name="strokeSizeInput")
    def stroke_size_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "strokeSizeInput"))

    @builtins.property
    @jsii.member(jsii_name="strokeSizeVarInput")
    def stroke_size_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "strokeSizeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="strokeVarInput")
    def stroke_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "strokeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="textInput")
    def text_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "textInput"))

    @builtins.property
    @jsii.member(jsii_name="textVarInput")
    def text_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "textVarInput"))

    @builtins.property
    @jsii.member(jsii_name="transformationInput")
    def transformation_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageTextImageTransformation"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageTextImageTransformation"], jsii.get(self, "transformationInput"))

    @builtins.property
    @jsii.member(jsii_name="typefaceInput")
    def typeface_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typefaceInput"))

    @builtins.property
    @jsii.member(jsii_name="typefaceVarInput")
    def typeface_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typefaceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="fill")
    def fill(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fill"))

    @fill.setter
    def fill(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__09185d4dff0170a07865daea5ce2ba6999c9716eae242afbf27c176a73afb2d2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fill", value)

    @builtins.property
    @jsii.member(jsii_name="fillVar")
    def fill_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fillVar"))

    @fill_var.setter
    def fill_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__34e4318be6103943ab7a535a35199fa9dc9719444c795b440e4c21df5465ddab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fillVar", value)

    @builtins.property
    @jsii.member(jsii_name="size")
    def size(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "size"))

    @size.setter
    def size(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d61819320ad9d363fdee8ec2f06af49f8e77f42a3337afbfacfdca486e6fbdec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "size", value)

    @builtins.property
    @jsii.member(jsii_name="sizeVar")
    def size_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sizeVar"))

    @size_var.setter
    def size_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__168ef68498f39f0c573e5ae3550ada8876389e2bb9fb2e50b647d98711d39da6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sizeVar", value)

    @builtins.property
    @jsii.member(jsii_name="stroke")
    def stroke(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "stroke"))

    @stroke.setter
    def stroke(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3dfccfae626fc6033c878f9542358ff8932b48558ae02487c1cf6541bb5820b2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "stroke", value)

    @builtins.property
    @jsii.member(jsii_name="strokeSize")
    def stroke_size(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "strokeSize"))

    @stroke_size.setter
    def stroke_size(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__57acaa0ebbede33f19090274ad73f039d3ef26ba4b3af43db5e5ba00bb156133)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "strokeSize", value)

    @builtins.property
    @jsii.member(jsii_name="strokeSizeVar")
    def stroke_size_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "strokeSizeVar"))

    @stroke_size_var.setter
    def stroke_size_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__19312cc5d419b871649dc7303b3f9a761ec526383c65b7f60de977230dd2e407)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "strokeSizeVar", value)

    @builtins.property
    @jsii.member(jsii_name="strokeVar")
    def stroke_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "strokeVar"))

    @stroke_var.setter
    def stroke_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a689b76eeb30b0dc637aa0f451e113b90e071168b4ef60875db6f973b92fc06)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "strokeVar", value)

    @builtins.property
    @jsii.member(jsii_name="text")
    def text(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "text"))

    @text.setter
    def text(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__45f0ba08da3b14245966783a041b301bb5cac0c79b8d2c4d6e6d82bfdcf06344)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "text", value)

    @builtins.property
    @jsii.member(jsii_name="textVar")
    def text_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "textVar"))

    @text_var.setter
    def text_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__770de44850441ea0a124629ea2a18fe2b1a873bdd6b30dec1d3acef89e09e43c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "textVar", value)

    @builtins.property
    @jsii.member(jsii_name="typeface")
    def typeface(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeface"))

    @typeface.setter
    def typeface(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fd793c8ac6758b484ffb43f9995767c7028cb7710ea9b02640b199c15770391a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeface", value)

    @builtins.property
    @jsii.member(jsii_name="typefaceVar")
    def typeface_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typefaceVar"))

    @typeface_var.setter
    def typeface_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6d016c65fd0975f442471fdc37bae4e7c39f6e42ab3d8995eb81ec686d13f1f2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typefaceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageTextImage]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageTextImage]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageTextImage]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a6ddae606cd5a709e9c6a487e577c0efceb10429cbb473754e49bce4bf1b2b0b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageTextImageTransformation",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageTextImageTransformation:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageTextImageTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageTextImageTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageTextImageTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__72188821b1cb38edb47c900c0095d24d1b8159c271d6b931b3afbd44e9d44acf)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageTextImageTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageTextImageTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageTextImageTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b4b13e07a7bbbce90157c7bc808288b4e2b1f37f70f7974c183c7d618e9c2483)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageUrlImage",
    jsii_struct_bases=[],
    name_mapping={
        "transformation": "transformation",
        "url": "url",
        "url_var": "urlVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageUrlImage:
    def __init__(
        self,
        *,
        transformation: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageUrlImageTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        url: typing.Optional[builtins.str] = None,
        url_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param transformation: transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        :param url: The URL of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url DataAkamaiImagingPolicyImage#url}
        :param url_var: The URL of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url_var DataAkamaiImagingPolicyImage#url_var}
        '''
        if isinstance(transformation, dict):
            transformation = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageUrlImageTransformation(**transformation)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2310ea5a0c60990e410a290eaffe3f964aa4658bf1871e1a57e17bacf234e5aa)
            check_type(argname="argument transformation", value=transformation, expected_type=type_hints["transformation"])
            check_type(argname="argument url", value=url, expected_type=type_hints["url"])
            check_type(argname="argument url_var", value=url_var, expected_type=type_hints["url_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if transformation is not None:
            self._values["transformation"] = transformation
        if url is not None:
            self._values["url"] = url
        if url_var is not None:
            self._values["url_var"] = url_var

    @builtins.property
    def transformation(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageUrlImageTransformation"]:
        '''transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        '''
        result = self._values.get("transformation")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageUrlImageTransformation"], result)

    @builtins.property
    def url(self) -> typing.Optional[builtins.str]:
        '''The URL of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url DataAkamaiImagingPolicyImage#url}
        '''
        result = self._values.get("url")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def url_var(self) -> typing.Optional[builtins.str]:
        '''The URL of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url_var DataAkamaiImagingPolicyImage#url_var}
        '''
        result = self._values.get("url_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageUrlImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageUrlImageList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageUrlImageList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3d469ee4db88c6480fe20ee43909f7cfcb7398f901f217a8cd1f91a4a39721d9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageUrlImageOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8e6406df4e41217dc59ca440ccae1fdeb433f9554958a5bbb4bd61993ec31067)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageUrlImageOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c7dbad0b338499608faca3f8290a7536b84bb6ff418c6349ed73f13e0cecef86)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3cb9f6f57a399bdd3dbdc3a6bb79fdf904288e7126fa6af1357d03c125315c2b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dafb50ebcb6a962ad743c3b4992998d92fb33420b40631da6beeef6af097f35d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageUrlImage]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageUrlImage]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageUrlImage]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a8334ede5cb701b9b9f237d82315964d9bad995f12945e427fcf7f4c94c82bdd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageUrlImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageUrlImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e6385512a843a185d1732ce923802f6a36eed84f2149c33020f07aa0f762d764)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformation")
    def put_transformation(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageUrlImageTransformation()

        return typing.cast(None, jsii.invoke(self, "putTransformation", [value]))

    @jsii.member(jsii_name="resetTransformation")
    def reset_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformation", []))

    @jsii.member(jsii_name="resetUrl")
    def reset_url(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUrl", []))

    @jsii.member(jsii_name="resetUrlVar")
    def reset_url_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUrlVar", []))

    @builtins.property
    @jsii.member(jsii_name="transformation")
    def transformation(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageUrlImageTransformationOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageUrlImageTransformationOutputReference", jsii.get(self, "transformation"))

    @builtins.property
    @jsii.member(jsii_name="transformationInput")
    def transformation_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageUrlImageTransformation"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageUrlImageTransformation"], jsii.get(self, "transformationInput"))

    @builtins.property
    @jsii.member(jsii_name="urlInput")
    def url_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "urlInput"))

    @builtins.property
    @jsii.member(jsii_name="urlVarInput")
    def url_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "urlVarInput"))

    @builtins.property
    @jsii.member(jsii_name="url")
    def url(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "url"))

    @url.setter
    def url(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d5916c4ec1f36435f4830b0542cf8f212ea5c246be8ea12ea174d05000a7ea6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "url", value)

    @builtins.property
    @jsii.member(jsii_name="urlVar")
    def url_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "urlVar"))

    @url_var.setter
    def url_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e702782c09116b4472d8bc4019b541512b7a0bd9a297516892afdb5589c727be)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "urlVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageUrlImage]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageUrlImage]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageUrlImage]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__532da7cc039853ecf27e4b2d0e45982525f104dc2c79f96ea442269f3ef6b7bd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageUrlImageTransformation",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageUrlImageTransformation:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageUrlImageTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageUrlImageTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageUrlImageTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b4af43b9d04899ad45cb770600b7931e4d6608782c584fed893dd4b838d975f8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageUrlImageTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageUrlImageTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageUrlImageTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__02c7911359860cc07ebf6d67009d1c9cb06d09aa1917383ce8d41702bf07adbf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__325f55de4bb88fb9382efc6797aaa6838d4981ff64143d0ad49b85da1f3d4f89)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0e2ee83785787c9d1ea702aed95a4124120f327f53c1f7d5e715253375250712)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5aa2713a831e40d31cb26813adc878f147b33384d657ea428f1ece3e995d74e0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3beb5428bef954fe65dd1466bdb4092f0c1dfb1068f22fd26d0cfe203623c677)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac01aba7083e26ce13d7d14fe800aaede740881ff18754dd1c93f886dd69a7da)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitComposite]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitComposite]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6a23ca5d0559e4eafd7a88691657e29c5663220e5734e76ee06cd4e66da7cf77)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d78a5c8e3358d0788ae76d001fc6d5deb72ba2c798a895bae7dac7796ba712c0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(
        self,
        *,
        box_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageBoxImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
        circle_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageCircleImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
        text_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageTextImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
        url_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageUrlImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param box_image: box_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#box_image DataAkamaiImagingPolicyImage#box_image}
        :param circle_image: circle_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#circle_image DataAkamaiImagingPolicyImage#circle_image}
        :param text_image: text_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text_image DataAkamaiImagingPolicyImage#text_image}
        :param url_image: url_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url_image DataAkamaiImagingPolicyImage#url_image}
        '''
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImage(
            box_image=box_image,
            circle_image=circle_image,
            text_image=text_image,
            url_image=url_image,
        )

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPlacement")
    def reset_placement(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacement", []))

    @jsii.member(jsii_name="resetPlacementVar")
    def reset_placement_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacementVar", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetScaleDimension")
    def reset_scale_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimension", []))

    @jsii.member(jsii_name="resetScaleDimensionVar")
    def reset_scale_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimensionVar", []))

    @jsii.member(jsii_name="resetScaleVar")
    def reset_scale_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="placementInput")
    def placement_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementInput"))

    @builtins.property
    @jsii.member(jsii_name="placementVarInput")
    def placement_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionInput")
    def scale_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVarInput")
    def scale_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleVarInput")
    def scale_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ec96a4e106d2820af128adceef91302ea423fc0d2bf2345d6ec1b1ac730789fc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__81a98a2f2bb12073a0bc9ec8abc004a8b75edf41df99c155ff9bededfe52c6c7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="placement")
    def placement(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placement"))

    @placement.setter
    def placement(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dba5de4bbedf2f31a1914a5d1e547dc0d7a379d72a63e1824b9b70a020f59950)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placement", value)

    @builtins.property
    @jsii.member(jsii_name="placementVar")
    def placement_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placementVar"))

    @placement_var.setter
    def placement_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__021e161b0bdc0fa61d4b990c69acd8a248e7dd5f2d84de440128f7145c821838)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placementVar", value)

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scale"))

    @scale.setter
    def scale(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e366ae794a01f8173c66c85e4ca07b7428c696f109c9841964987cafa03d0f75)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scale", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimension")
    def scale_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimension"))

    @scale_dimension.setter
    def scale_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c05ff5f0c9b6f49484aaed4c5ee384e47a9327a9b52313d896d071743f9776ce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimension", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVar")
    def scale_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimensionVar"))

    @scale_dimension_var.setter
    def scale_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__73fff74ff94965a8a18bdb61c0a5f28471254bb423a1dea6c5d1ad4ba24209b3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="scaleVar")
    def scale_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleVar"))

    @scale_var.setter
    def scale_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8ec1894df694bd3bf9c565d053a7aa728bf072abd860b04e13a92a93986dd3c1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9bcd63fb5e1c62afa2cf0e886aa99ad9f3b8176cbdf2d56725b97760172f1a4a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8ebf8168c64ef39336f1781881f13da7c22bf60f741c85095c5e36fda940d044)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__106161ca987eb6eb462d2c0b1926e2d3cf7dd9da6285326afa7afbd96945d2dc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1ddff2ebb3c03f48d727d022271de6a14564710ee2f91fc0f6ef254072c181eb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitComposite]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitComposite]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitComposite]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__69b5cf609e4340c34ea7b6be26ef27fddb27c1992546db4a7b133dd2e2b47338)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompound",
    jsii_struct_bases=[],
    name_mapping={"transformations": "transformations"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompound:
    def __init__(
        self,
        *,
        transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformations, typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param transformations: transformations block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__43a53988cf59d191b534d0d1e6b8bde5258eccb46c71fa6c3e705535a50efa3c)
            check_type(argname="argument transformations", value=transformations, expected_type=type_hints["transformations"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if transformations is not None:
            self._values["transformations"] = transformations

    @builtins.property
    def transformations(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformations]]]:
        '''transformations block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        result = self._values.get("transformations")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformations]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompound(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompoundList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompoundList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__83e2af028e39a1895df148219d7ee516179576ed2d5d7f0171ae36807256c1e0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompoundOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8bd0c9b3e733d31b696e2f14ec05d4e2f26045edb986a41c234f369b82e319aa)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompoundOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2c6c04b2e7f17a30a25baf452c38535514ada612b416b6f48a634f38aaefba80)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e2ce6d90674c886d4c8c50550ec41c2c247926af0634aecabe67d539e425c529)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__27a8f23d781158eb2e4fb901826d36d4460dfdb9e43a2c7122f24751c7b4ef7b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompound]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompound]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__60e92f2de9419d9871780e599ce8b246b7a8cd588c5072dd6f7ca759988b94b8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompoundOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompoundOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3324d615ab5ad4523f63dbbb8f3c835d8306c476f946dafd8664ecb6aedc55d1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformations")
    def put_transformations(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformations, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__60ebfdcc1a269153da736bdcf6f5d50a277d60aa542b22f0681f7bd8c7ae6fe6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTransformations", [value]))

    @jsii.member(jsii_name="resetTransformations")
    def reset_transformations(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformations", []))

    @builtins.property
    @jsii.member(jsii_name="transformations")
    def transformations(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsList", jsii.get(self, "transformations"))

    @builtins.property
    @jsii.member(jsii_name="transformationsInput")
    def transformations_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformations]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformations]]], jsii.get(self, "transformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompound]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompound]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompound]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ed2c09c66db68092b39049c29cc1d55b072fcf6bcc802f40e6a3a62daac2af7c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitContrast",
    jsii_struct_bases=[],
    name_mapping={
        "brightness": "brightness",
        "brightness_var": "brightnessVar",
        "contrast": "contrast",
        "contrast_var": "contrastVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitContrast:
    def __init__(
        self,
        *,
        brightness: typing.Optional[builtins.str] = None,
        brightness_var: typing.Optional[builtins.str] = None,
        contrast: typing.Optional[builtins.str] = None,
        contrast_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param brightness: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        :param brightness_var: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        :param contrast: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param contrast_var: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c476811cfb9cc4c110afa83ba8635a37df12f6011e83d0c3f83e15b07572f97d)
            check_type(argname="argument brightness", value=brightness, expected_type=type_hints["brightness"])
            check_type(argname="argument brightness_var", value=brightness_var, expected_type=type_hints["brightness_var"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument contrast_var", value=contrast_var, expected_type=type_hints["contrast_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if brightness is not None:
            self._values["brightness"] = brightness
        if brightness_var is not None:
            self._values["brightness_var"] = brightness_var
        if contrast is not None:
            self._values["contrast"] = contrast
        if contrast_var is not None:
            self._values["contrast_var"] = contrast_var

    @builtins.property
    def brightness(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        '''
        result = self._values.get("brightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def brightness_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        '''
        result = self._values.get("brightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        result = self._values.get("contrast_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitContrast(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitContrastList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitContrastList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__11354ee48104b97be8257274d34723bec422063b8dc831a560b76b98af2f9690)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitContrastOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__69d9f703ded65ef2dc41a9489c88621d017bccd116dfb8ad7885fbec26080764)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitContrastOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f43b0ef0613759e19af5ff0838e6f24b0a0b2d1d8f86cfdfa237a6d3216ebde2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac649bfc80e420e15403f4c2b3e7f011ee9c19d6110da126b33da827e0343b6c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__91fe9578d3a0172200114ffaf0d8b03a05760b327ec6d1a06eb6cc20102b9cab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitContrast]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitContrast]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__078dac95354d608a9ca044ea548f40372c7e06b2b298b67eea9949b99f77963e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitContrastOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitContrastOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fea0a2049de4c3c34b649f67e43c0b4be66c77979d8cf10bae3a4b0987efdf05)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetBrightness")
    def reset_brightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightness", []))

    @jsii.member(jsii_name="resetBrightnessVar")
    def reset_brightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightnessVar", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetContrastVar")
    def reset_contrast_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrastVar", []))

    @builtins.property
    @jsii.member(jsii_name="brightnessInput")
    def brightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="brightnessVarInput")
    def brightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastVarInput")
    def contrast_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="brightness")
    def brightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightness"))

    @brightness.setter
    def brightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e1569184fb280ee52c50976792a7ce1e334518031d698b2bbcd0b69bd8b66d8b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightness", value)

    @builtins.property
    @jsii.member(jsii_name="brightnessVar")
    def brightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightnessVar"))

    @brightness_var.setter
    def brightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3c55075763836d3e4ca58ce282a7e8d2df6c857a76ef8584fd5f48036c4e49ea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrast"))

    @contrast.setter
    def contrast(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f50c7b08a19af1c8807116499aa66d169b652b4c2947b4e4392bae8bc69ae2ef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrast", value)

    @builtins.property
    @jsii.member(jsii_name="contrastVar")
    def contrast_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrastVar"))

    @contrast_var.setter
    def contrast_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__73c4adfe5f5b8b1832e10a496776f2f9853fc1a9f662db84582ae1ebe32308dd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrastVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitContrast]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitContrast]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitContrast]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6db2653dccec174f6c216e530d9b00acaa23eae2e6f21eb73fdd4e1e09855e59)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCrop",
    jsii_struct_bases=[],
    name_mapping={
        "allow_expansion": "allowExpansion",
        "allow_expansion_var": "allowExpansionVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCrop:
    def __init__(
        self,
        *,
        allow_expansion: typing.Optional[builtins.str] = None,
        allow_expansion_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_expansion: If cropping an area outside of the existing canvas, expands the image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        :param allow_expansion_var: If cropping an area outside of the existing canvas, expands the image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        :param gravity: Frame of reference for X and Y Positions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Frame of reference for X and Y Positions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The number of pixels to crop along the y-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The number of pixels to crop along the y-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The number of pixels to crop along the x-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The number of pixels to crop along the x-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        :param x_position: The x-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e6099121f422a4bc44b0dc254a19e7a82f579c058a561f5af99f4e94463a8f16)
            check_type(argname="argument allow_expansion", value=allow_expansion, expected_type=type_hints["allow_expansion"])
            check_type(argname="argument allow_expansion_var", value=allow_expansion_var, expected_type=type_hints["allow_expansion_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if allow_expansion is not None:
            self._values["allow_expansion"] = allow_expansion
        if allow_expansion_var is not None:
            self._values["allow_expansion_var"] = allow_expansion_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def allow_expansion(self) -> typing.Optional[builtins.str]:
        '''If cropping an area outside of the existing canvas, expands the image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        '''
        result = self._values.get("allow_expansion")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def allow_expansion_var(self) -> typing.Optional[builtins.str]:
        '''If cropping an area outside of the existing canvas, expands the image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        '''
        result = self._values.get("allow_expansion_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Frame of reference for X and Y Positions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Frame of reference for X and Y Positions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the y-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the y-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the x-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the x-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__db115a4c716b3565521375b9c82a0b34d8c78a41a7ed460d20c348189dd7cfa5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a024b9c8f6c09bc7c89ac717808ed02ec390a89563d265780140adc41f30e896)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3b8a92c99c7496369e4f80d90de14c2a016da0dba90dde34bbe9c11b37899f21)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__302d9134742b391cb76e69c10aed835a8b75c87632b7719905980adf55be54e5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4720b0d3d1ae6abbb6fce46078f30b3ec96a0b49558898d6458de494a1c3142b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__62fe3db35af465e28b568c3a613adc61b64e8d6b81147193f9147a8f0152376f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e95331adeb88ed08e511644270c12785d903a293aac3fcbe1e4a6ce8fb9fcc10)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAllowExpansion")
    def reset_allow_expansion(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansion", []))

    @jsii.member(jsii_name="resetAllowExpansionVar")
    def reset_allow_expansion_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansionVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionInput")
    def allow_expansion_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVarInput")
    def allow_expansion_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansion")
    def allow_expansion(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansion"))

    @allow_expansion.setter
    def allow_expansion(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5443e7f651ca2cf356139a3ce1b99fc3861c371b590d72a1a482c14ad057d520)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansion", value)

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVar")
    def allow_expansion_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansionVar"))

    @allow_expansion_var.setter
    def allow_expansion_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bd884ccd1403a5a32a0ade4a88bed9f91b67d8918e5d57f244f39a61e45f7d80)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansionVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a0561ca47fac35eb464addcb1759140600249277df21cd04bc0f427a97ca5b70)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__034827bac6cf8a0ab2014522fff4c4f8c004bdfd1b2dcc1629ea3e02728b3eb8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__38a4af4c5b436c455769a28c5b08dd2917d7c1be29841d5230be69792a54d1e9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1c14f851e98dfc1540bc277e9a4386656a428ba9ab52b1bf8a7f17f5d760c2a9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__02559c43c856f96f5c0ddfe61f6d8647e5eff280101ae4e2838bd0257a09585e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be8a280b31c0c0715f7583aef5bc43697b4b940e4b8c6508cabb5cf3876cf2aa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__41442b6e2b9d6991cd9e18524746e0dce34bb5d8cfb72cc37f5f4a4e0c418fe7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__006d8b332776f0be85e64b4ce15629be9314470317f41e9775a0af9b697977d9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6452302cf72225ad3c9235207e29f22189df901ec1afeee5daba18000f2215ec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__75013927f376617f2d6ab37fd10cf83e715db3424d38bc0f70eec7159fe5b081)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e13e30142e6ddefa71712c04e19ff9209743fcb438f2fa02c0ab7f1a1765ca8e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFaceCrop",
    jsii_struct_bases=[],
    name_mapping={
        "algorithm": "algorithm",
        "algorithm_var": "algorithmVar",
        "confidence": "confidence",
        "confidence_var": "confidenceVar",
        "fail_gravity": "failGravity",
        "fail_gravity_var": "failGravityVar",
        "focus": "focus",
        "focus_var": "focusVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "padding": "padding",
        "padding_var": "paddingVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFaceCrop:
    def __init__(
        self,
        *,
        algorithm: typing.Optional[builtins.str] = None,
        algorithm_var: typing.Optional[builtins.str] = None,
        confidence: typing.Optional[builtins.str] = None,
        confidence_var: typing.Optional[builtins.str] = None,
        fail_gravity: typing.Optional[builtins.str] = None,
        fail_gravity_var: typing.Optional[builtins.str] = None,
        focus: typing.Optional[builtins.str] = None,
        focus_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param algorithm: Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm DataAkamaiImagingPolicyImage#algorithm}
        :param algorithm_var: Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm_var DataAkamaiImagingPolicyImage#algorithm_var}
        :param confidence: With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image. Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence DataAkamaiImagingPolicyImage#confidence}
        :param confidence_var: With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image. Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence_var DataAkamaiImagingPolicyImage#confidence_var}
        :param fail_gravity: Controls placement of the crop if Image and Video Manager does not detect any faces in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        :param fail_gravity_var: Controls placement of the crop if Image and Video Manager does not detect any faces in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        :param focus: Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus DataAkamaiImagingPolicyImage#focus}
        :param focus_var: Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus_var DataAkamaiImagingPolicyImage#focus_var}
        :param gravity: Controls placement of the crop. Directions are relative to the face(s) plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Controls placement of the crop. Directions are relative to the face(s) plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param padding: The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        :param style: Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0502dd7176c6bc8f44049ed0b70c153a7fe4db479d17fc5e3cc60cd6a10ae048)
            check_type(argname="argument algorithm", value=algorithm, expected_type=type_hints["algorithm"])
            check_type(argname="argument algorithm_var", value=algorithm_var, expected_type=type_hints["algorithm_var"])
            check_type(argname="argument confidence", value=confidence, expected_type=type_hints["confidence"])
            check_type(argname="argument confidence_var", value=confidence_var, expected_type=type_hints["confidence_var"])
            check_type(argname="argument fail_gravity", value=fail_gravity, expected_type=type_hints["fail_gravity"])
            check_type(argname="argument fail_gravity_var", value=fail_gravity_var, expected_type=type_hints["fail_gravity_var"])
            check_type(argname="argument focus", value=focus, expected_type=type_hints["focus"])
            check_type(argname="argument focus_var", value=focus_var, expected_type=type_hints["focus_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if algorithm is not None:
            self._values["algorithm"] = algorithm
        if algorithm_var is not None:
            self._values["algorithm_var"] = algorithm_var
        if confidence is not None:
            self._values["confidence"] = confidence
        if confidence_var is not None:
            self._values["confidence_var"] = confidence_var
        if fail_gravity is not None:
            self._values["fail_gravity"] = fail_gravity
        if fail_gravity_var is not None:
            self._values["fail_gravity_var"] = fail_gravity_var
        if focus is not None:
            self._values["focus"] = focus
        if focus_var is not None:
            self._values["focus_var"] = focus_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def algorithm(self) -> typing.Optional[builtins.str]:
        '''Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm DataAkamaiImagingPolicyImage#algorithm}
        '''
        result = self._values.get("algorithm")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def algorithm_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm_var DataAkamaiImagingPolicyImage#algorithm_var}
        '''
        result = self._values.get("algorithm_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def confidence(self) -> typing.Optional[builtins.str]:
        '''With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image.

        Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence DataAkamaiImagingPolicyImage#confidence}
        '''
        result = self._values.get("confidence")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def confidence_var(self) -> typing.Optional[builtins.str]:
        '''With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image.

        Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence_var DataAkamaiImagingPolicyImage#confidence_var}
        '''
        result = self._values.get("confidence_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any faces in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        '''
        result = self._values.get("fail_gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any faces in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        '''
        result = self._values.get("fail_gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def focus(self) -> typing.Optional[builtins.str]:
        '''Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus DataAkamaiImagingPolicyImage#focus}
        '''
        result = self._values.get("focus")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def focus_var(self) -> typing.Optional[builtins.str]:
        '''Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus_var DataAkamaiImagingPolicyImage#focus_var}
        '''
        result = self._values.get("focus_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the face(s) plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the face(s) plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFaceCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFaceCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFaceCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__304df565835b67a7ff38f999b62ec6547477a1ffb81b39a7ee50a9123e468d14)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFaceCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2493cb33bed5c16a1c4c54f8803a7369519c9e4a4d4a5bc257e663104851eb58)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFaceCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__205c31914977a7b8d7c17da05795d8a15dfed31d9d4880a4f17c3a62ba705334)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__19124c6c1c795c9c9793b8e484dcfb802816df67a355b3c84dbde79645f1a256)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__24aed51088a5d81a8bf0143044df9335f00f486499c574aea2a6e6e6b9499a75)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFaceCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFaceCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFaceCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dc5044b09cae933e70e1f928f59acafefc735fc490dbe1386a69893711fc8298)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFaceCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFaceCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5101f9f60952dbd05bdf51cc09e125bee50396cd41e6cf35f94ced1e9f28175c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAlgorithm")
    def reset_algorithm(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAlgorithm", []))

    @jsii.member(jsii_name="resetAlgorithmVar")
    def reset_algorithm_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAlgorithmVar", []))

    @jsii.member(jsii_name="resetConfidence")
    def reset_confidence(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetConfidence", []))

    @jsii.member(jsii_name="resetConfidenceVar")
    def reset_confidence_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetConfidenceVar", []))

    @jsii.member(jsii_name="resetFailGravity")
    def reset_fail_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravity", []))

    @jsii.member(jsii_name="resetFailGravityVar")
    def reset_fail_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravityVar", []))

    @jsii.member(jsii_name="resetFocus")
    def reset_focus(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFocus", []))

    @jsii.member(jsii_name="resetFocusVar")
    def reset_focus_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFocusVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="algorithmInput")
    def algorithm_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "algorithmInput"))

    @builtins.property
    @jsii.member(jsii_name="algorithmVarInput")
    def algorithm_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "algorithmVarInput"))

    @builtins.property
    @jsii.member(jsii_name="confidenceInput")
    def confidence_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "confidenceInput"))

    @builtins.property
    @jsii.member(jsii_name="confidenceVarInput")
    def confidence_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "confidenceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityInput")
    def fail_gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityVarInput")
    def fail_gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="focusInput")
    def focus_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "focusInput"))

    @builtins.property
    @jsii.member(jsii_name="focusVarInput")
    def focus_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "focusVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="algorithm")
    def algorithm(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "algorithm"))

    @algorithm.setter
    def algorithm(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__42db22a9655c77983fd3f3b99cc353ff851ded63cbf0afb6eddbbf7644ed722f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "algorithm", value)

    @builtins.property
    @jsii.member(jsii_name="algorithmVar")
    def algorithm_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "algorithmVar"))

    @algorithm_var.setter
    def algorithm_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b893c48d8cf61cba23dbaa0acc64274fee2c72497a6f3e0103a4158f8cb41bb0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "algorithmVar", value)

    @builtins.property
    @jsii.member(jsii_name="confidence")
    def confidence(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "confidence"))

    @confidence.setter
    def confidence(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c00be01b0f3f949639f1892d307c56d1e7bb49b038b9c05a8919a0537d039af4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "confidence", value)

    @builtins.property
    @jsii.member(jsii_name="confidenceVar")
    def confidence_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "confidenceVar"))

    @confidence_var.setter
    def confidence_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a282ccdf03aa31939b74183f0ab17348b17b93567de8bc29b6ae80688952907)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "confidenceVar", value)

    @builtins.property
    @jsii.member(jsii_name="failGravity")
    def fail_gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravity"))

    @fail_gravity.setter
    def fail_gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7627eaf765a522faa8900cb38e9b7b8267cb1bdefd3c3cb5f87a3bd6453e283c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravity", value)

    @builtins.property
    @jsii.member(jsii_name="failGravityVar")
    def fail_gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravityVar"))

    @fail_gravity_var.setter
    def fail_gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5c1de046ac8589656a7d87afa175e34f1835fbc5cd0c946501da576f7717fddb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="focus")
    def focus(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "focus"))

    @focus.setter
    def focus(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cfc64e7b64cee858bf6418d52647e3bbfd52702412ae4956fb785198f12adb5e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "focus", value)

    @builtins.property
    @jsii.member(jsii_name="focusVar")
    def focus_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "focusVar"))

    @focus_var.setter
    def focus_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__56332e98d6314d757ea08d2b3848375c22c7cfcd50fc01f7c59c3c13d1187a2c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "focusVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f4f72f8e7f166be2484e7d4cc0c01e4a64be0f04119078135462470429722da7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6bce54e093a5f2cee58c4efeec871c2b092bc13d224ca869925cc6059d2dc887)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0d57b2d68b687b84c4f70b75901a2990ee65de96434d73fb84bd445e50c30459)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__90eb45c78f092409c41cf5559ea1af61301cec95f3b07e94de67f16cb7513bea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__43b81e3d115082fbe7e13bfc9134bc8100d4603e2e4089e857725430a9435219)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fc955fcf6dbf2f18d5ff78a6a7ff48d4105fc24f2b41529d72ff58d24b702607)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__691f934a159a4c1f197e1b002e0b53e4ccb88f029a58484458c9ae646d45a0ac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__76846dfb1a413110cf8b510058e317878db081064f3d38a7676297a9f44801ce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df379b685422781f4293747ca083b00196de694d17b2665816c555c9856a58ea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5e203cb8526061eaeb6965a603b1e012c3e4d03fe9f3d9fda75029407b4291b8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFaceCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFaceCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFaceCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c0116eb49277747b915189fa7d9f42bc103e1eb48bf11c23ec6f94c0957137cb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFeatureCrop",
    jsii_struct_bases=[],
    name_mapping={
        "fail_gravity": "failGravity",
        "fail_gravity_var": "failGravityVar",
        "feature_radius": "featureRadius",
        "feature_radius_var": "featureRadiusVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "max_features": "maxFeatures",
        "max_features_var": "maxFeaturesVar",
        "min_feature_quality": "minFeatureQuality",
        "min_feature_quality_var": "minFeatureQualityVar",
        "padding": "padding",
        "padding_var": "paddingVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFeatureCrop:
    def __init__(
        self,
        *,
        fail_gravity: typing.Optional[builtins.str] = None,
        fail_gravity_var: typing.Optional[builtins.str] = None,
        feature_radius: typing.Optional[builtins.str] = None,
        feature_radius_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        max_features: typing.Optional[builtins.str] = None,
        max_features_var: typing.Optional[builtins.str] = None,
        min_feature_quality: typing.Optional[builtins.str] = None,
        min_feature_quality_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fail_gravity: Controls placement of the crop if Image and Video Manager does not detect any features in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        :param fail_gravity_var: Controls placement of the crop if Image and Video Manager does not detect any features in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        :param feature_radius: The size in pixels of the important features to search for. If identified, two features never appear closer together than this value, ``8.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius DataAkamaiImagingPolicyImage#feature_radius}
        :param feature_radius_var: The size in pixels of the important features to search for. If identified, two features never appear closer together than this value, ``8.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius_var DataAkamaiImagingPolicyImage#feature_radius_var}
        :param gravity: Controls placement of the crop. Directions are relative to the region of interest plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Controls placement of the crop. Directions are relative to the region of interest plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param max_features: The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features DataAkamaiImagingPolicyImage#max_features}
        :param max_features_var: The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features_var DataAkamaiImagingPolicyImage#max_features_var}
        :param min_feature_quality: Determines the minimum quality level of the feature identified. To consider a feature important, the feature needs to surpass this value. Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality DataAkamaiImagingPolicyImage#min_feature_quality}
        :param min_feature_quality_var: Determines the minimum quality level of the feature identified. To consider a feature important, the feature needs to surpass this value. Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality_var DataAkamaiImagingPolicyImage#min_feature_quality_var}
        :param padding: Adds space around the region of interest. The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: Adds space around the region of interest. The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        :param style: Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4b4b2ab0706e689018dab6d31431e901286a64aff0038fd3fe884a25a1e0333f)
            check_type(argname="argument fail_gravity", value=fail_gravity, expected_type=type_hints["fail_gravity"])
            check_type(argname="argument fail_gravity_var", value=fail_gravity_var, expected_type=type_hints["fail_gravity_var"])
            check_type(argname="argument feature_radius", value=feature_radius, expected_type=type_hints["feature_radius"])
            check_type(argname="argument feature_radius_var", value=feature_radius_var, expected_type=type_hints["feature_radius_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument max_features", value=max_features, expected_type=type_hints["max_features"])
            check_type(argname="argument max_features_var", value=max_features_var, expected_type=type_hints["max_features_var"])
            check_type(argname="argument min_feature_quality", value=min_feature_quality, expected_type=type_hints["min_feature_quality"])
            check_type(argname="argument min_feature_quality_var", value=min_feature_quality_var, expected_type=type_hints["min_feature_quality_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fail_gravity is not None:
            self._values["fail_gravity"] = fail_gravity
        if fail_gravity_var is not None:
            self._values["fail_gravity_var"] = fail_gravity_var
        if feature_radius is not None:
            self._values["feature_radius"] = feature_radius
        if feature_radius_var is not None:
            self._values["feature_radius_var"] = feature_radius_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if max_features is not None:
            self._values["max_features"] = max_features
        if max_features_var is not None:
            self._values["max_features_var"] = max_features_var
        if min_feature_quality is not None:
            self._values["min_feature_quality"] = min_feature_quality
        if min_feature_quality_var is not None:
            self._values["min_feature_quality_var"] = min_feature_quality_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def fail_gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any features in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        '''
        result = self._values.get("fail_gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any features in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        '''
        result = self._values.get("fail_gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feature_radius(self) -> typing.Optional[builtins.str]:
        '''The size in pixels of the important features to search for.

        If identified, two features never appear closer together than this value, ``8.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius DataAkamaiImagingPolicyImage#feature_radius}
        '''
        result = self._values.get("feature_radius")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feature_radius_var(self) -> typing.Optional[builtins.str]:
        '''The size in pixels of the important features to search for.

        If identified, two features never appear closer together than this value, ``8.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius_var DataAkamaiImagingPolicyImage#feature_radius_var}
        '''
        result = self._values.get("feature_radius_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the region of interest plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the region of interest plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def max_features(self) -> typing.Optional[builtins.str]:
        '''The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features DataAkamaiImagingPolicyImage#max_features}
        '''
        result = self._values.get("max_features")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def max_features_var(self) -> typing.Optional[builtins.str]:
        '''The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features_var DataAkamaiImagingPolicyImage#max_features_var}
        '''
        result = self._values.get("max_features_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def min_feature_quality(self) -> typing.Optional[builtins.str]:
        '''Determines the minimum quality level of the feature identified.

        To consider a feature important, the feature needs to surpass this value.  Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality DataAkamaiImagingPolicyImage#min_feature_quality}
        '''
        result = self._values.get("min_feature_quality")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def min_feature_quality_var(self) -> typing.Optional[builtins.str]:
        '''Determines the minimum quality level of the feature identified.

        To consider a feature important, the feature needs to surpass this value.  Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality_var DataAkamaiImagingPolicyImage#min_feature_quality_var}
        '''
        result = self._values.get("min_feature_quality_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''Adds space around the region of interest.

        The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''Adds space around the region of interest.

        The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFeatureCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFeatureCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFeatureCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e2a1e44da05a27c134a7aba9618fd825ae7116ac7b0753bdb39271c2eb9abc5d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFeatureCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c108aa493f42630902748fe31b4850e3fc59f60d58a4bb942e64ce99b4e82636)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFeatureCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fdcaf2adbad247849ae66743004a7d47f948477c37a56bc29ee4ec1fa41b86ca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__79580b2c27ea44b3aec03aaa0191a6bf3208b8277853c624cf8de97ec2fdfdc9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3e8aa17c1d2fbe03ac3e5ca38c043e21d80e2040801ac3cb1c5269b009b4f4e8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFeatureCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFeatureCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFeatureCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af8dbb2b8465e26a864a90206f3522390655a52f0979b9d628c95a98a13a5648)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFeatureCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFeatureCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af120950a850a8032f696bb44a4b58b54f46e321a711b3674214bec5228ddf73)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetFailGravity")
    def reset_fail_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravity", []))

    @jsii.member(jsii_name="resetFailGravityVar")
    def reset_fail_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravityVar", []))

    @jsii.member(jsii_name="resetFeatureRadius")
    def reset_feature_radius(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureRadius", []))

    @jsii.member(jsii_name="resetFeatureRadiusVar")
    def reset_feature_radius_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureRadiusVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetMaxFeatures")
    def reset_max_features(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxFeatures", []))

    @jsii.member(jsii_name="resetMaxFeaturesVar")
    def reset_max_features_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxFeaturesVar", []))

    @jsii.member(jsii_name="resetMinFeatureQuality")
    def reset_min_feature_quality(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMinFeatureQuality", []))

    @jsii.member(jsii_name="resetMinFeatureQualityVar")
    def reset_min_feature_quality_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMinFeatureQualityVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="failGravityInput")
    def fail_gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityVarInput")
    def fail_gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featureRadiusInput")
    def feature_radius_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featureRadiusInput"))

    @builtins.property
    @jsii.member(jsii_name="featureRadiusVarInput")
    def feature_radius_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featureRadiusVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesInput")
    def max_features_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "maxFeaturesInput"))

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesVarInput")
    def max_features_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "maxFeaturesVarInput"))

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityInput")
    def min_feature_quality_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "minFeatureQualityInput"))

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityVarInput")
    def min_feature_quality_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "minFeatureQualityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravity")
    def fail_gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravity"))

    @fail_gravity.setter
    def fail_gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4b372b3834c13848aa1dfc2ac0660502ddf487e049058ebad3cfe9924ec0108d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravity", value)

    @builtins.property
    @jsii.member(jsii_name="failGravityVar")
    def fail_gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravityVar"))

    @fail_gravity_var.setter
    def fail_gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b6b1aaa222a82143bc48a5954d20d91f87a798685c095f6e8ccb21706ce2d39e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="featureRadius")
    def feature_radius(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featureRadius"))

    @feature_radius.setter
    def feature_radius(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea56e96b6ef6fad17fd7a4bc785c044d6bd3ccf161ffa07e73d7c04db92c6699)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featureRadius", value)

    @builtins.property
    @jsii.member(jsii_name="featureRadiusVar")
    def feature_radius_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featureRadiusVar"))

    @feature_radius_var.setter
    def feature_radius_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f2f2c44c2a520c5febaa2f171ad49be2dcce9f6a523eb6cff7e66180e0e603e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featureRadiusVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e9a1d58b1f1c1dfd0aae39b0777e76eee09e5fcd16d42256f03348ee44d91573)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7a769442aeaec12ed12dc754c76f8a7a44e798eee2ec7c7a15f49b584286212a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f0a159cd5d1f27b2576c1d1d1f7b59c3398416ec6666c863a72b7e030eb57f48)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__080b7b1d099bf648b63296b533f88ac0ac38a5cd4c36de9ee4b900677433dc63)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="maxFeatures")
    def max_features(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "maxFeatures"))

    @max_features.setter
    def max_features(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2af2fa91ce27c896245d93275fe77a53c9ddba4bf50013df5de941cb99e33f33)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "maxFeatures", value)

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesVar")
    def max_features_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "maxFeaturesVar"))

    @max_features_var.setter
    def max_features_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b28012b5ab64a34e4287641dccaa08880bc1f0ca1c88770db5d5a1ad8ee4edbf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "maxFeaturesVar", value)

    @builtins.property
    @jsii.member(jsii_name="minFeatureQuality")
    def min_feature_quality(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "minFeatureQuality"))

    @min_feature_quality.setter
    def min_feature_quality(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f1f63061e4dbd57b306c006d9bb73cd329be32502e5d2e6ba922ac5618f6127d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "minFeatureQuality", value)

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityVar")
    def min_feature_quality_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "minFeatureQualityVar"))

    @min_feature_quality_var.setter
    def min_feature_quality_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__08c2535da44898e0c29d7735c79b2faddb5d1c6b225ee5836123166cabbb80ab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "minFeatureQualityVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e170f1fd556f8db686645c66730c8b4bb459067e97ff2339b448fac1bd2b0daa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f0c49e5bf0a03dff8102ba44dc062957b8b377dbd4eb3d1da4c729d4213a20fc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cbc2141dcd64b38a6730f96e427c7045d10155fc2918ae889c7442b5d51fbc7f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1851f40f18a2381a6cc30048894a63c2957e716ab54494e1d65e0fa9b6903b79)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df688bd1e0768c1a051a2c0197986f6f86a50d1c2062eae3e107147b5a6cec88)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f6bca368a99dab78e367aef3fa9508700c6f5754d5655f0ef79b26505bbce48d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFeatureCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFeatureCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFeatureCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0076db3906362720142791469c20f67ed4ce32fd65d318203e9bab4c63aa610e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFill",
    jsii_struct_bases=[],
    name_mapping={
        "fill_transformation": "fillTransformation",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFill:
    def __init__(
        self,
        *,
        fill_transformation: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fill_transformation: fill_transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_transformation DataAkamaiImagingPolicyImage#fill_transformation}
        :param height: The height value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The width value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(fill_transformation, dict):
            fill_transformation = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformation(**fill_transformation)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__14fd283b5671e4c79a49538a6644e92529da8f92122cbd387699c4dfa3ecae72)
            check_type(argname="argument fill_transformation", value=fill_transformation, expected_type=type_hints["fill_transformation"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fill_transformation is not None:
            self._values["fill_transformation"] = fill_transformation
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def fill_transformation(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformation"]:
        '''fill_transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_transformation DataAkamaiImagingPolicyImage#fill_transformation}
        '''
        result = self._values.get("fill_transformation")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformation"], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFill(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformation",
    jsii_struct_bases=[],
    name_mapping={
        "append": "append",
        "aspect_crop": "aspectCrop",
        "background_color": "backgroundColor",
        "blur": "blur",
        "chroma_key": "chromaKey",
        "composite": "composite",
        "compound": "compound",
        "contrast": "contrast",
        "crop": "crop",
        "face_crop": "faceCrop",
        "feature_crop": "featureCrop",
        "fit_and_fill": "fitAndFill",
        "goop": "goop",
        "grayscale": "grayscale",
        "hsl": "hsl",
        "hsv": "hsv",
        "if_dimension": "ifDimension",
        "if_orientation": "ifOrientation",
        "im_query": "imQuery",
        "max_colors": "maxColors",
        "mirror": "mirror",
        "mono_hue": "monoHue",
        "opacity": "opacity",
        "region_of_interest_crop": "regionOfInterestCrop",
        "relative_crop": "relativeCrop",
        "remove_color": "removeColor",
        "resize": "resize",
        "rotate": "rotate",
        "scale": "scale",
        "shear": "shear",
        "trim": "trim",
        "unsharp_mask": "unsharpMask",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformation:
    def __init__(
        self,
        *,
        append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationAppend", typing.Dict[builtins.str, typing.Any]]]]] = None,
        aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationAspectCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationBackgroundColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationBlur", typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationChromaKey", typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationComposite", typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationCompound", typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationContrast", typing.Dict[builtins.str, typing.Any]]]]] = None,
        crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationFaceCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationFeatureCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationFitAndFill", typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationGoop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationGrayscale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationHsl", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationHsv", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfDimension", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfOrientation", typing.Dict[builtins.str, typing.Any]]]]] = None,
        im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationImQuery", typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationMaxColors", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationMirror", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationMonoHue", typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationOpacity", typing.Dict[builtins.str, typing.Any]]]]] = None,
        region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationRegionOfInterestCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationRelativeCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationRemoveColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationResize", typing.Dict[builtins.str, typing.Any]]]]] = None,
        rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationRotate", typing.Dict[builtins.str, typing.Any]]]]] = None,
        scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationScale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationShear", typing.Dict[builtins.str, typing.Any]]]]] = None,
        trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationTrim", typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationUnsharpMask", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param append: append block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        :param aspect_crop: aspect_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param crop: crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        :param face_crop: face_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        :param feature_crop: feature_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        :param fit_and_fill: fit_and_fill block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param im_query: im_query block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param region_of_interest_crop: region_of_interest_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        :param relative_crop: relative_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param resize: resize block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        :param rotate: rotate block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        :param scale: scale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param shear: shear block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        :param trim: trim block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d92a0ddc1befeac1c66bd1314877bb63878daec54b4f1c66a218efa9dbc77a96)
            check_type(argname="argument append", value=append, expected_type=type_hints["append"])
            check_type(argname="argument aspect_crop", value=aspect_crop, expected_type=type_hints["aspect_crop"])
            check_type(argname="argument background_color", value=background_color, expected_type=type_hints["background_color"])
            check_type(argname="argument blur", value=blur, expected_type=type_hints["blur"])
            check_type(argname="argument chroma_key", value=chroma_key, expected_type=type_hints["chroma_key"])
            check_type(argname="argument composite", value=composite, expected_type=type_hints["composite"])
            check_type(argname="argument compound", value=compound, expected_type=type_hints["compound"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument crop", value=crop, expected_type=type_hints["crop"])
            check_type(argname="argument face_crop", value=face_crop, expected_type=type_hints["face_crop"])
            check_type(argname="argument feature_crop", value=feature_crop, expected_type=type_hints["feature_crop"])
            check_type(argname="argument fit_and_fill", value=fit_and_fill, expected_type=type_hints["fit_and_fill"])
            check_type(argname="argument goop", value=goop, expected_type=type_hints["goop"])
            check_type(argname="argument grayscale", value=grayscale, expected_type=type_hints["grayscale"])
            check_type(argname="argument hsl", value=hsl, expected_type=type_hints["hsl"])
            check_type(argname="argument hsv", value=hsv, expected_type=type_hints["hsv"])
            check_type(argname="argument if_dimension", value=if_dimension, expected_type=type_hints["if_dimension"])
            check_type(argname="argument if_orientation", value=if_orientation, expected_type=type_hints["if_orientation"])
            check_type(argname="argument im_query", value=im_query, expected_type=type_hints["im_query"])
            check_type(argname="argument max_colors", value=max_colors, expected_type=type_hints["max_colors"])
            check_type(argname="argument mirror", value=mirror, expected_type=type_hints["mirror"])
            check_type(argname="argument mono_hue", value=mono_hue, expected_type=type_hints["mono_hue"])
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument region_of_interest_crop", value=region_of_interest_crop, expected_type=type_hints["region_of_interest_crop"])
            check_type(argname="argument relative_crop", value=relative_crop, expected_type=type_hints["relative_crop"])
            check_type(argname="argument remove_color", value=remove_color, expected_type=type_hints["remove_color"])
            check_type(argname="argument resize", value=resize, expected_type=type_hints["resize"])
            check_type(argname="argument rotate", value=rotate, expected_type=type_hints["rotate"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument shear", value=shear, expected_type=type_hints["shear"])
            check_type(argname="argument trim", value=trim, expected_type=type_hints["trim"])
            check_type(argname="argument unsharp_mask", value=unsharp_mask, expected_type=type_hints["unsharp_mask"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if append is not None:
            self._values["append"] = append
        if aspect_crop is not None:
            self._values["aspect_crop"] = aspect_crop
        if background_color is not None:
            self._values["background_color"] = background_color
        if blur is not None:
            self._values["blur"] = blur
        if chroma_key is not None:
            self._values["chroma_key"] = chroma_key
        if composite is not None:
            self._values["composite"] = composite
        if compound is not None:
            self._values["compound"] = compound
        if contrast is not None:
            self._values["contrast"] = contrast
        if crop is not None:
            self._values["crop"] = crop
        if face_crop is not None:
            self._values["face_crop"] = face_crop
        if feature_crop is not None:
            self._values["feature_crop"] = feature_crop
        if fit_and_fill is not None:
            self._values["fit_and_fill"] = fit_and_fill
        if goop is not None:
            self._values["goop"] = goop
        if grayscale is not None:
            self._values["grayscale"] = grayscale
        if hsl is not None:
            self._values["hsl"] = hsl
        if hsv is not None:
            self._values["hsv"] = hsv
        if if_dimension is not None:
            self._values["if_dimension"] = if_dimension
        if if_orientation is not None:
            self._values["if_orientation"] = if_orientation
        if im_query is not None:
            self._values["im_query"] = im_query
        if max_colors is not None:
            self._values["max_colors"] = max_colors
        if mirror is not None:
            self._values["mirror"] = mirror
        if mono_hue is not None:
            self._values["mono_hue"] = mono_hue
        if opacity is not None:
            self._values["opacity"] = opacity
        if region_of_interest_crop is not None:
            self._values["region_of_interest_crop"] = region_of_interest_crop
        if relative_crop is not None:
            self._values["relative_crop"] = relative_crop
        if remove_color is not None:
            self._values["remove_color"] = remove_color
        if resize is not None:
            self._values["resize"] = resize
        if rotate is not None:
            self._values["rotate"] = rotate
        if scale is not None:
            self._values["scale"] = scale
        if shear is not None:
            self._values["shear"] = shear
        if trim is not None:
            self._values["trim"] = trim
        if unsharp_mask is not None:
            self._values["unsharp_mask"] = unsharp_mask

    @builtins.property
    def append(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationAppend"]]]:
        '''append block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        '''
        result = self._values.get("append")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationAppend"]]], result)

    @builtins.property
    def aspect_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationAspectCrop"]]]:
        '''aspect_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        '''
        result = self._values.get("aspect_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationAspectCrop"]]], result)

    @builtins.property
    def background_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationBackgroundColor"]]]:
        '''background_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        '''
        result = self._values.get("background_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationBackgroundColor"]]], result)

    @builtins.property
    def blur(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationBlur"]]]:
        '''blur block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        '''
        result = self._values.get("blur")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationBlur"]]], result)

    @builtins.property
    def chroma_key(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationChromaKey"]]]:
        '''chroma_key block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        '''
        result = self._values.get("chroma_key")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationChromaKey"]]], result)

    @builtins.property
    def composite(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationComposite"]]]:
        '''composite block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        '''
        result = self._values.get("composite")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationComposite"]]], result)

    @builtins.property
    def compound(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationCompound"]]]:
        '''compound block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        '''
        result = self._values.get("compound")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationCompound"]]], result)

    @builtins.property
    def contrast(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationContrast"]]]:
        '''contrast block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationContrast"]]], result)

    @builtins.property
    def crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationCrop"]]]:
        '''crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        '''
        result = self._values.get("crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationCrop"]]], result)

    @builtins.property
    def face_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationFaceCrop"]]]:
        '''face_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        '''
        result = self._values.get("face_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationFaceCrop"]]], result)

    @builtins.property
    def feature_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationFeatureCrop"]]]:
        '''feature_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        '''
        result = self._values.get("feature_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationFeatureCrop"]]], result)

    @builtins.property
    def fit_and_fill(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationFitAndFill"]]]:
        '''fit_and_fill block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        '''
        result = self._values.get("fit_and_fill")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationFitAndFill"]]], result)

    @builtins.property
    def goop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationGoop"]]]:
        '''goop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        '''
        result = self._values.get("goop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationGoop"]]], result)

    @builtins.property
    def grayscale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationGrayscale"]]]:
        '''grayscale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        '''
        result = self._values.get("grayscale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationGrayscale"]]], result)

    @builtins.property
    def hsl(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationHsl"]]]:
        '''hsl block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        '''
        result = self._values.get("hsl")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationHsl"]]], result)

    @builtins.property
    def hsv(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationHsv"]]]:
        '''hsv block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        '''
        result = self._values.get("hsv")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationHsv"]]], result)

    @builtins.property
    def if_dimension(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfDimension"]]]:
        '''if_dimension block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        '''
        result = self._values.get("if_dimension")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfDimension"]]], result)

    @builtins.property
    def if_orientation(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfOrientation"]]]:
        '''if_orientation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        '''
        result = self._values.get("if_orientation")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfOrientation"]]], result)

    @builtins.property
    def im_query(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationImQuery"]]]:
        '''im_query block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        '''
        result = self._values.get("im_query")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationImQuery"]]], result)

    @builtins.property
    def max_colors(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationMaxColors"]]]:
        '''max_colors block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        '''
        result = self._values.get("max_colors")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationMaxColors"]]], result)

    @builtins.property
    def mirror(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationMirror"]]]:
        '''mirror block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        '''
        result = self._values.get("mirror")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationMirror"]]], result)

    @builtins.property
    def mono_hue(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationMonoHue"]]]:
        '''mono_hue block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        '''
        result = self._values.get("mono_hue")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationMonoHue"]]], result)

    @builtins.property
    def opacity(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationOpacity"]]]:
        '''opacity block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationOpacity"]]], result)

    @builtins.property
    def region_of_interest_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationRegionOfInterestCrop"]]]:
        '''region_of_interest_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        '''
        result = self._values.get("region_of_interest_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationRegionOfInterestCrop"]]], result)

    @builtins.property
    def relative_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationRelativeCrop"]]]:
        '''relative_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        '''
        result = self._values.get("relative_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationRelativeCrop"]]], result)

    @builtins.property
    def remove_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationRemoveColor"]]]:
        '''remove_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        '''
        result = self._values.get("remove_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationRemoveColor"]]], result)

    @builtins.property
    def resize(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationResize"]]]:
        '''resize block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        '''
        result = self._values.get("resize")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationResize"]]], result)

    @builtins.property
    def rotate(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationRotate"]]]:
        '''rotate block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        '''
        result = self._values.get("rotate")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationRotate"]]], result)

    @builtins.property
    def scale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationScale"]]]:
        '''scale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationScale"]]], result)

    @builtins.property
    def shear(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationShear"]]]:
        '''shear block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        '''
        result = self._values.get("shear")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationShear"]]], result)

    @builtins.property
    def trim(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationTrim"]]]:
        '''trim block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        '''
        result = self._values.get("trim")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationTrim"]]], result)

    @builtins.property
    def unsharp_mask(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationUnsharpMask"]]]:
        '''unsharp_mask block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        result = self._values.get("unsharp_mask")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationUnsharpMask"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationAppend",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_priority": "gravityPriority",
        "gravity_priority_var": "gravityPriorityVar",
        "gravity_var": "gravityVar",
        "preserve_minor_dimension": "preserveMinorDimension",
        "preserve_minor_dimension_var": "preserveMinorDimensionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationAppend:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationAppendImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_priority: typing.Optional[builtins.str] = None,
        gravity_priority_var: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        preserve_minor_dimension: typing.Optional[builtins.str] = None,
        preserve_minor_dimension_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Specifies where to place the ``image`` relative to the source image. The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_priority: Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal. The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority DataAkamaiImagingPolicyImage#gravity_priority}
        :param gravity_priority_var: Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal. The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority_var DataAkamaiImagingPolicyImage#gravity_priority_var}
        :param gravity_var: Specifies where to place the ``image`` relative to the source image. The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param preserve_minor_dimension: Whether to preserve the source image's minor dimension, ``false`` by default. The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension DataAkamaiImagingPolicyImage#preserve_minor_dimension}
        :param preserve_minor_dimension_var: Whether to preserve the source image's minor dimension, ``false`` by default. The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension_var DataAkamaiImagingPolicyImage#preserve_minor_dimension_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationAppendImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__13d6b8e49d95423a9b7b18fef4625165b088a3dee3fa81c15ee7abfb6c15b7f1)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_priority", value=gravity_priority, expected_type=type_hints["gravity_priority"])
            check_type(argname="argument gravity_priority_var", value=gravity_priority_var, expected_type=type_hints["gravity_priority_var"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument preserve_minor_dimension", value=preserve_minor_dimension, expected_type=type_hints["preserve_minor_dimension"])
            check_type(argname="argument preserve_minor_dimension_var", value=preserve_minor_dimension_var, expected_type=type_hints["preserve_minor_dimension_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_priority is not None:
            self._values["gravity_priority"] = gravity_priority
        if gravity_priority_var is not None:
            self._values["gravity_priority_var"] = gravity_priority_var
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if preserve_minor_dimension is not None:
            self._values["preserve_minor_dimension"] = preserve_minor_dimension
        if preserve_minor_dimension_var is not None:
            self._values["preserve_minor_dimension_var"] = preserve_minor_dimension_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationAppendImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationAppendImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Specifies where to place the ``image`` relative to the source image.

        The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_priority(self) -> typing.Optional[builtins.str]:
        '''Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal.

        The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority DataAkamaiImagingPolicyImage#gravity_priority}
        '''
        result = self._values.get("gravity_priority")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_priority_var(self) -> typing.Optional[builtins.str]:
        '''Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal.

        The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority_var DataAkamaiImagingPolicyImage#gravity_priority_var}
        '''
        result = self._values.get("gravity_priority_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Specifies where to place the ``image`` relative to the source image.

        The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def preserve_minor_dimension(self) -> typing.Optional[builtins.str]:
        '''Whether to preserve the source image's minor dimension, ``false`` by default.

        The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension DataAkamaiImagingPolicyImage#preserve_minor_dimension}
        '''
        result = self._values.get("preserve_minor_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def preserve_minor_dimension_var(self) -> typing.Optional[builtins.str]:
        '''Whether to preserve the source image's minor dimension, ``false`` by default.

        The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension_var DataAkamaiImagingPolicyImage#preserve_minor_dimension_var}
        '''
        result = self._values.get("preserve_minor_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationAppend(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationAppendImage",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationAppendImage:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationAppendImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationAppendImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationAppendImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__77e9aae0406a78843f1929cf0fbfa1df7848614144d1be571bcc4fd6942f6e06)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationAppendImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationAppendImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationAppendImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3d217a56a28dc03810bbe400f7a50f6c0afcef681882896b2e723528a93d39cc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationAppendList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationAppendList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c35f8fedb4b91e00f36cde31454e700c8e7ef430ab65513391011dbb103a3271)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationAppendOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1c0af2fc6779386021a2c419a8ffaccf90b0649f0f00e84db22f694561658654)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationAppendOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c17d70b06cd451890f4872869ef71b55e64a4c9514a412163aaa4c79c3151e01)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__03c573867a3a15214009a083d1ab2a91def085813725c24194e812480fda741f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f43ea57f956621a92ab540ba581a6efcd31ab62922de5505b464d8291a66ea80)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationAppend]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationAppend]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationAppend]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a3cb9ede2d175ad42cd428ad18ff5288adf0fa32c5a3b14cac1b4a9577692890)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationAppendOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationAppendOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__02b9b6f5db93200825aaddb5671399ce2a4276c935ed472024a49b54db6c263a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationAppendImage()

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityPriority")
    def reset_gravity_priority(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityPriority", []))

    @jsii.member(jsii_name="resetGravityPriorityVar")
    def reset_gravity_priority_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityPriorityVar", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPreserveMinorDimension")
    def reset_preserve_minor_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPreserveMinorDimension", []))

    @jsii.member(jsii_name="resetPreserveMinorDimensionVar")
    def reset_preserve_minor_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPreserveMinorDimensionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationAppendImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationAppendImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityInput")
    def gravity_priority_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityPriorityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityVarInput")
    def gravity_priority_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityPriorityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationAppendImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationAppendImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionInput")
    def preserve_minor_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "preserveMinorDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionVarInput")
    def preserve_minor_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "preserveMinorDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__56dd8201fec35ddd31ac692160b0a0a0716c28526fca0aa23d08217724ec29b7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityPriority")
    def gravity_priority(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityPriority"))

    @gravity_priority.setter
    def gravity_priority(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__430e3145d3407825aa685633ae4832b2ec0df673328c7cacc66092c400206287)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityPriority", value)

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityVar")
    def gravity_priority_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityPriorityVar"))

    @gravity_priority_var.setter
    def gravity_priority_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__84886a063d17453a9017f467c29e7f58c7f0dc4c40feb0f7f840b2c73c91c6c5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityPriorityVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e1023a1da997dd9f33a1a4f710cfc37820d8faca73f5ccb5c628cac07956a1ef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimension")
    def preserve_minor_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "preserveMinorDimension"))

    @preserve_minor_dimension.setter
    def preserve_minor_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4f4b2cf6c2c27053628ddd92eab8018c9dae384f95ce73cdb09ae0ed29936ff8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "preserveMinorDimension", value)

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionVar")
    def preserve_minor_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "preserveMinorDimensionVar"))

    @preserve_minor_dimension_var.setter
    def preserve_minor_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6c8e1a1f5f4c497aeea5fd7a9c50f42aa10fedcc2424c27b442b7a8f643e02ec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "preserveMinorDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationAppend]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationAppend]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationAppend]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__24d19e174a7696a6aa28e310442b8a308d93a694e28158258109336b893d0d45)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationAspectCrop",
    jsii_struct_bases=[],
    name_mapping={
        "allow_expansion": "allowExpansion",
        "allow_expansion_var": "allowExpansionVar",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationAspectCrop:
    def __init__(
        self,
        *,
        allow_expansion: typing.Optional[builtins.str] = None,
        allow_expansion_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_expansion: Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image. Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        :param allow_expansion_var: Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image. Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        :param height: The height term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The width term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        :param x_position: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__64279504cc573198cc13653d98d437b6343e40a93cd792aad70e68a892910f6e)
            check_type(argname="argument allow_expansion", value=allow_expansion, expected_type=type_hints["allow_expansion"])
            check_type(argname="argument allow_expansion_var", value=allow_expansion_var, expected_type=type_hints["allow_expansion_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if allow_expansion is not None:
            self._values["allow_expansion"] = allow_expansion
        if allow_expansion_var is not None:
            self._values["allow_expansion_var"] = allow_expansion_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def allow_expansion(self) -> typing.Optional[builtins.str]:
        '''Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image.

        Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        '''
        result = self._values.get("allow_expansion")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def allow_expansion_var(self) -> typing.Optional[builtins.str]:
        '''Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image.

        Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        '''
        result = self._values.get("allow_expansion_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationAspectCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationAspectCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationAspectCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ced43c9a19568f8bc953ca0069f5cff74d88d8e3a62a0642a7ef64e58c345830)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationAspectCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9dc73df650cbf41bad721d33c31335b8bc9fbe4e5529a6b45ac46975a1fe556d)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationAspectCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ce461080e65019be3f8f4bc102f09b7e2a171b70512138a8f8a4c23b9db1531d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b4bb4aa87a134f805bcf038e8d062cc98e870e8b2401b2f36c5349163e268198)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3753d5f5e1d5091081262e2d062f531eafdb0afa615fd2511b0a00977e010227)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationAspectCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationAspectCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationAspectCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__555ab21cdc88bd551a844795f1fed3c01e85802b8288a80a226418ee81310525)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationAspectCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationAspectCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0dd798701cd70692bff92ae3d0e1b220c34e0951084f28df73766f38072c3baa)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAllowExpansion")
    def reset_allow_expansion(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansion", []))

    @jsii.member(jsii_name="resetAllowExpansionVar")
    def reset_allow_expansion_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansionVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionInput")
    def allow_expansion_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVarInput")
    def allow_expansion_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansion")
    def allow_expansion(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansion"))

    @allow_expansion.setter
    def allow_expansion(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ae5e1c6ef3ecf81151ba31680731b6b5181aa12529b28854659c0c6b24bdec6e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansion", value)

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVar")
    def allow_expansion_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansionVar"))

    @allow_expansion_var.setter
    def allow_expansion_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__68cb80c03f3049e517d9962a416168da4e0dbf5f34ad08f5af847be7721dcb40)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansionVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6ba786a1036dd291855306b8609c29517123475c54d46dfed98f1867ee5b99e0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__29a46ddb68824f421cd19f32968879e6bcf8ef5f984116770206bf4e70b6c02e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2dd172096a82324689d0fd7e0153d143768dd439caa305762b34174c75cb63dd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f3f8f16e5b9bf11dd3c9777e533eaec5a061939e1b8357a81156ed508da2e766)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a3947e99e340b7eb07b8420f7efcc9047a94865b98bcbd22811edbee870bb186)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__55a3ef36419c766a0294d1e22b2c222cbde0f9900ba6f5537222c767466c922d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__216403ef5a2da722bf04b1f0c051c84bf4fdc97df499bc1d643d91c6b6c0a8d5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__908dde7094efb451d670885b84cf42cf1b946f27651839311efd11c73bbd94b7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationAspectCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationAspectCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationAspectCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a8dce54adea4775e1c42a9ba8caa0efe2f8af438cc598f02d1b0be9e0ef70eb3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationBackgroundColor",
    jsii_struct_bases=[],
    name_mapping={"color": "color", "color_var": "colorVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationBackgroundColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__05de8069ca5f3cff374bc787323c9782e5b41bed102a519f1aa4eed0da46e04d)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationBackgroundColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationBackgroundColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationBackgroundColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b3a185f759b7cdb5f714edb857a0e1241b1d1164f2129e4998363ae96995210f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationBackgroundColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e442e48f5cdad9eef42b5a51666b6fe3472ed10fa9d0043d7df0bdeb6bab44dd)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationBackgroundColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d98e2c973eda0929ffec27c555b0dc2c23e993ce35824c07ad005e18c15d4060)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f853908ac6eefab5881cbc67dd0703ceca059c94101c79b407d74a954308c757)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5215057bf1c3f1a455c97d4e54428a9910e0b6d9d592a1f5492aea42f13f7616)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationBackgroundColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationBackgroundColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f70787e942652a72f29d77c88ebd89078a3cc900a8ea9ea4523cfcad4830f7e5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationBackgroundColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationBackgroundColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1c7499974cd23e03b601c3dd86df3045814efdfbff35e9e06451ef161956886f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__252776bb8915575bbe803a1fae16ff880df968b80eaa1302edd519f91e94740d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2f6bdc2bf8d3716e117164a24f4f44de0731bb9804b853d4f9871aaab1a2b47a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationBackgroundColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationBackgroundColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationBackgroundColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__831824f9b96902f4d1ffff5d468c451c31c0cbdd568d230552126e14078dcaf7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationBlur",
    jsii_struct_bases=[],
    name_mapping={"sigma": "sigma", "sigma_var": "sigmaVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationBlur:
    def __init__(
        self,
        *,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param sigma: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f821acb2a4039f313a9235adf55ab65d7fce32f2a7c5154e19ba24d049bda559)
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationBlur(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationBlurList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationBlurList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__45df656bc3ac12814a901fa66bdeccebe70b9c21d87f06a9a2f7013e8408dde2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationBlurOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f154a6c5c0879a3cf2d6029f7bc73e7021f916f0bf8ac66b1d555630bd0f0c91)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationBlurOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9572e36a1eb9a7794714c113d8c952936d47d325b682893b054323190a0d5ace)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__70831b16942d602f4e9e2d4b26c39a1a384d2b86e90c76b58770b35a8feee783)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c9ab9f15a734d0c600ec8a5c28fe00d6977f27fb55b9d8544ead5dc076a3c9c5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationBlur]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationBlur]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__edf3cc4e9237fc1812a80421092a1e50990f15f77b1c85122f585370e8753285)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationBlurOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationBlurOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__abfb9bcbdecab9951906ac9af7503960d5350d5f20b69c7739f8937c845a9f4d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2f9d6a72948296280ae8cda6ae1fa14575489aad4eb60ef0661c4e6f313cee1f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bfc73362091e6ea03a43c23935cbb3ca1db971a6f690b07348660ed240933954)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationBlur]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationBlur]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationBlur]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b825f2af2e627efc4a053b8fb10534e9e093fc454c414946b6be8fe831feb512)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationChromaKey",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_feather": "hueFeather",
        "hue_feather_var": "hueFeatherVar",
        "hue_tolerance": "hueTolerance",
        "hue_tolerance_var": "hueToleranceVar",
        "hue_var": "hueVar",
        "lightness_feather": "lightnessFeather",
        "lightness_feather_var": "lightnessFeatherVar",
        "lightness_tolerance": "lightnessTolerance",
        "lightness_tolerance_var": "lightnessToleranceVar",
        "saturation_feather": "saturationFeather",
        "saturation_feather_var": "saturationFeatherVar",
        "saturation_tolerance": "saturationTolerance",
        "saturation_tolerance_var": "saturationToleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationChromaKey:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_feather: typing.Optional[builtins.str] = None,
        hue_feather_var: typing.Optional[builtins.str] = None,
        hue_tolerance: typing.Optional[builtins.str] = None,
        hue_tolerance_var: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness_feather: typing.Optional[builtins.str] = None,
        lightness_feather_var: typing.Optional[builtins.str] = None,
        lightness_tolerance: typing.Optional[builtins.str] = None,
        lightness_tolerance_var: typing.Optional[builtins.str] = None,
        saturation_feather: typing.Optional[builtins.str] = None,
        saturation_feather_var: typing.Optional[builtins.str] = None,
        saturation_tolerance: typing.Optional[builtins.str] = None,
        saturation_tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_feather: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        :param hue_feather_var: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        :param hue_tolerance: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        :param hue_tolerance_var: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        :param hue_var: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness_feather: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        :param lightness_feather_var: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        :param lightness_tolerance: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        :param lightness_tolerance_var: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        :param saturation_feather: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        :param saturation_feather_var: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        :param saturation_tolerance: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        :param saturation_tolerance_var: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4fc81393e6ba4c15dae8c1f4fd87274739023406abb490a5a46f272a099460bc)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_feather", value=hue_feather, expected_type=type_hints["hue_feather"])
            check_type(argname="argument hue_feather_var", value=hue_feather_var, expected_type=type_hints["hue_feather_var"])
            check_type(argname="argument hue_tolerance", value=hue_tolerance, expected_type=type_hints["hue_tolerance"])
            check_type(argname="argument hue_tolerance_var", value=hue_tolerance_var, expected_type=type_hints["hue_tolerance_var"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness_feather", value=lightness_feather, expected_type=type_hints["lightness_feather"])
            check_type(argname="argument lightness_feather_var", value=lightness_feather_var, expected_type=type_hints["lightness_feather_var"])
            check_type(argname="argument lightness_tolerance", value=lightness_tolerance, expected_type=type_hints["lightness_tolerance"])
            check_type(argname="argument lightness_tolerance_var", value=lightness_tolerance_var, expected_type=type_hints["lightness_tolerance_var"])
            check_type(argname="argument saturation_feather", value=saturation_feather, expected_type=type_hints["saturation_feather"])
            check_type(argname="argument saturation_feather_var", value=saturation_feather_var, expected_type=type_hints["saturation_feather_var"])
            check_type(argname="argument saturation_tolerance", value=saturation_tolerance, expected_type=type_hints["saturation_tolerance"])
            check_type(argname="argument saturation_tolerance_var", value=saturation_tolerance_var, expected_type=type_hints["saturation_tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_feather is not None:
            self._values["hue_feather"] = hue_feather
        if hue_feather_var is not None:
            self._values["hue_feather_var"] = hue_feather_var
        if hue_tolerance is not None:
            self._values["hue_tolerance"] = hue_tolerance
        if hue_tolerance_var is not None:
            self._values["hue_tolerance_var"] = hue_tolerance_var
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness_feather is not None:
            self._values["lightness_feather"] = lightness_feather
        if lightness_feather_var is not None:
            self._values["lightness_feather_var"] = lightness_feather_var
        if lightness_tolerance is not None:
            self._values["lightness_tolerance"] = lightness_tolerance
        if lightness_tolerance_var is not None:
            self._values["lightness_tolerance_var"] = lightness_tolerance_var
        if saturation_feather is not None:
            self._values["saturation_feather"] = saturation_feather
        if saturation_feather_var is not None:
            self._values["saturation_feather_var"] = saturation_feather_var
        if saturation_tolerance is not None:
            self._values["saturation_tolerance"] = saturation_tolerance
        if saturation_tolerance_var is not None:
            self._values["saturation_tolerance_var"] = saturation_tolerance_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        '''
        result = self._values.get("hue_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        '''
        result = self._values.get("hue_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        '''
        result = self._values.get("hue_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        '''
        result = self._values.get("hue_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        '''
        result = self._values.get("lightness_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        '''
        result = self._values.get("lightness_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        '''
        result = self._values.get("lightness_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        '''
        result = self._values.get("lightness_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        '''
        result = self._values.get("saturation_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        '''
        result = self._values.get("saturation_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        '''
        result = self._values.get("saturation_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        result = self._values.get("saturation_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationChromaKey(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationChromaKeyList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationChromaKeyList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__45889b0e93c3c231fb0bddabd877e9c0a1b43ea67c5a12a4560b614e6178e381)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationChromaKeyOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cc918499f0d9175b26ef4b44928b815d929790de42040f0f35c1cdcdf4a5ff12)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationChromaKeyOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e0c5c2d9c8e77e40e167c689404bf91f832fe8294141d5f76da3b07c375024fc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__68fd15db3b023a650f2864c93d09a07ccf3263c2c35f45703443adba6a673d06)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__13ddc97c8d641e346f430ac049aeefc6ef1f370bc8b5df32151baf5b7d8f6a1e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationChromaKey]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationChromaKey]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__57cf447d54d69cedb4443b14378dc1b60be217bfc524559b44fee9df7ab86f12)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationChromaKeyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationChromaKeyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a37e3f41c8595c13b1c342aed0bb9142917ebb412dfbcdfa325a6bf483ea4c09)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueFeather")
    def reset_hue_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeather", []))

    @jsii.member(jsii_name="resetHueFeatherVar")
    def reset_hue_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeatherVar", []))

    @jsii.member(jsii_name="resetHueTolerance")
    def reset_hue_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueTolerance", []))

    @jsii.member(jsii_name="resetHueToleranceVar")
    def reset_hue_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueToleranceVar", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightnessFeather")
    def reset_lightness_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeather", []))

    @jsii.member(jsii_name="resetLightnessFeatherVar")
    def reset_lightness_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeatherVar", []))

    @jsii.member(jsii_name="resetLightnessTolerance")
    def reset_lightness_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessTolerance", []))

    @jsii.member(jsii_name="resetLightnessToleranceVar")
    def reset_lightness_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessToleranceVar", []))

    @jsii.member(jsii_name="resetSaturationFeather")
    def reset_saturation_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeather", []))

    @jsii.member(jsii_name="resetSaturationFeatherVar")
    def reset_saturation_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeatherVar", []))

    @jsii.member(jsii_name="resetSaturationTolerance")
    def reset_saturation_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationTolerance", []))

    @jsii.member(jsii_name="resetSaturationToleranceVar")
    def reset_saturation_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherInput")
    def hue_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVarInput")
    def hue_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceInput")
    def hue_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVarInput")
    def hue_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherInput")
    def lightness_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVarInput")
    def lightness_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceInput")
    def lightness_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVarInput")
    def lightness_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherInput")
    def saturation_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVarInput")
    def saturation_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceInput")
    def saturation_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVarInput")
    def saturation_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__43766f832ae737e9c509dd0dbc12851153aa45e97ea3b99f4a72511128706800)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeather")
    def hue_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeather"))

    @hue_feather.setter
    def hue_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f2164eec13fd6cfdb7f1be5c8d8029415484caafe6a5f8249b711ab0afe74e6f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeather", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVar")
    def hue_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeatherVar"))

    @hue_feather_var.setter
    def hue_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f653ff2eed73a585248852f588ac3285a330823bc3877aab48b59c40a82f7e6a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueTolerance")
    def hue_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueTolerance"))

    @hue_tolerance.setter
    def hue_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__797696345f715af7a60dc99cbf9474211976ad554602d71dc93f5b1740b0647d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVar")
    def hue_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueToleranceVar"))

    @hue_tolerance_var.setter
    def hue_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea1b7efc41a58893192af6710104dd10312da30c1fd74986a0c186f6ccb422d2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c53c32d90daa427dd7562f82be13c60ac220b769f446329cd3fa1e3a956046b0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeather")
    def lightness_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeather"))

    @lightness_feather.setter
    def lightness_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__db2ef3dd61fb68bb22674e565dac861ae4369fa9c70f66e68d14878d0ba19e73)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeather", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVar")
    def lightness_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeatherVar"))

    @lightness_feather_var.setter
    def lightness_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__36dc0bde23bb82e2dedd4ecd1eece4f5df94b3e09691e7eed01cb48d607041b1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessTolerance")
    def lightness_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessTolerance"))

    @lightness_tolerance.setter
    def lightness_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1dc1499a68290deec61836bc1fb1c0240b9d440b2bf87453b916622d366285e9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVar")
    def lightness_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessToleranceVar"))

    @lightness_tolerance_var.setter
    def lightness_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac5ed794fbc2c14816e1b340dcf292bbe35fd3d9afe7fed31b92738115c6c294)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeather")
    def saturation_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeather"))

    @saturation_feather.setter
    def saturation_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0c5063f8438d155111a55f8bc3ea0aa5089a4a89ccb298074d152fb19e43ed94)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeather", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVar")
    def saturation_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeatherVar"))

    @saturation_feather_var.setter
    def saturation_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5285fa19d6e5de011b94073617fa5e704e5113d1b595aa867de9117bdedd81e1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationTolerance")
    def saturation_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationTolerance"))

    @saturation_tolerance.setter
    def saturation_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c2996fba0d8c43c300c6081a8cfef2c9f10c0526fe31cd91b73505bdd25d45c4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVar")
    def saturation_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationToleranceVar"))

    @saturation_tolerance_var.setter
    def saturation_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3c2a02cdcd62fd675f02a9f5aefdf938e92491830b0a7bcea918873d1f5bada9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationChromaKey]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationChromaKey]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationChromaKey]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d041c0d54b6a760e058b9c90d9a89ff9f4d77801b1ca4c2f0072c92ecb840752)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationComposite",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "placement": "placement",
        "placement_var": "placementVar",
        "scale": "scale",
        "scale_dimension": "scaleDimension",
        "scale_dimension_var": "scaleDimensionVar",
        "scale_var": "scaleVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationComposite:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationCompositeImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        placement: typing.Optional[builtins.str] = None,
        placement_var: typing.Optional[builtins.str] = None,
        scale: typing.Optional[builtins.str] = None,
        scale_dimension: typing.Optional[builtins.str] = None,
        scale_dimension_var: typing.Optional[builtins.str] = None,
        scale_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param placement: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        :param placement_var: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        :param scale: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param scale_dimension: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        :param scale_dimension_var: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        :param scale_var: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        :param x_position: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationCompositeImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__97fc326d9abe1b32c6f729803522d698b640e3f8c3b6327fab103aeffaef4794)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument placement", value=placement, expected_type=type_hints["placement"])
            check_type(argname="argument placement_var", value=placement_var, expected_type=type_hints["placement_var"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument scale_dimension", value=scale_dimension, expected_type=type_hints["scale_dimension"])
            check_type(argname="argument scale_dimension_var", value=scale_dimension_var, expected_type=type_hints["scale_dimension_var"])
            check_type(argname="argument scale_var", value=scale_var, expected_type=type_hints["scale_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if placement is not None:
            self._values["placement"] = placement
        if placement_var is not None:
            self._values["placement_var"] = placement_var
        if scale is not None:
            self._values["scale"] = scale
        if scale_dimension is not None:
            self._values["scale_dimension"] = scale_dimension
        if scale_dimension_var is not None:
            self._values["scale_dimension_var"] = scale_dimension_var
        if scale_var is not None:
            self._values["scale_var"] = scale_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationCompositeImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationCompositeImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        '''
        result = self._values.get("placement")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement_var(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        '''
        result = self._values.get("placement_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        '''
        result = self._values.get("scale_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        '''
        result = self._values.get("scale_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        '''
        result = self._values.get("scale_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationComposite(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationCompositeImage",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationCompositeImage:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationCompositeImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationCompositeImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationCompositeImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1e437901aa86c14202b7a645dfb645ba069728cc04104691a03177381bfb5c77)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationCompositeImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationCompositeImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__36816ecc9a0ae8dc28b48ff4bed62701a3b2dbe73733a0d5fb8671af450d9f56)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationCompositeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationCompositeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df40b6096a83d7d94973509284700b90f2947fd858572fb21dccc340231dd557)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationCompositeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__659e88212a8812f1e076f98e2dff9592215fb05ef3de4256986191f53073c9b1)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationCompositeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f5c6e666cd0cda9576f0c0b5c346bd8e43f8c580c41e014dbcfd0a091969e282)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__861a6c406ad806f5a6af0affd220c1d5354cda343152656b33b0c90cf073c18a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3784df3a260a24b1f1f57f24f3337fea1b78929fc8a0b0ed9c3f4f0b6862d985)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationComposite]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationComposite]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d11e69cbd869b9b96fe141130745cb5cc7e8bc443929b96eead1d0adfde3ac4c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationCompositeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationCompositeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aeb1e2416e9e5fed72a8ad2f31d8a2ccde213a0a765ede8317c9313d8c646c92)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationCompositeImage()

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPlacement")
    def reset_placement(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacement", []))

    @jsii.member(jsii_name="resetPlacementVar")
    def reset_placement_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacementVar", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetScaleDimension")
    def reset_scale_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimension", []))

    @jsii.member(jsii_name="resetScaleDimensionVar")
    def reset_scale_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimensionVar", []))

    @jsii.member(jsii_name="resetScaleVar")
    def reset_scale_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationCompositeImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationCompositeImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationCompositeImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="placementInput")
    def placement_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementInput"))

    @builtins.property
    @jsii.member(jsii_name="placementVarInput")
    def placement_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionInput")
    def scale_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVarInput")
    def scale_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleVarInput")
    def scale_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__265de9a5fabb98f4dfffaf27541cbe0049bf229ec9ad8181782893797ed2d73b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cb999ceaf1f44079c3c8a53071e8f2bfe3ccaab6fa1041954699ea593034bc4a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="placement")
    def placement(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placement"))

    @placement.setter
    def placement(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c182b32486d97715187cc04d7e78b71dcca3a7fe6d1b82e9b9a87aa4027a6ff6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placement", value)

    @builtins.property
    @jsii.member(jsii_name="placementVar")
    def placement_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placementVar"))

    @placement_var.setter
    def placement_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ca95ef39ff3209deb6bc6230b97c14515c673c6bf5ba6f9403bf7e8b52bc43d7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placementVar", value)

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scale"))

    @scale.setter
    def scale(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b4b81a6a55d494d52a8f658234ebeab9cd195a4c88e5f20ff3204520c6a87dc6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scale", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimension")
    def scale_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimension"))

    @scale_dimension.setter
    def scale_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__20c3ff1a139a2ddf08333a89a8d295a7ca38b2aeded86087021ae1a01c342335)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimension", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVar")
    def scale_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimensionVar"))

    @scale_dimension_var.setter
    def scale_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__673111f4a3531c2214b35365f52e72f608478f0d94d5ab309aac5c4913af49b8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="scaleVar")
    def scale_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleVar"))

    @scale_var.setter
    def scale_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8b833e8736ce0f2425a774bae924fef8054d03ee3d562c70b6654faf744720bb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ec748cb8edfe41e58c5e4ea39ff06755ec1388b425b79cb3e869fe62c618ae7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__637603f040ae1c92f6517e7959f0f71c5d5b48798d00b00384fc392042fef3e6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__46553bb8651e282edf14356960ad075ee91dd7a87ed79336ed3e425e0d4afb42)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2dc577c27f5d803d5b3c079641d3f5de1fc32be66993d258be6e56fa6e196a92)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationComposite]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationComposite]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationComposite]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d44c88d61c2ced3ea060a000af823f422eb9dba867b80c24484f06bbc9e4afae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationCompound",
    jsii_struct_bases=[],
    name_mapping={"transformations": "transformations"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationCompound:
    def __init__(
        self,
        *,
        transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param transformations: transformations block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7c24107bc41f29fd8e0783a526d9b6f9be70a61a33a9e3721697237afe51c957)
            check_type(argname="argument transformations", value=transformations, expected_type=type_hints["transformations"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if transformations is not None:
            self._values["transformations"] = transformations

    @builtins.property
    def transformations(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationCompoundTransformations"]]]:
        '''transformations block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        result = self._values.get("transformations")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationCompoundTransformations"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationCompound(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationCompoundList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationCompoundList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1a2cade5b007794fc83c49c0ad03c2db3aaa3933f417e72bff665af7aa2f33c1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationCompoundOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__26a5010fbd41daf194f88a86ca5c2c87d9d4bfcc9077edcbba0b53efec40d243)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationCompoundOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2216ee140443c2ec64131c56d2fa100d7b2228cc039ddee09f0cda8e88b8cf29)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__63b66ecf7d5dbbd9851d3f38ed42a9fed5bf803cdaf1fc110063e0d0a07d9697)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3df65c1a527334257af2907518745ba27cd911eceea703b24aa3460e4b5a7bf9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationCompound]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationCompound]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ea0172acce385f96e259bd9df7abaab5c253302a80927d52f1dbe3b350c3c5b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationCompoundOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationCompoundOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1a3020a5e66a22c11d8963c2d8a8d28a29d613d68ce350a95417156836d27b55)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformations")
    def put_transformations(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a4f5bcec369920ca94f09e9323900f3b227a5eaa2f2605fdb7cab29803b6a56)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTransformations", [value]))

    @jsii.member(jsii_name="resetTransformations")
    def reset_transformations(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformations", []))

    @builtins.property
    @jsii.member(jsii_name="transformations")
    def transformations(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationCompoundTransformationsList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationCompoundTransformationsList", jsii.get(self, "transformations"))

    @builtins.property
    @jsii.member(jsii_name="transformationsInput")
    def transformations_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationCompoundTransformations"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationCompoundTransformations"]]], jsii.get(self, "transformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationCompound]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationCompound]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationCompound]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__00e2d5b8ff76dbceaa5fe4f43760332c72eba7260e817e9ed7d3d014b825aaf4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationCompoundTransformations",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationCompoundTransformations:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationCompoundTransformations(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationCompoundTransformationsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationCompoundTransformationsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6c276c6387345cb8825fe6a608ebc366d6ba5cc432ab0e774c8a0b61ebf2478b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationCompoundTransformationsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f69210b3a71a1844f049408d8373992e35f9496a77b2352f42ede0bae7729fda)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationCompoundTransformationsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3e71eedf031ca5dea49e25b9e99f15d3f3b300002cbe953bfdb853603477374a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7aa30783e98c35eaac0eacb3577aab38508c1edde59e5a4057c441d87ec89c92)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e05f9bcea69648177133ae71418d5c38f04da50c255596f8ec143f90bbd825a3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationCompoundTransformations]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationCompoundTransformations]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationCompoundTransformations]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d6c8ec265313be30b45894c4f7416cff417bdd5687d4bbb09cb0c325a453d77)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationCompoundTransformationsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationCompoundTransformationsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4abffd888c7b3b2783759d376359d0646f508ba4421391eafbcb8cfa3cf15fa2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationCompoundTransformations]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationCompoundTransformations]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationCompoundTransformations]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__01bbd21a0fd0aa41ac89150a524027326b67e4c0944b5843a48a261f72e921fc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationContrast",
    jsii_struct_bases=[],
    name_mapping={
        "brightness": "brightness",
        "brightness_var": "brightnessVar",
        "contrast": "contrast",
        "contrast_var": "contrastVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationContrast:
    def __init__(
        self,
        *,
        brightness: typing.Optional[builtins.str] = None,
        brightness_var: typing.Optional[builtins.str] = None,
        contrast: typing.Optional[builtins.str] = None,
        contrast_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param brightness: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        :param brightness_var: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        :param contrast: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param contrast_var: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f74c8d8914bb06e650b4dec03ef46d7e92a3b54ced1cc8f679ed22bb92dc7746)
            check_type(argname="argument brightness", value=brightness, expected_type=type_hints["brightness"])
            check_type(argname="argument brightness_var", value=brightness_var, expected_type=type_hints["brightness_var"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument contrast_var", value=contrast_var, expected_type=type_hints["contrast_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if brightness is not None:
            self._values["brightness"] = brightness
        if brightness_var is not None:
            self._values["brightness_var"] = brightness_var
        if contrast is not None:
            self._values["contrast"] = contrast
        if contrast_var is not None:
            self._values["contrast_var"] = contrast_var

    @builtins.property
    def brightness(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        '''
        result = self._values.get("brightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def brightness_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        '''
        result = self._values.get("brightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        result = self._values.get("contrast_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationContrast(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationContrastList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationContrastList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b50f27c1184a4cd2174d74195902ff5e62445b0b3a007e57be2bed8f381596a7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationContrastOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__412480c02441f044704d28c4e06fb08d00263cbacc65d3881b6fc25d95ecac9c)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationContrastOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e9c9291decb5783dbf96c91cad3bd3fb31fa1cca61d9a5d4e8f1c3626e43dbd7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__444520ec329052286f94d3dc46bc79bbc69cd7ae06176f8ec62ab394e9d75d68)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cb7212609da6a43ee049e447f2dd7db2a470c9a80b4e04fb27f045f2a64551a7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationContrast]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationContrast]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b47f8a4ae59c254e2e3b6d0297b843b3a7f25d3e14cc9d49e9a84bc95dd567b8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationContrastOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationContrastOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bd35e206166f4c4da108f0fa9e1d343704610b299df247dbdb897ac7f1c75ddd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetBrightness")
    def reset_brightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightness", []))

    @jsii.member(jsii_name="resetBrightnessVar")
    def reset_brightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightnessVar", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetContrastVar")
    def reset_contrast_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrastVar", []))

    @builtins.property
    @jsii.member(jsii_name="brightnessInput")
    def brightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="brightnessVarInput")
    def brightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastVarInput")
    def contrast_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="brightness")
    def brightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightness"))

    @brightness.setter
    def brightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cc41caef0ae3bef7ac43addacea441f5b6ad879bb3f520ee23abc2a45079d857)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightness", value)

    @builtins.property
    @jsii.member(jsii_name="brightnessVar")
    def brightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightnessVar"))

    @brightness_var.setter
    def brightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__baf1d831024bd9733571456fcd542b23799c078b50dd5743ad2910be3969123e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrast"))

    @contrast.setter
    def contrast(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c825b876e3fb590fceadb8e5a174d01e15994ed98fde1a63bce3073734d8aa41)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrast", value)

    @builtins.property
    @jsii.member(jsii_name="contrastVar")
    def contrast_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrastVar"))

    @contrast_var.setter
    def contrast_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__972e3cc7682de856c782ae108476b6be3a194a529218609618cafb64bb3a3386)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrastVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationContrast]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationContrast]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationContrast]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e4274e2297171f94194f0c223659d681b0a38dc2c67aaf612b0b780643d699b4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationCrop",
    jsii_struct_bases=[],
    name_mapping={
        "allow_expansion": "allowExpansion",
        "allow_expansion_var": "allowExpansionVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationCrop:
    def __init__(
        self,
        *,
        allow_expansion: typing.Optional[builtins.str] = None,
        allow_expansion_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_expansion: If cropping an area outside of the existing canvas, expands the image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        :param allow_expansion_var: If cropping an area outside of the existing canvas, expands the image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        :param gravity: Frame of reference for X and Y Positions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Frame of reference for X and Y Positions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The number of pixels to crop along the y-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The number of pixels to crop along the y-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The number of pixels to crop along the x-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The number of pixels to crop along the x-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        :param x_position: The x-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7b2184413a82624025721ee2313146ce187fbe7c0895a43d8504e9b9f2423591)
            check_type(argname="argument allow_expansion", value=allow_expansion, expected_type=type_hints["allow_expansion"])
            check_type(argname="argument allow_expansion_var", value=allow_expansion_var, expected_type=type_hints["allow_expansion_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if allow_expansion is not None:
            self._values["allow_expansion"] = allow_expansion
        if allow_expansion_var is not None:
            self._values["allow_expansion_var"] = allow_expansion_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def allow_expansion(self) -> typing.Optional[builtins.str]:
        '''If cropping an area outside of the existing canvas, expands the image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        '''
        result = self._values.get("allow_expansion")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def allow_expansion_var(self) -> typing.Optional[builtins.str]:
        '''If cropping an area outside of the existing canvas, expands the image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        '''
        result = self._values.get("allow_expansion_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Frame of reference for X and Y Positions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Frame of reference for X and Y Positions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the y-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the y-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the x-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the x-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4951e5638123187ca7c92f226ba16352c2d9c1a4b38db247ec7f1c3eefddfefd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a603ae0689de1b900973881cbade85c64ef6b617e4938ae42d89007ca87099e2)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9b7f898157db2d84cb3d40a2c01ed25f9fdc6dcb37b1da02dd679ab2fa78098e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__878d4519d9a11a0adea4d3fa245244ec54bd22fe642afdfaab977bd1da58182d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f5c944293d6e84ce8eb49418d77b63b4dbc68c36cabb72ec5dd35a75e6992402)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b4f66042e56f9aa3c8aacf771c50e515535b2c7c170c39e4b78510222575982f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__47448464c1a3bb2af3e373d6b0667619d260e3e30bde5b11af32b86c96c2253f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAllowExpansion")
    def reset_allow_expansion(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansion", []))

    @jsii.member(jsii_name="resetAllowExpansionVar")
    def reset_allow_expansion_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansionVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionInput")
    def allow_expansion_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVarInput")
    def allow_expansion_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansion")
    def allow_expansion(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansion"))

    @allow_expansion.setter
    def allow_expansion(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__16eaea5c93a313218b546a9ade7aa7ee03b74c7388c51ba2020c6254d0beb6e7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansion", value)

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVar")
    def allow_expansion_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansionVar"))

    @allow_expansion_var.setter
    def allow_expansion_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__65ecf269223b8ec8aa5e6b722fc0c5bba3fd3df3f4fd63e1f1df9442b0edfe4c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansionVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__05e5fe207d0320cab18b0c00748eeb085755f4874a27857603aaa32fde6d060f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ff1ae2d5be306dfb721dd8fbf6b59104331071a289e2f2b98740958247f4dee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5edd761b73a371358a19d8c237637a734c2e77d7644c9469560dbca305c16892)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__16ee0485c3a36660e485cd1e3b06d3cffb7a37fe04982c26aabd6e20ed48af8d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__56a3095005e4ff90e93289957cd3b9b446e8e9db3c90022177b0986109b707a6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7fea377d40c658b71774db93a87cf0f0d410d5f64b77f1cb8470a16fba52cc0a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b45b7f6420e11d8d5419a75bea486ddc9671a9662b69dfcc2d7007b9f44067ee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ab811511f80ec9a972c47461babdedf1da4f99e3392de4d53ff1a1557e65e42)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__90a8b753182654f441158483a2a3c03a5746ad2b56f8dcc33781f3cf40c8d212)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__768265f20e83917f3413cb978e5433bb4ad9d67a5da2bbd6357a64a2c3d4b83c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7cc1637ee024e598ffbc652264605bf6bb71cead1602c8dd71ea53ef8a21b051)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationFaceCrop",
    jsii_struct_bases=[],
    name_mapping={
        "algorithm": "algorithm",
        "algorithm_var": "algorithmVar",
        "confidence": "confidence",
        "confidence_var": "confidenceVar",
        "fail_gravity": "failGravity",
        "fail_gravity_var": "failGravityVar",
        "focus": "focus",
        "focus_var": "focusVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "padding": "padding",
        "padding_var": "paddingVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationFaceCrop:
    def __init__(
        self,
        *,
        algorithm: typing.Optional[builtins.str] = None,
        algorithm_var: typing.Optional[builtins.str] = None,
        confidence: typing.Optional[builtins.str] = None,
        confidence_var: typing.Optional[builtins.str] = None,
        fail_gravity: typing.Optional[builtins.str] = None,
        fail_gravity_var: typing.Optional[builtins.str] = None,
        focus: typing.Optional[builtins.str] = None,
        focus_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param algorithm: Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm DataAkamaiImagingPolicyImage#algorithm}
        :param algorithm_var: Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm_var DataAkamaiImagingPolicyImage#algorithm_var}
        :param confidence: With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image. Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence DataAkamaiImagingPolicyImage#confidence}
        :param confidence_var: With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image. Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence_var DataAkamaiImagingPolicyImage#confidence_var}
        :param fail_gravity: Controls placement of the crop if Image and Video Manager does not detect any faces in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        :param fail_gravity_var: Controls placement of the crop if Image and Video Manager does not detect any faces in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        :param focus: Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus DataAkamaiImagingPolicyImage#focus}
        :param focus_var: Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus_var DataAkamaiImagingPolicyImage#focus_var}
        :param gravity: Controls placement of the crop. Directions are relative to the face(s) plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Controls placement of the crop. Directions are relative to the face(s) plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param padding: The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        :param style: Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f507165ef2dfb32a36bb993127c7dec3dab2a36e820fb55f277d74741a8c06f4)
            check_type(argname="argument algorithm", value=algorithm, expected_type=type_hints["algorithm"])
            check_type(argname="argument algorithm_var", value=algorithm_var, expected_type=type_hints["algorithm_var"])
            check_type(argname="argument confidence", value=confidence, expected_type=type_hints["confidence"])
            check_type(argname="argument confidence_var", value=confidence_var, expected_type=type_hints["confidence_var"])
            check_type(argname="argument fail_gravity", value=fail_gravity, expected_type=type_hints["fail_gravity"])
            check_type(argname="argument fail_gravity_var", value=fail_gravity_var, expected_type=type_hints["fail_gravity_var"])
            check_type(argname="argument focus", value=focus, expected_type=type_hints["focus"])
            check_type(argname="argument focus_var", value=focus_var, expected_type=type_hints["focus_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if algorithm is not None:
            self._values["algorithm"] = algorithm
        if algorithm_var is not None:
            self._values["algorithm_var"] = algorithm_var
        if confidence is not None:
            self._values["confidence"] = confidence
        if confidence_var is not None:
            self._values["confidence_var"] = confidence_var
        if fail_gravity is not None:
            self._values["fail_gravity"] = fail_gravity
        if fail_gravity_var is not None:
            self._values["fail_gravity_var"] = fail_gravity_var
        if focus is not None:
            self._values["focus"] = focus
        if focus_var is not None:
            self._values["focus_var"] = focus_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def algorithm(self) -> typing.Optional[builtins.str]:
        '''Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm DataAkamaiImagingPolicyImage#algorithm}
        '''
        result = self._values.get("algorithm")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def algorithm_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm_var DataAkamaiImagingPolicyImage#algorithm_var}
        '''
        result = self._values.get("algorithm_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def confidence(self) -> typing.Optional[builtins.str]:
        '''With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image.

        Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence DataAkamaiImagingPolicyImage#confidence}
        '''
        result = self._values.get("confidence")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def confidence_var(self) -> typing.Optional[builtins.str]:
        '''With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image.

        Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence_var DataAkamaiImagingPolicyImage#confidence_var}
        '''
        result = self._values.get("confidence_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any faces in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        '''
        result = self._values.get("fail_gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any faces in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        '''
        result = self._values.get("fail_gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def focus(self) -> typing.Optional[builtins.str]:
        '''Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus DataAkamaiImagingPolicyImage#focus}
        '''
        result = self._values.get("focus")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def focus_var(self) -> typing.Optional[builtins.str]:
        '''Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus_var DataAkamaiImagingPolicyImage#focus_var}
        '''
        result = self._values.get("focus_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the face(s) plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the face(s) plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationFaceCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationFaceCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationFaceCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4596cdfa7086f018df18997d98524f1e5dd49ffde11e88c3359947025d2e8eeb)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationFaceCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__68c89c96865d53ccb48ef3a726200ab5e127b62d156065842ea88cd8f1cbd091)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationFaceCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aedd77d13bc3a06dcbdf2bdc2ebe477007a18860bfa41b8b30378d5623706022)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b568719baed356ea19e6c40e5476b24da83815f95ed145af58504fd2db3b4021)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d679103c59cf97158ce4cfa9c43cacea07c59b3b92b22c3bda751122fabb9353)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationFaceCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationFaceCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationFaceCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3c04be2cc89566f453bee4cd17dd4f536d37d22286f6a0fe82111e2b0efe4919)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationFaceCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationFaceCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dab7dbfb09dd6f54dfe23e3ef8ce6d0fc62474c2475b37351fbeaaa7c89fdd21)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAlgorithm")
    def reset_algorithm(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAlgorithm", []))

    @jsii.member(jsii_name="resetAlgorithmVar")
    def reset_algorithm_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAlgorithmVar", []))

    @jsii.member(jsii_name="resetConfidence")
    def reset_confidence(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetConfidence", []))

    @jsii.member(jsii_name="resetConfidenceVar")
    def reset_confidence_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetConfidenceVar", []))

    @jsii.member(jsii_name="resetFailGravity")
    def reset_fail_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravity", []))

    @jsii.member(jsii_name="resetFailGravityVar")
    def reset_fail_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravityVar", []))

    @jsii.member(jsii_name="resetFocus")
    def reset_focus(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFocus", []))

    @jsii.member(jsii_name="resetFocusVar")
    def reset_focus_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFocusVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="algorithmInput")
    def algorithm_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "algorithmInput"))

    @builtins.property
    @jsii.member(jsii_name="algorithmVarInput")
    def algorithm_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "algorithmVarInput"))

    @builtins.property
    @jsii.member(jsii_name="confidenceInput")
    def confidence_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "confidenceInput"))

    @builtins.property
    @jsii.member(jsii_name="confidenceVarInput")
    def confidence_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "confidenceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityInput")
    def fail_gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityVarInput")
    def fail_gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="focusInput")
    def focus_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "focusInput"))

    @builtins.property
    @jsii.member(jsii_name="focusVarInput")
    def focus_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "focusVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="algorithm")
    def algorithm(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "algorithm"))

    @algorithm.setter
    def algorithm(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2233f441d98067f24c824f76f243f1955824f66f876a513d380d8c19b8f0295e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "algorithm", value)

    @builtins.property
    @jsii.member(jsii_name="algorithmVar")
    def algorithm_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "algorithmVar"))

    @algorithm_var.setter
    def algorithm_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3de2cea332bae71250699c39246fa31ace223f2d7079ba4a7018863669da262d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "algorithmVar", value)

    @builtins.property
    @jsii.member(jsii_name="confidence")
    def confidence(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "confidence"))

    @confidence.setter
    def confidence(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2dd28010b6a80c37baed21f3722b93ae222cbd7a4722aef89d48965867767719)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "confidence", value)

    @builtins.property
    @jsii.member(jsii_name="confidenceVar")
    def confidence_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "confidenceVar"))

    @confidence_var.setter
    def confidence_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f3fa67a40eaa09c2a8ebd9452ace7db1932d93f89e3f45af1d2fd891a938db37)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "confidenceVar", value)

    @builtins.property
    @jsii.member(jsii_name="failGravity")
    def fail_gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravity"))

    @fail_gravity.setter
    def fail_gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__08784166621c51b03e74ae822167122950b6a0bc84f61d622473a73dabf655ec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravity", value)

    @builtins.property
    @jsii.member(jsii_name="failGravityVar")
    def fail_gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravityVar"))

    @fail_gravity_var.setter
    def fail_gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__631c9d182218a5aa65a77c7ba212e565e235dde84a0de8084b14cf99eb446336)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="focus")
    def focus(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "focus"))

    @focus.setter
    def focus(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d5fec617c1c3c72c41debff0ce072a8abee4bc10b9ae202e172f6492a7ef19a8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "focus", value)

    @builtins.property
    @jsii.member(jsii_name="focusVar")
    def focus_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "focusVar"))

    @focus_var.setter
    def focus_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6a66ce1e92dff5f79f8d29c921689cb747af1d2b5f4848e5e437aac5121a7533)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "focusVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9e428c5859593002d8ff612c9ec4cf96855297c5fffd5ad26ff36df507857e85)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__550602ebb28cef282a9feac6be297964805bdf889bfa7109cbdb2b307e516996)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d994a85013f3b6668911780f5ea802b112072627862333577dc9ffb6a2f477e9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ece5a5c8f578fd09e3edfc982d39e53dacb60acdfcb6d3de95041efa9e1ae25a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c3598ee4c3e9a399f98fe36b55fb15801a8efce56b07ee626b5a4fbbad9a27c5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3c81d79329141dde7b62d5a9fc866defaa60fd7a525395128f179a5a71f07fac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a5bc774463d573ec9a16bbcdc0c683d00639a6843e1c8cb99e713310b86b85a9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac7c8ad44d4abc9fdc3ab8e66f5f43c468bdb438ec3a4eac458c02a9ca4f211c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__32a6206940085eedc293b7e461379ed5ca02adac9e3c132f0f2009a2ea89e0b9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__752e4cb8697911aaa38f8602f6444086e98f5f3f38c31aed6b03f0809faf1e9a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationFaceCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationFaceCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationFaceCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cec487a082cdb3d9a5884931b712c719539f551ff251a7cf13f8684145e60a07)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationFeatureCrop",
    jsii_struct_bases=[],
    name_mapping={
        "fail_gravity": "failGravity",
        "fail_gravity_var": "failGravityVar",
        "feature_radius": "featureRadius",
        "feature_radius_var": "featureRadiusVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "max_features": "maxFeatures",
        "max_features_var": "maxFeaturesVar",
        "min_feature_quality": "minFeatureQuality",
        "min_feature_quality_var": "minFeatureQualityVar",
        "padding": "padding",
        "padding_var": "paddingVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationFeatureCrop:
    def __init__(
        self,
        *,
        fail_gravity: typing.Optional[builtins.str] = None,
        fail_gravity_var: typing.Optional[builtins.str] = None,
        feature_radius: typing.Optional[builtins.str] = None,
        feature_radius_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        max_features: typing.Optional[builtins.str] = None,
        max_features_var: typing.Optional[builtins.str] = None,
        min_feature_quality: typing.Optional[builtins.str] = None,
        min_feature_quality_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fail_gravity: Controls placement of the crop if Image and Video Manager does not detect any features in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        :param fail_gravity_var: Controls placement of the crop if Image and Video Manager does not detect any features in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        :param feature_radius: The size in pixels of the important features to search for. If identified, two features never appear closer together than this value, ``8.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius DataAkamaiImagingPolicyImage#feature_radius}
        :param feature_radius_var: The size in pixels of the important features to search for. If identified, two features never appear closer together than this value, ``8.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius_var DataAkamaiImagingPolicyImage#feature_radius_var}
        :param gravity: Controls placement of the crop. Directions are relative to the region of interest plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Controls placement of the crop. Directions are relative to the region of interest plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param max_features: The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features DataAkamaiImagingPolicyImage#max_features}
        :param max_features_var: The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features_var DataAkamaiImagingPolicyImage#max_features_var}
        :param min_feature_quality: Determines the minimum quality level of the feature identified. To consider a feature important, the feature needs to surpass this value. Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality DataAkamaiImagingPolicyImage#min_feature_quality}
        :param min_feature_quality_var: Determines the minimum quality level of the feature identified. To consider a feature important, the feature needs to surpass this value. Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality_var DataAkamaiImagingPolicyImage#min_feature_quality_var}
        :param padding: Adds space around the region of interest. The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: Adds space around the region of interest. The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        :param style: Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b3a8fcf6ce05dd7bef8de912e41358bd7d7ea5c7085f77dbe2b8db069f5b1c1b)
            check_type(argname="argument fail_gravity", value=fail_gravity, expected_type=type_hints["fail_gravity"])
            check_type(argname="argument fail_gravity_var", value=fail_gravity_var, expected_type=type_hints["fail_gravity_var"])
            check_type(argname="argument feature_radius", value=feature_radius, expected_type=type_hints["feature_radius"])
            check_type(argname="argument feature_radius_var", value=feature_radius_var, expected_type=type_hints["feature_radius_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument max_features", value=max_features, expected_type=type_hints["max_features"])
            check_type(argname="argument max_features_var", value=max_features_var, expected_type=type_hints["max_features_var"])
            check_type(argname="argument min_feature_quality", value=min_feature_quality, expected_type=type_hints["min_feature_quality"])
            check_type(argname="argument min_feature_quality_var", value=min_feature_quality_var, expected_type=type_hints["min_feature_quality_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fail_gravity is not None:
            self._values["fail_gravity"] = fail_gravity
        if fail_gravity_var is not None:
            self._values["fail_gravity_var"] = fail_gravity_var
        if feature_radius is not None:
            self._values["feature_radius"] = feature_radius
        if feature_radius_var is not None:
            self._values["feature_radius_var"] = feature_radius_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if max_features is not None:
            self._values["max_features"] = max_features
        if max_features_var is not None:
            self._values["max_features_var"] = max_features_var
        if min_feature_quality is not None:
            self._values["min_feature_quality"] = min_feature_quality
        if min_feature_quality_var is not None:
            self._values["min_feature_quality_var"] = min_feature_quality_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def fail_gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any features in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        '''
        result = self._values.get("fail_gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any features in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        '''
        result = self._values.get("fail_gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feature_radius(self) -> typing.Optional[builtins.str]:
        '''The size in pixels of the important features to search for.

        If identified, two features never appear closer together than this value, ``8.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius DataAkamaiImagingPolicyImage#feature_radius}
        '''
        result = self._values.get("feature_radius")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feature_radius_var(self) -> typing.Optional[builtins.str]:
        '''The size in pixels of the important features to search for.

        If identified, two features never appear closer together than this value, ``8.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius_var DataAkamaiImagingPolicyImage#feature_radius_var}
        '''
        result = self._values.get("feature_radius_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the region of interest plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the region of interest plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def max_features(self) -> typing.Optional[builtins.str]:
        '''The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features DataAkamaiImagingPolicyImage#max_features}
        '''
        result = self._values.get("max_features")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def max_features_var(self) -> typing.Optional[builtins.str]:
        '''The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features_var DataAkamaiImagingPolicyImage#max_features_var}
        '''
        result = self._values.get("max_features_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def min_feature_quality(self) -> typing.Optional[builtins.str]:
        '''Determines the minimum quality level of the feature identified.

        To consider a feature important, the feature needs to surpass this value.  Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality DataAkamaiImagingPolicyImage#min_feature_quality}
        '''
        result = self._values.get("min_feature_quality")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def min_feature_quality_var(self) -> typing.Optional[builtins.str]:
        '''Determines the minimum quality level of the feature identified.

        To consider a feature important, the feature needs to surpass this value.  Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality_var DataAkamaiImagingPolicyImage#min_feature_quality_var}
        '''
        result = self._values.get("min_feature_quality_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''Adds space around the region of interest.

        The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''Adds space around the region of interest.

        The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationFeatureCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationFeatureCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationFeatureCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__72a3fcf50cfa8ba935858f4bd34608130091a078a2fed3461fef96ea422e74e9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationFeatureCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5904991d46a6939db66bce5c8902cbf00c49f34993233e2ae0977fce16a3325e)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationFeatureCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__966a14d630b59f95090eb0da5ca8788be126f0edf47c6089d13c17cab53eef7e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ecde6dc86613a23657b10d8b3e66df4b0a3fe9f80637c92e5b4d8b9851c7416)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__da2cdf96e1943672b7deb8dce50869c9b538fbca3888ece53a2690f38795bbc7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationFeatureCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationFeatureCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationFeatureCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__240378d7c2783a937ebc9ee001dc828ff3a89226c235f9db05bda1a669b35bd2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationFeatureCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationFeatureCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c3c6ef53a1470031758efeb8ef508a48c8a1e8b309fabb511c2e8c1495db205c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetFailGravity")
    def reset_fail_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravity", []))

    @jsii.member(jsii_name="resetFailGravityVar")
    def reset_fail_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravityVar", []))

    @jsii.member(jsii_name="resetFeatureRadius")
    def reset_feature_radius(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureRadius", []))

    @jsii.member(jsii_name="resetFeatureRadiusVar")
    def reset_feature_radius_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureRadiusVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetMaxFeatures")
    def reset_max_features(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxFeatures", []))

    @jsii.member(jsii_name="resetMaxFeaturesVar")
    def reset_max_features_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxFeaturesVar", []))

    @jsii.member(jsii_name="resetMinFeatureQuality")
    def reset_min_feature_quality(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMinFeatureQuality", []))

    @jsii.member(jsii_name="resetMinFeatureQualityVar")
    def reset_min_feature_quality_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMinFeatureQualityVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="failGravityInput")
    def fail_gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityVarInput")
    def fail_gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featureRadiusInput")
    def feature_radius_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featureRadiusInput"))

    @builtins.property
    @jsii.member(jsii_name="featureRadiusVarInput")
    def feature_radius_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featureRadiusVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesInput")
    def max_features_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "maxFeaturesInput"))

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesVarInput")
    def max_features_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "maxFeaturesVarInput"))

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityInput")
    def min_feature_quality_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "minFeatureQualityInput"))

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityVarInput")
    def min_feature_quality_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "minFeatureQualityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravity")
    def fail_gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravity"))

    @fail_gravity.setter
    def fail_gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5c4e426886614090efaf1773d9a245aa752caeb4bf8eae94816eba5e3ff2f457)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravity", value)

    @builtins.property
    @jsii.member(jsii_name="failGravityVar")
    def fail_gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravityVar"))

    @fail_gravity_var.setter
    def fail_gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ffc0f0b6edb6d981631f28b73d93f765e918001482a0e57ae304b4047660163f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="featureRadius")
    def feature_radius(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featureRadius"))

    @feature_radius.setter
    def feature_radius(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5cb007b499eca84961775b8d57e8f07c2e35f868ffe1f73022adcb28f9410d9a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featureRadius", value)

    @builtins.property
    @jsii.member(jsii_name="featureRadiusVar")
    def feature_radius_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featureRadiusVar"))

    @feature_radius_var.setter
    def feature_radius_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f3c2c01dce9d1e913d668e3a520b5416df23203f13393c66d7e25b998e54d0a1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featureRadiusVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eb511ca31724bdbff9fd1df79023af1414c775d4d26790bdbb3627a563232694)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__350778a5400dc072bc89aede989fa11b3af6f0d34eed34d05fc29470cbdb1228)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__82762ddcfb82821b73254567a76410f0739218576dc2a671b22672e38fbf7528)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a2dc0888fc849128a50fc68d1ef07313fccd2b08b2c167a7920b2de15d3cf924)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="maxFeatures")
    def max_features(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "maxFeatures"))

    @max_features.setter
    def max_features(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6b0e2a58c7e1f2a17d475ab466d9d518da5679b5a740375c84dde9965040831c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "maxFeatures", value)

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesVar")
    def max_features_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "maxFeaturesVar"))

    @max_features_var.setter
    def max_features_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e1ce25cb888eb4f393bfef0853fc32b5396abad56f86a0f16235b4d7ed15ff21)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "maxFeaturesVar", value)

    @builtins.property
    @jsii.member(jsii_name="minFeatureQuality")
    def min_feature_quality(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "minFeatureQuality"))

    @min_feature_quality.setter
    def min_feature_quality(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8f55f44fd897c37fde9df69933e9f078aa32aeee59d8c79f04afff414e42b090)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "minFeatureQuality", value)

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityVar")
    def min_feature_quality_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "minFeatureQualityVar"))

    @min_feature_quality_var.setter
    def min_feature_quality_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__15a76d3fdcdc0c20a5d876b1337d2be2943a544b625c7dadc048bfc8478285b7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "minFeatureQualityVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__68764395d3b1bca4e7db95d0361b45c3b7ba439b6cae2e307ddca7f06e005031)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__317e10114744985eb0a16d60f8c786d3fdaedab06ceba401ded4e1fc57a4d23a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8392478c63336e2f2c3dcc24945f6b64d1f98c87b121503906885428f6d53f92)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8933c9154df68f3dd2f76adf9140332b07a507bb560ece485395a43ae4570e50)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e543484d136c0cc45eabfb2f68473b91152cb5d7bfbb601a2d1674b580689fac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__66a13f8bd86716a75feb065830d961f4ff2161ad8e4c204e163c4146746ab0dd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationFeatureCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationFeatureCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationFeatureCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9c1e00f8a335a08b7796d4b7e1771321a124380f72348fcbea7c52e61cea1714)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationFitAndFill",
    jsii_struct_bases=[],
    name_mapping={
        "fill_transformation": "fillTransformation",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationFitAndFill:
    def __init__(
        self,
        *,
        fill_transformation: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationFitAndFillFillTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fill_transformation: fill_transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_transformation DataAkamaiImagingPolicyImage#fill_transformation}
        :param height: The height value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The width value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(fill_transformation, dict):
            fill_transformation = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationFitAndFillFillTransformation(**fill_transformation)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__71f7a6166f95ddb5a29e5de379ff424c4ba882994f54c6d7efd3faf6ab0e5364)
            check_type(argname="argument fill_transformation", value=fill_transformation, expected_type=type_hints["fill_transformation"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fill_transformation is not None:
            self._values["fill_transformation"] = fill_transformation
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def fill_transformation(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationFitAndFillFillTransformation"]:
        '''fill_transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_transformation DataAkamaiImagingPolicyImage#fill_transformation}
        '''
        result = self._values.get("fill_transformation")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationFitAndFillFillTransformation"], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationFitAndFill(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationFitAndFillFillTransformation",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationFitAndFillFillTransformation:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationFitAndFillFillTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationFitAndFillFillTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationFitAndFillFillTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__376e1ea6a7d78316fba01701dfb2a78d7a168e88ae829d1da87bb9a1dace8339)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationFitAndFillFillTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationFitAndFillFillTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationFitAndFillFillTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e1f308b95612cf0e5be90cb1da4b832dda6956394946e2be990aed2ab9c7a54b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationFitAndFillList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationFitAndFillList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0c7f6af19f35ef6093c4cd981a4c8f8605e9b17d5ec9d54852d9a42401d0cdfd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationFitAndFillOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c9b24771a4ef3a8a26b44dc68c16c08e22486346800ccf5b0e08de54f05c723a)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationFitAndFillOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__71cdaf9ab66da7bef0e799a0b66e3e913ec304f9403f57a150ca04a2d84a8e5a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3010054749e064c6518a5e1b6f97598f72c0d7951c1d922c6b20ece713cd351e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d50afbae4455106ed2cb0dd4e9afd82cfa5c6aedfac4e4c39934affd86adfa2e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationFitAndFill]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationFitAndFill]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationFitAndFill]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__055b8a35950bf0e668563f94553782aa61ce9533263b878c086bb69aca2ffa7a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationFitAndFillOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationFitAndFillOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b64a9c0e6c96b162c44975d4381cbc81c14e3fb703909903ba5f4e4e71849acc)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putFillTransformation")
    def put_fill_transformation(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationFitAndFillFillTransformation()

        return typing.cast(None, jsii.invoke(self, "putFillTransformation", [value]))

    @jsii.member(jsii_name="resetFillTransformation")
    def reset_fill_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFillTransformation", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="fillTransformation")
    def fill_transformation(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationFitAndFillFillTransformationOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationFitAndFillFillTransformationOutputReference, jsii.get(self, "fillTransformation"))

    @builtins.property
    @jsii.member(jsii_name="fillTransformationInput")
    def fill_transformation_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationFitAndFillFillTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationFitAndFillFillTransformation], jsii.get(self, "fillTransformationInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__feb1a566b68c5f4ba7f7f643fcce6ba8b97c225f185fbbbb5b7c7fedb22a9066)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d301c30ce94331f9f5cd08eb7f92e20ed9252ab60b206af4c71a456023e4e38)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0e6df7c9e6807bc309859c90aa2df7953cb30fcce76e210d5ee3ce0cfb19f606)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__38834b7d5a4efed958326e4cc29ab8044e31863d695944cbbecf86f8719faa7a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationFitAndFill]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationFitAndFill]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationFitAndFill]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df1c5d65956da2b2d481fefe1be3f8091cb87f6efcb159144fd3cf546ddb1dcc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationGoop",
    jsii_struct_bases=[],
    name_mapping={
        "chaos": "chaos",
        "chaos_var": "chaosVar",
        "density": "density",
        "density_var": "densityVar",
        "power": "power",
        "power_var": "powerVar",
        "seed": "seed",
        "seed_var": "seedVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationGoop:
    def __init__(
        self,
        *,
        chaos: typing.Optional[builtins.str] = None,
        chaos_var: typing.Optional[builtins.str] = None,
        density: typing.Optional[builtins.str] = None,
        density_var: typing.Optional[builtins.str] = None,
        power: typing.Optional[builtins.str] = None,
        power_var: typing.Optional[builtins.str] = None,
        seed: typing.Optional[builtins.str] = None,
        seed_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param chaos: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        :param chaos_var: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        :param density: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        :param density_var: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        :param power: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        :param power_var: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        :param seed: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        :param seed_var: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a90fac0e26e6bb23db9c8f21d8e627b3a318a528c9456883963039f80b3e5b7)
            check_type(argname="argument chaos", value=chaos, expected_type=type_hints["chaos"])
            check_type(argname="argument chaos_var", value=chaos_var, expected_type=type_hints["chaos_var"])
            check_type(argname="argument density", value=density, expected_type=type_hints["density"])
            check_type(argname="argument density_var", value=density_var, expected_type=type_hints["density_var"])
            check_type(argname="argument power", value=power, expected_type=type_hints["power"])
            check_type(argname="argument power_var", value=power_var, expected_type=type_hints["power_var"])
            check_type(argname="argument seed", value=seed, expected_type=type_hints["seed"])
            check_type(argname="argument seed_var", value=seed_var, expected_type=type_hints["seed_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if chaos is not None:
            self._values["chaos"] = chaos
        if chaos_var is not None:
            self._values["chaos_var"] = chaos_var
        if density is not None:
            self._values["density"] = density
        if density_var is not None:
            self._values["density_var"] = density_var
        if power is not None:
            self._values["power"] = power
        if power_var is not None:
            self._values["power_var"] = power_var
        if seed is not None:
            self._values["seed"] = seed
        if seed_var is not None:
            self._values["seed_var"] = seed_var

    @builtins.property
    def chaos(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        '''
        result = self._values.get("chaos")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def chaos_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        '''
        result = self._values.get("chaos_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        '''
        result = self._values.get("density")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density_var(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        '''
        result = self._values.get("density_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        '''
        result = self._values.get("power")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power_var(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        '''
        result = self._values.get("power_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        '''
        result = self._values.get("seed")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed_var(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        result = self._values.get("seed_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationGoop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationGoopList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationGoopList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9410fd7f105a19ce2916fb1ac89090cffb8a1976eda9b2d5e9029282e97cf317)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationGoopOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f1c94989d3669c7d78b285596fd2196d16572f2c0b36281f44a69d5f17d39db6)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationGoopOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__238ae21d99b81046ad495d00b168cb9fb6d3919f997360a3d3d61d78e4bcd160)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__952d4cb7dc5535e74d58df97835fc0e641d77e1595e40cab1f5e691c3f890d89)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e14cc53df0ae4e0a509728bef9ece88a0c67edfc4035d92461df43367515a8c1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationGoop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationGoop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f5a62e275f6f117608a9b2f814ce125b7b57eee07116b5b33f18c490e84a66b7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationGoopOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationGoopOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4645fab14b0c8b62c58a8627e52b023458960b4f8e072f30bd27add151b8b65f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetChaos")
    def reset_chaos(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaos", []))

    @jsii.member(jsii_name="resetChaosVar")
    def reset_chaos_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaosVar", []))

    @jsii.member(jsii_name="resetDensity")
    def reset_density(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensity", []))

    @jsii.member(jsii_name="resetDensityVar")
    def reset_density_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensityVar", []))

    @jsii.member(jsii_name="resetPower")
    def reset_power(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPower", []))

    @jsii.member(jsii_name="resetPowerVar")
    def reset_power_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPowerVar", []))

    @jsii.member(jsii_name="resetSeed")
    def reset_seed(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeed", []))

    @jsii.member(jsii_name="resetSeedVar")
    def reset_seed_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeedVar", []))

    @builtins.property
    @jsii.member(jsii_name="chaosInput")
    def chaos_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosInput"))

    @builtins.property
    @jsii.member(jsii_name="chaosVarInput")
    def chaos_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosVarInput"))

    @builtins.property
    @jsii.member(jsii_name="densityInput")
    def density_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityInput"))

    @builtins.property
    @jsii.member(jsii_name="densityVarInput")
    def density_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="powerInput")
    def power_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerInput"))

    @builtins.property
    @jsii.member(jsii_name="powerVarInput")
    def power_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerVarInput"))

    @builtins.property
    @jsii.member(jsii_name="seedInput")
    def seed_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedInput"))

    @builtins.property
    @jsii.member(jsii_name="seedVarInput")
    def seed_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedVarInput"))

    @builtins.property
    @jsii.member(jsii_name="chaos")
    def chaos(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaos"))

    @chaos.setter
    def chaos(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__11aca7067ca0b1f0d2aa487f3d819a88e7310b14d61aa9c2621b5dbfb9ae6f5e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaos", value)

    @builtins.property
    @jsii.member(jsii_name="chaosVar")
    def chaos_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaosVar"))

    @chaos_var.setter
    def chaos_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f112ca27947dbd709f04cb321ccf1dc446865566d133b75f026144ecb365c6e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaosVar", value)

    @builtins.property
    @jsii.member(jsii_name="density")
    def density(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "density"))

    @density.setter
    def density(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__065f5340af429e1e31c7759308a8f8b0c907ce8878368eb67b600a121a48f436)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "density", value)

    @builtins.property
    @jsii.member(jsii_name="densityVar")
    def density_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "densityVar"))

    @density_var.setter
    def density_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ff8d16d378c753ad8b7684b9d46027c49ba77dbba90d497dbb2be7817c4a1ba8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "densityVar", value)

    @builtins.property
    @jsii.member(jsii_name="power")
    def power(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "power"))

    @power.setter
    def power(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__00ec0a173e1f3352ddc030ee0c765b4c0046ab79e860fbbe0f062feb70eda26c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "power", value)

    @builtins.property
    @jsii.member(jsii_name="powerVar")
    def power_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "powerVar"))

    @power_var.setter
    def power_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ca81b48d4fdd1222221407c889ea06d61309b03850699f9bc90dfefcc72116ad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "powerVar", value)

    @builtins.property
    @jsii.member(jsii_name="seed")
    def seed(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seed"))

    @seed.setter
    def seed(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__740a16c815082a6af553567aa943eaf74fbbd33d4149115ff0b30c19675fccd1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seed", value)

    @builtins.property
    @jsii.member(jsii_name="seedVar")
    def seed_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seedVar"))

    @seed_var.setter
    def seed_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cee9e1068dceca43d4591f0f49073573d106f72fc4f55adc4c26c5f66aea88cb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seedVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationGoop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationGoop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationGoop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__515c5a1237e01ed2692218b30d5bc488496a16a207e61d9921c87993a89d87fc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationGrayscale",
    jsii_struct_bases=[],
    name_mapping={"type": "type", "type_var": "typeVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationGrayscale:
    def __init__(
        self,
        *,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param type: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__13804a8113145c97fc1ae4f05c1477b09f6e426ba8db0d16207aea81c1aeae50)
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationGrayscale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationGrayscaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationGrayscaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7b52c679080eb0096f75eef35787017ff14fcb28ccc6b6f5cdae62b700f3ef4c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationGrayscaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__404a7ba2c013b8a8c39c52a856eb92b0bf9ae097481b3f0408471b23483a786e)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationGrayscaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e854093438b30dceae629c8390c403d0e1d1d096b78797a148d3a90015b18406)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a51a3b13c5c37d45ba9a89c214a1bdc17954d42db0453d5891c868917c5f82f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a4eb5d552203eafa9642b3b86323488766ab769d7d8d243ae945b814df6aaa9b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationGrayscale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationGrayscale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dcacde2a7c40cb39afe06ae250644e430cab27c7874e089b88cf1cdd51d5b8c7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationGrayscaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationGrayscaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac332d18a2aeaa1e88fa2985f76837da148cc839d3b6d2bf10a84ab3465c9c51)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__90f9e3440cf25b04e0c95dab31061b19a8f6f2d5ff4a8d795f5cdcdca5d78142)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d9909d5001d3a143292fb0e3d8b98b119cb51ed43fb1d5cfdecd3c3ca0713f9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationGrayscale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationGrayscale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationGrayscale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fbdf0f299fcb19f84c8334c560b053e044fc7173d691800ce34a42c1f2c8f2a2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationHsl",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "lightness": "lightness",
        "lightness_var": "lightnessVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationHsl:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness: typing.Optional[builtins.str] = None,
        lightness_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        :param lightness_var: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7060a8110c191a95556624c863a0c084ef9759be25ca90ab61f0c44cdf29030a)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness", value=lightness, expected_type=type_hints["lightness"])
            check_type(argname="argument lightness_var", value=lightness_var, expected_type=type_hints["lightness_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness is not None:
            self._values["lightness"] = lightness
        if lightness_var is not None:
            self._values["lightness_var"] = lightness_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        '''
        result = self._values.get("lightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        '''
        result = self._values.get("lightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationHsl(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationHslList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationHslList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3e2a5fcf68e3da5e5188d4ddc1bcd34aa1ccf408912dede1fe17206f55ffb127)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationHslOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4b4b77d537037a558760c271f6092eee21a3587246fd82da024c4bf2c8e01477)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationHslOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6dd9465d81dad1ab3c0c4f16203e81bdb30680e208cca3ae188bf3d14f8cff3c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__74a4a75171218b14b9fa3fb8d12d5d5affffd46c00d55e7839ffe1014989ca67)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__656bc493e00b43a33a4658548ad75dc570eb1d287278a0ede56d052fce5e75db)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationHsl]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationHsl]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0a33549ff200beb7c172525d7c30da4e9d6cfb61d9e43ae289d45694262198f9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationHslOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationHslOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__814366b9ea38252d489b18675513320e9a173e6427474e308af65806e9eaffcd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightness")
    def reset_lightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightness", []))

    @jsii.member(jsii_name="resetLightnessVar")
    def reset_lightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessInput")
    def lightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessVarInput")
    def lightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__888f558e6e58785bdf671b57f1b8c65c2ad2b40000b0a2090bbfa6b365b258c0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd809c44487eab5f97475f8f822f524948011911009dc2d8e162f8eb164a29a6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightness")
    def lightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightness"))

    @lightness.setter
    def lightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__775d307675d9281a8b4d4687afd0ae475ec2bad8a492e2aa2ced2cfc122162ee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightness", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessVar")
    def lightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessVar"))

    @lightness_var.setter
    def lightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__14218c3da1bfae8e840ce2363384d20e734213fa77c37d5a2e18851265b2f474)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0289480fd058d7aea095ad2ffb02650435f16a5425e7084c5812f5083201783f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eb3d851daa5bd23b06c1ed3e530f159294e0ad60e5b851aef60418303d495cfb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationHsl]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationHsl]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationHsl]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f78c45426811a941f05845007747e5e473ac23c94fe0b45123eb8779fefe9866)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationHsv",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationHsv:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        :param value: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5110f92ca4cbc79ae0019c32788d2b40b404f562e738fe4acf3bc2f04cd7c7fd)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationHsv(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationHsvList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationHsvList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__72d14e3d5cac50b18485666e484c5b5e6bd7b18b1708fa79d0624ebd472ed4f1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationHsvOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0b3fdc0f8fd67680d9498597fb2da79ccbc890f2f5c6d81b113d03eb9bddbabe)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationHsvOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd9355e55b78dce0430d1a07347ea545160eb2210024ba5e313b449de86a6e72)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d2c23a9e4cd12849a540e9d1c1636a474f62c9eee58251cbe7a31f1a9d5e5341)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9cc3e4d5af72506465cc14687c0f6d0930005df9cd22b21fd31aabbc7fd9b80c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationHsv]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationHsv]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7407de63791043ae53ecf6ea97e8a98eabade5167048be975c2742b053e3eee2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationHsvOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationHsvOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0b0aa84c6192e77d81c830de61313c6c8fc3ca3887e2214af863478d10f78b33)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e092d1c11788d06656af4fdd473bd09cc5e94a6bf752d35419bacd1791b4dfb6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__32fa8dd4ddeef9660982ea35f8dc09efebf69bce84d99dd7fcd8b8b88145746c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f6ec97269a7078fd7777a10565676ac749e52114c4d45338488b1790e4b00657)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__55d8539b55e2eb2172158c00588479299ed1138be056e3acd7aa16b7f9851742)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0dd7466ad9ff7c2784400bf956cccc852774dca9ea00ee46f004aaf2d6d12356)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__644e872a6e95abe5ec999dc3cfa0ba2049c2e1c97f750dfb1a5506f1cc0d5c1d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationHsv]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationHsv]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationHsv]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3b77c1c5b37732ead34c8001315609437e5c6f34bb6fc67372ab39713c48d595)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfDimension",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "dimension": "dimension",
        "dimension_var": "dimensionVar",
        "equal": "equal",
        "greater_than": "greaterThan",
        "less_than": "lessThan",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfDimension:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfDimensionDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        dimension: typing.Optional[builtins.str] = None,
        dimension_var: typing.Optional[builtins.str] = None,
        equal: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfDimensionEqual", typing.Dict[builtins.str, typing.Any]]] = None,
        greater_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfDimensionGreaterThan", typing.Dict[builtins.str, typing.Any]]] = None,
        less_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfDimensionLessThan", typing.Dict[builtins.str, typing.Any]]] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param dimension: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        :param dimension_var: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        :param equal: equal block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        :param greater_than: greater_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        :param less_than: less_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        :param value: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfDimensionDefault(**default)
        if isinstance(equal, dict):
            equal = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfDimensionEqual(**equal)
        if isinstance(greater_than, dict):
            greater_than = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfDimensionGreaterThan(**greater_than)
        if isinstance(less_than, dict):
            less_than = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfDimensionLessThan(**less_than)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__830a491ffc495a1332362dabcc14668535a96371298c685c71c03000f3a586e5)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument dimension", value=dimension, expected_type=type_hints["dimension"])
            check_type(argname="argument dimension_var", value=dimension_var, expected_type=type_hints["dimension_var"])
            check_type(argname="argument equal", value=equal, expected_type=type_hints["equal"])
            check_type(argname="argument greater_than", value=greater_than, expected_type=type_hints["greater_than"])
            check_type(argname="argument less_than", value=less_than, expected_type=type_hints["less_than"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if dimension is not None:
            self._values["dimension"] = dimension
        if dimension_var is not None:
            self._values["dimension_var"] = dimension_var
        if equal is not None:
            self._values["equal"] = equal
        if greater_than is not None:
            self._values["greater_than"] = greater_than
        if less_than is not None:
            self._values["less_than"] = less_than
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfDimensionDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfDimensionDefault"], result)

    @builtins.property
    def dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        '''
        result = self._values.get("dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        '''
        result = self._values.get("dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def equal(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfDimensionEqual"]:
        '''equal block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        '''
        result = self._values.get("equal")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfDimensionEqual"], result)

    @builtins.property
    def greater_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfDimensionGreaterThan"]:
        '''greater_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        '''
        result = self._values.get("greater_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfDimensionGreaterThan"], result)

    @builtins.property
    def less_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfDimensionLessThan"]:
        '''less_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        '''
        result = self._values.get("less_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfDimensionLessThan"], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfDimension(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfDimensionDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfDimensionDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfDimensionDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfDimensionDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfDimensionDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4548babda11be5b8ea1e2219b0884066ead968a33ea60c1dcf2a52cf5cde0bdd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfDimensionDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfDimensionDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4d1c21ba4400c2ad63d3dfd1805acb3f7c232bdfd48f741d332f90da42c45e54)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfDimensionEqual",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfDimensionEqual:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfDimensionEqual(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfDimensionEqualOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfDimensionEqualOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__28918ca947ae6249a19bc6edefb492b5ad4968552b80944824b726375add85bb)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfDimensionEqual], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfDimensionEqual],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d0298556a3b0d85e2868180e0a725331b9e963496844b9da88e4d774cbaf65d6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfDimensionGreaterThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfDimensionGreaterThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfDimensionGreaterThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfDimensionGreaterThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfDimensionGreaterThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e3268a75f5409d5f393d596da290c10ac8335577d34bf6deffded16d60f1a78e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfDimensionGreaterThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfDimensionGreaterThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0878fb1c140b728ec7d9fb35cc556be915987f7027210e44e377c87eaf780bc0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfDimensionLessThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfDimensionLessThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfDimensionLessThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfDimensionLessThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfDimensionLessThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__05150f48ea122f0c678824a996ed96cb974b20dd5f61aa48c50a546b60502468)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfDimensionLessThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfDimensionLessThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__03abf3f99c5f4831e79841d66bc33993cb3f83567c3e489691040202996191eb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfDimensionList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfDimensionList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__091b9988ce3a7489d6170dc47cca3372b6f323e9ae011e4671ec24f50430ef2d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfDimensionOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__515afe234165addb25260e35bf3fa0e99ffff38f5e5a15488b9cc15c23da526b)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfDimensionOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9304efc9baf2093ca4807ddee111ae18314e74291be4055451d5084bac1324f7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6938a752093ee6e1440c5ad13eb8c5c40447006eb00e366dd04262045cd5b38c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__84e7feeec16d23b0edf44656c0b1fc92c1ed87936e8b4ee159d3b297e98f7a9b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfDimension]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfDimension]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f01294a5ea8d80afde0f6cb9802e479eb4a9655c32be78195448c86bff036d05)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfDimensionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfDimensionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__06b4cbce66af2e27716b0d9484fa1806dbbbcecbdab6cb4271a459b2c86d4bf1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfDimensionDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putEqual")
    def put_equal(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfDimensionEqual()

        return typing.cast(None, jsii.invoke(self, "putEqual", [value]))

    @jsii.member(jsii_name="putGreaterThan")
    def put_greater_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfDimensionGreaterThan()

        return typing.cast(None, jsii.invoke(self, "putGreaterThan", [value]))

    @jsii.member(jsii_name="putLessThan")
    def put_less_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfDimensionLessThan()

        return typing.cast(None, jsii.invoke(self, "putLessThan", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetDimension")
    def reset_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimension", []))

    @jsii.member(jsii_name="resetDimensionVar")
    def reset_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimensionVar", []))

    @jsii.member(jsii_name="resetEqual")
    def reset_equal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEqual", []))

    @jsii.member(jsii_name="resetGreaterThan")
    def reset_greater_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGreaterThan", []))

    @jsii.member(jsii_name="resetLessThan")
    def reset_less_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLessThan", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfDimensionDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfDimensionDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="equal")
    def equal(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfDimensionEqualOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfDimensionEqualOutputReference, jsii.get(self, "equal"))

    @builtins.property
    @jsii.member(jsii_name="greaterThan")
    def greater_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfDimensionGreaterThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfDimensionGreaterThanOutputReference, jsii.get(self, "greaterThan"))

    @builtins.property
    @jsii.member(jsii_name="lessThan")
    def less_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfDimensionLessThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfDimensionLessThanOutputReference, jsii.get(self, "lessThan"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfDimensionDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionInput")
    def dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionVarInput")
    def dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="equalInput")
    def equal_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfDimensionEqual], jsii.get(self, "equalInput"))

    @builtins.property
    @jsii.member(jsii_name="greaterThanInput")
    def greater_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfDimensionGreaterThan], jsii.get(self, "greaterThanInput"))

    @builtins.property
    @jsii.member(jsii_name="lessThanInput")
    def less_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfDimensionLessThan], jsii.get(self, "lessThanInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="dimension")
    def dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimension"))

    @dimension.setter
    def dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__de0b132b0d0aba3227a160ebde55fe3ce4de2fe8dcb79142c0041a46f2173fa0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimension", value)

    @builtins.property
    @jsii.member(jsii_name="dimensionVar")
    def dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimensionVar"))

    @dimension_var.setter
    def dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__774db5acbc31a93c0e8b885c950cc711b972e0f9d8c0411b94960e6f6ade1035)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c9cf3aa6c81823c9b330b5929f86625e2c01ca548bc4eaa29d1d232f8cf9d7c5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1507d5bc73dc561392a90bd89afaa2801fb306b1dcbb89360be94142f4525c61)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfDimension]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfDimension]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfDimension]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d0164c8010da8fd4e009703aede0a961a08bac3ffe87e4becf28066d3ca3d5e0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfOrientation",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "landscape": "landscape",
        "portrait": "portrait",
        "square": "square",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfOrientation:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfOrientationDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        landscape: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfOrientationLandscape", typing.Dict[builtins.str, typing.Any]]] = None,
        portrait: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfOrientationPortrait", typing.Dict[builtins.str, typing.Any]]] = None,
        square: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfOrientationSquare", typing.Dict[builtins.str, typing.Any]]] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param landscape: landscape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        :param portrait: portrait block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        :param square: square block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfOrientationDefault(**default)
        if isinstance(landscape, dict):
            landscape = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfOrientationLandscape(**landscape)
        if isinstance(portrait, dict):
            portrait = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfOrientationPortrait(**portrait)
        if isinstance(square, dict):
            square = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfOrientationSquare(**square)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__722a2ece06450695fe8835af3a073884886d1e5cafd4cf54d6167b824d84f429)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument landscape", value=landscape, expected_type=type_hints["landscape"])
            check_type(argname="argument portrait", value=portrait, expected_type=type_hints["portrait"])
            check_type(argname="argument square", value=square, expected_type=type_hints["square"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if landscape is not None:
            self._values["landscape"] = landscape
        if portrait is not None:
            self._values["portrait"] = portrait
        if square is not None:
            self._values["square"] = square

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfOrientationDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfOrientationDefault"], result)

    @builtins.property
    def landscape(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfOrientationLandscape"]:
        '''landscape block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        '''
        result = self._values.get("landscape")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfOrientationLandscape"], result)

    @builtins.property
    def portrait(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfOrientationPortrait"]:
        '''portrait block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        '''
        result = self._values.get("portrait")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfOrientationPortrait"], result)

    @builtins.property
    def square(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfOrientationSquare"]:
        '''square block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        result = self._values.get("square")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfOrientationSquare"], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfOrientation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfOrientationDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfOrientationDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfOrientationDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfOrientationDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfOrientationDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ac60053a4875287d158eb5d71aa1c60f8c46eba2011a0423284fb5e56e25ef4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfOrientationDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfOrientationDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ad58541ba198db5246be1c938c53afd6328049f6900ffc5baf681f4392970dc6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfOrientationLandscape",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfOrientationLandscape:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfOrientationLandscape(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfOrientationLandscapeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfOrientationLandscapeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8385a7c88b308c1505f07c840fdbf64317bce0c52a7076f455ef9c731b60ec0a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfOrientationLandscape], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfOrientationLandscape],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ebcb3f529c6629eeec2215257f0df5cb80cbde2419c5184cab892db2547478cc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfOrientationList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfOrientationList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__087c22320abe3ecf913059280f644044ac853e9f09d66d43265ab3d338fad440)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfOrientationOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f345fd3f116505922d9b014c70137af33504d149f136c1fb14c4e12668bbfff8)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfOrientationOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__abb66455b5671eddbdea40ec07e3f6a9364836b8848a09a4a80aefb177fb3825)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e238dc5ec022a33f370453845980070efaf6e9876a425275b268881f18113990)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e2be1b44e3324c73ce54cb5b9ee5c50713f086417dcdb63a6e4d5f0fd25374cf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfOrientation]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfOrientation]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ec785674cc42cf0ec0ad3de139f36f46e674d37594243b47c6a4727b1abe5578)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfOrientationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfOrientationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d94b45fa4e62d994e19e66a5e6ef961483a19313007f256800d4690993f2b662)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfOrientationDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putLandscape")
    def put_landscape(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfOrientationLandscape()

        return typing.cast(None, jsii.invoke(self, "putLandscape", [value]))

    @jsii.member(jsii_name="putPortrait")
    def put_portrait(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfOrientationPortrait()

        return typing.cast(None, jsii.invoke(self, "putPortrait", [value]))

    @jsii.member(jsii_name="putSquare")
    def put_square(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfOrientationSquare()

        return typing.cast(None, jsii.invoke(self, "putSquare", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetLandscape")
    def reset_landscape(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLandscape", []))

    @jsii.member(jsii_name="resetPortrait")
    def reset_portrait(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPortrait", []))

    @jsii.member(jsii_name="resetSquare")
    def reset_square(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSquare", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfOrientationDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfOrientationDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="landscape")
    def landscape(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfOrientationLandscapeOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfOrientationLandscapeOutputReference, jsii.get(self, "landscape"))

    @builtins.property
    @jsii.member(jsii_name="portrait")
    def portrait(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfOrientationPortraitOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfOrientationPortraitOutputReference", jsii.get(self, "portrait"))

    @builtins.property
    @jsii.member(jsii_name="square")
    def square(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfOrientationSquareOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfOrientationSquareOutputReference", jsii.get(self, "square"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfOrientationDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="landscapeInput")
    def landscape_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfOrientationLandscape], jsii.get(self, "landscapeInput"))

    @builtins.property
    @jsii.member(jsii_name="portraitInput")
    def portrait_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfOrientationPortrait"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfOrientationPortrait"], jsii.get(self, "portraitInput"))

    @builtins.property
    @jsii.member(jsii_name="squareInput")
    def square_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfOrientationSquare"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfOrientationSquare"], jsii.get(self, "squareInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfOrientation]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfOrientation]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfOrientation]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ce02254c67d1edbabcb0802d192f56b7e191f3ff6e4aa456dd364d27aa84a88)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfOrientationPortrait",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfOrientationPortrait:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfOrientationPortrait(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfOrientationPortraitOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfOrientationPortraitOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0174025988b4107e63216f954380c2731003d0f4f8f28c190a7a092ffedee1ce)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfOrientationPortrait]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfOrientationPortrait], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfOrientationPortrait],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f9ae7f565178903b6771bb3018feccf5eca6beff4ec74462ed57a1fa6e32b64)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfOrientationSquare",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfOrientationSquare:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfOrientationSquare(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfOrientationSquareOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfOrientationSquareOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__72245c4790898af8187e0cb6d89ed16b0620af00bdf60c26e99f433d99869780)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfOrientationSquare]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfOrientationSquare], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfOrientationSquare],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2418c779779950e9da894aa980ca0abd03cc459321b519b420175685623a71c8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationImQuery",
    jsii_struct_bases=[],
    name_mapping={
        "allowed_transformations": "allowedTransformations",
        "query_var": "queryVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationImQuery:
    def __init__(
        self,
        *,
        allowed_transformations: typing.Sequence[builtins.str],
        query_var: builtins.str,
    ) -> None:
        '''
        :param allowed_transformations: Specifies the transformations that can be applied using the query string parameter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allowed_transformations DataAkamaiImagingPolicyImage#allowed_transformations}
        :param query_var: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#query_var DataAkamaiImagingPolicyImage#query_var}.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b343094396601428252a7ad9d7dfc7c44cfb3b787bb69cc86ab75045824e4de6)
            check_type(argname="argument allowed_transformations", value=allowed_transformations, expected_type=type_hints["allowed_transformations"])
            check_type(argname="argument query_var", value=query_var, expected_type=type_hints["query_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "allowed_transformations": allowed_transformations,
            "query_var": query_var,
        }

    @builtins.property
    def allowed_transformations(self) -> typing.List[builtins.str]:
        '''Specifies the transformations that can be applied using the query string parameter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allowed_transformations DataAkamaiImagingPolicyImage#allowed_transformations}
        '''
        result = self._values.get("allowed_transformations")
        assert result is not None, "Required property 'allowed_transformations' is missing"
        return typing.cast(typing.List[builtins.str], result)

    @builtins.property
    def query_var(self) -> builtins.str:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#query_var DataAkamaiImagingPolicyImage#query_var}.'''
        result = self._values.get("query_var")
        assert result is not None, "Required property 'query_var' is missing"
        return typing.cast(builtins.str, result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationImQuery(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationImQueryList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationImQueryList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__88fcfd48e6ae5f8df70558b7b406ed0a67750aeb1d96ce1f2687933943c12744)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationImQueryOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ee315addb1dad35da76f04336ba2e7121326605cd4aa952853033362943210c6)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationImQueryOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__893b7e897b09fd887cc6f2f82345d1fa84a7d95a04e0db603e94f086019a8eeb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bf00a59c1aa6682a838bdca2e500b9fa5057d44797f91c3e604dc6102e4aca38)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f2a1e5435a9e8d5930998a02222f9162144a0efeaeed758390716b41eb32796a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationImQuery]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationImQuery]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationImQuery]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ec64055aa371c7fee3fecfb7d06b5b8ff52bfa6b8ac8a7be5ebb95482c57151)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationImQueryOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationImQueryOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5d61ab8d8dea5093db7a19ed537cdf48ff4619e64269458aee8c83a8bbf5c993)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @builtins.property
    @jsii.member(jsii_name="allowedTransformationsInput")
    def allowed_transformations_input(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "allowedTransformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="queryVarInput")
    def query_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "queryVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowedTransformations")
    def allowed_transformations(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "allowedTransformations"))

    @allowed_transformations.setter
    def allowed_transformations(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5e4b67bbd635277ea4264b45ae0adb310772a1feb561cc9cc3ff27276216e210)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowedTransformations", value)

    @builtins.property
    @jsii.member(jsii_name="queryVar")
    def query_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "queryVar"))

    @query_var.setter
    def query_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8d6bd734357c62616f8b5c2a556f1899182b3d6b3e4be01f247dc132a50298bf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "queryVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationImQuery]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationImQuery]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationImQuery]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d90d73994bbaf09ae4402a182e2dccdfcb8d0d8246c636afb328cd3ec837ad2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationMaxColors",
    jsii_struct_bases=[],
    name_mapping={"colors": "colors", "colors_var": "colorsVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationMaxColors:
    def __init__(
        self,
        *,
        colors: typing.Optional[builtins.str] = None,
        colors_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param colors: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        :param colors_var: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d4c556a65e3473cdb88e81ff52f2c96d0ed108ce03d1c6789226472519ce9190)
            check_type(argname="argument colors", value=colors, expected_type=type_hints["colors"])
            check_type(argname="argument colors_var", value=colors_var, expected_type=type_hints["colors_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if colors is not None:
            self._values["colors"] = colors
        if colors_var is not None:
            self._values["colors_var"] = colors_var

    @builtins.property
    def colors(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        '''
        result = self._values.get("colors")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def colors_var(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        result = self._values.get("colors_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationMaxColors(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationMaxColorsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationMaxColorsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c9dc47b757b8529184fd5ca6bd9de31fe897ae565de28efb1c0af299992517a9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationMaxColorsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__675403a9b827dc36e09e8efd8822779a68a6a5853e7d8b0f8a1d6b740a20277d)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationMaxColorsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3fd59b2307fc9aa1ce3e0a0144f88a2ce27a942da0b9c55f61b1d53ee2602838)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__33b1e3fea93e3d1415e4d8760b0354a9a67e4efb12adab5f3e89a2a83af9c9d7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__768ba7079e1b0ff7f1732d275b5a2f75a632d1cde2407854a45c510b06550169)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationMaxColors]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationMaxColors]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cfbe7e4a50b51ba6b60af96d91eac6f7df534686d94603ffed1493718e48d440)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationMaxColorsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationMaxColorsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__def7d9651d90f2f1812b1b6d9d2ad1a9bcf7da8eeb5265380e2c95088ea180f0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColors")
    def reset_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColors", []))

    @jsii.member(jsii_name="resetColorsVar")
    def reset_colors_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorsVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorsInput")
    def colors_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsInput"))

    @builtins.property
    @jsii.member(jsii_name="colorsVarInput")
    def colors_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsVarInput"))

    @builtins.property
    @jsii.member(jsii_name="colors")
    def colors(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colors"))

    @colors.setter
    def colors(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dc830786d3ba55b73a822c8046ce1dc76980e1d303fcdd5429f8732b5960ec65)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colors", value)

    @builtins.property
    @jsii.member(jsii_name="colorsVar")
    def colors_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorsVar"))

    @colors_var.setter
    def colors_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f90abd5fb69721aae17a671cb2eb2d40b5eff88839bb1320c5c657842066296)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorsVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationMaxColors]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationMaxColors]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationMaxColors]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6a5b10e3bccf387236f0669b870400cff5cecbf15a68bfc6e1ffb591768d8b72)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationMirror",
    jsii_struct_bases=[],
    name_mapping={
        "horizontal": "horizontal",
        "horizontal_var": "horizontalVar",
        "vertical": "vertical",
        "vertical_var": "verticalVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationMirror:
    def __init__(
        self,
        *,
        horizontal: typing.Optional[builtins.str] = None,
        horizontal_var: typing.Optional[builtins.str] = None,
        vertical: typing.Optional[builtins.str] = None,
        vertical_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param horizontal: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        :param horizontal_var: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        :param vertical: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        :param vertical_var: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a7eabea1f0a7b9e445b86087fb5f11f5d667a47aed0e9e393b5d2652790d678)
            check_type(argname="argument horizontal", value=horizontal, expected_type=type_hints["horizontal"])
            check_type(argname="argument horizontal_var", value=horizontal_var, expected_type=type_hints["horizontal_var"])
            check_type(argname="argument vertical", value=vertical, expected_type=type_hints["vertical"])
            check_type(argname="argument vertical_var", value=vertical_var, expected_type=type_hints["vertical_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if horizontal is not None:
            self._values["horizontal"] = horizontal
        if horizontal_var is not None:
            self._values["horizontal_var"] = horizontal_var
        if vertical is not None:
            self._values["vertical"] = vertical
        if vertical_var is not None:
            self._values["vertical_var"] = vertical_var

    @builtins.property
    def horizontal(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        '''
        result = self._values.get("horizontal")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def horizontal_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        '''
        result = self._values.get("horizontal_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        '''
        result = self._values.get("vertical")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        result = self._values.get("vertical_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationMirror(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationMirrorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationMirrorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__307914cd08901bee0e8717647e138b33e71ed32e07369ba0d8993ec170695f1b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationMirrorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__31ce77019106616019dde438a8ac0353ee7e16bd0baaec433b40221d6f6e38b2)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationMirrorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5e8e5d4be0bd9bfa081211270d28a872ef46a6264f93fbda1d7de14b7b233dd5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__37076df538a2e848fcc24aaff98c875d56297d18a53dcebd932ba0cf809cb9dc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__80c7ebf03463386737efac2c29b294b9e63e09cdf47bb8b60f2def5aaab941c0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationMirror]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationMirror]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__09c962baf203dc8a943e71e485591031c4b236123fee5fcee7296fca259a8e28)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationMirrorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationMirrorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__97c8b0c3e27fc3ddbf4eabf84324e7e3a704de19798702892baa2cdec119b96c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHorizontal")
    def reset_horizontal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontal", []))

    @jsii.member(jsii_name="resetHorizontalVar")
    def reset_horizontal_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontalVar", []))

    @jsii.member(jsii_name="resetVertical")
    def reset_vertical(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVertical", []))

    @jsii.member(jsii_name="resetVerticalVar")
    def reset_vertical_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVerticalVar", []))

    @builtins.property
    @jsii.member(jsii_name="horizontalInput")
    def horizontal_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontalVarInput")
    def horizontal_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalInput")
    def vertical_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalVarInput")
    def vertical_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontal")
    def horizontal(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontal"))

    @horizontal.setter
    def horizontal(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ddc164d7655a13dc10693a7b943e9b636e981f9bb7aa3f0698701b1f179ae01)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontal", value)

    @builtins.property
    @jsii.member(jsii_name="horizontalVar")
    def horizontal_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontalVar"))

    @horizontal_var.setter
    def horizontal_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5d8b1b0c3684738b5a381b09fa658e404c8d1a375312281174806144b7debaf4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontalVar", value)

    @builtins.property
    @jsii.member(jsii_name="vertical")
    def vertical(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "vertical"))

    @vertical.setter
    def vertical(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8b111d000b55dafb61b2527badf94d078b66945fde5b8fdff8878e46b4553e98)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "vertical", value)

    @builtins.property
    @jsii.member(jsii_name="verticalVar")
    def vertical_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "verticalVar"))

    @vertical_var.setter
    def vertical_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__296d38adb8d2968dc0859a0a5d641b4bc0736cdf76f1ab4a179d39b768e579c5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "verticalVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationMirror]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationMirror]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationMirror]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__931ac24ffbf75f15ce3ff3003d22eebf97ce8879f3e1ab2cee44468280f164a4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationMonoHue",
    jsii_struct_bases=[],
    name_mapping={"hue": "hue", "hue_var": "hueVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationMonoHue:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8605871df816bd29ec9a54881737aa2bc81dc0ccffe4b691408c6b5e0d6c409f)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationMonoHue(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationMonoHueList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationMonoHueList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0e91940dc6a18a17779976984a8b146c63a1c05a0d34f9a1c889e76de583c433)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationMonoHueOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__33dfc037cd4bcef062d2c30bf71d0c098c27d744a5f2ef9f0ebe52ddb0c30135)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationMonoHueOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9248dcd6259eb3348454913df554ec82c9eb9dc378c79568471ad8016b05c5fc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df66903d64771caf1d772a91de0ccd6bfa6e3171db2e20cf857b2403e6ab8019)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__91db1090bb5d53b253a0a2e38d010e1dc402c3be6fa17ac499fe6e5ba25f25c1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationMonoHue]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationMonoHue]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__31738d8e5a0776325b200289a2f5cd9df39b1486741c350cdc057d4a5479b29f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationMonoHueOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationMonoHueOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__381ab0065a24a2a75f998f1c6df4f2349f04101fd7313cfd25dd1985f197f36f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea81452e823439d2e52a768d8e2e94d19132f27f7118e81b741a62539048449e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dc7621a630a886ff256105fefc77fbc8fa23da93e7276ad354adc3a7b293e418)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationMonoHue]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationMonoHue]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationMonoHue]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3af49f9fc3b315ad4939c037a91d76cf857aa7b57182d140efddca951ed029ab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationOpacity",
    jsii_struct_bases=[],
    name_mapping={"opacity": "opacity", "opacity_var": "opacityVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationOpacity:
    def __init__(
        self,
        *,
        opacity: typing.Optional[builtins.str] = None,
        opacity_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param opacity: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param opacity_var: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__277faa6df91610b0dbbfaa133cfe4e38de2b6780c04ec459472cd7b3f5bb51c9)
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument opacity_var", value=opacity_var, expected_type=type_hints["opacity_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if opacity is not None:
            self._values["opacity"] = opacity
        if opacity_var is not None:
            self._values["opacity_var"] = opacity_var

    @builtins.property
    def opacity(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def opacity_var(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        result = self._values.get("opacity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationOpacity(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationOpacityList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationOpacityList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2eb38f667bbd367c53bd60c88bcc8ef33713ace7082b4108292a525f66141059)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationOpacityOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1c67dbf1f17fbd0c84de159766c6071a2185cb8431ae2afd88627c4b3f3b7c8d)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationOpacityOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f8f91c25880de6443b2dcc0c89bf1f000dce009050783cd15ddd8146f197c384)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a8bdd8d3dc7312db08ff1f3eba69b2edd430f30412413e829891df0714bc555)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3621a1c90cd68a484cf453c1a4afafaa979496a963b3a29925dd8acda24d9d86)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationOpacity]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationOpacity]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__10aa0debc5a44c64faa6511a9434a5103d29d67460543f46752fed5e85176ee1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationOpacityOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationOpacityOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bd39d1777c1be5680931fb2f88a69e21c8e20569fb3944db2b130a54067bc590)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetOpacityVar")
    def reset_opacity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacityVar", []))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityVarInput")
    def opacity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacity"))

    @opacity.setter
    def opacity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e5f65794a86fac0713d5b2d3edbcfc0ea598f0a3892f38631d924486185cd508)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacity", value)

    @builtins.property
    @jsii.member(jsii_name="opacityVar")
    def opacity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacityVar"))

    @opacity_var.setter
    def opacity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d961729ff4b15b7ab92456f60ab785474897deac36dba0763f8dd095156e750)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacityVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationOpacity]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationOpacity]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationOpacity]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__26a61bd34d6380aa58ff0c805f113d697a2e30e60353d2965af0802ad6168a58)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__27462e703ab0ab4613d60ad8e1f6740ffed5ba6477c194aaeae8099a6f6b00da)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putAppend")
    def put_append(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationAppend, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__33e361dec3988eebb70803bbdda25d4a663b2c5a6d9096edc819f048850e686a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putAppend", [value]))

    @jsii.member(jsii_name="putAspectCrop")
    def put_aspect_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationAspectCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__da4d8575c396825dde9bb3a004f76e7349570a166ad04f2fa0c4463ff4802705)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putAspectCrop", [value]))

    @jsii.member(jsii_name="putBackgroundColor")
    def put_background_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3e0ec9b10621cfdb93385439869c6b9de9b86d66f92546e4a90ce4732e3c956a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBackgroundColor", [value]))

    @jsii.member(jsii_name="putBlur")
    def put_blur(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationBlur, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e4793e2b0e9db5c2073b853fad4acdd7d4d1106f202cf9bc01a0a020831d9689)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBlur", [value]))

    @jsii.member(jsii_name="putChromaKey")
    def put_chroma_key(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationChromaKey, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a6d589443aecdceae9e5aa22640242511649f17982def159712a2b37bc2a6cd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putChromaKey", [value]))

    @jsii.member(jsii_name="putComposite")
    def put_composite(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationComposite, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5e9e50324636ac31a1c79ee9ab6004bfecc55d8ea801beb6a4939c5540e0241b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putComposite", [value]))

    @jsii.member(jsii_name="putCompound")
    def put_compound(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationCompound, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ef638457e632dc3ee8e8635c066ab57d52f162deb9597f4207a3395dd484a25)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCompound", [value]))

    @jsii.member(jsii_name="putContrast")
    def put_contrast(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationContrast, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__649b1e38252630edeb0dfc3d84ac271fc932380abef3f4a6d8666463fe23b76d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putContrast", [value]))

    @jsii.member(jsii_name="putCrop")
    def put_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__72db974f3523ad0675f6ffeaf8749f14ba2b8c5c37d4235cfa78bb9fab874371)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCrop", [value]))

    @jsii.member(jsii_name="putFaceCrop")
    def put_face_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationFaceCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__938be56c2193bb269ee75c68d96c241e187bcda6b68eff2e379d0f30914608d5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFaceCrop", [value]))

    @jsii.member(jsii_name="putFeatureCrop")
    def put_feature_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationFeatureCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__06200438acacf915c7fe8e648f9f024cefb2ed2f9587dc63a6f53bb852cfc3c0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFeatureCrop", [value]))

    @jsii.member(jsii_name="putFitAndFill")
    def put_fit_and_fill(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationFitAndFill, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d2105883f50aaf397400bd5af5e607ddd83c98618ed2ae5584994dcee71eef92)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFitAndFill", [value]))

    @jsii.member(jsii_name="putGoop")
    def put_goop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationGoop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6ac5edc55bf615e71fda5b8353ff53d3c3862ab12c7f23fe3262eb6b04588a1f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGoop", [value]))

    @jsii.member(jsii_name="putGrayscale")
    def put_grayscale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationGrayscale, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0442cd7b143c92b627d9e7b8d7714f0fd7d4045fdfc67a7a2656285bd75f0f49)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGrayscale", [value]))

    @jsii.member(jsii_name="putHsl")
    def put_hsl(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationHsl, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b1a7b10b885868d48b68d89a9630224c4928cc1872f8df6733878445daed843d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsl", [value]))

    @jsii.member(jsii_name="putHsv")
    def put_hsv(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationHsv, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__20d8985d54ec2b9d6ce1884c951135a18ad0e631684bd17ce0730bc4a8b0dc6d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsv", [value]))

    @jsii.member(jsii_name="putIfDimension")
    def put_if_dimension(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfDimension, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__167399258dedb2a107342151da1bd7f650aa737ce09f39d3f58966349fce7223)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfDimension", [value]))

    @jsii.member(jsii_name="putIfOrientation")
    def put_if_orientation(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d2abc3867ae859c65349ba00b26e5de148ce0148cb61601456fe43b4595e5717)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfOrientation", [value]))

    @jsii.member(jsii_name="putImQuery")
    def put_im_query(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationImQuery, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e92148be23510f3f08dda7b1636bf402da44e2c5c25aa229041bcbb75daaa979)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putImQuery", [value]))

    @jsii.member(jsii_name="putMaxColors")
    def put_max_colors(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationMaxColors, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e7cc3946728ba0827e1fccaf714dfb51c6a019f5a4f3096123cc8358452fe073)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMaxColors", [value]))

    @jsii.member(jsii_name="putMirror")
    def put_mirror(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationMirror, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7b8ad4a764a6c24c962c8cba608b03b1d6b520929e0a57ea9ab2db63ebc39ef4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMirror", [value]))

    @jsii.member(jsii_name="putMonoHue")
    def put_mono_hue(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationMonoHue, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5bbed7684ac204c676809adb59cc6183da88b71240a620977e331be01d1b24f6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMonoHue", [value]))

    @jsii.member(jsii_name="putOpacity")
    def put_opacity(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationOpacity, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0eb11c047addfd0838f1bc0d41e1d2970868ab0fe2eaf8595a1762edd032afde)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putOpacity", [value]))

    @jsii.member(jsii_name="putRegionOfInterestCrop")
    def put_region_of_interest_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationRegionOfInterestCrop", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8f9a9dc96b47ad0ef854dcb507998a04247f6a1557df571d9895241c2c937c7d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRegionOfInterestCrop", [value]))

    @jsii.member(jsii_name="putRelativeCrop")
    def put_relative_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationRelativeCrop", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2151977ca24f336d2ef84e8e6b07f9bf643eb819ef2d05fe65b0fe6a4400979d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRelativeCrop", [value]))

    @jsii.member(jsii_name="putRemoveColor")
    def put_remove_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationRemoveColor", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fc44d4fd1099eb97b315868e1d5f697a87669e257e86302c0a4286a664c13aec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRemoveColor", [value]))

    @jsii.member(jsii_name="putResize")
    def put_resize(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationResize", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__115f17c6cf2ebba7eed714664e4648226453ed26c4662a544695c3a5fee2290c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putResize", [value]))

    @jsii.member(jsii_name="putRotate")
    def put_rotate(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationRotate", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cb26f120a55cebb66f4a591bf64240d5b4ea905190a24a3d558c5acba64dc510)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRotate", [value]))

    @jsii.member(jsii_name="putScale")
    def put_scale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationScale", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af3820c4a44ae69603aa0f384fb301cef42aeb6dfb0ab4327eb7a30229f14be5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putScale", [value]))

    @jsii.member(jsii_name="putShear")
    def put_shear(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationShear", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a034540779bd13e7247ceeeb5eefbc84700028a81f0bc50c88306f298dcea4b7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putShear", [value]))

    @jsii.member(jsii_name="putTrim")
    def put_trim(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationTrim", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__85683d73f3cf4447dd5420da946ec72b9bd6f13d4806fea0a7119a7ab73a6b2d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTrim", [value]))

    @jsii.member(jsii_name="putUnsharpMask")
    def put_unsharp_mask(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationUnsharpMask", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f1e853d212d175852bda7d4c2fb8e4e55ddbf527b81c282d00e22686e8313620)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putUnsharpMask", [value]))

    @jsii.member(jsii_name="resetAppend")
    def reset_append(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAppend", []))

    @jsii.member(jsii_name="resetAspectCrop")
    def reset_aspect_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspectCrop", []))

    @jsii.member(jsii_name="resetBackgroundColor")
    def reset_background_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBackgroundColor", []))

    @jsii.member(jsii_name="resetBlur")
    def reset_blur(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBlur", []))

    @jsii.member(jsii_name="resetChromaKey")
    def reset_chroma_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChromaKey", []))

    @jsii.member(jsii_name="resetComposite")
    def reset_composite(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetComposite", []))

    @jsii.member(jsii_name="resetCompound")
    def reset_compound(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCompound", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetCrop")
    def reset_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCrop", []))

    @jsii.member(jsii_name="resetFaceCrop")
    def reset_face_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFaceCrop", []))

    @jsii.member(jsii_name="resetFeatureCrop")
    def reset_feature_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureCrop", []))

    @jsii.member(jsii_name="resetFitAndFill")
    def reset_fit_and_fill(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFitAndFill", []))

    @jsii.member(jsii_name="resetGoop")
    def reset_goop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGoop", []))

    @jsii.member(jsii_name="resetGrayscale")
    def reset_grayscale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGrayscale", []))

    @jsii.member(jsii_name="resetHsl")
    def reset_hsl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsl", []))

    @jsii.member(jsii_name="resetHsv")
    def reset_hsv(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsv", []))

    @jsii.member(jsii_name="resetIfDimension")
    def reset_if_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfDimension", []))

    @jsii.member(jsii_name="resetIfOrientation")
    def reset_if_orientation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfOrientation", []))

    @jsii.member(jsii_name="resetImQuery")
    def reset_im_query(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetImQuery", []))

    @jsii.member(jsii_name="resetMaxColors")
    def reset_max_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxColors", []))

    @jsii.member(jsii_name="resetMirror")
    def reset_mirror(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMirror", []))

    @jsii.member(jsii_name="resetMonoHue")
    def reset_mono_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonoHue", []))

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetRegionOfInterestCrop")
    def reset_region_of_interest_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRegionOfInterestCrop", []))

    @jsii.member(jsii_name="resetRelativeCrop")
    def reset_relative_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRelativeCrop", []))

    @jsii.member(jsii_name="resetRemoveColor")
    def reset_remove_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRemoveColor", []))

    @jsii.member(jsii_name="resetResize")
    def reset_resize(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetResize", []))

    @jsii.member(jsii_name="resetRotate")
    def reset_rotate(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRotate", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetShear")
    def reset_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetShear", []))

    @jsii.member(jsii_name="resetTrim")
    def reset_trim(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTrim", []))

    @jsii.member(jsii_name="resetUnsharpMask")
    def reset_unsharp_mask(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUnsharpMask", []))

    @builtins.property
    @jsii.member(jsii_name="append")
    def append(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationAppendList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationAppendList, jsii.get(self, "append"))

    @builtins.property
    @jsii.member(jsii_name="aspectCrop")
    def aspect_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationAspectCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationAspectCropList, jsii.get(self, "aspectCrop"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColor")
    def background_color(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationBackgroundColorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationBackgroundColorList, jsii.get(self, "backgroundColor"))

    @builtins.property
    @jsii.member(jsii_name="blur")
    def blur(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationBlurList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationBlurList, jsii.get(self, "blur"))

    @builtins.property
    @jsii.member(jsii_name="chromaKey")
    def chroma_key(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationChromaKeyList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationChromaKeyList, jsii.get(self, "chromaKey"))

    @builtins.property
    @jsii.member(jsii_name="composite")
    def composite(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationCompositeList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationCompositeList, jsii.get(self, "composite"))

    @builtins.property
    @jsii.member(jsii_name="compound")
    def compound(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationCompoundList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationCompoundList, jsii.get(self, "compound"))

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationContrastList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationContrastList, jsii.get(self, "contrast"))

    @builtins.property
    @jsii.member(jsii_name="crop")
    def crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationCropList, jsii.get(self, "crop"))

    @builtins.property
    @jsii.member(jsii_name="faceCrop")
    def face_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationFaceCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationFaceCropList, jsii.get(self, "faceCrop"))

    @builtins.property
    @jsii.member(jsii_name="featureCrop")
    def feature_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationFeatureCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationFeatureCropList, jsii.get(self, "featureCrop"))

    @builtins.property
    @jsii.member(jsii_name="fitAndFill")
    def fit_and_fill(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationFitAndFillList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationFitAndFillList, jsii.get(self, "fitAndFill"))

    @builtins.property
    @jsii.member(jsii_name="goop")
    def goop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationGoopList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationGoopList, jsii.get(self, "goop"))

    @builtins.property
    @jsii.member(jsii_name="grayscale")
    def grayscale(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationGrayscaleList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationGrayscaleList, jsii.get(self, "grayscale"))

    @builtins.property
    @jsii.member(jsii_name="hsl")
    def hsl(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationHslList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationHslList, jsii.get(self, "hsl"))

    @builtins.property
    @jsii.member(jsii_name="hsv")
    def hsv(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationHsvList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationHsvList, jsii.get(self, "hsv"))

    @builtins.property
    @jsii.member(jsii_name="ifDimension")
    def if_dimension(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfDimensionList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfDimensionList, jsii.get(self, "ifDimension"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientation")
    def if_orientation(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfOrientationList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfOrientationList, jsii.get(self, "ifOrientation"))

    @builtins.property
    @jsii.member(jsii_name="imQuery")
    def im_query(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationImQueryList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationImQueryList, jsii.get(self, "imQuery"))

    @builtins.property
    @jsii.member(jsii_name="maxColors")
    def max_colors(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationMaxColorsList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationMaxColorsList, jsii.get(self, "maxColors"))

    @builtins.property
    @jsii.member(jsii_name="mirror")
    def mirror(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationMirrorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationMirrorList, jsii.get(self, "mirror"))

    @builtins.property
    @jsii.member(jsii_name="monoHue")
    def mono_hue(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationMonoHueList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationMonoHueList, jsii.get(self, "monoHue"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationOpacityList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationOpacityList, jsii.get(self, "opacity"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestCrop")
    def region_of_interest_crop(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationRegionOfInterestCropList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationRegionOfInterestCropList", jsii.get(self, "regionOfInterestCrop"))

    @builtins.property
    @jsii.member(jsii_name="relativeCrop")
    def relative_crop(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationRelativeCropList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationRelativeCropList", jsii.get(self, "relativeCrop"))

    @builtins.property
    @jsii.member(jsii_name="removeColor")
    def remove_color(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationRemoveColorList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationRemoveColorList", jsii.get(self, "removeColor"))

    @builtins.property
    @jsii.member(jsii_name="resize")
    def resize(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationResizeList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationResizeList", jsii.get(self, "resize"))

    @builtins.property
    @jsii.member(jsii_name="rotate")
    def rotate(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationRotateList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationRotateList", jsii.get(self, "rotate"))

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationScaleList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationScaleList", jsii.get(self, "scale"))

    @builtins.property
    @jsii.member(jsii_name="shear")
    def shear(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationShearList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationShearList", jsii.get(self, "shear"))

    @builtins.property
    @jsii.member(jsii_name="trim")
    def trim(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationTrimList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationTrimList", jsii.get(self, "trim"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMask")
    def unsharp_mask(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationUnsharpMaskList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationUnsharpMaskList", jsii.get(self, "unsharpMask"))

    @builtins.property
    @jsii.member(jsii_name="appendInput")
    def append_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationAppend]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationAppend]]], jsii.get(self, "appendInput"))

    @builtins.property
    @jsii.member(jsii_name="aspectCropInput")
    def aspect_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationAspectCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationAspectCrop]]], jsii.get(self, "aspectCropInput"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColorInput")
    def background_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationBackgroundColor]]], jsii.get(self, "backgroundColorInput"))

    @builtins.property
    @jsii.member(jsii_name="blurInput")
    def blur_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationBlur]]], jsii.get(self, "blurInput"))

    @builtins.property
    @jsii.member(jsii_name="chromaKeyInput")
    def chroma_key_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationChromaKey]]], jsii.get(self, "chromaKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="compositeInput")
    def composite_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationComposite]]], jsii.get(self, "compositeInput"))

    @builtins.property
    @jsii.member(jsii_name="compoundInput")
    def compound_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationCompound]]], jsii.get(self, "compoundInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationContrast]]], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="cropInput")
    def crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationCrop]]], jsii.get(self, "cropInput"))

    @builtins.property
    @jsii.member(jsii_name="faceCropInput")
    def face_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationFaceCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationFaceCrop]]], jsii.get(self, "faceCropInput"))

    @builtins.property
    @jsii.member(jsii_name="featureCropInput")
    def feature_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationFeatureCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationFeatureCrop]]], jsii.get(self, "featureCropInput"))

    @builtins.property
    @jsii.member(jsii_name="fitAndFillInput")
    def fit_and_fill_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationFitAndFill]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationFitAndFill]]], jsii.get(self, "fitAndFillInput"))

    @builtins.property
    @jsii.member(jsii_name="goopInput")
    def goop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationGoop]]], jsii.get(self, "goopInput"))

    @builtins.property
    @jsii.member(jsii_name="grayscaleInput")
    def grayscale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationGrayscale]]], jsii.get(self, "grayscaleInput"))

    @builtins.property
    @jsii.member(jsii_name="hslInput")
    def hsl_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationHsl]]], jsii.get(self, "hslInput"))

    @builtins.property
    @jsii.member(jsii_name="hsvInput")
    def hsv_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationHsv]]], jsii.get(self, "hsvInput"))

    @builtins.property
    @jsii.member(jsii_name="ifDimensionInput")
    def if_dimension_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfDimension]]], jsii.get(self, "ifDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientationInput")
    def if_orientation_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfOrientation]]], jsii.get(self, "ifOrientationInput"))

    @builtins.property
    @jsii.member(jsii_name="imQueryInput")
    def im_query_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationImQuery]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationImQuery]]], jsii.get(self, "imQueryInput"))

    @builtins.property
    @jsii.member(jsii_name="maxColorsInput")
    def max_colors_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationMaxColors]]], jsii.get(self, "maxColorsInput"))

    @builtins.property
    @jsii.member(jsii_name="mirrorInput")
    def mirror_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationMirror]]], jsii.get(self, "mirrorInput"))

    @builtins.property
    @jsii.member(jsii_name="monoHueInput")
    def mono_hue_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationMonoHue]]], jsii.get(self, "monoHueInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationOpacity]]], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestCropInput")
    def region_of_interest_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationRegionOfInterestCrop"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationRegionOfInterestCrop"]]], jsii.get(self, "regionOfInterestCropInput"))

    @builtins.property
    @jsii.member(jsii_name="relativeCropInput")
    def relative_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationRelativeCrop"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationRelativeCrop"]]], jsii.get(self, "relativeCropInput"))

    @builtins.property
    @jsii.member(jsii_name="removeColorInput")
    def remove_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationRemoveColor"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationRemoveColor"]]], jsii.get(self, "removeColorInput"))

    @builtins.property
    @jsii.member(jsii_name="resizeInput")
    def resize_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationResize"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationResize"]]], jsii.get(self, "resizeInput"))

    @builtins.property
    @jsii.member(jsii_name="rotateInput")
    def rotate_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationRotate"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationRotate"]]], jsii.get(self, "rotateInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationScale"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationScale"]]], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="shearInput")
    def shear_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationShear"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationShear"]]], jsii.get(self, "shearInput"))

    @builtins.property
    @jsii.member(jsii_name="trimInput")
    def trim_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationTrim"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationTrim"]]], jsii.get(self, "trimInput"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMaskInput")
    def unsharp_mask_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationUnsharpMask"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationUnsharpMask"]]], jsii.get(self, "unsharpMaskInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ec53f222e9283fdff22ce70ed25ea8850f8dfc5dc9ee71fd2f170dbc6177c6e3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationRegionOfInterestCrop",
    jsii_struct_bases=[],
    name_mapping={
        "region_of_interest": "regionOfInterest",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationRegionOfInterestCrop:
    def __init__(
        self,
        *,
        region_of_interest: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationRegionOfInterestCropRegionOfInterest", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param region_of_interest: region_of_interest block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest DataAkamaiImagingPolicyImage#region_of_interest}
        :param gravity: The placement of the crop area relative to the specified area of interest. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: The placement of the crop area relative to the specified area of interest. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param style: Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(region_of_interest, dict):
            region_of_interest = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationRegionOfInterestCropRegionOfInterest(**region_of_interest)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d327e677669da33445fd903814bdd3530cc7c19de1f489d7b1669929388f45bb)
            check_type(argname="argument region_of_interest", value=region_of_interest, expected_type=type_hints["region_of_interest"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "region_of_interest": region_of_interest,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def region_of_interest(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationRegionOfInterestCropRegionOfInterest":
        '''region_of_interest block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest DataAkamaiImagingPolicyImage#region_of_interest}
        '''
        result = self._values.get("region_of_interest")
        assert result is not None, "Required property 'region_of_interest' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationRegionOfInterestCropRegionOfInterest", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''The placement of the crop area relative to the specified area of interest.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''The placement of the crop area relative to the specified area of interest.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationRegionOfInterestCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationRegionOfInterestCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationRegionOfInterestCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1cd2aadc244eaed3617ebd4f3949de4d41aa2820e6d09954b35bf1c786291f4b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationRegionOfInterestCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f3cd958517ee7ac36475d13ec2c34b4c555fb7fb51c16037e50124c7bd5ed932)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationRegionOfInterestCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__188b76b799a332721dd2fb615fea7b636721f72cd50c0d94cd9c2ee0a2567c4c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d73b307c0bb31f1ed933f8b09fb2aef379356eaba746d805bdfdcd471f538b7a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7b1cb5eb00c051781e10f017b9004ebc0a121997b96eed41bdcdc8350871ee19)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationRegionOfInterestCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationRegionOfInterestCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationRegionOfInterestCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af907a8ddaf001336fa47aa3ea53fa2644a9f057ce9fc99564872a2059852560)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationRegionOfInterestCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationRegionOfInterestCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b0dfbabe22b5342defab95f5399f8d3e386e9462b400598abb8731979dc38d88)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putRegionOfInterest")
    def put_region_of_interest(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationRegionOfInterestCropRegionOfInterest()

        return typing.cast(None, jsii.invoke(self, "putRegionOfInterest", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterest")
    def region_of_interest(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestOutputReference", jsii.get(self, "regionOfInterest"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestInput")
    def region_of_interest_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationRegionOfInterestCropRegionOfInterest"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationRegionOfInterestCropRegionOfInterest"], jsii.get(self, "regionOfInterestInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c7c653c949b9619cb1aafe57035309772a666a8c832a12539e90cf6096e5d55e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2e0dfe1652f25b260907aa08091ed7ecaca3dcae3ff95111b88184f43ba7f84a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__278812f0b526b2e9948ba1413f7112847ee62e2beaee9d3123989eb3e34cfc13)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dcf27b0a71da71ffd153ffd0f59215d82fccc7ed18ad84234564ec334f50f987)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5a766c6b02589c769695c77a10dbf09f20b7e84f4ebf06c5d0fd2b798552206d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__13a569f19bfd9483b114d1843087c654fe97b8e498aa7ab0cec97726b50ff05f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b0611bdd0eba39bc8167567a8a56965a850a2173e83486a7b735f1460e2d397f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b70715ed83d03101c1c25e5f19c137aa0a1fa945fba15ed1baea56691cf799d3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationRegionOfInterestCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationRegionOfInterestCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationRegionOfInterestCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fbd97e4d0c475a730c9cf868201a72466fdd514cbebd002546bf56d624109d6e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationRegionOfInterestCropRegionOfInterest",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationRegionOfInterestCropRegionOfInterest:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationRegionOfInterestCropRegionOfInterest(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c3ae7a91cbd0b429be0b320e14dbd9981e34491e9f92439fc18f39d867c77341)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationRegionOfInterestCropRegionOfInterest]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationRegionOfInterestCropRegionOfInterest], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationRegionOfInterestCropRegionOfInterest],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1228c95db08234419caeb2bd3c262cfb7eee243f5001d428e7f3a1260b5aa6db)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationRelativeCrop",
    jsii_struct_bases=[],
    name_mapping={
        "east": "east",
        "east_var": "eastVar",
        "north": "north",
        "north_var": "northVar",
        "south": "south",
        "south_var": "southVar",
        "west": "west",
        "west_var": "westVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationRelativeCrop:
    def __init__(
        self,
        *,
        east: typing.Optional[builtins.str] = None,
        east_var: typing.Optional[builtins.str] = None,
        north: typing.Optional[builtins.str] = None,
        north_var: typing.Optional[builtins.str] = None,
        south: typing.Optional[builtins.str] = None,
        south_var: typing.Optional[builtins.str] = None,
        west: typing.Optional[builtins.str] = None,
        west_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param east: The number of pixels to shrink or expand the right side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east DataAkamaiImagingPolicyImage#east}
        :param east_var: The number of pixels to shrink or expand the right side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east_var DataAkamaiImagingPolicyImage#east_var}
        :param north: The number of pixels to shrink or expand the top side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north DataAkamaiImagingPolicyImage#north}
        :param north_var: The number of pixels to shrink or expand the top side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north_var DataAkamaiImagingPolicyImage#north_var}
        :param south: The number of pixels to shrink or expand the bottom side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south DataAkamaiImagingPolicyImage#south}
        :param south_var: The number of pixels to shrink or expand the bottom side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south_var DataAkamaiImagingPolicyImage#south_var}
        :param west: The number of pixels to shrink or expand the left side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west DataAkamaiImagingPolicyImage#west}
        :param west_var: The number of pixels to shrink or expand the left side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west_var DataAkamaiImagingPolicyImage#west_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1969d13fd64bbb8c022020a279b6725bc5cfc22403b079f5abc023d46ecb4ee7)
            check_type(argname="argument east", value=east, expected_type=type_hints["east"])
            check_type(argname="argument east_var", value=east_var, expected_type=type_hints["east_var"])
            check_type(argname="argument north", value=north, expected_type=type_hints["north"])
            check_type(argname="argument north_var", value=north_var, expected_type=type_hints["north_var"])
            check_type(argname="argument south", value=south, expected_type=type_hints["south"])
            check_type(argname="argument south_var", value=south_var, expected_type=type_hints["south_var"])
            check_type(argname="argument west", value=west, expected_type=type_hints["west"])
            check_type(argname="argument west_var", value=west_var, expected_type=type_hints["west_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if east is not None:
            self._values["east"] = east
        if east_var is not None:
            self._values["east_var"] = east_var
        if north is not None:
            self._values["north"] = north
        if north_var is not None:
            self._values["north_var"] = north_var
        if south is not None:
            self._values["south"] = south
        if south_var is not None:
            self._values["south_var"] = south_var
        if west is not None:
            self._values["west"] = west
        if west_var is not None:
            self._values["west_var"] = west_var

    @builtins.property
    def east(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the right side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east DataAkamaiImagingPolicyImage#east}
        '''
        result = self._values.get("east")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def east_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the right side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east_var DataAkamaiImagingPolicyImage#east_var}
        '''
        result = self._values.get("east_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def north(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the top side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north DataAkamaiImagingPolicyImage#north}
        '''
        result = self._values.get("north")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def north_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the top side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north_var DataAkamaiImagingPolicyImage#north_var}
        '''
        result = self._values.get("north_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def south(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the bottom side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south DataAkamaiImagingPolicyImage#south}
        '''
        result = self._values.get("south")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def south_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the bottom side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south_var DataAkamaiImagingPolicyImage#south_var}
        '''
        result = self._values.get("south_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def west(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the left side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west DataAkamaiImagingPolicyImage#west}
        '''
        result = self._values.get("west")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def west_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the left side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west_var DataAkamaiImagingPolicyImage#west_var}
        '''
        result = self._values.get("west_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationRelativeCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationRelativeCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationRelativeCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e886522b783aa45b9946c77053abe2799072bf70a334c30dc1997b7a04733d8d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationRelativeCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5108ca022433d7968e6ef8eead024d091a8540cdcce58640342a809d150b597e)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationRelativeCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cc93e0575c1c9028b3bdc9748b6c856141c51a5ffc6d6196922bab7df18b5ee2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ddd98d53a815d8da441e99aa44a18e0d9be45e7da422a001ca8c36c2bbad745d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__023169f419c9bb2e8a20e39848db0ec90895cfe7dffb41887f31b00922194bdc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationRelativeCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationRelativeCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationRelativeCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ff57d6b76a880d0d6724205e8b0736ebca20864e0dc1040ed6eb36fe2b80cc84)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationRelativeCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationRelativeCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d28557c3db6aa7bae47f84633b2c7fac2eabb091c272d0441ce3eae094d102cb)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetEast")
    def reset_east(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEast", []))

    @jsii.member(jsii_name="resetEastVar")
    def reset_east_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEastVar", []))

    @jsii.member(jsii_name="resetNorth")
    def reset_north(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNorth", []))

    @jsii.member(jsii_name="resetNorthVar")
    def reset_north_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNorthVar", []))

    @jsii.member(jsii_name="resetSouth")
    def reset_south(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSouth", []))

    @jsii.member(jsii_name="resetSouthVar")
    def reset_south_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSouthVar", []))

    @jsii.member(jsii_name="resetWest")
    def reset_west(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWest", []))

    @jsii.member(jsii_name="resetWestVar")
    def reset_west_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWestVar", []))

    @builtins.property
    @jsii.member(jsii_name="eastInput")
    def east_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "eastInput"))

    @builtins.property
    @jsii.member(jsii_name="eastVarInput")
    def east_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "eastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="northInput")
    def north_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "northInput"))

    @builtins.property
    @jsii.member(jsii_name="northVarInput")
    def north_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "northVarInput"))

    @builtins.property
    @jsii.member(jsii_name="southInput")
    def south_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "southInput"))

    @builtins.property
    @jsii.member(jsii_name="southVarInput")
    def south_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "southVarInput"))

    @builtins.property
    @jsii.member(jsii_name="westInput")
    def west_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "westInput"))

    @builtins.property
    @jsii.member(jsii_name="westVarInput")
    def west_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "westVarInput"))

    @builtins.property
    @jsii.member(jsii_name="east")
    def east(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "east"))

    @east.setter
    def east(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__989f0afd36746134caca1963bec889575550a2fd91f494c081d8016fd8dce411)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "east", value)

    @builtins.property
    @jsii.member(jsii_name="eastVar")
    def east_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "eastVar"))

    @east_var.setter
    def east_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__09a2b59059188c40e8dbc05af83cc9690db23702d2d03e78a21f592b2c23e4a8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "eastVar", value)

    @builtins.property
    @jsii.member(jsii_name="north")
    def north(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "north"))

    @north.setter
    def north(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e199b03626d79f34d4616d5b0c5abf0bc1756f742f60d79a44d9a2d6609bee0f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "north", value)

    @builtins.property
    @jsii.member(jsii_name="northVar")
    def north_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "northVar"))

    @north_var.setter
    def north_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e07c650a3c88e2c550137512384575897de0e58df952218ddaae96aa588a1de8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "northVar", value)

    @builtins.property
    @jsii.member(jsii_name="south")
    def south(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "south"))

    @south.setter
    def south(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f5ddd3c59ef0d39fcf3bfde70674acb9131e7ff4f732c02e8049b882f17dd841)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "south", value)

    @builtins.property
    @jsii.member(jsii_name="southVar")
    def south_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "southVar"))

    @south_var.setter
    def south_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__417cea497a67a37c4db062c6f78ae7e73b4249cb40433c5378480c64d59e2cdf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "southVar", value)

    @builtins.property
    @jsii.member(jsii_name="west")
    def west(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "west"))

    @west.setter
    def west(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__35c321541677974f603311c8c4228a329e199975d74d3a635525943104990541)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "west", value)

    @builtins.property
    @jsii.member(jsii_name="westVar")
    def west_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "westVar"))

    @west_var.setter
    def west_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e4fc0dd18462fcf440c3f19bbafa358367543c67fa5a14ec70e643eb60fbf058)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "westVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationRelativeCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationRelativeCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationRelativeCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a5908120ded42c19814ee5f5fbca974a587b645e862f6d27e2fadb7eca027684)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationRemoveColor",
    jsii_struct_bases=[],
    name_mapping={
        "color": "color",
        "color_var": "colorVar",
        "feather": "feather",
        "feather_var": "featherVar",
        "tolerance": "tolerance",
        "tolerance_var": "toleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationRemoveColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
        feather: typing.Optional[builtins.str] = None,
        feather_var: typing.Optional[builtins.str] = None,
        tolerance: typing.Optional[builtins.str] = None,
        tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        :param feather: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        :param feather_var: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        :param tolerance: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        :param tolerance_var: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ca52e19b662e814eacaced192ab98904bc97412f25cdea81f458b1561b9762d0)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
            check_type(argname="argument feather", value=feather, expected_type=type_hints["feather"])
            check_type(argname="argument feather_var", value=feather_var, expected_type=type_hints["feather_var"])
            check_type(argname="argument tolerance", value=tolerance, expected_type=type_hints["tolerance"])
            check_type(argname="argument tolerance_var", value=tolerance_var, expected_type=type_hints["tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var
        if feather is not None:
            self._values["feather"] = feather
        if feather_var is not None:
            self._values["feather_var"] = feather_var
        if tolerance is not None:
            self._values["tolerance"] = tolerance
        if tolerance_var is not None:
            self._values["tolerance_var"] = tolerance_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        '''
        result = self._values.get("feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather_var(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        '''
        result = self._values.get("feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        '''
        result = self._values.get("tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance_var(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        result = self._values.get("tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationRemoveColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationRemoveColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationRemoveColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fbd56257e42c0b9a4b86c516ad58f3ae4cc429bae2277244f35a8f510afb97d4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationRemoveColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e74f7fa9afe1a8b40e339ba11ee432390c8c18e91febb4ff753c3c93113ea7bc)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationRemoveColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b4efee9782cf806cd390ad0d852338777769a4b82738e258ccb46b3ad93a5578)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__789091ca13e6cbc0c2e09cb1e2cf86302103042934b158cdd171a950337fb968)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e67c8d6c4bc500861fd58474c05524dbb09fa80b34edbdec6d5361c870abf83e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationRemoveColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationRemoveColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationRemoveColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__971885ee753799c89927a43211e4eddfe7de6b03173b85f7c164ef4f2d2fcd16)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationRemoveColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationRemoveColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c63c8f3009bd4e43955504a1c35acef0386eb0519f335cda3894ccbb005a9d8d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @jsii.member(jsii_name="resetFeather")
    def reset_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeather", []))

    @jsii.member(jsii_name="resetFeatherVar")
    def reset_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatherVar", []))

    @jsii.member(jsii_name="resetTolerance")
    def reset_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTolerance", []))

    @jsii.member(jsii_name="resetToleranceVar")
    def reset_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featherInput")
    def feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherInput"))

    @builtins.property
    @jsii.member(jsii_name="featherVarInput")
    def feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceInput")
    def tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceVarInput")
    def tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd0d2cad8c7d03744ec0c65d9ac19cb86f1937201548a7da82329f3cfce95292)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e14ea8d92e7dc54164d8f5274b09da975caea109e00f40aadc31724b144c94b9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="feather")
    def feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "feather"))

    @feather.setter
    def feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__026973d2772ffb966f180dd1c0fb50a99c649f4fac467d9a9839c0be0f77730f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "feather", value)

    @builtins.property
    @jsii.member(jsii_name="featherVar")
    def feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featherVar"))

    @feather_var.setter
    def feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6eb0e3f14eb99f247091820df7e8bfe9bf32f5aed465c6d039fa6d3ffa66c1b7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featherVar", value)

    @builtins.property
    @jsii.member(jsii_name="tolerance")
    def tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tolerance"))

    @tolerance.setter
    def tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2dce977a5c25f7e6be5e90b40d2ee1a873db5dd624c0a80870531d68e0b156c6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tolerance", value)

    @builtins.property
    @jsii.member(jsii_name="toleranceVar")
    def tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "toleranceVar"))

    @tolerance_var.setter
    def tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4630708ac9b162f5a8408bb57d48a990e22cb29320f42d27fd56146aa7b7e527)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "toleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationRemoveColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationRemoveColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationRemoveColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__62525513a8a41eb7790719be056d23b9d2401095bf5a24d98f756f8418fb5932)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationResize",
    jsii_struct_bases=[],
    name_mapping={
        "aspect": "aspect",
        "aspect_var": "aspectVar",
        "height": "height",
        "height_var": "heightVar",
        "type": "type",
        "type_var": "typeVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationResize:
    def __init__(
        self,
        *,
        aspect: typing.Optional[builtins.str] = None,
        aspect_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param aspect: Preserves the aspect ratio. Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect DataAkamaiImagingPolicyImage#aspect}
        :param aspect_var: Preserves the aspect ratio. Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_var DataAkamaiImagingPolicyImage#aspect_var}
        :param height: The height to resize the source image to. Must be set if height is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height to resize the source image to. Must be set if height is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param type: Sets constraints for the image resize. Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: Sets constraints for the image resize. Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        :param width: The width to resize the source image to. Must be set if width is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width to resize the source image to. Must be set if width is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ae6de2672901b98fa372cf6a8ad95a8325adf206e35d0d21b1b83271dcde6643)
            check_type(argname="argument aspect", value=aspect, expected_type=type_hints["aspect"])
            check_type(argname="argument aspect_var", value=aspect_var, expected_type=type_hints["aspect_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if aspect is not None:
            self._values["aspect"] = aspect
        if aspect_var is not None:
            self._values["aspect_var"] = aspect_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def aspect(self) -> typing.Optional[builtins.str]:
        '''Preserves the aspect ratio.

        Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect DataAkamaiImagingPolicyImage#aspect}
        '''
        result = self._values.get("aspect")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def aspect_var(self) -> typing.Optional[builtins.str]:
        '''Preserves the aspect ratio.

        Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_var DataAkamaiImagingPolicyImage#aspect_var}
        '''
        result = self._values.get("aspect_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height to resize the source image to. Must be set if height is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height to resize the source image to. Must be set if height is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''Sets constraints for the image resize.

        Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''Sets constraints for the image resize.

        Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width to resize the source image to. Must be set if width is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width to resize the source image to. Must be set if width is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationResize(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationResizeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationResizeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__92f5b43294ba8fa58facc750a2020037bc9c1bacde2fd372e2e54c6dd66ba250)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationResizeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a2d6e8bb67676a6b0edb473ab7f7cc8bfe7495476d4e4b99830167d5f01cee9f)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationResizeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9e97e6c637cc7131f2b76d3f30cbad0fb07bd0a042e3a07bacf602e0bd560049)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__60f5f424ced6fbe0fb09f9129b4648a23893b9b749bbe4f4f8109dbc757e2746)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__facf67a7747d8ba835f0186c0bafc01d74843b04dd006e746688134b205da191)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationResize]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationResize]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationResize]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e02ac96bf7c3cbd7f7b99942e4c66ec18366a27619dbe570aadacb58ba6b8780)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationResizeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationResizeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__10a6278e8b92c9b5376ed4e8810f06fba36231f0c4017c86198b5da2a2c065de)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAspect")
    def reset_aspect(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspect", []))

    @jsii.member(jsii_name="resetAspectVar")
    def reset_aspect_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspectVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="aspectInput")
    def aspect_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "aspectInput"))

    @builtins.property
    @jsii.member(jsii_name="aspectVarInput")
    def aspect_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "aspectVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="aspect")
    def aspect(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "aspect"))

    @aspect.setter
    def aspect(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7ffb54044def6c067c762a9d2dfb74346866ea25a9417ef69b656e84dc69fe79)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "aspect", value)

    @builtins.property
    @jsii.member(jsii_name="aspectVar")
    def aspect_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "aspectVar"))

    @aspect_var.setter
    def aspect_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__29e0ca4a7b3bd516f948d2a97321ebadaa3225588af7b34ad38f53a745b8ea2f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "aspectVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5fc1b78752ceeae2725a1fa82d61e6a2418e0d7970d4efc731148d5350f10957)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__20310ad3a797b5de7cc5b98322c1f5ef9cfdd93a33684ff8bad2cb1057456d55)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ba64f0f2dd1a353eb97f4e04b11ebdfc221ed5e8f3c4a6e6d09c581873857a91)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__912bc63b53c70c72bf2b633c36e9323c0ca9e85ac01fb354b00cde0c531ef83a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__68605b3f4455ef2544102dcd509326a9e507ddb805f64eda9d7f60828d0e47dc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__575e2594e61e7f10b88169ae738c5c6fbd0e06b99191b5853b6fc01611ac06d6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationResize]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationResize]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationResize]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c07499489ae5ad5f620ac861a1397ef2ac900be5a625ae004c39b60b7b271780)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationRotate",
    jsii_struct_bases=[],
    name_mapping={"degrees": "degrees", "degrees_var": "degreesVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationRotate:
    def __init__(
        self,
        *,
        degrees: typing.Optional[builtins.str] = None,
        degrees_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param degrees: The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees DataAkamaiImagingPolicyImage#degrees}
        :param degrees_var: The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees_var DataAkamaiImagingPolicyImage#degrees_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4af49830ae65312e41f1c16121281dc9d370b68c10eb356c81afba583d6d519e)
            check_type(argname="argument degrees", value=degrees, expected_type=type_hints["degrees"])
            check_type(argname="argument degrees_var", value=degrees_var, expected_type=type_hints["degrees_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if degrees is not None:
            self._values["degrees"] = degrees
        if degrees_var is not None:
            self._values["degrees_var"] = degrees_var

    @builtins.property
    def degrees(self) -> typing.Optional[builtins.str]:
        '''The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees DataAkamaiImagingPolicyImage#degrees}
        '''
        result = self._values.get("degrees")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def degrees_var(self) -> typing.Optional[builtins.str]:
        '''The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees_var DataAkamaiImagingPolicyImage#degrees_var}
        '''
        result = self._values.get("degrees_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationRotate(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationRotateList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationRotateList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__46be3592e099f481140fbbe5ad5801522f2322f730c58ce51a48c10334ace844)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationRotateOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9171ae75b6a0258dfca90d4c915f862205fa2bfa82d6fc62869417d9242c4d11)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationRotateOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__33ee4c0134fd3dfe2e6cf9eea5b94a98d98008f495d46d4514a129207b3cd837)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dec15553836406ef851e872d606a7712d4165e6010e2b6b5238adf88d585af9c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e5a905554392a3daaee6066f304a4b5db8c42b2c4c5948cd95252f12b704a909)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationRotate]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationRotate]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationRotate]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a78bfe4902ce8177c344bfaaa34acc2910416ca0c049843e343e516e2484df2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationRotateOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationRotateOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c9fe371f6e863809db20d5392b2ccab8ab7e0b0df064eab0a741cdfb335292a7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetDegrees")
    def reset_degrees(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDegrees", []))

    @jsii.member(jsii_name="resetDegreesVar")
    def reset_degrees_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDegreesVar", []))

    @builtins.property
    @jsii.member(jsii_name="degreesInput")
    def degrees_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "degreesInput"))

    @builtins.property
    @jsii.member(jsii_name="degreesVarInput")
    def degrees_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "degreesVarInput"))

    @builtins.property
    @jsii.member(jsii_name="degrees")
    def degrees(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "degrees"))

    @degrees.setter
    def degrees(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7369c90abf6d71f6ba736fb99d0e0823886f4a5159f35c640af340fc5fc69f10)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "degrees", value)

    @builtins.property
    @jsii.member(jsii_name="degreesVar")
    def degrees_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "degreesVar"))

    @degrees_var.setter
    def degrees_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fd48266035b4365b84dd8c2b2d4a1c82c889f058001072213f6c6dc7bd55ace5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "degreesVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationRotate]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationRotate]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationRotate]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__35d702db53f261c7ef0413111e9c4492d554391f740e35491792f37aa7c96530)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationScale",
    jsii_struct_bases=[],
    name_mapping={
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationScale:
    def __init__(
        self,
        *,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param height: Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged. Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged. Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ec4a07e2bda3d5d4637dfb1c871e9290a6f16d3542b5b1836b014324e43d0dbe)
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size.

        Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size.

        Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged.

        Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged.

        Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationScale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationScaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationScaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__232569b5240553b6f106b1dda435def22a236acfda683a369c376fd2363f6223)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationScaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ccd79f0eb35c021d26f66c0ba2e435bd4ba5d9d4f4acda747ebc924cde6a16bd)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationScaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dcbb00cbd693df10506cfceac161808585e6ec613fc846358cc20c20ef63435d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fb7c588ccfba9daa11e5db119f0a93b748f1c77ab9eb878048ce68c61dd3e543)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__032ec086c832bd89098264241a931b6934a8f127b6c787d2a0ae97058fac17ab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationScale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationScale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationScale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df1592172277168648ca81ba8ecc51f56697c8bf2b094cf3717f4797bd6d62e0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationScaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationScaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b2213b8c5978f25e5ad7080aafb9c7d4008564ada16dd6f32616507a28e237a2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3450b32548f268053ca0ff579a081bcba869681a93ecebb26948abab1d3b0d95)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__69aaf74bb564f623246264f1deb92a8f23284c81b3b53549b386210b9e2b79c6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6b4ddfb36fe9bd1941ae1c05d26b2e2a100857c3f8dbc330a5cd8da1a84dfb58)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__41e264a9483ecb0fd709462c0c3f71383d07842ed167becee214e5fe0cddadf1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationScale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationScale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationScale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__57c582e54a0a648036a7cedb372f8c05e30884e1a9da59da2156ae54fefeb86a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationShear",
    jsii_struct_bases=[],
    name_mapping={
        "x_shear": "xShear",
        "x_shear_var": "xShearVar",
        "y_shear": "yShear",
        "y_shear_var": "yShearVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationShear:
    def __init__(
        self,
        *,
        x_shear: typing.Optional[builtins.str] = None,
        x_shear_var: typing.Optional[builtins.str] = None,
        y_shear: typing.Optional[builtins.str] = None,
        y_shear_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param x_shear: The amount to shear along the x-axis, measured in multiples of the image's width. Must be set if yShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear DataAkamaiImagingPolicyImage#x_shear}
        :param x_shear_var: The amount to shear along the x-axis, measured in multiples of the image's width. Must be set if yShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear_var DataAkamaiImagingPolicyImage#x_shear_var}
        :param y_shear: The amount to shear along the y-axis, measured in multiples of the image's height. Must be set if xShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear DataAkamaiImagingPolicyImage#y_shear}
        :param y_shear_var: The amount to shear along the y-axis, measured in multiples of the image's height. Must be set if xShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear_var DataAkamaiImagingPolicyImage#y_shear_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c2f97a52054963d76a11bea3eafa1a00953b3216e642e644080e77981f71f727)
            check_type(argname="argument x_shear", value=x_shear, expected_type=type_hints["x_shear"])
            check_type(argname="argument x_shear_var", value=x_shear_var, expected_type=type_hints["x_shear_var"])
            check_type(argname="argument y_shear", value=y_shear, expected_type=type_hints["y_shear"])
            check_type(argname="argument y_shear_var", value=y_shear_var, expected_type=type_hints["y_shear_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if x_shear is not None:
            self._values["x_shear"] = x_shear
        if x_shear_var is not None:
            self._values["x_shear_var"] = x_shear_var
        if y_shear is not None:
            self._values["y_shear"] = y_shear
        if y_shear_var is not None:
            self._values["y_shear_var"] = y_shear_var

    @builtins.property
    def x_shear(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the x-axis, measured in multiples of the image's width.

        Must be set if yShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear DataAkamaiImagingPolicyImage#x_shear}
        '''
        result = self._values.get("x_shear")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_shear_var(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the x-axis, measured in multiples of the image's width.

        Must be set if yShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear_var DataAkamaiImagingPolicyImage#x_shear_var}
        '''
        result = self._values.get("x_shear_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_shear(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the y-axis, measured in multiples of the image's height.

        Must be set if xShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear DataAkamaiImagingPolicyImage#y_shear}
        '''
        result = self._values.get("y_shear")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_shear_var(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the y-axis, measured in multiples of the image's height.

        Must be set if xShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear_var DataAkamaiImagingPolicyImage#y_shear_var}
        '''
        result = self._values.get("y_shear_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationShear(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationShearList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationShearList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9caaf12103dd21abc28653509d0e9913c95d23f8f79246ba07301c5aa1ce78c0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationShearOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6750f739d09483e19682b858865831d9fd77da36b87821c6267bd6766153667d)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationShearOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e0bb39cb6bf4d670ac8872836fc48a9202143c5da35bcb95ec6db1c2227db9da)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__88e3227ebb33107ff2a98efd29b491f26d6ea90a0afb5f5290f99979e0896f2e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b2e67d11a9245ada45a89c231e2050b248377d5450cf80f59120992db1c799e3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationShear]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationShear]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationShear]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cf38959acddd443a194f2fdb51c27829e7623db5fb68a9f857c3aba867b4f7a9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationShearOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationShearOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__65b9679031256a67e2e8302ecd860a9d35895bb264ddb6d3af6fc457f5059740)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetXShear")
    def reset_x_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXShear", []))

    @jsii.member(jsii_name="resetXShearVar")
    def reset_x_shear_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXShearVar", []))

    @jsii.member(jsii_name="resetYShear")
    def reset_y_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYShear", []))

    @jsii.member(jsii_name="resetYShearVar")
    def reset_y_shear_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYShearVar", []))

    @builtins.property
    @jsii.member(jsii_name="xShearInput")
    def x_shear_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xShearInput"))

    @builtins.property
    @jsii.member(jsii_name="xShearVarInput")
    def x_shear_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xShearVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yShearInput")
    def y_shear_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yShearInput"))

    @builtins.property
    @jsii.member(jsii_name="yShearVarInput")
    def y_shear_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yShearVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xShear")
    def x_shear(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xShear"))

    @x_shear.setter
    def x_shear(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__320815d177b5eb595721ab8163b295ed462b7f760d6aa92ac98d23271576fa86)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xShear", value)

    @builtins.property
    @jsii.member(jsii_name="xShearVar")
    def x_shear_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xShearVar"))

    @x_shear_var.setter
    def x_shear_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4b97a2336a14ab31d9d40677bb3be35ce3ce90cb24baaac1bfec29b6926344b6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xShearVar", value)

    @builtins.property
    @jsii.member(jsii_name="yShear")
    def y_shear(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yShear"))

    @y_shear.setter
    def y_shear(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__93769219be996fed81986f7cb6e00a6b7dcfae6a64adb39c3b1405bc3762aba7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yShear", value)

    @builtins.property
    @jsii.member(jsii_name="yShearVar")
    def y_shear_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yShearVar"))

    @y_shear_var.setter
    def y_shear_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__53d8d56858bf670eec794e1b9eb629120ccc450ffb7e8899a0d1227518e30a1c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yShearVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationShear]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationShear]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationShear]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3f14a4647671b84e42f7070ac323d5d42f0a156c76571f951eba5bd1547bc139)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationTrim",
    jsii_struct_bases=[],
    name_mapping={
        "fuzz": "fuzz",
        "fuzz_var": "fuzzVar",
        "padding": "padding",
        "padding_var": "paddingVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationTrim:
    def __init__(
        self,
        *,
        fuzz: typing.Optional[builtins.str] = None,
        fuzz_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fuzz: The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz DataAkamaiImagingPolicyImage#fuzz}
        :param fuzz_var: The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz_var DataAkamaiImagingPolicyImage#fuzz_var}
        :param padding: The amount of padding in pixels to add to the trimmed image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: The amount of padding in pixels to add to the trimmed image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ee699895a15e0cda6730ca5b83ae4b2040839488568192f1a545b7e94163657d)
            check_type(argname="argument fuzz", value=fuzz, expected_type=type_hints["fuzz"])
            check_type(argname="argument fuzz_var", value=fuzz_var, expected_type=type_hints["fuzz_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fuzz is not None:
            self._values["fuzz"] = fuzz
        if fuzz_var is not None:
            self._values["fuzz_var"] = fuzz_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var

    @builtins.property
    def fuzz(self) -> typing.Optional[builtins.str]:
        '''The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz DataAkamaiImagingPolicyImage#fuzz}
        '''
        result = self._values.get("fuzz")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fuzz_var(self) -> typing.Optional[builtins.str]:
        '''The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz_var DataAkamaiImagingPolicyImage#fuzz_var}
        '''
        result = self._values.get("fuzz_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''The amount of padding in pixels to add to the trimmed image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''The amount of padding in pixels to add to the trimmed image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationTrim(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationTrimList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationTrimList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e88d7209b6028447a0a4a38059101ec048401033a2c95ba1e99b2d97281e1937)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationTrimOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2044c4b1947354f55e990cafb0ec07b960fa2f8514afce2cb8c7fa01e5076917)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationTrimOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__443b96e594dc993e1b2b23a8e438712fcc4cbbfab503bfe045fe371cec20d412)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__23637054fb904d23cf85db282d92125de1bf840885aa2f24d1832a6153a08048)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f88f843f9cfa669dbc9ecca3cdb67e5790ca9ba9479ddbc35f03d96ae5001594)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationTrim]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationTrim]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationTrim]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__090f84d387b8017768aabdacb6feb39f2a83c40efd184ab2caf38b7ef60048e7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationTrimOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationTrimOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c88867f140d7f4ba83ea1d4be5c10f379a4668593ba82d31acb65d765a4afae3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetFuzz")
    def reset_fuzz(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFuzz", []))

    @jsii.member(jsii_name="resetFuzzVar")
    def reset_fuzz_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFuzzVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @builtins.property
    @jsii.member(jsii_name="fuzzInput")
    def fuzz_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fuzzInput"))

    @builtins.property
    @jsii.member(jsii_name="fuzzVarInput")
    def fuzz_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fuzzVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="fuzz")
    def fuzz(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fuzz"))

    @fuzz.setter
    def fuzz(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__23046336eb33e7b62f58e657236290b5837a88ce6fa28b85971927e152221d54)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fuzz", value)

    @builtins.property
    @jsii.member(jsii_name="fuzzVar")
    def fuzz_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fuzzVar"))

    @fuzz_var.setter
    def fuzz_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__33461aa4848165564cf53cb86d1518b5decac181b0f3372dd0ae2557597b5782)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fuzzVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d6877269068d3a5da6d363451c6afe4f1a7efc2e056b158ab6044704318e690a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__457768eba25b82c044cd870ac13fd4b4fe77cdf4ef4a9349ebb0e71701602e3e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationTrim]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationTrim]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationTrim]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__65dd1c7b252477d56a1091f102213842dc6548fff89af543a952ba575f02b0a4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationUnsharpMask",
    jsii_struct_bases=[],
    name_mapping={
        "gain": "gain",
        "gain_var": "gainVar",
        "sigma": "sigma",
        "sigma_var": "sigmaVar",
        "threshold": "threshold",
        "threshold_var": "thresholdVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationUnsharpMask:
    def __init__(
        self,
        *,
        gain: typing.Optional[builtins.str] = None,
        gain_var: typing.Optional[builtins.str] = None,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
        threshold: typing.Optional[builtins.str] = None,
        threshold_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param gain: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        :param gain_var: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        :param sigma: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        :param threshold: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        :param threshold_var: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6df32db1ca49941fce5ba8af914e4e69af9e45c7a2b138172bf1a513225876e3)
            check_type(argname="argument gain", value=gain, expected_type=type_hints["gain"])
            check_type(argname="argument gain_var", value=gain_var, expected_type=type_hints["gain_var"])
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
            check_type(argname="argument threshold", value=threshold, expected_type=type_hints["threshold"])
            check_type(argname="argument threshold_var", value=threshold_var, expected_type=type_hints["threshold_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if gain is not None:
            self._values["gain"] = gain
        if gain_var is not None:
            self._values["gain_var"] = gain_var
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var
        if threshold is not None:
            self._values["threshold"] = threshold
        if threshold_var is not None:
            self._values["threshold_var"] = threshold_var

    @builtins.property
    def gain(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        '''
        result = self._values.get("gain")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gain_var(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        '''
        result = self._values.get("gain_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        '''
        result = self._values.get("threshold")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold_var(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        result = self._values.get("threshold_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationUnsharpMask(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationUnsharpMaskList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationUnsharpMaskList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4e10d1cb54cda9529099b70a260b581e21b594100a478bc518ae234c994e867f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationUnsharpMaskOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bf1c8fd8490da3b283dd79c2ed5ab2de99f0ca7663abfd67152f554bcf6092ca)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationUnsharpMaskOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__27c4e7e8306478707fb12f5a969b980a7a825bd7d60e009780e03160c81aec5e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bed38bff9e289f78afb0d7b29e646dd4eb5e1f5ce252d03143daeed0a5d6ca73)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__38c0fc9ba6b66c02438e6ed0f0e67fd5b78a01b3cb96fd0068a5c391b52a3bcb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationUnsharpMask]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationUnsharpMask]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationUnsharpMask]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__90d30a7684893bf6e5304cfb44d5917702b95d2b6980df8a751a3e491e6178b8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationUnsharpMaskOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationUnsharpMaskOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__841995af72e4ae4a186bd7de4aaf9273528a4acc352bbbeb51789e6d6b842375)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetGain")
    def reset_gain(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGain", []))

    @jsii.member(jsii_name="resetGainVar")
    def reset_gain_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGainVar", []))

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @jsii.member(jsii_name="resetThreshold")
    def reset_threshold(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThreshold", []))

    @jsii.member(jsii_name="resetThresholdVar")
    def reset_threshold_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThresholdVar", []))

    @builtins.property
    @jsii.member(jsii_name="gainInput")
    def gain_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainInput"))

    @builtins.property
    @jsii.member(jsii_name="gainVarInput")
    def gain_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdInput")
    def threshold_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdVarInput")
    def threshold_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gain")
    def gain(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gain"))

    @gain.setter
    def gain(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7c85fe8c050d145c7c4f1abc855e16021ce9cd395c8dcc1b9e3b02f3d63ad92f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gain", value)

    @builtins.property
    @jsii.member(jsii_name="gainVar")
    def gain_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gainVar"))

    @gain_var.setter
    def gain_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8476a246fc4ae3f7beea3dd5bf06b39ac4be813321d949a56e833a99beab7779)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gainVar", value)

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb0e1a9f13b1d8767819654624fba3793c86502d961bbaa7d7ec7d7011200939)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__318ccc84d5fdff34dbf8e17d1066a77dfb00916c731160cc3a148966a02f4b59)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="threshold")
    def threshold(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "threshold"))

    @threshold.setter
    def threshold(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a4c7908543f520a1738499610ecc11f4dd852969078367adee9baf7035357906)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "threshold", value)

    @builtins.property
    @jsii.member(jsii_name="thresholdVar")
    def threshold_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "thresholdVar"))

    @threshold_var.setter
    def threshold_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0e3cc5b686d95098683d32086a6d71d9722c2fb6874c34555e46124feac02010)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "thresholdVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationUnsharpMask]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationUnsharpMask]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationUnsharpMask]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__100b830868e97f531b53e3c3d769418d00eb1762ca3eea871a0b290c4bb7b7fa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__afa9b59f9059bbe6fc7e53f078fb452118d88a0de7fbb653136d557fab54d79a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__20d6c02b2fa5ee7ddbf0aef4295345f22f57ff1589b1ff146ff96a39369f8108)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__26066815583e5c00d45aaaf78f0e2d0b791abf85438ac31a75ff23f0fa8b5dc5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4521466c56e6a6dcdae5e18a29de75d7a4d4dc531abca7d427be1c03830a4e2a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d0474f273e03a550ac8d4251e168d31ce3b38fb5958a4f85881474cd16d240c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFill]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFill]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFill]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7f88fe592b52802a978a32635cfa3632c817905afe91a51f601738bab2055628)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dd17704ed834a18ba99563ce675a5a578714cc666db57f747e43d77171971b13)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putFillTransformation")
    def put_fill_transformation(
        self,
        *,
        append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationAppend, typing.Dict[builtins.str, typing.Any]]]]] = None,
        aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationAspectCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
        crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationFaceCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationFeatureCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationFitAndFill, typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
        im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationImQuery, typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
        region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationRegionOfInterestCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationRelativeCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
        resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationResize, typing.Dict[builtins.str, typing.Any]]]]] = None,
        rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationRotate, typing.Dict[builtins.str, typing.Any]]]]] = None,
        scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationScale, typing.Dict[builtins.str, typing.Any]]]]] = None,
        shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationShear, typing.Dict[builtins.str, typing.Any]]]]] = None,
        trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationTrim, typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param append: append block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        :param aspect_crop: aspect_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param crop: crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        :param face_crop: face_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        :param feature_crop: feature_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        :param fit_and_fill: fit_and_fill block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param im_query: im_query block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param region_of_interest_crop: region_of_interest_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        :param relative_crop: relative_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param resize: resize block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        :param rotate: rotate block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        :param scale: scale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param shear: shear block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        :param trim: trim block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformation(
            append=append,
            aspect_crop=aspect_crop,
            background_color=background_color,
            blur=blur,
            chroma_key=chroma_key,
            composite=composite,
            compound=compound,
            contrast=contrast,
            crop=crop,
            face_crop=face_crop,
            feature_crop=feature_crop,
            fit_and_fill=fit_and_fill,
            goop=goop,
            grayscale=grayscale,
            hsl=hsl,
            hsv=hsv,
            if_dimension=if_dimension,
            if_orientation=if_orientation,
            im_query=im_query,
            max_colors=max_colors,
            mirror=mirror,
            mono_hue=mono_hue,
            opacity=opacity,
            region_of_interest_crop=region_of_interest_crop,
            relative_crop=relative_crop,
            remove_color=remove_color,
            resize=resize,
            rotate=rotate,
            scale=scale,
            shear=shear,
            trim=trim,
            unsharp_mask=unsharp_mask,
        )

        return typing.cast(None, jsii.invoke(self, "putFillTransformation", [value]))

    @jsii.member(jsii_name="resetFillTransformation")
    def reset_fill_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFillTransformation", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="fillTransformation")
    def fill_transformation(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationOutputReference, jsii.get(self, "fillTransformation"))

    @builtins.property
    @jsii.member(jsii_name="fillTransformationInput")
    def fill_transformation_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformation], jsii.get(self, "fillTransformationInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6bb8eee707733e1e286cb21f3d5ea3c62cd729ab8e8fb6c2f6dd368a784ece1b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fd7700c67e029f253f8ce391d344e64cf9d138516cdbd0105453451451e92791)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__98d49919c3705347b0d34523ccd307a37cd2f181b2630caff8536c80094d6692)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5b8d611b3e4ac76030c06ff285e35bf5794cb5ed760bbe4d6199761367d29da3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFill]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFill]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFill]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__82ca6d7e197511829e5ac583b4a860f94f92bad75dba59b003d2cd636e1565e6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitGoop",
    jsii_struct_bases=[],
    name_mapping={
        "chaos": "chaos",
        "chaos_var": "chaosVar",
        "density": "density",
        "density_var": "densityVar",
        "power": "power",
        "power_var": "powerVar",
        "seed": "seed",
        "seed_var": "seedVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitGoop:
    def __init__(
        self,
        *,
        chaos: typing.Optional[builtins.str] = None,
        chaos_var: typing.Optional[builtins.str] = None,
        density: typing.Optional[builtins.str] = None,
        density_var: typing.Optional[builtins.str] = None,
        power: typing.Optional[builtins.str] = None,
        power_var: typing.Optional[builtins.str] = None,
        seed: typing.Optional[builtins.str] = None,
        seed_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param chaos: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        :param chaos_var: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        :param density: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        :param density_var: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        :param power: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        :param power_var: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        :param seed: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        :param seed_var: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__802eebf776cef30d5c64b4dedbadb385ce619ebb04248a7a736196ffc42608c5)
            check_type(argname="argument chaos", value=chaos, expected_type=type_hints["chaos"])
            check_type(argname="argument chaos_var", value=chaos_var, expected_type=type_hints["chaos_var"])
            check_type(argname="argument density", value=density, expected_type=type_hints["density"])
            check_type(argname="argument density_var", value=density_var, expected_type=type_hints["density_var"])
            check_type(argname="argument power", value=power, expected_type=type_hints["power"])
            check_type(argname="argument power_var", value=power_var, expected_type=type_hints["power_var"])
            check_type(argname="argument seed", value=seed, expected_type=type_hints["seed"])
            check_type(argname="argument seed_var", value=seed_var, expected_type=type_hints["seed_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if chaos is not None:
            self._values["chaos"] = chaos
        if chaos_var is not None:
            self._values["chaos_var"] = chaos_var
        if density is not None:
            self._values["density"] = density
        if density_var is not None:
            self._values["density_var"] = density_var
        if power is not None:
            self._values["power"] = power
        if power_var is not None:
            self._values["power_var"] = power_var
        if seed is not None:
            self._values["seed"] = seed
        if seed_var is not None:
            self._values["seed_var"] = seed_var

    @builtins.property
    def chaos(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        '''
        result = self._values.get("chaos")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def chaos_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        '''
        result = self._values.get("chaos_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        '''
        result = self._values.get("density")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density_var(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        '''
        result = self._values.get("density_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        '''
        result = self._values.get("power")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power_var(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        '''
        result = self._values.get("power_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        '''
        result = self._values.get("seed")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed_var(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        result = self._values.get("seed_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitGoop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitGoopList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitGoopList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a1f87650842b54523bdca799e2430a99395b0e3bf6b96a8596b65f2b2b6d789)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitGoopOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__89ef1628e2ca72f315c2353d8a506d224ff7f58ad97d68aa12e1d7cccf8f2a4e)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitGoopOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7672b69930f4effd3bf5b86afe5a8bf326800014c4d05c9f10f5009765c23109)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8afd94bac75ab475243278c386334978578a2c5e906c59ff0797c7e8ab8ac8e4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6a36d7c1247f7e69969ede938be807cd2f2c8d01973b5019969bcaf3975de1a5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitGoop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitGoop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eaaae2de84da841de28c3bde533c00852f9afaa93e4ee0132646636962eea3de)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitGoopOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitGoopOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__245c8f336ae676a65459d7a633c93687b69d63f31bb6d8c7cf4b70425b5a2d1a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetChaos")
    def reset_chaos(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaos", []))

    @jsii.member(jsii_name="resetChaosVar")
    def reset_chaos_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaosVar", []))

    @jsii.member(jsii_name="resetDensity")
    def reset_density(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensity", []))

    @jsii.member(jsii_name="resetDensityVar")
    def reset_density_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensityVar", []))

    @jsii.member(jsii_name="resetPower")
    def reset_power(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPower", []))

    @jsii.member(jsii_name="resetPowerVar")
    def reset_power_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPowerVar", []))

    @jsii.member(jsii_name="resetSeed")
    def reset_seed(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeed", []))

    @jsii.member(jsii_name="resetSeedVar")
    def reset_seed_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeedVar", []))

    @builtins.property
    @jsii.member(jsii_name="chaosInput")
    def chaos_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosInput"))

    @builtins.property
    @jsii.member(jsii_name="chaosVarInput")
    def chaos_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosVarInput"))

    @builtins.property
    @jsii.member(jsii_name="densityInput")
    def density_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityInput"))

    @builtins.property
    @jsii.member(jsii_name="densityVarInput")
    def density_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="powerInput")
    def power_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerInput"))

    @builtins.property
    @jsii.member(jsii_name="powerVarInput")
    def power_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerVarInput"))

    @builtins.property
    @jsii.member(jsii_name="seedInput")
    def seed_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedInput"))

    @builtins.property
    @jsii.member(jsii_name="seedVarInput")
    def seed_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedVarInput"))

    @builtins.property
    @jsii.member(jsii_name="chaos")
    def chaos(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaos"))

    @chaos.setter
    def chaos(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3eb193e2c1dfe102ebce2ca73cd8a616afb5b75c389515a255c534fcbc0eb8ae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaos", value)

    @builtins.property
    @jsii.member(jsii_name="chaosVar")
    def chaos_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaosVar"))

    @chaos_var.setter
    def chaos_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e2386e0cd274dae23f9034c3bdb4c3ff6546285cf7bb225b1a9299c973e241c1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaosVar", value)

    @builtins.property
    @jsii.member(jsii_name="density")
    def density(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "density"))

    @density.setter
    def density(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b304e531b46f19c6039f2dd777e2534da73324ba40883370325431e9d39cbe3e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "density", value)

    @builtins.property
    @jsii.member(jsii_name="densityVar")
    def density_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "densityVar"))

    @density_var.setter
    def density_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fe51f4086a9532476b400ed78690d089af7be2428d04ba6f3a0505cc56d18f46)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "densityVar", value)

    @builtins.property
    @jsii.member(jsii_name="power")
    def power(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "power"))

    @power.setter
    def power(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__597f47a6e69a7f26abd91b99f7a0ce4140158ba0a0b405b286a4d1654794ecb7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "power", value)

    @builtins.property
    @jsii.member(jsii_name="powerVar")
    def power_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "powerVar"))

    @power_var.setter
    def power_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__28a8325f32206ff1612a6fe3928767f787df51ea31c67e82aa949a98ef8e801e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "powerVar", value)

    @builtins.property
    @jsii.member(jsii_name="seed")
    def seed(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seed"))

    @seed.setter
    def seed(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f317678d9bc0c387cd1bc75d11fbf3f93afde60aa9d6de245acc66140d859e88)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seed", value)

    @builtins.property
    @jsii.member(jsii_name="seedVar")
    def seed_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seedVar"))

    @seed_var.setter
    def seed_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__64f1546145078a3f602b9626590ece8f26c13770ac684509dc7c00c09cc66b7b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seedVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitGoop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitGoop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitGoop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__11f4fc659723ce2c1818e13666bdee8996ac3d16d45db77e17877da6b41b2447)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitGrayscale",
    jsii_struct_bases=[],
    name_mapping={"type": "type", "type_var": "typeVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitGrayscale:
    def __init__(
        self,
        *,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param type: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__33640f9e68e30787f9b375b3a5f654ff08949c1e3be72ba6ec9db140ae7981de)
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitGrayscale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitGrayscaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitGrayscaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__64f977bfe732b191f3084e76f5d515ebf474d17ef05735ac668f9fd9d3a2fd01)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitGrayscaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2048bdfab36adf18f588adc1095fd4dd925d4281d8ad4a73fbf7328100132c81)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitGrayscaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8df0e3ca06c42c85547df93e4491b12f491c9d9d0ab2c52198b059419a24cd96)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e38e1842167911361dc189a2af36ba6d65aff63ab0340d4598a8293932728230)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8fd86a06c70565dfd08d28570cc87aa61168148fbf039b728d7f822f528dea38)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitGrayscale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitGrayscale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a4ca2bb2337313435e5f6c6e3499d4a858f9b32f081d00c0f03b55d06e1d5af)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitGrayscaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitGrayscaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d8861ece979cc24b4540115a95a256d680eb63362dc8a8f7a3ffbc40a0bd0e9b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__56e6c713afe494a0a599367b2a96a7538e9c9a762ed23ddbbe94ee8140255b68)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__253f7dfc37b648402d16c482fb4d5389ffff04d68e284aac9666eedcc4169153)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitGrayscale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitGrayscale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitGrayscale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4cc852130a4a43a3371d67a334d453caa3f9015d475915b53cc3461f02fdd0cb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitHsl",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "lightness": "lightness",
        "lightness_var": "lightnessVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitHsl:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness: typing.Optional[builtins.str] = None,
        lightness_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        :param lightness_var: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__90715de453de20b1d9851eba907c543d05b26f88b935b762bd91b0a63f7ae297)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness", value=lightness, expected_type=type_hints["lightness"])
            check_type(argname="argument lightness_var", value=lightness_var, expected_type=type_hints["lightness_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness is not None:
            self._values["lightness"] = lightness
        if lightness_var is not None:
            self._values["lightness_var"] = lightness_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        '''
        result = self._values.get("lightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        '''
        result = self._values.get("lightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitHsl(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitHslList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitHslList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0c978361ae640207142ae2f2f0d987b182d82ce8ed2b01fc80840e951da26c70)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitHslOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5d1be7d832fc7394d85c7a1432a5c3bb10d6ad76a9fa0986d81a3c171ad59149)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitHslOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__78228aeab7f1eff6c72a1fdb45c2dbe283b31abc126af1398c854aebfac68985)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bd9c542eed56d30c358ffb8dd74c7c991e9c3361ddf961945a0fc44457b40adb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e97abaa1d61ddd33a8b980f60c24c04eaa3f75d523cfb30b1910bb326a9822f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitHsl]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitHsl]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9bd8c7d382a26e6df2c5b27c237305dd0b9c2a33c332d8e04b5432bb3cf4039d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitHslOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitHslOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d31f9a9d8f546716300758c0aa65297a761591203954361aa5e3d95b7e733587)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightness")
    def reset_lightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightness", []))

    @jsii.member(jsii_name="resetLightnessVar")
    def reset_lightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessInput")
    def lightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessVarInput")
    def lightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4987ce95f81873d0a9c245c3d2bdd6a1a849f1162b5bcabb3109c94ace6d3d33)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aa8eb347ab17ff42521cf2886507d8de457544f1585c963f6a77f897e76b5324)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightness")
    def lightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightness"))

    @lightness.setter
    def lightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__36c0cc4226dd09d31af4a7c34c795d3565ba1215f33cdebdd4bf02a7d3bc1a9a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightness", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessVar")
    def lightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessVar"))

    @lightness_var.setter
    def lightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1e34b67db0bf907e9621d3a2e5615cf3791dba061ab90beb05c2775fb1635a1b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__19b119ec13a042257aca7aef7e3bd5b1fbb24170493754ab3bbb033df11833a1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__99b829e027c67b7023957e7eed1664c7cd4223f2e684e85ad719576b132cc580)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitHsl]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitHsl]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitHsl]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e44e373cc2f42f7698ccfa20e95037dc2c4c9e19f075484fd39c5742e1adc086)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitHsv",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitHsv:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        :param value: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3f72fdc4eb62ec302ba5f737ffa9453670aa647d383ff7d14aca6d68be27200b)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitHsv(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitHsvList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitHsvList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__458446052805dc83a8934fac9c502bf638a255abdd569963aabc9371ec2c9c94)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitHsvOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__40575d2db031fba9dc92270281061da7b74fbaaf3cd2749519c4d21a5f124bcf)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitHsvOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6dcc798bed5afc908fd7091c0928dcae7868c1c8ff32c36d374a5085abeffed3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__541e47588e05bcbecdd14f3ace203ecb135fb64d29d3ff4c7e60cea251117887)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0d6224eed6367c2210e52d647130f1c8293ef1e13dabf3aa5c9ba08e06fc6a47)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitHsv]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitHsv]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__325e59feb7bd4cae2663e71a0be6b1bc7d78780fc09e771d07f230b3be79cc53)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitHsvOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitHsvOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__62484bf3a4ba5224101049d601a9af00613f9d7913ec6b16d8e3d1aaa35dc0d4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7a93bf4fdd71f49c994056a0b9d39e9fc079c84b5b37943e471f2a10dd00c689)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__10b697a86585c1c47ccaf6689de4ba50cdfa073e3cf4506ed020aaa9f52ef557)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bdba456e71da2b564e9ba6d150942f2683adf3b40dc77ad80fbaee27e92a7d85)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__db0021e05b6b2e6efd51f0998665208fe04cd5822abbe64b8b40797bd7e89111)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__57fb9bcfdcc50ba34b8a376111a98fb914844ca195ecf42bae24a98b0358aff0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2fbef0be92918c27f6450c77b32c112bf6b2496bae2b07f8fbf7336a418e2d5a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitHsv]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitHsv]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitHsv]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__da1aef9ec91cdbb636d4b1b1cfb7121ac2d0af23b69ebe51de05115096846faa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimension",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "dimension": "dimension",
        "dimension_var": "dimensionVar",
        "equal": "equal",
        "greater_than": "greaterThan",
        "less_than": "lessThan",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimension:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        dimension: typing.Optional[builtins.str] = None,
        dimension_var: typing.Optional[builtins.str] = None,
        equal: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqual", typing.Dict[builtins.str, typing.Any]]] = None,
        greater_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThan", typing.Dict[builtins.str, typing.Any]]] = None,
        less_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThan", typing.Dict[builtins.str, typing.Any]]] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param dimension: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        :param dimension_var: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        :param equal: equal block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        :param greater_than: greater_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        :param less_than: less_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        :param value: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefault(**default)
        if isinstance(equal, dict):
            equal = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqual(**equal)
        if isinstance(greater_than, dict):
            greater_than = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThan(**greater_than)
        if isinstance(less_than, dict):
            less_than = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThan(**less_than)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a8d7700b9b64321ff7ea9cdc6123cc75f82f80bed3782276bbb74469fec2b4c1)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument dimension", value=dimension, expected_type=type_hints["dimension"])
            check_type(argname="argument dimension_var", value=dimension_var, expected_type=type_hints["dimension_var"])
            check_type(argname="argument equal", value=equal, expected_type=type_hints["equal"])
            check_type(argname="argument greater_than", value=greater_than, expected_type=type_hints["greater_than"])
            check_type(argname="argument less_than", value=less_than, expected_type=type_hints["less_than"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if dimension is not None:
            self._values["dimension"] = dimension
        if dimension_var is not None:
            self._values["dimension_var"] = dimension_var
        if equal is not None:
            self._values["equal"] = equal
        if greater_than is not None:
            self._values["greater_than"] = greater_than
        if less_than is not None:
            self._values["less_than"] = less_than
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefault"], result)

    @builtins.property
    def dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        '''
        result = self._values.get("dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        '''
        result = self._values.get("dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def equal(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqual"]:
        '''equal block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        '''
        result = self._values.get("equal")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqual"], result)

    @builtins.property
    def greater_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThan"]:
        '''greater_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        '''
        result = self._values.get("greater_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThan"], result)

    @builtins.property
    def less_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThan"]:
        '''less_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        '''
        result = self._values.get("less_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThan"], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimension(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefault",
    jsii_struct_bases=[],
    name_mapping={
        "append": "append",
        "aspect_crop": "aspectCrop",
        "background_color": "backgroundColor",
        "blur": "blur",
        "chroma_key": "chromaKey",
        "composite": "composite",
        "compound": "compound",
        "contrast": "contrast",
        "crop": "crop",
        "face_crop": "faceCrop",
        "feature_crop": "featureCrop",
        "fit_and_fill": "fitAndFill",
        "goop": "goop",
        "grayscale": "grayscale",
        "hsl": "hsl",
        "hsv": "hsv",
        "if_dimension": "ifDimension",
        "if_orientation": "ifOrientation",
        "im_query": "imQuery",
        "max_colors": "maxColors",
        "mirror": "mirror",
        "mono_hue": "monoHue",
        "opacity": "opacity",
        "region_of_interest_crop": "regionOfInterestCrop",
        "relative_crop": "relativeCrop",
        "remove_color": "removeColor",
        "resize": "resize",
        "rotate": "rotate",
        "scale": "scale",
        "shear": "shear",
        "trim": "trim",
        "unsharp_mask": "unsharpMask",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefault:
    def __init__(
        self,
        *,
        append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultAppend", typing.Dict[builtins.str, typing.Any]]]]] = None,
        aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultAspectCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultBackgroundColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultBlur", typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultChromaKey", typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultComposite", typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultCompound", typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultContrast", typing.Dict[builtins.str, typing.Any]]]]] = None,
        crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultFaceCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultFeatureCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultFitAndFill", typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultGoop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultGrayscale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultHsl", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultHsv", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfDimension", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientation", typing.Dict[builtins.str, typing.Any]]]]] = None,
        im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultImQuery", typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultMaxColors", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultMirror", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultMonoHue", typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultOpacity", typing.Dict[builtins.str, typing.Any]]]]] = None,
        region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultRegionOfInterestCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultRelativeCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultRemoveColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultResize", typing.Dict[builtins.str, typing.Any]]]]] = None,
        rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultRotate", typing.Dict[builtins.str, typing.Any]]]]] = None,
        scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultScale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultShear", typing.Dict[builtins.str, typing.Any]]]]] = None,
        trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultTrim", typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultUnsharpMask", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param append: append block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        :param aspect_crop: aspect_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param crop: crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        :param face_crop: face_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        :param feature_crop: feature_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        :param fit_and_fill: fit_and_fill block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param im_query: im_query block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param region_of_interest_crop: region_of_interest_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        :param relative_crop: relative_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param resize: resize block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        :param rotate: rotate block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        :param scale: scale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param shear: shear block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        :param trim: trim block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1263f872530e7e440c019f619574cc2c68517dbefdc7dc3a473168b77af0f059)
            check_type(argname="argument append", value=append, expected_type=type_hints["append"])
            check_type(argname="argument aspect_crop", value=aspect_crop, expected_type=type_hints["aspect_crop"])
            check_type(argname="argument background_color", value=background_color, expected_type=type_hints["background_color"])
            check_type(argname="argument blur", value=blur, expected_type=type_hints["blur"])
            check_type(argname="argument chroma_key", value=chroma_key, expected_type=type_hints["chroma_key"])
            check_type(argname="argument composite", value=composite, expected_type=type_hints["composite"])
            check_type(argname="argument compound", value=compound, expected_type=type_hints["compound"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument crop", value=crop, expected_type=type_hints["crop"])
            check_type(argname="argument face_crop", value=face_crop, expected_type=type_hints["face_crop"])
            check_type(argname="argument feature_crop", value=feature_crop, expected_type=type_hints["feature_crop"])
            check_type(argname="argument fit_and_fill", value=fit_and_fill, expected_type=type_hints["fit_and_fill"])
            check_type(argname="argument goop", value=goop, expected_type=type_hints["goop"])
            check_type(argname="argument grayscale", value=grayscale, expected_type=type_hints["grayscale"])
            check_type(argname="argument hsl", value=hsl, expected_type=type_hints["hsl"])
            check_type(argname="argument hsv", value=hsv, expected_type=type_hints["hsv"])
            check_type(argname="argument if_dimension", value=if_dimension, expected_type=type_hints["if_dimension"])
            check_type(argname="argument if_orientation", value=if_orientation, expected_type=type_hints["if_orientation"])
            check_type(argname="argument im_query", value=im_query, expected_type=type_hints["im_query"])
            check_type(argname="argument max_colors", value=max_colors, expected_type=type_hints["max_colors"])
            check_type(argname="argument mirror", value=mirror, expected_type=type_hints["mirror"])
            check_type(argname="argument mono_hue", value=mono_hue, expected_type=type_hints["mono_hue"])
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument region_of_interest_crop", value=region_of_interest_crop, expected_type=type_hints["region_of_interest_crop"])
            check_type(argname="argument relative_crop", value=relative_crop, expected_type=type_hints["relative_crop"])
            check_type(argname="argument remove_color", value=remove_color, expected_type=type_hints["remove_color"])
            check_type(argname="argument resize", value=resize, expected_type=type_hints["resize"])
            check_type(argname="argument rotate", value=rotate, expected_type=type_hints["rotate"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument shear", value=shear, expected_type=type_hints["shear"])
            check_type(argname="argument trim", value=trim, expected_type=type_hints["trim"])
            check_type(argname="argument unsharp_mask", value=unsharp_mask, expected_type=type_hints["unsharp_mask"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if append is not None:
            self._values["append"] = append
        if aspect_crop is not None:
            self._values["aspect_crop"] = aspect_crop
        if background_color is not None:
            self._values["background_color"] = background_color
        if blur is not None:
            self._values["blur"] = blur
        if chroma_key is not None:
            self._values["chroma_key"] = chroma_key
        if composite is not None:
            self._values["composite"] = composite
        if compound is not None:
            self._values["compound"] = compound
        if contrast is not None:
            self._values["contrast"] = contrast
        if crop is not None:
            self._values["crop"] = crop
        if face_crop is not None:
            self._values["face_crop"] = face_crop
        if feature_crop is not None:
            self._values["feature_crop"] = feature_crop
        if fit_and_fill is not None:
            self._values["fit_and_fill"] = fit_and_fill
        if goop is not None:
            self._values["goop"] = goop
        if grayscale is not None:
            self._values["grayscale"] = grayscale
        if hsl is not None:
            self._values["hsl"] = hsl
        if hsv is not None:
            self._values["hsv"] = hsv
        if if_dimension is not None:
            self._values["if_dimension"] = if_dimension
        if if_orientation is not None:
            self._values["if_orientation"] = if_orientation
        if im_query is not None:
            self._values["im_query"] = im_query
        if max_colors is not None:
            self._values["max_colors"] = max_colors
        if mirror is not None:
            self._values["mirror"] = mirror
        if mono_hue is not None:
            self._values["mono_hue"] = mono_hue
        if opacity is not None:
            self._values["opacity"] = opacity
        if region_of_interest_crop is not None:
            self._values["region_of_interest_crop"] = region_of_interest_crop
        if relative_crop is not None:
            self._values["relative_crop"] = relative_crop
        if remove_color is not None:
            self._values["remove_color"] = remove_color
        if resize is not None:
            self._values["resize"] = resize
        if rotate is not None:
            self._values["rotate"] = rotate
        if scale is not None:
            self._values["scale"] = scale
        if shear is not None:
            self._values["shear"] = shear
        if trim is not None:
            self._values["trim"] = trim
        if unsharp_mask is not None:
            self._values["unsharp_mask"] = unsharp_mask

    @builtins.property
    def append(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultAppend"]]]:
        '''append block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        '''
        result = self._values.get("append")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultAppend"]]], result)

    @builtins.property
    def aspect_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultAspectCrop"]]]:
        '''aspect_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        '''
        result = self._values.get("aspect_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultAspectCrop"]]], result)

    @builtins.property
    def background_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultBackgroundColor"]]]:
        '''background_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        '''
        result = self._values.get("background_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultBackgroundColor"]]], result)

    @builtins.property
    def blur(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultBlur"]]]:
        '''blur block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        '''
        result = self._values.get("blur")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultBlur"]]], result)

    @builtins.property
    def chroma_key(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultChromaKey"]]]:
        '''chroma_key block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        '''
        result = self._values.get("chroma_key")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultChromaKey"]]], result)

    @builtins.property
    def composite(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultComposite"]]]:
        '''composite block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        '''
        result = self._values.get("composite")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultComposite"]]], result)

    @builtins.property
    def compound(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultCompound"]]]:
        '''compound block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        '''
        result = self._values.get("compound")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultCompound"]]], result)

    @builtins.property
    def contrast(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultContrast"]]]:
        '''contrast block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultContrast"]]], result)

    @builtins.property
    def crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultCrop"]]]:
        '''crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        '''
        result = self._values.get("crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultCrop"]]], result)

    @builtins.property
    def face_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultFaceCrop"]]]:
        '''face_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        '''
        result = self._values.get("face_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultFaceCrop"]]], result)

    @builtins.property
    def feature_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultFeatureCrop"]]]:
        '''feature_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        '''
        result = self._values.get("feature_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultFeatureCrop"]]], result)

    @builtins.property
    def fit_and_fill(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultFitAndFill"]]]:
        '''fit_and_fill block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        '''
        result = self._values.get("fit_and_fill")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultFitAndFill"]]], result)

    @builtins.property
    def goop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultGoop"]]]:
        '''goop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        '''
        result = self._values.get("goop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultGoop"]]], result)

    @builtins.property
    def grayscale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultGrayscale"]]]:
        '''grayscale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        '''
        result = self._values.get("grayscale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultGrayscale"]]], result)

    @builtins.property
    def hsl(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultHsl"]]]:
        '''hsl block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        '''
        result = self._values.get("hsl")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultHsl"]]], result)

    @builtins.property
    def hsv(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultHsv"]]]:
        '''hsv block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        '''
        result = self._values.get("hsv")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultHsv"]]], result)

    @builtins.property
    def if_dimension(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfDimension"]]]:
        '''if_dimension block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        '''
        result = self._values.get("if_dimension")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfDimension"]]], result)

    @builtins.property
    def if_orientation(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientation"]]]:
        '''if_orientation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        '''
        result = self._values.get("if_orientation")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientation"]]], result)

    @builtins.property
    def im_query(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultImQuery"]]]:
        '''im_query block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        '''
        result = self._values.get("im_query")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultImQuery"]]], result)

    @builtins.property
    def max_colors(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultMaxColors"]]]:
        '''max_colors block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        '''
        result = self._values.get("max_colors")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultMaxColors"]]], result)

    @builtins.property
    def mirror(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultMirror"]]]:
        '''mirror block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        '''
        result = self._values.get("mirror")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultMirror"]]], result)

    @builtins.property
    def mono_hue(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultMonoHue"]]]:
        '''mono_hue block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        '''
        result = self._values.get("mono_hue")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultMonoHue"]]], result)

    @builtins.property
    def opacity(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultOpacity"]]]:
        '''opacity block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultOpacity"]]], result)

    @builtins.property
    def region_of_interest_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultRegionOfInterestCrop"]]]:
        '''region_of_interest_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        '''
        result = self._values.get("region_of_interest_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultRegionOfInterestCrop"]]], result)

    @builtins.property
    def relative_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultRelativeCrop"]]]:
        '''relative_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        '''
        result = self._values.get("relative_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultRelativeCrop"]]], result)

    @builtins.property
    def remove_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultRemoveColor"]]]:
        '''remove_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        '''
        result = self._values.get("remove_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultRemoveColor"]]], result)

    @builtins.property
    def resize(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultResize"]]]:
        '''resize block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        '''
        result = self._values.get("resize")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultResize"]]], result)

    @builtins.property
    def rotate(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultRotate"]]]:
        '''rotate block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        '''
        result = self._values.get("rotate")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultRotate"]]], result)

    @builtins.property
    def scale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultScale"]]]:
        '''scale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultScale"]]], result)

    @builtins.property
    def shear(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultShear"]]]:
        '''shear block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        '''
        result = self._values.get("shear")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultShear"]]], result)

    @builtins.property
    def trim(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultTrim"]]]:
        '''trim block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        '''
        result = self._values.get("trim")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultTrim"]]], result)

    @builtins.property
    def unsharp_mask(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultUnsharpMask"]]]:
        '''unsharp_mask block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        result = self._values.get("unsharp_mask")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultUnsharpMask"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultAppend",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_priority": "gravityPriority",
        "gravity_priority_var": "gravityPriorityVar",
        "gravity_var": "gravityVar",
        "preserve_minor_dimension": "preserveMinorDimension",
        "preserve_minor_dimension_var": "preserveMinorDimensionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultAppend:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultAppendImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_priority: typing.Optional[builtins.str] = None,
        gravity_priority_var: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        preserve_minor_dimension: typing.Optional[builtins.str] = None,
        preserve_minor_dimension_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Specifies where to place the ``image`` relative to the source image. The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_priority: Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal. The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority DataAkamaiImagingPolicyImage#gravity_priority}
        :param gravity_priority_var: Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal. The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority_var DataAkamaiImagingPolicyImage#gravity_priority_var}
        :param gravity_var: Specifies where to place the ``image`` relative to the source image. The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param preserve_minor_dimension: Whether to preserve the source image's minor dimension, ``false`` by default. The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension DataAkamaiImagingPolicyImage#preserve_minor_dimension}
        :param preserve_minor_dimension_var: Whether to preserve the source image's minor dimension, ``false`` by default. The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension_var DataAkamaiImagingPolicyImage#preserve_minor_dimension_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultAppendImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__09d217c866cd45a0c0ed7308478761e54f94910e4b9a32a75f57d7c34fb886fa)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_priority", value=gravity_priority, expected_type=type_hints["gravity_priority"])
            check_type(argname="argument gravity_priority_var", value=gravity_priority_var, expected_type=type_hints["gravity_priority_var"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument preserve_minor_dimension", value=preserve_minor_dimension, expected_type=type_hints["preserve_minor_dimension"])
            check_type(argname="argument preserve_minor_dimension_var", value=preserve_minor_dimension_var, expected_type=type_hints["preserve_minor_dimension_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_priority is not None:
            self._values["gravity_priority"] = gravity_priority
        if gravity_priority_var is not None:
            self._values["gravity_priority_var"] = gravity_priority_var
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if preserve_minor_dimension is not None:
            self._values["preserve_minor_dimension"] = preserve_minor_dimension
        if preserve_minor_dimension_var is not None:
            self._values["preserve_minor_dimension_var"] = preserve_minor_dimension_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultAppendImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultAppendImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Specifies where to place the ``image`` relative to the source image.

        The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_priority(self) -> typing.Optional[builtins.str]:
        '''Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal.

        The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority DataAkamaiImagingPolicyImage#gravity_priority}
        '''
        result = self._values.get("gravity_priority")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_priority_var(self) -> typing.Optional[builtins.str]:
        '''Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal.

        The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority_var DataAkamaiImagingPolicyImage#gravity_priority_var}
        '''
        result = self._values.get("gravity_priority_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Specifies where to place the ``image`` relative to the source image.

        The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def preserve_minor_dimension(self) -> typing.Optional[builtins.str]:
        '''Whether to preserve the source image's minor dimension, ``false`` by default.

        The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension DataAkamaiImagingPolicyImage#preserve_minor_dimension}
        '''
        result = self._values.get("preserve_minor_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def preserve_minor_dimension_var(self) -> typing.Optional[builtins.str]:
        '''Whether to preserve the source image's minor dimension, ``false`` by default.

        The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension_var DataAkamaiImagingPolicyImage#preserve_minor_dimension_var}
        '''
        result = self._values.get("preserve_minor_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultAppend(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultAppendImage",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultAppendImage:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultAppendImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultAppendImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultAppendImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__726fc4c519c27fdd6d0bf9dc0c4cf4f926c6a9b6992ad4f550558a14b35fe2f5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultAppendImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultAppendImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultAppendImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2934c777fbceba03334e741c8688db67735680c1f40db8f5ab3661a2f94749d0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultAppendList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultAppendList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dcfa8d0266e7570ae831b8cc92098de899f3ec983c81822cb6dafff85d57952c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultAppendOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__05b8e51d0fb78391bc04d76da8e65c002489ab5e9fe35c5d90a13eb741395362)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultAppendOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a5b0c0b73869547049dc15bc3ff4a34be8a38aa126aa0dd327643c408eda493)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__922fc8e83c86ece53de442cc1cda41317288ab93fd69b3f05245f4555b07bd3c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5390c64d6bb810bc197a068ea89368b478bffc474ace510d8089b46dafe88b9d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultAppend]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultAppend]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultAppend]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0d77ab686e46b1d9a89b8c440b869258ffdf6734b67c031090a78aa597dd3ee8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultAppendOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultAppendOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ceb1c0e84b7dad811e4daeaf24c887a098fe8e28d3b86ef9df7add52eda36d26)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultAppendImage()

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityPriority")
    def reset_gravity_priority(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityPriority", []))

    @jsii.member(jsii_name="resetGravityPriorityVar")
    def reset_gravity_priority_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityPriorityVar", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPreserveMinorDimension")
    def reset_preserve_minor_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPreserveMinorDimension", []))

    @jsii.member(jsii_name="resetPreserveMinorDimensionVar")
    def reset_preserve_minor_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPreserveMinorDimensionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultAppendImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultAppendImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityInput")
    def gravity_priority_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityPriorityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityVarInput")
    def gravity_priority_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityPriorityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultAppendImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultAppendImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionInput")
    def preserve_minor_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "preserveMinorDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionVarInput")
    def preserve_minor_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "preserveMinorDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__94a2ca23962cc22dcb4f879cf0d283ce60f34db45bb40574163763cebedf8192)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityPriority")
    def gravity_priority(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityPriority"))

    @gravity_priority.setter
    def gravity_priority(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__238414cc15c5317207eb35a3a874a342e6625d89bf1b0db07ce14c32ff3e8c99)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityPriority", value)

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityVar")
    def gravity_priority_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityPriorityVar"))

    @gravity_priority_var.setter
    def gravity_priority_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__899587ab1514c0fb22460c1ea57cf9d3dd967f15854548d98556fa16059ea4d0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityPriorityVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4c6ed2694f89623ac81aec166b08635be065000114f0898f404bcae45d4b8a0f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimension")
    def preserve_minor_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "preserveMinorDimension"))

    @preserve_minor_dimension.setter
    def preserve_minor_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ecee88be38930571adfa242cd9ff7fbed116a82ae64d962ae0e84a605979b4eb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "preserveMinorDimension", value)

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionVar")
    def preserve_minor_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "preserveMinorDimensionVar"))

    @preserve_minor_dimension_var.setter
    def preserve_minor_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e9e850891eee8eaebb7e28184d2e78892e7023695777cd30846b0641baa6e2dd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "preserveMinorDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultAppend]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultAppend]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultAppend]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ce9511b1e14dfa12ad7d19cf70bb87644d3c2c0b607c695d0cb0326665f693d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultAspectCrop",
    jsii_struct_bases=[],
    name_mapping={
        "allow_expansion": "allowExpansion",
        "allow_expansion_var": "allowExpansionVar",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultAspectCrop:
    def __init__(
        self,
        *,
        allow_expansion: typing.Optional[builtins.str] = None,
        allow_expansion_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_expansion: Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image. Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        :param allow_expansion_var: Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image. Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        :param height: The height term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The width term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        :param x_position: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc9b269407a10a6621077311a74ae385340c572203f05d2440a143d378742e52)
            check_type(argname="argument allow_expansion", value=allow_expansion, expected_type=type_hints["allow_expansion"])
            check_type(argname="argument allow_expansion_var", value=allow_expansion_var, expected_type=type_hints["allow_expansion_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if allow_expansion is not None:
            self._values["allow_expansion"] = allow_expansion
        if allow_expansion_var is not None:
            self._values["allow_expansion_var"] = allow_expansion_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def allow_expansion(self) -> typing.Optional[builtins.str]:
        '''Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image.

        Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        '''
        result = self._values.get("allow_expansion")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def allow_expansion_var(self) -> typing.Optional[builtins.str]:
        '''Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image.

        Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        '''
        result = self._values.get("allow_expansion_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultAspectCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultAspectCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultAspectCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bef946c0058867cc393e75c77509dbda90d7254d5daa36fb302c69a36e683922)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultAspectCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1d9e987dbc3c047407637d7d7227198c3916e08ef8b67cb8be7542fdb1153707)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultAspectCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b8d4ec8eacd6acdf4a4874791441134433a31e532345594a2b32366e93d88047)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c603b85ff0044ee9c279f9c655abe193307013b965c4de9e4a405d5deb109ca1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7c1990d9ac694c6fcd20b7db9e09c7699225e52eab337f6df405e97a74eeb3e5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultAspectCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultAspectCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultAspectCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a178181f5465bbbbfd976e9fbb86d6870eb97f990f8bc5bf4dc6b6868ae985d2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultAspectCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultAspectCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b72f7ed4d64826b6a162adadd9ce3ee304c5cc2d9956c4c90bb014d03347213a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAllowExpansion")
    def reset_allow_expansion(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansion", []))

    @jsii.member(jsii_name="resetAllowExpansionVar")
    def reset_allow_expansion_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansionVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionInput")
    def allow_expansion_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVarInput")
    def allow_expansion_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansion")
    def allow_expansion(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansion"))

    @allow_expansion.setter
    def allow_expansion(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5e0672a56e0e4dd820b314e469d4b35454364f70308f7a66d4e49f2cc634ddb5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansion", value)

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVar")
    def allow_expansion_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansionVar"))

    @allow_expansion_var.setter
    def allow_expansion_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1995fb43d87feaa9e9244ae9c61cb78333abf16050cd8feef1a58cf85a3fe50a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansionVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f35dbbd3f4210f40baf7f82cb48b6147d538d92eaa5f8cab61e4b18f6f5708f0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4b0f9bc2963948f318a86d2d4560f84139fb6491a58347cc305d90a47bfcfa23)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__de33a989daa7a6e3ecbfd1a735ae689be80d683a4629d7022c487e3f4b85ed9c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d691a419c59372401219dbc04e619cd812a607672364ff0b92fc3e88a3a185cd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c2f4c410a096f374f67dc16a00838123f08adc18c93b9aa9936ea0d6028d24cb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0e34f2eec7cdf745230adda70eeb90ac5094a78272cea614b4e685214d0b4b99)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f2d29a9f178890721d3c383dd30028d7f90bef445aaef1316acaf3dbf4960a90)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__03b80750595298897a3ae25755d9d0237f24849af87fa0b948e8f226451bd4aa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultAspectCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultAspectCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultAspectCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a2e3a84f14a0bf361877ad83ce3673743bca84ed527651bc4021575384764f3c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultBackgroundColor",
    jsii_struct_bases=[],
    name_mapping={"color": "color", "color_var": "colorVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultBackgroundColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cdd3d60f1f574d640b52d48e92178d9f769281deb45bd57df52c0d69d4b1cde3)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultBackgroundColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultBackgroundColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultBackgroundColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5e3e008654d8fa83d13cbcd28393a5f16f3d540d84eb7e77a55f02b3b9f61a95)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultBackgroundColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3b81d6b6b615cfe50d2ccb46320e3afe61cced62b3091e35afa7a7d5b0058092)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultBackgroundColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9e072a43cba239731b77e07b7fdec3af6bc3f188019288d63b89bd422982a482)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__43ba28c0cb1b6447d61917fa3e369c72897fef28852430129cc9e63fba4bab7b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6495565e83216aa3a0362875b0823f2ec4c22f2aaadaa6896016414b1e250efb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultBackgroundColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultBackgroundColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b4192fe2a347a977666d4566c2fa769cd9654580c8cc6e14315a25fe3a17d553)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultBackgroundColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultBackgroundColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1542e90536e7efce436cdd6591512e439dd5ccce25add232bb4b09e33cb4d82f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b40a247c590c3379bcf4487fe994f5135679ccc73581df7c22e2aa9548fb8ccc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3823ae3d3ecc96ea05b0ff9c9a6b18c0a57e7b9114e89b93e65bf5b80becd896)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultBackgroundColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultBackgroundColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultBackgroundColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5de2141014e6eaf3373d42608aec13abb6360d529432795d9e75d9fce1b680a4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultBlur",
    jsii_struct_bases=[],
    name_mapping={"sigma": "sigma", "sigma_var": "sigmaVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultBlur:
    def __init__(
        self,
        *,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param sigma: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c62fb8fbc8f2e64039432490f8c64faab18b5f3de3d34634ac8994d06712215c)
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultBlur(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultBlurList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultBlurList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a50041ed43b5a6722d5d301530dbea6db057408ecb57fb09733d09012b824d6d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultBlurOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9bf0550aa02b30e50ab7241b7547a98ce4405fdbec56c8dcc31dc03679c42aac)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultBlurOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__45882d2085ccaf4d21d92a5a3b45527b7111e43aa38e27624260bc5f729b72fa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f3af3fef54fd3d215d28f0dfdc0489606f03843a4f546f233933c0ff853dcf2f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__260119bb052b27b0ecdde1d954a3a143f6e8111491ac36c9f255c3ca30ef45f4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultBlur]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultBlur]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__51e029138fb2ff0a9ee757610c4d33cd2edbc3a3105e3f5b36bb8d51f97b076d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultBlurOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultBlurOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__946891b6cc4feea0cf2555e1151a0e33c76500dde23a500b3d86840f4c8b7811)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3e0d5e9d106203adbdaa63893955a19d76b5dc8daa28cf172b77ddb05ee3eead)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__30b1ef942100718e935ecc71c2d585e56629dff47ace84ec6c644f15357231d3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultBlur]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultBlur]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultBlur]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8e41c5541d7a226533eb73bc9242de4e4ca1d5204c8f64aaf393aa251b480bed)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultChromaKey",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_feather": "hueFeather",
        "hue_feather_var": "hueFeatherVar",
        "hue_tolerance": "hueTolerance",
        "hue_tolerance_var": "hueToleranceVar",
        "hue_var": "hueVar",
        "lightness_feather": "lightnessFeather",
        "lightness_feather_var": "lightnessFeatherVar",
        "lightness_tolerance": "lightnessTolerance",
        "lightness_tolerance_var": "lightnessToleranceVar",
        "saturation_feather": "saturationFeather",
        "saturation_feather_var": "saturationFeatherVar",
        "saturation_tolerance": "saturationTolerance",
        "saturation_tolerance_var": "saturationToleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultChromaKey:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_feather: typing.Optional[builtins.str] = None,
        hue_feather_var: typing.Optional[builtins.str] = None,
        hue_tolerance: typing.Optional[builtins.str] = None,
        hue_tolerance_var: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness_feather: typing.Optional[builtins.str] = None,
        lightness_feather_var: typing.Optional[builtins.str] = None,
        lightness_tolerance: typing.Optional[builtins.str] = None,
        lightness_tolerance_var: typing.Optional[builtins.str] = None,
        saturation_feather: typing.Optional[builtins.str] = None,
        saturation_feather_var: typing.Optional[builtins.str] = None,
        saturation_tolerance: typing.Optional[builtins.str] = None,
        saturation_tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_feather: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        :param hue_feather_var: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        :param hue_tolerance: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        :param hue_tolerance_var: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        :param hue_var: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness_feather: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        :param lightness_feather_var: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        :param lightness_tolerance: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        :param lightness_tolerance_var: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        :param saturation_feather: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        :param saturation_feather_var: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        :param saturation_tolerance: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        :param saturation_tolerance_var: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ae96c2078cdeee9eb0b960fc1f37b3d44a553b216c6f9294cdfe02d02e80da7)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_feather", value=hue_feather, expected_type=type_hints["hue_feather"])
            check_type(argname="argument hue_feather_var", value=hue_feather_var, expected_type=type_hints["hue_feather_var"])
            check_type(argname="argument hue_tolerance", value=hue_tolerance, expected_type=type_hints["hue_tolerance"])
            check_type(argname="argument hue_tolerance_var", value=hue_tolerance_var, expected_type=type_hints["hue_tolerance_var"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness_feather", value=lightness_feather, expected_type=type_hints["lightness_feather"])
            check_type(argname="argument lightness_feather_var", value=lightness_feather_var, expected_type=type_hints["lightness_feather_var"])
            check_type(argname="argument lightness_tolerance", value=lightness_tolerance, expected_type=type_hints["lightness_tolerance"])
            check_type(argname="argument lightness_tolerance_var", value=lightness_tolerance_var, expected_type=type_hints["lightness_tolerance_var"])
            check_type(argname="argument saturation_feather", value=saturation_feather, expected_type=type_hints["saturation_feather"])
            check_type(argname="argument saturation_feather_var", value=saturation_feather_var, expected_type=type_hints["saturation_feather_var"])
            check_type(argname="argument saturation_tolerance", value=saturation_tolerance, expected_type=type_hints["saturation_tolerance"])
            check_type(argname="argument saturation_tolerance_var", value=saturation_tolerance_var, expected_type=type_hints["saturation_tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_feather is not None:
            self._values["hue_feather"] = hue_feather
        if hue_feather_var is not None:
            self._values["hue_feather_var"] = hue_feather_var
        if hue_tolerance is not None:
            self._values["hue_tolerance"] = hue_tolerance
        if hue_tolerance_var is not None:
            self._values["hue_tolerance_var"] = hue_tolerance_var
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness_feather is not None:
            self._values["lightness_feather"] = lightness_feather
        if lightness_feather_var is not None:
            self._values["lightness_feather_var"] = lightness_feather_var
        if lightness_tolerance is not None:
            self._values["lightness_tolerance"] = lightness_tolerance
        if lightness_tolerance_var is not None:
            self._values["lightness_tolerance_var"] = lightness_tolerance_var
        if saturation_feather is not None:
            self._values["saturation_feather"] = saturation_feather
        if saturation_feather_var is not None:
            self._values["saturation_feather_var"] = saturation_feather_var
        if saturation_tolerance is not None:
            self._values["saturation_tolerance"] = saturation_tolerance
        if saturation_tolerance_var is not None:
            self._values["saturation_tolerance_var"] = saturation_tolerance_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        '''
        result = self._values.get("hue_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        '''
        result = self._values.get("hue_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        '''
        result = self._values.get("hue_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        '''
        result = self._values.get("hue_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        '''
        result = self._values.get("lightness_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        '''
        result = self._values.get("lightness_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        '''
        result = self._values.get("lightness_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        '''
        result = self._values.get("lightness_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        '''
        result = self._values.get("saturation_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        '''
        result = self._values.get("saturation_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        '''
        result = self._values.get("saturation_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        result = self._values.get("saturation_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultChromaKey(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultChromaKeyList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultChromaKeyList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aeeb2d559191002f9d6460247f93ff1c793271f89d96065530e099f0293f3976)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultChromaKeyOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c08acd902c65501ad6dc5d5d4a0939a0b82c3ff938ff9b22523ad31e0cc7e1c5)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultChromaKeyOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ab94f39dbeedc1684a4ccb9bcc94bbc02be1c6f487ba12ecdf9951fe20dac8d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f8318369fd63e0441d85afdf32626ac7a17d1a168492b8098e03dcd999b8408)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d91cc0fd9a40188fe41e18b8373627825483fae97063178f6359fa0470af4c65)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultChromaKey]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultChromaKey]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d55ee42112036afcfe6c5fea8ffa29b61920be331958d7bcac69ade0451da83)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultChromaKeyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultChromaKeyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a93e3f27261ab26459b14d6f481a1ef2de65d756c64b10237e04f8e74a783e77)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueFeather")
    def reset_hue_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeather", []))

    @jsii.member(jsii_name="resetHueFeatherVar")
    def reset_hue_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeatherVar", []))

    @jsii.member(jsii_name="resetHueTolerance")
    def reset_hue_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueTolerance", []))

    @jsii.member(jsii_name="resetHueToleranceVar")
    def reset_hue_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueToleranceVar", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightnessFeather")
    def reset_lightness_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeather", []))

    @jsii.member(jsii_name="resetLightnessFeatherVar")
    def reset_lightness_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeatherVar", []))

    @jsii.member(jsii_name="resetLightnessTolerance")
    def reset_lightness_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessTolerance", []))

    @jsii.member(jsii_name="resetLightnessToleranceVar")
    def reset_lightness_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessToleranceVar", []))

    @jsii.member(jsii_name="resetSaturationFeather")
    def reset_saturation_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeather", []))

    @jsii.member(jsii_name="resetSaturationFeatherVar")
    def reset_saturation_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeatherVar", []))

    @jsii.member(jsii_name="resetSaturationTolerance")
    def reset_saturation_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationTolerance", []))

    @jsii.member(jsii_name="resetSaturationToleranceVar")
    def reset_saturation_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherInput")
    def hue_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVarInput")
    def hue_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceInput")
    def hue_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVarInput")
    def hue_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherInput")
    def lightness_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVarInput")
    def lightness_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceInput")
    def lightness_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVarInput")
    def lightness_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherInput")
    def saturation_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVarInput")
    def saturation_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceInput")
    def saturation_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVarInput")
    def saturation_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__09e3350239d3e0a6e467298186b2cb42ff6e84963e5b21c40c268c88767e4796)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeather")
    def hue_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeather"))

    @hue_feather.setter
    def hue_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__13e4f994020a7778c2e3ccf4e4da01d54e7b658905a6172d3db877f52bd84b5f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeather", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVar")
    def hue_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeatherVar"))

    @hue_feather_var.setter
    def hue_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__da02f56884aad708789c194b8eb0493ba3795878066691844b923fb555c73ad1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueTolerance")
    def hue_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueTolerance"))

    @hue_tolerance.setter
    def hue_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__336c2b8efff4b6aec28b56dc3920ef0b46e5b12f5363e2206c0822b6b190d5ea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVar")
    def hue_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueToleranceVar"))

    @hue_tolerance_var.setter
    def hue_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e6b3fa8dbe1a88c79d77d6966189dfb27b38246bfd9c19a6d52d61b43aeb49ac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f23f2fc70a4376e71256b3ea88b2ce7a37ac45cb255562021d363d0befaa0be)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeather")
    def lightness_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeather"))

    @lightness_feather.setter
    def lightness_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__723de178ac53bad9babfbe735c6ce925523503e1ef1f68f26e605c03893f127e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeather", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVar")
    def lightness_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeatherVar"))

    @lightness_feather_var.setter
    def lightness_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b9e5652c47ed4ec0d953e00faa483ec0c248e6480caefdb9a10c1d123bf3bf39)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessTolerance")
    def lightness_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessTolerance"))

    @lightness_tolerance.setter
    def lightness_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dc7598aa09924a66f458c63423088d24802a132019c1870479fb937bcf5c1010)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVar")
    def lightness_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessToleranceVar"))

    @lightness_tolerance_var.setter
    def lightness_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1b1b35aa4b28c74c8723381345b3d4e03c0bc4abafc651749240f6dd022e3b98)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeather")
    def saturation_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeather"))

    @saturation_feather.setter
    def saturation_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6619d01714999fac802f9d985261619a6df6c6bd4a862a61dfdc22ecd49e3642)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeather", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVar")
    def saturation_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeatherVar"))

    @saturation_feather_var.setter
    def saturation_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6cc320b0bc68038e7525e7a2e7533c338fb117173f2651f9b17e8b1dd720860b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationTolerance")
    def saturation_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationTolerance"))

    @saturation_tolerance.setter
    def saturation_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c19c4e9c25cac98b287803f14cff23284ea4b76b84e84588e088dbdc5423123b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVar")
    def saturation_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationToleranceVar"))

    @saturation_tolerance_var.setter
    def saturation_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e26958f1e72fca7b2217bffb795176fedd97d7ede0cd718db031326cc657df5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultChromaKey]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultChromaKey]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultChromaKey]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__04aa886a0b55b210f4d906795c7988d511a973a2bb9ab477d413eba2cce2645f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultComposite",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "placement": "placement",
        "placement_var": "placementVar",
        "scale": "scale",
        "scale_dimension": "scaleDimension",
        "scale_dimension_var": "scaleDimensionVar",
        "scale_var": "scaleVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultComposite:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultCompositeImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        placement: typing.Optional[builtins.str] = None,
        placement_var: typing.Optional[builtins.str] = None,
        scale: typing.Optional[builtins.str] = None,
        scale_dimension: typing.Optional[builtins.str] = None,
        scale_dimension_var: typing.Optional[builtins.str] = None,
        scale_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param placement: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        :param placement_var: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        :param scale: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param scale_dimension: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        :param scale_dimension_var: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        :param scale_var: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        :param x_position: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultCompositeImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__233aacb24ca19ef88ee2307b75ab1478b894bf8ee36f03fb50a0976dbd46c5a6)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument placement", value=placement, expected_type=type_hints["placement"])
            check_type(argname="argument placement_var", value=placement_var, expected_type=type_hints["placement_var"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument scale_dimension", value=scale_dimension, expected_type=type_hints["scale_dimension"])
            check_type(argname="argument scale_dimension_var", value=scale_dimension_var, expected_type=type_hints["scale_dimension_var"])
            check_type(argname="argument scale_var", value=scale_var, expected_type=type_hints["scale_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if placement is not None:
            self._values["placement"] = placement
        if placement_var is not None:
            self._values["placement_var"] = placement_var
        if scale is not None:
            self._values["scale"] = scale
        if scale_dimension is not None:
            self._values["scale_dimension"] = scale_dimension
        if scale_dimension_var is not None:
            self._values["scale_dimension_var"] = scale_dimension_var
        if scale_var is not None:
            self._values["scale_var"] = scale_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultCompositeImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultCompositeImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        '''
        result = self._values.get("placement")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement_var(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        '''
        result = self._values.get("placement_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        '''
        result = self._values.get("scale_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        '''
        result = self._values.get("scale_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        '''
        result = self._values.get("scale_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultComposite(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultCompositeImage",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultCompositeImage:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultCompositeImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultCompositeImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultCompositeImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__26709074b9f05af384ff3bdb2594f22ed4383f9144d7290ffb6b216872ab0cb9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultCompositeImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultCompositeImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__37ec6b44ad4b75c43bb5c49b2402295bf5417fefbb86863c7121494b763c60ce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultCompositeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultCompositeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1c20487ecfdebc885bef47e02c18bee8261b22df5ac883aac30c7ba1db44ad78)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultCompositeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bddc68e74ae07c0281a3299d1276150bcf00b083bd0d0e55ab3d29e44731f6de)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultCompositeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f32790f7d8a809f375ad2efc8708f9a685216bd11bcd31ccfe7674e4f41438fa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2eb1259a10108ad56aadd7d12c2dd7a43cc9d6c7e67fff1954c0ef4d009e7201)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__33fe2e94cae44e8947cd32d887fd4df4c0770dedac8ccc629658a8e626ac76f0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultComposite]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultComposite]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5238f9f786d3626ffe36279a4b1f9cdcfc93e32df17fdbaa0ca5a857c88f668b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultCompositeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultCompositeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7676390dd6af9e5a226d734599d023be75e40cccb4541569e99f1cd881893104)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultCompositeImage()

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPlacement")
    def reset_placement(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacement", []))

    @jsii.member(jsii_name="resetPlacementVar")
    def reset_placement_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacementVar", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetScaleDimension")
    def reset_scale_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimension", []))

    @jsii.member(jsii_name="resetScaleDimensionVar")
    def reset_scale_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimensionVar", []))

    @jsii.member(jsii_name="resetScaleVar")
    def reset_scale_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultCompositeImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultCompositeImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultCompositeImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="placementInput")
    def placement_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementInput"))

    @builtins.property
    @jsii.member(jsii_name="placementVarInput")
    def placement_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionInput")
    def scale_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVarInput")
    def scale_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleVarInput")
    def scale_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a5b81854219fefdff0bae0fbc574915d55ea44693aeb53a4d2c2d8da96bd260f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__70820f5a7ae0dbe71dd68305f61bbccccd4c0099dbd2adde85024888accb8e11)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="placement")
    def placement(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placement"))

    @placement.setter
    def placement(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8e6811f5273fdfb6d59dc6aaddd9f295535a4221622d1bb4f044005228c6bde2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placement", value)

    @builtins.property
    @jsii.member(jsii_name="placementVar")
    def placement_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placementVar"))

    @placement_var.setter
    def placement_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a519deedeb1d3980f5f05b5681f07a1d1128d65f71dc35d7c76d863d8716b18)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placementVar", value)

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scale"))

    @scale.setter
    def scale(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e0733df05189c346d41d8342af4904320ec88936bc8aab84bd05d055078771ec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scale", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimension")
    def scale_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimension"))

    @scale_dimension.setter
    def scale_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__05361a76eb3778b407adc97cf39f4db7c1abaccec903b2f66746713b4852c083)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimension", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVar")
    def scale_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimensionVar"))

    @scale_dimension_var.setter
    def scale_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cfa594999e81a704bf1170ca0ed18817aaad421643bb18482b82fc5b4a06ff25)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="scaleVar")
    def scale_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleVar"))

    @scale_var.setter
    def scale_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__753408a2a91b21e878ca755c5b8b141ea7603bbc119fa93c1400c6fd754bc2d6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__46475251af4b119ee20c3c231cfad7de5627d82f1a904fbf1ecbc1edfc4e26d6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cb7fc29496c39d5b895f4bdd35b56316449582109337703b6387c3a95e0b2a51)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__47ba0b587e9c76b22dd1b2c3dc48c78b77d3a8da9ca3ea7861ae9d981f96e59d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__53051af5478f2474de67eeef21c4ff12d5bb03fd93bc838d82f48ab87a6e6240)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultComposite]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultComposite]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultComposite]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9201c14c3fe74a3c2e33ae8ba79796fe4d554358936a3aa384cdd7b6f2e5f379)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultCompound",
    jsii_struct_bases=[],
    name_mapping={"transformations": "transformations"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultCompound:
    def __init__(
        self,
        *,
        transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param transformations: transformations block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6acde1ab4b67ba060711df2c26c1ec6464ec11f42fffa6788098441eb07638fe)
            check_type(argname="argument transformations", value=transformations, expected_type=type_hints["transformations"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if transformations is not None:
            self._values["transformations"] = transformations

    @builtins.property
    def transformations(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultCompoundTransformations"]]]:
        '''transformations block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        result = self._values.get("transformations")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultCompoundTransformations"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultCompound(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultCompoundList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultCompoundList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4c093d256489bd57b09b1c7a5952763338af62b6abbaee717311b07bf191b1ee)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultCompoundOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ac79cd2e5b1d27efbea67479caaa5ab7905611ffa6ed595a851a85aaabadd04)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultCompoundOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0702a6055612fd23a7056490eb9a89b8a123a7404cd4fc8e7ec1387596da89d3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4c28e05a8e060077276b1db6432098770c5124a2b55d23a6a11df5c9400d56ad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2acfd7957a7472f5d3bc44356b0c346e99bf968c5df789117e3b7c21a354a959)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultCompound]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultCompound]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6fd29c8e25eb68471ec7d92d5a850a178c15b6997d22eda2e48e292870f8e9ee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultCompoundOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultCompoundOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b2e4ceffd8aa319296c2000133362b5efc13241b68af34115d9487e3bdc91ddf)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformations")
    def put_transformations(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e5f7466b964985dc2e2b98dde5426d853b74c6964002f0df7a578320dc76be6f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTransformations", [value]))

    @jsii.member(jsii_name="resetTransformations")
    def reset_transformations(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformations", []))

    @builtins.property
    @jsii.member(jsii_name="transformations")
    def transformations(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultCompoundTransformationsList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultCompoundTransformationsList", jsii.get(self, "transformations"))

    @builtins.property
    @jsii.member(jsii_name="transformationsInput")
    def transformations_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultCompoundTransformations"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultCompoundTransformations"]]], jsii.get(self, "transformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultCompound]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultCompound]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultCompound]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cc79a7630d735ddec127b06d8d26433b3b2f0ee5faf7b45552225daa0a891de6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultCompoundTransformations",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultCompoundTransformations:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultCompoundTransformations(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultCompoundTransformationsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultCompoundTransformationsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__01c24887ef7be7447c9a262104cb531bea47410e1a6aad6a589becd12e735c5d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultCompoundTransformationsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fc81335e596d057e1e423acc7dac899cf1f849de1afbd05dc41b293d3e6d6c43)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultCompoundTransformationsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c27aade4770f2a7262be013b896f69f2fe733a52e8285c2444b66e2de69613c5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__700ba1ff28198fb4de84967e73c38af0a4750f174bc935f6443da0cbb11209a8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6531b685985c2f8ea584707f61b254e292cd49bf3f525febb3c7f82d054724e0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultCompoundTransformations]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultCompoundTransformations]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultCompoundTransformations]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d0c3382e9c4503737008972ee0e37eb87943660525985e20e56e2ea7a0884bf9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultCompoundTransformationsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultCompoundTransformationsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7b655bc08f6c7d4f385df923b005842ffc099f4090368449125c6197e56e83da)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultCompoundTransformations]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultCompoundTransformations]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultCompoundTransformations]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__485731565b98033a4e1bdecdbcda48bba1ca761115a02c0fe0072d0cfdf30389)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultContrast",
    jsii_struct_bases=[],
    name_mapping={
        "brightness": "brightness",
        "brightness_var": "brightnessVar",
        "contrast": "contrast",
        "contrast_var": "contrastVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultContrast:
    def __init__(
        self,
        *,
        brightness: typing.Optional[builtins.str] = None,
        brightness_var: typing.Optional[builtins.str] = None,
        contrast: typing.Optional[builtins.str] = None,
        contrast_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param brightness: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        :param brightness_var: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        :param contrast: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param contrast_var: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__54f5e09d4c91c155c74d76cd9197ee67ec61b8bb4eacf558e0fb40c21237012d)
            check_type(argname="argument brightness", value=brightness, expected_type=type_hints["brightness"])
            check_type(argname="argument brightness_var", value=brightness_var, expected_type=type_hints["brightness_var"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument contrast_var", value=contrast_var, expected_type=type_hints["contrast_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if brightness is not None:
            self._values["brightness"] = brightness
        if brightness_var is not None:
            self._values["brightness_var"] = brightness_var
        if contrast is not None:
            self._values["contrast"] = contrast
        if contrast_var is not None:
            self._values["contrast_var"] = contrast_var

    @builtins.property
    def brightness(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        '''
        result = self._values.get("brightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def brightness_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        '''
        result = self._values.get("brightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        result = self._values.get("contrast_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultContrast(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultContrastList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultContrastList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__60098e12c52f3d1a063de466c29a42d66f384ef2f0b26058bbd30ba30915e8b5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultContrastOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3981bf4e80a52232c379b7ae879260c700763d476cb191fa407a2e2d9c966e44)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultContrastOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ff1fe8300338bf67352af0f715be971c1c56c68b1e8ccc0383578c98669e6db)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d13eab5f7ff3b26f9dade9a337be7eda79e8d46916a951f8b66181693090d288)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f83ff9a331d49f8d1d76efcd8a6a0cc7b943b889dc30bc6a3d7f73e287f19255)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultContrast]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultContrast]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__556344f29a83fcb077dc19572a39b97359063eae2f8900a96e0ef4d9dd24e89a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultContrastOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultContrastOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c93b9242a4389c06f280272b630574dd959f5b0e662c4568d88c2fa532d1961e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetBrightness")
    def reset_brightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightness", []))

    @jsii.member(jsii_name="resetBrightnessVar")
    def reset_brightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightnessVar", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetContrastVar")
    def reset_contrast_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrastVar", []))

    @builtins.property
    @jsii.member(jsii_name="brightnessInput")
    def brightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="brightnessVarInput")
    def brightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastVarInput")
    def contrast_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="brightness")
    def brightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightness"))

    @brightness.setter
    def brightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7ddf5cb3b328e5305727fe937a27d482377a53bb158cea895a6d7d01a8febc7e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightness", value)

    @builtins.property
    @jsii.member(jsii_name="brightnessVar")
    def brightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightnessVar"))

    @brightness_var.setter
    def brightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__51b152c57e916ecf7f283680fbfdbd3490e9a246ba4662765dcf0ed86c4f693f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrast"))

    @contrast.setter
    def contrast(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5152c4f60d25074d10efae7a9154cc07f4ea914b2dca2c39500e5ba68e3b6b59)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrast", value)

    @builtins.property
    @jsii.member(jsii_name="contrastVar")
    def contrast_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrastVar"))

    @contrast_var.setter
    def contrast_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3085f62db2b1fc0182ab43f7047e1e7a4b9c61c13ee9d906be1352e0ed2d80b9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrastVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultContrast]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultContrast]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultContrast]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fcab59cd3d00ab58b92b3477ab26916431c64dec99082aff9d31a5974fba9f47)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultCrop",
    jsii_struct_bases=[],
    name_mapping={
        "allow_expansion": "allowExpansion",
        "allow_expansion_var": "allowExpansionVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultCrop:
    def __init__(
        self,
        *,
        allow_expansion: typing.Optional[builtins.str] = None,
        allow_expansion_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_expansion: If cropping an area outside of the existing canvas, expands the image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        :param allow_expansion_var: If cropping an area outside of the existing canvas, expands the image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        :param gravity: Frame of reference for X and Y Positions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Frame of reference for X and Y Positions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The number of pixels to crop along the y-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The number of pixels to crop along the y-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The number of pixels to crop along the x-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The number of pixels to crop along the x-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        :param x_position: The x-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4b9002e182bb43888e6636033bc1a788ee14cec472bf77622ee7731570a02053)
            check_type(argname="argument allow_expansion", value=allow_expansion, expected_type=type_hints["allow_expansion"])
            check_type(argname="argument allow_expansion_var", value=allow_expansion_var, expected_type=type_hints["allow_expansion_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if allow_expansion is not None:
            self._values["allow_expansion"] = allow_expansion
        if allow_expansion_var is not None:
            self._values["allow_expansion_var"] = allow_expansion_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def allow_expansion(self) -> typing.Optional[builtins.str]:
        '''If cropping an area outside of the existing canvas, expands the image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        '''
        result = self._values.get("allow_expansion")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def allow_expansion_var(self) -> typing.Optional[builtins.str]:
        '''If cropping an area outside of the existing canvas, expands the image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        '''
        result = self._values.get("allow_expansion_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Frame of reference for X and Y Positions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Frame of reference for X and Y Positions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the y-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the y-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the x-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the x-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1902d264d2c0a9a8e33ecbcf5611926d76a12d3eccb3ebec20a11dd210fc2556)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a956391992d346b55307f1f1cd9a3ed62cbbeffa595bf171f3aef1680b3a440a)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3108277a1fb890b978ec73f1594a326f3b1df4c596ad2aa1067bbf2580547612)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__39e87384876e2f74d12623a489e7275ec6988e506f414aeaefd905f5689a6004)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__16b38ee34fae66b8c12a1a7474298baeac12b267b2537a758ee46764ac1a0df3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1e0deffc195b2d17a6c4512e0f850169cd01dff6ee576c82baed541b6530d1c6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4e2c0cffbd46eee0c7d0c3c6ee477cb13ce391aac4410da9a246a84ccae82356)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAllowExpansion")
    def reset_allow_expansion(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansion", []))

    @jsii.member(jsii_name="resetAllowExpansionVar")
    def reset_allow_expansion_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansionVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionInput")
    def allow_expansion_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVarInput")
    def allow_expansion_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansion")
    def allow_expansion(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansion"))

    @allow_expansion.setter
    def allow_expansion(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e5fc60729f00de9cb4e739fb9a9456c9b0d169b149914474ea628b90b5313cb4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansion", value)

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVar")
    def allow_expansion_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansionVar"))

    @allow_expansion_var.setter
    def allow_expansion_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7e8f31e81b69a11d81ddc2ac5b68cf4fb113d14310e2da2ab1134f6f9beb213c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansionVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c1bc1e2e7d3f4006b98fc49085aeb647345b94947538c847b8e2b81a5274dc02)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d2c9a2e56c67affda25d77a0eba9b6e7c28b8259b36231329f966f91142e7f2a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fbbdd428004ba8118c6344497960eddfb158ffef6029c995b96521ece19c92ee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cc671de2595efb74f7965e2d251dad0d55ac363555e328c205e87ce7178227c0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d35b11b7cb77c6a17c9c551750b5d5587eeeda17d28fb9fe0a34920bbc61bb4e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7aaa8ff2659c5d13b7aa03b687e86912300afbfecccd771cfc45728659b8b28e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d283b7f6b16bb7870dcf55d320d4c9f47e0f9849aa0ace666caff7ce1338c425)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__328e1fb2a160b02d95fbc9b38e0d7cc9012bf439fe375939b0de11804c3b6833)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d308aa335681090bc3b3a871aa12fe0d311a9c8452789b4b0a352fe05279d2ec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ce929a00f23a0ba1ad0de1fdf25add60f8a577e9df44f88d28e0ec05a7c2f402)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1d87a1ba52098b0d0d1767b72e7482d1260d4b4706c049694b7c944fdb6051cd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultFaceCrop",
    jsii_struct_bases=[],
    name_mapping={
        "algorithm": "algorithm",
        "algorithm_var": "algorithmVar",
        "confidence": "confidence",
        "confidence_var": "confidenceVar",
        "fail_gravity": "failGravity",
        "fail_gravity_var": "failGravityVar",
        "focus": "focus",
        "focus_var": "focusVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "padding": "padding",
        "padding_var": "paddingVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultFaceCrop:
    def __init__(
        self,
        *,
        algorithm: typing.Optional[builtins.str] = None,
        algorithm_var: typing.Optional[builtins.str] = None,
        confidence: typing.Optional[builtins.str] = None,
        confidence_var: typing.Optional[builtins.str] = None,
        fail_gravity: typing.Optional[builtins.str] = None,
        fail_gravity_var: typing.Optional[builtins.str] = None,
        focus: typing.Optional[builtins.str] = None,
        focus_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param algorithm: Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm DataAkamaiImagingPolicyImage#algorithm}
        :param algorithm_var: Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm_var DataAkamaiImagingPolicyImage#algorithm_var}
        :param confidence: With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image. Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence DataAkamaiImagingPolicyImage#confidence}
        :param confidence_var: With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image. Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence_var DataAkamaiImagingPolicyImage#confidence_var}
        :param fail_gravity: Controls placement of the crop if Image and Video Manager does not detect any faces in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        :param fail_gravity_var: Controls placement of the crop if Image and Video Manager does not detect any faces in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        :param focus: Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus DataAkamaiImagingPolicyImage#focus}
        :param focus_var: Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus_var DataAkamaiImagingPolicyImage#focus_var}
        :param gravity: Controls placement of the crop. Directions are relative to the face(s) plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Controls placement of the crop. Directions are relative to the face(s) plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param padding: The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        :param style: Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3fddc320f9e3ca6f239bc5512d6ce8d66d07b1a2703ca0e87fc33fbd861977ae)
            check_type(argname="argument algorithm", value=algorithm, expected_type=type_hints["algorithm"])
            check_type(argname="argument algorithm_var", value=algorithm_var, expected_type=type_hints["algorithm_var"])
            check_type(argname="argument confidence", value=confidence, expected_type=type_hints["confidence"])
            check_type(argname="argument confidence_var", value=confidence_var, expected_type=type_hints["confidence_var"])
            check_type(argname="argument fail_gravity", value=fail_gravity, expected_type=type_hints["fail_gravity"])
            check_type(argname="argument fail_gravity_var", value=fail_gravity_var, expected_type=type_hints["fail_gravity_var"])
            check_type(argname="argument focus", value=focus, expected_type=type_hints["focus"])
            check_type(argname="argument focus_var", value=focus_var, expected_type=type_hints["focus_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if algorithm is not None:
            self._values["algorithm"] = algorithm
        if algorithm_var is not None:
            self._values["algorithm_var"] = algorithm_var
        if confidence is not None:
            self._values["confidence"] = confidence
        if confidence_var is not None:
            self._values["confidence_var"] = confidence_var
        if fail_gravity is not None:
            self._values["fail_gravity"] = fail_gravity
        if fail_gravity_var is not None:
            self._values["fail_gravity_var"] = fail_gravity_var
        if focus is not None:
            self._values["focus"] = focus
        if focus_var is not None:
            self._values["focus_var"] = focus_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def algorithm(self) -> typing.Optional[builtins.str]:
        '''Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm DataAkamaiImagingPolicyImage#algorithm}
        '''
        result = self._values.get("algorithm")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def algorithm_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm_var DataAkamaiImagingPolicyImage#algorithm_var}
        '''
        result = self._values.get("algorithm_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def confidence(self) -> typing.Optional[builtins.str]:
        '''With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image.

        Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence DataAkamaiImagingPolicyImage#confidence}
        '''
        result = self._values.get("confidence")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def confidence_var(self) -> typing.Optional[builtins.str]:
        '''With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image.

        Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence_var DataAkamaiImagingPolicyImage#confidence_var}
        '''
        result = self._values.get("confidence_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any faces in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        '''
        result = self._values.get("fail_gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any faces in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        '''
        result = self._values.get("fail_gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def focus(self) -> typing.Optional[builtins.str]:
        '''Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus DataAkamaiImagingPolicyImage#focus}
        '''
        result = self._values.get("focus")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def focus_var(self) -> typing.Optional[builtins.str]:
        '''Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus_var DataAkamaiImagingPolicyImage#focus_var}
        '''
        result = self._values.get("focus_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the face(s) plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the face(s) plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultFaceCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultFaceCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultFaceCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__16231f4a2fb6c96a97b4dbc50f6573fc0161c0c79cb26c9989f1c82902feea0d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultFaceCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a98f28c61baae76686d5dacc63660754c4aa230001829d70d837f1d14323f428)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultFaceCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4c1de4e756860ee79990353a21f0160ef2219c2d496ba3ade9da19975d1e22be)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fb001c4e4c9d4fed8987c53619241064b7c764fa5bc17f081331a2b9307968e3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a6954334911daf92db20895addde081b1068ae63a124271349617669f9c4e821)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultFaceCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultFaceCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultFaceCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7aff1721a9c2e8011427656751bef6d2d9da2b8cbd014a2520e26cf8004a8bf4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultFaceCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultFaceCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__162a6df9eb32b7c4b5f136096a12ddd0ed13d0075dd41fc1730c94eb3b29d0e3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAlgorithm")
    def reset_algorithm(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAlgorithm", []))

    @jsii.member(jsii_name="resetAlgorithmVar")
    def reset_algorithm_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAlgorithmVar", []))

    @jsii.member(jsii_name="resetConfidence")
    def reset_confidence(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetConfidence", []))

    @jsii.member(jsii_name="resetConfidenceVar")
    def reset_confidence_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetConfidenceVar", []))

    @jsii.member(jsii_name="resetFailGravity")
    def reset_fail_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravity", []))

    @jsii.member(jsii_name="resetFailGravityVar")
    def reset_fail_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravityVar", []))

    @jsii.member(jsii_name="resetFocus")
    def reset_focus(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFocus", []))

    @jsii.member(jsii_name="resetFocusVar")
    def reset_focus_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFocusVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="algorithmInput")
    def algorithm_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "algorithmInput"))

    @builtins.property
    @jsii.member(jsii_name="algorithmVarInput")
    def algorithm_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "algorithmVarInput"))

    @builtins.property
    @jsii.member(jsii_name="confidenceInput")
    def confidence_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "confidenceInput"))

    @builtins.property
    @jsii.member(jsii_name="confidenceVarInput")
    def confidence_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "confidenceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityInput")
    def fail_gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityVarInput")
    def fail_gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="focusInput")
    def focus_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "focusInput"))

    @builtins.property
    @jsii.member(jsii_name="focusVarInput")
    def focus_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "focusVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="algorithm")
    def algorithm(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "algorithm"))

    @algorithm.setter
    def algorithm(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__36330cea25ea8de74ce3b561b175a63f5b4236f95b1d06615c585a6ff49b6717)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "algorithm", value)

    @builtins.property
    @jsii.member(jsii_name="algorithmVar")
    def algorithm_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "algorithmVar"))

    @algorithm_var.setter
    def algorithm_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__db717c6b8ed3083b734d51f36f2a0d4922b6fe34f5a08be132c2c762bf7853b9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "algorithmVar", value)

    @builtins.property
    @jsii.member(jsii_name="confidence")
    def confidence(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "confidence"))

    @confidence.setter
    def confidence(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__50d3bb261967a1ec3822356faf5f5373958b995b0146a09dc808906facda6819)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "confidence", value)

    @builtins.property
    @jsii.member(jsii_name="confidenceVar")
    def confidence_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "confidenceVar"))

    @confidence_var.setter
    def confidence_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6aaa1090426e61c11235808f4e164066115b956d2561d6ccaf31d76e950c8469)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "confidenceVar", value)

    @builtins.property
    @jsii.member(jsii_name="failGravity")
    def fail_gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravity"))

    @fail_gravity.setter
    def fail_gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__89ac26f7c5a5dc177ca83e36bdc477c148d82327f8ce4e5b0206dbc662b2c4f0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravity", value)

    @builtins.property
    @jsii.member(jsii_name="failGravityVar")
    def fail_gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravityVar"))

    @fail_gravity_var.setter
    def fail_gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__64f23fb6f774d67c2138da1c6dacde24d114b01083151bb6b44b5b5c8004091e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="focus")
    def focus(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "focus"))

    @focus.setter
    def focus(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b291fdf18e6ebd90e91051148bbcb1dcfa18d76ac56272c83db03aa5862ab6f8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "focus", value)

    @builtins.property
    @jsii.member(jsii_name="focusVar")
    def focus_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "focusVar"))

    @focus_var.setter
    def focus_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a88f87992e0a11338f2f539f760d30cfdd4d7f42b1d6c3ecadcc6dfe1e992466)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "focusVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5bdebe5e63dba6256f978ad8b5c6c0082b2e1a0729b3a0996416c4f94dbc9ed0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5c7575345fefb355bb21867d168f222968b4877bb5a56f280a02e065011de939)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__98d218523d3330bcb974ec6df84fbd10a94de5cb7a1a9f606f5adeb0f010b37d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f80970fef85d3c53ff5c92c54c6b3322bd94e206cf7bba41c9e8269fb3e628c6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2b1d42b44e6d0aa476adf6449d42b04678901d32c9d8bd5e46c3ca5c65ff0d86)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c4f4a3fd8e797db94167e4e65a725346c28dbea0073904ed93e1e6f881009da4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e707fb201d2c819b5c7630b7295e3d14eced2a2dc219b67debd6b8aae5c0a9ec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e90aa8a4b3e1994714ea78712bffaf37d3450bf21bdff6bedf03e336d6bc0a78)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1412f190b4f468892756e839873f664df03e3aef22e2a2c997290378bd9423af)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__39039c2d0e408f28c1b490073c6ea3ab5dab470f5ec6f9335958bffe5f5df7a8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultFaceCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultFaceCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultFaceCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df83e4a0c2bc3e9820b87b281904474f1b1dfdb0b15c97e3dd96eb77a04b799f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultFeatureCrop",
    jsii_struct_bases=[],
    name_mapping={
        "fail_gravity": "failGravity",
        "fail_gravity_var": "failGravityVar",
        "feature_radius": "featureRadius",
        "feature_radius_var": "featureRadiusVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "max_features": "maxFeatures",
        "max_features_var": "maxFeaturesVar",
        "min_feature_quality": "minFeatureQuality",
        "min_feature_quality_var": "minFeatureQualityVar",
        "padding": "padding",
        "padding_var": "paddingVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultFeatureCrop:
    def __init__(
        self,
        *,
        fail_gravity: typing.Optional[builtins.str] = None,
        fail_gravity_var: typing.Optional[builtins.str] = None,
        feature_radius: typing.Optional[builtins.str] = None,
        feature_radius_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        max_features: typing.Optional[builtins.str] = None,
        max_features_var: typing.Optional[builtins.str] = None,
        min_feature_quality: typing.Optional[builtins.str] = None,
        min_feature_quality_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fail_gravity: Controls placement of the crop if Image and Video Manager does not detect any features in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        :param fail_gravity_var: Controls placement of the crop if Image and Video Manager does not detect any features in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        :param feature_radius: The size in pixels of the important features to search for. If identified, two features never appear closer together than this value, ``8.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius DataAkamaiImagingPolicyImage#feature_radius}
        :param feature_radius_var: The size in pixels of the important features to search for. If identified, two features never appear closer together than this value, ``8.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius_var DataAkamaiImagingPolicyImage#feature_radius_var}
        :param gravity: Controls placement of the crop. Directions are relative to the region of interest plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Controls placement of the crop. Directions are relative to the region of interest plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param max_features: The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features DataAkamaiImagingPolicyImage#max_features}
        :param max_features_var: The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features_var DataAkamaiImagingPolicyImage#max_features_var}
        :param min_feature_quality: Determines the minimum quality level of the feature identified. To consider a feature important, the feature needs to surpass this value. Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality DataAkamaiImagingPolicyImage#min_feature_quality}
        :param min_feature_quality_var: Determines the minimum quality level of the feature identified. To consider a feature important, the feature needs to surpass this value. Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality_var DataAkamaiImagingPolicyImage#min_feature_quality_var}
        :param padding: Adds space around the region of interest. The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: Adds space around the region of interest. The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        :param style: Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ace86bfc407e9d0a7cee953373f4ae1a0159d11386ffd2f812329ab870f7183a)
            check_type(argname="argument fail_gravity", value=fail_gravity, expected_type=type_hints["fail_gravity"])
            check_type(argname="argument fail_gravity_var", value=fail_gravity_var, expected_type=type_hints["fail_gravity_var"])
            check_type(argname="argument feature_radius", value=feature_radius, expected_type=type_hints["feature_radius"])
            check_type(argname="argument feature_radius_var", value=feature_radius_var, expected_type=type_hints["feature_radius_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument max_features", value=max_features, expected_type=type_hints["max_features"])
            check_type(argname="argument max_features_var", value=max_features_var, expected_type=type_hints["max_features_var"])
            check_type(argname="argument min_feature_quality", value=min_feature_quality, expected_type=type_hints["min_feature_quality"])
            check_type(argname="argument min_feature_quality_var", value=min_feature_quality_var, expected_type=type_hints["min_feature_quality_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fail_gravity is not None:
            self._values["fail_gravity"] = fail_gravity
        if fail_gravity_var is not None:
            self._values["fail_gravity_var"] = fail_gravity_var
        if feature_radius is not None:
            self._values["feature_radius"] = feature_radius
        if feature_radius_var is not None:
            self._values["feature_radius_var"] = feature_radius_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if max_features is not None:
            self._values["max_features"] = max_features
        if max_features_var is not None:
            self._values["max_features_var"] = max_features_var
        if min_feature_quality is not None:
            self._values["min_feature_quality"] = min_feature_quality
        if min_feature_quality_var is not None:
            self._values["min_feature_quality_var"] = min_feature_quality_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def fail_gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any features in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        '''
        result = self._values.get("fail_gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any features in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        '''
        result = self._values.get("fail_gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feature_radius(self) -> typing.Optional[builtins.str]:
        '''The size in pixels of the important features to search for.

        If identified, two features never appear closer together than this value, ``8.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius DataAkamaiImagingPolicyImage#feature_radius}
        '''
        result = self._values.get("feature_radius")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feature_radius_var(self) -> typing.Optional[builtins.str]:
        '''The size in pixels of the important features to search for.

        If identified, two features never appear closer together than this value, ``8.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius_var DataAkamaiImagingPolicyImage#feature_radius_var}
        '''
        result = self._values.get("feature_radius_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the region of interest plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the region of interest plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def max_features(self) -> typing.Optional[builtins.str]:
        '''The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features DataAkamaiImagingPolicyImage#max_features}
        '''
        result = self._values.get("max_features")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def max_features_var(self) -> typing.Optional[builtins.str]:
        '''The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features_var DataAkamaiImagingPolicyImage#max_features_var}
        '''
        result = self._values.get("max_features_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def min_feature_quality(self) -> typing.Optional[builtins.str]:
        '''Determines the minimum quality level of the feature identified.

        To consider a feature important, the feature needs to surpass this value.  Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality DataAkamaiImagingPolicyImage#min_feature_quality}
        '''
        result = self._values.get("min_feature_quality")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def min_feature_quality_var(self) -> typing.Optional[builtins.str]:
        '''Determines the minimum quality level of the feature identified.

        To consider a feature important, the feature needs to surpass this value.  Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality_var DataAkamaiImagingPolicyImage#min_feature_quality_var}
        '''
        result = self._values.get("min_feature_quality_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''Adds space around the region of interest.

        The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''Adds space around the region of interest.

        The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultFeatureCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultFeatureCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultFeatureCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aeb37bd98395b60e6440b0c0b497b59b7899f233fcc2e78127c02edb0e5ddff6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultFeatureCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b71147285e4de4cc083381aa0966f54a9e6d85c6c93d4cb23e1eed9def4ecf31)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultFeatureCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc7f5949a2903659f4c18cfa180cba083399b059d247673d1222fc22016d046a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3f8c719a74cb242d71042798ec301a0853aa5436e58174d6b294670ba96daef2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a36fd0e0b05a02aa6dcdb159937653a23454e1271e9e601b0735a2176c141253)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultFeatureCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultFeatureCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultFeatureCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__120b70e7772da4c324653773ea99aa3ef4dd2a8ad716886487fe3f473a6e56b7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultFeatureCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultFeatureCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__faf532ea89ac0ec4da246afa18aa22b0d9214ba5f5a5705668896d3da1394aa2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetFailGravity")
    def reset_fail_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravity", []))

    @jsii.member(jsii_name="resetFailGravityVar")
    def reset_fail_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravityVar", []))

    @jsii.member(jsii_name="resetFeatureRadius")
    def reset_feature_radius(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureRadius", []))

    @jsii.member(jsii_name="resetFeatureRadiusVar")
    def reset_feature_radius_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureRadiusVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetMaxFeatures")
    def reset_max_features(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxFeatures", []))

    @jsii.member(jsii_name="resetMaxFeaturesVar")
    def reset_max_features_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxFeaturesVar", []))

    @jsii.member(jsii_name="resetMinFeatureQuality")
    def reset_min_feature_quality(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMinFeatureQuality", []))

    @jsii.member(jsii_name="resetMinFeatureQualityVar")
    def reset_min_feature_quality_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMinFeatureQualityVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="failGravityInput")
    def fail_gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityVarInput")
    def fail_gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featureRadiusInput")
    def feature_radius_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featureRadiusInput"))

    @builtins.property
    @jsii.member(jsii_name="featureRadiusVarInput")
    def feature_radius_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featureRadiusVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesInput")
    def max_features_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "maxFeaturesInput"))

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesVarInput")
    def max_features_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "maxFeaturesVarInput"))

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityInput")
    def min_feature_quality_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "minFeatureQualityInput"))

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityVarInput")
    def min_feature_quality_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "minFeatureQualityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravity")
    def fail_gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravity"))

    @fail_gravity.setter
    def fail_gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3f3e45bf9063d012e0d708cd45d44f8dc65adde5248845d9200d48a7c982a038)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravity", value)

    @builtins.property
    @jsii.member(jsii_name="failGravityVar")
    def fail_gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravityVar"))

    @fail_gravity_var.setter
    def fail_gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d41f8594c6238a5746e0817d16bbcfb46938f940d60693f561e04cc539e41455)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="featureRadius")
    def feature_radius(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featureRadius"))

    @feature_radius.setter
    def feature_radius(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a63e10229cd4de7b878098b14c8ba8060e1ff8e8f1d30416833cdc82a0f3675)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featureRadius", value)

    @builtins.property
    @jsii.member(jsii_name="featureRadiusVar")
    def feature_radius_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featureRadiusVar"))

    @feature_radius_var.setter
    def feature_radius_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d060482cefb1e0bb35add431efeee44d09cacc6f20f3426b26f73cf98841da3d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featureRadiusVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9aabea596b27ad1c0ebd558b362c43d81f1b2d0e1363d51aad1bb92493b7ed2e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d7b753c348ffcd2867542f7b65203f3f925d572e48b7dca4c1b630859135036b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4faab0fe8e53ecc44bef8277efcd5adb46f6b4f3d3f1c44d9e4da91fcea5227d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c81ed55f720ce9742cd9011f66173aa347da31dd19fd8fa35a2a2f0a180c47ea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="maxFeatures")
    def max_features(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "maxFeatures"))

    @max_features.setter
    def max_features(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__79a110ef517b2fde4623dd0bf50d63efd5bba893ce2a9dcb713a3fc5090b603f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "maxFeatures", value)

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesVar")
    def max_features_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "maxFeaturesVar"))

    @max_features_var.setter
    def max_features_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1e35a7a8d7edb8e36bd02c9a2e922b62dbe2060a3b80b6aec47b1c941ff7c5f7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "maxFeaturesVar", value)

    @builtins.property
    @jsii.member(jsii_name="minFeatureQuality")
    def min_feature_quality(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "minFeatureQuality"))

    @min_feature_quality.setter
    def min_feature_quality(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b769918c2b6ba4ae7eb5c056fc410a803050254c3131f72b94ae25969fa39a1b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "minFeatureQuality", value)

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityVar")
    def min_feature_quality_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "minFeatureQualityVar"))

    @min_feature_quality_var.setter
    def min_feature_quality_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__21657636637a81db1893bd80c060d53d11eb625bc004d6e5946da70d2df39faf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "minFeatureQualityVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__67aaba687b2410589fde44a234dd5840352aedacc178ac0039b5363b77c2986b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a04b077e356ebd25c547867033d52c9c4094bfafd8db74167320a7096778f78)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__90ae72e4cf6d34f659b506ab4530e9341e4020427aa693a96207c2940e703740)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3eb50f33259ffc186e54ce15835340db19b3dffbcac743bd4bb0eb0d0322f965)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7ad07a16f03726b3997b43401b6637a7424fba59942cd8a3f4ce0eb258cf93a0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c7c6816fb7b9cf11be983716708df3f31af1317b3166ed35365bea273585c773)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultFeatureCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultFeatureCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultFeatureCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9e90539319ed410ea072d72cd632011fb36d6072d4fd29f8f6611d65e22835a5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultFitAndFill",
    jsii_struct_bases=[],
    name_mapping={
        "fill_transformation": "fillTransformation",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultFitAndFill:
    def __init__(
        self,
        *,
        fill_transformation: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultFitAndFillFillTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fill_transformation: fill_transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_transformation DataAkamaiImagingPolicyImage#fill_transformation}
        :param height: The height value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The width value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(fill_transformation, dict):
            fill_transformation = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultFitAndFillFillTransformation(**fill_transformation)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dced1267807b8882d9621f52e2e669f807f281871157c67c682b551c99829d61)
            check_type(argname="argument fill_transformation", value=fill_transformation, expected_type=type_hints["fill_transformation"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fill_transformation is not None:
            self._values["fill_transformation"] = fill_transformation
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def fill_transformation(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultFitAndFillFillTransformation"]:
        '''fill_transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_transformation DataAkamaiImagingPolicyImage#fill_transformation}
        '''
        result = self._values.get("fill_transformation")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultFitAndFillFillTransformation"], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultFitAndFill(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultFitAndFillFillTransformation",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultFitAndFillFillTransformation:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultFitAndFillFillTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultFitAndFillFillTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultFitAndFillFillTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f8cf0695537d0c5bc87c0c6ba576098e3513e4ffdf60ad57d21f35e89abc361)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultFitAndFillFillTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultFitAndFillFillTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultFitAndFillFillTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a5b3f0b7fbf85b7777d9837c92689fb7ba2724b85b042497a35334349a2adb8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultFitAndFillList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultFitAndFillList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__66641a593e94b1513136ac39ef72d8baafa340a92e83883c4b957b12b19961e1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultFitAndFillOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a8d86137544d80ea93b6bd28be903e61eaa25346ae83718550aea73d3c3a586b)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultFitAndFillOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a60b1f5c0455878012c9ff41cfe759e2c5ba22da41707fd8bf01adf96ff238ef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e05840dbb0a2c12ec2eb03764f80106ffa5367594057961f9ebb1d7fa859f2de)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e9c7e8c75efb50595627ea26544315fe0ffe1be0330c1aa1532d51d793e7eefe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultFitAndFill]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultFitAndFill]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultFitAndFill]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b1ebe2a777bc43233915b62b593fc3d428631f40fffd97fabee577dd8ab72f8f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultFitAndFillOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultFitAndFillOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__828b2d076c72677faf52cca1956d509551dbd410862a814295212e5ae8e472ca)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putFillTransformation")
    def put_fill_transformation(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultFitAndFillFillTransformation()

        return typing.cast(None, jsii.invoke(self, "putFillTransformation", [value]))

    @jsii.member(jsii_name="resetFillTransformation")
    def reset_fill_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFillTransformation", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="fillTransformation")
    def fill_transformation(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultFitAndFillFillTransformationOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultFitAndFillFillTransformationOutputReference, jsii.get(self, "fillTransformation"))

    @builtins.property
    @jsii.member(jsii_name="fillTransformationInput")
    def fill_transformation_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultFitAndFillFillTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultFitAndFillFillTransformation], jsii.get(self, "fillTransformationInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9270931a3d3f237b6f2f0809d312b2ffd3038ae899ffa7f7b5eb4a462183e4f2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dd0b0f9258155121f098b813fefee7786e7579e7046c7101790e93e16067fb37)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af7a6d897f4d1d412e77da98e6d4cacd17bc3f4eff2f123a528c8be23f1d8ce4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d779002a92685a1a2d1f8e46153f1b336f9d57c5c456ac678b5378006a4a68a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultFitAndFill]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultFitAndFill]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultFitAndFill]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ca47af2489727a69b9421453de384744e9850fe5db7589e10c20d79652a62e94)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultGoop",
    jsii_struct_bases=[],
    name_mapping={
        "chaos": "chaos",
        "chaos_var": "chaosVar",
        "density": "density",
        "density_var": "densityVar",
        "power": "power",
        "power_var": "powerVar",
        "seed": "seed",
        "seed_var": "seedVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultGoop:
    def __init__(
        self,
        *,
        chaos: typing.Optional[builtins.str] = None,
        chaos_var: typing.Optional[builtins.str] = None,
        density: typing.Optional[builtins.str] = None,
        density_var: typing.Optional[builtins.str] = None,
        power: typing.Optional[builtins.str] = None,
        power_var: typing.Optional[builtins.str] = None,
        seed: typing.Optional[builtins.str] = None,
        seed_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param chaos: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        :param chaos_var: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        :param density: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        :param density_var: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        :param power: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        :param power_var: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        :param seed: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        :param seed_var: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__867459ab42fd85d79305ef55124a9b684ea706261d458242c5841e94da360961)
            check_type(argname="argument chaos", value=chaos, expected_type=type_hints["chaos"])
            check_type(argname="argument chaos_var", value=chaos_var, expected_type=type_hints["chaos_var"])
            check_type(argname="argument density", value=density, expected_type=type_hints["density"])
            check_type(argname="argument density_var", value=density_var, expected_type=type_hints["density_var"])
            check_type(argname="argument power", value=power, expected_type=type_hints["power"])
            check_type(argname="argument power_var", value=power_var, expected_type=type_hints["power_var"])
            check_type(argname="argument seed", value=seed, expected_type=type_hints["seed"])
            check_type(argname="argument seed_var", value=seed_var, expected_type=type_hints["seed_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if chaos is not None:
            self._values["chaos"] = chaos
        if chaos_var is not None:
            self._values["chaos_var"] = chaos_var
        if density is not None:
            self._values["density"] = density
        if density_var is not None:
            self._values["density_var"] = density_var
        if power is not None:
            self._values["power"] = power
        if power_var is not None:
            self._values["power_var"] = power_var
        if seed is not None:
            self._values["seed"] = seed
        if seed_var is not None:
            self._values["seed_var"] = seed_var

    @builtins.property
    def chaos(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        '''
        result = self._values.get("chaos")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def chaos_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        '''
        result = self._values.get("chaos_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        '''
        result = self._values.get("density")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density_var(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        '''
        result = self._values.get("density_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        '''
        result = self._values.get("power")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power_var(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        '''
        result = self._values.get("power_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        '''
        result = self._values.get("seed")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed_var(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        result = self._values.get("seed_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultGoop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultGoopList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultGoopList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5552b0a4edd347195f0d532cf5bf7ccc37aa6b213f959efe1db020c072407a69)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultGoopOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac61c864d59d8492f7c58cf4a369eba3cd5af41e5049b946dddd27de5c3eee8c)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultGoopOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c70b498faf7f7275ccd2240e3f7e86200e2749b6732abf74531f3825fc75ad99)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8df2d64b3c385923e7e88ae6b0597cd84603be732cd5120c16d9604c362dcd63)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9768e228d31f5716703d12cc19c3f66ff40fe6e9a1c472e2692f881365b79d6e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultGoop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultGoop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__61e7cd4be1013929b50b529e94aa675ac7d1625eea335b8007fdacea5f9cc8f1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultGoopOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultGoopOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6bfcf169cea7edcd44cb4fbe2fe206152596c0353106f4091fbf4f459b7a2494)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetChaos")
    def reset_chaos(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaos", []))

    @jsii.member(jsii_name="resetChaosVar")
    def reset_chaos_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaosVar", []))

    @jsii.member(jsii_name="resetDensity")
    def reset_density(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensity", []))

    @jsii.member(jsii_name="resetDensityVar")
    def reset_density_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensityVar", []))

    @jsii.member(jsii_name="resetPower")
    def reset_power(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPower", []))

    @jsii.member(jsii_name="resetPowerVar")
    def reset_power_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPowerVar", []))

    @jsii.member(jsii_name="resetSeed")
    def reset_seed(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeed", []))

    @jsii.member(jsii_name="resetSeedVar")
    def reset_seed_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeedVar", []))

    @builtins.property
    @jsii.member(jsii_name="chaosInput")
    def chaos_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosInput"))

    @builtins.property
    @jsii.member(jsii_name="chaosVarInput")
    def chaos_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosVarInput"))

    @builtins.property
    @jsii.member(jsii_name="densityInput")
    def density_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityInput"))

    @builtins.property
    @jsii.member(jsii_name="densityVarInput")
    def density_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="powerInput")
    def power_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerInput"))

    @builtins.property
    @jsii.member(jsii_name="powerVarInput")
    def power_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerVarInput"))

    @builtins.property
    @jsii.member(jsii_name="seedInput")
    def seed_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedInput"))

    @builtins.property
    @jsii.member(jsii_name="seedVarInput")
    def seed_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedVarInput"))

    @builtins.property
    @jsii.member(jsii_name="chaos")
    def chaos(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaos"))

    @chaos.setter
    def chaos(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__13a816f0a98cf33bb10c7cf5002ba60df43bb65a293a5a443b7d71345431746a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaos", value)

    @builtins.property
    @jsii.member(jsii_name="chaosVar")
    def chaos_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaosVar"))

    @chaos_var.setter
    def chaos_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fd17daf240dc38c55d7ce6506e085ea1b80eb0b91a74b1e896ed1e038959d3dd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaosVar", value)

    @builtins.property
    @jsii.member(jsii_name="density")
    def density(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "density"))

    @density.setter
    def density(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d8a9bd926a8e387af93f8fff27d8788c57f66fc7d74c2416fb1b103ca4e33859)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "density", value)

    @builtins.property
    @jsii.member(jsii_name="densityVar")
    def density_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "densityVar"))

    @density_var.setter
    def density_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__107a1fcd496ab802721f5fc7a719a920c42d29880995e765bdb42c85bd0c3b32)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "densityVar", value)

    @builtins.property
    @jsii.member(jsii_name="power")
    def power(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "power"))

    @power.setter
    def power(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b0adcbd17f937a6963c5345187ee8cf6964a9f9ab86d48c1421ff58318cbf567)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "power", value)

    @builtins.property
    @jsii.member(jsii_name="powerVar")
    def power_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "powerVar"))

    @power_var.setter
    def power_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb1de145913a817a31fdc6bc84d6692c5171a2bc60a1b9820761e78b63a7eb71)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "powerVar", value)

    @builtins.property
    @jsii.member(jsii_name="seed")
    def seed(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seed"))

    @seed.setter
    def seed(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d11816f7e968c4eaa06dbc8a7f3607dd6820da4da2c289c92a8ed0a8a3debc2d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seed", value)

    @builtins.property
    @jsii.member(jsii_name="seedVar")
    def seed_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seedVar"))

    @seed_var.setter
    def seed_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc27bbe9f3f95bf8fc10cf4f6a38cbf8f93c245c88c8da3b40f92168d49a526b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seedVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultGoop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultGoop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultGoop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b448770f299d0e82eae579a44eb54b04f8d93d561bc41c3f2cba5e7866c48753)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultGrayscale",
    jsii_struct_bases=[],
    name_mapping={"type": "type", "type_var": "typeVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultGrayscale:
    def __init__(
        self,
        *,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param type: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__40c49c048bd4c185f7a57eb646da1a04761713dd9dcd9a73e3f6459c77b91676)
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultGrayscale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultGrayscaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultGrayscaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1ca17946341a742765edb9e2074a93314d45a44c8ae2bc8bd1b0f3c2033ee0a0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultGrayscaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__60ad4502abf0bffae889d14720674032a973967190ac466eadca4eeaf17e2a42)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultGrayscaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a9dbdbbd48866d6c29d713dfb4c28e2ded7550429cccdb7878a1ddb90bc861d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a1c2161590718a74f4b194c30395a0e18593f292983868e5a726793144850aa9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d19b02bc1c4d857413075d613fd3aa8812d9ac24b3487c93429d4d8805b12c4e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultGrayscale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultGrayscale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4c3b36ae74acbda6c723b1633bd97a5c2f35ff08647c58228ec5aeeef392f26a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultGrayscaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultGrayscaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e1e3a580a9d9eca0765a2ffc42223585adeab83c1305d4616a6c0f9a458b49b7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e6512eccef7cb714ef55ee902005e73019f358de9d70a501becb2249bfe6796b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f3a7d5fd34c508f734f977511fc3da06ca456724358e907b1fb9306fb80f74cc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultGrayscale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultGrayscale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultGrayscale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__abcba1954a4856feff2a09b5563395cb910227677a58dd1d6b503075826ae274)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultHsl",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "lightness": "lightness",
        "lightness_var": "lightnessVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultHsl:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness: typing.Optional[builtins.str] = None,
        lightness_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        :param lightness_var: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__883b8fce6e33bc637ab9688ac2e45a1548c05e3f1e408cc9a753c8630ef66a37)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness", value=lightness, expected_type=type_hints["lightness"])
            check_type(argname="argument lightness_var", value=lightness_var, expected_type=type_hints["lightness_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness is not None:
            self._values["lightness"] = lightness
        if lightness_var is not None:
            self._values["lightness_var"] = lightness_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        '''
        result = self._values.get("lightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        '''
        result = self._values.get("lightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultHsl(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultHslList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultHslList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ebc83cb4a15330bfc4d5bd68723a260616c837c491e1cd5a41e5c8406f28e01e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultHslOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3e27cdab5d25c455fc8ce571e1864f9aa41cd174c3e7accbd687615f64f3a8cc)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultHslOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c17fd073658de09fa574f9cb31692e4ab39cad734c6b7f956ffc7334b25ae2c1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fbe87cb1fabc26cb5e1fc17a755f2b4cfe1f605c620930d43392cdc792b603ca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__49e30fffda31a55b11a0d5e58c7fd55c23160baecaf2fce644cb2933c52c01e7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultHsl]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultHsl]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__38e840ca16c08e49e7847f080a01e648231195f9fc84d6ef402c4254ba9a98c7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultHslOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultHslOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b89c03afaf2a9d98bc0cd012f65e0cdecd4448c745b75c7a90f479a295e6d79d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightness")
    def reset_lightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightness", []))

    @jsii.member(jsii_name="resetLightnessVar")
    def reset_lightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessInput")
    def lightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessVarInput")
    def lightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c6dd6389eafdfe1ffd42cd1d62357fab9c4ef75cc66c53a10c44dd9866bbe8d0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6c058ca376635fea5d05683cc4e7eaebb3e78d995b5ffcdc06b958e58e0cec01)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightness")
    def lightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightness"))

    @lightness.setter
    def lightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5cbb08e24e36d74dae9db5412513b519182cee0a964518ba0f0fde9197acc3b1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightness", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessVar")
    def lightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessVar"))

    @lightness_var.setter
    def lightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6fa195dc7c8b4a94fd791e8eba8341934bfe46961e1a9a264927ea6aa88e9c03)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__75ac24035df3a38352dbc8ccaa339908b3f1bc22d0d2d7901031da981ae2b9f8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fc53bfa352aa9988e69f16cd6462952b75e25d8b96a49ca802478037fb943071)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultHsl]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultHsl]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultHsl]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__065a12e8e7c18f2055b45383dcebcc4fb0b736750dde0b26475a351f452a0230)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultHsv",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultHsv:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        :param value: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__65f12b9891874a0f47fb7c40261129e08363e12fb22ed838c2502dec430354ce)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultHsv(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultHsvList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultHsvList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0220776437c0fe8516cae2f4abc22437b7ff9e76bb354174d9d55976933c04ab)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultHsvOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4d6cbcf2942610e11ce2711374eb049c11ec64f11c42bf956b29f479416d65f1)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultHsvOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b968b7dfcb90012969ce0b393c85b4b2bf553c8bba567736b337e356c2e4873c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__298daeb76572247e0881d8b29d61c2202510098fc8f368d8b83c576205112974)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__18774512168c31741ddff796d84041852ff708cb158dd75bf08a7e10b0359f28)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultHsv]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultHsv]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd5c179a5063a8d6cecd2d553e899ccdb2dc7ddf0043f31f14bb5763a86780d8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultHsvOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultHsvOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2f7d072b5d4ab40c17487edb69f7618b5bce99a1fcb781b41520e5e8e45c5abc)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a53ccbf69960644db4b3fdf3aa36fc0d8b8dac31f9f8446d557834414a1f4ff1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e320ed50939d1ea1c21ea94095f76af6bec8260f83eed1fc8cdcfd97e093f25f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5b2256bd0e0c5b246967dc83082c7e2457f1f749686f2642a919926ea843e31a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__459fadb776fb1a5094560589a4dad5d67a9c82d663a0420b5800cfa0ff9e7fbf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ed4f6534b1dbd89a716d0573c0df0701d35299a20c68303773bb20178aaafdb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__98d23be72e92b715f40d7256518d1a8465c8d0b8b69483fb4243c48c41293a3e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultHsv]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultHsv]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultHsv]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__291db8242e58af893886aab7e5ed6d03565929b8abdb4f59d27510d513251d8c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfDimension",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "dimension": "dimension",
        "dimension_var": "dimensionVar",
        "equal": "equal",
        "greater_than": "greaterThan",
        "less_than": "lessThan",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfDimension:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        dimension: typing.Optional[builtins.str] = None,
        dimension_var: typing.Optional[builtins.str] = None,
        equal: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionEqual", typing.Dict[builtins.str, typing.Any]]] = None,
        greater_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionGreaterThan", typing.Dict[builtins.str, typing.Any]]] = None,
        less_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionLessThan", typing.Dict[builtins.str, typing.Any]]] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param dimension: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        :param dimension_var: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        :param equal: equal block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        :param greater_than: greater_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        :param less_than: less_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        :param value: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionDefault(**default)
        if isinstance(equal, dict):
            equal = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionEqual(**equal)
        if isinstance(greater_than, dict):
            greater_than = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionGreaterThan(**greater_than)
        if isinstance(less_than, dict):
            less_than = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionLessThan(**less_than)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__47c81d10c7cf7c129a6de824ee1e6d2a8c05161b1c6520f05a7970e405020e59)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument dimension", value=dimension, expected_type=type_hints["dimension"])
            check_type(argname="argument dimension_var", value=dimension_var, expected_type=type_hints["dimension_var"])
            check_type(argname="argument equal", value=equal, expected_type=type_hints["equal"])
            check_type(argname="argument greater_than", value=greater_than, expected_type=type_hints["greater_than"])
            check_type(argname="argument less_than", value=less_than, expected_type=type_hints["less_than"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if dimension is not None:
            self._values["dimension"] = dimension
        if dimension_var is not None:
            self._values["dimension_var"] = dimension_var
        if equal is not None:
            self._values["equal"] = equal
        if greater_than is not None:
            self._values["greater_than"] = greater_than
        if less_than is not None:
            self._values["less_than"] = less_than
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionDefault"], result)

    @builtins.property
    def dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        '''
        result = self._values.get("dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        '''
        result = self._values.get("dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def equal(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionEqual"]:
        '''equal block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        '''
        result = self._values.get("equal")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionEqual"], result)

    @builtins.property
    def greater_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionGreaterThan"]:
        '''greater_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        '''
        result = self._values.get("greater_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionGreaterThan"], result)

    @builtins.property
    def less_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionLessThan"]:
        '''less_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        '''
        result = self._values.get("less_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionLessThan"], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfDimension(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f5219cb34ace675d929997763a581c817fd984ff05888cbe14ad29257b2cec33)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dd09d02b708aa602b368c76208b5ce33242d59892b5bf93b227d909302cf85ce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionEqual",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionEqual:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionEqual(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionEqualOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionEqualOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d5bbb055dbec6f446bc8ce38416cc7add652b02e4e8872dc8eeee0eead1d2c00)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionEqual], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionEqual],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__724055dcbdf1f27d13592bb64ce7782bd06ed27285939c3345b794f8f16f6e0c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionGreaterThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionGreaterThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionGreaterThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionGreaterThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionGreaterThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__715c51c4ace2200445fa6718f21e21b442c408c1a2b41328c6eae198070226d3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionGreaterThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionGreaterThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bafb5e8338fd49a2ee4c4d4a6cdb0331fb7355691305385e752ac20f28457876)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionLessThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionLessThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionLessThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionLessThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionLessThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7f1098481db307437707c941ea29e7d07a430689384604159122abd4de30e514)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionLessThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionLessThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2547471b28d81d1599ff218337f0f2719992d828c2f248344934f2898021d818)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__caf81afbdec6cdbadf294c94e82c26b3ecb7fea6f80a93cfc9456f7072c279cf)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7e8f5452ad253fdec6439a4cf9f94a41d0953a188fc38ee542d70e2a1996d9e5)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__95631384765bf907f97519ecdbe181aa4a9985725db85226062888ef978ef007)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7c0728eea6c6d70e556ed5995e32005c93b23cc40d80dff582bea43bbf1c7db4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8c0e7a3e2a52006fe77895199255dcb7bf5d52e56280402cbbbea917fd6d11b3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfDimension]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfDimension]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3d1566ca65791ac01fdef753fe836654111f4d3d61da49909ee3b050daec2dd8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7730d32338fbc4a2cea1e3bb70657d8bc4688f13e7c69af398c5249813a87ffa)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putEqual")
    def put_equal(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionEqual()

        return typing.cast(None, jsii.invoke(self, "putEqual", [value]))

    @jsii.member(jsii_name="putGreaterThan")
    def put_greater_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionGreaterThan()

        return typing.cast(None, jsii.invoke(self, "putGreaterThan", [value]))

    @jsii.member(jsii_name="putLessThan")
    def put_less_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionLessThan()

        return typing.cast(None, jsii.invoke(self, "putLessThan", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetDimension")
    def reset_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimension", []))

    @jsii.member(jsii_name="resetDimensionVar")
    def reset_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimensionVar", []))

    @jsii.member(jsii_name="resetEqual")
    def reset_equal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEqual", []))

    @jsii.member(jsii_name="resetGreaterThan")
    def reset_greater_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGreaterThan", []))

    @jsii.member(jsii_name="resetLessThan")
    def reset_less_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLessThan", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="equal")
    def equal(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionEqualOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionEqualOutputReference, jsii.get(self, "equal"))

    @builtins.property
    @jsii.member(jsii_name="greaterThan")
    def greater_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionGreaterThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionGreaterThanOutputReference, jsii.get(self, "greaterThan"))

    @builtins.property
    @jsii.member(jsii_name="lessThan")
    def less_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionLessThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionLessThanOutputReference, jsii.get(self, "lessThan"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionInput")
    def dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionVarInput")
    def dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="equalInput")
    def equal_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionEqual], jsii.get(self, "equalInput"))

    @builtins.property
    @jsii.member(jsii_name="greaterThanInput")
    def greater_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionGreaterThan], jsii.get(self, "greaterThanInput"))

    @builtins.property
    @jsii.member(jsii_name="lessThanInput")
    def less_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionLessThan], jsii.get(self, "lessThanInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="dimension")
    def dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimension"))

    @dimension.setter
    def dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__127dc3f71bb887debfdeb2446be42399d6d0066d1a257897367fddc8a8b5a715)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimension", value)

    @builtins.property
    @jsii.member(jsii_name="dimensionVar")
    def dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimensionVar"))

    @dimension_var.setter
    def dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ebbe9d847cebd21438d743229bf9483bda0f58a110ce2fed6861d3395e145204)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9f672d2b05e9a0e8cda4207a72cb24f6150df20b14fd198d1891f430d860e7c9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4409a46fd1479c0ade0ff93178ef533796b8aa0af94ee419a97cc00fe4e316bd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfDimension]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfDimension]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfDimension]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__957014a93945f03341cfbc86f01e7c38418cb0dfe5638fdfe6a9f952398867fd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientation",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "landscape": "landscape",
        "portrait": "portrait",
        "square": "square",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientation:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        landscape: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationLandscape", typing.Dict[builtins.str, typing.Any]]] = None,
        portrait: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationPortrait", typing.Dict[builtins.str, typing.Any]]] = None,
        square: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationSquare", typing.Dict[builtins.str, typing.Any]]] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param landscape: landscape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        :param portrait: portrait block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        :param square: square block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationDefault(**default)
        if isinstance(landscape, dict):
            landscape = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationLandscape(**landscape)
        if isinstance(portrait, dict):
            portrait = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationPortrait(**portrait)
        if isinstance(square, dict):
            square = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationSquare(**square)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2e8ef69acd1a48bc2b3a94f94c166a3636141fb0e222b5cb0b9a39bc531f1489)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument landscape", value=landscape, expected_type=type_hints["landscape"])
            check_type(argname="argument portrait", value=portrait, expected_type=type_hints["portrait"])
            check_type(argname="argument square", value=square, expected_type=type_hints["square"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if landscape is not None:
            self._values["landscape"] = landscape
        if portrait is not None:
            self._values["portrait"] = portrait
        if square is not None:
            self._values["square"] = square

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationDefault"], result)

    @builtins.property
    def landscape(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationLandscape"]:
        '''landscape block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        '''
        result = self._values.get("landscape")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationLandscape"], result)

    @builtins.property
    def portrait(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationPortrait"]:
        '''portrait block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        '''
        result = self._values.get("portrait")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationPortrait"], result)

    @builtins.property
    def square(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationSquare"]:
        '''square block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        result = self._values.get("square")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationSquare"], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__488269e2c6aa7a003b43dc472a11cc6cecf4749e890e17455b9951766fef9cdf)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ee5bce788e8914a74a1c5a381b467bd8e709b969ddc4823b77b9fec7caf9cd0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationLandscape",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationLandscape:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationLandscape(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationLandscapeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationLandscapeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__44355f9c08a3940ddc22d825ec4fe070b7a9f219bee827676cd384adb4f8f891)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationLandscape], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationLandscape],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__505d1557049648b4594252774d22800b16f13e767601bb1c59f3b8fc6a68fb91)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8585c1d20de16b1fd602a7b7f34856f7122dc515521e1b3f4e6d84809c79abe8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8c0a0f665c97bffaf2df036dbeafdcb97c5b28115bb0266c3838a3371ab1f039)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a4de557ac6c5baf9a7f648fe873be1926f37e50f0796a5edd087a46aeccea62)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__219ff76953ceabd403f26db300b35b76afd4d5c26c7b42f2de7ca6acb8d774f7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af9b5d42b084219e433c0a4aba972c9f38f200920519de77d3cb054cbb5845f7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientation]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientation]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__311f87e0b08639d3a392a8b934b2ba6caa1b43d4f7ea433ee9b036c18bd22761)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1d80cd058a112a1e8a3b4d4101442b40310a76ad8427e4ea87f9d6c65b727ab1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putLandscape")
    def put_landscape(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationLandscape()

        return typing.cast(None, jsii.invoke(self, "putLandscape", [value]))

    @jsii.member(jsii_name="putPortrait")
    def put_portrait(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationPortrait()

        return typing.cast(None, jsii.invoke(self, "putPortrait", [value]))

    @jsii.member(jsii_name="putSquare")
    def put_square(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationSquare()

        return typing.cast(None, jsii.invoke(self, "putSquare", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetLandscape")
    def reset_landscape(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLandscape", []))

    @jsii.member(jsii_name="resetPortrait")
    def reset_portrait(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPortrait", []))

    @jsii.member(jsii_name="resetSquare")
    def reset_square(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSquare", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="landscape")
    def landscape(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationLandscapeOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationLandscapeOutputReference, jsii.get(self, "landscape"))

    @builtins.property
    @jsii.member(jsii_name="portrait")
    def portrait(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationPortraitOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationPortraitOutputReference", jsii.get(self, "portrait"))

    @builtins.property
    @jsii.member(jsii_name="square")
    def square(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationSquareOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationSquareOutputReference", jsii.get(self, "square"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="landscapeInput")
    def landscape_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationLandscape], jsii.get(self, "landscapeInput"))

    @builtins.property
    @jsii.member(jsii_name="portraitInput")
    def portrait_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationPortrait"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationPortrait"], jsii.get(self, "portraitInput"))

    @builtins.property
    @jsii.member(jsii_name="squareInput")
    def square_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationSquare"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationSquare"], jsii.get(self, "squareInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientation]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientation]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientation]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__83d9674abaec19531bd410b5cf1745d013b372923f48b9e7d465160af03df46e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationPortrait",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationPortrait:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationPortrait(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationPortraitOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationPortraitOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f46b4b323a3b321a244df48e0dbfc3e391736d63fb0e1eecdc39156f38ab3e88)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationPortrait]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationPortrait], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationPortrait],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ba11b1d25c3558ade55bbc82d3d96efea48d271b0dadf2809457b1d5870259b2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationSquare",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationSquare:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationSquare(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationSquareOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationSquareOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__965c7040833b56ec56a03cd048d96d461256a742f18feb709ad61c9a2044d5d5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationSquare]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationSquare], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationSquare],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e8cd2da8dbff3e0a87aea3e6010dbdab2f8464b0f2e4c386646e39f52bc0ee5b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultImQuery",
    jsii_struct_bases=[],
    name_mapping={
        "allowed_transformations": "allowedTransformations",
        "query_var": "queryVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultImQuery:
    def __init__(
        self,
        *,
        allowed_transformations: typing.Sequence[builtins.str],
        query_var: builtins.str,
    ) -> None:
        '''
        :param allowed_transformations: Specifies the transformations that can be applied using the query string parameter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allowed_transformations DataAkamaiImagingPolicyImage#allowed_transformations}
        :param query_var: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#query_var DataAkamaiImagingPolicyImage#query_var}.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__04690a43bba53c844ff54bcecaa745a0b1f8952b195d7d32ff8201b43550f229)
            check_type(argname="argument allowed_transformations", value=allowed_transformations, expected_type=type_hints["allowed_transformations"])
            check_type(argname="argument query_var", value=query_var, expected_type=type_hints["query_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "allowed_transformations": allowed_transformations,
            "query_var": query_var,
        }

    @builtins.property
    def allowed_transformations(self) -> typing.List[builtins.str]:
        '''Specifies the transformations that can be applied using the query string parameter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allowed_transformations DataAkamaiImagingPolicyImage#allowed_transformations}
        '''
        result = self._values.get("allowed_transformations")
        assert result is not None, "Required property 'allowed_transformations' is missing"
        return typing.cast(typing.List[builtins.str], result)

    @builtins.property
    def query_var(self) -> builtins.str:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#query_var DataAkamaiImagingPolicyImage#query_var}.'''
        result = self._values.get("query_var")
        assert result is not None, "Required property 'query_var' is missing"
        return typing.cast(builtins.str, result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultImQuery(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultImQueryList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultImQueryList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__98bbe109354a3e95ab462ca04dbbc464ddb26417a6b6951b753e6ed892f1092f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultImQueryOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__88f102655941c493131270ae92f43961b9373206db0952edd327449683930b2f)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultImQueryOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2adf11f920cd2807b3399aa744eb67ab36cf5b1fa51a8afed72feb47a4e5e80f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8ada6f8581adfed78bcb396a7935b246cc53cd846f47412069796886e7f92ea4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8576ef734156c2a7850d398f9365255a15b7f10611576559df77f71df3698748)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultImQuery]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultImQuery]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultImQuery]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c666ba877e14397ff703fb08f61e07fcb6212e701856c99681f504aa5946f9fe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultImQueryOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultImQueryOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__807dddc670398dc844e31cd3743a89f3af4030398aa0b86db90503181b046000)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @builtins.property
    @jsii.member(jsii_name="allowedTransformationsInput")
    def allowed_transformations_input(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "allowedTransformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="queryVarInput")
    def query_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "queryVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowedTransformations")
    def allowed_transformations(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "allowedTransformations"))

    @allowed_transformations.setter
    def allowed_transformations(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4d2d78cb1e86a6a68f56fb1b7a7b85a167b6c371f8504c259b482ccdeb42af35)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowedTransformations", value)

    @builtins.property
    @jsii.member(jsii_name="queryVar")
    def query_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "queryVar"))

    @query_var.setter
    def query_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__36b9adc0221beb1cac6d660c6d3a01930165c978e14091118ebd9a7d4ce17f85)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "queryVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultImQuery]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultImQuery]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultImQuery]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__942f357184a76281e0f10b740b7f38ab1b73f09e98c72d499b632b335079ee2b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultMaxColors",
    jsii_struct_bases=[],
    name_mapping={"colors": "colors", "colors_var": "colorsVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultMaxColors:
    def __init__(
        self,
        *,
        colors: typing.Optional[builtins.str] = None,
        colors_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param colors: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        :param colors_var: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__84f44ad4958be2e1d6d0dee64adb715354f21ad2ba879f86f8bb2d9c033654aa)
            check_type(argname="argument colors", value=colors, expected_type=type_hints["colors"])
            check_type(argname="argument colors_var", value=colors_var, expected_type=type_hints["colors_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if colors is not None:
            self._values["colors"] = colors
        if colors_var is not None:
            self._values["colors_var"] = colors_var

    @builtins.property
    def colors(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        '''
        result = self._values.get("colors")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def colors_var(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        result = self._values.get("colors_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultMaxColors(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultMaxColorsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultMaxColorsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8e5c85a246f1b21b901d24ff21ed8ac7670f134681e238d8c9d46662176939a6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultMaxColorsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e1f7327cee15c1bf1f794f6625982a1dbf9a554b88bb43017ddd506d048d005f)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultMaxColorsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6d7e9c4bea51f4287e85c32ff606d0e111576eb1707cd90b03c99a9f858d9bdd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__77e4fb805da65fd28c9d33ceb7f8f435082a7f913dfd36838fe6c5cbaa1e35ea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c48959892f946ed804015ad4176ea72b8b7889ec5bddb3da998d11d71441e8b4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultMaxColors]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultMaxColors]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8320b06aba20840014e34f1f2816a12a417b79886517edebf6fa83cb04dbc997)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultMaxColorsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultMaxColorsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8857c6b501b513fb733dd0346dd265d816a6ac708c805f48f11355e541204298)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColors")
    def reset_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColors", []))

    @jsii.member(jsii_name="resetColorsVar")
    def reset_colors_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorsVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorsInput")
    def colors_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsInput"))

    @builtins.property
    @jsii.member(jsii_name="colorsVarInput")
    def colors_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsVarInput"))

    @builtins.property
    @jsii.member(jsii_name="colors")
    def colors(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colors"))

    @colors.setter
    def colors(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1fb114dfe62b946ead19ea131147eaf7fe239f2bdcb8b4d3e75dccc2b63a633a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colors", value)

    @builtins.property
    @jsii.member(jsii_name="colorsVar")
    def colors_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorsVar"))

    @colors_var.setter
    def colors_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__71d985f0e3d11d3b8f28185accc0fc5ab517ed73ec64d5ee11ed3c1df399d750)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorsVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultMaxColors]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultMaxColors]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultMaxColors]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__de81d6e2316ea6682a24182afa51e952ed46badb9ee8c9df5a0469ad5452d225)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultMirror",
    jsii_struct_bases=[],
    name_mapping={
        "horizontal": "horizontal",
        "horizontal_var": "horizontalVar",
        "vertical": "vertical",
        "vertical_var": "verticalVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultMirror:
    def __init__(
        self,
        *,
        horizontal: typing.Optional[builtins.str] = None,
        horizontal_var: typing.Optional[builtins.str] = None,
        vertical: typing.Optional[builtins.str] = None,
        vertical_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param horizontal: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        :param horizontal_var: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        :param vertical: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        :param vertical_var: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__54f3c4c9c12dc802f70ead424e1dd869ba09d816fcdf984e44eb31232d46b662)
            check_type(argname="argument horizontal", value=horizontal, expected_type=type_hints["horizontal"])
            check_type(argname="argument horizontal_var", value=horizontal_var, expected_type=type_hints["horizontal_var"])
            check_type(argname="argument vertical", value=vertical, expected_type=type_hints["vertical"])
            check_type(argname="argument vertical_var", value=vertical_var, expected_type=type_hints["vertical_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if horizontal is not None:
            self._values["horizontal"] = horizontal
        if horizontal_var is not None:
            self._values["horizontal_var"] = horizontal_var
        if vertical is not None:
            self._values["vertical"] = vertical
        if vertical_var is not None:
            self._values["vertical_var"] = vertical_var

    @builtins.property
    def horizontal(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        '''
        result = self._values.get("horizontal")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def horizontal_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        '''
        result = self._values.get("horizontal_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        '''
        result = self._values.get("vertical")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        result = self._values.get("vertical_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultMirror(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultMirrorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultMirrorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd5046cca5d17dcc91e1d676071b16e1b6e11840967d3f72826e891d40af847e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultMirrorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__23ded112a93e5d783c4b095f2dcb9597ce27b38f97244bb3388a6748f0d56647)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultMirrorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eb5cd9111faf5e3b1050205a1d99cd897a9828e7d4da2c7e57fadfbfa6a571ed)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__232d9e39e739b648bef31d90dcca82a0b0dfcda972bec80653e24db27ac1af8e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e55a10520d926908537dd3e17bc68161c1686cdcab2156af394e5d88b0fb7d13)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultMirror]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultMirror]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8034ea1c3c94e5d907a1ab868777321d745325b3a9da87eb1d26c891e7b3bbfb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultMirrorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultMirrorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__506776f6c4e0df4b2963a594347e5df3f3680912242c16d83cacc2daa1a4a1de)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHorizontal")
    def reset_horizontal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontal", []))

    @jsii.member(jsii_name="resetHorizontalVar")
    def reset_horizontal_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontalVar", []))

    @jsii.member(jsii_name="resetVertical")
    def reset_vertical(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVertical", []))

    @jsii.member(jsii_name="resetVerticalVar")
    def reset_vertical_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVerticalVar", []))

    @builtins.property
    @jsii.member(jsii_name="horizontalInput")
    def horizontal_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontalVarInput")
    def horizontal_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalInput")
    def vertical_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalVarInput")
    def vertical_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontal")
    def horizontal(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontal"))

    @horizontal.setter
    def horizontal(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__23b04760fe162e767d7d1700b4a53bec3c67f11696b7f6db6240079ec2efbcab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontal", value)

    @builtins.property
    @jsii.member(jsii_name="horizontalVar")
    def horizontal_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontalVar"))

    @horizontal_var.setter
    def horizontal_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4d5df654830eb9adf1c82686bbd3fbb0f2a907a1599b11678bc9c18f084d8aa2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontalVar", value)

    @builtins.property
    @jsii.member(jsii_name="vertical")
    def vertical(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "vertical"))

    @vertical.setter
    def vertical(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__884c24c8757d54d322721650606ea6477037bd6b4e45da14a4c3d9feabea73f8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "vertical", value)

    @builtins.property
    @jsii.member(jsii_name="verticalVar")
    def vertical_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "verticalVar"))

    @vertical_var.setter
    def vertical_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__64e7f1f9411b59e646c1e30d44fe99273b8bd015336d58db3455d301ba77abc3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "verticalVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultMirror]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultMirror]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultMirror]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7de67bbdecae1af399b7491db2193c013878caf4f1fccb4946b10587e06c13ea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultMonoHue",
    jsii_struct_bases=[],
    name_mapping={"hue": "hue", "hue_var": "hueVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultMonoHue:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a21b57dbe2c0b429e8b88506a6c571dc1f70b4112b2e86272117cb602da66f5)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultMonoHue(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultMonoHueList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultMonoHueList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3d643ad7bbc1a8cd2acd3a0e00db277a6b3ee4b96c8ff901f4176dab7842340d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultMonoHueOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1de88f4821bb6f4a7d6102b5294d2bcea87d65d712bd9008094429f6a3eece05)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultMonoHueOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c15da06a48a2df78c2b5840f7177524933d123bc897a964fd638008870a14e82)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cafe8895eecdbca8ef65dcaa5fedf3eecb7305d9c6647d4bf06bc79f0124387a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__83fcd8619e537649429fd7bf221110cd55fd2b75c3a9a152a743c61e1d14e22e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultMonoHue]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultMonoHue]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dbdc6b35ae9c78ff8cd936487994845769c84309baf496f4f959cb85cf8c68e2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultMonoHueOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultMonoHueOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__edc1ebfcb2eba71bf979acb8fe4ba5c1bf2f187351e8f0a4bad4b6e7475713a2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9642ef836714a2b32a1b2e8649c7ef5b084d2cb79c4dff5c20973afd4c4b9fa7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d8ca418dfa4596daa4effadb5a9297c82b44a44da5564ccc6a4fc73d1be93406)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultMonoHue]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultMonoHue]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultMonoHue]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ada08fdb2215430a40cb48b9ecf439eec0e0b8fa918da01b3fe563c5c998501f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultOpacity",
    jsii_struct_bases=[],
    name_mapping={"opacity": "opacity", "opacity_var": "opacityVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultOpacity:
    def __init__(
        self,
        *,
        opacity: typing.Optional[builtins.str] = None,
        opacity_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param opacity: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param opacity_var: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__44a4adcc1b1253269074feb3c094de6cc4fc339fdf231c55a001a2c3db1c79bf)
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument opacity_var", value=opacity_var, expected_type=type_hints["opacity_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if opacity is not None:
            self._values["opacity"] = opacity
        if opacity_var is not None:
            self._values["opacity_var"] = opacity_var

    @builtins.property
    def opacity(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def opacity_var(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        result = self._values.get("opacity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultOpacity(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultOpacityList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultOpacityList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__575ade7cb01792a20b4402fc9c11672c8de48131bd2372f1e3c89e79d46203e9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultOpacityOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__08e01909ce74e8b9ef897cdcaea1e288a74395754ec88682b2d60411aebbc9ed)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultOpacityOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__060024fbb5574807d39348f4f8d4b0775c25df531438357f7e6a66ef337972d6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__01b50724a4639448df8dd09936ff1371c156f87a990d65456800ad000660fe93)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fffec9b9c2080d0a92bda216c89783124e1c490745c4ac8acc4599aacde1495a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultOpacity]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultOpacity]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ecad1fa21084504c4c93308de3cda08145be5f3c0c69d9253f5ece2ad5ba1478)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultOpacityOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultOpacityOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f3a343d92baf1cfe53966f24341f15be13b39304bf0d11f9ebe777b3874486fb)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetOpacityVar")
    def reset_opacity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacityVar", []))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityVarInput")
    def opacity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacity"))

    @opacity.setter
    def opacity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ace8c45fd364fd81934fecac0a44fa581211ba2db9104315cbd8d321b0718ce5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacity", value)

    @builtins.property
    @jsii.member(jsii_name="opacityVar")
    def opacity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacityVar"))

    @opacity_var.setter
    def opacity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__06611acaad815941c1f456dbd9a8c2baaabe868aaec39d5062618343e595c8ff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacityVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultOpacity]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultOpacity]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultOpacity]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3c87689dd7bb29ca6e2f8cade14839ab5b4544ef17c6d51158013c15e764b159)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ef94b7ab4e6a8c7e006d3670e5c1b8bbb6739b7b534a1a470bd56b23f0a3a605)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putAppend")
    def put_append(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultAppend, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d0cae9a16fa915b9bfcf113159202436c5dc7767c3884238623844cb04efd126)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putAppend", [value]))

    @jsii.member(jsii_name="putAspectCrop")
    def put_aspect_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultAspectCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__303e86344eec6465ddb908c462a2fcc87cf456dfec0d2d054cfb6f67748f3529)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putAspectCrop", [value]))

    @jsii.member(jsii_name="putBackgroundColor")
    def put_background_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a00a700d5a1a38d1255666fe4a49c62f31044f1122eb87ab3de8d5ac80a9ce67)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBackgroundColor", [value]))

    @jsii.member(jsii_name="putBlur")
    def put_blur(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultBlur, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e2e5fb0daf6d1d5aa55d9387e19f83b6b7bcf7b1fb3022c2a8a82ed6e7b734de)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBlur", [value]))

    @jsii.member(jsii_name="putChromaKey")
    def put_chroma_key(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultChromaKey, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ae0b0ac29846a17a9dbc953a41b45758093697d3af055069c941153c5e3a67da)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putChromaKey", [value]))

    @jsii.member(jsii_name="putComposite")
    def put_composite(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultComposite, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b7a9d95ce9008759b9886523b42160162a966ee30fcd5ca8daeb87554f58ee31)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putComposite", [value]))

    @jsii.member(jsii_name="putCompound")
    def put_compound(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultCompound, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a758e61c4c24e9104a98151600a495f97bbd50efdf46555a9f0b8b10521405a7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCompound", [value]))

    @jsii.member(jsii_name="putContrast")
    def put_contrast(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultContrast, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__febf1ca2713ebaad198172a5a4f03368d8fe1d982e69e81061ead99b4810069c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putContrast", [value]))

    @jsii.member(jsii_name="putCrop")
    def put_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__87c322558b3b5cb73ae05fa01a1875f0914c45777d1efdaba77038ef2e6b185f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCrop", [value]))

    @jsii.member(jsii_name="putFaceCrop")
    def put_face_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultFaceCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__812df52d38627fd25d171e53e9a8c5788f597d6313f6d0462478ac4f56db92e5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFaceCrop", [value]))

    @jsii.member(jsii_name="putFeatureCrop")
    def put_feature_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultFeatureCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__714186488ac3fc1890cbd3af9f5157b51845b4d91d63b9baf5e392aea0fc78fa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFeatureCrop", [value]))

    @jsii.member(jsii_name="putFitAndFill")
    def put_fit_and_fill(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultFitAndFill, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b974808d8c277ee96d99181bffbf2eca190bc7f179a2cf83c58efdfe199a1357)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFitAndFill", [value]))

    @jsii.member(jsii_name="putGoop")
    def put_goop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultGoop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5c1c4bb30539aa9236aba8c2ec3abf9de074792fb08b9d02883652091b40b3cb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGoop", [value]))

    @jsii.member(jsii_name="putGrayscale")
    def put_grayscale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultGrayscale, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f432c58dfe70f29a44e37d58061721051b8f188fe5711f396a2e024ab0e5f1b4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGrayscale", [value]))

    @jsii.member(jsii_name="putHsl")
    def put_hsl(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultHsl, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__82ad5e2ba0efce7ba799bd0a43c2c99da639c0e5862f56451e6bcb95141ff64d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsl", [value]))

    @jsii.member(jsii_name="putHsv")
    def put_hsv(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultHsv, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__17fbce39d78cc713eced9b624de1f438110469be51a5997579d0a57645b224ad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsv", [value]))

    @jsii.member(jsii_name="putIfDimension")
    def put_if_dimension(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfDimension, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d369ab4006f28dcbe5d96e87be31553d42ab3fa6ec4ee0a33964cc241f7719ca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfDimension", [value]))

    @jsii.member(jsii_name="putIfOrientation")
    def put_if_orientation(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e2147f9a9a7ed14eb65e174d9191f55892cfca0d56cd8bd0070243fa610e2633)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfOrientation", [value]))

    @jsii.member(jsii_name="putImQuery")
    def put_im_query(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultImQuery, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ca94e18fcebff746ca104b5658296b8ad1781f6ff29cba552d971eebf991b4b5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putImQuery", [value]))

    @jsii.member(jsii_name="putMaxColors")
    def put_max_colors(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultMaxColors, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f5d470d24042c6938cf1a02ec033819b7e32c983de3a0e800c5257d8a2d1b10c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMaxColors", [value]))

    @jsii.member(jsii_name="putMirror")
    def put_mirror(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultMirror, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7e6ff7ae723af56ce14fb4d58ac65dda51d16d90716bd5111e22e76a6b9ab002)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMirror", [value]))

    @jsii.member(jsii_name="putMonoHue")
    def put_mono_hue(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultMonoHue, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__96452ac968b67d07182bf3f613cc7bbf333074b11c506e28bfe7e1105918f788)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMonoHue", [value]))

    @jsii.member(jsii_name="putOpacity")
    def put_opacity(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultOpacity, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e8c803c993a01c1a77d91ccac11f337fe76391581c286ae08daace01479bcc82)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putOpacity", [value]))

    @jsii.member(jsii_name="putRegionOfInterestCrop")
    def put_region_of_interest_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultRegionOfInterestCrop", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8ac6647eb90c5c068859e396ad75d5708b2016f0566d916b87bf8b80f972404d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRegionOfInterestCrop", [value]))

    @jsii.member(jsii_name="putRelativeCrop")
    def put_relative_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultRelativeCrop", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__51fc6cb333816cd4617929d6f2baffa91297e03da412d3a32ca78d8049b059db)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRelativeCrop", [value]))

    @jsii.member(jsii_name="putRemoveColor")
    def put_remove_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultRemoveColor", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1d15d8d84ba0cfecdda9e31748a992aa4fd6186f32f10ed2da1e59d9f813feed)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRemoveColor", [value]))

    @jsii.member(jsii_name="putResize")
    def put_resize(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultResize", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3fc50d7e6328d5c5e257600840c0c171e9c5d3691b4522c160fb45228c5c3608)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putResize", [value]))

    @jsii.member(jsii_name="putRotate")
    def put_rotate(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultRotate", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ea3228f4900848f13b5dd2abb3cd033293f44516f4d5eaaf06d58d8f53781ad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRotate", [value]))

    @jsii.member(jsii_name="putScale")
    def put_scale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultScale", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__03a40c4e1d1f33b66193f538a0cd82e65e19185b8301e640911a5cae3c239e98)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putScale", [value]))

    @jsii.member(jsii_name="putShear")
    def put_shear(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultShear", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a328047fb2a2913e14668b5a1cd3e4adbd74e465e991a675121974e55f159cf2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putShear", [value]))

    @jsii.member(jsii_name="putTrim")
    def put_trim(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultTrim", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c673ecdf8ca439666ca51393af0ea7d1968b982329004c3b1aeccc695c9b4997)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTrim", [value]))

    @jsii.member(jsii_name="putUnsharpMask")
    def put_unsharp_mask(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultUnsharpMask", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c1a4e530ca1f1a2e600f729c905afc067c048ec792ae0c478066204f9183789d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putUnsharpMask", [value]))

    @jsii.member(jsii_name="resetAppend")
    def reset_append(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAppend", []))

    @jsii.member(jsii_name="resetAspectCrop")
    def reset_aspect_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspectCrop", []))

    @jsii.member(jsii_name="resetBackgroundColor")
    def reset_background_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBackgroundColor", []))

    @jsii.member(jsii_name="resetBlur")
    def reset_blur(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBlur", []))

    @jsii.member(jsii_name="resetChromaKey")
    def reset_chroma_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChromaKey", []))

    @jsii.member(jsii_name="resetComposite")
    def reset_composite(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetComposite", []))

    @jsii.member(jsii_name="resetCompound")
    def reset_compound(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCompound", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetCrop")
    def reset_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCrop", []))

    @jsii.member(jsii_name="resetFaceCrop")
    def reset_face_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFaceCrop", []))

    @jsii.member(jsii_name="resetFeatureCrop")
    def reset_feature_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureCrop", []))

    @jsii.member(jsii_name="resetFitAndFill")
    def reset_fit_and_fill(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFitAndFill", []))

    @jsii.member(jsii_name="resetGoop")
    def reset_goop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGoop", []))

    @jsii.member(jsii_name="resetGrayscale")
    def reset_grayscale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGrayscale", []))

    @jsii.member(jsii_name="resetHsl")
    def reset_hsl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsl", []))

    @jsii.member(jsii_name="resetHsv")
    def reset_hsv(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsv", []))

    @jsii.member(jsii_name="resetIfDimension")
    def reset_if_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfDimension", []))

    @jsii.member(jsii_name="resetIfOrientation")
    def reset_if_orientation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfOrientation", []))

    @jsii.member(jsii_name="resetImQuery")
    def reset_im_query(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetImQuery", []))

    @jsii.member(jsii_name="resetMaxColors")
    def reset_max_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxColors", []))

    @jsii.member(jsii_name="resetMirror")
    def reset_mirror(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMirror", []))

    @jsii.member(jsii_name="resetMonoHue")
    def reset_mono_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonoHue", []))

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetRegionOfInterestCrop")
    def reset_region_of_interest_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRegionOfInterestCrop", []))

    @jsii.member(jsii_name="resetRelativeCrop")
    def reset_relative_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRelativeCrop", []))

    @jsii.member(jsii_name="resetRemoveColor")
    def reset_remove_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRemoveColor", []))

    @jsii.member(jsii_name="resetResize")
    def reset_resize(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetResize", []))

    @jsii.member(jsii_name="resetRotate")
    def reset_rotate(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRotate", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetShear")
    def reset_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetShear", []))

    @jsii.member(jsii_name="resetTrim")
    def reset_trim(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTrim", []))

    @jsii.member(jsii_name="resetUnsharpMask")
    def reset_unsharp_mask(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUnsharpMask", []))

    @builtins.property
    @jsii.member(jsii_name="append")
    def append(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultAppendList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultAppendList, jsii.get(self, "append"))

    @builtins.property
    @jsii.member(jsii_name="aspectCrop")
    def aspect_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultAspectCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultAspectCropList, jsii.get(self, "aspectCrop"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColor")
    def background_color(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultBackgroundColorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultBackgroundColorList, jsii.get(self, "backgroundColor"))

    @builtins.property
    @jsii.member(jsii_name="blur")
    def blur(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultBlurList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultBlurList, jsii.get(self, "blur"))

    @builtins.property
    @jsii.member(jsii_name="chromaKey")
    def chroma_key(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultChromaKeyList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultChromaKeyList, jsii.get(self, "chromaKey"))

    @builtins.property
    @jsii.member(jsii_name="composite")
    def composite(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultCompositeList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultCompositeList, jsii.get(self, "composite"))

    @builtins.property
    @jsii.member(jsii_name="compound")
    def compound(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultCompoundList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultCompoundList, jsii.get(self, "compound"))

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultContrastList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultContrastList, jsii.get(self, "contrast"))

    @builtins.property
    @jsii.member(jsii_name="crop")
    def crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultCropList, jsii.get(self, "crop"))

    @builtins.property
    @jsii.member(jsii_name="faceCrop")
    def face_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultFaceCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultFaceCropList, jsii.get(self, "faceCrop"))

    @builtins.property
    @jsii.member(jsii_name="featureCrop")
    def feature_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultFeatureCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultFeatureCropList, jsii.get(self, "featureCrop"))

    @builtins.property
    @jsii.member(jsii_name="fitAndFill")
    def fit_and_fill(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultFitAndFillList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultFitAndFillList, jsii.get(self, "fitAndFill"))

    @builtins.property
    @jsii.member(jsii_name="goop")
    def goop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultGoopList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultGoopList, jsii.get(self, "goop"))

    @builtins.property
    @jsii.member(jsii_name="grayscale")
    def grayscale(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultGrayscaleList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultGrayscaleList, jsii.get(self, "grayscale"))

    @builtins.property
    @jsii.member(jsii_name="hsl")
    def hsl(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultHslList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultHslList, jsii.get(self, "hsl"))

    @builtins.property
    @jsii.member(jsii_name="hsv")
    def hsv(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultHsvList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultHsvList, jsii.get(self, "hsv"))

    @builtins.property
    @jsii.member(jsii_name="ifDimension")
    def if_dimension(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionList, jsii.get(self, "ifDimension"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientation")
    def if_orientation(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationList, jsii.get(self, "ifOrientation"))

    @builtins.property
    @jsii.member(jsii_name="imQuery")
    def im_query(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultImQueryList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultImQueryList, jsii.get(self, "imQuery"))

    @builtins.property
    @jsii.member(jsii_name="maxColors")
    def max_colors(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultMaxColorsList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultMaxColorsList, jsii.get(self, "maxColors"))

    @builtins.property
    @jsii.member(jsii_name="mirror")
    def mirror(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultMirrorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultMirrorList, jsii.get(self, "mirror"))

    @builtins.property
    @jsii.member(jsii_name="monoHue")
    def mono_hue(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultMonoHueList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultMonoHueList, jsii.get(self, "monoHue"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultOpacityList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultOpacityList, jsii.get(self, "opacity"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestCrop")
    def region_of_interest_crop(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultRegionOfInterestCropList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultRegionOfInterestCropList", jsii.get(self, "regionOfInterestCrop"))

    @builtins.property
    @jsii.member(jsii_name="relativeCrop")
    def relative_crop(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultRelativeCropList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultRelativeCropList", jsii.get(self, "relativeCrop"))

    @builtins.property
    @jsii.member(jsii_name="removeColor")
    def remove_color(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultRemoveColorList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultRemoveColorList", jsii.get(self, "removeColor"))

    @builtins.property
    @jsii.member(jsii_name="resize")
    def resize(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultResizeList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultResizeList", jsii.get(self, "resize"))

    @builtins.property
    @jsii.member(jsii_name="rotate")
    def rotate(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultRotateList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultRotateList", jsii.get(self, "rotate"))

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultScaleList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultScaleList", jsii.get(self, "scale"))

    @builtins.property
    @jsii.member(jsii_name="shear")
    def shear(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultShearList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultShearList", jsii.get(self, "shear"))

    @builtins.property
    @jsii.member(jsii_name="trim")
    def trim(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultTrimList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultTrimList", jsii.get(self, "trim"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMask")
    def unsharp_mask(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultUnsharpMaskList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultUnsharpMaskList", jsii.get(self, "unsharpMask"))

    @builtins.property
    @jsii.member(jsii_name="appendInput")
    def append_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultAppend]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultAppend]]], jsii.get(self, "appendInput"))

    @builtins.property
    @jsii.member(jsii_name="aspectCropInput")
    def aspect_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultAspectCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultAspectCrop]]], jsii.get(self, "aspectCropInput"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColorInput")
    def background_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultBackgroundColor]]], jsii.get(self, "backgroundColorInput"))

    @builtins.property
    @jsii.member(jsii_name="blurInput")
    def blur_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultBlur]]], jsii.get(self, "blurInput"))

    @builtins.property
    @jsii.member(jsii_name="chromaKeyInput")
    def chroma_key_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultChromaKey]]], jsii.get(self, "chromaKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="compositeInput")
    def composite_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultComposite]]], jsii.get(self, "compositeInput"))

    @builtins.property
    @jsii.member(jsii_name="compoundInput")
    def compound_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultCompound]]], jsii.get(self, "compoundInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultContrast]]], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="cropInput")
    def crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultCrop]]], jsii.get(self, "cropInput"))

    @builtins.property
    @jsii.member(jsii_name="faceCropInput")
    def face_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultFaceCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultFaceCrop]]], jsii.get(self, "faceCropInput"))

    @builtins.property
    @jsii.member(jsii_name="featureCropInput")
    def feature_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultFeatureCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultFeatureCrop]]], jsii.get(self, "featureCropInput"))

    @builtins.property
    @jsii.member(jsii_name="fitAndFillInput")
    def fit_and_fill_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultFitAndFill]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultFitAndFill]]], jsii.get(self, "fitAndFillInput"))

    @builtins.property
    @jsii.member(jsii_name="goopInput")
    def goop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultGoop]]], jsii.get(self, "goopInput"))

    @builtins.property
    @jsii.member(jsii_name="grayscaleInput")
    def grayscale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultGrayscale]]], jsii.get(self, "grayscaleInput"))

    @builtins.property
    @jsii.member(jsii_name="hslInput")
    def hsl_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultHsl]]], jsii.get(self, "hslInput"))

    @builtins.property
    @jsii.member(jsii_name="hsvInput")
    def hsv_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultHsv]]], jsii.get(self, "hsvInput"))

    @builtins.property
    @jsii.member(jsii_name="ifDimensionInput")
    def if_dimension_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfDimension]]], jsii.get(self, "ifDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientationInput")
    def if_orientation_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientation]]], jsii.get(self, "ifOrientationInput"))

    @builtins.property
    @jsii.member(jsii_name="imQueryInput")
    def im_query_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultImQuery]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultImQuery]]], jsii.get(self, "imQueryInput"))

    @builtins.property
    @jsii.member(jsii_name="maxColorsInput")
    def max_colors_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultMaxColors]]], jsii.get(self, "maxColorsInput"))

    @builtins.property
    @jsii.member(jsii_name="mirrorInput")
    def mirror_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultMirror]]], jsii.get(self, "mirrorInput"))

    @builtins.property
    @jsii.member(jsii_name="monoHueInput")
    def mono_hue_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultMonoHue]]], jsii.get(self, "monoHueInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultOpacity]]], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestCropInput")
    def region_of_interest_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultRegionOfInterestCrop"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultRegionOfInterestCrop"]]], jsii.get(self, "regionOfInterestCropInput"))

    @builtins.property
    @jsii.member(jsii_name="relativeCropInput")
    def relative_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultRelativeCrop"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultRelativeCrop"]]], jsii.get(self, "relativeCropInput"))

    @builtins.property
    @jsii.member(jsii_name="removeColorInput")
    def remove_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultRemoveColor"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultRemoveColor"]]], jsii.get(self, "removeColorInput"))

    @builtins.property
    @jsii.member(jsii_name="resizeInput")
    def resize_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultResize"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultResize"]]], jsii.get(self, "resizeInput"))

    @builtins.property
    @jsii.member(jsii_name="rotateInput")
    def rotate_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultRotate"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultRotate"]]], jsii.get(self, "rotateInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultScale"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultScale"]]], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="shearInput")
    def shear_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultShear"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultShear"]]], jsii.get(self, "shearInput"))

    @builtins.property
    @jsii.member(jsii_name="trimInput")
    def trim_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultTrim"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultTrim"]]], jsii.get(self, "trimInput"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMaskInput")
    def unsharp_mask_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultUnsharpMask"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultUnsharpMask"]]], jsii.get(self, "unsharpMaskInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e309f1b4228ddbdc9014b6adbc3050364847f27e8ebb5a6e70cfdf993fc39fbc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultRegionOfInterestCrop",
    jsii_struct_bases=[],
    name_mapping={
        "region_of_interest": "regionOfInterest",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultRegionOfInterestCrop:
    def __init__(
        self,
        *,
        region_of_interest: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultRegionOfInterestCropRegionOfInterest", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param region_of_interest: region_of_interest block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest DataAkamaiImagingPolicyImage#region_of_interest}
        :param gravity: The placement of the crop area relative to the specified area of interest. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: The placement of the crop area relative to the specified area of interest. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param style: Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(region_of_interest, dict):
            region_of_interest = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultRegionOfInterestCropRegionOfInterest(**region_of_interest)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b1d669b8e22c513bd02db0466b32fff940fdfa93daa9fc52e8669fe2b15f88d7)
            check_type(argname="argument region_of_interest", value=region_of_interest, expected_type=type_hints["region_of_interest"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "region_of_interest": region_of_interest,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def region_of_interest(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultRegionOfInterestCropRegionOfInterest":
        '''region_of_interest block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest DataAkamaiImagingPolicyImage#region_of_interest}
        '''
        result = self._values.get("region_of_interest")
        assert result is not None, "Required property 'region_of_interest' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultRegionOfInterestCropRegionOfInterest", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''The placement of the crop area relative to the specified area of interest.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''The placement of the crop area relative to the specified area of interest.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultRegionOfInterestCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultRegionOfInterestCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultRegionOfInterestCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d076746aa9f76e32d4c8959c97efe8e3f80c8f5b5beff9a075ff2984f3d0813f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultRegionOfInterestCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd5c597d29d581088050983a2618bdb57c01f8d8f6efd21c84707986d0858ac7)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultRegionOfInterestCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9c50ff4d3dbf848390072748e251a4ac820684b7b392f3d60ba33600dd9a0751)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ab55e968cb9174792e2f95aed8f3729375c53f5a476c1751bd0b7d9013c395d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6aaec7002ba1d7ca2a9227f8b6d2f904f54ac5d9aec93fcf9f49be65da1d1a0b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultRegionOfInterestCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultRegionOfInterestCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultRegionOfInterestCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a960fdf45ecd2b98007dced0c280bbf22f6cb56c9b475a6a0ef8da799f49d603)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultRegionOfInterestCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultRegionOfInterestCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c5ab21424ade9e6c1cdd08e725d82c0e22e166a578e99d2f0d0241fd494adcf9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putRegionOfInterest")
    def put_region_of_interest(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultRegionOfInterestCropRegionOfInterest()

        return typing.cast(None, jsii.invoke(self, "putRegionOfInterest", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterest")
    def region_of_interest(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultRegionOfInterestCropRegionOfInterestOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultRegionOfInterestCropRegionOfInterestOutputReference", jsii.get(self, "regionOfInterest"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestInput")
    def region_of_interest_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultRegionOfInterestCropRegionOfInterest"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultRegionOfInterestCropRegionOfInterest"], jsii.get(self, "regionOfInterestInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__acd92195103ac80034ea0812815633883a9934dd43a57b1b2a80b8dcd4a84cc9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__baacf6425b018ca1641d3ec84bf8519795d99b73780c93ddaffd37635f402839)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0f25fa3fb5da3a0a16a7d0b009740a4d48fc14f20d21d338cdd2a67ce79f3e2f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__95f8b996952e9d63a00c82d7402ad84ae684038c2ff7871baabdba9c72ede4a0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9045dcb8c4b68cdac3be1aab45c2dd689cb3bcd1d524d4ef3b0a064ce2455ef7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cb00e4efb1bdaf5ab9fd689b6a63b13e65555465cd58eb4eba1fb0b95a27d68b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f13dd6b6d43a68c063e6c0a62358c422b0587e722b1f23fbfb1a34923732f16f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0cdfc84783fe81e40dc5b340929e066ee9a658c8d3934f9c739f81cd701de501)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultRegionOfInterestCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultRegionOfInterestCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultRegionOfInterestCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a8d769dfba5d5146b6e579ae3970e3790b7dbc040bb2dbd5075ac2477032ca3c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultRegionOfInterestCropRegionOfInterest",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultRegionOfInterestCropRegionOfInterest:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultRegionOfInterestCropRegionOfInterest(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultRegionOfInterestCropRegionOfInterestOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultRegionOfInterestCropRegionOfInterestOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5618e950db7b84dc5a44457199bb1d936b7764cf43e9cb9a4239ca81b4969c96)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultRegionOfInterestCropRegionOfInterest]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultRegionOfInterestCropRegionOfInterest], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultRegionOfInterestCropRegionOfInterest],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c6abfc8b9894ef9b3a7685f3f7762a9dd879899bec54c58fc8aae1b443d5747e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultRelativeCrop",
    jsii_struct_bases=[],
    name_mapping={
        "east": "east",
        "east_var": "eastVar",
        "north": "north",
        "north_var": "northVar",
        "south": "south",
        "south_var": "southVar",
        "west": "west",
        "west_var": "westVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultRelativeCrop:
    def __init__(
        self,
        *,
        east: typing.Optional[builtins.str] = None,
        east_var: typing.Optional[builtins.str] = None,
        north: typing.Optional[builtins.str] = None,
        north_var: typing.Optional[builtins.str] = None,
        south: typing.Optional[builtins.str] = None,
        south_var: typing.Optional[builtins.str] = None,
        west: typing.Optional[builtins.str] = None,
        west_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param east: The number of pixels to shrink or expand the right side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east DataAkamaiImagingPolicyImage#east}
        :param east_var: The number of pixels to shrink or expand the right side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east_var DataAkamaiImagingPolicyImage#east_var}
        :param north: The number of pixels to shrink or expand the top side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north DataAkamaiImagingPolicyImage#north}
        :param north_var: The number of pixels to shrink or expand the top side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north_var DataAkamaiImagingPolicyImage#north_var}
        :param south: The number of pixels to shrink or expand the bottom side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south DataAkamaiImagingPolicyImage#south}
        :param south_var: The number of pixels to shrink or expand the bottom side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south_var DataAkamaiImagingPolicyImage#south_var}
        :param west: The number of pixels to shrink or expand the left side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west DataAkamaiImagingPolicyImage#west}
        :param west_var: The number of pixels to shrink or expand the left side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west_var DataAkamaiImagingPolicyImage#west_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b9a77343be90d5de9847da21405948055f9df9d296cacb58cfc2b4512bf5cc88)
            check_type(argname="argument east", value=east, expected_type=type_hints["east"])
            check_type(argname="argument east_var", value=east_var, expected_type=type_hints["east_var"])
            check_type(argname="argument north", value=north, expected_type=type_hints["north"])
            check_type(argname="argument north_var", value=north_var, expected_type=type_hints["north_var"])
            check_type(argname="argument south", value=south, expected_type=type_hints["south"])
            check_type(argname="argument south_var", value=south_var, expected_type=type_hints["south_var"])
            check_type(argname="argument west", value=west, expected_type=type_hints["west"])
            check_type(argname="argument west_var", value=west_var, expected_type=type_hints["west_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if east is not None:
            self._values["east"] = east
        if east_var is not None:
            self._values["east_var"] = east_var
        if north is not None:
            self._values["north"] = north
        if north_var is not None:
            self._values["north_var"] = north_var
        if south is not None:
            self._values["south"] = south
        if south_var is not None:
            self._values["south_var"] = south_var
        if west is not None:
            self._values["west"] = west
        if west_var is not None:
            self._values["west_var"] = west_var

    @builtins.property
    def east(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the right side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east DataAkamaiImagingPolicyImage#east}
        '''
        result = self._values.get("east")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def east_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the right side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east_var DataAkamaiImagingPolicyImage#east_var}
        '''
        result = self._values.get("east_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def north(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the top side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north DataAkamaiImagingPolicyImage#north}
        '''
        result = self._values.get("north")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def north_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the top side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north_var DataAkamaiImagingPolicyImage#north_var}
        '''
        result = self._values.get("north_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def south(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the bottom side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south DataAkamaiImagingPolicyImage#south}
        '''
        result = self._values.get("south")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def south_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the bottom side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south_var DataAkamaiImagingPolicyImage#south_var}
        '''
        result = self._values.get("south_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def west(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the left side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west DataAkamaiImagingPolicyImage#west}
        '''
        result = self._values.get("west")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def west_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the left side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west_var DataAkamaiImagingPolicyImage#west_var}
        '''
        result = self._values.get("west_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultRelativeCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultRelativeCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultRelativeCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__00981469e63972ba19484d15edc0666f7f1f535292c1da3de8e202abf3ff3965)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultRelativeCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0fa8ef764849af3a527ae7e12ce5d39a614f7322978359bbead2129274e95e42)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultRelativeCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4646efa6cfbb393179823797c1f6c1b2dc38235b0b7914fab11a0248a46c08a4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3774c98aa5f4cd74000a67c7e3d36935a7ba4c8a4f5842b46bf2777bbcfb2a13)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be862c8097cb75c27353d8038e5f54de1d569def66afa086cc46efe1af0ecdef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultRelativeCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultRelativeCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultRelativeCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__25d18e2201b6ace557698b073804972e0ba713ea2faeca3c609b17085faa37f3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultRelativeCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultRelativeCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1cdc4f4eed20456fbad066bf993b9107ff27a34e807b5b50f5967ebdbfb01b73)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetEast")
    def reset_east(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEast", []))

    @jsii.member(jsii_name="resetEastVar")
    def reset_east_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEastVar", []))

    @jsii.member(jsii_name="resetNorth")
    def reset_north(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNorth", []))

    @jsii.member(jsii_name="resetNorthVar")
    def reset_north_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNorthVar", []))

    @jsii.member(jsii_name="resetSouth")
    def reset_south(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSouth", []))

    @jsii.member(jsii_name="resetSouthVar")
    def reset_south_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSouthVar", []))

    @jsii.member(jsii_name="resetWest")
    def reset_west(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWest", []))

    @jsii.member(jsii_name="resetWestVar")
    def reset_west_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWestVar", []))

    @builtins.property
    @jsii.member(jsii_name="eastInput")
    def east_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "eastInput"))

    @builtins.property
    @jsii.member(jsii_name="eastVarInput")
    def east_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "eastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="northInput")
    def north_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "northInput"))

    @builtins.property
    @jsii.member(jsii_name="northVarInput")
    def north_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "northVarInput"))

    @builtins.property
    @jsii.member(jsii_name="southInput")
    def south_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "southInput"))

    @builtins.property
    @jsii.member(jsii_name="southVarInput")
    def south_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "southVarInput"))

    @builtins.property
    @jsii.member(jsii_name="westInput")
    def west_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "westInput"))

    @builtins.property
    @jsii.member(jsii_name="westVarInput")
    def west_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "westVarInput"))

    @builtins.property
    @jsii.member(jsii_name="east")
    def east(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "east"))

    @east.setter
    def east(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__27e9f695e2995c6e336fd463d39727a68ca709bc114b2959ede125d25bdc07c4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "east", value)

    @builtins.property
    @jsii.member(jsii_name="eastVar")
    def east_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "eastVar"))

    @east_var.setter
    def east_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ce8fec9557d58eb598e372938751a7613f02f51f04946227a0ec0067d7eea2d5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "eastVar", value)

    @builtins.property
    @jsii.member(jsii_name="north")
    def north(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "north"))

    @north.setter
    def north(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__05472c481474464cfac16eabcc7a7e2d733cdc90dae033988c24667f76759c1c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "north", value)

    @builtins.property
    @jsii.member(jsii_name="northVar")
    def north_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "northVar"))

    @north_var.setter
    def north_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d8484ccdc39c6e03b81f978d840a2d981121e05c13ba3bab1f183a91c6c3905)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "northVar", value)

    @builtins.property
    @jsii.member(jsii_name="south")
    def south(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "south"))

    @south.setter
    def south(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7f5647c6fd03da05ee422b643bd7883bffc28bf9ece1ea42b622bfc286e2147b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "south", value)

    @builtins.property
    @jsii.member(jsii_name="southVar")
    def south_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "southVar"))

    @south_var.setter
    def south_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__61054d48c8e2bcdb941ece21cb20c8cbf6298f47d17fb5d7d6bffe86677025f9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "southVar", value)

    @builtins.property
    @jsii.member(jsii_name="west")
    def west(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "west"))

    @west.setter
    def west(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__78990d24b2852ce48c1f3a5fc7a6d40b093b4e48eaa80b206e35a02f632d96fe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "west", value)

    @builtins.property
    @jsii.member(jsii_name="westVar")
    def west_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "westVar"))

    @west_var.setter
    def west_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c7585b3ca7f73714e69fe17d8796ecadd897af82a0752a365377bf948e921a61)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "westVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultRelativeCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultRelativeCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultRelativeCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__99951a601a51204e821a1c2571d854b14301fefcce4302524b3dcd62019901a2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultRemoveColor",
    jsii_struct_bases=[],
    name_mapping={
        "color": "color",
        "color_var": "colorVar",
        "feather": "feather",
        "feather_var": "featherVar",
        "tolerance": "tolerance",
        "tolerance_var": "toleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultRemoveColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
        feather: typing.Optional[builtins.str] = None,
        feather_var: typing.Optional[builtins.str] = None,
        tolerance: typing.Optional[builtins.str] = None,
        tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        :param feather: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        :param feather_var: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        :param tolerance: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        :param tolerance_var: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ddef1617e77ac207b73c8bf03ba96679355fc6dcdf7cd69c7a646a014bd251e7)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
            check_type(argname="argument feather", value=feather, expected_type=type_hints["feather"])
            check_type(argname="argument feather_var", value=feather_var, expected_type=type_hints["feather_var"])
            check_type(argname="argument tolerance", value=tolerance, expected_type=type_hints["tolerance"])
            check_type(argname="argument tolerance_var", value=tolerance_var, expected_type=type_hints["tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var
        if feather is not None:
            self._values["feather"] = feather
        if feather_var is not None:
            self._values["feather_var"] = feather_var
        if tolerance is not None:
            self._values["tolerance"] = tolerance
        if tolerance_var is not None:
            self._values["tolerance_var"] = tolerance_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        '''
        result = self._values.get("feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather_var(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        '''
        result = self._values.get("feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        '''
        result = self._values.get("tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance_var(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        result = self._values.get("tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultRemoveColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultRemoveColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultRemoveColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__20b8f9ec3a67f4d4a496168f77ea02d897b7a13407b580739642c54a76d4a3e2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultRemoveColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__246a8ca3d6871bebbc104ba97f9d0a0d8645f7bdeda5edd792ce50fb527d55ab)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultRemoveColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5d3878d10b12816511b3b614c9a718561b9749e2002ff9c60b93665071ac9ee7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e43a5ce13ea5aadd1cc5ec556407daf7fd8459d17a4e6dbf37daa92f86f37c68)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__11e97e121cee123f98132e61dd75c0ee9d9514afd345c55ff9cfd91d1511df8c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultRemoveColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultRemoveColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultRemoveColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0dce384e633f2ea71c0b03a21b9a117dce1ec2e53744c94d897d8f42ade7b308)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultRemoveColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultRemoveColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f178c6d3a104894ad6b9bad055f30eac7a950dc6613cae8e0b706891d053d39)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @jsii.member(jsii_name="resetFeather")
    def reset_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeather", []))

    @jsii.member(jsii_name="resetFeatherVar")
    def reset_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatherVar", []))

    @jsii.member(jsii_name="resetTolerance")
    def reset_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTolerance", []))

    @jsii.member(jsii_name="resetToleranceVar")
    def reset_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featherInput")
    def feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherInput"))

    @builtins.property
    @jsii.member(jsii_name="featherVarInput")
    def feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceInput")
    def tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceVarInput")
    def tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bac86001bef5c86f18b4aea6afda6d291675c830dbf8c2b5e472eb985805f30f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9761a544643751b69e0e5da5eb25b5204a46a0ba741e5cbd7faef35de343a803)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="feather")
    def feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "feather"))

    @feather.setter
    def feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5a023dbbb659b29d203cf14b627d8877bcdea6c979038c21d32c5024b9dcb9fd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "feather", value)

    @builtins.property
    @jsii.member(jsii_name="featherVar")
    def feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featherVar"))

    @feather_var.setter
    def feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ed276d83c82446fc18c63aa67e81ed5de10af45d712ac85909468ddf39b41957)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featherVar", value)

    @builtins.property
    @jsii.member(jsii_name="tolerance")
    def tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tolerance"))

    @tolerance.setter
    def tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5a8df22faad25db05a1cd916fa130e1a88e493b8f903ba7b4d6b641df0fa10fa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tolerance", value)

    @builtins.property
    @jsii.member(jsii_name="toleranceVar")
    def tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "toleranceVar"))

    @tolerance_var.setter
    def tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4f30bf2aec575ddd4909cc94b985102f075bef6139d8fa8d639e53a3660c9ba2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "toleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultRemoveColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultRemoveColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultRemoveColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e36920f88fac510fa7579db7b8cc9f368b668b61c51ed796937a5d3afb3ae822)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultResize",
    jsii_struct_bases=[],
    name_mapping={
        "aspect": "aspect",
        "aspect_var": "aspectVar",
        "height": "height",
        "height_var": "heightVar",
        "type": "type",
        "type_var": "typeVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultResize:
    def __init__(
        self,
        *,
        aspect: typing.Optional[builtins.str] = None,
        aspect_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param aspect: Preserves the aspect ratio. Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect DataAkamaiImagingPolicyImage#aspect}
        :param aspect_var: Preserves the aspect ratio. Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_var DataAkamaiImagingPolicyImage#aspect_var}
        :param height: The height to resize the source image to. Must be set if height is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height to resize the source image to. Must be set if height is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param type: Sets constraints for the image resize. Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: Sets constraints for the image resize. Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        :param width: The width to resize the source image to. Must be set if width is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width to resize the source image to. Must be set if width is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3666a852986cc01f19ac73d61c2292d0e625c498890bf5d10849c8403f1f3b05)
            check_type(argname="argument aspect", value=aspect, expected_type=type_hints["aspect"])
            check_type(argname="argument aspect_var", value=aspect_var, expected_type=type_hints["aspect_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if aspect is not None:
            self._values["aspect"] = aspect
        if aspect_var is not None:
            self._values["aspect_var"] = aspect_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def aspect(self) -> typing.Optional[builtins.str]:
        '''Preserves the aspect ratio.

        Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect DataAkamaiImagingPolicyImage#aspect}
        '''
        result = self._values.get("aspect")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def aspect_var(self) -> typing.Optional[builtins.str]:
        '''Preserves the aspect ratio.

        Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_var DataAkamaiImagingPolicyImage#aspect_var}
        '''
        result = self._values.get("aspect_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height to resize the source image to. Must be set if height is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height to resize the source image to. Must be set if height is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''Sets constraints for the image resize.

        Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''Sets constraints for the image resize.

        Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width to resize the source image to. Must be set if width is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width to resize the source image to. Must be set if width is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultResize(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultResizeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultResizeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__107af9431f34c167df24886b39819e364418b725bc561d95367124d72d784126)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultResizeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bbc1c29e37b4dd76a0377794ea635e1409569e190eb12bc78d75d1997f12a084)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultResizeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__da773b8913a5f1bb80ae105942b2fa4da33169fa96433502fadbcb0e20928f97)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d6effe5df3a9102f8caaaa4035356dba681a90d8bdcbd50e6d5ab04b0e5684d1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1699268b5f5c1548308c6daac8b2c288085fb41aadce87b97ca75cfbb7048b4d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultResize]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultResize]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultResize]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__518648ba23e06aafca55eac4ea49eb4ac865e71709474c9b88206bcac1bb4987)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultResizeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultResizeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3059acc15061119e02ea17c10c95450454d2a122f79c72c83f7a2662d0168c38)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAspect")
    def reset_aspect(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspect", []))

    @jsii.member(jsii_name="resetAspectVar")
    def reset_aspect_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspectVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="aspectInput")
    def aspect_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "aspectInput"))

    @builtins.property
    @jsii.member(jsii_name="aspectVarInput")
    def aspect_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "aspectVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="aspect")
    def aspect(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "aspect"))

    @aspect.setter
    def aspect(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__907fc419dd0f33d0914425bbb8e15f516e94bfab7da19a7170d901eeefff423a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "aspect", value)

    @builtins.property
    @jsii.member(jsii_name="aspectVar")
    def aspect_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "aspectVar"))

    @aspect_var.setter
    def aspect_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9bfe4ec4aa109c0cbadf2141e9ce8e724e6509d23ac76af7e95dd84e97793616)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "aspectVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cf7d5b87f75ed14146cc60a9a6fd133f53429071c97350b4a5ea87e0251593d0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__69ee9d4e4d305e07e282384697a2fa67888a01c8fd872dd8ba49340c1cbee36f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ec08e7b45277bce79ec5401f05caf1a7b6c7ed07845e5e01c0f26ce2b83eeca4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3f997d088e2f9ff1f4d85d36e5fa2765e562c537574d66e49560b1cb5d4ed0ce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6ce68776113318505f1394f044d1ad13dbc029fdcffec74c7f82d3cc0a75029a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e0340f2613bc7d3da413c412ee6fd277205d945553a429a7191d651f40b2b6c4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultResize]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultResize]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultResize]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__464311b5d77e4371a8a129cd547c2d670a0b89d636a39536964be470c20bcba1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultRotate",
    jsii_struct_bases=[],
    name_mapping={"degrees": "degrees", "degrees_var": "degreesVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultRotate:
    def __init__(
        self,
        *,
        degrees: typing.Optional[builtins.str] = None,
        degrees_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param degrees: The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees DataAkamaiImagingPolicyImage#degrees}
        :param degrees_var: The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees_var DataAkamaiImagingPolicyImage#degrees_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1122eebcf7edd90adbeb836a8d4abe9f6261fc3d974919759be03ff61fe88969)
            check_type(argname="argument degrees", value=degrees, expected_type=type_hints["degrees"])
            check_type(argname="argument degrees_var", value=degrees_var, expected_type=type_hints["degrees_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if degrees is not None:
            self._values["degrees"] = degrees
        if degrees_var is not None:
            self._values["degrees_var"] = degrees_var

    @builtins.property
    def degrees(self) -> typing.Optional[builtins.str]:
        '''The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees DataAkamaiImagingPolicyImage#degrees}
        '''
        result = self._values.get("degrees")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def degrees_var(self) -> typing.Optional[builtins.str]:
        '''The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees_var DataAkamaiImagingPolicyImage#degrees_var}
        '''
        result = self._values.get("degrees_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultRotate(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultRotateList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultRotateList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a3112534451b035560f4c235cc07990f7ca9324fe21ee4ce92ee2a715baf8ec5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultRotateOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dfb59827e002a6ce2a719f6731c2a5e1516bb52ad9509d5ee24fbbf4d7e1ee1c)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultRotateOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6330f7f4ae67950d4ae14e8cab492a53d8b519630aefc482a7ab4f62dbf7bc23)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e920236e1ce8ca402bc6056625fdbb231ec39f2fd53dcccd8fbd192ffc1270f1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e82972b4e10b82522390ae32c0a72e53199d73e4a9c13f0ba15616ad1f00174d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultRotate]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultRotate]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultRotate]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f626c1fecbe8235cfb150f4cf4f2d6398ef299029e2b0914253587b452f45deb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultRotateOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultRotateOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fe80bf06c02e253ee35ac02b80629b261d089ae33fa29ad962e296c0e2da6d0f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetDegrees")
    def reset_degrees(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDegrees", []))

    @jsii.member(jsii_name="resetDegreesVar")
    def reset_degrees_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDegreesVar", []))

    @builtins.property
    @jsii.member(jsii_name="degreesInput")
    def degrees_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "degreesInput"))

    @builtins.property
    @jsii.member(jsii_name="degreesVarInput")
    def degrees_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "degreesVarInput"))

    @builtins.property
    @jsii.member(jsii_name="degrees")
    def degrees(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "degrees"))

    @degrees.setter
    def degrees(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8904a596e18d9e87769360bddc79cd0ea6d263adf202815fb90a627ac9989014)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "degrees", value)

    @builtins.property
    @jsii.member(jsii_name="degreesVar")
    def degrees_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "degreesVar"))

    @degrees_var.setter
    def degrees_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eabeb1f31e55c36beced855f0c3bb072f0b94c6fe98b774c8373cddb14e754ba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "degreesVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultRotate]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultRotate]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultRotate]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b8c47e00485dcd2d5757b74a1f1c319da85f75362e2748437c2ff79c2ddeb07c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultScale",
    jsii_struct_bases=[],
    name_mapping={
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultScale:
    def __init__(
        self,
        *,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param height: Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged. Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged. Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2eddbaa11ee059b55a9c9ba787aa4d8c10fabc41fcf9d236209ba1242f188b7d)
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size.

        Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size.

        Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged.

        Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged.

        Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultScale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultScaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultScaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a436048e4174f1a70c24bb9608729348808849ba52618ce5936a35a9db60d42e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultScaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__18eedba28b3d5fa0a04a46d3cd74368e7b969bdf0bd490ce6f66517b1be0e2b3)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultScaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7935f00b5bb3dffdff650bb6b1fb03168e33e163b0c1ecab845b02721104b92e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fe4bc456d4d6daef7297b98c5ace5108db22c7041eda38c4fc1405d3f0d7f302)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3bbb4b74e344be5eb50e55f1de1f7da88d6e8d83d8ff0f1dddd5e80d3e1154a3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultScale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultScale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultScale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8d751c14feda0d800028fc1924c753051d2f3cba26c76d9fc6000e2eb3029192)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultScaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultScaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__90c57fb16b3d4b4a088e159b3a8707affdbc55a48d8507108c9aea3120a018ab)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6b7a444ebeb413164853a8a18e547b3e79d508be0008a28f0a4a0c4af6f1f6c4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b345bed49ddf971b0b1b9f2c6fdc5b783b1f097df1af72c9552a069a261e7742)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__66d2e5ac4047ca411c0bb007eb80232dfc7401510a2cc1ef4e8774f69e0bc99a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0de8c8709fd92f0b95e2cf06d569ac84febfe8ceea0c1609b370fc8c00703415)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultScale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultScale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultScale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8c9721f86ce794a04a9c8c6b5af1195c6b7e1e6422dcedc319ee10ff1f629d2e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultShear",
    jsii_struct_bases=[],
    name_mapping={
        "x_shear": "xShear",
        "x_shear_var": "xShearVar",
        "y_shear": "yShear",
        "y_shear_var": "yShearVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultShear:
    def __init__(
        self,
        *,
        x_shear: typing.Optional[builtins.str] = None,
        x_shear_var: typing.Optional[builtins.str] = None,
        y_shear: typing.Optional[builtins.str] = None,
        y_shear_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param x_shear: The amount to shear along the x-axis, measured in multiples of the image's width. Must be set if yShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear DataAkamaiImagingPolicyImage#x_shear}
        :param x_shear_var: The amount to shear along the x-axis, measured in multiples of the image's width. Must be set if yShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear_var DataAkamaiImagingPolicyImage#x_shear_var}
        :param y_shear: The amount to shear along the y-axis, measured in multiples of the image's height. Must be set if xShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear DataAkamaiImagingPolicyImage#y_shear}
        :param y_shear_var: The amount to shear along the y-axis, measured in multiples of the image's height. Must be set if xShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear_var DataAkamaiImagingPolicyImage#y_shear_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3b6615ad0c6951d3af96b5709caf9010a07c48eaff2142a8586f4e99ac5f21cb)
            check_type(argname="argument x_shear", value=x_shear, expected_type=type_hints["x_shear"])
            check_type(argname="argument x_shear_var", value=x_shear_var, expected_type=type_hints["x_shear_var"])
            check_type(argname="argument y_shear", value=y_shear, expected_type=type_hints["y_shear"])
            check_type(argname="argument y_shear_var", value=y_shear_var, expected_type=type_hints["y_shear_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if x_shear is not None:
            self._values["x_shear"] = x_shear
        if x_shear_var is not None:
            self._values["x_shear_var"] = x_shear_var
        if y_shear is not None:
            self._values["y_shear"] = y_shear
        if y_shear_var is not None:
            self._values["y_shear_var"] = y_shear_var

    @builtins.property
    def x_shear(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the x-axis, measured in multiples of the image's width.

        Must be set if yShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear DataAkamaiImagingPolicyImage#x_shear}
        '''
        result = self._values.get("x_shear")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_shear_var(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the x-axis, measured in multiples of the image's width.

        Must be set if yShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear_var DataAkamaiImagingPolicyImage#x_shear_var}
        '''
        result = self._values.get("x_shear_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_shear(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the y-axis, measured in multiples of the image's height.

        Must be set if xShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear DataAkamaiImagingPolicyImage#y_shear}
        '''
        result = self._values.get("y_shear")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_shear_var(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the y-axis, measured in multiples of the image's height.

        Must be set if xShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear_var DataAkamaiImagingPolicyImage#y_shear_var}
        '''
        result = self._values.get("y_shear_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultShear(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultShearList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultShearList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__41bc15c1bf64872419c216219780bf40da789447efd562a9dcbe40820395ecf7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultShearOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ec734798f6ffa8660082a50433a6292d0165d8f43d6b52b4216f04e659c7d828)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultShearOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__403b45c0ec2daa516ae57dc65de926484022b966b54d01c39b07a8532eaae510)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fdc3fb13c227c7d4a433c7c328ff450d7167003e2ddeb82b959a883cdf983493)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be708980a3d0eab2447b444b61c8f7af9802d1cd30d34acc3d0723b2e511f7a1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultShear]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultShear]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultShear]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__335d6716ba6e7133351940ffd14e78276a254928e10f2263c8b1b74d18046789)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultShearOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultShearOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d4dd83a40137efbd058654435d87dad36e13322acfd1c9b485df485dd0cff9d8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetXShear")
    def reset_x_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXShear", []))

    @jsii.member(jsii_name="resetXShearVar")
    def reset_x_shear_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXShearVar", []))

    @jsii.member(jsii_name="resetYShear")
    def reset_y_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYShear", []))

    @jsii.member(jsii_name="resetYShearVar")
    def reset_y_shear_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYShearVar", []))

    @builtins.property
    @jsii.member(jsii_name="xShearInput")
    def x_shear_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xShearInput"))

    @builtins.property
    @jsii.member(jsii_name="xShearVarInput")
    def x_shear_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xShearVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yShearInput")
    def y_shear_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yShearInput"))

    @builtins.property
    @jsii.member(jsii_name="yShearVarInput")
    def y_shear_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yShearVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xShear")
    def x_shear(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xShear"))

    @x_shear.setter
    def x_shear(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0457bbffc809d0fe845d14825803a906f4e3fd7576588293eeecba1bc0ab6cf8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xShear", value)

    @builtins.property
    @jsii.member(jsii_name="xShearVar")
    def x_shear_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xShearVar"))

    @x_shear_var.setter
    def x_shear_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__548f8634736f593b13b07cf25c8ca49dfed87ca6171bb1a8906562dcd6d1a720)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xShearVar", value)

    @builtins.property
    @jsii.member(jsii_name="yShear")
    def y_shear(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yShear"))

    @y_shear.setter
    def y_shear(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f260f6d86b68150cd6ab3d562fef46b1576e2fbd41c5339c24aa0d51d4874965)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yShear", value)

    @builtins.property
    @jsii.member(jsii_name="yShearVar")
    def y_shear_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yShearVar"))

    @y_shear_var.setter
    def y_shear_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__89856f8bc7bf628fd122adc461f667f1f70d74fb0143e5d08b939744f70290ed)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yShearVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultShear]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultShear]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultShear]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__15f821bab7c351d08982f9f9dd77ef1157d2143302d7f1ab6edfc54a60c448c1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultTrim",
    jsii_struct_bases=[],
    name_mapping={
        "fuzz": "fuzz",
        "fuzz_var": "fuzzVar",
        "padding": "padding",
        "padding_var": "paddingVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultTrim:
    def __init__(
        self,
        *,
        fuzz: typing.Optional[builtins.str] = None,
        fuzz_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fuzz: The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz DataAkamaiImagingPolicyImage#fuzz}
        :param fuzz_var: The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz_var DataAkamaiImagingPolicyImage#fuzz_var}
        :param padding: The amount of padding in pixels to add to the trimmed image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: The amount of padding in pixels to add to the trimmed image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d2e82c1a00f2a2843fbfe0162bc71fcc00327f2ea8eeef9528275675d6df3976)
            check_type(argname="argument fuzz", value=fuzz, expected_type=type_hints["fuzz"])
            check_type(argname="argument fuzz_var", value=fuzz_var, expected_type=type_hints["fuzz_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fuzz is not None:
            self._values["fuzz"] = fuzz
        if fuzz_var is not None:
            self._values["fuzz_var"] = fuzz_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var

    @builtins.property
    def fuzz(self) -> typing.Optional[builtins.str]:
        '''The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz DataAkamaiImagingPolicyImage#fuzz}
        '''
        result = self._values.get("fuzz")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fuzz_var(self) -> typing.Optional[builtins.str]:
        '''The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz_var DataAkamaiImagingPolicyImage#fuzz_var}
        '''
        result = self._values.get("fuzz_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''The amount of padding in pixels to add to the trimmed image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''The amount of padding in pixels to add to the trimmed image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultTrim(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultTrimList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultTrimList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__70ffb4678465b49dd25a7ead7af1b02ef506c51f88de7f943046bd251a25ead7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultTrimOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__87b11bb2a16a10fb84c721504e924d5c6d4d1e538d4931eddd57db27ae140be3)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultTrimOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__31cb9ca4c04d7cc558fab6532c15bafe0339064f1cf8fda33f85ef5e230fb937)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c6b11d383ed0d19ae704875ba1f6c0ed6cbcade4b0c612258b717d9b31337ff6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6539839a91a105288352274cae4b2ae86291e598811341e3dad01dc6c5fcb696)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultTrim]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultTrim]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultTrim]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__955e73bec0f3181869abac7f4aea19426ca1d3c8d67bbd680c0284d877ccbb51)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultTrimOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultTrimOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ef3d5fd7e3f6d648cdbb6862b78d75028ca7d30b24206b6ae8a12a367f693ea1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetFuzz")
    def reset_fuzz(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFuzz", []))

    @jsii.member(jsii_name="resetFuzzVar")
    def reset_fuzz_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFuzzVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @builtins.property
    @jsii.member(jsii_name="fuzzInput")
    def fuzz_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fuzzInput"))

    @builtins.property
    @jsii.member(jsii_name="fuzzVarInput")
    def fuzz_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fuzzVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="fuzz")
    def fuzz(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fuzz"))

    @fuzz.setter
    def fuzz(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ebdfb7c784b2a6cb688d1591e43f9a88f48f204dfc7bb65a924ec6b60f8be887)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fuzz", value)

    @builtins.property
    @jsii.member(jsii_name="fuzzVar")
    def fuzz_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fuzzVar"))

    @fuzz_var.setter
    def fuzz_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3589471f5c577b48bcddda378cb2f3e2e909d9f1075f62d467ae0e1d2495c9b0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fuzzVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__26e5c6ecb8f425812618afe050d1baf0aff9c57c1fabc5a7e83123142658689d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__55516cb41b0a26afbe2aff68895dc5490bb3a2d66c37736000288a84c40dad7d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultTrim]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultTrim]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultTrim]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__96e756b67594b7f560bedbe82626e01f48e6b2dd2365d59793dbbf166c0b3e13)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultUnsharpMask",
    jsii_struct_bases=[],
    name_mapping={
        "gain": "gain",
        "gain_var": "gainVar",
        "sigma": "sigma",
        "sigma_var": "sigmaVar",
        "threshold": "threshold",
        "threshold_var": "thresholdVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultUnsharpMask:
    def __init__(
        self,
        *,
        gain: typing.Optional[builtins.str] = None,
        gain_var: typing.Optional[builtins.str] = None,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
        threshold: typing.Optional[builtins.str] = None,
        threshold_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param gain: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        :param gain_var: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        :param sigma: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        :param threshold: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        :param threshold_var: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bf0ceaa243146c50fa100ea1164f2c941cef3ed29789b0fbd6fe32d72091d4d1)
            check_type(argname="argument gain", value=gain, expected_type=type_hints["gain"])
            check_type(argname="argument gain_var", value=gain_var, expected_type=type_hints["gain_var"])
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
            check_type(argname="argument threshold", value=threshold, expected_type=type_hints["threshold"])
            check_type(argname="argument threshold_var", value=threshold_var, expected_type=type_hints["threshold_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if gain is not None:
            self._values["gain"] = gain
        if gain_var is not None:
            self._values["gain_var"] = gain_var
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var
        if threshold is not None:
            self._values["threshold"] = threshold
        if threshold_var is not None:
            self._values["threshold_var"] = threshold_var

    @builtins.property
    def gain(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        '''
        result = self._values.get("gain")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gain_var(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        '''
        result = self._values.get("gain_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        '''
        result = self._values.get("threshold")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold_var(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        result = self._values.get("threshold_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultUnsharpMask(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultUnsharpMaskList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultUnsharpMaskList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__412de6a5cdc2b0143af7c54d2c3fe2a9e60c3c498baebaf43fb114e34da19e71)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultUnsharpMaskOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__41ec2a2f4ccc3fdf575469cacf267ce07e173873bb4142c007e1198d204c5243)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultUnsharpMaskOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__32e7e7724ef17634fc50ee3f337975421b7b7c337af794a528bd08208e9b2035)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ba14cc3c1bd917e75d117c358a396da63be394a18400047422c7fe64dacacc68)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b42c68acb4a396215c71a01906479cb03b107b3c9e32e2e013d491e74ebe02da)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultUnsharpMask]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultUnsharpMask]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultUnsharpMask]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cc3c720e885f3d89425d3843933c2054c2279cd6deb0a14811254a6398b13e1f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultUnsharpMaskOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultUnsharpMaskOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ef9024a7f29f7dbdda67a3df7faaecc6079c53efd1a43ac79c4901721dae2e32)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetGain")
    def reset_gain(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGain", []))

    @jsii.member(jsii_name="resetGainVar")
    def reset_gain_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGainVar", []))

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @jsii.member(jsii_name="resetThreshold")
    def reset_threshold(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThreshold", []))

    @jsii.member(jsii_name="resetThresholdVar")
    def reset_threshold_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThresholdVar", []))

    @builtins.property
    @jsii.member(jsii_name="gainInput")
    def gain_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainInput"))

    @builtins.property
    @jsii.member(jsii_name="gainVarInput")
    def gain_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdInput")
    def threshold_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdVarInput")
    def threshold_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gain")
    def gain(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gain"))

    @gain.setter
    def gain(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1e6b7dadf308af9e6e1a206f068ca06b9333c15e932c0ada136f5cd26e862846)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gain", value)

    @builtins.property
    @jsii.member(jsii_name="gainVar")
    def gain_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gainVar"))

    @gain_var.setter
    def gain_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__463300d15d980c381399d0c8adc3711461ceecb2fd3a3749b9a9cd7e2eb23bd6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gainVar", value)

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__82613b28fb32ac995d619abbb60de911eb90f8699d5cdf7b30045968fa422183)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__99dd5b54c858afa4ce52ee8c5aba32586ef7f780612cbc191303079d5527e073)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="threshold")
    def threshold(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "threshold"))

    @threshold.setter
    def threshold(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d6832f0663b6be1bac4b8089e15f1a6cb340a25cdc97b2f6645203128810e7c5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "threshold", value)

    @builtins.property
    @jsii.member(jsii_name="thresholdVar")
    def threshold_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "thresholdVar"))

    @threshold_var.setter
    def threshold_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1c304cc4e0a78469852e84dad2cb28baeec57dd2d6443f93644558dc659d13cd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "thresholdVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultUnsharpMask]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultUnsharpMask]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultUnsharpMask]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__53a1996dfc3feac31927e652c221372d721c435f6e9ba5889855cf342b2e0df9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqual",
    jsii_struct_bases=[],
    name_mapping={
        "append": "append",
        "aspect_crop": "aspectCrop",
        "background_color": "backgroundColor",
        "blur": "blur",
        "chroma_key": "chromaKey",
        "composite": "composite",
        "compound": "compound",
        "contrast": "contrast",
        "crop": "crop",
        "face_crop": "faceCrop",
        "feature_crop": "featureCrop",
        "fit_and_fill": "fitAndFill",
        "goop": "goop",
        "grayscale": "grayscale",
        "hsl": "hsl",
        "hsv": "hsv",
        "if_dimension": "ifDimension",
        "if_orientation": "ifOrientation",
        "im_query": "imQuery",
        "max_colors": "maxColors",
        "mirror": "mirror",
        "mono_hue": "monoHue",
        "opacity": "opacity",
        "region_of_interest_crop": "regionOfInterestCrop",
        "relative_crop": "relativeCrop",
        "remove_color": "removeColor",
        "resize": "resize",
        "rotate": "rotate",
        "scale": "scale",
        "shear": "shear",
        "trim": "trim",
        "unsharp_mask": "unsharpMask",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqual:
    def __init__(
        self,
        *,
        append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualAppend", typing.Dict[builtins.str, typing.Any]]]]] = None,
        aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualAspectCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualBackgroundColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualBlur", typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualChromaKey", typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualComposite", typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualCompound", typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualContrast", typing.Dict[builtins.str, typing.Any]]]]] = None,
        crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualFaceCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualFeatureCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualFitAndFill", typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualGoop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualGrayscale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualHsl", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualHsv", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfDimension", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfOrientation", typing.Dict[builtins.str, typing.Any]]]]] = None,
        im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualImQuery", typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualMaxColors", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualMirror", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualMonoHue", typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualOpacity", typing.Dict[builtins.str, typing.Any]]]]] = None,
        region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualRegionOfInterestCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualRelativeCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualRemoveColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualResize", typing.Dict[builtins.str, typing.Any]]]]] = None,
        rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualRotate", typing.Dict[builtins.str, typing.Any]]]]] = None,
        scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualScale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualShear", typing.Dict[builtins.str, typing.Any]]]]] = None,
        trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualTrim", typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualUnsharpMask", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param append: append block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        :param aspect_crop: aspect_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param crop: crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        :param face_crop: face_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        :param feature_crop: feature_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        :param fit_and_fill: fit_and_fill block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param im_query: im_query block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param region_of_interest_crop: region_of_interest_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        :param relative_crop: relative_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param resize: resize block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        :param rotate: rotate block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        :param scale: scale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param shear: shear block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        :param trim: trim block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9e9742dabf9329a8de667ed03e6280bc598bda8d6f7ffc2193d5f0eadd263591)
            check_type(argname="argument append", value=append, expected_type=type_hints["append"])
            check_type(argname="argument aspect_crop", value=aspect_crop, expected_type=type_hints["aspect_crop"])
            check_type(argname="argument background_color", value=background_color, expected_type=type_hints["background_color"])
            check_type(argname="argument blur", value=blur, expected_type=type_hints["blur"])
            check_type(argname="argument chroma_key", value=chroma_key, expected_type=type_hints["chroma_key"])
            check_type(argname="argument composite", value=composite, expected_type=type_hints["composite"])
            check_type(argname="argument compound", value=compound, expected_type=type_hints["compound"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument crop", value=crop, expected_type=type_hints["crop"])
            check_type(argname="argument face_crop", value=face_crop, expected_type=type_hints["face_crop"])
            check_type(argname="argument feature_crop", value=feature_crop, expected_type=type_hints["feature_crop"])
            check_type(argname="argument fit_and_fill", value=fit_and_fill, expected_type=type_hints["fit_and_fill"])
            check_type(argname="argument goop", value=goop, expected_type=type_hints["goop"])
            check_type(argname="argument grayscale", value=grayscale, expected_type=type_hints["grayscale"])
            check_type(argname="argument hsl", value=hsl, expected_type=type_hints["hsl"])
            check_type(argname="argument hsv", value=hsv, expected_type=type_hints["hsv"])
            check_type(argname="argument if_dimension", value=if_dimension, expected_type=type_hints["if_dimension"])
            check_type(argname="argument if_orientation", value=if_orientation, expected_type=type_hints["if_orientation"])
            check_type(argname="argument im_query", value=im_query, expected_type=type_hints["im_query"])
            check_type(argname="argument max_colors", value=max_colors, expected_type=type_hints["max_colors"])
            check_type(argname="argument mirror", value=mirror, expected_type=type_hints["mirror"])
            check_type(argname="argument mono_hue", value=mono_hue, expected_type=type_hints["mono_hue"])
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument region_of_interest_crop", value=region_of_interest_crop, expected_type=type_hints["region_of_interest_crop"])
            check_type(argname="argument relative_crop", value=relative_crop, expected_type=type_hints["relative_crop"])
            check_type(argname="argument remove_color", value=remove_color, expected_type=type_hints["remove_color"])
            check_type(argname="argument resize", value=resize, expected_type=type_hints["resize"])
            check_type(argname="argument rotate", value=rotate, expected_type=type_hints["rotate"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument shear", value=shear, expected_type=type_hints["shear"])
            check_type(argname="argument trim", value=trim, expected_type=type_hints["trim"])
            check_type(argname="argument unsharp_mask", value=unsharp_mask, expected_type=type_hints["unsharp_mask"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if append is not None:
            self._values["append"] = append
        if aspect_crop is not None:
            self._values["aspect_crop"] = aspect_crop
        if background_color is not None:
            self._values["background_color"] = background_color
        if blur is not None:
            self._values["blur"] = blur
        if chroma_key is not None:
            self._values["chroma_key"] = chroma_key
        if composite is not None:
            self._values["composite"] = composite
        if compound is not None:
            self._values["compound"] = compound
        if contrast is not None:
            self._values["contrast"] = contrast
        if crop is not None:
            self._values["crop"] = crop
        if face_crop is not None:
            self._values["face_crop"] = face_crop
        if feature_crop is not None:
            self._values["feature_crop"] = feature_crop
        if fit_and_fill is not None:
            self._values["fit_and_fill"] = fit_and_fill
        if goop is not None:
            self._values["goop"] = goop
        if grayscale is not None:
            self._values["grayscale"] = grayscale
        if hsl is not None:
            self._values["hsl"] = hsl
        if hsv is not None:
            self._values["hsv"] = hsv
        if if_dimension is not None:
            self._values["if_dimension"] = if_dimension
        if if_orientation is not None:
            self._values["if_orientation"] = if_orientation
        if im_query is not None:
            self._values["im_query"] = im_query
        if max_colors is not None:
            self._values["max_colors"] = max_colors
        if mirror is not None:
            self._values["mirror"] = mirror
        if mono_hue is not None:
            self._values["mono_hue"] = mono_hue
        if opacity is not None:
            self._values["opacity"] = opacity
        if region_of_interest_crop is not None:
            self._values["region_of_interest_crop"] = region_of_interest_crop
        if relative_crop is not None:
            self._values["relative_crop"] = relative_crop
        if remove_color is not None:
            self._values["remove_color"] = remove_color
        if resize is not None:
            self._values["resize"] = resize
        if rotate is not None:
            self._values["rotate"] = rotate
        if scale is not None:
            self._values["scale"] = scale
        if shear is not None:
            self._values["shear"] = shear
        if trim is not None:
            self._values["trim"] = trim
        if unsharp_mask is not None:
            self._values["unsharp_mask"] = unsharp_mask

    @builtins.property
    def append(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualAppend"]]]:
        '''append block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        '''
        result = self._values.get("append")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualAppend"]]], result)

    @builtins.property
    def aspect_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualAspectCrop"]]]:
        '''aspect_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        '''
        result = self._values.get("aspect_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualAspectCrop"]]], result)

    @builtins.property
    def background_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualBackgroundColor"]]]:
        '''background_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        '''
        result = self._values.get("background_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualBackgroundColor"]]], result)

    @builtins.property
    def blur(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualBlur"]]]:
        '''blur block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        '''
        result = self._values.get("blur")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualBlur"]]], result)

    @builtins.property
    def chroma_key(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualChromaKey"]]]:
        '''chroma_key block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        '''
        result = self._values.get("chroma_key")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualChromaKey"]]], result)

    @builtins.property
    def composite(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualComposite"]]]:
        '''composite block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        '''
        result = self._values.get("composite")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualComposite"]]], result)

    @builtins.property
    def compound(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualCompound"]]]:
        '''compound block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        '''
        result = self._values.get("compound")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualCompound"]]], result)

    @builtins.property
    def contrast(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualContrast"]]]:
        '''contrast block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualContrast"]]], result)

    @builtins.property
    def crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualCrop"]]]:
        '''crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        '''
        result = self._values.get("crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualCrop"]]], result)

    @builtins.property
    def face_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualFaceCrop"]]]:
        '''face_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        '''
        result = self._values.get("face_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualFaceCrop"]]], result)

    @builtins.property
    def feature_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualFeatureCrop"]]]:
        '''feature_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        '''
        result = self._values.get("feature_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualFeatureCrop"]]], result)

    @builtins.property
    def fit_and_fill(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualFitAndFill"]]]:
        '''fit_and_fill block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        '''
        result = self._values.get("fit_and_fill")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualFitAndFill"]]], result)

    @builtins.property
    def goop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualGoop"]]]:
        '''goop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        '''
        result = self._values.get("goop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualGoop"]]], result)

    @builtins.property
    def grayscale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualGrayscale"]]]:
        '''grayscale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        '''
        result = self._values.get("grayscale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualGrayscale"]]], result)

    @builtins.property
    def hsl(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualHsl"]]]:
        '''hsl block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        '''
        result = self._values.get("hsl")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualHsl"]]], result)

    @builtins.property
    def hsv(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualHsv"]]]:
        '''hsv block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        '''
        result = self._values.get("hsv")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualHsv"]]], result)

    @builtins.property
    def if_dimension(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfDimension"]]]:
        '''if_dimension block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        '''
        result = self._values.get("if_dimension")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfDimension"]]], result)

    @builtins.property
    def if_orientation(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfOrientation"]]]:
        '''if_orientation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        '''
        result = self._values.get("if_orientation")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfOrientation"]]], result)

    @builtins.property
    def im_query(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualImQuery"]]]:
        '''im_query block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        '''
        result = self._values.get("im_query")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualImQuery"]]], result)

    @builtins.property
    def max_colors(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualMaxColors"]]]:
        '''max_colors block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        '''
        result = self._values.get("max_colors")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualMaxColors"]]], result)

    @builtins.property
    def mirror(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualMirror"]]]:
        '''mirror block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        '''
        result = self._values.get("mirror")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualMirror"]]], result)

    @builtins.property
    def mono_hue(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualMonoHue"]]]:
        '''mono_hue block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        '''
        result = self._values.get("mono_hue")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualMonoHue"]]], result)

    @builtins.property
    def opacity(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualOpacity"]]]:
        '''opacity block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualOpacity"]]], result)

    @builtins.property
    def region_of_interest_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualRegionOfInterestCrop"]]]:
        '''region_of_interest_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        '''
        result = self._values.get("region_of_interest_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualRegionOfInterestCrop"]]], result)

    @builtins.property
    def relative_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualRelativeCrop"]]]:
        '''relative_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        '''
        result = self._values.get("relative_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualRelativeCrop"]]], result)

    @builtins.property
    def remove_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualRemoveColor"]]]:
        '''remove_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        '''
        result = self._values.get("remove_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualRemoveColor"]]], result)

    @builtins.property
    def resize(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualResize"]]]:
        '''resize block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        '''
        result = self._values.get("resize")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualResize"]]], result)

    @builtins.property
    def rotate(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualRotate"]]]:
        '''rotate block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        '''
        result = self._values.get("rotate")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualRotate"]]], result)

    @builtins.property
    def scale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualScale"]]]:
        '''scale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualScale"]]], result)

    @builtins.property
    def shear(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualShear"]]]:
        '''shear block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        '''
        result = self._values.get("shear")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualShear"]]], result)

    @builtins.property
    def trim(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualTrim"]]]:
        '''trim block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        '''
        result = self._values.get("trim")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualTrim"]]], result)

    @builtins.property
    def unsharp_mask(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualUnsharpMask"]]]:
        '''unsharp_mask block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        result = self._values.get("unsharp_mask")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualUnsharpMask"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqual(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualAppend",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_priority": "gravityPriority",
        "gravity_priority_var": "gravityPriorityVar",
        "gravity_var": "gravityVar",
        "preserve_minor_dimension": "preserveMinorDimension",
        "preserve_minor_dimension_var": "preserveMinorDimensionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualAppend:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualAppendImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_priority: typing.Optional[builtins.str] = None,
        gravity_priority_var: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        preserve_minor_dimension: typing.Optional[builtins.str] = None,
        preserve_minor_dimension_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Specifies where to place the ``image`` relative to the source image. The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_priority: Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal. The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority DataAkamaiImagingPolicyImage#gravity_priority}
        :param gravity_priority_var: Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal. The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority_var DataAkamaiImagingPolicyImage#gravity_priority_var}
        :param gravity_var: Specifies where to place the ``image`` relative to the source image. The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param preserve_minor_dimension: Whether to preserve the source image's minor dimension, ``false`` by default. The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension DataAkamaiImagingPolicyImage#preserve_minor_dimension}
        :param preserve_minor_dimension_var: Whether to preserve the source image's minor dimension, ``false`` by default. The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension_var DataAkamaiImagingPolicyImage#preserve_minor_dimension_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualAppendImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__11c9880897029b93160347e0bd95990151a1474d8411f2590736f772d5e74340)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_priority", value=gravity_priority, expected_type=type_hints["gravity_priority"])
            check_type(argname="argument gravity_priority_var", value=gravity_priority_var, expected_type=type_hints["gravity_priority_var"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument preserve_minor_dimension", value=preserve_minor_dimension, expected_type=type_hints["preserve_minor_dimension"])
            check_type(argname="argument preserve_minor_dimension_var", value=preserve_minor_dimension_var, expected_type=type_hints["preserve_minor_dimension_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_priority is not None:
            self._values["gravity_priority"] = gravity_priority
        if gravity_priority_var is not None:
            self._values["gravity_priority_var"] = gravity_priority_var
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if preserve_minor_dimension is not None:
            self._values["preserve_minor_dimension"] = preserve_minor_dimension
        if preserve_minor_dimension_var is not None:
            self._values["preserve_minor_dimension_var"] = preserve_minor_dimension_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualAppendImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualAppendImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Specifies where to place the ``image`` relative to the source image.

        The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_priority(self) -> typing.Optional[builtins.str]:
        '''Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal.

        The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority DataAkamaiImagingPolicyImage#gravity_priority}
        '''
        result = self._values.get("gravity_priority")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_priority_var(self) -> typing.Optional[builtins.str]:
        '''Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal.

        The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority_var DataAkamaiImagingPolicyImage#gravity_priority_var}
        '''
        result = self._values.get("gravity_priority_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Specifies where to place the ``image`` relative to the source image.

        The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def preserve_minor_dimension(self) -> typing.Optional[builtins.str]:
        '''Whether to preserve the source image's minor dimension, ``false`` by default.

        The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension DataAkamaiImagingPolicyImage#preserve_minor_dimension}
        '''
        result = self._values.get("preserve_minor_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def preserve_minor_dimension_var(self) -> typing.Optional[builtins.str]:
        '''Whether to preserve the source image's minor dimension, ``false`` by default.

        The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension_var DataAkamaiImagingPolicyImage#preserve_minor_dimension_var}
        '''
        result = self._values.get("preserve_minor_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualAppend(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualAppendImage",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualAppendImage:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualAppendImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualAppendImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualAppendImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eed3f3c5a3629553f498ff5eef4b370b562a18b13f7e59eb78d80a6171954712)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualAppendImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualAppendImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualAppendImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9efd3511086dc4dc1fbed7a6921a9151829e32dc0fedade763a994bdd83c8a1b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualAppendList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualAppendList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d2628543ad3760bdb5f13807a6313ecf4c2a3ccbce7d5ac1c4fe1e864fa30078)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualAppendOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__316fc47e42eb9a8a0632f21659a300e7e531a4b489317257f14ef2a1e6b1dd92)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualAppendOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d67ad56306f8ad0a5870929709ddcb6cf07e4f242d572a4c3afa6d2bc7c7cfac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0e0ea210158c8ca00108b570c36782c8719f4949f2126d58072022b1e0c4f299)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8856834916ddfe1cdebd3d7b4d1da6fe70c52278a5c1a378869f31ad205b7f84)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualAppend]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualAppend]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualAppend]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__da335d0a15840f11e2e07e048c3e66239f34216fb6e8e6e157d239336411914c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualAppendOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualAppendOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3114fcc6cf431a7a89e93c1dda5916006dbf824e94262e78b2afb3b5f8049769)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualAppendImage()

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityPriority")
    def reset_gravity_priority(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityPriority", []))

    @jsii.member(jsii_name="resetGravityPriorityVar")
    def reset_gravity_priority_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityPriorityVar", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPreserveMinorDimension")
    def reset_preserve_minor_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPreserveMinorDimension", []))

    @jsii.member(jsii_name="resetPreserveMinorDimensionVar")
    def reset_preserve_minor_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPreserveMinorDimensionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualAppendImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualAppendImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityInput")
    def gravity_priority_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityPriorityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityVarInput")
    def gravity_priority_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityPriorityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualAppendImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualAppendImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionInput")
    def preserve_minor_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "preserveMinorDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionVarInput")
    def preserve_minor_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "preserveMinorDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__18a24303edc72e8a2d9b08215223ef860f02d41967c4ae42b303d5912292579d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityPriority")
    def gravity_priority(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityPriority"))

    @gravity_priority.setter
    def gravity_priority(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2c2f5b3b856562f9e8633956ee1d24eb7e57a7ac3f5b0e8dafebe21e6d08fa2c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityPriority", value)

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityVar")
    def gravity_priority_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityPriorityVar"))

    @gravity_priority_var.setter
    def gravity_priority_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4eb0a7adc30596d15c8f89a247ee14e9066acf447e67f178207d61a17684904a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityPriorityVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e54dee00252476ad64d63285e3ab592bc24ee17b5dd48c95427ba45fbbdb02d6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimension")
    def preserve_minor_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "preserveMinorDimension"))

    @preserve_minor_dimension.setter
    def preserve_minor_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8b0438e2ac257df1598510602c8578acad773db245fb72e3e08fc95a24869fd8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "preserveMinorDimension", value)

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionVar")
    def preserve_minor_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "preserveMinorDimensionVar"))

    @preserve_minor_dimension_var.setter
    def preserve_minor_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fc606c86c9ead19ac134e599924f828c081a79d4c0042bd1deb3d645eaa2db0d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "preserveMinorDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualAppend]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualAppend]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualAppend]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aa1eda32d835b2b4a31720f02e6a86a686b21edc5a281f17521613fda0c3ec03)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualAspectCrop",
    jsii_struct_bases=[],
    name_mapping={
        "allow_expansion": "allowExpansion",
        "allow_expansion_var": "allowExpansionVar",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualAspectCrop:
    def __init__(
        self,
        *,
        allow_expansion: typing.Optional[builtins.str] = None,
        allow_expansion_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_expansion: Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image. Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        :param allow_expansion_var: Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image. Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        :param height: The height term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The width term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        :param x_position: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c3357aa2b5817521eaa325aaba656742d98574580d6c0c35dd7fa48e6edb8fa4)
            check_type(argname="argument allow_expansion", value=allow_expansion, expected_type=type_hints["allow_expansion"])
            check_type(argname="argument allow_expansion_var", value=allow_expansion_var, expected_type=type_hints["allow_expansion_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if allow_expansion is not None:
            self._values["allow_expansion"] = allow_expansion
        if allow_expansion_var is not None:
            self._values["allow_expansion_var"] = allow_expansion_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def allow_expansion(self) -> typing.Optional[builtins.str]:
        '''Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image.

        Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        '''
        result = self._values.get("allow_expansion")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def allow_expansion_var(self) -> typing.Optional[builtins.str]:
        '''Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image.

        Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        '''
        result = self._values.get("allow_expansion_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualAspectCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualAspectCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualAspectCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cb64d7ef3b31d46d6f070816718c372d91617ed3beacde5d082537508c35e1be)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualAspectCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1e282fd45effe9fecf2f8227adc530790169fea2b3139de6bcaf28ef642afdbd)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualAspectCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c36ff1472d7d15a29b799e9a1a00d51defca2685de36c169a7e8d2ccb0da8f55)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__13514d1f27ef1b1d7d522af7a35a3e096c9544455f571ba06263a924b093dc16)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7a5319c2e8e969181e85acdb6002d3515dd618a5db508b08a255320edd11d2b0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualAspectCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualAspectCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualAspectCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1701d26cd8bd44fc4c1732a0a25629605f400d190a5b2dd3d1391ab5dc9e50c5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualAspectCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualAspectCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7b875a15ed71f57e00069874cfb7edce79f0bb509d925c8c00eb04ebd7266c03)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAllowExpansion")
    def reset_allow_expansion(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansion", []))

    @jsii.member(jsii_name="resetAllowExpansionVar")
    def reset_allow_expansion_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansionVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionInput")
    def allow_expansion_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVarInput")
    def allow_expansion_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansion")
    def allow_expansion(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansion"))

    @allow_expansion.setter
    def allow_expansion(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__307b19743960cb9b704115fd64379b089bc635f1b9434608fd3c4569120f40d8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansion", value)

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVar")
    def allow_expansion_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansionVar"))

    @allow_expansion_var.setter
    def allow_expansion_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df69f43fc8cf99b3a1ae188135ee18d90c5b6ad306630fbace04f50167d3de8e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansionVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__09b7e7c05360d3a9ce63b668036f9113a7e37fec6f62265071a1ba869fae66c3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e7b3c2a2daddbf518e0fd70798b99fe615afe9931e0bb92fb71910baef5573d9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__253cbd22b963f1ef7e45761152029d911fb27e76c5a60c16295a490224ce61da)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0c5147f6a5810744f5130bada563e25eadf850e05476540f3c07b2ba4119d55c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__10caeff6be03f3a67565ad8f8f1b8295d872c9944eb5faf6304754c99200ba05)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__52e7bdc1ac88a827419ebd4bd34b5520bcd3080989136c156d7e121a39f512ea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__426350020ab6e58e78cc4ed97f7d9c24eac45ee8962de0512b978e8a4cb681ce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d9599422ad9a87d6efff5eb19166b42a7542faf2dfe3eac805c4984e1f485d02)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualAspectCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualAspectCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualAspectCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__abb777efbef34fdd3925e2d4db9e831737df307686e97e6c50f59b45b896d462)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualBackgroundColor",
    jsii_struct_bases=[],
    name_mapping={"color": "color", "color_var": "colorVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualBackgroundColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4351780741a04a0017ef04b196edcbb7a5967309ebfd237f9c57785838ff280a)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualBackgroundColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualBackgroundColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualBackgroundColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f388d66f970e4dce8217f00efde14a15559f9bf5bb1220fb8e9f15964f1f0a3f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualBackgroundColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df7aa380ae8412dd25959250f03c3770079fe9237bed1b1df2e99f6f1352a864)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualBackgroundColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__987653ee7889498fae855c481efa79bdf8f04bf81b6240df6c22b966867dd336)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d55a66df5ce64bc5ca286a64b910713ec03fb681e57d3f5c16e937f27c74a528)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__74638dab20f73de3747af993c5cbba81a63d03c6d3fed6180deadad939087057)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualBackgroundColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualBackgroundColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__67f2e13dde2d146ef8289a1cbca1e793535e63cc8f1a0d194f4b3e4b110b5d37)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualBackgroundColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualBackgroundColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__010d81fb92524c9aaec230c180c38cd1e5e5f950d4ec7be6fcc845afa9770f88)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c42b251617717a21fdf8c849a14a224ce64d756261bc7103c1731aef2710c1d6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f72e4abd9907c86310bcfa225dbfc16e2ba38d3db92d417457a8814a6a4e3155)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualBackgroundColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualBackgroundColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualBackgroundColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9e44fc727101e11619a7a481729161e3feac547adff2ce0e87f23a6c1c156c9f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualBlur",
    jsii_struct_bases=[],
    name_mapping={"sigma": "sigma", "sigma_var": "sigmaVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualBlur:
    def __init__(
        self,
        *,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param sigma: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7f728a39872967cfa7b2b23bcb405fb80d46e2add2454c025339dc0e14e4825a)
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualBlur(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualBlurList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualBlurList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__76c1e6f3ed8cf0e0866e629022a597777381b2818b0873fde2d4e4e03c87b40a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualBlurOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__62f326b1d7cd8337baf41209057cfd412e5830989efcafacfd99b1d9d9315e4f)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualBlurOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__444c4442340dfe559a57c6ccbc38b38c7edfd403aafca72c5e13134c0529143c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc10cfa266521d2026e5fcec7646e8e60fe102e8c3dccd2d650ebd34bd757270)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fc0f68d50c144d27d51d6dc06b0ca58020379ef68c976f1d9473f2d5ff6f3f49)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualBlur]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualBlur]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__de13d69ec85d44ce0f917826f8415214ce68ea9f032331d370e814feae1b1372)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualBlurOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualBlurOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bbf832c3ec1ed41a2beb0799f422cbf3dbf7cf235527193a94acf19fd0178a19)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8d4dcf52edbb2a9af851f18159824f539f74dc08b83a842f6a4b50d4072ee894)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ef10f1ed41429960453bc465558eb868ed093125035e2a69b190c2ae575da53)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualBlur]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualBlur]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualBlur]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8cd742c25239b6efcd40064b1077fb46cbfbfc4144df9b7e94850c96c741f050)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualChromaKey",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_feather": "hueFeather",
        "hue_feather_var": "hueFeatherVar",
        "hue_tolerance": "hueTolerance",
        "hue_tolerance_var": "hueToleranceVar",
        "hue_var": "hueVar",
        "lightness_feather": "lightnessFeather",
        "lightness_feather_var": "lightnessFeatherVar",
        "lightness_tolerance": "lightnessTolerance",
        "lightness_tolerance_var": "lightnessToleranceVar",
        "saturation_feather": "saturationFeather",
        "saturation_feather_var": "saturationFeatherVar",
        "saturation_tolerance": "saturationTolerance",
        "saturation_tolerance_var": "saturationToleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualChromaKey:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_feather: typing.Optional[builtins.str] = None,
        hue_feather_var: typing.Optional[builtins.str] = None,
        hue_tolerance: typing.Optional[builtins.str] = None,
        hue_tolerance_var: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness_feather: typing.Optional[builtins.str] = None,
        lightness_feather_var: typing.Optional[builtins.str] = None,
        lightness_tolerance: typing.Optional[builtins.str] = None,
        lightness_tolerance_var: typing.Optional[builtins.str] = None,
        saturation_feather: typing.Optional[builtins.str] = None,
        saturation_feather_var: typing.Optional[builtins.str] = None,
        saturation_tolerance: typing.Optional[builtins.str] = None,
        saturation_tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_feather: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        :param hue_feather_var: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        :param hue_tolerance: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        :param hue_tolerance_var: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        :param hue_var: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness_feather: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        :param lightness_feather_var: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        :param lightness_tolerance: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        :param lightness_tolerance_var: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        :param saturation_feather: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        :param saturation_feather_var: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        :param saturation_tolerance: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        :param saturation_tolerance_var: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ce538ef3cc50adb934bf5064c8e4c126445eed4a3cc68f53080cdee0a67ba599)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_feather", value=hue_feather, expected_type=type_hints["hue_feather"])
            check_type(argname="argument hue_feather_var", value=hue_feather_var, expected_type=type_hints["hue_feather_var"])
            check_type(argname="argument hue_tolerance", value=hue_tolerance, expected_type=type_hints["hue_tolerance"])
            check_type(argname="argument hue_tolerance_var", value=hue_tolerance_var, expected_type=type_hints["hue_tolerance_var"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness_feather", value=lightness_feather, expected_type=type_hints["lightness_feather"])
            check_type(argname="argument lightness_feather_var", value=lightness_feather_var, expected_type=type_hints["lightness_feather_var"])
            check_type(argname="argument lightness_tolerance", value=lightness_tolerance, expected_type=type_hints["lightness_tolerance"])
            check_type(argname="argument lightness_tolerance_var", value=lightness_tolerance_var, expected_type=type_hints["lightness_tolerance_var"])
            check_type(argname="argument saturation_feather", value=saturation_feather, expected_type=type_hints["saturation_feather"])
            check_type(argname="argument saturation_feather_var", value=saturation_feather_var, expected_type=type_hints["saturation_feather_var"])
            check_type(argname="argument saturation_tolerance", value=saturation_tolerance, expected_type=type_hints["saturation_tolerance"])
            check_type(argname="argument saturation_tolerance_var", value=saturation_tolerance_var, expected_type=type_hints["saturation_tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_feather is not None:
            self._values["hue_feather"] = hue_feather
        if hue_feather_var is not None:
            self._values["hue_feather_var"] = hue_feather_var
        if hue_tolerance is not None:
            self._values["hue_tolerance"] = hue_tolerance
        if hue_tolerance_var is not None:
            self._values["hue_tolerance_var"] = hue_tolerance_var
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness_feather is not None:
            self._values["lightness_feather"] = lightness_feather
        if lightness_feather_var is not None:
            self._values["lightness_feather_var"] = lightness_feather_var
        if lightness_tolerance is not None:
            self._values["lightness_tolerance"] = lightness_tolerance
        if lightness_tolerance_var is not None:
            self._values["lightness_tolerance_var"] = lightness_tolerance_var
        if saturation_feather is not None:
            self._values["saturation_feather"] = saturation_feather
        if saturation_feather_var is not None:
            self._values["saturation_feather_var"] = saturation_feather_var
        if saturation_tolerance is not None:
            self._values["saturation_tolerance"] = saturation_tolerance
        if saturation_tolerance_var is not None:
            self._values["saturation_tolerance_var"] = saturation_tolerance_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        '''
        result = self._values.get("hue_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        '''
        result = self._values.get("hue_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        '''
        result = self._values.get("hue_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        '''
        result = self._values.get("hue_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        '''
        result = self._values.get("lightness_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        '''
        result = self._values.get("lightness_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        '''
        result = self._values.get("lightness_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        '''
        result = self._values.get("lightness_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        '''
        result = self._values.get("saturation_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        '''
        result = self._values.get("saturation_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        '''
        result = self._values.get("saturation_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        result = self._values.get("saturation_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualChromaKey(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualChromaKeyList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualChromaKeyList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5eb209d13c0ffe5ca7eb0b8b734f894a72811cc5c2b7c72b8e9bea54cb07d7a2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualChromaKeyOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a63e59034c2355e5adf21617a2669dde7c7474f1ca4e2e940c2657894f6abf0c)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualChromaKeyOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6fba4342913c66355e3ac23031d20e406bd7e78376baa2e1bd58f4e05ddb4fe8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0f0c9899531ac2a62e022cc7422335ab5b48e23fe552afb1f589cfdf7c6b985c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7e332d6c35b638e90284030482c68f7913dd816db7a4d9d63447471ead0a45d8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualChromaKey]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualChromaKey]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eee007e4a8d1834dbd3add809777416a5c0be43a5639e003d1c12fa66073744c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualChromaKeyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualChromaKeyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0f106a055771e11be976ee4d350e43ea7a2262faf9bfd6b81d0fb68c921c2246)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueFeather")
    def reset_hue_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeather", []))

    @jsii.member(jsii_name="resetHueFeatherVar")
    def reset_hue_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeatherVar", []))

    @jsii.member(jsii_name="resetHueTolerance")
    def reset_hue_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueTolerance", []))

    @jsii.member(jsii_name="resetHueToleranceVar")
    def reset_hue_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueToleranceVar", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightnessFeather")
    def reset_lightness_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeather", []))

    @jsii.member(jsii_name="resetLightnessFeatherVar")
    def reset_lightness_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeatherVar", []))

    @jsii.member(jsii_name="resetLightnessTolerance")
    def reset_lightness_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessTolerance", []))

    @jsii.member(jsii_name="resetLightnessToleranceVar")
    def reset_lightness_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessToleranceVar", []))

    @jsii.member(jsii_name="resetSaturationFeather")
    def reset_saturation_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeather", []))

    @jsii.member(jsii_name="resetSaturationFeatherVar")
    def reset_saturation_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeatherVar", []))

    @jsii.member(jsii_name="resetSaturationTolerance")
    def reset_saturation_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationTolerance", []))

    @jsii.member(jsii_name="resetSaturationToleranceVar")
    def reset_saturation_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherInput")
    def hue_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVarInput")
    def hue_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceInput")
    def hue_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVarInput")
    def hue_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherInput")
    def lightness_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVarInput")
    def lightness_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceInput")
    def lightness_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVarInput")
    def lightness_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherInput")
    def saturation_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVarInput")
    def saturation_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceInput")
    def saturation_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVarInput")
    def saturation_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__06de32486d0a2dbb60e6e31cf1a04d43470bd3e58cbdffa67e1878099a5a2eea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeather")
    def hue_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeather"))

    @hue_feather.setter
    def hue_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2413bef5f7e53ac38bdfde6604d4f6261b9575312c4f6a0f74ba719406171247)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeather", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVar")
    def hue_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeatherVar"))

    @hue_feather_var.setter
    def hue_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__411d7d0d88941d619b2275a06a419a4977127ad798f5ebd583c345a95404e737)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueTolerance")
    def hue_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueTolerance"))

    @hue_tolerance.setter
    def hue_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1c62a4cc8e7af4852e0e49f8778d6f548deb0e04b8ff7b9080d709ff55e1755d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVar")
    def hue_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueToleranceVar"))

    @hue_tolerance_var.setter
    def hue_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9b2440f37b0b028d9dc9f7f7b8383c03dd54ceb0a8bbd9c0cf0f666bafa5845f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__639827437d7029b7d317286477e18540c6c40284ebd1914a2fcc6d26cc57e0d3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeather")
    def lightness_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeather"))

    @lightness_feather.setter
    def lightness_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c6163d3c24f4b376b9e353fc04c3e17c619180578083790e7193bb143aa0e414)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeather", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVar")
    def lightness_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeatherVar"))

    @lightness_feather_var.setter
    def lightness_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8c434ff328264b379cdce02fc76584a931babc4eb98613b18172f83ecd4f466e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessTolerance")
    def lightness_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessTolerance"))

    @lightness_tolerance.setter
    def lightness_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__98bb045c4073e20b7745c3d0bb68ae4d51ef879ce5776ae6341c2dd12f0d1c62)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVar")
    def lightness_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessToleranceVar"))

    @lightness_tolerance_var.setter
    def lightness_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f955d04b08aaccfbf56647eebb1510c9e63d6ae396bc199ee7a2f41746ef3640)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeather")
    def saturation_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeather"))

    @saturation_feather.setter
    def saturation_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4db2e789c90231844ce80a3c5d1a16ed0ff67f7add23a063f5da9a7e0961c550)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeather", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVar")
    def saturation_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeatherVar"))

    @saturation_feather_var.setter
    def saturation_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cc0b7d4278d43b669d804776dc79bc6f3e7a6176544fb5611e17592347094810)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationTolerance")
    def saturation_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationTolerance"))

    @saturation_tolerance.setter
    def saturation_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__82a35455974d1d7762df981072e2e2d88b921c74a8bda1d07a7baddf64b30b88)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVar")
    def saturation_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationToleranceVar"))

    @saturation_tolerance_var.setter
    def saturation_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1070ecf29e9280d7c8c775a96eb0ee3ddb5ad8e82b9419c76b62c8c7534f28e8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualChromaKey]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualChromaKey]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualChromaKey]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__68b7c47026790a61c1a151789cab11a9b3377e7f25721276fcc7558fa769c2ec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualComposite",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "placement": "placement",
        "placement_var": "placementVar",
        "scale": "scale",
        "scale_dimension": "scaleDimension",
        "scale_dimension_var": "scaleDimensionVar",
        "scale_var": "scaleVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualComposite:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualCompositeImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        placement: typing.Optional[builtins.str] = None,
        placement_var: typing.Optional[builtins.str] = None,
        scale: typing.Optional[builtins.str] = None,
        scale_dimension: typing.Optional[builtins.str] = None,
        scale_dimension_var: typing.Optional[builtins.str] = None,
        scale_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param placement: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        :param placement_var: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        :param scale: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param scale_dimension: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        :param scale_dimension_var: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        :param scale_var: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        :param x_position: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualCompositeImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1b766b973c30960da3bfaaf2513c304cb96074e5e1e9e9f51a9eab39bf51ba56)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument placement", value=placement, expected_type=type_hints["placement"])
            check_type(argname="argument placement_var", value=placement_var, expected_type=type_hints["placement_var"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument scale_dimension", value=scale_dimension, expected_type=type_hints["scale_dimension"])
            check_type(argname="argument scale_dimension_var", value=scale_dimension_var, expected_type=type_hints["scale_dimension_var"])
            check_type(argname="argument scale_var", value=scale_var, expected_type=type_hints["scale_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if placement is not None:
            self._values["placement"] = placement
        if placement_var is not None:
            self._values["placement_var"] = placement_var
        if scale is not None:
            self._values["scale"] = scale
        if scale_dimension is not None:
            self._values["scale_dimension"] = scale_dimension
        if scale_dimension_var is not None:
            self._values["scale_dimension_var"] = scale_dimension_var
        if scale_var is not None:
            self._values["scale_var"] = scale_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualCompositeImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualCompositeImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        '''
        result = self._values.get("placement")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement_var(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        '''
        result = self._values.get("placement_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        '''
        result = self._values.get("scale_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        '''
        result = self._values.get("scale_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        '''
        result = self._values.get("scale_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualComposite(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualCompositeImage",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualCompositeImage:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualCompositeImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualCompositeImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualCompositeImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__58a61d26067a34c21870bc200e3e72e874b2b5ff1db3fc3f6029e8607afc8caa)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualCompositeImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualCompositeImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8952fe3a92df71288aef9c8fadea964b08d49d4f20fa9655915ce08e322ee554)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualCompositeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualCompositeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d9560c5dd8acb76d76bd8b203875b58dfc1d291ae760a6683dbc5833406f914)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualCompositeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__31789a7218ab298627224e11e778b1df3a845294053b7d24ed68dd1f627e86e9)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualCompositeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__60fd0fcf334fc60bbd4d8b32aebbe25044fb2638444d195366abc4b543be09e0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f5412b036c365d8d74c9d48e5a83a87dd9aef24ce4aee4a7aff6b4d9be8dbdc8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__abdafd27d6b2ddf034ab68c08e2d30941c72608ad34afa4aa85f274db062c489)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualComposite]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualComposite]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7a13afd2eea9d00775897c37938d28e0bc9d4a1fd0a350a1b0d45fa641bc4d4e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualCompositeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualCompositeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5d41fe1e150f0e02de7e183ae2da622092b502b2a3348d70b2580c9f4d12318b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualCompositeImage()

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPlacement")
    def reset_placement(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacement", []))

    @jsii.member(jsii_name="resetPlacementVar")
    def reset_placement_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacementVar", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetScaleDimension")
    def reset_scale_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimension", []))

    @jsii.member(jsii_name="resetScaleDimensionVar")
    def reset_scale_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimensionVar", []))

    @jsii.member(jsii_name="resetScaleVar")
    def reset_scale_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualCompositeImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualCompositeImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualCompositeImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="placementInput")
    def placement_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementInput"))

    @builtins.property
    @jsii.member(jsii_name="placementVarInput")
    def placement_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionInput")
    def scale_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVarInput")
    def scale_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleVarInput")
    def scale_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__115251e88793d5115bfb03bc0a85ea731a2bb367164550d5afb5681ca89c8a02)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bdb4a1d023f8a7fc3fdc6f072ee9e27ec386e980bb9ed0a7a292ca6339c7103e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="placement")
    def placement(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placement"))

    @placement.setter
    def placement(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f776ea8b7d247bb6b668ada2babb95c7b77bd35cdc0a20100782f4e3a14c93f4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placement", value)

    @builtins.property
    @jsii.member(jsii_name="placementVar")
    def placement_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placementVar"))

    @placement_var.setter
    def placement_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1fdb31259e3e4e89ba247fb2eb6c13f95d68651a1eed26860ac0e66365c81df6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placementVar", value)

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scale"))

    @scale.setter
    def scale(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bdb44dcac72d0cae9045b3a8e32748ece9105e1619e4f9d29bf9436af7613568)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scale", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimension")
    def scale_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimension"))

    @scale_dimension.setter
    def scale_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__04062c65364b7e86c2f1071a29d498dc324ce6ed34816f12c41958c79fef2b8b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimension", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVar")
    def scale_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimensionVar"))

    @scale_dimension_var.setter
    def scale_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea5562caed9c2fc81d2f076dae8e21b0c9e545e7d25701f184cf16246d8f11e0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="scaleVar")
    def scale_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleVar"))

    @scale_var.setter
    def scale_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4aeeaacc6b110e2e695046011edf7820b563d157512ee9c5fc1bdc189d841a2a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a27f2579fd931d79d1b0bcaab9975f3437a889af102f172d0adbd5d001b9f608)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a540bfe5301c081b19826642c9d54df159ea5e0f60e2819914df7eed68007c1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__76c57ff10b16667f6faf3b4e1e61b183919d70647b26d93a277d1b53b697cb8d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0541ab6569dc38583d60cf39f00361c799b7db6c30a207cef1e7bc8401450692)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualComposite]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualComposite]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualComposite]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5d5d6d5cfcbd4fac2e762673ba8325b953e3042b3b22b65138e9b35537bc5dea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualCompound",
    jsii_struct_bases=[],
    name_mapping={"transformations": "transformations"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualCompound:
    def __init__(
        self,
        *,
        transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param transformations: transformations block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c80e64a7660fbf829e0d4abcd31f7a9ff106a8ce62ad505b61e87bd0afd6be0b)
            check_type(argname="argument transformations", value=transformations, expected_type=type_hints["transformations"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if transformations is not None:
            self._values["transformations"] = transformations

    @builtins.property
    def transformations(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualCompoundTransformations"]]]:
        '''transformations block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        result = self._values.get("transformations")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualCompoundTransformations"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualCompound(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualCompoundList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualCompoundList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__282c34dbfea4d80ab3af6162d563b5ff8f616a82264a05a68a57d2ed8f86bbd0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualCompoundOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3f223296dfa1aff0fe2a3397b07e4a2ec7c65371f95ffa0c3e045b810a49178c)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualCompoundOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e93fc9d59068e5e14fc5b191500d519b6cf7350dacc395ac2c1fd29654017500)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6799e6faee4643f5412f6e263a570c8175cb56415283b54215c9767c1ff3942c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d8c55f2d903baab23a4ecca3004cdf01e8f5d6b124334ac7e727052af6c6e68)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualCompound]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualCompound]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__81ae73c93837de3935c67efe544432c1261d20dcb6dd87485aab7461be1b20fb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualCompoundOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualCompoundOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d08e83a2bddb1b606dc3e919e7b0b71f75a63601f5d74ec116ff3437fa6cca90)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformations")
    def put_transformations(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9fcf54bd1dd30cb655ac5f98e8b9a705fb69971525fb03c8f1723c88f04f5eb2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTransformations", [value]))

    @jsii.member(jsii_name="resetTransformations")
    def reset_transformations(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformations", []))

    @builtins.property
    @jsii.member(jsii_name="transformations")
    def transformations(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualCompoundTransformationsList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualCompoundTransformationsList", jsii.get(self, "transformations"))

    @builtins.property
    @jsii.member(jsii_name="transformationsInput")
    def transformations_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualCompoundTransformations"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualCompoundTransformations"]]], jsii.get(self, "transformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualCompound]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualCompound]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualCompound]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__391161fb7a575e00133b838da0fe99c401d9e052c70e74bd2590706096415e9a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualCompoundTransformations",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualCompoundTransformations:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualCompoundTransformations(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualCompoundTransformationsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualCompoundTransformationsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__042cbfcf238390a54079006dc9efbf25502c3f4f0bd1e4c80e02b1843c286435)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualCompoundTransformationsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e56c537038d80408291edef5cc794e14a0464450f3e6a838665c65eeafd53c59)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualCompoundTransformationsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e969c7d43a6027e20da9b91b1ff81fca9e1a8b3f74423023be1593c7b4d96830)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d7e1ee8520615644425a5a3be725550e5630757c8877d4fe1ebfca4a0b4bb2f1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__80710fe87124f78eff7e715b45628cfdb4d53f54cafa8c9db26c71c54f5dd005)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualCompoundTransformations]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualCompoundTransformations]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualCompoundTransformations]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__62b84776f0391fbf14e7db8c4c1a5e11773c53a918a9704bd5a6d00dd262881b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualCompoundTransformationsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualCompoundTransformationsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1a47945a0ca2d8a7e86afb87c69179795cde42a4f6e6edc2657869c78641b1a1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualCompoundTransformations]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualCompoundTransformations]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualCompoundTransformations]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__271d59e6f92e1e9572bf71b4bf577b1eaf209400507af48099b605702d360a89)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualContrast",
    jsii_struct_bases=[],
    name_mapping={
        "brightness": "brightness",
        "brightness_var": "brightnessVar",
        "contrast": "contrast",
        "contrast_var": "contrastVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualContrast:
    def __init__(
        self,
        *,
        brightness: typing.Optional[builtins.str] = None,
        brightness_var: typing.Optional[builtins.str] = None,
        contrast: typing.Optional[builtins.str] = None,
        contrast_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param brightness: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        :param brightness_var: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        :param contrast: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param contrast_var: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e54f3a4ae68308842183bff16e970df6dc2ae061dde4256f2ec3dceb93fd0b00)
            check_type(argname="argument brightness", value=brightness, expected_type=type_hints["brightness"])
            check_type(argname="argument brightness_var", value=brightness_var, expected_type=type_hints["brightness_var"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument contrast_var", value=contrast_var, expected_type=type_hints["contrast_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if brightness is not None:
            self._values["brightness"] = brightness
        if brightness_var is not None:
            self._values["brightness_var"] = brightness_var
        if contrast is not None:
            self._values["contrast"] = contrast
        if contrast_var is not None:
            self._values["contrast_var"] = contrast_var

    @builtins.property
    def brightness(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        '''
        result = self._values.get("brightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def brightness_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        '''
        result = self._values.get("brightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        result = self._values.get("contrast_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualContrast(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualContrastList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualContrastList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__659c6577175df3c579e216d675af1ecc676ff938db8caa2a786fcd8af1ea2cf4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualContrastOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__075941c324a26b0dac2fafb64b12176a2eae1e4af825949ee899d8f8c0a51079)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualContrastOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8923bb53584b32088a1f687a4e76b9c003a433e545fde48d0b1998783f0d87cb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0de2bc446fda271a2fa5c9b327ddb87edab9198a96ca13d3495485f8be01039b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a16a1c4824b5c8b19be3717e0bea67a2da4fa42eb9f22572e79783ebc2461f8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualContrast]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualContrast]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__20876ac4c7d3f45f375037424ba2bb7d1402886e425e53f0d928bcff7c7dd7f8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualContrastOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualContrastOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c0bfdf166b2f9f39caade2d74a285db22b018184912f0cd5d9c20136e730e295)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetBrightness")
    def reset_brightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightness", []))

    @jsii.member(jsii_name="resetBrightnessVar")
    def reset_brightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightnessVar", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetContrastVar")
    def reset_contrast_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrastVar", []))

    @builtins.property
    @jsii.member(jsii_name="brightnessInput")
    def brightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="brightnessVarInput")
    def brightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastVarInput")
    def contrast_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="brightness")
    def brightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightness"))

    @brightness.setter
    def brightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6cc0d8f690d4141453201c49070e191c5659fca42c1b956532b18b563f7adaf5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightness", value)

    @builtins.property
    @jsii.member(jsii_name="brightnessVar")
    def brightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightnessVar"))

    @brightness_var.setter
    def brightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__945134c3143d074b5109fa780af34be648502234690d0f165ce5a4a5d27bdec7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrast"))

    @contrast.setter
    def contrast(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab618008eaa307e95fefe52272480b13d8429fea505fb731cb92c7652d86d6f0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrast", value)

    @builtins.property
    @jsii.member(jsii_name="contrastVar")
    def contrast_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrastVar"))

    @contrast_var.setter
    def contrast_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7e4a532139f1070ed78048da9feed1609c8bc65b8f3926eb47b1c5d2b6504043)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrastVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualContrast]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualContrast]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualContrast]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1622eb488908ec86cfd58c25645be1782a149b21389ab78d65c43192b78b5e0f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualCrop",
    jsii_struct_bases=[],
    name_mapping={
        "allow_expansion": "allowExpansion",
        "allow_expansion_var": "allowExpansionVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualCrop:
    def __init__(
        self,
        *,
        allow_expansion: typing.Optional[builtins.str] = None,
        allow_expansion_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_expansion: If cropping an area outside of the existing canvas, expands the image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        :param allow_expansion_var: If cropping an area outside of the existing canvas, expands the image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        :param gravity: Frame of reference for X and Y Positions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Frame of reference for X and Y Positions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The number of pixels to crop along the y-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The number of pixels to crop along the y-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The number of pixels to crop along the x-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The number of pixels to crop along the x-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        :param x_position: The x-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ba8762ae1af3230499228143261ed5b5bbff46f0c693706a537fc35bcb0e1f9)
            check_type(argname="argument allow_expansion", value=allow_expansion, expected_type=type_hints["allow_expansion"])
            check_type(argname="argument allow_expansion_var", value=allow_expansion_var, expected_type=type_hints["allow_expansion_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if allow_expansion is not None:
            self._values["allow_expansion"] = allow_expansion
        if allow_expansion_var is not None:
            self._values["allow_expansion_var"] = allow_expansion_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def allow_expansion(self) -> typing.Optional[builtins.str]:
        '''If cropping an area outside of the existing canvas, expands the image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        '''
        result = self._values.get("allow_expansion")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def allow_expansion_var(self) -> typing.Optional[builtins.str]:
        '''If cropping an area outside of the existing canvas, expands the image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        '''
        result = self._values.get("allow_expansion_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Frame of reference for X and Y Positions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Frame of reference for X and Y Positions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the y-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the y-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the x-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the x-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2784c4700fa9ea27906f9fe9f24fd6164c56a15af85f48aaece6ef4ee217eebe)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e6a243fb0b13202c3b429ed853177447a4a693077fd315ea21d0afb9e1a185fc)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b7c77963ad7d45475897aacd9766f0af05cdf17f8c5111475a4b74096a014e7e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__779cfc074245b7eee1f56951cc6cb2d94e4857ffcf653b34ffd0bbe4111d59ed)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__599931f79546019b46015fe99d083f4bac03824defd6bde071112005a1cd927a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8ecb1410e75619a855af605bda840f6483d691b72303b6dce38b5dd2253861c4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__76c378e46dd176e6c02e540af906d4e8148fc193e4d7b95f49936da84f261459)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAllowExpansion")
    def reset_allow_expansion(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansion", []))

    @jsii.member(jsii_name="resetAllowExpansionVar")
    def reset_allow_expansion_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansionVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionInput")
    def allow_expansion_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVarInput")
    def allow_expansion_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansion")
    def allow_expansion(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansion"))

    @allow_expansion.setter
    def allow_expansion(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ee81bf4e23794f66815e114e059ecddc81d5eda361ca96ae8135945d0beba4bd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansion", value)

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVar")
    def allow_expansion_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansionVar"))

    @allow_expansion_var.setter
    def allow_expansion_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c567baa83b39e7e6297f0a7fbcbcc8363f3e9b0920c2225e29899928efd2cd11)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansionVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fca8410b8a850905fbf5e783144ca1185e897d7c7001e604eb9e74ada6097d75)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4798b0552a4e63d39b813c5529a36584b754b82ed1b0cc5e7b021e6b9b01ec5a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__066ddec2e620c480e342bac2bd837e68582594f64c02cfd83f96925eb486b755)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ce01ddb5042776f6bc4e614f756c7d8a7109202a90cde3e1c763a30ae182a01)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__84dcbaf181b965a55a5629f1f0c3bb135e54d91eded6ed381d4e3399b134aec9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c2ad8af573bf95b5fcfe78474eb26c449d49bae4390710e8e6e2b38ee8e5563d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b2234e67ae4fe0869e6944dfb84c7b9c4d5f7373e1530b0a91fe128e6a0812e7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__574ae636ec797637c7ee7a8f42f0a2c3aca7d4f716d4523b9df0c81dbeecdb07)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__048bb49a36cd388f4aab747ebd17f0686173c3c05acc8f70f53d133b70f23352)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__67915ba03b70d86f99d8b4a49d67ce1f46f49d363db2a7af2efbba49ce89e803)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f26e79df265c54b07938fad92e413a8372a7327f9016d1930da64f9c887e489b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualFaceCrop",
    jsii_struct_bases=[],
    name_mapping={
        "algorithm": "algorithm",
        "algorithm_var": "algorithmVar",
        "confidence": "confidence",
        "confidence_var": "confidenceVar",
        "fail_gravity": "failGravity",
        "fail_gravity_var": "failGravityVar",
        "focus": "focus",
        "focus_var": "focusVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "padding": "padding",
        "padding_var": "paddingVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualFaceCrop:
    def __init__(
        self,
        *,
        algorithm: typing.Optional[builtins.str] = None,
        algorithm_var: typing.Optional[builtins.str] = None,
        confidence: typing.Optional[builtins.str] = None,
        confidence_var: typing.Optional[builtins.str] = None,
        fail_gravity: typing.Optional[builtins.str] = None,
        fail_gravity_var: typing.Optional[builtins.str] = None,
        focus: typing.Optional[builtins.str] = None,
        focus_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param algorithm: Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm DataAkamaiImagingPolicyImage#algorithm}
        :param algorithm_var: Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm_var DataAkamaiImagingPolicyImage#algorithm_var}
        :param confidence: With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image. Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence DataAkamaiImagingPolicyImage#confidence}
        :param confidence_var: With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image. Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence_var DataAkamaiImagingPolicyImage#confidence_var}
        :param fail_gravity: Controls placement of the crop if Image and Video Manager does not detect any faces in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        :param fail_gravity_var: Controls placement of the crop if Image and Video Manager does not detect any faces in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        :param focus: Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus DataAkamaiImagingPolicyImage#focus}
        :param focus_var: Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus_var DataAkamaiImagingPolicyImage#focus_var}
        :param gravity: Controls placement of the crop. Directions are relative to the face(s) plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Controls placement of the crop. Directions are relative to the face(s) plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param padding: The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        :param style: Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__718b1c34aa41be6fa40d691edeea5cf003a040b590d42e09dabb0646df5b1e24)
            check_type(argname="argument algorithm", value=algorithm, expected_type=type_hints["algorithm"])
            check_type(argname="argument algorithm_var", value=algorithm_var, expected_type=type_hints["algorithm_var"])
            check_type(argname="argument confidence", value=confidence, expected_type=type_hints["confidence"])
            check_type(argname="argument confidence_var", value=confidence_var, expected_type=type_hints["confidence_var"])
            check_type(argname="argument fail_gravity", value=fail_gravity, expected_type=type_hints["fail_gravity"])
            check_type(argname="argument fail_gravity_var", value=fail_gravity_var, expected_type=type_hints["fail_gravity_var"])
            check_type(argname="argument focus", value=focus, expected_type=type_hints["focus"])
            check_type(argname="argument focus_var", value=focus_var, expected_type=type_hints["focus_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if algorithm is not None:
            self._values["algorithm"] = algorithm
        if algorithm_var is not None:
            self._values["algorithm_var"] = algorithm_var
        if confidence is not None:
            self._values["confidence"] = confidence
        if confidence_var is not None:
            self._values["confidence_var"] = confidence_var
        if fail_gravity is not None:
            self._values["fail_gravity"] = fail_gravity
        if fail_gravity_var is not None:
            self._values["fail_gravity_var"] = fail_gravity_var
        if focus is not None:
            self._values["focus"] = focus
        if focus_var is not None:
            self._values["focus_var"] = focus_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def algorithm(self) -> typing.Optional[builtins.str]:
        '''Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm DataAkamaiImagingPolicyImage#algorithm}
        '''
        result = self._values.get("algorithm")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def algorithm_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm_var DataAkamaiImagingPolicyImage#algorithm_var}
        '''
        result = self._values.get("algorithm_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def confidence(self) -> typing.Optional[builtins.str]:
        '''With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image.

        Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence DataAkamaiImagingPolicyImage#confidence}
        '''
        result = self._values.get("confidence")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def confidence_var(self) -> typing.Optional[builtins.str]:
        '''With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image.

        Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence_var DataAkamaiImagingPolicyImage#confidence_var}
        '''
        result = self._values.get("confidence_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any faces in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        '''
        result = self._values.get("fail_gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any faces in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        '''
        result = self._values.get("fail_gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def focus(self) -> typing.Optional[builtins.str]:
        '''Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus DataAkamaiImagingPolicyImage#focus}
        '''
        result = self._values.get("focus")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def focus_var(self) -> typing.Optional[builtins.str]:
        '''Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus_var DataAkamaiImagingPolicyImage#focus_var}
        '''
        result = self._values.get("focus_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the face(s) plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the face(s) plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualFaceCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualFaceCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualFaceCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c4009bac51b0959da295c1f2866e26fd65e02d393e80f9598a7b188f039e474f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualFaceCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__14719f17b0cbc222d0a918487cecc765c138c3cdab544bbc0c5080ac94264ee9)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualFaceCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b1c2b25f30ef5f22567313faafb849063a39e517843a0e196c594a4d4c808241)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ad2244305d531af4173a132b16f1f7b2aee6b3fab47405dece7f502b87edc6ca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__008d88f32fc66c411d4651bdb925eddbcfdc111331708630b6736f4583307a10)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualFaceCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualFaceCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualFaceCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cfe1929fe7853dc72ba7dd26bdebbf3f1f2cff6a356b7331e703c0586e02ebe6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualFaceCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualFaceCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e757c922c2ee237005f874824944ca3a6ee5af114a1c78f9c57b1ab071019062)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAlgorithm")
    def reset_algorithm(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAlgorithm", []))

    @jsii.member(jsii_name="resetAlgorithmVar")
    def reset_algorithm_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAlgorithmVar", []))

    @jsii.member(jsii_name="resetConfidence")
    def reset_confidence(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetConfidence", []))

    @jsii.member(jsii_name="resetConfidenceVar")
    def reset_confidence_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetConfidenceVar", []))

    @jsii.member(jsii_name="resetFailGravity")
    def reset_fail_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravity", []))

    @jsii.member(jsii_name="resetFailGravityVar")
    def reset_fail_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravityVar", []))

    @jsii.member(jsii_name="resetFocus")
    def reset_focus(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFocus", []))

    @jsii.member(jsii_name="resetFocusVar")
    def reset_focus_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFocusVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="algorithmInput")
    def algorithm_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "algorithmInput"))

    @builtins.property
    @jsii.member(jsii_name="algorithmVarInput")
    def algorithm_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "algorithmVarInput"))

    @builtins.property
    @jsii.member(jsii_name="confidenceInput")
    def confidence_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "confidenceInput"))

    @builtins.property
    @jsii.member(jsii_name="confidenceVarInput")
    def confidence_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "confidenceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityInput")
    def fail_gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityVarInput")
    def fail_gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="focusInput")
    def focus_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "focusInput"))

    @builtins.property
    @jsii.member(jsii_name="focusVarInput")
    def focus_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "focusVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="algorithm")
    def algorithm(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "algorithm"))

    @algorithm.setter
    def algorithm(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__82db712a3d57bbf287c9729844dc2841d76e0a3ca05c696d1d60fdf2f13a1c27)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "algorithm", value)

    @builtins.property
    @jsii.member(jsii_name="algorithmVar")
    def algorithm_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "algorithmVar"))

    @algorithm_var.setter
    def algorithm_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b3c13e894e355c14cec814c2a636fe5cd8320083b0a5c4213c93985405d75462)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "algorithmVar", value)

    @builtins.property
    @jsii.member(jsii_name="confidence")
    def confidence(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "confidence"))

    @confidence.setter
    def confidence(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3868c5b6eb58a3b066b03d04f12804eae64c5d0a7de1cbf5760d815f4efe56aa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "confidence", value)

    @builtins.property
    @jsii.member(jsii_name="confidenceVar")
    def confidence_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "confidenceVar"))

    @confidence_var.setter
    def confidence_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__749f343bf239fdfe1911a309235c999377cadc0c390773b587333c0802d9fa63)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "confidenceVar", value)

    @builtins.property
    @jsii.member(jsii_name="failGravity")
    def fail_gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravity"))

    @fail_gravity.setter
    def fail_gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8594259c5c225398905f7887d9601408ed0a57881d2698b596bc5e87958e43cf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravity", value)

    @builtins.property
    @jsii.member(jsii_name="failGravityVar")
    def fail_gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravityVar"))

    @fail_gravity_var.setter
    def fail_gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ba3d52c5c128ad67838036483ed5159843d9de7d59865cb70c6bb063d40584a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="focus")
    def focus(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "focus"))

    @focus.setter
    def focus(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f0804985950537db2c5deb2476f7c20b517d876c198fa97500cae77e75382b3c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "focus", value)

    @builtins.property
    @jsii.member(jsii_name="focusVar")
    def focus_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "focusVar"))

    @focus_var.setter
    def focus_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__03f4af1ada08c2e2793d6ff872ad15854fccf75b079eb403acbaafa2758fa31c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "focusVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__046ca9ed640d1b30a196212d4b3ab7da2aad1100bd18ae875b2f96a8bd546669)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b6b402fb0336eee4b7f61bc5c9bccbc40afa42778813ebe3131bd257a15a4ab0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__26368b61edb59479c280034c5f9a1cd3cfbc15f2c88ad16879204f4313174906)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d9575013a2bb56951c3c727e9acba5918d296892b9a51ec38b1eae2572efa51)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6a97d53431c544091d4c13b226a4cfb0199bf7fdd7f206dbbf04248669d2c7d7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9f27eda746bac78f8d9e0d56cee4621c61fb4ab1789e0b4d69954238db6ad4ba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a3489d98f1cdee6568de9cc0af008af85dd97e29f0e213e402742282e55d28e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__59bfd69549f4344b3af3ce0b24824a2145af0b9d98fcf1ac7ab3b6b46d6d27a1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__54756692325eca60952519d406a80b081b3211f6b3e344e002d48ea0a09b083d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0a60a4e1997f63aea4faa4a3a40a0b6e02eddb0677b519368814376e4be070b3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualFaceCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualFaceCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualFaceCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d0abb3cf69d119ea5f9da2bfefe3d0c87b2fff409b1446299ffb04268e87289a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualFeatureCrop",
    jsii_struct_bases=[],
    name_mapping={
        "fail_gravity": "failGravity",
        "fail_gravity_var": "failGravityVar",
        "feature_radius": "featureRadius",
        "feature_radius_var": "featureRadiusVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "max_features": "maxFeatures",
        "max_features_var": "maxFeaturesVar",
        "min_feature_quality": "minFeatureQuality",
        "min_feature_quality_var": "minFeatureQualityVar",
        "padding": "padding",
        "padding_var": "paddingVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualFeatureCrop:
    def __init__(
        self,
        *,
        fail_gravity: typing.Optional[builtins.str] = None,
        fail_gravity_var: typing.Optional[builtins.str] = None,
        feature_radius: typing.Optional[builtins.str] = None,
        feature_radius_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        max_features: typing.Optional[builtins.str] = None,
        max_features_var: typing.Optional[builtins.str] = None,
        min_feature_quality: typing.Optional[builtins.str] = None,
        min_feature_quality_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fail_gravity: Controls placement of the crop if Image and Video Manager does not detect any features in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        :param fail_gravity_var: Controls placement of the crop if Image and Video Manager does not detect any features in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        :param feature_radius: The size in pixels of the important features to search for. If identified, two features never appear closer together than this value, ``8.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius DataAkamaiImagingPolicyImage#feature_radius}
        :param feature_radius_var: The size in pixels of the important features to search for. If identified, two features never appear closer together than this value, ``8.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius_var DataAkamaiImagingPolicyImage#feature_radius_var}
        :param gravity: Controls placement of the crop. Directions are relative to the region of interest plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Controls placement of the crop. Directions are relative to the region of interest plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param max_features: The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features DataAkamaiImagingPolicyImage#max_features}
        :param max_features_var: The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features_var DataAkamaiImagingPolicyImage#max_features_var}
        :param min_feature_quality: Determines the minimum quality level of the feature identified. To consider a feature important, the feature needs to surpass this value. Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality DataAkamaiImagingPolicyImage#min_feature_quality}
        :param min_feature_quality_var: Determines the minimum quality level of the feature identified. To consider a feature important, the feature needs to surpass this value. Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality_var DataAkamaiImagingPolicyImage#min_feature_quality_var}
        :param padding: Adds space around the region of interest. The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: Adds space around the region of interest. The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        :param style: Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__60015f9b265b006697e641107fac82ff485ce4b0f1d87027ea0ccbaa5135e315)
            check_type(argname="argument fail_gravity", value=fail_gravity, expected_type=type_hints["fail_gravity"])
            check_type(argname="argument fail_gravity_var", value=fail_gravity_var, expected_type=type_hints["fail_gravity_var"])
            check_type(argname="argument feature_radius", value=feature_radius, expected_type=type_hints["feature_radius"])
            check_type(argname="argument feature_radius_var", value=feature_radius_var, expected_type=type_hints["feature_radius_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument max_features", value=max_features, expected_type=type_hints["max_features"])
            check_type(argname="argument max_features_var", value=max_features_var, expected_type=type_hints["max_features_var"])
            check_type(argname="argument min_feature_quality", value=min_feature_quality, expected_type=type_hints["min_feature_quality"])
            check_type(argname="argument min_feature_quality_var", value=min_feature_quality_var, expected_type=type_hints["min_feature_quality_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fail_gravity is not None:
            self._values["fail_gravity"] = fail_gravity
        if fail_gravity_var is not None:
            self._values["fail_gravity_var"] = fail_gravity_var
        if feature_radius is not None:
            self._values["feature_radius"] = feature_radius
        if feature_radius_var is not None:
            self._values["feature_radius_var"] = feature_radius_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if max_features is not None:
            self._values["max_features"] = max_features
        if max_features_var is not None:
            self._values["max_features_var"] = max_features_var
        if min_feature_quality is not None:
            self._values["min_feature_quality"] = min_feature_quality
        if min_feature_quality_var is not None:
            self._values["min_feature_quality_var"] = min_feature_quality_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def fail_gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any features in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        '''
        result = self._values.get("fail_gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any features in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        '''
        result = self._values.get("fail_gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feature_radius(self) -> typing.Optional[builtins.str]:
        '''The size in pixels of the important features to search for.

        If identified, two features never appear closer together than this value, ``8.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius DataAkamaiImagingPolicyImage#feature_radius}
        '''
        result = self._values.get("feature_radius")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feature_radius_var(self) -> typing.Optional[builtins.str]:
        '''The size in pixels of the important features to search for.

        If identified, two features never appear closer together than this value, ``8.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius_var DataAkamaiImagingPolicyImage#feature_radius_var}
        '''
        result = self._values.get("feature_radius_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the region of interest plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the region of interest plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def max_features(self) -> typing.Optional[builtins.str]:
        '''The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features DataAkamaiImagingPolicyImage#max_features}
        '''
        result = self._values.get("max_features")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def max_features_var(self) -> typing.Optional[builtins.str]:
        '''The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features_var DataAkamaiImagingPolicyImage#max_features_var}
        '''
        result = self._values.get("max_features_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def min_feature_quality(self) -> typing.Optional[builtins.str]:
        '''Determines the minimum quality level of the feature identified.

        To consider a feature important, the feature needs to surpass this value.  Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality DataAkamaiImagingPolicyImage#min_feature_quality}
        '''
        result = self._values.get("min_feature_quality")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def min_feature_quality_var(self) -> typing.Optional[builtins.str]:
        '''Determines the minimum quality level of the feature identified.

        To consider a feature important, the feature needs to surpass this value.  Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality_var DataAkamaiImagingPolicyImage#min_feature_quality_var}
        '''
        result = self._values.get("min_feature_quality_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''Adds space around the region of interest.

        The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''Adds space around the region of interest.

        The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualFeatureCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualFeatureCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualFeatureCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2fdf0d18a5d96fa33f69974a845fd358a03ad570072c20686be3a6528b117885)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualFeatureCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0e2cd022c8b8c7177fe3a3997247468798631eaf1c9d1f76f237538b2f3400f2)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualFeatureCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__71799c34e7e3b3517133e2189549c9be05c25def14ad0ddf72938fc65dd48f22)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f6ff648afd583114549461b052d7f8793cfc094ae75dd0c68cea3bc8485ca2d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0c668f4bd536693116ae7bfab92514c8fe1b6793fa9b0e6ccaa993eb58d5fcec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualFeatureCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualFeatureCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualFeatureCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__72b8c7392a7a9bf5f7dcdb84fca093f2bdbc5d2063a90bf89ef490236515e663)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualFeatureCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualFeatureCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__98065c9c1527a080f2131e8547f824ead5b74bf6437489348268384d3da86e7e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetFailGravity")
    def reset_fail_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravity", []))

    @jsii.member(jsii_name="resetFailGravityVar")
    def reset_fail_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravityVar", []))

    @jsii.member(jsii_name="resetFeatureRadius")
    def reset_feature_radius(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureRadius", []))

    @jsii.member(jsii_name="resetFeatureRadiusVar")
    def reset_feature_radius_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureRadiusVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetMaxFeatures")
    def reset_max_features(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxFeatures", []))

    @jsii.member(jsii_name="resetMaxFeaturesVar")
    def reset_max_features_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxFeaturesVar", []))

    @jsii.member(jsii_name="resetMinFeatureQuality")
    def reset_min_feature_quality(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMinFeatureQuality", []))

    @jsii.member(jsii_name="resetMinFeatureQualityVar")
    def reset_min_feature_quality_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMinFeatureQualityVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="failGravityInput")
    def fail_gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityVarInput")
    def fail_gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featureRadiusInput")
    def feature_radius_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featureRadiusInput"))

    @builtins.property
    @jsii.member(jsii_name="featureRadiusVarInput")
    def feature_radius_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featureRadiusVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesInput")
    def max_features_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "maxFeaturesInput"))

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesVarInput")
    def max_features_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "maxFeaturesVarInput"))

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityInput")
    def min_feature_quality_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "minFeatureQualityInput"))

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityVarInput")
    def min_feature_quality_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "minFeatureQualityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravity")
    def fail_gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravity"))

    @fail_gravity.setter
    def fail_gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__622896cb6496f9f0879d3a3241e171184e17044d5d0770057d6f0e038cecd268)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravity", value)

    @builtins.property
    @jsii.member(jsii_name="failGravityVar")
    def fail_gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravityVar"))

    @fail_gravity_var.setter
    def fail_gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8c05d2525757afd35b9a61e0d3cb0c24326ef35f2a3a2510b74ba1425a23194a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="featureRadius")
    def feature_radius(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featureRadius"))

    @feature_radius.setter
    def feature_radius(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7db0e78a694a4eb6afab74a143fc47a20a2d3c12266f76af47c9aa3dccc28b9b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featureRadius", value)

    @builtins.property
    @jsii.member(jsii_name="featureRadiusVar")
    def feature_radius_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featureRadiusVar"))

    @feature_radius_var.setter
    def feature_radius_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7badd843b09af70988ce282738d9162b1320de0582601c28658bb2046446ef5c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featureRadiusVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e77cae3725d9266ea73e488b52d6cf5440dd279fd9a2a739ab269936b9fcd0a5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea92a8b9fa7b7eef393094575d8be413edfa632f8b26ea8594dbb1f660571bc6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b3265372ffd3622460d9bce8b155008b29f3d6b5d8947842fbe153befac17a75)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__499c3b95cfa1a5f50170602336ce43960dddc236b2947b646edc45c740a5efdf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="maxFeatures")
    def max_features(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "maxFeatures"))

    @max_features.setter
    def max_features(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__faf0e271b8b52cb37b012129ad0278594fd30be355cd7c362da96f206cc13a00)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "maxFeatures", value)

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesVar")
    def max_features_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "maxFeaturesVar"))

    @max_features_var.setter
    def max_features_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__367607ca55668c0165a83be7df98b357be1dd8a82557af3a51be77a7293ec94f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "maxFeaturesVar", value)

    @builtins.property
    @jsii.member(jsii_name="minFeatureQuality")
    def min_feature_quality(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "minFeatureQuality"))

    @min_feature_quality.setter
    def min_feature_quality(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7fd2ac1bde92a8fa4222140111cc4ae66d629e53b169469fafc90866b2479089)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "minFeatureQuality", value)

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityVar")
    def min_feature_quality_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "minFeatureQualityVar"))

    @min_feature_quality_var.setter
    def min_feature_quality_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a9d3c0e9aed74fb8e90f9ba9c9760cddc17ec7f54e626d56ec63bf1a8328e05)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "minFeatureQualityVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__efa74925755da8cdb1f5c830711e14abe0eeaa56a7feb0c204282128b9b1600b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e47449137f4a44e1cb7352c1d5441a6650eea7307607c723415dc77f0afcf9d3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__db336c4cb82d2b43927896bcf292f569b057612e377cff67b0afb4566287cddd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6c16938c841e07130be81d221d82cbdf7c9560a382d1717fcb5e6c5f329d42be)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__582469815020e0d7d8a89f734a32b91d9d4e370aea0681ff8eec6dde2a40a998)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e9b6e7add5bc1dc672207dd67974c6dc5966b3821e8eb82f688e0987c8fc9bf7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualFeatureCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualFeatureCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualFeatureCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a8c6e896a0387cdc0a40c9807d6da93facd3f6b2eb4f1fc2e9e55145073d2208)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualFitAndFill",
    jsii_struct_bases=[],
    name_mapping={
        "fill_transformation": "fillTransformation",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualFitAndFill:
    def __init__(
        self,
        *,
        fill_transformation: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualFitAndFillFillTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fill_transformation: fill_transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_transformation DataAkamaiImagingPolicyImage#fill_transformation}
        :param height: The height value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The width value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(fill_transformation, dict):
            fill_transformation = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualFitAndFillFillTransformation(**fill_transformation)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__955a38fd1f405a2c7254ccb26cd9cc09aaaeea3fa583e9c8a7a5d435c0f794a9)
            check_type(argname="argument fill_transformation", value=fill_transformation, expected_type=type_hints["fill_transformation"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fill_transformation is not None:
            self._values["fill_transformation"] = fill_transformation
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def fill_transformation(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualFitAndFillFillTransformation"]:
        '''fill_transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_transformation DataAkamaiImagingPolicyImage#fill_transformation}
        '''
        result = self._values.get("fill_transformation")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualFitAndFillFillTransformation"], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualFitAndFill(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualFitAndFillFillTransformation",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualFitAndFillFillTransformation:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualFitAndFillFillTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualFitAndFillFillTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualFitAndFillFillTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f81266f0f9e14b36293ece4f5755228d1fba9620009281b6f152a39f00dfd276)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualFitAndFillFillTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualFitAndFillFillTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualFitAndFillFillTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__659471c25a622dc2ddb7def8e02c962761874e759222c4d911b0cb43f9c32b08)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualFitAndFillList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualFitAndFillList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__455241ff20bd48ad764c3ebab056ae0e6cff4d14cefdb02f2094c6bbfe282b7d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualFitAndFillOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__06537be3bf678cc96e0bb6c73415d6d24f75349241711033773bcc9f6aac8f84)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualFitAndFillOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d0f9d25b8e0d1b60e683f16ab79419a925228ecfe7e8e371c2772bb6bfca53ed)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ac59e24a829321c4e7e458d7d1f46a316cf18fbfdd1e863163e0e8b914c120f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ed409baa9c4a25fb4e11ed0613c529b3b6af58c27a68d8c148c92f8a75be2549)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualFitAndFill]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualFitAndFill]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualFitAndFill]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc66bb4b2eba692862d2ec549e42441f1c64e5ff629e7bdfb85dcf010644d641)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualFitAndFillOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualFitAndFillOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__925f8be703def33dfc269664d7d07b44a87eb91ba25bb269e24695a5d9d0a8ce)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putFillTransformation")
    def put_fill_transformation(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualFitAndFillFillTransformation()

        return typing.cast(None, jsii.invoke(self, "putFillTransformation", [value]))

    @jsii.member(jsii_name="resetFillTransformation")
    def reset_fill_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFillTransformation", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="fillTransformation")
    def fill_transformation(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualFitAndFillFillTransformationOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualFitAndFillFillTransformationOutputReference, jsii.get(self, "fillTransformation"))

    @builtins.property
    @jsii.member(jsii_name="fillTransformationInput")
    def fill_transformation_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualFitAndFillFillTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualFitAndFillFillTransformation], jsii.get(self, "fillTransformationInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2879d85a2663e3e7a5810768cb31ef93a89c435d3b3ba7fee738245f41162321)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7fce499340dfaf16749891db53f86662d832c117f69caf0c074ca3dfa0d4124d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a2e3c084d8c86f3d6206ebd5603e02366b8d16ee1ad624e24370bc4386f20f2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e5b873ae3d7352e04bcad8d11bb67b235c7c157a3ce8428832e8906510d30023)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualFitAndFill]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualFitAndFill]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualFitAndFill]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d4184579eb90f4c6c8fb2757a29299a8a8aade0aec08dc46a5920e2af213540b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualGoop",
    jsii_struct_bases=[],
    name_mapping={
        "chaos": "chaos",
        "chaos_var": "chaosVar",
        "density": "density",
        "density_var": "densityVar",
        "power": "power",
        "power_var": "powerVar",
        "seed": "seed",
        "seed_var": "seedVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualGoop:
    def __init__(
        self,
        *,
        chaos: typing.Optional[builtins.str] = None,
        chaos_var: typing.Optional[builtins.str] = None,
        density: typing.Optional[builtins.str] = None,
        density_var: typing.Optional[builtins.str] = None,
        power: typing.Optional[builtins.str] = None,
        power_var: typing.Optional[builtins.str] = None,
        seed: typing.Optional[builtins.str] = None,
        seed_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param chaos: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        :param chaos_var: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        :param density: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        :param density_var: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        :param power: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        :param power_var: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        :param seed: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        :param seed_var: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e9a4a92139b1f06cd591a7da9e1b2de65144edfe1db5cd5b766d2fe5b8a91152)
            check_type(argname="argument chaos", value=chaos, expected_type=type_hints["chaos"])
            check_type(argname="argument chaos_var", value=chaos_var, expected_type=type_hints["chaos_var"])
            check_type(argname="argument density", value=density, expected_type=type_hints["density"])
            check_type(argname="argument density_var", value=density_var, expected_type=type_hints["density_var"])
            check_type(argname="argument power", value=power, expected_type=type_hints["power"])
            check_type(argname="argument power_var", value=power_var, expected_type=type_hints["power_var"])
            check_type(argname="argument seed", value=seed, expected_type=type_hints["seed"])
            check_type(argname="argument seed_var", value=seed_var, expected_type=type_hints["seed_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if chaos is not None:
            self._values["chaos"] = chaos
        if chaos_var is not None:
            self._values["chaos_var"] = chaos_var
        if density is not None:
            self._values["density"] = density
        if density_var is not None:
            self._values["density_var"] = density_var
        if power is not None:
            self._values["power"] = power
        if power_var is not None:
            self._values["power_var"] = power_var
        if seed is not None:
            self._values["seed"] = seed
        if seed_var is not None:
            self._values["seed_var"] = seed_var

    @builtins.property
    def chaos(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        '''
        result = self._values.get("chaos")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def chaos_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        '''
        result = self._values.get("chaos_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        '''
        result = self._values.get("density")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density_var(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        '''
        result = self._values.get("density_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        '''
        result = self._values.get("power")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power_var(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        '''
        result = self._values.get("power_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        '''
        result = self._values.get("seed")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed_var(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        result = self._values.get("seed_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualGoop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualGoopList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualGoopList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bfdbbdb3c572bd55d344216cf51e80fbd8848b77976c57b222741b27df97325b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualGoopOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2bea1b4b9876074c00b05b09f8464d818299e31f221e8668371583e26d2fd007)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualGoopOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f3e17aed746d9b7cefa0043371051394e42aba7d9610f0a620d173c6ef3334c4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b3c3677deda7e173034a2a64d466cf05a1b1473316f898aa941646cb17fe1e44)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__83cf192b1ddb9857b7f5d3594918595fd644ee8c695e4cae5a44300255335205)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualGoop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualGoop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8171def5334ad8aaf3871599ec968ec83e3d3441c75365771f565e7d04ea10f9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualGoopOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualGoopOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3e4e94c46d79d6b785684d67ae11b1221b25dc81bd89c0a634b1b44ce021c140)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetChaos")
    def reset_chaos(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaos", []))

    @jsii.member(jsii_name="resetChaosVar")
    def reset_chaos_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaosVar", []))

    @jsii.member(jsii_name="resetDensity")
    def reset_density(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensity", []))

    @jsii.member(jsii_name="resetDensityVar")
    def reset_density_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensityVar", []))

    @jsii.member(jsii_name="resetPower")
    def reset_power(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPower", []))

    @jsii.member(jsii_name="resetPowerVar")
    def reset_power_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPowerVar", []))

    @jsii.member(jsii_name="resetSeed")
    def reset_seed(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeed", []))

    @jsii.member(jsii_name="resetSeedVar")
    def reset_seed_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeedVar", []))

    @builtins.property
    @jsii.member(jsii_name="chaosInput")
    def chaos_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosInput"))

    @builtins.property
    @jsii.member(jsii_name="chaosVarInput")
    def chaos_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosVarInput"))

    @builtins.property
    @jsii.member(jsii_name="densityInput")
    def density_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityInput"))

    @builtins.property
    @jsii.member(jsii_name="densityVarInput")
    def density_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="powerInput")
    def power_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerInput"))

    @builtins.property
    @jsii.member(jsii_name="powerVarInput")
    def power_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerVarInput"))

    @builtins.property
    @jsii.member(jsii_name="seedInput")
    def seed_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedInput"))

    @builtins.property
    @jsii.member(jsii_name="seedVarInput")
    def seed_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedVarInput"))

    @builtins.property
    @jsii.member(jsii_name="chaos")
    def chaos(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaos"))

    @chaos.setter
    def chaos(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__288f09930d486d30c847b29e5ab4516b86d5a303d3ac94022cfdb0f91d249634)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaos", value)

    @builtins.property
    @jsii.member(jsii_name="chaosVar")
    def chaos_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaosVar"))

    @chaos_var.setter
    def chaos_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7b5fa865e62a0f8059d7b633a9a62d2adbe89de779945e2464477d212bac8265)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaosVar", value)

    @builtins.property
    @jsii.member(jsii_name="density")
    def density(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "density"))

    @density.setter
    def density(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6a7da2b87df9c4edd65f73656d8d08806146db4f5e056ae61e3b28bbe4bd2b08)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "density", value)

    @builtins.property
    @jsii.member(jsii_name="densityVar")
    def density_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "densityVar"))

    @density_var.setter
    def density_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fc858d5415ead4aeba0de2ac7e74e8994116c0316bf3484fc53f63ae8a2f1c96)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "densityVar", value)

    @builtins.property
    @jsii.member(jsii_name="power")
    def power(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "power"))

    @power.setter
    def power(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0b6572023794cb996625f0f8b5d589d7fb1399d44d01f2338e4a84691f9d326a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "power", value)

    @builtins.property
    @jsii.member(jsii_name="powerVar")
    def power_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "powerVar"))

    @power_var.setter
    def power_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e537e3d66f8c9105fe272c18b512bdf3f2ea4b0c408353d997c3d5f85fede127)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "powerVar", value)

    @builtins.property
    @jsii.member(jsii_name="seed")
    def seed(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seed"))

    @seed.setter
    def seed(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__baf2bc80c132262d21c0f96d5e9629e8259f4aebc614137360cdf043353f4675)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seed", value)

    @builtins.property
    @jsii.member(jsii_name="seedVar")
    def seed_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seedVar"))

    @seed_var.setter
    def seed_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__db70135f12a3ab5babd48d58b072f9d17fe5fa6ce3ef5ea7f21f959427bf0532)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seedVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualGoop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualGoop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualGoop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a4d6b5d2e550cee1b1377b21c6309f575d5f901ff3db3f57d5fdf2c69ee085bc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualGrayscale",
    jsii_struct_bases=[],
    name_mapping={"type": "type", "type_var": "typeVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualGrayscale:
    def __init__(
        self,
        *,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param type: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a42c5d0ea4fa6cddcd6d149ffcd0f09e9717f81173b8c3ff03bac608d281264c)
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualGrayscale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualGrayscaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualGrayscaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__49afd11ad5fa0d4bbc43bd0042d26584eb29066b9bdc1b88878131911d6868ff)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualGrayscaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__45fcbb31957d1782c8b58496c0c8a641ef9c151a09640a864c4c5132a0cd30d6)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualGrayscaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ebcb491d36ad6143c4273424f530d1aac41bc8924ba7650c52ae6c344181676d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__227b5c7bdccfb75192b248b92076faa7b9d2409dcddaa1fd4eb2fecf4537ae2a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__90f256ac6bc6da12481efe8b6df68800698dca1e2322256568504cfa327709f9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualGrayscale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualGrayscale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__42be188cb8d9c8684cd4be24eb839f125e9708d46d6c65a2812304136866902f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualGrayscaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualGrayscaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ee8ce7de654b86860dddd004cfeed93f58d21f33bf4ba230ff51ca21f5fe6cf)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__acee4bf545589552e8ae27071cee6bf7ef56855cedf2045f2155ff5efb102809)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__48bdafdc6babf9a7a2999c89082ba2c9f3f85f4772dea918a921738c2957d34e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualGrayscale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualGrayscale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualGrayscale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1e87fb8b4bf0b43e2f6f1d2354eaf35525ac430046937a98834779a71f3868db)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualHsl",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "lightness": "lightness",
        "lightness_var": "lightnessVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualHsl:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness: typing.Optional[builtins.str] = None,
        lightness_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        :param lightness_var: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b07247e5fe8bed72ed97d95be46361472605636472b147d9c26bf2a22a17d548)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness", value=lightness, expected_type=type_hints["lightness"])
            check_type(argname="argument lightness_var", value=lightness_var, expected_type=type_hints["lightness_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness is not None:
            self._values["lightness"] = lightness
        if lightness_var is not None:
            self._values["lightness_var"] = lightness_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        '''
        result = self._values.get("lightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        '''
        result = self._values.get("lightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualHsl(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualHslList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualHslList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__173d4d9d593995f9d2f8e23d39d8955894bb3b90236b68057ea365f6b3a3ff0a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualHslOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0abb80bbae75da1770e82c757790a19550f164aca83f9132fc40810e2a5251aa)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualHslOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d9d617027ae08b3d4f62c229d400952c5125735cf823f5e0cb38582a4c0af463)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d5e6288cd3c2fee57b4fe249f689e4098ca9b632438e62f705a5f2e3b5edb722)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__791e065c202b15bff3d4c4c979f2d63f8805391ad8163be30103ac297139c51f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualHsl]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualHsl]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be5da0c7faad54481704e64d75fae2cb733705c69ce4fe7b925956deb93b4c41)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualHslOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualHslOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b2b54cff537a2239e8998f0c367e5630561a1e5eaa509eb739cba4a59b41072a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightness")
    def reset_lightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightness", []))

    @jsii.member(jsii_name="resetLightnessVar")
    def reset_lightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessInput")
    def lightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessVarInput")
    def lightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__adc728f48cae0969945ab4687d96dc03f1f5b8bcf24db99f340a471d9d492d2b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a00d23cfe69317def683f6700c384a25b26a891b94dee332a9f56333b00b68e4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightness")
    def lightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightness"))

    @lightness.setter
    def lightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c79d1efa2158a4a87fc5a3491d466a9e17a3fc77ada40d5c691c93cc3a2949fe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightness", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessVar")
    def lightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessVar"))

    @lightness_var.setter
    def lightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ede4584cb43eeb7ce6de7949b07c63dc9ffbb18f30382c00b15ed9a8b05fa955)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__43729ad5d32576ab21ffd43d6c00571d51a2d961bf149f8e2a95163d2b81766f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ae19440865ac8f3f8540612397e61b709fc7ae358b5e51cdffbff0016d2833b6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualHsl]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualHsl]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualHsl]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4dc8cf68bb28fa56224161ac694d66a39636bb79373e6795ecc591badb3dcb80)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualHsv",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualHsv:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        :param value: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__243a2933f84eda951d6c2c9a43c97e9410f39fdd481bee60aec155bcba77ea26)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualHsv(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualHsvList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualHsvList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__865d1186995577f9ac20d6cdf69624451a1ab655e766e75daf3d821fd174fd9a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualHsvOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ca2c495ca75f967eee77f69dad3972ef47ddcae5a8c7494bd4a9d8634838981b)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualHsvOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a085e59b14f7d4551cbf8f10b34413274a13989517d006fdedbc4c82dd3d73c9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1e1060c0c370b7a803bfee6e85e024c38b3056eef682e0f1fc73662ecc07780e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__58a03f11572474c917bed040bc9cbf9cac72bf2863a30d677dabd1ef698b269f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualHsv]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualHsv]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__641e6ed272c682a927f2abe3228c84d46cdfd12b47cccc3553510a2e5d2b193e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualHsvOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualHsvOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2c642709e8914600825e889ff735bcec56924ca0673d407800f97ae9f666c766)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ca7a4727422f26f4a6b4b3531f486965458ef5734a9d7622fac98cce979d51d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6d86b414ccf669dbffa2f75060cf6f72540df01ecf1b9575215dbb10af2ce17d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__32a578b69ef38557c29bc600a9ae98842132a9c31e2889ff634e912612b4f098)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a0e00072c48f6deb1127060a20b1e3970c0bc4e9e8c9e794bbbf026fa17378b0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b457868f25128dd337a15b31cebcd64b2176d6f4a1943b181e7f01bf35ff9bb6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0623548f77c71ec1b0c0a2d66651659ac48392441dcd2ed61d00467bc97643a2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualHsv]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualHsv]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualHsv]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d00052b0aeb94229986419949f29f9dcf6bad4abcd13f7acbe921238fcaf928d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfDimension",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "dimension": "dimension",
        "dimension_var": "dimensionVar",
        "equal": "equal",
        "greater_than": "greaterThan",
        "less_than": "lessThan",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfDimension:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        dimension: typing.Optional[builtins.str] = None,
        dimension_var: typing.Optional[builtins.str] = None,
        equal: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionEqual", typing.Dict[builtins.str, typing.Any]]] = None,
        greater_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionGreaterThan", typing.Dict[builtins.str, typing.Any]]] = None,
        less_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionLessThan", typing.Dict[builtins.str, typing.Any]]] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param dimension: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        :param dimension_var: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        :param equal: equal block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        :param greater_than: greater_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        :param less_than: less_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        :param value: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionDefault(**default)
        if isinstance(equal, dict):
            equal = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionEqual(**equal)
        if isinstance(greater_than, dict):
            greater_than = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionGreaterThan(**greater_than)
        if isinstance(less_than, dict):
            less_than = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionLessThan(**less_than)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__05aee40beb963aa36a7fce50dbc9b11f477fd1740f9d40578623e306f67504e9)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument dimension", value=dimension, expected_type=type_hints["dimension"])
            check_type(argname="argument dimension_var", value=dimension_var, expected_type=type_hints["dimension_var"])
            check_type(argname="argument equal", value=equal, expected_type=type_hints["equal"])
            check_type(argname="argument greater_than", value=greater_than, expected_type=type_hints["greater_than"])
            check_type(argname="argument less_than", value=less_than, expected_type=type_hints["less_than"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if dimension is not None:
            self._values["dimension"] = dimension
        if dimension_var is not None:
            self._values["dimension_var"] = dimension_var
        if equal is not None:
            self._values["equal"] = equal
        if greater_than is not None:
            self._values["greater_than"] = greater_than
        if less_than is not None:
            self._values["less_than"] = less_than
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionDefault"], result)

    @builtins.property
    def dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        '''
        result = self._values.get("dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        '''
        result = self._values.get("dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def equal(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionEqual"]:
        '''equal block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        '''
        result = self._values.get("equal")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionEqual"], result)

    @builtins.property
    def greater_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionGreaterThan"]:
        '''greater_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        '''
        result = self._values.get("greater_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionGreaterThan"], result)

    @builtins.property
    def less_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionLessThan"]:
        '''less_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        '''
        result = self._values.get("less_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionLessThan"], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfDimension(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8d347df2afe2c641bce4416f85de3c31c06d429dbcd33d0b5bb15ecb9374ab9a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__30b75439ae855a000a5a8af0444f9ef43cc2180786e2eb9670e5b0b6d76bdeea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionEqual",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionEqual:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionEqual(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionEqualOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionEqualOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fe28d89323105995aa57e3b17aa85f707df709a5c1009a53a274db0fdffa2781)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionEqual], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionEqual],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d162b8f0d270906a23d7643008b6c299c411158146bfb19a2c0c76072e241d2a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionGreaterThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionGreaterThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionGreaterThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionGreaterThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionGreaterThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__379cad54da513eca9631821fc511f105274389ca33c906607ce16469a0cbf08a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionGreaterThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionGreaterThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ae3048703952c3fa19778ac47cc8bdbdcc8417a2dc7dfd2769fa91d025964be)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionLessThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionLessThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionLessThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionLessThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionLessThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__57ec839ebd16016bb775730472cfe97c3b8cb0d7749c6779e32d8827a6c51564)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionLessThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionLessThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__81ed0c3a4983c15d5f0e423c772bcae79ed0cffce6d9b385c33fd9a6d0e98f5b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0c36323ef91054378b826be3eb80cab6e522257d392471980fc12a21950eaed9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__356f5b9707d9173fa2344fefb24b55594ffc41939961a8da499d743491dda80a)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f59d079e7a760a8fb10fb6e70d72ed8e2e7a8424b84a49e4198c76fd0a7ab08d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1e3a8a6964ce9e7d78d9d184450e5fbca33c3fbefdf0809211022f9f85ccad8e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__84338282934f8d43d15d2f63f9424659d7edb411ffcf75d81537b07b10e065ac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfDimension]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfDimension]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dbc5daf49535c2202fb75971a85a1ae90184b4d345d1a027cac0483df03d5a80)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__44f634c09f0723fa65d0a7f350b9e91b56e086b66f84c7c4ce339b046b11be62)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putEqual")
    def put_equal(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionEqual()

        return typing.cast(None, jsii.invoke(self, "putEqual", [value]))

    @jsii.member(jsii_name="putGreaterThan")
    def put_greater_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionGreaterThan()

        return typing.cast(None, jsii.invoke(self, "putGreaterThan", [value]))

    @jsii.member(jsii_name="putLessThan")
    def put_less_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionLessThan()

        return typing.cast(None, jsii.invoke(self, "putLessThan", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetDimension")
    def reset_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimension", []))

    @jsii.member(jsii_name="resetDimensionVar")
    def reset_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimensionVar", []))

    @jsii.member(jsii_name="resetEqual")
    def reset_equal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEqual", []))

    @jsii.member(jsii_name="resetGreaterThan")
    def reset_greater_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGreaterThan", []))

    @jsii.member(jsii_name="resetLessThan")
    def reset_less_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLessThan", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="equal")
    def equal(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionEqualOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionEqualOutputReference, jsii.get(self, "equal"))

    @builtins.property
    @jsii.member(jsii_name="greaterThan")
    def greater_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionGreaterThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionGreaterThanOutputReference, jsii.get(self, "greaterThan"))

    @builtins.property
    @jsii.member(jsii_name="lessThan")
    def less_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionLessThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionLessThanOutputReference, jsii.get(self, "lessThan"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionInput")
    def dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionVarInput")
    def dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="equalInput")
    def equal_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionEqual], jsii.get(self, "equalInput"))

    @builtins.property
    @jsii.member(jsii_name="greaterThanInput")
    def greater_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionGreaterThan], jsii.get(self, "greaterThanInput"))

    @builtins.property
    @jsii.member(jsii_name="lessThanInput")
    def less_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionLessThan], jsii.get(self, "lessThanInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="dimension")
    def dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimension"))

    @dimension.setter
    def dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6c12768a2517d98d074b7604b71fdae3053f9c1f994f3489f4ea52c7d46d1296)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimension", value)

    @builtins.property
    @jsii.member(jsii_name="dimensionVar")
    def dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimensionVar"))

    @dimension_var.setter
    def dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__82d590bc213debe85ae5635878b4d720215e6ad5b0929770d98d2d2b2925dfc2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__43591c0c511e2880eae0d2925f2d5c37cb69367d94e98f1e8fd41c8c7f2823c7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__000967f3cb7f616c4c7492f3519eb543751cba796c2149047079d128169cdf5f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfDimension]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfDimension]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfDimension]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2991e7a051cf01cb13335f4ae82ba0c0d52f7c08dcb8c90b9617d6f5fe055ed1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfOrientation",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "landscape": "landscape",
        "portrait": "portrait",
        "square": "square",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfOrientation:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        landscape: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationLandscape", typing.Dict[builtins.str, typing.Any]]] = None,
        portrait: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationPortrait", typing.Dict[builtins.str, typing.Any]]] = None,
        square: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationSquare", typing.Dict[builtins.str, typing.Any]]] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param landscape: landscape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        :param portrait: portrait block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        :param square: square block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationDefault(**default)
        if isinstance(landscape, dict):
            landscape = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationLandscape(**landscape)
        if isinstance(portrait, dict):
            portrait = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationPortrait(**portrait)
        if isinstance(square, dict):
            square = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationSquare(**square)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4035cd8a3e350fa76482ad7760817d27e6cd9aa4cfbc11d9bf34c8f669f63996)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument landscape", value=landscape, expected_type=type_hints["landscape"])
            check_type(argname="argument portrait", value=portrait, expected_type=type_hints["portrait"])
            check_type(argname="argument square", value=square, expected_type=type_hints["square"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if landscape is not None:
            self._values["landscape"] = landscape
        if portrait is not None:
            self._values["portrait"] = portrait
        if square is not None:
            self._values["square"] = square

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationDefault"], result)

    @builtins.property
    def landscape(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationLandscape"]:
        '''landscape block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        '''
        result = self._values.get("landscape")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationLandscape"], result)

    @builtins.property
    def portrait(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationPortrait"]:
        '''portrait block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        '''
        result = self._values.get("portrait")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationPortrait"], result)

    @builtins.property
    def square(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationSquare"]:
        '''square block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        result = self._values.get("square")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationSquare"], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfOrientation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ccd06074a504877c1d1228bd08988583952a98e2dd054aaa0a42b7e8b193375c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__47d98b3498474ec60154f77271a580d3101cd4a151307da649c0e2899e84703f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationLandscape",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationLandscape:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationLandscape(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationLandscapeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationLandscapeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6c837b710190bdc1e8282c5a90549b7e1f34790155e259bed8c2fa256b46203e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationLandscape], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationLandscape],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__932fa7acc22b1eba778aff71d2a4dae1b4f645a3d1217dc953b45f57fd516388)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__93faa34beb217152da08d09937255bce03b2333926af7ff294b11236bb5eaba5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__44a1f603ef6de50c5fbabc9c1bd0b7c9d7194202c08bcc7bd9f7ff7ee429bfe6)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d7d31a1a8e37e732c6c3cf2b0ae6a26c38e46ba672406744a67fc77709d599f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__56ae60647e50fe54210488c67e431e95fbce6802704f2858eaa7c391f4bb56f4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__06e92dcdfc750898f84dd719124b6cfd29a43c68695e18cfa2545b02727da2f9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfOrientation]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfOrientation]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d16e7a7e364ca73b7621db09aaa10cc947875196d3ac692b8941aa11a13fd623)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d8da00bd316e23ae34ff618dc1bba4335eecdbfecf7624910f1da5adfd7bc14e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putLandscape")
    def put_landscape(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationLandscape()

        return typing.cast(None, jsii.invoke(self, "putLandscape", [value]))

    @jsii.member(jsii_name="putPortrait")
    def put_portrait(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationPortrait()

        return typing.cast(None, jsii.invoke(self, "putPortrait", [value]))

    @jsii.member(jsii_name="putSquare")
    def put_square(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationSquare()

        return typing.cast(None, jsii.invoke(self, "putSquare", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetLandscape")
    def reset_landscape(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLandscape", []))

    @jsii.member(jsii_name="resetPortrait")
    def reset_portrait(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPortrait", []))

    @jsii.member(jsii_name="resetSquare")
    def reset_square(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSquare", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="landscape")
    def landscape(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationLandscapeOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationLandscapeOutputReference, jsii.get(self, "landscape"))

    @builtins.property
    @jsii.member(jsii_name="portrait")
    def portrait(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationPortraitOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationPortraitOutputReference", jsii.get(self, "portrait"))

    @builtins.property
    @jsii.member(jsii_name="square")
    def square(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationSquareOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationSquareOutputReference", jsii.get(self, "square"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="landscapeInput")
    def landscape_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationLandscape], jsii.get(self, "landscapeInput"))

    @builtins.property
    @jsii.member(jsii_name="portraitInput")
    def portrait_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationPortrait"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationPortrait"], jsii.get(self, "portraitInput"))

    @builtins.property
    @jsii.member(jsii_name="squareInput")
    def square_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationSquare"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationSquare"], jsii.get(self, "squareInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfOrientation]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfOrientation]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfOrientation]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__145596fdd3ec49287f89b4ec178f70d996ec5e5b46cd03a7646f0d696b18bc72)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationPortrait",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationPortrait:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationPortrait(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationPortraitOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationPortraitOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c601aaca79c7454eacf58d3dd8d24388f04eb1e175d7df842d5f8c8be8504b43)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationPortrait]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationPortrait], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationPortrait],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__db09417a8e9e3ab0cf02fc71ba8430ee8e644ccee4727a793c7c80d34baf76b8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationSquare",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationSquare:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationSquare(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationSquareOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationSquareOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d88c3ed09a4544ceec29c20652e64496b2c131c08d36b230d5416993b95d32a6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationSquare]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationSquare], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationSquare],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__62c264a1bea1a113a13dbb6101476b75cc974caad85ce0b2ec785a2258da4765)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualImQuery",
    jsii_struct_bases=[],
    name_mapping={
        "allowed_transformations": "allowedTransformations",
        "query_var": "queryVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualImQuery:
    def __init__(
        self,
        *,
        allowed_transformations: typing.Sequence[builtins.str],
        query_var: builtins.str,
    ) -> None:
        '''
        :param allowed_transformations: Specifies the transformations that can be applied using the query string parameter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allowed_transformations DataAkamaiImagingPolicyImage#allowed_transformations}
        :param query_var: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#query_var DataAkamaiImagingPolicyImage#query_var}.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5047e1cbf65b6cfc5f272b6d23636300e2c8617deae81f9ccaf634d5f8d28499)
            check_type(argname="argument allowed_transformations", value=allowed_transformations, expected_type=type_hints["allowed_transformations"])
            check_type(argname="argument query_var", value=query_var, expected_type=type_hints["query_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "allowed_transformations": allowed_transformations,
            "query_var": query_var,
        }

    @builtins.property
    def allowed_transformations(self) -> typing.List[builtins.str]:
        '''Specifies the transformations that can be applied using the query string parameter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allowed_transformations DataAkamaiImagingPolicyImage#allowed_transformations}
        '''
        result = self._values.get("allowed_transformations")
        assert result is not None, "Required property 'allowed_transformations' is missing"
        return typing.cast(typing.List[builtins.str], result)

    @builtins.property
    def query_var(self) -> builtins.str:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#query_var DataAkamaiImagingPolicyImage#query_var}.'''
        result = self._values.get("query_var")
        assert result is not None, "Required property 'query_var' is missing"
        return typing.cast(builtins.str, result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualImQuery(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualImQueryList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualImQueryList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__42c266e451d935664ea8058fe16702275075e847f02258f475f9874a6caf9f69)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualImQueryOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__220d724b5fb3d705e703ae83631e054c9dfe5db211f24d231f1f28a0f9cd4535)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualImQueryOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__de067ab1ffe21022cac9c9b9e2494e44e0c9375a9d4ca49747e550de9d681352)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fb0e940efb47fed954721e5feb20478c3547b19eb5eccc6c02fb42ea84274107)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a4cb68a4efea240bca049a9bdea8d75ff76f651da965610f0cc04a6c6dea29c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualImQuery]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualImQuery]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualImQuery]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__db95d3642dd08253a9cc38b1840d3a1eb522447d2b452fa165d7af525576d57e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualImQueryOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualImQueryOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ba036fd61d3add09428eff09b587b3c88f7baced40c61dc0eeb35f692715943c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @builtins.property
    @jsii.member(jsii_name="allowedTransformationsInput")
    def allowed_transformations_input(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "allowedTransformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="queryVarInput")
    def query_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "queryVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowedTransformations")
    def allowed_transformations(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "allowedTransformations"))

    @allowed_transformations.setter
    def allowed_transformations(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__949afb1d874cabeaaf7c45213c4b4b0e08137475713628e59d3112639ef53e47)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowedTransformations", value)

    @builtins.property
    @jsii.member(jsii_name="queryVar")
    def query_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "queryVar"))

    @query_var.setter
    def query_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6308be15e1d40b7ac7385b1c4edafcecbc96c503b0e824188945db9b7a909e42)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "queryVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualImQuery]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualImQuery]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualImQuery]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__adc45b02348681417f7bb73a9d43db017e07f9ba81f1d7ee3c6e6784d03ad973)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualMaxColors",
    jsii_struct_bases=[],
    name_mapping={"colors": "colors", "colors_var": "colorsVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualMaxColors:
    def __init__(
        self,
        *,
        colors: typing.Optional[builtins.str] = None,
        colors_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param colors: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        :param colors_var: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a2679989018527a0a15f8ef62d760d7ee0855a0aa2d4a2c6a494fbb32a96aa17)
            check_type(argname="argument colors", value=colors, expected_type=type_hints["colors"])
            check_type(argname="argument colors_var", value=colors_var, expected_type=type_hints["colors_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if colors is not None:
            self._values["colors"] = colors
        if colors_var is not None:
            self._values["colors_var"] = colors_var

    @builtins.property
    def colors(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        '''
        result = self._values.get("colors")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def colors_var(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        result = self._values.get("colors_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualMaxColors(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualMaxColorsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualMaxColorsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6b6713b550d29f2bd3ec33f7518698dbd0f026eef9d078056be260632ded7be3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualMaxColorsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cf7ea5c6a5052118b199b70d9741c867d364d0fe6ab8831a89184332f42f2e21)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualMaxColorsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__87f3f2f3f64d3c98e9396a7c5bf8fd856e1e80cb7a27882e96b7b1983056ee0a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__314022ba5c334772ed981dd324988c5d4a226e4b9fa133cc70c7875d5208eaa6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a0a4d125b1ec86e96732a19695c1d65e5671ad4561c107d7857dbb88f3a69605)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualMaxColors]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualMaxColors]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__321bf4736515b2412463c4078f1e6d17227cc8eb884e2dd2da1b9f1cac8cb9a4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualMaxColorsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualMaxColorsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0eddd5fafa8d3525b15a3482bc3c663ac3892b651886f0ce661517b3be27dfda)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColors")
    def reset_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColors", []))

    @jsii.member(jsii_name="resetColorsVar")
    def reset_colors_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorsVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorsInput")
    def colors_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsInput"))

    @builtins.property
    @jsii.member(jsii_name="colorsVarInput")
    def colors_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsVarInput"))

    @builtins.property
    @jsii.member(jsii_name="colors")
    def colors(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colors"))

    @colors.setter
    def colors(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0bf5e47c15a801222d1dcffd464795beba6d30840a62e04665a7068a50411bfe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colors", value)

    @builtins.property
    @jsii.member(jsii_name="colorsVar")
    def colors_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorsVar"))

    @colors_var.setter
    def colors_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e5f0732d6761855c2a7e1e6fd4d1eafdd8af94c511b7666f9cd2900d8230c76)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorsVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualMaxColors]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualMaxColors]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualMaxColors]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__17b3ddb9df2900fa276c3c1c7021e489092b08c7a59bd07623dc99d3f361e121)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualMirror",
    jsii_struct_bases=[],
    name_mapping={
        "horizontal": "horizontal",
        "horizontal_var": "horizontalVar",
        "vertical": "vertical",
        "vertical_var": "verticalVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualMirror:
    def __init__(
        self,
        *,
        horizontal: typing.Optional[builtins.str] = None,
        horizontal_var: typing.Optional[builtins.str] = None,
        vertical: typing.Optional[builtins.str] = None,
        vertical_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param horizontal: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        :param horizontal_var: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        :param vertical: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        :param vertical_var: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fbb6f1da1ca326892e8b04ed195da28a3b083b53a39326e3c794494579f54dfb)
            check_type(argname="argument horizontal", value=horizontal, expected_type=type_hints["horizontal"])
            check_type(argname="argument horizontal_var", value=horizontal_var, expected_type=type_hints["horizontal_var"])
            check_type(argname="argument vertical", value=vertical, expected_type=type_hints["vertical"])
            check_type(argname="argument vertical_var", value=vertical_var, expected_type=type_hints["vertical_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if horizontal is not None:
            self._values["horizontal"] = horizontal
        if horizontal_var is not None:
            self._values["horizontal_var"] = horizontal_var
        if vertical is not None:
            self._values["vertical"] = vertical
        if vertical_var is not None:
            self._values["vertical_var"] = vertical_var

    @builtins.property
    def horizontal(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        '''
        result = self._values.get("horizontal")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def horizontal_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        '''
        result = self._values.get("horizontal_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        '''
        result = self._values.get("vertical")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        result = self._values.get("vertical_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualMirror(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualMirrorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualMirrorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1ac4ad37f54108f06ee08bd75d092a04b511e56928f35349a415ab81efcd8433)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualMirrorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__efcfa00706ed6b06a1df799e9b3ef94160f69ddc77a7bfb772a88bc90bbb911e)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualMirrorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__139ef24c2f2d0000023b8dd876fed5044818271b53e6c1936e2635b3f18ac088)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3d4c54d518cd73fe0380cc7f6744d32595a8ee98933e2819a6f54090325a2fd6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__416430bda1b96ab50a268c437d76f489bf5550153b05b5b852d29eea90a839b9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualMirror]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualMirror]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__812feed1ee7194715a0ba00db660cb24fae185099d738391d581a8ec2647dd44)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualMirrorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualMirrorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__286fa0ae2ac2d42c815a9e0a1485c20bd482cee822882c05aa2b0140f818f5af)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHorizontal")
    def reset_horizontal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontal", []))

    @jsii.member(jsii_name="resetHorizontalVar")
    def reset_horizontal_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontalVar", []))

    @jsii.member(jsii_name="resetVertical")
    def reset_vertical(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVertical", []))

    @jsii.member(jsii_name="resetVerticalVar")
    def reset_vertical_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVerticalVar", []))

    @builtins.property
    @jsii.member(jsii_name="horizontalInput")
    def horizontal_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontalVarInput")
    def horizontal_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalInput")
    def vertical_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalVarInput")
    def vertical_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontal")
    def horizontal(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontal"))

    @horizontal.setter
    def horizontal(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__881e0c7e6bed61da594618d32a8296d62b8ed41e2e6f4afb60a713d41697af3b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontal", value)

    @builtins.property
    @jsii.member(jsii_name="horizontalVar")
    def horizontal_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontalVar"))

    @horizontal_var.setter
    def horizontal_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0cd80086cbad6dc12a563c8c4ab864729a174148e5cc3d9b8decc0a99997967a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontalVar", value)

    @builtins.property
    @jsii.member(jsii_name="vertical")
    def vertical(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "vertical"))

    @vertical.setter
    def vertical(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1521aec5fc222c940cd80b0084961bbbad8e5537c5bd81a73128f9cdeebc32f2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "vertical", value)

    @builtins.property
    @jsii.member(jsii_name="verticalVar")
    def vertical_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "verticalVar"))

    @vertical_var.setter
    def vertical_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__116f16230bca951ed1694c3a61014e169c0aaba79461c4f420c19a1fe5e73cb8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "verticalVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualMirror]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualMirror]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualMirror]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4e44ffbe17b333f2af547f095cdb0b0a7bb4e3f31902a79f98cd657ea86b911b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualMonoHue",
    jsii_struct_bases=[],
    name_mapping={"hue": "hue", "hue_var": "hueVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualMonoHue:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__022afe606753ab5923f2e25ebcd704511540182280914f425167fa5322cbc970)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualMonoHue(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualMonoHueList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualMonoHueList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__102415b9aa7ccade7c48e3011c6cb153dc8ffe48d079635ab3b211229f36e6b1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualMonoHueOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__590dd35c770639959fff60f58f5d8edeaf4a205661187894649fb9895daec2bf)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualMonoHueOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b48b3f8df912d1e2c28dbfb8e0c1074a8a28d70aff52f9e9ec66615cc9d4f9ba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dcb4f46ed7010c48c0f7fd669e9988b17c2dee2cb7b131156265842297026d3f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8f7330f3049f7c06f568013f6cb144f47cd327379c2c9951119e09d1277848d2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualMonoHue]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualMonoHue]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b060f0cab44389b5705b55a9ee12230213aba1b8d8e76fd80dde5509799f138d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualMonoHueOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualMonoHueOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a4273633d62070a4368f6f9de37ba7ef8094ac5c442a9630db82ea1dd786b6c4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cfbde13478f5c12d92b56a6f6c2b8bf049dc1a506feca9475973abf795ffe364)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__462116b067d222c7b2f1705f29efce392e88d9eedc1ab228dfdd92535e822bde)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualMonoHue]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualMonoHue]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualMonoHue]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d10599dfa1ef76f697c21e2f1d0df63f8d36f79784b55433e49c7bcfe90a36e5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualOpacity",
    jsii_struct_bases=[],
    name_mapping={"opacity": "opacity", "opacity_var": "opacityVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualOpacity:
    def __init__(
        self,
        *,
        opacity: typing.Optional[builtins.str] = None,
        opacity_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param opacity: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param opacity_var: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__88b10e7daee264cae2d3ab19788b5bccaff9146b9f7c677a20fa33c501146a68)
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument opacity_var", value=opacity_var, expected_type=type_hints["opacity_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if opacity is not None:
            self._values["opacity"] = opacity
        if opacity_var is not None:
            self._values["opacity_var"] = opacity_var

    @builtins.property
    def opacity(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def opacity_var(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        result = self._values.get("opacity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualOpacity(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualOpacityList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualOpacityList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a568a32ad2d2a090f94e14bee7436499142856e7d070bc99cce0f864a56d9df1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualOpacityOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__742910497111c93aa4061453ce4e19d64ab551c624103d96ef9e332cdb368564)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualOpacityOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f091b0000cc6545f419828cd2ec70c694f82614a41ef38dbed756080df3054b7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__82451f237264604d6e0e4d0f4408ea10141ded876f8abc11dda15231964f0397)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__15ddf1efd594a393ccc702be62e7cec7f424cd160f6ae206f07c213426637d00)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualOpacity]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualOpacity]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a97e35dee3b4aedd514f916058d484f0a2107f8855b50e9bb439d2eda0ed5ee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualOpacityOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualOpacityOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fd89ba536f3424ad825a6c3d90794b0f5ca729ec66271f80003c0200f5b23a12)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetOpacityVar")
    def reset_opacity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacityVar", []))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityVarInput")
    def opacity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacity"))

    @opacity.setter
    def opacity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eae85a1fb67fb9a53ff324a84057b53a28385cb47fad54e3c9d5aacf79b25897)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacity", value)

    @builtins.property
    @jsii.member(jsii_name="opacityVar")
    def opacity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacityVar"))

    @opacity_var.setter
    def opacity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bdea2e61273451f192a8aefccaab573f5672c2a649933faff065b5b99f19c500)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacityVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualOpacity]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualOpacity]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualOpacity]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2cc7ef452bb17c230a319171bab2d9b260d6560473952925f31d1132de425e17)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4dfd3f3a33f19684cb37f621dba81603a8626dfeedf5fed506d30ae52eee30fe)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putAppend")
    def put_append(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualAppend, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b0bc203694b9667ff0ef6afc72417ba4f78f14db9b5fd8e43d41963a9286dccd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putAppend", [value]))

    @jsii.member(jsii_name="putAspectCrop")
    def put_aspect_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualAspectCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d7d752d3b0d951a7e642c5cefe4247d37a8f949da9ee9009d55fee314d6768a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putAspectCrop", [value]))

    @jsii.member(jsii_name="putBackgroundColor")
    def put_background_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__47408e463e940582c256d4a9e935f74dc8ec45ae626fb2402c5c401b5bb3513f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBackgroundColor", [value]))

    @jsii.member(jsii_name="putBlur")
    def put_blur(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualBlur, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0831ceff120804665907955dc2ab7b5a96a747c301a09f9f327a7b7cebabbae8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBlur", [value]))

    @jsii.member(jsii_name="putChromaKey")
    def put_chroma_key(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualChromaKey, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d88531fcbdc8d92ad57ba1b73caf862179b991b5117d45075a2e364d438281d2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putChromaKey", [value]))

    @jsii.member(jsii_name="putComposite")
    def put_composite(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualComposite, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5fe4e0f36669cc7cb3a3c9a5c6ffe309a6672c328ea3380231ccd9d8ea8fe6d0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putComposite", [value]))

    @jsii.member(jsii_name="putCompound")
    def put_compound(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualCompound, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__15f60f1c9eb9b2491eaa2163d8d5208bee5566dc23247040a72a8aeb8784fba8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCompound", [value]))

    @jsii.member(jsii_name="putContrast")
    def put_contrast(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualContrast, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aca044e5a7ff66fcf2b291da2d5a8019a25cb8011f89e8c6f8734772910474cf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putContrast", [value]))

    @jsii.member(jsii_name="putCrop")
    def put_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5923841eaa7b2bf709822ec909fac956e0e15476e0e53fc6475ea46dff866ace)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCrop", [value]))

    @jsii.member(jsii_name="putFaceCrop")
    def put_face_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualFaceCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__720d8d490ab885e10e56edfd6a036c0d818ef47aba237b2beff12541ff13de75)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFaceCrop", [value]))

    @jsii.member(jsii_name="putFeatureCrop")
    def put_feature_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualFeatureCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d23d19927cedc8858f86138da9477efb6178bd6e83d328106005af68df4d64be)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFeatureCrop", [value]))

    @jsii.member(jsii_name="putFitAndFill")
    def put_fit_and_fill(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualFitAndFill, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8906d58e8f705a5493753a1fb92e5b93b573dba06674482c35673dae5f0e33bc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFitAndFill", [value]))

    @jsii.member(jsii_name="putGoop")
    def put_goop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualGoop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__53915876c749ceb46c93db5e5164d53fccd9b916eac1e4a99ba6ec2755e4f3a7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGoop", [value]))

    @jsii.member(jsii_name="putGrayscale")
    def put_grayscale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualGrayscale, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__53734ed81fe2a13c060d172352278b3068e8142cee5228b456d1b2d1fded2da7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGrayscale", [value]))

    @jsii.member(jsii_name="putHsl")
    def put_hsl(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualHsl, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a89c2b0f1f7fb09caa1791e72ff4a13da40cba6d42b990ebe97431fe1967454d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsl", [value]))

    @jsii.member(jsii_name="putHsv")
    def put_hsv(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualHsv, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b205c77e59388ca42992ec375fef14bb64413a0abda43b5e4674fb039c8780d6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsv", [value]))

    @jsii.member(jsii_name="putIfDimension")
    def put_if_dimension(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfDimension, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5311d352975f07498a5a4d4855bf2759ec76cce71b03bc3e9111b874a668c0ed)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfDimension", [value]))

    @jsii.member(jsii_name="putIfOrientation")
    def put_if_orientation(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fd179f2b9e27548962fc38b2d75b07a7074f7499df9150ff63f1fb590ac58a63)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfOrientation", [value]))

    @jsii.member(jsii_name="putImQuery")
    def put_im_query(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualImQuery, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3cb49c8d1c4cbba55cb40fb2d77c5edebfb53e3d4e2c0e7120197ceb1e6a1fcd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putImQuery", [value]))

    @jsii.member(jsii_name="putMaxColors")
    def put_max_colors(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualMaxColors, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af41a9119611c0bd947e30225a079b912139effeb77a18f7b282f0d40cb9715a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMaxColors", [value]))

    @jsii.member(jsii_name="putMirror")
    def put_mirror(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualMirror, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__46990ed2e36073dddd2408917b4f555f647bb5649c88fca54ac5db6da884f3e3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMirror", [value]))

    @jsii.member(jsii_name="putMonoHue")
    def put_mono_hue(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualMonoHue, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f5c2c2bdf6313866ad71c93136208bbcd5a8b47266c2f5537e88c63556513ecb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMonoHue", [value]))

    @jsii.member(jsii_name="putOpacity")
    def put_opacity(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualOpacity, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4bf50862ad23e1468631f29cb617f9f61a7ffca85d242ceb4efd894067cdb516)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putOpacity", [value]))

    @jsii.member(jsii_name="putRegionOfInterestCrop")
    def put_region_of_interest_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualRegionOfInterestCrop", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__50cfc77bb068d9a14815381cf8466e384bac1a02bf4cd8ca6325222e106ce88b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRegionOfInterestCrop", [value]))

    @jsii.member(jsii_name="putRelativeCrop")
    def put_relative_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualRelativeCrop", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__520e5d90acfb49c01224c709d18aa544fdee9aa64f1f216d8f9906b6d234a1a8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRelativeCrop", [value]))

    @jsii.member(jsii_name="putRemoveColor")
    def put_remove_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualRemoveColor", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4c20f9f3ff933f23ba2cee7ad0a4f6bc566174457873e9b1efdf97759e417317)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRemoveColor", [value]))

    @jsii.member(jsii_name="putResize")
    def put_resize(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualResize", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d94b123f7cac5980af5742e61ef4fdc991af89024a134660a63489810858ae2d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putResize", [value]))

    @jsii.member(jsii_name="putRotate")
    def put_rotate(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualRotate", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a31cfc45c408b54b37f27a386650710ba0ca463b092531eb5b2ed36d0975f911)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRotate", [value]))

    @jsii.member(jsii_name="putScale")
    def put_scale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualScale", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dfdc93b7bb0b2af4e36f7cec998e5607b3906a59cc5732c7a233c2254e839902)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putScale", [value]))

    @jsii.member(jsii_name="putShear")
    def put_shear(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualShear", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__240ce7b00d284ad691dfbfb4d7c56e279404c84bbf6956f46b4aaf3bea99ade3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putShear", [value]))

    @jsii.member(jsii_name="putTrim")
    def put_trim(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualTrim", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7bd6f949f60de0f3f34a54698c676b73bec6cb7162cda959e17adcc30e9b92f7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTrim", [value]))

    @jsii.member(jsii_name="putUnsharpMask")
    def put_unsharp_mask(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualUnsharpMask", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__81df0267c706c1dd4d711abf27539df2f3c2a78dcfbf770ca5c39c7b11336089)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putUnsharpMask", [value]))

    @jsii.member(jsii_name="resetAppend")
    def reset_append(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAppend", []))

    @jsii.member(jsii_name="resetAspectCrop")
    def reset_aspect_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspectCrop", []))

    @jsii.member(jsii_name="resetBackgroundColor")
    def reset_background_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBackgroundColor", []))

    @jsii.member(jsii_name="resetBlur")
    def reset_blur(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBlur", []))

    @jsii.member(jsii_name="resetChromaKey")
    def reset_chroma_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChromaKey", []))

    @jsii.member(jsii_name="resetComposite")
    def reset_composite(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetComposite", []))

    @jsii.member(jsii_name="resetCompound")
    def reset_compound(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCompound", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetCrop")
    def reset_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCrop", []))

    @jsii.member(jsii_name="resetFaceCrop")
    def reset_face_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFaceCrop", []))

    @jsii.member(jsii_name="resetFeatureCrop")
    def reset_feature_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureCrop", []))

    @jsii.member(jsii_name="resetFitAndFill")
    def reset_fit_and_fill(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFitAndFill", []))

    @jsii.member(jsii_name="resetGoop")
    def reset_goop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGoop", []))

    @jsii.member(jsii_name="resetGrayscale")
    def reset_grayscale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGrayscale", []))

    @jsii.member(jsii_name="resetHsl")
    def reset_hsl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsl", []))

    @jsii.member(jsii_name="resetHsv")
    def reset_hsv(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsv", []))

    @jsii.member(jsii_name="resetIfDimension")
    def reset_if_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfDimension", []))

    @jsii.member(jsii_name="resetIfOrientation")
    def reset_if_orientation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfOrientation", []))

    @jsii.member(jsii_name="resetImQuery")
    def reset_im_query(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetImQuery", []))

    @jsii.member(jsii_name="resetMaxColors")
    def reset_max_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxColors", []))

    @jsii.member(jsii_name="resetMirror")
    def reset_mirror(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMirror", []))

    @jsii.member(jsii_name="resetMonoHue")
    def reset_mono_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonoHue", []))

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetRegionOfInterestCrop")
    def reset_region_of_interest_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRegionOfInterestCrop", []))

    @jsii.member(jsii_name="resetRelativeCrop")
    def reset_relative_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRelativeCrop", []))

    @jsii.member(jsii_name="resetRemoveColor")
    def reset_remove_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRemoveColor", []))

    @jsii.member(jsii_name="resetResize")
    def reset_resize(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetResize", []))

    @jsii.member(jsii_name="resetRotate")
    def reset_rotate(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRotate", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetShear")
    def reset_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetShear", []))

    @jsii.member(jsii_name="resetTrim")
    def reset_trim(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTrim", []))

    @jsii.member(jsii_name="resetUnsharpMask")
    def reset_unsharp_mask(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUnsharpMask", []))

    @builtins.property
    @jsii.member(jsii_name="append")
    def append(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualAppendList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualAppendList, jsii.get(self, "append"))

    @builtins.property
    @jsii.member(jsii_name="aspectCrop")
    def aspect_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualAspectCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualAspectCropList, jsii.get(self, "aspectCrop"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColor")
    def background_color(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualBackgroundColorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualBackgroundColorList, jsii.get(self, "backgroundColor"))

    @builtins.property
    @jsii.member(jsii_name="blur")
    def blur(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualBlurList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualBlurList, jsii.get(self, "blur"))

    @builtins.property
    @jsii.member(jsii_name="chromaKey")
    def chroma_key(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualChromaKeyList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualChromaKeyList, jsii.get(self, "chromaKey"))

    @builtins.property
    @jsii.member(jsii_name="composite")
    def composite(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualCompositeList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualCompositeList, jsii.get(self, "composite"))

    @builtins.property
    @jsii.member(jsii_name="compound")
    def compound(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualCompoundList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualCompoundList, jsii.get(self, "compound"))

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualContrastList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualContrastList, jsii.get(self, "contrast"))

    @builtins.property
    @jsii.member(jsii_name="crop")
    def crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualCropList, jsii.get(self, "crop"))

    @builtins.property
    @jsii.member(jsii_name="faceCrop")
    def face_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualFaceCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualFaceCropList, jsii.get(self, "faceCrop"))

    @builtins.property
    @jsii.member(jsii_name="featureCrop")
    def feature_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualFeatureCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualFeatureCropList, jsii.get(self, "featureCrop"))

    @builtins.property
    @jsii.member(jsii_name="fitAndFill")
    def fit_and_fill(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualFitAndFillList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualFitAndFillList, jsii.get(self, "fitAndFill"))

    @builtins.property
    @jsii.member(jsii_name="goop")
    def goop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualGoopList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualGoopList, jsii.get(self, "goop"))

    @builtins.property
    @jsii.member(jsii_name="grayscale")
    def grayscale(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualGrayscaleList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualGrayscaleList, jsii.get(self, "grayscale"))

    @builtins.property
    @jsii.member(jsii_name="hsl")
    def hsl(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualHslList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualHslList, jsii.get(self, "hsl"))

    @builtins.property
    @jsii.member(jsii_name="hsv")
    def hsv(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualHsvList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualHsvList, jsii.get(self, "hsv"))

    @builtins.property
    @jsii.member(jsii_name="ifDimension")
    def if_dimension(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionList, jsii.get(self, "ifDimension"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientation")
    def if_orientation(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationList, jsii.get(self, "ifOrientation"))

    @builtins.property
    @jsii.member(jsii_name="imQuery")
    def im_query(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualImQueryList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualImQueryList, jsii.get(self, "imQuery"))

    @builtins.property
    @jsii.member(jsii_name="maxColors")
    def max_colors(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualMaxColorsList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualMaxColorsList, jsii.get(self, "maxColors"))

    @builtins.property
    @jsii.member(jsii_name="mirror")
    def mirror(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualMirrorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualMirrorList, jsii.get(self, "mirror"))

    @builtins.property
    @jsii.member(jsii_name="monoHue")
    def mono_hue(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualMonoHueList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualMonoHueList, jsii.get(self, "monoHue"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualOpacityList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualOpacityList, jsii.get(self, "opacity"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestCrop")
    def region_of_interest_crop(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualRegionOfInterestCropList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualRegionOfInterestCropList", jsii.get(self, "regionOfInterestCrop"))

    @builtins.property
    @jsii.member(jsii_name="relativeCrop")
    def relative_crop(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualRelativeCropList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualRelativeCropList", jsii.get(self, "relativeCrop"))

    @builtins.property
    @jsii.member(jsii_name="removeColor")
    def remove_color(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualRemoveColorList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualRemoveColorList", jsii.get(self, "removeColor"))

    @builtins.property
    @jsii.member(jsii_name="resize")
    def resize(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualResizeList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualResizeList", jsii.get(self, "resize"))

    @builtins.property
    @jsii.member(jsii_name="rotate")
    def rotate(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualRotateList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualRotateList", jsii.get(self, "rotate"))

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualScaleList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualScaleList", jsii.get(self, "scale"))

    @builtins.property
    @jsii.member(jsii_name="shear")
    def shear(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualShearList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualShearList", jsii.get(self, "shear"))

    @builtins.property
    @jsii.member(jsii_name="trim")
    def trim(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualTrimList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualTrimList", jsii.get(self, "trim"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMask")
    def unsharp_mask(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualUnsharpMaskList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualUnsharpMaskList", jsii.get(self, "unsharpMask"))

    @builtins.property
    @jsii.member(jsii_name="appendInput")
    def append_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualAppend]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualAppend]]], jsii.get(self, "appendInput"))

    @builtins.property
    @jsii.member(jsii_name="aspectCropInput")
    def aspect_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualAspectCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualAspectCrop]]], jsii.get(self, "aspectCropInput"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColorInput")
    def background_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualBackgroundColor]]], jsii.get(self, "backgroundColorInput"))

    @builtins.property
    @jsii.member(jsii_name="blurInput")
    def blur_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualBlur]]], jsii.get(self, "blurInput"))

    @builtins.property
    @jsii.member(jsii_name="chromaKeyInput")
    def chroma_key_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualChromaKey]]], jsii.get(self, "chromaKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="compositeInput")
    def composite_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualComposite]]], jsii.get(self, "compositeInput"))

    @builtins.property
    @jsii.member(jsii_name="compoundInput")
    def compound_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualCompound]]], jsii.get(self, "compoundInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualContrast]]], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="cropInput")
    def crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualCrop]]], jsii.get(self, "cropInput"))

    @builtins.property
    @jsii.member(jsii_name="faceCropInput")
    def face_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualFaceCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualFaceCrop]]], jsii.get(self, "faceCropInput"))

    @builtins.property
    @jsii.member(jsii_name="featureCropInput")
    def feature_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualFeatureCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualFeatureCrop]]], jsii.get(self, "featureCropInput"))

    @builtins.property
    @jsii.member(jsii_name="fitAndFillInput")
    def fit_and_fill_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualFitAndFill]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualFitAndFill]]], jsii.get(self, "fitAndFillInput"))

    @builtins.property
    @jsii.member(jsii_name="goopInput")
    def goop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualGoop]]], jsii.get(self, "goopInput"))

    @builtins.property
    @jsii.member(jsii_name="grayscaleInput")
    def grayscale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualGrayscale]]], jsii.get(self, "grayscaleInput"))

    @builtins.property
    @jsii.member(jsii_name="hslInput")
    def hsl_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualHsl]]], jsii.get(self, "hslInput"))

    @builtins.property
    @jsii.member(jsii_name="hsvInput")
    def hsv_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualHsv]]], jsii.get(self, "hsvInput"))

    @builtins.property
    @jsii.member(jsii_name="ifDimensionInput")
    def if_dimension_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfDimension]]], jsii.get(self, "ifDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientationInput")
    def if_orientation_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfOrientation]]], jsii.get(self, "ifOrientationInput"))

    @builtins.property
    @jsii.member(jsii_name="imQueryInput")
    def im_query_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualImQuery]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualImQuery]]], jsii.get(self, "imQueryInput"))

    @builtins.property
    @jsii.member(jsii_name="maxColorsInput")
    def max_colors_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualMaxColors]]], jsii.get(self, "maxColorsInput"))

    @builtins.property
    @jsii.member(jsii_name="mirrorInput")
    def mirror_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualMirror]]], jsii.get(self, "mirrorInput"))

    @builtins.property
    @jsii.member(jsii_name="monoHueInput")
    def mono_hue_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualMonoHue]]], jsii.get(self, "monoHueInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualOpacity]]], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestCropInput")
    def region_of_interest_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualRegionOfInterestCrop"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualRegionOfInterestCrop"]]], jsii.get(self, "regionOfInterestCropInput"))

    @builtins.property
    @jsii.member(jsii_name="relativeCropInput")
    def relative_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualRelativeCrop"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualRelativeCrop"]]], jsii.get(self, "relativeCropInput"))

    @builtins.property
    @jsii.member(jsii_name="removeColorInput")
    def remove_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualRemoveColor"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualRemoveColor"]]], jsii.get(self, "removeColorInput"))

    @builtins.property
    @jsii.member(jsii_name="resizeInput")
    def resize_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualResize"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualResize"]]], jsii.get(self, "resizeInput"))

    @builtins.property
    @jsii.member(jsii_name="rotateInput")
    def rotate_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualRotate"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualRotate"]]], jsii.get(self, "rotateInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualScale"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualScale"]]], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="shearInput")
    def shear_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualShear"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualShear"]]], jsii.get(self, "shearInput"))

    @builtins.property
    @jsii.member(jsii_name="trimInput")
    def trim_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualTrim"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualTrim"]]], jsii.get(self, "trimInput"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMaskInput")
    def unsharp_mask_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualUnsharpMask"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualUnsharpMask"]]], jsii.get(self, "unsharpMaskInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqual], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqual],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fd35647c81e23b86cca35170f442db8cbf188f01cba99e2c2b3cf5075b801305)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualRegionOfInterestCrop",
    jsii_struct_bases=[],
    name_mapping={
        "region_of_interest": "regionOfInterest",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualRegionOfInterestCrop:
    def __init__(
        self,
        *,
        region_of_interest: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualRegionOfInterestCropRegionOfInterest", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param region_of_interest: region_of_interest block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest DataAkamaiImagingPolicyImage#region_of_interest}
        :param gravity: The placement of the crop area relative to the specified area of interest. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: The placement of the crop area relative to the specified area of interest. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param style: Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(region_of_interest, dict):
            region_of_interest = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualRegionOfInterestCropRegionOfInterest(**region_of_interest)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d76dfbeb29fd5b81efc657deb1e6548f4ce85db7aee032b1b12bbe093af709d1)
            check_type(argname="argument region_of_interest", value=region_of_interest, expected_type=type_hints["region_of_interest"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "region_of_interest": region_of_interest,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def region_of_interest(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualRegionOfInterestCropRegionOfInterest":
        '''region_of_interest block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest DataAkamaiImagingPolicyImage#region_of_interest}
        '''
        result = self._values.get("region_of_interest")
        assert result is not None, "Required property 'region_of_interest' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualRegionOfInterestCropRegionOfInterest", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''The placement of the crop area relative to the specified area of interest.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''The placement of the crop area relative to the specified area of interest.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualRegionOfInterestCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualRegionOfInterestCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualRegionOfInterestCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e2ee1959dbb1ee39f7199852eb84b66985f6918faa1b14282a7499f67d4d5072)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualRegionOfInterestCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d6cf6b5e0d1615417faf836749c3539126298825cb31736f52b75c98c97c493c)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualRegionOfInterestCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b295e9b5a05ca79a853ec9514c6e83158c0f8f90c1222e74a211923ba5b89cea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d0812f1a460cf35c75fc0293874211af07a349eccdfaf7dbede02ec71a6c9ab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c88ba109cb2dcce289f11536a70713f9f35570377c28b7ef767a3f80f65cbf78)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualRegionOfInterestCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualRegionOfInterestCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualRegionOfInterestCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f2a8956841a25c105eec1e55daa2bac8d6cd24ff05a7322e270f350bf3516da6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualRegionOfInterestCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualRegionOfInterestCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7a8d31c8ed577bef01b04abdf192f461e53895935e38e3b1b8991abaa6545894)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putRegionOfInterest")
    def put_region_of_interest(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualRegionOfInterestCropRegionOfInterest()

        return typing.cast(None, jsii.invoke(self, "putRegionOfInterest", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterest")
    def region_of_interest(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualRegionOfInterestCropRegionOfInterestOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualRegionOfInterestCropRegionOfInterestOutputReference", jsii.get(self, "regionOfInterest"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestInput")
    def region_of_interest_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualRegionOfInterestCropRegionOfInterest"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualRegionOfInterestCropRegionOfInterest"], jsii.get(self, "regionOfInterestInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cdcc22102709a568f0c6096a8d07453e29353360765542dde56b213bd57a908a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eca7e3c73fdbb9de4d7d5878e87bdd96bf82520d8c5efe09fac72622000e1bda)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a6db652f1545ef808f5749add55e6417ae31155e2fdd71ff2d050d35db0fb3e7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ac5c63ec77de74336fc0a92363b01a3b966133177eb5db169cb5a2faacf2b73)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e5b2f439ba96e2cb09032c3bce1d077c419ec6e304c0ddf1142589830ea8bd4e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e5ef1197adacfbdfb1a32c1c3c88875766e56d0fa8d535fcbc086b764a98227c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__834d6a8e5e4b2210e458aa134e02272e7c81bcd3d644153288fd209ed5244b68)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__34e77f4de2c1f12d4ad8fde102532d503df95df798090407eceb7b80c7cdb77c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualRegionOfInterestCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualRegionOfInterestCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualRegionOfInterestCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__167843ca1f01c8e1ad9b84aa8e034043f2f80c3bc1a453e924af1c794d575cc6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualRegionOfInterestCropRegionOfInterest",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualRegionOfInterestCropRegionOfInterest:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualRegionOfInterestCropRegionOfInterest(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualRegionOfInterestCropRegionOfInterestOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualRegionOfInterestCropRegionOfInterestOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9af09c24e4ba72b111905b7f2e28b4a7b457068fd51c451ed008b144242c5b8b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualRegionOfInterestCropRegionOfInterest]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualRegionOfInterestCropRegionOfInterest], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualRegionOfInterestCropRegionOfInterest],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0b3032d081ce683dfc256731e9bc238c9dc09d79df91a164f6c6ee494c11f977)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualRelativeCrop",
    jsii_struct_bases=[],
    name_mapping={
        "east": "east",
        "east_var": "eastVar",
        "north": "north",
        "north_var": "northVar",
        "south": "south",
        "south_var": "southVar",
        "west": "west",
        "west_var": "westVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualRelativeCrop:
    def __init__(
        self,
        *,
        east: typing.Optional[builtins.str] = None,
        east_var: typing.Optional[builtins.str] = None,
        north: typing.Optional[builtins.str] = None,
        north_var: typing.Optional[builtins.str] = None,
        south: typing.Optional[builtins.str] = None,
        south_var: typing.Optional[builtins.str] = None,
        west: typing.Optional[builtins.str] = None,
        west_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param east: The number of pixels to shrink or expand the right side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east DataAkamaiImagingPolicyImage#east}
        :param east_var: The number of pixels to shrink or expand the right side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east_var DataAkamaiImagingPolicyImage#east_var}
        :param north: The number of pixels to shrink or expand the top side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north DataAkamaiImagingPolicyImage#north}
        :param north_var: The number of pixels to shrink or expand the top side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north_var DataAkamaiImagingPolicyImage#north_var}
        :param south: The number of pixels to shrink or expand the bottom side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south DataAkamaiImagingPolicyImage#south}
        :param south_var: The number of pixels to shrink or expand the bottom side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south_var DataAkamaiImagingPolicyImage#south_var}
        :param west: The number of pixels to shrink or expand the left side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west DataAkamaiImagingPolicyImage#west}
        :param west_var: The number of pixels to shrink or expand the left side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west_var DataAkamaiImagingPolicyImage#west_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e98ad59d6f7c0d6e430f6d93a27bdc81de89b578e2e538a320ff83c5b5c84bbe)
            check_type(argname="argument east", value=east, expected_type=type_hints["east"])
            check_type(argname="argument east_var", value=east_var, expected_type=type_hints["east_var"])
            check_type(argname="argument north", value=north, expected_type=type_hints["north"])
            check_type(argname="argument north_var", value=north_var, expected_type=type_hints["north_var"])
            check_type(argname="argument south", value=south, expected_type=type_hints["south"])
            check_type(argname="argument south_var", value=south_var, expected_type=type_hints["south_var"])
            check_type(argname="argument west", value=west, expected_type=type_hints["west"])
            check_type(argname="argument west_var", value=west_var, expected_type=type_hints["west_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if east is not None:
            self._values["east"] = east
        if east_var is not None:
            self._values["east_var"] = east_var
        if north is not None:
            self._values["north"] = north
        if north_var is not None:
            self._values["north_var"] = north_var
        if south is not None:
            self._values["south"] = south
        if south_var is not None:
            self._values["south_var"] = south_var
        if west is not None:
            self._values["west"] = west
        if west_var is not None:
            self._values["west_var"] = west_var

    @builtins.property
    def east(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the right side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east DataAkamaiImagingPolicyImage#east}
        '''
        result = self._values.get("east")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def east_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the right side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east_var DataAkamaiImagingPolicyImage#east_var}
        '''
        result = self._values.get("east_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def north(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the top side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north DataAkamaiImagingPolicyImage#north}
        '''
        result = self._values.get("north")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def north_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the top side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north_var DataAkamaiImagingPolicyImage#north_var}
        '''
        result = self._values.get("north_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def south(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the bottom side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south DataAkamaiImagingPolicyImage#south}
        '''
        result = self._values.get("south")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def south_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the bottom side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south_var DataAkamaiImagingPolicyImage#south_var}
        '''
        result = self._values.get("south_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def west(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the left side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west DataAkamaiImagingPolicyImage#west}
        '''
        result = self._values.get("west")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def west_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the left side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west_var DataAkamaiImagingPolicyImage#west_var}
        '''
        result = self._values.get("west_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualRelativeCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualRelativeCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualRelativeCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__58b0948e7d54bfde228916568190ae06fb10569d26514393898bbe880389415c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualRelativeCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c879ae5de1d2614ebd782aa333085858cc4cf78c4bbf4209c9058b80f3f1f705)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualRelativeCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__600aec221240e50755a638a2284431a08782c23f3be15154121947f91c664705)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1a3445471d2500fb3e95c4315497e0e9465119009ea7f54fb9a6dc8fe00bbe0e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__840e1bda0d8998d53c387b917fec74d481a493de9df415839c61b5cced012f20)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualRelativeCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualRelativeCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualRelativeCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ed2ee439d86188c1e56302d60572dcd044702f1aa8a9c13d85f6e071375686c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualRelativeCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualRelativeCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa777c8d505403357554f26c948acf7f12696ceb4b9b139523dcd48d49b05f8e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetEast")
    def reset_east(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEast", []))

    @jsii.member(jsii_name="resetEastVar")
    def reset_east_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEastVar", []))

    @jsii.member(jsii_name="resetNorth")
    def reset_north(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNorth", []))

    @jsii.member(jsii_name="resetNorthVar")
    def reset_north_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNorthVar", []))

    @jsii.member(jsii_name="resetSouth")
    def reset_south(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSouth", []))

    @jsii.member(jsii_name="resetSouthVar")
    def reset_south_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSouthVar", []))

    @jsii.member(jsii_name="resetWest")
    def reset_west(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWest", []))

    @jsii.member(jsii_name="resetWestVar")
    def reset_west_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWestVar", []))

    @builtins.property
    @jsii.member(jsii_name="eastInput")
    def east_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "eastInput"))

    @builtins.property
    @jsii.member(jsii_name="eastVarInput")
    def east_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "eastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="northInput")
    def north_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "northInput"))

    @builtins.property
    @jsii.member(jsii_name="northVarInput")
    def north_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "northVarInput"))

    @builtins.property
    @jsii.member(jsii_name="southInput")
    def south_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "southInput"))

    @builtins.property
    @jsii.member(jsii_name="southVarInput")
    def south_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "southVarInput"))

    @builtins.property
    @jsii.member(jsii_name="westInput")
    def west_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "westInput"))

    @builtins.property
    @jsii.member(jsii_name="westVarInput")
    def west_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "westVarInput"))

    @builtins.property
    @jsii.member(jsii_name="east")
    def east(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "east"))

    @east.setter
    def east(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1453f51c0422652fe9b9c0ceeecbe8515836c9afd00a10c7300564f1052ea87f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "east", value)

    @builtins.property
    @jsii.member(jsii_name="eastVar")
    def east_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "eastVar"))

    @east_var.setter
    def east_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1d9b8d9871d8afa1b3b8bc22238234833fb38a897553ba189a1c9773883ef128)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "eastVar", value)

    @builtins.property
    @jsii.member(jsii_name="north")
    def north(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "north"))

    @north.setter
    def north(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ddefeff67a3537016f62db9d9c40a2d7c86ec91da83c6afb70ef8a776f6a663f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "north", value)

    @builtins.property
    @jsii.member(jsii_name="northVar")
    def north_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "northVar"))

    @north_var.setter
    def north_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__17c84d0fd1310257b3ad01ed402eceda47cf1c9fa4f4ea19d3c74b24249c46f6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "northVar", value)

    @builtins.property
    @jsii.member(jsii_name="south")
    def south(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "south"))

    @south.setter
    def south(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c8d0bd34513d1dcde9a465258d5777e0f669b14edd0603620a7b9a8994e5d4e7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "south", value)

    @builtins.property
    @jsii.member(jsii_name="southVar")
    def south_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "southVar"))

    @south_var.setter
    def south_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b7bec1134abcbed3663645fa58bd3d261221e4e5879f71582634fdc5134343b6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "southVar", value)

    @builtins.property
    @jsii.member(jsii_name="west")
    def west(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "west"))

    @west.setter
    def west(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5c8a0a5ca93e8f82946394acf28c8131960a27fdd703bd56c0275e4b4469f39c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "west", value)

    @builtins.property
    @jsii.member(jsii_name="westVar")
    def west_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "westVar"))

    @west_var.setter
    def west_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8cc4019509f81f2120d2b1691af1b0baa11b78ba285790721ac5fc1165fb9b1f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "westVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualRelativeCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualRelativeCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualRelativeCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__359881af250f0b1701b66bf1be940cc18d233ad41e8f05b17938465e3c03b700)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualRemoveColor",
    jsii_struct_bases=[],
    name_mapping={
        "color": "color",
        "color_var": "colorVar",
        "feather": "feather",
        "feather_var": "featherVar",
        "tolerance": "tolerance",
        "tolerance_var": "toleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualRemoveColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
        feather: typing.Optional[builtins.str] = None,
        feather_var: typing.Optional[builtins.str] = None,
        tolerance: typing.Optional[builtins.str] = None,
        tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        :param feather: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        :param feather_var: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        :param tolerance: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        :param tolerance_var: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c1397df8fe58f0a43d10e9efcee320e6d11198aade3a822673b2d23a4467fc0c)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
            check_type(argname="argument feather", value=feather, expected_type=type_hints["feather"])
            check_type(argname="argument feather_var", value=feather_var, expected_type=type_hints["feather_var"])
            check_type(argname="argument tolerance", value=tolerance, expected_type=type_hints["tolerance"])
            check_type(argname="argument tolerance_var", value=tolerance_var, expected_type=type_hints["tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var
        if feather is not None:
            self._values["feather"] = feather
        if feather_var is not None:
            self._values["feather_var"] = feather_var
        if tolerance is not None:
            self._values["tolerance"] = tolerance
        if tolerance_var is not None:
            self._values["tolerance_var"] = tolerance_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        '''
        result = self._values.get("feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather_var(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        '''
        result = self._values.get("feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        '''
        result = self._values.get("tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance_var(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        result = self._values.get("tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualRemoveColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualRemoveColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualRemoveColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9dc8a8c3ce5dbfeceb89ef03fbddd3a3bac94e083c9912c00cf694c770d01b1d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualRemoveColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__afc8bdd38c154506e4768afa18486ac2b635732f9f9db3323af8e5f169007620)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualRemoveColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__54422189162bb2f532d6dffcf3550a884549039aeb25cd43b5a3966bf830dbcc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1bf6bd14bca5f03afb643ed3d2796b6dc9b0e5a8e9f1dba4724f3af9be098fbf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a6293b9356397eac37e588416b45e55c059b787c841b7da06ff2af67bd6538dd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualRemoveColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualRemoveColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualRemoveColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3b14fc15873a935d3f8f4a140292e925c67dd307ccd717b93f0dd69276fbedb2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualRemoveColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualRemoveColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c72a9637e5ef9242453825acb6cfb8b4ad5a95b4ced1229c6d6453c5c168d544)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @jsii.member(jsii_name="resetFeather")
    def reset_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeather", []))

    @jsii.member(jsii_name="resetFeatherVar")
    def reset_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatherVar", []))

    @jsii.member(jsii_name="resetTolerance")
    def reset_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTolerance", []))

    @jsii.member(jsii_name="resetToleranceVar")
    def reset_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featherInput")
    def feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherInput"))

    @builtins.property
    @jsii.member(jsii_name="featherVarInput")
    def feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceInput")
    def tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceVarInput")
    def tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1881443a710c1abdfbd786d7597ec818411f6d18eb711938655bb7e49045ec1b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8073897a7187cdaf66e035533f0851ad026fb857fd20d7e870703ff3d43f800d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="feather")
    def feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "feather"))

    @feather.setter
    def feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__baa25f5905de1fbba916042b5291dcf9fc718132feeed2316bcca11971e16862)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "feather", value)

    @builtins.property
    @jsii.member(jsii_name="featherVar")
    def feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featherVar"))

    @feather_var.setter
    def feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9287d6eb408dbbf280b5a97a5ed187edb4c848da8f589de42d59580efcf862ca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featherVar", value)

    @builtins.property
    @jsii.member(jsii_name="tolerance")
    def tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tolerance"))

    @tolerance.setter
    def tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ca1b9eafbfde421083d7e58e15e23a576199404e7252f21377ecba22e912b36)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tolerance", value)

    @builtins.property
    @jsii.member(jsii_name="toleranceVar")
    def tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "toleranceVar"))

    @tolerance_var.setter
    def tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ee606ae629dae08df5ba975e57002dff0847c8247c88d98c065fc391d0d1c842)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "toleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualRemoveColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualRemoveColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualRemoveColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0594ccceedf841baccc656506e02eba55baf582a424559d6dc87951a1b8b0b7a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualResize",
    jsii_struct_bases=[],
    name_mapping={
        "aspect": "aspect",
        "aspect_var": "aspectVar",
        "height": "height",
        "height_var": "heightVar",
        "type": "type",
        "type_var": "typeVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualResize:
    def __init__(
        self,
        *,
        aspect: typing.Optional[builtins.str] = None,
        aspect_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param aspect: Preserves the aspect ratio. Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect DataAkamaiImagingPolicyImage#aspect}
        :param aspect_var: Preserves the aspect ratio. Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_var DataAkamaiImagingPolicyImage#aspect_var}
        :param height: The height to resize the source image to. Must be set if height is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height to resize the source image to. Must be set if height is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param type: Sets constraints for the image resize. Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: Sets constraints for the image resize. Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        :param width: The width to resize the source image to. Must be set if width is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width to resize the source image to. Must be set if width is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3d7afb7c42098a07b545920201e7c35470cc6252abc5f8ce5cbd7ba7d39f7dd5)
            check_type(argname="argument aspect", value=aspect, expected_type=type_hints["aspect"])
            check_type(argname="argument aspect_var", value=aspect_var, expected_type=type_hints["aspect_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if aspect is not None:
            self._values["aspect"] = aspect
        if aspect_var is not None:
            self._values["aspect_var"] = aspect_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def aspect(self) -> typing.Optional[builtins.str]:
        '''Preserves the aspect ratio.

        Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect DataAkamaiImagingPolicyImage#aspect}
        '''
        result = self._values.get("aspect")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def aspect_var(self) -> typing.Optional[builtins.str]:
        '''Preserves the aspect ratio.

        Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_var DataAkamaiImagingPolicyImage#aspect_var}
        '''
        result = self._values.get("aspect_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height to resize the source image to. Must be set if height is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height to resize the source image to. Must be set if height is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''Sets constraints for the image resize.

        Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''Sets constraints for the image resize.

        Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width to resize the source image to. Must be set if width is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width to resize the source image to. Must be set if width is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualResize(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualResizeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualResizeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9982704bd91e17535d0695f882f89762783880cfa6cf1fbe45f862f781875356)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualResizeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4541153047193357c636056e9fa1e7f5eae5f5467986bdfbb05dc2602dc08a47)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualResizeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d23a69fa60b61d7e8921883037f5be195ccc96ff302e4c867bb25588cbd7de91)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f07e03e2d2ec2f48a6b085b6fba537ab2815bbcda96245e9078473e4ecc86e44)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a21971e6a813a071ea8ef7a375a0788e882020186db6f9f26e2d1be30884ba64)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualResize]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualResize]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualResize]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0eb1692afe41bed8659512f348a8bd43300f5141eb18d5130c394eff98fa0cc8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualResizeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualResizeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ddeb8b416e9523d6ee0cd919f34b405202dce08d3a5cd2763c73574ed8c7b193)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAspect")
    def reset_aspect(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspect", []))

    @jsii.member(jsii_name="resetAspectVar")
    def reset_aspect_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspectVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="aspectInput")
    def aspect_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "aspectInput"))

    @builtins.property
    @jsii.member(jsii_name="aspectVarInput")
    def aspect_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "aspectVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="aspect")
    def aspect(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "aspect"))

    @aspect.setter
    def aspect(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ce943ba9192f997e4cf0b1f5b0174827563d59e411d0706630f17482479b534e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "aspect", value)

    @builtins.property
    @jsii.member(jsii_name="aspectVar")
    def aspect_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "aspectVar"))

    @aspect_var.setter
    def aspect_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2f859df2d5407fad910f2c24ed048188db22ca12c7facfaf8ea91bb378b4c988)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "aspectVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7a134f51785f57ed91b4659947f5b908994a73f6e219e2a589fb071931507b7f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__733eed5ac23394bc49e1a1bcb9f59186fd53cf789a94bb3e229608f4d361eaf9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a88c436825a734b758c8452efaa22cad32687e63109801d1585e6801bc5151ca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8c7faca622c4fd9c20c941857cc211db659d64e0a20f72586e01490d68418056)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__172ec983bc2cdd0893dc3c6e25e454f6da67ae8b99dbfdcf35a2dc5932d480ec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ad302fe8a78ea8e79425955fbd4c267f98d1a1f73d68aab68a3d0ee088978c7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualResize]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualResize]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualResize]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ee97c285909ca2b7d400b98e07b9533dd66a0494688b29eb40ad5525469fe25)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualRotate",
    jsii_struct_bases=[],
    name_mapping={"degrees": "degrees", "degrees_var": "degreesVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualRotate:
    def __init__(
        self,
        *,
        degrees: typing.Optional[builtins.str] = None,
        degrees_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param degrees: The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees DataAkamaiImagingPolicyImage#degrees}
        :param degrees_var: The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees_var DataAkamaiImagingPolicyImage#degrees_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__68ff0c0ae74d48f61354c226dda095a71ad7635611af8f7c35f131cb697d898a)
            check_type(argname="argument degrees", value=degrees, expected_type=type_hints["degrees"])
            check_type(argname="argument degrees_var", value=degrees_var, expected_type=type_hints["degrees_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if degrees is not None:
            self._values["degrees"] = degrees
        if degrees_var is not None:
            self._values["degrees_var"] = degrees_var

    @builtins.property
    def degrees(self) -> typing.Optional[builtins.str]:
        '''The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees DataAkamaiImagingPolicyImage#degrees}
        '''
        result = self._values.get("degrees")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def degrees_var(self) -> typing.Optional[builtins.str]:
        '''The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees_var DataAkamaiImagingPolicyImage#degrees_var}
        '''
        result = self._values.get("degrees_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualRotate(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualRotateList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualRotateList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8522b0f26984a077318b9692bab7235e99e5543ab59bff96431bb64bd718b554)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualRotateOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__98afbb0795d00830abf228da07f277560acd2b2e72881a85a3489184022fedc7)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualRotateOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bfea885a8af3447338f3ee3938f201f2e3de7674d86d0861ee43de13ad1f30f2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f05f2191186fcdbba0d681d56cf99a3382e6de9dac3bbd2880f89ac5f7a0cca6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__21c0a4bdf3b656327ea942a6da2550d44300ecc4f268ccb1b469cdda73c1a969)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualRotate]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualRotate]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualRotate]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0c9bed713fc284a907e222d949da201ffefc65c8616f37afbc49b38580e7781c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualRotateOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualRotateOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b59ae7fa79e2fe42e3c9872cc2d69530d52246f348f80fa3751ab772b572f002)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetDegrees")
    def reset_degrees(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDegrees", []))

    @jsii.member(jsii_name="resetDegreesVar")
    def reset_degrees_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDegreesVar", []))

    @builtins.property
    @jsii.member(jsii_name="degreesInput")
    def degrees_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "degreesInput"))

    @builtins.property
    @jsii.member(jsii_name="degreesVarInput")
    def degrees_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "degreesVarInput"))

    @builtins.property
    @jsii.member(jsii_name="degrees")
    def degrees(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "degrees"))

    @degrees.setter
    def degrees(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f15ba31b752d5c05d06c1f2757dad8bddcba4e1ceae7b394496b9ee69b912a1e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "degrees", value)

    @builtins.property
    @jsii.member(jsii_name="degreesVar")
    def degrees_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "degreesVar"))

    @degrees_var.setter
    def degrees_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c005321376c281fa139f66f5a461b597824b5888fbe409b8b26ab219d75ed99a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "degreesVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualRotate]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualRotate]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualRotate]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eb36fe43ae986b07274cf6c366bd4f07838c976cc81325810a3fc13fa0dcf411)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualScale",
    jsii_struct_bases=[],
    name_mapping={
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualScale:
    def __init__(
        self,
        *,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param height: Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged. Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged. Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3c04c1cb1b16d6db8f5ea652f0030ea9bcdecff17c5518df0b38a19cefacdaab)
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size.

        Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size.

        Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged.

        Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged.

        Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualScale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualScaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualScaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2874ef3b40d27809b07df94b18540a8ad1f7a8ba110a5c75967bebce7a0e647a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualScaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__14fb54436b241de2d1b3f32a0dbef353003b0517672e24ae1b0f295e0068dd9c)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualScaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3b4882650f26bbcae264a90e03d53184026b2eef134a647f32b64c9a8ff63fe3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2f539d50d2bfd4e18455a070d23ce59be0331b081c1e3b87076c8038bcaa82ff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__01b548fed0df3f471f936577aee5b6baf11869f9267584e8ab430c5501a6ef48)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualScale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualScale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualScale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4b3be29934540da6d3ab24ce6ed0d6b27f959236baea94fcbfe752ac436b967a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualScaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualScaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b4a0eba657803869988dd6e3d30e19ee89cfd835c48c5c8bea9712fe31fb02ca)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5bd875f773338f82b41f8c51015d88f2a9e2aece8d4c44fca504a5aaddcf382b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f2ee4311407756de69b8ee240b50b95adcbde677a4f0c09f9ab590abdbfb8dbf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__185f1df7e59e81d67873817416e8381b2e4433778ded4aa7b036ea54578b8cda)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bed92580c3b1a3dfa8d024b43f138a1f0c8d1f2c5921d76bb0f496c6f0c39fc7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualScale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualScale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualScale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b80eac0b721844c0af5ac5640164122202fe7d6c485a8ab3a447866c025deea3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualShear",
    jsii_struct_bases=[],
    name_mapping={
        "x_shear": "xShear",
        "x_shear_var": "xShearVar",
        "y_shear": "yShear",
        "y_shear_var": "yShearVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualShear:
    def __init__(
        self,
        *,
        x_shear: typing.Optional[builtins.str] = None,
        x_shear_var: typing.Optional[builtins.str] = None,
        y_shear: typing.Optional[builtins.str] = None,
        y_shear_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param x_shear: The amount to shear along the x-axis, measured in multiples of the image's width. Must be set if yShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear DataAkamaiImagingPolicyImage#x_shear}
        :param x_shear_var: The amount to shear along the x-axis, measured in multiples of the image's width. Must be set if yShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear_var DataAkamaiImagingPolicyImage#x_shear_var}
        :param y_shear: The amount to shear along the y-axis, measured in multiples of the image's height. Must be set if xShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear DataAkamaiImagingPolicyImage#y_shear}
        :param y_shear_var: The amount to shear along the y-axis, measured in multiples of the image's height. Must be set if xShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear_var DataAkamaiImagingPolicyImage#y_shear_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0615d37cd6ed73f4de61e294966ea2e0c13e3fab63ccdc146a7d66a068163da7)
            check_type(argname="argument x_shear", value=x_shear, expected_type=type_hints["x_shear"])
            check_type(argname="argument x_shear_var", value=x_shear_var, expected_type=type_hints["x_shear_var"])
            check_type(argname="argument y_shear", value=y_shear, expected_type=type_hints["y_shear"])
            check_type(argname="argument y_shear_var", value=y_shear_var, expected_type=type_hints["y_shear_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if x_shear is not None:
            self._values["x_shear"] = x_shear
        if x_shear_var is not None:
            self._values["x_shear_var"] = x_shear_var
        if y_shear is not None:
            self._values["y_shear"] = y_shear
        if y_shear_var is not None:
            self._values["y_shear_var"] = y_shear_var

    @builtins.property
    def x_shear(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the x-axis, measured in multiples of the image's width.

        Must be set if yShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear DataAkamaiImagingPolicyImage#x_shear}
        '''
        result = self._values.get("x_shear")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_shear_var(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the x-axis, measured in multiples of the image's width.

        Must be set if yShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear_var DataAkamaiImagingPolicyImage#x_shear_var}
        '''
        result = self._values.get("x_shear_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_shear(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the y-axis, measured in multiples of the image's height.

        Must be set if xShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear DataAkamaiImagingPolicyImage#y_shear}
        '''
        result = self._values.get("y_shear")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_shear_var(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the y-axis, measured in multiples of the image's height.

        Must be set if xShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear_var DataAkamaiImagingPolicyImage#y_shear_var}
        '''
        result = self._values.get("y_shear_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualShear(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualShearList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualShearList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0fe632f568a3591b74d7c7132f74217557a91d4dc37d5687506f0773280b4f5b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualShearOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8bc18dc8f80e2bbea26003f1fac9006bc04470904a6dd56b72f39cdcb96ee5ad)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualShearOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b2e3485c1cc39f505f4362be1642b371b255aeb6f897f2d0304e7aebbbdbce06)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__18e6810c3e3d5b4426dc6adc622077e9b915661a6699637069f4ba0314fcac97)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4f1b6cdeabb7f0fc998ad970ab370db26909a0b9c881bfc05ef56ff593a8f564)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualShear]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualShear]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualShear]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9246aaa96f00b81e318596cf4971e8ef547f6a51e1e5abb1ce397b15eeb64ea7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualShearOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualShearOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0a5c356fdd2c11561cbbd822a9080e4c381d944626978a5d2deac088c0eba2cf)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetXShear")
    def reset_x_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXShear", []))

    @jsii.member(jsii_name="resetXShearVar")
    def reset_x_shear_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXShearVar", []))

    @jsii.member(jsii_name="resetYShear")
    def reset_y_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYShear", []))

    @jsii.member(jsii_name="resetYShearVar")
    def reset_y_shear_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYShearVar", []))

    @builtins.property
    @jsii.member(jsii_name="xShearInput")
    def x_shear_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xShearInput"))

    @builtins.property
    @jsii.member(jsii_name="xShearVarInput")
    def x_shear_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xShearVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yShearInput")
    def y_shear_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yShearInput"))

    @builtins.property
    @jsii.member(jsii_name="yShearVarInput")
    def y_shear_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yShearVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xShear")
    def x_shear(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xShear"))

    @x_shear.setter
    def x_shear(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f0d8fd9fd74560a33b86071895fb122a72bef165339d42477168d0bbb84951d9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xShear", value)

    @builtins.property
    @jsii.member(jsii_name="xShearVar")
    def x_shear_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xShearVar"))

    @x_shear_var.setter
    def x_shear_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4994fb771a552f9306dee96ed0ecdb0b89d9e082c7f10b6a1d2dcf275aaeca62)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xShearVar", value)

    @builtins.property
    @jsii.member(jsii_name="yShear")
    def y_shear(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yShear"))

    @y_shear.setter
    def y_shear(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__75bf97270742e1740d437fc0da112b3765acf5178cc33805fec2c4b02f65b0af)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yShear", value)

    @builtins.property
    @jsii.member(jsii_name="yShearVar")
    def y_shear_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yShearVar"))

    @y_shear_var.setter
    def y_shear_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a74cc32104ab376cdeb421ff2c5f574bd03b8f3225f62618ff3e60717de9a44c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yShearVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualShear]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualShear]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualShear]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__006dcd814a176dec8c3b2ce58aa6786cdb9a8f1b49ccec64da538d0f6e154be8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualTrim",
    jsii_struct_bases=[],
    name_mapping={
        "fuzz": "fuzz",
        "fuzz_var": "fuzzVar",
        "padding": "padding",
        "padding_var": "paddingVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualTrim:
    def __init__(
        self,
        *,
        fuzz: typing.Optional[builtins.str] = None,
        fuzz_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fuzz: The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz DataAkamaiImagingPolicyImage#fuzz}
        :param fuzz_var: The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz_var DataAkamaiImagingPolicyImage#fuzz_var}
        :param padding: The amount of padding in pixels to add to the trimmed image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: The amount of padding in pixels to add to the trimmed image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__81cef071d1a1c2f4dfcc3f4c9041fef08ed83322a3451590ed0c02b8add6f718)
            check_type(argname="argument fuzz", value=fuzz, expected_type=type_hints["fuzz"])
            check_type(argname="argument fuzz_var", value=fuzz_var, expected_type=type_hints["fuzz_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fuzz is not None:
            self._values["fuzz"] = fuzz
        if fuzz_var is not None:
            self._values["fuzz_var"] = fuzz_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var

    @builtins.property
    def fuzz(self) -> typing.Optional[builtins.str]:
        '''The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz DataAkamaiImagingPolicyImage#fuzz}
        '''
        result = self._values.get("fuzz")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fuzz_var(self) -> typing.Optional[builtins.str]:
        '''The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz_var DataAkamaiImagingPolicyImage#fuzz_var}
        '''
        result = self._values.get("fuzz_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''The amount of padding in pixels to add to the trimmed image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''The amount of padding in pixels to add to the trimmed image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualTrim(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualTrimList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualTrimList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6c05070efe056c1e69f5722ee81cc3998cbd3d60a337554a1b780082d8415cf9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualTrimOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4efe365aace428f5544cf37388e6d36e031a0f43e6347583b39b586e63366c06)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualTrimOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4d2dc10270045efd708c846fafbef081503485bc775b49ef92269af7bfda6fec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6b255344166ee474e8411f29ea0a698d526955f9c7873471761fe5074a29b5d4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__063101cdca53abafb4ed5dffd921ad61eb0067ccce3bef060ee285852feab6ea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualTrim]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualTrim]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualTrim]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ee81bf979bc8bfc423948e87dddc3047793bbc1ce4d23547f464a1ef854ac4e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualTrimOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualTrimOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__090b50aa78d9a6eb0cda151a6f39c0286ef3ad845c06cb15b6b131a704f90d6a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetFuzz")
    def reset_fuzz(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFuzz", []))

    @jsii.member(jsii_name="resetFuzzVar")
    def reset_fuzz_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFuzzVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @builtins.property
    @jsii.member(jsii_name="fuzzInput")
    def fuzz_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fuzzInput"))

    @builtins.property
    @jsii.member(jsii_name="fuzzVarInput")
    def fuzz_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fuzzVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="fuzz")
    def fuzz(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fuzz"))

    @fuzz.setter
    def fuzz(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__22ac5937777f90f575c28ae69067c6d4c5e939e583f943697c98198fa368934c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fuzz", value)

    @builtins.property
    @jsii.member(jsii_name="fuzzVar")
    def fuzz_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fuzzVar"))

    @fuzz_var.setter
    def fuzz_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8b41fd8a7696610e51884a5ede20956a932748954e068a88db74f152a84762a6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fuzzVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d891d314716e5f08d09737839e0434800d3e7e6dbf165df254c5017f248072db)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__060c5b963d3e4f1c6f012df8f63932503191ce0e84650a4df31628d732eb42c0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualTrim]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualTrim]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualTrim]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0b3fedd5f124fe901919e0273d3774b0f182c0e69e25f670b7835aadbe491fa1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualUnsharpMask",
    jsii_struct_bases=[],
    name_mapping={
        "gain": "gain",
        "gain_var": "gainVar",
        "sigma": "sigma",
        "sigma_var": "sigmaVar",
        "threshold": "threshold",
        "threshold_var": "thresholdVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualUnsharpMask:
    def __init__(
        self,
        *,
        gain: typing.Optional[builtins.str] = None,
        gain_var: typing.Optional[builtins.str] = None,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
        threshold: typing.Optional[builtins.str] = None,
        threshold_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param gain: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        :param gain_var: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        :param sigma: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        :param threshold: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        :param threshold_var: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__76e979c96a54edda20ccd8ce0b83778d847d2437d19fcfd1e71f6943befd2369)
            check_type(argname="argument gain", value=gain, expected_type=type_hints["gain"])
            check_type(argname="argument gain_var", value=gain_var, expected_type=type_hints["gain_var"])
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
            check_type(argname="argument threshold", value=threshold, expected_type=type_hints["threshold"])
            check_type(argname="argument threshold_var", value=threshold_var, expected_type=type_hints["threshold_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if gain is not None:
            self._values["gain"] = gain
        if gain_var is not None:
            self._values["gain_var"] = gain_var
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var
        if threshold is not None:
            self._values["threshold"] = threshold
        if threshold_var is not None:
            self._values["threshold_var"] = threshold_var

    @builtins.property
    def gain(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        '''
        result = self._values.get("gain")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gain_var(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        '''
        result = self._values.get("gain_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        '''
        result = self._values.get("threshold")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold_var(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        result = self._values.get("threshold_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualUnsharpMask(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualUnsharpMaskList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualUnsharpMaskList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a34b3bd95c274a15ad24644a5c6dc9d84e7da34c9614da0604f253156ba7d72)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualUnsharpMaskOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3510f9bd289c28a1caa7719af61f42131c50a6d8b9150858b98895c6be5e7f01)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualUnsharpMaskOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9de5efec400f49ed7058714cd242ae2bdabbd4bb58b39c1af37fdf55c33ccaa7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a3916d8b1cd4c3f807e87174e691a52b1d1a773fbc1d9e0134e43b84797f673e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a6f9d664a51d5927428d83f087ba84401a8e74bc372d3badb8e4c9775d6cecc7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualUnsharpMask]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualUnsharpMask]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualUnsharpMask]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9f963c1e247d96a2118ca7c103783e4af0a1b4ce434942f7f4a6184f963010ab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualUnsharpMaskOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualUnsharpMaskOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1b99b123d8f41713900742b1bb541578d33c895f1a7f4b2fff26eda0dc15586a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetGain")
    def reset_gain(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGain", []))

    @jsii.member(jsii_name="resetGainVar")
    def reset_gain_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGainVar", []))

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @jsii.member(jsii_name="resetThreshold")
    def reset_threshold(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThreshold", []))

    @jsii.member(jsii_name="resetThresholdVar")
    def reset_threshold_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThresholdVar", []))

    @builtins.property
    @jsii.member(jsii_name="gainInput")
    def gain_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainInput"))

    @builtins.property
    @jsii.member(jsii_name="gainVarInput")
    def gain_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdInput")
    def threshold_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdVarInput")
    def threshold_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gain")
    def gain(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gain"))

    @gain.setter
    def gain(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6c70102a4c0ac80afc39384ca88da732a9950c10c0856ea3f711036504364f45)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gain", value)

    @builtins.property
    @jsii.member(jsii_name="gainVar")
    def gain_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gainVar"))

    @gain_var.setter
    def gain_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7f1f06b986d68c8d28612df2eaef452eca369de0c56760da7b4fccb514db039a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gainVar", value)

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fd79794988893dce74ef74337c81c44f742fdcd5b139119015361973cd32053e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__645fb605b969f0ee53e72a7aa180d3fe12632ee652623100a547d84defd0314a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="threshold")
    def threshold(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "threshold"))

    @threshold.setter
    def threshold(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a8b8af8141af5e10f4f03e35c86c3eda28fd56ad0e61b78771f91ca736751efb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "threshold", value)

    @builtins.property
    @jsii.member(jsii_name="thresholdVar")
    def threshold_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "thresholdVar"))

    @threshold_var.setter
    def threshold_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ec6c5e4a219310e230103787545721641a7bf11b307f396b104dde6f0f66146)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "thresholdVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualUnsharpMask]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualUnsharpMask]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualUnsharpMask]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8e48258bcc134b236db71992e3f8f611061c5376d3f651f8e0c6e9cdc55203a6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThan",
    jsii_struct_bases=[],
    name_mapping={
        "append": "append",
        "aspect_crop": "aspectCrop",
        "background_color": "backgroundColor",
        "blur": "blur",
        "chroma_key": "chromaKey",
        "composite": "composite",
        "compound": "compound",
        "contrast": "contrast",
        "crop": "crop",
        "face_crop": "faceCrop",
        "feature_crop": "featureCrop",
        "fit_and_fill": "fitAndFill",
        "goop": "goop",
        "grayscale": "grayscale",
        "hsl": "hsl",
        "hsv": "hsv",
        "if_dimension": "ifDimension",
        "if_orientation": "ifOrientation",
        "im_query": "imQuery",
        "max_colors": "maxColors",
        "mirror": "mirror",
        "mono_hue": "monoHue",
        "opacity": "opacity",
        "region_of_interest_crop": "regionOfInterestCrop",
        "relative_crop": "relativeCrop",
        "remove_color": "removeColor",
        "resize": "resize",
        "rotate": "rotate",
        "scale": "scale",
        "shear": "shear",
        "trim": "trim",
        "unsharp_mask": "unsharpMask",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThan:
    def __init__(
        self,
        *,
        append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanAppend", typing.Dict[builtins.str, typing.Any]]]]] = None,
        aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanAspectCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanBackgroundColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanBlur", typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanChromaKey", typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanComposite", typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanCompound", typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanContrast", typing.Dict[builtins.str, typing.Any]]]]] = None,
        crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanFaceCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanFeatureCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanFitAndFill", typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanGoop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanGrayscale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanHsl", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanHsv", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimension", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientation", typing.Dict[builtins.str, typing.Any]]]]] = None,
        im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanImQuery", typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanMaxColors", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanMirror", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanMonoHue", typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanOpacity", typing.Dict[builtins.str, typing.Any]]]]] = None,
        region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanRegionOfInterestCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanRelativeCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanRemoveColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanResize", typing.Dict[builtins.str, typing.Any]]]]] = None,
        rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanRotate", typing.Dict[builtins.str, typing.Any]]]]] = None,
        scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanScale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanShear", typing.Dict[builtins.str, typing.Any]]]]] = None,
        trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanTrim", typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanUnsharpMask", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param append: append block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        :param aspect_crop: aspect_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param crop: crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        :param face_crop: face_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        :param feature_crop: feature_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        :param fit_and_fill: fit_and_fill block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param im_query: im_query block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param region_of_interest_crop: region_of_interest_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        :param relative_crop: relative_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param resize: resize block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        :param rotate: rotate block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        :param scale: scale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param shear: shear block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        :param trim: trim block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5fd6dfd038f9ed8f2edb29ce3d0f9581ea429c66a966d51ef32c7ca71f8d483d)
            check_type(argname="argument append", value=append, expected_type=type_hints["append"])
            check_type(argname="argument aspect_crop", value=aspect_crop, expected_type=type_hints["aspect_crop"])
            check_type(argname="argument background_color", value=background_color, expected_type=type_hints["background_color"])
            check_type(argname="argument blur", value=blur, expected_type=type_hints["blur"])
            check_type(argname="argument chroma_key", value=chroma_key, expected_type=type_hints["chroma_key"])
            check_type(argname="argument composite", value=composite, expected_type=type_hints["composite"])
            check_type(argname="argument compound", value=compound, expected_type=type_hints["compound"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument crop", value=crop, expected_type=type_hints["crop"])
            check_type(argname="argument face_crop", value=face_crop, expected_type=type_hints["face_crop"])
            check_type(argname="argument feature_crop", value=feature_crop, expected_type=type_hints["feature_crop"])
            check_type(argname="argument fit_and_fill", value=fit_and_fill, expected_type=type_hints["fit_and_fill"])
            check_type(argname="argument goop", value=goop, expected_type=type_hints["goop"])
            check_type(argname="argument grayscale", value=grayscale, expected_type=type_hints["grayscale"])
            check_type(argname="argument hsl", value=hsl, expected_type=type_hints["hsl"])
            check_type(argname="argument hsv", value=hsv, expected_type=type_hints["hsv"])
            check_type(argname="argument if_dimension", value=if_dimension, expected_type=type_hints["if_dimension"])
            check_type(argname="argument if_orientation", value=if_orientation, expected_type=type_hints["if_orientation"])
            check_type(argname="argument im_query", value=im_query, expected_type=type_hints["im_query"])
            check_type(argname="argument max_colors", value=max_colors, expected_type=type_hints["max_colors"])
            check_type(argname="argument mirror", value=mirror, expected_type=type_hints["mirror"])
            check_type(argname="argument mono_hue", value=mono_hue, expected_type=type_hints["mono_hue"])
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument region_of_interest_crop", value=region_of_interest_crop, expected_type=type_hints["region_of_interest_crop"])
            check_type(argname="argument relative_crop", value=relative_crop, expected_type=type_hints["relative_crop"])
            check_type(argname="argument remove_color", value=remove_color, expected_type=type_hints["remove_color"])
            check_type(argname="argument resize", value=resize, expected_type=type_hints["resize"])
            check_type(argname="argument rotate", value=rotate, expected_type=type_hints["rotate"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument shear", value=shear, expected_type=type_hints["shear"])
            check_type(argname="argument trim", value=trim, expected_type=type_hints["trim"])
            check_type(argname="argument unsharp_mask", value=unsharp_mask, expected_type=type_hints["unsharp_mask"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if append is not None:
            self._values["append"] = append
        if aspect_crop is not None:
            self._values["aspect_crop"] = aspect_crop
        if background_color is not None:
            self._values["background_color"] = background_color
        if blur is not None:
            self._values["blur"] = blur
        if chroma_key is not None:
            self._values["chroma_key"] = chroma_key
        if composite is not None:
            self._values["composite"] = composite
        if compound is not None:
            self._values["compound"] = compound
        if contrast is not None:
            self._values["contrast"] = contrast
        if crop is not None:
            self._values["crop"] = crop
        if face_crop is not None:
            self._values["face_crop"] = face_crop
        if feature_crop is not None:
            self._values["feature_crop"] = feature_crop
        if fit_and_fill is not None:
            self._values["fit_and_fill"] = fit_and_fill
        if goop is not None:
            self._values["goop"] = goop
        if grayscale is not None:
            self._values["grayscale"] = grayscale
        if hsl is not None:
            self._values["hsl"] = hsl
        if hsv is not None:
            self._values["hsv"] = hsv
        if if_dimension is not None:
            self._values["if_dimension"] = if_dimension
        if if_orientation is not None:
            self._values["if_orientation"] = if_orientation
        if im_query is not None:
            self._values["im_query"] = im_query
        if max_colors is not None:
            self._values["max_colors"] = max_colors
        if mirror is not None:
            self._values["mirror"] = mirror
        if mono_hue is not None:
            self._values["mono_hue"] = mono_hue
        if opacity is not None:
            self._values["opacity"] = opacity
        if region_of_interest_crop is not None:
            self._values["region_of_interest_crop"] = region_of_interest_crop
        if relative_crop is not None:
            self._values["relative_crop"] = relative_crop
        if remove_color is not None:
            self._values["remove_color"] = remove_color
        if resize is not None:
            self._values["resize"] = resize
        if rotate is not None:
            self._values["rotate"] = rotate
        if scale is not None:
            self._values["scale"] = scale
        if shear is not None:
            self._values["shear"] = shear
        if trim is not None:
            self._values["trim"] = trim
        if unsharp_mask is not None:
            self._values["unsharp_mask"] = unsharp_mask

    @builtins.property
    def append(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanAppend"]]]:
        '''append block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        '''
        result = self._values.get("append")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanAppend"]]], result)

    @builtins.property
    def aspect_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanAspectCrop"]]]:
        '''aspect_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        '''
        result = self._values.get("aspect_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanAspectCrop"]]], result)

    @builtins.property
    def background_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanBackgroundColor"]]]:
        '''background_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        '''
        result = self._values.get("background_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanBackgroundColor"]]], result)

    @builtins.property
    def blur(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanBlur"]]]:
        '''blur block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        '''
        result = self._values.get("blur")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanBlur"]]], result)

    @builtins.property
    def chroma_key(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanChromaKey"]]]:
        '''chroma_key block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        '''
        result = self._values.get("chroma_key")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanChromaKey"]]], result)

    @builtins.property
    def composite(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanComposite"]]]:
        '''composite block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        '''
        result = self._values.get("composite")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanComposite"]]], result)

    @builtins.property
    def compound(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanCompound"]]]:
        '''compound block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        '''
        result = self._values.get("compound")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanCompound"]]], result)

    @builtins.property
    def contrast(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanContrast"]]]:
        '''contrast block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanContrast"]]], result)

    @builtins.property
    def crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanCrop"]]]:
        '''crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        '''
        result = self._values.get("crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanCrop"]]], result)

    @builtins.property
    def face_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanFaceCrop"]]]:
        '''face_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        '''
        result = self._values.get("face_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanFaceCrop"]]], result)

    @builtins.property
    def feature_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanFeatureCrop"]]]:
        '''feature_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        '''
        result = self._values.get("feature_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanFeatureCrop"]]], result)

    @builtins.property
    def fit_and_fill(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanFitAndFill"]]]:
        '''fit_and_fill block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        '''
        result = self._values.get("fit_and_fill")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanFitAndFill"]]], result)

    @builtins.property
    def goop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanGoop"]]]:
        '''goop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        '''
        result = self._values.get("goop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanGoop"]]], result)

    @builtins.property
    def grayscale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanGrayscale"]]]:
        '''grayscale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        '''
        result = self._values.get("grayscale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanGrayscale"]]], result)

    @builtins.property
    def hsl(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanHsl"]]]:
        '''hsl block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        '''
        result = self._values.get("hsl")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanHsl"]]], result)

    @builtins.property
    def hsv(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanHsv"]]]:
        '''hsv block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        '''
        result = self._values.get("hsv")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanHsv"]]], result)

    @builtins.property
    def if_dimension(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimension"]]]:
        '''if_dimension block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        '''
        result = self._values.get("if_dimension")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimension"]]], result)

    @builtins.property
    def if_orientation(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientation"]]]:
        '''if_orientation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        '''
        result = self._values.get("if_orientation")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientation"]]], result)

    @builtins.property
    def im_query(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanImQuery"]]]:
        '''im_query block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        '''
        result = self._values.get("im_query")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanImQuery"]]], result)

    @builtins.property
    def max_colors(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanMaxColors"]]]:
        '''max_colors block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        '''
        result = self._values.get("max_colors")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanMaxColors"]]], result)

    @builtins.property
    def mirror(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanMirror"]]]:
        '''mirror block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        '''
        result = self._values.get("mirror")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanMirror"]]], result)

    @builtins.property
    def mono_hue(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanMonoHue"]]]:
        '''mono_hue block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        '''
        result = self._values.get("mono_hue")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanMonoHue"]]], result)

    @builtins.property
    def opacity(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanOpacity"]]]:
        '''opacity block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanOpacity"]]], result)

    @builtins.property
    def region_of_interest_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanRegionOfInterestCrop"]]]:
        '''region_of_interest_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        '''
        result = self._values.get("region_of_interest_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanRegionOfInterestCrop"]]], result)

    @builtins.property
    def relative_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanRelativeCrop"]]]:
        '''relative_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        '''
        result = self._values.get("relative_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanRelativeCrop"]]], result)

    @builtins.property
    def remove_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanRemoveColor"]]]:
        '''remove_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        '''
        result = self._values.get("remove_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanRemoveColor"]]], result)

    @builtins.property
    def resize(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanResize"]]]:
        '''resize block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        '''
        result = self._values.get("resize")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanResize"]]], result)

    @builtins.property
    def rotate(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanRotate"]]]:
        '''rotate block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        '''
        result = self._values.get("rotate")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanRotate"]]], result)

    @builtins.property
    def scale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanScale"]]]:
        '''scale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanScale"]]], result)

    @builtins.property
    def shear(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanShear"]]]:
        '''shear block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        '''
        result = self._values.get("shear")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanShear"]]], result)

    @builtins.property
    def trim(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanTrim"]]]:
        '''trim block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        '''
        result = self._values.get("trim")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanTrim"]]], result)

    @builtins.property
    def unsharp_mask(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanUnsharpMask"]]]:
        '''unsharp_mask block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        result = self._values.get("unsharp_mask")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanUnsharpMask"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanAppend",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_priority": "gravityPriority",
        "gravity_priority_var": "gravityPriorityVar",
        "gravity_var": "gravityVar",
        "preserve_minor_dimension": "preserveMinorDimension",
        "preserve_minor_dimension_var": "preserveMinorDimensionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanAppend:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanAppendImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_priority: typing.Optional[builtins.str] = None,
        gravity_priority_var: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        preserve_minor_dimension: typing.Optional[builtins.str] = None,
        preserve_minor_dimension_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Specifies where to place the ``image`` relative to the source image. The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_priority: Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal. The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority DataAkamaiImagingPolicyImage#gravity_priority}
        :param gravity_priority_var: Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal. The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority_var DataAkamaiImagingPolicyImage#gravity_priority_var}
        :param gravity_var: Specifies where to place the ``image`` relative to the source image. The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param preserve_minor_dimension: Whether to preserve the source image's minor dimension, ``false`` by default. The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension DataAkamaiImagingPolicyImage#preserve_minor_dimension}
        :param preserve_minor_dimension_var: Whether to preserve the source image's minor dimension, ``false`` by default. The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension_var DataAkamaiImagingPolicyImage#preserve_minor_dimension_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanAppendImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e8a3bba8791218e4882ea9bd9f1342f7e124a42762a8821c3816fcfe1f751cb9)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_priority", value=gravity_priority, expected_type=type_hints["gravity_priority"])
            check_type(argname="argument gravity_priority_var", value=gravity_priority_var, expected_type=type_hints["gravity_priority_var"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument preserve_minor_dimension", value=preserve_minor_dimension, expected_type=type_hints["preserve_minor_dimension"])
            check_type(argname="argument preserve_minor_dimension_var", value=preserve_minor_dimension_var, expected_type=type_hints["preserve_minor_dimension_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_priority is not None:
            self._values["gravity_priority"] = gravity_priority
        if gravity_priority_var is not None:
            self._values["gravity_priority_var"] = gravity_priority_var
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if preserve_minor_dimension is not None:
            self._values["preserve_minor_dimension"] = preserve_minor_dimension
        if preserve_minor_dimension_var is not None:
            self._values["preserve_minor_dimension_var"] = preserve_minor_dimension_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanAppendImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanAppendImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Specifies where to place the ``image`` relative to the source image.

        The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_priority(self) -> typing.Optional[builtins.str]:
        '''Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal.

        The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority DataAkamaiImagingPolicyImage#gravity_priority}
        '''
        result = self._values.get("gravity_priority")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_priority_var(self) -> typing.Optional[builtins.str]:
        '''Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal.

        The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority_var DataAkamaiImagingPolicyImage#gravity_priority_var}
        '''
        result = self._values.get("gravity_priority_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Specifies where to place the ``image`` relative to the source image.

        The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def preserve_minor_dimension(self) -> typing.Optional[builtins.str]:
        '''Whether to preserve the source image's minor dimension, ``false`` by default.

        The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension DataAkamaiImagingPolicyImage#preserve_minor_dimension}
        '''
        result = self._values.get("preserve_minor_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def preserve_minor_dimension_var(self) -> typing.Optional[builtins.str]:
        '''Whether to preserve the source image's minor dimension, ``false`` by default.

        The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension_var DataAkamaiImagingPolicyImage#preserve_minor_dimension_var}
        '''
        result = self._values.get("preserve_minor_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanAppend(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanAppendImage",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanAppendImage:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanAppendImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanAppendImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanAppendImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__757c2dee352eb3b8ff323e87bc7a466e0bedf11013c455b3b7a43a76fd348ce2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanAppendImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanAppendImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanAppendImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1088c6af4697a484a76a97c2fe1bdfcb2ba10ee5c4133b9acd29a49da22be7a6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanAppendList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanAppendList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9e2a0c015b66b1450993bccbc4f41e0270c141f77c000966d87eca38e40cbc6d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanAppendOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__369c21939312c6ea0daf7bd312f59204054fb0bc899509f401b58cb835e11a9c)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanAppendOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__890488b748d0891ee92deaaac8befc7678f17846c68e24b135fa14d5731f1862)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e7b6523d8d68eb908b6888d64713701c6ede4137b9948999dd1400804e15b9e7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__60f2d2f0207663fcee0fc02ce21ac6e18a6491f15ce6a374c445b9ad68626ec6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanAppend]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanAppend]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanAppend]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9da42cb5cd3c374780d3b269995185117ddd3af9c476fe3e357ba43d633a58bb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanAppendOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanAppendOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a651fde50e9783e0987f091a99de994e10373d4ff1b564d8422fe08e1d486733)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanAppendImage()

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityPriority")
    def reset_gravity_priority(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityPriority", []))

    @jsii.member(jsii_name="resetGravityPriorityVar")
    def reset_gravity_priority_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityPriorityVar", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPreserveMinorDimension")
    def reset_preserve_minor_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPreserveMinorDimension", []))

    @jsii.member(jsii_name="resetPreserveMinorDimensionVar")
    def reset_preserve_minor_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPreserveMinorDimensionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanAppendImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanAppendImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityInput")
    def gravity_priority_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityPriorityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityVarInput")
    def gravity_priority_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityPriorityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanAppendImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanAppendImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionInput")
    def preserve_minor_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "preserveMinorDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionVarInput")
    def preserve_minor_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "preserveMinorDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3b17e85c77995949fdd54140f490ffaad5432b50df2c077fcf106b8e386ff39c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityPriority")
    def gravity_priority(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityPriority"))

    @gravity_priority.setter
    def gravity_priority(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ff7eeff0baf1bbf2c02c675e276cd055bf08215a720e15326954a1dc3b55c6ba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityPriority", value)

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityVar")
    def gravity_priority_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityPriorityVar"))

    @gravity_priority_var.setter
    def gravity_priority_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b2527e61a4007e434902c6578edd511e2232f396a826f7b942822803d792a286)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityPriorityVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ca3cf0f29f06c2bd6f1c0219feb26651de312ee24f98d8cb75e7a458889d8096)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimension")
    def preserve_minor_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "preserveMinorDimension"))

    @preserve_minor_dimension.setter
    def preserve_minor_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__58bd11b263420977cfb330e74dc0dbf4b996120a142749bad05e0a504d1a3cea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "preserveMinorDimension", value)

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionVar")
    def preserve_minor_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "preserveMinorDimensionVar"))

    @preserve_minor_dimension_var.setter
    def preserve_minor_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fb3df79d4f2d0af5d69364fb84aac19891d914718f32fd87f44964bad4998e39)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "preserveMinorDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanAppend]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanAppend]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanAppend]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__964675493e81712f6a524b75a6480a73507e10e1a884a38881bebcb69a3b9e7b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanAspectCrop",
    jsii_struct_bases=[],
    name_mapping={
        "allow_expansion": "allowExpansion",
        "allow_expansion_var": "allowExpansionVar",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanAspectCrop:
    def __init__(
        self,
        *,
        allow_expansion: typing.Optional[builtins.str] = None,
        allow_expansion_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_expansion: Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image. Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        :param allow_expansion_var: Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image. Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        :param height: The height term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The width term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        :param x_position: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9659a97a34cda4d03d574bf120d3f6b8a81c3c77336f1f44de732d9ad1b85e99)
            check_type(argname="argument allow_expansion", value=allow_expansion, expected_type=type_hints["allow_expansion"])
            check_type(argname="argument allow_expansion_var", value=allow_expansion_var, expected_type=type_hints["allow_expansion_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if allow_expansion is not None:
            self._values["allow_expansion"] = allow_expansion
        if allow_expansion_var is not None:
            self._values["allow_expansion_var"] = allow_expansion_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def allow_expansion(self) -> typing.Optional[builtins.str]:
        '''Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image.

        Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        '''
        result = self._values.get("allow_expansion")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def allow_expansion_var(self) -> typing.Optional[builtins.str]:
        '''Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image.

        Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        '''
        result = self._values.get("allow_expansion_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanAspectCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanAspectCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanAspectCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd30f4c0fcac4d4b8ed84d152cb395622337caa4029f84880462db8a7a8f4b57)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanAspectCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb39aa182ed2e9d8d548a9ce3996438e68dc90223956502c4be103a1f9a1aac0)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanAspectCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__877a2a7de7862d307c809fcf78fd209d34c361fb07758394e4681cc67717dc7c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__66e23f1a112e848b3eee5572c8e7df363f91308625c8343b74b92fef20c2973c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__77390c2b27a1c14bcebeef093b100e266b1da306605f4e6a58c6efb40837067c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanAspectCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanAspectCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanAspectCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4cb2833011b9ae6cd047d64d5e85af65a3454b7c491d7b3192d1ea24493691f2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanAspectCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanAspectCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ce83f15fb1551aa1f67c09bd77430a109d3206f3af8a74f276215780e986f4b6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAllowExpansion")
    def reset_allow_expansion(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansion", []))

    @jsii.member(jsii_name="resetAllowExpansionVar")
    def reset_allow_expansion_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansionVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionInput")
    def allow_expansion_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVarInput")
    def allow_expansion_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansion")
    def allow_expansion(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansion"))

    @allow_expansion.setter
    def allow_expansion(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__17d5764f02a9e19da46c2f23658e3129373f3315c40e2ef68c5d2c5873296ea6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansion", value)

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVar")
    def allow_expansion_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansionVar"))

    @allow_expansion_var.setter
    def allow_expansion_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__942ed1fa3d09e0f3e01ca5091ede1c17742aeb3ac8801282f9e431ae3c562c31)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansionVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__51c3139f6118e236eb590817c1bf3e3284154235902d34ab236372a1bf2055ae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__de109b153a36200afeca71fca6411e38d7af14f69370399ce195cb8fc151cdbd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__995ec40b3da64bab7dd9b7885870ac06e8ce77834710f4567c9e2eed5f6c0f07)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9370fcdf332c16c09ef177db06459fd01c95b0df67b297ed15a3b9d45b06d024)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d11b5a531cdc4502a6733485c1542eb3c00af8e25918058e0142ef9e240516c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dad1dfeb0f139874e01827972e71873b9ff8ebc2b0a2ab5add8eabf5b6d27e8c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5c04f8a10451b21d2b7ee39dec544b855d9cd33532ea7b9e5d4a3046214b8fb2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea79854e17a21784eb7ca1ed4f52f08c9fd45cd07858a75ea85426a8b2f071e3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanAspectCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanAspectCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanAspectCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a39db112767c8eeb817858e06fcb42a20ee216bfd30a356e9012e11dd2f7b58)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanBackgroundColor",
    jsii_struct_bases=[],
    name_mapping={"color": "color", "color_var": "colorVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanBackgroundColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e463188d6bbb8fc0bb2a7044cde5cff712e6785307f9c7a960509a100b821c22)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanBackgroundColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanBackgroundColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanBackgroundColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__daf9cdc4b2abc89133f1f3193e3bdab8e3907b4b0035d1e116ceebe59054acb3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanBackgroundColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__21498f153f6088e8771b9173a5150dcecc75e671988c3ba0fb0c4809e63e26e9)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanBackgroundColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__01d9011558cade372300cf8fe73d7977dde0644175360681d2c8c482c7a149a0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7409d3ee60a55318c116b70ccc9d4a4abc36ed8c7775948507adda43ae0feaa5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7b44953cd84a8e9045c14ce02904cfad37259f68768d72dc93586bab9e5072ad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanBackgroundColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanBackgroundColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e08b7114de66b06c944d8ffbe89b6aeae97f769070031e3df87e6f77ebc54024)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanBackgroundColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanBackgroundColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__77fa0ac548f8e83f8412a32eae88a9d1bcd5af2d235f608342d40bcf4b78c0b3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__078124d19b3c0b842d237125afe49a7b3563a9efacf8633fef17b13215756aed)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ab8ea431bd050d25aba6cf1ba1a626372df71a3742c1b12bb9d547b7a9431ea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanBackgroundColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanBackgroundColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanBackgroundColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3cba79ab1a86026cda76f697c892761a7b0847aa42cc14c6a93d9723a2d0457d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanBlur",
    jsii_struct_bases=[],
    name_mapping={"sigma": "sigma", "sigma_var": "sigmaVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanBlur:
    def __init__(
        self,
        *,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param sigma: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__defd574deb7b9b04790a0d0a80bc845d076e109dfdaa2078e2aad501cb879d18)
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanBlur(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanBlurList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanBlurList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eaf963b168c1d77b49dab7353268bcc2a0100d4866aca6d20dbdcda489219a04)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanBlurOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dbc33e896d5d82244efcc69090e7c6e61c1484d05172e1f92f00f5d5aa0401a7)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanBlurOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fcb6e997aad70e95493d755257919708d9b24505f0baef5d02242bf6f2fc555c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5709d8290f468b26bc0cf4f7ef4be2654aeb2cc1703219f1e086ac7e1c36d45e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__26cba16f1af1bcae6aad73d2e5f36f71c54256960c4c2fff1d5082934139050d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanBlur]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanBlur]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ef8f32acfe3368b8314c277530f1df2697a061f6251d8692448d68837ed16b66)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanBlurOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanBlurOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__51b33f77fe529d0fab3febffaa2cfee431a073bfad0c1e2cad27d7f13cb819db)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bff8ac3310717c49e187d3cfc0abd80dbfcbd5db30fcdf45d881da490ab24877)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cb48f202c9a1f536c40d6fa176afe244f06fcac8fa8cb2ff3a7fb12a45af4f6c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanBlur]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanBlur]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanBlur]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3f84a5a4e1df37c8fec31bfc7c545ddcdcc3711fdf118b79fefe0b46d55424b6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanChromaKey",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_feather": "hueFeather",
        "hue_feather_var": "hueFeatherVar",
        "hue_tolerance": "hueTolerance",
        "hue_tolerance_var": "hueToleranceVar",
        "hue_var": "hueVar",
        "lightness_feather": "lightnessFeather",
        "lightness_feather_var": "lightnessFeatherVar",
        "lightness_tolerance": "lightnessTolerance",
        "lightness_tolerance_var": "lightnessToleranceVar",
        "saturation_feather": "saturationFeather",
        "saturation_feather_var": "saturationFeatherVar",
        "saturation_tolerance": "saturationTolerance",
        "saturation_tolerance_var": "saturationToleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanChromaKey:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_feather: typing.Optional[builtins.str] = None,
        hue_feather_var: typing.Optional[builtins.str] = None,
        hue_tolerance: typing.Optional[builtins.str] = None,
        hue_tolerance_var: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness_feather: typing.Optional[builtins.str] = None,
        lightness_feather_var: typing.Optional[builtins.str] = None,
        lightness_tolerance: typing.Optional[builtins.str] = None,
        lightness_tolerance_var: typing.Optional[builtins.str] = None,
        saturation_feather: typing.Optional[builtins.str] = None,
        saturation_feather_var: typing.Optional[builtins.str] = None,
        saturation_tolerance: typing.Optional[builtins.str] = None,
        saturation_tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_feather: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        :param hue_feather_var: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        :param hue_tolerance: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        :param hue_tolerance_var: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        :param hue_var: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness_feather: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        :param lightness_feather_var: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        :param lightness_tolerance: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        :param lightness_tolerance_var: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        :param saturation_feather: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        :param saturation_feather_var: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        :param saturation_tolerance: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        :param saturation_tolerance_var: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b950b02f029485c663ed3edd01adae75acbf2e62888b467049471442aa360347)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_feather", value=hue_feather, expected_type=type_hints["hue_feather"])
            check_type(argname="argument hue_feather_var", value=hue_feather_var, expected_type=type_hints["hue_feather_var"])
            check_type(argname="argument hue_tolerance", value=hue_tolerance, expected_type=type_hints["hue_tolerance"])
            check_type(argname="argument hue_tolerance_var", value=hue_tolerance_var, expected_type=type_hints["hue_tolerance_var"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness_feather", value=lightness_feather, expected_type=type_hints["lightness_feather"])
            check_type(argname="argument lightness_feather_var", value=lightness_feather_var, expected_type=type_hints["lightness_feather_var"])
            check_type(argname="argument lightness_tolerance", value=lightness_tolerance, expected_type=type_hints["lightness_tolerance"])
            check_type(argname="argument lightness_tolerance_var", value=lightness_tolerance_var, expected_type=type_hints["lightness_tolerance_var"])
            check_type(argname="argument saturation_feather", value=saturation_feather, expected_type=type_hints["saturation_feather"])
            check_type(argname="argument saturation_feather_var", value=saturation_feather_var, expected_type=type_hints["saturation_feather_var"])
            check_type(argname="argument saturation_tolerance", value=saturation_tolerance, expected_type=type_hints["saturation_tolerance"])
            check_type(argname="argument saturation_tolerance_var", value=saturation_tolerance_var, expected_type=type_hints["saturation_tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_feather is not None:
            self._values["hue_feather"] = hue_feather
        if hue_feather_var is not None:
            self._values["hue_feather_var"] = hue_feather_var
        if hue_tolerance is not None:
            self._values["hue_tolerance"] = hue_tolerance
        if hue_tolerance_var is not None:
            self._values["hue_tolerance_var"] = hue_tolerance_var
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness_feather is not None:
            self._values["lightness_feather"] = lightness_feather
        if lightness_feather_var is not None:
            self._values["lightness_feather_var"] = lightness_feather_var
        if lightness_tolerance is not None:
            self._values["lightness_tolerance"] = lightness_tolerance
        if lightness_tolerance_var is not None:
            self._values["lightness_tolerance_var"] = lightness_tolerance_var
        if saturation_feather is not None:
            self._values["saturation_feather"] = saturation_feather
        if saturation_feather_var is not None:
            self._values["saturation_feather_var"] = saturation_feather_var
        if saturation_tolerance is not None:
            self._values["saturation_tolerance"] = saturation_tolerance
        if saturation_tolerance_var is not None:
            self._values["saturation_tolerance_var"] = saturation_tolerance_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        '''
        result = self._values.get("hue_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        '''
        result = self._values.get("hue_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        '''
        result = self._values.get("hue_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        '''
        result = self._values.get("hue_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        '''
        result = self._values.get("lightness_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        '''
        result = self._values.get("lightness_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        '''
        result = self._values.get("lightness_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        '''
        result = self._values.get("lightness_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        '''
        result = self._values.get("saturation_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        '''
        result = self._values.get("saturation_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        '''
        result = self._values.get("saturation_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        result = self._values.get("saturation_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanChromaKey(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanChromaKeyList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanChromaKeyList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7a902faee694f108f522c51eb064d8533817fa46955bb1f376c430b11d3793e6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanChromaKeyOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1516b9f6eb63b9ed98314516926bd50aa47e4695ae2bffb0fe2965fbed360bc5)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanChromaKeyOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__18d5d2430fe10ed1e2b8e6ea4e611ac43dd630a16cc8146f0fb1bdabcfc48f61)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__18de02cfb70c6f0fb030cee696eb1f7e0c37fa9ce0d16b27c6e0007eed22c519)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__299320d2973d911aa7bb5a9fbb4e4004ee4151456e4edb71229849b4dd3f9250)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanChromaKey]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanChromaKey]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__429d7d3a9e2e23ce3c49ad5f8eec54d3d158597b2705588e998c2e2b26081bc5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanChromaKeyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanChromaKeyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5e19b865adb8d89f5af3fe19b1c6c00dcc7ffaa8cbc5137b25ecd3fd989760f8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueFeather")
    def reset_hue_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeather", []))

    @jsii.member(jsii_name="resetHueFeatherVar")
    def reset_hue_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeatherVar", []))

    @jsii.member(jsii_name="resetHueTolerance")
    def reset_hue_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueTolerance", []))

    @jsii.member(jsii_name="resetHueToleranceVar")
    def reset_hue_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueToleranceVar", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightnessFeather")
    def reset_lightness_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeather", []))

    @jsii.member(jsii_name="resetLightnessFeatherVar")
    def reset_lightness_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeatherVar", []))

    @jsii.member(jsii_name="resetLightnessTolerance")
    def reset_lightness_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessTolerance", []))

    @jsii.member(jsii_name="resetLightnessToleranceVar")
    def reset_lightness_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessToleranceVar", []))

    @jsii.member(jsii_name="resetSaturationFeather")
    def reset_saturation_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeather", []))

    @jsii.member(jsii_name="resetSaturationFeatherVar")
    def reset_saturation_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeatherVar", []))

    @jsii.member(jsii_name="resetSaturationTolerance")
    def reset_saturation_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationTolerance", []))

    @jsii.member(jsii_name="resetSaturationToleranceVar")
    def reset_saturation_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherInput")
    def hue_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVarInput")
    def hue_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceInput")
    def hue_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVarInput")
    def hue_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherInput")
    def lightness_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVarInput")
    def lightness_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceInput")
    def lightness_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVarInput")
    def lightness_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherInput")
    def saturation_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVarInput")
    def saturation_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceInput")
    def saturation_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVarInput")
    def saturation_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__224470d5eed758ed2309551f150110269309cb350841911ce8a8473d5da11b0c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeather")
    def hue_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeather"))

    @hue_feather.setter
    def hue_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5526a6a6a27616dc1f6c2cdba25f687ff9d8b1ff32cf8443a8cb35f102a679ed)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeather", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVar")
    def hue_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeatherVar"))

    @hue_feather_var.setter
    def hue_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab8568a8f77b74391377e5865bec145312b3fec830992322214f13ad03cfccab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueTolerance")
    def hue_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueTolerance"))

    @hue_tolerance.setter
    def hue_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be107f3488bffcb8ca8a36f530fb791d33acb0e44c655d2fe128ae3003ffa2ec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVar")
    def hue_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueToleranceVar"))

    @hue_tolerance_var.setter
    def hue_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2fe0b12164c796ed884f522a2dd8cb84e78f0ea63aca072f22599e7428a5f232)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4260b4a5d48e8ad8b8e40d5072d79c0433507dd273d6f9216bcb41eae8c11586)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeather")
    def lightness_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeather"))

    @lightness_feather.setter
    def lightness_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__84c105d249fb0a503c1d5eb43cdb8e3c977530ac5db8f0aa16d4d025c7850b9a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeather", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVar")
    def lightness_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeatherVar"))

    @lightness_feather_var.setter
    def lightness_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0e6802c334f4d4bcf4f5a269d2e8810d37ba10e17c6b1830aec4c53b32a003d7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessTolerance")
    def lightness_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessTolerance"))

    @lightness_tolerance.setter
    def lightness_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b319018945e2c06462bb0f3227e4b15d0964cc2e4c941b67df38fd569cacfed2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVar")
    def lightness_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessToleranceVar"))

    @lightness_tolerance_var.setter
    def lightness_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a3e8e1ad4c759634f12c360eedad095671ac897e12abfc007bf062ebb485716)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeather")
    def saturation_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeather"))

    @saturation_feather.setter
    def saturation_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ded853b2aad89cd76a06d8f6bcdf8be85ddc5f5953d795197ea8c3271bae880e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeather", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVar")
    def saturation_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeatherVar"))

    @saturation_feather_var.setter
    def saturation_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ffecaccc57cb6b8bd74cba3d581e04ef573f57acd7a3f2135995d48b9326fb2d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationTolerance")
    def saturation_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationTolerance"))

    @saturation_tolerance.setter
    def saturation_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__49401c34c368078c08f1283b547ed35eaf840d888afc2490870423e5383a4af3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVar")
    def saturation_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationToleranceVar"))

    @saturation_tolerance_var.setter
    def saturation_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9c0ff81caebc2f447a409a136605a0ea2376c50cabaaa7657b07aa5e82fc3f87)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanChromaKey]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanChromaKey]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanChromaKey]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f0426f2d49d2bf34fcbc856005c16807978e7779ead4ed87a7442d285f2366c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanComposite",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "placement": "placement",
        "placement_var": "placementVar",
        "scale": "scale",
        "scale_dimension": "scaleDimension",
        "scale_dimension_var": "scaleDimensionVar",
        "scale_var": "scaleVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanComposite:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanCompositeImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        placement: typing.Optional[builtins.str] = None,
        placement_var: typing.Optional[builtins.str] = None,
        scale: typing.Optional[builtins.str] = None,
        scale_dimension: typing.Optional[builtins.str] = None,
        scale_dimension_var: typing.Optional[builtins.str] = None,
        scale_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param placement: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        :param placement_var: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        :param scale: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param scale_dimension: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        :param scale_dimension_var: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        :param scale_var: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        :param x_position: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanCompositeImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c470c5068a35c99a345a91556d04146fba8fea83a9952c033a821a2f6f8a0763)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument placement", value=placement, expected_type=type_hints["placement"])
            check_type(argname="argument placement_var", value=placement_var, expected_type=type_hints["placement_var"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument scale_dimension", value=scale_dimension, expected_type=type_hints["scale_dimension"])
            check_type(argname="argument scale_dimension_var", value=scale_dimension_var, expected_type=type_hints["scale_dimension_var"])
            check_type(argname="argument scale_var", value=scale_var, expected_type=type_hints["scale_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if placement is not None:
            self._values["placement"] = placement
        if placement_var is not None:
            self._values["placement_var"] = placement_var
        if scale is not None:
            self._values["scale"] = scale
        if scale_dimension is not None:
            self._values["scale_dimension"] = scale_dimension
        if scale_dimension_var is not None:
            self._values["scale_dimension_var"] = scale_dimension_var
        if scale_var is not None:
            self._values["scale_var"] = scale_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanCompositeImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanCompositeImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        '''
        result = self._values.get("placement")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement_var(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        '''
        result = self._values.get("placement_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        '''
        result = self._values.get("scale_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        '''
        result = self._values.get("scale_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        '''
        result = self._values.get("scale_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanComposite(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanCompositeImage",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanCompositeImage:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanCompositeImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanCompositeImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanCompositeImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ff7b0b9d992bc973159b83f50fb7b3f53ba5322a7a1b27b1a500b90cdc30b5f1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanCompositeImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanCompositeImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a25974e6139848defbdf3e99e69d54482ee5b2e1e1bcdda99834c58694e0fa84)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanCompositeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanCompositeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c99daed3a3bc6c2cd219f1eb80539de15cefe54a883ecf399ee1f6f2a0fe98c5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanCompositeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e1726cbce459b2ad7a928a9b574f29094b5075926dba59f75533aa3a071ce5c1)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanCompositeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ad0172df8905236c8445c2293195e492c275a6e7681d57159510e8e495ec7ff2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9f3ec5d35152bbc8d27c026fc5b845098110f757d03e42c06c960688193c9e1f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a94861ac825d716aadc18a9c689e4ef5a8bb68f49081321c77c23e343c8c4763)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanComposite]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanComposite]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ba86d0479e48546a166c8177221b1897735013d8fabd3791017cb0b5160dfd83)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanCompositeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanCompositeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f89b4aafe1d22a231538a04d6147482200ea976a8048b09f827abd3339f57124)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanCompositeImage()

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPlacement")
    def reset_placement(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacement", []))

    @jsii.member(jsii_name="resetPlacementVar")
    def reset_placement_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacementVar", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetScaleDimension")
    def reset_scale_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimension", []))

    @jsii.member(jsii_name="resetScaleDimensionVar")
    def reset_scale_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimensionVar", []))

    @jsii.member(jsii_name="resetScaleVar")
    def reset_scale_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanCompositeImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanCompositeImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanCompositeImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="placementInput")
    def placement_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementInput"))

    @builtins.property
    @jsii.member(jsii_name="placementVarInput")
    def placement_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionInput")
    def scale_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVarInput")
    def scale_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleVarInput")
    def scale_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a9f75e34a3e89333999db8e7617277f24a9533b0d08b2406339c359007335c9c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7fdf2ad62eeb3a03136740022c5668d22c99f159a509502b49ff2a41cb1f691f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="placement")
    def placement(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placement"))

    @placement.setter
    def placement(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7a8ee49250e1f91b58bcbcd495b49e831d399ef62abaf6e9d7358008e4b10165)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placement", value)

    @builtins.property
    @jsii.member(jsii_name="placementVar")
    def placement_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placementVar"))

    @placement_var.setter
    def placement_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3599af27e7bb49a530b3c4bb0535265c5799f435cf27bc854e15e4a1f0359b1e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placementVar", value)

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scale"))

    @scale.setter
    def scale(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__68a64fcd08a4c14e287cc6a367cd8a21cbf9a48334ae22af29e2b67ece4046d0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scale", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimension")
    def scale_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimension"))

    @scale_dimension.setter
    def scale_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f95b8df32bc2dbac0082f243fcbf7577c999d10d2fd62ea56578f911306a200)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimension", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVar")
    def scale_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimensionVar"))

    @scale_dimension_var.setter
    def scale_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__faf1019a8a632c46e2d32035ef5e2745a5b4dab4ba150ad0d718e4c5ecc0a30a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="scaleVar")
    def scale_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleVar"))

    @scale_var.setter
    def scale_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__531764d74f55f40ee862940fa6d43fd32a88408d5cc83d8ee7ad35350ab53405)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2e58925bf75ebcbea88c65135d7154c5f22100bac536fc9195a8c6a341913f60)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__801f9c7198615ad1f842af41fbfc26d7962550cc7bafe6bcd93b1c9e4ce6ecdb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__466b26dc8cd016402b1201ce5c82695e16f5c9106fc9fce66b300b4dbcb53d5a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f1c4b300a1cdc4aeb90ad8673c2ddd0d709fc1c9d8cba5ed18444cb749704fac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanComposite]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanComposite]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanComposite]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ec6624bccc0766e8ceeb792f77aae6f020cd74c4579e2f5959207571bf29510)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanCompound",
    jsii_struct_bases=[],
    name_mapping={"transformations": "transformations"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanCompound:
    def __init__(
        self,
        *,
        transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param transformations: transformations block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__69a9b662c80dcf28f7750fa378b8f807dd65fbb25a6756e287e71ce4f726e3f5)
            check_type(argname="argument transformations", value=transformations, expected_type=type_hints["transformations"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if transformations is not None:
            self._values["transformations"] = transformations

    @builtins.property
    def transformations(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanCompoundTransformations"]]]:
        '''transformations block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        result = self._values.get("transformations")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanCompoundTransformations"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanCompound(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanCompoundList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanCompoundList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__13130f6fae9cb123849d2d7ceac62aa40295e95cb804ca98da89fc4ffaaecd8f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanCompoundOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__266e6809fb0d25659b9ab3d8bacaec96fc694331f313233542dcc3d6ac32a498)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanCompoundOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__644c00ebbaa761890d22c5ffe474798c8c2bcc7031a2dbd2b26fe05a70511b70)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__108c5df7b8ad490df078010f8715cfafd72fc9e43095d1d6a8b4fdc6c23032b0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a86c0e56ea6b06953106e32a4193732937f3012d6cd58350f752bb10f2957975)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanCompound]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanCompound]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2e223085b03c29ed939256a634edb44868148284494427e9e0054a8f77ad11fa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanCompoundOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanCompoundOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__517cc6047336cf872b854c32323ae82750c4b38e07a41252f4812cc840981801)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformations")
    def put_transformations(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ef02d75ccfb6f39240bd6cdfdcf432240499b74146759f21436871f39e82df8d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTransformations", [value]))

    @jsii.member(jsii_name="resetTransformations")
    def reset_transformations(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformations", []))

    @builtins.property
    @jsii.member(jsii_name="transformations")
    def transformations(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanCompoundTransformationsList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanCompoundTransformationsList", jsii.get(self, "transformations"))

    @builtins.property
    @jsii.member(jsii_name="transformationsInput")
    def transformations_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanCompoundTransformations"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanCompoundTransformations"]]], jsii.get(self, "transformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanCompound]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanCompound]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanCompound]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__207f4fa36152d30bef457a84cf7db48eaa03277a27099d664e08ab88bd66f4a2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanCompoundTransformations",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanCompoundTransformations:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanCompoundTransformations(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanCompoundTransformationsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanCompoundTransformationsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3f152a40df789944fc6f1f0c4c8de5d3fb99b2f2a96d2b176671df47843fe0cb)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanCompoundTransformationsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8020ba895efe2daac926171427b9397abec4f38032b9f31cae4771f6615219c8)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanCompoundTransformationsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4c5cfd9c5cb998b545d743e5a50a08e5d507c29a6716a70966fe209bb4ebf003)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c12ec464bf2a877e9704041d672cd2192884189e8764dbde6133f8425f9cd71a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__436adea8bae7856a2584d5d40f86ff231bbd6ea4f830dfeec2a9dce0fb4e76f2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanCompoundTransformations]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanCompoundTransformations]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanCompoundTransformations]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__79488c4b8b668e4efe7dc82951570eba6141a2438463db2b4b2f2bdf33e5b7a4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanCompoundTransformationsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanCompoundTransformationsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7571f4d33d85ef9eeb82c189c3ccba77545737fe490c5df6118d2df888fb68b5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanCompoundTransformations]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanCompoundTransformations]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanCompoundTransformations]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__27c0cf9a278b42d5832a03bf0624bd6e03969527d8826ed35cbb547bd7eded5f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanContrast",
    jsii_struct_bases=[],
    name_mapping={
        "brightness": "brightness",
        "brightness_var": "brightnessVar",
        "contrast": "contrast",
        "contrast_var": "contrastVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanContrast:
    def __init__(
        self,
        *,
        brightness: typing.Optional[builtins.str] = None,
        brightness_var: typing.Optional[builtins.str] = None,
        contrast: typing.Optional[builtins.str] = None,
        contrast_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param brightness: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        :param brightness_var: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        :param contrast: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param contrast_var: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__52ab0148bf4ca5c860304f06f5f41e06d5affc115c28264d9bbf4ed7ac5bf44e)
            check_type(argname="argument brightness", value=brightness, expected_type=type_hints["brightness"])
            check_type(argname="argument brightness_var", value=brightness_var, expected_type=type_hints["brightness_var"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument contrast_var", value=contrast_var, expected_type=type_hints["contrast_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if brightness is not None:
            self._values["brightness"] = brightness
        if brightness_var is not None:
            self._values["brightness_var"] = brightness_var
        if contrast is not None:
            self._values["contrast"] = contrast
        if contrast_var is not None:
            self._values["contrast_var"] = contrast_var

    @builtins.property
    def brightness(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        '''
        result = self._values.get("brightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def brightness_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        '''
        result = self._values.get("brightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        result = self._values.get("contrast_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanContrast(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanContrastList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanContrastList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__72a080cf49b869ab55ce5bec4adcc1e5d7e0e5fbe1d64df9bfc37b8e982c2a58)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanContrastOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__41978f7a7cd188e386aa8f75b3f1cdc797c249246936e5240bf6557449184cd5)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanContrastOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f1e4abee961b3a0a6372984e1cacb4dd481034904e9f6b7475561147314ca6a5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b33e4d1c1157da580dcc71d01a51179d8c17b3c9dfa1507ef654a3c0b9b5a520)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1b8e931666ce7b38cce8c5cd50aa466e9c1b2ff88dffc811238fd7ef81a96989)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanContrast]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanContrast]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__48b9e0bb8e4c1923a8483803a38409acbce7f48c42c1da0a85cca0bdcaacd0f5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanContrastOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanContrastOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__82e39e7f2dacdede6a41060eb6812de15eecbaab6cc4cd3f50c8e2c8b7c7ece5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetBrightness")
    def reset_brightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightness", []))

    @jsii.member(jsii_name="resetBrightnessVar")
    def reset_brightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightnessVar", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetContrastVar")
    def reset_contrast_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrastVar", []))

    @builtins.property
    @jsii.member(jsii_name="brightnessInput")
    def brightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="brightnessVarInput")
    def brightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastVarInput")
    def contrast_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="brightness")
    def brightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightness"))

    @brightness.setter
    def brightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e86ccd203e9920f65609451b1c6de2cc465e2216e6b5cbd5a39a2a8217f3c78e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightness", value)

    @builtins.property
    @jsii.member(jsii_name="brightnessVar")
    def brightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightnessVar"))

    @brightness_var.setter
    def brightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c851d8de339fa472c09eb28cf8fa555640833ddf3ee81fd91fb78b6ebbf06c77)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrast"))

    @contrast.setter
    def contrast(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__36b13206d99c77b0e2c1bf23af82b14e1615c349438c9aa63cfe3819b1a8bc28)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrast", value)

    @builtins.property
    @jsii.member(jsii_name="contrastVar")
    def contrast_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrastVar"))

    @contrast_var.setter
    def contrast_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5d9deaba1a2184655c3ac1155ba2a8f0796ec530fcae0c509f92aac2303d4b64)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrastVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanContrast]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanContrast]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanContrast]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__75e58d60a5607c92a466c3693a0a9a0813c80e1502f6d3323f4d2dcc3d8dbb95)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanCrop",
    jsii_struct_bases=[],
    name_mapping={
        "allow_expansion": "allowExpansion",
        "allow_expansion_var": "allowExpansionVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanCrop:
    def __init__(
        self,
        *,
        allow_expansion: typing.Optional[builtins.str] = None,
        allow_expansion_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_expansion: If cropping an area outside of the existing canvas, expands the image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        :param allow_expansion_var: If cropping an area outside of the existing canvas, expands the image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        :param gravity: Frame of reference for X and Y Positions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Frame of reference for X and Y Positions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The number of pixels to crop along the y-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The number of pixels to crop along the y-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The number of pixels to crop along the x-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The number of pixels to crop along the x-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        :param x_position: The x-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__992b5904e053e5cd8043776f38735785794fc0cee0a586950e0bf10e5460d9cf)
            check_type(argname="argument allow_expansion", value=allow_expansion, expected_type=type_hints["allow_expansion"])
            check_type(argname="argument allow_expansion_var", value=allow_expansion_var, expected_type=type_hints["allow_expansion_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if allow_expansion is not None:
            self._values["allow_expansion"] = allow_expansion
        if allow_expansion_var is not None:
            self._values["allow_expansion_var"] = allow_expansion_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def allow_expansion(self) -> typing.Optional[builtins.str]:
        '''If cropping an area outside of the existing canvas, expands the image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        '''
        result = self._values.get("allow_expansion")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def allow_expansion_var(self) -> typing.Optional[builtins.str]:
        '''If cropping an area outside of the existing canvas, expands the image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        '''
        result = self._values.get("allow_expansion_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Frame of reference for X and Y Positions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Frame of reference for X and Y Positions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the y-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the y-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the x-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the x-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__48283e7dcfe69a45d7e132b3d58408be62075f4185285bbda48bb0489cb6f9ed)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3150c9ae3a60916c3ec5ec9d506cf03cd4f2ef62d347dd96787831b54e2376f2)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__22e535e7cfd15319cb801ce99ca83f89d3368d493f24f8a307e5db91352a8f09)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__79260c53288016f2f14667979185ff76426879d1c554c46f74feedd1b12574e9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__285f59fff3f1090b3cdc945e4e595197404aec43b937884bfbfa8325dcd64ad8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__51f6de3aebcf8e31bcfe00a1682755d731abc3218863de9a181336c45553e4ad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a1131f761211154b0e4179f3d1c4ade20b7c9421157e3d3f3a3b26712d17009f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAllowExpansion")
    def reset_allow_expansion(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansion", []))

    @jsii.member(jsii_name="resetAllowExpansionVar")
    def reset_allow_expansion_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansionVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionInput")
    def allow_expansion_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVarInput")
    def allow_expansion_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansion")
    def allow_expansion(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansion"))

    @allow_expansion.setter
    def allow_expansion(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__88d4808fd16ed9e64b3dc7d86bdff0f32160af33f34948c72b48646feaa34678)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansion", value)

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVar")
    def allow_expansion_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansionVar"))

    @allow_expansion_var.setter
    def allow_expansion_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1a78b6e851ff726fefcfe958c7d3f5ecc39ad236a54450aa89a245e36b742f9a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansionVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__32cb9efe1c50fdf7f875ac9509c671ecbefadf6ee3ac066b30f1b6c4a6432be8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2131252d5170becd2cb976d855556587c31bd694a0fc116c742cca7e034de227)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__71f03cfc324ecb9dac9f7d4611b446b6ab3763b1263f6640796a599e7bee81e2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5e00cf213940016ec5c4e965d3040b323a9ebac94a6549b38de2986381c97e8d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab52042a06bf9b70ab8e74bc28b2a0f8d26d5f1444342de7d25f524ee5eeb498)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__814c4f27dfb76fcf9245d271997010d6ca74459597c1af528ec76d97fee8a3d6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fac2664bdc78c99b70b1577fd9805b34038e74ec1b0d74a1222e4abc0588352c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__391fabd1e43990feae230aed1a303c0b5ba496e8818a390f1276372b5dea4e1a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d346a6bd20c8494c124ad841b18b72aa24dbf1c360c305ac1a06cac9eb8522b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c838860878d43fab1406a249b6ae0dbed23515811596199f7a8d8c58512cba3b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5cb519629afc0e9764a04d96383a0b705c21a9c15cfa0331f2e872261e36ba6e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanFaceCrop",
    jsii_struct_bases=[],
    name_mapping={
        "algorithm": "algorithm",
        "algorithm_var": "algorithmVar",
        "confidence": "confidence",
        "confidence_var": "confidenceVar",
        "fail_gravity": "failGravity",
        "fail_gravity_var": "failGravityVar",
        "focus": "focus",
        "focus_var": "focusVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "padding": "padding",
        "padding_var": "paddingVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanFaceCrop:
    def __init__(
        self,
        *,
        algorithm: typing.Optional[builtins.str] = None,
        algorithm_var: typing.Optional[builtins.str] = None,
        confidence: typing.Optional[builtins.str] = None,
        confidence_var: typing.Optional[builtins.str] = None,
        fail_gravity: typing.Optional[builtins.str] = None,
        fail_gravity_var: typing.Optional[builtins.str] = None,
        focus: typing.Optional[builtins.str] = None,
        focus_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param algorithm: Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm DataAkamaiImagingPolicyImage#algorithm}
        :param algorithm_var: Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm_var DataAkamaiImagingPolicyImage#algorithm_var}
        :param confidence: With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image. Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence DataAkamaiImagingPolicyImage#confidence}
        :param confidence_var: With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image. Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence_var DataAkamaiImagingPolicyImage#confidence_var}
        :param fail_gravity: Controls placement of the crop if Image and Video Manager does not detect any faces in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        :param fail_gravity_var: Controls placement of the crop if Image and Video Manager does not detect any faces in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        :param focus: Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus DataAkamaiImagingPolicyImage#focus}
        :param focus_var: Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus_var DataAkamaiImagingPolicyImage#focus_var}
        :param gravity: Controls placement of the crop. Directions are relative to the face(s) plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Controls placement of the crop. Directions are relative to the face(s) plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param padding: The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        :param style: Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3310387e083f76d79af1044dab658d8f9fd5432060ce4e38b1112ba1b6729dde)
            check_type(argname="argument algorithm", value=algorithm, expected_type=type_hints["algorithm"])
            check_type(argname="argument algorithm_var", value=algorithm_var, expected_type=type_hints["algorithm_var"])
            check_type(argname="argument confidence", value=confidence, expected_type=type_hints["confidence"])
            check_type(argname="argument confidence_var", value=confidence_var, expected_type=type_hints["confidence_var"])
            check_type(argname="argument fail_gravity", value=fail_gravity, expected_type=type_hints["fail_gravity"])
            check_type(argname="argument fail_gravity_var", value=fail_gravity_var, expected_type=type_hints["fail_gravity_var"])
            check_type(argname="argument focus", value=focus, expected_type=type_hints["focus"])
            check_type(argname="argument focus_var", value=focus_var, expected_type=type_hints["focus_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if algorithm is not None:
            self._values["algorithm"] = algorithm
        if algorithm_var is not None:
            self._values["algorithm_var"] = algorithm_var
        if confidence is not None:
            self._values["confidence"] = confidence
        if confidence_var is not None:
            self._values["confidence_var"] = confidence_var
        if fail_gravity is not None:
            self._values["fail_gravity"] = fail_gravity
        if fail_gravity_var is not None:
            self._values["fail_gravity_var"] = fail_gravity_var
        if focus is not None:
            self._values["focus"] = focus
        if focus_var is not None:
            self._values["focus_var"] = focus_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def algorithm(self) -> typing.Optional[builtins.str]:
        '''Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm DataAkamaiImagingPolicyImage#algorithm}
        '''
        result = self._values.get("algorithm")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def algorithm_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm_var DataAkamaiImagingPolicyImage#algorithm_var}
        '''
        result = self._values.get("algorithm_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def confidence(self) -> typing.Optional[builtins.str]:
        '''With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image.

        Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence DataAkamaiImagingPolicyImage#confidence}
        '''
        result = self._values.get("confidence")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def confidence_var(self) -> typing.Optional[builtins.str]:
        '''With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image.

        Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence_var DataAkamaiImagingPolicyImage#confidence_var}
        '''
        result = self._values.get("confidence_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any faces in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        '''
        result = self._values.get("fail_gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any faces in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        '''
        result = self._values.get("fail_gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def focus(self) -> typing.Optional[builtins.str]:
        '''Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus DataAkamaiImagingPolicyImage#focus}
        '''
        result = self._values.get("focus")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def focus_var(self) -> typing.Optional[builtins.str]:
        '''Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus_var DataAkamaiImagingPolicyImage#focus_var}
        '''
        result = self._values.get("focus_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the face(s) plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the face(s) plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanFaceCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanFaceCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanFaceCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__46e480ef0fc56d547afd9c247468742f6dd469207b82ae55bdc89ef449e2acd3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanFaceCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b63a7cacd1f3ad02021df3b9e76de16a2056b89bf8f8d7c431313adce3f7bc52)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanFaceCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b66eb2bcd6a3e5efb75d9cf93e93165f2ed282fff754c1181799be30f5eb33da)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9f1f5f1bf5747968c9d4b97ccc45ec12953247a5d4c2f977f99c3c0e39d3ae0f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2fe674ba1fbca2c47ae19b1b8af515f5d6515ccb55563f12c57f8fa123576208)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanFaceCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanFaceCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanFaceCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a1c7dbb42bc5cdd1b3fbab46c27f838f7487318ce58dd91e656c7d648e2462b1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanFaceCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanFaceCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__397f8bccd7c140651e1214275bcdd08df4407a34cc2a2dee5281b5142abe6618)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAlgorithm")
    def reset_algorithm(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAlgorithm", []))

    @jsii.member(jsii_name="resetAlgorithmVar")
    def reset_algorithm_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAlgorithmVar", []))

    @jsii.member(jsii_name="resetConfidence")
    def reset_confidence(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetConfidence", []))

    @jsii.member(jsii_name="resetConfidenceVar")
    def reset_confidence_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetConfidenceVar", []))

    @jsii.member(jsii_name="resetFailGravity")
    def reset_fail_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravity", []))

    @jsii.member(jsii_name="resetFailGravityVar")
    def reset_fail_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravityVar", []))

    @jsii.member(jsii_name="resetFocus")
    def reset_focus(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFocus", []))

    @jsii.member(jsii_name="resetFocusVar")
    def reset_focus_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFocusVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="algorithmInput")
    def algorithm_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "algorithmInput"))

    @builtins.property
    @jsii.member(jsii_name="algorithmVarInput")
    def algorithm_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "algorithmVarInput"))

    @builtins.property
    @jsii.member(jsii_name="confidenceInput")
    def confidence_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "confidenceInput"))

    @builtins.property
    @jsii.member(jsii_name="confidenceVarInput")
    def confidence_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "confidenceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityInput")
    def fail_gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityVarInput")
    def fail_gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="focusInput")
    def focus_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "focusInput"))

    @builtins.property
    @jsii.member(jsii_name="focusVarInput")
    def focus_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "focusVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="algorithm")
    def algorithm(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "algorithm"))

    @algorithm.setter
    def algorithm(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e700eed3f8b4cb17b3b2cea7b6ba634a22335f294e7687da53f8179ec4b828d7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "algorithm", value)

    @builtins.property
    @jsii.member(jsii_name="algorithmVar")
    def algorithm_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "algorithmVar"))

    @algorithm_var.setter
    def algorithm_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4f38c36b0be1dfaf757371e58c6cfebd010cc60736f3ae8dfb74800361262373)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "algorithmVar", value)

    @builtins.property
    @jsii.member(jsii_name="confidence")
    def confidence(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "confidence"))

    @confidence.setter
    def confidence(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac95e2fe69a44260ae4577a8f40da568359be2fb0c34f685d7c7705d176d96bb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "confidence", value)

    @builtins.property
    @jsii.member(jsii_name="confidenceVar")
    def confidence_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "confidenceVar"))

    @confidence_var.setter
    def confidence_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__21100bfa2877a0245913dbca2b369958e1d53be18049bcef6c2d91cd68cdf8b3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "confidenceVar", value)

    @builtins.property
    @jsii.member(jsii_name="failGravity")
    def fail_gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravity"))

    @fail_gravity.setter
    def fail_gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d49d31fd724bf5d9b9b926fb9a6fa0c69cf485187a4710c503cd1a7a6c78c27f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravity", value)

    @builtins.property
    @jsii.member(jsii_name="failGravityVar")
    def fail_gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravityVar"))

    @fail_gravity_var.setter
    def fail_gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7caa0c3d3f68ad0e6994e6067387df50ee17416e6ee6cfa052bfa88d6d208206)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="focus")
    def focus(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "focus"))

    @focus.setter
    def focus(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__daaa0bf97325ada2749f87fee62b0a6eadff5db0aef303a6f8dd3645b630337c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "focus", value)

    @builtins.property
    @jsii.member(jsii_name="focusVar")
    def focus_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "focusVar"))

    @focus_var.setter
    def focus_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2f8786b7382141a7e646294b40a6d47fda2f46a5cf41a170fe47a22b2d7b8bf7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "focusVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e3f98f3a76ab345b3de7fcf86a4a9a113cda742093c188c54e3ff7c67ac3d18f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3d9e1c9242a83d537928170e60aa6747e992d1c4bfbdd92af88b0ff5aa6df3e1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2df863f510e787c4eb159f543b5317cd37874023d0bfd4a505b994942d6ba79d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4b061d74ddabf503d5b63c9ffd6e46638db5f314860886c6cb7a091a53eefca8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b68ef2a27bdd3bc1ebe4f572b8b8784da84c07d9594a4bb23d0b06311a5733d7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c38c44de125ff7a79a669240a139cb3d65f116e44edefb3bce313c4235d58582)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__47efe135998219610ec2bd55352beddd6822e9bb1667936f84b86aedc57c44ab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__51ec0d589b3f8edd98fdd928b17b3a819a2a7659932e1aa9ae8c7877acbecb07)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b34ae8b4fcee6191261cb3b9f226cfe3f7adbb175abf50b704ef54ea26db2d7a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__01b69607262f74aa87eacc3611afe8af6a7f803d1ac4299705ecbadbead98912)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanFaceCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanFaceCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanFaceCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__594fdb51c083ed521491554c468ebcf3f29cdb871a6d5bc9cd88732d5bff1605)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanFeatureCrop",
    jsii_struct_bases=[],
    name_mapping={
        "fail_gravity": "failGravity",
        "fail_gravity_var": "failGravityVar",
        "feature_radius": "featureRadius",
        "feature_radius_var": "featureRadiusVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "max_features": "maxFeatures",
        "max_features_var": "maxFeaturesVar",
        "min_feature_quality": "minFeatureQuality",
        "min_feature_quality_var": "minFeatureQualityVar",
        "padding": "padding",
        "padding_var": "paddingVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanFeatureCrop:
    def __init__(
        self,
        *,
        fail_gravity: typing.Optional[builtins.str] = None,
        fail_gravity_var: typing.Optional[builtins.str] = None,
        feature_radius: typing.Optional[builtins.str] = None,
        feature_radius_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        max_features: typing.Optional[builtins.str] = None,
        max_features_var: typing.Optional[builtins.str] = None,
        min_feature_quality: typing.Optional[builtins.str] = None,
        min_feature_quality_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fail_gravity: Controls placement of the crop if Image and Video Manager does not detect any features in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        :param fail_gravity_var: Controls placement of the crop if Image and Video Manager does not detect any features in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        :param feature_radius: The size in pixels of the important features to search for. If identified, two features never appear closer together than this value, ``8.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius DataAkamaiImagingPolicyImage#feature_radius}
        :param feature_radius_var: The size in pixels of the important features to search for. If identified, two features never appear closer together than this value, ``8.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius_var DataAkamaiImagingPolicyImage#feature_radius_var}
        :param gravity: Controls placement of the crop. Directions are relative to the region of interest plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Controls placement of the crop. Directions are relative to the region of interest plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param max_features: The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features DataAkamaiImagingPolicyImage#max_features}
        :param max_features_var: The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features_var DataAkamaiImagingPolicyImage#max_features_var}
        :param min_feature_quality: Determines the minimum quality level of the feature identified. To consider a feature important, the feature needs to surpass this value. Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality DataAkamaiImagingPolicyImage#min_feature_quality}
        :param min_feature_quality_var: Determines the minimum quality level of the feature identified. To consider a feature important, the feature needs to surpass this value. Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality_var DataAkamaiImagingPolicyImage#min_feature_quality_var}
        :param padding: Adds space around the region of interest. The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: Adds space around the region of interest. The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        :param style: Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5a57c242f795c5ff5e4e62f7c9da9283a31bf8d686eacb6f3b871f6779d187c3)
            check_type(argname="argument fail_gravity", value=fail_gravity, expected_type=type_hints["fail_gravity"])
            check_type(argname="argument fail_gravity_var", value=fail_gravity_var, expected_type=type_hints["fail_gravity_var"])
            check_type(argname="argument feature_radius", value=feature_radius, expected_type=type_hints["feature_radius"])
            check_type(argname="argument feature_radius_var", value=feature_radius_var, expected_type=type_hints["feature_radius_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument max_features", value=max_features, expected_type=type_hints["max_features"])
            check_type(argname="argument max_features_var", value=max_features_var, expected_type=type_hints["max_features_var"])
            check_type(argname="argument min_feature_quality", value=min_feature_quality, expected_type=type_hints["min_feature_quality"])
            check_type(argname="argument min_feature_quality_var", value=min_feature_quality_var, expected_type=type_hints["min_feature_quality_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fail_gravity is not None:
            self._values["fail_gravity"] = fail_gravity
        if fail_gravity_var is not None:
            self._values["fail_gravity_var"] = fail_gravity_var
        if feature_radius is not None:
            self._values["feature_radius"] = feature_radius
        if feature_radius_var is not None:
            self._values["feature_radius_var"] = feature_radius_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if max_features is not None:
            self._values["max_features"] = max_features
        if max_features_var is not None:
            self._values["max_features_var"] = max_features_var
        if min_feature_quality is not None:
            self._values["min_feature_quality"] = min_feature_quality
        if min_feature_quality_var is not None:
            self._values["min_feature_quality_var"] = min_feature_quality_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def fail_gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any features in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        '''
        result = self._values.get("fail_gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any features in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        '''
        result = self._values.get("fail_gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feature_radius(self) -> typing.Optional[builtins.str]:
        '''The size in pixels of the important features to search for.

        If identified, two features never appear closer together than this value, ``8.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius DataAkamaiImagingPolicyImage#feature_radius}
        '''
        result = self._values.get("feature_radius")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feature_radius_var(self) -> typing.Optional[builtins.str]:
        '''The size in pixels of the important features to search for.

        If identified, two features never appear closer together than this value, ``8.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius_var DataAkamaiImagingPolicyImage#feature_radius_var}
        '''
        result = self._values.get("feature_radius_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the region of interest plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the region of interest plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def max_features(self) -> typing.Optional[builtins.str]:
        '''The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features DataAkamaiImagingPolicyImage#max_features}
        '''
        result = self._values.get("max_features")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def max_features_var(self) -> typing.Optional[builtins.str]:
        '''The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features_var DataAkamaiImagingPolicyImage#max_features_var}
        '''
        result = self._values.get("max_features_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def min_feature_quality(self) -> typing.Optional[builtins.str]:
        '''Determines the minimum quality level of the feature identified.

        To consider a feature important, the feature needs to surpass this value.  Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality DataAkamaiImagingPolicyImage#min_feature_quality}
        '''
        result = self._values.get("min_feature_quality")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def min_feature_quality_var(self) -> typing.Optional[builtins.str]:
        '''Determines the minimum quality level of the feature identified.

        To consider a feature important, the feature needs to surpass this value.  Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality_var DataAkamaiImagingPolicyImage#min_feature_quality_var}
        '''
        result = self._values.get("min_feature_quality_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''Adds space around the region of interest.

        The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''Adds space around the region of interest.

        The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanFeatureCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanFeatureCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanFeatureCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ec21eaffaabdf21b3b76133f4b32f993708279f89f81d8afd7627f990d419c5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanFeatureCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f4ed4e5eea60741bb1629285a7d849a8063b6cb85a8996c0245178f1dec9761)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanFeatureCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__db4e06451e4f02d79fdf06be6e7b78e510afed220749ca477b7f17275a3dd3e7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__862d7175c4cca10906f5ad42c82c3b0920549741cc6876b2f24d84a2a9df12bf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e86e90f1377b33b5a7baa8f14d1f16b1bbf85ce587955682530583cb9829be11)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanFeatureCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanFeatureCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanFeatureCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__96b5327f45e1f7599893cb9ce2f197c307919651acc9f1e2f871bab9f7e4aa14)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanFeatureCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanFeatureCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a59ae6ed739a7fa30c1878d420fb46ba7e35f31ea382b172a938ce0b519e4421)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetFailGravity")
    def reset_fail_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravity", []))

    @jsii.member(jsii_name="resetFailGravityVar")
    def reset_fail_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravityVar", []))

    @jsii.member(jsii_name="resetFeatureRadius")
    def reset_feature_radius(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureRadius", []))

    @jsii.member(jsii_name="resetFeatureRadiusVar")
    def reset_feature_radius_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureRadiusVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetMaxFeatures")
    def reset_max_features(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxFeatures", []))

    @jsii.member(jsii_name="resetMaxFeaturesVar")
    def reset_max_features_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxFeaturesVar", []))

    @jsii.member(jsii_name="resetMinFeatureQuality")
    def reset_min_feature_quality(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMinFeatureQuality", []))

    @jsii.member(jsii_name="resetMinFeatureQualityVar")
    def reset_min_feature_quality_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMinFeatureQualityVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="failGravityInput")
    def fail_gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityVarInput")
    def fail_gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featureRadiusInput")
    def feature_radius_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featureRadiusInput"))

    @builtins.property
    @jsii.member(jsii_name="featureRadiusVarInput")
    def feature_radius_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featureRadiusVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesInput")
    def max_features_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "maxFeaturesInput"))

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesVarInput")
    def max_features_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "maxFeaturesVarInput"))

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityInput")
    def min_feature_quality_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "minFeatureQualityInput"))

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityVarInput")
    def min_feature_quality_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "minFeatureQualityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravity")
    def fail_gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravity"))

    @fail_gravity.setter
    def fail_gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__91755d0608163eeff5c1abffd77599e22146c630d78f97c47c085c1dc7dd19be)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravity", value)

    @builtins.property
    @jsii.member(jsii_name="failGravityVar")
    def fail_gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravityVar"))

    @fail_gravity_var.setter
    def fail_gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__595ea53e1b320d3a03c9d00822491956bc248a733a4d44bc25b7c71b2a1b85ae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="featureRadius")
    def feature_radius(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featureRadius"))

    @feature_radius.setter
    def feature_radius(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8426fe02590bf86563dbcbbbd6a6c583b9e3bcfc20e62f826d360862a406a803)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featureRadius", value)

    @builtins.property
    @jsii.member(jsii_name="featureRadiusVar")
    def feature_radius_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featureRadiusVar"))

    @feature_radius_var.setter
    def feature_radius_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cdaad36a740e7346f81d15ca497960fc350b82ea90461db2571771838618deab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featureRadiusVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__275ff5026a670ac74f19fc993fb111681a146118fb3ef6ff7a9b658bc6ce22c8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__60114388d8986b8aca7b683c8f8e5dcfef31cd88fc144db79ca1c6f72665e691)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5b6c53dd213cc03dceb3bbcd654268595f0e2e8635304974d277be0b92ec319c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a2aced69abefd40658c08459080c262098815b82775052d8ca4121e225a4a869)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="maxFeatures")
    def max_features(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "maxFeatures"))

    @max_features.setter
    def max_features(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ca6013de94ef9c208beffebc41442173439ecc0f457f4f309802325621e689eb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "maxFeatures", value)

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesVar")
    def max_features_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "maxFeaturesVar"))

    @max_features_var.setter
    def max_features_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d7022bb2968edbc9f624ad5b3f6dbc0f6969dd1b358b2871edd8210d4634ceb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "maxFeaturesVar", value)

    @builtins.property
    @jsii.member(jsii_name="minFeatureQuality")
    def min_feature_quality(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "minFeatureQuality"))

    @min_feature_quality.setter
    def min_feature_quality(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5b9b81ceb68973d770301dce2153b4c23f6fc67536297619469c3aec1ed4f27d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "minFeatureQuality", value)

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityVar")
    def min_feature_quality_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "minFeatureQualityVar"))

    @min_feature_quality_var.setter
    def min_feature_quality_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a05974a9493cc696cc0b2ad849247c71c624869accc761e592f5ba51e4bec886)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "minFeatureQualityVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2b9b7eb695e8321d6c4252375be4a101f798bff61851f091c8713854e78f4365)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7124049ff0733bf0198de4699beb1d5f14caa3562a13a784e49668cb08432ad1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__56ae92f4d4bc88bd14ba88c1cc54f660b410481187b97a6a98c172410bab26dc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__669bfe324a198cdf5289c9bc300cebb640409c7d9245758de239641a089bb606)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ae1ed2abfbc663e8724d065e7af9d5f455e5b82ed74b45115071a42c5c255b3d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8b6ae0c104a1e2e65e46e18619643c32f729156b1f02d24687bd74aad824f674)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanFeatureCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanFeatureCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanFeatureCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__382f1d30600d88d0ec74dbd55b94ae9c1b066003c2ced8be010b716e121ab08c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanFitAndFill",
    jsii_struct_bases=[],
    name_mapping={
        "fill_transformation": "fillTransformation",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanFitAndFill:
    def __init__(
        self,
        *,
        fill_transformation: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanFitAndFillFillTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fill_transformation: fill_transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_transformation DataAkamaiImagingPolicyImage#fill_transformation}
        :param height: The height value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The width value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(fill_transformation, dict):
            fill_transformation = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanFitAndFillFillTransformation(**fill_transformation)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd16fff9ce23cb5486dd4051186dd92c62d9bdcbe80119280bac865ac052c557)
            check_type(argname="argument fill_transformation", value=fill_transformation, expected_type=type_hints["fill_transformation"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fill_transformation is not None:
            self._values["fill_transformation"] = fill_transformation
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def fill_transformation(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanFitAndFillFillTransformation"]:
        '''fill_transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_transformation DataAkamaiImagingPolicyImage#fill_transformation}
        '''
        result = self._values.get("fill_transformation")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanFitAndFillFillTransformation"], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanFitAndFill(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanFitAndFillFillTransformation",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanFitAndFillFillTransformation:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanFitAndFillFillTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanFitAndFillFillTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanFitAndFillFillTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__101f61639b7563d7c75987ec3da5705080f21a45efd613a6bb9dae7e6bebda6b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanFitAndFillFillTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanFitAndFillFillTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanFitAndFillFillTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9e1ac2dddc4df82dc4fd59306387cd9697d86e82d2b25714bfb02dde41e23bad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanFitAndFillList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanFitAndFillList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__acdc37fba56050a08d56ea5793a354d3e62920a1ee11148dabd8e8b2289db6b8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanFitAndFillOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c4b773bcbd72204ee52516b0ecef372cb75e435cdc02119041a641ebf6d990c0)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanFitAndFillOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__599221f2e55f7b1e660db0d9970ec4d8282c1ff0f8f31fcfa23b7b21842a553b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__154a756b1279d79497cc786dc04d541ade52832f91cc652e0c1615415d63b36b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d784dd54c5ca1c81f0d7d1040dfcd902a055b651c54532b9f75a80b54ab08c6c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanFitAndFill]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanFitAndFill]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanFitAndFill]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__18a2260e8634745d39edd3df7467a78e1eb9548e32701b7608c6fe4d30521ee2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanFitAndFillOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanFitAndFillOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__748d48b30400c00d6a9a5b4f3b2add62317965574eb1a1fd474553667c437f33)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putFillTransformation")
    def put_fill_transformation(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanFitAndFillFillTransformation()

        return typing.cast(None, jsii.invoke(self, "putFillTransformation", [value]))

    @jsii.member(jsii_name="resetFillTransformation")
    def reset_fill_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFillTransformation", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="fillTransformation")
    def fill_transformation(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanFitAndFillFillTransformationOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanFitAndFillFillTransformationOutputReference, jsii.get(self, "fillTransformation"))

    @builtins.property
    @jsii.member(jsii_name="fillTransformationInput")
    def fill_transformation_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanFitAndFillFillTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanFitAndFillFillTransformation], jsii.get(self, "fillTransformationInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3bf0905b6c4bc1425a8ddb366de7f42b8906afde9bf325399ff8197705d355f3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__77710cdb38ebc414ea206dc197957c70a6d8d438c31717089907659b550d42d0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eabde89f0c25cbe776e78e9019218c10a9fbf47c05500e2919c8543125acaddf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ad32b3079a8ebc23bcc16297be01a2c227b008b1478cc62670b32a27a91ee4a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanFitAndFill]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanFitAndFill]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanFitAndFill]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8fe241d4dc04696dfd982e6f465ece9d6fb4f1f000f65a163d07e12242800372)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanGoop",
    jsii_struct_bases=[],
    name_mapping={
        "chaos": "chaos",
        "chaos_var": "chaosVar",
        "density": "density",
        "density_var": "densityVar",
        "power": "power",
        "power_var": "powerVar",
        "seed": "seed",
        "seed_var": "seedVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanGoop:
    def __init__(
        self,
        *,
        chaos: typing.Optional[builtins.str] = None,
        chaos_var: typing.Optional[builtins.str] = None,
        density: typing.Optional[builtins.str] = None,
        density_var: typing.Optional[builtins.str] = None,
        power: typing.Optional[builtins.str] = None,
        power_var: typing.Optional[builtins.str] = None,
        seed: typing.Optional[builtins.str] = None,
        seed_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param chaos: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        :param chaos_var: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        :param density: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        :param density_var: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        :param power: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        :param power_var: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        :param seed: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        :param seed_var: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b172d2dc14b8bd964ff74984c22fcff95a269aba7eb86d9d84a4c0fc95c915e4)
            check_type(argname="argument chaos", value=chaos, expected_type=type_hints["chaos"])
            check_type(argname="argument chaos_var", value=chaos_var, expected_type=type_hints["chaos_var"])
            check_type(argname="argument density", value=density, expected_type=type_hints["density"])
            check_type(argname="argument density_var", value=density_var, expected_type=type_hints["density_var"])
            check_type(argname="argument power", value=power, expected_type=type_hints["power"])
            check_type(argname="argument power_var", value=power_var, expected_type=type_hints["power_var"])
            check_type(argname="argument seed", value=seed, expected_type=type_hints["seed"])
            check_type(argname="argument seed_var", value=seed_var, expected_type=type_hints["seed_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if chaos is not None:
            self._values["chaos"] = chaos
        if chaos_var is not None:
            self._values["chaos_var"] = chaos_var
        if density is not None:
            self._values["density"] = density
        if density_var is not None:
            self._values["density_var"] = density_var
        if power is not None:
            self._values["power"] = power
        if power_var is not None:
            self._values["power_var"] = power_var
        if seed is not None:
            self._values["seed"] = seed
        if seed_var is not None:
            self._values["seed_var"] = seed_var

    @builtins.property
    def chaos(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        '''
        result = self._values.get("chaos")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def chaos_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        '''
        result = self._values.get("chaos_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        '''
        result = self._values.get("density")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density_var(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        '''
        result = self._values.get("density_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        '''
        result = self._values.get("power")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power_var(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        '''
        result = self._values.get("power_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        '''
        result = self._values.get("seed")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed_var(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        result = self._values.get("seed_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanGoop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanGoopList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanGoopList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__38b79b659bfcce6ea18707fa0b8bb236324e60471b588a425f2cc080ff85784b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanGoopOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c058ae3b8b84a959845d7b504efe87353782d551df4804539e51631d26d890ac)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanGoopOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__63d56fc413407e9920876c125b065ec79da0a9e190dec23fa92793ebfc0aa38d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__39cbca890eb555fbcbfb78c8094e470563e8f267fa61e9241517156e33f11106)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fc929ca2583dfd45c791f0870593fe0c3ce7431c877fb260b957525d34a6cf8f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanGoop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanGoop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__35306871231f56072ef9d53cffdac4df52f355db8083ba7d09acdc49d7cb0dc0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanGoopOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanGoopOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__242b8ac4c17a7c08472e421797b1be03c05a6823b43e2f64ec05f862f3524556)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetChaos")
    def reset_chaos(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaos", []))

    @jsii.member(jsii_name="resetChaosVar")
    def reset_chaos_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaosVar", []))

    @jsii.member(jsii_name="resetDensity")
    def reset_density(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensity", []))

    @jsii.member(jsii_name="resetDensityVar")
    def reset_density_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensityVar", []))

    @jsii.member(jsii_name="resetPower")
    def reset_power(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPower", []))

    @jsii.member(jsii_name="resetPowerVar")
    def reset_power_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPowerVar", []))

    @jsii.member(jsii_name="resetSeed")
    def reset_seed(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeed", []))

    @jsii.member(jsii_name="resetSeedVar")
    def reset_seed_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeedVar", []))

    @builtins.property
    @jsii.member(jsii_name="chaosInput")
    def chaos_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosInput"))

    @builtins.property
    @jsii.member(jsii_name="chaosVarInput")
    def chaos_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosVarInput"))

    @builtins.property
    @jsii.member(jsii_name="densityInput")
    def density_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityInput"))

    @builtins.property
    @jsii.member(jsii_name="densityVarInput")
    def density_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="powerInput")
    def power_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerInput"))

    @builtins.property
    @jsii.member(jsii_name="powerVarInput")
    def power_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerVarInput"))

    @builtins.property
    @jsii.member(jsii_name="seedInput")
    def seed_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedInput"))

    @builtins.property
    @jsii.member(jsii_name="seedVarInput")
    def seed_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedVarInput"))

    @builtins.property
    @jsii.member(jsii_name="chaos")
    def chaos(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaos"))

    @chaos.setter
    def chaos(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df56efadf8e8e005db5e37fc1dc44a47a277aa518168d4ddccfbd8d80d41651d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaos", value)

    @builtins.property
    @jsii.member(jsii_name="chaosVar")
    def chaos_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaosVar"))

    @chaos_var.setter
    def chaos_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__70ad796954d155f2ea91758f8c623bc4cf9ec77a3d8b59316dcf0a9b70a4ebd8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaosVar", value)

    @builtins.property
    @jsii.member(jsii_name="density")
    def density(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "density"))

    @density.setter
    def density(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0e413ebb701bb0c9a36d667a78a83b5faa6cd2ad4b503a26e53bbbfb8d51be0b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "density", value)

    @builtins.property
    @jsii.member(jsii_name="densityVar")
    def density_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "densityVar"))

    @density_var.setter
    def density_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__65a16b1e2d36e051d5283a885688f645b4fe108fe8566683a7beb962854b8256)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "densityVar", value)

    @builtins.property
    @jsii.member(jsii_name="power")
    def power(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "power"))

    @power.setter
    def power(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5403d159d11a25c9826d0615f3214d9270afe38d84344af568963909e488c98a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "power", value)

    @builtins.property
    @jsii.member(jsii_name="powerVar")
    def power_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "powerVar"))

    @power_var.setter
    def power_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b0aa240e374b5c71384dac0c4c9e443b5857633e12b9528959d90404308775c1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "powerVar", value)

    @builtins.property
    @jsii.member(jsii_name="seed")
    def seed(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seed"))

    @seed.setter
    def seed(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__712ce61630d246c1f5f2a37ec4644bad63b6156eb9ab0d3a35485b45e0c8d47b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seed", value)

    @builtins.property
    @jsii.member(jsii_name="seedVar")
    def seed_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seedVar"))

    @seed_var.setter
    def seed_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dd58d88f8eb29a95b20103e5725ad04a82924a5f4b06515a15c0dc246f799a85)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seedVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanGoop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanGoop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanGoop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__baf9a9fd29c060867eacc7438dd6967b95197a14a7b50fd8970abfd1ee6396ca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanGrayscale",
    jsii_struct_bases=[],
    name_mapping={"type": "type", "type_var": "typeVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanGrayscale:
    def __init__(
        self,
        *,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param type: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e4ca3ceced7ee9a8290489ac4c04630c9089cfe58733fdf67c526dee8c919dad)
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanGrayscale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanGrayscaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanGrayscaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cb03a25639c3c50f09eb4a09e56c7e8448ba92c25255371904517ce6d17c8638)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanGrayscaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d8b68a5f6ae67e3716c07122e370f1f6323efc944515e34ebdf19b4155157207)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanGrayscaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__67101b6d88bc42f7d7de1e81d3f94ca7987541b28a7e07904d4f54d936e27441)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fe919b952927ca45475124d68b6e69031257799c6ea9207de7a0b16f708295b2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__28aec4f527c7b58be0209d5bba3f09d7b35a16faa21819129aa2b75b742799b3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanGrayscale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanGrayscale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2bffbd265764f577768833952c6712618263ff302311f178d8fe9623d1983b43)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanGrayscaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanGrayscaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cf7c9ac3d3759851730e04900f57af0c0ef8b9a5dd1465f42220c5545333f051)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e979e9b863fd8074a508372929f533b640ff73a5d220eef410ec5eeabe992888)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__47ea5a7621db0b8f55f3b0f950f186aa4876e5c0041032c6b20a878fdf13d0be)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanGrayscale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanGrayscale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanGrayscale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a29bd12e204f6ea2fcfec8b48ae8217eb6fb3b930f1f63cc3cc48dcc6c9b4c2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanHsl",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "lightness": "lightness",
        "lightness_var": "lightnessVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanHsl:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness: typing.Optional[builtins.str] = None,
        lightness_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        :param lightness_var: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4bcf09d810476a047e8e89e8bba8c3fb202a3a911feda89b8f59f370ac2a296b)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness", value=lightness, expected_type=type_hints["lightness"])
            check_type(argname="argument lightness_var", value=lightness_var, expected_type=type_hints["lightness_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness is not None:
            self._values["lightness"] = lightness
        if lightness_var is not None:
            self._values["lightness_var"] = lightness_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        '''
        result = self._values.get("lightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        '''
        result = self._values.get("lightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanHsl(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanHslList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanHslList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__07bc4000fe636edbda52efe29472d8834e1687fa15e6374d99fa03bd377dbb03)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanHslOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b9952896d45cb1905950f18c2858fb113314232814ff937ca04ad4282cd6abd3)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanHslOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1c6b1f30439a6653ffb163b6ced467f2aac4d16f683ee914a90de0d1867db906)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7919e40b004544e9e3e7f58217b96135aefd3e24c28d486d091f2800c06c2351)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7cf1ccc895486deaa93fa8d0939a9378b27cc4b80fd3a3c81580291dfc9c230c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanHsl]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanHsl]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__41b3cd334b0009aa9a6a2cc6a4fda81c9736a8aadfc1e744cdbb61cf9da99a23)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanHslOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanHslOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1a064096ba15afbde16fc1da48e53b38443faa4a14ee9050a9a44d630af1d443)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightness")
    def reset_lightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightness", []))

    @jsii.member(jsii_name="resetLightnessVar")
    def reset_lightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessInput")
    def lightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessVarInput")
    def lightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f96dfd9f231ced03a343a59731e9ca6f537e3c8c883c9fe1375b4038ace1a23)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f30895a49670d615183428cfb8b7a27a3293125c1e3a437db0b4fb2172cbab24)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightness")
    def lightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightness"))

    @lightness.setter
    def lightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ccb1d398081a1297162bd50f3c9be2289a15c6b399ff5c754d0c01b5f0a89a7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightness", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessVar")
    def lightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessVar"))

    @lightness_var.setter
    def lightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bec874551c11142dcbd9c947d14c85bbbacd6b731387f21b19b32af2a4cf0f04)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fd411137b911f89294340eeeeced41d2f5641e3a4f306c28dd422b8559053422)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__746c2a36a5f69af63befe1b58811363ef3f27abfe1631e2f2d41768fed3f6f9f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanHsl]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanHsl]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanHsl]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2c2c98999962f2642361d85709a33854bfe79884cc10146817078e989660309c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanHsv",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanHsv:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        :param value: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc3701b68095eeee58386b22e5754215c5086cfada89b7ad037944dd3380c6aa)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanHsv(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanHsvList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanHsvList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9831078130c3dd700c463e72c33c98ef723d60effe795bd756b965b6230e1cda)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanHsvOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4aafa89b73ddefcba8286021b863b7ba80eb1917c8d13a032ed7aad0d9932eda)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanHsvOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__adb9be11b7b78e418ae9285b785c700f605b52091fd904ece4ada727b4417236)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a8909b9dd78217fc0e98fbade41b945f5b990c4df0d6855f61268292985b9f8f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ef83c345eca4e184f7a2b162dbbaf2694f3d14dd74b8fef2c20a669d9066b57d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanHsv]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanHsv]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__78243a538f6035db383dda2265dd095074b791d3ff3cf1cd70a01691a46c7974)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanHsvOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanHsvOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7456a7aa1a378840c22b2690e5e71822c1cef66e5f7e856c7b8b64e3c222c57a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__542d34c1c5fc98127da4d4fe707c418605fc528a8bbce05b86ef381660f2980d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6673c7ee72cddec8ee3ba98f89ad8f4f2ecef79be267188e07b2c3b0b76a3c95)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__684384df9c33cdf487e08a9b199d434e7179ea78bdcec9048327d61d9fcb4df9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b2d6f63cebc06b47cfa53190dc4a515312c342b3d846dce7307387c7694afa19)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7b5699f6ddde83bca44e5b835ebee266ed7c4f2ce34d9dac29d48fbb18d51dc2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c5dd712bea2532682a50d1c0e9df122cafa5126b47a7a28b5676d25e9a78c26f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanHsv]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanHsv]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanHsv]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1921ba8daa138bea83bba22390af6e131f3df7d375c3172e73e06d9ff82242a5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimension",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "dimension": "dimension",
        "dimension_var": "dimensionVar",
        "equal": "equal",
        "greater_than": "greaterThan",
        "less_than": "lessThan",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimension:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        dimension: typing.Optional[builtins.str] = None,
        dimension_var: typing.Optional[builtins.str] = None,
        equal: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionEqual", typing.Dict[builtins.str, typing.Any]]] = None,
        greater_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionGreaterThan", typing.Dict[builtins.str, typing.Any]]] = None,
        less_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionLessThan", typing.Dict[builtins.str, typing.Any]]] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param dimension: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        :param dimension_var: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        :param equal: equal block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        :param greater_than: greater_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        :param less_than: less_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        :param value: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionDefault(**default)
        if isinstance(equal, dict):
            equal = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionEqual(**equal)
        if isinstance(greater_than, dict):
            greater_than = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionGreaterThan(**greater_than)
        if isinstance(less_than, dict):
            less_than = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionLessThan(**less_than)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7064fbd5776ce0803686b61581bbc65506d09934b58a39095ee60077f89dec1b)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument dimension", value=dimension, expected_type=type_hints["dimension"])
            check_type(argname="argument dimension_var", value=dimension_var, expected_type=type_hints["dimension_var"])
            check_type(argname="argument equal", value=equal, expected_type=type_hints["equal"])
            check_type(argname="argument greater_than", value=greater_than, expected_type=type_hints["greater_than"])
            check_type(argname="argument less_than", value=less_than, expected_type=type_hints["less_than"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if dimension is not None:
            self._values["dimension"] = dimension
        if dimension_var is not None:
            self._values["dimension_var"] = dimension_var
        if equal is not None:
            self._values["equal"] = equal
        if greater_than is not None:
            self._values["greater_than"] = greater_than
        if less_than is not None:
            self._values["less_than"] = less_than
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionDefault"], result)

    @builtins.property
    def dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        '''
        result = self._values.get("dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        '''
        result = self._values.get("dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def equal(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionEqual"]:
        '''equal block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        '''
        result = self._values.get("equal")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionEqual"], result)

    @builtins.property
    def greater_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionGreaterThan"]:
        '''greater_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        '''
        result = self._values.get("greater_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionGreaterThan"], result)

    @builtins.property
    def less_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionLessThan"]:
        '''less_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        '''
        result = self._values.get("less_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionLessThan"], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimension(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__03213c7a8ef656db96465fc1b9519983f7d7909f9ae79572c01dcf88e0723ccf)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__573061c3a4a23cceb91528ae23bcd1957fffe7fa9d6c97b5f4981f01e70b6426)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionEqual",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionEqual:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionEqual(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionEqualOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionEqualOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3bf5723273ad8460e49d91a51a8fc94084f2563ee83cc29ad4e8eae0de2a46a0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionEqual], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionEqual],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c584d4865f63b13fcb429bb8ea88e4da9cc8a259e06040db151c474aa23bbee2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionGreaterThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionGreaterThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionGreaterThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionGreaterThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionGreaterThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cac578bc45a5abd4a0ab985af9a98e7ef85706bd9a00a8c88c134d1b7398fecf)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionGreaterThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionGreaterThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__480f49179b4c93c187183c722ef00912282da9de9e1c8008e46db9519ef57cec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionLessThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionLessThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionLessThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionLessThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionLessThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4bfb8bc332226fa985dba809b6a8db4b23a7dae8d8c70849f318b32f49852762)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionLessThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionLessThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__85ec4925e7b6fe9dff271f92412e10aeabbd30e9c3d49f70988dc1fd1ab503bd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e64c6ebb446305d42e7a693fc89454513affb86e3a6f476866384b467ab0e3ae)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__49b8ac3cf8b65572aca0887a47e49e249469bd905036d9c537dd3a7d946b26a6)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7b2b227cd0a79313872f4a243a1f4ee97d19ad6054a9ca9176085179a101f7f7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4b9ebb66a580324ae9da47a64df9a27965e669b9b0ad9afa305aa98826370941)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8fa3616b6e0411d3d1bf46608d9cc92e3cf56c8b86bb9491afbecc67e47cbce5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimension]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimension]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ebcbaca071694af7120ce8007b816c6b308e470701a770cddd6419fd2d1f7a9d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f8b5129d24856d304281da641fde4f49fe2394421a51866f9ee98c9f410dfd9c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putEqual")
    def put_equal(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionEqual()

        return typing.cast(None, jsii.invoke(self, "putEqual", [value]))

    @jsii.member(jsii_name="putGreaterThan")
    def put_greater_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionGreaterThan()

        return typing.cast(None, jsii.invoke(self, "putGreaterThan", [value]))

    @jsii.member(jsii_name="putLessThan")
    def put_less_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionLessThan()

        return typing.cast(None, jsii.invoke(self, "putLessThan", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetDimension")
    def reset_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimension", []))

    @jsii.member(jsii_name="resetDimensionVar")
    def reset_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimensionVar", []))

    @jsii.member(jsii_name="resetEqual")
    def reset_equal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEqual", []))

    @jsii.member(jsii_name="resetGreaterThan")
    def reset_greater_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGreaterThan", []))

    @jsii.member(jsii_name="resetLessThan")
    def reset_less_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLessThan", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="equal")
    def equal(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionEqualOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionEqualOutputReference, jsii.get(self, "equal"))

    @builtins.property
    @jsii.member(jsii_name="greaterThan")
    def greater_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionGreaterThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionGreaterThanOutputReference, jsii.get(self, "greaterThan"))

    @builtins.property
    @jsii.member(jsii_name="lessThan")
    def less_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionLessThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionLessThanOutputReference, jsii.get(self, "lessThan"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionInput")
    def dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionVarInput")
    def dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="equalInput")
    def equal_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionEqual], jsii.get(self, "equalInput"))

    @builtins.property
    @jsii.member(jsii_name="greaterThanInput")
    def greater_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionGreaterThan], jsii.get(self, "greaterThanInput"))

    @builtins.property
    @jsii.member(jsii_name="lessThanInput")
    def less_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionLessThan], jsii.get(self, "lessThanInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="dimension")
    def dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimension"))

    @dimension.setter
    def dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6b6bada9ddac11813008cdc77ca5f587d9c4d16329a848ab556794b57011e68b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimension", value)

    @builtins.property
    @jsii.member(jsii_name="dimensionVar")
    def dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimensionVar"))

    @dimension_var.setter
    def dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__419ce132ba1ad7b8c580d9a97ae61aebfc771496b7cff11dcb360ba7edcbdf23)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0823edb312e9cce1ea1cf1638271e86b18b9a22e73dcc8b94210d650cb66bebb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__657e0049ca1e4ef1aeccc1b486a84d305c06989622c869c59879b0a44f576323)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimension]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimension]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimension]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d6508dba7c186f414312ce40d0912640a35e98fc3cbb47bc62451425bf866cd1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientation",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "landscape": "landscape",
        "portrait": "portrait",
        "square": "square",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientation:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        landscape: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationLandscape", typing.Dict[builtins.str, typing.Any]]] = None,
        portrait: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationPortrait", typing.Dict[builtins.str, typing.Any]]] = None,
        square: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationSquare", typing.Dict[builtins.str, typing.Any]]] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param landscape: landscape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        :param portrait: portrait block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        :param square: square block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationDefault(**default)
        if isinstance(landscape, dict):
            landscape = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationLandscape(**landscape)
        if isinstance(portrait, dict):
            portrait = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationPortrait(**portrait)
        if isinstance(square, dict):
            square = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationSquare(**square)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2099fbdd69142bfcdc2cb53b574eb783c0809127ba72a1d146686dc4b5067954)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument landscape", value=landscape, expected_type=type_hints["landscape"])
            check_type(argname="argument portrait", value=portrait, expected_type=type_hints["portrait"])
            check_type(argname="argument square", value=square, expected_type=type_hints["square"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if landscape is not None:
            self._values["landscape"] = landscape
        if portrait is not None:
            self._values["portrait"] = portrait
        if square is not None:
            self._values["square"] = square

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationDefault"], result)

    @builtins.property
    def landscape(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationLandscape"]:
        '''landscape block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        '''
        result = self._values.get("landscape")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationLandscape"], result)

    @builtins.property
    def portrait(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationPortrait"]:
        '''portrait block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        '''
        result = self._values.get("portrait")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationPortrait"], result)

    @builtins.property
    def square(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationSquare"]:
        '''square block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        result = self._values.get("square")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationSquare"], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8c909568b3c3174fd6511f8b550159d6ddac0f9c1ebd204ae5ff7cc68e791ebc)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7df303d38352bca34de1cdc01d75eea85191caab52a445fe3391424c3a30908f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationLandscape",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationLandscape:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationLandscape(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationLandscapeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationLandscapeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f0d39ec83ab5b35e399a211d1a326d2315a50a0a2c550c515ddf75b67c6a876b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationLandscape], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationLandscape],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fff7e53a9d075090851810f4e1c30d1b791199bbbd9e64892ea69cba355459cf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f495cb1abbc372fe13508dbde7b136a806cf11452a075cbb4e24e0b10533ff17)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9499f53eb8570aa5ee94ad0e74d32f5c5c563ebdb3c4f5e4bef3fc846d224804)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7a6c8e05877034dceaa05b8a27ab544ca3685ee7afb8dfd2be457196eaf63618)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c9f6f48e61c61b73fe6484e0b950794eddb2fa5abae87fa7c973bd192153d4a7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ce4d0a95d2ae537a48f9227225171593dd84a623b6a6c1ef2054607031994a1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientation]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientation]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a816ac36e91cb60bfddd3a6da00d95a9bc2989d73676b33c9e4cc007f014427)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7eaf750755b60796b243f127fc252e52c90ae47ce86c3434fb8558216e55d422)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putLandscape")
    def put_landscape(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationLandscape()

        return typing.cast(None, jsii.invoke(self, "putLandscape", [value]))

    @jsii.member(jsii_name="putPortrait")
    def put_portrait(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationPortrait()

        return typing.cast(None, jsii.invoke(self, "putPortrait", [value]))

    @jsii.member(jsii_name="putSquare")
    def put_square(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationSquare()

        return typing.cast(None, jsii.invoke(self, "putSquare", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetLandscape")
    def reset_landscape(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLandscape", []))

    @jsii.member(jsii_name="resetPortrait")
    def reset_portrait(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPortrait", []))

    @jsii.member(jsii_name="resetSquare")
    def reset_square(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSquare", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="landscape")
    def landscape(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationLandscapeOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationLandscapeOutputReference, jsii.get(self, "landscape"))

    @builtins.property
    @jsii.member(jsii_name="portrait")
    def portrait(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationPortraitOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationPortraitOutputReference", jsii.get(self, "portrait"))

    @builtins.property
    @jsii.member(jsii_name="square")
    def square(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationSquareOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationSquareOutputReference", jsii.get(self, "square"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="landscapeInput")
    def landscape_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationLandscape], jsii.get(self, "landscapeInput"))

    @builtins.property
    @jsii.member(jsii_name="portraitInput")
    def portrait_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationPortrait"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationPortrait"], jsii.get(self, "portraitInput"))

    @builtins.property
    @jsii.member(jsii_name="squareInput")
    def square_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationSquare"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationSquare"], jsii.get(self, "squareInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientation]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientation]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientation]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a9e6da6ef071f28f94697019c84033a22610be4dc61ca5dcd6c0357d1e1f3379)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationPortrait",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationPortrait:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationPortrait(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationPortraitOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationPortraitOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1a0da2386172e45256b55685976293869ed58e2c0ed6e8c9b0554dd0d5d7a86b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationPortrait]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationPortrait], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationPortrait],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__50de0cf583a39f50fdb8ca7bad83311292a776951d31d37b1a9c359bbbdf71ed)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationSquare",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationSquare:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationSquare(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationSquareOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationSquareOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3d3bb0b584fbf3a3ec9f26c3f6f437018d55d72e815d9e9e5fd2b9a558bc49d7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationSquare]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationSquare], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationSquare],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__059b6d51c9c32805df1d7efeb700b9782d3c7fa7a0840d29749944284539f7f0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanImQuery",
    jsii_struct_bases=[],
    name_mapping={
        "allowed_transformations": "allowedTransformations",
        "query_var": "queryVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanImQuery:
    def __init__(
        self,
        *,
        allowed_transformations: typing.Sequence[builtins.str],
        query_var: builtins.str,
    ) -> None:
        '''
        :param allowed_transformations: Specifies the transformations that can be applied using the query string parameter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allowed_transformations DataAkamaiImagingPolicyImage#allowed_transformations}
        :param query_var: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#query_var DataAkamaiImagingPolicyImage#query_var}.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f3d6cc4e578702a9bbb5d7c401d583d2d0935b84affa8d93ecceab42a85d9a34)
            check_type(argname="argument allowed_transformations", value=allowed_transformations, expected_type=type_hints["allowed_transformations"])
            check_type(argname="argument query_var", value=query_var, expected_type=type_hints["query_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "allowed_transformations": allowed_transformations,
            "query_var": query_var,
        }

    @builtins.property
    def allowed_transformations(self) -> typing.List[builtins.str]:
        '''Specifies the transformations that can be applied using the query string parameter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allowed_transformations DataAkamaiImagingPolicyImage#allowed_transformations}
        '''
        result = self._values.get("allowed_transformations")
        assert result is not None, "Required property 'allowed_transformations' is missing"
        return typing.cast(typing.List[builtins.str], result)

    @builtins.property
    def query_var(self) -> builtins.str:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#query_var DataAkamaiImagingPolicyImage#query_var}.'''
        result = self._values.get("query_var")
        assert result is not None, "Required property 'query_var' is missing"
        return typing.cast(builtins.str, result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanImQuery(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanImQueryList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanImQueryList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c85fa188d283d3479666ad5f1dab31176e81d8567f4fd5fd3198db0c84c16ebd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanImQueryOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__905cf7a2e87aff236899bb7a6b5d1578378c61e73559598553240e96acefd99e)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanImQueryOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__51a44d43957db1045c56287f082c97adc2bf96e3bb24f309ce9272b81ea2b7d4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__745e95e9022a1536954ea4b35e67b2dbe667d3c3decb49c6fb6db436fff31297)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ccac70e20d3c2e3783498ecabea437d9814ecd96c835f7c7e901f269df56101e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanImQuery]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanImQuery]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanImQuery]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__06d159fc89e2a16310ed688592fee39f78efee8b3bcdf12de0e02980303e9652)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanImQueryOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanImQueryOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d622d82c3e374c439fdd9844e3e8889f8de6ffd1be2aac6a99da456f5d428d1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @builtins.property
    @jsii.member(jsii_name="allowedTransformationsInput")
    def allowed_transformations_input(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "allowedTransformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="queryVarInput")
    def query_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "queryVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowedTransformations")
    def allowed_transformations(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "allowedTransformations"))

    @allowed_transformations.setter
    def allowed_transformations(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f28263133cd6e1515ae654d47c8436b492d7fc5904b82faae13a635fd1f2a9f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowedTransformations", value)

    @builtins.property
    @jsii.member(jsii_name="queryVar")
    def query_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "queryVar"))

    @query_var.setter
    def query_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0498479b1ab4b09e74c27903ad6a9229443d7d2e2362f23b76f037657e447170)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "queryVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanImQuery]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanImQuery]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanImQuery]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__46f8cbefe237eafa77a665bd36350fd7d846f4131eba6e5eb664a9751e75c662)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanMaxColors",
    jsii_struct_bases=[],
    name_mapping={"colors": "colors", "colors_var": "colorsVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanMaxColors:
    def __init__(
        self,
        *,
        colors: typing.Optional[builtins.str] = None,
        colors_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param colors: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        :param colors_var: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__804e5a6bde7db558b8be28a702a07e61b42b8803599c18ff552b3f53a3abb588)
            check_type(argname="argument colors", value=colors, expected_type=type_hints["colors"])
            check_type(argname="argument colors_var", value=colors_var, expected_type=type_hints["colors_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if colors is not None:
            self._values["colors"] = colors
        if colors_var is not None:
            self._values["colors_var"] = colors_var

    @builtins.property
    def colors(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        '''
        result = self._values.get("colors")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def colors_var(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        result = self._values.get("colors_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanMaxColors(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanMaxColorsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanMaxColorsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3cddcd2be561cc27d5460b10045dc918f1f46a01db173d6d67bbe39c30645d3f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanMaxColorsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7b8f9966f17118470775cd5ebda9d2df2c8fe84d52d9ba89f1d4414ce0fc2b98)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanMaxColorsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__23f70e4df98a1886999725b7a7f1845c2697445f3c1b7bf55dd14faa19478f72)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f450f87e29da0436ba1a064c1196eafee45f65f4d64b62daf82391e2293b910)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__147446dce50489c811992eaf61a8ffaa04c6a8b9696d3fd2c01124fa2953aecd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanMaxColors]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanMaxColors]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8f569247d1c9912f68caabfb2d66286be16f8eea555a6cf8d521daf32c9ba351)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanMaxColorsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanMaxColorsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fb630027deb00db26a1c7ab9efe7ccda574976bdd4bef7ed1a7cd9c49bbd65a0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColors")
    def reset_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColors", []))

    @jsii.member(jsii_name="resetColorsVar")
    def reset_colors_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorsVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorsInput")
    def colors_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsInput"))

    @builtins.property
    @jsii.member(jsii_name="colorsVarInput")
    def colors_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsVarInput"))

    @builtins.property
    @jsii.member(jsii_name="colors")
    def colors(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colors"))

    @colors.setter
    def colors(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9b588c31d46065e855101024fa54b1282ed130f2539eea5a23ea6dc69fcb7430)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colors", value)

    @builtins.property
    @jsii.member(jsii_name="colorsVar")
    def colors_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorsVar"))

    @colors_var.setter
    def colors_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__53cfdbbcd2b492b007460a9523fce6728bdf5327b3f3aa8f6daab767b3dd011b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorsVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanMaxColors]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanMaxColors]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanMaxColors]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6ded0b3191d96d7787d646f463934f70354f12ade5d9dc2f927e671c646502f9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanMirror",
    jsii_struct_bases=[],
    name_mapping={
        "horizontal": "horizontal",
        "horizontal_var": "horizontalVar",
        "vertical": "vertical",
        "vertical_var": "verticalVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanMirror:
    def __init__(
        self,
        *,
        horizontal: typing.Optional[builtins.str] = None,
        horizontal_var: typing.Optional[builtins.str] = None,
        vertical: typing.Optional[builtins.str] = None,
        vertical_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param horizontal: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        :param horizontal_var: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        :param vertical: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        :param vertical_var: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ddca5996ed4074a6264df130766d3a15909b17a36204314dddee3b9bd859ec05)
            check_type(argname="argument horizontal", value=horizontal, expected_type=type_hints["horizontal"])
            check_type(argname="argument horizontal_var", value=horizontal_var, expected_type=type_hints["horizontal_var"])
            check_type(argname="argument vertical", value=vertical, expected_type=type_hints["vertical"])
            check_type(argname="argument vertical_var", value=vertical_var, expected_type=type_hints["vertical_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if horizontal is not None:
            self._values["horizontal"] = horizontal
        if horizontal_var is not None:
            self._values["horizontal_var"] = horizontal_var
        if vertical is not None:
            self._values["vertical"] = vertical
        if vertical_var is not None:
            self._values["vertical_var"] = vertical_var

    @builtins.property
    def horizontal(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        '''
        result = self._values.get("horizontal")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def horizontal_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        '''
        result = self._values.get("horizontal_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        '''
        result = self._values.get("vertical")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        result = self._values.get("vertical_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanMirror(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanMirrorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanMirrorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d6398356fc8cfabdf0dac3ca4c5b0aa738bfd33c90e9bfa249c3edc2212bff53)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanMirrorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3aa24f6e6ac0af12a0f8a71a9606e9b9d1e4ba8b189eba36d6bc7d797980cd4c)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanMirrorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__42b7a0727bbf52ff642954b2b5ac05be30854e9d405054efe8026b0e5317ba8d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__64042955ae0b81b3ec11928e2a4d38f6d34663aab73b0bb916a52bc1354ffda9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a3bd7002b6be680008638367faea1ab0b026704f3b426aee0443e07f9ff495eb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanMirror]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanMirror]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d50bad75ecf1feda02056345bc862190bdbc72ad714cba268de6886904e97560)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanMirrorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanMirrorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d0528b61785ae7a40dfbb007c4085ff7900d16be84060596dada0aacdc760eee)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHorizontal")
    def reset_horizontal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontal", []))

    @jsii.member(jsii_name="resetHorizontalVar")
    def reset_horizontal_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontalVar", []))

    @jsii.member(jsii_name="resetVertical")
    def reset_vertical(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVertical", []))

    @jsii.member(jsii_name="resetVerticalVar")
    def reset_vertical_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVerticalVar", []))

    @builtins.property
    @jsii.member(jsii_name="horizontalInput")
    def horizontal_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontalVarInput")
    def horizontal_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalInput")
    def vertical_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalVarInput")
    def vertical_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontal")
    def horizontal(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontal"))

    @horizontal.setter
    def horizontal(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6d1fd829ba46f23508a00d7063f9838d7b2aa772c22e61be5568c2f6a2ba7d7d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontal", value)

    @builtins.property
    @jsii.member(jsii_name="horizontalVar")
    def horizontal_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontalVar"))

    @horizontal_var.setter
    def horizontal_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__586ebaba938d61e4218e506743b6bb2084d3582845747262b9c18c1cd3cf5ec2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontalVar", value)

    @builtins.property
    @jsii.member(jsii_name="vertical")
    def vertical(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "vertical"))

    @vertical.setter
    def vertical(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__055545eeed02187ec3440a56f2587f0d802a20464349dae717d778a93430968f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "vertical", value)

    @builtins.property
    @jsii.member(jsii_name="verticalVar")
    def vertical_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "verticalVar"))

    @vertical_var.setter
    def vertical_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__486aab051d63c27c85e6c44efb76cc897b7b3d8090860cf6744f337e61e3f982)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "verticalVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanMirror]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanMirror]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanMirror]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1219e33b8ae2eef0c19c841ac5705c28910922b0001744dd3dcc1e95f6ddfeb3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanMonoHue",
    jsii_struct_bases=[],
    name_mapping={"hue": "hue", "hue_var": "hueVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanMonoHue:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d2c8c4098030f0bb681c6f7127b6128022cdaeb3c8161200fe5fcda902adeb6f)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanMonoHue(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanMonoHueList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanMonoHueList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7f516a919c3f4f2ac1da158150f79eda530b22b8b21e4afd081fcba6a1a1a806)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanMonoHueOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2543de4945bcc37b918be08173b95a90a3ea7b6d42846cb2955b4ac0d7c99ae9)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanMonoHueOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e4f56933657ded35d80a94d49d328b75b3ea92ceb61cf214569158dd225b0033)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__69e0498e5c6f3b345c9a357b7d5b7a5fac2acb6fdfa329a20acd53321573db2f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5393fb35794093187f2bf9181699e602c62d91efdb4cc0a8f4e2da0bb716e2a2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanMonoHue]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanMonoHue]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9b5f776d0746bd2dc31591cf893c78c6368d46d6956ea7709aa9e7823a7ebebf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanMonoHueOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanMonoHueOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8168198bf526058ce41700b34a64f0861d4b8085e546e96b582816da2395828b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f2c36852d73974bac035e00af923525a4928561b7fa98a67acaf9571e90bc632)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__78bd63b2a62110f889d6bef9655df525c47a259b0578471c8da218e43272d2a4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanMonoHue]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanMonoHue]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanMonoHue]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0bb6ebfef7fb3d56936e0ec6f6b930106c4f7fcc92882100b3be4b7e37e8ca6b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanOpacity",
    jsii_struct_bases=[],
    name_mapping={"opacity": "opacity", "opacity_var": "opacityVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanOpacity:
    def __init__(
        self,
        *,
        opacity: typing.Optional[builtins.str] = None,
        opacity_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param opacity: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param opacity_var: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b63b2d37454c0438115e8cf966c1213a2580e89a77219da7febb8e83f04de7cc)
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument opacity_var", value=opacity_var, expected_type=type_hints["opacity_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if opacity is not None:
            self._values["opacity"] = opacity
        if opacity_var is not None:
            self._values["opacity_var"] = opacity_var

    @builtins.property
    def opacity(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def opacity_var(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        result = self._values.get("opacity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanOpacity(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanOpacityList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanOpacityList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__94d34ce562395aed98436511619878931f26b0d6f4c74b437d73c93886b55e7d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanOpacityOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__52d23e5c35b895a137e20d39fd14ab31bba69b517151eec805cfdc0533126212)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanOpacityOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2f9529ae0badb654017c79b4814b2122562dc55322099d5100428ad9397e9a47)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4aa07a5871bfb98c248aa58f19e32cc905d1cc081d6a529f43d4e47c16b52819)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__338f7b7614d54e76f18eb937d95ae7545ebb3d800f981207e052c1d1331ef7b6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanOpacity]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanOpacity]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9e55be3fc6ac0fd0d36ff8996d3ec81720891cc503e5bfb4426ece42f854c96c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanOpacityOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanOpacityOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9c5c59ee42d9ae74a99138252e2b24d494b453493ccaaa9707aa9345ab096de4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetOpacityVar")
    def reset_opacity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacityVar", []))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityVarInput")
    def opacity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacity"))

    @opacity.setter
    def opacity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7230bd1fc6ab37dbc5838ee43158866e77854e11986b8ac353d16c281e8adb85)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacity", value)

    @builtins.property
    @jsii.member(jsii_name="opacityVar")
    def opacity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacityVar"))

    @opacity_var.setter
    def opacity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__17639f631593afd24e9ea563ba6f62bc321125f4e587621d9382a0b8de932a03)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacityVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanOpacity]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanOpacity]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanOpacity]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__55e4a976a783c044fabeaad283fdcc089f96fe5f921a92cdb8e055e88338e73f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b16a0774d5dd760256ace8280b85e175038f0d20ef6acd8bd27e0ae39b6eef0d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putAppend")
    def put_append(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanAppend, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be53e767feeac9acdd01ba3ff30db119dc593825f711c733fe48b7a3e27f0099)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putAppend", [value]))

    @jsii.member(jsii_name="putAspectCrop")
    def put_aspect_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanAspectCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a35631cf6160dde7ac2ab4f32125ab6a2cb436fcf82c3b5501b441acddb0aca9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putAspectCrop", [value]))

    @jsii.member(jsii_name="putBackgroundColor")
    def put_background_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e1758b91bbbe1f5139ade1f92136c140a584685681f50ec5eb82cea163cc928f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBackgroundColor", [value]))

    @jsii.member(jsii_name="putBlur")
    def put_blur(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanBlur, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a1467370dd895f2790bee8d9d1a156184a8e2de487b5f8f30e843a32f093e2de)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBlur", [value]))

    @jsii.member(jsii_name="putChromaKey")
    def put_chroma_key(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanChromaKey, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3542f4da19249137147858ed657f6f768164200c0d03b34f24d31460e5662190)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putChromaKey", [value]))

    @jsii.member(jsii_name="putComposite")
    def put_composite(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanComposite, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7e791a1334b35a4cb00ca89cd3783e489fc31fec16b947a492bd9a8867134f85)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putComposite", [value]))

    @jsii.member(jsii_name="putCompound")
    def put_compound(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanCompound, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df11f140c521fb769bc3a8734664c277df5d67c36ae3d6932870e21b41b81cb0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCompound", [value]))

    @jsii.member(jsii_name="putContrast")
    def put_contrast(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanContrast, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6d40b1ab5692cd3b7b84f7ab0fdcabe49d74e02cffd6de2108dce49166a278b1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putContrast", [value]))

    @jsii.member(jsii_name="putCrop")
    def put_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0e5ad200b93011b14895e3c51a47401e0250f9a655c7ff9f6102d3abf5709034)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCrop", [value]))

    @jsii.member(jsii_name="putFaceCrop")
    def put_face_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanFaceCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3e1599c0aafb93dd27bef0b01d9606b074bef28e7942968d17649120a360a962)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFaceCrop", [value]))

    @jsii.member(jsii_name="putFeatureCrop")
    def put_feature_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanFeatureCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7ff0e5de2bcb7889f5812a9b4861a9ddb8f80217cedfbf9e995ded94288755a2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFeatureCrop", [value]))

    @jsii.member(jsii_name="putFitAndFill")
    def put_fit_and_fill(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanFitAndFill, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4c0e69ab6b936c90866596f5c6df0490649d82071637cfd352de742f97e359d0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFitAndFill", [value]))

    @jsii.member(jsii_name="putGoop")
    def put_goop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanGoop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a148f64ebaddbab785ea7c5ceb92a51d06280bc24529de25a630473cb6196f0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGoop", [value]))

    @jsii.member(jsii_name="putGrayscale")
    def put_grayscale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanGrayscale, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fbe142b5eab7184d5502681f57c18d12427ceecb9b884457da5138f585c98014)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGrayscale", [value]))

    @jsii.member(jsii_name="putHsl")
    def put_hsl(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanHsl, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__41859ca55d0e545ce5910b36cfb8776dda8ff2aa48d41865fbc2af19f8e3b36d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsl", [value]))

    @jsii.member(jsii_name="putHsv")
    def put_hsv(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanHsv, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9e579de2d7fb783e276e269fc13933d812ae0a42e0d5f3b36596e009b88d26c0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsv", [value]))

    @jsii.member(jsii_name="putIfDimension")
    def put_if_dimension(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimension, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c3f1c8acd75e5ce9b80f300a07814cf6bb4f7bcdef5bd848f17171d92e3299f3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfDimension", [value]))

    @jsii.member(jsii_name="putIfOrientation")
    def put_if_orientation(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__511c135054e2a1e078a18a82c239a7693f876622ee5319f1bfb54bbb8f0242f3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfOrientation", [value]))

    @jsii.member(jsii_name="putImQuery")
    def put_im_query(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanImQuery, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a5b538714cbdc6db6bb90983509975fad4c9f738f497ef5d20f5d3f66465900)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putImQuery", [value]))

    @jsii.member(jsii_name="putMaxColors")
    def put_max_colors(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanMaxColors, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0bdd4648019224deb8684cf83c9f8af49d67e569fafcfae4704ef1211157bb7f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMaxColors", [value]))

    @jsii.member(jsii_name="putMirror")
    def put_mirror(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanMirror, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1ec901ff75a692f349865f02946c982a44c4b48b815c13087dba5b6e4833ed1d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMirror", [value]))

    @jsii.member(jsii_name="putMonoHue")
    def put_mono_hue(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanMonoHue, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__535018c1e687186734852fd1e9a3679a82d1957c91095e1cfc0825a24f7fab8f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMonoHue", [value]))

    @jsii.member(jsii_name="putOpacity")
    def put_opacity(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanOpacity, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4f514481edbf25e385b8eaa72b8fb282ab6f3b3dc171d588bb4c7b60a9483710)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putOpacity", [value]))

    @jsii.member(jsii_name="putRegionOfInterestCrop")
    def put_region_of_interest_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanRegionOfInterestCrop", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b47423106bd5c57fbecc1106b03ee66929f2e88e22df70e90efc68bcdfd7c0aa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRegionOfInterestCrop", [value]))

    @jsii.member(jsii_name="putRelativeCrop")
    def put_relative_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanRelativeCrop", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f8ece44121da9264bab0e4d755f024c25bc3734ad73a5206f827542758193d95)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRelativeCrop", [value]))

    @jsii.member(jsii_name="putRemoveColor")
    def put_remove_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanRemoveColor", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4f0e4153c2addde23d28e9a63a8f1a51be7c36cb1cf20456aa3862fe689d24bc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRemoveColor", [value]))

    @jsii.member(jsii_name="putResize")
    def put_resize(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanResize", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3d4c3ed5e2ecd24167cdbc2d195f0884d463066743ddab24b0c4e0fd99e0f977)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putResize", [value]))

    @jsii.member(jsii_name="putRotate")
    def put_rotate(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanRotate", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__14c72f58d973f5901f26d01dcad8f77e8aac597df52e1737e19efea602c2bfac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRotate", [value]))

    @jsii.member(jsii_name="putScale")
    def put_scale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanScale", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8123c1eb5dd0fc4a4a68f7d1dfabc82951fbb56d268b8c3a9268f471473d1fe5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putScale", [value]))

    @jsii.member(jsii_name="putShear")
    def put_shear(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanShear", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c91560aecdbde15fd04803e2221d2f3cfde68f7d9864baace2f926a8000715ee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putShear", [value]))

    @jsii.member(jsii_name="putTrim")
    def put_trim(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanTrim", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f5e74238343bf7a2bce94d6e53ad254a0199a53f29667d3379ca3443ff759a8b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTrim", [value]))

    @jsii.member(jsii_name="putUnsharpMask")
    def put_unsharp_mask(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanUnsharpMask", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1ab25b2288c37312f8670d678c872c3feb9a615b5da6853bf7ebc1feeb01557f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putUnsharpMask", [value]))

    @jsii.member(jsii_name="resetAppend")
    def reset_append(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAppend", []))

    @jsii.member(jsii_name="resetAspectCrop")
    def reset_aspect_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspectCrop", []))

    @jsii.member(jsii_name="resetBackgroundColor")
    def reset_background_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBackgroundColor", []))

    @jsii.member(jsii_name="resetBlur")
    def reset_blur(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBlur", []))

    @jsii.member(jsii_name="resetChromaKey")
    def reset_chroma_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChromaKey", []))

    @jsii.member(jsii_name="resetComposite")
    def reset_composite(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetComposite", []))

    @jsii.member(jsii_name="resetCompound")
    def reset_compound(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCompound", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetCrop")
    def reset_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCrop", []))

    @jsii.member(jsii_name="resetFaceCrop")
    def reset_face_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFaceCrop", []))

    @jsii.member(jsii_name="resetFeatureCrop")
    def reset_feature_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureCrop", []))

    @jsii.member(jsii_name="resetFitAndFill")
    def reset_fit_and_fill(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFitAndFill", []))

    @jsii.member(jsii_name="resetGoop")
    def reset_goop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGoop", []))

    @jsii.member(jsii_name="resetGrayscale")
    def reset_grayscale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGrayscale", []))

    @jsii.member(jsii_name="resetHsl")
    def reset_hsl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsl", []))

    @jsii.member(jsii_name="resetHsv")
    def reset_hsv(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsv", []))

    @jsii.member(jsii_name="resetIfDimension")
    def reset_if_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfDimension", []))

    @jsii.member(jsii_name="resetIfOrientation")
    def reset_if_orientation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfOrientation", []))

    @jsii.member(jsii_name="resetImQuery")
    def reset_im_query(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetImQuery", []))

    @jsii.member(jsii_name="resetMaxColors")
    def reset_max_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxColors", []))

    @jsii.member(jsii_name="resetMirror")
    def reset_mirror(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMirror", []))

    @jsii.member(jsii_name="resetMonoHue")
    def reset_mono_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonoHue", []))

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetRegionOfInterestCrop")
    def reset_region_of_interest_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRegionOfInterestCrop", []))

    @jsii.member(jsii_name="resetRelativeCrop")
    def reset_relative_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRelativeCrop", []))

    @jsii.member(jsii_name="resetRemoveColor")
    def reset_remove_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRemoveColor", []))

    @jsii.member(jsii_name="resetResize")
    def reset_resize(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetResize", []))

    @jsii.member(jsii_name="resetRotate")
    def reset_rotate(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRotate", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetShear")
    def reset_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetShear", []))

    @jsii.member(jsii_name="resetTrim")
    def reset_trim(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTrim", []))

    @jsii.member(jsii_name="resetUnsharpMask")
    def reset_unsharp_mask(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUnsharpMask", []))

    @builtins.property
    @jsii.member(jsii_name="append")
    def append(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanAppendList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanAppendList, jsii.get(self, "append"))

    @builtins.property
    @jsii.member(jsii_name="aspectCrop")
    def aspect_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanAspectCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanAspectCropList, jsii.get(self, "aspectCrop"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColor")
    def background_color(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanBackgroundColorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanBackgroundColorList, jsii.get(self, "backgroundColor"))

    @builtins.property
    @jsii.member(jsii_name="blur")
    def blur(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanBlurList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanBlurList, jsii.get(self, "blur"))

    @builtins.property
    @jsii.member(jsii_name="chromaKey")
    def chroma_key(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanChromaKeyList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanChromaKeyList, jsii.get(self, "chromaKey"))

    @builtins.property
    @jsii.member(jsii_name="composite")
    def composite(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanCompositeList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanCompositeList, jsii.get(self, "composite"))

    @builtins.property
    @jsii.member(jsii_name="compound")
    def compound(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanCompoundList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanCompoundList, jsii.get(self, "compound"))

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanContrastList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanContrastList, jsii.get(self, "contrast"))

    @builtins.property
    @jsii.member(jsii_name="crop")
    def crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanCropList, jsii.get(self, "crop"))

    @builtins.property
    @jsii.member(jsii_name="faceCrop")
    def face_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanFaceCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanFaceCropList, jsii.get(self, "faceCrop"))

    @builtins.property
    @jsii.member(jsii_name="featureCrop")
    def feature_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanFeatureCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanFeatureCropList, jsii.get(self, "featureCrop"))

    @builtins.property
    @jsii.member(jsii_name="fitAndFill")
    def fit_and_fill(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanFitAndFillList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanFitAndFillList, jsii.get(self, "fitAndFill"))

    @builtins.property
    @jsii.member(jsii_name="goop")
    def goop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanGoopList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanGoopList, jsii.get(self, "goop"))

    @builtins.property
    @jsii.member(jsii_name="grayscale")
    def grayscale(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanGrayscaleList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanGrayscaleList, jsii.get(self, "grayscale"))

    @builtins.property
    @jsii.member(jsii_name="hsl")
    def hsl(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanHslList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanHslList, jsii.get(self, "hsl"))

    @builtins.property
    @jsii.member(jsii_name="hsv")
    def hsv(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanHsvList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanHsvList, jsii.get(self, "hsv"))

    @builtins.property
    @jsii.member(jsii_name="ifDimension")
    def if_dimension(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionList, jsii.get(self, "ifDimension"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientation")
    def if_orientation(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationList, jsii.get(self, "ifOrientation"))

    @builtins.property
    @jsii.member(jsii_name="imQuery")
    def im_query(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanImQueryList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanImQueryList, jsii.get(self, "imQuery"))

    @builtins.property
    @jsii.member(jsii_name="maxColors")
    def max_colors(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanMaxColorsList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanMaxColorsList, jsii.get(self, "maxColors"))

    @builtins.property
    @jsii.member(jsii_name="mirror")
    def mirror(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanMirrorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanMirrorList, jsii.get(self, "mirror"))

    @builtins.property
    @jsii.member(jsii_name="monoHue")
    def mono_hue(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanMonoHueList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanMonoHueList, jsii.get(self, "monoHue"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanOpacityList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanOpacityList, jsii.get(self, "opacity"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestCrop")
    def region_of_interest_crop(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanRegionOfInterestCropList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanRegionOfInterestCropList", jsii.get(self, "regionOfInterestCrop"))

    @builtins.property
    @jsii.member(jsii_name="relativeCrop")
    def relative_crop(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanRelativeCropList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanRelativeCropList", jsii.get(self, "relativeCrop"))

    @builtins.property
    @jsii.member(jsii_name="removeColor")
    def remove_color(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanRemoveColorList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanRemoveColorList", jsii.get(self, "removeColor"))

    @builtins.property
    @jsii.member(jsii_name="resize")
    def resize(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanResizeList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanResizeList", jsii.get(self, "resize"))

    @builtins.property
    @jsii.member(jsii_name="rotate")
    def rotate(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanRotateList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanRotateList", jsii.get(self, "rotate"))

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanScaleList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanScaleList", jsii.get(self, "scale"))

    @builtins.property
    @jsii.member(jsii_name="shear")
    def shear(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanShearList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanShearList", jsii.get(self, "shear"))

    @builtins.property
    @jsii.member(jsii_name="trim")
    def trim(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanTrimList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanTrimList", jsii.get(self, "trim"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMask")
    def unsharp_mask(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanUnsharpMaskList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanUnsharpMaskList", jsii.get(self, "unsharpMask"))

    @builtins.property
    @jsii.member(jsii_name="appendInput")
    def append_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanAppend]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanAppend]]], jsii.get(self, "appendInput"))

    @builtins.property
    @jsii.member(jsii_name="aspectCropInput")
    def aspect_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanAspectCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanAspectCrop]]], jsii.get(self, "aspectCropInput"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColorInput")
    def background_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanBackgroundColor]]], jsii.get(self, "backgroundColorInput"))

    @builtins.property
    @jsii.member(jsii_name="blurInput")
    def blur_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanBlur]]], jsii.get(self, "blurInput"))

    @builtins.property
    @jsii.member(jsii_name="chromaKeyInput")
    def chroma_key_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanChromaKey]]], jsii.get(self, "chromaKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="compositeInput")
    def composite_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanComposite]]], jsii.get(self, "compositeInput"))

    @builtins.property
    @jsii.member(jsii_name="compoundInput")
    def compound_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanCompound]]], jsii.get(self, "compoundInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanContrast]]], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="cropInput")
    def crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanCrop]]], jsii.get(self, "cropInput"))

    @builtins.property
    @jsii.member(jsii_name="faceCropInput")
    def face_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanFaceCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanFaceCrop]]], jsii.get(self, "faceCropInput"))

    @builtins.property
    @jsii.member(jsii_name="featureCropInput")
    def feature_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanFeatureCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanFeatureCrop]]], jsii.get(self, "featureCropInput"))

    @builtins.property
    @jsii.member(jsii_name="fitAndFillInput")
    def fit_and_fill_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanFitAndFill]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanFitAndFill]]], jsii.get(self, "fitAndFillInput"))

    @builtins.property
    @jsii.member(jsii_name="goopInput")
    def goop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanGoop]]], jsii.get(self, "goopInput"))

    @builtins.property
    @jsii.member(jsii_name="grayscaleInput")
    def grayscale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanGrayscale]]], jsii.get(self, "grayscaleInput"))

    @builtins.property
    @jsii.member(jsii_name="hslInput")
    def hsl_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanHsl]]], jsii.get(self, "hslInput"))

    @builtins.property
    @jsii.member(jsii_name="hsvInput")
    def hsv_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanHsv]]], jsii.get(self, "hsvInput"))

    @builtins.property
    @jsii.member(jsii_name="ifDimensionInput")
    def if_dimension_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimension]]], jsii.get(self, "ifDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientationInput")
    def if_orientation_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientation]]], jsii.get(self, "ifOrientationInput"))

    @builtins.property
    @jsii.member(jsii_name="imQueryInput")
    def im_query_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanImQuery]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanImQuery]]], jsii.get(self, "imQueryInput"))

    @builtins.property
    @jsii.member(jsii_name="maxColorsInput")
    def max_colors_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanMaxColors]]], jsii.get(self, "maxColorsInput"))

    @builtins.property
    @jsii.member(jsii_name="mirrorInput")
    def mirror_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanMirror]]], jsii.get(self, "mirrorInput"))

    @builtins.property
    @jsii.member(jsii_name="monoHueInput")
    def mono_hue_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanMonoHue]]], jsii.get(self, "monoHueInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanOpacity]]], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestCropInput")
    def region_of_interest_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanRegionOfInterestCrop"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanRegionOfInterestCrop"]]], jsii.get(self, "regionOfInterestCropInput"))

    @builtins.property
    @jsii.member(jsii_name="relativeCropInput")
    def relative_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanRelativeCrop"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanRelativeCrop"]]], jsii.get(self, "relativeCropInput"))

    @builtins.property
    @jsii.member(jsii_name="removeColorInput")
    def remove_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanRemoveColor"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanRemoveColor"]]], jsii.get(self, "removeColorInput"))

    @builtins.property
    @jsii.member(jsii_name="resizeInput")
    def resize_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanResize"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanResize"]]], jsii.get(self, "resizeInput"))

    @builtins.property
    @jsii.member(jsii_name="rotateInput")
    def rotate_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanRotate"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanRotate"]]], jsii.get(self, "rotateInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanScale"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanScale"]]], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="shearInput")
    def shear_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanShear"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanShear"]]], jsii.get(self, "shearInput"))

    @builtins.property
    @jsii.member(jsii_name="trimInput")
    def trim_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanTrim"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanTrim"]]], jsii.get(self, "trimInput"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMaskInput")
    def unsharp_mask_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanUnsharpMask"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanUnsharpMask"]]], jsii.get(self, "unsharpMaskInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__51902252b572af911bfb669260662aa3adac8e3cc718e6f5f194810e27f221db)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanRegionOfInterestCrop",
    jsii_struct_bases=[],
    name_mapping={
        "region_of_interest": "regionOfInterest",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanRegionOfInterestCrop:
    def __init__(
        self,
        *,
        region_of_interest: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanRegionOfInterestCropRegionOfInterest", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param region_of_interest: region_of_interest block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest DataAkamaiImagingPolicyImage#region_of_interest}
        :param gravity: The placement of the crop area relative to the specified area of interest. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: The placement of the crop area relative to the specified area of interest. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param style: Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(region_of_interest, dict):
            region_of_interest = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanRegionOfInterestCropRegionOfInterest(**region_of_interest)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dfa2732cc17cd92467e5a2b9948b4054da6f00ef13e73697b36ec2e1636276cf)
            check_type(argname="argument region_of_interest", value=region_of_interest, expected_type=type_hints["region_of_interest"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "region_of_interest": region_of_interest,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def region_of_interest(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanRegionOfInterestCropRegionOfInterest":
        '''region_of_interest block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest DataAkamaiImagingPolicyImage#region_of_interest}
        '''
        result = self._values.get("region_of_interest")
        assert result is not None, "Required property 'region_of_interest' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanRegionOfInterestCropRegionOfInterest", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''The placement of the crop area relative to the specified area of interest.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''The placement of the crop area relative to the specified area of interest.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanRegionOfInterestCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanRegionOfInterestCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanRegionOfInterestCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2e1ddf6408a84fb95687207949235eee7789254afec28abe3f201e500cde43c6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanRegionOfInterestCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3cc5618db07e4738b2d36c61db5997d2be0d58c2e474e4b096b8613e75d2d285)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanRegionOfInterestCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8aa2562df4169d7e54ffaf4a9004b6dc3effc55fc822bddecd5bfb9ad4ed949c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__127464c249079f0bcc4e98ea4b9af1889dc9b41eaed0299e205896385fcbf266)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c8378423334b821e7ab61175b8670e7c282c9f0fe0b7a7f52ffa342f072e6092)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanRegionOfInterestCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanRegionOfInterestCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanRegionOfInterestCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f35e3efe38e63b34daa10fbe7ac44513e2b95b76bb82cb79ef89d3bba613cdf5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanRegionOfInterestCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanRegionOfInterestCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b5068e73ff401095b85d6d043595f40f880cc53e8e3db0aebeacdafa378a911c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putRegionOfInterest")
    def put_region_of_interest(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanRegionOfInterestCropRegionOfInterest()

        return typing.cast(None, jsii.invoke(self, "putRegionOfInterest", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterest")
    def region_of_interest(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestOutputReference", jsii.get(self, "regionOfInterest"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestInput")
    def region_of_interest_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanRegionOfInterestCropRegionOfInterest"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanRegionOfInterestCropRegionOfInterest"], jsii.get(self, "regionOfInterestInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fc7ea5cba4bc8cd0a8837b329f90a0087b054cd907fe8ad283c9ca61b02f300b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__16038516c13ce97dfa385152f569e521ca232b83da394168cf6adb67476de25c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c477023a7cdf2558032d5ec0140215d1c0252e2e6c0e322a21c1265429567022)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7ac2c21bccc6fea15d52fa1d3f8c3688a64b9141fe0debffdddab5c897c32938)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__17f16393ca9e2c05c887ef9c3f34e86b32660e002a7f21cb2480564eef914921)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f5497ee6cda192d64d350989d6c55bfca3de91b0aa80f0304345245323a9d679)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f3d433ea008f912e11a4079708bd672605270de59ace9d1ba88685d604649b10)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__304e7ff087a87624d45a903c885352488878e9edcbd67b346e30015219240ed9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanRegionOfInterestCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanRegionOfInterestCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanRegionOfInterestCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0a716934d5de356fc2a70883652acad21b7458b9c1decc3df3827b7f03e18d67)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanRegionOfInterestCropRegionOfInterest",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanRegionOfInterestCropRegionOfInterest:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanRegionOfInterestCropRegionOfInterest(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3efc92f880a931805b369f1c00c308915e54cc889515a584165fcdb172e1cd5b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanRegionOfInterestCropRegionOfInterest]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanRegionOfInterestCropRegionOfInterest], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanRegionOfInterestCropRegionOfInterest],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fb46ab68f98567d21d07eba1bf761cec69b5f117494144369899dc9716c91e7f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanRelativeCrop",
    jsii_struct_bases=[],
    name_mapping={
        "east": "east",
        "east_var": "eastVar",
        "north": "north",
        "north_var": "northVar",
        "south": "south",
        "south_var": "southVar",
        "west": "west",
        "west_var": "westVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanRelativeCrop:
    def __init__(
        self,
        *,
        east: typing.Optional[builtins.str] = None,
        east_var: typing.Optional[builtins.str] = None,
        north: typing.Optional[builtins.str] = None,
        north_var: typing.Optional[builtins.str] = None,
        south: typing.Optional[builtins.str] = None,
        south_var: typing.Optional[builtins.str] = None,
        west: typing.Optional[builtins.str] = None,
        west_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param east: The number of pixels to shrink or expand the right side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east DataAkamaiImagingPolicyImage#east}
        :param east_var: The number of pixels to shrink or expand the right side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east_var DataAkamaiImagingPolicyImage#east_var}
        :param north: The number of pixels to shrink or expand the top side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north DataAkamaiImagingPolicyImage#north}
        :param north_var: The number of pixels to shrink or expand the top side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north_var DataAkamaiImagingPolicyImage#north_var}
        :param south: The number of pixels to shrink or expand the bottom side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south DataAkamaiImagingPolicyImage#south}
        :param south_var: The number of pixels to shrink or expand the bottom side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south_var DataAkamaiImagingPolicyImage#south_var}
        :param west: The number of pixels to shrink or expand the left side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west DataAkamaiImagingPolicyImage#west}
        :param west_var: The number of pixels to shrink or expand the left side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west_var DataAkamaiImagingPolicyImage#west_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b7abe68a1a9411be91682bed324ae69b5fe7acb45f3348ad94a3fe7851fb1c34)
            check_type(argname="argument east", value=east, expected_type=type_hints["east"])
            check_type(argname="argument east_var", value=east_var, expected_type=type_hints["east_var"])
            check_type(argname="argument north", value=north, expected_type=type_hints["north"])
            check_type(argname="argument north_var", value=north_var, expected_type=type_hints["north_var"])
            check_type(argname="argument south", value=south, expected_type=type_hints["south"])
            check_type(argname="argument south_var", value=south_var, expected_type=type_hints["south_var"])
            check_type(argname="argument west", value=west, expected_type=type_hints["west"])
            check_type(argname="argument west_var", value=west_var, expected_type=type_hints["west_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if east is not None:
            self._values["east"] = east
        if east_var is not None:
            self._values["east_var"] = east_var
        if north is not None:
            self._values["north"] = north
        if north_var is not None:
            self._values["north_var"] = north_var
        if south is not None:
            self._values["south"] = south
        if south_var is not None:
            self._values["south_var"] = south_var
        if west is not None:
            self._values["west"] = west
        if west_var is not None:
            self._values["west_var"] = west_var

    @builtins.property
    def east(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the right side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east DataAkamaiImagingPolicyImage#east}
        '''
        result = self._values.get("east")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def east_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the right side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east_var DataAkamaiImagingPolicyImage#east_var}
        '''
        result = self._values.get("east_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def north(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the top side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north DataAkamaiImagingPolicyImage#north}
        '''
        result = self._values.get("north")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def north_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the top side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north_var DataAkamaiImagingPolicyImage#north_var}
        '''
        result = self._values.get("north_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def south(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the bottom side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south DataAkamaiImagingPolicyImage#south}
        '''
        result = self._values.get("south")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def south_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the bottom side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south_var DataAkamaiImagingPolicyImage#south_var}
        '''
        result = self._values.get("south_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def west(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the left side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west DataAkamaiImagingPolicyImage#west}
        '''
        result = self._values.get("west")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def west_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the left side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west_var DataAkamaiImagingPolicyImage#west_var}
        '''
        result = self._values.get("west_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanRelativeCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanRelativeCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanRelativeCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__da24ef3a80b62a0819a4421b306673da82dda10b2a3d2a9484b28e78de1c3fc1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanRelativeCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__268130c3cb0855dc1f5f7b5ecd6f1ca86e0f598cae0d9ee51bd2f8901b5d14bd)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanRelativeCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ef12e6b19fe77157aeba15da432868dc7694988279f6760645ca29256d14942)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a60156c372f59408241eef8eabf1d1d4d5eb19a22679c128e94b34fed05bfde8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__02fecad9b8afa330af3086dca22ce7ade751983d127e3f7d760e7cb88f15d049)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanRelativeCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanRelativeCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanRelativeCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8641759db74edfa16611a15ded6f9dde3dba398bbe19448d4d5adc87481a567b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanRelativeCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanRelativeCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1197699db10409eeebff49a3b23f2d25631911601de8de50abb3e534fac72a06)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetEast")
    def reset_east(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEast", []))

    @jsii.member(jsii_name="resetEastVar")
    def reset_east_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEastVar", []))

    @jsii.member(jsii_name="resetNorth")
    def reset_north(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNorth", []))

    @jsii.member(jsii_name="resetNorthVar")
    def reset_north_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNorthVar", []))

    @jsii.member(jsii_name="resetSouth")
    def reset_south(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSouth", []))

    @jsii.member(jsii_name="resetSouthVar")
    def reset_south_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSouthVar", []))

    @jsii.member(jsii_name="resetWest")
    def reset_west(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWest", []))

    @jsii.member(jsii_name="resetWestVar")
    def reset_west_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWestVar", []))

    @builtins.property
    @jsii.member(jsii_name="eastInput")
    def east_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "eastInput"))

    @builtins.property
    @jsii.member(jsii_name="eastVarInput")
    def east_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "eastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="northInput")
    def north_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "northInput"))

    @builtins.property
    @jsii.member(jsii_name="northVarInput")
    def north_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "northVarInput"))

    @builtins.property
    @jsii.member(jsii_name="southInput")
    def south_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "southInput"))

    @builtins.property
    @jsii.member(jsii_name="southVarInput")
    def south_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "southVarInput"))

    @builtins.property
    @jsii.member(jsii_name="westInput")
    def west_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "westInput"))

    @builtins.property
    @jsii.member(jsii_name="westVarInput")
    def west_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "westVarInput"))

    @builtins.property
    @jsii.member(jsii_name="east")
    def east(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "east"))

    @east.setter
    def east(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d4653209c5c516249853b7f40042b05b57ee68686cd5d78eecea4fbf083678a4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "east", value)

    @builtins.property
    @jsii.member(jsii_name="eastVar")
    def east_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "eastVar"))

    @east_var.setter
    def east_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6efacf45d77cf1dc1cffc92a753e444e510944c68cc9bb317532cb3dd167e7de)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "eastVar", value)

    @builtins.property
    @jsii.member(jsii_name="north")
    def north(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "north"))

    @north.setter
    def north(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c03d20b0b2e93a40801892ca1cf1af66b413b562454ca8ca557ac40e603a835d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "north", value)

    @builtins.property
    @jsii.member(jsii_name="northVar")
    def north_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "northVar"))

    @north_var.setter
    def north_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3424c002bf9cc1c1d7c104c72cc9a921e39dbd0f8901e34152e2d917a07a15e1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "northVar", value)

    @builtins.property
    @jsii.member(jsii_name="south")
    def south(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "south"))

    @south.setter
    def south(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cdbef618fc5f32c6432fbadb0beec2f05c8e070afcce0b1bb95f4eb6c5cc634d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "south", value)

    @builtins.property
    @jsii.member(jsii_name="southVar")
    def south_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "southVar"))

    @south_var.setter
    def south_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b60e832bbde9bb7c95f0310867c8033b9111c944195add0c9f84e33e2672a8d8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "southVar", value)

    @builtins.property
    @jsii.member(jsii_name="west")
    def west(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "west"))

    @west.setter
    def west(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__33b28ab845ebba3b31628f7934f127d07ba78a81b051d8e6b4ff400b82d77cc0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "west", value)

    @builtins.property
    @jsii.member(jsii_name="westVar")
    def west_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "westVar"))

    @west_var.setter
    def west_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ee896ceaf5d00de3a678e961b2eb52cd9450c14917153145a673588ffddec63d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "westVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanRelativeCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanRelativeCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanRelativeCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e995bdaade7eb75ba20fad217e3604cad6ac760e4c2b5ae50bee1b68ce5259e9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanRemoveColor",
    jsii_struct_bases=[],
    name_mapping={
        "color": "color",
        "color_var": "colorVar",
        "feather": "feather",
        "feather_var": "featherVar",
        "tolerance": "tolerance",
        "tolerance_var": "toleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanRemoveColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
        feather: typing.Optional[builtins.str] = None,
        feather_var: typing.Optional[builtins.str] = None,
        tolerance: typing.Optional[builtins.str] = None,
        tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        :param feather: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        :param feather_var: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        :param tolerance: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        :param tolerance_var: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__52407b32cea78e505c7694f64c2567d4e72d09d83e64380ca0c08e016ed2ee1d)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
            check_type(argname="argument feather", value=feather, expected_type=type_hints["feather"])
            check_type(argname="argument feather_var", value=feather_var, expected_type=type_hints["feather_var"])
            check_type(argname="argument tolerance", value=tolerance, expected_type=type_hints["tolerance"])
            check_type(argname="argument tolerance_var", value=tolerance_var, expected_type=type_hints["tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var
        if feather is not None:
            self._values["feather"] = feather
        if feather_var is not None:
            self._values["feather_var"] = feather_var
        if tolerance is not None:
            self._values["tolerance"] = tolerance
        if tolerance_var is not None:
            self._values["tolerance_var"] = tolerance_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        '''
        result = self._values.get("feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather_var(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        '''
        result = self._values.get("feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        '''
        result = self._values.get("tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance_var(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        result = self._values.get("tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanRemoveColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanRemoveColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanRemoveColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__148098fc03d1c58ae78a66d6e4396c0be0c92c5af15464a37098b250908b70b8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanRemoveColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fdd1607f582a707c7aaad42d5c05aa34c63c791552bb65a3ec03c348d0edabbf)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanRemoveColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dcdda326978ea9c688af74e1d54e97aa2bbfdc2437fd5d6f4a175cfe645ec048)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__17cecc3d1f56ab5809ae3e43b152f5280aa9c6d710bacd5ca7468e02ef0139d6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af2c7cf49b6e6a4c093a12b8c08b01894f09310ce6d80be0e60eacaf9c0f11eb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanRemoveColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanRemoveColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanRemoveColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__53d72150770ec46423bc76238321854b73f775d3ed1581129a61f4a529da64ce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanRemoveColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanRemoveColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f17c941a06635485547e8af792f0b8bbfb1346e8fb514c98d94a1051547ce353)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @jsii.member(jsii_name="resetFeather")
    def reset_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeather", []))

    @jsii.member(jsii_name="resetFeatherVar")
    def reset_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatherVar", []))

    @jsii.member(jsii_name="resetTolerance")
    def reset_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTolerance", []))

    @jsii.member(jsii_name="resetToleranceVar")
    def reset_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featherInput")
    def feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherInput"))

    @builtins.property
    @jsii.member(jsii_name="featherVarInput")
    def feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceInput")
    def tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceVarInput")
    def tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0e2a7e66a07b7603225e64c58cdd3b36f9221efb2445874109c6081634a89365)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__303052c4596ebf47c18a2bc50db25af652060e89af5a534190b64f4d8ada07ae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="feather")
    def feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "feather"))

    @feather.setter
    def feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1b619f58f9da16cb869d967612de71d5edb4174e10f5d66fbe521c4aec5d46a3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "feather", value)

    @builtins.property
    @jsii.member(jsii_name="featherVar")
    def feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featherVar"))

    @feather_var.setter
    def feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f5994729869eb023942422d379af6d60731ce77087bfd1acecacc978f6f9e84)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featherVar", value)

    @builtins.property
    @jsii.member(jsii_name="tolerance")
    def tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tolerance"))

    @tolerance.setter
    def tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ccf92e23cfcb04f9bd5263ff06843be70434d9f9097aa889edbd0fcccf88ab35)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tolerance", value)

    @builtins.property
    @jsii.member(jsii_name="toleranceVar")
    def tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "toleranceVar"))

    @tolerance_var.setter
    def tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e9ffee7ebd839a856e2913f8f20a9d8e8b9bbfef4e6b3f587212f652e22c8e40)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "toleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanRemoveColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanRemoveColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanRemoveColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a104bc5221c3cb7770750feb4a171af0aa3a25f6625d74045c09eaec998d26c0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanResize",
    jsii_struct_bases=[],
    name_mapping={
        "aspect": "aspect",
        "aspect_var": "aspectVar",
        "height": "height",
        "height_var": "heightVar",
        "type": "type",
        "type_var": "typeVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanResize:
    def __init__(
        self,
        *,
        aspect: typing.Optional[builtins.str] = None,
        aspect_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param aspect: Preserves the aspect ratio. Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect DataAkamaiImagingPolicyImage#aspect}
        :param aspect_var: Preserves the aspect ratio. Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_var DataAkamaiImagingPolicyImage#aspect_var}
        :param height: The height to resize the source image to. Must be set if height is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height to resize the source image to. Must be set if height is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param type: Sets constraints for the image resize. Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: Sets constraints for the image resize. Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        :param width: The width to resize the source image to. Must be set if width is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width to resize the source image to. Must be set if width is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__18364188f8f2c58e406a02e1157dcdd16c4e3187ea434b24afeea7adf7145059)
            check_type(argname="argument aspect", value=aspect, expected_type=type_hints["aspect"])
            check_type(argname="argument aspect_var", value=aspect_var, expected_type=type_hints["aspect_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if aspect is not None:
            self._values["aspect"] = aspect
        if aspect_var is not None:
            self._values["aspect_var"] = aspect_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def aspect(self) -> typing.Optional[builtins.str]:
        '''Preserves the aspect ratio.

        Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect DataAkamaiImagingPolicyImage#aspect}
        '''
        result = self._values.get("aspect")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def aspect_var(self) -> typing.Optional[builtins.str]:
        '''Preserves the aspect ratio.

        Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_var DataAkamaiImagingPolicyImage#aspect_var}
        '''
        result = self._values.get("aspect_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height to resize the source image to. Must be set if height is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height to resize the source image to. Must be set if height is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''Sets constraints for the image resize.

        Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''Sets constraints for the image resize.

        Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width to resize the source image to. Must be set if width is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width to resize the source image to. Must be set if width is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanResize(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanResizeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanResizeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1094a2d8e1d793d88388c75ac4357e62a37e710d30ad469c5ea4144bbb2ff75b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanResizeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a4a60d59a32a05ae772f290ed27be3bf8615933dc83634a87c56ddcff04bc155)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanResizeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__21a967bb964c3c0343386d5b219e94c4647b24452377566f7fc30f4bfcecfa90)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__07a714463f68cb21d83b1c54f5e54f8f295d248220f96c5800a21ecdffd52a55)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__960192171da5d87d7471352ba8a472fd0cae6ee740c20696ac09e88da2a3cf7c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanResize]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanResize]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanResize]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__17b7370b359c497a9e9f97ecf7b357b715c81c2cea0f420d9ffc03115ef6dd3f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanResizeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanResizeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b4be8144af95b6ae602ccb485b587ec1515b4247407ac365392f38340dece3c7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAspect")
    def reset_aspect(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspect", []))

    @jsii.member(jsii_name="resetAspectVar")
    def reset_aspect_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspectVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="aspectInput")
    def aspect_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "aspectInput"))

    @builtins.property
    @jsii.member(jsii_name="aspectVarInput")
    def aspect_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "aspectVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="aspect")
    def aspect(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "aspect"))

    @aspect.setter
    def aspect(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dc4b22f00bd29c8cf4d5c06515ff3f05fe84a447fd24508efe3ae64536e61092)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "aspect", value)

    @builtins.property
    @jsii.member(jsii_name="aspectVar")
    def aspect_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "aspectVar"))

    @aspect_var.setter
    def aspect_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af697abbbe830306849090bb52eff72935abf426c0b7685fa6e6c9842ea4108b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "aspectVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__360a8010a07b461dff686dff09f7bddd9b257a180ce6a44cd45dbe47081d8c1b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e295c52a8866fdfe46018895d3d718ecd00948c24e038142f19ddd75c60a7ad2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c0bb724cecc3cc6c1f0d20eccaaa156eb45da8c135af82522a345a8a68cd7371)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__67786406ad0599bd3797ffe1cf95d315ef8ecf44c8951e37d3f01d105050a631)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__98c6a24fccc667aaeab344881680b99d0c2ae550054e48eb3ec2bdd967f27295)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8873565389c749747632306cb9afc07ba26e7004851b55327ffcb8f15304db15)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanResize]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanResize]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanResize]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__47df1908159a9901b9468629e8375eb0d26037f0fcdd9b55178db085da57062e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanRotate",
    jsii_struct_bases=[],
    name_mapping={"degrees": "degrees", "degrees_var": "degreesVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanRotate:
    def __init__(
        self,
        *,
        degrees: typing.Optional[builtins.str] = None,
        degrees_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param degrees: The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees DataAkamaiImagingPolicyImage#degrees}
        :param degrees_var: The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees_var DataAkamaiImagingPolicyImage#degrees_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6ed71cd854fc6506d674727ce0366c5b8d3623ce7d674b4c153db77d77081997)
            check_type(argname="argument degrees", value=degrees, expected_type=type_hints["degrees"])
            check_type(argname="argument degrees_var", value=degrees_var, expected_type=type_hints["degrees_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if degrees is not None:
            self._values["degrees"] = degrees
        if degrees_var is not None:
            self._values["degrees_var"] = degrees_var

    @builtins.property
    def degrees(self) -> typing.Optional[builtins.str]:
        '''The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees DataAkamaiImagingPolicyImage#degrees}
        '''
        result = self._values.get("degrees")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def degrees_var(self) -> typing.Optional[builtins.str]:
        '''The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees_var DataAkamaiImagingPolicyImage#degrees_var}
        '''
        result = self._values.get("degrees_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanRotate(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanRotateList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanRotateList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__45834533e2b822b1864bfc021edef690ffa7d746e9083d569a9ea412b193b315)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanRotateOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b18c1a6015a1e948962160b2912dae753e96549b8134025a5c917d309c5bc177)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanRotateOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6d21713ab4ca3bfc70ce9991a499b30ecc217bab778098f89dbb8ed700d478b1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aea4ed70844acfa5c06ae7ed7dbd6cbdf688c312e93d9700177a36b3a89c445c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c1e0c58553a5f284c08498f383adc45a566872e2a0e75bed53dc786cafb640b7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanRotate]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanRotate]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanRotate]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__28762542b6343ccf11df92bf68f60640babc2790128172cb723afda687fa6a27)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanRotateOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanRotateOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9b21e75fe7fe97d7b38fe4fe207fdfccf612a2ab64352aa3cfc167705310f7f2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetDegrees")
    def reset_degrees(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDegrees", []))

    @jsii.member(jsii_name="resetDegreesVar")
    def reset_degrees_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDegreesVar", []))

    @builtins.property
    @jsii.member(jsii_name="degreesInput")
    def degrees_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "degreesInput"))

    @builtins.property
    @jsii.member(jsii_name="degreesVarInput")
    def degrees_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "degreesVarInput"))

    @builtins.property
    @jsii.member(jsii_name="degrees")
    def degrees(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "degrees"))

    @degrees.setter
    def degrees(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__37e5a29eddfd38f62e5001b90eaf045ceb41768fae331c50112af5493a95bf69)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "degrees", value)

    @builtins.property
    @jsii.member(jsii_name="degreesVar")
    def degrees_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "degreesVar"))

    @degrees_var.setter
    def degrees_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__12957c538f5a6ec0af065b93abbecf51cac99b574792e38236f1713091cd80c2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "degreesVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanRotate]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanRotate]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanRotate]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b752c83d061a8adbf15f797831efd72bc920faff8d597e85875780bc2ffa4419)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanScale",
    jsii_struct_bases=[],
    name_mapping={
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanScale:
    def __init__(
        self,
        *,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param height: Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged. Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged. Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8e37f03a1035d3d2d209b9bdd49929db4738e935abd53fabc8ed1918c4f46aae)
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size.

        Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size.

        Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged.

        Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged.

        Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanScale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanScaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanScaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b4992cb6119fb0a7b45f2feccc082d241622aa9d06c3676c412c624eeed00e9f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanScaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cb7ba35cf4cb407cf298e34781a91ae9aa9d1740e8dd08a47a8c4f8b5e631980)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanScaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e03cacc9d7dea8beed867edf160723358dc6d4aff011f9b6ccb4b74921a06f81)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__199b9fec843e14609d6e7db3072e079fc3cb2e74b7a85cdddd766ae67afe557e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e5d6d0477808b96f215217f65a347b663d005be94591835f7e21de2bbc96ebc9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanScale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanScale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanScale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bdd782558d0f5df26c3f669cddd3bfe1c106198b1867655f8513f2c8fcdfbeb5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanScaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanScaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3748ad868c11afbd032f35623f39a39ad9ea7abe7fe8d9b69d42da354065edb7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__91882defc7125a29573ae4c138e94e5c2f645ae61393800b509bd9c8c900ff77)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dbe6d582d293c4b96d710d1dbbe8b4c52c6807a5466f3632d96e7d0d77d0edbf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8c6b31df61a8d215483625553c9eaba49934d719e68af38ba4f1c59b38e6d160)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e768cf5ffbaf417038e9ef63df091b6d54b949d693dfb3b26d2687e32a42e421)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanScale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanScale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanScale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab19965fc7f8dba33e43c89e4c02336cfc2a22a01dbd3236c74ba1042873c393)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanShear",
    jsii_struct_bases=[],
    name_mapping={
        "x_shear": "xShear",
        "x_shear_var": "xShearVar",
        "y_shear": "yShear",
        "y_shear_var": "yShearVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanShear:
    def __init__(
        self,
        *,
        x_shear: typing.Optional[builtins.str] = None,
        x_shear_var: typing.Optional[builtins.str] = None,
        y_shear: typing.Optional[builtins.str] = None,
        y_shear_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param x_shear: The amount to shear along the x-axis, measured in multiples of the image's width. Must be set if yShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear DataAkamaiImagingPolicyImage#x_shear}
        :param x_shear_var: The amount to shear along the x-axis, measured in multiples of the image's width. Must be set if yShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear_var DataAkamaiImagingPolicyImage#x_shear_var}
        :param y_shear: The amount to shear along the y-axis, measured in multiples of the image's height. Must be set if xShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear DataAkamaiImagingPolicyImage#y_shear}
        :param y_shear_var: The amount to shear along the y-axis, measured in multiples of the image's height. Must be set if xShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear_var DataAkamaiImagingPolicyImage#y_shear_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e00e1b8a43c553870f7e6fe8ab49925c0d67648545a86f099f6a43af993414c3)
            check_type(argname="argument x_shear", value=x_shear, expected_type=type_hints["x_shear"])
            check_type(argname="argument x_shear_var", value=x_shear_var, expected_type=type_hints["x_shear_var"])
            check_type(argname="argument y_shear", value=y_shear, expected_type=type_hints["y_shear"])
            check_type(argname="argument y_shear_var", value=y_shear_var, expected_type=type_hints["y_shear_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if x_shear is not None:
            self._values["x_shear"] = x_shear
        if x_shear_var is not None:
            self._values["x_shear_var"] = x_shear_var
        if y_shear is not None:
            self._values["y_shear"] = y_shear
        if y_shear_var is not None:
            self._values["y_shear_var"] = y_shear_var

    @builtins.property
    def x_shear(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the x-axis, measured in multiples of the image's width.

        Must be set if yShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear DataAkamaiImagingPolicyImage#x_shear}
        '''
        result = self._values.get("x_shear")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_shear_var(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the x-axis, measured in multiples of the image's width.

        Must be set if yShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear_var DataAkamaiImagingPolicyImage#x_shear_var}
        '''
        result = self._values.get("x_shear_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_shear(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the y-axis, measured in multiples of the image's height.

        Must be set if xShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear DataAkamaiImagingPolicyImage#y_shear}
        '''
        result = self._values.get("y_shear")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_shear_var(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the y-axis, measured in multiples of the image's height.

        Must be set if xShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear_var DataAkamaiImagingPolicyImage#y_shear_var}
        '''
        result = self._values.get("y_shear_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanShear(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanShearList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanShearList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a87d47aecb0c5df02b9da173b5949228932a5b845e303b13ecd5c6c7697afa7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanShearOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1af7ba3a913c97fd7ae933620c3fdd8aeb4774b55e5a8131e055dcb8d1a1a61c)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanShearOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3db7bcfa0b2d55b0875dafca8520ec71ac8ebcc6b0030c26355f7ce1452ddd56)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f1fc8a7ba2f3d6c04dc9ec0d4f3212febfa21a2df794702f658b2759d684f218)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d0b4c09ffae89af9311f8c1b47c7875208a1bb2c4e99b2b8873be11306fcbe02)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanShear]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanShear]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanShear]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ecce47a1070104a0d7ec1aa9b323651e44fe861d24440972c8569b730d47051)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanShearOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanShearOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__961cd795ace1489ddec86b5f7feb72263961a0be034e0b38210b96c9a89d5429)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetXShear")
    def reset_x_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXShear", []))

    @jsii.member(jsii_name="resetXShearVar")
    def reset_x_shear_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXShearVar", []))

    @jsii.member(jsii_name="resetYShear")
    def reset_y_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYShear", []))

    @jsii.member(jsii_name="resetYShearVar")
    def reset_y_shear_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYShearVar", []))

    @builtins.property
    @jsii.member(jsii_name="xShearInput")
    def x_shear_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xShearInput"))

    @builtins.property
    @jsii.member(jsii_name="xShearVarInput")
    def x_shear_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xShearVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yShearInput")
    def y_shear_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yShearInput"))

    @builtins.property
    @jsii.member(jsii_name="yShearVarInput")
    def y_shear_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yShearVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xShear")
    def x_shear(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xShear"))

    @x_shear.setter
    def x_shear(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cc658301998d0b19933013a828813444c137bc53f306180486e59640c428872e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xShear", value)

    @builtins.property
    @jsii.member(jsii_name="xShearVar")
    def x_shear_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xShearVar"))

    @x_shear_var.setter
    def x_shear_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1e6df239fc1045a33241674ed634cd55d5d2eee15fbffb21bf7daa979b176e49)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xShearVar", value)

    @builtins.property
    @jsii.member(jsii_name="yShear")
    def y_shear(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yShear"))

    @y_shear.setter
    def y_shear(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4888220fdead292006d316ff7a1ce9f4f1cbe0fc4c30594edeb8d58fec3bdfb1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yShear", value)

    @builtins.property
    @jsii.member(jsii_name="yShearVar")
    def y_shear_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yShearVar"))

    @y_shear_var.setter
    def y_shear_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e966764ec9f1443cf1f399d5dfc932d17390ade7d34b8352cfa927dc48fdf5d3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yShearVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanShear]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanShear]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanShear]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__802c75cb27dd391b13a6931fb470646d99ff5c2289da04bb3cc2b11d687f0cd7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanTrim",
    jsii_struct_bases=[],
    name_mapping={
        "fuzz": "fuzz",
        "fuzz_var": "fuzzVar",
        "padding": "padding",
        "padding_var": "paddingVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanTrim:
    def __init__(
        self,
        *,
        fuzz: typing.Optional[builtins.str] = None,
        fuzz_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fuzz: The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz DataAkamaiImagingPolicyImage#fuzz}
        :param fuzz_var: The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz_var DataAkamaiImagingPolicyImage#fuzz_var}
        :param padding: The amount of padding in pixels to add to the trimmed image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: The amount of padding in pixels to add to the trimmed image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7945ea5b915a4c9e0e1e61bfa0f2274f934ae64b84ea53866605eebf3dd7501e)
            check_type(argname="argument fuzz", value=fuzz, expected_type=type_hints["fuzz"])
            check_type(argname="argument fuzz_var", value=fuzz_var, expected_type=type_hints["fuzz_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fuzz is not None:
            self._values["fuzz"] = fuzz
        if fuzz_var is not None:
            self._values["fuzz_var"] = fuzz_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var

    @builtins.property
    def fuzz(self) -> typing.Optional[builtins.str]:
        '''The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz DataAkamaiImagingPolicyImage#fuzz}
        '''
        result = self._values.get("fuzz")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fuzz_var(self) -> typing.Optional[builtins.str]:
        '''The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz_var DataAkamaiImagingPolicyImage#fuzz_var}
        '''
        result = self._values.get("fuzz_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''The amount of padding in pixels to add to the trimmed image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''The amount of padding in pixels to add to the trimmed image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanTrim(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanTrimList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanTrimList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1b3532dfceb31b8cee1754b1fe244b46762c0f63932aa72591842ae67ad364c3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanTrimOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bbebc6be70fe5fb1f239f09c71c16a97842f7af51719e5357ecdcf613acfc919)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanTrimOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__74df041b6602c6b6189cb573692898c894c6667a963ab125ae437b1861877aac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3592e1bb8667626fcfe6e8223a6233c8dd42274e43aa494feeee39ab0f372f38)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e065d8d89eb2451451ac74870de2e6018f6fe3a1810b870573014a00599d4116)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanTrim]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanTrim]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanTrim]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4d37ce24fec7048602065d1591688b89269ef78ceb13a79800312637e6e0fee5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanTrimOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanTrimOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b7ec962741df543f56085682abab770c3d17552794301f9bee5435f998cbdfe4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetFuzz")
    def reset_fuzz(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFuzz", []))

    @jsii.member(jsii_name="resetFuzzVar")
    def reset_fuzz_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFuzzVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @builtins.property
    @jsii.member(jsii_name="fuzzInput")
    def fuzz_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fuzzInput"))

    @builtins.property
    @jsii.member(jsii_name="fuzzVarInput")
    def fuzz_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fuzzVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="fuzz")
    def fuzz(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fuzz"))

    @fuzz.setter
    def fuzz(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__67efe3bfd76f5ce6de5edfd84ad01ec0732a1d296e660690b37f7460b54d7062)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fuzz", value)

    @builtins.property
    @jsii.member(jsii_name="fuzzVar")
    def fuzz_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fuzzVar"))

    @fuzz_var.setter
    def fuzz_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c33d78e0c4c585466ee45aaa13379c3343cbd2082743752e81b75f3041711387)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fuzzVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2c88f9a3baf33179aa5dd69710973c1caca37ca478d21b4146b7920a27f61c1f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5bf22ae32343937e02c1fae84622c683935f3440b8f2b28d1e9c9b06aec73e38)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanTrim]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanTrim]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanTrim]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4063bac3f10c68442cf2ee58e08875c9e458074784dc5b444a79b2802ef904fa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanUnsharpMask",
    jsii_struct_bases=[],
    name_mapping={
        "gain": "gain",
        "gain_var": "gainVar",
        "sigma": "sigma",
        "sigma_var": "sigmaVar",
        "threshold": "threshold",
        "threshold_var": "thresholdVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanUnsharpMask:
    def __init__(
        self,
        *,
        gain: typing.Optional[builtins.str] = None,
        gain_var: typing.Optional[builtins.str] = None,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
        threshold: typing.Optional[builtins.str] = None,
        threshold_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param gain: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        :param gain_var: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        :param sigma: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        :param threshold: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        :param threshold_var: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__80803a55dad04195ebe2348f691643a416b0dbf1f4b15f750e7dd15ca74a8a1c)
            check_type(argname="argument gain", value=gain, expected_type=type_hints["gain"])
            check_type(argname="argument gain_var", value=gain_var, expected_type=type_hints["gain_var"])
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
            check_type(argname="argument threshold", value=threshold, expected_type=type_hints["threshold"])
            check_type(argname="argument threshold_var", value=threshold_var, expected_type=type_hints["threshold_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if gain is not None:
            self._values["gain"] = gain
        if gain_var is not None:
            self._values["gain_var"] = gain_var
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var
        if threshold is not None:
            self._values["threshold"] = threshold
        if threshold_var is not None:
            self._values["threshold_var"] = threshold_var

    @builtins.property
    def gain(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        '''
        result = self._values.get("gain")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gain_var(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        '''
        result = self._values.get("gain_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        '''
        result = self._values.get("threshold")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold_var(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        result = self._values.get("threshold_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanUnsharpMask(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanUnsharpMaskList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanUnsharpMaskList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6b899d8fa71c792486235ebafaa1b86cee5cbadba0aa01cf3629ea2aac6e9ff3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanUnsharpMaskOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__961aac6147535c9e1d6da05ddf98bfd794bbee2c61d0a334e8efc436f9aedd59)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanUnsharpMaskOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f46924e9c22bc934fd5eed8e622d536320789c141f6d56c00fd8a9dd9512471)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be4aa682b2074be4615038218938e7751b05931ffe994058a9ac40cd3104fa35)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ce50ed0f5e8188acdebc3039935321dd4ea8b7d79e82ef47266f62af752c4d5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanUnsharpMask]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanUnsharpMask]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanUnsharpMask]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a3ca5ff1ecf39f0b6e3e56153ff909052ba2983debb5bd07e1451d140f54bdd6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanUnsharpMaskOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanUnsharpMaskOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__34b9ab7cac9cad177d3a044bb527ac3853228b224865adf37662761c4e8154b6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetGain")
    def reset_gain(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGain", []))

    @jsii.member(jsii_name="resetGainVar")
    def reset_gain_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGainVar", []))

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @jsii.member(jsii_name="resetThreshold")
    def reset_threshold(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThreshold", []))

    @jsii.member(jsii_name="resetThresholdVar")
    def reset_threshold_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThresholdVar", []))

    @builtins.property
    @jsii.member(jsii_name="gainInput")
    def gain_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainInput"))

    @builtins.property
    @jsii.member(jsii_name="gainVarInput")
    def gain_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdInput")
    def threshold_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdVarInput")
    def threshold_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gain")
    def gain(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gain"))

    @gain.setter
    def gain(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5bd70fe2c1afaa27c52b3ac510022f71735b29a4aaf14602c8f2e32098c65673)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gain", value)

    @builtins.property
    @jsii.member(jsii_name="gainVar")
    def gain_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gainVar"))

    @gain_var.setter
    def gain_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8bf0110b0ecc4a97da25a69fa9a62054d2e8dc68d1f96f71c9253a55027de935)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gainVar", value)

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__18fd682c7c4490b332903f80a2ac35d1fb78a08434a277922b3f5f08be721cd1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__de5a9c857e80d677d2fd93157ad2e0425ec34fdf955d72e6a877c037fe4458f3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="threshold")
    def threshold(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "threshold"))

    @threshold.setter
    def threshold(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1e1869a9851ee9dc24e3e37ed796546933ff32bb79f2a5ec55b7ca6af958faba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "threshold", value)

    @builtins.property
    @jsii.member(jsii_name="thresholdVar")
    def threshold_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "thresholdVar"))

    @threshold_var.setter
    def threshold_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d030f46f34520c35fbea69789a0b1f0741392f6cf7936bce0afd8cdf611518c9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "thresholdVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanUnsharpMask]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanUnsharpMask]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanUnsharpMask]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d5181e973fbaf9b3637d1beb56bb3dcc86dafaf2b7bb0f0b100a664e2c1b75cc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThan",
    jsii_struct_bases=[],
    name_mapping={
        "append": "append",
        "aspect_crop": "aspectCrop",
        "background_color": "backgroundColor",
        "blur": "blur",
        "chroma_key": "chromaKey",
        "composite": "composite",
        "compound": "compound",
        "contrast": "contrast",
        "crop": "crop",
        "face_crop": "faceCrop",
        "feature_crop": "featureCrop",
        "fit_and_fill": "fitAndFill",
        "goop": "goop",
        "grayscale": "grayscale",
        "hsl": "hsl",
        "hsv": "hsv",
        "if_dimension": "ifDimension",
        "if_orientation": "ifOrientation",
        "im_query": "imQuery",
        "max_colors": "maxColors",
        "mirror": "mirror",
        "mono_hue": "monoHue",
        "opacity": "opacity",
        "region_of_interest_crop": "regionOfInterestCrop",
        "relative_crop": "relativeCrop",
        "remove_color": "removeColor",
        "resize": "resize",
        "rotate": "rotate",
        "scale": "scale",
        "shear": "shear",
        "trim": "trim",
        "unsharp_mask": "unsharpMask",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThan:
    def __init__(
        self,
        *,
        append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanAppend", typing.Dict[builtins.str, typing.Any]]]]] = None,
        aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanAspectCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanBackgroundColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanBlur", typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanChromaKey", typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanComposite", typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanCompound", typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanContrast", typing.Dict[builtins.str, typing.Any]]]]] = None,
        crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanFaceCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanFeatureCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanFitAndFill", typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanGoop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanGrayscale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanHsl", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanHsv", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfDimension", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientation", typing.Dict[builtins.str, typing.Any]]]]] = None,
        im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanImQuery", typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanMaxColors", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanMirror", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanMonoHue", typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanOpacity", typing.Dict[builtins.str, typing.Any]]]]] = None,
        region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanRegionOfInterestCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanRelativeCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanRemoveColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanResize", typing.Dict[builtins.str, typing.Any]]]]] = None,
        rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanRotate", typing.Dict[builtins.str, typing.Any]]]]] = None,
        scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanScale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanShear", typing.Dict[builtins.str, typing.Any]]]]] = None,
        trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanTrim", typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanUnsharpMask", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param append: append block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        :param aspect_crop: aspect_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param crop: crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        :param face_crop: face_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        :param feature_crop: feature_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        :param fit_and_fill: fit_and_fill block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param im_query: im_query block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param region_of_interest_crop: region_of_interest_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        :param relative_crop: relative_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param resize: resize block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        :param rotate: rotate block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        :param scale: scale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param shear: shear block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        :param trim: trim block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2f89d84b8024014905dc9bebd8435ee33187e552f62f088bc4e318cb12cbf90c)
            check_type(argname="argument append", value=append, expected_type=type_hints["append"])
            check_type(argname="argument aspect_crop", value=aspect_crop, expected_type=type_hints["aspect_crop"])
            check_type(argname="argument background_color", value=background_color, expected_type=type_hints["background_color"])
            check_type(argname="argument blur", value=blur, expected_type=type_hints["blur"])
            check_type(argname="argument chroma_key", value=chroma_key, expected_type=type_hints["chroma_key"])
            check_type(argname="argument composite", value=composite, expected_type=type_hints["composite"])
            check_type(argname="argument compound", value=compound, expected_type=type_hints["compound"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument crop", value=crop, expected_type=type_hints["crop"])
            check_type(argname="argument face_crop", value=face_crop, expected_type=type_hints["face_crop"])
            check_type(argname="argument feature_crop", value=feature_crop, expected_type=type_hints["feature_crop"])
            check_type(argname="argument fit_and_fill", value=fit_and_fill, expected_type=type_hints["fit_and_fill"])
            check_type(argname="argument goop", value=goop, expected_type=type_hints["goop"])
            check_type(argname="argument grayscale", value=grayscale, expected_type=type_hints["grayscale"])
            check_type(argname="argument hsl", value=hsl, expected_type=type_hints["hsl"])
            check_type(argname="argument hsv", value=hsv, expected_type=type_hints["hsv"])
            check_type(argname="argument if_dimension", value=if_dimension, expected_type=type_hints["if_dimension"])
            check_type(argname="argument if_orientation", value=if_orientation, expected_type=type_hints["if_orientation"])
            check_type(argname="argument im_query", value=im_query, expected_type=type_hints["im_query"])
            check_type(argname="argument max_colors", value=max_colors, expected_type=type_hints["max_colors"])
            check_type(argname="argument mirror", value=mirror, expected_type=type_hints["mirror"])
            check_type(argname="argument mono_hue", value=mono_hue, expected_type=type_hints["mono_hue"])
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument region_of_interest_crop", value=region_of_interest_crop, expected_type=type_hints["region_of_interest_crop"])
            check_type(argname="argument relative_crop", value=relative_crop, expected_type=type_hints["relative_crop"])
            check_type(argname="argument remove_color", value=remove_color, expected_type=type_hints["remove_color"])
            check_type(argname="argument resize", value=resize, expected_type=type_hints["resize"])
            check_type(argname="argument rotate", value=rotate, expected_type=type_hints["rotate"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument shear", value=shear, expected_type=type_hints["shear"])
            check_type(argname="argument trim", value=trim, expected_type=type_hints["trim"])
            check_type(argname="argument unsharp_mask", value=unsharp_mask, expected_type=type_hints["unsharp_mask"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if append is not None:
            self._values["append"] = append
        if aspect_crop is not None:
            self._values["aspect_crop"] = aspect_crop
        if background_color is not None:
            self._values["background_color"] = background_color
        if blur is not None:
            self._values["blur"] = blur
        if chroma_key is not None:
            self._values["chroma_key"] = chroma_key
        if composite is not None:
            self._values["composite"] = composite
        if compound is not None:
            self._values["compound"] = compound
        if contrast is not None:
            self._values["contrast"] = contrast
        if crop is not None:
            self._values["crop"] = crop
        if face_crop is not None:
            self._values["face_crop"] = face_crop
        if feature_crop is not None:
            self._values["feature_crop"] = feature_crop
        if fit_and_fill is not None:
            self._values["fit_and_fill"] = fit_and_fill
        if goop is not None:
            self._values["goop"] = goop
        if grayscale is not None:
            self._values["grayscale"] = grayscale
        if hsl is not None:
            self._values["hsl"] = hsl
        if hsv is not None:
            self._values["hsv"] = hsv
        if if_dimension is not None:
            self._values["if_dimension"] = if_dimension
        if if_orientation is not None:
            self._values["if_orientation"] = if_orientation
        if im_query is not None:
            self._values["im_query"] = im_query
        if max_colors is not None:
            self._values["max_colors"] = max_colors
        if mirror is not None:
            self._values["mirror"] = mirror
        if mono_hue is not None:
            self._values["mono_hue"] = mono_hue
        if opacity is not None:
            self._values["opacity"] = opacity
        if region_of_interest_crop is not None:
            self._values["region_of_interest_crop"] = region_of_interest_crop
        if relative_crop is not None:
            self._values["relative_crop"] = relative_crop
        if remove_color is not None:
            self._values["remove_color"] = remove_color
        if resize is not None:
            self._values["resize"] = resize
        if rotate is not None:
            self._values["rotate"] = rotate
        if scale is not None:
            self._values["scale"] = scale
        if shear is not None:
            self._values["shear"] = shear
        if trim is not None:
            self._values["trim"] = trim
        if unsharp_mask is not None:
            self._values["unsharp_mask"] = unsharp_mask

    @builtins.property
    def append(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanAppend"]]]:
        '''append block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        '''
        result = self._values.get("append")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanAppend"]]], result)

    @builtins.property
    def aspect_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanAspectCrop"]]]:
        '''aspect_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        '''
        result = self._values.get("aspect_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanAspectCrop"]]], result)

    @builtins.property
    def background_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanBackgroundColor"]]]:
        '''background_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        '''
        result = self._values.get("background_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanBackgroundColor"]]], result)

    @builtins.property
    def blur(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanBlur"]]]:
        '''blur block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        '''
        result = self._values.get("blur")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanBlur"]]], result)

    @builtins.property
    def chroma_key(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanChromaKey"]]]:
        '''chroma_key block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        '''
        result = self._values.get("chroma_key")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanChromaKey"]]], result)

    @builtins.property
    def composite(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanComposite"]]]:
        '''composite block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        '''
        result = self._values.get("composite")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanComposite"]]], result)

    @builtins.property
    def compound(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanCompound"]]]:
        '''compound block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        '''
        result = self._values.get("compound")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanCompound"]]], result)

    @builtins.property
    def contrast(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanContrast"]]]:
        '''contrast block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanContrast"]]], result)

    @builtins.property
    def crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanCrop"]]]:
        '''crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        '''
        result = self._values.get("crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanCrop"]]], result)

    @builtins.property
    def face_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanFaceCrop"]]]:
        '''face_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        '''
        result = self._values.get("face_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanFaceCrop"]]], result)

    @builtins.property
    def feature_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanFeatureCrop"]]]:
        '''feature_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        '''
        result = self._values.get("feature_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanFeatureCrop"]]], result)

    @builtins.property
    def fit_and_fill(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanFitAndFill"]]]:
        '''fit_and_fill block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        '''
        result = self._values.get("fit_and_fill")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanFitAndFill"]]], result)

    @builtins.property
    def goop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanGoop"]]]:
        '''goop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        '''
        result = self._values.get("goop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanGoop"]]], result)

    @builtins.property
    def grayscale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanGrayscale"]]]:
        '''grayscale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        '''
        result = self._values.get("grayscale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanGrayscale"]]], result)

    @builtins.property
    def hsl(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanHsl"]]]:
        '''hsl block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        '''
        result = self._values.get("hsl")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanHsl"]]], result)

    @builtins.property
    def hsv(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanHsv"]]]:
        '''hsv block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        '''
        result = self._values.get("hsv")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanHsv"]]], result)

    @builtins.property
    def if_dimension(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfDimension"]]]:
        '''if_dimension block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        '''
        result = self._values.get("if_dimension")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfDimension"]]], result)

    @builtins.property
    def if_orientation(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientation"]]]:
        '''if_orientation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        '''
        result = self._values.get("if_orientation")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientation"]]], result)

    @builtins.property
    def im_query(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanImQuery"]]]:
        '''im_query block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        '''
        result = self._values.get("im_query")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanImQuery"]]], result)

    @builtins.property
    def max_colors(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanMaxColors"]]]:
        '''max_colors block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        '''
        result = self._values.get("max_colors")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanMaxColors"]]], result)

    @builtins.property
    def mirror(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanMirror"]]]:
        '''mirror block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        '''
        result = self._values.get("mirror")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanMirror"]]], result)

    @builtins.property
    def mono_hue(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanMonoHue"]]]:
        '''mono_hue block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        '''
        result = self._values.get("mono_hue")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanMonoHue"]]], result)

    @builtins.property
    def opacity(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanOpacity"]]]:
        '''opacity block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanOpacity"]]], result)

    @builtins.property
    def region_of_interest_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanRegionOfInterestCrop"]]]:
        '''region_of_interest_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        '''
        result = self._values.get("region_of_interest_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanRegionOfInterestCrop"]]], result)

    @builtins.property
    def relative_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanRelativeCrop"]]]:
        '''relative_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        '''
        result = self._values.get("relative_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanRelativeCrop"]]], result)

    @builtins.property
    def remove_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanRemoveColor"]]]:
        '''remove_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        '''
        result = self._values.get("remove_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanRemoveColor"]]], result)

    @builtins.property
    def resize(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanResize"]]]:
        '''resize block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        '''
        result = self._values.get("resize")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanResize"]]], result)

    @builtins.property
    def rotate(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanRotate"]]]:
        '''rotate block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        '''
        result = self._values.get("rotate")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanRotate"]]], result)

    @builtins.property
    def scale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanScale"]]]:
        '''scale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanScale"]]], result)

    @builtins.property
    def shear(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanShear"]]]:
        '''shear block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        '''
        result = self._values.get("shear")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanShear"]]], result)

    @builtins.property
    def trim(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanTrim"]]]:
        '''trim block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        '''
        result = self._values.get("trim")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanTrim"]]], result)

    @builtins.property
    def unsharp_mask(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanUnsharpMask"]]]:
        '''unsharp_mask block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        result = self._values.get("unsharp_mask")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanUnsharpMask"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanAppend",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_priority": "gravityPriority",
        "gravity_priority_var": "gravityPriorityVar",
        "gravity_var": "gravityVar",
        "preserve_minor_dimension": "preserveMinorDimension",
        "preserve_minor_dimension_var": "preserveMinorDimensionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanAppend:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanAppendImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_priority: typing.Optional[builtins.str] = None,
        gravity_priority_var: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        preserve_minor_dimension: typing.Optional[builtins.str] = None,
        preserve_minor_dimension_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Specifies where to place the ``image`` relative to the source image. The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_priority: Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal. The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority DataAkamaiImagingPolicyImage#gravity_priority}
        :param gravity_priority_var: Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal. The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority_var DataAkamaiImagingPolicyImage#gravity_priority_var}
        :param gravity_var: Specifies where to place the ``image`` relative to the source image. The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param preserve_minor_dimension: Whether to preserve the source image's minor dimension, ``false`` by default. The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension DataAkamaiImagingPolicyImage#preserve_minor_dimension}
        :param preserve_minor_dimension_var: Whether to preserve the source image's minor dimension, ``false`` by default. The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension_var DataAkamaiImagingPolicyImage#preserve_minor_dimension_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanAppendImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b20defad745f52cddee6daac2415a5a4b08b6e36d02b6d88ba4570f938d63e48)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_priority", value=gravity_priority, expected_type=type_hints["gravity_priority"])
            check_type(argname="argument gravity_priority_var", value=gravity_priority_var, expected_type=type_hints["gravity_priority_var"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument preserve_minor_dimension", value=preserve_minor_dimension, expected_type=type_hints["preserve_minor_dimension"])
            check_type(argname="argument preserve_minor_dimension_var", value=preserve_minor_dimension_var, expected_type=type_hints["preserve_minor_dimension_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_priority is not None:
            self._values["gravity_priority"] = gravity_priority
        if gravity_priority_var is not None:
            self._values["gravity_priority_var"] = gravity_priority_var
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if preserve_minor_dimension is not None:
            self._values["preserve_minor_dimension"] = preserve_minor_dimension
        if preserve_minor_dimension_var is not None:
            self._values["preserve_minor_dimension_var"] = preserve_minor_dimension_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanAppendImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanAppendImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Specifies where to place the ``image`` relative to the source image.

        The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_priority(self) -> typing.Optional[builtins.str]:
        '''Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal.

        The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority DataAkamaiImagingPolicyImage#gravity_priority}
        '''
        result = self._values.get("gravity_priority")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_priority_var(self) -> typing.Optional[builtins.str]:
        '''Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal.

        The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority_var DataAkamaiImagingPolicyImage#gravity_priority_var}
        '''
        result = self._values.get("gravity_priority_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Specifies where to place the ``image`` relative to the source image.

        The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def preserve_minor_dimension(self) -> typing.Optional[builtins.str]:
        '''Whether to preserve the source image's minor dimension, ``false`` by default.

        The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension DataAkamaiImagingPolicyImage#preserve_minor_dimension}
        '''
        result = self._values.get("preserve_minor_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def preserve_minor_dimension_var(self) -> typing.Optional[builtins.str]:
        '''Whether to preserve the source image's minor dimension, ``false`` by default.

        The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension_var DataAkamaiImagingPolicyImage#preserve_minor_dimension_var}
        '''
        result = self._values.get("preserve_minor_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanAppend(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanAppendImage",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanAppendImage:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanAppendImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanAppendImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanAppendImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f2b29e1c2829108dc90b2fe31657069d56112c52cce0efc399f4eda3d82097d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanAppendImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanAppendImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanAppendImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c524c34432cb1c1db169d6907bed067c693ac72b2a935e9f8e4454d9d50e4628)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanAppendList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanAppendList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__23a1b4ad85041f98ae24ea4ab4b916c41913ea13486082142d98d75e4efcefd3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanAppendOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__71ff85ff383b4f97eb352ea42087e75cb40d7302cd5bb7023125787a915fed9d)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanAppendOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3f30186d5dcf0f2f4357f89ab7de8e5e7c62d1ade9b237ec0d43ae8a536f2d96)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d80dedcefb33e877527715d620fc52afd3cc8e0c6c2dea81ac6c0ed47fe64de)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__910115754fa6b71a69069fc45ce4e094cd9bb3ffbc3a97abeac646babb7506b2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanAppend]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanAppend]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanAppend]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d063165b824354e7837e442a16e17db0ab5878b42fe61436dd0530e339f3f63c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanAppendOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanAppendOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6ff17c2f8442642da4c0c193e9602aa44a0704dd7c7cff0dd9c0cd6a77c3e24d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanAppendImage()

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityPriority")
    def reset_gravity_priority(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityPriority", []))

    @jsii.member(jsii_name="resetGravityPriorityVar")
    def reset_gravity_priority_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityPriorityVar", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPreserveMinorDimension")
    def reset_preserve_minor_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPreserveMinorDimension", []))

    @jsii.member(jsii_name="resetPreserveMinorDimensionVar")
    def reset_preserve_minor_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPreserveMinorDimensionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanAppendImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanAppendImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityInput")
    def gravity_priority_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityPriorityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityVarInput")
    def gravity_priority_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityPriorityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanAppendImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanAppendImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionInput")
    def preserve_minor_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "preserveMinorDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionVarInput")
    def preserve_minor_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "preserveMinorDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f3dc5b6f339170127dbb138c4c6a3103cb46da8f0d54c5837ac67f09dca28de)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityPriority")
    def gravity_priority(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityPriority"))

    @gravity_priority.setter
    def gravity_priority(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9dde91f1a9bac6be17e1b5212136f36d00802af159e46586bc710a170c2b8306)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityPriority", value)

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityVar")
    def gravity_priority_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityPriorityVar"))

    @gravity_priority_var.setter
    def gravity_priority_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__69fd3a8c3764cd9eb09704acd1002e3fc6530e4a66df05423b5f7bdd02d25423)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityPriorityVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1d6576e0a5344a6d29044a6ff60201b42d251e5f30e80dcaf14df4cfbc0cfaaf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimension")
    def preserve_minor_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "preserveMinorDimension"))

    @preserve_minor_dimension.setter
    def preserve_minor_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__363488d61a0ba3357dc30633dd8d47704b1d33eb7c513a737a52a2ba89e08247)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "preserveMinorDimension", value)

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionVar")
    def preserve_minor_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "preserveMinorDimensionVar"))

    @preserve_minor_dimension_var.setter
    def preserve_minor_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9f702ff4ef5180aa0742a74ee3449f9647e05d8e463cf0edc5aa592772deac98)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "preserveMinorDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanAppend]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanAppend]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanAppend]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__efcc3dfde548f12fccd1a413b4b44669469e19c2a9e254e901362c4278512f04)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanAspectCrop",
    jsii_struct_bases=[],
    name_mapping={
        "allow_expansion": "allowExpansion",
        "allow_expansion_var": "allowExpansionVar",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanAspectCrop:
    def __init__(
        self,
        *,
        allow_expansion: typing.Optional[builtins.str] = None,
        allow_expansion_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_expansion: Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image. Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        :param allow_expansion_var: Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image. Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        :param height: The height term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The width term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        :param x_position: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7104a6bf56fe932f1894ac4ae80b3654b23f1dafcd8d6ae4ad769678c5a6bd65)
            check_type(argname="argument allow_expansion", value=allow_expansion, expected_type=type_hints["allow_expansion"])
            check_type(argname="argument allow_expansion_var", value=allow_expansion_var, expected_type=type_hints["allow_expansion_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if allow_expansion is not None:
            self._values["allow_expansion"] = allow_expansion
        if allow_expansion_var is not None:
            self._values["allow_expansion_var"] = allow_expansion_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def allow_expansion(self) -> typing.Optional[builtins.str]:
        '''Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image.

        Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        '''
        result = self._values.get("allow_expansion")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def allow_expansion_var(self) -> typing.Optional[builtins.str]:
        '''Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image.

        Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        '''
        result = self._values.get("allow_expansion_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanAspectCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanAspectCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanAspectCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3866474b5beeae5074429909a179e9d536ccee9bf9fd7ff6db4655ed80821d9f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanAspectCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac7e6a34c9015b41f19a1bb6bb40ee0e63ec2f4e39e9e1d06085731b8cd5a4f8)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanAspectCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__322c72aab4abf6ba5aaddb8ae9ab97f5f83f0826d1368db4ccfb88defc85ca2e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a8712d8bbadbe3969d13cf298db377d0f11859b53108d18320328fc1cdfc4a65)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4d796ff662fbe05d3e5492bd4bcda44112f5a3c1e3b87ce974318f5f7e59c001)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanAspectCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanAspectCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanAspectCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c8322372623d797a03ce677557381e9f571bcf373dbe3493778997a6add7c5d7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanAspectCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanAspectCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1190b9335dc05a0fc6dc79fb24be3d0e81e8efc57905e5bd5bdbdef719db24d7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAllowExpansion")
    def reset_allow_expansion(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansion", []))

    @jsii.member(jsii_name="resetAllowExpansionVar")
    def reset_allow_expansion_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansionVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionInput")
    def allow_expansion_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVarInput")
    def allow_expansion_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansion")
    def allow_expansion(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansion"))

    @allow_expansion.setter
    def allow_expansion(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3858cda41fb37b22d176e618c9029f556ebc3f870986731d00cd64f4f2fd322e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansion", value)

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVar")
    def allow_expansion_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansionVar"))

    @allow_expansion_var.setter
    def allow_expansion_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4bdd079999d2e18ca80bdd182133a4568440317dda59ed16da9a37d31ddb456a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansionVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e002de07210e1a3e15b361c2daec3e05463197f46674d73725314a5fea61171d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a4d192369c9b97e3bde17696039d13eafcdcef2a271e75a60011934de2313790)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fef6231bd90b5830abff830953f9bb14eef8e874740ebdd436a3f9c95eccccdf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dff91a12034206a6cea51ad3779e8c8a4bc6027dc4b6a0d42fb95787b33089fd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8451b168f6d0e2f2f15c18e1cb6a0561a14a3aa7abc07ff0c3bcd7ea4499855d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__67157c0af8c9c928be8978a063db47ef1a3bc2eda67482521ea5938cd3dae680)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__133d8cac195d5da9ed34ec65143f6d67456baec8a57cd01c5973d7b9ef48b783)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d74b37d0fb7ca77ed19bdb717212091b10b5534a143158077b8215f326c4e75b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanAspectCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanAspectCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanAspectCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ee85a8f32997e240c415b5eb83e3a22f02b777b5d0fd148f194fecd9ae0c7376)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanBackgroundColor",
    jsii_struct_bases=[],
    name_mapping={"color": "color", "color_var": "colorVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanBackgroundColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__564a196b878ee7c9c4c07f672e867262ad0687fec091856cb2293de974434dc8)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanBackgroundColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanBackgroundColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanBackgroundColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c92b88a1398a3bd630516a1b1108b9dae04e4dc3e70785728974689980b5bd0b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanBackgroundColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5df97b3e113bebfb73fd3090604221b4adb4ddcb1c536a353ab75e2ec6c71fc8)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanBackgroundColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2971b2dfd0cf618774b4a263936a979c9e9818b84f9c38b3c5daaeac2c690580)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__24baf910e15ecdb75378d31138c8d90aa72d993330e10bc04250e6eb1051ef72)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2af3e8138f0c57438f199280ee48928a95b3fdb4ea69d42ddff05923fdabdbab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanBackgroundColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanBackgroundColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b8187f4a476f1316d6639e3238836f357e453b66534992370457b71a9d8d6341)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanBackgroundColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanBackgroundColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__91f7c55fc7982e084616a84f5c34026f49d518717613307e9f73b94e05f06771)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c720b292bb0bb75197ddfe3a3edc4361ee940e828713a91d726943967187e67c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ee2fbc3411af9d22013fc3c9821a7b4b38e5a4d127c32958b298fbddb8e068b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanBackgroundColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanBackgroundColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanBackgroundColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be8cc0ff9be6d4c74400f3731cbe5c4ee5ba3c46d89e642012fe8d7e06ba2288)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanBlur",
    jsii_struct_bases=[],
    name_mapping={"sigma": "sigma", "sigma_var": "sigmaVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanBlur:
    def __init__(
        self,
        *,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param sigma: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__97e70cf5b98918cf21cc579ac2b864a41f5649720747e59ba69677cdc591d734)
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanBlur(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanBlurList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanBlurList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__870dde7d5e9c9dfaae574d110cf6b92c831176f9a10947400a7a73f65276787c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanBlurOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f32bf60bc01f0f36ce3171644ddefd0a56b7e21ca0ba5363cc813444be797474)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanBlurOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e09b87b2f14b9ba6cc949a048b3bb3206ef57f060c234ef78d8fba6cdc3a0e8d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__59a780e260e32bd33cbbbb0c5442f759ae221b0cbc145eae649c631822e7067e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__59805dc6eda3fa38e441c79eabd4d0297c1d8592eac47c89cd95f141b5ca1552)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanBlur]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanBlur]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__49eb88759e2fe0c5cce3e3ab9844f7c1e2616b9f1120638ea2eb0d6be839fb81)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanBlurOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanBlurOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f0c10ae76b01f0154a7a8b215c9b64bd7b3d7afc503352940b72564c31ab1734)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ffc8e7118fe784305c15164da3dd654e33a8ba9b02e03889473f564d0004a1d1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__647139ceed12f31aaa0a99dab056faa7dab82673181139802384c6c583b38f36)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanBlur]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanBlur]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanBlur]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4b190a6fe59dfec60b7c03c56e25d951ac4606da95f1f32b2c39816127770ae3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanChromaKey",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_feather": "hueFeather",
        "hue_feather_var": "hueFeatherVar",
        "hue_tolerance": "hueTolerance",
        "hue_tolerance_var": "hueToleranceVar",
        "hue_var": "hueVar",
        "lightness_feather": "lightnessFeather",
        "lightness_feather_var": "lightnessFeatherVar",
        "lightness_tolerance": "lightnessTolerance",
        "lightness_tolerance_var": "lightnessToleranceVar",
        "saturation_feather": "saturationFeather",
        "saturation_feather_var": "saturationFeatherVar",
        "saturation_tolerance": "saturationTolerance",
        "saturation_tolerance_var": "saturationToleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanChromaKey:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_feather: typing.Optional[builtins.str] = None,
        hue_feather_var: typing.Optional[builtins.str] = None,
        hue_tolerance: typing.Optional[builtins.str] = None,
        hue_tolerance_var: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness_feather: typing.Optional[builtins.str] = None,
        lightness_feather_var: typing.Optional[builtins.str] = None,
        lightness_tolerance: typing.Optional[builtins.str] = None,
        lightness_tolerance_var: typing.Optional[builtins.str] = None,
        saturation_feather: typing.Optional[builtins.str] = None,
        saturation_feather_var: typing.Optional[builtins.str] = None,
        saturation_tolerance: typing.Optional[builtins.str] = None,
        saturation_tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_feather: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        :param hue_feather_var: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        :param hue_tolerance: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        :param hue_tolerance_var: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        :param hue_var: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness_feather: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        :param lightness_feather_var: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        :param lightness_tolerance: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        :param lightness_tolerance_var: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        :param saturation_feather: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        :param saturation_feather_var: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        :param saturation_tolerance: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        :param saturation_tolerance_var: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6da5322c8c2e43d027b9a40e7819ade2684c20d93f44144d3337ad8d41807159)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_feather", value=hue_feather, expected_type=type_hints["hue_feather"])
            check_type(argname="argument hue_feather_var", value=hue_feather_var, expected_type=type_hints["hue_feather_var"])
            check_type(argname="argument hue_tolerance", value=hue_tolerance, expected_type=type_hints["hue_tolerance"])
            check_type(argname="argument hue_tolerance_var", value=hue_tolerance_var, expected_type=type_hints["hue_tolerance_var"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness_feather", value=lightness_feather, expected_type=type_hints["lightness_feather"])
            check_type(argname="argument lightness_feather_var", value=lightness_feather_var, expected_type=type_hints["lightness_feather_var"])
            check_type(argname="argument lightness_tolerance", value=lightness_tolerance, expected_type=type_hints["lightness_tolerance"])
            check_type(argname="argument lightness_tolerance_var", value=lightness_tolerance_var, expected_type=type_hints["lightness_tolerance_var"])
            check_type(argname="argument saturation_feather", value=saturation_feather, expected_type=type_hints["saturation_feather"])
            check_type(argname="argument saturation_feather_var", value=saturation_feather_var, expected_type=type_hints["saturation_feather_var"])
            check_type(argname="argument saturation_tolerance", value=saturation_tolerance, expected_type=type_hints["saturation_tolerance"])
            check_type(argname="argument saturation_tolerance_var", value=saturation_tolerance_var, expected_type=type_hints["saturation_tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_feather is not None:
            self._values["hue_feather"] = hue_feather
        if hue_feather_var is not None:
            self._values["hue_feather_var"] = hue_feather_var
        if hue_tolerance is not None:
            self._values["hue_tolerance"] = hue_tolerance
        if hue_tolerance_var is not None:
            self._values["hue_tolerance_var"] = hue_tolerance_var
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness_feather is not None:
            self._values["lightness_feather"] = lightness_feather
        if lightness_feather_var is not None:
            self._values["lightness_feather_var"] = lightness_feather_var
        if lightness_tolerance is not None:
            self._values["lightness_tolerance"] = lightness_tolerance
        if lightness_tolerance_var is not None:
            self._values["lightness_tolerance_var"] = lightness_tolerance_var
        if saturation_feather is not None:
            self._values["saturation_feather"] = saturation_feather
        if saturation_feather_var is not None:
            self._values["saturation_feather_var"] = saturation_feather_var
        if saturation_tolerance is not None:
            self._values["saturation_tolerance"] = saturation_tolerance
        if saturation_tolerance_var is not None:
            self._values["saturation_tolerance_var"] = saturation_tolerance_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        '''
        result = self._values.get("hue_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        '''
        result = self._values.get("hue_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        '''
        result = self._values.get("hue_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        '''
        result = self._values.get("hue_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        '''
        result = self._values.get("lightness_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        '''
        result = self._values.get("lightness_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        '''
        result = self._values.get("lightness_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        '''
        result = self._values.get("lightness_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        '''
        result = self._values.get("saturation_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        '''
        result = self._values.get("saturation_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        '''
        result = self._values.get("saturation_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        result = self._values.get("saturation_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanChromaKey(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanChromaKeyList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanChromaKeyList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__090e90119d224ef364615644c8cd9686dc21c7da21e4ddc0322f9fab8d3fc02e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanChromaKeyOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c9e2148e2cf834a2ada933de66a886816246d00f0e7a4139ac8233625305ef84)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanChromaKeyOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__379a63fb6150916dfed15a5fd1c265778f397d86855294cce47d46e717f8c2b1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e7351a9051bc7f36da776c869b0207016a7b2f8cbd6858fc591cf04af06a710c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9892d551ad1c539d8dae0413f1a510f6835a5fff25ce59ae09b4edb42989c175)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanChromaKey]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanChromaKey]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b377e5612866e9ac81bafec5cbdb63527f41e834291714f64b89690d8306b962)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanChromaKeyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanChromaKeyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b069d7076007842263af071aaf346c73c9409a29c6e3499f181de8397fe75917)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueFeather")
    def reset_hue_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeather", []))

    @jsii.member(jsii_name="resetHueFeatherVar")
    def reset_hue_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeatherVar", []))

    @jsii.member(jsii_name="resetHueTolerance")
    def reset_hue_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueTolerance", []))

    @jsii.member(jsii_name="resetHueToleranceVar")
    def reset_hue_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueToleranceVar", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightnessFeather")
    def reset_lightness_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeather", []))

    @jsii.member(jsii_name="resetLightnessFeatherVar")
    def reset_lightness_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeatherVar", []))

    @jsii.member(jsii_name="resetLightnessTolerance")
    def reset_lightness_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessTolerance", []))

    @jsii.member(jsii_name="resetLightnessToleranceVar")
    def reset_lightness_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessToleranceVar", []))

    @jsii.member(jsii_name="resetSaturationFeather")
    def reset_saturation_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeather", []))

    @jsii.member(jsii_name="resetSaturationFeatherVar")
    def reset_saturation_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeatherVar", []))

    @jsii.member(jsii_name="resetSaturationTolerance")
    def reset_saturation_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationTolerance", []))

    @jsii.member(jsii_name="resetSaturationToleranceVar")
    def reset_saturation_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherInput")
    def hue_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVarInput")
    def hue_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceInput")
    def hue_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVarInput")
    def hue_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherInput")
    def lightness_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVarInput")
    def lightness_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceInput")
    def lightness_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVarInput")
    def lightness_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherInput")
    def saturation_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVarInput")
    def saturation_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceInput")
    def saturation_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVarInput")
    def saturation_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__35dd74b27f89fbc649fed7d8fd8228874ddbfda376d532b2e86ee8597622e85b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeather")
    def hue_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeather"))

    @hue_feather.setter
    def hue_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2347a3cc5faa2d66bef0b4c53129dd9f0074a0d44bd1f4beb6daf7ab5e5895e0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeather", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVar")
    def hue_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeatherVar"))

    @hue_feather_var.setter
    def hue_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e8b673bc7d635795c89813e94b6303bc9a1758ba5b9b365ad392b237a67193aa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueTolerance")
    def hue_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueTolerance"))

    @hue_tolerance.setter
    def hue_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__47a3d9b9054e848d664ba26cfa95260cbbd085e2ed240df7cfd8b1c0a218d603)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVar")
    def hue_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueToleranceVar"))

    @hue_tolerance_var.setter
    def hue_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f7e1c7e0333d31f0323197888c48f125b809a8c53753f1099aab7ab029bc58fc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__686722ad5c63535793c30b8f758a3fd3b27331957be78d495693f239de96bdb7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeather")
    def lightness_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeather"))

    @lightness_feather.setter
    def lightness_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d759659643e001e59ed119b0b3f0509dfc36940fb206bb83268b9a2820fe023b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeather", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVar")
    def lightness_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeatherVar"))

    @lightness_feather_var.setter
    def lightness_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0b97ee5b0ba894fe8591bd8aa05d0a4ff9962199d83dbd1a7e37203b804e369b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessTolerance")
    def lightness_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessTolerance"))

    @lightness_tolerance.setter
    def lightness_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d169ee15aa7126321c8ffc14ed172a54a402d441861b84402c1b07d77c2a840)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVar")
    def lightness_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessToleranceVar"))

    @lightness_tolerance_var.setter
    def lightness_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ee5345d05b4b910f4a0ac9fb4f34eacd80acabd0d49316f3a896367fb33399fb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeather")
    def saturation_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeather"))

    @saturation_feather.setter
    def saturation_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__02bbf7d23698105007e4db6b8a229c90494fe3d7519568a0c46dd2d2012c78bf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeather", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVar")
    def saturation_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeatherVar"))

    @saturation_feather_var.setter
    def saturation_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c243645e28230e2d1966c0b25fc87a8a88c4ea07372fbdb451b35f29db715266)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationTolerance")
    def saturation_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationTolerance"))

    @saturation_tolerance.setter
    def saturation_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8bd08e5b29313cc14b5c6876b7a9c828d4c5f625ed82e5da0e8ac5684fe4e979)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVar")
    def saturation_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationToleranceVar"))

    @saturation_tolerance_var.setter
    def saturation_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__581ea5e4c8823fa07cd8e3f98f8bde88b23408d508e625e94a1db575fd52d6f5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanChromaKey]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanChromaKey]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanChromaKey]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__93ebd3ebd57f92ae8922017577fee40e131ac1fff1834bfcdfefa95355a5d2f4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanComposite",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "placement": "placement",
        "placement_var": "placementVar",
        "scale": "scale",
        "scale_dimension": "scaleDimension",
        "scale_dimension_var": "scaleDimensionVar",
        "scale_var": "scaleVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanComposite:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanCompositeImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        placement: typing.Optional[builtins.str] = None,
        placement_var: typing.Optional[builtins.str] = None,
        scale: typing.Optional[builtins.str] = None,
        scale_dimension: typing.Optional[builtins.str] = None,
        scale_dimension_var: typing.Optional[builtins.str] = None,
        scale_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param placement: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        :param placement_var: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        :param scale: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param scale_dimension: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        :param scale_dimension_var: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        :param scale_var: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        :param x_position: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanCompositeImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__46d2c9f81c5e447631a9c68214f8ef1e26a75455ff7f4ef13d24966c3d89c4ed)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument placement", value=placement, expected_type=type_hints["placement"])
            check_type(argname="argument placement_var", value=placement_var, expected_type=type_hints["placement_var"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument scale_dimension", value=scale_dimension, expected_type=type_hints["scale_dimension"])
            check_type(argname="argument scale_dimension_var", value=scale_dimension_var, expected_type=type_hints["scale_dimension_var"])
            check_type(argname="argument scale_var", value=scale_var, expected_type=type_hints["scale_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if placement is not None:
            self._values["placement"] = placement
        if placement_var is not None:
            self._values["placement_var"] = placement_var
        if scale is not None:
            self._values["scale"] = scale
        if scale_dimension is not None:
            self._values["scale_dimension"] = scale_dimension
        if scale_dimension_var is not None:
            self._values["scale_dimension_var"] = scale_dimension_var
        if scale_var is not None:
            self._values["scale_var"] = scale_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanCompositeImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanCompositeImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        '''
        result = self._values.get("placement")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement_var(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        '''
        result = self._values.get("placement_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        '''
        result = self._values.get("scale_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        '''
        result = self._values.get("scale_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        '''
        result = self._values.get("scale_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanComposite(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanCompositeImage",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanCompositeImage:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanCompositeImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanCompositeImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanCompositeImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__710cb76efd5a67b09ee06b8230f1e7d79ec4cf9b34a103cec4dfc73892dc024e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanCompositeImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanCompositeImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ed4db96696c68c1ded53c15619b103098de7abe5d4766252bdc1f1d6f8488e00)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanCompositeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanCompositeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aa1718421703f17b2ad2830c717b103dbf50ada9403237cae9ead5c05fe48e73)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanCompositeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__49c98985d5b556dbf4caadc2f1f64ee9ca3f7f7286040ef1e61f4e00e11269af)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanCompositeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5388dfc45d6a09b58f015831fdd68377c000b120637db8fa584214e43ad10e13)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5bb08473a22c76159938a5897227edb3bac499cbc542dde353cd3827e60e055b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__521e3937655df4e5a0697f673e1871f8d9acdd14d7535c90251d75c63f3e0d3e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanComposite]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanComposite]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__99894a4008427b82d3f38329947baea40918db76db9878740eeaa75987cb67d6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanCompositeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanCompositeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4e5f5ee891f34233bce5a95af3ccfa348a46fc53cfad1b22e9cd6306d7bc70a3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanCompositeImage()

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPlacement")
    def reset_placement(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacement", []))

    @jsii.member(jsii_name="resetPlacementVar")
    def reset_placement_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacementVar", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetScaleDimension")
    def reset_scale_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimension", []))

    @jsii.member(jsii_name="resetScaleDimensionVar")
    def reset_scale_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimensionVar", []))

    @jsii.member(jsii_name="resetScaleVar")
    def reset_scale_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanCompositeImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanCompositeImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanCompositeImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="placementInput")
    def placement_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementInput"))

    @builtins.property
    @jsii.member(jsii_name="placementVarInput")
    def placement_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionInput")
    def scale_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVarInput")
    def scale_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleVarInput")
    def scale_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__375a8b6999a252914067281ff797b5015b96eaec7345c7f9e2f40c1dbac2b1eb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b6e0cf96e2575a0edf9c92560c8a49ed6cd023a925b8be90d798d1ee5c89086f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="placement")
    def placement(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placement"))

    @placement.setter
    def placement(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__14114ca1e471802bc08d3281a672837db48898d8a773ff2d7d08033a1f71ed8d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placement", value)

    @builtins.property
    @jsii.member(jsii_name="placementVar")
    def placement_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placementVar"))

    @placement_var.setter
    def placement_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f834a93cfcba905bc673094e8fae1f49425afff5b6f9d15a90fe6473141312e9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placementVar", value)

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scale"))

    @scale.setter
    def scale(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6d560e2afd33a954da6b4ebcea882ec0df534902ed4eb364e02878783055ed21)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scale", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimension")
    def scale_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimension"))

    @scale_dimension.setter
    def scale_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f9b53c6fccf436b2fde73585085880c76e5fbdb792785cc0ed0d95d055a77b0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimension", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVar")
    def scale_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimensionVar"))

    @scale_dimension_var.setter
    def scale_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__90529d830a2f559d8a7f120eef42b6c3dc28e1b779c58adc5f19324ddda245e6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="scaleVar")
    def scale_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleVar"))

    @scale_var.setter
    def scale_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__91bd7e3c6318671b9a4e2189e42fe2dc1116da2ec0b1220fba32206427a1c75a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ca3914a8f3af2c0108dc0bc2917caec5ff447979793da9d69b7f7b9b5401dcbd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d5ccf19d7814d38b94cb29d4753b4c29d6ecb6d8f8cbeb907016f776182af738)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__37d55e48d786620fa2e38fc1e0fc82602ff99c88d7b40cda6266e3f94124359b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3e4fde770fc6ac842f7ca9465b381a0c9220e2d9af016bd02e0bebbafa2a60b8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanComposite]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanComposite]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanComposite]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__929f7107a963ff81bc79effde9de0c303c2301a322fde01243302e7029af1c2b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanCompound",
    jsii_struct_bases=[],
    name_mapping={"transformations": "transformations"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanCompound:
    def __init__(
        self,
        *,
        transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param transformations: transformations block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__902d90a7765b5ae6de9ce68ff6d2ad098dd2cf1e758fb6aa9c69b9f7aa540a13)
            check_type(argname="argument transformations", value=transformations, expected_type=type_hints["transformations"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if transformations is not None:
            self._values["transformations"] = transformations

    @builtins.property
    def transformations(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanCompoundTransformations"]]]:
        '''transformations block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        result = self._values.get("transformations")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanCompoundTransformations"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanCompound(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanCompoundList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanCompoundList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a1c925e8c4eb6a12ccbcfa54184849fc0a4c42973402ece04782900d4faa23b3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanCompoundOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f7467881d43f9ae8d329d863c9c47624cc2b14c9bf6a066c4cb8fdbd20126c43)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanCompoundOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5dba8960e535edf7faf16c8aa71740416104f4dda5c72e0d2a521ffd42d68f14)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e7484b4856a8dfdd160c402caa3ec80eca50658cacee78e1cc93bce6e7219c8b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6895c8ce7ca0cad7913fff8591f2b87cf23afa7ffe674222af7d7b034d7f2565)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanCompound]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanCompound]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6aec3e6b568a6576ccfd82f8a43e2eb5e46e41081ccd79c0a2e9e67bfb6c966f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanCompoundOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanCompoundOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__68517998618a88b17b5dba8304e88cdb14b38ccdcbec30fcf62c0f198b9d3dfb)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformations")
    def put_transformations(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d7d89df5ee575503ba3c864a3c2630cae17b4df82d8e8afdaabe3a4f2cea90d5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTransformations", [value]))

    @jsii.member(jsii_name="resetTransformations")
    def reset_transformations(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformations", []))

    @builtins.property
    @jsii.member(jsii_name="transformations")
    def transformations(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanCompoundTransformationsList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanCompoundTransformationsList", jsii.get(self, "transformations"))

    @builtins.property
    @jsii.member(jsii_name="transformationsInput")
    def transformations_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanCompoundTransformations"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanCompoundTransformations"]]], jsii.get(self, "transformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanCompound]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanCompound]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanCompound]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8753cd46a84e84bdeca0677cc967186ff79db4587bde6e3df601ff4cc89ab640)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanCompoundTransformations",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanCompoundTransformations:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanCompoundTransformations(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanCompoundTransformationsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanCompoundTransformationsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2b2bbf2123ecc5049d1ce2f7a17a6b25578bbdf2cdf5839777883b1aab2b8fac)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanCompoundTransformationsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8e49630ad5d4c65a9ac85240ced7e37ee61a84f81c180344774875f60ec47cc3)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanCompoundTransformationsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d725f80db2b41570023abd23989e2e6e3dc71e71fd9a39fef23441229ab1d125)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a896e37eb33b241994f3ddbe16a016988f84a56ab8b00b02684865a7b2bc0b7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__978e0a7d4d2a88c379337050a58b6942aabb661038050d989da62c8ad8a99b3e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanCompoundTransformations]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanCompoundTransformations]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanCompoundTransformations]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__85dad25f18d2790bcd0d9703a2ef1e41d6573b5439e9d8209c5684cdfb9af876)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanCompoundTransformationsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanCompoundTransformationsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8feda665e2ff99edc77b0b6d6d818cd70c8fd0530c0d0e5b6196f0094e164328)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanCompoundTransformations]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanCompoundTransformations]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanCompoundTransformations]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8db03b8c6d4a739f45c7c1f0299245d13c2e98154eaa5b3aa66f62a520018125)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanContrast",
    jsii_struct_bases=[],
    name_mapping={
        "brightness": "brightness",
        "brightness_var": "brightnessVar",
        "contrast": "contrast",
        "contrast_var": "contrastVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanContrast:
    def __init__(
        self,
        *,
        brightness: typing.Optional[builtins.str] = None,
        brightness_var: typing.Optional[builtins.str] = None,
        contrast: typing.Optional[builtins.str] = None,
        contrast_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param brightness: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        :param brightness_var: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        :param contrast: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param contrast_var: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e608866331790e8ef854096e842140de73a35057570e8cb0176676d77bdbf38a)
            check_type(argname="argument brightness", value=brightness, expected_type=type_hints["brightness"])
            check_type(argname="argument brightness_var", value=brightness_var, expected_type=type_hints["brightness_var"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument contrast_var", value=contrast_var, expected_type=type_hints["contrast_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if brightness is not None:
            self._values["brightness"] = brightness
        if brightness_var is not None:
            self._values["brightness_var"] = brightness_var
        if contrast is not None:
            self._values["contrast"] = contrast
        if contrast_var is not None:
            self._values["contrast_var"] = contrast_var

    @builtins.property
    def brightness(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        '''
        result = self._values.get("brightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def brightness_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        '''
        result = self._values.get("brightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        result = self._values.get("contrast_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanContrast(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanContrastList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanContrastList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cbc284fa410c35796be9e150bf5557e2951932e2ab5fdd12d360e1a9c8943a65)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanContrastOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__931a33a763abe42aa76742da2c10602b147021de07570a9c57ea10d9a07ad455)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanContrastOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__42e0ff78b2f232bf8404f8378aa812eca92a7f440e0653e0f2277149c6c3516f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d7e39dd0df71862cb00c687aed0f8aae1e6c5713b0ec9d48fc9cb889b04dd581)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__124d055d3f9c461a57a3f51fca7e4b3eb75e4b751929827f4d9138ac6aff9780)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanContrast]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanContrast]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d53ae66b10431147094926be721664c9d62a153660d73f268339b2783c13ae3c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanContrastOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanContrastOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1a1b20fe33d0b5bf37a25ef9ccb3f4cc7759ac66a7bebc2d6a1b6b4f88219814)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetBrightness")
    def reset_brightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightness", []))

    @jsii.member(jsii_name="resetBrightnessVar")
    def reset_brightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightnessVar", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetContrastVar")
    def reset_contrast_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrastVar", []))

    @builtins.property
    @jsii.member(jsii_name="brightnessInput")
    def brightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="brightnessVarInput")
    def brightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastVarInput")
    def contrast_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="brightness")
    def brightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightness"))

    @brightness.setter
    def brightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3dc8d4fad10610f60dc8411ff9d5547d9b016e0adb03b78b139cf5a977ab834b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightness", value)

    @builtins.property
    @jsii.member(jsii_name="brightnessVar")
    def brightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightnessVar"))

    @brightness_var.setter
    def brightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f763bc5f34e33df283951c53b6a911a057beb554ce865a6a6ace8abc7b579564)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrast"))

    @contrast.setter
    def contrast(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__90f892f0a4f6e5920b8b9768effc93e0aa868b1345df183c364d431757023147)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrast", value)

    @builtins.property
    @jsii.member(jsii_name="contrastVar")
    def contrast_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrastVar"))

    @contrast_var.setter
    def contrast_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fcd8f0bf5289282e647dad286283fe9590a4811281708b6bf163d65871a6738b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrastVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanContrast]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanContrast]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanContrast]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eb13f9fcb1446b460f00a4d1bc0ca0fec153823db50ac7528e61dc52f17560fd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanCrop",
    jsii_struct_bases=[],
    name_mapping={
        "allow_expansion": "allowExpansion",
        "allow_expansion_var": "allowExpansionVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanCrop:
    def __init__(
        self,
        *,
        allow_expansion: typing.Optional[builtins.str] = None,
        allow_expansion_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_expansion: If cropping an area outside of the existing canvas, expands the image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        :param allow_expansion_var: If cropping an area outside of the existing canvas, expands the image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        :param gravity: Frame of reference for X and Y Positions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Frame of reference for X and Y Positions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The number of pixels to crop along the y-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The number of pixels to crop along the y-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The number of pixels to crop along the x-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The number of pixels to crop along the x-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        :param x_position: The x-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e13f59b2a3a0cbd9f0150b085c20ef05a56ff88384c55e4c8d672a48644fe339)
            check_type(argname="argument allow_expansion", value=allow_expansion, expected_type=type_hints["allow_expansion"])
            check_type(argname="argument allow_expansion_var", value=allow_expansion_var, expected_type=type_hints["allow_expansion_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if allow_expansion is not None:
            self._values["allow_expansion"] = allow_expansion
        if allow_expansion_var is not None:
            self._values["allow_expansion_var"] = allow_expansion_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def allow_expansion(self) -> typing.Optional[builtins.str]:
        '''If cropping an area outside of the existing canvas, expands the image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        '''
        result = self._values.get("allow_expansion")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def allow_expansion_var(self) -> typing.Optional[builtins.str]:
        '''If cropping an area outside of the existing canvas, expands the image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        '''
        result = self._values.get("allow_expansion_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Frame of reference for X and Y Positions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Frame of reference for X and Y Positions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the y-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the y-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the x-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the x-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9dc64db9d9610b01fc34110f37ba3546f04e70ddf5662281e5f1e3c55ef2ef36)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f87f2c7e9ac69bc6d5fbbf18e8795a65bf6a07d9d0c30635d67479b60c269f5d)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__218c7e93d4ba6f15ba3f38e40c58fca455e13c61665fe758bf830d57a6eb4c6c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7cab487688439721c28802f47d8d503aea0a32548e033fd1f0b8904c0ba6fb8a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f989fb3c6a1c6ee12695997f3bba181971c8ee18dc09da14f83d1ddf68317e8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cfb483364a53ffea2394b576542a37b9bcd7ad579ac3dd7e17a22cbd8f27dc1c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__83627e2cc3f5a2f2ec8b995751755d1550e46e5521c5c7722c7581c79cd6bef8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAllowExpansion")
    def reset_allow_expansion(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansion", []))

    @jsii.member(jsii_name="resetAllowExpansionVar")
    def reset_allow_expansion_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansionVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionInput")
    def allow_expansion_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVarInput")
    def allow_expansion_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansion")
    def allow_expansion(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansion"))

    @allow_expansion.setter
    def allow_expansion(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b559a653e002ea7f548ae90a34bb12e680baa3bfe074e324976ab448caa98fee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansion", value)

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVar")
    def allow_expansion_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansionVar"))

    @allow_expansion_var.setter
    def allow_expansion_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__95da2467506e9d0d71e1ff3b759fb7d9b5b7dec1ed0d71ed157daf66acf7cc06)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansionVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c1601cfb1340a0e008bf527fcca48a6039a3d8ff3c52a836a41ad2ddffb484ea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__68b47c6a89999ffefd7de8fc0d935718015457015e7ea887d73d7ae00d9ac5bc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5cfd0b94ca79440cac4c889dec096ab112453d851f75b8c25a394ef3b0ff9440)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__28174b236d7a58d3ca9b3c71984ea94df3e302f6f91f3460164d7c612b517f48)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d489ac9c5d65e924ac705e4cb9385cb01b1f71b61310a46cf0aa6d6ded990611)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__968e421e919719286c785f418e65153e1c68c02e71a8afb281b7589c2a835c2a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__00217cbf77e584eb3407bd0ee59112308cdf3221089dfcf741404400f5b1e2df)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d84dd3f1d18edc2d81836f3f7f2dfec835c827b2c5777f89c5fa9f1f2e707e7a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7673d5b78f6f944fcda1251072f62049f703a0b8e5c6c0680c2307cfb57137dd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0e907991cecf373a3527289bb775541a72c9e3487ea77e2292dc5be58097099f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0816a2eac0e8143d06623c6593e175a41355597829c56d931ed81d2825b77e8d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanFaceCrop",
    jsii_struct_bases=[],
    name_mapping={
        "algorithm": "algorithm",
        "algorithm_var": "algorithmVar",
        "confidence": "confidence",
        "confidence_var": "confidenceVar",
        "fail_gravity": "failGravity",
        "fail_gravity_var": "failGravityVar",
        "focus": "focus",
        "focus_var": "focusVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "padding": "padding",
        "padding_var": "paddingVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanFaceCrop:
    def __init__(
        self,
        *,
        algorithm: typing.Optional[builtins.str] = None,
        algorithm_var: typing.Optional[builtins.str] = None,
        confidence: typing.Optional[builtins.str] = None,
        confidence_var: typing.Optional[builtins.str] = None,
        fail_gravity: typing.Optional[builtins.str] = None,
        fail_gravity_var: typing.Optional[builtins.str] = None,
        focus: typing.Optional[builtins.str] = None,
        focus_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param algorithm: Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm DataAkamaiImagingPolicyImage#algorithm}
        :param algorithm_var: Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm_var DataAkamaiImagingPolicyImage#algorithm_var}
        :param confidence: With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image. Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence DataAkamaiImagingPolicyImage#confidence}
        :param confidence_var: With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image. Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence_var DataAkamaiImagingPolicyImage#confidence_var}
        :param fail_gravity: Controls placement of the crop if Image and Video Manager does not detect any faces in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        :param fail_gravity_var: Controls placement of the crop if Image and Video Manager does not detect any faces in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        :param focus: Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus DataAkamaiImagingPolicyImage#focus}
        :param focus_var: Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus_var DataAkamaiImagingPolicyImage#focus_var}
        :param gravity: Controls placement of the crop. Directions are relative to the face(s) plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Controls placement of the crop. Directions are relative to the face(s) plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param padding: The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        :param style: Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ba747847262b6aac996c7bb88861ea0481c60158e5b9629857b372b1ffdabe94)
            check_type(argname="argument algorithm", value=algorithm, expected_type=type_hints["algorithm"])
            check_type(argname="argument algorithm_var", value=algorithm_var, expected_type=type_hints["algorithm_var"])
            check_type(argname="argument confidence", value=confidence, expected_type=type_hints["confidence"])
            check_type(argname="argument confidence_var", value=confidence_var, expected_type=type_hints["confidence_var"])
            check_type(argname="argument fail_gravity", value=fail_gravity, expected_type=type_hints["fail_gravity"])
            check_type(argname="argument fail_gravity_var", value=fail_gravity_var, expected_type=type_hints["fail_gravity_var"])
            check_type(argname="argument focus", value=focus, expected_type=type_hints["focus"])
            check_type(argname="argument focus_var", value=focus_var, expected_type=type_hints["focus_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if algorithm is not None:
            self._values["algorithm"] = algorithm
        if algorithm_var is not None:
            self._values["algorithm_var"] = algorithm_var
        if confidence is not None:
            self._values["confidence"] = confidence
        if confidence_var is not None:
            self._values["confidence_var"] = confidence_var
        if fail_gravity is not None:
            self._values["fail_gravity"] = fail_gravity
        if fail_gravity_var is not None:
            self._values["fail_gravity_var"] = fail_gravity_var
        if focus is not None:
            self._values["focus"] = focus
        if focus_var is not None:
            self._values["focus_var"] = focus_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def algorithm(self) -> typing.Optional[builtins.str]:
        '''Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm DataAkamaiImagingPolicyImage#algorithm}
        '''
        result = self._values.get("algorithm")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def algorithm_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm_var DataAkamaiImagingPolicyImage#algorithm_var}
        '''
        result = self._values.get("algorithm_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def confidence(self) -> typing.Optional[builtins.str]:
        '''With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image.

        Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence DataAkamaiImagingPolicyImage#confidence}
        '''
        result = self._values.get("confidence")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def confidence_var(self) -> typing.Optional[builtins.str]:
        '''With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image.

        Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence_var DataAkamaiImagingPolicyImage#confidence_var}
        '''
        result = self._values.get("confidence_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any faces in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        '''
        result = self._values.get("fail_gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any faces in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        '''
        result = self._values.get("fail_gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def focus(self) -> typing.Optional[builtins.str]:
        '''Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus DataAkamaiImagingPolicyImage#focus}
        '''
        result = self._values.get("focus")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def focus_var(self) -> typing.Optional[builtins.str]:
        '''Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus_var DataAkamaiImagingPolicyImage#focus_var}
        '''
        result = self._values.get("focus_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the face(s) plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the face(s) plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanFaceCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanFaceCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanFaceCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5afa70d330360834d612e054c56031dcefbc7f48378787ba4d1077cae005b1d1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanFaceCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e5affd1779d24b74dff2e73daa31cbcd14b4e365a4b1fa643ebfbee9dd941ef2)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanFaceCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8e347556f99d194b1d82c202e94c7c67fedcbee0e3012bd932cd8aa5c6339cc9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6a6f38ce5add5189970b791a5c19917a957c32721937c8dd53a265779f6fd04a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__40e7a49825b313d9b79fbe80c780c839965d3e478a1d7e9b7173b4ae705c6c8e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanFaceCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanFaceCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanFaceCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fac632d13f0687bdff6e039c30db8e3fc762d9f37c3d857f0d98c00586cabf1e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanFaceCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanFaceCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4b0edf621b1c13e2f33681b38cc98b9915a5f82ceb89d3536eb6daedf15504f8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAlgorithm")
    def reset_algorithm(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAlgorithm", []))

    @jsii.member(jsii_name="resetAlgorithmVar")
    def reset_algorithm_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAlgorithmVar", []))

    @jsii.member(jsii_name="resetConfidence")
    def reset_confidence(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetConfidence", []))

    @jsii.member(jsii_name="resetConfidenceVar")
    def reset_confidence_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetConfidenceVar", []))

    @jsii.member(jsii_name="resetFailGravity")
    def reset_fail_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravity", []))

    @jsii.member(jsii_name="resetFailGravityVar")
    def reset_fail_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravityVar", []))

    @jsii.member(jsii_name="resetFocus")
    def reset_focus(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFocus", []))

    @jsii.member(jsii_name="resetFocusVar")
    def reset_focus_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFocusVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="algorithmInput")
    def algorithm_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "algorithmInput"))

    @builtins.property
    @jsii.member(jsii_name="algorithmVarInput")
    def algorithm_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "algorithmVarInput"))

    @builtins.property
    @jsii.member(jsii_name="confidenceInput")
    def confidence_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "confidenceInput"))

    @builtins.property
    @jsii.member(jsii_name="confidenceVarInput")
    def confidence_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "confidenceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityInput")
    def fail_gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityVarInput")
    def fail_gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="focusInput")
    def focus_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "focusInput"))

    @builtins.property
    @jsii.member(jsii_name="focusVarInput")
    def focus_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "focusVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="algorithm")
    def algorithm(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "algorithm"))

    @algorithm.setter
    def algorithm(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__39d8adc8535494c99c17689773b16bbe47432297708a092c70878f1de01d7ada)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "algorithm", value)

    @builtins.property
    @jsii.member(jsii_name="algorithmVar")
    def algorithm_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "algorithmVar"))

    @algorithm_var.setter
    def algorithm_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d05ff6cc18a4aa2d84a658b72421ac409e21943686d496c69980aa04a208f6c6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "algorithmVar", value)

    @builtins.property
    @jsii.member(jsii_name="confidence")
    def confidence(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "confidence"))

    @confidence.setter
    def confidence(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__83c55a5006e0a1a233d425bce0b70e795144d0dce3fca700053108fa38a09a11)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "confidence", value)

    @builtins.property
    @jsii.member(jsii_name="confidenceVar")
    def confidence_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "confidenceVar"))

    @confidence_var.setter
    def confidence_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__763d3a78f8edd2d2fc146284f05724586acb1349d267087630c59232e8b66621)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "confidenceVar", value)

    @builtins.property
    @jsii.member(jsii_name="failGravity")
    def fail_gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravity"))

    @fail_gravity.setter
    def fail_gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__556abb7565f4de938d33a28c52b9da4442721bc6df044116e247a1b45bfa6c07)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravity", value)

    @builtins.property
    @jsii.member(jsii_name="failGravityVar")
    def fail_gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravityVar"))

    @fail_gravity_var.setter
    def fail_gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e914e71474d0f4749df40f60fa45a3fc83251458e37440069d7a4598f7590949)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="focus")
    def focus(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "focus"))

    @focus.setter
    def focus(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4616977955d1feb42bdb4a9129384f200720ccf3a69e87118e49c58edb715104)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "focus", value)

    @builtins.property
    @jsii.member(jsii_name="focusVar")
    def focus_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "focusVar"))

    @focus_var.setter
    def focus_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fcac86c8c41a98a78f2668177fa366009ce69d87355502f745bd279ad009bed4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "focusVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__92a59d6fb8075348e70d1b172d1b0ecc34be5be9bee091abd7d34741cff7ecb6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__66a5b1cccfc403340351fd642a2da1a12b12533961c884a0d14bd1b43790bb00)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fe4d186dad4c24ccdf194040e605fdabf811b94d933eaab19956f6eb4c633c01)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ad4d8b498decc27e8816be7dc290aeea404044999898980d42840fa5938e716)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5dd83f1ad8d54422a1ccb78fb08a8f4345602e82f2ece970ece22da2c8d77b0e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af06806575d139fccb1e1f7ffe0946ee1ec4e232fae4d1b76d7f810585c75872)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__84410335b1c32163452532e511747ed1a6254dd4541b6eb1c419395a8a01a1b9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1845b263559ed886b4d023b880c448d6038eaaca01975b6a36e613d096ff823e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b0013b40f88892f6c9bbdce20ddb66668cf04731bf883dea3a3743c8f0d8ee9a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3e240c8ca87c6fc5cb1a24301c15edf019e14ca289f47c7bb9156c1d24455c98)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanFaceCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanFaceCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanFaceCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__de9f37e220414f9010712ca304253d83a5c27c77c2e9ab2f68bb48946b87520b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanFeatureCrop",
    jsii_struct_bases=[],
    name_mapping={
        "fail_gravity": "failGravity",
        "fail_gravity_var": "failGravityVar",
        "feature_radius": "featureRadius",
        "feature_radius_var": "featureRadiusVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "max_features": "maxFeatures",
        "max_features_var": "maxFeaturesVar",
        "min_feature_quality": "minFeatureQuality",
        "min_feature_quality_var": "minFeatureQualityVar",
        "padding": "padding",
        "padding_var": "paddingVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanFeatureCrop:
    def __init__(
        self,
        *,
        fail_gravity: typing.Optional[builtins.str] = None,
        fail_gravity_var: typing.Optional[builtins.str] = None,
        feature_radius: typing.Optional[builtins.str] = None,
        feature_radius_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        max_features: typing.Optional[builtins.str] = None,
        max_features_var: typing.Optional[builtins.str] = None,
        min_feature_quality: typing.Optional[builtins.str] = None,
        min_feature_quality_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fail_gravity: Controls placement of the crop if Image and Video Manager does not detect any features in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        :param fail_gravity_var: Controls placement of the crop if Image and Video Manager does not detect any features in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        :param feature_radius: The size in pixels of the important features to search for. If identified, two features never appear closer together than this value, ``8.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius DataAkamaiImagingPolicyImage#feature_radius}
        :param feature_radius_var: The size in pixels of the important features to search for. If identified, two features never appear closer together than this value, ``8.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius_var DataAkamaiImagingPolicyImage#feature_radius_var}
        :param gravity: Controls placement of the crop. Directions are relative to the region of interest plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Controls placement of the crop. Directions are relative to the region of interest plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param max_features: The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features DataAkamaiImagingPolicyImage#max_features}
        :param max_features_var: The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features_var DataAkamaiImagingPolicyImage#max_features_var}
        :param min_feature_quality: Determines the minimum quality level of the feature identified. To consider a feature important, the feature needs to surpass this value. Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality DataAkamaiImagingPolicyImage#min_feature_quality}
        :param min_feature_quality_var: Determines the minimum quality level of the feature identified. To consider a feature important, the feature needs to surpass this value. Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality_var DataAkamaiImagingPolicyImage#min_feature_quality_var}
        :param padding: Adds space around the region of interest. The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: Adds space around the region of interest. The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        :param style: Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cc6042f3b95dcac6b3bd318dc049051fb115a3d2ec402cb71a279ce49ad089eb)
            check_type(argname="argument fail_gravity", value=fail_gravity, expected_type=type_hints["fail_gravity"])
            check_type(argname="argument fail_gravity_var", value=fail_gravity_var, expected_type=type_hints["fail_gravity_var"])
            check_type(argname="argument feature_radius", value=feature_radius, expected_type=type_hints["feature_radius"])
            check_type(argname="argument feature_radius_var", value=feature_radius_var, expected_type=type_hints["feature_radius_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument max_features", value=max_features, expected_type=type_hints["max_features"])
            check_type(argname="argument max_features_var", value=max_features_var, expected_type=type_hints["max_features_var"])
            check_type(argname="argument min_feature_quality", value=min_feature_quality, expected_type=type_hints["min_feature_quality"])
            check_type(argname="argument min_feature_quality_var", value=min_feature_quality_var, expected_type=type_hints["min_feature_quality_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fail_gravity is not None:
            self._values["fail_gravity"] = fail_gravity
        if fail_gravity_var is not None:
            self._values["fail_gravity_var"] = fail_gravity_var
        if feature_radius is not None:
            self._values["feature_radius"] = feature_radius
        if feature_radius_var is not None:
            self._values["feature_radius_var"] = feature_radius_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if max_features is not None:
            self._values["max_features"] = max_features
        if max_features_var is not None:
            self._values["max_features_var"] = max_features_var
        if min_feature_quality is not None:
            self._values["min_feature_quality"] = min_feature_quality
        if min_feature_quality_var is not None:
            self._values["min_feature_quality_var"] = min_feature_quality_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def fail_gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any features in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        '''
        result = self._values.get("fail_gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any features in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        '''
        result = self._values.get("fail_gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feature_radius(self) -> typing.Optional[builtins.str]:
        '''The size in pixels of the important features to search for.

        If identified, two features never appear closer together than this value, ``8.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius DataAkamaiImagingPolicyImage#feature_radius}
        '''
        result = self._values.get("feature_radius")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feature_radius_var(self) -> typing.Optional[builtins.str]:
        '''The size in pixels of the important features to search for.

        If identified, two features never appear closer together than this value, ``8.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius_var DataAkamaiImagingPolicyImage#feature_radius_var}
        '''
        result = self._values.get("feature_radius_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the region of interest plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the region of interest plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def max_features(self) -> typing.Optional[builtins.str]:
        '''The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features DataAkamaiImagingPolicyImage#max_features}
        '''
        result = self._values.get("max_features")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def max_features_var(self) -> typing.Optional[builtins.str]:
        '''The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features_var DataAkamaiImagingPolicyImage#max_features_var}
        '''
        result = self._values.get("max_features_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def min_feature_quality(self) -> typing.Optional[builtins.str]:
        '''Determines the minimum quality level of the feature identified.

        To consider a feature important, the feature needs to surpass this value.  Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality DataAkamaiImagingPolicyImage#min_feature_quality}
        '''
        result = self._values.get("min_feature_quality")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def min_feature_quality_var(self) -> typing.Optional[builtins.str]:
        '''Determines the minimum quality level of the feature identified.

        To consider a feature important, the feature needs to surpass this value.  Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality_var DataAkamaiImagingPolicyImage#min_feature_quality_var}
        '''
        result = self._values.get("min_feature_quality_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''Adds space around the region of interest.

        The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''Adds space around the region of interest.

        The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanFeatureCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanFeatureCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanFeatureCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__958f3d73db0d53e0a5a733f7a25e1ac315277de5ec372d1f6b6951db86cf235f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanFeatureCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9bef7da61b02f6ce4c9c7abff5d9813261dc70df9867c89716e2a5df2053009b)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanFeatureCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd441a2d86f752929a99e12bb8337f33a1c3b316c28858871d76c5699689fead)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__147ab99dfc6846df925a27d12f754a186fcfebce89542dd28873d0d020844fa5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__873a8a89f13b24737390868590164a1fb94b4cbbcbe4614ebf826b5ae5011356)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanFeatureCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanFeatureCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanFeatureCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b983e0e5137fb55e82689c2c448ecbcfaeffce3dfea04e2febe808bb639ad7b5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanFeatureCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanFeatureCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bfe430035f6144ad2d6e585e27f3bae3a1063ea028f795f5b9569cf9d8be2c0e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetFailGravity")
    def reset_fail_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravity", []))

    @jsii.member(jsii_name="resetFailGravityVar")
    def reset_fail_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravityVar", []))

    @jsii.member(jsii_name="resetFeatureRadius")
    def reset_feature_radius(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureRadius", []))

    @jsii.member(jsii_name="resetFeatureRadiusVar")
    def reset_feature_radius_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureRadiusVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetMaxFeatures")
    def reset_max_features(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxFeatures", []))

    @jsii.member(jsii_name="resetMaxFeaturesVar")
    def reset_max_features_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxFeaturesVar", []))

    @jsii.member(jsii_name="resetMinFeatureQuality")
    def reset_min_feature_quality(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMinFeatureQuality", []))

    @jsii.member(jsii_name="resetMinFeatureQualityVar")
    def reset_min_feature_quality_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMinFeatureQualityVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="failGravityInput")
    def fail_gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityVarInput")
    def fail_gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featureRadiusInput")
    def feature_radius_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featureRadiusInput"))

    @builtins.property
    @jsii.member(jsii_name="featureRadiusVarInput")
    def feature_radius_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featureRadiusVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesInput")
    def max_features_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "maxFeaturesInput"))

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesVarInput")
    def max_features_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "maxFeaturesVarInput"))

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityInput")
    def min_feature_quality_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "minFeatureQualityInput"))

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityVarInput")
    def min_feature_quality_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "minFeatureQualityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravity")
    def fail_gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravity"))

    @fail_gravity.setter
    def fail_gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd8fc0379ebf8854a549e7fa254807da0efb34266f669109f15d92e3da7b3cb2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravity", value)

    @builtins.property
    @jsii.member(jsii_name="failGravityVar")
    def fail_gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravityVar"))

    @fail_gravity_var.setter
    def fail_gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7bd6c54542750b8743e246da1b83e712ec0efeb78debc535d2717d797cacc3f0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="featureRadius")
    def feature_radius(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featureRadius"))

    @feature_radius.setter
    def feature_radius(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__28bf421c23844c3f0ac21594e2f4a82990a6c18f0f707475fb67a2b9accc10ec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featureRadius", value)

    @builtins.property
    @jsii.member(jsii_name="featureRadiusVar")
    def feature_radius_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featureRadiusVar"))

    @feature_radius_var.setter
    def feature_radius_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__423aaa4c429481a1f7cbaf6e40a0f46eb10ce4fa1091d443d051cdd991cee38a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featureRadiusVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a729ae49a486f8f978fc6215bee2bfef72bea2d353aa193cab2623f7e4ee7f35)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__386a0fc14f2354043ec8d0f371449614f6da771af398ac90f89f270f83c64293)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dbcaa4b73b2d1f556f085529c34fe37b8edc63f781efd84e758381963e80d21a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c35d3a1aac7c15ddbbe9005daf174a708d4a15f3313ffe336f7ecf616df21a3c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="maxFeatures")
    def max_features(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "maxFeatures"))

    @max_features.setter
    def max_features(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a88cb61583e494508712c83924d9a0ba98ae872cc0218d55fcd771f655151dbc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "maxFeatures", value)

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesVar")
    def max_features_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "maxFeaturesVar"))

    @max_features_var.setter
    def max_features_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c195d122e4e5d6c8178c4fff1dddee7aef1bb61b74b94747f815fef28e4b6a52)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "maxFeaturesVar", value)

    @builtins.property
    @jsii.member(jsii_name="minFeatureQuality")
    def min_feature_quality(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "minFeatureQuality"))

    @min_feature_quality.setter
    def min_feature_quality(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__644b8197f1f5b23126629a0636e5c1282d6415290d82b13de5be1a13b25adb83)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "minFeatureQuality", value)

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityVar")
    def min_feature_quality_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "minFeatureQualityVar"))

    @min_feature_quality_var.setter
    def min_feature_quality_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8ff52320ee8f01d47ff32c54fe9b622ff3a01013e315881e6a435d529018e5b7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "minFeatureQualityVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1e2ed2d4b4cea1023d8a2a176041ea940c5a17d950b6795aad6c4c4fcebd2735)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c3c492aeb8ec7dd5a7880c6e45c3e909cce081c222b832728d6ef7615298d263)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a2b9858b736a7b50f96c5e78cbc34ec9895f921d6492f3f30433ec6f0d768f00)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__13a54d4886cc2d2daf3dc120a0867f0f808d5ad7b0127b0b35fd271b28b7030b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__391358493483322f2f9cb2bb947db71a6c1d3f415d9dda043c3dd52e2365c1ec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__002af9ef07832e0da23d3feab4f94f979a6e020d1b96dfc5731333d94f3c8580)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanFeatureCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanFeatureCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanFeatureCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d3395699aeab27565386131047ae752aea5d1bcb7a166cbed1295f48e607ec9e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanFitAndFill",
    jsii_struct_bases=[],
    name_mapping={
        "fill_transformation": "fillTransformation",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanFitAndFill:
    def __init__(
        self,
        *,
        fill_transformation: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanFitAndFillFillTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fill_transformation: fill_transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_transformation DataAkamaiImagingPolicyImage#fill_transformation}
        :param height: The height value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The width value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(fill_transformation, dict):
            fill_transformation = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanFitAndFillFillTransformation(**fill_transformation)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bcb9d9d4b769b155af66fa74b8d22e0678d3014d7746aeaba54e81de908a2904)
            check_type(argname="argument fill_transformation", value=fill_transformation, expected_type=type_hints["fill_transformation"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fill_transformation is not None:
            self._values["fill_transformation"] = fill_transformation
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def fill_transformation(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanFitAndFillFillTransformation"]:
        '''fill_transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_transformation DataAkamaiImagingPolicyImage#fill_transformation}
        '''
        result = self._values.get("fill_transformation")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanFitAndFillFillTransformation"], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanFitAndFill(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanFitAndFillFillTransformation",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanFitAndFillFillTransformation:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanFitAndFillFillTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanFitAndFillFillTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanFitAndFillFillTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__76c2b6e52691f5571e09624c2d8332e5625fd4c5cf3113f025714c8b8ba15037)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanFitAndFillFillTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanFitAndFillFillTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanFitAndFillFillTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d79b0d39a3f30381acf72e8b186c52e88a59746493886f5317f689c8b41ddda3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanFitAndFillList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanFitAndFillList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2c1d9d92b578177d698adeb4e8126cd9c650a92ec433479ba4268fec433a4a50)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanFitAndFillOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__38385e9e9d883d82d37e0dbe698c572b2a8541f4ec2a328372e39311a7e28f9e)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanFitAndFillOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6de09a665938ec30dcad22c7cb5f769fc7f1f70b7abc75a07044ba3853869ff7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f023ae980ffc83c91e2a5da0b2ae488f74b2a39443f2d9013df1b7cca6e15987)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7eb413bb94b136910a247938c081cca8a7734b0d31ea997bf889a14c21f78054)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanFitAndFill]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanFitAndFill]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanFitAndFill]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4938be3e1a135188eaf6b785b000378fec28e692b99e50c4675402dfaf48377f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanFitAndFillOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanFitAndFillOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e1da756ca71d306a50ad112b63a8a1af62db9d6096cadbf470381135fbb3a4b1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putFillTransformation")
    def put_fill_transformation(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanFitAndFillFillTransformation()

        return typing.cast(None, jsii.invoke(self, "putFillTransformation", [value]))

    @jsii.member(jsii_name="resetFillTransformation")
    def reset_fill_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFillTransformation", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="fillTransformation")
    def fill_transformation(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanFitAndFillFillTransformationOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanFitAndFillFillTransformationOutputReference, jsii.get(self, "fillTransformation"))

    @builtins.property
    @jsii.member(jsii_name="fillTransformationInput")
    def fill_transformation_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanFitAndFillFillTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanFitAndFillFillTransformation], jsii.get(self, "fillTransformationInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ee38aae033528d61e03e46fc37ff91aa5738ec8facb27ca60063bfe5a6bd0e53)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3198ad3cc8d7d29605557ca5dc2645b5d8bc05435edc8cb78b52c2486abe76ed)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be79ef5a2a5f86e72cb4cabd5f4555c1a3478d305513caee448124bf0bc67adc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__79286581b5388136ef2e5e5521e98ac92999f03f50fb39e9cba66eebb2f21237)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanFitAndFill]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanFitAndFill]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanFitAndFill]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__306bcd8b37d625c0b69413bcc8f6eb692b4a0f2a9cb19bd2bb98c62cc4544d69)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanGoop",
    jsii_struct_bases=[],
    name_mapping={
        "chaos": "chaos",
        "chaos_var": "chaosVar",
        "density": "density",
        "density_var": "densityVar",
        "power": "power",
        "power_var": "powerVar",
        "seed": "seed",
        "seed_var": "seedVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanGoop:
    def __init__(
        self,
        *,
        chaos: typing.Optional[builtins.str] = None,
        chaos_var: typing.Optional[builtins.str] = None,
        density: typing.Optional[builtins.str] = None,
        density_var: typing.Optional[builtins.str] = None,
        power: typing.Optional[builtins.str] = None,
        power_var: typing.Optional[builtins.str] = None,
        seed: typing.Optional[builtins.str] = None,
        seed_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param chaos: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        :param chaos_var: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        :param density: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        :param density_var: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        :param power: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        :param power_var: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        :param seed: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        :param seed_var: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f7af60a0647e1fd5826fe6c12c379c5b6ff39f9a16155abfd84d48f1e1fbe9e1)
            check_type(argname="argument chaos", value=chaos, expected_type=type_hints["chaos"])
            check_type(argname="argument chaos_var", value=chaos_var, expected_type=type_hints["chaos_var"])
            check_type(argname="argument density", value=density, expected_type=type_hints["density"])
            check_type(argname="argument density_var", value=density_var, expected_type=type_hints["density_var"])
            check_type(argname="argument power", value=power, expected_type=type_hints["power"])
            check_type(argname="argument power_var", value=power_var, expected_type=type_hints["power_var"])
            check_type(argname="argument seed", value=seed, expected_type=type_hints["seed"])
            check_type(argname="argument seed_var", value=seed_var, expected_type=type_hints["seed_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if chaos is not None:
            self._values["chaos"] = chaos
        if chaos_var is not None:
            self._values["chaos_var"] = chaos_var
        if density is not None:
            self._values["density"] = density
        if density_var is not None:
            self._values["density_var"] = density_var
        if power is not None:
            self._values["power"] = power
        if power_var is not None:
            self._values["power_var"] = power_var
        if seed is not None:
            self._values["seed"] = seed
        if seed_var is not None:
            self._values["seed_var"] = seed_var

    @builtins.property
    def chaos(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        '''
        result = self._values.get("chaos")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def chaos_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        '''
        result = self._values.get("chaos_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        '''
        result = self._values.get("density")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density_var(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        '''
        result = self._values.get("density_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        '''
        result = self._values.get("power")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power_var(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        '''
        result = self._values.get("power_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        '''
        result = self._values.get("seed")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed_var(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        result = self._values.get("seed_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanGoop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanGoopList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanGoopList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6eed8c7f9dabee888cd52f6b785ab5f07df81826d1547fdb73b410416560f0cf)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanGoopOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__023976a901bb4c0fdc53fcf44a140ebc69128f374eb4195d3faadfbfff5fa77b)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanGoopOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__413e34327b0978e0201ca0ec0903d894333b655bad33c7b689fd95f7eae7db13)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__484abb169e3389d14b80ffe8c2dd10a613470a2f3cfcb0f0989bb37222b22c50)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a1c3cdf8ac9ab905a73697918296a7614373d465ff22f9d8f575c8d4cf68a153)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanGoop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanGoop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0326b2115d2c02d4e3421f020c1b585c3e3c2e84bdf4a3b15434a661e105b471)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanGoopOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanGoopOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4e9ced78f260dabbbd483a886f6a6a561a7a9a69d1ec2b08d501c68199d0bda3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetChaos")
    def reset_chaos(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaos", []))

    @jsii.member(jsii_name="resetChaosVar")
    def reset_chaos_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaosVar", []))

    @jsii.member(jsii_name="resetDensity")
    def reset_density(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensity", []))

    @jsii.member(jsii_name="resetDensityVar")
    def reset_density_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensityVar", []))

    @jsii.member(jsii_name="resetPower")
    def reset_power(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPower", []))

    @jsii.member(jsii_name="resetPowerVar")
    def reset_power_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPowerVar", []))

    @jsii.member(jsii_name="resetSeed")
    def reset_seed(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeed", []))

    @jsii.member(jsii_name="resetSeedVar")
    def reset_seed_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeedVar", []))

    @builtins.property
    @jsii.member(jsii_name="chaosInput")
    def chaos_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosInput"))

    @builtins.property
    @jsii.member(jsii_name="chaosVarInput")
    def chaos_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosVarInput"))

    @builtins.property
    @jsii.member(jsii_name="densityInput")
    def density_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityInput"))

    @builtins.property
    @jsii.member(jsii_name="densityVarInput")
    def density_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="powerInput")
    def power_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerInput"))

    @builtins.property
    @jsii.member(jsii_name="powerVarInput")
    def power_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerVarInput"))

    @builtins.property
    @jsii.member(jsii_name="seedInput")
    def seed_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedInput"))

    @builtins.property
    @jsii.member(jsii_name="seedVarInput")
    def seed_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedVarInput"))

    @builtins.property
    @jsii.member(jsii_name="chaos")
    def chaos(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaos"))

    @chaos.setter
    def chaos(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ed955cd9af18509dac9ba3ad3b2437130bf1847f07e86193fe3748364f475de1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaos", value)

    @builtins.property
    @jsii.member(jsii_name="chaosVar")
    def chaos_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaosVar"))

    @chaos_var.setter
    def chaos_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4930e68cc3eb30f13747d8824b0bef611c80ef5db17bdd12fc6ef6abc5702d40)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaosVar", value)

    @builtins.property
    @jsii.member(jsii_name="density")
    def density(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "density"))

    @density.setter
    def density(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__70aedaa9a647118c9c935cd637a7e280a411a1474b736bc6931335b752f911f5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "density", value)

    @builtins.property
    @jsii.member(jsii_name="densityVar")
    def density_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "densityVar"))

    @density_var.setter
    def density_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__35a897736fe25d8aa1c15984dff25fbb4be350f14224160281276236b6d5d115)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "densityVar", value)

    @builtins.property
    @jsii.member(jsii_name="power")
    def power(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "power"))

    @power.setter
    def power(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__47374996304ddf653a87dc03af3f39d4e386afa6b274531a8ba543e15c024e41)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "power", value)

    @builtins.property
    @jsii.member(jsii_name="powerVar")
    def power_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "powerVar"))

    @power_var.setter
    def power_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__adc90ce21aba99c49dfa3f06a4b775815ae06a7e37ce63d4e1bded4dd22d1db3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "powerVar", value)

    @builtins.property
    @jsii.member(jsii_name="seed")
    def seed(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seed"))

    @seed.setter
    def seed(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c0269b2c41be8f0a5fecb7456fc866db8714b43d5ae38326d8a3e0fad7308a47)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seed", value)

    @builtins.property
    @jsii.member(jsii_name="seedVar")
    def seed_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seedVar"))

    @seed_var.setter
    def seed_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c0f14901048ac26022fa0ac5c8a62b82e77bfd1491e8350116755532a4725cff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seedVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanGoop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanGoop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanGoop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b918600d035cf7288ba44b4d893a712054b51280329233d9b8ccd55039503dcb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanGrayscale",
    jsii_struct_bases=[],
    name_mapping={"type": "type", "type_var": "typeVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanGrayscale:
    def __init__(
        self,
        *,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param type: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f08a3bb662e341b4a0169540595c2fd0871f0ff453c91b2305aba5a77f0e6ec8)
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanGrayscale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanGrayscaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanGrayscaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__12894eaa1fcff8bcd5caf7f937eb086c11860aeb7c588e81d17a3eb64493766e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanGrayscaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__27cd23a35378477c082f5dbccd3046644ff77e5269d6427a6d89c17d6371d252)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanGrayscaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__824b100f015d98e41d57ca5d6f317da70c7e4b51b30bf0d40c95d7c5e5a38095)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__97f0accf5dbe2237f35ee897b127643b48ff682f0f005c1a78613c61c40c09d0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c1364f4ba720d2a85ebf74f7329c68038956e6d7d0e306cd918bb9ba55eee864)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanGrayscale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanGrayscale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a4a8b07f3e9b1f52287bb5184d672ad7c7e10657ff902dd9147438d7c8902819)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanGrayscaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanGrayscaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__465f31043dc2d2870a2cc6f5025be91e300fd5730289b77f37e1d3fedbcb453b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a75342534d9b7dc68cba71155cbd8b1f81f7bf05dbf604d0018712fc6c0ff1c9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d68c8bfc8ec3d603fe29582bbff8a9afa6c27e6ef8539fb1f14ee2ec7882aa0a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanGrayscale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanGrayscale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanGrayscale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7b83311f9912e4c37c14b995844194ecab4497f2eff4b8e9e43b3d927bd6e6fb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanHsl",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "lightness": "lightness",
        "lightness_var": "lightnessVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanHsl:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness: typing.Optional[builtins.str] = None,
        lightness_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        :param lightness_var: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__501168213e4677c534a3c0645f722c5b14507057d1059216f8a9d2cdcd9204c2)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness", value=lightness, expected_type=type_hints["lightness"])
            check_type(argname="argument lightness_var", value=lightness_var, expected_type=type_hints["lightness_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness is not None:
            self._values["lightness"] = lightness
        if lightness_var is not None:
            self._values["lightness_var"] = lightness_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        '''
        result = self._values.get("lightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        '''
        result = self._values.get("lightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanHsl(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanHslList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanHslList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f21bc9fc52b1356e45ba34e1fe80a264d046e939e315861008ba53fe4c714e69)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanHslOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ff4301e435176ccf23d8202c960267ac4947f0bdca14f334d44d0c889f360e8)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanHslOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df09a7215813e6a72977782341d3cf6b78b9b4a041a64d72ba8f8dd4bc029141)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__52797854c98a752a6fcb115813de785e04455a8cde737868e40beb846665d041)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__04112930979681940168d89950775179f68d63ace0d86c40c29bdbdba7196c69)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanHsl]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanHsl]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eef657fa8550d0a4c1d427abf12c92c54ae640ca000bbb0973941280f44447ed)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanHslOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanHslOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7dffc5d82d806a347595bda45fc7aec8c4c889c590e4f25aac41f6bab91ac623)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightness")
    def reset_lightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightness", []))

    @jsii.member(jsii_name="resetLightnessVar")
    def reset_lightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessInput")
    def lightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessVarInput")
    def lightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b9aaf18bfe9dbf2648a853326834a7f12acb4cb83e8b1415394bd65620825e91)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c49d25e9e6c5087c33fb8f7afe0745746da8c7a36d396ca901007f32fb5ae0fa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightness")
    def lightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightness"))

    @lightness.setter
    def lightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a905efaeff67a7c3a2049682ccb68ce1589cf3bf60bc27b3310dc706f2875c0e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightness", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessVar")
    def lightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessVar"))

    @lightness_var.setter
    def lightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__924d61f5cd04814341502549472b66c531d52592c0d117deebb74b9fe45c6cc1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3d9fe2ee51062a65ee6d1d4b32d52f73869222be164bd9349213e7aa248262a9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a24b984895bfc45d60f2d9278cf5081a720e2909d8971eb0fffe496589722803)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanHsl]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanHsl]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanHsl]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a57fa627faddb90fcda0e67b997933b17c4af7979313fe478fd42eb6d7f06df0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanHsv",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanHsv:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        :param value: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__357184a284e2f2a2b53340f9b04ebde1300d4af5d54e856e81075751d04eddf5)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanHsv(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanHsvList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanHsvList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__61e65c44cf6e633dc32badc4baad5375e8d64043690ebb11a59e77bb7f08cd9f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanHsvOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__499f7b130383703479eaa3d44ef07486f178770f929ccf78a938f72f18bb830f)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanHsvOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__939f73f6d13480b987971f89c930fa209cd55f62010c0defd451feb03f02f1c8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e39c3f6597e167bcc12e230bff2ac7dd7494a3f5bcbe985e652f27928087244b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e93cb312f2568b6978036ee55f790f71a36c4ccc98c3482de44d34ed62787eba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanHsv]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanHsv]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__07ba7eddd268c2df266e623c9d316dc67c06c8a9f30960479b3cf3684a8166e7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanHsvOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanHsvOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dcd4551469cfe548b2c5a88d4689bdd27f25d7d70fc8a1b827abdf889f5cebab)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3fb2e443c439fba86a30fe3bd53453827af61d840db192559b79cad844896ef1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8fd68c06bf1cfd624a56e6ccf9c69f70ee72519065260d2490a503e00eb7286d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__126ea91b635b51665506c02ef6dbd75dbbf51762904e46c0b4344aa25d49f3c7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c12f12a76167ec44cc973ac4032cbbdd90c44c3ca4f8061665e850e5c150e321)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__370f62e8c98e25002735aaae3f23242b3fbc3f15e18bb157e50108a22045532b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__63bbb0e40dea4c5a8e382493473b84df08a62d9fa3304e780de3da2e79ee4cc4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanHsv]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanHsv]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanHsv]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a537296b36169afbaff2c13f0c0fe5c33517a431cc772a18b17ec9a0b55b091f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfDimension",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "dimension": "dimension",
        "dimension_var": "dimensionVar",
        "equal": "equal",
        "greater_than": "greaterThan",
        "less_than": "lessThan",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfDimension:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        dimension: typing.Optional[builtins.str] = None,
        dimension_var: typing.Optional[builtins.str] = None,
        equal: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionEqual", typing.Dict[builtins.str, typing.Any]]] = None,
        greater_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionGreaterThan", typing.Dict[builtins.str, typing.Any]]] = None,
        less_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionLessThan", typing.Dict[builtins.str, typing.Any]]] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param dimension: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        :param dimension_var: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        :param equal: equal block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        :param greater_than: greater_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        :param less_than: less_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        :param value: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionDefault(**default)
        if isinstance(equal, dict):
            equal = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionEqual(**equal)
        if isinstance(greater_than, dict):
            greater_than = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionGreaterThan(**greater_than)
        if isinstance(less_than, dict):
            less_than = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionLessThan(**less_than)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__91cf2cf46aeea29c5c0712d10da32e504e46c26059c96188782ff4e9e0af9fd7)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument dimension", value=dimension, expected_type=type_hints["dimension"])
            check_type(argname="argument dimension_var", value=dimension_var, expected_type=type_hints["dimension_var"])
            check_type(argname="argument equal", value=equal, expected_type=type_hints["equal"])
            check_type(argname="argument greater_than", value=greater_than, expected_type=type_hints["greater_than"])
            check_type(argname="argument less_than", value=less_than, expected_type=type_hints["less_than"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if dimension is not None:
            self._values["dimension"] = dimension
        if dimension_var is not None:
            self._values["dimension_var"] = dimension_var
        if equal is not None:
            self._values["equal"] = equal
        if greater_than is not None:
            self._values["greater_than"] = greater_than
        if less_than is not None:
            self._values["less_than"] = less_than
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionDefault"], result)

    @builtins.property
    def dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        '''
        result = self._values.get("dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        '''
        result = self._values.get("dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def equal(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionEqual"]:
        '''equal block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        '''
        result = self._values.get("equal")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionEqual"], result)

    @builtins.property
    def greater_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionGreaterThan"]:
        '''greater_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        '''
        result = self._values.get("greater_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionGreaterThan"], result)

    @builtins.property
    def less_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionLessThan"]:
        '''less_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        '''
        result = self._values.get("less_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionLessThan"], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfDimension(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__35b2653cba777a314f42c1a151872d43e280223fe081e1e22fecae7735e016be)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f7071843cb46d0af97f5b01b07f2cf6dedf7696ec6503d22d5391bce5dab6efd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionEqual",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionEqual:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionEqual(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionEqualOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionEqualOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f2b8ba669e2ecaa551f361263a673dad09a5409377f6bbf1c0763144b5356f8a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionEqual], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionEqual],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c8d5d463a6bb05eb89538ede1ebc4efa4ea73e50c51a0d36f9d5e33eec0d254b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionGreaterThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionGreaterThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionGreaterThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionGreaterThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionGreaterThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5b88a6c39760e6e50ff31e2522ae1d4202b307a6041c828ea715dcc8bc293eee)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionGreaterThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionGreaterThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f946252f34ac10f6c857bde163c7dc1342976a320607fd878faec3514ac6f20a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionLessThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionLessThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionLessThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionLessThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionLessThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8361f2bc1955c4fd8e36b49183dbaa4f4df81b81f5000fa4cb1e40ffbedcafcf)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionLessThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionLessThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1dec243283f711f5c80dec024f15f379eb8f3aac3678319bf051729501097cab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f111348e47fa4138c57a3082cc3001f055976ffb522faeeff5f1245e4f11442d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4219866b824f61c0eb8405c0ea15fd3caa5c1098b769f2f702fdf6c03606f859)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__378ed9ec15fdd8853267d9e561ac941b85eca82c896c494e94554ef8ca888a9e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4edf46d8801ec6bb8c7c210cb5d051df0acf8a1d71116bba27a72f61224cf7cf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6d26994a6544aea917da53a7a672467568d29cc710227297203b884415cad04a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfDimension]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfDimension]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f6a1ec49cadf7c7ff76bce083f2fd588efc2d3167f42b27134aa1a36eb67f875)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea7635aa8e8138cb259a09d4decf9fe3291c36fd622d79216a5bfc99b8bd2584)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putEqual")
    def put_equal(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionEqual()

        return typing.cast(None, jsii.invoke(self, "putEqual", [value]))

    @jsii.member(jsii_name="putGreaterThan")
    def put_greater_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionGreaterThan()

        return typing.cast(None, jsii.invoke(self, "putGreaterThan", [value]))

    @jsii.member(jsii_name="putLessThan")
    def put_less_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionLessThan()

        return typing.cast(None, jsii.invoke(self, "putLessThan", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetDimension")
    def reset_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimension", []))

    @jsii.member(jsii_name="resetDimensionVar")
    def reset_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimensionVar", []))

    @jsii.member(jsii_name="resetEqual")
    def reset_equal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEqual", []))

    @jsii.member(jsii_name="resetGreaterThan")
    def reset_greater_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGreaterThan", []))

    @jsii.member(jsii_name="resetLessThan")
    def reset_less_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLessThan", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="equal")
    def equal(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionEqualOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionEqualOutputReference, jsii.get(self, "equal"))

    @builtins.property
    @jsii.member(jsii_name="greaterThan")
    def greater_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionGreaterThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionGreaterThanOutputReference, jsii.get(self, "greaterThan"))

    @builtins.property
    @jsii.member(jsii_name="lessThan")
    def less_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionLessThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionLessThanOutputReference, jsii.get(self, "lessThan"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionInput")
    def dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionVarInput")
    def dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="equalInput")
    def equal_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionEqual], jsii.get(self, "equalInput"))

    @builtins.property
    @jsii.member(jsii_name="greaterThanInput")
    def greater_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionGreaterThan], jsii.get(self, "greaterThanInput"))

    @builtins.property
    @jsii.member(jsii_name="lessThanInput")
    def less_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionLessThan], jsii.get(self, "lessThanInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="dimension")
    def dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimension"))

    @dimension.setter
    def dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__57ad06fd35748c826d10bb28cbce4bb0eff23846ccb620e5207e05f716843e7c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimension", value)

    @builtins.property
    @jsii.member(jsii_name="dimensionVar")
    def dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimensionVar"))

    @dimension_var.setter
    def dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e88a883f1407840246780e26e5b71bca1680cba053076721c6de2d8d106c66c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__33eee5e8da77b56a58b6e32732367a98e5e36d75bf90c4d64b0d050566ac4d54)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0a42c1b2d7b46f0605bdb807c537989872cd8d27206607f28cb5d22286d9b309)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfDimension]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfDimension]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfDimension]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1175fdc810c6569b0b153d1bec599fba61b90a7a46cf0bb646753121e7399883)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientation",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "landscape": "landscape",
        "portrait": "portrait",
        "square": "square",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientation:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        landscape: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationLandscape", typing.Dict[builtins.str, typing.Any]]] = None,
        portrait: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationPortrait", typing.Dict[builtins.str, typing.Any]]] = None,
        square: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationSquare", typing.Dict[builtins.str, typing.Any]]] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param landscape: landscape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        :param portrait: portrait block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        :param square: square block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationDefault(**default)
        if isinstance(landscape, dict):
            landscape = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationLandscape(**landscape)
        if isinstance(portrait, dict):
            portrait = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationPortrait(**portrait)
        if isinstance(square, dict):
            square = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationSquare(**square)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__519ddeb26f95bb7f4a587facd5a1db9143426652963a076d4357dc80ab79a8bf)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument landscape", value=landscape, expected_type=type_hints["landscape"])
            check_type(argname="argument portrait", value=portrait, expected_type=type_hints["portrait"])
            check_type(argname="argument square", value=square, expected_type=type_hints["square"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if landscape is not None:
            self._values["landscape"] = landscape
        if portrait is not None:
            self._values["portrait"] = portrait
        if square is not None:
            self._values["square"] = square

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationDefault"], result)

    @builtins.property
    def landscape(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationLandscape"]:
        '''landscape block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        '''
        result = self._values.get("landscape")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationLandscape"], result)

    @builtins.property
    def portrait(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationPortrait"]:
        '''portrait block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        '''
        result = self._values.get("portrait")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationPortrait"], result)

    @builtins.property
    def square(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationSquare"]:
        '''square block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        result = self._values.get("square")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationSquare"], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__19269c4ae85cb132f9578580be40aadeba1ba2003113354f156869a1b8ae6b5d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bd5b2fa605f849742bc495ed6959234d8dc10588c23da341f89f363f9bfb76a4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationLandscape",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationLandscape:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationLandscape(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationLandscapeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationLandscapeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d03ad70de6f39beff23ee5d681b0a36f0702cbfeda307d2d3356c41cb5382f52)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationLandscape], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationLandscape],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4bcf3189971d44bc513c56be48c453ec83c1834cca2904edb796bd1673d793a9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d8008e9bbbaa7c7111a96fd74f234eb68f96d16567ac4e372d2e8bd0912de225)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8ea207f23bce7fd775485f69f4fb1dec6e236be653c5e5379ef8322a1c6b7f55)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e63e8b8d34a52346e580fd11a6e716ba3ba65708ad5f945f1f4ea361fa51d4b6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__29729b84081c32cdfb02a15fdf991f79b81549ce8ef59b1b68626be0d85cc201)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ceb96359f042c768f7a6fb968325a8028351b7bdfd59db87ede6890aeee9fd4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientation]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientation]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__46b673899aa008792f5e7a9f630337a433d4d931a1db8f2a55db94a8de6db4a3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5968ae3f2d9f1f1500aa5d2141b44352e9f1611ad382c1074ab0fe60c4285ea9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putLandscape")
    def put_landscape(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationLandscape()

        return typing.cast(None, jsii.invoke(self, "putLandscape", [value]))

    @jsii.member(jsii_name="putPortrait")
    def put_portrait(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationPortrait()

        return typing.cast(None, jsii.invoke(self, "putPortrait", [value]))

    @jsii.member(jsii_name="putSquare")
    def put_square(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationSquare()

        return typing.cast(None, jsii.invoke(self, "putSquare", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetLandscape")
    def reset_landscape(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLandscape", []))

    @jsii.member(jsii_name="resetPortrait")
    def reset_portrait(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPortrait", []))

    @jsii.member(jsii_name="resetSquare")
    def reset_square(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSquare", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="landscape")
    def landscape(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationLandscapeOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationLandscapeOutputReference, jsii.get(self, "landscape"))

    @builtins.property
    @jsii.member(jsii_name="portrait")
    def portrait(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationPortraitOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationPortraitOutputReference", jsii.get(self, "portrait"))

    @builtins.property
    @jsii.member(jsii_name="square")
    def square(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationSquareOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationSquareOutputReference", jsii.get(self, "square"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="landscapeInput")
    def landscape_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationLandscape], jsii.get(self, "landscapeInput"))

    @builtins.property
    @jsii.member(jsii_name="portraitInput")
    def portrait_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationPortrait"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationPortrait"], jsii.get(self, "portraitInput"))

    @builtins.property
    @jsii.member(jsii_name="squareInput")
    def square_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationSquare"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationSquare"], jsii.get(self, "squareInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientation]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientation]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientation]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6ac0152e805c85a86b3649fca412ea8f2ee2b676e298ff88792c472dd760ebba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationPortrait",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationPortrait:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationPortrait(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationPortraitOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationPortraitOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0d1abdec01ed57a6600dc0d6a01b3146c46ee71aaded1a0ab53d4eacf80e0e27)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationPortrait]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationPortrait], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationPortrait],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__24931438fec3ae6c2fa7749361880408adc3cf9308e92615bdcd62ca9423d746)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationSquare",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationSquare:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationSquare(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationSquareOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationSquareOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__409164884b8485eac37e25da0ef5b647102490c006f1b364ae60ed95bc3d78e9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationSquare]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationSquare], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationSquare],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6bfd709a64ce69490e30dcf803d1b765d023a64afc3014be6e9257f847167683)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanImQuery",
    jsii_struct_bases=[],
    name_mapping={
        "allowed_transformations": "allowedTransformations",
        "query_var": "queryVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanImQuery:
    def __init__(
        self,
        *,
        allowed_transformations: typing.Sequence[builtins.str],
        query_var: builtins.str,
    ) -> None:
        '''
        :param allowed_transformations: Specifies the transformations that can be applied using the query string parameter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allowed_transformations DataAkamaiImagingPolicyImage#allowed_transformations}
        :param query_var: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#query_var DataAkamaiImagingPolicyImage#query_var}.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2590020bca609e1d7b4b1e309b88a3945857d9d27616b6deb6dcd0ecac4ad5ce)
            check_type(argname="argument allowed_transformations", value=allowed_transformations, expected_type=type_hints["allowed_transformations"])
            check_type(argname="argument query_var", value=query_var, expected_type=type_hints["query_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "allowed_transformations": allowed_transformations,
            "query_var": query_var,
        }

    @builtins.property
    def allowed_transformations(self) -> typing.List[builtins.str]:
        '''Specifies the transformations that can be applied using the query string parameter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allowed_transformations DataAkamaiImagingPolicyImage#allowed_transformations}
        '''
        result = self._values.get("allowed_transformations")
        assert result is not None, "Required property 'allowed_transformations' is missing"
        return typing.cast(typing.List[builtins.str], result)

    @builtins.property
    def query_var(self) -> builtins.str:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#query_var DataAkamaiImagingPolicyImage#query_var}.'''
        result = self._values.get("query_var")
        assert result is not None, "Required property 'query_var' is missing"
        return typing.cast(builtins.str, result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanImQuery(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanImQueryList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanImQueryList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ece13b025fc81e5f6accc4716d0734f84c4419faff95967aa596e68736ba4d79)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanImQueryOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1fdf19ad1c68a1cd12cc1558e0614ba797847d473cb8287f025905bf4a15f382)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanImQueryOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bd54c222c9a4cbfe1a3065e4e1c894937c17275073f108acf9b9950fb33acbe0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b57122e2553144141461aa85770cf4c6e1a566b8b92a6b45038bd87d83b0be4a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__45ea4c949a3b810a836844e4baa257c2214e551d4f940393d4e3af14cb3673ea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanImQuery]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanImQuery]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanImQuery]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6bb9aa084f1b26deb3b4a7bd71d49f59c193316df7f8fbe89ceadfa3bd0cffa7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanImQueryOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanImQueryOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b278d9294ecb1344a47ba07642c430b34d3fdd1a8207f33b275e391d5af6791b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @builtins.property
    @jsii.member(jsii_name="allowedTransformationsInput")
    def allowed_transformations_input(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "allowedTransformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="queryVarInput")
    def query_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "queryVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowedTransformations")
    def allowed_transformations(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "allowedTransformations"))

    @allowed_transformations.setter
    def allowed_transformations(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a2a329fb913c7b6c0a1d9f72e5578d5dab2292e8f1e03b3cfb48d9a8e868a4d4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowedTransformations", value)

    @builtins.property
    @jsii.member(jsii_name="queryVar")
    def query_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "queryVar"))

    @query_var.setter
    def query_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c9132c42d60309e8d2fe29b431b526b45a8796391db1d40d2efe0ddfd6ba7034)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "queryVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanImQuery]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanImQuery]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanImQuery]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6902d9a76ef89f782241ae26ce3d9a76892ba4cdde67955539b487d394b819da)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanMaxColors",
    jsii_struct_bases=[],
    name_mapping={"colors": "colors", "colors_var": "colorsVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanMaxColors:
    def __init__(
        self,
        *,
        colors: typing.Optional[builtins.str] = None,
        colors_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param colors: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        :param colors_var: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a51d2e1d72465561ad10f58bac3342598a98e14b5c6808bebad8cb89f6c48734)
            check_type(argname="argument colors", value=colors, expected_type=type_hints["colors"])
            check_type(argname="argument colors_var", value=colors_var, expected_type=type_hints["colors_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if colors is not None:
            self._values["colors"] = colors
        if colors_var is not None:
            self._values["colors_var"] = colors_var

    @builtins.property
    def colors(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        '''
        result = self._values.get("colors")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def colors_var(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        result = self._values.get("colors_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanMaxColors(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanMaxColorsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanMaxColorsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3d62e0e3a717b6a58a108d9bc782488b48cc3ba03123e273a4d5e9e81df5e7a8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanMaxColorsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__505ddf6b060ee2552fa577d55a19840c4cd15e3e1e5c843dc96cc3d333b007ff)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanMaxColorsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__64d01331efaa5ce7bd803ccc5aedfd6bc779bf27e5225c6bc64616b9accc2183)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fd2b7f53d9a6fcc41d6d944f1befa69fc6621073b01e3faf72e976fdaf5512ab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__00da3bccef80fc68fb75955b4f2cc99d9412d28553a3a024307e6c1f5f46a235)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanMaxColors]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanMaxColors]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__21a77617cc103a30be18bfbd1813c187bcbff82fcc015e10b85708e3a90ea079)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanMaxColorsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanMaxColorsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__68d0ecc3cabc422a19696562ba125b9427f8a0d1e3dcc1920ebb3d80cb84ad63)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColors")
    def reset_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColors", []))

    @jsii.member(jsii_name="resetColorsVar")
    def reset_colors_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorsVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorsInput")
    def colors_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsInput"))

    @builtins.property
    @jsii.member(jsii_name="colorsVarInput")
    def colors_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsVarInput"))

    @builtins.property
    @jsii.member(jsii_name="colors")
    def colors(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colors"))

    @colors.setter
    def colors(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__19eb2e79bb94c428a03f670a1f9957e9b3569577d54fe4cf4c6eb115efd5c9b7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colors", value)

    @builtins.property
    @jsii.member(jsii_name="colorsVar")
    def colors_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorsVar"))

    @colors_var.setter
    def colors_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b40af08849fcbc98f44cc57184be5e11b4896df7ef12fc2701da97115921a38c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorsVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanMaxColors]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanMaxColors]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanMaxColors]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__60819b8655e184bb8e87eed3d2f816cd89dfa91dbd5abe759cb345f17b183f92)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanMirror",
    jsii_struct_bases=[],
    name_mapping={
        "horizontal": "horizontal",
        "horizontal_var": "horizontalVar",
        "vertical": "vertical",
        "vertical_var": "verticalVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanMirror:
    def __init__(
        self,
        *,
        horizontal: typing.Optional[builtins.str] = None,
        horizontal_var: typing.Optional[builtins.str] = None,
        vertical: typing.Optional[builtins.str] = None,
        vertical_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param horizontal: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        :param horizontal_var: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        :param vertical: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        :param vertical_var: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a6420b80c5f0702b548f76721aef2081e8e1bc573c75312635508759a7329517)
            check_type(argname="argument horizontal", value=horizontal, expected_type=type_hints["horizontal"])
            check_type(argname="argument horizontal_var", value=horizontal_var, expected_type=type_hints["horizontal_var"])
            check_type(argname="argument vertical", value=vertical, expected_type=type_hints["vertical"])
            check_type(argname="argument vertical_var", value=vertical_var, expected_type=type_hints["vertical_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if horizontal is not None:
            self._values["horizontal"] = horizontal
        if horizontal_var is not None:
            self._values["horizontal_var"] = horizontal_var
        if vertical is not None:
            self._values["vertical"] = vertical
        if vertical_var is not None:
            self._values["vertical_var"] = vertical_var

    @builtins.property
    def horizontal(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        '''
        result = self._values.get("horizontal")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def horizontal_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        '''
        result = self._values.get("horizontal_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        '''
        result = self._values.get("vertical")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        result = self._values.get("vertical_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanMirror(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanMirrorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanMirrorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b27472f2f9f60ef74c9997ea32692a81c854e2bab8050a295a5f93ed2a3c84e5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanMirrorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1c114094cb758c489bb37fa39b2a0dd875d62d54ea7386c72ac908bcc24378d6)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanMirrorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ff4b40d358bf976b735c79f17ad7901d8a47336a211f95f05dca07f05817082a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bf7fce5bcba2c00cdcca3c250246f20565f1599c4fe0f220f17752df14e27aea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__66cea2e42b85f9a6398101cee57bcd9192f50facf96338064657712d8cce8167)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanMirror]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanMirror]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__adf073b2dbec2e6c34154c08726f94200b08d414d7d29e71a208c864ca2fcfe3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanMirrorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanMirrorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5cbd53a2002b8965abb5d6ce8aa66f5950914394ec27dd3b82b03854af25c0ec)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHorizontal")
    def reset_horizontal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontal", []))

    @jsii.member(jsii_name="resetHorizontalVar")
    def reset_horizontal_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontalVar", []))

    @jsii.member(jsii_name="resetVertical")
    def reset_vertical(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVertical", []))

    @jsii.member(jsii_name="resetVerticalVar")
    def reset_vertical_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVerticalVar", []))

    @builtins.property
    @jsii.member(jsii_name="horizontalInput")
    def horizontal_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontalVarInput")
    def horizontal_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalInput")
    def vertical_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalVarInput")
    def vertical_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontal")
    def horizontal(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontal"))

    @horizontal.setter
    def horizontal(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__76a68783a6611f5ea5b5da66476377715dbd6b62b174f5c20c877dd2b63ca98c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontal", value)

    @builtins.property
    @jsii.member(jsii_name="horizontalVar")
    def horizontal_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontalVar"))

    @horizontal_var.setter
    def horizontal_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a568f41f7ab09e1537a22565651b29c3414591ad3b6f07d59b05a515921dcd46)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontalVar", value)

    @builtins.property
    @jsii.member(jsii_name="vertical")
    def vertical(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "vertical"))

    @vertical.setter
    def vertical(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__332f91e828722331d7342e3339fd6935c719b4af2c6c7f929c5a07531dd8c13e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "vertical", value)

    @builtins.property
    @jsii.member(jsii_name="verticalVar")
    def vertical_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "verticalVar"))

    @vertical_var.setter
    def vertical_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__28148339f0b71ca23637e4296ae69708007eacf0d6800eec80a0eb0bbd0d39b9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "verticalVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanMirror]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanMirror]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanMirror]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__17e388f623f133bf486bdc50e9c313a508a6d8f0d0d977ebc4ffb57e3ca94d06)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanMonoHue",
    jsii_struct_bases=[],
    name_mapping={"hue": "hue", "hue_var": "hueVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanMonoHue:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__563c16daee8afe5b5fc3e810b1586acda85c03c30d3d8576ff1f3cdc0c393d7f)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanMonoHue(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanMonoHueList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanMonoHueList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aa8293dc08d98f96819593ba90cab4f3e9c81dbb1a5228a7a93110e95de6ea72)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanMonoHueOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__97ce6892636de07c696e1e5e63cbc530c8d38927d556bf474619b93a916d013f)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanMonoHueOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__591c7296d73a27eb7503019db95c777ee03bb5a341ea06b70ec4c75dea4bc9d7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d44f5c8234f8f62beb807ba7f91477ac8ab42c4a8f6f3da2afa7ccf5cff478b5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__39e5424d31e4374f61f00060f9cd45fb6e7661c3fba5458c02e9d2c6e21edfe7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanMonoHue]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanMonoHue]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6509a08bb415c76332e48452a40900cd945a3ff576c8a97992c8eb65b552c5b2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanMonoHueOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanMonoHueOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__913479e5d4b39a03f65930426a60a43f20bc44934452860bdea52f95c2a54816)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f90d8ff9d6c1c9a8be3ae88b9eefab91a927d1d4d6a03bfeeb78fbbe2f478563)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__82a67222ef45f169c0a690ba372887369f920fad777a72e6f9e296f331bde43f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanMonoHue]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanMonoHue]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanMonoHue]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c51bb3bc8389ee136dccf48a5851c78c24e08955410f9db9529d92a0ae7b0a7d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanOpacity",
    jsii_struct_bases=[],
    name_mapping={"opacity": "opacity", "opacity_var": "opacityVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanOpacity:
    def __init__(
        self,
        *,
        opacity: typing.Optional[builtins.str] = None,
        opacity_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param opacity: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param opacity_var: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d6811e8da771f15b45deb474444c15e38736ddd9cd5ce88974633c9d7887151f)
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument opacity_var", value=opacity_var, expected_type=type_hints["opacity_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if opacity is not None:
            self._values["opacity"] = opacity
        if opacity_var is not None:
            self._values["opacity_var"] = opacity_var

    @builtins.property
    def opacity(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def opacity_var(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        result = self._values.get("opacity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanOpacity(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanOpacityList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanOpacityList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__21d8b4cf1289d6551dfe7105287dc481820a339449b07aa618f45f064b6e182e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanOpacityOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c157fd9f0cc101b1c8f4671891b6c5bb6c45250f61c9426acdfc84141b1c4962)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanOpacityOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bcb399ebdfff1ca5193fd9260938668f1352c14f6833eb7086e54f3627817692)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b465122224aa1fad4d9ef2ab1524bb9d91a81808d617b9dbbacadf8167474197)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__651dd29c87d976c158249beeea436be4d6ee502d15ca5bef1f88b289c990be5c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanOpacity]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanOpacity]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9f583eec40d4b5e4fdcae8ad5e0c0677464d2685b21413f6484625f57b837b66)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanOpacityOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanOpacityOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d800611d4e0cda1e3a48ad421d2e355a19c57365eb553b02c7a6947283d65e2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetOpacityVar")
    def reset_opacity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacityVar", []))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityVarInput")
    def opacity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacity"))

    @opacity.setter
    def opacity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a8feca6e4dcd31774fa8f79e631921d07c6489ba65ad65de96b66b18bdd39d93)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacity", value)

    @builtins.property
    @jsii.member(jsii_name="opacityVar")
    def opacity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacityVar"))

    @opacity_var.setter
    def opacity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a75fa9b9bcf71f39d7a5d68a37bdf0ee411a263cdad8dab24b5c77a8eb95a4f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacityVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanOpacity]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanOpacity]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanOpacity]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e2f5032ece2581c804a4fa22ee2c32887d731c2da4a4848dab785e1f678db20d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8973a71ea69c016db32b35c3dbc1e6adae9170496d10c65be978a7fffaea3806)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putAppend")
    def put_append(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanAppend, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e2a521d9cfe6cf6c15db0240aad9ebd3692f4fd0031a2157be680fcc56ec11c2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putAppend", [value]))

    @jsii.member(jsii_name="putAspectCrop")
    def put_aspect_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanAspectCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0951f2582b1f3d69e1afc9e79f77f02112f260a74ce71565cbe89ff85c81285a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putAspectCrop", [value]))

    @jsii.member(jsii_name="putBackgroundColor")
    def put_background_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7329dfd722db9c3c267d69edbd3bb11755ec3f031f6d1f3ef9553ef54d29c3f4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBackgroundColor", [value]))

    @jsii.member(jsii_name="putBlur")
    def put_blur(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanBlur, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7179caaba922372193d18ede2ea9597ee7ef205f7315a07390edf6838f54367d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBlur", [value]))

    @jsii.member(jsii_name="putChromaKey")
    def put_chroma_key(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanChromaKey, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__87d5262ebfc65b19b4acd43fec53d98dec21adb3e7950a0c9faded316b6bfdb2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putChromaKey", [value]))

    @jsii.member(jsii_name="putComposite")
    def put_composite(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanComposite, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__73a29d2d6b7e0718ec6c7e4f260d81f7dd8930c3ed9a13a1631c3099d413593c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putComposite", [value]))

    @jsii.member(jsii_name="putCompound")
    def put_compound(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanCompound, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__47394d5ea0f205c7856f286a940bf70efc50142a9ce5872e6f71ad328aa013cc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCompound", [value]))

    @jsii.member(jsii_name="putContrast")
    def put_contrast(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanContrast, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__739a2c54c531bd76514474efa019be4ae14fe73b99a3da640c0ace28d1b2a6de)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putContrast", [value]))

    @jsii.member(jsii_name="putCrop")
    def put_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c771785233593d0e4223caa161540710ee6db1e92d477309b5477558e16de172)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCrop", [value]))

    @jsii.member(jsii_name="putFaceCrop")
    def put_face_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanFaceCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e9c8467d0d4652c620ce4cb64e85584615976c531f2d3af28b9a17ede01f233)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFaceCrop", [value]))

    @jsii.member(jsii_name="putFeatureCrop")
    def put_feature_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanFeatureCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b67b8d24f8adac2457324be5244ec90376a41238c23040275ecf649fd3542290)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFeatureCrop", [value]))

    @jsii.member(jsii_name="putFitAndFill")
    def put_fit_and_fill(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanFitAndFill, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4026e49442400a8a69dbcb5f2357c165e80163e2b9bca14a89fdb31ad14a246f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFitAndFill", [value]))

    @jsii.member(jsii_name="putGoop")
    def put_goop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanGoop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6c389a9fec63a3a67504975758fa4354d60957b3ad744d740251e24120f1bd3e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGoop", [value]))

    @jsii.member(jsii_name="putGrayscale")
    def put_grayscale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanGrayscale, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__104829e75796fc65dd82e8514b17a4616eb6672adeeb7eebd5bb7c11bd9406a3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGrayscale", [value]))

    @jsii.member(jsii_name="putHsl")
    def put_hsl(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanHsl, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4d2ed944bd331026a7a00baf68eafb69cb7cd5108142be0d1087db57587e60da)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsl", [value]))

    @jsii.member(jsii_name="putHsv")
    def put_hsv(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanHsv, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a99c14280309f8334dae45ab4385ec1a828da50e80a8e8bcd36f9fd403461884)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsv", [value]))

    @jsii.member(jsii_name="putIfDimension")
    def put_if_dimension(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfDimension, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a0148c737077589241144b50d84745d6bd2a15b9ad1281bbdcce4901bb078bd6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfDimension", [value]))

    @jsii.member(jsii_name="putIfOrientation")
    def put_if_orientation(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a7c086c77c0cb73047b9bedc46a4742e92f4faf80c439dabf607d855b9039f25)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfOrientation", [value]))

    @jsii.member(jsii_name="putImQuery")
    def put_im_query(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanImQuery, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c00ebbb8024f071b07e6f0d49b3ebe8a18efdef9c9ff395c2255e915e8a1e375)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putImQuery", [value]))

    @jsii.member(jsii_name="putMaxColors")
    def put_max_colors(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanMaxColors, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fb5a95bc609d3b1ec8d9dee1503ddac9bc6ce2f3a99405fdf117ff54aedccf3b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMaxColors", [value]))

    @jsii.member(jsii_name="putMirror")
    def put_mirror(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanMirror, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__343367b5b10f9b2fa5bc83dc96026182208707d3c3103e6a0c5cbaf9148f1129)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMirror", [value]))

    @jsii.member(jsii_name="putMonoHue")
    def put_mono_hue(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanMonoHue, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cf078f8d7c1862290dba5de7d2a1505bfa5692d67691a3b30879ac459db61c0a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMonoHue", [value]))

    @jsii.member(jsii_name="putOpacity")
    def put_opacity(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanOpacity, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__52714cf234b2c8b9fbd86cc5e1fa491a892738bbbbf25dcedbb81dec3fa473d6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putOpacity", [value]))

    @jsii.member(jsii_name="putRegionOfInterestCrop")
    def put_region_of_interest_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanRegionOfInterestCrop", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7a4a04afc3fea548cce105d7b891c3f6ae4f9b976ba40de7011ed713af3fed42)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRegionOfInterestCrop", [value]))

    @jsii.member(jsii_name="putRelativeCrop")
    def put_relative_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanRelativeCrop", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9fd7887e0892614b1561bcbc3a5a0bbf4ddb8ae2d100f85c21d3edf84445b5d0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRelativeCrop", [value]))

    @jsii.member(jsii_name="putRemoveColor")
    def put_remove_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanRemoveColor", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c80950da5d3678cd181bf8dcb784642bdde6a48ebb5fe5dc11859214689a91e3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRemoveColor", [value]))

    @jsii.member(jsii_name="putResize")
    def put_resize(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanResize", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a0241fa6d466a50824eaab3080ad7e47feca712d3cd1828a7b26345fe2cf4317)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putResize", [value]))

    @jsii.member(jsii_name="putRotate")
    def put_rotate(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanRotate", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__077531c37e619bb85e89f8ca256145141ffa3098c7cc77f5df71907373aacfa8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRotate", [value]))

    @jsii.member(jsii_name="putScale")
    def put_scale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanScale", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a4018205bcdf11cff0124ee32941577e728554acd9df75f713efebe05d9e3162)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putScale", [value]))

    @jsii.member(jsii_name="putShear")
    def put_shear(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanShear", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__16a49f47357412107470049794d4480cb865a94cc53ba31f5060591ce321dc11)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putShear", [value]))

    @jsii.member(jsii_name="putTrim")
    def put_trim(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanTrim", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1b39d6dd0e33e7f8ed3793b051282754e494a376f8fab9cff6b0cc3a6d9b3ea0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTrim", [value]))

    @jsii.member(jsii_name="putUnsharpMask")
    def put_unsharp_mask(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanUnsharpMask", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b965a417577dbb2f2ef60b7f78e957993d4cd462f6af549ce818ac072ab92268)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putUnsharpMask", [value]))

    @jsii.member(jsii_name="resetAppend")
    def reset_append(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAppend", []))

    @jsii.member(jsii_name="resetAspectCrop")
    def reset_aspect_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspectCrop", []))

    @jsii.member(jsii_name="resetBackgroundColor")
    def reset_background_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBackgroundColor", []))

    @jsii.member(jsii_name="resetBlur")
    def reset_blur(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBlur", []))

    @jsii.member(jsii_name="resetChromaKey")
    def reset_chroma_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChromaKey", []))

    @jsii.member(jsii_name="resetComposite")
    def reset_composite(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetComposite", []))

    @jsii.member(jsii_name="resetCompound")
    def reset_compound(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCompound", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetCrop")
    def reset_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCrop", []))

    @jsii.member(jsii_name="resetFaceCrop")
    def reset_face_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFaceCrop", []))

    @jsii.member(jsii_name="resetFeatureCrop")
    def reset_feature_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureCrop", []))

    @jsii.member(jsii_name="resetFitAndFill")
    def reset_fit_and_fill(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFitAndFill", []))

    @jsii.member(jsii_name="resetGoop")
    def reset_goop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGoop", []))

    @jsii.member(jsii_name="resetGrayscale")
    def reset_grayscale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGrayscale", []))

    @jsii.member(jsii_name="resetHsl")
    def reset_hsl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsl", []))

    @jsii.member(jsii_name="resetHsv")
    def reset_hsv(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsv", []))

    @jsii.member(jsii_name="resetIfDimension")
    def reset_if_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfDimension", []))

    @jsii.member(jsii_name="resetIfOrientation")
    def reset_if_orientation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfOrientation", []))

    @jsii.member(jsii_name="resetImQuery")
    def reset_im_query(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetImQuery", []))

    @jsii.member(jsii_name="resetMaxColors")
    def reset_max_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxColors", []))

    @jsii.member(jsii_name="resetMirror")
    def reset_mirror(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMirror", []))

    @jsii.member(jsii_name="resetMonoHue")
    def reset_mono_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonoHue", []))

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetRegionOfInterestCrop")
    def reset_region_of_interest_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRegionOfInterestCrop", []))

    @jsii.member(jsii_name="resetRelativeCrop")
    def reset_relative_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRelativeCrop", []))

    @jsii.member(jsii_name="resetRemoveColor")
    def reset_remove_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRemoveColor", []))

    @jsii.member(jsii_name="resetResize")
    def reset_resize(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetResize", []))

    @jsii.member(jsii_name="resetRotate")
    def reset_rotate(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRotate", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetShear")
    def reset_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetShear", []))

    @jsii.member(jsii_name="resetTrim")
    def reset_trim(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTrim", []))

    @jsii.member(jsii_name="resetUnsharpMask")
    def reset_unsharp_mask(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUnsharpMask", []))

    @builtins.property
    @jsii.member(jsii_name="append")
    def append(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanAppendList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanAppendList, jsii.get(self, "append"))

    @builtins.property
    @jsii.member(jsii_name="aspectCrop")
    def aspect_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanAspectCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanAspectCropList, jsii.get(self, "aspectCrop"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColor")
    def background_color(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanBackgroundColorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanBackgroundColorList, jsii.get(self, "backgroundColor"))

    @builtins.property
    @jsii.member(jsii_name="blur")
    def blur(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanBlurList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanBlurList, jsii.get(self, "blur"))

    @builtins.property
    @jsii.member(jsii_name="chromaKey")
    def chroma_key(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanChromaKeyList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanChromaKeyList, jsii.get(self, "chromaKey"))

    @builtins.property
    @jsii.member(jsii_name="composite")
    def composite(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanCompositeList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanCompositeList, jsii.get(self, "composite"))

    @builtins.property
    @jsii.member(jsii_name="compound")
    def compound(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanCompoundList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanCompoundList, jsii.get(self, "compound"))

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanContrastList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanContrastList, jsii.get(self, "contrast"))

    @builtins.property
    @jsii.member(jsii_name="crop")
    def crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanCropList, jsii.get(self, "crop"))

    @builtins.property
    @jsii.member(jsii_name="faceCrop")
    def face_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanFaceCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanFaceCropList, jsii.get(self, "faceCrop"))

    @builtins.property
    @jsii.member(jsii_name="featureCrop")
    def feature_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanFeatureCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanFeatureCropList, jsii.get(self, "featureCrop"))

    @builtins.property
    @jsii.member(jsii_name="fitAndFill")
    def fit_and_fill(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanFitAndFillList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanFitAndFillList, jsii.get(self, "fitAndFill"))

    @builtins.property
    @jsii.member(jsii_name="goop")
    def goop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanGoopList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanGoopList, jsii.get(self, "goop"))

    @builtins.property
    @jsii.member(jsii_name="grayscale")
    def grayscale(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanGrayscaleList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanGrayscaleList, jsii.get(self, "grayscale"))

    @builtins.property
    @jsii.member(jsii_name="hsl")
    def hsl(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanHslList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanHslList, jsii.get(self, "hsl"))

    @builtins.property
    @jsii.member(jsii_name="hsv")
    def hsv(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanHsvList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanHsvList, jsii.get(self, "hsv"))

    @builtins.property
    @jsii.member(jsii_name="ifDimension")
    def if_dimension(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionList, jsii.get(self, "ifDimension"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientation")
    def if_orientation(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationList, jsii.get(self, "ifOrientation"))

    @builtins.property
    @jsii.member(jsii_name="imQuery")
    def im_query(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanImQueryList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanImQueryList, jsii.get(self, "imQuery"))

    @builtins.property
    @jsii.member(jsii_name="maxColors")
    def max_colors(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanMaxColorsList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanMaxColorsList, jsii.get(self, "maxColors"))

    @builtins.property
    @jsii.member(jsii_name="mirror")
    def mirror(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanMirrorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanMirrorList, jsii.get(self, "mirror"))

    @builtins.property
    @jsii.member(jsii_name="monoHue")
    def mono_hue(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanMonoHueList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanMonoHueList, jsii.get(self, "monoHue"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanOpacityList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanOpacityList, jsii.get(self, "opacity"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestCrop")
    def region_of_interest_crop(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanRegionOfInterestCropList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanRegionOfInterestCropList", jsii.get(self, "regionOfInterestCrop"))

    @builtins.property
    @jsii.member(jsii_name="relativeCrop")
    def relative_crop(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanRelativeCropList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanRelativeCropList", jsii.get(self, "relativeCrop"))

    @builtins.property
    @jsii.member(jsii_name="removeColor")
    def remove_color(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanRemoveColorList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanRemoveColorList", jsii.get(self, "removeColor"))

    @builtins.property
    @jsii.member(jsii_name="resize")
    def resize(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanResizeList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanResizeList", jsii.get(self, "resize"))

    @builtins.property
    @jsii.member(jsii_name="rotate")
    def rotate(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanRotateList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanRotateList", jsii.get(self, "rotate"))

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanScaleList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanScaleList", jsii.get(self, "scale"))

    @builtins.property
    @jsii.member(jsii_name="shear")
    def shear(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanShearList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanShearList", jsii.get(self, "shear"))

    @builtins.property
    @jsii.member(jsii_name="trim")
    def trim(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanTrimList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanTrimList", jsii.get(self, "trim"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMask")
    def unsharp_mask(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanUnsharpMaskList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanUnsharpMaskList", jsii.get(self, "unsharpMask"))

    @builtins.property
    @jsii.member(jsii_name="appendInput")
    def append_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanAppend]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanAppend]]], jsii.get(self, "appendInput"))

    @builtins.property
    @jsii.member(jsii_name="aspectCropInput")
    def aspect_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanAspectCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanAspectCrop]]], jsii.get(self, "aspectCropInput"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColorInput")
    def background_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanBackgroundColor]]], jsii.get(self, "backgroundColorInput"))

    @builtins.property
    @jsii.member(jsii_name="blurInput")
    def blur_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanBlur]]], jsii.get(self, "blurInput"))

    @builtins.property
    @jsii.member(jsii_name="chromaKeyInput")
    def chroma_key_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanChromaKey]]], jsii.get(self, "chromaKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="compositeInput")
    def composite_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanComposite]]], jsii.get(self, "compositeInput"))

    @builtins.property
    @jsii.member(jsii_name="compoundInput")
    def compound_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanCompound]]], jsii.get(self, "compoundInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanContrast]]], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="cropInput")
    def crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanCrop]]], jsii.get(self, "cropInput"))

    @builtins.property
    @jsii.member(jsii_name="faceCropInput")
    def face_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanFaceCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanFaceCrop]]], jsii.get(self, "faceCropInput"))

    @builtins.property
    @jsii.member(jsii_name="featureCropInput")
    def feature_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanFeatureCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanFeatureCrop]]], jsii.get(self, "featureCropInput"))

    @builtins.property
    @jsii.member(jsii_name="fitAndFillInput")
    def fit_and_fill_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanFitAndFill]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanFitAndFill]]], jsii.get(self, "fitAndFillInput"))

    @builtins.property
    @jsii.member(jsii_name="goopInput")
    def goop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanGoop]]], jsii.get(self, "goopInput"))

    @builtins.property
    @jsii.member(jsii_name="grayscaleInput")
    def grayscale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanGrayscale]]], jsii.get(self, "grayscaleInput"))

    @builtins.property
    @jsii.member(jsii_name="hslInput")
    def hsl_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanHsl]]], jsii.get(self, "hslInput"))

    @builtins.property
    @jsii.member(jsii_name="hsvInput")
    def hsv_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanHsv]]], jsii.get(self, "hsvInput"))

    @builtins.property
    @jsii.member(jsii_name="ifDimensionInput")
    def if_dimension_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfDimension]]], jsii.get(self, "ifDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientationInput")
    def if_orientation_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientation]]], jsii.get(self, "ifOrientationInput"))

    @builtins.property
    @jsii.member(jsii_name="imQueryInput")
    def im_query_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanImQuery]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanImQuery]]], jsii.get(self, "imQueryInput"))

    @builtins.property
    @jsii.member(jsii_name="maxColorsInput")
    def max_colors_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanMaxColors]]], jsii.get(self, "maxColorsInput"))

    @builtins.property
    @jsii.member(jsii_name="mirrorInput")
    def mirror_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanMirror]]], jsii.get(self, "mirrorInput"))

    @builtins.property
    @jsii.member(jsii_name="monoHueInput")
    def mono_hue_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanMonoHue]]], jsii.get(self, "monoHueInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanOpacity]]], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestCropInput")
    def region_of_interest_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanRegionOfInterestCrop"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanRegionOfInterestCrop"]]], jsii.get(self, "regionOfInterestCropInput"))

    @builtins.property
    @jsii.member(jsii_name="relativeCropInput")
    def relative_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanRelativeCrop"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanRelativeCrop"]]], jsii.get(self, "relativeCropInput"))

    @builtins.property
    @jsii.member(jsii_name="removeColorInput")
    def remove_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanRemoveColor"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanRemoveColor"]]], jsii.get(self, "removeColorInput"))

    @builtins.property
    @jsii.member(jsii_name="resizeInput")
    def resize_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanResize"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanResize"]]], jsii.get(self, "resizeInput"))

    @builtins.property
    @jsii.member(jsii_name="rotateInput")
    def rotate_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanRotate"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanRotate"]]], jsii.get(self, "rotateInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanScale"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanScale"]]], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="shearInput")
    def shear_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanShear"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanShear"]]], jsii.get(self, "shearInput"))

    @builtins.property
    @jsii.member(jsii_name="trimInput")
    def trim_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanTrim"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanTrim"]]], jsii.get(self, "trimInput"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMaskInput")
    def unsharp_mask_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanUnsharpMask"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanUnsharpMask"]]], jsii.get(self, "unsharpMaskInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8e8a71e48af035f66981ff74ca00c5e3dc8e0e0233b6f30c348a41b7a6ca3295)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanRegionOfInterestCrop",
    jsii_struct_bases=[],
    name_mapping={
        "region_of_interest": "regionOfInterest",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanRegionOfInterestCrop:
    def __init__(
        self,
        *,
        region_of_interest: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanRegionOfInterestCropRegionOfInterest", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param region_of_interest: region_of_interest block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest DataAkamaiImagingPolicyImage#region_of_interest}
        :param gravity: The placement of the crop area relative to the specified area of interest. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: The placement of the crop area relative to the specified area of interest. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param style: Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(region_of_interest, dict):
            region_of_interest = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanRegionOfInterestCropRegionOfInterest(**region_of_interest)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__33bdc2e3297560252f64de097da6900be4d00f78137f2ce65ddae73efb602196)
            check_type(argname="argument region_of_interest", value=region_of_interest, expected_type=type_hints["region_of_interest"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "region_of_interest": region_of_interest,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def region_of_interest(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanRegionOfInterestCropRegionOfInterest":
        '''region_of_interest block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest DataAkamaiImagingPolicyImage#region_of_interest}
        '''
        result = self._values.get("region_of_interest")
        assert result is not None, "Required property 'region_of_interest' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanRegionOfInterestCropRegionOfInterest", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''The placement of the crop area relative to the specified area of interest.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''The placement of the crop area relative to the specified area of interest.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanRegionOfInterestCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanRegionOfInterestCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanRegionOfInterestCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f5b4f1294d8a0542344ea210f82b50c9e8ffc250a6e1797fe623ffe386667503)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanRegionOfInterestCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__74e94a332e7ae0b4c3951807c8ed790cec7c10c47a0d1bf320821827883cd122)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanRegionOfInterestCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e488a085f67395c2b7c5e8d4a100c486fed8a964f35b4f9010fcf1aaa0730788)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d7e784986c45c7df53b613ba115a7064d5c1ded1493c1fc20790a46222a2c495)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac878be25d194d64e1942ecbbabb9244c9dbc141c1359138669b23ec440ac83a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanRegionOfInterestCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanRegionOfInterestCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanRegionOfInterestCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__30ae5f89bec3b53307f405c09bd0dff5aa57d37bd8ee76697d43e6731c13837e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanRegionOfInterestCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanRegionOfInterestCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8675fc611d959e4b6ef27f31de7629c090dce976d4d3cf1d43f0bc62ba47b458)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putRegionOfInterest")
    def put_region_of_interest(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanRegionOfInterestCropRegionOfInterest()

        return typing.cast(None, jsii.invoke(self, "putRegionOfInterest", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterest")
    def region_of_interest(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanRegionOfInterestCropRegionOfInterestOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanRegionOfInterestCropRegionOfInterestOutputReference", jsii.get(self, "regionOfInterest"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestInput")
    def region_of_interest_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanRegionOfInterestCropRegionOfInterest"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanRegionOfInterestCropRegionOfInterest"], jsii.get(self, "regionOfInterestInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__db2416a67dfbcaef0155e81bda936abcf11b4ec4b1fb71252efc6d4cda52f2dc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b49c8a2865306494869e1d3f8c90acf0741520588d3fddbc5619c4bf336f4344)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__473617858d797055446455bed4cb0d741de2ae232ccdd6d1ab8433d8451c2443)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__644ee8d74f7dc20ef8545611fedfe997bf13672da386c354524fbf810c1479c2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__92a7bff27b70655ec4343127e6a1103c15677a4fa9c3a4da0b3b34aaf2881201)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ee6273a2a80e00ea14a0269eed460b6104dc49ac6b38cde4f622384225165254)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__189c51d6e704f027539f0ac89f12514b4aea847cc9de2cee9df1d5af28bcee81)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__74c12f3c3aec4bb3d38e84731b84d99ec30f93a93dff9d77a0eb40530ea62e67)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanRegionOfInterestCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanRegionOfInterestCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanRegionOfInterestCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cfd9eeda0ecd7152037973c07eb79e42b5c10234eb185474c93e62d17461f3e8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanRegionOfInterestCropRegionOfInterest",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanRegionOfInterestCropRegionOfInterest:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanRegionOfInterestCropRegionOfInterest(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanRegionOfInterestCropRegionOfInterestOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanRegionOfInterestCropRegionOfInterestOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f2c10e0d5d8851ca6566034e34bdfea7b55df2bc26a61f2fcea3256640f143a4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanRegionOfInterestCropRegionOfInterest]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanRegionOfInterestCropRegionOfInterest], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanRegionOfInterestCropRegionOfInterest],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ea030dea2997f62acb836657f4ffe5732a77305345f20bdf485c71776c13339)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanRelativeCrop",
    jsii_struct_bases=[],
    name_mapping={
        "east": "east",
        "east_var": "eastVar",
        "north": "north",
        "north_var": "northVar",
        "south": "south",
        "south_var": "southVar",
        "west": "west",
        "west_var": "westVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanRelativeCrop:
    def __init__(
        self,
        *,
        east: typing.Optional[builtins.str] = None,
        east_var: typing.Optional[builtins.str] = None,
        north: typing.Optional[builtins.str] = None,
        north_var: typing.Optional[builtins.str] = None,
        south: typing.Optional[builtins.str] = None,
        south_var: typing.Optional[builtins.str] = None,
        west: typing.Optional[builtins.str] = None,
        west_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param east: The number of pixels to shrink or expand the right side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east DataAkamaiImagingPolicyImage#east}
        :param east_var: The number of pixels to shrink or expand the right side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east_var DataAkamaiImagingPolicyImage#east_var}
        :param north: The number of pixels to shrink or expand the top side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north DataAkamaiImagingPolicyImage#north}
        :param north_var: The number of pixels to shrink or expand the top side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north_var DataAkamaiImagingPolicyImage#north_var}
        :param south: The number of pixels to shrink or expand the bottom side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south DataAkamaiImagingPolicyImage#south}
        :param south_var: The number of pixels to shrink or expand the bottom side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south_var DataAkamaiImagingPolicyImage#south_var}
        :param west: The number of pixels to shrink or expand the left side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west DataAkamaiImagingPolicyImage#west}
        :param west_var: The number of pixels to shrink or expand the left side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west_var DataAkamaiImagingPolicyImage#west_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c5ab3e94cda97ad4eb63e42077615d097998d032ba2fa56d4bb60c3de4217554)
            check_type(argname="argument east", value=east, expected_type=type_hints["east"])
            check_type(argname="argument east_var", value=east_var, expected_type=type_hints["east_var"])
            check_type(argname="argument north", value=north, expected_type=type_hints["north"])
            check_type(argname="argument north_var", value=north_var, expected_type=type_hints["north_var"])
            check_type(argname="argument south", value=south, expected_type=type_hints["south"])
            check_type(argname="argument south_var", value=south_var, expected_type=type_hints["south_var"])
            check_type(argname="argument west", value=west, expected_type=type_hints["west"])
            check_type(argname="argument west_var", value=west_var, expected_type=type_hints["west_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if east is not None:
            self._values["east"] = east
        if east_var is not None:
            self._values["east_var"] = east_var
        if north is not None:
            self._values["north"] = north
        if north_var is not None:
            self._values["north_var"] = north_var
        if south is not None:
            self._values["south"] = south
        if south_var is not None:
            self._values["south_var"] = south_var
        if west is not None:
            self._values["west"] = west
        if west_var is not None:
            self._values["west_var"] = west_var

    @builtins.property
    def east(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the right side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east DataAkamaiImagingPolicyImage#east}
        '''
        result = self._values.get("east")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def east_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the right side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east_var DataAkamaiImagingPolicyImage#east_var}
        '''
        result = self._values.get("east_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def north(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the top side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north DataAkamaiImagingPolicyImage#north}
        '''
        result = self._values.get("north")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def north_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the top side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north_var DataAkamaiImagingPolicyImage#north_var}
        '''
        result = self._values.get("north_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def south(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the bottom side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south DataAkamaiImagingPolicyImage#south}
        '''
        result = self._values.get("south")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def south_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the bottom side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south_var DataAkamaiImagingPolicyImage#south_var}
        '''
        result = self._values.get("south_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def west(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the left side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west DataAkamaiImagingPolicyImage#west}
        '''
        result = self._values.get("west")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def west_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the left side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west_var DataAkamaiImagingPolicyImage#west_var}
        '''
        result = self._values.get("west_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanRelativeCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanRelativeCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanRelativeCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__361ec076f6e3e8684d54974d29b98603f153b9dd56db5dba3b7bbb177497cea9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanRelativeCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ed62862cb0809549f21f7397f7e9d004265dcd9a64a9c5cf9cda2f77962bce74)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanRelativeCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3565751d8f34496226a88887dab347c1ba4b2ec7880afc3023cedc4066ae9115)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__36d72b82c739227cda60d48ff8243aad84ef8c75b742626160cf43b2335e3fe0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__87124133211d0f43a16286f223958ba6ba4503fd8f6bd9208678411bedd7a25e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanRelativeCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanRelativeCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanRelativeCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__933573a92c6b1246a73c26f680bfb1afd083d8f46d44b19bfa4b993bdc35e7e2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanRelativeCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanRelativeCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4b8132dcded76612fda334b00951276333430324b2c18b31757203b9eaf93f21)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetEast")
    def reset_east(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEast", []))

    @jsii.member(jsii_name="resetEastVar")
    def reset_east_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEastVar", []))

    @jsii.member(jsii_name="resetNorth")
    def reset_north(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNorth", []))

    @jsii.member(jsii_name="resetNorthVar")
    def reset_north_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNorthVar", []))

    @jsii.member(jsii_name="resetSouth")
    def reset_south(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSouth", []))

    @jsii.member(jsii_name="resetSouthVar")
    def reset_south_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSouthVar", []))

    @jsii.member(jsii_name="resetWest")
    def reset_west(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWest", []))

    @jsii.member(jsii_name="resetWestVar")
    def reset_west_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWestVar", []))

    @builtins.property
    @jsii.member(jsii_name="eastInput")
    def east_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "eastInput"))

    @builtins.property
    @jsii.member(jsii_name="eastVarInput")
    def east_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "eastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="northInput")
    def north_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "northInput"))

    @builtins.property
    @jsii.member(jsii_name="northVarInput")
    def north_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "northVarInput"))

    @builtins.property
    @jsii.member(jsii_name="southInput")
    def south_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "southInput"))

    @builtins.property
    @jsii.member(jsii_name="southVarInput")
    def south_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "southVarInput"))

    @builtins.property
    @jsii.member(jsii_name="westInput")
    def west_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "westInput"))

    @builtins.property
    @jsii.member(jsii_name="westVarInput")
    def west_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "westVarInput"))

    @builtins.property
    @jsii.member(jsii_name="east")
    def east(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "east"))

    @east.setter
    def east(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__661524ef3d9400179f14a42c5c30c69698e30496cc0f677e1d6032fc5821f4d7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "east", value)

    @builtins.property
    @jsii.member(jsii_name="eastVar")
    def east_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "eastVar"))

    @east_var.setter
    def east_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a39ab85f180e406d67d6ac75011d027a392bfdb9fe1f4cd2c457f25ab032c31a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "eastVar", value)

    @builtins.property
    @jsii.member(jsii_name="north")
    def north(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "north"))

    @north.setter
    def north(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1a536b9a184fb74f878f0c64b2c30330ad124745722a0dd91aff38a8a0493ae0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "north", value)

    @builtins.property
    @jsii.member(jsii_name="northVar")
    def north_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "northVar"))

    @north_var.setter
    def north_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9e0905df4ba57f08663a55c27d4859ea6026f50b2aad1f38aaa0b67da7d71ac1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "northVar", value)

    @builtins.property
    @jsii.member(jsii_name="south")
    def south(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "south"))

    @south.setter
    def south(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__02612a5112b2f300641d279e1c14dc7317383e8f783761b06507beff2cfe4288)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "south", value)

    @builtins.property
    @jsii.member(jsii_name="southVar")
    def south_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "southVar"))

    @south_var.setter
    def south_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e004186896e58cbee0969146df128bbde8b7050ddd720db42c0136592c634bda)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "southVar", value)

    @builtins.property
    @jsii.member(jsii_name="west")
    def west(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "west"))

    @west.setter
    def west(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7327640050af5f615ac90da4a959a76023ed0fb78f8a26a5363971078d12dc23)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "west", value)

    @builtins.property
    @jsii.member(jsii_name="westVar")
    def west_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "westVar"))

    @west_var.setter
    def west_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8457ab470f42dfee8e410228e9dc7e4126c2b6ec212c97c75616f86716e6e07b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "westVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanRelativeCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanRelativeCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanRelativeCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e474744f731befa09e823936708c43fca2f184709a5c3524a6f45327f0fb3cbd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanRemoveColor",
    jsii_struct_bases=[],
    name_mapping={
        "color": "color",
        "color_var": "colorVar",
        "feather": "feather",
        "feather_var": "featherVar",
        "tolerance": "tolerance",
        "tolerance_var": "toleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanRemoveColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
        feather: typing.Optional[builtins.str] = None,
        feather_var: typing.Optional[builtins.str] = None,
        tolerance: typing.Optional[builtins.str] = None,
        tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        :param feather: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        :param feather_var: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        :param tolerance: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        :param tolerance_var: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__273c3ef95c7f3f759630b589f618a781da372b976635646e714eacb0bf88d243)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
            check_type(argname="argument feather", value=feather, expected_type=type_hints["feather"])
            check_type(argname="argument feather_var", value=feather_var, expected_type=type_hints["feather_var"])
            check_type(argname="argument tolerance", value=tolerance, expected_type=type_hints["tolerance"])
            check_type(argname="argument tolerance_var", value=tolerance_var, expected_type=type_hints["tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var
        if feather is not None:
            self._values["feather"] = feather
        if feather_var is not None:
            self._values["feather_var"] = feather_var
        if tolerance is not None:
            self._values["tolerance"] = tolerance
        if tolerance_var is not None:
            self._values["tolerance_var"] = tolerance_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        '''
        result = self._values.get("feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather_var(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        '''
        result = self._values.get("feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        '''
        result = self._values.get("tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance_var(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        result = self._values.get("tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanRemoveColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanRemoveColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanRemoveColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7eed44728f24ebf8da1dd1f4be948c3265f789d82b1dd56e9e0477fda9b62357)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanRemoveColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d5c6258d4283f4a19f95e5019075866830a2102397eb2a532a8b498ca527dc7)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanRemoveColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c766b3a2ffdbf7f2f217dc1148b659b7a68d27efd4fb823a4a3dcc520d1dcf27)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3bb9a1ac748a7be31cb35d4fe67019189394d8399c675511e112e5886dddaebc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2b305c8313e170ef31a22330ba03d1dda86be4b47c4a11ea15d3ad70912f99a0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanRemoveColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanRemoveColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanRemoveColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0cdb57d061d85db4494c2aced92f8c9819ad0c77da3541f6d09781e88367962a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanRemoveColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanRemoveColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f31cbfe269288005dc55ec0f109ef823cda4d0f0a8f34179e8d336c0b96cb0e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @jsii.member(jsii_name="resetFeather")
    def reset_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeather", []))

    @jsii.member(jsii_name="resetFeatherVar")
    def reset_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatherVar", []))

    @jsii.member(jsii_name="resetTolerance")
    def reset_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTolerance", []))

    @jsii.member(jsii_name="resetToleranceVar")
    def reset_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featherInput")
    def feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherInput"))

    @builtins.property
    @jsii.member(jsii_name="featherVarInput")
    def feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceInput")
    def tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceVarInput")
    def tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__70410b2bc4941becc46ffc2af63fe3875a4339acac68cd191fc3a0b4e361a4d8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fea29d00aec4f046b589621f980c0d0c6b00bd9e4fec3db373bf7c4af1fe7d82)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="feather")
    def feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "feather"))

    @feather.setter
    def feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4336d3f3b7975e9949c83f3e876558f499a62f9596c3e4983c643007d907c02f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "feather", value)

    @builtins.property
    @jsii.member(jsii_name="featherVar")
    def feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featherVar"))

    @feather_var.setter
    def feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__244147b98ea5cc497bac545b6889e2582bc3a0e11a52db92a62f1fe4a2aa7273)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featherVar", value)

    @builtins.property
    @jsii.member(jsii_name="tolerance")
    def tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tolerance"))

    @tolerance.setter
    def tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7ff141be84cd11c5041e127341528833179bf87c3db36e4bd924b9eaf8ae9693)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tolerance", value)

    @builtins.property
    @jsii.member(jsii_name="toleranceVar")
    def tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "toleranceVar"))

    @tolerance_var.setter
    def tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c81b85af744bef7cc5ff20b68d148c13d8a61b3ada1d2006562cf633bb01fec9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "toleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanRemoveColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanRemoveColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanRemoveColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__39d3c7a6192f65f066bf3c89d2265bd3055b255cc7eb7cfae97db25377251730)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanResize",
    jsii_struct_bases=[],
    name_mapping={
        "aspect": "aspect",
        "aspect_var": "aspectVar",
        "height": "height",
        "height_var": "heightVar",
        "type": "type",
        "type_var": "typeVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanResize:
    def __init__(
        self,
        *,
        aspect: typing.Optional[builtins.str] = None,
        aspect_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param aspect: Preserves the aspect ratio. Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect DataAkamaiImagingPolicyImage#aspect}
        :param aspect_var: Preserves the aspect ratio. Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_var DataAkamaiImagingPolicyImage#aspect_var}
        :param height: The height to resize the source image to. Must be set if height is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height to resize the source image to. Must be set if height is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param type: Sets constraints for the image resize. Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: Sets constraints for the image resize. Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        :param width: The width to resize the source image to. Must be set if width is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width to resize the source image to. Must be set if width is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dffec3762c260370db254c179af423dc89fc6a7648d2a312b93c9caa6ea4e9bf)
            check_type(argname="argument aspect", value=aspect, expected_type=type_hints["aspect"])
            check_type(argname="argument aspect_var", value=aspect_var, expected_type=type_hints["aspect_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if aspect is not None:
            self._values["aspect"] = aspect
        if aspect_var is not None:
            self._values["aspect_var"] = aspect_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def aspect(self) -> typing.Optional[builtins.str]:
        '''Preserves the aspect ratio.

        Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect DataAkamaiImagingPolicyImage#aspect}
        '''
        result = self._values.get("aspect")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def aspect_var(self) -> typing.Optional[builtins.str]:
        '''Preserves the aspect ratio.

        Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_var DataAkamaiImagingPolicyImage#aspect_var}
        '''
        result = self._values.get("aspect_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height to resize the source image to. Must be set if height is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height to resize the source image to. Must be set if height is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''Sets constraints for the image resize.

        Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''Sets constraints for the image resize.

        Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width to resize the source image to. Must be set if width is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width to resize the source image to. Must be set if width is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanResize(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanResizeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanResizeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cc1e4877266517056efec8c5597b0814f489fc8c22625f79c1a79a797b030af0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanResizeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__619631bc2b92a1e8ed5154970fe462974c01e5b5a3e6c9880fc7863111bb5e0f)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanResizeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b34efeef7864bd3ed8fd5ad1ce766be05bfa11b058bc32a285970b6901cf54df)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a495f01f10f64e33a09db61b93e3ba2478ffaeb3f3f15f2a3c00bfaa88bd21fb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cf473e232ed62283d95b04000c0a969051eef0ffaa7f6a08405a851731c7fb8a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanResize]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanResize]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanResize]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__34fe0616e322a1fa08134fc7922106a68ff766c868abfb940d9f2a89675d146b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanResizeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanResizeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4e2ce5a2b46bba505ee350b26068b27870d7cd09de025347acb9dbf058145e17)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAspect")
    def reset_aspect(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspect", []))

    @jsii.member(jsii_name="resetAspectVar")
    def reset_aspect_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspectVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="aspectInput")
    def aspect_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "aspectInput"))

    @builtins.property
    @jsii.member(jsii_name="aspectVarInput")
    def aspect_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "aspectVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="aspect")
    def aspect(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "aspect"))

    @aspect.setter
    def aspect(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__921d9426ab419bd4b8177f003652573671f1e6f6b51dce2cb0d6cd8b16a293eb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "aspect", value)

    @builtins.property
    @jsii.member(jsii_name="aspectVar")
    def aspect_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "aspectVar"))

    @aspect_var.setter
    def aspect_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__80a66839bc97462f03a4f05fc5bc93b5c935a09e1e87a6435bbcbcd0b8b8d748)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "aspectVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__75993ada51cec1b2564607b3bd3f81ad0289ae6e6b8ed293d80f1a0697bb286f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__532d4ea096305596a2ff530742be496071f0545d559b9d983066d92d06ca6a9d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cace56141f0949936c9c814c34e344e9b060e1e07ef08406a3e908eacac9e068)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9fc0676289bb472adfbdff37c265c427eb9490102f12a6b519201cbbba59944d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6b127974f61ef895434b6cf11935709e573ec3cc3cdf8dcd1f0780e01bcf7171)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d572e1506eb09dd65354d7d5c3b5715909f469f1c3022664523a07cb04b91e8e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanResize]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanResize]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanResize]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7fa2dd96ee0f435de58c6008fb8bd22af9b7159e701e6c37dba65758816b4d5d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanRotate",
    jsii_struct_bases=[],
    name_mapping={"degrees": "degrees", "degrees_var": "degreesVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanRotate:
    def __init__(
        self,
        *,
        degrees: typing.Optional[builtins.str] = None,
        degrees_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param degrees: The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees DataAkamaiImagingPolicyImage#degrees}
        :param degrees_var: The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees_var DataAkamaiImagingPolicyImage#degrees_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__91b478b56c858422119aa3ed1df26669ebf39f8af01a2180a50e4541e1486729)
            check_type(argname="argument degrees", value=degrees, expected_type=type_hints["degrees"])
            check_type(argname="argument degrees_var", value=degrees_var, expected_type=type_hints["degrees_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if degrees is not None:
            self._values["degrees"] = degrees
        if degrees_var is not None:
            self._values["degrees_var"] = degrees_var

    @builtins.property
    def degrees(self) -> typing.Optional[builtins.str]:
        '''The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees DataAkamaiImagingPolicyImage#degrees}
        '''
        result = self._values.get("degrees")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def degrees_var(self) -> typing.Optional[builtins.str]:
        '''The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees_var DataAkamaiImagingPolicyImage#degrees_var}
        '''
        result = self._values.get("degrees_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanRotate(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanRotateList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanRotateList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a2110d05a6ae08ef6522b7206f885fe066870f6988a13bfdeea76acab9d9d391)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanRotateOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__28279d4b4e2aecbb0509d70472521bbb8b0adab327057a5b0491c2bbb5276f5a)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanRotateOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__acfef957c899d2baf8970cbefb00747b437d6e6c940a68652da8b11d362bd5f8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e2ee94d523dfa21d31856373564968da7fde4fb2e538813a685e1470ce92b2e8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4463500f1bbbf25064cc8cb6d2fe406ae1e74b4bd64dac7df2784cc722d43974)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanRotate]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanRotate]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanRotate]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__823f8bfe93e38a9b0964d771b2c0de0983ef8deaf27e2ee4c9726de3090091c3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanRotateOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanRotateOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7835113469ff88005459f5a1a51ec4148de4a3039933a29659a3344d8fe4c43a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetDegrees")
    def reset_degrees(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDegrees", []))

    @jsii.member(jsii_name="resetDegreesVar")
    def reset_degrees_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDegreesVar", []))

    @builtins.property
    @jsii.member(jsii_name="degreesInput")
    def degrees_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "degreesInput"))

    @builtins.property
    @jsii.member(jsii_name="degreesVarInput")
    def degrees_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "degreesVarInput"))

    @builtins.property
    @jsii.member(jsii_name="degrees")
    def degrees(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "degrees"))

    @degrees.setter
    def degrees(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__473f9fb241b28f8b49503240359c87a9ec873d98d5b6f34f6d2434d0a0b6e4a3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "degrees", value)

    @builtins.property
    @jsii.member(jsii_name="degreesVar")
    def degrees_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "degreesVar"))

    @degrees_var.setter
    def degrees_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea0fd0a30b6b56d2411b121cfaa7c2c9323bf6f8c462cebaae57b79b975d057e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "degreesVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanRotate]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanRotate]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanRotate]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d3e530417df375bb4ba9ae5545f9f0f57da7b1e44132045baf5789313ebb6db5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanScale",
    jsii_struct_bases=[],
    name_mapping={
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanScale:
    def __init__(
        self,
        *,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param height: Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged. Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged. Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__079c25dc3405f0a10b3c040e50c0046a6de8865ba2090dc1f1e8223f4a917811)
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size.

        Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size.

        Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged.

        Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged.

        Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanScale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanScaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanScaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab4ddd004312307cb715bfc9fa35f158195c1a651ca4eb22576d8fbf5f8d2886)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanScaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d91c88a889f720dd6e017273c62d877681dd0cf3c07388cbfb2c95ddf38b5a01)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanScaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__92189ca6cf047daac9b9a753d424f72359ed61169f3ed091c348329c9d9495fc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__84b77bccb0b779dac45a886c77b900db3d2403bbf53b419213a1f2f4ddb10ebf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a412b97350f733dda216b1f169d9c219c7124abbd99089ab5f8a4620b44294ce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanScale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanScale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanScale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac8c52a8021036c49b3a221c298bbb22860bac60b238ee90e727879532dd6191)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanScaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanScaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e032f8a4bf539a83a5e074141bb6a66c755179cecd75e524b3aa329accb0287e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2bd67bca828a59aeb72d67fa856021847595218954f7ebd996fc789e75339991)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1406bfce50796efcdbbdc000859ffb1e340c85ab48875686e36a6b136358066a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e614454423b40b1a89c97b524fe9434c2e591711fa981c0ccf1e563b7e18c1e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8960a09ccaff754202813b3801888a290e23670e0f0fd05527ba7cb13546c1d5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanScale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanScale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanScale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b8e0f79ddbfb09decff2114136a02c3d14db788dea1e4f987421c99d4a386198)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanShear",
    jsii_struct_bases=[],
    name_mapping={
        "x_shear": "xShear",
        "x_shear_var": "xShearVar",
        "y_shear": "yShear",
        "y_shear_var": "yShearVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanShear:
    def __init__(
        self,
        *,
        x_shear: typing.Optional[builtins.str] = None,
        x_shear_var: typing.Optional[builtins.str] = None,
        y_shear: typing.Optional[builtins.str] = None,
        y_shear_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param x_shear: The amount to shear along the x-axis, measured in multiples of the image's width. Must be set if yShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear DataAkamaiImagingPolicyImage#x_shear}
        :param x_shear_var: The amount to shear along the x-axis, measured in multiples of the image's width. Must be set if yShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear_var DataAkamaiImagingPolicyImage#x_shear_var}
        :param y_shear: The amount to shear along the y-axis, measured in multiples of the image's height. Must be set if xShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear DataAkamaiImagingPolicyImage#y_shear}
        :param y_shear_var: The amount to shear along the y-axis, measured in multiples of the image's height. Must be set if xShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear_var DataAkamaiImagingPolicyImage#y_shear_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e8ab6a13564f876980c05f9c4f955daaee588a28782bfa7d602be7528e0042cc)
            check_type(argname="argument x_shear", value=x_shear, expected_type=type_hints["x_shear"])
            check_type(argname="argument x_shear_var", value=x_shear_var, expected_type=type_hints["x_shear_var"])
            check_type(argname="argument y_shear", value=y_shear, expected_type=type_hints["y_shear"])
            check_type(argname="argument y_shear_var", value=y_shear_var, expected_type=type_hints["y_shear_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if x_shear is not None:
            self._values["x_shear"] = x_shear
        if x_shear_var is not None:
            self._values["x_shear_var"] = x_shear_var
        if y_shear is not None:
            self._values["y_shear"] = y_shear
        if y_shear_var is not None:
            self._values["y_shear_var"] = y_shear_var

    @builtins.property
    def x_shear(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the x-axis, measured in multiples of the image's width.

        Must be set if yShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear DataAkamaiImagingPolicyImage#x_shear}
        '''
        result = self._values.get("x_shear")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_shear_var(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the x-axis, measured in multiples of the image's width.

        Must be set if yShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear_var DataAkamaiImagingPolicyImage#x_shear_var}
        '''
        result = self._values.get("x_shear_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_shear(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the y-axis, measured in multiples of the image's height.

        Must be set if xShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear DataAkamaiImagingPolicyImage#y_shear}
        '''
        result = self._values.get("y_shear")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_shear_var(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the y-axis, measured in multiples of the image's height.

        Must be set if xShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear_var DataAkamaiImagingPolicyImage#y_shear_var}
        '''
        result = self._values.get("y_shear_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanShear(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanShearList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanShearList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e1008950be71ddcf3c4264affa3d0d514610c76731ccae1a4e0856874093525f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanShearOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__68b3275c14e8a99d51dbd1ba13b095e785c5a1bbf6a20c3e5de507b2841422cf)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanShearOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c7259e4057affb654913f91b22c854b17583cab9f1ce31539e7871ed9f071f05)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cc49f8567bfc59e5b13382a9c1d63dbd01051a863f156c87b5af6632be5280d8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__085376039b5605a7e849f74c906ce4c2379dfeae8c601d67a1d04586ba907a79)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanShear]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanShear]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanShear]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1b2e58015ef9148075428f37aa7827f9248b38ffd588514e3466d11d41946ddd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanShearOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanShearOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d9a10198b9123ee2f1bae158a8cf88091c0d0b6a5a09bf3c8a4b5cd6f67549da)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetXShear")
    def reset_x_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXShear", []))

    @jsii.member(jsii_name="resetXShearVar")
    def reset_x_shear_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXShearVar", []))

    @jsii.member(jsii_name="resetYShear")
    def reset_y_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYShear", []))

    @jsii.member(jsii_name="resetYShearVar")
    def reset_y_shear_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYShearVar", []))

    @builtins.property
    @jsii.member(jsii_name="xShearInput")
    def x_shear_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xShearInput"))

    @builtins.property
    @jsii.member(jsii_name="xShearVarInput")
    def x_shear_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xShearVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yShearInput")
    def y_shear_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yShearInput"))

    @builtins.property
    @jsii.member(jsii_name="yShearVarInput")
    def y_shear_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yShearVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xShear")
    def x_shear(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xShear"))

    @x_shear.setter
    def x_shear(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f1e7c5b32cd0a78b1ba5606003d3b660eec2f3e04a9ffa29812dbab618071b79)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xShear", value)

    @builtins.property
    @jsii.member(jsii_name="xShearVar")
    def x_shear_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xShearVar"))

    @x_shear_var.setter
    def x_shear_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__058b842449192055c88f37c1a0ab6e5211332d4983fba18d35571899fe32c4c9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xShearVar", value)

    @builtins.property
    @jsii.member(jsii_name="yShear")
    def y_shear(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yShear"))

    @y_shear.setter
    def y_shear(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__701023c95c5046df7b3f52bf1eea37b76b8b6f2f7cf4b7de2db3fc92b344c9f3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yShear", value)

    @builtins.property
    @jsii.member(jsii_name="yShearVar")
    def y_shear_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yShearVar"))

    @y_shear_var.setter
    def y_shear_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f6e23e95e2d977a5cebfc56f4fe3ff2a5e41444b3ae5d2613da9233433a111a2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yShearVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanShear]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanShear]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanShear]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4cc9b6fd10ea1afaa28ac8e871d10b989e1e1910da22227544f69d2040cae883)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanTrim",
    jsii_struct_bases=[],
    name_mapping={
        "fuzz": "fuzz",
        "fuzz_var": "fuzzVar",
        "padding": "padding",
        "padding_var": "paddingVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanTrim:
    def __init__(
        self,
        *,
        fuzz: typing.Optional[builtins.str] = None,
        fuzz_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fuzz: The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz DataAkamaiImagingPolicyImage#fuzz}
        :param fuzz_var: The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz_var DataAkamaiImagingPolicyImage#fuzz_var}
        :param padding: The amount of padding in pixels to add to the trimmed image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: The amount of padding in pixels to add to the trimmed image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0a93ccdf9704af653da6277c6d8ff3214149f756409d96a59a8d8f2729032336)
            check_type(argname="argument fuzz", value=fuzz, expected_type=type_hints["fuzz"])
            check_type(argname="argument fuzz_var", value=fuzz_var, expected_type=type_hints["fuzz_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fuzz is not None:
            self._values["fuzz"] = fuzz
        if fuzz_var is not None:
            self._values["fuzz_var"] = fuzz_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var

    @builtins.property
    def fuzz(self) -> typing.Optional[builtins.str]:
        '''The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz DataAkamaiImagingPolicyImage#fuzz}
        '''
        result = self._values.get("fuzz")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fuzz_var(self) -> typing.Optional[builtins.str]:
        '''The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz_var DataAkamaiImagingPolicyImage#fuzz_var}
        '''
        result = self._values.get("fuzz_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''The amount of padding in pixels to add to the trimmed image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''The amount of padding in pixels to add to the trimmed image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanTrim(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanTrimList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanTrimList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__00bc4bdd6ed8233f1cd07a4758eb8c807486461448839f8196b6dc56af67b830)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanTrimOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bfa274f71cbd039ac45e2e737dfa098b5327cf217a8808c9ca321cb41d544ab3)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanTrimOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__16c3a4816c8a0ffdbff0f9c7f5a02d24621926a2386033ed3a5612f5fbdb9617)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__26655089ef277cc5655eccbdb5729347f2c31d1501ca74613956399e8d1c3570)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__46143ebdbf8068f4157bc4131dbb2b077300064b99ab89468495bc3422030aef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanTrim]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanTrim]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanTrim]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6ed4895fce4e3338d748d46637b563e0eedf43ae076fcc22114412747efa7145)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanTrimOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanTrimOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__127931603bfca7e2f51cb0390dbaf156f4f9d6281ce02c1e714d72c90c780fa3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetFuzz")
    def reset_fuzz(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFuzz", []))

    @jsii.member(jsii_name="resetFuzzVar")
    def reset_fuzz_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFuzzVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @builtins.property
    @jsii.member(jsii_name="fuzzInput")
    def fuzz_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fuzzInput"))

    @builtins.property
    @jsii.member(jsii_name="fuzzVarInput")
    def fuzz_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fuzzVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="fuzz")
    def fuzz(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fuzz"))

    @fuzz.setter
    def fuzz(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bd538f4d065f685b78e505d285cc24812996a210f86ce541fba05a8eed7421d9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fuzz", value)

    @builtins.property
    @jsii.member(jsii_name="fuzzVar")
    def fuzz_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fuzzVar"))

    @fuzz_var.setter
    def fuzz_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac0ee60708fa8bb7678f65082fe0943f3a99e9da6afa7879b6014f266cdc6c1c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fuzzVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__102692259261ac722543d0f51e75346807a0633f47f19a4dd6bb998675227b5d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0208ad241b7be102a90043f682c33e285b9c8c8939a2d39f69974ea9c7662c6f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanTrim]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanTrim]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanTrim]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6ce80715fec7e81b66e354df73e1b1271f20670fcdb7b360951af589f2cb9905)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanUnsharpMask",
    jsii_struct_bases=[],
    name_mapping={
        "gain": "gain",
        "gain_var": "gainVar",
        "sigma": "sigma",
        "sigma_var": "sigmaVar",
        "threshold": "threshold",
        "threshold_var": "thresholdVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanUnsharpMask:
    def __init__(
        self,
        *,
        gain: typing.Optional[builtins.str] = None,
        gain_var: typing.Optional[builtins.str] = None,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
        threshold: typing.Optional[builtins.str] = None,
        threshold_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param gain: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        :param gain_var: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        :param sigma: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        :param threshold: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        :param threshold_var: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dea6b03988f1b144d6dfb83fcb360f0d3e666557f310f5c60d84164274473470)
            check_type(argname="argument gain", value=gain, expected_type=type_hints["gain"])
            check_type(argname="argument gain_var", value=gain_var, expected_type=type_hints["gain_var"])
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
            check_type(argname="argument threshold", value=threshold, expected_type=type_hints["threshold"])
            check_type(argname="argument threshold_var", value=threshold_var, expected_type=type_hints["threshold_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if gain is not None:
            self._values["gain"] = gain
        if gain_var is not None:
            self._values["gain_var"] = gain_var
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var
        if threshold is not None:
            self._values["threshold"] = threshold
        if threshold_var is not None:
            self._values["threshold_var"] = threshold_var

    @builtins.property
    def gain(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        '''
        result = self._values.get("gain")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gain_var(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        '''
        result = self._values.get("gain_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        '''
        result = self._values.get("threshold")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold_var(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        result = self._values.get("threshold_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanUnsharpMask(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanUnsharpMaskList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanUnsharpMaskList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eaa4b87a3695646ce4597534b0449d136be699ca86aa89178195db6f89f927f7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanUnsharpMaskOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__175c2fc800c78304773e4160b0c777451ce1ea168525ef03c4e8256ad6d3c634)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanUnsharpMaskOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aa5a173edaebcc9aa3cae723fa1e7fc12d0e486900ac3044b409d4f7e4962a5b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a552754685e949e5133a24eb6affd0b0f2aa5d5928bf91b1dd0a3a8aec1be64)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__05e6df7b9fea52624187ad39e594ee6044870d1e894662a0be3377f201cb369f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanUnsharpMask]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanUnsharpMask]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanUnsharpMask]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9806a449abfc9af7247143f42e650ec1f6944480fefda7ea5f2be8c4d8c4ecb3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanUnsharpMaskOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanUnsharpMaskOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5fe17dcd88e5c3622d95d7d2d7bb6291611d10a68d7f337968efa0132757a1f1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetGain")
    def reset_gain(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGain", []))

    @jsii.member(jsii_name="resetGainVar")
    def reset_gain_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGainVar", []))

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @jsii.member(jsii_name="resetThreshold")
    def reset_threshold(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThreshold", []))

    @jsii.member(jsii_name="resetThresholdVar")
    def reset_threshold_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThresholdVar", []))

    @builtins.property
    @jsii.member(jsii_name="gainInput")
    def gain_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainInput"))

    @builtins.property
    @jsii.member(jsii_name="gainVarInput")
    def gain_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdInput")
    def threshold_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdVarInput")
    def threshold_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gain")
    def gain(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gain"))

    @gain.setter
    def gain(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0de47355cba13f9667e7f2e4414ea5adc33b784ae400cc6b32543911ccacd6fa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gain", value)

    @builtins.property
    @jsii.member(jsii_name="gainVar")
    def gain_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gainVar"))

    @gain_var.setter
    def gain_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e20628f9d3f840e6bd65d7024c2095a0a332f6bb04228f461ec013faa98f46db)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gainVar", value)

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__335c86a9611ebf3268812f481fb99b2eb22262362c2396f6351163a19eab23d0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2cc2f1468f5786166ccc9cb57b1a0e126b37a466734985c8762250cf98158030)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="threshold")
    def threshold(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "threshold"))

    @threshold.setter
    def threshold(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d32e8bcbf80586c06eab5cb0fb6c784c80c84cd8998e2c235f6eb51811ce6f7b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "threshold", value)

    @builtins.property
    @jsii.member(jsii_name="thresholdVar")
    def threshold_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "thresholdVar"))

    @threshold_var.setter
    def threshold_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1725810d9aa02d0dcdefd52b84654eb42b64dea121bdd109a123399d14888170)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "thresholdVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanUnsharpMask]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanUnsharpMask]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanUnsharpMask]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2049c97ee6bc487af278b9098903abef4dba4b0677d0d039fb953f1ca95c7e49)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__755ffb59665528998b455b91db64a4efce228191bd4a6bc3b96068411634df85)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aa8223432caf97ed0c9228fe59400d5b865c726043b51ea2ddacb9f2b70b6f4a)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__63299e0222639196416b8fdf7eea0fbb8d97e83de7b54ca809dee42f5479c553)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a2623d7abb942f320968b29dd7abe323fd551d3c999ccc7f5559075cbf828f36)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aa3963e79f59247f2875b43f941295ede1a15cf06aad5a1cc9236a2017566b62)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimension]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimension]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9dc91d10af86d5f01b2c1bca6cd1943da4807492145dde7ef715241b953d57d7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f3fd43b1ad191202b4b1fa335bdcc6dedc93fd8ed60db9a9b593d7d946ca0ed3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(
        self,
        *,
        append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultAppend, typing.Dict[builtins.str, typing.Any]]]]] = None,
        aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultAspectCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
        crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultFaceCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultFeatureCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultFitAndFill, typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
        im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultImQuery, typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
        region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultRegionOfInterestCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultRelativeCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
        resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultResize, typing.Dict[builtins.str, typing.Any]]]]] = None,
        rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultRotate, typing.Dict[builtins.str, typing.Any]]]]] = None,
        scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultScale, typing.Dict[builtins.str, typing.Any]]]]] = None,
        shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultShear, typing.Dict[builtins.str, typing.Any]]]]] = None,
        trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultTrim, typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param append: append block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        :param aspect_crop: aspect_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param crop: crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        :param face_crop: face_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        :param feature_crop: feature_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        :param fit_and_fill: fit_and_fill block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param im_query: im_query block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param region_of_interest_crop: region_of_interest_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        :param relative_crop: relative_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param resize: resize block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        :param rotate: rotate block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        :param scale: scale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param shear: shear block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        :param trim: trim block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefault(
            append=append,
            aspect_crop=aspect_crop,
            background_color=background_color,
            blur=blur,
            chroma_key=chroma_key,
            composite=composite,
            compound=compound,
            contrast=contrast,
            crop=crop,
            face_crop=face_crop,
            feature_crop=feature_crop,
            fit_and_fill=fit_and_fill,
            goop=goop,
            grayscale=grayscale,
            hsl=hsl,
            hsv=hsv,
            if_dimension=if_dimension,
            if_orientation=if_orientation,
            im_query=im_query,
            max_colors=max_colors,
            mirror=mirror,
            mono_hue=mono_hue,
            opacity=opacity,
            region_of_interest_crop=region_of_interest_crop,
            relative_crop=relative_crop,
            remove_color=remove_color,
            resize=resize,
            rotate=rotate,
            scale=scale,
            shear=shear,
            trim=trim,
            unsharp_mask=unsharp_mask,
        )

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putEqual")
    def put_equal(
        self,
        *,
        append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualAppend, typing.Dict[builtins.str, typing.Any]]]]] = None,
        aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualAspectCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
        crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualFaceCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualFeatureCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualFitAndFill, typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
        im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualImQuery, typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
        region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualRegionOfInterestCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualRelativeCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
        resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualResize, typing.Dict[builtins.str, typing.Any]]]]] = None,
        rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualRotate, typing.Dict[builtins.str, typing.Any]]]]] = None,
        scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualScale, typing.Dict[builtins.str, typing.Any]]]]] = None,
        shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualShear, typing.Dict[builtins.str, typing.Any]]]]] = None,
        trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualTrim, typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param append: append block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        :param aspect_crop: aspect_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param crop: crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        :param face_crop: face_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        :param feature_crop: feature_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        :param fit_and_fill: fit_and_fill block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param im_query: im_query block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param region_of_interest_crop: region_of_interest_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        :param relative_crop: relative_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param resize: resize block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        :param rotate: rotate block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        :param scale: scale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param shear: shear block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        :param trim: trim block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqual(
            append=append,
            aspect_crop=aspect_crop,
            background_color=background_color,
            blur=blur,
            chroma_key=chroma_key,
            composite=composite,
            compound=compound,
            contrast=contrast,
            crop=crop,
            face_crop=face_crop,
            feature_crop=feature_crop,
            fit_and_fill=fit_and_fill,
            goop=goop,
            grayscale=grayscale,
            hsl=hsl,
            hsv=hsv,
            if_dimension=if_dimension,
            if_orientation=if_orientation,
            im_query=im_query,
            max_colors=max_colors,
            mirror=mirror,
            mono_hue=mono_hue,
            opacity=opacity,
            region_of_interest_crop=region_of_interest_crop,
            relative_crop=relative_crop,
            remove_color=remove_color,
            resize=resize,
            rotate=rotate,
            scale=scale,
            shear=shear,
            trim=trim,
            unsharp_mask=unsharp_mask,
        )

        return typing.cast(None, jsii.invoke(self, "putEqual", [value]))

    @jsii.member(jsii_name="putGreaterThan")
    def put_greater_than(
        self,
        *,
        append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanAppend, typing.Dict[builtins.str, typing.Any]]]]] = None,
        aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanAspectCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
        crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanFaceCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanFeatureCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanFitAndFill, typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
        im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanImQuery, typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
        region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanRegionOfInterestCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanRelativeCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
        resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanResize, typing.Dict[builtins.str, typing.Any]]]]] = None,
        rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanRotate, typing.Dict[builtins.str, typing.Any]]]]] = None,
        scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanScale, typing.Dict[builtins.str, typing.Any]]]]] = None,
        shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanShear, typing.Dict[builtins.str, typing.Any]]]]] = None,
        trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanTrim, typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param append: append block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        :param aspect_crop: aspect_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param crop: crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        :param face_crop: face_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        :param feature_crop: feature_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        :param fit_and_fill: fit_and_fill block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param im_query: im_query block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param region_of_interest_crop: region_of_interest_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        :param relative_crop: relative_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param resize: resize block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        :param rotate: rotate block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        :param scale: scale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param shear: shear block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        :param trim: trim block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThan(
            append=append,
            aspect_crop=aspect_crop,
            background_color=background_color,
            blur=blur,
            chroma_key=chroma_key,
            composite=composite,
            compound=compound,
            contrast=contrast,
            crop=crop,
            face_crop=face_crop,
            feature_crop=feature_crop,
            fit_and_fill=fit_and_fill,
            goop=goop,
            grayscale=grayscale,
            hsl=hsl,
            hsv=hsv,
            if_dimension=if_dimension,
            if_orientation=if_orientation,
            im_query=im_query,
            max_colors=max_colors,
            mirror=mirror,
            mono_hue=mono_hue,
            opacity=opacity,
            region_of_interest_crop=region_of_interest_crop,
            relative_crop=relative_crop,
            remove_color=remove_color,
            resize=resize,
            rotate=rotate,
            scale=scale,
            shear=shear,
            trim=trim,
            unsharp_mask=unsharp_mask,
        )

        return typing.cast(None, jsii.invoke(self, "putGreaterThan", [value]))

    @jsii.member(jsii_name="putLessThan")
    def put_less_than(
        self,
        *,
        append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanAppend, typing.Dict[builtins.str, typing.Any]]]]] = None,
        aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanAspectCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
        crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanFaceCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanFeatureCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanFitAndFill, typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
        im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanImQuery, typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
        region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanRegionOfInterestCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanRelativeCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
        resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanResize, typing.Dict[builtins.str, typing.Any]]]]] = None,
        rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanRotate, typing.Dict[builtins.str, typing.Any]]]]] = None,
        scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanScale, typing.Dict[builtins.str, typing.Any]]]]] = None,
        shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanShear, typing.Dict[builtins.str, typing.Any]]]]] = None,
        trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanTrim, typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param append: append block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        :param aspect_crop: aspect_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param crop: crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        :param face_crop: face_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        :param feature_crop: feature_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        :param fit_and_fill: fit_and_fill block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param im_query: im_query block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param region_of_interest_crop: region_of_interest_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        :param relative_crop: relative_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param resize: resize block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        :param rotate: rotate block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        :param scale: scale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param shear: shear block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        :param trim: trim block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThan(
            append=append,
            aspect_crop=aspect_crop,
            background_color=background_color,
            blur=blur,
            chroma_key=chroma_key,
            composite=composite,
            compound=compound,
            contrast=contrast,
            crop=crop,
            face_crop=face_crop,
            feature_crop=feature_crop,
            fit_and_fill=fit_and_fill,
            goop=goop,
            grayscale=grayscale,
            hsl=hsl,
            hsv=hsv,
            if_dimension=if_dimension,
            if_orientation=if_orientation,
            im_query=im_query,
            max_colors=max_colors,
            mirror=mirror,
            mono_hue=mono_hue,
            opacity=opacity,
            region_of_interest_crop=region_of_interest_crop,
            relative_crop=relative_crop,
            remove_color=remove_color,
            resize=resize,
            rotate=rotate,
            scale=scale,
            shear=shear,
            trim=trim,
            unsharp_mask=unsharp_mask,
        )

        return typing.cast(None, jsii.invoke(self, "putLessThan", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetDimension")
    def reset_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimension", []))

    @jsii.member(jsii_name="resetDimensionVar")
    def reset_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimensionVar", []))

    @jsii.member(jsii_name="resetEqual")
    def reset_equal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEqual", []))

    @jsii.member(jsii_name="resetGreaterThan")
    def reset_greater_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGreaterThan", []))

    @jsii.member(jsii_name="resetLessThan")
    def reset_less_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLessThan", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="equal")
    def equal(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualOutputReference, jsii.get(self, "equal"))

    @builtins.property
    @jsii.member(jsii_name="greaterThan")
    def greater_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanOutputReference, jsii.get(self, "greaterThan"))

    @builtins.property
    @jsii.member(jsii_name="lessThan")
    def less_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanOutputReference, jsii.get(self, "lessThan"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionInput")
    def dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionVarInput")
    def dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="equalInput")
    def equal_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqual], jsii.get(self, "equalInput"))

    @builtins.property
    @jsii.member(jsii_name="greaterThanInput")
    def greater_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThan], jsii.get(self, "greaterThanInput"))

    @builtins.property
    @jsii.member(jsii_name="lessThanInput")
    def less_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThan], jsii.get(self, "lessThanInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="dimension")
    def dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimension"))

    @dimension.setter
    def dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6106b45a5801fe2b2960841cba50834835a78a7ea9deb92fc327d1c3a45666da)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimension", value)

    @builtins.property
    @jsii.member(jsii_name="dimensionVar")
    def dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimensionVar"))

    @dimension_var.setter
    def dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c73420ef320971653163f913f00305a4159354e46fc33b02e957bf8aadf7b76c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5621141cfc839ae40278b5f8fba98caf84bc4a4dd61a2e6d0204a80bc5f6b3e5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__83a56c73eb2623f28c0f818186749246b4e66b4861d73e4654489cda3f64c6de)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimension]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimension]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimension]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fe70f3d0a3d5e2dd0c1ac929cfc589948e085efb3a9c130fbb9693a0320be322)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitImQuery",
    jsii_struct_bases=[],
    name_mapping={
        "allowed_transformations": "allowedTransformations",
        "query_var": "queryVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitImQuery:
    def __init__(
        self,
        *,
        allowed_transformations: typing.Sequence[builtins.str],
        query_var: builtins.str,
    ) -> None:
        '''
        :param allowed_transformations: Specifies the transformations that can be applied using the query string parameter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allowed_transformations DataAkamaiImagingPolicyImage#allowed_transformations}
        :param query_var: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#query_var DataAkamaiImagingPolicyImage#query_var}.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__da8d9e4341b30f44db0f59485ad52e94e6123dac467ff383c57bd511d30abe15)
            check_type(argname="argument allowed_transformations", value=allowed_transformations, expected_type=type_hints["allowed_transformations"])
            check_type(argname="argument query_var", value=query_var, expected_type=type_hints["query_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "allowed_transformations": allowed_transformations,
            "query_var": query_var,
        }

    @builtins.property
    def allowed_transformations(self) -> typing.List[builtins.str]:
        '''Specifies the transformations that can be applied using the query string parameter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allowed_transformations DataAkamaiImagingPolicyImage#allowed_transformations}
        '''
        result = self._values.get("allowed_transformations")
        assert result is not None, "Required property 'allowed_transformations' is missing"
        return typing.cast(typing.List[builtins.str], result)

    @builtins.property
    def query_var(self) -> builtins.str:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#query_var DataAkamaiImagingPolicyImage#query_var}.'''
        result = self._values.get("query_var")
        assert result is not None, "Required property 'query_var' is missing"
        return typing.cast(builtins.str, result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitImQuery(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitImQueryList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitImQueryList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__35007d11b3a050a43c076f035ec97ba5251453a5f34d559b6d4814f380f9e326)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitImQueryOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c839a927451470729e9fc17eacf2db3c2e60f26c9cdd73e170b3df4a932c9eb3)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitImQueryOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e0446090f67d35f0b03724c32f638e94a930504db37c8d83840658e00fa70817)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1275d901e53d4ca02a48233126902c26a6094a018d2fa024e024ffff69b12832)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bda9613131f1706e83c7a4e7e89fd0fe7e8da3df30b692f88fbb2c3a37629c3a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitImQuery]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitImQuery]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitImQuery]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5cae9172127dab6ef5fab2c205bcb656ea041095f1963718178f29863a96425d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitImQueryOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitImQueryOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b01f41c99484418dd9d37b847cf60b18075a71eac8b5d9e17abe1b17c89615b9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @builtins.property
    @jsii.member(jsii_name="allowedTransformationsInput")
    def allowed_transformations_input(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "allowedTransformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="queryVarInput")
    def query_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "queryVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowedTransformations")
    def allowed_transformations(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "allowedTransformations"))

    @allowed_transformations.setter
    def allowed_transformations(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9f518f9d7a20f1f79e460f0fdaefa9db05ccf1f8faba1c9580e2805183763def)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowedTransformations", value)

    @builtins.property
    @jsii.member(jsii_name="queryVar")
    def query_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "queryVar"))

    @query_var.setter
    def query_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f37eed1a9ecce79cd0f63a06c751d4002a1958af7d06a82c6928247063103253)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "queryVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitImQuery]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitImQuery]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitImQuery]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__29634b88a445b57abf5fbc8ecf48fa4ec8857080a53f34b58a529468386af9ac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitMaxColors",
    jsii_struct_bases=[],
    name_mapping={"colors": "colors", "colors_var": "colorsVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitMaxColors:
    def __init__(
        self,
        *,
        colors: typing.Optional[builtins.str] = None,
        colors_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param colors: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        :param colors_var: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a301afa10f1a0e7bc38b4deb411f1a1f22f1451ac443fa5036be056eb3551d1e)
            check_type(argname="argument colors", value=colors, expected_type=type_hints["colors"])
            check_type(argname="argument colors_var", value=colors_var, expected_type=type_hints["colors_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if colors is not None:
            self._values["colors"] = colors
        if colors_var is not None:
            self._values["colors_var"] = colors_var

    @builtins.property
    def colors(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        '''
        result = self._values.get("colors")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def colors_var(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        result = self._values.get("colors_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitMaxColors(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitMaxColorsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitMaxColorsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2cd25141d6efb59a40f7dc5a7898344ce6e7f9500e5e661953a96a6dcd950875)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitMaxColorsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3c8f276c2652a9b93c0df3095720c2cdbff274492d0a1e1528a4fcea8d5daada)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitMaxColorsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__40bc8c149a8caf49f77608fa2f662ec6d30d68b52d28fa4514350029ecfe4cd8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__42a79752fd8f226007818df59b5c7466665cc0cc2370eda55dc98750a01e4405)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bff73485f8ef9b63a16829c05a275f0420ae9f817ba588b1903b58f30c7188d8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitMaxColors]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitMaxColors]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f6f9fcd35a2165055042d77dd0263a87e745b02e8d82627217cc9cd48cef878a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitMaxColorsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitMaxColorsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__535ad115cd1c47aac17c33b55f853c11ce12ae71dbb1894c569cfebf138d0e2f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColors")
    def reset_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColors", []))

    @jsii.member(jsii_name="resetColorsVar")
    def reset_colors_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorsVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorsInput")
    def colors_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsInput"))

    @builtins.property
    @jsii.member(jsii_name="colorsVarInput")
    def colors_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsVarInput"))

    @builtins.property
    @jsii.member(jsii_name="colors")
    def colors(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colors"))

    @colors.setter
    def colors(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac09ae6fb0498bb4da6f08bf83ce11e63b51a13a6b7d9e6a83600c6a36ef871c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colors", value)

    @builtins.property
    @jsii.member(jsii_name="colorsVar")
    def colors_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorsVar"))

    @colors_var.setter
    def colors_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7aa4921a489c4511b6b3bcff8987d487513688f24fc10bdff8f06bf861d4c42f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorsVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitMaxColors]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitMaxColors]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitMaxColors]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a9ecbe030c69f112f123f20a22220773f6f386df88cf198f74cf1c727a922217)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitMirror",
    jsii_struct_bases=[],
    name_mapping={
        "horizontal": "horizontal",
        "horizontal_var": "horizontalVar",
        "vertical": "vertical",
        "vertical_var": "verticalVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitMirror:
    def __init__(
        self,
        *,
        horizontal: typing.Optional[builtins.str] = None,
        horizontal_var: typing.Optional[builtins.str] = None,
        vertical: typing.Optional[builtins.str] = None,
        vertical_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param horizontal: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        :param horizontal_var: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        :param vertical: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        :param vertical_var: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9813e60096a7c7cdb183f2df0322c3cfe1fc6807aa2f484ae5846cf4f3ec36c1)
            check_type(argname="argument horizontal", value=horizontal, expected_type=type_hints["horizontal"])
            check_type(argname="argument horizontal_var", value=horizontal_var, expected_type=type_hints["horizontal_var"])
            check_type(argname="argument vertical", value=vertical, expected_type=type_hints["vertical"])
            check_type(argname="argument vertical_var", value=vertical_var, expected_type=type_hints["vertical_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if horizontal is not None:
            self._values["horizontal"] = horizontal
        if horizontal_var is not None:
            self._values["horizontal_var"] = horizontal_var
        if vertical is not None:
            self._values["vertical"] = vertical
        if vertical_var is not None:
            self._values["vertical_var"] = vertical_var

    @builtins.property
    def horizontal(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        '''
        result = self._values.get("horizontal")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def horizontal_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        '''
        result = self._values.get("horizontal_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        '''
        result = self._values.get("vertical")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        result = self._values.get("vertical_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitMirror(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitMirrorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitMirrorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__caa1f86eff141002dd6ed237f40d05b45a3cd09bb92488db84a08a85cd543816)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitMirrorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b4483f859016185aa33381e8fd757540337ecfd48ea25c2f0c7d948d9634e72a)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitMirrorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__29f4c4e1b049ca7d8619ec0548ab5198d5b6934faf0c72f567bc17943860e3f4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__35d3f3cc6171cce5fc735661d019c1b39aabfc217675f639046a3b028fa205db)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__809e67714e92433b70dca302198b4871d914136d602278fb3192a63c03eedd54)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitMirror]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitMirror]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f78fdf467842299bdb57349cf9c2f022458e79333eff5d24e85e1f9b96430b1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitMirrorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitMirrorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9589c59c3df202fb0228f8f10e69a90f91a5127b65dea1c5857a7f7f92afcee4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHorizontal")
    def reset_horizontal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontal", []))

    @jsii.member(jsii_name="resetHorizontalVar")
    def reset_horizontal_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontalVar", []))

    @jsii.member(jsii_name="resetVertical")
    def reset_vertical(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVertical", []))

    @jsii.member(jsii_name="resetVerticalVar")
    def reset_vertical_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVerticalVar", []))

    @builtins.property
    @jsii.member(jsii_name="horizontalInput")
    def horizontal_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontalVarInput")
    def horizontal_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalInput")
    def vertical_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalVarInput")
    def vertical_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontal")
    def horizontal(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontal"))

    @horizontal.setter
    def horizontal(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0275e07120e3bcb5c1a547b89cb15122f951806e560d0ed8dcf4e1306d355283)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontal", value)

    @builtins.property
    @jsii.member(jsii_name="horizontalVar")
    def horizontal_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontalVar"))

    @horizontal_var.setter
    def horizontal_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__99e60aff92e4d651d2c7ad4919ee0d9067ab86bcc775f7e74c63f686b80cc6b8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontalVar", value)

    @builtins.property
    @jsii.member(jsii_name="vertical")
    def vertical(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "vertical"))

    @vertical.setter
    def vertical(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f2dd267a6dc1f6d5537b4a024f76f3c28cf6a7c9be652a8ba1692b3890912b4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "vertical", value)

    @builtins.property
    @jsii.member(jsii_name="verticalVar")
    def vertical_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "verticalVar"))

    @vertical_var.setter
    def vertical_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5699f5f96b448197069bdbd098fbaf11e4b782ea389dcf2a9fa94ff00be3ea89)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "verticalVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitMirror]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitMirror]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitMirror]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__739da48ccc9f887f70ec75095643a5650529bb616be4f325ca012e02857e1ff1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitMonoHue",
    jsii_struct_bases=[],
    name_mapping={"hue": "hue", "hue_var": "hueVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitMonoHue:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3c1fd31b0d3c6b377a227f2bf0727bdf06f7ab6f2002f26d0f1d2d8bb795cea4)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitMonoHue(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitMonoHueList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitMonoHueList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ad058b744edc08b54adec8096cd7772c0c37572f716c55466c83eec1503910a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitMonoHueOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f3505a2bc93119c88beab417ead19e6cb14b383caecadeccb276c674412f5dba)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitMonoHueOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a1bdd587cc20ada53407798c2b12b982e0bd645d12e53d0cbc830841929b2157)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__44a3da14738e07d53bc5ef62920219cb9fa4f963edadc2506545214a9f0ee077)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5a9a36d0c787b4ad44b27934bbc59679b7884ebe0085a3206cfaca7033cf766f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitMonoHue]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitMonoHue]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__627d3672e68e2321841f8109998d62f0e5fe18652d39bcdd65f7565c0f6592a2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitMonoHueOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitMonoHueOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0f6bb0f259afd8406fee57e743ee0102e86d673639b608eabb4bd1c2436ca0cf)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc5cdeb1e204e2d3f6d9c7eed1912c5927b81a1c989b61d4b9b2e85607f0a42b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__730819a5421a00c4a0c761ef65e09c2432462b82fcedb3a36bf3fc6d1f6a8b27)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitMonoHue]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitMonoHue]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitMonoHue]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8d61aaa52bc4132e520c6cc98d0182626c2cdae3eae2befb27fdab72bd5e1f2e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitOpacity",
    jsii_struct_bases=[],
    name_mapping={"opacity": "opacity", "opacity_var": "opacityVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitOpacity:
    def __init__(
        self,
        *,
        opacity: typing.Optional[builtins.str] = None,
        opacity_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param opacity: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param opacity_var: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__45ca6a25b86032700a959af9c9132106477f75c73955cd92fd29d9768bd0ae1f)
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument opacity_var", value=opacity_var, expected_type=type_hints["opacity_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if opacity is not None:
            self._values["opacity"] = opacity
        if opacity_var is not None:
            self._values["opacity_var"] = opacity_var

    @builtins.property
    def opacity(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def opacity_var(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        result = self._values.get("opacity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitOpacity(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitOpacityList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitOpacityList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c274c363d109445245ce3747ae28c3b49a0fb38f5baa7dd0288732f1115018ae)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitOpacityOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e1b645d6855a7850be89c02c77282e4f3fb7ba8d4d5353867bcf3053e7662d8)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitOpacityOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__278d2b6fa97c6cb717f0bb70b617bc36e890214dd080784fa323866377c1e486)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__74b3ea5b6e3dce44772aef5bf2f7e672703caf7b77c4f4b2eaf81598184c2350)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__897a4fac71f0d3ee38e7256a1800db3d87d0feb63a9d53abd73281257a4a36b0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitOpacity]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitOpacity]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__614ef0ca9f710ddf7358a61cf43e74898c62f8713eeff15d46d4773b50e2aaf5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitOpacityOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitOpacityOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__deee2a652087550e60e938f5fe277f1353b94b432032a33b2893381a4864b0f3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetOpacityVar")
    def reset_opacity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacityVar", []))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityVarInput")
    def opacity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacity"))

    @opacity.setter
    def opacity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fb1a9d08d6f4b4cac732073c034791ce55ed48416d721d2e2a968fc0ce69e13f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacity", value)

    @builtins.property
    @jsii.member(jsii_name="opacityVar")
    def opacity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacityVar"))

    @opacity_var.setter
    def opacity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__319f1414014b5183d584c76fbf1ff63988e99c2485d9862c62553c0e8c26f575)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacityVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitOpacity]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitOpacity]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitOpacity]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ecb760543bf8f4d82c43936f5b3bcb3bad0314b1c49737d6b53363354f07f9bb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__117d1a16ad15219b75582eae91b47885f9cda7e8f900b79b9d07b9a5b4d9f3ba)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putAppend")
    def put_append(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppend, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3013e38bb41f3dce91e0190e7f2c26b6ddefa99c18d58afb927518949b5ad67c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putAppend", [value]))

    @jsii.member(jsii_name="putAspectCrop")
    def put_aspect_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAspectCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__68f62306f1f880ba50e44a12c5902ad314d6007818091144a34dc14cc60f9b49)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putAspectCrop", [value]))

    @jsii.member(jsii_name="putBackgroundColor")
    def put_background_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b75a09cf527f4d11474cd7f4e6a9c43d1c3c7d42e62ef99c45c7ae9d82223964)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBackgroundColor", [value]))

    @jsii.member(jsii_name="putBlur")
    def put_blur(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitBlur, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__26a725a70efa0acc9fb08708f5b9f7ae7cb0e87b556640a827ad9fee038a4165)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBlur", [value]))

    @jsii.member(jsii_name="putChromaKey")
    def put_chroma_key(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitChromaKey, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__18e3795ceb1ec93c2cb059e1fb2e86814c393ab67288dc435cc754d8213a5efe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putChromaKey", [value]))

    @jsii.member(jsii_name="putComposite")
    def put_composite(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitComposite, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fea0e98a1a08ac64891d82806b2972b69f53963c77142013aaec1292475bab87)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putComposite", [value]))

    @jsii.member(jsii_name="putCompound")
    def put_compound(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompound, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__efd7167e06087a949b24b69e0c41dabcf1dcc17dc9fe11205b192307b0b40e67)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCompound", [value]))

    @jsii.member(jsii_name="putContrast")
    def put_contrast(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitContrast, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f7eeeb37475ec0ccd0d7ef3cffcc9cb6aeea00ecf1f84fec2cf825064152906d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putContrast", [value]))

    @jsii.member(jsii_name="putCrop")
    def put_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a74e13a513632f636f039e59b7d178848afdf0a30ddb31cf8ca5a2c465f36a1a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCrop", [value]))

    @jsii.member(jsii_name="putFaceCrop")
    def put_face_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFaceCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4d4a4595d190146715d5633323e9246d83808971dbe8e0bdf64cc5c356c75b58)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFaceCrop", [value]))

    @jsii.member(jsii_name="putFeatureCrop")
    def put_feature_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFeatureCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a44bfa8a22fe5ead2e87aa4691eb65ad98a0decded12531d61d616bb5e20eeb2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFeatureCrop", [value]))

    @jsii.member(jsii_name="putFitAndFill")
    def put_fit_and_fill(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFill, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__613b923d76019b3f578f8dbab249e124385b92563d92439370ee98a1f03562d6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFitAndFill", [value]))

    @jsii.member(jsii_name="putGoop")
    def put_goop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitGoop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d864093f8647c6d3bb6b0f62a6446e9ba727c3ab4460b68d0c6983c424a400c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGoop", [value]))

    @jsii.member(jsii_name="putGrayscale")
    def put_grayscale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitGrayscale, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7e0e210cdb41dcb5714d13538cf4a0f97f286cf443b04f1917c5c7b210fcfb54)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGrayscale", [value]))

    @jsii.member(jsii_name="putHsl")
    def put_hsl(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitHsl, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fc2ffe61728f0b73fbec8398f8bf0a2950ecc5e3558cbbb8f3f231b3d6b4f694)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsl", [value]))

    @jsii.member(jsii_name="putHsv")
    def put_hsv(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitHsv, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e5fde1248db5e29785da7723d9d4c7bbe8000bfc308c93472118d222b0131aaf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsv", [value]))

    @jsii.member(jsii_name="putIfDimension")
    def put_if_dimension(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimension, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6a4981d5e227403e9564c3a830c772a1e58801f44bf0bc34270ab299ea66df10)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfDimension", [value]))

    @jsii.member(jsii_name="putIfOrientation")
    def put_if_orientation(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc3261e45806cf71434a7532347f7c4f86949522475d1977ae8a20c56234477d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfOrientation", [value]))

    @jsii.member(jsii_name="putImQuery")
    def put_im_query(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitImQuery, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6db788d1d1d4cf3253cfa0086169d4cf791dab50c8d4fcf706d21f49521064ff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putImQuery", [value]))

    @jsii.member(jsii_name="putMaxColors")
    def put_max_colors(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitMaxColors, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d9c576ac89e4ed868461e91fd983edccc233f5612e22bc4781928247c01745cd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMaxColors", [value]))

    @jsii.member(jsii_name="putMirror")
    def put_mirror(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitMirror, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e91191d74b4c2f4f6163660a4108db41fce9f881abcc7f721f665353512cc989)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMirror", [value]))

    @jsii.member(jsii_name="putMonoHue")
    def put_mono_hue(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitMonoHue, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ef5b126dfbfbef6c56cf57e26f1238861ef38057e88d0a90afce9b49e639eb39)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMonoHue", [value]))

    @jsii.member(jsii_name="putOpacity")
    def put_opacity(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitOpacity, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__50883701ee25e0d5ceb46886893462d6426ab45280a117aad020e1e988aa6878)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putOpacity", [value]))

    @jsii.member(jsii_name="putRegionOfInterestCrop")
    def put_region_of_interest_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCrop", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4f91b503c1852c8a56c111e998ea1ee6f4e74c65d600823081a03834b89323f7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRegionOfInterestCrop", [value]))

    @jsii.member(jsii_name="putRelativeCrop")
    def put_relative_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRelativeCrop", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__27426a7b23472accbd28051a0e8290b6b5643c11491adff74d23458d8a681d40)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRelativeCrop", [value]))

    @jsii.member(jsii_name="putRemoveColor")
    def put_remove_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRemoveColor", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6134c0a8e6ecde770d81d85d0b2d14593264f29e71844d0ce6e8da2b9e97c77b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRemoveColor", [value]))

    @jsii.member(jsii_name="putResize")
    def put_resize(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitResize", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a0495a1e46a637b7a1161ce9f676081afb31d0f8bd9d9071948462a38626f2b0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putResize", [value]))

    @jsii.member(jsii_name="putRotate")
    def put_rotate(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRotate", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6392ab12774aa42968d39852d873b8b2268029647b6de18ae94c18a53eca56a0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRotate", [value]))

    @jsii.member(jsii_name="putScale")
    def put_scale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitScale", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ed6e52f76eb0f6d30d387b6f6a6f6331d7cc725a58c91d972b2a92c33769c656)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putScale", [value]))

    @jsii.member(jsii_name="putShear")
    def put_shear(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitShear", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8c9bd25b1761dbf93ab271608a3aca17c175ac1ea6eb450c5100b82bbb303b7c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putShear", [value]))

    @jsii.member(jsii_name="putTrim")
    def put_trim(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitTrim", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__269b4d928f39fe176d6985995415e80f4e27ed89544fbdd9531ccec79b940e4f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTrim", [value]))

    @jsii.member(jsii_name="putUnsharpMask")
    def put_unsharp_mask(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitUnsharpMask", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__45efe98620ebff6e8021d758db2f2f041a9cae9f2f9da4748016d255b948ceab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putUnsharpMask", [value]))

    @jsii.member(jsii_name="resetAppend")
    def reset_append(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAppend", []))

    @jsii.member(jsii_name="resetAspectCrop")
    def reset_aspect_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspectCrop", []))

    @jsii.member(jsii_name="resetBackgroundColor")
    def reset_background_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBackgroundColor", []))

    @jsii.member(jsii_name="resetBlur")
    def reset_blur(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBlur", []))

    @jsii.member(jsii_name="resetChromaKey")
    def reset_chroma_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChromaKey", []))

    @jsii.member(jsii_name="resetComposite")
    def reset_composite(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetComposite", []))

    @jsii.member(jsii_name="resetCompound")
    def reset_compound(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCompound", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetCrop")
    def reset_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCrop", []))

    @jsii.member(jsii_name="resetFaceCrop")
    def reset_face_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFaceCrop", []))

    @jsii.member(jsii_name="resetFeatureCrop")
    def reset_feature_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureCrop", []))

    @jsii.member(jsii_name="resetFitAndFill")
    def reset_fit_and_fill(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFitAndFill", []))

    @jsii.member(jsii_name="resetGoop")
    def reset_goop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGoop", []))

    @jsii.member(jsii_name="resetGrayscale")
    def reset_grayscale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGrayscale", []))

    @jsii.member(jsii_name="resetHsl")
    def reset_hsl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsl", []))

    @jsii.member(jsii_name="resetHsv")
    def reset_hsv(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsv", []))

    @jsii.member(jsii_name="resetIfDimension")
    def reset_if_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfDimension", []))

    @jsii.member(jsii_name="resetIfOrientation")
    def reset_if_orientation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfOrientation", []))

    @jsii.member(jsii_name="resetImQuery")
    def reset_im_query(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetImQuery", []))

    @jsii.member(jsii_name="resetMaxColors")
    def reset_max_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxColors", []))

    @jsii.member(jsii_name="resetMirror")
    def reset_mirror(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMirror", []))

    @jsii.member(jsii_name="resetMonoHue")
    def reset_mono_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonoHue", []))

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetRegionOfInterestCrop")
    def reset_region_of_interest_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRegionOfInterestCrop", []))

    @jsii.member(jsii_name="resetRelativeCrop")
    def reset_relative_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRelativeCrop", []))

    @jsii.member(jsii_name="resetRemoveColor")
    def reset_remove_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRemoveColor", []))

    @jsii.member(jsii_name="resetResize")
    def reset_resize(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetResize", []))

    @jsii.member(jsii_name="resetRotate")
    def reset_rotate(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRotate", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetShear")
    def reset_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetShear", []))

    @jsii.member(jsii_name="resetTrim")
    def reset_trim(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTrim", []))

    @jsii.member(jsii_name="resetUnsharpMask")
    def reset_unsharp_mask(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUnsharpMask", []))

    @builtins.property
    @jsii.member(jsii_name="append")
    def append(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendList, jsii.get(self, "append"))

    @builtins.property
    @jsii.member(jsii_name="aspectCrop")
    def aspect_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAspectCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAspectCropList, jsii.get(self, "aspectCrop"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColor")
    def background_color(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitBackgroundColorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitBackgroundColorList, jsii.get(self, "backgroundColor"))

    @builtins.property
    @jsii.member(jsii_name="blur")
    def blur(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitBlurList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitBlurList, jsii.get(self, "blur"))

    @builtins.property
    @jsii.member(jsii_name="chromaKey")
    def chroma_key(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitChromaKeyList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitChromaKeyList, jsii.get(self, "chromaKey"))

    @builtins.property
    @jsii.member(jsii_name="composite")
    def composite(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeList, jsii.get(self, "composite"))

    @builtins.property
    @jsii.member(jsii_name="compound")
    def compound(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompoundList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompoundList, jsii.get(self, "compound"))

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitContrastList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitContrastList, jsii.get(self, "contrast"))

    @builtins.property
    @jsii.member(jsii_name="crop")
    def crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCropList, jsii.get(self, "crop"))

    @builtins.property
    @jsii.member(jsii_name="faceCrop")
    def face_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFaceCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFaceCropList, jsii.get(self, "faceCrop"))

    @builtins.property
    @jsii.member(jsii_name="featureCrop")
    def feature_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFeatureCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFeatureCropList, jsii.get(self, "featureCrop"))

    @builtins.property
    @jsii.member(jsii_name="fitAndFill")
    def fit_and_fill(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillList, jsii.get(self, "fitAndFill"))

    @builtins.property
    @jsii.member(jsii_name="goop")
    def goop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitGoopList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitGoopList, jsii.get(self, "goop"))

    @builtins.property
    @jsii.member(jsii_name="grayscale")
    def grayscale(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitGrayscaleList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitGrayscaleList, jsii.get(self, "grayscale"))

    @builtins.property
    @jsii.member(jsii_name="hsl")
    def hsl(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitHslList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitHslList, jsii.get(self, "hsl"))

    @builtins.property
    @jsii.member(jsii_name="hsv")
    def hsv(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitHsvList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitHsvList, jsii.get(self, "hsv"))

    @builtins.property
    @jsii.member(jsii_name="ifDimension")
    def if_dimension(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionList, jsii.get(self, "ifDimension"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientation")
    def if_orientation(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationList, jsii.get(self, "ifOrientation"))

    @builtins.property
    @jsii.member(jsii_name="imQuery")
    def im_query(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitImQueryList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitImQueryList, jsii.get(self, "imQuery"))

    @builtins.property
    @jsii.member(jsii_name="maxColors")
    def max_colors(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitMaxColorsList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitMaxColorsList, jsii.get(self, "maxColors"))

    @builtins.property
    @jsii.member(jsii_name="mirror")
    def mirror(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitMirrorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitMirrorList, jsii.get(self, "mirror"))

    @builtins.property
    @jsii.member(jsii_name="monoHue")
    def mono_hue(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitMonoHueList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitMonoHueList, jsii.get(self, "monoHue"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitOpacityList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitOpacityList, jsii.get(self, "opacity"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestCrop")
    def region_of_interest_crop(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropList", jsii.get(self, "regionOfInterestCrop"))

    @builtins.property
    @jsii.member(jsii_name="relativeCrop")
    def relative_crop(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRelativeCropList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRelativeCropList", jsii.get(self, "relativeCrop"))

    @builtins.property
    @jsii.member(jsii_name="removeColor")
    def remove_color(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRemoveColorList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRemoveColorList", jsii.get(self, "removeColor"))

    @builtins.property
    @jsii.member(jsii_name="resize")
    def resize(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitResizeList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitResizeList", jsii.get(self, "resize"))

    @builtins.property
    @jsii.member(jsii_name="rotate")
    def rotate(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRotateList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRotateList", jsii.get(self, "rotate"))

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitScaleList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitScaleList", jsii.get(self, "scale"))

    @builtins.property
    @jsii.member(jsii_name="shear")
    def shear(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitShearList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitShearList", jsii.get(self, "shear"))

    @builtins.property
    @jsii.member(jsii_name="trim")
    def trim(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitTrimList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitTrimList", jsii.get(self, "trim"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMask")
    def unsharp_mask(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitUnsharpMaskList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitUnsharpMaskList", jsii.get(self, "unsharpMask"))

    @builtins.property
    @jsii.member(jsii_name="appendInput")
    def append_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppend]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppend]]], jsii.get(self, "appendInput"))

    @builtins.property
    @jsii.member(jsii_name="aspectCropInput")
    def aspect_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAspectCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAspectCrop]]], jsii.get(self, "aspectCropInput"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColorInput")
    def background_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitBackgroundColor]]], jsii.get(self, "backgroundColorInput"))

    @builtins.property
    @jsii.member(jsii_name="blurInput")
    def blur_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitBlur]]], jsii.get(self, "blurInput"))

    @builtins.property
    @jsii.member(jsii_name="chromaKeyInput")
    def chroma_key_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitChromaKey]]], jsii.get(self, "chromaKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="compositeInput")
    def composite_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitComposite]]], jsii.get(self, "compositeInput"))

    @builtins.property
    @jsii.member(jsii_name="compoundInput")
    def compound_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompound]]], jsii.get(self, "compoundInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitContrast]]], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="cropInput")
    def crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCrop]]], jsii.get(self, "cropInput"))

    @builtins.property
    @jsii.member(jsii_name="faceCropInput")
    def face_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFaceCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFaceCrop]]], jsii.get(self, "faceCropInput"))

    @builtins.property
    @jsii.member(jsii_name="featureCropInput")
    def feature_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFeatureCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFeatureCrop]]], jsii.get(self, "featureCropInput"))

    @builtins.property
    @jsii.member(jsii_name="fitAndFillInput")
    def fit_and_fill_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFill]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFill]]], jsii.get(self, "fitAndFillInput"))

    @builtins.property
    @jsii.member(jsii_name="goopInput")
    def goop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitGoop]]], jsii.get(self, "goopInput"))

    @builtins.property
    @jsii.member(jsii_name="grayscaleInput")
    def grayscale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitGrayscale]]], jsii.get(self, "grayscaleInput"))

    @builtins.property
    @jsii.member(jsii_name="hslInput")
    def hsl_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitHsl]]], jsii.get(self, "hslInput"))

    @builtins.property
    @jsii.member(jsii_name="hsvInput")
    def hsv_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitHsv]]], jsii.get(self, "hsvInput"))

    @builtins.property
    @jsii.member(jsii_name="ifDimensionInput")
    def if_dimension_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimension]]], jsii.get(self, "ifDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientationInput")
    def if_orientation_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientation]]], jsii.get(self, "ifOrientationInput"))

    @builtins.property
    @jsii.member(jsii_name="imQueryInput")
    def im_query_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitImQuery]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitImQuery]]], jsii.get(self, "imQueryInput"))

    @builtins.property
    @jsii.member(jsii_name="maxColorsInput")
    def max_colors_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitMaxColors]]], jsii.get(self, "maxColorsInput"))

    @builtins.property
    @jsii.member(jsii_name="mirrorInput")
    def mirror_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitMirror]]], jsii.get(self, "mirrorInput"))

    @builtins.property
    @jsii.member(jsii_name="monoHueInput")
    def mono_hue_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitMonoHue]]], jsii.get(self, "monoHueInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitOpacity]]], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestCropInput")
    def region_of_interest_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCrop"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCrop"]]], jsii.get(self, "regionOfInterestCropInput"))

    @builtins.property
    @jsii.member(jsii_name="relativeCropInput")
    def relative_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRelativeCrop"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRelativeCrop"]]], jsii.get(self, "relativeCropInput"))

    @builtins.property
    @jsii.member(jsii_name="removeColorInput")
    def remove_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRemoveColor"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRemoveColor"]]], jsii.get(self, "removeColorInput"))

    @builtins.property
    @jsii.member(jsii_name="resizeInput")
    def resize_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitResize"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitResize"]]], jsii.get(self, "resizeInput"))

    @builtins.property
    @jsii.member(jsii_name="rotateInput")
    def rotate_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRotate"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRotate"]]], jsii.get(self, "rotateInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitScale"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitScale"]]], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="shearInput")
    def shear_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitShear"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitShear"]]], jsii.get(self, "shearInput"))

    @builtins.property
    @jsii.member(jsii_name="trimInput")
    def trim_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitTrim"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitTrim"]]], jsii.get(self, "trimInput"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMaskInput")
    def unsharp_mask_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitUnsharpMask"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitUnsharpMask"]]], jsii.get(self, "unsharpMaskInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortrait]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortrait], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortrait],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__de35b7898e53e1d99aeb6d4cd09c80e440149fd2e0b19f4e97e9df340cb72d6e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCrop",
    jsii_struct_bases=[],
    name_mapping={
        "region_of_interest": "regionOfInterest",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCrop:
    def __init__(
        self,
        *,
        region_of_interest: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterest", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param region_of_interest: region_of_interest block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest DataAkamaiImagingPolicyImage#region_of_interest}
        :param gravity: The placement of the crop area relative to the specified area of interest. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: The placement of the crop area relative to the specified area of interest. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param style: Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(region_of_interest, dict):
            region_of_interest = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterest(**region_of_interest)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1edcc674d427331180328751c491e68a77cddb49abe533488a3f3281e328236f)
            check_type(argname="argument region_of_interest", value=region_of_interest, expected_type=type_hints["region_of_interest"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "region_of_interest": region_of_interest,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def region_of_interest(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterest":
        '''region_of_interest block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest DataAkamaiImagingPolicyImage#region_of_interest}
        '''
        result = self._values.get("region_of_interest")
        assert result is not None, "Required property 'region_of_interest' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterest", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''The placement of the crop area relative to the specified area of interest.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''The placement of the crop area relative to the specified area of interest.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1987887530bfd05096df5f73533daac539e67b12526b1752b279fff3262f5181)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a5f70f8d07dae0dd73194edb92268af22ed5dbf6f49f29cf09b97bd338f5b5b8)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c89c1e0b164a115b54b86c1a5c0978656fdcbadec702452d3cf2822e773fc829)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__242cc1cde590c11c9fe55fe1eb6ff2e99d64e4504f36f8884b9a85d79d29a83f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2bdf8d922c2783383bdd0d4298995f1793dd11610052d18cc46d48ff77e48c81)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a452dfadb597ff060605d375cba7a168a7bd55a4324193916e4fb0c7fe3edd25)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4e9c4049792cc460b15761e6731d1dbf3ca2477433185838b35440dc0f899188)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putRegionOfInterest")
    def put_region_of_interest(
        self,
        *,
        circle_shape: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestCircleShape", typing.Dict[builtins.str, typing.Any]]]]] = None,
        point_shape: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestPointShape", typing.Dict[builtins.str, typing.Any]]]]] = None,
        polygon_shape: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestPolygonShape", typing.Dict[builtins.str, typing.Any]]]]] = None,
        rectangle_shape: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestRectangleShape", typing.Dict[builtins.str, typing.Any]]]]] = None,
        union_shape: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestUnionShape", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param circle_shape: circle_shape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#circle_shape DataAkamaiImagingPolicyImage#circle_shape}
        :param point_shape: point_shape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#point_shape DataAkamaiImagingPolicyImage#point_shape}
        :param polygon_shape: polygon_shape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#polygon_shape DataAkamaiImagingPolicyImage#polygon_shape}
        :param rectangle_shape: rectangle_shape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rectangle_shape DataAkamaiImagingPolicyImage#rectangle_shape}
        :param union_shape: union_shape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#union_shape DataAkamaiImagingPolicyImage#union_shape}
        '''
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterest(
            circle_shape=circle_shape,
            point_shape=point_shape,
            polygon_shape=polygon_shape,
            rectangle_shape=rectangle_shape,
            union_shape=union_shape,
        )

        return typing.cast(None, jsii.invoke(self, "putRegionOfInterest", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterest")
    def region_of_interest(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestOutputReference", jsii.get(self, "regionOfInterest"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestInput")
    def region_of_interest_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterest"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterest"], jsii.get(self, "regionOfInterestInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a26ee0f25613a140da1f477e190eaafa0c6b920cbce1af2f3b25b5386daca99)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c18e0f531b63f0894752aade79294dcc469ba98772d35b46d629136514d095ac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3f84c28a3bc20ebf808086bc9d438e73904859826866f5de58dddb444bd83679)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__46c6cba081aae7bbdf8ce5135e23509398c4aefc8020c7bb4cbde89fd30140ff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__727e29fad17ab44ad2d1ba40a070d48d5d3bf1e97a7936637d745bee7f0ffbfe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1e196812b77bdfefcbb2e98f71cd17aed1ef71766b53a1d2d91a945973dffd21)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c42911f58354542e3ff1632228ef5a76a2c8215365592200b4c890a91c0e6040)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c9a012c53daba3ff3fac5a7cea8c2e4bc5304974228fefc199104fe4bfd8bbcd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__01b0fb4b73d171c3b510551613bfffde24d6950e88c734e79a1c236c02946d06)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterest",
    jsii_struct_bases=[],
    name_mapping={
        "circle_shape": "circleShape",
        "point_shape": "pointShape",
        "polygon_shape": "polygonShape",
        "rectangle_shape": "rectangleShape",
        "union_shape": "unionShape",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterest:
    def __init__(
        self,
        *,
        circle_shape: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestCircleShape", typing.Dict[builtins.str, typing.Any]]]]] = None,
        point_shape: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestPointShape", typing.Dict[builtins.str, typing.Any]]]]] = None,
        polygon_shape: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestPolygonShape", typing.Dict[builtins.str, typing.Any]]]]] = None,
        rectangle_shape: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestRectangleShape", typing.Dict[builtins.str, typing.Any]]]]] = None,
        union_shape: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestUnionShape", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param circle_shape: circle_shape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#circle_shape DataAkamaiImagingPolicyImage#circle_shape}
        :param point_shape: point_shape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#point_shape DataAkamaiImagingPolicyImage#point_shape}
        :param polygon_shape: polygon_shape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#polygon_shape DataAkamaiImagingPolicyImage#polygon_shape}
        :param rectangle_shape: rectangle_shape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rectangle_shape DataAkamaiImagingPolicyImage#rectangle_shape}
        :param union_shape: union_shape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#union_shape DataAkamaiImagingPolicyImage#union_shape}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5112cabbcf1dcf2c93b527040fde8f60c8e6107d235e73fef4cc31820af01671)
            check_type(argname="argument circle_shape", value=circle_shape, expected_type=type_hints["circle_shape"])
            check_type(argname="argument point_shape", value=point_shape, expected_type=type_hints["point_shape"])
            check_type(argname="argument polygon_shape", value=polygon_shape, expected_type=type_hints["polygon_shape"])
            check_type(argname="argument rectangle_shape", value=rectangle_shape, expected_type=type_hints["rectangle_shape"])
            check_type(argname="argument union_shape", value=union_shape, expected_type=type_hints["union_shape"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if circle_shape is not None:
            self._values["circle_shape"] = circle_shape
        if point_shape is not None:
            self._values["point_shape"] = point_shape
        if polygon_shape is not None:
            self._values["polygon_shape"] = polygon_shape
        if rectangle_shape is not None:
            self._values["rectangle_shape"] = rectangle_shape
        if union_shape is not None:
            self._values["union_shape"] = union_shape

    @builtins.property
    def circle_shape(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestCircleShape"]]]:
        '''circle_shape block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#circle_shape DataAkamaiImagingPolicyImage#circle_shape}
        '''
        result = self._values.get("circle_shape")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestCircleShape"]]], result)

    @builtins.property
    def point_shape(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestPointShape"]]]:
        '''point_shape block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#point_shape DataAkamaiImagingPolicyImage#point_shape}
        '''
        result = self._values.get("point_shape")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestPointShape"]]], result)

    @builtins.property
    def polygon_shape(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestPolygonShape"]]]:
        '''polygon_shape block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#polygon_shape DataAkamaiImagingPolicyImage#polygon_shape}
        '''
        result = self._values.get("polygon_shape")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestPolygonShape"]]], result)

    @builtins.property
    def rectangle_shape(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestRectangleShape"]]]:
        '''rectangle_shape block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rectangle_shape DataAkamaiImagingPolicyImage#rectangle_shape}
        '''
        result = self._values.get("rectangle_shape")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestRectangleShape"]]], result)

    @builtins.property
    def union_shape(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestUnionShape"]]]:
        '''union_shape block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#union_shape DataAkamaiImagingPolicyImage#union_shape}
        '''
        result = self._values.get("union_shape")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestUnionShape"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterest(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestCircleShape",
    jsii_struct_bases=[],
    name_mapping={"center": "center", "radius": "radius", "radius_var": "radiusVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestCircleShape:
    def __init__(
        self,
        *,
        center: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestCircleShapeCenter", typing.Dict[builtins.str, typing.Any]],
        radius: typing.Optional[builtins.str] = None,
        radius_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param center: center block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#center DataAkamaiImagingPolicyImage#center}
        :param radius: The radius of the circle measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#radius DataAkamaiImagingPolicyImage#radius}
        :param radius_var: The radius of the circle measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#radius_var DataAkamaiImagingPolicyImage#radius_var}
        '''
        if isinstance(center, dict):
            center = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestCircleShapeCenter(**center)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c4e251d7a121789788774c18b38bded51bb56116d6ac949cd1c531b0523b9861)
            check_type(argname="argument center", value=center, expected_type=type_hints["center"])
            check_type(argname="argument radius", value=radius, expected_type=type_hints["radius"])
            check_type(argname="argument radius_var", value=radius_var, expected_type=type_hints["radius_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "center": center,
        }
        if radius is not None:
            self._values["radius"] = radius
        if radius_var is not None:
            self._values["radius_var"] = radius_var

    @builtins.property
    def center(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestCircleShapeCenter":
        '''center block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#center DataAkamaiImagingPolicyImage#center}
        '''
        result = self._values.get("center")
        assert result is not None, "Required property 'center' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestCircleShapeCenter", result)

    @builtins.property
    def radius(self) -> typing.Optional[builtins.str]:
        '''The radius of the circle measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#radius DataAkamaiImagingPolicyImage#radius}
        '''
        result = self._values.get("radius")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def radius_var(self) -> typing.Optional[builtins.str]:
        '''The radius of the circle measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#radius_var DataAkamaiImagingPolicyImage#radius_var}
        '''
        result = self._values.get("radius_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestCircleShape(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestCircleShapeCenter",
    jsii_struct_bases=[],
    name_mapping={"x": "x", "x_var": "xVar", "y": "y", "y_var": "yVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestCircleShapeCenter:
    def __init__(
        self,
        *,
        x: typing.Optional[builtins.str] = None,
        x_var: typing.Optional[builtins.str] = None,
        y: typing.Optional[builtins.str] = None,
        y_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param x: The horizontal position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x DataAkamaiImagingPolicyImage#x}
        :param x_var: The horizontal position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_var DataAkamaiImagingPolicyImage#x_var}
        :param y: The vertical position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y DataAkamaiImagingPolicyImage#y}
        :param y_var: The vertical position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_var DataAkamaiImagingPolicyImage#y_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__93145c1857c161a9df3fea39aae865a2f2ef729f0b8d33a0c7a07d2344afb753)
            check_type(argname="argument x", value=x, expected_type=type_hints["x"])
            check_type(argname="argument x_var", value=x_var, expected_type=type_hints["x_var"])
            check_type(argname="argument y", value=y, expected_type=type_hints["y"])
            check_type(argname="argument y_var", value=y_var, expected_type=type_hints["y_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if x is not None:
            self._values["x"] = x
        if x_var is not None:
            self._values["x_var"] = x_var
        if y is not None:
            self._values["y"] = y
        if y_var is not None:
            self._values["y_var"] = y_var

    @builtins.property
    def x(self) -> typing.Optional[builtins.str]:
        '''The horizontal position of the point, measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x DataAkamaiImagingPolicyImage#x}
        '''
        result = self._values.get("x")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_var(self) -> typing.Optional[builtins.str]:
        '''The horizontal position of the point, measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_var DataAkamaiImagingPolicyImage#x_var}
        '''
        result = self._values.get("x_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y(self) -> typing.Optional[builtins.str]:
        '''The vertical position of the point, measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y DataAkamaiImagingPolicyImage#y}
        '''
        result = self._values.get("y")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_var(self) -> typing.Optional[builtins.str]:
        '''The vertical position of the point, measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_var DataAkamaiImagingPolicyImage#y_var}
        '''
        result = self._values.get("y_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestCircleShapeCenter(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestCircleShapeCenterOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestCircleShapeCenterOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7581b56468af770408a97f28116c232f8b3394253392d257861e9f52676b10cd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetX")
    def reset_x(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetX", []))

    @jsii.member(jsii_name="resetXVar")
    def reset_x_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXVar", []))

    @jsii.member(jsii_name="resetY")
    def reset_y(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetY", []))

    @jsii.member(jsii_name="resetYVar")
    def reset_y_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYVar", []))

    @builtins.property
    @jsii.member(jsii_name="xInput")
    def x_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xInput"))

    @builtins.property
    @jsii.member(jsii_name="xVarInput")
    def x_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yInput")
    def y_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yInput"))

    @builtins.property
    @jsii.member(jsii_name="yVarInput")
    def y_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yVarInput"))

    @builtins.property
    @jsii.member(jsii_name="x")
    def x(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "x"))

    @x.setter
    def x(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4431eba3d3fd680b72ff5b918d008e6c0dcba970d3178418ec9b6064e53f6935)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "x", value)

    @builtins.property
    @jsii.member(jsii_name="xVar")
    def x_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xVar"))

    @x_var.setter
    def x_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c03701480c59c6e12e84743c53640b852842a44f2f2c161f251b0d923bc3e7cd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xVar", value)

    @builtins.property
    @jsii.member(jsii_name="y")
    def y(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "y"))

    @y.setter
    def y(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8988064b0b492e9c71e9dd96c2687f4b7236ab17543fc5d23baa987ce616fe32)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "y", value)

    @builtins.property
    @jsii.member(jsii_name="yVar")
    def y_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yVar"))

    @y_var.setter
    def y_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5d136ec2cb0d29fe2c0341486ec17b3016274973c087b54437849872a739c849)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestCircleShapeCenter]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestCircleShapeCenter], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestCircleShapeCenter],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d0d66122dedf9a85cffcc565e76475b3c18a7f1a478ad24d8e9f50956f230e9f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestCircleShapeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestCircleShapeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2c2be058714ecb25da877d78352f8d73340a9ae52cd227e319d51a9d383a779a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestCircleShapeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d9c16f4ba3c35142dc0288c0afad96ce6e3428a738c32554affbdaa39d85d535)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestCircleShapeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8cd442fce42a7f5150eb5dbc43edf35250275d6441525b924e38341a16632e66)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bf8e49b7a83cc74a5fffccc70615603e2b2c7ccb338f616562b4bc3c5eb0745a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1189173dafcdfb7cc6b9c648898ba8474e1a9de5bccda622da65a2b7015d91dc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestCircleShape]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestCircleShape]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestCircleShape]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__362e3a15a8ab758b118ab3f5e40204897ddd5b48974d0216ba2ab371cb2a9a18)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestCircleShapeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestCircleShapeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d3d71dfafa241a5a1c5f5bdd907e558f3c521f305a57dbfc806620005fc36bc)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putCenter")
    def put_center(
        self,
        *,
        x: typing.Optional[builtins.str] = None,
        x_var: typing.Optional[builtins.str] = None,
        y: typing.Optional[builtins.str] = None,
        y_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param x: The horizontal position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x DataAkamaiImagingPolicyImage#x}
        :param x_var: The horizontal position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_var DataAkamaiImagingPolicyImage#x_var}
        :param y: The vertical position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y DataAkamaiImagingPolicyImage#y}
        :param y_var: The vertical position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_var DataAkamaiImagingPolicyImage#y_var}
        '''
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestCircleShapeCenter(
            x=x, x_var=x_var, y=y, y_var=y_var
        )

        return typing.cast(None, jsii.invoke(self, "putCenter", [value]))

    @jsii.member(jsii_name="resetRadius")
    def reset_radius(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRadius", []))

    @jsii.member(jsii_name="resetRadiusVar")
    def reset_radius_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRadiusVar", []))

    @builtins.property
    @jsii.member(jsii_name="center")
    def center(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestCircleShapeCenterOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestCircleShapeCenterOutputReference, jsii.get(self, "center"))

    @builtins.property
    @jsii.member(jsii_name="centerInput")
    def center_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestCircleShapeCenter]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestCircleShapeCenter], jsii.get(self, "centerInput"))

    @builtins.property
    @jsii.member(jsii_name="radiusInput")
    def radius_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "radiusInput"))

    @builtins.property
    @jsii.member(jsii_name="radiusVarInput")
    def radius_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "radiusVarInput"))

    @builtins.property
    @jsii.member(jsii_name="radius")
    def radius(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "radius"))

    @radius.setter
    def radius(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1eb5c4595eef714c5af3dd9daa9f9250a9f140bd47acc8232a055bf49e5a9f8a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "radius", value)

    @builtins.property
    @jsii.member(jsii_name="radiusVar")
    def radius_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "radiusVar"))

    @radius_var.setter
    def radius_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__40d2ca0e8d536aa0bbff51ca1343401755b811dd9b42b9e189919fa00fb21c36)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "radiusVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestCircleShape]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestCircleShape]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestCircleShape]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6538eb7f0700719b726cb192971d9706842cca2fcf1b709ac2237ae5b14ce34d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac2e4e8717f99ed2dfc72a95605eb6771d07c0e878835a9a63d33a719094b51f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putCircleShape")
    def put_circle_shape(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestCircleShape, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8bf195b961460a9183249cc78e49e151097a154a421ee405332b70aa082a9fe3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCircleShape", [value]))

    @jsii.member(jsii_name="putPointShape")
    def put_point_shape(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestPointShape", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__38397026d0225e746531e28c5362bf6715ed494766252f62ca890df342fc0d70)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putPointShape", [value]))

    @jsii.member(jsii_name="putPolygonShape")
    def put_polygon_shape(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestPolygonShape", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7153f04b87ce4ee8233cb85d4cbe6b01ce6b34f087909d2375da12c274619ad9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putPolygonShape", [value]))

    @jsii.member(jsii_name="putRectangleShape")
    def put_rectangle_shape(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestRectangleShape", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__507811c8180a6083b7de57bed3263692e52381e0b5866cc990c13cf0c6ee9c96)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRectangleShape", [value]))

    @jsii.member(jsii_name="putUnionShape")
    def put_union_shape(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestUnionShape", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9eb1ebbed46102e7bb11a6a02dd9aaeb9eb58fcda7e843b0a5e9ec7add1e6085)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putUnionShape", [value]))

    @jsii.member(jsii_name="resetCircleShape")
    def reset_circle_shape(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCircleShape", []))

    @jsii.member(jsii_name="resetPointShape")
    def reset_point_shape(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPointShape", []))

    @jsii.member(jsii_name="resetPolygonShape")
    def reset_polygon_shape(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPolygonShape", []))

    @jsii.member(jsii_name="resetRectangleShape")
    def reset_rectangle_shape(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRectangleShape", []))

    @jsii.member(jsii_name="resetUnionShape")
    def reset_union_shape(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUnionShape", []))

    @builtins.property
    @jsii.member(jsii_name="circleShape")
    def circle_shape(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestCircleShapeList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestCircleShapeList, jsii.get(self, "circleShape"))

    @builtins.property
    @jsii.member(jsii_name="pointShape")
    def point_shape(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestPointShapeList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestPointShapeList", jsii.get(self, "pointShape"))

    @builtins.property
    @jsii.member(jsii_name="polygonShape")
    def polygon_shape(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestPolygonShapeList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestPolygonShapeList", jsii.get(self, "polygonShape"))

    @builtins.property
    @jsii.member(jsii_name="rectangleShape")
    def rectangle_shape(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestRectangleShapeList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestRectangleShapeList", jsii.get(self, "rectangleShape"))

    @builtins.property
    @jsii.member(jsii_name="unionShape")
    def union_shape(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestUnionShapeList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestUnionShapeList", jsii.get(self, "unionShape"))

    @builtins.property
    @jsii.member(jsii_name="circleShapeInput")
    def circle_shape_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestCircleShape]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestCircleShape]]], jsii.get(self, "circleShapeInput"))

    @builtins.property
    @jsii.member(jsii_name="pointShapeInput")
    def point_shape_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestPointShape"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestPointShape"]]], jsii.get(self, "pointShapeInput"))

    @builtins.property
    @jsii.member(jsii_name="polygonShapeInput")
    def polygon_shape_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestPolygonShape"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestPolygonShape"]]], jsii.get(self, "polygonShapeInput"))

    @builtins.property
    @jsii.member(jsii_name="rectangleShapeInput")
    def rectangle_shape_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestRectangleShape"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestRectangleShape"]]], jsii.get(self, "rectangleShapeInput"))

    @builtins.property
    @jsii.member(jsii_name="unionShapeInput")
    def union_shape_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestUnionShape"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestUnionShape"]]], jsii.get(self, "unionShapeInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterest]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterest], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterest],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3d61785af05e403b176cbc4f08ee85d0f9ecc5a8d1ed7aed36ab14685c53729d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestPointShape",
    jsii_struct_bases=[],
    name_mapping={"x": "x", "x_var": "xVar", "y": "y", "y_var": "yVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestPointShape:
    def __init__(
        self,
        *,
        x: typing.Optional[builtins.str] = None,
        x_var: typing.Optional[builtins.str] = None,
        y: typing.Optional[builtins.str] = None,
        y_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param x: The horizontal position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x DataAkamaiImagingPolicyImage#x}
        :param x_var: The horizontal position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_var DataAkamaiImagingPolicyImage#x_var}
        :param y: The vertical position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y DataAkamaiImagingPolicyImage#y}
        :param y_var: The vertical position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_var DataAkamaiImagingPolicyImage#y_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__82ebef4d676090bb7e47ee021e59ea3a4d056ce447c20d068f9471bf580d8a2b)
            check_type(argname="argument x", value=x, expected_type=type_hints["x"])
            check_type(argname="argument x_var", value=x_var, expected_type=type_hints["x_var"])
            check_type(argname="argument y", value=y, expected_type=type_hints["y"])
            check_type(argname="argument y_var", value=y_var, expected_type=type_hints["y_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if x is not None:
            self._values["x"] = x
        if x_var is not None:
            self._values["x_var"] = x_var
        if y is not None:
            self._values["y"] = y
        if y_var is not None:
            self._values["y_var"] = y_var

    @builtins.property
    def x(self) -> typing.Optional[builtins.str]:
        '''The horizontal position of the point, measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x DataAkamaiImagingPolicyImage#x}
        '''
        result = self._values.get("x")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_var(self) -> typing.Optional[builtins.str]:
        '''The horizontal position of the point, measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_var DataAkamaiImagingPolicyImage#x_var}
        '''
        result = self._values.get("x_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y(self) -> typing.Optional[builtins.str]:
        '''The vertical position of the point, measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y DataAkamaiImagingPolicyImage#y}
        '''
        result = self._values.get("y")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_var(self) -> typing.Optional[builtins.str]:
        '''The vertical position of the point, measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_var DataAkamaiImagingPolicyImage#y_var}
        '''
        result = self._values.get("y_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestPointShape(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestPointShapeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestPointShapeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b00f4f25de9083d8e6a90766a9dee54d3a7063d481d3d9fab87100d6da03c8c3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestPointShapeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__991839df94857b362414eab3a7af4c1f9be45fa8d507f2a70d94fbbd8fafa2a6)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestPointShapeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__86441aaac50c66ba593fcc25a16291f66064f473655d00afac958d598fbcf166)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eb6e118bfefd06b6f1f42b9de05f28e207f38a00256cde3607009426ce857eaf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__49fbef9b85a1cb2e3317fe94babece024ffef1f2b73d1088d9695872c43e9311)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestPointShape]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestPointShape]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestPointShape]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0b35f65baf69f90efb96f1a065876d1bc35fded20e84d762d45c059e72797357)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestPointShapeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestPointShapeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__48c0fc832050ef19231613e4bee7c72f6b1152aa8bc5aff78dbaf4e1929ec1f4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetX")
    def reset_x(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetX", []))

    @jsii.member(jsii_name="resetXVar")
    def reset_x_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXVar", []))

    @jsii.member(jsii_name="resetY")
    def reset_y(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetY", []))

    @jsii.member(jsii_name="resetYVar")
    def reset_y_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYVar", []))

    @builtins.property
    @jsii.member(jsii_name="xInput")
    def x_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xInput"))

    @builtins.property
    @jsii.member(jsii_name="xVarInput")
    def x_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yInput")
    def y_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yInput"))

    @builtins.property
    @jsii.member(jsii_name="yVarInput")
    def y_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yVarInput"))

    @builtins.property
    @jsii.member(jsii_name="x")
    def x(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "x"))

    @x.setter
    def x(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d099cfc05774a7f4b5f2dc28781c22a2e847a2b50e5c35115d3ea954d46ebb3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "x", value)

    @builtins.property
    @jsii.member(jsii_name="xVar")
    def x_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xVar"))

    @x_var.setter
    def x_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c463f49e20a20042810c4bd76a62997123731ff707411ed0e2ffe59488015421)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xVar", value)

    @builtins.property
    @jsii.member(jsii_name="y")
    def y(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "y"))

    @y.setter
    def y(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b33abd8a6a1ca2f963cb38d2fa16cd89c48719c556792995f17bc353226af92b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "y", value)

    @builtins.property
    @jsii.member(jsii_name="yVar")
    def y_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yVar"))

    @y_var.setter
    def y_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__022bb022394ac99158e07fb2f21d5d6c2eb03a7ae549802047ffec8f54f32f5f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestPointShape]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestPointShape]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestPointShape]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7e28101304d8caa1dcda7dfa88e06e6a65f3b2d2cca23531e5d8351272b2cfb1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestPolygonShape",
    jsii_struct_bases=[],
    name_mapping={"points": "points"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestPolygonShape:
    def __init__(
        self,
        *,
        points: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestPolygonShapePoints", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param points: points block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#points DataAkamaiImagingPolicyImage#points}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e21f812c98f7b27fa343682d599d911a5580b6d063bd8a4d7ee08fa8fad9d80)
            check_type(argname="argument points", value=points, expected_type=type_hints["points"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "points": points,
        }

    @builtins.property
    def points(
        self,
    ) -> typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestPolygonShapePoints"]]:
        '''points block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#points DataAkamaiImagingPolicyImage#points}
        '''
        result = self._values.get("points")
        assert result is not None, "Required property 'points' is missing"
        return typing.cast(typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestPolygonShapePoints"]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestPolygonShape(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestPolygonShapeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestPolygonShapeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__366a177ca5c246535f14579b97eade09f0036d0aa4224a4039fd0a62953ed0d8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestPolygonShapeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c46436eca1807dcfb92c060005bf30cdc0144ab43ad33080bb604b18eaed589a)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestPolygonShapeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c3c3a12e5824419d2cd3861a29e809bc42d136e17d45fa42f24a92b3dbc827b4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__240dc76038303e81251754c3f0410118b2abfb12afbc56bfb86ca5223088b333)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__687f5300cc6f2fc5168ccbbcec6d95237b8a380a6a84322fe6893c09c5937441)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestPolygonShape]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestPolygonShape]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestPolygonShape]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d0d0bb2ff97bb54d5dd4d399930b34f5c482b1f5f80acaa938f795c424b8e6c0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestPolygonShapeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestPolygonShapeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__87745312ecd0d1a17344dedf0da2ae25f0051a0f1aab8b375c0736ddad972e40)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putPoints")
    def put_points(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestPolygonShapePoints", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__db238625b023c70d929f8c42532265ee4066dee0f1e201449f306cc841ad481e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putPoints", [value]))

    @builtins.property
    @jsii.member(jsii_name="points")
    def points(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestPolygonShapePointsList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestPolygonShapePointsList", jsii.get(self, "points"))

    @builtins.property
    @jsii.member(jsii_name="pointsInput")
    def points_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestPolygonShapePoints"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestPolygonShapePoints"]]], jsii.get(self, "pointsInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestPolygonShape]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestPolygonShape]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestPolygonShape]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4554ca1c431447642ac3d15386a6dcfe670de983af7834874c1a68946d752e50)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestPolygonShapePoints",
    jsii_struct_bases=[],
    name_mapping={"x": "x", "x_var": "xVar", "y": "y", "y_var": "yVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestPolygonShapePoints:
    def __init__(
        self,
        *,
        x: typing.Optional[builtins.str] = None,
        x_var: typing.Optional[builtins.str] = None,
        y: typing.Optional[builtins.str] = None,
        y_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param x: The horizontal position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x DataAkamaiImagingPolicyImage#x}
        :param x_var: The horizontal position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_var DataAkamaiImagingPolicyImage#x_var}
        :param y: The vertical position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y DataAkamaiImagingPolicyImage#y}
        :param y_var: The vertical position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_var DataAkamaiImagingPolicyImage#y_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b102f70bdece8468706826d855f9b8c8116885b4069b678e5ae0921a02e58d0b)
            check_type(argname="argument x", value=x, expected_type=type_hints["x"])
            check_type(argname="argument x_var", value=x_var, expected_type=type_hints["x_var"])
            check_type(argname="argument y", value=y, expected_type=type_hints["y"])
            check_type(argname="argument y_var", value=y_var, expected_type=type_hints["y_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if x is not None:
            self._values["x"] = x
        if x_var is not None:
            self._values["x_var"] = x_var
        if y is not None:
            self._values["y"] = y
        if y_var is not None:
            self._values["y_var"] = y_var

    @builtins.property
    def x(self) -> typing.Optional[builtins.str]:
        '''The horizontal position of the point, measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x DataAkamaiImagingPolicyImage#x}
        '''
        result = self._values.get("x")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_var(self) -> typing.Optional[builtins.str]:
        '''The horizontal position of the point, measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_var DataAkamaiImagingPolicyImage#x_var}
        '''
        result = self._values.get("x_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y(self) -> typing.Optional[builtins.str]:
        '''The vertical position of the point, measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y DataAkamaiImagingPolicyImage#y}
        '''
        result = self._values.get("y")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_var(self) -> typing.Optional[builtins.str]:
        '''The vertical position of the point, measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_var DataAkamaiImagingPolicyImage#y_var}
        '''
        result = self._values.get("y_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestPolygonShapePoints(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestPolygonShapePointsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestPolygonShapePointsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__91151e1b5f8eaab01173b112087ebd288f433d5859424c4f1fcdf4f9fee77a27)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestPolygonShapePointsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f338c1ac19fe3880406f78491649a047cd6de29d85c37697436e232ac35b6101)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestPolygonShapePointsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d0a1b0bda931914eb2bd658b67fd580a3a21c3e5b3317a9cdbac183f0db3e670)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a9aed584ec06e3eccb5ec7b0bbb54a6ac2a9142e1dfefb5f1b660f2929e9a1e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__01e2a2347b68a7e155269af2d67812c22682f34756f031152480e4493b6c4ff5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestPolygonShapePoints]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestPolygonShapePoints]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestPolygonShapePoints]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d8a7ffb88d1db0b80bc046bb4f3789a56e2ee5d6ca489f33af2d08742d4855d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestPolygonShapePointsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestPolygonShapePointsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a2d0284cd1383f69e885e8eeae2a75c5f97aa8f6af813895c422cebbb66aecb3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetX")
    def reset_x(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetX", []))

    @jsii.member(jsii_name="resetXVar")
    def reset_x_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXVar", []))

    @jsii.member(jsii_name="resetY")
    def reset_y(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetY", []))

    @jsii.member(jsii_name="resetYVar")
    def reset_y_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYVar", []))

    @builtins.property
    @jsii.member(jsii_name="xInput")
    def x_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xInput"))

    @builtins.property
    @jsii.member(jsii_name="xVarInput")
    def x_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yInput")
    def y_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yInput"))

    @builtins.property
    @jsii.member(jsii_name="yVarInput")
    def y_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yVarInput"))

    @builtins.property
    @jsii.member(jsii_name="x")
    def x(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "x"))

    @x.setter
    def x(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__87893bce609a90dfb26b4831be679a33c299452686b0261e9deba214a2aed0e1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "x", value)

    @builtins.property
    @jsii.member(jsii_name="xVar")
    def x_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xVar"))

    @x_var.setter
    def x_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f2d97fe9bba5155dc927a94053c7853dd9f5100d9d703b7e80654c5666e51b69)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xVar", value)

    @builtins.property
    @jsii.member(jsii_name="y")
    def y(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "y"))

    @y.setter
    def y(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3739ce86ef0e68861a7ca0d3ab9641b473088102e17c788f55ae2cb4cfee14a4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "y", value)

    @builtins.property
    @jsii.member(jsii_name="yVar")
    def y_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yVar"))

    @y_var.setter
    def y_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d8e9b4d8f73e6b8592b1347b5761af58e7f0d26c37c0a3f91b405458714302e3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestPolygonShapePoints]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestPolygonShapePoints]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestPolygonShapePoints]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4d031a2a4ab6c0036a2c50c89a39cb13505f838602192e96e0e9dc13eb89cc6d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestRectangleShape",
    jsii_struct_bases=[],
    name_mapping={
        "anchor": "anchor",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestRectangleShape:
    def __init__(
        self,
        *,
        anchor: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestRectangleShapeAnchor", typing.Dict[builtins.str, typing.Any]],
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param anchor: anchor block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#anchor DataAkamaiImagingPolicyImage#anchor}
        :param height: Extends the rectangle down from the ``anchor`` point. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: Extends the rectangle down from the ``anchor`` point. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: Extends the rectangle right from the ``anchor`` point. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: Extends the rectangle right from the ``anchor`` point. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(anchor, dict):
            anchor = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestRectangleShapeAnchor(**anchor)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bcb32da1897476853a7caa563b6da2b5f4b6003e5bf7d1fce0e78f683c6ecd7d)
            check_type(argname="argument anchor", value=anchor, expected_type=type_hints["anchor"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "anchor": anchor,
        }
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def anchor(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestRectangleShapeAnchor":
        '''anchor block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#anchor DataAkamaiImagingPolicyImage#anchor}
        '''
        result = self._values.get("anchor")
        assert result is not None, "Required property 'anchor' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestRectangleShapeAnchor", result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''Extends the rectangle down from the ``anchor`` point.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''Extends the rectangle down from the ``anchor`` point.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''Extends the rectangle right from the ``anchor`` point.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''Extends the rectangle right from the ``anchor`` point.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestRectangleShape(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestRectangleShapeAnchor",
    jsii_struct_bases=[],
    name_mapping={"x": "x", "x_var": "xVar", "y": "y", "y_var": "yVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestRectangleShapeAnchor:
    def __init__(
        self,
        *,
        x: typing.Optional[builtins.str] = None,
        x_var: typing.Optional[builtins.str] = None,
        y: typing.Optional[builtins.str] = None,
        y_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param x: The horizontal position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x DataAkamaiImagingPolicyImage#x}
        :param x_var: The horizontal position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_var DataAkamaiImagingPolicyImage#x_var}
        :param y: The vertical position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y DataAkamaiImagingPolicyImage#y}
        :param y_var: The vertical position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_var DataAkamaiImagingPolicyImage#y_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7c1541b3ab565af0b1e14b79ce177e5c6d59fa0995fa6f1254b60f2438ebc5a3)
            check_type(argname="argument x", value=x, expected_type=type_hints["x"])
            check_type(argname="argument x_var", value=x_var, expected_type=type_hints["x_var"])
            check_type(argname="argument y", value=y, expected_type=type_hints["y"])
            check_type(argname="argument y_var", value=y_var, expected_type=type_hints["y_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if x is not None:
            self._values["x"] = x
        if x_var is not None:
            self._values["x_var"] = x_var
        if y is not None:
            self._values["y"] = y
        if y_var is not None:
            self._values["y_var"] = y_var

    @builtins.property
    def x(self) -> typing.Optional[builtins.str]:
        '''The horizontal position of the point, measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x DataAkamaiImagingPolicyImage#x}
        '''
        result = self._values.get("x")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_var(self) -> typing.Optional[builtins.str]:
        '''The horizontal position of the point, measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_var DataAkamaiImagingPolicyImage#x_var}
        '''
        result = self._values.get("x_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y(self) -> typing.Optional[builtins.str]:
        '''The vertical position of the point, measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y DataAkamaiImagingPolicyImage#y}
        '''
        result = self._values.get("y")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_var(self) -> typing.Optional[builtins.str]:
        '''The vertical position of the point, measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_var DataAkamaiImagingPolicyImage#y_var}
        '''
        result = self._values.get("y_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestRectangleShapeAnchor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestRectangleShapeAnchorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestRectangleShapeAnchorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f89c2ef47b90a8f45a2944e0702873960efb849b2fe3e98adeefa600ae6ba40f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetX")
    def reset_x(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetX", []))

    @jsii.member(jsii_name="resetXVar")
    def reset_x_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXVar", []))

    @jsii.member(jsii_name="resetY")
    def reset_y(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetY", []))

    @jsii.member(jsii_name="resetYVar")
    def reset_y_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYVar", []))

    @builtins.property
    @jsii.member(jsii_name="xInput")
    def x_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xInput"))

    @builtins.property
    @jsii.member(jsii_name="xVarInput")
    def x_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yInput")
    def y_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yInput"))

    @builtins.property
    @jsii.member(jsii_name="yVarInput")
    def y_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yVarInput"))

    @builtins.property
    @jsii.member(jsii_name="x")
    def x(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "x"))

    @x.setter
    def x(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ba8d890055201357f2e2072dc11785fc9a2f3040be14e34dcde3fd8a83f5527)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "x", value)

    @builtins.property
    @jsii.member(jsii_name="xVar")
    def x_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xVar"))

    @x_var.setter
    def x_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c7709768b9cbe5afb272e71d3882e7d38c1a5295517f2d2aa8423ea2bceade1c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xVar", value)

    @builtins.property
    @jsii.member(jsii_name="y")
    def y(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "y"))

    @y.setter
    def y(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__def7ba697bdceb80d6ac00d3b8bf6c57af5fda912fff4be542112ff126bdf33a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "y", value)

    @builtins.property
    @jsii.member(jsii_name="yVar")
    def y_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yVar"))

    @y_var.setter
    def y_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a836476c784bf3911f4d18664ef65806a650572c7441a56b995e8a1224d316e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestRectangleShapeAnchor]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestRectangleShapeAnchor], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestRectangleShapeAnchor],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__28adbe65d9944146ae310e2ae5cb142f2d32148b33ae02c3134a45d53950f7e6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestRectangleShapeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestRectangleShapeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5c4751e545157261db3706ca9e4ef0b9dc4637c2057c5c7fe072e9b61d7946aa)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestRectangleShapeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f3bb0f8d11b08eb63297e4604ac7c75675f5be921b7b869f706c65d74f35dc37)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestRectangleShapeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__25fc8089e1812e5c432af3e21cb20c93f219dde13cccf237681d039feb853e22)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8d5bf0dc36b49f48ac143208a147b5524e991de8e6be012b462d03ffbb21d856)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8f529ccc667b62f8ca9f3475dff0a5005924e6f3686a87939280ff9841254bc4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestRectangleShape]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestRectangleShape]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestRectangleShape]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8b94d2d51d516abe397a34d30f148b9b8bf1610beca24966f91fd7228c9a1aca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestRectangleShapeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestRectangleShapeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__19fc59091196d553bb405fdc640a6f823fb0a1bcbfaa71940aceac6d7b5a9c26)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putAnchor")
    def put_anchor(
        self,
        *,
        x: typing.Optional[builtins.str] = None,
        x_var: typing.Optional[builtins.str] = None,
        y: typing.Optional[builtins.str] = None,
        y_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param x: The horizontal position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x DataAkamaiImagingPolicyImage#x}
        :param x_var: The horizontal position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_var DataAkamaiImagingPolicyImage#x_var}
        :param y: The vertical position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y DataAkamaiImagingPolicyImage#y}
        :param y_var: The vertical position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_var DataAkamaiImagingPolicyImage#y_var}
        '''
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestRectangleShapeAnchor(
            x=x, x_var=x_var, y=y, y_var=y_var
        )

        return typing.cast(None, jsii.invoke(self, "putAnchor", [value]))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="anchor")
    def anchor(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestRectangleShapeAnchorOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestRectangleShapeAnchorOutputReference, jsii.get(self, "anchor"))

    @builtins.property
    @jsii.member(jsii_name="anchorInput")
    def anchor_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestRectangleShapeAnchor]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestRectangleShapeAnchor], jsii.get(self, "anchorInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__613687fada091d2eb23dec14d38153edbe9e9d22fd1d3916d21a6e54e71a701d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c0cd34659d1b0cab96d6e0b46b0fa490d6558ccc83bba01c283b69fb6c2af858)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8811e397f7097393e6135286e278860487d31d82f6e07bdffd4ed73787111fe1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fd68e741fcd3af0f80859e7fb8b62d0e9ef854b1831ebf212b28654c1d0cb147)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestRectangleShape]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestRectangleShape]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestRectangleShape]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d69812fd47baf802b3e64c60408f12799d4da5d21740bc13660c8ffbff8b09aa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestUnionShape",
    jsii_struct_bases=[],
    name_mapping={"shapes": "shapes"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestUnionShape:
    def __init__(
        self,
        *,
        shapes: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestUnionShapeShapes", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param shapes: shapes block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shapes DataAkamaiImagingPolicyImage#shapes}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cdc4a1156d6b0028b3a90673463a39c9cd031e136fe6cf31de31c63af7074686)
            check_type(argname="argument shapes", value=shapes, expected_type=type_hints["shapes"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "shapes": shapes,
        }

    @builtins.property
    def shapes(
        self,
    ) -> typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestUnionShapeShapes"]]:
        '''shapes block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shapes DataAkamaiImagingPolicyImage#shapes}
        '''
        result = self._values.get("shapes")
        assert result is not None, "Required property 'shapes' is missing"
        return typing.cast(typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestUnionShapeShapes"]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestUnionShape(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestUnionShapeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestUnionShapeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__06421288a6ba3e078c97d432caf0527884718f01bcaae02cfbce7270d34fd8f0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestUnionShapeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f318ad7222ebc314ae919afb5f6d85e406e740dfea4d8072867633ee796f4a22)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestUnionShapeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c7212b1aea61c90fca3f18cfee01838fd8e53ee89dee8295a9b9db8107e53365)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__18c92498b77a1d65ca9df5f1df7ae604f4bd890d8545b11f41ef820f82493fa6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b32dcf16a4251c61e7299cad556a68076e0d3bbab2f46fa94eba89ccfc7a1851)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestUnionShape]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestUnionShape]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestUnionShape]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__381175ad7e74865ea0ccf959503da70207a5c4df7ca5ab6000d7a00e21f5040a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestUnionShapeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestUnionShapeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fc74cb7f45dd9626d0799f2fbfb4de92f7d3f9990e3761d45982f78867a61eca)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putShapes")
    def put_shapes(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestUnionShapeShapes", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a2c489ca947ab3c85f574d1b32becce495edf53b5ba5a6053e7eba8837efe6ae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putShapes", [value]))

    @builtins.property
    @jsii.member(jsii_name="shapes")
    def shapes(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestUnionShapeShapesList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestUnionShapeShapesList", jsii.get(self, "shapes"))

    @builtins.property
    @jsii.member(jsii_name="shapesInput")
    def shapes_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestUnionShapeShapes"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestUnionShapeShapes"]]], jsii.get(self, "shapesInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestUnionShape]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestUnionShape]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestUnionShape]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__750b497930149eeb81b607bf45001d8c6f00c59dfcdb2c23b86dd0ad54d92f9c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestUnionShapeShapes",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestUnionShapeShapes:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestUnionShapeShapes(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestUnionShapeShapesList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestUnionShapeShapesList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ba72020e8602703521f44c1d6236fdd73576b9caa0a742391f20c9d5a612cd65)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestUnionShapeShapesOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4b97e97cb8048e879f056f73d796506689b0279b0bb858f243438866a30a011d)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestUnionShapeShapesOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__089371c57260a0e60cb34b0634d49b9b356df4c98311947244491ec069c9e45f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4e1c18c2a9fbd87c776f2cf99d332a07a72d9adfde6cabc6948fce167166b82a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4bcefd7e4464ad6c5646e9b6f51fd515fcb86636ef6186035bba2040525e46d6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestUnionShapeShapes]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestUnionShapeShapes]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestUnionShapeShapes]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ca5f119be1e8a61255966ed4875b2d6ed4eec89b635bf9ea9dd61ce0b6d237d0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestUnionShapeShapesOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestUnionShapeShapesOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b83d34d9b0afe3babba5ec33b8c84d9d42064c80a5a45790a1c0dfeaa53028ee)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestUnionShapeShapes]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestUnionShapeShapes]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestUnionShapeShapes]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b326c262fc3564b829fe4f63e539c45c956860413dd23a566f4d48888bdfcfd7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRelativeCrop",
    jsii_struct_bases=[],
    name_mapping={
        "east": "east",
        "east_var": "eastVar",
        "north": "north",
        "north_var": "northVar",
        "south": "south",
        "south_var": "southVar",
        "west": "west",
        "west_var": "westVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRelativeCrop:
    def __init__(
        self,
        *,
        east: typing.Optional[builtins.str] = None,
        east_var: typing.Optional[builtins.str] = None,
        north: typing.Optional[builtins.str] = None,
        north_var: typing.Optional[builtins.str] = None,
        south: typing.Optional[builtins.str] = None,
        south_var: typing.Optional[builtins.str] = None,
        west: typing.Optional[builtins.str] = None,
        west_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param east: The number of pixels to shrink or expand the right side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east DataAkamaiImagingPolicyImage#east}
        :param east_var: The number of pixels to shrink or expand the right side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east_var DataAkamaiImagingPolicyImage#east_var}
        :param north: The number of pixels to shrink or expand the top side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north DataAkamaiImagingPolicyImage#north}
        :param north_var: The number of pixels to shrink or expand the top side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north_var DataAkamaiImagingPolicyImage#north_var}
        :param south: The number of pixels to shrink or expand the bottom side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south DataAkamaiImagingPolicyImage#south}
        :param south_var: The number of pixels to shrink or expand the bottom side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south_var DataAkamaiImagingPolicyImage#south_var}
        :param west: The number of pixels to shrink or expand the left side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west DataAkamaiImagingPolicyImage#west}
        :param west_var: The number of pixels to shrink or expand the left side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west_var DataAkamaiImagingPolicyImage#west_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__20999be9a8e4f16de0d0257507d29ec701f396340013266ecd5f3607213eb341)
            check_type(argname="argument east", value=east, expected_type=type_hints["east"])
            check_type(argname="argument east_var", value=east_var, expected_type=type_hints["east_var"])
            check_type(argname="argument north", value=north, expected_type=type_hints["north"])
            check_type(argname="argument north_var", value=north_var, expected_type=type_hints["north_var"])
            check_type(argname="argument south", value=south, expected_type=type_hints["south"])
            check_type(argname="argument south_var", value=south_var, expected_type=type_hints["south_var"])
            check_type(argname="argument west", value=west, expected_type=type_hints["west"])
            check_type(argname="argument west_var", value=west_var, expected_type=type_hints["west_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if east is not None:
            self._values["east"] = east
        if east_var is not None:
            self._values["east_var"] = east_var
        if north is not None:
            self._values["north"] = north
        if north_var is not None:
            self._values["north_var"] = north_var
        if south is not None:
            self._values["south"] = south
        if south_var is not None:
            self._values["south_var"] = south_var
        if west is not None:
            self._values["west"] = west
        if west_var is not None:
            self._values["west_var"] = west_var

    @builtins.property
    def east(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the right side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east DataAkamaiImagingPolicyImage#east}
        '''
        result = self._values.get("east")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def east_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the right side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east_var DataAkamaiImagingPolicyImage#east_var}
        '''
        result = self._values.get("east_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def north(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the top side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north DataAkamaiImagingPolicyImage#north}
        '''
        result = self._values.get("north")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def north_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the top side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north_var DataAkamaiImagingPolicyImage#north_var}
        '''
        result = self._values.get("north_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def south(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the bottom side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south DataAkamaiImagingPolicyImage#south}
        '''
        result = self._values.get("south")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def south_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the bottom side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south_var DataAkamaiImagingPolicyImage#south_var}
        '''
        result = self._values.get("south_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def west(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the left side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west DataAkamaiImagingPolicyImage#west}
        '''
        result = self._values.get("west")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def west_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the left side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west_var DataAkamaiImagingPolicyImage#west_var}
        '''
        result = self._values.get("west_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRelativeCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRelativeCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRelativeCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cdb4522e91ff5c97a1de8ab960449c22372d16e8dc1c41a48745c6e64b7cfee7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRelativeCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4e6322b67909983aca9c095c0ecb72a759a8473131042535d5ee73b556ae64e3)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRelativeCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8bd92fc6ba8a7c5c0e64b9c03ad3b8e73b3dacbe81acb21b109ac65f79e7e981)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__13422a2ed06a03ac86725a7abf677a04dd70d05efa2a6b138859920f99d72a4d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3f054087aec53dc4d565e7238c1e6c32a5489c782b4c5df804b25d788af5553c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRelativeCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRelativeCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRelativeCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__736235f2fe2287f437068d398cb0ddc6d071cd0c5a1e5202ecdeccfdc3a31451)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRelativeCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRelativeCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dabfb8f0ddda62919635675fd0756d5dc7706dd96bb7029691c4a7d23f0c3f19)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetEast")
    def reset_east(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEast", []))

    @jsii.member(jsii_name="resetEastVar")
    def reset_east_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEastVar", []))

    @jsii.member(jsii_name="resetNorth")
    def reset_north(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNorth", []))

    @jsii.member(jsii_name="resetNorthVar")
    def reset_north_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNorthVar", []))

    @jsii.member(jsii_name="resetSouth")
    def reset_south(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSouth", []))

    @jsii.member(jsii_name="resetSouthVar")
    def reset_south_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSouthVar", []))

    @jsii.member(jsii_name="resetWest")
    def reset_west(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWest", []))

    @jsii.member(jsii_name="resetWestVar")
    def reset_west_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWestVar", []))

    @builtins.property
    @jsii.member(jsii_name="eastInput")
    def east_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "eastInput"))

    @builtins.property
    @jsii.member(jsii_name="eastVarInput")
    def east_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "eastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="northInput")
    def north_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "northInput"))

    @builtins.property
    @jsii.member(jsii_name="northVarInput")
    def north_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "northVarInput"))

    @builtins.property
    @jsii.member(jsii_name="southInput")
    def south_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "southInput"))

    @builtins.property
    @jsii.member(jsii_name="southVarInput")
    def south_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "southVarInput"))

    @builtins.property
    @jsii.member(jsii_name="westInput")
    def west_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "westInput"))

    @builtins.property
    @jsii.member(jsii_name="westVarInput")
    def west_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "westVarInput"))

    @builtins.property
    @jsii.member(jsii_name="east")
    def east(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "east"))

    @east.setter
    def east(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__67541bad4020c8f6a3af73f1f4544c277480287f03910fc8c4d60b85d59bd96e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "east", value)

    @builtins.property
    @jsii.member(jsii_name="eastVar")
    def east_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "eastVar"))

    @east_var.setter
    def east_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c66fc74728f299c091f41e6152d21c54c9a60e6e2749a27b3b7e1df462987f29)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "eastVar", value)

    @builtins.property
    @jsii.member(jsii_name="north")
    def north(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "north"))

    @north.setter
    def north(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__96b9c625f6854a3daa7027dd1bfd3a7daba32a78b18c0949eacb68bd83a7babf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "north", value)

    @builtins.property
    @jsii.member(jsii_name="northVar")
    def north_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "northVar"))

    @north_var.setter
    def north_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7a6f2b83c1e5e7681d500c627df49928d6188b217f654901c2eade401721bdf6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "northVar", value)

    @builtins.property
    @jsii.member(jsii_name="south")
    def south(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "south"))

    @south.setter
    def south(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__329f8c9aa560ee2ba28e32d69095f532a3b03b7d9cf33104acdf9d8065f91a17)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "south", value)

    @builtins.property
    @jsii.member(jsii_name="southVar")
    def south_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "southVar"))

    @south_var.setter
    def south_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__41c5d576140b4110cd5c68ac04fa58f0304a60d701f4fed91f7b00e46df4af47)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "southVar", value)

    @builtins.property
    @jsii.member(jsii_name="west")
    def west(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "west"))

    @west.setter
    def west(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__666a2e269ece99fb8d75e5e26a765877b6afb7369d1d1422043e9cdd3c0f9ead)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "west", value)

    @builtins.property
    @jsii.member(jsii_name="westVar")
    def west_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "westVar"))

    @west_var.setter
    def west_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f891470e1fead7d5decad4328724fe66fae9f3c95f91c7b4ecd90c760d544d0e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "westVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRelativeCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRelativeCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRelativeCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dc1a51c4d6be8baedec6b7cecc0e1f9df3b8edae242fe12b573374851d1bd86f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRemoveColor",
    jsii_struct_bases=[],
    name_mapping={
        "color": "color",
        "color_var": "colorVar",
        "feather": "feather",
        "feather_var": "featherVar",
        "tolerance": "tolerance",
        "tolerance_var": "toleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRemoveColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
        feather: typing.Optional[builtins.str] = None,
        feather_var: typing.Optional[builtins.str] = None,
        tolerance: typing.Optional[builtins.str] = None,
        tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        :param feather: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        :param feather_var: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        :param tolerance: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        :param tolerance_var: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6628d7d8b9c478c1788a7b491c02acdc653f39a2a9f9268e3839b37871b8bff7)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
            check_type(argname="argument feather", value=feather, expected_type=type_hints["feather"])
            check_type(argname="argument feather_var", value=feather_var, expected_type=type_hints["feather_var"])
            check_type(argname="argument tolerance", value=tolerance, expected_type=type_hints["tolerance"])
            check_type(argname="argument tolerance_var", value=tolerance_var, expected_type=type_hints["tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var
        if feather is not None:
            self._values["feather"] = feather
        if feather_var is not None:
            self._values["feather_var"] = feather_var
        if tolerance is not None:
            self._values["tolerance"] = tolerance
        if tolerance_var is not None:
            self._values["tolerance_var"] = tolerance_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        '''
        result = self._values.get("feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather_var(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        '''
        result = self._values.get("feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        '''
        result = self._values.get("tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance_var(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        result = self._values.get("tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRemoveColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRemoveColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRemoveColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__403c4beaae8744f5419a5b5bf5817e533c661beb091b4c37b26bd5593f95539e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRemoveColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d85a07ea6179bddfa79121edbef07d86e20610172f17d649456c6b48c56bceeb)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRemoveColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7f8ce794b2cb88bb3b25e3f74639e4e930fe59d3ef845ff801910198bef52f2f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7e8ae5029551b0795250849dab5e84e9fbb8aa6c8c448ea0aeaa5aedc4d8d657)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d086a906c868009669cfd7aae8649f424b2b5f422bd4452e1fa08fa3a0b0588)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRemoveColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRemoveColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRemoveColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ac1b8ad975f6b632ac4ccc86dbbbb81ff26d0329146fdd173a641c99036b047)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRemoveColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRemoveColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__02c66cceae8760cd0d3efffa0ef4b4f638aa79572f4cd1aa746ba34887b7d784)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @jsii.member(jsii_name="resetFeather")
    def reset_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeather", []))

    @jsii.member(jsii_name="resetFeatherVar")
    def reset_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatherVar", []))

    @jsii.member(jsii_name="resetTolerance")
    def reset_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTolerance", []))

    @jsii.member(jsii_name="resetToleranceVar")
    def reset_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featherInput")
    def feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherInput"))

    @builtins.property
    @jsii.member(jsii_name="featherVarInput")
    def feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceInput")
    def tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceVarInput")
    def tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__907d3e15582cfdd83860efda578e59f33effd6a251445d70cdaac0a72de50d8d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__60f99c928a91c2c3f253d40de8e96939d8f124225bf15a70995b262250fe36ec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="feather")
    def feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "feather"))

    @feather.setter
    def feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__463c0052a2133d20edc95282cd5e78d7932ed1c16658d322dd4994820214ac40)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "feather", value)

    @builtins.property
    @jsii.member(jsii_name="featherVar")
    def feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featherVar"))

    @feather_var.setter
    def feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6c377a26508b7b1ea9c295424fb323ad23eb29519ce648c29ced7d3c54419bd8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featherVar", value)

    @builtins.property
    @jsii.member(jsii_name="tolerance")
    def tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tolerance"))

    @tolerance.setter
    def tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6bf6aa2da3281b2521523fb6be32c2290d29b296e0c6b064ecd31e866dcc8558)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tolerance", value)

    @builtins.property
    @jsii.member(jsii_name="toleranceVar")
    def tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "toleranceVar"))

    @tolerance_var.setter
    def tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__11fded7bce307376d5b4a31fc03f51dabab45bc62cd466e6dadb580a258a4fae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "toleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRemoveColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRemoveColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRemoveColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__30d1065827c0c6afd07f80d08df5c39b1a424eb0bfbbc938a60311dda15ae636)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitResize",
    jsii_struct_bases=[],
    name_mapping={
        "aspect": "aspect",
        "aspect_var": "aspectVar",
        "height": "height",
        "height_var": "heightVar",
        "type": "type",
        "type_var": "typeVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitResize:
    def __init__(
        self,
        *,
        aspect: typing.Optional[builtins.str] = None,
        aspect_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param aspect: Preserves the aspect ratio. Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect DataAkamaiImagingPolicyImage#aspect}
        :param aspect_var: Preserves the aspect ratio. Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_var DataAkamaiImagingPolicyImage#aspect_var}
        :param height: The height to resize the source image to. Must be set if height is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height to resize the source image to. Must be set if height is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param type: Sets constraints for the image resize. Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: Sets constraints for the image resize. Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        :param width: The width to resize the source image to. Must be set if width is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width to resize the source image to. Must be set if width is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6eaf02079b26b23e02d66a62390f0bdec983f280b92d1fce24aea373019eb1e8)
            check_type(argname="argument aspect", value=aspect, expected_type=type_hints["aspect"])
            check_type(argname="argument aspect_var", value=aspect_var, expected_type=type_hints["aspect_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if aspect is not None:
            self._values["aspect"] = aspect
        if aspect_var is not None:
            self._values["aspect_var"] = aspect_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def aspect(self) -> typing.Optional[builtins.str]:
        '''Preserves the aspect ratio.

        Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect DataAkamaiImagingPolicyImage#aspect}
        '''
        result = self._values.get("aspect")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def aspect_var(self) -> typing.Optional[builtins.str]:
        '''Preserves the aspect ratio.

        Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_var DataAkamaiImagingPolicyImage#aspect_var}
        '''
        result = self._values.get("aspect_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height to resize the source image to. Must be set if height is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height to resize the source image to. Must be set if height is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''Sets constraints for the image resize.

        Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''Sets constraints for the image resize.

        Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width to resize the source image to. Must be set if width is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width to resize the source image to. Must be set if width is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitResize(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitResizeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitResizeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4caef534684f713439f17407b61937bde015ca76637077b337abdbb85a4cde53)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitResizeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__de29bd5fff3ac8536d1dc716aa4977142659a413908a6d3db18eb5946a9e654c)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitResizeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ef0b4df5eda44f8af541963c5fc47af8810ec937d20038e9f28afa7840e8ed5a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb6217163a9225dcdd00a56cf8dce3a5cba1666e9afcd075eb5fba7349631494)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__87df160fce847d04d27446fa58f7cd89fca1092f791cef14f88ba432625fa110)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitResize]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitResize]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitResize]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2147cb6d83da5455028524e9c36a8b6fdbef89aa676e639dbf15cdab03cadf2b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitResizeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitResizeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__08c09a1abd4800c848c438f22ccd5a989d828ed49a2b75cf96cc6302bfa997a8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAspect")
    def reset_aspect(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspect", []))

    @jsii.member(jsii_name="resetAspectVar")
    def reset_aspect_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspectVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="aspectInput")
    def aspect_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "aspectInput"))

    @builtins.property
    @jsii.member(jsii_name="aspectVarInput")
    def aspect_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "aspectVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="aspect")
    def aspect(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "aspect"))

    @aspect.setter
    def aspect(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4fc80c70c3995aecf3678cde3c9affecab6acab3a66db69ee3a37d2d083294bf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "aspect", value)

    @builtins.property
    @jsii.member(jsii_name="aspectVar")
    def aspect_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "aspectVar"))

    @aspect_var.setter
    def aspect_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d162d5cfab01487981b7334b95052add7cc28c7d2ec70de2d6d7d1c46b748f48)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "aspectVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__305f2a296e1046aaeedec1afb69c3b609d453040a07eadc8a78c1dea89528e81)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f4e12134be9828a92af3a2ffba4c1b8fc5630858eadf7ef4c19a8501b4afe6fd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__19da0681affda6e716d9308a52d6e6275afa03b5e2eb225df7e917d7bc4d284b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c09b7545689803bc0da4c575fee14f07ed6c358396779b11fdd8a7d1f781d49f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c720e05326fdc7b1f6cd629006eaf957ca06cf5e6641acc1b40683e35db3012e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__21c4d8482825c6061148a9f79ef7e47b0040118f1172bce5a88ee4718aeff3e2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitResize]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitResize]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitResize]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2c0eda8a9eede77dd8fa1f58ea2fb941207a7fc1e14f8836eb1319dc9111afee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRotate",
    jsii_struct_bases=[],
    name_mapping={"degrees": "degrees", "degrees_var": "degreesVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRotate:
    def __init__(
        self,
        *,
        degrees: typing.Optional[builtins.str] = None,
        degrees_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param degrees: The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees DataAkamaiImagingPolicyImage#degrees}
        :param degrees_var: The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees_var DataAkamaiImagingPolicyImage#degrees_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ee8cb662c5ec01ce4b364ec1220a251c9370c239c6cc86d61ca53a3d8a25fc2a)
            check_type(argname="argument degrees", value=degrees, expected_type=type_hints["degrees"])
            check_type(argname="argument degrees_var", value=degrees_var, expected_type=type_hints["degrees_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if degrees is not None:
            self._values["degrees"] = degrees
        if degrees_var is not None:
            self._values["degrees_var"] = degrees_var

    @builtins.property
    def degrees(self) -> typing.Optional[builtins.str]:
        '''The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees DataAkamaiImagingPolicyImage#degrees}
        '''
        result = self._values.get("degrees")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def degrees_var(self) -> typing.Optional[builtins.str]:
        '''The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees_var DataAkamaiImagingPolicyImage#degrees_var}
        '''
        result = self._values.get("degrees_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRotate(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRotateList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRotateList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c39d0bb462e926f1d3a8358251ffbd15611c387b854edcadae9ad6b6a74630a9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRotateOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea0ae49c303253aeaf4fcd7fb3b655336101982fbf3d6eda403e2a3bab6c420f)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRotateOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__63edd5b5c2b8ada5a5f70ff6d02b0e05db882c80c7738d529758cd2df30d90a9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f7c6db95f225119c5d379d028298971a5bbcd7300a4cd2c0cdadc8714c96c3f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c80327b417c4e55f0cac253618f6e5caf2848ceabe12e9116712d05ac6518b2f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRotate]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRotate]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRotate]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__260d4105eae8b08fada6748d31457b37858071a855de379bf9abb0c3d605dd82)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRotateOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRotateOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7f648b92b08ac386a939d181357c468dd6d68f087e0b0f3c717af9129066ea88)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetDegrees")
    def reset_degrees(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDegrees", []))

    @jsii.member(jsii_name="resetDegreesVar")
    def reset_degrees_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDegreesVar", []))

    @builtins.property
    @jsii.member(jsii_name="degreesInput")
    def degrees_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "degreesInput"))

    @builtins.property
    @jsii.member(jsii_name="degreesVarInput")
    def degrees_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "degreesVarInput"))

    @builtins.property
    @jsii.member(jsii_name="degrees")
    def degrees(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "degrees"))

    @degrees.setter
    def degrees(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ac57b774ad731bb7840f062764e2f600fa9a49a5e19e3d38161ee34255f25b0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "degrees", value)

    @builtins.property
    @jsii.member(jsii_name="degreesVar")
    def degrees_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "degreesVar"))

    @degrees_var.setter
    def degrees_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5e492f11a85179fcc1cbf94e4404341e86494630e5a536e898573d80458f9e89)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "degreesVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRotate]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRotate]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRotate]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dec60464f5c244b2b07df3572e7691a087d2159e923d0233048cd808b0600421)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitScale",
    jsii_struct_bases=[],
    name_mapping={
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitScale:
    def __init__(
        self,
        *,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param height: Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged. Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged. Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d32bebf0308ee217d863d9ef2be9f96a886dc4b180ef3db53927e8471e7cb87)
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size.

        Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size.

        Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged.

        Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged.

        Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitScale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitScaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitScaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__077644e0d435098af12bf3612f74497a7693b951ce7a6546561624698537ea88)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitScaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c4d76aab9c3847a0e58003c080faccca880bdbb40fa7c61254239a3041463286)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitScaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__43f40db820776409b357ca272a2d143751296598f61bf490bff78113a64de266)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b6b0e5c8362b212f8d487ed8a0dac8d8024475e9afa92e4e0db31debacc7fc06)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1d59e8f6b77065c0aba26c885cdbb652fc3a233ed3606fd60d1ac59d9e262ebc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitScale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitScale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitScale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__89be9cf12d207f37a4001f2645b530ed640be134eddaee52716e3032ae3bb6f0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitScaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitScaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__005330d087e31d4cb459c649b647e36dce245e95eea488af82fd8653bfd2f9cf)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2538c86cc09158072919a9e90d142c50ba9bef4dc585c291b2f994c66e472812)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e46be09a03a053d878bff273cfcb90f8c4a641a26ddff08c0be9471c7d2ff0d6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__afd757726c1492e81f7434f6a798c6e05f81f02815ccead165278f0bd81e2b2f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dcfe95f084704aeb32df6e5be3df10903a0e7eee0e58457729fcc10b7620237b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitScale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitScale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitScale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1792d1b12acc1e114a732efbbf44b51ddef6922cb78603efd3df055cb5e5b938)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitShear",
    jsii_struct_bases=[],
    name_mapping={
        "x_shear": "xShear",
        "x_shear_var": "xShearVar",
        "y_shear": "yShear",
        "y_shear_var": "yShearVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitShear:
    def __init__(
        self,
        *,
        x_shear: typing.Optional[builtins.str] = None,
        x_shear_var: typing.Optional[builtins.str] = None,
        y_shear: typing.Optional[builtins.str] = None,
        y_shear_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param x_shear: The amount to shear along the x-axis, measured in multiples of the image's width. Must be set if yShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear DataAkamaiImagingPolicyImage#x_shear}
        :param x_shear_var: The amount to shear along the x-axis, measured in multiples of the image's width. Must be set if yShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear_var DataAkamaiImagingPolicyImage#x_shear_var}
        :param y_shear: The amount to shear along the y-axis, measured in multiples of the image's height. Must be set if xShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear DataAkamaiImagingPolicyImage#y_shear}
        :param y_shear_var: The amount to shear along the y-axis, measured in multiples of the image's height. Must be set if xShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear_var DataAkamaiImagingPolicyImage#y_shear_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__15a20d6d8de52cb73307e71a806a2d348c3e2581bf68c04b42dd23b3695f2412)
            check_type(argname="argument x_shear", value=x_shear, expected_type=type_hints["x_shear"])
            check_type(argname="argument x_shear_var", value=x_shear_var, expected_type=type_hints["x_shear_var"])
            check_type(argname="argument y_shear", value=y_shear, expected_type=type_hints["y_shear"])
            check_type(argname="argument y_shear_var", value=y_shear_var, expected_type=type_hints["y_shear_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if x_shear is not None:
            self._values["x_shear"] = x_shear
        if x_shear_var is not None:
            self._values["x_shear_var"] = x_shear_var
        if y_shear is not None:
            self._values["y_shear"] = y_shear
        if y_shear_var is not None:
            self._values["y_shear_var"] = y_shear_var

    @builtins.property
    def x_shear(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the x-axis, measured in multiples of the image's width.

        Must be set if yShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear DataAkamaiImagingPolicyImage#x_shear}
        '''
        result = self._values.get("x_shear")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_shear_var(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the x-axis, measured in multiples of the image's width.

        Must be set if yShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear_var DataAkamaiImagingPolicyImage#x_shear_var}
        '''
        result = self._values.get("x_shear_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_shear(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the y-axis, measured in multiples of the image's height.

        Must be set if xShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear DataAkamaiImagingPolicyImage#y_shear}
        '''
        result = self._values.get("y_shear")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_shear_var(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the y-axis, measured in multiples of the image's height.

        Must be set if xShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear_var DataAkamaiImagingPolicyImage#y_shear_var}
        '''
        result = self._values.get("y_shear_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitShear(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitShearList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitShearList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e425495d53d1882195b3c3dc7cb86888517eb4d4edf3cc02e736f31bd00ef9fe)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitShearOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8849c3fdf7b60cd0d573a88059d056e72b6dad5de0b572571fddcaa023dffd70)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitShearOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__06376796d2d34884dae7306e4d9e1300654698fba99a1eaaf3eb62f00da76356)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e226d4e0ca103914180009081af4149a8ed6fcb47e21fdd924a5fa658673ca01)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dd5a6ccf6adfca0d193a6a9a5e09cea0e26a6f50ffa144ac9b0cb9e287d5747d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitShear]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitShear]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitShear]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2e5bb055134387b603dcf3b740db653223aeaa45a2b900e53568e1b1e7e259b2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitShearOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitShearOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8ff62354718cd87d08c9635546df90a33f37b84c565f39cac4603e793293dea7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetXShear")
    def reset_x_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXShear", []))

    @jsii.member(jsii_name="resetXShearVar")
    def reset_x_shear_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXShearVar", []))

    @jsii.member(jsii_name="resetYShear")
    def reset_y_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYShear", []))

    @jsii.member(jsii_name="resetYShearVar")
    def reset_y_shear_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYShearVar", []))

    @builtins.property
    @jsii.member(jsii_name="xShearInput")
    def x_shear_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xShearInput"))

    @builtins.property
    @jsii.member(jsii_name="xShearVarInput")
    def x_shear_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xShearVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yShearInput")
    def y_shear_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yShearInput"))

    @builtins.property
    @jsii.member(jsii_name="yShearVarInput")
    def y_shear_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yShearVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xShear")
    def x_shear(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xShear"))

    @x_shear.setter
    def x_shear(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f46a463dc1cb8309dd4bd03fc9f8dd00d6c581d52518b8d176aff36b86d4f27)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xShear", value)

    @builtins.property
    @jsii.member(jsii_name="xShearVar")
    def x_shear_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xShearVar"))

    @x_shear_var.setter
    def x_shear_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__20e395ae008b4d9ffe9f5ad4e04dacc5a2172fae1b8246e457d4e86532ef4ac6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xShearVar", value)

    @builtins.property
    @jsii.member(jsii_name="yShear")
    def y_shear(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yShear"))

    @y_shear.setter
    def y_shear(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7744af10bacdefae598a73892be49628ced11281f244a4061dc91e7a32f4abe5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yShear", value)

    @builtins.property
    @jsii.member(jsii_name="yShearVar")
    def y_shear_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yShearVar"))

    @y_shear_var.setter
    def y_shear_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fe11fc24334d02b0f759eccce93235d207d581ded6b352adf1e1756e727892e7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yShearVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitShear]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitShear]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitShear]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__148a5047b080c6c06d4dbbeb535a0dd54a8243b293ba5a5424ca1a024d1663d2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitTrim",
    jsii_struct_bases=[],
    name_mapping={
        "fuzz": "fuzz",
        "fuzz_var": "fuzzVar",
        "padding": "padding",
        "padding_var": "paddingVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitTrim:
    def __init__(
        self,
        *,
        fuzz: typing.Optional[builtins.str] = None,
        fuzz_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fuzz: The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz DataAkamaiImagingPolicyImage#fuzz}
        :param fuzz_var: The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz_var DataAkamaiImagingPolicyImage#fuzz_var}
        :param padding: The amount of padding in pixels to add to the trimmed image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: The amount of padding in pixels to add to the trimmed image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ae6c2c48c29be91f6f6096ee7ff915eb94c4e295ac443b6b489d0985885c6314)
            check_type(argname="argument fuzz", value=fuzz, expected_type=type_hints["fuzz"])
            check_type(argname="argument fuzz_var", value=fuzz_var, expected_type=type_hints["fuzz_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fuzz is not None:
            self._values["fuzz"] = fuzz
        if fuzz_var is not None:
            self._values["fuzz_var"] = fuzz_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var

    @builtins.property
    def fuzz(self) -> typing.Optional[builtins.str]:
        '''The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz DataAkamaiImagingPolicyImage#fuzz}
        '''
        result = self._values.get("fuzz")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fuzz_var(self) -> typing.Optional[builtins.str]:
        '''The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz_var DataAkamaiImagingPolicyImage#fuzz_var}
        '''
        result = self._values.get("fuzz_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''The amount of padding in pixels to add to the trimmed image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''The amount of padding in pixels to add to the trimmed image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitTrim(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitTrimList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitTrimList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e5052d3e88855e4c3713537ab124f083bb75aa0025fdba424036583f5dbaa2e5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitTrimOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8bdf3a0596767a23b609d68094cbab96d62a924e4be381cd55159f01d242c304)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitTrimOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f9ba8cde42555eec904ff5d9160f15b8f19bc301167850ca84e8134993d2451b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e0ad087e7922b729f22d5cc2d25a191261f305c490f6b9fb80502f1573bbfcb5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f7379353329fd73aec78e9341aa45682114697e0004bf552ad0045f91cb141d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitTrim]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitTrim]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitTrim]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__536c76ecd8d94bd7e11087d9c0ad8faadd149ecb1fecfb7b28d828450e81f4f0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitTrimOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitTrimOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d1005bc347c479459974df17f32ad2292e71f35b8c36fa0afd6eefdd329ef25f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetFuzz")
    def reset_fuzz(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFuzz", []))

    @jsii.member(jsii_name="resetFuzzVar")
    def reset_fuzz_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFuzzVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @builtins.property
    @jsii.member(jsii_name="fuzzInput")
    def fuzz_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fuzzInput"))

    @builtins.property
    @jsii.member(jsii_name="fuzzVarInput")
    def fuzz_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fuzzVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="fuzz")
    def fuzz(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fuzz"))

    @fuzz.setter
    def fuzz(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0da431543ba60dee54631dbc5bbfdb8663131b77c568afb0a024c418f50d89ef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fuzz", value)

    @builtins.property
    @jsii.member(jsii_name="fuzzVar")
    def fuzz_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fuzzVar"))

    @fuzz_var.setter
    def fuzz_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0635543ab4ac4ae3ffe31f67897d73921856abecc0efe87cb19d148f13cfd213)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fuzzVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a619402b6c7e9b123461021b44f073d3cc65442d026dcdf3056e3820f44c5140)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__51bd0d75f5efa63b24f7787f5fc2e832911689026a51d9b85f60b7db14ac78ea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitTrim]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitTrim]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitTrim]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6801462dff985b45abe4e9782be9727cab9b5b648d8bc9200900f9e3ee9c0624)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitUnsharpMask",
    jsii_struct_bases=[],
    name_mapping={
        "gain": "gain",
        "gain_var": "gainVar",
        "sigma": "sigma",
        "sigma_var": "sigmaVar",
        "threshold": "threshold",
        "threshold_var": "thresholdVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitUnsharpMask:
    def __init__(
        self,
        *,
        gain: typing.Optional[builtins.str] = None,
        gain_var: typing.Optional[builtins.str] = None,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
        threshold: typing.Optional[builtins.str] = None,
        threshold_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param gain: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        :param gain_var: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        :param sigma: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        :param threshold: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        :param threshold_var: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d3b4f36a05750a9ccaf9f3f2e3599037de00ad61a45d4ee3ef27fa41ef189eca)
            check_type(argname="argument gain", value=gain, expected_type=type_hints["gain"])
            check_type(argname="argument gain_var", value=gain_var, expected_type=type_hints["gain_var"])
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
            check_type(argname="argument threshold", value=threshold, expected_type=type_hints["threshold"])
            check_type(argname="argument threshold_var", value=threshold_var, expected_type=type_hints["threshold_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if gain is not None:
            self._values["gain"] = gain
        if gain_var is not None:
            self._values["gain_var"] = gain_var
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var
        if threshold is not None:
            self._values["threshold"] = threshold
        if threshold_var is not None:
            self._values["threshold_var"] = threshold_var

    @builtins.property
    def gain(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        '''
        result = self._values.get("gain")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gain_var(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        '''
        result = self._values.get("gain_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        '''
        result = self._values.get("threshold")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold_var(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        result = self._values.get("threshold_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitUnsharpMask(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitUnsharpMaskList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitUnsharpMaskList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__16de13c5b7c4267ee66b20b9695526f0a6799c4b2476da5c89f20a65f1e3a161)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitUnsharpMaskOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4024100466d4295cf8d787a0681b2a8b155ff1ec086446c12e74d65e55395feb)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitUnsharpMaskOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6cc6da990a34625f3beb3257afe376a9d3ecc1fb58b88101200baffccac27063)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__87328927571426c7fa6e1f29b67f827fd0c56a52f61f45d45272897e1ed38166)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5bcb4ec35a2fb9d7190e5936fa1366fbe8dc9414f9e400ab276f91eab3f2dd81)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitUnsharpMask]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitUnsharpMask]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitUnsharpMask]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__052722e66b433b5d96e25770274bc86c3634e8fd56b7affaf82b82e239e678f0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitUnsharpMaskOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitUnsharpMaskOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__361cc8168db787dfbc65249c157810f4c8e76e208a83e26fedbf4b6be0b9a734)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetGain")
    def reset_gain(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGain", []))

    @jsii.member(jsii_name="resetGainVar")
    def reset_gain_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGainVar", []))

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @jsii.member(jsii_name="resetThreshold")
    def reset_threshold(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThreshold", []))

    @jsii.member(jsii_name="resetThresholdVar")
    def reset_threshold_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThresholdVar", []))

    @builtins.property
    @jsii.member(jsii_name="gainInput")
    def gain_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainInput"))

    @builtins.property
    @jsii.member(jsii_name="gainVarInput")
    def gain_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdInput")
    def threshold_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdVarInput")
    def threshold_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gain")
    def gain(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gain"))

    @gain.setter
    def gain(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f4abd2bfd4b10425cf9ce52b654255d5f222c592c11c8d448f37b40bc57424a5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gain", value)

    @builtins.property
    @jsii.member(jsii_name="gainVar")
    def gain_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gainVar"))

    @gain_var.setter
    def gain_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d8203ad66c2a13aaf3373bc5f437f19046536dd48f3ca819e7a269290ae98ccb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gainVar", value)

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__09f9c138fd49d64384bb8efd2cfcf543f0afc86ab037d4603132fd7baaf9767d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6959701e1584322f8768b8b35a94c9196483a71238f676d9f1cf8d813ef50bb4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="threshold")
    def threshold(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "threshold"))

    @threshold.setter
    def threshold(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4b3648e94858f2c713c75176e3de11853d8db2f395bcbfecfdbd65571483c519)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "threshold", value)

    @builtins.property
    @jsii.member(jsii_name="thresholdVar")
    def threshold_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "thresholdVar"))

    @threshold_var.setter
    def threshold_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0d06c7e0506ca99eead3b7730e37c61155946b7302a9700ea71db301f31eca94)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "thresholdVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitUnsharpMask]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitUnsharpMask]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitUnsharpMask]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fdbc1820ccff4f7358b75caa6fcc67cc7b7440e3baf89d9fcc9e0d59f43d6adb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquare",
    jsii_struct_bases=[],
    name_mapping={
        "append": "append",
        "aspect_crop": "aspectCrop",
        "background_color": "backgroundColor",
        "blur": "blur",
        "chroma_key": "chromaKey",
        "composite": "composite",
        "compound": "compound",
        "contrast": "contrast",
        "crop": "crop",
        "face_crop": "faceCrop",
        "feature_crop": "featureCrop",
        "fit_and_fill": "fitAndFill",
        "goop": "goop",
        "grayscale": "grayscale",
        "hsl": "hsl",
        "hsv": "hsv",
        "if_dimension": "ifDimension",
        "if_orientation": "ifOrientation",
        "im_query": "imQuery",
        "max_colors": "maxColors",
        "mirror": "mirror",
        "mono_hue": "monoHue",
        "opacity": "opacity",
        "region_of_interest_crop": "regionOfInterestCrop",
        "relative_crop": "relativeCrop",
        "remove_color": "removeColor",
        "resize": "resize",
        "rotate": "rotate",
        "scale": "scale",
        "shear": "shear",
        "trim": "trim",
        "unsharp_mask": "unsharpMask",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquare:
    def __init__(
        self,
        *,
        append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppend", typing.Dict[builtins.str, typing.Any]]]]] = None,
        aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAspectCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareBackgroundColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareBlur", typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareChromaKey", typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareComposite", typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompound", typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareContrast", typing.Dict[builtins.str, typing.Any]]]]] = None,
        crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFaceCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFeatureCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFill", typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareGoop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareGrayscale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareHsl", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareHsv", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimension", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
        im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareImQuery", typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareMaxColors", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareMirror", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareMonoHue", typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareOpacity", typing.Dict[builtins.str, typing.Any]]]]] = None,
        region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRelativeCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRemoveColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareResize", typing.Dict[builtins.str, typing.Any]]]]] = None,
        rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRotate", typing.Dict[builtins.str, typing.Any]]]]] = None,
        scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareScale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareShear", typing.Dict[builtins.str, typing.Any]]]]] = None,
        trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareTrim", typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareUnsharpMask", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param append: append block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        :param aspect_crop: aspect_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param crop: crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        :param face_crop: face_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        :param feature_crop: feature_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        :param fit_and_fill: fit_and_fill block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param im_query: im_query block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param region_of_interest_crop: region_of_interest_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        :param relative_crop: relative_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param resize: resize block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        :param rotate: rotate block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        :param scale: scale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param shear: shear block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        :param trim: trim block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__993c793d5c3e239961b91c70259f1180f43f1e551306e81380c4f6a51988f26d)
            check_type(argname="argument append", value=append, expected_type=type_hints["append"])
            check_type(argname="argument aspect_crop", value=aspect_crop, expected_type=type_hints["aspect_crop"])
            check_type(argname="argument background_color", value=background_color, expected_type=type_hints["background_color"])
            check_type(argname="argument blur", value=blur, expected_type=type_hints["blur"])
            check_type(argname="argument chroma_key", value=chroma_key, expected_type=type_hints["chroma_key"])
            check_type(argname="argument composite", value=composite, expected_type=type_hints["composite"])
            check_type(argname="argument compound", value=compound, expected_type=type_hints["compound"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument crop", value=crop, expected_type=type_hints["crop"])
            check_type(argname="argument face_crop", value=face_crop, expected_type=type_hints["face_crop"])
            check_type(argname="argument feature_crop", value=feature_crop, expected_type=type_hints["feature_crop"])
            check_type(argname="argument fit_and_fill", value=fit_and_fill, expected_type=type_hints["fit_and_fill"])
            check_type(argname="argument goop", value=goop, expected_type=type_hints["goop"])
            check_type(argname="argument grayscale", value=grayscale, expected_type=type_hints["grayscale"])
            check_type(argname="argument hsl", value=hsl, expected_type=type_hints["hsl"])
            check_type(argname="argument hsv", value=hsv, expected_type=type_hints["hsv"])
            check_type(argname="argument if_dimension", value=if_dimension, expected_type=type_hints["if_dimension"])
            check_type(argname="argument if_orientation", value=if_orientation, expected_type=type_hints["if_orientation"])
            check_type(argname="argument im_query", value=im_query, expected_type=type_hints["im_query"])
            check_type(argname="argument max_colors", value=max_colors, expected_type=type_hints["max_colors"])
            check_type(argname="argument mirror", value=mirror, expected_type=type_hints["mirror"])
            check_type(argname="argument mono_hue", value=mono_hue, expected_type=type_hints["mono_hue"])
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument region_of_interest_crop", value=region_of_interest_crop, expected_type=type_hints["region_of_interest_crop"])
            check_type(argname="argument relative_crop", value=relative_crop, expected_type=type_hints["relative_crop"])
            check_type(argname="argument remove_color", value=remove_color, expected_type=type_hints["remove_color"])
            check_type(argname="argument resize", value=resize, expected_type=type_hints["resize"])
            check_type(argname="argument rotate", value=rotate, expected_type=type_hints["rotate"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument shear", value=shear, expected_type=type_hints["shear"])
            check_type(argname="argument trim", value=trim, expected_type=type_hints["trim"])
            check_type(argname="argument unsharp_mask", value=unsharp_mask, expected_type=type_hints["unsharp_mask"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if append is not None:
            self._values["append"] = append
        if aspect_crop is not None:
            self._values["aspect_crop"] = aspect_crop
        if background_color is not None:
            self._values["background_color"] = background_color
        if blur is not None:
            self._values["blur"] = blur
        if chroma_key is not None:
            self._values["chroma_key"] = chroma_key
        if composite is not None:
            self._values["composite"] = composite
        if compound is not None:
            self._values["compound"] = compound
        if contrast is not None:
            self._values["contrast"] = contrast
        if crop is not None:
            self._values["crop"] = crop
        if face_crop is not None:
            self._values["face_crop"] = face_crop
        if feature_crop is not None:
            self._values["feature_crop"] = feature_crop
        if fit_and_fill is not None:
            self._values["fit_and_fill"] = fit_and_fill
        if goop is not None:
            self._values["goop"] = goop
        if grayscale is not None:
            self._values["grayscale"] = grayscale
        if hsl is not None:
            self._values["hsl"] = hsl
        if hsv is not None:
            self._values["hsv"] = hsv
        if if_dimension is not None:
            self._values["if_dimension"] = if_dimension
        if if_orientation is not None:
            self._values["if_orientation"] = if_orientation
        if im_query is not None:
            self._values["im_query"] = im_query
        if max_colors is not None:
            self._values["max_colors"] = max_colors
        if mirror is not None:
            self._values["mirror"] = mirror
        if mono_hue is not None:
            self._values["mono_hue"] = mono_hue
        if opacity is not None:
            self._values["opacity"] = opacity
        if region_of_interest_crop is not None:
            self._values["region_of_interest_crop"] = region_of_interest_crop
        if relative_crop is not None:
            self._values["relative_crop"] = relative_crop
        if remove_color is not None:
            self._values["remove_color"] = remove_color
        if resize is not None:
            self._values["resize"] = resize
        if rotate is not None:
            self._values["rotate"] = rotate
        if scale is not None:
            self._values["scale"] = scale
        if shear is not None:
            self._values["shear"] = shear
        if trim is not None:
            self._values["trim"] = trim
        if unsharp_mask is not None:
            self._values["unsharp_mask"] = unsharp_mask

    @builtins.property
    def append(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppend"]]]:
        '''append block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        '''
        result = self._values.get("append")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppend"]]], result)

    @builtins.property
    def aspect_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAspectCrop"]]]:
        '''aspect_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        '''
        result = self._values.get("aspect_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAspectCrop"]]], result)

    @builtins.property
    def background_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareBackgroundColor"]]]:
        '''background_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        '''
        result = self._values.get("background_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareBackgroundColor"]]], result)

    @builtins.property
    def blur(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareBlur"]]]:
        '''blur block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        '''
        result = self._values.get("blur")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareBlur"]]], result)

    @builtins.property
    def chroma_key(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareChromaKey"]]]:
        '''chroma_key block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        '''
        result = self._values.get("chroma_key")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareChromaKey"]]], result)

    @builtins.property
    def composite(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareComposite"]]]:
        '''composite block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        '''
        result = self._values.get("composite")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareComposite"]]], result)

    @builtins.property
    def compound(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompound"]]]:
        '''compound block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        '''
        result = self._values.get("compound")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompound"]]], result)

    @builtins.property
    def contrast(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareContrast"]]]:
        '''contrast block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareContrast"]]], result)

    @builtins.property
    def crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCrop"]]]:
        '''crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        '''
        result = self._values.get("crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCrop"]]], result)

    @builtins.property
    def face_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFaceCrop"]]]:
        '''face_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        '''
        result = self._values.get("face_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFaceCrop"]]], result)

    @builtins.property
    def feature_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFeatureCrop"]]]:
        '''feature_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        '''
        result = self._values.get("feature_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFeatureCrop"]]], result)

    @builtins.property
    def fit_and_fill(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFill"]]]:
        '''fit_and_fill block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        '''
        result = self._values.get("fit_and_fill")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFill"]]], result)

    @builtins.property
    def goop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareGoop"]]]:
        '''goop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        '''
        result = self._values.get("goop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareGoop"]]], result)

    @builtins.property
    def grayscale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareGrayscale"]]]:
        '''grayscale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        '''
        result = self._values.get("grayscale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareGrayscale"]]], result)

    @builtins.property
    def hsl(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareHsl"]]]:
        '''hsl block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        '''
        result = self._values.get("hsl")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareHsl"]]], result)

    @builtins.property
    def hsv(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareHsv"]]]:
        '''hsv block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        '''
        result = self._values.get("hsv")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareHsv"]]], result)

    @builtins.property
    def if_dimension(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimension"]]]:
        '''if_dimension block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        '''
        result = self._values.get("if_dimension")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimension"]]], result)

    @builtins.property
    def if_orientation(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientation]]]:
        '''if_orientation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        '''
        result = self._values.get("if_orientation")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientation]]], result)

    @builtins.property
    def im_query(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareImQuery"]]]:
        '''im_query block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        '''
        result = self._values.get("im_query")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareImQuery"]]], result)

    @builtins.property
    def max_colors(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareMaxColors"]]]:
        '''max_colors block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        '''
        result = self._values.get("max_colors")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareMaxColors"]]], result)

    @builtins.property
    def mirror(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareMirror"]]]:
        '''mirror block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        '''
        result = self._values.get("mirror")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareMirror"]]], result)

    @builtins.property
    def mono_hue(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareMonoHue"]]]:
        '''mono_hue block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        '''
        result = self._values.get("mono_hue")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareMonoHue"]]], result)

    @builtins.property
    def opacity(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareOpacity"]]]:
        '''opacity block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareOpacity"]]], result)

    @builtins.property
    def region_of_interest_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCrop"]]]:
        '''region_of_interest_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        '''
        result = self._values.get("region_of_interest_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCrop"]]], result)

    @builtins.property
    def relative_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRelativeCrop"]]]:
        '''relative_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        '''
        result = self._values.get("relative_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRelativeCrop"]]], result)

    @builtins.property
    def remove_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRemoveColor"]]]:
        '''remove_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        '''
        result = self._values.get("remove_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRemoveColor"]]], result)

    @builtins.property
    def resize(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareResize"]]]:
        '''resize block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        '''
        result = self._values.get("resize")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareResize"]]], result)

    @builtins.property
    def rotate(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRotate"]]]:
        '''rotate block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        '''
        result = self._values.get("rotate")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRotate"]]], result)

    @builtins.property
    def scale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareScale"]]]:
        '''scale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareScale"]]], result)

    @builtins.property
    def shear(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareShear"]]]:
        '''shear block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        '''
        result = self._values.get("shear")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareShear"]]], result)

    @builtins.property
    def trim(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareTrim"]]]:
        '''trim block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        '''
        result = self._values.get("trim")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareTrim"]]], result)

    @builtins.property
    def unsharp_mask(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareUnsharpMask"]]]:
        '''unsharp_mask block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        result = self._values.get("unsharp_mask")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareUnsharpMask"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquare(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppend",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_priority": "gravityPriority",
        "gravity_priority_var": "gravityPriorityVar",
        "gravity_var": "gravityVar",
        "preserve_minor_dimension": "preserveMinorDimension",
        "preserve_minor_dimension_var": "preserveMinorDimensionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppend:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_priority: typing.Optional[builtins.str] = None,
        gravity_priority_var: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        preserve_minor_dimension: typing.Optional[builtins.str] = None,
        preserve_minor_dimension_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Specifies where to place the ``image`` relative to the source image. The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_priority: Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal. The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority DataAkamaiImagingPolicyImage#gravity_priority}
        :param gravity_priority_var: Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal. The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority_var DataAkamaiImagingPolicyImage#gravity_priority_var}
        :param gravity_var: Specifies where to place the ``image`` relative to the source image. The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param preserve_minor_dimension: Whether to preserve the source image's minor dimension, ``false`` by default. The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension DataAkamaiImagingPolicyImage#preserve_minor_dimension}
        :param preserve_minor_dimension_var: Whether to preserve the source image's minor dimension, ``false`` by default. The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension_var DataAkamaiImagingPolicyImage#preserve_minor_dimension_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aba4e058b85e3109ad9d10b368e4d71cd13ca6fb58a690e9b852e0e4585d17ac)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_priority", value=gravity_priority, expected_type=type_hints["gravity_priority"])
            check_type(argname="argument gravity_priority_var", value=gravity_priority_var, expected_type=type_hints["gravity_priority_var"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument preserve_minor_dimension", value=preserve_minor_dimension, expected_type=type_hints["preserve_minor_dimension"])
            check_type(argname="argument preserve_minor_dimension_var", value=preserve_minor_dimension_var, expected_type=type_hints["preserve_minor_dimension_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_priority is not None:
            self._values["gravity_priority"] = gravity_priority
        if gravity_priority_var is not None:
            self._values["gravity_priority_var"] = gravity_priority_var
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if preserve_minor_dimension is not None:
            self._values["preserve_minor_dimension"] = preserve_minor_dimension
        if preserve_minor_dimension_var is not None:
            self._values["preserve_minor_dimension_var"] = preserve_minor_dimension_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Specifies where to place the ``image`` relative to the source image.

        The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_priority(self) -> typing.Optional[builtins.str]:
        '''Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal.

        The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority DataAkamaiImagingPolicyImage#gravity_priority}
        '''
        result = self._values.get("gravity_priority")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_priority_var(self) -> typing.Optional[builtins.str]:
        '''Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal.

        The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority_var DataAkamaiImagingPolicyImage#gravity_priority_var}
        '''
        result = self._values.get("gravity_priority_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Specifies where to place the ``image`` relative to the source image.

        The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def preserve_minor_dimension(self) -> typing.Optional[builtins.str]:
        '''Whether to preserve the source image's minor dimension, ``false`` by default.

        The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension DataAkamaiImagingPolicyImage#preserve_minor_dimension}
        '''
        result = self._values.get("preserve_minor_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def preserve_minor_dimension_var(self) -> typing.Optional[builtins.str]:
        '''Whether to preserve the source image's minor dimension, ``false`` by default.

        The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension_var DataAkamaiImagingPolicyImage#preserve_minor_dimension_var}
        '''
        result = self._values.get("preserve_minor_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppend(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImage",
    jsii_struct_bases=[],
    name_mapping={
        "box_image": "boxImage",
        "circle_image": "circleImage",
        "text_image": "textImage",
        "url_image": "urlImage",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImage:
    def __init__(
        self,
        *,
        box_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageBoxImage", typing.Dict[builtins.str, typing.Any]]]]] = None,
        circle_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageCircleImage", typing.Dict[builtins.str, typing.Any]]]]] = None,
        text_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageTextImage", typing.Dict[builtins.str, typing.Any]]]]] = None,
        url_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageUrlImage", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param box_image: box_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#box_image DataAkamaiImagingPolicyImage#box_image}
        :param circle_image: circle_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#circle_image DataAkamaiImagingPolicyImage#circle_image}
        :param text_image: text_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text_image DataAkamaiImagingPolicyImage#text_image}
        :param url_image: url_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url_image DataAkamaiImagingPolicyImage#url_image}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3e1724f44e96fdb524033b693498dc9392c37f34db27f2076deabdc43acb72ac)
            check_type(argname="argument box_image", value=box_image, expected_type=type_hints["box_image"])
            check_type(argname="argument circle_image", value=circle_image, expected_type=type_hints["circle_image"])
            check_type(argname="argument text_image", value=text_image, expected_type=type_hints["text_image"])
            check_type(argname="argument url_image", value=url_image, expected_type=type_hints["url_image"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if box_image is not None:
            self._values["box_image"] = box_image
        if circle_image is not None:
            self._values["circle_image"] = circle_image
        if text_image is not None:
            self._values["text_image"] = text_image
        if url_image is not None:
            self._values["url_image"] = url_image

    @builtins.property
    def box_image(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageBoxImage"]]]:
        '''box_image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#box_image DataAkamaiImagingPolicyImage#box_image}
        '''
        result = self._values.get("box_image")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageBoxImage"]]], result)

    @builtins.property
    def circle_image(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageCircleImage"]]]:
        '''circle_image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#circle_image DataAkamaiImagingPolicyImage#circle_image}
        '''
        result = self._values.get("circle_image")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageCircleImage"]]], result)

    @builtins.property
    def text_image(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageTextImage"]]]:
        '''text_image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text_image DataAkamaiImagingPolicyImage#text_image}
        '''
        result = self._values.get("text_image")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageTextImage"]]], result)

    @builtins.property
    def url_image(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageUrlImage"]]]:
        '''url_image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url_image DataAkamaiImagingPolicyImage#url_image}
        '''
        result = self._values.get("url_image")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageUrlImage"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageBoxImage",
    jsii_struct_bases=[],
    name_mapping={
        "color": "color",
        "color_var": "colorVar",
        "height": "height",
        "height_var": "heightVar",
        "transformation": "transformation",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageBoxImage:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        transformation: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageBoxImageTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The fill color of the box, not the edge of the box. The API supports hexadecimal representation and CSS hexadecimal color values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The fill color of the box, not the edge of the box. The API supports hexadecimal representation and CSS hexadecimal color values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        :param height: The height of the box in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height of the box in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param transformation: transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        :param width: The width of the box in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width of the box in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(transformation, dict):
            transformation = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageBoxImageTransformation(**transformation)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d7ea9f3e03390871f735cba519aabcb8d1e4f62e88863155ff7f3fa503ef597)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument transformation", value=transformation, expected_type=type_hints["transformation"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if transformation is not None:
            self._values["transformation"] = transformation
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The fill color of the box, not the edge of the box.

        The API supports hexadecimal representation and CSS hexadecimal color values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The fill color of the box, not the edge of the box.

        The API supports hexadecimal representation and CSS hexadecimal color values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height of the box in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height of the box in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def transformation(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageBoxImageTransformation"]:
        '''transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        '''
        result = self._values.get("transformation")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageBoxImageTransformation"], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width of the box in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width of the box in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageBoxImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageBoxImageList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageBoxImageList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__624c667636cdeb5ae38c0fba558e22da2ea69cabb03a37d0426ff0a3d5561a47)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageBoxImageOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dab1a227167710740c653b1e9789cc37dc183e89b0bcdde8b94df7e86150d2a8)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageBoxImageOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d2e676870386318cd84ee13ceca90166b2356b7bcf2bb017ce0ac37e97f6616)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0a58b75a2af8e30a7356d65d576454ef2a2fab3b1083d8b834c1685d85b28371)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__96ba2f6ff7dc686bc3bc7f93e738e303a167299297f16ff1bdf054e70a95f3cb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageBoxImage]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageBoxImage]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageBoxImage]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__095586c23b05847678ad9655d5b5b89a093789e2b1585775cd95ece5824d5592)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageBoxImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageBoxImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ef0980b550bfe9c9c733fe9c3073bde4e39b4616dca8d018b6f68606e205ef7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformation")
    def put_transformation(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageBoxImageTransformation()

        return typing.cast(None, jsii.invoke(self, "putTransformation", [value]))

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetTransformation")
    def reset_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformation", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="transformation")
    def transformation(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageBoxImageTransformationOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageBoxImageTransformationOutputReference", jsii.get(self, "transformation"))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="transformationInput")
    def transformation_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageBoxImageTransformation"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageBoxImageTransformation"], jsii.get(self, "transformationInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e67a1c959c0b50d26b845794320ff76105e7eff2193c4269bb4a561acd69f3e2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4e8b03db97506086d26b82635313b49aeb5d506fea86482a3a6c2e1aa65fbb45)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8e1b4a26a2ddab6c3b4eb413e2fabd5c8d9cfe86eeffa4c590b1390d7dcbfb68)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c0c6cf6a1928a61ff3b06abcf086527e8f4385bafb46c38b7853b2e4aab4093c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0b991fd9a58005d2af6cea87217bd75cefa82a3069b5a861feb0f28c7dafc1f4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f061f55b7f6fb04780aa866f94c9724a67a382481844686da156878a9e699755)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageBoxImage]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageBoxImage]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageBoxImage]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__14761a8300a11627007fd54904a9a836db5c3432283eadd95905506790bd4914)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageBoxImageTransformation",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageBoxImageTransformation:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageBoxImageTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageBoxImageTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageBoxImageTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8ade5351787107421078c87e8fcc271111afa6f844d9a319456c8edb748dab0c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageBoxImageTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageBoxImageTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageBoxImageTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a136bd49b33b06fffe16576f89fffe9dfbad5eb03dd3100d99a1a0214301f58d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageCircleImage",
    jsii_struct_bases=[],
    name_mapping={
        "color": "color",
        "color_var": "colorVar",
        "diameter": "diameter",
        "diameter_var": "diameterVar",
        "transformation": "transformation",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageCircleImage:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
        diameter: typing.Optional[builtins.str] = None,
        diameter_var: typing.Optional[builtins.str] = None,
        transformation: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageCircleImageTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The fill color of the circle. The API supports hexadecimal representation and CSS hexadecimal color values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The fill color of the circle. The API supports hexadecimal representation and CSS hexadecimal color values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        :param diameter: The diameter of the circle. The diameter will be the width and the height of the image in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#diameter DataAkamaiImagingPolicyImage#diameter}
        :param diameter_var: The diameter of the circle. The diameter will be the width and the height of the image in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#diameter_var DataAkamaiImagingPolicyImage#diameter_var}
        :param transformation: transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        :param width: The width of the box in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width of the box in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(transformation, dict):
            transformation = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageCircleImageTransformation(**transformation)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0cddfdc4b9a0290230818ff1518ea0585db09a69b06ca1cec5838540657356db)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
            check_type(argname="argument diameter", value=diameter, expected_type=type_hints["diameter"])
            check_type(argname="argument diameter_var", value=diameter_var, expected_type=type_hints["diameter_var"])
            check_type(argname="argument transformation", value=transformation, expected_type=type_hints["transformation"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var
        if diameter is not None:
            self._values["diameter"] = diameter
        if diameter_var is not None:
            self._values["diameter_var"] = diameter_var
        if transformation is not None:
            self._values["transformation"] = transformation
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The fill color of the circle. The API supports hexadecimal representation and CSS hexadecimal color values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The fill color of the circle. The API supports hexadecimal representation and CSS hexadecimal color values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def diameter(self) -> typing.Optional[builtins.str]:
        '''The diameter of the circle. The diameter will be the width and the height of the image in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#diameter DataAkamaiImagingPolicyImage#diameter}
        '''
        result = self._values.get("diameter")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def diameter_var(self) -> typing.Optional[builtins.str]:
        '''The diameter of the circle. The diameter will be the width and the height of the image in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#diameter_var DataAkamaiImagingPolicyImage#diameter_var}
        '''
        result = self._values.get("diameter_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def transformation(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageCircleImageTransformation"]:
        '''transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        '''
        result = self._values.get("transformation")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageCircleImageTransformation"], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width of the box in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width of the box in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageCircleImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageCircleImageList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageCircleImageList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9b79a8ef1f2a740627a73bc58fd5ef3ab29cad6075c3e25f03ccfc2ca8a277ec)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageCircleImageOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4e703d15f4a653546df42683e14c0a2401961db6fa4179de625e5b14abd4744b)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageCircleImageOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__683d788dff32fe85e9d2e4b6fef9b9f2132255cfd9698249921078f6ade2dcad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6edb2ee506e14d07e6e285eb8663a58262f7b2f33cf797577d53f29f6f594095)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8491e02933405601b3de566bb47f2a5dc549a38f6f93f49a272974464547fd59)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageCircleImage]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageCircleImage]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageCircleImage]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a9f7e312c77b0bb3dc57bcb56e9b9f431d6a6f1dcca61d626fb0b26ed933d9db)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageCircleImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageCircleImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0219a7182d87b8d8311a49db68a7c04a022b4bf0f1dfd7f2ce90e0b41d69bdd0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformation")
    def put_transformation(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageCircleImageTransformation()

        return typing.cast(None, jsii.invoke(self, "putTransformation", [value]))

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @jsii.member(jsii_name="resetDiameter")
    def reset_diameter(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDiameter", []))

    @jsii.member(jsii_name="resetDiameterVar")
    def reset_diameter_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDiameterVar", []))

    @jsii.member(jsii_name="resetTransformation")
    def reset_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformation", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="transformation")
    def transformation(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageCircleImageTransformationOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageCircleImageTransformationOutputReference", jsii.get(self, "transformation"))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="diameterInput")
    def diameter_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "diameterInput"))

    @builtins.property
    @jsii.member(jsii_name="diameterVarInput")
    def diameter_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "diameterVarInput"))

    @builtins.property
    @jsii.member(jsii_name="transformationInput")
    def transformation_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageCircleImageTransformation"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageCircleImageTransformation"], jsii.get(self, "transformationInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9eba7fd320e31bdf78815258ebb0c4ad3b44e7d780ff6e3c69f3385bc511be8b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bf5f30e2c10a6f212fdab170d629bfb8e00bb5c52696f1727186fa41f38a7caa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="diameter")
    def diameter(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "diameter"))

    @diameter.setter
    def diameter(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a21917c1eb4726dcf16c32d586e9bc241974373dba264430c66cc9ef72de3e4a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "diameter", value)

    @builtins.property
    @jsii.member(jsii_name="diameterVar")
    def diameter_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "diameterVar"))

    @diameter_var.setter
    def diameter_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d9ba19299f8cf4a1607bb219708a3cbdb16ada3f30899371e04da355a790bd1d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "diameterVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__192502ef776c5501d1cf5355d4708222d526d42f1f7eba110b339745899a37f3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__49554166a0abf4be10766d29c83850941d2c3ee0c7082b66b2a2183ef9412acd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageCircleImage]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageCircleImage]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageCircleImage]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1c7ac0ff98512001a8179d72385f3575d62b4ef360a31bc0eec3c8282bd24905)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageCircleImageTransformation",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageCircleImageTransformation:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageCircleImageTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageCircleImageTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageCircleImageTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__380fec27c27f47fdac4487ec16156ff5517cefda1963eccae5146ca10507ff97)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageCircleImageTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageCircleImageTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageCircleImageTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__99ffbc1af9d5482aeca28206e42f5fdc46323b0b649751e12470dbff20f14e0c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f374717010db1e16a46683c799a48f80bf10b84fa07602c8c4a3ccccfe969160)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putBoxImage")
    def put_box_image(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageBoxImage, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__17fa0fec7173486968c5e9bbfec81b627e747de62cae618b6bd54cccd44cb7b1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBoxImage", [value]))

    @jsii.member(jsii_name="putCircleImage")
    def put_circle_image(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageCircleImage, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__12fb3bb2944322e5b73bf4b7b52ea68574e630c97485a94587fd3a22d4bd8f33)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCircleImage", [value]))

    @jsii.member(jsii_name="putTextImage")
    def put_text_image(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageTextImage", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__56379672857bca164754211e8e3ca54be974098fa0e49b1a97c2bfe9fec512b8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTextImage", [value]))

    @jsii.member(jsii_name="putUrlImage")
    def put_url_image(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageUrlImage", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__61d5d367ceff7a80ba2407ff92f0311c5cdc1049c04c531bb916a7b399796a5e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putUrlImage", [value]))

    @jsii.member(jsii_name="resetBoxImage")
    def reset_box_image(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBoxImage", []))

    @jsii.member(jsii_name="resetCircleImage")
    def reset_circle_image(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCircleImage", []))

    @jsii.member(jsii_name="resetTextImage")
    def reset_text_image(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTextImage", []))

    @jsii.member(jsii_name="resetUrlImage")
    def reset_url_image(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUrlImage", []))

    @builtins.property
    @jsii.member(jsii_name="boxImage")
    def box_image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageBoxImageList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageBoxImageList, jsii.get(self, "boxImage"))

    @builtins.property
    @jsii.member(jsii_name="circleImage")
    def circle_image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageCircleImageList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageCircleImageList, jsii.get(self, "circleImage"))

    @builtins.property
    @jsii.member(jsii_name="textImage")
    def text_image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageTextImageList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageTextImageList", jsii.get(self, "textImage"))

    @builtins.property
    @jsii.member(jsii_name="urlImage")
    def url_image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageUrlImageList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageUrlImageList", jsii.get(self, "urlImage"))

    @builtins.property
    @jsii.member(jsii_name="boxImageInput")
    def box_image_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageBoxImage]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageBoxImage]]], jsii.get(self, "boxImageInput"))

    @builtins.property
    @jsii.member(jsii_name="circleImageInput")
    def circle_image_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageCircleImage]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageCircleImage]]], jsii.get(self, "circleImageInput"))

    @builtins.property
    @jsii.member(jsii_name="textImageInput")
    def text_image_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageTextImage"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageTextImage"]]], jsii.get(self, "textImageInput"))

    @builtins.property
    @jsii.member(jsii_name="urlImageInput")
    def url_image_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageUrlImage"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageUrlImage"]]], jsii.get(self, "urlImageInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__72de26956d52236f33014b8618ecef80cdd05711f061dd46bc98e1c0131b4947)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageTextImage",
    jsii_struct_bases=[],
    name_mapping={
        "fill": "fill",
        "fill_var": "fillVar",
        "size": "size",
        "size_var": "sizeVar",
        "stroke": "stroke",
        "stroke_size": "strokeSize",
        "stroke_size_var": "strokeSizeVar",
        "stroke_var": "strokeVar",
        "text": "text",
        "text_var": "textVar",
        "transformation": "transformation",
        "typeface": "typeface",
        "typeface_var": "typefaceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageTextImage:
    def __init__(
        self,
        *,
        fill: typing.Optional[builtins.str] = None,
        fill_var: typing.Optional[builtins.str] = None,
        size: typing.Optional[builtins.str] = None,
        size_var: typing.Optional[builtins.str] = None,
        stroke: typing.Optional[builtins.str] = None,
        stroke_size: typing.Optional[builtins.str] = None,
        stroke_size_var: typing.Optional[builtins.str] = None,
        stroke_var: typing.Optional[builtins.str] = None,
        text: typing.Optional[builtins.str] = None,
        text_var: typing.Optional[builtins.str] = None,
        transformation: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageTextImageTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        typeface: typing.Optional[builtins.str] = None,
        typeface_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fill: The main fill color of the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill DataAkamaiImagingPolicyImage#fill}
        :param fill_var: The main fill color of the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_var DataAkamaiImagingPolicyImage#fill_var}
        :param size: The size in pixels to render the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#size DataAkamaiImagingPolicyImage#size}
        :param size_var: The size in pixels to render the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#size_var DataAkamaiImagingPolicyImage#size_var}
        :param stroke: The color for the outline of the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke DataAkamaiImagingPolicyImage#stroke}
        :param stroke_size: The thickness in points for the outline of the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_size DataAkamaiImagingPolicyImage#stroke_size}
        :param stroke_size_var: The thickness in points for the outline of the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_size_var DataAkamaiImagingPolicyImage#stroke_size_var}
        :param stroke_var: The color for the outline of the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_var DataAkamaiImagingPolicyImage#stroke_var}
        :param text: The line of text to render. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text DataAkamaiImagingPolicyImage#text}
        :param text_var: The line of text to render. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text_var DataAkamaiImagingPolicyImage#text_var}
        :param transformation: transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        :param typeface: The font family to apply to the text image. This may be a URL to a TrueType or WOFF (v1) typeface, or a string that refers to one of the standard built-in browser fonts. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#typeface DataAkamaiImagingPolicyImage#typeface}
        :param typeface_var: The font family to apply to the text image. This may be a URL to a TrueType or WOFF (v1) typeface, or a string that refers to one of the standard built-in browser fonts. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#typeface_var DataAkamaiImagingPolicyImage#typeface_var}
        '''
        if isinstance(transformation, dict):
            transformation = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageTextImageTransformation(**transformation)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d1e73261acff7898994d639fab118e667d899912ec9ee11adaba648740371656)
            check_type(argname="argument fill", value=fill, expected_type=type_hints["fill"])
            check_type(argname="argument fill_var", value=fill_var, expected_type=type_hints["fill_var"])
            check_type(argname="argument size", value=size, expected_type=type_hints["size"])
            check_type(argname="argument size_var", value=size_var, expected_type=type_hints["size_var"])
            check_type(argname="argument stroke", value=stroke, expected_type=type_hints["stroke"])
            check_type(argname="argument stroke_size", value=stroke_size, expected_type=type_hints["stroke_size"])
            check_type(argname="argument stroke_size_var", value=stroke_size_var, expected_type=type_hints["stroke_size_var"])
            check_type(argname="argument stroke_var", value=stroke_var, expected_type=type_hints["stroke_var"])
            check_type(argname="argument text", value=text, expected_type=type_hints["text"])
            check_type(argname="argument text_var", value=text_var, expected_type=type_hints["text_var"])
            check_type(argname="argument transformation", value=transformation, expected_type=type_hints["transformation"])
            check_type(argname="argument typeface", value=typeface, expected_type=type_hints["typeface"])
            check_type(argname="argument typeface_var", value=typeface_var, expected_type=type_hints["typeface_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fill is not None:
            self._values["fill"] = fill
        if fill_var is not None:
            self._values["fill_var"] = fill_var
        if size is not None:
            self._values["size"] = size
        if size_var is not None:
            self._values["size_var"] = size_var
        if stroke is not None:
            self._values["stroke"] = stroke
        if stroke_size is not None:
            self._values["stroke_size"] = stroke_size
        if stroke_size_var is not None:
            self._values["stroke_size_var"] = stroke_size_var
        if stroke_var is not None:
            self._values["stroke_var"] = stroke_var
        if text is not None:
            self._values["text"] = text
        if text_var is not None:
            self._values["text_var"] = text_var
        if transformation is not None:
            self._values["transformation"] = transformation
        if typeface is not None:
            self._values["typeface"] = typeface
        if typeface_var is not None:
            self._values["typeface_var"] = typeface_var

    @builtins.property
    def fill(self) -> typing.Optional[builtins.str]:
        '''The main fill color of the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill DataAkamaiImagingPolicyImage#fill}
        '''
        result = self._values.get("fill")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fill_var(self) -> typing.Optional[builtins.str]:
        '''The main fill color of the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_var DataAkamaiImagingPolicyImage#fill_var}
        '''
        result = self._values.get("fill_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def size(self) -> typing.Optional[builtins.str]:
        '''The size in pixels to render the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#size DataAkamaiImagingPolicyImage#size}
        '''
        result = self._values.get("size")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def size_var(self) -> typing.Optional[builtins.str]:
        '''The size in pixels to render the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#size_var DataAkamaiImagingPolicyImage#size_var}
        '''
        result = self._values.get("size_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def stroke(self) -> typing.Optional[builtins.str]:
        '''The color for the outline of the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke DataAkamaiImagingPolicyImage#stroke}
        '''
        result = self._values.get("stroke")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def stroke_size(self) -> typing.Optional[builtins.str]:
        '''The thickness in points for the outline of the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_size DataAkamaiImagingPolicyImage#stroke_size}
        '''
        result = self._values.get("stroke_size")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def stroke_size_var(self) -> typing.Optional[builtins.str]:
        '''The thickness in points for the outline of the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_size_var DataAkamaiImagingPolicyImage#stroke_size_var}
        '''
        result = self._values.get("stroke_size_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def stroke_var(self) -> typing.Optional[builtins.str]:
        '''The color for the outline of the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_var DataAkamaiImagingPolicyImage#stroke_var}
        '''
        result = self._values.get("stroke_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def text(self) -> typing.Optional[builtins.str]:
        '''The line of text to render.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text DataAkamaiImagingPolicyImage#text}
        '''
        result = self._values.get("text")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def text_var(self) -> typing.Optional[builtins.str]:
        '''The line of text to render.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text_var DataAkamaiImagingPolicyImage#text_var}
        '''
        result = self._values.get("text_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def transformation(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageTextImageTransformation"]:
        '''transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        '''
        result = self._values.get("transformation")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageTextImageTransformation"], result)

    @builtins.property
    def typeface(self) -> typing.Optional[builtins.str]:
        '''The font family to apply to the text image.

        This may be a URL to a TrueType or WOFF (v1) typeface, or a string that refers to one of the standard built-in browser fonts.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#typeface DataAkamaiImagingPolicyImage#typeface}
        '''
        result = self._values.get("typeface")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def typeface_var(self) -> typing.Optional[builtins.str]:
        '''The font family to apply to the text image.

        This may be a URL to a TrueType or WOFF (v1) typeface, or a string that refers to one of the standard built-in browser fonts.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#typeface_var DataAkamaiImagingPolicyImage#typeface_var}
        '''
        result = self._values.get("typeface_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageTextImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageTextImageList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageTextImageList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__85641a5ad650bef375dc05874f51b969cfa039bb219b3d92b5a99aa942c20658)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageTextImageOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__62480f2a273905cdc58157e19ff62acecb01229c26a78cd9f113d6c798d45bda)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageTextImageOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__897b1c95fddc8946ce8bb958a7bff203c04ae5b0fa4025e1e6ede13045abc7b5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8b7f78b1cd070bf8b94917e8092819772c82d8a7ef863f899180283e09fd51a9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cce48b74d04fc747abc0307743bea66877182e1f5410a91c7e83dbd440a97427)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageTextImage]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageTextImage]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageTextImage]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__589a641e0fcbcb8e12924a4f5bb086c4111bbc04198ffbf9902bb826e66c3c06)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageTextImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageTextImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__446c7f348f99f25e4d0231f0d56d1356bbd36693bffec17b81209b3ec182179f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformation")
    def put_transformation(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageTextImageTransformation()

        return typing.cast(None, jsii.invoke(self, "putTransformation", [value]))

    @jsii.member(jsii_name="resetFill")
    def reset_fill(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFill", []))

    @jsii.member(jsii_name="resetFillVar")
    def reset_fill_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFillVar", []))

    @jsii.member(jsii_name="resetSize")
    def reset_size(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSize", []))

    @jsii.member(jsii_name="resetSizeVar")
    def reset_size_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSizeVar", []))

    @jsii.member(jsii_name="resetStroke")
    def reset_stroke(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStroke", []))

    @jsii.member(jsii_name="resetStrokeSize")
    def reset_stroke_size(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStrokeSize", []))

    @jsii.member(jsii_name="resetStrokeSizeVar")
    def reset_stroke_size_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStrokeSizeVar", []))

    @jsii.member(jsii_name="resetStrokeVar")
    def reset_stroke_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStrokeVar", []))

    @jsii.member(jsii_name="resetText")
    def reset_text(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetText", []))

    @jsii.member(jsii_name="resetTextVar")
    def reset_text_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTextVar", []))

    @jsii.member(jsii_name="resetTransformation")
    def reset_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformation", []))

    @jsii.member(jsii_name="resetTypeface")
    def reset_typeface(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeface", []))

    @jsii.member(jsii_name="resetTypefaceVar")
    def reset_typeface_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypefaceVar", []))

    @builtins.property
    @jsii.member(jsii_name="transformation")
    def transformation(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageTextImageTransformationOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageTextImageTransformationOutputReference", jsii.get(self, "transformation"))

    @builtins.property
    @jsii.member(jsii_name="fillInput")
    def fill_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fillInput"))

    @builtins.property
    @jsii.member(jsii_name="fillVarInput")
    def fill_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fillVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sizeInput")
    def size_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sizeInput"))

    @builtins.property
    @jsii.member(jsii_name="sizeVarInput")
    def size_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sizeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="strokeInput")
    def stroke_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "strokeInput"))

    @builtins.property
    @jsii.member(jsii_name="strokeSizeInput")
    def stroke_size_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "strokeSizeInput"))

    @builtins.property
    @jsii.member(jsii_name="strokeSizeVarInput")
    def stroke_size_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "strokeSizeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="strokeVarInput")
    def stroke_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "strokeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="textInput")
    def text_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "textInput"))

    @builtins.property
    @jsii.member(jsii_name="textVarInput")
    def text_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "textVarInput"))

    @builtins.property
    @jsii.member(jsii_name="transformationInput")
    def transformation_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageTextImageTransformation"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageTextImageTransformation"], jsii.get(self, "transformationInput"))

    @builtins.property
    @jsii.member(jsii_name="typefaceInput")
    def typeface_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typefaceInput"))

    @builtins.property
    @jsii.member(jsii_name="typefaceVarInput")
    def typeface_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typefaceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="fill")
    def fill(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fill"))

    @fill.setter
    def fill(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b99a522b3ae915d6e37be075c681c3f618d67e3104956414474ddc86b63effcd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fill", value)

    @builtins.property
    @jsii.member(jsii_name="fillVar")
    def fill_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fillVar"))

    @fill_var.setter
    def fill_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__28c4cc4a959bde1245db96f49c24b27cd34b36096d2a42a9d8b39466694da1bc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fillVar", value)

    @builtins.property
    @jsii.member(jsii_name="size")
    def size(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "size"))

    @size.setter
    def size(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ad1b465bce59ac823e3202656da31f7f5e04a91f92f8bc3b0799d00ed8d6bb16)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "size", value)

    @builtins.property
    @jsii.member(jsii_name="sizeVar")
    def size_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sizeVar"))

    @size_var.setter
    def size_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__412adef70f494eadaffaa34fda6d2df60b86544d899bf913fb5a630a3660ed71)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sizeVar", value)

    @builtins.property
    @jsii.member(jsii_name="stroke")
    def stroke(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "stroke"))

    @stroke.setter
    def stroke(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ca1ecf7e3d52b10cad22b19c6327aeecf3e62403fbc38943c8c16ebe0491b7a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "stroke", value)

    @builtins.property
    @jsii.member(jsii_name="strokeSize")
    def stroke_size(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "strokeSize"))

    @stroke_size.setter
    def stroke_size(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c052f5f38bbdcc8549954f5a05dc057bb2ad0be73c160341f7aced97b9dbebfa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "strokeSize", value)

    @builtins.property
    @jsii.member(jsii_name="strokeSizeVar")
    def stroke_size_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "strokeSizeVar"))

    @stroke_size_var.setter
    def stroke_size_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8315b074d2b8f755bcc173bc43a53bcec16c6871ec235ebfe2c9df6ff1f188dd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "strokeSizeVar", value)

    @builtins.property
    @jsii.member(jsii_name="strokeVar")
    def stroke_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "strokeVar"))

    @stroke_var.setter
    def stroke_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5d7507a42e3eda315e46f5c8b7bf097564009ea13529f8f769e9dfdebb0549b1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "strokeVar", value)

    @builtins.property
    @jsii.member(jsii_name="text")
    def text(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "text"))

    @text.setter
    def text(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fb57ccf3ae91413a308a5efc8a39f48a7c6c981af9cd69412fc45ea5299b6d28)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "text", value)

    @builtins.property
    @jsii.member(jsii_name="textVar")
    def text_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "textVar"))

    @text_var.setter
    def text_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aaff2ad1b58ce373617f984340e91444a2c8f5b704b884391b4beb1b088db6d6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "textVar", value)

    @builtins.property
    @jsii.member(jsii_name="typeface")
    def typeface(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeface"))

    @typeface.setter
    def typeface(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d67363992f9cb8b388d1dd40aae09e404d71b0cfff6d5e4702f71f1e4ffcf404)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeface", value)

    @builtins.property
    @jsii.member(jsii_name="typefaceVar")
    def typeface_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typefaceVar"))

    @typeface_var.setter
    def typeface_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__de18d57fecd39c0e3acff62131143b782570b2cac911251c7e72dfde395114d6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typefaceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageTextImage]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageTextImage]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageTextImage]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__28f5b4085d10d6e19fe43fbbcab1d356f5af032bf5ba37b0205cc750ace3cb66)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageTextImageTransformation",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageTextImageTransformation:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageTextImageTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageTextImageTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageTextImageTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1fdfc9cee815d58a37e7b1207535b1d4282fad69c90e95fdd0ec53a28520a72f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageTextImageTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageTextImageTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageTextImageTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__844d5903aaa85850f978bec64b0fef8af8ee4d1fb22c974295f2f961e98b7811)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageUrlImage",
    jsii_struct_bases=[],
    name_mapping={
        "transformation": "transformation",
        "url": "url",
        "url_var": "urlVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageUrlImage:
    def __init__(
        self,
        *,
        transformation: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageUrlImageTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        url: typing.Optional[builtins.str] = None,
        url_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param transformation: transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        :param url: The URL of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url DataAkamaiImagingPolicyImage#url}
        :param url_var: The URL of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url_var DataAkamaiImagingPolicyImage#url_var}
        '''
        if isinstance(transformation, dict):
            transformation = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageUrlImageTransformation(**transformation)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e0e9b9348d1433ebe08b8afb1c8596ba99e0aed5cdcbd4cfef9343f6db9b2ac2)
            check_type(argname="argument transformation", value=transformation, expected_type=type_hints["transformation"])
            check_type(argname="argument url", value=url, expected_type=type_hints["url"])
            check_type(argname="argument url_var", value=url_var, expected_type=type_hints["url_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if transformation is not None:
            self._values["transformation"] = transformation
        if url is not None:
            self._values["url"] = url
        if url_var is not None:
            self._values["url_var"] = url_var

    @builtins.property
    def transformation(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageUrlImageTransformation"]:
        '''transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        '''
        result = self._values.get("transformation")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageUrlImageTransformation"], result)

    @builtins.property
    def url(self) -> typing.Optional[builtins.str]:
        '''The URL of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url DataAkamaiImagingPolicyImage#url}
        '''
        result = self._values.get("url")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def url_var(self) -> typing.Optional[builtins.str]:
        '''The URL of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url_var DataAkamaiImagingPolicyImage#url_var}
        '''
        result = self._values.get("url_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageUrlImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageUrlImageList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageUrlImageList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__56e891b401a5255c036ac2a51fb99ef0d956d175c938b646ad9ff2f5a6aeee6b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageUrlImageOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f6684038c67cf361bbf14439f503d66653b97e9e1a412edd132796666c708c7)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageUrlImageOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0973e35a8879c5d5cd7d22f92513161fe95d12213c23e28e185abbf17c1015f3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__416cc8a966ec0c0694ca4a118a8f2b3aae0da047283ee85cad82d52e90c61b0c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__564a11a9fb139fa6b6ce6627c7979416852e583ff8f4d4ef581fbdd8c7611eac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageUrlImage]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageUrlImage]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageUrlImage]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__860e93e2423971c2912a7697e875675664c39b2f30ede99606d731a9bfbdb3d3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageUrlImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageUrlImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c3e5e1d09b132dc4b142dd10278ac0eefc4308f1e49aefdce9dabd1825288a0a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformation")
    def put_transformation(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageUrlImageTransformation()

        return typing.cast(None, jsii.invoke(self, "putTransformation", [value]))

    @jsii.member(jsii_name="resetTransformation")
    def reset_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformation", []))

    @jsii.member(jsii_name="resetUrl")
    def reset_url(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUrl", []))

    @jsii.member(jsii_name="resetUrlVar")
    def reset_url_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUrlVar", []))

    @builtins.property
    @jsii.member(jsii_name="transformation")
    def transformation(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageUrlImageTransformationOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageUrlImageTransformationOutputReference", jsii.get(self, "transformation"))

    @builtins.property
    @jsii.member(jsii_name="transformationInput")
    def transformation_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageUrlImageTransformation"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageUrlImageTransformation"], jsii.get(self, "transformationInput"))

    @builtins.property
    @jsii.member(jsii_name="urlInput")
    def url_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "urlInput"))

    @builtins.property
    @jsii.member(jsii_name="urlVarInput")
    def url_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "urlVarInput"))

    @builtins.property
    @jsii.member(jsii_name="url")
    def url(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "url"))

    @url.setter
    def url(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__666966c8a063e82468144ce849725855f27b1fc4d4b16a85f087786adcbf47c5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "url", value)

    @builtins.property
    @jsii.member(jsii_name="urlVar")
    def url_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "urlVar"))

    @url_var.setter
    def url_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__84610994dcb47506ec9a8e32c135065c896fb7a95a70d94f4312251fdd726aec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "urlVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageUrlImage]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageUrlImage]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageUrlImage]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__34dbfe45e049ff8b940542dc222c6a5087a0c8cecc208b131a7de549ba5bad35)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageUrlImageTransformation",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageUrlImageTransformation:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageUrlImageTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageUrlImageTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageUrlImageTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__50bb9942282dd7f6ce17b67c8f6d2922ca0d247296bfe304b3c46942299aec21)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageUrlImageTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageUrlImageTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageUrlImageTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ea40f376b8e157ae9b06270e7d75f29cabafabdfc11ffad41e06780ab2ef033)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1daf303e27a7afb97c6d2cd5d8f9464abc5228da0c63ecf2506b040977b186b5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__74727195774c311c8f70e57a07d79174b511c214c3abb116731d238af9417c0b)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e5f976fe50ff2cea350205cc8b151614536e72c73667be823a86cbf34588a48b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1cf722e5b4b70df938a5ef12a1150927851740cdda227a2c4ac1d607ceb1af2d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2c2c06cdde2a8239de3f2ad5c2361c43b0e5dac0d06b5d63d1e6c93d4842d757)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppend]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppend]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppend]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3bee6f3fa42eccd1f14a0d0a5c9f96ab8714cf41d064793a146b5258fc716dc8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d0c95950363b7e1358bbe4d675d2cddaa02ee4d79d9b17ab91b3c32484606ec)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(
        self,
        *,
        box_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageBoxImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
        circle_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageCircleImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
        text_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageTextImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
        url_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageUrlImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param box_image: box_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#box_image DataAkamaiImagingPolicyImage#box_image}
        :param circle_image: circle_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#circle_image DataAkamaiImagingPolicyImage#circle_image}
        :param text_image: text_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text_image DataAkamaiImagingPolicyImage#text_image}
        :param url_image: url_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url_image DataAkamaiImagingPolicyImage#url_image}
        '''
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImage(
            box_image=box_image,
            circle_image=circle_image,
            text_image=text_image,
            url_image=url_image,
        )

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityPriority")
    def reset_gravity_priority(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityPriority", []))

    @jsii.member(jsii_name="resetGravityPriorityVar")
    def reset_gravity_priority_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityPriorityVar", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPreserveMinorDimension")
    def reset_preserve_minor_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPreserveMinorDimension", []))

    @jsii.member(jsii_name="resetPreserveMinorDimensionVar")
    def reset_preserve_minor_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPreserveMinorDimensionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityInput")
    def gravity_priority_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityPriorityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityVarInput")
    def gravity_priority_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityPriorityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionInput")
    def preserve_minor_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "preserveMinorDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionVarInput")
    def preserve_minor_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "preserveMinorDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__688bd47011a8b6c24f7f1387663b277e822ae40954b3912de960fa454a3b4919)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityPriority")
    def gravity_priority(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityPriority"))

    @gravity_priority.setter
    def gravity_priority(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a5a6cb64616f8ce6903e76709b07c119c3992118cad142fb5b2d6ad4e2065c5a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityPriority", value)

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityVar")
    def gravity_priority_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityPriorityVar"))

    @gravity_priority_var.setter
    def gravity_priority_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__80e71d1cb2a90b3ba6f61dc1a92a81a39db5a32c529a0dcae1a83d8a98fc8bf8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityPriorityVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ca32b87d5cf6c3406515872ac946fc2cfae83654fabd3ecbcc1dcc3069b2486c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimension")
    def preserve_minor_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "preserveMinorDimension"))

    @preserve_minor_dimension.setter
    def preserve_minor_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__40c6fe1d6a5110a869298bb2472095076ef70cf751ab5657d46769df1e2d7697)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "preserveMinorDimension", value)

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionVar")
    def preserve_minor_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "preserveMinorDimensionVar"))

    @preserve_minor_dimension_var.setter
    def preserve_minor_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__007daf5b9c4088f00d3360c1e9b5d091783a38b1a9f6f473f1669ffdc071db25)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "preserveMinorDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppend]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppend]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppend]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__51ea7044a9d68e5ee130c7b0934e13580363de46ac686258284cc69a55eb8fc7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAspectCrop",
    jsii_struct_bases=[],
    name_mapping={
        "allow_expansion": "allowExpansion",
        "allow_expansion_var": "allowExpansionVar",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAspectCrop:
    def __init__(
        self,
        *,
        allow_expansion: typing.Optional[builtins.str] = None,
        allow_expansion_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_expansion: Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image. Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        :param allow_expansion_var: Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image. Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        :param height: The height term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The width term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        :param x_position: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d96d0e4b106ee3e54d6f13c336eeac8351c3e41ea2e4874144ff6a38869805a)
            check_type(argname="argument allow_expansion", value=allow_expansion, expected_type=type_hints["allow_expansion"])
            check_type(argname="argument allow_expansion_var", value=allow_expansion_var, expected_type=type_hints["allow_expansion_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if allow_expansion is not None:
            self._values["allow_expansion"] = allow_expansion
        if allow_expansion_var is not None:
            self._values["allow_expansion_var"] = allow_expansion_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def allow_expansion(self) -> typing.Optional[builtins.str]:
        '''Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image.

        Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        '''
        result = self._values.get("allow_expansion")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def allow_expansion_var(self) -> typing.Optional[builtins.str]:
        '''Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image.

        Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        '''
        result = self._values.get("allow_expansion_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAspectCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAspectCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAspectCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d81e7fd553fbe42d10d6d44db96b1fe6330c0f5702a9189dbaba086b7cbeb8c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAspectCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__23dfab02b9ef0da35cd551afbfe9c60e7012d617fe8f8a88e8f16342f67015ef)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAspectCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e9d54f76071f15b251ebc630f124564251fb75bf2706f7aa232d5ef7556bf0a4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0c799f506993254be6952e9b4e6ce135bfc2a2daaef90846167eaa4ea470b7d5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__56736581016e09021e2655c090568d11fbc9b5d8440e3ec7aceae879392f3c23)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAspectCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAspectCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAspectCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6bb5178944eff3d72d824632c6ed7e44227d7a42b93422fc6b8f7b11fb283609)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAspectCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAspectCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f55f02a69af2fd6e7c95afa7fdd56a555cefb9df6d4c936b003af6167be6ff4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAllowExpansion")
    def reset_allow_expansion(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansion", []))

    @jsii.member(jsii_name="resetAllowExpansionVar")
    def reset_allow_expansion_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansionVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionInput")
    def allow_expansion_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVarInput")
    def allow_expansion_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansion")
    def allow_expansion(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansion"))

    @allow_expansion.setter
    def allow_expansion(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f1f923772eb735bd6f4caca3a3781f540a98334872de0ee4392702d604dec6ca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansion", value)

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVar")
    def allow_expansion_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansionVar"))

    @allow_expansion_var.setter
    def allow_expansion_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a918ace7ffc3aa1a1425cd0121dd89c605a312ddaef062436f702e65c7511cad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansionVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b5339db441a23a974de17021327c7efc4d53f4673cc942533641a94dbc4fcbfe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e098551bf86fd930993192f7b3dfc0f0c8c3b6e2ca87bea11f1f979030502ee5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c1209869d8246e7ed1f7f1c70903f1e5438decc3aed34be667175d7254b24877)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dacf8f00ec2dc3fb74307e4d3ce6359a1d135dd0a2ac5f67e0f54421cdf33c81)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5319a1b03d74ea46918d237a89d1c421127fc062da9aaa5d9657aabe498880b3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__de1ee5446324dce8d69bc22620abb233885655bdf2a69aad4d716a46e3c714a0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__147c599d1b6d8f1cc22489497f99f1ba4b20190e7c5e891ea25ea5de94d38283)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d5cf91bf8cda82d844f0b671f0e26f5e1ac0b950ce243c6f0d263a60b8a4bfa0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAspectCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAspectCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAspectCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2df3dd0aad17402198287546a771d7baadd4e70d1762314e5f8229233a99b54f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareBackgroundColor",
    jsii_struct_bases=[],
    name_mapping={"color": "color", "color_var": "colorVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareBackgroundColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3dad1fffe85ae37b4b17f6a75a22fe6aef40c3e1c1bcfeb4bf712872ea9d7874)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareBackgroundColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareBackgroundColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareBackgroundColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__210117cc3569de7cc7ec4897781953db7de5e2a6caa7ef94543da48da5d8c84e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareBackgroundColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f8d963e894b5541f2f68132af58dfb2e5a7705088c49e20c0a8fd3fc99eeb924)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareBackgroundColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d3c9cfd418db6f5ec93307db9210509c189c34311cc234cc77a35398c32cdabe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__26327a389ca585d4c8d4953ec79f985aba9cbf38426fedfea9d7fd5146f5de62)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab2adad84d2fb48ce1072fdce5214a80720b9f75bf179476d85e63524e423bf2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareBackgroundColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareBackgroundColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ff537e42c22cd1e0f7e07470f7e0db0dbf2bfe0159e95712e28507e4fe90b36)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareBackgroundColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareBackgroundColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e99cb152fd5c07c77ca2110275401b71260d209818c5efe62e9aad33d2e22271)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__159f349038eee89e6adf9d6dedfd79d6bb00e5a6e9f40f889962bf5ac6aaebd1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__18e278bd36e257880a21117bee9a0fa3635954e82a2ddbfddf1f07d808e8fcd7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareBackgroundColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareBackgroundColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareBackgroundColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c69cfbd591c715d12f8f3aaafc97ddf5f7f1d9f4754bb9e9c697d38327307308)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareBlur",
    jsii_struct_bases=[],
    name_mapping={"sigma": "sigma", "sigma_var": "sigmaVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareBlur:
    def __init__(
        self,
        *,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param sigma: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f65f56658e22eef9b632730fc075d0ef0a688cb1ea49994607bb34f7b1eb3d12)
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareBlur(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareBlurList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareBlurList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__59c545b9015eb09ebacce713b2574c48bd10b2c25a42714a2f8ad153cf160639)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareBlurOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8b8bf8775873e48d81770a44ddb959913a3d2206b893a9b07d71390633776cb4)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareBlurOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb748484962a450244b03c2a7ac093b579cafbd98445be7158b9adff1c85612b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab3f5dd2799281f626551f6c8dccfa9cb5c1bb23c5548f8f3cff09dca6a70351)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3b2037ce57f1bfa9418f90db03bffa3f2a08e5a4eda76e6094cada71a56e56fb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareBlur]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareBlur]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f62fee977b30e09d6a358e5f56e253d25f32b3c61c4ee83a7c88cae294cc753)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareBlurOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareBlurOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ad14b67475122a6a12d78f1dd59630def7bae6fea53b7068ccac98cbf272569)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__28998d6c58b108d2f4d2802c86889652a85a440a46755f7a004c6918498ebfc9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__08fed26625ba83ccb896065a2919d1296a0aba81b03ee3a02d3bc504de7be5bf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareBlur]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareBlur]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareBlur]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__163a8ec1d8df63fc0ee5778b902f0557fa34ba18e171f0cadea7e8022483ce4e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareChromaKey",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_feather": "hueFeather",
        "hue_feather_var": "hueFeatherVar",
        "hue_tolerance": "hueTolerance",
        "hue_tolerance_var": "hueToleranceVar",
        "hue_var": "hueVar",
        "lightness_feather": "lightnessFeather",
        "lightness_feather_var": "lightnessFeatherVar",
        "lightness_tolerance": "lightnessTolerance",
        "lightness_tolerance_var": "lightnessToleranceVar",
        "saturation_feather": "saturationFeather",
        "saturation_feather_var": "saturationFeatherVar",
        "saturation_tolerance": "saturationTolerance",
        "saturation_tolerance_var": "saturationToleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareChromaKey:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_feather: typing.Optional[builtins.str] = None,
        hue_feather_var: typing.Optional[builtins.str] = None,
        hue_tolerance: typing.Optional[builtins.str] = None,
        hue_tolerance_var: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness_feather: typing.Optional[builtins.str] = None,
        lightness_feather_var: typing.Optional[builtins.str] = None,
        lightness_tolerance: typing.Optional[builtins.str] = None,
        lightness_tolerance_var: typing.Optional[builtins.str] = None,
        saturation_feather: typing.Optional[builtins.str] = None,
        saturation_feather_var: typing.Optional[builtins.str] = None,
        saturation_tolerance: typing.Optional[builtins.str] = None,
        saturation_tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_feather: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        :param hue_feather_var: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        :param hue_tolerance: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        :param hue_tolerance_var: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        :param hue_var: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness_feather: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        :param lightness_feather_var: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        :param lightness_tolerance: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        :param lightness_tolerance_var: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        :param saturation_feather: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        :param saturation_feather_var: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        :param saturation_tolerance: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        :param saturation_tolerance_var: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e3feaa6b0d709fa4c8d13d7d1733b2dbf69eee720e83980acac17cdee56f462a)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_feather", value=hue_feather, expected_type=type_hints["hue_feather"])
            check_type(argname="argument hue_feather_var", value=hue_feather_var, expected_type=type_hints["hue_feather_var"])
            check_type(argname="argument hue_tolerance", value=hue_tolerance, expected_type=type_hints["hue_tolerance"])
            check_type(argname="argument hue_tolerance_var", value=hue_tolerance_var, expected_type=type_hints["hue_tolerance_var"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness_feather", value=lightness_feather, expected_type=type_hints["lightness_feather"])
            check_type(argname="argument lightness_feather_var", value=lightness_feather_var, expected_type=type_hints["lightness_feather_var"])
            check_type(argname="argument lightness_tolerance", value=lightness_tolerance, expected_type=type_hints["lightness_tolerance"])
            check_type(argname="argument lightness_tolerance_var", value=lightness_tolerance_var, expected_type=type_hints["lightness_tolerance_var"])
            check_type(argname="argument saturation_feather", value=saturation_feather, expected_type=type_hints["saturation_feather"])
            check_type(argname="argument saturation_feather_var", value=saturation_feather_var, expected_type=type_hints["saturation_feather_var"])
            check_type(argname="argument saturation_tolerance", value=saturation_tolerance, expected_type=type_hints["saturation_tolerance"])
            check_type(argname="argument saturation_tolerance_var", value=saturation_tolerance_var, expected_type=type_hints["saturation_tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_feather is not None:
            self._values["hue_feather"] = hue_feather
        if hue_feather_var is not None:
            self._values["hue_feather_var"] = hue_feather_var
        if hue_tolerance is not None:
            self._values["hue_tolerance"] = hue_tolerance
        if hue_tolerance_var is not None:
            self._values["hue_tolerance_var"] = hue_tolerance_var
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness_feather is not None:
            self._values["lightness_feather"] = lightness_feather
        if lightness_feather_var is not None:
            self._values["lightness_feather_var"] = lightness_feather_var
        if lightness_tolerance is not None:
            self._values["lightness_tolerance"] = lightness_tolerance
        if lightness_tolerance_var is not None:
            self._values["lightness_tolerance_var"] = lightness_tolerance_var
        if saturation_feather is not None:
            self._values["saturation_feather"] = saturation_feather
        if saturation_feather_var is not None:
            self._values["saturation_feather_var"] = saturation_feather_var
        if saturation_tolerance is not None:
            self._values["saturation_tolerance"] = saturation_tolerance
        if saturation_tolerance_var is not None:
            self._values["saturation_tolerance_var"] = saturation_tolerance_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        '''
        result = self._values.get("hue_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        '''
        result = self._values.get("hue_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        '''
        result = self._values.get("hue_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        '''
        result = self._values.get("hue_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        '''
        result = self._values.get("lightness_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        '''
        result = self._values.get("lightness_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        '''
        result = self._values.get("lightness_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        '''
        result = self._values.get("lightness_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        '''
        result = self._values.get("saturation_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        '''
        result = self._values.get("saturation_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        '''
        result = self._values.get("saturation_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        result = self._values.get("saturation_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareChromaKey(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareChromaKeyList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareChromaKeyList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__45cc42c2fafffd209ada305028357ca6c819bd82a851cff00b57224ea9866f8d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareChromaKeyOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3911574df0c66ff1d3970282a03d71a296e0d757991d9b19f725e2c09e398898)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareChromaKeyOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0b00a210754bf9f4699aeb693cbda294ff694dc19b81581e4c317d828724e80e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9341e9b15cb0dd0d950f05a830bb1ef51a64c0f0bbe1e26ac99f3b2aa98bf06d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0dccf4519dbb1da3b37da04b182bd5eff1fadbe84ef13d5d41428175fddb98fa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareChromaKey]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareChromaKey]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a30846600ae1a58f714f52e76d2519bd9ecc38c3cc101714ec7f3905c4354a56)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareChromaKeyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareChromaKeyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3730f1ef287bea56d836dbf57a78208429d4049c89f224a2c97df3edafa4167e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueFeather")
    def reset_hue_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeather", []))

    @jsii.member(jsii_name="resetHueFeatherVar")
    def reset_hue_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeatherVar", []))

    @jsii.member(jsii_name="resetHueTolerance")
    def reset_hue_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueTolerance", []))

    @jsii.member(jsii_name="resetHueToleranceVar")
    def reset_hue_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueToleranceVar", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightnessFeather")
    def reset_lightness_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeather", []))

    @jsii.member(jsii_name="resetLightnessFeatherVar")
    def reset_lightness_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeatherVar", []))

    @jsii.member(jsii_name="resetLightnessTolerance")
    def reset_lightness_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessTolerance", []))

    @jsii.member(jsii_name="resetLightnessToleranceVar")
    def reset_lightness_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessToleranceVar", []))

    @jsii.member(jsii_name="resetSaturationFeather")
    def reset_saturation_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeather", []))

    @jsii.member(jsii_name="resetSaturationFeatherVar")
    def reset_saturation_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeatherVar", []))

    @jsii.member(jsii_name="resetSaturationTolerance")
    def reset_saturation_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationTolerance", []))

    @jsii.member(jsii_name="resetSaturationToleranceVar")
    def reset_saturation_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherInput")
    def hue_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVarInput")
    def hue_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceInput")
    def hue_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVarInput")
    def hue_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherInput")
    def lightness_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVarInput")
    def lightness_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceInput")
    def lightness_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVarInput")
    def lightness_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherInput")
    def saturation_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVarInput")
    def saturation_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceInput")
    def saturation_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVarInput")
    def saturation_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a07acb034120544a7f95f98ec2dc8f10b08d2ef24aa2947c56ab4599bdf22a9f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeather")
    def hue_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeather"))

    @hue_feather.setter
    def hue_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b1282e47a32132516d6798c58183283ed70cb6a93f46e4e463ccbdb10fd4474b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeather", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVar")
    def hue_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeatherVar"))

    @hue_feather_var.setter
    def hue_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__838e35b86599508646c3bf675888a623d67e0ba3194949f8a326f5467306f0a3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueTolerance")
    def hue_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueTolerance"))

    @hue_tolerance.setter
    def hue_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__52e8fbda80a8e8b7212c4a24255504636f058bc3b65687003c8ccd6f7575f57d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVar")
    def hue_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueToleranceVar"))

    @hue_tolerance_var.setter
    def hue_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__18b19b32292099116af704abe538faaf33b6564daf12d8c1e32c772a4241676f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a7508a4fdbde40aaa0163ae9d5c398f351da870e146b5fd8d67d6e33f8bac2b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeather")
    def lightness_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeather"))

    @lightness_feather.setter
    def lightness_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7c46512cc116152788ef2d1bbdf173055c168a78627d224c755cab49c91f1a33)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeather", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVar")
    def lightness_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeatherVar"))

    @lightness_feather_var.setter
    def lightness_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d0e0e0f806d5ca9de0cfb7a678f66e973e903e93b0552601bf1fd6b7cc2feb04)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessTolerance")
    def lightness_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessTolerance"))

    @lightness_tolerance.setter
    def lightness_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__da1e823ee8564d4a946b17dba62ed3efe9bb4f4e3a99a9466fc541e7c0b4ec72)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVar")
    def lightness_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessToleranceVar"))

    @lightness_tolerance_var.setter
    def lightness_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__faf4030ddd09ca19a4ef22f887c9320a9a38e1f71b5a5fa90edb8d69e44da99f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeather")
    def saturation_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeather"))

    @saturation_feather.setter
    def saturation_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e08bddc518a7a405035b0ec0604a3e7dff26bcb2656fad3418a952884d5add66)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeather", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVar")
    def saturation_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeatherVar"))

    @saturation_feather_var.setter
    def saturation_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__12932435cd0467e4694f1e961bcd5d8aacbbb4ca2d129ae0e5025d773041395a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationTolerance")
    def saturation_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationTolerance"))

    @saturation_tolerance.setter
    def saturation_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__82b66daef30aa5548bee47e1f4244f9ea9f24dd2722e55ae15cca90d5fb46e6e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVar")
    def saturation_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationToleranceVar"))

    @saturation_tolerance_var.setter
    def saturation_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0817cd1f8b28dd8f8308ffa3a9b2b4d78cb1739d634ac413736a9d43a1513fd3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareChromaKey]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareChromaKey]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareChromaKey]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__338b37d5c88b5a4cb5b4671a9f5dd314377480be289aedaa175ffbd0d2653c07)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareComposite",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "placement": "placement",
        "placement_var": "placementVar",
        "scale": "scale",
        "scale_dimension": "scaleDimension",
        "scale_dimension_var": "scaleDimensionVar",
        "scale_var": "scaleVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareComposite:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        placement: typing.Optional[builtins.str] = None,
        placement_var: typing.Optional[builtins.str] = None,
        scale: typing.Optional[builtins.str] = None,
        scale_dimension: typing.Optional[builtins.str] = None,
        scale_dimension_var: typing.Optional[builtins.str] = None,
        scale_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param placement: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        :param placement_var: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        :param scale: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param scale_dimension: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        :param scale_dimension_var: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        :param scale_var: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        :param x_position: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__09a1b0b34fe9aa2440b2a69f958e615151b964ce4ff8e2f39bb9f95850a432a9)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument placement", value=placement, expected_type=type_hints["placement"])
            check_type(argname="argument placement_var", value=placement_var, expected_type=type_hints["placement_var"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument scale_dimension", value=scale_dimension, expected_type=type_hints["scale_dimension"])
            check_type(argname="argument scale_dimension_var", value=scale_dimension_var, expected_type=type_hints["scale_dimension_var"])
            check_type(argname="argument scale_var", value=scale_var, expected_type=type_hints["scale_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if placement is not None:
            self._values["placement"] = placement
        if placement_var is not None:
            self._values["placement_var"] = placement_var
        if scale is not None:
            self._values["scale"] = scale
        if scale_dimension is not None:
            self._values["scale_dimension"] = scale_dimension
        if scale_dimension_var is not None:
            self._values["scale_dimension_var"] = scale_dimension_var
        if scale_var is not None:
            self._values["scale_var"] = scale_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        '''
        result = self._values.get("placement")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement_var(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        '''
        result = self._values.get("placement_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        '''
        result = self._values.get("scale_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        '''
        result = self._values.get("scale_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        '''
        result = self._values.get("scale_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareComposite(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImage",
    jsii_struct_bases=[],
    name_mapping={
        "box_image": "boxImage",
        "circle_image": "circleImage",
        "text_image": "textImage",
        "url_image": "urlImage",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImage:
    def __init__(
        self,
        *,
        box_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageBoxImage", typing.Dict[builtins.str, typing.Any]]]]] = None,
        circle_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageCircleImage", typing.Dict[builtins.str, typing.Any]]]]] = None,
        text_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageTextImage", typing.Dict[builtins.str, typing.Any]]]]] = None,
        url_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageUrlImage", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param box_image: box_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#box_image DataAkamaiImagingPolicyImage#box_image}
        :param circle_image: circle_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#circle_image DataAkamaiImagingPolicyImage#circle_image}
        :param text_image: text_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text_image DataAkamaiImagingPolicyImage#text_image}
        :param url_image: url_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url_image DataAkamaiImagingPolicyImage#url_image}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bd32fdfc84633eb7658077b51c8c0cdda827ecf598bb8572da748adb178ad5f7)
            check_type(argname="argument box_image", value=box_image, expected_type=type_hints["box_image"])
            check_type(argname="argument circle_image", value=circle_image, expected_type=type_hints["circle_image"])
            check_type(argname="argument text_image", value=text_image, expected_type=type_hints["text_image"])
            check_type(argname="argument url_image", value=url_image, expected_type=type_hints["url_image"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if box_image is not None:
            self._values["box_image"] = box_image
        if circle_image is not None:
            self._values["circle_image"] = circle_image
        if text_image is not None:
            self._values["text_image"] = text_image
        if url_image is not None:
            self._values["url_image"] = url_image

    @builtins.property
    def box_image(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageBoxImage"]]]:
        '''box_image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#box_image DataAkamaiImagingPolicyImage#box_image}
        '''
        result = self._values.get("box_image")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageBoxImage"]]], result)

    @builtins.property
    def circle_image(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageCircleImage"]]]:
        '''circle_image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#circle_image DataAkamaiImagingPolicyImage#circle_image}
        '''
        result = self._values.get("circle_image")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageCircleImage"]]], result)

    @builtins.property
    def text_image(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageTextImage"]]]:
        '''text_image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text_image DataAkamaiImagingPolicyImage#text_image}
        '''
        result = self._values.get("text_image")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageTextImage"]]], result)

    @builtins.property
    def url_image(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageUrlImage"]]]:
        '''url_image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url_image DataAkamaiImagingPolicyImage#url_image}
        '''
        result = self._values.get("url_image")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageUrlImage"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageBoxImage",
    jsii_struct_bases=[],
    name_mapping={
        "color": "color",
        "color_var": "colorVar",
        "height": "height",
        "height_var": "heightVar",
        "transformation": "transformation",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageBoxImage:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        transformation: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageBoxImageTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The fill color of the box, not the edge of the box. The API supports hexadecimal representation and CSS hexadecimal color values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The fill color of the box, not the edge of the box. The API supports hexadecimal representation and CSS hexadecimal color values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        :param height: The height of the box in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height of the box in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param transformation: transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        :param width: The width of the box in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width of the box in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(transformation, dict):
            transformation = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageBoxImageTransformation(**transformation)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cb6f285de431735dcdfe50c7ceac54d9646d0679bee7e93c78eee25ad930b728)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument transformation", value=transformation, expected_type=type_hints["transformation"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if transformation is not None:
            self._values["transformation"] = transformation
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The fill color of the box, not the edge of the box.

        The API supports hexadecimal representation and CSS hexadecimal color values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The fill color of the box, not the edge of the box.

        The API supports hexadecimal representation and CSS hexadecimal color values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height of the box in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height of the box in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def transformation(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageBoxImageTransformation"]:
        '''transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        '''
        result = self._values.get("transformation")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageBoxImageTransformation"], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width of the box in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width of the box in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageBoxImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageBoxImageList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageBoxImageList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0d9dfa77bc094017391528bd0a53d83791de442970a63bdc3da63a6291ea2c20)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageBoxImageOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__73f68241993096e11f7e9d6eeab439265040c4c3f1b734710ec49ac59618be8f)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageBoxImageOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__19939e9eab911d6fe0df30e330ca456581a746685160ae73f493ac0a1a17b7eb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c88e8e086a5720a8d7ce26a6968c7d4e7467f3618dab863057bc561e85cb058e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__72fc52c4333625281419503208b20caef9ae6a88027450337278a1ec2b66f016)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageBoxImage]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageBoxImage]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageBoxImage]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dcb297e097b1d8a902330e668195085f82afc2eac53fbbc51c4e5dab71972674)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageBoxImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageBoxImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__87ed50d2b2756fecbe52290c708438ee2afb9d8c4f17a96b1a7f01b30edbc808)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformation")
    def put_transformation(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageBoxImageTransformation()

        return typing.cast(None, jsii.invoke(self, "putTransformation", [value]))

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetTransformation")
    def reset_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformation", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="transformation")
    def transformation(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageBoxImageTransformationOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageBoxImageTransformationOutputReference", jsii.get(self, "transformation"))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="transformationInput")
    def transformation_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageBoxImageTransformation"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageBoxImageTransformation"], jsii.get(self, "transformationInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a1a807d8b75c1a957e995c9dc79bffa29b67f9a2e35f4ead570d79182c1b9d22)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9639490c521fdce5e0544a39909cb0f1c854f99c1bbe7163c0421e882937caa5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4168bd9f21387f9994a34f102fdf7cce233293d3ad7a51f6ec0e81bbda06c9d8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ab6f30315ad1b97398b1edfb1ce37e0d201aa7073e0b28dd5ca3183c23fb9ba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d685eb8b402275597d7ff5a511abd3f179b7dfe2df90dd8e0e424fe67735805c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fb5ef58e098d97abc11aa1868ff1ee20506a513cad5bdbdf4bf3c256e5856ac9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageBoxImage]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageBoxImage]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageBoxImage]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6490df8ce887e6d8f05c50e838f809fe30ca40fdfdff95b6b000abbddedca3ce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageBoxImageTransformation",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageBoxImageTransformation:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageBoxImageTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageBoxImageTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageBoxImageTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ac2fc59853b8e9569229538eb2bda1a543b7f709459daf43773a487241440c2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageBoxImageTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageBoxImageTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageBoxImageTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2bb026abbb9466f89446f5669ee79d35dec6486bf9178ac90eeb3641d30d2ca5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageCircleImage",
    jsii_struct_bases=[],
    name_mapping={
        "color": "color",
        "color_var": "colorVar",
        "diameter": "diameter",
        "diameter_var": "diameterVar",
        "transformation": "transformation",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageCircleImage:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
        diameter: typing.Optional[builtins.str] = None,
        diameter_var: typing.Optional[builtins.str] = None,
        transformation: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageCircleImageTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The fill color of the circle. The API supports hexadecimal representation and CSS hexadecimal color values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The fill color of the circle. The API supports hexadecimal representation and CSS hexadecimal color values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        :param diameter: The diameter of the circle. The diameter will be the width and the height of the image in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#diameter DataAkamaiImagingPolicyImage#diameter}
        :param diameter_var: The diameter of the circle. The diameter will be the width and the height of the image in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#diameter_var DataAkamaiImagingPolicyImage#diameter_var}
        :param transformation: transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        :param width: The width of the box in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width of the box in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(transformation, dict):
            transformation = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageCircleImageTransformation(**transformation)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__13b9ffaefcd5e0cb820a5d1175fa9c35c072212d1a0fc6c0b958169ddb95c548)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
            check_type(argname="argument diameter", value=diameter, expected_type=type_hints["diameter"])
            check_type(argname="argument diameter_var", value=diameter_var, expected_type=type_hints["diameter_var"])
            check_type(argname="argument transformation", value=transformation, expected_type=type_hints["transformation"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var
        if diameter is not None:
            self._values["diameter"] = diameter
        if diameter_var is not None:
            self._values["diameter_var"] = diameter_var
        if transformation is not None:
            self._values["transformation"] = transformation
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The fill color of the circle. The API supports hexadecimal representation and CSS hexadecimal color values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The fill color of the circle. The API supports hexadecimal representation and CSS hexadecimal color values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def diameter(self) -> typing.Optional[builtins.str]:
        '''The diameter of the circle. The diameter will be the width and the height of the image in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#diameter DataAkamaiImagingPolicyImage#diameter}
        '''
        result = self._values.get("diameter")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def diameter_var(self) -> typing.Optional[builtins.str]:
        '''The diameter of the circle. The diameter will be the width and the height of the image in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#diameter_var DataAkamaiImagingPolicyImage#diameter_var}
        '''
        result = self._values.get("diameter_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def transformation(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageCircleImageTransformation"]:
        '''transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        '''
        result = self._values.get("transformation")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageCircleImageTransformation"], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width of the box in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width of the box in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageCircleImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageCircleImageList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageCircleImageList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1a2c821ff5b70c580daab50a8408491df998057dd57d9e26fd7a754611afe6f6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageCircleImageOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__192a92873ae97e54a62dbec078b2546d85cc416ccfb02ac5b93033e000db23d1)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageCircleImageOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d5e17ca084ba4b8fccfc03bac8fc55bf0d3f58614c074b09aa3926dd25f3ee9c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0fd62cee7f4edba391d20969d30f38a8b8ccbd143754abf8ab8590621bbde4a2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__44ca69feb9ce1c31eaa069a3c3d88e21d9f658f0f2796108a69af0a9573f7458)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageCircleImage]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageCircleImage]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageCircleImage]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea440b1d35bfd484824cbfbbd2e1f128a6c63242e05b5e618d35856e99434dbe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageCircleImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageCircleImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7ec40324de8cb09fd8529568f9eba60a97c35814068d8a6b44e50df322c9da84)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformation")
    def put_transformation(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageCircleImageTransformation()

        return typing.cast(None, jsii.invoke(self, "putTransformation", [value]))

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @jsii.member(jsii_name="resetDiameter")
    def reset_diameter(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDiameter", []))

    @jsii.member(jsii_name="resetDiameterVar")
    def reset_diameter_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDiameterVar", []))

    @jsii.member(jsii_name="resetTransformation")
    def reset_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformation", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="transformation")
    def transformation(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageCircleImageTransformationOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageCircleImageTransformationOutputReference", jsii.get(self, "transformation"))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="diameterInput")
    def diameter_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "diameterInput"))

    @builtins.property
    @jsii.member(jsii_name="diameterVarInput")
    def diameter_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "diameterVarInput"))

    @builtins.property
    @jsii.member(jsii_name="transformationInput")
    def transformation_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageCircleImageTransformation"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageCircleImageTransformation"], jsii.get(self, "transformationInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb05aac6a1225270374a1d5a4620b25d989e6a0a17abe33559b4c979866a5ef3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__374b3a76e5e5f3c2c976bc8462974ddb2cc21a6eb366b5b6adb55d10adc8bd2b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="diameter")
    def diameter(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "diameter"))

    @diameter.setter
    def diameter(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__172642304ef19104ad9a12c02fcd255e3932dbcec666bec658311ae47c53a8a9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "diameter", value)

    @builtins.property
    @jsii.member(jsii_name="diameterVar")
    def diameter_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "diameterVar"))

    @diameter_var.setter
    def diameter_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__26f6eca577cc9bf1a07c4ccd4d1b513e247f87b861f26d08131c54f0a6a7e9e6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "diameterVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a6dfa9eb40a3002c0b8acd4f7cfc4c801dd05116d02f3f88cb783f170902b35e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a24ac70aa315aec7f8fc587bb7924bf390a41044cd6e171686687e0015b2c1b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageCircleImage]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageCircleImage]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageCircleImage]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c497249c6de4b483d9ebcdd3566dd177bc04f06fc9fc014671668fadb67a4aa5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageCircleImageTransformation",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageCircleImageTransformation:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageCircleImageTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageCircleImageTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageCircleImageTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c8fb9b87f3bca68ec99ff0ab2fc8b43a2f0b6125c173986b57d825d1374a0722)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageCircleImageTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageCircleImageTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageCircleImageTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__05a68bd7e26edd6da4c6b21a7008be075d3ade0a8ee7ecc2c4bc424e077b31a1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2808be132094089b2128dfd7d8a702475e4cdec9661680226cdb9da23285ca9c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putBoxImage")
    def put_box_image(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageBoxImage, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d504a27623b166313a06ba81421ee65da67a09f77eb6ddafb8f7e259d3c82fe0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBoxImage", [value]))

    @jsii.member(jsii_name="putCircleImage")
    def put_circle_image(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageCircleImage, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__25d1a0dcfeece0fadbd2bae7445db310daf4434159510a100f29782f74163607)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCircleImage", [value]))

    @jsii.member(jsii_name="putTextImage")
    def put_text_image(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageTextImage", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__96c0410581abaa7c2548efd991543d9479efc6e58bc70ea384b02cfb7b146620)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTextImage", [value]))

    @jsii.member(jsii_name="putUrlImage")
    def put_url_image(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageUrlImage", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__67777b14e9b95803b3de3d493d40ef67756b634127b541f1eb1d552a10617da7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putUrlImage", [value]))

    @jsii.member(jsii_name="resetBoxImage")
    def reset_box_image(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBoxImage", []))

    @jsii.member(jsii_name="resetCircleImage")
    def reset_circle_image(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCircleImage", []))

    @jsii.member(jsii_name="resetTextImage")
    def reset_text_image(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTextImage", []))

    @jsii.member(jsii_name="resetUrlImage")
    def reset_url_image(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUrlImage", []))

    @builtins.property
    @jsii.member(jsii_name="boxImage")
    def box_image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageBoxImageList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageBoxImageList, jsii.get(self, "boxImage"))

    @builtins.property
    @jsii.member(jsii_name="circleImage")
    def circle_image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageCircleImageList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageCircleImageList, jsii.get(self, "circleImage"))

    @builtins.property
    @jsii.member(jsii_name="textImage")
    def text_image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageTextImageList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageTextImageList", jsii.get(self, "textImage"))

    @builtins.property
    @jsii.member(jsii_name="urlImage")
    def url_image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageUrlImageList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageUrlImageList", jsii.get(self, "urlImage"))

    @builtins.property
    @jsii.member(jsii_name="boxImageInput")
    def box_image_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageBoxImage]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageBoxImage]]], jsii.get(self, "boxImageInput"))

    @builtins.property
    @jsii.member(jsii_name="circleImageInput")
    def circle_image_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageCircleImage]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageCircleImage]]], jsii.get(self, "circleImageInput"))

    @builtins.property
    @jsii.member(jsii_name="textImageInput")
    def text_image_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageTextImage"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageTextImage"]]], jsii.get(self, "textImageInput"))

    @builtins.property
    @jsii.member(jsii_name="urlImageInput")
    def url_image_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageUrlImage"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageUrlImage"]]], jsii.get(self, "urlImageInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e5f3eab9bb27b54ecf497439734cfc4a4fb3e60a777d3643563b22b7f6ee7440)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageTextImage",
    jsii_struct_bases=[],
    name_mapping={
        "fill": "fill",
        "fill_var": "fillVar",
        "size": "size",
        "size_var": "sizeVar",
        "stroke": "stroke",
        "stroke_size": "strokeSize",
        "stroke_size_var": "strokeSizeVar",
        "stroke_var": "strokeVar",
        "text": "text",
        "text_var": "textVar",
        "transformation": "transformation",
        "typeface": "typeface",
        "typeface_var": "typefaceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageTextImage:
    def __init__(
        self,
        *,
        fill: typing.Optional[builtins.str] = None,
        fill_var: typing.Optional[builtins.str] = None,
        size: typing.Optional[builtins.str] = None,
        size_var: typing.Optional[builtins.str] = None,
        stroke: typing.Optional[builtins.str] = None,
        stroke_size: typing.Optional[builtins.str] = None,
        stroke_size_var: typing.Optional[builtins.str] = None,
        stroke_var: typing.Optional[builtins.str] = None,
        text: typing.Optional[builtins.str] = None,
        text_var: typing.Optional[builtins.str] = None,
        transformation: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageTextImageTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        typeface: typing.Optional[builtins.str] = None,
        typeface_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fill: The main fill color of the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill DataAkamaiImagingPolicyImage#fill}
        :param fill_var: The main fill color of the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_var DataAkamaiImagingPolicyImage#fill_var}
        :param size: The size in pixels to render the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#size DataAkamaiImagingPolicyImage#size}
        :param size_var: The size in pixels to render the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#size_var DataAkamaiImagingPolicyImage#size_var}
        :param stroke: The color for the outline of the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke DataAkamaiImagingPolicyImage#stroke}
        :param stroke_size: The thickness in points for the outline of the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_size DataAkamaiImagingPolicyImage#stroke_size}
        :param stroke_size_var: The thickness in points for the outline of the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_size_var DataAkamaiImagingPolicyImage#stroke_size_var}
        :param stroke_var: The color for the outline of the text. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_var DataAkamaiImagingPolicyImage#stroke_var}
        :param text: The line of text to render. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text DataAkamaiImagingPolicyImage#text}
        :param text_var: The line of text to render. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text_var DataAkamaiImagingPolicyImage#text_var}
        :param transformation: transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        :param typeface: The font family to apply to the text image. This may be a URL to a TrueType or WOFF (v1) typeface, or a string that refers to one of the standard built-in browser fonts. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#typeface DataAkamaiImagingPolicyImage#typeface}
        :param typeface_var: The font family to apply to the text image. This may be a URL to a TrueType or WOFF (v1) typeface, or a string that refers to one of the standard built-in browser fonts. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#typeface_var DataAkamaiImagingPolicyImage#typeface_var}
        '''
        if isinstance(transformation, dict):
            transformation = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageTextImageTransformation(**transformation)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0be8639728c600db64bc87c64f163d98bdc1539c1e3c2724421235e09de40a6a)
            check_type(argname="argument fill", value=fill, expected_type=type_hints["fill"])
            check_type(argname="argument fill_var", value=fill_var, expected_type=type_hints["fill_var"])
            check_type(argname="argument size", value=size, expected_type=type_hints["size"])
            check_type(argname="argument size_var", value=size_var, expected_type=type_hints["size_var"])
            check_type(argname="argument stroke", value=stroke, expected_type=type_hints["stroke"])
            check_type(argname="argument stroke_size", value=stroke_size, expected_type=type_hints["stroke_size"])
            check_type(argname="argument stroke_size_var", value=stroke_size_var, expected_type=type_hints["stroke_size_var"])
            check_type(argname="argument stroke_var", value=stroke_var, expected_type=type_hints["stroke_var"])
            check_type(argname="argument text", value=text, expected_type=type_hints["text"])
            check_type(argname="argument text_var", value=text_var, expected_type=type_hints["text_var"])
            check_type(argname="argument transformation", value=transformation, expected_type=type_hints["transformation"])
            check_type(argname="argument typeface", value=typeface, expected_type=type_hints["typeface"])
            check_type(argname="argument typeface_var", value=typeface_var, expected_type=type_hints["typeface_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fill is not None:
            self._values["fill"] = fill
        if fill_var is not None:
            self._values["fill_var"] = fill_var
        if size is not None:
            self._values["size"] = size
        if size_var is not None:
            self._values["size_var"] = size_var
        if stroke is not None:
            self._values["stroke"] = stroke
        if stroke_size is not None:
            self._values["stroke_size"] = stroke_size
        if stroke_size_var is not None:
            self._values["stroke_size_var"] = stroke_size_var
        if stroke_var is not None:
            self._values["stroke_var"] = stroke_var
        if text is not None:
            self._values["text"] = text
        if text_var is not None:
            self._values["text_var"] = text_var
        if transformation is not None:
            self._values["transformation"] = transformation
        if typeface is not None:
            self._values["typeface"] = typeface
        if typeface_var is not None:
            self._values["typeface_var"] = typeface_var

    @builtins.property
    def fill(self) -> typing.Optional[builtins.str]:
        '''The main fill color of the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill DataAkamaiImagingPolicyImage#fill}
        '''
        result = self._values.get("fill")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fill_var(self) -> typing.Optional[builtins.str]:
        '''The main fill color of the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_var DataAkamaiImagingPolicyImage#fill_var}
        '''
        result = self._values.get("fill_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def size(self) -> typing.Optional[builtins.str]:
        '''The size in pixels to render the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#size DataAkamaiImagingPolicyImage#size}
        '''
        result = self._values.get("size")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def size_var(self) -> typing.Optional[builtins.str]:
        '''The size in pixels to render the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#size_var DataAkamaiImagingPolicyImage#size_var}
        '''
        result = self._values.get("size_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def stroke(self) -> typing.Optional[builtins.str]:
        '''The color for the outline of the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke DataAkamaiImagingPolicyImage#stroke}
        '''
        result = self._values.get("stroke")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def stroke_size(self) -> typing.Optional[builtins.str]:
        '''The thickness in points for the outline of the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_size DataAkamaiImagingPolicyImage#stroke_size}
        '''
        result = self._values.get("stroke_size")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def stroke_size_var(self) -> typing.Optional[builtins.str]:
        '''The thickness in points for the outline of the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_size_var DataAkamaiImagingPolicyImage#stroke_size_var}
        '''
        result = self._values.get("stroke_size_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def stroke_var(self) -> typing.Optional[builtins.str]:
        '''The color for the outline of the text.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_var DataAkamaiImagingPolicyImage#stroke_var}
        '''
        result = self._values.get("stroke_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def text(self) -> typing.Optional[builtins.str]:
        '''The line of text to render.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text DataAkamaiImagingPolicyImage#text}
        '''
        result = self._values.get("text")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def text_var(self) -> typing.Optional[builtins.str]:
        '''The line of text to render.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text_var DataAkamaiImagingPolicyImage#text_var}
        '''
        result = self._values.get("text_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def transformation(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageTextImageTransformation"]:
        '''transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        '''
        result = self._values.get("transformation")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageTextImageTransformation"], result)

    @builtins.property
    def typeface(self) -> typing.Optional[builtins.str]:
        '''The font family to apply to the text image.

        This may be a URL to a TrueType or WOFF (v1) typeface, or a string that refers to one of the standard built-in browser fonts.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#typeface DataAkamaiImagingPolicyImage#typeface}
        '''
        result = self._values.get("typeface")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def typeface_var(self) -> typing.Optional[builtins.str]:
        '''The font family to apply to the text image.

        This may be a URL to a TrueType or WOFF (v1) typeface, or a string that refers to one of the standard built-in browser fonts.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#typeface_var DataAkamaiImagingPolicyImage#typeface_var}
        '''
        result = self._values.get("typeface_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageTextImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageTextImageList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageTextImageList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3eefbfbc3e1b2f79f915d3fba669ff7e9fa0b1adcc3405a3ed6a3dc60d5c80df)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageTextImageOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__60fa8a5281f5b00ad8d4c11d17716490fb13259ede0846c40123264b9ca34b91)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageTextImageOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d7c03033401ff2accc97ca5e7ccf8d46b8a7f4fe0dafb86846f10e7e651467b9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fb218a695e3fcb4245a07371b4941f533f476ed7d6f7a40b5e452316555d7fce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__535179eed05d12a31d8da92996809f73ce384f7476a3e163e4d507daef122e5b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageTextImage]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageTextImage]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageTextImage]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2f441e03fabdb404e3407593a6fe587e587f22352d507ae72f75946ade8eb4ad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageTextImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageTextImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6c7e3b9dbcce47fb76e808bd31735dd0b70fc606d989bfecd4dc3695efea2129)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformation")
    def put_transformation(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageTextImageTransformation()

        return typing.cast(None, jsii.invoke(self, "putTransformation", [value]))

    @jsii.member(jsii_name="resetFill")
    def reset_fill(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFill", []))

    @jsii.member(jsii_name="resetFillVar")
    def reset_fill_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFillVar", []))

    @jsii.member(jsii_name="resetSize")
    def reset_size(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSize", []))

    @jsii.member(jsii_name="resetSizeVar")
    def reset_size_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSizeVar", []))

    @jsii.member(jsii_name="resetStroke")
    def reset_stroke(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStroke", []))

    @jsii.member(jsii_name="resetStrokeSize")
    def reset_stroke_size(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStrokeSize", []))

    @jsii.member(jsii_name="resetStrokeSizeVar")
    def reset_stroke_size_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStrokeSizeVar", []))

    @jsii.member(jsii_name="resetStrokeVar")
    def reset_stroke_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStrokeVar", []))

    @jsii.member(jsii_name="resetText")
    def reset_text(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetText", []))

    @jsii.member(jsii_name="resetTextVar")
    def reset_text_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTextVar", []))

    @jsii.member(jsii_name="resetTransformation")
    def reset_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformation", []))

    @jsii.member(jsii_name="resetTypeface")
    def reset_typeface(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeface", []))

    @jsii.member(jsii_name="resetTypefaceVar")
    def reset_typeface_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypefaceVar", []))

    @builtins.property
    @jsii.member(jsii_name="transformation")
    def transformation(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageTextImageTransformationOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageTextImageTransformationOutputReference", jsii.get(self, "transformation"))

    @builtins.property
    @jsii.member(jsii_name="fillInput")
    def fill_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fillInput"))

    @builtins.property
    @jsii.member(jsii_name="fillVarInput")
    def fill_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fillVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sizeInput")
    def size_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sizeInput"))

    @builtins.property
    @jsii.member(jsii_name="sizeVarInput")
    def size_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sizeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="strokeInput")
    def stroke_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "strokeInput"))

    @builtins.property
    @jsii.member(jsii_name="strokeSizeInput")
    def stroke_size_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "strokeSizeInput"))

    @builtins.property
    @jsii.member(jsii_name="strokeSizeVarInput")
    def stroke_size_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "strokeSizeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="strokeVarInput")
    def stroke_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "strokeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="textInput")
    def text_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "textInput"))

    @builtins.property
    @jsii.member(jsii_name="textVarInput")
    def text_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "textVarInput"))

    @builtins.property
    @jsii.member(jsii_name="transformationInput")
    def transformation_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageTextImageTransformation"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageTextImageTransformation"], jsii.get(self, "transformationInput"))

    @builtins.property
    @jsii.member(jsii_name="typefaceInput")
    def typeface_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typefaceInput"))

    @builtins.property
    @jsii.member(jsii_name="typefaceVarInput")
    def typeface_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typefaceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="fill")
    def fill(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fill"))

    @fill.setter
    def fill(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c7be84dccfe3427c59e63684bedce28a83a9eb36e37e27a6e0e035ee6f703a38)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fill", value)

    @builtins.property
    @jsii.member(jsii_name="fillVar")
    def fill_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fillVar"))

    @fill_var.setter
    def fill_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__84c2860aa15ab21658d6c3055c271ad216e81c3a7e97742d3b8f545d0922e690)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fillVar", value)

    @builtins.property
    @jsii.member(jsii_name="size")
    def size(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "size"))

    @size.setter
    def size(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__04e6281a927bb11bec94d733fa43f042060ef2ccd0183e7acdd92d1092d93d6d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "size", value)

    @builtins.property
    @jsii.member(jsii_name="sizeVar")
    def size_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sizeVar"))

    @size_var.setter
    def size_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2736bf47d447037577763f94bb14461eb463264ea96e63c957f1a4026c102211)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sizeVar", value)

    @builtins.property
    @jsii.member(jsii_name="stroke")
    def stroke(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "stroke"))

    @stroke.setter
    def stroke(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eff51f96d404b350156273a4260ab76d5adaf0a062ff17e3064f568104c55bbc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "stroke", value)

    @builtins.property
    @jsii.member(jsii_name="strokeSize")
    def stroke_size(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "strokeSize"))

    @stroke_size.setter
    def stroke_size(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f7e3ec68ba38497fa7bf2ac1d1f8c2aa89c5a8e88c2b2fa9addb2d3e73906ef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "strokeSize", value)

    @builtins.property
    @jsii.member(jsii_name="strokeSizeVar")
    def stroke_size_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "strokeSizeVar"))

    @stroke_size_var.setter
    def stroke_size_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__99a9a6cf54b6f6d4eeca223e93d2724a8b8a8709a341f45ea92c68682afe3c90)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "strokeSizeVar", value)

    @builtins.property
    @jsii.member(jsii_name="strokeVar")
    def stroke_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "strokeVar"))

    @stroke_var.setter
    def stroke_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2794b920e92da09de3c89596dbc3e7cfb78bed9beec71c8497d25a45ec45749a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "strokeVar", value)

    @builtins.property
    @jsii.member(jsii_name="text")
    def text(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "text"))

    @text.setter
    def text(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6510fdcc3c9b25d3588e078f568218c38602e57211ee0ed91be65c820ef168f7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "text", value)

    @builtins.property
    @jsii.member(jsii_name="textVar")
    def text_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "textVar"))

    @text_var.setter
    def text_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3004238d87f0dfd7f6f3bb05efe23c1a837985df9573508b87424fefe9d857a8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "textVar", value)

    @builtins.property
    @jsii.member(jsii_name="typeface")
    def typeface(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeface"))

    @typeface.setter
    def typeface(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4998479b8259846582e051de991553443abfa9f9243cf5b365bb0559e41199ef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeface", value)

    @builtins.property
    @jsii.member(jsii_name="typefaceVar")
    def typeface_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typefaceVar"))

    @typeface_var.setter
    def typeface_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__947ad83174284bef5065b1db5643e83b4a0dafea34a24ea1b4d1eb0da0297c78)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typefaceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageTextImage]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageTextImage]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageTextImage]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c6e39b712e25177696479f1ea6d32a7476c626229d66b5d3de367ce0b2fd735e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageTextImageTransformation",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageTextImageTransformation:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageTextImageTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageTextImageTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageTextImageTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9635414ebff9e37d4c28d181080dd0f35bc64be39ed2154d01846ac522a585c7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageTextImageTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageTextImageTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageTextImageTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b8716181127046e9c56f83958120dd1ff0296e78c41737f9abb1cbef34903430)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageUrlImage",
    jsii_struct_bases=[],
    name_mapping={
        "transformation": "transformation",
        "url": "url",
        "url_var": "urlVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageUrlImage:
    def __init__(
        self,
        *,
        transformation: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageUrlImageTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        url: typing.Optional[builtins.str] = None,
        url_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param transformation: transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        :param url: The URL of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url DataAkamaiImagingPolicyImage#url}
        :param url_var: The URL of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url_var DataAkamaiImagingPolicyImage#url_var}
        '''
        if isinstance(transformation, dict):
            transformation = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageUrlImageTransformation(**transformation)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9c151525b6ca632af1832f46244128fb17656594938551010eb96acfb48e43b4)
            check_type(argname="argument transformation", value=transformation, expected_type=type_hints["transformation"])
            check_type(argname="argument url", value=url, expected_type=type_hints["url"])
            check_type(argname="argument url_var", value=url_var, expected_type=type_hints["url_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if transformation is not None:
            self._values["transformation"] = transformation
        if url is not None:
            self._values["url"] = url
        if url_var is not None:
            self._values["url_var"] = url_var

    @builtins.property
    def transformation(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageUrlImageTransformation"]:
        '''transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
        '''
        result = self._values.get("transformation")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageUrlImageTransformation"], result)

    @builtins.property
    def url(self) -> typing.Optional[builtins.str]:
        '''The URL of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url DataAkamaiImagingPolicyImage#url}
        '''
        result = self._values.get("url")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def url_var(self) -> typing.Optional[builtins.str]:
        '''The URL of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url_var DataAkamaiImagingPolicyImage#url_var}
        '''
        result = self._values.get("url_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageUrlImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageUrlImageList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageUrlImageList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6d5f6f09104c5f1ff4518a3a8ac78ffebaadd8da71e2f1106d8d8c43384f3d7b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageUrlImageOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d664bb7a72adaac5cd7216313c378c0493d5a4f346365f82fdd06bb83d779944)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageUrlImageOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__29c327f6c8c817fdad7cfb14c45c17f550e54f5348b3ea3b173863d767c2194d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__03b7bf6667909cee4bab3162f231a77fc3b910d410dcd8b48ce7f80233079904)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__72e1eb69bdbe3eca265a9ed76e5047b45c877ef459d37f4acac926c5effc57ec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageUrlImage]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageUrlImage]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageUrlImage]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4f404246cb79b42463aa390e8a344e57d7eb8674b3d94e4e3fa52b1cf6015f9a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageUrlImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageUrlImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f7e9af4a3cf315084ad683767e1d289f3ceb8c3aceefb615d4cf82e4c5834cfd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformation")
    def put_transformation(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageUrlImageTransformation()

        return typing.cast(None, jsii.invoke(self, "putTransformation", [value]))

    @jsii.member(jsii_name="resetTransformation")
    def reset_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformation", []))

    @jsii.member(jsii_name="resetUrl")
    def reset_url(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUrl", []))

    @jsii.member(jsii_name="resetUrlVar")
    def reset_url_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUrlVar", []))

    @builtins.property
    @jsii.member(jsii_name="transformation")
    def transformation(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageUrlImageTransformationOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageUrlImageTransformationOutputReference", jsii.get(self, "transformation"))

    @builtins.property
    @jsii.member(jsii_name="transformationInput")
    def transformation_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageUrlImageTransformation"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageUrlImageTransformation"], jsii.get(self, "transformationInput"))

    @builtins.property
    @jsii.member(jsii_name="urlInput")
    def url_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "urlInput"))

    @builtins.property
    @jsii.member(jsii_name="urlVarInput")
    def url_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "urlVarInput"))

    @builtins.property
    @jsii.member(jsii_name="url")
    def url(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "url"))

    @url.setter
    def url(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__71dfff733c457c43ae4b802ebf46708af744271ccf9eeb3c1e3bd32f43504a7f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "url", value)

    @builtins.property
    @jsii.member(jsii_name="urlVar")
    def url_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "urlVar"))

    @url_var.setter
    def url_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e0a39ec7bb18caedcd6f89b71eebad9f0286055c1c72aef6f44b6e36e042dc63)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "urlVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageUrlImage]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageUrlImage]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageUrlImage]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b8d5b3df693ef999e68832b574360ef8fd7baa3900f02921fc81e418f1560a96)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageUrlImageTransformation",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageUrlImageTransformation:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageUrlImageTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageUrlImageTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageUrlImageTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a49da2f6d64c87d5a5835caddf554c7be49adede7b436e788196a7ad500f41e8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageUrlImageTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageUrlImageTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageUrlImageTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__37e2f4267366898bbdb44dd43ffee8a0075e0513cb471ba9170a33f0cfbd14f5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a1a82665c284c8ad8c9792a73f0f73984d337a6fceb2ee1f7285e5051871881d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__90b2f2f525a8fc06f81431b6c1d092fcdc30d735ae6833439b7ee1c0367e6589)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__06c31d87e6d616f44d31577ed1454477aca753c8fd593a4a693bb98f343fd316)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2dddb10f52ce88271b4288a6d13d5b26fbfad2e56510849f09a1cb6da2317d41)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9440501419515dc4123508b1f681a488d5e5ebdf8811a9d6273bc35b9f97ec26)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareComposite]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareComposite]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9b67f6d8d8a2280369c1df5375d31328cc3f15b0a1438aff97d0575b9a716061)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9f968981ec2043d67b8205560d1ca8d6fb04d3148ac0c9bb6cfc52091ddd8607)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(
        self,
        *,
        box_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageBoxImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
        circle_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageCircleImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
        text_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageTextImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
        url_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageUrlImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param box_image: box_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#box_image DataAkamaiImagingPolicyImage#box_image}
        :param circle_image: circle_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#circle_image DataAkamaiImagingPolicyImage#circle_image}
        :param text_image: text_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text_image DataAkamaiImagingPolicyImage#text_image}
        :param url_image: url_image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url_image DataAkamaiImagingPolicyImage#url_image}
        '''
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImage(
            box_image=box_image,
            circle_image=circle_image,
            text_image=text_image,
            url_image=url_image,
        )

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPlacement")
    def reset_placement(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacement", []))

    @jsii.member(jsii_name="resetPlacementVar")
    def reset_placement_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacementVar", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetScaleDimension")
    def reset_scale_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimension", []))

    @jsii.member(jsii_name="resetScaleDimensionVar")
    def reset_scale_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimensionVar", []))

    @jsii.member(jsii_name="resetScaleVar")
    def reset_scale_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="placementInput")
    def placement_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementInput"))

    @builtins.property
    @jsii.member(jsii_name="placementVarInput")
    def placement_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionInput")
    def scale_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVarInput")
    def scale_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleVarInput")
    def scale_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e6c8b8326c98cde831f8b0e0cf3c4fa85e5f2fc1a9e8b15593c092b7d1bbcadc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be59012a395bfb0dda582d5af639f088e1dfe6a9da13ea15083f28b58f8007a4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="placement")
    def placement(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placement"))

    @placement.setter
    def placement(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9cc23800ab86d761234bf92ad6b31ad494c42bd964544d4bd5fd64099a035666)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placement", value)

    @builtins.property
    @jsii.member(jsii_name="placementVar")
    def placement_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placementVar"))

    @placement_var.setter
    def placement_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__26430126d782e30b9f42acc104272b54832951d19ffdd632a5635860cf17588d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placementVar", value)

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scale"))

    @scale.setter
    def scale(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ad9494f49b06c7cff555f7d7903d4ed72dcf337cd3df42943076b946cb35d40)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scale", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimension")
    def scale_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimension"))

    @scale_dimension.setter
    def scale_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a09e4308a33964bd944fdf56163f7cf811d9cb3570f09b504231638540b8ed8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimension", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVar")
    def scale_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimensionVar"))

    @scale_dimension_var.setter
    def scale_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__764382aab036275605ea78fa875f33174dea08a02df53d144b858f569e9f5196)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="scaleVar")
    def scale_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleVar"))

    @scale_var.setter
    def scale_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea9045c5e69d64782fd281d20150ff7019992ce1520d875e3af10165904ff183)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dd78245f5cf9b65b4f532d7b9467a7feaafc66b62852ff61eb18ce067f524628)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0d7a1214e0833a679e5b1551f6208fe54c34cd0a8884488e229f94b31c5147cc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e2ee0a13cd59b39bc5a35aa05c6c5c5191742cb9842a83b456c289d64df3744e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ff39d7fb446b715d3d56eb6e030981c136f0cf6a61198ab0dc838fa02a65de55)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareComposite]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareComposite]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareComposite]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b87c88b4aa1c82003165df494dc38f8b10a85236009df0f8e5b295b0377e5f63)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompound",
    jsii_struct_bases=[],
    name_mapping={"transformations": "transformations"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompound:
    def __init__(
        self,
        *,
        transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformations, typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param transformations: transformations block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ad9d735a313604c3a1ab1e3ac3f74d98b3817ef940bec0032c8282655a4dc6e5)
            check_type(argname="argument transformations", value=transformations, expected_type=type_hints["transformations"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if transformations is not None:
            self._values["transformations"] = transformations

    @builtins.property
    def transformations(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformations]]]:
        '''transformations block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        result = self._values.get("transformations")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformations]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompound(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompoundList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompoundList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aef6f8209a86877e4017e3a11fed2f61484c982486ba0bb6ee28ffd2e11ba893)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompoundOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__63aab50861780ec862c5fe2e37c184d2241929bfee79475fead10f7770749f90)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompoundOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__783fc3e9dd4299c47b25689004f9268acfcca5ceaae60a0d46b64b969e45d0fc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a7dd770f9b42cf141fad4acc3597d6ca471ee4a62ebad73e7d0e2dd9cd9c6f8c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__96b36ae45f498c6e05e0aecb66839b3be5308a5243c87d68b90d48dc02996bd1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompound]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompound]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__745659030fbb0343bcb421292f3206e404d6a8d909591af214d244401673e0dc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompoundOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompoundOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c43a7724e30d62492f07dee7fefdad52f30d9d4773bec931238b3108bd7c5ad6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformations")
    def put_transformations(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformations, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0f8c146f033b1d0ff87ea1a2ce07e3a9126de70587e66339dace847469c36a6a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTransformations", [value]))

    @jsii.member(jsii_name="resetTransformations")
    def reset_transformations(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformations", []))

    @builtins.property
    @jsii.member(jsii_name="transformations")
    def transformations(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsList", jsii.get(self, "transformations"))

    @builtins.property
    @jsii.member(jsii_name="transformationsInput")
    def transformations_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformations]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformations]]], jsii.get(self, "transformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompound]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompound]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompound]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8805fa104116980d3e84dc5290746ede6bca43cb2364726eb5509d0613fa167f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareContrast",
    jsii_struct_bases=[],
    name_mapping={
        "brightness": "brightness",
        "brightness_var": "brightnessVar",
        "contrast": "contrast",
        "contrast_var": "contrastVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareContrast:
    def __init__(
        self,
        *,
        brightness: typing.Optional[builtins.str] = None,
        brightness_var: typing.Optional[builtins.str] = None,
        contrast: typing.Optional[builtins.str] = None,
        contrast_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param brightness: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        :param brightness_var: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        :param contrast: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param contrast_var: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8ae78180fe1a50d99572bb4dabedd37ec83909eeea25a3e1937194862364e90f)
            check_type(argname="argument brightness", value=brightness, expected_type=type_hints["brightness"])
            check_type(argname="argument brightness_var", value=brightness_var, expected_type=type_hints["brightness_var"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument contrast_var", value=contrast_var, expected_type=type_hints["contrast_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if brightness is not None:
            self._values["brightness"] = brightness
        if brightness_var is not None:
            self._values["brightness_var"] = brightness_var
        if contrast is not None:
            self._values["contrast"] = contrast
        if contrast_var is not None:
            self._values["contrast_var"] = contrast_var

    @builtins.property
    def brightness(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        '''
        result = self._values.get("brightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def brightness_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        '''
        result = self._values.get("brightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        result = self._values.get("contrast_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareContrast(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareContrastList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareContrastList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__325cffc9d8c678e099e19095397f6b7a8cc66c307673b30bd6fd542e59020971)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareContrastOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__719e6cb44cc6afd71d6c6ef7b53d61437390c6aca56904ade2c00b381814c6b9)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareContrastOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5aecb5bfa97b729a512a3a355c57911825859b37fc693376b110f50b0663cc8a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0844ec89f78fa03dc431fee52310f3dc783041e1d1c321ecce50d4cc8ab1380e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__228c39f436c38cf87c24c767d7b5bc772e69f101a5f804d548bdd9c91807ae8a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareContrast]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareContrast]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a1b3bb23d33187e2321d8ac7f635eed6ecb93c07751d858ffe80e433fb1a1be4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareContrastOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareContrastOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f8a684776b72e86fa1f538fdbb65ea85d7cacf56ff368c9cddc922dafecc9f3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetBrightness")
    def reset_brightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightness", []))

    @jsii.member(jsii_name="resetBrightnessVar")
    def reset_brightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightnessVar", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetContrastVar")
    def reset_contrast_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrastVar", []))

    @builtins.property
    @jsii.member(jsii_name="brightnessInput")
    def brightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="brightnessVarInput")
    def brightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastVarInput")
    def contrast_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="brightness")
    def brightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightness"))

    @brightness.setter
    def brightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d39e3c880d5d74bf1821d56f0159a8c67d08226dfc7b4cff6c0b444936c8c11f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightness", value)

    @builtins.property
    @jsii.member(jsii_name="brightnessVar")
    def brightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightnessVar"))

    @brightness_var.setter
    def brightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__71a3596191b846bafbc59b9cb685a932d83ae62ea2bdd01302be1374e9747601)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrast"))

    @contrast.setter
    def contrast(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5206379a9ef78fc1c92035367452f517d8ca1e65143fcc50ceb95e3f11a4adaf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrast", value)

    @builtins.property
    @jsii.member(jsii_name="contrastVar")
    def contrast_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrastVar"))

    @contrast_var.setter
    def contrast_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ba2cebeac4c29dbe85735fc952cac81a7b07ca0aeb446fcd1333ec63ede87560)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrastVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareContrast]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareContrast]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareContrast]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d4e85365536109d4547c5637a55b28d9d3c22b988ac8df1d5442495857b4aa7f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCrop",
    jsii_struct_bases=[],
    name_mapping={
        "allow_expansion": "allowExpansion",
        "allow_expansion_var": "allowExpansionVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCrop:
    def __init__(
        self,
        *,
        allow_expansion: typing.Optional[builtins.str] = None,
        allow_expansion_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_expansion: If cropping an area outside of the existing canvas, expands the image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        :param allow_expansion_var: If cropping an area outside of the existing canvas, expands the image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        :param gravity: Frame of reference for X and Y Positions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Frame of reference for X and Y Positions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The number of pixels to crop along the y-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The number of pixels to crop along the y-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The number of pixels to crop along the x-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The number of pixels to crop along the x-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        :param x_position: The x-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__83c52c08670fe3e871bdd512d1a0573c8a694d50572111b5c49f534c597a3f40)
            check_type(argname="argument allow_expansion", value=allow_expansion, expected_type=type_hints["allow_expansion"])
            check_type(argname="argument allow_expansion_var", value=allow_expansion_var, expected_type=type_hints["allow_expansion_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if allow_expansion is not None:
            self._values["allow_expansion"] = allow_expansion
        if allow_expansion_var is not None:
            self._values["allow_expansion_var"] = allow_expansion_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def allow_expansion(self) -> typing.Optional[builtins.str]:
        '''If cropping an area outside of the existing canvas, expands the image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        '''
        result = self._values.get("allow_expansion")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def allow_expansion_var(self) -> typing.Optional[builtins.str]:
        '''If cropping an area outside of the existing canvas, expands the image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        '''
        result = self._values.get("allow_expansion_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Frame of reference for X and Y Positions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Frame of reference for X and Y Positions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the y-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the y-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the x-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the x-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a4a2bc24c0893a72a9562b7e869e6e7aa34ef067283680971a2e9c0024abb660)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__23fbdbd07cc94b3d045148ca21e2848831cd8d0e4080733da50c2b2fa82f4e65)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__12f728db00303f0a48760077e9db411351062538b32c2147c36d761a830a47fb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5cabb9b984eda3e01d9f03cfb3cd6bbb5d1b09cb8155a09a9d1159703877b02e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0543b278179dd1794dabcccf5ea23927f054b96e3e962216ee52833ceca7d34c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8d3ef4b1a8f1cbd56a7cc3144f8bc8559eb9b068fb3017ff34e5d387318c6f9d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__270fc7de9f26f3cf537a1a00ed7d00a683a3012d597df9195593fd9916be0900)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAllowExpansion")
    def reset_allow_expansion(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansion", []))

    @jsii.member(jsii_name="resetAllowExpansionVar")
    def reset_allow_expansion_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansionVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionInput")
    def allow_expansion_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVarInput")
    def allow_expansion_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansion")
    def allow_expansion(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansion"))

    @allow_expansion.setter
    def allow_expansion(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cea57cb851b255fef9da77815cf2b1727fabdd9fca2348f0c501ad6c6f8ab651)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansion", value)

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVar")
    def allow_expansion_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansionVar"))

    @allow_expansion_var.setter
    def allow_expansion_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2390c2daa1fc1306bc829d857172869ff8b951f33af24a6544f98595e2a20b24)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansionVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__39aec45753b17505b949f0d8b43a4b6a1297fcb3a551b3f80201d02933c04dd8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cfccf68094a2ce9c9fda00c65ec1c8a48832eba025240fb134ef63a663244064)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0c601bafdbb1c66719e7d715ad1b1f30492fff91a6f7c7dd3f8b8bb16940891e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__05e2f5705be338036e007f95da57a006a2050010eae6597cebc186c997e8c4f8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c29e44adc838f007cd619a6a3e2b18984d81715a28a526f694c1b669d8b3dc67)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1434ab546c3864b92a144de0aa8ce9112b9ca9d063627cae12b24c82b0dcde43)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__469f68cc7bda9b5bd5753bf1b74e8da60c3d7e1cc08dfd605290d1945b641fe4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__52cf965fba9e684650118fa90621c1b5538fa34106b12c585e920455f4b67175)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__42b8899ef80bf3669f92464f66988ae854e1520eeb7b3663171acca2ad6935da)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0afaa5a9f58cce97a58cd61b3ce556c5cda284f06b1a9a8705f9f9f931278ec3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__29d74660b83806006c5ff7e8f41cd768de998b7e5cc134ebec63e7cb6e4495cf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFaceCrop",
    jsii_struct_bases=[],
    name_mapping={
        "algorithm": "algorithm",
        "algorithm_var": "algorithmVar",
        "confidence": "confidence",
        "confidence_var": "confidenceVar",
        "fail_gravity": "failGravity",
        "fail_gravity_var": "failGravityVar",
        "focus": "focus",
        "focus_var": "focusVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "padding": "padding",
        "padding_var": "paddingVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFaceCrop:
    def __init__(
        self,
        *,
        algorithm: typing.Optional[builtins.str] = None,
        algorithm_var: typing.Optional[builtins.str] = None,
        confidence: typing.Optional[builtins.str] = None,
        confidence_var: typing.Optional[builtins.str] = None,
        fail_gravity: typing.Optional[builtins.str] = None,
        fail_gravity_var: typing.Optional[builtins.str] = None,
        focus: typing.Optional[builtins.str] = None,
        focus_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param algorithm: Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm DataAkamaiImagingPolicyImage#algorithm}
        :param algorithm_var: Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm_var DataAkamaiImagingPolicyImage#algorithm_var}
        :param confidence: With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image. Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence DataAkamaiImagingPolicyImage#confidence}
        :param confidence_var: With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image. Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence_var DataAkamaiImagingPolicyImage#confidence_var}
        :param fail_gravity: Controls placement of the crop if Image and Video Manager does not detect any faces in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        :param fail_gravity_var: Controls placement of the crop if Image and Video Manager does not detect any faces in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        :param focus: Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus DataAkamaiImagingPolicyImage#focus}
        :param focus_var: Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus_var DataAkamaiImagingPolicyImage#focus_var}
        :param gravity: Controls placement of the crop. Directions are relative to the face(s) plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Controls placement of the crop. Directions are relative to the face(s) plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param padding: The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        :param style: Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__060a0a8e3c8fe9e43d74bcce495c743d32a6cc03cac33b708a8dbf1dc902648e)
            check_type(argname="argument algorithm", value=algorithm, expected_type=type_hints["algorithm"])
            check_type(argname="argument algorithm_var", value=algorithm_var, expected_type=type_hints["algorithm_var"])
            check_type(argname="argument confidence", value=confidence, expected_type=type_hints["confidence"])
            check_type(argname="argument confidence_var", value=confidence_var, expected_type=type_hints["confidence_var"])
            check_type(argname="argument fail_gravity", value=fail_gravity, expected_type=type_hints["fail_gravity"])
            check_type(argname="argument fail_gravity_var", value=fail_gravity_var, expected_type=type_hints["fail_gravity_var"])
            check_type(argname="argument focus", value=focus, expected_type=type_hints["focus"])
            check_type(argname="argument focus_var", value=focus_var, expected_type=type_hints["focus_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if algorithm is not None:
            self._values["algorithm"] = algorithm
        if algorithm_var is not None:
            self._values["algorithm_var"] = algorithm_var
        if confidence is not None:
            self._values["confidence"] = confidence
        if confidence_var is not None:
            self._values["confidence_var"] = confidence_var
        if fail_gravity is not None:
            self._values["fail_gravity"] = fail_gravity
        if fail_gravity_var is not None:
            self._values["fail_gravity_var"] = fail_gravity_var
        if focus is not None:
            self._values["focus"] = focus
        if focus_var is not None:
            self._values["focus_var"] = focus_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def algorithm(self) -> typing.Optional[builtins.str]:
        '''Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm DataAkamaiImagingPolicyImage#algorithm}
        '''
        result = self._values.get("algorithm")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def algorithm_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm_var DataAkamaiImagingPolicyImage#algorithm_var}
        '''
        result = self._values.get("algorithm_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def confidence(self) -> typing.Optional[builtins.str]:
        '''With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image.

        Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence DataAkamaiImagingPolicyImage#confidence}
        '''
        result = self._values.get("confidence")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def confidence_var(self) -> typing.Optional[builtins.str]:
        '''With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image.

        Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence_var DataAkamaiImagingPolicyImage#confidence_var}
        '''
        result = self._values.get("confidence_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any faces in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        '''
        result = self._values.get("fail_gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any faces in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        '''
        result = self._values.get("fail_gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def focus(self) -> typing.Optional[builtins.str]:
        '''Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus DataAkamaiImagingPolicyImage#focus}
        '''
        result = self._values.get("focus")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def focus_var(self) -> typing.Optional[builtins.str]:
        '''Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus_var DataAkamaiImagingPolicyImage#focus_var}
        '''
        result = self._values.get("focus_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the face(s) plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the face(s) plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFaceCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFaceCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFaceCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__de451c71a04f9a7eb19152fb05aad447f3a05e9ec1b5852f34c6cc4bb953b3f6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFaceCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__81531d8c3ad4083bafbfdf53193ceb627ccaaf9c2334c2e8bee445ee859dd44e)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFaceCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__418ecbf99fa86e91faa304fa32f13b5a1f43d2511f973e8ddd4fd419049c09c2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__54c88eb0a7135bfab18ed514b02319bd1911cc3e8687be12c800816770b373f6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9bd714a2b2f9d8f0b7f010d38ca474ea9457683c09a497dd9e84624872b59aa4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFaceCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFaceCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFaceCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1a68c4a8c1415e22b0d5b89b316bba4eb56f32dfa4d281330dd96e1cbd52c06a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFaceCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFaceCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__199b9e1a7b8e0d86727a8802f2ea6761111a54fb674d746135550b0dd0840955)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAlgorithm")
    def reset_algorithm(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAlgorithm", []))

    @jsii.member(jsii_name="resetAlgorithmVar")
    def reset_algorithm_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAlgorithmVar", []))

    @jsii.member(jsii_name="resetConfidence")
    def reset_confidence(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetConfidence", []))

    @jsii.member(jsii_name="resetConfidenceVar")
    def reset_confidence_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetConfidenceVar", []))

    @jsii.member(jsii_name="resetFailGravity")
    def reset_fail_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravity", []))

    @jsii.member(jsii_name="resetFailGravityVar")
    def reset_fail_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravityVar", []))

    @jsii.member(jsii_name="resetFocus")
    def reset_focus(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFocus", []))

    @jsii.member(jsii_name="resetFocusVar")
    def reset_focus_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFocusVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="algorithmInput")
    def algorithm_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "algorithmInput"))

    @builtins.property
    @jsii.member(jsii_name="algorithmVarInput")
    def algorithm_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "algorithmVarInput"))

    @builtins.property
    @jsii.member(jsii_name="confidenceInput")
    def confidence_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "confidenceInput"))

    @builtins.property
    @jsii.member(jsii_name="confidenceVarInput")
    def confidence_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "confidenceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityInput")
    def fail_gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityVarInput")
    def fail_gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="focusInput")
    def focus_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "focusInput"))

    @builtins.property
    @jsii.member(jsii_name="focusVarInput")
    def focus_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "focusVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="algorithm")
    def algorithm(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "algorithm"))

    @algorithm.setter
    def algorithm(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4c60245c088ea265d02feb34e4fedd1b346a2a1f37b7d52ade57eaa4d4bd6ad3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "algorithm", value)

    @builtins.property
    @jsii.member(jsii_name="algorithmVar")
    def algorithm_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "algorithmVar"))

    @algorithm_var.setter
    def algorithm_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0b1d0a9d0717497a6d87b5a548a27f668a9f0e0ba69ad563a4fb5d5905261c06)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "algorithmVar", value)

    @builtins.property
    @jsii.member(jsii_name="confidence")
    def confidence(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "confidence"))

    @confidence.setter
    def confidence(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__454bb4ebb1086a332959fcc4a8e6083b18a4ca70b4b6c141927a85bb68876ba5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "confidence", value)

    @builtins.property
    @jsii.member(jsii_name="confidenceVar")
    def confidence_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "confidenceVar"))

    @confidence_var.setter
    def confidence_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f1717921f25f3295d6b7037f50305c4c9624c0b496bc958b29809b688a425d40)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "confidenceVar", value)

    @builtins.property
    @jsii.member(jsii_name="failGravity")
    def fail_gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravity"))

    @fail_gravity.setter
    def fail_gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ecd637bab1ac592b7376f6b52b3bde458d7870b492bc822a0e1e9c464e6a773)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravity", value)

    @builtins.property
    @jsii.member(jsii_name="failGravityVar")
    def fail_gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravityVar"))

    @fail_gravity_var.setter
    def fail_gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0e94f6631c4be7c5348b4a1a2430f7c4cdf4af45ff8f4b4e4d34bffed3a348cc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="focus")
    def focus(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "focus"))

    @focus.setter
    def focus(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa07fdaf9b5b746796c5f2bedb4463f34a0969c3814fac001608c510c77e07bb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "focus", value)

    @builtins.property
    @jsii.member(jsii_name="focusVar")
    def focus_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "focusVar"))

    @focus_var.setter
    def focus_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__51040f36f4af5e7a8c30dcd965fa7ae6ee8213a6b4d6da8da936b40c4e0277b7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "focusVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f0dfbfd03ce68f71d73af83e277035cbdb4d1fe2776d5459948aea42b078189f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eda9c1ae86f773a37b9d0707ae64d37f0a4b99e5c5246c6ff2de665654c0b718)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ac20f7b81517e930252f9e78d5a63d8909b454fafe57dba639d7f95fbb7f2de)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__24e5f3720876edb41baa1d750ae1d989289bcb3d335532f9b6fee044f02d93bf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__afcfbaf2102cf4ccdfebce2657d8ec62f8173a8fcb680f87a1e23f8e2ae38427)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3e5167cbab9891cc3f961590d48a03ba9b537f292bb1f46c1b880eb780388143)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ba388ed744ceeafc15c3b5711cde8ad8fe394fae1c7d9bc9a713312cf5c280ca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d49bef26ebfb8fb83e35c513672b48ffc5e12cbc06e7cfbd7d993cb6da199f77)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__841fe049bfa3969563ccf1832a5dc4ea1ba1cb391eb963b43d7a442c70e2a3f7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f62ecee9b827af911c5c494dfd0b8b8bfb177597d121997818a23a37e8361045)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFaceCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFaceCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFaceCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e856b575f85dcbaff12ad911826dcb2784b2cfa00722442b49c36b93fbae7df6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFeatureCrop",
    jsii_struct_bases=[],
    name_mapping={
        "fail_gravity": "failGravity",
        "fail_gravity_var": "failGravityVar",
        "feature_radius": "featureRadius",
        "feature_radius_var": "featureRadiusVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "max_features": "maxFeatures",
        "max_features_var": "maxFeaturesVar",
        "min_feature_quality": "minFeatureQuality",
        "min_feature_quality_var": "minFeatureQualityVar",
        "padding": "padding",
        "padding_var": "paddingVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFeatureCrop:
    def __init__(
        self,
        *,
        fail_gravity: typing.Optional[builtins.str] = None,
        fail_gravity_var: typing.Optional[builtins.str] = None,
        feature_radius: typing.Optional[builtins.str] = None,
        feature_radius_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        max_features: typing.Optional[builtins.str] = None,
        max_features_var: typing.Optional[builtins.str] = None,
        min_feature_quality: typing.Optional[builtins.str] = None,
        min_feature_quality_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fail_gravity: Controls placement of the crop if Image and Video Manager does not detect any features in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        :param fail_gravity_var: Controls placement of the crop if Image and Video Manager does not detect any features in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        :param feature_radius: The size in pixels of the important features to search for. If identified, two features never appear closer together than this value, ``8.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius DataAkamaiImagingPolicyImage#feature_radius}
        :param feature_radius_var: The size in pixels of the important features to search for. If identified, two features never appear closer together than this value, ``8.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius_var DataAkamaiImagingPolicyImage#feature_radius_var}
        :param gravity: Controls placement of the crop. Directions are relative to the region of interest plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Controls placement of the crop. Directions are relative to the region of interest plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param max_features: The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features DataAkamaiImagingPolicyImage#max_features}
        :param max_features_var: The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features_var DataAkamaiImagingPolicyImage#max_features_var}
        :param min_feature_quality: Determines the minimum quality level of the feature identified. To consider a feature important, the feature needs to surpass this value. Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality DataAkamaiImagingPolicyImage#min_feature_quality}
        :param min_feature_quality_var: Determines the minimum quality level of the feature identified. To consider a feature important, the feature needs to surpass this value. Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality_var DataAkamaiImagingPolicyImage#min_feature_quality_var}
        :param padding: Adds space around the region of interest. The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: Adds space around the region of interest. The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        :param style: Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9853904d39a0bf032f22ed9ae3e28de19e53fc08bbf77f66b2d4fd8b660fa5d7)
            check_type(argname="argument fail_gravity", value=fail_gravity, expected_type=type_hints["fail_gravity"])
            check_type(argname="argument fail_gravity_var", value=fail_gravity_var, expected_type=type_hints["fail_gravity_var"])
            check_type(argname="argument feature_radius", value=feature_radius, expected_type=type_hints["feature_radius"])
            check_type(argname="argument feature_radius_var", value=feature_radius_var, expected_type=type_hints["feature_radius_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument max_features", value=max_features, expected_type=type_hints["max_features"])
            check_type(argname="argument max_features_var", value=max_features_var, expected_type=type_hints["max_features_var"])
            check_type(argname="argument min_feature_quality", value=min_feature_quality, expected_type=type_hints["min_feature_quality"])
            check_type(argname="argument min_feature_quality_var", value=min_feature_quality_var, expected_type=type_hints["min_feature_quality_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fail_gravity is not None:
            self._values["fail_gravity"] = fail_gravity
        if fail_gravity_var is not None:
            self._values["fail_gravity_var"] = fail_gravity_var
        if feature_radius is not None:
            self._values["feature_radius"] = feature_radius
        if feature_radius_var is not None:
            self._values["feature_radius_var"] = feature_radius_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if max_features is not None:
            self._values["max_features"] = max_features
        if max_features_var is not None:
            self._values["max_features_var"] = max_features_var
        if min_feature_quality is not None:
            self._values["min_feature_quality"] = min_feature_quality
        if min_feature_quality_var is not None:
            self._values["min_feature_quality_var"] = min_feature_quality_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def fail_gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any features in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        '''
        result = self._values.get("fail_gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any features in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        '''
        result = self._values.get("fail_gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feature_radius(self) -> typing.Optional[builtins.str]:
        '''The size in pixels of the important features to search for.

        If identified, two features never appear closer together than this value, ``8.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius DataAkamaiImagingPolicyImage#feature_radius}
        '''
        result = self._values.get("feature_radius")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feature_radius_var(self) -> typing.Optional[builtins.str]:
        '''The size in pixels of the important features to search for.

        If identified, two features never appear closer together than this value, ``8.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius_var DataAkamaiImagingPolicyImage#feature_radius_var}
        '''
        result = self._values.get("feature_radius_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the region of interest plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the region of interest plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def max_features(self) -> typing.Optional[builtins.str]:
        '''The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features DataAkamaiImagingPolicyImage#max_features}
        '''
        result = self._values.get("max_features")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def max_features_var(self) -> typing.Optional[builtins.str]:
        '''The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features_var DataAkamaiImagingPolicyImage#max_features_var}
        '''
        result = self._values.get("max_features_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def min_feature_quality(self) -> typing.Optional[builtins.str]:
        '''Determines the minimum quality level of the feature identified.

        To consider a feature important, the feature needs to surpass this value.  Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality DataAkamaiImagingPolicyImage#min_feature_quality}
        '''
        result = self._values.get("min_feature_quality")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def min_feature_quality_var(self) -> typing.Optional[builtins.str]:
        '''Determines the minimum quality level of the feature identified.

        To consider a feature important, the feature needs to surpass this value.  Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality_var DataAkamaiImagingPolicyImage#min_feature_quality_var}
        '''
        result = self._values.get("min_feature_quality_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''Adds space around the region of interest.

        The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''Adds space around the region of interest.

        The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFeatureCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFeatureCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFeatureCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2bda6c407fbb236faa6d0b5e881fd76cace84f18dbe591bebd51924b97319506)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFeatureCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__94dea2a5b9679dd8637f35d195feffac9f389ca4e3c57c7346311e062668dfec)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFeatureCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__006a7cd8ad36419860ef5b18c21fc6516f0e648df18e7680b74cb26fcd0c6ffa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d4ccab063f15888d08e63f6d5be942d1b4568541807477ccab8063b808b7a940)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8d383075b8b3bf96048409b451d1b43ad5c5bdb36d9599e926fc2b22ce8b7541)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFeatureCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFeatureCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFeatureCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__97de55788241845ba9a39904442b73e63026748c0e439d1956e8eafb337aee0f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFeatureCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFeatureCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__87ce00c3de81c38752e42788dea466baf371bcf7d7b05faedc535d2186ec8e57)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetFailGravity")
    def reset_fail_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravity", []))

    @jsii.member(jsii_name="resetFailGravityVar")
    def reset_fail_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravityVar", []))

    @jsii.member(jsii_name="resetFeatureRadius")
    def reset_feature_radius(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureRadius", []))

    @jsii.member(jsii_name="resetFeatureRadiusVar")
    def reset_feature_radius_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureRadiusVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetMaxFeatures")
    def reset_max_features(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxFeatures", []))

    @jsii.member(jsii_name="resetMaxFeaturesVar")
    def reset_max_features_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxFeaturesVar", []))

    @jsii.member(jsii_name="resetMinFeatureQuality")
    def reset_min_feature_quality(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMinFeatureQuality", []))

    @jsii.member(jsii_name="resetMinFeatureQualityVar")
    def reset_min_feature_quality_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMinFeatureQualityVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="failGravityInput")
    def fail_gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityVarInput")
    def fail_gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featureRadiusInput")
    def feature_radius_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featureRadiusInput"))

    @builtins.property
    @jsii.member(jsii_name="featureRadiusVarInput")
    def feature_radius_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featureRadiusVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesInput")
    def max_features_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "maxFeaturesInput"))

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesVarInput")
    def max_features_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "maxFeaturesVarInput"))

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityInput")
    def min_feature_quality_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "minFeatureQualityInput"))

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityVarInput")
    def min_feature_quality_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "minFeatureQualityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravity")
    def fail_gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravity"))

    @fail_gravity.setter
    def fail_gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1814b6e4812e701278dd3fb4efeecac6a826fd24483ed0dfc2fccae7b302a8ef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravity", value)

    @builtins.property
    @jsii.member(jsii_name="failGravityVar")
    def fail_gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravityVar"))

    @fail_gravity_var.setter
    def fail_gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__da2f0ea7f214eec908332162020b83798df5afab2cb39301a6622d5ef849642b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="featureRadius")
    def feature_radius(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featureRadius"))

    @feature_radius.setter
    def feature_radius(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ff7fe7547056855d44038bd9ef3d1dd21cbcf3085d05635be97c96d56dd4f2e8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featureRadius", value)

    @builtins.property
    @jsii.member(jsii_name="featureRadiusVar")
    def feature_radius_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featureRadiusVar"))

    @feature_radius_var.setter
    def feature_radius_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1abf450a3a1138b4843d45789336d3f15ffb7494aae06811f82d00fd1fd74fbc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featureRadiusVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eae993c5fef1b7da4188fdc368367b26f148eb2e962bc365d0fe2bd25b93a6be)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d842a47a281fefc276e991def4d702c741e622a863643fe2d70872819730b063)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__50367d49a2f8ef525477a7382d91b894faeed6db61357e10900d1970985b00d3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5982869827b01451d8e382b9f84024f8170aa2fb31a3c9f50e35aa921cd54ae0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="maxFeatures")
    def max_features(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "maxFeatures"))

    @max_features.setter
    def max_features(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fe8f6c1f534a8989fb818cba04def531a32f70449040615fd8371259bef99a79)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "maxFeatures", value)

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesVar")
    def max_features_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "maxFeaturesVar"))

    @max_features_var.setter
    def max_features_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__46e4d04d6a4c697f094916da8ee552b6e13f73d554d3b9b83fdea5c59fe367e3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "maxFeaturesVar", value)

    @builtins.property
    @jsii.member(jsii_name="minFeatureQuality")
    def min_feature_quality(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "minFeatureQuality"))

    @min_feature_quality.setter
    def min_feature_quality(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__84e510cb8a1cc7aa6179cf676870b43b7bebfcc2aa1e0d6d81f0db0cf92cc6d4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "minFeatureQuality", value)

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityVar")
    def min_feature_quality_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "minFeatureQualityVar"))

    @min_feature_quality_var.setter
    def min_feature_quality_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a32b9b73e3cc5fdc99e43c1e3582132980e903d7f9e896bdf96f2c8eaeb217a4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "minFeatureQualityVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a9b262dc4129aacb951b1feba5b8a1a99e6440feee2e80d99df9ae296052d46c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d312c386a57f236da4cf02af8ff4f5a20ef38680ae7773c4d0d82f71418de7a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__92692ff353dd06561c1694282874ef2e790d198038aafde40356e82433cf90a5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a70d4bafef6bff1a386158ff8cc46a5d5305d3c6c32c8a92ff1346b5bf8a9de7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e016386be4571151b4f43342a2270ead6df67bde3affb53faccafbc9dc88c31b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__28ad5b71171346eb875656d6895ce50c6b62111c960c9b186a226af2d44d0716)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFeatureCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFeatureCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFeatureCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1014a1ebc53e387c4ce26dd3575d1775750eb9ffbd4df55b9f2f360cd236759b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFill",
    jsii_struct_bases=[],
    name_mapping={
        "fill_transformation": "fillTransformation",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFill:
    def __init__(
        self,
        *,
        fill_transformation: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fill_transformation: fill_transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_transformation DataAkamaiImagingPolicyImage#fill_transformation}
        :param height: The height value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The width value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(fill_transformation, dict):
            fill_transformation = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformation(**fill_transformation)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__62d5e7211a0bd4fabc1de81181e16ba8c818d418a1c9767f2b440369b2ed8d28)
            check_type(argname="argument fill_transformation", value=fill_transformation, expected_type=type_hints["fill_transformation"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fill_transformation is not None:
            self._values["fill_transformation"] = fill_transformation
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def fill_transformation(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformation"]:
        '''fill_transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_transformation DataAkamaiImagingPolicyImage#fill_transformation}
        '''
        result = self._values.get("fill_transformation")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformation"], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFill(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformation",
    jsii_struct_bases=[],
    name_mapping={
        "append": "append",
        "aspect_crop": "aspectCrop",
        "background_color": "backgroundColor",
        "blur": "blur",
        "chroma_key": "chromaKey",
        "composite": "composite",
        "compound": "compound",
        "contrast": "contrast",
        "crop": "crop",
        "face_crop": "faceCrop",
        "feature_crop": "featureCrop",
        "fit_and_fill": "fitAndFill",
        "goop": "goop",
        "grayscale": "grayscale",
        "hsl": "hsl",
        "hsv": "hsv",
        "if_dimension": "ifDimension",
        "if_orientation": "ifOrientation",
        "im_query": "imQuery",
        "max_colors": "maxColors",
        "mirror": "mirror",
        "mono_hue": "monoHue",
        "opacity": "opacity",
        "region_of_interest_crop": "regionOfInterestCrop",
        "relative_crop": "relativeCrop",
        "remove_color": "removeColor",
        "resize": "resize",
        "rotate": "rotate",
        "scale": "scale",
        "shear": "shear",
        "trim": "trim",
        "unsharp_mask": "unsharpMask",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformation:
    def __init__(
        self,
        *,
        append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationAppend", typing.Dict[builtins.str, typing.Any]]]]] = None,
        aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationAspectCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationBackgroundColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationBlur", typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationChromaKey", typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationComposite", typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationCompound", typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationContrast", typing.Dict[builtins.str, typing.Any]]]]] = None,
        crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationFaceCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationFeatureCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationFitAndFill", typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationGoop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationGrayscale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationHsl", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationHsv", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfDimension", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfOrientation", typing.Dict[builtins.str, typing.Any]]]]] = None,
        im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationImQuery", typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationMaxColors", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationMirror", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationMonoHue", typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationOpacity", typing.Dict[builtins.str, typing.Any]]]]] = None,
        region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationRegionOfInterestCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationRelativeCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationRemoveColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationResize", typing.Dict[builtins.str, typing.Any]]]]] = None,
        rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationRotate", typing.Dict[builtins.str, typing.Any]]]]] = None,
        scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationScale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationShear", typing.Dict[builtins.str, typing.Any]]]]] = None,
        trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationTrim", typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationUnsharpMask", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param append: append block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        :param aspect_crop: aspect_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param crop: crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        :param face_crop: face_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        :param feature_crop: feature_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        :param fit_and_fill: fit_and_fill block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param im_query: im_query block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param region_of_interest_crop: region_of_interest_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        :param relative_crop: relative_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param resize: resize block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        :param rotate: rotate block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        :param scale: scale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param shear: shear block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        :param trim: trim block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__34dc2809f2ca63c9df9377f0ffc70c5539ff4c34423eea2865839b1234d698dd)
            check_type(argname="argument append", value=append, expected_type=type_hints["append"])
            check_type(argname="argument aspect_crop", value=aspect_crop, expected_type=type_hints["aspect_crop"])
            check_type(argname="argument background_color", value=background_color, expected_type=type_hints["background_color"])
            check_type(argname="argument blur", value=blur, expected_type=type_hints["blur"])
            check_type(argname="argument chroma_key", value=chroma_key, expected_type=type_hints["chroma_key"])
            check_type(argname="argument composite", value=composite, expected_type=type_hints["composite"])
            check_type(argname="argument compound", value=compound, expected_type=type_hints["compound"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument crop", value=crop, expected_type=type_hints["crop"])
            check_type(argname="argument face_crop", value=face_crop, expected_type=type_hints["face_crop"])
            check_type(argname="argument feature_crop", value=feature_crop, expected_type=type_hints["feature_crop"])
            check_type(argname="argument fit_and_fill", value=fit_and_fill, expected_type=type_hints["fit_and_fill"])
            check_type(argname="argument goop", value=goop, expected_type=type_hints["goop"])
            check_type(argname="argument grayscale", value=grayscale, expected_type=type_hints["grayscale"])
            check_type(argname="argument hsl", value=hsl, expected_type=type_hints["hsl"])
            check_type(argname="argument hsv", value=hsv, expected_type=type_hints["hsv"])
            check_type(argname="argument if_dimension", value=if_dimension, expected_type=type_hints["if_dimension"])
            check_type(argname="argument if_orientation", value=if_orientation, expected_type=type_hints["if_orientation"])
            check_type(argname="argument im_query", value=im_query, expected_type=type_hints["im_query"])
            check_type(argname="argument max_colors", value=max_colors, expected_type=type_hints["max_colors"])
            check_type(argname="argument mirror", value=mirror, expected_type=type_hints["mirror"])
            check_type(argname="argument mono_hue", value=mono_hue, expected_type=type_hints["mono_hue"])
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument region_of_interest_crop", value=region_of_interest_crop, expected_type=type_hints["region_of_interest_crop"])
            check_type(argname="argument relative_crop", value=relative_crop, expected_type=type_hints["relative_crop"])
            check_type(argname="argument remove_color", value=remove_color, expected_type=type_hints["remove_color"])
            check_type(argname="argument resize", value=resize, expected_type=type_hints["resize"])
            check_type(argname="argument rotate", value=rotate, expected_type=type_hints["rotate"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument shear", value=shear, expected_type=type_hints["shear"])
            check_type(argname="argument trim", value=trim, expected_type=type_hints["trim"])
            check_type(argname="argument unsharp_mask", value=unsharp_mask, expected_type=type_hints["unsharp_mask"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if append is not None:
            self._values["append"] = append
        if aspect_crop is not None:
            self._values["aspect_crop"] = aspect_crop
        if background_color is not None:
            self._values["background_color"] = background_color
        if blur is not None:
            self._values["blur"] = blur
        if chroma_key is not None:
            self._values["chroma_key"] = chroma_key
        if composite is not None:
            self._values["composite"] = composite
        if compound is not None:
            self._values["compound"] = compound
        if contrast is not None:
            self._values["contrast"] = contrast
        if crop is not None:
            self._values["crop"] = crop
        if face_crop is not None:
            self._values["face_crop"] = face_crop
        if feature_crop is not None:
            self._values["feature_crop"] = feature_crop
        if fit_and_fill is not None:
            self._values["fit_and_fill"] = fit_and_fill
        if goop is not None:
            self._values["goop"] = goop
        if grayscale is not None:
            self._values["grayscale"] = grayscale
        if hsl is not None:
            self._values["hsl"] = hsl
        if hsv is not None:
            self._values["hsv"] = hsv
        if if_dimension is not None:
            self._values["if_dimension"] = if_dimension
        if if_orientation is not None:
            self._values["if_orientation"] = if_orientation
        if im_query is not None:
            self._values["im_query"] = im_query
        if max_colors is not None:
            self._values["max_colors"] = max_colors
        if mirror is not None:
            self._values["mirror"] = mirror
        if mono_hue is not None:
            self._values["mono_hue"] = mono_hue
        if opacity is not None:
            self._values["opacity"] = opacity
        if region_of_interest_crop is not None:
            self._values["region_of_interest_crop"] = region_of_interest_crop
        if relative_crop is not None:
            self._values["relative_crop"] = relative_crop
        if remove_color is not None:
            self._values["remove_color"] = remove_color
        if resize is not None:
            self._values["resize"] = resize
        if rotate is not None:
            self._values["rotate"] = rotate
        if scale is not None:
            self._values["scale"] = scale
        if shear is not None:
            self._values["shear"] = shear
        if trim is not None:
            self._values["trim"] = trim
        if unsharp_mask is not None:
            self._values["unsharp_mask"] = unsharp_mask

    @builtins.property
    def append(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationAppend"]]]:
        '''append block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        '''
        result = self._values.get("append")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationAppend"]]], result)

    @builtins.property
    def aspect_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationAspectCrop"]]]:
        '''aspect_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        '''
        result = self._values.get("aspect_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationAspectCrop"]]], result)

    @builtins.property
    def background_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationBackgroundColor"]]]:
        '''background_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        '''
        result = self._values.get("background_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationBackgroundColor"]]], result)

    @builtins.property
    def blur(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationBlur"]]]:
        '''blur block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        '''
        result = self._values.get("blur")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationBlur"]]], result)

    @builtins.property
    def chroma_key(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationChromaKey"]]]:
        '''chroma_key block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        '''
        result = self._values.get("chroma_key")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationChromaKey"]]], result)

    @builtins.property
    def composite(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationComposite"]]]:
        '''composite block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        '''
        result = self._values.get("composite")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationComposite"]]], result)

    @builtins.property
    def compound(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationCompound"]]]:
        '''compound block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        '''
        result = self._values.get("compound")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationCompound"]]], result)

    @builtins.property
    def contrast(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationContrast"]]]:
        '''contrast block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationContrast"]]], result)

    @builtins.property
    def crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationCrop"]]]:
        '''crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        '''
        result = self._values.get("crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationCrop"]]], result)

    @builtins.property
    def face_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationFaceCrop"]]]:
        '''face_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        '''
        result = self._values.get("face_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationFaceCrop"]]], result)

    @builtins.property
    def feature_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationFeatureCrop"]]]:
        '''feature_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        '''
        result = self._values.get("feature_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationFeatureCrop"]]], result)

    @builtins.property
    def fit_and_fill(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationFitAndFill"]]]:
        '''fit_and_fill block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        '''
        result = self._values.get("fit_and_fill")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationFitAndFill"]]], result)

    @builtins.property
    def goop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationGoop"]]]:
        '''goop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        '''
        result = self._values.get("goop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationGoop"]]], result)

    @builtins.property
    def grayscale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationGrayscale"]]]:
        '''grayscale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        '''
        result = self._values.get("grayscale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationGrayscale"]]], result)

    @builtins.property
    def hsl(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationHsl"]]]:
        '''hsl block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        '''
        result = self._values.get("hsl")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationHsl"]]], result)

    @builtins.property
    def hsv(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationHsv"]]]:
        '''hsv block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        '''
        result = self._values.get("hsv")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationHsv"]]], result)

    @builtins.property
    def if_dimension(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfDimension"]]]:
        '''if_dimension block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        '''
        result = self._values.get("if_dimension")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfDimension"]]], result)

    @builtins.property
    def if_orientation(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfOrientation"]]]:
        '''if_orientation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        '''
        result = self._values.get("if_orientation")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfOrientation"]]], result)

    @builtins.property
    def im_query(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationImQuery"]]]:
        '''im_query block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        '''
        result = self._values.get("im_query")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationImQuery"]]], result)

    @builtins.property
    def max_colors(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationMaxColors"]]]:
        '''max_colors block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        '''
        result = self._values.get("max_colors")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationMaxColors"]]], result)

    @builtins.property
    def mirror(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationMirror"]]]:
        '''mirror block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        '''
        result = self._values.get("mirror")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationMirror"]]], result)

    @builtins.property
    def mono_hue(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationMonoHue"]]]:
        '''mono_hue block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        '''
        result = self._values.get("mono_hue")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationMonoHue"]]], result)

    @builtins.property
    def opacity(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationOpacity"]]]:
        '''opacity block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationOpacity"]]], result)

    @builtins.property
    def region_of_interest_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationRegionOfInterestCrop"]]]:
        '''region_of_interest_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        '''
        result = self._values.get("region_of_interest_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationRegionOfInterestCrop"]]], result)

    @builtins.property
    def relative_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationRelativeCrop"]]]:
        '''relative_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        '''
        result = self._values.get("relative_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationRelativeCrop"]]], result)

    @builtins.property
    def remove_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationRemoveColor"]]]:
        '''remove_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        '''
        result = self._values.get("remove_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationRemoveColor"]]], result)

    @builtins.property
    def resize(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationResize"]]]:
        '''resize block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        '''
        result = self._values.get("resize")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationResize"]]], result)

    @builtins.property
    def rotate(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationRotate"]]]:
        '''rotate block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        '''
        result = self._values.get("rotate")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationRotate"]]], result)

    @builtins.property
    def scale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationScale"]]]:
        '''scale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationScale"]]], result)

    @builtins.property
    def shear(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationShear"]]]:
        '''shear block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        '''
        result = self._values.get("shear")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationShear"]]], result)

    @builtins.property
    def trim(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationTrim"]]]:
        '''trim block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        '''
        result = self._values.get("trim")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationTrim"]]], result)

    @builtins.property
    def unsharp_mask(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationUnsharpMask"]]]:
        '''unsharp_mask block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        result = self._values.get("unsharp_mask")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationUnsharpMask"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationAppend",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_priority": "gravityPriority",
        "gravity_priority_var": "gravityPriorityVar",
        "gravity_var": "gravityVar",
        "preserve_minor_dimension": "preserveMinorDimension",
        "preserve_minor_dimension_var": "preserveMinorDimensionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationAppend:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationAppendImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_priority: typing.Optional[builtins.str] = None,
        gravity_priority_var: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        preserve_minor_dimension: typing.Optional[builtins.str] = None,
        preserve_minor_dimension_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Specifies where to place the ``image`` relative to the source image. The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_priority: Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal. The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority DataAkamaiImagingPolicyImage#gravity_priority}
        :param gravity_priority_var: Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal. The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority_var DataAkamaiImagingPolicyImage#gravity_priority_var}
        :param gravity_var: Specifies where to place the ``image`` relative to the source image. The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param preserve_minor_dimension: Whether to preserve the source image's minor dimension, ``false`` by default. The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension DataAkamaiImagingPolicyImage#preserve_minor_dimension}
        :param preserve_minor_dimension_var: Whether to preserve the source image's minor dimension, ``false`` by default. The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension_var DataAkamaiImagingPolicyImage#preserve_minor_dimension_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationAppendImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c7a089c5011abed56e674b26e3f2b79327992cdd2f35eb3b4daadb4eb983a295)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_priority", value=gravity_priority, expected_type=type_hints["gravity_priority"])
            check_type(argname="argument gravity_priority_var", value=gravity_priority_var, expected_type=type_hints["gravity_priority_var"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument preserve_minor_dimension", value=preserve_minor_dimension, expected_type=type_hints["preserve_minor_dimension"])
            check_type(argname="argument preserve_minor_dimension_var", value=preserve_minor_dimension_var, expected_type=type_hints["preserve_minor_dimension_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_priority is not None:
            self._values["gravity_priority"] = gravity_priority
        if gravity_priority_var is not None:
            self._values["gravity_priority_var"] = gravity_priority_var
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if preserve_minor_dimension is not None:
            self._values["preserve_minor_dimension"] = preserve_minor_dimension
        if preserve_minor_dimension_var is not None:
            self._values["preserve_minor_dimension_var"] = preserve_minor_dimension_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationAppendImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationAppendImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Specifies where to place the ``image`` relative to the source image.

        The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_priority(self) -> typing.Optional[builtins.str]:
        '''Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal.

        The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority DataAkamaiImagingPolicyImage#gravity_priority}
        '''
        result = self._values.get("gravity_priority")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_priority_var(self) -> typing.Optional[builtins.str]:
        '''Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal.

        The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority_var DataAkamaiImagingPolicyImage#gravity_priority_var}
        '''
        result = self._values.get("gravity_priority_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Specifies where to place the ``image`` relative to the source image.

        The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def preserve_minor_dimension(self) -> typing.Optional[builtins.str]:
        '''Whether to preserve the source image's minor dimension, ``false`` by default.

        The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension DataAkamaiImagingPolicyImage#preserve_minor_dimension}
        '''
        result = self._values.get("preserve_minor_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def preserve_minor_dimension_var(self) -> typing.Optional[builtins.str]:
        '''Whether to preserve the source image's minor dimension, ``false`` by default.

        The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension_var DataAkamaiImagingPolicyImage#preserve_minor_dimension_var}
        '''
        result = self._values.get("preserve_minor_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationAppend(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationAppendImage",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationAppendImage:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationAppendImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationAppendImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationAppendImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4f6d236871655d156589064b356228d7145799b6de5625c4070e37d50a70f320)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationAppendImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationAppendImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationAppendImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4e69d294e2b8d3106b964ab771ec3edad918c7f3aa52df8568a57d5fe03c25ba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationAppendList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationAppendList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__36c49a657c83f88ab442f92ada2f3e12ab51eb897ddce1e6b5dc3c272b88d3ff)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationAppendOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3763319634098201a2ba5f915e77716cd3ac0c5c1d90b4ab4dedca85af791a8e)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationAppendOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__15f261daf1b8677b5efbb2623fee330907980dba0cc02cf7d12132611a16fefa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bd694cd952758def08dfdfcf0b52e2722c5388f769dd1b177ddfad4b869f09d0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c6a4b1041551b349cb60dc6c56769657a3bf9db466419d2592d1b67d11cdc5d4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationAppend]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationAppend]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationAppend]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__857acaa1cd26a6b144e7457baed2f4c07bef3dc7252f0f5c293f708b51f87d18)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationAppendOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationAppendOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d8bb548f80a44c317275f77745e7ef1ced81748880562a22cdca05b32ad1a9ec)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationAppendImage()

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityPriority")
    def reset_gravity_priority(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityPriority", []))

    @jsii.member(jsii_name="resetGravityPriorityVar")
    def reset_gravity_priority_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityPriorityVar", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPreserveMinorDimension")
    def reset_preserve_minor_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPreserveMinorDimension", []))

    @jsii.member(jsii_name="resetPreserveMinorDimensionVar")
    def reset_preserve_minor_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPreserveMinorDimensionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationAppendImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationAppendImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityInput")
    def gravity_priority_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityPriorityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityVarInput")
    def gravity_priority_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityPriorityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationAppendImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationAppendImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionInput")
    def preserve_minor_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "preserveMinorDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionVarInput")
    def preserve_minor_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "preserveMinorDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3843b60fec85698541857384a8274624e4b2a018c0dda5b717aab710e5f36332)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityPriority")
    def gravity_priority(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityPriority"))

    @gravity_priority.setter
    def gravity_priority(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7a3547160d7c5c765df11796471aa6da8840bde1cab36b977cffa2c3ec481e6d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityPriority", value)

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityVar")
    def gravity_priority_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityPriorityVar"))

    @gravity_priority_var.setter
    def gravity_priority_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7a6d965499568033d834eaaeec9c9c8eb2ad6d901b5b634c6b9ad8e9c2de2c75)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityPriorityVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c8901c0c69f7e9537f3cb1e5eecc64b628fa79e81838d09a0b62c94b8e31182b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimension")
    def preserve_minor_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "preserveMinorDimension"))

    @preserve_minor_dimension.setter
    def preserve_minor_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__65944b16bfc8996f03a9620790e84a4a8c8f58fd1dc9d0174471b62fb188c199)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "preserveMinorDimension", value)

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionVar")
    def preserve_minor_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "preserveMinorDimensionVar"))

    @preserve_minor_dimension_var.setter
    def preserve_minor_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e08db53c8c58ad24fc664871850cffdd5b87af10809ba513944ee1e28b566672)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "preserveMinorDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationAppend]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationAppend]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationAppend]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__70bb102ee60d06f3339d5caa566f0bc24533824d8cc391043f3890de0c21509e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationAspectCrop",
    jsii_struct_bases=[],
    name_mapping={
        "allow_expansion": "allowExpansion",
        "allow_expansion_var": "allowExpansionVar",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationAspectCrop:
    def __init__(
        self,
        *,
        allow_expansion: typing.Optional[builtins.str] = None,
        allow_expansion_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_expansion: Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image. Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        :param allow_expansion_var: Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image. Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        :param height: The height term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The width term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        :param x_position: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dbb173acbd4329a81c79a0eeaed7718fcb4ad7c7c4a0f9115312314be8ff54b7)
            check_type(argname="argument allow_expansion", value=allow_expansion, expected_type=type_hints["allow_expansion"])
            check_type(argname="argument allow_expansion_var", value=allow_expansion_var, expected_type=type_hints["allow_expansion_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if allow_expansion is not None:
            self._values["allow_expansion"] = allow_expansion
        if allow_expansion_var is not None:
            self._values["allow_expansion_var"] = allow_expansion_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def allow_expansion(self) -> typing.Optional[builtins.str]:
        '''Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image.

        Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        '''
        result = self._values.get("allow_expansion")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def allow_expansion_var(self) -> typing.Optional[builtins.str]:
        '''Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image.

        Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        '''
        result = self._values.get("allow_expansion_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationAspectCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationAspectCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationAspectCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__51c3024a4872dc58ce23ae90f9a6ff651079ccbe5a9bffc0034b85400a5b27b0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationAspectCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa38823926afd2cf09376e072dfa9574f5c7220725c427f51f5b00515875e4df)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationAspectCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ce940c7b9b3f87081e1f85a66a3fd8b0f2e5a1807e3f2e8eea0cc1a982f48f4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6b6b17593e3f0f09824c1d93d1e56b9eb20fa8e5232f57aa92309c1d5b0a2a47)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__238709c42c490cc31bcfdb569e5b3954b38ec71f064a2809683ad37e8296356d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationAspectCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationAspectCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationAspectCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__24e8b4ceeb001f7669c630a805e7955160b5bb60cd78be563a836e447066497c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationAspectCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationAspectCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__891c83ec10f8df9d393599527787f59feb0e0d8d8f19fd8a9b0a6e277eb7cace)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAllowExpansion")
    def reset_allow_expansion(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansion", []))

    @jsii.member(jsii_name="resetAllowExpansionVar")
    def reset_allow_expansion_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansionVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionInput")
    def allow_expansion_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVarInput")
    def allow_expansion_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansion")
    def allow_expansion(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansion"))

    @allow_expansion.setter
    def allow_expansion(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dbcac27bffbb2516eef595be6c309c3ff4a49da4a87b78ca22cd4e149820ee13)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansion", value)

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVar")
    def allow_expansion_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansionVar"))

    @allow_expansion_var.setter
    def allow_expansion_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8d33ceed5c15e1b82b7fa4d8c8432d5f24697140e18541107a169e8ca8ee474c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansionVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__366c9923027409f2db94beef4c011af2e9dc343072c70834d2f4313a6307b09e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__251441abfdca13d7ce420911d7380c9dec704e2a8f70ba09e421ddc6f6fa1221)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3c0c4d6456362bd04511f0762bead03ab890f1c5f338412308f4c9f1066e50b8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__547bc21b918b4166f0831bb9236917617261b5bec5d1cf0157b221a296f2befb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__883d045a7d1678e4077d24f5cf2f2aae020ddffefb484d3bb6067c81133286ea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__937f0f41c2206743c81b259f7cdb0f0e07988b73fa17d25f680fdc30d6e81afb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3b1600e260b4861f91adc8a4dbe99d93120a32a9f7748074755d61a54c058c88)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__13ae084273685165a5866cbd697a226220ee8fc775c38fc9c553edd13d0b8b2e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationAspectCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationAspectCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationAspectCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1c114cae78f99b2c49cf6062aa319dab694179c7bd28dbd66e940da1b6439acd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationBackgroundColor",
    jsii_struct_bases=[],
    name_mapping={"color": "color", "color_var": "colorVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationBackgroundColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__85d211376f2ebe760afabe4a6dd48021bb924b8db21627d2b8d78c491f6415d4)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationBackgroundColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationBackgroundColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationBackgroundColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__01eac3179fb775a73b7ff65b6754c3cbe6e101102b8ebf8327bcb8b7e86ba12e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationBackgroundColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5dc65f77b96fc73765b47902f61059f161fc8bd276de8f1fc40ca8b9a7aff5f8)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationBackgroundColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6a4d121e75fe1a092968637e64f94e348a5141bb16a7cf1244825852b2192830)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3aba197cf4e649aecbdf6601e1950ceda3bfc852e44c4ac8734c796f6a569286)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b7d3a2d44dceeddf80b4279387314cef67dfdda33b61451d929c9478e30c064d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationBackgroundColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationBackgroundColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d049636121157e8262f551bbe69a118d7c8204fff56861a7019e745c9fd68a0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationBackgroundColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationBackgroundColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6ba7adfeccf28c6f56add70db8445076681086822701ed9a046180f7249f99b7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ac7a3a4caa4eca06c64efaa4d0222d7541086e3f1d877340d36e67f23f9f2cb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8b46e9f29cae041f20bc927f7b9b66c36c2131aad52bb02dac07641e1df322f2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationBackgroundColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationBackgroundColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationBackgroundColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__06557c35724ef109f4600d99a4d496db3ddb84a616bd972254abd9afa9ca9472)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationBlur",
    jsii_struct_bases=[],
    name_mapping={"sigma": "sigma", "sigma_var": "sigmaVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationBlur:
    def __init__(
        self,
        *,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param sigma: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d0f737fecea9ac4868cbfc2c501860dbb0248bcb2248f44113ad4b760bc699c)
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationBlur(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationBlurList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationBlurList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fccb5a59eac006347f03e9c7a350ccba10f1c47aa0c04935e6ee2d49b43ee867)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationBlurOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d9fc636e9651566974b16be20880ec7f4b44d7ea0ec0ca5920a9fdce8eb9c618)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationBlurOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ef240a7abf207b51c59c18ad16b0f61ced0fb3c40afc0cbf412df77f0b2bdcbc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a46b1382804e217e5b338508846a7f8d59853abcc9b384e8e927e67e6759150)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ce1bfc5bde489b3ca9ef76c7c1f1ade6820e41a3b7cb199fa4152b1056083cdf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationBlur]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationBlur]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__73be0566682ef5bede11b4e8a0c3b3f5f1723e4db99cce659c4ac6b09669060f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationBlurOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationBlurOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__25f383d5817a629b6011290869c4416c0e88613ebc4407aa64d409abce05e41d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__81bf70912d703f024fc0a2988c6a534ac72eaa9600d20ca0ef94e7032d87a779)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__02744c89b3faa46b0aa1f8291c66bf03e4574e5c25e36e3af42422d37bea2b0d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationBlur]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationBlur]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationBlur]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__123a5556f212df07ae89d134ee8fe79f8cc409a363e971c517b4d0abbe43c35c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationChromaKey",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_feather": "hueFeather",
        "hue_feather_var": "hueFeatherVar",
        "hue_tolerance": "hueTolerance",
        "hue_tolerance_var": "hueToleranceVar",
        "hue_var": "hueVar",
        "lightness_feather": "lightnessFeather",
        "lightness_feather_var": "lightnessFeatherVar",
        "lightness_tolerance": "lightnessTolerance",
        "lightness_tolerance_var": "lightnessToleranceVar",
        "saturation_feather": "saturationFeather",
        "saturation_feather_var": "saturationFeatherVar",
        "saturation_tolerance": "saturationTolerance",
        "saturation_tolerance_var": "saturationToleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationChromaKey:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_feather: typing.Optional[builtins.str] = None,
        hue_feather_var: typing.Optional[builtins.str] = None,
        hue_tolerance: typing.Optional[builtins.str] = None,
        hue_tolerance_var: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness_feather: typing.Optional[builtins.str] = None,
        lightness_feather_var: typing.Optional[builtins.str] = None,
        lightness_tolerance: typing.Optional[builtins.str] = None,
        lightness_tolerance_var: typing.Optional[builtins.str] = None,
        saturation_feather: typing.Optional[builtins.str] = None,
        saturation_feather_var: typing.Optional[builtins.str] = None,
        saturation_tolerance: typing.Optional[builtins.str] = None,
        saturation_tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_feather: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        :param hue_feather_var: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        :param hue_tolerance: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        :param hue_tolerance_var: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        :param hue_var: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness_feather: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        :param lightness_feather_var: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        :param lightness_tolerance: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        :param lightness_tolerance_var: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        :param saturation_feather: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        :param saturation_feather_var: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        :param saturation_tolerance: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        :param saturation_tolerance_var: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__617bc4824033f2e648d7947cc0fa1b92695b157c19492197a8514185891f5c74)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_feather", value=hue_feather, expected_type=type_hints["hue_feather"])
            check_type(argname="argument hue_feather_var", value=hue_feather_var, expected_type=type_hints["hue_feather_var"])
            check_type(argname="argument hue_tolerance", value=hue_tolerance, expected_type=type_hints["hue_tolerance"])
            check_type(argname="argument hue_tolerance_var", value=hue_tolerance_var, expected_type=type_hints["hue_tolerance_var"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness_feather", value=lightness_feather, expected_type=type_hints["lightness_feather"])
            check_type(argname="argument lightness_feather_var", value=lightness_feather_var, expected_type=type_hints["lightness_feather_var"])
            check_type(argname="argument lightness_tolerance", value=lightness_tolerance, expected_type=type_hints["lightness_tolerance"])
            check_type(argname="argument lightness_tolerance_var", value=lightness_tolerance_var, expected_type=type_hints["lightness_tolerance_var"])
            check_type(argname="argument saturation_feather", value=saturation_feather, expected_type=type_hints["saturation_feather"])
            check_type(argname="argument saturation_feather_var", value=saturation_feather_var, expected_type=type_hints["saturation_feather_var"])
            check_type(argname="argument saturation_tolerance", value=saturation_tolerance, expected_type=type_hints["saturation_tolerance"])
            check_type(argname="argument saturation_tolerance_var", value=saturation_tolerance_var, expected_type=type_hints["saturation_tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_feather is not None:
            self._values["hue_feather"] = hue_feather
        if hue_feather_var is not None:
            self._values["hue_feather_var"] = hue_feather_var
        if hue_tolerance is not None:
            self._values["hue_tolerance"] = hue_tolerance
        if hue_tolerance_var is not None:
            self._values["hue_tolerance_var"] = hue_tolerance_var
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness_feather is not None:
            self._values["lightness_feather"] = lightness_feather
        if lightness_feather_var is not None:
            self._values["lightness_feather_var"] = lightness_feather_var
        if lightness_tolerance is not None:
            self._values["lightness_tolerance"] = lightness_tolerance
        if lightness_tolerance_var is not None:
            self._values["lightness_tolerance_var"] = lightness_tolerance_var
        if saturation_feather is not None:
            self._values["saturation_feather"] = saturation_feather
        if saturation_feather_var is not None:
            self._values["saturation_feather_var"] = saturation_feather_var
        if saturation_tolerance is not None:
            self._values["saturation_tolerance"] = saturation_tolerance
        if saturation_tolerance_var is not None:
            self._values["saturation_tolerance_var"] = saturation_tolerance_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        '''
        result = self._values.get("hue_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        '''
        result = self._values.get("hue_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        '''
        result = self._values.get("hue_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        '''
        result = self._values.get("hue_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        '''
        result = self._values.get("lightness_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        '''
        result = self._values.get("lightness_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        '''
        result = self._values.get("lightness_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        '''
        result = self._values.get("lightness_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        '''
        result = self._values.get("saturation_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        '''
        result = self._values.get("saturation_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        '''
        result = self._values.get("saturation_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        result = self._values.get("saturation_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationChromaKey(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationChromaKeyList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationChromaKeyList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__246ed7b5052e2b7138f3b9a96a66d3e746d16065f7cef7fd211e6a59c34a8cc5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationChromaKeyOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__85041e4d8e574db17c4c05ad7bc550cf970757d5432337b62701269374e20d3f)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationChromaKeyOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7574c383a6a462e21c855e2f1aad2d663cd99e34bff39764da21c7ba20d4936b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6024a2a899367a831482cd4e9c8054b2413621a3cfaa6ea1c545bfbb082c4652)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4aef23b0140f145b3cc7d76362822a653a99f873fe13e17a6aa0363243babdf3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationChromaKey]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationChromaKey]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa566b5061adeaa9c92c894ed0baa2c25efd901526a5946bf5a733da35bad47a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationChromaKeyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationChromaKeyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__99398d35cb4be8ac227ca6a37e16c45971ac94b474a7ad3688f3471fa752828b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueFeather")
    def reset_hue_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeather", []))

    @jsii.member(jsii_name="resetHueFeatherVar")
    def reset_hue_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeatherVar", []))

    @jsii.member(jsii_name="resetHueTolerance")
    def reset_hue_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueTolerance", []))

    @jsii.member(jsii_name="resetHueToleranceVar")
    def reset_hue_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueToleranceVar", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightnessFeather")
    def reset_lightness_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeather", []))

    @jsii.member(jsii_name="resetLightnessFeatherVar")
    def reset_lightness_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeatherVar", []))

    @jsii.member(jsii_name="resetLightnessTolerance")
    def reset_lightness_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessTolerance", []))

    @jsii.member(jsii_name="resetLightnessToleranceVar")
    def reset_lightness_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessToleranceVar", []))

    @jsii.member(jsii_name="resetSaturationFeather")
    def reset_saturation_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeather", []))

    @jsii.member(jsii_name="resetSaturationFeatherVar")
    def reset_saturation_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeatherVar", []))

    @jsii.member(jsii_name="resetSaturationTolerance")
    def reset_saturation_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationTolerance", []))

    @jsii.member(jsii_name="resetSaturationToleranceVar")
    def reset_saturation_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherInput")
    def hue_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVarInput")
    def hue_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceInput")
    def hue_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVarInput")
    def hue_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherInput")
    def lightness_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVarInput")
    def lightness_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceInput")
    def lightness_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVarInput")
    def lightness_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherInput")
    def saturation_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVarInput")
    def saturation_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceInput")
    def saturation_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVarInput")
    def saturation_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__379987a4f8a8a5bd408895445ce22dbc000210cb9e017c47d2a273ca6d206429)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeather")
    def hue_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeather"))

    @hue_feather.setter
    def hue_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0db6f09572cd34e07729a6560ac5704cba9652e9dd37b147b3155e472d583d37)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeather", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVar")
    def hue_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeatherVar"))

    @hue_feather_var.setter
    def hue_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ebac7416363193c810f829344df0e7f7924bb655b0116deb2dae934888f3c053)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueTolerance")
    def hue_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueTolerance"))

    @hue_tolerance.setter
    def hue_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a31f11eec7ce378a9c4d25817c9b43cb4de15e183360e864f4b9d9f3e4f64be6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVar")
    def hue_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueToleranceVar"))

    @hue_tolerance_var.setter
    def hue_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__840688c057dc1e726dd9729d01556c871ca63358f4f16afda1956bd851be0c7f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1511a6bde58cc42eaef59960dc3a3f48cac2184e381cf2bd609c35fcac3e23b8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeather")
    def lightness_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeather"))

    @lightness_feather.setter
    def lightness_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__109acd179277696172825f8a2e833394115f6502cda51c7a47f7f626719c1993)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeather", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVar")
    def lightness_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeatherVar"))

    @lightness_feather_var.setter
    def lightness_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__27f3e165246213a5706f75878e9661f518db82a064ee18fdbdf423b1edd539b2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessTolerance")
    def lightness_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessTolerance"))

    @lightness_tolerance.setter
    def lightness_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e2092fb3eb27fb995d4533a72abd16f6e0c4035333b61aaf4785c175bd4b801a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVar")
    def lightness_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessToleranceVar"))

    @lightness_tolerance_var.setter
    def lightness_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a68fd3ec007906c3a94240accf5f5b59962409d052513c2a0d62fed6facd8340)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeather")
    def saturation_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeather"))

    @saturation_feather.setter
    def saturation_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ec0d74d8beda358e68b93a67d37b1b6537870b51268f59fae8aca32d408f3e7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeather", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVar")
    def saturation_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeatherVar"))

    @saturation_feather_var.setter
    def saturation_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__572d5ff5f4d6ff864d6b29266a1360488d6b8ef62989bd656117997e05d31da8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationTolerance")
    def saturation_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationTolerance"))

    @saturation_tolerance.setter
    def saturation_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8d7faba46582b8744319761244946604bff967048fab38fdeadedbc7d08dcebe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVar")
    def saturation_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationToleranceVar"))

    @saturation_tolerance_var.setter
    def saturation_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8d76742fb1f960e0b37e20c8c8ef6d320ab49c078abf88747f43ab87b8a6fa7d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationChromaKey]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationChromaKey]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationChromaKey]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ff7132269643cfd2bd6e133c099374f9434cb3a3780390d4bdaabc5eec3ed32)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationComposite",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "placement": "placement",
        "placement_var": "placementVar",
        "scale": "scale",
        "scale_dimension": "scaleDimension",
        "scale_dimension_var": "scaleDimensionVar",
        "scale_var": "scaleVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationComposite:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationCompositeImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        placement: typing.Optional[builtins.str] = None,
        placement_var: typing.Optional[builtins.str] = None,
        scale: typing.Optional[builtins.str] = None,
        scale_dimension: typing.Optional[builtins.str] = None,
        scale_dimension_var: typing.Optional[builtins.str] = None,
        scale_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param placement: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        :param placement_var: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        :param scale: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param scale_dimension: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        :param scale_dimension_var: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        :param scale_var: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        :param x_position: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationCompositeImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9aa461d3569abb90a9cfb672a3a739a97be5505595ac08c7e4461326aa94ad50)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument placement", value=placement, expected_type=type_hints["placement"])
            check_type(argname="argument placement_var", value=placement_var, expected_type=type_hints["placement_var"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument scale_dimension", value=scale_dimension, expected_type=type_hints["scale_dimension"])
            check_type(argname="argument scale_dimension_var", value=scale_dimension_var, expected_type=type_hints["scale_dimension_var"])
            check_type(argname="argument scale_var", value=scale_var, expected_type=type_hints["scale_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if placement is not None:
            self._values["placement"] = placement
        if placement_var is not None:
            self._values["placement_var"] = placement_var
        if scale is not None:
            self._values["scale"] = scale
        if scale_dimension is not None:
            self._values["scale_dimension"] = scale_dimension
        if scale_dimension_var is not None:
            self._values["scale_dimension_var"] = scale_dimension_var
        if scale_var is not None:
            self._values["scale_var"] = scale_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationCompositeImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationCompositeImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        '''
        result = self._values.get("placement")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement_var(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        '''
        result = self._values.get("placement_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        '''
        result = self._values.get("scale_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        '''
        result = self._values.get("scale_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        '''
        result = self._values.get("scale_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationComposite(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationCompositeImage",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationCompositeImage:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationCompositeImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationCompositeImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationCompositeImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0afdc220d3c03cd75511c96545117f185423d94249b0cda659d97ea1a17f3247)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationCompositeImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationCompositeImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__09d7b8bb0a1c4c775c2106ecdde9ed8ee4f1c2b1f2639b502b18a56d925cc1f7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationCompositeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationCompositeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__adc4cb3236ef09ad09ed2ccf69841ed1bac0d1fa7cbe1cf91950778cf32ad657)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationCompositeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bce46bed7bc2285bfe4c85317bb132a4d847254366309bef000473fa15972871)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationCompositeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f869e5655b16acc4a581ab995db80cd58056c2c5bc6e4d67cafea30e81e21744)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__47164493216b5b055e7d091ae12209e9264defeae335ffc399498a7ec08a3db5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8fc4b0469190072351989aaaeb32436829b4d96dbe9fc4a574ac4f3acbc64bbf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationComposite]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationComposite]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__042b27f4ed26a93611ada4eed2ea3546550373fc1f100d848bb0f39ce1185903)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationCompositeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationCompositeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e76c8d202bb8584c26df5672215f5080e36994687890131d65f109099dadaf94)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationCompositeImage()

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPlacement")
    def reset_placement(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacement", []))

    @jsii.member(jsii_name="resetPlacementVar")
    def reset_placement_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacementVar", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetScaleDimension")
    def reset_scale_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimension", []))

    @jsii.member(jsii_name="resetScaleDimensionVar")
    def reset_scale_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimensionVar", []))

    @jsii.member(jsii_name="resetScaleVar")
    def reset_scale_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationCompositeImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationCompositeImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationCompositeImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="placementInput")
    def placement_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementInput"))

    @builtins.property
    @jsii.member(jsii_name="placementVarInput")
    def placement_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionInput")
    def scale_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVarInput")
    def scale_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleVarInput")
    def scale_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1c38564a7deefcff4deb76034e33d559d2bcadd06d5b545146f6fdb1cfa9b3f2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__42f6c55e2a730c3779055a7af9cb01f8ff0b44071b2d983fbf603bfe80ce5396)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="placement")
    def placement(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placement"))

    @placement.setter
    def placement(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4aa2e711a0898b791bb8a9103d9b73fb60d734b3abe2ba7b6110a596b9429578)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placement", value)

    @builtins.property
    @jsii.member(jsii_name="placementVar")
    def placement_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placementVar"))

    @placement_var.setter
    def placement_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__744df71c6b58cf87438dc79aefd603fd5fcdb5ae043453f8c5e4b9defe6ff12b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placementVar", value)

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scale"))

    @scale.setter
    def scale(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2beaa659582702bf9c979328f2737b4106547f996b707364205539acaf367d31)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scale", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimension")
    def scale_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimension"))

    @scale_dimension.setter
    def scale_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__95ba687c38c7d6d17825f42a1795bda5f7801b1fc3ea42306810df88438ce288)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimension", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVar")
    def scale_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimensionVar"))

    @scale_dimension_var.setter
    def scale_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a2cc8a3ceadcae98970fa6f6ebf9e7747e0d5567e7a33c21b827994d6114eab8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="scaleVar")
    def scale_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleVar"))

    @scale_var.setter
    def scale_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__001f9d094719532df6da1641f284d04ed3a072b5aa351d1b42b5a90b97da4dab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__890788448b40b46832ac8a9dd97267bded65d415274ffebd803b4e1b0680c09c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bda015a5de0f296dae455d3bc7abe4b950bcd0ce4d883174e47ef9428c6bf29f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__67bf1bd6d6bc09c7a1660c4450b0e6506807f8d8ada6e5fffd1fba3052671b7d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7e260281d0a1c72ffea9949d54032db87df9fc091697e55bd15e90cd1c40124e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationComposite]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationComposite]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationComposite]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3d8b01b824f90bc937743d6e5a5ee15dad51e1c29c966d6f7db59bec542a5a4f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationCompound",
    jsii_struct_bases=[],
    name_mapping={"transformations": "transformations"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationCompound:
    def __init__(
        self,
        *,
        transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param transformations: transformations block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9f66272c8eee629b5c0563be4acbfe216b5d00ce39ce4583d79c26caf9c6e5f5)
            check_type(argname="argument transformations", value=transformations, expected_type=type_hints["transformations"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if transformations is not None:
            self._values["transformations"] = transformations

    @builtins.property
    def transformations(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationCompoundTransformations"]]]:
        '''transformations block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        result = self._values.get("transformations")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationCompoundTransformations"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationCompound(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationCompoundList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationCompoundList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__71e7ec6a372acbe96b86eb0c3da42b36d94dae4f118f3b8e5de8daa46a794423)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationCompoundOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c0b529a1068913e7f9afd02a40732377fa11fd285c93af7977f00a92c8b35803)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationCompoundOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e1d8038a44e5c649fab5a0a76904aad25b833567f64cda8a88a4b00389bb0332)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f7ef9b246049318ff32eaab01595b767545b08db38ebac55d978623d3faa687)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d4340c274e48f50369bb1522a01b779cdcc55654b113abeefbc4008fae03554f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationCompound]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationCompound]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fb8637799008ec6fca1dec2d598ee539c0a66ce9c9edac7d28d5f6e564b19afc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationCompoundOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationCompoundOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__72d0b89defe6d9d7da25022f04eed984a589a2a8ce6e82d921e15a3e8ec1d3d1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformations")
    def put_transformations(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__57e15f118f4692ffcf54ca3ff657c3fe35d8e2b1aca96985a602bd728fe0937d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTransformations", [value]))

    @jsii.member(jsii_name="resetTransformations")
    def reset_transformations(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformations", []))

    @builtins.property
    @jsii.member(jsii_name="transformations")
    def transformations(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationCompoundTransformationsList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationCompoundTransformationsList", jsii.get(self, "transformations"))

    @builtins.property
    @jsii.member(jsii_name="transformationsInput")
    def transformations_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationCompoundTransformations"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationCompoundTransformations"]]], jsii.get(self, "transformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationCompound]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationCompound]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationCompound]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3d18aaf47db7d0bfd577f2cd2e1c92a7f7e30277aae5b2fbc5fc3843a75fef27)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationCompoundTransformations",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationCompoundTransformations:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationCompoundTransformations(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationCompoundTransformationsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationCompoundTransformationsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2079a454c28adba95d34bad8b49a58ff9b8104fe3632228f7d6e2169fcd12b2b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationCompoundTransformationsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__732757e28245626e4c3f43e4539ff44b42ce278bc52671983384c53e9cea0ca2)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationCompoundTransformationsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b3ac1ae16213a21eccdf64153f31eb54d2cdb6cd19edf6500d1b55f17c76db70)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eb81add9f3f564ba9e1911d71354316296cc81561c493bff86464303f1730289)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fc24614ca357ab6eb96f43db2a092c32bfc2be73893e5de217d77468a0634dad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationCompoundTransformations]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationCompoundTransformations]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationCompoundTransformations]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1753c2078e7bb1f8359ce8561493ff674e45f4e3126ab42e309e0939dc1820e9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationCompoundTransformationsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationCompoundTransformationsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__47d4d89cbe1876cf5d50a218527564d11f2032460655580c3a9e96c4478dfd1d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationCompoundTransformations]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationCompoundTransformations]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationCompoundTransformations]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1a025311b96bd6cc5bf81cdc818a4c271cfd983d22c8622a3d919f45c6bb7102)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationContrast",
    jsii_struct_bases=[],
    name_mapping={
        "brightness": "brightness",
        "brightness_var": "brightnessVar",
        "contrast": "contrast",
        "contrast_var": "contrastVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationContrast:
    def __init__(
        self,
        *,
        brightness: typing.Optional[builtins.str] = None,
        brightness_var: typing.Optional[builtins.str] = None,
        contrast: typing.Optional[builtins.str] = None,
        contrast_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param brightness: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        :param brightness_var: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        :param contrast: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param contrast_var: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a11373f93fd42c1894cc0acdbb24c6b28f36d9a4adc60de018391974e94e564d)
            check_type(argname="argument brightness", value=brightness, expected_type=type_hints["brightness"])
            check_type(argname="argument brightness_var", value=brightness_var, expected_type=type_hints["brightness_var"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument contrast_var", value=contrast_var, expected_type=type_hints["contrast_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if brightness is not None:
            self._values["brightness"] = brightness
        if brightness_var is not None:
            self._values["brightness_var"] = brightness_var
        if contrast is not None:
            self._values["contrast"] = contrast
        if contrast_var is not None:
            self._values["contrast_var"] = contrast_var

    @builtins.property
    def brightness(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        '''
        result = self._values.get("brightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def brightness_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        '''
        result = self._values.get("brightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        result = self._values.get("contrast_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationContrast(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationContrastList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationContrastList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9c029fa8bfd29a4ce029c81590e7d799dd355e298e923789ef714281d65998f3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationContrastOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__110dca09cab33504088d8289ab9172e5fa40d555bf00802b15554b1f125737fc)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationContrastOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8b13779a8035a362ca6f5f38d2cdaf33a9c48bf7743877c8d853f18c5679419d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f5638b955e820ff7bc6ab27d5e03cacd7f56305a7d77c979c01c316b8be09163)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9eee89236fb45721efd5090416da1b9d0cbaa0510e77ad77f13a71ac99fdbf87)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationContrast]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationContrast]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cdddbb01063297c93cafaddc3a5673259850717f6478f145404aaeedc2029513)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationContrastOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationContrastOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ccf2571cbfaee943141c8709a75c85ca3bdfde05d32e8eaf3ef5ba85722f900f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetBrightness")
    def reset_brightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightness", []))

    @jsii.member(jsii_name="resetBrightnessVar")
    def reset_brightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightnessVar", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetContrastVar")
    def reset_contrast_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrastVar", []))

    @builtins.property
    @jsii.member(jsii_name="brightnessInput")
    def brightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="brightnessVarInput")
    def brightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastVarInput")
    def contrast_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="brightness")
    def brightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightness"))

    @brightness.setter
    def brightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__36675c1f75ab5bde509730cbfd9b06e4572c2f3e16e5a86f56a460f5a1d47d4d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightness", value)

    @builtins.property
    @jsii.member(jsii_name="brightnessVar")
    def brightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightnessVar"))

    @brightness_var.setter
    def brightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__767fbf2bad86a0d7678855e571ec251a713848ca728d195fcccc69a155f14078)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrast"))

    @contrast.setter
    def contrast(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__24f79f27a4336e8a4c1846c9a8b89d96dc5d5b84e9d82e8a2206d84f8f4113de)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrast", value)

    @builtins.property
    @jsii.member(jsii_name="contrastVar")
    def contrast_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrastVar"))

    @contrast_var.setter
    def contrast_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5421d0661472b6f354741e6d3ae359092646b6984ce4b37bd4d5a8e29b2911b3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrastVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationContrast]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationContrast]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationContrast]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__115696d086686b8fc2bcedbb1a74f79d77f7dc37ba98f5c225e7258f0a819bf0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationCrop",
    jsii_struct_bases=[],
    name_mapping={
        "allow_expansion": "allowExpansion",
        "allow_expansion_var": "allowExpansionVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationCrop:
    def __init__(
        self,
        *,
        allow_expansion: typing.Optional[builtins.str] = None,
        allow_expansion_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_expansion: If cropping an area outside of the existing canvas, expands the image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        :param allow_expansion_var: If cropping an area outside of the existing canvas, expands the image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        :param gravity: Frame of reference for X and Y Positions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Frame of reference for X and Y Positions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The number of pixels to crop along the y-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The number of pixels to crop along the y-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The number of pixels to crop along the x-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The number of pixels to crop along the x-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        :param x_position: The x-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__380d5ede4e93b66d5138bd5305ba2351d14b06e81c9fc08d742d33e99ee35c2f)
            check_type(argname="argument allow_expansion", value=allow_expansion, expected_type=type_hints["allow_expansion"])
            check_type(argname="argument allow_expansion_var", value=allow_expansion_var, expected_type=type_hints["allow_expansion_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if allow_expansion is not None:
            self._values["allow_expansion"] = allow_expansion
        if allow_expansion_var is not None:
            self._values["allow_expansion_var"] = allow_expansion_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def allow_expansion(self) -> typing.Optional[builtins.str]:
        '''If cropping an area outside of the existing canvas, expands the image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        '''
        result = self._values.get("allow_expansion")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def allow_expansion_var(self) -> typing.Optional[builtins.str]:
        '''If cropping an area outside of the existing canvas, expands the image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        '''
        result = self._values.get("allow_expansion_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Frame of reference for X and Y Positions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Frame of reference for X and Y Positions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the y-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the y-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the x-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the x-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__31ae6084cd813fc80db696b98951cfdcb7a95955fe19af5fda5bbb11f30bdefb)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__295bdc8a7391664dee7c7da765346c3df73755d6b729ef990ac6771c4500e945)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__73825eacd84a83dfd2fbf81d98fcb560c07b668d271b9879782184273251bbcd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7986114306200e3b96ef51f7a3f931c7577f9277108ca09772a9870c9edd08ba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__48895edd78c62e7d492c830b5e368604cd6acbd2892778724b73e52d5488fa6d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f265c8eba3b65f5efe5a412466328bc37b14998345249d736d3e0aff27f6e8aa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ad4106b7e7451a0d0bd817ac1cca46252a14557443b2561f4fc9b209acb9ac8c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAllowExpansion")
    def reset_allow_expansion(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansion", []))

    @jsii.member(jsii_name="resetAllowExpansionVar")
    def reset_allow_expansion_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansionVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionInput")
    def allow_expansion_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVarInput")
    def allow_expansion_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansion")
    def allow_expansion(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansion"))

    @allow_expansion.setter
    def allow_expansion(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3e4959934d6f1c1028c441a0bb202d79d0fba3905ca9c228efba977a32cce838)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansion", value)

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVar")
    def allow_expansion_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansionVar"))

    @allow_expansion_var.setter
    def allow_expansion_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c795e5438b17692ecca7b384f7f7927b8bfee7f51d9b99a20ea8aaba8d4d7872)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansionVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__042ac43ef5be6ba1e5a27a7f50923ad0f7104e537b3c868538df6324de1f2baa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c71cd6e9d3782fb9250b2351004f9367e7512532ec0ed9ef17e620b0df1d6c7e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9139089979529925fa20543c6bf0bb9fd92768c72f749c2b90f1448b80710f00)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a4e199580c58d00704dad7e7fc1e348c880c8f7f00ed006a53e1ebdc08f18cf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__25ffb6240c278a70fb8f5439c17fffcdcd04c6932b1292fc209b8a180effc94f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea69570bb014e7e391aa78085babad0c9ebc7e473f4980d0877ee6f1dfa5b72c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__47ff5fefa940483dd38bd6bb79200044912402e3d5c9b546456f6ad008f1cca0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__08de0d6b68447322613bf18e3184374f16a171cf95f87f2e5996ba9a41340e4b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f14c674122aeec080a52abf793d5b7b292ce092177bc6408cfa8013cd44dc16b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__07dd737560936efbe91a289006948f5450ffd6914fa73292dc688d071f788817)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7e1967e72047bbb58954bc41610934749eb663ad0a3619d8dcf486b33fc2efbd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationFaceCrop",
    jsii_struct_bases=[],
    name_mapping={
        "algorithm": "algorithm",
        "algorithm_var": "algorithmVar",
        "confidence": "confidence",
        "confidence_var": "confidenceVar",
        "fail_gravity": "failGravity",
        "fail_gravity_var": "failGravityVar",
        "focus": "focus",
        "focus_var": "focusVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "padding": "padding",
        "padding_var": "paddingVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationFaceCrop:
    def __init__(
        self,
        *,
        algorithm: typing.Optional[builtins.str] = None,
        algorithm_var: typing.Optional[builtins.str] = None,
        confidence: typing.Optional[builtins.str] = None,
        confidence_var: typing.Optional[builtins.str] = None,
        fail_gravity: typing.Optional[builtins.str] = None,
        fail_gravity_var: typing.Optional[builtins.str] = None,
        focus: typing.Optional[builtins.str] = None,
        focus_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param algorithm: Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm DataAkamaiImagingPolicyImage#algorithm}
        :param algorithm_var: Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm_var DataAkamaiImagingPolicyImage#algorithm_var}
        :param confidence: With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image. Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence DataAkamaiImagingPolicyImage#confidence}
        :param confidence_var: With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image. Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence_var DataAkamaiImagingPolicyImage#confidence_var}
        :param fail_gravity: Controls placement of the crop if Image and Video Manager does not detect any faces in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        :param fail_gravity_var: Controls placement of the crop if Image and Video Manager does not detect any faces in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        :param focus: Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus DataAkamaiImagingPolicyImage#focus}
        :param focus_var: Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus_var DataAkamaiImagingPolicyImage#focus_var}
        :param gravity: Controls placement of the crop. Directions are relative to the face(s) plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Controls placement of the crop. Directions are relative to the face(s) plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param padding: The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        :param style: Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__38dd494a9f4407fdfb83bcb366ad121435c410deacb13a8c7a5846eb3f34c952)
            check_type(argname="argument algorithm", value=algorithm, expected_type=type_hints["algorithm"])
            check_type(argname="argument algorithm_var", value=algorithm_var, expected_type=type_hints["algorithm_var"])
            check_type(argname="argument confidence", value=confidence, expected_type=type_hints["confidence"])
            check_type(argname="argument confidence_var", value=confidence_var, expected_type=type_hints["confidence_var"])
            check_type(argname="argument fail_gravity", value=fail_gravity, expected_type=type_hints["fail_gravity"])
            check_type(argname="argument fail_gravity_var", value=fail_gravity_var, expected_type=type_hints["fail_gravity_var"])
            check_type(argname="argument focus", value=focus, expected_type=type_hints["focus"])
            check_type(argname="argument focus_var", value=focus_var, expected_type=type_hints["focus_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if algorithm is not None:
            self._values["algorithm"] = algorithm
        if algorithm_var is not None:
            self._values["algorithm_var"] = algorithm_var
        if confidence is not None:
            self._values["confidence"] = confidence
        if confidence_var is not None:
            self._values["confidence_var"] = confidence_var
        if fail_gravity is not None:
            self._values["fail_gravity"] = fail_gravity
        if fail_gravity_var is not None:
            self._values["fail_gravity_var"] = fail_gravity_var
        if focus is not None:
            self._values["focus"] = focus
        if focus_var is not None:
            self._values["focus_var"] = focus_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def algorithm(self) -> typing.Optional[builtins.str]:
        '''Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm DataAkamaiImagingPolicyImage#algorithm}
        '''
        result = self._values.get("algorithm")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def algorithm_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm_var DataAkamaiImagingPolicyImage#algorithm_var}
        '''
        result = self._values.get("algorithm_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def confidence(self) -> typing.Optional[builtins.str]:
        '''With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image.

        Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence DataAkamaiImagingPolicyImage#confidence}
        '''
        result = self._values.get("confidence")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def confidence_var(self) -> typing.Optional[builtins.str]:
        '''With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image.

        Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence_var DataAkamaiImagingPolicyImage#confidence_var}
        '''
        result = self._values.get("confidence_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any faces in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        '''
        result = self._values.get("fail_gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any faces in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        '''
        result = self._values.get("fail_gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def focus(self) -> typing.Optional[builtins.str]:
        '''Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus DataAkamaiImagingPolicyImage#focus}
        '''
        result = self._values.get("focus")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def focus_var(self) -> typing.Optional[builtins.str]:
        '''Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus_var DataAkamaiImagingPolicyImage#focus_var}
        '''
        result = self._values.get("focus_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the face(s) plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the face(s) plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationFaceCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationFaceCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationFaceCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e696249311f491e968f1550280b9a1fa3c29df6c8d1a25ee15988459f630f661)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationFaceCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__67c39fe0e117730759ebcff7c82063c5caa8e28c4f8deef74cfec67af2c5890f)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationFaceCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d33164c1e53dc894663422129ff2bc0dd47f3f954040fd92dff226700be56add)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__077d36cc4c49161a1a8b52e6f547d5d1cd197aecc695833a9b536b7af694f51c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b0b0276fbe7501e85016d8f986103109c1941e9cca2714430d7c48e13315030a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationFaceCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationFaceCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationFaceCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6bde84a207de3fdee6ada9b48032cb18db1468786aac36c08d82ede0cdf269ba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationFaceCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationFaceCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__651b4b961421e51ea251dc436130e5eb00ee19765710e2d4d33c6dd59d5fccda)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAlgorithm")
    def reset_algorithm(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAlgorithm", []))

    @jsii.member(jsii_name="resetAlgorithmVar")
    def reset_algorithm_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAlgorithmVar", []))

    @jsii.member(jsii_name="resetConfidence")
    def reset_confidence(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetConfidence", []))

    @jsii.member(jsii_name="resetConfidenceVar")
    def reset_confidence_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetConfidenceVar", []))

    @jsii.member(jsii_name="resetFailGravity")
    def reset_fail_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravity", []))

    @jsii.member(jsii_name="resetFailGravityVar")
    def reset_fail_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravityVar", []))

    @jsii.member(jsii_name="resetFocus")
    def reset_focus(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFocus", []))

    @jsii.member(jsii_name="resetFocusVar")
    def reset_focus_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFocusVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="algorithmInput")
    def algorithm_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "algorithmInput"))

    @builtins.property
    @jsii.member(jsii_name="algorithmVarInput")
    def algorithm_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "algorithmVarInput"))

    @builtins.property
    @jsii.member(jsii_name="confidenceInput")
    def confidence_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "confidenceInput"))

    @builtins.property
    @jsii.member(jsii_name="confidenceVarInput")
    def confidence_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "confidenceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityInput")
    def fail_gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityVarInput")
    def fail_gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="focusInput")
    def focus_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "focusInput"))

    @builtins.property
    @jsii.member(jsii_name="focusVarInput")
    def focus_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "focusVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="algorithm")
    def algorithm(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "algorithm"))

    @algorithm.setter
    def algorithm(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__77632071ae7f862cc8da60930f802eae376f2cc628e72a66a8ebad5ec7935713)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "algorithm", value)

    @builtins.property
    @jsii.member(jsii_name="algorithmVar")
    def algorithm_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "algorithmVar"))

    @algorithm_var.setter
    def algorithm_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2dce71111cd708a6c4aa3604fefd1292fd6d9f14dfb052d727d3b7d228f4c5b6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "algorithmVar", value)

    @builtins.property
    @jsii.member(jsii_name="confidence")
    def confidence(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "confidence"))

    @confidence.setter
    def confidence(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__481b0f00707737ef17b55525e885a87676ce294d20cbc4ef12ae686e0de8110f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "confidence", value)

    @builtins.property
    @jsii.member(jsii_name="confidenceVar")
    def confidence_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "confidenceVar"))

    @confidence_var.setter
    def confidence_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a5d823788060b107342e951b2d1f9b86322f5fbca23c17ea2d9db5075430042)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "confidenceVar", value)

    @builtins.property
    @jsii.member(jsii_name="failGravity")
    def fail_gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravity"))

    @fail_gravity.setter
    def fail_gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0370e6f945fa703618c8a597d4868ba425f94f13d2030f1d1209bb30c57e1736)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravity", value)

    @builtins.property
    @jsii.member(jsii_name="failGravityVar")
    def fail_gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravityVar"))

    @fail_gravity_var.setter
    def fail_gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d64cf559cdefb6cd697080628fb02358be3482c2f9604892e20120d188b3bb50)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="focus")
    def focus(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "focus"))

    @focus.setter
    def focus(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__452655f6c0cb946f1376ff2a787f81a413deab5733dee4724f5d6e4cea97e84c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "focus", value)

    @builtins.property
    @jsii.member(jsii_name="focusVar")
    def focus_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "focusVar"))

    @focus_var.setter
    def focus_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__787cb85144caa49fcb1e4a6738e904e57afd9d1471f65518e7aa64293e79f66d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "focusVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e1c916bd97ba0c788c03f8d84faa1bb3327744f378e1c5abf1a852c7886b1236)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c59685f47f3041ed5b12bb7e2b8628b9c592167b8dbf8837349affce3cf893c7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b200a4a00024d6f126ec53ce953a371f31d7c87ef06e1f822a91953bb1d44977)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__10e84644d3533cbabf2e7fb8a00910e5fc95fb21495ca9eb937917d965c21357)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a9e33007ba8c26d9f826748bf8ed52a4f67a73dbe03fbfef0b51d599419b8af)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__060295a933ca121340ff3e58644c806d77e13317cfa0230b557fbc2d852e49da)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bf7a839d92f5e9fd3a682ab0510bd3a79b3b48710589a5e470f61d065ae50922)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__266aa6bb0eea399e5ac92ec5625baaf0418d74355e5644b2c6ff7cc4dfd44342)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fc936df4b6b4a22105b7b25bb04e7c115aeb30e7f87f7ef79d5bd438ba6ba480)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d1d9900971c0a1b52581b24c1c71111807dfafeeda99250fade794ca299389e1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationFaceCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationFaceCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationFaceCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d3107c1b217ec0e09a7e56d40c239fee171870562f867d387e4841a0ffc0c652)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationFeatureCrop",
    jsii_struct_bases=[],
    name_mapping={
        "fail_gravity": "failGravity",
        "fail_gravity_var": "failGravityVar",
        "feature_radius": "featureRadius",
        "feature_radius_var": "featureRadiusVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "max_features": "maxFeatures",
        "max_features_var": "maxFeaturesVar",
        "min_feature_quality": "minFeatureQuality",
        "min_feature_quality_var": "minFeatureQualityVar",
        "padding": "padding",
        "padding_var": "paddingVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationFeatureCrop:
    def __init__(
        self,
        *,
        fail_gravity: typing.Optional[builtins.str] = None,
        fail_gravity_var: typing.Optional[builtins.str] = None,
        feature_radius: typing.Optional[builtins.str] = None,
        feature_radius_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        max_features: typing.Optional[builtins.str] = None,
        max_features_var: typing.Optional[builtins.str] = None,
        min_feature_quality: typing.Optional[builtins.str] = None,
        min_feature_quality_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fail_gravity: Controls placement of the crop if Image and Video Manager does not detect any features in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        :param fail_gravity_var: Controls placement of the crop if Image and Video Manager does not detect any features in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        :param feature_radius: The size in pixels of the important features to search for. If identified, two features never appear closer together than this value, ``8.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius DataAkamaiImagingPolicyImage#feature_radius}
        :param feature_radius_var: The size in pixels of the important features to search for. If identified, two features never appear closer together than this value, ``8.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius_var DataAkamaiImagingPolicyImage#feature_radius_var}
        :param gravity: Controls placement of the crop. Directions are relative to the region of interest plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Controls placement of the crop. Directions are relative to the region of interest plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param max_features: The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features DataAkamaiImagingPolicyImage#max_features}
        :param max_features_var: The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features_var DataAkamaiImagingPolicyImage#max_features_var}
        :param min_feature_quality: Determines the minimum quality level of the feature identified. To consider a feature important, the feature needs to surpass this value. Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality DataAkamaiImagingPolicyImage#min_feature_quality}
        :param min_feature_quality_var: Determines the minimum quality level of the feature identified. To consider a feature important, the feature needs to surpass this value. Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality_var DataAkamaiImagingPolicyImage#min_feature_quality_var}
        :param padding: Adds space around the region of interest. The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: Adds space around the region of interest. The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        :param style: Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4460701d1d2a68021d1b87c2144caac5fef23249bbcfa63a80d842a0059de958)
            check_type(argname="argument fail_gravity", value=fail_gravity, expected_type=type_hints["fail_gravity"])
            check_type(argname="argument fail_gravity_var", value=fail_gravity_var, expected_type=type_hints["fail_gravity_var"])
            check_type(argname="argument feature_radius", value=feature_radius, expected_type=type_hints["feature_radius"])
            check_type(argname="argument feature_radius_var", value=feature_radius_var, expected_type=type_hints["feature_radius_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument max_features", value=max_features, expected_type=type_hints["max_features"])
            check_type(argname="argument max_features_var", value=max_features_var, expected_type=type_hints["max_features_var"])
            check_type(argname="argument min_feature_quality", value=min_feature_quality, expected_type=type_hints["min_feature_quality"])
            check_type(argname="argument min_feature_quality_var", value=min_feature_quality_var, expected_type=type_hints["min_feature_quality_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fail_gravity is not None:
            self._values["fail_gravity"] = fail_gravity
        if fail_gravity_var is not None:
            self._values["fail_gravity_var"] = fail_gravity_var
        if feature_radius is not None:
            self._values["feature_radius"] = feature_radius
        if feature_radius_var is not None:
            self._values["feature_radius_var"] = feature_radius_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if max_features is not None:
            self._values["max_features"] = max_features
        if max_features_var is not None:
            self._values["max_features_var"] = max_features_var
        if min_feature_quality is not None:
            self._values["min_feature_quality"] = min_feature_quality
        if min_feature_quality_var is not None:
            self._values["min_feature_quality_var"] = min_feature_quality_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def fail_gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any features in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        '''
        result = self._values.get("fail_gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any features in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        '''
        result = self._values.get("fail_gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feature_radius(self) -> typing.Optional[builtins.str]:
        '''The size in pixels of the important features to search for.

        If identified, two features never appear closer together than this value, ``8.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius DataAkamaiImagingPolicyImage#feature_radius}
        '''
        result = self._values.get("feature_radius")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feature_radius_var(self) -> typing.Optional[builtins.str]:
        '''The size in pixels of the important features to search for.

        If identified, two features never appear closer together than this value, ``8.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius_var DataAkamaiImagingPolicyImage#feature_radius_var}
        '''
        result = self._values.get("feature_radius_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the region of interest plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the region of interest plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def max_features(self) -> typing.Optional[builtins.str]:
        '''The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features DataAkamaiImagingPolicyImage#max_features}
        '''
        result = self._values.get("max_features")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def max_features_var(self) -> typing.Optional[builtins.str]:
        '''The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features_var DataAkamaiImagingPolicyImage#max_features_var}
        '''
        result = self._values.get("max_features_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def min_feature_quality(self) -> typing.Optional[builtins.str]:
        '''Determines the minimum quality level of the feature identified.

        To consider a feature important, the feature needs to surpass this value.  Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality DataAkamaiImagingPolicyImage#min_feature_quality}
        '''
        result = self._values.get("min_feature_quality")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def min_feature_quality_var(self) -> typing.Optional[builtins.str]:
        '''Determines the minimum quality level of the feature identified.

        To consider a feature important, the feature needs to surpass this value.  Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality_var DataAkamaiImagingPolicyImage#min_feature_quality_var}
        '''
        result = self._values.get("min_feature_quality_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''Adds space around the region of interest.

        The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''Adds space around the region of interest.

        The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationFeatureCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationFeatureCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationFeatureCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__80addd63acab5c86e8eca2068cda85e2f14d0bd3319bd002f954d439aae59bcf)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationFeatureCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ed40c57d75b3bfe83ccb9709da37aa7d50848d264c92a8eb4e63d79175623efc)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationFeatureCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__189981a596909c88f89731b6452f54ecd83404b3e972e2422c3ec31aacacbf7a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__79cdd21ced580496879a9e1e7420d1329929b9aa3f97f371b192da36198dfd64)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__74ba74e64e0abdcac946f74fb8c37b7da6f9f3314fc0a27e703125a1686c0d19)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationFeatureCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationFeatureCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationFeatureCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3709444ccca752e7a81c927e3b504087db0c2164a1e70da8c0590e4961212017)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationFeatureCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationFeatureCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ff67f1af45fbccbc97b069a8b49606c5e6cd55e881340a24ac3d18225da4c3c7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetFailGravity")
    def reset_fail_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravity", []))

    @jsii.member(jsii_name="resetFailGravityVar")
    def reset_fail_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravityVar", []))

    @jsii.member(jsii_name="resetFeatureRadius")
    def reset_feature_radius(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureRadius", []))

    @jsii.member(jsii_name="resetFeatureRadiusVar")
    def reset_feature_radius_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureRadiusVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetMaxFeatures")
    def reset_max_features(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxFeatures", []))

    @jsii.member(jsii_name="resetMaxFeaturesVar")
    def reset_max_features_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxFeaturesVar", []))

    @jsii.member(jsii_name="resetMinFeatureQuality")
    def reset_min_feature_quality(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMinFeatureQuality", []))

    @jsii.member(jsii_name="resetMinFeatureQualityVar")
    def reset_min_feature_quality_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMinFeatureQualityVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="failGravityInput")
    def fail_gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityVarInput")
    def fail_gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featureRadiusInput")
    def feature_radius_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featureRadiusInput"))

    @builtins.property
    @jsii.member(jsii_name="featureRadiusVarInput")
    def feature_radius_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featureRadiusVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesInput")
    def max_features_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "maxFeaturesInput"))

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesVarInput")
    def max_features_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "maxFeaturesVarInput"))

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityInput")
    def min_feature_quality_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "minFeatureQualityInput"))

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityVarInput")
    def min_feature_quality_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "minFeatureQualityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravity")
    def fail_gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravity"))

    @fail_gravity.setter
    def fail_gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a9072bc872ddd97987a4195543bf61f797d8f62dd4a5b5a2c4c1381115345f4b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravity", value)

    @builtins.property
    @jsii.member(jsii_name="failGravityVar")
    def fail_gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravityVar"))

    @fail_gravity_var.setter
    def fail_gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__74746763ab285a235edde3fb39449b0ea9bdf7b1cf6952a2483ef18e54f55f9c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="featureRadius")
    def feature_radius(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featureRadius"))

    @feature_radius.setter
    def feature_radius(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a7ef25156583e1e531a3d48f6c10381fefbbf9fea84415b3a2ae8833d9a5d54)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featureRadius", value)

    @builtins.property
    @jsii.member(jsii_name="featureRadiusVar")
    def feature_radius_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featureRadiusVar"))

    @feature_radius_var.setter
    def feature_radius_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__318b876b20e5e366c6b2d076cca1fcb6e7e42d0b3bb7f90d12533e39779a2dc8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featureRadiusVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5777f3d1e1caf84b0d35d73ab394435af920ef634a696768b5638b548c14f455)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a3f434b333aaf493ebd8f65b0b1042849d79048ba459c209b72512d3a737f671)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9822657bef5800f62e0ede779ad78b6daeb51212af3e767071c04381cc71a6ad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b787142ecdc5ac638b4416312112aa42dfe4121baf19555f7c183a5dbecc75ec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="maxFeatures")
    def max_features(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "maxFeatures"))

    @max_features.setter
    def max_features(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3f880aa8e841c59721c5c69319767cb1695eb457a2b62b4351a65eeb75fef024)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "maxFeatures", value)

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesVar")
    def max_features_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "maxFeaturesVar"))

    @max_features_var.setter
    def max_features_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab70a4772a2d5ae6d04838389cbd0df476ca92d3dafa06000ecbec909697038b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "maxFeaturesVar", value)

    @builtins.property
    @jsii.member(jsii_name="minFeatureQuality")
    def min_feature_quality(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "minFeatureQuality"))

    @min_feature_quality.setter
    def min_feature_quality(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a6e717c0b6956df031e9b99ca0ecb09aba81c2b538c9598594e8f1de083658fa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "minFeatureQuality", value)

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityVar")
    def min_feature_quality_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "minFeatureQualityVar"))

    @min_feature_quality_var.setter
    def min_feature_quality_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2c987d67f383bd8dd9b409f63449a56382354b085add7c050b876e953d8ecf14)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "minFeatureQualityVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__abbdd5de29c66fb136a9396e56ae599a8ec0aec07f774ea2500fdf6175578618)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d8d30513bcc711aa79ca191fe0f686b746ea06cab1984cef313f5da1b884e607)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cc196601bab38b31ed390245ccb9c6260dbaa94152952f716fe144a97121c426)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eb98f856be317f7320b510cb6b79c5e3143720d82dd12a5bedbcc18b42c6588f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3499f001a500a36b2d0f4860245ae311aea3f933e924733893d791e110c8d0c7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cf9c554c9052d8aaa77777d6f5f47274855de1a130fa83fadd016fe86df21a29)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationFeatureCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationFeatureCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationFeatureCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bbe02650dec92c7633067682b996bcc9b2789c9a93f296bd50a8a0f3e035145e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationFitAndFill",
    jsii_struct_bases=[],
    name_mapping={
        "fill_transformation": "fillTransformation",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationFitAndFill:
    def __init__(
        self,
        *,
        fill_transformation: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationFitAndFillFillTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fill_transformation: fill_transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_transformation DataAkamaiImagingPolicyImage#fill_transformation}
        :param height: The height value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The width value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(fill_transformation, dict):
            fill_transformation = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationFitAndFillFillTransformation(**fill_transformation)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7742aae8502c27b8017fa7ff7b3de84d6ee493f94d83f25a98b5849f8d5067c9)
            check_type(argname="argument fill_transformation", value=fill_transformation, expected_type=type_hints["fill_transformation"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fill_transformation is not None:
            self._values["fill_transformation"] = fill_transformation
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def fill_transformation(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationFitAndFillFillTransformation"]:
        '''fill_transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_transformation DataAkamaiImagingPolicyImage#fill_transformation}
        '''
        result = self._values.get("fill_transformation")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationFitAndFillFillTransformation"], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationFitAndFill(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationFitAndFillFillTransformation",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationFitAndFillFillTransformation:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationFitAndFillFillTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationFitAndFillFillTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationFitAndFillFillTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2cb6b4e16acb53b82ab8c865eed78aceb972bdd100ae6f1ab288e8c793cd9a9d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationFitAndFillFillTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationFitAndFillFillTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationFitAndFillFillTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8e74f3d7a59baca13453fff9d593fea0fa39df8c0e439e1340938569f5c154d9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationFitAndFillList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationFitAndFillList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0e88a737df8b2b6874f24fea4fdc43262fa8a5856e0c5a98c3fbeedb707f3e07)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationFitAndFillOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8e75b16c8322208b1194207a718168ba74f2e5aae04e0fac0c10e79d4201fb85)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationFitAndFillOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__074ebb8f30302c4374d4c686f1f60384295b2c81afe5e6e75a7bfd31b4bbed64)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__21ddd0c1d9c8207ecc678e062ca6bcd093c8c82f5dc1d502ffd860b59cb3073e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__40ddd03aa42cedb4795371f732f57f809ee56233b70124d246b599352613d646)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationFitAndFill]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationFitAndFill]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationFitAndFill]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__633193dc55f848c1cfae2680e1f9b8eb9e1632187c59c4bc07978dbb1f5c7653)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationFitAndFillOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationFitAndFillOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fcffd964336cf5833a8b15ed0e75c30227cd195177941e109d8fc42f29643b2a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putFillTransformation")
    def put_fill_transformation(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationFitAndFillFillTransformation()

        return typing.cast(None, jsii.invoke(self, "putFillTransformation", [value]))

    @jsii.member(jsii_name="resetFillTransformation")
    def reset_fill_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFillTransformation", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="fillTransformation")
    def fill_transformation(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationFitAndFillFillTransformationOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationFitAndFillFillTransformationOutputReference, jsii.get(self, "fillTransformation"))

    @builtins.property
    @jsii.member(jsii_name="fillTransformationInput")
    def fill_transformation_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationFitAndFillFillTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationFitAndFillFillTransformation], jsii.get(self, "fillTransformationInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b68862c6e4c75be564b4cacb202ff3b99991448e8603b55435547aa78f798d19)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__872a34b3800c3e9d672cd1117427c0a013e4fb2cbe292dbaae7974ea1f26f78c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cdd3ae135841ab9cfc8c956dcc1b5644ad4c9fd56dd13dfec6051e6f7155ce68)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8c808d239b8d5959931aabd7ae45cc343bc3aa68271f67cfe6a4d5e474c408df)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationFitAndFill]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationFitAndFill]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationFitAndFill]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__943458cb7e134b38c7364b2ecb7b7954e75ac8db116fd80b9498a583daf12184)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationGoop",
    jsii_struct_bases=[],
    name_mapping={
        "chaos": "chaos",
        "chaos_var": "chaosVar",
        "density": "density",
        "density_var": "densityVar",
        "power": "power",
        "power_var": "powerVar",
        "seed": "seed",
        "seed_var": "seedVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationGoop:
    def __init__(
        self,
        *,
        chaos: typing.Optional[builtins.str] = None,
        chaos_var: typing.Optional[builtins.str] = None,
        density: typing.Optional[builtins.str] = None,
        density_var: typing.Optional[builtins.str] = None,
        power: typing.Optional[builtins.str] = None,
        power_var: typing.Optional[builtins.str] = None,
        seed: typing.Optional[builtins.str] = None,
        seed_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param chaos: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        :param chaos_var: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        :param density: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        :param density_var: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        :param power: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        :param power_var: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        :param seed: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        :param seed_var: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9e738ba37e53089353881a3e3aa42369a920717c6d28caf7654c05e6583922a8)
            check_type(argname="argument chaos", value=chaos, expected_type=type_hints["chaos"])
            check_type(argname="argument chaos_var", value=chaos_var, expected_type=type_hints["chaos_var"])
            check_type(argname="argument density", value=density, expected_type=type_hints["density"])
            check_type(argname="argument density_var", value=density_var, expected_type=type_hints["density_var"])
            check_type(argname="argument power", value=power, expected_type=type_hints["power"])
            check_type(argname="argument power_var", value=power_var, expected_type=type_hints["power_var"])
            check_type(argname="argument seed", value=seed, expected_type=type_hints["seed"])
            check_type(argname="argument seed_var", value=seed_var, expected_type=type_hints["seed_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if chaos is not None:
            self._values["chaos"] = chaos
        if chaos_var is not None:
            self._values["chaos_var"] = chaos_var
        if density is not None:
            self._values["density"] = density
        if density_var is not None:
            self._values["density_var"] = density_var
        if power is not None:
            self._values["power"] = power
        if power_var is not None:
            self._values["power_var"] = power_var
        if seed is not None:
            self._values["seed"] = seed
        if seed_var is not None:
            self._values["seed_var"] = seed_var

    @builtins.property
    def chaos(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        '''
        result = self._values.get("chaos")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def chaos_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        '''
        result = self._values.get("chaos_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        '''
        result = self._values.get("density")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density_var(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        '''
        result = self._values.get("density_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        '''
        result = self._values.get("power")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power_var(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        '''
        result = self._values.get("power_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        '''
        result = self._values.get("seed")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed_var(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        result = self._values.get("seed_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationGoop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationGoopList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationGoopList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__32f605bb83cee8ae69389d1ae96cd5dd1fd3c82c09b5da6aa998cc77bb588df7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationGoopOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bef51e4335198b2d1aa8f4dbd5680508db579c1eeefbe31d2fbd7f7a43a36bf2)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationGoopOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cb8c7c19a7ba2a7b9e1d8f0ba97103bdc134ba40d897d5821109479bf93beec3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__62c2bbaa6e5612d60bfb5d52b824dccf03ca4433796c81d18cbb1147941de443)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1efab45ab1a367deaca8f3083b2ba7026a577d2e6a60d835aae0d4f7917b770c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationGoop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationGoop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c7fb800aa353994513aec4c98c41ec251765a25169ebf7bf33cbc55d0f8b9316)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationGoopOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationGoopOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__63bcc3c1146eb82db9ca9cf7378a6605e4e68a4b59fd40412de37fa4ed3d043d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetChaos")
    def reset_chaos(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaos", []))

    @jsii.member(jsii_name="resetChaosVar")
    def reset_chaos_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaosVar", []))

    @jsii.member(jsii_name="resetDensity")
    def reset_density(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensity", []))

    @jsii.member(jsii_name="resetDensityVar")
    def reset_density_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensityVar", []))

    @jsii.member(jsii_name="resetPower")
    def reset_power(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPower", []))

    @jsii.member(jsii_name="resetPowerVar")
    def reset_power_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPowerVar", []))

    @jsii.member(jsii_name="resetSeed")
    def reset_seed(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeed", []))

    @jsii.member(jsii_name="resetSeedVar")
    def reset_seed_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeedVar", []))

    @builtins.property
    @jsii.member(jsii_name="chaosInput")
    def chaos_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosInput"))

    @builtins.property
    @jsii.member(jsii_name="chaosVarInput")
    def chaos_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosVarInput"))

    @builtins.property
    @jsii.member(jsii_name="densityInput")
    def density_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityInput"))

    @builtins.property
    @jsii.member(jsii_name="densityVarInput")
    def density_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="powerInput")
    def power_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerInput"))

    @builtins.property
    @jsii.member(jsii_name="powerVarInput")
    def power_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerVarInput"))

    @builtins.property
    @jsii.member(jsii_name="seedInput")
    def seed_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedInput"))

    @builtins.property
    @jsii.member(jsii_name="seedVarInput")
    def seed_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedVarInput"))

    @builtins.property
    @jsii.member(jsii_name="chaos")
    def chaos(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaos"))

    @chaos.setter
    def chaos(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a49d6ea079fbe4132b82cedeb2b072f0d530feae68ee8b8e0aac7cb215786cf9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaos", value)

    @builtins.property
    @jsii.member(jsii_name="chaosVar")
    def chaos_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaosVar"))

    @chaos_var.setter
    def chaos_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e80d3941750884003ad6f9f7a2da4aff8fa192ae9b3daa6c1022db9c69bebed9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaosVar", value)

    @builtins.property
    @jsii.member(jsii_name="density")
    def density(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "density"))

    @density.setter
    def density(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8c06a5451ecd3eac4fa227f34c1c0ee911a11537621537ed1ac64f178d2f0aa4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "density", value)

    @builtins.property
    @jsii.member(jsii_name="densityVar")
    def density_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "densityVar"))

    @density_var.setter
    def density_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0109e9ff1b0344fa0bf8ba471876f2204fb5eea73bed95bfb25f91f28b5a49aa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "densityVar", value)

    @builtins.property
    @jsii.member(jsii_name="power")
    def power(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "power"))

    @power.setter
    def power(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__89f044f3dad52d7c6757ab89efb526ce2e8203080fc17ee5981269112385ddca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "power", value)

    @builtins.property
    @jsii.member(jsii_name="powerVar")
    def power_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "powerVar"))

    @power_var.setter
    def power_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b1b46fdc3bc3592a7e267c1d01c9be1207de786ac8dde8040149a809bcda74af)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "powerVar", value)

    @builtins.property
    @jsii.member(jsii_name="seed")
    def seed(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seed"))

    @seed.setter
    def seed(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a4a4995e07baf83caead6a8fabfb749f2c52a8f31283975b007eb6dd0ba87f6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seed", value)

    @builtins.property
    @jsii.member(jsii_name="seedVar")
    def seed_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seedVar"))

    @seed_var.setter
    def seed_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8f051360fcf1ede7783a7e6365c66b2c4ef525dbf5fa4971ee1ca6ace025114f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seedVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationGoop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationGoop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationGoop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b528b3b68d85f057b0c9bd832ffed0b85e713f01267ea6f9cefea65f21e7964c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationGrayscale",
    jsii_struct_bases=[],
    name_mapping={"type": "type", "type_var": "typeVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationGrayscale:
    def __init__(
        self,
        *,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param type: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c85bbb72d6d1ff155f6cea37fcde1bc4c4de14d25e34030ac98b00fc306dd70a)
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationGrayscale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationGrayscaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationGrayscaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9b0c473867994f7ada9acdd40a02332dea93a2b091e6e5bf7aee3fbefd74da3b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationGrayscaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__13116f6968f893ae41e81de74f15a743e12622b3ade416965b54a3ecc4b3355c)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationGrayscaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__41ceca74bd98da59b80285c6cb04e211fe5fb55d4b9a74b077fcb18d85e32d56)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__66394e48eeadbb1e11ae67b31e048fee7979075b07e067646a691e3f1a4a9def)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9163aa16f7d200d3ef5cb79eef164b116136a5a53ca28f55363e7febbfbc70df)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationGrayscale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationGrayscale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__00b1170464964713051909971026fea7d0173d77031496182512b09e055f24e5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationGrayscaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationGrayscaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cf4a901a2a6c5e755fceb4bb5490ce6e400d8663dbffc6d4b46b1b3157673fa6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__319093f28e68b4a746f4471b7bf01507b9f7445b4483558534aba101e1d19988)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__844348523ce104d29e47f81ca71fdfa46fed7ac73d2e97177751e7ca7b309c2e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationGrayscale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationGrayscale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationGrayscale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cf5133b86145c6d147340dc1c4e57090d2349c80afd0c9ef7893ab744ee959eb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationHsl",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "lightness": "lightness",
        "lightness_var": "lightnessVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationHsl:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness: typing.Optional[builtins.str] = None,
        lightness_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        :param lightness_var: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aca98c624bfc0617294c69acc61c09c97d4db49730bb4a41c15cd7e0709d4a6c)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness", value=lightness, expected_type=type_hints["lightness"])
            check_type(argname="argument lightness_var", value=lightness_var, expected_type=type_hints["lightness_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness is not None:
            self._values["lightness"] = lightness
        if lightness_var is not None:
            self._values["lightness_var"] = lightness_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        '''
        result = self._values.get("lightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        '''
        result = self._values.get("lightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationHsl(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationHslList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationHslList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4bb654feebb203fa950a0f9b055fa20878c72f8af3f3237c061b44bf27026f80)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationHslOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f16224f10fdb3e87881b12d51fb5233a9029ca3e78f51dfcc393770ac157e769)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationHslOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aaecff9b4fad95bf48f91ebbfef1fb3e7eac9aa5c43171b41c8a04f521456f0f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ffa6d7fbd55554fe73d682f70c49426366042defb104f3417e0ddf7cc55e4e69)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a98a5193d0ee227cd0e506cce3f3d5703a78f0161c3da609855101becde1a69b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationHsl]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationHsl]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6eba064a98443bf324383abb4a8459a2a5814ee43800c4ddde25b6e98aaee76e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationHslOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationHslOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0bf8c25e90c326402746919d02d014ff359d40c1177811cd707673b9e3f21d09)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightness")
    def reset_lightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightness", []))

    @jsii.member(jsii_name="resetLightnessVar")
    def reset_lightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessInput")
    def lightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessVarInput")
    def lightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b33e023f5c8d4998eb9defa56bccd1253b73b8e3afa7aa1e3b98a4c73f604580)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0e372907b631fed624a62df14bd00e01dbda8e9c9eab67ac945260cb3d7107b6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightness")
    def lightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightness"))

    @lightness.setter
    def lightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d98fedcef382a3966cd4cf6560c125681dbb31baa6f70e2b0fcf7e185b4c7b30)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightness", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessVar")
    def lightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessVar"))

    @lightness_var.setter
    def lightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ebabefa0b26e8431bb410f572f4de92fafa1aa9fd2192c257a715e865b6336f3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f7e8b703d10f188c5221650b350cdfa8ba19ea7efef313524cfdfc8ba14e5373)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__435043bc3e563022cffdd3136a20ead5e70611e70e8f9f20cc8c2a9d77ad2a81)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationHsl]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationHsl]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationHsl]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8d5f0aef2403787a95681b121f1b7c9203412aedcb1f2431f0da209c93a0ee96)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationHsv",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationHsv:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        :param value: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__40f7974b80f202f24aa302eb500d0b87a6843d0794205419f8e1c021ef61c6b8)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationHsv(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationHsvList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationHsvList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5e70fddc41b8e45149d9749d2d382d38661b813bb13787b8fa16c57f0cd9180d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationHsvOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2b9f706c74a6eb67fefd77e7ff90d6f04a0e36d4a5a89e15cc6af0b62e5ee618)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationHsvOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cae1e7490be3c83287e95d1d7c0f497265352392d0e63a3338a6a3c29edb4949)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e3d0eed7b8f816d4bdd98572a56fb38b4a2be0a54baf3062cabbc2aed61e7521)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9f7802e7f22168329bf3b99b8310961906de8cb1fce4a36b81c9b8062a6b6ec7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationHsv]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationHsv]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__63d0959d455aca090ad54003e0e2516376b1a11a2dfac3c17bd7ad724e67114e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationHsvOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationHsvOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f9c8be0d041a66d4395a37e5016b22fefe2906ca3fb5d64ea3f9be209b978da)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ee6e07b3f435afd172d2d3f87c2f45d092fe91b9b0c782abb4f02f95301e047)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__da309f3ac2727666cfc42aa73db7f88f906fc3126e245818212e96d78de3494a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3c9d9ba755a46a75a878cc803894253f5b3d081ef491a2e62907cf13fb089cd0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d997eed3d29564b7118a39ea876dfa83655a20174e8307810f965b3943dbaa8b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f24dab5d203927ea5dce19a849fd5bbf20584d075634d69f16698c75c96faae6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3c143c56266cbd86ad08a05d69a350d6af1b8d257d46b1fa0ac048e767de0465)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationHsv]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationHsv]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationHsv]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a17331cde8156b64e78d09b3b6679fb8a15c749b6841e4d99e97007cd541580c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfDimension",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "dimension": "dimension",
        "dimension_var": "dimensionVar",
        "equal": "equal",
        "greater_than": "greaterThan",
        "less_than": "lessThan",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfDimension:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfDimensionDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        dimension: typing.Optional[builtins.str] = None,
        dimension_var: typing.Optional[builtins.str] = None,
        equal: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfDimensionEqual", typing.Dict[builtins.str, typing.Any]]] = None,
        greater_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfDimensionGreaterThan", typing.Dict[builtins.str, typing.Any]]] = None,
        less_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfDimensionLessThan", typing.Dict[builtins.str, typing.Any]]] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param dimension: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        :param dimension_var: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        :param equal: equal block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        :param greater_than: greater_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        :param less_than: less_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        :param value: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfDimensionDefault(**default)
        if isinstance(equal, dict):
            equal = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfDimensionEqual(**equal)
        if isinstance(greater_than, dict):
            greater_than = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfDimensionGreaterThan(**greater_than)
        if isinstance(less_than, dict):
            less_than = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfDimensionLessThan(**less_than)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7e3174fb21a8e02cda5fa54c3e632c62d5c78600b7fe714e3beb00e6c7d7dfd9)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument dimension", value=dimension, expected_type=type_hints["dimension"])
            check_type(argname="argument dimension_var", value=dimension_var, expected_type=type_hints["dimension_var"])
            check_type(argname="argument equal", value=equal, expected_type=type_hints["equal"])
            check_type(argname="argument greater_than", value=greater_than, expected_type=type_hints["greater_than"])
            check_type(argname="argument less_than", value=less_than, expected_type=type_hints["less_than"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if dimension is not None:
            self._values["dimension"] = dimension
        if dimension_var is not None:
            self._values["dimension_var"] = dimension_var
        if equal is not None:
            self._values["equal"] = equal
        if greater_than is not None:
            self._values["greater_than"] = greater_than
        if less_than is not None:
            self._values["less_than"] = less_than
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfDimensionDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfDimensionDefault"], result)

    @builtins.property
    def dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        '''
        result = self._values.get("dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        '''
        result = self._values.get("dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def equal(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfDimensionEqual"]:
        '''equal block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        '''
        result = self._values.get("equal")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfDimensionEqual"], result)

    @builtins.property
    def greater_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfDimensionGreaterThan"]:
        '''greater_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        '''
        result = self._values.get("greater_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfDimensionGreaterThan"], result)

    @builtins.property
    def less_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfDimensionLessThan"]:
        '''less_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        '''
        result = self._values.get("less_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfDimensionLessThan"], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfDimension(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfDimensionDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfDimensionDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfDimensionDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfDimensionDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfDimensionDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__80b705021c7163085bb84a6fcbc640e3479dc6e838dfce860d5a0f391c4136e1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfDimensionDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfDimensionDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0721f5718267961fa1a1f24fba441df40b43e7d0a2f20892a6a0eb0be8113fc0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfDimensionEqual",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfDimensionEqual:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfDimensionEqual(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfDimensionEqualOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfDimensionEqualOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f0fc5f11756e73f9ab837c1139f04742943f8070fde3c0b80c69e93a8f9681c6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfDimensionEqual], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfDimensionEqual],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__991e6a6edbdc5758000a87ca29bf624048d84282b3971244fa3526c2a2037466)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfDimensionGreaterThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfDimensionGreaterThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfDimensionGreaterThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfDimensionGreaterThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfDimensionGreaterThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__862b6b74313deb04554b412b10289af8615545586263f3381ec0c3977743d640)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfDimensionGreaterThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfDimensionGreaterThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__19ea4616ec9c763da6e26920a352eadc611b30b5eab2403253877a63942d1cfd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfDimensionLessThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfDimensionLessThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfDimensionLessThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfDimensionLessThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfDimensionLessThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__50f90cb188c2dd6ee53caf0d6b4bcce5c37dabcdde52a1c78239dd4c86e06073)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfDimensionLessThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfDimensionLessThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3df8be85f3c68a715c2bbcf78c5393c1d1706d5661bbfc09a772e3da445d541a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfDimensionList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfDimensionList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d41438438a6bbd8c2620304dcaa61c7aad18f112a9575c246f86e8ccd00f285)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfDimensionOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fe945581d765ebc254f241c63b1b603c0017903876d059d2c75efacffb10393e)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfDimensionOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0961f5739f43ed7b35aeda6aba6c0326f3329bc70fd928e2a841e906e636ae43)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__68decbbb382b0e6eed1ecb8c1fe2716d7512e4bebd2ce1da493867ba2cbd886f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f54bcf03f6263e654b3d8ac2f4b1b0016804afda5ff55a43aa71989b1a753bdb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfDimension]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfDimension]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d2dd511aa2074391166ddc92004f3ea8d3c058a494b06603ef9ff0c209eb6957)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfDimensionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfDimensionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f293728427c42e1e6b9d95689606d3a01e7e1004a9ed51dfc746c468d88809f2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfDimensionDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putEqual")
    def put_equal(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfDimensionEqual()

        return typing.cast(None, jsii.invoke(self, "putEqual", [value]))

    @jsii.member(jsii_name="putGreaterThan")
    def put_greater_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfDimensionGreaterThan()

        return typing.cast(None, jsii.invoke(self, "putGreaterThan", [value]))

    @jsii.member(jsii_name="putLessThan")
    def put_less_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfDimensionLessThan()

        return typing.cast(None, jsii.invoke(self, "putLessThan", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetDimension")
    def reset_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimension", []))

    @jsii.member(jsii_name="resetDimensionVar")
    def reset_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimensionVar", []))

    @jsii.member(jsii_name="resetEqual")
    def reset_equal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEqual", []))

    @jsii.member(jsii_name="resetGreaterThan")
    def reset_greater_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGreaterThan", []))

    @jsii.member(jsii_name="resetLessThan")
    def reset_less_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLessThan", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfDimensionDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfDimensionDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="equal")
    def equal(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfDimensionEqualOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfDimensionEqualOutputReference, jsii.get(self, "equal"))

    @builtins.property
    @jsii.member(jsii_name="greaterThan")
    def greater_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfDimensionGreaterThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfDimensionGreaterThanOutputReference, jsii.get(self, "greaterThan"))

    @builtins.property
    @jsii.member(jsii_name="lessThan")
    def less_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfDimensionLessThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfDimensionLessThanOutputReference, jsii.get(self, "lessThan"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfDimensionDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionInput")
    def dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionVarInput")
    def dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="equalInput")
    def equal_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfDimensionEqual], jsii.get(self, "equalInput"))

    @builtins.property
    @jsii.member(jsii_name="greaterThanInput")
    def greater_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfDimensionGreaterThan], jsii.get(self, "greaterThanInput"))

    @builtins.property
    @jsii.member(jsii_name="lessThanInput")
    def less_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfDimensionLessThan], jsii.get(self, "lessThanInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="dimension")
    def dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimension"))

    @dimension.setter
    def dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__da64ee0093e9aa30897984a04d3a996dae10f8ab29a4f047d3e7b9dedef58d72)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimension", value)

    @builtins.property
    @jsii.member(jsii_name="dimensionVar")
    def dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimensionVar"))

    @dimension_var.setter
    def dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f9fb9fdd9c9ad80614b089272b5b090b8925e6430598b201009be8a018588189)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__84e514da8dabd2b9b4b1cf938c7af5b4996bcff64a801702195174867e379729)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__76a6c52a211e7797ea444bcf711e28cc9cbe9c494f498a5f9b243c91796db02c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfDimension]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfDimension]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfDimension]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9546b132df504e3c0d90cdb72612db4b43e36a57a638fd75980d4a09e703eadd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfOrientation",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "landscape": "landscape",
        "portrait": "portrait",
        "square": "square",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfOrientation:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfOrientationDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        landscape: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfOrientationLandscape", typing.Dict[builtins.str, typing.Any]]] = None,
        portrait: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfOrientationPortrait", typing.Dict[builtins.str, typing.Any]]] = None,
        square: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfOrientationSquare", typing.Dict[builtins.str, typing.Any]]] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param landscape: landscape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        :param portrait: portrait block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        :param square: square block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfOrientationDefault(**default)
        if isinstance(landscape, dict):
            landscape = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfOrientationLandscape(**landscape)
        if isinstance(portrait, dict):
            portrait = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfOrientationPortrait(**portrait)
        if isinstance(square, dict):
            square = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfOrientationSquare(**square)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7c81f7b6a81444d9a66745463094656582c3d119f2078e40c04d0c2638e507ba)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument landscape", value=landscape, expected_type=type_hints["landscape"])
            check_type(argname="argument portrait", value=portrait, expected_type=type_hints["portrait"])
            check_type(argname="argument square", value=square, expected_type=type_hints["square"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if landscape is not None:
            self._values["landscape"] = landscape
        if portrait is not None:
            self._values["portrait"] = portrait
        if square is not None:
            self._values["square"] = square

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfOrientationDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfOrientationDefault"], result)

    @builtins.property
    def landscape(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfOrientationLandscape"]:
        '''landscape block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        '''
        result = self._values.get("landscape")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfOrientationLandscape"], result)

    @builtins.property
    def portrait(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfOrientationPortrait"]:
        '''portrait block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        '''
        result = self._values.get("portrait")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfOrientationPortrait"], result)

    @builtins.property
    def square(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfOrientationSquare"]:
        '''square block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        result = self._values.get("square")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfOrientationSquare"], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfOrientation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfOrientationDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfOrientationDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfOrientationDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfOrientationDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfOrientationDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c699f6c7c754589debfb6cf4ab1166087841758f2f6bdb19ab9e75db4d7d4a82)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfOrientationDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfOrientationDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ad6caa1d80f7430c779e910ba38ee81b5de9eb7961fe23a80b5feb0890eacf5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfOrientationLandscape",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfOrientationLandscape:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfOrientationLandscape(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfOrientationLandscapeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfOrientationLandscapeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__69eab947e8d607b9622ca2691323b1954815b794bdd579497f6790fdeabc8a4d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfOrientationLandscape], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfOrientationLandscape],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__01ab7009548f9238d6a19ac8bb12b1217461a5990584e4ee0120bc583ec702d2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfOrientationList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfOrientationList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a690c3e9cfa1ec7fb2ec324da0ce2b907b1cccf6158b4d58d7ff1bc2e5a9adbf)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfOrientationOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5a565b1c2850c46c8077bff52a1d5eddd166f9e82aad65061a4b89810bc66c4e)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfOrientationOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f5cea23542a4af085a112c13acebc03389fd6d1f20139a7b309dec070e873672)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a37787e539b7ad4fefce15e279c3e20975194c56bf6f307f774d5efab6f3c3e6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__40a9cc90548661730e1977642678dceee1ee65ff31b63874a9a1089f274eb907)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfOrientation]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfOrientation]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ff9b596e77ed26d8fa9465effea91500cd97fc147bd09a7dae6c876b371d95fc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfOrientationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfOrientationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cb08a8462f00181977184a3d6ec6cdc30e86d9a59f07c2e1b7f1ca215f45386c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfOrientationDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putLandscape")
    def put_landscape(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfOrientationLandscape()

        return typing.cast(None, jsii.invoke(self, "putLandscape", [value]))

    @jsii.member(jsii_name="putPortrait")
    def put_portrait(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfOrientationPortrait()

        return typing.cast(None, jsii.invoke(self, "putPortrait", [value]))

    @jsii.member(jsii_name="putSquare")
    def put_square(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfOrientationSquare()

        return typing.cast(None, jsii.invoke(self, "putSquare", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetLandscape")
    def reset_landscape(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLandscape", []))

    @jsii.member(jsii_name="resetPortrait")
    def reset_portrait(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPortrait", []))

    @jsii.member(jsii_name="resetSquare")
    def reset_square(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSquare", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfOrientationDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfOrientationDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="landscape")
    def landscape(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfOrientationLandscapeOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfOrientationLandscapeOutputReference, jsii.get(self, "landscape"))

    @builtins.property
    @jsii.member(jsii_name="portrait")
    def portrait(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfOrientationPortraitOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfOrientationPortraitOutputReference", jsii.get(self, "portrait"))

    @builtins.property
    @jsii.member(jsii_name="square")
    def square(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfOrientationSquareOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfOrientationSquareOutputReference", jsii.get(self, "square"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfOrientationDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="landscapeInput")
    def landscape_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfOrientationLandscape], jsii.get(self, "landscapeInput"))

    @builtins.property
    @jsii.member(jsii_name="portraitInput")
    def portrait_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfOrientationPortrait"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfOrientationPortrait"], jsii.get(self, "portraitInput"))

    @builtins.property
    @jsii.member(jsii_name="squareInput")
    def square_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfOrientationSquare"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfOrientationSquare"], jsii.get(self, "squareInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfOrientation]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfOrientation]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfOrientation]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c1f3d120e11b8282b840d2481a10b2de32163d994de5ad58db06f9674b95fe92)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfOrientationPortrait",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfOrientationPortrait:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfOrientationPortrait(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfOrientationPortraitOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfOrientationPortraitOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d84dda43d1e7d202356afd014edafd2bff8909f1999385cdfaaa313603fdc9f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfOrientationPortrait]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfOrientationPortrait], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfOrientationPortrait],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d4ef5525526d5103e4986bb0777e8862a189ad20fd681dbd9dda8f80735a62da)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfOrientationSquare",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfOrientationSquare:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfOrientationSquare(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfOrientationSquareOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfOrientationSquareOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__906d62cb3f9bf9f8bd1a37a92ceda8d1b28cd92e02674b6aad975f510b0193b4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfOrientationSquare]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfOrientationSquare], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfOrientationSquare],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1e8ea5a9d7a0fb3a931af5f7a7299fd507bfab5e4b06e5664ab4a353f88ae8ca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationImQuery",
    jsii_struct_bases=[],
    name_mapping={
        "allowed_transformations": "allowedTransformations",
        "query_var": "queryVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationImQuery:
    def __init__(
        self,
        *,
        allowed_transformations: typing.Sequence[builtins.str],
        query_var: builtins.str,
    ) -> None:
        '''
        :param allowed_transformations: Specifies the transformations that can be applied using the query string parameter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allowed_transformations DataAkamaiImagingPolicyImage#allowed_transformations}
        :param query_var: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#query_var DataAkamaiImagingPolicyImage#query_var}.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2e9aacf005b63a6a1bed65f8538a66a92dd131f4c2fcdd8222f478ba2da15992)
            check_type(argname="argument allowed_transformations", value=allowed_transformations, expected_type=type_hints["allowed_transformations"])
            check_type(argname="argument query_var", value=query_var, expected_type=type_hints["query_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "allowed_transformations": allowed_transformations,
            "query_var": query_var,
        }

    @builtins.property
    def allowed_transformations(self) -> typing.List[builtins.str]:
        '''Specifies the transformations that can be applied using the query string parameter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allowed_transformations DataAkamaiImagingPolicyImage#allowed_transformations}
        '''
        result = self._values.get("allowed_transformations")
        assert result is not None, "Required property 'allowed_transformations' is missing"
        return typing.cast(typing.List[builtins.str], result)

    @builtins.property
    def query_var(self) -> builtins.str:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#query_var DataAkamaiImagingPolicyImage#query_var}.'''
        result = self._values.get("query_var")
        assert result is not None, "Required property 'query_var' is missing"
        return typing.cast(builtins.str, result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationImQuery(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationImQueryList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationImQueryList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f8e0ca5ae3f98ab2ff385302f6b0d652233f60da38e0ab620b221463e211222)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationImQueryOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b4695ade7c92d2a1cf887fd36595ea5ead351ef70e68ca3f1097d3a6ef240ecb)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationImQueryOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d7a70b4aa4544e4fe432d8a2011d972caa73b850696c9b77180feee0e1e2de44)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__986bf154522a94485dfa81b5106caeca55fb3c50ffe610768b20908bb0d301dc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__54817498f8a950ace791960dc0df7afcc829f0209a24b34d4fc9cfa42adea089)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationImQuery]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationImQuery]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationImQuery]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6b889cb1ee75eb5e7a4bc114179928150e303404a981900a9f8936a17b5517d8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationImQueryOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationImQueryOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6a3629a006628c9abd7cada9f8adea54f037cd72abcc6ac8865c73509fc6e5ad)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @builtins.property
    @jsii.member(jsii_name="allowedTransformationsInput")
    def allowed_transformations_input(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "allowedTransformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="queryVarInput")
    def query_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "queryVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowedTransformations")
    def allowed_transformations(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "allowedTransformations"))

    @allowed_transformations.setter
    def allowed_transformations(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__824f6a8f2f797c2159d70aa43f54402591249685239748ac657de5878140f69b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowedTransformations", value)

    @builtins.property
    @jsii.member(jsii_name="queryVar")
    def query_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "queryVar"))

    @query_var.setter
    def query_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__379feb4479304272ceed2ae8f2ae06fc916d8cdd103af67ac035d76b57b5335d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "queryVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationImQuery]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationImQuery]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationImQuery]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1da03ee9cb4bbb13ce2870fb224a7e072f85721c10b4ab53e78286277b22ee4d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationMaxColors",
    jsii_struct_bases=[],
    name_mapping={"colors": "colors", "colors_var": "colorsVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationMaxColors:
    def __init__(
        self,
        *,
        colors: typing.Optional[builtins.str] = None,
        colors_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param colors: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        :param colors_var: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__118c1e33d93bd086ea6f5f70aea5419639a528d84c82b67f48e7f99d31b62d92)
            check_type(argname="argument colors", value=colors, expected_type=type_hints["colors"])
            check_type(argname="argument colors_var", value=colors_var, expected_type=type_hints["colors_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if colors is not None:
            self._values["colors"] = colors
        if colors_var is not None:
            self._values["colors_var"] = colors_var

    @builtins.property
    def colors(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        '''
        result = self._values.get("colors")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def colors_var(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        result = self._values.get("colors_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationMaxColors(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationMaxColorsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationMaxColorsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b6865fb1b94b416abf676e7127c699b5ff1599b0d64bf2ebbf2e901e8d56376b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationMaxColorsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d607b2ca29cd8bb7322ff7384beb2f43f3ef750548e2177c2160e6a90adecd2d)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationMaxColorsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1b218e13170839a99e7ef0cc42ec1abc2dcaa45cad44ae82fad123ed788457e2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2414905a8783efe7e284f2e737479c344ad442bf571d545ead07649b34702729)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__16e9d572a94dfa1ea3e9e9524239a6fb11522d6f9795f9c7b0781dd97b2cb6ee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationMaxColors]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationMaxColors]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c8da15c2824ab0c418abd213e681aa0b96294d613398921003ceb7e7af7f56e1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationMaxColorsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationMaxColorsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d3db9ffe28e73f7626922dd098c692066fc35a102e5e3754dc486d2a02fa5244)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColors")
    def reset_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColors", []))

    @jsii.member(jsii_name="resetColorsVar")
    def reset_colors_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorsVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorsInput")
    def colors_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsInput"))

    @builtins.property
    @jsii.member(jsii_name="colorsVarInput")
    def colors_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsVarInput"))

    @builtins.property
    @jsii.member(jsii_name="colors")
    def colors(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colors"))

    @colors.setter
    def colors(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e857abf5809eb1ed2a8551f520deabfeed53a480c2981fd6e8507aed9e04f7d1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colors", value)

    @builtins.property
    @jsii.member(jsii_name="colorsVar")
    def colors_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorsVar"))

    @colors_var.setter
    def colors_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cbdbe7cb52c9a4a95e035b1f8d9e72911d871b13cb851b38c6fc3a887450cc3f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorsVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationMaxColors]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationMaxColors]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationMaxColors]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2f4c4c9bf46b41b362f7df1a83f59f83b62f23cfd9c659ce5ed56a0f8e106f8b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationMirror",
    jsii_struct_bases=[],
    name_mapping={
        "horizontal": "horizontal",
        "horizontal_var": "horizontalVar",
        "vertical": "vertical",
        "vertical_var": "verticalVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationMirror:
    def __init__(
        self,
        *,
        horizontal: typing.Optional[builtins.str] = None,
        horizontal_var: typing.Optional[builtins.str] = None,
        vertical: typing.Optional[builtins.str] = None,
        vertical_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param horizontal: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        :param horizontal_var: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        :param vertical: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        :param vertical_var: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f022519ae1f520c1300979d93483da801f172a5324b3f87768873d41627b2bac)
            check_type(argname="argument horizontal", value=horizontal, expected_type=type_hints["horizontal"])
            check_type(argname="argument horizontal_var", value=horizontal_var, expected_type=type_hints["horizontal_var"])
            check_type(argname="argument vertical", value=vertical, expected_type=type_hints["vertical"])
            check_type(argname="argument vertical_var", value=vertical_var, expected_type=type_hints["vertical_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if horizontal is not None:
            self._values["horizontal"] = horizontal
        if horizontal_var is not None:
            self._values["horizontal_var"] = horizontal_var
        if vertical is not None:
            self._values["vertical"] = vertical
        if vertical_var is not None:
            self._values["vertical_var"] = vertical_var

    @builtins.property
    def horizontal(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        '''
        result = self._values.get("horizontal")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def horizontal_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        '''
        result = self._values.get("horizontal_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        '''
        result = self._values.get("vertical")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        result = self._values.get("vertical_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationMirror(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationMirrorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationMirrorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e021d978bdabf42438413ee628b1593dd343325466e45c89af914aea6ba88d30)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationMirrorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__61f9f0514673f5f6e035f149ca36ec8d589ac18cd7b1016f9689057436ac1b2b)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationMirrorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__41d44e27359c343c9e611c6b267bf0e8ea798c13010ec1687c4457124bd40a44)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aa95a0a80783d9457bcbe5408e28ebe1dfeccfec0c58f02f9d67a0e74a17decd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b2e9a5a0951f1699493550a1c898e8dd7b6a7863dcd8f29460bbcafc25ba51e2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationMirror]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationMirror]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2150808405a88fee136182f260c8cd21e923a9375f724e177c1c6281d7136067)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationMirrorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationMirrorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6bbe2960b598163caa2836c55637052a8f445c1025c3aa723b52866ae4a64921)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHorizontal")
    def reset_horizontal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontal", []))

    @jsii.member(jsii_name="resetHorizontalVar")
    def reset_horizontal_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontalVar", []))

    @jsii.member(jsii_name="resetVertical")
    def reset_vertical(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVertical", []))

    @jsii.member(jsii_name="resetVerticalVar")
    def reset_vertical_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVerticalVar", []))

    @builtins.property
    @jsii.member(jsii_name="horizontalInput")
    def horizontal_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontalVarInput")
    def horizontal_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalInput")
    def vertical_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalVarInput")
    def vertical_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontal")
    def horizontal(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontal"))

    @horizontal.setter
    def horizontal(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__46e483005e6fc24a58f4c680cda02091654329d9a065ae9b66f25090ea2509b3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontal", value)

    @builtins.property
    @jsii.member(jsii_name="horizontalVar")
    def horizontal_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontalVar"))

    @horizontal_var.setter
    def horizontal_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4b11e5f28577c37de40cfbacdde89b1034b92c870e5d532181a318ba8bbb98c5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontalVar", value)

    @builtins.property
    @jsii.member(jsii_name="vertical")
    def vertical(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "vertical"))

    @vertical.setter
    def vertical(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__07aaf958eb0a25aa604295bbdec71a10bf4d834d7be926939b4f47c069258cb5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "vertical", value)

    @builtins.property
    @jsii.member(jsii_name="verticalVar")
    def vertical_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "verticalVar"))

    @vertical_var.setter
    def vertical_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9eb0e712d611084daf5535c54765789befe58e4767b3b9847624336dc700e1f8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "verticalVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationMirror]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationMirror]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationMirror]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__98999a9be638ba901d265dcce9c4bc0b3a446bac5be849fc03e2f2911cfe061d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationMonoHue",
    jsii_struct_bases=[],
    name_mapping={"hue": "hue", "hue_var": "hueVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationMonoHue:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__02dd6024d928106c327f37cafab60a17394a420db08f7ffce12c0469510357a7)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationMonoHue(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationMonoHueList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationMonoHueList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e88e35a2c8bcf342f1c934f417491a5d0408a81fa3e309c7182f27354f360939)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationMonoHueOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e451868881002dc0e417a3a8ffb44e6867606894c1e62ea74134ffed500453a2)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationMonoHueOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__073e5625077373a6d25563ec36380a8b8dc3fdc3fc2d45ebda3b827bcd05e92f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__50f248b42cb47fa89825c6aa8ddf6bf6b7562a511d64bc64534d7a61171e259e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d2a66268adb64b4d857ac8993fd94e5645e5ea642c02028f763fc74ac44a54fc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationMonoHue]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationMonoHue]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ddcdb4c2426deaef7550a916ffe010015d388c51d0681442176b9b9cd8146030)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationMonoHueOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationMonoHueOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f9161397e146efaf2fa0624f9c19b87f83bf950cc54a0d0ee38c9f76020217bc)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4f646ae152d474fcd466f93fc1ead91e44361948c9630cea54f7a17ff926a7a2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__deaad98568acf2882b508db00a07a9edff4261bb1850a541f2213a4d4f7bfaba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationMonoHue]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationMonoHue]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationMonoHue]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__79c360d29cbc677f7e759281614c60590aed7f399e729d440f72b0e91022390e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationOpacity",
    jsii_struct_bases=[],
    name_mapping={"opacity": "opacity", "opacity_var": "opacityVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationOpacity:
    def __init__(
        self,
        *,
        opacity: typing.Optional[builtins.str] = None,
        opacity_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param opacity: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param opacity_var: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6961f2200be57ad661d7332e67af87c1d64ec46a96b292cd5c5a9a058b84cfe1)
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument opacity_var", value=opacity_var, expected_type=type_hints["opacity_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if opacity is not None:
            self._values["opacity"] = opacity
        if opacity_var is not None:
            self._values["opacity_var"] = opacity_var

    @builtins.property
    def opacity(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def opacity_var(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        result = self._values.get("opacity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationOpacity(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationOpacityList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationOpacityList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__face8192a1aa933f9c3f708e1f7b778cc0d898648368aabbd0ee6289bcff63d4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationOpacityOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__55dc88bb41b7835e49cbfb1b7d2628e4929bbb138fcf6a223d2942094b583c4d)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationOpacityOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa603b19de70ff3637a8d109c517e7152da6c1f6be264bd9bfc33c36a39a898a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__568f90506e39fe0e10198a8f4bcb87016727c4458cc8fe9da3be331ba94d2603)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c97dab4cb2ef23f0af7e3af323910b1f0fd59906ac64d118e3efff4f295e1699)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationOpacity]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationOpacity]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9fe4babf353762f9c309fefe33b58cc252904743c7fd000b1b2678c83dccd7f2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationOpacityOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationOpacityOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0d6a95043010da8b209ddddd0118a9da89ce40e88c5853ee5b8d41e8faaf13bd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetOpacityVar")
    def reset_opacity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacityVar", []))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityVarInput")
    def opacity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacity"))

    @opacity.setter
    def opacity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__336c18584d52c53389f156a3a405083bb84ab750278e6beaee065df4811743d5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacity", value)

    @builtins.property
    @jsii.member(jsii_name="opacityVar")
    def opacity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacityVar"))

    @opacity_var.setter
    def opacity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9b5e6dee758c087d4abafef9678f13c5444764e3ed3945cf9c29b05cd65b3922)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacityVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationOpacity]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationOpacity]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationOpacity]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__83c088989e2b91110c74b35cea2650a54641c3e5343362bdf146f1e53bbee22b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d5ca16486ae4f8312bbefbab725a0e95d2ac5b80d283c636b9567f91f7ea4da8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putAppend")
    def put_append(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationAppend, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__48717d06d14071e5588a2faff21c9ef295ca3d7e8babcb2eabab3b3481dd97d1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putAppend", [value]))

    @jsii.member(jsii_name="putAspectCrop")
    def put_aspect_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationAspectCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0c7efc73beb2516b4908e41d97389c74eec7f76549384357ec44c2c156289070)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putAspectCrop", [value]))

    @jsii.member(jsii_name="putBackgroundColor")
    def put_background_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__17dbe4b748e52e5a66e03aa2c06cb34120589881a9374613ae1af382f43ea7a5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBackgroundColor", [value]))

    @jsii.member(jsii_name="putBlur")
    def put_blur(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationBlur, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fce2cba7569b626e31e6a186e0677043df4f59613145480b7c61406c31de5b29)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBlur", [value]))

    @jsii.member(jsii_name="putChromaKey")
    def put_chroma_key(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationChromaKey, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd0e0473a8f61a79ae8901674692f821d8e8d7dad4d1fb9f67ee1c5d5dcae279)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putChromaKey", [value]))

    @jsii.member(jsii_name="putComposite")
    def put_composite(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationComposite, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8337d745e21a44d4dc66bd743780db40ecb04705640848395c08ae88d5d58c5e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putComposite", [value]))

    @jsii.member(jsii_name="putCompound")
    def put_compound(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationCompound, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d17bdb7d7b8bde77e5cadb145e62d7af9ca9cfdf01810db12ecdda57d9f702ea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCompound", [value]))

    @jsii.member(jsii_name="putContrast")
    def put_contrast(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationContrast, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3d9593bbcd2efc252700a4b41fc35e1712a2c7dadace7048a8f148a0f53a00e2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putContrast", [value]))

    @jsii.member(jsii_name="putCrop")
    def put_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ebe0c5ba27ba1151c07fbdbc0f46dc68b4fd3d34bc12dca3d2bf3531ec0b206)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCrop", [value]))

    @jsii.member(jsii_name="putFaceCrop")
    def put_face_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationFaceCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cf2040d801a97de9b1b08a9b0739af2454f687ae4ac1c2188dcd1f3fd472e746)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFaceCrop", [value]))

    @jsii.member(jsii_name="putFeatureCrop")
    def put_feature_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationFeatureCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__34e3c6cc9bb55069ced84f60854fc2002c8089b9080da5a57c482510f97adede)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFeatureCrop", [value]))

    @jsii.member(jsii_name="putFitAndFill")
    def put_fit_and_fill(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationFitAndFill, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a8ba27cea199b3c325cc0b994121ea9bfbc2e03db168167b775468cd256f55f4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFitAndFill", [value]))

    @jsii.member(jsii_name="putGoop")
    def put_goop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationGoop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f3c842d39487e73330f8b14b1e9ca06e851deb687b67b13d6e6a34df3328e9ee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGoop", [value]))

    @jsii.member(jsii_name="putGrayscale")
    def put_grayscale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationGrayscale, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4f5d4458923042f93c859ba661b6603626346779e35da0febe24f36ec494fd4d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGrayscale", [value]))

    @jsii.member(jsii_name="putHsl")
    def put_hsl(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationHsl, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7c6b62286b93b5bd442b5d78370efb187050a522b2f81942c24f9a7a97b486bb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsl", [value]))

    @jsii.member(jsii_name="putHsv")
    def put_hsv(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationHsv, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__22f91ccc6c75c73aa4c704812465ed1c3db88a0604dd698c47ed246fff57466e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsv", [value]))

    @jsii.member(jsii_name="putIfDimension")
    def put_if_dimension(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfDimension, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2f025beaebf441d37ecac62ca8989105652134bb6d185f1d177074b7d7cdec65)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfDimension", [value]))

    @jsii.member(jsii_name="putIfOrientation")
    def put_if_orientation(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4c2cff388adda7bdba9e248d3ca966625eac3dff6d48c57257e1eacbaa8db96b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfOrientation", [value]))

    @jsii.member(jsii_name="putImQuery")
    def put_im_query(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationImQuery, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__42a03bcba1bb494974bd31bf337fb393de9327c509376d6258e68fe4dd094881)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putImQuery", [value]))

    @jsii.member(jsii_name="putMaxColors")
    def put_max_colors(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationMaxColors, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__93df7fa42bc5efc94dcb3cab6cb406c9d3cdd7a707fbf48950a6faad038d44c1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMaxColors", [value]))

    @jsii.member(jsii_name="putMirror")
    def put_mirror(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationMirror, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__999d1a2b3fd238b761d83f8e873b773507f5509463ca07322b21aa2e495e3ac8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMirror", [value]))

    @jsii.member(jsii_name="putMonoHue")
    def put_mono_hue(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationMonoHue, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bdc412d0f425c2e22ed63190811ce0b8b8201e43618d44f08fb84206c0c418b3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMonoHue", [value]))

    @jsii.member(jsii_name="putOpacity")
    def put_opacity(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationOpacity, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5fbde86b1814ce533f8db2ae0ae07410e4eeb7c5a4b75ff3fda0980466585f16)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putOpacity", [value]))

    @jsii.member(jsii_name="putRegionOfInterestCrop")
    def put_region_of_interest_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationRegionOfInterestCrop", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__828320ed854d0583c6e3ffb9b9de8970b10dec96a31094d57aaf12990e0779a4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRegionOfInterestCrop", [value]))

    @jsii.member(jsii_name="putRelativeCrop")
    def put_relative_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationRelativeCrop", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b09716bbb946036fe5280ade2947492317a8cd9c623a1cc0e05f9b6d0e42aaa3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRelativeCrop", [value]))

    @jsii.member(jsii_name="putRemoveColor")
    def put_remove_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationRemoveColor", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dfe3468316191521c823ac181865759e0b74e7daef54af89b3befe27b20bf410)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRemoveColor", [value]))

    @jsii.member(jsii_name="putResize")
    def put_resize(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationResize", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fe9a7c50c3e283207b1646043af65577d9793aea95c137cc9785d0f378b58c11)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putResize", [value]))

    @jsii.member(jsii_name="putRotate")
    def put_rotate(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationRotate", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__de5654d25554d1a2d93853b378392eaa3b0a0669ceb0c7001018661515578f74)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRotate", [value]))

    @jsii.member(jsii_name="putScale")
    def put_scale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationScale", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__639c8d881a9f1e73a92bd97558bc83964f2297a2b39cd6bd1be51619f7016352)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putScale", [value]))

    @jsii.member(jsii_name="putShear")
    def put_shear(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationShear", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__520a435e62d389630fd290140362c006cd240513af932f3621799b9358d2c5ec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putShear", [value]))

    @jsii.member(jsii_name="putTrim")
    def put_trim(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationTrim", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d9ddd145036a0af91ed11da4b4dfba0cd7221fa3bce98c79ef069e97a4454f74)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTrim", [value]))

    @jsii.member(jsii_name="putUnsharpMask")
    def put_unsharp_mask(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationUnsharpMask", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f12e619fa5c948befc3cc12b0171bb3eecaa2e95cccba87c94301fbc5b5edc9f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putUnsharpMask", [value]))

    @jsii.member(jsii_name="resetAppend")
    def reset_append(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAppend", []))

    @jsii.member(jsii_name="resetAspectCrop")
    def reset_aspect_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspectCrop", []))

    @jsii.member(jsii_name="resetBackgroundColor")
    def reset_background_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBackgroundColor", []))

    @jsii.member(jsii_name="resetBlur")
    def reset_blur(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBlur", []))

    @jsii.member(jsii_name="resetChromaKey")
    def reset_chroma_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChromaKey", []))

    @jsii.member(jsii_name="resetComposite")
    def reset_composite(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetComposite", []))

    @jsii.member(jsii_name="resetCompound")
    def reset_compound(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCompound", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetCrop")
    def reset_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCrop", []))

    @jsii.member(jsii_name="resetFaceCrop")
    def reset_face_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFaceCrop", []))

    @jsii.member(jsii_name="resetFeatureCrop")
    def reset_feature_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureCrop", []))

    @jsii.member(jsii_name="resetFitAndFill")
    def reset_fit_and_fill(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFitAndFill", []))

    @jsii.member(jsii_name="resetGoop")
    def reset_goop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGoop", []))

    @jsii.member(jsii_name="resetGrayscale")
    def reset_grayscale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGrayscale", []))

    @jsii.member(jsii_name="resetHsl")
    def reset_hsl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsl", []))

    @jsii.member(jsii_name="resetHsv")
    def reset_hsv(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsv", []))

    @jsii.member(jsii_name="resetIfDimension")
    def reset_if_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfDimension", []))

    @jsii.member(jsii_name="resetIfOrientation")
    def reset_if_orientation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfOrientation", []))

    @jsii.member(jsii_name="resetImQuery")
    def reset_im_query(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetImQuery", []))

    @jsii.member(jsii_name="resetMaxColors")
    def reset_max_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxColors", []))

    @jsii.member(jsii_name="resetMirror")
    def reset_mirror(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMirror", []))

    @jsii.member(jsii_name="resetMonoHue")
    def reset_mono_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonoHue", []))

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetRegionOfInterestCrop")
    def reset_region_of_interest_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRegionOfInterestCrop", []))

    @jsii.member(jsii_name="resetRelativeCrop")
    def reset_relative_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRelativeCrop", []))

    @jsii.member(jsii_name="resetRemoveColor")
    def reset_remove_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRemoveColor", []))

    @jsii.member(jsii_name="resetResize")
    def reset_resize(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetResize", []))

    @jsii.member(jsii_name="resetRotate")
    def reset_rotate(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRotate", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetShear")
    def reset_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetShear", []))

    @jsii.member(jsii_name="resetTrim")
    def reset_trim(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTrim", []))

    @jsii.member(jsii_name="resetUnsharpMask")
    def reset_unsharp_mask(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUnsharpMask", []))

    @builtins.property
    @jsii.member(jsii_name="append")
    def append(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationAppendList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationAppendList, jsii.get(self, "append"))

    @builtins.property
    @jsii.member(jsii_name="aspectCrop")
    def aspect_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationAspectCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationAspectCropList, jsii.get(self, "aspectCrop"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColor")
    def background_color(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationBackgroundColorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationBackgroundColorList, jsii.get(self, "backgroundColor"))

    @builtins.property
    @jsii.member(jsii_name="blur")
    def blur(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationBlurList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationBlurList, jsii.get(self, "blur"))

    @builtins.property
    @jsii.member(jsii_name="chromaKey")
    def chroma_key(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationChromaKeyList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationChromaKeyList, jsii.get(self, "chromaKey"))

    @builtins.property
    @jsii.member(jsii_name="composite")
    def composite(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationCompositeList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationCompositeList, jsii.get(self, "composite"))

    @builtins.property
    @jsii.member(jsii_name="compound")
    def compound(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationCompoundList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationCompoundList, jsii.get(self, "compound"))

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationContrastList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationContrastList, jsii.get(self, "contrast"))

    @builtins.property
    @jsii.member(jsii_name="crop")
    def crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationCropList, jsii.get(self, "crop"))

    @builtins.property
    @jsii.member(jsii_name="faceCrop")
    def face_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationFaceCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationFaceCropList, jsii.get(self, "faceCrop"))

    @builtins.property
    @jsii.member(jsii_name="featureCrop")
    def feature_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationFeatureCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationFeatureCropList, jsii.get(self, "featureCrop"))

    @builtins.property
    @jsii.member(jsii_name="fitAndFill")
    def fit_and_fill(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationFitAndFillList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationFitAndFillList, jsii.get(self, "fitAndFill"))

    @builtins.property
    @jsii.member(jsii_name="goop")
    def goop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationGoopList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationGoopList, jsii.get(self, "goop"))

    @builtins.property
    @jsii.member(jsii_name="grayscale")
    def grayscale(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationGrayscaleList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationGrayscaleList, jsii.get(self, "grayscale"))

    @builtins.property
    @jsii.member(jsii_name="hsl")
    def hsl(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationHslList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationHslList, jsii.get(self, "hsl"))

    @builtins.property
    @jsii.member(jsii_name="hsv")
    def hsv(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationHsvList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationHsvList, jsii.get(self, "hsv"))

    @builtins.property
    @jsii.member(jsii_name="ifDimension")
    def if_dimension(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfDimensionList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfDimensionList, jsii.get(self, "ifDimension"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientation")
    def if_orientation(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfOrientationList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfOrientationList, jsii.get(self, "ifOrientation"))

    @builtins.property
    @jsii.member(jsii_name="imQuery")
    def im_query(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationImQueryList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationImQueryList, jsii.get(self, "imQuery"))

    @builtins.property
    @jsii.member(jsii_name="maxColors")
    def max_colors(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationMaxColorsList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationMaxColorsList, jsii.get(self, "maxColors"))

    @builtins.property
    @jsii.member(jsii_name="mirror")
    def mirror(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationMirrorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationMirrorList, jsii.get(self, "mirror"))

    @builtins.property
    @jsii.member(jsii_name="monoHue")
    def mono_hue(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationMonoHueList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationMonoHueList, jsii.get(self, "monoHue"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationOpacityList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationOpacityList, jsii.get(self, "opacity"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestCrop")
    def region_of_interest_crop(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationRegionOfInterestCropList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationRegionOfInterestCropList", jsii.get(self, "regionOfInterestCrop"))

    @builtins.property
    @jsii.member(jsii_name="relativeCrop")
    def relative_crop(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationRelativeCropList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationRelativeCropList", jsii.get(self, "relativeCrop"))

    @builtins.property
    @jsii.member(jsii_name="removeColor")
    def remove_color(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationRemoveColorList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationRemoveColorList", jsii.get(self, "removeColor"))

    @builtins.property
    @jsii.member(jsii_name="resize")
    def resize(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationResizeList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationResizeList", jsii.get(self, "resize"))

    @builtins.property
    @jsii.member(jsii_name="rotate")
    def rotate(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationRotateList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationRotateList", jsii.get(self, "rotate"))

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationScaleList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationScaleList", jsii.get(self, "scale"))

    @builtins.property
    @jsii.member(jsii_name="shear")
    def shear(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationShearList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationShearList", jsii.get(self, "shear"))

    @builtins.property
    @jsii.member(jsii_name="trim")
    def trim(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationTrimList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationTrimList", jsii.get(self, "trim"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMask")
    def unsharp_mask(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationUnsharpMaskList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationUnsharpMaskList", jsii.get(self, "unsharpMask"))

    @builtins.property
    @jsii.member(jsii_name="appendInput")
    def append_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationAppend]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationAppend]]], jsii.get(self, "appendInput"))

    @builtins.property
    @jsii.member(jsii_name="aspectCropInput")
    def aspect_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationAspectCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationAspectCrop]]], jsii.get(self, "aspectCropInput"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColorInput")
    def background_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationBackgroundColor]]], jsii.get(self, "backgroundColorInput"))

    @builtins.property
    @jsii.member(jsii_name="blurInput")
    def blur_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationBlur]]], jsii.get(self, "blurInput"))

    @builtins.property
    @jsii.member(jsii_name="chromaKeyInput")
    def chroma_key_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationChromaKey]]], jsii.get(self, "chromaKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="compositeInput")
    def composite_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationComposite]]], jsii.get(self, "compositeInput"))

    @builtins.property
    @jsii.member(jsii_name="compoundInput")
    def compound_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationCompound]]], jsii.get(self, "compoundInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationContrast]]], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="cropInput")
    def crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationCrop]]], jsii.get(self, "cropInput"))

    @builtins.property
    @jsii.member(jsii_name="faceCropInput")
    def face_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationFaceCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationFaceCrop]]], jsii.get(self, "faceCropInput"))

    @builtins.property
    @jsii.member(jsii_name="featureCropInput")
    def feature_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationFeatureCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationFeatureCrop]]], jsii.get(self, "featureCropInput"))

    @builtins.property
    @jsii.member(jsii_name="fitAndFillInput")
    def fit_and_fill_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationFitAndFill]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationFitAndFill]]], jsii.get(self, "fitAndFillInput"))

    @builtins.property
    @jsii.member(jsii_name="goopInput")
    def goop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationGoop]]], jsii.get(self, "goopInput"))

    @builtins.property
    @jsii.member(jsii_name="grayscaleInput")
    def grayscale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationGrayscale]]], jsii.get(self, "grayscaleInput"))

    @builtins.property
    @jsii.member(jsii_name="hslInput")
    def hsl_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationHsl]]], jsii.get(self, "hslInput"))

    @builtins.property
    @jsii.member(jsii_name="hsvInput")
    def hsv_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationHsv]]], jsii.get(self, "hsvInput"))

    @builtins.property
    @jsii.member(jsii_name="ifDimensionInput")
    def if_dimension_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfDimension]]], jsii.get(self, "ifDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientationInput")
    def if_orientation_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfOrientation]]], jsii.get(self, "ifOrientationInput"))

    @builtins.property
    @jsii.member(jsii_name="imQueryInput")
    def im_query_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationImQuery]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationImQuery]]], jsii.get(self, "imQueryInput"))

    @builtins.property
    @jsii.member(jsii_name="maxColorsInput")
    def max_colors_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationMaxColors]]], jsii.get(self, "maxColorsInput"))

    @builtins.property
    @jsii.member(jsii_name="mirrorInput")
    def mirror_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationMirror]]], jsii.get(self, "mirrorInput"))

    @builtins.property
    @jsii.member(jsii_name="monoHueInput")
    def mono_hue_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationMonoHue]]], jsii.get(self, "monoHueInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationOpacity]]], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestCropInput")
    def region_of_interest_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationRegionOfInterestCrop"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationRegionOfInterestCrop"]]], jsii.get(self, "regionOfInterestCropInput"))

    @builtins.property
    @jsii.member(jsii_name="relativeCropInput")
    def relative_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationRelativeCrop"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationRelativeCrop"]]], jsii.get(self, "relativeCropInput"))

    @builtins.property
    @jsii.member(jsii_name="removeColorInput")
    def remove_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationRemoveColor"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationRemoveColor"]]], jsii.get(self, "removeColorInput"))

    @builtins.property
    @jsii.member(jsii_name="resizeInput")
    def resize_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationResize"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationResize"]]], jsii.get(self, "resizeInput"))

    @builtins.property
    @jsii.member(jsii_name="rotateInput")
    def rotate_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationRotate"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationRotate"]]], jsii.get(self, "rotateInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationScale"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationScale"]]], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="shearInput")
    def shear_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationShear"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationShear"]]], jsii.get(self, "shearInput"))

    @builtins.property
    @jsii.member(jsii_name="trimInput")
    def trim_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationTrim"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationTrim"]]], jsii.get(self, "trimInput"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMaskInput")
    def unsharp_mask_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationUnsharpMask"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationUnsharpMask"]]], jsii.get(self, "unsharpMaskInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b46a69984bff7a103a995ba4671aac041002b36f3c550efb69749993509cc93b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationRegionOfInterestCrop",
    jsii_struct_bases=[],
    name_mapping={
        "region_of_interest": "regionOfInterest",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationRegionOfInterestCrop:
    def __init__(
        self,
        *,
        region_of_interest: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationRegionOfInterestCropRegionOfInterest", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param region_of_interest: region_of_interest block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest DataAkamaiImagingPolicyImage#region_of_interest}
        :param gravity: The placement of the crop area relative to the specified area of interest. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: The placement of the crop area relative to the specified area of interest. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param style: Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(region_of_interest, dict):
            region_of_interest = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationRegionOfInterestCropRegionOfInterest(**region_of_interest)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c32fa87ccb4ad7318edf940eb0fb72147576c0e968af5af18fe622607f08c101)
            check_type(argname="argument region_of_interest", value=region_of_interest, expected_type=type_hints["region_of_interest"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "region_of_interest": region_of_interest,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def region_of_interest(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationRegionOfInterestCropRegionOfInterest":
        '''region_of_interest block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest DataAkamaiImagingPolicyImage#region_of_interest}
        '''
        result = self._values.get("region_of_interest")
        assert result is not None, "Required property 'region_of_interest' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationRegionOfInterestCropRegionOfInterest", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''The placement of the crop area relative to the specified area of interest.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''The placement of the crop area relative to the specified area of interest.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationRegionOfInterestCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationRegionOfInterestCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationRegionOfInterestCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__600677ed480ca79232deaf895cd0b8abeeb18776380e8c2499a48b24d2720ad0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationRegionOfInterestCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__24b585ecac6ed8a67e1d4a3f0a892923e52a89692f1a250720318782d832c0e5)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationRegionOfInterestCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6caa6ee64d97a53929c0d25fbc31caf2d744a59504c82a79589b51eaac725d85)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3bd65e0893dbe89147a32145887f51a4b313b7400480653f78da2fc693dfcfca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__51f9a9af6361ecc13e645b340820e2663df566ecf01c74629c6240b8a96b75b5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationRegionOfInterestCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationRegionOfInterestCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationRegionOfInterestCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__744f798025ee615e290385c56f05c468d5fbe1b9c4d2d239eb6299d4907a725e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationRegionOfInterestCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationRegionOfInterestCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3539747ca5853b1f215e7ed6c66bddd40bf3197d8a05b8cbacf45e58b88e4b5e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putRegionOfInterest")
    def put_region_of_interest(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationRegionOfInterestCropRegionOfInterest()

        return typing.cast(None, jsii.invoke(self, "putRegionOfInterest", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterest")
    def region_of_interest(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestOutputReference", jsii.get(self, "regionOfInterest"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestInput")
    def region_of_interest_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationRegionOfInterestCropRegionOfInterest"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationRegionOfInterestCropRegionOfInterest"], jsii.get(self, "regionOfInterestInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ed705da38f3b3db06b754ebb7b58c11752a7b70ade4188fe49e0628ac1bd520e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c9c44bc3a2eefc50ddbc74ddececbfb814f98bbd36ea88b1373529ba7c688056)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__01002805f6b5e657b898b767f59bcfec4aab2a7ed1cf8cdb937841854fc76f89)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ad1438b3aae457d71fcf71566a20680bd7dcc3077ef697fe90195dba0fc7bddc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__47bfd7d88d067a7b1436c3574200fb7ec1e577c3194b9e43f913e50cfe4dcf06)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1889edc0c4468eeb0483ce45666dae3a065a7e69cb7aefd6d1498155e020e81c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__12caf2dd453d0945d3af26bd32a64c38836650eef4fbed8425c7a590525bfdd6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__44eaedee8bb37555c23a487ca7ea8c292e0cf5aad87ee5bde800870bde6374ee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationRegionOfInterestCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationRegionOfInterestCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationRegionOfInterestCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4536c4b8204c1d17e0b19a53e0ec9a93cf47ee328e7ecef091d05ea227abbd80)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationRegionOfInterestCropRegionOfInterest",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationRegionOfInterestCropRegionOfInterest:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationRegionOfInterestCropRegionOfInterest(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e49072826ef1ef7e3097b5c03c9a9955811bd5ef71747cb59ca955cefae6d45b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationRegionOfInterestCropRegionOfInterest]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationRegionOfInterestCropRegionOfInterest], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationRegionOfInterestCropRegionOfInterest],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__10fe40b1d2d585e88e7489fcd9d97c02fce273d52072620b33cdee3c5c7ec10e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationRelativeCrop",
    jsii_struct_bases=[],
    name_mapping={
        "east": "east",
        "east_var": "eastVar",
        "north": "north",
        "north_var": "northVar",
        "south": "south",
        "south_var": "southVar",
        "west": "west",
        "west_var": "westVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationRelativeCrop:
    def __init__(
        self,
        *,
        east: typing.Optional[builtins.str] = None,
        east_var: typing.Optional[builtins.str] = None,
        north: typing.Optional[builtins.str] = None,
        north_var: typing.Optional[builtins.str] = None,
        south: typing.Optional[builtins.str] = None,
        south_var: typing.Optional[builtins.str] = None,
        west: typing.Optional[builtins.str] = None,
        west_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param east: The number of pixels to shrink or expand the right side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east DataAkamaiImagingPolicyImage#east}
        :param east_var: The number of pixels to shrink or expand the right side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east_var DataAkamaiImagingPolicyImage#east_var}
        :param north: The number of pixels to shrink or expand the top side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north DataAkamaiImagingPolicyImage#north}
        :param north_var: The number of pixels to shrink or expand the top side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north_var DataAkamaiImagingPolicyImage#north_var}
        :param south: The number of pixels to shrink or expand the bottom side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south DataAkamaiImagingPolicyImage#south}
        :param south_var: The number of pixels to shrink or expand the bottom side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south_var DataAkamaiImagingPolicyImage#south_var}
        :param west: The number of pixels to shrink or expand the left side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west DataAkamaiImagingPolicyImage#west}
        :param west_var: The number of pixels to shrink or expand the left side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west_var DataAkamaiImagingPolicyImage#west_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c8edc817108d912907bcfd1f760f5a62567e4f2017c6bbd8f04d31260c2aebdf)
            check_type(argname="argument east", value=east, expected_type=type_hints["east"])
            check_type(argname="argument east_var", value=east_var, expected_type=type_hints["east_var"])
            check_type(argname="argument north", value=north, expected_type=type_hints["north"])
            check_type(argname="argument north_var", value=north_var, expected_type=type_hints["north_var"])
            check_type(argname="argument south", value=south, expected_type=type_hints["south"])
            check_type(argname="argument south_var", value=south_var, expected_type=type_hints["south_var"])
            check_type(argname="argument west", value=west, expected_type=type_hints["west"])
            check_type(argname="argument west_var", value=west_var, expected_type=type_hints["west_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if east is not None:
            self._values["east"] = east
        if east_var is not None:
            self._values["east_var"] = east_var
        if north is not None:
            self._values["north"] = north
        if north_var is not None:
            self._values["north_var"] = north_var
        if south is not None:
            self._values["south"] = south
        if south_var is not None:
            self._values["south_var"] = south_var
        if west is not None:
            self._values["west"] = west
        if west_var is not None:
            self._values["west_var"] = west_var

    @builtins.property
    def east(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the right side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east DataAkamaiImagingPolicyImage#east}
        '''
        result = self._values.get("east")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def east_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the right side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east_var DataAkamaiImagingPolicyImage#east_var}
        '''
        result = self._values.get("east_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def north(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the top side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north DataAkamaiImagingPolicyImage#north}
        '''
        result = self._values.get("north")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def north_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the top side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north_var DataAkamaiImagingPolicyImage#north_var}
        '''
        result = self._values.get("north_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def south(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the bottom side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south DataAkamaiImagingPolicyImage#south}
        '''
        result = self._values.get("south")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def south_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the bottom side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south_var DataAkamaiImagingPolicyImage#south_var}
        '''
        result = self._values.get("south_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def west(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the left side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west DataAkamaiImagingPolicyImage#west}
        '''
        result = self._values.get("west")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def west_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the left side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west_var DataAkamaiImagingPolicyImage#west_var}
        '''
        result = self._values.get("west_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationRelativeCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationRelativeCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationRelativeCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__33da63ba94bc0ae0d78ca2c472c2f3b2a8259a65a6657dfb51ad696f7dffef53)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationRelativeCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be37a8324ceffa9b92a8ba43806f470615e967e4621a163df3d36e5f7fedca70)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationRelativeCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1331b903795d30d3a6cc8ce1eef37c69a5f9479e25961230fd6ec77317a2bd7b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3c9e9d5acd964fbcac31ff64943684d6d62d6a515917456cbd2bd6280ae2af03)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7560421952ea39876cfebd59e0dcef4a71ab028290ce5ac8706feef8a2a71319)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationRelativeCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationRelativeCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationRelativeCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f9868b34abeb445527668a2bf5bc5f45d53e8fa2430a2a6551071cfe72f7e92)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationRelativeCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationRelativeCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b262ada254ebf72219279a373f2db06d806d650d82ef591187a57a29478356a5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetEast")
    def reset_east(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEast", []))

    @jsii.member(jsii_name="resetEastVar")
    def reset_east_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEastVar", []))

    @jsii.member(jsii_name="resetNorth")
    def reset_north(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNorth", []))

    @jsii.member(jsii_name="resetNorthVar")
    def reset_north_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNorthVar", []))

    @jsii.member(jsii_name="resetSouth")
    def reset_south(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSouth", []))

    @jsii.member(jsii_name="resetSouthVar")
    def reset_south_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSouthVar", []))

    @jsii.member(jsii_name="resetWest")
    def reset_west(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWest", []))

    @jsii.member(jsii_name="resetWestVar")
    def reset_west_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWestVar", []))

    @builtins.property
    @jsii.member(jsii_name="eastInput")
    def east_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "eastInput"))

    @builtins.property
    @jsii.member(jsii_name="eastVarInput")
    def east_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "eastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="northInput")
    def north_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "northInput"))

    @builtins.property
    @jsii.member(jsii_name="northVarInput")
    def north_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "northVarInput"))

    @builtins.property
    @jsii.member(jsii_name="southInput")
    def south_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "southInput"))

    @builtins.property
    @jsii.member(jsii_name="southVarInput")
    def south_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "southVarInput"))

    @builtins.property
    @jsii.member(jsii_name="westInput")
    def west_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "westInput"))

    @builtins.property
    @jsii.member(jsii_name="westVarInput")
    def west_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "westVarInput"))

    @builtins.property
    @jsii.member(jsii_name="east")
    def east(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "east"))

    @east.setter
    def east(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6a1682c612b48e308081a6d9eb419f82b72e97977951e994f1c034e46ead89f3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "east", value)

    @builtins.property
    @jsii.member(jsii_name="eastVar")
    def east_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "eastVar"))

    @east_var.setter
    def east_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e64f39e8cd89883cdf2893466aaa76479a4b15617bcda4ab5651723b958403c0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "eastVar", value)

    @builtins.property
    @jsii.member(jsii_name="north")
    def north(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "north"))

    @north.setter
    def north(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__19f256d9e99bfb70653170daa4c4362b07eee3bc49abe1bc83d907b5ef193e0e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "north", value)

    @builtins.property
    @jsii.member(jsii_name="northVar")
    def north_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "northVar"))

    @north_var.setter
    def north_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__943d5681aa5672869fe60df777049aea6ee16e8f0a7db386fb5fc09bd3c7b5df)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "northVar", value)

    @builtins.property
    @jsii.member(jsii_name="south")
    def south(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "south"))

    @south.setter
    def south(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0e24b28836300db1cf47819ac2ab5c992ac1f18d7610d5fa990e2715ebdeab29)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "south", value)

    @builtins.property
    @jsii.member(jsii_name="southVar")
    def south_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "southVar"))

    @south_var.setter
    def south_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__167c5441637cf8b03686f35d66914a50315cd2e5a9e3c8371cb514343a3a598c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "southVar", value)

    @builtins.property
    @jsii.member(jsii_name="west")
    def west(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "west"))

    @west.setter
    def west(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__83d99a76faafcb6bdc3582080e6cea423c3253252bd2147315ae657b9cd8670f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "west", value)

    @builtins.property
    @jsii.member(jsii_name="westVar")
    def west_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "westVar"))

    @west_var.setter
    def west_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4bd7e0b3e0a56fa1583703ccd11d5a68190e29868d7a3e76b537e1af216dd7e0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "westVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationRelativeCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationRelativeCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationRelativeCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b9c1884978bc09b9294f615461bc066d4d1b307f02dd500829bc05884bd8dcc2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationRemoveColor",
    jsii_struct_bases=[],
    name_mapping={
        "color": "color",
        "color_var": "colorVar",
        "feather": "feather",
        "feather_var": "featherVar",
        "tolerance": "tolerance",
        "tolerance_var": "toleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationRemoveColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
        feather: typing.Optional[builtins.str] = None,
        feather_var: typing.Optional[builtins.str] = None,
        tolerance: typing.Optional[builtins.str] = None,
        tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        :param feather: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        :param feather_var: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        :param tolerance: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        :param tolerance_var: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__01ed62dc6f69742a674626e75c4e04f11fb16740c54c26cf4f47f4289722e659)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
            check_type(argname="argument feather", value=feather, expected_type=type_hints["feather"])
            check_type(argname="argument feather_var", value=feather_var, expected_type=type_hints["feather_var"])
            check_type(argname="argument tolerance", value=tolerance, expected_type=type_hints["tolerance"])
            check_type(argname="argument tolerance_var", value=tolerance_var, expected_type=type_hints["tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var
        if feather is not None:
            self._values["feather"] = feather
        if feather_var is not None:
            self._values["feather_var"] = feather_var
        if tolerance is not None:
            self._values["tolerance"] = tolerance
        if tolerance_var is not None:
            self._values["tolerance_var"] = tolerance_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        '''
        result = self._values.get("feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather_var(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        '''
        result = self._values.get("feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        '''
        result = self._values.get("tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance_var(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        result = self._values.get("tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationRemoveColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationRemoveColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationRemoveColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d858214d58f285cf9159988aed3ab160bb97584bb35e5288e0939c7937f92603)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationRemoveColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__35895697dafc960629c730e34605a1c28bcd0208d0921472b78575ebf294c83f)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationRemoveColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9b6c522beacf4af24d30a13baa89ff70d9815a49dd973f6b099aa9d2dc8b6966)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e4ae6663683184cac7d60e72644eeb96d5e4ed45920517650fcd964bce78094d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__10da259843362520a8293d068b9ef215c20ce19b9d4951270a1ed058f34b6a68)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationRemoveColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationRemoveColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationRemoveColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d8a04d352c9dccf485a472b03405c2410a04fbc8eac505524ad7c757bb4f5416)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationRemoveColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationRemoveColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5aa58d77ae5b33c098e84d85b55fe327e66ede6d0f46ade874ad13c491ca5938)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @jsii.member(jsii_name="resetFeather")
    def reset_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeather", []))

    @jsii.member(jsii_name="resetFeatherVar")
    def reset_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatherVar", []))

    @jsii.member(jsii_name="resetTolerance")
    def reset_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTolerance", []))

    @jsii.member(jsii_name="resetToleranceVar")
    def reset_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featherInput")
    def feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherInput"))

    @builtins.property
    @jsii.member(jsii_name="featherVarInput")
    def feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceInput")
    def tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceVarInput")
    def tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6da1d80f465aa2392a18eece275fb84eaa67682ed308688e9c436fb38eaaa1c8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e1a249e677d40a086b945c27a3799e32a17945e8d7be92a2aa81afa905ff1a4a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="feather")
    def feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "feather"))

    @feather.setter
    def feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__57f2be9c02e54076cf52bb21d9ef992ff40040bbd2ee9c8cf3512379895ae13a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "feather", value)

    @builtins.property
    @jsii.member(jsii_name="featherVar")
    def feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featherVar"))

    @feather_var.setter
    def feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1562d3e8abbaaa5501e55e97f0c0a7d6e69b4b70140e6a1795fc6e705f0b9bef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featherVar", value)

    @builtins.property
    @jsii.member(jsii_name="tolerance")
    def tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tolerance"))

    @tolerance.setter
    def tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a6c05d208760211424efc6a601ea12f247e85cc0386b93fd1c1c0697d9cc12a8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tolerance", value)

    @builtins.property
    @jsii.member(jsii_name="toleranceVar")
    def tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "toleranceVar"))

    @tolerance_var.setter
    def tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__36bb653eea151189e6fdb402b8d2acef5ff3075090f13a99ff7a2665b3c46c59)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "toleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationRemoveColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationRemoveColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationRemoveColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__40c41812bde6eb904c276725ba389add6452724a814046de0222b33c75e377fd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationResize",
    jsii_struct_bases=[],
    name_mapping={
        "aspect": "aspect",
        "aspect_var": "aspectVar",
        "height": "height",
        "height_var": "heightVar",
        "type": "type",
        "type_var": "typeVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationResize:
    def __init__(
        self,
        *,
        aspect: typing.Optional[builtins.str] = None,
        aspect_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param aspect: Preserves the aspect ratio. Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect DataAkamaiImagingPolicyImage#aspect}
        :param aspect_var: Preserves the aspect ratio. Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_var DataAkamaiImagingPolicyImage#aspect_var}
        :param height: The height to resize the source image to. Must be set if height is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height to resize the source image to. Must be set if height is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param type: Sets constraints for the image resize. Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: Sets constraints for the image resize. Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        :param width: The width to resize the source image to. Must be set if width is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width to resize the source image to. Must be set if width is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__427f263c84568543482e9620d2a0440343f7fa0bff2325ec283e405f1a51dcbf)
            check_type(argname="argument aspect", value=aspect, expected_type=type_hints["aspect"])
            check_type(argname="argument aspect_var", value=aspect_var, expected_type=type_hints["aspect_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if aspect is not None:
            self._values["aspect"] = aspect
        if aspect_var is not None:
            self._values["aspect_var"] = aspect_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def aspect(self) -> typing.Optional[builtins.str]:
        '''Preserves the aspect ratio.

        Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect DataAkamaiImagingPolicyImage#aspect}
        '''
        result = self._values.get("aspect")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def aspect_var(self) -> typing.Optional[builtins.str]:
        '''Preserves the aspect ratio.

        Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_var DataAkamaiImagingPolicyImage#aspect_var}
        '''
        result = self._values.get("aspect_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height to resize the source image to. Must be set if height is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height to resize the source image to. Must be set if height is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''Sets constraints for the image resize.

        Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''Sets constraints for the image resize.

        Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width to resize the source image to. Must be set if width is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width to resize the source image to. Must be set if width is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationResize(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationResizeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationResizeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__793062359fa58232e5528383a265bf748c9a893bd6d176adecfa67daa4ebb659)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationResizeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4f278cc8f583150e2cd9beb14daf0c0848dbd50bf59b6b4f18524e04a9aec879)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationResizeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3d1448b1362f7013ca96be02f670ba097d7cec4799df6eeba714c0be3021bbc4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e21eed6b8a5263bf10ceaec00f3113450317ff7e2e6a45ab4b19aff0931ef52b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__187caf0101566e2fd18ccfa0202008dbf14d00ac3263597f0bbfd45212c78d36)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationResize]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationResize]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationResize]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__13899ab3958ec81cc2bf1d82259a47cee0f9dc34bb268bc47343a1f36ccb7c0b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationResizeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationResizeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6a7f371f7722857b21d12d255dc0379d4e24ca84fd6ce0677270c766a637c276)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAspect")
    def reset_aspect(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspect", []))

    @jsii.member(jsii_name="resetAspectVar")
    def reset_aspect_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspectVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="aspectInput")
    def aspect_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "aspectInput"))

    @builtins.property
    @jsii.member(jsii_name="aspectVarInput")
    def aspect_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "aspectVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="aspect")
    def aspect(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "aspect"))

    @aspect.setter
    def aspect(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a3d10323b417a89dbf29fd15fa0358e54ad671dd5704a6359d20a85445155436)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "aspect", value)

    @builtins.property
    @jsii.member(jsii_name="aspectVar")
    def aspect_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "aspectVar"))

    @aspect_var.setter
    def aspect_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7f9690477fa62656aed7ad2f6e3d565e4abd9731a18ca8910c83712c9764e47d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "aspectVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__40353008eb1c42b9bc545641be09e48d3c4db8cef9d1967fffb4e42cc4cf0864)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a19697bd3728937f0c52f63d9afaecc9c38aad5afbc08a7b4eec7af006833b91)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__84cd92b720113fa9e247d12b233cf4f058f4ecc750c7cbbbd22fd3d394265e8f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d7fbf2ef96cd8c53976ed34c1e1f95a053d591dbdc848b49d6556fa9b995e40)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__12d6a3855f521affeb321d2e2f5be85efed80ec075eed9ce0d5ce7d3596913d1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3e975313603eb44cd3c724230babf8bd171b7c7b1a0a727cf7b221166042520a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationResize]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationResize]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationResize]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__41e91fd8d4b619a5737b068708485beaf764a51fe47ee35bb17170751fe9cc2b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationRotate",
    jsii_struct_bases=[],
    name_mapping={"degrees": "degrees", "degrees_var": "degreesVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationRotate:
    def __init__(
        self,
        *,
        degrees: typing.Optional[builtins.str] = None,
        degrees_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param degrees: The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees DataAkamaiImagingPolicyImage#degrees}
        :param degrees_var: The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees_var DataAkamaiImagingPolicyImage#degrees_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f6375c1ec0f14458eed06dc70c3961afa0ff258f358056910722089a5a96524a)
            check_type(argname="argument degrees", value=degrees, expected_type=type_hints["degrees"])
            check_type(argname="argument degrees_var", value=degrees_var, expected_type=type_hints["degrees_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if degrees is not None:
            self._values["degrees"] = degrees
        if degrees_var is not None:
            self._values["degrees_var"] = degrees_var

    @builtins.property
    def degrees(self) -> typing.Optional[builtins.str]:
        '''The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees DataAkamaiImagingPolicyImage#degrees}
        '''
        result = self._values.get("degrees")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def degrees_var(self) -> typing.Optional[builtins.str]:
        '''The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees_var DataAkamaiImagingPolicyImage#degrees_var}
        '''
        result = self._values.get("degrees_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationRotate(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationRotateList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationRotateList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5dfa3e260176f94d281d57a8d7ac01ac0b5eda2342ce1030f8d94d4872930eee)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationRotateOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__669e5f9ce90a83167b8ab492c7d89a5b72bdf8b3c4a52ffd8b00ddefdfe011e0)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationRotateOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d5efad07108ef49c7eac1c77f89a8d9b38ccbb8444d49ab329d15c807e0f009e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a9accc192d0c08737c563619c9524b9d005a16a16a3ea11f72153d7d2b59157)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0446cf654194afa5459d7c890b19542533c1a194f86e6d72725fbffd4f282655)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationRotate]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationRotate]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationRotate]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__845ccd96e12edd4dfdc0b6ea1322a5a55eb74aab38e09710617455f2db90f148)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationRotateOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationRotateOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cbc2329f66898e88c93eb5cfae97bf637ff3f38204cc5af68e117c5532d739ee)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetDegrees")
    def reset_degrees(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDegrees", []))

    @jsii.member(jsii_name="resetDegreesVar")
    def reset_degrees_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDegreesVar", []))

    @builtins.property
    @jsii.member(jsii_name="degreesInput")
    def degrees_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "degreesInput"))

    @builtins.property
    @jsii.member(jsii_name="degreesVarInput")
    def degrees_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "degreesVarInput"))

    @builtins.property
    @jsii.member(jsii_name="degrees")
    def degrees(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "degrees"))

    @degrees.setter
    def degrees(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__db0fd4e74ffed3546753da01556eb75440c02a61b13ca7ffc5860acf4398cea4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "degrees", value)

    @builtins.property
    @jsii.member(jsii_name="degreesVar")
    def degrees_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "degreesVar"))

    @degrees_var.setter
    def degrees_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d4bb741dde11fdc28d52517a81789df4d4516b59c73a5be37cd095cc3e6a2ee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "degreesVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationRotate]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationRotate]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationRotate]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__50906b19d9598c20586d6a6325fbdbe5dec8f426adafa557f992323341a9b59d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationScale",
    jsii_struct_bases=[],
    name_mapping={
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationScale:
    def __init__(
        self,
        *,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param height: Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged. Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged. Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__558ec8d11139944707614f0d421cb6a358a389e78e3e7abdcfcde1b472116b1f)
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size.

        Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size.

        Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged.

        Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged.

        Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationScale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationScaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationScaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eb06fbbeedb7f449d92220bdf404f743469d6a86a6fd5ecc96fdd2c7a74ac3b2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationScaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9322b8739a2550812a80327fe15fdca99ace2a2e6f7d90a8e81e0c103e27a044)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationScaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d98e183d9aa10dd83bcb529e56947d27a5e3a24124816fbbcb8185334f9e5a7c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__44ae5b1a093334c7e14978e0bc897e9a452f9677c262ccc71994aa9b0ff70c89)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c2346cc2182a3b0bc160e02d783c84afcadfe7fc60d6ad4a5c331900ae6a07fa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationScale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationScale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationScale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2bee97ef8cd9dffbaacd052d94a55b3f99c51f581947ca84a5689cae893777f4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationScaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationScaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6edcbfb5dcd1614e70add4f989e66dccaf4a3e767491d4e7c33bf0f82b5a7be4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e2ba80e95ae9b7dafb3f852646d5f228c14fdbb3e734894b1698ae36408c191d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__492e7a18cdc2eea3e6f82e6e893a39d5fb6cdda9193398402d99499374b699a9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8dfa2462299dccf15ce562e5e29baa12408a0fc106eb403f99523b209592cef2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c141018fd13afd51c2984ba2f6b6be2762113d8341d3ea53e7ca24f7c4352171)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationScale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationScale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationScale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fc11f72515c019d83f26e243e3683c88604a7ce43eca6690bb49c4ffa83de12d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationShear",
    jsii_struct_bases=[],
    name_mapping={
        "x_shear": "xShear",
        "x_shear_var": "xShearVar",
        "y_shear": "yShear",
        "y_shear_var": "yShearVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationShear:
    def __init__(
        self,
        *,
        x_shear: typing.Optional[builtins.str] = None,
        x_shear_var: typing.Optional[builtins.str] = None,
        y_shear: typing.Optional[builtins.str] = None,
        y_shear_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param x_shear: The amount to shear along the x-axis, measured in multiples of the image's width. Must be set if yShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear DataAkamaiImagingPolicyImage#x_shear}
        :param x_shear_var: The amount to shear along the x-axis, measured in multiples of the image's width. Must be set if yShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear_var DataAkamaiImagingPolicyImage#x_shear_var}
        :param y_shear: The amount to shear along the y-axis, measured in multiples of the image's height. Must be set if xShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear DataAkamaiImagingPolicyImage#y_shear}
        :param y_shear_var: The amount to shear along the y-axis, measured in multiples of the image's height. Must be set if xShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear_var DataAkamaiImagingPolicyImage#y_shear_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3e29dfbe6e8caf5c8b6e8e071c83b32a70da7952b17c23a30016344b6aac2a8c)
            check_type(argname="argument x_shear", value=x_shear, expected_type=type_hints["x_shear"])
            check_type(argname="argument x_shear_var", value=x_shear_var, expected_type=type_hints["x_shear_var"])
            check_type(argname="argument y_shear", value=y_shear, expected_type=type_hints["y_shear"])
            check_type(argname="argument y_shear_var", value=y_shear_var, expected_type=type_hints["y_shear_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if x_shear is not None:
            self._values["x_shear"] = x_shear
        if x_shear_var is not None:
            self._values["x_shear_var"] = x_shear_var
        if y_shear is not None:
            self._values["y_shear"] = y_shear
        if y_shear_var is not None:
            self._values["y_shear_var"] = y_shear_var

    @builtins.property
    def x_shear(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the x-axis, measured in multiples of the image's width.

        Must be set if yShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear DataAkamaiImagingPolicyImage#x_shear}
        '''
        result = self._values.get("x_shear")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_shear_var(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the x-axis, measured in multiples of the image's width.

        Must be set if yShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear_var DataAkamaiImagingPolicyImage#x_shear_var}
        '''
        result = self._values.get("x_shear_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_shear(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the y-axis, measured in multiples of the image's height.

        Must be set if xShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear DataAkamaiImagingPolicyImage#y_shear}
        '''
        result = self._values.get("y_shear")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_shear_var(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the y-axis, measured in multiples of the image's height.

        Must be set if xShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear_var DataAkamaiImagingPolicyImage#y_shear_var}
        '''
        result = self._values.get("y_shear_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationShear(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationShearList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationShearList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aaeaa0e48714e017d3742b861048060d1b9051d37fe9d92eeee5e79c4eee3604)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationShearOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__14e17e0943e9467567d20dd667fdda861073885fd986ff51a8e82f5f080a3d58)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationShearOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c67c4a599e75ab05b1f1d87776a1201b9df97cd9f587752b6fd6ae2a75e50225)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__974a779f3dbcdb5208828fe5b7e0fb482e8faaa3335cee8cb480af64f11df4b9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__002fc05244f34f43d28331e6230d04c0ebd92ab7430dad395396f074e80d7196)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationShear]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationShear]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationShear]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d146e5cf2ed9b0f8d92675482fa6ce47b6dad064a9a9c180ac5f4db3860eb863)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationShearOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationShearOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4dd833f6e7c8809d89fdc8fc3508945e2327b343268bbe240f7422db25bb07a0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetXShear")
    def reset_x_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXShear", []))

    @jsii.member(jsii_name="resetXShearVar")
    def reset_x_shear_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXShearVar", []))

    @jsii.member(jsii_name="resetYShear")
    def reset_y_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYShear", []))

    @jsii.member(jsii_name="resetYShearVar")
    def reset_y_shear_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYShearVar", []))

    @builtins.property
    @jsii.member(jsii_name="xShearInput")
    def x_shear_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xShearInput"))

    @builtins.property
    @jsii.member(jsii_name="xShearVarInput")
    def x_shear_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xShearVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yShearInput")
    def y_shear_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yShearInput"))

    @builtins.property
    @jsii.member(jsii_name="yShearVarInput")
    def y_shear_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yShearVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xShear")
    def x_shear(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xShear"))

    @x_shear.setter
    def x_shear(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a910e5a7b023742bca8c8d360a5789068163329ebda76d7606a18df104fe9b10)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xShear", value)

    @builtins.property
    @jsii.member(jsii_name="xShearVar")
    def x_shear_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xShearVar"))

    @x_shear_var.setter
    def x_shear_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__49d03885fc297a0066ee256b761733dbb29ec585641231dc18bc752c2843a542)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xShearVar", value)

    @builtins.property
    @jsii.member(jsii_name="yShear")
    def y_shear(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yShear"))

    @y_shear.setter
    def y_shear(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__63bf81c1ad5a55a5c72bba283ef62f625af90161c788eb7a018009746aaa4ee5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yShear", value)

    @builtins.property
    @jsii.member(jsii_name="yShearVar")
    def y_shear_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yShearVar"))

    @y_shear_var.setter
    def y_shear_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ec276bfb0dfad3622955955b221bb21995f03d3556fa314072883c6411c93cc6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yShearVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationShear]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationShear]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationShear]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8618f18c6f4dc939693c7ad171f89d4394fb052b57f8ca6c04703bafd85d8536)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationTrim",
    jsii_struct_bases=[],
    name_mapping={
        "fuzz": "fuzz",
        "fuzz_var": "fuzzVar",
        "padding": "padding",
        "padding_var": "paddingVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationTrim:
    def __init__(
        self,
        *,
        fuzz: typing.Optional[builtins.str] = None,
        fuzz_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fuzz: The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz DataAkamaiImagingPolicyImage#fuzz}
        :param fuzz_var: The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz_var DataAkamaiImagingPolicyImage#fuzz_var}
        :param padding: The amount of padding in pixels to add to the trimmed image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: The amount of padding in pixels to add to the trimmed image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__260e3530af2dde18519b6a271e8abd9b35b2d1f75fa35c8d3264ab36555c1296)
            check_type(argname="argument fuzz", value=fuzz, expected_type=type_hints["fuzz"])
            check_type(argname="argument fuzz_var", value=fuzz_var, expected_type=type_hints["fuzz_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fuzz is not None:
            self._values["fuzz"] = fuzz
        if fuzz_var is not None:
            self._values["fuzz_var"] = fuzz_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var

    @builtins.property
    def fuzz(self) -> typing.Optional[builtins.str]:
        '''The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz DataAkamaiImagingPolicyImage#fuzz}
        '''
        result = self._values.get("fuzz")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fuzz_var(self) -> typing.Optional[builtins.str]:
        '''The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz_var DataAkamaiImagingPolicyImage#fuzz_var}
        '''
        result = self._values.get("fuzz_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''The amount of padding in pixels to add to the trimmed image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''The amount of padding in pixels to add to the trimmed image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationTrim(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationTrimList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationTrimList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__125a79424e958ade931ba523b5e645c97d11d94bce612871e9549349513e3527)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationTrimOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ec0ca8f1f1d6972f17384a17785d8ef6435da6ca0d6cac91ff4e45dc142fa17)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationTrimOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a5c839ec93eaad23bec5df7016c6bbdb16aff62f5144755fa52f7d0a375768a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ebc60837997805083ae1f36c336f7ddfedd2bf06f13235666c4b51fd1223c620)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__271729cb19bae581e15bc7767faf83446d85356102fe93876303021828f955e3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationTrim]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationTrim]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationTrim]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__147dd86b48117c872d5f99ae1fdc21e927f3fb5b0a424384ceb52becd4066bfb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationTrimOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationTrimOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__da87d4ab55cc9a8b9d1ee0a7b29d154c48289bc7f6dc9abae8a4934518f3a03f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetFuzz")
    def reset_fuzz(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFuzz", []))

    @jsii.member(jsii_name="resetFuzzVar")
    def reset_fuzz_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFuzzVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @builtins.property
    @jsii.member(jsii_name="fuzzInput")
    def fuzz_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fuzzInput"))

    @builtins.property
    @jsii.member(jsii_name="fuzzVarInput")
    def fuzz_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fuzzVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="fuzz")
    def fuzz(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fuzz"))

    @fuzz.setter
    def fuzz(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5424accc34367c8338dc15992a2f45d2c3fee7539800d5cec795abe0ba0de8ea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fuzz", value)

    @builtins.property
    @jsii.member(jsii_name="fuzzVar")
    def fuzz_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fuzzVar"))

    @fuzz_var.setter
    def fuzz_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__605ec43c23f222622d7f683404583fc2c312c3b5beffe3121f0e35226953734a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fuzzVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5b47653ccb38e446d1af22293fa484898283daacdebbd380b79fa78b76b0e235)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dbdd6ff2537cb32aa2c29fcecf3f45537cb3e359d4d26d7a46715fdd6661d3bc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationTrim]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationTrim]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationTrim]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ef00d6fcbb1ae8bb1b0080f1a2df38fad950996b71c5cc13853cc8523dfdcfdb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationUnsharpMask",
    jsii_struct_bases=[],
    name_mapping={
        "gain": "gain",
        "gain_var": "gainVar",
        "sigma": "sigma",
        "sigma_var": "sigmaVar",
        "threshold": "threshold",
        "threshold_var": "thresholdVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationUnsharpMask:
    def __init__(
        self,
        *,
        gain: typing.Optional[builtins.str] = None,
        gain_var: typing.Optional[builtins.str] = None,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
        threshold: typing.Optional[builtins.str] = None,
        threshold_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param gain: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        :param gain_var: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        :param sigma: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        :param threshold: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        :param threshold_var: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f14168477bec10136a9242b665efa8d11f4730f39a4bd197ffa33584b9b54a5f)
            check_type(argname="argument gain", value=gain, expected_type=type_hints["gain"])
            check_type(argname="argument gain_var", value=gain_var, expected_type=type_hints["gain_var"])
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
            check_type(argname="argument threshold", value=threshold, expected_type=type_hints["threshold"])
            check_type(argname="argument threshold_var", value=threshold_var, expected_type=type_hints["threshold_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if gain is not None:
            self._values["gain"] = gain
        if gain_var is not None:
            self._values["gain_var"] = gain_var
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var
        if threshold is not None:
            self._values["threshold"] = threshold
        if threshold_var is not None:
            self._values["threshold_var"] = threshold_var

    @builtins.property
    def gain(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        '''
        result = self._values.get("gain")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gain_var(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        '''
        result = self._values.get("gain_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        '''
        result = self._values.get("threshold")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold_var(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        result = self._values.get("threshold_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationUnsharpMask(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationUnsharpMaskList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationUnsharpMaskList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f1afad1cad94a25243ae9fda08b85ec26b0e40c7c79b5e2dbd4f4b81de7cc24)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationUnsharpMaskOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a2ab610db228c17501fadef006e9e0f1df25db8d5f33c04f85aa52b695d886be)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationUnsharpMaskOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d880ea758c7bbdeea29d5133a417a918671e233cb7f401933f979a78e28ed55)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a6b29c10d59535ca22ceccd9c59b4d0b5e94e2ac0ba8b8df917d543428d59fcb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__29fe1f18bb318ea362619e3b602fde32a2160da3b51df9f351df85750eb08874)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationUnsharpMask]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationUnsharpMask]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationUnsharpMask]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__751bb9342a551248021159ce4f7ffdf515f30c283bf7a564b31151f60566990a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationUnsharpMaskOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationUnsharpMaskOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d27c51fd39a8563712b94726d99b60fcf24c62ecb8355a4385d62ce83abf7d4e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetGain")
    def reset_gain(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGain", []))

    @jsii.member(jsii_name="resetGainVar")
    def reset_gain_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGainVar", []))

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @jsii.member(jsii_name="resetThreshold")
    def reset_threshold(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThreshold", []))

    @jsii.member(jsii_name="resetThresholdVar")
    def reset_threshold_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThresholdVar", []))

    @builtins.property
    @jsii.member(jsii_name="gainInput")
    def gain_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainInput"))

    @builtins.property
    @jsii.member(jsii_name="gainVarInput")
    def gain_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdInput")
    def threshold_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdVarInput")
    def threshold_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gain")
    def gain(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gain"))

    @gain.setter
    def gain(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9b6109f0bf011972f6712ee4c795d916f2602233cdf9be9afe845a42c41dafdc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gain", value)

    @builtins.property
    @jsii.member(jsii_name="gainVar")
    def gain_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gainVar"))

    @gain_var.setter
    def gain_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__86ccc1753ecf7c3c46ceda46f9bb87195671b1e8cf7fd6ada75b6a04aa790cbf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gainVar", value)

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__da63adab31fdacab2a36f00280967d901670596c96040e244e9dd9b5594030b5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8ed5a3a77b43e73f4502e6ee0f43875f6b318e849f5c018aac132c0aebb79fd8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="threshold")
    def threshold(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "threshold"))

    @threshold.setter
    def threshold(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__04a2033d808b301deedfdb3135cef98f9c34b47373127fe781c11eeddc097b4b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "threshold", value)

    @builtins.property
    @jsii.member(jsii_name="thresholdVar")
    def threshold_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "thresholdVar"))

    @threshold_var.setter
    def threshold_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__57e4fd208bff1ac05bea2dfb21b83ccff05a01b7372708d7b26424adde83f576)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "thresholdVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationUnsharpMask]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationUnsharpMask]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationUnsharpMask]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cc3ddf41fd958189c1f754557668e6ea51e66439df6113d8f40494df29ed1ad4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d4299d540c22dedb18d8bca0450b23f3fd29cff3224d3027e4c0b16f3226efcd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7a020bd5d4c0007e55cba1b72e23c41bc74a730963a9bdbd343536b83b8b097b)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__53859681d914a97aa6e500f26563da3cbe59916a1128963241f2c39a9df9655f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ea8873bb666ff8f20a8ddce987e5958115a520545580a81552541b988b6e2fd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__55e6990e9d8a205eb5d34819dfdd18abfb78ad50ccc0f97e1c02cafb10b5db8e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFill]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFill]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFill]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__39a441c33537a1387da8eb59fd319db0b5196ea216bada63e81e06152d62e6ad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c385f618de8acf7f6cb8370ef1ab96f326abfd34c1078dd489b91bb3f00bf531)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putFillTransformation")
    def put_fill_transformation(
        self,
        *,
        append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationAppend, typing.Dict[builtins.str, typing.Any]]]]] = None,
        aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationAspectCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
        crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationFaceCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationFeatureCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationFitAndFill, typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
        im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationImQuery, typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
        region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationRegionOfInterestCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationRelativeCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
        resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationResize, typing.Dict[builtins.str, typing.Any]]]]] = None,
        rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationRotate, typing.Dict[builtins.str, typing.Any]]]]] = None,
        scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationScale, typing.Dict[builtins.str, typing.Any]]]]] = None,
        shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationShear, typing.Dict[builtins.str, typing.Any]]]]] = None,
        trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationTrim, typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param append: append block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        :param aspect_crop: aspect_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param crop: crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        :param face_crop: face_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        :param feature_crop: feature_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        :param fit_and_fill: fit_and_fill block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param im_query: im_query block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param region_of_interest_crop: region_of_interest_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        :param relative_crop: relative_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param resize: resize block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        :param rotate: rotate block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        :param scale: scale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param shear: shear block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        :param trim: trim block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformation(
            append=append,
            aspect_crop=aspect_crop,
            background_color=background_color,
            blur=blur,
            chroma_key=chroma_key,
            composite=composite,
            compound=compound,
            contrast=contrast,
            crop=crop,
            face_crop=face_crop,
            feature_crop=feature_crop,
            fit_and_fill=fit_and_fill,
            goop=goop,
            grayscale=grayscale,
            hsl=hsl,
            hsv=hsv,
            if_dimension=if_dimension,
            if_orientation=if_orientation,
            im_query=im_query,
            max_colors=max_colors,
            mirror=mirror,
            mono_hue=mono_hue,
            opacity=opacity,
            region_of_interest_crop=region_of_interest_crop,
            relative_crop=relative_crop,
            remove_color=remove_color,
            resize=resize,
            rotate=rotate,
            scale=scale,
            shear=shear,
            trim=trim,
            unsharp_mask=unsharp_mask,
        )

        return typing.cast(None, jsii.invoke(self, "putFillTransformation", [value]))

    @jsii.member(jsii_name="resetFillTransformation")
    def reset_fill_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFillTransformation", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="fillTransformation")
    def fill_transformation(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationOutputReference, jsii.get(self, "fillTransformation"))

    @builtins.property
    @jsii.member(jsii_name="fillTransformationInput")
    def fill_transformation_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformation], jsii.get(self, "fillTransformationInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1b98dc430e31831c7e8994a4b36ee7b11f1a89d2ae66534182f86eb6640c387e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__32d4e703985e35c27ac937fbb560a2aafcf56b8af088c66dcfe05d61b47513e5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5efc1a51cf70971debd995d8b9432bba8227535c62fdf9c32476a5832247aa6d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__137ee936943384f74fb6d255a2a96e0939e0930a3801b6b9da090c2aa1a88eb0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFill]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFill]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFill]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6d85f510407d3d1a0979f3d7f447932c8bc1f79dbe51eaf8ac0da0e698f5f28f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareGoop",
    jsii_struct_bases=[],
    name_mapping={
        "chaos": "chaos",
        "chaos_var": "chaosVar",
        "density": "density",
        "density_var": "densityVar",
        "power": "power",
        "power_var": "powerVar",
        "seed": "seed",
        "seed_var": "seedVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareGoop:
    def __init__(
        self,
        *,
        chaos: typing.Optional[builtins.str] = None,
        chaos_var: typing.Optional[builtins.str] = None,
        density: typing.Optional[builtins.str] = None,
        density_var: typing.Optional[builtins.str] = None,
        power: typing.Optional[builtins.str] = None,
        power_var: typing.Optional[builtins.str] = None,
        seed: typing.Optional[builtins.str] = None,
        seed_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param chaos: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        :param chaos_var: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        :param density: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        :param density_var: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        :param power: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        :param power_var: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        :param seed: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        :param seed_var: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__34fb29c473b24606a7dca5203d8d0fa390d1d5d99f3e08c38e9823cc7100e654)
            check_type(argname="argument chaos", value=chaos, expected_type=type_hints["chaos"])
            check_type(argname="argument chaos_var", value=chaos_var, expected_type=type_hints["chaos_var"])
            check_type(argname="argument density", value=density, expected_type=type_hints["density"])
            check_type(argname="argument density_var", value=density_var, expected_type=type_hints["density_var"])
            check_type(argname="argument power", value=power, expected_type=type_hints["power"])
            check_type(argname="argument power_var", value=power_var, expected_type=type_hints["power_var"])
            check_type(argname="argument seed", value=seed, expected_type=type_hints["seed"])
            check_type(argname="argument seed_var", value=seed_var, expected_type=type_hints["seed_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if chaos is not None:
            self._values["chaos"] = chaos
        if chaos_var is not None:
            self._values["chaos_var"] = chaos_var
        if density is not None:
            self._values["density"] = density
        if density_var is not None:
            self._values["density_var"] = density_var
        if power is not None:
            self._values["power"] = power
        if power_var is not None:
            self._values["power_var"] = power_var
        if seed is not None:
            self._values["seed"] = seed
        if seed_var is not None:
            self._values["seed_var"] = seed_var

    @builtins.property
    def chaos(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        '''
        result = self._values.get("chaos")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def chaos_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        '''
        result = self._values.get("chaos_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        '''
        result = self._values.get("density")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density_var(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        '''
        result = self._values.get("density_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        '''
        result = self._values.get("power")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power_var(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        '''
        result = self._values.get("power_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        '''
        result = self._values.get("seed")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed_var(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        result = self._values.get("seed_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareGoop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareGoopList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareGoopList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2c92dca9f5ac5292c44be70db795c213fa9b25b94c8f37b603e7ce376f60512b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareGoopOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__95efc5c3c0ba03b7edc31e37274ddf68505dfacf01d5309a79288b66e02377be)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareGoopOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4347d7e9e6947b673bb5b624e89e909fa9124e43f753448b3b23eea6e24250a2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0cde4cb039543e457f539362da0dbfc0fcb3cb2f0512ceaca25d3bcd427fbd31)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__edaa63c88544ac4ecff8fa561da8530cf02bc460e034fc69ae409425f69a3f2f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareGoop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareGoop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e33812682d03fc39b38998f430165aa9b72f83f000822cfee226abed7c6da231)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareGoopOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareGoopOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ea0cd5017d5565aff5f57bf77ebd067bc93ef7c25e84fe57698e08dc7c2442f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetChaos")
    def reset_chaos(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaos", []))

    @jsii.member(jsii_name="resetChaosVar")
    def reset_chaos_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaosVar", []))

    @jsii.member(jsii_name="resetDensity")
    def reset_density(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensity", []))

    @jsii.member(jsii_name="resetDensityVar")
    def reset_density_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensityVar", []))

    @jsii.member(jsii_name="resetPower")
    def reset_power(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPower", []))

    @jsii.member(jsii_name="resetPowerVar")
    def reset_power_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPowerVar", []))

    @jsii.member(jsii_name="resetSeed")
    def reset_seed(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeed", []))

    @jsii.member(jsii_name="resetSeedVar")
    def reset_seed_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeedVar", []))

    @builtins.property
    @jsii.member(jsii_name="chaosInput")
    def chaos_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosInput"))

    @builtins.property
    @jsii.member(jsii_name="chaosVarInput")
    def chaos_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosVarInput"))

    @builtins.property
    @jsii.member(jsii_name="densityInput")
    def density_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityInput"))

    @builtins.property
    @jsii.member(jsii_name="densityVarInput")
    def density_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="powerInput")
    def power_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerInput"))

    @builtins.property
    @jsii.member(jsii_name="powerVarInput")
    def power_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerVarInput"))

    @builtins.property
    @jsii.member(jsii_name="seedInput")
    def seed_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedInput"))

    @builtins.property
    @jsii.member(jsii_name="seedVarInput")
    def seed_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedVarInput"))

    @builtins.property
    @jsii.member(jsii_name="chaos")
    def chaos(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaos"))

    @chaos.setter
    def chaos(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6b50c91bf00384db6b43e0bba0571fceefd5670704cf05fa6f7cc9b906527b72)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaos", value)

    @builtins.property
    @jsii.member(jsii_name="chaosVar")
    def chaos_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaosVar"))

    @chaos_var.setter
    def chaos_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__854c42e6201fcc9afe8699e66df7f09743e4a1c34d5db41ee405d0dff940b96c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaosVar", value)

    @builtins.property
    @jsii.member(jsii_name="density")
    def density(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "density"))

    @density.setter
    def density(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4e67da75fb67d2301d7a426ddf0b3f06c37546d3977ae0c0315f9861417e73fd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "density", value)

    @builtins.property
    @jsii.member(jsii_name="densityVar")
    def density_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "densityVar"))

    @density_var.setter
    def density_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f22609be26ce89a8c209dfb6def3625c56520e63df568dc8b8105ce4be7b3123)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "densityVar", value)

    @builtins.property
    @jsii.member(jsii_name="power")
    def power(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "power"))

    @power.setter
    def power(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ec0ba734bbf9c7aefaf800f44fbd725d633d0c137f915ab046c990aefb3bff12)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "power", value)

    @builtins.property
    @jsii.member(jsii_name="powerVar")
    def power_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "powerVar"))

    @power_var.setter
    def power_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5b19e2ec8ba9e1234b25dd9fea1502a339ffe6303872c6d0ba43e0da901af31c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "powerVar", value)

    @builtins.property
    @jsii.member(jsii_name="seed")
    def seed(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seed"))

    @seed.setter
    def seed(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__27db9e40c6607b457dda5b7091a1c45ebf2e9b4dc69d55470d7a3d054d7dc8ac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seed", value)

    @builtins.property
    @jsii.member(jsii_name="seedVar")
    def seed_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seedVar"))

    @seed_var.setter
    def seed_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b2662948fae6711a6ff5555452edf00612355921583ebfe8d512a1d079a032c8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seedVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareGoop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareGoop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareGoop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aa8c9dcc6ae0b7e2bc9534801ec0847168b7e06fe8f8abd4e7677cb81ba3171f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareGrayscale",
    jsii_struct_bases=[],
    name_mapping={"type": "type", "type_var": "typeVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareGrayscale:
    def __init__(
        self,
        *,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param type: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__79872335b53707678c254160d17a283aa61c03ecebbe81778151f8ac6c64a463)
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareGrayscale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareGrayscaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareGrayscaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d078b2ce2bccdad2e134ce4fa85573bf51c06bcef4060be8f242d99341e30db1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareGrayscaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__11b721fc151aacfbfbf8d59348d927207416f2bd7f24aa2f8aca12a6dd8acab9)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareGrayscaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6fe0b15fe106fb9fa0ec7ee5d8ba110dd8b52fa4d1e2ef5cf9b07596e2494333)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__381a7e2a5fc7e9423db019dea3dbcee97f24097dd2512db9174520eb93f4f181)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__569d81571df0fd2f1bd1bce713d78e510b1048bf62bae92525361ead7813e3c3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareGrayscale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareGrayscale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4d1ab90bfcebc29ae560c8e233fac7b6426838fbda205624ed6ade78b54621ba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareGrayscaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareGrayscaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f957392396f3f9d3fefaae25d7076889c6bb97772ff3a769db9bc886264c9639)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a665d82046ea3aaef85f9f28beb0e0d0ff9bab2203003e6125accce26354c466)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6fc1105dc20567daa4c95701ed8004b86461a06535523c8873d3488cd48f96c3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareGrayscale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareGrayscale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareGrayscale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1ff9aac0ebd10492bca7a60e039c2b460bf08287bacf6e30e651a2e02618ef3f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareHsl",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "lightness": "lightness",
        "lightness_var": "lightnessVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareHsl:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness: typing.Optional[builtins.str] = None,
        lightness_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        :param lightness_var: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__efeabbfc7aca7d6362319c07a53d6195c0dd7bed29072d7ae98ea3d0b5014380)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness", value=lightness, expected_type=type_hints["lightness"])
            check_type(argname="argument lightness_var", value=lightness_var, expected_type=type_hints["lightness_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness is not None:
            self._values["lightness"] = lightness
        if lightness_var is not None:
            self._values["lightness_var"] = lightness_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        '''
        result = self._values.get("lightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        '''
        result = self._values.get("lightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareHsl(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareHslList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareHslList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b0a13e73c79448fbcf459ac093c251f037c352e06a9a7ab07c215e141538f3b8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareHslOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab208f69bdae7e66b040eaed3520f62b5fe5ea40a35eefdcd562e96acb9c15fd)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareHslOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__80c9629652430140992a544a2a01557988da12409ff6ee105ddcf090849861f3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c6ab631c263f30c006717235f77c5ec9bd9e5c29ea31da94e462624e35bf21b8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__13fedd1e8607f59f51cad00c8ba6f811c5980856a69eee50c4e53c05eecef115)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareHsl]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareHsl]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__298197f26e5efad660f07eb6baafa17a6e396deeab922429144e881c62bf1783)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareHslOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareHslOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__41c397a521012b5d0c45eb07024de29caabce8bb3b971ca1094938bbc02d300f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightness")
    def reset_lightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightness", []))

    @jsii.member(jsii_name="resetLightnessVar")
    def reset_lightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessInput")
    def lightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessVarInput")
    def lightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d870f6f4b8f0c15e21f867751a21c20616772a13f13c149917f2a929e5d4ab1d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3938e717cb97647b9726453dad1c28ed2693875f92cbdb89deee9d531774bc08)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightness")
    def lightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightness"))

    @lightness.setter
    def lightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1b22305f91cbe35505b02a47766c9a31fd934f716b4f05e8e04d33fc967493f9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightness", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessVar")
    def lightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessVar"))

    @lightness_var.setter
    def lightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9896ce1353a9a2b8b55867745bf10df2d5d59c3eed6fc87fc0dc9df3e8870405)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__45bfc447c0981749aa0e28f655e0d91ea15421a03939b543a4dfffe7ad07bbc5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b4766a49d53c1b3ee7d1545e599cbb1dc8fd2b199395ada290ad609a67f24002)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareHsl]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareHsl]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareHsl]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1da6047d5dfce43208878e176435859ac71534ecd1a959df008c67d7831cbb3b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareHsv",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareHsv:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        :param value: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__da7f0c56348ae8dd3e65b85f793d6979f79b3c6f992ddcc6c0072ba7785dcdb6)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareHsv(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareHsvList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareHsvList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8b0d4f557193285f37ee9b89ffa573ddeba256d5e76611da06abc59a1543355c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareHsvOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ed2e8ae002e99b731c3189f604acdfdf52960f1b509711f6ea5631500de007da)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareHsvOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ca78843699083d265335e07d3d11a47c376dda6d688e6c6dfa280eb5d241e500)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__28c36c841765c83082917bb5c9551070071e567e29487b25c1cb4b308c6341fc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c7950baaa0bad1e3594bb4f4f0cc1b644b6db4833114d6a66388c587003e0a90)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareHsv]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareHsv]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__62c521f7b169345c0b678877ff7fecd8cde4f9d77d5b8b2d706c6cabfa9c01f4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareHsvOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareHsvOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0aec172ea7ea687a1950affd4c26faad823ac80f79b24ae199478298f104297c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d4720844e83bbfbc1db0fe0d795deda541a78fddf50738c6a049de880abe0f93)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1aad4387c0a2aa7dfd0d3ed7d536bcdaae98042048264ef39dd481e5d594a402)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3c49850ae7d8be928ea1cf43c28dce13e81eadd0883cd11d42b2f0c042841816)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a84ec4a2e761e289f56ea137aad47f7c8b732547f0dee514e0f862fb6e680ad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fc4a3b6e2e268070631343606f084a07811ef064a9ac4de09981366bdde84131)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a9671d7df7b2df8f9648ef110a5fde5884ee55f6d6d0f42311e86e74e637d677)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareHsv]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareHsv]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareHsv]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__241bbf7bcb6fe9c0738af6993b57b90201c408135ec9e64b7393679d4aa5d133)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimension",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "dimension": "dimension",
        "dimension_var": "dimensionVar",
        "equal": "equal",
        "greater_than": "greaterThan",
        "less_than": "lessThan",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimension:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        dimension: typing.Optional[builtins.str] = None,
        dimension_var: typing.Optional[builtins.str] = None,
        equal: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqual", typing.Dict[builtins.str, typing.Any]]] = None,
        greater_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThan", typing.Dict[builtins.str, typing.Any]]] = None,
        less_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThan", typing.Dict[builtins.str, typing.Any]]] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param dimension: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        :param dimension_var: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        :param equal: equal block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        :param greater_than: greater_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        :param less_than: less_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        :param value: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefault(**default)
        if isinstance(equal, dict):
            equal = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqual(**equal)
        if isinstance(greater_than, dict):
            greater_than = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThan(**greater_than)
        if isinstance(less_than, dict):
            less_than = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThan(**less_than)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1819ffbd583bbaeb01ca466f7925cb1d5ee636dd998cacf346e37c473b4edf4c)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument dimension", value=dimension, expected_type=type_hints["dimension"])
            check_type(argname="argument dimension_var", value=dimension_var, expected_type=type_hints["dimension_var"])
            check_type(argname="argument equal", value=equal, expected_type=type_hints["equal"])
            check_type(argname="argument greater_than", value=greater_than, expected_type=type_hints["greater_than"])
            check_type(argname="argument less_than", value=less_than, expected_type=type_hints["less_than"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if dimension is not None:
            self._values["dimension"] = dimension
        if dimension_var is not None:
            self._values["dimension_var"] = dimension_var
        if equal is not None:
            self._values["equal"] = equal
        if greater_than is not None:
            self._values["greater_than"] = greater_than
        if less_than is not None:
            self._values["less_than"] = less_than
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefault"], result)

    @builtins.property
    def dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        '''
        result = self._values.get("dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        '''
        result = self._values.get("dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def equal(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqual"]:
        '''equal block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        '''
        result = self._values.get("equal")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqual"], result)

    @builtins.property
    def greater_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThan"]:
        '''greater_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        '''
        result = self._values.get("greater_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThan"], result)

    @builtins.property
    def less_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThan"]:
        '''less_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        '''
        result = self._values.get("less_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThan"], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimension(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefault",
    jsii_struct_bases=[],
    name_mapping={
        "append": "append",
        "aspect_crop": "aspectCrop",
        "background_color": "backgroundColor",
        "blur": "blur",
        "chroma_key": "chromaKey",
        "composite": "composite",
        "compound": "compound",
        "contrast": "contrast",
        "crop": "crop",
        "face_crop": "faceCrop",
        "feature_crop": "featureCrop",
        "fit_and_fill": "fitAndFill",
        "goop": "goop",
        "grayscale": "grayscale",
        "hsl": "hsl",
        "hsv": "hsv",
        "if_dimension": "ifDimension",
        "if_orientation": "ifOrientation",
        "im_query": "imQuery",
        "max_colors": "maxColors",
        "mirror": "mirror",
        "mono_hue": "monoHue",
        "opacity": "opacity",
        "region_of_interest_crop": "regionOfInterestCrop",
        "relative_crop": "relativeCrop",
        "remove_color": "removeColor",
        "resize": "resize",
        "rotate": "rotate",
        "scale": "scale",
        "shear": "shear",
        "trim": "trim",
        "unsharp_mask": "unsharpMask",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefault:
    def __init__(
        self,
        *,
        append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultAppend", typing.Dict[builtins.str, typing.Any]]]]] = None,
        aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultAspectCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultBackgroundColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultBlur", typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultChromaKey", typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultComposite", typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultCompound", typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultContrast", typing.Dict[builtins.str, typing.Any]]]]] = None,
        crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultFaceCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultFeatureCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultFitAndFill", typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultGoop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultGrayscale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultHsl", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultHsv", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfDimension", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfOrientation", typing.Dict[builtins.str, typing.Any]]]]] = None,
        im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultImQuery", typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultMaxColors", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultMirror", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultMonoHue", typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultOpacity", typing.Dict[builtins.str, typing.Any]]]]] = None,
        region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultRegionOfInterestCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultRelativeCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultRemoveColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultResize", typing.Dict[builtins.str, typing.Any]]]]] = None,
        rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultRotate", typing.Dict[builtins.str, typing.Any]]]]] = None,
        scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultScale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultShear", typing.Dict[builtins.str, typing.Any]]]]] = None,
        trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultTrim", typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultUnsharpMask", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param append: append block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        :param aspect_crop: aspect_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param crop: crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        :param face_crop: face_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        :param feature_crop: feature_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        :param fit_and_fill: fit_and_fill block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param im_query: im_query block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param region_of_interest_crop: region_of_interest_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        :param relative_crop: relative_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param resize: resize block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        :param rotate: rotate block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        :param scale: scale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param shear: shear block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        :param trim: trim block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e577ee19f41b8ce5fe09a394bac0f3c9cd7e8b655e744b1dcdb51482405220a4)
            check_type(argname="argument append", value=append, expected_type=type_hints["append"])
            check_type(argname="argument aspect_crop", value=aspect_crop, expected_type=type_hints["aspect_crop"])
            check_type(argname="argument background_color", value=background_color, expected_type=type_hints["background_color"])
            check_type(argname="argument blur", value=blur, expected_type=type_hints["blur"])
            check_type(argname="argument chroma_key", value=chroma_key, expected_type=type_hints["chroma_key"])
            check_type(argname="argument composite", value=composite, expected_type=type_hints["composite"])
            check_type(argname="argument compound", value=compound, expected_type=type_hints["compound"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument crop", value=crop, expected_type=type_hints["crop"])
            check_type(argname="argument face_crop", value=face_crop, expected_type=type_hints["face_crop"])
            check_type(argname="argument feature_crop", value=feature_crop, expected_type=type_hints["feature_crop"])
            check_type(argname="argument fit_and_fill", value=fit_and_fill, expected_type=type_hints["fit_and_fill"])
            check_type(argname="argument goop", value=goop, expected_type=type_hints["goop"])
            check_type(argname="argument grayscale", value=grayscale, expected_type=type_hints["grayscale"])
            check_type(argname="argument hsl", value=hsl, expected_type=type_hints["hsl"])
            check_type(argname="argument hsv", value=hsv, expected_type=type_hints["hsv"])
            check_type(argname="argument if_dimension", value=if_dimension, expected_type=type_hints["if_dimension"])
            check_type(argname="argument if_orientation", value=if_orientation, expected_type=type_hints["if_orientation"])
            check_type(argname="argument im_query", value=im_query, expected_type=type_hints["im_query"])
            check_type(argname="argument max_colors", value=max_colors, expected_type=type_hints["max_colors"])
            check_type(argname="argument mirror", value=mirror, expected_type=type_hints["mirror"])
            check_type(argname="argument mono_hue", value=mono_hue, expected_type=type_hints["mono_hue"])
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument region_of_interest_crop", value=region_of_interest_crop, expected_type=type_hints["region_of_interest_crop"])
            check_type(argname="argument relative_crop", value=relative_crop, expected_type=type_hints["relative_crop"])
            check_type(argname="argument remove_color", value=remove_color, expected_type=type_hints["remove_color"])
            check_type(argname="argument resize", value=resize, expected_type=type_hints["resize"])
            check_type(argname="argument rotate", value=rotate, expected_type=type_hints["rotate"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument shear", value=shear, expected_type=type_hints["shear"])
            check_type(argname="argument trim", value=trim, expected_type=type_hints["trim"])
            check_type(argname="argument unsharp_mask", value=unsharp_mask, expected_type=type_hints["unsharp_mask"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if append is not None:
            self._values["append"] = append
        if aspect_crop is not None:
            self._values["aspect_crop"] = aspect_crop
        if background_color is not None:
            self._values["background_color"] = background_color
        if blur is not None:
            self._values["blur"] = blur
        if chroma_key is not None:
            self._values["chroma_key"] = chroma_key
        if composite is not None:
            self._values["composite"] = composite
        if compound is not None:
            self._values["compound"] = compound
        if contrast is not None:
            self._values["contrast"] = contrast
        if crop is not None:
            self._values["crop"] = crop
        if face_crop is not None:
            self._values["face_crop"] = face_crop
        if feature_crop is not None:
            self._values["feature_crop"] = feature_crop
        if fit_and_fill is not None:
            self._values["fit_and_fill"] = fit_and_fill
        if goop is not None:
            self._values["goop"] = goop
        if grayscale is not None:
            self._values["grayscale"] = grayscale
        if hsl is not None:
            self._values["hsl"] = hsl
        if hsv is not None:
            self._values["hsv"] = hsv
        if if_dimension is not None:
            self._values["if_dimension"] = if_dimension
        if if_orientation is not None:
            self._values["if_orientation"] = if_orientation
        if im_query is not None:
            self._values["im_query"] = im_query
        if max_colors is not None:
            self._values["max_colors"] = max_colors
        if mirror is not None:
            self._values["mirror"] = mirror
        if mono_hue is not None:
            self._values["mono_hue"] = mono_hue
        if opacity is not None:
            self._values["opacity"] = opacity
        if region_of_interest_crop is not None:
            self._values["region_of_interest_crop"] = region_of_interest_crop
        if relative_crop is not None:
            self._values["relative_crop"] = relative_crop
        if remove_color is not None:
            self._values["remove_color"] = remove_color
        if resize is not None:
            self._values["resize"] = resize
        if rotate is not None:
            self._values["rotate"] = rotate
        if scale is not None:
            self._values["scale"] = scale
        if shear is not None:
            self._values["shear"] = shear
        if trim is not None:
            self._values["trim"] = trim
        if unsharp_mask is not None:
            self._values["unsharp_mask"] = unsharp_mask

    @builtins.property
    def append(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultAppend"]]]:
        '''append block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        '''
        result = self._values.get("append")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultAppend"]]], result)

    @builtins.property
    def aspect_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultAspectCrop"]]]:
        '''aspect_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        '''
        result = self._values.get("aspect_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultAspectCrop"]]], result)

    @builtins.property
    def background_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultBackgroundColor"]]]:
        '''background_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        '''
        result = self._values.get("background_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultBackgroundColor"]]], result)

    @builtins.property
    def blur(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultBlur"]]]:
        '''blur block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        '''
        result = self._values.get("blur")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultBlur"]]], result)

    @builtins.property
    def chroma_key(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultChromaKey"]]]:
        '''chroma_key block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        '''
        result = self._values.get("chroma_key")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultChromaKey"]]], result)

    @builtins.property
    def composite(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultComposite"]]]:
        '''composite block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        '''
        result = self._values.get("composite")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultComposite"]]], result)

    @builtins.property
    def compound(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultCompound"]]]:
        '''compound block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        '''
        result = self._values.get("compound")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultCompound"]]], result)

    @builtins.property
    def contrast(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultContrast"]]]:
        '''contrast block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultContrast"]]], result)

    @builtins.property
    def crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultCrop"]]]:
        '''crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        '''
        result = self._values.get("crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultCrop"]]], result)

    @builtins.property
    def face_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultFaceCrop"]]]:
        '''face_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        '''
        result = self._values.get("face_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultFaceCrop"]]], result)

    @builtins.property
    def feature_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultFeatureCrop"]]]:
        '''feature_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        '''
        result = self._values.get("feature_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultFeatureCrop"]]], result)

    @builtins.property
    def fit_and_fill(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultFitAndFill"]]]:
        '''fit_and_fill block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        '''
        result = self._values.get("fit_and_fill")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultFitAndFill"]]], result)

    @builtins.property
    def goop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultGoop"]]]:
        '''goop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        '''
        result = self._values.get("goop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultGoop"]]], result)

    @builtins.property
    def grayscale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultGrayscale"]]]:
        '''grayscale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        '''
        result = self._values.get("grayscale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultGrayscale"]]], result)

    @builtins.property
    def hsl(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultHsl"]]]:
        '''hsl block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        '''
        result = self._values.get("hsl")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultHsl"]]], result)

    @builtins.property
    def hsv(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultHsv"]]]:
        '''hsv block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        '''
        result = self._values.get("hsv")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultHsv"]]], result)

    @builtins.property
    def if_dimension(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfDimension"]]]:
        '''if_dimension block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        '''
        result = self._values.get("if_dimension")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfDimension"]]], result)

    @builtins.property
    def if_orientation(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfOrientation"]]]:
        '''if_orientation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        '''
        result = self._values.get("if_orientation")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfOrientation"]]], result)

    @builtins.property
    def im_query(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultImQuery"]]]:
        '''im_query block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        '''
        result = self._values.get("im_query")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultImQuery"]]], result)

    @builtins.property
    def max_colors(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultMaxColors"]]]:
        '''max_colors block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        '''
        result = self._values.get("max_colors")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultMaxColors"]]], result)

    @builtins.property
    def mirror(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultMirror"]]]:
        '''mirror block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        '''
        result = self._values.get("mirror")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultMirror"]]], result)

    @builtins.property
    def mono_hue(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultMonoHue"]]]:
        '''mono_hue block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        '''
        result = self._values.get("mono_hue")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultMonoHue"]]], result)

    @builtins.property
    def opacity(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultOpacity"]]]:
        '''opacity block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultOpacity"]]], result)

    @builtins.property
    def region_of_interest_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultRegionOfInterestCrop"]]]:
        '''region_of_interest_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        '''
        result = self._values.get("region_of_interest_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultRegionOfInterestCrop"]]], result)

    @builtins.property
    def relative_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultRelativeCrop"]]]:
        '''relative_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        '''
        result = self._values.get("relative_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultRelativeCrop"]]], result)

    @builtins.property
    def remove_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultRemoveColor"]]]:
        '''remove_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        '''
        result = self._values.get("remove_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultRemoveColor"]]], result)

    @builtins.property
    def resize(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultResize"]]]:
        '''resize block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        '''
        result = self._values.get("resize")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultResize"]]], result)

    @builtins.property
    def rotate(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultRotate"]]]:
        '''rotate block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        '''
        result = self._values.get("rotate")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultRotate"]]], result)

    @builtins.property
    def scale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultScale"]]]:
        '''scale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultScale"]]], result)

    @builtins.property
    def shear(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultShear"]]]:
        '''shear block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        '''
        result = self._values.get("shear")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultShear"]]], result)

    @builtins.property
    def trim(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultTrim"]]]:
        '''trim block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        '''
        result = self._values.get("trim")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultTrim"]]], result)

    @builtins.property
    def unsharp_mask(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultUnsharpMask"]]]:
        '''unsharp_mask block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        result = self._values.get("unsharp_mask")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultUnsharpMask"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultAppend",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_priority": "gravityPriority",
        "gravity_priority_var": "gravityPriorityVar",
        "gravity_var": "gravityVar",
        "preserve_minor_dimension": "preserveMinorDimension",
        "preserve_minor_dimension_var": "preserveMinorDimensionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultAppend:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultAppendImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_priority: typing.Optional[builtins.str] = None,
        gravity_priority_var: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        preserve_minor_dimension: typing.Optional[builtins.str] = None,
        preserve_minor_dimension_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Specifies where to place the ``image`` relative to the source image. The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_priority: Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal. The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority DataAkamaiImagingPolicyImage#gravity_priority}
        :param gravity_priority_var: Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal. The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority_var DataAkamaiImagingPolicyImage#gravity_priority_var}
        :param gravity_var: Specifies where to place the ``image`` relative to the source image. The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param preserve_minor_dimension: Whether to preserve the source image's minor dimension, ``false`` by default. The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension DataAkamaiImagingPolicyImage#preserve_minor_dimension}
        :param preserve_minor_dimension_var: Whether to preserve the source image's minor dimension, ``false`` by default. The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension_var DataAkamaiImagingPolicyImage#preserve_minor_dimension_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultAppendImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__194c9414d4e2f37b80f3ccf3bde6bb4f318fe0bc1620de522f71b4c280aca9d9)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_priority", value=gravity_priority, expected_type=type_hints["gravity_priority"])
            check_type(argname="argument gravity_priority_var", value=gravity_priority_var, expected_type=type_hints["gravity_priority_var"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument preserve_minor_dimension", value=preserve_minor_dimension, expected_type=type_hints["preserve_minor_dimension"])
            check_type(argname="argument preserve_minor_dimension_var", value=preserve_minor_dimension_var, expected_type=type_hints["preserve_minor_dimension_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_priority is not None:
            self._values["gravity_priority"] = gravity_priority
        if gravity_priority_var is not None:
            self._values["gravity_priority_var"] = gravity_priority_var
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if preserve_minor_dimension is not None:
            self._values["preserve_minor_dimension"] = preserve_minor_dimension
        if preserve_minor_dimension_var is not None:
            self._values["preserve_minor_dimension_var"] = preserve_minor_dimension_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultAppendImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultAppendImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Specifies where to place the ``image`` relative to the source image.

        The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_priority(self) -> typing.Optional[builtins.str]:
        '''Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal.

        The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority DataAkamaiImagingPolicyImage#gravity_priority}
        '''
        result = self._values.get("gravity_priority")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_priority_var(self) -> typing.Optional[builtins.str]:
        '''Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal.

        The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority_var DataAkamaiImagingPolicyImage#gravity_priority_var}
        '''
        result = self._values.get("gravity_priority_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Specifies where to place the ``image`` relative to the source image.

        The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def preserve_minor_dimension(self) -> typing.Optional[builtins.str]:
        '''Whether to preserve the source image's minor dimension, ``false`` by default.

        The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension DataAkamaiImagingPolicyImage#preserve_minor_dimension}
        '''
        result = self._values.get("preserve_minor_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def preserve_minor_dimension_var(self) -> typing.Optional[builtins.str]:
        '''Whether to preserve the source image's minor dimension, ``false`` by default.

        The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension_var DataAkamaiImagingPolicyImage#preserve_minor_dimension_var}
        '''
        result = self._values.get("preserve_minor_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultAppend(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultAppendImage",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultAppendImage:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultAppendImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultAppendImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultAppendImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3dd08dd7a45f0673efd3a51596f12b5a6dbd659c314d79fd5b6536ee7a2067a9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultAppendImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultAppendImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultAppendImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__93ca220900cc1a820aaf5b87b8486a1c0f60ee6446403a15e1a423db018bf653)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultAppendList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultAppendList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b0b6a4c043902adf4b65ef3465625de04e3bf3064964ae7759f3f9035d56fce9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultAppendOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9df104e44979dabcfabb7b10677b254247b8e3e12d047719ed10b18d88caba1f)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultAppendOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a3d7b25fb93c57c85b59d3125c5fe7f6f9614a9464fefcc562e0b590ae8953e8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dca52d0b3c7c8e594627434f4c98acdba6a3cf84207214c5d68ef84ed1bf0c96)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__db3448c99ebd303e4d5fa26f60eebbd4ede80d7d993a15749f3c3153a495a1da)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultAppend]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultAppend]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultAppend]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dbe430681e72879618fbb8b6aab6f1663360577d4d55b27325a658bb46e992be)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultAppendOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultAppendOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dfc58a56e5130034b0155cc9347dcf77ef1b536c3bf467ecb405b29ea4289919)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultAppendImage()

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityPriority")
    def reset_gravity_priority(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityPriority", []))

    @jsii.member(jsii_name="resetGravityPriorityVar")
    def reset_gravity_priority_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityPriorityVar", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPreserveMinorDimension")
    def reset_preserve_minor_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPreserveMinorDimension", []))

    @jsii.member(jsii_name="resetPreserveMinorDimensionVar")
    def reset_preserve_minor_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPreserveMinorDimensionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultAppendImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultAppendImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityInput")
    def gravity_priority_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityPriorityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityVarInput")
    def gravity_priority_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityPriorityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultAppendImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultAppendImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionInput")
    def preserve_minor_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "preserveMinorDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionVarInput")
    def preserve_minor_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "preserveMinorDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bfe84f892db1af551d00306a4422cdb5cd8b2f759b02965d6074c75b2867c185)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityPriority")
    def gravity_priority(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityPriority"))

    @gravity_priority.setter
    def gravity_priority(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d07e30ac9d66511bfacf9a1782053e57321a86e0c3a0b21857229ad62c7983f0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityPriority", value)

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityVar")
    def gravity_priority_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityPriorityVar"))

    @gravity_priority_var.setter
    def gravity_priority_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a05263fc2b465220d840492b80a6029183f3a45e82d58540978502c8e6070da8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityPriorityVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d39e153a708fa0f9185561c3e14bb649af2bf49ac8746e7f78d05656d646c9bb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimension")
    def preserve_minor_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "preserveMinorDimension"))

    @preserve_minor_dimension.setter
    def preserve_minor_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__552c87ae30cb5176eb68d6f5778a467fe5bceaf6ceecb3b9fbf507c608fc9b76)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "preserveMinorDimension", value)

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionVar")
    def preserve_minor_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "preserveMinorDimensionVar"))

    @preserve_minor_dimension_var.setter
    def preserve_minor_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a1b56453631430710ac3ff6ecbc9759a29b673f9dc8cd41d57f3d5644999b5ec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "preserveMinorDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultAppend]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultAppend]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultAppend]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f0bc2fc52555b56b1aec290b135e21e628febce6b8e0773764a397fae385ff6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultAspectCrop",
    jsii_struct_bases=[],
    name_mapping={
        "allow_expansion": "allowExpansion",
        "allow_expansion_var": "allowExpansionVar",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultAspectCrop:
    def __init__(
        self,
        *,
        allow_expansion: typing.Optional[builtins.str] = None,
        allow_expansion_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_expansion: Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image. Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        :param allow_expansion_var: Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image. Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        :param height: The height term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The width term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        :param x_position: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__029560b8ea1e87bdfa9eb2958fbb71ea73782989e547504557b78c6ef617e685)
            check_type(argname="argument allow_expansion", value=allow_expansion, expected_type=type_hints["allow_expansion"])
            check_type(argname="argument allow_expansion_var", value=allow_expansion_var, expected_type=type_hints["allow_expansion_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if allow_expansion is not None:
            self._values["allow_expansion"] = allow_expansion
        if allow_expansion_var is not None:
            self._values["allow_expansion_var"] = allow_expansion_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def allow_expansion(self) -> typing.Optional[builtins.str]:
        '''Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image.

        Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        '''
        result = self._values.get("allow_expansion")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def allow_expansion_var(self) -> typing.Optional[builtins.str]:
        '''Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image.

        Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        '''
        result = self._values.get("allow_expansion_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultAspectCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultAspectCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultAspectCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__727d2e823d415c7e95e1ab8f1765c512a8ed9e0544424f806eb60f64c8bd0139)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultAspectCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b79a602848b8c2f3a02c6a21033e31cd9aa0996c3f175aa2afd05a29da95dc0d)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultAspectCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8c67fe7a7f9835dfd29aa513f9736ce9e5f2f1ccf5675105b487a79eecb43270)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__98f38114695cebcee50163c5469cc79a40544571783d416073e75a03f51dc7a9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c540ce869afa699f55ad696574fa3ddd79fc9cadd435fa5a83752abf3c50a26c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultAspectCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultAspectCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultAspectCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb0d0098e91b69b793b8279d0401310f6ba97f91292ba818cd6a4a75fb4c03be)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultAspectCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultAspectCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d5b1969761f06dd593ecdf1976a0976be35816ad8c5b0d7b930323a0039cee6a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAllowExpansion")
    def reset_allow_expansion(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansion", []))

    @jsii.member(jsii_name="resetAllowExpansionVar")
    def reset_allow_expansion_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansionVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionInput")
    def allow_expansion_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVarInput")
    def allow_expansion_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansion")
    def allow_expansion(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansion"))

    @allow_expansion.setter
    def allow_expansion(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9be181d4d8342a17d04f8245a7b3c1f89351d92358ffd06cdab041d7d6bbb124)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansion", value)

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVar")
    def allow_expansion_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansionVar"))

    @allow_expansion_var.setter
    def allow_expansion_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__644e833308693ecfbca54bfdfcf8cae7c6f75240d2355a7f4a36b8e879c08c8b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansionVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__da7148608f63fba174b0a45d68bc76e17fc87243300c10c4002a6a0df4a3458d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0a0e13d1575c0042ec1d463c6de86ad10da9352d6e016815feb9c814d95f140e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0094aa3882002d6a276bdd2d15d61e482cf5a71894a633964d3d8377e634419e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ebfeb5709ff1ad2ca36e18cc1dd4bddf2e7b1526576e246427e37a4a9209e6c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5e99ac99f176aefe50e95f80adedc6adce13fc258971a1f03efea3a8bd0fed5c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ed608e0cacc43c7327a9979c069552e39ec7909c2d5904d88a9de3ca1dbb23f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a0efe704b18fdea08ec53a6251780b3802ba682e6ac5988410171aea9a5874a2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b4d6d234b23ccebc73bb650bf12aa97636bcacc9738cb132075c1dc4072508bf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultAspectCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultAspectCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultAspectCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a225393a80c1d14642d4eaa54057056e9783289f8b50e57778e96e776ba088f3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultBackgroundColor",
    jsii_struct_bases=[],
    name_mapping={"color": "color", "color_var": "colorVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultBackgroundColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f7167392c0318343fbb4c5c04ef3bd937fdb57536ad4e3479229d782f50e29fb)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultBackgroundColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultBackgroundColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultBackgroundColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f25acc02959cddfa868d7a2bfdb35c1113a2e5a73517556fbac7ba63b425615b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultBackgroundColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2b613e5ff684777e847fdc9424621a23290e83d2b001fab8c2373a725136d794)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultBackgroundColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__81842f387257f9fa39d0415c29cb88a6ac3b8a3819abfe9e8887de62c40b1394)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fec52542946497d4da30b9348b0fbec641247ec458a65942eeba32b12e56df4b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3fbe5572675b4da35f918c27a0e621e9d2731c57959911b811c16578c3fb081c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultBackgroundColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultBackgroundColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__720a16cfb3f6c7c9422e1d8765e9374514e4fbf6e9cc6935045dde4022cce964)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultBackgroundColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultBackgroundColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b1435999329aa93fc3202a718cc3c1e7b435dbaf82585fde3f772da441ca48d5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__557deee56400b13f553da84a878cb1bf91f553ec6aac2b548ebb778361045f01)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__19907c194f86c3794d7a774eb991f8bde541417637494b785513210d1d597dda)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultBackgroundColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultBackgroundColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultBackgroundColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d2f5e5558afba1ca4ec5a2b8db2b782927d946c8d348478dcc3903afbfcd831)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultBlur",
    jsii_struct_bases=[],
    name_mapping={"sigma": "sigma", "sigma_var": "sigmaVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultBlur:
    def __init__(
        self,
        *,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param sigma: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0c183e5e4094cfb767ddd6f44fb6bbd93796ca1694acc17f77a19979a8061584)
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultBlur(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultBlurList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultBlurList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__29461679c938937f4792da07327e74f473e2daac4690cae1874b348aabff35cf)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultBlurOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d266d41acab49d4a5665b916282cc93c87d2f7e3b998dfe66cdb83ae4b378a79)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultBlurOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e30307ce6ee8e606cc073c9203ce6fb68b09ef92c1844b8732e3979f7c06d2f9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__45006c0c93ba62231bf2b4882ea61befa3523111d71227f575c304442b3b9712)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__07f43c8602bdad634ca26d52b7cc8fa2c7b6f56fb8f40cbd4e7322df45368847)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultBlur]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultBlur]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a593122b1d95ad55d27f72e49d22948704fed72e6a0d4e5451e0002eb459bb10)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultBlurOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultBlurOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c7226ac1c5d79f36536d247a9d3c70f7e68bf1ba7341871fed762593800b97ca)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__37902f7f89b6a85eb8e78899235b8a2d571a60d4db32fe7a674ec9a0a21b05e3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fe57f6898360239d41a844600a3c1a976fd573da8e55f84ec680cd3715d02bee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultBlur]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultBlur]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultBlur]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d13a154c65376c16d18eb21d3bcc0df39428b9136f9072f2c3641a1b64e27419)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultChromaKey",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_feather": "hueFeather",
        "hue_feather_var": "hueFeatherVar",
        "hue_tolerance": "hueTolerance",
        "hue_tolerance_var": "hueToleranceVar",
        "hue_var": "hueVar",
        "lightness_feather": "lightnessFeather",
        "lightness_feather_var": "lightnessFeatherVar",
        "lightness_tolerance": "lightnessTolerance",
        "lightness_tolerance_var": "lightnessToleranceVar",
        "saturation_feather": "saturationFeather",
        "saturation_feather_var": "saturationFeatherVar",
        "saturation_tolerance": "saturationTolerance",
        "saturation_tolerance_var": "saturationToleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultChromaKey:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_feather: typing.Optional[builtins.str] = None,
        hue_feather_var: typing.Optional[builtins.str] = None,
        hue_tolerance: typing.Optional[builtins.str] = None,
        hue_tolerance_var: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness_feather: typing.Optional[builtins.str] = None,
        lightness_feather_var: typing.Optional[builtins.str] = None,
        lightness_tolerance: typing.Optional[builtins.str] = None,
        lightness_tolerance_var: typing.Optional[builtins.str] = None,
        saturation_feather: typing.Optional[builtins.str] = None,
        saturation_feather_var: typing.Optional[builtins.str] = None,
        saturation_tolerance: typing.Optional[builtins.str] = None,
        saturation_tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_feather: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        :param hue_feather_var: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        :param hue_tolerance: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        :param hue_tolerance_var: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        :param hue_var: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness_feather: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        :param lightness_feather_var: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        :param lightness_tolerance: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        :param lightness_tolerance_var: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        :param saturation_feather: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        :param saturation_feather_var: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        :param saturation_tolerance: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        :param saturation_tolerance_var: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4f9ad2d44c01882d96db99341bbfd479a4d4364eb6b7ebf06c9b23b68584f8b8)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_feather", value=hue_feather, expected_type=type_hints["hue_feather"])
            check_type(argname="argument hue_feather_var", value=hue_feather_var, expected_type=type_hints["hue_feather_var"])
            check_type(argname="argument hue_tolerance", value=hue_tolerance, expected_type=type_hints["hue_tolerance"])
            check_type(argname="argument hue_tolerance_var", value=hue_tolerance_var, expected_type=type_hints["hue_tolerance_var"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness_feather", value=lightness_feather, expected_type=type_hints["lightness_feather"])
            check_type(argname="argument lightness_feather_var", value=lightness_feather_var, expected_type=type_hints["lightness_feather_var"])
            check_type(argname="argument lightness_tolerance", value=lightness_tolerance, expected_type=type_hints["lightness_tolerance"])
            check_type(argname="argument lightness_tolerance_var", value=lightness_tolerance_var, expected_type=type_hints["lightness_tolerance_var"])
            check_type(argname="argument saturation_feather", value=saturation_feather, expected_type=type_hints["saturation_feather"])
            check_type(argname="argument saturation_feather_var", value=saturation_feather_var, expected_type=type_hints["saturation_feather_var"])
            check_type(argname="argument saturation_tolerance", value=saturation_tolerance, expected_type=type_hints["saturation_tolerance"])
            check_type(argname="argument saturation_tolerance_var", value=saturation_tolerance_var, expected_type=type_hints["saturation_tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_feather is not None:
            self._values["hue_feather"] = hue_feather
        if hue_feather_var is not None:
            self._values["hue_feather_var"] = hue_feather_var
        if hue_tolerance is not None:
            self._values["hue_tolerance"] = hue_tolerance
        if hue_tolerance_var is not None:
            self._values["hue_tolerance_var"] = hue_tolerance_var
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness_feather is not None:
            self._values["lightness_feather"] = lightness_feather
        if lightness_feather_var is not None:
            self._values["lightness_feather_var"] = lightness_feather_var
        if lightness_tolerance is not None:
            self._values["lightness_tolerance"] = lightness_tolerance
        if lightness_tolerance_var is not None:
            self._values["lightness_tolerance_var"] = lightness_tolerance_var
        if saturation_feather is not None:
            self._values["saturation_feather"] = saturation_feather
        if saturation_feather_var is not None:
            self._values["saturation_feather_var"] = saturation_feather_var
        if saturation_tolerance is not None:
            self._values["saturation_tolerance"] = saturation_tolerance
        if saturation_tolerance_var is not None:
            self._values["saturation_tolerance_var"] = saturation_tolerance_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        '''
        result = self._values.get("hue_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        '''
        result = self._values.get("hue_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        '''
        result = self._values.get("hue_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        '''
        result = self._values.get("hue_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        '''
        result = self._values.get("lightness_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        '''
        result = self._values.get("lightness_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        '''
        result = self._values.get("lightness_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        '''
        result = self._values.get("lightness_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        '''
        result = self._values.get("saturation_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        '''
        result = self._values.get("saturation_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        '''
        result = self._values.get("saturation_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        result = self._values.get("saturation_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultChromaKey(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultChromaKeyList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultChromaKeyList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ba33123dff0cac4955aa882a1ef864244ee156be83b9e246b3d7a422f80c2505)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultChromaKeyOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a03f9c3e256e524e0e74e0613298bef8eaf5edb621ceadd0fa549b893d1df845)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultChromaKeyOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c2268630e34b4c0e63234ef8e770f544b1e03dc84cbad4b608f106bcc3204030)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__52adc612350df64bfb1cdaff3487051bb43826912c18ecf5238f9c0f03714dcf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f59384acfd85e1b782b6f43667acbf90c81a427ecacc3b42fd56aead29f15850)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultChromaKey]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultChromaKey]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7ecb60a5ce255fcd80c194b50e28a9e3199603b08e1cc164f2848cd896bfc288)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultChromaKeyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultChromaKeyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f504e2499d71e49ef6ea94576403dd87b15a0aa968bf8e63ead17ed62b34eecc)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueFeather")
    def reset_hue_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeather", []))

    @jsii.member(jsii_name="resetHueFeatherVar")
    def reset_hue_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeatherVar", []))

    @jsii.member(jsii_name="resetHueTolerance")
    def reset_hue_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueTolerance", []))

    @jsii.member(jsii_name="resetHueToleranceVar")
    def reset_hue_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueToleranceVar", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightnessFeather")
    def reset_lightness_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeather", []))

    @jsii.member(jsii_name="resetLightnessFeatherVar")
    def reset_lightness_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeatherVar", []))

    @jsii.member(jsii_name="resetLightnessTolerance")
    def reset_lightness_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessTolerance", []))

    @jsii.member(jsii_name="resetLightnessToleranceVar")
    def reset_lightness_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessToleranceVar", []))

    @jsii.member(jsii_name="resetSaturationFeather")
    def reset_saturation_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeather", []))

    @jsii.member(jsii_name="resetSaturationFeatherVar")
    def reset_saturation_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeatherVar", []))

    @jsii.member(jsii_name="resetSaturationTolerance")
    def reset_saturation_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationTolerance", []))

    @jsii.member(jsii_name="resetSaturationToleranceVar")
    def reset_saturation_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherInput")
    def hue_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVarInput")
    def hue_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceInput")
    def hue_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVarInput")
    def hue_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherInput")
    def lightness_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVarInput")
    def lightness_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceInput")
    def lightness_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVarInput")
    def lightness_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherInput")
    def saturation_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVarInput")
    def saturation_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceInput")
    def saturation_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVarInput")
    def saturation_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e2ca4c0498a50ce111bc1348f54f1cbb5e821637cf4e91bbce3d3fc050f22e3a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeather")
    def hue_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeather"))

    @hue_feather.setter
    def hue_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d2eeca2325f1e783cc0e757c5b4445b3ce0f7542a34ff0bbb32078d219b1d1ad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeather", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVar")
    def hue_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeatherVar"))

    @hue_feather_var.setter
    def hue_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3b3c0835139fb8a98f8f17bc0a45156c1a5fecbf290ce5cdf1a17ebcf38cd02f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueTolerance")
    def hue_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueTolerance"))

    @hue_tolerance.setter
    def hue_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__436aa8de1cf4b7d629abab95fa1c52bc9a1fa389703ebe887a610b4a39560078)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVar")
    def hue_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueToleranceVar"))

    @hue_tolerance_var.setter
    def hue_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9fa6a7835c03e6c23d59e46fc0a2f2407ea682fa622819bc9d35ac36c3f641f6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2942a2300c5055ca236171176f1c9b4b7a2dffec61a91898d0bee06fea5ff78e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeather")
    def lightness_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeather"))

    @lightness_feather.setter
    def lightness_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fc428ae4063faa7a08f9417429ecb549b60791e4bf38a5d0aa22cc2145ad2267)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeather", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVar")
    def lightness_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeatherVar"))

    @lightness_feather_var.setter
    def lightness_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d41094cbe1946719755900c230c9a09e7ceea30888ebe7192c35697f9dfc2336)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessTolerance")
    def lightness_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessTolerance"))

    @lightness_tolerance.setter
    def lightness_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__773f8d606cebf6a4b033d9905e8df0d26bc6c0fcec2e4be7fc839cf16ff46852)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVar")
    def lightness_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessToleranceVar"))

    @lightness_tolerance_var.setter
    def lightness_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8eceed25ae8525243d3c4a3872f36ea30a0e1f3ecfd473dbc8ea29a16bb727ae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeather")
    def saturation_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeather"))

    @saturation_feather.setter
    def saturation_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__71a9a843dcdb70ec5f45e17c7c8006d96204ced72e8da73cc761308a04d4dd91)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeather", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVar")
    def saturation_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeatherVar"))

    @saturation_feather_var.setter
    def saturation_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__46f49d5818f251e072aa6e0fe9168430679232595c991908edf8900ec8e1f6a9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationTolerance")
    def saturation_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationTolerance"))

    @saturation_tolerance.setter
    def saturation_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__229f921c91d72637a777fb9a3fec525a21ea3665862bd37cb214287b16ee43e5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVar")
    def saturation_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationToleranceVar"))

    @saturation_tolerance_var.setter
    def saturation_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9bd1e05b77f80890f6c80af07f5bb8a55c881fc558c04001a5022522f5d18cfd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultChromaKey]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultChromaKey]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultChromaKey]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__baf4bcbcbf96455f40b9a00f731bf4baf9e63f2c553913769edce7f931a00278)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultComposite",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "placement": "placement",
        "placement_var": "placementVar",
        "scale": "scale",
        "scale_dimension": "scaleDimension",
        "scale_dimension_var": "scaleDimensionVar",
        "scale_var": "scaleVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultComposite:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultCompositeImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        placement: typing.Optional[builtins.str] = None,
        placement_var: typing.Optional[builtins.str] = None,
        scale: typing.Optional[builtins.str] = None,
        scale_dimension: typing.Optional[builtins.str] = None,
        scale_dimension_var: typing.Optional[builtins.str] = None,
        scale_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param placement: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        :param placement_var: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        :param scale: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param scale_dimension: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        :param scale_dimension_var: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        :param scale_var: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        :param x_position: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultCompositeImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b38c333c02fa37871147c6294f8cfa53c8fcf781783d0d676b2d68fce9e6953b)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument placement", value=placement, expected_type=type_hints["placement"])
            check_type(argname="argument placement_var", value=placement_var, expected_type=type_hints["placement_var"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument scale_dimension", value=scale_dimension, expected_type=type_hints["scale_dimension"])
            check_type(argname="argument scale_dimension_var", value=scale_dimension_var, expected_type=type_hints["scale_dimension_var"])
            check_type(argname="argument scale_var", value=scale_var, expected_type=type_hints["scale_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if placement is not None:
            self._values["placement"] = placement
        if placement_var is not None:
            self._values["placement_var"] = placement_var
        if scale is not None:
            self._values["scale"] = scale
        if scale_dimension is not None:
            self._values["scale_dimension"] = scale_dimension
        if scale_dimension_var is not None:
            self._values["scale_dimension_var"] = scale_dimension_var
        if scale_var is not None:
            self._values["scale_var"] = scale_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultCompositeImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultCompositeImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        '''
        result = self._values.get("placement")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement_var(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        '''
        result = self._values.get("placement_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        '''
        result = self._values.get("scale_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        '''
        result = self._values.get("scale_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        '''
        result = self._values.get("scale_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultComposite(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultCompositeImage",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultCompositeImage:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultCompositeImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultCompositeImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultCompositeImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__05992c58de18b1978bb567c3955ab4b94f87ca3cb159796866f9e1d329a6a134)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultCompositeImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultCompositeImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__813f3243623c5c17b0d43a99b75700a8626719e0519f0bf44bc146e6dda02ffb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultCompositeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultCompositeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af5a06d9747f9369b94a43838cbbb127ad921e0f5e918c0626786c5dac1be3e2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultCompositeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__db8be0822837530b39b38dc3c06e7f634bef29d5e79df7db181337168cf62703)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultCompositeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2b8807b16a08c97d0ee82d393baba3fb1850513e00820ffc18c6a0a1498a8a9f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__952ec94125c99c478243b00d2c68bb5b1e2be2d8830048eb317969ec621a446e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__35cb212e3556dca0d5670943e6bb47ec05ce9309424e9d2c057aeb3e7a4b4682)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultComposite]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultComposite]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9fa1fff09fa2caef9012c0f4aa8b7a17d32334e6bb80875e9db884b2e184de6b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultCompositeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultCompositeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__180a847c4ca571eb02af12b588be819924315cf3a64145345bdbad0d13ac6911)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultCompositeImage()

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPlacement")
    def reset_placement(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacement", []))

    @jsii.member(jsii_name="resetPlacementVar")
    def reset_placement_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacementVar", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetScaleDimension")
    def reset_scale_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimension", []))

    @jsii.member(jsii_name="resetScaleDimensionVar")
    def reset_scale_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimensionVar", []))

    @jsii.member(jsii_name="resetScaleVar")
    def reset_scale_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultCompositeImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultCompositeImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultCompositeImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="placementInput")
    def placement_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementInput"))

    @builtins.property
    @jsii.member(jsii_name="placementVarInput")
    def placement_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionInput")
    def scale_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVarInput")
    def scale_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleVarInput")
    def scale_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ca05bb5f9597c4bb38df980cff0c11e2db884498edcfb9582999a2a920bdcee9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e1f7902eade8c385d11c994351b70983964b40ef2b74719de782d948c77d8b35)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="placement")
    def placement(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placement"))

    @placement.setter
    def placement(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f9376ae96e409806fb2f1c48ee344460fbdd060d14aa9fb1ca887ca970563808)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placement", value)

    @builtins.property
    @jsii.member(jsii_name="placementVar")
    def placement_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placementVar"))

    @placement_var.setter
    def placement_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d2483b6385c910064963fd3b69005f79abede81e4504343e01ff77c95e583c0d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placementVar", value)

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scale"))

    @scale.setter
    def scale(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ff6e00b8ba0260ac09fecd661cbccc63794b9934c14fd44242ad1927a7f1da60)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scale", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimension")
    def scale_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimension"))

    @scale_dimension.setter
    def scale_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7dfb61f9c9b8b81826f5338f1627077af10916f2fe72d64687ce8d993e2daf30)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimension", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVar")
    def scale_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimensionVar"))

    @scale_dimension_var.setter
    def scale_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__11b3685353e3db3f39b9f25655336c1f230b7b965c27255f58d424278a599e94)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="scaleVar")
    def scale_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleVar"))

    @scale_var.setter
    def scale_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f3e3c8a9c02bfef22f191d71e945c19559a09d41458ec324e70c9b3711bd4a11)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__825fe38e302b4514588965cf0feb8c9ec9a8efcede6efd2d7971f94e81818072)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8e4c159395083c4bff083f2bce569d2a8478c3569922f40fe7c94d831e37cf01)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb425c30639070e9299cfee39265a9e638f47862100903a5154fa7a929471f43)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ca44308113b81d41358396fe35a2f4e2321b74b20cc3f6668456d4d257d129f8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultComposite]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultComposite]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultComposite]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__569104dd4f6efe9e9fa71c05c2fcb8e34f2ddf2e90a3961926acfe5af357bfe4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultCompound",
    jsii_struct_bases=[],
    name_mapping={"transformations": "transformations"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultCompound:
    def __init__(
        self,
        *,
        transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param transformations: transformations block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__11ec94e6255f4eaab31fc8189fcc3f9f83b83aa5f4a7348206cfbc8459b89298)
            check_type(argname="argument transformations", value=transformations, expected_type=type_hints["transformations"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if transformations is not None:
            self._values["transformations"] = transformations

    @builtins.property
    def transformations(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultCompoundTransformations"]]]:
        '''transformations block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        result = self._values.get("transformations")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultCompoundTransformations"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultCompound(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultCompoundList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultCompoundList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cef3c1ca3d82450691c06b3bc006c585fa0f2dbb1cc60e3496cf68a7073812cb)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultCompoundOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__550c22b42a7650a28db1853e37f4fd2d24fc129fb715ee526b8c97bdcec59064)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultCompoundOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__27a9d03bcd1b83337347efaed51c59022cd7f2cd4f2843d17d2bb8f0ec4d523e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a834fec00fc03233265091e8065fb9d1bd5f007735e58b6841256494d40ebe5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0c35d214e6bcfa33c5b489d622ef2c71522944a2ee316b51af543e05e346e4a1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultCompound]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultCompound]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__962163069e0244c6c69cf2125f78761e5819159e63c55284d5e05c452a03a0be)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultCompoundOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultCompoundOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4e1a19eaea9e4ac00f7d0f57b24eb70ccfe9ffa4cb8294e4e67cc2b87d208275)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformations")
    def put_transformations(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fff3a97b5494243d237097844b1b6d4bce874547be270ed882b5fdedf4cdcaec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTransformations", [value]))

    @jsii.member(jsii_name="resetTransformations")
    def reset_transformations(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformations", []))

    @builtins.property
    @jsii.member(jsii_name="transformations")
    def transformations(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultCompoundTransformationsList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultCompoundTransformationsList", jsii.get(self, "transformations"))

    @builtins.property
    @jsii.member(jsii_name="transformationsInput")
    def transformations_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultCompoundTransformations"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultCompoundTransformations"]]], jsii.get(self, "transformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultCompound]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultCompound]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultCompound]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__249384db9455e2a0a0f9e6b8ed7a6ad5298f3787333f3f32413a9a4bd7977692)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultCompoundTransformations",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultCompoundTransformations:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultCompoundTransformations(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultCompoundTransformationsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultCompoundTransformationsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f6c6109502724e0b0eb2b3320680a6057856aac6940a2fbf8e1061edc8957ac5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultCompoundTransformationsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__33674ec54d27722a4b3697957bc56b22f39ffdd585878025aec842c1e55c796b)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultCompoundTransformationsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c40cafe326bce65e2b4dacbe7d2ea0eb251d44af3439b7e04ec20f3ded6116b4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1156cc14d1034ca1645db9fa345d0b38d1def20a12ce738d29c686fcf72720af)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__711ca9e82f51e63af9c74712b74604d8379b59c2f7469d70a93accbe0188e4ac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultCompoundTransformations]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultCompoundTransformations]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultCompoundTransformations]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__30eba9dcadfd93fd1a56d4cb876503287354e71b02f20a57a5374fd4dd93528e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultCompoundTransformationsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultCompoundTransformationsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__516a0340bb76af6c2715351347a7a3843c0ae68810e4359c5baad4baa9f3ec36)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultCompoundTransformations]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultCompoundTransformations]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultCompoundTransformations]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__304c3a2f75a1b76777e87971637e4ed104cdf3dc241956d10367636da4561c8f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultContrast",
    jsii_struct_bases=[],
    name_mapping={
        "brightness": "brightness",
        "brightness_var": "brightnessVar",
        "contrast": "contrast",
        "contrast_var": "contrastVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultContrast:
    def __init__(
        self,
        *,
        brightness: typing.Optional[builtins.str] = None,
        brightness_var: typing.Optional[builtins.str] = None,
        contrast: typing.Optional[builtins.str] = None,
        contrast_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param brightness: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        :param brightness_var: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        :param contrast: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param contrast_var: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2c04497f64ab1497168d1f0394589bc26a57e1014e274300a7b9650c6d09e249)
            check_type(argname="argument brightness", value=brightness, expected_type=type_hints["brightness"])
            check_type(argname="argument brightness_var", value=brightness_var, expected_type=type_hints["brightness_var"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument contrast_var", value=contrast_var, expected_type=type_hints["contrast_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if brightness is not None:
            self._values["brightness"] = brightness
        if brightness_var is not None:
            self._values["brightness_var"] = brightness_var
        if contrast is not None:
            self._values["contrast"] = contrast
        if contrast_var is not None:
            self._values["contrast_var"] = contrast_var

    @builtins.property
    def brightness(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        '''
        result = self._values.get("brightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def brightness_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        '''
        result = self._values.get("brightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        result = self._values.get("contrast_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultContrast(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultContrastList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultContrastList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7f1270e0086b92bf325f0d7e5c5af639de62aa3176663b140ed06099e0b41e33)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultContrastOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__59a93d4befb1265c6ba2850ed4c3f812ec0b3f0036380bd45ebf7ffd30511ebc)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultContrastOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0f482333094580aa317c37e68d51c6ebdb1f30ec8b489e0c22a311a9e4de941f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__555cd04c140a9c457b6ad7ced7e98af7503c238d1f11d7bb0971f51e1bd412b6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__61c55eedb4f42d6e99a1885177be8d09f8a76f9244ba8e454a8cc077bff452e7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultContrast]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultContrast]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5170c5795b61481b9901be641631a2af37244a4a18815badfb9cf303929b26d1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultContrastOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultContrastOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a625826f47d1f1582d0c39239fdce816c1c771bf5e97c557a4d264e84159c1b2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetBrightness")
    def reset_brightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightness", []))

    @jsii.member(jsii_name="resetBrightnessVar")
    def reset_brightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightnessVar", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetContrastVar")
    def reset_contrast_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrastVar", []))

    @builtins.property
    @jsii.member(jsii_name="brightnessInput")
    def brightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="brightnessVarInput")
    def brightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastVarInput")
    def contrast_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="brightness")
    def brightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightness"))

    @brightness.setter
    def brightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__278d6178322057d3edd61061d605a077a3426362eabc790ba7768100065dc3fb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightness", value)

    @builtins.property
    @jsii.member(jsii_name="brightnessVar")
    def brightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightnessVar"))

    @brightness_var.setter
    def brightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__01c3e2d0bed226b6d7289e680b58a7605cf0262b7b8213b5af6e0bbbbaef5cc3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrast"))

    @contrast.setter
    def contrast(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b93af62ce9eed6fcb292ef921a418751864fc9b5ef12da5e7fc0c7c67d2d0a4b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrast", value)

    @builtins.property
    @jsii.member(jsii_name="contrastVar")
    def contrast_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrastVar"))

    @contrast_var.setter
    def contrast_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0950dad86f18b02f1520c48f064f54e7582d1e54c7b65cc2f0e6fa2164b26969)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrastVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultContrast]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultContrast]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultContrast]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__414b740ce1f93efef22a5e9e31b87d8248167734a07ac382dbcd250cf313eae6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultCrop",
    jsii_struct_bases=[],
    name_mapping={
        "allow_expansion": "allowExpansion",
        "allow_expansion_var": "allowExpansionVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultCrop:
    def __init__(
        self,
        *,
        allow_expansion: typing.Optional[builtins.str] = None,
        allow_expansion_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_expansion: If cropping an area outside of the existing canvas, expands the image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        :param allow_expansion_var: If cropping an area outside of the existing canvas, expands the image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        :param gravity: Frame of reference for X and Y Positions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Frame of reference for X and Y Positions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The number of pixels to crop along the y-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The number of pixels to crop along the y-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The number of pixels to crop along the x-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The number of pixels to crop along the x-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        :param x_position: The x-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ec1340c41890711b9d5d4a801ac0d88d0783fe155eaad63ac1d22ed86b8debed)
            check_type(argname="argument allow_expansion", value=allow_expansion, expected_type=type_hints["allow_expansion"])
            check_type(argname="argument allow_expansion_var", value=allow_expansion_var, expected_type=type_hints["allow_expansion_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if allow_expansion is not None:
            self._values["allow_expansion"] = allow_expansion
        if allow_expansion_var is not None:
            self._values["allow_expansion_var"] = allow_expansion_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def allow_expansion(self) -> typing.Optional[builtins.str]:
        '''If cropping an area outside of the existing canvas, expands the image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        '''
        result = self._values.get("allow_expansion")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def allow_expansion_var(self) -> typing.Optional[builtins.str]:
        '''If cropping an area outside of the existing canvas, expands the image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        '''
        result = self._values.get("allow_expansion_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Frame of reference for X and Y Positions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Frame of reference for X and Y Positions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the y-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the y-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the x-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the x-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9187fb6d7cc080d10bf78d565d0147d86387851aafdb7d6b2432cde887753d8b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c339b02052ba6e2c41b27dd79f7be58c711b37a91d233be172cd3cd27d689970)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__725777e6b60c68675982b82a74e61b86b7f43b817a6321d71ac9ef0376b59bd7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__589df2ff03236dbfdf0e63f8b78fc4a0c5983ddf74b0f7d47d2376a7777089eb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f4e0815de3ac9da72e34fe878ab2be3f7db011a27de8e12b5e97c01aaad1aaa2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aa4c827e4bbe1f32194165f3021dc04baa407296a900b999fec1da0008fda8fc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8e32574dbe2866030355af08f591478c1d5435773c7eb3fa4cc4567fad9efdb5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAllowExpansion")
    def reset_allow_expansion(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansion", []))

    @jsii.member(jsii_name="resetAllowExpansionVar")
    def reset_allow_expansion_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansionVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionInput")
    def allow_expansion_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVarInput")
    def allow_expansion_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansion")
    def allow_expansion(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansion"))

    @allow_expansion.setter
    def allow_expansion(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d9e4a04360ddea4da706f14c2cffe12047de682e2275461c3053767baf535143)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansion", value)

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVar")
    def allow_expansion_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansionVar"))

    @allow_expansion_var.setter
    def allow_expansion_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e45afc3fe1f8fe30ad982f8fb9ffe6f6fd823dd77cd9bf8d9eea6663ed2352c5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansionVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eb9fd6d27d4a4dcdf3bd599c162b99553c8630f19efc2532e53ae36caf054aaa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8eb320945da1be36e9a147dff7af6653de1935c759c4b1cbc95792f79d08e74e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f50c412f9604589ea48c6a91b8ebf3fb60341444563ad0811fa0f99e756ee4fa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c8a771f906830d7bc2125292c31c4d630c92b0d3dc73863d44a80c622b5e2b1c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fb81530eeca0933b4edc130236f31ebf74bb544ef2f989ecb4d08d794cc57bde)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f4252610969a06cefea863b98b407b37d07f4c34af69b5ce5567888924031a8b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e9c1fc54000c5c1677ee9a80437413b138d735c03a7e818a33dd1281a654f44d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7995f028396f1d064900b7d07aa76460bd1f4a7ae021c75ac044aa0109cc06e3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6966ae4f621cda7ca064a77ff46b1303923b013c4c53295bd35f594751f2b0c5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ed85dd8b352f57f8fb0eb96f81d5831216434b293f818e06bba737227ee3bd41)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__590258071c769a4f7a9518c99458f637f0f2a91f24109782a5e11c9e264b8c45)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultFaceCrop",
    jsii_struct_bases=[],
    name_mapping={
        "algorithm": "algorithm",
        "algorithm_var": "algorithmVar",
        "confidence": "confidence",
        "confidence_var": "confidenceVar",
        "fail_gravity": "failGravity",
        "fail_gravity_var": "failGravityVar",
        "focus": "focus",
        "focus_var": "focusVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "padding": "padding",
        "padding_var": "paddingVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultFaceCrop:
    def __init__(
        self,
        *,
        algorithm: typing.Optional[builtins.str] = None,
        algorithm_var: typing.Optional[builtins.str] = None,
        confidence: typing.Optional[builtins.str] = None,
        confidence_var: typing.Optional[builtins.str] = None,
        fail_gravity: typing.Optional[builtins.str] = None,
        fail_gravity_var: typing.Optional[builtins.str] = None,
        focus: typing.Optional[builtins.str] = None,
        focus_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param algorithm: Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm DataAkamaiImagingPolicyImage#algorithm}
        :param algorithm_var: Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm_var DataAkamaiImagingPolicyImage#algorithm_var}
        :param confidence: With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image. Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence DataAkamaiImagingPolicyImage#confidence}
        :param confidence_var: With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image. Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence_var DataAkamaiImagingPolicyImage#confidence_var}
        :param fail_gravity: Controls placement of the crop if Image and Video Manager does not detect any faces in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        :param fail_gravity_var: Controls placement of the crop if Image and Video Manager does not detect any faces in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        :param focus: Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus DataAkamaiImagingPolicyImage#focus}
        :param focus_var: Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus_var DataAkamaiImagingPolicyImage#focus_var}
        :param gravity: Controls placement of the crop. Directions are relative to the face(s) plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Controls placement of the crop. Directions are relative to the face(s) plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param padding: The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        :param style: Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__444378c4f3bdf31af287463353892e6a7c4997ba2061a48fe53d8bc3bc8ee6fc)
            check_type(argname="argument algorithm", value=algorithm, expected_type=type_hints["algorithm"])
            check_type(argname="argument algorithm_var", value=algorithm_var, expected_type=type_hints["algorithm_var"])
            check_type(argname="argument confidence", value=confidence, expected_type=type_hints["confidence"])
            check_type(argname="argument confidence_var", value=confidence_var, expected_type=type_hints["confidence_var"])
            check_type(argname="argument fail_gravity", value=fail_gravity, expected_type=type_hints["fail_gravity"])
            check_type(argname="argument fail_gravity_var", value=fail_gravity_var, expected_type=type_hints["fail_gravity_var"])
            check_type(argname="argument focus", value=focus, expected_type=type_hints["focus"])
            check_type(argname="argument focus_var", value=focus_var, expected_type=type_hints["focus_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if algorithm is not None:
            self._values["algorithm"] = algorithm
        if algorithm_var is not None:
            self._values["algorithm_var"] = algorithm_var
        if confidence is not None:
            self._values["confidence"] = confidence
        if confidence_var is not None:
            self._values["confidence_var"] = confidence_var
        if fail_gravity is not None:
            self._values["fail_gravity"] = fail_gravity
        if fail_gravity_var is not None:
            self._values["fail_gravity_var"] = fail_gravity_var
        if focus is not None:
            self._values["focus"] = focus
        if focus_var is not None:
            self._values["focus_var"] = focus_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def algorithm(self) -> typing.Optional[builtins.str]:
        '''Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm DataAkamaiImagingPolicyImage#algorithm}
        '''
        result = self._values.get("algorithm")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def algorithm_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm_var DataAkamaiImagingPolicyImage#algorithm_var}
        '''
        result = self._values.get("algorithm_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def confidence(self) -> typing.Optional[builtins.str]:
        '''With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image.

        Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence DataAkamaiImagingPolicyImage#confidence}
        '''
        result = self._values.get("confidence")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def confidence_var(self) -> typing.Optional[builtins.str]:
        '''With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image.

        Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence_var DataAkamaiImagingPolicyImage#confidence_var}
        '''
        result = self._values.get("confidence_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any faces in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        '''
        result = self._values.get("fail_gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any faces in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        '''
        result = self._values.get("fail_gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def focus(self) -> typing.Optional[builtins.str]:
        '''Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus DataAkamaiImagingPolicyImage#focus}
        '''
        result = self._values.get("focus")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def focus_var(self) -> typing.Optional[builtins.str]:
        '''Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus_var DataAkamaiImagingPolicyImage#focus_var}
        '''
        result = self._values.get("focus_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the face(s) plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the face(s) plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultFaceCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultFaceCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultFaceCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d29475a10b41d1ad278c1c9acfaa246ddc4266bf3b1888521d332689662cfc44)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultFaceCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ddca097194fb1c36bb441a1b18f19e681d8d73d93186d4cf15d5acf2ef55a8a)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultFaceCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__14d96e1a32deb3c5494d01e8ca7d5563b5aeae16235345841a69089c4598e81d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__48c2558cf671f2e38cc011970ee5dd689c095df2208f86be3868afba0b9f7575)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7a991e661767bc0f55e36d1c368fec5effc272083f7234afdc40c157df14e93b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultFaceCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultFaceCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultFaceCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6a13f93b861bf2f9e68515cb83b013d01e300c25ed6b9ff13aeb814fefd055c8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultFaceCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultFaceCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6cadbe29d8f16c5133d429980c64570c8576de67180c1d927f81bbf6cdc05110)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAlgorithm")
    def reset_algorithm(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAlgorithm", []))

    @jsii.member(jsii_name="resetAlgorithmVar")
    def reset_algorithm_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAlgorithmVar", []))

    @jsii.member(jsii_name="resetConfidence")
    def reset_confidence(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetConfidence", []))

    @jsii.member(jsii_name="resetConfidenceVar")
    def reset_confidence_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetConfidenceVar", []))

    @jsii.member(jsii_name="resetFailGravity")
    def reset_fail_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravity", []))

    @jsii.member(jsii_name="resetFailGravityVar")
    def reset_fail_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravityVar", []))

    @jsii.member(jsii_name="resetFocus")
    def reset_focus(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFocus", []))

    @jsii.member(jsii_name="resetFocusVar")
    def reset_focus_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFocusVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="algorithmInput")
    def algorithm_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "algorithmInput"))

    @builtins.property
    @jsii.member(jsii_name="algorithmVarInput")
    def algorithm_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "algorithmVarInput"))

    @builtins.property
    @jsii.member(jsii_name="confidenceInput")
    def confidence_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "confidenceInput"))

    @builtins.property
    @jsii.member(jsii_name="confidenceVarInput")
    def confidence_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "confidenceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityInput")
    def fail_gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityVarInput")
    def fail_gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="focusInput")
    def focus_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "focusInput"))

    @builtins.property
    @jsii.member(jsii_name="focusVarInput")
    def focus_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "focusVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="algorithm")
    def algorithm(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "algorithm"))

    @algorithm.setter
    def algorithm(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2429f8a8029471866551cb8be4c03955a1945d2878170b728c934f31b03fbcdc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "algorithm", value)

    @builtins.property
    @jsii.member(jsii_name="algorithmVar")
    def algorithm_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "algorithmVar"))

    @algorithm_var.setter
    def algorithm_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e5ff147b34a94fc11dfad945d3e7abf42fae1660f6850bb364ee68e8e965b83)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "algorithmVar", value)

    @builtins.property
    @jsii.member(jsii_name="confidence")
    def confidence(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "confidence"))

    @confidence.setter
    def confidence(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__24350f4b36ba260aebcf0e0c779061c50269e0e3b053acffb7a81fe30367d42c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "confidence", value)

    @builtins.property
    @jsii.member(jsii_name="confidenceVar")
    def confidence_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "confidenceVar"))

    @confidence_var.setter
    def confidence_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__151119f3ae108e238f71b9a216b5ec4d65bfaf1e89a7325f29aa0b31e8d550fb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "confidenceVar", value)

    @builtins.property
    @jsii.member(jsii_name="failGravity")
    def fail_gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravity"))

    @fail_gravity.setter
    def fail_gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c216597a7845dce14977df384e2a6cb655fa021b9aa677f761bf049de129595b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravity", value)

    @builtins.property
    @jsii.member(jsii_name="failGravityVar")
    def fail_gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravityVar"))

    @fail_gravity_var.setter
    def fail_gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dd56c187ceb328b11cb26ed360aa1ac4ff4850e3f458dc30c2250e69f630a820)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="focus")
    def focus(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "focus"))

    @focus.setter
    def focus(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5bed224eed4d3467608ee4feaad624f141581e6c999c95b448f47f272a3afcea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "focus", value)

    @builtins.property
    @jsii.member(jsii_name="focusVar")
    def focus_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "focusVar"))

    @focus_var.setter
    def focus_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eed81a619c01f0374ab74914fb7e417cae1e94901b29672641031500be3e9061)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "focusVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bbdcfac34ce8dabc119bdc8f1280309e52ea810e12daf65134ad2d07a903750b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__356c006a73daaa5508b10879c287eb5817aec3d7c24ffe99d62aeaefc3b686b7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e89b8a7443f13e320e8c64317014c181a8ea360c0fee4c5eff3b4c29b1cb70ee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c9dc60ec26e5769c245a7c3f727e606bdd47a70b67866c86b44c7709035a4f03)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0c8fdbc903edebfe789832a6438312a8fcde4f3f51ce754df3ca4c59cd9c8eae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2174b7e6ceb7d1a7bfa3ee883e899bccf781b0bfeec6b2c8f4b0a4124f3bdbc5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__64785482522bd4785542de3c117f8db435919f991cddc74dda1f99b50396beac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0f26f5875ebe0793a050f8983c49184a361ef9bcb16f1faca44b7ea234f78919)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3df11b1860415635cdb404d400de90047bab36226b7234349277ca45dee0e30f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f1b0d2564c5a0e113351b049031d76c3d66fb4d198ecf2a0bcf8478ad37dac03)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultFaceCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultFaceCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultFaceCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eefc6c08ebf87010ebed9c14275b3df0b052784126d1952c9406e6e77e3c518c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultFeatureCrop",
    jsii_struct_bases=[],
    name_mapping={
        "fail_gravity": "failGravity",
        "fail_gravity_var": "failGravityVar",
        "feature_radius": "featureRadius",
        "feature_radius_var": "featureRadiusVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "max_features": "maxFeatures",
        "max_features_var": "maxFeaturesVar",
        "min_feature_quality": "minFeatureQuality",
        "min_feature_quality_var": "minFeatureQualityVar",
        "padding": "padding",
        "padding_var": "paddingVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultFeatureCrop:
    def __init__(
        self,
        *,
        fail_gravity: typing.Optional[builtins.str] = None,
        fail_gravity_var: typing.Optional[builtins.str] = None,
        feature_radius: typing.Optional[builtins.str] = None,
        feature_radius_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        max_features: typing.Optional[builtins.str] = None,
        max_features_var: typing.Optional[builtins.str] = None,
        min_feature_quality: typing.Optional[builtins.str] = None,
        min_feature_quality_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fail_gravity: Controls placement of the crop if Image and Video Manager does not detect any features in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        :param fail_gravity_var: Controls placement of the crop if Image and Video Manager does not detect any features in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        :param feature_radius: The size in pixels of the important features to search for. If identified, two features never appear closer together than this value, ``8.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius DataAkamaiImagingPolicyImage#feature_radius}
        :param feature_radius_var: The size in pixels of the important features to search for. If identified, two features never appear closer together than this value, ``8.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius_var DataAkamaiImagingPolicyImage#feature_radius_var}
        :param gravity: Controls placement of the crop. Directions are relative to the region of interest plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Controls placement of the crop. Directions are relative to the region of interest plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param max_features: The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features DataAkamaiImagingPolicyImage#max_features}
        :param max_features_var: The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features_var DataAkamaiImagingPolicyImage#max_features_var}
        :param min_feature_quality: Determines the minimum quality level of the feature identified. To consider a feature important, the feature needs to surpass this value. Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality DataAkamaiImagingPolicyImage#min_feature_quality}
        :param min_feature_quality_var: Determines the minimum quality level of the feature identified. To consider a feature important, the feature needs to surpass this value. Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality_var DataAkamaiImagingPolicyImage#min_feature_quality_var}
        :param padding: Adds space around the region of interest. The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: Adds space around the region of interest. The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        :param style: Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1e2a8e8d17b8b26e6adeb83fae49b933f4b7908a707e83ea6e277fcae272ae89)
            check_type(argname="argument fail_gravity", value=fail_gravity, expected_type=type_hints["fail_gravity"])
            check_type(argname="argument fail_gravity_var", value=fail_gravity_var, expected_type=type_hints["fail_gravity_var"])
            check_type(argname="argument feature_radius", value=feature_radius, expected_type=type_hints["feature_radius"])
            check_type(argname="argument feature_radius_var", value=feature_radius_var, expected_type=type_hints["feature_radius_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument max_features", value=max_features, expected_type=type_hints["max_features"])
            check_type(argname="argument max_features_var", value=max_features_var, expected_type=type_hints["max_features_var"])
            check_type(argname="argument min_feature_quality", value=min_feature_quality, expected_type=type_hints["min_feature_quality"])
            check_type(argname="argument min_feature_quality_var", value=min_feature_quality_var, expected_type=type_hints["min_feature_quality_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fail_gravity is not None:
            self._values["fail_gravity"] = fail_gravity
        if fail_gravity_var is not None:
            self._values["fail_gravity_var"] = fail_gravity_var
        if feature_radius is not None:
            self._values["feature_radius"] = feature_radius
        if feature_radius_var is not None:
            self._values["feature_radius_var"] = feature_radius_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if max_features is not None:
            self._values["max_features"] = max_features
        if max_features_var is not None:
            self._values["max_features_var"] = max_features_var
        if min_feature_quality is not None:
            self._values["min_feature_quality"] = min_feature_quality
        if min_feature_quality_var is not None:
            self._values["min_feature_quality_var"] = min_feature_quality_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def fail_gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any features in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        '''
        result = self._values.get("fail_gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any features in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        '''
        result = self._values.get("fail_gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feature_radius(self) -> typing.Optional[builtins.str]:
        '''The size in pixels of the important features to search for.

        If identified, two features never appear closer together than this value, ``8.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius DataAkamaiImagingPolicyImage#feature_radius}
        '''
        result = self._values.get("feature_radius")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feature_radius_var(self) -> typing.Optional[builtins.str]:
        '''The size in pixels of the important features to search for.

        If identified, two features never appear closer together than this value, ``8.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius_var DataAkamaiImagingPolicyImage#feature_radius_var}
        '''
        result = self._values.get("feature_radius_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the region of interest plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the region of interest plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def max_features(self) -> typing.Optional[builtins.str]:
        '''The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features DataAkamaiImagingPolicyImage#max_features}
        '''
        result = self._values.get("max_features")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def max_features_var(self) -> typing.Optional[builtins.str]:
        '''The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features_var DataAkamaiImagingPolicyImage#max_features_var}
        '''
        result = self._values.get("max_features_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def min_feature_quality(self) -> typing.Optional[builtins.str]:
        '''Determines the minimum quality level of the feature identified.

        To consider a feature important, the feature needs to surpass this value.  Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality DataAkamaiImagingPolicyImage#min_feature_quality}
        '''
        result = self._values.get("min_feature_quality")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def min_feature_quality_var(self) -> typing.Optional[builtins.str]:
        '''Determines the minimum quality level of the feature identified.

        To consider a feature important, the feature needs to surpass this value.  Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality_var DataAkamaiImagingPolicyImage#min_feature_quality_var}
        '''
        result = self._values.get("min_feature_quality_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''Adds space around the region of interest.

        The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''Adds space around the region of interest.

        The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultFeatureCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultFeatureCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultFeatureCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__182b8ba23e51f4964fb71811b0d5f4bc429d4b4375c39c7c6acbdefa95c711dd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultFeatureCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__735d809fb86ab614898fe73a9128967e4d8a1e43e33c2f020b65462fa4e62d8f)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultFeatureCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1925e6e28cb22e59b20746a8e8997bf59a93f798c21fb0f31668ba6998e750bf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0a0fa25823b44ca06a63a481a584dc9459853b202e9dadfd79a103145cd5b27e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__67c55086b51cfb74b7f6eb5596c688a7cb32752ef4f32dfd74dcf475fae6df5e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultFeatureCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultFeatureCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultFeatureCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f9f2007dc05fabf91feb1c8ae7247d1a23d69c70390edb2b5dbf0966238bad67)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultFeatureCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultFeatureCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ee3b8c9b1912abef44917881730fae83bae6362c9fe0a6d5547fb3d56781de4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetFailGravity")
    def reset_fail_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravity", []))

    @jsii.member(jsii_name="resetFailGravityVar")
    def reset_fail_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravityVar", []))

    @jsii.member(jsii_name="resetFeatureRadius")
    def reset_feature_radius(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureRadius", []))

    @jsii.member(jsii_name="resetFeatureRadiusVar")
    def reset_feature_radius_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureRadiusVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetMaxFeatures")
    def reset_max_features(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxFeatures", []))

    @jsii.member(jsii_name="resetMaxFeaturesVar")
    def reset_max_features_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxFeaturesVar", []))

    @jsii.member(jsii_name="resetMinFeatureQuality")
    def reset_min_feature_quality(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMinFeatureQuality", []))

    @jsii.member(jsii_name="resetMinFeatureQualityVar")
    def reset_min_feature_quality_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMinFeatureQualityVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="failGravityInput")
    def fail_gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityVarInput")
    def fail_gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featureRadiusInput")
    def feature_radius_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featureRadiusInput"))

    @builtins.property
    @jsii.member(jsii_name="featureRadiusVarInput")
    def feature_radius_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featureRadiusVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesInput")
    def max_features_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "maxFeaturesInput"))

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesVarInput")
    def max_features_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "maxFeaturesVarInput"))

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityInput")
    def min_feature_quality_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "minFeatureQualityInput"))

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityVarInput")
    def min_feature_quality_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "minFeatureQualityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravity")
    def fail_gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravity"))

    @fail_gravity.setter
    def fail_gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__35b185986c3adb3ae4c446440c0eb8398e5860014fddf91d84d18072eaf7e3db)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravity", value)

    @builtins.property
    @jsii.member(jsii_name="failGravityVar")
    def fail_gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravityVar"))

    @fail_gravity_var.setter
    def fail_gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__39bd55fd9367d3f29515b8814ab31c7d679106ef3fd7d0d63448176e1f1e5c29)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="featureRadius")
    def feature_radius(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featureRadius"))

    @feature_radius.setter
    def feature_radius(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f978aaf108046fddfe57048cfd8cf0bc4e56384898bc5ea9a3dd3585f7e7b879)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featureRadius", value)

    @builtins.property
    @jsii.member(jsii_name="featureRadiusVar")
    def feature_radius_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featureRadiusVar"))

    @feature_radius_var.setter
    def feature_radius_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__570a811ac685cf26b7a049203f32f25fca1cae19c1a93d7e2d4f478ba8e2e0aa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featureRadiusVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4474763c0f044278e065b7166cfc43a3e500ac8d80066544a65bb6945319eb09)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__08b51ed7a83485cb5a27f97a864ee9d416f6e6cab5501525ec682c28f49609e8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0c3bc0f20decbe63a95e514de10fb7eeccb4365e068c15b070f214239442492f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e49dcddde2d6b60e7cf1685c37423a3dc304746022a99ab006c5592406293e8a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="maxFeatures")
    def max_features(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "maxFeatures"))

    @max_features.setter
    def max_features(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e193b72e803c6469848f227eb53ba6c7d351251ccac0cfdde3bc9315cd810bb6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "maxFeatures", value)

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesVar")
    def max_features_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "maxFeaturesVar"))

    @max_features_var.setter
    def max_features_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ceb775c2418c75cf37affdb818827f728aaf2c47cbb22e6853511608c4cd74c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "maxFeaturesVar", value)

    @builtins.property
    @jsii.member(jsii_name="minFeatureQuality")
    def min_feature_quality(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "minFeatureQuality"))

    @min_feature_quality.setter
    def min_feature_quality(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d750fccfa280ab3ac46d6b53b76599cdace205b12fd33737513c5e3a95734904)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "minFeatureQuality", value)

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityVar")
    def min_feature_quality_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "minFeatureQualityVar"))

    @min_feature_quality_var.setter
    def min_feature_quality_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc5459403f7969fde526e731be39243244c29d726511124f5915cca41a50109a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "minFeatureQualityVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e9846463233fafbb4babe4968e759796a334311a2023c2c7f218ea0503dddc8d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__da3af2483a62a85d405fcaa39ebe008d3cc8b881c42ae5aeee5e6b769394d6b4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5c9571c7da09b3d5832ae61075d803ec688e58ae7bdf484dcf30fd676ccc5ee7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__876b99c9ce7fa04d1ab448add781afa9cba29eed0531e0e8e54654db3823c13c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__33ba7420a5b2f8b3247d0c7e22f3d38abd5c5e9f4e9109bc73b78c6bd78d6227)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0dd975eeabde185a96de6480931a6532d27f77575d7ab2d84a667b11559d6c95)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultFeatureCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultFeatureCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultFeatureCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f52e7dd4b48f5e9a90945498976284f3e09db0bef605610af35e90ad6dedfb85)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultFitAndFill",
    jsii_struct_bases=[],
    name_mapping={
        "fill_transformation": "fillTransformation",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultFitAndFill:
    def __init__(
        self,
        *,
        fill_transformation: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultFitAndFillFillTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fill_transformation: fill_transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_transformation DataAkamaiImagingPolicyImage#fill_transformation}
        :param height: The height value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The width value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(fill_transformation, dict):
            fill_transformation = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultFitAndFillFillTransformation(**fill_transformation)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e10c4cee3bf437d7062f53a9187a3d2d5ea5b7a1afedae97156ccffca5164d95)
            check_type(argname="argument fill_transformation", value=fill_transformation, expected_type=type_hints["fill_transformation"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fill_transformation is not None:
            self._values["fill_transformation"] = fill_transformation
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def fill_transformation(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultFitAndFillFillTransformation"]:
        '''fill_transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_transformation DataAkamaiImagingPolicyImage#fill_transformation}
        '''
        result = self._values.get("fill_transformation")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultFitAndFillFillTransformation"], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultFitAndFill(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultFitAndFillFillTransformation",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultFitAndFillFillTransformation:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultFitAndFillFillTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultFitAndFillFillTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultFitAndFillFillTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b5c0c6f45af7863f485485061679dbd099e791cd90484d702632c243d9dddc71)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultFitAndFillFillTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultFitAndFillFillTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultFitAndFillFillTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fab98d5e355a70a6d983024affbf1539f6f4a5756856a7f6d6cc83ccfdbb2994)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultFitAndFillList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultFitAndFillList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4972dc7fe859f6f75e7474ee602f70e78f895fab96a9ff992ac872006caf26cb)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultFitAndFillOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb9d0b9cb95bfa85663b69c6f7900688783892b8d4776bbb6329337e1c702e86)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultFitAndFillOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b690231ad3c63e76c36fba34ce575b4461583666030a901fea74a06c6eb4534b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__86f7c3e83604d223beeabcb0e2c881c92c1e633e01f9ac3320ea8862d2d14175)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ce76370f5426938b1326933900f2b4a8d0d37a2f966fc84055f3d238433a67c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultFitAndFill]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultFitAndFill]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultFitAndFill]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bdbd85c2139ce111253e908bed36c68d8f9468bf4128b325f9eba7ee63f83b4f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultFitAndFillOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultFitAndFillOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ee1909cc74d84f4d4afaef1f8aa228cf94baee010dc20d816aa1a79d59177459)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putFillTransformation")
    def put_fill_transformation(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultFitAndFillFillTransformation()

        return typing.cast(None, jsii.invoke(self, "putFillTransformation", [value]))

    @jsii.member(jsii_name="resetFillTransformation")
    def reset_fill_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFillTransformation", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="fillTransformation")
    def fill_transformation(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultFitAndFillFillTransformationOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultFitAndFillFillTransformationOutputReference, jsii.get(self, "fillTransformation"))

    @builtins.property
    @jsii.member(jsii_name="fillTransformationInput")
    def fill_transformation_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultFitAndFillFillTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultFitAndFillFillTransformation], jsii.get(self, "fillTransformationInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8079dd39fcf2b72b58a1a79c6920c2afd5b562076ea274befa76063c4f4e5e72)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cf65570cb9dd0a8557a3e3446afef0c85cc9b3dc68564ce417cee19e05f1d6ac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b08d0a33708e49e3fbbfe287d817a985248a16afcbbc08f3174e1f2a402bc0aa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5a6edc6505ef001d15804c42dc6d6655a758713e99b41c075980c946c51b0cb5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultFitAndFill]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultFitAndFill]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultFitAndFill]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ef5ea5b4fa0ccafef8823d8abb13551656e7beb42d5f40ce19dedec293309cca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultGoop",
    jsii_struct_bases=[],
    name_mapping={
        "chaos": "chaos",
        "chaos_var": "chaosVar",
        "density": "density",
        "density_var": "densityVar",
        "power": "power",
        "power_var": "powerVar",
        "seed": "seed",
        "seed_var": "seedVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultGoop:
    def __init__(
        self,
        *,
        chaos: typing.Optional[builtins.str] = None,
        chaos_var: typing.Optional[builtins.str] = None,
        density: typing.Optional[builtins.str] = None,
        density_var: typing.Optional[builtins.str] = None,
        power: typing.Optional[builtins.str] = None,
        power_var: typing.Optional[builtins.str] = None,
        seed: typing.Optional[builtins.str] = None,
        seed_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param chaos: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        :param chaos_var: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        :param density: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        :param density_var: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        :param power: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        :param power_var: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        :param seed: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        :param seed_var: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b30e3e52c59023010b2297b188312826244cfe1fea385c5240eed5cdbe2ae70f)
            check_type(argname="argument chaos", value=chaos, expected_type=type_hints["chaos"])
            check_type(argname="argument chaos_var", value=chaos_var, expected_type=type_hints["chaos_var"])
            check_type(argname="argument density", value=density, expected_type=type_hints["density"])
            check_type(argname="argument density_var", value=density_var, expected_type=type_hints["density_var"])
            check_type(argname="argument power", value=power, expected_type=type_hints["power"])
            check_type(argname="argument power_var", value=power_var, expected_type=type_hints["power_var"])
            check_type(argname="argument seed", value=seed, expected_type=type_hints["seed"])
            check_type(argname="argument seed_var", value=seed_var, expected_type=type_hints["seed_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if chaos is not None:
            self._values["chaos"] = chaos
        if chaos_var is not None:
            self._values["chaos_var"] = chaos_var
        if density is not None:
            self._values["density"] = density
        if density_var is not None:
            self._values["density_var"] = density_var
        if power is not None:
            self._values["power"] = power
        if power_var is not None:
            self._values["power_var"] = power_var
        if seed is not None:
            self._values["seed"] = seed
        if seed_var is not None:
            self._values["seed_var"] = seed_var

    @builtins.property
    def chaos(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        '''
        result = self._values.get("chaos")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def chaos_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        '''
        result = self._values.get("chaos_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        '''
        result = self._values.get("density")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density_var(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        '''
        result = self._values.get("density_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        '''
        result = self._values.get("power")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power_var(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        '''
        result = self._values.get("power_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        '''
        result = self._values.get("seed")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed_var(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        result = self._values.get("seed_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultGoop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultGoopList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultGoopList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4e5fe65d8e3348d4489eca8cf7a7114fae833c4ac7438d8fcb4bb0801861484f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultGoopOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2dd99eb3c418d36e63466bae355b3daf40fcca92484f3fa3b8bb73985afeb97d)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultGoopOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0dac62993595971a3a199496dc1d73a968efb93a0391cfaf49b58ab50141f046)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__525a4c2b29068708f0a9af6be7c57879c7debddc985bb3dd4168685b635ffdf4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__22dd84769fe2fda032453c67815c420d60ebbefe0f413889861f1a6f73f55963)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultGoop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultGoop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__164521a1919516c785af1274eceada8214141922b837223f4e7894913388c770)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultGoopOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultGoopOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f3f74a139d3febca77154c1a5e743a960b8d30fa4074ea43cdfdabd2d10b05e2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetChaos")
    def reset_chaos(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaos", []))

    @jsii.member(jsii_name="resetChaosVar")
    def reset_chaos_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaosVar", []))

    @jsii.member(jsii_name="resetDensity")
    def reset_density(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensity", []))

    @jsii.member(jsii_name="resetDensityVar")
    def reset_density_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensityVar", []))

    @jsii.member(jsii_name="resetPower")
    def reset_power(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPower", []))

    @jsii.member(jsii_name="resetPowerVar")
    def reset_power_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPowerVar", []))

    @jsii.member(jsii_name="resetSeed")
    def reset_seed(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeed", []))

    @jsii.member(jsii_name="resetSeedVar")
    def reset_seed_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeedVar", []))

    @builtins.property
    @jsii.member(jsii_name="chaosInput")
    def chaos_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosInput"))

    @builtins.property
    @jsii.member(jsii_name="chaosVarInput")
    def chaos_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosVarInput"))

    @builtins.property
    @jsii.member(jsii_name="densityInput")
    def density_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityInput"))

    @builtins.property
    @jsii.member(jsii_name="densityVarInput")
    def density_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="powerInput")
    def power_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerInput"))

    @builtins.property
    @jsii.member(jsii_name="powerVarInput")
    def power_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerVarInput"))

    @builtins.property
    @jsii.member(jsii_name="seedInput")
    def seed_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedInput"))

    @builtins.property
    @jsii.member(jsii_name="seedVarInput")
    def seed_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedVarInput"))

    @builtins.property
    @jsii.member(jsii_name="chaos")
    def chaos(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaos"))

    @chaos.setter
    def chaos(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b8c36e8629a25a25eb99ebf8d70b68123cfc035a9bb1368396120d922c34fe10)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaos", value)

    @builtins.property
    @jsii.member(jsii_name="chaosVar")
    def chaos_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaosVar"))

    @chaos_var.setter
    def chaos_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__460015a33422ea0c53e841d4dde0d6dd423868e0fcc35bea88b5d3d9b0a37e38)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaosVar", value)

    @builtins.property
    @jsii.member(jsii_name="density")
    def density(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "density"))

    @density.setter
    def density(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f6d49a49a6b208bb43278fec6b42576247c325d5a4f15e011dfeb3f19859e874)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "density", value)

    @builtins.property
    @jsii.member(jsii_name="densityVar")
    def density_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "densityVar"))

    @density_var.setter
    def density_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__35f09c6ecac7f4fc184488019588de387b908d98db110bae987a5e781807ee97)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "densityVar", value)

    @builtins.property
    @jsii.member(jsii_name="power")
    def power(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "power"))

    @power.setter
    def power(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fd4fa380b3a2a03f4fab3eacebd520a50255a266fe9af7e5cf045822a4f47747)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "power", value)

    @builtins.property
    @jsii.member(jsii_name="powerVar")
    def power_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "powerVar"))

    @power_var.setter
    def power_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f831c1b4a25abfb6dcaea97ba1eedb0a8ac7167a598228bd23b1c70454517b8f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "powerVar", value)

    @builtins.property
    @jsii.member(jsii_name="seed")
    def seed(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seed"))

    @seed.setter
    def seed(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__97019dfdbe8e77ae4f6b8f3c27797c55e7847eebfbf8ff67ce29ed8819eeff2f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seed", value)

    @builtins.property
    @jsii.member(jsii_name="seedVar")
    def seed_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seedVar"))

    @seed_var.setter
    def seed_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e52dd060fa4d6b85348ba9a25d536a992e553fd0c4988b566662418408081913)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seedVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultGoop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultGoop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultGoop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2e8555b29e74c690e658bb85a4ad8151c37a7c16226f1146a825ac2e5b3668ae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultGrayscale",
    jsii_struct_bases=[],
    name_mapping={"type": "type", "type_var": "typeVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultGrayscale:
    def __init__(
        self,
        *,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param type: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fdf82984903c06af45aa9d1f521ea33f572615d1c1aa9432480aa0f73ad4ae2e)
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultGrayscale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultGrayscaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultGrayscaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f5b50d4960bffd04b07fd86dbe789427ad4a19a5a123587b0990b9a3df766879)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultGrayscaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1b78015dfc2cc6c69e217cacbe304ef585b3e8e2e846e3aab302ab7a5f85d5b3)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultGrayscaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__259b781ddc56eebbe056cdf9a8632965732707c2bbdb4ee5aefbc51679264315)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__66eae480f34166e8ae2d176983fb0e9e430fccd37ccc55755f1c341c483e90d5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8be56d772be76d3c3c982823fd325aaf19475bf06cf4cd6f5f45dbf55c556595)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultGrayscale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultGrayscale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2cd2d32f533f41e51c90bc2854691d7e85d79b4c381e5be0d874fd13b2de0f06)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultGrayscaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultGrayscaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0c0975172fe2d874c322a298ad253470cd9e045f85ab6a8b84b4a311a4677a05)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0683be390bb0603eeae32855938f831855bcd9731e1ee7aeb63eb9e6b093bda9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__81bd7541a04a06baa1bfcc1bed9be40e1fdc3eae6068b4f54613233de90db222)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultGrayscale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultGrayscale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultGrayscale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bfa9eba2c5d94af46b7a6cf282a5f153b8a73a3f18acfc1d6274055da2a22987)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultHsl",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "lightness": "lightness",
        "lightness_var": "lightnessVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultHsl:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness: typing.Optional[builtins.str] = None,
        lightness_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        :param lightness_var: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a0beb4599e5a1e173b91de74c796466be3c27c76bf091eb051c5027457e5c788)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness", value=lightness, expected_type=type_hints["lightness"])
            check_type(argname="argument lightness_var", value=lightness_var, expected_type=type_hints["lightness_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness is not None:
            self._values["lightness"] = lightness
        if lightness_var is not None:
            self._values["lightness_var"] = lightness_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        '''
        result = self._values.get("lightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        '''
        result = self._values.get("lightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultHsl(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultHslList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultHslList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__de4f5bafa1ae20579c41b8c7c8883747d19d4e1e01e1ce3bdd86d50e7e9803a2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultHslOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a8eb33a55c613f0bc85443375a082dbb84028ffe2ea3da492282b49edd5bbc81)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultHslOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a157f6a696ec1dd4bc1d737fe4fecedc8c1adca71ce3231bd5e78e2465439396)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ebad15043604645bb7abf78945b7cdcf195d1b84cb786446abf3723b101a8b2d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__51fdb0aee06e1da82769af0a86403906e71a2550d8ac5aa912b263cc41f96b8c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultHsl]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultHsl]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1025a79fb032ed334f9d72d8970fcc9f0c4749d214f7563c7e05453616e13646)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultHslOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultHslOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a84477c1ec0fd1f036c62b6b769066db7709a654c6fa58d89695c4880af9a45)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightness")
    def reset_lightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightness", []))

    @jsii.member(jsii_name="resetLightnessVar")
    def reset_lightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessInput")
    def lightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessVarInput")
    def lightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1badb2e0bec5a8425c0875e23d4375aa9b341baaf3119c93104bab9d4b5f3879)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ed83f9df7f15ba1d820911823e9f410e8e116c76e9dce7d8c3ee739f8a0d39e3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightness")
    def lightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightness"))

    @lightness.setter
    def lightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ecc230d5862fc0558dbe323c5dbf5e53d66ef0b7a2f49fce35995650f863e866)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightness", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessVar")
    def lightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessVar"))

    @lightness_var.setter
    def lightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__093272db22703b3a15f6b66ffd480220037936ced3eb02a8ef3b49e116533339)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9783637db1271d32cadf76ca4f7a2bdd5ef838040afd8c74f812c1038242a1ff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__904688b0143bf83d6737faa029ec2cd7c68555310b5c46a218d3fe7d34d2f892)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultHsl]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultHsl]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultHsl]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fd737d9969e43bbe977d8d588af87c0672daabcc73b5ce1431bb4b339767962f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultHsv",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultHsv:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        :param value: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d2762b20e6b25a31bba67c5adedc5b74a41f7e62f6639a97ff7afea13cde090b)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultHsv(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultHsvList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultHsvList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac26996813a0ebe2656189771b58a84231011eedbe653be2b8d1d2b7f00e991e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultHsvOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ea11a1ba1e805eddf89c93758e7b7b04ec9b565db37575c4ef8c560cc9ee727)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultHsvOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3dd56e4debd6a1657cbb79aca434d304e4ce8296d5fa92b7b219da2c782a44fb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__61ce0b3702f6661f4722506146de04206a00630128616785e68bd9f1b540f01d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__540f5f64465f4c2a497a06b458156702dd372a2d689c9b977e47de44a7711252)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultHsv]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultHsv]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa51af8612e9211f2b885e11a7131227775e9c97818c04c949b425ba5ef392fe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultHsvOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultHsvOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e0210fa9e95e0098bfddfdfe5bbda4320db3078a2bf13d7f99444f6624559cd4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2528c3368ba47305f1312554ed81a23f7977eb63fb1861cfb990f09e92d58e7b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__679b9d1e92b494718aa5fe6d50a334b4b578cf1b3a68947d9b677ca3eabd6cd5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9e8fbaf3281be135b6aa9a1656f3ff19ed781cf08bed03e8c232c1853179c97e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__471e84fd8ed5c936fc47253e6b3637f5a2ab28f81e6f279e1fefaecbb9c09444)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__02db0b8237a52ba3b8fa2b99c2fdcba8df5a5ee81d5e20c4e01493308c9651d0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d8e8bb996af54cda73c2f3fd0cfb420a44ce51a5326dc7a0dcb4b78bda09b731)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultHsv]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultHsv]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultHsv]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__14e2a91ecfb9880e6f610adf139f0e3580cdcc2a3b8ae749e3f4aa227bc777f2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfDimension",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "dimension": "dimension",
        "dimension_var": "dimensionVar",
        "equal": "equal",
        "greater_than": "greaterThan",
        "less_than": "lessThan",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfDimension:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        dimension: typing.Optional[builtins.str] = None,
        dimension_var: typing.Optional[builtins.str] = None,
        equal: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionEqual", typing.Dict[builtins.str, typing.Any]]] = None,
        greater_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionGreaterThan", typing.Dict[builtins.str, typing.Any]]] = None,
        less_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionLessThan", typing.Dict[builtins.str, typing.Any]]] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param dimension: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        :param dimension_var: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        :param equal: equal block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        :param greater_than: greater_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        :param less_than: less_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        :param value: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionDefault(**default)
        if isinstance(equal, dict):
            equal = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionEqual(**equal)
        if isinstance(greater_than, dict):
            greater_than = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionGreaterThan(**greater_than)
        if isinstance(less_than, dict):
            less_than = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionLessThan(**less_than)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fbdf7cf0c3d4945a5d6c1b4b40d28b26f74cbb90ed090fcc33c69c2cc8b77246)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument dimension", value=dimension, expected_type=type_hints["dimension"])
            check_type(argname="argument dimension_var", value=dimension_var, expected_type=type_hints["dimension_var"])
            check_type(argname="argument equal", value=equal, expected_type=type_hints["equal"])
            check_type(argname="argument greater_than", value=greater_than, expected_type=type_hints["greater_than"])
            check_type(argname="argument less_than", value=less_than, expected_type=type_hints["less_than"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if dimension is not None:
            self._values["dimension"] = dimension
        if dimension_var is not None:
            self._values["dimension_var"] = dimension_var
        if equal is not None:
            self._values["equal"] = equal
        if greater_than is not None:
            self._values["greater_than"] = greater_than
        if less_than is not None:
            self._values["less_than"] = less_than
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionDefault"], result)

    @builtins.property
    def dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        '''
        result = self._values.get("dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        '''
        result = self._values.get("dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def equal(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionEqual"]:
        '''equal block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        '''
        result = self._values.get("equal")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionEqual"], result)

    @builtins.property
    def greater_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionGreaterThan"]:
        '''greater_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        '''
        result = self._values.get("greater_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionGreaterThan"], result)

    @builtins.property
    def less_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionLessThan"]:
        '''less_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        '''
        result = self._values.get("less_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionLessThan"], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfDimension(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5fa50ed4910b72a724e08934bb0389841a3c662946f9cd0e8cbdc6c86272b881)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d6ce72ff3d9a2703a7e47434dd17404abe00e4cc8d43e04b26a074bb50f881ab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionEqual",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionEqual:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionEqual(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionEqualOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionEqualOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__36b7d3f28a890252df6ac626542bc1c262bfd9ac63872178178107cd1b176ac9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionEqual], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionEqual],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ae38796c4438c774ea3620857671246dc79acdd9882060456b3aa033aec953c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionGreaterThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionGreaterThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionGreaterThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionGreaterThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionGreaterThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c7a2e1d9032c066259ec75eb00f7134e6f54239fffc5e7b0c3cb977866e38135)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionGreaterThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionGreaterThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ae5c09b6ae45bd0e44723d5f8e26996f39880ede5539539d8ed5fe006ea7d26b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionLessThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionLessThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionLessThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionLessThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionLessThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e079ea412defcaa6917a5c8b274a1fba652bd12c50a78f7ebdb56bacd8214064)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionLessThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionLessThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b1abb82b168b4132ed16b9c827ec45b07f378e52fc7fd11cc3c62c777c5367e3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__81d25e86d5f7124c8705790316f075a3ffeaab7d29c6af65746187923a1792d3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__23ca6f393156b804a3c1abff62f2395dec0ac4a1ab8261102a2525977b8f06cf)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d1987e94f1d9453485cb6fa8e0235d7194cf33f6d2bda089318fec188b31f5a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4320a6c654c854ba3d7de5ff8a39a283bb90dc3bd17ff9ed810e3f260819e99e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ff5b5b1078eb35d5a356bb6b2493f106c37df300afa5b15998d573f3b17fa660)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfDimension]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfDimension]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d27cae2108f636afdc7fe6889cf90f8fa0c50bc7131214d4f41933a2e1804d76)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c2ec28b02c79ae259b08837a602c926f290021d905339de84c50ab0d3d19ae67)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putEqual")
    def put_equal(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionEqual()

        return typing.cast(None, jsii.invoke(self, "putEqual", [value]))

    @jsii.member(jsii_name="putGreaterThan")
    def put_greater_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionGreaterThan()

        return typing.cast(None, jsii.invoke(self, "putGreaterThan", [value]))

    @jsii.member(jsii_name="putLessThan")
    def put_less_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionLessThan()

        return typing.cast(None, jsii.invoke(self, "putLessThan", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetDimension")
    def reset_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimension", []))

    @jsii.member(jsii_name="resetDimensionVar")
    def reset_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimensionVar", []))

    @jsii.member(jsii_name="resetEqual")
    def reset_equal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEqual", []))

    @jsii.member(jsii_name="resetGreaterThan")
    def reset_greater_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGreaterThan", []))

    @jsii.member(jsii_name="resetLessThan")
    def reset_less_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLessThan", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="equal")
    def equal(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionEqualOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionEqualOutputReference, jsii.get(self, "equal"))

    @builtins.property
    @jsii.member(jsii_name="greaterThan")
    def greater_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionGreaterThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionGreaterThanOutputReference, jsii.get(self, "greaterThan"))

    @builtins.property
    @jsii.member(jsii_name="lessThan")
    def less_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionLessThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionLessThanOutputReference, jsii.get(self, "lessThan"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionInput")
    def dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionVarInput")
    def dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="equalInput")
    def equal_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionEqual], jsii.get(self, "equalInput"))

    @builtins.property
    @jsii.member(jsii_name="greaterThanInput")
    def greater_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionGreaterThan], jsii.get(self, "greaterThanInput"))

    @builtins.property
    @jsii.member(jsii_name="lessThanInput")
    def less_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionLessThan], jsii.get(self, "lessThanInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="dimension")
    def dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimension"))

    @dimension.setter
    def dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3f278f10f16fb1aa545463a8e8d41492250fa11070d5d8e21bd0836a31bd42b2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimension", value)

    @builtins.property
    @jsii.member(jsii_name="dimensionVar")
    def dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimensionVar"))

    @dimension_var.setter
    def dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__05e1ca7fb0b4ee15385453448f262c340cffba15a8643945adbd4f0a53ee451d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3cc33aaf5bc70c56131f26e3c930d32f8286add9db1bee9b84cfad3febb93218)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__61656ecec82e54a3d4238b725a03757944e63c9706a4065486f500028f5b05c2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfDimension]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfDimension]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfDimension]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4eae1f5b426c36692ddf63ea333e886ada5e507ba60ca709daf569d80e5620ef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfOrientation",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "landscape": "landscape",
        "portrait": "portrait",
        "square": "square",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfOrientation:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        landscape: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationLandscape", typing.Dict[builtins.str, typing.Any]]] = None,
        portrait: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationPortrait", typing.Dict[builtins.str, typing.Any]]] = None,
        square: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationSquare", typing.Dict[builtins.str, typing.Any]]] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param landscape: landscape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        :param portrait: portrait block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        :param square: square block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationDefault(**default)
        if isinstance(landscape, dict):
            landscape = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationLandscape(**landscape)
        if isinstance(portrait, dict):
            portrait = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationPortrait(**portrait)
        if isinstance(square, dict):
            square = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationSquare(**square)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c3980db62a71b0f5dd6f6b543d55675d09fe15698a9e022e58af0aad6e012142)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument landscape", value=landscape, expected_type=type_hints["landscape"])
            check_type(argname="argument portrait", value=portrait, expected_type=type_hints["portrait"])
            check_type(argname="argument square", value=square, expected_type=type_hints["square"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if landscape is not None:
            self._values["landscape"] = landscape
        if portrait is not None:
            self._values["portrait"] = portrait
        if square is not None:
            self._values["square"] = square

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationDefault"], result)

    @builtins.property
    def landscape(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationLandscape"]:
        '''landscape block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        '''
        result = self._values.get("landscape")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationLandscape"], result)

    @builtins.property
    def portrait(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationPortrait"]:
        '''portrait block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        '''
        result = self._values.get("portrait")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationPortrait"], result)

    @builtins.property
    def square(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationSquare"]:
        '''square block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        result = self._values.get("square")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationSquare"], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfOrientation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__850377aba1ed36b5a80536e9b39f41ed129985aa15412cd30833aa42b384fd66)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__739a3ea245791f90c9c05fb33ac906c707ca20383898354cd6cae5b7aa9bb31d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationLandscape",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationLandscape:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationLandscape(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationLandscapeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationLandscapeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ca0ac85b27b41296a5f227131a57e0a8e86b54d752be0a936c2168718e44362)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationLandscape], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationLandscape],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ef196bdef871e8919b6efe356d16d036f26769a9b1c62343e7a8f185dc59518)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b26639d9d02a49f923377c911dd7cd3e722876501f5f856ad99fd2c2ab84c2bd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__95f027eabe6b34aa34f4a287ecf9d959b6733534c377b55f81c9be1c0d143646)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c72bac1ce984bfdb83c8d88051336681f3f059d75b2a80615dca18181d6e43fd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dae01105ca2c967cd58af1e68abb64b26d3a69ff543df2c1920dbed6168e102b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e9475c9849044d27da58888bc2ce243169eb8049523366725086bcc1705195ad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfOrientation]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfOrientation]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f482b51361e96e98505093d2f9246d9d68bdf1aaea4a9894d162161229c06ac8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__815cf5a3f84dae48f01bd1a1f39ffc00f224b238a61925791f17cd61ab60869c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putLandscape")
    def put_landscape(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationLandscape()

        return typing.cast(None, jsii.invoke(self, "putLandscape", [value]))

    @jsii.member(jsii_name="putPortrait")
    def put_portrait(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationPortrait()

        return typing.cast(None, jsii.invoke(self, "putPortrait", [value]))

    @jsii.member(jsii_name="putSquare")
    def put_square(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationSquare()

        return typing.cast(None, jsii.invoke(self, "putSquare", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetLandscape")
    def reset_landscape(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLandscape", []))

    @jsii.member(jsii_name="resetPortrait")
    def reset_portrait(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPortrait", []))

    @jsii.member(jsii_name="resetSquare")
    def reset_square(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSquare", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="landscape")
    def landscape(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationLandscapeOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationLandscapeOutputReference, jsii.get(self, "landscape"))

    @builtins.property
    @jsii.member(jsii_name="portrait")
    def portrait(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationPortraitOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationPortraitOutputReference", jsii.get(self, "portrait"))

    @builtins.property
    @jsii.member(jsii_name="square")
    def square(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationSquareOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationSquareOutputReference", jsii.get(self, "square"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="landscapeInput")
    def landscape_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationLandscape], jsii.get(self, "landscapeInput"))

    @builtins.property
    @jsii.member(jsii_name="portraitInput")
    def portrait_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationPortrait"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationPortrait"], jsii.get(self, "portraitInput"))

    @builtins.property
    @jsii.member(jsii_name="squareInput")
    def square_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationSquare"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationSquare"], jsii.get(self, "squareInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfOrientation]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfOrientation]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfOrientation]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e631af7afedaac55f9ef71f0eae12948322470097a5eb157ac5f871014984024)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationPortrait",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationPortrait:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationPortrait(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationPortraitOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationPortraitOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c8af83e45900f9e6f9ac8f3a12379680705d89ab321df6e25235393bb66369d6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationPortrait]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationPortrait], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationPortrait],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8d49aee230aca26f21d25d9ce8ae08c22d58cfedddec9e0bf955c7e6b44d04e7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationSquare",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationSquare:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationSquare(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationSquareOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationSquareOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__15c46ef2bbb9859833ca6319d0cd71b4da310c879f400814f8e5f61703a1631f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationSquare]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationSquare], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationSquare],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3294dcbb813f79120ed2ba5d9e35fb3db6c472bf0dfa775c6ba60a1e01074c94)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultImQuery",
    jsii_struct_bases=[],
    name_mapping={
        "allowed_transformations": "allowedTransformations",
        "query_var": "queryVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultImQuery:
    def __init__(
        self,
        *,
        allowed_transformations: typing.Sequence[builtins.str],
        query_var: builtins.str,
    ) -> None:
        '''
        :param allowed_transformations: Specifies the transformations that can be applied using the query string parameter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allowed_transformations DataAkamaiImagingPolicyImage#allowed_transformations}
        :param query_var: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#query_var DataAkamaiImagingPolicyImage#query_var}.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__48faf5dcb5069fdd35cfb7b1895da0c794aa460d8c3edca7f38bb2155c9b3f7d)
            check_type(argname="argument allowed_transformations", value=allowed_transformations, expected_type=type_hints["allowed_transformations"])
            check_type(argname="argument query_var", value=query_var, expected_type=type_hints["query_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "allowed_transformations": allowed_transformations,
            "query_var": query_var,
        }

    @builtins.property
    def allowed_transformations(self) -> typing.List[builtins.str]:
        '''Specifies the transformations that can be applied using the query string parameter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allowed_transformations DataAkamaiImagingPolicyImage#allowed_transformations}
        '''
        result = self._values.get("allowed_transformations")
        assert result is not None, "Required property 'allowed_transformations' is missing"
        return typing.cast(typing.List[builtins.str], result)

    @builtins.property
    def query_var(self) -> builtins.str:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#query_var DataAkamaiImagingPolicyImage#query_var}.'''
        result = self._values.get("query_var")
        assert result is not None, "Required property 'query_var' is missing"
        return typing.cast(builtins.str, result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultImQuery(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultImQueryList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultImQueryList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__24e6ddfd22b91fab44c1851fc1100540a1aa1d6c3b0ebfa9c95430c40c456edb)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultImQueryOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__558c18790756a30ec42abca303ffdc51a17a0848d64a933ccd04e07b13df792c)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultImQueryOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2e2fc4156f200db6c6be8445f5d253520b8bedc63cb59eae4d58534076a3a141)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a96e2753778f660008842245a70a41cef1d7a7ac0beb9bd514f8aa07d72a7556)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4fd59375cc60f48592d73f9757b9113341a17a4f3399ff7650b76cd81e13a3ec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultImQuery]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultImQuery]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultImQuery]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f961db30654a9b9ac71745ad23ac6417bf6b536804681985796ee74378d54b09)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultImQueryOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultImQueryOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f0feeed0f6fba71f546227b4119abd4b0d9075aef49c59232d65af1008ce5a46)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @builtins.property
    @jsii.member(jsii_name="allowedTransformationsInput")
    def allowed_transformations_input(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "allowedTransformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="queryVarInput")
    def query_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "queryVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowedTransformations")
    def allowed_transformations(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "allowedTransformations"))

    @allowed_transformations.setter
    def allowed_transformations(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9fc9c28f4dab19cc32e17bcbb084b62a09b12c98ae64ac70a1cfc11e6311df42)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowedTransformations", value)

    @builtins.property
    @jsii.member(jsii_name="queryVar")
    def query_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "queryVar"))

    @query_var.setter
    def query_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1624e1a8992e993b09c649c4bf468a1ac30f6fcc042f898db189c768b6ec347e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "queryVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultImQuery]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultImQuery]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultImQuery]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__903044201a8b50f6c8928b7ac51cb8f20ecfa5d2e6fd9c5aebcb28450a1c0480)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultMaxColors",
    jsii_struct_bases=[],
    name_mapping={"colors": "colors", "colors_var": "colorsVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultMaxColors:
    def __init__(
        self,
        *,
        colors: typing.Optional[builtins.str] = None,
        colors_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param colors: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        :param colors_var: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__587b34aa22f2a2c8bb889e0856a3a2b6650aff7b73f81baf6eb73bb73eaee356)
            check_type(argname="argument colors", value=colors, expected_type=type_hints["colors"])
            check_type(argname="argument colors_var", value=colors_var, expected_type=type_hints["colors_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if colors is not None:
            self._values["colors"] = colors
        if colors_var is not None:
            self._values["colors_var"] = colors_var

    @builtins.property
    def colors(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        '''
        result = self._values.get("colors")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def colors_var(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        result = self._values.get("colors_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultMaxColors(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultMaxColorsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultMaxColorsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e660f8273517295d2e57ffc708d4fea38e6f151d2344d1c02c8ef3a372c7cebe)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultMaxColorsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__85f33b8450f5c70b73b42757d030d3e6bb3a1a222d4c41b2ada7343d367838f8)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultMaxColorsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__67b2ca43d175368b2429160575787a37f0333ebd4c858d8f96e5fab2f7a0c44a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fef4af94b55679a826d0279bdad3bf35384c322f3b1f80de899d892ca6ec6fa1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__03e786f63ed1e1399a0f08cbaf0e91304024e764f336e2773f4371acd5ed292a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultMaxColors]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultMaxColors]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c02823035a332c2082cb8ebfc4e253ff12362921fd3ae52786a4f66c04f8a7f4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultMaxColorsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultMaxColorsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e8b3bf062d60a8c64328e86b2f25f5f796d1e6b0e7e5eff93742bf23a4612f8d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColors")
    def reset_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColors", []))

    @jsii.member(jsii_name="resetColorsVar")
    def reset_colors_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorsVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorsInput")
    def colors_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsInput"))

    @builtins.property
    @jsii.member(jsii_name="colorsVarInput")
    def colors_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsVarInput"))

    @builtins.property
    @jsii.member(jsii_name="colors")
    def colors(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colors"))

    @colors.setter
    def colors(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5c3c7f782207751ec5e29e2e84c31202220e1ab26b02a76b708d131c75691f61)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colors", value)

    @builtins.property
    @jsii.member(jsii_name="colorsVar")
    def colors_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorsVar"))

    @colors_var.setter
    def colors_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ec7eb81c0064a3bf1f2a4bdf9c074610cbec428915696769e981076490e8d1b9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorsVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultMaxColors]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultMaxColors]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultMaxColors]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__388c6ac80137194e7666274d89d987f6132e544e9ba4343e1d17efbd0a95fc65)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultMirror",
    jsii_struct_bases=[],
    name_mapping={
        "horizontal": "horizontal",
        "horizontal_var": "horizontalVar",
        "vertical": "vertical",
        "vertical_var": "verticalVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultMirror:
    def __init__(
        self,
        *,
        horizontal: typing.Optional[builtins.str] = None,
        horizontal_var: typing.Optional[builtins.str] = None,
        vertical: typing.Optional[builtins.str] = None,
        vertical_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param horizontal: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        :param horizontal_var: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        :param vertical: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        :param vertical_var: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2abf4f7effcbbef8882c55c165ee35c752434a7c1b923812c3bd09234554db80)
            check_type(argname="argument horizontal", value=horizontal, expected_type=type_hints["horizontal"])
            check_type(argname="argument horizontal_var", value=horizontal_var, expected_type=type_hints["horizontal_var"])
            check_type(argname="argument vertical", value=vertical, expected_type=type_hints["vertical"])
            check_type(argname="argument vertical_var", value=vertical_var, expected_type=type_hints["vertical_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if horizontal is not None:
            self._values["horizontal"] = horizontal
        if horizontal_var is not None:
            self._values["horizontal_var"] = horizontal_var
        if vertical is not None:
            self._values["vertical"] = vertical
        if vertical_var is not None:
            self._values["vertical_var"] = vertical_var

    @builtins.property
    def horizontal(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        '''
        result = self._values.get("horizontal")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def horizontal_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        '''
        result = self._values.get("horizontal_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        '''
        result = self._values.get("vertical")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        result = self._values.get("vertical_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultMirror(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultMirrorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultMirrorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__33bc26ad65db1cb60a38aed1ab327da55bbe296b7fe448c3d408f38668800b96)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultMirrorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e8262cfb06c9a66dbecbad706fa5522ce45f69274e8ce7fc62c03a770547313e)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultMirrorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2740c08fcdd9b4c6f330db2a40d3d2203599f3a1655b9977fdf792fd1693855f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d9b77f8a727aa73b03fe29baf46c33a3726640cba83e52b23ab95b3b2c71ad3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4c9f6a15c664ebac842d51971de6a8664b9a63a0f08d71f29b24b9265f2cf728)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultMirror]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultMirror]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__263793fdf137e780a2bbb5e8db07c79b064feceb1cecd728df9067e4def8b510)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultMirrorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultMirrorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__14daba4d2e169619bbe03c4b30900bf8867666f2d6694ae9b8e9229cc8c3a9f8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHorizontal")
    def reset_horizontal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontal", []))

    @jsii.member(jsii_name="resetHorizontalVar")
    def reset_horizontal_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontalVar", []))

    @jsii.member(jsii_name="resetVertical")
    def reset_vertical(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVertical", []))

    @jsii.member(jsii_name="resetVerticalVar")
    def reset_vertical_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVerticalVar", []))

    @builtins.property
    @jsii.member(jsii_name="horizontalInput")
    def horizontal_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontalVarInput")
    def horizontal_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalInput")
    def vertical_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalVarInput")
    def vertical_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontal")
    def horizontal(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontal"))

    @horizontal.setter
    def horizontal(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ee96df8a19d8ed1fab6a2eeff641faffd47f3db9aa47f39f5738d0b850b229ed)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontal", value)

    @builtins.property
    @jsii.member(jsii_name="horizontalVar")
    def horizontal_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontalVar"))

    @horizontal_var.setter
    def horizontal_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f539a6e3e110fb1a28558ff0e5ff59d0e4dface8ba14abf7bb4ad0ba714adaa9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontalVar", value)

    @builtins.property
    @jsii.member(jsii_name="vertical")
    def vertical(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "vertical"))

    @vertical.setter
    def vertical(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__967a783205b4bbbb968d7eb4ee81712cb2f196f0faa7abc44bd78c5f43d7689d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "vertical", value)

    @builtins.property
    @jsii.member(jsii_name="verticalVar")
    def vertical_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "verticalVar"))

    @vertical_var.setter
    def vertical_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__77fafb50efa46b38a0e43773101299558172da055a3ecea7f632e8d9704416da)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "verticalVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultMirror]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultMirror]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultMirror]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c55446020547f99b3f164e31becd21710c2098236fbdf2228056218e6d33e2ee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultMonoHue",
    jsii_struct_bases=[],
    name_mapping={"hue": "hue", "hue_var": "hueVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultMonoHue:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f2cd4d01bbff009c38859e78263e88a15f2fbb1812c39d44efa1a19abf4998e6)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultMonoHue(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultMonoHueList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultMonoHueList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a491601ce398146b9308a86d8735766e4a897a9f59f5feaebd2320a180cbb28)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultMonoHueOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__265b23dffba9d987cad165c33ae597b818314c8f57908cc55d21af80716a5199)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultMonoHueOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__893d0028bae586d644dbdefd10cd4c5544c2e569ff01bd6d326ff9a4aa7d0c33)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a89e3dadfe1c36f2af292f80aa6d47ee1e99e2e48403b1ea425d4391d4b6ce3a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__804f9d65b0d761a744ebd460716b98bb6e308b710da6db28c60e232518988510)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultMonoHue]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultMonoHue]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1aa79d3c16cf37e06d677722a2c9192880a39d3630fba9a202f1f32471244d2b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultMonoHueOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultMonoHueOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aa7d49a332416641ce14b504fd21fe95a7660bf5ad1ce2bef1e9741747149bd4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a29ccc117807d5f918c625062e6384622d1e605f78ef41a04f2184ac6d052b95)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__16d87ccf570dcd55f13df4aed549e3391891bfa0e9bcb6cb1df2622a8aed191c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultMonoHue]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultMonoHue]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultMonoHue]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a4072ee920a7e8d78a7c396862edbcede2274e4f515f49ae89807289bad3ee7c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultOpacity",
    jsii_struct_bases=[],
    name_mapping={"opacity": "opacity", "opacity_var": "opacityVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultOpacity:
    def __init__(
        self,
        *,
        opacity: typing.Optional[builtins.str] = None,
        opacity_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param opacity: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param opacity_var: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__577920a34ee654cd225061aeabad32ec5c57372f695ec270b91b9e62ec6bf349)
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument opacity_var", value=opacity_var, expected_type=type_hints["opacity_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if opacity is not None:
            self._values["opacity"] = opacity
        if opacity_var is not None:
            self._values["opacity_var"] = opacity_var

    @builtins.property
    def opacity(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def opacity_var(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        result = self._values.get("opacity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultOpacity(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultOpacityList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultOpacityList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__99f355919144826c60cafebd86563cdd90b3a664ac38ba2f456cc9a1326fcf15)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultOpacityOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__67fef8295eb92aa0e27590b1a6b4791ad99175f825158a527f72b44e6f5354d6)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultOpacityOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f2b0e3f974361181f5511b09e92546f14aed0577c0746572a394d190d736db28)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ba7f0a69a6f15d4403fccc8455a32dfaaa1f71490525901ab4b6a090f610d76b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b183c9057531c7f97bb1732ae7abb98937f96066e83731f9276d57778ad1dd64)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultOpacity]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultOpacity]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__63b56a79292634505af44d23f4a08757235dd064b14b9786f569acfcb2d304b0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultOpacityOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultOpacityOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__66f27f999f1e5f790110ed89b1b496c84e567df5c4876d4b2674b08ff6ad9efe)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetOpacityVar")
    def reset_opacity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacityVar", []))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityVarInput")
    def opacity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacity"))

    @opacity.setter
    def opacity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__58dd44cf391fdc908870763b3c2d783b520054b4b829ccc8b6f186a67baa65ab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacity", value)

    @builtins.property
    @jsii.member(jsii_name="opacityVar")
    def opacity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacityVar"))

    @opacity_var.setter
    def opacity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4c7185f6cfc2aa4e814978c2c9cc64a6970f14f2e6c4215a1e1250978abcdf3b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacityVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultOpacity]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultOpacity]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultOpacity]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4fa4cde12bc4392ed7c18327e136d7129d34a420c89eb3b9656f448dabd1eceb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c427a56d71755925ac720b12471fe2ab5615213f4c7461be89a5d430b797a0e6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putAppend")
    def put_append(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultAppend, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e094b64b42338df6f511f72b9d0fbc0d856ac4788c29a745b02c63929289f0e6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putAppend", [value]))

    @jsii.member(jsii_name="putAspectCrop")
    def put_aspect_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultAspectCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__458bd9607c30db97ad77208b41cd8c4d9ef5cbd3dcabf0a2b5445312f052d52d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putAspectCrop", [value]))

    @jsii.member(jsii_name="putBackgroundColor")
    def put_background_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd8bb08bdc86e088a4b037042b7cb9dc332b922b3d3b9276322b27d85d99f2f7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBackgroundColor", [value]))

    @jsii.member(jsii_name="putBlur")
    def put_blur(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultBlur, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5edac6f1e7238f84a1cc578abf17bf0a9281a6f2cf104a34f5b2953e07c38fcb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBlur", [value]))

    @jsii.member(jsii_name="putChromaKey")
    def put_chroma_key(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultChromaKey, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d858c27e9452bd2808f71eaa07c478aa20c1c47660479a57dd85d51dfc7b5826)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putChromaKey", [value]))

    @jsii.member(jsii_name="putComposite")
    def put_composite(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultComposite, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__98fe7224d2ce87fff13aa545b2f470093ca380e7b8ec2b87ade71c240e393356)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putComposite", [value]))

    @jsii.member(jsii_name="putCompound")
    def put_compound(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultCompound, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5cb7385b818aceec6d92c54b35edac0f7c1f4e5eff395a3702c203588b757141)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCompound", [value]))

    @jsii.member(jsii_name="putContrast")
    def put_contrast(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultContrast, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3125f0a2af02a3998494a51af590bf0fbfbc0be63892aba7a58bd927e7e4d7fe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putContrast", [value]))

    @jsii.member(jsii_name="putCrop")
    def put_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d1a5b901195cc9120fd71eed58362dae615d786e114e3b966fd397055e9a1499)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCrop", [value]))

    @jsii.member(jsii_name="putFaceCrop")
    def put_face_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultFaceCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0d2d7b4846649eeb3b6208df88ab315271979646505bdaeb2c92f8dcd021ab6e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFaceCrop", [value]))

    @jsii.member(jsii_name="putFeatureCrop")
    def put_feature_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultFeatureCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__305fe647e1471c7e773d5ec2dfe4f81ffefdc019d42cb60cea1beb3425fff23d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFeatureCrop", [value]))

    @jsii.member(jsii_name="putFitAndFill")
    def put_fit_and_fill(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultFitAndFill, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2c01c99c8af83668384e3d87b5e17e4eb898b4d18b23eeb399c195c73b824e53)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFitAndFill", [value]))

    @jsii.member(jsii_name="putGoop")
    def put_goop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultGoop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d508ba113569183fb98f4e4e0f277411b5406c26228dbe66f3758955bfc8057b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGoop", [value]))

    @jsii.member(jsii_name="putGrayscale")
    def put_grayscale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultGrayscale, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__83db96f3da729d261ee5ecf46af9e9dda5e9215d20a80072fa728456cfb6ee41)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGrayscale", [value]))

    @jsii.member(jsii_name="putHsl")
    def put_hsl(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultHsl, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__835e8032b0d547b0b7294b60d95e4c651bdb84b8825fab99ce0ff2e96213ffce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsl", [value]))

    @jsii.member(jsii_name="putHsv")
    def put_hsv(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultHsv, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__42b12f886ec6fa1c56b81d029916339fb66eadda8b42db134a3b068083ef19ac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsv", [value]))

    @jsii.member(jsii_name="putIfDimension")
    def put_if_dimension(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfDimension, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ef776352b09701e5102240a2b21e70881391a1c0c9172d29e70cef81b9e9fc37)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfDimension", [value]))

    @jsii.member(jsii_name="putIfOrientation")
    def put_if_orientation(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9fb0cf452742664e5f3831806115bff6239dd72bbddf41db809ec6138747a4d4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfOrientation", [value]))

    @jsii.member(jsii_name="putImQuery")
    def put_im_query(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultImQuery, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ca1158020acb6ad136be7d45e95270e78b2ea90e1c36f42a45337e05b16a270)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putImQuery", [value]))

    @jsii.member(jsii_name="putMaxColors")
    def put_max_colors(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultMaxColors, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__84dfb10ac7ec61155b092a627362201df62fbff7294ae46fe5cbd6fe69a534fc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMaxColors", [value]))

    @jsii.member(jsii_name="putMirror")
    def put_mirror(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultMirror, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f0b10069a6de90595fbfb50c3b7117182b1f7b0094d3af380ece2a5bd3b5b8b2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMirror", [value]))

    @jsii.member(jsii_name="putMonoHue")
    def put_mono_hue(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultMonoHue, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__838e839118de0637f153570ade500ea628782fcdc7d17505ee50a1db3010019e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMonoHue", [value]))

    @jsii.member(jsii_name="putOpacity")
    def put_opacity(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultOpacity, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a949e581b0c1a757819fdda228fab6c446389d8789146e1a62c5afb5f1f25ac3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putOpacity", [value]))

    @jsii.member(jsii_name="putRegionOfInterestCrop")
    def put_region_of_interest_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultRegionOfInterestCrop", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8e794c9b23245c8f182b8db3722a1bbd22e1e26ff6a7756c8a1e685be989dbde)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRegionOfInterestCrop", [value]))

    @jsii.member(jsii_name="putRelativeCrop")
    def put_relative_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultRelativeCrop", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2facc8fc1b3edb3fdc3be1f5cf8aafca71793e3848827d03e8697998d70ac90d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRelativeCrop", [value]))

    @jsii.member(jsii_name="putRemoveColor")
    def put_remove_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultRemoveColor", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__de71eb9bdadcf9eb8000b36dbece64e479fc947201d13fa7b38828502d1ae5a3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRemoveColor", [value]))

    @jsii.member(jsii_name="putResize")
    def put_resize(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultResize", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ff5ca93e9753a66bb562e371ef9612a2f02934e3969cef1d61ec28f3dbadedf8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putResize", [value]))

    @jsii.member(jsii_name="putRotate")
    def put_rotate(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultRotate", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b2987cb90fc9c9dcecf9f4a209c47d972b700b933c0337402cc0f3694974a142)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRotate", [value]))

    @jsii.member(jsii_name="putScale")
    def put_scale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultScale", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ad724bd3f52e718f4864c27f9e327d50adae68139b0db7e0879df873205728a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putScale", [value]))

    @jsii.member(jsii_name="putShear")
    def put_shear(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultShear", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d8be509c02d2ef7fadac4801ed87ceb71155553959b14a99d459d12451fa8d1d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putShear", [value]))

    @jsii.member(jsii_name="putTrim")
    def put_trim(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultTrim", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__18ba9f540dcaa5d05b37f64f68d59bb696c2336fd19e9896e75f72dddb8e5b96)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTrim", [value]))

    @jsii.member(jsii_name="putUnsharpMask")
    def put_unsharp_mask(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultUnsharpMask", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d3f2fe953fa40dc49c12ca34fbd836e92ce38086897649fc1b6f189b645a74ad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putUnsharpMask", [value]))

    @jsii.member(jsii_name="resetAppend")
    def reset_append(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAppend", []))

    @jsii.member(jsii_name="resetAspectCrop")
    def reset_aspect_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspectCrop", []))

    @jsii.member(jsii_name="resetBackgroundColor")
    def reset_background_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBackgroundColor", []))

    @jsii.member(jsii_name="resetBlur")
    def reset_blur(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBlur", []))

    @jsii.member(jsii_name="resetChromaKey")
    def reset_chroma_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChromaKey", []))

    @jsii.member(jsii_name="resetComposite")
    def reset_composite(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetComposite", []))

    @jsii.member(jsii_name="resetCompound")
    def reset_compound(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCompound", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetCrop")
    def reset_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCrop", []))

    @jsii.member(jsii_name="resetFaceCrop")
    def reset_face_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFaceCrop", []))

    @jsii.member(jsii_name="resetFeatureCrop")
    def reset_feature_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureCrop", []))

    @jsii.member(jsii_name="resetFitAndFill")
    def reset_fit_and_fill(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFitAndFill", []))

    @jsii.member(jsii_name="resetGoop")
    def reset_goop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGoop", []))

    @jsii.member(jsii_name="resetGrayscale")
    def reset_grayscale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGrayscale", []))

    @jsii.member(jsii_name="resetHsl")
    def reset_hsl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsl", []))

    @jsii.member(jsii_name="resetHsv")
    def reset_hsv(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsv", []))

    @jsii.member(jsii_name="resetIfDimension")
    def reset_if_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfDimension", []))

    @jsii.member(jsii_name="resetIfOrientation")
    def reset_if_orientation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfOrientation", []))

    @jsii.member(jsii_name="resetImQuery")
    def reset_im_query(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetImQuery", []))

    @jsii.member(jsii_name="resetMaxColors")
    def reset_max_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxColors", []))

    @jsii.member(jsii_name="resetMirror")
    def reset_mirror(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMirror", []))

    @jsii.member(jsii_name="resetMonoHue")
    def reset_mono_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonoHue", []))

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetRegionOfInterestCrop")
    def reset_region_of_interest_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRegionOfInterestCrop", []))

    @jsii.member(jsii_name="resetRelativeCrop")
    def reset_relative_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRelativeCrop", []))

    @jsii.member(jsii_name="resetRemoveColor")
    def reset_remove_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRemoveColor", []))

    @jsii.member(jsii_name="resetResize")
    def reset_resize(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetResize", []))

    @jsii.member(jsii_name="resetRotate")
    def reset_rotate(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRotate", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetShear")
    def reset_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetShear", []))

    @jsii.member(jsii_name="resetTrim")
    def reset_trim(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTrim", []))

    @jsii.member(jsii_name="resetUnsharpMask")
    def reset_unsharp_mask(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUnsharpMask", []))

    @builtins.property
    @jsii.member(jsii_name="append")
    def append(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultAppendList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultAppendList, jsii.get(self, "append"))

    @builtins.property
    @jsii.member(jsii_name="aspectCrop")
    def aspect_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultAspectCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultAspectCropList, jsii.get(self, "aspectCrop"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColor")
    def background_color(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultBackgroundColorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultBackgroundColorList, jsii.get(self, "backgroundColor"))

    @builtins.property
    @jsii.member(jsii_name="blur")
    def blur(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultBlurList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultBlurList, jsii.get(self, "blur"))

    @builtins.property
    @jsii.member(jsii_name="chromaKey")
    def chroma_key(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultChromaKeyList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultChromaKeyList, jsii.get(self, "chromaKey"))

    @builtins.property
    @jsii.member(jsii_name="composite")
    def composite(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultCompositeList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultCompositeList, jsii.get(self, "composite"))

    @builtins.property
    @jsii.member(jsii_name="compound")
    def compound(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultCompoundList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultCompoundList, jsii.get(self, "compound"))

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultContrastList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultContrastList, jsii.get(self, "contrast"))

    @builtins.property
    @jsii.member(jsii_name="crop")
    def crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultCropList, jsii.get(self, "crop"))

    @builtins.property
    @jsii.member(jsii_name="faceCrop")
    def face_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultFaceCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultFaceCropList, jsii.get(self, "faceCrop"))

    @builtins.property
    @jsii.member(jsii_name="featureCrop")
    def feature_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultFeatureCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultFeatureCropList, jsii.get(self, "featureCrop"))

    @builtins.property
    @jsii.member(jsii_name="fitAndFill")
    def fit_and_fill(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultFitAndFillList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultFitAndFillList, jsii.get(self, "fitAndFill"))

    @builtins.property
    @jsii.member(jsii_name="goop")
    def goop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultGoopList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultGoopList, jsii.get(self, "goop"))

    @builtins.property
    @jsii.member(jsii_name="grayscale")
    def grayscale(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultGrayscaleList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultGrayscaleList, jsii.get(self, "grayscale"))

    @builtins.property
    @jsii.member(jsii_name="hsl")
    def hsl(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultHslList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultHslList, jsii.get(self, "hsl"))

    @builtins.property
    @jsii.member(jsii_name="hsv")
    def hsv(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultHsvList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultHsvList, jsii.get(self, "hsv"))

    @builtins.property
    @jsii.member(jsii_name="ifDimension")
    def if_dimension(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionList, jsii.get(self, "ifDimension"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientation")
    def if_orientation(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationList, jsii.get(self, "ifOrientation"))

    @builtins.property
    @jsii.member(jsii_name="imQuery")
    def im_query(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultImQueryList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultImQueryList, jsii.get(self, "imQuery"))

    @builtins.property
    @jsii.member(jsii_name="maxColors")
    def max_colors(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultMaxColorsList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultMaxColorsList, jsii.get(self, "maxColors"))

    @builtins.property
    @jsii.member(jsii_name="mirror")
    def mirror(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultMirrorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultMirrorList, jsii.get(self, "mirror"))

    @builtins.property
    @jsii.member(jsii_name="monoHue")
    def mono_hue(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultMonoHueList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultMonoHueList, jsii.get(self, "monoHue"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultOpacityList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultOpacityList, jsii.get(self, "opacity"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestCrop")
    def region_of_interest_crop(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultRegionOfInterestCropList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultRegionOfInterestCropList", jsii.get(self, "regionOfInterestCrop"))

    @builtins.property
    @jsii.member(jsii_name="relativeCrop")
    def relative_crop(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultRelativeCropList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultRelativeCropList", jsii.get(self, "relativeCrop"))

    @builtins.property
    @jsii.member(jsii_name="removeColor")
    def remove_color(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultRemoveColorList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultRemoveColorList", jsii.get(self, "removeColor"))

    @builtins.property
    @jsii.member(jsii_name="resize")
    def resize(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultResizeList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultResizeList", jsii.get(self, "resize"))

    @builtins.property
    @jsii.member(jsii_name="rotate")
    def rotate(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultRotateList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultRotateList", jsii.get(self, "rotate"))

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultScaleList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultScaleList", jsii.get(self, "scale"))

    @builtins.property
    @jsii.member(jsii_name="shear")
    def shear(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultShearList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultShearList", jsii.get(self, "shear"))

    @builtins.property
    @jsii.member(jsii_name="trim")
    def trim(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultTrimList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultTrimList", jsii.get(self, "trim"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMask")
    def unsharp_mask(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultUnsharpMaskList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultUnsharpMaskList", jsii.get(self, "unsharpMask"))

    @builtins.property
    @jsii.member(jsii_name="appendInput")
    def append_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultAppend]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultAppend]]], jsii.get(self, "appendInput"))

    @builtins.property
    @jsii.member(jsii_name="aspectCropInput")
    def aspect_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultAspectCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultAspectCrop]]], jsii.get(self, "aspectCropInput"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColorInput")
    def background_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultBackgroundColor]]], jsii.get(self, "backgroundColorInput"))

    @builtins.property
    @jsii.member(jsii_name="blurInput")
    def blur_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultBlur]]], jsii.get(self, "blurInput"))

    @builtins.property
    @jsii.member(jsii_name="chromaKeyInput")
    def chroma_key_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultChromaKey]]], jsii.get(self, "chromaKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="compositeInput")
    def composite_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultComposite]]], jsii.get(self, "compositeInput"))

    @builtins.property
    @jsii.member(jsii_name="compoundInput")
    def compound_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultCompound]]], jsii.get(self, "compoundInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultContrast]]], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="cropInput")
    def crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultCrop]]], jsii.get(self, "cropInput"))

    @builtins.property
    @jsii.member(jsii_name="faceCropInput")
    def face_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultFaceCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultFaceCrop]]], jsii.get(self, "faceCropInput"))

    @builtins.property
    @jsii.member(jsii_name="featureCropInput")
    def feature_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultFeatureCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultFeatureCrop]]], jsii.get(self, "featureCropInput"))

    @builtins.property
    @jsii.member(jsii_name="fitAndFillInput")
    def fit_and_fill_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultFitAndFill]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultFitAndFill]]], jsii.get(self, "fitAndFillInput"))

    @builtins.property
    @jsii.member(jsii_name="goopInput")
    def goop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultGoop]]], jsii.get(self, "goopInput"))

    @builtins.property
    @jsii.member(jsii_name="grayscaleInput")
    def grayscale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultGrayscale]]], jsii.get(self, "grayscaleInput"))

    @builtins.property
    @jsii.member(jsii_name="hslInput")
    def hsl_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultHsl]]], jsii.get(self, "hslInput"))

    @builtins.property
    @jsii.member(jsii_name="hsvInput")
    def hsv_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultHsv]]], jsii.get(self, "hsvInput"))

    @builtins.property
    @jsii.member(jsii_name="ifDimensionInput")
    def if_dimension_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfDimension]]], jsii.get(self, "ifDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientationInput")
    def if_orientation_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfOrientation]]], jsii.get(self, "ifOrientationInput"))

    @builtins.property
    @jsii.member(jsii_name="imQueryInput")
    def im_query_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultImQuery]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultImQuery]]], jsii.get(self, "imQueryInput"))

    @builtins.property
    @jsii.member(jsii_name="maxColorsInput")
    def max_colors_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultMaxColors]]], jsii.get(self, "maxColorsInput"))

    @builtins.property
    @jsii.member(jsii_name="mirrorInput")
    def mirror_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultMirror]]], jsii.get(self, "mirrorInput"))

    @builtins.property
    @jsii.member(jsii_name="monoHueInput")
    def mono_hue_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultMonoHue]]], jsii.get(self, "monoHueInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultOpacity]]], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestCropInput")
    def region_of_interest_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultRegionOfInterestCrop"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultRegionOfInterestCrop"]]], jsii.get(self, "regionOfInterestCropInput"))

    @builtins.property
    @jsii.member(jsii_name="relativeCropInput")
    def relative_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultRelativeCrop"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultRelativeCrop"]]], jsii.get(self, "relativeCropInput"))

    @builtins.property
    @jsii.member(jsii_name="removeColorInput")
    def remove_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultRemoveColor"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultRemoveColor"]]], jsii.get(self, "removeColorInput"))

    @builtins.property
    @jsii.member(jsii_name="resizeInput")
    def resize_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultResize"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultResize"]]], jsii.get(self, "resizeInput"))

    @builtins.property
    @jsii.member(jsii_name="rotateInput")
    def rotate_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultRotate"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultRotate"]]], jsii.get(self, "rotateInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultScale"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultScale"]]], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="shearInput")
    def shear_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultShear"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultShear"]]], jsii.get(self, "shearInput"))

    @builtins.property
    @jsii.member(jsii_name="trimInput")
    def trim_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultTrim"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultTrim"]]], jsii.get(self, "trimInput"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMaskInput")
    def unsharp_mask_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultUnsharpMask"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultUnsharpMask"]]], jsii.get(self, "unsharpMaskInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9306efc7fc737bad4307aa04849a8f13e9d426dc0b0f88ba4c3829bb4bf6667d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultRegionOfInterestCrop",
    jsii_struct_bases=[],
    name_mapping={
        "region_of_interest": "regionOfInterest",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultRegionOfInterestCrop:
    def __init__(
        self,
        *,
        region_of_interest: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultRegionOfInterestCropRegionOfInterest", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param region_of_interest: region_of_interest block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest DataAkamaiImagingPolicyImage#region_of_interest}
        :param gravity: The placement of the crop area relative to the specified area of interest. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: The placement of the crop area relative to the specified area of interest. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param style: Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(region_of_interest, dict):
            region_of_interest = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultRegionOfInterestCropRegionOfInterest(**region_of_interest)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__73edb4eb3065736b4bd7cb4dabf596a3b24b706aa904060251d9db43b514ddb2)
            check_type(argname="argument region_of_interest", value=region_of_interest, expected_type=type_hints["region_of_interest"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "region_of_interest": region_of_interest,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def region_of_interest(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultRegionOfInterestCropRegionOfInterest":
        '''region_of_interest block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest DataAkamaiImagingPolicyImage#region_of_interest}
        '''
        result = self._values.get("region_of_interest")
        assert result is not None, "Required property 'region_of_interest' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultRegionOfInterestCropRegionOfInterest", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''The placement of the crop area relative to the specified area of interest.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''The placement of the crop area relative to the specified area of interest.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultRegionOfInterestCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultRegionOfInterestCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultRegionOfInterestCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7b7c119c9b2b5ae5d097d6b878bd57444315e4bf8ab6a2aa69d320d548ae4745)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultRegionOfInterestCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__28f658da4d449bfcec835c06da619e1142404701b33de89b55ef55773adc5dc1)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultRegionOfInterestCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8c7ea9d7cdd84922d1c0e38a855c02deb3fd3bb8af98989345dfd2281f5fd06c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1b3a23c2c7a803d81633fae4cc0aa5c3ddf73eb991695d7405c83c4e0ee1ec0b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ddf055b5876c486502067e6aef572e0f845f3d13b0a5b6d11d4f2c3787a3b05)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultRegionOfInterestCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultRegionOfInterestCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultRegionOfInterestCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a46fac3ebe459e2025bde347bf1aba7efdd15495232affad7a64b9731394d60d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultRegionOfInterestCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultRegionOfInterestCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__258d309f5634d0ceb71e5d52f0ad5f0fea8ab17edcc59b921a3b1b6bf8963a79)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putRegionOfInterest")
    def put_region_of_interest(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultRegionOfInterestCropRegionOfInterest()

        return typing.cast(None, jsii.invoke(self, "putRegionOfInterest", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterest")
    def region_of_interest(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultRegionOfInterestCropRegionOfInterestOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultRegionOfInterestCropRegionOfInterestOutputReference", jsii.get(self, "regionOfInterest"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestInput")
    def region_of_interest_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultRegionOfInterestCropRegionOfInterest"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultRegionOfInterestCropRegionOfInterest"], jsii.get(self, "regionOfInterestInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__750aff8e498faccee7ea3dbf7c87f6655ad4b5164a1c5feb305440702062c6df)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b720544fd3d5f02266ecc966c077d1e9ac9899cf850531ac4e0d94afab726f34)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fc69a5a78828489b17c34cb127329e616bb056f54edc660a16e29fb8304a5fa6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d2c37aa9035e804b01a63a7253841af2f51eda99452f5657819fd728a625c7d4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1464bd20f3487c14cc1e03d4bc64552bbf911b1b0cdb8aa46a5a8a0b2f3c42bc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__abbbdb03c392edc0c8b780b00c45dfe6c92b2f3bd6438e3a1102c778686df698)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d817b11b5274b0b291416b0d760576ad45c306b558dc0ba2ffa440724c66b478)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d8efbc5438d87cc381719f463aa010e3639714e29c9910793e2e6ff952219573)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultRegionOfInterestCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultRegionOfInterestCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultRegionOfInterestCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__014160ccd82fe65f30d4402ce1955a32ac381ad4a9a4830639ee13c6140ca060)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultRegionOfInterestCropRegionOfInterest",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultRegionOfInterestCropRegionOfInterest:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultRegionOfInterestCropRegionOfInterest(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultRegionOfInterestCropRegionOfInterestOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultRegionOfInterestCropRegionOfInterestOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__764604ed249f609f2ff2d6fa6ea08e29578518c831744d1700ae85c4bccf0bba)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultRegionOfInterestCropRegionOfInterest]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultRegionOfInterestCropRegionOfInterest], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultRegionOfInterestCropRegionOfInterest],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3f37485035ce36f6dc1fb675e7910b1de0e6f4913031793498bec2bb67e6ba80)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultRelativeCrop",
    jsii_struct_bases=[],
    name_mapping={
        "east": "east",
        "east_var": "eastVar",
        "north": "north",
        "north_var": "northVar",
        "south": "south",
        "south_var": "southVar",
        "west": "west",
        "west_var": "westVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultRelativeCrop:
    def __init__(
        self,
        *,
        east: typing.Optional[builtins.str] = None,
        east_var: typing.Optional[builtins.str] = None,
        north: typing.Optional[builtins.str] = None,
        north_var: typing.Optional[builtins.str] = None,
        south: typing.Optional[builtins.str] = None,
        south_var: typing.Optional[builtins.str] = None,
        west: typing.Optional[builtins.str] = None,
        west_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param east: The number of pixels to shrink or expand the right side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east DataAkamaiImagingPolicyImage#east}
        :param east_var: The number of pixels to shrink or expand the right side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east_var DataAkamaiImagingPolicyImage#east_var}
        :param north: The number of pixels to shrink or expand the top side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north DataAkamaiImagingPolicyImage#north}
        :param north_var: The number of pixels to shrink or expand the top side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north_var DataAkamaiImagingPolicyImage#north_var}
        :param south: The number of pixels to shrink or expand the bottom side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south DataAkamaiImagingPolicyImage#south}
        :param south_var: The number of pixels to shrink or expand the bottom side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south_var DataAkamaiImagingPolicyImage#south_var}
        :param west: The number of pixels to shrink or expand the left side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west DataAkamaiImagingPolicyImage#west}
        :param west_var: The number of pixels to shrink or expand the left side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west_var DataAkamaiImagingPolicyImage#west_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a50e38185f4e8cf7ba78e9ea2647b37f6722b8ce7425e7645dc7b5b5af706a03)
            check_type(argname="argument east", value=east, expected_type=type_hints["east"])
            check_type(argname="argument east_var", value=east_var, expected_type=type_hints["east_var"])
            check_type(argname="argument north", value=north, expected_type=type_hints["north"])
            check_type(argname="argument north_var", value=north_var, expected_type=type_hints["north_var"])
            check_type(argname="argument south", value=south, expected_type=type_hints["south"])
            check_type(argname="argument south_var", value=south_var, expected_type=type_hints["south_var"])
            check_type(argname="argument west", value=west, expected_type=type_hints["west"])
            check_type(argname="argument west_var", value=west_var, expected_type=type_hints["west_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if east is not None:
            self._values["east"] = east
        if east_var is not None:
            self._values["east_var"] = east_var
        if north is not None:
            self._values["north"] = north
        if north_var is not None:
            self._values["north_var"] = north_var
        if south is not None:
            self._values["south"] = south
        if south_var is not None:
            self._values["south_var"] = south_var
        if west is not None:
            self._values["west"] = west
        if west_var is not None:
            self._values["west_var"] = west_var

    @builtins.property
    def east(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the right side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east DataAkamaiImagingPolicyImage#east}
        '''
        result = self._values.get("east")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def east_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the right side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east_var DataAkamaiImagingPolicyImage#east_var}
        '''
        result = self._values.get("east_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def north(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the top side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north DataAkamaiImagingPolicyImage#north}
        '''
        result = self._values.get("north")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def north_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the top side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north_var DataAkamaiImagingPolicyImage#north_var}
        '''
        result = self._values.get("north_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def south(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the bottom side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south DataAkamaiImagingPolicyImage#south}
        '''
        result = self._values.get("south")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def south_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the bottom side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south_var DataAkamaiImagingPolicyImage#south_var}
        '''
        result = self._values.get("south_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def west(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the left side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west DataAkamaiImagingPolicyImage#west}
        '''
        result = self._values.get("west")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def west_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the left side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west_var DataAkamaiImagingPolicyImage#west_var}
        '''
        result = self._values.get("west_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultRelativeCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultRelativeCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultRelativeCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__661036f399b522c789f34d941c96f49fe22426f061ecaf1dff0918235679cdc8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultRelativeCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__46a79840b9124f6bb9720200311c241b0c461c46c315d4f28b777522a5033cec)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultRelativeCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b00996f6c28e5d30c4f06c3e29eeb465825b2e429bd95c67b11bfaea0e528372)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eb76c4e547897288f2da565b6ad77968f49f39aa68a901d1c35a119b584b6930)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__98734545e601b3087c71ecd0a3783c166c9709546bf1f0b09c7398e79621ec1b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultRelativeCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultRelativeCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultRelativeCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a7bc91adbc00abdae81afe9e5e92503994b4d3131f90eff991b2517edc203aa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultRelativeCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultRelativeCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__08cc81efa5246b14c2480e25e17650f6bb54e5c1c28096897eed95cb4513f156)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetEast")
    def reset_east(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEast", []))

    @jsii.member(jsii_name="resetEastVar")
    def reset_east_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEastVar", []))

    @jsii.member(jsii_name="resetNorth")
    def reset_north(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNorth", []))

    @jsii.member(jsii_name="resetNorthVar")
    def reset_north_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNorthVar", []))

    @jsii.member(jsii_name="resetSouth")
    def reset_south(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSouth", []))

    @jsii.member(jsii_name="resetSouthVar")
    def reset_south_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSouthVar", []))

    @jsii.member(jsii_name="resetWest")
    def reset_west(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWest", []))

    @jsii.member(jsii_name="resetWestVar")
    def reset_west_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWestVar", []))

    @builtins.property
    @jsii.member(jsii_name="eastInput")
    def east_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "eastInput"))

    @builtins.property
    @jsii.member(jsii_name="eastVarInput")
    def east_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "eastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="northInput")
    def north_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "northInput"))

    @builtins.property
    @jsii.member(jsii_name="northVarInput")
    def north_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "northVarInput"))

    @builtins.property
    @jsii.member(jsii_name="southInput")
    def south_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "southInput"))

    @builtins.property
    @jsii.member(jsii_name="southVarInput")
    def south_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "southVarInput"))

    @builtins.property
    @jsii.member(jsii_name="westInput")
    def west_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "westInput"))

    @builtins.property
    @jsii.member(jsii_name="westVarInput")
    def west_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "westVarInput"))

    @builtins.property
    @jsii.member(jsii_name="east")
    def east(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "east"))

    @east.setter
    def east(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__88dab37671e93af2fc85120e1451426bf5d63718efc27b2e733b03198218030c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "east", value)

    @builtins.property
    @jsii.member(jsii_name="eastVar")
    def east_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "eastVar"))

    @east_var.setter
    def east_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__33153cc79380b53f1502abd9b92d28781a2fbc0d8444636361c158a93c5d4e7a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "eastVar", value)

    @builtins.property
    @jsii.member(jsii_name="north")
    def north(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "north"))

    @north.setter
    def north(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ef85e8b63979b60aca889da7014c825e497624f04911263265b0677d77c7133d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "north", value)

    @builtins.property
    @jsii.member(jsii_name="northVar")
    def north_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "northVar"))

    @north_var.setter
    def north_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cc5fcdb52ad4e452aaede10ac0cfb4ac58f0f92e6e1fb1e1ffbc92df60f07908)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "northVar", value)

    @builtins.property
    @jsii.member(jsii_name="south")
    def south(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "south"))

    @south.setter
    def south(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d2bea06c3259047518e2cdd3d10cb21d516446fa993dcaf3b8f41a46e1f18399)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "south", value)

    @builtins.property
    @jsii.member(jsii_name="southVar")
    def south_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "southVar"))

    @south_var.setter
    def south_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0d8fbfc36a36fa9f114c34ac3acf1535122e5a168682dbfb9bda86cb3c3b9d2e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "southVar", value)

    @builtins.property
    @jsii.member(jsii_name="west")
    def west(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "west"))

    @west.setter
    def west(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d51b0c77a94779970db5fddef79503fe7ed95d2548e0df85dce46628be1ad32)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "west", value)

    @builtins.property
    @jsii.member(jsii_name="westVar")
    def west_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "westVar"))

    @west_var.setter
    def west_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__51d1e827c9930377e2dcf7e25803633f113441d1bfb3cc49c6121efc9932bbfb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "westVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultRelativeCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultRelativeCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultRelativeCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d02bc2960c738ca9e2f52b12667e08a18294806d963060b2e10be10f960af8e9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultRemoveColor",
    jsii_struct_bases=[],
    name_mapping={
        "color": "color",
        "color_var": "colorVar",
        "feather": "feather",
        "feather_var": "featherVar",
        "tolerance": "tolerance",
        "tolerance_var": "toleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultRemoveColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
        feather: typing.Optional[builtins.str] = None,
        feather_var: typing.Optional[builtins.str] = None,
        tolerance: typing.Optional[builtins.str] = None,
        tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        :param feather: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        :param feather_var: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        :param tolerance: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        :param tolerance_var: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ff90d35eefd0cbc95d9e1cdaaccae3efc5682833fbd8bfe69c413508c72d688)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
            check_type(argname="argument feather", value=feather, expected_type=type_hints["feather"])
            check_type(argname="argument feather_var", value=feather_var, expected_type=type_hints["feather_var"])
            check_type(argname="argument tolerance", value=tolerance, expected_type=type_hints["tolerance"])
            check_type(argname="argument tolerance_var", value=tolerance_var, expected_type=type_hints["tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var
        if feather is not None:
            self._values["feather"] = feather
        if feather_var is not None:
            self._values["feather_var"] = feather_var
        if tolerance is not None:
            self._values["tolerance"] = tolerance
        if tolerance_var is not None:
            self._values["tolerance_var"] = tolerance_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        '''
        result = self._values.get("feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather_var(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        '''
        result = self._values.get("feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        '''
        result = self._values.get("tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance_var(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        result = self._values.get("tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultRemoveColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultRemoveColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultRemoveColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1dcb0be43478af03a5b0da9fe79952671b6c48ef74f39eb1dde44fc547c4005c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultRemoveColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a4b5db311bf6d33c0fe69a8db3bf94995422d00fa767851ac9072235ab6ac517)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultRemoveColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e43b4a5ca758e7ed65525fd8c619981d89196c893a1edb65ba96120b98e0c505)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__69c610a50cfd7529381b52bd097fa8afe4695d52ba10208d5dd24ff0ab61b4e9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0b66c65091374e7840c058c3aec9e60af526b46458134c7243d583e900e372b7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultRemoveColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultRemoveColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultRemoveColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f3bf44e359a2ea60fa473b7e97b29981189520d9c16ecd231e132f899ac33ce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultRemoveColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultRemoveColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b004bcfc1913f681cd1a80a76ee601e02e29bb1e6e3a252b2115f4259a542583)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @jsii.member(jsii_name="resetFeather")
    def reset_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeather", []))

    @jsii.member(jsii_name="resetFeatherVar")
    def reset_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatherVar", []))

    @jsii.member(jsii_name="resetTolerance")
    def reset_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTolerance", []))

    @jsii.member(jsii_name="resetToleranceVar")
    def reset_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featherInput")
    def feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherInput"))

    @builtins.property
    @jsii.member(jsii_name="featherVarInput")
    def feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceInput")
    def tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceVarInput")
    def tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__36960863c9d299e6269fdf15f6f81dcabed9d9cb34563e6e98b83c75c655283e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ca8746b3155e4182ce94a34dfaece38b42c873c60d9d62b876981eff46a5fab9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="feather")
    def feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "feather"))

    @feather.setter
    def feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e8b4c584035b3fb2dd8aef29330ef6a044542676eb11fa8f28f66518467e6449)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "feather", value)

    @builtins.property
    @jsii.member(jsii_name="featherVar")
    def feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featherVar"))

    @feather_var.setter
    def feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a44ca01042b9b4c1ff86f482943cdedcea9b19acb502ef6e974b0d9eaf4c24cf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featherVar", value)

    @builtins.property
    @jsii.member(jsii_name="tolerance")
    def tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tolerance"))

    @tolerance.setter
    def tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__08d00dd458fe9e7d4f581c5d56e07b4ed5585ed423e7b884757f5f2139210e5f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tolerance", value)

    @builtins.property
    @jsii.member(jsii_name="toleranceVar")
    def tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "toleranceVar"))

    @tolerance_var.setter
    def tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ee5a0e6aafc853664e50b2217eea975ce61025d774c73b3d3bb79b6a82c507a4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "toleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultRemoveColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultRemoveColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultRemoveColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__111a3707707b590c627c3156471d095431b2cd7299461b2459fe77f3e56508e8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultResize",
    jsii_struct_bases=[],
    name_mapping={
        "aspect": "aspect",
        "aspect_var": "aspectVar",
        "height": "height",
        "height_var": "heightVar",
        "type": "type",
        "type_var": "typeVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultResize:
    def __init__(
        self,
        *,
        aspect: typing.Optional[builtins.str] = None,
        aspect_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param aspect: Preserves the aspect ratio. Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect DataAkamaiImagingPolicyImage#aspect}
        :param aspect_var: Preserves the aspect ratio. Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_var DataAkamaiImagingPolicyImage#aspect_var}
        :param height: The height to resize the source image to. Must be set if height is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height to resize the source image to. Must be set if height is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param type: Sets constraints for the image resize. Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: Sets constraints for the image resize. Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        :param width: The width to resize the source image to. Must be set if width is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width to resize the source image to. Must be set if width is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8580ffa731db0b4db58e8d09b87cfb9985d2f3e32873bd53c01e6dd4ebef2f40)
            check_type(argname="argument aspect", value=aspect, expected_type=type_hints["aspect"])
            check_type(argname="argument aspect_var", value=aspect_var, expected_type=type_hints["aspect_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if aspect is not None:
            self._values["aspect"] = aspect
        if aspect_var is not None:
            self._values["aspect_var"] = aspect_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def aspect(self) -> typing.Optional[builtins.str]:
        '''Preserves the aspect ratio.

        Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect DataAkamaiImagingPolicyImage#aspect}
        '''
        result = self._values.get("aspect")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def aspect_var(self) -> typing.Optional[builtins.str]:
        '''Preserves the aspect ratio.

        Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_var DataAkamaiImagingPolicyImage#aspect_var}
        '''
        result = self._values.get("aspect_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height to resize the source image to. Must be set if height is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height to resize the source image to. Must be set if height is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''Sets constraints for the image resize.

        Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''Sets constraints for the image resize.

        Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width to resize the source image to. Must be set if width is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width to resize the source image to. Must be set if width is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultResize(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultResizeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultResizeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d38112cdfd26ecd84996b993334ab97a202731c21969607414ecd630c0c6b6cd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultResizeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5bb95b69e8f6772a5c5bb7bf48feb10d587448820d649b82d8e46c6210989bf8)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultResizeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8ec46239a7f5b04a49e31ef90e635f108eb7c06037bb8946598dd2b801c0cf18)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3729497f7af15bdc9bc04821ee520f90f023de39ba86c910e07d27509ffb0f5b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__93e1a6f12a32dc13ddfb932150bba8cdeea7902ed6fac39cc5fb758cdfbe18ec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultResize]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultResize]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultResize]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5e5cf46ebe35373a9146aae5d0240de089549ee5a3a3082dc40b05ce2c9e9f64)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultResizeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultResizeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__abf25ae43647ac249fc9c576687360cca9f0423463ebeb69335351b30c5a6c7d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAspect")
    def reset_aspect(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspect", []))

    @jsii.member(jsii_name="resetAspectVar")
    def reset_aspect_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspectVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="aspectInput")
    def aspect_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "aspectInput"))

    @builtins.property
    @jsii.member(jsii_name="aspectVarInput")
    def aspect_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "aspectVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="aspect")
    def aspect(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "aspect"))

    @aspect.setter
    def aspect(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6ec1118e162e03dba283da3a3ef26a4a5741539052255bbf9796ac2f6b12a848)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "aspect", value)

    @builtins.property
    @jsii.member(jsii_name="aspectVar")
    def aspect_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "aspectVar"))

    @aspect_var.setter
    def aspect_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b910689fd3d7ae0bd19202952dd83cc0d520b621e8cd1b80e75b10c7122644c9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "aspectVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f290482ebac34379593f8d0a7478a45725f1d68d8848deac44ad4f1899c9a114)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d80e70c38b38b234bf93b3a4f306410588f363f34f77448d11fcb518f53cea9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4506578b62ebdab1921a10fb79025a96fc26c93d93ce7408e399e70fde9c72dd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c494d5942c37b2fbe40e0e8d501b4557c8c400e1bdce42d3ec4de2fd5090cafd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__721a4a0f8ee7da737328ccd93829636da64ce782107ecd101a766fd8895330d6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9e0f2e4ae8b95a734c8775b1a3540f9c8c66e61f49303f911a643a6ecb3ba18a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultResize]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultResize]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultResize]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e51fe85729d3511417325aaf85e165e8e8df28c65449511b49a548fcb12d18d3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultRotate",
    jsii_struct_bases=[],
    name_mapping={"degrees": "degrees", "degrees_var": "degreesVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultRotate:
    def __init__(
        self,
        *,
        degrees: typing.Optional[builtins.str] = None,
        degrees_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param degrees: The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees DataAkamaiImagingPolicyImage#degrees}
        :param degrees_var: The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees_var DataAkamaiImagingPolicyImage#degrees_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__63856cb6f65a036aebc7e326cada02320482b78459361dcd6b380c8b4b5ce29f)
            check_type(argname="argument degrees", value=degrees, expected_type=type_hints["degrees"])
            check_type(argname="argument degrees_var", value=degrees_var, expected_type=type_hints["degrees_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if degrees is not None:
            self._values["degrees"] = degrees
        if degrees_var is not None:
            self._values["degrees_var"] = degrees_var

    @builtins.property
    def degrees(self) -> typing.Optional[builtins.str]:
        '''The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees DataAkamaiImagingPolicyImage#degrees}
        '''
        result = self._values.get("degrees")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def degrees_var(self) -> typing.Optional[builtins.str]:
        '''The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees_var DataAkamaiImagingPolicyImage#degrees_var}
        '''
        result = self._values.get("degrees_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultRotate(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultRotateList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultRotateList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fac07855cccfc0f22a6c49b3c702fcde0ecf1adba5b7558a9f7e2ee05969ac2a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultRotateOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__314ca85b8f3f212fc61796013f67a90b242a860ac15500509032681b0851a9da)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultRotateOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__51a259338b75ef229affb7793805c847a090410f14596e9ecc16e69523067a42)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b364816949120d753d9672d71efb70491da8fb8b232fae71ff8a63d0e1ecd664)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea91b3665c9ba888358b600fec76e87be9df42cb5279803e475d8bf3858a749b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultRotate]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultRotate]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultRotate]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d2ec5e47658bdbc80b866effb1fed056ebe7b23b819917f23acbe3fced0dfc30)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultRotateOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultRotateOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d355275b5a7f026538e847fa1c134ded9c636f25d7d9d483c240e83bebc202a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetDegrees")
    def reset_degrees(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDegrees", []))

    @jsii.member(jsii_name="resetDegreesVar")
    def reset_degrees_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDegreesVar", []))

    @builtins.property
    @jsii.member(jsii_name="degreesInput")
    def degrees_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "degreesInput"))

    @builtins.property
    @jsii.member(jsii_name="degreesVarInput")
    def degrees_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "degreesVarInput"))

    @builtins.property
    @jsii.member(jsii_name="degrees")
    def degrees(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "degrees"))

    @degrees.setter
    def degrees(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__446021511af5725066374b9bedaa7fd8d7f4a3bbf33c96546e84d7cdd398375e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "degrees", value)

    @builtins.property
    @jsii.member(jsii_name="degreesVar")
    def degrees_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "degreesVar"))

    @degrees_var.setter
    def degrees_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8b16faec677d80a2ae470204d6b487fcc79df640d92b57acc7ab0eff3d11cb2e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "degreesVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultRotate]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultRotate]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultRotate]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2aa0a447d0569e0e2347d08502843d07eae9bd21d2af8076fe5a33eec086d38f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultScale",
    jsii_struct_bases=[],
    name_mapping={
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultScale:
    def __init__(
        self,
        *,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param height: Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged. Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged. Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc911677e8dda343fed5d530a80cb93f1f16286316da6763ec8d0fe604fe9654)
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size.

        Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size.

        Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged.

        Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged.

        Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultScale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultScaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultScaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__58e9df8b99a6c7a337cc6a440dc61ef25512e6d66ec7ad498a4800eb796f3df6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultScaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ff8fd4418bb3a6ff24ddbd9aba3d7e83de590618307e3dbd21ba3fef9edc97a9)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultScaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__18c4daea007dab9a02b9101d2ffed9ad434fcb126337dea207c44f3c8f4fb6eb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__48d5687b33104c3b77d418956cb40f476720911116a91a96db25ab9109acfa07)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__84e52e3dfda53637e35f8b26e9f0b1e9ed19f99d2c62e5ff8cd866aaa451953d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultScale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultScale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultScale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__677b40136dd3bcd47e20b988171cb45223ac3fbf030a09f6169226d1918881d0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultScaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultScaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e7171d6472f4c1b3d6c7c64c9106b77384103ddb3eecc4897a4952d117d92c0e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e771a0a6abc3a4abf2cf5e4bca85e656d1f0e6191327782dcd909c07a4f4df44)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9c5a49d8a995ffc59a1aaed56d9eab46299434941fcbe2ce3455e64c69d86edd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e94d29282c7f53a2afbc47528e20b43880c20e20ca7f9d1caeba2d470d6d301f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__14a7d140ed38d8ebad762ccdd5eb0d6529399ed6b61747b42e4ae95402b4b2b8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultScale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultScale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultScale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e05be615b5e0864a6cfda88c170a418d8b1700c1fe878fcc4d9eacf13de512c1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultShear",
    jsii_struct_bases=[],
    name_mapping={
        "x_shear": "xShear",
        "x_shear_var": "xShearVar",
        "y_shear": "yShear",
        "y_shear_var": "yShearVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultShear:
    def __init__(
        self,
        *,
        x_shear: typing.Optional[builtins.str] = None,
        x_shear_var: typing.Optional[builtins.str] = None,
        y_shear: typing.Optional[builtins.str] = None,
        y_shear_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param x_shear: The amount to shear along the x-axis, measured in multiples of the image's width. Must be set if yShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear DataAkamaiImagingPolicyImage#x_shear}
        :param x_shear_var: The amount to shear along the x-axis, measured in multiples of the image's width. Must be set if yShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear_var DataAkamaiImagingPolicyImage#x_shear_var}
        :param y_shear: The amount to shear along the y-axis, measured in multiples of the image's height. Must be set if xShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear DataAkamaiImagingPolicyImage#y_shear}
        :param y_shear_var: The amount to shear along the y-axis, measured in multiples of the image's height. Must be set if xShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear_var DataAkamaiImagingPolicyImage#y_shear_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__75e838c170005f5dd521bffc5e15a09adc497a9f1e2f5b6d2e727993b17774a9)
            check_type(argname="argument x_shear", value=x_shear, expected_type=type_hints["x_shear"])
            check_type(argname="argument x_shear_var", value=x_shear_var, expected_type=type_hints["x_shear_var"])
            check_type(argname="argument y_shear", value=y_shear, expected_type=type_hints["y_shear"])
            check_type(argname="argument y_shear_var", value=y_shear_var, expected_type=type_hints["y_shear_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if x_shear is not None:
            self._values["x_shear"] = x_shear
        if x_shear_var is not None:
            self._values["x_shear_var"] = x_shear_var
        if y_shear is not None:
            self._values["y_shear"] = y_shear
        if y_shear_var is not None:
            self._values["y_shear_var"] = y_shear_var

    @builtins.property
    def x_shear(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the x-axis, measured in multiples of the image's width.

        Must be set if yShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear DataAkamaiImagingPolicyImage#x_shear}
        '''
        result = self._values.get("x_shear")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_shear_var(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the x-axis, measured in multiples of the image's width.

        Must be set if yShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear_var DataAkamaiImagingPolicyImage#x_shear_var}
        '''
        result = self._values.get("x_shear_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_shear(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the y-axis, measured in multiples of the image's height.

        Must be set if xShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear DataAkamaiImagingPolicyImage#y_shear}
        '''
        result = self._values.get("y_shear")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_shear_var(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the y-axis, measured in multiples of the image's height.

        Must be set if xShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear_var DataAkamaiImagingPolicyImage#y_shear_var}
        '''
        result = self._values.get("y_shear_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultShear(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultShearList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultShearList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3607e6610e38f492b2b6a452a993637d58e296eb1dade72bd14609a0fe2ae3ee)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultShearOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0125035a56addfa5b70cb77b2ce9e9ede8220465607f2c089e86e814a5e8ff6e)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultShearOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7b6a58ceeccc04619c78f11079a461f9879e622c6073f12ab55065c61b555318)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0e62c25c6257f06138c210293696e5dc3139e18431238ba60782a4fbeed7acb3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f1f586a72e0c65023f53655cf21b6c7f9cd306b1f885380ed9a512c1d6c366e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultShear]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultShear]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultShear]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__adf9b25d60923cd398d64cd00dbce0ddda0b91c06d558a69b4d7259f42b096e4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultShearOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultShearOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__79c3307ee19db7763b4fe7be21803e2a3b9187c9b564c9a0e7ee3334f0721c58)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetXShear")
    def reset_x_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXShear", []))

    @jsii.member(jsii_name="resetXShearVar")
    def reset_x_shear_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXShearVar", []))

    @jsii.member(jsii_name="resetYShear")
    def reset_y_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYShear", []))

    @jsii.member(jsii_name="resetYShearVar")
    def reset_y_shear_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYShearVar", []))

    @builtins.property
    @jsii.member(jsii_name="xShearInput")
    def x_shear_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xShearInput"))

    @builtins.property
    @jsii.member(jsii_name="xShearVarInput")
    def x_shear_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xShearVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yShearInput")
    def y_shear_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yShearInput"))

    @builtins.property
    @jsii.member(jsii_name="yShearVarInput")
    def y_shear_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yShearVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xShear")
    def x_shear(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xShear"))

    @x_shear.setter
    def x_shear(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9537d91dbb3ea4d9f0824e96fcb6cad599597f0b13b2379f15167f56d903acc4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xShear", value)

    @builtins.property
    @jsii.member(jsii_name="xShearVar")
    def x_shear_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xShearVar"))

    @x_shear_var.setter
    def x_shear_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f15bcd998c153127a770834a38d7a15e7c4be17490ab7a5f623ca4b4fac7653)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xShearVar", value)

    @builtins.property
    @jsii.member(jsii_name="yShear")
    def y_shear(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yShear"))

    @y_shear.setter
    def y_shear(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bdd71b5c7746431871a0da300523e25f8add973fec02e222932eb9f9dafe0a49)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yShear", value)

    @builtins.property
    @jsii.member(jsii_name="yShearVar")
    def y_shear_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yShearVar"))

    @y_shear_var.setter
    def y_shear_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7f964232957690af1bd2abe89028dac66aabbd99fa79367a484738bea80b7477)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yShearVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultShear]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultShear]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultShear]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__749a718d668f54a952f1fa63fe1b0612b6cdd9dd76153c1b01be7de9106b1904)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultTrim",
    jsii_struct_bases=[],
    name_mapping={
        "fuzz": "fuzz",
        "fuzz_var": "fuzzVar",
        "padding": "padding",
        "padding_var": "paddingVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultTrim:
    def __init__(
        self,
        *,
        fuzz: typing.Optional[builtins.str] = None,
        fuzz_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fuzz: The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz DataAkamaiImagingPolicyImage#fuzz}
        :param fuzz_var: The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz_var DataAkamaiImagingPolicyImage#fuzz_var}
        :param padding: The amount of padding in pixels to add to the trimmed image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: The amount of padding in pixels to add to the trimmed image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a4b7dfe7881244062b2b14c21bd8bf41a1f02c95fd6093b652d4b86ddf7ef5d1)
            check_type(argname="argument fuzz", value=fuzz, expected_type=type_hints["fuzz"])
            check_type(argname="argument fuzz_var", value=fuzz_var, expected_type=type_hints["fuzz_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fuzz is not None:
            self._values["fuzz"] = fuzz
        if fuzz_var is not None:
            self._values["fuzz_var"] = fuzz_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var

    @builtins.property
    def fuzz(self) -> typing.Optional[builtins.str]:
        '''The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz DataAkamaiImagingPolicyImage#fuzz}
        '''
        result = self._values.get("fuzz")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fuzz_var(self) -> typing.Optional[builtins.str]:
        '''The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz_var DataAkamaiImagingPolicyImage#fuzz_var}
        '''
        result = self._values.get("fuzz_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''The amount of padding in pixels to add to the trimmed image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''The amount of padding in pixels to add to the trimmed image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultTrim(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultTrimList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultTrimList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__668ac9c0fcbe2d730f8927fa013f236ce7452e8561eb960ef6e5a78b579d74b9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultTrimOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__355183e941629b2dc8be6a3157cffefddf3e86b70115b3b58da2782d02f68641)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultTrimOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1af01249a96fadf48d50cfee13270011f57ce88e5b1f4ff3ca8d9a09534a5232)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__936b0777bc0de8831534392da54518854a92163b89a02d97c50387e3d02a35f7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1556b1f552777f1e8d3b40ebaf9680d5feeadafab252d91894ef918952094fe4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultTrim]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultTrim]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultTrim]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1a9a957949047994a5039ada1b06f7f033b0fccc8ba8decfba003f5364c18c62)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultTrimOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultTrimOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__94218dd8c54de2e70a1b85a6a1b3103a6c2bd9651990ee02abd2ba94754e00c8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetFuzz")
    def reset_fuzz(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFuzz", []))

    @jsii.member(jsii_name="resetFuzzVar")
    def reset_fuzz_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFuzzVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @builtins.property
    @jsii.member(jsii_name="fuzzInput")
    def fuzz_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fuzzInput"))

    @builtins.property
    @jsii.member(jsii_name="fuzzVarInput")
    def fuzz_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fuzzVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="fuzz")
    def fuzz(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fuzz"))

    @fuzz.setter
    def fuzz(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a2fddc6177ee6a5da9e4b09abd7935f4ec56739208a167018d0a5e781d976d6d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fuzz", value)

    @builtins.property
    @jsii.member(jsii_name="fuzzVar")
    def fuzz_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fuzzVar"))

    @fuzz_var.setter
    def fuzz_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f122c5c001d8f0f8ce1af8f158ef0e840f3420a8ad7b047d3d8cf3c6a5214a78)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fuzzVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__145ce504573c81e44dd204a4a01adb43d744a4eb4623ced34f7b0072271d3546)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__49e0dada7e89775091915330f5248079d3ef5aa823f644b631e3599d5667152e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultTrim]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultTrim]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultTrim]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__041d4ea0298df323e1eb1c4c59af39f457b6a8e2765bf715f97a87b5427b8cca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultUnsharpMask",
    jsii_struct_bases=[],
    name_mapping={
        "gain": "gain",
        "gain_var": "gainVar",
        "sigma": "sigma",
        "sigma_var": "sigmaVar",
        "threshold": "threshold",
        "threshold_var": "thresholdVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultUnsharpMask:
    def __init__(
        self,
        *,
        gain: typing.Optional[builtins.str] = None,
        gain_var: typing.Optional[builtins.str] = None,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
        threshold: typing.Optional[builtins.str] = None,
        threshold_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param gain: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        :param gain_var: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        :param sigma: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        :param threshold: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        :param threshold_var: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d0abfcc2ce717b66835d1ff07b9b97a2331003bf6fe353e8a2cfa43e4490cb4c)
            check_type(argname="argument gain", value=gain, expected_type=type_hints["gain"])
            check_type(argname="argument gain_var", value=gain_var, expected_type=type_hints["gain_var"])
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
            check_type(argname="argument threshold", value=threshold, expected_type=type_hints["threshold"])
            check_type(argname="argument threshold_var", value=threshold_var, expected_type=type_hints["threshold_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if gain is not None:
            self._values["gain"] = gain
        if gain_var is not None:
            self._values["gain_var"] = gain_var
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var
        if threshold is not None:
            self._values["threshold"] = threshold
        if threshold_var is not None:
            self._values["threshold_var"] = threshold_var

    @builtins.property
    def gain(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        '''
        result = self._values.get("gain")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gain_var(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        '''
        result = self._values.get("gain_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        '''
        result = self._values.get("threshold")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold_var(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        result = self._values.get("threshold_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultUnsharpMask(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultUnsharpMaskList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultUnsharpMaskList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__641dc53d3e06c006dbc4bc7c350595f647b1211c3ee0bd46fee16dcb7093399d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultUnsharpMaskOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c4c43cfd410d08fa68b7a90be26399721b949364a6bc2130868a062242db49d4)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultUnsharpMaskOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ee754d3aacaf0aa0c23e0dc0925e5c9802bf6b8bb363e0094998efa654cd93d0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__38f0b8e5d1877e12aea676ead2824a696611f197a526e876f41e2280d30b571f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9f08bf03f16ba9d4c1fff247eacb3dcd459b7ea333da7e3452db50dbfb19a4d1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultUnsharpMask]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultUnsharpMask]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultUnsharpMask]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9179c8e944b2708d80bdf1dbce43d2e50a6d1fe5ffbfaf612f6491872049727c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultUnsharpMaskOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultUnsharpMaskOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4c16418f8e07fd1aef13110eceda9d892e00816d31eb2e09e20db1376c22050f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetGain")
    def reset_gain(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGain", []))

    @jsii.member(jsii_name="resetGainVar")
    def reset_gain_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGainVar", []))

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @jsii.member(jsii_name="resetThreshold")
    def reset_threshold(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThreshold", []))

    @jsii.member(jsii_name="resetThresholdVar")
    def reset_threshold_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThresholdVar", []))

    @builtins.property
    @jsii.member(jsii_name="gainInput")
    def gain_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainInput"))

    @builtins.property
    @jsii.member(jsii_name="gainVarInput")
    def gain_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdInput")
    def threshold_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdVarInput")
    def threshold_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gain")
    def gain(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gain"))

    @gain.setter
    def gain(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a84948324689e8ff7e6a4f53986fc43d502b0e40f63919d232dd3276704c1ed1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gain", value)

    @builtins.property
    @jsii.member(jsii_name="gainVar")
    def gain_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gainVar"))

    @gain_var.setter
    def gain_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e46cbc0c736c7b0ee792cdc491d0dfcd56a5c86ca57bc285d1f6885d971c753a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gainVar", value)

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__050f0d080a4c65960484d329d795bb392b36484fc5b47ebaa97c06fa1f5a512e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2fb55cb80884f1e7e6ead1b9649e27be0a1fcc8bb38e403264eacb4e9bbb7e8a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="threshold")
    def threshold(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "threshold"))

    @threshold.setter
    def threshold(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__baac8163f4bdaf572ee8e9272e6d21fcd41526e842fb1f67a60460dffe4e4bf2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "threshold", value)

    @builtins.property
    @jsii.member(jsii_name="thresholdVar")
    def threshold_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "thresholdVar"))

    @threshold_var.setter
    def threshold_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__871fe16ffe126aa56e405e121eaa8681a3c3b9e7a521f6af3339b7fe70dd129b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "thresholdVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultUnsharpMask]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultUnsharpMask]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultUnsharpMask]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c2abf4983e98124554f786171a30a5702827f4893d9df3ce2a2c1d32d459ff51)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqual",
    jsii_struct_bases=[],
    name_mapping={
        "append": "append",
        "aspect_crop": "aspectCrop",
        "background_color": "backgroundColor",
        "blur": "blur",
        "chroma_key": "chromaKey",
        "composite": "composite",
        "compound": "compound",
        "contrast": "contrast",
        "crop": "crop",
        "face_crop": "faceCrop",
        "feature_crop": "featureCrop",
        "fit_and_fill": "fitAndFill",
        "goop": "goop",
        "grayscale": "grayscale",
        "hsl": "hsl",
        "hsv": "hsv",
        "if_dimension": "ifDimension",
        "if_orientation": "ifOrientation",
        "im_query": "imQuery",
        "max_colors": "maxColors",
        "mirror": "mirror",
        "mono_hue": "monoHue",
        "opacity": "opacity",
        "region_of_interest_crop": "regionOfInterestCrop",
        "relative_crop": "relativeCrop",
        "remove_color": "removeColor",
        "resize": "resize",
        "rotate": "rotate",
        "scale": "scale",
        "shear": "shear",
        "trim": "trim",
        "unsharp_mask": "unsharpMask",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqual:
    def __init__(
        self,
        *,
        append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualAppend", typing.Dict[builtins.str, typing.Any]]]]] = None,
        aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualAspectCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualBackgroundColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualBlur", typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualChromaKey", typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualComposite", typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualCompound", typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualContrast", typing.Dict[builtins.str, typing.Any]]]]] = None,
        crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualFaceCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualFeatureCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualFitAndFill", typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualGoop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualGrayscale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualHsl", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualHsv", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfDimension", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfOrientation", typing.Dict[builtins.str, typing.Any]]]]] = None,
        im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualImQuery", typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualMaxColors", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualMirror", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualMonoHue", typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualOpacity", typing.Dict[builtins.str, typing.Any]]]]] = None,
        region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualRegionOfInterestCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualRelativeCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualRemoveColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualResize", typing.Dict[builtins.str, typing.Any]]]]] = None,
        rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualRotate", typing.Dict[builtins.str, typing.Any]]]]] = None,
        scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualScale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualShear", typing.Dict[builtins.str, typing.Any]]]]] = None,
        trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualTrim", typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualUnsharpMask", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param append: append block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        :param aspect_crop: aspect_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param crop: crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        :param face_crop: face_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        :param feature_crop: feature_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        :param fit_and_fill: fit_and_fill block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param im_query: im_query block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param region_of_interest_crop: region_of_interest_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        :param relative_crop: relative_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param resize: resize block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        :param rotate: rotate block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        :param scale: scale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param shear: shear block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        :param trim: trim block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3e1b894d51fd9a6f1064b10b2a75d3074f2170f9020bd30a24feb78dd5bff171)
            check_type(argname="argument append", value=append, expected_type=type_hints["append"])
            check_type(argname="argument aspect_crop", value=aspect_crop, expected_type=type_hints["aspect_crop"])
            check_type(argname="argument background_color", value=background_color, expected_type=type_hints["background_color"])
            check_type(argname="argument blur", value=blur, expected_type=type_hints["blur"])
            check_type(argname="argument chroma_key", value=chroma_key, expected_type=type_hints["chroma_key"])
            check_type(argname="argument composite", value=composite, expected_type=type_hints["composite"])
            check_type(argname="argument compound", value=compound, expected_type=type_hints["compound"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument crop", value=crop, expected_type=type_hints["crop"])
            check_type(argname="argument face_crop", value=face_crop, expected_type=type_hints["face_crop"])
            check_type(argname="argument feature_crop", value=feature_crop, expected_type=type_hints["feature_crop"])
            check_type(argname="argument fit_and_fill", value=fit_and_fill, expected_type=type_hints["fit_and_fill"])
            check_type(argname="argument goop", value=goop, expected_type=type_hints["goop"])
            check_type(argname="argument grayscale", value=grayscale, expected_type=type_hints["grayscale"])
            check_type(argname="argument hsl", value=hsl, expected_type=type_hints["hsl"])
            check_type(argname="argument hsv", value=hsv, expected_type=type_hints["hsv"])
            check_type(argname="argument if_dimension", value=if_dimension, expected_type=type_hints["if_dimension"])
            check_type(argname="argument if_orientation", value=if_orientation, expected_type=type_hints["if_orientation"])
            check_type(argname="argument im_query", value=im_query, expected_type=type_hints["im_query"])
            check_type(argname="argument max_colors", value=max_colors, expected_type=type_hints["max_colors"])
            check_type(argname="argument mirror", value=mirror, expected_type=type_hints["mirror"])
            check_type(argname="argument mono_hue", value=mono_hue, expected_type=type_hints["mono_hue"])
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument region_of_interest_crop", value=region_of_interest_crop, expected_type=type_hints["region_of_interest_crop"])
            check_type(argname="argument relative_crop", value=relative_crop, expected_type=type_hints["relative_crop"])
            check_type(argname="argument remove_color", value=remove_color, expected_type=type_hints["remove_color"])
            check_type(argname="argument resize", value=resize, expected_type=type_hints["resize"])
            check_type(argname="argument rotate", value=rotate, expected_type=type_hints["rotate"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument shear", value=shear, expected_type=type_hints["shear"])
            check_type(argname="argument trim", value=trim, expected_type=type_hints["trim"])
            check_type(argname="argument unsharp_mask", value=unsharp_mask, expected_type=type_hints["unsharp_mask"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if append is not None:
            self._values["append"] = append
        if aspect_crop is not None:
            self._values["aspect_crop"] = aspect_crop
        if background_color is not None:
            self._values["background_color"] = background_color
        if blur is not None:
            self._values["blur"] = blur
        if chroma_key is not None:
            self._values["chroma_key"] = chroma_key
        if composite is not None:
            self._values["composite"] = composite
        if compound is not None:
            self._values["compound"] = compound
        if contrast is not None:
            self._values["contrast"] = contrast
        if crop is not None:
            self._values["crop"] = crop
        if face_crop is not None:
            self._values["face_crop"] = face_crop
        if feature_crop is not None:
            self._values["feature_crop"] = feature_crop
        if fit_and_fill is not None:
            self._values["fit_and_fill"] = fit_and_fill
        if goop is not None:
            self._values["goop"] = goop
        if grayscale is not None:
            self._values["grayscale"] = grayscale
        if hsl is not None:
            self._values["hsl"] = hsl
        if hsv is not None:
            self._values["hsv"] = hsv
        if if_dimension is not None:
            self._values["if_dimension"] = if_dimension
        if if_orientation is not None:
            self._values["if_orientation"] = if_orientation
        if im_query is not None:
            self._values["im_query"] = im_query
        if max_colors is not None:
            self._values["max_colors"] = max_colors
        if mirror is not None:
            self._values["mirror"] = mirror
        if mono_hue is not None:
            self._values["mono_hue"] = mono_hue
        if opacity is not None:
            self._values["opacity"] = opacity
        if region_of_interest_crop is not None:
            self._values["region_of_interest_crop"] = region_of_interest_crop
        if relative_crop is not None:
            self._values["relative_crop"] = relative_crop
        if remove_color is not None:
            self._values["remove_color"] = remove_color
        if resize is not None:
            self._values["resize"] = resize
        if rotate is not None:
            self._values["rotate"] = rotate
        if scale is not None:
            self._values["scale"] = scale
        if shear is not None:
            self._values["shear"] = shear
        if trim is not None:
            self._values["trim"] = trim
        if unsharp_mask is not None:
            self._values["unsharp_mask"] = unsharp_mask

    @builtins.property
    def append(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualAppend"]]]:
        '''append block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        '''
        result = self._values.get("append")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualAppend"]]], result)

    @builtins.property
    def aspect_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualAspectCrop"]]]:
        '''aspect_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        '''
        result = self._values.get("aspect_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualAspectCrop"]]], result)

    @builtins.property
    def background_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualBackgroundColor"]]]:
        '''background_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        '''
        result = self._values.get("background_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualBackgroundColor"]]], result)

    @builtins.property
    def blur(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualBlur"]]]:
        '''blur block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        '''
        result = self._values.get("blur")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualBlur"]]], result)

    @builtins.property
    def chroma_key(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualChromaKey"]]]:
        '''chroma_key block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        '''
        result = self._values.get("chroma_key")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualChromaKey"]]], result)

    @builtins.property
    def composite(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualComposite"]]]:
        '''composite block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        '''
        result = self._values.get("composite")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualComposite"]]], result)

    @builtins.property
    def compound(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualCompound"]]]:
        '''compound block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        '''
        result = self._values.get("compound")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualCompound"]]], result)

    @builtins.property
    def contrast(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualContrast"]]]:
        '''contrast block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualContrast"]]], result)

    @builtins.property
    def crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualCrop"]]]:
        '''crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        '''
        result = self._values.get("crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualCrop"]]], result)

    @builtins.property
    def face_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualFaceCrop"]]]:
        '''face_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        '''
        result = self._values.get("face_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualFaceCrop"]]], result)

    @builtins.property
    def feature_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualFeatureCrop"]]]:
        '''feature_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        '''
        result = self._values.get("feature_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualFeatureCrop"]]], result)

    @builtins.property
    def fit_and_fill(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualFitAndFill"]]]:
        '''fit_and_fill block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        '''
        result = self._values.get("fit_and_fill")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualFitAndFill"]]], result)

    @builtins.property
    def goop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualGoop"]]]:
        '''goop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        '''
        result = self._values.get("goop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualGoop"]]], result)

    @builtins.property
    def grayscale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualGrayscale"]]]:
        '''grayscale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        '''
        result = self._values.get("grayscale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualGrayscale"]]], result)

    @builtins.property
    def hsl(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualHsl"]]]:
        '''hsl block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        '''
        result = self._values.get("hsl")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualHsl"]]], result)

    @builtins.property
    def hsv(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualHsv"]]]:
        '''hsv block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        '''
        result = self._values.get("hsv")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualHsv"]]], result)

    @builtins.property
    def if_dimension(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfDimension"]]]:
        '''if_dimension block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        '''
        result = self._values.get("if_dimension")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfDimension"]]], result)

    @builtins.property
    def if_orientation(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfOrientation"]]]:
        '''if_orientation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        '''
        result = self._values.get("if_orientation")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfOrientation"]]], result)

    @builtins.property
    def im_query(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualImQuery"]]]:
        '''im_query block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        '''
        result = self._values.get("im_query")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualImQuery"]]], result)

    @builtins.property
    def max_colors(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualMaxColors"]]]:
        '''max_colors block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        '''
        result = self._values.get("max_colors")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualMaxColors"]]], result)

    @builtins.property
    def mirror(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualMirror"]]]:
        '''mirror block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        '''
        result = self._values.get("mirror")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualMirror"]]], result)

    @builtins.property
    def mono_hue(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualMonoHue"]]]:
        '''mono_hue block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        '''
        result = self._values.get("mono_hue")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualMonoHue"]]], result)

    @builtins.property
    def opacity(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualOpacity"]]]:
        '''opacity block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualOpacity"]]], result)

    @builtins.property
    def region_of_interest_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualRegionOfInterestCrop"]]]:
        '''region_of_interest_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        '''
        result = self._values.get("region_of_interest_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualRegionOfInterestCrop"]]], result)

    @builtins.property
    def relative_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualRelativeCrop"]]]:
        '''relative_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        '''
        result = self._values.get("relative_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualRelativeCrop"]]], result)

    @builtins.property
    def remove_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualRemoveColor"]]]:
        '''remove_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        '''
        result = self._values.get("remove_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualRemoveColor"]]], result)

    @builtins.property
    def resize(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualResize"]]]:
        '''resize block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        '''
        result = self._values.get("resize")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualResize"]]], result)

    @builtins.property
    def rotate(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualRotate"]]]:
        '''rotate block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        '''
        result = self._values.get("rotate")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualRotate"]]], result)

    @builtins.property
    def scale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualScale"]]]:
        '''scale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualScale"]]], result)

    @builtins.property
    def shear(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualShear"]]]:
        '''shear block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        '''
        result = self._values.get("shear")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualShear"]]], result)

    @builtins.property
    def trim(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualTrim"]]]:
        '''trim block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        '''
        result = self._values.get("trim")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualTrim"]]], result)

    @builtins.property
    def unsharp_mask(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualUnsharpMask"]]]:
        '''unsharp_mask block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        result = self._values.get("unsharp_mask")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualUnsharpMask"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqual(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualAppend",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_priority": "gravityPriority",
        "gravity_priority_var": "gravityPriorityVar",
        "gravity_var": "gravityVar",
        "preserve_minor_dimension": "preserveMinorDimension",
        "preserve_minor_dimension_var": "preserveMinorDimensionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualAppend:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualAppendImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_priority: typing.Optional[builtins.str] = None,
        gravity_priority_var: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        preserve_minor_dimension: typing.Optional[builtins.str] = None,
        preserve_minor_dimension_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Specifies where to place the ``image`` relative to the source image. The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_priority: Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal. The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority DataAkamaiImagingPolicyImage#gravity_priority}
        :param gravity_priority_var: Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal. The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority_var DataAkamaiImagingPolicyImage#gravity_priority_var}
        :param gravity_var: Specifies where to place the ``image`` relative to the source image. The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param preserve_minor_dimension: Whether to preserve the source image's minor dimension, ``false`` by default. The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension DataAkamaiImagingPolicyImage#preserve_minor_dimension}
        :param preserve_minor_dimension_var: Whether to preserve the source image's minor dimension, ``false`` by default. The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension_var DataAkamaiImagingPolicyImage#preserve_minor_dimension_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualAppendImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__349d9d703adcab4218daa8bab91f47619d0dca49f27e40d66e3c4d5f6f8215af)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_priority", value=gravity_priority, expected_type=type_hints["gravity_priority"])
            check_type(argname="argument gravity_priority_var", value=gravity_priority_var, expected_type=type_hints["gravity_priority_var"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument preserve_minor_dimension", value=preserve_minor_dimension, expected_type=type_hints["preserve_minor_dimension"])
            check_type(argname="argument preserve_minor_dimension_var", value=preserve_minor_dimension_var, expected_type=type_hints["preserve_minor_dimension_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_priority is not None:
            self._values["gravity_priority"] = gravity_priority
        if gravity_priority_var is not None:
            self._values["gravity_priority_var"] = gravity_priority_var
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if preserve_minor_dimension is not None:
            self._values["preserve_minor_dimension"] = preserve_minor_dimension
        if preserve_minor_dimension_var is not None:
            self._values["preserve_minor_dimension_var"] = preserve_minor_dimension_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualAppendImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualAppendImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Specifies where to place the ``image`` relative to the source image.

        The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_priority(self) -> typing.Optional[builtins.str]:
        '''Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal.

        The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority DataAkamaiImagingPolicyImage#gravity_priority}
        '''
        result = self._values.get("gravity_priority")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_priority_var(self) -> typing.Optional[builtins.str]:
        '''Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal.

        The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority_var DataAkamaiImagingPolicyImage#gravity_priority_var}
        '''
        result = self._values.get("gravity_priority_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Specifies where to place the ``image`` relative to the source image.

        The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def preserve_minor_dimension(self) -> typing.Optional[builtins.str]:
        '''Whether to preserve the source image's minor dimension, ``false`` by default.

        The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension DataAkamaiImagingPolicyImage#preserve_minor_dimension}
        '''
        result = self._values.get("preserve_minor_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def preserve_minor_dimension_var(self) -> typing.Optional[builtins.str]:
        '''Whether to preserve the source image's minor dimension, ``false`` by default.

        The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension_var DataAkamaiImagingPolicyImage#preserve_minor_dimension_var}
        '''
        result = self._values.get("preserve_minor_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualAppend(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualAppendImage",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualAppendImage:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualAppendImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualAppendImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualAppendImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3cb9447162504350035e7499f3c9dc397c62c76297b8d79c29cb3142cb0dc176)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualAppendImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualAppendImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualAppendImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__56154ecbd724e721b883c887c408b45550d9f9094d683916fc090b93a590956a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualAppendList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualAppendList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af6a9087a07eadb7ecb04fcc8c46e80898e5de8ff1afcc34e396c3576a460962)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualAppendOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9fc3c16a45958bf8ca9365a6840b6083814a074ed58bf43825295cd479ad8853)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualAppendOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cdb48ecb0d184840bb99deef978dd299d135d0cd868b0382be19c1047c4cf411)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b0f50439bd3ba725b0394583fb118e539b82b54eb91d6cc54465aad613f6bced)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e7b38daa917eb3230b6dfaaf607ad10594e4e41c028987795e8703a5feacd09f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualAppend]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualAppend]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualAppend]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__01517631ac9b74c5971e63c18eac310e035b72dd285a3f0076bf79f4a10372dd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualAppendOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualAppendOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5bb40b853318c04b62a9c5ca4d02f386e297a1a8d14c55fbf09adc0eadcec230)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualAppendImage()

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityPriority")
    def reset_gravity_priority(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityPriority", []))

    @jsii.member(jsii_name="resetGravityPriorityVar")
    def reset_gravity_priority_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityPriorityVar", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPreserveMinorDimension")
    def reset_preserve_minor_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPreserveMinorDimension", []))

    @jsii.member(jsii_name="resetPreserveMinorDimensionVar")
    def reset_preserve_minor_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPreserveMinorDimensionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualAppendImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualAppendImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityInput")
    def gravity_priority_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityPriorityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityVarInput")
    def gravity_priority_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityPriorityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualAppendImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualAppendImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionInput")
    def preserve_minor_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "preserveMinorDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionVarInput")
    def preserve_minor_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "preserveMinorDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c5ee135cfcaa7216438d2f33aab38541aeebf3fc56d048c4597855b06dd322ff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityPriority")
    def gravity_priority(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityPriority"))

    @gravity_priority.setter
    def gravity_priority(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b8598bcefa1578a09808b6749e035aceef96fd75f3a4b48850f6ed5181523333)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityPriority", value)

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityVar")
    def gravity_priority_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityPriorityVar"))

    @gravity_priority_var.setter
    def gravity_priority_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__27d424ef47e38b76d66f0687db7b4bdc477ee4aa89dec6914530d55211612f04)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityPriorityVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c184f95f0c869c040df684c279d81fba224d80177550a3029234aecd7500ca16)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimension")
    def preserve_minor_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "preserveMinorDimension"))

    @preserve_minor_dimension.setter
    def preserve_minor_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6b5d720eb2774538e05b44453a195c16807fd1dce9aa2faf2216dc3420a7168d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "preserveMinorDimension", value)

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionVar")
    def preserve_minor_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "preserveMinorDimensionVar"))

    @preserve_minor_dimension_var.setter
    def preserve_minor_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7c32129690d34b2456268cffc75ff1d297d0e6fb5ebb74ff0644d22c21c7a068)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "preserveMinorDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualAppend]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualAppend]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualAppend]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f228af7d7655926e575dc8e179855324358806d2e7c37c28fb27ac56621ac0b1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualAspectCrop",
    jsii_struct_bases=[],
    name_mapping={
        "allow_expansion": "allowExpansion",
        "allow_expansion_var": "allowExpansionVar",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualAspectCrop:
    def __init__(
        self,
        *,
        allow_expansion: typing.Optional[builtins.str] = None,
        allow_expansion_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_expansion: Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image. Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        :param allow_expansion_var: Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image. Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        :param height: The height term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The width term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        :param x_position: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b6f37e040ba6aa0c684e02a9433c649f52dcb0f65841c10df3d48c3605de8de6)
            check_type(argname="argument allow_expansion", value=allow_expansion, expected_type=type_hints["allow_expansion"])
            check_type(argname="argument allow_expansion_var", value=allow_expansion_var, expected_type=type_hints["allow_expansion_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if allow_expansion is not None:
            self._values["allow_expansion"] = allow_expansion
        if allow_expansion_var is not None:
            self._values["allow_expansion_var"] = allow_expansion_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def allow_expansion(self) -> typing.Optional[builtins.str]:
        '''Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image.

        Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        '''
        result = self._values.get("allow_expansion")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def allow_expansion_var(self) -> typing.Optional[builtins.str]:
        '''Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image.

        Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        '''
        result = self._values.get("allow_expansion_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualAspectCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualAspectCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualAspectCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6febb6637577d2e295a2ec8e39959f04acff6997fffc766b729c1b9337030ca9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualAspectCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__71824b1583753ff56474ca9dc06c4c188faf08eff15a03e79456e74d6d65283a)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualAspectCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c84045afb898ab213ffcabcb13703c19ba292b8f485b1f2fefe3dddbd6008bb8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cac75ba74d5db95ddde70963f521486ee5519dd15bf7e66aca9e7b076133e815)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af138da74a503d9795f52c2d3caa56fd9c6f81b6047634f28b5f85406a8da446)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualAspectCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualAspectCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualAspectCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5b7ce64d2180a4b36b0993da54d1237004ab0beaaaf60b555a86426032536608)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualAspectCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualAspectCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b2001dc3a3c7edaa944927c0529993de7561a5009f6f09fc132874163ecc99df)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAllowExpansion")
    def reset_allow_expansion(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansion", []))

    @jsii.member(jsii_name="resetAllowExpansionVar")
    def reset_allow_expansion_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansionVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionInput")
    def allow_expansion_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVarInput")
    def allow_expansion_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansion")
    def allow_expansion(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansion"))

    @allow_expansion.setter
    def allow_expansion(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__76621e38a0ec13235ae996c80f4a4524ca179854837591b0a91da5a08b494826)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansion", value)

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVar")
    def allow_expansion_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansionVar"))

    @allow_expansion_var.setter
    def allow_expansion_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__118c74507f30ae60bf3c02de170fd6cf873745211ecd97b694a3d681059e46c7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansionVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e54e9f3cfb4a304fb4418f13a249ea95beb4937b13b0187f2ef35bf6996c814b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__52ea7f258ed992803ccefdf290b31aa7e704360f68d2a97aa6271ee3d426f7d6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__378b3e765171de2608451b4b1732f80d196c13aeea8104587a162d290639129e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__06f2825be9b8c0cf411b5a6030441c43c9a38067abaeb3aefd623c4f956863d7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__897980bc83188e27d8d911ae75b386d800607e36aec3a541e7b9b0128566d2e8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__90673c99b073ea7473817c61e2af7c1ff6435a4ab7c5c9f7b716113c27dbdce1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9744de641189b0e2a817f104d773b4710bb04311ee056c199422601d15d4d5c6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4d8a00414231ab94d63ed32b47c0b21c35d0f6c3a89088c1ded66f8cb156476b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualAspectCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualAspectCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualAspectCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c89d4655e3e23c070f5281671e7d6961acb04a3f7525baf378b1f606d2011375)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualBackgroundColor",
    jsii_struct_bases=[],
    name_mapping={"color": "color", "color_var": "colorVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualBackgroundColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e9c29bf9700f389381d093c70296f71a0fa1a99b14c2f3721d6222afa3064fc9)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualBackgroundColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualBackgroundColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualBackgroundColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__623fb4ba17537eb43c8a7bd770d24030b586d62eebc3b0720ba290719eb5ad20)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualBackgroundColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__303b21a77e3521844ad14783c4448fa1c4ea5a3b7da84b91ec0f0e1efc3fafc0)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualBackgroundColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9f3f14b3e3f536406d6da08dce0dc2fa1d031a601b8b4e3e1fb3cd3ee1261bfd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__87b52393106e4925c08eb5c811397f0a86229cba5fd0cd7a7b992fab1f557fa3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6b1bccf747f5edb57aa4d770423e65249fd45c3b4e3636c0b02484418ff31dee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualBackgroundColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualBackgroundColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b064a703ec0fa0a4a8ffd315d1d5d6319d1b5405c8df7e106cafb4070ca3c9d3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualBackgroundColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualBackgroundColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__68779c0c08a5f754a0a11e3748bb5df6903b7877173e449bf7cf1f888d89e5c1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4fc40c9171737bb72d3b800f9bd33edbb4d295d5b3ee0136512149fde64047ba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cea797b46e9e9a5c8ebd45f458afd277ae820453dd0f31042eec81faee5ddd2b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualBackgroundColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualBackgroundColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualBackgroundColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c2c983e9a2d7af686f3ed3d4cb6b905e597ccbc35be2c8d6bc6dac26c2cdd8eb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualBlur",
    jsii_struct_bases=[],
    name_mapping={"sigma": "sigma", "sigma_var": "sigmaVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualBlur:
    def __init__(
        self,
        *,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param sigma: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ce8d56026d23e2d24a7b5928bc39b5f75c0d4bdba6f2f662a0c09b1bf07255be)
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualBlur(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualBlurList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualBlurList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1bb1ae6e1eb22603d824c38cc281f1813130d527b1e6ceb5cac742e3c45c2f46)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualBlurOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b97e64d25b0298a2d7017db2c7b5456e3096ea102cebb43e6e18b66a6801e7bf)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualBlurOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eff46aaf03ac1f5a9a185c1b3859952e049b839130b80c129a9d0764429923d3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d879bd64d48b469c7a9b966b6671c6149e8a3dacd5b9d9141cced9293b826107)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c6b3a72559b414a2426f1164b50455d0aeaa118e26b3cacb518e90402fd33e12)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualBlur]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualBlur]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aa5da4a3581f3fc92e9f1a59ff7b0ad9ef4fb63b9d01e229eedb96252fcf8f99)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualBlurOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualBlurOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1efec8c18ef92a3ab6f27cd175b8c6b82851368c83f2ffbadc4d8c5aa9e7a822)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ec27ce40b05ce4bfaf300fe15488a695dba2adaf64c29f310b6f2a423be08561)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a0e944ab7ed625e47511f815b917d7a1dfc983da5a13a2b03a90c11cad82c8ea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualBlur]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualBlur]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualBlur]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__29edcb09f308069447973de8aaf0dc0ed08ee65cf117850887ff26d8d1da9d46)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualChromaKey",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_feather": "hueFeather",
        "hue_feather_var": "hueFeatherVar",
        "hue_tolerance": "hueTolerance",
        "hue_tolerance_var": "hueToleranceVar",
        "hue_var": "hueVar",
        "lightness_feather": "lightnessFeather",
        "lightness_feather_var": "lightnessFeatherVar",
        "lightness_tolerance": "lightnessTolerance",
        "lightness_tolerance_var": "lightnessToleranceVar",
        "saturation_feather": "saturationFeather",
        "saturation_feather_var": "saturationFeatherVar",
        "saturation_tolerance": "saturationTolerance",
        "saturation_tolerance_var": "saturationToleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualChromaKey:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_feather: typing.Optional[builtins.str] = None,
        hue_feather_var: typing.Optional[builtins.str] = None,
        hue_tolerance: typing.Optional[builtins.str] = None,
        hue_tolerance_var: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness_feather: typing.Optional[builtins.str] = None,
        lightness_feather_var: typing.Optional[builtins.str] = None,
        lightness_tolerance: typing.Optional[builtins.str] = None,
        lightness_tolerance_var: typing.Optional[builtins.str] = None,
        saturation_feather: typing.Optional[builtins.str] = None,
        saturation_feather_var: typing.Optional[builtins.str] = None,
        saturation_tolerance: typing.Optional[builtins.str] = None,
        saturation_tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_feather: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        :param hue_feather_var: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        :param hue_tolerance: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        :param hue_tolerance_var: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        :param hue_var: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness_feather: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        :param lightness_feather_var: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        :param lightness_tolerance: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        :param lightness_tolerance_var: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        :param saturation_feather: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        :param saturation_feather_var: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        :param saturation_tolerance: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        :param saturation_tolerance_var: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b30361e351bd103e4c3adb80a7fd061c6aeccf291a2f160658eadb3520899536)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_feather", value=hue_feather, expected_type=type_hints["hue_feather"])
            check_type(argname="argument hue_feather_var", value=hue_feather_var, expected_type=type_hints["hue_feather_var"])
            check_type(argname="argument hue_tolerance", value=hue_tolerance, expected_type=type_hints["hue_tolerance"])
            check_type(argname="argument hue_tolerance_var", value=hue_tolerance_var, expected_type=type_hints["hue_tolerance_var"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness_feather", value=lightness_feather, expected_type=type_hints["lightness_feather"])
            check_type(argname="argument lightness_feather_var", value=lightness_feather_var, expected_type=type_hints["lightness_feather_var"])
            check_type(argname="argument lightness_tolerance", value=lightness_tolerance, expected_type=type_hints["lightness_tolerance"])
            check_type(argname="argument lightness_tolerance_var", value=lightness_tolerance_var, expected_type=type_hints["lightness_tolerance_var"])
            check_type(argname="argument saturation_feather", value=saturation_feather, expected_type=type_hints["saturation_feather"])
            check_type(argname="argument saturation_feather_var", value=saturation_feather_var, expected_type=type_hints["saturation_feather_var"])
            check_type(argname="argument saturation_tolerance", value=saturation_tolerance, expected_type=type_hints["saturation_tolerance"])
            check_type(argname="argument saturation_tolerance_var", value=saturation_tolerance_var, expected_type=type_hints["saturation_tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_feather is not None:
            self._values["hue_feather"] = hue_feather
        if hue_feather_var is not None:
            self._values["hue_feather_var"] = hue_feather_var
        if hue_tolerance is not None:
            self._values["hue_tolerance"] = hue_tolerance
        if hue_tolerance_var is not None:
            self._values["hue_tolerance_var"] = hue_tolerance_var
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness_feather is not None:
            self._values["lightness_feather"] = lightness_feather
        if lightness_feather_var is not None:
            self._values["lightness_feather_var"] = lightness_feather_var
        if lightness_tolerance is not None:
            self._values["lightness_tolerance"] = lightness_tolerance
        if lightness_tolerance_var is not None:
            self._values["lightness_tolerance_var"] = lightness_tolerance_var
        if saturation_feather is not None:
            self._values["saturation_feather"] = saturation_feather
        if saturation_feather_var is not None:
            self._values["saturation_feather_var"] = saturation_feather_var
        if saturation_tolerance is not None:
            self._values["saturation_tolerance"] = saturation_tolerance
        if saturation_tolerance_var is not None:
            self._values["saturation_tolerance_var"] = saturation_tolerance_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        '''
        result = self._values.get("hue_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        '''
        result = self._values.get("hue_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        '''
        result = self._values.get("hue_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        '''
        result = self._values.get("hue_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        '''
        result = self._values.get("lightness_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        '''
        result = self._values.get("lightness_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        '''
        result = self._values.get("lightness_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        '''
        result = self._values.get("lightness_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        '''
        result = self._values.get("saturation_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        '''
        result = self._values.get("saturation_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        '''
        result = self._values.get("saturation_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        result = self._values.get("saturation_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualChromaKey(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualChromaKeyList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualChromaKeyList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__81ad209ef3506300013878107d26432e3324465f5beeea23d2796a420a60fb77)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualChromaKeyOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__24e35f5ee8c7f1de377475c1464dee874e9657000db53e58a5b00d6f66c6c28f)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualChromaKeyOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d216526796f6cf1b7794fbf97bc7fe5d51eefc2f6e933a27da479a7dac6f1572)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d735710720bf3258e3ad5f670948801c119aba4cfc4360863c612ac6601e8b9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b138eac3d7d4f4e2186e98d9ff4fe1de9a6a2ae4df902aff376385149a9c4b1d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualChromaKey]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualChromaKey]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d9d9dd028d800222df898395038d7450643e97ae1e7a94b29fffad1be99b544b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualChromaKeyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualChromaKeyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fd13b2a03aa426e8d1920c6895eda0df5eb2b40fdd5b9c9d88575fab78275817)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueFeather")
    def reset_hue_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeather", []))

    @jsii.member(jsii_name="resetHueFeatherVar")
    def reset_hue_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeatherVar", []))

    @jsii.member(jsii_name="resetHueTolerance")
    def reset_hue_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueTolerance", []))

    @jsii.member(jsii_name="resetHueToleranceVar")
    def reset_hue_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueToleranceVar", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightnessFeather")
    def reset_lightness_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeather", []))

    @jsii.member(jsii_name="resetLightnessFeatherVar")
    def reset_lightness_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeatherVar", []))

    @jsii.member(jsii_name="resetLightnessTolerance")
    def reset_lightness_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessTolerance", []))

    @jsii.member(jsii_name="resetLightnessToleranceVar")
    def reset_lightness_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessToleranceVar", []))

    @jsii.member(jsii_name="resetSaturationFeather")
    def reset_saturation_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeather", []))

    @jsii.member(jsii_name="resetSaturationFeatherVar")
    def reset_saturation_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeatherVar", []))

    @jsii.member(jsii_name="resetSaturationTolerance")
    def reset_saturation_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationTolerance", []))

    @jsii.member(jsii_name="resetSaturationToleranceVar")
    def reset_saturation_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherInput")
    def hue_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVarInput")
    def hue_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceInput")
    def hue_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVarInput")
    def hue_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherInput")
    def lightness_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVarInput")
    def lightness_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceInput")
    def lightness_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVarInput")
    def lightness_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherInput")
    def saturation_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVarInput")
    def saturation_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceInput")
    def saturation_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVarInput")
    def saturation_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a4c41b72ee6f62ad02c3bfd28f4b4c03b227207bbb9b849830d308fe041226ec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeather")
    def hue_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeather"))

    @hue_feather.setter
    def hue_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__afb4faf038c5aea0b241c81bebf62952fc5f6b783dab8162f1f57249bc3f92c0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeather", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVar")
    def hue_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeatherVar"))

    @hue_feather_var.setter
    def hue_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f8a287651b6c926d7a1c81f7ecba2067b3abb922dd49967e8cc7ba3538d25181)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueTolerance")
    def hue_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueTolerance"))

    @hue_tolerance.setter
    def hue_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4fd9d4768e7795d121fbbe6fc6bcb60a10819b1ae32cf31a5f6bd0dca56dec68)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVar")
    def hue_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueToleranceVar"))

    @hue_tolerance_var.setter
    def hue_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__625e97d4a33c17095f457bab9d1749537ed252871f2ed51773f25eaf935ab5d7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__80ef806a1ca86573e2f2926cfdd6d3fdc78ca75149d211282f6a4c9aa5f3944a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeather")
    def lightness_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeather"))

    @lightness_feather.setter
    def lightness_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__163a4fb56f3375dc65ce825f31db61aee3f0c4c5a255e1fd603726af799d8027)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeather", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVar")
    def lightness_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeatherVar"))

    @lightness_feather_var.setter
    def lightness_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c43a5ef5bfecea058302c9c6ebe2dbe1de7d44a15d96d47c5df2d55949f121ca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessTolerance")
    def lightness_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessTolerance"))

    @lightness_tolerance.setter
    def lightness_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d7dadbced295bd48dfdb3e77d840e9f8f614c808f8078ad309a115f9ee78ec7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVar")
    def lightness_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessToleranceVar"))

    @lightness_tolerance_var.setter
    def lightness_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b5c2979a08bdefddead69bb3629fb00d18ef71e9616c78c904309ff781838edf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeather")
    def saturation_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeather"))

    @saturation_feather.setter
    def saturation_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b0b2d808cb7bd091932fc7e9442da717659289d42ae6b26e8b966ae95abb9180)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeather", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVar")
    def saturation_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeatherVar"))

    @saturation_feather_var.setter
    def saturation_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cab74d6fe36e9f97c6d1beb7b6695f44db478fc295a6fd67faa49a4f2e39c671)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationTolerance")
    def saturation_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationTolerance"))

    @saturation_tolerance.setter
    def saturation_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f7ce049b8de72047d0315400746bb04d317c78852a3b1cfecdce6f745b146ba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVar")
    def saturation_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationToleranceVar"))

    @saturation_tolerance_var.setter
    def saturation_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a88ec69fa03a2d070a9bccc826a21d1ecf07f0e6e8d23dc98bc42b8ce6426a10)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualChromaKey]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualChromaKey]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualChromaKey]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0e46e2d26d8a2a01b30ff6259c37f291e6607780b47f3e912555c790add103e8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualComposite",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "placement": "placement",
        "placement_var": "placementVar",
        "scale": "scale",
        "scale_dimension": "scaleDimension",
        "scale_dimension_var": "scaleDimensionVar",
        "scale_var": "scaleVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualComposite:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualCompositeImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        placement: typing.Optional[builtins.str] = None,
        placement_var: typing.Optional[builtins.str] = None,
        scale: typing.Optional[builtins.str] = None,
        scale_dimension: typing.Optional[builtins.str] = None,
        scale_dimension_var: typing.Optional[builtins.str] = None,
        scale_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param placement: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        :param placement_var: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        :param scale: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param scale_dimension: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        :param scale_dimension_var: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        :param scale_var: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        :param x_position: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualCompositeImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__904d6c3b6a6fb89d0e6ea76a56bacad419c836d2ddbd0136f40fb618c9a1c50f)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument placement", value=placement, expected_type=type_hints["placement"])
            check_type(argname="argument placement_var", value=placement_var, expected_type=type_hints["placement_var"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument scale_dimension", value=scale_dimension, expected_type=type_hints["scale_dimension"])
            check_type(argname="argument scale_dimension_var", value=scale_dimension_var, expected_type=type_hints["scale_dimension_var"])
            check_type(argname="argument scale_var", value=scale_var, expected_type=type_hints["scale_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if placement is not None:
            self._values["placement"] = placement
        if placement_var is not None:
            self._values["placement_var"] = placement_var
        if scale is not None:
            self._values["scale"] = scale
        if scale_dimension is not None:
            self._values["scale_dimension"] = scale_dimension
        if scale_dimension_var is not None:
            self._values["scale_dimension_var"] = scale_dimension_var
        if scale_var is not None:
            self._values["scale_var"] = scale_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualCompositeImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualCompositeImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        '''
        result = self._values.get("placement")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement_var(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        '''
        result = self._values.get("placement_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        '''
        result = self._values.get("scale_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        '''
        result = self._values.get("scale_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        '''
        result = self._values.get("scale_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualComposite(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualCompositeImage",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualCompositeImage:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualCompositeImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualCompositeImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualCompositeImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a1ae2d478b5d62ec5460763a62b737fa26c7f91b54b74e655c79b0331f6b5ef)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualCompositeImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualCompositeImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__985b1215b220393b3abfb23d34ffcf18209af4c59ae824a1aa3bcac6670cc44e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualCompositeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualCompositeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__798f3f04df25250690ae6700a6ab14432e21c31fe4e5b3196a300976e9ddb75f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualCompositeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e88d39cec6cb43ae7a7cb789fcd74111ec30c07d3f0ef6189a8d18a6f654c131)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualCompositeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e432c5c374b6d9e14b34469ee492cde6bed2cb4dca682aabfed960bfe36d6d48)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0fe33f1eb9dbf2ef870635b7effb04dbee63a630d4ab1a75149d1d2b1b07d3fd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7b5e077a44adc80aa208728e74aee0ef9a7eda11a9f54a6022af9c584b55e492)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualComposite]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualComposite]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5af7ab81f1a1ccb435b7681f5452ac8086fad67df94b87d72869ac89f682adc7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualCompositeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualCompositeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__749892954b4c1233f5ba4f83170ebd76331171faa96e633a225e784ec1b43e5e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualCompositeImage()

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPlacement")
    def reset_placement(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacement", []))

    @jsii.member(jsii_name="resetPlacementVar")
    def reset_placement_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacementVar", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetScaleDimension")
    def reset_scale_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimension", []))

    @jsii.member(jsii_name="resetScaleDimensionVar")
    def reset_scale_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimensionVar", []))

    @jsii.member(jsii_name="resetScaleVar")
    def reset_scale_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualCompositeImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualCompositeImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualCompositeImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="placementInput")
    def placement_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementInput"))

    @builtins.property
    @jsii.member(jsii_name="placementVarInput")
    def placement_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionInput")
    def scale_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVarInput")
    def scale_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleVarInput")
    def scale_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0b96370137a59380e14cf6d719067cf82edfa994d9640ccad4990a2b3966ed2b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eaf9769670ccddb5f1554c7b71fabc6a6a624bfebd223a600f7b488be0badece)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="placement")
    def placement(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placement"))

    @placement.setter
    def placement(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__68aa8e90c6af33e631b9e650fd7e176a4ec8cf4bae377eb74dd383e96529f3e8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placement", value)

    @builtins.property
    @jsii.member(jsii_name="placementVar")
    def placement_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placementVar"))

    @placement_var.setter
    def placement_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eb9131e86afa8adb6be50573b938ad5d044985f9fc47a0f304fcca49d8122e57)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placementVar", value)

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scale"))

    @scale.setter
    def scale(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__37c998bd6e3d86e9022e84c4e52714f12729c28f3c14c30bb65ed7c54068a065)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scale", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimension")
    def scale_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimension"))

    @scale_dimension.setter
    def scale_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e3fa7cd7a9fda50287c13f029e2c7a2f82b0cd4788136d5e135055e0a704260d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimension", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVar")
    def scale_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimensionVar"))

    @scale_dimension_var.setter
    def scale_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a2a4350b0aa6bc5dee0b9731e929f4ae770f5bbf2517d12e46c0c4e68bc20da8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="scaleVar")
    def scale_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleVar"))

    @scale_var.setter
    def scale_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d9cb5f89887607598084898dfabc1c73b5db17ecb8b58553ffd804d279f31054)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__29e746206efdb97fc8d24d02ccd7b901213d2bea83e0b003b358454b33d02b6c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__170b032d70dc6279cbc542874d481e0b9a6afc9a1315d920558f771a8fcce715)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1b36ded035c9fa1b549ce58a6e9c897e2e6a98d7ee564bf81c40f992267a90bb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7360a731906a41a756ad8d5791329a7092f055d6a313c649e6ca395e6b88fdaf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualComposite]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualComposite]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualComposite]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b2f6fc3bf5427090dc9c761bd4edf902679c872ab5eca0838b9269880f7fddf8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualCompound",
    jsii_struct_bases=[],
    name_mapping={"transformations": "transformations"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualCompound:
    def __init__(
        self,
        *,
        transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param transformations: transformations block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__40e321e12f5be7fb1228c09f53c48ba6f1005e7f25ae9c239f699a82a469a19d)
            check_type(argname="argument transformations", value=transformations, expected_type=type_hints["transformations"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if transformations is not None:
            self._values["transformations"] = transformations

    @builtins.property
    def transformations(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualCompoundTransformations"]]]:
        '''transformations block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        result = self._values.get("transformations")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualCompoundTransformations"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualCompound(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualCompoundList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualCompoundList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a14b0d186dd992aad6468643539b246acb7a3d768c38c1c9582a521c0c71043b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualCompoundOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d6a6b0a5e9c21c33992eb88552b99f628b845702dbebf2f47df52446c8a48e1)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualCompoundOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6bca1aec467f609e8345eb0b9012d8a740f0d25c13994695762e217a14fb9622)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c5d38c42ce99f6457575fc9225a14bb6db0c423a768a3818e72a90f0ba36e862)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e1b6ab1ec766baf18602598c77eb9f373dc3391f5d4800d4d1ce71e8b220cd3d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualCompound]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualCompound]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2fb186fe48636d076efc126e9af392cdb1666940fa60173471e9c133e855baeb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualCompoundOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualCompoundOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f85b6982509e16fc574bd76e4cc8d14d798fd78b2a2a3aa839730d1e948d8915)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformations")
    def put_transformations(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6c1f1506325a9a730b8f715e2bcb5e13c2da38ad10f0d2fc792318a79e0dea97)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTransformations", [value]))

    @jsii.member(jsii_name="resetTransformations")
    def reset_transformations(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformations", []))

    @builtins.property
    @jsii.member(jsii_name="transformations")
    def transformations(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualCompoundTransformationsList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualCompoundTransformationsList", jsii.get(self, "transformations"))

    @builtins.property
    @jsii.member(jsii_name="transformationsInput")
    def transformations_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualCompoundTransformations"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualCompoundTransformations"]]], jsii.get(self, "transformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualCompound]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualCompound]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualCompound]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__31ddb27d50ac9f103aa096b83f14a02e3f8c7ff096dc378a5b08df9d0f465f94)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualCompoundTransformations",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualCompoundTransformations:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualCompoundTransformations(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualCompoundTransformationsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualCompoundTransformationsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__14d50aa079ec40af534ebcd35ea415a5eb46f8ded13aef0a61a658408962b0ff)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualCompoundTransformationsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__131117adc4a1c4d5fd485e858e6d4b4578d1f800ad061589c91892e8980df286)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualCompoundTransformationsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c723de3206a5846f8b03db336fe11470c44889bf35fec282f0c03cda5a37bec4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__01a1e4765738c38608e265dfa971d85c88b893d54d952c1982fa944a78f8c440)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2cf16852d7ef792b9a3e099c904b17d6eb0d77329ab348904b75a5cdf952d1a3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualCompoundTransformations]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualCompoundTransformations]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualCompoundTransformations]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6963052e57ae218b8850501e26473e60c809becbe10489e317e2c8b0d61dc740)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualCompoundTransformationsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualCompoundTransformationsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__13baa64ab92060544e96ac25255c09481541feb6c841ec88c5d875aeff12bf09)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualCompoundTransformations]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualCompoundTransformations]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualCompoundTransformations]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__25d0e74ebb7b12ab25aa960921b2abf489fe4a901d30f92100573335e94abb6d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualContrast",
    jsii_struct_bases=[],
    name_mapping={
        "brightness": "brightness",
        "brightness_var": "brightnessVar",
        "contrast": "contrast",
        "contrast_var": "contrastVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualContrast:
    def __init__(
        self,
        *,
        brightness: typing.Optional[builtins.str] = None,
        brightness_var: typing.Optional[builtins.str] = None,
        contrast: typing.Optional[builtins.str] = None,
        contrast_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param brightness: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        :param brightness_var: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        :param contrast: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param contrast_var: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__67639a3a1411f354789fcfc6c68800dfa2dc44d74d6b7d3e75c6362e14ecb947)
            check_type(argname="argument brightness", value=brightness, expected_type=type_hints["brightness"])
            check_type(argname="argument brightness_var", value=brightness_var, expected_type=type_hints["brightness_var"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument contrast_var", value=contrast_var, expected_type=type_hints["contrast_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if brightness is not None:
            self._values["brightness"] = brightness
        if brightness_var is not None:
            self._values["brightness_var"] = brightness_var
        if contrast is not None:
            self._values["contrast"] = contrast
        if contrast_var is not None:
            self._values["contrast_var"] = contrast_var

    @builtins.property
    def brightness(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        '''
        result = self._values.get("brightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def brightness_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        '''
        result = self._values.get("brightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        result = self._values.get("contrast_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualContrast(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualContrastList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualContrastList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b016357a063809c38377acf2334aa8a792d160d6b1add16b29836988b66440bc)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualContrastOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aeb881fa6862d1c323d02d7449d37108ee8f496f4d5e7388e7d4968ea737b01f)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualContrastOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd652cd01b3437cc8fad3dcc589ab672cf545abf303cf84395ddb1aa83ee8cac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fe7f39f1688f8406656bfd208d9767f9754bdc7cf3a45b8c960c428183b457e1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__38633c4026cd3d258b7322ad363dc48453f85cf8be96cae7b1699b673fd2c09b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualContrast]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualContrast]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d6f776b2e8ba6ad35f5608cddc7369b7e7930eccdbfd690bceb7dc152d4f8728)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualContrastOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualContrastOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__294c55bba246f5a307ea15ddf0df5a2d77716a73a97226e5febd040790dbb511)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetBrightness")
    def reset_brightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightness", []))

    @jsii.member(jsii_name="resetBrightnessVar")
    def reset_brightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightnessVar", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetContrastVar")
    def reset_contrast_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrastVar", []))

    @builtins.property
    @jsii.member(jsii_name="brightnessInput")
    def brightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="brightnessVarInput")
    def brightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastVarInput")
    def contrast_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="brightness")
    def brightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightness"))

    @brightness.setter
    def brightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8e35aabd2285bb4d7d797cfde89e3f0ae8cb1208567a0ee8afb90c5637979066)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightness", value)

    @builtins.property
    @jsii.member(jsii_name="brightnessVar")
    def brightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightnessVar"))

    @brightness_var.setter
    def brightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__165d03ab4bf96d440e0388d6a83632609b9ff269f39108227dd1ec349df29ca1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrast"))

    @contrast.setter
    def contrast(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__99fff2be6f5a4d9568d3cb613358ee1a521c6aabdb884b272ad6ee7474873268)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrast", value)

    @builtins.property
    @jsii.member(jsii_name="contrastVar")
    def contrast_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrastVar"))

    @contrast_var.setter
    def contrast_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__535992be2013cf77de8f0778fb491929d473ddeb47038ddad02428cd24e8cde8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrastVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualContrast]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualContrast]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualContrast]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5260874d58c0b2d4b5dd9bce30c5f58921c45264686b0293251fd815c16d9ebd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualCrop",
    jsii_struct_bases=[],
    name_mapping={
        "allow_expansion": "allowExpansion",
        "allow_expansion_var": "allowExpansionVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualCrop:
    def __init__(
        self,
        *,
        allow_expansion: typing.Optional[builtins.str] = None,
        allow_expansion_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_expansion: If cropping an area outside of the existing canvas, expands the image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        :param allow_expansion_var: If cropping an area outside of the existing canvas, expands the image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        :param gravity: Frame of reference for X and Y Positions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Frame of reference for X and Y Positions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The number of pixels to crop along the y-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The number of pixels to crop along the y-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The number of pixels to crop along the x-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The number of pixels to crop along the x-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        :param x_position: The x-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8853b26f3559c444e58a890cf224c641cef094a0ebcd913d483a31215e179601)
            check_type(argname="argument allow_expansion", value=allow_expansion, expected_type=type_hints["allow_expansion"])
            check_type(argname="argument allow_expansion_var", value=allow_expansion_var, expected_type=type_hints["allow_expansion_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if allow_expansion is not None:
            self._values["allow_expansion"] = allow_expansion
        if allow_expansion_var is not None:
            self._values["allow_expansion_var"] = allow_expansion_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def allow_expansion(self) -> typing.Optional[builtins.str]:
        '''If cropping an area outside of the existing canvas, expands the image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        '''
        result = self._values.get("allow_expansion")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def allow_expansion_var(self) -> typing.Optional[builtins.str]:
        '''If cropping an area outside of the existing canvas, expands the image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        '''
        result = self._values.get("allow_expansion_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Frame of reference for X and Y Positions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Frame of reference for X and Y Positions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the y-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the y-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the x-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the x-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__68d9d0c4305f58aeb42ca872fe38ca488e602bbdc7bf31b4d3af5d29f687282f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1d20f057c895aa6b8666f3b90ca00983300a1b4f8926b1bdba942b75497171df)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__67a0d1cdd80651588fdea147255c3f4590f6ecb5a1c0c0274aa16d137062bf87)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__73ad9a0755c199b92e0c730204c75ff613f24e13b086e420eb13851751e2422c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__88cebe7a34cccd247d04beedb4a763e3998b5546a5f571923111a5d461d37cf0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__35b2ceb9c6895553d29804fe7037e69fde88e8fc732bd787c025e29471c0fd31)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__45654ea86dce70ed83ebad1a880ad9513cd5bcedc97513b31ad9ed9c14d3a955)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAllowExpansion")
    def reset_allow_expansion(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansion", []))

    @jsii.member(jsii_name="resetAllowExpansionVar")
    def reset_allow_expansion_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansionVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionInput")
    def allow_expansion_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVarInput")
    def allow_expansion_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansion")
    def allow_expansion(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansion"))

    @allow_expansion.setter
    def allow_expansion(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fbaeb9f4bde06690602f9a91b50e84a39f02307ea17004b34e2b064a59dc6e1d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansion", value)

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVar")
    def allow_expansion_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansionVar"))

    @allow_expansion_var.setter
    def allow_expansion_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e28a17f8b71edf046e2f546fb1538fb26105c5d3ff97fb2a73f5733fcded6b6a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansionVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1be3c4d2440e6ec2aeb2a7ad206d967c916e357742075362bcd7db29d57a2ba5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c029aafcc179694564db801d78c02f719c7682edfe7d40e0fcbc1e5c78106eaf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__efe8b74288dd0175ab3fcf39988cd614c4b02588a54c8377b428d64d194d4639)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cb10d64c654622078f49155177414b825fc27179feca49b3267816d1e026676b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f9a4bc31b9f1766867c8a15dfbcdeec351180fde9f2b5e156ff63388374f5d47)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__23903f55c2f9aa487097ae6e995262717cbba8be35ba84d5519bdec44db88598)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e87f36efb196898519d2261ae946a8a5013993b92fefa45c81b0241e34db173)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ed8a9ac12dcf620bec50db6efd74dda5ced8f075c346f2759a359a7144eff139)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__716338747344f6b174aba859d6fb3a31da3a565eac50acc854a8cc6667209ff0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3239acb5aef6203226809d249150da186f2d4120a85bd2c59f504cd21f055d4b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bff409a43465496358512a0df41c6cd50122fecfb6c67d5c91b239aea1ee5745)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualFaceCrop",
    jsii_struct_bases=[],
    name_mapping={
        "algorithm": "algorithm",
        "algorithm_var": "algorithmVar",
        "confidence": "confidence",
        "confidence_var": "confidenceVar",
        "fail_gravity": "failGravity",
        "fail_gravity_var": "failGravityVar",
        "focus": "focus",
        "focus_var": "focusVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "padding": "padding",
        "padding_var": "paddingVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualFaceCrop:
    def __init__(
        self,
        *,
        algorithm: typing.Optional[builtins.str] = None,
        algorithm_var: typing.Optional[builtins.str] = None,
        confidence: typing.Optional[builtins.str] = None,
        confidence_var: typing.Optional[builtins.str] = None,
        fail_gravity: typing.Optional[builtins.str] = None,
        fail_gravity_var: typing.Optional[builtins.str] = None,
        focus: typing.Optional[builtins.str] = None,
        focus_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param algorithm: Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm DataAkamaiImagingPolicyImage#algorithm}
        :param algorithm_var: Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm_var DataAkamaiImagingPolicyImage#algorithm_var}
        :param confidence: With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image. Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence DataAkamaiImagingPolicyImage#confidence}
        :param confidence_var: With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image. Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence_var DataAkamaiImagingPolicyImage#confidence_var}
        :param fail_gravity: Controls placement of the crop if Image and Video Manager does not detect any faces in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        :param fail_gravity_var: Controls placement of the crop if Image and Video Manager does not detect any faces in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        :param focus: Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus DataAkamaiImagingPolicyImage#focus}
        :param focus_var: Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus_var DataAkamaiImagingPolicyImage#focus_var}
        :param gravity: Controls placement of the crop. Directions are relative to the face(s) plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Controls placement of the crop. Directions are relative to the face(s) plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param padding: The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        :param style: Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af983ffae1ba515fe5c7eba40328e9f1d41cf7b8ddbf45682a8c98073ef638f4)
            check_type(argname="argument algorithm", value=algorithm, expected_type=type_hints["algorithm"])
            check_type(argname="argument algorithm_var", value=algorithm_var, expected_type=type_hints["algorithm_var"])
            check_type(argname="argument confidence", value=confidence, expected_type=type_hints["confidence"])
            check_type(argname="argument confidence_var", value=confidence_var, expected_type=type_hints["confidence_var"])
            check_type(argname="argument fail_gravity", value=fail_gravity, expected_type=type_hints["fail_gravity"])
            check_type(argname="argument fail_gravity_var", value=fail_gravity_var, expected_type=type_hints["fail_gravity_var"])
            check_type(argname="argument focus", value=focus, expected_type=type_hints["focus"])
            check_type(argname="argument focus_var", value=focus_var, expected_type=type_hints["focus_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if algorithm is not None:
            self._values["algorithm"] = algorithm
        if algorithm_var is not None:
            self._values["algorithm_var"] = algorithm_var
        if confidence is not None:
            self._values["confidence"] = confidence
        if confidence_var is not None:
            self._values["confidence_var"] = confidence_var
        if fail_gravity is not None:
            self._values["fail_gravity"] = fail_gravity
        if fail_gravity_var is not None:
            self._values["fail_gravity_var"] = fail_gravity_var
        if focus is not None:
            self._values["focus"] = focus
        if focus_var is not None:
            self._values["focus_var"] = focus_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def algorithm(self) -> typing.Optional[builtins.str]:
        '''Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm DataAkamaiImagingPolicyImage#algorithm}
        '''
        result = self._values.get("algorithm")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def algorithm_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm_var DataAkamaiImagingPolicyImage#algorithm_var}
        '''
        result = self._values.get("algorithm_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def confidence(self) -> typing.Optional[builtins.str]:
        '''With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image.

        Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence DataAkamaiImagingPolicyImage#confidence}
        '''
        result = self._values.get("confidence")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def confidence_var(self) -> typing.Optional[builtins.str]:
        '''With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image.

        Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence_var DataAkamaiImagingPolicyImage#confidence_var}
        '''
        result = self._values.get("confidence_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any faces in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        '''
        result = self._values.get("fail_gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any faces in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        '''
        result = self._values.get("fail_gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def focus(self) -> typing.Optional[builtins.str]:
        '''Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus DataAkamaiImagingPolicyImage#focus}
        '''
        result = self._values.get("focus")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def focus_var(self) -> typing.Optional[builtins.str]:
        '''Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus_var DataAkamaiImagingPolicyImage#focus_var}
        '''
        result = self._values.get("focus_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the face(s) plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the face(s) plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualFaceCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualFaceCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualFaceCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c60f1e421347eba0f96db292cbfe47af2396d4312265beb6e5a15cf350a99922)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualFaceCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__935a4ba2bcc7c7ed1b8409a79d92ed5110bf4d506cab3e1f3b5a6720d3d2d14f)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualFaceCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3d21fc1b2e6b690118979a49348b81abf0a92520f0eb24686ab20dafeedaee63)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d4c8866b0c0aa73b2a9f4a3539cbff71c80abc48c753c2cf00586ca3149d83b3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__04f0277eb10f29c44701aeb2f1e4259472c749fb57bf93c588e872eb0e3ff0be)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualFaceCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualFaceCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualFaceCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d93b7f59dc098f14915ec0941483655d87fa979a735ba1695b9513bf558fc6f0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualFaceCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualFaceCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__15cb085d01e7617d60cf4521b9e2d1f47ce46ae088f8398e64bdd79ed8edc663)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAlgorithm")
    def reset_algorithm(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAlgorithm", []))

    @jsii.member(jsii_name="resetAlgorithmVar")
    def reset_algorithm_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAlgorithmVar", []))

    @jsii.member(jsii_name="resetConfidence")
    def reset_confidence(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetConfidence", []))

    @jsii.member(jsii_name="resetConfidenceVar")
    def reset_confidence_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetConfidenceVar", []))

    @jsii.member(jsii_name="resetFailGravity")
    def reset_fail_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravity", []))

    @jsii.member(jsii_name="resetFailGravityVar")
    def reset_fail_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravityVar", []))

    @jsii.member(jsii_name="resetFocus")
    def reset_focus(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFocus", []))

    @jsii.member(jsii_name="resetFocusVar")
    def reset_focus_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFocusVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="algorithmInput")
    def algorithm_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "algorithmInput"))

    @builtins.property
    @jsii.member(jsii_name="algorithmVarInput")
    def algorithm_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "algorithmVarInput"))

    @builtins.property
    @jsii.member(jsii_name="confidenceInput")
    def confidence_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "confidenceInput"))

    @builtins.property
    @jsii.member(jsii_name="confidenceVarInput")
    def confidence_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "confidenceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityInput")
    def fail_gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityVarInput")
    def fail_gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="focusInput")
    def focus_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "focusInput"))

    @builtins.property
    @jsii.member(jsii_name="focusVarInput")
    def focus_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "focusVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="algorithm")
    def algorithm(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "algorithm"))

    @algorithm.setter
    def algorithm(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e9da1a2f056600aa218c4e630fb584d4d83efa2901085721ccafa9553086ca85)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "algorithm", value)

    @builtins.property
    @jsii.member(jsii_name="algorithmVar")
    def algorithm_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "algorithmVar"))

    @algorithm_var.setter
    def algorithm_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a00e30cbac6abcfbabd9a36d3e0149ca6e82294bd32e5ebb2f075ba555ec4982)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "algorithmVar", value)

    @builtins.property
    @jsii.member(jsii_name="confidence")
    def confidence(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "confidence"))

    @confidence.setter
    def confidence(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__809469d3e7f7b29ba224ff2df33dd9f3aebb27ec1dd84e63c59ff0a054611ac2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "confidence", value)

    @builtins.property
    @jsii.member(jsii_name="confidenceVar")
    def confidence_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "confidenceVar"))

    @confidence_var.setter
    def confidence_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ef8168fb6326f92a8cced8f5092886bd1e7bc4404247c4deedab5f22af56caf0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "confidenceVar", value)

    @builtins.property
    @jsii.member(jsii_name="failGravity")
    def fail_gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravity"))

    @fail_gravity.setter
    def fail_gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dd624744fde03c9b45825e872e846157618d92b5384ec5c4efaf3d125e1badb1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravity", value)

    @builtins.property
    @jsii.member(jsii_name="failGravityVar")
    def fail_gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravityVar"))

    @fail_gravity_var.setter
    def fail_gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e71c8e772e0083ea9db27f511b1fd66f871e65e0ad663fd4803d07a86d109582)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="focus")
    def focus(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "focus"))

    @focus.setter
    def focus(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0291fc6fcb93661cdbf9979ce7d5bd7877bddd718358d5cd204eae8054571078)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "focus", value)

    @builtins.property
    @jsii.member(jsii_name="focusVar")
    def focus_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "focusVar"))

    @focus_var.setter
    def focus_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5d3e3e2caf32f4b67d0dc45992ffcfd4fffd574710a64a9e132db8b47881ecf3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "focusVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__329410b5b3f10b9980ace5a598ebfda99fb5a37e1220b2361facab5a5163b04d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e2ca406ea9458dc4c6dd7b3c2ab022126f03a62fdf8b31549c228590cd467097)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b8faf59130200552d5685a779c62289f674d0aca08d5130ffed99c44b2eab238)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7b2da8d59f0a4ee421c614ed3fd18e8c560a900ed6dfa757d94c70822ce8e8af)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac932b38cf160f1be32385269f31e94246d15d3ef1db3a95ee77916e80a5ffb4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__932c2c7fe7fe55c13a1fb23724712f14c442d067a8c2ce1132c902f56554c8a8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__91ead687fb38b0c04d7fa0eb46017483c9d0ba433cd493abb13f28d0798a9c6a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4f6b152c8e80275b395a13dca4b22686980e04aad8d63bce5b17b91c9a044008)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7af9a31de32c0ab9668a8cdfee97544237cb791dbff0dd6460d1a320f27003da)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9018afd478672f83dd71d0ffdf41e4becb261e38e472d96b6ddaf93aca29d846)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualFaceCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualFaceCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualFaceCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5323997ddc6e86155d5bd983a21440f1022ca7329eb09181ca2104a48e3f5816)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualFeatureCrop",
    jsii_struct_bases=[],
    name_mapping={
        "fail_gravity": "failGravity",
        "fail_gravity_var": "failGravityVar",
        "feature_radius": "featureRadius",
        "feature_radius_var": "featureRadiusVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "max_features": "maxFeatures",
        "max_features_var": "maxFeaturesVar",
        "min_feature_quality": "minFeatureQuality",
        "min_feature_quality_var": "minFeatureQualityVar",
        "padding": "padding",
        "padding_var": "paddingVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualFeatureCrop:
    def __init__(
        self,
        *,
        fail_gravity: typing.Optional[builtins.str] = None,
        fail_gravity_var: typing.Optional[builtins.str] = None,
        feature_radius: typing.Optional[builtins.str] = None,
        feature_radius_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        max_features: typing.Optional[builtins.str] = None,
        max_features_var: typing.Optional[builtins.str] = None,
        min_feature_quality: typing.Optional[builtins.str] = None,
        min_feature_quality_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fail_gravity: Controls placement of the crop if Image and Video Manager does not detect any features in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        :param fail_gravity_var: Controls placement of the crop if Image and Video Manager does not detect any features in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        :param feature_radius: The size in pixels of the important features to search for. If identified, two features never appear closer together than this value, ``8.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius DataAkamaiImagingPolicyImage#feature_radius}
        :param feature_radius_var: The size in pixels of the important features to search for. If identified, two features never appear closer together than this value, ``8.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius_var DataAkamaiImagingPolicyImage#feature_radius_var}
        :param gravity: Controls placement of the crop. Directions are relative to the region of interest plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Controls placement of the crop. Directions are relative to the region of interest plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param max_features: The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features DataAkamaiImagingPolicyImage#max_features}
        :param max_features_var: The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features_var DataAkamaiImagingPolicyImage#max_features_var}
        :param min_feature_quality: Determines the minimum quality level of the feature identified. To consider a feature important, the feature needs to surpass this value. Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality DataAkamaiImagingPolicyImage#min_feature_quality}
        :param min_feature_quality_var: Determines the minimum quality level of the feature identified. To consider a feature important, the feature needs to surpass this value. Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality_var DataAkamaiImagingPolicyImage#min_feature_quality_var}
        :param padding: Adds space around the region of interest. The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: Adds space around the region of interest. The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        :param style: Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e7fcf181e36462f1d710838ceb9f52a49d8fcd34061c3362805e0a17ee06eac9)
            check_type(argname="argument fail_gravity", value=fail_gravity, expected_type=type_hints["fail_gravity"])
            check_type(argname="argument fail_gravity_var", value=fail_gravity_var, expected_type=type_hints["fail_gravity_var"])
            check_type(argname="argument feature_radius", value=feature_radius, expected_type=type_hints["feature_radius"])
            check_type(argname="argument feature_radius_var", value=feature_radius_var, expected_type=type_hints["feature_radius_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument max_features", value=max_features, expected_type=type_hints["max_features"])
            check_type(argname="argument max_features_var", value=max_features_var, expected_type=type_hints["max_features_var"])
            check_type(argname="argument min_feature_quality", value=min_feature_quality, expected_type=type_hints["min_feature_quality"])
            check_type(argname="argument min_feature_quality_var", value=min_feature_quality_var, expected_type=type_hints["min_feature_quality_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fail_gravity is not None:
            self._values["fail_gravity"] = fail_gravity
        if fail_gravity_var is not None:
            self._values["fail_gravity_var"] = fail_gravity_var
        if feature_radius is not None:
            self._values["feature_radius"] = feature_radius
        if feature_radius_var is not None:
            self._values["feature_radius_var"] = feature_radius_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if max_features is not None:
            self._values["max_features"] = max_features
        if max_features_var is not None:
            self._values["max_features_var"] = max_features_var
        if min_feature_quality is not None:
            self._values["min_feature_quality"] = min_feature_quality
        if min_feature_quality_var is not None:
            self._values["min_feature_quality_var"] = min_feature_quality_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def fail_gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any features in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        '''
        result = self._values.get("fail_gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any features in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        '''
        result = self._values.get("fail_gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feature_radius(self) -> typing.Optional[builtins.str]:
        '''The size in pixels of the important features to search for.

        If identified, two features never appear closer together than this value, ``8.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius DataAkamaiImagingPolicyImage#feature_radius}
        '''
        result = self._values.get("feature_radius")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feature_radius_var(self) -> typing.Optional[builtins.str]:
        '''The size in pixels of the important features to search for.

        If identified, two features never appear closer together than this value, ``8.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius_var DataAkamaiImagingPolicyImage#feature_radius_var}
        '''
        result = self._values.get("feature_radius_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the region of interest plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the region of interest plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def max_features(self) -> typing.Optional[builtins.str]:
        '''The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features DataAkamaiImagingPolicyImage#max_features}
        '''
        result = self._values.get("max_features")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def max_features_var(self) -> typing.Optional[builtins.str]:
        '''The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features_var DataAkamaiImagingPolicyImage#max_features_var}
        '''
        result = self._values.get("max_features_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def min_feature_quality(self) -> typing.Optional[builtins.str]:
        '''Determines the minimum quality level of the feature identified.

        To consider a feature important, the feature needs to surpass this value.  Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality DataAkamaiImagingPolicyImage#min_feature_quality}
        '''
        result = self._values.get("min_feature_quality")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def min_feature_quality_var(self) -> typing.Optional[builtins.str]:
        '''Determines the minimum quality level of the feature identified.

        To consider a feature important, the feature needs to surpass this value.  Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality_var DataAkamaiImagingPolicyImage#min_feature_quality_var}
        '''
        result = self._values.get("min_feature_quality_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''Adds space around the region of interest.

        The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''Adds space around the region of interest.

        The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualFeatureCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualFeatureCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualFeatureCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__07be05010a5c4f5610a516d99707fb376c5ff281ccd7210d061eb9489673a81d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualFeatureCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1096dee7ae131be79fc9367ec3b442ac12bc2a5e44e5c13cdae88d4826435726)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualFeatureCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__239aa425705e58ea3d8c022f946f78939de44463588717e1c52a64a64cffc7d0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3fbb76d2f3051ce2ec4e666dc913a1c969826b87d976828f7ca31372edf8cd14)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__824b00a69e05808516a9914a0ff4f9723604dd5e3a21292e2ae5a9e28cd23126)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualFeatureCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualFeatureCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualFeatureCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__94023643247bfe74924eeeaffe114834c76e16e4fb1467c9cfd660ffbb7f0d73)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualFeatureCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualFeatureCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d8df67b7f3e852cf52e47351d7e2d00ad3450c8cb782ee031ff0b3e7747ab639)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetFailGravity")
    def reset_fail_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravity", []))

    @jsii.member(jsii_name="resetFailGravityVar")
    def reset_fail_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravityVar", []))

    @jsii.member(jsii_name="resetFeatureRadius")
    def reset_feature_radius(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureRadius", []))

    @jsii.member(jsii_name="resetFeatureRadiusVar")
    def reset_feature_radius_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureRadiusVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetMaxFeatures")
    def reset_max_features(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxFeatures", []))

    @jsii.member(jsii_name="resetMaxFeaturesVar")
    def reset_max_features_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxFeaturesVar", []))

    @jsii.member(jsii_name="resetMinFeatureQuality")
    def reset_min_feature_quality(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMinFeatureQuality", []))

    @jsii.member(jsii_name="resetMinFeatureQualityVar")
    def reset_min_feature_quality_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMinFeatureQualityVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="failGravityInput")
    def fail_gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityVarInput")
    def fail_gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featureRadiusInput")
    def feature_radius_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featureRadiusInput"))

    @builtins.property
    @jsii.member(jsii_name="featureRadiusVarInput")
    def feature_radius_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featureRadiusVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesInput")
    def max_features_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "maxFeaturesInput"))

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesVarInput")
    def max_features_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "maxFeaturesVarInput"))

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityInput")
    def min_feature_quality_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "minFeatureQualityInput"))

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityVarInput")
    def min_feature_quality_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "minFeatureQualityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravity")
    def fail_gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravity"))

    @fail_gravity.setter
    def fail_gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a4b5fa058569bd6a14bbee4483159980e757582b17d5a2f7863b16f930f59437)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravity", value)

    @builtins.property
    @jsii.member(jsii_name="failGravityVar")
    def fail_gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravityVar"))

    @fail_gravity_var.setter
    def fail_gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eff5463dd7c2d1929d2f5de1fe1432511f304bed43dd5f209d4ff7404be91515)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="featureRadius")
    def feature_radius(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featureRadius"))

    @feature_radius.setter
    def feature_radius(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2fbc7bbead0ff801303a601664b5a074c84f37b1e4bac1bdfc1a6c6ca8a26753)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featureRadius", value)

    @builtins.property
    @jsii.member(jsii_name="featureRadiusVar")
    def feature_radius_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featureRadiusVar"))

    @feature_radius_var.setter
    def feature_radius_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__94d37846994c97c14992d8237de743c31e6a379c2d532e730c2f687b4fc6131f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featureRadiusVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f426f9a881b733d3ccbe52ac6d05d31997bddf50bad069a882fe3b0ca6c9ec8e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b127982b8acd163b6b1bbd745ae3f4d18fcb6c655b07941d8ad6b5729b93db8b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6bae3c5c6ed3fad41d6a4dae2c70e3736de85876f964443edc1e534e22f76f99)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__da1ce6f94624a5754bb6ca4b92a5f27ad4620d95d751cbbcca6114720f2c6930)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="maxFeatures")
    def max_features(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "maxFeatures"))

    @max_features.setter
    def max_features(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e1a46b4191500f86c90f6e91146be9b3bc730c487b9cda12ef9d10818923284)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "maxFeatures", value)

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesVar")
    def max_features_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "maxFeaturesVar"))

    @max_features_var.setter
    def max_features_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__807d096abada4e1659563d369cecb695bc55a66823fcffd528438e59c25dbaec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "maxFeaturesVar", value)

    @builtins.property
    @jsii.member(jsii_name="minFeatureQuality")
    def min_feature_quality(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "minFeatureQuality"))

    @min_feature_quality.setter
    def min_feature_quality(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea6b8004b0e3cb83358b1eeb6a20b2eaa34c3ec9e0b44f4e9c88a6dce9ec0db6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "minFeatureQuality", value)

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityVar")
    def min_feature_quality_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "minFeatureQualityVar"))

    @min_feature_quality_var.setter
    def min_feature_quality_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__083fb8062712498dfe1f3334713fd290fef137ac0643ba7602625cec1d5d51a4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "minFeatureQualityVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__04fe4a35f865fdd133970ed7b0bc895bb9ed3b19ec851243b97c89107e586867)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__19796ddded3edd669242be3c903e53510703144890453fb6bfa0fc70df1c40cf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__591fb18c9e617dd8216b20fc75a27f51beff4c7e51a8222abf17222c0a1e38af)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3d14893f1c2ea2cfe83b027ca2f04ba3dd304dfe523864a8e0209bbd0dea4e21)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__18d80f52f9198739ab36a7dc7bb39f896e08c9aa734ba21566c4461387c1b672)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8dec6db1b245f4b17f39a88c4ec2d26a965979c9dca3a7e7eee6ad251320f4d6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualFeatureCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualFeatureCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualFeatureCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__90093821668b6dad47a737ed4e1689ad776618004f328b609e36dfb96e4316ee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualFitAndFill",
    jsii_struct_bases=[],
    name_mapping={
        "fill_transformation": "fillTransformation",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualFitAndFill:
    def __init__(
        self,
        *,
        fill_transformation: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualFitAndFillFillTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fill_transformation: fill_transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_transformation DataAkamaiImagingPolicyImage#fill_transformation}
        :param height: The height value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The width value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(fill_transformation, dict):
            fill_transformation = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualFitAndFillFillTransformation(**fill_transformation)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f9e632c1050c4e6317d6e9789768d3c68f276e70bd2a1a112d02acd6e6b7de1)
            check_type(argname="argument fill_transformation", value=fill_transformation, expected_type=type_hints["fill_transformation"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fill_transformation is not None:
            self._values["fill_transformation"] = fill_transformation
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def fill_transformation(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualFitAndFillFillTransformation"]:
        '''fill_transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_transformation DataAkamaiImagingPolicyImage#fill_transformation}
        '''
        result = self._values.get("fill_transformation")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualFitAndFillFillTransformation"], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualFitAndFill(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualFitAndFillFillTransformation",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualFitAndFillFillTransformation:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualFitAndFillFillTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualFitAndFillFillTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualFitAndFillFillTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__038a7c40f3f4a018fa714ec29a5dbc27a69a2acb37f2368122cb0e569e6e038d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualFitAndFillFillTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualFitAndFillFillTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualFitAndFillFillTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e15f048896d6403c17067bfc7267c58e1efc735a1068a8b35bc3efb312d45b03)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualFitAndFillList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualFitAndFillList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8f005895aa8ba3070bf427a2d3061f74e3196c92bee02e2ca48bd89208134c6e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualFitAndFillOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f730de3f44280e1a8c959946edbcede9a5ad6b1e21858e8dddd054cfbbbd8530)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualFitAndFillOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__caa96f8fc2153290cf6a71e091bb73bc8af03e87cef82c17ae99365d54b1d5ca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c6bd5eb7e89d3eea545b4434615a7ccd30ad9a7293ce662b89bcfcd4ff84e4fc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8d94bf3ab7c594bf6d5b25fb3bbcdfc036051a89eca39812d5db023333ffee60)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualFitAndFill]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualFitAndFill]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualFitAndFill]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__454ed91f6c3f796937ac470a0f4a0f925442d2de6bcd06b5c8f5e0ac068e83fb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualFitAndFillOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualFitAndFillOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c83962c1ec31a15918fa316c33c2c6abfba5367f27472254cc9b3eb3b79b292f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putFillTransformation")
    def put_fill_transformation(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualFitAndFillFillTransformation()

        return typing.cast(None, jsii.invoke(self, "putFillTransformation", [value]))

    @jsii.member(jsii_name="resetFillTransformation")
    def reset_fill_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFillTransformation", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="fillTransformation")
    def fill_transformation(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualFitAndFillFillTransformationOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualFitAndFillFillTransformationOutputReference, jsii.get(self, "fillTransformation"))

    @builtins.property
    @jsii.member(jsii_name="fillTransformationInput")
    def fill_transformation_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualFitAndFillFillTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualFitAndFillFillTransformation], jsii.get(self, "fillTransformationInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e5e102b835b977821eee040cda106803e27b97095bea83d02d8e0d74f252d734)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a656e1ae4a02c2950e9f3e0153ec549a5cf54141c0bb350d9b0aea54ac78dd78)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7f768930ee73d9b1856d973fcd18fc5a75208c097e68992715b4c16ea1c09fd0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f606c51e7cd4cd790c6c23e82f7198d3a565ad204b5ff5094e662d50252d595e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualFitAndFill]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualFitAndFill]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualFitAndFill]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e55e6b3a42127cf277cb4528adcd447858535c1cbc0a6dd2808fa2aed33ce8d0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualGoop",
    jsii_struct_bases=[],
    name_mapping={
        "chaos": "chaos",
        "chaos_var": "chaosVar",
        "density": "density",
        "density_var": "densityVar",
        "power": "power",
        "power_var": "powerVar",
        "seed": "seed",
        "seed_var": "seedVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualGoop:
    def __init__(
        self,
        *,
        chaos: typing.Optional[builtins.str] = None,
        chaos_var: typing.Optional[builtins.str] = None,
        density: typing.Optional[builtins.str] = None,
        density_var: typing.Optional[builtins.str] = None,
        power: typing.Optional[builtins.str] = None,
        power_var: typing.Optional[builtins.str] = None,
        seed: typing.Optional[builtins.str] = None,
        seed_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param chaos: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        :param chaos_var: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        :param density: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        :param density_var: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        :param power: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        :param power_var: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        :param seed: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        :param seed_var: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__639988ea26f5a6319a4a235d190ef9ef823e2d09142f0e956b8fd2f2bb61ad47)
            check_type(argname="argument chaos", value=chaos, expected_type=type_hints["chaos"])
            check_type(argname="argument chaos_var", value=chaos_var, expected_type=type_hints["chaos_var"])
            check_type(argname="argument density", value=density, expected_type=type_hints["density"])
            check_type(argname="argument density_var", value=density_var, expected_type=type_hints["density_var"])
            check_type(argname="argument power", value=power, expected_type=type_hints["power"])
            check_type(argname="argument power_var", value=power_var, expected_type=type_hints["power_var"])
            check_type(argname="argument seed", value=seed, expected_type=type_hints["seed"])
            check_type(argname="argument seed_var", value=seed_var, expected_type=type_hints["seed_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if chaos is not None:
            self._values["chaos"] = chaos
        if chaos_var is not None:
            self._values["chaos_var"] = chaos_var
        if density is not None:
            self._values["density"] = density
        if density_var is not None:
            self._values["density_var"] = density_var
        if power is not None:
            self._values["power"] = power
        if power_var is not None:
            self._values["power_var"] = power_var
        if seed is not None:
            self._values["seed"] = seed
        if seed_var is not None:
            self._values["seed_var"] = seed_var

    @builtins.property
    def chaos(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        '''
        result = self._values.get("chaos")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def chaos_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        '''
        result = self._values.get("chaos_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        '''
        result = self._values.get("density")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density_var(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        '''
        result = self._values.get("density_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        '''
        result = self._values.get("power")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power_var(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        '''
        result = self._values.get("power_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        '''
        result = self._values.get("seed")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed_var(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        result = self._values.get("seed_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualGoop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualGoopList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualGoopList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c9a3fa05e218e72414ba0edcb46ae007481f679f57b95efe7ba212f5614d22af)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualGoopOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eef02abdd6afc1d35a75e0a92c00587fd3e0b497e3ee37ecd163ef27d04f61ab)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualGoopOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bdd05524372982cf85d27f1a94165d086ab13b50b0895bec63d171581de8d8f3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0198962658810b5062f911b3c97869a37bf9c5631256ce4afc44b96c956d0322)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__20a7c7a231050b10253cbd377561f36b7bc1e3cb4d2d1ce8489bc0b324a8d3e9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualGoop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualGoop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aff25cae762a45bfc385618b6e21d66d7726bbfe958c5f13de33920e11b92017)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualGoopOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualGoopOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f6e987658b1bea06c12a4ba17615bf2d6476513768991a3c583c7318b54f6692)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetChaos")
    def reset_chaos(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaos", []))

    @jsii.member(jsii_name="resetChaosVar")
    def reset_chaos_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaosVar", []))

    @jsii.member(jsii_name="resetDensity")
    def reset_density(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensity", []))

    @jsii.member(jsii_name="resetDensityVar")
    def reset_density_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensityVar", []))

    @jsii.member(jsii_name="resetPower")
    def reset_power(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPower", []))

    @jsii.member(jsii_name="resetPowerVar")
    def reset_power_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPowerVar", []))

    @jsii.member(jsii_name="resetSeed")
    def reset_seed(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeed", []))

    @jsii.member(jsii_name="resetSeedVar")
    def reset_seed_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeedVar", []))

    @builtins.property
    @jsii.member(jsii_name="chaosInput")
    def chaos_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosInput"))

    @builtins.property
    @jsii.member(jsii_name="chaosVarInput")
    def chaos_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosVarInput"))

    @builtins.property
    @jsii.member(jsii_name="densityInput")
    def density_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityInput"))

    @builtins.property
    @jsii.member(jsii_name="densityVarInput")
    def density_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="powerInput")
    def power_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerInput"))

    @builtins.property
    @jsii.member(jsii_name="powerVarInput")
    def power_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerVarInput"))

    @builtins.property
    @jsii.member(jsii_name="seedInput")
    def seed_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedInput"))

    @builtins.property
    @jsii.member(jsii_name="seedVarInput")
    def seed_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedVarInput"))

    @builtins.property
    @jsii.member(jsii_name="chaos")
    def chaos(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaos"))

    @chaos.setter
    def chaos(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f2a0a4fe2d1bf3708e4288a530d34eb103a9c9c5ce1a50fcad89c6dcbcd997a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaos", value)

    @builtins.property
    @jsii.member(jsii_name="chaosVar")
    def chaos_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaosVar"))

    @chaos_var.setter
    def chaos_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa4678870e58fc66e9b5a63fabf4cc2e2603fe90988a7637a1ad6773a601da0a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaosVar", value)

    @builtins.property
    @jsii.member(jsii_name="density")
    def density(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "density"))

    @density.setter
    def density(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0211d8ad7cf764a6ce2f586226f0b15817815d142bf198099d1051fd73f49a33)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "density", value)

    @builtins.property
    @jsii.member(jsii_name="densityVar")
    def density_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "densityVar"))

    @density_var.setter
    def density_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e43040e1f6bcdd968aca46a7f570d74c44907810aef584bcefdc4fd96d73c389)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "densityVar", value)

    @builtins.property
    @jsii.member(jsii_name="power")
    def power(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "power"))

    @power.setter
    def power(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0bf2d33587d83bda46eb839acd40526e9ce4feb68646f817d118c476d47608ba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "power", value)

    @builtins.property
    @jsii.member(jsii_name="powerVar")
    def power_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "powerVar"))

    @power_var.setter
    def power_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d3fdbf3fbff1885a8dcbb53bcbc250253b5cd308f347a45362dbeba366716289)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "powerVar", value)

    @builtins.property
    @jsii.member(jsii_name="seed")
    def seed(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seed"))

    @seed.setter
    def seed(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0e0f4492b8430605b02a11c00a85c589d53a1cddfb96f0bed0bccacdadd55a77)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seed", value)

    @builtins.property
    @jsii.member(jsii_name="seedVar")
    def seed_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seedVar"))

    @seed_var.setter
    def seed_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2bf36470130c32803c244bf93d9e484966247ed2a7d8d31000892079bd0f3a63)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seedVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualGoop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualGoop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualGoop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f6382bbeec564562dedb2baa03abf635e551c059fc282e0a9c816840bf5052d8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualGrayscale",
    jsii_struct_bases=[],
    name_mapping={"type": "type", "type_var": "typeVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualGrayscale:
    def __init__(
        self,
        *,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param type: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d466bb4f0b5383e351f81c30afd420a40bbd85a742c781669e6493ec7598bf5)
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualGrayscale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualGrayscaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualGrayscaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__037da08402134660a26a307fd51d10152125f403248ee4777f6ca7e2ca606f5e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualGrayscaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7547f0b8cff0b74334fbaff9a29f92a7b9e6a4f9604c7d5920631b8f4089b184)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualGrayscaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__246f9aea0862e43af31805856ad3711ab0f4c93db8d5ab9042aff2e0974b4fe1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__06acc1c5b35b481decb2ab584e9e3c04990051699109b0581715f7efc0823639)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d809b053b9c25c349ec35eeaeb2395a659ac1954e6c3b3ab291cd863b432a2b7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualGrayscale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualGrayscale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__430966297a64203e2ef432f2c04c0461f774ab5b8b6088291b15afe68f55e795)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualGrayscaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualGrayscaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0592c21adb48dde4fe7d3b154f240a3eaa38669b39bb2fd34259f7389d0a4200)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__40a9eb3c2d9c2377332db00c2c51d363ffb5d773538189c6956700dcc30ab7a4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa8ec540680ea1b0dac38b274c3dd264027993334e4cc477ec54c1332fcf5891)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualGrayscale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualGrayscale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualGrayscale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9876df15eaa99643e14852152330749edfe9eb386f808c7107b3fe8ae47d1d27)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualHsl",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "lightness": "lightness",
        "lightness_var": "lightnessVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualHsl:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness: typing.Optional[builtins.str] = None,
        lightness_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        :param lightness_var: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b78678e34c828734879e2644f53611b67d91d6d123173ae1e6d766c0e1ea9a9d)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness", value=lightness, expected_type=type_hints["lightness"])
            check_type(argname="argument lightness_var", value=lightness_var, expected_type=type_hints["lightness_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness is not None:
            self._values["lightness"] = lightness
        if lightness_var is not None:
            self._values["lightness_var"] = lightness_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        '''
        result = self._values.get("lightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        '''
        result = self._values.get("lightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualHsl(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualHslList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualHslList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__00151cf53a1ea8ab4ad8493a08681142c9f303dd31870523462fc9047c91ed99)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualHslOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e3790ffdc54f50cebf1e71e1075611cdd73c022cb14d5ace650e42c522edce16)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualHslOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2156090989277fb23a8d2480989d59a64ca0c856a8578038b3714b812072042d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f4d09502a6897fd2a8823d3a0c3ec7e4c14ee855b5114d493fc7396502f8cdb2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e54aafafd14348213c322e9fe713c1b8ae5f240d430b3178c133a72035abd31a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualHsl]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualHsl]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fd2a303e04247e7eef9ff391820fafcbce8ff6994ec1e1f130050b8f2af1ae6f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualHslOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualHslOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dd002a0f00f0ed70c18a576e8a77bdc4b9860d434f9f7d2243130e64ac34ba3e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightness")
    def reset_lightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightness", []))

    @jsii.member(jsii_name="resetLightnessVar")
    def reset_lightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessInput")
    def lightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessVarInput")
    def lightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eda1bdf6f99a863ea73a24a02dbf506025234d0e90ba7648a4c928a8f6251471)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__219b0fb96993061107b316b233bfa80c59a7aa886ff60a86ae53a91c3e6b6207)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightness")
    def lightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightness"))

    @lightness.setter
    def lightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b4b76a3830be1c62c4098abb96404a37687a3a90fc6d72196798382cbb70fa73)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightness", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessVar")
    def lightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessVar"))

    @lightness_var.setter
    def lightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a59f840903d58dc8d3f4b075f126bfc6cf9ed5d35bdc055044b429e33a4f91f7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__13e0cb0043a417fe8e45f70529cd718d30c174774620a2be1e25674568abc074)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ecf8eba200361d268b0ee8c0fa4bd698188c77b27667adbceec9e75037b8c098)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualHsl]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualHsl]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualHsl]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7a10a4d82f3cb5098f370745076fc604266eeeea5b2e78c6de758f032e83e1ae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualHsv",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualHsv:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        :param value: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f12ad6f175dc8bee79003e940b85159e801e7ed5e9a9e7124a096bfc7666811)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualHsv(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualHsvList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualHsvList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a289d8135295b4d1187f755434cc940a9fbe99d573451e772a68ceab24cee79)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualHsvOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__44031b17b429c8063930315dc3b1298390e7f3f7c5d1a6dec7edc2bb6dbc6a2c)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualHsvOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7b2c39b049328200756b92e8399df3571080f47d8ac2c629d6451b64e0be49b6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dc870362d0ff713dc22c23211c63fb675edfb1950412e19d4763c1d801ef812c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__70385f11dd7ae092f09dc80032458bdc0fe2b99fbde6dc4d0b02b846531bdc18)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualHsv]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualHsv]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5e4713b2335d57a3685fd6a58cc71ca94ed9e38cf9eef30ac191ffcc1bd430c9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualHsvOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualHsvOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c4e642967dffdc27e47c153ed4e81dcc068a268e1a72e25f402bbda37d149fc0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e03942811bab81243b1b9372d14c700bf529c466fe0eb063d71e8a06c3f27802)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a6924412a88dc37a97b5794f69a63d94d3392fccc60d17cdefd244aba70c3356)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dcb1f37fe99fdcdd06f44f87664a45c24dee6c67df5c23c2b5fe250c14fb7206)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ad37e1aae2e076c9d91dfdce940d1d9af3fdff5e550537736b6b98a927f65d08)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__72cad5e3c7d749a6c34d1cd44129b63b54b127b6d122c911ccdf64d946a2ab90)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__29c74beb66de02ffc65aba2de8e1ecd3dbd108183d8f2b80566cba96099f19f7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualHsv]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualHsv]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualHsv]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__774507f04bb5809e92d256eb5638ce2601abe432e8768fe1ee65899ba450878f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfDimension",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "dimension": "dimension",
        "dimension_var": "dimensionVar",
        "equal": "equal",
        "greater_than": "greaterThan",
        "less_than": "lessThan",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfDimension:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfDimensionDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        dimension: typing.Optional[builtins.str] = None,
        dimension_var: typing.Optional[builtins.str] = None,
        equal: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfDimensionEqual", typing.Dict[builtins.str, typing.Any]]] = None,
        greater_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfDimensionGreaterThan", typing.Dict[builtins.str, typing.Any]]] = None,
        less_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfDimensionLessThan", typing.Dict[builtins.str, typing.Any]]] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param dimension: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        :param dimension_var: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        :param equal: equal block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        :param greater_than: greater_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        :param less_than: less_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        :param value: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfDimensionDefault(**default)
        if isinstance(equal, dict):
            equal = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfDimensionEqual(**equal)
        if isinstance(greater_than, dict):
            greater_than = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfDimensionGreaterThan(**greater_than)
        if isinstance(less_than, dict):
            less_than = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfDimensionLessThan(**less_than)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a81837f0c59ecdefa117631fbd1ffb9916fb8dd14ac895add712bc862a34cc65)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument dimension", value=dimension, expected_type=type_hints["dimension"])
            check_type(argname="argument dimension_var", value=dimension_var, expected_type=type_hints["dimension_var"])
            check_type(argname="argument equal", value=equal, expected_type=type_hints["equal"])
            check_type(argname="argument greater_than", value=greater_than, expected_type=type_hints["greater_than"])
            check_type(argname="argument less_than", value=less_than, expected_type=type_hints["less_than"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if dimension is not None:
            self._values["dimension"] = dimension
        if dimension_var is not None:
            self._values["dimension_var"] = dimension_var
        if equal is not None:
            self._values["equal"] = equal
        if greater_than is not None:
            self._values["greater_than"] = greater_than
        if less_than is not None:
            self._values["less_than"] = less_than
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfDimensionDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfDimensionDefault"], result)

    @builtins.property
    def dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        '''
        result = self._values.get("dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        '''
        result = self._values.get("dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def equal(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfDimensionEqual"]:
        '''equal block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        '''
        result = self._values.get("equal")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfDimensionEqual"], result)

    @builtins.property
    def greater_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfDimensionGreaterThan"]:
        '''greater_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        '''
        result = self._values.get("greater_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfDimensionGreaterThan"], result)

    @builtins.property
    def less_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfDimensionLessThan"]:
        '''less_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        '''
        result = self._values.get("less_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfDimensionLessThan"], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfDimension(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfDimensionDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfDimensionDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfDimensionDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfDimensionDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfDimensionDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__10201d51425d59ace7fd8f97233d22a14f8a01b0a7294047540d2626072519a7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfDimensionDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfDimensionDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__20460ecb98cb20109ae7aa004514c8d2719984e6ec57c0c11c2e05689d9fcb38)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfDimensionEqual",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfDimensionEqual:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfDimensionEqual(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfDimensionEqualOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfDimensionEqualOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3987073b35804dda6e00fd83937cbfbaebf7fb62bf8c56548fd1bbc3a3c37fbd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfDimensionEqual], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfDimensionEqual],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d99e7e9b7affba62ec1a514dccccce8a9129ff18009b07ef06fbe06aa2ceb5fd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfDimensionGreaterThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfDimensionGreaterThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfDimensionGreaterThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfDimensionGreaterThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfDimensionGreaterThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1e4a7e0ecf3c298b5dfd03424aa828cd08533a7e00803c1646f115ee466dad60)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfDimensionGreaterThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfDimensionGreaterThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a2c1bd094ce88592c294d9966335171154618e8f06c690d63884ca37d13efc7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfDimensionLessThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfDimensionLessThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfDimensionLessThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfDimensionLessThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfDimensionLessThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__97d479e3b73e9366b134d9d3394cc030731d5a7482c0036ee12144aa5182b87a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfDimensionLessThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfDimensionLessThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b3e8fdd79c4964899c056d53cdf5edefc06dd6cf0891aa0b4e1448eb7c42bf08)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfDimensionList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfDimensionList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2755397bf6e8ba56170664a74cd117b53f4d5c60d60ca40503ff2727a57df3e3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfDimensionOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7ef9a740dcf3c9d5ff753da100184665d07c39b2229feacb6ec48d05c6e2095f)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfDimensionOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4f51f51ac42a8a27d5eb26e83564658d2d1e1ea99aa7e74c750e5ebf15981891)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f34b9484c1e5e9a494fde48e039b5a26be228cc1c4ad48dab38492b9e851a3d2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9157377de61060d243da28dd52f2d3429dae42f192625bd20534099fa0d5ce28)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfDimension]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfDimension]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f60e8cb45a070c940b4096f95ed2615c75a95919b2b296b75978ec9bee4c7b75)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfDimensionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfDimensionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5c2ff2c0e4b4af9df93cf03a62869dfdde12b6ab0edcae0d4acffb59314523b5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfDimensionDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putEqual")
    def put_equal(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfDimensionEqual()

        return typing.cast(None, jsii.invoke(self, "putEqual", [value]))

    @jsii.member(jsii_name="putGreaterThan")
    def put_greater_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfDimensionGreaterThan()

        return typing.cast(None, jsii.invoke(self, "putGreaterThan", [value]))

    @jsii.member(jsii_name="putLessThan")
    def put_less_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfDimensionLessThan()

        return typing.cast(None, jsii.invoke(self, "putLessThan", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetDimension")
    def reset_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimension", []))

    @jsii.member(jsii_name="resetDimensionVar")
    def reset_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimensionVar", []))

    @jsii.member(jsii_name="resetEqual")
    def reset_equal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEqual", []))

    @jsii.member(jsii_name="resetGreaterThan")
    def reset_greater_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGreaterThan", []))

    @jsii.member(jsii_name="resetLessThan")
    def reset_less_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLessThan", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfDimensionDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfDimensionDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="equal")
    def equal(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfDimensionEqualOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfDimensionEqualOutputReference, jsii.get(self, "equal"))

    @builtins.property
    @jsii.member(jsii_name="greaterThan")
    def greater_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfDimensionGreaterThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfDimensionGreaterThanOutputReference, jsii.get(self, "greaterThan"))

    @builtins.property
    @jsii.member(jsii_name="lessThan")
    def less_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfDimensionLessThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfDimensionLessThanOutputReference, jsii.get(self, "lessThan"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfDimensionDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionInput")
    def dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionVarInput")
    def dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="equalInput")
    def equal_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfDimensionEqual], jsii.get(self, "equalInput"))

    @builtins.property
    @jsii.member(jsii_name="greaterThanInput")
    def greater_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfDimensionGreaterThan], jsii.get(self, "greaterThanInput"))

    @builtins.property
    @jsii.member(jsii_name="lessThanInput")
    def less_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfDimensionLessThan], jsii.get(self, "lessThanInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="dimension")
    def dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimension"))

    @dimension.setter
    def dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0fe1089038e6341e25996e621e9d3e836ce56521c18f412ace5b21049c3fa89e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimension", value)

    @builtins.property
    @jsii.member(jsii_name="dimensionVar")
    def dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimensionVar"))

    @dimension_var.setter
    def dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1133f8b6b7b556d0833f03afb55fd66b02d22826d2d103eeb136bd4350674395)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__16798c661cae4aa4d5b17cfab34469b1ca7e74fa84160689d9bcb2887b4803cc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__55d9defc946896af2a5fc5fa99b439d1f2b6a32f68859500fe466f7ca45bdc7f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfDimension]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfDimension]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfDimension]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8514d3eea818bb8e88b686f45611d40de3eb7d6d3f7b1b99dd44615d530d8b6c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfOrientation",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "landscape": "landscape",
        "portrait": "portrait",
        "square": "square",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfOrientation:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfOrientationDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        landscape: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfOrientationLandscape", typing.Dict[builtins.str, typing.Any]]] = None,
        portrait: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfOrientationPortrait", typing.Dict[builtins.str, typing.Any]]] = None,
        square: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfOrientationSquare", typing.Dict[builtins.str, typing.Any]]] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param landscape: landscape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        :param portrait: portrait block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        :param square: square block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfOrientationDefault(**default)
        if isinstance(landscape, dict):
            landscape = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfOrientationLandscape(**landscape)
        if isinstance(portrait, dict):
            portrait = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfOrientationPortrait(**portrait)
        if isinstance(square, dict):
            square = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfOrientationSquare(**square)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e9d89deb5b69a94fc265363ef121a5105fe47831c2e66628691e9d93c53b28cb)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument landscape", value=landscape, expected_type=type_hints["landscape"])
            check_type(argname="argument portrait", value=portrait, expected_type=type_hints["portrait"])
            check_type(argname="argument square", value=square, expected_type=type_hints["square"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if landscape is not None:
            self._values["landscape"] = landscape
        if portrait is not None:
            self._values["portrait"] = portrait
        if square is not None:
            self._values["square"] = square

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfOrientationDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfOrientationDefault"], result)

    @builtins.property
    def landscape(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfOrientationLandscape"]:
        '''landscape block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        '''
        result = self._values.get("landscape")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfOrientationLandscape"], result)

    @builtins.property
    def portrait(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfOrientationPortrait"]:
        '''portrait block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        '''
        result = self._values.get("portrait")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfOrientationPortrait"], result)

    @builtins.property
    def square(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfOrientationSquare"]:
        '''square block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        result = self._values.get("square")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfOrientationSquare"], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfOrientation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfOrientationDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfOrientationDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfOrientationDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfOrientationDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfOrientationDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__25ee959be12ec3374f6f7bffc658ef09aa5924d5f47b765dbbd4906dd2361e10)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfOrientationDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfOrientationDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aac499c0527c7977cbd455429e17e6dbdf23ed0432f8c06837e848eebc4332f7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfOrientationLandscape",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfOrientationLandscape:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfOrientationLandscape(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfOrientationLandscapeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfOrientationLandscapeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7e35b25435f2a4cf0919c3c294677e8f3f04dbe76482de0987667cf795dbaf19)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfOrientationLandscape], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfOrientationLandscape],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d275aedcea1a94673fe8d487a23ab8b8b82e845a24b54a51a198e0e0aaa06138)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfOrientationList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfOrientationList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__25ea98780b56d4cc79cfdcc48df30aa197d31ade7b545758d4470e226a8598e8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfOrientationOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c28457e9c1aba25e928c084ea4e3591ea384ae5e56bc039ce9b62fe8241a6d22)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfOrientationOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c5288d85784166a4c81f208c0e9fda0383fa7cd4138a52b4b23233e5a585699b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__db33dab77392866e602ad80fd6ae15232736b8d0782b1d5875307f43c8207db4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cf05196ccef25c3315a2fda36ac5b3859d9d4fbe9c2e860b7398696cb5896ab2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfOrientation]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfOrientation]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9eac5aa964389a4a109f5e8650244b68fc9394cf10e6afa7f0e84d2faaef2199)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfOrientationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfOrientationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__baaa4fc1d69a76187852f8689626433c544d26261c736234bd48179435aba659)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfOrientationDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putLandscape")
    def put_landscape(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfOrientationLandscape()

        return typing.cast(None, jsii.invoke(self, "putLandscape", [value]))

    @jsii.member(jsii_name="putPortrait")
    def put_portrait(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfOrientationPortrait()

        return typing.cast(None, jsii.invoke(self, "putPortrait", [value]))

    @jsii.member(jsii_name="putSquare")
    def put_square(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfOrientationSquare()

        return typing.cast(None, jsii.invoke(self, "putSquare", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetLandscape")
    def reset_landscape(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLandscape", []))

    @jsii.member(jsii_name="resetPortrait")
    def reset_portrait(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPortrait", []))

    @jsii.member(jsii_name="resetSquare")
    def reset_square(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSquare", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfOrientationDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfOrientationDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="landscape")
    def landscape(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfOrientationLandscapeOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfOrientationLandscapeOutputReference, jsii.get(self, "landscape"))

    @builtins.property
    @jsii.member(jsii_name="portrait")
    def portrait(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfOrientationPortraitOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfOrientationPortraitOutputReference", jsii.get(self, "portrait"))

    @builtins.property
    @jsii.member(jsii_name="square")
    def square(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfOrientationSquareOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfOrientationSquareOutputReference", jsii.get(self, "square"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfOrientationDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="landscapeInput")
    def landscape_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfOrientationLandscape], jsii.get(self, "landscapeInput"))

    @builtins.property
    @jsii.member(jsii_name="portraitInput")
    def portrait_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfOrientationPortrait"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfOrientationPortrait"], jsii.get(self, "portraitInput"))

    @builtins.property
    @jsii.member(jsii_name="squareInput")
    def square_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfOrientationSquare"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfOrientationSquare"], jsii.get(self, "squareInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfOrientation]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfOrientation]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfOrientation]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__38d032d208fb156276d9cd4d72a45419b721c26aed3e9a7d3b5372d9c71c1b5a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfOrientationPortrait",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfOrientationPortrait:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfOrientationPortrait(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfOrientationPortraitOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfOrientationPortraitOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5691310e3ab7b3fd262aad285262658d3e8cedb297c61df18734a295cf47b284)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfOrientationPortrait]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfOrientationPortrait], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfOrientationPortrait],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__34d3219e4b1654f203e4feaa278822a569c0d630482805eedd58a49e1514a1ba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfOrientationSquare",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfOrientationSquare:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfOrientationSquare(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfOrientationSquareOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfOrientationSquareOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__278935e53c47cf283ece629cdeee1dff0babcbc317d0d2278a3d8bc81a370a19)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfOrientationSquare]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfOrientationSquare], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfOrientationSquare],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c800b1a88b084f0be5e0ca7fa091c7c95392a84042147dcc56e7ba7615512169)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualImQuery",
    jsii_struct_bases=[],
    name_mapping={
        "allowed_transformations": "allowedTransformations",
        "query_var": "queryVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualImQuery:
    def __init__(
        self,
        *,
        allowed_transformations: typing.Sequence[builtins.str],
        query_var: builtins.str,
    ) -> None:
        '''
        :param allowed_transformations: Specifies the transformations that can be applied using the query string parameter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allowed_transformations DataAkamaiImagingPolicyImage#allowed_transformations}
        :param query_var: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#query_var DataAkamaiImagingPolicyImage#query_var}.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a92e52e86c3737bc814d65712c11f27bb00c52b2d9d8ae33b3d3aacea948330)
            check_type(argname="argument allowed_transformations", value=allowed_transformations, expected_type=type_hints["allowed_transformations"])
            check_type(argname="argument query_var", value=query_var, expected_type=type_hints["query_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "allowed_transformations": allowed_transformations,
            "query_var": query_var,
        }

    @builtins.property
    def allowed_transformations(self) -> typing.List[builtins.str]:
        '''Specifies the transformations that can be applied using the query string parameter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allowed_transformations DataAkamaiImagingPolicyImage#allowed_transformations}
        '''
        result = self._values.get("allowed_transformations")
        assert result is not None, "Required property 'allowed_transformations' is missing"
        return typing.cast(typing.List[builtins.str], result)

    @builtins.property
    def query_var(self) -> builtins.str:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#query_var DataAkamaiImagingPolicyImage#query_var}.'''
        result = self._values.get("query_var")
        assert result is not None, "Required property 'query_var' is missing"
        return typing.cast(builtins.str, result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualImQuery(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualImQueryList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualImQueryList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c5eebb8d5cd7baa508a08ff0ee8bd4fed3ff53a1bb8043b8a8cfb9dfa32f2e2f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualImQueryOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__384042ef7fa652818407612dbf803251c3c1e788d489bb206df72d2085cb3531)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualImQueryOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__701eb35d27f5dea2b283b9eecc0a457e310f7c787b7fbd2d572d0c8d091784ee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__448afd56e87a6954dcc35f266768d4d1a7f7dd92d5159e74b99f63a4fa2a0728)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7485d950543356b33998b82eacd1f88b3d97cb2688e186371db5e23e2a44fc63)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualImQuery]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualImQuery]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualImQuery]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f399a2ca5809ec05f6862957138fcb6a3926cf6c461b00aa78957b23774b0bb1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualImQueryOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualImQueryOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6d10ac8b0a61189540f6eaf5c9a7a6c16e8c24b32560126a85a9397d3190d915)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @builtins.property
    @jsii.member(jsii_name="allowedTransformationsInput")
    def allowed_transformations_input(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "allowedTransformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="queryVarInput")
    def query_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "queryVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowedTransformations")
    def allowed_transformations(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "allowedTransformations"))

    @allowed_transformations.setter
    def allowed_transformations(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ecfce2c3f704494b0bdc4daa9e727501955c2598c67d287b6de123a5dd71347f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowedTransformations", value)

    @builtins.property
    @jsii.member(jsii_name="queryVar")
    def query_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "queryVar"))

    @query_var.setter
    def query_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b5d20aad221c615c7d960a8f7acb902c012c32c18d8150c1771b7a7162bba653)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "queryVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualImQuery]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualImQuery]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualImQuery]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__035cae23e7e9771003929414434cccd24d2ec2319f98252c0ad8b40dcd0240c9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualMaxColors",
    jsii_struct_bases=[],
    name_mapping={"colors": "colors", "colors_var": "colorsVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualMaxColors:
    def __init__(
        self,
        *,
        colors: typing.Optional[builtins.str] = None,
        colors_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param colors: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        :param colors_var: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac1b8ed54a8f001bb3962bf78ce4eed844a6edc06a94ccd5b00f158082ce919e)
            check_type(argname="argument colors", value=colors, expected_type=type_hints["colors"])
            check_type(argname="argument colors_var", value=colors_var, expected_type=type_hints["colors_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if colors is not None:
            self._values["colors"] = colors
        if colors_var is not None:
            self._values["colors_var"] = colors_var

    @builtins.property
    def colors(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        '''
        result = self._values.get("colors")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def colors_var(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        result = self._values.get("colors_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualMaxColors(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualMaxColorsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualMaxColorsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__541569d9e1ae4acfcf001b6288789d65bcfa34459417fe963c28bf6d9c8a160f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualMaxColorsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c47964692294e02bcb8e07b447acd548437b48f90e57ec05984d8b74b0417828)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualMaxColorsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b0b87b7df90854a883026798a5281350828d86905edd8fd75ec0e7360a24e03c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6aa7702ab6649c11f0b18b5d6dda6424a8801986e0e452f3f8694e8b0329521d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__edaab3dad441fae0b34ca5f9b6f4f8b03f1fa135bdc58ab07d47e04748d13a8b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualMaxColors]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualMaxColors]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d78d087ce9f6bc32f7c347669a2867150a7e3dd18f894a900c3da44c2bd117d8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualMaxColorsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualMaxColorsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eec0bb4c67665397950f5dbed6431b18cdfbb955b51c44c328447ae0c69954e4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColors")
    def reset_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColors", []))

    @jsii.member(jsii_name="resetColorsVar")
    def reset_colors_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorsVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorsInput")
    def colors_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsInput"))

    @builtins.property
    @jsii.member(jsii_name="colorsVarInput")
    def colors_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsVarInput"))

    @builtins.property
    @jsii.member(jsii_name="colors")
    def colors(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colors"))

    @colors.setter
    def colors(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__41d45b75037e5f05ddaaeb8c5f8cfb6177e34668bd53a6232cdbb6527cdc0aa1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colors", value)

    @builtins.property
    @jsii.member(jsii_name="colorsVar")
    def colors_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorsVar"))

    @colors_var.setter
    def colors_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4b408ef622a23cb4ced17963ec06c84c3688aff0d921742b114d144cce235594)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorsVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualMaxColors]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualMaxColors]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualMaxColors]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0b0226229e193d507c52c2a81ff9387f4f9816f6baefb57306420b24ba5e6987)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualMirror",
    jsii_struct_bases=[],
    name_mapping={
        "horizontal": "horizontal",
        "horizontal_var": "horizontalVar",
        "vertical": "vertical",
        "vertical_var": "verticalVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualMirror:
    def __init__(
        self,
        *,
        horizontal: typing.Optional[builtins.str] = None,
        horizontal_var: typing.Optional[builtins.str] = None,
        vertical: typing.Optional[builtins.str] = None,
        vertical_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param horizontal: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        :param horizontal_var: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        :param vertical: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        :param vertical_var: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aa1556baa15363eb20876e9cc0fb336819154d69317a1fa4c5f3d03762503ca1)
            check_type(argname="argument horizontal", value=horizontal, expected_type=type_hints["horizontal"])
            check_type(argname="argument horizontal_var", value=horizontal_var, expected_type=type_hints["horizontal_var"])
            check_type(argname="argument vertical", value=vertical, expected_type=type_hints["vertical"])
            check_type(argname="argument vertical_var", value=vertical_var, expected_type=type_hints["vertical_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if horizontal is not None:
            self._values["horizontal"] = horizontal
        if horizontal_var is not None:
            self._values["horizontal_var"] = horizontal_var
        if vertical is not None:
            self._values["vertical"] = vertical
        if vertical_var is not None:
            self._values["vertical_var"] = vertical_var

    @builtins.property
    def horizontal(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        '''
        result = self._values.get("horizontal")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def horizontal_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        '''
        result = self._values.get("horizontal_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        '''
        result = self._values.get("vertical")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        result = self._values.get("vertical_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualMirror(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualMirrorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualMirrorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__51d450daa4467b0ebe597e95fedbda5e5020ddc99c0f84c8dfe22a513b100311)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualMirrorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7e0c8c5f74433631cf6a071ebbd371df3748635ccd57e3e783edb590ff5ac590)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualMirrorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa11baa1ba615db03f1d846a95fb13b6bb9d241ca97e9c561e7d41216c969f84)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ce1deb2f7f5a9e78fb4feaeacd1edcebc4cb18050e8ea5ef467d8992205e57c2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b5c66f2d203b269650d49444138c8373611a739726bc8067908cb04322f2e80a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualMirror]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualMirror]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7ac5f9a9f31399dd37f199fd7ed051e79cb9dfe5a3ee16aeaa0f5c7476f71369)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualMirrorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualMirrorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d1a369f99cbe1e56f501e1d1161aeb9e42b9195f4c9048bbdeb9b27d81ddd53e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHorizontal")
    def reset_horizontal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontal", []))

    @jsii.member(jsii_name="resetHorizontalVar")
    def reset_horizontal_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontalVar", []))

    @jsii.member(jsii_name="resetVertical")
    def reset_vertical(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVertical", []))

    @jsii.member(jsii_name="resetVerticalVar")
    def reset_vertical_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVerticalVar", []))

    @builtins.property
    @jsii.member(jsii_name="horizontalInput")
    def horizontal_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontalVarInput")
    def horizontal_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalInput")
    def vertical_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalVarInput")
    def vertical_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontal")
    def horizontal(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontal"))

    @horizontal.setter
    def horizontal(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7c1f47d7026659b6184d08f1aa42399d670572a81d99dc72b34b078f1a435b81)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontal", value)

    @builtins.property
    @jsii.member(jsii_name="horizontalVar")
    def horizontal_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontalVar"))

    @horizontal_var.setter
    def horizontal_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__20e768b15b69f7cb7f766557b8b2f181a4fa4faee3738b5412530a2e0a6930be)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontalVar", value)

    @builtins.property
    @jsii.member(jsii_name="vertical")
    def vertical(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "vertical"))

    @vertical.setter
    def vertical(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__64205384a678e5c228a877b72620abf92e1d218c5aead9fb9a21ae2d9cc0c1b1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "vertical", value)

    @builtins.property
    @jsii.member(jsii_name="verticalVar")
    def vertical_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "verticalVar"))

    @vertical_var.setter
    def vertical_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f8bacf0616a13f3e65f476a5668cdb69abc24136ea5bccb6c9db1973e03e6a9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "verticalVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualMirror]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualMirror]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualMirror]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c6f8eaea620318d6503a1806ea266bfc033fb7f0931fc9a75c801d9ea02fe23c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualMonoHue",
    jsii_struct_bases=[],
    name_mapping={"hue": "hue", "hue_var": "hueVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualMonoHue:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b1f9a569d1fba17c62e2f25db762017c6feb2fefff18b554961c2758627da8fd)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualMonoHue(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualMonoHueList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualMonoHueList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__04510583cb6df9332fa2ec84d47123aaf1e1e45d56579445955bb3f82c588712)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualMonoHueOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8ce62cc5cdbce9499e5cb0b150e4c05e121933b808bfaad2db25349db08b4780)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualMonoHueOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__58e7ad647015fc9200f79088fb0a74f6a26e77d393b71fa9d5f63118ddccab1b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0d8836c3f8be9e59e943d0ce4fa4b833a4c9085437f2e4115b5ce0d79fb08079)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6817974540df036895477ca068b4480f3bd61c7c6d8cf3ceea2300c4c70d6bdc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualMonoHue]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualMonoHue]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f3f637d9ff0ca2ff2b6d7836df157310e43f81390bf8e1f863445508c99685d2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualMonoHueOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualMonoHueOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__659ca0a1065bcb4486d65c537ea794aee9d07f240efe7728bdb45e10ee5394dd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9dd13cda480375690ce1b1073bb880c509bb51e98c5a999e9e8bcb4cf6bb0c37)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b170e2f5ce9253b0d61f7c4d4ea5ecc8a9bd666983654c818a97bb29caff2739)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualMonoHue]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualMonoHue]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualMonoHue]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a86c4271f8921d873d7d17d424512189a87a5d75b0eef3fba18e55b99195aa0c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualOpacity",
    jsii_struct_bases=[],
    name_mapping={"opacity": "opacity", "opacity_var": "opacityVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualOpacity:
    def __init__(
        self,
        *,
        opacity: typing.Optional[builtins.str] = None,
        opacity_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param opacity: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param opacity_var: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fbd4f532d36ff439fd0a365b22b47785e95c226f91d8c9463229fa14a700b04b)
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument opacity_var", value=opacity_var, expected_type=type_hints["opacity_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if opacity is not None:
            self._values["opacity"] = opacity
        if opacity_var is not None:
            self._values["opacity_var"] = opacity_var

    @builtins.property
    def opacity(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def opacity_var(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        result = self._values.get("opacity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualOpacity(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualOpacityList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualOpacityList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__01ee738b8d4d9fc23937a7cec3f5ac6ddaf6ba5add2d484037ca578f08e11e57)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualOpacityOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f8016b1bbbd43179910d0ed5e166a79725562c39193959a33fbff5ece70030f5)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualOpacityOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f6cfcbcd8cbefb3c5c5631802ed0045521ef902a8742d1d1c9be49776fff52b2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e510006af18164fcf4651f81f0f05ebc9bad5a772297f52f223d2087ee0e0b44)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cedb4999ea8e3775f7afdfc0a1bf1f2be279bf75844fcdf10ff11fb64304f554)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualOpacity]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualOpacity]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b458db824c85bc21ff9ceebb272669b4238507e5ec8201ba02f2b6ce10c68dde)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualOpacityOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualOpacityOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6868c94c681ac8b61ea3167b214455bae8cc6be7685070a29624f34bb8d7e22b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetOpacityVar")
    def reset_opacity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacityVar", []))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityVarInput")
    def opacity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacity"))

    @opacity.setter
    def opacity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9b4d28a9af3b111c57bb71bda8c1274fb5254d0ace693eb93c70577b8b2c90c8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacity", value)

    @builtins.property
    @jsii.member(jsii_name="opacityVar")
    def opacity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacityVar"))

    @opacity_var.setter
    def opacity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5209f562e5dce6a9310e1a42f382b05ae745daa4cae0d55a60ce5284f629a258)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacityVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualOpacity]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualOpacity]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualOpacity]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0212ff232619d826aafdbb0d5d37cf6c7aa9d37fbd047df31f5a347be1dcf207)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2561cf8dac2ffae50a78e4fb34f6c6b4b2c69ad6e03af5163c26d94ab0c0e95b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putAppend")
    def put_append(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualAppend, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aa8a11027b715648f2bc9f3f2bab0557643befaed85b6ab75a668e8942845543)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putAppend", [value]))

    @jsii.member(jsii_name="putAspectCrop")
    def put_aspect_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualAspectCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__57f34d1c2fb26853600df91dc1827be57c0658974ea293b6998d16f1481c7cf2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putAspectCrop", [value]))

    @jsii.member(jsii_name="putBackgroundColor")
    def put_background_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__461e550a4898e0733863ab2f7bae2216ef768f4fc6ef2724885d247f83c9b3f5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBackgroundColor", [value]))

    @jsii.member(jsii_name="putBlur")
    def put_blur(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualBlur, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__33ff8bd4e90a51fb4297e5842e5db69806fff0de1163c1601afc85ac9f7c79fd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBlur", [value]))

    @jsii.member(jsii_name="putChromaKey")
    def put_chroma_key(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualChromaKey, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3d00d7cb68bedd1356513a89e180de2473ec3f3100ad9e1f9349c70efb4cb544)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putChromaKey", [value]))

    @jsii.member(jsii_name="putComposite")
    def put_composite(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualComposite, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__74803d5f469e1ef2136adb26f44c14b220a4d102b7c79237c020758ff4c9a9da)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putComposite", [value]))

    @jsii.member(jsii_name="putCompound")
    def put_compound(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualCompound, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d52306391b2623f197e5e9f7d565b2378175e5f587cc301f766583743c44ff3d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCompound", [value]))

    @jsii.member(jsii_name="putContrast")
    def put_contrast(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualContrast, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a7c84a15d648037356676f243c5e5061134ee115b946ee434b73ff5e9cb8f254)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putContrast", [value]))

    @jsii.member(jsii_name="putCrop")
    def put_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e1505c74372da4d25571940c59f8de2f8a2a9bf03c97755e0395e6aa8fab682e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCrop", [value]))

    @jsii.member(jsii_name="putFaceCrop")
    def put_face_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualFaceCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0c1764d0d066b6e9567d72f7d3642998cf89836a5e1dcc4a63a71cae1cbd7f9b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFaceCrop", [value]))

    @jsii.member(jsii_name="putFeatureCrop")
    def put_feature_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualFeatureCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab96a236e183818dafacb3e3798bb90cf3f36b1f6348422064a4d479a426f513)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFeatureCrop", [value]))

    @jsii.member(jsii_name="putFitAndFill")
    def put_fit_and_fill(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualFitAndFill, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa10232e751f0e279505055850074d5fa8dc10924f82a13bb92dc134c28ce1e1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFitAndFill", [value]))

    @jsii.member(jsii_name="putGoop")
    def put_goop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualGoop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__87c219a4a8396c365b92685e5abe8d2c274b5c44f4a3e1ba5f5b22fc2354abab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGoop", [value]))

    @jsii.member(jsii_name="putGrayscale")
    def put_grayscale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualGrayscale, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a95644ab577f49b5608274581d6b208a07e6e65648ed55f42342d425c16b772)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGrayscale", [value]))

    @jsii.member(jsii_name="putHsl")
    def put_hsl(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualHsl, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__969ce2e29ffdc6563f05e2f9e6a2b63d00c1098ed285a7b0eec26d4f2ba069a2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsl", [value]))

    @jsii.member(jsii_name="putHsv")
    def put_hsv(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualHsv, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5583144e90c0e02ce7132cb014852d98ecfef6945b7d7b49979051cdd276d081)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsv", [value]))

    @jsii.member(jsii_name="putIfDimension")
    def put_if_dimension(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfDimension, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a228c270b473088b77cdfd55597ba4d84b9c2077bf04c78e0e0ebfd3029f2b9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfDimension", [value]))

    @jsii.member(jsii_name="putIfOrientation")
    def put_if_orientation(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e617bc5b8d7e7f3b563971fd7f654263d0fb97f0d7e3c0c6c93ab7a1e54f4597)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfOrientation", [value]))

    @jsii.member(jsii_name="putImQuery")
    def put_im_query(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualImQuery, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b1d6f6d4c0cb70af0b3784fc41c1881d48e6adf755d7f0cc7f2707747ebf9abd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putImQuery", [value]))

    @jsii.member(jsii_name="putMaxColors")
    def put_max_colors(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualMaxColors, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__08b78ae9810af3c6735c1434901a25cc5134b9230f50a0290dc9ee494a967a3e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMaxColors", [value]))

    @jsii.member(jsii_name="putMirror")
    def put_mirror(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualMirror, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__96ff9d1368707f0ebbd3c808ad48821978002d45239efbb4b9e5cb34ec450c3d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMirror", [value]))

    @jsii.member(jsii_name="putMonoHue")
    def put_mono_hue(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualMonoHue, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__30174be602786ccf62091f1118af45b0f5ec7f45a3e11018394f44d12ae951d5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMonoHue", [value]))

    @jsii.member(jsii_name="putOpacity")
    def put_opacity(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualOpacity, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ca233aa391a03e05b984fefac7f93e9266d522ab7368d3d3d8f3bb2df57bdc0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putOpacity", [value]))

    @jsii.member(jsii_name="putRegionOfInterestCrop")
    def put_region_of_interest_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualRegionOfInterestCrop", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dbe75686ac5b1aeec993022ada4add46ec7d1fe23a7634d44c37950bbb838bcf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRegionOfInterestCrop", [value]))

    @jsii.member(jsii_name="putRelativeCrop")
    def put_relative_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualRelativeCrop", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2192167bb3e6609f047ccbbd593f2b94e02df7aa4bfb6a6a0f2e1c9e61456785)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRelativeCrop", [value]))

    @jsii.member(jsii_name="putRemoveColor")
    def put_remove_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualRemoveColor", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c7f1bcf7796fffe8633a1c8b9737e78f5f512de4cd7b5ea9ed861fee568c5195)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRemoveColor", [value]))

    @jsii.member(jsii_name="putResize")
    def put_resize(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualResize", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fc085c3289525da032ad0d143c7bd54020bd05a013daea86fbbb88000bf88357)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putResize", [value]))

    @jsii.member(jsii_name="putRotate")
    def put_rotate(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualRotate", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7e65e6942e0ae2d07830dd9fcb0ec0e32b09f23a487169cbc6f1e435e2ed8f91)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRotate", [value]))

    @jsii.member(jsii_name="putScale")
    def put_scale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualScale", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2fb2e509a8f59708974ab95f9b5af8cdc724f5a0c404a3ad23aa3478f48768a6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putScale", [value]))

    @jsii.member(jsii_name="putShear")
    def put_shear(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualShear", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__291b8ee308e7af06ea751708ff97b1adfa44bc7f54e0fa5f3865c3cd0d641b4e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putShear", [value]))

    @jsii.member(jsii_name="putTrim")
    def put_trim(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualTrim", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4c31b3877fa5314247cadbf90c3b1989868b740ff2be61b446d9cb6cb47ac4c3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTrim", [value]))

    @jsii.member(jsii_name="putUnsharpMask")
    def put_unsharp_mask(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualUnsharpMask", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__032387fb3fbe097767e1db1ab160e2d3139db7ea2382004a404054b0a9cfded1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putUnsharpMask", [value]))

    @jsii.member(jsii_name="resetAppend")
    def reset_append(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAppend", []))

    @jsii.member(jsii_name="resetAspectCrop")
    def reset_aspect_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspectCrop", []))

    @jsii.member(jsii_name="resetBackgroundColor")
    def reset_background_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBackgroundColor", []))

    @jsii.member(jsii_name="resetBlur")
    def reset_blur(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBlur", []))

    @jsii.member(jsii_name="resetChromaKey")
    def reset_chroma_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChromaKey", []))

    @jsii.member(jsii_name="resetComposite")
    def reset_composite(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetComposite", []))

    @jsii.member(jsii_name="resetCompound")
    def reset_compound(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCompound", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetCrop")
    def reset_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCrop", []))

    @jsii.member(jsii_name="resetFaceCrop")
    def reset_face_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFaceCrop", []))

    @jsii.member(jsii_name="resetFeatureCrop")
    def reset_feature_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureCrop", []))

    @jsii.member(jsii_name="resetFitAndFill")
    def reset_fit_and_fill(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFitAndFill", []))

    @jsii.member(jsii_name="resetGoop")
    def reset_goop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGoop", []))

    @jsii.member(jsii_name="resetGrayscale")
    def reset_grayscale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGrayscale", []))

    @jsii.member(jsii_name="resetHsl")
    def reset_hsl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsl", []))

    @jsii.member(jsii_name="resetHsv")
    def reset_hsv(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsv", []))

    @jsii.member(jsii_name="resetIfDimension")
    def reset_if_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfDimension", []))

    @jsii.member(jsii_name="resetIfOrientation")
    def reset_if_orientation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfOrientation", []))

    @jsii.member(jsii_name="resetImQuery")
    def reset_im_query(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetImQuery", []))

    @jsii.member(jsii_name="resetMaxColors")
    def reset_max_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxColors", []))

    @jsii.member(jsii_name="resetMirror")
    def reset_mirror(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMirror", []))

    @jsii.member(jsii_name="resetMonoHue")
    def reset_mono_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonoHue", []))

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetRegionOfInterestCrop")
    def reset_region_of_interest_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRegionOfInterestCrop", []))

    @jsii.member(jsii_name="resetRelativeCrop")
    def reset_relative_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRelativeCrop", []))

    @jsii.member(jsii_name="resetRemoveColor")
    def reset_remove_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRemoveColor", []))

    @jsii.member(jsii_name="resetResize")
    def reset_resize(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetResize", []))

    @jsii.member(jsii_name="resetRotate")
    def reset_rotate(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRotate", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetShear")
    def reset_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetShear", []))

    @jsii.member(jsii_name="resetTrim")
    def reset_trim(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTrim", []))

    @jsii.member(jsii_name="resetUnsharpMask")
    def reset_unsharp_mask(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUnsharpMask", []))

    @builtins.property
    @jsii.member(jsii_name="append")
    def append(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualAppendList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualAppendList, jsii.get(self, "append"))

    @builtins.property
    @jsii.member(jsii_name="aspectCrop")
    def aspect_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualAspectCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualAspectCropList, jsii.get(self, "aspectCrop"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColor")
    def background_color(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualBackgroundColorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualBackgroundColorList, jsii.get(self, "backgroundColor"))

    @builtins.property
    @jsii.member(jsii_name="blur")
    def blur(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualBlurList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualBlurList, jsii.get(self, "blur"))

    @builtins.property
    @jsii.member(jsii_name="chromaKey")
    def chroma_key(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualChromaKeyList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualChromaKeyList, jsii.get(self, "chromaKey"))

    @builtins.property
    @jsii.member(jsii_name="composite")
    def composite(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualCompositeList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualCompositeList, jsii.get(self, "composite"))

    @builtins.property
    @jsii.member(jsii_name="compound")
    def compound(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualCompoundList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualCompoundList, jsii.get(self, "compound"))

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualContrastList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualContrastList, jsii.get(self, "contrast"))

    @builtins.property
    @jsii.member(jsii_name="crop")
    def crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualCropList, jsii.get(self, "crop"))

    @builtins.property
    @jsii.member(jsii_name="faceCrop")
    def face_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualFaceCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualFaceCropList, jsii.get(self, "faceCrop"))

    @builtins.property
    @jsii.member(jsii_name="featureCrop")
    def feature_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualFeatureCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualFeatureCropList, jsii.get(self, "featureCrop"))

    @builtins.property
    @jsii.member(jsii_name="fitAndFill")
    def fit_and_fill(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualFitAndFillList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualFitAndFillList, jsii.get(self, "fitAndFill"))

    @builtins.property
    @jsii.member(jsii_name="goop")
    def goop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualGoopList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualGoopList, jsii.get(self, "goop"))

    @builtins.property
    @jsii.member(jsii_name="grayscale")
    def grayscale(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualGrayscaleList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualGrayscaleList, jsii.get(self, "grayscale"))

    @builtins.property
    @jsii.member(jsii_name="hsl")
    def hsl(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualHslList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualHslList, jsii.get(self, "hsl"))

    @builtins.property
    @jsii.member(jsii_name="hsv")
    def hsv(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualHsvList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualHsvList, jsii.get(self, "hsv"))

    @builtins.property
    @jsii.member(jsii_name="ifDimension")
    def if_dimension(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfDimensionList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfDimensionList, jsii.get(self, "ifDimension"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientation")
    def if_orientation(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfOrientationList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfOrientationList, jsii.get(self, "ifOrientation"))

    @builtins.property
    @jsii.member(jsii_name="imQuery")
    def im_query(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualImQueryList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualImQueryList, jsii.get(self, "imQuery"))

    @builtins.property
    @jsii.member(jsii_name="maxColors")
    def max_colors(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualMaxColorsList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualMaxColorsList, jsii.get(self, "maxColors"))

    @builtins.property
    @jsii.member(jsii_name="mirror")
    def mirror(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualMirrorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualMirrorList, jsii.get(self, "mirror"))

    @builtins.property
    @jsii.member(jsii_name="monoHue")
    def mono_hue(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualMonoHueList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualMonoHueList, jsii.get(self, "monoHue"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualOpacityList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualOpacityList, jsii.get(self, "opacity"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestCrop")
    def region_of_interest_crop(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualRegionOfInterestCropList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualRegionOfInterestCropList", jsii.get(self, "regionOfInterestCrop"))

    @builtins.property
    @jsii.member(jsii_name="relativeCrop")
    def relative_crop(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualRelativeCropList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualRelativeCropList", jsii.get(self, "relativeCrop"))

    @builtins.property
    @jsii.member(jsii_name="removeColor")
    def remove_color(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualRemoveColorList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualRemoveColorList", jsii.get(self, "removeColor"))

    @builtins.property
    @jsii.member(jsii_name="resize")
    def resize(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualResizeList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualResizeList", jsii.get(self, "resize"))

    @builtins.property
    @jsii.member(jsii_name="rotate")
    def rotate(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualRotateList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualRotateList", jsii.get(self, "rotate"))

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualScaleList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualScaleList", jsii.get(self, "scale"))

    @builtins.property
    @jsii.member(jsii_name="shear")
    def shear(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualShearList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualShearList", jsii.get(self, "shear"))

    @builtins.property
    @jsii.member(jsii_name="trim")
    def trim(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualTrimList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualTrimList", jsii.get(self, "trim"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMask")
    def unsharp_mask(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualUnsharpMaskList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualUnsharpMaskList", jsii.get(self, "unsharpMask"))

    @builtins.property
    @jsii.member(jsii_name="appendInput")
    def append_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualAppend]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualAppend]]], jsii.get(self, "appendInput"))

    @builtins.property
    @jsii.member(jsii_name="aspectCropInput")
    def aspect_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualAspectCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualAspectCrop]]], jsii.get(self, "aspectCropInput"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColorInput")
    def background_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualBackgroundColor]]], jsii.get(self, "backgroundColorInput"))

    @builtins.property
    @jsii.member(jsii_name="blurInput")
    def blur_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualBlur]]], jsii.get(self, "blurInput"))

    @builtins.property
    @jsii.member(jsii_name="chromaKeyInput")
    def chroma_key_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualChromaKey]]], jsii.get(self, "chromaKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="compositeInput")
    def composite_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualComposite]]], jsii.get(self, "compositeInput"))

    @builtins.property
    @jsii.member(jsii_name="compoundInput")
    def compound_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualCompound]]], jsii.get(self, "compoundInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualContrast]]], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="cropInput")
    def crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualCrop]]], jsii.get(self, "cropInput"))

    @builtins.property
    @jsii.member(jsii_name="faceCropInput")
    def face_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualFaceCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualFaceCrop]]], jsii.get(self, "faceCropInput"))

    @builtins.property
    @jsii.member(jsii_name="featureCropInput")
    def feature_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualFeatureCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualFeatureCrop]]], jsii.get(self, "featureCropInput"))

    @builtins.property
    @jsii.member(jsii_name="fitAndFillInput")
    def fit_and_fill_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualFitAndFill]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualFitAndFill]]], jsii.get(self, "fitAndFillInput"))

    @builtins.property
    @jsii.member(jsii_name="goopInput")
    def goop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualGoop]]], jsii.get(self, "goopInput"))

    @builtins.property
    @jsii.member(jsii_name="grayscaleInput")
    def grayscale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualGrayscale]]], jsii.get(self, "grayscaleInput"))

    @builtins.property
    @jsii.member(jsii_name="hslInput")
    def hsl_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualHsl]]], jsii.get(self, "hslInput"))

    @builtins.property
    @jsii.member(jsii_name="hsvInput")
    def hsv_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualHsv]]], jsii.get(self, "hsvInput"))

    @builtins.property
    @jsii.member(jsii_name="ifDimensionInput")
    def if_dimension_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfDimension]]], jsii.get(self, "ifDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientationInput")
    def if_orientation_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfOrientation]]], jsii.get(self, "ifOrientationInput"))

    @builtins.property
    @jsii.member(jsii_name="imQueryInput")
    def im_query_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualImQuery]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualImQuery]]], jsii.get(self, "imQueryInput"))

    @builtins.property
    @jsii.member(jsii_name="maxColorsInput")
    def max_colors_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualMaxColors]]], jsii.get(self, "maxColorsInput"))

    @builtins.property
    @jsii.member(jsii_name="mirrorInput")
    def mirror_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualMirror]]], jsii.get(self, "mirrorInput"))

    @builtins.property
    @jsii.member(jsii_name="monoHueInput")
    def mono_hue_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualMonoHue]]], jsii.get(self, "monoHueInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualOpacity]]], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestCropInput")
    def region_of_interest_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualRegionOfInterestCrop"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualRegionOfInterestCrop"]]], jsii.get(self, "regionOfInterestCropInput"))

    @builtins.property
    @jsii.member(jsii_name="relativeCropInput")
    def relative_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualRelativeCrop"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualRelativeCrop"]]], jsii.get(self, "relativeCropInput"))

    @builtins.property
    @jsii.member(jsii_name="removeColorInput")
    def remove_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualRemoveColor"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualRemoveColor"]]], jsii.get(self, "removeColorInput"))

    @builtins.property
    @jsii.member(jsii_name="resizeInput")
    def resize_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualResize"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualResize"]]], jsii.get(self, "resizeInput"))

    @builtins.property
    @jsii.member(jsii_name="rotateInput")
    def rotate_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualRotate"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualRotate"]]], jsii.get(self, "rotateInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualScale"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualScale"]]], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="shearInput")
    def shear_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualShear"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualShear"]]], jsii.get(self, "shearInput"))

    @builtins.property
    @jsii.member(jsii_name="trimInput")
    def trim_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualTrim"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualTrim"]]], jsii.get(self, "trimInput"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMaskInput")
    def unsharp_mask_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualUnsharpMask"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualUnsharpMask"]]], jsii.get(self, "unsharpMaskInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqual], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqual],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__26c83c0f478a53e1749a961fbf4852cd4e2a647ddb72833c3de0feeee7bec9c5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualRegionOfInterestCrop",
    jsii_struct_bases=[],
    name_mapping={
        "region_of_interest": "regionOfInterest",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualRegionOfInterestCrop:
    def __init__(
        self,
        *,
        region_of_interest: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualRegionOfInterestCropRegionOfInterest", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param region_of_interest: region_of_interest block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest DataAkamaiImagingPolicyImage#region_of_interest}
        :param gravity: The placement of the crop area relative to the specified area of interest. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: The placement of the crop area relative to the specified area of interest. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param style: Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(region_of_interest, dict):
            region_of_interest = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualRegionOfInterestCropRegionOfInterest(**region_of_interest)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1b5ac97dc9022f8b192b56a91a8b04488be94b81786e716ac29f88532629d963)
            check_type(argname="argument region_of_interest", value=region_of_interest, expected_type=type_hints["region_of_interest"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "region_of_interest": region_of_interest,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def region_of_interest(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualRegionOfInterestCropRegionOfInterest":
        '''region_of_interest block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest DataAkamaiImagingPolicyImage#region_of_interest}
        '''
        result = self._values.get("region_of_interest")
        assert result is not None, "Required property 'region_of_interest' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualRegionOfInterestCropRegionOfInterest", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''The placement of the crop area relative to the specified area of interest.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''The placement of the crop area relative to the specified area of interest.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualRegionOfInterestCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualRegionOfInterestCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualRegionOfInterestCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__373a91b7efea2b8a40cb586fb2eee037107df6d6b36a049e4e49618335b4ccd9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualRegionOfInterestCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5fddb254ca7c7aee44b5581c08cd1db4a06da122f0339721ae7cdfe948ac7e5d)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualRegionOfInterestCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d6a0ff6e5a4c7bd32b880eb9c3396bc84f755914389b5e5ee58c61a678f72ca2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__34c3047ccfcb33bc1c62138a30df4aa5a1fb9dbea099a328026b1b8c1207e1d9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f4e6ee99708ea464b7fc1749d26e904741175349001cfecdd06e2a464e126f3c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualRegionOfInterestCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualRegionOfInterestCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualRegionOfInterestCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__76eb6fc712f6fddf91bd2f53791ab438743a14d9528418dcf5fd9f18daca08f5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualRegionOfInterestCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualRegionOfInterestCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7640cf87b9887f1ef4d94bffdbe346314ecc55e2b072bd5db4a1d28076936387)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putRegionOfInterest")
    def put_region_of_interest(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualRegionOfInterestCropRegionOfInterest()

        return typing.cast(None, jsii.invoke(self, "putRegionOfInterest", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterest")
    def region_of_interest(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualRegionOfInterestCropRegionOfInterestOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualRegionOfInterestCropRegionOfInterestOutputReference", jsii.get(self, "regionOfInterest"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestInput")
    def region_of_interest_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualRegionOfInterestCropRegionOfInterest"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualRegionOfInterestCropRegionOfInterest"], jsii.get(self, "regionOfInterestInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c1cb3122e56f6b2dd33fd7722989c85e7c73553d7b31cdfd36233049c236132e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__60e9c2e6ab2a1a6276ec0b81dfdb9ef1f6d53c605a86e87c4651ad011bf8677f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1804c0a5fad7683888408003f29ca5ca5b521cd8790c955c67d7a46e5b1e576a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__90f82d3d0e3c9f74b885e4297f532320ff5816b10e218db418e12e8505d3930c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8355fe60dc0278990c830d22e27d38c7db650c53c0f799bebac0bb85e4f40a7f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d8965fd901932c598bc1ee9f4bb1f6449188d13a88c49657dcb822b4b1ee95a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__909689263d81e4b085ca47164151c7e0f5be6aff252a3668ac9127350fba4cc0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2c010e3b4f60d0f77a5a37806f60da00db46184bc98525615aa56755ba82908d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualRegionOfInterestCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualRegionOfInterestCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualRegionOfInterestCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f4e0c750417a138dc6197b2269cd2d5262ccea3c63586ed3628098b677bb268d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualRegionOfInterestCropRegionOfInterest",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualRegionOfInterestCropRegionOfInterest:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualRegionOfInterestCropRegionOfInterest(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualRegionOfInterestCropRegionOfInterestOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualRegionOfInterestCropRegionOfInterestOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__397a70e6efa12783b5e4db70f84f8cadb9f68820278c5b5e3a7be16880a9cc1b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualRegionOfInterestCropRegionOfInterest]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualRegionOfInterestCropRegionOfInterest], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualRegionOfInterestCropRegionOfInterest],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__40b6718f5da21a2d9601a110169848a36b644bef292b2faf9915f85aa4606007)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualRelativeCrop",
    jsii_struct_bases=[],
    name_mapping={
        "east": "east",
        "east_var": "eastVar",
        "north": "north",
        "north_var": "northVar",
        "south": "south",
        "south_var": "southVar",
        "west": "west",
        "west_var": "westVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualRelativeCrop:
    def __init__(
        self,
        *,
        east: typing.Optional[builtins.str] = None,
        east_var: typing.Optional[builtins.str] = None,
        north: typing.Optional[builtins.str] = None,
        north_var: typing.Optional[builtins.str] = None,
        south: typing.Optional[builtins.str] = None,
        south_var: typing.Optional[builtins.str] = None,
        west: typing.Optional[builtins.str] = None,
        west_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param east: The number of pixels to shrink or expand the right side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east DataAkamaiImagingPolicyImage#east}
        :param east_var: The number of pixels to shrink or expand the right side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east_var DataAkamaiImagingPolicyImage#east_var}
        :param north: The number of pixels to shrink or expand the top side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north DataAkamaiImagingPolicyImage#north}
        :param north_var: The number of pixels to shrink or expand the top side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north_var DataAkamaiImagingPolicyImage#north_var}
        :param south: The number of pixels to shrink or expand the bottom side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south DataAkamaiImagingPolicyImage#south}
        :param south_var: The number of pixels to shrink or expand the bottom side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south_var DataAkamaiImagingPolicyImage#south_var}
        :param west: The number of pixels to shrink or expand the left side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west DataAkamaiImagingPolicyImage#west}
        :param west_var: The number of pixels to shrink or expand the left side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west_var DataAkamaiImagingPolicyImage#west_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__832f8433293f229f0597c8b8ca6eca348debaa9ff84a7f73962c1311654d5e24)
            check_type(argname="argument east", value=east, expected_type=type_hints["east"])
            check_type(argname="argument east_var", value=east_var, expected_type=type_hints["east_var"])
            check_type(argname="argument north", value=north, expected_type=type_hints["north"])
            check_type(argname="argument north_var", value=north_var, expected_type=type_hints["north_var"])
            check_type(argname="argument south", value=south, expected_type=type_hints["south"])
            check_type(argname="argument south_var", value=south_var, expected_type=type_hints["south_var"])
            check_type(argname="argument west", value=west, expected_type=type_hints["west"])
            check_type(argname="argument west_var", value=west_var, expected_type=type_hints["west_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if east is not None:
            self._values["east"] = east
        if east_var is not None:
            self._values["east_var"] = east_var
        if north is not None:
            self._values["north"] = north
        if north_var is not None:
            self._values["north_var"] = north_var
        if south is not None:
            self._values["south"] = south
        if south_var is not None:
            self._values["south_var"] = south_var
        if west is not None:
            self._values["west"] = west
        if west_var is not None:
            self._values["west_var"] = west_var

    @builtins.property
    def east(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the right side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east DataAkamaiImagingPolicyImage#east}
        '''
        result = self._values.get("east")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def east_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the right side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east_var DataAkamaiImagingPolicyImage#east_var}
        '''
        result = self._values.get("east_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def north(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the top side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north DataAkamaiImagingPolicyImage#north}
        '''
        result = self._values.get("north")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def north_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the top side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north_var DataAkamaiImagingPolicyImage#north_var}
        '''
        result = self._values.get("north_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def south(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the bottom side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south DataAkamaiImagingPolicyImage#south}
        '''
        result = self._values.get("south")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def south_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the bottom side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south_var DataAkamaiImagingPolicyImage#south_var}
        '''
        result = self._values.get("south_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def west(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the left side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west DataAkamaiImagingPolicyImage#west}
        '''
        result = self._values.get("west")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def west_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the left side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west_var DataAkamaiImagingPolicyImage#west_var}
        '''
        result = self._values.get("west_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualRelativeCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualRelativeCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualRelativeCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__865cce1a44b43ae32428c837f820a3d1fb06cf1530f3f9b08233abadec09e2a3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualRelativeCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc1340dd225b2bcd6e347fac88be6096220dc948425d6f3ea42b76b72e1c1e1c)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualRelativeCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd3a168f69092cc865c956debc451b1228823ab5f17fd72de28db13d05b0370e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ccae5bd89bc15fbb75aa71f707e6f17cc0be1ae883e0c42704e3b2505437d928)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f2d80900b690929102d0ebbdc76994fa67e76d507bd5b3b3e056fb7c38406c2f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualRelativeCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualRelativeCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualRelativeCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cac11c7bb70e5f54744c4dda402c395519ba5ef124f9869d29e03fdaca79d384)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualRelativeCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualRelativeCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__04c78c39bff0338abad4363258874d3ee025581348badaef82e9504b9e24487f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetEast")
    def reset_east(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEast", []))

    @jsii.member(jsii_name="resetEastVar")
    def reset_east_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEastVar", []))

    @jsii.member(jsii_name="resetNorth")
    def reset_north(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNorth", []))

    @jsii.member(jsii_name="resetNorthVar")
    def reset_north_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNorthVar", []))

    @jsii.member(jsii_name="resetSouth")
    def reset_south(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSouth", []))

    @jsii.member(jsii_name="resetSouthVar")
    def reset_south_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSouthVar", []))

    @jsii.member(jsii_name="resetWest")
    def reset_west(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWest", []))

    @jsii.member(jsii_name="resetWestVar")
    def reset_west_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWestVar", []))

    @builtins.property
    @jsii.member(jsii_name="eastInput")
    def east_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "eastInput"))

    @builtins.property
    @jsii.member(jsii_name="eastVarInput")
    def east_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "eastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="northInput")
    def north_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "northInput"))

    @builtins.property
    @jsii.member(jsii_name="northVarInput")
    def north_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "northVarInput"))

    @builtins.property
    @jsii.member(jsii_name="southInput")
    def south_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "southInput"))

    @builtins.property
    @jsii.member(jsii_name="southVarInput")
    def south_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "southVarInput"))

    @builtins.property
    @jsii.member(jsii_name="westInput")
    def west_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "westInput"))

    @builtins.property
    @jsii.member(jsii_name="westVarInput")
    def west_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "westVarInput"))

    @builtins.property
    @jsii.member(jsii_name="east")
    def east(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "east"))

    @east.setter
    def east(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__61a3c8b9e811b2e1606160493330f37317e884a2cc94a9a8ade8275096a49c7b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "east", value)

    @builtins.property
    @jsii.member(jsii_name="eastVar")
    def east_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "eastVar"))

    @east_var.setter
    def east_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__33b219f5f48e4642d38edb3f653a25e211a4e5a8487b8e73a0e13dfbcd11df6b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "eastVar", value)

    @builtins.property
    @jsii.member(jsii_name="north")
    def north(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "north"))

    @north.setter
    def north(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__69034379a5d42f4201895b2695cc28a5704bf8ffa78b5828c15ddac2c95d65ec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "north", value)

    @builtins.property
    @jsii.member(jsii_name="northVar")
    def north_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "northVar"))

    @north_var.setter
    def north_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__67e8fbf437df7f0e83a9674f8c7dd0d0c8372dab63a07e19019222586c6aa4ac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "northVar", value)

    @builtins.property
    @jsii.member(jsii_name="south")
    def south(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "south"))

    @south.setter
    def south(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__016cc5cc1ed74a1eecff7e2159bb3bd7e72c6a6eea0ca2d6590d0e4bc07956f4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "south", value)

    @builtins.property
    @jsii.member(jsii_name="southVar")
    def south_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "southVar"))

    @south_var.setter
    def south_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__973047561ad52065e603600812329b42b815d546a8727eda4d2a310ed6a0f74c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "southVar", value)

    @builtins.property
    @jsii.member(jsii_name="west")
    def west(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "west"))

    @west.setter
    def west(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__140154728c4de9e6f97f507604f25341f8a12193530a306389d71b71205b6252)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "west", value)

    @builtins.property
    @jsii.member(jsii_name="westVar")
    def west_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "westVar"))

    @west_var.setter
    def west_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f258877032ade59f6ee10ad387683620fcbbf905d1ad8bcbe9cdc82c8ee884f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "westVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualRelativeCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualRelativeCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualRelativeCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__17761b53fe6300856ee2ecac81f945db033d0ed9deebd1050681621a2e7515f5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualRemoveColor",
    jsii_struct_bases=[],
    name_mapping={
        "color": "color",
        "color_var": "colorVar",
        "feather": "feather",
        "feather_var": "featherVar",
        "tolerance": "tolerance",
        "tolerance_var": "toleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualRemoveColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
        feather: typing.Optional[builtins.str] = None,
        feather_var: typing.Optional[builtins.str] = None,
        tolerance: typing.Optional[builtins.str] = None,
        tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        :param feather: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        :param feather_var: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        :param tolerance: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        :param tolerance_var: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4f5998a4839fbac414b287f4d3e75a3bca6ab3e8ed07650be1153018f08c8354)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
            check_type(argname="argument feather", value=feather, expected_type=type_hints["feather"])
            check_type(argname="argument feather_var", value=feather_var, expected_type=type_hints["feather_var"])
            check_type(argname="argument tolerance", value=tolerance, expected_type=type_hints["tolerance"])
            check_type(argname="argument tolerance_var", value=tolerance_var, expected_type=type_hints["tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var
        if feather is not None:
            self._values["feather"] = feather
        if feather_var is not None:
            self._values["feather_var"] = feather_var
        if tolerance is not None:
            self._values["tolerance"] = tolerance
        if tolerance_var is not None:
            self._values["tolerance_var"] = tolerance_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        '''
        result = self._values.get("feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather_var(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        '''
        result = self._values.get("feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        '''
        result = self._values.get("tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance_var(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        result = self._values.get("tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualRemoveColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualRemoveColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualRemoveColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5e170ce5add6f89c4024fbaa21e8488fd521495c46021bcbe4a0e247eb1548ae)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualRemoveColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c556ad177baec0a0da8762e55174e04b54b512066729bb9cc267735176f5f238)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualRemoveColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac0246d692b5d26d23b961329434adc8e6019445d9146361f2df82bf96feb090)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5993bcea4fe727b82a56b8c3a668ff8347cdb06a0e9471c8aceebe4f58d61c97)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fc1f6633efedbee3b5aafcd1072e276d85a60713f18184ddd141fa2085b55bf3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualRemoveColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualRemoveColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualRemoveColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__de0fdb20a14a7f4cda25aaeb78cb49e1734049a711eee48c1d3acd0760262839)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualRemoveColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualRemoveColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__011158daf05d0a8eb1a4a39fa54ea0a48cef049f92c1d687325a39bdbf7d105a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @jsii.member(jsii_name="resetFeather")
    def reset_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeather", []))

    @jsii.member(jsii_name="resetFeatherVar")
    def reset_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatherVar", []))

    @jsii.member(jsii_name="resetTolerance")
    def reset_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTolerance", []))

    @jsii.member(jsii_name="resetToleranceVar")
    def reset_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featherInput")
    def feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherInput"))

    @builtins.property
    @jsii.member(jsii_name="featherVarInput")
    def feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceInput")
    def tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceVarInput")
    def tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2707e9a783623cc9689fd2c8fbc1bfbf5fe16e1b39294f22d836f8c1470288a4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6ca9f164e847996d18a551c8755c3e3898b21945c34274b306040ac2a37e0d66)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="feather")
    def feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "feather"))

    @feather.setter
    def feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__504c2df247dafaae26ff5573fcf05c38c043bb66e880386a38c53a75de859b36)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "feather", value)

    @builtins.property
    @jsii.member(jsii_name="featherVar")
    def feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featherVar"))

    @feather_var.setter
    def feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c926fac702655b46e8a06b4a4604eef61472686b37023cdf7aad95dd17b16c45)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featherVar", value)

    @builtins.property
    @jsii.member(jsii_name="tolerance")
    def tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tolerance"))

    @tolerance.setter
    def tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fe60f45e88312b065e4115b007c9c333c150da129e9545c39dd035c0789f4567)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tolerance", value)

    @builtins.property
    @jsii.member(jsii_name="toleranceVar")
    def tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "toleranceVar"))

    @tolerance_var.setter
    def tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__475a3202dcdb567cd74007b736673b73d9dd3cd4485cd005acaf514f5fdf5eb1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "toleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualRemoveColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualRemoveColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualRemoveColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d512d2588682d214f17c6bf620be83be708601634d6b33c3501f5b5752de4fa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualResize",
    jsii_struct_bases=[],
    name_mapping={
        "aspect": "aspect",
        "aspect_var": "aspectVar",
        "height": "height",
        "height_var": "heightVar",
        "type": "type",
        "type_var": "typeVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualResize:
    def __init__(
        self,
        *,
        aspect: typing.Optional[builtins.str] = None,
        aspect_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param aspect: Preserves the aspect ratio. Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect DataAkamaiImagingPolicyImage#aspect}
        :param aspect_var: Preserves the aspect ratio. Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_var DataAkamaiImagingPolicyImage#aspect_var}
        :param height: The height to resize the source image to. Must be set if height is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height to resize the source image to. Must be set if height is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param type: Sets constraints for the image resize. Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: Sets constraints for the image resize. Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        :param width: The width to resize the source image to. Must be set if width is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width to resize the source image to. Must be set if width is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__33bb03e0d6c2bcb7f5266f579d0a6863ade3dacb461c482762e7197fefcc6ee6)
            check_type(argname="argument aspect", value=aspect, expected_type=type_hints["aspect"])
            check_type(argname="argument aspect_var", value=aspect_var, expected_type=type_hints["aspect_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if aspect is not None:
            self._values["aspect"] = aspect
        if aspect_var is not None:
            self._values["aspect_var"] = aspect_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def aspect(self) -> typing.Optional[builtins.str]:
        '''Preserves the aspect ratio.

        Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect DataAkamaiImagingPolicyImage#aspect}
        '''
        result = self._values.get("aspect")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def aspect_var(self) -> typing.Optional[builtins.str]:
        '''Preserves the aspect ratio.

        Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_var DataAkamaiImagingPolicyImage#aspect_var}
        '''
        result = self._values.get("aspect_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height to resize the source image to. Must be set if height is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height to resize the source image to. Must be set if height is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''Sets constraints for the image resize.

        Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''Sets constraints for the image resize.

        Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width to resize the source image to. Must be set if width is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width to resize the source image to. Must be set if width is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualResize(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualResizeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualResizeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__549f5d43b0d7ca7a4792b922b721dc503115e4e723c57e43dd34aa2828739579)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualResizeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1d7230fbc8293c1a4f2eef4ed560f190672e32f6c229c461a9ea182356678d2f)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualResizeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8f2354cf12008486f00d4d9c72fcc75bcc396aa24e83cccf47f3cc54f5c1ff2a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__193d939584737500fb6ac04169c26acca9d99ac6cedf61c4f3f2b135ec15c911)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__62bbb992cc7f5a1211c34fafd21cf6c784c02252fcdfee09cc238617bb4090fd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualResize]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualResize]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualResize]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b80d2c2fafd0fea520880ba9d6969e5d3149d3e655b7ced1abd7ad8be057dd0b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualResizeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualResizeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__48de73c5f2efe05b62a2f691d3ca772568f2ab6467adc2042bfc7ec662fc0acf)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAspect")
    def reset_aspect(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspect", []))

    @jsii.member(jsii_name="resetAspectVar")
    def reset_aspect_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspectVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="aspectInput")
    def aspect_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "aspectInput"))

    @builtins.property
    @jsii.member(jsii_name="aspectVarInput")
    def aspect_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "aspectVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="aspect")
    def aspect(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "aspect"))

    @aspect.setter
    def aspect(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e3def353a31cd754de5bcfcda2856e55a70ee27b2ab534e815ae01154fdddd0d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "aspect", value)

    @builtins.property
    @jsii.member(jsii_name="aspectVar")
    def aspect_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "aspectVar"))

    @aspect_var.setter
    def aspect_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4f05c3ef3fc87589189ea1cfbc46e0b7cbd9510ee2dcad6f9e7a4279b00d3900)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "aspectVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b02d72fdb2dc6d5f262a0884717c70ddb668f033a6983fb7f189d9105ad19cb6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1c8cdff8aad5a0dc1b345ca40adce0c8996e11953d0535557c0f73ed707d7f3e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ba8ad70b4bc15c6e62e419bba99fc51a3d871901dca12d263368f4001223aa44)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cf0407c6b0d586f715dbff131ec506e9e9e6bdefdd03805f8ff7844e4f7c7d9a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bbffa305df875c87e10571bcd724877c9c1c2adbe415c1d2ea53a5045bf03e1d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__15226bf133ccafe44c217796191d770dbe7bc1992855de472bfa4e50c27ab421)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualResize]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualResize]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualResize]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__06e92c317512fb87dc1c59be6574a609b3d60b4cd82787849446adee9b3a086f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualRotate",
    jsii_struct_bases=[],
    name_mapping={"degrees": "degrees", "degrees_var": "degreesVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualRotate:
    def __init__(
        self,
        *,
        degrees: typing.Optional[builtins.str] = None,
        degrees_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param degrees: The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees DataAkamaiImagingPolicyImage#degrees}
        :param degrees_var: The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees_var DataAkamaiImagingPolicyImage#degrees_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4fa121f5ef9178c8b7217832df5a17b4493708e456a6e5f1ec4f33f3937085da)
            check_type(argname="argument degrees", value=degrees, expected_type=type_hints["degrees"])
            check_type(argname="argument degrees_var", value=degrees_var, expected_type=type_hints["degrees_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if degrees is not None:
            self._values["degrees"] = degrees
        if degrees_var is not None:
            self._values["degrees_var"] = degrees_var

    @builtins.property
    def degrees(self) -> typing.Optional[builtins.str]:
        '''The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees DataAkamaiImagingPolicyImage#degrees}
        '''
        result = self._values.get("degrees")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def degrees_var(self) -> typing.Optional[builtins.str]:
        '''The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees_var DataAkamaiImagingPolicyImage#degrees_var}
        '''
        result = self._values.get("degrees_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualRotate(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualRotateList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualRotateList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__225411eae24ee67f5d0523bf918e0fccc8dafc1f6f58b4c7940c5c4c9df11c73)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualRotateOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__448e3cf795e34b8cc7ea83545635336e6b1ea38808f815af55c28ee88be85324)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualRotateOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8b6438468d88e992a8b97949f253872cac120a9c56d6f6f49fd72211152b48f4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2db608bc03e929dda0a2af0ecd559459d6b72963fa3897f0f105938307982f72)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__829c72763d22176764b9c7e54da074aeff4c0928fc74ea665c78ae7dcb1b4190)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualRotate]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualRotate]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualRotate]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ae3789c2a58da9f7e8c4e49b5f3b92fa0531aa15e298b22f9eb94d16fabf6e29)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualRotateOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualRotateOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3edfefc6d0645be255152e33b02b53ad027574be3e2ebb18fd9cc0f2a4f5ab2a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetDegrees")
    def reset_degrees(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDegrees", []))

    @jsii.member(jsii_name="resetDegreesVar")
    def reset_degrees_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDegreesVar", []))

    @builtins.property
    @jsii.member(jsii_name="degreesInput")
    def degrees_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "degreesInput"))

    @builtins.property
    @jsii.member(jsii_name="degreesVarInput")
    def degrees_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "degreesVarInput"))

    @builtins.property
    @jsii.member(jsii_name="degrees")
    def degrees(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "degrees"))

    @degrees.setter
    def degrees(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a527d8833cc9f81efbbc8ef03e0ecdf1aef05c3076cd6a2906191e5ef6fed1c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "degrees", value)

    @builtins.property
    @jsii.member(jsii_name="degreesVar")
    def degrees_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "degreesVar"))

    @degrees_var.setter
    def degrees_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__86ef96fc217d3a044c830f13b39fb93dae970d97ae3956f6f5c2f7ee47c56019)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "degreesVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualRotate]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualRotate]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualRotate]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a19b435159a61c59faff35bd4379f4ca6abcaa6c6bf581075b0adccced672a08)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualScale",
    jsii_struct_bases=[],
    name_mapping={
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualScale:
    def __init__(
        self,
        *,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param height: Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged. Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged. Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__966c16fd82d8384bc82bbd843536052c81f3c1b794813c2bb102629ceefe0755)
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size.

        Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size.

        Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged.

        Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged.

        Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualScale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualScaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualScaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__55e0bce03451e0170437bb5407edf8d804bdf65206ceaddb2229b3e28a9831ca)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualScaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b40fa12c9d7c746af8a3196832b6de1dc59cf891ed115672bef720f0f8f5fd81)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualScaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d33b3a36ffe82e62a3e8536561ee0ccb2672c2e75a23c6685a83a138930d7f64)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__188a2f624c6ce9526781a19f22f4c340adb5b074138e577af64c7f6082c3b5d4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a2bc82eecc5aa39148a63468dc53aecfe651a5449bb6fa21aabcd4f60508d60c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualScale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualScale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualScale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b4614ced7385e922a3e11995e68d8572fcdf52c45f22de6cbe35fc63e3dffea4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualScaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualScaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ec133f01e483cf45d176ebd2e1c09f94d278a15d7a3535837184ffb9c9cb28b9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fd907bac4d038bdef1a67dd8e4510e0987ab71050f5b5233fd2b276c859b7c27)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__baeb276ee7348c3327e315d44a6dd2f478ad94d5b3fa2cb415d868c11bf96d3d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__29d9d28a73c1c21a7c68be63164aaef51e2a44d27138d8aeaabebee0456803ea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__628316c9e99af5ab250e768c1f6946858b6de4e8cfb9965ad8ce7b06e5a594fc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualScale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualScale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualScale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f5a520e1d2577b3ca8db3de9d799ace3e896ed008695dd7fdd1f508cad596b65)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualShear",
    jsii_struct_bases=[],
    name_mapping={
        "x_shear": "xShear",
        "x_shear_var": "xShearVar",
        "y_shear": "yShear",
        "y_shear_var": "yShearVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualShear:
    def __init__(
        self,
        *,
        x_shear: typing.Optional[builtins.str] = None,
        x_shear_var: typing.Optional[builtins.str] = None,
        y_shear: typing.Optional[builtins.str] = None,
        y_shear_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param x_shear: The amount to shear along the x-axis, measured in multiples of the image's width. Must be set if yShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear DataAkamaiImagingPolicyImage#x_shear}
        :param x_shear_var: The amount to shear along the x-axis, measured in multiples of the image's width. Must be set if yShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear_var DataAkamaiImagingPolicyImage#x_shear_var}
        :param y_shear: The amount to shear along the y-axis, measured in multiples of the image's height. Must be set if xShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear DataAkamaiImagingPolicyImage#y_shear}
        :param y_shear_var: The amount to shear along the y-axis, measured in multiples of the image's height. Must be set if xShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear_var DataAkamaiImagingPolicyImage#y_shear_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0805b775d19925560962c93d290f53ced0d48b16f8c23f7ca2fc021af1a853d3)
            check_type(argname="argument x_shear", value=x_shear, expected_type=type_hints["x_shear"])
            check_type(argname="argument x_shear_var", value=x_shear_var, expected_type=type_hints["x_shear_var"])
            check_type(argname="argument y_shear", value=y_shear, expected_type=type_hints["y_shear"])
            check_type(argname="argument y_shear_var", value=y_shear_var, expected_type=type_hints["y_shear_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if x_shear is not None:
            self._values["x_shear"] = x_shear
        if x_shear_var is not None:
            self._values["x_shear_var"] = x_shear_var
        if y_shear is not None:
            self._values["y_shear"] = y_shear
        if y_shear_var is not None:
            self._values["y_shear_var"] = y_shear_var

    @builtins.property
    def x_shear(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the x-axis, measured in multiples of the image's width.

        Must be set if yShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear DataAkamaiImagingPolicyImage#x_shear}
        '''
        result = self._values.get("x_shear")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_shear_var(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the x-axis, measured in multiples of the image's width.

        Must be set if yShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear_var DataAkamaiImagingPolicyImage#x_shear_var}
        '''
        result = self._values.get("x_shear_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_shear(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the y-axis, measured in multiples of the image's height.

        Must be set if xShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear DataAkamaiImagingPolicyImage#y_shear}
        '''
        result = self._values.get("y_shear")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_shear_var(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the y-axis, measured in multiples of the image's height.

        Must be set if xShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear_var DataAkamaiImagingPolicyImage#y_shear_var}
        '''
        result = self._values.get("y_shear_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualShear(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualShearList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualShearList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__36518abf518abdf27d5b63af960cdfc00a3a29f1f8225ccca042760033c34e33)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualShearOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__11338d4d5a9ce268ef0d68a401434713c122a449dc531d7222ffb15ebdf2aa2c)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualShearOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bd8a67a337c64f3233a0e3ec78bb6a8d2601e131da2dc0652b3ae774d7cbd354)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d33546d41899dd565092857f382992d9ec7e24160233da8fff9440b771b90347)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ec81b59d57710f97bb46197b90047439e60f38aae3b0a71028379481bf34af5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualShear]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualShear]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualShear]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__79175ebc5287270a533602ed8d6eb48cba63ed90bcc07bc39f8a3fdec02bb194)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualShearOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualShearOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0de019f5d5a99a186e366eb90f8547b738328021471e29d733f45ddee4d65837)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetXShear")
    def reset_x_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXShear", []))

    @jsii.member(jsii_name="resetXShearVar")
    def reset_x_shear_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXShearVar", []))

    @jsii.member(jsii_name="resetYShear")
    def reset_y_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYShear", []))

    @jsii.member(jsii_name="resetYShearVar")
    def reset_y_shear_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYShearVar", []))

    @builtins.property
    @jsii.member(jsii_name="xShearInput")
    def x_shear_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xShearInput"))

    @builtins.property
    @jsii.member(jsii_name="xShearVarInput")
    def x_shear_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xShearVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yShearInput")
    def y_shear_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yShearInput"))

    @builtins.property
    @jsii.member(jsii_name="yShearVarInput")
    def y_shear_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yShearVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xShear")
    def x_shear(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xShear"))

    @x_shear.setter
    def x_shear(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eb63f0cb6031331c6ff82865dec371d37514928e0958bc623a2f229c0965c01e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xShear", value)

    @builtins.property
    @jsii.member(jsii_name="xShearVar")
    def x_shear_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xShearVar"))

    @x_shear_var.setter
    def x_shear_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e90967e192179ece939ecb6eef6cef928abaa926c9ffe32c83a4e2ea3df3c4dd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xShearVar", value)

    @builtins.property
    @jsii.member(jsii_name="yShear")
    def y_shear(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yShear"))

    @y_shear.setter
    def y_shear(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__463e6b75147e97a1e0cccaea7a5da6b38363648092d99af7ee09bb535096a458)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yShear", value)

    @builtins.property
    @jsii.member(jsii_name="yShearVar")
    def y_shear_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yShearVar"))

    @y_shear_var.setter
    def y_shear_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af2b737b2f29c6a58aa3eb9d8353519f69684ae95136c3f0ae65243cf3780346)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yShearVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualShear]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualShear]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualShear]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b1a9be9fd9c7b6bb946c34ac9610066746b5f9c4c783e0f5f5f5ed6c2bc18ad0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualTrim",
    jsii_struct_bases=[],
    name_mapping={
        "fuzz": "fuzz",
        "fuzz_var": "fuzzVar",
        "padding": "padding",
        "padding_var": "paddingVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualTrim:
    def __init__(
        self,
        *,
        fuzz: typing.Optional[builtins.str] = None,
        fuzz_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fuzz: The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz DataAkamaiImagingPolicyImage#fuzz}
        :param fuzz_var: The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz_var DataAkamaiImagingPolicyImage#fuzz_var}
        :param padding: The amount of padding in pixels to add to the trimmed image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: The amount of padding in pixels to add to the trimmed image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cdd288bf224231de5f04eb9e6c168b301334a5544a7bc3322f8b4250db7bcb3a)
            check_type(argname="argument fuzz", value=fuzz, expected_type=type_hints["fuzz"])
            check_type(argname="argument fuzz_var", value=fuzz_var, expected_type=type_hints["fuzz_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fuzz is not None:
            self._values["fuzz"] = fuzz
        if fuzz_var is not None:
            self._values["fuzz_var"] = fuzz_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var

    @builtins.property
    def fuzz(self) -> typing.Optional[builtins.str]:
        '''The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz DataAkamaiImagingPolicyImage#fuzz}
        '''
        result = self._values.get("fuzz")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fuzz_var(self) -> typing.Optional[builtins.str]:
        '''The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz_var DataAkamaiImagingPolicyImage#fuzz_var}
        '''
        result = self._values.get("fuzz_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''The amount of padding in pixels to add to the trimmed image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''The amount of padding in pixels to add to the trimmed image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualTrim(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualTrimList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualTrimList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__adaa0a468fef33b0a9a347ecd9179547a6dd64ff6820861121f3037c4bac3a91)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualTrimOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0d079e0fa9615ed628f4d3206a6ca8500f40578822bac6d3c7990a2a3ccca2bd)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualTrimOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d6eec3aefc4984a0dd3c87120442677b7d0d9a5f7f4836f34560f4e9f2568376)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6490718589eaefde5c5b09a505a1cbb4d28ca49795597035b9e2d049df917de6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3fb7abef2f3d70972d347fb09b02b79ba3145f4491e8be4ed04578ea4105cc04)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualTrim]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualTrim]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualTrim]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__01542495f2534b573c019bd7119d17fa22f7fe781e71b790ff37947511602c3c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualTrimOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualTrimOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__817fa60cb968c675f0b64fa943a49fba5cf9c95e01cbcae9637cf210fdc4736e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetFuzz")
    def reset_fuzz(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFuzz", []))

    @jsii.member(jsii_name="resetFuzzVar")
    def reset_fuzz_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFuzzVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @builtins.property
    @jsii.member(jsii_name="fuzzInput")
    def fuzz_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fuzzInput"))

    @builtins.property
    @jsii.member(jsii_name="fuzzVarInput")
    def fuzz_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fuzzVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="fuzz")
    def fuzz(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fuzz"))

    @fuzz.setter
    def fuzz(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6102634446d209a05758849df204b2436574d8430a758f945b299bd118756e14)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fuzz", value)

    @builtins.property
    @jsii.member(jsii_name="fuzzVar")
    def fuzz_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fuzzVar"))

    @fuzz_var.setter
    def fuzz_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3b67dae0fe758f2cf7413f08e9b756e08334721e2c5e9dd0740b0051ae543048)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fuzzVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7bef3eaf99b6ae321c2c8625b0bcbabb6f1d9f648433e5b3e5ec79f5dc0729bf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d807e61172d57073c27fe1e757f7bdcce88dcf8c5e71190dee4837814f8e472e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualTrim]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualTrim]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualTrim]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3429e2798b7d7fd7cf127ab3d829d06f80f829a7beeac63dc02c42bbffb17754)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualUnsharpMask",
    jsii_struct_bases=[],
    name_mapping={
        "gain": "gain",
        "gain_var": "gainVar",
        "sigma": "sigma",
        "sigma_var": "sigmaVar",
        "threshold": "threshold",
        "threshold_var": "thresholdVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualUnsharpMask:
    def __init__(
        self,
        *,
        gain: typing.Optional[builtins.str] = None,
        gain_var: typing.Optional[builtins.str] = None,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
        threshold: typing.Optional[builtins.str] = None,
        threshold_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param gain: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        :param gain_var: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        :param sigma: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        :param threshold: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        :param threshold_var: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8b26374399e989105bbd670bbc87ff5f15ec41e4f3a3bab54c032d69b7e70886)
            check_type(argname="argument gain", value=gain, expected_type=type_hints["gain"])
            check_type(argname="argument gain_var", value=gain_var, expected_type=type_hints["gain_var"])
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
            check_type(argname="argument threshold", value=threshold, expected_type=type_hints["threshold"])
            check_type(argname="argument threshold_var", value=threshold_var, expected_type=type_hints["threshold_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if gain is not None:
            self._values["gain"] = gain
        if gain_var is not None:
            self._values["gain_var"] = gain_var
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var
        if threshold is not None:
            self._values["threshold"] = threshold
        if threshold_var is not None:
            self._values["threshold_var"] = threshold_var

    @builtins.property
    def gain(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        '''
        result = self._values.get("gain")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gain_var(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        '''
        result = self._values.get("gain_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        '''
        result = self._values.get("threshold")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold_var(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        result = self._values.get("threshold_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualUnsharpMask(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualUnsharpMaskList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualUnsharpMaskList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__50171f9fbd8f9d337ac2da32e667e8ab4b1c6ce19ee6655be6d2f45d88d05176)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualUnsharpMaskOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6880934aaca5a453e0a6bc38e43b92c5f461ae19d7731930aab02f84031f91b7)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualUnsharpMaskOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d9f64fc9ae5ca1ec8d3dcbd6539bb17dddbcbd219c2ab2cecafab9a895dce19)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dfb987c41c37f9dc58bb5265e33c9cb13755bb50525ba9c77271096431475654)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e367d00efa7662d3ca8d214d7f1faaba0d0ee285f6116900697e3dc002759740)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualUnsharpMask]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualUnsharpMask]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualUnsharpMask]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a2d8e8dc41f8e1266d1fa5aa6a165c4dc446248b02f763397e0e115fa9b560af)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualUnsharpMaskOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualUnsharpMaskOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9fe17e30c5f4716470dc7fd67fbcdc231f311b097c531457f0a19bdfbfb753c6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetGain")
    def reset_gain(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGain", []))

    @jsii.member(jsii_name="resetGainVar")
    def reset_gain_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGainVar", []))

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @jsii.member(jsii_name="resetThreshold")
    def reset_threshold(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThreshold", []))

    @jsii.member(jsii_name="resetThresholdVar")
    def reset_threshold_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThresholdVar", []))

    @builtins.property
    @jsii.member(jsii_name="gainInput")
    def gain_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainInput"))

    @builtins.property
    @jsii.member(jsii_name="gainVarInput")
    def gain_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdInput")
    def threshold_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdVarInput")
    def threshold_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gain")
    def gain(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gain"))

    @gain.setter
    def gain(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a1876e17b356acabedc13506730941835ba986a64bf0df952d486efe1b5c6718)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gain", value)

    @builtins.property
    @jsii.member(jsii_name="gainVar")
    def gain_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gainVar"))

    @gain_var.setter
    def gain_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b321f21b0a7fab65fc08051725ed28c745331fbc8cc793b88d5209cc0aa60b2a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gainVar", value)

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c46feae34692b0b5a206cc1a09eb20ec5a38bdfab901e4d900a6eb381d56ae74)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fb976912d960382ef8261e8767732343b09192a0f789b0b97e71b59c615ab467)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="threshold")
    def threshold(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "threshold"))

    @threshold.setter
    def threshold(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d32519cb11f148f67da32ae2b22cfe35bd81d23efa59f0f86dda323513e64f19)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "threshold", value)

    @builtins.property
    @jsii.member(jsii_name="thresholdVar")
    def threshold_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "thresholdVar"))

    @threshold_var.setter
    def threshold_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__14fb6e025995b550b644d3890730df7d87e741d8f73e18ea7f2d2b491bfb9ed0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "thresholdVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualUnsharpMask]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualUnsharpMask]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualUnsharpMask]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fcb40b0eefb5ef8279e49a9168884c26c29c78ab289fdd3c806758bbf108f419)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThan",
    jsii_struct_bases=[],
    name_mapping={
        "append": "append",
        "aspect_crop": "aspectCrop",
        "background_color": "backgroundColor",
        "blur": "blur",
        "chroma_key": "chromaKey",
        "composite": "composite",
        "compound": "compound",
        "contrast": "contrast",
        "crop": "crop",
        "face_crop": "faceCrop",
        "feature_crop": "featureCrop",
        "fit_and_fill": "fitAndFill",
        "goop": "goop",
        "grayscale": "grayscale",
        "hsl": "hsl",
        "hsv": "hsv",
        "if_dimension": "ifDimension",
        "if_orientation": "ifOrientation",
        "im_query": "imQuery",
        "max_colors": "maxColors",
        "mirror": "mirror",
        "mono_hue": "monoHue",
        "opacity": "opacity",
        "region_of_interest_crop": "regionOfInterestCrop",
        "relative_crop": "relativeCrop",
        "remove_color": "removeColor",
        "resize": "resize",
        "rotate": "rotate",
        "scale": "scale",
        "shear": "shear",
        "trim": "trim",
        "unsharp_mask": "unsharpMask",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThan:
    def __init__(
        self,
        *,
        append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanAppend", typing.Dict[builtins.str, typing.Any]]]]] = None,
        aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanAspectCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanBackgroundColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanBlur", typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanChromaKey", typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanComposite", typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanCompound", typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanContrast", typing.Dict[builtins.str, typing.Any]]]]] = None,
        crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanFaceCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanFeatureCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanFitAndFill", typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanGoop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanGrayscale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanHsl", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanHsv", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimension", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientation", typing.Dict[builtins.str, typing.Any]]]]] = None,
        im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanImQuery", typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanMaxColors", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanMirror", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanMonoHue", typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanOpacity", typing.Dict[builtins.str, typing.Any]]]]] = None,
        region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanRegionOfInterestCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanRelativeCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanRemoveColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanResize", typing.Dict[builtins.str, typing.Any]]]]] = None,
        rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanRotate", typing.Dict[builtins.str, typing.Any]]]]] = None,
        scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanScale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanShear", typing.Dict[builtins.str, typing.Any]]]]] = None,
        trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanTrim", typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanUnsharpMask", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param append: append block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        :param aspect_crop: aspect_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param crop: crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        :param face_crop: face_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        :param feature_crop: feature_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        :param fit_and_fill: fit_and_fill block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param im_query: im_query block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param region_of_interest_crop: region_of_interest_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        :param relative_crop: relative_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param resize: resize block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        :param rotate: rotate block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        :param scale: scale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param shear: shear block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        :param trim: trim block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa8b8d3b1957aa2311a26b45ae4f03cf3dd94c6f1ef6c5e38598e678ef588a57)
            check_type(argname="argument append", value=append, expected_type=type_hints["append"])
            check_type(argname="argument aspect_crop", value=aspect_crop, expected_type=type_hints["aspect_crop"])
            check_type(argname="argument background_color", value=background_color, expected_type=type_hints["background_color"])
            check_type(argname="argument blur", value=blur, expected_type=type_hints["blur"])
            check_type(argname="argument chroma_key", value=chroma_key, expected_type=type_hints["chroma_key"])
            check_type(argname="argument composite", value=composite, expected_type=type_hints["composite"])
            check_type(argname="argument compound", value=compound, expected_type=type_hints["compound"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument crop", value=crop, expected_type=type_hints["crop"])
            check_type(argname="argument face_crop", value=face_crop, expected_type=type_hints["face_crop"])
            check_type(argname="argument feature_crop", value=feature_crop, expected_type=type_hints["feature_crop"])
            check_type(argname="argument fit_and_fill", value=fit_and_fill, expected_type=type_hints["fit_and_fill"])
            check_type(argname="argument goop", value=goop, expected_type=type_hints["goop"])
            check_type(argname="argument grayscale", value=grayscale, expected_type=type_hints["grayscale"])
            check_type(argname="argument hsl", value=hsl, expected_type=type_hints["hsl"])
            check_type(argname="argument hsv", value=hsv, expected_type=type_hints["hsv"])
            check_type(argname="argument if_dimension", value=if_dimension, expected_type=type_hints["if_dimension"])
            check_type(argname="argument if_orientation", value=if_orientation, expected_type=type_hints["if_orientation"])
            check_type(argname="argument im_query", value=im_query, expected_type=type_hints["im_query"])
            check_type(argname="argument max_colors", value=max_colors, expected_type=type_hints["max_colors"])
            check_type(argname="argument mirror", value=mirror, expected_type=type_hints["mirror"])
            check_type(argname="argument mono_hue", value=mono_hue, expected_type=type_hints["mono_hue"])
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument region_of_interest_crop", value=region_of_interest_crop, expected_type=type_hints["region_of_interest_crop"])
            check_type(argname="argument relative_crop", value=relative_crop, expected_type=type_hints["relative_crop"])
            check_type(argname="argument remove_color", value=remove_color, expected_type=type_hints["remove_color"])
            check_type(argname="argument resize", value=resize, expected_type=type_hints["resize"])
            check_type(argname="argument rotate", value=rotate, expected_type=type_hints["rotate"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument shear", value=shear, expected_type=type_hints["shear"])
            check_type(argname="argument trim", value=trim, expected_type=type_hints["trim"])
            check_type(argname="argument unsharp_mask", value=unsharp_mask, expected_type=type_hints["unsharp_mask"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if append is not None:
            self._values["append"] = append
        if aspect_crop is not None:
            self._values["aspect_crop"] = aspect_crop
        if background_color is not None:
            self._values["background_color"] = background_color
        if blur is not None:
            self._values["blur"] = blur
        if chroma_key is not None:
            self._values["chroma_key"] = chroma_key
        if composite is not None:
            self._values["composite"] = composite
        if compound is not None:
            self._values["compound"] = compound
        if contrast is not None:
            self._values["contrast"] = contrast
        if crop is not None:
            self._values["crop"] = crop
        if face_crop is not None:
            self._values["face_crop"] = face_crop
        if feature_crop is not None:
            self._values["feature_crop"] = feature_crop
        if fit_and_fill is not None:
            self._values["fit_and_fill"] = fit_and_fill
        if goop is not None:
            self._values["goop"] = goop
        if grayscale is not None:
            self._values["grayscale"] = grayscale
        if hsl is not None:
            self._values["hsl"] = hsl
        if hsv is not None:
            self._values["hsv"] = hsv
        if if_dimension is not None:
            self._values["if_dimension"] = if_dimension
        if if_orientation is not None:
            self._values["if_orientation"] = if_orientation
        if im_query is not None:
            self._values["im_query"] = im_query
        if max_colors is not None:
            self._values["max_colors"] = max_colors
        if mirror is not None:
            self._values["mirror"] = mirror
        if mono_hue is not None:
            self._values["mono_hue"] = mono_hue
        if opacity is not None:
            self._values["opacity"] = opacity
        if region_of_interest_crop is not None:
            self._values["region_of_interest_crop"] = region_of_interest_crop
        if relative_crop is not None:
            self._values["relative_crop"] = relative_crop
        if remove_color is not None:
            self._values["remove_color"] = remove_color
        if resize is not None:
            self._values["resize"] = resize
        if rotate is not None:
            self._values["rotate"] = rotate
        if scale is not None:
            self._values["scale"] = scale
        if shear is not None:
            self._values["shear"] = shear
        if trim is not None:
            self._values["trim"] = trim
        if unsharp_mask is not None:
            self._values["unsharp_mask"] = unsharp_mask

    @builtins.property
    def append(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanAppend"]]]:
        '''append block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        '''
        result = self._values.get("append")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanAppend"]]], result)

    @builtins.property
    def aspect_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanAspectCrop"]]]:
        '''aspect_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        '''
        result = self._values.get("aspect_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanAspectCrop"]]], result)

    @builtins.property
    def background_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanBackgroundColor"]]]:
        '''background_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        '''
        result = self._values.get("background_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanBackgroundColor"]]], result)

    @builtins.property
    def blur(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanBlur"]]]:
        '''blur block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        '''
        result = self._values.get("blur")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanBlur"]]], result)

    @builtins.property
    def chroma_key(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanChromaKey"]]]:
        '''chroma_key block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        '''
        result = self._values.get("chroma_key")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanChromaKey"]]], result)

    @builtins.property
    def composite(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanComposite"]]]:
        '''composite block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        '''
        result = self._values.get("composite")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanComposite"]]], result)

    @builtins.property
    def compound(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanCompound"]]]:
        '''compound block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        '''
        result = self._values.get("compound")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanCompound"]]], result)

    @builtins.property
    def contrast(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanContrast"]]]:
        '''contrast block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanContrast"]]], result)

    @builtins.property
    def crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanCrop"]]]:
        '''crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        '''
        result = self._values.get("crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanCrop"]]], result)

    @builtins.property
    def face_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanFaceCrop"]]]:
        '''face_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        '''
        result = self._values.get("face_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanFaceCrop"]]], result)

    @builtins.property
    def feature_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanFeatureCrop"]]]:
        '''feature_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        '''
        result = self._values.get("feature_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanFeatureCrop"]]], result)

    @builtins.property
    def fit_and_fill(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanFitAndFill"]]]:
        '''fit_and_fill block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        '''
        result = self._values.get("fit_and_fill")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanFitAndFill"]]], result)

    @builtins.property
    def goop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanGoop"]]]:
        '''goop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        '''
        result = self._values.get("goop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanGoop"]]], result)

    @builtins.property
    def grayscale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanGrayscale"]]]:
        '''grayscale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        '''
        result = self._values.get("grayscale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanGrayscale"]]], result)

    @builtins.property
    def hsl(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanHsl"]]]:
        '''hsl block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        '''
        result = self._values.get("hsl")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanHsl"]]], result)

    @builtins.property
    def hsv(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanHsv"]]]:
        '''hsv block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        '''
        result = self._values.get("hsv")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanHsv"]]], result)

    @builtins.property
    def if_dimension(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimension"]]]:
        '''if_dimension block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        '''
        result = self._values.get("if_dimension")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimension"]]], result)

    @builtins.property
    def if_orientation(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientation"]]]:
        '''if_orientation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        '''
        result = self._values.get("if_orientation")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientation"]]], result)

    @builtins.property
    def im_query(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanImQuery"]]]:
        '''im_query block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        '''
        result = self._values.get("im_query")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanImQuery"]]], result)

    @builtins.property
    def max_colors(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanMaxColors"]]]:
        '''max_colors block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        '''
        result = self._values.get("max_colors")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanMaxColors"]]], result)

    @builtins.property
    def mirror(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanMirror"]]]:
        '''mirror block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        '''
        result = self._values.get("mirror")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanMirror"]]], result)

    @builtins.property
    def mono_hue(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanMonoHue"]]]:
        '''mono_hue block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        '''
        result = self._values.get("mono_hue")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanMonoHue"]]], result)

    @builtins.property
    def opacity(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanOpacity"]]]:
        '''opacity block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanOpacity"]]], result)

    @builtins.property
    def region_of_interest_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanRegionOfInterestCrop"]]]:
        '''region_of_interest_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        '''
        result = self._values.get("region_of_interest_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanRegionOfInterestCrop"]]], result)

    @builtins.property
    def relative_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanRelativeCrop"]]]:
        '''relative_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        '''
        result = self._values.get("relative_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanRelativeCrop"]]], result)

    @builtins.property
    def remove_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanRemoveColor"]]]:
        '''remove_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        '''
        result = self._values.get("remove_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanRemoveColor"]]], result)

    @builtins.property
    def resize(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanResize"]]]:
        '''resize block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        '''
        result = self._values.get("resize")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanResize"]]], result)

    @builtins.property
    def rotate(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanRotate"]]]:
        '''rotate block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        '''
        result = self._values.get("rotate")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanRotate"]]], result)

    @builtins.property
    def scale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanScale"]]]:
        '''scale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanScale"]]], result)

    @builtins.property
    def shear(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanShear"]]]:
        '''shear block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        '''
        result = self._values.get("shear")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanShear"]]], result)

    @builtins.property
    def trim(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanTrim"]]]:
        '''trim block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        '''
        result = self._values.get("trim")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanTrim"]]], result)

    @builtins.property
    def unsharp_mask(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanUnsharpMask"]]]:
        '''unsharp_mask block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        result = self._values.get("unsharp_mask")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanUnsharpMask"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanAppend",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_priority": "gravityPriority",
        "gravity_priority_var": "gravityPriorityVar",
        "gravity_var": "gravityVar",
        "preserve_minor_dimension": "preserveMinorDimension",
        "preserve_minor_dimension_var": "preserveMinorDimensionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanAppend:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanAppendImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_priority: typing.Optional[builtins.str] = None,
        gravity_priority_var: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        preserve_minor_dimension: typing.Optional[builtins.str] = None,
        preserve_minor_dimension_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Specifies where to place the ``image`` relative to the source image. The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_priority: Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal. The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority DataAkamaiImagingPolicyImage#gravity_priority}
        :param gravity_priority_var: Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal. The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority_var DataAkamaiImagingPolicyImage#gravity_priority_var}
        :param gravity_var: Specifies where to place the ``image`` relative to the source image. The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param preserve_minor_dimension: Whether to preserve the source image's minor dimension, ``false`` by default. The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension DataAkamaiImagingPolicyImage#preserve_minor_dimension}
        :param preserve_minor_dimension_var: Whether to preserve the source image's minor dimension, ``false`` by default. The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension_var DataAkamaiImagingPolicyImage#preserve_minor_dimension_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanAppendImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cf65b1ce2927b9cfbd591ee37d136c9f2c15f6a6a6e7d115ce84e0e3d3673b34)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_priority", value=gravity_priority, expected_type=type_hints["gravity_priority"])
            check_type(argname="argument gravity_priority_var", value=gravity_priority_var, expected_type=type_hints["gravity_priority_var"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument preserve_minor_dimension", value=preserve_minor_dimension, expected_type=type_hints["preserve_minor_dimension"])
            check_type(argname="argument preserve_minor_dimension_var", value=preserve_minor_dimension_var, expected_type=type_hints["preserve_minor_dimension_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_priority is not None:
            self._values["gravity_priority"] = gravity_priority
        if gravity_priority_var is not None:
            self._values["gravity_priority_var"] = gravity_priority_var
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if preserve_minor_dimension is not None:
            self._values["preserve_minor_dimension"] = preserve_minor_dimension
        if preserve_minor_dimension_var is not None:
            self._values["preserve_minor_dimension_var"] = preserve_minor_dimension_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanAppendImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanAppendImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Specifies where to place the ``image`` relative to the source image.

        The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_priority(self) -> typing.Optional[builtins.str]:
        '''Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal.

        The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority DataAkamaiImagingPolicyImage#gravity_priority}
        '''
        result = self._values.get("gravity_priority")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_priority_var(self) -> typing.Optional[builtins.str]:
        '''Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal.

        The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority_var DataAkamaiImagingPolicyImage#gravity_priority_var}
        '''
        result = self._values.get("gravity_priority_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Specifies where to place the ``image`` relative to the source image.

        The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def preserve_minor_dimension(self) -> typing.Optional[builtins.str]:
        '''Whether to preserve the source image's minor dimension, ``false`` by default.

        The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension DataAkamaiImagingPolicyImage#preserve_minor_dimension}
        '''
        result = self._values.get("preserve_minor_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def preserve_minor_dimension_var(self) -> typing.Optional[builtins.str]:
        '''Whether to preserve the source image's minor dimension, ``false`` by default.

        The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension_var DataAkamaiImagingPolicyImage#preserve_minor_dimension_var}
        '''
        result = self._values.get("preserve_minor_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanAppend(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanAppendImage",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanAppendImage:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanAppendImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanAppendImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanAppendImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3e376e32c8ec0badcda041aa1d22acfd3704e35e49f1a58016a06b36747be679)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanAppendImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanAppendImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanAppendImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1706cefc9f87d15bd9328f1e4b6f9dd4af522a4d46cad9b3636a45a392478999)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanAppendList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanAppendList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5154de1d577e49cb309e00143695816d7513306de034d88fa4dbbe9b6aeca02c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanAppendOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc0a0a561827dd1c4f8cebdd6476289ceb7953f1281903c24967111aff1e709f)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanAppendOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__defd1876ea39114c2b1bc01b1e1cac87206eb9042f1035ae45718edc5e12a318)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a339b058394b546ab98b006d2ee5b9cd446ad5caeeecd4f1e3b9b6df1de6f043)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__354172a00692c231cdceadd474a5f505a58781f23d047ffa288896f8b3a2a322)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanAppend]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanAppend]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanAppend]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a282b3944cb82712bcf436e756bf31cbf5ea4141a8571b6d9827168065436a73)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanAppendOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanAppendOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d9c2c32b30c85de02fedb1f6d74bbd7e68b8621fdd3241e07c83c473a9a122cd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanAppendImage()

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityPriority")
    def reset_gravity_priority(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityPriority", []))

    @jsii.member(jsii_name="resetGravityPriorityVar")
    def reset_gravity_priority_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityPriorityVar", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPreserveMinorDimension")
    def reset_preserve_minor_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPreserveMinorDimension", []))

    @jsii.member(jsii_name="resetPreserveMinorDimensionVar")
    def reset_preserve_minor_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPreserveMinorDimensionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanAppendImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanAppendImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityInput")
    def gravity_priority_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityPriorityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityVarInput")
    def gravity_priority_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityPriorityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanAppendImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanAppendImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionInput")
    def preserve_minor_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "preserveMinorDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionVarInput")
    def preserve_minor_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "preserveMinorDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9697bdf05da1689fdecfe980605d2ca77582aeaabcca7fe0a0a6e56871078ce7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityPriority")
    def gravity_priority(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityPriority"))

    @gravity_priority.setter
    def gravity_priority(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1b5e92a6a0fcc15e2a07facec5278d108d1f146502b8e5f27ba804d071664767)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityPriority", value)

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityVar")
    def gravity_priority_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityPriorityVar"))

    @gravity_priority_var.setter
    def gravity_priority_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__acdde2ae6125b242b4266a2064e2b14e3db06df3e302bdef31638bdc9591b360)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityPriorityVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6af2c53f40a21884c91fbd47a2cd7b7d7d53f22a3ebd0d73f37f99c0c6f0c040)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimension")
    def preserve_minor_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "preserveMinorDimension"))

    @preserve_minor_dimension.setter
    def preserve_minor_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3f4f41a903b61bb7744c50d6776a1a17ca0eb57f4297d49905119219649f56a6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "preserveMinorDimension", value)

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionVar")
    def preserve_minor_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "preserveMinorDimensionVar"))

    @preserve_minor_dimension_var.setter
    def preserve_minor_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f42ec836108f177a0f6a8d7b1787ad24d11043c6a9756615078c9ce4e2febf6e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "preserveMinorDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanAppend]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanAppend]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanAppend]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__94d86251d8a25ae31fc6785bef0067ba2d5160a593c5e0aa40bd7fbca9266221)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanAspectCrop",
    jsii_struct_bases=[],
    name_mapping={
        "allow_expansion": "allowExpansion",
        "allow_expansion_var": "allowExpansionVar",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanAspectCrop:
    def __init__(
        self,
        *,
        allow_expansion: typing.Optional[builtins.str] = None,
        allow_expansion_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_expansion: Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image. Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        :param allow_expansion_var: Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image. Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        :param height: The height term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The width term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        :param x_position: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8c4ee8da701d585f1295732cfceec014784d60ba4d0b7c8e814a1b6be4530f8e)
            check_type(argname="argument allow_expansion", value=allow_expansion, expected_type=type_hints["allow_expansion"])
            check_type(argname="argument allow_expansion_var", value=allow_expansion_var, expected_type=type_hints["allow_expansion_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if allow_expansion is not None:
            self._values["allow_expansion"] = allow_expansion
        if allow_expansion_var is not None:
            self._values["allow_expansion_var"] = allow_expansion_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def allow_expansion(self) -> typing.Optional[builtins.str]:
        '''Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image.

        Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        '''
        result = self._values.get("allow_expansion")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def allow_expansion_var(self) -> typing.Optional[builtins.str]:
        '''Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image.

        Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        '''
        result = self._values.get("allow_expansion_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanAspectCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanAspectCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanAspectCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b61910ccffe65b3b48c5053322c42d7cde8f548cb5736fac8bdc09f141b8dbdc)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanAspectCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__59209539d2583f395c3023bca53579f811bfb5da5e4ceec68e9f2a9a0edb017e)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanAspectCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ea341dd0f0fafec2d5e4828014cd3c16556ff002c85f9d4e862fdc4584217bf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5512f1aa61f4c9a9dc96fa1b06a1a00a127c1bf700b8de1c7c3bc7709fcb8d33)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__30a3c28b72edbe51cdb7b53cd662dcfb16cf25b316f308f6cdbee9211d53759c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanAspectCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanAspectCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanAspectCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__792ed481657a9ae1833ba775a71297053da322729e2ceb32135175113d78ca1f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanAspectCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanAspectCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__785e55df4e5a4bc856f1ff69e486cf099c173f98a525f502ba751a541f61f46c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAllowExpansion")
    def reset_allow_expansion(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansion", []))

    @jsii.member(jsii_name="resetAllowExpansionVar")
    def reset_allow_expansion_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansionVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionInput")
    def allow_expansion_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVarInput")
    def allow_expansion_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansion")
    def allow_expansion(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansion"))

    @allow_expansion.setter
    def allow_expansion(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__97dc9b5afdde58f6ae2249306d7b956bb22a63393d43fa4bf47dabd6f5442bc7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansion", value)

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVar")
    def allow_expansion_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansionVar"))

    @allow_expansion_var.setter
    def allow_expansion_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f813f32cf96b32bf922208fef740fd7d066ebdf0e48379cac0866336fc2020b7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansionVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0566f7a7fdcb527abf922d8b6403c9414e8e0367b668f66cc549503e07a2f338)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__89824f4f5e5c0099491ad52cc9a794647a6d02c60c5ad11c68bfdbf7b4a52e9b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__779a48f607758935fbad0068c4405eff40216f0513d4fd9c731df4e1df9b406b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__db71976b10fdfa02d8eb1de6cad984d7b0558e0d451035e2f94b91b32df4d6b2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__50a90dc79b3357f68898bccc91e36d0593c3766b7aca7016fce0d00cb6c84721)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa5e8ab02a05d7ff1332de53899477aa448825f05dab9a082cefb4392856cf60)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ef18d30291908c39460b956df1424bec5e06193ad67cc2e246d8bc5e34764e0a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d6bc14d49c5b3d6fa4cfa74b37e625374a22f13a69f15ebdf73f8e31373a288)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanAspectCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanAspectCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanAspectCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4c741a040e3511d9995eb1ae0c404c34125e17d08faa4bb5513d83a4f646558b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanBackgroundColor",
    jsii_struct_bases=[],
    name_mapping={"color": "color", "color_var": "colorVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanBackgroundColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c12a07042f6d0ccb5a49ce895cc8a564a5e135eb6f6a382ea4faa46158afb9c1)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanBackgroundColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanBackgroundColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanBackgroundColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f3b3ef8293ab146190a815a6a75ed3a3aab7765801aba3871046c6add7a63690)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanBackgroundColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3892a296a17f905fe13d773bcd230ce9cb2a262d66bce121edabe49a6c6841fd)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanBackgroundColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__389a2078460160d4e9f237ff1e38f408cba73a58f71998f0b61edac4af539714)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__39a100930f49928f28e4298fc06a8fcf58f190fb3512b8a852ab1a600bcec92c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__28524850d33fdcd2fb4033fbbff4b3e2de391e78f08f07723b8ffb991f9b5a83)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanBackgroundColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanBackgroundColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b9907de70dd58f24fa0c1ce463b89470ae2de0aabd3c393e8057b2b7a0bf1e5b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanBackgroundColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanBackgroundColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1dbcd44b3ab1c091c83357daeceb28e4af7f3d11e87e427d293ee81a0a4a203e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__20f486ad82d783f871dc6d0d3f9a302b18b7e69a72f296fcbe485a27d837927e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d13bce9f19edf44c55f1a0fd22ef4cb8099c0cf6cf7ffe191d5ed279382bf81)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanBackgroundColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanBackgroundColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanBackgroundColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bfd4484623eb08905f5426977e5dc5dc5c41087c237d4dbd93ec351f0a996335)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanBlur",
    jsii_struct_bases=[],
    name_mapping={"sigma": "sigma", "sigma_var": "sigmaVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanBlur:
    def __init__(
        self,
        *,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param sigma: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b09ac50fc61d9ef3705eb2f8ed4dce746b68dcceb477eba86a6d75c82907434a)
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanBlur(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanBlurList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanBlurList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ddeb6ca7180a58f2fc3b784658e7e729ab43b5482524d92620b3d1e8af55f503)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanBlurOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__740a8e4da27f9f9ca6fbf38e207d5c86b7f2e6f357ef1a9368d6e603675d29d8)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanBlurOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4340b9f332069809c2f9a710d8d86a8563f404bc3fc713916bb2cbd7494ad224)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7b4bfaedc609d0179cbb181b597d6980ca4c07ac60de243afa310add19d7458d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7707819bff95463688aa3be1b8817c1c53fe040bf8b22df8d22564cc8fd4faca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanBlur]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanBlur]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__84316c7d90b1613861bf4a68e8b0691cdb9797e8e74f59e1f2797ba2bccfaa26)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanBlurOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanBlurOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fc6b724b2c58113d1160f65f4834a1825f267072e59ac1ccad75d02682e205b0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cadc4cb3013687787d8cf34f6602dc510ad59e2b9397460ee26664f43b26ac13)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b4b448757cded122373b514a3c59f0788f63bb6cf80095eb32d1220d7a844e15)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanBlur]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanBlur]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanBlur]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d02a4ea6b954f0af7db2452f2501b04b90b3ca5244b932b3e3bb7ddc4f6a854a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanChromaKey",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_feather": "hueFeather",
        "hue_feather_var": "hueFeatherVar",
        "hue_tolerance": "hueTolerance",
        "hue_tolerance_var": "hueToleranceVar",
        "hue_var": "hueVar",
        "lightness_feather": "lightnessFeather",
        "lightness_feather_var": "lightnessFeatherVar",
        "lightness_tolerance": "lightnessTolerance",
        "lightness_tolerance_var": "lightnessToleranceVar",
        "saturation_feather": "saturationFeather",
        "saturation_feather_var": "saturationFeatherVar",
        "saturation_tolerance": "saturationTolerance",
        "saturation_tolerance_var": "saturationToleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanChromaKey:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_feather: typing.Optional[builtins.str] = None,
        hue_feather_var: typing.Optional[builtins.str] = None,
        hue_tolerance: typing.Optional[builtins.str] = None,
        hue_tolerance_var: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness_feather: typing.Optional[builtins.str] = None,
        lightness_feather_var: typing.Optional[builtins.str] = None,
        lightness_tolerance: typing.Optional[builtins.str] = None,
        lightness_tolerance_var: typing.Optional[builtins.str] = None,
        saturation_feather: typing.Optional[builtins.str] = None,
        saturation_feather_var: typing.Optional[builtins.str] = None,
        saturation_tolerance: typing.Optional[builtins.str] = None,
        saturation_tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_feather: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        :param hue_feather_var: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        :param hue_tolerance: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        :param hue_tolerance_var: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        :param hue_var: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness_feather: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        :param lightness_feather_var: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        :param lightness_tolerance: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        :param lightness_tolerance_var: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        :param saturation_feather: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        :param saturation_feather_var: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        :param saturation_tolerance: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        :param saturation_tolerance_var: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__235779d74ba05104a162b416ca2ae66d36b7284cc59d8ee97cb03dc8594dd556)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_feather", value=hue_feather, expected_type=type_hints["hue_feather"])
            check_type(argname="argument hue_feather_var", value=hue_feather_var, expected_type=type_hints["hue_feather_var"])
            check_type(argname="argument hue_tolerance", value=hue_tolerance, expected_type=type_hints["hue_tolerance"])
            check_type(argname="argument hue_tolerance_var", value=hue_tolerance_var, expected_type=type_hints["hue_tolerance_var"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness_feather", value=lightness_feather, expected_type=type_hints["lightness_feather"])
            check_type(argname="argument lightness_feather_var", value=lightness_feather_var, expected_type=type_hints["lightness_feather_var"])
            check_type(argname="argument lightness_tolerance", value=lightness_tolerance, expected_type=type_hints["lightness_tolerance"])
            check_type(argname="argument lightness_tolerance_var", value=lightness_tolerance_var, expected_type=type_hints["lightness_tolerance_var"])
            check_type(argname="argument saturation_feather", value=saturation_feather, expected_type=type_hints["saturation_feather"])
            check_type(argname="argument saturation_feather_var", value=saturation_feather_var, expected_type=type_hints["saturation_feather_var"])
            check_type(argname="argument saturation_tolerance", value=saturation_tolerance, expected_type=type_hints["saturation_tolerance"])
            check_type(argname="argument saturation_tolerance_var", value=saturation_tolerance_var, expected_type=type_hints["saturation_tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_feather is not None:
            self._values["hue_feather"] = hue_feather
        if hue_feather_var is not None:
            self._values["hue_feather_var"] = hue_feather_var
        if hue_tolerance is not None:
            self._values["hue_tolerance"] = hue_tolerance
        if hue_tolerance_var is not None:
            self._values["hue_tolerance_var"] = hue_tolerance_var
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness_feather is not None:
            self._values["lightness_feather"] = lightness_feather
        if lightness_feather_var is not None:
            self._values["lightness_feather_var"] = lightness_feather_var
        if lightness_tolerance is not None:
            self._values["lightness_tolerance"] = lightness_tolerance
        if lightness_tolerance_var is not None:
            self._values["lightness_tolerance_var"] = lightness_tolerance_var
        if saturation_feather is not None:
            self._values["saturation_feather"] = saturation_feather
        if saturation_feather_var is not None:
            self._values["saturation_feather_var"] = saturation_feather_var
        if saturation_tolerance is not None:
            self._values["saturation_tolerance"] = saturation_tolerance
        if saturation_tolerance_var is not None:
            self._values["saturation_tolerance_var"] = saturation_tolerance_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        '''
        result = self._values.get("hue_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        '''
        result = self._values.get("hue_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        '''
        result = self._values.get("hue_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        '''
        result = self._values.get("hue_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        '''
        result = self._values.get("lightness_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        '''
        result = self._values.get("lightness_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        '''
        result = self._values.get("lightness_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        '''
        result = self._values.get("lightness_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        '''
        result = self._values.get("saturation_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        '''
        result = self._values.get("saturation_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        '''
        result = self._values.get("saturation_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        result = self._values.get("saturation_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanChromaKey(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanChromaKeyList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanChromaKeyList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d63fe95aed68f307675a97b9136e8f5f72f119f8dce9901ae43621d6ee00a640)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanChromaKeyOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd08321cae00a1b0c7c229da8acc0cf54a8b7ae1fa45808b0e15cf6171414228)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanChromaKeyOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7f0250b904f56442d3a9947e952edd5920d98d7799b531d6c146551b38874180)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__149f24b5b522280907e55e4786f4940d7ab08858bc32f3cb9d1ff8bf9642fb02)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4700a1bcdc0a8b67de71e63b6e83be258b3addb0f93e28db8fbfdf829575b8bd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanChromaKey]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanChromaKey]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ae8a5e969585105dde038d380b75b7f9d57fa313817c6590cfa02d9a22953eb4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanChromaKeyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanChromaKeyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__49a85e0923877ab07537d41dd145c537033a96ab162febad181873af17c7699c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueFeather")
    def reset_hue_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeather", []))

    @jsii.member(jsii_name="resetHueFeatherVar")
    def reset_hue_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeatherVar", []))

    @jsii.member(jsii_name="resetHueTolerance")
    def reset_hue_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueTolerance", []))

    @jsii.member(jsii_name="resetHueToleranceVar")
    def reset_hue_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueToleranceVar", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightnessFeather")
    def reset_lightness_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeather", []))

    @jsii.member(jsii_name="resetLightnessFeatherVar")
    def reset_lightness_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeatherVar", []))

    @jsii.member(jsii_name="resetLightnessTolerance")
    def reset_lightness_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessTolerance", []))

    @jsii.member(jsii_name="resetLightnessToleranceVar")
    def reset_lightness_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessToleranceVar", []))

    @jsii.member(jsii_name="resetSaturationFeather")
    def reset_saturation_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeather", []))

    @jsii.member(jsii_name="resetSaturationFeatherVar")
    def reset_saturation_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeatherVar", []))

    @jsii.member(jsii_name="resetSaturationTolerance")
    def reset_saturation_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationTolerance", []))

    @jsii.member(jsii_name="resetSaturationToleranceVar")
    def reset_saturation_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherInput")
    def hue_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVarInput")
    def hue_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceInput")
    def hue_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVarInput")
    def hue_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherInput")
    def lightness_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVarInput")
    def lightness_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceInput")
    def lightness_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVarInput")
    def lightness_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherInput")
    def saturation_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVarInput")
    def saturation_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceInput")
    def saturation_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVarInput")
    def saturation_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0d2976465f3f434b1e12b3eb8b64b5892f0696f25854a0347d2af6e7bee68ef2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeather")
    def hue_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeather"))

    @hue_feather.setter
    def hue_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1a607fa5ccca3584d22fbb461973ace0677494671d3fa3dd5d0a3db64cca5cc6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeather", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVar")
    def hue_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeatherVar"))

    @hue_feather_var.setter
    def hue_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__495fc5f728ed0f02d0226885fdae6dafdbbefed0ec30dcaf6e1dab4196f3003c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueTolerance")
    def hue_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueTolerance"))

    @hue_tolerance.setter
    def hue_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e87019476142a2ca1d1f4aedc385fa982c18b2beddf5c6050aaee23d3eaa2f00)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVar")
    def hue_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueToleranceVar"))

    @hue_tolerance_var.setter
    def hue_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__546dc79c9b14d2dcf42ec8cf5f2902c66fb9a0d202eadb270049f3a77068eebf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__72ebd50ce7611d9935bb077aad86a9c1f573fd80d381fb661dbb5d749e5b0410)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeather")
    def lightness_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeather"))

    @lightness_feather.setter
    def lightness_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7729b1069aca4c4c38a42adac6f24bc9df10cd8fbb229918e219b7542b270e76)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeather", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVar")
    def lightness_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeatherVar"))

    @lightness_feather_var.setter
    def lightness_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9f274f0a74f21a6f54c583b90f0b59b38dd1e15b2b1831d922016ca16a38aa70)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessTolerance")
    def lightness_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessTolerance"))

    @lightness_tolerance.setter
    def lightness_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__505f970c5eaa0d65daa41eba0a911e2a542ce4c029a41a63e16bee28bab1b283)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVar")
    def lightness_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessToleranceVar"))

    @lightness_tolerance_var.setter
    def lightness_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__374d62bc668ba759fdb559af54733eb4c07bf5ffdd78ecb0ac26d66aaa7d4a36)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeather")
    def saturation_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeather"))

    @saturation_feather.setter
    def saturation_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d8e52036281b722385d5cb45e26d231ac96af73b419fd2133329bbdaf19bf701)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeather", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVar")
    def saturation_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeatherVar"))

    @saturation_feather_var.setter
    def saturation_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__06546b6b303414632d9111db2f7ff7b693bbdfc628a0689e1a1996d00c7c692c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationTolerance")
    def saturation_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationTolerance"))

    @saturation_tolerance.setter
    def saturation_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d14a5521edc2c81dc5ff3b0c59a1e4ed5a3953b49a40ca864b3f95945ea80105)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVar")
    def saturation_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationToleranceVar"))

    @saturation_tolerance_var.setter
    def saturation_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bef90bff6b2c30d0829f700f7f51b70fbc042f57ec606478071dafecf2444620)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanChromaKey]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanChromaKey]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanChromaKey]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fca32b1a059ca2fe5d45d1650fc861a577ec00709de8d21c0cc5499ba4e08ee1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanComposite",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "placement": "placement",
        "placement_var": "placementVar",
        "scale": "scale",
        "scale_dimension": "scaleDimension",
        "scale_dimension_var": "scaleDimensionVar",
        "scale_var": "scaleVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanComposite:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanCompositeImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        placement: typing.Optional[builtins.str] = None,
        placement_var: typing.Optional[builtins.str] = None,
        scale: typing.Optional[builtins.str] = None,
        scale_dimension: typing.Optional[builtins.str] = None,
        scale_dimension_var: typing.Optional[builtins.str] = None,
        scale_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param placement: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        :param placement_var: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        :param scale: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param scale_dimension: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        :param scale_dimension_var: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        :param scale_var: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        :param x_position: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanCompositeImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d074566ddbda07f1ef02a2c37528285fb79fb1bb1ab04f1873f4661c6e32f892)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument placement", value=placement, expected_type=type_hints["placement"])
            check_type(argname="argument placement_var", value=placement_var, expected_type=type_hints["placement_var"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument scale_dimension", value=scale_dimension, expected_type=type_hints["scale_dimension"])
            check_type(argname="argument scale_dimension_var", value=scale_dimension_var, expected_type=type_hints["scale_dimension_var"])
            check_type(argname="argument scale_var", value=scale_var, expected_type=type_hints["scale_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if placement is not None:
            self._values["placement"] = placement
        if placement_var is not None:
            self._values["placement_var"] = placement_var
        if scale is not None:
            self._values["scale"] = scale
        if scale_dimension is not None:
            self._values["scale_dimension"] = scale_dimension
        if scale_dimension_var is not None:
            self._values["scale_dimension_var"] = scale_dimension_var
        if scale_var is not None:
            self._values["scale_var"] = scale_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanCompositeImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanCompositeImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        '''
        result = self._values.get("placement")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement_var(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        '''
        result = self._values.get("placement_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        '''
        result = self._values.get("scale_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        '''
        result = self._values.get("scale_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        '''
        result = self._values.get("scale_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanComposite(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanCompositeImage",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanCompositeImage:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanCompositeImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanCompositeImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanCompositeImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__137cfd4a6fa2cc1b40027a7d212e65496fc11365b1e342f7572c410a36f0b436)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanCompositeImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanCompositeImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__09fbec41028a488c1030522b34301068f371e3bc37136c7d98f80af12ede9bcc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanCompositeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanCompositeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f2e853f712c57866b275f9d15f825bb93325458d97b481cefd37a61447d34c14)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanCompositeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d9ee1ed281a2cf314a60e79093f9684845e9d5094a0b6c6d23c43ef803e805cc)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanCompositeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e6112c6d8958c93908d7cc0276202fa562c6ce327c98cebf84514e388bb95c3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0d3eb664f441885f603906317c9a72aae42adbc0362dab94209657c13cc4f21d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__607d9be580ee95a0acc3c1c62f52bc221750a7b1ac4c23f639d90ba7497e8a49)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanComposite]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanComposite]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f19850b4c26edc0e53fa1d20c5be50d0e72e2123850c2b2fd9a4a8c3fb0211b4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanCompositeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanCompositeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__99e02a96a6a91d386b02a27dc3c96d58fa61bb1a96c48d18d3cb42afeb406be9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanCompositeImage()

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPlacement")
    def reset_placement(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacement", []))

    @jsii.member(jsii_name="resetPlacementVar")
    def reset_placement_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacementVar", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetScaleDimension")
    def reset_scale_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimension", []))

    @jsii.member(jsii_name="resetScaleDimensionVar")
    def reset_scale_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimensionVar", []))

    @jsii.member(jsii_name="resetScaleVar")
    def reset_scale_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanCompositeImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanCompositeImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanCompositeImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="placementInput")
    def placement_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementInput"))

    @builtins.property
    @jsii.member(jsii_name="placementVarInput")
    def placement_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionInput")
    def scale_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVarInput")
    def scale_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleVarInput")
    def scale_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4aaa030b46c982f1aba6f8d0c561c6e153202ce3851a17dfed0d2b2c20107183)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__89e5ecee237ecdf2d69740ad7a533b0d16ac8be9ed9c0cc64ff3bb532a03f5d3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="placement")
    def placement(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placement"))

    @placement.setter
    def placement(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7895503a697445d581c1fd514c5796c39e476296da85a5319c70ecd043c0f54d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placement", value)

    @builtins.property
    @jsii.member(jsii_name="placementVar")
    def placement_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placementVar"))

    @placement_var.setter
    def placement_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fe7e8bdda860c92254fda93fe78ad42d9217251b0ad641938074ec2294858cc6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placementVar", value)

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scale"))

    @scale.setter
    def scale(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bf1eb3499b95513137389da5a9a1f813e7542b47f229239c034a4b2db969c6c0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scale", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimension")
    def scale_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimension"))

    @scale_dimension.setter
    def scale_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__09220b38c86e93fd99e4e379ae3805e51a5b5341c14aa912c956e0b23134e12c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimension", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVar")
    def scale_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimensionVar"))

    @scale_dimension_var.setter
    def scale_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7b887ed05240552342737e69418e8a8234438298dc7d94a66be4803e5146e24c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="scaleVar")
    def scale_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleVar"))

    @scale_var.setter
    def scale_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1b46f847461ba459756bad91b88613531460fee1fb1e08cc1cfa25c3b3ccc6dc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b5868a83f972179917034b2b7c10532644da930b52fb0537e2ebd67535a3e2f3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__28c3c56e4522ccaa7550d6c199086303b923e89057f52548663534b762feb206)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ef138749ad6ffeeeed72c1faa1c864d0274d9721552d57088edd8ad11b1e557)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9889d587be4b5d3e33893dddc0205de9aad40cd2a828867ee85f1afdb673a020)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanComposite]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanComposite]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanComposite]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8629962ee6252ed16eff503dc4c63b1667230df81aa52e9d09eb2345d437165a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanCompound",
    jsii_struct_bases=[],
    name_mapping={"transformations": "transformations"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanCompound:
    def __init__(
        self,
        *,
        transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param transformations: transformations block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b823844dc7da4ea90b6bbb6b3395c071b91c91258d26e5e927f272d939379fc1)
            check_type(argname="argument transformations", value=transformations, expected_type=type_hints["transformations"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if transformations is not None:
            self._values["transformations"] = transformations

    @builtins.property
    def transformations(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanCompoundTransformations"]]]:
        '''transformations block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        result = self._values.get("transformations")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanCompoundTransformations"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanCompound(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanCompoundList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanCompoundList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e98e77e52908ee0f39ad3b110baab96d06a9f9e8872a6496645b5428bf138791)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanCompoundOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__70034c93a4a2dfd5a86e6647328663fc4b6cd2c1eb9eaa32c75a7f80e9803b33)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanCompoundOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d6040cc2440ed2b99aa0d345386a7e3ec32baab694890ebe14afcea283eac3fb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e3b7b5fd61443bfafdddd6b07c6c89cee25905538c51b80be117ac99aa33ee78)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b7e59594e3462b6666a8b661b88be9098f3d35e8b826e4d7b1635e7e4b517005)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanCompound]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanCompound]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7161399b7891b11bbadac72d6104e74bef1c9c67b7ea4648377ab221f6e6230b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanCompoundOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanCompoundOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc45b01b7d661cdc5527c3fcdbe24d2d99660e64a09e55e0d60feaecdc4f90aa)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformations")
    def put_transformations(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__27639c51642625aae24d8590809cd550ce7f2437e1aa953193892dbec63cb99d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTransformations", [value]))

    @jsii.member(jsii_name="resetTransformations")
    def reset_transformations(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformations", []))

    @builtins.property
    @jsii.member(jsii_name="transformations")
    def transformations(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanCompoundTransformationsList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanCompoundTransformationsList", jsii.get(self, "transformations"))

    @builtins.property
    @jsii.member(jsii_name="transformationsInput")
    def transformations_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanCompoundTransformations"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanCompoundTransformations"]]], jsii.get(self, "transformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanCompound]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanCompound]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanCompound]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4bee80686c48ea474a095aed35ba94b68d4d6ff2091cc096daa5564cd7982c05)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanCompoundTransformations",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanCompoundTransformations:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanCompoundTransformations(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanCompoundTransformationsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanCompoundTransformationsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7cac961d009585da91bba5064d7bbae092c11493a6ea56bfdf5775c20eb1d781)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanCompoundTransformationsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1632c95412f5025d978fc9ebfe0569c2f952c50d7d9dde6c8631df6b9f286161)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanCompoundTransformationsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dcd9c142c4efec412c3eb353b7e85707ed337bda6e244a90584a5b3918caa501)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__249000dbebfcc7663966f5ed25e905f2a3e2764c91a22c47e71c4ca21e49c80f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a5f1d040a6f5b194fe4dcc2543cb49f02df01cd10731a3d3ecfc1520af0e53af)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanCompoundTransformations]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanCompoundTransformations]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanCompoundTransformations]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d202e7aff99c91c531f297ad37f11a950cebfe369a2b8af14aaac944b99645f4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanCompoundTransformationsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanCompoundTransformationsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d9b6d29c2497ac1cd8ef9cd8fc9677ddab2455e62364ecab3dbbdb99fcd3bb13)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanCompoundTransformations]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanCompoundTransformations]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanCompoundTransformations]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5d05a2d27ebf6f3e3d9a0f9192139f007d1b10b74f10ed266db29fb832d88a03)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanContrast",
    jsii_struct_bases=[],
    name_mapping={
        "brightness": "brightness",
        "brightness_var": "brightnessVar",
        "contrast": "contrast",
        "contrast_var": "contrastVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanContrast:
    def __init__(
        self,
        *,
        brightness: typing.Optional[builtins.str] = None,
        brightness_var: typing.Optional[builtins.str] = None,
        contrast: typing.Optional[builtins.str] = None,
        contrast_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param brightness: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        :param brightness_var: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        :param contrast: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param contrast_var: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8e768068461651cb8989687d6aaa3280fcd84e525c5a94e239fb37a6b3b4ceea)
            check_type(argname="argument brightness", value=brightness, expected_type=type_hints["brightness"])
            check_type(argname="argument brightness_var", value=brightness_var, expected_type=type_hints["brightness_var"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument contrast_var", value=contrast_var, expected_type=type_hints["contrast_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if brightness is not None:
            self._values["brightness"] = brightness
        if brightness_var is not None:
            self._values["brightness_var"] = brightness_var
        if contrast is not None:
            self._values["contrast"] = contrast
        if contrast_var is not None:
            self._values["contrast_var"] = contrast_var

    @builtins.property
    def brightness(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        '''
        result = self._values.get("brightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def brightness_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        '''
        result = self._values.get("brightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        result = self._values.get("contrast_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanContrast(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanContrastList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanContrastList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2065e4a819fc37519f4c12f283f7189d9cb0c1ca10f69464e25203fd828e2e69)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanContrastOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__459b526b705b2930586bb4869d771c23bad41658d5b66459932256d5a8421d68)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanContrastOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__daccbc22faed7e8c00374e61bfb27e6102401ad33f7425317c898014a69a4d01)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3de44f8c18acaecfd31a963ec5441b86ccb3ffef739cda70400321e331df2c4c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b84129fa46473894a61710960ec5c200e46f70a750cf9045aa170dbace4b4113)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanContrast]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanContrast]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__68a81035748bcc0cdce72ec6e6bd54e0585925c5babb78a557bb1293d6d46076)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanContrastOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanContrastOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5bfe506270ab3ba67a64a9cb51e3ff2434271b354b6be766ed6c8e1add052024)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetBrightness")
    def reset_brightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightness", []))

    @jsii.member(jsii_name="resetBrightnessVar")
    def reset_brightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightnessVar", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetContrastVar")
    def reset_contrast_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrastVar", []))

    @builtins.property
    @jsii.member(jsii_name="brightnessInput")
    def brightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="brightnessVarInput")
    def brightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastVarInput")
    def contrast_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="brightness")
    def brightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightness"))

    @brightness.setter
    def brightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5772ce3069510127af97ac3cdefc8c79802c14ce7814d9b0e96299251969ef3d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightness", value)

    @builtins.property
    @jsii.member(jsii_name="brightnessVar")
    def brightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightnessVar"))

    @brightness_var.setter
    def brightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af63a1b109f0d5ff00f52c80e763521b509fe8708be9eef57796d2c3b307f55d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrast"))

    @contrast.setter
    def contrast(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__54cb236f62d5e97e9240470754db35e5ddc49ffdbba1054bba1d50869112e7d1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrast", value)

    @builtins.property
    @jsii.member(jsii_name="contrastVar")
    def contrast_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrastVar"))

    @contrast_var.setter
    def contrast_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5352b6d6722c575ef3f0870addabc2e4cc5816abf6f41c043d070aced6e775fd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrastVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanContrast]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanContrast]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanContrast]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d5264abf91ed922728f96038f32ed14a03f0befc6fe280c5f79d6ab3e31b2bbe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanCrop",
    jsii_struct_bases=[],
    name_mapping={
        "allow_expansion": "allowExpansion",
        "allow_expansion_var": "allowExpansionVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanCrop:
    def __init__(
        self,
        *,
        allow_expansion: typing.Optional[builtins.str] = None,
        allow_expansion_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_expansion: If cropping an area outside of the existing canvas, expands the image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        :param allow_expansion_var: If cropping an area outside of the existing canvas, expands the image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        :param gravity: Frame of reference for X and Y Positions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Frame of reference for X and Y Positions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The number of pixels to crop along the y-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The number of pixels to crop along the y-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The number of pixels to crop along the x-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The number of pixels to crop along the x-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        :param x_position: The x-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__09fba282c9c0edd5584c1a5f8e06a8c765f492f6c2ba660b6c325c59d6dfa791)
            check_type(argname="argument allow_expansion", value=allow_expansion, expected_type=type_hints["allow_expansion"])
            check_type(argname="argument allow_expansion_var", value=allow_expansion_var, expected_type=type_hints["allow_expansion_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if allow_expansion is not None:
            self._values["allow_expansion"] = allow_expansion
        if allow_expansion_var is not None:
            self._values["allow_expansion_var"] = allow_expansion_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def allow_expansion(self) -> typing.Optional[builtins.str]:
        '''If cropping an area outside of the existing canvas, expands the image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        '''
        result = self._values.get("allow_expansion")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def allow_expansion_var(self) -> typing.Optional[builtins.str]:
        '''If cropping an area outside of the existing canvas, expands the image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        '''
        result = self._values.get("allow_expansion_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Frame of reference for X and Y Positions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Frame of reference for X and Y Positions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the y-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the y-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the x-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the x-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__52c9d728adc654b37117a573edb5e4d1a2b5ec90ff17c98737faa36759c5f03a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f44d8078e428ecab9884e7eccfec59b1c9eef89fcb14ec774c3fc273b268b0b)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__29d66089acde2aff17bfb3cf5e31a14673115be4240cbd97215c3461a1729eb3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__595dead67256b11ed2aa5f2f8f0ddf1ec3471570ce01c9d80363328a4b60e396)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0a76ef3f5e47ce22f406d7ae8037ee83392b6a52ae85cea85751cd5bf710b0de)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__79195da272bd1bc87f0de58abc4d16717d016bebc1b3f5bb44e7830c60e07906)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0b1dc8183fabf628f216df6d13f63e0c2cd0b2c4313be16137728a5ac8aeb681)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAllowExpansion")
    def reset_allow_expansion(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansion", []))

    @jsii.member(jsii_name="resetAllowExpansionVar")
    def reset_allow_expansion_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansionVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionInput")
    def allow_expansion_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVarInput")
    def allow_expansion_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansion")
    def allow_expansion(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansion"))

    @allow_expansion.setter
    def allow_expansion(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__46bfd975ce29c3da5a5595578d32ac76eaa924fae407ecdc7b1bd212eb7f9870)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansion", value)

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVar")
    def allow_expansion_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansionVar"))

    @allow_expansion_var.setter
    def allow_expansion_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ab74e24426936c9349337b5c1a3b765bd55dc5b255d8bbb1b0b217011ec4db7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansionVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__161c04f386d77632d7cb558fd30de3d2b91b2db6a1ab60275f57aa2e1747e945)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dbc18f7ab4cbe26407e8039fd9a8b351f7b2b5e793a2571cbcd8ff0fabfbafdf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a6cf42b56175fa836713da6037a955510e46d6196484b065c04920c5c2a57ace)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9acdf4cbe45612b6a2bd7b0fd92a8f6e95d7429210a77171fc9881d66ee4d4a4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f6b1d1526fac3cdbadb8d3d12f36a559b5b4a8795990e6f1eb1b187726aa9b50)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__559bddd0c58a8bba6566e2c855f299a6c23ed8897fdb7e96350e1605f0edd50d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df35c8accdd6c445fd03e6e2ba169cbafe48ca62dd60ae84429ad3ee25d6c7fd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__689e7a9ffba682cecdda25313991d4da5e5f2ee77921af71c95ecb14835a145b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f30666e8ce8ca5386381d1300d1bf3a5029f0a9abbd333ff6d87e0167e364e89)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1301ff57fdbcb4eee33f1250779611aa65c7c82fb2d81be38df5a4d3692ac484)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a061a9586776a33c6668b0416eee494dc2f3c0cd86c03ed4b892ad2263f43663)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanFaceCrop",
    jsii_struct_bases=[],
    name_mapping={
        "algorithm": "algorithm",
        "algorithm_var": "algorithmVar",
        "confidence": "confidence",
        "confidence_var": "confidenceVar",
        "fail_gravity": "failGravity",
        "fail_gravity_var": "failGravityVar",
        "focus": "focus",
        "focus_var": "focusVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "padding": "padding",
        "padding_var": "paddingVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanFaceCrop:
    def __init__(
        self,
        *,
        algorithm: typing.Optional[builtins.str] = None,
        algorithm_var: typing.Optional[builtins.str] = None,
        confidence: typing.Optional[builtins.str] = None,
        confidence_var: typing.Optional[builtins.str] = None,
        fail_gravity: typing.Optional[builtins.str] = None,
        fail_gravity_var: typing.Optional[builtins.str] = None,
        focus: typing.Optional[builtins.str] = None,
        focus_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param algorithm: Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm DataAkamaiImagingPolicyImage#algorithm}
        :param algorithm_var: Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm_var DataAkamaiImagingPolicyImage#algorithm_var}
        :param confidence: With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image. Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence DataAkamaiImagingPolicyImage#confidence}
        :param confidence_var: With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image. Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence_var DataAkamaiImagingPolicyImage#confidence_var}
        :param fail_gravity: Controls placement of the crop if Image and Video Manager does not detect any faces in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        :param fail_gravity_var: Controls placement of the crop if Image and Video Manager does not detect any faces in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        :param focus: Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus DataAkamaiImagingPolicyImage#focus}
        :param focus_var: Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus_var DataAkamaiImagingPolicyImage#focus_var}
        :param gravity: Controls placement of the crop. Directions are relative to the face(s) plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Controls placement of the crop. Directions are relative to the face(s) plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param padding: The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        :param style: Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d6ab9aa7c7325032aef07d7716fb776c381b85bd7349e94ccd609c857e8e0bfd)
            check_type(argname="argument algorithm", value=algorithm, expected_type=type_hints["algorithm"])
            check_type(argname="argument algorithm_var", value=algorithm_var, expected_type=type_hints["algorithm_var"])
            check_type(argname="argument confidence", value=confidence, expected_type=type_hints["confidence"])
            check_type(argname="argument confidence_var", value=confidence_var, expected_type=type_hints["confidence_var"])
            check_type(argname="argument fail_gravity", value=fail_gravity, expected_type=type_hints["fail_gravity"])
            check_type(argname="argument fail_gravity_var", value=fail_gravity_var, expected_type=type_hints["fail_gravity_var"])
            check_type(argname="argument focus", value=focus, expected_type=type_hints["focus"])
            check_type(argname="argument focus_var", value=focus_var, expected_type=type_hints["focus_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if algorithm is not None:
            self._values["algorithm"] = algorithm
        if algorithm_var is not None:
            self._values["algorithm_var"] = algorithm_var
        if confidence is not None:
            self._values["confidence"] = confidence
        if confidence_var is not None:
            self._values["confidence_var"] = confidence_var
        if fail_gravity is not None:
            self._values["fail_gravity"] = fail_gravity
        if fail_gravity_var is not None:
            self._values["fail_gravity_var"] = fail_gravity_var
        if focus is not None:
            self._values["focus"] = focus
        if focus_var is not None:
            self._values["focus_var"] = focus_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def algorithm(self) -> typing.Optional[builtins.str]:
        '''Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm DataAkamaiImagingPolicyImage#algorithm}
        '''
        result = self._values.get("algorithm")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def algorithm_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm_var DataAkamaiImagingPolicyImage#algorithm_var}
        '''
        result = self._values.get("algorithm_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def confidence(self) -> typing.Optional[builtins.str]:
        '''With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image.

        Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence DataAkamaiImagingPolicyImage#confidence}
        '''
        result = self._values.get("confidence")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def confidence_var(self) -> typing.Optional[builtins.str]:
        '''With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image.

        Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence_var DataAkamaiImagingPolicyImage#confidence_var}
        '''
        result = self._values.get("confidence_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any faces in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        '''
        result = self._values.get("fail_gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any faces in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        '''
        result = self._values.get("fail_gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def focus(self) -> typing.Optional[builtins.str]:
        '''Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus DataAkamaiImagingPolicyImage#focus}
        '''
        result = self._values.get("focus")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def focus_var(self) -> typing.Optional[builtins.str]:
        '''Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus_var DataAkamaiImagingPolicyImage#focus_var}
        '''
        result = self._values.get("focus_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the face(s) plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the face(s) plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanFaceCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanFaceCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanFaceCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d1ac7accd1cf1f5b1d206d5ddc0d4244d32bb8815fae8dda47c51daeba54921)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanFaceCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5d2dd12436133279c3cc6a5b30aacc28a369a1d75aa3dec488fb07c1abca4879)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanFaceCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cc90e529cb5a8ffa01244001483f2ae84b40cd160021511c493ed40f6243fcec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__010bb9c534c55a305a25881d400310bbbee3a5e7329e03f61ee17df804a5875a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0a7d72e53a528eaac3202bee3bbad7d56d1a95b25059bad54998867a8b8bad38)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanFaceCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanFaceCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanFaceCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d2c67a0fd14d66604f321cb4275b121a723d600e81e900103544c76dc03efa05)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanFaceCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanFaceCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__614e9381cb2ca64ae31d7d0c10fe3460211d6ca2a6bc9d7cdc45745475d19c3b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAlgorithm")
    def reset_algorithm(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAlgorithm", []))

    @jsii.member(jsii_name="resetAlgorithmVar")
    def reset_algorithm_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAlgorithmVar", []))

    @jsii.member(jsii_name="resetConfidence")
    def reset_confidence(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetConfidence", []))

    @jsii.member(jsii_name="resetConfidenceVar")
    def reset_confidence_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetConfidenceVar", []))

    @jsii.member(jsii_name="resetFailGravity")
    def reset_fail_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravity", []))

    @jsii.member(jsii_name="resetFailGravityVar")
    def reset_fail_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravityVar", []))

    @jsii.member(jsii_name="resetFocus")
    def reset_focus(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFocus", []))

    @jsii.member(jsii_name="resetFocusVar")
    def reset_focus_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFocusVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="algorithmInput")
    def algorithm_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "algorithmInput"))

    @builtins.property
    @jsii.member(jsii_name="algorithmVarInput")
    def algorithm_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "algorithmVarInput"))

    @builtins.property
    @jsii.member(jsii_name="confidenceInput")
    def confidence_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "confidenceInput"))

    @builtins.property
    @jsii.member(jsii_name="confidenceVarInput")
    def confidence_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "confidenceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityInput")
    def fail_gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityVarInput")
    def fail_gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="focusInput")
    def focus_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "focusInput"))

    @builtins.property
    @jsii.member(jsii_name="focusVarInput")
    def focus_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "focusVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="algorithm")
    def algorithm(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "algorithm"))

    @algorithm.setter
    def algorithm(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9e751dfe070090089d4f46b0a91a3bf94f33418828948349c8fdc863c1da638d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "algorithm", value)

    @builtins.property
    @jsii.member(jsii_name="algorithmVar")
    def algorithm_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "algorithmVar"))

    @algorithm_var.setter
    def algorithm_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d40747b337e5f5a706cba8c7e504838c8c492d39554cc8fa3e52b2f395ccd276)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "algorithmVar", value)

    @builtins.property
    @jsii.member(jsii_name="confidence")
    def confidence(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "confidence"))

    @confidence.setter
    def confidence(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b96a200f3bcb53cc07123fb38220b04dafc4f901754c9cab23bef6aa18288d5f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "confidence", value)

    @builtins.property
    @jsii.member(jsii_name="confidenceVar")
    def confidence_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "confidenceVar"))

    @confidence_var.setter
    def confidence_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__39971f70d7900731b6bbf440c585df6dc4a2e90fc67cf1f8d740b022da5a970c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "confidenceVar", value)

    @builtins.property
    @jsii.member(jsii_name="failGravity")
    def fail_gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravity"))

    @fail_gravity.setter
    def fail_gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__56f34e4a1a39ae70736b1145db0314acbff1873b519f78965001719756c24c9c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravity", value)

    @builtins.property
    @jsii.member(jsii_name="failGravityVar")
    def fail_gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravityVar"))

    @fail_gravity_var.setter
    def fail_gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4beff4e511235da87368c5090db937503b904ca48651675b6ede6b747a14e669)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="focus")
    def focus(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "focus"))

    @focus.setter
    def focus(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b851801020a96162bf79954249393aa3637ab27fd5d57953868e35e3b62336d7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "focus", value)

    @builtins.property
    @jsii.member(jsii_name="focusVar")
    def focus_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "focusVar"))

    @focus_var.setter
    def focus_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c1c6bb97bbd6d8712939494bf450ed882c92d81a0778f28057b3d73c8c12810f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "focusVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__86082a74da06fbcb5d023ab053735998462c87ac4a0f79acfe3c2fae762e14c3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__55f98e79dd8225190fa6b9b9a6c7fb71072155ab75959464a3be415752576e0c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e70346748a6f93f354688b7aa12a2bbd4dd829bbf2e925c857845499df0ae587)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a1ecfbed066f19b921f1a46469ff8986502575ce94b76ffb5edfef657e9917ce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea7f0f522be40bdef08102f81c5a7da6e4a87eae074e593ed53787f014a75990)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c76fa63cec338b345dedb5d029c382ffbfe47f09c5a7396112f436ec036cb96d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6497004f3363817d72f7c2df213081b9349b0603b90e3b84752de7f187c64df5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f5dfe2474481b85c963f0963462bd2ba4178e1aa74d5fad7e6742cf67eead02b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__822836acb86a7cfc517ee11ace0f41b6a8361509644941af50395caa5ded7769)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__027cfe103f3ee618bf4e83c86e9cd942d5f679a7a8d859a5cf0410af2a33551f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanFaceCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanFaceCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanFaceCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__284c684551dd6003fddaeadc31116e0cb7596eb746dac455101da3bf8faa9936)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanFeatureCrop",
    jsii_struct_bases=[],
    name_mapping={
        "fail_gravity": "failGravity",
        "fail_gravity_var": "failGravityVar",
        "feature_radius": "featureRadius",
        "feature_radius_var": "featureRadiusVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "max_features": "maxFeatures",
        "max_features_var": "maxFeaturesVar",
        "min_feature_quality": "minFeatureQuality",
        "min_feature_quality_var": "minFeatureQualityVar",
        "padding": "padding",
        "padding_var": "paddingVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanFeatureCrop:
    def __init__(
        self,
        *,
        fail_gravity: typing.Optional[builtins.str] = None,
        fail_gravity_var: typing.Optional[builtins.str] = None,
        feature_radius: typing.Optional[builtins.str] = None,
        feature_radius_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        max_features: typing.Optional[builtins.str] = None,
        max_features_var: typing.Optional[builtins.str] = None,
        min_feature_quality: typing.Optional[builtins.str] = None,
        min_feature_quality_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fail_gravity: Controls placement of the crop if Image and Video Manager does not detect any features in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        :param fail_gravity_var: Controls placement of the crop if Image and Video Manager does not detect any features in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        :param feature_radius: The size in pixels of the important features to search for. If identified, two features never appear closer together than this value, ``8.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius DataAkamaiImagingPolicyImage#feature_radius}
        :param feature_radius_var: The size in pixels of the important features to search for. If identified, two features never appear closer together than this value, ``8.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius_var DataAkamaiImagingPolicyImage#feature_radius_var}
        :param gravity: Controls placement of the crop. Directions are relative to the region of interest plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Controls placement of the crop. Directions are relative to the region of interest plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param max_features: The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features DataAkamaiImagingPolicyImage#max_features}
        :param max_features_var: The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features_var DataAkamaiImagingPolicyImage#max_features_var}
        :param min_feature_quality: Determines the minimum quality level of the feature identified. To consider a feature important, the feature needs to surpass this value. Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality DataAkamaiImagingPolicyImage#min_feature_quality}
        :param min_feature_quality_var: Determines the minimum quality level of the feature identified. To consider a feature important, the feature needs to surpass this value. Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality_var DataAkamaiImagingPolicyImage#min_feature_quality_var}
        :param padding: Adds space around the region of interest. The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: Adds space around the region of interest. The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        :param style: Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e065089cbd49e480e19a0fa44644ca163f90492a7e0c0dcc7d0195c8b38b84d2)
            check_type(argname="argument fail_gravity", value=fail_gravity, expected_type=type_hints["fail_gravity"])
            check_type(argname="argument fail_gravity_var", value=fail_gravity_var, expected_type=type_hints["fail_gravity_var"])
            check_type(argname="argument feature_radius", value=feature_radius, expected_type=type_hints["feature_radius"])
            check_type(argname="argument feature_radius_var", value=feature_radius_var, expected_type=type_hints["feature_radius_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument max_features", value=max_features, expected_type=type_hints["max_features"])
            check_type(argname="argument max_features_var", value=max_features_var, expected_type=type_hints["max_features_var"])
            check_type(argname="argument min_feature_quality", value=min_feature_quality, expected_type=type_hints["min_feature_quality"])
            check_type(argname="argument min_feature_quality_var", value=min_feature_quality_var, expected_type=type_hints["min_feature_quality_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fail_gravity is not None:
            self._values["fail_gravity"] = fail_gravity
        if fail_gravity_var is not None:
            self._values["fail_gravity_var"] = fail_gravity_var
        if feature_radius is not None:
            self._values["feature_radius"] = feature_radius
        if feature_radius_var is not None:
            self._values["feature_radius_var"] = feature_radius_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if max_features is not None:
            self._values["max_features"] = max_features
        if max_features_var is not None:
            self._values["max_features_var"] = max_features_var
        if min_feature_quality is not None:
            self._values["min_feature_quality"] = min_feature_quality
        if min_feature_quality_var is not None:
            self._values["min_feature_quality_var"] = min_feature_quality_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def fail_gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any features in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        '''
        result = self._values.get("fail_gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any features in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        '''
        result = self._values.get("fail_gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feature_radius(self) -> typing.Optional[builtins.str]:
        '''The size in pixels of the important features to search for.

        If identified, two features never appear closer together than this value, ``8.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius DataAkamaiImagingPolicyImage#feature_radius}
        '''
        result = self._values.get("feature_radius")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feature_radius_var(self) -> typing.Optional[builtins.str]:
        '''The size in pixels of the important features to search for.

        If identified, two features never appear closer together than this value, ``8.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius_var DataAkamaiImagingPolicyImage#feature_radius_var}
        '''
        result = self._values.get("feature_radius_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the region of interest plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the region of interest plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def max_features(self) -> typing.Optional[builtins.str]:
        '''The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features DataAkamaiImagingPolicyImage#max_features}
        '''
        result = self._values.get("max_features")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def max_features_var(self) -> typing.Optional[builtins.str]:
        '''The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features_var DataAkamaiImagingPolicyImage#max_features_var}
        '''
        result = self._values.get("max_features_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def min_feature_quality(self) -> typing.Optional[builtins.str]:
        '''Determines the minimum quality level of the feature identified.

        To consider a feature important, the feature needs to surpass this value.  Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality DataAkamaiImagingPolicyImage#min_feature_quality}
        '''
        result = self._values.get("min_feature_quality")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def min_feature_quality_var(self) -> typing.Optional[builtins.str]:
        '''Determines the minimum quality level of the feature identified.

        To consider a feature important, the feature needs to surpass this value.  Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality_var DataAkamaiImagingPolicyImage#min_feature_quality_var}
        '''
        result = self._values.get("min_feature_quality_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''Adds space around the region of interest.

        The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''Adds space around the region of interest.

        The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanFeatureCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanFeatureCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanFeatureCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8d6644319513e2f90234620ea60c374c57208b17bdad86d87d2382e8e366a6bc)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanFeatureCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d37707c61163e35d41f1e2584257e57731478db984ac904e0c71ffcc59473d14)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanFeatureCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__010090f1134a1c4a5038d76bc106d1b42ae23fae604771d30f12a3587bbc0d8f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0bde8d388cbb96a717af0f8cd5e3cf608ac8441b4d36d525a71f51caa55bd9c7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__94efad3775d50775ad5f27cf41af55d408acd7840e2a31d57bd2936a2b1e833e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanFeatureCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanFeatureCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanFeatureCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1d296a3cc220e26f5c1addc5513f0fc7995e1ec62c595ae37a43835be8063f68)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanFeatureCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanFeatureCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c51b3aeb59d853a3a1576b414ef9baaa79ae9f51921493f5275c323e48733ed5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetFailGravity")
    def reset_fail_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravity", []))

    @jsii.member(jsii_name="resetFailGravityVar")
    def reset_fail_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravityVar", []))

    @jsii.member(jsii_name="resetFeatureRadius")
    def reset_feature_radius(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureRadius", []))

    @jsii.member(jsii_name="resetFeatureRadiusVar")
    def reset_feature_radius_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureRadiusVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetMaxFeatures")
    def reset_max_features(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxFeatures", []))

    @jsii.member(jsii_name="resetMaxFeaturesVar")
    def reset_max_features_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxFeaturesVar", []))

    @jsii.member(jsii_name="resetMinFeatureQuality")
    def reset_min_feature_quality(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMinFeatureQuality", []))

    @jsii.member(jsii_name="resetMinFeatureQualityVar")
    def reset_min_feature_quality_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMinFeatureQualityVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="failGravityInput")
    def fail_gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityVarInput")
    def fail_gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featureRadiusInput")
    def feature_radius_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featureRadiusInput"))

    @builtins.property
    @jsii.member(jsii_name="featureRadiusVarInput")
    def feature_radius_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featureRadiusVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesInput")
    def max_features_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "maxFeaturesInput"))

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesVarInput")
    def max_features_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "maxFeaturesVarInput"))

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityInput")
    def min_feature_quality_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "minFeatureQualityInput"))

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityVarInput")
    def min_feature_quality_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "minFeatureQualityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravity")
    def fail_gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravity"))

    @fail_gravity.setter
    def fail_gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__95665bdd0ec4abb18aea2407318b17c2367d3d47d2bdd96ef23266ebba2e793e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravity", value)

    @builtins.property
    @jsii.member(jsii_name="failGravityVar")
    def fail_gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravityVar"))

    @fail_gravity_var.setter
    def fail_gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a98b1f270bc346ed4355cf5f2f9d963b956018f0c4fe0e294bb8f1a49bed422f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="featureRadius")
    def feature_radius(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featureRadius"))

    @feature_radius.setter
    def feature_radius(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__abc6c79507425e25f52fb16fa70c2c4f4fc40c28a3f5bdc0cd0ec9c4452fb1fa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featureRadius", value)

    @builtins.property
    @jsii.member(jsii_name="featureRadiusVar")
    def feature_radius_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featureRadiusVar"))

    @feature_radius_var.setter
    def feature_radius_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa4253df53584d31568afd739d6c34e0abb412f9d65553dd3f3c4efb9b536c7e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featureRadiusVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ad55dbcc1bbab410205bb127118825da380dbe12bcc88aa4c993ba97acebf413)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9b769129b6657cf2208915e7efe3c4cf7e1b60b21c5c4d40f14e8b2aa2424926)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8ce795898e139c0343f4ec9368530052eeccadaebae392829e7f6ba86d963f9c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c93eb616b2d9e94df8d551743a6ddf8e0dd31fa6ba7e3e72721971f7a7601b01)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="maxFeatures")
    def max_features(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "maxFeatures"))

    @max_features.setter
    def max_features(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__046abef66676de4add5031d535ab1c84b4f85c4195f293411bc9dc9ffe6bfdff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "maxFeatures", value)

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesVar")
    def max_features_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "maxFeaturesVar"))

    @max_features_var.setter
    def max_features_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__787937c7a07029aa90bb19246e962b5210a96dce774fdbb62ad83925807a55c6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "maxFeaturesVar", value)

    @builtins.property
    @jsii.member(jsii_name="minFeatureQuality")
    def min_feature_quality(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "minFeatureQuality"))

    @min_feature_quality.setter
    def min_feature_quality(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d60a56597b3d5253535f733b8d349f7ffc2d4a8ecd40eff3bb157bf58546cd2f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "minFeatureQuality", value)

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityVar")
    def min_feature_quality_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "minFeatureQualityVar"))

    @min_feature_quality_var.setter
    def min_feature_quality_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d23e7f1deae568a7cf5717ab1e76635d8483663d672ecaa7b8c4cb28c296c419)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "minFeatureQualityVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0f6d7186aad8fb43f2f59159abf99370eda82c7e3005376d85277853f8c8e007)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__28214947b3aee227b02e68aa91b62f3f336b206cfbe43c0538117f8b38857d3d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__256f5aebfe1cf29d4aaff1683219943bfa0115e4fba914834c407d7d5d3fe69b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e818865511c588075bd19c66625ff3f4e06c90465a30270250432015cdafeb8d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__17487ed1c38727a65caf08b1304384ca07ffaf95f3b011f1a561cf8b338d2eb4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fe4804fe4b7472854bdba96ba007538863f6dff3e061670e83f2735cd7403d1a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanFeatureCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanFeatureCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanFeatureCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__61d5fe4ad7e0e668977e9bc9117f4fdbfd9c6b6cec90b61556c6ce535469564a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanFitAndFill",
    jsii_struct_bases=[],
    name_mapping={
        "fill_transformation": "fillTransformation",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanFitAndFill:
    def __init__(
        self,
        *,
        fill_transformation: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanFitAndFillFillTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fill_transformation: fill_transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_transformation DataAkamaiImagingPolicyImage#fill_transformation}
        :param height: The height value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The width value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(fill_transformation, dict):
            fill_transformation = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanFitAndFillFillTransformation(**fill_transformation)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5bebce284efb0cf2f65af90b58d206ffe9115fa1aa748dfff3691e8bf71941c2)
            check_type(argname="argument fill_transformation", value=fill_transformation, expected_type=type_hints["fill_transformation"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fill_transformation is not None:
            self._values["fill_transformation"] = fill_transformation
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def fill_transformation(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanFitAndFillFillTransformation"]:
        '''fill_transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_transformation DataAkamaiImagingPolicyImage#fill_transformation}
        '''
        result = self._values.get("fill_transformation")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanFitAndFillFillTransformation"], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanFitAndFill(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanFitAndFillFillTransformation",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanFitAndFillFillTransformation:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanFitAndFillFillTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanFitAndFillFillTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanFitAndFillFillTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fd53bd8b48abff26b49fbd492ca54c66d379419817a2692e68990cc479615854)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanFitAndFillFillTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanFitAndFillFillTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanFitAndFillFillTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__91edfd3411dab86631a66777b580e1228bff268ce3851d074333ecf3dcae5a67)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanFitAndFillList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanFitAndFillList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8ec6f8c8f8114c2eb6860816bc6dd790445a19111e7a2a006542477ec608ddfe)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanFitAndFillOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0618d0517238a138c6d917dedd0cfc1ffac5204e13517d04ffc58ee23a73d623)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanFitAndFillOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8fbede664b0fefc9f6e175f31332e186830e5a48d82ac86dad3d248c4d0dc965)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__16eb4984b38cbf8f56a93a6b222f064eea4b05704dce81308c2f3caadc8b18f8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__56a7ec99b8f8d6f60fca94ac4e6be48c7c98a8ae1ab1622b487e95cae5e01db0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanFitAndFill]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanFitAndFill]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanFitAndFill]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0370a3a242b94e448b7d0ffe2a50cbca42ce6b331efb20d718b7e71a2375a924)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanFitAndFillOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanFitAndFillOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ca13e3dff4923da32e16489b6d5b58f95d52f80f5cc9245a3e9f4aef759c10c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putFillTransformation")
    def put_fill_transformation(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanFitAndFillFillTransformation()

        return typing.cast(None, jsii.invoke(self, "putFillTransformation", [value]))

    @jsii.member(jsii_name="resetFillTransformation")
    def reset_fill_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFillTransformation", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="fillTransformation")
    def fill_transformation(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanFitAndFillFillTransformationOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanFitAndFillFillTransformationOutputReference, jsii.get(self, "fillTransformation"))

    @builtins.property
    @jsii.member(jsii_name="fillTransformationInput")
    def fill_transformation_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanFitAndFillFillTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanFitAndFillFillTransformation], jsii.get(self, "fillTransformationInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4b5826ac08b6b52a8b1677468f7a20a43c930ff3e46273d1534e3ba16b8e785a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__84ef705365721942d4f2dc2543cc8b2e244cbd0d089feea8454f40a99f0d82c3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7839eca006885ee2f7820ab3d42e32edf07cf9745768201398a99ac621ea613d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__91605e02e3524365e1b33585345e6c84af8db6a6925d02ecd135257ca029d049)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanFitAndFill]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanFitAndFill]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanFitAndFill]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df29191484c16df2a6210fe24ece6fd403f0004cc7ff4ea7cc7b9761b8cdfd75)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanGoop",
    jsii_struct_bases=[],
    name_mapping={
        "chaos": "chaos",
        "chaos_var": "chaosVar",
        "density": "density",
        "density_var": "densityVar",
        "power": "power",
        "power_var": "powerVar",
        "seed": "seed",
        "seed_var": "seedVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanGoop:
    def __init__(
        self,
        *,
        chaos: typing.Optional[builtins.str] = None,
        chaos_var: typing.Optional[builtins.str] = None,
        density: typing.Optional[builtins.str] = None,
        density_var: typing.Optional[builtins.str] = None,
        power: typing.Optional[builtins.str] = None,
        power_var: typing.Optional[builtins.str] = None,
        seed: typing.Optional[builtins.str] = None,
        seed_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param chaos: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        :param chaos_var: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        :param density: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        :param density_var: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        :param power: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        :param power_var: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        :param seed: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        :param seed_var: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d0c7055f70973bb08ade9f00570bcc0012c2067166f62c4d78810f78cf1d2d4a)
            check_type(argname="argument chaos", value=chaos, expected_type=type_hints["chaos"])
            check_type(argname="argument chaos_var", value=chaos_var, expected_type=type_hints["chaos_var"])
            check_type(argname="argument density", value=density, expected_type=type_hints["density"])
            check_type(argname="argument density_var", value=density_var, expected_type=type_hints["density_var"])
            check_type(argname="argument power", value=power, expected_type=type_hints["power"])
            check_type(argname="argument power_var", value=power_var, expected_type=type_hints["power_var"])
            check_type(argname="argument seed", value=seed, expected_type=type_hints["seed"])
            check_type(argname="argument seed_var", value=seed_var, expected_type=type_hints["seed_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if chaos is not None:
            self._values["chaos"] = chaos
        if chaos_var is not None:
            self._values["chaos_var"] = chaos_var
        if density is not None:
            self._values["density"] = density
        if density_var is not None:
            self._values["density_var"] = density_var
        if power is not None:
            self._values["power"] = power
        if power_var is not None:
            self._values["power_var"] = power_var
        if seed is not None:
            self._values["seed"] = seed
        if seed_var is not None:
            self._values["seed_var"] = seed_var

    @builtins.property
    def chaos(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        '''
        result = self._values.get("chaos")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def chaos_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        '''
        result = self._values.get("chaos_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        '''
        result = self._values.get("density")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density_var(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        '''
        result = self._values.get("density_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        '''
        result = self._values.get("power")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power_var(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        '''
        result = self._values.get("power_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        '''
        result = self._values.get("seed")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed_var(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        result = self._values.get("seed_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanGoop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanGoopList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanGoopList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0c5cf7adcc7213aadb28625edbf08d425219f0def67614f444f6d24c0560d883)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanGoopOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c21784abef0be0b0cce622d8a0b512b287f6483e760beedfbdfa1a9390a2564e)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanGoopOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c2ef9fdbb0c8bd196c7c22aa350d6415d5b55ac0b7cbab609321094b5f0da5d7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fe0dc8ff3bde3858d3303f434b47a0f10a2f8d31d1d80f3260b077c694c724e0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a8a91786889ddb6c834afdbe303180352177c90c8a3ce28fa61b04cf5cf37e38)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanGoop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanGoop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a88cd833880c91d59075a381051b6b04a8bf8095d68b8d9328734e4d3f226c1a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanGoopOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanGoopOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5e2bb15eb2f02c5b07aaff78575491483e0f92b7cbfa6c7b2299d8928c4a0ebf)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetChaos")
    def reset_chaos(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaos", []))

    @jsii.member(jsii_name="resetChaosVar")
    def reset_chaos_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaosVar", []))

    @jsii.member(jsii_name="resetDensity")
    def reset_density(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensity", []))

    @jsii.member(jsii_name="resetDensityVar")
    def reset_density_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensityVar", []))

    @jsii.member(jsii_name="resetPower")
    def reset_power(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPower", []))

    @jsii.member(jsii_name="resetPowerVar")
    def reset_power_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPowerVar", []))

    @jsii.member(jsii_name="resetSeed")
    def reset_seed(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeed", []))

    @jsii.member(jsii_name="resetSeedVar")
    def reset_seed_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeedVar", []))

    @builtins.property
    @jsii.member(jsii_name="chaosInput")
    def chaos_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosInput"))

    @builtins.property
    @jsii.member(jsii_name="chaosVarInput")
    def chaos_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosVarInput"))

    @builtins.property
    @jsii.member(jsii_name="densityInput")
    def density_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityInput"))

    @builtins.property
    @jsii.member(jsii_name="densityVarInput")
    def density_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="powerInput")
    def power_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerInput"))

    @builtins.property
    @jsii.member(jsii_name="powerVarInput")
    def power_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerVarInput"))

    @builtins.property
    @jsii.member(jsii_name="seedInput")
    def seed_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedInput"))

    @builtins.property
    @jsii.member(jsii_name="seedVarInput")
    def seed_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedVarInput"))

    @builtins.property
    @jsii.member(jsii_name="chaos")
    def chaos(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaos"))

    @chaos.setter
    def chaos(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8578965530ab36471ef6852200a5b74410ff642f5308cdce2d059d2c5f5e26a0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaos", value)

    @builtins.property
    @jsii.member(jsii_name="chaosVar")
    def chaos_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaosVar"))

    @chaos_var.setter
    def chaos_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1a9498783f055894b77734cf99bd029b900cc0ee70884c59ab1da96f30a131d7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaosVar", value)

    @builtins.property
    @jsii.member(jsii_name="density")
    def density(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "density"))

    @density.setter
    def density(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c352705e648b9ee01bd0bdae5a4ff070cae222df8b0de8d3720d085d625acaf0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "density", value)

    @builtins.property
    @jsii.member(jsii_name="densityVar")
    def density_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "densityVar"))

    @density_var.setter
    def density_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__da438d67374c24038c72cf2540b59c00ce1b6e5ea61ad37387084663e13e241b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "densityVar", value)

    @builtins.property
    @jsii.member(jsii_name="power")
    def power(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "power"))

    @power.setter
    def power(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d3dacc9416f779e5762dcb80b4b7c06a1d13213ba06b0e32189d1cbe31ae1825)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "power", value)

    @builtins.property
    @jsii.member(jsii_name="powerVar")
    def power_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "powerVar"))

    @power_var.setter
    def power_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__97e2f79edb52bbef1537b66142611fad11b4aafa8c285412c0934c3e99f17148)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "powerVar", value)

    @builtins.property
    @jsii.member(jsii_name="seed")
    def seed(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seed"))

    @seed.setter
    def seed(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__03670d1812fd7ac066da673c022aa4ab926db2d9062f740b69ae25fc9f808ab2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seed", value)

    @builtins.property
    @jsii.member(jsii_name="seedVar")
    def seed_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seedVar"))

    @seed_var.setter
    def seed_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d78835d6ab3a84ddcc1fd364c38eecd6dcd61ad01c0cafb9c9aed5a913573cb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seedVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanGoop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanGoop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanGoop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fb5663b47cb8c553515a764cd22c90b602722faac691240156f182dd3a5519dd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanGrayscale",
    jsii_struct_bases=[],
    name_mapping={"type": "type", "type_var": "typeVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanGrayscale:
    def __init__(
        self,
        *,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param type: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__06a3745a5ff8f4525b10fadfad7145ff0ae53661e25e2afd2de12c4a4599ef36)
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanGrayscale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanGrayscaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanGrayscaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__20b14d65e8269fab8cd3bcee73d96b56b5193022857d4017c05069f8e0bf1345)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanGrayscaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4647f8095889d570f5a2a90b1ce1683d3e09312ac72cff53d5c154995d878ffb)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanGrayscaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1d7df6d9b0ab12a64f2f5011b2d58c7c97da71853d9891cdd99af17daf5f734a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0995ef42625fcf4d31ad3327a819de4e6cd700d73e37b6bce179e217fcdabc94)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3b3cbcf3b5fb4d552d3e99c06c5de5370647d3a75a48e237f69a3eb55106a674)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanGrayscale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanGrayscale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8c4702eb128d5b57a315631e869c9a005fccdbc0e9c2aee11fd39a5f5f896190)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanGrayscaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanGrayscaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__718f3051d5b307377e2e8ba12d843181f202d55a16d46b781927f62072f3f12d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bf8999b1c60f7a9833fe6c8c7eb474621da50711e4296489fc1c1a55271c36eb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__073eb34c18394336be0ad229e02632725e9ee2511611d44f680687a161d106e8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanGrayscale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanGrayscale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanGrayscale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__800defec664fa72d83f94e2bb475ba800fcb714532dfd9da0e3ddaea814a25d9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanHsl",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "lightness": "lightness",
        "lightness_var": "lightnessVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanHsl:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness: typing.Optional[builtins.str] = None,
        lightness_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        :param lightness_var: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__71230722e31c939b4deacf937bdb96eae95f756c92a2fd459b7d3b73c1e9ba98)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness", value=lightness, expected_type=type_hints["lightness"])
            check_type(argname="argument lightness_var", value=lightness_var, expected_type=type_hints["lightness_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness is not None:
            self._values["lightness"] = lightness
        if lightness_var is not None:
            self._values["lightness_var"] = lightness_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        '''
        result = self._values.get("lightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        '''
        result = self._values.get("lightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanHsl(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanHslList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanHslList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a9b11823f6396662319e99a4c5e7cbb774d99debcc552871e91477ff040c90dc)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanHslOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bbf7a5148ca8d6c7ba908145ca61c4ce47a1bfee3f5e7b0b4f798c649c67b589)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanHslOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__847caee70a4381c0f1b12ff42302421efb99b42bcb2e515d5a38b10498fa485f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__86740d7bb41609bdecfa7ffd614b96f9d4d0513bbb9d26ce97049b8ab727c7f7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c138a6b6fa4e1c04781b0092e60a7c8684feb2b1f3e9c67d1272ba99918449e0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanHsl]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanHsl]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df36326966afade54bfb0624a99ba06e4766c0be95dbdc9480fb8797ab992361)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanHslOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanHslOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8cecc7c1fb56b64e3eea7a757b364a8fdfe0a3d66b678440d2fc8439c7fb12c2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightness")
    def reset_lightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightness", []))

    @jsii.member(jsii_name="resetLightnessVar")
    def reset_lightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessInput")
    def lightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessVarInput")
    def lightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9fdb722e92eff0136e5ecf5181ebb7f471f745917a7042018e71972d06448c66)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3bb527d3f798341d42c5dbc2785198148620b6e2858050e3ec0c770a771cd949)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightness")
    def lightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightness"))

    @lightness.setter
    def lightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aeca946e2a599980215d6691e5646ab419dfbc18748cc693e4ce3a02f07261ae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightness", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessVar")
    def lightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessVar"))

    @lightness_var.setter
    def lightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd0d67eb2678dd981823fe7edf9b5179b70ee852ba55988965d5fd96e3bc0746)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ed2ddb1f7885fdbf8f9a935fde8d8c89f34309a31a3deb74d5272cb0756adb4d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ed8ee42993510703318808cab4fe274cc6f0348fc8084798a39d31be97f32c38)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanHsl]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanHsl]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanHsl]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ec64c9f31c63a60aa96e9e5e8aeb77efacb56d95db211219f3c8b3fb5d79c53)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanHsv",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanHsv:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        :param value: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1dd28f9ac0ffa0547f9b4c4177845a48c5c51212c4d3bdad8566007bae5b0196)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanHsv(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanHsvList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanHsvList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f31d563eda5a4d4d0d53f5444c67ce6d75214261837a61c3929bedf8b2b85f28)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanHsvOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__880e397c5578b214f4e33bcd904b5e326cc77d666e0732c7634e64010ed817fa)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanHsvOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9e45a6759051f8223f5608cf5439b835947cd9bff4dfc9c46256260711b16b9f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b8fd20dcf128d9a5222253bc46837627d6c82e94b0c044d95664a2f73cae5c2d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d10e829eba9326bd177a8de5abca5e4f1e1b1145a8cc2c7099b9abc37e38f8a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanHsv]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanHsv]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f48170519e10fe8ed52b604f29281c97510e1169a86fce823baeebbbb6fc54a8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanHsvOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanHsvOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0d6132f8080bdc49db724c4eb3a8af91f261428fbe58e1644411554a4fac1be2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab50954c96c49824ad09288f24db00daa131babbac0422524f6e0d3b86516703)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e7ff362efe59d23305638dbadf69e72e03dcce38b3379cecddebce06ba09b186)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__17fd34424eb1d740fc9c065fa4b8b90578c6743cef6d9249560efb04e3d1e69c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f78a13faf002cdd95989a180a4f0495b41a61cb54d5dba1e0d4cd211f7154adb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cfa0d58300696c63b865c7da07cb48b2488da9d8598997c580af42f8eeb1c4c1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__facc5b813b1f0e13223056d7ede8126e8f2ec812cc96d049584311250d08a3d2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanHsv]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanHsv]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanHsv]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c2120d6a37527e8f7bac626b72580b802b9d52649ac25e97886bec165866e649)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimension",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "dimension": "dimension",
        "dimension_var": "dimensionVar",
        "equal": "equal",
        "greater_than": "greaterThan",
        "less_than": "lessThan",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimension:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        dimension: typing.Optional[builtins.str] = None,
        dimension_var: typing.Optional[builtins.str] = None,
        equal: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionEqual", typing.Dict[builtins.str, typing.Any]]] = None,
        greater_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionGreaterThan", typing.Dict[builtins.str, typing.Any]]] = None,
        less_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionLessThan", typing.Dict[builtins.str, typing.Any]]] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param dimension: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        :param dimension_var: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        :param equal: equal block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        :param greater_than: greater_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        :param less_than: less_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        :param value: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionDefault(**default)
        if isinstance(equal, dict):
            equal = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionEqual(**equal)
        if isinstance(greater_than, dict):
            greater_than = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionGreaterThan(**greater_than)
        if isinstance(less_than, dict):
            less_than = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionLessThan(**less_than)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c643102d25a29cf49e4894a42c96e0b5dbf57e6cbd90592a86c1b9b52eae9c5b)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument dimension", value=dimension, expected_type=type_hints["dimension"])
            check_type(argname="argument dimension_var", value=dimension_var, expected_type=type_hints["dimension_var"])
            check_type(argname="argument equal", value=equal, expected_type=type_hints["equal"])
            check_type(argname="argument greater_than", value=greater_than, expected_type=type_hints["greater_than"])
            check_type(argname="argument less_than", value=less_than, expected_type=type_hints["less_than"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if dimension is not None:
            self._values["dimension"] = dimension
        if dimension_var is not None:
            self._values["dimension_var"] = dimension_var
        if equal is not None:
            self._values["equal"] = equal
        if greater_than is not None:
            self._values["greater_than"] = greater_than
        if less_than is not None:
            self._values["less_than"] = less_than
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionDefault"], result)

    @builtins.property
    def dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        '''
        result = self._values.get("dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        '''
        result = self._values.get("dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def equal(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionEqual"]:
        '''equal block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        '''
        result = self._values.get("equal")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionEqual"], result)

    @builtins.property
    def greater_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionGreaterThan"]:
        '''greater_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        '''
        result = self._values.get("greater_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionGreaterThan"], result)

    @builtins.property
    def less_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionLessThan"]:
        '''less_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        '''
        result = self._values.get("less_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionLessThan"], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimension(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__941505d8c61250146ebcebcb6465c9a357f40e418e772c69542add4a05824df1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fd947ea50565602e81745d8a6b0f4f8086a98f123ea5fc8519a2325e8f03251b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionEqual",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionEqual:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionEqual(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionEqualOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionEqualOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ed8c5c75952edad3a74d271655d26867c4ee12d93629199d2e78a59138572718)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionEqual], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionEqual],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__37de267da463aee0f6805204a80ffd676e90653d8b4598b6aa2cff959d9c3bf4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionGreaterThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionGreaterThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionGreaterThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionGreaterThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionGreaterThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d51c5a70083d7a986ef600b8fd295a75a1fb7a007adc0d3df708589af3c6bb87)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionGreaterThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionGreaterThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__997ed51758e9e8ef29e1ce22c9a06aa7c6758cf06be5db15fa691608bba33fe3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionLessThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionLessThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionLessThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionLessThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionLessThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4e659221de4b89b06d7a270cd3e89f91549e4004a3bab6a6c0e5494e735aa4a0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionLessThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionLessThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2b154610b8a8ddebd27506b7d6a3380d702a094091e0a3e7cea9971075f99422)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__40ada009f54fa9c99705499ab23047bf45a4bbd07a48c5d5f13419a24f2fa177)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e90b440a8a8b3df0a6f31a4945a7089259389b88bd352946a4e1db9c7145a692)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__99bbce56b35cf0046d6cbbc5b08875d32df1f7e3d4adaa345d7698713ac4e331)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b68db3fd0914f7de51ccff178c23106b3e7fdc794853e542a8bdc9654d827cb1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3be9874615b4e5dbaef68cbda0ea9a3f80a73a0472e74662cac73203db24a8a2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimension]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimension]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8b4e11a18e6c44d7f45dcd67064c3860e414664aa2cc52c7ba1651cfe0c389ea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__438c7670968626c5693d653da8c773efd159711c1bc7d6e2b4e64268c1e9d9f2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putEqual")
    def put_equal(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionEqual()

        return typing.cast(None, jsii.invoke(self, "putEqual", [value]))

    @jsii.member(jsii_name="putGreaterThan")
    def put_greater_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionGreaterThan()

        return typing.cast(None, jsii.invoke(self, "putGreaterThan", [value]))

    @jsii.member(jsii_name="putLessThan")
    def put_less_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionLessThan()

        return typing.cast(None, jsii.invoke(self, "putLessThan", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetDimension")
    def reset_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimension", []))

    @jsii.member(jsii_name="resetDimensionVar")
    def reset_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimensionVar", []))

    @jsii.member(jsii_name="resetEqual")
    def reset_equal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEqual", []))

    @jsii.member(jsii_name="resetGreaterThan")
    def reset_greater_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGreaterThan", []))

    @jsii.member(jsii_name="resetLessThan")
    def reset_less_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLessThan", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="equal")
    def equal(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionEqualOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionEqualOutputReference, jsii.get(self, "equal"))

    @builtins.property
    @jsii.member(jsii_name="greaterThan")
    def greater_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionGreaterThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionGreaterThanOutputReference, jsii.get(self, "greaterThan"))

    @builtins.property
    @jsii.member(jsii_name="lessThan")
    def less_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionLessThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionLessThanOutputReference, jsii.get(self, "lessThan"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionInput")
    def dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionVarInput")
    def dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="equalInput")
    def equal_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionEqual], jsii.get(self, "equalInput"))

    @builtins.property
    @jsii.member(jsii_name="greaterThanInput")
    def greater_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionGreaterThan], jsii.get(self, "greaterThanInput"))

    @builtins.property
    @jsii.member(jsii_name="lessThanInput")
    def less_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionLessThan], jsii.get(self, "lessThanInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="dimension")
    def dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimension"))

    @dimension.setter
    def dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d0e07c80a13383b78ce4416fe42f26f47782f93dc487cb3d6d2b3e5ddd1e7af)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimension", value)

    @builtins.property
    @jsii.member(jsii_name="dimensionVar")
    def dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimensionVar"))

    @dimension_var.setter
    def dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9e204e69385bc2d1214c6e86abf30eacaa46e969bef58d3000457c083cc4556a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8416afd1440d7ce1d31705532b9dfbaa990400b6c09491accf5213204f02893a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__16c93d857ba80701573334d5c4f9e5b69d732ee9daeea3f8411c78f399db65c4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimension]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimension]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimension]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2fc4bcc445b4cd2abc9a436f2a852bf55dc362cfc3dfec8b270ac664e23294bd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientation",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "landscape": "landscape",
        "portrait": "portrait",
        "square": "square",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientation:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        landscape: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationLandscape", typing.Dict[builtins.str, typing.Any]]] = None,
        portrait: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationPortrait", typing.Dict[builtins.str, typing.Any]]] = None,
        square: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationSquare", typing.Dict[builtins.str, typing.Any]]] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param landscape: landscape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        :param portrait: portrait block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        :param square: square block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationDefault(**default)
        if isinstance(landscape, dict):
            landscape = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationLandscape(**landscape)
        if isinstance(portrait, dict):
            portrait = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationPortrait(**portrait)
        if isinstance(square, dict):
            square = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationSquare(**square)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c15006f40e0d584deca271f8646a7a524fb7fb65a5d415462a4d2783ba50e8e7)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument landscape", value=landscape, expected_type=type_hints["landscape"])
            check_type(argname="argument portrait", value=portrait, expected_type=type_hints["portrait"])
            check_type(argname="argument square", value=square, expected_type=type_hints["square"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if landscape is not None:
            self._values["landscape"] = landscape
        if portrait is not None:
            self._values["portrait"] = portrait
        if square is not None:
            self._values["square"] = square

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationDefault"], result)

    @builtins.property
    def landscape(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationLandscape"]:
        '''landscape block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        '''
        result = self._values.get("landscape")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationLandscape"], result)

    @builtins.property
    def portrait(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationPortrait"]:
        '''portrait block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        '''
        result = self._values.get("portrait")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationPortrait"], result)

    @builtins.property
    def square(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationSquare"]:
        '''square block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        result = self._values.get("square")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationSquare"], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9e765e931bb3d84fcfea9ae7ffc8bf79c93bc81885feaa969943eef9e43dc070)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__def074f42bb0007c3f3f529b396638818d40d58a252a22c0fe4a2a31bb5b1841)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationLandscape",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationLandscape:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationLandscape(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationLandscapeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationLandscapeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__92cc029dc52c3c47d63295929b9b8d85287f27c18edcda501a9b2a548e50e568)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationLandscape], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationLandscape],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a3f9ca5174d698a87906d1aa1ed32faf65b81d9a2e1f717dfd275315afdfd65f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__692e67fbe2ac94ace3ce4848eacaee85fe22e7aab36edce983c25850a8ab93eb)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8c8e30ba6a20f23410f1fa9c2065cb2963b97f6cd7590742a3486c7f827ff63a)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f0712df6f04b7ee788188b8bf804abc09a235bdf7c5c6b2002d2e29295e600ea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c417da9ae1941c8e5f425b458d4fc6c7dca885fd583519f3996149c55f3156b9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__16b0a1d5c65043b7c2e97634a16498f15f3bbf3665bb66e49cf6b02c7c5e9a7d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientation]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientation]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__731d71a2e72e7195cbe086cd01c41fae8ec631d21ec0e3bc85acdf4a10706164)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__429530c2166fef18da338092c76430ad0c9fbad4ff7aa74b437f87e3e89ff8ca)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putLandscape")
    def put_landscape(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationLandscape()

        return typing.cast(None, jsii.invoke(self, "putLandscape", [value]))

    @jsii.member(jsii_name="putPortrait")
    def put_portrait(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationPortrait()

        return typing.cast(None, jsii.invoke(self, "putPortrait", [value]))

    @jsii.member(jsii_name="putSquare")
    def put_square(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationSquare()

        return typing.cast(None, jsii.invoke(self, "putSquare", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetLandscape")
    def reset_landscape(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLandscape", []))

    @jsii.member(jsii_name="resetPortrait")
    def reset_portrait(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPortrait", []))

    @jsii.member(jsii_name="resetSquare")
    def reset_square(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSquare", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="landscape")
    def landscape(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationLandscapeOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationLandscapeOutputReference, jsii.get(self, "landscape"))

    @builtins.property
    @jsii.member(jsii_name="portrait")
    def portrait(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationPortraitOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationPortraitOutputReference", jsii.get(self, "portrait"))

    @builtins.property
    @jsii.member(jsii_name="square")
    def square(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationSquareOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationSquareOutputReference", jsii.get(self, "square"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="landscapeInput")
    def landscape_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationLandscape], jsii.get(self, "landscapeInput"))

    @builtins.property
    @jsii.member(jsii_name="portraitInput")
    def portrait_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationPortrait"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationPortrait"], jsii.get(self, "portraitInput"))

    @builtins.property
    @jsii.member(jsii_name="squareInput")
    def square_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationSquare"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationSquare"], jsii.get(self, "squareInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientation]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientation]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientation]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a09d6fba79dc9e75dee68b640081fb41b5269550180bcf3345b953d2ae3dcb9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationPortrait",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationPortrait:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationPortrait(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationPortraitOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationPortraitOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f0bbfea1a7de801e2d506d65f050e2f03688271bee0208e45d8ed2641b0f98bd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationPortrait]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationPortrait], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationPortrait],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4b664e4d0cfd4db933dc24bc6d33bf9187873250c0aa748d001c7bc7ffaddd18)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationSquare",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationSquare:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationSquare(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationSquareOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationSquareOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__17e63728c05b12ff6f03bf1af038327c986520ab8b3dee956223d1344092d780)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationSquare]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationSquare], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationSquare],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__36fc645b1c989a4fd123291e45fc419205eb323f47ce6e0342c951b0839ea022)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanImQuery",
    jsii_struct_bases=[],
    name_mapping={
        "allowed_transformations": "allowedTransformations",
        "query_var": "queryVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanImQuery:
    def __init__(
        self,
        *,
        allowed_transformations: typing.Sequence[builtins.str],
        query_var: builtins.str,
    ) -> None:
        '''
        :param allowed_transformations: Specifies the transformations that can be applied using the query string parameter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allowed_transformations DataAkamaiImagingPolicyImage#allowed_transformations}
        :param query_var: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#query_var DataAkamaiImagingPolicyImage#query_var}.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d2c8d41d60385c4f06e70e65de19024982090019e9cb0f7996a118130c94dbb7)
            check_type(argname="argument allowed_transformations", value=allowed_transformations, expected_type=type_hints["allowed_transformations"])
            check_type(argname="argument query_var", value=query_var, expected_type=type_hints["query_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "allowed_transformations": allowed_transformations,
            "query_var": query_var,
        }

    @builtins.property
    def allowed_transformations(self) -> typing.List[builtins.str]:
        '''Specifies the transformations that can be applied using the query string parameter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allowed_transformations DataAkamaiImagingPolicyImage#allowed_transformations}
        '''
        result = self._values.get("allowed_transformations")
        assert result is not None, "Required property 'allowed_transformations' is missing"
        return typing.cast(typing.List[builtins.str], result)

    @builtins.property
    def query_var(self) -> builtins.str:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#query_var DataAkamaiImagingPolicyImage#query_var}.'''
        result = self._values.get("query_var")
        assert result is not None, "Required property 'query_var' is missing"
        return typing.cast(builtins.str, result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanImQuery(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanImQueryList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanImQueryList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__24f350d47967994d1d30db4a42aca701ba6b7ec5f1a4ee58d2f0570e31430fa3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanImQueryOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__347810b47ec8f910c85451c6a9f28111df67e6e6f463f7dbb3b5482ed903a43b)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanImQueryOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a3f3989819edbbfcc78c754ece386595ee320c0d10d659ed397e05ced901d279)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dffb184d107aeb12b1c49b49c38b3417112de70060ca0924777b0b6a3b79c729)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6329f5f9520de8f03dc5c1f59e8256ae420e883452fd6bac168b8ccccee01cca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanImQuery]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanImQuery]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanImQuery]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__24aa50d4c60abf6b583148b5b335ba68b74b376c8e178f48dbb2fc22817f84d0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanImQueryOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanImQueryOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__69e9624e1eccb9034f8181e7f0f37d1bff6ff3dc7d73fb3ca7ea1af175553e05)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @builtins.property
    @jsii.member(jsii_name="allowedTransformationsInput")
    def allowed_transformations_input(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "allowedTransformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="queryVarInput")
    def query_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "queryVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowedTransformations")
    def allowed_transformations(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "allowedTransformations"))

    @allowed_transformations.setter
    def allowed_transformations(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__527a1be36ee2dcd17ab6e5cd5151f22317933d3eaa5f8b2299a923ae5f35a9ee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowedTransformations", value)

    @builtins.property
    @jsii.member(jsii_name="queryVar")
    def query_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "queryVar"))

    @query_var.setter
    def query_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__82a881a677e952ed1220ba285113286b8d10ebc8222b74e4a996087e5cf9ab59)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "queryVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanImQuery]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanImQuery]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanImQuery]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c3390ef38f52ff2ecd7138eabe90b503dee28bcc3f6c9d50c5d069b3b95f6988)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanMaxColors",
    jsii_struct_bases=[],
    name_mapping={"colors": "colors", "colors_var": "colorsVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanMaxColors:
    def __init__(
        self,
        *,
        colors: typing.Optional[builtins.str] = None,
        colors_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param colors: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        :param colors_var: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__92ed7042f33be238781858d2278382e4b090518e5fb3dbc36d74409220b80edb)
            check_type(argname="argument colors", value=colors, expected_type=type_hints["colors"])
            check_type(argname="argument colors_var", value=colors_var, expected_type=type_hints["colors_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if colors is not None:
            self._values["colors"] = colors
        if colors_var is not None:
            self._values["colors_var"] = colors_var

    @builtins.property
    def colors(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        '''
        result = self._values.get("colors")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def colors_var(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        result = self._values.get("colors_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanMaxColors(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanMaxColorsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanMaxColorsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e3f3daa9b0843de936e271ccaafd237ee87dbc42e4ffa7da5fd970300a3b0094)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanMaxColorsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__872964d38fd03a792dd0332e18603ab24067cb9b6dc4b322f37f8a242e17f1e1)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanMaxColorsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__234390c42cc92047028e80a677c2d38d3254ebf1a0c249c2b420ed418b2d7880)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f34eb838bdcc840d7219e57f4c41e218dba02a537da2d6f957c85d7d237c1bfa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c886ba512db6b9964345d271086e8dc2fd6e6a164c82fd15a1170c7ef8d489d3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanMaxColors]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanMaxColors]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a64a23f1a2d90b769cf03711869454fb5ccae9ff48c8944838bee2ab70bb2a96)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanMaxColorsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanMaxColorsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2e9b35c055c9c7289dd7a185db9d3d44a72dbecd30978f82a1323965b6539d60)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColors")
    def reset_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColors", []))

    @jsii.member(jsii_name="resetColorsVar")
    def reset_colors_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorsVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorsInput")
    def colors_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsInput"))

    @builtins.property
    @jsii.member(jsii_name="colorsVarInput")
    def colors_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsVarInput"))

    @builtins.property
    @jsii.member(jsii_name="colors")
    def colors(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colors"))

    @colors.setter
    def colors(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ed81b31b9124fea96687d5b959416b3e37d8cf6b24003cbe4c829fed791f698b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colors", value)

    @builtins.property
    @jsii.member(jsii_name="colorsVar")
    def colors_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorsVar"))

    @colors_var.setter
    def colors_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa1965af36d80ae30033b3ffb46ea58b22c08eebdb05c0e592cfcb771c726750)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorsVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanMaxColors]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanMaxColors]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanMaxColors]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2cce6e1a978abfde59f1f63835eea41fd02db129ff93512717f67469d56fcc16)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanMirror",
    jsii_struct_bases=[],
    name_mapping={
        "horizontal": "horizontal",
        "horizontal_var": "horizontalVar",
        "vertical": "vertical",
        "vertical_var": "verticalVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanMirror:
    def __init__(
        self,
        *,
        horizontal: typing.Optional[builtins.str] = None,
        horizontal_var: typing.Optional[builtins.str] = None,
        vertical: typing.Optional[builtins.str] = None,
        vertical_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param horizontal: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        :param horizontal_var: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        :param vertical: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        :param vertical_var: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ce6c767925cf74b9f0a26bf941ebcde2e73d7e3c16980fc4a368588a95271b31)
            check_type(argname="argument horizontal", value=horizontal, expected_type=type_hints["horizontal"])
            check_type(argname="argument horizontal_var", value=horizontal_var, expected_type=type_hints["horizontal_var"])
            check_type(argname="argument vertical", value=vertical, expected_type=type_hints["vertical"])
            check_type(argname="argument vertical_var", value=vertical_var, expected_type=type_hints["vertical_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if horizontal is not None:
            self._values["horizontal"] = horizontal
        if horizontal_var is not None:
            self._values["horizontal_var"] = horizontal_var
        if vertical is not None:
            self._values["vertical"] = vertical
        if vertical_var is not None:
            self._values["vertical_var"] = vertical_var

    @builtins.property
    def horizontal(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        '''
        result = self._values.get("horizontal")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def horizontal_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        '''
        result = self._values.get("horizontal_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        '''
        result = self._values.get("vertical")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        result = self._values.get("vertical_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanMirror(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanMirrorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanMirrorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__baa1ffe7b7092428de27d9e48f6f76cb848ebafbae62ac882918b344059891a5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanMirrorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b53abd3a78123a99fbf9843fd3e0edffcd7d662d82649d7c17f9277a113cfed4)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanMirrorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__720c35fb209d452424848abf09aa7a2b0afaa908dfa8eb00b4c41b5119b3bd03)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a4946bf8ea7d4279651aefa9c9224328161b71164205c6f0516b1d419486b8ee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a16481b7839701e8996d4fd85b03f891b39209785d6cea9abd3dae0b0f303129)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanMirror]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanMirror]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__beb4adaf1bbe54da96086542a05fb075b6c3cfba206047de7a84bb0578f52e4b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanMirrorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanMirrorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fe73fa98d26701aa0a9b137e1933589541558339786c854d0e285f5623df22f7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHorizontal")
    def reset_horizontal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontal", []))

    @jsii.member(jsii_name="resetHorizontalVar")
    def reset_horizontal_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontalVar", []))

    @jsii.member(jsii_name="resetVertical")
    def reset_vertical(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVertical", []))

    @jsii.member(jsii_name="resetVerticalVar")
    def reset_vertical_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVerticalVar", []))

    @builtins.property
    @jsii.member(jsii_name="horizontalInput")
    def horizontal_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontalVarInput")
    def horizontal_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalInput")
    def vertical_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalVarInput")
    def vertical_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontal")
    def horizontal(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontal"))

    @horizontal.setter
    def horizontal(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b63ceae050b86f1b4fd7fe2cb28f43596043ed8a57da4ecf86921ed3db7d16d6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontal", value)

    @builtins.property
    @jsii.member(jsii_name="horizontalVar")
    def horizontal_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontalVar"))

    @horizontal_var.setter
    def horizontal_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ca04632f6f4eb668fd0c34c9351b836af658e626bcb2950d7fc3316381271268)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontalVar", value)

    @builtins.property
    @jsii.member(jsii_name="vertical")
    def vertical(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "vertical"))

    @vertical.setter
    def vertical(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__97395cee7b76688e02d39fe47a54a92c2660539aa943400b345f4695fa92d780)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "vertical", value)

    @builtins.property
    @jsii.member(jsii_name="verticalVar")
    def vertical_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "verticalVar"))

    @vertical_var.setter
    def vertical_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5def3b9d760ae763270b395d18ff6677dbe9e6e9a53d283fd90d137c066a12a3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "verticalVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanMirror]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanMirror]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanMirror]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2dd686ba218a7e73ae07805f28df95b62935dc92f3cd2b814a481ac7215cb7ae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanMonoHue",
    jsii_struct_bases=[],
    name_mapping={"hue": "hue", "hue_var": "hueVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanMonoHue:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c70b22c709f88b7bc38077ecdcff7baded6ff46defedbb2b851357ae91386edc)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanMonoHue(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanMonoHueList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanMonoHueList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__242a7b1f844afe9d1bf8b29e337b88a2df1b1ee81e61f894381ce17e2192d878)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanMonoHueOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3689b42369b3b11f0e9a284f0e73c3ea46ec24500d5a55052c7d13d99a2417f4)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanMonoHueOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d4951c5d0e12d2458da348904072c803c5145b26cfdbb22fb69918d5a4f943be)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4cf1ec11f42992e550104b04cdb26f6d6cd41ba33b4e59f09b38499555ce93ff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3910f2b77ead774eb1379a89dc7319379fa7435d93c545bf5d4189f098d2284d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanMonoHue]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanMonoHue]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d30280c9f241938548f6cbbdf971b08d242f6c8ca24b68d439f0f511ad99af0e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanMonoHueOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanMonoHueOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a6c044a7de3f8b343a9f9f6d22ce475e2cbe9f5f7c8e12b9e7991af47ba0eb56)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5324f4b7302022c5a32687214879e608d5a68fbdc957c4cd169eaa0f06182bdb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ffdd64adda75565b74c7e3259cc747d7017aa0f6877c0035a58a9caca0a7dbe4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanMonoHue]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanMonoHue]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanMonoHue]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ff10dcd57451654d55f23c16339d8df6bf560c2196b5a866dd03076518da3f2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanOpacity",
    jsii_struct_bases=[],
    name_mapping={"opacity": "opacity", "opacity_var": "opacityVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanOpacity:
    def __init__(
        self,
        *,
        opacity: typing.Optional[builtins.str] = None,
        opacity_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param opacity: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param opacity_var: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8deac2a309cc8db539f7137deb054308ffc0140986a0b2dac72bd551d52564ba)
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument opacity_var", value=opacity_var, expected_type=type_hints["opacity_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if opacity is not None:
            self._values["opacity"] = opacity
        if opacity_var is not None:
            self._values["opacity_var"] = opacity_var

    @builtins.property
    def opacity(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def opacity_var(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        result = self._values.get("opacity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanOpacity(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanOpacityList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanOpacityList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc3fd25faaa01a3616f29d79b22e09d27045dbc30410d5e8a9f850fb485648c5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanOpacityOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c56e15477d1d8b34938e3cf71bd88fcd7f1cb2b1bda852207be2e1ba7b1542e0)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanOpacityOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__15a66ad3344c5989d7da7fd169fad26302ee58c353d086101050c9f3ed4ac0b1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__66914066d22ca98495d60f80eb14c42228227792a051e6bfc5ba071a34b4e88b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8e45628400700d41efe5af722c2874d9ed5c47a42fcf87b9dc1c9331eda12a23)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanOpacity]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanOpacity]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e4debf45591d71e9ee497c43e4fe0d657307917c6dbefc9f9c333236121f0f47)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanOpacityOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanOpacityOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__71bc710289e1625a6818e6555b867544a8605cccb282320d9bfe01dfefd7ad87)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetOpacityVar")
    def reset_opacity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacityVar", []))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityVarInput")
    def opacity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacity"))

    @opacity.setter
    def opacity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aa1568b06c3ce32904b223c4a44ff189d280c45cd3fcc2082b3947f1e5beeac9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacity", value)

    @builtins.property
    @jsii.member(jsii_name="opacityVar")
    def opacity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacityVar"))

    @opacity_var.setter
    def opacity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__abded29739ba231d9ab31754956a69a12a250ab4437d34aca4054b7fb82c9532)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacityVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanOpacity]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanOpacity]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanOpacity]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__64b5a8196b91602d948d2ecb4050c6143e9cc129cee55e0a928b8fbcb7df6b52)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__27d30c59803850691b8e52fe9bbae39b684da3d3708ab25433956d2c2077f19a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putAppend")
    def put_append(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanAppend, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c57e5c5b2897355d2c150aeec00580ef3cbb056fbe483deba3b7ab8c3890ba72)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putAppend", [value]))

    @jsii.member(jsii_name="putAspectCrop")
    def put_aspect_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanAspectCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__82a6e472162401f4c2b38c4f702fe9d3c475b3380903edeef207749e7664112e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putAspectCrop", [value]))

    @jsii.member(jsii_name="putBackgroundColor")
    def put_background_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b2c04838dd32aeac778d802403a0b9cc030d2f80354428b42557a3eaafc79a8b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBackgroundColor", [value]))

    @jsii.member(jsii_name="putBlur")
    def put_blur(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanBlur, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f128242a90a4f61501fdbe8b532749d863b8239fa895599d17329e17bd35bb36)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBlur", [value]))

    @jsii.member(jsii_name="putChromaKey")
    def put_chroma_key(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanChromaKey, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c3eddde881307c9963ba303a7678a3b27e265dd95d9f92fee2a94e5de5f71a69)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putChromaKey", [value]))

    @jsii.member(jsii_name="putComposite")
    def put_composite(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanComposite, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__07f53e89cc63ccd6c8fbf6da1ab7bc2b11cf7788d68b6fc762179f8c8209bb6f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putComposite", [value]))

    @jsii.member(jsii_name="putCompound")
    def put_compound(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanCompound, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3e7bda5718c7991d930662a5040a5dd5125232bf60734e964ecfbf50e14fcd59)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCompound", [value]))

    @jsii.member(jsii_name="putContrast")
    def put_contrast(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanContrast, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5b4bd779b7dafcd3d118b18180871bba41d17e82c11b10d2ce7fc8bce72ef9fb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putContrast", [value]))

    @jsii.member(jsii_name="putCrop")
    def put_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d83ebb48207c13e6b8d5af46a490dfe2e1d9cee845e78ffcb9ec721da308869e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCrop", [value]))

    @jsii.member(jsii_name="putFaceCrop")
    def put_face_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanFaceCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__15603cedd8cf544241af96fb631648b60224b8b4d8ff7fa08f75ccdbe05cdeb7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFaceCrop", [value]))

    @jsii.member(jsii_name="putFeatureCrop")
    def put_feature_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanFeatureCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1d2945816ac5b172dba3aeb568c62ba8a27f6d2cda09727131c900e5b1a39678)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFeatureCrop", [value]))

    @jsii.member(jsii_name="putFitAndFill")
    def put_fit_and_fill(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanFitAndFill, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__59fa796e768fb6f9960030a4767a14ce90b40bd7c479cab1ac9a44e6ba2e6f26)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFitAndFill", [value]))

    @jsii.member(jsii_name="putGoop")
    def put_goop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanGoop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a6a192d938b550174b9e3062268cf365783e0319f41a6cc274c32308f2ee8f68)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGoop", [value]))

    @jsii.member(jsii_name="putGrayscale")
    def put_grayscale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanGrayscale, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__db003e48face3ad79702f8d2c91e20d96dc3ec75b6fd5cb68e5afda21a270c17)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGrayscale", [value]))

    @jsii.member(jsii_name="putHsl")
    def put_hsl(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanHsl, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__929ec8d26edccf8cb6465942d4f42e519af50dda21a4977d76399c6fc2b153c2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsl", [value]))

    @jsii.member(jsii_name="putHsv")
    def put_hsv(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanHsv, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fbe9f0abddf5ab75eb920f2b6e7925125e3a7a996f573efe7b3652ff5ba40dc1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsv", [value]))

    @jsii.member(jsii_name="putIfDimension")
    def put_if_dimension(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimension, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__36762b474bc504a7e017b63251621e82fe3af9ee2227d9075cdf2d7e3223e8d1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfDimension", [value]))

    @jsii.member(jsii_name="putIfOrientation")
    def put_if_orientation(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__50a5ffe2bd7ac413b7bfbfda8d82042c178fdd08920bb0efe7478c822d127084)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfOrientation", [value]))

    @jsii.member(jsii_name="putImQuery")
    def put_im_query(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanImQuery, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d4dcaf0cf07f7da825cbaa8fd335dba46896b03c4a9fbf7d59120ace2d6541e0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putImQuery", [value]))

    @jsii.member(jsii_name="putMaxColors")
    def put_max_colors(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanMaxColors, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7f6b3764105853f78d3ea658502876425be679c0ed15a79edf129d22d8747ee7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMaxColors", [value]))

    @jsii.member(jsii_name="putMirror")
    def put_mirror(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanMirror, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1026bf4e6223cad8607cc9165b4b3be60e935cb9368c20df7b6dc03dbe9e5dce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMirror", [value]))

    @jsii.member(jsii_name="putMonoHue")
    def put_mono_hue(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanMonoHue, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f574a6c828dd11019e6f99538b15a9ac0c1014c9890864c8027751b203cde15)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMonoHue", [value]))

    @jsii.member(jsii_name="putOpacity")
    def put_opacity(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanOpacity, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1bd6dc9225b179e2f94fefa23778485567f8dee788fb5cd7fddc2e6bd60f07a2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putOpacity", [value]))

    @jsii.member(jsii_name="putRegionOfInterestCrop")
    def put_region_of_interest_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanRegionOfInterestCrop", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__732c76e99266d29e77bc67704267338d5899f08257bb86d3b7231497b4cdf7c3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRegionOfInterestCrop", [value]))

    @jsii.member(jsii_name="putRelativeCrop")
    def put_relative_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanRelativeCrop", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fdce86f8c83d8f5edffd44d1fd1f0df1007141f302a3f59c871dce153c96ebed)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRelativeCrop", [value]))

    @jsii.member(jsii_name="putRemoveColor")
    def put_remove_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanRemoveColor", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dd81264985f1edb66bf72d13ae86803239ca2cfa75b655f95b4da4449f2a2227)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRemoveColor", [value]))

    @jsii.member(jsii_name="putResize")
    def put_resize(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanResize", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9adb1a819ad37e5f223aca36c0b8ec1a2770ffc08b1dcdfe61e18ad9af6dd8a0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putResize", [value]))

    @jsii.member(jsii_name="putRotate")
    def put_rotate(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanRotate", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__67349bbb3336fe5514681faae0b0caab1957d84f100407c96aa4abbffd8d91c1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRotate", [value]))

    @jsii.member(jsii_name="putScale")
    def put_scale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanScale", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__51f5d00514fb054e4218e368f017de9832c9f8af6322840b50fa3586a6ed58fc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putScale", [value]))

    @jsii.member(jsii_name="putShear")
    def put_shear(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanShear", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4f58dd77532b66c57ecc916f5a9206001cd220bf2de6223a47e2147ddd1341db)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putShear", [value]))

    @jsii.member(jsii_name="putTrim")
    def put_trim(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanTrim", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6b521b1b8d7e3495c6fcff5548657e663af754f846f593060dc6ddc753746eaf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTrim", [value]))

    @jsii.member(jsii_name="putUnsharpMask")
    def put_unsharp_mask(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanUnsharpMask", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9fe8b13ef1e0509c6f03d02204b7f3f58cd8cf37a70cd8f9acb7b098beb9d9a1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putUnsharpMask", [value]))

    @jsii.member(jsii_name="resetAppend")
    def reset_append(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAppend", []))

    @jsii.member(jsii_name="resetAspectCrop")
    def reset_aspect_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspectCrop", []))

    @jsii.member(jsii_name="resetBackgroundColor")
    def reset_background_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBackgroundColor", []))

    @jsii.member(jsii_name="resetBlur")
    def reset_blur(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBlur", []))

    @jsii.member(jsii_name="resetChromaKey")
    def reset_chroma_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChromaKey", []))

    @jsii.member(jsii_name="resetComposite")
    def reset_composite(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetComposite", []))

    @jsii.member(jsii_name="resetCompound")
    def reset_compound(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCompound", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetCrop")
    def reset_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCrop", []))

    @jsii.member(jsii_name="resetFaceCrop")
    def reset_face_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFaceCrop", []))

    @jsii.member(jsii_name="resetFeatureCrop")
    def reset_feature_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureCrop", []))

    @jsii.member(jsii_name="resetFitAndFill")
    def reset_fit_and_fill(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFitAndFill", []))

    @jsii.member(jsii_name="resetGoop")
    def reset_goop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGoop", []))

    @jsii.member(jsii_name="resetGrayscale")
    def reset_grayscale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGrayscale", []))

    @jsii.member(jsii_name="resetHsl")
    def reset_hsl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsl", []))

    @jsii.member(jsii_name="resetHsv")
    def reset_hsv(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsv", []))

    @jsii.member(jsii_name="resetIfDimension")
    def reset_if_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfDimension", []))

    @jsii.member(jsii_name="resetIfOrientation")
    def reset_if_orientation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfOrientation", []))

    @jsii.member(jsii_name="resetImQuery")
    def reset_im_query(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetImQuery", []))

    @jsii.member(jsii_name="resetMaxColors")
    def reset_max_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxColors", []))

    @jsii.member(jsii_name="resetMirror")
    def reset_mirror(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMirror", []))

    @jsii.member(jsii_name="resetMonoHue")
    def reset_mono_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonoHue", []))

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetRegionOfInterestCrop")
    def reset_region_of_interest_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRegionOfInterestCrop", []))

    @jsii.member(jsii_name="resetRelativeCrop")
    def reset_relative_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRelativeCrop", []))

    @jsii.member(jsii_name="resetRemoveColor")
    def reset_remove_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRemoveColor", []))

    @jsii.member(jsii_name="resetResize")
    def reset_resize(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetResize", []))

    @jsii.member(jsii_name="resetRotate")
    def reset_rotate(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRotate", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetShear")
    def reset_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetShear", []))

    @jsii.member(jsii_name="resetTrim")
    def reset_trim(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTrim", []))

    @jsii.member(jsii_name="resetUnsharpMask")
    def reset_unsharp_mask(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUnsharpMask", []))

    @builtins.property
    @jsii.member(jsii_name="append")
    def append(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanAppendList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanAppendList, jsii.get(self, "append"))

    @builtins.property
    @jsii.member(jsii_name="aspectCrop")
    def aspect_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanAspectCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanAspectCropList, jsii.get(self, "aspectCrop"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColor")
    def background_color(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanBackgroundColorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanBackgroundColorList, jsii.get(self, "backgroundColor"))

    @builtins.property
    @jsii.member(jsii_name="blur")
    def blur(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanBlurList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanBlurList, jsii.get(self, "blur"))

    @builtins.property
    @jsii.member(jsii_name="chromaKey")
    def chroma_key(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanChromaKeyList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanChromaKeyList, jsii.get(self, "chromaKey"))

    @builtins.property
    @jsii.member(jsii_name="composite")
    def composite(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanCompositeList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanCompositeList, jsii.get(self, "composite"))

    @builtins.property
    @jsii.member(jsii_name="compound")
    def compound(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanCompoundList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanCompoundList, jsii.get(self, "compound"))

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanContrastList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanContrastList, jsii.get(self, "contrast"))

    @builtins.property
    @jsii.member(jsii_name="crop")
    def crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanCropList, jsii.get(self, "crop"))

    @builtins.property
    @jsii.member(jsii_name="faceCrop")
    def face_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanFaceCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanFaceCropList, jsii.get(self, "faceCrop"))

    @builtins.property
    @jsii.member(jsii_name="featureCrop")
    def feature_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanFeatureCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanFeatureCropList, jsii.get(self, "featureCrop"))

    @builtins.property
    @jsii.member(jsii_name="fitAndFill")
    def fit_and_fill(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanFitAndFillList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanFitAndFillList, jsii.get(self, "fitAndFill"))

    @builtins.property
    @jsii.member(jsii_name="goop")
    def goop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanGoopList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanGoopList, jsii.get(self, "goop"))

    @builtins.property
    @jsii.member(jsii_name="grayscale")
    def grayscale(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanGrayscaleList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanGrayscaleList, jsii.get(self, "grayscale"))

    @builtins.property
    @jsii.member(jsii_name="hsl")
    def hsl(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanHslList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanHslList, jsii.get(self, "hsl"))

    @builtins.property
    @jsii.member(jsii_name="hsv")
    def hsv(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanHsvList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanHsvList, jsii.get(self, "hsv"))

    @builtins.property
    @jsii.member(jsii_name="ifDimension")
    def if_dimension(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionList, jsii.get(self, "ifDimension"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientation")
    def if_orientation(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationList, jsii.get(self, "ifOrientation"))

    @builtins.property
    @jsii.member(jsii_name="imQuery")
    def im_query(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanImQueryList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanImQueryList, jsii.get(self, "imQuery"))

    @builtins.property
    @jsii.member(jsii_name="maxColors")
    def max_colors(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanMaxColorsList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanMaxColorsList, jsii.get(self, "maxColors"))

    @builtins.property
    @jsii.member(jsii_name="mirror")
    def mirror(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanMirrorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanMirrorList, jsii.get(self, "mirror"))

    @builtins.property
    @jsii.member(jsii_name="monoHue")
    def mono_hue(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanMonoHueList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanMonoHueList, jsii.get(self, "monoHue"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanOpacityList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanOpacityList, jsii.get(self, "opacity"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestCrop")
    def region_of_interest_crop(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanRegionOfInterestCropList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanRegionOfInterestCropList", jsii.get(self, "regionOfInterestCrop"))

    @builtins.property
    @jsii.member(jsii_name="relativeCrop")
    def relative_crop(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanRelativeCropList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanRelativeCropList", jsii.get(self, "relativeCrop"))

    @builtins.property
    @jsii.member(jsii_name="removeColor")
    def remove_color(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanRemoveColorList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanRemoveColorList", jsii.get(self, "removeColor"))

    @builtins.property
    @jsii.member(jsii_name="resize")
    def resize(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanResizeList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanResizeList", jsii.get(self, "resize"))

    @builtins.property
    @jsii.member(jsii_name="rotate")
    def rotate(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanRotateList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanRotateList", jsii.get(self, "rotate"))

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanScaleList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanScaleList", jsii.get(self, "scale"))

    @builtins.property
    @jsii.member(jsii_name="shear")
    def shear(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanShearList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanShearList", jsii.get(self, "shear"))

    @builtins.property
    @jsii.member(jsii_name="trim")
    def trim(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanTrimList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanTrimList", jsii.get(self, "trim"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMask")
    def unsharp_mask(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanUnsharpMaskList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanUnsharpMaskList", jsii.get(self, "unsharpMask"))

    @builtins.property
    @jsii.member(jsii_name="appendInput")
    def append_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanAppend]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanAppend]]], jsii.get(self, "appendInput"))

    @builtins.property
    @jsii.member(jsii_name="aspectCropInput")
    def aspect_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanAspectCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanAspectCrop]]], jsii.get(self, "aspectCropInput"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColorInput")
    def background_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanBackgroundColor]]], jsii.get(self, "backgroundColorInput"))

    @builtins.property
    @jsii.member(jsii_name="blurInput")
    def blur_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanBlur]]], jsii.get(self, "blurInput"))

    @builtins.property
    @jsii.member(jsii_name="chromaKeyInput")
    def chroma_key_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanChromaKey]]], jsii.get(self, "chromaKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="compositeInput")
    def composite_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanComposite]]], jsii.get(self, "compositeInput"))

    @builtins.property
    @jsii.member(jsii_name="compoundInput")
    def compound_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanCompound]]], jsii.get(self, "compoundInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanContrast]]], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="cropInput")
    def crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanCrop]]], jsii.get(self, "cropInput"))

    @builtins.property
    @jsii.member(jsii_name="faceCropInput")
    def face_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanFaceCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanFaceCrop]]], jsii.get(self, "faceCropInput"))

    @builtins.property
    @jsii.member(jsii_name="featureCropInput")
    def feature_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanFeatureCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanFeatureCrop]]], jsii.get(self, "featureCropInput"))

    @builtins.property
    @jsii.member(jsii_name="fitAndFillInput")
    def fit_and_fill_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanFitAndFill]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanFitAndFill]]], jsii.get(self, "fitAndFillInput"))

    @builtins.property
    @jsii.member(jsii_name="goopInput")
    def goop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanGoop]]], jsii.get(self, "goopInput"))

    @builtins.property
    @jsii.member(jsii_name="grayscaleInput")
    def grayscale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanGrayscale]]], jsii.get(self, "grayscaleInput"))

    @builtins.property
    @jsii.member(jsii_name="hslInput")
    def hsl_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanHsl]]], jsii.get(self, "hslInput"))

    @builtins.property
    @jsii.member(jsii_name="hsvInput")
    def hsv_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanHsv]]], jsii.get(self, "hsvInput"))

    @builtins.property
    @jsii.member(jsii_name="ifDimensionInput")
    def if_dimension_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimension]]], jsii.get(self, "ifDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientationInput")
    def if_orientation_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientation]]], jsii.get(self, "ifOrientationInput"))

    @builtins.property
    @jsii.member(jsii_name="imQueryInput")
    def im_query_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanImQuery]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanImQuery]]], jsii.get(self, "imQueryInput"))

    @builtins.property
    @jsii.member(jsii_name="maxColorsInput")
    def max_colors_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanMaxColors]]], jsii.get(self, "maxColorsInput"))

    @builtins.property
    @jsii.member(jsii_name="mirrorInput")
    def mirror_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanMirror]]], jsii.get(self, "mirrorInput"))

    @builtins.property
    @jsii.member(jsii_name="monoHueInput")
    def mono_hue_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanMonoHue]]], jsii.get(self, "monoHueInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanOpacity]]], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestCropInput")
    def region_of_interest_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanRegionOfInterestCrop"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanRegionOfInterestCrop"]]], jsii.get(self, "regionOfInterestCropInput"))

    @builtins.property
    @jsii.member(jsii_name="relativeCropInput")
    def relative_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanRelativeCrop"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanRelativeCrop"]]], jsii.get(self, "relativeCropInput"))

    @builtins.property
    @jsii.member(jsii_name="removeColorInput")
    def remove_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanRemoveColor"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanRemoveColor"]]], jsii.get(self, "removeColorInput"))

    @builtins.property
    @jsii.member(jsii_name="resizeInput")
    def resize_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanResize"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanResize"]]], jsii.get(self, "resizeInput"))

    @builtins.property
    @jsii.member(jsii_name="rotateInput")
    def rotate_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanRotate"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanRotate"]]], jsii.get(self, "rotateInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanScale"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanScale"]]], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="shearInput")
    def shear_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanShear"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanShear"]]], jsii.get(self, "shearInput"))

    @builtins.property
    @jsii.member(jsii_name="trimInput")
    def trim_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanTrim"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanTrim"]]], jsii.get(self, "trimInput"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMaskInput")
    def unsharp_mask_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanUnsharpMask"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanUnsharpMask"]]], jsii.get(self, "unsharpMaskInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fd8bb4da006eda882abb6de292c059d09a83b692d14dcdf87de5c33c5a132aa5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanRegionOfInterestCrop",
    jsii_struct_bases=[],
    name_mapping={
        "region_of_interest": "regionOfInterest",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanRegionOfInterestCrop:
    def __init__(
        self,
        *,
        region_of_interest: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanRegionOfInterestCropRegionOfInterest", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param region_of_interest: region_of_interest block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest DataAkamaiImagingPolicyImage#region_of_interest}
        :param gravity: The placement of the crop area relative to the specified area of interest. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: The placement of the crop area relative to the specified area of interest. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param style: Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(region_of_interest, dict):
            region_of_interest = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanRegionOfInterestCropRegionOfInterest(**region_of_interest)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8c904349a0422cc7b2d0fd19f899c60e990aedd0681b1217cddeb37e546f21bc)
            check_type(argname="argument region_of_interest", value=region_of_interest, expected_type=type_hints["region_of_interest"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "region_of_interest": region_of_interest,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def region_of_interest(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanRegionOfInterestCropRegionOfInterest":
        '''region_of_interest block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest DataAkamaiImagingPolicyImage#region_of_interest}
        '''
        result = self._values.get("region_of_interest")
        assert result is not None, "Required property 'region_of_interest' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanRegionOfInterestCropRegionOfInterest", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''The placement of the crop area relative to the specified area of interest.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''The placement of the crop area relative to the specified area of interest.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanRegionOfInterestCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanRegionOfInterestCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanRegionOfInterestCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8d2b9c41fc7c0ec0b99696b708f55d1c5f0be0e6fd128de7ae936314e6541ecb)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanRegionOfInterestCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af9522e94e2816a32a7a06a9c17d3ea908753ebeffdcf3724730ae02aca19143)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanRegionOfInterestCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7ec6fbf917ea1fc455a060342f9e4be6e70ca17676c05ea8d5b662ffbe85c2fd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__36c05c18af9c9330bb154720c468d6103ff3a01770cf5e0d033fe14a26a75fb6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a0a48750f26df3f65d28793502ad8367c29c28fc9f75cedc8ad2952bab9c9950)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanRegionOfInterestCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanRegionOfInterestCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanRegionOfInterestCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eefa096eeb9c2f62afe5ff52db3498d3f5212c68d6d276df0d3564f0caf4a811)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanRegionOfInterestCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanRegionOfInterestCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0dd6107d1fa6386a933da5da86c700bf403faa3089653414365719d7b6f68458)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putRegionOfInterest")
    def put_region_of_interest(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanRegionOfInterestCropRegionOfInterest()

        return typing.cast(None, jsii.invoke(self, "putRegionOfInterest", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterest")
    def region_of_interest(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestOutputReference", jsii.get(self, "regionOfInterest"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestInput")
    def region_of_interest_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanRegionOfInterestCropRegionOfInterest"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanRegionOfInterestCropRegionOfInterest"], jsii.get(self, "regionOfInterestInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8973f7640a3f45f383be94741288247724f043da1672ae41dabbcac3ad4efe7b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fcf401e0b1a25e15c6164082995e32b39fc6082598ce1c26a6991a4f39265509)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a411051b667f08bc217f1f51b1eec02e64656eee8662edfd507aa88e85b19dba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__337a89707ba5e2f73221ddb9f24a6db60f86a8dd7916bcc722b09db30b30be45)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__02ba5bde7d1dc6930db46e221151d670b8372aac41ae1adaaf0754bf1c9117e6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a61aa05ce464e62e45aeb6ca47ed21f384926e458442edc19bf8e7ceba889245)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__541e32e482f6c317bf3e262f8fff57e5d92856420ae9f90390cbe4a8d4847ac3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7317058c704ceee2aec447158296095448c31f12c4f911a3e6727d152e77444b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanRegionOfInterestCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanRegionOfInterestCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanRegionOfInterestCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__670d25422a5fbd49a8f2b7231a6429f6f708257ffab3aa2f964f2b58545d018c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanRegionOfInterestCropRegionOfInterest",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanRegionOfInterestCropRegionOfInterest:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanRegionOfInterestCropRegionOfInterest(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a4d8766aeeac9df43eccd5f67a89fda429825de9470317b2b15ebeab98cd5a5d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanRegionOfInterestCropRegionOfInterest]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanRegionOfInterestCropRegionOfInterest], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanRegionOfInterestCropRegionOfInterest],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__055bb97c54ac7177056da93b43a57c9bb32f5859280c3d440d14da31de21c2a1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanRelativeCrop",
    jsii_struct_bases=[],
    name_mapping={
        "east": "east",
        "east_var": "eastVar",
        "north": "north",
        "north_var": "northVar",
        "south": "south",
        "south_var": "southVar",
        "west": "west",
        "west_var": "westVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanRelativeCrop:
    def __init__(
        self,
        *,
        east: typing.Optional[builtins.str] = None,
        east_var: typing.Optional[builtins.str] = None,
        north: typing.Optional[builtins.str] = None,
        north_var: typing.Optional[builtins.str] = None,
        south: typing.Optional[builtins.str] = None,
        south_var: typing.Optional[builtins.str] = None,
        west: typing.Optional[builtins.str] = None,
        west_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param east: The number of pixels to shrink or expand the right side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east DataAkamaiImagingPolicyImage#east}
        :param east_var: The number of pixels to shrink or expand the right side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east_var DataAkamaiImagingPolicyImage#east_var}
        :param north: The number of pixels to shrink or expand the top side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north DataAkamaiImagingPolicyImage#north}
        :param north_var: The number of pixels to shrink or expand the top side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north_var DataAkamaiImagingPolicyImage#north_var}
        :param south: The number of pixels to shrink or expand the bottom side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south DataAkamaiImagingPolicyImage#south}
        :param south_var: The number of pixels to shrink or expand the bottom side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south_var DataAkamaiImagingPolicyImage#south_var}
        :param west: The number of pixels to shrink or expand the left side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west DataAkamaiImagingPolicyImage#west}
        :param west_var: The number of pixels to shrink or expand the left side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west_var DataAkamaiImagingPolicyImage#west_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__03724ff939a370abcc342516e9259b3714e0a9c386ade57d79c407db74be69d3)
            check_type(argname="argument east", value=east, expected_type=type_hints["east"])
            check_type(argname="argument east_var", value=east_var, expected_type=type_hints["east_var"])
            check_type(argname="argument north", value=north, expected_type=type_hints["north"])
            check_type(argname="argument north_var", value=north_var, expected_type=type_hints["north_var"])
            check_type(argname="argument south", value=south, expected_type=type_hints["south"])
            check_type(argname="argument south_var", value=south_var, expected_type=type_hints["south_var"])
            check_type(argname="argument west", value=west, expected_type=type_hints["west"])
            check_type(argname="argument west_var", value=west_var, expected_type=type_hints["west_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if east is not None:
            self._values["east"] = east
        if east_var is not None:
            self._values["east_var"] = east_var
        if north is not None:
            self._values["north"] = north
        if north_var is not None:
            self._values["north_var"] = north_var
        if south is not None:
            self._values["south"] = south
        if south_var is not None:
            self._values["south_var"] = south_var
        if west is not None:
            self._values["west"] = west
        if west_var is not None:
            self._values["west_var"] = west_var

    @builtins.property
    def east(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the right side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east DataAkamaiImagingPolicyImage#east}
        '''
        result = self._values.get("east")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def east_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the right side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east_var DataAkamaiImagingPolicyImage#east_var}
        '''
        result = self._values.get("east_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def north(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the top side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north DataAkamaiImagingPolicyImage#north}
        '''
        result = self._values.get("north")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def north_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the top side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north_var DataAkamaiImagingPolicyImage#north_var}
        '''
        result = self._values.get("north_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def south(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the bottom side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south DataAkamaiImagingPolicyImage#south}
        '''
        result = self._values.get("south")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def south_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the bottom side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south_var DataAkamaiImagingPolicyImage#south_var}
        '''
        result = self._values.get("south_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def west(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the left side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west DataAkamaiImagingPolicyImage#west}
        '''
        result = self._values.get("west")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def west_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the left side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west_var DataAkamaiImagingPolicyImage#west_var}
        '''
        result = self._values.get("west_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanRelativeCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanRelativeCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanRelativeCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f1815c5e8dad0f2bb5e8a02aa0c5d640c5e6676ee8e0e70c74029c9917663020)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanRelativeCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f61dbb85b69fd45baaa312d1838a568d64cd77eb77c52f601ffa6208d8109cf8)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanRelativeCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a0bf816fa7d3fdd68f23db2241fb65b7245011c5ed6c0a8e0b200b1aeae19a7c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__59298539d8c8802082c9b99dd997927cf68442ff6acdd953c666527ae3a31ea5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__95d2e9d40ab8a2916032bb56f4ecb7d3af587ee0d00ac87906095a97e1e53b36)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanRelativeCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanRelativeCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanRelativeCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0dc8f14893e7187ce993b6f8ff1f530e3cbf0d1cc1a4d2c3289fccfc6e0fd8f1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanRelativeCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanRelativeCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c4e667a2a7594abbaa2e02f242f4f118bf14625e9092cf3cc65ac3e363045e7c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetEast")
    def reset_east(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEast", []))

    @jsii.member(jsii_name="resetEastVar")
    def reset_east_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEastVar", []))

    @jsii.member(jsii_name="resetNorth")
    def reset_north(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNorth", []))

    @jsii.member(jsii_name="resetNorthVar")
    def reset_north_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNorthVar", []))

    @jsii.member(jsii_name="resetSouth")
    def reset_south(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSouth", []))

    @jsii.member(jsii_name="resetSouthVar")
    def reset_south_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSouthVar", []))

    @jsii.member(jsii_name="resetWest")
    def reset_west(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWest", []))

    @jsii.member(jsii_name="resetWestVar")
    def reset_west_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWestVar", []))

    @builtins.property
    @jsii.member(jsii_name="eastInput")
    def east_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "eastInput"))

    @builtins.property
    @jsii.member(jsii_name="eastVarInput")
    def east_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "eastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="northInput")
    def north_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "northInput"))

    @builtins.property
    @jsii.member(jsii_name="northVarInput")
    def north_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "northVarInput"))

    @builtins.property
    @jsii.member(jsii_name="southInput")
    def south_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "southInput"))

    @builtins.property
    @jsii.member(jsii_name="southVarInput")
    def south_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "southVarInput"))

    @builtins.property
    @jsii.member(jsii_name="westInput")
    def west_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "westInput"))

    @builtins.property
    @jsii.member(jsii_name="westVarInput")
    def west_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "westVarInput"))

    @builtins.property
    @jsii.member(jsii_name="east")
    def east(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "east"))

    @east.setter
    def east(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ad77d6e892c63cddf76327542bd13b17051c8881f264179471cc2c32087ef04a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "east", value)

    @builtins.property
    @jsii.member(jsii_name="eastVar")
    def east_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "eastVar"))

    @east_var.setter
    def east_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8dc9bacdcaa6859e09f044de0ce94c89bf072cca5a0f4d75f19e2a3b05827725)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "eastVar", value)

    @builtins.property
    @jsii.member(jsii_name="north")
    def north(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "north"))

    @north.setter
    def north(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__867c3ea886db0fd17fa3a9eefdac7b2623adc6ca0570f97cc08ed523d7313a08)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "north", value)

    @builtins.property
    @jsii.member(jsii_name="northVar")
    def north_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "northVar"))

    @north_var.setter
    def north_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9e3e66ab4a160c30ccc4604cb2f992110ffdcc0a450e54061297e9d8bcb33d1c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "northVar", value)

    @builtins.property
    @jsii.member(jsii_name="south")
    def south(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "south"))

    @south.setter
    def south(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6d154e1f18e50d184c7ee2e732cb7a7e6887f80d6ec677a4a9e87660602076c5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "south", value)

    @builtins.property
    @jsii.member(jsii_name="southVar")
    def south_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "southVar"))

    @south_var.setter
    def south_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8fb3769e363623aca3a86357eba84cbb7abcd7de1ad7db09cec33de5d3384f6d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "southVar", value)

    @builtins.property
    @jsii.member(jsii_name="west")
    def west(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "west"))

    @west.setter
    def west(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__111305d790c6467731a17e3cf91d5fe93298a98d0b2b838bbfe45947ee0c12fd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "west", value)

    @builtins.property
    @jsii.member(jsii_name="westVar")
    def west_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "westVar"))

    @west_var.setter
    def west_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__180e76401a001f18d506d23a2ff527b0cad07b4abd8ffb19cd2152931f387c46)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "westVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanRelativeCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanRelativeCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanRelativeCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__53f086ed3808eecff0d3e55f686fa9b1f858dfe40ef38c60128979e0da0479ca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanRemoveColor",
    jsii_struct_bases=[],
    name_mapping={
        "color": "color",
        "color_var": "colorVar",
        "feather": "feather",
        "feather_var": "featherVar",
        "tolerance": "tolerance",
        "tolerance_var": "toleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanRemoveColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
        feather: typing.Optional[builtins.str] = None,
        feather_var: typing.Optional[builtins.str] = None,
        tolerance: typing.Optional[builtins.str] = None,
        tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        :param feather: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        :param feather_var: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        :param tolerance: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        :param tolerance_var: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8f34096369dab43d871cb640ec1455c19e438445fecd7078a16893dc32522bba)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
            check_type(argname="argument feather", value=feather, expected_type=type_hints["feather"])
            check_type(argname="argument feather_var", value=feather_var, expected_type=type_hints["feather_var"])
            check_type(argname="argument tolerance", value=tolerance, expected_type=type_hints["tolerance"])
            check_type(argname="argument tolerance_var", value=tolerance_var, expected_type=type_hints["tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var
        if feather is not None:
            self._values["feather"] = feather
        if feather_var is not None:
            self._values["feather_var"] = feather_var
        if tolerance is not None:
            self._values["tolerance"] = tolerance
        if tolerance_var is not None:
            self._values["tolerance_var"] = tolerance_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        '''
        result = self._values.get("feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather_var(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        '''
        result = self._values.get("feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        '''
        result = self._values.get("tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance_var(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        result = self._values.get("tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanRemoveColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanRemoveColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanRemoveColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e639b260a2ddb8c6efc3ce52dc4a110c31f94d345a67fcab75d4131b605f8580)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanRemoveColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e6126ef31d7af3c69689448a4232c662422d8d2a6c56f5da0acabc9ece3e2dec)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanRemoveColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3cabe6723fa174e4add627f260221aa0af6e321fe0fe46a4240af1ca1a16a4d7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cfa9ff42be266d207c8596a1cdb8ad43ca4ac18535b59c04296d3dde478aaae6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9724c3e3b499835ebce8c31f33c0685792d3f998fd150a4a7367fad04c9fef93)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanRemoveColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanRemoveColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanRemoveColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__56f8de2320fc225a4b6d8632af1a932d569b40185798e1f3ef621b5f2e5ceaff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanRemoveColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanRemoveColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eea32e2f000a3a4b00e3adcce06ab7185b4d32eb8c9b18a138e90264172f306e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @jsii.member(jsii_name="resetFeather")
    def reset_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeather", []))

    @jsii.member(jsii_name="resetFeatherVar")
    def reset_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatherVar", []))

    @jsii.member(jsii_name="resetTolerance")
    def reset_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTolerance", []))

    @jsii.member(jsii_name="resetToleranceVar")
    def reset_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featherInput")
    def feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherInput"))

    @builtins.property
    @jsii.member(jsii_name="featherVarInput")
    def feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceInput")
    def tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceVarInput")
    def tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ef8646342d815b4e64256eaad898d4b09ad2933bbeb8c458fc8f420f08d163de)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__015cc76a70c1c85167e0a5b1981e49a61c8033f73eb1fb0be8737fc35a04491c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="feather")
    def feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "feather"))

    @feather.setter
    def feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__44474270d24c75618cd36b527fd96115d94a62aeb64c9b47a14485fd4d3178e5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "feather", value)

    @builtins.property
    @jsii.member(jsii_name="featherVar")
    def feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featherVar"))

    @feather_var.setter
    def feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__143c6de46582d72cfd8362736f37a3b07e06c1be5be173bfb22de0cf94c1c503)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featherVar", value)

    @builtins.property
    @jsii.member(jsii_name="tolerance")
    def tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tolerance"))

    @tolerance.setter
    def tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__75dfe1d7fb4c191a0dbeea4f3f3e9dfcf43c72b4e16700e95112430b7a17f384)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tolerance", value)

    @builtins.property
    @jsii.member(jsii_name="toleranceVar")
    def tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "toleranceVar"))

    @tolerance_var.setter
    def tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a81ff76c24f12cc521421ad326cea592f2a51b394da1400b20cc01af36bd711)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "toleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanRemoveColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanRemoveColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanRemoveColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5c1f464aef313757691b67df39a768dee33c03aaf047b8078f16bd310f5cd393)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanResize",
    jsii_struct_bases=[],
    name_mapping={
        "aspect": "aspect",
        "aspect_var": "aspectVar",
        "height": "height",
        "height_var": "heightVar",
        "type": "type",
        "type_var": "typeVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanResize:
    def __init__(
        self,
        *,
        aspect: typing.Optional[builtins.str] = None,
        aspect_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param aspect: Preserves the aspect ratio. Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect DataAkamaiImagingPolicyImage#aspect}
        :param aspect_var: Preserves the aspect ratio. Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_var DataAkamaiImagingPolicyImage#aspect_var}
        :param height: The height to resize the source image to. Must be set if height is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height to resize the source image to. Must be set if height is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param type: Sets constraints for the image resize. Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: Sets constraints for the image resize. Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        :param width: The width to resize the source image to. Must be set if width is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width to resize the source image to. Must be set if width is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5760541bbdc61255f9fcf796b29e08e3a94731973a281c5f84bc21d6bd86d772)
            check_type(argname="argument aspect", value=aspect, expected_type=type_hints["aspect"])
            check_type(argname="argument aspect_var", value=aspect_var, expected_type=type_hints["aspect_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if aspect is not None:
            self._values["aspect"] = aspect
        if aspect_var is not None:
            self._values["aspect_var"] = aspect_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def aspect(self) -> typing.Optional[builtins.str]:
        '''Preserves the aspect ratio.

        Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect DataAkamaiImagingPolicyImage#aspect}
        '''
        result = self._values.get("aspect")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def aspect_var(self) -> typing.Optional[builtins.str]:
        '''Preserves the aspect ratio.

        Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_var DataAkamaiImagingPolicyImage#aspect_var}
        '''
        result = self._values.get("aspect_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height to resize the source image to. Must be set if height is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height to resize the source image to. Must be set if height is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''Sets constraints for the image resize.

        Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''Sets constraints for the image resize.

        Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width to resize the source image to. Must be set if width is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width to resize the source image to. Must be set if width is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanResize(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanResizeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanResizeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__975aff52431946df171f00ba8dc4781930f68137ac6d7a3cdd7ecd86b84280ac)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanResizeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__71cffc16fb6151513d2c4f0cc5cf0ffae52ab4aaeeb8160391c558ee02a38f59)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanResizeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1fbe74977f3dfbf0c5e685d4153ac4d27fc4066e6db8fbb42ded6066d673bde6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__040b985216f06f7214e078da6444d0a6ab01c874d6facd9caa251b3a06660e28)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__18dfed2ce6af14512f4ef1cb30f68a91f8c0733706a3ca355603b296f34d2255)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanResize]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanResize]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanResize]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2dd33c93b4728356632acf18b4cc9885df35a9ab4a6a575659488e42357adde3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanResizeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanResizeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4e40e8e786619bfa5c3e8432655cef6de8f8efd22bb60f618c7ec05e8d94e81a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAspect")
    def reset_aspect(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspect", []))

    @jsii.member(jsii_name="resetAspectVar")
    def reset_aspect_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspectVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="aspectInput")
    def aspect_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "aspectInput"))

    @builtins.property
    @jsii.member(jsii_name="aspectVarInput")
    def aspect_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "aspectVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="aspect")
    def aspect(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "aspect"))

    @aspect.setter
    def aspect(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f58f02fe8e48734f3ccd52813e703993f833b2894106e37cc5f5fc17ba84cfc0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "aspect", value)

    @builtins.property
    @jsii.member(jsii_name="aspectVar")
    def aspect_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "aspectVar"))

    @aspect_var.setter
    def aspect_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__60d473357288b784f3bc66e385658f85d5da0479d6522ac496ad4b8d79bcf91e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "aspectVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__526fac7190e804fc3e7120ff7140271d8d40cabd78e530cab57c6124c6f3751e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ab88803b309c1f148bb18730592456641e873e6625fce007f28a9913cf06a7e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bfc2edae570034c118786ff39ba94b469a93bd92d78627ad8f75657236780c2a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2cf9e157c3c07bc8192baef754cd5ee5a1891f1535211389226b6f47aec4e969)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f3ffaaf5c2fb6bd0c5281ab21df8052f61e3c89716c794ae0e2e21bd5e116a8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__50bf211ff54fb684c1f3351f1f9e3894d08243a5ba189378c8f49c47e690db49)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanResize]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanResize]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanResize]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd6b18b8aa33c257c258e9de3980c70c687f3287beb64f8a57105caf23418c7c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanRotate",
    jsii_struct_bases=[],
    name_mapping={"degrees": "degrees", "degrees_var": "degreesVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanRotate:
    def __init__(
        self,
        *,
        degrees: typing.Optional[builtins.str] = None,
        degrees_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param degrees: The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees DataAkamaiImagingPolicyImage#degrees}
        :param degrees_var: The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees_var DataAkamaiImagingPolicyImage#degrees_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__64040f0a9620ae12f1966cd5c9265311760e194e01411f673c8992f3386c0048)
            check_type(argname="argument degrees", value=degrees, expected_type=type_hints["degrees"])
            check_type(argname="argument degrees_var", value=degrees_var, expected_type=type_hints["degrees_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if degrees is not None:
            self._values["degrees"] = degrees
        if degrees_var is not None:
            self._values["degrees_var"] = degrees_var

    @builtins.property
    def degrees(self) -> typing.Optional[builtins.str]:
        '''The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees DataAkamaiImagingPolicyImage#degrees}
        '''
        result = self._values.get("degrees")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def degrees_var(self) -> typing.Optional[builtins.str]:
        '''The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees_var DataAkamaiImagingPolicyImage#degrees_var}
        '''
        result = self._values.get("degrees_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanRotate(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanRotateList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanRotateList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1acffa4f1dcbc7de96f4d054ee6990febf8c23024c04345e0c31de97619535b1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanRotateOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__34f0227b663f6d19abc97b47084c21286f96e91e033a3fd7ec191948d254cddc)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanRotateOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8554c6b9e3e27cd8032416beb439c9c86dba311382d404002edfbf4300c02574)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6d2b68d445222f33e8647b8631b31a409807d36e07b428f52180bd5fe6e7c3b5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__56af6d76ee340fe33a5e6d17c9c87db201fdc0dbc1e7b5f1b526179e9d9dcac8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanRotate]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanRotate]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanRotate]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8ffecf3e0d9c8c92a463d22e09e7b55fc7182323e5cf57e3c9979a51df03982a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanRotateOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanRotateOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__331da0892699a7a7eb7539710e93ae671de2f561b4f54048e973a2f2f7709bad)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetDegrees")
    def reset_degrees(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDegrees", []))

    @jsii.member(jsii_name="resetDegreesVar")
    def reset_degrees_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDegreesVar", []))

    @builtins.property
    @jsii.member(jsii_name="degreesInput")
    def degrees_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "degreesInput"))

    @builtins.property
    @jsii.member(jsii_name="degreesVarInput")
    def degrees_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "degreesVarInput"))

    @builtins.property
    @jsii.member(jsii_name="degrees")
    def degrees(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "degrees"))

    @degrees.setter
    def degrees(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8576335f7b821291a8d7b19cc3bbb3ad1cee3efa530c95e35b1a6d778536c67f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "degrees", value)

    @builtins.property
    @jsii.member(jsii_name="degreesVar")
    def degrees_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "degreesVar"))

    @degrees_var.setter
    def degrees_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c175bc87c432524646afcf969b674c1f1befbf27949003e6e9b0300138ed5933)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "degreesVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanRotate]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanRotate]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanRotate]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7788919e8094264f92924a3ac32840b9152fd89f03eab0761edfbd8dc82f0262)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanScale",
    jsii_struct_bases=[],
    name_mapping={
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanScale:
    def __init__(
        self,
        *,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param height: Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged. Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged. Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__801c2b92b21cbc3428d861109b749d7e7b2126b68afe5fee5460ebfa5a7162fd)
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size.

        Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size.

        Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged.

        Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged.

        Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanScale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanScaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanScaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4c43215fcc284a73279944fccd31f4c5ed8fac0a767fafc213a04370b791ae87)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanScaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b45037077dadc86ae4481bc4b401c6bdfce9fea0771fb91af302123808a5c19c)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanScaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c712ba9209fad119c5e798dc80fcac2da96eaae1e00afc36ca530e8692922e38)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ed81fd75ca219c876b5e793126e74bca7123876439c0d845d5862025083f3c8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__41a48c2c105adbeb91da74be4d3bc7f69839f3a6a255a271c925f1856a62c2c9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanScale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanScale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanScale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__27534c203e6acf4737fe15cab33950718985ab88ba01ec8dfdfa21a81b374aa4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanScaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanScaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__61f51d3ebf557ef97e08fe868598337a4ea9df9204603fed50991def8eea756c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e2528f0006766bfc0bc5bbb8d93c96704a0e8c1310efc686df6e47b9881ac710)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d2a44033ffd92f6054e6e3a480d7538956de3c56d4bdabea6910f314d280f1e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__402db28e832876f5d4f7f5b0be482ac2ca71416e6d077535930031fadb59a4fa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d67b65a950aed6826d8cb73602a874a4d8b805915256edaf83d56b083854bd9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanScale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanScale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanScale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__40365aaa70645e89973149666dd2e9d67e3cf57921fbdc4ce5326f3bf2cf5d98)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanShear",
    jsii_struct_bases=[],
    name_mapping={
        "x_shear": "xShear",
        "x_shear_var": "xShearVar",
        "y_shear": "yShear",
        "y_shear_var": "yShearVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanShear:
    def __init__(
        self,
        *,
        x_shear: typing.Optional[builtins.str] = None,
        x_shear_var: typing.Optional[builtins.str] = None,
        y_shear: typing.Optional[builtins.str] = None,
        y_shear_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param x_shear: The amount to shear along the x-axis, measured in multiples of the image's width. Must be set if yShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear DataAkamaiImagingPolicyImage#x_shear}
        :param x_shear_var: The amount to shear along the x-axis, measured in multiples of the image's width. Must be set if yShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear_var DataAkamaiImagingPolicyImage#x_shear_var}
        :param y_shear: The amount to shear along the y-axis, measured in multiples of the image's height. Must be set if xShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear DataAkamaiImagingPolicyImage#y_shear}
        :param y_shear_var: The amount to shear along the y-axis, measured in multiples of the image's height. Must be set if xShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear_var DataAkamaiImagingPolicyImage#y_shear_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2008592e2c6000a954203c5418bc1800f0706ff086712426c7621ad3b9490744)
            check_type(argname="argument x_shear", value=x_shear, expected_type=type_hints["x_shear"])
            check_type(argname="argument x_shear_var", value=x_shear_var, expected_type=type_hints["x_shear_var"])
            check_type(argname="argument y_shear", value=y_shear, expected_type=type_hints["y_shear"])
            check_type(argname="argument y_shear_var", value=y_shear_var, expected_type=type_hints["y_shear_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if x_shear is not None:
            self._values["x_shear"] = x_shear
        if x_shear_var is not None:
            self._values["x_shear_var"] = x_shear_var
        if y_shear is not None:
            self._values["y_shear"] = y_shear
        if y_shear_var is not None:
            self._values["y_shear_var"] = y_shear_var

    @builtins.property
    def x_shear(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the x-axis, measured in multiples of the image's width.

        Must be set if yShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear DataAkamaiImagingPolicyImage#x_shear}
        '''
        result = self._values.get("x_shear")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_shear_var(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the x-axis, measured in multiples of the image's width.

        Must be set if yShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear_var DataAkamaiImagingPolicyImage#x_shear_var}
        '''
        result = self._values.get("x_shear_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_shear(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the y-axis, measured in multiples of the image's height.

        Must be set if xShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear DataAkamaiImagingPolicyImage#y_shear}
        '''
        result = self._values.get("y_shear")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_shear_var(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the y-axis, measured in multiples of the image's height.

        Must be set if xShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear_var DataAkamaiImagingPolicyImage#y_shear_var}
        '''
        result = self._values.get("y_shear_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanShear(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanShearList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanShearList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b0011ad8f6fff9734be756ccb942e1b594b4890367edbb4dbf123b3aca5bc2f9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanShearOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1239bb8d556ee5442b10f07e85f4432c0807049a4658e6f0fe0ad609ef95c8c0)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanShearOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0f0a06c955f3c0bc3b4a29c5e1ad8ad734e593618d8c0797c9bdbe6fbe373397)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a37c65f27d787ecb34863060564d65a0426b7ef2246bdc3558c10a340b149b9f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4eadcff0c9675802ea324b3c842897b2029fdd8fa71ebddf46b17053111b337f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanShear]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanShear]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanShear]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0d785b1c1cc11da59dc0bb1275a4b3899774308d6f8efb497576503e38afd8c2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanShearOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanShearOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d57e8aa02a9dd253dec776d7a20ba7689c0ea4afd153008235ce4e4051dfa078)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetXShear")
    def reset_x_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXShear", []))

    @jsii.member(jsii_name="resetXShearVar")
    def reset_x_shear_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXShearVar", []))

    @jsii.member(jsii_name="resetYShear")
    def reset_y_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYShear", []))

    @jsii.member(jsii_name="resetYShearVar")
    def reset_y_shear_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYShearVar", []))

    @builtins.property
    @jsii.member(jsii_name="xShearInput")
    def x_shear_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xShearInput"))

    @builtins.property
    @jsii.member(jsii_name="xShearVarInput")
    def x_shear_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xShearVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yShearInput")
    def y_shear_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yShearInput"))

    @builtins.property
    @jsii.member(jsii_name="yShearVarInput")
    def y_shear_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yShearVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xShear")
    def x_shear(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xShear"))

    @x_shear.setter
    def x_shear(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e026b0e5bba5bbd586640e8f2230b7d9040ab64635bded07eb7ae33cd9ac8ec4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xShear", value)

    @builtins.property
    @jsii.member(jsii_name="xShearVar")
    def x_shear_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xShearVar"))

    @x_shear_var.setter
    def x_shear_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f12e6c0ff4b95378fc95131fb22b62c5e4a7bb8be881bef2171aa37a4971f858)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xShearVar", value)

    @builtins.property
    @jsii.member(jsii_name="yShear")
    def y_shear(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yShear"))

    @y_shear.setter
    def y_shear(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__509c74794f0fbafb26ed1044315f2b90c565d374403f37277c2f3b1f14cdb6c9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yShear", value)

    @builtins.property
    @jsii.member(jsii_name="yShearVar")
    def y_shear_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yShearVar"))

    @y_shear_var.setter
    def y_shear_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__81bd32f50617730e1d29eef761410970b00c50963074e11a18552765aaaaed6c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yShearVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanShear]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanShear]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanShear]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ca5c0d2b2c180b8941c61a4cbc5d04296205e848075a03a7f08440121458973a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanTrim",
    jsii_struct_bases=[],
    name_mapping={
        "fuzz": "fuzz",
        "fuzz_var": "fuzzVar",
        "padding": "padding",
        "padding_var": "paddingVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanTrim:
    def __init__(
        self,
        *,
        fuzz: typing.Optional[builtins.str] = None,
        fuzz_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fuzz: The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz DataAkamaiImagingPolicyImage#fuzz}
        :param fuzz_var: The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz_var DataAkamaiImagingPolicyImage#fuzz_var}
        :param padding: The amount of padding in pixels to add to the trimmed image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: The amount of padding in pixels to add to the trimmed image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a1f865de3a83ed31f4c9a690bdbc4ce24e43f2b2737242e86f3c8f2b09d9ad70)
            check_type(argname="argument fuzz", value=fuzz, expected_type=type_hints["fuzz"])
            check_type(argname="argument fuzz_var", value=fuzz_var, expected_type=type_hints["fuzz_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fuzz is not None:
            self._values["fuzz"] = fuzz
        if fuzz_var is not None:
            self._values["fuzz_var"] = fuzz_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var

    @builtins.property
    def fuzz(self) -> typing.Optional[builtins.str]:
        '''The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz DataAkamaiImagingPolicyImage#fuzz}
        '''
        result = self._values.get("fuzz")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fuzz_var(self) -> typing.Optional[builtins.str]:
        '''The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz_var DataAkamaiImagingPolicyImage#fuzz_var}
        '''
        result = self._values.get("fuzz_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''The amount of padding in pixels to add to the trimmed image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''The amount of padding in pixels to add to the trimmed image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanTrim(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanTrimList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanTrimList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a13ee7ea995b791de498bdf9fa13cf2d04efd7035795b1c697d4d20f3cc4ee40)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanTrimOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__11aef1e51349c403f452686b8f67d124eca351f6e71ca91786b2bdeaf04a4bc6)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanTrimOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__815f0c64df302799c8ff6b02b1f24e9e9837665bb6df3491dc6005f94a7f6274)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__425e3357832a0e8416f99470e7a5bbd16981179240914e19c816b943b726882c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f8e489e0fd9760305e3d1685007aef125314c113e4b608db72964d529c1c07ca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanTrim]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanTrim]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanTrim]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f987dd8f41880f5139863db88eecc7c74637357a06765f0c495c82c48570c86b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanTrimOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanTrimOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1e3e9da2e4226b298d17fa590db92f108a9e1556c67c7719955f87e2de3aa851)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetFuzz")
    def reset_fuzz(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFuzz", []))

    @jsii.member(jsii_name="resetFuzzVar")
    def reset_fuzz_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFuzzVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @builtins.property
    @jsii.member(jsii_name="fuzzInput")
    def fuzz_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fuzzInput"))

    @builtins.property
    @jsii.member(jsii_name="fuzzVarInput")
    def fuzz_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fuzzVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="fuzz")
    def fuzz(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fuzz"))

    @fuzz.setter
    def fuzz(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e0b162ae2c6d1ec45eb94dfa09b933ffd5edd92b770b29f64d26d0c68c12d20)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fuzz", value)

    @builtins.property
    @jsii.member(jsii_name="fuzzVar")
    def fuzz_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fuzzVar"))

    @fuzz_var.setter
    def fuzz_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c552eedf0754a939106ffb089da66c7b001fca30b90219207c1af394ad585ee6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fuzzVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2136d1c9c7fb36bfcc4a93e929ab82c3ccce5e2962199e45a46cb64ddf0556c7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9b92d9603ae8a9dd0f180d1844f21f87c9de5cdd41738f641ad8e71384569adb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanTrim]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanTrim]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanTrim]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c0e61adffbf53508acdcfb2c15454e97a4ae8c7cfc17306c0a71df1740b24746)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanUnsharpMask",
    jsii_struct_bases=[],
    name_mapping={
        "gain": "gain",
        "gain_var": "gainVar",
        "sigma": "sigma",
        "sigma_var": "sigmaVar",
        "threshold": "threshold",
        "threshold_var": "thresholdVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanUnsharpMask:
    def __init__(
        self,
        *,
        gain: typing.Optional[builtins.str] = None,
        gain_var: typing.Optional[builtins.str] = None,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
        threshold: typing.Optional[builtins.str] = None,
        threshold_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param gain: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        :param gain_var: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        :param sigma: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        :param threshold: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        :param threshold_var: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bcae54d0d9b8330f21c89fc8fb7977fdcd445f7a25924c5ebde952b4be3e51f5)
            check_type(argname="argument gain", value=gain, expected_type=type_hints["gain"])
            check_type(argname="argument gain_var", value=gain_var, expected_type=type_hints["gain_var"])
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
            check_type(argname="argument threshold", value=threshold, expected_type=type_hints["threshold"])
            check_type(argname="argument threshold_var", value=threshold_var, expected_type=type_hints["threshold_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if gain is not None:
            self._values["gain"] = gain
        if gain_var is not None:
            self._values["gain_var"] = gain_var
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var
        if threshold is not None:
            self._values["threshold"] = threshold
        if threshold_var is not None:
            self._values["threshold_var"] = threshold_var

    @builtins.property
    def gain(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        '''
        result = self._values.get("gain")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gain_var(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        '''
        result = self._values.get("gain_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        '''
        result = self._values.get("threshold")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold_var(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        result = self._values.get("threshold_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanUnsharpMask(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanUnsharpMaskList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanUnsharpMaskList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4d48c2dc35ba7736d0d8aa3f3cb1c967654eaa270586331d7065a35bc62f9bd6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanUnsharpMaskOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__39b89713591730b3bd297357c17a9723b469208697b024217a039b424bfeb2c0)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanUnsharpMaskOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c8dd86a305467795131747761555bbf46e21690e8b3f79e5bd06d207e78237c1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b1c6dc65930f45d00cfb29752f83a50877d02e61d83d70d7960b3bed8afe3241)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__92230caab96ec9f35b157c95921fb0403a570ee0dde6edbe9896c0aeeb5bd638)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanUnsharpMask]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanUnsharpMask]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanUnsharpMask]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ddb947360da4251beae5ff0be682de52010d80dbc213fda0f354af4d858f2306)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanUnsharpMaskOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanUnsharpMaskOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ed6029977c2c59a63d4161799a901c9753bf65d308362c9aae9acbb3f010ebb)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetGain")
    def reset_gain(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGain", []))

    @jsii.member(jsii_name="resetGainVar")
    def reset_gain_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGainVar", []))

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @jsii.member(jsii_name="resetThreshold")
    def reset_threshold(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThreshold", []))

    @jsii.member(jsii_name="resetThresholdVar")
    def reset_threshold_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThresholdVar", []))

    @builtins.property
    @jsii.member(jsii_name="gainInput")
    def gain_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainInput"))

    @builtins.property
    @jsii.member(jsii_name="gainVarInput")
    def gain_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdInput")
    def threshold_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdVarInput")
    def threshold_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gain")
    def gain(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gain"))

    @gain.setter
    def gain(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f2d63cd267f1c9eb007634130e52f5821075dab70f662907fe14faabf2853b92)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gain", value)

    @builtins.property
    @jsii.member(jsii_name="gainVar")
    def gain_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gainVar"))

    @gain_var.setter
    def gain_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__53a4c3a0b09ccfdf0b463f8ab627e2f5141efb3be8448748b98d49f1c9d4fe9e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gainVar", value)

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ab30173802397aa272bb8a7843161f172f9b66b01a23c9d9fd1dfe22c123ed3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4279a1a081fe9d10397923c406e7aa2184ec1891821903ba11f2eddb64896f4c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="threshold")
    def threshold(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "threshold"))

    @threshold.setter
    def threshold(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9bd78cecf93be0852fef70fb899cc253d67847f9c27218420c6b6e75012d2b56)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "threshold", value)

    @builtins.property
    @jsii.member(jsii_name="thresholdVar")
    def threshold_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "thresholdVar"))

    @threshold_var.setter
    def threshold_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a0e796906c1dbb7b2f54395fc79f19f423e7a96cf6669d280763f93a5ce87746)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "thresholdVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanUnsharpMask]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanUnsharpMask]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanUnsharpMask]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a8d7059f60cac9d898ce20db3122bdb6aa92d17f84f66a2fb9394655f34d07d5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThan",
    jsii_struct_bases=[],
    name_mapping={
        "append": "append",
        "aspect_crop": "aspectCrop",
        "background_color": "backgroundColor",
        "blur": "blur",
        "chroma_key": "chromaKey",
        "composite": "composite",
        "compound": "compound",
        "contrast": "contrast",
        "crop": "crop",
        "face_crop": "faceCrop",
        "feature_crop": "featureCrop",
        "fit_and_fill": "fitAndFill",
        "goop": "goop",
        "grayscale": "grayscale",
        "hsl": "hsl",
        "hsv": "hsv",
        "if_dimension": "ifDimension",
        "if_orientation": "ifOrientation",
        "im_query": "imQuery",
        "max_colors": "maxColors",
        "mirror": "mirror",
        "mono_hue": "monoHue",
        "opacity": "opacity",
        "region_of_interest_crop": "regionOfInterestCrop",
        "relative_crop": "relativeCrop",
        "remove_color": "removeColor",
        "resize": "resize",
        "rotate": "rotate",
        "scale": "scale",
        "shear": "shear",
        "trim": "trim",
        "unsharp_mask": "unsharpMask",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThan:
    def __init__(
        self,
        *,
        append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanAppend", typing.Dict[builtins.str, typing.Any]]]]] = None,
        aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanAspectCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanBackgroundColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanBlur", typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanChromaKey", typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanComposite", typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanCompound", typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanContrast", typing.Dict[builtins.str, typing.Any]]]]] = None,
        crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanFaceCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanFeatureCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanFitAndFill", typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanGoop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanGrayscale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanHsl", typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanHsv", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfDimension", typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfOrientation", typing.Dict[builtins.str, typing.Any]]]]] = None,
        im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanImQuery", typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanMaxColors", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanMirror", typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanMonoHue", typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanOpacity", typing.Dict[builtins.str, typing.Any]]]]] = None,
        region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanRegionOfInterestCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanRelativeCrop", typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanRemoveColor", typing.Dict[builtins.str, typing.Any]]]]] = None,
        resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanResize", typing.Dict[builtins.str, typing.Any]]]]] = None,
        rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanRotate", typing.Dict[builtins.str, typing.Any]]]]] = None,
        scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanScale", typing.Dict[builtins.str, typing.Any]]]]] = None,
        shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanShear", typing.Dict[builtins.str, typing.Any]]]]] = None,
        trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanTrim", typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanUnsharpMask", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param append: append block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        :param aspect_crop: aspect_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param crop: crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        :param face_crop: face_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        :param feature_crop: feature_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        :param fit_and_fill: fit_and_fill block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param im_query: im_query block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param region_of_interest_crop: region_of_interest_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        :param relative_crop: relative_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param resize: resize block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        :param rotate: rotate block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        :param scale: scale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param shear: shear block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        :param trim: trim block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cf732182872dea3f3878f6f1a98b994df8f1bb88c2ee6eb6b32470518adc9867)
            check_type(argname="argument append", value=append, expected_type=type_hints["append"])
            check_type(argname="argument aspect_crop", value=aspect_crop, expected_type=type_hints["aspect_crop"])
            check_type(argname="argument background_color", value=background_color, expected_type=type_hints["background_color"])
            check_type(argname="argument blur", value=blur, expected_type=type_hints["blur"])
            check_type(argname="argument chroma_key", value=chroma_key, expected_type=type_hints["chroma_key"])
            check_type(argname="argument composite", value=composite, expected_type=type_hints["composite"])
            check_type(argname="argument compound", value=compound, expected_type=type_hints["compound"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument crop", value=crop, expected_type=type_hints["crop"])
            check_type(argname="argument face_crop", value=face_crop, expected_type=type_hints["face_crop"])
            check_type(argname="argument feature_crop", value=feature_crop, expected_type=type_hints["feature_crop"])
            check_type(argname="argument fit_and_fill", value=fit_and_fill, expected_type=type_hints["fit_and_fill"])
            check_type(argname="argument goop", value=goop, expected_type=type_hints["goop"])
            check_type(argname="argument grayscale", value=grayscale, expected_type=type_hints["grayscale"])
            check_type(argname="argument hsl", value=hsl, expected_type=type_hints["hsl"])
            check_type(argname="argument hsv", value=hsv, expected_type=type_hints["hsv"])
            check_type(argname="argument if_dimension", value=if_dimension, expected_type=type_hints["if_dimension"])
            check_type(argname="argument if_orientation", value=if_orientation, expected_type=type_hints["if_orientation"])
            check_type(argname="argument im_query", value=im_query, expected_type=type_hints["im_query"])
            check_type(argname="argument max_colors", value=max_colors, expected_type=type_hints["max_colors"])
            check_type(argname="argument mirror", value=mirror, expected_type=type_hints["mirror"])
            check_type(argname="argument mono_hue", value=mono_hue, expected_type=type_hints["mono_hue"])
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument region_of_interest_crop", value=region_of_interest_crop, expected_type=type_hints["region_of_interest_crop"])
            check_type(argname="argument relative_crop", value=relative_crop, expected_type=type_hints["relative_crop"])
            check_type(argname="argument remove_color", value=remove_color, expected_type=type_hints["remove_color"])
            check_type(argname="argument resize", value=resize, expected_type=type_hints["resize"])
            check_type(argname="argument rotate", value=rotate, expected_type=type_hints["rotate"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument shear", value=shear, expected_type=type_hints["shear"])
            check_type(argname="argument trim", value=trim, expected_type=type_hints["trim"])
            check_type(argname="argument unsharp_mask", value=unsharp_mask, expected_type=type_hints["unsharp_mask"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if append is not None:
            self._values["append"] = append
        if aspect_crop is not None:
            self._values["aspect_crop"] = aspect_crop
        if background_color is not None:
            self._values["background_color"] = background_color
        if blur is not None:
            self._values["blur"] = blur
        if chroma_key is not None:
            self._values["chroma_key"] = chroma_key
        if composite is not None:
            self._values["composite"] = composite
        if compound is not None:
            self._values["compound"] = compound
        if contrast is not None:
            self._values["contrast"] = contrast
        if crop is not None:
            self._values["crop"] = crop
        if face_crop is not None:
            self._values["face_crop"] = face_crop
        if feature_crop is not None:
            self._values["feature_crop"] = feature_crop
        if fit_and_fill is not None:
            self._values["fit_and_fill"] = fit_and_fill
        if goop is not None:
            self._values["goop"] = goop
        if grayscale is not None:
            self._values["grayscale"] = grayscale
        if hsl is not None:
            self._values["hsl"] = hsl
        if hsv is not None:
            self._values["hsv"] = hsv
        if if_dimension is not None:
            self._values["if_dimension"] = if_dimension
        if if_orientation is not None:
            self._values["if_orientation"] = if_orientation
        if im_query is not None:
            self._values["im_query"] = im_query
        if max_colors is not None:
            self._values["max_colors"] = max_colors
        if mirror is not None:
            self._values["mirror"] = mirror
        if mono_hue is not None:
            self._values["mono_hue"] = mono_hue
        if opacity is not None:
            self._values["opacity"] = opacity
        if region_of_interest_crop is not None:
            self._values["region_of_interest_crop"] = region_of_interest_crop
        if relative_crop is not None:
            self._values["relative_crop"] = relative_crop
        if remove_color is not None:
            self._values["remove_color"] = remove_color
        if resize is not None:
            self._values["resize"] = resize
        if rotate is not None:
            self._values["rotate"] = rotate
        if scale is not None:
            self._values["scale"] = scale
        if shear is not None:
            self._values["shear"] = shear
        if trim is not None:
            self._values["trim"] = trim
        if unsharp_mask is not None:
            self._values["unsharp_mask"] = unsharp_mask

    @builtins.property
    def append(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanAppend"]]]:
        '''append block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        '''
        result = self._values.get("append")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanAppend"]]], result)

    @builtins.property
    def aspect_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanAspectCrop"]]]:
        '''aspect_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        '''
        result = self._values.get("aspect_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanAspectCrop"]]], result)

    @builtins.property
    def background_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanBackgroundColor"]]]:
        '''background_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        '''
        result = self._values.get("background_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanBackgroundColor"]]], result)

    @builtins.property
    def blur(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanBlur"]]]:
        '''blur block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        '''
        result = self._values.get("blur")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanBlur"]]], result)

    @builtins.property
    def chroma_key(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanChromaKey"]]]:
        '''chroma_key block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        '''
        result = self._values.get("chroma_key")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanChromaKey"]]], result)

    @builtins.property
    def composite(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanComposite"]]]:
        '''composite block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        '''
        result = self._values.get("composite")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanComposite"]]], result)

    @builtins.property
    def compound(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanCompound"]]]:
        '''compound block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        '''
        result = self._values.get("compound")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanCompound"]]], result)

    @builtins.property
    def contrast(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanContrast"]]]:
        '''contrast block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanContrast"]]], result)

    @builtins.property
    def crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanCrop"]]]:
        '''crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        '''
        result = self._values.get("crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanCrop"]]], result)

    @builtins.property
    def face_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanFaceCrop"]]]:
        '''face_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        '''
        result = self._values.get("face_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanFaceCrop"]]], result)

    @builtins.property
    def feature_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanFeatureCrop"]]]:
        '''feature_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        '''
        result = self._values.get("feature_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanFeatureCrop"]]], result)

    @builtins.property
    def fit_and_fill(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanFitAndFill"]]]:
        '''fit_and_fill block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        '''
        result = self._values.get("fit_and_fill")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanFitAndFill"]]], result)

    @builtins.property
    def goop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanGoop"]]]:
        '''goop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        '''
        result = self._values.get("goop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanGoop"]]], result)

    @builtins.property
    def grayscale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanGrayscale"]]]:
        '''grayscale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        '''
        result = self._values.get("grayscale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanGrayscale"]]], result)

    @builtins.property
    def hsl(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanHsl"]]]:
        '''hsl block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        '''
        result = self._values.get("hsl")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanHsl"]]], result)

    @builtins.property
    def hsv(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanHsv"]]]:
        '''hsv block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        '''
        result = self._values.get("hsv")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanHsv"]]], result)

    @builtins.property
    def if_dimension(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfDimension"]]]:
        '''if_dimension block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        '''
        result = self._values.get("if_dimension")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfDimension"]]], result)

    @builtins.property
    def if_orientation(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfOrientation"]]]:
        '''if_orientation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        '''
        result = self._values.get("if_orientation")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfOrientation"]]], result)

    @builtins.property
    def im_query(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanImQuery"]]]:
        '''im_query block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        '''
        result = self._values.get("im_query")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanImQuery"]]], result)

    @builtins.property
    def max_colors(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanMaxColors"]]]:
        '''max_colors block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        '''
        result = self._values.get("max_colors")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanMaxColors"]]], result)

    @builtins.property
    def mirror(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanMirror"]]]:
        '''mirror block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        '''
        result = self._values.get("mirror")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanMirror"]]], result)

    @builtins.property
    def mono_hue(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanMonoHue"]]]:
        '''mono_hue block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        '''
        result = self._values.get("mono_hue")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanMonoHue"]]], result)

    @builtins.property
    def opacity(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanOpacity"]]]:
        '''opacity block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanOpacity"]]], result)

    @builtins.property
    def region_of_interest_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanRegionOfInterestCrop"]]]:
        '''region_of_interest_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        '''
        result = self._values.get("region_of_interest_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanRegionOfInterestCrop"]]], result)

    @builtins.property
    def relative_crop(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanRelativeCrop"]]]:
        '''relative_crop block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        '''
        result = self._values.get("relative_crop")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanRelativeCrop"]]], result)

    @builtins.property
    def remove_color(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanRemoveColor"]]]:
        '''remove_color block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        '''
        result = self._values.get("remove_color")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanRemoveColor"]]], result)

    @builtins.property
    def resize(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanResize"]]]:
        '''resize block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        '''
        result = self._values.get("resize")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanResize"]]], result)

    @builtins.property
    def rotate(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanRotate"]]]:
        '''rotate block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        '''
        result = self._values.get("rotate")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanRotate"]]], result)

    @builtins.property
    def scale(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanScale"]]]:
        '''scale block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanScale"]]], result)

    @builtins.property
    def shear(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanShear"]]]:
        '''shear block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        '''
        result = self._values.get("shear")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanShear"]]], result)

    @builtins.property
    def trim(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanTrim"]]]:
        '''trim block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        '''
        result = self._values.get("trim")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanTrim"]]], result)

    @builtins.property
    def unsharp_mask(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanUnsharpMask"]]]:
        '''unsharp_mask block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        result = self._values.get("unsharp_mask")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanUnsharpMask"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanAppend",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_priority": "gravityPriority",
        "gravity_priority_var": "gravityPriorityVar",
        "gravity_var": "gravityVar",
        "preserve_minor_dimension": "preserveMinorDimension",
        "preserve_minor_dimension_var": "preserveMinorDimensionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanAppend:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanAppendImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_priority: typing.Optional[builtins.str] = None,
        gravity_priority_var: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        preserve_minor_dimension: typing.Optional[builtins.str] = None,
        preserve_minor_dimension_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Specifies where to place the ``image`` relative to the source image. The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_priority: Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal. The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority DataAkamaiImagingPolicyImage#gravity_priority}
        :param gravity_priority_var: Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal. The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority_var DataAkamaiImagingPolicyImage#gravity_priority_var}
        :param gravity_var: Specifies where to place the ``image`` relative to the source image. The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param preserve_minor_dimension: Whether to preserve the source image's minor dimension, ``false`` by default. The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension DataAkamaiImagingPolicyImage#preserve_minor_dimension}
        :param preserve_minor_dimension_var: Whether to preserve the source image's minor dimension, ``false`` by default. The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension_var DataAkamaiImagingPolicyImage#preserve_minor_dimension_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanAppendImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bd23e59e1f0110c5f332edb98c2ce9735f00cb71ef52aa41a452bfe0dfc09eda)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_priority", value=gravity_priority, expected_type=type_hints["gravity_priority"])
            check_type(argname="argument gravity_priority_var", value=gravity_priority_var, expected_type=type_hints["gravity_priority_var"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument preserve_minor_dimension", value=preserve_minor_dimension, expected_type=type_hints["preserve_minor_dimension"])
            check_type(argname="argument preserve_minor_dimension_var", value=preserve_minor_dimension_var, expected_type=type_hints["preserve_minor_dimension_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_priority is not None:
            self._values["gravity_priority"] = gravity_priority
        if gravity_priority_var is not None:
            self._values["gravity_priority_var"] = gravity_priority_var
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if preserve_minor_dimension is not None:
            self._values["preserve_minor_dimension"] = preserve_minor_dimension
        if preserve_minor_dimension_var is not None:
            self._values["preserve_minor_dimension_var"] = preserve_minor_dimension_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanAppendImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanAppendImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Specifies where to place the ``image`` relative to the source image.

        The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_priority(self) -> typing.Optional[builtins.str]:
        '''Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal.

        The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority DataAkamaiImagingPolicyImage#gravity_priority}
        '''
        result = self._values.get("gravity_priority")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_priority_var(self) -> typing.Optional[builtins.str]:
        '''Determines the exact placement of the ``image`` when ``gravity`` is ``Center`` or a diagonal.

        The value is either ``horizontal`` or ``vertical``. Use ``horizontal`` to append an ``image`` east or west of the source image. This aligns the ``image`` on the vertical gravity component, placing ``Center`` gravity east. Use ``vertical`` to append an ``image`` north or south of the source image. This aligns the ``image`` on the horizontal gravity component, placing ``Center`` gravity south.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority_var DataAkamaiImagingPolicyImage#gravity_priority_var}
        '''
        result = self._values.get("gravity_priority_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Specifies where to place the ``image`` relative to the source image.

        The available values represent the eight cardinal directions (``North``, ``South``, ``East``, ``West``, ``NorthEast``, ``NorthWest``, ``SouthEast``, ``SouthWest``) and a ``Center`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def preserve_minor_dimension(self) -> typing.Optional[builtins.str]:
        '''Whether to preserve the source image's minor dimension, ``false`` by default.

        The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension DataAkamaiImagingPolicyImage#preserve_minor_dimension}
        '''
        result = self._values.get("preserve_minor_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def preserve_minor_dimension_var(self) -> typing.Optional[builtins.str]:
        '''Whether to preserve the source image's minor dimension, ``false`` by default.

        The minor dimension is the dimension opposite the dimension that the appending ``image`` is placed. For example, the dimensions of the source image are 100 × 100 pixels. The dimensions of the appending ``image`` are 50 × 150 pixels. The ``gravity`` is set to ``East``. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the ``preserveMinorDimension`` is set to ``true``. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 × 100 pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension_var DataAkamaiImagingPolicyImage#preserve_minor_dimension_var}
        '''
        result = self._values.get("preserve_minor_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanAppend(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanAppendImage",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanAppendImage:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanAppendImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanAppendImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanAppendImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__015eee4319f29d49a8ef844bb0479501f9a4ee217fcf59406ab5bf33f481d36a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanAppendImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanAppendImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanAppendImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8b2759e16aaa0bb2fdf294fc914910e93c9af854eccfd20da97960d90bd0a290)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanAppendList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanAppendList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__932bf341e4562b559727de231b2c0f324ee4f1c6ef27776739b7726e1ba75814)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanAppendOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7ff464ae8d987f9057a4f9127d8665a13a341bc2b845026365414ceea481a5e4)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanAppendOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__93fbd253bcce69c1ee7cf5428b35e7ffe670384c02cd87d9ce27c63c893f4b1c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b03fa8f7cbca984b489ec289d25d044d84a7a6a90d9d30cc0e4254451a88d43b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1b21e75e9748d3a22c60d9f66d4e3c6a2973879c4fab24e3c4fa5c049291f8fc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanAppend]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanAppend]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanAppend]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b4919d6d634ffe0835a9373bc82d2643d2ac254d6af67415aba724d885e6b700)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanAppendOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanAppendOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__76b4cd8c04fb61de39e6d822f53165ed9baa46169e3c4f759925c6e01bbc8a62)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanAppendImage()

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityPriority")
    def reset_gravity_priority(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityPriority", []))

    @jsii.member(jsii_name="resetGravityPriorityVar")
    def reset_gravity_priority_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityPriorityVar", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPreserveMinorDimension")
    def reset_preserve_minor_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPreserveMinorDimension", []))

    @jsii.member(jsii_name="resetPreserveMinorDimensionVar")
    def reset_preserve_minor_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPreserveMinorDimensionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanAppendImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanAppendImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityInput")
    def gravity_priority_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityPriorityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityVarInput")
    def gravity_priority_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityPriorityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanAppendImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanAppendImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionInput")
    def preserve_minor_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "preserveMinorDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionVarInput")
    def preserve_minor_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "preserveMinorDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__57c0ad8501a6c1425f4c2d03e8e2244c23de2cb727173b3c4728d881e26cc2f8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityPriority")
    def gravity_priority(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityPriority"))

    @gravity_priority.setter
    def gravity_priority(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e9f36e43f63d961c99bf93dbd7ab72b1a770fdfa808e98dc67194afdae1c9457)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityPriority", value)

    @builtins.property
    @jsii.member(jsii_name="gravityPriorityVar")
    def gravity_priority_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityPriorityVar"))

    @gravity_priority_var.setter
    def gravity_priority_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c2b01a7ccc37559e24c0f71caf66ec2ccafb5300579afb5e66dee7b499deda31)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityPriorityVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__addcfcb271d59a5998fdad950e6c1ba8d4498328c2d473fdd6f7822934af0573)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimension")
    def preserve_minor_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "preserveMinorDimension"))

    @preserve_minor_dimension.setter
    def preserve_minor_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d7042572088941d35bbd1e90a4893fd28740eddf033ae1f1f7a7600f6823fe26)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "preserveMinorDimension", value)

    @builtins.property
    @jsii.member(jsii_name="preserveMinorDimensionVar")
    def preserve_minor_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "preserveMinorDimensionVar"))

    @preserve_minor_dimension_var.setter
    def preserve_minor_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2f227f822efba04ae854400d03437360f40d90735691aa0c16043f5fb3d70733)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "preserveMinorDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanAppend]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanAppend]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanAppend]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3c149906c666af43361f9ae854ecdf645d8157c163d807a37872dc86b9d5dd25)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanAspectCrop",
    jsii_struct_bases=[],
    name_mapping={
        "allow_expansion": "allowExpansion",
        "allow_expansion_var": "allowExpansionVar",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanAspectCrop:
    def __init__(
        self,
        *,
        allow_expansion: typing.Optional[builtins.str] = None,
        allow_expansion_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_expansion: Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image. Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        :param allow_expansion_var: Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image. Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        :param height: The height term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The width term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width term of the aspect ratio to crop. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        :param x_position: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2c1834b6c6dd59bb1fe73e318270f7507fa0ed4228765b22e91b24c98b0c4ff6)
            check_type(argname="argument allow_expansion", value=allow_expansion, expected_type=type_hints["allow_expansion"])
            check_type(argname="argument allow_expansion_var", value=allow_expansion_var, expected_type=type_hints["allow_expansion_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if allow_expansion is not None:
            self._values["allow_expansion"] = allow_expansion
        if allow_expansion_var is not None:
            self._values["allow_expansion_var"] = allow_expansion_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def allow_expansion(self) -> typing.Optional[builtins.str]:
        '''Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image.

        Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        '''
        result = self._values.get("allow_expansion")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def allow_expansion_var(self) -> typing.Optional[builtins.str]:
        '''Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image.

        Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        '''
        result = self._values.get("allow_expansion_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width term of the aspect ratio to crop.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied.

        When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanAspectCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanAspectCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanAspectCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d6eba68bdc175389c87a388ac02a9354e55c16043dcd3f3884cdff52c6096d9a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanAspectCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__09eac71dc29ab66ebcbad403d894b7e07fafc9d575f6a557e7d059e2c295577f)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanAspectCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f782e9122b2fe592763cc5771bf8fa07dee7fb93c89076b4a45fd678b1481172)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__36cba6e3dd5535356b8870d42e9758831312590219e94f190298a300db54c95f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__35b52417dde97149ca971a51023a1fda22fa0e7429dca5664e74186fdee43d8c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanAspectCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanAspectCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanAspectCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0a8e61860b1adf2eadfbc34a43559383e54a95fbb67426b6279917a57a1faa35)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanAspectCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanAspectCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__607d408ecb5d7b196dbccd1edb4af700d4cb1b347c64ba11842035cd7197a1ec)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAllowExpansion")
    def reset_allow_expansion(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansion", []))

    @jsii.member(jsii_name="resetAllowExpansionVar")
    def reset_allow_expansion_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansionVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionInput")
    def allow_expansion_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVarInput")
    def allow_expansion_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansion")
    def allow_expansion(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansion"))

    @allow_expansion.setter
    def allow_expansion(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab8a38f1c06dd715d94b08ef2d28de1ed2b62bb675b500fdf24861cb5784df94)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansion", value)

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVar")
    def allow_expansion_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansionVar"))

    @allow_expansion_var.setter
    def allow_expansion_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ba3cd3a2e7debd53797664052c0fdcda1514ad351ff58fb380d2897aeab7af49)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansionVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e9efaf73e27e4d1b1ac5bafdc0f6942d6fbb5c59340b29e824d51252d90a5731)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7ba4da23434b63de84204512671944ae29c5b48c5e792ef758c22070fcd18ccc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2b5e3171836fe5df54c68fbcdb2ed025b04fb615c619fe1aa11caf0a7615a7c0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__10639bd069e0f585eb1f112b6be4148a5fc3f4d2a198ace95f796abbf321e2db)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0602ce6024ec2f37f1ce8f9781f5400aa18c4e947b52ef8aacb871c4ade741b1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ce737c29bbc33b3ffccbf77ab5456d0e7a7d6b1846b95ea808a2d8ccd654c4e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2767e616c94605d33ebe82838a0859df8796370f4ce0f5aae2bee31778b51e9c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc724e08c8d25f4667390bfb52064227b202bb8664150c0fd487fcbc2573c9dc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanAspectCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanAspectCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanAspectCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c0566d46bb9a4c502c78493b1d77a0878ba0db2d8cd47fcc947d4b44a8f272bf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanBackgroundColor",
    jsii_struct_bases=[],
    name_mapping={"color": "color", "color_var": "colorVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanBackgroundColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value for the background. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c0af45ea467ea61117560b52ba74ae4d9d9af0139c2721c94dde722108fab733)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value for the background.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanBackgroundColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanBackgroundColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanBackgroundColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8b4a5109ca297d9bfad22249eafe2fdc32de4e978ca87ae179bc56f3126d58b8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanBackgroundColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c91c4e9c3df0370f41dae946db92b173618d76ea8e7af0559506602f65603eac)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanBackgroundColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5d433c790289508a83428f026371ceb542c3a16530403acfeb07e5d0d77b4635)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7f115dcaca4bb8d1567a07254ae7f8540ee3ccab34f0cf34fcfadd5f0989a914)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__29cd4fc9b237b97f3cc815366559fe4dfe677a6beba095c288cf3647b65c60d6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanBackgroundColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanBackgroundColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__11e227c041b40058c2fa1b25af245e163a6d69dd30e4e14c2b143ff59361bf25)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanBackgroundColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanBackgroundColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9f1e74a7ae00062a52b197b588cdbc40cb30a3db1ed80c3f037cfd5078325d89)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fe50bb1e964abcb947bf4b6084c3f2c5a2e9d7b12a24b12502c50578a1a5c727)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1d12ee97e7936cfdd199ebf05c55f966e0413f92e60428caa276e9b18d6e20bd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanBackgroundColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanBackgroundColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanBackgroundColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4e26ba29261b64b79148ccfd539400e08abfc375c95f5574de2291d209884706)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanBlur",
    jsii_struct_bases=[],
    name_mapping={"sigma": "sigma", "sigma_var": "sigmaVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanBlur:
    def __init__(
        self,
        *,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param sigma: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2e2ee49bb304869e8cabc0cf34c8866604ba9de4fa72c03b92fbcff931ddbb17)
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to scatter the original pixel by to create the blur effect.

        Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanBlur(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanBlurList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanBlurList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6beeb29c92f74f5bf4d107888efc3a50d80fd5a4b8bc296ed65ded43fda0b3eb)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanBlurOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__921f73fd03e0c8c4f58f46445a3f12d674a5777a3bb741db8b52e12a3d020d93)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanBlurOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1615a798281b99f03b3ff18c511d77c023c767fdbd2f30b6f5b4534b7f6d9679)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a8922ba4fc2a088d7530997eb3dc85af419e07f2d8378d5a39862121a02c4f4d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5c81ae3737e130e0b35b7f76c6daf382787ee78aa725a3283883b318b6c2be69)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanBlur]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanBlur]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ed1a6eaf358f577a7340036778fbafe987482ad83aaa4473fe521d378e3eb3f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanBlurOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanBlurOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__26d754c405a034042b35ea28a9761e6b8cfb6b03d383c89ecb3220f6087931e5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b7e7310932e0cf88b255c7d3a14177cd5ac735feb60e808dd03422ef03bbd210)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__11c1bc41c62d861f3efd77b53724489114fc7da60359226b482518480e92d501)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanBlur]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanBlur]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanBlur]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0a960065a2417718f8f85958ff584a0fc70540b50b799fca84e63cd8831faff9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanChromaKey",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_feather": "hueFeather",
        "hue_feather_var": "hueFeatherVar",
        "hue_tolerance": "hueTolerance",
        "hue_tolerance_var": "hueToleranceVar",
        "hue_var": "hueVar",
        "lightness_feather": "lightnessFeather",
        "lightness_feather_var": "lightnessFeatherVar",
        "lightness_tolerance": "lightnessTolerance",
        "lightness_tolerance_var": "lightnessToleranceVar",
        "saturation_feather": "saturationFeather",
        "saturation_feather_var": "saturationFeatherVar",
        "saturation_tolerance": "saturationTolerance",
        "saturation_tolerance_var": "saturationToleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanChromaKey:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_feather: typing.Optional[builtins.str] = None,
        hue_feather_var: typing.Optional[builtins.str] = None,
        hue_tolerance: typing.Optional[builtins.str] = None,
        hue_tolerance_var: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness_feather: typing.Optional[builtins.str] = None,
        lightness_feather_var: typing.Optional[builtins.str] = None,
        lightness_tolerance: typing.Optional[builtins.str] = None,
        lightness_tolerance_var: typing.Optional[builtins.str] = None,
        saturation_feather: typing.Optional[builtins.str] = None,
        saturation_feather_var: typing.Optional[builtins.str] = None,
        saturation_tolerance: typing.Optional[builtins.str] = None,
        saturation_tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_feather: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        :param hue_feather_var: How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        :param hue_tolerance: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        :param hue_tolerance_var: How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        :param hue_var: The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness_feather: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        :param lightness_feather_var: How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        :param lightness_tolerance: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        :param lightness_tolerance_var: How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        :param saturation_feather: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        :param saturation_feather_var: How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        :param saturation_tolerance: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        :param saturation_tolerance_var: How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2e0284294bd7a48474e26fa378916d8f612659462652cbc2c2a8160f5f25aa9f)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_feather", value=hue_feather, expected_type=type_hints["hue_feather"])
            check_type(argname="argument hue_feather_var", value=hue_feather_var, expected_type=type_hints["hue_feather_var"])
            check_type(argname="argument hue_tolerance", value=hue_tolerance, expected_type=type_hints["hue_tolerance"])
            check_type(argname="argument hue_tolerance_var", value=hue_tolerance_var, expected_type=type_hints["hue_tolerance_var"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness_feather", value=lightness_feather, expected_type=type_hints["lightness_feather"])
            check_type(argname="argument lightness_feather_var", value=lightness_feather_var, expected_type=type_hints["lightness_feather_var"])
            check_type(argname="argument lightness_tolerance", value=lightness_tolerance, expected_type=type_hints["lightness_tolerance"])
            check_type(argname="argument lightness_tolerance_var", value=lightness_tolerance_var, expected_type=type_hints["lightness_tolerance_var"])
            check_type(argname="argument saturation_feather", value=saturation_feather, expected_type=type_hints["saturation_feather"])
            check_type(argname="argument saturation_feather_var", value=saturation_feather_var, expected_type=type_hints["saturation_feather_var"])
            check_type(argname="argument saturation_tolerance", value=saturation_tolerance, expected_type=type_hints["saturation_tolerance"])
            check_type(argname="argument saturation_tolerance_var", value=saturation_tolerance_var, expected_type=type_hints["saturation_tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_feather is not None:
            self._values["hue_feather"] = hue_feather
        if hue_feather_var is not None:
            self._values["hue_feather_var"] = hue_feather_var
        if hue_tolerance is not None:
            self._values["hue_tolerance"] = hue_tolerance
        if hue_tolerance_var is not None:
            self._values["hue_tolerance_var"] = hue_tolerance_var
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness_feather is not None:
            self._values["lightness_feather"] = lightness_feather
        if lightness_feather_var is not None:
            self._values["lightness_feather_var"] = lightness_feather_var
        if lightness_tolerance is not None:
            self._values["lightness_tolerance"] = lightness_tolerance
        if lightness_tolerance_var is not None:
            self._values["lightness_tolerance_var"] = lightness_tolerance_var
        if saturation_feather is not None:
            self._values["saturation_feather"] = saturation_feather
        if saturation_feather_var is not None:
            self._values["saturation_feather_var"] = saturation_feather_var
        if saturation_tolerance is not None:
            self._values["saturation_tolerance"] = saturation_tolerance
        if saturation_tolerance_var is not None:
            self._values["saturation_tolerance_var"] = saturation_tolerance_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
        '''
        result = self._values.get("hue_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional hue to make semi-transparent beyond the Hue Tolerance.

        By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
        '''
        result = self._values.get("hue_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
        '''
        result = self._values.get("hue_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's hue needs to be to the selected hue for it to be changed to fully transparent.

        If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
        '''
        result = self._values.get("hue_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The hue to remove.

        Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
        '''
        result = self._values.get("lightness_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional lightness to make semi-transparent beyond the Lightness Tolerance.

        The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
        '''
        result = self._values.get("lightness_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
        '''
        result = self._values.get("lightness_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How much of the lightest part and darkest part of a color to preserve.

        For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
        '''
        result = self._values.get("lightness_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
        '''
        result = self._values.get("saturation_feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_feather_var(self) -> typing.Optional[builtins.str]:
        '''How much additional saturation to make semi-transparent beyond the Saturation Tolerance.

        By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
        '''
        result = self._values.get("saturation_feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
        '''
        result = self._values.get("saturation_tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_tolerance_var(self) -> typing.Optional[builtins.str]:
        '''How close a color's saturation needs to be to full saturation for it to be changed to fully transparent.

        For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
        '''
        result = self._values.get("saturation_tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanChromaKey(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanChromaKeyList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanChromaKeyList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3b56c0ea29e502c376c9e1c9128ef217293f8a26f0f1389347b3352510f81c49)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanChromaKeyOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__05eda0fb2693aa3ea5cd5fc93c711b5be4879a64d4a5cb8dcedc81d22a45eccc)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanChromaKeyOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__746fa4bfceee461e779bc3a78a0af7a27bcbfc985e2eaee111cf36eaea9332f4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b68b2b505d32eae5cdcd6560144731efa3390c0cb50adc8a65231c6ac9794979)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2810b97d8d6e4ac6d812bfa7ea10ad8431a5e7f22745cfc3fa1cc7adea51a240)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanChromaKey]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanChromaKey]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__41a6dffa091ee53566225614a55c2ce7bca0bdd03b11973ed63b0a0375a80410)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanChromaKeyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanChromaKeyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__923e6ae20d747424b27dfc9559546954b6b0107c7ebb3f25469ad672fa31b38a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueFeather")
    def reset_hue_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeather", []))

    @jsii.member(jsii_name="resetHueFeatherVar")
    def reset_hue_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueFeatherVar", []))

    @jsii.member(jsii_name="resetHueTolerance")
    def reset_hue_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueTolerance", []))

    @jsii.member(jsii_name="resetHueToleranceVar")
    def reset_hue_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueToleranceVar", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightnessFeather")
    def reset_lightness_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeather", []))

    @jsii.member(jsii_name="resetLightnessFeatherVar")
    def reset_lightness_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessFeatherVar", []))

    @jsii.member(jsii_name="resetLightnessTolerance")
    def reset_lightness_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessTolerance", []))

    @jsii.member(jsii_name="resetLightnessToleranceVar")
    def reset_lightness_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessToleranceVar", []))

    @jsii.member(jsii_name="resetSaturationFeather")
    def reset_saturation_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeather", []))

    @jsii.member(jsii_name="resetSaturationFeatherVar")
    def reset_saturation_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationFeatherVar", []))

    @jsii.member(jsii_name="resetSaturationTolerance")
    def reset_saturation_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationTolerance", []))

    @jsii.member(jsii_name="resetSaturationToleranceVar")
    def reset_saturation_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherInput")
    def hue_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVarInput")
    def hue_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceInput")
    def hue_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVarInput")
    def hue_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherInput")
    def lightness_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVarInput")
    def lightness_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceInput")
    def lightness_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVarInput")
    def lightness_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherInput")
    def saturation_feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVarInput")
    def saturation_feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationFeatherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceInput")
    def saturation_tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVarInput")
    def saturation_tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationToleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0cb86481b63dc61472264a30364099bde44cec6ac0e3c7846d1abc2665d3fe2c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeather")
    def hue_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeather"))

    @hue_feather.setter
    def hue_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cffe660538fc9241143b5ef188e65b4afc9cd09ed51e44827e5c1a7ad75dd2dd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeather", value)

    @builtins.property
    @jsii.member(jsii_name="hueFeatherVar")
    def hue_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueFeatherVar"))

    @hue_feather_var.setter
    def hue_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__610bb969071ded2266dd908fd30e7300b423d838fd80679ee2057101b54bbe48)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueTolerance")
    def hue_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueTolerance"))

    @hue_tolerance.setter
    def hue_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d85c87459f19ce01bb3cb746d2d34b97eb1985d9149afe0d5b56d419757cb720)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="hueToleranceVar")
    def hue_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueToleranceVar"))

    @hue_tolerance_var.setter
    def hue_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ec574dd0ddf481f173764ab1d20b589828c9b2994f4b08b96e78e4dd8a2ba6ee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ef0b87cd8dee3bc71c0ad42e358960d13ec2bcdf81a78714d573b29f72cceaee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeather")
    def lightness_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeather"))

    @lightness_feather.setter
    def lightness_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0338d57188635dfecf51daa7978faf98df2edf4cf10b67efae9e58a2bb5621bd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeather", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessFeatherVar")
    def lightness_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessFeatherVar"))

    @lightness_feather_var.setter
    def lightness_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__52fc767c7c20274ff5b6693afa55e201e8a50bb5e118a4867e16ecead131d0e6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessTolerance")
    def lightness_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessTolerance"))

    @lightness_tolerance.setter
    def lightness_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5e7f301562c1fb9cfac7db41fdc1a2f156d2c67195d81196b36161e3d5051a18)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessToleranceVar")
    def lightness_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessToleranceVar"))

    @lightness_tolerance_var.setter
    def lightness_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ed099d0f92d5f250fdebd3e1de0f92b36b4598c29cd4ad1a45b6aaf6a4509243)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeather")
    def saturation_feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeather"))

    @saturation_feather.setter
    def saturation_feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4b5c2d11ca8a5b71c723e7ab3ee32c1ae14a7857b8a5b7290a70d977239c588d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeather", value)

    @builtins.property
    @jsii.member(jsii_name="saturationFeatherVar")
    def saturation_feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationFeatherVar"))

    @saturation_feather_var.setter
    def saturation_feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d983200c2b35a6f265883a4fb278ad6de8d1a4aec7525ebf51f3f1c6056afa34)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationFeatherVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturationTolerance")
    def saturation_tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationTolerance"))

    @saturation_tolerance.setter
    def saturation_tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1bd0dacde3579190b30aeff6e717bd1ce94321bcb1c7aacf2f16f87d271cc797)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationTolerance", value)

    @builtins.property
    @jsii.member(jsii_name="saturationToleranceVar")
    def saturation_tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationToleranceVar"))

    @saturation_tolerance_var.setter
    def saturation_tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7f347de0d69027ce683829cb17f767d5ef98034e66cf4b3faff82975eb223243)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationToleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanChromaKey]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanChromaKey]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanChromaKey]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__09358d033f84569fa3317dfd19f14eb0e92a51de4dad30b968e7cfeeeb3b4769)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanComposite",
    jsii_struct_bases=[],
    name_mapping={
        "image": "image",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "placement": "placement",
        "placement_var": "placementVar",
        "scale": "scale",
        "scale_dimension": "scaleDimension",
        "scale_dimension_var": "scaleDimensionVar",
        "scale_var": "scaleVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanComposite:
    def __init__(
        self,
        *,
        image: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanCompositeImage", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        placement: typing.Optional[builtins.str] = None,
        placement_var: typing.Optional[builtins.str] = None,
        scale: typing.Optional[builtins.str] = None,
        scale_dimension: typing.Optional[builtins.str] = None,
        scale_dimension_var: typing.Optional[builtins.str] = None,
        scale_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image: image block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        :param gravity: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param placement: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        :param placement_var: Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        :param scale: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param scale_dimension: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        :param scale_dimension_var: The dimension, either ``width`` or ``height``, of the source image to scale. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        :param scale_var: A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        :param x_position: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if isinstance(image, dict):
            image = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanCompositeImage(**image)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7200337fdda17b980e8fb71fa318486f59a8e0cce325d00c51ce056991753d43)
            check_type(argname="argument image", value=image, expected_type=type_hints["image"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument placement", value=placement, expected_type=type_hints["placement"])
            check_type(argname="argument placement_var", value=placement_var, expected_type=type_hints["placement_var"])
            check_type(argname="argument scale", value=scale, expected_type=type_hints["scale"])
            check_type(argname="argument scale_dimension", value=scale_dimension, expected_type=type_hints["scale_dimension"])
            check_type(argname="argument scale_dimension_var", value=scale_dimension_var, expected_type=type_hints["scale_dimension_var"])
            check_type(argname="argument scale_var", value=scale_var, expected_type=type_hints["scale_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "image": image,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if placement is not None:
            self._values["placement"] = placement
        if placement_var is not None:
            self._values["placement_var"] = placement_var
        if scale is not None:
            self._values["scale"] = scale
        if scale_dimension is not None:
            self._values["scale_dimension"] = scale_dimension
        if scale_dimension_var is not None:
            self._values["scale_dimension_var"] = scale_dimension_var
        if scale_var is not None:
            self._values["scale_var"] = scale_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def image(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanCompositeImage":
        '''image block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
        '''
        result = self._values.get("image")
        assert result is not None, "Required property 'image' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanCompositeImage", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Compass direction indicating the corner or edge of the base image to place the applied image.

        Use Horizontal and Vertical Offset to adjust the applied image's gravity position

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
        '''
        result = self._values.get("placement")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def placement_var(self) -> typing.Optional[builtins.str]:
        '''Place applied image on top of or underneath the base image.

        Watermarks are usually applied over. Backgrounds are usually applied under.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
        '''
        result = self._values.get("placement_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        '''
        result = self._values.get("scale")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
        '''
        result = self._values.get("scale_dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension, either ``width`` or ``height``, of the source image to scale.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
        '''
        result = self._values.get("scale_dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scale_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default.

        Set the ``scaleDimension`` to calculate the ``scale`` from the source image's width or height.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
        '''
        result = self._values.get("scale_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanComposite(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanCompositeImage",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanCompositeImage:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanCompositeImage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanCompositeImageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanCompositeImageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1ad04e0af8ee040f9dd754902cadcde64e98e1fe97d3939322fd1d14690bd5b8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanCompositeImage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanCompositeImage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0bd01453c29bb1aead28e5d9adffdec8eb2c06fb1c0b56b90f0501bb49a15eb5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanCompositeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanCompositeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a25c019cbb511bdb542939ec3beabe9dca2ec3469904f650b03d35c8f9df6988)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanCompositeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aafe148f01d648147a2404d586ebbe6d918a6e5a7781f83a6ca6ad33fdeaa54d)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanCompositeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a9cc0f5c13e451bd664c8a32cb6c9e24dade7a08a60ff1c39fa203530c66b8cc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__78d2e21f7424c8f65992b6fd6af70edbb299db10b572f4d9700ad78726c5b923)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__326a71802d5b164c01882bcbd0393708dc22d0d000ea022356d3967332454678)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanComposite]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanComposite]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__90985ec797d9c40adb624ceb6ee11b76825650453805c2c921c4d1706fe74bbc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanCompositeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanCompositeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5a5efde369ed43da764c66118819ed87f05d10635eed800cd1d661df57df9dfb)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putImage")
    def put_image(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanCompositeImage()

        return typing.cast(None, jsii.invoke(self, "putImage", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetPlacement")
    def reset_placement(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacement", []))

    @jsii.member(jsii_name="resetPlacementVar")
    def reset_placement_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPlacementVar", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetScaleDimension")
    def reset_scale_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimension", []))

    @jsii.member(jsii_name="resetScaleDimensionVar")
    def reset_scale_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleDimensionVar", []))

    @jsii.member(jsii_name="resetScaleVar")
    def reset_scale_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScaleVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="image")
    def image(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanCompositeImageOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanCompositeImageOutputReference, jsii.get(self, "image"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="imageInput")
    def image_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanCompositeImage]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanCompositeImage], jsii.get(self, "imageInput"))

    @builtins.property
    @jsii.member(jsii_name="placementInput")
    def placement_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementInput"))

    @builtins.property
    @jsii.member(jsii_name="placementVarInput")
    def placement_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "placementVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionInput")
    def scale_dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVarInput")
    def scale_dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleDimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleVarInput")
    def scale_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scaleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__58180cf262383b009a99c54b8dd532b327ad30e40ddfe5020b5edbe9535c6961)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__44d23495667171c705a2dce039d0205047a3b7d7603b5bf958aad16f1450f14e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="placement")
    def placement(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placement"))

    @placement.setter
    def placement(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__236db6c83813c56647f65c0a1b0f3f5023ad39d7474767885db4c29e81142ccb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placement", value)

    @builtins.property
    @jsii.member(jsii_name="placementVar")
    def placement_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "placementVar"))

    @placement_var.setter
    def placement_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__287c417093f70fa6939e426c2b0cc71edfc3d438546489bb68744fb0944ba9b2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "placementVar", value)

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scale"))

    @scale.setter
    def scale(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a7122fca07ea881361931f4d1c633955b6b81e77975bca3bb868b8c565da1c7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scale", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimension")
    def scale_dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimension"))

    @scale_dimension.setter
    def scale_dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__da387b33c6798b99c3c7b8248f06f66284398dd4a619591e38b1722021ca3bda)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimension", value)

    @builtins.property
    @jsii.member(jsii_name="scaleDimensionVar")
    def scale_dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleDimensionVar"))

    @scale_dimension_var.setter
    def scale_dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2e99eafe0f4410d6cbe84907b14360f86a913b2c47f81e5e38a717380e0631f3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleDimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="scaleVar")
    def scale_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scaleVar"))

    @scale_var.setter
    def scale_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__21285ff083b34e83b3fcb95cb5a414896ebbf4d87f46de889f1c96f9d866cbf2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scaleVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8ab06d1d1dbbcf15c4d09001805603eda9df1a9d3371cffad6514ff681ae2e9b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__821782504a99b684d76ff8617291a0e31df3f792d132f332ab282541893ca77d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0437212adf7b1a7d287213e3500e7bdf64002ca327c288a874167313b92e6d2c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a75d63655b71ffdd68ba129175feccecbde163484557e9680fb104a3fe6c388)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanComposite]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanComposite]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanComposite]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b9cf6e7ecf7cf0c8bea00d94196aa1011bf0140a7920679a33c4cb7563f05f66)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanCompound",
    jsii_struct_bases=[],
    name_mapping={"transformations": "transformations"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanCompound:
    def __init__(
        self,
        *,
        transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param transformations: transformations block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__168abed2dca5d46574c71787d5001c5bddec8fd5c8a93e68c4f5be1aa378133f)
            check_type(argname="argument transformations", value=transformations, expected_type=type_hints["transformations"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if transformations is not None:
            self._values["transformations"] = transformations

    @builtins.property
    def transformations(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanCompoundTransformations"]]]:
        '''transformations block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
        '''
        result = self._values.get("transformations")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanCompoundTransformations"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanCompound(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanCompoundList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanCompoundList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__99ea1aeae92c7c802bbbab046b97a3ab97ba4aaf522b89afbd969f2c3736b9dd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanCompoundOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__928e791da7ba424e8a3514266e4d0db164f0f718a489c47a635e4c847dfbcb3d)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanCompoundOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__97336606265238ff4a494699d7bc7c826cef5b36cf73eedbc1b5f06dc57b9a87)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab948a4df800e1a3984afd77ca8bdfcdfe52895c3313292553482db0c5bbc3f6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__45aff22c665d2e742c02803c565be5c9f3957ca8c7f99ddfe787e4fa486f4c39)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanCompound]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanCompound]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dbc2e0ce711a2b1aa653f9a31b826daea249acb751a07e97aedcfc398b2e3dbd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanCompoundOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanCompoundOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f8523b9bdd7575620b00dac6a29cc22a1a02c699cabffd0862169b8c7c86bcb5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putTransformations")
    def put_transformations(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanCompoundTransformations", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__94b3169631c6a9687a86b39e006ad440aab2ae5e5b977ffc06b1a83d1dabd128)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTransformations", [value]))

    @jsii.member(jsii_name="resetTransformations")
    def reset_transformations(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransformations", []))

    @builtins.property
    @jsii.member(jsii_name="transformations")
    def transformations(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanCompoundTransformationsList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanCompoundTransformationsList", jsii.get(self, "transformations"))

    @builtins.property
    @jsii.member(jsii_name="transformationsInput")
    def transformations_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanCompoundTransformations"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanCompoundTransformations"]]], jsii.get(self, "transformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanCompound]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanCompound]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanCompound]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9e9c7b37719e48b5facf48ba40526a5bce7f831ba1d955e50ddc13a605b11df7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanCompoundTransformations",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanCompoundTransformations:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanCompoundTransformations(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanCompoundTransformationsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanCompoundTransformationsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c90ad5548823659b8b0e0340ed51834774a3251bb44b6e636ce864a98158d266)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanCompoundTransformationsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a109ede6b32c5231b737a0dab2e86e0e48d09888fefa8e2748e6ff7c860fefe8)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanCompoundTransformationsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bd95746055bfcf979b59182f0e0e6e58c33b6ac56c3f5a6b836fdefa62c450ea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__18e7a58c54aa518a0f2bd692a50ca97fa0a38a8cb58d79d27032333a13dc9b4e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__982f7760157f208b09ee57fd71222563834be2dcd30d942bb9d2a0de5d6370f0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanCompoundTransformations]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanCompoundTransformations]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanCompoundTransformations]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__11cf42530e9c18f684d29f294d3be1200849176e03b8ef1ec31cf1f8a8cf282b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanCompoundTransformationsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanCompoundTransformationsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__63635c8444b4ae62dc5a28247b65ef0cbaa25c5f589f5cea1bdcddb1543d1a25)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanCompoundTransformations]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanCompoundTransformations]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanCompoundTransformations]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1dd5f55a8cf4223cbdb2e1136658e9e6030e7d4832b54c929e3e9cf3af670149)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanContrast",
    jsii_struct_bases=[],
    name_mapping={
        "brightness": "brightness",
        "brightness_var": "brightnessVar",
        "contrast": "contrast",
        "contrast_var": "contrastVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanContrast:
    def __init__(
        self,
        *,
        brightness: typing.Optional[builtins.str] = None,
        brightness_var: typing.Optional[builtins.str] = None,
        contrast: typing.Optional[builtins.str] = None,
        contrast_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param brightness: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        :param brightness_var: Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of ``1`` produces a white image. A value of ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        :param contrast: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param contrast_var: Adjusts the contrast of the image. Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d70ccd976388c6491a96868542d8c48b35247ec7104bb8a0067037f67f6dfe1b)
            check_type(argname="argument brightness", value=brightness, expected_type=type_hints["brightness"])
            check_type(argname="argument brightness_var", value=brightness_var, expected_type=type_hints["brightness_var"])
            check_type(argname="argument contrast", value=contrast, expected_type=type_hints["contrast"])
            check_type(argname="argument contrast_var", value=contrast_var, expected_type=type_hints["contrast_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if brightness is not None:
            self._values["brightness"] = brightness
        if brightness_var is not None:
            self._values["brightness_var"] = brightness_var
        if contrast is not None:
            self._values["contrast"] = contrast
        if contrast_var is not None:
            self._values["contrast_var"] = contrast_var

    @builtins.property
    def brightness(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
        '''
        result = self._values.get("brightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def brightness_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the brightness of the image.

        Positive values increase brightness and negative values decrease brightness. A value of  ``1`` produces a white image. A value of  ``-1`` produces a black image. The default value is ``0``, which leaves the image unchanged. The acceptable value range is ``-1.0`` to ``1.0``. Values outside of the acceptable range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
        '''
        result = self._values.get("brightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        '''
        result = self._values.get("contrast")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def contrast_var(self) -> typing.Optional[builtins.str]:
        '''Adjusts the contrast of the image.

        Expressed as a range from ``-1`` to ``1``, positive values increase contrast, negative values decrease it, while ``0`` leaves the image unchanged. Values outside of the ``-1`` to ``1`` range clamp to this range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
        '''
        result = self._values.get("contrast_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanContrast(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanContrastList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanContrastList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3fba62e764f7e467dcd9777a76c5ab675890fbacce3943f026469585bc6ce5ca)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanContrastOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f82e02e3fd8a24c2a2d8acfb51ffb0b38f28fa601d671fe33246ffcf401fee5a)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanContrastOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__83b757616387ffe89d809d4d1675bb26e4d1d03672d11a85ed3ce1a09db26e42)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__002517ec829ce9c7c7791e124fc3938b0fc3fa19fa673deae5b6ef8ec1c6f3df)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__32de93d61f6c3376b1838a8fbb977efb8b0a745af4cf780c3f23e79375d1b0f9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanContrast]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanContrast]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__893fe3a173244db07e7abdeea05cdf16555f2025958010c5e7f9045a944af88d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanContrastOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanContrastOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__edb5e9a137d6a377d8b3d22dbb1583b7f59e747ef59603b256a8f21580d18518)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetBrightness")
    def reset_brightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightness", []))

    @jsii.member(jsii_name="resetBrightnessVar")
    def reset_brightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrightnessVar", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetContrastVar")
    def reset_contrast_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrastVar", []))

    @builtins.property
    @jsii.member(jsii_name="brightnessInput")
    def brightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="brightnessVarInput")
    def brightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "brightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastVarInput")
    def contrast_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contrastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="brightness")
    def brightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightness"))

    @brightness.setter
    def brightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__77d7af5c5cc7a4c1eef460180cd36ac0440b9ce17c1f7190205e9be6fa540afb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightness", value)

    @builtins.property
    @jsii.member(jsii_name="brightnessVar")
    def brightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "brightnessVar"))

    @brightness_var.setter
    def brightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__03daf42190607178faefe2468334bd1525439df33429cc6a34cd678855c3ea9c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrast"))

    @contrast.setter
    def contrast(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fce63c38b5d81c9c84bc0afae0c692232fdd13c5afb715666c3bf14cefb094d0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrast", value)

    @builtins.property
    @jsii.member(jsii_name="contrastVar")
    def contrast_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contrastVar"))

    @contrast_var.setter
    def contrast_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__21f7fbebe61d482071da583f282f06791eabeb43938ed3465dca0d87817d995f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contrastVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanContrast]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanContrast]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanContrast]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ce5efe09fe6f31b199846d73d0bee15b8a08c8d5c25539b6f2a835d8a297129)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanCrop",
    jsii_struct_bases=[],
    name_mapping={
        "allow_expansion": "allowExpansion",
        "allow_expansion_var": "allowExpansionVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
        "x_position": "xPosition",
        "x_position_var": "xPositionVar",
        "y_position": "yPosition",
        "y_position_var": "yPositionVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanCrop:
    def __init__(
        self,
        *,
        allow_expansion: typing.Optional[builtins.str] = None,
        allow_expansion_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
        x_position: typing.Optional[builtins.str] = None,
        x_position_var: typing.Optional[builtins.str] = None,
        y_position: typing.Optional[builtins.str] = None,
        y_position_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_expansion: If cropping an area outside of the existing canvas, expands the image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        :param allow_expansion_var: If cropping an area outside of the existing canvas, expands the image canvas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        :param gravity: Frame of reference for X and Y Positions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Frame of reference for X and Y Positions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The number of pixels to crop along the y-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The number of pixels to crop along the y-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The number of pixels to crop along the x-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The number of pixels to crop along the x-axis. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        :param x_position: The x-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        :param x_position_var: The x-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        :param y_position: The y-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        :param y_position_var: The y-axis position of the image to crop from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ccb046735e9227d072bb661584fe4576057dc071655c396d846e0556d3724bd)
            check_type(argname="argument allow_expansion", value=allow_expansion, expected_type=type_hints["allow_expansion"])
            check_type(argname="argument allow_expansion_var", value=allow_expansion_var, expected_type=type_hints["allow_expansion_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
            check_type(argname="argument x_position", value=x_position, expected_type=type_hints["x_position"])
            check_type(argname="argument x_position_var", value=x_position_var, expected_type=type_hints["x_position_var"])
            check_type(argname="argument y_position", value=y_position, expected_type=type_hints["y_position"])
            check_type(argname="argument y_position_var", value=y_position_var, expected_type=type_hints["y_position_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if allow_expansion is not None:
            self._values["allow_expansion"] = allow_expansion
        if allow_expansion_var is not None:
            self._values["allow_expansion_var"] = allow_expansion_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var
        if x_position is not None:
            self._values["x_position"] = x_position
        if x_position_var is not None:
            self._values["x_position_var"] = x_position_var
        if y_position is not None:
            self._values["y_position"] = y_position
        if y_position_var is not None:
            self._values["y_position_var"] = y_position_var

    @builtins.property
    def allow_expansion(self) -> typing.Optional[builtins.str]:
        '''If cropping an area outside of the existing canvas, expands the image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
        '''
        result = self._values.get("allow_expansion")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def allow_expansion_var(self) -> typing.Optional[builtins.str]:
        '''If cropping an area outside of the existing canvas, expands the image canvas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
        '''
        result = self._values.get("allow_expansion_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Frame of reference for X and Y Positions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Frame of reference for X and Y Positions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the y-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the y-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the x-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to crop along the x-axis.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
        '''
        result = self._values.get("x_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_position_var(self) -> typing.Optional[builtins.str]:
        '''The x-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
        '''
        result = self._values.get("x_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
        '''
        result = self._values.get("y_position")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_position_var(self) -> typing.Optional[builtins.str]:
        '''The y-axis position of the image to crop from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
        '''
        result = self._values.get("y_position_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__196b44322d566872819c7c50275e850c4e4b603b90e3cdff376fc7c86a75f233)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__83dde5e41afdb62e234682bcf0f3694f195ff88247f9259aa73243d31c685e3c)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a52b2692dee66cd40df9c68117391aea36a5305e4c19cc5d300d786f58d8f0c8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4339e21008a46169de0d9aba6f55291f47fe5931ceb0d8f01c1be5f68102f30f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fc3f2b291a022e25ac7852c67a8d01f2d7aa94c1acb2b2e07c69f7f713a6b6d8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ace52347e1eb9e3673aadebf91b5a0dc1522f6ec8b49b600f92c22710fa6862)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e5d1b242195f05172d6d1e9bbf723d780700227397f37980c58788294276eed)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAllowExpansion")
    def reset_allow_expansion(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansion", []))

    @jsii.member(jsii_name="resetAllowExpansionVar")
    def reset_allow_expansion_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowExpansionVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @jsii.member(jsii_name="resetXPosition")
    def reset_x_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPosition", []))

    @jsii.member(jsii_name="resetXPositionVar")
    def reset_x_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXPositionVar", []))

    @jsii.member(jsii_name="resetYPosition")
    def reset_y_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPosition", []))

    @jsii.member(jsii_name="resetYPositionVar")
    def reset_y_position_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYPositionVar", []))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionInput")
    def allow_expansion_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVarInput")
    def allow_expansion_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowExpansionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionInput")
    def x_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="xPositionVarInput")
    def x_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionInput")
    def y_position_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionInput"))

    @builtins.property
    @jsii.member(jsii_name="yPositionVarInput")
    def y_position_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yPositionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowExpansion")
    def allow_expansion(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansion"))

    @allow_expansion.setter
    def allow_expansion(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__368d53eb5effe5d761213f6658ba3de717dd0169082f68b9174bc10e2fee2826)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansion", value)

    @builtins.property
    @jsii.member(jsii_name="allowExpansionVar")
    def allow_expansion_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowExpansionVar"))

    @allow_expansion_var.setter
    def allow_expansion_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2b06038b32fe2cb88dc3385bd9282adec3a19241611eff794268cf5909578b52)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowExpansionVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c75a48fa1773f172366831e80a91721a63adf1bf0bff0bdd72da5ced55fe1859)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e3d069c6632318337d9330d84d5a392223a9a087098c4f97190a6df8d9aa4e49)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__28533f2fc44a9d1df68f04cfd544a15278d56fbfb50e9c5f24e483b4e28ef7db)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2e9b56a12c52d4cf5eab946c94191937abca6a3d3203f75b8ec433b3a171f364)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8ed7492828ddef261cf8f82f6e83a42c2328d94a4db5e5f3f4ff4ee328981303)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c1b39e2fd64916b9d461e3fa3e5d90405222c78d6602d90ad187f961ec14daea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="xPosition")
    def x_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPosition"))

    @x_position.setter
    def x_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8390784c8c65eed42b65a6ac9944b71556e7e7d516f6ec428ba81af29e47bb43)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPosition", value)

    @builtins.property
    @jsii.member(jsii_name="xPositionVar")
    def x_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xPositionVar"))

    @x_position_var.setter
    def x_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e35db87b93f6be316767f16f6597a2801dbe8d7c030edbe56861a884eb66aea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="yPosition")
    def y_position(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPosition"))

    @y_position.setter
    def y_position(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dbc54fd82a6127e7dc810ce3629ee6c1c29bdb8393e131d51b4f647a4cab9c5e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPosition", value)

    @builtins.property
    @jsii.member(jsii_name="yPositionVar")
    def y_position_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yPositionVar"))

    @y_position_var.setter
    def y_position_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fb4b1be4466fb27711b8ea428a444df64b2b8b976cbb69173870f9c4c0483166)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yPositionVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b3432cfd6f191c4d5604dc50c693446fac1fb501fbc3e03ab4ebd13030806530)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanFaceCrop",
    jsii_struct_bases=[],
    name_mapping={
        "algorithm": "algorithm",
        "algorithm_var": "algorithmVar",
        "confidence": "confidence",
        "confidence_var": "confidenceVar",
        "fail_gravity": "failGravity",
        "fail_gravity_var": "failGravityVar",
        "focus": "focus",
        "focus_var": "focusVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "padding": "padding",
        "padding_var": "paddingVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanFaceCrop:
    def __init__(
        self,
        *,
        algorithm: typing.Optional[builtins.str] = None,
        algorithm_var: typing.Optional[builtins.str] = None,
        confidence: typing.Optional[builtins.str] = None,
        confidence_var: typing.Optional[builtins.str] = None,
        fail_gravity: typing.Optional[builtins.str] = None,
        fail_gravity_var: typing.Optional[builtins.str] = None,
        focus: typing.Optional[builtins.str] = None,
        focus_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param algorithm: Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm DataAkamaiImagingPolicyImage#algorithm}
        :param algorithm_var: Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm_var DataAkamaiImagingPolicyImage#algorithm_var}
        :param confidence: With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image. Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence DataAkamaiImagingPolicyImage#confidence}
        :param confidence_var: With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image. Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence_var DataAkamaiImagingPolicyImage#confidence_var}
        :param fail_gravity: Controls placement of the crop if Image and Video Manager does not detect any faces in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        :param fail_gravity_var: Controls placement of the crop if Image and Video Manager does not detect any faces in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        :param focus: Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus DataAkamaiImagingPolicyImage#focus}
        :param focus_var: Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus_var DataAkamaiImagingPolicyImage#focus_var}
        :param gravity: Controls placement of the crop. Directions are relative to the face(s) plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Controls placement of the crop. Directions are relative to the face(s) plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param padding: The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        :param style: Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width of the output image in pixels relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b8fa54c24d1ca3ea6e2bbcbc3c37149aeda908d1536fb6a858090f4508550754)
            check_type(argname="argument algorithm", value=algorithm, expected_type=type_hints["algorithm"])
            check_type(argname="argument algorithm_var", value=algorithm_var, expected_type=type_hints["algorithm_var"])
            check_type(argname="argument confidence", value=confidence, expected_type=type_hints["confidence"])
            check_type(argname="argument confidence_var", value=confidence_var, expected_type=type_hints["confidence_var"])
            check_type(argname="argument fail_gravity", value=fail_gravity, expected_type=type_hints["fail_gravity"])
            check_type(argname="argument fail_gravity_var", value=fail_gravity_var, expected_type=type_hints["fail_gravity_var"])
            check_type(argname="argument focus", value=focus, expected_type=type_hints["focus"])
            check_type(argname="argument focus_var", value=focus_var, expected_type=type_hints["focus_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if algorithm is not None:
            self._values["algorithm"] = algorithm
        if algorithm_var is not None:
            self._values["algorithm_var"] = algorithm_var
        if confidence is not None:
            self._values["confidence"] = confidence
        if confidence_var is not None:
            self._values["confidence_var"] = confidence_var
        if fail_gravity is not None:
            self._values["fail_gravity"] = fail_gravity
        if fail_gravity_var is not None:
            self._values["fail_gravity_var"] = fail_gravity_var
        if focus is not None:
            self._values["focus"] = focus
        if focus_var is not None:
            self._values["focus_var"] = focus_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def algorithm(self) -> typing.Optional[builtins.str]:
        '''Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm DataAkamaiImagingPolicyImage#algorithm}
        '''
        result = self._values.get("algorithm")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def algorithm_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the type of algorithm used to detect faces in the image, either ``cascade`` for the cascade classifier algorithm or ``dnn`` for the deep neural network algorithm, ``cascade`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm_var DataAkamaiImagingPolicyImage#algorithm_var}
        '''
        result = self._values.get("algorithm_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def confidence(self) -> typing.Optional[builtins.str]:
        '''With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image.

        Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence DataAkamaiImagingPolicyImage#confidence}
        '''
        result = self._values.get("confidence")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def confidence_var(self) -> typing.Optional[builtins.str]:
        '''With ``algorithm`` set to ``dnn``, specifies the minimum confidence needed to detect faces in the image.

        Values range from ``0`` to ``1`` for increased confidence, and possibly fewer faces detected.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence_var DataAkamaiImagingPolicyImage#confidence_var}
        '''
        result = self._values.get("confidence_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any faces in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        '''
        result = self._values.get("fail_gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any faces in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        '''
        result = self._values.get("fail_gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def focus(self) -> typing.Optional[builtins.str]:
        '''Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus DataAkamaiImagingPolicyImage#focus}
        '''
        result = self._values.get("focus")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def focus_var(self) -> typing.Optional[builtins.str]:
        '''Distinguishes the faces detected, either ``biggestFace`` or ``allFaces`` to place the crop rectangle around the full set of faces, ``all`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus_var DataAkamaiImagingPolicyImage#focus_var}
        '''
        result = self._values.get("focus_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the face(s) plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the face(s) plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''The padding ratio based on the dimensions of the biggest face detected, ``0.5`` by default. Larger values increase padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the faces detected in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places a raw crop around the faces, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and faces as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the faces, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width of the output image in pixels relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanFaceCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanFaceCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanFaceCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__32bf776b550db80767e76286bfb632d560003ad9daa761ed32202dd4f2e00562)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanFaceCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dee546ecada9e5cb18f852eb81142bb31502cc7cb8e64a9d34a8f75fbef9949c)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanFaceCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__707c83189bfd70f9e14a3b2e70ff711b577abc46a793e88a61057e66bb05e3fd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aa389489e30ed1f01db799e389afce46477ce1baacc3cee357a8e200922d7c91)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__517aa089c74d3aa1f75b68fbb8d94658d1d896a89311c8e48fb370f7d2a3b4d8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanFaceCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanFaceCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanFaceCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e687ec689ef588910a4c78102482fa5d1b6371a9b015b4af6d9f6222f651044f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanFaceCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanFaceCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__277ca2b683fde30679b53ae0d9d7c9cf515fc567fc538dbf50b2e070e15b2183)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAlgorithm")
    def reset_algorithm(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAlgorithm", []))

    @jsii.member(jsii_name="resetAlgorithmVar")
    def reset_algorithm_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAlgorithmVar", []))

    @jsii.member(jsii_name="resetConfidence")
    def reset_confidence(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetConfidence", []))

    @jsii.member(jsii_name="resetConfidenceVar")
    def reset_confidence_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetConfidenceVar", []))

    @jsii.member(jsii_name="resetFailGravity")
    def reset_fail_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravity", []))

    @jsii.member(jsii_name="resetFailGravityVar")
    def reset_fail_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravityVar", []))

    @jsii.member(jsii_name="resetFocus")
    def reset_focus(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFocus", []))

    @jsii.member(jsii_name="resetFocusVar")
    def reset_focus_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFocusVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="algorithmInput")
    def algorithm_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "algorithmInput"))

    @builtins.property
    @jsii.member(jsii_name="algorithmVarInput")
    def algorithm_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "algorithmVarInput"))

    @builtins.property
    @jsii.member(jsii_name="confidenceInput")
    def confidence_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "confidenceInput"))

    @builtins.property
    @jsii.member(jsii_name="confidenceVarInput")
    def confidence_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "confidenceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityInput")
    def fail_gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityVarInput")
    def fail_gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="focusInput")
    def focus_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "focusInput"))

    @builtins.property
    @jsii.member(jsii_name="focusVarInput")
    def focus_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "focusVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="algorithm")
    def algorithm(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "algorithm"))

    @algorithm.setter
    def algorithm(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__56b50ea44041ce45116eb262490cbfa53900ffcc317f43748f0e937cd042d9c0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "algorithm", value)

    @builtins.property
    @jsii.member(jsii_name="algorithmVar")
    def algorithm_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "algorithmVar"))

    @algorithm_var.setter
    def algorithm_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9776d82582f22739ee0e8f6c1ba22017a93b0f11f53bfd7d2d6e064060157b11)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "algorithmVar", value)

    @builtins.property
    @jsii.member(jsii_name="confidence")
    def confidence(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "confidence"))

    @confidence.setter
    def confidence(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__92579216994571d1131d545b03c741a1143ee70d85028b54a4274bffc032c4f1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "confidence", value)

    @builtins.property
    @jsii.member(jsii_name="confidenceVar")
    def confidence_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "confidenceVar"))

    @confidence_var.setter
    def confidence_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7b4cb8c67c477ee2e1b2f19fcf3f051fca657e97c04c37ee319088d59e739dec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "confidenceVar", value)

    @builtins.property
    @jsii.member(jsii_name="failGravity")
    def fail_gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravity"))

    @fail_gravity.setter
    def fail_gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__57eaeb42e229b204e1ccafe206153159ae8551b492af8584afd033d8b8a6ba3c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravity", value)

    @builtins.property
    @jsii.member(jsii_name="failGravityVar")
    def fail_gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravityVar"))

    @fail_gravity_var.setter
    def fail_gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0d2ac31e8d934ce47bd2561bc4f06bdb479cf97d85ad03b0b90b2bacba2966fe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="focus")
    def focus(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "focus"))

    @focus.setter
    def focus(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__de17a9c2c1a75510231e43e751120d74d867d27dcc31c5a760d5eb4979d2b50e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "focus", value)

    @builtins.property
    @jsii.member(jsii_name="focusVar")
    def focus_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "focusVar"))

    @focus_var.setter
    def focus_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__570074c096461805953924abd2d50e30b2823f7039d72ec1f37f76ad1c742421)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "focusVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bd2e94e9dc0f9385eeffaa5df57a1dc0d3482af328d098c234541636ff0b2717)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__586799076ad2d60c7e89981cbd19501f83b56f5c9135dd8a1b586e650924cf05)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9c8aa6e22f549bc69c9bf406521014e128e4cb7e8f8fbd1d2de3e4834934c523)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3803706f7e6751a2666738b67d7320e7be1271a9ebd0f3210dddac1401ef9a06)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__47a0f6dd2eb6efdd1d7281ca5bed34ce036b121b524dc6d03924368a1490caa8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__99592b01b37d30e0a2f81d5c16c7a4a6c9168716836174b6cbdf291f17dd0dd3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__280f75da82f89c8a3792959070b35c3007d9c188bb2404eb49a21d503c390511)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__93dded5ecfd34302bcfa3a7e06ed08a37822acf580a8c3e5d505139702af61b4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dd2710a39844766e11a363ee64fedd4ab36de4a9f4e4bc61c89a9cf6160292d2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fc94a4dcebcf9b93288e581b966fdb287ca0bb83dc938fea4c4ba41323322cb4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanFaceCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanFaceCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanFaceCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c5bae00f0e5658c1c45a63d8a7a382be2380ab6c98dcef4d265af71154d63b5a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanFeatureCrop",
    jsii_struct_bases=[],
    name_mapping={
        "fail_gravity": "failGravity",
        "fail_gravity_var": "failGravityVar",
        "feature_radius": "featureRadius",
        "feature_radius_var": "featureRadiusVar",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "max_features": "maxFeatures",
        "max_features_var": "maxFeaturesVar",
        "min_feature_quality": "minFeatureQuality",
        "min_feature_quality_var": "minFeatureQualityVar",
        "padding": "padding",
        "padding_var": "paddingVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanFeatureCrop:
    def __init__(
        self,
        *,
        fail_gravity: typing.Optional[builtins.str] = None,
        fail_gravity_var: typing.Optional[builtins.str] = None,
        feature_radius: typing.Optional[builtins.str] = None,
        feature_radius_var: typing.Optional[builtins.str] = None,
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        max_features: typing.Optional[builtins.str] = None,
        max_features_var: typing.Optional[builtins.str] = None,
        min_feature_quality: typing.Optional[builtins.str] = None,
        min_feature_quality_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fail_gravity: Controls placement of the crop if Image and Video Manager does not detect any features in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        :param fail_gravity_var: Controls placement of the crop if Image and Video Manager does not detect any features in the image. Directions are relative to the edges of the image being transformed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        :param feature_radius: The size in pixels of the important features to search for. If identified, two features never appear closer together than this value, ``8.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius DataAkamaiImagingPolicyImage#feature_radius}
        :param feature_radius_var: The size in pixels of the important features to search for. If identified, two features never appear closer together than this value, ``8.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius_var DataAkamaiImagingPolicyImage#feature_radius_var}
        :param gravity: Controls placement of the crop. Directions are relative to the region of interest plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: Controls placement of the crop. Directions are relative to the region of interest plus padding. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param max_features: The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features DataAkamaiImagingPolicyImage#max_features}
        :param max_features_var: The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features_var DataAkamaiImagingPolicyImage#max_features_var}
        :param min_feature_quality: Determines the minimum quality level of the feature identified. To consider a feature important, the feature needs to surpass this value. Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality DataAkamaiImagingPolicyImage#min_feature_quality}
        :param min_feature_quality_var: Determines the minimum quality level of the feature identified. To consider a feature important, the feature needs to surpass this value. Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality_var DataAkamaiImagingPolicyImage#min_feature_quality_var}
        :param padding: Adds space around the region of interest. The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: Adds space around the region of interest. The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        :param style: Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8e41d12bc861ba57be47d4918126d1aa38dc671579e2825e6945352d5a34d83f)
            check_type(argname="argument fail_gravity", value=fail_gravity, expected_type=type_hints["fail_gravity"])
            check_type(argname="argument fail_gravity_var", value=fail_gravity_var, expected_type=type_hints["fail_gravity_var"])
            check_type(argname="argument feature_radius", value=feature_radius, expected_type=type_hints["feature_radius"])
            check_type(argname="argument feature_radius_var", value=feature_radius_var, expected_type=type_hints["feature_radius_var"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument max_features", value=max_features, expected_type=type_hints["max_features"])
            check_type(argname="argument max_features_var", value=max_features_var, expected_type=type_hints["max_features_var"])
            check_type(argname="argument min_feature_quality", value=min_feature_quality, expected_type=type_hints["min_feature_quality"])
            check_type(argname="argument min_feature_quality_var", value=min_feature_quality_var, expected_type=type_hints["min_feature_quality_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fail_gravity is not None:
            self._values["fail_gravity"] = fail_gravity
        if fail_gravity_var is not None:
            self._values["fail_gravity_var"] = fail_gravity_var
        if feature_radius is not None:
            self._values["feature_radius"] = feature_radius
        if feature_radius_var is not None:
            self._values["feature_radius_var"] = feature_radius_var
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if max_features is not None:
            self._values["max_features"] = max_features
        if max_features_var is not None:
            self._values["max_features_var"] = max_features_var
        if min_feature_quality is not None:
            self._values["min_feature_quality"] = min_feature_quality
        if min_feature_quality_var is not None:
            self._values["min_feature_quality_var"] = min_feature_quality_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def fail_gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any features in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
        '''
        result = self._values.get("fail_gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fail_gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop if Image and Video Manager does not detect any features in the image.

        Directions are relative to the edges of the image being transformed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
        '''
        result = self._values.get("fail_gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feature_radius(self) -> typing.Optional[builtins.str]:
        '''The size in pixels of the important features to search for.

        If identified, two features never appear closer together than this value, ``8.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius DataAkamaiImagingPolicyImage#feature_radius}
        '''
        result = self._values.get("feature_radius")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feature_radius_var(self) -> typing.Optional[builtins.str]:
        '''The size in pixels of the important features to search for.

        If identified, two features never appear closer together than this value, ``8.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius_var DataAkamaiImagingPolicyImage#feature_radius_var}
        '''
        result = self._values.get("feature_radius_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the region of interest plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''Controls placement of the crop. Directions are relative to the region of interest plus padding.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def max_features(self) -> typing.Optional[builtins.str]:
        '''The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features DataAkamaiImagingPolicyImage#max_features}
        '''
        result = self._values.get("max_features")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def max_features_var(self) -> typing.Optional[builtins.str]:
        '''The maximum number of features to identify as important features, ``32`` by default. The strongest features are always chosen.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features_var DataAkamaiImagingPolicyImage#max_features_var}
        '''
        result = self._values.get("max_features_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def min_feature_quality(self) -> typing.Optional[builtins.str]:
        '''Determines the minimum quality level of the feature identified.

        To consider a feature important, the feature needs to surpass this value.  Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality DataAkamaiImagingPolicyImage#min_feature_quality}
        '''
        result = self._values.get("min_feature_quality")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def min_feature_quality_var(self) -> typing.Optional[builtins.str]:
        '''Determines the minimum quality level of the feature identified.

        To consider a feature important, the feature needs to surpass this value.  Image and Video Manager measures quality on a scale from ``0`` for the lowest quality to ``1`` for the highest quality, ``.1`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality_var DataAkamaiImagingPolicyImage#min_feature_quality_var}
        '''
        result = self._values.get("min_feature_quality_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''Adds space around the region of interest.

        The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''Adds space around the region of interest.

        The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the features identified in the source image, ``fill`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` performs a raw crop around the features, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and features as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the features, relative to the specified ``width`` and ``height`` values. Allows Variable substitution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanFeatureCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanFeatureCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanFeatureCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f2e417089b91211397cc41e5bedf8acfbf458b1d778a82f7783aefe223d7fd3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanFeatureCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b298a519862a424675eb5d08dfb04fa9f6ede40740178af6354f4bc8c59765b7)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanFeatureCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a8bad6a09d20685407a0d40305b51256ef257b33dc4827f978861ddb46134c00)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ff503ec39a27ca6b851e74c3a78627af8db5a2c1dee8943aebd8153b15fb39d2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bcdbbee2827a9ff910d42bddc5916e8f586ffb1fd3260fdc300eb450303fbed6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanFeatureCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanFeatureCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanFeatureCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__36f9eb1ed4c885d3b4a8df5ce6dc9825192543eec2e133be5f11ae2cf5fc26ae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanFeatureCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanFeatureCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__79725360c16cffb64417ca363a3fe63d640a8f970f27f436d862417e71a4bb84)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetFailGravity")
    def reset_fail_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravity", []))

    @jsii.member(jsii_name="resetFailGravityVar")
    def reset_fail_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailGravityVar", []))

    @jsii.member(jsii_name="resetFeatureRadius")
    def reset_feature_radius(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureRadius", []))

    @jsii.member(jsii_name="resetFeatureRadiusVar")
    def reset_feature_radius_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureRadiusVar", []))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetMaxFeatures")
    def reset_max_features(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxFeatures", []))

    @jsii.member(jsii_name="resetMaxFeaturesVar")
    def reset_max_features_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxFeaturesVar", []))

    @jsii.member(jsii_name="resetMinFeatureQuality")
    def reset_min_feature_quality(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMinFeatureQuality", []))

    @jsii.member(jsii_name="resetMinFeatureQualityVar")
    def reset_min_feature_quality_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMinFeatureQualityVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="failGravityInput")
    def fail_gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravityVarInput")
    def fail_gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failGravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featureRadiusInput")
    def feature_radius_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featureRadiusInput"))

    @builtins.property
    @jsii.member(jsii_name="featureRadiusVarInput")
    def feature_radius_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featureRadiusVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesInput")
    def max_features_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "maxFeaturesInput"))

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesVarInput")
    def max_features_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "maxFeaturesVarInput"))

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityInput")
    def min_feature_quality_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "minFeatureQualityInput"))

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityVarInput")
    def min_feature_quality_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "minFeatureQualityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="failGravity")
    def fail_gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravity"))

    @fail_gravity.setter
    def fail_gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__00d2c41389e16b97914cfd082e5329718be8ddd61f774a6895c6e912327178b2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravity", value)

    @builtins.property
    @jsii.member(jsii_name="failGravityVar")
    def fail_gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failGravityVar"))

    @fail_gravity_var.setter
    def fail_gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2e15ef44d852f4996db703bb8f046c7f6ea6fd8710a179097cee976d361a7ac9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failGravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="featureRadius")
    def feature_radius(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featureRadius"))

    @feature_radius.setter
    def feature_radius(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5cdff836143f827ae1bc38ffe806d97b772a91f6131de237929253e6b0918165)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featureRadius", value)

    @builtins.property
    @jsii.member(jsii_name="featureRadiusVar")
    def feature_radius_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featureRadiusVar"))

    @feature_radius_var.setter
    def feature_radius_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f253ecc8392985aa960f8bd94f1aacdc0aaadbff39dd5b79ec62c64773af7767)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featureRadiusVar", value)

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__88d5f0ad41bf03f6651806b4a3de0ea8ce43ed805aef3eec65da95d2cebc13f6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c33e8385c8edfcfa21de65d6bdc23d8ba1133d969b4be87ced6ee1a83935d6a3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f0383e0aee78ca3901815da48ccc2513982a2fff1303f540fc05c88397fc40a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c8752b33e559f404a820bec2f8e10691be753ab998e0cb528660770db9cf0170)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="maxFeatures")
    def max_features(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "maxFeatures"))

    @max_features.setter
    def max_features(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__24187d2b03ae6ea95fc7890f029406b4c5ae2f31432b589007cb82f342502ab4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "maxFeatures", value)

    @builtins.property
    @jsii.member(jsii_name="maxFeaturesVar")
    def max_features_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "maxFeaturesVar"))

    @max_features_var.setter
    def max_features_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9547ba7b9ea31caeb0144338e20c28b8255ab1e587d81ee5eec1bdf66a30d425)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "maxFeaturesVar", value)

    @builtins.property
    @jsii.member(jsii_name="minFeatureQuality")
    def min_feature_quality(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "minFeatureQuality"))

    @min_feature_quality.setter
    def min_feature_quality(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2bc9b7a3b616f1c38d9e00ea985956391b0ed4c0db88fbf55b44b4e3dec06bdf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "minFeatureQuality", value)

    @builtins.property
    @jsii.member(jsii_name="minFeatureQualityVar")
    def min_feature_quality_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "minFeatureQualityVar"))

    @min_feature_quality_var.setter
    def min_feature_quality_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cb8f304410ac79e4e27fa14f69b9098883e3ba91683c1c7ad0b148e589607bb0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "minFeatureQualityVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2e3f49f6addbad3362d25fb1f9c37b5f5665504e6a76599a76fc26220f9f845f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d14643f2a525771460850fa336dc9fdd2329f2f40c540ae66e48b3c3ad3e42bc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f62db95e769c23608ee773539587465f03c9501d513326397dd6d2ebc4f6ad75)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9fffb6d953f3c006d047d831b0e5e82a5af2b2650ed2be3831f66ccc94429c33)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b5dba2197b823519dddf1e7a7f85a72b48b36575a2f891e27af838d0419a096d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c729fa342f13fb564a9bb017601d8e4ba21108bbc268708eaafa30fd73651302)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanFeatureCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanFeatureCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanFeatureCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__628089053dd7ab43ae787c1797118c401898228ec09c5945a33869d93de887c5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanFitAndFill",
    jsii_struct_bases=[],
    name_mapping={
        "fill_transformation": "fillTransformation",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanFitAndFill:
    def __init__(
        self,
        *,
        fill_transformation: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanFitAndFillFillTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fill_transformation: fill_transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_transformation DataAkamaiImagingPolicyImage#fill_transformation}
        :param height: The height value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: The width value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width value of the resized image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(fill_transformation, dict):
            fill_transformation = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanFitAndFillFillTransformation(**fill_transformation)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f23798f6cc2ccaeced3147d82ee7ca1c3d171b0302f0cf6aa66f060d48559418)
            check_type(argname="argument fill_transformation", value=fill_transformation, expected_type=type_hints["fill_transformation"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fill_transformation is not None:
            self._values["fill_transformation"] = fill_transformation
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def fill_transformation(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanFitAndFillFillTransformation"]:
        '''fill_transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_transformation DataAkamaiImagingPolicyImage#fill_transformation}
        '''
        result = self._values.get("fill_transformation")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanFitAndFillFillTransformation"], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width value of the resized image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanFitAndFill(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanFitAndFillFillTransformation",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanFitAndFillFillTransformation:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanFitAndFillFillTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanFitAndFillFillTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanFitAndFillFillTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fc1c6607c6c9e71a2e0d18731f1eab38813348221cc321e267abfeef4f5b70db)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanFitAndFillFillTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanFitAndFillFillTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanFitAndFillFillTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e31cf185f5a54de2ed584e925ce0c8ff0b1ab97052ec36157eac30d1fe183d74)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanFitAndFillList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanFitAndFillList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ddd870c7bb0501b28d7d03af589c336696098f8fe4c0dc9e9df955890345d4dc)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanFitAndFillOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__155d1ee2e5e0e8a616cdf68bcd1580c03aa610c887ea18daa2d3effdeb8649ad)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanFitAndFillOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fcc2c6d6b767e862e6df3c79b2675480c5356303cc2c7b3993b38c493a6ca653)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__69b61f76acd73bcbee294081dd7d750e95193a6502e1d620a080c1e73e8e1e8a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e723a897de324b63098edb46afd8af57fcc8e845a08ef47658727d47990138a8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanFitAndFill]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanFitAndFill]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanFitAndFill]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b784951a188e4a5fcad0c8114f3f5bc700e3bd6909328e03a7294092ce7a4c05)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanFitAndFillOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanFitAndFillOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__38ad02421742e5e5f46161e6c3614f54f1c33fffececcb5952ed29a839aed28c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putFillTransformation")
    def put_fill_transformation(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanFitAndFillFillTransformation()

        return typing.cast(None, jsii.invoke(self, "putFillTransformation", [value]))

    @jsii.member(jsii_name="resetFillTransformation")
    def reset_fill_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFillTransformation", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="fillTransformation")
    def fill_transformation(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanFitAndFillFillTransformationOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanFitAndFillFillTransformationOutputReference, jsii.get(self, "fillTransformation"))

    @builtins.property
    @jsii.member(jsii_name="fillTransformationInput")
    def fill_transformation_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanFitAndFillFillTransformation]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanFitAndFillFillTransformation], jsii.get(self, "fillTransformationInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b8f41a91982b32a2eaaeb1577c1c8386f3d56c91f01f9181c29845f203f29916)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c593b4f88d37b742fc3556a9d69d3ec78ed3e898c4653fa8cf1c562800119610)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__40e67d3f7645aae98c36c09387d58eea12816cc59df0d08b5335eabd179c06a1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4d68d82810a38a0f0961997f122f38e5e6b0888fbeec3ecd816f53fc1702bc30)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanFitAndFill]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanFitAndFill]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanFitAndFill]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1816b019da746d6e9612feb3199955d12f9368abf6178f36422e28484e92008c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanGoop",
    jsii_struct_bases=[],
    name_mapping={
        "chaos": "chaos",
        "chaos_var": "chaosVar",
        "density": "density",
        "density_var": "densityVar",
        "power": "power",
        "power_var": "powerVar",
        "seed": "seed",
        "seed_var": "seedVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanGoop:
    def __init__(
        self,
        *,
        chaos: typing.Optional[builtins.str] = None,
        chaos_var: typing.Optional[builtins.str] = None,
        density: typing.Optional[builtins.str] = None,
        density_var: typing.Optional[builtins.str] = None,
        power: typing.Optional[builtins.str] = None,
        power_var: typing.Optional[builtins.str] = None,
        seed: typing.Optional[builtins.str] = None,
        seed_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param chaos: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        :param chaos_var: Specifies the greatest distance control points may move from their original position. A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        :param density: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        :param density_var: Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        :param power: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        :param power_var: By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of ``2.0``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        :param seed: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        :param seed_var: Specifies your own ``seed`` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5441d628c97d1eb942d7b7c0aae3cf041cabcb4faae4e2ce993e368a6c035670)
            check_type(argname="argument chaos", value=chaos, expected_type=type_hints["chaos"])
            check_type(argname="argument chaos_var", value=chaos_var, expected_type=type_hints["chaos_var"])
            check_type(argname="argument density", value=density, expected_type=type_hints["density"])
            check_type(argname="argument density_var", value=density_var, expected_type=type_hints["density_var"])
            check_type(argname="argument power", value=power, expected_type=type_hints["power"])
            check_type(argname="argument power_var", value=power_var, expected_type=type_hints["power_var"])
            check_type(argname="argument seed", value=seed, expected_type=type_hints["seed"])
            check_type(argname="argument seed_var", value=seed_var, expected_type=type_hints["seed_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if chaos is not None:
            self._values["chaos"] = chaos
        if chaos_var is not None:
            self._values["chaos_var"] = chaos_var
        if density is not None:
            self._values["density"] = density
        if density_var is not None:
            self._values["density_var"] = density_var
        if power is not None:
            self._values["power"] = power
        if power_var is not None:
            self._values["power_var"] = power_var
        if seed is not None:
            self._values["seed"] = seed
        if seed_var is not None:
            self._values["seed_var"] = seed_var

    @builtins.property
    def chaos(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
        '''
        result = self._values.get("chaos")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def chaos_var(self) -> typing.Optional[builtins.str]:
        '''Specifies the greatest distance control points may move from their original position.

        A value of ``1.0`` shifts control points over as far as the next one in the original grid. A value of ``0.0`` leaves the image unchanged. Values under ``0.5`` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
        '''
        result = self._values.get("chaos_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
        '''
        result = self._values.get("density")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def density_var(self) -> typing.Optional[builtins.str]:
        '''Controls the density of control points used to distort the image.

        The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
        '''
        result = self._values.get("density_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
        '''
        result = self._values.get("power")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def power_var(self) -> typing.Optional[builtins.str]:
        '''By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent.

        You shouldnt need to vary the default value of ``2.0``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
        '''
        result = self._values.get("power_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
        '''
        result = self._values.get("seed")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def seed_var(self) -> typing.Optional[builtins.str]:
        '''Specifies your own ``seed`` value as an alternative to the default, which is subject to variability.

        This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, ``Goop`` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
        '''
        result = self._values.get("seed_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanGoop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanGoopList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanGoopList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ad4ff6a3fcabe6df43ffbe39e821fff24836aeeb20eb5ee835eb9bbd60bac83)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanGoopOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f9102510f2d7389d2805b53b71e820dc23b88ebe27656de269b2b11d09e4f4d)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanGoopOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be40ef7e2b306cbdf4853305077858db417e96f04c7d9b8b2a981c797b559b0a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a6766da50650a2babaf862664c935dab35d11701924768b9d2bb87167ea79ad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd69f86cc565fd39bbd1b99c06753b92884801bd69862153d91d2e6ccfe56d9a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanGoop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanGoop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d2581ed6b4ba571d283d2f396fbb12877c62b1343824a687f6a3a8097335bf2f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanGoopOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanGoopOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b42516cf71c40ac013d0379a0f75289c31d6f6cb0ff37f1b925cfcdb981c1275)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetChaos")
    def reset_chaos(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaos", []))

    @jsii.member(jsii_name="resetChaosVar")
    def reset_chaos_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaosVar", []))

    @jsii.member(jsii_name="resetDensity")
    def reset_density(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensity", []))

    @jsii.member(jsii_name="resetDensityVar")
    def reset_density_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDensityVar", []))

    @jsii.member(jsii_name="resetPower")
    def reset_power(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPower", []))

    @jsii.member(jsii_name="resetPowerVar")
    def reset_power_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPowerVar", []))

    @jsii.member(jsii_name="resetSeed")
    def reset_seed(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeed", []))

    @jsii.member(jsii_name="resetSeedVar")
    def reset_seed_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeedVar", []))

    @builtins.property
    @jsii.member(jsii_name="chaosInput")
    def chaos_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosInput"))

    @builtins.property
    @jsii.member(jsii_name="chaosVarInput")
    def chaos_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chaosVarInput"))

    @builtins.property
    @jsii.member(jsii_name="densityInput")
    def density_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityInput"))

    @builtins.property
    @jsii.member(jsii_name="densityVarInput")
    def density_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "densityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="powerInput")
    def power_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerInput"))

    @builtins.property
    @jsii.member(jsii_name="powerVarInput")
    def power_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "powerVarInput"))

    @builtins.property
    @jsii.member(jsii_name="seedInput")
    def seed_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedInput"))

    @builtins.property
    @jsii.member(jsii_name="seedVarInput")
    def seed_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "seedVarInput"))

    @builtins.property
    @jsii.member(jsii_name="chaos")
    def chaos(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaos"))

    @chaos.setter
    def chaos(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__da923a8092f1848728004912476a6451a0934fe4b384a2fa87775b2779c581b2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaos", value)

    @builtins.property
    @jsii.member(jsii_name="chaosVar")
    def chaos_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chaosVar"))

    @chaos_var.setter
    def chaos_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dd2e557487921a42f147bf9945b20e5f67c806184c4c7f072a4dcecd166a9039)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chaosVar", value)

    @builtins.property
    @jsii.member(jsii_name="density")
    def density(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "density"))

    @density.setter
    def density(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5341471bb8ea5bf19fc67775c865015302eb9422993ec5638fc7176247472a7c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "density", value)

    @builtins.property
    @jsii.member(jsii_name="densityVar")
    def density_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "densityVar"))

    @density_var.setter
    def density_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__03a5e5996efc83666a03855fb5ba218b3c252bb9d162de09a03ade8e21997636)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "densityVar", value)

    @builtins.property
    @jsii.member(jsii_name="power")
    def power(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "power"))

    @power.setter
    def power(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fe98bd0c046c0e7aa8f3fdc84b34618bc7e91cc3af1e9d361ec0785c139653bd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "power", value)

    @builtins.property
    @jsii.member(jsii_name="powerVar")
    def power_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "powerVar"))

    @power_var.setter
    def power_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0e5706bcc404cc52c84ac500638cebacae4d034f836b7863a77e4229ca42f91f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "powerVar", value)

    @builtins.property
    @jsii.member(jsii_name="seed")
    def seed(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seed"))

    @seed.setter
    def seed(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a9be3791667728c75d5f6e6c715908d2201103b87387f6514d3548c46f066763)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seed", value)

    @builtins.property
    @jsii.member(jsii_name="seedVar")
    def seed_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "seedVar"))

    @seed_var.setter
    def seed_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a40691ee3fed5d7122feeaf49eff814cee3300f59bbdccae933ffe7fab5b5a9b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "seedVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanGoop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanGoop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanGoop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5b86ff50d66e9b5e2e355280f916bc0868d93e3d799ca44634a2c5153d681cda)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanGrayscale",
    jsii_struct_bases=[],
    name_mapping={"type": "type", "type_var": "typeVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanGrayscale:
    def __init__(
        self,
        *,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param type: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d64f258c99dcdb2d5e200e4cbc548a9a51417fb8ed32ec8d3d3a2ae2a307c9c2)
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''The algorithm used to transform colors to grays, either ``Brightness``, ``Lightness``, ``Rec601``, or the default ``Rec709``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanGrayscale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanGrayscaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanGrayscaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ba7de3d869f98877b31f8e5c25eb80e6650d6fd091795e82fe0e695413132887)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanGrayscaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__279f38fa0dd12bb056f54d8c9ff1d34415c22eee2723fef47cc7e4b31c5e745d)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanGrayscaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d1fd5a8ccd5c97b72007f0348e06cf2272a49470bd274df67a13fd5bf4f7f753)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6b4375ab72092e295a47d3a076c10580874ea666174d2933e55625202eb4dcaf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__726b1be0cdc18c1184532ae1c0bd63d830c19ed1c76a97d5b9087ad33fe16968)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanGrayscale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanGrayscale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__588c1881503813065a618a43a0c72c0da805af0cd2017823b278924f20c903a8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanGrayscaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanGrayscaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3d486bbef446b35b0333feb5a4508c8963de27c1e525815805ce0490dcd218e3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3e44a77406332cfeb0e427de04ede2dbd9f85ecf7f6bd26eadcac2deb5d4cca1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3c08d02ce40ee4307b118bc8270d5a5ea391e754b30987a2349ba0e19ddd2dcc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanGrayscale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanGrayscale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanGrayscale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b6a61478f195f71c4a17efab3315be1fbfc8dd526c7691f8fa3a73cab678b0f8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanHsl",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "lightness": "lightness",
        "lightness_var": "lightnessVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanHsl:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        lightness: typing.Optional[builtins.str] = None,
        lightness_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param lightness: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        :param lightness_var: A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2549cd0e21d657502e8d0bf44b38f647acf40b2948e3ac10c51e9f28b0499c8b)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument lightness", value=lightness, expected_type=type_hints["lightness"])
            check_type(argname="argument lightness_var", value=lightness_var, expected_type=type_hints["lightness_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if lightness is not None:
            self._values["lightness"] = lightness
        if lightness_var is not None:
            self._values["lightness_var"] = lightness_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
        '''
        result = self._values.get("lightness")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lightness_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness of colors in the image.

        Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than ``1.0`` decrease the lightness of colors in the image. Values greater than ``1.0`` increase the lightness of colors in the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
        '''
        result = self._values.get("lightness_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanHsl(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanHslList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanHslList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ecc3b94367a8581d455000122e846c76e3c6c67d186da5c79865508965636fa8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanHslOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4b0deab0dd57cbaf9a4c58c9660cbd093dc6b740d6ddf5cb42975feeb50448e2)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanHslOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0d9c6f528b7a6c19594a588bd2d597279262ee02443cfa69abd85485e451c782)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1b050ab6a286c9d0bb9acb3e351c5adaee098fea4a9e4b5977341563369e82aa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__09c5d6211b2b3039ccbf8c9e2eb664c61bd9a6c9fe54dcf91865f17af5209815)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanHsl]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanHsl]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a7089c00e14672d0847884eac62d3f7c683ac2da3b4b16e751ef25733e967e0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanHslOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanHslOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7684249ccf9385eb0a904a23b39a92fa31b85e18f9b9ce2c6e2e3471ab132bb8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetLightness")
    def reset_lightness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightness", []))

    @jsii.member(jsii_name="resetLightnessVar")
    def reset_lightness_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLightnessVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessInput")
    def lightness_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessInput"))

    @builtins.property
    @jsii.member(jsii_name="lightnessVarInput")
    def lightness_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lightnessVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3c7aeb2955d91e06c43c796d954ab8f0e7add50f26f2a3bfe9e9d4d242dc50ad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__639b7debeb0bcf66d1db812acf3f05c7f1dd88ed77a66307effe6d19c828ab2e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="lightness")
    def lightness(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightness"))

    @lightness.setter
    def lightness(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3e3aee16b2f3f5bbc56e804785d8537009e84d62f0fe17d37930d25f0fe4d90a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightness", value)

    @builtins.property
    @jsii.member(jsii_name="lightnessVar")
    def lightness_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lightnessVar"))

    @lightness_var.setter
    def lightness_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c7eb318e11479bc09478f12b249b096fc4bb0d63beaeace462b96bcf4b929800)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lightnessVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__99b07e68cafc236813e585bac2f36c8f21ff5b9b47fec2fd82f1f59d0b2281ab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__71c640ba8c2c24ae6cd43665a7ff4f6dc43c19fbbcefb0af94b370bf22091ef9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanHsl]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanHsl]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanHsl]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__731951cc61bc2037703c8c6c7eef94566ebee4295bf150d6c9bbddb485fd5d3b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanHsv",
    jsii_struct_bases=[],
    name_mapping={
        "hue": "hue",
        "hue_var": "hueVar",
        "saturation": "saturation",
        "saturation_var": "saturationVar",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanHsv:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
        saturation: typing.Optional[builtins.str] = None,
        saturation_var: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: The number of degrees to rotate colors around the color wheel, ``0.0`` by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        :param saturation: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        :param saturation_var: A multiplier to adjust the saturation of colors in the image. Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        :param value: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__19836768698c256a4bbbaa97ff0ef3b6e5830c32ea169ced48c1da1fd41fc2c7)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
            check_type(argname="argument saturation", value=saturation, expected_type=type_hints["saturation"])
            check_type(argname="argument saturation_var", value=saturation_var, expected_type=type_hints["saturation_var"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var
        if saturation is not None:
            self._values["saturation"] = saturation
        if saturation_var is not None:
            self._values["saturation_var"] = saturation_var
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''The number of degrees to rotate colors around the color wheel, ``0.0`` by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
        '''
        result = self._values.get("saturation")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saturation_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the saturation of colors in the image.

        Values less than ``1.0`` decrease saturation and values greater than ``1.0`` increase the saturation. A value of ``0.0`` removes all color from the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
        '''
        result = self._values.get("saturation_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''A multiplier to adjust the lightness or darkness of the images base color.

        Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanHsv(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanHsvList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanHsvList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__53ae16a5e7c382034eb6901ebc4eafa4023708b1a0d88aece4a24a5f7d17b56d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanHsvOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab2342dec42edefb8779bb257a7f1909edd1fc44678eee771be85b7c909e87b2)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanHsvOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3d6de8ed829798fb52759ebeae20311f37c23267d01e482960987721274be11a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f44029c7cce2cc461408eb9c0206a38f8b8c1bc967d10b03446ecdd6f66931b8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__01c4110668aa5a4ea1a4b2bad0a2a5fd60e1c692bf57bce442f44a22132ad8fd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanHsv]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanHsv]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac181b30d9261288b5b9d24be3413228c495a91af2579823fb21636736d97c09)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanHsvOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanHsvOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__323bc9612cf32ef571976e008f537c7e82db06828d7941ce67e039c236e99cc3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @jsii.member(jsii_name="resetSaturation")
    def reset_saturation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturation", []))

    @jsii.member(jsii_name="resetSaturationVar")
    def reset_saturation_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaturationVar", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationInput")
    def saturation_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationInput"))

    @builtins.property
    @jsii.member(jsii_name="saturationVarInput")
    def saturation_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saturationVarInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0286d03812bbe1e2b5609fb46a300e96c84bcd624ddb12b2a1dece3b0a61af48)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__823b1b0ad0cb93e31da9fa9029b7e18f08285e3320fe8b487304499ad07ede78)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="saturation")
    def saturation(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturation"))

    @saturation.setter
    def saturation(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cdc8b18fe50355fc8cb39bc52b5e3acca1728dbf6498f8b2a642b332ccccc123)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturation", value)

    @builtins.property
    @jsii.member(jsii_name="saturationVar")
    def saturation_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saturationVar"))

    @saturation_var.setter
    def saturation_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__29f56211941540f063ff7a9976b9b19c46ecf04803cf8c7f25fadda58be3516c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saturationVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d071fccfc6e5f45b250e62801be539d8cffa57e24387bb733426718415803414)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__54257faa73f801e2e8343763b0ce2da782dad7224890b28e7ca1fde3106a5f28)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanHsv]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanHsv]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanHsv]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__375c83dfbaf1d38c3ced452e3d33164a6df102b98b916cd4ddefad386a532ded)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfDimension",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "dimension": "dimension",
        "dimension_var": "dimensionVar",
        "equal": "equal",
        "greater_than": "greaterThan",
        "less_than": "lessThan",
        "value": "value",
        "value_var": "valueVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfDimension:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        dimension: typing.Optional[builtins.str] = None,
        dimension_var: typing.Optional[builtins.str] = None,
        equal: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionEqual", typing.Dict[builtins.str, typing.Any]]] = None,
        greater_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionGreaterThan", typing.Dict[builtins.str, typing.Any]]] = None,
        less_than: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionLessThan", typing.Dict[builtins.str, typing.Any]]] = None,
        value: typing.Optional[builtins.str] = None,
        value_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param dimension: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        :param dimension_var: The dimension to use to select the transformation, either ``height``, ``width``, or ``both``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        :param equal: equal block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        :param greater_than: greater_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        :param less_than: less_than block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        :param value: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        :param value_var: The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionDefault(**default)
        if isinstance(equal, dict):
            equal = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionEqual(**equal)
        if isinstance(greater_than, dict):
            greater_than = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionGreaterThan(**greater_than)
        if isinstance(less_than, dict):
            less_than = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionLessThan(**less_than)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__34d129c913fe053a044d1006a4858ae45c6fefde045ea28ea46c219b734238f2)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument dimension", value=dimension, expected_type=type_hints["dimension"])
            check_type(argname="argument dimension_var", value=dimension_var, expected_type=type_hints["dimension_var"])
            check_type(argname="argument equal", value=equal, expected_type=type_hints["equal"])
            check_type(argname="argument greater_than", value=greater_than, expected_type=type_hints["greater_than"])
            check_type(argname="argument less_than", value=less_than, expected_type=type_hints["less_than"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
            check_type(argname="argument value_var", value=value_var, expected_type=type_hints["value_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if dimension is not None:
            self._values["dimension"] = dimension
        if dimension_var is not None:
            self._values["dimension_var"] = dimension_var
        if equal is not None:
            self._values["equal"] = equal
        if greater_than is not None:
            self._values["greater_than"] = greater_than
        if less_than is not None:
            self._values["less_than"] = less_than
        if value is not None:
            self._values["value"] = value
        if value_var is not None:
            self._values["value_var"] = value_var

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionDefault"], result)

    @builtins.property
    def dimension(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
        '''
        result = self._values.get("dimension")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def dimension_var(self) -> typing.Optional[builtins.str]:
        '''The dimension to use to select the transformation, either ``height``, ``width``, or ``both``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
        '''
        result = self._values.get("dimension_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def equal(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionEqual"]:
        '''equal block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
        '''
        result = self._values.get("equal")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionEqual"], result)

    @builtins.property
    def greater_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionGreaterThan"]:
        '''greater_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
        '''
        result = self._values.get("greater_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionGreaterThan"], result)

    @builtins.property
    def less_than(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionLessThan"]:
        '''less_than block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
        '''
        result = self._values.get("less_than")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionLessThan"], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_var(self) -> typing.Optional[builtins.str]:
        '''The value to compare against the source image dimension.

        For example, if the image dimension is less than the value the lessThan transformation is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
        '''
        result = self._values.get("value_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfDimension(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__28c0f2cb6eb99263bc928801cec0c2e92318dba3f5e05dfeb0ecdc4c809f8d10)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__224f36cbac10b8775c694f5e3b351c3bb50d29c5fb4fdb2485b674a63077d68b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionEqual",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionEqual:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionEqual(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionEqualOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionEqualOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b023327e65d343b776574bbddf02a8a87b52ea2795814ae0a3aa15b5f7596d37)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionEqual], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionEqual],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3cac9affd0b94d0c39f5a6a2f50efe91ecaae9d380c38285849022f3bb02082a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionGreaterThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionGreaterThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionGreaterThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionGreaterThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionGreaterThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8617b2571faab62ce7878fb6904b8c14763b9247479dc5ad9385c2ea9d4f7ffb)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionGreaterThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionGreaterThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__99b7882469e0c2b114e32da0128bc935cc8765905dea4d61d6cf466db62ecd26)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionLessThan",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionLessThan:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionLessThan(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionLessThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionLessThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__048ca11eb02511a39a6291ccadc2e4cf9a8ef2c7f98bf8ae5ccaad41239f8320)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionLessThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionLessThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bddb8a11cb3b23cfc0325663dd549549ec6f5e07cef5a86b9553d7f49596ac28)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__93b9d54e1e30fc09243ff809e781ea901a5aa04c1c7301e34db6de5c5f989d20)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__39b9b2f2abefb3c413a5820fe3869d802ecc6434386f6d458ecf0cbf3f3b6434)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a9de379e84492df9d2b166c97d1bc540a139dac4da8b144ffa0e0df9beb84ef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c6617825307e214d07519c2484faf6ff6dc0949cb8f4300d6580b7b2edd3e6c4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__933028075bb7130f500afb0d79da4b1f30f77b97ec0f124113b314c8f5f27c4d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfDimension]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfDimension]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__94873a5a8df2c34086386fc472ac418eaa2f71940ea4728f074a3157b3281d82)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__54a7148a45224df802c7197db0d832a7404e93c87e2fdb90fef8b93c25357bd3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putEqual")
    def put_equal(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionEqual()

        return typing.cast(None, jsii.invoke(self, "putEqual", [value]))

    @jsii.member(jsii_name="putGreaterThan")
    def put_greater_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionGreaterThan()

        return typing.cast(None, jsii.invoke(self, "putGreaterThan", [value]))

    @jsii.member(jsii_name="putLessThan")
    def put_less_than(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionLessThan()

        return typing.cast(None, jsii.invoke(self, "putLessThan", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetDimension")
    def reset_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimension", []))

    @jsii.member(jsii_name="resetDimensionVar")
    def reset_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimensionVar", []))

    @jsii.member(jsii_name="resetEqual")
    def reset_equal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEqual", []))

    @jsii.member(jsii_name="resetGreaterThan")
    def reset_greater_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGreaterThan", []))

    @jsii.member(jsii_name="resetLessThan")
    def reset_less_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLessThan", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="equal")
    def equal(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionEqualOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionEqualOutputReference, jsii.get(self, "equal"))

    @builtins.property
    @jsii.member(jsii_name="greaterThan")
    def greater_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionGreaterThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionGreaterThanOutputReference, jsii.get(self, "greaterThan"))

    @builtins.property
    @jsii.member(jsii_name="lessThan")
    def less_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionLessThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionLessThanOutputReference, jsii.get(self, "lessThan"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionInput")
    def dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionVarInput")
    def dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="equalInput")
    def equal_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionEqual], jsii.get(self, "equalInput"))

    @builtins.property
    @jsii.member(jsii_name="greaterThanInput")
    def greater_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionGreaterThan], jsii.get(self, "greaterThanInput"))

    @builtins.property
    @jsii.member(jsii_name="lessThanInput")
    def less_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionLessThan], jsii.get(self, "lessThanInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="dimension")
    def dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimension"))

    @dimension.setter
    def dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a096b7f0fd15cc2b383ccb3239ac75a48509a376d062110e27042e6558ff2a97)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimension", value)

    @builtins.property
    @jsii.member(jsii_name="dimensionVar")
    def dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimensionVar"))

    @dimension_var.setter
    def dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0e92b4d9175d21bb247e69b7eee7199e541db195a2d6a7a1a1fa14755f408727)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e4638347e02b984c60fede605850750ae91dd12cf455b37db8099aed98727c4e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__18c7960affa0e3dd635da33dbe348981d93a546b0f580c65babfafa0f136fea5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfDimension]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfDimension]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfDimension]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__faf259eb0adcc1490e78cf7979ab1781b78df87d8e2bfebd337222d89c02fe91)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfOrientation",
    jsii_struct_bases=[],
    name_mapping={
        "default": "default",
        "landscape": "landscape",
        "portrait": "portrait",
        "square": "square",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfOrientation:
    def __init__(
        self,
        *,
        default: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationDefault", typing.Dict[builtins.str, typing.Any]]] = None,
        landscape: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationLandscape", typing.Dict[builtins.str, typing.Any]]] = None,
        portrait: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationPortrait", typing.Dict[builtins.str, typing.Any]]] = None,
        square: typing.Optional[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationSquare", typing.Dict[builtins.str, typing.Any]]] = None,
    ) -> None:
        '''
        :param default: default block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        :param landscape: landscape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        :param portrait: portrait block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        :param square: square block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        if isinstance(default, dict):
            default = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationDefault(**default)
        if isinstance(landscape, dict):
            landscape = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationLandscape(**landscape)
        if isinstance(portrait, dict):
            portrait = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationPortrait(**portrait)
        if isinstance(square, dict):
            square = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationSquare(**square)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e35e512ec55ee449c6e0b630e2cc4ab7e15c1934219c114bda816ca221544798)
            check_type(argname="argument default", value=default, expected_type=type_hints["default"])
            check_type(argname="argument landscape", value=landscape, expected_type=type_hints["landscape"])
            check_type(argname="argument portrait", value=portrait, expected_type=type_hints["portrait"])
            check_type(argname="argument square", value=square, expected_type=type_hints["square"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if default is not None:
            self._values["default"] = default
        if landscape is not None:
            self._values["landscape"] = landscape
        if portrait is not None:
            self._values["portrait"] = portrait
        if square is not None:
            self._values["square"] = square

    @builtins.property
    def default(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationDefault"]:
        '''default block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
        '''
        result = self._values.get("default")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationDefault"], result)

    @builtins.property
    def landscape(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationLandscape"]:
        '''landscape block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
        '''
        result = self._values.get("landscape")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationLandscape"], result)

    @builtins.property
    def portrait(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationPortrait"]:
        '''portrait block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
        '''
        result = self._values.get("portrait")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationPortrait"], result)

    @builtins.property
    def square(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationSquare"]:
        '''square block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
        '''
        result = self._values.get("square")
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationSquare"], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfOrientation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationDefault",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationDefault:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationDefault(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationDefaultOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationDefaultOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__22fa163fe9b5d1cc8906b321a4efeb9db215bff9e775f96962d0a5e9dd05fca3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationDefault], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationDefault],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__868806ff37276d1b575fc729092b770f7fe5b2f18af3e55bd1bb2d0e3f22b81b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationLandscape",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationLandscape:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationLandscape(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationLandscapeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationLandscapeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4b1e3d95c2951a3f811b4227ce1ae4536716058c2577ef34600f7ff7b5e804d0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationLandscape], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationLandscape],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ccc48dd9ed9ca9c318321b5108d4c9f0981d9d12784b3b6d80cdf4d15b7561c0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__66c130bd69bf1514337470c3ce290c365419156836964d3c874c1642a06df298)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f37631619e3c246492924e9f6845ee071adb01bcdc7593abe2dd61a682a5425f)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5edd0f8bb5272ed90d0281930ef355b38b4f8c21f887f6bed054d12d018d4cde)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a18b221a9b8c70207eedffb44d680f20210e2158738bd83f78aa55964fbc8c4d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c3d9db3a66ebbe94d1281351b0259158833b7ff61fca6ceb823f8a508034e584)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfOrientation]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfOrientation]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__667a0569356e8c28cafb52442a9080b990513c08af26cb9ad3623da4a471a0b2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2f6904e17c5c6d3c86abaa416bc507a9bd544a3f6f5b07e67b3dfc066ed7e6c4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationDefault()

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putLandscape")
    def put_landscape(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationLandscape()

        return typing.cast(None, jsii.invoke(self, "putLandscape", [value]))

    @jsii.member(jsii_name="putPortrait")
    def put_portrait(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationPortrait()

        return typing.cast(None, jsii.invoke(self, "putPortrait", [value]))

    @jsii.member(jsii_name="putSquare")
    def put_square(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationSquare()

        return typing.cast(None, jsii.invoke(self, "putSquare", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetLandscape")
    def reset_landscape(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLandscape", []))

    @jsii.member(jsii_name="resetPortrait")
    def reset_portrait(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPortrait", []))

    @jsii.member(jsii_name="resetSquare")
    def reset_square(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSquare", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="landscape")
    def landscape(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationLandscapeOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationLandscapeOutputReference, jsii.get(self, "landscape"))

    @builtins.property
    @jsii.member(jsii_name="portrait")
    def portrait(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationPortraitOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationPortraitOutputReference", jsii.get(self, "portrait"))

    @builtins.property
    @jsii.member(jsii_name="square")
    def square(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationSquareOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationSquareOutputReference", jsii.get(self, "square"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="landscapeInput")
    def landscape_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationLandscape]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationLandscape], jsii.get(self, "landscapeInput"))

    @builtins.property
    @jsii.member(jsii_name="portraitInput")
    def portrait_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationPortrait"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationPortrait"], jsii.get(self, "portraitInput"))

    @builtins.property
    @jsii.member(jsii_name="squareInput")
    def square_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationSquare"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationSquare"], jsii.get(self, "squareInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfOrientation]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfOrientation]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfOrientation]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__55106d3d675d2a5cfb206e3902f27e9e01b7fa779c0efc021d30e30683e6d45f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationPortrait",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationPortrait:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationPortrait(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationPortraitOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationPortraitOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1313b41239f7941cf5ded5a885e03f3cc131170cfc8df208cf0d18a2a69f3f69)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationPortrait]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationPortrait], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationPortrait],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__89e20dc2e58feace8a603ff96b66bdc5d758e4e0d82ec8c9f8d170295dce3b5a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationSquare",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationSquare:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationSquare(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationSquareOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationSquareOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ef1f1e8a3f23a68273d14326476f7aa4f2aa60b93c0d113fb0a6424acb5b020)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationSquare]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationSquare], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationSquare],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2e315e3211dca9b6269e566012f7720c9be38760ed65286c412e30086bde3048)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanImQuery",
    jsii_struct_bases=[],
    name_mapping={
        "allowed_transformations": "allowedTransformations",
        "query_var": "queryVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanImQuery:
    def __init__(
        self,
        *,
        allowed_transformations: typing.Sequence[builtins.str],
        query_var: builtins.str,
    ) -> None:
        '''
        :param allowed_transformations: Specifies the transformations that can be applied using the query string parameter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allowed_transformations DataAkamaiImagingPolicyImage#allowed_transformations}
        :param query_var: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#query_var DataAkamaiImagingPolicyImage#query_var}.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__23bd17808449125dcd8603ca46e1a26638b98a910a7183dadd915263184a1659)
            check_type(argname="argument allowed_transformations", value=allowed_transformations, expected_type=type_hints["allowed_transformations"])
            check_type(argname="argument query_var", value=query_var, expected_type=type_hints["query_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "allowed_transformations": allowed_transformations,
            "query_var": query_var,
        }

    @builtins.property
    def allowed_transformations(self) -> typing.List[builtins.str]:
        '''Specifies the transformations that can be applied using the query string parameter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allowed_transformations DataAkamaiImagingPolicyImage#allowed_transformations}
        '''
        result = self._values.get("allowed_transformations")
        assert result is not None, "Required property 'allowed_transformations' is missing"
        return typing.cast(typing.List[builtins.str], result)

    @builtins.property
    def query_var(self) -> builtins.str:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#query_var DataAkamaiImagingPolicyImage#query_var}.'''
        result = self._values.get("query_var")
        assert result is not None, "Required property 'query_var' is missing"
        return typing.cast(builtins.str, result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanImQuery(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanImQueryList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanImQueryList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__248050f82a6b2a8deea410ff053df4f99df91cbb5757b622f1a1c2de39967c74)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanImQueryOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dfc343125048431e4831a79523b0424b2984bf86d7ff040224a6539d9f5715a1)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanImQueryOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__524fbeb7b4e74ab92ba1ae55a0dac794f8038f76b43b1b3cf8fde9d3e6bd9b50)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0aac64e976a9460097c76b2c432e70af92308409b3ceb4e19f9b3d661fcd5798)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1e1042d982dfba2f8063c54d235c0593b198074604cfde942198e3f56c1c2918)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanImQuery]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanImQuery]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanImQuery]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5bdd8c20bc4e3237f7d4532c44b513b19ff60a0cb6a54fffd0d2dc66221e546c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanImQueryOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanImQueryOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c025d82d1969a24a435bf3b01690270841f750d8c01baaf7bb06ee623e7d056e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @builtins.property
    @jsii.member(jsii_name="allowedTransformationsInput")
    def allowed_transformations_input(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "allowedTransformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="queryVarInput")
    def query_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "queryVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowedTransformations")
    def allowed_transformations(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "allowedTransformations"))

    @allowed_transformations.setter
    def allowed_transformations(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__41ec90f2b8202e5072f4c7eea0f59d2992c671ca8434fd5d04decd04f2cdfebb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowedTransformations", value)

    @builtins.property
    @jsii.member(jsii_name="queryVar")
    def query_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "queryVar"))

    @query_var.setter
    def query_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e0a32181a681ba98cfa9451ad161e71e1b2e889dd6416c953ee345957e650bfa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "queryVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanImQuery]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanImQuery]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanImQuery]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__07126174cd7b6af25d93a44126aae7d74f386b2f7512051e613a90daab0dc0eb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanMaxColors",
    jsii_struct_bases=[],
    name_mapping={"colors": "colors", "colors_var": "colorsVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanMaxColors:
    def __init__(
        self,
        *,
        colors: typing.Optional[builtins.str] = None,
        colors_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param colors: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        :param colors_var: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4064ba2a1e2cf062eb7dc62100aa77f8e1c1087ce6f152a367bbcf8b082e7807)
            check_type(argname="argument colors", value=colors, expected_type=type_hints["colors"])
            check_type(argname="argument colors_var", value=colors_var, expected_type=type_hints["colors_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if colors is not None:
            self._values["colors"] = colors
        if colors_var is not None:
            self._values["colors_var"] = colors_var

    @builtins.property
    def colors(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        '''
        result = self._values.get("colors")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def colors_var(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        result = self._values.get("colors_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanMaxColors(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanMaxColorsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanMaxColorsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b1cda5c72b6ec451143e0344ee2c8aab41d0d44d2347ab53c33d9bc3890d8321)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanMaxColorsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__062e2928f5967fa2efc9b4af0026384a2a28c4d68b7ea4ba95a867d9b3db4930)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanMaxColorsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3eae7998c86141be239bb0990ba7393ac4bb762280f110c066cc48fa1e3e0973)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d8ba4ac811462f3d095cffcce2b416d3ec375f7ec39e89dcf5abd6d3adefdf5f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d23e0edb9df42e8537b3a996668f5b06fa7236702867ee621a8401689279f9e6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanMaxColors]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanMaxColors]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dace6f16dd3eddba01c10a5f69d2911b14b63f91a6cb2e50585b9ce0cd324bdb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanMaxColorsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanMaxColorsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f7918b7c4e75e50fcdc74e68f220c2e2fcac68dd6255fe6591e9c0c834dc223b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColors")
    def reset_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColors", []))

    @jsii.member(jsii_name="resetColorsVar")
    def reset_colors_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorsVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorsInput")
    def colors_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsInput"))

    @builtins.property
    @jsii.member(jsii_name="colorsVarInput")
    def colors_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsVarInput"))

    @builtins.property
    @jsii.member(jsii_name="colors")
    def colors(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colors"))

    @colors.setter
    def colors(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fee69c43bcd353b81e24cf3b5e6915484ff78d218948064621ef8aec48e7e67e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colors", value)

    @builtins.property
    @jsii.member(jsii_name="colorsVar")
    def colors_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorsVar"))

    @colors_var.setter
    def colors_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ffe29d10f4cabeb75f088bd8284abce5efb12def41d2b94fd2a53cddf4a2d933)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorsVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanMaxColors]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanMaxColors]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanMaxColors]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9dd31854410e698d71092a242778c5a712a1222d3916c2639f3e911a22c63494)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanMirror",
    jsii_struct_bases=[],
    name_mapping={
        "horizontal": "horizontal",
        "horizontal_var": "horizontalVar",
        "vertical": "vertical",
        "vertical_var": "verticalVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanMirror:
    def __init__(
        self,
        *,
        horizontal: typing.Optional[builtins.str] = None,
        horizontal_var: typing.Optional[builtins.str] = None,
        vertical: typing.Optional[builtins.str] = None,
        vertical_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param horizontal: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        :param horizontal_var: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        :param vertical: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        :param vertical_var: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__782545bf2e2d2a3449f0f4d275c999a11139478452ff361d9501a23747c05a49)
            check_type(argname="argument horizontal", value=horizontal, expected_type=type_hints["horizontal"])
            check_type(argname="argument horizontal_var", value=horizontal_var, expected_type=type_hints["horizontal_var"])
            check_type(argname="argument vertical", value=vertical, expected_type=type_hints["vertical"])
            check_type(argname="argument vertical_var", value=vertical_var, expected_type=type_hints["vertical_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if horizontal is not None:
            self._values["horizontal"] = horizontal
        if horizontal_var is not None:
            self._values["horizontal_var"] = horizontal_var
        if vertical is not None:
            self._values["vertical"] = vertical
        if vertical_var is not None:
            self._values["vertical_var"] = vertical_var

    @builtins.property
    def horizontal(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        '''
        result = self._values.get("horizontal")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def horizontal_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        '''
        result = self._values.get("horizontal_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        '''
        result = self._values.get("vertical")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        result = self._values.get("vertical_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanMirror(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanMirrorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanMirrorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__542eb409ae693ce3543c4edeca0aa26e7fc164505d4669469187014409c380a4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanMirrorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd0b43c42eadbc34eea65949749050575899055eeccc0a9fa81a83e6e0367d2f)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanMirrorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__50cc60f4cc94c6f3a8eb972ca6eb7acba9696835725cf37cd16fd20c0732954a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c58cd572bb9cee3df82defc998b05af9e6c0d40fe728dd138031308588903f7c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e921e9de73aebb0d3a827e32fa8160a2d2f7fa9e0825d892b0243a8a7360880e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanMirror]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanMirror]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7813d8c7a5425eb93b5301ebfa698aaf225a0cede68ba5c8279d498d144f414b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanMirrorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanMirrorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fb88beced0d59f69c1ed6cffda193ca5661c41ffe6074867ff25ca973dac44ba)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHorizontal")
    def reset_horizontal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontal", []))

    @jsii.member(jsii_name="resetHorizontalVar")
    def reset_horizontal_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontalVar", []))

    @jsii.member(jsii_name="resetVertical")
    def reset_vertical(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVertical", []))

    @jsii.member(jsii_name="resetVerticalVar")
    def reset_vertical_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVerticalVar", []))

    @builtins.property
    @jsii.member(jsii_name="horizontalInput")
    def horizontal_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontalVarInput")
    def horizontal_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalInput")
    def vertical_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalVarInput")
    def vertical_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontal")
    def horizontal(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontal"))

    @horizontal.setter
    def horizontal(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__890784e7236213ef74ad1328474cee7af32fb34712940a73fed15b27de7d7b50)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontal", value)

    @builtins.property
    @jsii.member(jsii_name="horizontalVar")
    def horizontal_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontalVar"))

    @horizontal_var.setter
    def horizontal_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5763d02da73919cbaa17af84541f08c5f25b74c557deea4a7f5734cdb7e40c33)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontalVar", value)

    @builtins.property
    @jsii.member(jsii_name="vertical")
    def vertical(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "vertical"))

    @vertical.setter
    def vertical(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1df6c11a7115de813ed3f010388cb9752d4085033ca6da2a10920077f1d7e480)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "vertical", value)

    @builtins.property
    @jsii.member(jsii_name="verticalVar")
    def vertical_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "verticalVar"))

    @vertical_var.setter
    def vertical_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2262ec1ac1b0ead227818622f44b06ecee929d72ece9497015671c0a52f6ddbd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "verticalVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanMirror]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanMirror]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanMirror]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b6361384ece32b86c93cf205c216c6a7e2854efe9c5b1b1e3d8883091f17ef73)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanMonoHue",
    jsii_struct_bases=[],
    name_mapping={"hue": "hue", "hue_var": "hueVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanMonoHue:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__71c07702b0ae1140b73dbd1fafd67e3878b28d825fca3c7d278f7c15b3328c57)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanMonoHue(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanMonoHueList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanMonoHueList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__96692df872a45c7e815e83155abbceada3fc8e0b456534fd8fd30eaf60036d9d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanMonoHueOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f3e4d72b5d92dd0467c6a438318a286b6e2a4a8e5da0d0f288cde39fd83461b)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanMonoHueOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c67f135138303b8b1f141af8fa81a2407c0e9e0c25193df30709dbfab74af156)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__40b89606af7b1927e2b75adf57b55662ba5ef757685c09a9fea0e6bb248c939e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b7ccb2ed168ddfe0d358967dc21bb5c2fae125c19b52850130e10b2a65bfa3af)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanMonoHue]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanMonoHue]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f9c98fac17de350767b79a196b6da96386886aac774439e67b70631ee7e1c88b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanMonoHueOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanMonoHueOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__94f29c9e0d43f6b64d246235eb49ced6884f8b245d983f542fd7a33d26226861)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a41241bfe881fdc0339bac9017078c924ed078b598d405fbdeff6b7d93180c59)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c8b7ff8eedf9eddf70e13dcba68a04a52c33c115d00ceac0a1d896814a5d26f3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanMonoHue]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanMonoHue]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanMonoHue]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cb57f49c2417e9ee5068f490c5fc638935a6232ea1999bf46a9836105be312e4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanOpacity",
    jsii_struct_bases=[],
    name_mapping={"opacity": "opacity", "opacity_var": "opacityVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanOpacity:
    def __init__(
        self,
        *,
        opacity: typing.Optional[builtins.str] = None,
        opacity_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param opacity: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param opacity_var: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6c826ddd1fb8c43a05f43e2f1e801f4f2388fc3e7b4113d18f1e23779602bb1d)
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument opacity_var", value=opacity_var, expected_type=type_hints["opacity_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if opacity is not None:
            self._values["opacity"] = opacity
        if opacity_var is not None:
            self._values["opacity_var"] = opacity_var

    @builtins.property
    def opacity(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def opacity_var(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        result = self._values.get("opacity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanOpacity(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanOpacityList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanOpacityList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5fdb1b565c5f67dd09d68d57f978658866c3a7025e051bdb1d6d076595220ee9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanOpacityOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6af80e6e91877a9ec576538adcb20e4cf43e50a4e92d5389754e7a6d26b69be7)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanOpacityOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__51389e3d4257b058b616b736edfa063c901f59115dc6d81dca0fce62ea9e0139)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__782872678dbcd4080572ff36fcb76f3793956b58d292be8b7055f01984705709)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0e89369ff5ef83498355e5a3a2802e736f97b04fd0b5e3821eca4d30a73f5797)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanOpacity]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanOpacity]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__41f49c2c91f3d33aba1c57a4967c2745a7b3dfcecd76ebee3c49639324a60db5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanOpacityOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanOpacityOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__98f0864cb56f5272fd4bcb6d3061961bee2594df72cef1eb0b522e788457df24)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetOpacityVar")
    def reset_opacity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacityVar", []))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityVarInput")
    def opacity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacity"))

    @opacity.setter
    def opacity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8b108ceaf34a1c936a483fdd16b7d1cd8bc6a8e5c99dfbe694fa9688a9945042)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacity", value)

    @builtins.property
    @jsii.member(jsii_name="opacityVar")
    def opacity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacityVar"))

    @opacity_var.setter
    def opacity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__46d697c57ffa3db8dff63ebf6303032956deff1db844773f1e59d09ec87681d9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacityVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanOpacity]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanOpacity]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanOpacity]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f6cb3585c64a892c35b2888476b8ccc695b59bcddc0ef252563d39df440bd3c2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eed3a907edce4c39b980aba4cef4a962f64d09ad55f8630c5f767d436747bd1d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putAppend")
    def put_append(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanAppend, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__05d3be9c5787f7d40db22705d57b6a36c713205320da08ea066a2feef6682e55)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putAppend", [value]))

    @jsii.member(jsii_name="putAspectCrop")
    def put_aspect_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanAspectCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c69933350fd4337744ba75a9328930dc40bb06ecaeb8321a9177652c579192fc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putAspectCrop", [value]))

    @jsii.member(jsii_name="putBackgroundColor")
    def put_background_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3cfc3e314231b7371d728c1baf337d34c3d6d0e171cfd1658d15bd1a570515aa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBackgroundColor", [value]))

    @jsii.member(jsii_name="putBlur")
    def put_blur(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanBlur, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ef5120373b10fff2699850e3bdfe5db33f988d9da246b62e676ac78ddb7b4a22)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBlur", [value]))

    @jsii.member(jsii_name="putChromaKey")
    def put_chroma_key(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanChromaKey, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3f30d0c0393ebfb282c59668f2d9916f0596462f994fd6242c638a6a8940db31)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putChromaKey", [value]))

    @jsii.member(jsii_name="putComposite")
    def put_composite(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanComposite, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__51eee7bcb634cadce8acd6d27d2873edb8a60b2c9498197ff54355368c60c5dc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putComposite", [value]))

    @jsii.member(jsii_name="putCompound")
    def put_compound(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanCompound, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f0243fb2600ace2b0e91b6150dfc3cd18188149fedbf63e7e3cdfa3e22abd31f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCompound", [value]))

    @jsii.member(jsii_name="putContrast")
    def put_contrast(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanContrast, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0932e18230fa1df54d501f075d0d4de8e5b56ee09a2442a2648742d24af6fbe2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putContrast", [value]))

    @jsii.member(jsii_name="putCrop")
    def put_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1eb83aca763399595bcfaab9087a59f4dbd39f5f60232a36da114c9973ae441d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCrop", [value]))

    @jsii.member(jsii_name="putFaceCrop")
    def put_face_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanFaceCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__85227ec8e0114da221f5cf4958b29b9dc0a4e474ed460fd107f62659dc480cf2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFaceCrop", [value]))

    @jsii.member(jsii_name="putFeatureCrop")
    def put_feature_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanFeatureCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__04ccfbd123679ff4b4a817e804ea9b8a43437f9bd2d0404ff63e28bd8ed33636)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFeatureCrop", [value]))

    @jsii.member(jsii_name="putFitAndFill")
    def put_fit_and_fill(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanFitAndFill, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b63bdab6b1bb6d603cc88cdd350dea529dafb3ffb24f9ebbfd14778844567051)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFitAndFill", [value]))

    @jsii.member(jsii_name="putGoop")
    def put_goop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanGoop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8e2b4f0472fbea51e9f09d6a9126fa196d28478103c1babef3658a3d3a3889a5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGoop", [value]))

    @jsii.member(jsii_name="putGrayscale")
    def put_grayscale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanGrayscale, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5bd7890eb9424b1e2774bbe8e087bfdf13338dc5d82942dc0236d61bdeeb33ad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGrayscale", [value]))

    @jsii.member(jsii_name="putHsl")
    def put_hsl(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanHsl, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0c825598c53db7137068f388ba2c66698351bef6c3f2071d9c3984763556e4fc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsl", [value]))

    @jsii.member(jsii_name="putHsv")
    def put_hsv(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanHsv, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__534cc2c6de8a8622e6dd6ee72ed70e0224b488f5cf77988f3bec788b1b6f5230)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsv", [value]))

    @jsii.member(jsii_name="putIfDimension")
    def put_if_dimension(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfDimension, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1d930b72245d6f8373d53ccfbd2ee20be8e7cd1b24e07c2fcf57b02e1770a899)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfDimension", [value]))

    @jsii.member(jsii_name="putIfOrientation")
    def put_if_orientation(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__63e328f2a50c13544a038aae99a5b5dc6003a5d26f4ed535f291ca6cf5639a42)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfOrientation", [value]))

    @jsii.member(jsii_name="putImQuery")
    def put_im_query(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanImQuery, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ba7cc7bcc8cb45394cafb96518148f6f773efabb85f7d7a3b2e5e5f3d0e75235)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putImQuery", [value]))

    @jsii.member(jsii_name="putMaxColors")
    def put_max_colors(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanMaxColors, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c75ae8907ad75ce7d55d343001bd999002e674d7cf9f096e2170cbfcf096b09c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMaxColors", [value]))

    @jsii.member(jsii_name="putMirror")
    def put_mirror(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanMirror, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d216b61ad47374d16f283e7a9f942c15116683c768a3b4185c9815c5ab8be1d5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMirror", [value]))

    @jsii.member(jsii_name="putMonoHue")
    def put_mono_hue(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanMonoHue, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2fa0168f3badcec9e977444319750fd84469e99d1ec47055dfd90990f3212051)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMonoHue", [value]))

    @jsii.member(jsii_name="putOpacity")
    def put_opacity(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanOpacity, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f3585ad3ec33ec68ae51e326757b8aa52d0c139e0496688c54774ff4b062e90d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putOpacity", [value]))

    @jsii.member(jsii_name="putRegionOfInterestCrop")
    def put_region_of_interest_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanRegionOfInterestCrop", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a8b4b08f3a7ce3a26bdc89630d5428da4ceededffda8e05293803beba02e7b1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRegionOfInterestCrop", [value]))

    @jsii.member(jsii_name="putRelativeCrop")
    def put_relative_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanRelativeCrop", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2cd14cb39259b600634c35d24548b550a095ccd811f95e37abe88b1f6b911b4b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRelativeCrop", [value]))

    @jsii.member(jsii_name="putRemoveColor")
    def put_remove_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanRemoveColor", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9c6e172be28d95f416bfc0ebcb6b0ec0a33de92744d669bb16ff95b504aa1327)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRemoveColor", [value]))

    @jsii.member(jsii_name="putResize")
    def put_resize(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanResize", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b24ca5c15818faa6fe9adb5a56fd0eb9fb7d19e7ad24ed7365e8792a3fa6857b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putResize", [value]))

    @jsii.member(jsii_name="putRotate")
    def put_rotate(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanRotate", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__39021ab3e53fc8954691e6295eff468450d8885c7d9c3f0a8925547e465af2e0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRotate", [value]))

    @jsii.member(jsii_name="putScale")
    def put_scale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanScale", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4b85161f92cafc2725e10ca738f11b75b9f4827d80bf7eaf172a8b54948fe050)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putScale", [value]))

    @jsii.member(jsii_name="putShear")
    def put_shear(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanShear", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a5e9d263fdb2825b2c411ea8ad1a119f2042682ee1c80f2612c8a19af4a1ee4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putShear", [value]))

    @jsii.member(jsii_name="putTrim")
    def put_trim(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanTrim", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__29f5652912a43865099e6be08bf805462c54ceec731f4781a33ca029dba9a6e7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTrim", [value]))

    @jsii.member(jsii_name="putUnsharpMask")
    def put_unsharp_mask(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanUnsharpMask", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ccec55b99db96021df4312fa3cf881a5dd897ba835e8f06941931a803a879e1d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putUnsharpMask", [value]))

    @jsii.member(jsii_name="resetAppend")
    def reset_append(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAppend", []))

    @jsii.member(jsii_name="resetAspectCrop")
    def reset_aspect_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspectCrop", []))

    @jsii.member(jsii_name="resetBackgroundColor")
    def reset_background_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBackgroundColor", []))

    @jsii.member(jsii_name="resetBlur")
    def reset_blur(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBlur", []))

    @jsii.member(jsii_name="resetChromaKey")
    def reset_chroma_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChromaKey", []))

    @jsii.member(jsii_name="resetComposite")
    def reset_composite(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetComposite", []))

    @jsii.member(jsii_name="resetCompound")
    def reset_compound(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCompound", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetCrop")
    def reset_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCrop", []))

    @jsii.member(jsii_name="resetFaceCrop")
    def reset_face_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFaceCrop", []))

    @jsii.member(jsii_name="resetFeatureCrop")
    def reset_feature_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureCrop", []))

    @jsii.member(jsii_name="resetFitAndFill")
    def reset_fit_and_fill(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFitAndFill", []))

    @jsii.member(jsii_name="resetGoop")
    def reset_goop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGoop", []))

    @jsii.member(jsii_name="resetGrayscale")
    def reset_grayscale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGrayscale", []))

    @jsii.member(jsii_name="resetHsl")
    def reset_hsl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsl", []))

    @jsii.member(jsii_name="resetHsv")
    def reset_hsv(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsv", []))

    @jsii.member(jsii_name="resetIfDimension")
    def reset_if_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfDimension", []))

    @jsii.member(jsii_name="resetIfOrientation")
    def reset_if_orientation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfOrientation", []))

    @jsii.member(jsii_name="resetImQuery")
    def reset_im_query(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetImQuery", []))

    @jsii.member(jsii_name="resetMaxColors")
    def reset_max_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxColors", []))

    @jsii.member(jsii_name="resetMirror")
    def reset_mirror(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMirror", []))

    @jsii.member(jsii_name="resetMonoHue")
    def reset_mono_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonoHue", []))

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetRegionOfInterestCrop")
    def reset_region_of_interest_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRegionOfInterestCrop", []))

    @jsii.member(jsii_name="resetRelativeCrop")
    def reset_relative_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRelativeCrop", []))

    @jsii.member(jsii_name="resetRemoveColor")
    def reset_remove_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRemoveColor", []))

    @jsii.member(jsii_name="resetResize")
    def reset_resize(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetResize", []))

    @jsii.member(jsii_name="resetRotate")
    def reset_rotate(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRotate", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetShear")
    def reset_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetShear", []))

    @jsii.member(jsii_name="resetTrim")
    def reset_trim(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTrim", []))

    @jsii.member(jsii_name="resetUnsharpMask")
    def reset_unsharp_mask(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUnsharpMask", []))

    @builtins.property
    @jsii.member(jsii_name="append")
    def append(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanAppendList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanAppendList, jsii.get(self, "append"))

    @builtins.property
    @jsii.member(jsii_name="aspectCrop")
    def aspect_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanAspectCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanAspectCropList, jsii.get(self, "aspectCrop"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColor")
    def background_color(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanBackgroundColorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanBackgroundColorList, jsii.get(self, "backgroundColor"))

    @builtins.property
    @jsii.member(jsii_name="blur")
    def blur(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanBlurList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanBlurList, jsii.get(self, "blur"))

    @builtins.property
    @jsii.member(jsii_name="chromaKey")
    def chroma_key(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanChromaKeyList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanChromaKeyList, jsii.get(self, "chromaKey"))

    @builtins.property
    @jsii.member(jsii_name="composite")
    def composite(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanCompositeList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanCompositeList, jsii.get(self, "composite"))

    @builtins.property
    @jsii.member(jsii_name="compound")
    def compound(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanCompoundList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanCompoundList, jsii.get(self, "compound"))

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanContrastList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanContrastList, jsii.get(self, "contrast"))

    @builtins.property
    @jsii.member(jsii_name="crop")
    def crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanCropList, jsii.get(self, "crop"))

    @builtins.property
    @jsii.member(jsii_name="faceCrop")
    def face_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanFaceCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanFaceCropList, jsii.get(self, "faceCrop"))

    @builtins.property
    @jsii.member(jsii_name="featureCrop")
    def feature_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanFeatureCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanFeatureCropList, jsii.get(self, "featureCrop"))

    @builtins.property
    @jsii.member(jsii_name="fitAndFill")
    def fit_and_fill(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanFitAndFillList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanFitAndFillList, jsii.get(self, "fitAndFill"))

    @builtins.property
    @jsii.member(jsii_name="goop")
    def goop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanGoopList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanGoopList, jsii.get(self, "goop"))

    @builtins.property
    @jsii.member(jsii_name="grayscale")
    def grayscale(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanGrayscaleList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanGrayscaleList, jsii.get(self, "grayscale"))

    @builtins.property
    @jsii.member(jsii_name="hsl")
    def hsl(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanHslList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanHslList, jsii.get(self, "hsl"))

    @builtins.property
    @jsii.member(jsii_name="hsv")
    def hsv(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanHsvList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanHsvList, jsii.get(self, "hsv"))

    @builtins.property
    @jsii.member(jsii_name="ifDimension")
    def if_dimension(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionList, jsii.get(self, "ifDimension"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientation")
    def if_orientation(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationList, jsii.get(self, "ifOrientation"))

    @builtins.property
    @jsii.member(jsii_name="imQuery")
    def im_query(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanImQueryList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanImQueryList, jsii.get(self, "imQuery"))

    @builtins.property
    @jsii.member(jsii_name="maxColors")
    def max_colors(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanMaxColorsList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanMaxColorsList, jsii.get(self, "maxColors"))

    @builtins.property
    @jsii.member(jsii_name="mirror")
    def mirror(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanMirrorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanMirrorList, jsii.get(self, "mirror"))

    @builtins.property
    @jsii.member(jsii_name="monoHue")
    def mono_hue(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanMonoHueList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanMonoHueList, jsii.get(self, "monoHue"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanOpacityList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanOpacityList, jsii.get(self, "opacity"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestCrop")
    def region_of_interest_crop(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanRegionOfInterestCropList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanRegionOfInterestCropList", jsii.get(self, "regionOfInterestCrop"))

    @builtins.property
    @jsii.member(jsii_name="relativeCrop")
    def relative_crop(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanRelativeCropList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanRelativeCropList", jsii.get(self, "relativeCrop"))

    @builtins.property
    @jsii.member(jsii_name="removeColor")
    def remove_color(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanRemoveColorList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanRemoveColorList", jsii.get(self, "removeColor"))

    @builtins.property
    @jsii.member(jsii_name="resize")
    def resize(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanResizeList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanResizeList", jsii.get(self, "resize"))

    @builtins.property
    @jsii.member(jsii_name="rotate")
    def rotate(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanRotateList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanRotateList", jsii.get(self, "rotate"))

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanScaleList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanScaleList", jsii.get(self, "scale"))

    @builtins.property
    @jsii.member(jsii_name="shear")
    def shear(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanShearList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanShearList", jsii.get(self, "shear"))

    @builtins.property
    @jsii.member(jsii_name="trim")
    def trim(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanTrimList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanTrimList", jsii.get(self, "trim"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMask")
    def unsharp_mask(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanUnsharpMaskList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanUnsharpMaskList", jsii.get(self, "unsharpMask"))

    @builtins.property
    @jsii.member(jsii_name="appendInput")
    def append_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanAppend]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanAppend]]], jsii.get(self, "appendInput"))

    @builtins.property
    @jsii.member(jsii_name="aspectCropInput")
    def aspect_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanAspectCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanAspectCrop]]], jsii.get(self, "aspectCropInput"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColorInput")
    def background_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanBackgroundColor]]], jsii.get(self, "backgroundColorInput"))

    @builtins.property
    @jsii.member(jsii_name="blurInput")
    def blur_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanBlur]]], jsii.get(self, "blurInput"))

    @builtins.property
    @jsii.member(jsii_name="chromaKeyInput")
    def chroma_key_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanChromaKey]]], jsii.get(self, "chromaKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="compositeInput")
    def composite_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanComposite]]], jsii.get(self, "compositeInput"))

    @builtins.property
    @jsii.member(jsii_name="compoundInput")
    def compound_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanCompound]]], jsii.get(self, "compoundInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanContrast]]], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="cropInput")
    def crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanCrop]]], jsii.get(self, "cropInput"))

    @builtins.property
    @jsii.member(jsii_name="faceCropInput")
    def face_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanFaceCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanFaceCrop]]], jsii.get(self, "faceCropInput"))

    @builtins.property
    @jsii.member(jsii_name="featureCropInput")
    def feature_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanFeatureCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanFeatureCrop]]], jsii.get(self, "featureCropInput"))

    @builtins.property
    @jsii.member(jsii_name="fitAndFillInput")
    def fit_and_fill_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanFitAndFill]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanFitAndFill]]], jsii.get(self, "fitAndFillInput"))

    @builtins.property
    @jsii.member(jsii_name="goopInput")
    def goop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanGoop]]], jsii.get(self, "goopInput"))

    @builtins.property
    @jsii.member(jsii_name="grayscaleInput")
    def grayscale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanGrayscale]]], jsii.get(self, "grayscaleInput"))

    @builtins.property
    @jsii.member(jsii_name="hslInput")
    def hsl_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanHsl]]], jsii.get(self, "hslInput"))

    @builtins.property
    @jsii.member(jsii_name="hsvInput")
    def hsv_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanHsv]]], jsii.get(self, "hsvInput"))

    @builtins.property
    @jsii.member(jsii_name="ifDimensionInput")
    def if_dimension_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfDimension]]], jsii.get(self, "ifDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientationInput")
    def if_orientation_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfOrientation]]], jsii.get(self, "ifOrientationInput"))

    @builtins.property
    @jsii.member(jsii_name="imQueryInput")
    def im_query_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanImQuery]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanImQuery]]], jsii.get(self, "imQueryInput"))

    @builtins.property
    @jsii.member(jsii_name="maxColorsInput")
    def max_colors_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanMaxColors]]], jsii.get(self, "maxColorsInput"))

    @builtins.property
    @jsii.member(jsii_name="mirrorInput")
    def mirror_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanMirror]]], jsii.get(self, "mirrorInput"))

    @builtins.property
    @jsii.member(jsii_name="monoHueInput")
    def mono_hue_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanMonoHue]]], jsii.get(self, "monoHueInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanOpacity]]], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestCropInput")
    def region_of_interest_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanRegionOfInterestCrop"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanRegionOfInterestCrop"]]], jsii.get(self, "regionOfInterestCropInput"))

    @builtins.property
    @jsii.member(jsii_name="relativeCropInput")
    def relative_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanRelativeCrop"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanRelativeCrop"]]], jsii.get(self, "relativeCropInput"))

    @builtins.property
    @jsii.member(jsii_name="removeColorInput")
    def remove_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanRemoveColor"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanRemoveColor"]]], jsii.get(self, "removeColorInput"))

    @builtins.property
    @jsii.member(jsii_name="resizeInput")
    def resize_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanResize"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanResize"]]], jsii.get(self, "resizeInput"))

    @builtins.property
    @jsii.member(jsii_name="rotateInput")
    def rotate_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanRotate"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanRotate"]]], jsii.get(self, "rotateInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanScale"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanScale"]]], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="shearInput")
    def shear_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanShear"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanShear"]]], jsii.get(self, "shearInput"))

    @builtins.property
    @jsii.member(jsii_name="trimInput")
    def trim_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanTrim"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanTrim"]]], jsii.get(self, "trimInput"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMaskInput")
    def unsharp_mask_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanUnsharpMask"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanUnsharpMask"]]], jsii.get(self, "unsharpMaskInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThan], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThan],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0e9a2265e6f0d88a6da385ca4afc604137af113ecc991cb939b08ae61fe7400c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanRegionOfInterestCrop",
    jsii_struct_bases=[],
    name_mapping={
        "region_of_interest": "regionOfInterest",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanRegionOfInterestCrop:
    def __init__(
        self,
        *,
        region_of_interest: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanRegionOfInterestCropRegionOfInterest", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param region_of_interest: region_of_interest block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest DataAkamaiImagingPolicyImage#region_of_interest}
        :param gravity: The placement of the crop area relative to the specified area of interest. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: The placement of the crop area relative to the specified area of interest. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param style: Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(region_of_interest, dict):
            region_of_interest = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanRegionOfInterestCropRegionOfInterest(**region_of_interest)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1cde74ec1a5d398643f09c9fef26cce8b4b4204cdd2798e6e6e4368f76879bc9)
            check_type(argname="argument region_of_interest", value=region_of_interest, expected_type=type_hints["region_of_interest"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "region_of_interest": region_of_interest,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def region_of_interest(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanRegionOfInterestCropRegionOfInterest":
        '''region_of_interest block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest DataAkamaiImagingPolicyImage#region_of_interest}
        '''
        result = self._values.get("region_of_interest")
        assert result is not None, "Required property 'region_of_interest' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanRegionOfInterestCropRegionOfInterest", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''The placement of the crop area relative to the specified area of interest.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''The placement of the crop area relative to the specified area of interest.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanRegionOfInterestCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanRegionOfInterestCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanRegionOfInterestCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8485fed9c0114fb735484624b471f30c920eeee3b766dfa72fdfb73af53d2000)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanRegionOfInterestCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ccd02340b4457a42c791e9ab528ba96e0d9b53ad47b905d8f6a916c68c4db93)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanRegionOfInterestCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b300b6f724d59f81dfd1fc720bcc4c2b3f4c41441074d04a35f67712e56ca3f5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0bf4b1acb37bd5f9286b57929e16cda483c18d38d5fcf36082e430ae2e8dbf40)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__72e77a3b6ee74037d07cb3766537fcba4c0862e4d3814f4036d4dd9cc6b6ff99)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanRegionOfInterestCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanRegionOfInterestCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanRegionOfInterestCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cfc6578dcf1f122714901424d5799b89cc98a054bb9f3cdfd3516d6c04c43a35)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanRegionOfInterestCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanRegionOfInterestCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a6d50287199ff588cbf00c191f1de068eb47c2f0bdde79cfde610dfe4e2807e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putRegionOfInterest")
    def put_region_of_interest(self) -> None:
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanRegionOfInterestCropRegionOfInterest()

        return typing.cast(None, jsii.invoke(self, "putRegionOfInterest", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterest")
    def region_of_interest(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanRegionOfInterestCropRegionOfInterestOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanRegionOfInterestCropRegionOfInterestOutputReference", jsii.get(self, "regionOfInterest"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestInput")
    def region_of_interest_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanRegionOfInterestCropRegionOfInterest"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanRegionOfInterestCropRegionOfInterest"], jsii.get(self, "regionOfInterestInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd78fffbe609ad8c5558ca2561b013011169da38ecce327df2e224ff4e77ee1d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8879bf6a38b9cb2f1482ea95adc5dca6b9504cd1ba23e035efde6058b503c7d0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c11298c513966ac59bfe0190acf38865239ab7afb7c1de2f18fdea564ae6c1dd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a2430e0edc495735670e955114ef2f555691714b256361d2f79ad1df8c406ce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a90f000fff464f6cae64b9f907c224e6b4025a0d1fb17cccda5fde4adb483da0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a2c2c69660d5a1ac731a5d930810abc54b87e0fb1030bac12e40d78bd49b1c21)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c8f967768ad21dfd94a078967d96a65b2adac83730cb17ef3c9fc6286a022238)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5caf8507a7d038a0bb10b9f7e66e92ca807f50af694bf0d7d421406d6fda7f47)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanRegionOfInterestCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanRegionOfInterestCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanRegionOfInterestCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__33c8b6eb1a13b390f6bbc391bc4ed6e5d30c921909d3ef44fdf84f8dac5c9f86)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanRegionOfInterestCropRegionOfInterest",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanRegionOfInterestCropRegionOfInterest:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanRegionOfInterestCropRegionOfInterest(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanRegionOfInterestCropRegionOfInterestOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanRegionOfInterestCropRegionOfInterestOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__622e891d924d8c1757d00d739d910dc367f42473e80d6ccf15878a2954c6e584)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanRegionOfInterestCropRegionOfInterest]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanRegionOfInterestCropRegionOfInterest], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanRegionOfInterestCropRegionOfInterest],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__061ca97a03fca1ede3265ed63232866f8ceda20e694202bcc781742baac7328e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanRelativeCrop",
    jsii_struct_bases=[],
    name_mapping={
        "east": "east",
        "east_var": "eastVar",
        "north": "north",
        "north_var": "northVar",
        "south": "south",
        "south_var": "southVar",
        "west": "west",
        "west_var": "westVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanRelativeCrop:
    def __init__(
        self,
        *,
        east: typing.Optional[builtins.str] = None,
        east_var: typing.Optional[builtins.str] = None,
        north: typing.Optional[builtins.str] = None,
        north_var: typing.Optional[builtins.str] = None,
        south: typing.Optional[builtins.str] = None,
        south_var: typing.Optional[builtins.str] = None,
        west: typing.Optional[builtins.str] = None,
        west_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param east: The number of pixels to shrink or expand the right side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east DataAkamaiImagingPolicyImage#east}
        :param east_var: The number of pixels to shrink or expand the right side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east_var DataAkamaiImagingPolicyImage#east_var}
        :param north: The number of pixels to shrink or expand the top side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north DataAkamaiImagingPolicyImage#north}
        :param north_var: The number of pixels to shrink or expand the top side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north_var DataAkamaiImagingPolicyImage#north_var}
        :param south: The number of pixels to shrink or expand the bottom side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south DataAkamaiImagingPolicyImage#south}
        :param south_var: The number of pixels to shrink or expand the bottom side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south_var DataAkamaiImagingPolicyImage#south_var}
        :param west: The number of pixels to shrink or expand the left side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west DataAkamaiImagingPolicyImage#west}
        :param west_var: The number of pixels to shrink or expand the left side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west_var DataAkamaiImagingPolicyImage#west_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__757d9714c7e4dda3ce4511b04db29f2f8c0c949d8b94d6bf72e6dcc590541b62)
            check_type(argname="argument east", value=east, expected_type=type_hints["east"])
            check_type(argname="argument east_var", value=east_var, expected_type=type_hints["east_var"])
            check_type(argname="argument north", value=north, expected_type=type_hints["north"])
            check_type(argname="argument north_var", value=north_var, expected_type=type_hints["north_var"])
            check_type(argname="argument south", value=south, expected_type=type_hints["south"])
            check_type(argname="argument south_var", value=south_var, expected_type=type_hints["south_var"])
            check_type(argname="argument west", value=west, expected_type=type_hints["west"])
            check_type(argname="argument west_var", value=west_var, expected_type=type_hints["west_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if east is not None:
            self._values["east"] = east
        if east_var is not None:
            self._values["east_var"] = east_var
        if north is not None:
            self._values["north"] = north
        if north_var is not None:
            self._values["north_var"] = north_var
        if south is not None:
            self._values["south"] = south
        if south_var is not None:
            self._values["south_var"] = south_var
        if west is not None:
            self._values["west"] = west
        if west_var is not None:
            self._values["west_var"] = west_var

    @builtins.property
    def east(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the right side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east DataAkamaiImagingPolicyImage#east}
        '''
        result = self._values.get("east")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def east_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the right side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east_var DataAkamaiImagingPolicyImage#east_var}
        '''
        result = self._values.get("east_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def north(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the top side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north DataAkamaiImagingPolicyImage#north}
        '''
        result = self._values.get("north")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def north_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the top side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north_var DataAkamaiImagingPolicyImage#north_var}
        '''
        result = self._values.get("north_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def south(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the bottom side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south DataAkamaiImagingPolicyImage#south}
        '''
        result = self._values.get("south")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def south_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the bottom side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south_var DataAkamaiImagingPolicyImage#south_var}
        '''
        result = self._values.get("south_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def west(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the left side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west DataAkamaiImagingPolicyImage#west}
        '''
        result = self._values.get("west")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def west_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the left side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west_var DataAkamaiImagingPolicyImage#west_var}
        '''
        result = self._values.get("west_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanRelativeCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanRelativeCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanRelativeCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__74a936732a8ece21a6d1e07a6727bc428ed7fc6625af5f79f85b1ab864eff05b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanRelativeCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__728abd727a37f0032e267accbed8f10e58ea0664fc8fe33b4b811c7bbadb31db)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanRelativeCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__192cd3c9d4bd4b4276780dc2bdec1f28f371fd6fa20ece9cdfb003f5d05bf022)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b9ef3a1c1feb442d75fd65ed827a81ba781bf24665fb5c136f24d1a7861909c7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0e802ce1274737539e3b8f4ae13ff85e63a1e3083e33b4080226deb319fea7eb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanRelativeCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanRelativeCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanRelativeCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8f7e6df3dc0e158a82ff100ebb001f9bc08205485e23e52342d9687159ca616c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanRelativeCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanRelativeCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__abc2365a54c00d86af1e4083400494a976efaa362b5f2a9ea82596f439754bd5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetEast")
    def reset_east(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEast", []))

    @jsii.member(jsii_name="resetEastVar")
    def reset_east_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEastVar", []))

    @jsii.member(jsii_name="resetNorth")
    def reset_north(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNorth", []))

    @jsii.member(jsii_name="resetNorthVar")
    def reset_north_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNorthVar", []))

    @jsii.member(jsii_name="resetSouth")
    def reset_south(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSouth", []))

    @jsii.member(jsii_name="resetSouthVar")
    def reset_south_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSouthVar", []))

    @jsii.member(jsii_name="resetWest")
    def reset_west(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWest", []))

    @jsii.member(jsii_name="resetWestVar")
    def reset_west_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWestVar", []))

    @builtins.property
    @jsii.member(jsii_name="eastInput")
    def east_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "eastInput"))

    @builtins.property
    @jsii.member(jsii_name="eastVarInput")
    def east_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "eastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="northInput")
    def north_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "northInput"))

    @builtins.property
    @jsii.member(jsii_name="northVarInput")
    def north_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "northVarInput"))

    @builtins.property
    @jsii.member(jsii_name="southInput")
    def south_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "southInput"))

    @builtins.property
    @jsii.member(jsii_name="southVarInput")
    def south_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "southVarInput"))

    @builtins.property
    @jsii.member(jsii_name="westInput")
    def west_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "westInput"))

    @builtins.property
    @jsii.member(jsii_name="westVarInput")
    def west_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "westVarInput"))

    @builtins.property
    @jsii.member(jsii_name="east")
    def east(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "east"))

    @east.setter
    def east(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__94580559ae5afd9a4bbb082cc7279c89f9da93993aca0a7ea8bc204b1d104658)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "east", value)

    @builtins.property
    @jsii.member(jsii_name="eastVar")
    def east_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "eastVar"))

    @east_var.setter
    def east_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__13d4b6ab657e87494855c4c530406f903b285666c296a3ad59a116682dce6810)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "eastVar", value)

    @builtins.property
    @jsii.member(jsii_name="north")
    def north(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "north"))

    @north.setter
    def north(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__70dd6ba9355b95f5d59b00b39bf4317a146b5f81dbf0fc36036710d1f1b4bb81)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "north", value)

    @builtins.property
    @jsii.member(jsii_name="northVar")
    def north_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "northVar"))

    @north_var.setter
    def north_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4cd4be37e7367b1c35dd5f600d3b989455922cc65251e5d30fb4ce8de94148de)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "northVar", value)

    @builtins.property
    @jsii.member(jsii_name="south")
    def south(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "south"))

    @south.setter
    def south(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3726e07437da153acbb54b12db44203e78426fe3d46bb4b732516f74d7566bab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "south", value)

    @builtins.property
    @jsii.member(jsii_name="southVar")
    def south_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "southVar"))

    @south_var.setter
    def south_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__256b782259c6ce8e8f2cfa7d8e9d26e24b40dc2c6cb6c01ca2b9dc4f44b9b302)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "southVar", value)

    @builtins.property
    @jsii.member(jsii_name="west")
    def west(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "west"))

    @west.setter
    def west(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f39b854846f53b793e9671b0c6917e1512da869b66755e5b0988d10a4d49af1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "west", value)

    @builtins.property
    @jsii.member(jsii_name="westVar")
    def west_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "westVar"))

    @west_var.setter
    def west_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e01e7a6a16c31af4056398f194daaca50b14b60efc9d7e7d1bb45c812a1c8793)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "westVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanRelativeCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanRelativeCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanRelativeCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__31838d1d62182ebe69ac014a8893a736ad41239c15f34fc2f3b1b74f095d50c3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanRemoveColor",
    jsii_struct_bases=[],
    name_mapping={
        "color": "color",
        "color_var": "colorVar",
        "feather": "feather",
        "feather_var": "featherVar",
        "tolerance": "tolerance",
        "tolerance_var": "toleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanRemoveColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
        feather: typing.Optional[builtins.str] = None,
        feather_var: typing.Optional[builtins.str] = None,
        tolerance: typing.Optional[builtins.str] = None,
        tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        :param feather: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        :param feather_var: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        :param tolerance: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        :param tolerance_var: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__960c0a517a96a3dbe9b95480dc533334d57bc0052ff8d0cbbd9ec57be92d73be)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
            check_type(argname="argument feather", value=feather, expected_type=type_hints["feather"])
            check_type(argname="argument feather_var", value=feather_var, expected_type=type_hints["feather_var"])
            check_type(argname="argument tolerance", value=tolerance, expected_type=type_hints["tolerance"])
            check_type(argname="argument tolerance_var", value=tolerance_var, expected_type=type_hints["tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var
        if feather is not None:
            self._values["feather"] = feather
        if feather_var is not None:
            self._values["feather_var"] = feather_var
        if tolerance is not None:
            self._values["tolerance"] = tolerance
        if tolerance_var is not None:
            self._values["tolerance_var"] = tolerance_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        '''
        result = self._values.get("feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather_var(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        '''
        result = self._values.get("feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        '''
        result = self._values.get("tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance_var(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        result = self._values.get("tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanRemoveColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanRemoveColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanRemoveColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__56c694ae9ac171ce9787002ba0db67ab5f0d5f3d9ffe363da79b80eed497e914)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanRemoveColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e3e9b729432ce8d8cf5d5d8c78af51af1d71f557b22c9031e11f5e3d915307d9)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanRemoveColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b4d54830d697efd6c08f7292e66ce8aa6620306537b5dadba3364ac2e43dbd14)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__215476a216495e4af596ae1a2be9cda778361950de5e384737a1836eefc54ffe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a0482ec2972733bba96c787f835cfc230f780df806f30c4280e7252e275a088)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanRemoveColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanRemoveColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanRemoveColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__832f072c45901856c567ab7ab419f43adaada03f7ef3c1ea1698484e65fb25d0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanRemoveColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanRemoveColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c55a36c1adb625fba013cb0ccbdfe24cd882ca35a9c6cd5b277152fdb6cb5ff2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @jsii.member(jsii_name="resetFeather")
    def reset_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeather", []))

    @jsii.member(jsii_name="resetFeatherVar")
    def reset_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatherVar", []))

    @jsii.member(jsii_name="resetTolerance")
    def reset_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTolerance", []))

    @jsii.member(jsii_name="resetToleranceVar")
    def reset_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featherInput")
    def feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherInput"))

    @builtins.property
    @jsii.member(jsii_name="featherVarInput")
    def feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceInput")
    def tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceVarInput")
    def tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__818cbe93d7f5cc09bbbfbab63b8c21cdbf32e15b3b5ae3d8019de69d485fa404)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a602dc0a6aecc75eb2d8b7d2d6731cb92cd2384176ab4907cf7f9181ecf2c4f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="feather")
    def feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "feather"))

    @feather.setter
    def feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b18c4ff69e743e8a36810eeedbbba2d56ef02eac53410a9c4bb80a3cd0939814)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "feather", value)

    @builtins.property
    @jsii.member(jsii_name="featherVar")
    def feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featherVar"))

    @feather_var.setter
    def feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d01342aa145f31de75b2d22739f1931c86b12a364dbf984f1f2e6d1a3dd5b716)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featherVar", value)

    @builtins.property
    @jsii.member(jsii_name="tolerance")
    def tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tolerance"))

    @tolerance.setter
    def tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__48ddf4dc9ec977dc849682580ded7b2040ed47b514c98ef0160d06f17d93c3d2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tolerance", value)

    @builtins.property
    @jsii.member(jsii_name="toleranceVar")
    def tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "toleranceVar"))

    @tolerance_var.setter
    def tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d2487119ed9fa160f1849c57eaa3c85b26b3cef5a2c40b5398b622070017e660)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "toleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanRemoveColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanRemoveColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanRemoveColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7ca440a41cd3c31323ba6fa33b96d68b6768c4d29871e2928f2ebf6fd776f868)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanResize",
    jsii_struct_bases=[],
    name_mapping={
        "aspect": "aspect",
        "aspect_var": "aspectVar",
        "height": "height",
        "height_var": "heightVar",
        "type": "type",
        "type_var": "typeVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanResize:
    def __init__(
        self,
        *,
        aspect: typing.Optional[builtins.str] = None,
        aspect_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param aspect: Preserves the aspect ratio. Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect DataAkamaiImagingPolicyImage#aspect}
        :param aspect_var: Preserves the aspect ratio. Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_var DataAkamaiImagingPolicyImage#aspect_var}
        :param height: The height to resize the source image to. Must be set if height is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height to resize the source image to. Must be set if height is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param type: Sets constraints for the image resize. Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: Sets constraints for the image resize. Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        :param width: The width to resize the source image to. Must be set if width is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width to resize the source image to. Must be set if width is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__68821b0b2b8db4739c8fe0c66dcb564315531db343704bbd94c6b45d1aa03814)
            check_type(argname="argument aspect", value=aspect, expected_type=type_hints["aspect"])
            check_type(argname="argument aspect_var", value=aspect_var, expected_type=type_hints["aspect_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if aspect is not None:
            self._values["aspect"] = aspect
        if aspect_var is not None:
            self._values["aspect_var"] = aspect_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def aspect(self) -> typing.Optional[builtins.str]:
        '''Preserves the aspect ratio.

        Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect DataAkamaiImagingPolicyImage#aspect}
        '''
        result = self._values.get("aspect")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def aspect_var(self) -> typing.Optional[builtins.str]:
        '''Preserves the aspect ratio.

        Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_var DataAkamaiImagingPolicyImage#aspect_var}
        '''
        result = self._values.get("aspect_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height to resize the source image to. Must be set if height is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height to resize the source image to. Must be set if height is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''Sets constraints for the image resize.

        Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''Sets constraints for the image resize.

        Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width to resize the source image to. Must be set if width is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width to resize the source image to. Must be set if width is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanResize(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanResizeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanResizeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__92e9ba2ee752e817c28cb66e89f664559ac9626470414a99592bdf60e74db93f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanResizeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9fddd5f4fed7872584712eb2d4cecdd0099134711b4d650c45663912b4be64e8)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanResizeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e8f8bbd9bcea66fda55a39b2f3986c9cc3f6b8f5db4f2b07ff1159eb369f2c77)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d6412d4a193a337046ddbbc6114dbd91ce5a49623b00adcd6e2123233bfa802)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eb9a7a229a4bd47e123ba04ec17aaf5ceb0344da094ea74daac4d8f8ed44c8e2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanResize]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanResize]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanResize]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cf787eadc93a66c241b4448ac0cd33420825dfc124946cce4e51b46ec343614f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanResizeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanResizeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7f251b2ae04eb5caf11475db11d048154f81602dfaafd6fde1d0ca092bed0858)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAspect")
    def reset_aspect(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspect", []))

    @jsii.member(jsii_name="resetAspectVar")
    def reset_aspect_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspectVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="aspectInput")
    def aspect_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "aspectInput"))

    @builtins.property
    @jsii.member(jsii_name="aspectVarInput")
    def aspect_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "aspectVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="aspect")
    def aspect(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "aspect"))

    @aspect.setter
    def aspect(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f287d2ef9de95d0995ddd3122737e69723d7091985a15833cbe24c025ad8978f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "aspect", value)

    @builtins.property
    @jsii.member(jsii_name="aspectVar")
    def aspect_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "aspectVar"))

    @aspect_var.setter
    def aspect_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1358d34c51c9a46ce613166acc4c8e331436d792e20e1a1f3f7fabc958677e86)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "aspectVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f6dcb556a3399493bbeb5017785a4bb76a23b0abf180f1b405d81f4ba953987)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a94b99ae39e4a7f61bd20daea07e242bb2cb7296279608e636da554660ecbf06)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b7cc7301d711540fbb506ec3264503ca1c04541801e6ae674fea06e23c52f3af)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__776565b546344be6a90f17c77168d1ebad7e18673511298713bf79677ec909fa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__30b57fc52738792c6e7236231af679499a99439ad52bf64854b5c7293eca2222)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ba579b78ba41dd33a7e965660691a1c5b26b0692db41cdca2acdb27df3fae425)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanResize]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanResize]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanResize]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a8dee1155e9b639d00887c2e99230a6a7f2a73bd9b6075a80a79e9ee5a2dba47)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanRotate",
    jsii_struct_bases=[],
    name_mapping={"degrees": "degrees", "degrees_var": "degreesVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanRotate:
    def __init__(
        self,
        *,
        degrees: typing.Optional[builtins.str] = None,
        degrees_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param degrees: The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees DataAkamaiImagingPolicyImage#degrees}
        :param degrees_var: The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees_var DataAkamaiImagingPolicyImage#degrees_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8bdd74c99ff46c47376a5db1646adcbffa4ebcba7ee25d8bc7b9c76c089bc43b)
            check_type(argname="argument degrees", value=degrees, expected_type=type_hints["degrees"])
            check_type(argname="argument degrees_var", value=degrees_var, expected_type=type_hints["degrees_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if degrees is not None:
            self._values["degrees"] = degrees
        if degrees_var is not None:
            self._values["degrees_var"] = degrees_var

    @builtins.property
    def degrees(self) -> typing.Optional[builtins.str]:
        '''The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees DataAkamaiImagingPolicyImage#degrees}
        '''
        result = self._values.get("degrees")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def degrees_var(self) -> typing.Optional[builtins.str]:
        '''The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees_var DataAkamaiImagingPolicyImage#degrees_var}
        '''
        result = self._values.get("degrees_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanRotate(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanRotateList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanRotateList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8696dc6b99cf707aed6047202661f92d67d28c5c891b9c8b419864cb1a767c03)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanRotateOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__801e51fd79a56f6622216c51f137cee8b03e364e722f32049fe83c0f96fa3fe6)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanRotateOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ff5c79d47a0b54519efa07faa11b962e8f651d68fabf3625b2380c14cedb076)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__74f1327ed9a49baa68bb1d30d1cad713ce71ff57d79b17dbea0505b34979a3a7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d48490dc0e36d87ea505cd5a12dc0a5d6c21fcdd647d550eafdac2ed4a6c5b1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanRotate]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanRotate]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanRotate]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a554a28b6d0e4b20237f680ffde798cafa9773ad54083339e02ddc81d9762aaf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanRotateOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanRotateOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__67e910f66efb719f4590368794115aa6fc309a77ee7a5ab2f6c7d80c9151f196)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetDegrees")
    def reset_degrees(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDegrees", []))

    @jsii.member(jsii_name="resetDegreesVar")
    def reset_degrees_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDegreesVar", []))

    @builtins.property
    @jsii.member(jsii_name="degreesInput")
    def degrees_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "degreesInput"))

    @builtins.property
    @jsii.member(jsii_name="degreesVarInput")
    def degrees_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "degreesVarInput"))

    @builtins.property
    @jsii.member(jsii_name="degrees")
    def degrees(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "degrees"))

    @degrees.setter
    def degrees(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__23b10b10e921d8795bbe65c338277d557a1dd73a2180e26fa4d725c9ee4c41d4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "degrees", value)

    @builtins.property
    @jsii.member(jsii_name="degreesVar")
    def degrees_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "degreesVar"))

    @degrees_var.setter
    def degrees_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__81ba2984267a776e65045b7717fc4b6c4515eb4f5dd2807d9ce8eee39aee87f5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "degreesVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanRotate]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanRotate]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanRotate]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9dcdf88161749b1f53734e00caaa97220fb96e77492888541fcba1f9ed13f1b8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanScale",
    jsii_struct_bases=[],
    name_mapping={
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanScale:
    def __init__(
        self,
        *,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param height: Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged. Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged. Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__163fc4fc76181135b0fa7ffb4bed0df3ae534ccdc55eae099828f13f43c33125)
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size.

        Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size.

        Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged.

        Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged.

        Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanScale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanScaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanScaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a318e87c6ba86f2763741662b5633b90f4e41ed626ffd609e8e203256fa0fa65)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanScaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__866c5950edda7f5433f6694bac66e5e70d2e6b3e9dc1002921a7bd00f5a190ab)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanScaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__49d8c757858ef6f8244972e8d7cc9a287051d88fb24fcada7ab6bf9b17f2dfa0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e078c4380fd1a02954b7e9282a37008e73a9a3eb3e61d8519ed9c8201c811fb0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f76eaa2a8d6b788cfcd1949111b1101b86319ded9403bbbd2c8688e90b3fcb2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanScale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanScale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanScale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__facaa311a9e4449656525ce019c6336e4dbae3996a535a2767411ae6f485d010)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanScaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanScaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ec405c701be738f72effe32503e537ef35cd4fb48f97de513812e623060dc28a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2240420df20dcc2caf20e289b95c7a7bbd4b31beafbe2381699121059a31e291)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f333e33c09ff27bd62b4b7081616e7ef7687c83a2b8e5b6bd653548f235e7cd6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bca087952ecb7c157444cb9371dda08965262773d048b9bad64216080f2a59f8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__69a7f58f0da20dfb450f06212c75b89c2399a43398a7a7ecd842ee6f3a58c478)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanScale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanScale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanScale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5951fc2442644d671ecee0251fbb2bf6f192b1c79fb8e2034b5b56236ebfb4bf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanShear",
    jsii_struct_bases=[],
    name_mapping={
        "x_shear": "xShear",
        "x_shear_var": "xShearVar",
        "y_shear": "yShear",
        "y_shear_var": "yShearVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanShear:
    def __init__(
        self,
        *,
        x_shear: typing.Optional[builtins.str] = None,
        x_shear_var: typing.Optional[builtins.str] = None,
        y_shear: typing.Optional[builtins.str] = None,
        y_shear_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param x_shear: The amount to shear along the x-axis, measured in multiples of the image's width. Must be set if yShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear DataAkamaiImagingPolicyImage#x_shear}
        :param x_shear_var: The amount to shear along the x-axis, measured in multiples of the image's width. Must be set if yShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear_var DataAkamaiImagingPolicyImage#x_shear_var}
        :param y_shear: The amount to shear along the y-axis, measured in multiples of the image's height. Must be set if xShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear DataAkamaiImagingPolicyImage#y_shear}
        :param y_shear_var: The amount to shear along the y-axis, measured in multiples of the image's height. Must be set if xShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear_var DataAkamaiImagingPolicyImage#y_shear_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a1a66aedd839c75749c0252135ec0770e4b236b9e5546e935b6c2e6e50ffbc4)
            check_type(argname="argument x_shear", value=x_shear, expected_type=type_hints["x_shear"])
            check_type(argname="argument x_shear_var", value=x_shear_var, expected_type=type_hints["x_shear_var"])
            check_type(argname="argument y_shear", value=y_shear, expected_type=type_hints["y_shear"])
            check_type(argname="argument y_shear_var", value=y_shear_var, expected_type=type_hints["y_shear_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if x_shear is not None:
            self._values["x_shear"] = x_shear
        if x_shear_var is not None:
            self._values["x_shear_var"] = x_shear_var
        if y_shear is not None:
            self._values["y_shear"] = y_shear
        if y_shear_var is not None:
            self._values["y_shear_var"] = y_shear_var

    @builtins.property
    def x_shear(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the x-axis, measured in multiples of the image's width.

        Must be set if yShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear DataAkamaiImagingPolicyImage#x_shear}
        '''
        result = self._values.get("x_shear")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_shear_var(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the x-axis, measured in multiples of the image's width.

        Must be set if yShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear_var DataAkamaiImagingPolicyImage#x_shear_var}
        '''
        result = self._values.get("x_shear_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_shear(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the y-axis, measured in multiples of the image's height.

        Must be set if xShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear DataAkamaiImagingPolicyImage#y_shear}
        '''
        result = self._values.get("y_shear")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_shear_var(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the y-axis, measured in multiples of the image's height.

        Must be set if xShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear_var DataAkamaiImagingPolicyImage#y_shear_var}
        '''
        result = self._values.get("y_shear_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanShear(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanShearList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanShearList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7e42b6cbb4d541b5e21e29f79d0e4ab78caa1b51239b8a6b4d009147d5a19c9a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanShearOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7f610a6de9b6951bcdd682ddb69283f77627ebf08e1cc4c563112998f6e590db)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanShearOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bf8a36ac5a900d2002f791a31bacd48c41009b9f4801d18a65c3ee8db5ac9d76)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__abbba7a3579e0930e276aab45408a848c155d2dcca4a7304f827fafa7d306281)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6fb8e83c196027d05ab6dc7c55ef66cefe84da1d0bc53af8d209f97daf11f505)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanShear]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanShear]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanShear]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8da91a928ca199890493d0939ea31125b96c980fb9cce248fdbf40bf18c7c71f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanShearOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanShearOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6a70084a913a11d87b084b18e2420f0a7c74f06db895779bf5cfb624b1d99ed7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetXShear")
    def reset_x_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXShear", []))

    @jsii.member(jsii_name="resetXShearVar")
    def reset_x_shear_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXShearVar", []))

    @jsii.member(jsii_name="resetYShear")
    def reset_y_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYShear", []))

    @jsii.member(jsii_name="resetYShearVar")
    def reset_y_shear_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYShearVar", []))

    @builtins.property
    @jsii.member(jsii_name="xShearInput")
    def x_shear_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xShearInput"))

    @builtins.property
    @jsii.member(jsii_name="xShearVarInput")
    def x_shear_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xShearVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yShearInput")
    def y_shear_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yShearInput"))

    @builtins.property
    @jsii.member(jsii_name="yShearVarInput")
    def y_shear_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yShearVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xShear")
    def x_shear(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xShear"))

    @x_shear.setter
    def x_shear(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c049c2519bc6ada06efd07bd712a61c3d3175dfc5dd02fd35444a6dbeb5c926d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xShear", value)

    @builtins.property
    @jsii.member(jsii_name="xShearVar")
    def x_shear_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xShearVar"))

    @x_shear_var.setter
    def x_shear_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5937da89f07f7ed9784fa82014ac23d535ea0ccb1d9af14a9b9149eb4893b635)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xShearVar", value)

    @builtins.property
    @jsii.member(jsii_name="yShear")
    def y_shear(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yShear"))

    @y_shear.setter
    def y_shear(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__77d9e6e51bb99d327480e17cc3fe77fe41e388acaedfa9af66be046fe80bc77c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yShear", value)

    @builtins.property
    @jsii.member(jsii_name="yShearVar")
    def y_shear_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yShearVar"))

    @y_shear_var.setter
    def y_shear_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f81097c60d0a9fd5cf73a1a58b90fb71939d3b8a53c90b8db8420fb71b7f4d45)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yShearVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanShear]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanShear]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanShear]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ef228e408498c8184c3bb1487baea0ca3647699411e67dbb078f76bac8d0478)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanTrim",
    jsii_struct_bases=[],
    name_mapping={
        "fuzz": "fuzz",
        "fuzz_var": "fuzzVar",
        "padding": "padding",
        "padding_var": "paddingVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanTrim:
    def __init__(
        self,
        *,
        fuzz: typing.Optional[builtins.str] = None,
        fuzz_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fuzz: The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz DataAkamaiImagingPolicyImage#fuzz}
        :param fuzz_var: The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz_var DataAkamaiImagingPolicyImage#fuzz_var}
        :param padding: The amount of padding in pixels to add to the trimmed image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: The amount of padding in pixels to add to the trimmed image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0e75f67ec2dded60e38f20fb3b01af4e69ccae3aaff47f8624baf9dffc198db0)
            check_type(argname="argument fuzz", value=fuzz, expected_type=type_hints["fuzz"])
            check_type(argname="argument fuzz_var", value=fuzz_var, expected_type=type_hints["fuzz_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fuzz is not None:
            self._values["fuzz"] = fuzz
        if fuzz_var is not None:
            self._values["fuzz_var"] = fuzz_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var

    @builtins.property
    def fuzz(self) -> typing.Optional[builtins.str]:
        '''The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz DataAkamaiImagingPolicyImage#fuzz}
        '''
        result = self._values.get("fuzz")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fuzz_var(self) -> typing.Optional[builtins.str]:
        '''The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz_var DataAkamaiImagingPolicyImage#fuzz_var}
        '''
        result = self._values.get("fuzz_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''The amount of padding in pixels to add to the trimmed image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''The amount of padding in pixels to add to the trimmed image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanTrim(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanTrimList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanTrimList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc548a60ef2f375ae037b69e8032ed713af304e44dfa57aa8c33efa673e910d6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanTrimOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__54305efc6ed070877544a62abe53c36478e957fc648b515b9782cc1a9dcba39a)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanTrimOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__71f74b395805ab0576852893cac4740d90b4d89f343571a94169f57046488fe5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__927a022e19fd6f6aa6d487fd72f35acee91490adf464d70cc21e9f2f804a2055)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7dd9752d40c92a1ff7e93557683679683018d513277fc31bb0722def27dc6576)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanTrim]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanTrim]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanTrim]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4cd94720af1550f3df85710e4c1163bc65c071262797628382bd5587b8a6c294)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanTrimOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanTrimOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ec53c1ebc6bb08bf6c9b9e523da590c83b11ae1e44e468740958b845f5bc645)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetFuzz")
    def reset_fuzz(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFuzz", []))

    @jsii.member(jsii_name="resetFuzzVar")
    def reset_fuzz_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFuzzVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @builtins.property
    @jsii.member(jsii_name="fuzzInput")
    def fuzz_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fuzzInput"))

    @builtins.property
    @jsii.member(jsii_name="fuzzVarInput")
    def fuzz_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fuzzVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="fuzz")
    def fuzz(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fuzz"))

    @fuzz.setter
    def fuzz(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb34a0f09643439ff741e3bb2c94cda7646ae82683bc7c77d4c98675a57b0d6b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fuzz", value)

    @builtins.property
    @jsii.member(jsii_name="fuzzVar")
    def fuzz_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fuzzVar"))

    @fuzz_var.setter
    def fuzz_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd5dac62282a45e99cec7794bd5eaf290a2425feb2c165eb9c7b9c79f6e9dcf6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fuzzVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a44acf24f6f5b2b461cc8614738929584d2ba14548a5560b0da542d3552b3714)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__412febe6f6edf6232152f4b59636eb9d497a55b4775809a6a9b96f87d4b1cf59)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanTrim]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanTrim]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanTrim]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2b3c6b70d28c5e47f75eccc60e3f683ce6c28e3f96033dd7bd6e706352f0608d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanUnsharpMask",
    jsii_struct_bases=[],
    name_mapping={
        "gain": "gain",
        "gain_var": "gainVar",
        "sigma": "sigma",
        "sigma_var": "sigmaVar",
        "threshold": "threshold",
        "threshold_var": "thresholdVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanUnsharpMask:
    def __init__(
        self,
        *,
        gain: typing.Optional[builtins.str] = None,
        gain_var: typing.Optional[builtins.str] = None,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
        threshold: typing.Optional[builtins.str] = None,
        threshold_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param gain: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        :param gain_var: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        :param sigma: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        :param threshold: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        :param threshold_var: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5b0d0aa4160a70b6062754999f9b9794fd4e513a08969aed2ce858fb49aa1599)
            check_type(argname="argument gain", value=gain, expected_type=type_hints["gain"])
            check_type(argname="argument gain_var", value=gain_var, expected_type=type_hints["gain_var"])
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
            check_type(argname="argument threshold", value=threshold, expected_type=type_hints["threshold"])
            check_type(argname="argument threshold_var", value=threshold_var, expected_type=type_hints["threshold_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if gain is not None:
            self._values["gain"] = gain
        if gain_var is not None:
            self._values["gain_var"] = gain_var
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var
        if threshold is not None:
            self._values["threshold"] = threshold
        if threshold_var is not None:
            self._values["threshold_var"] = threshold_var

    @builtins.property
    def gain(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        '''
        result = self._values.get("gain")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gain_var(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        '''
        result = self._values.get("gain_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        '''
        result = self._values.get("threshold")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold_var(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        result = self._values.get("threshold_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanUnsharpMask(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanUnsharpMaskList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanUnsharpMaskList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df2528c065148766fe25fabc7681e06958592b3279d760edff63cad2718fbfea)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanUnsharpMaskOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0496dbae86c805b560a99ceedad0f777426647116faab341559bcf020605b994)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanUnsharpMaskOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0f1cd6564d7916173b3fc680e4ea63edf2908298722185a80bb5f9a6f66d7f1a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e56cd6b4d8d47583bb25aa528b19f92d08f16983d8c41d8c67f453e8ecc9e8c5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4df266d8e41f9d72282c1a52bd26fd186587f995929cb5ead5751949f6083e09)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanUnsharpMask]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanUnsharpMask]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanUnsharpMask]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__338511c8adca0d20e5372f332b99d7ca4054291fe230f09c8a10a2b63eace97e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanUnsharpMaskOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanUnsharpMaskOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__77485c15414243e89b862f5d0c97ce4a4e53df982f42ae3cf638135a57ae4249)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetGain")
    def reset_gain(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGain", []))

    @jsii.member(jsii_name="resetGainVar")
    def reset_gain_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGainVar", []))

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @jsii.member(jsii_name="resetThreshold")
    def reset_threshold(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThreshold", []))

    @jsii.member(jsii_name="resetThresholdVar")
    def reset_threshold_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThresholdVar", []))

    @builtins.property
    @jsii.member(jsii_name="gainInput")
    def gain_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainInput"))

    @builtins.property
    @jsii.member(jsii_name="gainVarInput")
    def gain_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdInput")
    def threshold_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdVarInput")
    def threshold_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gain")
    def gain(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gain"))

    @gain.setter
    def gain(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f931f70c9b42996c6cac7892b57291ef7eef787dfb41e8e1c19f4191faffdba3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gain", value)

    @builtins.property
    @jsii.member(jsii_name="gainVar")
    def gain_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gainVar"))

    @gain_var.setter
    def gain_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f0d7213633f223f2ab1ea303b6622a9316774f2f57ff99db327a23d6d4d67a3f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gainVar", value)

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fde2969df6032bf92a0860a98068951a572e07bb71781bb8f9dfd21f83b0ddeb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__926ae219469200ba36625891dd654287a4f40932b7a98db6188e9442625d0f53)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="threshold")
    def threshold(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "threshold"))

    @threshold.setter
    def threshold(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__edc6f6df6708d616943ab3dc5a292375afb4870cf0688172ac4d4de5363b0b86)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "threshold", value)

    @builtins.property
    @jsii.member(jsii_name="thresholdVar")
    def threshold_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "thresholdVar"))

    @threshold_var.setter
    def threshold_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__384700da1a406300c62130275a9eb818eee9f81dbd4e07a408542ed17ba6ec57)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "thresholdVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanUnsharpMask]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanUnsharpMask]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanUnsharpMask]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6af3070bcd1468863d6db5ef6f4853965a41016f6433f871789e28a0d2f391a9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4db8a563a4172c391f6fbcaa19e550bc674a285a371e4e743be1c129e2c859ce)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__03dedc09893fdf81f6a05f4ca0d59ce739aacf0f018b6745118e3d43db47ade0)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a35e3a7e78830ffc9b2dc4b43118b745308808824b23d8b0f2760732f7345b31)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8e00c94ee31303ad528cb5ac9890ec68cda0560bab0b4a74f527389f6a20addd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__03f8aac04776855b150cae0d80d92b52929dee875c3b586bffb3296d849980f0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimension]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimension]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__688caf5e011330d36c8bda606748adbcf56389e3c15cc908c4c8c063c05f372c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1c698e0cea5c49fbcabc961469f7c6fc6d322de6621b51ecf5fa50fbc666f7af)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putDefault")
    def put_default(
        self,
        *,
        append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultAppend, typing.Dict[builtins.str, typing.Any]]]]] = None,
        aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultAspectCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
        crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultFaceCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultFeatureCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultFitAndFill, typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
        im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultImQuery, typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
        region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultRegionOfInterestCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultRelativeCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
        resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultResize, typing.Dict[builtins.str, typing.Any]]]]] = None,
        rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultRotate, typing.Dict[builtins.str, typing.Any]]]]] = None,
        scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultScale, typing.Dict[builtins.str, typing.Any]]]]] = None,
        shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultShear, typing.Dict[builtins.str, typing.Any]]]]] = None,
        trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultTrim, typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param append: append block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        :param aspect_crop: aspect_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param crop: crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        :param face_crop: face_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        :param feature_crop: feature_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        :param fit_and_fill: fit_and_fill block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param im_query: im_query block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param region_of_interest_crop: region_of_interest_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        :param relative_crop: relative_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param resize: resize block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        :param rotate: rotate block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        :param scale: scale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param shear: shear block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        :param trim: trim block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefault(
            append=append,
            aspect_crop=aspect_crop,
            background_color=background_color,
            blur=blur,
            chroma_key=chroma_key,
            composite=composite,
            compound=compound,
            contrast=contrast,
            crop=crop,
            face_crop=face_crop,
            feature_crop=feature_crop,
            fit_and_fill=fit_and_fill,
            goop=goop,
            grayscale=grayscale,
            hsl=hsl,
            hsv=hsv,
            if_dimension=if_dimension,
            if_orientation=if_orientation,
            im_query=im_query,
            max_colors=max_colors,
            mirror=mirror,
            mono_hue=mono_hue,
            opacity=opacity,
            region_of_interest_crop=region_of_interest_crop,
            relative_crop=relative_crop,
            remove_color=remove_color,
            resize=resize,
            rotate=rotate,
            scale=scale,
            shear=shear,
            trim=trim,
            unsharp_mask=unsharp_mask,
        )

        return typing.cast(None, jsii.invoke(self, "putDefault", [value]))

    @jsii.member(jsii_name="putEqual")
    def put_equal(
        self,
        *,
        append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualAppend, typing.Dict[builtins.str, typing.Any]]]]] = None,
        aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualAspectCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
        crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualFaceCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualFeatureCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualFitAndFill, typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
        im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualImQuery, typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
        region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualRegionOfInterestCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualRelativeCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
        resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualResize, typing.Dict[builtins.str, typing.Any]]]]] = None,
        rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualRotate, typing.Dict[builtins.str, typing.Any]]]]] = None,
        scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualScale, typing.Dict[builtins.str, typing.Any]]]]] = None,
        shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualShear, typing.Dict[builtins.str, typing.Any]]]]] = None,
        trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualTrim, typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param append: append block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        :param aspect_crop: aspect_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param crop: crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        :param face_crop: face_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        :param feature_crop: feature_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        :param fit_and_fill: fit_and_fill block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param im_query: im_query block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param region_of_interest_crop: region_of_interest_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        :param relative_crop: relative_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param resize: resize block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        :param rotate: rotate block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        :param scale: scale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param shear: shear block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        :param trim: trim block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqual(
            append=append,
            aspect_crop=aspect_crop,
            background_color=background_color,
            blur=blur,
            chroma_key=chroma_key,
            composite=composite,
            compound=compound,
            contrast=contrast,
            crop=crop,
            face_crop=face_crop,
            feature_crop=feature_crop,
            fit_and_fill=fit_and_fill,
            goop=goop,
            grayscale=grayscale,
            hsl=hsl,
            hsv=hsv,
            if_dimension=if_dimension,
            if_orientation=if_orientation,
            im_query=im_query,
            max_colors=max_colors,
            mirror=mirror,
            mono_hue=mono_hue,
            opacity=opacity,
            region_of_interest_crop=region_of_interest_crop,
            relative_crop=relative_crop,
            remove_color=remove_color,
            resize=resize,
            rotate=rotate,
            scale=scale,
            shear=shear,
            trim=trim,
            unsharp_mask=unsharp_mask,
        )

        return typing.cast(None, jsii.invoke(self, "putEqual", [value]))

    @jsii.member(jsii_name="putGreaterThan")
    def put_greater_than(
        self,
        *,
        append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanAppend, typing.Dict[builtins.str, typing.Any]]]]] = None,
        aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanAspectCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
        crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanFaceCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanFeatureCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanFitAndFill, typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
        im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanImQuery, typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
        region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanRegionOfInterestCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanRelativeCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
        resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanResize, typing.Dict[builtins.str, typing.Any]]]]] = None,
        rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanRotate, typing.Dict[builtins.str, typing.Any]]]]] = None,
        scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanScale, typing.Dict[builtins.str, typing.Any]]]]] = None,
        shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanShear, typing.Dict[builtins.str, typing.Any]]]]] = None,
        trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanTrim, typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param append: append block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        :param aspect_crop: aspect_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param crop: crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        :param face_crop: face_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        :param feature_crop: feature_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        :param fit_and_fill: fit_and_fill block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param im_query: im_query block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param region_of_interest_crop: region_of_interest_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        :param relative_crop: relative_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param resize: resize block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        :param rotate: rotate block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        :param scale: scale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param shear: shear block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        :param trim: trim block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThan(
            append=append,
            aspect_crop=aspect_crop,
            background_color=background_color,
            blur=blur,
            chroma_key=chroma_key,
            composite=composite,
            compound=compound,
            contrast=contrast,
            crop=crop,
            face_crop=face_crop,
            feature_crop=feature_crop,
            fit_and_fill=fit_and_fill,
            goop=goop,
            grayscale=grayscale,
            hsl=hsl,
            hsv=hsv,
            if_dimension=if_dimension,
            if_orientation=if_orientation,
            im_query=im_query,
            max_colors=max_colors,
            mirror=mirror,
            mono_hue=mono_hue,
            opacity=opacity,
            region_of_interest_crop=region_of_interest_crop,
            relative_crop=relative_crop,
            remove_color=remove_color,
            resize=resize,
            rotate=rotate,
            scale=scale,
            shear=shear,
            trim=trim,
            unsharp_mask=unsharp_mask,
        )

        return typing.cast(None, jsii.invoke(self, "putGreaterThan", [value]))

    @jsii.member(jsii_name="putLessThan")
    def put_less_than(
        self,
        *,
        append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanAppend, typing.Dict[builtins.str, typing.Any]]]]] = None,
        aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanAspectCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
        blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
        chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
        composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
        compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
        contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
        crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanFaceCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanFeatureCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanFitAndFill, typing.Dict[builtins.str, typing.Any]]]]] = None,
        goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
        hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
        if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
        im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanImQuery, typing.Dict[builtins.str, typing.Any]]]]] = None,
        max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
        mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
        mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
        opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
        region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanRegionOfInterestCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanRelativeCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
        remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
        resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanResize, typing.Dict[builtins.str, typing.Any]]]]] = None,
        rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanRotate, typing.Dict[builtins.str, typing.Any]]]]] = None,
        scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanScale, typing.Dict[builtins.str, typing.Any]]]]] = None,
        shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanShear, typing.Dict[builtins.str, typing.Any]]]]] = None,
        trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanTrim, typing.Dict[builtins.str, typing.Any]]]]] = None,
        unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param append: append block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
        :param aspect_crop: aspect_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
        :param background_color: background_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
        :param blur: blur block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
        :param chroma_key: chroma_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
        :param composite: composite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
        :param compound: compound block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
        :param contrast: contrast block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
        :param crop: crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
        :param face_crop: face_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
        :param feature_crop: feature_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
        :param fit_and_fill: fit_and_fill block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
        :param goop: goop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
        :param grayscale: grayscale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
        :param hsl: hsl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
        :param hsv: hsv block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
        :param if_dimension: if_dimension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
        :param if_orientation: if_orientation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
        :param im_query: im_query block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
        :param max_colors: max_colors block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
        :param mirror: mirror block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
        :param mono_hue: mono_hue block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
        :param opacity: opacity block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param region_of_interest_crop: region_of_interest_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
        :param relative_crop: relative_crop block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
        :param remove_color: remove_color block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
        :param resize: resize block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
        :param rotate: rotate block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
        :param scale: scale block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
        :param shear: shear block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
        :param trim: trim block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
        :param unsharp_mask: unsharp_mask block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
        '''
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThan(
            append=append,
            aspect_crop=aspect_crop,
            background_color=background_color,
            blur=blur,
            chroma_key=chroma_key,
            composite=composite,
            compound=compound,
            contrast=contrast,
            crop=crop,
            face_crop=face_crop,
            feature_crop=feature_crop,
            fit_and_fill=fit_and_fill,
            goop=goop,
            grayscale=grayscale,
            hsl=hsl,
            hsv=hsv,
            if_dimension=if_dimension,
            if_orientation=if_orientation,
            im_query=im_query,
            max_colors=max_colors,
            mirror=mirror,
            mono_hue=mono_hue,
            opacity=opacity,
            region_of_interest_crop=region_of_interest_crop,
            relative_crop=relative_crop,
            remove_color=remove_color,
            resize=resize,
            rotate=rotate,
            scale=scale,
            shear=shear,
            trim=trim,
            unsharp_mask=unsharp_mask,
        )

        return typing.cast(None, jsii.invoke(self, "putLessThan", [value]))

    @jsii.member(jsii_name="resetDefault")
    def reset_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefault", []))

    @jsii.member(jsii_name="resetDimension")
    def reset_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimension", []))

    @jsii.member(jsii_name="resetDimensionVar")
    def reset_dimension_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDimensionVar", []))

    @jsii.member(jsii_name="resetEqual")
    def reset_equal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEqual", []))

    @jsii.member(jsii_name="resetGreaterThan")
    def reset_greater_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGreaterThan", []))

    @jsii.member(jsii_name="resetLessThan")
    def reset_less_than(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLessThan", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @jsii.member(jsii_name="resetValueVar")
    def reset_value_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueVar", []))

    @builtins.property
    @jsii.member(jsii_name="default")
    def default(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultOutputReference, jsii.get(self, "default"))

    @builtins.property
    @jsii.member(jsii_name="equal")
    def equal(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualOutputReference, jsii.get(self, "equal"))

    @builtins.property
    @jsii.member(jsii_name="greaterThan")
    def greater_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanOutputReference, jsii.get(self, "greaterThan"))

    @builtins.property
    @jsii.member(jsii_name="lessThan")
    def less_than(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanOutputReference, jsii.get(self, "lessThan"))

    @builtins.property
    @jsii.member(jsii_name="defaultInput")
    def default_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefault]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefault], jsii.get(self, "defaultInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionInput")
    def dimension_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="dimensionVarInput")
    def dimension_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dimensionVarInput"))

    @builtins.property
    @jsii.member(jsii_name="equalInput")
    def equal_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqual]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqual], jsii.get(self, "equalInput"))

    @builtins.property
    @jsii.member(jsii_name="greaterThanInput")
    def greater_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThan], jsii.get(self, "greaterThanInput"))

    @builtins.property
    @jsii.member(jsii_name="lessThanInput")
    def less_than_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThan]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThan], jsii.get(self, "lessThanInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="valueVarInput")
    def value_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="dimension")
    def dimension(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimension"))

    @dimension.setter
    def dimension(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e8af88b312ab4adaba8d6e1f3d9aa7bca3aaef66a4dcf472df3c95d902d23ac5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimension", value)

    @builtins.property
    @jsii.member(jsii_name="dimensionVar")
    def dimension_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dimensionVar"))

    @dimension_var.setter
    def dimension_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8b2be676fb2b8bb021f592fde90f714250462c3fdddf16aa8030b7b94ce0945e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dimensionVar", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5e885be887a7ebfe05c204d169345fb74b165689c9c9eaaa558d1349832bb810)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="valueVar")
    def value_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueVar"))

    @value_var.setter
    def value_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0357c908e9b309afaed095d656b95ebc73f8613fc303876c19c27faecd85cd99)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimension]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimension]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimension]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d81a6a2fb39340e2907d7302a40e3fd1a4fb7f7ec4ce747a4321255092aaea1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareImQuery",
    jsii_struct_bases=[],
    name_mapping={
        "allowed_transformations": "allowedTransformations",
        "query_var": "queryVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareImQuery:
    def __init__(
        self,
        *,
        allowed_transformations: typing.Sequence[builtins.str],
        query_var: builtins.str,
    ) -> None:
        '''
        :param allowed_transformations: Specifies the transformations that can be applied using the query string parameter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allowed_transformations DataAkamaiImagingPolicyImage#allowed_transformations}
        :param query_var: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#query_var DataAkamaiImagingPolicyImage#query_var}.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9e7532b86e8df769c783fc2d1edcc2505e9dc68ca46471a4d64f8d4ceb5bc458)
            check_type(argname="argument allowed_transformations", value=allowed_transformations, expected_type=type_hints["allowed_transformations"])
            check_type(argname="argument query_var", value=query_var, expected_type=type_hints["query_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "allowed_transformations": allowed_transformations,
            "query_var": query_var,
        }

    @builtins.property
    def allowed_transformations(self) -> typing.List[builtins.str]:
        '''Specifies the transformations that can be applied using the query string parameter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allowed_transformations DataAkamaiImagingPolicyImage#allowed_transformations}
        '''
        result = self._values.get("allowed_transformations")
        assert result is not None, "Required property 'allowed_transformations' is missing"
        return typing.cast(typing.List[builtins.str], result)

    @builtins.property
    def query_var(self) -> builtins.str:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#query_var DataAkamaiImagingPolicyImage#query_var}.'''
        result = self._values.get("query_var")
        assert result is not None, "Required property 'query_var' is missing"
        return typing.cast(builtins.str, result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareImQuery(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareImQueryList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareImQueryList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__19d4ecd915c1d63d16224d59ce420744ad5e8f6f28ff4589191d11f74871a96f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareImQueryOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3b426061b4355ad82eb9498b053431a6217c67b22bb129a3131667f4e030e604)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareImQueryOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7887676c410ecb9bac1a6df3614c604705a448b072a36e609485630ae810073a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e15e8e961b08f47a759260479a6e1fd6727eacd50c9f7fe0fe0a8b43382af4cc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a07392add6d456f789774a6c84f94fe058bcbf089536f65ac8370f3b8e39bec3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareImQuery]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareImQuery]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareImQuery]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__12ec70b58def03bed0fb6da7a3afedd305f1a90f42ca3cc373d93b3866e6a3ae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareImQueryOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareImQueryOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__28f8bea830c771a4f593b4d799d59d457e48f04fe4641ca0feab8613db8edcd5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @builtins.property
    @jsii.member(jsii_name="allowedTransformationsInput")
    def allowed_transformations_input(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "allowedTransformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="queryVarInput")
    def query_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "queryVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowedTransformations")
    def allowed_transformations(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "allowedTransformations"))

    @allowed_transformations.setter
    def allowed_transformations(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df6d8dd7eee688a2ace7ff06a302a528815b9c44d4cfa9f81c15ab9e13f8f7ad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowedTransformations", value)

    @builtins.property
    @jsii.member(jsii_name="queryVar")
    def query_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "queryVar"))

    @query_var.setter
    def query_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c8b5f5142b9f3e0b8f5fcfc4a183d1e2e5bc2ab1ed27c22c621e624c00494413)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "queryVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareImQuery]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareImQuery]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareImQuery]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__31c06bbcbafb622fadf8fce3bcb8887bc93a37b6dbcd0ed9f61cd749f86a03a3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareMaxColors",
    jsii_struct_bases=[],
    name_mapping={"colors": "colors", "colors_var": "colorsVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareMaxColors:
    def __init__(
        self,
        *,
        colors: typing.Optional[builtins.str] = None,
        colors_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param colors: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        :param colors_var: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d83964ec11737cb224b261599a69fc6efc48241090c4dd39f1c69c9878102071)
            check_type(argname="argument colors", value=colors, expected_type=type_hints["colors"])
            check_type(argname="argument colors_var", value=colors_var, expected_type=type_hints["colors_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if colors is not None:
            self._values["colors"] = colors
        if colors_var is not None:
            self._values["colors_var"] = colors_var

    @builtins.property
    def colors(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        '''
        result = self._values.get("colors")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def colors_var(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        result = self._values.get("colors_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareMaxColors(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareMaxColorsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareMaxColorsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1e25fdacfa9c8fb9ff90d3d91f4836d79aaef5395ce61d456378f39c4639b5d2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareMaxColorsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__92683a0934d87f4518d837f53111b3d333f2f91606dd114ea7196164c86ca1c6)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareMaxColorsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e068c2f0e9da279f916d2da46debb2fff1cfb7136bbdf5f4edbd64a08401e21d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ec77d9d33474e7c09a29624646f08f685fa2b40e96b34767a906e0a11e159fb3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__89d59014bde96437fb85a02ae0c57865ca2a1b67c03090341e0f509dae66cdf9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareMaxColors]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareMaxColors]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ee716276994f30d8cd5d811419bd5ad890c18a9ab91510ce5e23d98d166f2582)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareMaxColorsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareMaxColorsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9f7b9c05a3349806285cdbaef60433456f6f41cfafe74c828e1ddcdd5c0c3057)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColors")
    def reset_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColors", []))

    @jsii.member(jsii_name="resetColorsVar")
    def reset_colors_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorsVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorsInput")
    def colors_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsInput"))

    @builtins.property
    @jsii.member(jsii_name="colorsVarInput")
    def colors_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsVarInput"))

    @builtins.property
    @jsii.member(jsii_name="colors")
    def colors(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colors"))

    @colors.setter
    def colors(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__27b784c5f25eaee8544244c096c1ede8f21f84613827a40661124aed836db5de)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colors", value)

    @builtins.property
    @jsii.member(jsii_name="colorsVar")
    def colors_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorsVar"))

    @colors_var.setter
    def colors_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__68a75b36746b56665a7c88481a3c32143367f690078f4a6bd650a1b229eca341)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorsVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareMaxColors]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareMaxColors]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareMaxColors]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__761244ec9b66bd851c42e1844e8089e82b0616599852f1ce8954d901ff13e918)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareMirror",
    jsii_struct_bases=[],
    name_mapping={
        "horizontal": "horizontal",
        "horizontal_var": "horizontalVar",
        "vertical": "vertical",
        "vertical_var": "verticalVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareMirror:
    def __init__(
        self,
        *,
        horizontal: typing.Optional[builtins.str] = None,
        horizontal_var: typing.Optional[builtins.str] = None,
        vertical: typing.Optional[builtins.str] = None,
        vertical_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param horizontal: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        :param horizontal_var: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        :param vertical: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        :param vertical_var: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__311fdcb29a30c20a37c9fe1b1e2df1fdde2897b9e4f1cfa9e7ff8e05bc44751b)
            check_type(argname="argument horizontal", value=horizontal, expected_type=type_hints["horizontal"])
            check_type(argname="argument horizontal_var", value=horizontal_var, expected_type=type_hints["horizontal_var"])
            check_type(argname="argument vertical", value=vertical, expected_type=type_hints["vertical"])
            check_type(argname="argument vertical_var", value=vertical_var, expected_type=type_hints["vertical_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if horizontal is not None:
            self._values["horizontal"] = horizontal
        if horizontal_var is not None:
            self._values["horizontal_var"] = horizontal_var
        if vertical is not None:
            self._values["vertical"] = vertical
        if vertical_var is not None:
            self._values["vertical_var"] = vertical_var

    @builtins.property
    def horizontal(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        '''
        result = self._values.get("horizontal")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def horizontal_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        '''
        result = self._values.get("horizontal_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        '''
        result = self._values.get("vertical")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        result = self._values.get("vertical_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareMirror(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareMirrorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareMirrorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c0a0b664e623c2c1e7a08b8a391c9c973f10cc2fe67de7706a6434189baf2f31)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareMirrorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__01c700a682116c6cb7179e189a9fc3ab84f70e000d4f64935386e2d633eacaaa)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareMirrorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2623b41165b5f3885894c70b44f904225f83f4946dc36b211e28fe971e332767)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ace98817fef3e6bdca6e1424f50a78af0ec52ebd0798702b6116b59e80b6c464)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bdc6bb44fae5b96683691f55a2b5ed5dc7c2b68a83c4733f0cbec8b15be09750)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareMirror]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareMirror]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__95e7da7be36d30f6c92e9eb0c5b926b428f99a3c561f12eb96ee6e0bf8578920)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareMirrorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareMirrorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a96268d06d60a8fc3ebf8e4278a1256f03229fe70c9cf2a8103a6a553d9d751)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHorizontal")
    def reset_horizontal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontal", []))

    @jsii.member(jsii_name="resetHorizontalVar")
    def reset_horizontal_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontalVar", []))

    @jsii.member(jsii_name="resetVertical")
    def reset_vertical(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVertical", []))

    @jsii.member(jsii_name="resetVerticalVar")
    def reset_vertical_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVerticalVar", []))

    @builtins.property
    @jsii.member(jsii_name="horizontalInput")
    def horizontal_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontalVarInput")
    def horizontal_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalInput")
    def vertical_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalVarInput")
    def vertical_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontal")
    def horizontal(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontal"))

    @horizontal.setter
    def horizontal(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e03be98990ae777e8261b1c841766e96145fd01d38d6e0c1373d7e3d74acbb5a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontal", value)

    @builtins.property
    @jsii.member(jsii_name="horizontalVar")
    def horizontal_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontalVar"))

    @horizontal_var.setter
    def horizontal_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ef6a92237600c79afc5d6f94f8464c035acc6ee6aa669353dc86900c3923c392)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontalVar", value)

    @builtins.property
    @jsii.member(jsii_name="vertical")
    def vertical(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "vertical"))

    @vertical.setter
    def vertical(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ad12273d1880a54bcc5c5684054fd807539eb8a8e4e31fd5608b8d187a9ba22)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "vertical", value)

    @builtins.property
    @jsii.member(jsii_name="verticalVar")
    def vertical_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "verticalVar"))

    @vertical_var.setter
    def vertical_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5387ac79bdaee0604fb966a4a26ec436ff24ad21f203aafe85337465cf057ee3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "verticalVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareMirror]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareMirror]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareMirror]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__20f450d845b8f501fc9c93ede76c0f0cbe54a9ef8c7497695aa4f35e8d1b5210)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareMonoHue",
    jsii_struct_bases=[],
    name_mapping={"hue": "hue", "hue_var": "hueVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareMonoHue:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__876c688f50e7cef7dae63b7dada4442ff580d1f0bd58788e8a36580207d8f4b1)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareMonoHue(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareMonoHueList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareMonoHueList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8f5c5db035c20db6f10a407cf0bc3558303184bc48a03714b965a5db82af463d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareMonoHueOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ae8f9b165025f414034093a03783d39888c8ea0e5179e171bbd8e833b395a4c2)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareMonoHueOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bddbb5d7fdafe10f9c5f843efff8812ff1abad49fe5fd39cc0bed477a9d21e9d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fc70f9c9c0f21618be105dbe394baf6bbd442b45ccbeb4fdebdc3ae030af7a7c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4c324234a2fa8822c99a505b99e67ad9bb242459e579a1ca05e975d661b1ab4a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareMonoHue]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareMonoHue]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__470af8cdca476d014a0e6b99994e6e237c098776137d667a125a2b2a530b3917)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareMonoHueOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareMonoHueOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c6e190fe3e250ce56b4fc7f9f0a001d31b6e1c7cca1c210bfd33e9fce206c62c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a6b2d236b458a900177d46f1405723f443d2c2f009b1b7bcf10f3c444e8ad69b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5a89b3c25059bf63352b6a742bef0b31ed64d8324f29bc4508469c3a1be6fb30)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareMonoHue]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareMonoHue]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareMonoHue]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__11ae239699789e33ac2f9a62c4b0120080556c1a36b16dec2737ece78c69db0a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareOpacity",
    jsii_struct_bases=[],
    name_mapping={"opacity": "opacity", "opacity_var": "opacityVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareOpacity:
    def __init__(
        self,
        *,
        opacity: typing.Optional[builtins.str] = None,
        opacity_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param opacity: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param opacity_var: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dad494b64663350f371d602bb3d7a9d44b0155a63e57a6116d2c3a07d9fad251)
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument opacity_var", value=opacity_var, expected_type=type_hints["opacity_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if opacity is not None:
            self._values["opacity"] = opacity
        if opacity_var is not None:
            self._values["opacity_var"] = opacity_var

    @builtins.property
    def opacity(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def opacity_var(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        result = self._values.get("opacity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareOpacity(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareOpacityList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareOpacityList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a0ec63b32546cbec0944afff4e607a3a7a7106a121a3e98fc9e17fe01fa9c41)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareOpacityOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab0b8abed3effe6f12c354f655a4efce53224c63153a4a01228ba354006f4c45)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareOpacityOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2100e496b8ac107471fe9a83847a2337f99d21f3706edcab7e4a0f68ee1fa775)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8fe81691fe69cbeb863526cbe4328557f4099ccde72ed74ee372608bfe4eae4b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__17208095698450a44f1a2ef20a11256cae50613333b92dced41da411b51279d3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareOpacity]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareOpacity]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac0b7b8dda66011313a5e4ac8305ed9709c4754cb36bd7b0a69cc4d1118bd1ee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareOpacityOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareOpacityOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b9754110fd550f8e72ed87b4502eb738aeef470f774d7974d3695f293d75d5cb)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetOpacityVar")
    def reset_opacity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacityVar", []))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityVarInput")
    def opacity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacity"))

    @opacity.setter
    def opacity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4bff7f6ba865ec9e8f38422e2bf54b2eaf865cf74021332b54aa7d689d1acd56)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacity", value)

    @builtins.property
    @jsii.member(jsii_name="opacityVar")
    def opacity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacityVar"))

    @opacity_var.setter
    def opacity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0d7a9ae501402369ce4d7cbea39f40d22134acbad642b92c1422bb9715757417)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacityVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareOpacity]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareOpacity]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareOpacity]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8f8f2c92d35b19a4888f33772229de370ee1d0936091cc73627376ebdd0b7958)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__175feb8804bdc128ec3650a2d3e82147f536c87682d201f24409e80c812c3c82)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putAppend")
    def put_append(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppend, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb8564e939d1ecab59a72344da5e0963af0f24489cdf91c5a91f12fb7627bec1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putAppend", [value]))

    @jsii.member(jsii_name="putAspectCrop")
    def put_aspect_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAspectCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6104bc9f84dbaf0dc71efc7d67f6345bf4a0820b443373527d1405ddba26a987)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putAspectCrop", [value]))

    @jsii.member(jsii_name="putBackgroundColor")
    def put_background_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f50a848a5b1b0e6e4c818e1ecfd4415eba6c0d27b4c1c593d28eef408c8e903e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBackgroundColor", [value]))

    @jsii.member(jsii_name="putBlur")
    def put_blur(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareBlur, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__abb1670b6a65547ddbf3257646b2006aabf92eff51cd0a1ae063db16cd0ea2f3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBlur", [value]))

    @jsii.member(jsii_name="putChromaKey")
    def put_chroma_key(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareChromaKey, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f11b7ee558a72719532374a0d6f16df8ec866cf735c868e0c2fb29f2eb427dbc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putChromaKey", [value]))

    @jsii.member(jsii_name="putComposite")
    def put_composite(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareComposite, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a4f409fc70c1a1ce1fe40a1f5d529deb5fdcb0bdc6c99c3daafecc9f37a73ff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putComposite", [value]))

    @jsii.member(jsii_name="putCompound")
    def put_compound(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompound, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__04f8f8628507ecd791def9a8bf6eccc83c80c86fff11dbbb03c8b23575d32dd1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCompound", [value]))

    @jsii.member(jsii_name="putContrast")
    def put_contrast(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareContrast, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dddf4b56b5a3455e178f44cdfeb7f27c7cd7b2ec9bbac16c15daf267fe78ac95)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putContrast", [value]))

    @jsii.member(jsii_name="putCrop")
    def put_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1c40025ce864c5b6d098f4bf235cbbfd766d909e9ca7bb0b1ae8c93383729fa6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCrop", [value]))

    @jsii.member(jsii_name="putFaceCrop")
    def put_face_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFaceCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__075e133fdbde3c824da18ec527b54b762652aa5e710040b8326279d59c965f74)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFaceCrop", [value]))

    @jsii.member(jsii_name="putFeatureCrop")
    def put_feature_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFeatureCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d503b14da308ff8e1ebbec33058a439a0aa6cc54c1272889822f081b0cc3b06f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFeatureCrop", [value]))

    @jsii.member(jsii_name="putFitAndFill")
    def put_fit_and_fill(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFill, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6a6fd674d37496fb7e13925c7edd8fffd9c34281ffaacccb41059c54b383a5e7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFitAndFill", [value]))

    @jsii.member(jsii_name="putGoop")
    def put_goop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareGoop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__80b4bdbaed1c0148878257749d89a9065c10d761e917aed565f75a31598c73ac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGoop", [value]))

    @jsii.member(jsii_name="putGrayscale")
    def put_grayscale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareGrayscale, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c7a4f13772134f9ddd4fea10e4f37d35d3402047106252bc26f3e69d1425895c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGrayscale", [value]))

    @jsii.member(jsii_name="putHsl")
    def put_hsl(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareHsl, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__def1438a56c87ccc4b900ffc637464bb33332ff564e90b1ab5ba6e5239d4a002)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsl", [value]))

    @jsii.member(jsii_name="putHsv")
    def put_hsv(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareHsv, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7e721ade666de49282544e2ba9634004ccef54560780e13065be5570582e5f7e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsv", [value]))

    @jsii.member(jsii_name="putIfDimension")
    def put_if_dimension(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimension, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__41a8243adc99991898e7332bb402d5834a3744caf1a642f8dfa1bd087d25e6b6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfDimension", [value]))

    @jsii.member(jsii_name="putIfOrientation")
    def put_if_orientation(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2b94dc53e545f039a9acce665c2b488a6dffd79ee8ed53c310237d572ec8a1ab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfOrientation", [value]))

    @jsii.member(jsii_name="putImQuery")
    def put_im_query(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareImQuery, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__045ff03dba607408c08831f1dca77f1c4d6949e71dab3240495f326362c89d44)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putImQuery", [value]))

    @jsii.member(jsii_name="putMaxColors")
    def put_max_colors(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareMaxColors, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7b16ccf429226acb860e0e4d1b30396056700c8c395fc8a488ef742b7a561ee9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMaxColors", [value]))

    @jsii.member(jsii_name="putMirror")
    def put_mirror(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareMirror, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4fa9a6ce59409413bed19b50b1dd0e4ba70d983f049529ddf3f3d5254b2f274e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMirror", [value]))

    @jsii.member(jsii_name="putMonoHue")
    def put_mono_hue(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareMonoHue, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a54f5a603b6950c83fb48511284fc0dee154a8861bf6bc9e5a4ede1e10cec7c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMonoHue", [value]))

    @jsii.member(jsii_name="putOpacity")
    def put_opacity(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareOpacity, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bfdebf566aa6fa9c4bda9c42f1f90bebb5e6659457730651dcfcfbb113ad91bc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putOpacity", [value]))

    @jsii.member(jsii_name="putRegionOfInterestCrop")
    def put_region_of_interest_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCrop", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__013b20e11d7a91a72ffee7d4207af441a0e117831263d6b7a60c997dfc5aae2a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRegionOfInterestCrop", [value]))

    @jsii.member(jsii_name="putRelativeCrop")
    def put_relative_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRelativeCrop", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a07de685c568f291f44f64459cb85c9b00ca9036cafd658a1c67fb64ab276fe1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRelativeCrop", [value]))

    @jsii.member(jsii_name="putRemoveColor")
    def put_remove_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRemoveColor", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0e2c4dfb3293ff40111976fd268d2db964c32a4a422e7b60403238018dc69030)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRemoveColor", [value]))

    @jsii.member(jsii_name="putResize")
    def put_resize(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareResize", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d5deee080bddf8a7d34b8969c08ad09a2dc7a1fc27790505e4576e4b261530ec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putResize", [value]))

    @jsii.member(jsii_name="putRotate")
    def put_rotate(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRotate", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d75a6b413fda17b52ab1e45f8aee0972ee12a8cd3f747661a509d0af83443ddb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRotate", [value]))

    @jsii.member(jsii_name="putScale")
    def put_scale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareScale", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4d1764908a6e7a40860a4c170a65822f91195f8b4fe163b0219acec80df10b3d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putScale", [value]))

    @jsii.member(jsii_name="putShear")
    def put_shear(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareShear", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__989290586ef6d4fdcca162c4826230bd08a3c493281a16d360296305fc3289b4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putShear", [value]))

    @jsii.member(jsii_name="putTrim")
    def put_trim(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareTrim", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f7e9ac70fb4ccc416a06bee44b4430bc6b63fdf83da800ee8f2085a97acf9ca3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTrim", [value]))

    @jsii.member(jsii_name="putUnsharpMask")
    def put_unsharp_mask(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareUnsharpMask", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5fbe90e0ab40fa53e932ccd70db85ee0184a0490340c051ee13be8817be3c175)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putUnsharpMask", [value]))

    @jsii.member(jsii_name="resetAppend")
    def reset_append(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAppend", []))

    @jsii.member(jsii_name="resetAspectCrop")
    def reset_aspect_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspectCrop", []))

    @jsii.member(jsii_name="resetBackgroundColor")
    def reset_background_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBackgroundColor", []))

    @jsii.member(jsii_name="resetBlur")
    def reset_blur(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBlur", []))

    @jsii.member(jsii_name="resetChromaKey")
    def reset_chroma_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChromaKey", []))

    @jsii.member(jsii_name="resetComposite")
    def reset_composite(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetComposite", []))

    @jsii.member(jsii_name="resetCompound")
    def reset_compound(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCompound", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetCrop")
    def reset_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCrop", []))

    @jsii.member(jsii_name="resetFaceCrop")
    def reset_face_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFaceCrop", []))

    @jsii.member(jsii_name="resetFeatureCrop")
    def reset_feature_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureCrop", []))

    @jsii.member(jsii_name="resetFitAndFill")
    def reset_fit_and_fill(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFitAndFill", []))

    @jsii.member(jsii_name="resetGoop")
    def reset_goop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGoop", []))

    @jsii.member(jsii_name="resetGrayscale")
    def reset_grayscale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGrayscale", []))

    @jsii.member(jsii_name="resetHsl")
    def reset_hsl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsl", []))

    @jsii.member(jsii_name="resetHsv")
    def reset_hsv(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsv", []))

    @jsii.member(jsii_name="resetIfDimension")
    def reset_if_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfDimension", []))

    @jsii.member(jsii_name="resetIfOrientation")
    def reset_if_orientation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfOrientation", []))

    @jsii.member(jsii_name="resetImQuery")
    def reset_im_query(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetImQuery", []))

    @jsii.member(jsii_name="resetMaxColors")
    def reset_max_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxColors", []))

    @jsii.member(jsii_name="resetMirror")
    def reset_mirror(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMirror", []))

    @jsii.member(jsii_name="resetMonoHue")
    def reset_mono_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonoHue", []))

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetRegionOfInterestCrop")
    def reset_region_of_interest_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRegionOfInterestCrop", []))

    @jsii.member(jsii_name="resetRelativeCrop")
    def reset_relative_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRelativeCrop", []))

    @jsii.member(jsii_name="resetRemoveColor")
    def reset_remove_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRemoveColor", []))

    @jsii.member(jsii_name="resetResize")
    def reset_resize(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetResize", []))

    @jsii.member(jsii_name="resetRotate")
    def reset_rotate(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRotate", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetShear")
    def reset_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetShear", []))

    @jsii.member(jsii_name="resetTrim")
    def reset_trim(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTrim", []))

    @jsii.member(jsii_name="resetUnsharpMask")
    def reset_unsharp_mask(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUnsharpMask", []))

    @builtins.property
    @jsii.member(jsii_name="append")
    def append(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendList, jsii.get(self, "append"))

    @builtins.property
    @jsii.member(jsii_name="aspectCrop")
    def aspect_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAspectCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAspectCropList, jsii.get(self, "aspectCrop"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColor")
    def background_color(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareBackgroundColorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareBackgroundColorList, jsii.get(self, "backgroundColor"))

    @builtins.property
    @jsii.member(jsii_name="blur")
    def blur(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareBlurList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareBlurList, jsii.get(self, "blur"))

    @builtins.property
    @jsii.member(jsii_name="chromaKey")
    def chroma_key(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareChromaKeyList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareChromaKeyList, jsii.get(self, "chromaKey"))

    @builtins.property
    @jsii.member(jsii_name="composite")
    def composite(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeList, jsii.get(self, "composite"))

    @builtins.property
    @jsii.member(jsii_name="compound")
    def compound(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompoundList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompoundList, jsii.get(self, "compound"))

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareContrastList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareContrastList, jsii.get(self, "contrast"))

    @builtins.property
    @jsii.member(jsii_name="crop")
    def crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCropList, jsii.get(self, "crop"))

    @builtins.property
    @jsii.member(jsii_name="faceCrop")
    def face_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFaceCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFaceCropList, jsii.get(self, "faceCrop"))

    @builtins.property
    @jsii.member(jsii_name="featureCrop")
    def feature_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFeatureCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFeatureCropList, jsii.get(self, "featureCrop"))

    @builtins.property
    @jsii.member(jsii_name="fitAndFill")
    def fit_and_fill(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillList, jsii.get(self, "fitAndFill"))

    @builtins.property
    @jsii.member(jsii_name="goop")
    def goop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareGoopList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareGoopList, jsii.get(self, "goop"))

    @builtins.property
    @jsii.member(jsii_name="grayscale")
    def grayscale(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareGrayscaleList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareGrayscaleList, jsii.get(self, "grayscale"))

    @builtins.property
    @jsii.member(jsii_name="hsl")
    def hsl(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareHslList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareHslList, jsii.get(self, "hsl"))

    @builtins.property
    @jsii.member(jsii_name="hsv")
    def hsv(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareHsvList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareHsvList, jsii.get(self, "hsv"))

    @builtins.property
    @jsii.member(jsii_name="ifDimension")
    def if_dimension(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionList, jsii.get(self, "ifDimension"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientation")
    def if_orientation(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationList, jsii.get(self, "ifOrientation"))

    @builtins.property
    @jsii.member(jsii_name="imQuery")
    def im_query(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareImQueryList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareImQueryList, jsii.get(self, "imQuery"))

    @builtins.property
    @jsii.member(jsii_name="maxColors")
    def max_colors(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareMaxColorsList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareMaxColorsList, jsii.get(self, "maxColors"))

    @builtins.property
    @jsii.member(jsii_name="mirror")
    def mirror(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareMirrorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareMirrorList, jsii.get(self, "mirror"))

    @builtins.property
    @jsii.member(jsii_name="monoHue")
    def mono_hue(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareMonoHueList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareMonoHueList, jsii.get(self, "monoHue"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareOpacityList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareOpacityList, jsii.get(self, "opacity"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestCrop")
    def region_of_interest_crop(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropList", jsii.get(self, "regionOfInterestCrop"))

    @builtins.property
    @jsii.member(jsii_name="relativeCrop")
    def relative_crop(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRelativeCropList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRelativeCropList", jsii.get(self, "relativeCrop"))

    @builtins.property
    @jsii.member(jsii_name="removeColor")
    def remove_color(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRemoveColorList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRemoveColorList", jsii.get(self, "removeColor"))

    @builtins.property
    @jsii.member(jsii_name="resize")
    def resize(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareResizeList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareResizeList", jsii.get(self, "resize"))

    @builtins.property
    @jsii.member(jsii_name="rotate")
    def rotate(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRotateList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRotateList", jsii.get(self, "rotate"))

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareScaleList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareScaleList", jsii.get(self, "scale"))

    @builtins.property
    @jsii.member(jsii_name="shear")
    def shear(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareShearList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareShearList", jsii.get(self, "shear"))

    @builtins.property
    @jsii.member(jsii_name="trim")
    def trim(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareTrimList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareTrimList", jsii.get(self, "trim"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMask")
    def unsharp_mask(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareUnsharpMaskList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareUnsharpMaskList", jsii.get(self, "unsharpMask"))

    @builtins.property
    @jsii.member(jsii_name="appendInput")
    def append_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppend]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppend]]], jsii.get(self, "appendInput"))

    @builtins.property
    @jsii.member(jsii_name="aspectCropInput")
    def aspect_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAspectCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAspectCrop]]], jsii.get(self, "aspectCropInput"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColorInput")
    def background_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareBackgroundColor]]], jsii.get(self, "backgroundColorInput"))

    @builtins.property
    @jsii.member(jsii_name="blurInput")
    def blur_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareBlur]]], jsii.get(self, "blurInput"))

    @builtins.property
    @jsii.member(jsii_name="chromaKeyInput")
    def chroma_key_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareChromaKey]]], jsii.get(self, "chromaKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="compositeInput")
    def composite_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareComposite]]], jsii.get(self, "compositeInput"))

    @builtins.property
    @jsii.member(jsii_name="compoundInput")
    def compound_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompound]]], jsii.get(self, "compoundInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareContrast]]], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="cropInput")
    def crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCrop]]], jsii.get(self, "cropInput"))

    @builtins.property
    @jsii.member(jsii_name="faceCropInput")
    def face_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFaceCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFaceCrop]]], jsii.get(self, "faceCropInput"))

    @builtins.property
    @jsii.member(jsii_name="featureCropInput")
    def feature_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFeatureCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFeatureCrop]]], jsii.get(self, "featureCropInput"))

    @builtins.property
    @jsii.member(jsii_name="fitAndFillInput")
    def fit_and_fill_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFill]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFill]]], jsii.get(self, "fitAndFillInput"))

    @builtins.property
    @jsii.member(jsii_name="goopInput")
    def goop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareGoop]]], jsii.get(self, "goopInput"))

    @builtins.property
    @jsii.member(jsii_name="grayscaleInput")
    def grayscale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareGrayscale]]], jsii.get(self, "grayscaleInput"))

    @builtins.property
    @jsii.member(jsii_name="hslInput")
    def hsl_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareHsl]]], jsii.get(self, "hslInput"))

    @builtins.property
    @jsii.member(jsii_name="hsvInput")
    def hsv_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareHsv]]], jsii.get(self, "hsvInput"))

    @builtins.property
    @jsii.member(jsii_name="ifDimensionInput")
    def if_dimension_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimension]]], jsii.get(self, "ifDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientationInput")
    def if_orientation_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientation]]], jsii.get(self, "ifOrientationInput"))

    @builtins.property
    @jsii.member(jsii_name="imQueryInput")
    def im_query_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareImQuery]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareImQuery]]], jsii.get(self, "imQueryInput"))

    @builtins.property
    @jsii.member(jsii_name="maxColorsInput")
    def max_colors_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareMaxColors]]], jsii.get(self, "maxColorsInput"))

    @builtins.property
    @jsii.member(jsii_name="mirrorInput")
    def mirror_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareMirror]]], jsii.get(self, "mirrorInput"))

    @builtins.property
    @jsii.member(jsii_name="monoHueInput")
    def mono_hue_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareMonoHue]]], jsii.get(self, "monoHueInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareOpacity]]], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestCropInput")
    def region_of_interest_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCrop"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCrop"]]], jsii.get(self, "regionOfInterestCropInput"))

    @builtins.property
    @jsii.member(jsii_name="relativeCropInput")
    def relative_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRelativeCrop"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRelativeCrop"]]], jsii.get(self, "relativeCropInput"))

    @builtins.property
    @jsii.member(jsii_name="removeColorInput")
    def remove_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRemoveColor"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRemoveColor"]]], jsii.get(self, "removeColorInput"))

    @builtins.property
    @jsii.member(jsii_name="resizeInput")
    def resize_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareResize"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareResize"]]], jsii.get(self, "resizeInput"))

    @builtins.property
    @jsii.member(jsii_name="rotateInput")
    def rotate_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRotate"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRotate"]]], jsii.get(self, "rotateInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareScale"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareScale"]]], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="shearInput")
    def shear_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareShear"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareShear"]]], jsii.get(self, "shearInput"))

    @builtins.property
    @jsii.member(jsii_name="trimInput")
    def trim_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareTrim"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareTrim"]]], jsii.get(self, "trimInput"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMaskInput")
    def unsharp_mask_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareUnsharpMask"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareUnsharpMask"]]], jsii.get(self, "unsharpMaskInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquare]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquare], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquare],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dccb10ed354cc9f6699099897fc5f4639d994d3930b70af4f95c4b73369eb9fb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCrop",
    jsii_struct_bases=[],
    name_mapping={
        "region_of_interest": "regionOfInterest",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCrop:
    def __init__(
        self,
        *,
        region_of_interest: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterest", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param region_of_interest: region_of_interest block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest DataAkamaiImagingPolicyImage#region_of_interest}
        :param gravity: The placement of the crop area relative to the specified area of interest. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: The placement of the crop area relative to the specified area of interest. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param style: Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(region_of_interest, dict):
            region_of_interest = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterest(**region_of_interest)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b9b270fd38dff49ab7c007117d50c03b358b41f37f1c1f40e3615d2a66d4fcb7)
            check_type(argname="argument region_of_interest", value=region_of_interest, expected_type=type_hints["region_of_interest"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "region_of_interest": region_of_interest,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def region_of_interest(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterest":
        '''region_of_interest block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest DataAkamaiImagingPolicyImage#region_of_interest}
        '''
        result = self._values.get("region_of_interest")
        assert result is not None, "Required property 'region_of_interest' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterest", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''The placement of the crop area relative to the specified area of interest.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''The placement of the crop area relative to the specified area of interest.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__45aab9005d41a41af86ce5a8edbfc789aa481ff12740f3d4160c88dbf801c6d6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__46bb24ecfc967a0ce71a2fe0c37bb74c372e3bd40d387bb05d4f093e93bb23ad)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3837c923875a60564fedfcb4a9873b56e02e2aa6fa5fdb3322f662d1f2ad26db)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a8b37d686d7350656926de5e1d3a3fa82f8834b0a484a1766fe22d6b13347659)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ef557e12b352a4b115b3f0fee3b160818433159e1c75dcbebe4e1404f22789d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__25f0489d31e4e9e5061ad8573178afd12e6006d658ad09ecc4d1976ef12be396)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cbedb7be616a4db0a960d25a4b5b8caa1eb1a075caaba01a7ef3ce89dddb4cf0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putRegionOfInterest")
    def put_region_of_interest(
        self,
        *,
        circle_shape: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestCircleShape", typing.Dict[builtins.str, typing.Any]]]]] = None,
        point_shape: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestPointShape", typing.Dict[builtins.str, typing.Any]]]]] = None,
        polygon_shape: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestPolygonShape", typing.Dict[builtins.str, typing.Any]]]]] = None,
        rectangle_shape: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestRectangleShape", typing.Dict[builtins.str, typing.Any]]]]] = None,
        union_shape: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestUnionShape", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param circle_shape: circle_shape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#circle_shape DataAkamaiImagingPolicyImage#circle_shape}
        :param point_shape: point_shape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#point_shape DataAkamaiImagingPolicyImage#point_shape}
        :param polygon_shape: polygon_shape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#polygon_shape DataAkamaiImagingPolicyImage#polygon_shape}
        :param rectangle_shape: rectangle_shape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rectangle_shape DataAkamaiImagingPolicyImage#rectangle_shape}
        :param union_shape: union_shape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#union_shape DataAkamaiImagingPolicyImage#union_shape}
        '''
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterest(
            circle_shape=circle_shape,
            point_shape=point_shape,
            polygon_shape=polygon_shape,
            rectangle_shape=rectangle_shape,
            union_shape=union_shape,
        )

        return typing.cast(None, jsii.invoke(self, "putRegionOfInterest", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterest")
    def region_of_interest(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestOutputReference", jsii.get(self, "regionOfInterest"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestInput")
    def region_of_interest_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterest"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterest"], jsii.get(self, "regionOfInterestInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d169248dbcae75ff59076dac5e9af95b4e0b4b56dc78598c9dd44d3d031151b9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0d9fb34e0c5cd8abc0e8f858fc6b640cae6a468b2c81991a518b22f87625b47a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5eef1449faec3dc0a91b7553ec25f9cfbee055198c205c2005876499da004aaa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6a31c45648258f9c260f22aa3555ecc7b29d304f3b8174d106c26da12e749eeb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e754ceb9959ba3a36c44fa89e2d90681bb13f6aabb1b41bb9b5c0a120a11051e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a4aa4b439eb199b1de6c5795ac17aec1e0792432f86b642b8bcd7dbdf72db6b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__03db6c3158b0d0743b4b096376c891478ab88c8b17e4c994b3ec6e41948f11f3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d070d89b12806d65e2dd231bd232dc3f352c0853e5b710c3c7168d4754a9d87)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cdf0cd6484b7110b108fc03b5e88124f1de49b304d29cd2203794597e9c3f0b1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterest",
    jsii_struct_bases=[],
    name_mapping={
        "circle_shape": "circleShape",
        "point_shape": "pointShape",
        "polygon_shape": "polygonShape",
        "rectangle_shape": "rectangleShape",
        "union_shape": "unionShape",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterest:
    def __init__(
        self,
        *,
        circle_shape: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestCircleShape", typing.Dict[builtins.str, typing.Any]]]]] = None,
        point_shape: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestPointShape", typing.Dict[builtins.str, typing.Any]]]]] = None,
        polygon_shape: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestPolygonShape", typing.Dict[builtins.str, typing.Any]]]]] = None,
        rectangle_shape: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestRectangleShape", typing.Dict[builtins.str, typing.Any]]]]] = None,
        union_shape: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestUnionShape", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param circle_shape: circle_shape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#circle_shape DataAkamaiImagingPolicyImage#circle_shape}
        :param point_shape: point_shape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#point_shape DataAkamaiImagingPolicyImage#point_shape}
        :param polygon_shape: polygon_shape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#polygon_shape DataAkamaiImagingPolicyImage#polygon_shape}
        :param rectangle_shape: rectangle_shape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rectangle_shape DataAkamaiImagingPolicyImage#rectangle_shape}
        :param union_shape: union_shape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#union_shape DataAkamaiImagingPolicyImage#union_shape}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__44d7c4026ae1f48a0a1104111d6c3a2127ef9253c84338aa2b5885f71e4e62ce)
            check_type(argname="argument circle_shape", value=circle_shape, expected_type=type_hints["circle_shape"])
            check_type(argname="argument point_shape", value=point_shape, expected_type=type_hints["point_shape"])
            check_type(argname="argument polygon_shape", value=polygon_shape, expected_type=type_hints["polygon_shape"])
            check_type(argname="argument rectangle_shape", value=rectangle_shape, expected_type=type_hints["rectangle_shape"])
            check_type(argname="argument union_shape", value=union_shape, expected_type=type_hints["union_shape"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if circle_shape is not None:
            self._values["circle_shape"] = circle_shape
        if point_shape is not None:
            self._values["point_shape"] = point_shape
        if polygon_shape is not None:
            self._values["polygon_shape"] = polygon_shape
        if rectangle_shape is not None:
            self._values["rectangle_shape"] = rectangle_shape
        if union_shape is not None:
            self._values["union_shape"] = union_shape

    @builtins.property
    def circle_shape(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestCircleShape"]]]:
        '''circle_shape block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#circle_shape DataAkamaiImagingPolicyImage#circle_shape}
        '''
        result = self._values.get("circle_shape")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestCircleShape"]]], result)

    @builtins.property
    def point_shape(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestPointShape"]]]:
        '''point_shape block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#point_shape DataAkamaiImagingPolicyImage#point_shape}
        '''
        result = self._values.get("point_shape")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestPointShape"]]], result)

    @builtins.property
    def polygon_shape(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestPolygonShape"]]]:
        '''polygon_shape block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#polygon_shape DataAkamaiImagingPolicyImage#polygon_shape}
        '''
        result = self._values.get("polygon_shape")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestPolygonShape"]]], result)

    @builtins.property
    def rectangle_shape(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestRectangleShape"]]]:
        '''rectangle_shape block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rectangle_shape DataAkamaiImagingPolicyImage#rectangle_shape}
        '''
        result = self._values.get("rectangle_shape")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestRectangleShape"]]], result)

    @builtins.property
    def union_shape(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestUnionShape"]]]:
        '''union_shape block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#union_shape DataAkamaiImagingPolicyImage#union_shape}
        '''
        result = self._values.get("union_shape")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestUnionShape"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterest(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestCircleShape",
    jsii_struct_bases=[],
    name_mapping={"center": "center", "radius": "radius", "radius_var": "radiusVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestCircleShape:
    def __init__(
        self,
        *,
        center: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestCircleShapeCenter", typing.Dict[builtins.str, typing.Any]],
        radius: typing.Optional[builtins.str] = None,
        radius_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param center: center block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#center DataAkamaiImagingPolicyImage#center}
        :param radius: The radius of the circle measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#radius DataAkamaiImagingPolicyImage#radius}
        :param radius_var: The radius of the circle measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#radius_var DataAkamaiImagingPolicyImage#radius_var}
        '''
        if isinstance(center, dict):
            center = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestCircleShapeCenter(**center)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7599ed7ac8cbd12e6c6ab837cc201c520982c56d181842673ffe65fb997c7436)
            check_type(argname="argument center", value=center, expected_type=type_hints["center"])
            check_type(argname="argument radius", value=radius, expected_type=type_hints["radius"])
            check_type(argname="argument radius_var", value=radius_var, expected_type=type_hints["radius_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "center": center,
        }
        if radius is not None:
            self._values["radius"] = radius
        if radius_var is not None:
            self._values["radius_var"] = radius_var

    @builtins.property
    def center(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestCircleShapeCenter":
        '''center block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#center DataAkamaiImagingPolicyImage#center}
        '''
        result = self._values.get("center")
        assert result is not None, "Required property 'center' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestCircleShapeCenter", result)

    @builtins.property
    def radius(self) -> typing.Optional[builtins.str]:
        '''The radius of the circle measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#radius DataAkamaiImagingPolicyImage#radius}
        '''
        result = self._values.get("radius")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def radius_var(self) -> typing.Optional[builtins.str]:
        '''The radius of the circle measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#radius_var DataAkamaiImagingPolicyImage#radius_var}
        '''
        result = self._values.get("radius_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestCircleShape(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestCircleShapeCenter",
    jsii_struct_bases=[],
    name_mapping={"x": "x", "x_var": "xVar", "y": "y", "y_var": "yVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestCircleShapeCenter:
    def __init__(
        self,
        *,
        x: typing.Optional[builtins.str] = None,
        x_var: typing.Optional[builtins.str] = None,
        y: typing.Optional[builtins.str] = None,
        y_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param x: The horizontal position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x DataAkamaiImagingPolicyImage#x}
        :param x_var: The horizontal position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_var DataAkamaiImagingPolicyImage#x_var}
        :param y: The vertical position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y DataAkamaiImagingPolicyImage#y}
        :param y_var: The vertical position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_var DataAkamaiImagingPolicyImage#y_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e6a168d732d93563939de15e7e0fae38c627422ec61f6a695c790e89d54647ca)
            check_type(argname="argument x", value=x, expected_type=type_hints["x"])
            check_type(argname="argument x_var", value=x_var, expected_type=type_hints["x_var"])
            check_type(argname="argument y", value=y, expected_type=type_hints["y"])
            check_type(argname="argument y_var", value=y_var, expected_type=type_hints["y_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if x is not None:
            self._values["x"] = x
        if x_var is not None:
            self._values["x_var"] = x_var
        if y is not None:
            self._values["y"] = y
        if y_var is not None:
            self._values["y_var"] = y_var

    @builtins.property
    def x(self) -> typing.Optional[builtins.str]:
        '''The horizontal position of the point, measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x DataAkamaiImagingPolicyImage#x}
        '''
        result = self._values.get("x")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_var(self) -> typing.Optional[builtins.str]:
        '''The horizontal position of the point, measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_var DataAkamaiImagingPolicyImage#x_var}
        '''
        result = self._values.get("x_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y(self) -> typing.Optional[builtins.str]:
        '''The vertical position of the point, measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y DataAkamaiImagingPolicyImage#y}
        '''
        result = self._values.get("y")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_var(self) -> typing.Optional[builtins.str]:
        '''The vertical position of the point, measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_var DataAkamaiImagingPolicyImage#y_var}
        '''
        result = self._values.get("y_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestCircleShapeCenter(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestCircleShapeCenterOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestCircleShapeCenterOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__50fa0b7adbb9779f2be243a157736ead0538a01cb92d99929858c79ba9bc4cae)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetX")
    def reset_x(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetX", []))

    @jsii.member(jsii_name="resetXVar")
    def reset_x_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXVar", []))

    @jsii.member(jsii_name="resetY")
    def reset_y(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetY", []))

    @jsii.member(jsii_name="resetYVar")
    def reset_y_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYVar", []))

    @builtins.property
    @jsii.member(jsii_name="xInput")
    def x_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xInput"))

    @builtins.property
    @jsii.member(jsii_name="xVarInput")
    def x_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yInput")
    def y_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yInput"))

    @builtins.property
    @jsii.member(jsii_name="yVarInput")
    def y_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yVarInput"))

    @builtins.property
    @jsii.member(jsii_name="x")
    def x(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "x"))

    @x.setter
    def x(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8710ad8a317128f8f8c1f34c62bf06e9bdcd355966ae084350b8ff531e11501d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "x", value)

    @builtins.property
    @jsii.member(jsii_name="xVar")
    def x_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xVar"))

    @x_var.setter
    def x_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d863b608fc881b2ab07664f394553065b17783b19e703d4b5e9639359db0c059)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xVar", value)

    @builtins.property
    @jsii.member(jsii_name="y")
    def y(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "y"))

    @y.setter
    def y(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5bf9f03cf08b4fa640a83498d9644ff177881621b0afe2e49cfdc30a1301749c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "y", value)

    @builtins.property
    @jsii.member(jsii_name="yVar")
    def y_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yVar"))

    @y_var.setter
    def y_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c8e7f4a698e68e97d0c4eebd2e45740bbfc62900d58976394fd66044e7fafd65)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestCircleShapeCenter]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestCircleShapeCenter], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestCircleShapeCenter],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e0d6ac759bcb556724c9605396141d4b225d0c4c3c753212b88201cb68ee136)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestCircleShapeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestCircleShapeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a3f2df78405b4c5f4a7193bca45fd707ebc6287c39c1901d9167e3737b0d223c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestCircleShapeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d369b667b6c8553b76216dc4fb5ed21ca6331faee1b1dc86913ea5ff3b54e398)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestCircleShapeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__19c9a65cfdbf2045d683317c21f037faa5c28eb0680996b05f938e5818582319)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e01f7276d98bc06fa9ba30160cf876eb08cdf96c74569392ebf84a62ed1ddc7d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bfe38ef42c4ab0a083504a59a5c768e8f765c0851b684beb3b8d1cf233889cb0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestCircleShape]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestCircleShape]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestCircleShape]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b4c1e52bbc3e7f1887211c2caf302c68b33309df139d7489d9cec7ed13903b90)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestCircleShapeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestCircleShapeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3543f83394c7a08eefe4cf659628f71f8466e1460960860f27ff7747bb09a8dc)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putCenter")
    def put_center(
        self,
        *,
        x: typing.Optional[builtins.str] = None,
        x_var: typing.Optional[builtins.str] = None,
        y: typing.Optional[builtins.str] = None,
        y_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param x: The horizontal position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x DataAkamaiImagingPolicyImage#x}
        :param x_var: The horizontal position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_var DataAkamaiImagingPolicyImage#x_var}
        :param y: The vertical position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y DataAkamaiImagingPolicyImage#y}
        :param y_var: The vertical position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_var DataAkamaiImagingPolicyImage#y_var}
        '''
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestCircleShapeCenter(
            x=x, x_var=x_var, y=y, y_var=y_var
        )

        return typing.cast(None, jsii.invoke(self, "putCenter", [value]))

    @jsii.member(jsii_name="resetRadius")
    def reset_radius(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRadius", []))

    @jsii.member(jsii_name="resetRadiusVar")
    def reset_radius_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRadiusVar", []))

    @builtins.property
    @jsii.member(jsii_name="center")
    def center(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestCircleShapeCenterOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestCircleShapeCenterOutputReference, jsii.get(self, "center"))

    @builtins.property
    @jsii.member(jsii_name="centerInput")
    def center_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestCircleShapeCenter]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestCircleShapeCenter], jsii.get(self, "centerInput"))

    @builtins.property
    @jsii.member(jsii_name="radiusInput")
    def radius_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "radiusInput"))

    @builtins.property
    @jsii.member(jsii_name="radiusVarInput")
    def radius_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "radiusVarInput"))

    @builtins.property
    @jsii.member(jsii_name="radius")
    def radius(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "radius"))

    @radius.setter
    def radius(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__49f8cbd213af2b5774df20fb7484bedb9fcc9fdcec614aad6cbaa429b5647f3a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "radius", value)

    @builtins.property
    @jsii.member(jsii_name="radiusVar")
    def radius_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "radiusVar"))

    @radius_var.setter
    def radius_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ff3e41253ee807b8b1b9c73a731e874f99e820634ed97ff71940238a7a98a03)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "radiusVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestCircleShape]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestCircleShape]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestCircleShape]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__864a4ff7c5f6fb1bf89448cbc8782c9923218e625ffc429d2b40bc297ea2641a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e2971dbdf0a59265c08c530b419a6c35fe7be2c73c28a49d3d60dda32d0b0c4b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putCircleShape")
    def put_circle_shape(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestCircleShape, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a65385567790fc73b6a72a19547647bc73b0ea593be60147013523e326b4aeb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCircleShape", [value]))

    @jsii.member(jsii_name="putPointShape")
    def put_point_shape(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestPointShape", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f5d0fa880068109c5cb583b09772c1b93ab8da3c6a6e0690c1b73f6f816f368e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putPointShape", [value]))

    @jsii.member(jsii_name="putPolygonShape")
    def put_polygon_shape(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestPolygonShape", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7e193aa9d24c8919eb5c05001bffd8c76a5e71bbccb92e9b62ef37ac24ce9c2e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putPolygonShape", [value]))

    @jsii.member(jsii_name="putRectangleShape")
    def put_rectangle_shape(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestRectangleShape", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__50938739b072727c58dae02b1e233151843e7572b383636342dbc2a83d4f04cf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRectangleShape", [value]))

    @jsii.member(jsii_name="putUnionShape")
    def put_union_shape(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestUnionShape", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__44f6d1c3db1c96096e2d0af67d5c8e693c02569f91aa8f465c7dd44ad0dab825)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putUnionShape", [value]))

    @jsii.member(jsii_name="resetCircleShape")
    def reset_circle_shape(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCircleShape", []))

    @jsii.member(jsii_name="resetPointShape")
    def reset_point_shape(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPointShape", []))

    @jsii.member(jsii_name="resetPolygonShape")
    def reset_polygon_shape(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPolygonShape", []))

    @jsii.member(jsii_name="resetRectangleShape")
    def reset_rectangle_shape(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRectangleShape", []))

    @jsii.member(jsii_name="resetUnionShape")
    def reset_union_shape(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUnionShape", []))

    @builtins.property
    @jsii.member(jsii_name="circleShape")
    def circle_shape(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestCircleShapeList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestCircleShapeList, jsii.get(self, "circleShape"))

    @builtins.property
    @jsii.member(jsii_name="pointShape")
    def point_shape(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestPointShapeList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestPointShapeList", jsii.get(self, "pointShape"))

    @builtins.property
    @jsii.member(jsii_name="polygonShape")
    def polygon_shape(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestPolygonShapeList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestPolygonShapeList", jsii.get(self, "polygonShape"))

    @builtins.property
    @jsii.member(jsii_name="rectangleShape")
    def rectangle_shape(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestRectangleShapeList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestRectangleShapeList", jsii.get(self, "rectangleShape"))

    @builtins.property
    @jsii.member(jsii_name="unionShape")
    def union_shape(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestUnionShapeList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestUnionShapeList", jsii.get(self, "unionShape"))

    @builtins.property
    @jsii.member(jsii_name="circleShapeInput")
    def circle_shape_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestCircleShape]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestCircleShape]]], jsii.get(self, "circleShapeInput"))

    @builtins.property
    @jsii.member(jsii_name="pointShapeInput")
    def point_shape_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestPointShape"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestPointShape"]]], jsii.get(self, "pointShapeInput"))

    @builtins.property
    @jsii.member(jsii_name="polygonShapeInput")
    def polygon_shape_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestPolygonShape"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestPolygonShape"]]], jsii.get(self, "polygonShapeInput"))

    @builtins.property
    @jsii.member(jsii_name="rectangleShapeInput")
    def rectangle_shape_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestRectangleShape"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestRectangleShape"]]], jsii.get(self, "rectangleShapeInput"))

    @builtins.property
    @jsii.member(jsii_name="unionShapeInput")
    def union_shape_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestUnionShape"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestUnionShape"]]], jsii.get(self, "unionShapeInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterest]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterest], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterest],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a76c6fd53ac63e5a871afa5507227b38c0922af6c6b7f4841b81416bb055c086)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestPointShape",
    jsii_struct_bases=[],
    name_mapping={"x": "x", "x_var": "xVar", "y": "y", "y_var": "yVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestPointShape:
    def __init__(
        self,
        *,
        x: typing.Optional[builtins.str] = None,
        x_var: typing.Optional[builtins.str] = None,
        y: typing.Optional[builtins.str] = None,
        y_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param x: The horizontal position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x DataAkamaiImagingPolicyImage#x}
        :param x_var: The horizontal position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_var DataAkamaiImagingPolicyImage#x_var}
        :param y: The vertical position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y DataAkamaiImagingPolicyImage#y}
        :param y_var: The vertical position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_var DataAkamaiImagingPolicyImage#y_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a211d3b0ba8fc96396e75701edbe8bb15c27f70ae91ddd71c5a599873fb31643)
            check_type(argname="argument x", value=x, expected_type=type_hints["x"])
            check_type(argname="argument x_var", value=x_var, expected_type=type_hints["x_var"])
            check_type(argname="argument y", value=y, expected_type=type_hints["y"])
            check_type(argname="argument y_var", value=y_var, expected_type=type_hints["y_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if x is not None:
            self._values["x"] = x
        if x_var is not None:
            self._values["x_var"] = x_var
        if y is not None:
            self._values["y"] = y
        if y_var is not None:
            self._values["y_var"] = y_var

    @builtins.property
    def x(self) -> typing.Optional[builtins.str]:
        '''The horizontal position of the point, measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x DataAkamaiImagingPolicyImage#x}
        '''
        result = self._values.get("x")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_var(self) -> typing.Optional[builtins.str]:
        '''The horizontal position of the point, measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_var DataAkamaiImagingPolicyImage#x_var}
        '''
        result = self._values.get("x_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y(self) -> typing.Optional[builtins.str]:
        '''The vertical position of the point, measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y DataAkamaiImagingPolicyImage#y}
        '''
        result = self._values.get("y")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_var(self) -> typing.Optional[builtins.str]:
        '''The vertical position of the point, measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_var DataAkamaiImagingPolicyImage#y_var}
        '''
        result = self._values.get("y_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestPointShape(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestPointShapeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestPointShapeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__82674bf9aecfd814af44b660a31d2ebff442d18fa076206cc6116df6189d2e90)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestPointShapeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3b324d213091929035a07ded61ecf3025726a677f5c0bc3481f7a9ef9ff182c5)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestPointShapeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__35aaf6b62dfd895f0fc3055db299a27d01d6c185b591d0b59cf6e84a5cfae867)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b3a454996f19c09f6fd4460d4647438fd1e057bf8dfe7150486a81ca6f1ad4f0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ea778dcac7789b5eccff48b9ce9ba8c1596ece381d080205cadce2b2bbd53b6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestPointShape]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestPointShape]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestPointShape]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1652d495daa4c3d263b416705874576dfd3edcec1e3cd602772a89ed76415a8b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestPointShapeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestPointShapeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__83991f546a967b8dbc1b17848571ca22337319e8f0a9980316b34ea0d29f2910)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetX")
    def reset_x(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetX", []))

    @jsii.member(jsii_name="resetXVar")
    def reset_x_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXVar", []))

    @jsii.member(jsii_name="resetY")
    def reset_y(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetY", []))

    @jsii.member(jsii_name="resetYVar")
    def reset_y_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYVar", []))

    @builtins.property
    @jsii.member(jsii_name="xInput")
    def x_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xInput"))

    @builtins.property
    @jsii.member(jsii_name="xVarInput")
    def x_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yInput")
    def y_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yInput"))

    @builtins.property
    @jsii.member(jsii_name="yVarInput")
    def y_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yVarInput"))

    @builtins.property
    @jsii.member(jsii_name="x")
    def x(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "x"))

    @x.setter
    def x(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4d3993ea0adbae5345bd63081f2443f1886e51a2ab41792cff68232a12ba93b5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "x", value)

    @builtins.property
    @jsii.member(jsii_name="xVar")
    def x_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xVar"))

    @x_var.setter
    def x_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__77e95e2ec00d89739eb2aedb71a881feac42d29e0d4a80e76e927eb77d97f9ff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xVar", value)

    @builtins.property
    @jsii.member(jsii_name="y")
    def y(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "y"))

    @y.setter
    def y(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f68b928c7b1b4c60967ebfc4fcf895f27c7594699a95f05cbf69e483466cae2f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "y", value)

    @builtins.property
    @jsii.member(jsii_name="yVar")
    def y_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yVar"))

    @y_var.setter
    def y_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7fcd6b2a5004501a5bf537c0204b629b65fde0fe909f4515be9f249efd05ad27)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestPointShape]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestPointShape]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestPointShape]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fafb4e730daedeae3b81890ffd88586166c2dce1f1aa330728a83cf08b614008)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestPolygonShape",
    jsii_struct_bases=[],
    name_mapping={"points": "points"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestPolygonShape:
    def __init__(
        self,
        *,
        points: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestPolygonShapePoints", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param points: points block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#points DataAkamaiImagingPolicyImage#points}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a667902e6b3c3461996a3050d4b08f8e4311d4e54eff7c8dbecb0caeb5c6658)
            check_type(argname="argument points", value=points, expected_type=type_hints["points"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "points": points,
        }

    @builtins.property
    def points(
        self,
    ) -> typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestPolygonShapePoints"]]:
        '''points block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#points DataAkamaiImagingPolicyImage#points}
        '''
        result = self._values.get("points")
        assert result is not None, "Required property 'points' is missing"
        return typing.cast(typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestPolygonShapePoints"]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestPolygonShape(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestPolygonShapeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestPolygonShapeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7ad4e5a6338622b8daeebf317b2277ebc1961e42f12c0e819221cb984982dd26)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestPolygonShapeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b03230a51dd9b210a510e75b94e5c3cebfedebb8156c14b7275137745d407a78)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestPolygonShapeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aa9b8241f7d49b12a133dd0ffddad6a450060e2a647e2468609a17748a363ba8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4be2043f94749460b966f6ade9e94c39c06cc753c624a7a40dea19e26f6c3b28)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9bd5aa766c9683effb6edc31cca6f108e287860d33b47a747918bd56dde8f48b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestPolygonShape]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestPolygonShape]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestPolygonShape]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a6bd97005f3b33282678b5d812f671c0320e75bb382694f97509aa9451750c7d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestPolygonShapeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestPolygonShapeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__291666172b4263dca918bd2239ec3870977747f94b95e0c098ba355be68ddf81)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putPoints")
    def put_points(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestPolygonShapePoints", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3582f50cb0f68a901f809a16203523604f0eaaa0696e502130e9693535b960cd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putPoints", [value]))

    @builtins.property
    @jsii.member(jsii_name="points")
    def points(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestPolygonShapePointsList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestPolygonShapePointsList", jsii.get(self, "points"))

    @builtins.property
    @jsii.member(jsii_name="pointsInput")
    def points_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestPolygonShapePoints"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestPolygonShapePoints"]]], jsii.get(self, "pointsInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestPolygonShape]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestPolygonShape]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestPolygonShape]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cee98d445371292a28946e0c592cad83d0ab7f3c179c6b9349eae28f87be906d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestPolygonShapePoints",
    jsii_struct_bases=[],
    name_mapping={"x": "x", "x_var": "xVar", "y": "y", "y_var": "yVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestPolygonShapePoints:
    def __init__(
        self,
        *,
        x: typing.Optional[builtins.str] = None,
        x_var: typing.Optional[builtins.str] = None,
        y: typing.Optional[builtins.str] = None,
        y_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param x: The horizontal position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x DataAkamaiImagingPolicyImage#x}
        :param x_var: The horizontal position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_var DataAkamaiImagingPolicyImage#x_var}
        :param y: The vertical position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y DataAkamaiImagingPolicyImage#y}
        :param y_var: The vertical position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_var DataAkamaiImagingPolicyImage#y_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__47650cf3c57dbec88c527b53e60ff07d372b7a11fc222f96066b8f695bea4f08)
            check_type(argname="argument x", value=x, expected_type=type_hints["x"])
            check_type(argname="argument x_var", value=x_var, expected_type=type_hints["x_var"])
            check_type(argname="argument y", value=y, expected_type=type_hints["y"])
            check_type(argname="argument y_var", value=y_var, expected_type=type_hints["y_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if x is not None:
            self._values["x"] = x
        if x_var is not None:
            self._values["x_var"] = x_var
        if y is not None:
            self._values["y"] = y
        if y_var is not None:
            self._values["y_var"] = y_var

    @builtins.property
    def x(self) -> typing.Optional[builtins.str]:
        '''The horizontal position of the point, measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x DataAkamaiImagingPolicyImage#x}
        '''
        result = self._values.get("x")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_var(self) -> typing.Optional[builtins.str]:
        '''The horizontal position of the point, measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_var DataAkamaiImagingPolicyImage#x_var}
        '''
        result = self._values.get("x_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y(self) -> typing.Optional[builtins.str]:
        '''The vertical position of the point, measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y DataAkamaiImagingPolicyImage#y}
        '''
        result = self._values.get("y")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_var(self) -> typing.Optional[builtins.str]:
        '''The vertical position of the point, measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_var DataAkamaiImagingPolicyImage#y_var}
        '''
        result = self._values.get("y_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestPolygonShapePoints(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestPolygonShapePointsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestPolygonShapePointsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d1f19c6f1853f3251cf83bc213d743aaf6ad4dee3583453ed17077f7b607f0c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestPolygonShapePointsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__06a95475a23537f2ba94bc8ff588c8d305099a42544ffbb13636ec7c12d9c325)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestPolygonShapePointsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c43d4142c8f007cd7684ca13f7101859dea9f33f758fb111d868158be4cc722f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__012026711353c92cf17bd608885f4959860294b347dbe1c19ea53158fefddaaf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1331bde7a4d3b49c9cbc3fa68f4e44d9f97dbc2c062fe76b1b90b9fe5ea8dd92)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestPolygonShapePoints]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestPolygonShapePoints]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestPolygonShapePoints]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c658e18c84b03a2a60a300a409655e8f2572363592b0bfadee9480f1a70e8da4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestPolygonShapePointsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestPolygonShapePointsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4d19dd1b1a2cad01e2e79d4c5f8ccddadf31eb47bd2034c917eafd8fed4501f5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetX")
    def reset_x(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetX", []))

    @jsii.member(jsii_name="resetXVar")
    def reset_x_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXVar", []))

    @jsii.member(jsii_name="resetY")
    def reset_y(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetY", []))

    @jsii.member(jsii_name="resetYVar")
    def reset_y_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYVar", []))

    @builtins.property
    @jsii.member(jsii_name="xInput")
    def x_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xInput"))

    @builtins.property
    @jsii.member(jsii_name="xVarInput")
    def x_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yInput")
    def y_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yInput"))

    @builtins.property
    @jsii.member(jsii_name="yVarInput")
    def y_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yVarInput"))

    @builtins.property
    @jsii.member(jsii_name="x")
    def x(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "x"))

    @x.setter
    def x(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__981e63dd15035d1831f23d03de843ad526166648a81960d0e2cf323142a0bada)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "x", value)

    @builtins.property
    @jsii.member(jsii_name="xVar")
    def x_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xVar"))

    @x_var.setter
    def x_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4848e7f271ae275ced2d7802e38e79c53b917280f5b1bd2f51fa83aa472ce108)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xVar", value)

    @builtins.property
    @jsii.member(jsii_name="y")
    def y(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "y"))

    @y.setter
    def y(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3bf35052885ca27f880c6885eca3b605adb8d97c0db821e9bc80b3a778e9e11e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "y", value)

    @builtins.property
    @jsii.member(jsii_name="yVar")
    def y_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yVar"))

    @y_var.setter
    def y_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7365ff531c2a33498479f45c896856d0e889a9831ad92ba83f295b54343729f7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestPolygonShapePoints]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestPolygonShapePoints]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestPolygonShapePoints]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5813d2eb701a68d2a0766ba8f1f1822ee7dd0a5886d6df84ac96b9c8ed09599b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestRectangleShape",
    jsii_struct_bases=[],
    name_mapping={
        "anchor": "anchor",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestRectangleShape:
    def __init__(
        self,
        *,
        anchor: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestRectangleShapeAnchor", typing.Dict[builtins.str, typing.Any]],
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param anchor: anchor block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#anchor DataAkamaiImagingPolicyImage#anchor}
        :param height: Extends the rectangle down from the ``anchor`` point. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: Extends the rectangle down from the ``anchor`` point. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: Extends the rectangle right from the ``anchor`` point. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: Extends the rectangle right from the ``anchor`` point. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(anchor, dict):
            anchor = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestRectangleShapeAnchor(**anchor)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__57b18aac7a0aa86ba606193a21c776fe51c128ad729649730833ca741d498138)
            check_type(argname="argument anchor", value=anchor, expected_type=type_hints["anchor"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "anchor": anchor,
        }
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def anchor(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestRectangleShapeAnchor":
        '''anchor block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#anchor DataAkamaiImagingPolicyImage#anchor}
        '''
        result = self._values.get("anchor")
        assert result is not None, "Required property 'anchor' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestRectangleShapeAnchor", result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''Extends the rectangle down from the ``anchor`` point.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''Extends the rectangle down from the ``anchor`` point.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''Extends the rectangle right from the ``anchor`` point.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''Extends the rectangle right from the ``anchor`` point.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestRectangleShape(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestRectangleShapeAnchor",
    jsii_struct_bases=[],
    name_mapping={"x": "x", "x_var": "xVar", "y": "y", "y_var": "yVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestRectangleShapeAnchor:
    def __init__(
        self,
        *,
        x: typing.Optional[builtins.str] = None,
        x_var: typing.Optional[builtins.str] = None,
        y: typing.Optional[builtins.str] = None,
        y_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param x: The horizontal position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x DataAkamaiImagingPolicyImage#x}
        :param x_var: The horizontal position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_var DataAkamaiImagingPolicyImage#x_var}
        :param y: The vertical position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y DataAkamaiImagingPolicyImage#y}
        :param y_var: The vertical position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_var DataAkamaiImagingPolicyImage#y_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ca9d55617207ab374dbff96a92da77ba483637200550a82c5f23ea2de472dc5e)
            check_type(argname="argument x", value=x, expected_type=type_hints["x"])
            check_type(argname="argument x_var", value=x_var, expected_type=type_hints["x_var"])
            check_type(argname="argument y", value=y, expected_type=type_hints["y"])
            check_type(argname="argument y_var", value=y_var, expected_type=type_hints["y_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if x is not None:
            self._values["x"] = x
        if x_var is not None:
            self._values["x_var"] = x_var
        if y is not None:
            self._values["y"] = y
        if y_var is not None:
            self._values["y_var"] = y_var

    @builtins.property
    def x(self) -> typing.Optional[builtins.str]:
        '''The horizontal position of the point, measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x DataAkamaiImagingPolicyImage#x}
        '''
        result = self._values.get("x")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_var(self) -> typing.Optional[builtins.str]:
        '''The horizontal position of the point, measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_var DataAkamaiImagingPolicyImage#x_var}
        '''
        result = self._values.get("x_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y(self) -> typing.Optional[builtins.str]:
        '''The vertical position of the point, measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y DataAkamaiImagingPolicyImage#y}
        '''
        result = self._values.get("y")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_var(self) -> typing.Optional[builtins.str]:
        '''The vertical position of the point, measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_var DataAkamaiImagingPolicyImage#y_var}
        '''
        result = self._values.get("y_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestRectangleShapeAnchor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestRectangleShapeAnchorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestRectangleShapeAnchorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__39f28044f50f8e682ba32c156a15ee98c900a65c1694f29a3f9f1a744aee5dd7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetX")
    def reset_x(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetX", []))

    @jsii.member(jsii_name="resetXVar")
    def reset_x_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXVar", []))

    @jsii.member(jsii_name="resetY")
    def reset_y(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetY", []))

    @jsii.member(jsii_name="resetYVar")
    def reset_y_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYVar", []))

    @builtins.property
    @jsii.member(jsii_name="xInput")
    def x_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xInput"))

    @builtins.property
    @jsii.member(jsii_name="xVarInput")
    def x_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yInput")
    def y_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yInput"))

    @builtins.property
    @jsii.member(jsii_name="yVarInput")
    def y_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yVarInput"))

    @builtins.property
    @jsii.member(jsii_name="x")
    def x(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "x"))

    @x.setter
    def x(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bf5d043fb81430ae00e2cdf0186c8044ad6199ddf9848e4367c4f69de61b4152)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "x", value)

    @builtins.property
    @jsii.member(jsii_name="xVar")
    def x_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xVar"))

    @x_var.setter
    def x_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__97776d11b9d8887a21792f05c1ab689b127b9ab49b81f800c4ff85d1ec25888a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xVar", value)

    @builtins.property
    @jsii.member(jsii_name="y")
    def y(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "y"))

    @y.setter
    def y(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fc01f6a1705a85c29c3782c66a671dbb963c0426ef8df6a4466acb7968dbd721)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "y", value)

    @builtins.property
    @jsii.member(jsii_name="yVar")
    def y_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yVar"))

    @y_var.setter
    def y_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__816b1028148d9d542e2648fab59634861a31965d43d0b9ca33c3142e8ff2a477)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestRectangleShapeAnchor]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestRectangleShapeAnchor], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestRectangleShapeAnchor],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__db1350a07e57a1696595df69a04d8381ebb4d7bc2d1f61fea6ce50243282c385)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestRectangleShapeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestRectangleShapeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0d275a1d22241664cd06f7c7039f6a07dbb14986d68c3570403fa8df3e907a26)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestRectangleShapeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5105ad538f9987501e0012133b21d33561bf83335fbd76ba9b0564931e557d85)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestRectangleShapeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2cddb8b12bf273789415fdebba0e3773ff78972c2b8311a8cfcf32b268941493)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ef19304633fef6c13567ab322e80e109ee2fba48f4a368ebda7f75e2a782b011)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__52468892730fb0c87e878e4138a5410948b520d680d45487bb4535b9e4ed8513)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestRectangleShape]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestRectangleShape]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestRectangleShape]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4549cf0d8067ee8c2432854fde766ff6df36f18092aa33ab56a15e8d5f1ea087)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestRectangleShapeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestRectangleShapeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__de199bb7dfd44fd3fd13291d69e4a00e93400a1ad5c00ce6dd3d3098303753fb)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putAnchor")
    def put_anchor(
        self,
        *,
        x: typing.Optional[builtins.str] = None,
        x_var: typing.Optional[builtins.str] = None,
        y: typing.Optional[builtins.str] = None,
        y_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param x: The horizontal position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x DataAkamaiImagingPolicyImage#x}
        :param x_var: The horizontal position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_var DataAkamaiImagingPolicyImage#x_var}
        :param y: The vertical position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y DataAkamaiImagingPolicyImage#y}
        :param y_var: The vertical position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_var DataAkamaiImagingPolicyImage#y_var}
        '''
        value = DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestRectangleShapeAnchor(
            x=x, x_var=x_var, y=y, y_var=y_var
        )

        return typing.cast(None, jsii.invoke(self, "putAnchor", [value]))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="anchor")
    def anchor(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestRectangleShapeAnchorOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestRectangleShapeAnchorOutputReference, jsii.get(self, "anchor"))

    @builtins.property
    @jsii.member(jsii_name="anchorInput")
    def anchor_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestRectangleShapeAnchor]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestRectangleShapeAnchor], jsii.get(self, "anchorInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4fdaf4572a09af3d154dd69997996a4b46d93f6d7d37ec69b0bf338365b40656)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__95ab821278737f8f17b9d99590ad5b6ca29ba39083563667268bf8d4db03ede7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c4d8175cde67d614245f6883b41295b730be83d1c57837f7c1ddb8be16f2ff6e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__60bc282b0cb7e2f750285bb3dfc89047d4c46a6024a4c8912a8507dce586f626)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestRectangleShape]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestRectangleShape]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestRectangleShape]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7612e5ed466e2ae1483355e45f82abb26deab4d14acac202248dc1f4dc8aa5bc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestUnionShape",
    jsii_struct_bases=[],
    name_mapping={"shapes": "shapes"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestUnionShape:
    def __init__(
        self,
        *,
        shapes: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestUnionShapeShapes", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param shapes: shapes block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shapes DataAkamaiImagingPolicyImage#shapes}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9227e1b915e1b63598ad51e299062bf480b7e1d8ada3d1162e52a5309892b375)
            check_type(argname="argument shapes", value=shapes, expected_type=type_hints["shapes"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "shapes": shapes,
        }

    @builtins.property
    def shapes(
        self,
    ) -> typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestUnionShapeShapes"]]:
        '''shapes block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shapes DataAkamaiImagingPolicyImage#shapes}
        '''
        result = self._values.get("shapes")
        assert result is not None, "Required property 'shapes' is missing"
        return typing.cast(typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestUnionShapeShapes"]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestUnionShape(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestUnionShapeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestUnionShapeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f0a15a721aff528383fdc8338bc6e9ff4740b224e53c5c9a673f4baa6e681f6b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestUnionShapeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c08a5d1421e839809fc060a741be76dc808278c1b10dc2f0f21e089ee3f7f4ae)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestUnionShapeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a61532aa7efc8d02c4be525d63485f994703fcef171cb8c9f5f8e7b378dccd16)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__244c9309ec256ba2d3ea2d9796b54484f4cfb436712335b3c0e911c3fdf91477)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e0d7aef172a4b54175477fe1aca881f4d94d540c72495ed50d4d534e5d59736a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestUnionShape]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestUnionShape]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestUnionShape]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__23027f29fe3342a7481c81e82e72a2497ce8931a945f9a69b52e938a351c1eb1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestUnionShapeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestUnionShapeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0bb447ab50913530873a50d68d8b1c2589914e4d644ac88d5fa24e6dad9b3f21)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putShapes")
    def put_shapes(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestUnionShapeShapes", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ddb22efcab7ef8aa30ec6c6a606778cf66288ed5c55bd16cb6d4b4740adef755)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putShapes", [value]))

    @builtins.property
    @jsii.member(jsii_name="shapes")
    def shapes(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestUnionShapeShapesList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestUnionShapeShapesList", jsii.get(self, "shapes"))

    @builtins.property
    @jsii.member(jsii_name="shapesInput")
    def shapes_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestUnionShapeShapes"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestUnionShapeShapes"]]], jsii.get(self, "shapesInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestUnionShape]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestUnionShape]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestUnionShape]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fb7bf9109b5adf275bdb8a6fa53b91d185c5e3844d6d404e5c002a219e39a56a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestUnionShapeShapes",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestUnionShapeShapes:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestUnionShapeShapes(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestUnionShapeShapesList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestUnionShapeShapesList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__38e263347e314d7cd2276512dc6a81aa4d4be89cc5878a8ba16291da47a534c1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestUnionShapeShapesOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a5e45cbb83cb3f494427026c652e1fc4055d0c71fe4f5bf01d001692ed175cca)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestUnionShapeShapesOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c595e68b0f802a263742f6f5e8ffc49784fcfe8095bfbc13eb814f8085918f19)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b7c40a676aea95dcbb87f862a14eadc6cc46f0249e5b32dd38ef7aff34ba118f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e1b27e5416cf1ce495909136c4720470e274547c719405af7cf02e4c436b7882)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestUnionShapeShapes]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestUnionShapeShapes]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestUnionShapeShapes]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__76b1dd3f8f64f3fc40d1a38409392401c4a629ba4a1961633533c2fe4e531b3d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestUnionShapeShapesOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestUnionShapeShapesOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__05ebbc38f99de203bc8b22e24d27c1600b5135237bea9518c0567b259b644fbc)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestUnionShapeShapes]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestUnionShapeShapes]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestUnionShapeShapes]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ed51ffd25ee613cb76b5da1074fa1c411d341a5e5fdd65ac5cfbe26322f2b4fe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRelativeCrop",
    jsii_struct_bases=[],
    name_mapping={
        "east": "east",
        "east_var": "eastVar",
        "north": "north",
        "north_var": "northVar",
        "south": "south",
        "south_var": "southVar",
        "west": "west",
        "west_var": "westVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRelativeCrop:
    def __init__(
        self,
        *,
        east: typing.Optional[builtins.str] = None,
        east_var: typing.Optional[builtins.str] = None,
        north: typing.Optional[builtins.str] = None,
        north_var: typing.Optional[builtins.str] = None,
        south: typing.Optional[builtins.str] = None,
        south_var: typing.Optional[builtins.str] = None,
        west: typing.Optional[builtins.str] = None,
        west_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param east: The number of pixels to shrink or expand the right side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east DataAkamaiImagingPolicyImage#east}
        :param east_var: The number of pixels to shrink or expand the right side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east_var DataAkamaiImagingPolicyImage#east_var}
        :param north: The number of pixels to shrink or expand the top side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north DataAkamaiImagingPolicyImage#north}
        :param north_var: The number of pixels to shrink or expand the top side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north_var DataAkamaiImagingPolicyImage#north_var}
        :param south: The number of pixels to shrink or expand the bottom side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south DataAkamaiImagingPolicyImage#south}
        :param south_var: The number of pixels to shrink or expand the bottom side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south_var DataAkamaiImagingPolicyImage#south_var}
        :param west: The number of pixels to shrink or expand the left side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west DataAkamaiImagingPolicyImage#west}
        :param west_var: The number of pixels to shrink or expand the left side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west_var DataAkamaiImagingPolicyImage#west_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8d5a3b5bcddb2ef9a94fdd3744124621f49e37752fdce4cd6e66e5284f39015e)
            check_type(argname="argument east", value=east, expected_type=type_hints["east"])
            check_type(argname="argument east_var", value=east_var, expected_type=type_hints["east_var"])
            check_type(argname="argument north", value=north, expected_type=type_hints["north"])
            check_type(argname="argument north_var", value=north_var, expected_type=type_hints["north_var"])
            check_type(argname="argument south", value=south, expected_type=type_hints["south"])
            check_type(argname="argument south_var", value=south_var, expected_type=type_hints["south_var"])
            check_type(argname="argument west", value=west, expected_type=type_hints["west"])
            check_type(argname="argument west_var", value=west_var, expected_type=type_hints["west_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if east is not None:
            self._values["east"] = east
        if east_var is not None:
            self._values["east_var"] = east_var
        if north is not None:
            self._values["north"] = north
        if north_var is not None:
            self._values["north_var"] = north_var
        if south is not None:
            self._values["south"] = south
        if south_var is not None:
            self._values["south_var"] = south_var
        if west is not None:
            self._values["west"] = west
        if west_var is not None:
            self._values["west_var"] = west_var

    @builtins.property
    def east(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the right side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east DataAkamaiImagingPolicyImage#east}
        '''
        result = self._values.get("east")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def east_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the right side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east_var DataAkamaiImagingPolicyImage#east_var}
        '''
        result = self._values.get("east_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def north(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the top side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north DataAkamaiImagingPolicyImage#north}
        '''
        result = self._values.get("north")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def north_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the top side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north_var DataAkamaiImagingPolicyImage#north_var}
        '''
        result = self._values.get("north_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def south(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the bottom side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south DataAkamaiImagingPolicyImage#south}
        '''
        result = self._values.get("south")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def south_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the bottom side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south_var DataAkamaiImagingPolicyImage#south_var}
        '''
        result = self._values.get("south_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def west(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the left side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west DataAkamaiImagingPolicyImage#west}
        '''
        result = self._values.get("west")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def west_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the left side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west_var DataAkamaiImagingPolicyImage#west_var}
        '''
        result = self._values.get("west_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRelativeCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRelativeCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRelativeCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d777342506186489615b78997542a2eebdcee182bf54b66d38071c72cdb198af)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRelativeCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f5ea0f52f3f91de1cad09e9e218f4a31463d010a7ceb36e435692ddf63a4779f)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRelativeCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b1f3a4c57cea5f2fc6053a3997d3734aa85db451ad4e892fd9352b8bf5a9ffa1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e7c630cf274438ed8d1696f2f1eac9bfa151688e621b2795cafdc1abc66ef886)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2badb2db0b8bf881d9d791c001554fa854ebe2c24bd764087799f11e92776010)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRelativeCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRelativeCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRelativeCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ffac406d2924dbf6d71f191f6ff90f9f23275291440ed5efa830cda6d9cfe679)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRelativeCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRelativeCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e3f9919aae3f79f5de1c691bc163cd749546dfe09c425065d206dd2637880d0c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetEast")
    def reset_east(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEast", []))

    @jsii.member(jsii_name="resetEastVar")
    def reset_east_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEastVar", []))

    @jsii.member(jsii_name="resetNorth")
    def reset_north(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNorth", []))

    @jsii.member(jsii_name="resetNorthVar")
    def reset_north_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNorthVar", []))

    @jsii.member(jsii_name="resetSouth")
    def reset_south(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSouth", []))

    @jsii.member(jsii_name="resetSouthVar")
    def reset_south_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSouthVar", []))

    @jsii.member(jsii_name="resetWest")
    def reset_west(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWest", []))

    @jsii.member(jsii_name="resetWestVar")
    def reset_west_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWestVar", []))

    @builtins.property
    @jsii.member(jsii_name="eastInput")
    def east_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "eastInput"))

    @builtins.property
    @jsii.member(jsii_name="eastVarInput")
    def east_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "eastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="northInput")
    def north_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "northInput"))

    @builtins.property
    @jsii.member(jsii_name="northVarInput")
    def north_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "northVarInput"))

    @builtins.property
    @jsii.member(jsii_name="southInput")
    def south_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "southInput"))

    @builtins.property
    @jsii.member(jsii_name="southVarInput")
    def south_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "southVarInput"))

    @builtins.property
    @jsii.member(jsii_name="westInput")
    def west_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "westInput"))

    @builtins.property
    @jsii.member(jsii_name="westVarInput")
    def west_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "westVarInput"))

    @builtins.property
    @jsii.member(jsii_name="east")
    def east(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "east"))

    @east.setter
    def east(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__445180286a006b459185778fbe1f402685d5df50e3049239eabfd922189272f9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "east", value)

    @builtins.property
    @jsii.member(jsii_name="eastVar")
    def east_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "eastVar"))

    @east_var.setter
    def east_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aa85b6daed1966c09f8690a63cb57c0c01b871faf3914fa0d3d0e30146f0f11b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "eastVar", value)

    @builtins.property
    @jsii.member(jsii_name="north")
    def north(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "north"))

    @north.setter
    def north(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab009aafe92be846befff9cc0075646cf0b896173e41cf349f78a555c6b55765)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "north", value)

    @builtins.property
    @jsii.member(jsii_name="northVar")
    def north_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "northVar"))

    @north_var.setter
    def north_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6067fe89045a2fe3261036872e343e1b5a5e968a1de5c9b30546dcb7bf202877)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "northVar", value)

    @builtins.property
    @jsii.member(jsii_name="south")
    def south(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "south"))

    @south.setter
    def south(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ddae1d22eee83a2345ffc3f4939f75480fa8870ef41e14237d0ce5f215f5f38)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "south", value)

    @builtins.property
    @jsii.member(jsii_name="southVar")
    def south_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "southVar"))

    @south_var.setter
    def south_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__338ad747439fa3f2d3a1c271e4aff2c009eb9f47c3a6fa7c5fbbdf4ed6d9ce5e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "southVar", value)

    @builtins.property
    @jsii.member(jsii_name="west")
    def west(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "west"))

    @west.setter
    def west(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__02b6ef418790b5d12745a93903c5ec448a8cfb6bd216e6e293b3db31b49d92d1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "west", value)

    @builtins.property
    @jsii.member(jsii_name="westVar")
    def west_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "westVar"))

    @west_var.setter
    def west_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__549cd05d1939e18f3de83a3e264faa7932a2317baffae2d1f9d080768c924dbb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "westVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRelativeCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRelativeCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRelativeCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__97e88420d5547a2f2338c18c490c7a437f4f07f6f805e3253804ae6f44e66c4a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRemoveColor",
    jsii_struct_bases=[],
    name_mapping={
        "color": "color",
        "color_var": "colorVar",
        "feather": "feather",
        "feather_var": "featherVar",
        "tolerance": "tolerance",
        "tolerance_var": "toleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRemoveColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
        feather: typing.Optional[builtins.str] = None,
        feather_var: typing.Optional[builtins.str] = None,
        tolerance: typing.Optional[builtins.str] = None,
        tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        :param feather: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        :param feather_var: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        :param tolerance: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        :param tolerance_var: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__22f50b7997c229390040b5ea65160ff3711aa98c0e851f2cb6a18de6d99163e8)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
            check_type(argname="argument feather", value=feather, expected_type=type_hints["feather"])
            check_type(argname="argument feather_var", value=feather_var, expected_type=type_hints["feather_var"])
            check_type(argname="argument tolerance", value=tolerance, expected_type=type_hints["tolerance"])
            check_type(argname="argument tolerance_var", value=tolerance_var, expected_type=type_hints["tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var
        if feather is not None:
            self._values["feather"] = feather
        if feather_var is not None:
            self._values["feather_var"] = feather_var
        if tolerance is not None:
            self._values["tolerance"] = tolerance
        if tolerance_var is not None:
            self._values["tolerance_var"] = tolerance_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        '''
        result = self._values.get("feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather_var(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        '''
        result = self._values.get("feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        '''
        result = self._values.get("tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance_var(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        result = self._values.get("tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRemoveColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRemoveColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRemoveColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__76b089832ba10f32e204e2a93fd13894af922e611b380486a9cb862b42799900)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRemoveColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__92b78817f409bb3cd44f96f27720595ab6011e53663aab462a0c8b8a7a00a78b)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRemoveColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b831ea04d9151ca467daee6fb59ecd4ecdae76293aadb3a0c5371b99460f503d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aa5ca684ed24f9d0d896cab1980282390978b885debf30a8824fd874aa97ce55)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2eeb4c199afde74932c2bdcd9f849140ea8ccddc7a1f8e136007025886233c78)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRemoveColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRemoveColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRemoveColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6a472def690b260b79c9faf98cfa584821a0c75d1788ffa946d6132e4b26f858)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRemoveColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRemoveColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__936ccb5cc4beb9924dee2aa4d0ecd7250f96b5652718b888e0c41b2528f449fa)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @jsii.member(jsii_name="resetFeather")
    def reset_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeather", []))

    @jsii.member(jsii_name="resetFeatherVar")
    def reset_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatherVar", []))

    @jsii.member(jsii_name="resetTolerance")
    def reset_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTolerance", []))

    @jsii.member(jsii_name="resetToleranceVar")
    def reset_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featherInput")
    def feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherInput"))

    @builtins.property
    @jsii.member(jsii_name="featherVarInput")
    def feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceInput")
    def tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceVarInput")
    def tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__59bf77e5761f45612292ea225871df2fe34ce383f65f465f934f8533bc06af13)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3b8ef7ada66d760828a4886704f453bcac10d72976f15e8d4d64a60ce6c48153)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="feather")
    def feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "feather"))

    @feather.setter
    def feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a9d5ef7cab508899daec6adf09877d1027652811544cfdd714b5115194e8de16)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "feather", value)

    @builtins.property
    @jsii.member(jsii_name="featherVar")
    def feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featherVar"))

    @feather_var.setter
    def feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__26779e4b7ab6faa2f6cc78cbe6610c3d53913f7ca5bd4422714171c7d4329d03)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featherVar", value)

    @builtins.property
    @jsii.member(jsii_name="tolerance")
    def tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tolerance"))

    @tolerance.setter
    def tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__81b3c1154049647f2967f2ce4ff3061a05490fd794cf0aa7ec8149235ec0f4a6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tolerance", value)

    @builtins.property
    @jsii.member(jsii_name="toleranceVar")
    def tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "toleranceVar"))

    @tolerance_var.setter
    def tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5db916946dad9d2a3d97f02d3ab3653b6a14429caa574daf70f578f8d83d41bd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "toleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRemoveColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRemoveColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRemoveColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__12e61c7c92b491a57c2862846f30078389d0abf149ff766f3f2aeb1134a7ccc9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareResize",
    jsii_struct_bases=[],
    name_mapping={
        "aspect": "aspect",
        "aspect_var": "aspectVar",
        "height": "height",
        "height_var": "heightVar",
        "type": "type",
        "type_var": "typeVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareResize:
    def __init__(
        self,
        *,
        aspect: typing.Optional[builtins.str] = None,
        aspect_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param aspect: Preserves the aspect ratio. Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect DataAkamaiImagingPolicyImage#aspect}
        :param aspect_var: Preserves the aspect ratio. Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_var DataAkamaiImagingPolicyImage#aspect_var}
        :param height: The height to resize the source image to. Must be set if height is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height to resize the source image to. Must be set if height is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param type: Sets constraints for the image resize. Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: Sets constraints for the image resize. Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        :param width: The width to resize the source image to. Must be set if width is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width to resize the source image to. Must be set if width is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0935cea73ec607d244919b1c6d147f0e6b7f3f1378c0e84cbe247b04cd631bff)
            check_type(argname="argument aspect", value=aspect, expected_type=type_hints["aspect"])
            check_type(argname="argument aspect_var", value=aspect_var, expected_type=type_hints["aspect_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if aspect is not None:
            self._values["aspect"] = aspect
        if aspect_var is not None:
            self._values["aspect_var"] = aspect_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def aspect(self) -> typing.Optional[builtins.str]:
        '''Preserves the aspect ratio.

        Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect DataAkamaiImagingPolicyImage#aspect}
        '''
        result = self._values.get("aspect")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def aspect_var(self) -> typing.Optional[builtins.str]:
        '''Preserves the aspect ratio.

        Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_var DataAkamaiImagingPolicyImage#aspect_var}
        '''
        result = self._values.get("aspect_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height to resize the source image to. Must be set if height is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height to resize the source image to. Must be set if height is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''Sets constraints for the image resize.

        Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''Sets constraints for the image resize.

        Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width to resize the source image to. Must be set if width is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width to resize the source image to. Must be set if width is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareResize(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareResizeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareResizeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__485c04c7e75cb2a3bc2768823fe883128a29b5ba23238e9de389fc6384e051f1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareResizeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__032ce0e5b42b9909fef2695386dce787fe60baa82aeea3bb1470bdb244eaa9b8)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareResizeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__58a415424a494ebafa2403cbc07ae55ecd4631ec63a42f9244e8c2e5a959b555)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__46f588dadf5939a7df1e7d8ee61e2b819c24332e428662c2dd8f2ac6e568ffa5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1539dd6cd16fb0274ed7dec9dd3b73306aec61fb05181662cc29505dcfc968ff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareResize]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareResize]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareResize]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__db6a03bccee55805e6fe63780ba9e86b5013b1a13706399facb08a710685b42e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareResizeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareResizeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__17a1f468a9097e52aa0e0c9aba43e65d9c010ba4120872b66bc301e946f953dc)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAspect")
    def reset_aspect(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspect", []))

    @jsii.member(jsii_name="resetAspectVar")
    def reset_aspect_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspectVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="aspectInput")
    def aspect_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "aspectInput"))

    @builtins.property
    @jsii.member(jsii_name="aspectVarInput")
    def aspect_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "aspectVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="aspect")
    def aspect(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "aspect"))

    @aspect.setter
    def aspect(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d53506e3607e155e7e2214c46a8c41a6c7ab6e0f2bea1c365dcc42431e98cf1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "aspect", value)

    @builtins.property
    @jsii.member(jsii_name="aspectVar")
    def aspect_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "aspectVar"))

    @aspect_var.setter
    def aspect_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2eeecede5ce23ecfb3753c44d69bc47847bf934a27ba701a69053295e6f9f058)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "aspectVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7c5cb70dbc4760ce59cf0126dc17b42fe8795dc20aa43d500a940a29012733a4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4046b51d1378eef5dd86efd1690d46ccbd6cbfc9054826d6671fd19f289e49ec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1ff36a185f206781dca1a0ec7a37120d8e77ae0217b8009ed690714893213570)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__43bff4498304f97d00bc6211b802c1463ad4cc18a96d6de51ae72c30307c6fd3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f8c1e7cd943dc1065779ec1dd9d4f797a1e2c8061cf666f4049e6624929ca6a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__49bf8837c6d75dbefabd3c6aaacef991a90107008167807447849e0aa36745ea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareResize]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareResize]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareResize]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5d91c7c0c8728191203a34caabb69eaf8a13c9234caf9f5942d165cdf2b68efb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRotate",
    jsii_struct_bases=[],
    name_mapping={"degrees": "degrees", "degrees_var": "degreesVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRotate:
    def __init__(
        self,
        *,
        degrees: typing.Optional[builtins.str] = None,
        degrees_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param degrees: The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees DataAkamaiImagingPolicyImage#degrees}
        :param degrees_var: The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees_var DataAkamaiImagingPolicyImage#degrees_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__490fe241235e8436b2ddd7e4011e49522494399ca088f6e242c7782bccffecd2)
            check_type(argname="argument degrees", value=degrees, expected_type=type_hints["degrees"])
            check_type(argname="argument degrees_var", value=degrees_var, expected_type=type_hints["degrees_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if degrees is not None:
            self._values["degrees"] = degrees
        if degrees_var is not None:
            self._values["degrees_var"] = degrees_var

    @builtins.property
    def degrees(self) -> typing.Optional[builtins.str]:
        '''The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees DataAkamaiImagingPolicyImage#degrees}
        '''
        result = self._values.get("degrees")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def degrees_var(self) -> typing.Optional[builtins.str]:
        '''The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees_var DataAkamaiImagingPolicyImage#degrees_var}
        '''
        result = self._values.get("degrees_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRotate(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRotateList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRotateList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__64e20c995dc2a9aa7eff80089cd3df86684af432562ed0e718ef5e0d2b5f0ec8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRotateOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a2bd18876e61cda7dfd4ade0d8149c7cba096e70fc98a63f2dc08dc49280f894)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRotateOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__52732ccc62c22a5840e126bbf7229dde9ed00bd125a21499bc6de31330c3aff6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d11ba7d19c9327365e8987698b49633b8ed7cb223bc1dd0e346399481631e1f5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3d3157c3bcce8289d8dd2cb39bf7dcc11312179f2152b73679814d23800552b6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRotate]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRotate]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRotate]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__835ca21320ba8eb8ebf7744fa9d2a593fc02001149b793d851aa971c558738b9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRotateOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRotateOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__27323e564ab3a04138cf5f3b35ad2f7b2b58b1428198c21bff5acf0024a5d897)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetDegrees")
    def reset_degrees(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDegrees", []))

    @jsii.member(jsii_name="resetDegreesVar")
    def reset_degrees_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDegreesVar", []))

    @builtins.property
    @jsii.member(jsii_name="degreesInput")
    def degrees_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "degreesInput"))

    @builtins.property
    @jsii.member(jsii_name="degreesVarInput")
    def degrees_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "degreesVarInput"))

    @builtins.property
    @jsii.member(jsii_name="degrees")
    def degrees(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "degrees"))

    @degrees.setter
    def degrees(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__702e0ad74be1e13606a54115b956f0f578949b4ea78fc174f1f58f938ba01f2c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "degrees", value)

    @builtins.property
    @jsii.member(jsii_name="degreesVar")
    def degrees_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "degreesVar"))

    @degrees_var.setter
    def degrees_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6cc4a51d86e80e2640c2df9dc20c6a4628711788c4bd4d1864e79dd4a1b9cd4c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "degreesVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRotate]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRotate]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRotate]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ccd759372b9a1a7e75a094fdaa52797af4953b94f48cb6cc7a0f6ec48ced97b3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareScale",
    jsii_struct_bases=[],
    name_mapping={
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareScale:
    def __init__(
        self,
        *,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param height: Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged. Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged. Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__56350ad2902e3610415eeb2cea8b9bca3e2006c014f7dfe5db80b157e426d95d)
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size.

        Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size.

        Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged.

        Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged.

        Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareScale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareScaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareScaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__91083da90216212da3ce91bd11799dea197d58fca5ce4f9d65435eeb45a44313)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareScaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e50a8e41f5949be402d5e6e96ecb49045d2fc461f605e041b7fd26769789a965)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareScaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2c99fd73625652fe78933cc30e04946f1c6e7ecc15dfdd797046154d1d47169a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f124e1748ee53d82f9f785500ca2e7c1ce2c3a333ee2daf5a98e99f4608ccf44)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__15faa0f34b4eb198c777b27b315bbb10b79e9441d4b070c7a05d07ff3e8d55c2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareScale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareScale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareScale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a798d282f0960c9d91e0d2aa8aa8f25502e06bd3079bb90033745e021c608da7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareScaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareScaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d84de07988b59b34afb6db5e646b4f4bb34851e0f2a9c6b3036ef2e59faf530)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__31ac5bc781d12cb0cce447480990540781c7a3a655d1fd80da5afa5c6b515d6b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2dbef6e8609b3e31894072614f0d22e2fed1ec3fbc24412e2b93c0d5fbcd5a98)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a8e923a92f75fd771b60deed93429d219a6437324194b81262e6875df0d48ea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8cdb30bab8fa8824ea872fd1342b5b11391039047d4e9e3bc445e962c3202d0d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareScale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareScale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareScale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dcf26ac006869c6a04a16894dfa58b34835041825a395a648a01c4e5853262d1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareShear",
    jsii_struct_bases=[],
    name_mapping={
        "x_shear": "xShear",
        "x_shear_var": "xShearVar",
        "y_shear": "yShear",
        "y_shear_var": "yShearVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareShear:
    def __init__(
        self,
        *,
        x_shear: typing.Optional[builtins.str] = None,
        x_shear_var: typing.Optional[builtins.str] = None,
        y_shear: typing.Optional[builtins.str] = None,
        y_shear_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param x_shear: The amount to shear along the x-axis, measured in multiples of the image's width. Must be set if yShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear DataAkamaiImagingPolicyImage#x_shear}
        :param x_shear_var: The amount to shear along the x-axis, measured in multiples of the image's width. Must be set if yShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear_var DataAkamaiImagingPolicyImage#x_shear_var}
        :param y_shear: The amount to shear along the y-axis, measured in multiples of the image's height. Must be set if xShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear DataAkamaiImagingPolicyImage#y_shear}
        :param y_shear_var: The amount to shear along the y-axis, measured in multiples of the image's height. Must be set if xShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear_var DataAkamaiImagingPolicyImage#y_shear_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8506ba815e6e19d76003c94179ebc088432bb77860f5eaaab8f236947e5cf66e)
            check_type(argname="argument x_shear", value=x_shear, expected_type=type_hints["x_shear"])
            check_type(argname="argument x_shear_var", value=x_shear_var, expected_type=type_hints["x_shear_var"])
            check_type(argname="argument y_shear", value=y_shear, expected_type=type_hints["y_shear"])
            check_type(argname="argument y_shear_var", value=y_shear_var, expected_type=type_hints["y_shear_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if x_shear is not None:
            self._values["x_shear"] = x_shear
        if x_shear_var is not None:
            self._values["x_shear_var"] = x_shear_var
        if y_shear is not None:
            self._values["y_shear"] = y_shear
        if y_shear_var is not None:
            self._values["y_shear_var"] = y_shear_var

    @builtins.property
    def x_shear(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the x-axis, measured in multiples of the image's width.

        Must be set if yShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear DataAkamaiImagingPolicyImage#x_shear}
        '''
        result = self._values.get("x_shear")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_shear_var(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the x-axis, measured in multiples of the image's width.

        Must be set if yShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear_var DataAkamaiImagingPolicyImage#x_shear_var}
        '''
        result = self._values.get("x_shear_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_shear(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the y-axis, measured in multiples of the image's height.

        Must be set if xShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear DataAkamaiImagingPolicyImage#y_shear}
        '''
        result = self._values.get("y_shear")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_shear_var(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the y-axis, measured in multiples of the image's height.

        Must be set if xShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear_var DataAkamaiImagingPolicyImage#y_shear_var}
        '''
        result = self._values.get("y_shear_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareShear(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareShearList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareShearList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b02a569dfd782a9c27039a77e6468fe7f64ffb994877fd9d825b690ad6873832)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareShearOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b97f87fa8fc561365eaab5eac471ba7517419995e0ae3e9ad18c74a80bce09ab)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareShearOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6beaedf2345bf393e083c557621acec8439c7af1bce06cbb08507140f58b6015)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8578a818d5848f284713ce0684a1622a718c47ab45f93a4119b63472bfe28c56)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0616ea83e7709215e2be417d9371152ed7c2e8b40331a47d67bf272a5c858813)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareShear]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareShear]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareShear]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c4549a43bfef4d638374d1f208a328c784e00102a1e572a6c464ec890554ea9d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareShearOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareShearOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c19028514661e3930b9cad9c7294642b55b909e2164138cf025b44895bd7c2b1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetXShear")
    def reset_x_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXShear", []))

    @jsii.member(jsii_name="resetXShearVar")
    def reset_x_shear_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXShearVar", []))

    @jsii.member(jsii_name="resetYShear")
    def reset_y_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYShear", []))

    @jsii.member(jsii_name="resetYShearVar")
    def reset_y_shear_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYShearVar", []))

    @builtins.property
    @jsii.member(jsii_name="xShearInput")
    def x_shear_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xShearInput"))

    @builtins.property
    @jsii.member(jsii_name="xShearVarInput")
    def x_shear_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xShearVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yShearInput")
    def y_shear_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yShearInput"))

    @builtins.property
    @jsii.member(jsii_name="yShearVarInput")
    def y_shear_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yShearVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xShear")
    def x_shear(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xShear"))

    @x_shear.setter
    def x_shear(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e1e257eac9c941e11e6aeefaba77ce6f2998fa44c766ecf6678551f009fce22)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xShear", value)

    @builtins.property
    @jsii.member(jsii_name="xShearVar")
    def x_shear_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xShearVar"))

    @x_shear_var.setter
    def x_shear_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7484162658816bf0f0970ee92d5c1c8c12615da904d30660bc31d4bf4ebb7e75)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xShearVar", value)

    @builtins.property
    @jsii.member(jsii_name="yShear")
    def y_shear(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yShear"))

    @y_shear.setter
    def y_shear(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ba047996d23d1f894f6ad7752462a4c02b82e92b0dde6cfadf4df781978f5846)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yShear", value)

    @builtins.property
    @jsii.member(jsii_name="yShearVar")
    def y_shear_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yShearVar"))

    @y_shear_var.setter
    def y_shear_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__764653f3586fe8772dc6f5d81463b8bbbf13f3c348f6eccc48a0a78771308ba4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yShearVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareShear]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareShear]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareShear]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c1499495133e05bc74e0fb7872e6188dfbf093040ea9c7607da0fe9c61532cb2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareTrim",
    jsii_struct_bases=[],
    name_mapping={
        "fuzz": "fuzz",
        "fuzz_var": "fuzzVar",
        "padding": "padding",
        "padding_var": "paddingVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareTrim:
    def __init__(
        self,
        *,
        fuzz: typing.Optional[builtins.str] = None,
        fuzz_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fuzz: The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz DataAkamaiImagingPolicyImage#fuzz}
        :param fuzz_var: The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz_var DataAkamaiImagingPolicyImage#fuzz_var}
        :param padding: The amount of padding in pixels to add to the trimmed image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: The amount of padding in pixels to add to the trimmed image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__daf52c3ebe58c873434e0b791233f16ef6912cd20cf10d40f6d575763ca247e0)
            check_type(argname="argument fuzz", value=fuzz, expected_type=type_hints["fuzz"])
            check_type(argname="argument fuzz_var", value=fuzz_var, expected_type=type_hints["fuzz_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fuzz is not None:
            self._values["fuzz"] = fuzz
        if fuzz_var is not None:
            self._values["fuzz_var"] = fuzz_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var

    @builtins.property
    def fuzz(self) -> typing.Optional[builtins.str]:
        '''The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz DataAkamaiImagingPolicyImage#fuzz}
        '''
        result = self._values.get("fuzz")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fuzz_var(self) -> typing.Optional[builtins.str]:
        '''The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz_var DataAkamaiImagingPolicyImage#fuzz_var}
        '''
        result = self._values.get("fuzz_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''The amount of padding in pixels to add to the trimmed image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''The amount of padding in pixels to add to the trimmed image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareTrim(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareTrimList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareTrimList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__97e394c12fc251902456820507908529f14ed367be0b63a6f052b7bc4e539c59)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareTrimOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__476470725fc0f05ac3014c6c18d5561b6db3e5acbcb5d857549033d7044709f5)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareTrimOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__950a9bf239d0d5ff238c59202bc80429d1cae4ad03ed640c1a3ec73d7ba57f1f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__754a8e58dad4dd5055a0755cc3a08dc3b9c268639d04e31a15172848b22e2dcc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e0e5f453ce38e264c4b022dcc8344dbaa040d86ffd1fd7653527c1d4d8274c9b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareTrim]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareTrim]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareTrim]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1c4598e8cf9e44d6f438ef02a70d88d66ec978b15e61c94c9ce70a917341621c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareTrimOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareTrimOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7db67c8b02d8977ccdbc4394e8b5d9ecb342afcad736310940ec2c3dbde68797)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetFuzz")
    def reset_fuzz(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFuzz", []))

    @jsii.member(jsii_name="resetFuzzVar")
    def reset_fuzz_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFuzzVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @builtins.property
    @jsii.member(jsii_name="fuzzInput")
    def fuzz_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fuzzInput"))

    @builtins.property
    @jsii.member(jsii_name="fuzzVarInput")
    def fuzz_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fuzzVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="fuzz")
    def fuzz(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fuzz"))

    @fuzz.setter
    def fuzz(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b1ede33fe522b1e586f0a7a1884050ed55194a09ead6c8b18c42a454acc9b79c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fuzz", value)

    @builtins.property
    @jsii.member(jsii_name="fuzzVar")
    def fuzz_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fuzzVar"))

    @fuzz_var.setter
    def fuzz_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2de848a9fd0451b2b3de13029ae0d8df6b4719ffec21bbf889b186e4dc386807)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fuzzVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__917bf228a1894d62494c4b1b2fabb3cdd998a49a84ee0d0d962ee84fd7b66d04)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__20b3e1d313e5839ff543de1baa6d7d3e7e8794f60a16af2f7289cac5423f4238)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareTrim]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareTrim]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareTrim]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b9c596e07a732d2e759bf652623c72368d7b09bbfb2be501bde44ea837df7c6b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareUnsharpMask",
    jsii_struct_bases=[],
    name_mapping={
        "gain": "gain",
        "gain_var": "gainVar",
        "sigma": "sigma",
        "sigma_var": "sigmaVar",
        "threshold": "threshold",
        "threshold_var": "thresholdVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareUnsharpMask:
    def __init__(
        self,
        *,
        gain: typing.Optional[builtins.str] = None,
        gain_var: typing.Optional[builtins.str] = None,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
        threshold: typing.Optional[builtins.str] = None,
        threshold_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param gain: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        :param gain_var: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        :param sigma: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        :param threshold: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        :param threshold_var: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__21ecb851d93f4d6a112140c90ecf5ae93e4983fb10ecfe99adcf4d4cfedcecd6)
            check_type(argname="argument gain", value=gain, expected_type=type_hints["gain"])
            check_type(argname="argument gain_var", value=gain_var, expected_type=type_hints["gain_var"])
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
            check_type(argname="argument threshold", value=threshold, expected_type=type_hints["threshold"])
            check_type(argname="argument threshold_var", value=threshold_var, expected_type=type_hints["threshold_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if gain is not None:
            self._values["gain"] = gain
        if gain_var is not None:
            self._values["gain_var"] = gain_var
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var
        if threshold is not None:
            self._values["threshold"] = threshold
        if threshold_var is not None:
            self._values["threshold_var"] = threshold_var

    @builtins.property
    def gain(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        '''
        result = self._values.get("gain")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gain_var(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        '''
        result = self._values.get("gain_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        '''
        result = self._values.get("threshold")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold_var(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        result = self._values.get("threshold_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareUnsharpMask(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareUnsharpMaskList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareUnsharpMaskList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2c9444b7cef8026648023d03b3037bd72adfb6d110ba893dec7c1c5c1412c797)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareUnsharpMaskOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__81c8b6606067820ff3a524583a88c36f4e57ffc007e21edd46b10a241848ba1a)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareUnsharpMaskOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e7d5e70a276d8ebc69c0beb9a2990fb6828955ab87839f452c0ff2c520d9e337)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__beee976d53e379ec1eb9ebe7b1911ca89da3ce815ba5e42c9956123ec7633ae4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7a3dbc765916541d763e4f942bc2e13327f9ad9bba9ef3d845a69d4b058194e9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareUnsharpMask]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareUnsharpMask]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareUnsharpMask]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c143943c09930797e04cafb19fc629432ae8cd6b30a8e7f703785ac5dbd831ab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareUnsharpMaskOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareUnsharpMaskOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f3378ef3b8558fb85c37dfd3e00487f2fe610e4595bf6a4c307b74426ca00bed)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetGain")
    def reset_gain(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGain", []))

    @jsii.member(jsii_name="resetGainVar")
    def reset_gain_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGainVar", []))

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @jsii.member(jsii_name="resetThreshold")
    def reset_threshold(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThreshold", []))

    @jsii.member(jsii_name="resetThresholdVar")
    def reset_threshold_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThresholdVar", []))

    @builtins.property
    @jsii.member(jsii_name="gainInput")
    def gain_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainInput"))

    @builtins.property
    @jsii.member(jsii_name="gainVarInput")
    def gain_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdInput")
    def threshold_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdVarInput")
    def threshold_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gain")
    def gain(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gain"))

    @gain.setter
    def gain(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9aa6bba1a3af4703fe4183479b39342ce68dbf9ccb85aa4d175dca7c01e922bf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gain", value)

    @builtins.property
    @jsii.member(jsii_name="gainVar")
    def gain_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gainVar"))

    @gain_var.setter
    def gain_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1dc42ae89002d21d3106eeff7d9e42f751edba983cec0bd9eecc603224f9dd92)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gainVar", value)

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e782f841a63133f97bcf6391f23e6f4785299728a6ff38c9de3849728d40fc53)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ad04996e40b72affb7114561b107071387598eab8d5dfd8dfd1fcb5627003fd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="threshold")
    def threshold(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "threshold"))

    @threshold.setter
    def threshold(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a6489ad56011dd5cb0832a78a3813d762e045e5ea2f3ea27eb8cb2b1d0d166d7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "threshold", value)

    @builtins.property
    @jsii.member(jsii_name="thresholdVar")
    def threshold_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "thresholdVar"))

    @threshold_var.setter
    def threshold_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__edeb3fdb0858a7141ea7e4319830e6741e9b93718e7f3bbcb1780bc3afc54a9a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "thresholdVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareUnsharpMask]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareUnsharpMask]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareUnsharpMask]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f48a2ddf5a3757d046b4982e3a1d8a0fffd571a319e73d8c89321eae16b9ec76)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsImQuery",
    jsii_struct_bases=[],
    name_mapping={
        "allowed_transformations": "allowedTransformations",
        "query_var": "queryVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsImQuery:
    def __init__(
        self,
        *,
        allowed_transformations: typing.Sequence[builtins.str],
        query_var: builtins.str,
    ) -> None:
        '''
        :param allowed_transformations: Specifies the transformations that can be applied using the query string parameter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allowed_transformations DataAkamaiImagingPolicyImage#allowed_transformations}
        :param query_var: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#query_var DataAkamaiImagingPolicyImage#query_var}.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6aac8d30ab6e91d7c53aa966d226c8d069eecdc1491d2068f110c49d19d37844)
            check_type(argname="argument allowed_transformations", value=allowed_transformations, expected_type=type_hints["allowed_transformations"])
            check_type(argname="argument query_var", value=query_var, expected_type=type_hints["query_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "allowed_transformations": allowed_transformations,
            "query_var": query_var,
        }

    @builtins.property
    def allowed_transformations(self) -> typing.List[builtins.str]:
        '''Specifies the transformations that can be applied using the query string parameter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allowed_transformations DataAkamaiImagingPolicyImage#allowed_transformations}
        '''
        result = self._values.get("allowed_transformations")
        assert result is not None, "Required property 'allowed_transformations' is missing"
        return typing.cast(typing.List[builtins.str], result)

    @builtins.property
    def query_var(self) -> builtins.str:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#query_var DataAkamaiImagingPolicyImage#query_var}.'''
        result = self._values.get("query_var")
        assert result is not None, "Required property 'query_var' is missing"
        return typing.cast(builtins.str, result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsImQuery(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsImQueryList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsImQueryList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__68f4277ad571134eba56df2b556c7f668fc883c12425594ad4a37c6661078a90)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsImQueryOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6160ceb4407a7fa11bcac96fce033119259ca1576aec3e339ea51a47ee2d5462)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsImQueryOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7e8d6ab9990fd3946838589e33dca047e2a4fad895bd79a8bae1b02a78e27e94)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__917dea640acbf03578a14013f0d3da8e25f550ab42c30c2e144519c508dd4379)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__876abbc913e0cca6c365f833d704ace09a49bf0b55fe9dc23e7b726407e2c424)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsImQuery]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsImQuery]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsImQuery]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__57fa0f7d5f6971f40bebf41a38737b06fcb9e5bf6a34e2736fc5ac09d1164232)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsImQueryOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsImQueryOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ad7aead91c1f80f722bcc8e920119ca3e434fa0cada5e547e9ae3140436c9433)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @builtins.property
    @jsii.member(jsii_name="allowedTransformationsInput")
    def allowed_transformations_input(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "allowedTransformationsInput"))

    @builtins.property
    @jsii.member(jsii_name="queryVarInput")
    def query_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "queryVarInput"))

    @builtins.property
    @jsii.member(jsii_name="allowedTransformations")
    def allowed_transformations(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "allowedTransformations"))

    @allowed_transformations.setter
    def allowed_transformations(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__59cba24fcfde9a97f7d375f46c5b34a0a377769e66f7b7cda80c9c0e32cd83aa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowedTransformations", value)

    @builtins.property
    @jsii.member(jsii_name="queryVar")
    def query_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "queryVar"))

    @query_var.setter
    def query_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc281a5c3633ad5da2d457528258b3705b3d9b3eb29c86a225f2e764df0f3403)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "queryVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsImQuery]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsImQuery]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsImQuery]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d9be9df8b9e71d9fd07205545cd59e28b4c4505e0c21d829f0764bc428f73dc5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f97848704b548c629048ed10db2150114e6042e071412c1ca454dcc194cbba7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__53c455d74167d0cfa8b22d57930c9485cde6460ca240ef7935b03121190e669f)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f0c9a586592863794d0871342d06192d8202436aafb891124e1e5bfd79372a0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0d97720645b1f7215c10ba2e64e95cc73873518df6812af419705676aae5d250)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__553a7167fbd812c41084b53a143df341a39535ebc37cf8781fd67091fa5ec843)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformations]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformations]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformations]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__215075f55328e0ab10be3724c84ab6b5db21285cb62841910c98146e47b50e7e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsMaxColors",
    jsii_struct_bases=[],
    name_mapping={"colors": "colors", "colors_var": "colorsVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsMaxColors:
    def __init__(
        self,
        *,
        colors: typing.Optional[builtins.str] = None,
        colors_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param colors: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        :param colors_var: The value representing the maximum number of colors to use with the source image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__463a42741b00d4bd47b418ada9946c3c1839f57edba79970a059e92cd72fd8e5)
            check_type(argname="argument colors", value=colors, expected_type=type_hints["colors"])
            check_type(argname="argument colors_var", value=colors_var, expected_type=type_hints["colors_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if colors is not None:
            self._values["colors"] = colors
        if colors_var is not None:
            self._values["colors_var"] = colors_var

    @builtins.property
    def colors(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
        '''
        result = self._values.get("colors")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def colors_var(self) -> typing.Optional[builtins.str]:
        '''The value representing the maximum number of colors to use with the source image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
        '''
        result = self._values.get("colors_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsMaxColors(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsMaxColorsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsMaxColorsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9044d059f56949ca234cc94c6ece4befdb20ef82359ad788a17fa40327533dbd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsMaxColorsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__61558af0df35a38c0c0e41e54cb6c05cb78cca83ed02d59a7f90fff5c941fbc3)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsMaxColorsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1912cdb02442b98c90319a475acfc21f20b32e0a515f6a3dd1d9757c0c8e6aa0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__39841fbe4e8b2b9fcfc91a0d6d02c7e24559004caabc209a39971f1a18badffe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bf630be8c18b940e7c922964225590aa6ea4fd868102cdca58c8693ff25d93e0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsMaxColors]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsMaxColors]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c85344d41cfc28a5be62f8ac2852b0b5879f0ec062a9fa0f62c5cfbad45c30d2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsMaxColorsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsMaxColorsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2e6b4c0c3acf321d1cfe74870caccc733fcf3e084bfe4fc424713541d70d5c87)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColors")
    def reset_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColors", []))

    @jsii.member(jsii_name="resetColorsVar")
    def reset_colors_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorsVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorsInput")
    def colors_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsInput"))

    @builtins.property
    @jsii.member(jsii_name="colorsVarInput")
    def colors_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorsVarInput"))

    @builtins.property
    @jsii.member(jsii_name="colors")
    def colors(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colors"))

    @colors.setter
    def colors(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6b6981e782582a3e3094454dd4391acb40bb455ac2b30946fdd751336abed681)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colors", value)

    @builtins.property
    @jsii.member(jsii_name="colorsVar")
    def colors_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorsVar"))

    @colors_var.setter
    def colors_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__04ec9d3dbb5c6274da35d90f5287802a676c127b4f4eb352ca98814a893b5607)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorsVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsMaxColors]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsMaxColors]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsMaxColors]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__10de39a9040e36f54b41bde6848b16c48d7492e947eaa667fee01620b49134cd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsMirror",
    jsii_struct_bases=[],
    name_mapping={
        "horizontal": "horizontal",
        "horizontal_var": "horizontalVar",
        "vertical": "vertical",
        "vertical_var": "verticalVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsMirror:
    def __init__(
        self,
        *,
        horizontal: typing.Optional[builtins.str] = None,
        horizontal_var: typing.Optional[builtins.str] = None,
        vertical: typing.Optional[builtins.str] = None,
        vertical_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param horizontal: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        :param horizontal_var: Flips the image horizontally. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        :param vertical: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        :param vertical_var: Flips the image vertically. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5422cca463be1ccef96fd0c578130f4da460f88b7d78d37190272b34d3a6d2e1)
            check_type(argname="argument horizontal", value=horizontal, expected_type=type_hints["horizontal"])
            check_type(argname="argument horizontal_var", value=horizontal_var, expected_type=type_hints["horizontal_var"])
            check_type(argname="argument vertical", value=vertical, expected_type=type_hints["vertical"])
            check_type(argname="argument vertical_var", value=vertical_var, expected_type=type_hints["vertical_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if horizontal is not None:
            self._values["horizontal"] = horizontal
        if horizontal_var is not None:
            self._values["horizontal_var"] = horizontal_var
        if vertical is not None:
            self._values["vertical"] = vertical
        if vertical_var is not None:
            self._values["vertical_var"] = vertical_var

    @builtins.property
    def horizontal(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
        '''
        result = self._values.get("horizontal")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def horizontal_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image horizontally.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
        '''
        result = self._values.get("horizontal_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
        '''
        result = self._values.get("vertical")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vertical_var(self) -> typing.Optional[builtins.str]:
        '''Flips the image vertically.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
        '''
        result = self._values.get("vertical_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsMirror(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsMirrorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsMirrorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__84deea7159074a2b6070777df676111d03cc83b58f0460594fa25e8d4638631d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsMirrorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__50341caf5f47b96757d175d86565c27812b58cc2c680aa5c8df1e4e1eb8c5a5a)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsMirrorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__50a682850866cee46c3b1ad9c4e61e4413df8c5e711497a6a170b4e30fbed81f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__93a7d8ea663c67ce865584e9a06b28f6303307ab5ad75ccfbc194db57061ecad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__22ee30d45489a2d3700d737bbe2b74d1886fbf8e02c0c49dc5f9100296980414)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsMirror]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsMirror]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1530352b5d9f0212c543413715269b76cd39f3eb78adc58ef35fb377aa242039)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsMirrorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsMirrorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d5a99f2192c72677f5ec860ccad2220ae4a264a097352f5d4766cf653cfadfc6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHorizontal")
    def reset_horizontal(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontal", []))

    @jsii.member(jsii_name="resetHorizontalVar")
    def reset_horizontal_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHorizontalVar", []))

    @jsii.member(jsii_name="resetVertical")
    def reset_vertical(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVertical", []))

    @jsii.member(jsii_name="resetVerticalVar")
    def reset_vertical_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVerticalVar", []))

    @builtins.property
    @jsii.member(jsii_name="horizontalInput")
    def horizontal_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontalVarInput")
    def horizontal_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "horizontalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalInput")
    def vertical_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalInput"))

    @builtins.property
    @jsii.member(jsii_name="verticalVarInput")
    def vertical_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verticalVarInput"))

    @builtins.property
    @jsii.member(jsii_name="horizontal")
    def horizontal(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontal"))

    @horizontal.setter
    def horizontal(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6096236110857e4816277fe477f037ff2c3014e40e72bd7f5dd7fa610cc4679a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontal", value)

    @builtins.property
    @jsii.member(jsii_name="horizontalVar")
    def horizontal_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "horizontalVar"))

    @horizontal_var.setter
    def horizontal_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1475fec58af67fc0cbdea95c59e4e4fb32ea3fb4c57ba5f10214f7bce0589909)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "horizontalVar", value)

    @builtins.property
    @jsii.member(jsii_name="vertical")
    def vertical(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "vertical"))

    @vertical.setter
    def vertical(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__766ad9c7c910560270d4779e735e28b1d894c21be24dfbb09e11e62051ef7426)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "vertical", value)

    @builtins.property
    @jsii.member(jsii_name="verticalVar")
    def vertical_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "verticalVar"))

    @vertical_var.setter
    def vertical_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5365b4a44c60ddff3f3b583c332dc60f3b0ed78aae300f348cc92be1c1835791)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "verticalVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsMirror]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsMirror]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsMirror]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c7b339b91235872b00487d06b3c4e27d39f77f551f318ed733ff2b9463d10c98)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsMonoHue",
    jsii_struct_bases=[],
    name_mapping={"hue": "hue", "hue_var": "hueVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsMonoHue:
    def __init__(
        self,
        *,
        hue: typing.Optional[builtins.str] = None,
        hue_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hue: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        :param hue_var: Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a434879ded1c642c0f5d216a14b9c6833a1f8102b577f9f03cef5c895e513126)
            check_type(argname="argument hue", value=hue, expected_type=type_hints["hue"])
            check_type(argname="argument hue_var", value=hue_var, expected_type=type_hints["hue_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hue is not None:
            self._values["hue"] = hue
        if hue_var is not None:
            self._values["hue_var"] = hue_var

    @builtins.property
    def hue(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
        '''
        result = self._values.get("hue")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hue_var(self) -> typing.Optional[builtins.str]:
        '''Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel.

        By default Mono Hue applies a red hue, 0.0 on the color wheel.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
        '''
        result = self._values.get("hue_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsMonoHue(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsMonoHueList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsMonoHueList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__41633f69a8a49c1ce4fc76cfff44f952cfb7cf7e3dc683e5811bcbd0f53e2ed1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsMonoHueOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__344c29f9bdd1b224d3a0e7878458b3dc376bbb1283139a757e89beed8c0e1c3c)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsMonoHueOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6df8428342686916cf5befe1ccb234ba96f5a83e23882e6b5099826aff4e1131)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b472892062c73fe48e8dcf7b953e7e28dd0d2e4b6e63bd36b00c5d69d31ab6b3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9b9ff33b6600dbe25477880ef63e4847504548fd5e113b56e678cc6d634bf0cd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsMonoHue]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsMonoHue]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__833047dfbf0a6e9ac5d9965eb73ed6300a7a6b243e5b8f2ce2c54c1d85483561)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsMonoHueOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsMonoHueOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be44d11050db0c004cbb2af859a7b95e4ea9d36fac99a48c4833860a66a7ed90)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHue")
    def reset_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHue", []))

    @jsii.member(jsii_name="resetHueVar")
    def reset_hue_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHueVar", []))

    @builtins.property
    @jsii.member(jsii_name="hueInput")
    def hue_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueInput"))

    @builtins.property
    @jsii.member(jsii_name="hueVarInput")
    def hue_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hueVarInput"))

    @builtins.property
    @jsii.member(jsii_name="hue")
    def hue(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hue"))

    @hue.setter
    def hue(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f8fb4851a6a392f2308943940af180f9018d176ad8d2ef5c157474b04e1a8c7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hue", value)

    @builtins.property
    @jsii.member(jsii_name="hueVar")
    def hue_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hueVar"))

    @hue_var.setter
    def hue_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c53234ca190c04ff42a835cdfabc837bf71dc03a8d074b182cee7c82fd14c234)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hueVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsMonoHue]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsMonoHue]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsMonoHue]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0c6b4e9c999f76b2af74036f26748a8b69f6939ff19b6953ec45eddacc7ef0c7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsOpacity",
    jsii_struct_bases=[],
    name_mapping={"opacity": "opacity", "opacity_var": "opacityVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsOpacity:
    def __init__(
        self,
        *,
        opacity: typing.Optional[builtins.str] = None,
        opacity_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param opacity: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        :param opacity_var: Represents alpha values on a scale of ``0`` to ``1``. Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b85d24bdc280038ffbe67970f665ec080ee7e7718b9233b3ee94384743811dd1)
            check_type(argname="argument opacity", value=opacity, expected_type=type_hints["opacity"])
            check_type(argname="argument opacity_var", value=opacity_var, expected_type=type_hints["opacity_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if opacity is not None:
            self._values["opacity"] = opacity
        if opacity_var is not None:
            self._values["opacity_var"] = opacity_var

    @builtins.property
    def opacity(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
        '''
        result = self._values.get("opacity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def opacity_var(self) -> typing.Optional[builtins.str]:
        '''Represents alpha values on a scale of ``0`` to ``1``.

        Values below ``1`` increase transparency, and ``0`` is invisible. For images that have some transparency, values above ``1`` increase the opacity of the transparent portions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
        '''
        result = self._values.get("opacity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsOpacity(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsOpacityList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsOpacityList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c374d96ab5832ce9cb48d228e1414983242077dd15389a52f30ee2308858e3d8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsOpacityOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c06c85dfa3a482329ae011ac0b6af162ca6f6151b0229a8d0d075d35fafe3ca0)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsOpacityOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9b3cbca4408c29256ed421c41ffe87b6a761706203b4078b123d65191c27c689)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__76a71c670f6722657af6c2619d410cb81d190af605117ee2a4c4924e88977c08)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__78f6209188fe1e9ddf002d31d2596a3dad554d6cb166b668c57cd3d81b58b85f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsOpacity]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsOpacity]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__77cfbc793fe294336f6bb0c2e18fd77a6b1b0beea1e78e987eb2b1e4cb7436ec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsOpacityOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsOpacityOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e992e767134d7fc9599ed36fd6aaf12f10273095d70ff3a4227e1411599b5c85)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetOpacityVar")
    def reset_opacity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacityVar", []))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityVarInput")
    def opacity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "opacityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacity"))

    @opacity.setter
    def opacity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8d3d1469788de962a4c7a2e7574f7a66522477adb3a6588adfc0c6a267e7be7e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacity", value)

    @builtins.property
    @jsii.member(jsii_name="opacityVar")
    def opacity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "opacityVar"))

    @opacity_var.setter
    def opacity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b6a08a6a8da41f9a6147c5a2d0f4f8916105411d5e9ae61644e4100e3db600d3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "opacityVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsOpacity]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsOpacity]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsOpacity]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d7399403b38ebe3649c3144248b8419788df6ddc4f6290a20ed8e93753293790)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b4a1a4d220d1358c0bd8f92b8b19c0e057590b9ce565d70dbf6fcb0effa67736)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putAppend")
    def put_append(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppend, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1bd8ade1e87c5c4540287ce65c073b306a4fc93c7a876832719e0e312c898c0e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putAppend", [value]))

    @jsii.member(jsii_name="putAspectCrop")
    def put_aspect_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAspectCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6bff1e1d17fa795c37128a2b604fcceb47cfc5b8c363101fd888f42597d1aef9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putAspectCrop", [value]))

    @jsii.member(jsii_name="putBackgroundColor")
    def put_background_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a80d1b0c650f9cf14cc4d8ca47b2504c6b1fbd1f9bf14a36e79169f410ed36ad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBackgroundColor", [value]))

    @jsii.member(jsii_name="putBlur")
    def put_blur(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsBlur, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9eff815fbb35c954dec497f6c1df6e3ce018d1c79def6aeb3dd161253b50efb1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBlur", [value]))

    @jsii.member(jsii_name="putChromaKey")
    def put_chroma_key(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsChromaKey, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__702dd316d224ac9cb7ec9b80bb24a5e9ac11b8e80f52ee79b65748d0a9b2bf39)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putChromaKey", [value]))

    @jsii.member(jsii_name="putComposite")
    def put_composite(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsComposite, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2c8701b87bc20ac85e798e6547fbeff73e2cc9cd3f9f65b47819b5db8e370895)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putComposite", [value]))

    @jsii.member(jsii_name="putCompound")
    def put_compound(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompound, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c1e80953c634210b0444ae804c10bacd2dfd62134157e73cfa5df76d2fbe728b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCompound", [value]))

    @jsii.member(jsii_name="putContrast")
    def put_contrast(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsContrast, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bab06ac29ddeef0f0f959f998aba9f600bca3906f006a556091e2741f0b262f3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putContrast", [value]))

    @jsii.member(jsii_name="putCrop")
    def put_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7c26ee3cad0e1f6658a23024d7b0a876146a491b8ade373ac8849ab031c7606d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCrop", [value]))

    @jsii.member(jsii_name="putFaceCrop")
    def put_face_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFaceCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f0093b9751dbec5a45cc4de2e718be6fbaa9568f6596bccb1341174af097a1fe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFaceCrop", [value]))

    @jsii.member(jsii_name="putFeatureCrop")
    def put_feature_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFeatureCrop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7ebdf97b3ec3e58fd077c19ed55cbd504651a0eb03a6a6b46779005441675e69)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFeatureCrop", [value]))

    @jsii.member(jsii_name="putFitAndFill")
    def put_fit_and_fill(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFill, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__95f68eb8808aeb051bde1cfea4f648cf04130653c32fb4ad8e2ee9b234cc7659)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFitAndFill", [value]))

    @jsii.member(jsii_name="putGoop")
    def put_goop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsGoop, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__70fe02f41a6f102b417b3f1f9575a0cc93745e5724e57ddbb74f32042113e27b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGoop", [value]))

    @jsii.member(jsii_name="putGrayscale")
    def put_grayscale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsGrayscale, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__37086956fd511d745b000fb802df85ae445590b9053d179015c3d4ca083661ad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putGrayscale", [value]))

    @jsii.member(jsii_name="putHsl")
    def put_hsl(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsHsl, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7905f54b28dceeb764a477a3e8cbca082773f5c4a9f86d4253a58d2c121735f5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsl", [value]))

    @jsii.member(jsii_name="putHsv")
    def put_hsv(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsHsv, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__39599bd47660a9b1531c53e0888f48f9118ab75c2d3e0b1b5326ca5a71360f83)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putHsv", [value]))

    @jsii.member(jsii_name="putIfDimension")
    def put_if_dimension(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimension, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__44375104d2580bdb6d264fd8008d56a83aa3de0fb50241118a5d502b52adca92)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfDimension", [value]))

    @jsii.member(jsii_name="putIfOrientation")
    def put_if_orientation(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b588e3dcd00b68e97d3be3f0be0474db3564333957a67fe195ebb300249d8e0b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putIfOrientation", [value]))

    @jsii.member(jsii_name="putImQuery")
    def put_im_query(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsImQuery, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__30b9191ed996d9e308b33b6c5dd713e4a63de0961bf4f5ea44cf59df67020f99)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putImQuery", [value]))

    @jsii.member(jsii_name="putMaxColors")
    def put_max_colors(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsMaxColors, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b3953424cf442d630a08c44f5511d470641880094817d87bc1b3e75d2a7f62c0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMaxColors", [value]))

    @jsii.member(jsii_name="putMirror")
    def put_mirror(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsMirror, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cec10298ffb708e4533c48a47c4da7458538c1123d8d2f5f1ab47855aab0cf67)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMirror", [value]))

    @jsii.member(jsii_name="putMonoHue")
    def put_mono_hue(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsMonoHue, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1b1e12ade469375737a901b070e2f44cf38f19e024a294a2a553f3ce84ee2ad0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putMonoHue", [value]))

    @jsii.member(jsii_name="putOpacity")
    def put_opacity(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsOpacity, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f3067fb9a5035db808eb131d0ad2d818d4e9e5673b319a7754f504fe121f4850)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putOpacity", [value]))

    @jsii.member(jsii_name="putRegionOfInterestCrop")
    def put_region_of_interest_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCrop", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cf363cd26034d21d77bcafdfe29b2653413347f0af1698fd81f8454c22670c6c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRegionOfInterestCrop", [value]))

    @jsii.member(jsii_name="putRelativeCrop")
    def put_relative_crop(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsRelativeCrop", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b6e3d6276a34a149f52d5b6298bc607e631cd95dc11b4da2ca0f61b895e9f37f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRelativeCrop", [value]))

    @jsii.member(jsii_name="putRemoveColor")
    def put_remove_color(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsRemoveColor", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__729c16d19f64adc5b79433f74dd577927ba84de8bcf71648f7987e60795c0fcc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRemoveColor", [value]))

    @jsii.member(jsii_name="putResize")
    def put_resize(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsResize", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__998893e8083cab251177e8fe961ec89f5f47456eb77571eec72dfea2718d822a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putResize", [value]))

    @jsii.member(jsii_name="putRotate")
    def put_rotate(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsRotate", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0361c23611648f70b6d55d08de2cac02a3d1b431d6f5fc85a900e8d1022be3c4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRotate", [value]))

    @jsii.member(jsii_name="putScale")
    def put_scale(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsScale", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__16c211cc140f4f2a52a6f9367317f00c4ba82e0f94131a23efc1029375ad06ad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putScale", [value]))

    @jsii.member(jsii_name="putShear")
    def put_shear(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsShear", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5a7d0028407e5a37bf6332866dfeac14d99e1f63e796bc830150977952c6eb99)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putShear", [value]))

    @jsii.member(jsii_name="putTrim")
    def put_trim(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsTrim", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3cc01b9bbfc200e00e4e6d0439468757b17e718442a3e79f09c3cb2278463c74)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putTrim", [value]))

    @jsii.member(jsii_name="putUnsharpMask")
    def put_unsharp_mask(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsUnsharpMask", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f19b7afddebcba07971902064ecf95e983c27eae86011ed656017feba95b843b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putUnsharpMask", [value]))

    @jsii.member(jsii_name="resetAppend")
    def reset_append(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAppend", []))

    @jsii.member(jsii_name="resetAspectCrop")
    def reset_aspect_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspectCrop", []))

    @jsii.member(jsii_name="resetBackgroundColor")
    def reset_background_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBackgroundColor", []))

    @jsii.member(jsii_name="resetBlur")
    def reset_blur(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBlur", []))

    @jsii.member(jsii_name="resetChromaKey")
    def reset_chroma_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChromaKey", []))

    @jsii.member(jsii_name="resetComposite")
    def reset_composite(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetComposite", []))

    @jsii.member(jsii_name="resetCompound")
    def reset_compound(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCompound", []))

    @jsii.member(jsii_name="resetContrast")
    def reset_contrast(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContrast", []))

    @jsii.member(jsii_name="resetCrop")
    def reset_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCrop", []))

    @jsii.member(jsii_name="resetFaceCrop")
    def reset_face_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFaceCrop", []))

    @jsii.member(jsii_name="resetFeatureCrop")
    def reset_feature_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatureCrop", []))

    @jsii.member(jsii_name="resetFitAndFill")
    def reset_fit_and_fill(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFitAndFill", []))

    @jsii.member(jsii_name="resetGoop")
    def reset_goop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGoop", []))

    @jsii.member(jsii_name="resetGrayscale")
    def reset_grayscale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGrayscale", []))

    @jsii.member(jsii_name="resetHsl")
    def reset_hsl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsl", []))

    @jsii.member(jsii_name="resetHsv")
    def reset_hsv(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsv", []))

    @jsii.member(jsii_name="resetIfDimension")
    def reset_if_dimension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfDimension", []))

    @jsii.member(jsii_name="resetIfOrientation")
    def reset_if_orientation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIfOrientation", []))

    @jsii.member(jsii_name="resetImQuery")
    def reset_im_query(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetImQuery", []))

    @jsii.member(jsii_name="resetMaxColors")
    def reset_max_colors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxColors", []))

    @jsii.member(jsii_name="resetMirror")
    def reset_mirror(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMirror", []))

    @jsii.member(jsii_name="resetMonoHue")
    def reset_mono_hue(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonoHue", []))

    @jsii.member(jsii_name="resetOpacity")
    def reset_opacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpacity", []))

    @jsii.member(jsii_name="resetRegionOfInterestCrop")
    def reset_region_of_interest_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRegionOfInterestCrop", []))

    @jsii.member(jsii_name="resetRelativeCrop")
    def reset_relative_crop(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRelativeCrop", []))

    @jsii.member(jsii_name="resetRemoveColor")
    def reset_remove_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRemoveColor", []))

    @jsii.member(jsii_name="resetResize")
    def reset_resize(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetResize", []))

    @jsii.member(jsii_name="resetRotate")
    def reset_rotate(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRotate", []))

    @jsii.member(jsii_name="resetScale")
    def reset_scale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScale", []))

    @jsii.member(jsii_name="resetShear")
    def reset_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetShear", []))

    @jsii.member(jsii_name="resetTrim")
    def reset_trim(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTrim", []))

    @jsii.member(jsii_name="resetUnsharpMask")
    def reset_unsharp_mask(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUnsharpMask", []))

    @builtins.property
    @jsii.member(jsii_name="append")
    def append(self) -> DataAkamaiImagingPolicyImagePolicyTransformationsAppendList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsAppendList, jsii.get(self, "append"))

    @builtins.property
    @jsii.member(jsii_name="aspectCrop")
    def aspect_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsAspectCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsAspectCropList, jsii.get(self, "aspectCrop"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColor")
    def background_color(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsBackgroundColorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsBackgroundColorList, jsii.get(self, "backgroundColor"))

    @builtins.property
    @jsii.member(jsii_name="blur")
    def blur(self) -> DataAkamaiImagingPolicyImagePolicyTransformationsBlurList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsBlurList, jsii.get(self, "blur"))

    @builtins.property
    @jsii.member(jsii_name="chromaKey")
    def chroma_key(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsChromaKeyList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsChromaKeyList, jsii.get(self, "chromaKey"))

    @builtins.property
    @jsii.member(jsii_name="composite")
    def composite(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsCompositeList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsCompositeList, jsii.get(self, "composite"))

    @builtins.property
    @jsii.member(jsii_name="compound")
    def compound(self) -> DataAkamaiImagingPolicyImagePolicyTransformationsCompoundList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsCompoundList, jsii.get(self, "compound"))

    @builtins.property
    @jsii.member(jsii_name="contrast")
    def contrast(self) -> DataAkamaiImagingPolicyImagePolicyTransformationsContrastList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsContrastList, jsii.get(self, "contrast"))

    @builtins.property
    @jsii.member(jsii_name="crop")
    def crop(self) -> DataAkamaiImagingPolicyImagePolicyTransformationsCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsCropList, jsii.get(self, "crop"))

    @builtins.property
    @jsii.member(jsii_name="faceCrop")
    def face_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFaceCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFaceCropList, jsii.get(self, "faceCrop"))

    @builtins.property
    @jsii.member(jsii_name="featureCrop")
    def feature_crop(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFeatureCropList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFeatureCropList, jsii.get(self, "featureCrop"))

    @builtins.property
    @jsii.member(jsii_name="fitAndFill")
    def fit_and_fill(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillList, jsii.get(self, "fitAndFill"))

    @builtins.property
    @jsii.member(jsii_name="goop")
    def goop(self) -> DataAkamaiImagingPolicyImagePolicyTransformationsGoopList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsGoopList, jsii.get(self, "goop"))

    @builtins.property
    @jsii.member(jsii_name="grayscale")
    def grayscale(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsGrayscaleList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsGrayscaleList, jsii.get(self, "grayscale"))

    @builtins.property
    @jsii.member(jsii_name="hsl")
    def hsl(self) -> DataAkamaiImagingPolicyImagePolicyTransformationsHslList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsHslList, jsii.get(self, "hsl"))

    @builtins.property
    @jsii.member(jsii_name="hsv")
    def hsv(self) -> DataAkamaiImagingPolicyImagePolicyTransformationsHsvList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsHsvList, jsii.get(self, "hsv"))

    @builtins.property
    @jsii.member(jsii_name="ifDimension")
    def if_dimension(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionList, jsii.get(self, "ifDimension"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientation")
    def if_orientation(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationList, jsii.get(self, "ifOrientation"))

    @builtins.property
    @jsii.member(jsii_name="imQuery")
    def im_query(self) -> DataAkamaiImagingPolicyImagePolicyTransformationsImQueryList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsImQueryList, jsii.get(self, "imQuery"))

    @builtins.property
    @jsii.member(jsii_name="maxColors")
    def max_colors(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsMaxColorsList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsMaxColorsList, jsii.get(self, "maxColors"))

    @builtins.property
    @jsii.member(jsii_name="mirror")
    def mirror(self) -> DataAkamaiImagingPolicyImagePolicyTransformationsMirrorList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsMirrorList, jsii.get(self, "mirror"))

    @builtins.property
    @jsii.member(jsii_name="monoHue")
    def mono_hue(self) -> DataAkamaiImagingPolicyImagePolicyTransformationsMonoHueList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsMonoHueList, jsii.get(self, "monoHue"))

    @builtins.property
    @jsii.member(jsii_name="opacity")
    def opacity(self) -> DataAkamaiImagingPolicyImagePolicyTransformationsOpacityList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsOpacityList, jsii.get(self, "opacity"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestCrop")
    def region_of_interest_crop(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropList", jsii.get(self, "regionOfInterestCrop"))

    @builtins.property
    @jsii.member(jsii_name="relativeCrop")
    def relative_crop(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsRelativeCropList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsRelativeCropList", jsii.get(self, "relativeCrop"))

    @builtins.property
    @jsii.member(jsii_name="removeColor")
    def remove_color(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsRemoveColorList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsRemoveColorList", jsii.get(self, "removeColor"))

    @builtins.property
    @jsii.member(jsii_name="resize")
    def resize(self) -> "DataAkamaiImagingPolicyImagePolicyTransformationsResizeList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsResizeList", jsii.get(self, "resize"))

    @builtins.property
    @jsii.member(jsii_name="rotate")
    def rotate(self) -> "DataAkamaiImagingPolicyImagePolicyTransformationsRotateList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsRotateList", jsii.get(self, "rotate"))

    @builtins.property
    @jsii.member(jsii_name="scale")
    def scale(self) -> "DataAkamaiImagingPolicyImagePolicyTransformationsScaleList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsScaleList", jsii.get(self, "scale"))

    @builtins.property
    @jsii.member(jsii_name="shear")
    def shear(self) -> "DataAkamaiImagingPolicyImagePolicyTransformationsShearList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsShearList", jsii.get(self, "shear"))

    @builtins.property
    @jsii.member(jsii_name="trim")
    def trim(self) -> "DataAkamaiImagingPolicyImagePolicyTransformationsTrimList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsTrimList", jsii.get(self, "trim"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMask")
    def unsharp_mask(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsUnsharpMaskList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsUnsharpMaskList", jsii.get(self, "unsharpMask"))

    @builtins.property
    @jsii.member(jsii_name="appendInput")
    def append_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppend]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppend]]], jsii.get(self, "appendInput"))

    @builtins.property
    @jsii.member(jsii_name="aspectCropInput")
    def aspect_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAspectCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAspectCrop]]], jsii.get(self, "aspectCropInput"))

    @builtins.property
    @jsii.member(jsii_name="backgroundColorInput")
    def background_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsBackgroundColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsBackgroundColor]]], jsii.get(self, "backgroundColorInput"))

    @builtins.property
    @jsii.member(jsii_name="blurInput")
    def blur_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsBlur]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsBlur]]], jsii.get(self, "blurInput"))

    @builtins.property
    @jsii.member(jsii_name="chromaKeyInput")
    def chroma_key_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsChromaKey]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsChromaKey]]], jsii.get(self, "chromaKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="compositeInput")
    def composite_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsComposite]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsComposite]]], jsii.get(self, "compositeInput"))

    @builtins.property
    @jsii.member(jsii_name="compoundInput")
    def compound_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompound]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCompound]]], jsii.get(self, "compoundInput"))

    @builtins.property
    @jsii.member(jsii_name="contrastInput")
    def contrast_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsContrast]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsContrast]]], jsii.get(self, "contrastInput"))

    @builtins.property
    @jsii.member(jsii_name="cropInput")
    def crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsCrop]]], jsii.get(self, "cropInput"))

    @builtins.property
    @jsii.member(jsii_name="faceCropInput")
    def face_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFaceCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFaceCrop]]], jsii.get(self, "faceCropInput"))

    @builtins.property
    @jsii.member(jsii_name="featureCropInput")
    def feature_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFeatureCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFeatureCrop]]], jsii.get(self, "featureCropInput"))

    @builtins.property
    @jsii.member(jsii_name="fitAndFillInput")
    def fit_and_fill_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFill]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFill]]], jsii.get(self, "fitAndFillInput"))

    @builtins.property
    @jsii.member(jsii_name="goopInput")
    def goop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsGoop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsGoop]]], jsii.get(self, "goopInput"))

    @builtins.property
    @jsii.member(jsii_name="grayscaleInput")
    def grayscale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsGrayscale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsGrayscale]]], jsii.get(self, "grayscaleInput"))

    @builtins.property
    @jsii.member(jsii_name="hslInput")
    def hsl_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsHsl]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsHsl]]], jsii.get(self, "hslInput"))

    @builtins.property
    @jsii.member(jsii_name="hsvInput")
    def hsv_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsHsv]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsHsv]]], jsii.get(self, "hsvInput"))

    @builtins.property
    @jsii.member(jsii_name="ifDimensionInput")
    def if_dimension_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimension]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimension]]], jsii.get(self, "ifDimensionInput"))

    @builtins.property
    @jsii.member(jsii_name="ifOrientationInput")
    def if_orientation_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientation]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientation]]], jsii.get(self, "ifOrientationInput"))

    @builtins.property
    @jsii.member(jsii_name="imQueryInput")
    def im_query_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsImQuery]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsImQuery]]], jsii.get(self, "imQueryInput"))

    @builtins.property
    @jsii.member(jsii_name="maxColorsInput")
    def max_colors_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsMaxColors]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsMaxColors]]], jsii.get(self, "maxColorsInput"))

    @builtins.property
    @jsii.member(jsii_name="mirrorInput")
    def mirror_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsMirror]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsMirror]]], jsii.get(self, "mirrorInput"))

    @builtins.property
    @jsii.member(jsii_name="monoHueInput")
    def mono_hue_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsMonoHue]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsMonoHue]]], jsii.get(self, "monoHueInput"))

    @builtins.property
    @jsii.member(jsii_name="opacityInput")
    def opacity_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsOpacity]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsOpacity]]], jsii.get(self, "opacityInput"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestCropInput")
    def region_of_interest_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCrop"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCrop"]]], jsii.get(self, "regionOfInterestCropInput"))

    @builtins.property
    @jsii.member(jsii_name="relativeCropInput")
    def relative_crop_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsRelativeCrop"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsRelativeCrop"]]], jsii.get(self, "relativeCropInput"))

    @builtins.property
    @jsii.member(jsii_name="removeColorInput")
    def remove_color_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsRemoveColor"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsRemoveColor"]]], jsii.get(self, "removeColorInput"))

    @builtins.property
    @jsii.member(jsii_name="resizeInput")
    def resize_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsResize"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsResize"]]], jsii.get(self, "resizeInput"))

    @builtins.property
    @jsii.member(jsii_name="rotateInput")
    def rotate_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsRotate"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsRotate"]]], jsii.get(self, "rotateInput"))

    @builtins.property
    @jsii.member(jsii_name="scaleInput")
    def scale_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsScale"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsScale"]]], jsii.get(self, "scaleInput"))

    @builtins.property
    @jsii.member(jsii_name="shearInput")
    def shear_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsShear"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsShear"]]], jsii.get(self, "shearInput"))

    @builtins.property
    @jsii.member(jsii_name="trimInput")
    def trim_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsTrim"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsTrim"]]], jsii.get(self, "trimInput"))

    @builtins.property
    @jsii.member(jsii_name="unsharpMaskInput")
    def unsharp_mask_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsUnsharpMask"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsUnsharpMask"]]], jsii.get(self, "unsharpMaskInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformations]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformations]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformations]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0995034942ce324440a551a301c078e9b4469853b5e400a721e6b1c473f25df6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCrop",
    jsii_struct_bases=[],
    name_mapping={
        "region_of_interest": "regionOfInterest",
        "gravity": "gravity",
        "gravity_var": "gravityVar",
        "height": "height",
        "height_var": "heightVar",
        "style": "style",
        "style_var": "styleVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCrop:
    def __init__(
        self,
        *,
        region_of_interest: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterest", typing.Dict[builtins.str, typing.Any]],
        gravity: typing.Optional[builtins.str] = None,
        gravity_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        style: typing.Optional[builtins.str] = None,
        style_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param region_of_interest: region_of_interest block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest DataAkamaiImagingPolicyImage#region_of_interest}
        :param gravity: The placement of the crop area relative to the specified area of interest. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        :param gravity_var: The placement of the crop area relative to the specified area of interest. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        :param height: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param style: Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        :param style_var: Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default. The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value. A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        :param width: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width in pixels of the output image relative to the specified ``style`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(region_of_interest, dict):
            region_of_interest = DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterest(**region_of_interest)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f5faf86b5f3db9a9f69e73c8abb5e9482d83f5e90b958d318005a5a2f4265cde)
            check_type(argname="argument region_of_interest", value=region_of_interest, expected_type=type_hints["region_of_interest"])
            check_type(argname="argument gravity", value=gravity, expected_type=type_hints["gravity"])
            check_type(argname="argument gravity_var", value=gravity_var, expected_type=type_hints["gravity_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument style", value=style, expected_type=type_hints["style"])
            check_type(argname="argument style_var", value=style_var, expected_type=type_hints["style_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "region_of_interest": region_of_interest,
        }
        if gravity is not None:
            self._values["gravity"] = gravity
        if gravity_var is not None:
            self._values["gravity_var"] = gravity_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if style is not None:
            self._values["style"] = style
        if style_var is not None:
            self._values["style_var"] = style_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def region_of_interest(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterest":
        '''region_of_interest block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest DataAkamaiImagingPolicyImage#region_of_interest}
        '''
        result = self._values.get("region_of_interest")
        assert result is not None, "Required property 'region_of_interest' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterest", result)

    @builtins.property
    def gravity(self) -> typing.Optional[builtins.str]:
        '''The placement of the crop area relative to the specified area of interest.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
        '''
        result = self._values.get("gravity")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gravity_var(self) -> typing.Optional[builtins.str]:
        '''The placement of the crop area relative to the specified area of interest.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
        '''
        result = self._values.get("gravity_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
        '''
        result = self._values.get("style")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def style_var(self) -> typing.Optional[builtins.str]:
        '''Specifies how to crop or scale a crop area for the specified area of interest in the source image, ``zoom`` by default.

        The output image resizes to the specified ``width`` and ``height`` values. A value of ``crop`` places raw crop around the point of interest, relative to the specified ``gravity`` value.  A value of ``fill`` scales the crop area to include as much of the image and point of interest as possible, relative to the specified ``width`` and ``height`` values. A value of ``zoom`` scales the crop area as small as possible to fit the point of interest, relative to the specified ``width`` and ``height`` values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
        '''
        result = self._values.get("style_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width in pixels of the output image relative to the specified ``style`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c30273dc06893bde73b4626172bf1f5fd6fa78ca02f903a65916ee1e07227552)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c975aaab791ccb25de394cc70dd55ae002f603c978cbcd1e7e24b5c4362cb918)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__40121c1b05f23d4f1151e0c2c65cfc874e12d371143e06757ced30cff4d35f98)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd82e301ea0e8fc394f9ee5ae57b8d6610d68d414a12320f977184219352cbcb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e2fb987b5981c788b82816dbbfc4382a9874396f1caaae89698c67eb72a45432)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fed5d22667f974c2cf44ba427dae18ce7278bbeae27d38b40044be21f0f345fc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c5d4b1f7de728ea22fec6f959ce9cb66075496aba696048cfbd97742a2a38946)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putRegionOfInterest")
    def put_region_of_interest(
        self,
        *,
        circle_shape: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestCircleShape", typing.Dict[builtins.str, typing.Any]]]]] = None,
        point_shape: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestPointShape", typing.Dict[builtins.str, typing.Any]]]]] = None,
        polygon_shape: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestPolygonShape", typing.Dict[builtins.str, typing.Any]]]]] = None,
        rectangle_shape: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestRectangleShape", typing.Dict[builtins.str, typing.Any]]]]] = None,
        union_shape: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShape", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param circle_shape: circle_shape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#circle_shape DataAkamaiImagingPolicyImage#circle_shape}
        :param point_shape: point_shape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#point_shape DataAkamaiImagingPolicyImage#point_shape}
        :param polygon_shape: polygon_shape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#polygon_shape DataAkamaiImagingPolicyImage#polygon_shape}
        :param rectangle_shape: rectangle_shape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rectangle_shape DataAkamaiImagingPolicyImage#rectangle_shape}
        :param union_shape: union_shape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#union_shape DataAkamaiImagingPolicyImage#union_shape}
        '''
        value = DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterest(
            circle_shape=circle_shape,
            point_shape=point_shape,
            polygon_shape=polygon_shape,
            rectangle_shape=rectangle_shape,
            union_shape=union_shape,
        )

        return typing.cast(None, jsii.invoke(self, "putRegionOfInterest", [value]))

    @jsii.member(jsii_name="resetGravity")
    def reset_gravity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravity", []))

    @jsii.member(jsii_name="resetGravityVar")
    def reset_gravity_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGravityVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetStyle")
    def reset_style(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyle", []))

    @jsii.member(jsii_name="resetStyleVar")
    def reset_style_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStyleVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterest")
    def region_of_interest(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestOutputReference":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestOutputReference", jsii.get(self, "regionOfInterest"))

    @builtins.property
    @jsii.member(jsii_name="gravityInput")
    def gravity_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityInput"))

    @builtins.property
    @jsii.member(jsii_name="gravityVarInput")
    def gravity_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gravityVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="regionOfInterestInput")
    def region_of_interest_input(
        self,
    ) -> typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterest"]:
        return typing.cast(typing.Optional["DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterest"], jsii.get(self, "regionOfInterestInput"))

    @builtins.property
    @jsii.member(jsii_name="styleInput")
    def style_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleInput"))

    @builtins.property
    @jsii.member(jsii_name="styleVarInput")
    def style_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "styleVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gravity")
    def gravity(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravity"))

    @gravity.setter
    def gravity(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__55b08db21fcb21df29a6005adc319ab5afd1d6acc2c3be8dcc918543880bcb90)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravity", value)

    @builtins.property
    @jsii.member(jsii_name="gravityVar")
    def gravity_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gravityVar"))

    @gravity_var.setter
    def gravity_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d226e16e4c8d4c13879dca0a8eb981ad2c7eab521e490dfc2702ebebca6993d7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gravityVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__afbd4c4c564289f76dd7e7499b1345b2aa3010145ad535f0fa08b033036b2eb5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d0e99bf4a9734b828ff324c85ced3b00623abddf4e64e5be18c96a8f05799d1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="style")
    def style(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "style"))

    @style.setter
    def style(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__61ac6e3ca492489feb63bc6aa4b22b4974d1373b3186c5c59e35a91271f50ce1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "style", value)

    @builtins.property
    @jsii.member(jsii_name="styleVar")
    def style_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "styleVar"))

    @style_var.setter
    def style_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__514502d293866e04e64d33aadc22e449e44101c996128c6c46b8f245d3b94076)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "styleVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__382ae79f1c0f94ed7b8267af2146bd0662ca426fc18a09174ba9f9c5c698952c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3438da76347594331d775dc71fe47f071f6601217549000a6abbe9b5e2d0db5e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__55dcfdb8d7aae6eaa257cc91307f2b2c0805ea1fb98048552b992c75cbc7239a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterest",
    jsii_struct_bases=[],
    name_mapping={
        "circle_shape": "circleShape",
        "point_shape": "pointShape",
        "polygon_shape": "polygonShape",
        "rectangle_shape": "rectangleShape",
        "union_shape": "unionShape",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterest:
    def __init__(
        self,
        *,
        circle_shape: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestCircleShape", typing.Dict[builtins.str, typing.Any]]]]] = None,
        point_shape: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestPointShape", typing.Dict[builtins.str, typing.Any]]]]] = None,
        polygon_shape: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestPolygonShape", typing.Dict[builtins.str, typing.Any]]]]] = None,
        rectangle_shape: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestRectangleShape", typing.Dict[builtins.str, typing.Any]]]]] = None,
        union_shape: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShape", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param circle_shape: circle_shape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#circle_shape DataAkamaiImagingPolicyImage#circle_shape}
        :param point_shape: point_shape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#point_shape DataAkamaiImagingPolicyImage#point_shape}
        :param polygon_shape: polygon_shape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#polygon_shape DataAkamaiImagingPolicyImage#polygon_shape}
        :param rectangle_shape: rectangle_shape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rectangle_shape DataAkamaiImagingPolicyImage#rectangle_shape}
        :param union_shape: union_shape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#union_shape DataAkamaiImagingPolicyImage#union_shape}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__281529c4e30100cbb08dad72de0cdcc11a52ff9d36b402183ea6c635012d7fbb)
            check_type(argname="argument circle_shape", value=circle_shape, expected_type=type_hints["circle_shape"])
            check_type(argname="argument point_shape", value=point_shape, expected_type=type_hints["point_shape"])
            check_type(argname="argument polygon_shape", value=polygon_shape, expected_type=type_hints["polygon_shape"])
            check_type(argname="argument rectangle_shape", value=rectangle_shape, expected_type=type_hints["rectangle_shape"])
            check_type(argname="argument union_shape", value=union_shape, expected_type=type_hints["union_shape"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if circle_shape is not None:
            self._values["circle_shape"] = circle_shape
        if point_shape is not None:
            self._values["point_shape"] = point_shape
        if polygon_shape is not None:
            self._values["polygon_shape"] = polygon_shape
        if rectangle_shape is not None:
            self._values["rectangle_shape"] = rectangle_shape
        if union_shape is not None:
            self._values["union_shape"] = union_shape

    @builtins.property
    def circle_shape(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestCircleShape"]]]:
        '''circle_shape block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#circle_shape DataAkamaiImagingPolicyImage#circle_shape}
        '''
        result = self._values.get("circle_shape")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestCircleShape"]]], result)

    @builtins.property
    def point_shape(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestPointShape"]]]:
        '''point_shape block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#point_shape DataAkamaiImagingPolicyImage#point_shape}
        '''
        result = self._values.get("point_shape")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestPointShape"]]], result)

    @builtins.property
    def polygon_shape(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestPolygonShape"]]]:
        '''polygon_shape block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#polygon_shape DataAkamaiImagingPolicyImage#polygon_shape}
        '''
        result = self._values.get("polygon_shape")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestPolygonShape"]]], result)

    @builtins.property
    def rectangle_shape(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestRectangleShape"]]]:
        '''rectangle_shape block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rectangle_shape DataAkamaiImagingPolicyImage#rectangle_shape}
        '''
        result = self._values.get("rectangle_shape")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestRectangleShape"]]], result)

    @builtins.property
    def union_shape(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShape"]]]:
        '''union_shape block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#union_shape DataAkamaiImagingPolicyImage#union_shape}
        '''
        result = self._values.get("union_shape")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShape"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterest(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestCircleShape",
    jsii_struct_bases=[],
    name_mapping={"center": "center", "radius": "radius", "radius_var": "radiusVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestCircleShape:
    def __init__(
        self,
        *,
        center: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestCircleShapeCenter", typing.Dict[builtins.str, typing.Any]],
        radius: typing.Optional[builtins.str] = None,
        radius_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param center: center block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#center DataAkamaiImagingPolicyImage#center}
        :param radius: The radius of the circle measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#radius DataAkamaiImagingPolicyImage#radius}
        :param radius_var: The radius of the circle measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#radius_var DataAkamaiImagingPolicyImage#radius_var}
        '''
        if isinstance(center, dict):
            center = DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestCircleShapeCenter(**center)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__96fdcc2febc6f893bc25d3520c1c16f6d6e101c9c1452798be0d38d14b80dc1d)
            check_type(argname="argument center", value=center, expected_type=type_hints["center"])
            check_type(argname="argument radius", value=radius, expected_type=type_hints["radius"])
            check_type(argname="argument radius_var", value=radius_var, expected_type=type_hints["radius_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "center": center,
        }
        if radius is not None:
            self._values["radius"] = radius
        if radius_var is not None:
            self._values["radius_var"] = radius_var

    @builtins.property
    def center(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestCircleShapeCenter":
        '''center block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#center DataAkamaiImagingPolicyImage#center}
        '''
        result = self._values.get("center")
        assert result is not None, "Required property 'center' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestCircleShapeCenter", result)

    @builtins.property
    def radius(self) -> typing.Optional[builtins.str]:
        '''The radius of the circle measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#radius DataAkamaiImagingPolicyImage#radius}
        '''
        result = self._values.get("radius")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def radius_var(self) -> typing.Optional[builtins.str]:
        '''The radius of the circle measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#radius_var DataAkamaiImagingPolicyImage#radius_var}
        '''
        result = self._values.get("radius_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestCircleShape(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestCircleShapeCenter",
    jsii_struct_bases=[],
    name_mapping={"x": "x", "x_var": "xVar", "y": "y", "y_var": "yVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestCircleShapeCenter:
    def __init__(
        self,
        *,
        x: typing.Optional[builtins.str] = None,
        x_var: typing.Optional[builtins.str] = None,
        y: typing.Optional[builtins.str] = None,
        y_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param x: The horizontal position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x DataAkamaiImagingPolicyImage#x}
        :param x_var: The horizontal position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_var DataAkamaiImagingPolicyImage#x_var}
        :param y: The vertical position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y DataAkamaiImagingPolicyImage#y}
        :param y_var: The vertical position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_var DataAkamaiImagingPolicyImage#y_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d44b4138006578ffd72fc3721a16058a5d6926b5adeb04691ec659acbf8cdfc)
            check_type(argname="argument x", value=x, expected_type=type_hints["x"])
            check_type(argname="argument x_var", value=x_var, expected_type=type_hints["x_var"])
            check_type(argname="argument y", value=y, expected_type=type_hints["y"])
            check_type(argname="argument y_var", value=y_var, expected_type=type_hints["y_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if x is not None:
            self._values["x"] = x
        if x_var is not None:
            self._values["x_var"] = x_var
        if y is not None:
            self._values["y"] = y
        if y_var is not None:
            self._values["y_var"] = y_var

    @builtins.property
    def x(self) -> typing.Optional[builtins.str]:
        '''The horizontal position of the point, measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x DataAkamaiImagingPolicyImage#x}
        '''
        result = self._values.get("x")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_var(self) -> typing.Optional[builtins.str]:
        '''The horizontal position of the point, measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_var DataAkamaiImagingPolicyImage#x_var}
        '''
        result = self._values.get("x_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y(self) -> typing.Optional[builtins.str]:
        '''The vertical position of the point, measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y DataAkamaiImagingPolicyImage#y}
        '''
        result = self._values.get("y")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_var(self) -> typing.Optional[builtins.str]:
        '''The vertical position of the point, measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_var DataAkamaiImagingPolicyImage#y_var}
        '''
        result = self._values.get("y_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestCircleShapeCenter(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestCircleShapeCenterOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestCircleShapeCenterOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__128504add62a28b89be7e598c6dba791819cf735b40c3295186c17b62fa8abd8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetX")
    def reset_x(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetX", []))

    @jsii.member(jsii_name="resetXVar")
    def reset_x_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXVar", []))

    @jsii.member(jsii_name="resetY")
    def reset_y(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetY", []))

    @jsii.member(jsii_name="resetYVar")
    def reset_y_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYVar", []))

    @builtins.property
    @jsii.member(jsii_name="xInput")
    def x_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xInput"))

    @builtins.property
    @jsii.member(jsii_name="xVarInput")
    def x_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yInput")
    def y_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yInput"))

    @builtins.property
    @jsii.member(jsii_name="yVarInput")
    def y_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yVarInput"))

    @builtins.property
    @jsii.member(jsii_name="x")
    def x(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "x"))

    @x.setter
    def x(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__17cd1a34b4e22dfb72834c9dc425195119936f4a392dae92a57d6ef5e8fc8e5a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "x", value)

    @builtins.property
    @jsii.member(jsii_name="xVar")
    def x_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xVar"))

    @x_var.setter
    def x_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bcbaa4786b2d6066ed7d7997b627410c8c0ff473e7cba5e4db5f0cff4d6ee1c3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xVar", value)

    @builtins.property
    @jsii.member(jsii_name="y")
    def y(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "y"))

    @y.setter
    def y(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ab22ed65e5577b11ede2dcefcf30ac59d701cee20c255d0f98aec43678ac05f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "y", value)

    @builtins.property
    @jsii.member(jsii_name="yVar")
    def y_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yVar"))

    @y_var.setter
    def y_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eebc0ec1721681b304d2940f284e02067f00f1fbf41ef009c8292a85904eb8a9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestCircleShapeCenter]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestCircleShapeCenter], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestCircleShapeCenter],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d6e25a19c785147401bb4d7716d0c77d48c5af94871e4de8236f404d046c3bd3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestCircleShapeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestCircleShapeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1c2cb5f3eb2e4f335a7202944a85aa1b3a9866e73bb7cd207f7610f55393e1d6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestCircleShapeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ee9241628279eafc34b7ea91dea4f4f48f15bb1e47ebead21190344113e50010)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestCircleShapeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__34e12db5efd6817388d3427161a6356f58d1198006fc3baa549455651479f589)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac0d4259052673ed2d124e5a21d47bd17aac4f51334ac5a619d6d37a4d2a4420)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__da7a86decd0b07b5673f9b365d344b3a63940cc3792adf72a0fe342f2bc38341)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestCircleShape]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestCircleShape]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestCircleShape]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__89117a8f6228b8c1a9fc23cdde1a54b89d0288089a9d52e5c48680771d9ed4c7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestCircleShapeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestCircleShapeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__67ccf057d59e875ebfc1f8f87c0a384b871c80a052f5120d18ec842268aa0c0e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putCenter")
    def put_center(
        self,
        *,
        x: typing.Optional[builtins.str] = None,
        x_var: typing.Optional[builtins.str] = None,
        y: typing.Optional[builtins.str] = None,
        y_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param x: The horizontal position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x DataAkamaiImagingPolicyImage#x}
        :param x_var: The horizontal position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_var DataAkamaiImagingPolicyImage#x_var}
        :param y: The vertical position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y DataAkamaiImagingPolicyImage#y}
        :param y_var: The vertical position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_var DataAkamaiImagingPolicyImage#y_var}
        '''
        value = DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestCircleShapeCenter(
            x=x, x_var=x_var, y=y, y_var=y_var
        )

        return typing.cast(None, jsii.invoke(self, "putCenter", [value]))

    @jsii.member(jsii_name="resetRadius")
    def reset_radius(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRadius", []))

    @jsii.member(jsii_name="resetRadiusVar")
    def reset_radius_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRadiusVar", []))

    @builtins.property
    @jsii.member(jsii_name="center")
    def center(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestCircleShapeCenterOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestCircleShapeCenterOutputReference, jsii.get(self, "center"))

    @builtins.property
    @jsii.member(jsii_name="centerInput")
    def center_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestCircleShapeCenter]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestCircleShapeCenter], jsii.get(self, "centerInput"))

    @builtins.property
    @jsii.member(jsii_name="radiusInput")
    def radius_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "radiusInput"))

    @builtins.property
    @jsii.member(jsii_name="radiusVarInput")
    def radius_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "radiusVarInput"))

    @builtins.property
    @jsii.member(jsii_name="radius")
    def radius(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "radius"))

    @radius.setter
    def radius(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4fcc989dde6f5e6c211d2cf64c5fe190db2d64ba66800d445acfe40eea7ccff2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "radius", value)

    @builtins.property
    @jsii.member(jsii_name="radiusVar")
    def radius_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "radiusVar"))

    @radius_var.setter
    def radius_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__93abe5fdf8d1f314491be5e039ccf75e1bf3f6a23d1508e08f425ef870d2d185)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "radiusVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestCircleShape]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestCircleShape]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestCircleShape]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__91bf010b4d3096f4d578d22f67b2a257334533705498379f6499c9168e703583)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ea6440d6a122b17544a8e3355bb7137e865c95f0bc50435ea7b9dd4b2f46bac)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putCircleShape")
    def put_circle_shape(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestCircleShape, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a252352c60398b4ec4ef8d613d51b95ec2b040a91e438f7734e764a5d4a03dfb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCircleShape", [value]))

    @jsii.member(jsii_name="putPointShape")
    def put_point_shape(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestPointShape", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d70d60633a1fbbfb1009f7098ae7050a96dc059ccf4eba96367aeaba3c106a0a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putPointShape", [value]))

    @jsii.member(jsii_name="putPolygonShape")
    def put_polygon_shape(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestPolygonShape", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__14b297a09bbd0d187a24cfcef5ad7e8dba254ba5f63101774be8dfbd1aaa990f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putPolygonShape", [value]))

    @jsii.member(jsii_name="putRectangleShape")
    def put_rectangle_shape(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestRectangleShape", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1ec0aa004a5b55a7412d40873ed440b659bf88f143e8ecd518e554e19c1be11c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRectangleShape", [value]))

    @jsii.member(jsii_name="putUnionShape")
    def put_union_shape(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShape", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__588f5d11859a7aab27d36b7c45e5dac75ac656f11d983d760dd6ee9aa9d3d232)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putUnionShape", [value]))

    @jsii.member(jsii_name="resetCircleShape")
    def reset_circle_shape(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCircleShape", []))

    @jsii.member(jsii_name="resetPointShape")
    def reset_point_shape(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPointShape", []))

    @jsii.member(jsii_name="resetPolygonShape")
    def reset_polygon_shape(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPolygonShape", []))

    @jsii.member(jsii_name="resetRectangleShape")
    def reset_rectangle_shape(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRectangleShape", []))

    @jsii.member(jsii_name="resetUnionShape")
    def reset_union_shape(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUnionShape", []))

    @builtins.property
    @jsii.member(jsii_name="circleShape")
    def circle_shape(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestCircleShapeList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestCircleShapeList, jsii.get(self, "circleShape"))

    @builtins.property
    @jsii.member(jsii_name="pointShape")
    def point_shape(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestPointShapeList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestPointShapeList", jsii.get(self, "pointShape"))

    @builtins.property
    @jsii.member(jsii_name="polygonShape")
    def polygon_shape(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestPolygonShapeList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestPolygonShapeList", jsii.get(self, "polygonShape"))

    @builtins.property
    @jsii.member(jsii_name="rectangleShape")
    def rectangle_shape(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestRectangleShapeList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestRectangleShapeList", jsii.get(self, "rectangleShape"))

    @builtins.property
    @jsii.member(jsii_name="unionShape")
    def union_shape(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeList", jsii.get(self, "unionShape"))

    @builtins.property
    @jsii.member(jsii_name="circleShapeInput")
    def circle_shape_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestCircleShape]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestCircleShape]]], jsii.get(self, "circleShapeInput"))

    @builtins.property
    @jsii.member(jsii_name="pointShapeInput")
    def point_shape_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestPointShape"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestPointShape"]]], jsii.get(self, "pointShapeInput"))

    @builtins.property
    @jsii.member(jsii_name="polygonShapeInput")
    def polygon_shape_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestPolygonShape"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestPolygonShape"]]], jsii.get(self, "polygonShapeInput"))

    @builtins.property
    @jsii.member(jsii_name="rectangleShapeInput")
    def rectangle_shape_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestRectangleShape"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestRectangleShape"]]], jsii.get(self, "rectangleShapeInput"))

    @builtins.property
    @jsii.member(jsii_name="unionShapeInput")
    def union_shape_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShape"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShape"]]], jsii.get(self, "unionShapeInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterest]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterest], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterest],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2095c8a4e0996d652a83aab6432d6c47768af782457971ddb163de0e55c0d41a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestPointShape",
    jsii_struct_bases=[],
    name_mapping={"x": "x", "x_var": "xVar", "y": "y", "y_var": "yVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestPointShape:
    def __init__(
        self,
        *,
        x: typing.Optional[builtins.str] = None,
        x_var: typing.Optional[builtins.str] = None,
        y: typing.Optional[builtins.str] = None,
        y_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param x: The horizontal position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x DataAkamaiImagingPolicyImage#x}
        :param x_var: The horizontal position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_var DataAkamaiImagingPolicyImage#x_var}
        :param y: The vertical position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y DataAkamaiImagingPolicyImage#y}
        :param y_var: The vertical position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_var DataAkamaiImagingPolicyImage#y_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9b7b81c35dc19c721a73bf995112d5518c6bddc25199457867251379f95baced)
            check_type(argname="argument x", value=x, expected_type=type_hints["x"])
            check_type(argname="argument x_var", value=x_var, expected_type=type_hints["x_var"])
            check_type(argname="argument y", value=y, expected_type=type_hints["y"])
            check_type(argname="argument y_var", value=y_var, expected_type=type_hints["y_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if x is not None:
            self._values["x"] = x
        if x_var is not None:
            self._values["x_var"] = x_var
        if y is not None:
            self._values["y"] = y
        if y_var is not None:
            self._values["y_var"] = y_var

    @builtins.property
    def x(self) -> typing.Optional[builtins.str]:
        '''The horizontal position of the point, measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x DataAkamaiImagingPolicyImage#x}
        '''
        result = self._values.get("x")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_var(self) -> typing.Optional[builtins.str]:
        '''The horizontal position of the point, measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_var DataAkamaiImagingPolicyImage#x_var}
        '''
        result = self._values.get("x_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y(self) -> typing.Optional[builtins.str]:
        '''The vertical position of the point, measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y DataAkamaiImagingPolicyImage#y}
        '''
        result = self._values.get("y")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_var(self) -> typing.Optional[builtins.str]:
        '''The vertical position of the point, measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_var DataAkamaiImagingPolicyImage#y_var}
        '''
        result = self._values.get("y_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestPointShape(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestPointShapeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestPointShapeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e2c42e6e46b70ed9aa7158168184bfaaf51e790b187583c99c7bf95bcd2a0a97)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestPointShapeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__04b4a077c3431ece2dc3f46474290ad951c6779c0140aafb3c6fe02cc231f2c7)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestPointShapeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ec43169c0672d825fc37c28108db5a1ece52598af6a1e3e9651972bdbe1a2478)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__253a950828d2c9acebebd15dd815e3aa96bc53978a3538e46db15471418395fe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__92341fbb19b437df6f0f6c07f3b4ce064454be6c0c58752a2b3d87aea2b51c88)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestPointShape]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestPointShape]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestPointShape]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a6950e614b360a71a90a4cde9f410f2632ef370d7a4d0f108091b15e47d297af)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestPointShapeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestPointShapeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eaca75503c2a924e025351e09451df87d77d29f1a4382b8a30f36c9648ccc9d0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetX")
    def reset_x(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetX", []))

    @jsii.member(jsii_name="resetXVar")
    def reset_x_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXVar", []))

    @jsii.member(jsii_name="resetY")
    def reset_y(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetY", []))

    @jsii.member(jsii_name="resetYVar")
    def reset_y_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYVar", []))

    @builtins.property
    @jsii.member(jsii_name="xInput")
    def x_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xInput"))

    @builtins.property
    @jsii.member(jsii_name="xVarInput")
    def x_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yInput")
    def y_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yInput"))

    @builtins.property
    @jsii.member(jsii_name="yVarInput")
    def y_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yVarInput"))

    @builtins.property
    @jsii.member(jsii_name="x")
    def x(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "x"))

    @x.setter
    def x(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dd62b5def0c9c228277cc7788ff69c47b88c47b50fefcff8aa01ed9e4ce4e39f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "x", value)

    @builtins.property
    @jsii.member(jsii_name="xVar")
    def x_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xVar"))

    @x_var.setter
    def x_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__11f8d536c216559c5067e9ad6359b4bd09030eaf857d7a582bc7dfecda709fbe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xVar", value)

    @builtins.property
    @jsii.member(jsii_name="y")
    def y(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "y"))

    @y.setter
    def y(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__045e864e23255bc8118d54d5a5dc48ef7be0b6a290c3ae41bbe5fffde165921b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "y", value)

    @builtins.property
    @jsii.member(jsii_name="yVar")
    def y_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yVar"))

    @y_var.setter
    def y_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a5f4b81af90bfcde5ed9931f0a976e9aaa6b7bf6548567c0fe809229fa67de34)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestPointShape]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestPointShape]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestPointShape]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__568f55b91961405c466328212266f9b299733e221d359eb11b54b5aec9076063)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestPolygonShape",
    jsii_struct_bases=[],
    name_mapping={"points": "points"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestPolygonShape:
    def __init__(
        self,
        *,
        points: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestPolygonShapePoints", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param points: points block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#points DataAkamaiImagingPolicyImage#points}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d49b2818a1892437476abfdf3bf6eca249372d740a5efce8e4d547aea814d6c3)
            check_type(argname="argument points", value=points, expected_type=type_hints["points"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "points": points,
        }

    @builtins.property
    def points(
        self,
    ) -> typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestPolygonShapePoints"]]:
        '''points block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#points DataAkamaiImagingPolicyImage#points}
        '''
        result = self._values.get("points")
        assert result is not None, "Required property 'points' is missing"
        return typing.cast(typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestPolygonShapePoints"]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestPolygonShape(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestPolygonShapeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestPolygonShapeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b5a1c860d162450b34bd6e0b1db5eda9bcf933e828c0e1f425e3994b31c8e1f3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestPolygonShapeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b1b000fa32b6361d44baa9c63db8fcb752d443269daa65cea45c5ca2d87727ea)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestPolygonShapeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a594fcfd235a2032e948972f2c8e6d05e612a770d4d1feba0200a33255eae360)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1aa0f6a0642041dc0e52f712a5b9bfda9829b438e3e2eaf6315190c00191ef49)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8b6f86ddd80cf8c6f7fbc8bde92d04694a52a9f8a8e8c08d4b1d7dd58f8c9259)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestPolygonShape]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestPolygonShape]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestPolygonShape]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__898f45a8175eed1e1ad83e673b065a5cd55909efb7e614613f169e8b79170b7c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestPolygonShapeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestPolygonShapeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__db2294fa24e1c34dbe26db07044782686d57b81f317cd990c54bb5389d712232)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putPoints")
    def put_points(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestPolygonShapePoints", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__259c6b73144a1f39c0b9f9b3b06bbd9803d095c4186cc00c9f96bdc82136fd19)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putPoints", [value]))

    @builtins.property
    @jsii.member(jsii_name="points")
    def points(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestPolygonShapePointsList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestPolygonShapePointsList", jsii.get(self, "points"))

    @builtins.property
    @jsii.member(jsii_name="pointsInput")
    def points_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestPolygonShapePoints"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestPolygonShapePoints"]]], jsii.get(self, "pointsInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestPolygonShape]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestPolygonShape]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestPolygonShape]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c841bc94dd9a8e0eba43f72ae679ab969f333dfdaa98e309963e5445b62d25d1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestPolygonShapePoints",
    jsii_struct_bases=[],
    name_mapping={"x": "x", "x_var": "xVar", "y": "y", "y_var": "yVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestPolygonShapePoints:
    def __init__(
        self,
        *,
        x: typing.Optional[builtins.str] = None,
        x_var: typing.Optional[builtins.str] = None,
        y: typing.Optional[builtins.str] = None,
        y_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param x: The horizontal position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x DataAkamaiImagingPolicyImage#x}
        :param x_var: The horizontal position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_var DataAkamaiImagingPolicyImage#x_var}
        :param y: The vertical position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y DataAkamaiImagingPolicyImage#y}
        :param y_var: The vertical position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_var DataAkamaiImagingPolicyImage#y_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__65d678bd113359f3d5820a0a67a14edf88cf88ed3fc3079ca7fe9de76c3b4c2d)
            check_type(argname="argument x", value=x, expected_type=type_hints["x"])
            check_type(argname="argument x_var", value=x_var, expected_type=type_hints["x_var"])
            check_type(argname="argument y", value=y, expected_type=type_hints["y"])
            check_type(argname="argument y_var", value=y_var, expected_type=type_hints["y_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if x is not None:
            self._values["x"] = x
        if x_var is not None:
            self._values["x_var"] = x_var
        if y is not None:
            self._values["y"] = y
        if y_var is not None:
            self._values["y_var"] = y_var

    @builtins.property
    def x(self) -> typing.Optional[builtins.str]:
        '''The horizontal position of the point, measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x DataAkamaiImagingPolicyImage#x}
        '''
        result = self._values.get("x")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_var(self) -> typing.Optional[builtins.str]:
        '''The horizontal position of the point, measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_var DataAkamaiImagingPolicyImage#x_var}
        '''
        result = self._values.get("x_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y(self) -> typing.Optional[builtins.str]:
        '''The vertical position of the point, measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y DataAkamaiImagingPolicyImage#y}
        '''
        result = self._values.get("y")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_var(self) -> typing.Optional[builtins.str]:
        '''The vertical position of the point, measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_var DataAkamaiImagingPolicyImage#y_var}
        '''
        result = self._values.get("y_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestPolygonShapePoints(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestPolygonShapePointsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestPolygonShapePointsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2f7c2bc9d98b014c7db63cfe2bd1a35615a6c8e779014c8a004612600085b1ee)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestPolygonShapePointsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__023ceb4007b98799a378749d59a8b340b548c6682911c4fcd023acab556841c4)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestPolygonShapePointsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a06eb4d531158004d3f332eed793b0748e620d53d3dfaab16a601946061753f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__51edf1e4763af80b6047b48da0d2db3cf8ab4a7f1615ddbe6261a31e53639b1f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ad417e62672ff4b8377df15ec8546e348c5fcdaf78395955aa430e3ee1bca1cf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestPolygonShapePoints]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestPolygonShapePoints]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestPolygonShapePoints]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__462b358fbebcc065d52a96d374783c0da42bb6032271fc88e51cee6de493680e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestPolygonShapePointsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestPolygonShapePointsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b1df922ca9708ded12f357cfc0de941b86a6706750166885b20ec7eb6d2c0960)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetX")
    def reset_x(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetX", []))

    @jsii.member(jsii_name="resetXVar")
    def reset_x_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXVar", []))

    @jsii.member(jsii_name="resetY")
    def reset_y(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetY", []))

    @jsii.member(jsii_name="resetYVar")
    def reset_y_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYVar", []))

    @builtins.property
    @jsii.member(jsii_name="xInput")
    def x_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xInput"))

    @builtins.property
    @jsii.member(jsii_name="xVarInput")
    def x_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yInput")
    def y_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yInput"))

    @builtins.property
    @jsii.member(jsii_name="yVarInput")
    def y_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yVarInput"))

    @builtins.property
    @jsii.member(jsii_name="x")
    def x(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "x"))

    @x.setter
    def x(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__25f8a357f11617cb8fe2ce39983cf7534c065a899744d40b2cb0570affbce71a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "x", value)

    @builtins.property
    @jsii.member(jsii_name="xVar")
    def x_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xVar"))

    @x_var.setter
    def x_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4455d826e6fa173405b81f1ef6f6df123a5ddc6153e60f1d4b481e746a16686f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xVar", value)

    @builtins.property
    @jsii.member(jsii_name="y")
    def y(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "y"))

    @y.setter
    def y(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5291861d03c7b20bb5135c914ddd8f2f606c4c94e7e68920a3e226c3c60c3091)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "y", value)

    @builtins.property
    @jsii.member(jsii_name="yVar")
    def y_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yVar"))

    @y_var.setter
    def y_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ada5e3033936e436358a983c55059f99c1c3e2f411d24b354f2d6dda48d7bd12)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestPolygonShapePoints]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestPolygonShapePoints]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestPolygonShapePoints]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d30f91af5c9e0ff35de2967054091271a0ffcbf0e117ac9cc0910141f6625f7f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestRectangleShape",
    jsii_struct_bases=[],
    name_mapping={
        "anchor": "anchor",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestRectangleShape:
    def __init__(
        self,
        *,
        anchor: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestRectangleShapeAnchor", typing.Dict[builtins.str, typing.Any]],
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param anchor: anchor block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#anchor DataAkamaiImagingPolicyImage#anchor}
        :param height: Extends the rectangle down from the ``anchor`` point. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: Extends the rectangle down from the ``anchor`` point. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: Extends the rectangle right from the ``anchor`` point. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: Extends the rectangle right from the ``anchor`` point. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(anchor, dict):
            anchor = DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestRectangleShapeAnchor(**anchor)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f9c58b0ebb2048a4c9991b89e1c8ea4f6d64a9cdc21588d5815719a7f44b32ad)
            check_type(argname="argument anchor", value=anchor, expected_type=type_hints["anchor"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "anchor": anchor,
        }
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def anchor(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestRectangleShapeAnchor":
        '''anchor block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#anchor DataAkamaiImagingPolicyImage#anchor}
        '''
        result = self._values.get("anchor")
        assert result is not None, "Required property 'anchor' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestRectangleShapeAnchor", result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''Extends the rectangle down from the ``anchor`` point.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''Extends the rectangle down from the ``anchor`` point.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''Extends the rectangle right from the ``anchor`` point.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''Extends the rectangle right from the ``anchor`` point.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestRectangleShape(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestRectangleShapeAnchor",
    jsii_struct_bases=[],
    name_mapping={"x": "x", "x_var": "xVar", "y": "y", "y_var": "yVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestRectangleShapeAnchor:
    def __init__(
        self,
        *,
        x: typing.Optional[builtins.str] = None,
        x_var: typing.Optional[builtins.str] = None,
        y: typing.Optional[builtins.str] = None,
        y_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param x: The horizontal position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x DataAkamaiImagingPolicyImage#x}
        :param x_var: The horizontal position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_var DataAkamaiImagingPolicyImage#x_var}
        :param y: The vertical position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y DataAkamaiImagingPolicyImage#y}
        :param y_var: The vertical position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_var DataAkamaiImagingPolicyImage#y_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__71b0a028b5a1ae0d23b5399e6fbd32e08e2776b4cd097bd63ea4daa0b8d55a17)
            check_type(argname="argument x", value=x, expected_type=type_hints["x"])
            check_type(argname="argument x_var", value=x_var, expected_type=type_hints["x_var"])
            check_type(argname="argument y", value=y, expected_type=type_hints["y"])
            check_type(argname="argument y_var", value=y_var, expected_type=type_hints["y_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if x is not None:
            self._values["x"] = x
        if x_var is not None:
            self._values["x_var"] = x_var
        if y is not None:
            self._values["y"] = y
        if y_var is not None:
            self._values["y_var"] = y_var

    @builtins.property
    def x(self) -> typing.Optional[builtins.str]:
        '''The horizontal position of the point, measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x DataAkamaiImagingPolicyImage#x}
        '''
        result = self._values.get("x")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_var(self) -> typing.Optional[builtins.str]:
        '''The horizontal position of the point, measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_var DataAkamaiImagingPolicyImage#x_var}
        '''
        result = self._values.get("x_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y(self) -> typing.Optional[builtins.str]:
        '''The vertical position of the point, measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y DataAkamaiImagingPolicyImage#y}
        '''
        result = self._values.get("y")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_var(self) -> typing.Optional[builtins.str]:
        '''The vertical position of the point, measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_var DataAkamaiImagingPolicyImage#y_var}
        '''
        result = self._values.get("y_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestRectangleShapeAnchor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestRectangleShapeAnchorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestRectangleShapeAnchorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f7d29a60c1d4e5d2a6cbebe3ead09fc4cd67ec6066275b704377537533bd726)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetX")
    def reset_x(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetX", []))

    @jsii.member(jsii_name="resetXVar")
    def reset_x_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXVar", []))

    @jsii.member(jsii_name="resetY")
    def reset_y(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetY", []))

    @jsii.member(jsii_name="resetYVar")
    def reset_y_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYVar", []))

    @builtins.property
    @jsii.member(jsii_name="xInput")
    def x_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xInput"))

    @builtins.property
    @jsii.member(jsii_name="xVarInput")
    def x_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yInput")
    def y_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yInput"))

    @builtins.property
    @jsii.member(jsii_name="yVarInput")
    def y_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yVarInput"))

    @builtins.property
    @jsii.member(jsii_name="x")
    def x(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "x"))

    @x.setter
    def x(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0e50cca99063d996f7cf97b126b142c0ddab6863c5dd7e9f2572d27e023510f4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "x", value)

    @builtins.property
    @jsii.member(jsii_name="xVar")
    def x_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xVar"))

    @x_var.setter
    def x_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__65974dc013e59113513d2ae774694380255d38632090cf1fe5bceac0cbe4aa6a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xVar", value)

    @builtins.property
    @jsii.member(jsii_name="y")
    def y(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "y"))

    @y.setter
    def y(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__99bfd7562a5b14a022c37b91da882a31f4b609c54e1d87f7055ab901b2a60b7a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "y", value)

    @builtins.property
    @jsii.member(jsii_name="yVar")
    def y_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yVar"))

    @y_var.setter
    def y_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b267462decf048ab5e7f2073afd06e7731ff4b1e4cc9d62f162b79693291dc60)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestRectangleShapeAnchor]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestRectangleShapeAnchor], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestRectangleShapeAnchor],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aa0b4292a3833bd6b7d34e0ae39677967584fc9ad265dda6d66b8b3e77a9a418)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestRectangleShapeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestRectangleShapeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__483ee486b5ff1f899dd5f2131cd5d0909acb611745feb8f02f0dc213617e2b0d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestRectangleShapeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ac124091df390016a2c32bc4bd3b99d5828d5d922e16eb8d98aada52f8fee3e)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestRectangleShapeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1ed1a008b50b7011cd051f5ab6b59008f836b6fa10e91b46ba7a2a8a199a5349)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b51c53c910684a0c49c0da83c76bc403de081d5faf594516fe6a9dcf25d94cd0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__881b7d6c7de65ebe6ff02224084ce0c6d3f63b0cdeef522e1e6a9366e0d7385c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestRectangleShape]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestRectangleShape]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestRectangleShape]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4d113aa6d34dad46c6a2f8ec4ff2a9b96cdee56b92a888745bfcb0c65bc0ef7e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestRectangleShapeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestRectangleShapeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d7feee3042f48968a6821d59ff3fc231219232cf05b375724b199cb2ece1786a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putAnchor")
    def put_anchor(
        self,
        *,
        x: typing.Optional[builtins.str] = None,
        x_var: typing.Optional[builtins.str] = None,
        y: typing.Optional[builtins.str] = None,
        y_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param x: The horizontal position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x DataAkamaiImagingPolicyImage#x}
        :param x_var: The horizontal position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_var DataAkamaiImagingPolicyImage#x_var}
        :param y: The vertical position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y DataAkamaiImagingPolicyImage#y}
        :param y_var: The vertical position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_var DataAkamaiImagingPolicyImage#y_var}
        '''
        value = DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestRectangleShapeAnchor(
            x=x, x_var=x_var, y=y, y_var=y_var
        )

        return typing.cast(None, jsii.invoke(self, "putAnchor", [value]))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="anchor")
    def anchor(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestRectangleShapeAnchorOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestRectangleShapeAnchorOutputReference, jsii.get(self, "anchor"))

    @builtins.property
    @jsii.member(jsii_name="anchorInput")
    def anchor_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestRectangleShapeAnchor]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestRectangleShapeAnchor], jsii.get(self, "anchorInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a45014e105cbd314c494f0b3e6c8ff69268c32996f51cbfd7af52fb270d325f9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a7ca95d56ab374586bbe82e642d933ebb9cde9433d37f236883338a66afe28f2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__45bb57488df937144310927fc37d9a5b9600c45de6fe1192fc84148b79e65530)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5028e70721f791f63f374a83dc45fdaf3ba08ea0547e112722253ad898c68f38)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestRectangleShape]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestRectangleShape]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestRectangleShape]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__33728d37c3e5d81a5790919a3f3ae29cb9e3fe6ab79086dafe2f9fc7c7d7b670)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShape",
    jsii_struct_bases=[],
    name_mapping={"shapes": "shapes"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShape:
    def __init__(
        self,
        *,
        shapes: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapes", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param shapes: shapes block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shapes DataAkamaiImagingPolicyImage#shapes}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__710a8763394a0c1e9f30957c739ce2e2df35c548917141f577b79b4bf7af5e06)
            check_type(argname="argument shapes", value=shapes, expected_type=type_hints["shapes"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "shapes": shapes,
        }

    @builtins.property
    def shapes(
        self,
    ) -> typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapes"]]:
        '''shapes block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shapes DataAkamaiImagingPolicyImage#shapes}
        '''
        result = self._values.get("shapes")
        assert result is not None, "Required property 'shapes' is missing"
        return typing.cast(typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapes"]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShape(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9befc9027ea441d5823bd7aca0a69b6f0a2ffcc04d9cd9ad525cb402fac7a07c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1cafa49696ae96932a992a972833a6206e1e76baa244ef0fc41986fd223fa17b)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9cc043524e8bb781717f86887d743cc0cf188c7ddd7c5aee64a58af29cdbbaec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__05dfef1a40eeba8563d5b5844d89039be24f67f24689dfb947fa19249c59b528)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__83265f66156bd4c86e50949c0d4ef923f8f9b2b6a964e6ca19ac5fbb3c114b5b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShape]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShape]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShape]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__83efa3045c162f32d50fdae749d68ffe8678ce6ebc390594aed3e1f9fd23533b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__06eb6436545d384db3c3071a8bdaee7bdd407272c8f64a945635ad85474d1006)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putShapes")
    def put_shapes(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapes", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__56ed9e64e80217ef6541b9264352331ff9b8ceec5efcb6ccdf089f270244d42c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putShapes", [value]))

    @builtins.property
    @jsii.member(jsii_name="shapes")
    def shapes(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesList", jsii.get(self, "shapes"))

    @builtins.property
    @jsii.member(jsii_name="shapesInput")
    def shapes_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapes"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapes"]]], jsii.get(self, "shapesInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShape]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShape]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShape]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7735c2c9e86f2ee2c5b11d232277a3180a40068437ccccc8f534389d9a89c6ef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapes",
    jsii_struct_bases=[],
    name_mapping={
        "circle_shape": "circleShape",
        "point_shape": "pointShape",
        "polygon_shape": "polygonShape",
        "rectangle_shape": "rectangleShape",
        "union_shape": "unionShape",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapes:
    def __init__(
        self,
        *,
        circle_shape: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesCircleShape", typing.Dict[builtins.str, typing.Any]]]]] = None,
        point_shape: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesPointShape", typing.Dict[builtins.str, typing.Any]]]]] = None,
        polygon_shape: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesPolygonShape", typing.Dict[builtins.str, typing.Any]]]]] = None,
        rectangle_shape: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesRectangleShape", typing.Dict[builtins.str, typing.Any]]]]] = None,
        union_shape: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesUnionShape", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param circle_shape: circle_shape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#circle_shape DataAkamaiImagingPolicyImage#circle_shape}
        :param point_shape: point_shape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#point_shape DataAkamaiImagingPolicyImage#point_shape}
        :param polygon_shape: polygon_shape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#polygon_shape DataAkamaiImagingPolicyImage#polygon_shape}
        :param rectangle_shape: rectangle_shape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rectangle_shape DataAkamaiImagingPolicyImage#rectangle_shape}
        :param union_shape: union_shape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#union_shape DataAkamaiImagingPolicyImage#union_shape}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f95f469f7fe0d57431837834ce07c239ed41116f0850f8a1deaff4a8a5639fd1)
            check_type(argname="argument circle_shape", value=circle_shape, expected_type=type_hints["circle_shape"])
            check_type(argname="argument point_shape", value=point_shape, expected_type=type_hints["point_shape"])
            check_type(argname="argument polygon_shape", value=polygon_shape, expected_type=type_hints["polygon_shape"])
            check_type(argname="argument rectangle_shape", value=rectangle_shape, expected_type=type_hints["rectangle_shape"])
            check_type(argname="argument union_shape", value=union_shape, expected_type=type_hints["union_shape"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if circle_shape is not None:
            self._values["circle_shape"] = circle_shape
        if point_shape is not None:
            self._values["point_shape"] = point_shape
        if polygon_shape is not None:
            self._values["polygon_shape"] = polygon_shape
        if rectangle_shape is not None:
            self._values["rectangle_shape"] = rectangle_shape
        if union_shape is not None:
            self._values["union_shape"] = union_shape

    @builtins.property
    def circle_shape(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesCircleShape"]]]:
        '''circle_shape block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#circle_shape DataAkamaiImagingPolicyImage#circle_shape}
        '''
        result = self._values.get("circle_shape")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesCircleShape"]]], result)

    @builtins.property
    def point_shape(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesPointShape"]]]:
        '''point_shape block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#point_shape DataAkamaiImagingPolicyImage#point_shape}
        '''
        result = self._values.get("point_shape")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesPointShape"]]], result)

    @builtins.property
    def polygon_shape(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesPolygonShape"]]]:
        '''polygon_shape block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#polygon_shape DataAkamaiImagingPolicyImage#polygon_shape}
        '''
        result = self._values.get("polygon_shape")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesPolygonShape"]]], result)

    @builtins.property
    def rectangle_shape(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesRectangleShape"]]]:
        '''rectangle_shape block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rectangle_shape DataAkamaiImagingPolicyImage#rectangle_shape}
        '''
        result = self._values.get("rectangle_shape")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesRectangleShape"]]], result)

    @builtins.property
    def union_shape(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesUnionShape"]]]:
        '''union_shape block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#union_shape DataAkamaiImagingPolicyImage#union_shape}
        '''
        result = self._values.get("union_shape")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesUnionShape"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapes(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesCircleShape",
    jsii_struct_bases=[],
    name_mapping={"center": "center", "radius": "radius", "radius_var": "radiusVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesCircleShape:
    def __init__(
        self,
        *,
        center: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesCircleShapeCenter", typing.Dict[builtins.str, typing.Any]],
        radius: typing.Optional[builtins.str] = None,
        radius_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param center: center block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#center DataAkamaiImagingPolicyImage#center}
        :param radius: The radius of the circle measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#radius DataAkamaiImagingPolicyImage#radius}
        :param radius_var: The radius of the circle measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#radius_var DataAkamaiImagingPolicyImage#radius_var}
        '''
        if isinstance(center, dict):
            center = DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesCircleShapeCenter(**center)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7302f403465da47e3d91f9c79986a2661b3059e5233099e357b727cbae23e963)
            check_type(argname="argument center", value=center, expected_type=type_hints["center"])
            check_type(argname="argument radius", value=radius, expected_type=type_hints["radius"])
            check_type(argname="argument radius_var", value=radius_var, expected_type=type_hints["radius_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "center": center,
        }
        if radius is not None:
            self._values["radius"] = radius
        if radius_var is not None:
            self._values["radius_var"] = radius_var

    @builtins.property
    def center(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesCircleShapeCenter":
        '''center block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#center DataAkamaiImagingPolicyImage#center}
        '''
        result = self._values.get("center")
        assert result is not None, "Required property 'center' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesCircleShapeCenter", result)

    @builtins.property
    def radius(self) -> typing.Optional[builtins.str]:
        '''The radius of the circle measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#radius DataAkamaiImagingPolicyImage#radius}
        '''
        result = self._values.get("radius")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def radius_var(self) -> typing.Optional[builtins.str]:
        '''The radius of the circle measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#radius_var DataAkamaiImagingPolicyImage#radius_var}
        '''
        result = self._values.get("radius_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesCircleShape(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesCircleShapeCenter",
    jsii_struct_bases=[],
    name_mapping={"x": "x", "x_var": "xVar", "y": "y", "y_var": "yVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesCircleShapeCenter:
    def __init__(
        self,
        *,
        x: typing.Optional[builtins.str] = None,
        x_var: typing.Optional[builtins.str] = None,
        y: typing.Optional[builtins.str] = None,
        y_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param x: The horizontal position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x DataAkamaiImagingPolicyImage#x}
        :param x_var: The horizontal position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_var DataAkamaiImagingPolicyImage#x_var}
        :param y: The vertical position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y DataAkamaiImagingPolicyImage#y}
        :param y_var: The vertical position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_var DataAkamaiImagingPolicyImage#y_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f4263de66591d3a88a85b13a841355a347e389606a61a5ce9257a4100d47c24)
            check_type(argname="argument x", value=x, expected_type=type_hints["x"])
            check_type(argname="argument x_var", value=x_var, expected_type=type_hints["x_var"])
            check_type(argname="argument y", value=y, expected_type=type_hints["y"])
            check_type(argname="argument y_var", value=y_var, expected_type=type_hints["y_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if x is not None:
            self._values["x"] = x
        if x_var is not None:
            self._values["x_var"] = x_var
        if y is not None:
            self._values["y"] = y
        if y_var is not None:
            self._values["y_var"] = y_var

    @builtins.property
    def x(self) -> typing.Optional[builtins.str]:
        '''The horizontal position of the point, measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x DataAkamaiImagingPolicyImage#x}
        '''
        result = self._values.get("x")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_var(self) -> typing.Optional[builtins.str]:
        '''The horizontal position of the point, measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_var DataAkamaiImagingPolicyImage#x_var}
        '''
        result = self._values.get("x_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y(self) -> typing.Optional[builtins.str]:
        '''The vertical position of the point, measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y DataAkamaiImagingPolicyImage#y}
        '''
        result = self._values.get("y")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_var(self) -> typing.Optional[builtins.str]:
        '''The vertical position of the point, measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_var DataAkamaiImagingPolicyImage#y_var}
        '''
        result = self._values.get("y_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesCircleShapeCenter(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesCircleShapeCenterOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesCircleShapeCenterOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b04e1ddbd60845243aa04e35bfc19b2201ece3a95f45d52b7f096d1bf6bc0e5d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetX")
    def reset_x(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetX", []))

    @jsii.member(jsii_name="resetXVar")
    def reset_x_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXVar", []))

    @jsii.member(jsii_name="resetY")
    def reset_y(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetY", []))

    @jsii.member(jsii_name="resetYVar")
    def reset_y_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYVar", []))

    @builtins.property
    @jsii.member(jsii_name="xInput")
    def x_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xInput"))

    @builtins.property
    @jsii.member(jsii_name="xVarInput")
    def x_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yInput")
    def y_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yInput"))

    @builtins.property
    @jsii.member(jsii_name="yVarInput")
    def y_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yVarInput"))

    @builtins.property
    @jsii.member(jsii_name="x")
    def x(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "x"))

    @x.setter
    def x(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__30f0d17980cc4ea840a1513aaa7bc2df2d45e02b6829688aee35a185f3d63c2e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "x", value)

    @builtins.property
    @jsii.member(jsii_name="xVar")
    def x_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xVar"))

    @x_var.setter
    def x_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__075cb47e95dd485f05ada464257205b03da850200ba936c60b761ec3d77b47a6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xVar", value)

    @builtins.property
    @jsii.member(jsii_name="y")
    def y(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "y"))

    @y.setter
    def y(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2c32c3862f370315b5f03a9b6fc151409fbbdc37ab1d7a16cea3452367284f6a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "y", value)

    @builtins.property
    @jsii.member(jsii_name="yVar")
    def y_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yVar"))

    @y_var.setter
    def y_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__93792fbe6db30884b2bf8ddab71c86163e0597461e9e38bff74c85a29db27bad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesCircleShapeCenter]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesCircleShapeCenter], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesCircleShapeCenter],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__50a35394f955f191275a1f3cba479e6a9d6b8729164a2a9b0df596cb6473d65b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesCircleShapeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesCircleShapeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__96a1b8f4cfb53bedf8b624693ced09e289a6950a1a3910c6c9552af93d2015a7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesCircleShapeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dab54c245bf4761510dd94eb506a0d620128bb07433c540abad7aa01d0258721)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesCircleShapeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5351e4223af23ea60e4b4be556a0d57c3b7ed5736806acf4349ada233728911a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eaa75aaae51a506ed4c6ebac27490081d6384968261ed68ed142be654c15c086)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7bc805d0cb89654dde5c621f4062548256d3991209af46b01b398291df217c7f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesCircleShape]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesCircleShape]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesCircleShape]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c10b8c1e8a51454cf72d3c8ec589e2f4a5c4dc3d6833de784e88663127232364)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesCircleShapeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesCircleShapeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9285df640c778ad4100ce68814a74fbe6f89b50a43fb9c316dac339d7d7ec803)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putCenter")
    def put_center(
        self,
        *,
        x: typing.Optional[builtins.str] = None,
        x_var: typing.Optional[builtins.str] = None,
        y: typing.Optional[builtins.str] = None,
        y_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param x: The horizontal position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x DataAkamaiImagingPolicyImage#x}
        :param x_var: The horizontal position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_var DataAkamaiImagingPolicyImage#x_var}
        :param y: The vertical position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y DataAkamaiImagingPolicyImage#y}
        :param y_var: The vertical position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_var DataAkamaiImagingPolicyImage#y_var}
        '''
        value = DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesCircleShapeCenter(
            x=x, x_var=x_var, y=y, y_var=y_var
        )

        return typing.cast(None, jsii.invoke(self, "putCenter", [value]))

    @jsii.member(jsii_name="resetRadius")
    def reset_radius(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRadius", []))

    @jsii.member(jsii_name="resetRadiusVar")
    def reset_radius_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRadiusVar", []))

    @builtins.property
    @jsii.member(jsii_name="center")
    def center(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesCircleShapeCenterOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesCircleShapeCenterOutputReference, jsii.get(self, "center"))

    @builtins.property
    @jsii.member(jsii_name="centerInput")
    def center_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesCircleShapeCenter]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesCircleShapeCenter], jsii.get(self, "centerInput"))

    @builtins.property
    @jsii.member(jsii_name="radiusInput")
    def radius_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "radiusInput"))

    @builtins.property
    @jsii.member(jsii_name="radiusVarInput")
    def radius_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "radiusVarInput"))

    @builtins.property
    @jsii.member(jsii_name="radius")
    def radius(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "radius"))

    @radius.setter
    def radius(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e91016ca5409c86607b06ab027ac981d762b576de4fd281a1fef0e226de5e4fa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "radius", value)

    @builtins.property
    @jsii.member(jsii_name="radiusVar")
    def radius_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "radiusVar"))

    @radius_var.setter
    def radius_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__976a63d451519cb0f8f29543158411b627418325d4288fe408099bb681c47a78)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "radiusVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesCircleShape]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesCircleShape]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesCircleShape]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8b48b42081a79b486b9f95ccae25fd1d3926de9e2b8a2223520c6545f9dcc24d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__12c47f612685a33459cd15c24822a3aca12af145740fc993ed359c864234bec2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__02adc51eb5c93d2fb58f3c7132f41ebe89866a5d21f04a31ef999b2e5599885a)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__41cfafddca97dbaac33dc98f89bba506328e3563005ce648b8559b54b01689da)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5b106b0c2a35ea03de5282825c7e9bd19e70d137d0e1fefca9743deb70538570)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8d1377befbaed5f4cd8359bdb835a8fda054487b0a8c53910f9eec2aa05ac496)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapes]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapes]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapes]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6c08631b801c78256f4ae683371d00edcb59a50aad90812a21356adfda9d240c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__04cf1a1544c36ef184cca6b8b21d062ddfc14ad98bc07c710e54d377dc206fb9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putCircleShape")
    def put_circle_shape(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesCircleShape, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7432a6cb09564bfdde9eae03c5ba763466719bdf4bf86c7164ed7906f31b9950)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCircleShape", [value]))

    @jsii.member(jsii_name="putPointShape")
    def put_point_shape(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesPointShape", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7af14cd79b34f7091a9012b4a55c0f24f5f49f272391e91dfe721590bb873a0f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putPointShape", [value]))

    @jsii.member(jsii_name="putPolygonShape")
    def put_polygon_shape(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesPolygonShape", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b70d2768d579c8fa6402e833cb5d4b38312abc2848da5aa7fd07ea444880ec0f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putPolygonShape", [value]))

    @jsii.member(jsii_name="putRectangleShape")
    def put_rectangle_shape(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesRectangleShape", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__feae94da58e1d81f10e1f7dd57f12d33d9f02b78ebd73831ce182ea092eb1442)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putRectangleShape", [value]))

    @jsii.member(jsii_name="putUnionShape")
    def put_union_shape(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesUnionShape", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0777ed7a5125d9d479f371991e33662b7f153dc5d0a2af1036e81b2d5bc93641)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putUnionShape", [value]))

    @jsii.member(jsii_name="resetCircleShape")
    def reset_circle_shape(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCircleShape", []))

    @jsii.member(jsii_name="resetPointShape")
    def reset_point_shape(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPointShape", []))

    @jsii.member(jsii_name="resetPolygonShape")
    def reset_polygon_shape(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPolygonShape", []))

    @jsii.member(jsii_name="resetRectangleShape")
    def reset_rectangle_shape(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRectangleShape", []))

    @jsii.member(jsii_name="resetUnionShape")
    def reset_union_shape(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUnionShape", []))

    @builtins.property
    @jsii.member(jsii_name="circleShape")
    def circle_shape(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesCircleShapeList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesCircleShapeList, jsii.get(self, "circleShape"))

    @builtins.property
    @jsii.member(jsii_name="pointShape")
    def point_shape(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesPointShapeList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesPointShapeList", jsii.get(self, "pointShape"))

    @builtins.property
    @jsii.member(jsii_name="polygonShape")
    def polygon_shape(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesPolygonShapeList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesPolygonShapeList", jsii.get(self, "polygonShape"))

    @builtins.property
    @jsii.member(jsii_name="rectangleShape")
    def rectangle_shape(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesRectangleShapeList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesRectangleShapeList", jsii.get(self, "rectangleShape"))

    @builtins.property
    @jsii.member(jsii_name="unionShape")
    def union_shape(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesUnionShapeList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesUnionShapeList", jsii.get(self, "unionShape"))

    @builtins.property
    @jsii.member(jsii_name="circleShapeInput")
    def circle_shape_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesCircleShape]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesCircleShape]]], jsii.get(self, "circleShapeInput"))

    @builtins.property
    @jsii.member(jsii_name="pointShapeInput")
    def point_shape_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesPointShape"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesPointShape"]]], jsii.get(self, "pointShapeInput"))

    @builtins.property
    @jsii.member(jsii_name="polygonShapeInput")
    def polygon_shape_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesPolygonShape"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesPolygonShape"]]], jsii.get(self, "polygonShapeInput"))

    @builtins.property
    @jsii.member(jsii_name="rectangleShapeInput")
    def rectangle_shape_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesRectangleShape"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesRectangleShape"]]], jsii.get(self, "rectangleShapeInput"))

    @builtins.property
    @jsii.member(jsii_name="unionShapeInput")
    def union_shape_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesUnionShape"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesUnionShape"]]], jsii.get(self, "unionShapeInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapes]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapes]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapes]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__89da7ba53abe3ced8d03ad1e6bf84d266297e206c33f593dfb85dcfa99971859)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesPointShape",
    jsii_struct_bases=[],
    name_mapping={"x": "x", "x_var": "xVar", "y": "y", "y_var": "yVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesPointShape:
    def __init__(
        self,
        *,
        x: typing.Optional[builtins.str] = None,
        x_var: typing.Optional[builtins.str] = None,
        y: typing.Optional[builtins.str] = None,
        y_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param x: The horizontal position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x DataAkamaiImagingPolicyImage#x}
        :param x_var: The horizontal position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_var DataAkamaiImagingPolicyImage#x_var}
        :param y: The vertical position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y DataAkamaiImagingPolicyImage#y}
        :param y_var: The vertical position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_var DataAkamaiImagingPolicyImage#y_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f7e615da7c01a4cc473861d9917565cb444b1ec11509e3e306876a19a0d69304)
            check_type(argname="argument x", value=x, expected_type=type_hints["x"])
            check_type(argname="argument x_var", value=x_var, expected_type=type_hints["x_var"])
            check_type(argname="argument y", value=y, expected_type=type_hints["y"])
            check_type(argname="argument y_var", value=y_var, expected_type=type_hints["y_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if x is not None:
            self._values["x"] = x
        if x_var is not None:
            self._values["x_var"] = x_var
        if y is not None:
            self._values["y"] = y
        if y_var is not None:
            self._values["y_var"] = y_var

    @builtins.property
    def x(self) -> typing.Optional[builtins.str]:
        '''The horizontal position of the point, measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x DataAkamaiImagingPolicyImage#x}
        '''
        result = self._values.get("x")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_var(self) -> typing.Optional[builtins.str]:
        '''The horizontal position of the point, measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_var DataAkamaiImagingPolicyImage#x_var}
        '''
        result = self._values.get("x_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y(self) -> typing.Optional[builtins.str]:
        '''The vertical position of the point, measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y DataAkamaiImagingPolicyImage#y}
        '''
        result = self._values.get("y")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_var(self) -> typing.Optional[builtins.str]:
        '''The vertical position of the point, measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_var DataAkamaiImagingPolicyImage#y_var}
        '''
        result = self._values.get("y_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesPointShape(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesPointShapeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesPointShapeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__18c4c1bd46d622b7cb201b8df63bd450a3a30b4f72534633be769d70b1860764)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesPointShapeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a40a589fe5669ac3186312ae7bf0d85cc4e7cd21552b9fd43fdd08d1d2762180)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesPointShapeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5b5e86e1799333c928726d312f87beebdce13abaf966f96b9b60cbdcb4791ec7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1ec857cedd32c037e19619576a8ea9500ed6237b8c17b9ebf7b275c7200ec2ab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__577873e0c0330779d58c21779ebb4b24f7396613057085ef61d992b024615a0f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesPointShape]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesPointShape]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesPointShape]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e7bb19bab114e5a6fdea00ff56a96241808cb330e7e74b8a9c5222e16e2ccb8f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesPointShapeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesPointShapeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e52c14afbb00d5502412a7eb65e2ce2be4041a88a9230002b406b349d8fc408d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetX")
    def reset_x(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetX", []))

    @jsii.member(jsii_name="resetXVar")
    def reset_x_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXVar", []))

    @jsii.member(jsii_name="resetY")
    def reset_y(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetY", []))

    @jsii.member(jsii_name="resetYVar")
    def reset_y_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYVar", []))

    @builtins.property
    @jsii.member(jsii_name="xInput")
    def x_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xInput"))

    @builtins.property
    @jsii.member(jsii_name="xVarInput")
    def x_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yInput")
    def y_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yInput"))

    @builtins.property
    @jsii.member(jsii_name="yVarInput")
    def y_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yVarInput"))

    @builtins.property
    @jsii.member(jsii_name="x")
    def x(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "x"))

    @x.setter
    def x(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4fa6eb6a39c7b39db67fb897490c454d50b7e6ff749dbb0edb13ba330a8fd826)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "x", value)

    @builtins.property
    @jsii.member(jsii_name="xVar")
    def x_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xVar"))

    @x_var.setter
    def x_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c4140449d8de027f06b2347f29b4752316f25503f1f2d2a3be92fc6a33096f1a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xVar", value)

    @builtins.property
    @jsii.member(jsii_name="y")
    def y(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "y"))

    @y.setter
    def y(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3931c46e47f7aaf1b916afe7c3deb74bcae39314b5b5ffae3a61b24c4ad76d55)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "y", value)

    @builtins.property
    @jsii.member(jsii_name="yVar")
    def y_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yVar"))

    @y_var.setter
    def y_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__71c0289e5ee828a869f149eb05b7bbf218b9dd9ca04727a77369a2a7882b950e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesPointShape]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesPointShape]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesPointShape]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4728e6b252a63e179b571e425b8df5030cbb0b375910c0144c37761e1e637ca1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesPolygonShape",
    jsii_struct_bases=[],
    name_mapping={"points": "points"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesPolygonShape:
    def __init__(
        self,
        *,
        points: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesPolygonShapePoints", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param points: points block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#points DataAkamaiImagingPolicyImage#points}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4be290c1fef5319c7e8e4cd1d8671007d0e4fe7f571ea98fe1c9add0b6ce98a6)
            check_type(argname="argument points", value=points, expected_type=type_hints["points"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "points": points,
        }

    @builtins.property
    def points(
        self,
    ) -> typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesPolygonShapePoints"]]:
        '''points block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#points DataAkamaiImagingPolicyImage#points}
        '''
        result = self._values.get("points")
        assert result is not None, "Required property 'points' is missing"
        return typing.cast(typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesPolygonShapePoints"]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesPolygonShape(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesPolygonShapeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesPolygonShapeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b1fd9dfab75c42b1286276450bdfacf54fd10d585ac71f5d8e8ddc16d84769e3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesPolygonShapeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0edaf95ce342ced957a384db0c680c8ba0a1263566423f62b76b501b1fc5fdf2)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesPolygonShapeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2eb371255734877a53b5acc9c0cb6e712584ac202961876507f99be72fd61707)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a417a4725a960ededd51849ecffbcb90b81f7231f898b73983b5f45999b4071)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ec73b23ac194c128a071994184e3b7250c78ca08efc6f6b6863ffc87134bbbe4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesPolygonShape]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesPolygonShape]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesPolygonShape]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7bb8e69016b7d3b3b283a1d784111f3e4b2777169c5f588c2b9aac40b03d757c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesPolygonShapeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesPolygonShapeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9fd64a4077893d04a3cce6928cb60da1d25cf6c89d3281fcdacfe39c030bc81f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putPoints")
    def put_points(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesPolygonShapePoints", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__75fc092941b2d2866f34bc2a41798456924ed7f9b79eee944adc074d963e4393)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putPoints", [value]))

    @builtins.property
    @jsii.member(jsii_name="points")
    def points(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesPolygonShapePointsList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesPolygonShapePointsList", jsii.get(self, "points"))

    @builtins.property
    @jsii.member(jsii_name="pointsInput")
    def points_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesPolygonShapePoints"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesPolygonShapePoints"]]], jsii.get(self, "pointsInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesPolygonShape]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesPolygonShape]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesPolygonShape]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d11855f55cccf7adc3ec9e31f5cae6a98f33131e4a0ccea09e2b1f05f5435e78)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesPolygonShapePoints",
    jsii_struct_bases=[],
    name_mapping={"x": "x", "x_var": "xVar", "y": "y", "y_var": "yVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesPolygonShapePoints:
    def __init__(
        self,
        *,
        x: typing.Optional[builtins.str] = None,
        x_var: typing.Optional[builtins.str] = None,
        y: typing.Optional[builtins.str] = None,
        y_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param x: The horizontal position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x DataAkamaiImagingPolicyImage#x}
        :param x_var: The horizontal position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_var DataAkamaiImagingPolicyImage#x_var}
        :param y: The vertical position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y DataAkamaiImagingPolicyImage#y}
        :param y_var: The vertical position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_var DataAkamaiImagingPolicyImage#y_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9287d825a00beb6e67adc28352e424d428b70ba7b6cd51307e3b3adeb43da143)
            check_type(argname="argument x", value=x, expected_type=type_hints["x"])
            check_type(argname="argument x_var", value=x_var, expected_type=type_hints["x_var"])
            check_type(argname="argument y", value=y, expected_type=type_hints["y"])
            check_type(argname="argument y_var", value=y_var, expected_type=type_hints["y_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if x is not None:
            self._values["x"] = x
        if x_var is not None:
            self._values["x_var"] = x_var
        if y is not None:
            self._values["y"] = y
        if y_var is not None:
            self._values["y_var"] = y_var

    @builtins.property
    def x(self) -> typing.Optional[builtins.str]:
        '''The horizontal position of the point, measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x DataAkamaiImagingPolicyImage#x}
        '''
        result = self._values.get("x")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_var(self) -> typing.Optional[builtins.str]:
        '''The horizontal position of the point, measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_var DataAkamaiImagingPolicyImage#x_var}
        '''
        result = self._values.get("x_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y(self) -> typing.Optional[builtins.str]:
        '''The vertical position of the point, measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y DataAkamaiImagingPolicyImage#y}
        '''
        result = self._values.get("y")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_var(self) -> typing.Optional[builtins.str]:
        '''The vertical position of the point, measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_var DataAkamaiImagingPolicyImage#y_var}
        '''
        result = self._values.get("y_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesPolygonShapePoints(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesPolygonShapePointsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesPolygonShapePointsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6b7ce5ca2072320145ee011b75f692fbf59a0288119fd99c35955a83dfb877cd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesPolygonShapePointsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6219bdac4b07d9e6fc21c686db6ec6231757b3cce8172d4fe703b57c3c752c97)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesPolygonShapePointsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ca456d90a85e07024f812ae2180987255824dfc69beaf02965070a5601567492)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__796dfb9c8804781ccc2b7041a72d415c2fa4e76e55f9e5338c06f861485bc718)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c214cf386f77d1b7e402f313c3922c24abd730cd7ecb06ebd3b62e32bb9ff4e7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesPolygonShapePoints]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesPolygonShapePoints]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesPolygonShapePoints]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__34bd196685d31d198f338357b56a2e874f3e6318d2e21f60e97c53c5b191489f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesPolygonShapePointsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesPolygonShapePointsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7c5ec11d729a67805e4cdf94a98e4c463de5cdd297af19be021fd6c91392f4fe)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetX")
    def reset_x(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetX", []))

    @jsii.member(jsii_name="resetXVar")
    def reset_x_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXVar", []))

    @jsii.member(jsii_name="resetY")
    def reset_y(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetY", []))

    @jsii.member(jsii_name="resetYVar")
    def reset_y_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYVar", []))

    @builtins.property
    @jsii.member(jsii_name="xInput")
    def x_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xInput"))

    @builtins.property
    @jsii.member(jsii_name="xVarInput")
    def x_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yInput")
    def y_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yInput"))

    @builtins.property
    @jsii.member(jsii_name="yVarInput")
    def y_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yVarInput"))

    @builtins.property
    @jsii.member(jsii_name="x")
    def x(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "x"))

    @x.setter
    def x(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df38978e88034a570e784dde6d44d2d1d4fc7d86fade4d15e0085c19764b63e1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "x", value)

    @builtins.property
    @jsii.member(jsii_name="xVar")
    def x_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xVar"))

    @x_var.setter
    def x_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b843de2f2e0e25f51cc39e468db31ec0d2d4ac3e9fc6d592c65aa356a5a4dd06)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xVar", value)

    @builtins.property
    @jsii.member(jsii_name="y")
    def y(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "y"))

    @y.setter
    def y(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__19cda8205b4458da649fa6b410f3a7477bcf99bffc80a37f4899f3de4669670f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "y", value)

    @builtins.property
    @jsii.member(jsii_name="yVar")
    def y_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yVar"))

    @y_var.setter
    def y_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__102f4b45e65fc9ecea712071a8521f9dae42f47148e965dc2c955cebd8b2063b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesPolygonShapePoints]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesPolygonShapePoints]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesPolygonShapePoints]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8d064f425ddc414af1dbf926d83ab2ddb535a34b94165d74d467fd7a4be23f07)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesRectangleShape",
    jsii_struct_bases=[],
    name_mapping={
        "anchor": "anchor",
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesRectangleShape:
    def __init__(
        self,
        *,
        anchor: typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesRectangleShapeAnchor", typing.Dict[builtins.str, typing.Any]],
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param anchor: anchor block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#anchor DataAkamaiImagingPolicyImage#anchor}
        :param height: Extends the rectangle down from the ``anchor`` point. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: Extends the rectangle down from the ``anchor`` point. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: Extends the rectangle right from the ``anchor`` point. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: Extends the rectangle right from the ``anchor`` point. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if isinstance(anchor, dict):
            anchor = DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesRectangleShapeAnchor(**anchor)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e52b5343447d0c87dbf1a4479790e4ea74c2d1c0274679a1b222157372d6bbe)
            check_type(argname="argument anchor", value=anchor, expected_type=type_hints["anchor"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "anchor": anchor,
        }
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def anchor(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesRectangleShapeAnchor":
        '''anchor block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#anchor DataAkamaiImagingPolicyImage#anchor}
        '''
        result = self._values.get("anchor")
        assert result is not None, "Required property 'anchor' is missing"
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesRectangleShapeAnchor", result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''Extends the rectangle down from the ``anchor`` point.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''Extends the rectangle down from the ``anchor`` point.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''Extends the rectangle right from the ``anchor`` point.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''Extends the rectangle right from the ``anchor`` point.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesRectangleShape(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesRectangleShapeAnchor",
    jsii_struct_bases=[],
    name_mapping={"x": "x", "x_var": "xVar", "y": "y", "y_var": "yVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesRectangleShapeAnchor:
    def __init__(
        self,
        *,
        x: typing.Optional[builtins.str] = None,
        x_var: typing.Optional[builtins.str] = None,
        y: typing.Optional[builtins.str] = None,
        y_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param x: The horizontal position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x DataAkamaiImagingPolicyImage#x}
        :param x_var: The horizontal position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_var DataAkamaiImagingPolicyImage#x_var}
        :param y: The vertical position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y DataAkamaiImagingPolicyImage#y}
        :param y_var: The vertical position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_var DataAkamaiImagingPolicyImage#y_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9be9c5ad9a0d14115d0a4577538e85404312d9f3823bc931e661ff60dc1a417f)
            check_type(argname="argument x", value=x, expected_type=type_hints["x"])
            check_type(argname="argument x_var", value=x_var, expected_type=type_hints["x_var"])
            check_type(argname="argument y", value=y, expected_type=type_hints["y"])
            check_type(argname="argument y_var", value=y_var, expected_type=type_hints["y_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if x is not None:
            self._values["x"] = x
        if x_var is not None:
            self._values["x_var"] = x_var
        if y is not None:
            self._values["y"] = y
        if y_var is not None:
            self._values["y_var"] = y_var

    @builtins.property
    def x(self) -> typing.Optional[builtins.str]:
        '''The horizontal position of the point, measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x DataAkamaiImagingPolicyImage#x}
        '''
        result = self._values.get("x")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_var(self) -> typing.Optional[builtins.str]:
        '''The horizontal position of the point, measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_var DataAkamaiImagingPolicyImage#x_var}
        '''
        result = self._values.get("x_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y(self) -> typing.Optional[builtins.str]:
        '''The vertical position of the point, measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y DataAkamaiImagingPolicyImage#y}
        '''
        result = self._values.get("y")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_var(self) -> typing.Optional[builtins.str]:
        '''The vertical position of the point, measured in pixels.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_var DataAkamaiImagingPolicyImage#y_var}
        '''
        result = self._values.get("y_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesRectangleShapeAnchor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesRectangleShapeAnchorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesRectangleShapeAnchorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__682df7af1de20945da0a662305e77d4e26d37b13dc5439877a754acf1766914c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetX")
    def reset_x(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetX", []))

    @jsii.member(jsii_name="resetXVar")
    def reset_x_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXVar", []))

    @jsii.member(jsii_name="resetY")
    def reset_y(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetY", []))

    @jsii.member(jsii_name="resetYVar")
    def reset_y_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYVar", []))

    @builtins.property
    @jsii.member(jsii_name="xInput")
    def x_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xInput"))

    @builtins.property
    @jsii.member(jsii_name="xVarInput")
    def x_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yInput")
    def y_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yInput"))

    @builtins.property
    @jsii.member(jsii_name="yVarInput")
    def y_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yVarInput"))

    @builtins.property
    @jsii.member(jsii_name="x")
    def x(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "x"))

    @x.setter
    def x(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__223aeb665ee9cf64d969f138decda7e35fd82a129285f38a2a7e2349c62c9856)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "x", value)

    @builtins.property
    @jsii.member(jsii_name="xVar")
    def x_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xVar"))

    @x_var.setter
    def x_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__763b7c394bdc88e20d16de9ec3a38c8e05879c49c59317c94719f3f2ab5bce1c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xVar", value)

    @builtins.property
    @jsii.member(jsii_name="y")
    def y(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "y"))

    @y.setter
    def y(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__09b218652ba5c5c2b78cd359d69122ebfd9553e162be29437258eb8e410920bb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "y", value)

    @builtins.property
    @jsii.member(jsii_name="yVar")
    def y_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yVar"))

    @y_var.setter
    def y_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0a9afac9cdd280d77f60f2fb81592a2d95ac1ceead3e2ec5792832e9151ad777)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesRectangleShapeAnchor]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesRectangleShapeAnchor], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesRectangleShapeAnchor],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6d78d2f1ca7757e20223c272b27102c2703150118da7d61088e3be4c0ed8cd33)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesRectangleShapeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesRectangleShapeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0016c99da4ab158c98a15f2d7b7dcadbf782f9392169dd7d9a37e2d123083a00)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesRectangleShapeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3e5d49de262d368d53fe053ef83e58ccf4887b6224f8c2b905d6272650b21a42)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesRectangleShapeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a9d404183983ce4649c1d1394f958c2be7d3461272a04014a4de52f4bff145a1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f87546a8d0327c83bbe9842180d985f6c51214bb5550968a322744e97de3844c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a95b7b113cd643f3418f285a15db8f136af84ff434e186593cb6ac3c334a2522)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesRectangleShape]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesRectangleShape]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesRectangleShape]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a292a9929a2540f9d12e471f1336b1f7faf787a10dfbaee5fd5ae7a99488c256)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesRectangleShapeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesRectangleShapeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__05611bd1678d84bf4a26c0b8cea316bf86250fd6028d880e27e27db2829dcd7b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putAnchor")
    def put_anchor(
        self,
        *,
        x: typing.Optional[builtins.str] = None,
        x_var: typing.Optional[builtins.str] = None,
        y: typing.Optional[builtins.str] = None,
        y_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param x: The horizontal position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x DataAkamaiImagingPolicyImage#x}
        :param x_var: The horizontal position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_var DataAkamaiImagingPolicyImage#x_var}
        :param y: The vertical position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y DataAkamaiImagingPolicyImage#y}
        :param y_var: The vertical position of the point, measured in pixels. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_var DataAkamaiImagingPolicyImage#y_var}
        '''
        value = DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesRectangleShapeAnchor(
            x=x, x_var=x_var, y=y, y_var=y_var
        )

        return typing.cast(None, jsii.invoke(self, "putAnchor", [value]))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="anchor")
    def anchor(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesRectangleShapeAnchorOutputReference:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesRectangleShapeAnchorOutputReference, jsii.get(self, "anchor"))

    @builtins.property
    @jsii.member(jsii_name="anchorInput")
    def anchor_input(
        self,
    ) -> typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesRectangleShapeAnchor]:
        return typing.cast(typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesRectangleShapeAnchor], jsii.get(self, "anchorInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__78a32532a328bb45e3ecda7a748c42e3f8c951717e83ef1a53f25afac7ab39a1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__120d4db379df39653771f333c0205d29d70a73a7a63a83b953accc1e4b968ff4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6300086d9d2d978e645fcf6c4082549f97a603527ddd77b63a2be60e8ef8cc27)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d33912cc3ac60b2287ff57c67a206950e03a1b399cb0f516e6bd1f549b96ce29)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesRectangleShape]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesRectangleShape]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesRectangleShape]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8392157b343159aee4efe671ae1ed804b35cc4a013ea713da94cbd87276980d6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesUnionShape",
    jsii_struct_bases=[],
    name_mapping={"shapes": "shapes"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesUnionShape:
    def __init__(
        self,
        *,
        shapes: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesUnionShapeShapes", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param shapes: shapes block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shapes DataAkamaiImagingPolicyImage#shapes}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1c03bdf0f9a2c728e1650c730cb258b46d9c84d48f3ac32cdd8824f1ec0f6da0)
            check_type(argname="argument shapes", value=shapes, expected_type=type_hints["shapes"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "shapes": shapes,
        }

    @builtins.property
    def shapes(
        self,
    ) -> typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesUnionShapeShapes"]]:
        '''shapes block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shapes DataAkamaiImagingPolicyImage#shapes}
        '''
        result = self._values.get("shapes")
        assert result is not None, "Required property 'shapes' is missing"
        return typing.cast(typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesUnionShapeShapes"]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesUnionShape(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesUnionShapeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesUnionShapeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac01b17d800ccce295accf5bbbfd1d458e9b84d0b336a2b1c205be2c869c0c77)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesUnionShapeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__453adfe65f2f86b36834bf508b61d94a947d3750a63ed9770c4e85bcbd6caff8)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesUnionShapeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be29612fa3e6a4e73d975a3bac8b9e8f91ba860f50ca9469859e101b865ea74e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__089a1ed4e527c643e99acc5852c2c53e21ff8f2a1bf7ebc01ab1a3f8ba213670)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__719fec3e2d6834d009c5299985a09ed810301ab349d2ebf5c6c8be16b65fec23)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesUnionShape]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesUnionShape]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesUnionShape]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a79c4d3b7f3dcf73afebc0311f3ecc200db8962d2f947e5d24e183780efd5023)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesUnionShapeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesUnionShapeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__940fcb74d8d17716e3bba341f3c4f789683bbe34484d03f655b866bb841d4c43)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putShapes")
    def put_shapes(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesUnionShapeShapes", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__06605d22cb4d1c294f70b93deb7d1951eaa486aa9462ddf7f62671e116da7644)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putShapes", [value]))

    @builtins.property
    @jsii.member(jsii_name="shapes")
    def shapes(
        self,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesUnionShapeShapesList":
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesUnionShapeShapesList", jsii.get(self, "shapes"))

    @builtins.property
    @jsii.member(jsii_name="shapesInput")
    def shapes_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesUnionShapeShapes"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesUnionShapeShapes"]]], jsii.get(self, "shapesInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesUnionShape]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesUnionShape]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesUnionShape]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fbf7e37119f428ff7cde4c49ab76bb890bd9be95ae0f881cbf7e9bd526b316bf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesUnionShapeShapes",
    jsii_struct_bases=[],
    name_mapping={},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesUnionShapeShapes:
    def __init__(self) -> None:
        self._values: typing.Dict[builtins.str, typing.Any] = {}

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesUnionShapeShapes(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesUnionShapeShapesList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesUnionShapeShapesList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__005256edc4f641260ad935b5f10041fdb931a8736bc24a4e9c7f69b1b42812b8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesUnionShapeShapesOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b6d5051aa2a5f910a4c5e6f126cc34bf08e79adc76b39cdcadb6b287044ce817)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesUnionShapeShapesOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2aedc7113e3eb4945e7746848bc84aa127116a7f4c3dc4a4f8dfe39d3472c033)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1a41a4843965d289f4dac2485e3bbd9f8643d85c834c0f5c7b31d85733c624ab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8c91235e3e81472696df9f4119ea7050941c657dbf91215bfa7bb699a3abc224)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesUnionShapeShapes]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesUnionShapeShapes]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesUnionShapeShapes]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e10bac6862dbc584ef84c353b9e569a660b36ecedc0402ff55f8f2ed0bf9b2a1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesUnionShapeShapesOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesUnionShapeShapesOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a2181e96c9507982144bfd34756caf21f21dad44efd19b79804f9eae5b62fb50)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesUnionShapeShapes]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesUnionShapeShapes]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesUnionShapeShapes]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5e5e32f69fe0e6c788daf04eb8c0cfbd4044b17d9178a1e13422156b6abd7d41)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsRelativeCrop",
    jsii_struct_bases=[],
    name_mapping={
        "east": "east",
        "east_var": "eastVar",
        "north": "north",
        "north_var": "northVar",
        "south": "south",
        "south_var": "southVar",
        "west": "west",
        "west_var": "westVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsRelativeCrop:
    def __init__(
        self,
        *,
        east: typing.Optional[builtins.str] = None,
        east_var: typing.Optional[builtins.str] = None,
        north: typing.Optional[builtins.str] = None,
        north_var: typing.Optional[builtins.str] = None,
        south: typing.Optional[builtins.str] = None,
        south_var: typing.Optional[builtins.str] = None,
        west: typing.Optional[builtins.str] = None,
        west_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param east: The number of pixels to shrink or expand the right side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east DataAkamaiImagingPolicyImage#east}
        :param east_var: The number of pixels to shrink or expand the right side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east_var DataAkamaiImagingPolicyImage#east_var}
        :param north: The number of pixels to shrink or expand the top side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north DataAkamaiImagingPolicyImage#north}
        :param north_var: The number of pixels to shrink or expand the top side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north_var DataAkamaiImagingPolicyImage#north_var}
        :param south: The number of pixels to shrink or expand the bottom side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south DataAkamaiImagingPolicyImage#south}
        :param south_var: The number of pixels to shrink or expand the bottom side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south_var DataAkamaiImagingPolicyImage#south_var}
        :param west: The number of pixels to shrink or expand the left side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west DataAkamaiImagingPolicyImage#west}
        :param west_var: The number of pixels to shrink or expand the left side of the image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west_var DataAkamaiImagingPolicyImage#west_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e7e47957ee8eefaeb96c4ad851c00ee4c1cf92ec09a80210da0f641f237655b)
            check_type(argname="argument east", value=east, expected_type=type_hints["east"])
            check_type(argname="argument east_var", value=east_var, expected_type=type_hints["east_var"])
            check_type(argname="argument north", value=north, expected_type=type_hints["north"])
            check_type(argname="argument north_var", value=north_var, expected_type=type_hints["north_var"])
            check_type(argname="argument south", value=south, expected_type=type_hints["south"])
            check_type(argname="argument south_var", value=south_var, expected_type=type_hints["south_var"])
            check_type(argname="argument west", value=west, expected_type=type_hints["west"])
            check_type(argname="argument west_var", value=west_var, expected_type=type_hints["west_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if east is not None:
            self._values["east"] = east
        if east_var is not None:
            self._values["east_var"] = east_var
        if north is not None:
            self._values["north"] = north
        if north_var is not None:
            self._values["north_var"] = north_var
        if south is not None:
            self._values["south"] = south
        if south_var is not None:
            self._values["south_var"] = south_var
        if west is not None:
            self._values["west"] = west
        if west_var is not None:
            self._values["west_var"] = west_var

    @builtins.property
    def east(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the right side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east DataAkamaiImagingPolicyImage#east}
        '''
        result = self._values.get("east")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def east_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the right side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east_var DataAkamaiImagingPolicyImage#east_var}
        '''
        result = self._values.get("east_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def north(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the top side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north DataAkamaiImagingPolicyImage#north}
        '''
        result = self._values.get("north")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def north_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the top side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north_var DataAkamaiImagingPolicyImage#north_var}
        '''
        result = self._values.get("north_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def south(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the bottom side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south DataAkamaiImagingPolicyImage#south}
        '''
        result = self._values.get("south")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def south_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the bottom side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south_var DataAkamaiImagingPolicyImage#south_var}
        '''
        result = self._values.get("south_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def west(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the left side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west DataAkamaiImagingPolicyImage#west}
        '''
        result = self._values.get("west")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def west_var(self) -> typing.Optional[builtins.str]:
        '''The number of pixels to shrink or expand the left side of the image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west_var DataAkamaiImagingPolicyImage#west_var}
        '''
        result = self._values.get("west_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsRelativeCrop(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsRelativeCropList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsRelativeCropList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ef3e0f35ae24812c538432aa426cd8656a7a5c07766c262290121537376cf349)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsRelativeCropOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a13086844d8a4761451b2bb44e173b044263aa792c790e1ea21c48c85e59d031)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsRelativeCropOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1c96d2f8863795d516a04158054d8e60ab556b2c23140c7c9dbbecead3d3375e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__40cb2f5af6e0a6eb4fb2861930269d9d5914bdf8edaecec4f58deca85b28c5c7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__29108f5dd986d2df91af93c53fa2ae24e89cdd7647b7205cf507dd73c316f51f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsRelativeCrop]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsRelativeCrop]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsRelativeCrop]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__21ee3dc617243ba43068c205f3ae058a6f83c3ceedec593cca4d15e7cb3121b7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsRelativeCropOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsRelativeCropOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__21e46acdce16d737aea3a1e51dfc150c57362cc9f100be2b5591605460fd1ddd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetEast")
    def reset_east(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEast", []))

    @jsii.member(jsii_name="resetEastVar")
    def reset_east_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEastVar", []))

    @jsii.member(jsii_name="resetNorth")
    def reset_north(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNorth", []))

    @jsii.member(jsii_name="resetNorthVar")
    def reset_north_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNorthVar", []))

    @jsii.member(jsii_name="resetSouth")
    def reset_south(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSouth", []))

    @jsii.member(jsii_name="resetSouthVar")
    def reset_south_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSouthVar", []))

    @jsii.member(jsii_name="resetWest")
    def reset_west(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWest", []))

    @jsii.member(jsii_name="resetWestVar")
    def reset_west_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWestVar", []))

    @builtins.property
    @jsii.member(jsii_name="eastInput")
    def east_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "eastInput"))

    @builtins.property
    @jsii.member(jsii_name="eastVarInput")
    def east_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "eastVarInput"))

    @builtins.property
    @jsii.member(jsii_name="northInput")
    def north_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "northInput"))

    @builtins.property
    @jsii.member(jsii_name="northVarInput")
    def north_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "northVarInput"))

    @builtins.property
    @jsii.member(jsii_name="southInput")
    def south_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "southInput"))

    @builtins.property
    @jsii.member(jsii_name="southVarInput")
    def south_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "southVarInput"))

    @builtins.property
    @jsii.member(jsii_name="westInput")
    def west_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "westInput"))

    @builtins.property
    @jsii.member(jsii_name="westVarInput")
    def west_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "westVarInput"))

    @builtins.property
    @jsii.member(jsii_name="east")
    def east(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "east"))

    @east.setter
    def east(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df06301e212884515625d66875e7536fa0d7232b5d3f8d2e8bca3e99ecfcf964)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "east", value)

    @builtins.property
    @jsii.member(jsii_name="eastVar")
    def east_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "eastVar"))

    @east_var.setter
    def east_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a28adb51dcbb69e6340d184e0c804a08a36f880100191820493a81bc7cb0949)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "eastVar", value)

    @builtins.property
    @jsii.member(jsii_name="north")
    def north(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "north"))

    @north.setter
    def north(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__25ed8cb8d7e132982712f63cb4e2abc1a29018a8c83be6d44bc3000ea9c4a6c0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "north", value)

    @builtins.property
    @jsii.member(jsii_name="northVar")
    def north_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "northVar"))

    @north_var.setter
    def north_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f6d6385bc4cac1d2395bdd344a541718222a93960d80dcbc297b175de1048c4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "northVar", value)

    @builtins.property
    @jsii.member(jsii_name="south")
    def south(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "south"))

    @south.setter
    def south(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6ed4edf8931efe62d25936c23e0be89becb0fd2ab6d7112fccc6296b1e75c915)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "south", value)

    @builtins.property
    @jsii.member(jsii_name="southVar")
    def south_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "southVar"))

    @south_var.setter
    def south_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__912165329def9684cbfc8aea3eda71933dca2959bf4b4ecde4dfd8fc51d67464)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "southVar", value)

    @builtins.property
    @jsii.member(jsii_name="west")
    def west(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "west"))

    @west.setter
    def west(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bf976aa551e0d730ff376a73777faa5ca7cab6ff9fb1dbc26b3a1d1b455138ee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "west", value)

    @builtins.property
    @jsii.member(jsii_name="westVar")
    def west_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "westVar"))

    @west_var.setter
    def west_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab411c29ecb23fb7070542deb52e112695fcac68aa653c59a24645c80dc7593e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "westVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsRelativeCrop]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsRelativeCrop]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsRelativeCrop]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__99d46e33107cc358542afbff701308411b3414402d67c72197c33cbac670a705)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsRemoveColor",
    jsii_struct_bases=[],
    name_mapping={
        "color": "color",
        "color_var": "colorVar",
        "feather": "feather",
        "feather_var": "featherVar",
        "tolerance": "tolerance",
        "tolerance_var": "toleranceVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsRemoveColor:
    def __init__(
        self,
        *,
        color: typing.Optional[builtins.str] = None,
        color_var: typing.Optional[builtins.str] = None,
        feather: typing.Optional[builtins.str] = None,
        feather_var: typing.Optional[builtins.str] = None,
        tolerance: typing.Optional[builtins.str] = None,
        tolerance_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param color: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        :param color_var: The hexadecimal CSS color value to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        :param feather: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        :param feather_var: The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge. The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        :param tolerance: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        :param tolerance_var: The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__10143cc4749f3c1ecea820a6f930f0e7d6733fa86295c08fbe8834aaa51f8a56)
            check_type(argname="argument color", value=color, expected_type=type_hints["color"])
            check_type(argname="argument color_var", value=color_var, expected_type=type_hints["color_var"])
            check_type(argname="argument feather", value=feather, expected_type=type_hints["feather"])
            check_type(argname="argument feather_var", value=feather_var, expected_type=type_hints["feather_var"])
            check_type(argname="argument tolerance", value=tolerance, expected_type=type_hints["tolerance"])
            check_type(argname="argument tolerance_var", value=tolerance_var, expected_type=type_hints["tolerance_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if color is not None:
            self._values["color"] = color
        if color_var is not None:
            self._values["color_var"] = color_var
        if feather is not None:
            self._values["feather"] = feather
        if feather_var is not None:
            self._values["feather_var"] = feather_var
        if tolerance is not None:
            self._values["tolerance"] = tolerance
        if tolerance_var is not None:
            self._values["tolerance_var"] = tolerance_var

    @builtins.property
    def color(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
        '''
        result = self._values.get("color")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def color_var(self) -> typing.Optional[builtins.str]:
        '''The hexadecimal CSS color value to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
        '''
        result = self._values.get("color_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
        '''
        result = self._values.get("feather")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def feather_var(self) -> typing.Optional[builtins.str]:
        '''The RemoveColor transformation may create a hard edge around an image.

        To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
        '''
        result = self._values.get("feather_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
        '''
        result = self._values.get("tolerance")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tolerance_var(self) -> typing.Optional[builtins.str]:
        '''The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent.

        Set the Tolerance to 0.0 to remove only the exact color specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
        '''
        result = self._values.get("tolerance_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsRemoveColor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsRemoveColorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsRemoveColorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__08ee2a5f33d181952ae1c6067cbbf441c95d10520977c1e5f2ac7b91a8ded197)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsRemoveColorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8dbcd8786cd5a537532e2ab7b658670dc017d6349f723c7afe6c7de8c6bf89d8)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsRemoveColorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e8b3bf5904f2f08433b533b3f993710dc389b8f38cbfef229abd7ff8432f9f33)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e5288dce7f0e4951a340fe187986f5b4e6a364612aeedbd10ff2f29013947808)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__014ef7c2508307e90fc2f305d0218eb72cf635d626807ffb8088e7b3018fc9a9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsRemoveColor]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsRemoveColor]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsRemoveColor]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__426ea3b44ac6fa55499bd17f1634609e996cb68f41706bd1e6e62c100efb634e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsRemoveColorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsRemoveColorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__59e480e549690a21f11edb4f7425e7bf8522631eab1e0bafc2cf22ae35d1b72b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetColor")
    def reset_color(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColor", []))

    @jsii.member(jsii_name="resetColorVar")
    def reset_color_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetColorVar", []))

    @jsii.member(jsii_name="resetFeather")
    def reset_feather(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeather", []))

    @jsii.member(jsii_name="resetFeatherVar")
    def reset_feather_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFeatherVar", []))

    @jsii.member(jsii_name="resetTolerance")
    def reset_tolerance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTolerance", []))

    @jsii.member(jsii_name="resetToleranceVar")
    def reset_tolerance_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetToleranceVar", []))

    @builtins.property
    @jsii.member(jsii_name="colorInput")
    def color_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorInput"))

    @builtins.property
    @jsii.member(jsii_name="colorVarInput")
    def color_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "colorVarInput"))

    @builtins.property
    @jsii.member(jsii_name="featherInput")
    def feather_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherInput"))

    @builtins.property
    @jsii.member(jsii_name="featherVarInput")
    def feather_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "featherVarInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceInput")
    def tolerance_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceInput"))

    @builtins.property
    @jsii.member(jsii_name="toleranceVarInput")
    def tolerance_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toleranceVarInput"))

    @builtins.property
    @jsii.member(jsii_name="color")
    def color(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "color"))

    @color.setter
    def color(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__11436940a5630142eba1e3a635beeafc270b53479045eec4a56bc78b867df18d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "color", value)

    @builtins.property
    @jsii.member(jsii_name="colorVar")
    def color_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "colorVar"))

    @color_var.setter
    def color_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__13ee8e769e0d79be6526e6dc714ddb565433e776e605c4a2e4ab633f732b958f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "colorVar", value)

    @builtins.property
    @jsii.member(jsii_name="feather")
    def feather(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "feather"))

    @feather.setter
    def feather(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4cd5d8c51abaf53e63fe681e195fc07f176c4e86531abc5fd584d48e06bf5d45)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "feather", value)

    @builtins.property
    @jsii.member(jsii_name="featherVar")
    def feather_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "featherVar"))

    @feather_var.setter
    def feather_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__79cdd3a8444187c48232f1af38572fa379b20bbb879ae5396e3e9e5519401225)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "featherVar", value)

    @builtins.property
    @jsii.member(jsii_name="tolerance")
    def tolerance(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tolerance"))

    @tolerance.setter
    def tolerance(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__91be373548e25d1a472a4a2a992f94b4d5657dcbd3f16485d796b687344f15a4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tolerance", value)

    @builtins.property
    @jsii.member(jsii_name="toleranceVar")
    def tolerance_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "toleranceVar"))

    @tolerance_var.setter
    def tolerance_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1e33988177fb8106c6eb1f93c9d759ad269040f632c88fa57c7354de953cf397)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "toleranceVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsRemoveColor]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsRemoveColor]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsRemoveColor]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__89499fcc6c319dc908c4043fdb8056e0d3cb3c180e03aca81a0ab3e6ff5f9376)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsResize",
    jsii_struct_bases=[],
    name_mapping={
        "aspect": "aspect",
        "aspect_var": "aspectVar",
        "height": "height",
        "height_var": "heightVar",
        "type": "type",
        "type_var": "typeVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsResize:
    def __init__(
        self,
        *,
        aspect: typing.Optional[builtins.str] = None,
        aspect_var: typing.Optional[builtins.str] = None,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        type: typing.Optional[builtins.str] = None,
        type_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param aspect: Preserves the aspect ratio. Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect DataAkamaiImagingPolicyImage#aspect}
        :param aspect_var: Preserves the aspect ratio. Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_var DataAkamaiImagingPolicyImage#aspect_var}
        :param height: The height to resize the source image to. Must be set if height is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: The height to resize the source image to. Must be set if height is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param type: Sets constraints for the image resize. Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param type_var: Sets constraints for the image resize. Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        :param width: The width to resize the source image to. Must be set if width is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: The width to resize the source image to. Must be set if width is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6bf28727fa0a2fa107176746bcb1ce7baf7ca50aafa76c03bb83ac05b172e8b3)
            check_type(argname="argument aspect", value=aspect, expected_type=type_hints["aspect"])
            check_type(argname="argument aspect_var", value=aspect_var, expected_type=type_hints["aspect_var"])
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument type_var", value=type_var, expected_type=type_hints["type_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if aspect is not None:
            self._values["aspect"] = aspect
        if aspect_var is not None:
            self._values["aspect_var"] = aspect_var
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if type is not None:
            self._values["type"] = type
        if type_var is not None:
            self._values["type_var"] = type_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def aspect(self) -> typing.Optional[builtins.str]:
        '''Preserves the aspect ratio.

        Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect DataAkamaiImagingPolicyImage#aspect}
        '''
        result = self._values.get("aspect")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def aspect_var(self) -> typing.Optional[builtins.str]:
        '''Preserves the aspect ratio.

        Select ``fit`` to make the image fit entirely within the selected width and height. When using ``fit``, the resulting image has the largest possible size for the specified dimensions. Select ``fill`` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise ``ignore`` changes the original aspect ratio to fit within an arbitrarily shaped rectangle.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_var DataAkamaiImagingPolicyImage#aspect_var}
        '''
        result = self._values.get("aspect_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''The height to resize the source image to. Must be set if height is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''The height to resize the source image to. Must be set if height is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''Sets constraints for the image resize.

        Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type_var(self) -> typing.Optional[builtins.str]:
        '''Sets constraints for the image resize.

        Select ``normal`` to resize in all cases, either increasing or decreasing the dimensions. Select ``downsize`` to ignore this transformation if the result would be larger than the original. Select ``upsize`` to ignore this transformation if the result would be smaller.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
        '''
        result = self._values.get("type_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''The width to resize the source image to. Must be set if width is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''The width to resize the source image to. Must be set if width is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsResize(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsResizeList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsResizeList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c8d7408aa807b76416031566ff70663c363c3407fd232f02720f863523233fbf)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsResizeOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8f132156ccabbae2eb180d0750dd86d32b609b459f323ccc48277ded972e553e)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsResizeOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d02cd2db0f254a0a00b0541d0c141a762321bc717496fe03f5db9bafc410f245)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__46c0cf4d07b2f89aca65da3d87d2aa0bb0c3e5b119b866001c7fefd4498b28af)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__821e4c0ea419483ba23d7b42e65c0879ad2be4d5f0b0d3409738e9cfa0571430)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsResize]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsResize]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsResize]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd3d94071a19062f4199a961a3ce2c4f30ebaeee95e8fa063a86daafd5804692)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsResizeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsResizeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fd76206015bfe94fa7ab14d9e2f9dd9d7e4b2d56f4779ac3f6661faa2201dd53)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAspect")
    def reset_aspect(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspect", []))

    @jsii.member(jsii_name="resetAspectVar")
    def reset_aspect_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAspectVar", []))

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetTypeVar")
    def reset_type_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypeVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="aspectInput")
    def aspect_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "aspectInput"))

    @builtins.property
    @jsii.member(jsii_name="aspectVarInput")
    def aspect_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "aspectVarInput"))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="typeVarInput")
    def type_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="aspect")
    def aspect(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "aspect"))

    @aspect.setter
    def aspect(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__db3191b96de6ee27329253151625d566c862bb442240d75f6aa6911728f9b4b5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "aspect", value)

    @builtins.property
    @jsii.member(jsii_name="aspectVar")
    def aspect_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "aspectVar"))

    @aspect_var.setter
    def aspect_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2fd3a9c8fa3cfb6b080d07b66083a3491751d867f54ddda8d8a489497bf93106)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "aspectVar", value)

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f9751d9ce27b9d5e13079e91c74273ab11b9148a422c8a8cd728c05caa6a82e5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__31fe8a83cd2d1314dbba9ada09fdfdcb20826ed162095e4580e9e5c487eeb902)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__915ccc0e6b95c3f178779cf31d202a4a4de98142aeed9d77913139c417902374)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="typeVar")
    def type_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typeVar"))

    @type_var.setter
    def type_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__737f56d9c0017e2f25a3c03f1df780371d07c00c7ed5a7cd7f5aba3386e11eaf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typeVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df3367ee52d0153a81c9b48db8ff57e75048f924854addb0639da28252683d7c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7816e3262e7bdd46ea72cf5c0b4000834ea50ab81a603ab33ab31eca95277d37)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsResize]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsResize]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsResize]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__12cf4e253e012a96e41c78aa63e9595e9a1613c56e72571d1c13cc1150ae520d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsRotate",
    jsii_struct_bases=[],
    name_mapping={"degrees": "degrees", "degrees_var": "degreesVar"},
)
class DataAkamaiImagingPolicyImagePolicyTransformationsRotate:
    def __init__(
        self,
        *,
        degrees: typing.Optional[builtins.str] = None,
        degrees_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param degrees: The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees DataAkamaiImagingPolicyImage#degrees}
        :param degrees_var: The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees_var DataAkamaiImagingPolicyImage#degrees_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f93ac540e891a8630059632fb81b81367b3ce5dc058afaa8d53f688082f0b3a3)
            check_type(argname="argument degrees", value=degrees, expected_type=type_hints["degrees"])
            check_type(argname="argument degrees_var", value=degrees_var, expected_type=type_hints["degrees_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if degrees is not None:
            self._values["degrees"] = degrees
        if degrees_var is not None:
            self._values["degrees_var"] = degrees_var

    @builtins.property
    def degrees(self) -> typing.Optional[builtins.str]:
        '''The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees DataAkamaiImagingPolicyImage#degrees}
        '''
        result = self._values.get("degrees")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def degrees_var(self) -> typing.Optional[builtins.str]:
        '''The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees_var DataAkamaiImagingPolicyImage#degrees_var}
        '''
        result = self._values.get("degrees_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsRotate(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsRotateList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsRotateList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__78b8736db9d48ec6e5b150b17d987bd6812ec3abbea713803e64010167a4b2bc)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsRotateOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__370084025443e2a59f8565d7da764558cb7f0ec3f1e0333e7f4c9abdd60807d4)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsRotateOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f90996d3c5328c1b7bb59a425977c2e7c63cb64f21eb22bc2e3470a9bc2ebc49)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d0eed55232c9d405a579aa371bbb4867cfaadcd75367263b91e2431c538212fb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2adc8db86f866be241fad66deb475e4f73f47bad1ccbcb4e45ae0578c6c75d5e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsRotate]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsRotate]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsRotate]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ae8297e54309d390da719042f98711c540af7e632bbf8c799c84464b0057e1f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsRotateOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsRotateOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5df35629ca223b6f17131afacf70e7a6318dbfdc779127d675d0654305064a7d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetDegrees")
    def reset_degrees(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDegrees", []))

    @jsii.member(jsii_name="resetDegreesVar")
    def reset_degrees_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDegreesVar", []))

    @builtins.property
    @jsii.member(jsii_name="degreesInput")
    def degrees_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "degreesInput"))

    @builtins.property
    @jsii.member(jsii_name="degreesVarInput")
    def degrees_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "degreesVarInput"))

    @builtins.property
    @jsii.member(jsii_name="degrees")
    def degrees(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "degrees"))

    @degrees.setter
    def degrees(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ddbfb8cff28de9b6fdf3ba74c8160879c7d43e3443488224c5b9d0619006e680)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "degrees", value)

    @builtins.property
    @jsii.member(jsii_name="degreesVar")
    def degrees_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "degreesVar"))

    @degrees_var.setter
    def degrees_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a8d1f54f748a55488a8ab305c931c3bbae85a8f31df3dd474d576e88a32044e8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "degreesVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsRotate]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsRotate]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsRotate]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__32b5ba404eeb9ac2e2db4d00c9b7eac30eb54b6a0ddb4bcbba148cde84ba67ac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsScale",
    jsii_struct_bases=[],
    name_mapping={
        "height": "height",
        "height_var": "heightVar",
        "width": "width",
        "width_var": "widthVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsScale:
    def __init__(
        self,
        *,
        height: typing.Optional[builtins.str] = None,
        height_var: typing.Optional[builtins.str] = None,
        width: typing.Optional[builtins.str] = None,
        width_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param height: Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        :param height_var: Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        :param width: Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged. Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        :param width_var: Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged. Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bef7c0d59cac147e10369ea8f6e6b0a411dad6d2b2be218eb3ff9043f7efd51e)
            check_type(argname="argument height", value=height, expected_type=type_hints["height"])
            check_type(argname="argument height_var", value=height_var, expected_type=type_hints["height_var"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument width_var", value=width_var, expected_type=type_hints["width_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if height is not None:
            self._values["height"] = height
        if height_var is not None:
            self._values["height_var"] = height_var
        if width is not None:
            self._values["width"] = width
        if width_var is not None:
            self._values["width_var"] = width_var

    @builtins.property
    def height(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size.

        Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
        '''
        result = self._values.get("height")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def height_var(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input height to determine the output height of the image, where values between ``0`` and ``1`` decrease size.

        Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
        '''
        result = self._values.get("height_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged.

        Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width_var(self) -> typing.Optional[builtins.str]:
        '''Scaling factor for the input width to determine the output width of the image, where ``1`` leaves the width unchanged.

        Values greater than ``1`` increase the image size. Image dimensions need to be non-zero positive numbers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
        '''
        result = self._values.get("width_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsScale(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsScaleList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsScaleList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__decdb06d962f7943d8e8151ce4cf50e807cc65bdcfa284fd77c15e841ac1665b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsScaleOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b2f2985fb91f134666e1e31f9c9b5e16cd5e10d7d9a6c3b221e06ee68cd9577c)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsScaleOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2b57f024fc00e8c5b1d40fa8fdcf99e1e79003b12b728993afa7cfa295f4112f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__22870bebbb323eec5f15fa2575570dae7c09ff3eb6afef635732bff4ae860b87)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__57b04844515954a473782fb2ef5fe778576bede8ec21bc78583e0e2854f65d26)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsScale]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsScale]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsScale]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__18ed08a568047d8d74085775b7e2535198e2ae13fd2756abe086cab1dfe8f8fa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsScaleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsScaleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0484ecf42f5a6ec9d95c18361f4e0e74947b56fdbc5bea17239c8016057f8f11)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetHeight")
    def reset_height(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeight", []))

    @jsii.member(jsii_name="resetHeightVar")
    def reset_height_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeightVar", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthVar")
    def reset_width_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthVar", []))

    @builtins.property
    @jsii.member(jsii_name="heightInput")
    def height_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightInput"))

    @builtins.property
    @jsii.member(jsii_name="heightVarInput")
    def height_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "heightVarInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthVarInput")
    def width_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthVarInput"))

    @builtins.property
    @jsii.member(jsii_name="height")
    def height(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "height"))

    @height.setter
    def height(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__84319c4e6fd17b03108f1dae95ab22fc5952618f23d8d3da2568c4e21c48704d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "height", value)

    @builtins.property
    @jsii.member(jsii_name="heightVar")
    def height_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "heightVar"))

    @height_var.setter
    def height_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__224f1c9a574da114c0aab0867ebf58755cde59c3714c50777a9fec4aa3554510)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "heightVar", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "width"))

    @width.setter
    def width(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b0ef58714a15aa84ebdab532b112600a5cace8feb772d56e6d92932eb9bcd3c0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthVar")
    def width_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthVar"))

    @width_var.setter
    def width_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a04b81fc6edcf3bcd6af26ce296d8f972d60579c8483da5c12c5ddc9c3c6873)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsScale]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsScale]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsScale]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a69b5a6cb96deda7940ecb8b9d748d762b10c6a566774f9b71c93141916cc76e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsShear",
    jsii_struct_bases=[],
    name_mapping={
        "x_shear": "xShear",
        "x_shear_var": "xShearVar",
        "y_shear": "yShear",
        "y_shear_var": "yShearVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsShear:
    def __init__(
        self,
        *,
        x_shear: typing.Optional[builtins.str] = None,
        x_shear_var: typing.Optional[builtins.str] = None,
        y_shear: typing.Optional[builtins.str] = None,
        y_shear_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param x_shear: The amount to shear along the x-axis, measured in multiples of the image's width. Must be set if yShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear DataAkamaiImagingPolicyImage#x_shear}
        :param x_shear_var: The amount to shear along the x-axis, measured in multiples of the image's width. Must be set if yShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear_var DataAkamaiImagingPolicyImage#x_shear_var}
        :param y_shear: The amount to shear along the y-axis, measured in multiples of the image's height. Must be set if xShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear DataAkamaiImagingPolicyImage#y_shear}
        :param y_shear_var: The amount to shear along the y-axis, measured in multiples of the image's height. Must be set if xShear is not specified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear_var DataAkamaiImagingPolicyImage#y_shear_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dc7154d289a8b6e5bfd300a2b8bc5c85013d4c92af234080f4afae285bec2cdf)
            check_type(argname="argument x_shear", value=x_shear, expected_type=type_hints["x_shear"])
            check_type(argname="argument x_shear_var", value=x_shear_var, expected_type=type_hints["x_shear_var"])
            check_type(argname="argument y_shear", value=y_shear, expected_type=type_hints["y_shear"])
            check_type(argname="argument y_shear_var", value=y_shear_var, expected_type=type_hints["y_shear_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if x_shear is not None:
            self._values["x_shear"] = x_shear
        if x_shear_var is not None:
            self._values["x_shear_var"] = x_shear_var
        if y_shear is not None:
            self._values["y_shear"] = y_shear
        if y_shear_var is not None:
            self._values["y_shear_var"] = y_shear_var

    @builtins.property
    def x_shear(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the x-axis, measured in multiples of the image's width.

        Must be set if yShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear DataAkamaiImagingPolicyImage#x_shear}
        '''
        result = self._values.get("x_shear")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def x_shear_var(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the x-axis, measured in multiples of the image's width.

        Must be set if yShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear_var DataAkamaiImagingPolicyImage#x_shear_var}
        '''
        result = self._values.get("x_shear_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_shear(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the y-axis, measured in multiples of the image's height.

        Must be set if xShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear DataAkamaiImagingPolicyImage#y_shear}
        '''
        result = self._values.get("y_shear")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def y_shear_var(self) -> typing.Optional[builtins.str]:
        '''The amount to shear along the y-axis, measured in multiples of the image's height.

        Must be set if xShear is not specified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear_var DataAkamaiImagingPolicyImage#y_shear_var}
        '''
        result = self._values.get("y_shear_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsShear(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsShearList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsShearList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6a3657f2f5112d5385b5004f1231b0eaebbc7be55707aca7a3ade850986c7164)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsShearOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aacbead6639cc9d818334e0ee1c3ab499001d72f30054193de5a0d5c71cdf836)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsShearOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a5dedf1d722f9eddcafe9777115f5b0ae1a3308c3ba2f0a6b43a399ad01dcf1a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6d22a80a0470bffe33eecae67448ab1a6e10347bf8f4033e973453bac867cb0e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e944a5b636a5348a8a73034db1377b5defe6c923817b9eddb82aa83dc9f64928)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsShear]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsShear]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsShear]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5c160ab06561206929d2639f6d787fec013cccc8a7a5c7a514fbf307297d825e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsShearOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsShearOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d7dc6a0ca3a74f4ab44555118905486c53a42a89888c640a70514fcbc6cf08e4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetXShear")
    def reset_x_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXShear", []))

    @jsii.member(jsii_name="resetXShearVar")
    def reset_x_shear_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXShearVar", []))

    @jsii.member(jsii_name="resetYShear")
    def reset_y_shear(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYShear", []))

    @jsii.member(jsii_name="resetYShearVar")
    def reset_y_shear_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetYShearVar", []))

    @builtins.property
    @jsii.member(jsii_name="xShearInput")
    def x_shear_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xShearInput"))

    @builtins.property
    @jsii.member(jsii_name="xShearVarInput")
    def x_shear_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xShearVarInput"))

    @builtins.property
    @jsii.member(jsii_name="yShearInput")
    def y_shear_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yShearInput"))

    @builtins.property
    @jsii.member(jsii_name="yShearVarInput")
    def y_shear_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "yShearVarInput"))

    @builtins.property
    @jsii.member(jsii_name="xShear")
    def x_shear(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xShear"))

    @x_shear.setter
    def x_shear(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__431bf6fa679a9004df4fe4e74b9c6f3d271e00e953433219c53271a92bcd120c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xShear", value)

    @builtins.property
    @jsii.member(jsii_name="xShearVar")
    def x_shear_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xShearVar"))

    @x_shear_var.setter
    def x_shear_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__913a5b44857240b3d401ed8011f6a8337b7889fba2bd60663f1804eb4b112d44)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xShearVar", value)

    @builtins.property
    @jsii.member(jsii_name="yShear")
    def y_shear(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yShear"))

    @y_shear.setter
    def y_shear(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__12213c6f10b3208b8b34b55f8e600bd6982ec25058603f1f2f0a835c9a962027)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yShear", value)

    @builtins.property
    @jsii.member(jsii_name="yShearVar")
    def y_shear_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "yShearVar"))

    @y_shear_var.setter
    def y_shear_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3596545ede68bce94da607278210453f8aa7cb76d335a22572a4b894cc6bf838)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "yShearVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsShear]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsShear]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsShear]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__abc0971b62382e07c1a75d5505151757b4e2e6d3b5f90b7cd58bb1d7bf95339c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsTrim",
    jsii_struct_bases=[],
    name_mapping={
        "fuzz": "fuzz",
        "fuzz_var": "fuzzVar",
        "padding": "padding",
        "padding_var": "paddingVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsTrim:
    def __init__(
        self,
        *,
        fuzz: typing.Optional[builtins.str] = None,
        fuzz_var: typing.Optional[builtins.str] = None,
        padding: typing.Optional[builtins.str] = None,
        padding_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fuzz: The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz DataAkamaiImagingPolicyImage#fuzz}
        :param fuzz_var: The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz_var DataAkamaiImagingPolicyImage#fuzz_var}
        :param padding: The amount of padding in pixels to add to the trimmed image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        :param padding_var: The amount of padding in pixels to add to the trimmed image. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d37259416347b90203c3e23a777282298b1a4137c9c1ad3d077a5353719092cc)
            check_type(argname="argument fuzz", value=fuzz, expected_type=type_hints["fuzz"])
            check_type(argname="argument fuzz_var", value=fuzz_var, expected_type=type_hints["fuzz_var"])
            check_type(argname="argument padding", value=padding, expected_type=type_hints["padding"])
            check_type(argname="argument padding_var", value=padding_var, expected_type=type_hints["padding_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fuzz is not None:
            self._values["fuzz"] = fuzz
        if fuzz_var is not None:
            self._values["fuzz_var"] = fuzz_var
        if padding is not None:
            self._values["padding"] = padding
        if padding_var is not None:
            self._values["padding_var"] = padding_var

    @builtins.property
    def fuzz(self) -> typing.Optional[builtins.str]:
        '''The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz DataAkamaiImagingPolicyImage#fuzz}
        '''
        result = self._values.get("fuzz")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def fuzz_var(self) -> typing.Optional[builtins.str]:
        '''The fuzz tolerance of the trim, a value between ``0`` and ``1`` that determines the acceptable amount of background variation before trimming stops.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz_var DataAkamaiImagingPolicyImage#fuzz_var}
        '''
        result = self._values.get("fuzz_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding(self) -> typing.Optional[builtins.str]:
        '''The amount of padding in pixels to add to the trimmed image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
        '''
        result = self._values.get("padding")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def padding_var(self) -> typing.Optional[builtins.str]:
        '''The amount of padding in pixels to add to the trimmed image.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
        '''
        result = self._values.get("padding_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsTrim(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsTrimList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsTrimList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d505d4e1aa8e0bbae95e4414dc2c4d8d64ef823b393866406685f99574e3d2db)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsTrimOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c67d0e57cce559fd780b6b446b632bccb2d8d7cd2dae386aa2e020bc24807ed8)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsTrimOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__93e4f48ff6dd91d9d04f35b15317cf1dd390cb2e59930b8b6aff6da79c04ebbf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__27d4d75b3132f2ed46303f82b9dd6c6c89b42c58e72a222c351b6c1775a388a2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ee0fdb38f4495f32ba30877cb247bef169b90e0a7df2880139daabf4a83e0c5d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsTrim]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsTrim]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsTrim]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3cf1a0274b9e8562210aa7acee303edb9dd2890be9ab4c684b9bc44cc7ba78e8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsTrimOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsTrimOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__981a077fd8adccc1d5f56781845edf3d95549a7118425a9473d16eafc64faf8a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetFuzz")
    def reset_fuzz(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFuzz", []))

    @jsii.member(jsii_name="resetFuzzVar")
    def reset_fuzz_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFuzzVar", []))

    @jsii.member(jsii_name="resetPadding")
    def reset_padding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPadding", []))

    @jsii.member(jsii_name="resetPaddingVar")
    def reset_padding_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPaddingVar", []))

    @builtins.property
    @jsii.member(jsii_name="fuzzInput")
    def fuzz_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fuzzInput"))

    @builtins.property
    @jsii.member(jsii_name="fuzzVarInput")
    def fuzz_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fuzzVarInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingInput")
    def padding_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingInput"))

    @builtins.property
    @jsii.member(jsii_name="paddingVarInput")
    def padding_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paddingVarInput"))

    @builtins.property
    @jsii.member(jsii_name="fuzz")
    def fuzz(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fuzz"))

    @fuzz.setter
    def fuzz(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ae1248f4f8f7364e9eb5b7961ce6a5f499f08679971fe58d13cca62c86f59b3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fuzz", value)

    @builtins.property
    @jsii.member(jsii_name="fuzzVar")
    def fuzz_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fuzzVar"))

    @fuzz_var.setter
    def fuzz_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d4ef6807ab41bf9a8abb903b2bc9938270f27f578cf7892afba027eb9eba070)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fuzzVar", value)

    @builtins.property
    @jsii.member(jsii_name="padding")
    def padding(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "padding"))

    @padding.setter
    def padding(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4b5cc21fe58510031ca975d4244e8f74ae35762a0ea3d68c9e536177b866d82d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "padding", value)

    @builtins.property
    @jsii.member(jsii_name="paddingVar")
    def padding_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paddingVar"))

    @padding_var.setter
    def padding_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2fd6a85e4493be42df92c1ee4100834cf41e0aa9691094d96654ad5ed3030dab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paddingVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsTrim]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsTrim]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsTrim]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f4567d71fc6ea4ef3352d661cb71bc0631ffb15abf88b9447371abaaf4d944ae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsUnsharpMask",
    jsii_struct_bases=[],
    name_mapping={
        "gain": "gain",
        "gain_var": "gainVar",
        "sigma": "sigma",
        "sigma_var": "sigmaVar",
        "threshold": "threshold",
        "threshold_var": "thresholdVar",
    },
)
class DataAkamaiImagingPolicyImagePolicyTransformationsUnsharpMask:
    def __init__(
        self,
        *,
        gain: typing.Optional[builtins.str] = None,
        gain_var: typing.Optional[builtins.str] = None,
        sigma: typing.Optional[builtins.str] = None,
        sigma_var: typing.Optional[builtins.str] = None,
        threshold: typing.Optional[builtins.str] = None,
        threshold_var: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param gain: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        :param gain_var: Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        :param sigma: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        :param sigma_var: The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        :param threshold: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        :param threshold_var: Set the minimum change required to include a detail in the filter. Higher values discard more changes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eadca9e361a87b7aeaa7f87892bde54979af50e4bd87901a29d47a7e6e1bd0c5)
            check_type(argname="argument gain", value=gain, expected_type=type_hints["gain"])
            check_type(argname="argument gain_var", value=gain_var, expected_type=type_hints["gain_var"])
            check_type(argname="argument sigma", value=sigma, expected_type=type_hints["sigma"])
            check_type(argname="argument sigma_var", value=sigma_var, expected_type=type_hints["sigma_var"])
            check_type(argname="argument threshold", value=threshold, expected_type=type_hints["threshold"])
            check_type(argname="argument threshold_var", value=threshold_var, expected_type=type_hints["threshold_var"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if gain is not None:
            self._values["gain"] = gain
        if gain_var is not None:
            self._values["gain_var"] = gain_var
        if sigma is not None:
            self._values["sigma"] = sigma
        if sigma_var is not None:
            self._values["sigma_var"] = sigma_var
        if threshold is not None:
            self._values["threshold"] = threshold
        if threshold_var is not None:
            self._values["threshold_var"] = threshold_var

    @builtins.property
    def gain(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
        '''
        result = self._values.get("gain")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gain_var(self) -> typing.Optional[builtins.str]:
        '''Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
        '''
        result = self._values.get("gain_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
        '''
        result = self._values.get("sigma")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sigma_var(self) -> typing.Optional[builtins.str]:
        '''The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, ``1.0`` by default. High values emphasize large details and low values emphasize small details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
        '''
        result = self._values.get("sigma_var")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
        '''
        result = self._values.get("threshold")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold_var(self) -> typing.Optional[builtins.str]:
        '''Set the minimum change required to include a detail in the filter. Higher values discard more changes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
        '''
        result = self._values.get("threshold_var")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyTransformationsUnsharpMask(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyTransformationsUnsharpMaskList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsUnsharpMaskList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ebc0c4b9a492467ccc083e8b07042c092ab68cf9709e1b85b6a4f41aed25e63)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyTransformationsUnsharpMaskOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__865bb719c53aa99cfa85cc554505fd2b199bdf49072eb204683bb1752c912929)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyTransformationsUnsharpMaskOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b8a97f735e248e25c51bde70cd502f509964f5ff6bcb50a9e4459d6a0e71c5ce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__087d6ef699f4cc1057830c757a41ffb5214c3d8a5300dc8d28c6fa24b659fd51)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__555b9ae4bd8cca5612025f7783189bff1f727a83fd8fd6d5945a7b391b73c1c4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsUnsharpMask]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsUnsharpMask]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsUnsharpMask]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2281c563f4ec9014ae8b6a4ac90f9a3fea04cacd19034483019a5d880b7a5593)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyTransformationsUnsharpMaskOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyTransformationsUnsharpMaskOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7fd03d4eb4aaf3829a29af1b1c892f80f2468a40db7241284745a6bf9547b0ca)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetGain")
    def reset_gain(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGain", []))

    @jsii.member(jsii_name="resetGainVar")
    def reset_gain_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGainVar", []))

    @jsii.member(jsii_name="resetSigma")
    def reset_sigma(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigma", []))

    @jsii.member(jsii_name="resetSigmaVar")
    def reset_sigma_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigmaVar", []))

    @jsii.member(jsii_name="resetThreshold")
    def reset_threshold(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThreshold", []))

    @jsii.member(jsii_name="resetThresholdVar")
    def reset_threshold_var(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThresholdVar", []))

    @builtins.property
    @jsii.member(jsii_name="gainInput")
    def gain_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainInput"))

    @builtins.property
    @jsii.member(jsii_name="gainVarInput")
    def gain_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gainVarInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaInput")
    def sigma_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaInput"))

    @builtins.property
    @jsii.member(jsii_name="sigmaVarInput")
    def sigma_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigmaVarInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdInput")
    def threshold_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdVarInput")
    def threshold_var_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdVarInput"))

    @builtins.property
    @jsii.member(jsii_name="gain")
    def gain(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gain"))

    @gain.setter
    def gain(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__241730431135e9211e5be73ec2e73ce8a8e73dcece3b026160e7cb0dd32c46db)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gain", value)

    @builtins.property
    @jsii.member(jsii_name="gainVar")
    def gain_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gainVar"))

    @gain_var.setter
    def gain_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e861a489107fb16737b6177a039e9c1cb6ab489bc5949de4ec69f0786f808233)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gainVar", value)

    @builtins.property
    @jsii.member(jsii_name="sigma")
    def sigma(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigma"))

    @sigma.setter
    def sigma(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__49184cba0560c45b8e3bbc91bd168b7384b66390434c569d4142a4f45f6e8cb7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigma", value)

    @builtins.property
    @jsii.member(jsii_name="sigmaVar")
    def sigma_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigmaVar"))

    @sigma_var.setter
    def sigma_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__06b7540be9b390c8e1648734217866bd21cf25b29249258800047fd4d7f261d3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigmaVar", value)

    @builtins.property
    @jsii.member(jsii_name="threshold")
    def threshold(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "threshold"))

    @threshold.setter
    def threshold(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c681abd05bab1bcbbb91f6dcba7d9ee4852cb87f47028d30bd70c6f495d39b82)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "threshold", value)

    @builtins.property
    @jsii.member(jsii_name="thresholdVar")
    def threshold_var(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "thresholdVar"))

    @threshold_var.setter
    def threshold_var(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2c2672dbc301519f6ff858b3e28737cb2516e1f03dd272620efb021bb0c28f12)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "thresholdVar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsUnsharpMask]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsUnsharpMask]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsUnsharpMask]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__63da1f8e5cd0aec5c8769483a15598073ee39400370c7f3d3d26d7b1d07882be)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyVariables",
    jsii_struct_bases=[],
    name_mapping={
        "default_value": "defaultValue",
        "name": "name",
        "type": "type",
        "enum_options": "enumOptions",
        "postfix": "postfix",
        "prefix": "prefix",
    },
)
class DataAkamaiImagingPolicyImagePolicyVariables:
    def __init__(
        self,
        *,
        default_value: builtins.str,
        name: builtins.str,
        type: builtins.str,
        enum_options: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiImagingPolicyImagePolicyVariablesEnumOptions", typing.Dict[builtins.str, typing.Any]]]]] = None,
        postfix: typing.Optional[builtins.str] = None,
        prefix: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param default_value: The default value of the variable if no query parameter is provided. It needs to be one of the ``enumOptions`` if any are provided. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default_value DataAkamaiImagingPolicyImage#default_value}
        :param name: The name of the variable, also available as the query parameter name to set the variable's value dynamically. Use up to 50 alphanumeric characters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#name DataAkamaiImagingPolicyImage#name}
        :param type: The type of value for the variable. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        :param enum_options: enum_options block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#enum_options DataAkamaiImagingPolicyImage#enum_options}
        :param postfix: A postfix added to the value provided for the variable, or to the default value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#postfix DataAkamaiImagingPolicyImage#postfix}
        :param prefix: A prefix added to the value provided for the variable, or to the default value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#prefix DataAkamaiImagingPolicyImage#prefix}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__23d7afb562856107540b81d7d43b9abd0c335a873e21ae39df47db3714c69954)
            check_type(argname="argument default_value", value=default_value, expected_type=type_hints["default_value"])
            check_type(argname="argument name", value=name, expected_type=type_hints["name"])
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument enum_options", value=enum_options, expected_type=type_hints["enum_options"])
            check_type(argname="argument postfix", value=postfix, expected_type=type_hints["postfix"])
            check_type(argname="argument prefix", value=prefix, expected_type=type_hints["prefix"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "default_value": default_value,
            "name": name,
            "type": type,
        }
        if enum_options is not None:
            self._values["enum_options"] = enum_options
        if postfix is not None:
            self._values["postfix"] = postfix
        if prefix is not None:
            self._values["prefix"] = prefix

    @builtins.property
    def default_value(self) -> builtins.str:
        '''The default value of the variable if no query parameter is provided.

        It needs to be one of the ``enumOptions`` if any are provided.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default_value DataAkamaiImagingPolicyImage#default_value}
        '''
        result = self._values.get("default_value")
        assert result is not None, "Required property 'default_value' is missing"
        return typing.cast(builtins.str, result)

    @builtins.property
    def name(self) -> builtins.str:
        '''The name of the variable, also available as the query parameter name to set the variable's value dynamically.

        Use up to 50 alphanumeric characters.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#name DataAkamaiImagingPolicyImage#name}
        '''
        result = self._values.get("name")
        assert result is not None, "Required property 'name' is missing"
        return typing.cast(builtins.str, result)

    @builtins.property
    def type(self) -> builtins.str:
        '''The type of value for the variable.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
        '''
        result = self._values.get("type")
        assert result is not None, "Required property 'type' is missing"
        return typing.cast(builtins.str, result)

    @builtins.property
    def enum_options(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyVariablesEnumOptions"]]]:
        '''enum_options block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#enum_options DataAkamaiImagingPolicyImage#enum_options}
        '''
        result = self._values.get("enum_options")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiImagingPolicyImagePolicyVariablesEnumOptions"]]], result)

    @builtins.property
    def postfix(self) -> typing.Optional[builtins.str]:
        '''A postfix added to the value provided for the variable, or to the default value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#postfix DataAkamaiImagingPolicyImage#postfix}
        '''
        result = self._values.get("postfix")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def prefix(self) -> typing.Optional[builtins.str]:
        '''A prefix added to the value provided for the variable, or to the default value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#prefix DataAkamaiImagingPolicyImage#prefix}
        '''
        result = self._values.get("prefix")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyVariables(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyVariablesEnumOptions",
    jsii_struct_bases=[],
    name_mapping={"id": "id", "value": "value"},
)
class DataAkamaiImagingPolicyImagePolicyVariablesEnumOptions:
    def __init__(self, *, id: builtins.str, value: builtins.str) -> None:
        '''
        :param id: The unique identifier for each enum value, up to 50 alphanumeric characters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#id DataAkamaiImagingPolicyImage#id} Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param value: The value of the variable when the ``id`` is provided. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a0000964f95ec6d851b64605e2562e52f9e11b393ef55285a75c2f90cf3f12bf)
            check_type(argname="argument id", value=id, expected_type=type_hints["id"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "id": id,
            "value": value,
        }

    @builtins.property
    def id(self) -> builtins.str:
        '''The unique identifier for each enum value, up to 50 alphanumeric characters.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#id DataAkamaiImagingPolicyImage#id}

        Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
        If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        '''
        result = self._values.get("id")
        assert result is not None, "Required property 'id' is missing"
        return typing.cast(builtins.str, result)

    @builtins.property
    def value(self) -> builtins.str:
        '''The value of the variable when the ``id`` is provided.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
        '''
        result = self._values.get("value")
        assert result is not None, "Required property 'value' is missing"
        return typing.cast(builtins.str, result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiImagingPolicyImagePolicyVariablesEnumOptions(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiImagingPolicyImagePolicyVariablesEnumOptionsList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyVariablesEnumOptionsList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fc0a2231b27dff1c3c4d5604f25463322c92629eacc3e04dac2efa3a63599f16)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyVariablesEnumOptionsOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ecf11df8f8924b47f153906bac77b22e6036b69cf18858122b86c3707027a2a)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyVariablesEnumOptionsOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__deea1f48891f4547300746a4687e5160a09dfa87c13697b59db396c2bbab1c35)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3b80cbfc229030657a9affcea79be3f596becc333583812ec1f94d69ca38a7da)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5381e46824ac67cfa62a3c643cc25f0cd9771218d0673b3d8647af7fc6839ce5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyVariablesEnumOptions]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyVariablesEnumOptions]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyVariablesEnumOptions]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5206dc968ec67d27f5dfb9c2295dbcdf81753e34783e6ee767b9f4571a18eb92)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyVariablesEnumOptionsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyVariablesEnumOptionsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a498e23f32932db7ff62d07450fd6c05900656247da3d944b6c517ebd1d0bf49)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @builtins.property
    @jsii.member(jsii_name="idInput")
    def id_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "idInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="id")
    def id(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "id"))

    @id.setter
    def id(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a02dbce9c6f5d8495edcd87240738d0947fab03046bbb89cf17b5b1a7e5fc97)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "id", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__89a44bb0f3129791186a953ac5b4aeddcbc7cbd2bed049b25ea321787703c6ef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyVariablesEnumOptions]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyVariablesEnumOptions]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyVariablesEnumOptions]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c879aa13fe225524aee165dc7b3de464ef162d0ed6c214222c4f83113875189a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyVariablesList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyVariablesList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9893ae11638a9234239e6c03d014b4a805f9b3fb3c557e96fa99c35a7dbe1a29)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiImagingPolicyImagePolicyVariablesOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1d49607a09de8c428d566f066837d57a536be4507a70353e1420f0df94a52970)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiImagingPolicyImagePolicyVariablesOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__73fc61df8bc654f83b0bbbbcd424bf3b3179419a665379311880722a3f7a8d54)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d53185411b65e3bd2cb0aaf3305336af634fd65ea8205d6b24c163325c24ca0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__934abfc00ea03d7181ed9ca0c2270ba901b4daee5ba9fe35da4ab79d344aaa38)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyVariables]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyVariables]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyVariables]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__42d21ff75834fde4aff85580702b8c85a5600e90c45f328ab0ca49e9cd89718b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiImagingPolicyImagePolicyVariablesOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiImagingPolicyImage.DataAkamaiImagingPolicyImagePolicyVariablesOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e0f1651cc3a62bccec55384fa6aaebd3a74940aba765a74082623d9977cdc7e8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putEnumOptions")
    def put_enum_options(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyVariablesEnumOptions, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__70d0ae73cdc54a0fb06ea166c0f139cc6eb8f70049df078d17c4ce0863cd6e77)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putEnumOptions", [value]))

    @jsii.member(jsii_name="resetEnumOptions")
    def reset_enum_options(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnumOptions", []))

    @jsii.member(jsii_name="resetPostfix")
    def reset_postfix(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPostfix", []))

    @jsii.member(jsii_name="resetPrefix")
    def reset_prefix(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPrefix", []))

    @builtins.property
    @jsii.member(jsii_name="enumOptions")
    def enum_options(
        self,
    ) -> DataAkamaiImagingPolicyImagePolicyVariablesEnumOptionsList:
        return typing.cast(DataAkamaiImagingPolicyImagePolicyVariablesEnumOptionsList, jsii.get(self, "enumOptions"))

    @builtins.property
    @jsii.member(jsii_name="defaultValueInput")
    def default_value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "defaultValueInput"))

    @builtins.property
    @jsii.member(jsii_name="enumOptionsInput")
    def enum_options_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyVariablesEnumOptions]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyVariablesEnumOptions]]], jsii.get(self, "enumOptionsInput"))

    @builtins.property
    @jsii.member(jsii_name="nameInput")
    def name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "nameInput"))

    @builtins.property
    @jsii.member(jsii_name="postfixInput")
    def postfix_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "postfixInput"))

    @builtins.property
    @jsii.member(jsii_name="prefixInput")
    def prefix_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "prefixInput"))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="defaultValue")
    def default_value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "defaultValue"))

    @default_value.setter
    def default_value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__57e2d102a72f6e6dbce89f5b2c827ac83595db366ae9fbb8afeb6e9a49a4a73e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "defaultValue", value)

    @builtins.property
    @jsii.member(jsii_name="name")
    def name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "name"))

    @name.setter
    def name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__396dfabf2cd9185dfa1a13f2c5fea57072b965faa94831b26e2c8b2981e0c38b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "name", value)

    @builtins.property
    @jsii.member(jsii_name="postfix")
    def postfix(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "postfix"))

    @postfix.setter
    def postfix(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e22085b60bc5264850d9f5e955e3d35dc44fb5a74089229b9e36ba55ec404de1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "postfix", value)

    @builtins.property
    @jsii.member(jsii_name="prefix")
    def prefix(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "prefix"))

    @prefix.setter
    def prefix(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8d29b7a2cb44b3303b33a3711828662ccd36dfcaeb3055864bda8fe7f0c5db9b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "prefix", value)

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__508d1ce808884f3e565d336d9b9083f2b1e300c0898daf543f6b9f6269fe2b89)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyVariables]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyVariables]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyVariables]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3268085c2ae9aca47d5f7712d9eaf3069f8daa661eb23434e466cbe5ea21349d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


__all__ = [
    "DataAkamaiImagingPolicyImage",
    "DataAkamaiImagingPolicyImageConfig",
    "DataAkamaiImagingPolicyImagePolicy",
    "DataAkamaiImagingPolicyImagePolicyBreakpoints",
    "DataAkamaiImagingPolicyImagePolicyBreakpointsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyOutput",
    "DataAkamaiImagingPolicyImagePolicyOutputOutputReference",
    "DataAkamaiImagingPolicyImagePolicyOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformations",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsBackgroundColor",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsBackgroundColorList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsBackgroundColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsBlur",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsBlurList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsBlurOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsChromaKey",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsChromaKeyList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsChromaKeyOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsComposite",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImage",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImage",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformation",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationBackgroundColor",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationBackgroundColorList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationBackgroundColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationBlur",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationBlurList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationBlurOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationChromaKey",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationChromaKeyList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationChromaKeyOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationComposite",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationCompositeImage",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationCompositeImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationCompositeList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationCompositeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationCompound",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationCompoundList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationCompoundOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationCompoundTransformations",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationCompoundTransformationsList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationCompoundTransformationsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationContrast",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationContrastList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationContrastOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationGoop",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationGoopList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationGoopOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationGrayscale",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationGrayscaleList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationGrayscaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationHsl",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationHslList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationHslOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationHsv",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationHsvList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationHsvOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimension",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimensionDefault",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimensionDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimensionEqual",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimensionEqualOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimensionGreaterThan",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimensionGreaterThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimensionLessThan",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimensionLessThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimensionList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimensionOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientation",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientationDefault",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientationDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientationLandscape",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientationLandscapeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientationList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientationPortrait",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientationPortraitOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientationSquare",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientationSquareOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationMaxColors",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationMaxColorsList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationMaxColorsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationMirror",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationMirrorList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationMirrorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationMonoHue",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationMonoHueList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationMonoHueOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationOpacity",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationOpacityList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationOpacityOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationRemoveColor",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationRemoveColorList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationRemoveColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationUnsharpMask",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationUnsharpMaskList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationUnsharpMaskOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImage",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformation",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationBackgroundColor",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationBackgroundColorList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationBackgroundColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationBlur",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationBlurList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationBlurOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationChromaKey",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationChromaKeyList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationChromaKeyOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationComposite",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationCompositeImage",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationCompositeImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationCompositeList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationCompositeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationCompound",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationCompoundList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationCompoundOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationCompoundTransformations",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationCompoundTransformationsList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationCompoundTransformationsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationContrast",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationContrastList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationContrastOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationGoop",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationGoopList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationGoopOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationGrayscale",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationGrayscaleList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationGrayscaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationHsl",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationHslList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationHslOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationHsv",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationHsvList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationHsvOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimension",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimensionDefault",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimensionDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimensionEqual",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimensionEqualOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimensionGreaterThan",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimensionGreaterThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimensionLessThan",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimensionLessThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimensionList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimensionOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientation",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientationDefault",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientationDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientationLandscape",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientationLandscapeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientationList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientationPortrait",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientationPortraitOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientationSquare",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientationSquareOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationMaxColors",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationMaxColorsList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationMaxColorsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationMirror",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationMirrorList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationMirrorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationMonoHue",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationMonoHueList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationMonoHueOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationOpacity",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationOpacityList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationOpacityOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationRemoveColor",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationRemoveColorList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationRemoveColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationUnsharpMask",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationUnsharpMaskList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationUnsharpMaskOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImage",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformation",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationBackgroundColor",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationBackgroundColorList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationBackgroundColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationBlur",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationBlurList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationBlurOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationChromaKey",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationChromaKeyList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationChromaKeyOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationComposite",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationCompositeImage",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationCompositeImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationCompositeList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationCompositeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationCompound",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationCompoundList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationCompoundOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationCompoundTransformations",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationCompoundTransformationsList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationCompoundTransformationsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationContrast",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationContrastList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationContrastOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationGoop",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationGoopList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationGoopOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationGrayscale",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationGrayscaleList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationGrayscaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationHsl",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationHslList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationHslOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationHsv",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationHsvList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationHsvOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimension",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimensionDefault",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimensionDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimensionEqual",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimensionEqualOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimensionGreaterThan",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimensionGreaterThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimensionLessThan",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimensionLessThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimensionList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimensionOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientation",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientationDefault",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientationDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientationLandscape",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientationLandscapeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientationList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientationPortrait",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientationPortraitOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientationSquare",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientationSquareOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationMaxColors",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationMaxColorsList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationMaxColorsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationMirror",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationMirrorList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationMirrorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationMonoHue",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationMonoHueList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationMonoHueOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationOpacity",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationOpacityList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationOpacityOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationRemoveColor",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationRemoveColorList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationRemoveColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationUnsharpMask",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationUnsharpMaskList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationUnsharpMaskOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImage",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformation",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationBackgroundColor",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationBackgroundColorList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationBackgroundColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationBlur",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationBlurList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationBlurOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationChromaKey",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationChromaKeyList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationChromaKeyOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationComposite",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationCompositeImage",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationCompositeImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationCompositeList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationCompositeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationCompound",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationCompoundList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationCompoundOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationCompoundTransformations",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationCompoundTransformationsList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationCompoundTransformationsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationContrast",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationContrastList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationContrastOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationGoop",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationGoopList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationGoopOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationGrayscale",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationGrayscaleList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationGrayscaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationHsl",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationHslList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationHslOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationHsv",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationHsvList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationHsvOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfDimension",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfDimensionDefault",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfDimensionDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfDimensionEqual",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfDimensionEqualOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfDimensionGreaterThan",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfDimensionGreaterThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfDimensionLessThan",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfDimensionLessThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfDimensionList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfDimensionOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfOrientation",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfOrientationDefault",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfOrientationDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfOrientationLandscape",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfOrientationLandscapeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfOrientationList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfOrientationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfOrientationPortrait",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfOrientationPortraitOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfOrientationSquare",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfOrientationSquareOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationMaxColors",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationMaxColorsList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationMaxColorsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationMirror",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationMirrorList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationMirrorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationMonoHue",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationMonoHueList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationMonoHueOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationOpacity",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationOpacityList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationOpacityOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationRemoveColor",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationRemoveColorList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationRemoveColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationUnsharpMask",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationUnsharpMaskList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationUnsharpMaskOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompound",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformations",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsBackgroundColor",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsBackgroundColorList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsBackgroundColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsBlur",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsBlurList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsBlurOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsChromaKey",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsChromaKeyList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsChromaKeyOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsComposite",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImage",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageBoxImage",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageBoxImageList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageBoxImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageBoxImageTransformation",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageBoxImageTransformationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageCircleImage",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageCircleImageList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageCircleImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageCircleImageTransformation",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageCircleImageTransformationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageTextImage",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageTextImageList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageTextImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageTextImageTransformation",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageTextImageTransformationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageUrlImage",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageUrlImageList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageUrlImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageUrlImageTransformation",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageUrlImageTransformationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsContrast",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsContrastList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsContrastOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsGoop",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsGoopList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsGoopOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsGrayscale",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsGrayscaleList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsGrayscaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsHsl",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsHslList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsHslOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsHsv",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsHsvList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsHsvOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimension",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefault",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultBackgroundColor",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultBackgroundColorList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultBackgroundColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultBlur",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultBlurList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultBlurOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultChromaKey",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultChromaKeyList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultChromaKeyOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultComposite",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultCompositeImage",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultCompositeImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultCompositeList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultCompositeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultCompound",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultCompoundList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultCompoundOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultCompoundTransformations",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultCompoundTransformationsList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultCompoundTransformationsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultContrast",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultContrastList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultContrastOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultGoop",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultGoopList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultGoopOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultGrayscale",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultGrayscaleList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultGrayscaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultHsl",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultHslList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultHslOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultHsv",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultHsvList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultHsvOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfDimension",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfDimensionDefault",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfDimensionDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfDimensionEqual",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfDimensionEqualOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfDimensionGreaterThan",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfDimensionGreaterThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfDimensionLessThan",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfDimensionLessThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfDimensionList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfDimensionOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfOrientation",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfOrientationDefault",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfOrientationDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfOrientationLandscape",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfOrientationLandscapeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfOrientationList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfOrientationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfOrientationPortrait",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfOrientationPortraitOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfOrientationSquare",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfOrientationSquareOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultMaxColors",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultMaxColorsList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultMaxColorsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultMirror",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultMirrorList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultMirrorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultMonoHue",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultMonoHueList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultMonoHueOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultOpacity",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultOpacityList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultOpacityOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultRemoveColor",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultRemoveColorList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultRemoveColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultUnsharpMask",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultUnsharpMaskList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultUnsharpMaskOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqual",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualBackgroundColor",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualBackgroundColorList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualBackgroundColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualBlur",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualBlurList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualBlurOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualChromaKey",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualChromaKeyList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualChromaKeyOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualComposite",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualCompositeImage",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualCompositeImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualCompositeList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualCompositeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualCompound",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualCompoundList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualCompoundOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualCompoundTransformations",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualCompoundTransformationsList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualCompoundTransformationsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualContrast",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualContrastList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualContrastOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualGoop",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualGoopList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualGoopOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualGrayscale",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualGrayscaleList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualGrayscaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualHsl",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualHslList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualHslOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualHsv",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualHsvList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualHsvOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfDimension",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfDimensionDefault",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfDimensionDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfDimensionEqual",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfDimensionEqualOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfDimensionGreaterThan",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfDimensionGreaterThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfDimensionLessThan",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfDimensionLessThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfDimensionList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfDimensionOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfOrientation",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfOrientationDefault",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfOrientationDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfOrientationLandscape",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfOrientationLandscapeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfOrientationList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfOrientationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfOrientationPortrait",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfOrientationPortraitOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfOrientationSquare",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfOrientationSquareOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualMaxColors",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualMaxColorsList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualMaxColorsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualMirror",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualMirrorList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualMirrorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualMonoHue",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualMonoHueList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualMonoHueOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualOpacity",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualOpacityList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualOpacityOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualRemoveColor",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualRemoveColorList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualRemoveColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualUnsharpMask",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualUnsharpMaskList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualUnsharpMaskOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThan",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanBackgroundColor",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanBackgroundColorList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanBackgroundColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanBlur",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanBlurList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanBlurOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanChromaKey",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanChromaKeyList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanChromaKeyOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanComposite",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanCompositeImage",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanCompositeImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanCompositeList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanCompositeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanCompound",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanCompoundList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanCompoundOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanCompoundTransformations",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanCompoundTransformationsList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanCompoundTransformationsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanContrast",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanContrastList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanContrastOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanGoop",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanGoopList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanGoopOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanGrayscale",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanGrayscaleList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanGrayscaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanHsl",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanHslList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanHslOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanHsv",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanHsvList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanHsvOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfDimension",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfDimensionDefault",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfDimensionDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfDimensionEqual",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfDimensionEqualOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfDimensionGreaterThan",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfDimensionGreaterThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfDimensionLessThan",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfDimensionLessThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfDimensionList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfDimensionOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfOrientation",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfOrientationDefault",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfOrientationDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfOrientationLandscape",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfOrientationLandscapeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfOrientationList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfOrientationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfOrientationPortrait",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfOrientationPortraitOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfOrientationSquare",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfOrientationSquareOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanMaxColors",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanMaxColorsList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanMaxColorsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanMirror",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanMirrorList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanMirrorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanMonoHue",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanMonoHueList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanMonoHueOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanOpacity",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanOpacityList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanOpacityOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanRemoveColor",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanRemoveColorList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanRemoveColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanUnsharpMask",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanUnsharpMaskList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanUnsharpMaskOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThan",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanBackgroundColor",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanBackgroundColorList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanBackgroundColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanBlur",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanBlurList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanBlurOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanChromaKey",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanChromaKeyList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanChromaKeyOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanComposite",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanCompositeImage",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanCompositeImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanCompositeList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanCompositeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanCompound",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanCompoundList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanCompoundOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanCompoundTransformations",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanCompoundTransformationsList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanCompoundTransformationsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanContrast",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanContrastList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanContrastOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanGoop",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanGoopList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanGoopOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanGrayscale",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanGrayscaleList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanGrayscaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanHsl",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanHslList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanHslOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanHsv",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanHsvList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanHsvOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfDimension",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfDimensionDefault",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfDimensionDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfDimensionEqual",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfDimensionEqualOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfDimensionGreaterThan",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfDimensionGreaterThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfDimensionLessThan",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfDimensionLessThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfDimensionList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfDimensionOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfOrientation",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfOrientationDefault",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfOrientationDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfOrientationLandscape",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfOrientationLandscapeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfOrientationList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfOrientationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfOrientationPortrait",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfOrientationPortraitOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfOrientationSquare",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfOrientationSquareOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanMaxColors",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanMaxColorsList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanMaxColorsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanMirror",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanMirrorList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanMirrorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanMonoHue",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanMonoHueList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanMonoHueOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanOpacity",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanOpacityList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanOpacityOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanRemoveColor",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanRemoveColorList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanRemoveColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanUnsharpMask",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanUnsharpMaskList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanUnsharpMaskOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientation",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefault",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultBackgroundColor",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultBackgroundColorList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultBackgroundColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultBlur",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultBlurList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultBlurOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultChromaKey",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultChromaKeyList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultChromaKeyOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultComposite",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultCompositeImage",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultCompositeImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultCompositeList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultCompositeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultCompound",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultCompoundList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultCompoundOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultCompoundTransformations",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultCompoundTransformationsList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultCompoundTransformationsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultContrast",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultContrastList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultContrastOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultGoop",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultGoopList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultGoopOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultGrayscale",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultGrayscaleList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultGrayscaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultHsl",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultHslList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultHslOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultHsv",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultHsvList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultHsvOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfDimension",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfDimensionDefault",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfDimensionDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfDimensionEqual",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfDimensionEqualOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfDimensionGreaterThan",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfDimensionGreaterThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfDimensionLessThan",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfDimensionLessThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfDimensionList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfDimensionOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfOrientation",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfOrientationDefault",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfOrientationDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfOrientationLandscape",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfOrientationLandscapeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfOrientationList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfOrientationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfOrientationPortrait",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfOrientationPortraitOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfOrientationSquare",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfOrientationSquareOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultMaxColors",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultMaxColorsList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultMaxColorsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultMirror",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultMirrorList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultMirrorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultMonoHue",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultMonoHueList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultMonoHueOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultOpacity",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultOpacityList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultOpacityOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultRemoveColor",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultRemoveColorList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultRemoveColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultUnsharpMask",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultUnsharpMaskList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultUnsharpMaskOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscape",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeBackgroundColor",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeBackgroundColorList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeBackgroundColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeBlur",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeBlurList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeBlurOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeChromaKey",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeChromaKeyList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeChromaKeyOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeComposite",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeCompositeImage",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeCompositeImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeCompositeList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeCompositeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeCompound",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeCompoundList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeCompoundOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeCompoundTransformations",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeCompoundTransformationsList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeCompoundTransformationsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeContrast",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeContrastList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeContrastOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeGoop",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeGoopList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeGoopOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeGrayscale",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeGrayscaleList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeGrayscaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeHsl",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeHslList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeHslOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeHsv",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeHsvList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeHsvOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfDimension",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfDimensionDefault",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfDimensionDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfDimensionEqual",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfDimensionEqualOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfDimensionGreaterThan",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfDimensionGreaterThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfDimensionLessThan",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfDimensionLessThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfDimensionList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfDimensionOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfOrientation",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfOrientationDefault",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfOrientationDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfOrientationLandscape",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfOrientationLandscapeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfOrientationList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfOrientationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfOrientationPortrait",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfOrientationPortraitOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfOrientationSquare",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfOrientationSquareOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeMaxColors",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeMaxColorsList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeMaxColorsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeMirror",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeMirrorList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeMirrorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeMonoHue",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeMonoHueList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeMonoHueOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeOpacity",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeOpacityList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeOpacityOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeRemoveColor",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeRemoveColorList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeRemoveColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeUnsharpMask",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeUnsharpMaskList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeUnsharpMaskOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortrait",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitBackgroundColor",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitBackgroundColorList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitBackgroundColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitBlur",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitBlurList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitBlurOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitChromaKey",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitChromaKeyList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitChromaKeyOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitComposite",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitCompositeImage",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitCompositeImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitCompositeList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitCompositeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitCompound",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitCompoundList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitCompoundOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitCompoundTransformations",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitCompoundTransformationsList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitCompoundTransformationsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitContrast",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitContrastList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitContrastOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitGoop",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitGoopList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitGoopOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitGrayscale",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitGrayscaleList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitGrayscaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitHsl",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitHslList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitHslOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitHsv",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitHsvList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitHsvOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfDimension",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfDimensionDefault",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfDimensionDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfDimensionEqual",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfDimensionEqualOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfDimensionGreaterThan",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfDimensionGreaterThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfDimensionLessThan",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfDimensionLessThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfDimensionList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfDimensionOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfOrientation",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfOrientationDefault",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfOrientationDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfOrientationLandscape",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfOrientationLandscapeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfOrientationList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfOrientationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfOrientationPortrait",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfOrientationPortraitOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfOrientationSquare",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfOrientationSquareOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitMaxColors",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitMaxColorsList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitMaxColorsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitMirror",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitMirrorList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitMirrorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitMonoHue",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitMonoHueList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitMonoHueOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitOpacity",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitOpacityList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitOpacityOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitRemoveColor",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitRemoveColorList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitRemoveColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitUnsharpMask",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitUnsharpMaskList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitUnsharpMaskOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquare",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareBackgroundColor",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareBackgroundColorList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareBackgroundColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareBlur",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareBlurList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareBlurOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareChromaKey",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareChromaKeyList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareChromaKeyOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareComposite",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareCompositeImage",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareCompositeImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareCompositeList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareCompositeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareCompound",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareCompoundList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareCompoundOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareCompoundTransformations",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareCompoundTransformationsList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareCompoundTransformationsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareContrast",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareContrastList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareContrastOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareGoop",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareGoopList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareGoopOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareGrayscale",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareGrayscaleList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareGrayscaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareHsl",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareHslList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareHslOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareHsv",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareHsvList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareHsvOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfDimension",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfDimensionDefault",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfDimensionDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfDimensionEqual",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfDimensionEqualOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfDimensionGreaterThan",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfDimensionGreaterThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfDimensionLessThan",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfDimensionLessThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfDimensionList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfDimensionOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfOrientation",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfOrientationDefault",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfOrientationDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfOrientationLandscape",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfOrientationLandscapeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfOrientationList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfOrientationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfOrientationPortrait",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfOrientationPortraitOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfOrientationSquare",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfOrientationSquareOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareMaxColors",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareMaxColorsList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareMaxColorsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareMirror",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareMirrorList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareMirrorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareMonoHue",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareMonoHueList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareMonoHueOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareOpacity",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareOpacityList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareOpacityOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareRemoveColor",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareRemoveColorList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareRemoveColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareUnsharpMask",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareUnsharpMaskList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareUnsharpMaskOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsMaxColors",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsMaxColorsList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsMaxColorsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsMirror",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsMirrorList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsMirrorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsMonoHue",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsMonoHueList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsMonoHueOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsOpacity",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsOpacityList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsOpacityOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsRemoveColor",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsRemoveColorList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsRemoveColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsUnsharpMask",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsUnsharpMaskList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsUnsharpMaskOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsContrast",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsContrastList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsContrastOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsGoop",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsGoopList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsGoopOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsGrayscale",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsGrayscaleList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsGrayscaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsHsl",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsHslList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsHslOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsHsv",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsHsvList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsHsvOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimension",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefault",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultBackgroundColor",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultBackgroundColorList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultBackgroundColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultBlur",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultBlurList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultBlurOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultChromaKey",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultChromaKeyList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultChromaKeyOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultComposite",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImage",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageBoxImage",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageBoxImageList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageBoxImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageBoxImageTransformation",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageBoxImageTransformationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageCircleImage",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageCircleImageList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageCircleImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageCircleImageTransformation",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageCircleImageTransformationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageTextImage",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageTextImageList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageTextImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageTextImageTransformation",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageTextImageTransformationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageUrlImage",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageUrlImageList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageUrlImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageUrlImageTransformation",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageUrlImageTransformationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompound",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformations",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsBackgroundColor",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsBackgroundColorList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsBackgroundColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsBlur",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsBlurList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsBlurOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsChromaKey",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsChromaKeyList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsChromaKeyOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsComposite",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsCompositeImage",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsCompositeImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsCompositeList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsCompositeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsCompound",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsCompoundList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsCompoundOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsCompoundTransformations",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsCompoundTransformationsList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsCompoundTransformationsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsContrast",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsContrastList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsContrastOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsGoop",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsGoopList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsGoopOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsGrayscale",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsGrayscaleList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsGrayscaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsHsl",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsHslList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsHslOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsHsv",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsHsvList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsHsvOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfDimension",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfDimensionDefault",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfDimensionDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfDimensionEqual",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfDimensionEqualOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfDimensionGreaterThan",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfDimensionGreaterThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfDimensionLessThan",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfDimensionLessThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfDimensionList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfDimensionOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfOrientation",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfOrientationDefault",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfOrientationDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfOrientationLandscape",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfOrientationLandscapeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfOrientationList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfOrientationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfOrientationPortrait",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfOrientationPortraitOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfOrientationSquare",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfOrientationSquareOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsMaxColors",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsMaxColorsList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsMaxColorsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsMirror",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsMirrorList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsMirrorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsMonoHue",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsMonoHueList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsMonoHueOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsOpacity",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsOpacityList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsOpacityOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsRemoveColor",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsRemoveColorList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsRemoveColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsUnsharpMask",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsUnsharpMaskList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsUnsharpMaskOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultContrast",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultContrastList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultContrastOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultGoop",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultGoopList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultGoopOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultGrayscale",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultGrayscaleList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultGrayscaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultHsl",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultHslList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultHslOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultHsv",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultHsvList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultHsvOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientation",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscape",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeBackgroundColor",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeBackgroundColorList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeBackgroundColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeBlur",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeBlurList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeBlurOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeChromaKey",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeChromaKeyList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeChromaKeyOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeComposite",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeCompositeImage",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeCompositeImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeCompositeList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeCompositeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeCompound",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeCompoundList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeCompoundOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeCompoundTransformations",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeCompoundTransformationsList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeCompoundTransformationsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeContrast",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeContrastList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeContrastOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeGoop",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeGoopList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeGoopOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeGrayscale",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeGrayscaleList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeGrayscaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeHsl",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeHslList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeHslOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeHsv",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeHsvList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeHsvOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimension",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionDefault",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionEqual",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionEqualOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionGreaterThan",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionGreaterThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionLessThan",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionLessThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientation",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationDefault",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationLandscape",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationLandscapeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationPortrait",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationPortraitOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationSquare",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationSquareOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeMaxColors",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeMaxColorsList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeMaxColorsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeMirror",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeMirrorList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeMirrorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeMonoHue",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeMonoHueList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeMonoHueOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeOpacity",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeOpacityList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeOpacityOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeRemoveColor",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeRemoveColorList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeRemoveColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeUnsharpMask",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeUnsharpMaskList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeUnsharpMaskOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortrait",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitBackgroundColor",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitBackgroundColorList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitBackgroundColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitBlur",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitBlurList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitBlurOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitChromaKey",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitChromaKeyList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitChromaKeyOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitComposite",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitCompositeImage",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitCompositeImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitCompositeList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitCompositeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitCompound",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitCompoundList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitCompoundOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitCompoundTransformations",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitCompoundTransformationsList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitCompoundTransformationsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitContrast",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitContrastList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitContrastOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitGoop",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitGoopList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitGoopOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitGrayscale",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitGrayscaleList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitGrayscaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitHsl",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitHslList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitHslOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitHsv",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitHsvList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitHsvOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfDimension",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionDefault",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionEqual",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionEqualOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionGreaterThan",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionGreaterThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionLessThan",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionLessThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientation",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationDefault",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationLandscape",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationLandscapeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationPortrait",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationPortraitOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationSquare",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationSquareOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitMaxColors",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitMaxColorsList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitMaxColorsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitMirror",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitMirrorList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitMirrorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitMonoHue",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitMonoHueList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitMonoHueOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitOpacity",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitOpacityList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitOpacityOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitRemoveColor",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitRemoveColorList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitRemoveColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitUnsharpMask",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitUnsharpMaskList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitUnsharpMaskOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquare",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareBackgroundColor",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareBackgroundColorList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareBackgroundColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareBlur",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareBlurList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareBlurOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareChromaKey",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareChromaKeyList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareChromaKeyOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareComposite",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareCompositeImage",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareCompositeImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareCompositeList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareCompositeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareCompound",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareCompoundList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareCompoundOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareCompoundTransformations",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareCompoundTransformationsList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareCompoundTransformationsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareContrast",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareContrastList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareContrastOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareGoop",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareGoopList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareGoopOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareGrayscale",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareGrayscaleList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareGrayscaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareHsl",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareHslList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareHslOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareHsv",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareHsvList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareHsvOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfDimension",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionDefault",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionEqual",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionEqualOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionGreaterThan",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionGreaterThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionLessThan",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionLessThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfOrientation",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationDefault",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationLandscape",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationLandscapeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationPortrait",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationPortraitOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationSquare",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationSquareOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareMaxColors",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareMaxColorsList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareMaxColorsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareMirror",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareMirrorList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareMirrorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareMonoHue",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareMonoHueList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareMonoHueOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareOpacity",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareOpacityList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareOpacityOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareRemoveColor",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareRemoveColorList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareRemoveColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareUnsharpMask",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareUnsharpMaskList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareUnsharpMaskOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultMaxColors",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultMaxColorsList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultMaxColorsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultMirror",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultMirrorList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultMirrorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultMonoHue",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultMonoHueList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultMonoHueOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultOpacity",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultOpacityList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultOpacityOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultRemoveColor",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultRemoveColorList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultRemoveColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultUnsharpMask",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultUnsharpMaskList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultUnsharpMaskOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqual",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualBackgroundColor",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualBackgroundColorList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualBackgroundColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualBlur",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualBlurList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualBlurOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualChromaKey",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualChromaKeyList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualChromaKeyOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualComposite",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImage",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageBoxImage",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageBoxImageList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageBoxImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageBoxImageTransformation",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageBoxImageTransformationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageCircleImage",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageCircleImageList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageCircleImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageCircleImageTransformation",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageCircleImageTransformationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageTextImage",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageTextImageList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageTextImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageTextImageTransformation",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageTextImageTransformationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageUrlImage",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageUrlImageList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageUrlImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageUrlImageTransformation",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageUrlImageTransformationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompound",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformations",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsBackgroundColor",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsBackgroundColorList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsBackgroundColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsBlur",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsBlurList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsBlurOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsChromaKey",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsChromaKeyList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsChromaKeyOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsComposite",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsCompositeImage",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsCompositeImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsCompositeList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsCompositeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsCompound",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsCompoundList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsCompoundOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsCompoundTransformations",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsCompoundTransformationsList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsCompoundTransformationsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsContrast",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsContrastList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsContrastOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsGoop",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsGoopList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsGoopOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsGrayscale",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsGrayscaleList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsGrayscaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsHsl",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsHslList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsHslOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsHsv",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsHsvList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsHsvOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfDimension",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfDimensionDefault",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfDimensionDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfDimensionEqual",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfDimensionEqualOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfDimensionGreaterThan",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfDimensionGreaterThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfDimensionLessThan",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfDimensionLessThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfDimensionList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfDimensionOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfOrientation",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfOrientationDefault",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfOrientationDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfOrientationLandscape",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfOrientationLandscapeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfOrientationList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfOrientationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfOrientationPortrait",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfOrientationPortraitOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfOrientationSquare",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfOrientationSquareOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsMaxColors",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsMaxColorsList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsMaxColorsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsMirror",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsMirrorList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsMirrorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsMonoHue",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsMonoHueList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsMonoHueOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsOpacity",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsOpacityList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsOpacityOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsRemoveColor",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsRemoveColorList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsRemoveColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsUnsharpMask",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsUnsharpMaskList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsUnsharpMaskOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualContrast",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualContrastList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualContrastOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualGoop",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualGoopList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualGoopOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualGrayscale",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualGrayscaleList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualGrayscaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualHsl",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualHslList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualHslOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualHsv",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualHsvList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualHsvOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientation",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefault",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultBackgroundColor",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultBackgroundColorList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultBackgroundColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultBlur",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultBlurList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultBlurOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultChromaKey",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultChromaKeyList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultChromaKeyOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultComposite",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultCompositeImage",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultCompositeImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultCompositeList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultCompositeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultCompound",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultCompoundList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultCompoundOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultCompoundTransformations",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultCompoundTransformationsList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultCompoundTransformationsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultContrast",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultContrastList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultContrastOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultGoop",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultGoopList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultGoopOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultGrayscale",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultGrayscaleList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultGrayscaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultHsl",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultHslList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultHslOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultHsv",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultHsvList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultHsvOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfDimension",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionDefault",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionEqual",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionEqualOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionGreaterThan",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionGreaterThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionLessThan",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionLessThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfOrientation",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationDefault",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationLandscape",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationLandscapeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationPortrait",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationPortraitOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationSquare",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationSquareOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultMaxColors",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultMaxColorsList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultMaxColorsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultMirror",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultMirrorList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultMirrorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultMonoHue",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultMonoHueList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultMonoHueOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultOpacity",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultOpacityList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultOpacityOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultRemoveColor",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultRemoveColorList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultRemoveColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultUnsharpMask",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultUnsharpMaskList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultUnsharpMaskOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscape",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeBackgroundColor",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeBackgroundColorList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeBackgroundColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeBlur",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeBlurList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeBlurOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeChromaKey",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeChromaKeyList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeChromaKeyOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeComposite",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeCompositeImage",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeCompositeImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeCompositeList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeCompositeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeCompound",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeCompoundList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeCompoundOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeCompoundTransformations",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeCompoundTransformationsList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeCompoundTransformationsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeContrast",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeContrastList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeContrastOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeGoop",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeGoopList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeGoopOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeGrayscale",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeGrayscaleList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeGrayscaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeHsl",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeHslList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeHslOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeHsv",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeHsvList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeHsvOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfDimension",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionDefault",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionEqual",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionEqualOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionGreaterThan",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionGreaterThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionLessThan",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionLessThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientation",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationDefault",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationLandscape",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationLandscapeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationPortrait",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationPortraitOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationSquare",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationSquareOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeMaxColors",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeMaxColorsList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeMaxColorsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeMirror",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeMirrorList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeMirrorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeMonoHue",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeMonoHueList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeMonoHueOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeOpacity",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeOpacityList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeOpacityOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeRemoveColor",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeRemoveColorList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeRemoveColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeUnsharpMask",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeUnsharpMaskList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeUnsharpMaskOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortrait",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitBackgroundColor",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitBackgroundColorList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitBackgroundColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitBlur",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitBlurList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitBlurOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitChromaKey",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitChromaKeyList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitChromaKeyOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitComposite",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitCompositeImage",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitCompositeImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitCompositeList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitCompositeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitCompound",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitCompoundList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitCompoundOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitCompoundTransformations",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitCompoundTransformationsList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitCompoundTransformationsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitContrast",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitContrastList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitContrastOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitGoop",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitGoopList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitGoopOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitGrayscale",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitGrayscaleList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitGrayscaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitHsl",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitHslList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitHslOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitHsv",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitHsvList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitHsvOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfDimension",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionDefault",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionEqual",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionEqualOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionGreaterThan",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionGreaterThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionLessThan",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionLessThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfOrientation",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationDefault",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationLandscape",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationLandscapeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationPortrait",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationPortraitOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationSquare",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationSquareOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitMaxColors",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitMaxColorsList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitMaxColorsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitMirror",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitMirrorList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitMirrorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitMonoHue",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitMonoHueList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitMonoHueOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitOpacity",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitOpacityList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitOpacityOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitRemoveColor",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitRemoveColorList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitRemoveColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitUnsharpMask",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitUnsharpMaskList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitUnsharpMaskOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquare",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareBackgroundColor",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareBackgroundColorList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareBackgroundColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareBlur",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareBlurList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareBlurOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareChromaKey",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareChromaKeyList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareChromaKeyOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareComposite",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareCompositeImage",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareCompositeImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareCompositeList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareCompositeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareCompound",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareCompoundList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareCompoundOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareCompoundTransformations",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareCompoundTransformationsList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareCompoundTransformationsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareContrast",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareContrastList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareContrastOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareGoop",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareGoopList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareGoopOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareGrayscale",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareGrayscaleList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareGrayscaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareHsl",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareHslList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareHslOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareHsv",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareHsvList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareHsvOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfDimension",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfDimensionDefault",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfDimensionDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfDimensionEqual",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfDimensionEqualOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfDimensionGreaterThan",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfDimensionGreaterThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfDimensionLessThan",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfDimensionLessThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfDimensionList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfDimensionOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfOrientation",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfOrientationDefault",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfOrientationDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfOrientationLandscape",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfOrientationLandscapeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfOrientationList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfOrientationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfOrientationPortrait",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfOrientationPortraitOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfOrientationSquare",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfOrientationSquareOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareMaxColors",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareMaxColorsList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareMaxColorsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareMirror",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareMirrorList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareMirrorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareMonoHue",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareMonoHueList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareMonoHueOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareOpacity",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareOpacityList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareOpacityOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareRemoveColor",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareRemoveColorList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareRemoveColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareUnsharpMask",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareUnsharpMaskList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareUnsharpMaskOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualMaxColors",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualMaxColorsList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualMaxColorsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualMirror",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualMirrorList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualMirrorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualMonoHue",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualMonoHueList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualMonoHueOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualOpacity",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualOpacityList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualOpacityOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualRemoveColor",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualRemoveColorList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualRemoveColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualUnsharpMask",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualUnsharpMaskList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualUnsharpMaskOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThan",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanBackgroundColor",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanBackgroundColorList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanBackgroundColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanBlur",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanBlurList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanBlurOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanChromaKey",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanChromaKeyList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanChromaKeyOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanComposite",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImage",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageBoxImage",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageBoxImageList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageBoxImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageBoxImageTransformation",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageBoxImageTransformationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageCircleImage",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageCircleImageList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageCircleImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageCircleImageTransformation",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageCircleImageTransformationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageTextImage",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageTextImageList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageTextImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageTextImageTransformation",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageTextImageTransformationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageUrlImage",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageUrlImageList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageUrlImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageUrlImageTransformation",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageUrlImageTransformationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompound",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformations",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsBackgroundColor",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsBackgroundColorList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsBackgroundColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsBlur",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsBlurList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsBlurOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsChromaKey",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsChromaKeyList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsChromaKeyOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsComposite",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsCompositeImage",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsCompositeImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsCompositeList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsCompositeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsCompound",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsCompoundList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsCompoundOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsCompoundTransformations",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsCompoundTransformationsList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsCompoundTransformationsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsContrast",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsContrastList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsContrastOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsGoop",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsGoopList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsGoopOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsGrayscale",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsGrayscaleList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsGrayscaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsHsl",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsHslList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsHslOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsHsv",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsHsvList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsHsvOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfDimension",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfDimensionDefault",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfDimensionDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfDimensionEqual",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfDimensionEqualOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfDimensionGreaterThan",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfDimensionGreaterThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfDimensionLessThan",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfDimensionLessThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfDimensionList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfDimensionOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfOrientation",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfOrientationDefault",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfOrientationDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfOrientationLandscape",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfOrientationLandscapeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfOrientationList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfOrientationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfOrientationPortrait",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfOrientationPortraitOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfOrientationSquare",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfOrientationSquareOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsMaxColors",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsMaxColorsList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsMaxColorsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsMirror",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsMirrorList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsMirrorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsMonoHue",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsMonoHueList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsMonoHueOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsOpacity",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsOpacityList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsOpacityOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsRemoveColor",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsRemoveColorList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsRemoveColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsUnsharpMask",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsUnsharpMaskList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsUnsharpMaskOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanContrast",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanContrastList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanContrastOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanGoop",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanGoopList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanGoopOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanGrayscale",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanGrayscaleList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanGrayscaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanHsl",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanHslList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanHslOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanHsv",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanHsvList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanHsvOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientation",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefault",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultBackgroundColor",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultBackgroundColorList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultBackgroundColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultBlur",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultBlurList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultBlurOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultChromaKey",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultChromaKeyList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultChromaKeyOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultComposite",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultCompositeImage",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultCompositeImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultCompositeList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultCompositeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultCompound",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultCompoundList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultCompoundOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultCompoundTransformations",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultCompoundTransformationsList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultCompoundTransformationsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultContrast",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultContrastList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultContrastOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultGoop",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultGoopList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultGoopOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultGrayscale",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultGrayscaleList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultGrayscaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultHsl",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultHslList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultHslOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultHsv",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultHsvList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultHsvOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimension",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionDefault",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionEqual",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionEqualOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionGreaterThan",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionGreaterThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionLessThan",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionLessThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientation",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationDefault",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationLandscape",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationLandscapeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationPortrait",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationPortraitOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationSquare",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationSquareOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultMaxColors",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultMaxColorsList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultMaxColorsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultMirror",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultMirrorList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultMirrorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultMonoHue",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultMonoHueList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultMonoHueOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultOpacity",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultOpacityList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultOpacityOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultRemoveColor",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultRemoveColorList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultRemoveColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultUnsharpMask",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultUnsharpMaskList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultUnsharpMaskOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscape",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeBackgroundColor",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeBackgroundColorList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeBackgroundColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeBlur",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeBlurList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeBlurOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeChromaKey",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeChromaKeyList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeChromaKeyOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeComposite",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompositeImage",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompositeImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompositeList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompositeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompound",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompoundList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompoundOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompoundTransformations",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompoundTransformationsList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompoundTransformationsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeContrast",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeContrastList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeContrastOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeGoop",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeGoopList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeGoopOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeGrayscale",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeGrayscaleList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeGrayscaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeHsl",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeHslList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeHslOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeHsv",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeHsvList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeHsvOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimension",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionDefault",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionEqual",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionEqualOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionGreaterThan",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionGreaterThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionLessThan",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionLessThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientation",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationDefault",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationLandscape",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationLandscapeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationPortrait",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationPortraitOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationSquare",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationSquareOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeMaxColors",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeMaxColorsList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeMaxColorsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeMirror",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeMirrorList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeMirrorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeMonoHue",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeMonoHueList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeMonoHueOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeOpacity",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeOpacityList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeOpacityOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeRemoveColor",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeRemoveColorList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeRemoveColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeUnsharpMask",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeUnsharpMaskList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeUnsharpMaskOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortrait",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitBackgroundColor",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitBackgroundColorList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitBackgroundColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitBlur",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitBlurList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitBlurOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitChromaKey",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitChromaKeyList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitChromaKeyOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitComposite",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitCompositeImage",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitCompositeImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitCompositeList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitCompositeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitCompound",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitCompoundList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitCompoundOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitCompoundTransformations",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitCompoundTransformationsList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitCompoundTransformationsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitContrast",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitContrastList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitContrastOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitGoop",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitGoopList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitGoopOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitGrayscale",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitGrayscaleList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitGrayscaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitHsl",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitHslList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitHslOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitHsv",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitHsvList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitHsvOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimension",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionDefault",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionEqual",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionEqualOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionGreaterThan",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionGreaterThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionLessThan",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionLessThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientation",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationDefault",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationLandscape",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationLandscapeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationPortrait",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationPortraitOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationSquare",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationSquareOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitMaxColors",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitMaxColorsList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitMaxColorsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitMirror",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitMirrorList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitMirrorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitMonoHue",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitMonoHueList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitMonoHueOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitOpacity",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitOpacityList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitOpacityOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitRemoveColor",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitRemoveColorList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitRemoveColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitUnsharpMask",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitUnsharpMaskList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitUnsharpMaskOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquare",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareBackgroundColor",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareBackgroundColorList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareBackgroundColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareBlur",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareBlurList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareBlurOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareChromaKey",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareChromaKeyList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareChromaKeyOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareComposite",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareCompositeImage",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareCompositeImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareCompositeList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareCompositeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareCompound",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareCompoundList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareCompoundOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareCompoundTransformations",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareCompoundTransformationsList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareCompoundTransformationsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareContrast",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareContrastList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareContrastOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareGoop",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareGoopList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareGoopOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareGrayscale",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareGrayscaleList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareGrayscaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareHsl",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareHslList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareHslOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareHsv",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareHsvList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareHsvOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimension",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionDefault",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionEqual",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionEqualOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionGreaterThan",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionGreaterThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionLessThan",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionLessThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientation",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationDefault",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationLandscape",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationLandscapeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationPortrait",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationPortraitOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationSquare",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationSquareOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareMaxColors",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareMaxColorsList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareMaxColorsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareMirror",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareMirrorList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareMirrorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareMonoHue",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareMonoHueList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareMonoHueOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareOpacity",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareOpacityList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareOpacityOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareRemoveColor",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareRemoveColorList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareRemoveColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareUnsharpMask",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareUnsharpMaskList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareUnsharpMaskOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanMaxColors",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanMaxColorsList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanMaxColorsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanMirror",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanMirrorList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanMirrorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanMonoHue",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanMonoHueList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanMonoHueOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanOpacity",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanOpacityList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanOpacityOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanRemoveColor",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanRemoveColorList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanRemoveColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanUnsharpMask",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanUnsharpMaskList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanUnsharpMaskOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThan",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanBackgroundColor",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanBackgroundColorList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanBackgroundColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanBlur",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanBlurList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanBlurOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanChromaKey",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanChromaKeyList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanChromaKeyOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanComposite",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImage",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageBoxImage",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageBoxImageList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageBoxImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageBoxImageTransformation",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageBoxImageTransformationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageCircleImage",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageCircleImageList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageCircleImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageCircleImageTransformation",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageCircleImageTransformationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageTextImage",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageTextImageList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageTextImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageTextImageTransformation",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageTextImageTransformationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageUrlImage",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageUrlImageList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageUrlImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageUrlImageTransformation",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageUrlImageTransformationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompound",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformations",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsBackgroundColor",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsBackgroundColorList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsBackgroundColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsBlur",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsBlurList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsBlurOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsChromaKey",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsChromaKeyList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsChromaKeyOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsComposite",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsCompositeImage",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsCompositeImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsCompositeList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsCompositeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsCompound",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsCompoundList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsCompoundOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsCompoundTransformations",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsCompoundTransformationsList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsCompoundTransformationsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsContrast",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsContrastList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsContrastOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsGoop",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsGoopList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsGoopOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsGrayscale",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsGrayscaleList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsGrayscaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsHsl",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsHslList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsHslOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsHsv",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsHsvList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsHsvOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfDimension",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfDimensionDefault",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfDimensionDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfDimensionEqual",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfDimensionEqualOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfDimensionGreaterThan",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfDimensionGreaterThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfDimensionLessThan",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfDimensionLessThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfDimensionList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfDimensionOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfOrientation",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfOrientationDefault",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfOrientationDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfOrientationLandscape",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfOrientationLandscapeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfOrientationList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfOrientationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfOrientationPortrait",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfOrientationPortraitOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfOrientationSquare",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfOrientationSquareOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsMaxColors",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsMaxColorsList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsMaxColorsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsMirror",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsMirrorList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsMirrorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsMonoHue",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsMonoHueList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsMonoHueOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsOpacity",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsOpacityList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsOpacityOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsRemoveColor",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsRemoveColorList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsRemoveColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsUnsharpMask",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsUnsharpMaskList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsUnsharpMaskOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanContrast",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanContrastList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanContrastOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanGoop",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanGoopList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanGoopOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanGrayscale",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanGrayscaleList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanGrayscaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanHsl",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanHslList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanHslOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanHsv",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanHsvList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanHsvOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientation",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefault",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultBackgroundColor",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultBackgroundColorList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultBackgroundColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultBlur",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultBlurList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultBlurOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultChromaKey",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultChromaKeyList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultChromaKeyOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultComposite",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultCompositeImage",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultCompositeImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultCompositeList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultCompositeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultCompound",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultCompoundList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultCompoundOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultCompoundTransformations",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultCompoundTransformationsList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultCompoundTransformationsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultContrast",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultContrastList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultContrastOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultGoop",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultGoopList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultGoopOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultGrayscale",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultGrayscaleList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultGrayscaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultHsl",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultHslList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultHslOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultHsv",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultHsvList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultHsvOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfDimension",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionDefault",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionEqual",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionEqualOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionGreaterThan",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionGreaterThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionLessThan",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionLessThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientation",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationDefault",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationLandscape",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationLandscapeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationPortrait",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationPortraitOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationSquare",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationSquareOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultMaxColors",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultMaxColorsList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultMaxColorsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultMirror",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultMirrorList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultMirrorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultMonoHue",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultMonoHueList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultMonoHueOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultOpacity",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultOpacityList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultOpacityOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultRemoveColor",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultRemoveColorList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultRemoveColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultUnsharpMask",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultUnsharpMaskList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultUnsharpMaskOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscape",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeBackgroundColor",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeBackgroundColorList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeBackgroundColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeBlur",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeBlurList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeBlurOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeChromaKey",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeChromaKeyList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeChromaKeyOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeComposite",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeCompositeImage",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeCompositeImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeCompositeList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeCompositeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeCompound",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeCompoundList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeCompoundOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeCompoundTransformations",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeCompoundTransformationsList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeCompoundTransformationsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeContrast",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeContrastList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeContrastOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeGoop",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeGoopList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeGoopOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeGrayscale",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeGrayscaleList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeGrayscaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeHsl",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeHslList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeHslOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeHsv",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeHsvList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeHsvOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimension",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionDefault",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionEqual",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionEqualOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionGreaterThan",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionGreaterThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionLessThan",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionLessThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientation",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationDefault",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationLandscape",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationLandscapeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationPortrait",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationPortraitOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationSquare",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationSquareOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeMaxColors",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeMaxColorsList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeMaxColorsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeMirror",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeMirrorList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeMirrorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeMonoHue",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeMonoHueList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeMonoHueOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeOpacity",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeOpacityList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeOpacityOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeRemoveColor",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeRemoveColorList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeRemoveColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeUnsharpMask",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeUnsharpMaskList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeUnsharpMaskOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortrait",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitBackgroundColor",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitBackgroundColorList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitBackgroundColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitBlur",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitBlurList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitBlurOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitChromaKey",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitChromaKeyList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitChromaKeyOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitComposite",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitCompositeImage",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitCompositeImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitCompositeList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitCompositeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitCompound",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitCompoundList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitCompoundOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitCompoundTransformations",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitCompoundTransformationsList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitCompoundTransformationsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitContrast",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitContrastList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitContrastOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitGoop",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitGoopList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitGoopOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitGrayscale",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitGrayscaleList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitGrayscaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitHsl",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitHslList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitHslOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitHsv",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitHsvList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitHsvOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfDimension",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionDefault",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionEqual",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionEqualOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionGreaterThan",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionGreaterThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionLessThan",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionLessThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientation",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationDefault",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationLandscape",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationLandscapeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationPortrait",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationPortraitOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationSquare",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationSquareOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitMaxColors",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitMaxColorsList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitMaxColorsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitMirror",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitMirrorList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitMirrorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitMonoHue",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitMonoHueList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitMonoHueOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitOpacity",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitOpacityList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitOpacityOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitRemoveColor",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitRemoveColorList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitRemoveColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitUnsharpMask",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitUnsharpMaskList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitUnsharpMaskOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquare",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareBackgroundColor",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareBackgroundColorList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareBackgroundColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareBlur",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareBlurList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareBlurOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareChromaKey",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareChromaKeyList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareChromaKeyOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareComposite",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareCompositeImage",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareCompositeImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareCompositeList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareCompositeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareCompound",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareCompoundList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareCompoundOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareCompoundTransformations",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareCompoundTransformationsList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareCompoundTransformationsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareContrast",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareContrastList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareContrastOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareGoop",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareGoopList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareGoopOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareGrayscale",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareGrayscaleList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareGrayscaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareHsl",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareHslList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareHslOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareHsv",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareHsvList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareHsvOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfDimension",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionDefault",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionEqual",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionEqualOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionGreaterThan",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionGreaterThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionLessThan",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionLessThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfOrientation",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationDefault",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationLandscape",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationLandscapeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationPortrait",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationPortraitOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationSquare",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationSquareOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareMaxColors",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareMaxColorsList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareMaxColorsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareMirror",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareMirrorList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareMirrorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareMonoHue",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareMonoHueList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareMonoHueOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareOpacity",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareOpacityList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareOpacityOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareRemoveColor",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareRemoveColorList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareRemoveColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareUnsharpMask",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareUnsharpMaskList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareUnsharpMaskOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanMaxColors",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanMaxColorsList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanMaxColorsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanMirror",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanMirrorList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanMirrorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanMonoHue",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanMonoHueList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanMonoHueOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanOpacity",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanOpacityList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanOpacityOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanRemoveColor",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanRemoveColorList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanRemoveColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanUnsharpMask",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanUnsharpMaskList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanUnsharpMaskOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientation",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefault",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultBackgroundColor",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultBackgroundColorList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultBackgroundColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultBlur",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultBlurList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultBlurOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultChromaKey",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultChromaKeyList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultChromaKeyOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultComposite",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImage",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageBoxImage",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageBoxImageList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageBoxImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageBoxImageTransformation",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageBoxImageTransformationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageCircleImage",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageCircleImageList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageCircleImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageCircleImageTransformation",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageCircleImageTransformationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageTextImage",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageTextImageList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageTextImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageTextImageTransformation",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageTextImageTransformationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageUrlImage",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageUrlImageList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageUrlImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageUrlImageTransformation",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageUrlImageTransformationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompound",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformations",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsBackgroundColor",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsBackgroundColorList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsBackgroundColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsBlur",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsBlurList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsBlurOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsChromaKey",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsChromaKeyList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsChromaKeyOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsComposite",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsCompositeImage",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsCompositeImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsCompositeList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsCompositeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsCompound",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsCompoundList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsCompoundOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsCompoundTransformations",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsCompoundTransformationsList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsCompoundTransformationsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsContrast",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsContrastList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsContrastOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsGoop",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsGoopList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsGoopOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsGrayscale",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsGrayscaleList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsGrayscaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsHsl",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsHslList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsHslOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsHsv",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsHsvList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsHsvOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfDimension",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfDimensionDefault",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfDimensionDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfDimensionEqual",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfDimensionEqualOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfDimensionGreaterThan",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfDimensionGreaterThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfDimensionLessThan",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfDimensionLessThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfDimensionList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfDimensionOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfOrientation",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfOrientationDefault",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfOrientationDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfOrientationLandscape",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfOrientationLandscapeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfOrientationList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfOrientationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfOrientationPortrait",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfOrientationPortraitOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfOrientationSquare",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfOrientationSquareOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsMaxColors",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsMaxColorsList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsMaxColorsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsMirror",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsMirrorList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsMirrorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsMonoHue",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsMonoHueList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsMonoHueOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsOpacity",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsOpacityList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsOpacityOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsRemoveColor",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsRemoveColorList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsRemoveColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsUnsharpMask",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsUnsharpMaskList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsUnsharpMaskOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultContrast",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultContrastList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultContrastOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultGoop",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultGoopList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultGoopOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultGrayscale",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultGrayscaleList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultGrayscaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultHsl",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultHslList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultHslOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultHsv",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultHsvList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultHsvOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimension",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqual",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualBackgroundColor",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualBackgroundColorList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualBackgroundColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualBlur",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualBlurList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualBlurOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualChromaKey",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualChromaKeyList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualChromaKeyOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualComposite",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualCompositeImage",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualCompositeImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualCompositeList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualCompositeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualCompound",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualCompoundList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualCompoundOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualCompoundTransformations",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualCompoundTransformationsList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualCompoundTransformationsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualContrast",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualContrastList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualContrastOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualGoop",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualGoopList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualGoopOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualGrayscale",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualGrayscaleList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualGrayscaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualHsl",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualHslList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualHslOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualHsv",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualHsvList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualHsvOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfDimension",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionDefault",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionEqual",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionEqualOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionGreaterThan",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionGreaterThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionLessThan",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionLessThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfOrientation",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationDefault",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationLandscape",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationLandscapeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationPortrait",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationPortraitOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationSquare",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationSquareOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualMaxColors",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualMaxColorsList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualMaxColorsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualMirror",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualMirrorList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualMirrorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualMonoHue",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualMonoHueList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualMonoHueOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualOpacity",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualOpacityList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualOpacityOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualRemoveColor",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualRemoveColorList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualRemoveColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualUnsharpMask",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualUnsharpMaskList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualUnsharpMaskOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThan",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanBackgroundColor",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanBackgroundColorList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanBackgroundColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanBlur",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanBlurList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanBlurOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanChromaKey",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanChromaKeyList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanChromaKeyOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanComposite",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanCompositeImage",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanCompositeImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanCompositeList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanCompositeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanCompound",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanCompoundList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanCompoundOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanCompoundTransformations",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanCompoundTransformationsList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanCompoundTransformationsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanContrast",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanContrastList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanContrastOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanGoop",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanGoopList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanGoopOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanGrayscale",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanGrayscaleList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanGrayscaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanHsl",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanHslList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanHslOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanHsv",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanHsvList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanHsvOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimension",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionDefault",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionEqual",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionEqualOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionGreaterThan",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionGreaterThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionLessThan",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionLessThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientation",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationDefault",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationLandscape",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationLandscapeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationPortrait",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationPortraitOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationSquare",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationSquareOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanMaxColors",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanMaxColorsList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanMaxColorsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanMirror",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanMirrorList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanMirrorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanMonoHue",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanMonoHueList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanMonoHueOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanOpacity",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanOpacityList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanOpacityOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanRemoveColor",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanRemoveColorList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanRemoveColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanUnsharpMask",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanUnsharpMaskList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanUnsharpMaskOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThan",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanBackgroundColor",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanBackgroundColorList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanBackgroundColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanBlur",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanBlurList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanBlurOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanChromaKey",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanChromaKeyList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanChromaKeyOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanComposite",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanCompositeImage",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanCompositeImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanCompositeList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanCompositeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanCompound",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanCompoundList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanCompoundOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanCompoundTransformations",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanCompoundTransformationsList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanCompoundTransformationsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanContrast",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanContrastList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanContrastOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanGoop",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanGoopList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanGoopOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanGrayscale",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanGrayscaleList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanGrayscaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanHsl",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanHslList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanHslOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanHsv",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanHsvList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanHsvOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfDimension",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionDefault",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionEqual",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionEqualOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionGreaterThan",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionGreaterThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionLessThan",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionLessThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientation",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationDefault",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationLandscape",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationLandscapeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationPortrait",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationPortraitOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationSquare",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationSquareOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanMaxColors",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanMaxColorsList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanMaxColorsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanMirror",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanMirrorList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanMirrorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanMonoHue",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanMonoHueList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanMonoHueOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanOpacity",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanOpacityList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanOpacityOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanRemoveColor",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanRemoveColorList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanRemoveColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanUnsharpMask",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanUnsharpMaskList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanUnsharpMaskOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultMaxColors",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultMaxColorsList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultMaxColorsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultMirror",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultMirrorList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultMirrorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultMonoHue",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultMonoHueList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultMonoHueOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultOpacity",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultOpacityList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultOpacityOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultRemoveColor",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultRemoveColorList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultRemoveColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultUnsharpMask",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultUnsharpMaskList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultUnsharpMaskOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscape",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeBackgroundColor",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeBackgroundColorList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeBackgroundColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeBlur",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeBlurList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeBlurOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeChromaKey",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeChromaKeyList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeChromaKeyOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeComposite",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImage",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageBoxImage",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageBoxImageList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageBoxImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageBoxImageTransformation",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageBoxImageTransformationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageCircleImage",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageCircleImageList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageCircleImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageCircleImageTransformation",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageCircleImageTransformationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageTextImage",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageTextImageList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageTextImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageTextImageTransformation",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageTextImageTransformationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageUrlImage",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageUrlImageList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageUrlImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageUrlImageTransformation",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageUrlImageTransformationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompound",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformations",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsBackgroundColor",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsBackgroundColorList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsBackgroundColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsBlur",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsBlurList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsBlurOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsChromaKey",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsChromaKeyList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsChromaKeyOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsComposite",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsCompositeImage",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsCompositeImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsCompositeList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsCompositeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsCompound",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsCompoundList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsCompoundOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsCompoundTransformations",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsCompoundTransformationsList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsCompoundTransformationsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsContrast",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsContrastList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsContrastOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsGoop",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsGoopList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsGoopOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsGrayscale",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsGrayscaleList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsGrayscaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsHsl",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsHslList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsHslOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsHsv",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsHsvList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsHsvOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfDimension",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfDimensionDefault",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfDimensionDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfDimensionEqual",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfDimensionEqualOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfDimensionGreaterThan",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfDimensionGreaterThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfDimensionLessThan",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfDimensionLessThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfDimensionList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfDimensionOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfOrientation",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfOrientationDefault",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfOrientationDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfOrientationLandscape",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfOrientationLandscapeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfOrientationList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfOrientationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfOrientationPortrait",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfOrientationPortraitOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfOrientationSquare",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfOrientationSquareOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsMaxColors",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsMaxColorsList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsMaxColorsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsMirror",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsMirrorList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsMirrorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsMonoHue",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsMonoHueList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsMonoHueOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsOpacity",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsOpacityList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsOpacityOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsRemoveColor",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsRemoveColorList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsRemoveColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsUnsharpMask",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsUnsharpMaskList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsUnsharpMaskOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeContrast",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeContrastList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeContrastOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeGoop",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeGoopList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeGoopOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeGrayscale",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeGrayscaleList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeGrayscaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeHsl",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeHslList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeHslOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeHsv",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeHsvList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeHsvOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimension",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefault",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultBackgroundColor",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultBackgroundColorList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultBackgroundColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultBlur",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultBlurList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultBlurOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultChromaKey",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultChromaKeyList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultChromaKeyOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultComposite",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultCompositeImage",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultCompositeImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultCompositeList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultCompositeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultCompound",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultCompoundList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultCompoundOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultCompoundTransformations",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultCompoundTransformationsList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultCompoundTransformationsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultContrast",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultContrastList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultContrastOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultGoop",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultGoopList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultGoopOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultGrayscale",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultGrayscaleList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultGrayscaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultHsl",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultHslList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultHslOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultHsv",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultHsvList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultHsvOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimension",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionDefault",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionEqual",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionEqualOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionGreaterThan",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionGreaterThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionLessThan",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionLessThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientation",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationDefault",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationLandscape",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationLandscapeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationPortrait",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationPortraitOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationSquare",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationSquareOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultMaxColors",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultMaxColorsList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultMaxColorsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultMirror",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultMirrorList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultMirrorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultMonoHue",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultMonoHueList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultMonoHueOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultOpacity",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultOpacityList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultOpacityOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultRemoveColor",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultRemoveColorList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultRemoveColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultUnsharpMask",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultUnsharpMaskList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultUnsharpMaskOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqual",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualBackgroundColor",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualBackgroundColorList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualBackgroundColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualBlur",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualBlurList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualBlurOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualChromaKey",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualChromaKeyList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualChromaKeyOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualComposite",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualCompositeImage",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualCompositeImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualCompositeList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualCompositeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualCompound",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualCompoundList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualCompoundOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualCompoundTransformations",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualCompoundTransformationsList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualCompoundTransformationsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualContrast",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualContrastList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualContrastOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualGoop",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualGoopList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualGoopOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualGrayscale",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualGrayscaleList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualGrayscaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualHsl",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualHslList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualHslOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualHsv",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualHsvList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualHsvOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfDimension",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionDefault",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionEqual",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionEqualOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionGreaterThan",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionGreaterThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionLessThan",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionLessThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientation",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationDefault",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationLandscape",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationLandscapeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationPortrait",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationPortraitOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationSquare",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationSquareOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualMaxColors",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualMaxColorsList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualMaxColorsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualMirror",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualMirrorList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualMirrorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualMonoHue",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualMonoHueList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualMonoHueOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualOpacity",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualOpacityList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualOpacityOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualRemoveColor",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualRemoveColorList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualRemoveColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualUnsharpMask",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualUnsharpMaskList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualUnsharpMaskOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThan",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanBackgroundColor",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanBackgroundColorList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanBackgroundColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanBlur",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanBlurList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanBlurOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanChromaKey",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanChromaKeyList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanChromaKeyOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanComposite",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompositeImage",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompositeImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompositeList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompositeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompound",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompoundList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompoundOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompoundTransformations",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompoundTransformationsList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompoundTransformationsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanContrast",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanContrastList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanContrastOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanGoop",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanGoopList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanGoopOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanGrayscale",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanGrayscaleList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanGrayscaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanHsl",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanHslList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanHslOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanHsv",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanHsvList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanHsvOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimension",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionDefault",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionEqual",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionEqualOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionGreaterThan",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionGreaterThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionLessThan",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionLessThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientation",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationDefault",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationLandscape",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationLandscapeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationPortrait",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationPortraitOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationSquare",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationSquareOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanMaxColors",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanMaxColorsList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanMaxColorsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanMirror",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanMirrorList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanMirrorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanMonoHue",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanMonoHueList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanMonoHueOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanOpacity",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanOpacityList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanOpacityOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanRemoveColor",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanRemoveColorList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanRemoveColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanUnsharpMask",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanUnsharpMaskList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanUnsharpMaskOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThan",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanBackgroundColor",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanBackgroundColorList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanBackgroundColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanBlur",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanBlurList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanBlurOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanChromaKey",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanChromaKeyList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanChromaKeyOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanComposite",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanCompositeImage",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanCompositeImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanCompositeList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanCompositeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanCompound",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanCompoundList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanCompoundOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanCompoundTransformations",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanCompoundTransformationsList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanCompoundTransformationsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanContrast",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanContrastList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanContrastOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanGoop",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanGoopList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanGoopOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanGrayscale",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanGrayscaleList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanGrayscaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanHsl",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanHslList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanHslOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanHsv",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanHsvList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanHsvOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimension",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionDefault",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionEqual",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionEqualOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionGreaterThan",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionGreaterThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionLessThan",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionLessThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientation",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationDefault",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationLandscape",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationLandscapeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationPortrait",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationPortraitOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationSquare",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationSquareOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanMaxColors",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanMaxColorsList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanMaxColorsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanMirror",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanMirrorList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanMirrorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanMonoHue",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanMonoHueList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanMonoHueOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanOpacity",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanOpacityList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanOpacityOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanRemoveColor",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanRemoveColorList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanRemoveColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanUnsharpMask",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanUnsharpMaskList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanUnsharpMaskOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeMaxColors",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeMaxColorsList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeMaxColorsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeMirror",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeMirrorList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeMirrorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeMonoHue",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeMonoHueList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeMonoHueOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeOpacity",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeOpacityList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeOpacityOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeRemoveColor",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeRemoveColorList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeRemoveColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeUnsharpMask",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeUnsharpMaskList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeUnsharpMaskOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortrait",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitBackgroundColor",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitBackgroundColorList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitBackgroundColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitBlur",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitBlurList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitBlurOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitChromaKey",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitChromaKeyList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitChromaKeyOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitComposite",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImage",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageBoxImage",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageBoxImageList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageBoxImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageBoxImageTransformation",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageBoxImageTransformationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageCircleImage",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageCircleImageList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageCircleImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageCircleImageTransformation",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageCircleImageTransformationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageTextImage",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageTextImageList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageTextImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageTextImageTransformation",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageTextImageTransformationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageUrlImage",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageUrlImageList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageUrlImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageUrlImageTransformation",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageUrlImageTransformationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompound",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformations",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsBackgroundColor",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsBackgroundColorList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsBackgroundColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsBlur",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsBlurList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsBlurOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsChromaKey",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsChromaKeyList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsChromaKeyOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsComposite",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsCompositeImage",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsCompositeImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsCompositeList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsCompositeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsCompound",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsCompoundList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsCompoundOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsCompoundTransformations",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsCompoundTransformationsList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsCompoundTransformationsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsContrast",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsContrastList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsContrastOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsGoop",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsGoopList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsGoopOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsGrayscale",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsGrayscaleList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsGrayscaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsHsl",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsHslList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsHslOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsHsv",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsHsvList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsHsvOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfDimension",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfDimensionDefault",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfDimensionDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfDimensionEqual",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfDimensionEqualOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfDimensionGreaterThan",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfDimensionGreaterThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfDimensionLessThan",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfDimensionLessThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfDimensionList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfDimensionOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfOrientation",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfOrientationDefault",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfOrientationDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfOrientationLandscape",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfOrientationLandscapeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfOrientationList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfOrientationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfOrientationPortrait",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfOrientationPortraitOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfOrientationSquare",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfOrientationSquareOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsMaxColors",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsMaxColorsList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsMaxColorsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsMirror",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsMirrorList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsMirrorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsMonoHue",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsMonoHueList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsMonoHueOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsOpacity",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsOpacityList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsOpacityOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsRemoveColor",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsRemoveColorList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsRemoveColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsUnsharpMask",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsUnsharpMaskList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsUnsharpMaskOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitContrast",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitContrastList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitContrastOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitGoop",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitGoopList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitGoopOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitGrayscale",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitGrayscaleList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitGrayscaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitHsl",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitHslList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitHslOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitHsv",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitHsvList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitHsvOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimension",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefault",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultBackgroundColor",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultBackgroundColorList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultBackgroundColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultBlur",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultBlurList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultBlurOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultChromaKey",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultChromaKeyList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultChromaKeyOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultComposite",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultCompositeImage",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultCompositeImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultCompositeList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultCompositeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultCompound",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultCompoundList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultCompoundOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultCompoundTransformations",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultCompoundTransformationsList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultCompoundTransformationsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultContrast",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultContrastList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultContrastOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultGoop",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultGoopList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultGoopOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultGrayscale",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultGrayscaleList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultGrayscaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultHsl",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultHslList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultHslOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultHsv",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultHsvList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultHsvOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimension",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionDefault",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionEqual",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionEqualOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionGreaterThan",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionGreaterThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionLessThan",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionLessThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientation",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationDefault",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationLandscape",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationLandscapeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationPortrait",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationPortraitOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationSquare",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationSquareOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultMaxColors",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultMaxColorsList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultMaxColorsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultMirror",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultMirrorList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultMirrorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultMonoHue",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultMonoHueList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultMonoHueOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultOpacity",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultOpacityList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultOpacityOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultRemoveColor",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultRemoveColorList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultRemoveColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultUnsharpMask",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultUnsharpMaskList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultUnsharpMaskOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqual",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualBackgroundColor",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualBackgroundColorList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualBackgroundColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualBlur",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualBlurList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualBlurOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualChromaKey",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualChromaKeyList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualChromaKeyOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualComposite",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualCompositeImage",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualCompositeImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualCompositeList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualCompositeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualCompound",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualCompoundList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualCompoundOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualCompoundTransformations",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualCompoundTransformationsList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualCompoundTransformationsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualContrast",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualContrastList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualContrastOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualGoop",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualGoopList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualGoopOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualGrayscale",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualGrayscaleList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualGrayscaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualHsl",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualHslList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualHslOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualHsv",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualHsvList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualHsvOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimension",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionDefault",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionEqual",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionEqualOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionGreaterThan",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionGreaterThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionLessThan",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionLessThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientation",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationDefault",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationLandscape",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationLandscapeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationPortrait",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationPortraitOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationSquare",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationSquareOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualMaxColors",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualMaxColorsList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualMaxColorsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualMirror",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualMirrorList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualMirrorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualMonoHue",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualMonoHueList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualMonoHueOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualOpacity",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualOpacityList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualOpacityOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualRemoveColor",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualRemoveColorList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualRemoveColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualUnsharpMask",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualUnsharpMaskList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualUnsharpMaskOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThan",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanBackgroundColor",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanBackgroundColorList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanBackgroundColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanBlur",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanBlurList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanBlurOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanChromaKey",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanChromaKeyList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanChromaKeyOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanComposite",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanCompositeImage",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanCompositeImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanCompositeList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanCompositeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanCompound",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanCompoundList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanCompoundOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanCompoundTransformations",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanCompoundTransformationsList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanCompoundTransformationsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanContrast",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanContrastList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanContrastOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanGoop",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanGoopList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanGoopOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanGrayscale",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanGrayscaleList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanGrayscaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanHsl",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanHslList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanHslOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanHsv",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanHsvList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanHsvOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimension",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionDefault",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionEqual",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionEqualOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionGreaterThan",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionGreaterThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionLessThan",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionLessThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientation",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationDefault",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationLandscape",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationLandscapeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationPortrait",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationPortraitOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationSquare",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationSquareOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanMaxColors",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanMaxColorsList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanMaxColorsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanMirror",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanMirrorList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanMirrorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanMonoHue",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanMonoHueList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanMonoHueOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanOpacity",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanOpacityList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanOpacityOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanRemoveColor",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanRemoveColorList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanRemoveColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanUnsharpMask",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanUnsharpMaskList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanUnsharpMaskOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThan",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanBackgroundColor",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanBackgroundColorList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanBackgroundColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanBlur",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanBlurList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanBlurOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanChromaKey",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanChromaKeyList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanChromaKeyOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanComposite",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanCompositeImage",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanCompositeImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanCompositeList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanCompositeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanCompound",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanCompoundList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanCompoundOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanCompoundTransformations",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanCompoundTransformationsList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanCompoundTransformationsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanContrast",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanContrastList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanContrastOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanGoop",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanGoopList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanGoopOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanGrayscale",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanGrayscaleList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanGrayscaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanHsl",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanHslList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanHslOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanHsv",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanHsvList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanHsvOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfDimension",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionDefault",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionEqual",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionEqualOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionGreaterThan",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionGreaterThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionLessThan",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionLessThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientation",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationDefault",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationLandscape",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationLandscapeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationPortrait",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationPortraitOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationSquare",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationSquareOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanMaxColors",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanMaxColorsList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanMaxColorsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanMirror",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanMirrorList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanMirrorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanMonoHue",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanMonoHueList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanMonoHueOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanOpacity",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanOpacityList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanOpacityOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanRemoveColor",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanRemoveColorList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanRemoveColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanUnsharpMask",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanUnsharpMaskList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanUnsharpMaskOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitMaxColors",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitMaxColorsList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitMaxColorsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitMirror",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitMirrorList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitMirrorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitMonoHue",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitMonoHueList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitMonoHueOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitOpacity",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitOpacityList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitOpacityOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitRemoveColor",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitRemoveColorList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitRemoveColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitUnsharpMask",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitUnsharpMaskList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitUnsharpMaskOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquare",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareBackgroundColor",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareBackgroundColorList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareBackgroundColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareBlur",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareBlurList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareBlurOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareChromaKey",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareChromaKeyList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareChromaKeyOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareComposite",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImage",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageBoxImage",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageBoxImageList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageBoxImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageBoxImageTransformation",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageBoxImageTransformationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageCircleImage",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageCircleImageList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageCircleImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageCircleImageTransformation",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageCircleImageTransformationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageTextImage",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageTextImageList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageTextImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageTextImageTransformation",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageTextImageTransformationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageUrlImage",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageUrlImageList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageUrlImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageUrlImageTransformation",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageUrlImageTransformationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompound",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformations",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsBackgroundColor",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsBackgroundColorList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsBackgroundColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsBlur",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsBlurList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsBlurOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsChromaKey",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsChromaKeyList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsChromaKeyOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsComposite",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsCompositeImage",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsCompositeImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsCompositeList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsCompositeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsCompound",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsCompoundList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsCompoundOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsCompoundTransformations",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsCompoundTransformationsList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsCompoundTransformationsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsContrast",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsContrastList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsContrastOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsGoop",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsGoopList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsGoopOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsGrayscale",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsGrayscaleList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsGrayscaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsHsl",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsHslList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsHslOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsHsv",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsHsvList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsHsvOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfDimension",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfDimensionDefault",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfDimensionDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfDimensionEqual",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfDimensionEqualOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfDimensionGreaterThan",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfDimensionGreaterThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfDimensionLessThan",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfDimensionLessThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfDimensionList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfDimensionOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfOrientation",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfOrientationDefault",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfOrientationDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfOrientationLandscape",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfOrientationLandscapeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfOrientationList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfOrientationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfOrientationPortrait",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfOrientationPortraitOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfOrientationSquare",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfOrientationSquareOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsMaxColors",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsMaxColorsList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsMaxColorsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsMirror",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsMirrorList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsMirrorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsMonoHue",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsMonoHueList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsMonoHueOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsOpacity",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsOpacityList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsOpacityOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsRemoveColor",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsRemoveColorList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsRemoveColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsUnsharpMask",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsUnsharpMaskList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsUnsharpMaskOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareContrast",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareContrastList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareContrastOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareGoop",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareGoopList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareGoopOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareGrayscale",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareGrayscaleList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareGrayscaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareHsl",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareHslList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareHslOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareHsv",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareHsvList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareHsvOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimension",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefault",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultBackgroundColor",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultBackgroundColorList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultBackgroundColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultBlur",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultBlurList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultBlurOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultChromaKey",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultChromaKeyList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultChromaKeyOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultComposite",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultCompositeImage",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultCompositeImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultCompositeList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultCompositeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultCompound",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultCompoundList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultCompoundOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultCompoundTransformations",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultCompoundTransformationsList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultCompoundTransformationsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultContrast",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultContrastList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultContrastOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultGoop",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultGoopList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultGoopOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultGrayscale",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultGrayscaleList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultGrayscaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultHsl",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultHslList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultHslOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultHsv",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultHsvList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultHsvOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfDimension",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionDefault",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionEqual",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionEqualOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionGreaterThan",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionGreaterThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionLessThan",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionLessThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfOrientation",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationDefault",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationLandscape",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationLandscapeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationPortrait",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationPortraitOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationSquare",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationSquareOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultMaxColors",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultMaxColorsList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultMaxColorsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultMirror",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultMirrorList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultMirrorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultMonoHue",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultMonoHueList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultMonoHueOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultOpacity",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultOpacityList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultOpacityOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultRemoveColor",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultRemoveColorList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultRemoveColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultUnsharpMask",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultUnsharpMaskList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultUnsharpMaskOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqual",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualBackgroundColor",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualBackgroundColorList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualBackgroundColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualBlur",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualBlurList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualBlurOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualChromaKey",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualChromaKeyList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualChromaKeyOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualComposite",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualCompositeImage",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualCompositeImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualCompositeList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualCompositeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualCompound",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualCompoundList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualCompoundOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualCompoundTransformations",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualCompoundTransformationsList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualCompoundTransformationsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualContrast",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualContrastList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualContrastOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualGoop",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualGoopList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualGoopOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualGrayscale",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualGrayscaleList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualGrayscaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualHsl",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualHslList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualHslOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualHsv",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualHsvList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualHsvOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfDimension",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfDimensionDefault",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfDimensionDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfDimensionEqual",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfDimensionEqualOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfDimensionGreaterThan",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfDimensionGreaterThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfDimensionLessThan",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfDimensionLessThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfDimensionList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfDimensionOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfOrientation",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfOrientationDefault",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfOrientationDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfOrientationLandscape",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfOrientationLandscapeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfOrientationList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfOrientationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfOrientationPortrait",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfOrientationPortraitOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfOrientationSquare",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfOrientationSquareOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualMaxColors",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualMaxColorsList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualMaxColorsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualMirror",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualMirrorList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualMirrorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualMonoHue",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualMonoHueList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualMonoHueOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualOpacity",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualOpacityList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualOpacityOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualRemoveColor",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualRemoveColorList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualRemoveColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualUnsharpMask",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualUnsharpMaskList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualUnsharpMaskOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThan",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanBackgroundColor",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanBackgroundColorList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanBackgroundColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanBlur",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanBlurList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanBlurOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanChromaKey",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanChromaKeyList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanChromaKeyOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanComposite",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanCompositeImage",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanCompositeImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanCompositeList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanCompositeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanCompound",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanCompoundList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanCompoundOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanCompoundTransformations",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanCompoundTransformationsList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanCompoundTransformationsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanContrast",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanContrastList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanContrastOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanGoop",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanGoopList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanGoopOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanGrayscale",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanGrayscaleList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanGrayscaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanHsl",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanHslList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanHslOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanHsv",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanHsvList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanHsvOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimension",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionDefault",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionEqual",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionEqualOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionGreaterThan",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionGreaterThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionLessThan",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionLessThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientation",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationDefault",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationLandscape",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationLandscapeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationPortrait",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationPortraitOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationSquare",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationSquareOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanMaxColors",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanMaxColorsList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanMaxColorsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanMirror",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanMirrorList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanMirrorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanMonoHue",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanMonoHueList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanMonoHueOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanOpacity",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanOpacityList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanOpacityOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanRemoveColor",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanRemoveColorList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanRemoveColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanUnsharpMask",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanUnsharpMaskList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanUnsharpMaskOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThan",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanBackgroundColor",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanBackgroundColorList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanBackgroundColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanBlur",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanBlurList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanBlurOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanChromaKey",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanChromaKeyList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanChromaKeyOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanComposite",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanCompositeImage",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanCompositeImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanCompositeList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanCompositeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanCompound",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanCompoundList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanCompoundOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanCompoundTransformations",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanCompoundTransformationsList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanCompoundTransformationsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanContrast",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanContrastList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanContrastOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanGoop",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanGoopList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanGoopOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanGrayscale",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanGrayscaleList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanGrayscaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanHsl",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanHslList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanHslOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanHsv",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanHsvList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanHsvOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfDimension",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionDefault",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionEqual",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionEqualOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionGreaterThan",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionGreaterThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionLessThan",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionLessThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfOrientation",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationDefault",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationLandscape",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationLandscapeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationPortrait",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationPortraitOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationSquare",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationSquareOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanMaxColors",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanMaxColorsList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanMaxColorsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanMirror",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanMirrorList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanMirrorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanMonoHue",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanMonoHueList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanMonoHueOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanOpacity",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanOpacityList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanOpacityOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanRemoveColor",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanRemoveColorList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanRemoveColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanUnsharpMask",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanUnsharpMaskList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanUnsharpMaskOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareMaxColors",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareMaxColorsList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareMaxColorsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareMirror",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareMirrorList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareMirrorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareMonoHue",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareMonoHueList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareMonoHueOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareOpacity",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareOpacityList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareOpacityOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareRemoveColor",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareRemoveColorList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareRemoveColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareUnsharpMask",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareUnsharpMaskList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareUnsharpMaskOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsMaxColors",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsMaxColorsList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsMaxColorsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsMirror",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsMirrorList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsMirrorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsMonoHue",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsMonoHueList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsMonoHueOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsOpacity",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsOpacityList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsOpacityOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsRemoveColor",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsRemoveColorList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsRemoveColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsUnsharpMask",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsUnsharpMaskList",
    "DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsUnsharpMaskOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformations",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppend",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationAppend",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationAppendImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationAppendImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationAppendList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationAppendOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationAspectCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationAspectCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationAspectCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationBackgroundColor",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationBackgroundColorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationBackgroundColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationBlur",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationBlurList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationBlurOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationChromaKey",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationChromaKeyList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationChromaKeyOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationComposite",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationCompositeImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationCompositeImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationCompositeList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationCompositeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationCompound",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationCompoundList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationCompoundOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationCompoundTransformations",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationCompoundTransformationsList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationCompoundTransformationsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationContrast",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationContrastList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationContrastOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationFaceCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationFaceCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationFaceCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationFeatureCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationFeatureCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationFeatureCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationFitAndFill",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationFitAndFillFillTransformation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationFitAndFillFillTransformationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationFitAndFillList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationFitAndFillOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationGoop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationGoopList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationGoopOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationGrayscale",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationGrayscaleList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationGrayscaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationHsl",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationHslList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationHslOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationHsv",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationHsvList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationHsvOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfDimension",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfDimensionDefault",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfDimensionDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfDimensionEqual",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfDimensionEqualOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfDimensionGreaterThan",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfDimensionGreaterThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfDimensionLessThan",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfDimensionLessThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfDimensionList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfDimensionOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfOrientation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfOrientationDefault",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfOrientationDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfOrientationLandscape",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfOrientationLandscapeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfOrientationList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfOrientationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfOrientationPortrait",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfOrientationPortraitOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfOrientationSquare",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfOrientationSquareOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationImQuery",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationImQueryList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationImQueryOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationMaxColors",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationMaxColorsList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationMaxColorsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationMirror",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationMirrorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationMirrorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationMonoHue",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationMonoHueList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationMonoHueOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationOpacity",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationOpacityList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationOpacityOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationRegionOfInterestCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationRegionOfInterestCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationRegionOfInterestCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationRegionOfInterestCropRegionOfInterest",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationRegionOfInterestCropRegionOfInterestOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationRelativeCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationRelativeCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationRelativeCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationRemoveColor",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationRemoveColorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationRemoveColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationResize",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationResizeList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationResizeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationRotate",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationRotateList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationRotateOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationScale",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationScaleList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationScaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationShear",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationShearList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationShearOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationTrim",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationTrimList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationTrimOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationUnsharpMask",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationUnsharpMaskList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationUnsharpMaskOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationAppend",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationAppendImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationAppendImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationAppendList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationAppendOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationAspectCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationAspectCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationAspectCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationBackgroundColor",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationBackgroundColorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationBackgroundColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationBlur",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationBlurList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationBlurOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationChromaKey",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationChromaKeyList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationChromaKeyOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationComposite",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationCompositeImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationCompositeImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationCompositeList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationCompositeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationCompound",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationCompoundList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationCompoundOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationCompoundTransformations",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationCompoundTransformationsList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationCompoundTransformationsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationContrast",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationContrastList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationContrastOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationFaceCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationFaceCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationFaceCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationFeatureCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationFeatureCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationFeatureCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationFitAndFill",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationFitAndFillFillTransformation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationFitAndFillFillTransformationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationFitAndFillList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationFitAndFillOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationGoop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationGoopList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationGoopOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationGrayscale",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationGrayscaleList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationGrayscaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationHsl",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationHslList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationHslOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationHsv",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationHsvList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationHsvOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfDimension",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfDimensionDefault",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfDimensionDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfDimensionEqual",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfDimensionEqualOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfDimensionGreaterThan",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfDimensionGreaterThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfDimensionLessThan",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfDimensionLessThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfDimensionList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfDimensionOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfOrientation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfOrientationDefault",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfOrientationDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfOrientationLandscape",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfOrientationLandscapeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfOrientationList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfOrientationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfOrientationPortrait",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfOrientationPortraitOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfOrientationSquare",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfOrientationSquareOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationImQuery",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationImQueryList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationImQueryOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationMaxColors",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationMaxColorsList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationMaxColorsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationMirror",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationMirrorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationMirrorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationMonoHue",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationMonoHueList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationMonoHueOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationOpacity",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationOpacityList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationOpacityOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationRegionOfInterestCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationRegionOfInterestCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationRegionOfInterestCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationRegionOfInterestCropRegionOfInterest",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationRegionOfInterestCropRegionOfInterestOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationRelativeCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationRelativeCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationRelativeCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationRemoveColor",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationRemoveColorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationRemoveColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationResize",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationResizeList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationResizeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationRotate",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationRotateList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationRotateOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationScale",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationScaleList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationScaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationShear",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationShearList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationShearOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationTrim",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationTrimList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationTrimOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationUnsharpMask",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationUnsharpMaskList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationUnsharpMaskOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationAppend",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationAppendImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationAppendImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationAppendList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationAppendOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationAspectCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationAspectCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationAspectCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationBackgroundColor",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationBackgroundColorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationBackgroundColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationBlur",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationBlurList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationBlurOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationChromaKey",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationChromaKeyList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationChromaKeyOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationComposite",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationCompositeImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationCompositeImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationCompositeList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationCompositeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationCompound",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationCompoundList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationCompoundOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationCompoundTransformations",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationCompoundTransformationsList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationCompoundTransformationsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationContrast",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationContrastList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationContrastOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationFaceCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationFaceCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationFaceCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationFeatureCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationFeatureCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationFeatureCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationFitAndFill",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationFitAndFillFillTransformation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationFitAndFillFillTransformationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationFitAndFillList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationFitAndFillOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationGoop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationGoopList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationGoopOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationGrayscale",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationGrayscaleList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationGrayscaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationHsl",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationHslList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationHslOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationHsv",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationHsvList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationHsvOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfDimension",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfDimensionDefault",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfDimensionDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfDimensionEqual",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfDimensionEqualOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfDimensionGreaterThan",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfDimensionGreaterThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfDimensionLessThan",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfDimensionLessThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfDimensionList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfDimensionOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfOrientation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfOrientationDefault",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfOrientationDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfOrientationLandscape",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfOrientationLandscapeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfOrientationList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfOrientationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfOrientationPortrait",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfOrientationPortraitOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfOrientationSquare",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfOrientationSquareOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationImQuery",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationImQueryList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationImQueryOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationMaxColors",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationMaxColorsList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationMaxColorsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationMirror",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationMirrorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationMirrorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationMonoHue",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationMonoHueList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationMonoHueOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationOpacity",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationOpacityList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationOpacityOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationRegionOfInterestCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationRegionOfInterestCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationRegionOfInterestCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationRegionOfInterestCropRegionOfInterest",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationRegionOfInterestCropRegionOfInterestOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationRelativeCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationRelativeCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationRelativeCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationRemoveColor",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationRemoveColorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationRemoveColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationResize",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationResizeList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationResizeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationRotate",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationRotateList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationRotateOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationScale",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationScaleList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationScaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationShear",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationShearList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationShearOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationTrim",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationTrimList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationTrimOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationUnsharpMask",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationUnsharpMaskList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationUnsharpMaskOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationAppend",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationAppendImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationAppendImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationAppendList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationAppendOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationAspectCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationAspectCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationAspectCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationBackgroundColor",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationBackgroundColorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationBackgroundColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationBlur",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationBlurList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationBlurOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationChromaKey",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationChromaKeyList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationChromaKeyOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationComposite",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationCompositeImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationCompositeImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationCompositeList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationCompositeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationCompound",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationCompoundList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationCompoundOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationCompoundTransformations",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationCompoundTransformationsList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationCompoundTransformationsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationContrast",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationContrastList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationContrastOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationFaceCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationFaceCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationFaceCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationFeatureCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationFeatureCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationFeatureCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationFitAndFill",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationFitAndFillFillTransformation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationFitAndFillFillTransformationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationFitAndFillList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationFitAndFillOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationGoop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationGoopList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationGoopOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationGrayscale",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationGrayscaleList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationGrayscaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationHsl",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationHslList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationHslOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationHsv",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationHsvList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationHsvOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfDimension",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfDimensionDefault",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfDimensionDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfDimensionEqual",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfDimensionEqualOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfDimensionGreaterThan",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfDimensionGreaterThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfDimensionLessThan",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfDimensionLessThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfDimensionList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfDimensionOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfOrientation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfOrientationDefault",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfOrientationDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfOrientationLandscape",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfOrientationLandscapeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfOrientationList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfOrientationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfOrientationPortrait",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfOrientationPortraitOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfOrientationSquare",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfOrientationSquareOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationImQuery",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationImQueryList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationImQueryOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationMaxColors",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationMaxColorsList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationMaxColorsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationMirror",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationMirrorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationMirrorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationMonoHue",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationMonoHueList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationMonoHueOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationOpacity",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationOpacityList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationOpacityOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationRegionOfInterestCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationRegionOfInterestCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationRegionOfInterestCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationRegionOfInterestCropRegionOfInterest",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationRegionOfInterestCropRegionOfInterestOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationRelativeCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationRelativeCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationRelativeCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationRemoveColor",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationRemoveColorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationRemoveColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationResize",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationResizeList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationResizeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationRotate",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationRotateList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationRotateOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationScale",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationScaleList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationScaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationShear",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationShearList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationShearOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationTrim",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationTrimList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationTrimOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationUnsharpMask",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationUnsharpMaskList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationUnsharpMaskOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAppendOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAspectCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAspectCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsAspectCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsBackgroundColor",
    "DataAkamaiImagingPolicyImagePolicyTransformationsBackgroundColorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsBackgroundColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsBlur",
    "DataAkamaiImagingPolicyImagePolicyTransformationsBlurList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsBlurOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsChromaKey",
    "DataAkamaiImagingPolicyImagePolicyTransformationsChromaKeyList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsChromaKeyOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsComposite",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationAppend",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationAppendImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationAppendImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationAppendList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationAppendOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationAspectCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationAspectCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationAspectCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationBackgroundColor",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationBackgroundColorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationBackgroundColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationBlur",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationBlurList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationBlurOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationChromaKey",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationChromaKeyList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationChromaKeyOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationComposite",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationCompositeImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationCompositeImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationCompositeList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationCompositeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationCompound",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationCompoundList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationCompoundOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationCompoundTransformations",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationCompoundTransformationsList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationCompoundTransformationsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationContrast",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationContrastList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationContrastOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationFaceCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationFaceCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationFaceCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationFeatureCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationFeatureCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationFeatureCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationFitAndFill",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationFitAndFillFillTransformation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationFitAndFillFillTransformationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationFitAndFillList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationFitAndFillOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationGoop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationGoopList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationGoopOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationGrayscale",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationGrayscaleList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationGrayscaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationHsl",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationHslList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationHslOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationHsv",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationHsvList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationHsvOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfDimension",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfDimensionDefault",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfDimensionDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfDimensionEqual",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfDimensionEqualOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfDimensionGreaterThan",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfDimensionGreaterThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfDimensionLessThan",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfDimensionLessThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfDimensionList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfDimensionOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfOrientation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfOrientationDefault",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfOrientationDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfOrientationLandscape",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfOrientationLandscapeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfOrientationList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfOrientationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfOrientationPortrait",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfOrientationPortraitOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfOrientationSquare",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationIfOrientationSquareOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationImQuery",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationImQueryList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationImQueryOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationMaxColors",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationMaxColorsList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationMaxColorsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationMirror",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationMirrorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationMirrorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationMonoHue",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationMonoHueList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationMonoHueOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationOpacity",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationOpacityList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationOpacityOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationRegionOfInterestCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationRegionOfInterestCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationRegionOfInterestCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationRegionOfInterestCropRegionOfInterest",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationRegionOfInterestCropRegionOfInterestOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationRelativeCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationRelativeCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationRelativeCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationRemoveColor",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationRemoveColorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationRemoveColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationResize",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationResizeList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationResizeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationRotate",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationRotateList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationRotateOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationScale",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationScaleList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationScaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationShear",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationShearList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationShearOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationTrim",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationTrimList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationTrimOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationUnsharpMask",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationUnsharpMaskList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageTransformationUnsharpMaskOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationAppend",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationAppendImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationAppendImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationAppendList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationAppendOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationAspectCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationAspectCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationAspectCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationBackgroundColor",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationBackgroundColorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationBackgroundColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationBlur",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationBlurList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationBlurOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationChromaKey",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationChromaKeyList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationChromaKeyOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationComposite",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationCompositeImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationCompositeImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationCompositeList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationCompositeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationCompound",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationCompoundList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationCompoundOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationCompoundTransformations",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationCompoundTransformationsList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationCompoundTransformationsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationContrast",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationContrastList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationContrastOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationFaceCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationFaceCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationFaceCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationFeatureCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationFeatureCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationFeatureCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationFitAndFill",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationFitAndFillFillTransformation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationFitAndFillFillTransformationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationFitAndFillList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationFitAndFillOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationGoop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationGoopList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationGoopOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationGrayscale",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationGrayscaleList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationGrayscaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationHsl",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationHslList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationHslOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationHsv",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationHsvList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationHsvOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfDimension",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfDimensionDefault",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfDimensionDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfDimensionEqual",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfDimensionEqualOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfDimensionGreaterThan",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfDimensionGreaterThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfDimensionLessThan",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfDimensionLessThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfDimensionList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfDimensionOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfOrientation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfOrientationDefault",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfOrientationDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfOrientationLandscape",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfOrientationLandscapeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfOrientationList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfOrientationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfOrientationPortrait",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfOrientationPortraitOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfOrientationSquare",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationIfOrientationSquareOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationImQuery",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationImQueryList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationImQueryOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationMaxColors",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationMaxColorsList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationMaxColorsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationMirror",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationMirrorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationMirrorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationMonoHue",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationMonoHueList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationMonoHueOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationOpacity",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationOpacityList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationOpacityOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationRegionOfInterestCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationRegionOfInterestCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationRegionOfInterestCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationRegionOfInterestCropRegionOfInterest",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationRegionOfInterestCropRegionOfInterestOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationRelativeCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationRelativeCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationRelativeCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationRemoveColor",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationRemoveColorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationRemoveColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationResize",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationResizeList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationResizeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationRotate",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationRotateList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationRotateOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationScale",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationScaleList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationScaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationShear",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationShearList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationShearOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationTrim",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationTrimList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationTrimOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationUnsharpMask",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationUnsharpMaskList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageTransformationUnsharpMaskOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationAppend",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationAppendImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationAppendImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationAppendList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationAppendOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationAspectCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationAspectCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationAspectCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationBackgroundColor",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationBackgroundColorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationBackgroundColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationBlur",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationBlurList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationBlurOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationChromaKey",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationChromaKeyList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationChromaKeyOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationComposite",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationCompositeImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationCompositeImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationCompositeList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationCompositeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationCompound",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationCompoundList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationCompoundOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationCompoundTransformations",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationCompoundTransformationsList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationCompoundTransformationsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationContrast",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationContrastList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationContrastOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationFaceCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationFaceCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationFaceCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationFeatureCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationFeatureCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationFeatureCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationFitAndFill",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationFitAndFillFillTransformation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationFitAndFillFillTransformationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationFitAndFillList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationFitAndFillOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationGoop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationGoopList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationGoopOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationGrayscale",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationGrayscaleList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationGrayscaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationHsl",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationHslList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationHslOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationHsv",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationHsvList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationHsvOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfDimension",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfDimensionDefault",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfDimensionDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfDimensionEqual",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfDimensionEqualOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfDimensionGreaterThan",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfDimensionGreaterThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfDimensionLessThan",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfDimensionLessThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfDimensionList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfDimensionOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfOrientation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfOrientationDefault",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfOrientationDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfOrientationLandscape",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfOrientationLandscapeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfOrientationList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfOrientationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfOrientationPortrait",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfOrientationPortraitOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfOrientationSquare",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationIfOrientationSquareOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationImQuery",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationImQueryList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationImQueryOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationMaxColors",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationMaxColorsList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationMaxColorsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationMirror",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationMirrorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationMirrorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationMonoHue",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationMonoHueList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationMonoHueOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationOpacity",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationOpacityList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationOpacityOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationRegionOfInterestCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationRegionOfInterestCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationRegionOfInterestCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationRegionOfInterestCropRegionOfInterest",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationRegionOfInterestCropRegionOfInterestOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationRelativeCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationRelativeCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationRelativeCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationRemoveColor",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationRemoveColorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationRemoveColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationResize",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationResizeList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationResizeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationRotate",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationRotateList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationRotateOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationScale",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationScaleList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationScaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationShear",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationShearList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationShearOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationTrim",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationTrimList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationTrimOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationUnsharpMask",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationUnsharpMaskList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageTransformationUnsharpMaskOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationAppend",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationAppendImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationAppendImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationAppendList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationAppendOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationAspectCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationAspectCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationAspectCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationBackgroundColor",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationBackgroundColorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationBackgroundColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationBlur",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationBlurList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationBlurOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationChromaKey",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationChromaKeyList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationChromaKeyOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationComposite",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCompositeImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCompositeImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCompositeList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCompositeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCompound",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCompoundList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCompoundOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCompoundTransformations",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCompoundTransformationsList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCompoundTransformationsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationContrast",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationContrastList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationContrastOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationFaceCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationFaceCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationFaceCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationFeatureCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationFeatureCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationFeatureCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationFitAndFill",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationFitAndFillFillTransformation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationFitAndFillFillTransformationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationFitAndFillList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationFitAndFillOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationGoop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationGoopList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationGoopOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationGrayscale",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationGrayscaleList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationGrayscaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationHsl",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationHslList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationHslOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationHsv",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationHsvList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationHsvOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimension",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimensionDefault",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimensionDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimensionEqual",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimensionEqualOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimensionGreaterThan",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimensionGreaterThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimensionLessThan",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimensionLessThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimensionList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimensionOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientationDefault",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientationDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientationLandscape",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientationLandscapeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientationList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientationPortrait",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientationPortraitOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientationSquare",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientationSquareOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationImQuery",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationImQueryList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationImQueryOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationMaxColors",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationMaxColorsList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationMaxColorsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationMirror",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationMirrorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationMirrorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationMonoHue",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationMonoHueList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationMonoHueOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationOpacity",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationOpacityList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationOpacityOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRegionOfInterestCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRegionOfInterestCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRegionOfInterestCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRegionOfInterestCropRegionOfInterest",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRegionOfInterestCropRegionOfInterestOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRelativeCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRelativeCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRelativeCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRemoveColor",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRemoveColorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRemoveColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationResize",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationResizeList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationResizeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRotate",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRotateList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRotateOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationScale",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationScaleList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationScaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationShear",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationShearList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationShearOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationTrim",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationTrimList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationTrimOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationUnsharpMask",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationUnsharpMaskList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationUnsharpMaskOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompositeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompound",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompoundList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCompoundOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsContrast",
    "DataAkamaiImagingPolicyImagePolicyTransformationsContrastList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsContrastOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFaceCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFaceCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFaceCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFeatureCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFeatureCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFeatureCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFill",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppend",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageBoxImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageBoxImageList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageBoxImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageBoxImageTransformation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageBoxImageTransformationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageCircleImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageCircleImageList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageCircleImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageCircleImageTransformation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageCircleImageTransformationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageTextImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageTextImageList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageTextImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageTextImageTransformation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageTextImageTransformationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageUrlImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageUrlImageList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageUrlImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageUrlImageTransformation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageUrlImageTransformationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAspectCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAspectCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAspectCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationBackgroundColor",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationBackgroundColorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationBackgroundColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationBlur",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationBlurList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationBlurOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationChromaKey",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationChromaKeyList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationChromaKeyOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationComposite",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageBoxImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageBoxImageList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageBoxImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageBoxImageTransformation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageBoxImageTransformationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageCircleImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageCircleImageList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageCircleImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageCircleImageTransformation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageCircleImageTransformationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageTextImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageTextImageList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageTextImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageTextImageTransformation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageTextImageTransformationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageUrlImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageUrlImageList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageUrlImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageUrlImageTransformation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageUrlImageTransformationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompound",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompoundList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompoundOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationContrast",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationContrastList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationContrastOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationFaceCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationFaceCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationFaceCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationFeatureCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationFeatureCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationFeatureCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationGoop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationGoopList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationGoopOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationGrayscale",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationGrayscaleList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationGrayscaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationHsl",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationHslList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationHslOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationHsv",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationHsvList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationHsvOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimension",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefault",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultAppend",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultAppendImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultAppendImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultAppendList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultAppendOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultAspectCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultAspectCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultAspectCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultBackgroundColor",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultBackgroundColorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultBackgroundColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultBlur",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultBlurList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultBlurOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultChromaKey",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultChromaKeyList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultChromaKeyOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultComposite",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultCompositeImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultCompositeImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultCompositeList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultCompositeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultCompound",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultCompoundList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultCompoundOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultCompoundTransformations",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultCompoundTransformationsList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultCompoundTransformationsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultContrast",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultContrastList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultContrastOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultFaceCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultFaceCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultFaceCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultFeatureCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultFeatureCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultFeatureCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultFitAndFill",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultFitAndFillFillTransformation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultFitAndFillFillTransformationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultFitAndFillList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultFitAndFillOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultGoop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultGoopList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultGoopOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultGrayscale",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultGrayscaleList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultGrayscaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultHsl",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultHslList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultHslOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultHsv",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultHsvList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultHsvOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfDimension",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfDimensionDefault",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfDimensionDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfDimensionEqual",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfDimensionEqualOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfDimensionGreaterThan",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfDimensionGreaterThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfDimensionLessThan",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfDimensionLessThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfDimensionList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfDimensionOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfOrientation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfOrientationDefault",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfOrientationDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfOrientationLandscape",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfOrientationLandscapeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfOrientationList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfOrientationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfOrientationPortrait",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfOrientationPortraitOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfOrientationSquare",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultIfOrientationSquareOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultImQuery",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultImQueryList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultImQueryOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultMaxColors",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultMaxColorsList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultMaxColorsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultMirror",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultMirrorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultMirrorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultMonoHue",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultMonoHueList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultMonoHueOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultOpacity",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultOpacityList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultOpacityOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultRegionOfInterestCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultRegionOfInterestCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultRegionOfInterestCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultRegionOfInterestCropRegionOfInterest",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultRegionOfInterestCropRegionOfInterestOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultRelativeCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultRelativeCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultRelativeCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultRemoveColor",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultRemoveColorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultRemoveColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultResize",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultResizeList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultResizeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultRotate",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultRotateList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultRotateOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultScale",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultScaleList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultScaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultShear",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultShearList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultShearOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultTrim",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultTrimList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultTrimOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultUnsharpMask",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultUnsharpMaskList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultUnsharpMaskOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqual",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualAppend",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualAppendImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualAppendImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualAppendList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualAppendOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualAspectCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualAspectCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualAspectCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualBackgroundColor",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualBackgroundColorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualBackgroundColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualBlur",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualBlurList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualBlurOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualChromaKey",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualChromaKeyList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualChromaKeyOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualComposite",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualCompositeImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualCompositeImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualCompositeList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualCompositeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualCompound",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualCompoundList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualCompoundOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualCompoundTransformations",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualCompoundTransformationsList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualCompoundTransformationsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualContrast",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualContrastList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualContrastOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualFaceCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualFaceCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualFaceCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualFeatureCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualFeatureCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualFeatureCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualFitAndFill",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualFitAndFillFillTransformation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualFitAndFillFillTransformationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualFitAndFillList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualFitAndFillOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualGoop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualGoopList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualGoopOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualGrayscale",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualGrayscaleList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualGrayscaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualHsl",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualHslList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualHslOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualHsv",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualHsvList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualHsvOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfDimension",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfDimensionDefault",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfDimensionDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfDimensionEqual",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfDimensionEqualOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfDimensionGreaterThan",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfDimensionGreaterThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfDimensionLessThan",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfDimensionLessThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfDimensionList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfDimensionOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfOrientation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfOrientationDefault",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfOrientationDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfOrientationLandscape",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfOrientationLandscapeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfOrientationList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfOrientationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfOrientationPortrait",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfOrientationPortraitOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfOrientationSquare",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualIfOrientationSquareOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualImQuery",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualImQueryList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualImQueryOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualMaxColors",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualMaxColorsList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualMaxColorsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualMirror",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualMirrorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualMirrorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualMonoHue",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualMonoHueList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualMonoHueOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualOpacity",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualOpacityList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualOpacityOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualRegionOfInterestCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualRegionOfInterestCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualRegionOfInterestCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualRegionOfInterestCropRegionOfInterest",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualRegionOfInterestCropRegionOfInterestOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualRelativeCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualRelativeCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualRelativeCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualRemoveColor",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualRemoveColorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualRemoveColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualResize",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualResizeList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualResizeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualRotate",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualRotateList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualRotateOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualScale",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualScaleList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualScaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualShear",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualShearList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualShearOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualTrim",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualTrimList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualTrimOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualUnsharpMask",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualUnsharpMaskList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionEqualUnsharpMaskOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThan",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanAppend",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanAppendImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanAppendImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanAppendList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanAppendOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanAspectCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanAspectCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanAspectCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanBackgroundColor",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanBackgroundColorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanBackgroundColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanBlur",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanBlurList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanBlurOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanChromaKey",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanChromaKeyList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanChromaKeyOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanComposite",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanCompositeImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanCompositeImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanCompositeList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanCompositeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanCompound",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanCompoundList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanCompoundOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanCompoundTransformations",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanCompoundTransformationsList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanCompoundTransformationsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanContrast",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanContrastList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanContrastOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanFaceCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanFaceCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanFaceCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanFeatureCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanFeatureCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanFeatureCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanFitAndFill",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanFitAndFillFillTransformation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanFitAndFillFillTransformationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanFitAndFillList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanFitAndFillOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanGoop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanGoopList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanGoopOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanGrayscale",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanGrayscaleList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanGrayscaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanHsl",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanHslList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanHslOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanHsv",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanHsvList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanHsvOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfDimension",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfDimensionDefault",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfDimensionDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfDimensionEqual",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfDimensionEqualOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfDimensionGreaterThan",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfDimensionGreaterThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfDimensionLessThan",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfDimensionLessThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfDimensionList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfDimensionOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfOrientation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfOrientationDefault",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfOrientationDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfOrientationLandscape",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfOrientationLandscapeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfOrientationList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfOrientationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfOrientationPortrait",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfOrientationPortraitOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfOrientationSquare",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanIfOrientationSquareOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanImQuery",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanImQueryList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanImQueryOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanMaxColors",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanMaxColorsList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanMaxColorsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanMirror",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanMirrorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanMirrorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanMonoHue",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanMonoHueList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanMonoHueOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanOpacity",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanOpacityList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanOpacityOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanRegionOfInterestCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanRegionOfInterestCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanRegionOfInterestCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanRegionOfInterestCropRegionOfInterest",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanRelativeCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanRelativeCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanRelativeCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanRemoveColor",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanRemoveColorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanRemoveColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanResize",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanResizeList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanResizeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanRotate",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanRotateList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanRotateOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanScale",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanScaleList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanScaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanShear",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanShearList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanShearOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanTrim",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanTrimList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanTrimOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanUnsharpMask",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanUnsharpMaskList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionGreaterThanUnsharpMaskOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThan",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanAppend",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanAppendImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanAppendImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanAppendList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanAppendOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanAspectCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanAspectCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanAspectCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanBackgroundColor",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanBackgroundColorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanBackgroundColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanBlur",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanBlurList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanBlurOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanChromaKey",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanChromaKeyList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanChromaKeyOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanComposite",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanCompositeImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanCompositeImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanCompositeList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanCompositeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanCompound",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanCompoundList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanCompoundOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanCompoundTransformations",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanCompoundTransformationsList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanCompoundTransformationsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanContrast",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanContrastList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanContrastOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanFaceCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanFaceCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanFaceCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanFeatureCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanFeatureCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanFeatureCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanFitAndFill",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanFitAndFillFillTransformation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanFitAndFillFillTransformationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanFitAndFillList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanFitAndFillOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanGoop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanGoopList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanGoopOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanGrayscale",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanGrayscaleList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanGrayscaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanHsl",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanHslList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanHslOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanHsv",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanHsvList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanHsvOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfDimension",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfDimensionDefault",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfDimensionDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfDimensionEqual",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfDimensionEqualOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfDimensionGreaterThan",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfDimensionGreaterThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfDimensionLessThan",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfDimensionLessThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfDimensionList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfDimensionOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfOrientation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfOrientationDefault",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfOrientationDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfOrientationLandscape",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfOrientationLandscapeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfOrientationList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfOrientationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfOrientationPortrait",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfOrientationPortraitOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfOrientationSquare",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanIfOrientationSquareOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanImQuery",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanImQueryList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanImQueryOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanMaxColors",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanMaxColorsList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanMaxColorsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanMirror",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanMirrorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanMirrorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanMonoHue",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanMonoHueList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanMonoHueOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanOpacity",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanOpacityList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanOpacityOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanRegionOfInterestCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanRegionOfInterestCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanRegionOfInterestCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanRegionOfInterestCropRegionOfInterest",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanRegionOfInterestCropRegionOfInterestOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanRelativeCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanRelativeCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanRelativeCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanRemoveColor",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanRemoveColorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanRemoveColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanResize",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanResizeList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanResizeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanRotate",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanRotateList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanRotateOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanScale",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanScaleList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanScaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanShear",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanShearList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanShearOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanTrim",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanTrimList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanTrimOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanUnsharpMask",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanUnsharpMaskList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionLessThanUnsharpMaskOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefault",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultAppend",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultAppendImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultAppendImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultAppendList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultAppendOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultAspectCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultAspectCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultAspectCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultBackgroundColor",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultBackgroundColorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultBackgroundColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultBlur",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultBlurList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultBlurOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultChromaKey",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultChromaKeyList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultChromaKeyOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultComposite",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultCompositeImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultCompositeImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultCompositeList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultCompositeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultCompound",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultCompoundList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultCompoundOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultCompoundTransformations",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultCompoundTransformationsList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultCompoundTransformationsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultContrast",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultContrastList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultContrastOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultFaceCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultFaceCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultFaceCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultFeatureCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultFeatureCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultFeatureCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultFitAndFill",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultFitAndFillFillTransformation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultFitAndFillFillTransformationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultFitAndFillList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultFitAndFillOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultGoop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultGoopList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultGoopOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultGrayscale",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultGrayscaleList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultGrayscaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultHsl",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultHslList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultHslOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultHsv",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultHsvList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultHsvOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfDimension",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfDimensionDefault",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfDimensionDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfDimensionEqual",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfDimensionEqualOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfDimensionGreaterThan",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfDimensionGreaterThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfDimensionLessThan",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfDimensionLessThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfDimensionList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfDimensionOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfOrientation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfOrientationDefault",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfOrientationDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfOrientationLandscape",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfOrientationLandscapeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfOrientationList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfOrientationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfOrientationPortrait",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfOrientationPortraitOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfOrientationSquare",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultIfOrientationSquareOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultImQuery",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultImQueryList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultImQueryOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultMaxColors",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultMaxColorsList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultMaxColorsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultMirror",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultMirrorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultMirrorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultMonoHue",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultMonoHueList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultMonoHueOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultOpacity",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultOpacityList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultOpacityOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultRegionOfInterestCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultRegionOfInterestCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultRegionOfInterestCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultRegionOfInterestCropRegionOfInterest",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultRegionOfInterestCropRegionOfInterestOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultRelativeCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultRelativeCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultRelativeCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultRemoveColor",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultRemoveColorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultRemoveColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultResize",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultResizeList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultResizeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultRotate",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultRotateList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultRotateOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultScale",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultScaleList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultScaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultShear",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultShearList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultShearOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultTrim",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultTrimList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultTrimOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultUnsharpMask",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultUnsharpMaskList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationDefaultUnsharpMaskOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscape",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeAppend",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeAppendImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeAppendImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeAppendList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeAppendOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeAspectCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeAspectCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeAspectCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeBackgroundColor",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeBackgroundColorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeBackgroundColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeBlur",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeBlurList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeBlurOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeChromaKey",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeChromaKeyList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeChromaKeyOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeComposite",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCompositeImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCompositeImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCompositeList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCompositeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCompound",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCompoundList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCompoundOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCompoundTransformations",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCompoundTransformationsList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCompoundTransformationsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeContrast",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeContrastList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeContrastOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeFaceCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeFaceCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeFaceCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeFeatureCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeFeatureCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeFeatureCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeFitAndFill",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeFitAndFillFillTransformation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeFitAndFillFillTransformationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeFitAndFillList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeFitAndFillOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeGoop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeGoopList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeGoopOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeGrayscale",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeGrayscaleList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeGrayscaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeHsl",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeHslList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeHslOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeHsv",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeHsvList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeHsvOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimension",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimensionDefault",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimensionDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimensionEqual",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimensionEqualOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimensionGreaterThan",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimensionGreaterThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimensionLessThan",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimensionLessThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimensionList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimensionOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientationDefault",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientationDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientationLandscape",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientationLandscapeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientationList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientationPortrait",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientationPortraitOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientationSquare",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientationSquareOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeImQuery",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeImQueryList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeImQueryOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeMaxColors",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeMaxColorsList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeMaxColorsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeMirror",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeMirrorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeMirrorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeMonoHue",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeMonoHueList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeMonoHueOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeOpacity",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeOpacityList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeOpacityOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRegionOfInterestCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRegionOfInterestCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRegionOfInterestCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRegionOfInterestCropRegionOfInterest",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRegionOfInterestCropRegionOfInterestOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRelativeCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRelativeCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRelativeCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRemoveColor",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRemoveColorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRemoveColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeResize",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeResizeList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeResizeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRotate",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRotateList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRotateOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeScale",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeScaleList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeScaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeShear",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeShearList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeShearOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeTrim",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeTrimList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeTrimOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeUnsharpMask",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeUnsharpMaskList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeUnsharpMaskOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortrait",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitAppend",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitAppendImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitAppendImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitAppendList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitAppendOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitAspectCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitAspectCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitAspectCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitBackgroundColor",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitBackgroundColorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitBackgroundColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitBlur",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitBlurList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitBlurOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitChromaKey",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitChromaKeyList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitChromaKeyOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitComposite",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCompositeImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCompositeImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCompositeList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCompositeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCompound",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCompoundList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCompoundOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCompoundTransformations",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCompoundTransformationsList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCompoundTransformationsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitContrast",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitContrastList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitContrastOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitFaceCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitFaceCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitFaceCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitFeatureCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitFeatureCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitFeatureCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitFitAndFill",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitFitAndFillFillTransformation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitFitAndFillFillTransformationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitFitAndFillList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitFitAndFillOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitGoop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitGoopList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitGoopOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitGrayscale",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitGrayscaleList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitGrayscaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitHsl",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitHslList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitHslOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitHsv",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitHsvList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitHsvOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimension",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimensionDefault",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimensionDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimensionEqual",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimensionEqualOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimensionGreaterThan",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimensionGreaterThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimensionLessThan",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimensionLessThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimensionList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimensionOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientationDefault",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientationDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientationLandscape",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientationLandscapeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientationList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientationPortrait",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientationPortraitOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientationSquare",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientationSquareOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitImQuery",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitImQueryList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitImQueryOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitMaxColors",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitMaxColorsList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitMaxColorsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitMirror",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitMirrorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitMirrorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitMonoHue",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitMonoHueList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitMonoHueOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitOpacity",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitOpacityList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitOpacityOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRegionOfInterestCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRegionOfInterestCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRegionOfInterestCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRegionOfInterestCropRegionOfInterest",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRegionOfInterestCropRegionOfInterestOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRelativeCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRelativeCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRelativeCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRemoveColor",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRemoveColorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRemoveColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitResize",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitResizeList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitResizeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRotate",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRotateList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRotateOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitScale",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitScaleList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitScaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitShear",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitShearList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitShearOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitTrim",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitTrimList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitTrimOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitUnsharpMask",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitUnsharpMaskList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitUnsharpMaskOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquare",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareAppend",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareAppendImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareAppendImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareAppendList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareAppendOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareAspectCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareAspectCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareAspectCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareBackgroundColor",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareBackgroundColorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareBackgroundColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareBlur",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareBlurList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareBlurOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareChromaKey",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareChromaKeyList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareChromaKeyOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareComposite",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareCompositeImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareCompositeImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareCompositeList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareCompositeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareCompound",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareCompoundList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareCompoundOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareCompoundTransformations",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareCompoundTransformationsList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareCompoundTransformationsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareContrast",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareContrastList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareContrastOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareFaceCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareFaceCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareFaceCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareFeatureCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareFeatureCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareFeatureCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareFitAndFill",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareFitAndFillFillTransformation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareFitAndFillFillTransformationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareFitAndFillList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareFitAndFillOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareGoop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareGoopList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareGoopOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareGrayscale",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareGrayscaleList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareGrayscaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareHsl",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareHslList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareHslOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareHsv",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareHsvList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareHsvOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfDimension",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfDimensionDefault",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfDimensionDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfDimensionEqual",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfDimensionEqualOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfDimensionGreaterThan",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfDimensionGreaterThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfDimensionLessThan",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfDimensionLessThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfDimensionList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfDimensionOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfOrientation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfOrientationDefault",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfOrientationDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfOrientationLandscape",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfOrientationLandscapeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfOrientationList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfOrientationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfOrientationPortrait",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfOrientationPortraitOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfOrientationSquare",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareIfOrientationSquareOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareImQuery",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareImQueryList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareImQueryOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareMaxColors",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareMaxColorsList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareMaxColorsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareMirror",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareMirrorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareMirrorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareMonoHue",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareMonoHueList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareMonoHueOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareOpacity",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareOpacityList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareOpacityOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareRegionOfInterestCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareRegionOfInterestCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareRegionOfInterestCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareRegionOfInterestCropRegionOfInterest",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareRegionOfInterestCropRegionOfInterestOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareRelativeCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareRelativeCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareRelativeCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareRemoveColor",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareRemoveColorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareRemoveColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareResize",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareResizeList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareResizeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareRotate",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareRotateList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareRotateOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareScale",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareScaleList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareScaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareShear",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareShearList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareShearOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareTrim",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareTrimList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareTrimOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareUnsharpMask",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareUnsharpMaskList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareUnsharpMaskOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationImQuery",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationImQueryList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationImQueryOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationMaxColors",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationMaxColorsList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationMaxColorsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationMirror",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationMirrorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationMirrorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationMonoHue",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationMonoHueList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationMonoHueOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationOpacity",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationOpacityList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationOpacityOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterest",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestCircleShape",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestCircleShapeCenter",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestCircleShapeCenterOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestCircleShapeList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestCircleShapeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestPointShape",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestPointShapeList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestPointShapeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestPolygonShape",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestPolygonShapeList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestPolygonShapeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestPolygonShapePoints",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestPolygonShapePointsList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestPolygonShapePointsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestRectangleShape",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestRectangleShapeAnchor",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestRectangleShapeAnchorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestRectangleShapeList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestRectangleShapeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestUnionShape",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestUnionShapeList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestUnionShapeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestUnionShapeShapes",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestUnionShapeShapesList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestUnionShapeShapesOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRelativeCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRelativeCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRelativeCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRemoveColor",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRemoveColorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRemoveColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationResize",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationResizeList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationResizeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRotate",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRotateList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationRotateOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationScale",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationScaleList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationScaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationShear",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationShearList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationShearOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationTrim",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationTrimList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationTrimOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationUnsharpMask",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationUnsharpMaskList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationUnsharpMaskOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsGoop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsGoopList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsGoopOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsGrayscale",
    "DataAkamaiImagingPolicyImagePolicyTransformationsGrayscaleList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsGrayscaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsHsl",
    "DataAkamaiImagingPolicyImagePolicyTransformationsHslList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsHslOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsHsv",
    "DataAkamaiImagingPolicyImagePolicyTransformationsHsvList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsHsvOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimension",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefault",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppend",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageBoxImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageBoxImageList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageBoxImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageBoxImageTransformation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageBoxImageTransformationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageCircleImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageCircleImageList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageCircleImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageCircleImageTransformation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageCircleImageTransformationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageTextImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageTextImageList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageTextImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageTextImageTransformation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageTextImageTransformationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageUrlImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageUrlImageList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageUrlImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageUrlImageTransformation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendImageUrlImageTransformationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAppendOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAspectCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAspectCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultAspectCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultBackgroundColor",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultBackgroundColorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultBackgroundColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultBlur",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultBlurList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultBlurOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultChromaKey",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultChromaKeyList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultChromaKeyOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultComposite",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageBoxImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageBoxImageList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageBoxImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageBoxImageTransformation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageBoxImageTransformationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageCircleImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageCircleImageList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageCircleImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageCircleImageTransformation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageCircleImageTransformationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageTextImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageTextImageList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageTextImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageTextImageTransformation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageTextImageTransformationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageUrlImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageUrlImageList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageUrlImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageUrlImageTransformation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeImageUrlImageTransformationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompositeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompound",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompoundList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCompoundOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultContrast",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultContrastList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultContrastOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFaceCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFaceCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFaceCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFeatureCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFeatureCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFeatureCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFill",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationAppend",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationAppendImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationAppendImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationAppendList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationAppendOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationAspectCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationAspectCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationAspectCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationBackgroundColor",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationBackgroundColorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationBackgroundColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationBlur",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationBlurList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationBlurOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationChromaKey",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationChromaKeyList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationChromaKeyOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationComposite",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationCompositeImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationCompositeImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationCompositeList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationCompositeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationCompound",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationCompoundList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationCompoundOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationCompoundTransformations",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationCompoundTransformationsList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationCompoundTransformationsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationContrast",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationContrastList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationContrastOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationFaceCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationFaceCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationFaceCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationFeatureCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationFeatureCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationFeatureCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationFitAndFill",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationFitAndFillFillTransformation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationFitAndFillFillTransformationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationFitAndFillList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationFitAndFillOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationGoop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationGoopList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationGoopOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationGrayscale",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationGrayscaleList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationGrayscaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationHsl",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationHslList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationHslOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationHsv",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationHsvList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationHsvOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfDimension",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfDimensionDefault",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfDimensionDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfDimensionEqual",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfDimensionEqualOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfDimensionGreaterThan",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfDimensionGreaterThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfDimensionLessThan",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfDimensionLessThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfDimensionList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfDimensionOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfOrientation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfOrientationDefault",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfOrientationDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfOrientationLandscape",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfOrientationLandscapeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfOrientationList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfOrientationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfOrientationPortrait",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfOrientationPortraitOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfOrientationSquare",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationIfOrientationSquareOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationImQuery",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationImQueryList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationImQueryOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationMaxColors",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationMaxColorsList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationMaxColorsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationMirror",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationMirrorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationMirrorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationMonoHue",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationMonoHueList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationMonoHueOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationOpacity",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationOpacityList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationOpacityOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationRegionOfInterestCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationRegionOfInterestCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationRegionOfInterestCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationRegionOfInterestCropRegionOfInterest",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationRelativeCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationRelativeCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationRelativeCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationRemoveColor",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationRemoveColorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationRemoveColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationResize",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationResizeList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationResizeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationRotate",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationRotateList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationRotateOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationScale",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationScaleList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationScaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationShear",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationShearList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationShearOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationTrim",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationTrimList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationTrimOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationUnsharpMask",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationUnsharpMaskList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillFillTransformationUnsharpMaskOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultFitAndFillOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultGoop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultGoopList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultGoopOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultGrayscale",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultGrayscaleList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultGrayscaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultHsl",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultHslList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultHslOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultHsv",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultHsvList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultHsvOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscape",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeAppend",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeAppendImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeAppendImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeAppendList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeAppendOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeAspectCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeAspectCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeAspectCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeBackgroundColor",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeBackgroundColorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeBackgroundColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeBlur",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeBlurList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeBlurOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeChromaKey",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeChromaKeyList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeChromaKeyOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeComposite",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeCompositeImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeCompositeImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeCompositeList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeCompositeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeCompound",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeCompoundList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeCompoundOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeCompoundTransformations",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeCompoundTransformationsList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeCompoundTransformationsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeContrast",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeContrastList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeContrastOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeFaceCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeFaceCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeFaceCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeFeatureCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeFeatureCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeFeatureCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeFitAndFill",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeFitAndFillFillTransformation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeFitAndFillFillTransformationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeFitAndFillList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeFitAndFillOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeGoop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeGoopList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeGoopOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeGrayscale",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeGrayscaleList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeGrayscaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeHsl",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeHslList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeHslOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeHsv",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeHsvList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeHsvOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimension",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionDefault",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionEqual",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionEqualOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionGreaterThan",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionGreaterThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionLessThan",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionLessThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationDefault",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationLandscape",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationLandscapeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationPortrait",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationPortraitOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationSquare",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationSquareOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeImQuery",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeImQueryList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeImQueryOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeMaxColors",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeMaxColorsList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeMaxColorsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeMirror",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeMirrorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeMirrorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeMonoHue",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeMonoHueList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeMonoHueOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeOpacity",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeOpacityList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeOpacityOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeRegionOfInterestCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeRegionOfInterestCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeRegionOfInterestCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeRegionOfInterestCropRegionOfInterest",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeRegionOfInterestCropRegionOfInterestOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeRelativeCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeRelativeCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeRelativeCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeRemoveColor",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeRemoveColorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeRemoveColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeResize",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeResizeList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeResizeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeRotate",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeRotateList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeRotateOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeScale",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeScaleList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeScaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeShear",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeShearList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeShearOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeTrim",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeTrimList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeTrimOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeUnsharpMask",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeUnsharpMaskList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationLandscapeUnsharpMaskOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortrait",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitAppend",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitAppendImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitAppendImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitAppendList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitAppendOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitAspectCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitAspectCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitAspectCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitBackgroundColor",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitBackgroundColorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitBackgroundColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitBlur",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitBlurList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitBlurOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitChromaKey",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitChromaKeyList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitChromaKeyOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitComposite",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitCompositeImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitCompositeImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitCompositeList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitCompositeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitCompound",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitCompoundList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitCompoundOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitCompoundTransformations",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitCompoundTransformationsList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitCompoundTransformationsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitContrast",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitContrastList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitContrastOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitFaceCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitFaceCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitFaceCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitFeatureCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitFeatureCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitFeatureCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitFitAndFill",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitFitAndFillFillTransformation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitFitAndFillFillTransformationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitFitAndFillList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitFitAndFillOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitGoop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitGoopList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitGoopOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitGrayscale",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitGrayscaleList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitGrayscaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitHsl",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitHslList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitHslOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitHsv",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitHsvList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitHsvOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfDimension",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionDefault",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionEqual",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionEqualOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionGreaterThan",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionGreaterThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionLessThan",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionLessThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationDefault",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationLandscape",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationLandscapeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationPortrait",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationPortraitOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationSquare",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationSquareOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitImQuery",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitImQueryList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitImQueryOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitMaxColors",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitMaxColorsList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitMaxColorsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitMirror",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitMirrorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitMirrorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitMonoHue",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitMonoHueList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitMonoHueOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitOpacity",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitOpacityList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitOpacityOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitRegionOfInterestCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitRegionOfInterestCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitRegionOfInterestCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitRegionOfInterestCropRegionOfInterest",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitRegionOfInterestCropRegionOfInterestOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitRelativeCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitRelativeCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitRelativeCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitRemoveColor",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitRemoveColorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitRemoveColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitResize",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitResizeList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitResizeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitRotate",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitRotateList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitRotateOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitScale",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitScaleList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitScaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitShear",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitShearList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitShearOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitTrim",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitTrimList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitTrimOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitUnsharpMask",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitUnsharpMaskList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationPortraitUnsharpMaskOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquare",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareAppend",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareAppendImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareAppendImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareAppendList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareAppendOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareAspectCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareAspectCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareAspectCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareBackgroundColor",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareBackgroundColorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareBackgroundColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareBlur",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareBlurList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareBlurOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareChromaKey",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareChromaKeyList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareChromaKeyOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareComposite",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareCompositeImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareCompositeImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareCompositeList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareCompositeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareCompound",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareCompoundList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareCompoundOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareCompoundTransformations",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareCompoundTransformationsList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareCompoundTransformationsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareContrast",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareContrastList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareContrastOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareFaceCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareFaceCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareFaceCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareFeatureCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareFeatureCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareFeatureCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareFitAndFill",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareFitAndFillFillTransformation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareFitAndFillFillTransformationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareFitAndFillList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareFitAndFillOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareGoop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareGoopList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareGoopOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareGrayscale",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareGrayscaleList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareGrayscaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareHsl",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareHslList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareHslOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareHsv",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareHsvList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareHsvOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfDimension",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionDefault",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionEqual",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionEqualOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionGreaterThan",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionGreaterThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionLessThan",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionLessThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfOrientation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationDefault",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationLandscape",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationLandscapeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationPortrait",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationPortraitOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationSquare",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationSquareOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareImQuery",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareImQueryList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareImQueryOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareMaxColors",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareMaxColorsList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareMaxColorsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareMirror",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareMirrorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareMirrorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareMonoHue",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareMonoHueList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareMonoHueOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareOpacity",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareOpacityList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareOpacityOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareRegionOfInterestCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareRegionOfInterestCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareRegionOfInterestCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareRegionOfInterestCropRegionOfInterest",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareRegionOfInterestCropRegionOfInterestOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareRelativeCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareRelativeCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareRelativeCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareRemoveColor",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareRemoveColorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareRemoveColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareResize",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareResizeList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareResizeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareRotate",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareRotateList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareRotateOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareScale",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareScaleList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareScaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareShear",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareShearList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareShearOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareTrim",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareTrimList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareTrimOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareUnsharpMask",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareUnsharpMaskList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultIfOrientationSquareUnsharpMaskOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultImQuery",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultImQueryList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultImQueryOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultMaxColors",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultMaxColorsList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultMaxColorsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultMirror",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultMirrorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultMirrorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultMonoHue",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultMonoHueList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultMonoHueOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultOpacity",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultOpacityList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultOpacityOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterest",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestCircleShape",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestCircleShapeCenter",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestCircleShapeCenterOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestCircleShapeList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestCircleShapeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestPointShape",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestPointShapeList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestPointShapeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestPolygonShape",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestPolygonShapeList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestPolygonShapeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestPolygonShapePoints",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestPolygonShapePointsList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestPolygonShapePointsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestRectangleShape",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestRectangleShapeAnchor",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestRectangleShapeAnchorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestRectangleShapeList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestRectangleShapeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestUnionShape",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestUnionShapeList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestUnionShapeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestUnionShapeShapes",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestUnionShapeShapesList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRegionOfInterestCropRegionOfInterestUnionShapeShapesOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRelativeCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRelativeCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRelativeCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRemoveColor",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRemoveColorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRemoveColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultResize",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultResizeList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultResizeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRotate",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRotateList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultRotateOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultScale",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultScaleList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultScaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultShear",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultShearList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultShearOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultTrim",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultTrimList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultTrimOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultUnsharpMask",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultUnsharpMaskList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionDefaultUnsharpMaskOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqual",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppend",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageBoxImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageBoxImageList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageBoxImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageBoxImageTransformation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageBoxImageTransformationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageCircleImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageCircleImageList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageCircleImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageCircleImageTransformation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageCircleImageTransformationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageTextImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageTextImageList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageTextImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageTextImageTransformation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageTextImageTransformationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageUrlImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageUrlImageList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageUrlImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageUrlImageTransformation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendImageUrlImageTransformationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAppendOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAspectCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAspectCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualAspectCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualBackgroundColor",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualBackgroundColorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualBackgroundColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualBlur",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualBlurList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualBlurOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualChromaKey",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualChromaKeyList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualChromaKeyOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualComposite",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageBoxImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageBoxImageList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageBoxImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageBoxImageTransformation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageBoxImageTransformationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageCircleImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageCircleImageList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageCircleImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageCircleImageTransformation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageCircleImageTransformationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageTextImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageTextImageList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageTextImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageTextImageTransformation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageTextImageTransformationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageUrlImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageUrlImageList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageUrlImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageUrlImageTransformation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeImageUrlImageTransformationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompositeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompound",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompoundList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCompoundOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualContrast",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualContrastList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualContrastOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFaceCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFaceCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFaceCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFeatureCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFeatureCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFeatureCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFill",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationAppend",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationAppendImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationAppendImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationAppendList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationAppendOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationAspectCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationAspectCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationAspectCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationBackgroundColor",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationBackgroundColorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationBackgroundColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationBlur",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationBlurList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationBlurOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationChromaKey",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationChromaKeyList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationChromaKeyOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationComposite",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationCompositeImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationCompositeImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationCompositeList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationCompositeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationCompound",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationCompoundList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationCompoundOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationCompoundTransformations",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationCompoundTransformationsList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationCompoundTransformationsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationContrast",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationContrastList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationContrastOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationFaceCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationFaceCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationFaceCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationFeatureCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationFeatureCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationFeatureCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationFitAndFill",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationFitAndFillFillTransformation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationFitAndFillFillTransformationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationFitAndFillList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationFitAndFillOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationGoop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationGoopList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationGoopOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationGrayscale",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationGrayscaleList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationGrayscaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationHsl",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationHslList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationHslOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationHsv",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationHsvList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationHsvOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfDimension",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfDimensionDefault",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfDimensionDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfDimensionEqual",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfDimensionEqualOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfDimensionGreaterThan",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfDimensionGreaterThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfDimensionLessThan",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfDimensionLessThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfDimensionList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfDimensionOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfOrientation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfOrientationDefault",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfOrientationDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfOrientationLandscape",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfOrientationLandscapeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfOrientationList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfOrientationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfOrientationPortrait",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfOrientationPortraitOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfOrientationSquare",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationIfOrientationSquareOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationImQuery",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationImQueryList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationImQueryOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationMaxColors",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationMaxColorsList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationMaxColorsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationMirror",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationMirrorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationMirrorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationMonoHue",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationMonoHueList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationMonoHueOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationOpacity",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationOpacityList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationOpacityOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationRegionOfInterestCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationRegionOfInterestCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationRegionOfInterestCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationRegionOfInterestCropRegionOfInterest",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationRelativeCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationRelativeCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationRelativeCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationRemoveColor",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationRemoveColorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationRemoveColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationResize",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationResizeList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationResizeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationRotate",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationRotateList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationRotateOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationScale",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationScaleList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationScaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationShear",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationShearList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationShearOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationTrim",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationTrimList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationTrimOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationUnsharpMask",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationUnsharpMaskList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillFillTransformationUnsharpMaskOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualFitAndFillOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualGoop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualGoopList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualGoopOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualGrayscale",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualGrayscaleList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualGrayscaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualHsl",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualHslList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualHslOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualHsv",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualHsvList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualHsvOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefault",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultAppend",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultAppendImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultAppendImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultAppendList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultAppendOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultAspectCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultAspectCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultAspectCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultBackgroundColor",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultBackgroundColorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultBackgroundColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultBlur",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultBlurList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultBlurOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultChromaKey",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultChromaKeyList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultChromaKeyOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultComposite",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultCompositeImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultCompositeImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultCompositeList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultCompositeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultCompound",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultCompoundList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultCompoundOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultCompoundTransformations",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultCompoundTransformationsList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultCompoundTransformationsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultContrast",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultContrastList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultContrastOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultFaceCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultFaceCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultFaceCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultFeatureCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultFeatureCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultFeatureCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultFitAndFill",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultFitAndFillFillTransformation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultFitAndFillFillTransformationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultFitAndFillList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultFitAndFillOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultGoop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultGoopList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultGoopOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultGrayscale",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultGrayscaleList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultGrayscaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultHsl",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultHslList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultHslOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultHsv",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultHsvList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultHsvOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfDimension",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionDefault",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionEqual",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionEqualOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionGreaterThan",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionGreaterThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionLessThan",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionLessThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfOrientation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationDefault",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationLandscape",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationLandscapeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationPortrait",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationPortraitOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationSquare",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationSquareOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultImQuery",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultImQueryList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultImQueryOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultMaxColors",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultMaxColorsList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultMaxColorsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultMirror",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultMirrorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultMirrorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultMonoHue",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultMonoHueList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultMonoHueOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultOpacity",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultOpacityList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultOpacityOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultRegionOfInterestCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultRegionOfInterestCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultRegionOfInterestCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultRegionOfInterestCropRegionOfInterest",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultRegionOfInterestCropRegionOfInterestOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultRelativeCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultRelativeCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultRelativeCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultRemoveColor",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultRemoveColorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultRemoveColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultResize",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultResizeList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultResizeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultRotate",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultRotateList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultRotateOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultScale",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultScaleList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultScaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultShear",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultShearList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultShearOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultTrim",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultTrimList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultTrimOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultUnsharpMask",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultUnsharpMaskList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationDefaultUnsharpMaskOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscape",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeAppend",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeAppendImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeAppendImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeAppendList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeAppendOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeAspectCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeAspectCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeAspectCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeBackgroundColor",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeBackgroundColorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeBackgroundColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeBlur",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeBlurList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeBlurOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeChromaKey",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeChromaKeyList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeChromaKeyOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeComposite",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeCompositeImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeCompositeImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeCompositeList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeCompositeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeCompound",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeCompoundList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeCompoundOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeCompoundTransformations",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeCompoundTransformationsList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeCompoundTransformationsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeContrast",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeContrastList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeContrastOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeFaceCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeFaceCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeFaceCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeFeatureCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeFeatureCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeFeatureCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeFitAndFill",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeFitAndFillFillTransformation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeFitAndFillFillTransformationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeFitAndFillList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeFitAndFillOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeGoop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeGoopList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeGoopOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeGrayscale",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeGrayscaleList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeGrayscaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeHsl",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeHslList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeHslOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeHsv",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeHsvList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeHsvOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfDimension",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionDefault",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionEqual",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionEqualOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionGreaterThan",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionGreaterThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionLessThan",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionLessThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationDefault",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationLandscape",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationLandscapeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationPortrait",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationPortraitOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationSquare",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationSquareOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeImQuery",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeImQueryList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeImQueryOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeMaxColors",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeMaxColorsList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeMaxColorsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeMirror",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeMirrorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeMirrorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeMonoHue",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeMonoHueList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeMonoHueOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeOpacity",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeOpacityList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeOpacityOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeRegionOfInterestCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeRegionOfInterestCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeRegionOfInterestCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeRegionOfInterestCropRegionOfInterest",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeRegionOfInterestCropRegionOfInterestOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeRelativeCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeRelativeCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeRelativeCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeRemoveColor",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeRemoveColorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeRemoveColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeResize",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeResizeList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeResizeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeRotate",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeRotateList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeRotateOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeScale",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeScaleList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeScaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeShear",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeShearList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeShearOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeTrim",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeTrimList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeTrimOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeUnsharpMask",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeUnsharpMaskList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationLandscapeUnsharpMaskOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortrait",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitAppend",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitAppendImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitAppendImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitAppendList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitAppendOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitAspectCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitAspectCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitAspectCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitBackgroundColor",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitBackgroundColorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitBackgroundColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitBlur",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitBlurList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitBlurOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitChromaKey",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitChromaKeyList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitChromaKeyOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitComposite",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitCompositeImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitCompositeImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitCompositeList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitCompositeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitCompound",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitCompoundList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitCompoundOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitCompoundTransformations",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitCompoundTransformationsList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitCompoundTransformationsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitContrast",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitContrastList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitContrastOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitFaceCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitFaceCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitFaceCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitFeatureCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitFeatureCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitFeatureCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitFitAndFill",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitFitAndFillFillTransformation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitFitAndFillFillTransformationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitFitAndFillList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitFitAndFillOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitGoop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitGoopList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitGoopOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitGrayscale",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitGrayscaleList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitGrayscaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitHsl",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitHslList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitHslOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitHsv",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitHsvList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitHsvOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfDimension",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionDefault",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionEqual",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionEqualOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionGreaterThan",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionGreaterThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionLessThan",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionLessThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfOrientation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationDefault",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationLandscape",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationLandscapeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationPortrait",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationPortraitOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationSquare",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationSquareOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitImQuery",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitImQueryList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitImQueryOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitMaxColors",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitMaxColorsList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitMaxColorsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitMirror",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitMirrorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitMirrorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitMonoHue",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitMonoHueList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitMonoHueOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitOpacity",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitOpacityList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitOpacityOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitRegionOfInterestCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitRegionOfInterestCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitRegionOfInterestCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitRegionOfInterestCropRegionOfInterest",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitRegionOfInterestCropRegionOfInterestOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitRelativeCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitRelativeCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitRelativeCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitRemoveColor",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitRemoveColorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitRemoveColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitResize",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitResizeList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitResizeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitRotate",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitRotateList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitRotateOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitScale",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitScaleList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitScaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitShear",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitShearList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitShearOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitTrim",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitTrimList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitTrimOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitUnsharpMask",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitUnsharpMaskList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationPortraitUnsharpMaskOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquare",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareAppend",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareAppendImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareAppendImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareAppendList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareAppendOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareAspectCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareAspectCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareAspectCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareBackgroundColor",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareBackgroundColorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareBackgroundColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareBlur",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareBlurList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareBlurOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareChromaKey",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareChromaKeyList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareChromaKeyOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareComposite",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareCompositeImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareCompositeImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareCompositeList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareCompositeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareCompound",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareCompoundList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareCompoundOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareCompoundTransformations",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareCompoundTransformationsList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareCompoundTransformationsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareContrast",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareContrastList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareContrastOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareFaceCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareFaceCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareFaceCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareFeatureCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareFeatureCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareFeatureCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareFitAndFill",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareFitAndFillFillTransformation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareFitAndFillFillTransformationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareFitAndFillList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareFitAndFillOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareGoop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareGoopList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareGoopOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareGrayscale",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareGrayscaleList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareGrayscaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareHsl",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareHslList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareHslOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareHsv",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareHsvList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareHsvOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfDimension",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfDimensionDefault",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfDimensionDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfDimensionEqual",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfDimensionEqualOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfDimensionGreaterThan",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfDimensionGreaterThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfDimensionLessThan",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfDimensionLessThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfDimensionList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfDimensionOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfOrientation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfOrientationDefault",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfOrientationDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfOrientationLandscape",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfOrientationLandscapeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfOrientationList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfOrientationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfOrientationPortrait",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfOrientationPortraitOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfOrientationSquare",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareIfOrientationSquareOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareImQuery",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareImQueryList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareImQueryOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareMaxColors",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareMaxColorsList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareMaxColorsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareMirror",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareMirrorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareMirrorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareMonoHue",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareMonoHueList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareMonoHueOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareOpacity",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareOpacityList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareOpacityOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareRegionOfInterestCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareRegionOfInterestCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareRegionOfInterestCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareRegionOfInterestCropRegionOfInterest",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareRegionOfInterestCropRegionOfInterestOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareRelativeCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareRelativeCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareRelativeCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareRemoveColor",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareRemoveColorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareRemoveColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareResize",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareResizeList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareResizeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareRotate",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareRotateList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareRotateOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareScale",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareScaleList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareScaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareShear",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareShearList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareShearOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareTrim",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareTrimList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareTrimOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareUnsharpMask",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareUnsharpMaskList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualIfOrientationSquareUnsharpMaskOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualImQuery",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualImQueryList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualImQueryOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualMaxColors",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualMaxColorsList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualMaxColorsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualMirror",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualMirrorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualMirrorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualMonoHue",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualMonoHueList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualMonoHueOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualOpacity",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualOpacityList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualOpacityOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterest",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestCircleShape",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestCircleShapeCenter",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestCircleShapeCenterOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestCircleShapeList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestCircleShapeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestPointShape",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestPointShapeList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestPointShapeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestPolygonShape",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestPolygonShapeList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestPolygonShapeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestPolygonShapePoints",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestPolygonShapePointsList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestPolygonShapePointsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestRectangleShape",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestRectangleShapeAnchor",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestRectangleShapeAnchorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestRectangleShapeList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestRectangleShapeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestUnionShape",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestUnionShapeList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestUnionShapeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestUnionShapeShapes",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestUnionShapeShapesList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRegionOfInterestCropRegionOfInterestUnionShapeShapesOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRelativeCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRelativeCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRelativeCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRemoveColor",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRemoveColorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRemoveColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualResize",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualResizeList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualResizeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRotate",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRotateList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualRotateOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualScale",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualScaleList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualScaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualShear",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualShearList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualShearOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualTrim",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualTrimList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualTrimOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualUnsharpMask",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualUnsharpMaskList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionEqualUnsharpMaskOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThan",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppend",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageBoxImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageBoxImageList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageBoxImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageBoxImageTransformation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageBoxImageTransformationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageCircleImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageCircleImageList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageCircleImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageCircleImageTransformation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageCircleImageTransformationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageTextImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageTextImageList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageTextImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageTextImageTransformation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageTextImageTransformationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageUrlImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageUrlImageList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageUrlImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageUrlImageTransformation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendImageUrlImageTransformationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAppendOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAspectCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAspectCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanAspectCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanBackgroundColor",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanBackgroundColorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanBackgroundColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanBlur",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanBlurList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanBlurOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanChromaKey",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanChromaKeyList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanChromaKeyOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanComposite",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageBoxImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageBoxImageList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageBoxImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageBoxImageTransformation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageBoxImageTransformationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageCircleImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageCircleImageList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageCircleImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageCircleImageTransformation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageCircleImageTransformationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageTextImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageTextImageList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageTextImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageTextImageTransformation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageTextImageTransformationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageUrlImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageUrlImageList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageUrlImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageUrlImageTransformation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeImageUrlImageTransformationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompositeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompound",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompoundList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCompoundOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanContrast",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanContrastList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanContrastOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFaceCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFaceCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFaceCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFeatureCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFeatureCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFeatureCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFill",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationAppend",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationAppendImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationAppendImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationAppendList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationAppendOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationAspectCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationAspectCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationAspectCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationBackgroundColor",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationBackgroundColorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationBackgroundColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationBlur",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationBlurList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationBlurOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationChromaKey",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationChromaKeyList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationChromaKeyOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationComposite",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationCompositeImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationCompositeImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationCompositeList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationCompositeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationCompound",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationCompoundList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationCompoundOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationCompoundTransformations",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationCompoundTransformationsList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationCompoundTransformationsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationContrast",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationContrastList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationContrastOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationFaceCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationFaceCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationFaceCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationFeatureCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationFeatureCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationFeatureCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationFitAndFill",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationFitAndFillFillTransformation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationFitAndFillFillTransformationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationFitAndFillList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationFitAndFillOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationGoop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationGoopList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationGoopOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationGrayscale",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationGrayscaleList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationGrayscaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationHsl",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationHslList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationHslOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationHsv",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationHsvList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationHsvOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfDimension",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfDimensionDefault",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfDimensionDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfDimensionEqual",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfDimensionEqualOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfDimensionGreaterThan",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfDimensionGreaterThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfDimensionLessThan",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfDimensionLessThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfDimensionList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfDimensionOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfOrientation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfOrientationDefault",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfOrientationDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfOrientationLandscape",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfOrientationLandscapeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfOrientationList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfOrientationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfOrientationPortrait",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfOrientationPortraitOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfOrientationSquare",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationIfOrientationSquareOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationImQuery",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationImQueryList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationImQueryOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationMaxColors",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationMaxColorsList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationMaxColorsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationMirror",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationMirrorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationMirrorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationMonoHue",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationMonoHueList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationMonoHueOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationOpacity",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationOpacityList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationOpacityOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationRegionOfInterestCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationRegionOfInterestCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationRegionOfInterestCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationRegionOfInterestCropRegionOfInterest",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationRelativeCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationRelativeCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationRelativeCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationRemoveColor",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationRemoveColorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationRemoveColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationResize",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationResizeList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationResizeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationRotate",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationRotateList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationRotateOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationScale",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationScaleList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationScaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationShear",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationShearList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationShearOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationTrim",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationTrimList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationTrimOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationUnsharpMask",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationUnsharpMaskList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillFillTransformationUnsharpMaskOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanFitAndFillOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanGoop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanGoopList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanGoopOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanGrayscale",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanGrayscaleList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanGrayscaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanHsl",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanHslList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanHslOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanHsv",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanHsvList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanHsvOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefault",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultAppend",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultAppendImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultAppendImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultAppendList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultAppendOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultAspectCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultAspectCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultAspectCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultBackgroundColor",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultBackgroundColorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultBackgroundColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultBlur",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultBlurList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultBlurOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultChromaKey",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultChromaKeyList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultChromaKeyOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultComposite",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultCompositeImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultCompositeImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultCompositeList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultCompositeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultCompound",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultCompoundList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultCompoundOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultCompoundTransformations",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultCompoundTransformationsList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultCompoundTransformationsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultContrast",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultContrastList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultContrastOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultFaceCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultFaceCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultFaceCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultFeatureCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultFeatureCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultFeatureCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultFitAndFill",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultFitAndFillFillTransformation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultFitAndFillFillTransformationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultFitAndFillList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultFitAndFillOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultGoop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultGoopList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultGoopOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultGrayscale",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultGrayscaleList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultGrayscaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultHsl",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultHslList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultHslOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultHsv",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultHsvList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultHsvOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimension",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionDefault",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionEqual",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionEqualOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionGreaterThan",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionGreaterThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionLessThan",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionLessThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationDefault",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationLandscape",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationLandscapeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationPortrait",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationPortraitOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationSquare",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationSquareOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultImQuery",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultImQueryList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultImQueryOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultMaxColors",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultMaxColorsList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultMaxColorsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultMirror",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultMirrorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultMirrorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultMonoHue",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultMonoHueList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultMonoHueOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultOpacity",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultOpacityList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultOpacityOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultRegionOfInterestCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultRegionOfInterestCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultRegionOfInterestCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultRegionOfInterestCropRegionOfInterest",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultRegionOfInterestCropRegionOfInterestOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultRelativeCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultRelativeCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultRelativeCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultRemoveColor",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultRemoveColorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultRemoveColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultResize",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultResizeList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultResizeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultRotate",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultRotateList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultRotateOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultScale",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultScaleList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultScaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultShear",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultShearList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultShearOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultTrim",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultTrimList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultTrimOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultUnsharpMask",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultUnsharpMaskList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationDefaultUnsharpMaskOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscape",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeAppend",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeAppendImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeAppendImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeAppendList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeAppendOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeAspectCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeAspectCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeAspectCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeBackgroundColor",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeBackgroundColorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeBackgroundColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeBlur",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeBlurList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeBlurOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeChromaKey",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeChromaKeyList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeChromaKeyOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeComposite",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompositeImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompositeImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompositeList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompositeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompound",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompoundList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompoundOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompoundTransformations",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompoundTransformationsList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompoundTransformationsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeContrast",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeContrastList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeContrastOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeFaceCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeFaceCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeFaceCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeFeatureCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeFeatureCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeFeatureCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeFitAndFill",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeFitAndFillFillTransformation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeFitAndFillFillTransformationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeFitAndFillList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeFitAndFillOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeGoop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeGoopList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeGoopOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeGrayscale",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeGrayscaleList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeGrayscaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeHsl",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeHslList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeHslOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeHsv",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeHsvList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeHsvOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimension",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionDefault",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionEqual",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionEqualOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionGreaterThan",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionGreaterThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionLessThan",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionLessThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationDefault",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationLandscape",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationLandscapeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationPortrait",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationPortraitOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationSquare",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationSquareOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeImQuery",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeImQueryList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeImQueryOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeMaxColors",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeMaxColorsList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeMaxColorsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeMirror",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeMirrorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeMirrorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeMonoHue",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeMonoHueList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeMonoHueOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeOpacity",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeOpacityList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeOpacityOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeRegionOfInterestCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeRegionOfInterestCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeRegionOfInterestCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeRegionOfInterestCropRegionOfInterest",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeRegionOfInterestCropRegionOfInterestOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeRelativeCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeRelativeCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeRelativeCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeRemoveColor",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeRemoveColorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeRemoveColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeResize",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeResizeList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeResizeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeRotate",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeRotateList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeRotateOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeScale",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeScaleList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeScaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeShear",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeShearList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeShearOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeTrim",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeTrimList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeTrimOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeUnsharpMask",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeUnsharpMaskList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationLandscapeUnsharpMaskOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortrait",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitAppend",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitAppendImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitAppendImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitAppendList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitAppendOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitAspectCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitAspectCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitAspectCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitBackgroundColor",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitBackgroundColorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitBackgroundColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitBlur",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitBlurList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitBlurOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitChromaKey",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitChromaKeyList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitChromaKeyOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitComposite",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitCompositeImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitCompositeImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitCompositeList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitCompositeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitCompound",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitCompoundList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitCompoundOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitCompoundTransformations",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitCompoundTransformationsList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitCompoundTransformationsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitContrast",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitContrastList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitContrastOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitFaceCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitFaceCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitFaceCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitFeatureCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitFeatureCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitFeatureCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitFitAndFill",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitFitAndFillFillTransformation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitFitAndFillFillTransformationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitFitAndFillList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitFitAndFillOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitGoop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitGoopList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitGoopOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitGrayscale",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitGrayscaleList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitGrayscaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitHsl",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitHslList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitHslOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitHsv",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitHsvList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitHsvOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimension",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionDefault",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionEqual",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionEqualOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionGreaterThan",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionGreaterThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionLessThan",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionLessThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationDefault",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationLandscape",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationLandscapeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationPortrait",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationPortraitOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationSquare",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationSquareOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitImQuery",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitImQueryList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitImQueryOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitMaxColors",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitMaxColorsList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitMaxColorsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitMirror",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitMirrorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitMirrorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitMonoHue",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitMonoHueList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitMonoHueOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitOpacity",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitOpacityList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitOpacityOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitRegionOfInterestCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitRegionOfInterestCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitRegionOfInterestCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitRegionOfInterestCropRegionOfInterest",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitRegionOfInterestCropRegionOfInterestOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitRelativeCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitRelativeCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitRelativeCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitRemoveColor",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitRemoveColorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitRemoveColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitResize",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitResizeList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitResizeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitRotate",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitRotateList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitRotateOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitScale",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitScaleList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitScaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitShear",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitShearList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitShearOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitTrim",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitTrimList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitTrimOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitUnsharpMask",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitUnsharpMaskList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationPortraitUnsharpMaskOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquare",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareAppend",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareAppendImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareAppendImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareAppendList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareAppendOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareAspectCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareAspectCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareAspectCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareBackgroundColor",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareBackgroundColorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareBackgroundColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareBlur",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareBlurList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareBlurOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareChromaKey",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareChromaKeyList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareChromaKeyOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareComposite",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareCompositeImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareCompositeImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareCompositeList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareCompositeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareCompound",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareCompoundList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareCompoundOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareCompoundTransformations",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareCompoundTransformationsList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareCompoundTransformationsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareContrast",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareContrastList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareContrastOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareFaceCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareFaceCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareFaceCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareFeatureCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareFeatureCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareFeatureCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareFitAndFill",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareFitAndFillFillTransformation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareFitAndFillFillTransformationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareFitAndFillList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareFitAndFillOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareGoop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareGoopList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareGoopOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareGrayscale",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareGrayscaleList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareGrayscaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareHsl",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareHslList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareHslOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareHsv",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareHsvList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareHsvOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimension",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionDefault",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionEqual",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionEqualOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionGreaterThan",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionGreaterThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionLessThan",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionLessThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationDefault",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationLandscape",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationLandscapeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationPortrait",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationPortraitOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationSquare",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationSquareOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareImQuery",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareImQueryList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareImQueryOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareMaxColors",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareMaxColorsList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareMaxColorsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareMirror",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareMirrorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareMirrorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareMonoHue",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareMonoHueList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareMonoHueOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareOpacity",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareOpacityList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareOpacityOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareRegionOfInterestCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareRegionOfInterestCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareRegionOfInterestCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareRegionOfInterestCropRegionOfInterest",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareRegionOfInterestCropRegionOfInterestOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareRelativeCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareRelativeCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareRelativeCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareRemoveColor",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareRemoveColorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareRemoveColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareResize",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareResizeList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareResizeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareRotate",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareRotateList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareRotateOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareScale",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareScaleList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareScaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareShear",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareShearList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareShearOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareTrim",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareTrimList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareTrimOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareUnsharpMask",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareUnsharpMaskList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanIfOrientationSquareUnsharpMaskOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanImQuery",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanImQueryList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanImQueryOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanMaxColors",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanMaxColorsList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanMaxColorsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanMirror",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanMirrorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanMirrorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanMonoHue",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanMonoHueList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanMonoHueOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanOpacity",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanOpacityList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanOpacityOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterest",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestCircleShape",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestCircleShapeCenter",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestCircleShapeCenterOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestCircleShapeList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestCircleShapeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestPointShape",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestPointShapeList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestPointShapeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestPolygonShape",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestPolygonShapeList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestPolygonShapeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestPolygonShapePoints",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestPolygonShapePointsList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestPolygonShapePointsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestRectangleShape",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestRectangleShapeAnchor",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestRectangleShapeAnchorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestRectangleShapeList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestRectangleShapeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestUnionShape",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestUnionShapeList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestUnionShapeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestUnionShapeShapes",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestUnionShapeShapesList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestUnionShapeShapesOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRelativeCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRelativeCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRelativeCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRemoveColor",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRemoveColorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRemoveColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanResize",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanResizeList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanResizeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRotate",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRotateList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanRotateOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanScale",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanScaleList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanScaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanShear",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanShearList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanShearOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanTrim",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanTrimList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanTrimOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanUnsharpMask",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanUnsharpMaskList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionGreaterThanUnsharpMaskOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThan",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppend",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageBoxImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageBoxImageList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageBoxImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageBoxImageTransformation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageBoxImageTransformationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageCircleImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageCircleImageList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageCircleImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageCircleImageTransformation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageCircleImageTransformationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageTextImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageTextImageList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageTextImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageTextImageTransformation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageTextImageTransformationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageUrlImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageUrlImageList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageUrlImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageUrlImageTransformation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendImageUrlImageTransformationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAppendOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAspectCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAspectCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanAspectCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanBackgroundColor",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanBackgroundColorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanBackgroundColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanBlur",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanBlurList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanBlurOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanChromaKey",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanChromaKeyList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanChromaKeyOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanComposite",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageBoxImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageBoxImageList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageBoxImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageBoxImageTransformation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageBoxImageTransformationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageCircleImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageCircleImageList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageCircleImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageCircleImageTransformation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageCircleImageTransformationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageTextImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageTextImageList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageTextImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageTextImageTransformation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageTextImageTransformationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageUrlImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageUrlImageList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageUrlImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageUrlImageTransformation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeImageUrlImageTransformationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompositeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompound",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompoundList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCompoundOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanContrast",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanContrastList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanContrastOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFaceCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFaceCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFaceCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFeatureCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFeatureCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFeatureCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFill",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationAppend",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationAppendImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationAppendImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationAppendList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationAppendOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationAspectCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationAspectCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationAspectCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationBackgroundColor",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationBackgroundColorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationBackgroundColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationBlur",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationBlurList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationBlurOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationChromaKey",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationChromaKeyList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationChromaKeyOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationComposite",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationCompositeImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationCompositeImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationCompositeList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationCompositeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationCompound",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationCompoundList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationCompoundOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationCompoundTransformations",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationCompoundTransformationsList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationCompoundTransformationsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationContrast",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationContrastList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationContrastOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationFaceCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationFaceCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationFaceCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationFeatureCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationFeatureCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationFeatureCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationFitAndFill",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationFitAndFillFillTransformation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationFitAndFillFillTransformationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationFitAndFillList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationFitAndFillOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationGoop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationGoopList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationGoopOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationGrayscale",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationGrayscaleList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationGrayscaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationHsl",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationHslList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationHslOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationHsv",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationHsvList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationHsvOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfDimension",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfDimensionDefault",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfDimensionDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfDimensionEqual",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfDimensionEqualOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfDimensionGreaterThan",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfDimensionGreaterThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfDimensionLessThan",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfDimensionLessThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfDimensionList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfDimensionOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfOrientation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfOrientationDefault",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfOrientationDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfOrientationLandscape",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfOrientationLandscapeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfOrientationList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfOrientationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfOrientationPortrait",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfOrientationPortraitOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfOrientationSquare",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationIfOrientationSquareOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationImQuery",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationImQueryList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationImQueryOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationMaxColors",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationMaxColorsList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationMaxColorsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationMirror",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationMirrorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationMirrorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationMonoHue",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationMonoHueList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationMonoHueOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationOpacity",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationOpacityList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationOpacityOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationRegionOfInterestCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationRegionOfInterestCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationRegionOfInterestCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationRegionOfInterestCropRegionOfInterest",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationRelativeCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationRelativeCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationRelativeCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationRemoveColor",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationRemoveColorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationRemoveColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationResize",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationResizeList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationResizeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationRotate",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationRotateList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationRotateOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationScale",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationScaleList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationScaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationShear",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationShearList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationShearOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationTrim",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationTrimList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationTrimOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationUnsharpMask",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationUnsharpMaskList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillFillTransformationUnsharpMaskOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanFitAndFillOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanGoop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanGoopList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanGoopOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanGrayscale",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanGrayscaleList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanGrayscaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanHsl",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanHslList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanHslOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanHsv",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanHsvList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanHsvOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefault",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultAppend",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultAppendImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultAppendImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultAppendList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultAppendOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultAspectCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultAspectCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultAspectCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultBackgroundColor",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultBackgroundColorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultBackgroundColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultBlur",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultBlurList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultBlurOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultChromaKey",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultChromaKeyList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultChromaKeyOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultComposite",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCompositeImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCompositeImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCompositeList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCompositeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCompound",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCompoundList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCompoundOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCompoundTransformations",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCompoundTransformationsList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCompoundTransformationsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultContrast",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultContrastList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultContrastOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultFaceCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultFaceCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultFaceCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultFeatureCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultFeatureCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultFeatureCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultFitAndFill",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultFitAndFillFillTransformation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultFitAndFillFillTransformationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultFitAndFillList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultFitAndFillOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultGoop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultGoopList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultGoopOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultGrayscale",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultGrayscaleList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultGrayscaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultHsl",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultHslList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultHslOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultHsv",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultHsvList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultHsvOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimension",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionDefault",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionEqual",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionEqualOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionGreaterThan",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionGreaterThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionLessThan",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionLessThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationDefault",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationLandscape",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationLandscapeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationPortrait",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationPortraitOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationSquare",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationSquareOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultImQuery",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultImQueryList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultImQueryOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultMaxColors",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultMaxColorsList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultMaxColorsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultMirror",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultMirrorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultMirrorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultMonoHue",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultMonoHueList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultMonoHueOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultOpacity",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultOpacityList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultOpacityOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRegionOfInterestCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRegionOfInterestCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRegionOfInterestCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRegionOfInterestCropRegionOfInterest",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRegionOfInterestCropRegionOfInterestOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRelativeCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRelativeCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRelativeCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRemoveColor",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRemoveColorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRemoveColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultResize",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultResizeList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultResizeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRotate",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRotateList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRotateOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultScale",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultScaleList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultScaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultShear",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultShearList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultShearOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultTrim",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultTrimList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultTrimOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultUnsharpMask",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultUnsharpMaskList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultUnsharpMaskOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscape",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeAppend",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeAppendImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeAppendImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeAppendList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeAppendOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeAspectCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeAspectCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeAspectCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeBackgroundColor",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeBackgroundColorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeBackgroundColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeBlur",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeBlurList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeBlurOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeChromaKey",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeChromaKeyList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeChromaKeyOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeComposite",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCompositeImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCompositeImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCompositeList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCompositeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCompound",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCompoundList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCompoundOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCompoundTransformations",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCompoundTransformationsList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCompoundTransformationsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeContrast",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeContrastList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeContrastOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeFaceCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeFaceCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeFaceCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeFeatureCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeFeatureCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeFeatureCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeFitAndFill",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeFitAndFillFillTransformation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeFitAndFillFillTransformationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeFitAndFillList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeFitAndFillOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeGoop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeGoopList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeGoopOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeGrayscale",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeGrayscaleList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeGrayscaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeHsl",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeHslList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeHslOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeHsv",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeHsvList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeHsvOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimension",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionDefault",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionEqual",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionEqualOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionGreaterThan",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionGreaterThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionLessThan",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionLessThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationDefault",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationLandscape",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationLandscapeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationPortrait",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationPortraitOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationSquare",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationSquareOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeImQuery",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeImQueryList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeImQueryOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeMaxColors",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeMaxColorsList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeMaxColorsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeMirror",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeMirrorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeMirrorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeMonoHue",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeMonoHueList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeMonoHueOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeOpacity",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeOpacityList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeOpacityOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRegionOfInterestCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRegionOfInterestCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRegionOfInterestCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRegionOfInterestCropRegionOfInterest",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRegionOfInterestCropRegionOfInterestOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRelativeCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRelativeCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRelativeCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRemoveColor",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRemoveColorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRemoveColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeResize",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeResizeList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeResizeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRotate",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRotateList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRotateOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeScale",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeScaleList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeScaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeShear",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeShearList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeShearOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeTrim",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeTrimList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeTrimOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeUnsharpMask",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeUnsharpMaskList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeUnsharpMaskOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortrait",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitAppend",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitAppendImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitAppendImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitAppendList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitAppendOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitAspectCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitAspectCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitAspectCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitBackgroundColor",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitBackgroundColorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitBackgroundColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitBlur",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitBlurList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitBlurOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitChromaKey",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitChromaKeyList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitChromaKeyOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitComposite",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitCompositeImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitCompositeImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitCompositeList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitCompositeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitCompound",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitCompoundList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitCompoundOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitCompoundTransformations",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitCompoundTransformationsList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitCompoundTransformationsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitContrast",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitContrastList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitContrastOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitFaceCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitFaceCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitFaceCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitFeatureCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitFeatureCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitFeatureCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitFitAndFill",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitFitAndFillFillTransformation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitFitAndFillFillTransformationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitFitAndFillList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitFitAndFillOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitGoop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitGoopList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitGoopOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitGrayscale",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitGrayscaleList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitGrayscaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitHsl",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitHslList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitHslOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitHsv",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitHsvList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitHsvOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfDimension",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionDefault",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionEqual",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionEqualOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionGreaterThan",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionGreaterThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionLessThan",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionLessThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationDefault",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationLandscape",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationLandscapeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationPortrait",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationPortraitOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationSquare",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationSquareOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitImQuery",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitImQueryList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitImQueryOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitMaxColors",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitMaxColorsList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitMaxColorsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitMirror",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitMirrorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitMirrorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitMonoHue",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitMonoHueList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitMonoHueOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitOpacity",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitOpacityList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitOpacityOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitRegionOfInterestCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitRegionOfInterestCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitRegionOfInterestCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitRegionOfInterestCropRegionOfInterest",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitRegionOfInterestCropRegionOfInterestOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitRelativeCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitRelativeCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitRelativeCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitRemoveColor",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitRemoveColorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitRemoveColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitResize",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitResizeList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitResizeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitRotate",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitRotateList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitRotateOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitScale",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitScaleList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitScaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitShear",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitShearList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitShearOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitTrim",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitTrimList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitTrimOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitUnsharpMask",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitUnsharpMaskList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitUnsharpMaskOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquare",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareAppend",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareAppendImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareAppendImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareAppendList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareAppendOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareAspectCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareAspectCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareAspectCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareBackgroundColor",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareBackgroundColorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareBackgroundColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareBlur",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareBlurList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareBlurOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareChromaKey",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareChromaKeyList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareChromaKeyOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareComposite",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareCompositeImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareCompositeImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareCompositeList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareCompositeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareCompound",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareCompoundList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareCompoundOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareCompoundTransformations",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareCompoundTransformationsList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareCompoundTransformationsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareContrast",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareContrastList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareContrastOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareFaceCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareFaceCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareFaceCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareFeatureCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareFeatureCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareFeatureCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareFitAndFill",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareFitAndFillFillTransformation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareFitAndFillFillTransformationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareFitAndFillList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareFitAndFillOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareGoop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareGoopList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareGoopOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareGrayscale",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareGrayscaleList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareGrayscaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareHsl",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareHslList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareHslOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareHsv",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareHsvList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareHsvOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfDimension",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionDefault",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionEqual",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionEqualOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionGreaterThan",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionGreaterThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionLessThan",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionLessThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfOrientation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationDefault",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationLandscape",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationLandscapeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationPortrait",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationPortraitOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationSquare",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationSquareOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareImQuery",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareImQueryList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareImQueryOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareMaxColors",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareMaxColorsList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareMaxColorsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareMirror",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareMirrorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareMirrorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareMonoHue",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareMonoHueList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareMonoHueOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareOpacity",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareOpacityList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareOpacityOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareRegionOfInterestCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareRegionOfInterestCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareRegionOfInterestCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareRegionOfInterestCropRegionOfInterest",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareRegionOfInterestCropRegionOfInterestOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareRelativeCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareRelativeCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareRelativeCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareRemoveColor",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareRemoveColorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareRemoveColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareResize",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareResizeList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareResizeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareRotate",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareRotateList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareRotateOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareScale",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareScaleList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareScaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareShear",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareShearList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareShearOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareTrim",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareTrimList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareTrimOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareUnsharpMask",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareUnsharpMaskList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationSquareUnsharpMaskOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanImQuery",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanImQueryList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanImQueryOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanMaxColors",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanMaxColorsList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanMaxColorsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanMirror",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanMirrorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanMirrorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanMonoHue",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanMonoHueList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanMonoHueOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanOpacity",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanOpacityList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanOpacityOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterest",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestCircleShape",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestCircleShapeCenter",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestCircleShapeCenterOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestCircleShapeList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestCircleShapeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestPointShape",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestPointShapeList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestPointShapeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestPolygonShape",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestPolygonShapeList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestPolygonShapeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestPolygonShapePoints",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestPolygonShapePointsList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestPolygonShapePointsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestRectangleShape",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestRectangleShapeAnchor",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestRectangleShapeAnchorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestRectangleShapeList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestRectangleShapeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestUnionShape",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestUnionShapeList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestUnionShapeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestUnionShapeShapes",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestUnionShapeShapesList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRegionOfInterestCropRegionOfInterestUnionShapeShapesOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRelativeCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRelativeCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRelativeCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRemoveColor",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRemoveColorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRemoveColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanResize",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanResizeList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanResizeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRotate",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRotateList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanRotateOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanScale",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanScaleList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanScaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanShear",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanShearList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanShearOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanTrim",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanTrimList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanTrimOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanUnsharpMask",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanUnsharpMaskList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanUnsharpMaskOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefault",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppend",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageBoxImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageBoxImageList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageBoxImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageBoxImageTransformation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageBoxImageTransformationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageCircleImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageCircleImageList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageCircleImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageCircleImageTransformation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageCircleImageTransformationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageTextImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageTextImageList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageTextImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageTextImageTransformation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageTextImageTransformationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageUrlImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageUrlImageList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageUrlImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageUrlImageTransformation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendImageUrlImageTransformationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAppendOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAspectCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAspectCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultAspectCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultBackgroundColor",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultBackgroundColorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultBackgroundColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultBlur",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultBlurList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultBlurOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultChromaKey",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultChromaKeyList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultChromaKeyOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultComposite",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageBoxImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageBoxImageList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageBoxImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageBoxImageTransformation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageBoxImageTransformationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageCircleImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageCircleImageList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageCircleImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageCircleImageTransformation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageCircleImageTransformationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageTextImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageTextImageList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageTextImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageTextImageTransformation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageTextImageTransformationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageUrlImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageUrlImageList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageUrlImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageUrlImageTransformation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeImageUrlImageTransformationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompositeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompound",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompoundList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCompoundOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultContrast",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultContrastList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultContrastOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFaceCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFaceCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFaceCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFeatureCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFeatureCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFeatureCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFill",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationAppend",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationAppendImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationAppendImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationAppendList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationAppendOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationAspectCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationAspectCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationAspectCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationBackgroundColor",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationBackgroundColorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationBackgroundColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationBlur",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationBlurList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationBlurOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationChromaKey",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationChromaKeyList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationChromaKeyOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationComposite",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationCompositeImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationCompositeImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationCompositeList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationCompositeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationCompound",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationCompoundList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationCompoundOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationCompoundTransformations",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationCompoundTransformationsList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationCompoundTransformationsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationContrast",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationContrastList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationContrastOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationFaceCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationFaceCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationFaceCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationFeatureCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationFeatureCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationFeatureCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationFitAndFill",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationFitAndFillFillTransformation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationFitAndFillFillTransformationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationFitAndFillList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationFitAndFillOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationGoop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationGoopList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationGoopOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationGrayscale",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationGrayscaleList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationGrayscaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationHsl",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationHslList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationHslOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationHsv",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationHsvList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationHsvOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfDimension",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfDimensionDefault",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfDimensionDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfDimensionEqual",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfDimensionEqualOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfDimensionGreaterThan",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfDimensionGreaterThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfDimensionLessThan",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfDimensionLessThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfDimensionList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfDimensionOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfOrientation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfOrientationDefault",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfOrientationDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfOrientationLandscape",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfOrientationLandscapeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfOrientationList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfOrientationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfOrientationPortrait",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfOrientationPortraitOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfOrientationSquare",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationIfOrientationSquareOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationImQuery",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationImQueryList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationImQueryOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationMaxColors",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationMaxColorsList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationMaxColorsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationMirror",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationMirrorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationMirrorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationMonoHue",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationMonoHueList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationMonoHueOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationOpacity",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationOpacityList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationOpacityOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationRegionOfInterestCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationRegionOfInterestCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationRegionOfInterestCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationRegionOfInterestCropRegionOfInterest",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationRelativeCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationRelativeCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationRelativeCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationRemoveColor",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationRemoveColorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationRemoveColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationResize",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationResizeList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationResizeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationRotate",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationRotateList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationRotateOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationScale",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationScaleList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationScaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationShear",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationShearList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationShearOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationTrim",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationTrimList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationTrimOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationUnsharpMask",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationUnsharpMaskList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillFillTransformationUnsharpMaskOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultFitAndFillOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultGoop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultGoopList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultGoopOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultGrayscale",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultGrayscaleList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultGrayscaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultHsl",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultHslList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultHslOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultHsv",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultHsvList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultHsvOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimension",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqual",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualAppend",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualAppendImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualAppendImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualAppendList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualAppendOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualAspectCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualAspectCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualAspectCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualBackgroundColor",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualBackgroundColorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualBackgroundColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualBlur",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualBlurList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualBlurOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualChromaKey",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualChromaKeyList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualChromaKeyOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualComposite",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualCompositeImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualCompositeImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualCompositeList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualCompositeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualCompound",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualCompoundList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualCompoundOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualCompoundTransformations",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualCompoundTransformationsList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualCompoundTransformationsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualContrast",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualContrastList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualContrastOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualFaceCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualFaceCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualFaceCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualFeatureCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualFeatureCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualFeatureCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualFitAndFill",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualFitAndFillFillTransformation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualFitAndFillFillTransformationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualFitAndFillList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualFitAndFillOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualGoop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualGoopList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualGoopOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualGrayscale",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualGrayscaleList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualGrayscaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualHsl",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualHslList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualHslOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualHsv",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualHsvList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualHsvOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfDimension",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionDefault",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionEqual",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionEqualOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionGreaterThan",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionGreaterThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionLessThan",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionLessThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfOrientation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationDefault",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationLandscape",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationLandscapeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationPortrait",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationPortraitOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationSquare",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationSquareOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualImQuery",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualImQueryList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualImQueryOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualMaxColors",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualMaxColorsList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualMaxColorsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualMirror",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualMirrorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualMirrorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualMonoHue",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualMonoHueList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualMonoHueOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualOpacity",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualOpacityList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualOpacityOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualRegionOfInterestCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualRegionOfInterestCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualRegionOfInterestCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualRegionOfInterestCropRegionOfInterest",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualRegionOfInterestCropRegionOfInterestOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualRelativeCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualRelativeCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualRelativeCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualRemoveColor",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualRemoveColorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualRemoveColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualResize",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualResizeList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualResizeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualRotate",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualRotateList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualRotateOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualScale",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualScaleList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualScaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualShear",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualShearList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualShearOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualTrim",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualTrimList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualTrimOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualUnsharpMask",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualUnsharpMaskList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionEqualUnsharpMaskOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThan",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanAppend",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanAppendImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanAppendImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanAppendList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanAppendOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanAspectCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanAspectCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanAspectCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanBackgroundColor",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanBackgroundColorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanBackgroundColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanBlur",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanBlurList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanBlurOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanChromaKey",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanChromaKeyList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanChromaKeyOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanComposite",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanCompositeImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanCompositeImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanCompositeList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanCompositeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanCompound",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanCompoundList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanCompoundOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanCompoundTransformations",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanCompoundTransformationsList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanCompoundTransformationsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanContrast",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanContrastList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanContrastOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanFaceCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanFaceCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanFaceCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanFeatureCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanFeatureCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanFeatureCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanFitAndFill",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanFitAndFillFillTransformation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanFitAndFillFillTransformationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanFitAndFillList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanFitAndFillOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanGoop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanGoopList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanGoopOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanGrayscale",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanGrayscaleList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanGrayscaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanHsl",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanHslList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanHslOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanHsv",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanHsvList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanHsvOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimension",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionDefault",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionEqual",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionEqualOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionGreaterThan",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionGreaterThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionLessThan",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionLessThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationDefault",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationLandscape",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationLandscapeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationPortrait",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationPortraitOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationSquare",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationSquareOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanImQuery",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanImQueryList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanImQueryOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanMaxColors",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanMaxColorsList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanMaxColorsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanMirror",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanMirrorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanMirrorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanMonoHue",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanMonoHueList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanMonoHueOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanOpacity",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanOpacityList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanOpacityOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanRegionOfInterestCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanRegionOfInterestCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanRegionOfInterestCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanRegionOfInterestCropRegionOfInterest",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanRelativeCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanRelativeCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanRelativeCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanRemoveColor",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanRemoveColorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanRemoveColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanResize",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanResizeList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanResizeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanRotate",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanRotateList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanRotateOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanScale",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanScaleList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanScaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanShear",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanShearList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanShearOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanTrim",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanTrimList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanTrimOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanUnsharpMask",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanUnsharpMaskList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionGreaterThanUnsharpMaskOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThan",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanAppend",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanAppendImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanAppendImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanAppendList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanAppendOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanAspectCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanAspectCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanAspectCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanBackgroundColor",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanBackgroundColorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanBackgroundColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanBlur",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanBlurList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanBlurOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanChromaKey",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanChromaKeyList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanChromaKeyOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanComposite",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanCompositeImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanCompositeImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanCompositeList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanCompositeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanCompound",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanCompoundList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanCompoundOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanCompoundTransformations",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanCompoundTransformationsList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanCompoundTransformationsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanContrast",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanContrastList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanContrastOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanFaceCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanFaceCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanFaceCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanFeatureCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanFeatureCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanFeatureCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanFitAndFill",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanFitAndFillFillTransformation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanFitAndFillFillTransformationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanFitAndFillList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanFitAndFillOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanGoop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanGoopList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanGoopOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanGrayscale",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanGrayscaleList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanGrayscaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanHsl",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanHslList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanHslOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanHsv",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanHsvList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanHsvOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfDimension",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionDefault",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionEqual",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionEqualOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionGreaterThan",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionGreaterThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionLessThan",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionLessThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationDefault",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationLandscape",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationLandscapeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationPortrait",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationPortraitOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationSquare",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationSquareOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanImQuery",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanImQueryList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanImQueryOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanMaxColors",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanMaxColorsList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanMaxColorsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanMirror",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanMirrorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanMirrorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanMonoHue",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanMonoHueList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanMonoHueOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanOpacity",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanOpacityList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanOpacityOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanRegionOfInterestCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanRegionOfInterestCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanRegionOfInterestCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanRegionOfInterestCropRegionOfInterest",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanRegionOfInterestCropRegionOfInterestOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanRelativeCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanRelativeCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanRelativeCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanRemoveColor",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanRemoveColorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanRemoveColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanResize",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanResizeList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanResizeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanRotate",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanRotateList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanRotateOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanScale",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanScaleList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanScaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanShear",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanShearList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanShearOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanTrim",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanTrimList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanTrimOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanUnsharpMask",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanUnsharpMaskList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionLessThanUnsharpMaskOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultIfDimensionOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultImQuery",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultImQueryList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultImQueryOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultMaxColors",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultMaxColorsList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultMaxColorsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultMirror",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultMirrorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultMirrorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultMonoHue",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultMonoHueList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultMonoHueOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultOpacity",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultOpacityList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultOpacityOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterest",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestCircleShape",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestCircleShapeCenter",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestCircleShapeCenterOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestCircleShapeList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestCircleShapeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestPointShape",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestPointShapeList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestPointShapeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestPolygonShape",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestPolygonShapeList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestPolygonShapeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestPolygonShapePoints",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestPolygonShapePointsList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestPolygonShapePointsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestRectangleShape",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestRectangleShapeAnchor",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestRectangleShapeAnchorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestRectangleShapeList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestRectangleShapeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestUnionShape",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestUnionShapeList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestUnionShapeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestUnionShapeShapes",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestUnionShapeShapesList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRegionOfInterestCropRegionOfInterestUnionShapeShapesOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRelativeCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRelativeCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRelativeCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRemoveColor",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRemoveColorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRemoveColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultResize",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultResizeList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultResizeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRotate",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRotateList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultRotateOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultScale",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultScaleList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultScaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultShear",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultShearList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultShearOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultTrim",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultTrimList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultTrimOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultUnsharpMask",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultUnsharpMaskList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationDefaultUnsharpMaskOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscape",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppend",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageBoxImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageBoxImageList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageBoxImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageBoxImageTransformation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageBoxImageTransformationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageCircleImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageCircleImageList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageCircleImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageCircleImageTransformation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageCircleImageTransformationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageTextImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageTextImageList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageTextImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageTextImageTransformation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageTextImageTransformationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageUrlImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageUrlImageList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageUrlImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageUrlImageTransformation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendImageUrlImageTransformationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAppendOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAspectCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAspectCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeAspectCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeBackgroundColor",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeBackgroundColorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeBackgroundColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeBlur",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeBlurList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeBlurOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeChromaKey",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeChromaKeyList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeChromaKeyOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeComposite",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageBoxImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageBoxImageList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageBoxImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageBoxImageTransformation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageBoxImageTransformationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageCircleImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageCircleImageList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageCircleImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageCircleImageTransformation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageCircleImageTransformationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageTextImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageTextImageList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageTextImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageTextImageTransformation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageTextImageTransformationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageUrlImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageUrlImageList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageUrlImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageUrlImageTransformation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeImageUrlImageTransformationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompositeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompound",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompoundList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCompoundOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeContrast",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeContrastList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeContrastOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFaceCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFaceCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFaceCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFeatureCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFeatureCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFeatureCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFill",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationAppend",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationAppendImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationAppendImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationAppendList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationAppendOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationAspectCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationAspectCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationAspectCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationBackgroundColor",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationBackgroundColorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationBackgroundColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationBlur",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationBlurList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationBlurOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationChromaKey",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationChromaKeyList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationChromaKeyOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationComposite",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationCompositeImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationCompositeImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationCompositeList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationCompositeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationCompound",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationCompoundList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationCompoundOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationCompoundTransformations",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationCompoundTransformationsList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationCompoundTransformationsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationContrast",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationContrastList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationContrastOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationFaceCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationFaceCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationFaceCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationFeatureCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationFeatureCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationFeatureCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationFitAndFill",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationFitAndFillFillTransformation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationFitAndFillFillTransformationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationFitAndFillList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationFitAndFillOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationGoop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationGoopList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationGoopOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationGrayscale",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationGrayscaleList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationGrayscaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationHsl",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationHslList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationHslOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationHsv",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationHsvList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationHsvOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfDimension",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfDimensionDefault",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfDimensionDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfDimensionEqual",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfDimensionEqualOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfDimensionGreaterThan",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfDimensionGreaterThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfDimensionLessThan",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfDimensionLessThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfDimensionList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfDimensionOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfOrientation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfOrientationDefault",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfOrientationDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfOrientationLandscape",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfOrientationLandscapeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfOrientationList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfOrientationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfOrientationPortrait",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfOrientationPortraitOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfOrientationSquare",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationIfOrientationSquareOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationImQuery",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationImQueryList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationImQueryOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationMaxColors",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationMaxColorsList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationMaxColorsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationMirror",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationMirrorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationMirrorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationMonoHue",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationMonoHueList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationMonoHueOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationOpacity",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationOpacityList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationOpacityOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationRegionOfInterestCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationRegionOfInterestCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationRegionOfInterestCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationRegionOfInterestCropRegionOfInterest",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationRelativeCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationRelativeCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationRelativeCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationRemoveColor",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationRemoveColorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationRemoveColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationResize",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationResizeList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationResizeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationRotate",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationRotateList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationRotateOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationScale",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationScaleList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationScaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationShear",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationShearList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationShearOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationTrim",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationTrimList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationTrimOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationUnsharpMask",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationUnsharpMaskList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillFillTransformationUnsharpMaskOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeFitAndFillOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeGoop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeGoopList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeGoopOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeGrayscale",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeGrayscaleList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeGrayscaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeHsl",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeHslList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeHslOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeHsv",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeHsvList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeHsvOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimension",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefault",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultAppend",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultAppendImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultAppendImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultAppendList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultAppendOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultAspectCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultAspectCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultAspectCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultBackgroundColor",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultBackgroundColorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultBackgroundColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultBlur",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultBlurList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultBlurOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultChromaKey",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultChromaKeyList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultChromaKeyOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultComposite",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCompositeImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCompositeImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCompositeList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCompositeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCompound",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCompoundList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCompoundOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCompoundTransformations",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCompoundTransformationsList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCompoundTransformationsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultContrast",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultContrastList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultContrastOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultFaceCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultFaceCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultFaceCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultFeatureCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultFeatureCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultFeatureCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultFitAndFill",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultFitAndFillFillTransformation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultFitAndFillFillTransformationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultFitAndFillList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultFitAndFillOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultGoop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultGoopList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultGoopOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultGrayscale",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultGrayscaleList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultGrayscaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultHsl",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultHslList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultHslOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultHsv",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultHsvList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultHsvOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimension",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionDefault",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionEqual",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionEqualOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionGreaterThan",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionGreaterThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionLessThan",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionLessThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationDefault",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationLandscape",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationLandscapeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationPortrait",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationPortraitOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationSquare",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationSquareOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultImQuery",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultImQueryList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultImQueryOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultMaxColors",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultMaxColorsList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultMaxColorsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultMirror",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultMirrorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultMirrorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultMonoHue",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultMonoHueList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultMonoHueOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultOpacity",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultOpacityList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultOpacityOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRegionOfInterestCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRegionOfInterestCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRegionOfInterestCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRegionOfInterestCropRegionOfInterest",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRegionOfInterestCropRegionOfInterestOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRelativeCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRelativeCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRelativeCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRemoveColor",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRemoveColorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRemoveColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultResize",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultResizeList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultResizeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRotate",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRotateList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRotateOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultScale",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultScaleList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultScaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultShear",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultShearList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultShearOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultTrim",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultTrimList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultTrimOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultUnsharpMask",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultUnsharpMaskList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultUnsharpMaskOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqual",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualAppend",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualAppendImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualAppendImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualAppendList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualAppendOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualAspectCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualAspectCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualAspectCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualBackgroundColor",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualBackgroundColorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualBackgroundColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualBlur",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualBlurList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualBlurOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualChromaKey",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualChromaKeyList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualChromaKeyOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualComposite",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCompositeImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCompositeImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCompositeList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCompositeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCompound",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCompoundList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCompoundOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCompoundTransformations",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCompoundTransformationsList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCompoundTransformationsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualContrast",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualContrastList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualContrastOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualFaceCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualFaceCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualFaceCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualFeatureCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualFeatureCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualFeatureCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualFitAndFill",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualFitAndFillFillTransformation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualFitAndFillFillTransformationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualFitAndFillList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualFitAndFillOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualGoop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualGoopList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualGoopOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualGrayscale",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualGrayscaleList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualGrayscaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualHsl",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualHslList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualHslOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualHsv",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualHsvList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualHsvOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimension",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionDefault",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionEqual",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionEqualOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionGreaterThan",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionGreaterThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionLessThan",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionLessThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationDefault",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationLandscape",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationLandscapeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationPortrait",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationPortraitOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationSquare",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationSquareOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualImQuery",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualImQueryList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualImQueryOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualMaxColors",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualMaxColorsList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualMaxColorsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualMirror",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualMirrorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualMirrorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualMonoHue",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualMonoHueList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualMonoHueOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualOpacity",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualOpacityList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualOpacityOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRegionOfInterestCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRegionOfInterestCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRegionOfInterestCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRegionOfInterestCropRegionOfInterest",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRegionOfInterestCropRegionOfInterestOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRelativeCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRelativeCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRelativeCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRemoveColor",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRemoveColorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRemoveColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualResize",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualResizeList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualResizeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRotate",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRotateList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRotateOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualScale",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualScaleList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualScaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualShear",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualShearList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualShearOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualTrim",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualTrimList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualTrimOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualUnsharpMask",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualUnsharpMaskList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualUnsharpMaskOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThan",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanAppend",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanAppendImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanAppendImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanAppendList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanAppendOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanAspectCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanAspectCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanAspectCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanBackgroundColor",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanBackgroundColorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanBackgroundColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanBlur",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanBlurList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanBlurOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanChromaKey",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanChromaKeyList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanChromaKeyOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanComposite",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompositeImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompositeImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompositeList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompositeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompound",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompoundList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompoundOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompoundTransformations",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompoundTransformationsList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompoundTransformationsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanContrast",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanContrastList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanContrastOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanFaceCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanFaceCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanFaceCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanFeatureCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanFeatureCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanFeatureCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanFitAndFill",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanFitAndFillFillTransformation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanFitAndFillFillTransformationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanFitAndFillList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanFitAndFillOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanGoop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanGoopList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanGoopOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanGrayscale",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanGrayscaleList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanGrayscaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanHsl",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanHslList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanHslOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanHsv",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanHsvList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanHsvOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimension",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionDefault",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionEqual",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionEqualOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionGreaterThan",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionGreaterThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionLessThan",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionLessThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationDefault",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationLandscape",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationLandscapeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationPortrait",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationPortraitOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationSquare",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationSquareOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanImQuery",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanImQueryList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanImQueryOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanMaxColors",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanMaxColorsList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanMaxColorsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanMirror",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanMirrorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanMirrorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanMonoHue",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanMonoHueList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanMonoHueOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanOpacity",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanOpacityList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanOpacityOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanRegionOfInterestCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanRegionOfInterestCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanRegionOfInterestCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanRegionOfInterestCropRegionOfInterest",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanRelativeCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanRelativeCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanRelativeCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanRemoveColor",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanRemoveColorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanRemoveColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanResize",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanResizeList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanResizeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanRotate",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanRotateList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanRotateOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanScale",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanScaleList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanScaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanShear",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanShearList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanShearOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanTrim",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanTrimList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanTrimOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanUnsharpMask",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanUnsharpMaskList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanUnsharpMaskOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThan",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanAppend",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanAppendImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanAppendImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanAppendList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanAppendOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanAspectCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanAspectCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanAspectCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanBackgroundColor",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanBackgroundColorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanBackgroundColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanBlur",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanBlurList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanBlurOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanChromaKey",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanChromaKeyList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanChromaKeyOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanComposite",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanCompositeImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanCompositeImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanCompositeList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanCompositeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanCompound",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanCompoundList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanCompoundOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanCompoundTransformations",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanCompoundTransformationsList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanCompoundTransformationsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanContrast",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanContrastList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanContrastOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanFaceCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanFaceCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanFaceCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanFeatureCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanFeatureCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanFeatureCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanFitAndFill",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanFitAndFillFillTransformation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanFitAndFillFillTransformationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanFitAndFillList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanFitAndFillOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanGoop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanGoopList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanGoopOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanGrayscale",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanGrayscaleList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanGrayscaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanHsl",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanHslList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanHslOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanHsv",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanHsvList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanHsvOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimension",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionDefault",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionEqual",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionEqualOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionGreaterThan",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionGreaterThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionLessThan",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionLessThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationDefault",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationLandscape",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationLandscapeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationPortrait",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationPortraitOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationSquare",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationSquareOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanImQuery",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanImQueryList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanImQueryOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanMaxColors",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanMaxColorsList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanMaxColorsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanMirror",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanMirrorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanMirrorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanMonoHue",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanMonoHueList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanMonoHueOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanOpacity",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanOpacityList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanOpacityOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanRegionOfInterestCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanRegionOfInterestCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanRegionOfInterestCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanRegionOfInterestCropRegionOfInterest",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanRegionOfInterestCropRegionOfInterestOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanRelativeCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanRelativeCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanRelativeCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanRemoveColor",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanRemoveColorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanRemoveColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanResize",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanResizeList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanResizeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanRotate",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanRotateList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanRotateOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanScale",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanScaleList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanScaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanShear",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanShearList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanShearOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanTrim",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanTrimList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanTrimOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanUnsharpMask",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanUnsharpMaskList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionLessThanUnsharpMaskOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeImQuery",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeImQueryList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeImQueryOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeMaxColors",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeMaxColorsList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeMaxColorsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeMirror",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeMirrorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeMirrorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeMonoHue",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeMonoHueList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeMonoHueOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeOpacity",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeOpacityList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeOpacityOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterest",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestCircleShape",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestCircleShapeCenter",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestCircleShapeCenterOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestCircleShapeList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestCircleShapeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestPointShape",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestPointShapeList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestPointShapeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestPolygonShape",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestPolygonShapeList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestPolygonShapeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestPolygonShapePoints",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestPolygonShapePointsList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestPolygonShapePointsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestRectangleShape",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestRectangleShapeAnchor",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestRectangleShapeAnchorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestRectangleShapeList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestRectangleShapeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestUnionShape",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestUnionShapeList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestUnionShapeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestUnionShapeShapes",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestUnionShapeShapesList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRegionOfInterestCropRegionOfInterestUnionShapeShapesOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRelativeCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRelativeCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRelativeCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRemoveColor",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRemoveColorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRemoveColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeResize",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeResizeList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeResizeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRotate",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRotateList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeRotateOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeScale",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeScaleList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeScaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeShear",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeShearList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeShearOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeTrim",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeTrimList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeTrimOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeUnsharpMask",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeUnsharpMaskList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeUnsharpMaskOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortrait",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppend",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageBoxImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageBoxImageList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageBoxImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageBoxImageTransformation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageBoxImageTransformationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageCircleImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageCircleImageList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageCircleImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageCircleImageTransformation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageCircleImageTransformationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageTextImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageTextImageList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageTextImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageTextImageTransformation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageTextImageTransformationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageUrlImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageUrlImageList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageUrlImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageUrlImageTransformation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendImageUrlImageTransformationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAppendOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAspectCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAspectCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitAspectCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitBackgroundColor",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitBackgroundColorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitBackgroundColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitBlur",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitBlurList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitBlurOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitChromaKey",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitChromaKeyList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitChromaKeyOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitComposite",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageBoxImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageBoxImageList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageBoxImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageBoxImageTransformation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageBoxImageTransformationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageCircleImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageCircleImageList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageCircleImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageCircleImageTransformation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageCircleImageTransformationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageTextImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageTextImageList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageTextImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageTextImageTransformation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageTextImageTransformationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageUrlImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageUrlImageList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageUrlImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageUrlImageTransformation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeImageUrlImageTransformationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompositeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompound",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompoundList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCompoundOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitContrast",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitContrastList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitContrastOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFaceCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFaceCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFaceCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFeatureCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFeatureCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFeatureCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFill",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationAppend",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationAppendImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationAppendImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationAppendList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationAppendOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationAspectCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationAspectCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationAspectCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationBackgroundColor",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationBackgroundColorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationBackgroundColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationBlur",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationBlurList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationBlurOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationChromaKey",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationChromaKeyList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationChromaKeyOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationComposite",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationCompositeImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationCompositeImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationCompositeList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationCompositeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationCompound",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationCompoundList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationCompoundOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationCompoundTransformations",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationCompoundTransformationsList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationCompoundTransformationsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationContrast",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationContrastList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationContrastOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationFaceCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationFaceCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationFaceCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationFeatureCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationFeatureCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationFeatureCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationFitAndFill",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationFitAndFillFillTransformation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationFitAndFillFillTransformationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationFitAndFillList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationFitAndFillOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationGoop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationGoopList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationGoopOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationGrayscale",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationGrayscaleList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationGrayscaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationHsl",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationHslList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationHslOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationHsv",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationHsvList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationHsvOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfDimension",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfDimensionDefault",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfDimensionDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfDimensionEqual",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfDimensionEqualOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfDimensionGreaterThan",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfDimensionGreaterThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfDimensionLessThan",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfDimensionLessThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfDimensionList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfDimensionOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfOrientation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfOrientationDefault",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfOrientationDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfOrientationLandscape",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfOrientationLandscapeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfOrientationList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfOrientationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfOrientationPortrait",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfOrientationPortraitOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfOrientationSquare",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationIfOrientationSquareOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationImQuery",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationImQueryList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationImQueryOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationMaxColors",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationMaxColorsList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationMaxColorsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationMirror",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationMirrorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationMirrorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationMonoHue",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationMonoHueList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationMonoHueOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationOpacity",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationOpacityList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationOpacityOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationRegionOfInterestCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationRegionOfInterestCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationRegionOfInterestCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationRegionOfInterestCropRegionOfInterest",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationRelativeCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationRelativeCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationRelativeCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationRemoveColor",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationRemoveColorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationRemoveColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationResize",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationResizeList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationResizeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationRotate",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationRotateList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationRotateOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationScale",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationScaleList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationScaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationShear",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationShearList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationShearOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationTrim",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationTrimList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationTrimOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationUnsharpMask",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationUnsharpMaskList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillFillTransformationUnsharpMaskOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitFitAndFillOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitGoop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitGoopList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitGoopOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitGrayscale",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitGrayscaleList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitGrayscaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitHsl",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitHslList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitHslOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitHsv",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitHsvList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitHsvOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimension",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefault",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultAppend",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultAppendImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultAppendImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultAppendList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultAppendOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultAspectCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultAspectCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultAspectCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultBackgroundColor",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultBackgroundColorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultBackgroundColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultBlur",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultBlurList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultBlurOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultChromaKey",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultChromaKeyList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultChromaKeyOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultComposite",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultCompositeImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultCompositeImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultCompositeList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultCompositeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultCompound",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultCompoundList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultCompoundOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultCompoundTransformations",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultCompoundTransformationsList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultCompoundTransformationsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultContrast",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultContrastList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultContrastOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultFaceCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultFaceCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultFaceCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultFeatureCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultFeatureCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultFeatureCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultFitAndFill",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultFitAndFillFillTransformation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultFitAndFillFillTransformationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultFitAndFillList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultFitAndFillOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultGoop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultGoopList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultGoopOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultGrayscale",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultGrayscaleList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultGrayscaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultHsl",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultHslList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultHslOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultHsv",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultHsvList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultHsvOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfDimension",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionDefault",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionEqual",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionEqualOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionGreaterThan",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionGreaterThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionLessThan",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionLessThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationDefault",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationLandscape",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationLandscapeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationPortrait",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationPortraitOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationSquare",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationSquareOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultImQuery",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultImQueryList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultImQueryOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultMaxColors",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultMaxColorsList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultMaxColorsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultMirror",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultMirrorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultMirrorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultMonoHue",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultMonoHueList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultMonoHueOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultOpacity",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultOpacityList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultOpacityOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultRegionOfInterestCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultRegionOfInterestCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultRegionOfInterestCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultRegionOfInterestCropRegionOfInterest",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultRegionOfInterestCropRegionOfInterestOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultRelativeCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultRelativeCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultRelativeCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultRemoveColor",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultRemoveColorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultRemoveColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultResize",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultResizeList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultResizeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultRotate",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultRotateList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultRotateOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultScale",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultScaleList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultScaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultShear",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultShearList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultShearOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultTrim",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultTrimList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultTrimOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultUnsharpMask",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultUnsharpMaskList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionDefaultUnsharpMaskOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqual",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualAppend",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualAppendImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualAppendImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualAppendList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualAppendOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualAspectCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualAspectCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualAspectCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualBackgroundColor",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualBackgroundColorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualBackgroundColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualBlur",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualBlurList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualBlurOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualChromaKey",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualChromaKeyList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualChromaKeyOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualComposite",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualCompositeImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualCompositeImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualCompositeList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualCompositeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualCompound",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualCompoundList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualCompoundOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualCompoundTransformations",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualCompoundTransformationsList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualCompoundTransformationsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualContrast",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualContrastList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualContrastOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualFaceCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualFaceCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualFaceCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualFeatureCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualFeatureCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualFeatureCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualFitAndFill",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualFitAndFillFillTransformation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualFitAndFillFillTransformationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualFitAndFillList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualFitAndFillOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualGoop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualGoopList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualGoopOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualGrayscale",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualGrayscaleList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualGrayscaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualHsl",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualHslList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualHslOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualHsv",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualHsvList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualHsvOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfDimension",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionDefault",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionEqual",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionEqualOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionGreaterThan",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionGreaterThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionLessThan",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionLessThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfOrientation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationDefault",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationLandscape",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationLandscapeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationPortrait",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationPortraitOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationSquare",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationSquareOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualImQuery",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualImQueryList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualImQueryOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualMaxColors",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualMaxColorsList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualMaxColorsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualMirror",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualMirrorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualMirrorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualMonoHue",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualMonoHueList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualMonoHueOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualOpacity",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualOpacityList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualOpacityOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualRegionOfInterestCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualRegionOfInterestCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualRegionOfInterestCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualRegionOfInterestCropRegionOfInterest",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualRegionOfInterestCropRegionOfInterestOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualRelativeCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualRelativeCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualRelativeCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualRemoveColor",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualRemoveColorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualRemoveColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualResize",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualResizeList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualResizeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualRotate",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualRotateList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualRotateOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualScale",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualScaleList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualScaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualShear",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualShearList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualShearOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualTrim",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualTrimList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualTrimOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualUnsharpMask",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualUnsharpMaskList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionEqualUnsharpMaskOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThan",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanAppend",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanAppendImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanAppendImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanAppendList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanAppendOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanAspectCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanAspectCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanAspectCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanBackgroundColor",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanBackgroundColorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanBackgroundColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanBlur",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanBlurList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanBlurOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanChromaKey",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanChromaKeyList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanChromaKeyOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanComposite",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanCompositeImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanCompositeImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanCompositeList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanCompositeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanCompound",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanCompoundList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanCompoundOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanCompoundTransformations",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanCompoundTransformationsList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanCompoundTransformationsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanContrast",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanContrastList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanContrastOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanFaceCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanFaceCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanFaceCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanFeatureCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanFeatureCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanFeatureCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanFitAndFill",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanFitAndFillFillTransformation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanFitAndFillFillTransformationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanFitAndFillList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanFitAndFillOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanGoop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanGoopList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanGoopOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanGrayscale",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanGrayscaleList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanGrayscaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanHsl",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanHslList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanHslOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanHsv",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanHsvList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanHsvOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimension",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionDefault",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionEqual",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionEqualOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionGreaterThan",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionGreaterThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionLessThan",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionLessThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationDefault",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationLandscape",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationLandscapeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationPortrait",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationPortraitOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationSquare",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationSquareOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanImQuery",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanImQueryList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanImQueryOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanMaxColors",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanMaxColorsList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanMaxColorsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanMirror",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanMirrorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanMirrorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanMonoHue",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanMonoHueList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanMonoHueOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanOpacity",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanOpacityList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanOpacityOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanRegionOfInterestCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanRegionOfInterestCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanRegionOfInterestCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanRegionOfInterestCropRegionOfInterest",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanRelativeCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanRelativeCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanRelativeCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanRemoveColor",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanRemoveColorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanRemoveColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanResize",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanResizeList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanResizeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanRotate",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanRotateList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanRotateOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanScale",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanScaleList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanScaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanShear",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanShearList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanShearOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanTrim",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanTrimList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanTrimOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanUnsharpMask",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanUnsharpMaskList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionGreaterThanUnsharpMaskOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThan",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanAppend",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanAppendImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanAppendImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanAppendList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanAppendOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanAspectCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanAspectCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanAspectCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanBackgroundColor",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanBackgroundColorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanBackgroundColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanBlur",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanBlurList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanBlurOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanChromaKey",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanChromaKeyList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanChromaKeyOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanComposite",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanCompositeImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanCompositeImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanCompositeList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanCompositeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanCompound",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanCompoundList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanCompoundOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanCompoundTransformations",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanCompoundTransformationsList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanCompoundTransformationsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanContrast",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanContrastList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanContrastOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanFaceCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanFaceCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanFaceCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanFeatureCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanFeatureCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanFeatureCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanFitAndFill",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanFitAndFillFillTransformation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanFitAndFillFillTransformationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanFitAndFillList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanFitAndFillOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanGoop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanGoopList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanGoopOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanGrayscale",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanGrayscaleList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanGrayscaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanHsl",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanHslList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanHslOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanHsv",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanHsvList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanHsvOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfDimension",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionDefault",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionEqual",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionEqualOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionGreaterThan",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionGreaterThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionLessThan",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionLessThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationDefault",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationLandscape",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationLandscapeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationPortrait",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationPortraitOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationSquare",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationSquareOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanImQuery",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanImQueryList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanImQueryOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanMaxColors",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanMaxColorsList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanMaxColorsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanMirror",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanMirrorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanMirrorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanMonoHue",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanMonoHueList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanMonoHueOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanOpacity",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanOpacityList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanOpacityOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanRegionOfInterestCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanRegionOfInterestCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanRegionOfInterestCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanRegionOfInterestCropRegionOfInterest",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanRegionOfInterestCropRegionOfInterestOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanRelativeCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanRelativeCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanRelativeCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanRemoveColor",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanRemoveColorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanRemoveColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanResize",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanResizeList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanResizeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanRotate",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanRotateList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanRotateOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanScale",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanScaleList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanScaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanShear",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanShearList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanShearOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanTrim",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanTrimList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanTrimOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanUnsharpMask",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanUnsharpMaskList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionLessThanUnsharpMaskOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitIfDimensionOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitImQuery",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitImQueryList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitImQueryOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitMaxColors",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitMaxColorsList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitMaxColorsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitMirror",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitMirrorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitMirrorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitMonoHue",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitMonoHueList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitMonoHueOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitOpacity",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitOpacityList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitOpacityOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterest",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestCircleShape",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestCircleShapeCenter",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestCircleShapeCenterOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestCircleShapeList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestCircleShapeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestPointShape",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestPointShapeList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestPointShapeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestPolygonShape",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestPolygonShapeList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestPolygonShapeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestPolygonShapePoints",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestPolygonShapePointsList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestPolygonShapePointsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestRectangleShape",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestRectangleShapeAnchor",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestRectangleShapeAnchorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestRectangleShapeList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestRectangleShapeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestUnionShape",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestUnionShapeList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestUnionShapeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestUnionShapeShapes",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestUnionShapeShapesList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRegionOfInterestCropRegionOfInterestUnionShapeShapesOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRelativeCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRelativeCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRelativeCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRemoveColor",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRemoveColorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRemoveColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitResize",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitResizeList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitResizeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRotate",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRotateList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitRotateOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitScale",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitScaleList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitScaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitShear",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitShearList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitShearOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitTrim",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitTrimList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitTrimOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitUnsharpMask",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitUnsharpMaskList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationPortraitUnsharpMaskOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquare",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppend",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageBoxImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageBoxImageList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageBoxImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageBoxImageTransformation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageBoxImageTransformationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageCircleImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageCircleImageList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageCircleImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageCircleImageTransformation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageCircleImageTransformationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageTextImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageTextImageList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageTextImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageTextImageTransformation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageTextImageTransformationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageUrlImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageUrlImageList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageUrlImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageUrlImageTransformation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendImageUrlImageTransformationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAppendOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAspectCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAspectCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareAspectCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareBackgroundColor",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareBackgroundColorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareBackgroundColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareBlur",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareBlurList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareBlurOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareChromaKey",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareChromaKeyList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareChromaKeyOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareComposite",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageBoxImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageBoxImageList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageBoxImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageBoxImageTransformation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageBoxImageTransformationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageCircleImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageCircleImageList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageCircleImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageCircleImageTransformation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageCircleImageTransformationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageTextImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageTextImageList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageTextImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageTextImageTransformation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageTextImageTransformationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageUrlImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageUrlImageList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageUrlImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageUrlImageTransformation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeImageUrlImageTransformationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompositeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompound",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompoundList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCompoundOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareContrast",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareContrastList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareContrastOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFaceCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFaceCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFaceCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFeatureCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFeatureCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFeatureCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFill",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationAppend",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationAppendImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationAppendImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationAppendList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationAppendOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationAspectCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationAspectCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationAspectCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationBackgroundColor",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationBackgroundColorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationBackgroundColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationBlur",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationBlurList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationBlurOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationChromaKey",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationChromaKeyList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationChromaKeyOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationComposite",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationCompositeImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationCompositeImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationCompositeList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationCompositeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationCompound",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationCompoundList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationCompoundOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationCompoundTransformations",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationCompoundTransformationsList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationCompoundTransformationsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationContrast",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationContrastList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationContrastOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationFaceCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationFaceCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationFaceCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationFeatureCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationFeatureCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationFeatureCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationFitAndFill",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationFitAndFillFillTransformation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationFitAndFillFillTransformationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationFitAndFillList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationFitAndFillOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationGoop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationGoopList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationGoopOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationGrayscale",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationGrayscaleList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationGrayscaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationHsl",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationHslList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationHslOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationHsv",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationHsvList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationHsvOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfDimension",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfDimensionDefault",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfDimensionDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfDimensionEqual",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfDimensionEqualOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfDimensionGreaterThan",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfDimensionGreaterThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfDimensionLessThan",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfDimensionLessThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfDimensionList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfDimensionOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfOrientation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfOrientationDefault",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfOrientationDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfOrientationLandscape",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfOrientationLandscapeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfOrientationList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfOrientationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfOrientationPortrait",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfOrientationPortraitOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfOrientationSquare",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationIfOrientationSquareOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationImQuery",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationImQueryList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationImQueryOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationMaxColors",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationMaxColorsList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationMaxColorsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationMirror",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationMirrorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationMirrorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationMonoHue",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationMonoHueList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationMonoHueOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationOpacity",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationOpacityList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationOpacityOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationRegionOfInterestCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationRegionOfInterestCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationRegionOfInterestCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationRegionOfInterestCropRegionOfInterest",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationRegionOfInterestCropRegionOfInterestOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationRelativeCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationRelativeCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationRelativeCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationRemoveColor",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationRemoveColorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationRemoveColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationResize",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationResizeList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationResizeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationRotate",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationRotateList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationRotateOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationScale",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationScaleList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationScaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationShear",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationShearList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationShearOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationTrim",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationTrimList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationTrimOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationUnsharpMask",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationUnsharpMaskList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillFillTransformationUnsharpMaskOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareFitAndFillOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareGoop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareGoopList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareGoopOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareGrayscale",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareGrayscaleList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareGrayscaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareHsl",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareHslList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareHslOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareHsv",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareHsvList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareHsvOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimension",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefault",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultAppend",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultAppendImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultAppendImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultAppendList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultAppendOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultAspectCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultAspectCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultAspectCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultBackgroundColor",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultBackgroundColorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultBackgroundColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultBlur",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultBlurList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultBlurOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultChromaKey",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultChromaKeyList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultChromaKeyOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultComposite",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultCompositeImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultCompositeImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultCompositeList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultCompositeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultCompound",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultCompoundList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultCompoundOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultCompoundTransformations",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultCompoundTransformationsList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultCompoundTransformationsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultContrast",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultContrastList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultContrastOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultFaceCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultFaceCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultFaceCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultFeatureCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultFeatureCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultFeatureCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultFitAndFill",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultFitAndFillFillTransformation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultFitAndFillFillTransformationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultFitAndFillList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultFitAndFillOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultGoop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultGoopList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultGoopOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultGrayscale",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultGrayscaleList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultGrayscaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultHsl",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultHslList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultHslOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultHsv",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultHsvList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultHsvOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfDimension",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionDefault",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionEqual",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionEqualOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionGreaterThan",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionGreaterThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionLessThan",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionLessThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfOrientation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationDefault",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationLandscape",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationLandscapeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationPortrait",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationPortraitOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationSquare",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationSquareOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultImQuery",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultImQueryList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultImQueryOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultMaxColors",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultMaxColorsList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultMaxColorsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultMirror",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultMirrorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultMirrorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultMonoHue",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultMonoHueList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultMonoHueOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultOpacity",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultOpacityList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultOpacityOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultRegionOfInterestCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultRegionOfInterestCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultRegionOfInterestCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultRegionOfInterestCropRegionOfInterest",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultRegionOfInterestCropRegionOfInterestOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultRelativeCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultRelativeCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultRelativeCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultRemoveColor",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultRemoveColorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultRemoveColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultResize",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultResizeList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultResizeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultRotate",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultRotateList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultRotateOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultScale",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultScaleList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultScaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultShear",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultShearList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultShearOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultTrim",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultTrimList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultTrimOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultUnsharpMask",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultUnsharpMaskList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionDefaultUnsharpMaskOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqual",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualAppend",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualAppendImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualAppendImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualAppendList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualAppendOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualAspectCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualAspectCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualAspectCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualBackgroundColor",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualBackgroundColorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualBackgroundColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualBlur",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualBlurList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualBlurOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualChromaKey",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualChromaKeyList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualChromaKeyOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualComposite",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualCompositeImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualCompositeImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualCompositeList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualCompositeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualCompound",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualCompoundList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualCompoundOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualCompoundTransformations",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualCompoundTransformationsList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualCompoundTransformationsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualContrast",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualContrastList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualContrastOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualFaceCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualFaceCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualFaceCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualFeatureCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualFeatureCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualFeatureCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualFitAndFill",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualFitAndFillFillTransformation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualFitAndFillFillTransformationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualFitAndFillList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualFitAndFillOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualGoop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualGoopList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualGoopOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualGrayscale",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualGrayscaleList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualGrayscaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualHsl",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualHslList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualHslOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualHsv",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualHsvList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualHsvOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfDimension",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfDimensionDefault",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfDimensionDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfDimensionEqual",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfDimensionEqualOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfDimensionGreaterThan",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfDimensionGreaterThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfDimensionLessThan",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfDimensionLessThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfDimensionList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfDimensionOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfOrientation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfOrientationDefault",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfOrientationDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfOrientationLandscape",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfOrientationLandscapeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfOrientationList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfOrientationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfOrientationPortrait",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfOrientationPortraitOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfOrientationSquare",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualIfOrientationSquareOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualImQuery",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualImQueryList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualImQueryOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualMaxColors",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualMaxColorsList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualMaxColorsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualMirror",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualMirrorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualMirrorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualMonoHue",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualMonoHueList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualMonoHueOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualOpacity",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualOpacityList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualOpacityOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualRegionOfInterestCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualRegionOfInterestCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualRegionOfInterestCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualRegionOfInterestCropRegionOfInterest",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualRegionOfInterestCropRegionOfInterestOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualRelativeCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualRelativeCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualRelativeCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualRemoveColor",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualRemoveColorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualRemoveColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualResize",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualResizeList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualResizeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualRotate",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualRotateList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualRotateOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualScale",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualScaleList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualScaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualShear",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualShearList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualShearOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualTrim",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualTrimList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualTrimOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualUnsharpMask",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualUnsharpMaskList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionEqualUnsharpMaskOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThan",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanAppend",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanAppendImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanAppendImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanAppendList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanAppendOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanAspectCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanAspectCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanAspectCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanBackgroundColor",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanBackgroundColorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanBackgroundColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanBlur",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanBlurList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanBlurOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanChromaKey",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanChromaKeyList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanChromaKeyOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanComposite",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanCompositeImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanCompositeImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanCompositeList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanCompositeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanCompound",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanCompoundList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanCompoundOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanCompoundTransformations",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanCompoundTransformationsList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanCompoundTransformationsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanContrast",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanContrastList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanContrastOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanFaceCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanFaceCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanFaceCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanFeatureCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanFeatureCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanFeatureCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanFitAndFill",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanFitAndFillFillTransformation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanFitAndFillFillTransformationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanFitAndFillList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanFitAndFillOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanGoop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanGoopList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanGoopOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanGrayscale",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanGrayscaleList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanGrayscaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanHsl",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanHslList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanHslOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanHsv",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanHsvList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanHsvOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimension",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionDefault",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionEqual",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionEqualOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionGreaterThan",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionGreaterThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionLessThan",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionLessThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationDefault",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationLandscape",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationLandscapeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationPortrait",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationPortraitOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationSquare",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationSquareOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanImQuery",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanImQueryList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanImQueryOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanMaxColors",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanMaxColorsList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanMaxColorsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanMirror",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanMirrorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanMirrorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanMonoHue",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanMonoHueList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanMonoHueOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanOpacity",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanOpacityList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanOpacityOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanRegionOfInterestCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanRegionOfInterestCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanRegionOfInterestCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanRegionOfInterestCropRegionOfInterest",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanRegionOfInterestCropRegionOfInterestOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanRelativeCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanRelativeCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanRelativeCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanRemoveColor",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanRemoveColorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanRemoveColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanResize",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanResizeList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanResizeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanRotate",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanRotateList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanRotateOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanScale",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanScaleList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanScaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanShear",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanShearList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanShearOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanTrim",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanTrimList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanTrimOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanUnsharpMask",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanUnsharpMaskList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionGreaterThanUnsharpMaskOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThan",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanAppend",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanAppendImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanAppendImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanAppendList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanAppendOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanAspectCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanAspectCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanAspectCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanBackgroundColor",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanBackgroundColorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanBackgroundColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanBlur",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanBlurList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanBlurOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanChromaKey",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanChromaKeyList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanChromaKeyOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanComposite",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanCompositeImage",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanCompositeImageOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanCompositeList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanCompositeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanCompound",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanCompoundList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanCompoundOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanCompoundTransformations",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanCompoundTransformationsList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanCompoundTransformationsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanContrast",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanContrastList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanContrastOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanFaceCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanFaceCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanFaceCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanFeatureCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanFeatureCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanFeatureCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanFitAndFill",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanFitAndFillFillTransformation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanFitAndFillFillTransformationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanFitAndFillList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanFitAndFillOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanGoop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanGoopList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanGoopOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanGrayscale",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanGrayscaleList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanGrayscaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanHsl",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanHslList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanHslOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanHsv",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanHsvList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanHsvOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfDimension",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionDefault",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionEqual",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionEqualOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionGreaterThan",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionGreaterThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionLessThan",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionLessThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfOrientation",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationDefault",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationDefaultOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationLandscape",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationLandscapeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationPortrait",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationPortraitOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationSquare",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationSquareOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanImQuery",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanImQueryList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanImQueryOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanMaxColors",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanMaxColorsList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanMaxColorsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanMirror",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanMirrorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanMirrorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanMonoHue",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanMonoHueList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanMonoHueOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanOpacity",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanOpacityList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanOpacityOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanRegionOfInterestCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanRegionOfInterestCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanRegionOfInterestCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanRegionOfInterestCropRegionOfInterest",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanRegionOfInterestCropRegionOfInterestOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanRelativeCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanRelativeCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanRelativeCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanRemoveColor",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanRemoveColorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanRemoveColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanResize",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanResizeList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanResizeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanRotate",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanRotateList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanRotateOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanScale",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanScaleList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanScaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanShear",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanShearList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanShearOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanTrim",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanTrimList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanTrimOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanUnsharpMask",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanUnsharpMaskList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionLessThanUnsharpMaskOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareIfDimensionOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareImQuery",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareImQueryList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareImQueryOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareMaxColors",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareMaxColorsList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareMaxColorsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareMirror",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareMirrorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareMirrorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareMonoHue",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareMonoHueList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareMonoHueOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareOpacity",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareOpacityList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareOpacityOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterest",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestCircleShape",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestCircleShapeCenter",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestCircleShapeCenterOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestCircleShapeList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestCircleShapeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestPointShape",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestPointShapeList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestPointShapeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestPolygonShape",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestPolygonShapeList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestPolygonShapeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestPolygonShapePoints",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestPolygonShapePointsList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestPolygonShapePointsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestRectangleShape",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestRectangleShapeAnchor",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestRectangleShapeAnchorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestRectangleShapeList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestRectangleShapeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestUnionShape",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestUnionShapeList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestUnionShapeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestUnionShapeShapes",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestUnionShapeShapesList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRegionOfInterestCropRegionOfInterestUnionShapeShapesOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRelativeCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRelativeCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRelativeCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRemoveColor",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRemoveColorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRemoveColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareResize",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareResizeList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareResizeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRotate",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRotateList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareRotateOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareScale",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareScaleList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareScaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareShear",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareShearList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareShearOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareTrim",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareTrimList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareTrimOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareUnsharpMask",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareUnsharpMaskList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationSquareUnsharpMaskOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsImQuery",
    "DataAkamaiImagingPolicyImagePolicyTransformationsImQueryList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsImQueryOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsMaxColors",
    "DataAkamaiImagingPolicyImagePolicyTransformationsMaxColorsList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsMaxColorsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsMirror",
    "DataAkamaiImagingPolicyImagePolicyTransformationsMirrorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsMirrorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsMonoHue",
    "DataAkamaiImagingPolicyImagePolicyTransformationsMonoHueList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsMonoHueOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsOpacity",
    "DataAkamaiImagingPolicyImagePolicyTransformationsOpacityList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsOpacityOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterest",
    "DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestCircleShape",
    "DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestCircleShapeCenter",
    "DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestCircleShapeCenterOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestCircleShapeList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestCircleShapeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestPointShape",
    "DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestPointShapeList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestPointShapeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestPolygonShape",
    "DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestPolygonShapeList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestPolygonShapeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestPolygonShapePoints",
    "DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestPolygonShapePointsList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestPolygonShapePointsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestRectangleShape",
    "DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestRectangleShapeAnchor",
    "DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestRectangleShapeAnchorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestRectangleShapeList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestRectangleShapeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShape",
    "DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapes",
    "DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesCircleShape",
    "DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesCircleShapeCenter",
    "DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesCircleShapeCenterOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesCircleShapeList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesCircleShapeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesPointShape",
    "DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesPointShapeList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesPointShapeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesPolygonShape",
    "DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesPolygonShapeList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesPolygonShapeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesPolygonShapePoints",
    "DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesPolygonShapePointsList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesPolygonShapePointsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesRectangleShape",
    "DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesRectangleShapeAnchor",
    "DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesRectangleShapeAnchorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesRectangleShapeList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesRectangleShapeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesUnionShape",
    "DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesUnionShapeList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesUnionShapeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesUnionShapeShapes",
    "DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesUnionShapeShapesList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCropRegionOfInterestUnionShapeShapesUnionShapeShapesOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsRelativeCrop",
    "DataAkamaiImagingPolicyImagePolicyTransformationsRelativeCropList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsRelativeCropOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsRemoveColor",
    "DataAkamaiImagingPolicyImagePolicyTransformationsRemoveColorList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsRemoveColorOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsResize",
    "DataAkamaiImagingPolicyImagePolicyTransformationsResizeList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsResizeOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsRotate",
    "DataAkamaiImagingPolicyImagePolicyTransformationsRotateList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsRotateOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsScale",
    "DataAkamaiImagingPolicyImagePolicyTransformationsScaleList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsScaleOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsShear",
    "DataAkamaiImagingPolicyImagePolicyTransformationsShearList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsShearOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsTrim",
    "DataAkamaiImagingPolicyImagePolicyTransformationsTrimList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsTrimOutputReference",
    "DataAkamaiImagingPolicyImagePolicyTransformationsUnsharpMask",
    "DataAkamaiImagingPolicyImagePolicyTransformationsUnsharpMaskList",
    "DataAkamaiImagingPolicyImagePolicyTransformationsUnsharpMaskOutputReference",
    "DataAkamaiImagingPolicyImagePolicyVariables",
    "DataAkamaiImagingPolicyImagePolicyVariablesEnumOptions",
    "DataAkamaiImagingPolicyImagePolicyVariablesEnumOptionsList",
    "DataAkamaiImagingPolicyImagePolicyVariablesEnumOptionsOutputReference",
    "DataAkamaiImagingPolicyImagePolicyVariablesList",
    "DataAkamaiImagingPolicyImagePolicyVariablesOutputReference",
]

publication.publish()

def _typecheckingstub__fa67c1d35fafc500927c6cfd2ed6b5a56b41b20dc0efa603a18f43fcb542e636(
    scope: _constructs_77d1e7e8.Construct,
    id_: builtins.str,
    *,
    policy: typing.Union[DataAkamaiImagingPolicyImagePolicy, typing.Dict[builtins.str, typing.Any]],
    id: typing.Optional[builtins.str] = None,
    connection: typing.Optional[typing.Union[typing.Union[_cdktf_9a9027ec.SSHProvisionerConnection, typing.Dict[builtins.str, typing.Any]], typing.Union[_cdktf_9a9027ec.WinrmProvisionerConnection, typing.Dict[builtins.str, typing.Any]]]] = None,
    count: typing.Optional[typing.Union[jsii.Number, _cdktf_9a9027ec.TerraformCount]] = None,
    depends_on: typing.Optional[typing.Sequence[_cdktf_9a9027ec.ITerraformDependable]] = None,
    for_each: typing.Optional[_cdktf_9a9027ec.ITerraformIterator] = None,
    lifecycle: typing.Optional[typing.Union[_cdktf_9a9027ec.TerraformResourceLifecycle, typing.Dict[builtins.str, typing.Any]]] = None,
    provider: typing.Optional[_cdktf_9a9027ec.TerraformProvider] = None,
    provisioners: typing.Optional[typing.Sequence[typing.Union[typing.Union[_cdktf_9a9027ec.FileProvisioner, typing.Dict[builtins.str, typing.Any]], typing.Union[_cdktf_9a9027ec.LocalExecProvisioner, typing.Dict[builtins.str, typing.Any]], typing.Union[_cdktf_9a9027ec.RemoteExecProvisioner, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__12208aeca9df727eca81de92357d1ca9e98355f64090f7e76a6846ca2fe8f6c6(
    scope: _constructs_77d1e7e8.Construct,
    import_to_id: builtins.str,
    import_from_id: builtins.str,
    provider: typing.Optional[_cdktf_9a9027ec.TerraformProvider] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b930b5b17ea8b3d384536756bae63dec69e365cdbb040e79df56b4d6973e1ae6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d8d7cdf78b038e598e98235478653ac3d6f5d113341fbb6b0a3926758360e960(
    *,
    connection: typing.Optional[typing.Union[typing.Union[_cdktf_9a9027ec.SSHProvisionerConnection, typing.Dict[builtins.str, typing.Any]], typing.Union[_cdktf_9a9027ec.WinrmProvisionerConnection, typing.Dict[builtins.str, typing.Any]]]] = None,
    count: typing.Optional[typing.Union[jsii.Number, _cdktf_9a9027ec.TerraformCount]] = None,
    depends_on: typing.Optional[typing.Sequence[_cdktf_9a9027ec.ITerraformDependable]] = None,
    for_each: typing.Optional[_cdktf_9a9027ec.ITerraformIterator] = None,
    lifecycle: typing.Optional[typing.Union[_cdktf_9a9027ec.TerraformResourceLifecycle, typing.Dict[builtins.str, typing.Any]]] = None,
    provider: typing.Optional[_cdktf_9a9027ec.TerraformProvider] = None,
    provisioners: typing.Optional[typing.Sequence[typing.Union[typing.Union[_cdktf_9a9027ec.FileProvisioner, typing.Dict[builtins.str, typing.Any]], typing.Union[_cdktf_9a9027ec.LocalExecProvisioner, typing.Dict[builtins.str, typing.Any]], typing.Union[_cdktf_9a9027ec.RemoteExecProvisioner, typing.Dict[builtins.str, typing.Any]]]]] = None,
    policy: typing.Union[DataAkamaiImagingPolicyImagePolicy, typing.Dict[builtins.str, typing.Any]],
    id: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2c1b3a76e154edd3464ad8e197ec85a4e1e0747d79aea73d07f128eacae44a2d(
    *,
    breakpoints: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyBreakpoints, typing.Dict[builtins.str, typing.Any]]] = None,
    hosts: typing.Optional[typing.Sequence[builtins.str]] = None,
    output: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyOutput, typing.Dict[builtins.str, typing.Any]]] = None,
    post_breakpoint_transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformations, typing.Dict[builtins.str, typing.Any]]]]] = None,
    rollout_duration: typing.Optional[builtins.str] = None,
    serve_stale_duration: typing.Optional[builtins.str] = None,
    transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformations, typing.Dict[builtins.str, typing.Any]]]]] = None,
    variables: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyVariables, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__477bd190572fab7b7278674e6e4fcd87f8266b73b0b91e6749371f80d1fbece3(
    *,
    widths: typing.Optional[typing.Sequence[jsii.Number]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__594b130aa84b81dc1fc3b006bf83dddda4a0858060150b97ce080ca11c8b7568(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f1a3cca8ecef95116dc959890ebcbca3aeeb93a391032e31db8c1b25ec6e751(
    value: typing.List[jsii.Number],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__379aa6372b50c29089fa535ed9872904f1d31137509a34519d92d60459e5b817(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyBreakpoints],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f4d1d604f1cc694898a17245fce9fd53f5a65ede319a256a9964a9dcfc9dc34(
    *,
    adaptive_quality: typing.Optional[builtins.str] = None,
    allowed_formats: typing.Optional[typing.Sequence[builtins.str]] = None,
    allow_pristine_on_downsize: typing.Optional[builtins.str] = None,
    forced_formats: typing.Optional[typing.Sequence[builtins.str]] = None,
    perceptual_quality: typing.Optional[builtins.str] = None,
    perceptual_quality_floor: typing.Optional[builtins.str] = None,
    perceptual_quality_var: typing.Optional[builtins.str] = None,
    prefer_modern_formats: typing.Optional[builtins.str] = None,
    quality: typing.Optional[builtins.str] = None,
    quality_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cb8c7ae57fcbc8a210b6f919669723cb78ee9c6d2bcec3d57c4d8dbf93f690ba(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7e82c87e485e4458f45a26dae70ae9bd4102d31daa461982a90ea71a34a2b2ca(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9865feec89c557fd6ee787a4752c5fb1b5f0b7d2498926e1bc9adec256dcd1c0(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5cbb7b53383b4afbe3c1f4effc2f035b57b24fbc5cfeeac72185b979abd63b10(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a8d8e2b92099ce70c6cec999cfabff256f5eb0ace25dfcf743c8675da930b03(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d570a44457842ba89bbbee1079810dc7bc3c7f6980be042b746a1e57be7189d4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f20de6facc1442aabf78e216d6378e6f042b5cd0eb4c37d0b468e3c470886334(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__38566ea236a4a1b8c34138798baa44288c486ea9066b611276f07f4f2edb839f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fd49b222dd1f8a79ace3940442e0e26f7152efa375c8775bc559d83d4820ea42(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8478235b2fbe4d9092bf5b5f00d700180345840ece943a1506a6d476953d3813(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a7e2fe17b00172a513eb5d1de2a7e91180d21ca24d6d5a735637cc76bc844963(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__90391d6b3e07b93c300d416f0f5d592cc70cc7a96f3f8ed3545b228b0a9e0be5(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyOutput],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2e57fe01c1c2ef852e84bd23913a18be40aa9b63c44f88b06fe7d5cfa89b1770(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df7417ffb42a9ac5a522db56d5f2740bd9bc543918c51d2e11c03b34cd48fc4b(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformations, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e473e31d417c6339ff05fc3d507c7176badbd9b5b1504b13787ab32fff33ae2c(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformations, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4d5d0ac517fecc025e0e5c66885da8b53c32fb543fe4f65da42469772398c57d(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyVariables, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3bd1f551bad641b8d4f7c27b878a5e8004d426379f58cba3e59e1f9bc88cabb3(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8301bbd82fd533487fb6feb8acbd44fe2068b7d2d3a5f910351b1cfead682e9c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7673294f5bdc7f8084acf97c74cf54710f4587ed6bc41df220b81305f5bccefb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__62e9b5a7cd4a7c197844b1666787df30dd43c8c34ffdab75af9760313ff310d5(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicy],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8beb93906b00713bc3abdfa02ab3d41b996448f7e228f5fd0da288c2d0611b11(
    *,
    background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
    chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
    composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
    compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
    contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
    goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
    max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
    opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
    remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__976d40ac512762121b9a06c4c05641195b5ae224d696e0418c134298024140df(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a9fd2b0eff845a2649d2bf0e03f7d2e79460ba3dadd02d382b6feed79411538(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__86da6f9a53bc6e0c1665d60428e392b2e12938e8a5f131a5eb15aadbe76c197e(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cbe2fbe167543f9da42392e55b8c564b1f92664f4592d6bb1efbc709d9b1f01e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fdc2de47033188fcc8c919664e5857001972d1ad3764061b643ec38b3c3833a5(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d8e195cc06c2ceec73b93b3d4ec05ec4b5a162e3c84e9d054db3dea8aee33190(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__16b63b565b615b8aa4246f8f5fb8667649ee036df1908f245128556b5a7b8feb(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsBackgroundColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__65d1b82a6e78ecb32be58ba02bc6eeafc762f28eec45479f2a290c08a39805b7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a60252d25462107435bc0bc03928c82a9e6e0d9536f93c809b9bf1591f2ba1f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ef5f68b12adea26df6d251fe32ccd8fad9214ba4de2722ca25eff41984e77eff(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__60962546c8480862e300b3efb581fa72368c3a7ec97f453195d0a4efb65fb08d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsBackgroundColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f28fcf4d90c1211834e669ae4fecff33a72a57d5e5c7c9903e9ef863a3822e7b(
    *,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a01703b61e9ed537ef90b54334bb95d556e5be475b78f3dc7f3369cba16c4be8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6504f0be5949718275273fafb98de7df93d6f54ac2681919342974313c8b9f5d(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ef5a783bd3c4b7bd8778bb59609e90003cd84f447739941481ff0f64db23cd1a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b243ec7f2c0c0de3d5a31ec7e5ec15bc4d1da9275372becb0fa151f7b7a9a2c9(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4dee906bb90210e80f4eb5e5cef6305f92187ec34b73b6eb0427dda8059aae6e(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e6d4dfd92ad03e0778740291f4405bee32e32814890e3637a5074583e2c9f7f2(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsBlur]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__83fcc61d131f68b4390387f73d802f6eeaf1a2b1e6d9b0f51a06611850731960(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f92388c2a790f956e1891e1fc34d0661649d1998e0e0a05f1302109585e9679e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__497ff54eaaf14391c35c84d6bcffd9be1f294827f30972f11c2f0931e514809e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d0cbf67a0d37689bef2899544aaea315be1fd2c0e2fe8344c2f436b662d2f6ec(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsBlur]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3537e283ef6378332e02ae28a8b34504f6ff29416f837eab551064b4af914a12(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_feather: typing.Optional[builtins.str] = None,
    hue_feather_var: typing.Optional[builtins.str] = None,
    hue_tolerance: typing.Optional[builtins.str] = None,
    hue_tolerance_var: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness_feather: typing.Optional[builtins.str] = None,
    lightness_feather_var: typing.Optional[builtins.str] = None,
    lightness_tolerance: typing.Optional[builtins.str] = None,
    lightness_tolerance_var: typing.Optional[builtins.str] = None,
    saturation_feather: typing.Optional[builtins.str] = None,
    saturation_feather_var: typing.Optional[builtins.str] = None,
    saturation_tolerance: typing.Optional[builtins.str] = None,
    saturation_tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3c7fed91cfd2a685ae7db944076a50f77402053c5946931ecb6046d45dce7720(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__79b7062e73057ce589281ea00f5221d31c838570c971188a9d19efd0f30d02e0(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__00eeb6b020e4649506bc6475c7c905a90c8099b082d1567df2f722d8cc306432(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__26a89787f3e8c1a9a36c49e921f1445d3fca856abb6e60f25e2cac2a85fd732d(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__84b2ccebf08ef35ae1991187423cb44c5c917a1a6f01741ab93a2c549c59f208(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cb001d39f0f613d1c04869c8ae1f12fddbc325e328c838f2215cd7440e6ac569(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsChromaKey]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__00e5decc2fbeee0260d3807595c4f0dc5d078c43bcd8d171ff297d5771c74ece(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1cb8d60be6c6e690bfadd2d8e0446209d3baa3e9f0e705425ffe5f722943d67c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7a6e56bba1033f6f68e19754e27a03f38c17afa5f40f5556b82c5fa3d84444b5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f07eba4078fe1eb65d23db0b86bc9b5937af7d5bb08b7c278bf08f841802e505(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__884d509e1c8720b64d9a977325b611fd12f4829e13494e8f7c890d880b620daa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__25ad86e2c526ed3800843a91296ccc42d7d04d6f3daba072dc9aaa903e1dedf5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3081b58925fceb00a3c28a45a1187e88435539e4ae5461567ecf6d4b67ab38ef(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cb72462616f7baf88a50794c56836cef7432046717084bb76d15f67d49f1ea3f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1492e21dea319a9d3f9b5de467a2a671aa55a83fb9e61e5a58452e9abbc921f4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__90b75488b132f5f9ade340f0fb9c644330611ebbd13252996af5a7990050d1fb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__205403a63e53b3439e220b34a47136338855cdb9c2952cd9070e44118c66811d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a263120ea55789f598e31b56fe8caa83336dbd35485600aaa3a8d3b9b19095aa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__31f64a49490be03a7c16e39051ce937cbe588368c7aa74a1a3deb292fd0f3d74(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d172c2830d9a258d2fc1e5309ad335aac86bed351180f4cb9a2ffe6f1c9a6e29(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6a669c504d218bc8b1d00f11e718aff85083f3d230a497d3ac8567bc02c185f4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f1e3b78a3fbffb3ec1b9a88fcacadc84edf2e7c55507149d3e731b2803d2e7f4(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsChromaKey]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c23de0ff5152b6b84ee6361f12bee30b53273acdb5601827ed5ca6f0d3bf003f(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    placement: typing.Optional[builtins.str] = None,
    placement_var: typing.Optional[builtins.str] = None,
    scale: typing.Optional[builtins.str] = None,
    scale_dimension: typing.Optional[builtins.str] = None,
    scale_dimension_var: typing.Optional[builtins.str] = None,
    scale_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a06c3cd53c47d16a8db647fb185fbf2095899595a2e4d1c07d68a6aeff0891b(
    *,
    box_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
    circle_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
    text_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
    url_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8f77b64cdb950bd2afa85377b18a87464c0bc9068e94e6a6d1899c4f9d401039(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    transformation: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__decc57ece0e7a5432f83856a2127a9fb5ab98d0cce93b0bcadd5888c00fda574(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__54f276a51b35c93f7f2ad3fff7affc66de34e60366841b24d48922c8e7216539(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cfd387d151d4efb58104e7e0b059c4456305e887eda96718f2734530f254d05e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d57a150c0c4bb4858d163c498830670f7e846d99e1ba2ff65ad19d00d618f757(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__998d6d4ad80374912244d6e7953fa89c7c817d97615c3fe244d92edb264aad88(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cb1e333d6ab73b6e75c67f1f1d1c120764594869762fc216fef2bbb681484bb1(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImage]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b565ce474ee8c65a018a5906b6cf00c46560598cdffc5a779698000d5ae85640(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__049a51a4f10c77d3bde60286d57e403da2cfa353b50a5d8a290b62f310dc5ca5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__efdfd4418d8f79f417a02b96e1cb271e72607082c477f0a72dfa7811d9ba9c17(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__237b22f610f5502358224fd96a6d590c485b902c14822fb807dedcee4f720f34(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4fbf2c678791697d5431435eb2b4e7e52614c26458de165c3f268bbebe0957a7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3d4bf41906f893a7b26324e546f05b8348bacd2a6855b57edaf45c7a5ef16344(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9b53dc277019a12406bca00b913a4327ef0db9e42759632fac329a98c38d2e7f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__909caf71150ea14c668198fd3e8794be16629634f62748121bbec70b83fc4b09(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImage]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a41e2d9f1b36900b603335110addc1fb8f74c03a3098f1495e539eadc77f46b(
    *,
    background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
    chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
    composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
    compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
    contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
    goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
    max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
    opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
    remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c7516b84ad9fbf9cb80181286ebf6d3e2308382de0193ba902fd570196a5d895(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__07126573444fd935b00c07e59174860a26e7dd487c006f52a5938f915bac90ce(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4f032ef2ec537a4f82ce8b951f58a98d351514e24d5e1547fee056bad6ebc1ed(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2e9d063b19845c2466f2d12d6c0e5a10aaa7e394f38b2e8760a9f94e1195c708(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5eddaed39bc85e60f57e155623977ffc75b0f9f74640598d7da3c8c7c9433c79(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c6a9433231242d549a81ef3bad8a1a671ed63cbe26e699e7bf6ea2bd967a19a9(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a51a1979c3eee534685168abad5f1c30ca4287bfbcc7838274bd4293bd9f214(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationBackgroundColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ceec05b3806a1b4f8b76cdd9f6cecc8f1ffd4e19304320ae83a3cde282a8b06(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a826a28fcaf9ff2969595096f2470a0fb98fa838ff7b1e686d3b61e14fc22f45(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f5ca294505f3c6d23518b391a523fcbf3e43b524a0c9bbaa02f7c9c8696ec565(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__19905e439b4b130735ae7fcc9f8132c9896653fa737629199f82c4b9ba4c6b48(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationBackgroundColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__024fbe2c4d6c3e20e049e0126adba8a3f6a39abcde9e074380cc99a7acdfb355(
    *,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c47f03ac290112c6e1490c3780e3869b315009a2b3a17e954288c0953cecc33d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c29e69359157c54e067979faf0475e28aad1de70cacbbd0e66f432095ab157ec(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__576aa4acb89ccf2e6f83ae3249de07de35b5b040db06c77b327e5e5ccaf97999(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__572e85357b6d0b0bbeff58a5d08546d3e4fcea863277e64f7b71cb62dfbde787(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8bd8aefafe020a58150534b88f7bf3093a1cfb3670206db05f3929fdcc39040f(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__45f86b458cc009962efd80555bc489fbc9ba9cf680a36443d76381ca389a3112(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationBlur]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ee7113d62f887e1005fa0715dde3b5a863ac150497f8b4527215807d5e95b6bc(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5b5e2a5b1abec87b3519a0f9ef1e1b63b946278eb1401c6a2df2424f9514cfd0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0a93986fd5d2f52317a7258887e5fb42b1793b9b2eae298debd2e2662439ba9e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c7bd87d9a5cb5e647d353db5fa5c183f414a62e0368a4ccbda40e2d986001dc8(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationBlur]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a85341ea1d18901d387bdae8478a8072ab8a1a7a5f8e3428fc61767f97415621(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_feather: typing.Optional[builtins.str] = None,
    hue_feather_var: typing.Optional[builtins.str] = None,
    hue_tolerance: typing.Optional[builtins.str] = None,
    hue_tolerance_var: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness_feather: typing.Optional[builtins.str] = None,
    lightness_feather_var: typing.Optional[builtins.str] = None,
    lightness_tolerance: typing.Optional[builtins.str] = None,
    lightness_tolerance_var: typing.Optional[builtins.str] = None,
    saturation_feather: typing.Optional[builtins.str] = None,
    saturation_feather_var: typing.Optional[builtins.str] = None,
    saturation_tolerance: typing.Optional[builtins.str] = None,
    saturation_tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bde985197598c6f8770149787e988447f73f69c2782d3f788203f8c370d875a4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cdc0d0144b72c3378229c71ea410705e8e2d74999ce74a296e2b8685df961d37(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__559b569bf07a57064c9255ca58822b3a6d35ab44867e22d0a28bc0f91de0134a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a7ffa7149aa8eabd2013b57f4515ff496f6dd61b1df6fc6989e17a0b429c10a(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__01dbb2352eab63bb83dc5594d58d3a0b85a6e93a1cca8e81cbb5b1d65c277929(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b3c9dd70aa8b2fc5c98def03b574fa1194fca5e002c6719097a47bcf6f99dca8(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationChromaKey]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fea18893142bc9b983ccaca2927e24f15f6e2b82eb4703bf90e430f7634494e6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eea83ec26b26df793220d25f27376cf58d6e5e4232d44294eb08a50abf3b70c2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__28993c749f9cd50da969b54ece8854183977e82280e67c375801e0ad4e183553(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4605c71bcb1f9b0cbf34e71a3e82bc60c9a81fb71216840a2d2f853972b2971d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3fe9ac067d13c6576f60288a7594a38ba76da4f3182706a3a866f5818397d739(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__36399603787a6f9b000a8b3dfa20312539ae5a5aaa4aab5f29decccc02fd3bea(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__afd5a0284ab4eb43f9627d159335d8d7debdd2901d5e0494271df7861ae2b092(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__189764658ab39ff92970f5dbc30cae305149275074e057da135087a2d8a5b342(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d33d27cf9909f28ab3fe888032a8d657e77dae7da27f7b9be14bcfcd631d8bc4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__da5c272ed13e23f49fb80c3b96c4530e86e836f21634a4689e9ce78ff16b1fd9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__75c55ef6a9ca244551bee066762aee8a64fa8713117d1dc1ae864625468cec7d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6a4874e253ef323ea853562f4450b8f190d02a5f22d77e4e6007c0e5d3cbf6d7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1af15c392bb9731af476f686871e421601fa2f82efb557d7f18c6e84704ae960(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c8345cf48240aaabc47a1bf1a780fe9a961e9fc5043a799597f62be7866a3fa7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d9461cdbea7b9939f3e2bc1f0ad5c31f24194d33b68946d59e2e6afddd5cc29b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5b409a66f631b9c03ed5f139b294f00e4cd709ec5708080e59d452cfff494d13(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationChromaKey]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eb4a6420c0fb3ed08140a1c2544ebef75dece6ee271d6ab45f84a6b72504b5e3(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationCompositeImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    placement: typing.Optional[builtins.str] = None,
    placement_var: typing.Optional[builtins.str] = None,
    scale: typing.Optional[builtins.str] = None,
    scale_dimension: typing.Optional[builtins.str] = None,
    scale_dimension_var: typing.Optional[builtins.str] = None,
    scale_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f7dca4e664c383b68ddf57f7042c65c94382a55ace4b32878b605b7329fee19(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0e4fb25109de7847c6afcc0f7784a76b50185264f93c26ad0adfd9ebe4a8bcf8(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationCompositeImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f7e1c6633aa79c4a9598a2eddfd0ed8eb0e13ae75047eb76fadb3a2002700f1b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3d66d08b0ffdd84348716f668c76cca9d7d00ccba80446b537674c0bd9209d8c(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__089977f2cd7d9baf4eb8cac41619cf1146708f31dd38027ba0ddc49c35cda30e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ebf1f9a172400f4ae966eae06c5d3696ff81409c6fa5fec317025a353a18405(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0cb0d65112ff278c914f868e5ce7282b58e600a04a54415960b1bed3959873f6(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bbca7cb78668911cf2cd62134449e4a3c6c7364812cd2fcfdb4e85ff115c2e52(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationComposite]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1bc9b590d9464d0d4e05df34e02bab2848ececd9ad36acb0a1af4e0a9525a08e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ed4726df97d32a5fe7cf55115015a91012a6977f433c15b16bd66fc344b1f259(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__09aab185a9cb98e2fc45e12c1452aac40d7d94d2d4dacb949d767a84d9a5e15b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3fab3f7a9fb014fcd6fdb98f348db2b250417ec39e028088722eb87491143293(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8bec1eff093e8a3444e1100bf892593bf084e8fbbdd308d53ecc15aa7320288f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a9ee97765287d67b86433c80c7daea77ae59e421a29cf92a536f744b430d2ac(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c94d23daceab03db0323f5ecff4d38de188f52f2db180697834b2b42d48e149b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__01232143b94a474a467597c867929b7e33d98c47c8bcd6b84dde65d43f9bd3b7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6140c12e4fbc571b3c10f9a4cfed92ddc06768cf58cfe69c222e978444642fe4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0a1ed7236dc5231d458fcdaf65c0b2c15600ec02ad26117405d621771f78c56d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__59a910d67f675710013c23ae6a6bf0e3aba3eaf50ddb2323c99bb35ba48eb706(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3fb452070e2892ff9a862c26ae351f17d1b24b61c9ea53512f4f4ea623219c04(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7bd9f852cf122f2bbab845cbf25feea86924d6dee99fcc767a7265d39e741456(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a1299b0eedcedea304994cbc89e2fa94570f6f57c6b1e1468cdacd8ba03871b1(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationComposite]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aa34a01ad5d40ad511d82e0b0372d1b99c3f5f0071c0f2a85678c3565736ed23(
    *,
    transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0d7b122f2f54b030f4758525b552ccb320d587befd16117e7c8e425636b0a5e0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7a75edb2cc2f32eafa8c90356470de279b25d70d16d1b690c0ff403f26929fef(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3b2e2ee12ceaccf65c396591589f1c6596a740e4aa174d520e4961c3265132c4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d601e72dcd7ee6e59b343a82cbb195ec1381a1ff8a521af02c24d69d918653e0(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__603c3bb4c90197d638866f640990da70464f549cdc758317c2afe903a9cd758e(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b9787e9e71fd71130c7066cb4b9d4754bbd2d2739ac80e26a75b6d4b13b1e4d2(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationCompound]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3c6cd10848741c9e932530fd9bc15ac205c3e3afaab3af03c12adb895f463f41(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd3c7e521196f3f61368a3017395876d513458746f2f97c4dd80488ca63f12bf(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8da5d89591da112973a042e5e6bd11c0baf2f7ce1e2dc260383d3e58bacf86be(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationCompound]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__48b4694cf1cf1bd0bfae5fc8f9cbcc4085b30d133f7ba41c76543add3dc28184(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7e53fdebba95ed04e354bcf6f23b23502c0f15bb8a6b224b340320bc804feebd(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bad2ec70abed85e0a1f8b282a7f05e95c323ac7722a94ffbd0c1140da7a8a8cb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__64beff1b7191de3b04af7134fc24db931a35c992dd6a2c08eba408f03cd8b202(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dc7881ae0001918ad6b66e559c56fa66cf0a2d429dc11be6092e096c914bfe85(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ad3d7982988fb8106f63e03754497915a61a78f9b587e197bc3df7a1a99878c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationCompoundTransformations]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e444d22bc18e70c42a8ab58f8aa6a501bed2a1b7b8ebe0df48561f84a88d3d75(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8461a5cdb7ba1f3b3cf24d455d5bcb3f1f06bb6b65e174528b1e6df68a30e8bd(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationCompoundTransformations]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0f4f8155cdc3f7e7d50e414e7b3fcfa8fa8d48d29867f2c3042c620358891f19(
    *,
    brightness: typing.Optional[builtins.str] = None,
    brightness_var: typing.Optional[builtins.str] = None,
    contrast: typing.Optional[builtins.str] = None,
    contrast_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__212e65c82f9758940b2e25aad8c6ec861be81a51e3a5c4108cee1d877200befa(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7b3c6bc76140d9b7c9ea49b65b828dfeea8742c3180c8fa07b060172271eba9f(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f1a5b20af2524c1db4610214496f3f90a27a9c12a70677ca5999c60dd3ac77d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c634cc7a29f08156523177cb5eacf78aaea313ba6ae56b686d53df52cf1d0b9b(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2c5eea8add26bf3b84a170c8d3103c3c4ff35ec100f7f81d257d0989206b6ce1(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ebce33f5281baded9210681e59356261c5eb03ba57b0606a020d9b74cf2b9c1d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationContrast]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__112ddc6732cfd27e22e10ac6154f556ab9dda5eedea11c32776a4a9c00fa391f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7ada9ac6df45eb0561ce6ca429c4c5a582923a17ea8c01c6abc6fc7e641280f2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__35cbaea641f1142d8e24b485fe47dc752d16358d1d05a5124d9d9ebc2bae1b92(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ca6aa835a968ba79ad8bba5bcc874676473cb83be408c1d21d1f4478c4f044c3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d2a7c0eca18225d26ce6caf90e1e74973ac4fc76a6a0455845513bee886f1c66(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__44387a456769275e366206bf4f7056838cae609e63954e8aa05543dcaff95598(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationContrast]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4bcf82039a11e9616dcc50398574e2dd01d8535e0f6f871d767db1f479521f07(
    *,
    chaos: typing.Optional[builtins.str] = None,
    chaos_var: typing.Optional[builtins.str] = None,
    density: typing.Optional[builtins.str] = None,
    density_var: typing.Optional[builtins.str] = None,
    power: typing.Optional[builtins.str] = None,
    power_var: typing.Optional[builtins.str] = None,
    seed: typing.Optional[builtins.str] = None,
    seed_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__547bd95b62134c163d7c5205f656c6a0f5a33d3b089c477d8cdc08d24178dce1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ffa73fcdb818126459441395b873ea63da104d02fd31928ab94df1d08ee49cb9(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__011983243b8586ed222ec7dcecd6f54b67616ec005bdbca44f2ef8965d01f329(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d805bc996d868e8b67fca15001c9b78da5a9633d632ea69305b65603aec128fe(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f14d5cc7fc5c8f85c1730b046810387f0aed394d892d01f9d52a2e7ab54c6d73(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cfc63797d17ba9d6465be606875425bd43ec976f857512cbe884dc9569a35457(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationGoop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f8ca2e09bf03df76f3b2d4f7c76f8a6228240a36681d915243d9962c6c6ebd9b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ce94c68c156a9be25ef0ca3e375728a87f5c982e4030f12d7f5c72cb06c3e56e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__970936bd35dbd39dc5e625a8bedcce864ba4a05bbe77e10c68b3ed23bc494496(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__87beca86071bb5f157b5acd8df89bd0e51084c646faed24b2b61a1f6db28cd39(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e6df81f47bc69b84490650439935e747bae194189c8f5ceecc4ea6a95b1c9ed5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__78ebf68855ce5f78b4fdafd232de39b1e1a3ff32a3066f1664ad29b128971c62(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1ecad76c4ce00840d70fb82cd8fba067d23938282f9d901db7a2b82f7a482394(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fb1d1b346d8fffd769618b0bec62907f92118099f485e6527497ec2093b8a1be(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__332c8dce216c8712000cec2ccfca5a491ea7a6d2d2ebe0d381b063affa21b453(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__587f5e107856bd2658d6bcde6136eb522ca7b8f1b58f6314c062204bf4b4ad33(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationGoop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c1be3c29686b2cf64b942e31a63b3c4b55e261dc15d877dc11c325cf62586bbe(
    *,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d5eac30f69df4fb56dda059c5a2e9465b8c89d0ad87ae9a3f372d182151627f7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__77dea154488001178f4549ffb3363973c9032f457045104229766136f065db97(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f74c99790fc682849a7834020856bcce90e150b86faac038700e17ec03be716a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ce752a335f0034202c253960cce20954d2e5791720a5046cc41ac42ba49cf93(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bd01ef319760f8402793a787b04bb064592fb53492d3d6150ddef0bbb929b428(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d6b59470d27f53f8cab3678b3ed61d5944c436286ca1d9dc5e76f7fecc9da99d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationGrayscale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aa227e22333527dcdd70f9983d5c8a82bb04f756ef94560a828fb0fc6446a5bc(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ffe1087a386d5d0a791eed45e29f1813fcccef158a1cacd2552473313ba6848f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a59caf3053e15a0211de37e590d80fad5fc4dcc88c1fd375088b058e44930e47(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b1e6d2a0b78358dc4849f6a25f360074fef031666815582578bf0717831fb832(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationGrayscale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__80fd7db9b2e78fe100b974146056b49f0ff30369f544b2dfa3c2b3e9dad30709(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness: typing.Optional[builtins.str] = None,
    lightness_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3d9a22791c37e5f3cfbd93ff351a6fa823e4a96eef85635fea35f0442f0ed8d4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a52040d78270e90489a1d7be80cbd976b76705b9261c57f904bff19120e4727a(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d30fd7ef122500473c0c6715e61a79566ca6356e8c7fe3139f64eb5cdfe1e5e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a49307b48c48aa37f466b6feb099ce0a5d520c6768517c2f96b1ea5c02e333f5(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cc15d3af838617b8f068de0aa04f903411972eb43a1b0c98e9dbef4140e26d04(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__14d957580e61039a8001b7aa1668872949bafad57820cf9738e7663ae74db1e0(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationHsl]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5db76bad99f31b6655058d11da8383602144dd0525cd4bf0335114d2b2452677(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bbd09e770458a941ae449ead5b2c6e7a0b52194ee963ebf7db3f3704b5afa586(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4eca61c1c389ecc3b96d47a0298a46b30dfdb468a727142f4cecf1365f16702b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__49c428c9bec9dfb7e7a6796de2fd075b5123f6e7458cd84b266c85f0c619e2fd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8ceff101dc0f95eb4cb2cf8d706bcd1b5906629bfc0ac922435227874bcc0b80(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bda90747219ad5cf7ad7c4f92624e6a55f2794123645cee9d8042f1d42f217d9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dab5829db86a11e1d460d548721def1a9720789420bfb521de1e4414cd299016(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__39e528a8f9a9adf50b88e01a914aac700515fb56fdc037f44beef95fd0bcb715(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationHsl]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__87a9f2a678049c6bd7a704c61490751454bce617a696a8c43180f564ec0b48e8(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1d6d025d27beb2846498f81af2655c223254e28c7abf007367dd2562fba553a0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ebeb109440b23e69c33e4261900ff3a08d32f33962445a2e746416f86962ef7(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4b1e80ed08b67aecb7744cf22af6cb66cc7af2e9c7f80b17e7ebb943768f6b33(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__19470275f412fa2e28d750da9343419c876608530a0869f9bb9505c436a660d4(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3e8bb2329f2f04f077a18dbfc454170c327e1c025714dd9c4cb5a32e5323e3d8(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2468c2cdebe2dda0788b2138bf049f06e26cde4c72ab98e8ef5937b7035e77bf(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationHsv]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d591f42d1c1bd9398ab6aa654ab297a0fa56879944eec7ab398675ec94e2e16(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd99ca3675ca6b6e8e700478de3b171e796dc45952ff5208feb0e4be67db883f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5926ecbce4c93960399c0c46e09c33117b983969b5bce4c96f15de81918d8596(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5c81860c0919f16bbaeb541fe2d61b7c1cf3aaa31c2be0067c7ec0a30747fab3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6071b58fb38b66373895562029112d74052cd8d775e5190f73242e879eeca65f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__11b051a066cacfb50c43a260bdb548510b8c9bb9e674914d4874460dd151c7db(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__950a63b1bb20d684cb35db65f4676b88dc42e4ee7bb1a8ccdd4024b887c38c9b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ca6966a05e6cd203c3cf6a8d40c12ede047e80884e729d22c7889787690fb9ea(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationHsv]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__212df54b4be700cd3fe45156205efec0314be0ca57d21023953ad7720c898893(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimensionDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    dimension: typing.Optional[builtins.str] = None,
    dimension_var: typing.Optional[builtins.str] = None,
    equal: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimensionEqual, typing.Dict[builtins.str, typing.Any]]] = None,
    greater_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimensionGreaterThan, typing.Dict[builtins.str, typing.Any]]] = None,
    less_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimensionLessThan, typing.Dict[builtins.str, typing.Any]]] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__03d7a978eadfd80c38dfe97da565f6dd75b4dc0d5b8125bbd1bc83b8c940accd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a03c4b903e10b46d6c663c935909500dbd19aaba7e0ef0ed8e0ba70fb0a872f9(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimensionDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ed4b3ff4b21e79c6eaf2948eec61ec4c961e1b90100e8bac8220cf0499fdbccc(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__19fc4895b8fca6b38b74128338bb968ecf7390efc7a80f1bcbe869bc53976ba1(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimensionEqual],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__85f3ab6f2d3c0897bf9007926ac49fe5b0dbbba19e516d44fc24c84cae9f47f4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0d642bebb1a18dc628c6ea523142319c1c70c3a113ad6f6f465caf9adf0d6b99(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimensionGreaterThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ed7d6dba26de36e67ccd0c95807377840fd810a3ecadde17bf940645b4d7a063(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b8065b18c74174cf74843a7532e0ccb8f68dc3164b491b733db26f7f8b5aa8f6(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimensionLessThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__81580f1cb57f92e0ca7a07c9b4edf25f7a4e7cb89a6e99154ad2b2e9926777fb(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aa1a109ada74671cd41c3add302cd2f9429471ae49bc80bc289f101dc36eec6e(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d9b873c97d12cbf1106843ea45801fbc23ec375010296dfe54f62f688efa485f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a75d958a600dca1ea082a58ee9646be25cb8110e3c25a7b72a862e0fe666d8e0(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__821c8c144efe2ec9e79fba692cddb5b41bc96c302e6c29141ec849b316a98a80(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4558d9728035bfc41b4cc06be47ba28c450f4029e5920be16edc7b8ee6f6b12c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimension]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5de0c09275e16dbd481a377d86f5f42cb190558e223eb48c8f48bb1069453751(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__afe970ad58b771bdbae97439e1060b56341cd1854d323e8e255c2b769128cd30(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__616fc838d3fccbef6f94fc60ae3ef7c0ae1a74cf2d4a4b880561ddbcc8709804(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0be27c54efb83ca1e773a00641965d88159e865c54d73d1211c1531ad83a30b5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__53caf7e561eaca06c94d64c3e1b83719f96f5b47230cefd67337e4c615eb55a6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e22e32026b418517482b2a26de4ed10e5fa7a5293859e45f6c8d2c462994734f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimension]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e2d5d23195160cb67f8c6038c4280284543af3885011a60282ba6566c954728e(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientationDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    landscape: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientationLandscape, typing.Dict[builtins.str, typing.Any]]] = None,
    portrait: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientationPortrait, typing.Dict[builtins.str, typing.Any]]] = None,
    square: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientationSquare, typing.Dict[builtins.str, typing.Any]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__59defac740695d3755426da41c5173cf97c8cad826e26d89303560cd7e532c82(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__79a84293e4d9a4434cdbf41fb3f3d16f93ecdd1bee5a9cbd7fe6afa5fd71f05f(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientationDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__57e5c0ea87b6b8b6f95b49d1a5db9e35192f2307c901592136212280916a8f2f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9eeb988701243fd426c66fd62ef186d5326537f92f06de6af0df85c040b95219(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientationLandscape],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dcde249cd0713afafe27eb07ff8e5dd310d9ace9ce150b56ecac7a105824a730(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5124a41f0ca539659d018314846627a32a24e6e578fb9f995761954b4d0ca5ef(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a9556945ecf92eda4c959980fafed2aec00d51f7fe80b8e708d59270102115a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aa45c7d8a0937e4b46e1c8f49230a3126ca21dbf809ab825ac90b816fa5348fe(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c1b563e622fe72530fbc28691eb04c705ab466d83fcc197a39f671c8bd80e4b5(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__77d836e0a36eb9a4e5c3d0ba2d341b5dc266efad7a162f14794855b014ba9758(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientation]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f660849db76825bb04f850bd613e0ab2c17ed54674d5d6efe056039b6e76299(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1026e275d605ef843ead56b444ee207cef21b9a8bccf35e9761990a0288d625d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientation]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__265e00e6ceeedf97131c1a7ad64c8c51cc609e4bf5907eff8878498e0cf4d318(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7a92af7212bab10910c6fa24529c9aa6e4a75038cf02aee17fd14902eb60569c(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientationPortrait],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7bc06b0666e6c1d622347de006a560b32370f69309ff30a341441c6189ce1879(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6a96e8fca7f386cad888d3c4583dd406e199805683cef1a228f255929e737232(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientationSquare],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0a9360c4b2acf000b2d1a6ebae155b34637821f3f3e0907781264dc32b39fa16(
    *,
    colors: typing.Optional[builtins.str] = None,
    colors_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ff7de3861555824a2fd3ff9d3492469cb4f8cd4e206facebffd96f28843119d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9aa59fe1432000db8e4fd613148d249f04af58fe317554c2b253cce152c1ce31(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__25908ea80e49b3e04c8b1ca75af0637553edd7ba903e3b7078c73e4858bc9c25(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ed83e8e57e7ab80a066a9227f6ae9c53ff50a187acb8e27429e8cb86e31c555(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ebe12d59fbead1fe1a9beeab68397112044a0072d10b2c094c51368631636cd5(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__68d0adcfac81b5a10095f8c7fea7a27df697b738fd6e0ed83d66617adeaf8c18(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationMaxColors]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5d9c36b3f160b7fe144429cb5b7256c103215a4fe8edeab0140d9457056948e6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5a893fa221787c9fe32463ec000ac06c3875528adf0015f4b6e9d955cd461d21(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cdf5616293d8975e3d32bf8e29e3808c3437fc43488291776d097078cfdd0371(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__07525ccde2e419426c2c125f344b6cc88d7cddfd3c26b12a5ea76cd0d891e071(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationMaxColors]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__89a277028825afa2f7e04c0ebaea5465da9c377a601a15f8b6f2af4dbcb5fddc(
    *,
    horizontal: typing.Optional[builtins.str] = None,
    horizontal_var: typing.Optional[builtins.str] = None,
    vertical: typing.Optional[builtins.str] = None,
    vertical_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__58bacf3f8e6eadccf88deb8f083e2caf5054ac1841cbee2e2da0bfd68a8412a5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7ad25f5122d8d9fbd4074e85ab45257a81983fcf2281dab8782e131ae455b2d4(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aacea49a7e348fc5a9d5ec997e8b0a3dafee0da09e3ef23d285021424063d71e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b011f7ae1fdc5f27e788705d176f548e2f8d9b3e9c83c050ff9df0e74354685a(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e5ed3527ce043ddf6b013c7ec2c14507b4b468f00f8117e98fc7db67152c36f1(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__76f419e44d27ea73cc7ed604d0ad0928293e8cb6c0f5d565cff13833173b54c8(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationMirror]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b3f3105acdc50c75c8c07b0e9192710e1a4347b95c656cb98985c299a5d6ea41(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__49eab2fab1a8be75a2c4ef91ce4b2b7848f41941949dfbd9eb52ff679dd710fd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ee466154889621523c08fda81c92c37d312ff2329d967faab442a13488d9e2a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__597bf8bcde6aae53823e92d7ef736a84407dad1385835314a8890a15ee915441(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cdedd1d7842e3871b1a676f42d50257574b699c85f6dc274ad69ec15765f52ce(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a37becbf27520724aa143a4a4dac3fdff3af0438f6e5d6f39277cfa5a763cfc(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationMirror]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a6ff833e012461ea627546751679501703b9696790d86a8c833b28178494dcae(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bdfda82cb045266f9ba9bc52ea6f355bd9edbecce65075d744cf7412f9d5d562(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__733be3069ff8605ee8b65d33e4aba142af7c07e6fe2e6b5bb55a06e0cf5acab0(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__026cef8933abda4fad87718bb5ad509ba4fe9fef28f0f06c2c965c8dbb1d2684(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0af192f8907a6801ac5eadb323d8bd63f6002d93a23d3e4dedbadf241ca2fe4d(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ff679b785eb8d48d0fea9872e7ec3ec8351ef21a611ecb9b89b7af2f1b9acf14(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e87de3c8ec4801fa5c28232cc5627187f2826bfbe4f7cd77eea0b85156e1d600(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationMonoHue]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__44b46cb3ba10accc931cae38fad472d2014fcbf9c83bd5707a9dccecc2bce516(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e468b8e8fd9bdaca7c13aaf8c2e60ba2b5f567ee76196b113b31fae3fc3e57f2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4f0de94fc477a25559b8693ae92a874ac3d302004ab1dc6335675046dc3e18c4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__228398da930f04f485278774a41633aca460e22f6885f0ba8a7af6375234e7c9(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationMonoHue]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cee1d1062c270902eecfcaf370a1fb16ad28208e5b1377258d277038e9f162e7(
    *,
    opacity: typing.Optional[builtins.str] = None,
    opacity_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3fcd353e86501990071f0836a3c78e2d3216dd229fb9e05e78f2bd97b1a64f71(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bbea731316e3127d40fe97e289d1bf548597d86079567ab3b9c2058b0d85eef8(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a7b067a8496eda9eac0203ebe1d11db1138659ca4f872513290898b629de654e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f1ef1573ee2fe5a18fa81827d024694aea5c654fa14a50d18be9d881eed90323(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fc1557e25845b0521ff722c48cc8be95a0f4cacb5266ff816f254f3a098938be(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__87adac9df8e906b04ce79d3585bcab3a4b01dbe627da30edde956e08ca8522f3(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationOpacity]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__17102c29344858b13915917d994be436167a10e8c073f939a388cf70770c896e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cf04d2c84fa79980ad1be810f6005ee6ec9a9e52562110ab216ea68dae0782b8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cb419d4922bfa6cb6a1298fa9332c8347497baa928341ecf77125f33e26526d7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1e2878c41f37ee84720230c461dd3c17f3fcf1cc0fbb86a64944e90fc225ec53(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationOpacity]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d7eb8315b7a2e936baa02daf7c91ae8b3212f5f76a3df4a3121140b6587a4b2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__643e5afa8c7ace823171e24982a5fb53591ccf62d2f6c7e19e99b8c347c28271(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f20ecb4732897a7b6911417cef9cbc6809062fd5c9d2f7d57b0bca90669d3dd0(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationBlur, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c1ffd10bbadcff6f7dda7288446e0000ab67147830e0526e17b1065b50f21021(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationChromaKey, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7cf71cd1d98db6bff381b49a36967eaf5f644fd7206411150af983b185e4ca3a(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationComposite, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9f955051c652c0c2911b50956941e857ac6ba9dbadde01876a3b271b2b40f9e5(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationCompound, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__633f5c737ec80fed3f51048b0661527ab4a6e644164bdfe3a58a207aa0d3d240(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationContrast, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__01cc5424358163b8342af73000c8d7c3587698f4672b753b8dc2d9f0c2734523(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationGoop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__89c4af0fc725a216d89e1dc03addc4c4a6836e3c659e1d9325cb3434353c8ee5(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationGrayscale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a490f7e720350c00a4248e0006cf2cbc753eb857c8ac7a4b911b0e633b02fe5a(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationHsl, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d2578f7470e98a419f1cc2b7fd471e90c8f4877d3e497edb92bfe3d8feeb6c5f(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationHsv, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c2c804268a445952f4530cd35b90c0c7b14443b86769fe0c119638d2fe5e2d4b(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimension, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__285a6d07dd2336d8864db84ac2c470b1f4fd9ef8d93fe58a0405c559ffbc3461(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0adc5e10bf2b1ad6bfbabf0c06aeb8a6bff3a78b06d4922006b96a7af3f450e3(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationMaxColors, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d5212163a2ff0893e97201ec5c1f605c396800970f356d9d57eebd4a15023f3(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationMirror, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__053b99279c6db6da83b340ed4627fa2f060bed7157ccee6d86f49c5f17ed0ff2(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationMonoHue, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f98f31cd950fa2cf9da1ef36840577a8fb073add078259ec4294cbfe6af7e27(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationOpacity, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c573d6d907ae511a7582e1df5dfbfeb0d856f572e24f4be184c27dac7297062b(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationRemoveColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__81b296e6903d2193dc3d5c3b765347f794345ac73392c4f4f38488492c85c317(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationUnsharpMask, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__41b8050e9d546c4a88e7ca338d0eed68df8b0316ada4ba61d9838bd9fd8fd8dd(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c018529f6ad5283391ef474f49533fb1cffdd12845a637d8810c1bf79d2e67e1(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
    feather: typing.Optional[builtins.str] = None,
    feather_var: typing.Optional[builtins.str] = None,
    tolerance: typing.Optional[builtins.str] = None,
    tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6ca1bcc62d35134d56e59a1eef36cdd668dcbcb94e27cd79a662673d33c2de59(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6cdc7c060a022f4bf89b43c3650e112d20fff144d2f214bc14cb6491b7f195e4(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__de09fb5cee98408fda97e43db168935131939e524e91bdab544ef763cba79b2f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__92de8e1cecf48e7e3bbc72e741420301e2f40e97715d9321d99dd11a561c119f(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1057d2108b49d77e9b549d7b8e1e401a8c6a095f166fc1516e2043b32a506e81(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__61b4cea047a5f9a5bc1addea0016a67f74452f7c2de78bd42dd76fa998ec02da(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationRemoveColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c06af81a31aa7c3f55c9aeab944216f29fb22467a65128b7f40dae0e41123a43(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9754c72736a8c9335a466066af259985d8f6a26f7cbc1f5723b4df1b735eeab5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__800763dee824faa006edf2faa5c9ed02756a9ff1a58acafb8d1711f8e6a41376(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc47d9f6885b5edd5cc9160e100476696cc5cf9a364dc4e8cb8cac47f0bef9d9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6d39186680ef9c533e6b14ca57e657607c6fabc8a80af1276f9ffab03cbc6ee1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb9212377c99964b82b20de5ad27cb95f61986865ce909b23271bbe67da431da(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e5ed04841755441b2a92111b70aad6bb92fb86a2f1b58af917a2ec6fdc842a26(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e384f59d52f786abecb6cf90904809d8a2692863d62f29a8eca17ffbdac421d0(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationRemoveColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a88b67fc66abf97e62ce7a8566cc33e857a1791be8b0ed39e89851ed09fa9de8(
    *,
    gain: typing.Optional[builtins.str] = None,
    gain_var: typing.Optional[builtins.str] = None,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
    threshold: typing.Optional[builtins.str] = None,
    threshold_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8e1a37120c0d8a074e462f9fda9c678fe2ec5f099ce0ee100fe50ee40de9ca12(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__11d73233b55a4b0565002f5f1f7f2b05aba1a49210af465f1b1a9a2849336cee(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d6356b350ff2130c7650d53753fe464d4de7537b21d373669a377443e1a5ba25(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b4eb61b2ca5c9451c3d1d14693505d508bff121a724c2ea910f6a55028d529e5(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ac63e61e44eca8597f090af66c0e7e21eeca56a57ec3cadf9bcccb5301f23cc(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6a1f714bbb8457139892d65d18d2a39e06bd2a07a1b16699e2e76111b8b94612(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationUnsharpMask]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b41585dde81fe5361c8f1131f3b789ea6e3b00eb71a6f5ff59c9dc92c80ac8f8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a030fe2cbfe1a5761a4a341f6d3cbf78eda1ae65e57c79fd1f72567812ec6b35(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab8c0dc2efc5dee4866c3d0369451776a52a1abc663ba56029f5d61d38b164d3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b31351651b634fc369dd1bca51e8a5e6ba9bd766c76958fe759a23a5c713a03d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a69b9a1495281352b9fc00f49e56b9b957177e53b893a906ca32ff4139c8078(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__50f8709aaeb98922e6135af64a9886d2fbfa4ebd17986d51a64cc06ebecdeee1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8b7bdd24421aac324364de408a41afae4ca2945a6ca3922440fc06e003ef9357(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3c9cbf3933ca44c5dc5dea11a339852288122225bac0d2d20e030e588f638246(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationUnsharpMask]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9126c933f1e9fe655d56dafac6cbbc8de912dc9c9b43ea09673811b940c8c1bd(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
    diameter: typing.Optional[builtins.str] = None,
    diameter_var: typing.Optional[builtins.str] = None,
    transformation: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1d777cc181d8e91734e55e17172b6cc7ea76e2bad56df318b0fbbcf3e8759ecf(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2476f0ae46f66cf63152c18dd22575b34c9c581c3d2956f1cdaf8bd9344ae705(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0b255fc3bb2b5b66e50b3ebbff62a0de6c06adac99a0f2d8f6478ff50def2495(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ff7aa9a9486ae0ebf3f9d68184c5893c76a7d2a0b9a5cef4ff4d69a4ecdbc19(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea40cbebe885366241ee41cd18dbd9bb593fbaf2f393980ea85edc5478dcfd40(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__04547e6c92bb9a1071fa83e655fb917fb6d6cc07971d834446fd1fdce7d8ec74(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImage]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e596a053b5781a2571f6e9cffe350654a7cd2967a2509fe977ee607541231d67(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e0e89ff14aa671beb6d699c92fe48c934ee1ac4585d523cf4fbd7b6eb006b5fb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1b89d2f4bf760a9ebb827bb02ec4b895146e16b3901038108d262427cae2ecfb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__31f54c886eff8312485a99196e034adbb57dd8a7b8586a17d3c281ba3eebcc0f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a77858ade57d61d6f4915612387b8d597669b37372f6501bd08dceabf9cc29da(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d11622c4018a8af38246a3e1d7c9ddb133d5a0a449a56d83d24f1d54a3b017ca(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bfe4e2b1100dd966ccc24d7482068ec12ada6190380acdbeb69c2a2a28557b94(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__49bd69255f38084e9628fd504d1529f228d36556571ecb4de1c26f9924719b4a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImage]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a8fcd2e13e6398a77596ce77b187931d6ac9ef08f8d32d6a75ce40631dcaed3c(
    *,
    background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
    chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
    composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
    compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
    contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
    goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
    max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
    opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
    remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd3b2e38dfe2ffd5ed9d3575f18a9d22f16d0a6cf8a7d7734c1d5df24b1f05c8(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5c670d1c7792188a2f821ba12c24670836aeea06b94e06f12405a49273d60a87(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a697efddaddbea9e3161eff230e5ef34e76487897a1a89ff3dedbeeeb91e74a(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__87d268d59f0c66d20851cdde4b427250e1246813744f4838a3149c239f28da6e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9e607f375ac74738352aed861f1b89b018d5e273ad12e818d22666c85a76d3ed(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc5e9f926fab8aaf9800b751d98dab67f0167fe2242ba6e9d39104d981b42155(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bd611e9eafdcedb24ab5fbcdd2805157121caf22e4c6b8173320a51d88afb783(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationBackgroundColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f0562c87b4d55989e8a81e46b42f1ac7f892b5e33887676b2c3270d83437e1b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__40018fce9c395594c151cdbcfef8ed73576bc96f5d5a01c33128681faa2db608(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6d2fb59fe300b692130cfe575ad7cd6825ff3c8af0ea7b3a090436c52164357e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__14f66b516cfd15451fcd89a4d4d0155ce2eac6e8458bd0d7de90201d34e21a70(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationBackgroundColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1855417c117ab1cd4bb0707a2c37ad8860a0e1e20721a731bf3e5365eccdd53a(
    *,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__818cbd31d1ad041695cc5289a46370a591550d04013cad6308e6143d2e790a05(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ad83c16c0a6164009419d0a5967c9c3d2e82bd50b200a8dcdd5eb554d417c32f(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0f21f49ba1e440ab5a417d5455b1b5f43f92a0472cdd9dc4ef45a5318ad48db4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ae4a405de956dcd5d3958a55e39ef850d795858433550a8f24a808b28b43ea51(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__92b8a84add5cdd4133f84e28d1b160cc4e9dad2ef5ef34fbb743f22a36774984(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__87e5ac896d6ac8028687be91ae2069e4a35eed7e510256f8c500e8c933a4cc83(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationBlur]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4093b1b960fce3850f538598b54296309a4cb4d85be690e5388f82bb1ee4663f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__601242082242ac7c01a8f8b9fa879aa550e4083811356e7c819f6040a701c15e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__21b55ba1ce8bcee02e00f7b6dd367904cd184f8a9bdefc6a096186c463264d44(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ec2718fa1b4a0b65575cf396f9c772752206ea168465c4075f4fa4a9ebfd7147(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationBlur]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__354b1c511b2093dd6200df0b478125ddff1e8fa2c29988c782a79a57341e3018(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_feather: typing.Optional[builtins.str] = None,
    hue_feather_var: typing.Optional[builtins.str] = None,
    hue_tolerance: typing.Optional[builtins.str] = None,
    hue_tolerance_var: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness_feather: typing.Optional[builtins.str] = None,
    lightness_feather_var: typing.Optional[builtins.str] = None,
    lightness_tolerance: typing.Optional[builtins.str] = None,
    lightness_tolerance_var: typing.Optional[builtins.str] = None,
    saturation_feather: typing.Optional[builtins.str] = None,
    saturation_feather_var: typing.Optional[builtins.str] = None,
    saturation_tolerance: typing.Optional[builtins.str] = None,
    saturation_tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a81ac16586e935b035fe69eab6bf5b483d5823155f86f28359e63997f4f04eb5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1e3beaf0afe35c725fa84dfc624c80a2c994e1fa90d8999b897f3717abe00bc5(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__56b591354cef1a12d8953489482c1e3254496efedb6a09b687c10e816d788d40(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fdb4ac0e50241716383c552221952dedb6937777bdacafad15306aaa2e23d5f5(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6db078f2a1664ac312599447b35db4aeb952ce74e0436fc943512fddc8d586af(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ec61d9d2cd2940857cf671e92e8d37df6b8bdcfdafe095e7ba0128cfb710b35(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationChromaKey]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e4a1f0ff04c9b24ddfbf299805455e9f71a3523db257daf993093431184d806c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b5467e1c772ecb331f615ae44788b3ad59ee4ddd8a6beabce63dad74dd6c2f98(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__74c180bd9f8465ccfa4f0a5c1ce769fa003d1f5570aba9f16a57de3d5eaac0ad(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__62b5286710af52346524673b808bea5ca595f06419d45640f63569cded838180(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e58f9b8bbede3cc06ad159a286155ba5f97b547d8217cd5db511dde6484317d9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6a51b5e47dcdb803a3101d64578ff38388e79448d38808423dc9387d960848c3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__00456b2023b539beadd4355b37b12088cec5b90a8c5b7318e7e8e1d2cf032e2b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__baf3894b15869a2bcaef0992d86d8d63679ac27d12d86f3d411e2716b056e7dc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d188ba066d1d011ce8b4ab0eaa3726ed934ae6641b9fb8a32c1329feec2315e8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1927558053f8e2deb6907e4cb94d2db35a9a06da1b2f88ecbbf791f8748e98e5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7f421164fcb2d5483210d7e634aa3bc785948c6080e7e6208ce3c67409cbd852(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cc98fe159a1913872982465acb7c26c9e1d82a02ddc5e5a222bca5b7765a7ec3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d9083c6d68580e3df8c1bb73302c16dfdd9172b56ce3b10db3ecb27f4164ff9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5a6e9a5ee24ca5752dd7c392deffd6c3cc1ffc7b5400db68d2116616a478e273(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5d37a6bbfd6cd746710d4be747c35bec6b64a72ec7e3f3af6868edbcba70251b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__25cacf61fedf6e0115417bae0aab22081e2496ebd27a58355b8f25eb169574c9(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationChromaKey]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ade6ca27cce3aa50e706835fde18e333a55bcedb472fa26b14494d006f45a8d0(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationCompositeImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    placement: typing.Optional[builtins.str] = None,
    placement_var: typing.Optional[builtins.str] = None,
    scale: typing.Optional[builtins.str] = None,
    scale_dimension: typing.Optional[builtins.str] = None,
    scale_dimension_var: typing.Optional[builtins.str] = None,
    scale_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f40a2b31cb8f512f786d9604467effabae40108a105d50d33c33361c74741803(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5d30d70e27fb456088754ba1da7491f7b8a3f8ddb52cf02ebef4ecf5d0329e4f(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationCompositeImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aa73112c8acdcde30fbb860cba4862c177d68ac90767dc2f942935f1fb13f4b7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4c21f6deea8aefface0cb3a18dd3c7da449fc3681270f1a6f1f2395f241f41a2(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__616125d4e1adce896e2ffe1278cbd5cacbbcab6a7131ae8a5ab9adf5b4fbe6e2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9f87cff3814ae825a5021c55267df8a0ca8d22340ba1252f25a5f43a05870bef(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ccfa573362d0f7544ad2d5db78fe34f62d6e5fba05da78137bb9cff3dabc36ee(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cbd2d41359af69781ae6464c8d1c6648c8aa586bcd078b51b1b99cfd061733af(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationComposite]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__59c7cebc14c4cadca26c992d69e55b6ae2b4864efa7a09bfd3b4dfad0f4b1911(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4b8fbb5ba5bf500fa2f0c05746d6a4174e0091b1e3833ec64f39641bdac5da51(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__865891c766994b481172e275c0ded8b4acea8f28b5311951c67d6f433ae3efb4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7db20e7a9ba5223b425edbf03c8853e459c86715833b0ab3bc7792b6d19647ae(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__543c648ec973c8780a9bb8c9c17383c44fa6700487ec3456df040fea261bb113(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea7c6ef7e926c1901fb13cfc5b730bbf346bf3cedaa0b0855fc0bea974ef3525(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__08fb530b572d1882928b5e76e0c58f2a4ab4004be930429c4eabd24d5645c2f9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__010c6d1ed4ad4234139735ea33be8a810b8818a0e1f656ef2b2a95886606c99e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6d127d2523bac2c03330f01313ddd512adfa5226dbb1c109e2d9c3435f4d883a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__35dec374c34a80cca3073ea1dce7bb2d8a1abd555e1cb7aec2b885b0cf00bf48(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__03f5b5ee573ee96bd2ee540a00d6d3624318055b75d19752bef6ef8c4f615a01(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__083b61943456d32e6bea368fed70469604572bc4744882174ddc34989c5d5f32(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__33f1c75e4baa79ade28810e3e24c4c78e8292057e85fc4dbcd2ce7a2bb6d2a76(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__178466af9477fe83f2d8bde89b8bd6a383b729482ba947adb9c3dcbad4c736c8(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationComposite]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f45da4ad82c576d3e41c02e52298d9e7e5d5e070a0d0b90ef58df3032bae1554(
    *,
    transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f7ed6a7a1c05f8bc1b26c5ccbb7f05fef358a0c6fa827b6fd2818b3e295b5ba4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f2c77fb71d8075f6fd9d26dea49ccf70bb6eb624e1ddf28bca6041ff4c1a3c6c(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7c6ce0b62fd1d1509fcd7bd6b1cc5672cac9db2a2d767d491c48bf93b3ad89a5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eec68300a6fe6da19fcf111e58fd9796081ce40ecb829a3cd36fa2e7be563658(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d77d2fd9405fe27948bed2cfe17b3a3496cd846fa01e833298141c1589f97987(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0da511d89c052f29322b7fcd658fd6888418121fce5a2f702fdfafc9fcd81882(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationCompound]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ea283026488b309ca06fff3e73cc6866b0692228c6a69d8c18813c33c4d7623(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__636fcedfe0e976cffd06659f970db7e47cd3827c0a8e6e2423273b337fab6f4b(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2b8a2b03812044d725a869e0da2ef33b8b97683451fe984d2449902cfacb179e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationCompound]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__44690673bd2c88fa78110ca29b5f662b561dab896ba11d3c3390dab1bc447c95(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7a1e73043e6729e6503b2f4253ff979e35131f1d0ca05d83370a55a86815166b(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bff04c95b8ad16fcd8e83e72eb7acccecdeaf1dfb85c8186ce0a7cfb5dbfddd0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__54bbded1ba57fb021c61010ce189eb5c4428188391097599f6d7fa625623e54b(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__924b1b221e8da626cb8bbb279f73addae55ca37e9496e274aabd40a9cd45b002(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__80ec4859478df7a16cb4c8b0baca9ff2fc397ac40dc389c04dbf2bc1173ea474(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationCompoundTransformations]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5d4f3b6e539f390cb6b963a9a47acc16bd39f6f9761e8e21858b0e226bd7ab38(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__29d57a1856b91e83575941491ca8b5e10debc12cfe79805592af3f8686be4301(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationCompoundTransformations]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f75980ab9ef918fdf6a1a330d8bf1ea5e0c33da98e00efd6cc2937c92e37fb1f(
    *,
    brightness: typing.Optional[builtins.str] = None,
    brightness_var: typing.Optional[builtins.str] = None,
    contrast: typing.Optional[builtins.str] = None,
    contrast_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a96cca5970db039d1ce761491e6e837ddcad476fff3c720272671a955f2a304(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fd0857b6ef146987a1b2252fbe026cd9f3fe3455b7f81072cfe25822577758bf(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aaac040964db9f148768399037ac393f017b2614cd35081ab527c68c883356ab(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__219e2d35e13a23f6b35ab99ca448890e24eba747b2129590e4ea0b272d20a42c(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c3f42c940d99e1237dbc89ca4412d461b65a5577485b6679b6edc9a448416abe(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d2ed9ee6685b105dafede8ad1b57f86ec1fe701f7b9d04b75eecb47ad89a75d2(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationContrast]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a5368356c26b99739f42bd5baab2d80ba4c5cc0cc9c673dacaf610d6f114ace(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cb84073f92e6029df0aac64852355feebe56f745e6e9f7bb7db73a18155aecda(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__23d7a57e6692bd683807f8d0a86a515d5ff535388ba71765bb05d95b4c229efa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6a26d5e14f4454c568a78207628fc70767ae611be33eed4650df94119c36151e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a72bb8c4b695e382ef91bcc08280620186d0bae0bbb55ee5c42bdc0cc28e7a05(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__62be4e2314e8304f5101d9d56c9db7757e7cbd0b0a5a357f23428973fb3f605f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationContrast]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ec18be64f0fa8b9cc30183aa0c114d200517cb27b162861e42e9560e2695eb3(
    *,
    chaos: typing.Optional[builtins.str] = None,
    chaos_var: typing.Optional[builtins.str] = None,
    density: typing.Optional[builtins.str] = None,
    density_var: typing.Optional[builtins.str] = None,
    power: typing.Optional[builtins.str] = None,
    power_var: typing.Optional[builtins.str] = None,
    seed: typing.Optional[builtins.str] = None,
    seed_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a4def1f1de59ab868e0654f6a708f709a689a74e8bf287074809e9ff06b7144(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__65f6c654f0265043195d4c746ebd6f43c78cfe08efba725c0b01010ccd98ad7e(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__75372c5de13a13b1f754a163e4b6d50e824ef12662cda1a49e6c23b4cb050df7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b97e69fe6955a337048553989fcc449e5708e87c6c41e53245b165654f47f77e(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b157c6643cbc207d742a6fab0f735d0afbd4c5de2996858d1254596c8750dd93(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__30bb2717098e81d92c4b845ba0c9618a0dfa46f3b50c58251f714d25a58b8fbb(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationGoop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b96d9697f41a2ca4a25f61bf810f5bb923a5daabc6b26f7c70b622807faf3eeb(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__90093e265f46484284bed96f652294db65db354e2a819ea59b13a745071d6515(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f244d959ee5fe3770348c9025082394af6939d506692edf73cb913526226c9bf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9065325cc6603e63f72a733bf64a050c0a4b5b14a9cdc97b6c4c48ccba42723d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b013d13e70b2676b33d28ce34b2e91f5afbd71548e63062b5d578eb5dc9524df(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__47eb53d0e6538af541dff7f48372c1a4832baf4b2ad36bfacea1d2f831dde517(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c4f3fe770d2f4da7ddfc7bcf22f4fb937f63d6db73afd6dd42980df8583ad5e2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2b0a078a19a05f83c3e11d0160ecc4728373f875ebf21d31a2baa4ec5d011bec(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9cd817602cec308554d797fa9a74aab39b172e8b272e895a23a71a786bbee304(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a1ac0f91093914261683418d0fec303093b11c41bbc21080512f0e76295e6f8(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationGoop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__091e48c6f1f0ac338561bab12e4ab3fcbc8788cee285d80bde30b14701c4f7ba(
    *,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8eb2591efe135126298c15c81a35361af8fbde9dfe1e19599cb9b6db9960d4ca(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac83130bd6f7a3528c49d898151f273af95bc5f6df15dc760473b6c7ddfc431a(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5fbf52e76816c1ffc8ec76053f3ed0f49e9283e897b36ca6b7359de8e8350f7e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__69297025b16b27cb999e64fed1d81412d6a7e4bf1b4b8958a72e4282e446173a(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f26d03b6a2c7f71960121f7b016b24752abc198c3aa9e8b9daa60e3de2f6b0f5(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2fa01d9aaa693e8622b4d63aa66627a4926dd7bd14c8471b355d57d40d5f39c2(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationGrayscale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0905a01aef554c90e820dd60908966e388a50ce155423f2e420e29bedee63214(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a990448a5ce60bdefadcde6e8956f9b3c380e20294405ec69e9a9c97d9b6f32(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a9784ef1499b2f17b1efcc2bf6816f4ae36c42e5f2b60df00643b4ded4e0b00(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__76e241bce9727ef4fb534abb2d134e393d853ede179ef0b49f658679d729e081(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationGrayscale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3afa630941a9e8c66558ea5f8d103374a8457d315a4f36c2c0e910e1a7d15f7a(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness: typing.Optional[builtins.str] = None,
    lightness_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dcf1dd7edc2915c9f7b63706c85022135e2b3bff29c9289f6cb902826f3c6630(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d96a8296c8e63a456c2b9c1cf13ce3b31e96d23bdf168ed1805c56326d4f3b9a(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__59dd153dc44c3a423961f7d1b7b556f6a3d335fd023ec12b453068323657ae0e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__63177f580ce55e8791ec719775b45ffc1a5356d8531b812edba50cdf80189801(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0796f7028e49c9f5fe0042b095f6f96c5a75e01dab1e39d5493118725658ed43(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__293f5dc43b7201a6a546a268aa50656d4a8934471e4151572bff15f21a981e60(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationHsl]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__00da61606105f832a8518b98c5a112d6bbae52b01dc64aa9757f6390a2f21fa2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d250f66952f7cffd55f6e0cfb9292d8e71435807555f57f4038bc70203da33b4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__562867db2089d940c366a8043c2a2e585ca99d9a73b6d26af320523d9b220f8c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f002fe49c52876db99fa5140e939d54e3f2c4548e156c30898f5daa9125d09fd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4784cd8783bbd9efdc166c81ceb1c5df7e5041401902d9d54d6f9285c19372ba(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7ff57dd9937348fdfe4f647839d10fa74591da4c3d4b965a715d4d732e37c978(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__57205ddc8b6801d0524e021c62629b274ac8d4d1b03c57c8847059c2c1086152(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__acedd5eb7f67c6e7369ed51c47210efe362b874454a22b4b740d7fbca6d1ff07(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationHsl]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab5a6979e2d7f01a6ff6078da2010913d3d62bc72b104d630a108e4ad527ae34(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b0153091adaea502c106bcad4d88021c5a72c24cf3571fb7148c29a77d0a31a3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__661643f76b5b699cfe383196679f3a0d788afc218ca03d55b15721a165bd831b(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__527537d6d715d4ec556cf1e5f275ca65a8b605866fa62996c438b22dd8e5d1ac(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e5f7b97ef4e4d84c88cdce056b354a09378216da2375d1908dce315703ce93e3(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1be65c6e3e2ba120b787c415845a796b5e4e80d99e10c7a72c3d6aa15b56bc17(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb04c14fdc9f6af4f745341b3caf13aa762e0de800eb93e7575ecb1a4fb2b9d3(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationHsv]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fe39a71a8cde3711d1d3172309581cbaa02a07c8b07f6c0f20f68d9947788ad2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8d5f2a99c5853d4e175df91c990235ae05c4eb9185bb1bc51b507a3f1bc851cf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b5cbc2d733fbe37c5f8fd5d4af94bd6b24b515449fdd4e258366967872646311(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5663df2929c04d9c61288cf84cfff0a730c7510f5268fb0eff5a5af0447de277(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e836982babf27b8e6232e74875dc0202421df41d5da5e1a6ccf29637542780d4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__65f141fa72f7ceeb18b9bb00aad88cf14de11aca2a293b85e0145d9fa7af2eb3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__62cce188d1a45718455dc7f768a8bd3cc9c75d728df8385b6ee73019486211e0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__de128c049fb5b46953c1ef73e9ecf7d7266db34bdfc4f0c8c7772614bf19ca1b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationHsv]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5d15ad4143c51b89b6a70f1f84668a3d765d0e5bea04d2e173d65d0935a5ee8e(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimensionDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    dimension: typing.Optional[builtins.str] = None,
    dimension_var: typing.Optional[builtins.str] = None,
    equal: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimensionEqual, typing.Dict[builtins.str, typing.Any]]] = None,
    greater_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimensionGreaterThan, typing.Dict[builtins.str, typing.Any]]] = None,
    less_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimensionLessThan, typing.Dict[builtins.str, typing.Any]]] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__68a9ca553e11ffce9b87cdaa7fe4781f4dcacbe1465b9ecb64492473f98460fc(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dc41421a63074a18db54133c10710d1d9b8f93dea5b1eca69de729e69cd3d560(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimensionDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dabe29a160960349637421a5db716c2d894a6c048b893d1bf1ae4731869ebffd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__00564e741f83eee514a6b7343d0b9d7e717107e185a65841791f2a120478f6d9(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimensionEqual],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b48ab31d0d4ff3c1df2b74fd538f10eb79ff118fb09215d101f386929a719012(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8feaf2daf102bfb418431d08e25e2624cacb01b799a3998f2f723cdba78fa46f(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimensionGreaterThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__86f792ccef692cde277cf1699e69369650dccdc6fd731b1956186e93a8cbf406(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0aeb5ae2f6591d82f18813d8a639bcd7ef5a0c63e751d17e8a2c354508b0788a(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimensionLessThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__60757ec94928bb6a2407a35cbfd5fd76eb342be7b9542d76c553f061c1757626(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__050900cdc6e60b962de4f33d69d9e93dca8282d1d3489e397a997659f9cf6ddc(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8ad9f9045f20e8c6a641a757ea2399e49041ab881177d14aad9371c7c3b84823(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0a3d2805b385906eaa0305056c5afdf8e1a39f5ad271640aebc74e640c2a1a49(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0f7c289c1fb64da1d3cdd49e8a471f8424df4e12f1e2377279e9332b79baed1c(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__47deede0b5e217abd735e37493fd7376b210aa12acda5b83a58d3935933d6e6d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimension]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c61ef3985381d769a63f977f2ca79dae444673a8e69e36b7c8adaa51b37b80b3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4e7f9de566984c08fb7b48046890c0ab2dab2128deb0a9410fd01c3a653e78b3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__99889450179dc8f9d80ba29796e2785f12cb3953e310e772d9e33bad2da0c9be(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ef59934f474333b20cee523e3bc54b69364a931d6bb916cc9037cfee76d4160(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__82802c1f87194946bd37510980ac3df078c41110986d993fcb1d9a010716a61d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a0e7c5f04f10e2e27c0cac07d8ee0ae2707040be04cd1936a51b5855e5bb7c44(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimension]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ffe0c99bc70af028350ddba5fd396369511293851aaa44554aa9935f8a04947(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientationDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    landscape: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientationLandscape, typing.Dict[builtins.str, typing.Any]]] = None,
    portrait: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientationPortrait, typing.Dict[builtins.str, typing.Any]]] = None,
    square: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientationSquare, typing.Dict[builtins.str, typing.Any]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ee6b8dc75d6554f08d8cac23cfc52b330b7669f9cb1d973f484217dd625e8c78(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d6a898b673e457bd9c6d1a69cf43cde7e0b3a3dfeda74c9aec60baf4f500961(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientationDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f948c3f60de141e290ab48539d7b349c8fc5fa20e1e72f2ea034307ad4db39e5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0b87c4a16141f22c412f048129626c41ed799c2c6c0a0cc730bc2ca74f376889(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientationLandscape],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__51c96f4598217d8a820f870397d27b59410436debf403ec2cdad028fed2b8be2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__006f1ea31a7f02fc13865e9743d327e87603cec55139f1cc092baae6c4186eeb(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__240a7f175383f646efcaf978642674ddbc6bff197cd742ef778f69012ca6dd5d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__386aeb0f2023c047fa76669cf5e819b757a3f8d0f8f66bcb6da2b24383516040(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bfb5e8788ca678f4ca8e6bba6a7cab776a9a307e0ba97e74ba851de9b08afcd9(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6c71a71832ea8e9dcfadbf146b666db27af31776c9448ebc3bfb72f85be5325f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientation]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e0755058892cd23924e4be2077fc37b11fd7dddba38ad4eb80e163dedbff5bb4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ba3960247647de912511fa20068615b55c5d07e328282a8232f653e6f432ac5(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientation]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ddae767565bf8bb72be9ffa667d7e04e254c2d9dab2ac958077c0727259dd891(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab8f537d88b31b1292ca2ea1ac464561129fe3e62b20c3158439f2e938e43a34(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientationPortrait],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b2312cd3204d69cfe99f9c72091cda26bc0b8ab63a8ce5b68be7e43b0c3d399f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__61acc2ca277899c81d40dccae575d7657be03d8d0fe1dff26f217589a76d52b7(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientationSquare],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6445a908d7bdd51b80bbd602846ac871656c5b65b4f949bddc9c7500fa21d3ed(
    *,
    colors: typing.Optional[builtins.str] = None,
    colors_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d59b30c49ad39faa5ba4c46fe8351608c237127981c8ce9775df6b93a5c40bd7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1e5921aebe30e68f6d106687da7f0f07fcd7f0cdbac3ca3aff9c73b9c4649590(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__24641d39cfaf8e091bcffdf1ce0ee4ec19b78e4e881f8f5fe0321f79a71f195a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7a97b40f9b309ffbb3a251b114316647f35048c18970effbb308ac169ec2774d(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__805d0af57f96f8c0bc1c46ec8ad7da9675383a263bec6f022477ba380d5924cd(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__63996b81a837f51477e1a505d73698a2bbe3dee2f6ceb159f2ae046be014cb7f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationMaxColors]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7e7bd75c57f5db853344eb12f05a7843db366dd01dd138da55a6cc6655bcf631(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d592b287413f3e51db9013f622d21b68702bdb13cae2dcab01cc64db2b5b1f9c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a6a91adc39d6eba330ec1d217f1c6bc871e0a6c17071f9e6cb5c2c3dd84e7d5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__38158a77ab77d148fe72fa9c7ab237adfd25e18dda2d071dc5523094acd444ea(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationMaxColors]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__59689a63a2dc456ade4d01c9acc994b3ec8a6c9b92ce6e5f8b6867ca37316dce(
    *,
    horizontal: typing.Optional[builtins.str] = None,
    horizontal_var: typing.Optional[builtins.str] = None,
    vertical: typing.Optional[builtins.str] = None,
    vertical_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b068c6c294358483d07b4ac5a0eceb0db555a3064b1177504f815d146ba04f7d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d73ceecfd7959a6bd5533a815f3ff881c9a4a7c95fe9eb0601f4cb58cb7db02f(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e1c4f3f5b62d3fe89cec18fcd8bf1fbbb5dd84326bcd6ec2eb1ecb1764796740(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb822302aaaf2d0e00bbbeb40d9d71802e5a37f583e50835e34c1263863e8b19(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__940caba4c48cee69936b0d246b0354ca1a63c55ba258b0088af147fb1a347417(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ca3e29d15e8f97c2b628d951b00e9cf00cdfbb41a47e320d35897bd5677d4079(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationMirror]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b78815adf5a8f8afb7095a831c86bb1405c5c3fdb39363e1b9399f103b88ee58(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d3a86126d4e7f67dbc3a8c099f6d12cbc14caa238d3340160113c5ccd0fcec2c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__89c3369bd62c0616453e005ccc4d4ef8a7a2e003784a3df9bb811ad5c4e795db(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__61e971f3ead57d21cb6579e8665c823cf42abba7d24e9cae34248859710c005e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__67d1baa097e4255ac429947bfb7e4c6a18e5dd83210f557fb86f2fbf67f5aadd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f0366ae5f6d9e0a1fd8ce81967168acb6602d7ae6232d796716412df6ac2be69(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationMirror]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__222aca57811b977610b69ae1bf1916b1a3e19774f51d45ff655ac9df4179633f(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d0fb5c33be98de7571d36d28394491ac2254e9918722a7dc94305cd555c5a686(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f21559ca5f36d440d3513334d0f9ab1788c7a642ca08e7bbb2e99d67a25c6cd1(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d72477adf9909a7edb7fa7696904cb23f6a25b4f2416801096f20a0b0e6d43c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__25d8f69e02aa5b5f1825abdbad8ebf1070b88b9b3b88349c202b11ff4310cd9a(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__82f2bde01066b443106fec80f05e0913f81429aea4500afbc5ed3a29b1c38392(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a9cf90d4a7ce29d13a4ef6f5386cd701a478321ee56751e1f07da6a5ffe4d0bf(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationMonoHue]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d981d6422e44f4899ea7afd97faf67e42631ed33d65f67bbd7ca2dd9b45c1ed4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__303c567fc1bb906ded394d65a105f1c27cbc15747ab7426011b0ecefd61604b9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6fba506271e2079bbb03a8d393fd729072eb52ef97fa1e31ba368b4ff7cb37ba(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__631ea7d54fa78439c5c2586e43bf37e00060455ef05106f0f0c716166e5abf8a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationMonoHue]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__33ebb8ca819b73400c76f940e2ff527908de7d67972c4a98371ee6b782502f7b(
    *,
    opacity: typing.Optional[builtins.str] = None,
    opacity_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ec9f2111c80b759046391c13d29239e79eb941d9b02e2486f0f450f3befdd7dd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e1d44a43256e3e7ba907aa4d7318d2ef3bf023b15eb5c0a9bb36af577841713(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eceb01b81a16bdd53bfb86b7ccbd34d8b2f462ffb7ee9f5633966e29f1110a97(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ce5c222e14bcde597f32e209d5ac1cdeba6f8e6492e14ee9a4dea879128b3112(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6bc847b113c60254dacaff3e0e5a169ee3ac953831c1855094f753dafb4a0f39(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f026fe96ee29e629ed25bdbe9d641a2aacba62679c078f8aae0a55c6a8856c09(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationOpacity]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__419ee6e2a120d560806f983fed69f5cf9af37892208d617e6867ad337d799290(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6d338110470ed02a4263327938c885267dc6c6faedef9b892357bbbc5d775dff(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cfb2e222cd69cd74f31a6d4df7725083f8293aabebf5d33dac3973c03f283e4b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__35dedabc0c7e96c1866ecbad2b9a1cc646f64af60759822ae48c51059a5b7cd8(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationOpacity]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b495807561f17bc0dea6b18d0a83bdcdff1c3b76331b9877776d539152c9ab19(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b35625678f6d33a606df0cc1aff1133b5cdc1470ff4505092d43cee5548baf0a(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__79801d8e88e58d44064f9e438405213c61f83e47f125c3318bb406887a4306ac(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationBlur, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0bbc10cdddcac67731b7f66eb5f7281fd406aab2d92aa5b24f397d8b740e329b(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationChromaKey, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5d40e18a6f7d9d71f60b4934e5a1ee08465e64fffbd9ab993c90bcb96e0ab109(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationComposite, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__262e2fbea1fce22d44a159459989cf6157e43ba2cb6d1d7e03d154791c3b498f(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationCompound, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a5f785d08645c5aba22442e773d200f32b36033f5fd3a37a98404200f14c41d2(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationContrast, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c79ef0269855d8f70bbb4bfe52667d998ab438fc279fe0a9bf372454373ffbd1(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationGoop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7916bb474a62505596531c5614dd5dc61cbd6518cb712a8507b1a4b07788ade5(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationGrayscale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8b7c0874c1bae6a913444922dfbe6f7d3b9cd43c841951cda2695e7ea2052bc1(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationHsl, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7518cd222ae6902b4be6fa7527c965d8ffbfc574cbd8215ee1eadcc2b0b6f516(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationHsv, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__40fc721443cb4dd21604f713bcd1dd713f0eb3ca1d31b6c4e6112b9475361349(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimension, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__32a73f6db2390e216f348c003cb2092f0e39b3a9c30bed407333cfcab873befa(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7b57ea443575e7f0f70dfed9eed5f511acaeff6e7489fad13f740bea5b25c9a0(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationMaxColors, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3e9aec9d6265714c9799f5b6890431170e97cb645d7b8d29d2c41c7cec25c6dc(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationMirror, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3b91acedf530e7baf7e294780662641068b7cdd8cfc80e32b8a392258f20821d(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationMonoHue, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f269cac0a92f15f38e24bc39e782a63b9a57c5d75b334e2a1a5a5344ae261603(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationOpacity, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f1fe53d9581370258e7b5f69e4506364a1c45d33df2b11194808dc249ebde7b5(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationRemoveColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__167f8dbadaea677e68a32f0103a005796d7f70f2a923b551cad73d6c44c53deb(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationUnsharpMask, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c8c895adc00d6767ffd659d5a6ff6a5b5bc635d64b407f54fccc15ddd52865be(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c9400272d78970b499087f9f95983433bfaeea80d99b8f81c7ee965f3e6325e2(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
    feather: typing.Optional[builtins.str] = None,
    feather_var: typing.Optional[builtins.str] = None,
    tolerance: typing.Optional[builtins.str] = None,
    tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__937d8264c71c7ae3fd0adfac9cad7cee420597c18bf6e434dddeb6be6ebc898b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8fbb912a9b61ac9672a3f4ee44fe2642b9e154fe8d8f6d61a35860fe0e2a11e7(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ea7cac2a951c25ce9f82cd46fce2006e7a8365b95f711004db76f507669f27d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b50667679033c46acb1daf4767a08aa1694ccb303fab760268d4cd1744194c28(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__68458ede47475746314dd80d39bf3ad448c5fb189600355916e5640d29c70604(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b99788274bb6e7510bd625ea0242f2b0524dd3433b9e37bb1432e46b7ed705e6(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationRemoveColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dab035e5d4401bcae5085b51da9e415118c0dbc72420f0226d3a5bfbc545f6c6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__68bf51163432bff1b4badc4d2b0d6fd0aadb3151af0d5998e766881d9f42033b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ad268115e5f7040fde39e42ead487801ae2b07c5ae034c1af651ff77769f0d83(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df11ae6c168a3718f6c1ce0b5c2ce3f2152082c4cf86b06062dfb5478df4fe41(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2f49dee4f687efbf8955ea7c4729c420410e7652c6933724327b83b0fa885209(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ef6fd22f21807a81ce850d0afd3475d81877f1cae73faa5c7a97bd450680e3bf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8d250ba37fe240735204ac0f1c3250ab792a357bdba0c894c241d8e406e1f75d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d226c4a24ffb06bd601b75e0bf480f465609b53c3729de33b6a7bf2f87e414c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationRemoveColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ec41a3530795a6e70b113baa0af5c3f868735d8ec47066d7de13f7c25743c84(
    *,
    gain: typing.Optional[builtins.str] = None,
    gain_var: typing.Optional[builtins.str] = None,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
    threshold: typing.Optional[builtins.str] = None,
    threshold_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__23801c329df86da2d87804d94654e524582dc4f7b3e57b8c29d5e122000e1e0a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8fc264c14b41af5b1026e17858e95c231366664b23fa88c94c18efe7b91b6c9a(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__090f349f8353b468f9daf3d545722b79e3ab0635feb4f5f42a921bb70f9f30bc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__16c76c9482ae9c9bd4860947399fc9836294ff6bf7248242c75fd5d7f6976ecc(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9bf55f22a7507f049c2e9a49f245816bfe67ca2de8fe20b1e276d706636e8294(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__52bb6090f07f9115c0ceb95646615248f3040a6a26e3c5685f2a9c8fca675b0f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationUnsharpMask]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d93702de80a5d13806913ccc9d4287d87eef776ec06a964781623d756125c54c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bcfdac06d2fa2d5740a4810463963ad1d51c00f0e28c23c5bc3a45741ed4677b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__788e7b5d0247b37dddfbcdadf9a8a1439c233044045f566dd41679ff29bffb15(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fbbd0227a41016bb003300ad4578d266ef8dfda64e82f9dec8f6a8ddfe004d36(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1a59ef46c294e900b0bc3e33e29eb952f2e93f82a7c959e379c709fdc7aeba9b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dacab95fb111f14ff32ceec1aafa2a02f9525ab5e29cd5a5336b3cd7e1d55f79(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d4cfe1766068355e7436b8e2639936cac786fee8796b5a9d437c1f0610bbc242(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9b49bd2c7694ba6e15e1d557f48ec7416fda314eb952c78d37265ce9c7f24b4f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationUnsharpMask]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__72348421cec61decf25f7223adc2a04dca8bd9196f925a6dd073485c2d0bfe5e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0fcc1a7950cc794ce7201ddbeb87265e0f52c3f26813c05965ff6c1a2909ff44(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImage, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ff40a90784a8917afea3b190a942351239a2363c67fe0294f68a2fbb013e915e(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImage, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e89ef357da70aadf67136aa2e46029523aa841bfe0ac12934cd816784af41eac(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImage, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e386f0094e8754c4314475affe7840ad1d68460c5bd73a5e9a7fd8905231f50(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImage, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8dd273e953c49d32ca01cf35ba851ed956e0ef1dd440ac2962e0564adc1153d2(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6cc8b68c0f68abff9602c79287497059fbd19e4f2579388b9045ab9ec0b1bf22(
    *,
    fill: typing.Optional[builtins.str] = None,
    fill_var: typing.Optional[builtins.str] = None,
    size: typing.Optional[builtins.str] = None,
    size_var: typing.Optional[builtins.str] = None,
    stroke: typing.Optional[builtins.str] = None,
    stroke_size: typing.Optional[builtins.str] = None,
    stroke_size_var: typing.Optional[builtins.str] = None,
    stroke_var: typing.Optional[builtins.str] = None,
    text: typing.Optional[builtins.str] = None,
    text_var: typing.Optional[builtins.str] = None,
    transformation: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    typeface: typing.Optional[builtins.str] = None,
    typeface_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c052a2df5744963f6b77b420a4dcf64ee8774f37195d2d2b7434b6c72149a2cc(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7226aab622b6742537ff223ee351270056a4d8d429067ab5e81f9fac96932f99(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d4a31e34cfc56c6c841848432ba5011e1ff3acc05df55df5988a4ecd36eff361(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a9c3f0ee751b846a558b7aea8d6fde3e24d086e0687c6c625ace182f741b6d77(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b80b815e31e3782d330c64870abbd203a4953b91c1062d0d1b5b5f97a7d504ca(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2222267fa54995696ab60579435da512ee3adf20235562ec481b563f79798870(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImage]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2e4cb3725c675da0b6575a279dea25028db62fc4eee34b45509dc698eb615491(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__22154e1b03baaf64a5c5178f41818996354dde1dd69d207af5f79f5e2df107d4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2c61137e8945effd848a3f7381d4a879c7c3f6186d9078044ea4bc1e95ce8016(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6d1d838cda98878fcc5bcad119b489702535413db14760d0d0acc970c2d3943d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f52b1df11bf7dd2241cc8c9bf03055bdb30ad3d7d8383aff11c28eead0f766df(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__daf3c1048186ac9ca10a0e9432c7b11c7ad6d54f005a3bd065f5471f7630efe4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6d16ef06ad0359784925b3cec4b57b0f7ff8e59f8ad89e7e8c15940c95ecdeee(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c97c8000d26fec97078490c3c3ff26305e03203e37e81d0dd619759f2a16b5bf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0acdedb5de183a3cb96e8fc6669fce4ba973feb17b2afe467b56ea171bdb0ca8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d763c1deae402a29f0ab950e12e769eadcfb45d326cfe7ee8bb6fd6047e925e0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d8b438524501358770941326926d243c89074e26efe86bdfe3ac809fbfab6420(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__70980bf861959843644b470827c3c1d07cdd13f24dbe87b0586edf9597a7d242(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__10952efe58e0bd1b9d4b6a505e504b6f99a7a9a46e94526ca5f73ba57214f084(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c37ce04db105fbce4a187202d9bfb96af5352ee06e1adef90afc14f740837764(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImage]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6b98c45e9cbc4362b5f0f14af3bcbc141355990c4e43458377591c99c35b026d(
    *,
    background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
    chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
    composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
    compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
    contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
    goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
    max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
    opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
    remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__30522af3b6344b2c8885db16b029635632014bdfe6ff3f6179bf0c0b7d2cb60c(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dcea3d1088dd675df48b1e478efab6b05506aa032a0d541096642db50fb90f73(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__61a866810a9552b2cf991295c32701c85c72cb835e3ff7209e0031a3743a9e8d(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__92a9729c5161e54b485353997003bb31bd60e5bd90f28c6ece9a12b0ffb11852(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__95b785a62d883dbbf8eb2aac1e0f74fdcb8836d6ee6e2c51af235512c921595f(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9977f4f782981f61503ad33d57e4dd024b4bf6f14ef63301e0d3ace55c09da83(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ca8775b06c9d8299dd81767aa6a0247e3c9c349b39b3490f179f6e902441f7d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationBackgroundColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ce77e447c6bb4c06fbe20a5863ddfffc7fd12db7573809f208a32c1b01a86fea(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2bef3eebd3dfff4cd822e57755606500ebee844eb9d039a6892eae3a2e58366e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__69fc3998f14516881bd08511eda808f67580d9789e3f7e50d5c0892c9a1498a3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__72ffb9518ea62fa2ed0f2a8c2400dbdf0560aa6ea52b3bfde14e198466db6eea(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationBackgroundColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__05cfb3995700f931d3a6a0ad85fc3652a6360bc6f1a91fa970e82b833bdcc63c(
    *,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__941494874811e49b05fa7efa3a9b78a0b5ca47c3e5b0ce554c89c3b1ff0f4eb7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d2d3f172e9095b73b91656a2168a3d5c2a1d3cee775e6676b67b3993b40fca23(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2e01fb2ab559b482921587ba51efda264ebce9255d90f9e871bbf5a11b59f0f0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a5b2630b8f1324f8acf6fedf04addbfc521c12c0b4550aac836ba01ceb8181d(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__27670af9a053e024f65a9e264096f64c6e256097de245049211998d6e6e6ebbf(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cb10aff993a95fe3578608cf5d696b1172176efef80ec9eda5208d54b252ba94(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationBlur]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b6d2fe43faae84271a6d79d26be68dcf7abfc0d6c083b332f52ae07e1dd2f7d4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c298adb5759c08fcba307ce80b14a6584c3f31d9ed79001c5b3c43572c4f5519(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__93e45ed2757e993096d28bfdfc98f13150a3841d64833b58c29ca19a9e53b4ff(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a13715b4a8ee420105c9f500cdbc5f771d405de037374f9c8c173722815a574(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationBlur]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6afce501b19dc8d19d402b611e65ab8118438dda500417b79c6f11fff217ac9b(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_feather: typing.Optional[builtins.str] = None,
    hue_feather_var: typing.Optional[builtins.str] = None,
    hue_tolerance: typing.Optional[builtins.str] = None,
    hue_tolerance_var: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness_feather: typing.Optional[builtins.str] = None,
    lightness_feather_var: typing.Optional[builtins.str] = None,
    lightness_tolerance: typing.Optional[builtins.str] = None,
    lightness_tolerance_var: typing.Optional[builtins.str] = None,
    saturation_feather: typing.Optional[builtins.str] = None,
    saturation_feather_var: typing.Optional[builtins.str] = None,
    saturation_tolerance: typing.Optional[builtins.str] = None,
    saturation_tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7a7c5d393e42df0725f3ca6bb7074f0acc07c231a8830834444268b0b38516c5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ae7a720ca460df54705ba32f844138f04e5506fa4cba3e38b9b264ecf86e347(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d8dff3c886e3030e54fb3482c8d2b8c09d6471a2acc4433d4e53949411a0bf5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__227267afe4c91d79c00a4a83abc49a32d361bd3d624052b937ccea9be3c9bfe7(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__429ca8c73c5577e6ee9fe40d30e5afc492d4e9c30d23c04da12b93cc7614cb65(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__db4312433fbb2286507844f7c87235bf52b0c6d5880164e457dba34efe776850(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationChromaKey]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ee18730421b1421f0a7ff5876f08b6b84ca6a36c4856e0f9733ca4fc131e6e68(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fc41b7809a75f640660ed8712e7c0474b7e055f4e7535722dfef9c5281cb1652(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__88749e49c031901dbe7a8d8f0c9e61e4361be455113322552a52451c38d7216d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5429641f1f3013cf2049cf3dd3ca62aa27dc7fe193b9d9bf0a57828c381307c5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c862cd201e52f863702556a95beca697a8a33558818bb98a99ad9f8eb1df9cb0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8b1600c99c086096ac140cb856ef2d7ba5d67fe4c4656387ef49d3b4d46f666e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e5fe72d179422f7b52555a485595271774ef4878acbbd34dc3e832733989224f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eb042ba85cdeb3bdec521ada18bf0754aa88408d6fddb075b04b8508fb23566d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__afaabfb8a37d924a7d3d231b43c2224e76dcb4251a755aafe37f51df0fe3bf06(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fe63fa645729bc4a91a75a2e674e7c8a06b205876c29784639aa1cca97bed075(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__634b5a9a37db8f68774526c65f302d0a69a5dc2f70ccfa9a3709c83b807ea3a4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cf3d8fe889833bb06798ca78aef325130771c5b4f748a7949c9ae7784d7ddb40(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3dc3d875e51c15504b86ed06693afb3dfc66a6530adbc6fa79c493aafbadf9df(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5b79d4ac78294510b0b9ebfdfd64278067d0ee34529a4bef9aeb5efaa30b5151(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a431a5fe0a739bdacb74e4796cbdf7fb3d8b7351f56e43ecb95ca02db7390ee7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aa17be3ecd3f87acb33c7958e732d0e8115894f92a2db2b6bd47e0d2c711d757(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationChromaKey]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7e4aa1278f9a75e7ce2d51aabb9d78c4b76abb7e2ea28bb03dafe59c0591a66a(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationCompositeImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    placement: typing.Optional[builtins.str] = None,
    placement_var: typing.Optional[builtins.str] = None,
    scale: typing.Optional[builtins.str] = None,
    scale_dimension: typing.Optional[builtins.str] = None,
    scale_dimension_var: typing.Optional[builtins.str] = None,
    scale_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0615ee2da717e17578e4097fe813c2d50541c3e7318384e2650696e3526c5a34(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d44e75989e49ad048a59713acd0bbfc2d61a35e948c017bd8fa97c8381b858a(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationCompositeImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aa6fa65e38eefdb24d2e7688d3201b24429df4d2b211a747d8927d68aa6e6a46(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7302fad2881e142ff9f7a167f9b6ee8ef7f32b0db4b154273c81ad3f5def9fef(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e70ff7b2b5b67a90a8fb593a1a73b1387044ab7a9b0944aac1f3a62c4b4d530(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c217e8855df29844b7e4efbe1725bad2e0e874123362e92c30198f1df4e1b7b6(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f1a319057868d254ac84cde3482deee168557cbfa32667c9184a65942496d720(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e9ec462a0d4e43f7bab35b37320698e9014830205805704552505637fb81ddf(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationComposite]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d4bde07127e3daae6625cd53e25f1d876d574c2a55a7a31f65686f6cbe6550fc(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__54cafbe46adf84bc73ad86ce005aa8eb82eb7412bb36011316eacb2c64773aeb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b75a26a198d345784db6658b360c2dc2c835ea3444c31b6445df222c7e6ee89d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6054912ae93931da9f99a764f6f94b5790c29268626a3194b07ccf7ef582bd45(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2992c214103089009fa83524d72fc788da0964ee0ef47991b5e9464c6cb44136(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b353257637dbaf480fc4c5e676f46b7e60b43302b562550d71146c8979c48b72(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b933dc79832fea1c194f8698e32f479b4976fe52fde6295624dd3727fcaf5c8e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0028c7fbc9f656be3a2cef149ececda2f36197a8c0853605d51fb96643c5c235(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__27d618ff7a3f16816306857a2f521ef584422d014212f85e889b4f5ed8c413ef(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d4bd8d29e7b891ca6df624e23bbd6d2e20fc9a6154ca11767e8d71d33df4889(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a0a454a3d294a747f7edfbf9b822995e5935584f6700410575a9109c0c244ad2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fa6f42bf2c06018ddc689b673ff7994a7d0421d7bbb8e5f8b9ab2f3ee8affde7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1c2c92236773b8814548bd18235762b20316b3afc05f1cfdb478048bc99c06ed(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__66c1bd006788d164614978d525a2433c1af976ce9e4b3e75600ca2c46739e753(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationComposite]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__407566b7147b9d2ceb8c2e05416a2cc572b57954cfda9648983104fed5242b4d(
    *,
    transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__31bfec7f8d143a35f93c84a56730cbabf678141ef16ecf77ab5783a739f63a04(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__84e455f0d4280d6e4ee4d8f513b243d56984cb3858b03d44e5fb6cff0afc769a(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__779ca093110a7b72c245b977638f0304fe0ac395e1c5281ddb7c2ccc87008ba3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__628091be3a7d23f149881ca9b220e2dff0435f0fb3e87efa4482d523898d2aa0(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__039debaa949152495c8d090587216f0914069530e7a8205beaac833cb0af39cc(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2f1a4fff9d562e1376c4f5d334b4a09cc2e22335768d2d6527fdba7d23a0f5e6(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationCompound]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d24a908324dab3337523de99bc0130639c8c09bdf120a578e8ccd624e7e87a1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9c01f3c1bd6435e96b0969f132efeda10f51c8ddc4c25031f1d27b17775640bb(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4e06e0b16921febcd53487275a00167d7e389ae202210691caa350930f795699(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationCompound]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c9e2c95f815e2e52591f11df5103695e80a7b781e13feb80d2e9a240f9ab4bd7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0276ee3e5810bbeedf50c48ae95efbe334d77e98594072177a5844c68692b8ef(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e25f54ab08c3938d4047d676f8268c883f05951cab3e5100961153fcf4f4c240(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d2bcb2e565108c9e0c6dc2221216391a9c26d9e35711eb1846878c89a66e32ab(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__20202598f8889ebc68a2372b4412689afb0ced2f4c22f3ee9adc41e0ee8aa87c(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b88c0f37e104cc00ac5e240922f4e32fafab98eb9194da6aa87525a9e3fb86ce(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationCompoundTransformations]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab54377f70d8a3b29225e419b3810d9af5b3f7555455074cf71b4a31eee6fd58(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__171d236f223af06edfd7d7414a8c44878376584c2d657860c1e9b97227b9db8c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationCompoundTransformations]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8b75e5ce898f2f273cdfd004ba521227f19a823710db560cb51f49c232d8ec5b(
    *,
    brightness: typing.Optional[builtins.str] = None,
    brightness_var: typing.Optional[builtins.str] = None,
    contrast: typing.Optional[builtins.str] = None,
    contrast_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__72ebcc0c758872d545f236d53651025e9c6adb05b7c7dfeb3d259e75cd53fff7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c9c21964ddd24ee6bf08b2cf8eeb3b25150a1fab2b432e113ae7cd9b339b40bd(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f4dab5573f560c3fca708b800679e7b690a55db419a3a498a51b3fad0c636b48(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__994bb6ae608a15d2b054f6577dbf5e3673b49255c4cb2e68c5ca5c14cfb0e1eb(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5d242c2671c9a6735442f08ad8ea9cb7ea9c39ea72d3f271770231fd7452baad(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__85743220209370b64756ac89639525918f641d24351b9e824afa80733beb3024(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationContrast]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__52fed364b3f01c7c61c1d33723fd8a5e417327bbd927910002743832734b1614(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b21b7c7100281e6196c2bd67c36a83d9ccfcdfbd6e5317263557697570e6bdb2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__12d72c3bc4f6fbac86e039246b28e5c8323e668654e9f6692310096ca422980a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c43a07a638df7e26ef5a6a55722c60419702621d5f04eab18bd4cef0de59412d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fcee963c2368ce2e0268d13917ba939937a32a2aff204b444504ddcb359db54a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dedbd357bb51fed519e467d84d9b5b14e539c929327b16ca69a5c2e942af3e5f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationContrast]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8230f36e560fbfdce628b3649fa8811e19134f1f7f743206236a870cb0196cbc(
    *,
    chaos: typing.Optional[builtins.str] = None,
    chaos_var: typing.Optional[builtins.str] = None,
    density: typing.Optional[builtins.str] = None,
    density_var: typing.Optional[builtins.str] = None,
    power: typing.Optional[builtins.str] = None,
    power_var: typing.Optional[builtins.str] = None,
    seed: typing.Optional[builtins.str] = None,
    seed_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8786fd4a49d5c4a2f2c2c07368fb2e8f4c1c3006e518c70554b03d85b85bab97(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__43a06e65a296b3eca076f5211e1bb7a835ce5ae6ff348352261ef85b0fa3a916(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d9252d9c5911a2ae87f54a500381086893ce410c51a3ace2981ac2c03b36a649(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2f48ed24925133b0e6c649dfdf74c1a265f17e2c4fc13004ec4f615792ae39d5(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__caebf66a0abe07ca41503a96c7d3f0bfc99813897e3249b6b294e2a7a2540752(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cc5e9dbfe0fe88ed7a8c7437b3ca50d75fec20e636d2569b61d43d2c756b1e4a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationGoop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a48d7d2e516fcb9fc6d8692615cded4b142298f01a6ecf21f05f5762c9b1dc7b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2972330de9cd3c6fcfa1763d7ca288990daefb858b90bb432d9e9a5cad343cc7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a76a7f10211f51a3788f139986cc900f81be83247c1fd042db382bc6b941bb0a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e5ef2eb2946981cef73de6d2fff8df858384b35f73e7fcaf34658caddaf72c34(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aa05c98493e1c4aa1e5b5d660e678d7884a31cd1bf92109bfac36d480f2dfee5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1443f1d0f5f08b49d232889762f3f184260d0cc47006a4d822fe777dd242cdb4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ac510949646cb0f4f2758f58d02fe7967371b12f6c639e9773fefe8afd27fb7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__95c5bb86b0e5dfcf957db137a201cd7dce81236ce6d20acf3c828db52a9c4f1f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cf854c3a404160b094a3c8fda41b46e16693b319b2f20c585e761feff0a8b9e4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5fefa7928a5de6c78f62d8d704465220508aa4611ac19cbd4111e43eddb5f8ed(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationGoop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__419223a214c77c4ff60e38184f83d663d828bcb5af5483876d9f4b2a143da169(
    *,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8dea9d6416f2837c4cca2739d22a3b42d1b67d914910fba61c7624f2f7535e6a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac073d3ba28975f2a4b702ae9af5b085cf98bf4e624353a926b8c8b5f01f3f44(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__debb5bb1c30c3066d1d2e9b91361db14d8d37c822b6ed2ad35e7071154edcb2f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b3125597d658ed44f7cad70461e15605d822999b7930836c3b5fe398be436bdb(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__387d5d3a3643ce772522429c1e57219b6b6ea2ed9d420811e5bd20b2e71e1ebc(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c252ac705a360e4c7330ab446b7e6ca669ebf11ab6c46e2f2412e4c9f66044bf(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationGrayscale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc97f7a16a3dd3cbdd41575e892c8b01903dce1a6d2e775037c1b08055f70cb1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc14d6b5209c6e92a1aff7289d08fc5a9f7167cd04fdef448168c4571babdee5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ddca39d4cf69b50c53b78d027a79808996bb8911641b2c67ba1f4f2734ac69e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__039c3742cb1215c080bfde9ec454fa4e1b569169747d2856f9231c5c48f99766(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationGrayscale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d9e8ee08de9db3c41188f481886003e64c025b8bf84ebde33168576e3660d1bc(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness: typing.Optional[builtins.str] = None,
    lightness_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__84b2d15c116439556114319738bcc36ae93f926c5af1b6906bbe64d2aa72ef73(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f0087856d3ac752a265064000b28e41616d46e0d2e294e9dd960cc85a71e85a1(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__415d99812a43aafd5bd6a91b8eada998fc45f0f63716effdb90e2d4743932e24(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab38330ed806e1d68a6ff522aa0e503eea7737ad3ce4402cd0cbcf638be8da59(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2db093292249fa50fd73d4b8c8e7b5831af113eda7ff05dc82804a83fd1a6b50(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b0b0c40d1609933a5799c9a843e8251265d01bf9b2e62e345c94d1d8acb3d9cc(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationHsl]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__490d68c90977a55a4c6f5f84c13176d82f5cbab14f288e05110ef1c49e267d31(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f1506c113fff91be31d9dead734ec53eada165bd55e0242bbb52ec44d239b046(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a97325856e902dbb583115e1ed805d770cf16eb07111c512cd50c02c0105d09(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fac375921d79160007878c81f318b9210c8949aab44fe7955b127f4af7aea202(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d42b70de44e8fa839177bb02d5bba66f90a0546b2171a66619a8e5748eed5021(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1c1ff9fb1b8ff44cf67d035de029de188a1b4a872567206b6364bfeba986fda1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__036c6d60d9829d6738ca7c16804393a2e99d5f5cbe969bab0d206eb9de671d5a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b54db4647d3c406f398ba28673a7ef9f196dba202a09b614fd82db849f724ea4(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationHsl]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e5206de7401159b99278b3bdf0859883182e3b9ec85b78736741e250bc3f191e(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__62d89822bce4953262d38530cb93f0d66a5f5f103164b37ce8bec10aa7133c62(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__06a4e7833c2c2a493b6165446f42840ffc7912a54021a8d1b515ed240d890caa(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__14faa8953fb7fbcd91525fd08ce770d0a9b5dc7d44b9b80d818176c54cb32cac(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4c5e9b50d0f4b6b0814d7deec5a251fa0931e83c48b53544bb1702ad84d600dd(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ad76be511c99fd842d8500d6f26b0a633f42f87d7e653ef758060415755adf27(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c1141216ca100ef66bde67351c4552575eb80635f228ea5022e94024698ebfcb(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationHsv]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f0c5c4e408b0c72712a39f9043e3c522739a145a16876f5944ffb6542ed4625(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0cb387abb298becf413a5caf7d2d5d6d35f7c680bd6977fbe1bff2d6a2898b7e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d1a3e7ebba20eb5b74df6d1f4dab014449bac59b9530bdb1efd36a427268d118(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__599dfb9485a39f159a88f701e60ab6c8ebea674685d805a5049f5cc2403b8159(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f370d15e1b1d3d97745bc2c5548dad44c45ade1cc932daf2a2fb490922512d6b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__79f8a022a78ddaf510ff5819401389fe5d2dd160459a10c66dade2c4e2c6a9db(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d4b0531a09edfd18416a72efc9028eca6c24827bd18820b1b48883fed63508ee(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9db0884630f7291c6d362fe73a96810d2497cc314ad46d2ceed72cbbd51cf37c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationHsv]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1549268f54979625174243b9d8441b6730698a36a8bfd657470960788941ba00(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimensionDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    dimension: typing.Optional[builtins.str] = None,
    dimension_var: typing.Optional[builtins.str] = None,
    equal: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimensionEqual, typing.Dict[builtins.str, typing.Any]]] = None,
    greater_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimensionGreaterThan, typing.Dict[builtins.str, typing.Any]]] = None,
    less_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimensionLessThan, typing.Dict[builtins.str, typing.Any]]] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ce60d478003e47524dac468310f338dbd9705245927feeadb5e59aa4f5c07461(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f673e162f3014b4c51aafab253f3de53cbf06da5b4d1220cef40ee2d443c255(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimensionDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e69b70a2a580b62154cd6992cbc568e31c211d6420d9b2d71e484013103d0205(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7afb524a7dc492d9ed4dd78671210d0e37fe36de1c58b9b10c407b97a961c8cc(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimensionEqual],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b6e097669a503fee0900e3393d243b554ee93873d3530d654d3b88ec8fdd2553(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__50a96789837d84f42c81f85af4669d4febf64a41acf7d49fcb9a63eec7bc2cd7(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimensionGreaterThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ca25a2a4315f6318cc15317ff76b0f55fadebe2ef5f9ee564f00b4e828d16881(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__56442d15c0d3892223e1452aee156f63dd80ed82c077900ecb230669baed356f(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimensionLessThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f6135fdd135e6c868ce2fc4ff3f157298c48e365ca9e8527a0c33724d4d1ca8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__28e3124521fd1d793cedc43bfe390a5bd285fc29d93fca122bc3b627c0e7faf9(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fbfbef93f87ee6983fe8a37a5467290afa08bf4555161a974e917012f067e964(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a0bd213293487d0c9359d37e2a6c3b5ade20ab540da423a71a738adca060f467(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__38606966ec1870db622bf727e844553cb5954e11b09a3a15a7c9912a5be013cb(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__653ebf475ec67dd0454bacb56db28b8b85df0ca6f6647214d520e90a9d4bfdda(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimension]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fa8a7496b90b7ec28222e23ca86464a6b50ca4e373b234f8acdc6e3a506179f8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ffdf155f09883df8105378db7d1359528cfc3ce11f563aca203830945040620d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d9bc5ed99618e5238f7480108c70d835e772404bd26dae4e4dc4948b11322de0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7189940994a12a16dd837a5e636960a60566f7f9436a219452385ba9565bb159(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cb12d099c2f8f249d70e4ba13cc751e27d2831d35f9d8ee1705264342f387745(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__69a17b57036a02ddeeb506332bbc5a1698499cd804301942d977b0a813ae7a00(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimension]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f81c4f58131fcf7d91c5fa8129ee07e6f3e0c39c9e19725ab2ca472c2dab70c(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientationDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    landscape: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientationLandscape, typing.Dict[builtins.str, typing.Any]]] = None,
    portrait: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientationPortrait, typing.Dict[builtins.str, typing.Any]]] = None,
    square: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientationSquare, typing.Dict[builtins.str, typing.Any]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9f7cda12f445cf15ccb5ad881ef0467cfcc1ff52622f03fca4f34b51ff1f9cd7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__54b5f5b75693863fc9a79b0e53a589c56e1782a5654801c1aac27a5635226b26(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientationDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__41d61ba78512e1ba69b69be9583920d0403ecff047ed43ee01d324f4eb787d5d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d29ec9b0668a91e9b76963d96cfa26dfa368899ea0cb77c6936b1b0035f5f5fb(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientationLandscape],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__41bd0fed47db4378f2c664d8db10b70e590122ca4dafe6a3fc520634d8180f10(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f443024667650cdfef5a00b23a0319eae443b1478892a88fbdd790a772a566f9(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__618296cd132ab334a36e53e96e6e88530bd073446b6e776f5c4abf2d714a9e4b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9aa02c5e5d2121df46166faa9fd895d54dcbeb570045da6bfa6707ca60b34de8(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c3b41a7a76a0b04df40a798d1f4506b662e852c644d810c193a0d2b6c3ddcdf3(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b9ba7e95edf24b1e62f1c0dc8235cc3dc4084188174782d6c79da3543ae9f213(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientation]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__61addde8f3edb7fc0ff0aa636f91f33e9dbc37438d0ce670c1e45debe3698009(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e3c28d7117506165dd316a76bfe9fafa688f2fd6e73916083047d8546714909e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientation]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f7cc105b62b94cdd911894a6e588d8cd18d4592e307a01bbb7241f253243b981(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fc5deeadbfff2f2d7f2d9ec224189201829ca5d7cb8ab8ac9be7f987405492d2(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientationPortrait],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__21ac05cb83095546396d7e91682e0a41615b15e8110dd446b28f25166a0b29ad(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b3d9d2e0d4ef45e0926c334b0be1546349ce53104953aa07c1b5986a517c2111(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientationSquare],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ee74b8966ef14b1bcdac37bc43ecee9ad7d6a756bd98e2aba4377bd7ea1b0b71(
    *,
    colors: typing.Optional[builtins.str] = None,
    colors_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8dbb3e10a26eb92673bd643458a4bbfea559c16ddd1cbd439f76efb9b6e916b8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a37738bc31773be9a478c44c0530179cffb702477a5e5beba9c74797dc8743d3(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f92e1df5078d90b61458f821fd709b933a3d11b54dc35e8665e1a12620668279(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__31d49566ae620e0c86716ccd93f9b5eec9ad0655b2514081efd1db64e814baed(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e877f17a9dfea0feec1c9c13a5a8643851853f770ea898c546999657e0b62219(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__572ee3a47f009a9daccc2139ac1a6dead1ef879a62ce90dea45579fa63ae9b0f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationMaxColors]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__66f8b8064b023e533f5ddde0f27f16c3f915e68bfdfbd5d344d7ce229f40cdcd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e66a49435bc024074e919b353534a46dd54b5089b4737238fbad822a24897d4f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0d20f27174f87a032eaf03fc9181db1263efd84d08b4cfc16c0c95f9e6d3fd14(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f2fcd526750114cebd078e536020c56d4894abe6bb68740f03fdc4ac91512a04(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationMaxColors]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__54bc31c7438bd76f042087e06bd9e518ebe018a62f8d919726b779c14d3bee61(
    *,
    horizontal: typing.Optional[builtins.str] = None,
    horizontal_var: typing.Optional[builtins.str] = None,
    vertical: typing.Optional[builtins.str] = None,
    vertical_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b39915ef499b698c51436e4632b90e54fe9c3a7c30b0440af7916343e10e9fb1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6142627f765bcaeb37466820d95ca349b80f3fffd1229a3f46ee8efda9d646eb(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c897b83d8623e63ec33e01318c713655dbc60a29b1ed6506e38e7861bd0783d5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6358ff04ec64daf38cdaa41d935adcf9ae3eaabeb8306487bec45a693a4c01e8(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aedf47a47060d34e2ed314e4e36cb8e1c551c355691fc1ead3948645f8c813ac(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__523d99639f6898ce9d27e852c00e6d3a738df22fee5d66b537224fe1302f5b72(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationMirror]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7f2fb577b03140203a39b2a1bb7439c762a9af4e998b1580f3d8564334a94472(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a4994080427ac787c6499d245cd315df3a462a8b550a62d5741ec9a223300e37(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a6fe6da0850a1339b6346d0d7ef29ef026f83c751ad7238af4bc8438f1ebf98(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d6ee10d1c20cdcb8dec63888aa9bcf419ccf5e00b4113467d6d8343c6c986452(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__24095aeee9d52dc3d993becaf7a850d05e87377ebb641578c88e0584a8c94e1e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__161eb176d684e3cc9d864bb59e0b38bacf35faeff6d76ac675832ce69a466174(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationMirror]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__348f739a17648b30846f8126333850f3187d132d0490e2f9be3a7ddc68cce491(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__60cafb819311d849e6eaea6a61cbe4e7b6d8d25a44b2fc053a930e5b51150b15(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__739042e49b50ca4a2fabcb265d8aa2655d145e0066b8a9fbab61990f96a0320a(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a3ef1949709ae5ebabb3b98de644aa42e3908e0718e34e0b35148aa655f5d1ae(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__35f0dcb33a78032530d7ac83b098aa254ca15882d32bea299d2369371e3b8faf(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6b43181a4a1f276e01af69a22498ab3bdb194a49c4d4c76b5e3a3b2c9c12d6f4(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af7201559e33568b996365d5bd11e25ea545e4f378a67143f02d0a2e82f0c2b9(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationMonoHue]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__605100904f62217ae6c2f1cdd8e8c7b9b218ce4f560c301ec62a3d59ad8bba58(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a6ce7373ce35e295deec8e15a2c3eabc80b654f3e62ae974b0990a0f7f5c80a7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d0c83f520ed9b48d60d3a4eecbbb6fcd287f78e6802f657f4643e1d8d8abde7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__862a89cd17780bd5494c8d69e8b7ae46ab26c7fbf2b596085b1c16fda7df9b10(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationMonoHue]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__34a95b040391bb739d5bc769ff0d2c62342d22b1638e8f2cecebe1f97309a611(
    *,
    opacity: typing.Optional[builtins.str] = None,
    opacity_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__464f88ae3cbb41e9d3ccaa7677e37b7b7d181e2c9696092928833948d7ce47bd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__23f4864ab98ae044204dce2c99ba212b973f3af1b962ca86443e6d75b9fba0ac(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a0871afca369e4a4795b8cf8ada495c20db21d2ced8810e679f428c4c1c34f1b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a2db812761b7b9374684fb13fbfd466000f412e236fff744f51cd0ad0455301(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__15f9a21a040dfbf12ef89cd090da472061636268a70741e7cb0a77a21a47211e(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3e131b8c9f7902a4fa1ad70371b3d2b96af87692865963717a74b270915ba5fa(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationOpacity]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__72a958a8f5d23904dafd2aef5b845c72918bc049e5981ff7dddf6f84479119a7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3b7f8d1b4b18f9413c419b589fc320566d90575010c2f2bc1a2dfdc4d35087d7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab6bbb37fa2dac8f404528a00f9b0d0b960d47cfb96d74f811b399cf660526b2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c0560fa23096dabaffa41bac9693f9b4db0b1fb2fe180febdd0cb52eb3ca4745(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationOpacity]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__05a2556b66e74f3d81e6ed9f06ab4bb7a44e6f5d2b254126d075e277247b1803(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c8f925ae3d579f7930ba388d392c7f804a8fa044c18db64082a8b659404a04c1(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5d84594748dc1a7998bfb3db77aa83f058f21a42ce42ba2beb8ca7183817f946(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationBlur, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d51f549f29be296aa11b7f39f40322bcaaeb411f5ed92ad01c8b7b97a4f91903(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationChromaKey, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__14d855dc038c23b6265a694cc2a04c3003775811cecdbfd936bd8c05ad0811be(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationComposite, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a205bc8f3f9d4013ea878ae732f7dc49b1ff0339edbbb5427726c73b0bb8aeb9(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationCompound, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1137efa6d71c7f730d05f514d90cb06d1466378603313a94e744daab58397846(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationContrast, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0bb91dd29853f220ebf14f39f6ea6fb9059aeab714f5ab75f863b88ed687e95f(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationGoop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ca88e68ce9bf4121f373b46ea2c9f91ddb1379481067e43cb4cd3b6ec3b00bbb(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationGrayscale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__09a8e096d8384e47d9ed58b850896eb517ebfd7c9173aed825d3d380f4895f3d(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationHsl, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c86a591d232abde6b703b5cc376e54e1565d848d4b26c470403b4c4b324be70d(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationHsv, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a8489380218bb1805ee40a560258d5a0091d4630e78759becd95b959ed0ac518(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimension, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8b200def2be2510fbeacd2894b882d09e16570b8b07fb59440e75ba0bb3bece0(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__674d93a72f0294e309894d65c15d75d79f723230ca2a008323f93cea1de5eba3(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationMaxColors, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6907296151f9ed26e18c8a027e3d293a70cfaa58d8168d5a0f48a9b287506df9(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationMirror, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aeb4b1bc88a1adaac1e3ea61c31d05e8b7712e540b4bb55d9bd91410d72b1bbd(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationMonoHue, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__29efc2611373226d56bd7bc320a07c3c71c790025e0a0b1a1476fb9b4fae8f26(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationOpacity, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9c65c00bd311fbb9aedd0f2e83db27e12150202f860fd2d6d3b411cba8e59295(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationRemoveColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a18399c726eb362cff5715420105afef82051cfdbc0e6192bf9f43221429fb48(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationUnsharpMask, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__46d1be4d3692d7cf864e084dfe6d853a69bc3d478d560d8420a167d32dff30c7(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7b6e0ae9644f7e7c7913e13eb7870fa0cc997c4b46ab3ca88474d384f0de9af2(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
    feather: typing.Optional[builtins.str] = None,
    feather_var: typing.Optional[builtins.str] = None,
    tolerance: typing.Optional[builtins.str] = None,
    tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d72f93e2c2ebf1d8728f9b6652cb104dd54c65a80fac42760864ae380c12ed3f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d99559320b2513c0d82d8b215ab0e256778079791d649413132d889a3babee8e(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ae0f4ca06b18e6e9cb0a9a42d5b42cdc39d0ca6997921e038da24fddb9fb02cd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a22cc297e63691ada0f32fff7968520f0c92517d6b256da3e57a878043c0fe85(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e22956bdc0549144ab015ff5404d176957a02e3ec2a771b435e9346df197b006(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__25a78ad1ac62d223dc3723525732b5aafee94f32e48a5c4a95f3230afbce0de7(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationRemoveColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7a1d725770ffdbe0c54c4ef6e0624a9e1420858375682f2e6a09a02b09ac163e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__03b2c0dd8ae3eb759efec0d1c5d1a4cea5a56408c27cf07b0791781a959a329b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6d4c78098b63842505fcf46fa9089f41bf4eebb4bc05caabc13f988f9971174b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3f58cd09b69d3bdd3d8cfaaff31fbbd05dfdda2bfe83a4bda0fc9c2bacdf366a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__72892ecb51c858eb7c29bde49f0126a4df7a9d3782e99dd1ce85cf48ac5a51f9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1424254df93c30cd5394607ec3ddf82660bcd475c5461490d45741b1ca237ac0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__86cedd077be6f54ee689b91408bdc8f7ab766b8db0c8ddf1bfb25f116e8ae02d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__67606f5c0108fd2abf5f0d3cd9b623d96b49eb18a98c79b7326f3e76602631ce(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationRemoveColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__204988e024e53957e76e70d1b84352e608c59172d08091fd4aeb44ca8e3da00b(
    *,
    gain: typing.Optional[builtins.str] = None,
    gain_var: typing.Optional[builtins.str] = None,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
    threshold: typing.Optional[builtins.str] = None,
    threshold_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b9e757548628c1363f8e86d6828bd2927e4a73feef049c0fc84f05859f3bc978(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__066d6ef431717f8826fefe369fc32c9d437e5de7b13a1dcc998b47487f541518(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a1771474422a6114f363887975788f21c34ff543a1dc853868d15137756a875e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f3d226440099891425a0ca8c5320c05c03e0bb3bc966c38588fc3f37199f0cb7(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1825450b222c4d33c8893ea443ce19dedf23b9954004420734f5a821a0d0682a(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ab65c9f087712c2d9259aada88876e5a1183f8214213cfbdd41c9a04ed965b9(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationUnsharpMask]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__98a96d048016b78be7b8ff985bd144bcbe209365005050ccce99b8e2f16126a9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6ced05841df45dacb1e792bdaa6ea5e024196d3b05c0049b34d50f221734e51f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__120e79d12aac42bdce3019afd23db94fd9cb8691035704ba550e8798ece1a5fb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__180327b914a416ca08001282ab735469dbf61175cadadea5474e5ea72fab09c4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2961665ba53b4bb4341e4ba4ae6d152d9facbeeb5a7a99430d5c085a408a8c74(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3f87b95163cf114134fb79fc553b1d05de7d05206297cc3cfc9a0079a6c4dc0e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__745f2bc04091a6ea860e90bfdf5a85e12861442766237d0201a012b261c90a67(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ff2c6cf9a31122f01bcf6091046f4000b1436a9261f10c59d3ade345e6b1b531(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationUnsharpMask]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__189f1c7ef76661c7a4118aacc3968a0d07a0693e95e4f5ea6fb3631af9fb124f(
    *,
    transformation: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    url: typing.Optional[builtins.str] = None,
    url_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dd34e86b951718ebe0248bb2f2c5e01f89385412f97924c20c1c54446e97a4d2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6a4741310faa574301e0309e4fcc4cda0ea13767395a73eef9120bb4fa0f595c(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__76d91debdbe5d21481733d18378b126eceef580a188fbbce932e4f0f6e1c6ceb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__36bfd1f295bae91cc202a54c591bd43c9b05d7624d6e3c7a9277dbbd364bef34(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d2acce2f045c180cedd20620bdd07d68578a2d58b922a0734792bcf10284eb51(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a6d1d7ecbc9f507257551592f3f6324637fbe00be04e1958ce82ff0a544732f2(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImage]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__91ddde01e98b4b6c0bd3689ab58d35b6f77367396a3072522cc62fcbb60fbc65(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f5c7e8d912d280daad284e0575cdeab986540f24837aa6b86963c6e2467a9ed5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a33572fe5c61ca64d0748298536c53ec671ef39c7a583b61cc842ce95e6d4fb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c71c6a8ea21ae93f892d2fd193a773e9bf632bdda82b64363536de913e9f2646(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImage]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8b1b4f2d070cd94286cce46787c6c770bb43d361937cb6ed5d83940a5c7ae472(
    *,
    background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
    chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
    composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
    compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
    contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
    goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
    max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
    opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
    remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a19d7e9480083a5049be4263022f78fd455df6720a0b13166117569dfd962f8(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__60e3fc0c4b4a1a82572460bcd4ac41554f7123d28ed6f63dcfb1209a08e83233(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4f3e0645ec3d5131c963ba080cd68fe3dd4483504cad2faefd72a3f4575bbadd(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__12e7be1e426d79096e8d865b500f4785bfd6ac1e7bef06757d4c705e8a94f579(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eaed16dbbee70cff1fa36fec7718fa09099ba2f070aea6f9b4a173312007537c(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__55e6a5f364c83c61aceeb3ca4192c7d02d0f6569be52d4137daedfe6350018e5(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c95884d9f438a896b68d436e478eba125514217073699e307a12e494721d462f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationBackgroundColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__996a8e1ba60f3c1d75414b10de2376e3dd30722371afac45fb8865a314e410cb(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__732a13a8a4c61cb433195fba1b01ddc7feda11b51d7bf4e4e5985028206c7bb2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__887d28806377d220ec353978b165398968a461e55d1706657012f20d660cc17c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d6b384da93936c126ae8c4ba379f7d86406388573df932a664ee54d25a37b97(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationBackgroundColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d41fcc37ff91bb1b1c2e2e0e65a7564b8f6d9804ab5860af82ae37c4d595871c(
    *,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5580119f859029347697915dc9d15c7a9f23416cd24d0e3ada47e241d2ccea14(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__23db5611540586436e32f596a6709686527da646fd1ac4f7388b13bf56d28f8a(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c54197770a4636df89e715f52282123736b7ebdf10ba348ea5c742a21dd8f790(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f24f20f58012b8d128f7adde38b7117f14eee6f28cdd6e02199e5fe8b8105f0d(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ccd6fa829c82e55894975912fc73dc38259bd7109279f2f2e624b18ed7da01f3(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__973a6f49a4065221a8b4a7af7acdfee8c4fec6dcc5f5623d0e10a538432b6d22(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationBlur]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3c55e08c7473b165c24f5efc15c0fce6c3536b400086baf1744d3c7299f409f5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__03eab8e98fa385402cf09ed2ee0b453b7d0ac0e4b7890fa245e2e8ad56b01b9e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__95fb1f31c0c925a8d456af7d6f798bcc505309742e4079b49e53c20f6bfd5921(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__65f7c8a75a92f82ea7fea8815bc94cd2691017ce527b2dcb075f191d3a3bc153(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationBlur]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__853f4172fd3f2dd60a08ac7ea59d14b9aaceaee678f1e7d0ec5c2b232e661ddc(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_feather: typing.Optional[builtins.str] = None,
    hue_feather_var: typing.Optional[builtins.str] = None,
    hue_tolerance: typing.Optional[builtins.str] = None,
    hue_tolerance_var: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness_feather: typing.Optional[builtins.str] = None,
    lightness_feather_var: typing.Optional[builtins.str] = None,
    lightness_tolerance: typing.Optional[builtins.str] = None,
    lightness_tolerance_var: typing.Optional[builtins.str] = None,
    saturation_feather: typing.Optional[builtins.str] = None,
    saturation_feather_var: typing.Optional[builtins.str] = None,
    saturation_tolerance: typing.Optional[builtins.str] = None,
    saturation_tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__65db4f8719c74e8c6360da25f81fb9e6ffcb4f95fe8e9b01817d4cfe3bab2520(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__52912db8cb53a87b9246e4888a7afafa47efc5f1b79e8d0bd6a9c841ee4872bc(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b0850fd535f86680b74f94bb6714adcd08eaeeafd154d5d7843fd68450a95384(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__28b457aefa2b39f574996e876a827e8803bb7656dcb3a5ff0866ae3b7fba20ca(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8d5a9520fb001fc90764081c159110475d4882aa534b5526c6c01ec1d7572d66(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__62cf2baa97298cb5488fc52974ab2215f3184f973f60b88d18806e2bdf2171d3(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationChromaKey]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5520cd0cd1c7c180e8eb2e48b44fe32c9a62d9d81667937d589d0f9fe36cd3bf(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d015e5e01cac37af0c98385c1783c0e92d4a8f601c3b64f36c621d6d9cce685c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__43e59768ff94d3ad68275f1349010239903913c04936c111b7e6244c919bbf85(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2681be63154b15c0ff0527a750d481ea559a9dc03c97ac012ac3d7c03e212077(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dccbe19783d96a0971af42d605c7b2a99b747aa994c19cb8cb5594754daa67b5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__50f0e41594ab3ef2d25f60a9ef0aba5c5644d6309ecaa05d02672d34134f35f3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f9b58142f2ad61cee4de594e0e112fa12fe79a204b669167a1fd8c0322899789(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__96970c448307a16bdd0ce0d009097e467a04df639abcfbfd6d3154f86747c15b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__512671a0e26fb180bc21fc9e3571cfc96e19ea30d553508759833e63a3412efb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e35e3b42001ad9ef76056860e6832d66d6a3c984a5de31b525dfa33f263a878a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a1f69f6eae0d7c12abe2b3bce16eb420607c226a8a7228f215804dee45ebd67f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd50b6bd173da340faea9894978e6ea0844f464c5e4fd3ebfe0cbb23afea9b49(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__26db547095b6a1ad1f76ec6c4a441fec0f1983ae965c24ee9ae6185f353bf47f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f26c38aa033351c22104205cf34d516b502caebccb87ed2fe3bce4d20be2c4a4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__663fc47124e4da75c17e9ea906c1b117354aa54b8dc298fee9aa3a52016f11f5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__efdae642a77329c958de72b928d56a8f844ad5980929f45604d4cdd932cfe277(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationChromaKey]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a5eebc3c7cacab485fac90b5ed72e2344d724fd78f743029d64ad6390abea0b(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationCompositeImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    placement: typing.Optional[builtins.str] = None,
    placement_var: typing.Optional[builtins.str] = None,
    scale: typing.Optional[builtins.str] = None,
    scale_dimension: typing.Optional[builtins.str] = None,
    scale_dimension_var: typing.Optional[builtins.str] = None,
    scale_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__74bef026ebd0fe1c6afa7caa65fafb6bc60ecf0f8adff3528c1ddc030b995709(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4c8a3e39feadacc2dec042ac115201590f482a891d4759d441781d5fd2cd5e63(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationCompositeImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a826465fea69bf5487067df7113b9dc1238a0874d8a138eebb3a82c42ab86deb(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6abb16e8b0a4cf5c8c9b45d04589644ade0663bfe205c929574cbcafb1b9ce65(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8dfa4caab97724eb3429706b8e8a6c23ae7c592388ed6866f2e4327f1fc4f3e1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e9f550c1175adc497aa37d71140b2616561b8d136b3e0aaf7f5362fe4d4dc855(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e8fa9ffbf5b344c46f28809cd13591044c5e3dd44361d2448c5e21b9053efe60(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a1e5748d9f6d5ebac1fb210fe1761b17cd2cb041ae2a35753becc4c08bad7ca(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationComposite]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b52940bacbf3be3e817d460f10bf03f8b9a11359dfbaf03e2a8c7524c961b521(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be30aa878081c9eec01770f86a0eb396efc7a2f1f451b51e98fcf6392f696879(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__02d6ab4d82829b85848769de973d9d39bcf54a84a9286d0081e69505451da0d1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8f9ab4fa58c29d03105554aa4aa30df6401b9df24dd7af8f01d80ca61679e384(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ae606aa8195a006c81155be7593e35adf9800402092f3acde2b3f9e086e7d89a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__56759c9f3b54475105d6198f0f3fd622d1e805f91bc621a38e9b7b99f425a143(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4573bf5d5bac3aaad6f4f263b853d2e3ffca1c1005a0155333b6ff8dd08ebd0a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0329a7a17abb089e0600096c814550ec0b138ee5eec09b02536f52e6bacceb1e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fe9fcb4e6fb451c1c818c70d94cd3e8d77022390616c8bb576dd587dc1737e28(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__73ea1db5000750e67b75d3baa0a245dd8982978a941dc7aa12d4d2f33a20a4a8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ff307364a6a321ace07367ea2402f7c8569d692dee4d4ce8785bb00ca4da0e94(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6972bb0e044de91504f328eaef14015036e28b457d0bb9927bd81d0a31b2bbc0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a20817a054d1c5a4f2e9c2145b5c27cb87f0d4df3715659e754d6f08c5daa79c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__87dd126f3896cff400f4f9f51606515de33c1f71dcaafcefb7d003447eda37ce(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationComposite]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__912e245e086066e1d4ab776c392b40aa340d649a16c30a3b37ad770f943109fa(
    *,
    transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5d226d245216f043782e9545201287ee242b7a99b93e20591070050faf00a3c2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dd0d98f1e828bc8a9d8f230cb8124a5e7d75ca2fcddecb58f2d1d452632fa4ec(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c7a13fb6d6543cd209e1b73bd13ca05d9d1162b4ad44e375fb9d046d8a8240ee(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e846316d058b61eb2994a814e3d3d9906aabb3d4a645610ac64e465742cd22c7(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e8eb972539d4b338161c9f7d9062ce8fea713226a75875d7430c3cb3ce5895c7(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__96f5d435d11fa11027f7830b696fe61d1de5baf037e7559c90ab65cb770e027f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationCompound]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__47901395113d0227814855c19b612bb188aca6feac0f5381ea589ef4fdc4cd23(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__96ac6f99d418b91397659e818c18cccb4d8759597eb8d43f36aa553fcee49a44(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2463ea4b66726064c6b5921b48819772bd60b193b9db19a56572de025b86e3a7(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationCompound]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b159f6a2da4a9b7ab1c13f15cbd690dd3af8445d9501216763845c5065282782(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__afaa3cbab5a8c09ba7da2e16873e3cc3ed5bf9bbebae28d8f055b36f17403ade(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1e84c886807fc6f5b54397fd1ab83bb4c50307fc04a12e238f571d4c63ea6457(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d0fd76aa6a13723d804d16cb22c1c12d4825a98f0e20a08e93f8e14483214263(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__097c2eb8b1fc4e2334fd10b1906fe4822e6d78a98dc5998a998d680159ae8001(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c89a3e56c1b71335daf9b2568a570b9a03ea82cbea899f512737b166dc79d015(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationCompoundTransformations]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cb01811388faf059949afa68f22b8e6fa914fcb5b7f5c1add22c535648589f40(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3c1bc5a64a98615915000058d25b4cebf21ffd1ba10f47775bb803433e097e40(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationCompoundTransformations]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d065744b4b72d4bf1c1b8dad79214232d52616be1d0f1f7776a6799b1964c85(
    *,
    brightness: typing.Optional[builtins.str] = None,
    brightness_var: typing.Optional[builtins.str] = None,
    contrast: typing.Optional[builtins.str] = None,
    contrast_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__199bc96489956ebc4b1b33b1ad66966a8f4bc3ab466a9e1baef5adfd83f61874(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f5d2e0b9affb385864a7485b46da2e51b82bc73065b4e84e06e6d4a2895eb764(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a2e8e007fe3c1f22793e1639e63a31f074d94d2375c1960efeac03ae533b1818(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c15298014d99b2801a7f2f149d3c6d29f80c3d5c3400c436134757798b6ad398(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5db38f9d81830d9560ee56297b67f3ef2ddf7ddddc834155ede91553c82de377(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1441110b3d0ef59e0df0738a164c3524f4678545d6140ece40083c9a8d72fe0d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationContrast]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e0d563837aaf718934214888860e8d634877155b3922e8f78f7d64f20d5dc724(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__55f8276284ee68f7f33aff4a0dbc76b483bff3fd9c1b5e35874adbf0f3773d80(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7e901bbbbf2093ecd055a0bf74ad96c5f9e74d0a77b759acb83a17d557c1cc11(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d92fee028dc0080f8500ab235447e80b46fb6f6be19eb7b71edb2c01b43241c2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fd99f1cccc505106cf96b3e58321ca8409b940fbafbfbd01ea0e800a1912d106(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e165edc14257f9a670e71d90ba18961b2018f9652a354278ab97c6882d203cec(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationContrast]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be5f14aff0bb08b5fee9409800b1ff48ac3d189774f872208a6ef16ee94c7e04(
    *,
    chaos: typing.Optional[builtins.str] = None,
    chaos_var: typing.Optional[builtins.str] = None,
    density: typing.Optional[builtins.str] = None,
    density_var: typing.Optional[builtins.str] = None,
    power: typing.Optional[builtins.str] = None,
    power_var: typing.Optional[builtins.str] = None,
    seed: typing.Optional[builtins.str] = None,
    seed_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3885469baf060fefff5ead5983c6f16d8d6857f65765e99825175a72df9e50ed(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e2af40eda0f28d0036617405b0ec62ee763dce62511a9e422da8543d25e0aded(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d224657c19205a436b69f14b19f4bda02b7e4769c89c5029582507b78b6f3c25(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7f7123880e8f11c83123e4ee639a33bf52ae4d25549f0dbc2907fcf5ef4418c1(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e047623900b3f6063f316321493e79f4349b6fd6ad43a0ecc3c9c52d633de219(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__387c8524fff90b809e91cdc2ab37fa4fe0112a2197668ae77fcf5332ef38a499(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationGoop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c7d9216c9e256d8e28630b30ecea94c363eea06bd833c1e2391a38305ce3db87(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__904a440c6a0940c97bf05534e6495d85c0de9aff1b6bc3bc26119c8a03df1bd9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b3ef4c822add4aa465589be8ca8a23aa825496980fdad4b26bf4f0fec67ec4dc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d1ae647a9553b4723b5c1693ae23e20d8723ab3c93dcbfdf6891679037ecf612(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ba877e9e252f8facc17ec1f80f2583769dbc25ade3e9e6f9de6465eb1b8ca94(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b3786f9eca01f9ab141172612b30b368321cfc32207ffeb10f8c2b8fa01d30f5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__69b8d0e70cde8b971ef19470dbb8fc200f4dd6939722cea1a1f83d6b1ade8a8d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3b72773f5e9e636befda35c5cbf0f8c723e9cb287598ed70ae426b92cdd792fc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7bf8f8a4c487a955d844f101e28624ada025e0c5170a1407219a329919bf8339(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__595939fd27469ead35661213b1c48719b99b042d432dca88923c9ab3e20e45ea(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationGoop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0914e1c8313fc066c2beb10d82890b9416d622d420e208042a39a752ad1f20d2(
    *,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__da268698e0f3aa2eb66d2dce5a1498c6c71817e770204320ba0688261677bdc6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__41bfec46677883e64c098e05fc22b04ca91dbfe9a9cc6e9fb252a57573c838aa(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8f2ce157eee0cf3833fafcd27df4fec90467cd1f952344f7dcedc85d733f0f7e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9539113b0b6ad79f7b0ab0ffabb91af8b688d3d03e8bb66ea81b0d037e8aa041(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__51a94ad4924a66c0d2aa77a8859e9f1db8932975e6a3bf115e0b75f060a66481(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8b7c4ff1e128ad673ceeac890e3712bfc09b3d056bdaeb647b588059134c96e9(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationGrayscale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c6bb3f441f9b85979e230ec201f304b3806c381254eb06ca7ea006f89fbb76fb(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b2713c3e38ae3a6e2d3a8b09ed8113d6839c83ad9b4f39908e1077430d8a754d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b6768c98897af14601de9db63a8fb94119a2e0dcc8104e886821368a688cc141(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__91117a2c80c3119fe7479514c338ea200f5161c17942a4d08d79a1f33ae606dd(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationGrayscale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3f16202dcac0f4606798592f9cc2c69aeef96b0956def92b4a5edcbab3d98756(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness: typing.Optional[builtins.str] = None,
    lightness_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b1b5b82ef43d937f27b7d331b048a9d6de8abac4a8e8500f18c553bd2a10df4b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3851744fbc96cd1da7e92eb3cab0eb1273993eb4d3d7f58eb3484fd83a14da2d(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__42ce96e7def528c05e6ac653f0dde034e8f7ac50c5676949eff49241c803947a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__677f7650117b13820a3a96667d4bc3eecaca049542e0980b55b7b25f93e15faa(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a4ab48af4e40f1b475a73208f80041086928eb9a117689a82d2082e2c6887850(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2709aafee2066e8abf95cc26fd846b8b3e3269ae4394ff2c1cfa3338032b20f4(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationHsl]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__723af49bf369edce7aab5bf92828698e4ce83afd2793addd72e6b06ebfd5d9c4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fd1a9e2e01a8ad61dccc0f69c92b033f0b8880d2deae95cebd53a8b844cabddf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__928f99fe41ca15a111835ca432fc7668e926d63492d7c33f104bac0b0832b83b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d5af2434b02f3f4e6bdf6d5b817211bd55201c0c7430b4f63d1aec96f32e1081(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__43efca915ad5dc678a80a9f5b92c5c63a03b3a8531b3f56e944ea43c7c2e9bca(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bbec86efc16e676707276e922a72e2fe25a5e58da37a66563455167c7f57358b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__de8c3638208001d84a6de0a15c19cc9aa958802ad625c764ca3a0d0339c11a21(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5d544a09852a78ba8171083b66ee4f984b59ac854ed7032b046fdb815b423c68(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationHsl]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__473c08c61de5f38da4095cb4c20f92d9b31aa080e94c700a52fdc8ac06749b2b(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bcd1a4de1d4f459f570e5339817e3979884cd5bdef40855198ade9fa69b2c742(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__38d4370388f2c9141122b03094b2d4240eb6fc7346a28f20dd66ace34d6eb11d(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b62cf54db2d29cd7af6ecbe4cfe643e03ce1d8d6704f656d4efcd691e1b55770(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ed7142dd04f3e2bfac93cb4248e8aaafdf7d1eb6c38c55194365c06f30d53af0(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1a91317690c370c76072d912861ce82e5fab0a37835bc4a0da0bf51697bf7e86(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6ce192ca07d6cb602c7d07a8419442290c4da933d7c69c36dcfb44a4fd8fa056(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationHsv]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0a5b8c97d6e8236a7c37dc78782b5dda3967aed6c6635d7b2ee23476838dd9fc(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__661dfb8aa5b5f1c782a08d191b245a9af1b76729c90a5ed0ec5c8de495c4f58d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b8f07c361dfc6dc9b8ae01d951f59eee9357efc3c5df38a40a5b57680a00f589(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9287dd179a74c571b8b6893b689fe83d1ab0b3ac5e94064c1ba758d23017edba(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7c1570a5fe98281ac99bbc5b56ddcda5783b985a3ee5d980e77a1566614a169f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ef360c83bfaf5ecfd48e6ae956186051e49a6e73e3fda8a54f71f3414a770c8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d826a71b7f71b7bacdf54d6e35e7b7db6f601466e9c0513b2181aa9d316ac4df(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb8bd4099febc7ea1b10737d3ac88b23937d8d63fdb0ed34ca124854d2491cb1(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationHsv]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__88cac9c38d5b59ba1f029d8321ae07dcd4989eefca94ebf01674138d8107d7de(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfDimensionDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    dimension: typing.Optional[builtins.str] = None,
    dimension_var: typing.Optional[builtins.str] = None,
    equal: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfDimensionEqual, typing.Dict[builtins.str, typing.Any]]] = None,
    greater_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfDimensionGreaterThan, typing.Dict[builtins.str, typing.Any]]] = None,
    less_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfDimensionLessThan, typing.Dict[builtins.str, typing.Any]]] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__05d76e76add08414bb62c2dcc8c09aa174024e2ea8a97409bf62be410a36d66d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9efd555fb32868f09820a5451fb4ef6607646cc70631230713f532eef1c5255a(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfDimensionDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1229e4d41a4bb63b6a34b5c62411914e86b8342a8d580a41eb4755a43bc6b342(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__abbf587d88983d049f4a3a575e617bf0b2b1f1ed3cc6e242f75f4a8c6fd20393(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfDimensionEqual],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df4517fd02743cbd05e99232201c01e98434c89df9d116d968c48166f448bd4c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__11be117227523b1707fc1f26e77b83ac740c010e8b1ad3457e8d0ab8da8cc15f(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfDimensionGreaterThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f584d64be11c2b7c7109f7bf0c9cba78e87249c27d8af1311b82e244b29b3ccb(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__535b4c6da6c6ac88075cd20caf04c4e9d8e5f974357c13a5bc323757e1e9bcdd(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfDimensionLessThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a5f6c5616c1658a9678ec8c01b9f01f074f4080793d81ff5a8a39d72ba70daa5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5dd8e12793c9da02fc3ea241a3f44ed3559f89c212b8581ad062bd7d503dabd3(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2fe02936aad959c4afd2bafa8571d41f597ff6285d0dc895834d77c2ae474166(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e28882c9eb062edc92f9c41a9e31ecb604a4943323d29b776fc9f8d238d22c6c(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c9ba17ad14975bd307ee670f80d22166f273eeb0de2ad688debd52ee8acef02e(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7e2df4b7e05bfaa6a061a7031faf360ffa01376773030b024fbab8cc29810035(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfDimension]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e228f64348047854042e557ba61bc185fbffdee3959f6c1ecb328d60bf3faa7a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__758803f659197a3b38530d4bc9a399009cdf3917251f4db2c0816493023d7eef(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d3250804385a991073971cd776875839fc34cc0cbf6093fb7c04889722b5a6ab(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a2956189d791d22910bebb34149b43f889477a5615b2e95085823705c1f9f3ef(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__843307562cfa6567be5b69a61c2f8dd601ada57cf66e994c3d88470a1458223e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c97c0ea7737d7079764263b1c68f745e60f56454bdace0aab5a1dfc3afcf54c4(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfDimension]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__342e7561ef7e857c3107541316ff871bc844ab6929b3eba5c6dfc5d17842d1b1(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfOrientationDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    landscape: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfOrientationLandscape, typing.Dict[builtins.str, typing.Any]]] = None,
    portrait: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfOrientationPortrait, typing.Dict[builtins.str, typing.Any]]] = None,
    square: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfOrientationSquare, typing.Dict[builtins.str, typing.Any]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3660eb5dc5071055945779e7af74ade8d471a20cb942b3ea60c19cbbd953f556(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__77bd8dd02e18552aa063aa90a358b223bbfe6182c2726730f0530a5124233aac(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfOrientationDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7869819439947acb3f7798a64db23c4673559cd5eab175f24d9308294cf9192d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2b573250da8768633ef9e0bc2c28a7725bd8b3ff5886206f52e2039b06855da1(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfOrientationLandscape],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a2c6325a4410ab6014cdff464caf6ff596ce3e68b4fe1b591e83c7144df88a21(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ada6cf0051e5aab7938ad2e3c7d3824f6a3442c846af9c654d2dabc473b7acbc(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__60b89d93f410295e80648f25fd95ab75fee1b08cefc6a58a40c97cf8ab42e4d0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__36256afd2a8d06ff611ab6b8f2de90ab4d8300d9d462bd79532e31978f10ddf2(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__007b763d0ae569395290ae731aa3ff44ee42624fa3193257246f88111e152937(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4d330f62c0e5679296fcc1d5bcc3a3dea96608fb941bac7509eac6d57df701ae(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfOrientation]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1bc2ae772e59f44f33c97b2aaf103ecbb8a513664291bca59dc449b33bfbe641(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6d4250fcba7c96469be39a863427b202659c58c6c4c724d608df273f9dc566eb(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfOrientation]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__450616edd0d3994073df004e2b228fe2efe7b2c520ee68f55290a792e79b564d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6b0b62c8d0573a1fb62fa1630125075c710271a9dd6a0f34ee75a15c8ed29228(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfOrientationPortrait],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dd5b7026b6bd8ede01728df34508a239ced7772e624a50813b1af1634377bd6c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__faba454d30117fa4ee32fdc002b971f8461c2e097b2465d9612716e27e5ad035(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfOrientationSquare],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ff0bd53489417f5017f17367f3b1b4a06532e393f135119b44acb19ee365c201(
    *,
    colors: typing.Optional[builtins.str] = None,
    colors_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__257714038a0383e9f8f30e71d54da602bcfe6b10f0b95db33319998e807c249e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__398007519ceb7ca23cfa6bbd4d361528cfa3cbb9dc1fba0bfd26ea1e7b38fa20(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dd7f8c8b2c2b91230a85d0752cf0547ed523983e3bb36393cb12c1b3ae3505a4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__31567fa75e116d93415b8272d101af956faed6462b608c1522551040064d1869(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f5c9fecba8408a3bf839f30d3be763f9d9175ff46e8793b856cfcd543e4824f7(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__401ec9930af5eef9888cb98642bd1fb8e02ffc59519a62bd03ccecf4df32b743(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationMaxColors]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__03e5fbf7ba05b3018ca171c2b6e84e33f2306846d558f2215da62d04a6b89094(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c9d911b33d4fbf45b21973b638e046c00996fe711718f3ae1249c90697ca0cd7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a0790e83c1648d2015beab954304a6743af19948890f4635b961d415cc83296(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__597a6bd1a4988cefd6d89bc8468d04f36d14db22d0b99dbd530d48c506a9d957(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationMaxColors]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e0752013560400418df32f91fb3e5a9109881790dba905aed064a45d5d76c8e5(
    *,
    horizontal: typing.Optional[builtins.str] = None,
    horizontal_var: typing.Optional[builtins.str] = None,
    vertical: typing.Optional[builtins.str] = None,
    vertical_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1de7275ca5150c27f8ab34a3502ba27d83e87a598c68064178f13f035fe2a365(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cb4ee297b8ef275bfc09f777fbe8af359b847ed9895cb5c9b1d0d0dca8d5f621(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0cfd9f574722ce7b1e3b696a769971956bad29f83fb1193e2aaf82c5729f4796(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__61df5164eb39854de294e18ce406a9bb2a1d95ac7afacae5612c3f6efeb58e34(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb9aec9406decca5f28553f52d6132ee7e08821f0f41f100dbfbd01ed30286b7(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d387babefe9f9d9e57b6202135d14c77bc7131770de897015601a13949b934d5(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationMirror]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__868922dbe92859d174f1c10fdf28556c57b3b4bf201e418813681da27429e190(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__27ddff1bb59dacc97ae5293e794280e7bf70604c632e6209340935f20f5f29cb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__40059d463f8a2adf16e20d9c87bb741ca8b9ca2787581f4471a2cd4ee2c43ba0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__18d605c01acbc476f28b64a6832464589db983c9e3be21c3e9dd6bba54a5c595(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f9dbe9093bab185d837249bb15b7d79ce8eebc356ce10f5f6e883379afc82a48(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9782310f905baf46cbe62b6025635dacc9c38dab9e9785ef4383a8d15b1266b6(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationMirror]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__239fe0ec118b1cc368e9eaaf504ed46fff13d3e41bab2480a1bc303c5dce721a(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__42516506093a18c72b77f33564f297c3a4525eb08ae791a9f18b3087856cf0eb(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3339ebf0482874c4a926b405e01b77cf043b45529d0a85cc0debcf09d98e6116(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__740883ed96d118cf059889c1e71acac08a9689b7b33cf1975df862228e323e7b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b991a49d11a65db94a1911fb4c1de849e34e9199e42e0eb052679fc4193b7273(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__63dbbe0426530ff7633e6b395e738da8d9affd1721211d47772a5602e69efc6e(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__755f751d5215ffbd0648b8f24a354b4f7270fda941144acc937032c475a097e2(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationMonoHue]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__90bc3492ac214e1b5d8aac361c380d16aeeae5a92064517ebf771a9199c2e028(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b5170a4b9f25a9dfa8d4f303f6ce2e477bd7eec23734a3edabdf64c4c7fa10bd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9e66469a6eb3d607086f4bb6213b04ad230678aa9bd5c11eb5671e2765c54514(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4fc8f52cb24b40135f8e9b90b7d520b9a85290a38d85996e8d9d0c1d1c63f075(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationMonoHue]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a1bcc1fc268c694953de7446675f89889e3f8b771c862ff0b55c4280dc009d3f(
    *,
    opacity: typing.Optional[builtins.str] = None,
    opacity_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a4c646452a3cff964adc7d9d97c14dc7dbe18ad9baf5aaa55d07ff1579bd3877(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ecd47719041a87579340d8713c4b6f76a6abb524b856cc127e0acc46ce69a2da(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__658f4723871496a0af19159aed004bc4406fa7095300e37e535a1ef839df9cef(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__160827182e4ceb4ed37220a136c535aa8d3299a466ed5bed0bacc36fb7ed0073(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7cae618d2a435568fa9bcc0529ebb3cae73f260e0e41288f4e27ed1a3555b07b(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__03d8b591a60020f9c2f4538fc20234ec7324dda34ef61a58b5bcec0c44c4724a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationOpacity]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__498e791613298289444630f406a742efcf2c4c2b37f8de356125e07fe418b0f1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8e26653b7845337b1b58af6c7705526f40d23f8a48c5c23d5a60abc807a338e5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5fd3e1ad4ce44cdad52ec5a151e39524b6b0fba1f6f0ce887d7aade0e1ccd69f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__76330a198c2582a8965b6d6a594aadadf1c98d4b2e1815fc09093532924dd2f7(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationOpacity]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8e471b78a9c3e7cabe5198ce9a98c4cb5206fc2d27a4943ce4e567a753430cf6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9f01a44bc51466362ed3766700bd12da7b6f90e1a5370f95ec2bf9dc1acf09c1(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__994e34616d3a9515cbada898c2037bdcaa20782418eec5cec9611f4ce3981fe7(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationBlur, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__225cb0d28eacc536a82369e6bad8b636a69f682f1dc9bf0ca3dab93623323199(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationChromaKey, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a76a3bfaf227196dbc9c779242ae45d7a27b73e054741cc5f4625cc6989feba2(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationComposite, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6bb7e26fe92275a04a1f88e24bb1f9dfeebe9b9101d8ebe6b53f1e6541ea3749(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationCompound, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eb129cb8a62c9140e1ca04a736d99cc5654fcb64dabd385df6110ea0dd0ba759(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationContrast, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__15c3fb21bb3c1fe10d34ea71e22d437dd6360e0b7e379d17869277ba68987c0c(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationGoop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__db9f677fc77afa15ca14adc05c08d0551508aef35487a245bb0fb8f53db922c1(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationGrayscale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__305ac829ca0b70cc3b4cce9a0802d831dd6d7303b677c4eee755a9e56293c1b5(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationHsl, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea810f60119a57d43b4fed3001614ead5aa86ab00ab7042f0fc1eacc1f5aa0a8(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationHsv, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__57cfa8a9d0c59471e9f37900b29ee6c58caf1ca71ed1aaad87d8c16060f32629(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfDimension, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f527a7cd86d3b6896a35aecff668733b698d7124afbf740e894e98810491ee3c(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be832f159b15764f8038e0ca94039be5290e6aade9cb96456d999e14589ea339(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationMaxColors, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dfec902a3891eb3ea82ae054808e81451e419fa5d57f1d61332fc6a00aefcece(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationMirror, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f8f8a571e78a46852d790da872971eb0e8225ce872d8c22818f71dfd83aa04cf(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationMonoHue, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ef00c1758a80fcb5c5309564245c8c5da19e2025100dab37d22f18f024de8908(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationOpacity, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d1d6c7d6980d7bfed2689604fa04eb333be97aedda1ba0b91e6c396ebcd5e4dd(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationRemoveColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6a6a67b89cb4b20788dad1e286f74b1866274321f065f5390061e3f9646aa211(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationUnsharpMask, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4d9139cd6fb3ecd403e63cfa95bb43f3757cc8d3a82409d4679361dafd8349e3(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__52efef93d0bafcb928e099369568891aeb76c1ab4a1ea2163e5004a526c45dee(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
    feather: typing.Optional[builtins.str] = None,
    feather_var: typing.Optional[builtins.str] = None,
    tolerance: typing.Optional[builtins.str] = None,
    tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a4f924a9370f3498642ba798d96fb04d10249f1a8cea5ce69f9e03dacb621e2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5a6963192ef58e7a4d5f39af0477a762c190bb4e432e4347764ddaa1e9b5c6ab(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8611e9ea923f763329ac86b752a84dc677522c420c96464af8aee5865e83b038(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9bb95660df416de7f4d63455983a66dd050b4bf2e99a4439dcc4946ce3a9935d(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__81f30b5e6cdff8b061a5c10b8cc2ff883ce8b3d9e7c11ab7dbff1442b0ed163c(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ca3c4ee9cb87a71470606a5a711b0807d1e4defac8f8f239146402fe4616cd6(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationRemoveColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__44ec84348fa9321b382991627f2c60f547a0d07015f529880ab020bbe310f9b9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__25a9262c210da64a9b81d610e47d51feb79e515f02105ff33c9ec85e8d20daaf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__91f805c3d306a43c56ec4d7d02bfbb22c0fc9f635e49a4daf7a6c1f60457be6d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2bcee6dfc96bce75fe166a20c7b2fc4b5f5b2aa6c4a0311de386d4a081291a40(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e0e77d80357e485be35f1439fe4f6d7dd5722b174c544b27b4bad17552897ea2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__93dd59b81cca7e29cda6aaf3f0190157d00aafef1b21df0ede4a46db34fb4d61(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f674e776b4bfd16378db90e61c5e69e6e5bbe628973f332623f373bc56a671ad(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b1f5a04d454ead0a941ba0c4c84c712f3c25a36e7a78a683176a6e958bb00c5d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationRemoveColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c4f19dae1d999cac3641a12bc78a18a3a721a06fe6e9fdf426f4b518ff5838e3(
    *,
    gain: typing.Optional[builtins.str] = None,
    gain_var: typing.Optional[builtins.str] = None,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
    threshold: typing.Optional[builtins.str] = None,
    threshold_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ad70b83c60212d96311993898b6d6c6c2983b3b82dce76878fb253082facbfa3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e8776c21d4fffec63c2b86323a0930a97f24803e0c439d4104647159c38aa2ea(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b415a687cd076e114b0a982ddd0d4c8ff14e868bf1e59e5bbd208518c026d214(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6ba0183f35e8c6acefe1272e0394c5afc8816a4870c304482ab8da0d530be09d(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9b0b0907cc39e26f2cf0ae46a52bb1884a9181f0e261f8d5ca965bc4e6eec7e7(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__436625e16b3b01bf6c975a06a174313780f4d164999b88726ca31fdef32126bc(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationUnsharpMask]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ec317d6b101b32818bdb7872f7b05488edb215cc6806f2e414e7227278fdbcfe(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__80709e80d0a2d1571b7b65f1bdd8df9c2a68fcb12a1cde03cfb81daad7ee1344(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7dd551882eb9dafa5f2515b66faa272e6826fee92c2202047971f3538468e5c7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__220f23ff439048040011270b597fe08571311f8d42bbe579443faba93a166d8d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ff182a1db22c305bf21209d4c90743a22e60d9226efde4fdf5dbccbb4aa12c64(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__77053b189eb47ed5c6052fc952415da255a94bae305b4277d491c9bd7a88986e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__68026356a8a607d2055e6c1a3bbaab1c33d92e7a8835d44bb96ac3c0e92a531e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0a7643b219e2ce0e2a79aab901c47e9278f4e256a8b73a6a17c2f424467ea6d7(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationUnsharpMask]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c1bafc0231d1fb7aec79bf9d38d39faac2cd017f26011d866681fba1ecf30352(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__545241e5c822c7101c451f29b6fded7f77d57c982355ff1e012b018539d0f012(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7758e69eadd2d3dbb3ffd98618684f2468876e920345bd4e8f71c3dbc06e6a7f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d69b827978f19ced5d73d18a13b21b7b4cfbffb44bb5ab0b4a0c5d8d8ed4593f(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5c1e6f1765489182ccdc791e9683fa7e86432dd38410e8b69eec2f932e0a6039(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__65d0687df459135bd4f4733e80b66efb8d0158b65d9d606ddb99fff6bfd93352(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsComposite]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a58a89cf3ec0292fad32c99131830b4097894f09a81078ff417eb2bc438f82ba(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3517d88edc4e1e552b4a24f293f589d3a92056efb4b63139c896f303d782bf03(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c8d1ea888993d0b37235134f9635c75336140189694e7a44808551676b8216b2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__924d3ec12ddfa343b9548221d9c326bdfebf4c21634c5236e31d8075e722ca7a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__59bf97d57c5c05f810b31e3b2d5b0762f39dbfd31ce794fea0af13757c031bc9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__18cd906868d84cc7fffd9016856a110b63f6b883d41b12b95601ffa1bdd4def7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4216d135407b2d70cde7698853b0b65236644fc2b266ca73bedb3095bd7ddd6d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0a9913efaaf2744d94a68661b9795b9507bdcbf61f62dca2378411a8d5b0b1bb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4913008fb4c086dc2f2c277259b5d8ca457fc803d267b50965777a35863b6842(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0e3fc7fb84cdc04bff006e534fc4b278049622b6005206b49b396cb05eb68585(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a7c09f791801a64722885de4f8bc85385c2a89e2b0f3e054b4844c87335902dd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__246a9db2664e4009356c28871602ad012cc4d202fc3964cbe3a3021495c307f5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2e75c7779852c86fb709ccbe513e115cd8c0f0ca467b01e7cbcc7633565a79ce(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9faee3f765ec3b19d90a4070213da4eddb452158d891325249b7acfaca3656bd(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsComposite]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a1f63fbcb308b17dfe8adc41d8c651f313f3e082f4fe08f7a2cb2fed9ddeeeb6(
    *,
    transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c43381b92577b2aae4058b532e5642fbfdf32d63dc469dcd5df33043ef8635e1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb7081d96b9a7ed7057581dfb43e66da39f817d269e4dac6aacd1ecffb6ae5e1(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4f3ee31881d4dce9966fac9d77c389d18446aa2df0956d57446165fa16e4160f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a3c3eed571a05bba4f268d43367c0ab4b583a5b66acf0cf76e35cc025c0d8bd3(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e11913bee00d5d8ac90f5663885463e3c0f56014048266a5f61236591afec9e2(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7faa6f6377a0e44ef23eeecef066473fe635c90f3c89a30c06c797406b97da43(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompound]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__97a558bf6e7169b2778fa3274266101c849ae4db26081d594560b5dbbfd0a3fb(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__131eb89f1e3c20fe7dc8f4e0595b4f86f441dcc2043b0fd9880974f3a5ed9bef(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0d861660bbeab2b66b583e5f9758123497d6d4a03aafe61b6830b3d08ce7fb91(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompound]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c951c2a8e44f0f6bb8f6a794aa1df990f8cc9f0445f371bc8ddc8124edcf4164(
    *,
    background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
    chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
    composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
    compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
    contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
    goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
    max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
    opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
    remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__42497e51b6217f290465ba3f97aa7739503c1e70c0190cba2564e07e348f32c2(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1a6800ed89e1a280b1c7eb30d46b871087714c779f2b1ca7240f5964128e3947(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d3c598838f50e94581d3124c1092e168cf72176bfcc890ada2b04fbea0f2371(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fdfa506e6170fbdf717f32904a26441262aeb74f3a8ff84ed3725e84add9ea70(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fcaf500dbe1d036c75c01b298b57430b6820adc45a52950e10af77ff4fc29450(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__49527e39599077cc610f76b178e90cc6f0df3c60007af4175575fe6d0ddd1fd1(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ff9edf1b4807177f5b6dcc3b91fe7f4bbb2f441924fa9505624acf5083b22257(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsBackgroundColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__71305ce1ff0ebdf8dab654afd26da386375a81e57e38378635b80825bdfd4bbd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__679b75c6339075fc47b2f1972dc7a3dfe3478ab29900fa79d57d946b484287a9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__09ac87cdd05b2b1307f94640d378edc1cdc1fb91fd886fed67c08225d845fa7b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7b97af21294394941a713ea4967fa74e47d68f6abf53c2779e396b7bc329674f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsBackgroundColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6562c7f0f32954bc047ac1c48b71c156d6f7179ee95b75e7cf0bc965eb04c503(
    *,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__98e8e683f4ace09eb5b71ee38b45cd2697ce3e7ee59cada057bf4ad18695b1e9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__25de19294783acc4484f2dc31cbd743ea9d7dfe117c8c0d23330c259f4dc4bb4(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__697ba33497b016394b269a059b6401ee9ddecf14bdc3d1810e6687df0e764d5b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d6f3c9fc9d3e12e54ced661038682d25a492c95b7adcaeb1487bc1e83f5b9b3a(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f3262a5e90d8181bd64a24552ecd678ca2e0a3d7ec8e1f90caba8341c341615f(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__844be7430c0bf73d49031d7fabf9c93efa4b8a60128970396fb9baa2e881cb5f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsBlur]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__224fed1ea1c01c20334a0f766970feca9445e2fe13396be6c0b35c7e7ce281d6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0c28271968495080348266dbc22feafe7fc087e91e9b66d917981591d40733df(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__38ea4c76e7a5ef5f2ffda645f8eefdc29c9c41a6e82c7c9c1aa383fc8fdd1ff3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ca801cdc1d916eb54f87d66164cb66e5378642e59bef840e05fef571c3e78853(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsBlur]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__efbaf35fb0036d27d9058e253d11fe11467b8b47479324a4835c1bc0583a29bb(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_feather: typing.Optional[builtins.str] = None,
    hue_feather_var: typing.Optional[builtins.str] = None,
    hue_tolerance: typing.Optional[builtins.str] = None,
    hue_tolerance_var: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness_feather: typing.Optional[builtins.str] = None,
    lightness_feather_var: typing.Optional[builtins.str] = None,
    lightness_tolerance: typing.Optional[builtins.str] = None,
    lightness_tolerance_var: typing.Optional[builtins.str] = None,
    saturation_feather: typing.Optional[builtins.str] = None,
    saturation_feather_var: typing.Optional[builtins.str] = None,
    saturation_tolerance: typing.Optional[builtins.str] = None,
    saturation_tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__963ae9b2c1877e66c62f92b3bcd83c42c0fb2c498936e62c12f69b38ce21db46(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__17bb734eac2453847445152a45bb5e27506d7dfe3e1a45f15252b2ff92651de0(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3f61d55b96ada200716d3d481f49583fba0aae9f82b2ae068ce161ff00f85fac(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__56d58058cf8bf62100a2dc598799065ddb644487a682d9f89253cf4e701d127d(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5de1cc654cb40ced373fc8ca891b6ac4749475311df4f70925fa19da1fd0d4c6(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9024314d955c2cca61f3fef658274d8c277531a65f88bf39de5d67c539d18c61(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsChromaKey]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__681b14a4fc3c3b0cc17d553044701d12d67ea1dee95c78cfc5120aacefb86435(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8bebe3ff53462afd0c07666d8f0c064f2a03dcb89dcfa6347dcab81ed71b01f5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e7d3bae4eb64af8511c890a5e0d716342857ee2e01269849f5d7c97bebf4e6d6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a0460fbf6ab9237f3d0a19fc778802aab5f9d50f2a9ec30ab38f9a44cb622e08(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ec4fb600f404ab62be3e316e5d58f7390ab27d6cc370a720c10959307ee3e84(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d451f19c920d44d2215fa2d01c0b96d6cb13d30f58113e2423d8098c31df3c58(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f448dab2a240d8cb27531738c190f5ddf373758c5c222ec04ef4fbb93eb4a64d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fd266c1a89b7cbdda4eb73bf3ba4061b5c8f9dfb17b6223f0ede76d4a02765b2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9dcba3c690708ed9207c1dca26fd3a8373f1e7fc7bbe6f435143772c1e30509e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__141800fec5410a22a9a5554e20d22d221d0891a980e616d6be0cc84d6e99a64c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__787777dcabf8db7b9fda0e57f0f5c6cf00925430ecc9b370318674d7e2728092(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f74c103ccd9fe3c485a6b67b4ce686b07e812cdad709e35aeae93f62af04cf72(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__256289fbdd031f79729d15c1f7cd266eb540816ad13403d2b955463e94290e65(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8d0a292b506e4df0853ac4bd36944f58b5bab7f4702f43bb01f90e45f295dda9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8cae80b2c5f9cb190d81de7e0392f3a654d3990d31768554b191a4cf46f8bd44(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a0386b2334f7b80e1f5d379a9015402307e5e1fcbd3597011fa2e135cb22666(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsChromaKey]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cbd387dfabefe60783d2e7d2fe38ad3aef86de7fe702790e60cb84e7476ff4b3(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    placement: typing.Optional[builtins.str] = None,
    placement_var: typing.Optional[builtins.str] = None,
    scale: typing.Optional[builtins.str] = None,
    scale_dimension: typing.Optional[builtins.str] = None,
    scale_dimension_var: typing.Optional[builtins.str] = None,
    scale_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2b5ae45ac022af1eb5008f120750c2796dafdd87157c09859113982967f2f2c9(
    *,
    box_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageBoxImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
    circle_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageCircleImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
    text_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageTextImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
    url_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageUrlImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__adc1a8cda138857c4bb1155d6208e3180dcbdd8babca1885ce5efd79e1658976(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    transformation: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageBoxImageTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__167e127a4081097c66d8b3fa4f5f09918294837c876120b6574dde7a9e10219d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2e773cdb652ea350964a4aff0221b529131f268992b4a95662c0e1da2f4afd1d(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4eac6f7c280ff9992b5abed3429ab4c465f718b3648b7eec9d8fb3c2b27fa361(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__271256439dd46784d5ede7ea09936a30232a19ec8faec665a0b30c24f1b559a4(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2b56810540212e29d2f4dfdf4f883dc69d8789cf0f6a2734c03cea4cdd800f12(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c3ef3c5ebbd4b7f8c756d6df95662b53e717ecb44e942932dde02379964c867e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageBoxImage]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__24f2dd6607f4db527b0b12f41c8f9f444673acbdb51bcab8b1ebf45ecd179106(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ac536b6c8ed9f88feeed2daeb330cb321b1645b5eb9e8538dcc548b5a4a306b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__25ae43f79f5c42205cb2d6bb2f9689216b64c8c09412f507fe9985b9bffb51c9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a283112023befee96be1387767a66d6c0b28927c75c59cade7e4723eef6ab8e4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__30851a7fd164b369a9eee8b86eda189ac8da4f0c1a3377951d5b054c6cdb0a67(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea91117149b6b4bd1e274ee89e5936195f69106e9439ba4a4f8bcdf3abdc2f58(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__145b76766801e398f7e809e7d75d4f48b99b658387fcec4ab41ef7ebfd8ce808(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__71f2b92ac6cafcdc71dd918257aa7f3cbfe1aa499f5ea8db8b783198f45fdd37(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageBoxImage]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f99b0e1b97f48fc58ab4ad0a5015d2d07b45d93cea7208f2523650c9f3f8d3dd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7c620b70fff52170bbd06c82433de6d5c48d7ade10cce7301158edf4f50220fb(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageBoxImageTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c20ee8e3de861a2ed1a7cf370b45883a9d5b6050a5d696bc22520658d4c9949a(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
    diameter: typing.Optional[builtins.str] = None,
    diameter_var: typing.Optional[builtins.str] = None,
    transformation: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageCircleImageTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4015aaa6301598577b9aa1e1a2469d2a32b13ce3a6aad9853043289e9b27f295(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ce3e583e885e1484f6f1b1e26a95c1cd06136e2eecae299793012bcdd54153ff(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__03af6f51cadee0efc6e3adf0c3f3f661fe6114f9b7808f8748849e76d827cb23(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__23f4b9cbe7d1376d483005cbbc2d1c796d255e64eec3c67b43e1ba3d983ccaf9(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a84e48a16c65d85e9c3748a613c2b2055704a36dc28de9351f708f682b892de3(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__506b53b6ba424e2f1a056407fa6fdd9d130f8fa07e5b87cd889fb768fff04f60(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageCircleImage]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ca8044939842497e19ebda7a5b1dc70153ea7b93749c9f7e3d9a71cf075326c8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__12dda14f0b010b7f1c38ca049a01271cbc1cd38aa07b825647aea0844e26b433(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__82998d78e25d025015f51489ed051b03c2778eaf03b96b9d4a7de66c08d80983(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a99fc73a52cc8547a4b3c88eaadc11937f72415c8584fa3485e435435e8713b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be8817af6b9147ac6ac3386d953562d115717d885356451284e55efb8ecb7c97(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6a5dd98020752f60abc0b10d1eb1a5dde484abb77c0e883a447173c4bee5e199(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b5658cb9bbca8953780d9f3990defb8db3abcc96829076566e53c3797670ae50(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__79b2fbd42568ff70af58f2c1e1a0ff9cbdb9d4454f8a40415f51722582820f69(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageCircleImage]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6ae5ac9b562b840d95c2b6dfb13944d21f36ff4bcb7736ceca2bf31a0a2e63aa(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__80ac33568d191a5c75af7d5870e38351cf3a0877d0050078f5ecddf0742281c2(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageCircleImageTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__adfcd5e0a15191723a1c21355b88b445e68e4e0df175caf5687babb82ddf8542(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e4cc57292833a5859698b4572cd1ee3630b857301610fc27171dd387875513ba(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageBoxImage, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1eda4f46b81b725ac925ed769a3549fc71bbb7b7fa9d450428b4dc810f4bc01a(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageCircleImage, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__750fe57f73b93aacb7146176ba867f0debaccfb22a78c1b5a35499a451521747(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageTextImage, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__83325459a02027517eb261bbce7d1c39444f8ea7e4911046014fe8843e8771e0(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageUrlImage, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3219be2a960590f05bdf8b38904407b53295f2a8cdb401599ec7b5274b787fa1(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bf9730e2501c28ef7702728838d3e0317a30a17e6fd035cd3be122d336e9c7bb(
    *,
    fill: typing.Optional[builtins.str] = None,
    fill_var: typing.Optional[builtins.str] = None,
    size: typing.Optional[builtins.str] = None,
    size_var: typing.Optional[builtins.str] = None,
    stroke: typing.Optional[builtins.str] = None,
    stroke_size: typing.Optional[builtins.str] = None,
    stroke_size_var: typing.Optional[builtins.str] = None,
    stroke_var: typing.Optional[builtins.str] = None,
    text: typing.Optional[builtins.str] = None,
    text_var: typing.Optional[builtins.str] = None,
    transformation: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageTextImageTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    typeface: typing.Optional[builtins.str] = None,
    typeface_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0100f1fd5be3033e542e9ccbf78246f235c01b4418dbc200b7b594803a30bf1f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be60452d326fc363cefeb96ba15f6111cba9ce6bf6becdd407b7964d50a3e76d(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d101c5ce691162e8c1f2141ea6fc6a06b5faf034e682f35db54ecdaffbfe4ba(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__37192b4a6dd34d4cf2eed8e198c738d93ba155245fc324cb99790ebb4ef8d695(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7efa482d4578a336ee8a468921802f98e9cd24f9c7ed78479a61df0a3128346f(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fc519effe6802c57209d91efd4748f119f80d2e5462c6f7560d280bfcb3dc23a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageTextImage]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d20baa0934c9f064be0671e7bd8881c67d3333df29741d222baa42118ddd8ae5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__40dad0d0af44dedd3a735c4338d5d270c2c5385573874ad09613ac6b6f084895(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dc7ed8765793a49942f3942ce979267e5a4922500b774735c9379c47f97d4eff(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a694ae7691f6d591e4bfaac3ec6b07dc9bb6c2c9c61630ef9848d2b2736eaed5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bcde19468b7852f00fcfc87399f56a964e3eb25f4a9df24ad6a7d2997258de29(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__56066c28b029e47f45b6bb26135dbafb26854fc0cec08a66875d422276d46348(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9bb1d39cfe3dd3d41107f1b79d5621f7e3a200d96e8985777ab0f9ac0cb85ae6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__972510bbad6925919885e3f779be3fc4b441d27735a2519ad2a0f60f8452f254(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5b982d180491a19c153cb414b32ebd83f4926fb05ba8fb12f47db54afa222327(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f6ceff5283def79237e401922dce1094543986531bddb8b02fcb10aab42632f5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5cbc1a1dd4eade2f42a82bd1e618aead69250d23b316b8a8e6afa679ff650f37(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3346720bb4cd5053c5c70b245491551369136576c6179816feaeecce3089ae20(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1deb43fcfd0d3db00286683bb47baeced9c519dd6db85a5809c636cffd308f7c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__24c0d10f5e0536996b31f109320c506d3d028670a6a2bedeff41fd6e5c54baea(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageTextImage]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6a9894f4e25528ac91d5af3d26876de657708571ca05bd68e7a223cab349c188(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a4e168c50e2e3455274c470b36ca2a4133eea06ef0bf5dbdcdf46f5fe3c15c16(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageTextImageTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d1964489fe0313efa24971fb072f68b84452653fdde45f3895afcd16d6516314(
    *,
    transformation: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageUrlImageTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    url: typing.Optional[builtins.str] = None,
    url_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6581d58d95cedf365cf0bba4f18114d304146a9dc1873932d8aaa6be67b9f741(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eb97a21cfbdc96aae56232c92beb065a010472889d9bf821bcaaec30cd30304b(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c09a6665b13e2fa2c6428f3515a47b254358c420c57c79da714cb15b5db9379b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a51f8008cde062669a052710e0708adec0defd40cb588ae349a266ba68ab088e(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__28ec55b0822a95265ceed47f55baae64a97b30c8823365c2d5cb26980938e0de(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3f6319c800175c924c72d16e176c1e782e6a5891217a70ae3b35ea1138163311(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageUrlImage]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7f96810a6b1a2007f1229c67ce3be0bbdab071efe7b17253e60ffe2f85291b65(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__12050eb41632031428865bfa25c2ea10571bfdbf5e512bab9cf965685b1d65a0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac93291b2001bdefaab87899f171bbc1eb2fdbfc57fee9f6d94248dda6806a4e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d6da18af63ec9bf0de28b32d92a6068df1fcc6bbc7ea8ec676d3ef2c355d030f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageUrlImage]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__31449d4e495e61f614f3ab154251f51bd3d1973d88c82c391d2a74d226370fed(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__77e7356f8a5ba9b7fd40324c82d64ea0e7bf794d202f2557b4382c93066dc0fb(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsCompositeImageUrlImageTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7b4eb8af8e98d525235fe8f43a22d84cdd2606e96d5d5e4ad0b4ab091daf1b84(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e0900d7c929f5301d7e59c9fa27229fc85b23530ce7519c44bdd59651f3c7494(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a0e7cd9100baacbcb8bbf9fba307ce7da4fbbc9eb7348dcbaf77e33331de34cc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b6c42389dd6020314067913dd7a9b038c9ddd752bfb848b100ba044eab9fe54c(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__697080bb01b4b582d1799cc1d091d0befccd56c208695e8db29adfcbdfc7e845(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7565b5d8a085e0f9bab3947f7c7c4f6319264da1073d1bffa17e33917d0df11b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsComposite]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8c79198e338a530c6979b0fa1ad369057dfba101c64cda60adf56f4b50fc780b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6ff64a1dbaafaea0703e57e34679b29679f6843894c3fd8a470d4f968fed4a3f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__035f4c8bb1de96e35be97b27c3298c2ac15214319038be14b8a3b0453761fe2c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8034edc8411ea67a021f4568346726d7ffe40af5ad73833aab66ec419e3349e3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1e0806bf3911443cfcb2f014f53ad59fdf3414650920ca24fdc6e5a4ddf65091(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__728e6e8ad988e1d3783e0f9ca4aef5ebf87ede9f9975b163716def4708a8166b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dc2380e8fec085fd4f032cf26c847bfcb18bdb51df0d5251337bd064be9214d1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__85bbe61fd8e56f19266901e4d3aa5b67609dca544709b49149e3fce39479c688(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dc9e2e4f78bbec42f1e31b773da2db19d1eee283e63ac9dc8f4f82f583b73a63(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fe6a1a5cc6ccb54a673e9ed6b0afb0319c3a9506f8b9a36c178098ebbd69b94b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__985e4b540e6d6c17950eba51fbc37b13c0c9a47f8b8dc4913191a67bba51edc9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e6c44ebdb4d95a4532fb3d7857d6db1ba2f5ae96c795dd7a5cd42cf28daaccb7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c6f29d614028f4a65d97bb4906065ab2030fa3b723cdb98e2629eacc70e18793(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__01cbb1e960145028ce9fab8d224940b07f7b6db7cb77ef36ab9fb70ec93ab329(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsComposite]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2444e3cfa8a0a2d55a49596cb939e842d85e7cf4ede85fd9d230b3590439d4c8(
    *,
    brightness: typing.Optional[builtins.str] = None,
    brightness_var: typing.Optional[builtins.str] = None,
    contrast: typing.Optional[builtins.str] = None,
    contrast_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0b6c5d97d83cd7062f754a6453b5300dd1c97374064b3b3d10f8ec8df543c0e8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7ba4dc1c596cec8ef8bebe0ea2ae4bedfe8f6dfed68c417152651c5680eb4097(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__61cc1dbb121c5a3e30ac36ee3eefc9fb2782aa1a3893dc571212d9e68fb17327(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8335d84dc0d0b40e4c450333fb455029072fe2cd214bdbeee567a3da11b84a29(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d3c8f09ada58869f1043181f3664d08c6fc113f56c4cb89f782bb7953118cee4(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dccfcc99e11aef852caa51c3373363c1e7c7c3ddeea388ed8f03376617d9c088(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsContrast]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3cb95e9bed5b00c235a2e7babd8766b4cd079e09626686a6d9deca395315ae3d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e8bf57e199b52d801533f6ac039869fd968e8153f89d62b8b19ee03998c41d2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3dda5fb39fe218c8456d9f5e45631ffa43790a85229c7ef45004a7d18a2a5dfa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6ab541553716375accd528a0220a2b228e420766cf697bf257741aca3c9dba60(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1ca62cca331ee8cb451e81a80aafbbed4920c27f470ecf0df40386afe4ea94be(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__efdd9b44407771ace1f4a164caf8e151bbcd50b01d4d1c8dadc920865d532850(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsContrast]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__63e67c204fb49b9dca7ba65fa9d6ea49254e8d40bc0770245401251b315b53c8(
    *,
    chaos: typing.Optional[builtins.str] = None,
    chaos_var: typing.Optional[builtins.str] = None,
    density: typing.Optional[builtins.str] = None,
    density_var: typing.Optional[builtins.str] = None,
    power: typing.Optional[builtins.str] = None,
    power_var: typing.Optional[builtins.str] = None,
    seed: typing.Optional[builtins.str] = None,
    seed_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0569fcfff59ec0896d933526d4f0a2c50f0b3d052bd6eb36bda01b50577216e2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__271c2ac66ce2fe5072167c88c8c3048bac45d61abcb64cfb26231e52861fc68e(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__348ae47ade40e2eee9ac3db1d717c776e9edb61fce013c20f3074a4b03fe2a6c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9874c6798ce8f59ba8044dba29de11a84c722841c008aac326aa3f7247c429c9(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3c9a178a173915f8c80e076d29b2fa1d5a3c795441a192ba40cd9881ea1bf32a(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__227fa05a41fc9c516289165806b651c429b038e3fd7d5299c0a58cc64c0b5104(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsGoop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c07fe05f02297127d6266add7b70339a9f309e7c8103c89b94b27c58b7c59654(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d70a7344577ee1a33852969147fb1c2f925af7e2d8ea0c715cbfb2555a1af35d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__50b4137fed5730ace846cb9600088721a4c8afe9792ab52728ca0aed82f79d05(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__24bb26d50c29fdc5bad2a2a736a5679bf207174cb278b24842cbdee343047443(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c7d864344b960d096e2a4c04242fc46dd9cd39c2616948d94a817654fe0cd03c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5c7b3dac64054809dd369a1f88497bc520744bb1a174967e967532cc64b8d22d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__443614e5b5d299dabce485613e23cc07e3238caa9017d09bda3c42a54ad00e38(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e2ec8da4952c0490fb316cbfd887dd9051273c76d55b4ecf440ef22d150621d3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2f6d46414fec57831163a4b31bd4c9f669a337ab8072b0188d2f00eb0d5d4b23(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ad69808a48c5025fa56c96b0c99834b170de9dc3d77440c57198c6f0dcb9fb35(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsGoop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f598726c4a5a7c97ae5f09c7d372515b126e87acc41feda6dd4ba906d2680056(
    *,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__81211085cbb4f4a47605857278eb896362c7659c9c9cba5df59b840488c1343b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d83d4ee33ffca821ae6c2a3684030532cb7fe8ec68f61b1b45f155c0629958a(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0a6f617ea47c505fdfdf3d29bd751d296264f298e23f7f5432b62a646745caba(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4932f305b1d5ac6c8025d8792c03c6307ddab83d768363fc1e92712819b2ab1a(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__357f96f7f546394698db6912dda74783a6b960d2f4c7f0a839ef76dcc76f9c35(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__52370154ec51b516e7cd3e1e22dcece3095f02aa9bfff916ae5beaceaf19e3c8(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsGrayscale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e195a6ff98e6a64c29a9135ee554fc6fa5103edc02bbb3ef23a5d966d64bdbaa(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2194d5b6b0b07e372a4b0370807a5963c842c5287870caac1a1f15244b0c7c79(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f45c7083ad75001c620c37d10613ee87ffd043ecadfe6af2cdc985406726174(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e9a96b3a8f548b8964297267b74764c1135b9b2a058f9cceec5649e2cb363b24(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsGrayscale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a59d4846754d9f75997eb29b8910c9047e5451a297238cd7b54f30485bccfc8b(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness: typing.Optional[builtins.str] = None,
    lightness_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__699c7f9469a830a1cab773334b22b2d1ada45b2caca58eea6573aa3080d61a5a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5243f747b2dc82a5da9828ba0ed3baaf3c5dcb8e84c6d3e4897a2ffc756ee985(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__784a4b89c540c819c08709a4a99e40a8232592978cf2b0870cde59bd73798959(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f60cd2bcbb2d429105c2d6e7e6f156c2a8cf60707e9d3d57335dd4f98b99b8d(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f6a0e2bb3a688ade9c93efe266c75f8794d5115d319f027373e8eabe30a0a5f5(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__885f6e15b73b4101633c41005b84aa856ce003edfd4e95e9ebf5ef246e61194a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsHsl]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c982dc6d37df8597a5d1df3796310c13a3bc1b66d0f89d6afe55957d4fac6728(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fef7fb53bbdb36dafd27c12f8c252acf12d8591da9d99269dad73c186e2eed4d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1a3e7f2d2d30c216be32f54ff698c294b9c551acb017b55557ac7f66074a528c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a2126a9deaedb4c8afbbd8514df489813eba2b9290747db1035c1ce16de48274(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__137758d487331a2a1fb19bebfaf32e0f8c3dfafd12fec2435ea4383b6397176f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4db0844ac95feaf27a44f8517c1f5eb27c51e71f655044163770d1b6f52fa90f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f6319989a37d8ec448b4b085f51ba148b8c55084934bbbddb1f3307652431757(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ba8e35c41eec44891ca222ebe97892bbabd77779000519b4f72c36e5b1b1ffcf(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsHsl]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f05978142a8de554cc1d5233609fbb269898c8690712f5f47a2222c7a89c187c(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a2da7806cc8870a9f83c82abb1d6df3b4b66562e59544927c2c91d72cfc4b482(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7688fa6cfde615d63e338a653fffee3abde33acf17357e7d5d4ff45d034e3716(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d95178279188f064abd3c06c3583c09ca501b959bd03d63920524498329b1fff(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__17699db2ce4a58b2055829fd3d143321a21de9f31e0ffaee3039f8f6f7f85417(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c5bd71a798f05b0a9a996ecef853ffc82584ed0133b259ae507087cdd2d2ee2f(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__751a903c3bcd6d93d2dbb43a2e21f7f375149a70eaab92f82ff4f045028b3423(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsHsv]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__db57d3afc64429cad08e11485bc49c490524f90c41e2971a5826b189c2f3ea24(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__76fbdce40eb008e30a78905260fb8720031009ca094c4f432cfbeb64fe4a3db8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac1033fcd03b628c3c3b4f22a46db9d6af1559b47e7319cefd9d0b3e55e370a8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__84c4646e1cdf1c42dca7103af562a9950e5bdfe64906abaf3d6ef4d2e3ce5d06(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__097d9260aafefd19805e1e690175185ce67298698512518be784aef5047a42ce(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4fc4edb4b1fdf9dd17fd03d30085dfdc6a01857f6a7715f11005d6105bdce657(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1255e35d052c6d80af968f55ab1f8144700987368880a2fa94ef2796aea19cc7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__38fdb9e47841292e41a1c110a382287ac4a2852dacb13a197ff4d78a2d3ed911(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsHsv]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8339d7acb4cd20a470b4c07926df18edfcca1592a4ef1ffae7c3c35fa9f9eff3(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    dimension: typing.Optional[builtins.str] = None,
    dimension_var: typing.Optional[builtins.str] = None,
    equal: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqual, typing.Dict[builtins.str, typing.Any]]] = None,
    greater_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThan, typing.Dict[builtins.str, typing.Any]]] = None,
    less_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThan, typing.Dict[builtins.str, typing.Any]]] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a0fdb07f021cb21115bf647cf47747b146a32c9d983e92f91e83ad4c7cad8cf3(
    *,
    background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
    chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
    composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
    compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
    contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
    goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
    max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
    opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
    remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__54362789079a10fc385e027e306aa2d3f19bf5f13566e21f6a25059a084e8220(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c1e3eef8846db725e63870fc142593dc96ef69543f1b46f9f139bb352845da2c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__367bdc231deccc06838415e5e0f4635d5019ea800a0daae326a53ac30f313727(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2b803b5a582cd90a101a5cae4efc3f2de2a8dbd87ab300971ce9f8d59ef4cb8c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__479409048d4541965045e75ab7039cbde8ee4e04cbd92c448f5302646df97100(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0e3514181cd20e1a4d56ccda7950ee4f665c60da7b62c9faf107076eb037513e(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d96f77175ee87d31e271ea162de2223078a9251844aa8484ac98dd06a9e8565(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultBackgroundColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8e1d56131009599b8029095c42cc4ce51fce74835c75359c0235cc818aacb4e1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2b61bb4d2bea6b55c1677fbab9b18e8d9ea4827d411569babb3e34ba6c8cb2e8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8148925a5e68b5e0b85621659ac24842feb2db001754f99610a0dec011fb236b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__20184e89cf395229ff8220d80bf72d761ccc7dafc9547b21b0b22337dd67145a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultBackgroundColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8229beeb47cc2f69b10cc05701317bde6211c2d768bfe3876170b11e2edf2e0b(
    *,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c40cc37377a65cdc1140fcb7f091d46cb3df6f8d1907b2019a17060d05b82355(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8610478af442f0d5fd2d3c766950c7d29c1ec6961f955fa8e697258df818d6af(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__30a71ea94cef95b179dc7abda1545a5265a2c0b68dd7306d35c3dc50c111b44b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c3ac4bd9584c61bdeb20efe3f02f8bfa96819c7945046f6d5da0caca97fe9dad(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ebdb87377dfeebf02c08b87b81632ad0a6aaf8ef7ea8468cf4f40f9dcbf63fb(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ffcf094431252c1de890e7942a3f10af3f0730e9c804a175fedc3c4f0ee0428(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultBlur]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0eaba432eaad7079e10e3481840ec53882927c1d8ca21a73713f615ad746c48a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0d32a894c72f0926afad68897f39fc8176afd9d363a8b98d6adccf6d0613e616(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d46ccef751d84e2db9f700fb64b654c4b1115f72fa54f111c0172f3f3f3c857f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ed9bb70af86f8526b6dd7dcc87e4196ca6b7876571b51af1452b223b2f44f24(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultBlur]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__948b1c864d0c23af3e4650622481314f2715b51d78b86766c9b43550229e722c(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_feather: typing.Optional[builtins.str] = None,
    hue_feather_var: typing.Optional[builtins.str] = None,
    hue_tolerance: typing.Optional[builtins.str] = None,
    hue_tolerance_var: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness_feather: typing.Optional[builtins.str] = None,
    lightness_feather_var: typing.Optional[builtins.str] = None,
    lightness_tolerance: typing.Optional[builtins.str] = None,
    lightness_tolerance_var: typing.Optional[builtins.str] = None,
    saturation_feather: typing.Optional[builtins.str] = None,
    saturation_feather_var: typing.Optional[builtins.str] = None,
    saturation_tolerance: typing.Optional[builtins.str] = None,
    saturation_tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ca608809f62519f723441ccc54301309f5c8532ff9926b50b67a18f8ce01000(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__290912e1cff16471922573d47c2faf21a3baad83d4e90d034c91a6cbe2e72a86(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7f5a1925e24cb9f684cbf20bfebbf7e8a0c802f809c6360173ae883930c41e99(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9726aa5f20ba37b4e5f0abe10b17c306732c13e1a8bc1e1e74a514592a495ea5(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7cd608ed493a1d3d219296573e86a1295de4581b418e74fb8827b11e1ca95cf4(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__944d42e594a795799e6afb753c1f4af5be31097df31f1616b7c46c82806acd42(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultChromaKey]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__17a5502232221485023b5a236b47585a71da217bf0fd8abdc8f93c13237337f6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4563256cae25d6ce8749021f0ddfe9d594a63f30f78993b34d51dbb76309238f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7b8852217a040822472d60f59b5cd49ef1bd2781aaebe20d54caaae0931af612(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5d6340ac761af58caee587ae9137543a72ff1268fee8162566e6802a9eaebdac(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4e6fc134216b9c442c45f8bea3d50e1352c32aaf84208c82c84ec5bb5ee5a2a1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fbcd5e7eab21eb9ef818b92a5f75b8da4aea2d8d0ef9ec31a9652d64170a9e32(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__59777fa5d9f4ed790ad2412e610f009aab6633687aa47c3cd9e32c8409a45f3f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__59b78cc1e599bcfbcf7e45b1700a1efa1615ae9c3308d056dad67e7e2fc5b0fa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8830751d0bf6659e8e2c73ae12229fca3bf8c1e2af36cf2266e59dd3a3948fd9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__33be4eda34864306f94946de105c46a266e886524e3a8e85dc8acc5b830189d6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7ac26895c03bdf19aa412989deadbe8bdd31f2cfb516e5e604060bf0cc6eb3d7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__031c8ba264dbbf52598e4af94d6fed263fb293f3e8b2b868f6c0b36363a6639d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__57582da4e28f2781b51bc430f99f00d47defbf168f72f39e29b57de3895b6b4e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__edd6dc418b628dd9607dbda7aaf68da17c2939c5260d0cd5f0e7f58cbf43f343(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ad672b64511d1303cbfb2957b2f2d1f18a743552acabd74735fdfbbec29b9b3d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__94872793678ea13721f7ec61080396db4e60670adb7414471f0f1a658fec3102(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultChromaKey]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__db91937991bd7805893ee80ef0bbc5cc7e03bd80bf7183125c4fb0d78d65f5cf(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultCompositeImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    placement: typing.Optional[builtins.str] = None,
    placement_var: typing.Optional[builtins.str] = None,
    scale: typing.Optional[builtins.str] = None,
    scale_dimension: typing.Optional[builtins.str] = None,
    scale_dimension_var: typing.Optional[builtins.str] = None,
    scale_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__11e0af7069c4362273f951336cf08aeab265cfa6b3c633108641616e6319970d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__963cfc1eb4a2bed8d2139605b0b887b94e8128ff7b9c03516da30c021b84a1c6(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultCompositeImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0f691af0b89970b7e779e4eb07dbe5e217457ac38b8adf77cb51f3d2170ac6c6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b14ea0c64e5f412c80caadbc37c8093b65a529e5f9049ef96cc91454856ad04e(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0f436868de4315b852fe0c1ee073d077047ad84f684e499c1c4de6b492b5a88d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c81b52ae750eff7de886b6ad81fc313a37cbe9cba7ae6761665287c8f6dffdb3(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__73971ecc1a7b18eafff7f11476149f42ba64354feda1581078699b662301aa45(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__267bbc8401b84a8b8fcc12fe753c0eb346ab6720eadd8089c707ee879ac78d51(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultComposite]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cf6f1b6ef548373305948c71a677216b3e16ca3a452489fc5ebec6552ee5f456(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ec21286aa7a49bb346672f376cf9a116334212bccdc3a4012eb46bec02c695c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__62f5c98ba1e32bd0f146025b6fa87efec7291b9182bce2337aff7bd0a0573e2e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9bbbba53575122d524c481a03b7741ac95b8afcad4e39bb98031ce82dafca94a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a46ca1929465a2316152323c023cc0369b16b4fb6cb8ac69c26761948ccaed70(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4486cd873a2364155866d90e390646d6a18a78463d1cc3ddc1c3b972c35917d4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__691973c7897450fee028b1498da548b2be64546a0b491593b0080dd1c9468e3c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a73e561792ad3667eb787afaa4558bed6a3067d40e66417c14b217613d5abc0b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f62c51f8ca5f9cfd0307896563fe258c3760062e52b3a42407c2d4215bf9aa42(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a69526d47a76e4251b89116be43ac3d925d35c81d977f40817c032cfd7adcf8c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0dc24c1b8e88a628fb5c5e59180001684834c3b9fad5a0ec3431ec3f1c1356b5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7c3d87a14361b1f52eb0fff38772b210c041177ff6670bd431865951e7669cca(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eb40e8f36609e15c2fc16e3838b72a1023e1e188a617eccd63f48730210e4d02(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f8cf40e052685a49721eec397cbde001cbeae7c0b202b8810c20754b685eb5c8(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultComposite]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fcd5f9b7b5d6d600ca26138db185bacf449a04c8b5ac1ad321f19ab9a2a89f14(
    *,
    transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ec358436b6a57fd5bd8dc01b8244927f2d89248f927382c6cea1ecad83483476(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ebd7b3cc92337f7aae00472cdc509a01508960ea0f5988db1378621d8ee55eeb(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c799961220c4f2c6581ec37004159b997a2882de93257624a037095400e2d5f3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__448336181cc92ca867205b77d2b4fe5400d49118e4d6b01bde84051d39930554(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8abd5879a3e2ad6a956a88a854bdd7ec2faac9c6690213ab476177707d99155d(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d09d5cc02e46986746725aeb339d73cc9285289a8105907319304afcd0727096(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultCompound]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b1ed884af5d2d011503e813dd64a1878756c606884ea489e9721cdd4170aa81b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7871d6eaaf678a64a46cdfb9d4652b8fe8f930c03b463f46e85d5d315fecf366(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__61b2d4233e44e78608d96d85e463236f38b78801c55de379e588484fe2680cc1(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultCompound]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e318d5f7a228e53ce7615bad308504d49f749e0b099e38426529db7fb91822d2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f2e5aaedfcd9313a0562b3c0aa05bf585b99d6c5c39be306d48cf6c2ca15df66(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7e0d6c6778156bee20484b8a7c31a112e1860624cee2319f52e46b9a8cd0e7c7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e5f92ca9fc096a59f27c6a9a24d2ead67286a6a0638260e96bd9dfb0e1617a70(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__47fc2f5e061b22c14f544010ac12fdadcfc394016fabf861181c81240bf22496(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__67b31782f71cee01bf8268fd4389b948acfad14b1d844afe0fba2611f02750be(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultCompoundTransformations]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__67148b033f272886582a4a88621d8b60292c7ec6fff6cce98b35f496f068cd0b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__658fd47a509585c5a5722da4c0793f838a1d231580d25b1422909614e7895708(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultCompoundTransformations]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2b130c8b510302f2dd710bbd9f9f0d1857733a2c0c6487a957a9d384edd54bda(
    *,
    brightness: typing.Optional[builtins.str] = None,
    brightness_var: typing.Optional[builtins.str] = None,
    contrast: typing.Optional[builtins.str] = None,
    contrast_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a8eb57d6f5255740b916a458a978db23d43b91e263bdd47f7df94d1592dc9ecc(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c1151843458ade6892646f0d900582d740c83618cc69cd07cc527b5385f2269c(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__62a37c42d45c3c3aa410745180ed85862c9ff1c84db0f997da1228df906a8c07(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7ff89b100725a66f971471d6e8e1102fb63281daecd79c6580e2a0930e791e0a(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e393784a09e3b83310c5c5efe31127270d892afa33d5bacf3a092a17051f2afb(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__73ab056de33dd0cf1a6fef4d7e7aad5ef53494290a5e14380efd847287a6a1fa(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultContrast]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__04b681046143b1fad5145369786290cff58c02fccf708eaffe0ec12222ad4cff(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f5fd1b57e800438fd26d5a2fe0fd45396815401ec7b3f5bef90d544e34672d94(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__081e50b3a64a8151b1130037d1edddaeef76ce4563d38a2e59683eb9b3f79228(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1ee12634fefbe7acb2e4fc1d6c45fef376bd90da473e694573be89b5edbe934b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fca627b7bf9176e813d630965c0aec5ec624b8b26a81c9cd5b603ed7e98831a5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5a6022002b5f5f705bc6ef971104cd810947dc0ccf2852f25caa693359e083d2(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultContrast]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ae40307957c0be64dc45b8bd81479b3aeace8022e65924b87bb69fcb85ec01be(
    *,
    chaos: typing.Optional[builtins.str] = None,
    chaos_var: typing.Optional[builtins.str] = None,
    density: typing.Optional[builtins.str] = None,
    density_var: typing.Optional[builtins.str] = None,
    power: typing.Optional[builtins.str] = None,
    power_var: typing.Optional[builtins.str] = None,
    seed: typing.Optional[builtins.str] = None,
    seed_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5d12347b38792e4d7a0bba4f953316fdd178dd0a786e871e9d6b7bd05e047753(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0f145d97cc1f6fb7fc489e38fefb6d27b4f3c71bc72d38f41941c80b9ab43650(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0eaaa070216abe5f8952af8492d19e5464527bee58ad16ddebe04f9557dbb1c3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__61574a0ad34b7480bf1e0066fcd116d4ef98fc061d63b857c2017467746a6da9(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b9afa5f8577632f710520ec3eb0efdfb4ac8f639ebe5f9a4c8552b990cec67d6(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7869f9ca3230e8b36ab758a0220543d9338d12d9fa5d5873b98e078ca57036fd(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultGoop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__53a01837b71aaad5e7254d5cef7a5a1ae9168dba5a0e011afa44be4bcc427d2d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6cf23203e1725362c88c3d06bbf8f60898085e45e251727364c80cb7815ca049(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__84d441d1f27bbb68c2917318ae3eb25b3dc7b23c4550b796be9a80ea973d41d2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__46c5469b2bd361ed1482db26fb99a6f1fddcc45b63363aad66040ed320961ff7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c9a54d8377a30e9975ba3ce8a000f0b0c5ab7440c53eef34667459fc5e6de6ef(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__548d7b21791a475cce65c7832850511f3e57f39a7b509d9dfa4b8d564b530cb5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3153a2f6efcc93dd688e84c8824288b3da41bad33d2ca61ae982af9c0bc6170a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fa3869c95cf32982cd76791d9e1520754e72d77971533c6738c85e3f24df82f4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a411e0757ff0ed3f99062a717c7e517c577c5b864f6aec4130e013f02a7e09a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2b0fc876583da55bc44ac371505a6b736a93fd6e5ae8a4445d0b948ac7395a78(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultGoop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f380993ce4654d8e36f0cc9d9e2fd037e1d1f958be853080c976ca603665fa4c(
    *,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__62fcdd494cb37e5651d737144f3032aa2a78b1f48fc8473818fb09858c54a70c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a8d708204021acee14e23f50956712b36773b1b5ba518a719d07568b411d612d(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__730f727fe34de628e6109d3280e7435da119daf024f4a8c009bba2f1d9284fa3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1ab835efb862a3a079e798926b27f2c51aa6252462714bb863142e1e2cca9324(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__70477ace5fb1d2d9fec7c58ad62a12f3b2b4f02de5dd0ae10acfb09b2a6cfa4a(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__619751c0a1a291ab69c735016131341017f92792d8d0601e6f71abfbe15ab656(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultGrayscale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3d8bed9ef2c656bf6d2c9c69de8899eb607ce2457b2fbf22e63e43baa2f43693(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__49f01b5c4bb80c5f9ae0a435a5ebdbc10b1f86892c4a58897a8a54d478d0c184(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__283b0a04b42f9eb9aca02a4595e8cc99b1feea5eccaa99cf30fce3152a6e5af9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__450a65ec0d8a1e9835457c993ab52d426fdfa921571ea6cef1402ddfeeaf77bd(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultGrayscale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3e96c320c20c0ebcfe00acb90db1237a51c4e446644b5b6e5aa742ea0f9694cc(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness: typing.Optional[builtins.str] = None,
    lightness_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f01c610f20488db8cde3b75946b7e110f8ba4dcdf2550db8bd75ddcdf4e09333(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__27b753d95656c6a9fda861badc86a886d7e7fa508f73dec26a2a507fd038933e(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b19d6c179d8d3ed2f2c5c029b47301f711aac9b9ee3502d8c608915ac5fc695f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f5deb5b06433524028b9689afbc17c6f74f9c7548a05ff52b449c28c9613053e(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__883ddc05d128bf38a4b27d4520f71cc97f1cb5c2cf76b424b0a05ccaaba476b8(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b4cbd8e2c7ac183b74abf5f4f049576d9787dcc42cd743683f19b7cb704aea0b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultHsl]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eb276042f709e1c9dcff30cf8bf81d1a895359b2d26de553c5a32c99a73f7855(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc1a6099b7437d6f8f5cb26c55dbe8b139db70850d43cd2fdbefd58715148ec6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__778a96099472d64e357b18e09e3e26c6562f99c572836b2d5566ab9f26a0869d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d81398cf1ebddd618b1df15122c4b68123c468d038314cfc793aa1563c6667d7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a0730e34ec04aa08b9a29788797f14cc38c68045b5eb0322c13c98700e327af(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__58f2e5e3b0cc466ddcd5a5b5e2c0290fa34cad1f10f85e1c9d04c8f913728b35(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8b3458fb308e57493734584cc1ea3458e76a0a04761875004704d0ebda179d8b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__79020a745d884074b5dcab69bfd9b096f9b8fff0f11daf88869d56f65cc7dbd7(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultHsl]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__29982be246ae7689443f5b9db1c17bced369961df53a0808b5161c278dcb6e4d(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f7098e3154bf861cc38cb82bd3d3d23d3ae6ffcc638822097f96aeb85abc565c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ce2a4caeedaa63d8f3a0bff50e0d109f43b93fd3cef6e479454c0054cde9c85f(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9b05bcb0ea7c27be74c299ba31fd857a6a7f623d1a3fabfc579e7cd3173ba582(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f949274f290b9b4a2f31b825d36c3134c0ab6e2a269b653368b726131c716ae7(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3db29378787be4d63fc6e40c356ddd7951de77356493a44601142dcb99a4b659(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a4811524855123373d753aad74bb7854352c79ee6e8d6e88bc1c4550d0c0dd34(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultHsv]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__770b9b6ef6899c8f90abf611e43310ba5fcf0afe3c7011a537336709d731bfa6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__61b981211c0ad9443e867cbd3a6d6a051a57fe1e79cbb26a3d9c14822c5a0735(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__987776a123431f51a43afb8128f1e2e96ce89c6b95a0ee96b54b47d0d11078f7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e6b05067bdfb2472734d6c4b5ce0a386d98895930aefa9b3b6d06598bf10ee74(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b007de7e1f9ba0e0ee4d430ce55ddbabdd1ab2b9e0568f233c1af9129230a8fe(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__97b4e6dbbb71c9ca35286687e4e0f031e32dbcf438bde38d487eae65a58ecff6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3c48435d582c4fbaaaaf4c544dbb51f9e6f00b936dc896cfc9b82ea814f3c4f7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1c77f25d82db08477df8b218cc4150718dfa385df0ae2f750f375581140e80bb(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultHsv]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f41132ef443eba540608905f0158a34a68597826db8843e02940aed9a80fd8a(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfDimensionDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    dimension: typing.Optional[builtins.str] = None,
    dimension_var: typing.Optional[builtins.str] = None,
    equal: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfDimensionEqual, typing.Dict[builtins.str, typing.Any]]] = None,
    greater_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfDimensionGreaterThan, typing.Dict[builtins.str, typing.Any]]] = None,
    less_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfDimensionLessThan, typing.Dict[builtins.str, typing.Any]]] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b793a71f97d95f0cfc3913907d1941d28a4ec21cc4742f88221ff8a6be3d060c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1118d71f69ec08d9a7af65e136b750d9d23daf7cfe73c21264ceb12d6001388d(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfDimensionDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1a032a7d519ca721dab405153ca219884a985bc3da89a30c37b438776ca20afd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__70738aa51b6cfbbbd6deca3b0e625d4f1f780ebc4107680947ed40e9ccd73f1a(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfDimensionEqual],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bd10ef5bca104f7d98ef7d565c253e429125b70852595a12a3e41dae779b15d5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7b77c91ca397929926ad15fd553d4cb75991da9d86944ed6dae54d7c5f641098(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfDimensionGreaterThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d43dbb18c4553ab0eaea9486161f2c2e898630b92e4282879558c843bcfebc6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3dc6b728638cf61be9881c15e213e6ad3649cf40a8de5e3edee47e40f88f418c(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfDimensionLessThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea3d7db9971fe94cfb609f2000ee82eec8da095cc102f63e93d8b7c962905b01(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d8ff43c71a2f6a95b8906f35644e8260a89242ca25df082466dc2af4d59cced(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ca0602e4ae7995650a9e6333f554614ca029ba9009a0173d08dae078ba83209(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c884accee8edc8ded7d82e8bb7d5ccf1d4802175dce516ebd5388b9d01534dac(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__232ef4f624c75790b8c53c20b1bfb166d9c7800352a757ddab0c2c84328425f2(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9252424f5811da80ebe9f4848fd8fe2034a60fd02b60b033a7ff7f30d7e9c0cc(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfDimension]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1373832baa79ac17d7fe2f8aba305166a5c6545559a28ec2fc3499e30bbc8485(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5e7da3921d0b698e21eb24e42410f920b5306a59e91fde8611421505912c6a5d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ae82506c260f34da5df5824e04494e2f3d73f73ab054a01d29f28b833b2fd00(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5148dd4af5995e9a3eac378cf7240e7fed0e2073b2a8846ca47bed1af9a2a538(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__556a0224453fa54b5653ef4bbd8497b86d5db324b1e0cc3c5e49b97a4af111f8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c7a4bf9125b36fc2862d98d0f8c58fc1ab10e3e68e88cae69a784752561639c4(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfDimension]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7ff2975a217e8f29af0008ae7ea90d3df0179cf6b1ee5c891ba5b2210681ac4a(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfOrientationDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    landscape: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfOrientationLandscape, typing.Dict[builtins.str, typing.Any]]] = None,
    portrait: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfOrientationPortrait, typing.Dict[builtins.str, typing.Any]]] = None,
    square: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfOrientationSquare, typing.Dict[builtins.str, typing.Any]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__587539e097b9738fb38af2a103899612686e22caff4e33b73824bd9c321b179d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be0b0db08f13a09d504846d369ee472ea9146db918ad4ea183b477251be9fda9(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfOrientationDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__47b898319dfd7889f16b141ae4da56b5bdb3ec949bd6d8cb557799eea08987f8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__881205d38407106f62393ed6150f0b82f5ca305033b8ee53a79053abc6345599(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfOrientationLandscape],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9df72537d6e8db7c53d83c06bbecbc618d55b8021b19adf70551622b2f5f79d0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__661f786c06a3f313bd2534c19aa499415f6f4c069d78dc886901507ff698e98f(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aa81fc1d0fbbc0d6d9cf306973541acc094d0e84ad3a0add6d85e29bc9e6e135(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__608ade6c8eb879e79dc2c2ef05b6457d194b2b50298b7cc0bd9aa295d0c64af2(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__813baef2ab4ebc3e8593a2dad8ebe57e22a581b32c1123fb8e06bace14827357(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3305d17b04872fe5727c7a3bf91551ef0838c26c1f2033e634138e914f01a3b1(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfOrientation]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ef191c2fbc70c53e6f95c64f4c9dd7cda849d85c549179e96adaaf21d160e274(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4b5c1a8472fcaddde8f9f3b21d49a7923c2732f457516e125e0f0871e72e9f03(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfOrientation]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a90b479e23ef03ef265c05772ad6198f57914c619976359f56fb0b2029f6f77(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cfda15fb9a80a87c1f22833720cb34dc751f2289355cdaed167ced2e69ff0cb0(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfOrientationPortrait],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a49442d17b1673e7810bab45bd444e3a8ac1eb1a58c4fa28a38fdd55344d3eb(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__391ea645cb6c98b392a780b9df01618481f3be8b7fbced86cf589fef5532cddb(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfOrientationSquare],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__10096fd4f298cdbed6963a278aff07d986d16c4074862c5674d8901e57e0e157(
    *,
    colors: typing.Optional[builtins.str] = None,
    colors_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__97c9e55c9327331f15a777cc250583c0d1b68d0ecba80c71f9f2d77d4fab0f8f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2b6c366ab0e52555d8ea45b036234c6cdf91c92db67b2fecf1c0757e01b157a6(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7839399583d49ce81d7a92b0a1909ffd1e68bd8f5685297ff7881d6a76d75432(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7f5e44100f8a08fb73fa85f71eedd0c36a9eac84cc0ee72d0769d8171ac5af7a(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__77b57c1190d44c1237f5edce5e4f1d63f495065fe3d3e7fd1cf60785a0d4a188(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__12cda01744d10d727dd79610bc2b2cbf9a9b2a1416e87216a24a91b9f21996e2(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultMaxColors]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__72b962dda4714b6bc5b4e2ff97772fab2aec13102bfc230e81fdcc15ded4f475(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d4e689afcaa6035ac8eb9ff115e689de475b20580b6e4f349ae6ae70de2ebc8d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d03489f9ba093f02d431af0866cf231abfcf9881d29ba2746309f897a7b22ba4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__59a14c35658e0d3b82d0a428f08d0b218f1c87bd94c9009e58d7cd1c2ba5ed9e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultMaxColors]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__90518335a101f072ff06fdf9c78d73c59f33f345a699cb2bca72bc0c283156f3(
    *,
    horizontal: typing.Optional[builtins.str] = None,
    horizontal_var: typing.Optional[builtins.str] = None,
    vertical: typing.Optional[builtins.str] = None,
    vertical_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4f8c61b66449c78337bdc8de64f8734d0a6d73512f8dfb9f1003dc9686e3f399(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__162319ef3557d889fea01f72cd4435787aa7efd0b9f2c363f8274204553fb6ea(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__20f746f11c089faefa029787b3be48487fc5b3acf1997744ff41b95cfc0f5df5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dcfd6880cdb808fe990e2ee5b3cd6dab899521880e4b438810c94c59e3135117(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8070d704bbd6451ffeecc68775a3b28baaa0acafde032563fc95ad40dcf9e02b(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ac15a2383a3290087e1dda3723d6d7204696060c30232249181bfcc818ada0b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultMirror]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a87b8863c70f27326ad70da3ac6bedc0885bd17484a172eac2fc824e63816f0a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__297408093cfc87f35408c0fe3687693b27c2e19a6e96489cb8a8548d474983d5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9fdefcc04459105638389745c839fcedde59029ebc68b71d7d5ae5ed4dbed708(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__35572a2fe4b9eee9f979e0b102a838d09c337fe7226bfb53b57859ed069c65df(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dd95747f176f4c9bfe188c46498a12c672d92baafe668a9ddfde79545e3b9cce(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b67f34b846f852d5f7098d2dbce134e731ca535589500aeb68f82acac136add3(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultMirror]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b8ca8e2808ff9ed5e5dd7199238fc94c03637c0794d497b9c639dc9bef4f5960(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ded1d8883855c543f50220596368ffb9a5dde448a30b7622af25e3a4de08b0d5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__25929aa2e29e6f4d6f47364f7dd69e7ae2bb4d2f4a18c6d2bd27761ea99a0ed8(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6a892437edc31ae2d38685b07a7fd46a49cd94a60b216b311f7bfbf0b968354b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2bea4471edd69d752178146f6004c4b702761cf0a776275daa1b543b0bd8dec7(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6dc1f8885f29fea9d7430f213ac04ae840891dc22d4eb792138c3bf065afbd4b(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ee38ae331e88a89eb9e93abfae4d087c6c9b35fd8c6985f90f26743e1fe56a0(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultMonoHue]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__49c701103b1313024704df416b0d83a15bfc5470b47ae5af1e702796e910f475(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6a9a19738e39e318ebbb8c603fdbd3c4f6134cf9aae4b4e7d0383f3f616bf728(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__42f0c092cdac096d2a48a61c3b35f6fb077e60491cefd493976e543447d8a964(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b18363b4e1491bc775d4195cfb34e58c6b1abfbb320d9bc993cf9619c2389f77(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultMonoHue]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c818503f719004a5441a5813087479a05ef1b4d4fce9823d0abe47dd37a2b136(
    *,
    opacity: typing.Optional[builtins.str] = None,
    opacity_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ae3497e1b3651dbcc34e09a96943ab3b420f2dcbc51021ad56f6243b6f6a49d5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cc719dfb54ca37d0e8afac2d0f85d52462dc0c97f4569a86683845995a0e537a(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2f47cf50a1a8ebc45350d445f4fb0c2fc5c0fe57afc1f3bb16614c17927d2993(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__21b71400828a789c0f5423de6b5631380dfbd0729f958a3a884c74037bd4c1d6(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a4c24d4cdb1646213c0f25706430e04685992de20b264293dfd78b19266c6b6(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cf335d8f2b99c2b1e22d8358627397d2a2be49c63257bfe1adaef5a31163b9ae(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultOpacity]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__66609e30c4a062a7ae266db93660cd10cd6f8ae0733e7ba48b220d95ef98d129(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6af82e1fce0490b85595954d3cff3a48a05e8b33c7bf51d6cb233e2de74823af(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5b7d3d108fa615a2ef55942d39858ff1e1e80f23255b860b2ebdbe52ad17ce81(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ade5aa94f282d2513922c0860aad01a422d44139912b7997581bf3f0b530a40(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultOpacity]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8dd93561d1458bc72de249be1aef092ae7104f4bdda5be4d0f5fe6a4377b10fa(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__41c14e0c50af74183409d6d397b9035e69e24a88864d3c2475346791d5736427(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__61b47c8333e8cbf3e22b90e57fee8d82323cd8e9b4359fc36d4f0242fb4e8857(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultBlur, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__60b631948cbb2548bc88ae49324ad86e9107faab6685fbde5b64523dcc712161(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultChromaKey, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e57f37b17a2f42378500c84d1cd836ec75c649f826dcb1b09c80e756d43420b5(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultComposite, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c20253e0310a15dec7c5c38f9d78ff19cd35726df04f5093709138adbfefdf1d(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultCompound, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8d9b330fe3855a4edb2e95114b26f78e132b4632fd47a734421e7346b7bc3bcb(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultContrast, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb637e4c7693efd7f4ca4873a4fbe181af91f23c14ef018682a8ff4c9afae8ce(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultGoop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f7bcdb7305160c5244e924cef9b2a8081d7bd55b3c9bdcfe9c5c848a11338a57(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultGrayscale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1cf25dcadec20213acbef58a2f92bb600b73e51be73c020d6a89774b8319c69c(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultHsl, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b29dd83f9dfed69d1a89154dde3deb667e42394f69b1d30a5ce5119cf52ddca7(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultHsv, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__19b42e0780263ccc2a8e6254704f4a9e31bf722c03ce1e769269256bb460ed85(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfDimension, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__561006853a38939c01c9c38e6cfd0e0fdc1ad4ca3e07f84224b8fcbf0f071913(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a056176415595e0ecfde80f7795c75b8266c1f29c7e16b86baccebeb57a4a3c9(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultMaxColors, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dac30ed2639557cb87eb038b17ce9fa58da96ad68714ac486691cc6e47950e13(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultMirror, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__318abdd7e6caae76c9fa9bf8a40e77e8e0760dfcf3dbf4266e70c7a06dbfb390(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultMonoHue, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c8b3b5080a45fca14c09a301cec8ce399023a292343056b66f0fe93ac5dac53b(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultOpacity, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0c8830a04288872cf4c23fc9da5e6583a463b3abbfce8d37131fc47381044cf3(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultRemoveColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__582a94c4d04d46346fe4f4e1332c5666655b04f1ab6ccc2649ad479275fef03b(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultUnsharpMask, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__375db144c27cfd1dcdcd71b8c57a81948d934cb0f93f4359592ebdabd22546d5(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__22bf5753842458369d7f0ff5f5b17d77bab08ce884d66659560cf23cc5454381(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
    feather: typing.Optional[builtins.str] = None,
    feather_var: typing.Optional[builtins.str] = None,
    tolerance: typing.Optional[builtins.str] = None,
    tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__adf66352d63f142725b09df0d46bc5c29a1093aef7e975cdcfbecab4f3e6ca5f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2034ce21bc6b66c9ffe4fd3c3981128f7664b9be6cf7e61ef7b76334f075f7e9(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__48600d9338f1592b80dacd1b6fdc5dd4daac75994f0c8519b5b42a5174f936d0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d3d4659d1ff849ec130fe75786f04eba75e34794455b94b362df4d8c16336699(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__32b8fcaeebe5e70061290e9242dea2720f27ea9c8407c2f37c304fb49651c57e(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7c8a58591a8554896d43366553fcaa7c7b556b9d56bd1489d8dad8761bd2d61e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultRemoveColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6fecc018846ae3cbc0532acb9e8dbd2ba9b1d523fa0fb86cf79ae65f9029eb15(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__318a2fcfdf012f6e242e53b59f22a6663abdb53fa43bbc2f5a45242f97d85766(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3f59960cd572ef01ce18e656e1a54f4f7902f91c70ca62e743514de5ee45daae(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__53bd24e80226ef66aaab6257bb97ea8f0422537be83b86f1bb48c71a9d4b73cc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5fa5580e1f182dd94628a111b96b7a7131471bf14ef852f91e201719ca412bdb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cb03fa3f6d3c56dd166a462a36ff2b3ad8d6b02cd287eaaced90c4d7237936d2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__023e0d7dfc650ab31d161a78e4cc1d5d49e20140ae1568ecaf06ca684aa11b63(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__57054c58c26eca01a343864be0d6bca1792a78272c822d3a4479d37511becc82(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultRemoveColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5e10a922639234663c822868e279af2a14d90c410534f69af3edc85abbf3053d(
    *,
    gain: typing.Optional[builtins.str] = None,
    gain_var: typing.Optional[builtins.str] = None,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
    threshold: typing.Optional[builtins.str] = None,
    threshold_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__25014995626339f81006668051a369bfed43eb7c409f3b52bba4363038b41e4c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aee95ff319c4c0a792d722c88f76360aa7884e15f02e502ebc3a0e97f2bc2316(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e1a6042bb46144f50cda0759fc3be3dac337d1ad21173dfe9f0c5d403b0b021a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e5b31938af7df49c23cd0953fc7816f963171bf342ea44790abd4f28984a8cb5(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__72ebbffa05996929647749119015962f4b017b6c8e9e11956274208d762fc744(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e550524914e488a3eaa173f2c64684b6e87f5f462bf0b88cec4b5fab88afb4db(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultUnsharpMask]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fdb5d24684502cab5842c45e426a4a92477313d16a866b8027ccf5738a87311d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c06142965947d110de538402b05ce75ab19bb58f2d55f31376b2d13ad442814f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bcba933c8ee9fcc96040b073e2a036ec04cb242a3523d7d1221aedaa01d90925(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7de0e82b381dc15a0a7df723576783073a96c7f899d9f3f82baa5b69bba7e553(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__627bcfb3da71efd79f67ab2ddff5cc00b0139f8e317286918f4edae9ffa2327a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__62c27d532bc053b1b1f4758af062fe623ec70400b958dfce1b6bb11f20ebb74d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8aba976153b9eb17ad5d7067f38f72381a03f0d063a348638183c03b6e349937(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__66c087435d923f5a692ee0276aedf700feddc0a7afc50f903220cbf0293e0330(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionDefaultUnsharpMask]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8b18da53144e22782049a3bf0fa04975b8c13c137eb4229824e9d2f50cf682ef(
    *,
    background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
    chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
    composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
    compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
    contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
    goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
    max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
    opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
    remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6d4f0743e910520263edfc55f5b6c1d73517a57877cfd36c119aa631bca411b0(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0a3d1f0f5c9f326777fb7c39d498af1e4b0f48b030cbc9bad3b4864941c92126(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a441157b1d35aa2007af57f4e157977d6aa437662acb52788b1699b8b431e001(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e6cb033ceef17a5b35a7325aa3221c75149589758c98f733e78e0888f92fda5b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d25b6082f684627775c53c72ec00e99b5334eac6b033a8e95c22532c05eec87e(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__91c840483733ffa8b66061c7da4d570b1ee52de29fc9ab5d41ea9622932a42c3(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eb675f6dc3ee570a658b5c98bd81e1587b40d7d5ee399c82e8e2a4e17de1c82c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualBackgroundColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ecb59e0ef96baa204aedb9c0fbbad2d3c3ed9341443847e466c19aaa750fdf04(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__17e2f760ea21209582a9b402ff80d306e05554a29a7509a9d8d783c34ba2638d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__86b753b42ba05b4b67a1a0a88e98ab1fef5c56303b0e43ceb417977c8b80e648(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__603739c4737d26d6d589f564d34321a333db522cbf1303fd6537cbb1c7f41383(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualBackgroundColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c6eaf61f2ff9d83e6e05edcfc7c80d7446fb449253e4a096f3cac607b7a89533(
    *,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a900e711cc3e993e02c7c3b64d30c2ce4d3994d3cc0a543d0e0d84116c72559(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bdbaf96b6a8904a7b32d0291a2c8f38cb40d68f69b59811c1edae9685eecc329(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0c0848600270e567c373e733836d49d7f547eae64c80f1495a46d71da6ca458b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__383a7d5833f450245abd6023a48b7c5b5f2cd2e185ee99d030364a3b38bcc617(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b0491658467d80f00a6d801a9ef2de1197e08674a664c62c6633d2098c8d03e1(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d47deff31a0e432b0ff190009abc2d1797c8d4d4c694689498773166a838bad(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualBlur]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__93218bc1e69cf07e6322f3ca33f1ee3a146fdb32a0fcff208bcb3a43f2875ed7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__448c45700627867b7240b4536357b48b6b8a61fe9bb15929e2beb6e2c7c923f2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8210442a7a8a24cf0b036c64d56c727dbd1ef464bd4c110bff29498ec3c03b6f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__270a1bda1b771e62389df58d8cef772ea7216019a4b494c8e3b0f96d9d9562da(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualBlur]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b6f40f48ddb64d03819253da0bd8677b0356eab73d918bec80d4e6ff123fb303(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_feather: typing.Optional[builtins.str] = None,
    hue_feather_var: typing.Optional[builtins.str] = None,
    hue_tolerance: typing.Optional[builtins.str] = None,
    hue_tolerance_var: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness_feather: typing.Optional[builtins.str] = None,
    lightness_feather_var: typing.Optional[builtins.str] = None,
    lightness_tolerance: typing.Optional[builtins.str] = None,
    lightness_tolerance_var: typing.Optional[builtins.str] = None,
    saturation_feather: typing.Optional[builtins.str] = None,
    saturation_feather_var: typing.Optional[builtins.str] = None,
    saturation_tolerance: typing.Optional[builtins.str] = None,
    saturation_tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__371f2352913436085014889995b0aa9ade1fd0f6f724b5ab4738cbf5120f8bfd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9adfaab6dcaf4291f44afe8bcebdcff6b92e977a394bd1dc8fd90a0fd1bc3262(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dbfb5741432c007f40e858599c8c74fa8263cd990f748e837595e56778a2cac1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__525c44bf65475d40b0053295ab65f56ff85d63e1d0b148116d3dfeec073bf287(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3040974d05bc2b60f85305442d0540d615b37aef9be3817cf678ce9a7fdb22b7(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__677e7a86e3ecc28f0102847af3bdc5427b8ca3b5f83c63a79f7c971512558038(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualChromaKey]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__91351b79e53a9739bfad0b445d448014f7a61c8fcdc1b8dcfae5849fb1807668(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c19c3a1edd07a76ba3ac48c577f95c45f6b53e15269c6e0c7fc27c1216a8d3ce(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d33374b64ed9b3e8501180a389c9209d80752d34c5acab973854bcc172866519(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4165a80ad5206d5fe28827d9a2597f404c4f5faea1bfdb82ab5ef9fe209cc2fa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9f801df48a0cfa927065fa2f5bd33755070a1f284dc925088d6be072241aa31e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a6c49e025fc05a0911820cbea99c4d6a286620855ee7af159ab99249b10c7ec(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bfd2929489993b032d3fe05602c24c61ba557ee01b8549d7664de25b45066ef6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3c1ae986ddc64599e48c7a54096bfb558280e3f70f3feb02c0a2e9875bd6d0a4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__16f7829d941ab6fb8c91626d848fdc30c14173174b10fc61fd652c9ae5fec725(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4159231f45566368e47f2814e2c7a32882df860e2db0fe7c618e71d5e2aa2228(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__48b8c07b354c1c507f6648f1df8c05c894c315e31d73e1a22add69dbd8a6c79d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__453ce145b708691b5102da2fbcba940c5777f2d25c6d9d3e43c6928f04d80b64(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e8c29ed55fdba06764bcd5a3ec5f94b38fc9f542ff3bca81cae85ab106fa99d1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e2dd1dc96d0c32d9390c3800a9cf305ae2ad688c08921981a08429469914b157(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ad3a5a94d924781dfa2bcab9b7ef1ff897875e7ff3022025f14de4a2ac16cd9d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5021b1de815be77dc653477f35401f3d59451cb958cd076502cdf7ccaddb2406(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualChromaKey]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__53512a177c0fbf7bae60fa97c4ba62905144275996bfb137da5242a19a8db920(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualCompositeImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    placement: typing.Optional[builtins.str] = None,
    placement_var: typing.Optional[builtins.str] = None,
    scale: typing.Optional[builtins.str] = None,
    scale_dimension: typing.Optional[builtins.str] = None,
    scale_dimension_var: typing.Optional[builtins.str] = None,
    scale_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a883000a2905d0eb887b70786a59aec9ce1ea18117996867d1f32260ee405462(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4f9cf66f287ac1b0ed99ad494a4ad928041db18d830898651f047583ffb86a46(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualCompositeImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e9be1c419cf29ee90e2917e5c5b8c3723a63d15e2d8ba26edcd0e01a4a80a304(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4758fa19464b07eef323ddf928f35dd57c4e1f4fa7a1c5ac1c45b1e5951e1bb8(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7524311241389bb56b7cfa2e93a374d8e444d03196189ce3f7df09e533c226e3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f4ef84bedf4ac5f323e4900226503e8ac4650f1cf7de09f1510a2ab48dc353ca(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__047e456a15d1d4d138e77ff562978d7a135c3352ca90d265b99e38435d82eee4(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ef6c908b9387f4cab5d92f9bd51bdd1b92a870873179293eaba5201e5bb3904f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualComposite]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a52d056040d459035a473df2d8856d1579f94493ca1d04c2a779d4eb4048bfc(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c01b1a65e3a794c1d8bc5a9dcd2d41a3281bf8f2d641048eaf8784c2e625a45e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2574f91deeca69f9ca9ce9817f21a3178eba5fb990548536c8d7f7a9fd2ec6a0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fa91b9dd87b8a4c55f3d2ed091c683a446a0f3ad88d62a0475b179cb752831ca(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__abb2cb775bc739eaffc606120a571606e983e3c5fe2360e9f97f98c022dbc683(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4b0a91c9b1c35763129a61157052e8cd13ffbe2cd1837dbf9ebad0e91b2ec447(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__10a59be6c3793546c8bb3c7462fd80c588dc8a9246bbeb23b6d22de9f124ce33(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aae5e7e002185851e5017a216f80993e1d275d566b59df0723f8d8f0acc05545(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f506938f5f5d74fa11b77e81c8dfb2a3564b7d7a973a52685f642ea36e6f8229(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c5bcc583e341a6f31f5704e3503a490ce385788ef2a18ecd5839912c101a22b9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__455ac6c777d7c2d678e3e3af6f2cd53ac83afcdb0b369745e5a050b725f1070d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3e74b2a375783627a7b48c86fa3fe8a3f4783eb419012fb1f465657edccbda9c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8f7d5aeb04507f739b5eb3c5ed62a1987bc64aaea1b646dcaf34b7136958d71b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__abb9fecf68b219424a019d8c54612971bc497ac94e55c2468f0405fd20f47de2(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualComposite]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fe216face3d5cbd8fe1da2fc3bfd1e0499c8e15a7fda3b8989a0a58a19ff428f(
    *,
    transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bad2c93c515959b9bb414703c0b335df59f6e0dd799ccecf15af51d3bcea60ce(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__97cb32ba13d3053a8e38e94e50a949e18c820e28ff31ef05765b03fa82f72b94(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__746e5ce8dd3a2340d247323851c08ad8969154d000082cdb8dff861476193216(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2cf53628c5391684f98e1b1ad930d37b23897dfc810cf4ae7f3016b6f91a97ed(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0693e705a545dab79f8859100c54e6e4d511bcb0d77a7608305f0cd2eb2c0510(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__62e9c408162a5fd14ccee847ca4e6ee56e1d60b96c12fc31ae3bb1748ef22bd1(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualCompound]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a6ffb9b0642dccbbc3427d670e24542a58ba6009a5d36d27878bcd2edd339193(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5227a5c7f3a116bcbfe35fe9b21b5d564e51edf963d0cf2eb605d196623f54cf(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ce9eebcaa8443ed6d351f9f4494df54b4cb57bc744ac2e463fd55753051ade97(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualCompound]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bcc906c908aa34ee1c2bb2b82c1eca123be30abc96fe8a0916521e15206b9b9a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1ad2c250532ee8d864e8798cb93ba1da4af6328dbc9e994c6a2d24fcfc3a7d46(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__504caaebf9b332ab868f8c441b5c32efb02584af96840a7535fec795fbd8d090(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e50a14027c1d9449ba9be4d5158d0b30196a0cb18a5652c31eca797c9e9c3882(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ce49de8c06823a1445815f6ec00bf4ba7ac279da0e0d7e3b8b687fe25aad3ec1(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b72b1eda688edebc4ffb3762a15b0e8e41542a5d96e1f99885f85fa81301a7cd(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualCompoundTransformations]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__62b02ddf7086ac6bc9f0d7d64eb83e06f878a349b03a3d3619df6bceae298b25(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0d8682b3c054e0d0a1d14eeaa4e7ab76854f0904f573a364119033d5ab21156c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualCompoundTransformations]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d963a52fa6710f64a0aa22f3e3c933d57e1640f31aa18dfcddfa4982dcd4dec6(
    *,
    brightness: typing.Optional[builtins.str] = None,
    brightness_var: typing.Optional[builtins.str] = None,
    contrast: typing.Optional[builtins.str] = None,
    contrast_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ec25aa0e4c80354d456e228f22357cfe45b884fd70cb38db36cf2f5e842c057c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7a655a886b1c7e4c14b0376046614094cdb611b8632f71327ddaf5753e467c5c(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c7859d26793be6a64234382193865a5a532027158cafe92bb697f07f6de959b7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e6ab48314eb23f4eba45943497dd3ec8088c3d79d9cdca4ac55efe0484f14d6a(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d0b062ad31a9b2b0ea1d717626673fb971a93bb89fdc02c3300850cd5a4fb24e(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__15392a485ff716f1b52ebb73afa439d64d53060a5630c74f658d7513bd6bf307(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualContrast]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0aa383ad67c2862b873b6bf5d3453760d9bd8ae179f954fb401cedaf16410348(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d7c9836fa564eb5e819f47b18689d4bec3ff7c0e681195e60c77b036747334db(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c3c60cbef0edcbb69b6c57ab99a3caf0a416350e69a77a8339ad0de1a59f66a2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8e7210d4b1f9cf89d9e3792ff14faaf3d30e271e0e57d03aff272e28128038c3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__14e06899df59e5523819a4d7692ac942d34d642800c2820b711e796d74c0fce2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9cea0926ab675e1bece1d0355511f34d40d2737a140365d1858d27297571a983(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualContrast]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__067a7d4cfa876635f03c4f20d0dc96bd0c284e258f0e3c348873de3b91b23f67(
    *,
    chaos: typing.Optional[builtins.str] = None,
    chaos_var: typing.Optional[builtins.str] = None,
    density: typing.Optional[builtins.str] = None,
    density_var: typing.Optional[builtins.str] = None,
    power: typing.Optional[builtins.str] = None,
    power_var: typing.Optional[builtins.str] = None,
    seed: typing.Optional[builtins.str] = None,
    seed_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ce140ebeae9a389ace9113601982fe0fd99b76dcd0ee15077ed5dd4048f037c5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2c776dd7d01ee7ba27635dcb4319b27904dd6bc1b5458dc89dc808b611e4283e(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__faf7d7c556c790e9afb6752c7b52d5831e8fbfcfed1f69d704459fc4302a4293(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__65b2b90726628b4d6789d8480e22a3e62d83064128c5a09a0d576540eab3a61f(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ccde076eb6120b29cf88f5deeccc7b1189d41969a8acbdcf8996d76031cffdfe(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7a71081585e80e78947c9aeb9ccff0faef72e03498a6e6be7245132dfdc729ba(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualGoop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__129c5e566217f6d2f6f11b12ffe21e6f0994e5ab32a282233c26a94baf8c5599(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0445fdf54d7984d9ef4652c57222c053d5404d5b1040c50e5356e3e3d237f79b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__826b3be548204dafdfb0a3b0a75b17280d6e626a255107f44535f004f55df960(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__06eb9bae6f8f50e478a7e74dd1a23d1171140f03af9ad2eabdd617d5d7c60d71(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ed06f6fa7bbe4927a0f489d4d25ec56324b91cb2623dfd821a00464a0d840dc6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2dfcab8356caed1d61f78744e28178226f6aaac439e5f66cb364357b5456ed92(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fd7b54f919fac4d99ec6c6acb922e9e17a4503e70ec0e02838929af7522c6c75(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac9dbb390484dff99f2843dda297d71234355e5dac9528457649aaab4a89e263(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea7a9ffd8356f59e8ef57611c67706f7973cab1675cc7b01a42ab65277f11f04(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0bd3311553835ba78b6781b139bcbbfb559097db89e6d2be4f70a1694f6854fc(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualGoop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__15134fff2544b27358999c4da5aa797fa0f51e1f7a020e1b548a3e35707c718d(
    *,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4acc02c616360d2341d150c39aedefec3d2c31b3afccbeec093520b147047378(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__373e52a0ecda6e3e29c4b804b0198fd58a2a159a7f674088ec152e85bba96462(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__254e6168255d01d5d20de91a90513dc9a4e47058c5a82a3e421a2926363f6962(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0fbd222daa8d46c3ab7ad43b7eeeed09f525629effe45367192c515b4a632291(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5dc52aff9493a57ff6de4475c0540f5e927345416d0c8b26e0ed52e40c4df02f(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ebf2bbfcddacfbf5fcbd7a98223947ccbb399a788e84b8f2ce21c032847ac8a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualGrayscale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dab6bc26a0c41df0ec226545d37db2f3fae2eee9d21a2d4167557db75d663550(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f15a56f44a7a6e554800d437863b979eed7fcc94e5ae47e39d8b490055f9db00(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a2eabd14b3216aedd1e93f5a37cbd1654274c6412813f386ee443a1f843f97c3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bbb9af519aa6aa8fa054853f549c33970b1c4f003b92ae661c259d6a1453897d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualGrayscale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__436b1c54ab479a152be3beb50582e447a3d7f876cecac10601ae40312d1d56e3(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness: typing.Optional[builtins.str] = None,
    lightness_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c23033f9594f8de3b6632f5e028124c87bffe9167f7259bbdd0ca1c554b72291(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2204404a64a8e39c3b8f100c08b44ca91ee4b491c7c98492bf35b51b833759bb(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__864a9405d8f93f8ff005e33c1d3d590ab896144a1d762e4a48143476ade46b8c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c5e1606ec645d26f3038ef72933c0be2ca5319c55df37ff76c812421828d9023(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dad1d4c67638061f5df06e7bba9ce922a82a0c3c4153f98c82e57cb62b13ee0a(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__94664d350dc798e84d9949b04562b005f0b6536d091962d6248c955214b5a67b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualHsl]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eb1e38c36ba9070d790027461f4cfc49806d02fb716e94423f43501a3253f640(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__befda91bc3eb3d9b0d18666b1ce08f9cef7cfdf7c44dbfff99f493c6d3935c7f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b3c4fa31fe597da38872fc4533bf366e95818e6a59f0cf62df368de7809b2f06(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4d5c1b2e4741fd13c85cf8e60e8ad198f1ce9cefbf75360954dd12e9ab61d2c7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__abd2c4c0162c44859b00f5270ca99abec560762de450c1044477038aef47649b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c5d9c7d4f56ee03fe0cb7abb995f97a1cbb8395194bd4a7c1d77ca9fa204f29c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc03d898d81b73e8b84fda2736cee02e0400db6fedaac8253fde806818af0b34(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__080d9740e5814b71133aac4f3392abd3bc02ef6ad077f357ff98ceb72b9b1ed8(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualHsl]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__edfed2db995bd4844c73f0bf8a2aa7de8974359f847e8ad41ce64eccbc04a7da(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7cd17d25db43673e7406aee9415d21deb5295fcb99b0a7c1cfe1c79ff1f217f4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1418ffea966981792c648a7a5bd0a898a5d8a960c29bc3a642d0b08951e624f3(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f044c790fe8ff7e65f7517ca4db6db264e239ca465f8f8cd350e617a0a6f9b39(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0b3c629161f06e81eded95f63f648090e67a13b1bd8f199db965425a0f1c76e6(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__94eb9331a45003714969448d50273d50553890789eeabb38bfffdf9cb9d2d57b(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__611053185b9c650fd5b9a30e33310d957ddb13b4ea718ddc8e2b4b8cc2ee0c35(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualHsv]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d94fb7e761651cf2ff791ca2332e0289d43d2e21b1e492e9690de320a192b7be(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a82723311a1c27e3ea91d9f9c9c5b73f12035e4959e1a608648a2c0b1e361bdc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__98e53215336b00e0e93f3caf84c702518348deebc7dc99134b6c8f84b8594999(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__513247df4939ff876f728af1aa51ab96b92948b83f13f9e1c6d7a426d8203bca(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac3a83f7a9dc2037a5136b4d94530685f1f036afdb27bb5d8d939d9a0e0094e4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__987c8fb7abb71cbee8488f06542d7964dda507c25a51a91f33c216eb346601b9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dc9f217b3b11babd90a92ea255aa027a83fc6a24edca13614adba6916bde294c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c5a8c7b76ab2569e25aeb344a95ef2fac150e3378dba90f9c59c5d9b67a54f9c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualHsv]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f29aa500c3719ee4d75e0b653d0adac69e0c890179329be440d9041fc866c649(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfDimensionDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    dimension: typing.Optional[builtins.str] = None,
    dimension_var: typing.Optional[builtins.str] = None,
    equal: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfDimensionEqual, typing.Dict[builtins.str, typing.Any]]] = None,
    greater_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfDimensionGreaterThan, typing.Dict[builtins.str, typing.Any]]] = None,
    less_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfDimensionLessThan, typing.Dict[builtins.str, typing.Any]]] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0654b6a4c7e83211604a004a58e48ebd70dcb75cd54c883f458ed7d23a866712(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b3cf4408c1869e1edef43223b3420339636255fd6909e8e98293943c01a0dda1(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfDimensionDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0529e9515971d7d5656ade6377af8b9425b9dc32b6460ffe205b3fb4ad7e022f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__938480248c25ba9aefe2b82c661525e28d7e55bb378473b95f1bc60cbc0c70ff(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfDimensionEqual],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3290f9d5a44672c3c5a7f68d5f7c396ce09f96e11f4cfa775b674accc7d948a2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cdff202e1fe067c9da3bb669e65bcb4a00fd4daee6a2f1b871547d71039f88ac(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfDimensionGreaterThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__adb0fb53a4cea0da264d8bcb727fe4dd21c44319f8c6d28e90521481b0290abc(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__09b02f145c610c96c4459d5a633ffcca8719eb26122a79dfb85b46689df351a8(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfDimensionLessThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4841a02d86bb814c3aaad516201bded338ab5fa635f0da948b39cd4aec0ffc9d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ed9819c2a913b7816a9f04637622d67787ab0d41bf4b85456e683ca6b4dcc54(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ccb44572d86c7f52bb40956b3b5de1a17a2c3b3581c01dca17271e5d2d7935d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cca2286853b02cc08e3b21fe436e09356e2798fefd174526e62a3b7a0245b51b(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ffba37f83a017d5899475d059e4386203127030ba4c2f0adf6054419480a7ae6(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__67f617e25dd239f8398b76215eb5c15f1d858f0f08915f3fa1dab624353ef457(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfDimension]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dbfac6814ead4b950737170beb4351930e2fd9aa4bd758e16e021255ff0e29fe(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__761e4c64641d93576499695192802f995972bb80d8aa003912a29878d675b980(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__77e491f5fb857ddaffcc349dc86e24ca9ef300294f7e495243ce6199bad1fd74(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a6c81a28c62eb834de3b859a4c756c2bd8a5577aeff489a972f76538bedd264(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__86d578b6baa3fce4d6afe90f45b652e233c261a9732630b0607e46b8b5e04756(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__27be1902f161e58a1e9883ed7804536a687b58f14981b42160603f3154b0354b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfDimension]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d1d7378eb2425ea63edb2b6df03aec75de6eb41d237f269d38e8b37a7d974bca(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfOrientationDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    landscape: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfOrientationLandscape, typing.Dict[builtins.str, typing.Any]]] = None,
    portrait: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfOrientationPortrait, typing.Dict[builtins.str, typing.Any]]] = None,
    square: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfOrientationSquare, typing.Dict[builtins.str, typing.Any]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__37dfc651e3e55e9a6e35b45f423b4c187530c0de2504440ee6bc5fbd17bce39e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4849bbdfa5c481805994ad9eca8dfa99f005b7c4356e9623291b39ee55bf16e6(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfOrientationDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__90fd013239deda2990648295456e4eb682babcdc69ac03319ac809e9faa16395(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__33c43092a4890f967e77096363a6aaaf629fa06ea4d2972ae4a8b4a05fc6ae3a(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfOrientationLandscape],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__59434560e6bf8375a1e9f2a40bd56eaf5d3f15c31afea9b84e62a1d54beada39(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3925de0d5cd9587cfaa5b382bedb19057c0445ce3c3adddb84cadbb523353c74(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__304754fbcf25a3ae1638bbdd2be856a7e44f8f93ae3623e7eff6b42b215c5ec8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__01b5ce57033c75a56cf5bc4d73fd1a67a556eab01fb2daa9906caf825aff8ca4(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__37a909ae60e7d40c91f75e209ca7a9f9676b423746bcf3f589041a459b5710f8(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1faa8d78a89dbf5180f2087366ea4bdaea854f477abc1d9053bd32808c0b4ab8(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfOrientation]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c1ef88451355505d68dd1a1e2a06cf1c5d149d5f4bff23e45e261321ceee6897(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b9912f85ac7dae169acf6da7fd7e2f7ff6e0c67549c2b5c1f3d9a7131f51d12d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfOrientation]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d65b1d3bcd361e4be5a1e81bd022e56c4ef2b470a286a4a7fd5c13a581210d4c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fa296662e257c7e234c1b9c4090c26f2ebb6304f491687615ca319a0840eb31c(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfOrientationPortrait],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5c440c8fb819f4afdc15cb244da4cf26c5c199eb432b66d68c9f822599ddc0a4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b20e58accc1fb7b260f221f73126b136b5c7655228de237631c7be9357cc6ebf(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfOrientationSquare],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ffdace73790e7ebceb27054f22661ec39694277cc1b7677927b746cbbec7edfb(
    *,
    colors: typing.Optional[builtins.str] = None,
    colors_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6af21ab4a9d690ef1268b2daaff262613162822f5564e7acf4dde1c449fdead2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4548844a1156f04e02f4254bc0f421a7a1d354f9dbe87a02c7c7b5a8b4e26dbd(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cdfbd9a56d8f31eb9f68fa571c47d64c50b3ca753b02dfe82c981f452b404345(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__710b6caa077527c305911a017f23d87bc92a72f358370b2fe4b11f89db7c80d8(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a6ddf69dcea0aa03121e5ed8c00ec0fed7bcf489df729a0ed7ea04ccda44644d(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f0a94a5893b9582abc48ebf7c22a3ce08cd9b3ac3e821cb315aa5985a364d9b0(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualMaxColors]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__43eb5f32359a965274254fe9e4e63fc1d894f426009832842317ed022bd2f317(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c8595a7b2a5a294972cf12e3109b8663c696b78a8df8bf87316601607a81da76(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ed471f2a089e075650c9dacbd31a71eed6aa9ddf7d4683dbab14b74bc7bc9fd3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cc7f641314bfda9173b09f2982ffe7a9e6ef2e3f6bbc999cbd0a604ef38a3a64(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualMaxColors]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0b6a5f46c1a926c14f197eb7d30a880ddaab6b0bfb28495a79138597919aa3c5(
    *,
    horizontal: typing.Optional[builtins.str] = None,
    horizontal_var: typing.Optional[builtins.str] = None,
    vertical: typing.Optional[builtins.str] = None,
    vertical_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8857ca39fc710e837f0c8c05c350ae9782d184aa85e104461b2f824a4124da08(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__05e600fe6d2e6ee55ce20d90d398ab221b4ae853fac78475dc2252173c66e68e(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__551b73e1b8ff62023b7ce993f274b211a11a8e57564b3e24bc96c7d68c0df14f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e69a1b2a0adc48363b34d6bf8a7d240a815ead395dcf203913f93b8f2c3ede44(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__35c46a2253a6a8034cc1be75b40361f979d2d282a62d33e64716b49d425145fe(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__97e69851bc033e5e5f9dec1dce2fbc8678492351c11a12decead18c823bd8391(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualMirror]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4d0ac354a4f3f7a516eb6f384fe87b21d12fbf76a840b9c3a36f03d15914cd97(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c9a54a56e01f70a5cd90c412a205774e3e39778b666a89e71bbae1f4c2b46c1c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8f7c666250584f0591c40061804e6813c76d06654c7d8ce012af9916ccb20b1b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__affae258e5deae75b61f87ee23cb17dfc51109af1f595cbae572f1c0dde05334(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__196877dd35edfe4b764aff40294ecac12a79a7193db1bf375b2e64f66eb1d4b0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__68cceb23f8200f9b65f1b57422199b51273847aaedc37eb9b880002cbde319e9(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualMirror]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a4f7f1d8855c9cd4f7b807e21a14ff9e51a93e8384b691616ecdfb70e79574a6(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__71636c18f470bd63ec9273650d3bb72cfddcfcda624095e49125eff49938523a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dbe2b198b7002a69078ee9d066585ce05adc0e98e5a9bde513d6a7ae4b15e832(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af36bb0f3f61356b1e95a54fa25141bccda75bf6e0eb052afdf96e0de372ee1b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__afd6f2c4a9a75127c89efc7a4a1f9053306633d0aa13ab1c6046688b7c177284(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f81db770c21a40af1a5deb77c161b9ce94691688216a0b66302f6d387005383e(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__606631799240506b401aad7af3e651f39eb8aca5ba272c624e211bb6677a610c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualMonoHue]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__152bb49caeec2e94a923c95ba328df2592b7e18ec9d69af3dacdb3ce05747d91(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__292ce903d22ad289e43f017f4303a2dbbf3cb9b6315720023e7286d4cacf276b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f7ab4387736d1be5fff542bf9433949fcdeda57cc9e62666b78b5b0e3f1a1c7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8e2591e64b016540f471b545b61fd2fef3fdb625f607a3158a175f58eeba642f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualMonoHue]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac6c1f020828626eec1a1104c93e32b7d134fd2eba56a55e0435c786c88e4a5a(
    *,
    opacity: typing.Optional[builtins.str] = None,
    opacity_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7e82e559edecf8d324d882379fac4964974a8c1af303fcf981fdddefc548c407(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__41485b603b0f18ea8a1df1604377fa0c84a09616453d330d4d006d86339e20c5(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__390527c8184b67630eae4552449db6774b5c1e9f2f739aacf0bd0c663b704e5b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b95b2fc4080c211fa0b063fe89d6e98c6729ff962de356b96286e1ecea19ed2f(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__59eafa42947eaa79d5bf0aa2bac663d148aa4f417165afeded924ba760a67fe3(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__38af1b0d72d5c2367555b92670a3fadd09124fc099d1f39564426b859310e81d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualOpacity]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__40029822633917b6fd477dd97d08b39eea0a0f651909de33b4948fa9d6f613a0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__428a1f4275275700d622c8500a30336103887eded5268491de64a3171ad1e013(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4cd9850bc0dcb60320cfab96c2f0c1f3a904cb93e3ac5f156a5d872ce8989123(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__87e7e1ed5ddff62e44e42f0de71047b392b6cea92e16da3bb7020f9160a8581b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualOpacity]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4eafb1ffb18d16928687ec11da855c829dff4a9ccc25f67a2c1f18a533c8cbd3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a2d1feade3a79d5f03e0d85a9eeb01670963fc231c7583efbdc99d405ebe124(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8d31b59076f8899d4e738185e5a132a35d72cd78b4ef8f4cfe4bc2b643a915bd(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualBlur, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__99c8d96d1617e6648f02bb1873d0accb2eb44b0c093ee2479cdb21144c4f35c2(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualChromaKey, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2efc5b72d909dce8da0a2b4286425794b342d5c19d70114672076533636b0e81(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualComposite, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8478037e977d0c13267d2b89085179bc4d7460b50e386b1fb615542a44fdb658(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualCompound, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__40035561d80cd751952039c3f3e98ac2b51d6f60962dcb8a66ce6227ed26397e(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualContrast, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__85e2a4aecde86be64a9ad2edc0f79f1159cd7252be3ff8dcac394ba4a2566c6e(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualGoop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a2dc145b6e8d7861a90affcb04f077439538a012e02bfa9c708266b953e5e45e(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualGrayscale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f599741b1418326774d47ef7bafe34e1e4322a3d53998e6c026d53b69efde3b5(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualHsl, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0f97a4354b132127d9ea2e11d28d4c3a8f819f936e6af77a2d392cfeb7033502(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualHsv, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__767891cc1e5c6519722f9e71be857c299345737db4a31f42f7216002d8454e3d(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfDimension, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__347cef4c6c2f15934325de9d2cb893fc7c6f943b6527f9a09d43c69e359f3b27(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__866120067dff67732d51e9919b01ea07e2feb97fe2503f28621deb80af9fba04(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualMaxColors, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ebd99b1fed6bd18913ea039f540f963469c3dcd20845e98478335727722b6072(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualMirror, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a54a380aaa31e863789f81ecdf99c1c9bbd291223ebb2802b4b3cd925dafcbb(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualMonoHue, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__edae2352b61096c8aeaa0e41fc731705fd834d8789441ff80d9089a1b99ecfe5(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualOpacity, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f7f4ec77e3ac398b5fbe63567cfcbad70f621359eddea4c0007ec27fed84d041(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualRemoveColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c1730477695f243f125b879548305a4b3fce97893d277d79998efab8901f9cbd(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualUnsharpMask, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e4b23ec89f0c7c64890fc7fc18cc98883accaae0d2f3ad0faae904b87fea42d3(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqual],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9cd9fa1200dc547d99048ec22631d0e173b540ca79803f2bf1e2f1d19d7bbfc8(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
    feather: typing.Optional[builtins.str] = None,
    feather_var: typing.Optional[builtins.str] = None,
    tolerance: typing.Optional[builtins.str] = None,
    tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f95d9298e7396923ea514a84e2a9fd38f09fb712d0075303d7a9fc8fe88b8883(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9424455b72cf927c89d018c852a4c1484cbf2d4c04af70ce1a5d1fb74866184b(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__60a451c97ef587bb71fd04a5397abf7b699757b61b1e2db348d269c162faf043(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af12168d36fbaa8d9fd4a99d8cfae5cc763c5e9921fdca69444f422c25d85a02(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0af2988ed2f799743b54bab0ee097bc68b67c64a6bad18e440ab1148080fd7b0(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6474049534276ba170d60a91092fde9b258d3cc45ef968fa4c21aa696bc9c87d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualRemoveColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5363a1aa43ba07cadca273ea3ef00c89663fd097d1b195729f726d35170483c8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__83da2c1d1115fda2fe10ff0f065a69d4779eccfe4e68c6065410b54056eef2b7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a1b2d90229238d0eba3c154a8017f7f8f0f3e8d4e292bdb1a5f1a34516e9321(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eaedf91bd596da3333caa340bfb868601e622f32cef2c97aef8a48946360ae58(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b9ab71421431ad868963aab3ce7ee14aacbf9cf0b5cd06c590a2d834d9b897c2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd9451ef08a15cf019f051d77d733fdaab4ee27861aef6e654819595f8b48fd8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__16a3e6003f97e6cfbce8a53e70018c4396fa0d37cbf402b0a2b4e40e97f93e56(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__11b0845330de823e65557b1ed3a66a798e6558658f27269d0505256efdaa0c28(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualRemoveColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5e458b25be57738a5e83d7c3b551abe900741a62687701d3c9d4e3ea8c97bff4(
    *,
    gain: typing.Optional[builtins.str] = None,
    gain_var: typing.Optional[builtins.str] = None,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
    threshold: typing.Optional[builtins.str] = None,
    threshold_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__61abd9000a25df57ac28dabe0ed03bb92e0aaf22a2d39b6b15fb1a9bb606de9d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3438459c30f2ffd31ef1dfe5defee35241d9c44da555c8dd4c0414fceae2c1b8(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9de086c73af871de1480979ec29404be740cd406e5a78b2694528b0bc5e6b545(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4468e67e6b7c2879e8d005410b66f8c10fcc12718a084d6acf0847a5b8e07971(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fd710e23ea49ca06f2bc7d05355890624b3cd10442c3cdd0a561546af5b6b8fc(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__899e5ef895eb473aa5d08464cf1395403f5b28237d8d4e863a2c5a2683ecd329(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualUnsharpMask]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__238f5f2d30811cbc1b309533e87712f24d20d4fbfd2d932af0fa5564cf4bd4ef(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__667cbc286735ebefb0215d315078788aa0506c4f9f9384219885f65358f0ec96(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1cc11cb88823f61476a0f7a3b2cabe617f93cfb3784c5ec798a708509ee06c9b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5b6f5ba8f25f2953600bc5429f6f7bd0035743599814c5b9871ff0e3c0d231ef(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f4b5f12e51c660af5f520a549f8f25955ea8313ee2b2d07bc9a9f3b4f0b41cdb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0a56b9625f314c74706a202f2c0e41758677f80e7e719e7a002956dcf08bcc86(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6b66eee0d7ce0a2fa3e16b0e56f3871b6d040a9c1dc8976f47735ed85bf9a8e5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__706d0e2224f6b3a6b88b23fffdc0e86b68f403fcd315c5e5acb55a98dacbab62(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionEqualUnsharpMask]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c7dda430a5f7c1b532ecdfc8d4191af62cbfdc46a4c9d67a95e1768bbfeb3329(
    *,
    background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
    chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
    composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
    compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
    contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
    goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
    max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
    opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
    remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5a8461ce47273008f7ec90415bb7664cb85f28ce37801808c4a4ee1bf88f73e5(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ba831df5d53e38d5fe16d11ec7da2e50435ddbf3f650e1690b8858eb88e9ffe(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__87b47c286ae4a03878e3a50350bb536a07a66027b28132ecebb2aadfef8dd5ef(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9aaba333268f44f1f1e8e2597e6b72493e3bc1061596f58b68138bcb121f774a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0aeacb507ef6216da6e7bee0fd396e59f21b08c4fada083cd094028f002cbd89(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0449e82aeac677004e82b2ec726d362527051032c518c6d92c30649d5de36d2f(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b617ac6049d6c7ab0b56f6090d48253299ad4dedea31e8fbe80a11eb7aeca3a8(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanBackgroundColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8591574f58480f474e58d05c02f3f22875a51148d61d7f3f57d9aef9321ba0c6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ac14c8981262f82092f2e9cc2e0e80383096e4e1ff3d67daf599d162aa62ea4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d3e6105851380f5be71623a5943822199de37dc126db47cd4c4bf04b19534dbe(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a81fd8ebdbc75f42dd4698f3f4c2d6d099486e5c826d8e51cc3d4b4ec090f2ca(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanBackgroundColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__34e6473e702e4df5d891e9c19404245d429171a3bc4aab505eb3aaba96164ea8(
    *,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2554b3beaaa2fcee16481350ebf017d5b9e4e666294ea26ec44ad9e6783fb5cb(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a2e05b60c722f154061fbc4a37efb35e6645078d3da10424b8eed6d2d8d7f9be(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ee62455a750f70c1f436a1f46ef876331cd15b1de0a5b4c770ce905419f94cc8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a18419b346580c9d5cfc893049e55941b0e4758d9505573a195f97e2bb414259(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e031589f52053b2fe2b23fec7dfb59c143c3bfd583cd93730a339137598473b7(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ffe3144fd69b9437407f7a6790d739edab8ad42a60c82db455928b555571b6f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanBlur]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e1bb26e6adcf8fbae08e7ffed519b6a93423e74c2c55eb62f5e7538c92291735(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__89aaead51260fb027b815262ba240f4628697e31208bbe1fc580f1daf606d4d5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2179acb884ca45fa6fe018da9e8e592bbb43595ada5822beb1e464ad1dd97fa9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b52b4581911ceab56fe57b3384ee05e2007c4dc761093e5043851156d968f6b8(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanBlur]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__414275b6e8cab6c700b2ee938844b823931bb655bc02d05f2b395ae30ea15ab3(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_feather: typing.Optional[builtins.str] = None,
    hue_feather_var: typing.Optional[builtins.str] = None,
    hue_tolerance: typing.Optional[builtins.str] = None,
    hue_tolerance_var: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness_feather: typing.Optional[builtins.str] = None,
    lightness_feather_var: typing.Optional[builtins.str] = None,
    lightness_tolerance: typing.Optional[builtins.str] = None,
    lightness_tolerance_var: typing.Optional[builtins.str] = None,
    saturation_feather: typing.Optional[builtins.str] = None,
    saturation_feather_var: typing.Optional[builtins.str] = None,
    saturation_tolerance: typing.Optional[builtins.str] = None,
    saturation_tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7518cfd722694fe0a4c7b37e5764034559f48998807728b46030c5f512881e09(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d2777827b8c99ca485938576956f1db02dc8480826721d4e3c3acbb6393290f4(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__981687f23833c440f505fb9f0ebaf035c71e2d6db434e1fc82177f0697d35166(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5aa30d0e372fdbc6f85acf30372693b5acfd3328bfcee58184d020a6ec487f46(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b32e5d21d797de8516d9de5e128f1d0885b4dfaf97fe52f9a47929efcfc662eb(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__afb7855cb31220628ee59db1e07d75ca803f66d4947fe4257b0ea87ccc3fb8c9(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanChromaKey]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c0cf5262db8f3a88700b050656bb518d626c29534a0f96a5bedeb532768ecc2b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cb8a6d8255863e139e3d84d5c869a9d7988a5a1b5e07fd1cf3796cec34724a1d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb2cb1b681652404311448f5ee0ece39e47508d42a2682eb1397a2d56a384353(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__60a8ed1858072df0e2123a3b62dee766c35d55fa6ae4ee97de401605cb228977(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2e57e13e82a7eba270416e2741291ce3bb916abf62ffdbe6fd592bfd40e16f1b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__75fffd307f05c62a6bd5e8f2e5b6bc6009ad030982e27fe4cfb031c270b60064(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bcd2dfb2ad04b92ce93603aca80f90cde8d367e1d039ece580c57a0b13b6d40d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__17fde7f99a7281b35156c0b2b566820ef5827d6b70ed68d001e20e46708618e3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ccabea2cad56238702638f7814421cbdbf952a12f18c3de513369d928f4604c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7e5b7c92c68dbae7340351a416e8edb948ac868cedfd5fde709aa70c45508bc1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__951c35d62d09d5c7c9740065e1ccb8141a4109f3759d5c9e4a55846c08af335c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__743bc87c1b5c57c1b3722866f13f23786b65bd5788eccb4783485c36827ecb6a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ff27c1237477f55c6d27181056610827f91cb0d6597e362d2f5c7f7d5bd47f9a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f52ec74f1e13d6910f1a30a17441754347e20f885ff95a44edc5fe00815525df(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bdf3b992a4c5265e50b43bd74b86a24280d0d3635d62027135c2b9dfeb0a6e66(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__95a51f258c56e45d11f0662cfb17dc60270feab115bd48a99838586353c976cb(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanChromaKey]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3abfbe8cb6377272959eb85b25aacb960956286bf7a7fea0cbd3b1e2391c97fd(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanCompositeImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    placement: typing.Optional[builtins.str] = None,
    placement_var: typing.Optional[builtins.str] = None,
    scale: typing.Optional[builtins.str] = None,
    scale_dimension: typing.Optional[builtins.str] = None,
    scale_dimension_var: typing.Optional[builtins.str] = None,
    scale_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4c8fce1c6739afe597f87d9b9197028c23b21e2adaddce439a5fa82b3dc05f3c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e67fa400242bd4a60b8993fd622b8380781774feac92d63b35f1628fc86e9007(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanCompositeImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ec9a3257a600539919ca6ff9a2712ae968faa692a6d63bef3cf17ebe14eaf082(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6cd9b94bfb8a1d796bb9314972c209671e38c64423ac313afb365632b5cfbd9c(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a1681d456e4ac42d3bf49c79bf17ebeef27ded2b3fbf02cb78bb792de9389fe0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd83249d39e0d626be31ebfd7f108f7943243abc6b8bdd3b0e4c9846ca31bf0c(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f7c6ee9026a6d05bc79a809b8aedb35a969635a745fefed6c6b88f0dffcaad8(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__810eacab11f92eb73029b4b6cce0206a0f91260a50d3e10aaa3d6608d3759acb(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanComposite]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5bd53f0f56ffa3d0eea25b500bf59315f48b578ca2578d263e0ac2b608562bc3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b089e74067122cc186c0b8d3f46bb4fa34877290ec2bed4df196b6b4684bcc17(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fd792b0fb18192a4eb64d35c69ac8a897111b37c5ecbbdcea4196b548c05b334(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__799d0c2c8fd0c4380b391f9822657ee3cae9ebef89186aa8095f503cfa3ec1b7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6fdec0da66981591b8a872a8c20adfd06a865a3cb3d1f78520fca920dbd3c731(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__975499b13def20586372901ffeeaa0be583d7c232c78e2d1d01783a754192af9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b5e88d42f38e0d3f8097300b9d1d1d573f1782b93d8d67762e53671f27459aed(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e04ad1fcc1674abb017d980896fb4fb80e9e0ad350e23ca97720978287c026f2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f3ce75c78a25e13d3b959648da2bdd2c9e493f7123bcb4e4956aa0a98eaa8ef3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5e4db4944943552bc2a4734fb218cd46d34c90bd962fac7f29aeadd4fa4e913e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__710357feaacd2e1ea20b8a14450cc2a047c58138a7cdd252346fc1ba181d818b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c6f86f51399267e952db15b70a5f746d5202ed2906149bc9554586b2089f7cb0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a4032fd9a5e876122fd62cb56b1e79df570a967ce40a5ca9159b60d1f4a1aef9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c797fac0e158089387de1181a9f6af78f9a0958051dd99861d9db64bb528a4e2(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanComposite]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__07d0d49d42f0c0280d8827c0702310fe380c855dca9586ddd84e4a1ea9dfb35a(
    *,
    transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__34552a1f98147b25547caaee5ead338b7e64cbdbc5e86d4f35b0c97f500af3b1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__92de4d156cee6298bb977d36a63a1374c2f075d9f743d39c7454d1ac56b0a3b7(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7656fcfbf5976127bf1131e5a99b98162bdf8fb2d6f0a80ec835ac60a1957ea5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__296fe60d25a19ec5b932918a65058faaedf13ee1f5fb82423b896deabe0a82b4(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__81079465755ee68667ba82743c03c7ab8f2c952e02b7e0c86f51fe0e501008ee(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c69174d6c2d9d530f713c923ced243886450508dce32219b488eb01de594837c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanCompound]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d6b91f241752cd8c360b002d44c1a3e69ba491ce6816a792d11319193275b3d9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0abaefc0a6acd3ae48736066a3e5abfadd4d9b3f90f8eba98d04be7bdefc4947(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2f998cac078c08ab42b16614508c744c8ca1dc4c9ab9944f010e322a40d67cec(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanCompound]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d65b9915014f11a831ff1adea00d964855049da929c0854a6dd4841f0b266d00(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4d905a8bf657a4f5ed059655b702739d19f66e331ea182867a359e6005d45c9c(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6a52e4cf9e3a4f5ba4759d37e44fb6de8e1f2778ed19a461b128b9fed292d346(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cde2dbfc45e5ae0b29143f2e6204b6f3ff9897403150711edab6170c0ebab79e(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__04e48118d3927ff84bcbfa8508d62531f0a9d799c09b94dcf4be74fd14e7a4e9(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af16abd08ce3c578d4984953497438e19567617ccd358ed5fb9912aefb02cb13(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanCompoundTransformations]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a0c58e088f099e7984c04b43eb66ed2aaba14ca04916ac8f246719baa4e2c41e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a479ec619594bec9950f6b0d49e9a83d95c8625b1332bd59b6b32e552506acc9(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanCompoundTransformations]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6b7d53507b2f82a88d474fac39f0e7683eddcd0afe52e4c36c80da56c842a36d(
    *,
    brightness: typing.Optional[builtins.str] = None,
    brightness_var: typing.Optional[builtins.str] = None,
    contrast: typing.Optional[builtins.str] = None,
    contrast_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1a8cc488359c6e0e20d6bac99c5b1f40cb6a6454f0bf6d1f91798661fbbd0834(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ad97702e84f8162ef987fc4fbd0167894e4bcedb9bbc4c8d0c229d4aee067e9(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e1cb8b7e439fae766cf082f6e58f8c7e99376b34d0f6423b9dd7b2829362ca1c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__11948e18ad6900fd54c37d9d905f978d6d21a01d62ccdf8110991c41de1e98b7(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__17bf628e7c7ae4e435a87f7dd72fcb4288b222231652f05fab3356fb23006c63(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__39e9c13f5d8d72561e8937435f60cdbc20d3e3a14b9788badb21caf2bb28ecdd(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanContrast]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d3271d87270d2ab5e3f67cad585099f92d4bd5382e9aae3ab9d7b05d6682f9f6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__289c9f8cb365b190f523a8baf9a524d1092324b0e816bb8d84df4c1667171763(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ac1df71a5d6f673a3b4f810d18a76e299ebcec505d0eb477c76c20364b519a2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3da744d83495701a27325143291ff25683118588253ed2f08cd0ab2351cc60e6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__514b31850211ba37b6b49ab0b2689d027f80dffb91cdcfd4f76a76b7f819b56c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6d910b9fc8e9c689b61d0e64ec5163c5284ffbba365f992fd55aae5805f24b16(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanContrast]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__00d75455e21c56b9636e14e61a1185f64548f40f96096ae0af34b66664b3e995(
    *,
    chaos: typing.Optional[builtins.str] = None,
    chaos_var: typing.Optional[builtins.str] = None,
    density: typing.Optional[builtins.str] = None,
    density_var: typing.Optional[builtins.str] = None,
    power: typing.Optional[builtins.str] = None,
    power_var: typing.Optional[builtins.str] = None,
    seed: typing.Optional[builtins.str] = None,
    seed_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__91dcf424181fb209baa2bae0a16cb0725ea3558a515e4f30a2d0b26a59a0992a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__346c9318fa72455c6bc3d3ffa2f06a936ac13b7314b09f2ae25c177ffcedbc84(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__db3c03e26fd0b1e7fe8570b680ec1d5d27372ec2db39a2ff3ae7a1b330a0f2f1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1ca62edc408d5a44687d190ce855f611da60f7990eac1e1fe264a20abeafee74(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__56c5eb59797ddc38d78248945ad2a8ae407ebec7f8fad8a47bdbee4d5ba36849(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8380dae7e2cb6e1ffad8b2473b8cea6d6b213f349c43055e058d6d7ff5ed66b2(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanGoop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__982a4526a47bca92b5f408822b29e680187a249c87b65ae467ee3ef0cbbaf11c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be5fa1357e661f84a07a1570dc05811ffdfacb060b6eac9c2b9ccdad505d12e9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c7a6f3d5ab2e12041f906546806d6770c5fee63ae47f4aca04b70f5fba17f470(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1263c34d8dc30155ba6258686463e8c00bb4a450e9078d12c1c966c536285ce1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8c20f5a015319bd0caab4178ea3b855da0c234f18936bc3151353482707809e0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__42d6ac88cd966696a6a5cc2b4b27189ad375dea72403123b9f561939d53654cf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea4d8e7677b62b8e09ffaebb3761b06301030a20fd39009ccf6fe7480887eab7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4edda2985ce46e3521783fc68c933c82b4994126e6eaeddc8947a17e9fdeb086(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__80e323bb828cf19f10d5f798694944f1c6a92889232d7b9a21033b65a45403c3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__96b6977e0966339198e758b5c3bdf15036b42bc9fb0a43862efa364479b762ce(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanGoop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f89d9326e01968bcf7db151f611cfd04c250dc947e04a71ddd837972221c7fb(
    *,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__837106f5d11b949885a67bb88a59c09d75cc4c3edfadba9ba8dbf595b12063aa(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b8b668a32c7bb4eb9ae61f23899aa3b213d2273270bfbd848d1c75ee6bed108c(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__64058fe987f6772f51eea49dddc4b031fc88128cb780bd0642de2f9a7efd8d6b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7abab27fa62271033bb9eb7a5d1d439e64da19f9d3eabc7e7e023b7c15ab9636(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f40abac8892bc662300f3bdb95a3bb608f590196241ba383251b3dd4f049c56f(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7bd7d0d3e6ae1b388554ca6a051feadfe0cd2b4580e8775046026fbab457389b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanGrayscale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7309ef6fe1669a82bcbd9f756021c7b175b06e11031fdee364469c3a1beed015(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c24fabf11bb533bdfadbf34b705ed1a5f4b9d05aa2687718c1890c73b67e0f79(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d2470beb9152beafe8e965f452a6776205939deae817195ff2071b51dba369f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0feb76f4d2e964691e276bf8044da5c36fc0c6935a35486d0338820da97cabc8(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanGrayscale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b6f19068ea3e711b6a01dc30f4fa6cf81f5480bce2967a3f943cec1ab7a74fbd(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness: typing.Optional[builtins.str] = None,
    lightness_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__41c8a106b2ad31f9b25070e8c73824ffb2fdfd7333a147b3690a34b4af7c5672(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__77dc17cd485fd355eefae64041f8880b86b68934ed2bf0bfc5114b95c26d23e3(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8f08ad53f82eefc95f1b4f3318170a1171873f76f4cf5cfddf91d292e663183b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fc7f51e9cb052df4854b5665500f8ddbafb0900af9aec66f27739d5986640388(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__13f76bb810372027265c84abded8547d5ecabe99b85d17f37dd351c42b64181c(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5e0afb3ef7c4d46f6ab8c6b447f9dc5bc13acd74ee16bf0ea7d4ba076d03104b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanHsl]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__51f3429ec5747d13f5776aef8d96add0e4d5cb042563208eea4e84a3e1cd5fe8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c13d10684150ccafa153b054051faf2a64cc50e29f84d0fe5ec8dda1410e2f56(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__baccbc4a997b64f02ac2fffc72fd6ed96f397ab418ccec62c3df284a4009e10d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4d57d623fe0359248538a80eac4396a4d7d0780f57a61e965d972c5f87fd1a70(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8d4a07794e407615a8d28a38af4496028f1d6b431b2a4045a452addb9c5074cb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__408bf7493b86f27c2462cf5641e6c252a093b3cfd0ddc9ee2868d09eaf3458b9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__425cb5fdc15d6169c08c1988ec4f514d4082b48a6d893bc0033bcbb99b3138db(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0984d2e748e205527483606d6c1dbf7385857df9917a7a43d1cf3db333ca9724(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanHsl]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aa8394fe0dd2b7f0e44451a472d07cd058aca7547d2f2cc86539702f9c5fb3bd(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__61b6ee7b719da1ab9019ffed6081cac9bc51ae890e4884ee9a0c5b9c1a990548(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cbefb6eb9ac657279b48c9ff312849ae9fb715b239bfff04a630ee0fc935c55f(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e96359b303cf566539887c3ff853a0284de6fcc8d26428c3bab948d735ee036f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7f8fb55e6e36c486e33b7654158ec265b5dcd50dc08f6cd7def809edd1757229(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9b22df128950442d5ec29eabe07503e88421ed10461eee301a35cab1f89d0210(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ec39aadd428519216f467222d01db43f9ecb41fd67a995dcfd588b591be05c61(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanHsv]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c80054e1463c3bfccd3724e5903816993e3e0330c2893029a9d19e7f3ad8d244(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__680f4f401afa4983c3775de53690a0d7d67e6daa6a406afbe89a98cfde036f96(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5fc7304b9d54834213d42c25dc797851f84ac5448c5bd558819eb26d8e76c1db(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__da0f24f95016f2e179c1194db84008ef6f49fb672c8b28af25287af4558ccb33(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d7df6e866b177a601196a985689b544dbbe0caec070851f3ad39e3b4f23e2e05(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__669729276102ded74e6d61ed49e9e6541dfdb9305fc8e65ae62fe290f4704a4d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a5f5ce33d91d1c324c7e6aa1001856b4088567707463d076a412ad4995da6e42(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__48762d0054f22b3b432b4d0b328609828935f32099b466e8078991c70ed18079(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanHsv]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5e9082fc662a8f60925b2af1bf3dcdc95674db8014f38badd2841cdc87792df7(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfDimensionDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    dimension: typing.Optional[builtins.str] = None,
    dimension_var: typing.Optional[builtins.str] = None,
    equal: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfDimensionEqual, typing.Dict[builtins.str, typing.Any]]] = None,
    greater_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfDimensionGreaterThan, typing.Dict[builtins.str, typing.Any]]] = None,
    less_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfDimensionLessThan, typing.Dict[builtins.str, typing.Any]]] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b2085c5403081c8ca4e462cafbdec572bbfc5a74733ddc7a9179ad882ab8aea4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__67888f6f0f84174db5fca26be0e3291bc4977eac2458c3685ed1f784eaf9dc31(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfDimensionDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b8dbf72c27c1da2160c9e2f0569f97e883e59d530c1edd27a5bc15c83f7e848d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eb52fdf0fb051bec657a20e52c4d0f55afa1037b71c11aefce81098ad6c64de3(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfDimensionEqual],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cdafd4285f4f7e4c693c83062c3aa2c4ec20ca7c2c2d109fab5ee22e182a5635(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8d74747a6fe21335d482e5dff2a13a21f53f6b4290a0eee973ecbb56210861fa(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfDimensionGreaterThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__edca4961b2573b8dbe32e242a968355360525ba0a13dc07baab00edd8a383312(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2bc15faa99b21ccee09940791a648ea77585d1084e42473a2d3fe74fbdf14abc(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfDimensionLessThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__585afcc290660e0b8c04df834440c58cde8a8aacbde2dcf136322e3497eb5249(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a06196616a833ce52b567b83a6dcbadbdf5cb1b917da39421731ebc1dddeb514(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c9eb92024daa9231205f15e493f2a15264ffc38d9dedcdb3e564c7770ddde75c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f640cae4fad5f2153048ee09d286c6129960fd688207716cf9d66a27d098c666(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a5390cbe33c833a5893c63931f374851ad44021be448eb231697d811045deeb(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__34d3d567218065cb98870d423fc54d5d47f1d97e1531fad0ba0a183de90dd22c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfDimension]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5bf4c031517b137ad6cc0dbef117a4e393d80cf558eed972b67597c0c7dd8e55(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a3bf4032b56da982de1813c283a73887f6b371621117ed59f42388d31d7d96b6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1d0dcf7715bc8f48f98048ebbc0f3c0289e9fb4a3d45dcef1985aeff9250ffac(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__50540040af472c54ee8a6f5346d5ddc435e988f1f70813ff1feaf5a448f3ab57(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6682eab02106f66274caedfe5cf3c0e4e5c32298503265b1bb6f6b083c093a3e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9f03e1064e11740e5586e53e54cb4a2902008e7fc5f5f7faa051d690de6d8a98(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfDimension]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__90f27e26a8969fe915c1b448c76f5d8c5d0ec7bc09c9724b920e35e900bfe360(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfOrientationDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    landscape: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfOrientationLandscape, typing.Dict[builtins.str, typing.Any]]] = None,
    portrait: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfOrientationPortrait, typing.Dict[builtins.str, typing.Any]]] = None,
    square: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfOrientationSquare, typing.Dict[builtins.str, typing.Any]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e043688d6a401143c75ee19ec92f78727da70ce0e2f513f8c3c3482ed2b76bd2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3dbf5516362cbd643c565fff90d2d946413100dbe4eb87c833938c26b88a82b0(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfOrientationDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__62fda9052d2b57fecce93fa3e9d5a0d7def805a3689cda1839207d7a5fe9d88f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4213b456436f237f8b1af31a479250db617cd6cccbf6ceec7b12f99a0b0be4a9(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfOrientationLandscape],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c459b81197ea85e53ef73e7c5b00dd39145066661206ad3611431d02f29b13dd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c9fd9637efcc03b9271ea7e93de5cc0a5f292a86dfdaf1303e7e12195c055276(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__76a90d748c2e6206a3798a37af159524c07c283420cc40fb7b689c9bb9fba9e2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8ed7ea88d57d3935a05f8512716f563c7870a6c619fca681c40fdeb435d3fc27(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cfcb16dc70ff97370a913e7e5e001f5e79902386bb72cef77d7e11b7951d5253(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ca8dc4ae3e46a7c7e6e506b469db854cde987442c6c36c64860dfa08b7f537d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfOrientation]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c8f0f3664e6e9e9bc4986eefb9339f6fa3df47204d710bc0675b319e389b3c84(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a4cf388a5dd7a176a6104affc9098480a46d3124d8b8539666e24bf2b5dffad6(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfOrientation]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f0dbbf49f24a749d88c9bc4755b560259cecdecc9c00b55fbcc1d960052fa899(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6763b10891a28badd240489b1d2d54b00d505982524da1ac4ab186ca917681a9(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfOrientationPortrait],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0fd579d0bbc788bd7c891d371d5d8a8ab2ee8dbf5a1e7682a89fd21361055375(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fb5c9878a3d909274dd72aa85185c354f7420714dc1b672d4d34d990622eb10f(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfOrientationSquare],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ff91949a1f93374d30bbd363ad604aa0f3eb22ffa8ba6387988e9a07e07d59a6(
    *,
    colors: typing.Optional[builtins.str] = None,
    colors_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__04d4f35767f48642227adb8a01e95b6319851e763ffa2155255e160fc0af144c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d32a1d427bcc8d29588d98cf9f829dd051a8afe777b61d673d44455ab39d5a35(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__193e61d28c6f0261abafcec0457eaab05eb0a3b0d7a1255789392af78d064a0b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__51cca25d91cd9b08bf80df2a79d48a0a07f90d816ed4319a6c37b3baf2d34144(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6287cf9bc8af5cd8a9bb852449d4489fba7d31f7850c4d716da94f5200b76455(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__29ed1299584ebd94125cf01b3d2a79fd3ca49a9e6e2ba2fa2627a6a941473de5(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanMaxColors]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3d367ca01e6d9966677355fdcbe7c6300579e84af5d7814a71255f1e75f0a140(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a1ea4ea96fdf6b75c982243e2aafb3a705110fee2b4048f0cea6eec1573346e6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fe282b29f3eef6c508e9d91fe5bb7c7fe87147360e6ed74ddb1c4125cda2f63d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f406ffdd18d0e117eb3001242040bd02b1e033c22611d959699f7484fd2e5e14(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanMaxColors]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__82404bebb7b30eb073c26c07f90f7f35516629d85c8039015e016f88357e4acb(
    *,
    horizontal: typing.Optional[builtins.str] = None,
    horizontal_var: typing.Optional[builtins.str] = None,
    vertical: typing.Optional[builtins.str] = None,
    vertical_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0502f04a9328e9253068facf51ba8c8a6eed6c631cd786e3cea2f2e339cd719c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9516b4b830fed745dbf722f573b70f6826d03fdd9ee250e8a53b16a489f81ffb(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0211bb73ea0c280d16de7fb0d29072c2b9bf9be2d6b4906effc514494c8dd9c1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__413f980f7c41beab54294c70fbf592a65b34f9bdb7d7c1af3dbdee0838b2b111(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__504b011d77efa4f336ff176225a98d113e87b5368dfc74b048ca4aa5ec5dd55e(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aa92763b6b838821fa526c6fd8d2942e874679674d2b5268e8b62e9d0e5d0a58(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanMirror]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d658f91e6830005d0c8cb9b121b04a8331318a78e58fb6b5f20fb35fde5f938a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e061270f8a46d552417788c7f9b20f736be0a43cb0ee72ccbb5d64e76c1e9a7a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__52acf0d044830fcf091ff58178a4caf73941236283f44329660948bdd3a60ce2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7c1d8bce35023b37a4799a6e7483e98fff53b51ed1171369dee146a3916d0d47(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1bf3abbc24988acd433be9c9ebe55cd83ea7e1ba99317d4e45212b418c937c2f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__789f19bde56d148f926fb1509924050aae5d3416d0af6bbdb527b5390cbc9634(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanMirror]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b7e0a8aa181a8f06c6a12ac39492e425f2ddfe020f2d1f76f3517ba167f7331a(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__497010f67b2bfa086a87f5498c35eb3f6b873969c8ace5a9ba62494817d8a572(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__956c6e81b73806b705f17d804eb3980566d4478b99ac8297a22cc202cc623d1b(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0fc7209aca4f5455e74c7970fe0e97635132c5b760f36f398d5b8afda3e4291c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1065f23589c377c50e897eedf86f411b18fa9c9445bf22ba93c7d547205e08ca(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__90a6a8f2d19869226887edcd4ce22bde74f2e9d4f193ddbdb8db06e35dbc50ab(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ab2378430c4b71c0859582ed0827d95d9ca516ef3a8c3123b69690c08894213(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanMonoHue]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1caeb25b4d736dc6290c82a15f61e804c7721de8a4be031c5ab018cb589cd7fa(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d71f45d122c1d308989af7dfa20582280997152e435595cc18207a529bc5338c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c103f6ac64dc4217fa3b75f774d336564083d42774616f4c175ecd21a05829b1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__97e0599be5d5c94b08447d898177ab752a20669dbb2ad95758b85debce33b477(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanMonoHue]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ebf4a00bca4223363af1037ecdd108ba115ff09bc4f48ec803a41b735f264f38(
    *,
    opacity: typing.Optional[builtins.str] = None,
    opacity_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8e1de15ffe751083dd3afd1f70650d5a00258a1c8114d19ab20073de51dcafdd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8d4a5e94105bfb02ea4de6f0f2cda990a44a8657a152325264ad8743c8b5468b(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__055f2e928399347c61b082f1b59329d5dec739a740b61bba17f0e0662073692d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ca68aa9165c6939f46874e9a00a9f74224c609487d5dcf4cc6899cc1c51bc8f4(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a7fb4d2aaa3191e6fb72cdcc1314877feadbfa073a06ab98545376fa9f925d8(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__470c113abe2ebccb32ab25839d25fcdcdd65fd63e07e7e7e6c99654c6e0487d2(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanOpacity]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__424491a06280186befb7619b09a054474bbd0d718638dc1c7af0b6415ece958f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f8f006a4b68c60adc5a0cd65e26401045d423d31c190e32afed7ae1c8e6c62a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3d01b97f4e8e22d894b60f47f3777dcda2e1ee86670a9d37ca020a9f6c730e69(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f7a4513f373c879376d675b2e6ba27a651b352bc0f0f0c2c7e9e23e957219d2e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanOpacity]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0986610d9b1fa7ca6d8590798e7b2e4b144cb352edc382fd68271430d027d9c0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7f78776aad4a2c4e0660a64bb66149bac9a9c6232311629582290d68ce389f0c(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dd2566a1ba45ba9813d5429d3f2148fc208677c3550ad2e9b212dd7aa3468af5(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanBlur, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6c6b550eb63acd512eaca713ef4a7eda6980a13eff3bc662633806e442efd8fd(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanChromaKey, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac2368ceb09be717d8fb24e04610d7969f28110f1f16f0e890b4f4c485244ece(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanComposite, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__07531ae5c25e1d12ac6c68b9e41d1d33bd92966966ef6c19e86e934e18c01898(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanCompound, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__60c0b448f0c67376134fb03bdf1182e3ce38cac3bbb26882b35a238623a71e9e(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanContrast, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__748573d22c7c8e6e6b9c336885bc461ee5aafbd3d7e222591849ae698d3a0033(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanGoop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e26850cc50283710eacc0b56126fe3db4c2e17c296e9cb005760e4f5e6a1a1f9(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanGrayscale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d9fb1d7653d74d7bf9cc02338b3e2c6335210730e50d0186565a1b72c06e4bed(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanHsl, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e9416bcbfce0f8c6c5a36bafc0b40ede7f3fa1a4feebdb6b3c434d7f09d676d0(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanHsv, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6fad595cc057ffae96acae6349d262b05cb897e4792ca5cac882bdbb2aa914cf(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfDimension, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8061770a2041768d2653d0bbdd6ccc692b9014f7905f96a54f15e33d8dfc3444(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b5b616c494dd14335606eed7b5371b7571c3938033ad8b347e434c3b34a2711e(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanMaxColors, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__040d36869259d03cb6a11aa3d7433d55786ad4daa62339a3a8c575ce3039c63f(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanMirror, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cb86f33511c718a30abf98e160b07034919850d7ce2be405803592a84ba85fcf(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanMonoHue, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__593ac8ec71c054640d96b00f6d1558f76eb54f19e93cbe82d5733b9e4a80db90(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanOpacity, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__67db673fc29778d89be44d132ddeb468c1286ac3ec48148eb3129d9f809481ee(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanRemoveColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__88a4a99756fb9fe8db12b8ad96359d7cd41b88a96b9d18a92a771533db71d994(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanUnsharpMask, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7c787bdcc93dbeb4d62144de327aabbb5061c4c7a2f360fc5881e6902b75895f(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e2c571b64e1ed554ee2e786042a434581da344f5458c7ec4fef569598ff7f593(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
    feather: typing.Optional[builtins.str] = None,
    feather_var: typing.Optional[builtins.str] = None,
    tolerance: typing.Optional[builtins.str] = None,
    tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ce24abaaea4c54644c22bedba3ace85b2f34b0561fcce8a314a300683b8cb364(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__efafe05f7f850ec22f343280a79ff370240054c185345654e0116b374b216d99(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7e3a1d83695153c6f03cf40052d95b4911d578b5deb8fb4e7817ac8e5918ecf9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d150986990bd9eb9e241bd542873d6a9a4cd5c96f552c764962fcfdd42f5b825(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3435c3b03a5199f0759ec44e9cd458b0107b283a4cba3963c3709cfa7fb4269a(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__361866000b4eb54c733b52232c6b2b5fef2a6759499109ea2fdd9888a8658180(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanRemoveColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b5bdaa8ee61019dd2f29de61ce18e083d3961994a68b0eac85a8e77ab0bd591c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d2d6ada7335c3d9a94b166c5fe61ee1322bb48228504d7564f24186b47ef3395(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a6a027fc8a53ff68ad7290ed9526ac53504da7dc94bf7f9b36815a190d2c5e9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__38f1ce7b4f875ad9cdc92a8451544a6921bc49f7b948ed6cd3f1a0caed36f4bc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f31f438314a1dd6898e5ed1095f7137b6eeb7323e731790a0854b7a3f8a77fa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__33e849f963b9f9dec96e26257d6e451f1b92da821a10ec10471a7d70c1d6cbbe(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e96450bca097d49a147521e7a65de0eca7602a1ddf6954f2867ab2316d4ed31c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__15e7b9f9f51859c5cb0982d4a57cc8dd87481f75c1e704aa90409b96a3377b52(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanRemoveColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__99e9cd14664840d3b3d0255c0a5e026a37cb0633e237a0823b7e6509dff5aedf(
    *,
    gain: typing.Optional[builtins.str] = None,
    gain_var: typing.Optional[builtins.str] = None,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
    threshold: typing.Optional[builtins.str] = None,
    threshold_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bf5f31af99f7cbaf978f8ab71e9d952e1665df2318f84a360cfa74e637db4a76(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fea578ab39e9ccde00607c0b7c2ff6cc624fbb92fbf363a4004be2b54abd967a(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a3c9b4561211ade6f9d848b1a7f5bbc2439456d507ba44d2da94f3698a8df9b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5d820f6a1d5951beb93ba4df837df34930ffa797a2167c0775495a9d98d95921(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__241e88cf58b17cb9da131f6c8e656ab8ff08bcb33bb6bc75cf48567330238593(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d90aa1661575c8fb3061f55cb79e3b85ef0e7631551828799389b9626b79f943(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanUnsharpMask]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__479e8fdb1899fc714a39cb083e4cb68842679032095ad5cf6b40c166d77cca35(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__afa3fb5279dc58d268544b0b32fd2685ef3d876620e7cfa921bba7b51db6474e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__61b375b53d12a83fa1f434c11efc9fbe9385aa4929f0d05213a86365d32639f4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ad8b627e66e27f88d3e0cbd89692da87ef3253ed4f9409246c3586ab708ca103(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a6319ba26a0122833baa311245eac0c4ec9b91fe976a02b217ccbbabb239250(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__124e9c36696315993145e799a13463d9bf0f7622e8941d9dcfef48502b442ee2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__feab78b0d985a07769c21be8356518c18fce295c2b5ea444008dd7da8f59d2fe(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5b3270a9d38690d2b6f37b4925143d1c4525f460cebcecc15c38ba364969dfad(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionGreaterThanUnsharpMask]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__147d658f6a6aa120e8a9bd7706409108c0fffd41383c3b7353147f5bc40e12b0(
    *,
    background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
    chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
    composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
    compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
    contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
    goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
    max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
    opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
    remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__44c448fcef6587b433dc1b675a37ff1a9075e0d83a74b403f0b8cb250dc9b6cd(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b45409b4d4877ff8947ad66ee052ec7d9300c080ca85b451aeae8572a8153f82(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__702736b00724501a89c6d562b01c06d7f9c33dc3d2fddb0e374cf826943626a0(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c5ce059fd618d3d117cff924562a9c0212ba00961473a688446fac385fa2ecbc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__17db5a07be999329e78179da1ef75a7b5c8482258026034586dd4baa3a3c058a(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__12f450f33c68610fb8a3b1a4207996b26092e7e0898262c7b0d7b1240dd79399(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e673e1b29f6d01ed88d581d9d0e7646878d12abdc5f47d488395220fcf6ce8e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanBackgroundColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f2e6dc2a8e1b5b5da80054cdd12c9590df105cf5e42cf581b8d256a6d539cf12(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6915731cbf40aea5e179b0192e31339266ccebadc5738878c76790a3ed028ca1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fb12ee149a4bd124362d8d91799ba6b4d9d00ebcaf42f2234e325f0e7747925c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a66de82537a1af9cffe8b36ad13994fe861b975c34fecd664dd0cdbb43eeb7f6(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanBackgroundColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fefc1dcb4ebfc18fe75a819cfa8a3f7bbd1f0314570f51051a5fcce6bf18edb1(
    *,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e88ba89557adc3805b713d6ca745c4a006b8fe9cb781f5a51e7d61fa97918591(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__08af2de661b0901b87de3193ad8ad50af38654a08d3d77831f386d35e475003b(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fe962e2abc7f6445572bb424bacf3405135a5fb290d0367bd9e4391cce12ecf7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__79c4a39738a174412894daf8cc37ba92ccfd29d69142e299a5c3bd5fac446e80(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5e25639b45e9c90036cac5f43df3b231fee8860ab8a283bb4031147c259ba0c6(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__849891222350537e5705c767f197476947850ff63418d39ebc6a5989f53434ef(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanBlur]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1ef6368c14b46c3d81b91b6d4d5510b3c9a33d86c25e97ecea32ac5cc3cb9f4d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4d564b53e3ff7eaf8d57cdf7ddc667d55dc377b44506791baf33a73439168dc9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aa167f138f725e646c80f6d34a377c22d7a385b02d93587aad45df4bcecf37f9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1221049c9b3a710e4c2b47cc834e4726292b674ed81c18ff88e0a3b2c2112ae3(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanBlur]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__71a8e5d6a7c4da79e62e3ed877cec2c1688ae08fcdf03cca781394453beef959(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_feather: typing.Optional[builtins.str] = None,
    hue_feather_var: typing.Optional[builtins.str] = None,
    hue_tolerance: typing.Optional[builtins.str] = None,
    hue_tolerance_var: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness_feather: typing.Optional[builtins.str] = None,
    lightness_feather_var: typing.Optional[builtins.str] = None,
    lightness_tolerance: typing.Optional[builtins.str] = None,
    lightness_tolerance_var: typing.Optional[builtins.str] = None,
    saturation_feather: typing.Optional[builtins.str] = None,
    saturation_feather_var: typing.Optional[builtins.str] = None,
    saturation_tolerance: typing.Optional[builtins.str] = None,
    saturation_tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a875d46e6862d84489f6d8b34e584e002c0f432afeedcaaee710430bf9688f0d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__491841a56c1dd9a0bb1d2d1cbe8f727fe3948c26b16c427097be570c73cab10d(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__34c392d01a7695ab22b524a3342f3809d33b6e892cf59c8b161a5515bebb3358(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fd85be6c8bd5ec666269c2ac0d71bfb0b4f2cde0bc93d28eddec29f8d76c768d(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__826a8586e0f16e0a93bacb2aee0c32a0a1aa6476f72550e7ea811e6bbf029d18(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__17e127205bcb9407d945d9e192ca955f6bddd040a3875acb0e01862c0e670c07(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanChromaKey]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bee3e2b959b6758e35c8038010a712a6911aef3c1fa5e674cef27900636f77a1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f93ad3543ff930829ae24b4d49d2bc5fadbc6b34d98e1099d7dbd3f631d30b89(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7e363040d7d403aa307d4e388c5642213ffa995f284d85e304179baf2ef98c78(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__52740c0e1ec6377f717c6e22014c94ff1499fd2ebf40779fa4e0f052636cd18f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd88e64b1f762240832c07bd06b05378db8813f95122d854e650c0e1a5c12c9e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__40ef8091dc7fab59df346b7b24d5c2813cff2b98df84ec2e7ebeea9a0fbd7522(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d413bdcfc22d2d122bb244f63e260db51dedd7c04f2ff60ebe9a48e67b40a6a1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__065382178b974a640196bf30021f072398cd9b69e1bbf54c1ad4811a163ca14a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__17bd4b072e2a6ecff73152b1f1ab9f774dfde1753c8647f8ca89e5120fb2618b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9291b53102571139cc2a410d674bb1541e64d68c23cf70a5337764bc728a7ce3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d7efbef42def4299861632d3adf98b860ba0c123037b44bcf8bbe6d764de7051(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__344fd65208c912182f4f61a5aa94a4a802851ab0ebe5c5bcbd314fd3813d5122(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__77a07584ff847e61fd801aae960fea409481f3b35a37184c92a5862be2bfd79e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fb331e2dfb18b410a3a651c27ebb65611e6458d9bf2060f9d4aea56a61f41b72(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ca4f93d0376982888418abc16e879648dbd04389b63131d3e38d4133e0c750aa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f2a596af7cfb4d9117076b7d6d2ffdc2e5a25f0c9d65ef398faa1cbda113541f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanChromaKey]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d8acb3ee6c3b8a61ee592947dfe3f0515183034efc167013216293c6ab557f5b(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanCompositeImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    placement: typing.Optional[builtins.str] = None,
    placement_var: typing.Optional[builtins.str] = None,
    scale: typing.Optional[builtins.str] = None,
    scale_dimension: typing.Optional[builtins.str] = None,
    scale_dimension_var: typing.Optional[builtins.str] = None,
    scale_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f6798c1705688584f836f2c7562bc32c314bae5705e8b2fd45bb75dafe194b83(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__98632303a582fef39e35d8e3fedb98f0d13fdac9db21442432e6f8d3f9869aa0(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanCompositeImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__460da31349372b8e766dc1000ce8003c5013ba2a629fdfb1c9e260c2dd9671f6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e33faa9f6b6ae9f050fa9657939b7f86cbc9e130b2e85b8a3b0bb59cc7d47456(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e7ebe64df03818a36001ec9cc16782d6821ff374b75a2b3bd8b5a53a3e1a7bd6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3bb897dbf96843f2606a2d790b6794d08a6cc796d279a7df09bb4f22fac80488(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__068038ed72e6fc25261ee5ae92dd7b3dd93c89b4538b1b3fbf358f5528203a38(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab3da94750d37d30e25af4f8dcf7dfd7f73db386a6c5dcda8386f4093791fec5(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanComposite]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a26fc50b73be860e301bfd2a76ff74f139cb8d5aeacb4691f29079afd539c87(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f6f12618bd9eae779e44318e0fcee8cd370cff060835ce5507e530e5f4b8bc7e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1d99757c1c559415e9313718c0e6a65514e9a1b3f41e64d6609fd503a9c1f058(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0976da0c741518e6003323becc9240e9fee4ba2e923dc89220f3965fa8820f50(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__85a06507dc6071d0b2a8bb4bae279d1bd9f9307f4741b5b3d0c3529865bc2a09(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__87f8598206adabd27f6e6269cd1f9bc5d7cfbfed9e1a6a776397a720448b2b33(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__602b233d0f522720c1410717cc7d5659617bb3b01c3322cb03cc0e24cf567133(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__edd417922b2e0eb3a0f29efe74ccdad621b80be39d74a307dd394074d5b4d632(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__10ba891924f8de64d3d64a56d012387600d7e4472bb1f0d07ec16ab42075512c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__18df454944cf121bc86a26740cf08e0afa66e85b10ffe78496ec98086d9931ec(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8f8c752b5d7f0ea8bca955ceb94c7c1001b7b0af2c35d520720dd807c4f98625(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2e4c9b527273ebcf04bf6157b9f5e4395785dd5bc48db67eae1353a1d44b27e1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a4e7f8d6b9466dcf6d206aa58fd6ad5f7de837eb83bc2b2807f097ec3c695bd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7027f67b1e934019f3e28fd3ab6e98713bf29489c9193bbbeecbc6816a61dda3(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanComposite]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dd63bb968a999480f925a85c9a2610462162ba312b573b5b686e4ae8a6c6e2fd(
    *,
    transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f979005b21cb797886a70be1175d8eb15900553da8f0f02da187cd6fe23e77bd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f2eee1b46db593fd8a868473d72d049acf0c7554dc2f22fd261588bb2bda26a(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__414acee4e28d435615c7b2148888bbf7d11f2e26ce0fe2704d64bd2dffc99788(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aab3104b914723b989f09032e21c7b568b075d57ab38df57838f0fb13e3457e4(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0188b967eb1f66b8c4fe313408942d2ad02270e810fd5cf5d505d4b8cb01d3c3(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__61228e233e81416c38ecc87e7616122d2430c5eccad6a634bd2dbcaba070c289(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanCompound]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d095c6d358d2fe8031edad9c1df478c01c2bf43e0bfaecf2798dde949ae237a7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__15dec3c333f9da0e436f632d88799d17efbdc29c42b34dbdedaece266b0dc691(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a974581ed3cf2413bb7a70c6ab4b9f08afd1b1d5f5557cbbe91a7c48bcf08ae3(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanCompound]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__71c92870ebbc9841e7f6484259f340be8b01d7484d10cd4797c34b8139126190(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d74a0e78ea1331944a0cecc5e8a20e1a6f56f525f45ae256a270cc5a6c9a9c4c(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ec44f227a87d1575a83112bd633a8a7ae23608efad0b2179bb61298862a5e1a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d1ad71507e0f279b1b367e4373430a6c92b94519149b873adeea590b71e84d1(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__21c627b6e96b7c062fe389835d64a372fe8ed490a8b9b18124a9eeca64be8c9c(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4cc28634bdcf9a7c60264f93340a0d0b2fd841f61129e74a8c7982b8010cbb85(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanCompoundTransformations]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f57e12e5f7d5b600a015f0e554308a9a98c7de893f673011729f2f97a7886607(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__198a506247fe3c4d108400058c8b61838c1555c77fdc33b96b7e112cb6da1049(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanCompoundTransformations]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__376f504600bb76f41653d3a038a77f11875c8b8c941aa20e0a1c45737db211c6(
    *,
    brightness: typing.Optional[builtins.str] = None,
    brightness_var: typing.Optional[builtins.str] = None,
    contrast: typing.Optional[builtins.str] = None,
    contrast_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1c33c742beeef63073a4abcdb2f7f28c6d53d6bd1e8a2cf8cb7839f5eb9687c1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__81ffa328d2ed6967852e6ec84db9df5e316d8f0f7389503af2dd8e0a4056ed86(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__105d2b3038c4006fa2637f48246f3cb54bf239730586228606f3c461b01b88c8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e23e0fed4fde9dc1b95b1e3bd8903f023035b7d7a26573eb53ba85b4623bc90c(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1e2cbe506418ad4f2cddc0f2d8b0cc29d11ece49efd95b81c78aac488a15cbc3(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f07ed1ed73c1bf3c24a7064d5365f0f6355fe95256182f967e5dcca53bf81689(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanContrast]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__98cb0b06dceffd7b6472df32e180d6ed43d1375d2eb16388d08f9807b35e6f0e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__31eebc19a38880c9a064754f37219d345021a94ff4456903ee84558c876c9150(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__deebc98fefc85a96f65268aedf2c479e7262cb537d12a3045236e8e37f96ccc6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__99b23010f25a8c93a554aa8f67ad707b4b16bb61f0f2e6a6aa845c4e949419a0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__89a8a9553c49b7bd1c7174fd603acf5a817e209943e41495121941532fd66cda(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4cf413af77cc50c1ebbe39fe29b4b5817f209ca5e1eccedf5e3db1c4fbe68f8e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanContrast]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2dd1c70287c84fe798ae909f4306cd4aaa4ad2a77d4a0f9a8979b281ff0b2ca1(
    *,
    chaos: typing.Optional[builtins.str] = None,
    chaos_var: typing.Optional[builtins.str] = None,
    density: typing.Optional[builtins.str] = None,
    density_var: typing.Optional[builtins.str] = None,
    power: typing.Optional[builtins.str] = None,
    power_var: typing.Optional[builtins.str] = None,
    seed: typing.Optional[builtins.str] = None,
    seed_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8e175072b46d7c39d3a74e2c0449320eb22e527e876b5c9498d78ff7513558b5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dca39dc7830b97eafaef8ef13d84a1c4ed494cbabb96d99492b8e882f37033fc(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e4edcf52ef9f238e7d3c8e759fb76b0fde67453eb5d45d69b1a3d10e0f8a3763(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__85a641968eee1762ed142651e5c93494ef3f7f87731887cc2305c1efe55d1dbd(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ce8f634500b67a423a0b476bfce08014a1b2fd24e105ca315e1771062ec5c8df(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4fcb4334b5a5274e360cc568fac52f2f66078fd170c24af65afa4900bd1dfb14(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanGoop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6dc53be30a15b3930ebceda8dc42d14e64f35d133f45c82c3804fd77754d4681(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bab3e77f278f0617626187a6775966e142366061774fab528e9b9f6c8e51f5d0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb2c3434432f2a277d7ad53daf2dd48d07517c20ab33172d6f8ae21998cf2bff(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__17aa48cb5b7bbc3f4e8312fe4f8ec25947a8479dbe28c67eca3d31417fa3469e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e346a8d3116e012f0cb7de4b01ddf4829e8e9354f28d3b0b60626c6f1d222beb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__39ffc3157c3f7fb1201364692906f64feab8710494357fcbd4ecace8612dd6e4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3f0c7dc86620dfc435349c5ae06a0f781c7b8b6958c3dd32fb7425159e3d6210(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a619d25216f88e89cb3d3196cadfc0fd297ac0eba26559788140e3a31246bdc7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__74f8613aa22c83d24520dda3d4729bf66a3b6d41b18f3cfbd6f25f008ddc0ee3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__71c0e3f7d3cf994ac6c5d86599bbb1b2d177e2f2b0c85a0385db7751cd74b94b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanGoop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ccdd246f5ec8a19eb9c43e4d0412a36c6bd9b5263b94af8e6b9744f3356e67e1(
    *,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ae9aa2d5a8b2a6121d5e57e958d24315e6b36e78c46de59e842ff8be56d4d654(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aeac63093fc099fc0903a2bfcab4f43c421bfc991efb22fc9d3a50dd4d399667(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a9b644818a8896ac217e933d74374d091aa33cb56a5377786ee39b5ece55824a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__07b048b984f860896450241db5dcf9dada8dca8cdf1a2cf0cc1b577a05c7e493(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__48b561b83195f86b8dc36f61679db26ce80cb934be62f53a2a368eed70c56d07(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cf91c0dd3417cdd105481e5d06ec359105c5805a5b0e4a94981aa86866bcf4bd(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanGrayscale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0d360b7410287e2527af591bf88147312ade4be21357d8d31fbea75efec3d1ab(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8edb67981ab33887ff161f9f343a6b67271901a78594d72ef2142160de235e48(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9e79d179025fc59c78374b4f13c77004046ca0e36e7fc3981d979208c171dac1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__162ea4533d7ccb89d448f6038861b5799c02c55ce8109cbb4bdcfa15ac29b4a6(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanGrayscale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b3945004c2076343cc965d48e92020f12660369f71d33856a333fb93eb288cf0(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness: typing.Optional[builtins.str] = None,
    lightness_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e33b00f9b77e42fa623fb406d4631d5357ed6060942cf4beac7e42e8dac14145(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a5cb4a1aaac80778180deebc7dd52b851eb12bbf6393969ff44b703ad8fd2a29(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7e21292fe155f572dfc1e27e3246ca3598098b02a56b22342107b3f46aff51ef(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__73caa724b46d9e9eb5ce655aba76fee78f89e8109ddb78bd70da697e9586966f(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__15f6e8028bc4ef8473fb9c226ca22f0d9d91921e4f71c15c0e0b7ca9fe9b788a(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4bc6030f58ad178b7ef1a87ded85dcc8d232da8f8770c806d0f46f764d848a61(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanHsl]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a3cd13f48f9ad629e5eded12b4a306eaacd00bf1b9c4b6721bada903747fbb13(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__26e23ed4687569f6369c908440a4f0163b8e7fe30d702f4b8d85d14801885cd6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5574bfcd24d66980313551956b0a439f1977957d03f485de43ca5363a334e7bc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3d88357ed7710e1f1cbd4db8c0844705da29a18c5e78f1f4ca436ca243cb4240(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5465bb97d95befe48aa7167dbb8ab5417ee301332069b847826fdb385629c467(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fce72852a305799d53a7441cafb29292646d7b284b35239bc2406073d2271093(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__228dd388bdf8a7d45a580370cf2c4434d1433d6f76a6abbbdb39371ede9ebdd4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ae48fd5bfbf0467439f0ffec2731a2e13188a0f3fea3d45f09e464f58034924c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanHsl]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7c8960f821555253853cc363aedc71cedd14b99e85717263718451fa15e621df(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d0f6e295c00aa9fe56811175cb703fdd09da47dcae976387b34317473c2f2c7e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6b172e180aae829a736f76af19f30bf17bc40f91d09cd969be466ba0645c84e3(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6c7f1f835ad8af23876c8c2d7cf0dacdba9ce54104574ae5a2429d7645267470(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a50da2d5e398e1b68539459ff79b72af6c54b0178b9818d87897294dd8243587(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ba43ae77d16f110bb97a7a5598dbd2e7ccf800e731d28055ea5d29fc6a00ed1b(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f6ff2b5cf75461506a7b8c3a11561240743954d71070e56e195450e846e85f4(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanHsv]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__64728fd8675c290eb2cc624e5b5d6795f21a5c04bf8ff6a73b61400f786e7aad(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4aa27f5fed662a642439a087f5a79fa74d8a8d6ec110bde3203c08c19922759d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f405b318ec95d9d616b0491c53e93c8c9d9e3bb252fb424a2f893db47fb5914a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1ab753dbe80c9be476ac33c67cc45cd62c272e4436f59427e09195f30cc05668(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a0e51fd92b3250f11622f7cacdc43ee33513780ce1ccaa1a8ec2a645426eb740(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ae0c1ba8fe7bac896199df978d78e245f249e6d4ed649cfb8439912b6315b0f9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0d255b8efa54c23c48b136c1e4d666d31ae3a3d827c923d41337f3679cca9c76(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6d124719e71a839eca47330cac4305bdbea5a4989c290d956e1210a3c8122e78(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanHsv]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ed0fdeaf3622c6a5935bef6e88bd2e7fadeee1f617b36c8e3fb87a068daa4e4a(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfDimensionDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    dimension: typing.Optional[builtins.str] = None,
    dimension_var: typing.Optional[builtins.str] = None,
    equal: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfDimensionEqual, typing.Dict[builtins.str, typing.Any]]] = None,
    greater_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfDimensionGreaterThan, typing.Dict[builtins.str, typing.Any]]] = None,
    less_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfDimensionLessThan, typing.Dict[builtins.str, typing.Any]]] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__728d1eb9c22a49a9a9282df7e0b7c1b241c3a61915802a8c5a7d50ee67411a20(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6a6ddbf9c3e64c8d5b2ba32957fbc21a1486f6b01cc1e9fefe57fc49b5be98f8(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfDimensionDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e1ee6993b7282bd2e367aaaa780169360199fc31fe0558f27e7f00544f77277e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b6dfc1a2a7341e66e37ab417deffeba41ec75eb596631e452ae02df13b0d03f6(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfDimensionEqual],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d90747323378d7ed9904e0212bf8e6651df03001d68573a1be1204f208b1c081(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ded1c57a9f6f3a0991eac331c8488ab6943f30ccc56ed9b5c5b8c8982c84eb21(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfDimensionGreaterThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5e767bbf010a1fd45bb775fb6b3937eeae28b5890a09c15afb776a9218a9f2e8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0774779189147eb613d378c5ab2a66a1aafe275048f2fbaa0b3288029176efc5(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfDimensionLessThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1a049e7c13d790f409e91746fd965140a5b8249f02e5b39b15352c47bc4bc816(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f085042eeaf38eb4626cc91c4f29bbf458e2612be3199fc367b3652758c5393(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1acf8059c6c0cd94c8c521053cf4a247088747a7fdd9030ad3312b1065a5248d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c34cf21a12fcf34245c0df4ab76795b6eeb07c838502cb257866d4aaa485ec65(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__288ce0c90af91b6ae4c4ac1db86f3dc64edf3d8bed70b167e0a26ef19e6fa4fa(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__76f48459cc8ecb63962c9ef6e5ec1790408bd2cf70430dfd92fad7f57c595d93(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfDimension]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__96678c3443b62386f4cf62f72df81c7c13ad03a33bc6112ae2735ad6c8ef09b9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__85e78d70479901e38e5aa1e006eb3b86cc2c861a98c6b36862ddb158a62c0baa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__34d76e62e6a61a242f3a015e0ad328d5e54bb1db7d1b0e56100cd4979a0e7352(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2b346de7aa97698b6d87a96637bf45c19049c1072c1dfdac92acef635aeb0bba(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2261d2f50429eea1c2382cac9cadba9ab1ea55ca3a286f1ae159b362a6f60dfc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__25cc91d1f5248a21d9125aa84fdc26a4077144d92a804f7e342cd4504b5ef221(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfDimension]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e65df1c3f71f852f0fb2a452ded573279e172f6a789e3182c1ddef66e6b97e82(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfOrientationDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    landscape: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfOrientationLandscape, typing.Dict[builtins.str, typing.Any]]] = None,
    portrait: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfOrientationPortrait, typing.Dict[builtins.str, typing.Any]]] = None,
    square: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfOrientationSquare, typing.Dict[builtins.str, typing.Any]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d1ef295dd214702a9c8efd57bbee634e988e962af3368690a6244c1e4a17dcf(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1a57732c1aa5b3711b2905a934bd17e79ede3780292efcd8d5f614e68c281f61(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfOrientationDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a13d3f0c111ad6fb1f977e5d2fa94227efcf6227ab883eb41ee5d5e8c323cdb5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1d7f045c4c1fb1d389e6a34fa5993293e2cea0c20e3c4d86dedf8e350d07d876(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfOrientationLandscape],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d5f04118c3f310d6b4d92dd8c1034e69efc0d134864bf7db2614dbc94e457092(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b14e1495d91b96455d4f3ea2e7046d76604942e32d73550948d44477af01a8ba(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__66b36c4722aa2d4e16175759379984f3043459f42f69057eaabcf402b61a6425(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__782d286a4981097410a163ba59d738b429aed1f0084bb8bef2fde547fbba0081(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__95633a6485abaded7cea148cee08afd402307fcf907c720c4b4b3f70d4764c23(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a5f86339f9bc6dd32292475897c337016bfae8ed912f0a5a25035d847f981a66(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfOrientation]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__195a06e28f2878e1298771719f3aee853d68097fab02ee5407945bcd06bbb534(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9e714651de4ca327061229c8249210e662ab3ea3f70ac1e0c12f2eca4d458f93(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfOrientation]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f62e387f08e08fcdd79aa4caa8185aeb2e13662bb45818be845a78e238d2c487(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bd142c8e49da179ca21d7c56df86615bca7fb8df61207cec3d735c703256af4a(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfOrientationPortrait],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1389baea2235e76b31cdbd00d8e19f33fccd84ed92b63a955d467a6f3ef65c9c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8c28d7530bccce6ba06daeaf319c61ecd02eab4a25323a8e9a80876039a6981e(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfOrientationSquare],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9e18f8baffec2e0530cfbf25c379daf7da70d56e67101434eb5fce09f1f4e95f(
    *,
    colors: typing.Optional[builtins.str] = None,
    colors_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e41de7cb9fa1a1d318c1971d17f69bfb486df6a5d9a4e38f320d655723e778c0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f25a796607b9fdc01f39c66d53b7b458c8a65fcb8de71b69af03f84f75b45cf(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a9342767d1502c64c226263d43e027a8085a738dea15f1581507e74a8fda451(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__40461a52a8015c4c43e027b3a8392b920ac99cb25ab1c94a23342df7fcaf5dca(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__250c96aed5cc8d34636f0db9baf4a146c1c4e9d04f8a281f8ce6ad0ce631d5df(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7a21280b771b590e3d21e0933d6f3d5c3e8b5dae1b3aca8d34bc6920a3909a2b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanMaxColors]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ccfb091529eca96ff55010a35a40ffcc15d4483ef11f36ff8473fb99cf1161c4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a2fb378ee5420fc8b16f2b143966f59d62a9f7bf66ec081dc56460fc56e97ab(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__efa5357878105e86743ae613c2c0dbc8cc5962d40502cfa8ec110c19d023493f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__97265f5bd6fb6ba14b144cb0de346759c7f03daed2b45ba55b7996b60f399ed7(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanMaxColors]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1250fe0f521d2d6281aba6ce8112fcb59c62fda7a05695a88b8df675ffa3e682(
    *,
    horizontal: typing.Optional[builtins.str] = None,
    horizontal_var: typing.Optional[builtins.str] = None,
    vertical: typing.Optional[builtins.str] = None,
    vertical_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e38c09f52344063a8b067ea1046bf8e4918b56b67ea5bc9624b0c32685fbdb01(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__86b7e19e01305495e68c129022dcb8700e7bc234292b81b260847a1893372ecf(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__43aafb6f66963a6331dfe478c4e8d59851ca77d5121210656b874353d8add2a1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f6784a7cb1bf7b28c0c92ed2aca1e798bde0d0c4de089f070d501270176e419c(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7ef5d7de594957537c553c5d47187c07cf928a1bee02bff9b05a9e1164ef29e7(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__57f27a75ee0e967fc1fa2a81519efecd451335bf17936d5cfb016909999bc238(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanMirror]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__50aac53157cf287251646c199a22a52263e1dbc9174e1f573cb5ad256926d873(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__278fddd3a7783c77e842d4b67eeb1daf30abdaf7e967d39633d9be8373e6bd85(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bddf6cbb1f1dbd11fe4bdabd17acddfee6a264a20a8e610153f1ed136d7232cf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4af16bc7fa58a91d7e1b70f607db765c88a71df3a9935c0596bb8b114b07e83d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__56cc810abe60e214765fd670d1655e76b797cf948187858d2a527b629403c298(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__822b127922cab1d4f3ad0c2b2af919fff97d39f5a24a12169ad58046298ebdc3(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanMirror]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__64dc3e2627d7748667e9aec96a80cd24a5cc55536b0f0f1649e8a92f86985e6c(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__027d6fdf4ee8980826049b4ff9e97cfe73e70659cd56d700225d56400ffa63ba(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f077b1ff8508f0f1f745486063e71094745131a32f5bd9d8dbbba3d02b51d7ba(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f0fae1607cf6a68ca7c20a740dd8b5ee6a585d55db157a6c33fa5cbac93f3f47(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0802826c7bb2058e9fcf2d10a1ff66bb50134d8cf646a9c455cdc6811c733a77(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3f37c164f1b3468ae36d96b5885fe54ec3d5051fb5f4a471aed00f2af0ae3d32(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__66b03031b4a462bf0c279adb5b190f8de3d7ce2c7837eacd375be4a2de7b4434(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanMonoHue]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__34f681b4e342f24946505c2f61c228fe60cf0669c166add906223defc0f51a03(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__77b9ec359b6acf2b5cb5ab80297d3cb6dd9858a439c4ebf9420c4dab0def84b0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d28eb1f303a289610ff9db0c7d7fdc937d3c7954ebdeca16bf21c3c7be824f2a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b725dc9f5c4c1f5d1776c86c131f6e984e0b8eb471f09ee6e58aaf3c9cc0873d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanMonoHue]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__adeebcaa470a532bf9cceaef36796ee9d5e3f095286f6d2d1909fa4c58addbc1(
    *,
    opacity: typing.Optional[builtins.str] = None,
    opacity_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7ba94a663d75bddcdd676b9e355258c8e0e600f1d3901a392d34c1d0d32d0a7a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7ab7b2165802b17f3dcaad20d39760dd0828c818a396cb5f0665c8b7a21ebe4e(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d1bf0e0fedf79148cc3305d1295b6a1e6ad7bb470b58e0929220c5887026646(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cb07cb404c25a79414fdd3bde751ee51c7d85c9d83e262a52066b4c4bda6ffa5(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__27656449028ec74571a4e55f0cb14e6e1862cfbf14c1bf2f887cfcd388b23f57(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b6098163968f8932d1f7d3ad4433791e23abc1e82f54235eced3b68112792812(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanOpacity]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e2c68d00daa8ea55bf51714e99686b4d15a9709924305981e7a5d11a41a7ee73(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a5ff49e2dde4d61727bef48500e88067e1e4e3b5749c1fbc44397b389bd1a103(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__37b0e810e7c017f211949a403986baea10f31f040df9d91c6b2deb69833ece8a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d3a397181f4908bd0d305dfbbc51c1e5aa96de1c51e24645aaa058c5867881a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanOpacity]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a4a9cfd5563bebdfea86187fb8c43978a73faa23aa95d82421ce5e433ab8f152(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d919a6041de90d618708c08da0e70b2ee8b6a8bb2d15b32638bb08eba52c0b0d(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1a3d3786125eef39889b2dd3653f11c39fc56b536782c428f3a931f2d63347f3(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanBlur, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__316e27103600344a1036eaa490f3c458581b15230e1f0d80d9f6947aa1861dd2(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanChromaKey, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__77b6e874cfd935a4ea4e8cc6cd44fe59317eb93d395ddcc78a1563db13d2b78e(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanComposite, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8f6774eed65a83863f799e0723fcb57903c306465861e5ee78fb0c7199cf82e1(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanCompound, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a3455ea1d43baa9ff5f03d36aec003b70a0ca4b0c4be3125268cc4742c39be3(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanContrast, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__17cb93e0bd8ac76a1a8a1645609f009a14d097f31243b63c0f27b51469880e6f(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanGoop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c9ce0514cdf7035c15fbceaf731ecc4443366bf5508988b8097ae9e6d4a33d88(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanGrayscale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d670a1228506c7e0d1c9df47d953c638fdecaadf15afcda4af0648868387e2e1(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanHsl, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ab4e7896067c6c0459052a0c68c755a04c3869d1dd92d12606c70ec751a36b1(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanHsv, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b0d6aad4c101f803664d4ef0d7feee7d5b20028a14ad2efac46dd8da97c661ed(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfDimension, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1b0c44f90fb0a0cbc334e3ece48afc29419702c0967023c3110076cfac580e4e(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f6db2ae2d7aaf6815293b6acb51e816ccd1279ad55b132265d49e1f38b46e52f(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanMaxColors, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fccff4eaff1588808c987d71f7ac516707a906a199b47e5a0db16b3738e02bd7(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanMirror, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__07bc335594710387c28af69b8c7950252bf5414522120ba81008675795078ae7(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanMonoHue, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ad27c2ced80a844727f44236fae109daf594645c21594d919b01a8bc20351b7(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanOpacity, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9c2d4df76649130421f3860fbffec9d95b621db0b57d56a21e80bb79f41a508f(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanRemoveColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dcab4ce81925b3c98270c0026a641ad61d48de1e07a7c9b6b1d7600d157839e1(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanUnsharpMask, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2e6a17435e5315effbe170d269a1bebdde9c63a7a8f96d235b0ae4556f5b3651(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8c62c07d819c233ee50e8f736687daa5b94d6116b8a903dd6ee5597c207358b0(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
    feather: typing.Optional[builtins.str] = None,
    feather_var: typing.Optional[builtins.str] = None,
    tolerance: typing.Optional[builtins.str] = None,
    tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5d14f6048b095bde20ff660705fe407c7f3a1a0de5044cd8fccb7350252e6bfd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__644044dd3d93ceba8874463c167275cfda5eddda6114d630b4c1ef22b70e5ff2(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__65a6508d53b40e1912c7a7a2149bb86e463ed21725d9ae1b41792c5594151f56(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b3fb8cd64ddc04736a8a040a3a3eb2eaee9b68bca71595355d85ff3808c1148f(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bccc0f831362a51c1389e9b25c6679f2d27915646f8c1d281887523f2dbf652f(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8abca92266642fba8b8eea50f40fcee463b880dffe0da5afc9e4773a761608fb(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanRemoveColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fa735a5104be4bcecfd21e553fdca0a80007fae69d9393faab94d6c891d1c877(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__37c4ec00e44391f28529ac494878d884ef4b473fbc461f6d97980370d71045c3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b69cee3e62a211e35982a91793d4595fcc8b4f3c5fbc9843e2a9ba5ddb462054(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a3a98da7824e4af03f77b89d3d38155a4cdc1fb3b413c3da7ff4e950a65856dc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac5440cf7daa0b522e2a4fbfbfbb7d9fd07f7771d363c5e495d3989365a11590(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__facbcafb347e8ead0c39e7f67a06bf7bd4b8a64b42cecc048bbb5c322978ccda(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__969a5ec3b03262ab71d27fda39f795652760aaa9c5634ebc13bc92c705b6a04d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0f411719e7c9053615e7e92184ad3c625c410434594b1559b59027e025e1f758(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanRemoveColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4db6d3a700a3603262793c03be473010c494f3e0812cada2e90503009824bbb6(
    *,
    gain: typing.Optional[builtins.str] = None,
    gain_var: typing.Optional[builtins.str] = None,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
    threshold: typing.Optional[builtins.str] = None,
    threshold_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8c56e86202b9b264ef3d76b9aa2d5f824be3c4ac6278ea20a4138254c6eb1af1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__63b6835760e55edcf58ad385f5d79fab52fc983c77a102400414da6e1f3176b5(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3e6b57411000a23b5b6c222b0a44793655db7f7163db09dd9785a178dfd137cc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c16053644336067d2ccca66370245af1f5a09732d851a107245abc093ecbdefa(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d37c1b9da5d0cc7957f7ea76e2ab1817b964f29da4a3e2ab134f012f6d53e647(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__397bf29c47db46af64859d127d5fd2b07f23a87f71da9f547583d4b414c52a7f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanUnsharpMask]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__28b9edcf05b70e25577f7e6d26deba9f7f201a90d0442394604e2a9f72ca75a0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__afa3a5db7d1e280e80b0ba6b9b6930a289a2a4caefc3f55694d2a73d0fd89b3c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ebd33897bf1bfbdbba5cfe276f2acbddf0fdfcfa44d365ac1457f30ad31faec1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e0ae300e3e7234f07e42ca341bbbb76f0416467592174a7f2359b79ad47e7086(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f92ec7af47a5ab057532b04c09e7df3d9e10909ee37d40ecc2ef228769b98461(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9203fa8f24ef7ed51cb891eb306f6158b3e1541b35d2a23f4ba28aae314b91ff(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7fc77c25078fadeef2dfbde207c08a2fe1fce0c25741caef03adc4e0ca3bd8d7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__beeffe21160c4c9a186ce431e024f1d99c930d064f1b6b9f1dfd3c1b895e459e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimensionLessThanUnsharpMask]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__009b6ffd0f884ba4577011231a01e8cec12a87bfc9328d1fe83e8cbea37a68df(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0aecb0ef38f3c025f7bfc2423a429ed97123cf7e25a99cd0647aed366ddf2215(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ee95c1d2aba8f8dec2cd96a4ac4ff60218a528d247e1811378823bb978a6bdf5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c076694c3a04eb0f74f56ca02b12c6479b417b4297b53c528a4bd5cd5d53c775(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__21a25d35578b65150ac546c94b04d2a80963b73c4d059931565289e9fa17ed5f(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e5b80a86b5825273c5a66bda78980d85aa6bf82fd8b6cb4a06a329415628d036(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimension]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0220485a64c6edab99e5fe0c448de18706c0a7b573114a1af750245afc7f86ea(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7e5bb1ab43cb47de3577cd4b26504fba9dd85b607097c67ea2bfd89ed3f9a746(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3b08e338975bed00909e49dbac5dd27b3427f47c6debeccd7115882a2419cbe1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9cc3f132fa8332dea449d576d55ac08c17c676a510f6a7c2e4af13fc629deb7a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6740627a01687e75c4b033ae82445e889c0fa7e02d38f913995575a62e8798b7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5e7247bc9c5f27c6210ae103f0b8d250e8362e37b6a571fcf51cb9045d491b5a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimension]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__805c231ad30e4e72ef994792b877e2647c1c908f891fd8036b42773c69be7131(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    landscape: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscape, typing.Dict[builtins.str, typing.Any]]] = None,
    portrait: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortrait, typing.Dict[builtins.str, typing.Any]]] = None,
    square: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquare, typing.Dict[builtins.str, typing.Any]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac5bf9604783cbf2493693a7e96cc10fd1487f2364f44c376c633c4c990c47d7(
    *,
    background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
    chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
    composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
    compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
    contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
    goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
    max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
    opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
    remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a516ff8d83ede5d30e66794f72063b7a54263ac3913468714f5b779c414949ab(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2828bb7a5a54a93a6ae9ce7a9d96555ad4bd63a813badc5b8e1f80d6e859aa4e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__11afe6f059d48c9331be572e934767ba1691a632a00fbbd1284a87cf2c0127de(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e6122fb0d1ebfb814635c233ce38d449b79b745454479a625a33da94b19615a9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3c62ec95becf97c21775e8d37734cc1e4d3b91b224dd8d8f8476df8ea6218b8b(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__24b383984be50f1524618167430682eee8c36739d52008cc8516e22a9f436973(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7bd629c6ca63cd629f14d2c5abed7fa20d9546d6520e4ae05ecb45b184deccc0(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultBackgroundColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4d4efb0a86b7da3e1304a43013f9c2ff8eec868c5ca56704e9381ff52c5a4c47(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__45a42880753b8e0c43384566de89be775670a3bffb822a43293eb36df95255a8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cf7fd8d38f487282cfe4677fc5a6157e59605e29a1a2dd1e3a1cc3dbefe03114(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__27638b7f83b72b74344f31c26d46687fee2a8a8f9fa14cbbe86cd14f317ad2e9(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultBackgroundColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b0aee1998a2f60c32838ed9b40b6f5d96f66cef263b8ab3b8697b0865f48f32c(
    *,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3178606d9c66f166adb0f36a12eae355bfb3c4e442851dbef50ce58e18947a10(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c1899e16a186ea578fcc86b404109f2222a9074432d13929cadb99626291813d(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cbfef02ff25bd726b49b1f719dc1e4ebdd4546b222ad3484a3a65d66e0ba427a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__31c42daa9526a773a63c4522fcf376259c7d97b3bdac1c5675a35fae0d71d156(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d8f766a3a9f1ad5638e857e80d3520dbdcc3d8279b72407b0b108fc5798c8f83(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c2360fce046af5a251c1064242360a672ad4a07d230f257f48b989f6c93b7d55(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultBlur]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0da12cba22d40d199ed6f6911cf444dd5e17d6489acb4af766aa1c8f8996cde8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__079a66f77bf109614a25aae9bdd452cbb2fd7580f2d49891e70f0e5f3ef1669a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__974c7816cc9db7c3ba45954c017873bfeedfd52dac6f026db23440f25977d517(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b7c5145ff8ace8caefb9bab39bab5005557bc06a48272b812dc390db8b3933fa(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultBlur]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b0577b051e088b3e50ae8ad86f1bced41ea60af146738cffc493d71e0599b7fe(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_feather: typing.Optional[builtins.str] = None,
    hue_feather_var: typing.Optional[builtins.str] = None,
    hue_tolerance: typing.Optional[builtins.str] = None,
    hue_tolerance_var: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness_feather: typing.Optional[builtins.str] = None,
    lightness_feather_var: typing.Optional[builtins.str] = None,
    lightness_tolerance: typing.Optional[builtins.str] = None,
    lightness_tolerance_var: typing.Optional[builtins.str] = None,
    saturation_feather: typing.Optional[builtins.str] = None,
    saturation_feather_var: typing.Optional[builtins.str] = None,
    saturation_tolerance: typing.Optional[builtins.str] = None,
    saturation_tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__80c11e844b2139b71920aa1193ac40441197cf2fba9412481161acfbb16ba6e2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d426e0e21edd234f3fc3ed7ebda2bfa7b01049c04ea2d40d073f310b562bd0ec(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__74ec246b946191126eb8328ae4061f4ea1a5165e2dbf2abcc619f617e0779c99(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3510aa38587f6780bd6d8a77a8c26f026a9097a42beb8a7ce0fb6d5b9894d084(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0208d2a8259831ffa0c6967ac32909896542994216aaad1a5195f7654f136147(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__525f82ee94e9b3a3b73fa0d169132c48e8189566a3b73c8daf257e59fcd6e858(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultChromaKey]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab734ab5f2eafce623eb3d52dd472abd10eb4848e6691bb829af50494ce29120(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__67778ed67ce49c69ae5cbcb87ab80e6b0d6ca1beb3f72dca10082aea9310e84f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c3a9abf65b36afc5c4f94636043b24fdc6fcdb5658dd489104ae5a7d7bad2782(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1c7ea9c26d7a5f7964ab850530165aef438d5872c3cb52f2d91db585960cc522(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eade1d50ca29f6b114b175578f26d351780607a21e636971958cee53297d4793(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__45b1f3b5afa9c9c9057393787b4d0ba9a04b5f1302e0a3f538b63a3f5978b7a5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0f09ab7ba44e76d9449d3b6ec26ea1d9d5141c5b0ba5910d3c4aa86da3b6310d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__660067e6cff63fb97d04f4b4369d84699eea39f55d5cb0116c39e37dc2ff2eca(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__72ed3290468f095822c32969a9f64ed07f5674ed13fa6fa0be7011d572912747(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e685550440b21488d55779572d83a148ad0a1add69f49b414df6be3dbd178a53(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__79cbb446d1e6939c4a11b68ec9e5150ad815e27bfd91a2806e3bec9b73771ee9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a9ba972542f9c85c075082a4d912f0eecd08cd1be83de06892d3c641d9447c78(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__571e6969f3a88e94358df985bea62b3f375ff0a063bbc2960e1b7424e68e891d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ceb50482bdf9f9cbeb06d0a54908d71699d3b306b0b9b3c3ced47b9492b6ab4b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__757d8dc5c293bbb2eb1daf9f6bbc8936a6fc8e7ae317f0d76259300a907aecc1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7053e09db413eb3b580ec0f608ceda53e046641d533663754043d4d0541c8cf4(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultChromaKey]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2868d54324907e9ba87b1b2eb211e29b07e37b08bce7ce9e80e60610a6e4239a(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultCompositeImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    placement: typing.Optional[builtins.str] = None,
    placement_var: typing.Optional[builtins.str] = None,
    scale: typing.Optional[builtins.str] = None,
    scale_dimension: typing.Optional[builtins.str] = None,
    scale_dimension_var: typing.Optional[builtins.str] = None,
    scale_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__24c3fca4dfb02aa37db08762341497f9f5d48da5f0ab0600cec6c65ed45dab11(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7dfa5184e9045b4f2d0a8c49b8e3447b6f6b70e1770e0c4c7ec31afe57b81b3b(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultCompositeImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1d5b5a23dccc5f7c7ea0a30d413f012904c2c04201513c158ab7af4f91b29e1f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__21013cb06714da948286be4c5945b658709477c71735d1e3a786df75587b32f5(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__92102155ce531b817614cdc9997bd9ebc958ba59502f6257520f2700dd08c9eb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__91f381df2ccce2efe6ef1a498040b6ae61db254d777a6848d661231fcf89d544(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__654e943a3d2a8ea5870164a7b15b1484d6102690ef8ef5256762ae8c76070558(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af1d5aee1948ec6d39069d018a6c82e3e7261ae6102844bf8c7ea998074ebf32(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultComposite]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6155734480e6414f41d09554f2ae1f97e2d5f6b1a4ac7b9f8f962716b38cec4c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__59d7a26e9d7cfe9017bfb8cbb36fdc705fb2b16aed8bf9cebc83d2d7056d19f1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__566a80d65da014b63356a67eff0803277096f6b0bce5c014e0dc2324173381eb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bebb6b84daa604f6d43903c659292acba99eb1c9a49218502420fdfc098a7fba(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__751b8b6dc06e9366979044dc281a9561fed1cd507d827983a93624e79b8fed66(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d253a91fe661bd60f9747adccba77da45b902e0a1229d3199eaf3a483c58c825(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c7dbf0bca343b6bbf80bac37e7e535249102a39be411bc18d9aea1b39bd3a985(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ebcfd0d0ef492bd0c5594ed7dee27e5d99bc5df542cbfcc199b8ae666a7798ae(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4dc8cfa8c146a3f0b6f4296c50be546c93812c65d8fd3ab616af394ba096a0c3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c9baed8c220971f77a54d1cf4864f9e3d62ec28eb3f145db77d53ce08a46ef25(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__08f9b3d110a1c8d2a1474ee5a4aa84bdaf3dbe0fccbde05484f572381954c23d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d8b924aed1d95d5a3d9e51fc3b64c04f3b59f9709ce5ce39f91422adae1f770c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ecce1bf4f63e2e5a9d7c00dc46811b0435bf5bb996d22c547727c48d9f57aaa2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__11b024b1f15c792b9dfe89f2eafcc67b426e24f17cbe49f79a761ae8ee655eb1(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultComposite]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__529696ae5fac9d0df253cd27a9cca3f0b9cc5dad60ac80635bc767b3d4fd5d8d(
    *,
    transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4dd0d2e5567ce326017b5f980278185f849014a6d69599c2607cc251949640ad(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ec5192255011e3d235bb98c9193cfec9972ccf4b93f2e968b1f279d3d884746(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5da09188803f582f0a0548fefe687f47ac249d49453d71ea6e112973622825e9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__59775787804b06a67e40d5229c6c8dd084b0c84dfb7ff6f33c85bd92d67b0554(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5a3ae89b3ed05fdde3c33887d1926d85930d3895bdd391dc0239000df0d1856f(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7af820c2457a93ac1480ff47c95b173612e5019e3c64f1c4c80ff2877e170ebf(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultCompound]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cacafb5b1574b012b43159ef868ecb1de6c6821f5d2052d3478f36fbd537fe8c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5b9963c2984f62ae3edaf4301ddd473fea44f658544f5a96d66470d5992b036e(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cc4a39b23d3d3adec78ea99163056ff2ec2b431f27106d96b0ed304874724207(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultCompound]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f71b916b8f73c1b36d1d9ade84b9f8451e4b8b14115af1a88aac25274cc12227(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__113768365781bf640576dd79b7c944d02fac27daa87d17bd3286f753d43c6408(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e0f98ff654a4af2da90060001f61fcf5730b63bc9c3c52013f892d485a48c97(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3dd7ceda790ee82b2573da14797ef4ff8ebc6b8533b1934781c4cb99a41d95c5(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__21c4169cccda09d8dd12c5f77ac3c4241451eba3663237b9c5d4b2738b19021a(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ed413fa74988c130d76d8fc380701a9a2e4ef293952ac76164ee9db4124a3c7(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultCompoundTransformations]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a2c5db0bc175868415fcd524b86b37ca8d4e375285de8da09cef24b3df90f06e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4cd5d393ba8f7d56a5a81f2507a594dc857e9535230afc95799b289d07e62459(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultCompoundTransformations]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__892fe013e89efd4f5f6583c904f78d9aea4e3b82ffcbf723dc6351a536fc1eb0(
    *,
    brightness: typing.Optional[builtins.str] = None,
    brightness_var: typing.Optional[builtins.str] = None,
    contrast: typing.Optional[builtins.str] = None,
    contrast_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__090d310d473cbba9cddc91c9556cc3f9968127865970ece2ba38b8f502b98849(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__32876eca495c273136d9a5be1cdf3f6741776297c07085681f5815f90187e088(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a9a9d82504efebc09f05c654391ded7e98f9e8aaeceaebe2e658c92fc43b38a3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a58295d3b8d8670da8939339f3ca685e4043324955fa0ff2f64221c17bb5933(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__393690427cf3ffdef4ff247bc1738308e2940505e7ed12963b049809cd76ebb3(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__494db0e86471c7058d3ef4fe4fb318e20182beceb0f1382e32a03107f6b4769c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultContrast]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fbce997068a032b327942508c8b734a41665c55b20d4d47eb6de5b7cd8f9ddfd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a9a3af4dd6a3a4fdc0d694a3235e6e14b4948e572199ee0ba307cbd4e01a3b73(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d32c0b181680705915efc6dd78fdcc1e50e19b1c98a5d6284e98e0844b5ffdc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ce8f378b80ee0e72dbf5b1b85c0edfb63271f151298e488f9e2690993798c24(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a0b7989132a51ee23956619472abfc85665a3c4c347f84cb2e74c4ba30aeeef6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f920baefc132d45e9d6a85e4a7a4f0f887f1d8b2f791a16d2b1766f1f89cb2e4(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultContrast]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__529afffe01434f48516c722b608c17207f416118b38bcec13ab055555399d2d4(
    *,
    chaos: typing.Optional[builtins.str] = None,
    chaos_var: typing.Optional[builtins.str] = None,
    density: typing.Optional[builtins.str] = None,
    density_var: typing.Optional[builtins.str] = None,
    power: typing.Optional[builtins.str] = None,
    power_var: typing.Optional[builtins.str] = None,
    seed: typing.Optional[builtins.str] = None,
    seed_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__03a0437b03ca7f9551f13e254897fa771806722b44f68faf0a54eaf6d7468462(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d8c14bc557fd50379096b125ec9d616603f1f09f36059ae5b89b217061fe4dc6(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ed6bec4c2d9610d490dd77602ff1286970d773fcbdd8796520582007705002c8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__322d7470d243794b17943855ce2e288641a53baf54ae04007bdb35fbe0292751(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0cd17a6124962fec8bac63935a371d4c1dc4c50f06e7d7fd19ed9769301ed7ac(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ada3406216f9bd62e8e7041f73c6b7e32eda17a779497e07732488cb2b7597c2(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultGoop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0a8df505c4e4c420a4786bd085482d03a7ebed7f94fc119510b17b706abb2e62(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d90cdd8704ab891b16322f3e0015d10a4d11c16d21aa0e23f5f12950c984791(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ddda0cea30e76b1f020e58bbcf45c68b984b2023dc96d65d1861eb2f8a674cec(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__98b79df36533b00b1a7d3872c792eb7cd89e014b75e07b4ec7946ebfb39268c6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c65783653c75d7341f395d58c13b463880f7ae6a3d04bc2eaa827b28798394ae(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2618cd0c8ad396ff7c84575f4759497f4666cac320d7f90f50905b58a7e00e28(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b9a39cad98904157dbfa96a7076145582c7d39d5d55748e83ed9702879e0784c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b150a27a95227d7e307c20be13e62baf305c9d4d889c9ccb7d307e2c8cde45b1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7563c3cb878316a53db9a8fa8eb4ad79f266e7dd2f9c37cf54bf3051a206b51b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ead6881f643aba59c01a0ede89a890078e90e946a890892ac2eb208ee00d4b81(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultGoop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d377288648aff375a66960c978e8e0137c8c2aa6ef75a687fbbd2e7833c9bd76(
    *,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__380547667f8ef03434b64bdc5e6cf2b062d26977bc77351d39e8286df51a0bf3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a0370e77cf19786d73ae0f617c9361f74ffc85a7e4d8127cc4757241b945c2a1(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bdc188252d404f49090759bf3e813ef27fd9fde60508fa3632844808fd9511e0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cbbc68fdac3aeffee65878f482c7509405e8d8cc3fe499806bff88124f6bb640(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c212eea415d1cb18943c59fc9114941efb0ef668824a5ca72df679bc77878b07(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1e87dae6686ab4e87a07c993dd51a8b3fa13e90b527e145d30488d30b5888e4f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultGrayscale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__64511169ec308eed9bcc057634ad4db65e02bf36026ac540d191e3c00a568a3d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__72e2c67268af5e9c69b44d8277c21f208dfa003ae73e9316475c9063d653c273(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5855038a0d2510725253f81c0343f8a907232fda518584c7edf0c9c8dc009fce(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c50012bdb4094c3326ac6372c2c7efbff67dfed9e1ed081e337ac656aa1d48b8(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultGrayscale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3f6bc199e544ea444dd4207746225796625a05093384c91b8c732bad949e5dbb(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness: typing.Optional[builtins.str] = None,
    lightness_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1d17b7c7868a5cf7987851639b8f296cefef241bcc5519ffd2604ceb995fb0b2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2de3aba25fb06601dc914011e9015303dd0368bfcd73de94be6c5b391b4cac42(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a5aff2a090d46b20bae975161c3165370cfb90e8e0dc50827cc7247e29469118(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a1d0c040332653a300e59d3cfdd16059d12324ad49e9a445700890625eb4bfa3(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3bbdbce28f409e6f8a3aaa3ce64925d3bd7cd9fe4776ce7e324f4bf813c43ac1(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6b6e4c52d9199dd15a2496fd7193bc0575b170add3be3517128db6c4f9cb4f54(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultHsl]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__032ae0864f758ad7e35ca6a14d35486002e7c8e1af42345731b19e56f4fab43d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ff44b7562e1d978be09ae0a56b6fdd3a59d002dc5c5aeea50537c2d0256cd907(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d0b4343d63032c6fe8de1ea020ae013c9abf18ee75d39c67812e4e71ad922c29(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__78db65057e8a41425d93c479a308e6a7ce6b923bb6ac87f1d4462f200980b71d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3e462a583ce198c6feea681dee1f3c5157b8750c2841c6c7a1199a1e720e8f54(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__51480f99aa279670b5c53d1f06749574cb77d1ac3c443dcdbdb7fe5da3415d6d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0da030a234a8e042645d4a05dc73009cc34f18d5ea14545979181c2ebb3f62cb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__414ef4574b2a0cba2b783a2db5346e37d46c643b36f8f70bd7c8e2a0a244d43c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultHsl]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__234fae9561339bbffdbbfe8d4eae749b79b916d23f573bbe988260087a17b934(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f27c7d514ac7a7dbdd09cae5886586492f121f14517214a875e4c29b10b9ae51(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__46c41abc955086cb35ffc74d35bb01e3921fa7a14a38fcd29147d5b96828e838(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__414a442cbfa38f3d1696ba0ff3cce2e843f0d15aa50bd6f76dfed69e3c549980(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7c38033f76fb9aafcb0b3e9feaf696e442331158e8c353bee81027bde49bb2df(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__25def13ef3ca884056252cd17b6251c22e6de9c9c89fd4870a0164e3d48a636e(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__64acb4adfd98f7da07aef5b0ed3a4d3d2349d6c88a2b950e8ec02ee20e8b56c8(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultHsv]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a18e2fd597b6c4b51ae6d1266deb8fc3647f46128762bbd0e11942efcfa9c48(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__96f3381b31716f796639679905f07a9d9a10b9835150f16bbcbdb8275ba74213(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b75954d360592be25304bf90a2df57d48e88698214e6f167481cdf60530fbcb6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eb823d4e71b371ded6bd0afe7f93785d93695c08faafbccffabe49391002360e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__944d88804190edc981cfc3b581903b4ac174395c724855154905c68c8a69cc64(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0440814fa93e55ae9f2ddf4c7713fc03a2206d36530c1bd2d9d9d32e0f97f18c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4f663cade92a564ae304b74a596c79d66da8c56a641c0b183ca5ed3ca60e79ba(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__78492eb7d30bb9820774a698c1f012dc859fe8c02614906e4796b5c46c10ed65(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultHsv]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ec6fafd8260e8cfdec92f32a15f1cf29066e70168f04a13087d097b4e33abb3b(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfDimensionDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    dimension: typing.Optional[builtins.str] = None,
    dimension_var: typing.Optional[builtins.str] = None,
    equal: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfDimensionEqual, typing.Dict[builtins.str, typing.Any]]] = None,
    greater_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfDimensionGreaterThan, typing.Dict[builtins.str, typing.Any]]] = None,
    less_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfDimensionLessThan, typing.Dict[builtins.str, typing.Any]]] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f64d185a23119e6a38e44a26305be4ae030314942c2f43392154c6ebc1cea96b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__96254eefa6282f558534fea6e045cb8900597a67c44fffa5edd2de9bb56fd198(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfDimensionDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4e5b0059482f3c2c1dde1d7aca14619920061bdbb06d5fb92b7ef13a46fcfa46(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cf76269a193c03c4c90088722e311f99c53a8c8b5381586569374d562001c63f(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfDimensionEqual],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__70e2ee689f94f3d36cf943f2721531d200e752b1e11a3b2509ded864ff795d24(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b209b6e373ca86d8baa3cb8160c094f92b2568d9919b781507262ad3cd1725dc(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfDimensionGreaterThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f1360716f0f87c92cc3df55542d46413c119e5b7d1ec75548839ebaccc86f94(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c1ad0953f35179e985996c11e9791dbbbcf4da0386989d8ae99a3f0c33724287(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfDimensionLessThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2f2c12fc0ca82630c21a6658769dde5be93c063fb322d8826a707abfe79275b2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7e6e05139047ba078b304b31a6753feeaa806e1956613411b22d990a09fd59ae(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c36b551774485e4a26cabbe835505663ce63df32f52fa85d566595fa42dbbd10(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dc47b1195ffac9fdd5322911deae1810a78c71554132862cce0e8e6401cbea98(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c3fdf2a5d4d4925e79ab38d0f99d60c43e42fab510c98047504a1f7d8b1d177b(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b58aca1d97c83724e092ecd80715b11e14d6a5d321d7c603d3630e1b8b2d2e77(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfDimension]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__64a9c9985040d46b6c8331092deea8b8d7a0f0c3075147f72d6393b14257b865(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f89fb86a88a4bd87daadb004e0d139dbf317e71788a87ad6a062cd1939f51cea(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e9073ef153faba0343f14cb9c68aa3298af5d87c0ef23ddda056ba16a4541119(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eb127efa7705535501056304b7b2cd757d9b62ffd88252ff5a5d425594bf0897(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b7cac673a2873372a53105fe7734f920c91d677e28f874fd4b9508cf9c1d38a3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bbb57bf03c58081568848f631fd88783869c4e70a97ac20d38597ccdd6380488(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfDimension]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c11a86e97615958865befb0e179a29405707c5ad34c3aecfb91883df8862f2d3(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfOrientationDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    landscape: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfOrientationLandscape, typing.Dict[builtins.str, typing.Any]]] = None,
    portrait: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfOrientationPortrait, typing.Dict[builtins.str, typing.Any]]] = None,
    square: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfOrientationSquare, typing.Dict[builtins.str, typing.Any]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc381d5a7f3ffb69237c61edb20c0fb6cdefaf8bb4eeae25c664214a4962245d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a4a0cfc171797e92b84ce4d2f91ff044e9b4f21728bac3e3da4fdbbcf26c457c(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfOrientationDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac88d7703b1c805394265847e79e49563db36bd043d2bc0a861164b13c86d29a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4992d64467f26d626cbd23467b041bc3f1bdb915dfd2ffdeb986cf90bec770f6(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfOrientationLandscape],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__71242f33bb69fc804eefa8a5acbc834efbfb51fe279a556c1b77b5812374236e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__56be4e9f3712dcbee7312c7afbd762854fe6131aba0a0027e696a564610705d9(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__217b114ec580c0fa52f90428a51c4e7cbcb57b140ee9a8b74f38c648ef77a9a9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__214c68f045a7f3951f279fe0b937b50f6cfc392019b44a93d75e8cff63dce5b9(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a5cc17fc91a5d3dc1db19bbb0a6b7bf23891548942be47b96d89c1c117fd5fc3(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7b2d7253ed7aec3ce54ee8cf02b4397e5381e5f3673717fc12bd404135dc032a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfOrientation]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__63b528764e4b5fc0795f9f856aafaf70544e96ac5d02e8a303edb02b46e5d704(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f4c154fbcdf84f01882802db0aab7ed26ab905140c191e084ac0f68e36b62734(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfOrientation]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ba11f8cd195bbd6da35af7ccec6f99749b4f6a150498092ee811460e2b7b5f68(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0bba80ef6f470a319ad5438f094d780c12dfa30f2d8155bbd97b2eef75507b45(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfOrientationPortrait],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__559d1d6d99c27e6c14b56ef0be79a06efe7711f007bae349f0c41b383fe1792a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__22882997b03412a5d21655cbbc96a9e73c16a60e6322ec553d1fab7e6057a1d6(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfOrientationSquare],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__05f6ee7c2a1219e4e35922487385bfc748dc31b78de13950066c7f94bd480e05(
    *,
    colors: typing.Optional[builtins.str] = None,
    colors_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__55251d830762992023a5cce48b3921e1737b8d3ded619d347ca42749f9a17f88(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ef2738598ebcb25e88bc7cfc4f18c540e9af641886c8cbad02207939d8b9026(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d8170aa28479574b5a72814b4dc5996ddc8a92190e3b2e8c944cab26301dd0f8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__45ee41ddce017ba27e9ceef2e6fd4f7b5808b21c0ea19658ddcd23705eca3355(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__49be627a24fa2f6aacae462dbfc3e7e1361fb1aeb6ea89e10765cc01b2632354(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__293950d0a2e014490d4837f53b61715c107501c3eb36eeeb4c6cfcdacd4bf601(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultMaxColors]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ad7b73620b2f4592ba4d45a5caeb17ae6385f9c4ecc8a52183fc5556eb2c0c31(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8d4d540714c65ebf263c421edd599639856e7093234e36d017f82473828788aa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9863aa556ba1535f574116948ff755eb34ce46c4a6bba02850418838056ae8c5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__67a164acb2f65f7367610207071255f88827f1553fac3ff4ecdca90242e11351(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultMaxColors]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4189ffdc7cbc9aacddf724a40728f5a4eeacf9f9a89d66c90ea7c73f1717d3ce(
    *,
    horizontal: typing.Optional[builtins.str] = None,
    horizontal_var: typing.Optional[builtins.str] = None,
    vertical: typing.Optional[builtins.str] = None,
    vertical_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8c64739fac9b0a67166e2297875f0f48308cd0c429b87a240ac50b60f4529504(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4b3fa0935aac00ec374867e65d79f5d96a3ab73c5a7246bf43f5d6f6d1bc2b7c(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__24ebcd69f4ff24fafde3a3b0ad00e557ae92f6285c6bb66f87875570b6a87ee0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__816736c7a89db9b7c2f38667f9d3984c3ac593e10e3c83c91beed7c6c3e26022(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a5376969aca685820cfa0ac73501a5be61a2608a2d213fdba0674a45451c50d7(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e3482cd5c99ccbab493f00ed86ea373f382ee7068c68cc99b6ede68a1d8dce8f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultMirror]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8753731b577fc372a7acb23dc2a0081ac62be0dbb885d7a955dd3e734d1529cf(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__74387a46b180e81ed2288039d020d3c0e184c0d8ae9e7d59fe7b05640e3ba730(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__83b6c7b9ff583c6abdb854f8553c33b3a272484bab066c4d41efef8e006fb8ec(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ad6042c85b5254ecd36110f5045ab0a121981cfc332cd64bfdee2f450d4cc6b7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f3b7e46cbe47d5103c399e3c934de8f859769cae81b2bc8290b427d8e6e1e7e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3c8b79d70de76c312a248c006b1b56ad5e8659309e09fdeee45a92b489506768(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultMirror]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__773a93a6974c2e936cc07778c3d52e7a178c80e83c5ba7ac000dbdf34d19bc59(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f6084148b6dd64e19ad9e19ab26fe27ccadf49ab99bb248731157b6798638a07(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__add854a5426a9bbc196b7a3923b1f021c336e69eeb71704c8d1b06a66b21586f(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b7ccf756b1162068ae2db7711fcf827668a4881f7c5b7f55592d81722ea679e3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fb53db76fec603ca3ad6471ee93e40331a4266666a0040da6df6d877b629f5e4(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__15030594b8ebe8d21f8d6d37797e802ab462280e541cb4c8efa8511a269cc260(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__85352c220550371816099120907b73352cd2d162ea9a4958103d5bd943a6a357(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultMonoHue]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__24b93d505b4f52e3f862234fad0a8ec7df205ad99129bc99d212029fe9b34551(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0008ba331d75197029206e2b30d7d9e238c70af76b3cdb46fb5daaee5d93bca1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__71017437cfa13f44056969a25f8cbca9fa02c6de9f74cfc437a4b3c23728008e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f884bb5c2fe5f500e78c8e22540fe01c55c0d063f5f84c516eb5c0d5825e1e2a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultMonoHue]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__71db3ea10ac42e58378d347f590733fca63e8d46a2e64ea5350478c2b7106933(
    *,
    opacity: typing.Optional[builtins.str] = None,
    opacity_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__94cb53e2e093c639c9b51fc9202b35750491e9a8c9758df5eaea246325893758(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__71a6a6384fab8df02c3b8ce238c2b42fb53921857c8dce651ee5912e6ab99123(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8682afa7f66816a7b6870774f8c28e2aac83f2aaa28663556a7d84cce54fd41d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a951d282a076935940942d9f5134ae20d23d4c2e879b7a69e963cb9959be408(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__55d837e8b9db4a4cc2e47dc2794561bfa879b0483374f56451a5721a598bd752(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d1d73e5d88e587bc6c6731bcd803b001824af7dd2affe4d61f9c46afff5569e6(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultOpacity]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__649e4f74ef3e9318586c0da2865366dceca29b9fbe76c582f76a063655f4f63d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f36ee493d6f7b3b75b511ba38d501ef340b82f3a9b4046087d25219e194ee114(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a38c7f2882789e4a5c53f86ba82942fc8dd0a8d29bbc8c031a769771eb59c593(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__12c669a9da54955f26d6376ea1677d6c3098e3cca0111f564d3c1b57d7abe7a1(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultOpacity]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__220b283e84c4fa5371d049bb0129886c22af649663ba5f14165a2d6ef027be36(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1242a4f1c29b6c539b0c0be1fbe93081223815adad974ce9f6680ffa999cad4b(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0f3c4eaeeef48efa96adab817d3ca67946a8c8d84dccf01d144a3ab4d35406f8(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultBlur, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7030174b288cf809da59989594b34135b053a55e6088e6b970529fab57f583f4(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultChromaKey, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5cf2a4098d6dfa4d6b89c37f7b8453efb8c49b0407a1defdacabcaf3aac26484(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultComposite, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__79a3c4e424a3a9eecf9ad1182cb2602f2ceee8de3d9b797825fd657937b3208d(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultCompound, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__37f978df3d47d2bfea737f980b9afd4ddbaeb6137d06a58c30af6572d229fda7(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultContrast, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c3acb415954423fa32dc3a556e9d04bec927eb02a654b116e87d861dca391c95(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultGoop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ed92d4ca0ac2e7ed25de5805abe575a5c377d0b2599284cafdbd7b5ce67000e3(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultGrayscale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f7d9a8a065545eddd01ae21d200e96a9aaabd1d1d396d77bff8f20260c45e994(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultHsl, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__973d20ad332542c8d0724a9c2b8ea9ada719557616ce03c135091aaf27a4a2fd(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultHsv, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a45b627d86d4e6bf0e366d18a6f3531a188dfe2cf90ed3c46a694cbc5563ba9(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfDimension, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__362e147f0f9a31a0fd2980f21b8acdf0577a0b30cce1fc52205903edbfe78199(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__49cf95f695d776254036c13d0366988dfd22d32f1a278309e94363a6218ad6aa(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultMaxColors, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1ecf1c163cded56f15b68bc8fd9dfd4a67823217c91a4bde47d751156f7a727f(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultMirror, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__12435fd3f912a9f764b21394c19d9fcff9cdfd35fa17948d74e8055954d3dd22(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultMonoHue, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5591b59efc14aea19a7e47b581ae791d5f2b520539bf8851012719e27c8a5326(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultOpacity, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__45b9617790364a75ee4598e6f5fc463393aebde9143fb9b688a5d2dd31fd4bff(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultRemoveColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8bcc56e2ccb647ff9f09f0fdfcf111a52413b28aea2edda212975367e57f7e83(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultUnsharpMask, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f36c7b2efd2e06e73e89f480eb020a74182287446038874417ab63d7603dfb48(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7281cc04d55d018f488e6b9aec9ef144f4c8affb287f23c0259b747eabc3b921(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
    feather: typing.Optional[builtins.str] = None,
    feather_var: typing.Optional[builtins.str] = None,
    tolerance: typing.Optional[builtins.str] = None,
    tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2396225f17e624e9804a3bf070b9e48a30eb53f6aef3f4f5aaf88b7a33cd0eef(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__52b10c07364830a7ba380beee34de9ce51663c66e2e1faab48bc06adc3b9de43(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8e82724b520bba4ad307dfba6b027ff0ffebcca0b934e06b7cfa0f37ac1a1fcd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__93ae475a7d96cbc0311160717590c6f0f4e4ff47c3e2622db5d42ab706bc114d(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__44e8eb2d1318b5d87cfe4b4618f9e19221c1475054bd544df6b7509aa67dbb4d(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__33e82a98f0dcac99c57f9aeb106735fb1dd27e308c1600e80a3dedf0adc439d9(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultRemoveColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8f904e3b239aca920f2ac3ef2817af089bd988ccf87ba3d0f7855f11cdc4aba6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6862a57cbeec1bbb7d64f9ff24a3feabf26f887adc2d0af37f46a70434a53e70(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__23c6f3e481a2bbc7dc30246ca1702b4966468a73017f99a8bc69cf881b9097df(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3abceb114837ca71c649471d2c87a34c414207c70327f29d3742d3bdbda1f154(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ab19aafafb1c1be5231946b3012aa766ad018ae9854b52cb5a93460d490d6e5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__647217f2efd5d2a88e76c31392841bde86a7f946f0b972066726445ab5f16652(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a980bee82a9d4536df5439aad576dfd2dd1ccb8c63c92a0b70633cf674f60690(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5bb94718ea2aaecc0adc01c26525d7bb773bc3264c163ab6cbb62e8d314701e6(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultRemoveColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__524b8b77fe5467e764e0e6970b1afa76983b713096126a6dd085a940c93f7bba(
    *,
    gain: typing.Optional[builtins.str] = None,
    gain_var: typing.Optional[builtins.str] = None,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
    threshold: typing.Optional[builtins.str] = None,
    threshold_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aa270a24dd0cd8cdc864317fc7dab1c7bc73e3bbabdeeaf859ce8b6b2c88756c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2c039c89dc7bc45625b8d2e1821dcfdbd2256e97153b73ea386fd0f43f0c2d5d(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__458c3f8691a85049bd27092b3952a25c5bc0efd518b1c3b7d15844d602a92ba6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dea95f59f55f425dd9a01229bf48f4d6954e74e406f583fee017f393caf505b9(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f78edcd961863b3918f4be510de5ac20db456585f1c93b7766dd650b080ca5c8(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f4b0371af609ae6b05458fa744314a5bc95c7603e377eb65cdfc03760c30df2b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultUnsharpMask]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__09c822a2decbf004764963940f829f464aa722fea9431a001d9a163150a2c1f6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d9492c6766a416965ed9a49c7a0d7672abd62bbd690dc0300315abf2c0c704a7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__107b4a071f4d401129864f83fb5aa4032162e44c317cde75f5dea8558cccd9d3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e0569dbba0362af37eecf4e67b1b9185d5759dde748a39014b27b511b68fc24a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8ff47db717875c62b43290a570426b4b50ee035effef44508745c7aa163294d8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e64c88a37c599fc191913227e9365fe7f0251f71b5e842750b67de40848f7fb0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b22f4bc871af9923d0fa39cd682382700f89c4e62a7bd8808ed2e8c590a6d6f9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e7e2c7744fe7acc87db6a180634c53e62125d273d0dadcff68f43a6e2e026bfd(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationDefaultUnsharpMask]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6a78b0a62bcdeab874c1010c2c71fffcc9102cc875e5ae3514552a42c886a592(
    *,
    background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
    chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
    composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
    compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
    contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
    goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
    max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
    opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
    remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d124b29bb963f913c993dba9c7b6adccd72b866e5bf2248b7f1888b25b9e8151(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0fbcb52a69f898e54b34c0be9d92b6f5d8408e777ef2a2a6b4035e94f7961e07(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__adace08618c21b350472b591ed7ad4084bb882c46a94dda02a7ee309516f5a5b(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d031dd1c65b7375f24c55dedd1fa6e388d0f6693e814dee0cf590dea120cd836(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7e07d8cf19c4d3b91779ab071f287a605f27e3b18b665ce368369dc0d390b9b1(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b62129f0d435dbda0b3880c71888bb698449d4a881a0816fb277891c5865376d(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__496b5bb9760ffd0601203eb7357aff0a4de115c9f56ab7aa684aa6909eb996ea(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeBackgroundColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d26803333803f285ddc26163b06cc189a3b4097e1331fd5b79635903aeb8947a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eb3ead6223211ddc47b5da49efb2cf5a0386cf994f77f376952f03b362f64636(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__83fe220de3d08b091eda0643e9e7b4a00b5c93258a20f7fd93f72cf19687cc22(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4fd1156ed5f559ad7905819df8ad018486ab404f677f29cf5e14f95206e29e11(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeBackgroundColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7dccfad831c406b327472ddc071d86b2ec8008ba03410b7f2b98c6f5c0fa5d6c(
    *,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__395209de5d9312e4ff0cf18bac7fa5b97e44893aca42727838e5b379207883f3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ad77d7d8e60336cbd199c9a5a0d97d50833ffb5348670ef9b2e879cb07ef1c79(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0af72e23ffa3ad373dee72dc2e295bf406011963229a2b4f0fce3eb6f5ad38f9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1b5bd543e674f161cc899b667fbbfd05f25d161d3ee8ddf779d3dea391ff8828(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c05d3664fef37d23955a31f80eeb9abea4c728a3f8b55b4f95ae087ba46c3d84(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__109e454bd90690ae6f7a5e284410e9811d7c150be1cced5809c2d32af92809af(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeBlur]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0f79fc0d0739c2880124d3b38af81440d80c02a4ee2a604d8c4077751163841e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__108e91a75a6c73226c52960b3c74553a3d64ad55078dcfd5f4e97178722e9a1e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__095804937911ebdef1051e2acdcf77ea49d80fcda62ee76d5dfbb35938f60225(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b3967fb7bbdf54ac8192769ac63bf1626d0df810ea36d624a24952c3b4648516(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeBlur]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__780c8400f3ec8658b790d3175b9cdcd78939c6992822b560a47f67ec5301274e(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_feather: typing.Optional[builtins.str] = None,
    hue_feather_var: typing.Optional[builtins.str] = None,
    hue_tolerance: typing.Optional[builtins.str] = None,
    hue_tolerance_var: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness_feather: typing.Optional[builtins.str] = None,
    lightness_feather_var: typing.Optional[builtins.str] = None,
    lightness_tolerance: typing.Optional[builtins.str] = None,
    lightness_tolerance_var: typing.Optional[builtins.str] = None,
    saturation_feather: typing.Optional[builtins.str] = None,
    saturation_feather_var: typing.Optional[builtins.str] = None,
    saturation_tolerance: typing.Optional[builtins.str] = None,
    saturation_tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__244fd2fec8fa76861259e4ca3c1eb7bb389286c23da7619e9fe03c71ed42b8d5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__08f84ed76ca3382e4fbc8b5e828722cdd05346954be929a5e39fd19a51a1acc1(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__167422fd512a7d88c1e45b3c2567fc6987a1481804eebac000d9677ffe85888c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ed5d4ea1b9eff0ececc8834b21f15ccd47dc9e073cd9f056b20d178ea33a8597(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__70e059aa4a8bfff4d39c1d4d094f73099316af6c8fb4fc5d19a59eb0d0c569c2(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f74162a5e6521904ed01e94593384805d48b5a15413e2ad97b9c39ac9d6c7ce6(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeChromaKey]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__10b47290e9fe958d5b1131a45cd59897d31ec41a6a419c73a2314911d9d43471(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8fbb7ecb08f28863e6f2ab03a2801895a7be231c6485dd6a7a8defb48cb15143(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d25bf2da94dda1cfb78016c83d00ea0f0f82c1fb94ff1d8f76a0f0540dbfb551(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f4b737f47694d85f531bb8515ad46dacd4c1a244267fde41fb975d49eb0843a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9f9286b8e4fa517450ff7cca1c7d07a81e5b221fec0398627e84105c71ba9d04(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__45ce930923ba47adf0f42db2b48f20148a8bb03f37aaf9537f0ddf3f86b43e58(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6d5aea4ac1c6fb3d909ed9a749c87b14e193b780afea763d391149b699c18557(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__07edbb2e7094706e896a3869e068aeaf285c2a43d7a366558a577cd7e07d02a8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0aef1d3066ff27beb2dbfb6b33d37cc8f2458cceac542ffa0c91351ea41fd870(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b3772465934ab5f85cd78e970607676da9ff907c2b6e151736b6b26d47a097ea(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fca2b5b97acd26030c3aa07901879f81b958215c21cf7a8210388eb6c05680b2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__69ffc30c5f63f6ffbf8aa6dbd1c27b23128a390ce0a806fb8f1cac7534bf7af6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d1a5cd571ea40b431778e1fe9d0a0a99f3870c1ada2f163fd56b5514b32c9da4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__742c45149ea096925347e9221458544bd863ecef01e54ba5ab444cef67b26796(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__934e4cec63218500b5648e802dd9df18ad045c10956225671231d1eb736265d2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fc8914eea012ccfb6eecaf52d9a91ae6fbae1dfa833205e7e13ca3fdd0bcfc4c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeChromaKey]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__147fab6bdfd76702551eaaed540a4bcbea6ad751e1acadcd107c614e6de1104c(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeCompositeImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    placement: typing.Optional[builtins.str] = None,
    placement_var: typing.Optional[builtins.str] = None,
    scale: typing.Optional[builtins.str] = None,
    scale_dimension: typing.Optional[builtins.str] = None,
    scale_dimension_var: typing.Optional[builtins.str] = None,
    scale_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__17494e3047bb2e40b30f17226210ee4fe5ac6f0debc0067625c508abc22a6c13(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f7c13bfe5d54c243dbff6850f3421e397835708f19a64a114b47e13ea298c1ba(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeCompositeImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ed96e6a760678db709958ad1678861a76e735124d3712bd58e49d1238372e35(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__26dcafbb9d0f7835e9854025a51742ed9b3bb96d5fecf7947fd522fdeb87d5b6(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__805938747ce0ff3855b33512005296260574b269e4e0c9e88f8b77e7617b1ccb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__422ea4fb23a5cdc14bb3233bfb062ec687c176d20190844f08df0ceb9fe9883a(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ec827606da7decc3429302467f93a1f086c9ca1c11f8e85a263949cdca5460f6(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b100118fece193297d8f81cef2e0a8f36f62f2ecbc7120691e285d97e063cc03(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeComposite]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b5b2fd4798c3682797b92a6f84a9191ce391bb920c52e9e58dc4db3301e31bd9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8ef7ad5ec46a315f39ab422fcb50d95f6af383327f40a59a4ba3adc8a64b7018(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__46457dda3f1ecdbf0173a9d3088e4080ded4858f53fc1938b5d4f7033b106d62(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__58895d2d668540965e6723992bcf51b55d362cc908f0ed2e441e37c2942c6175(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a3cf90d949b38d496fff7bc5fdfee394b72569e0ec65413ad888b1a57a0ca7c8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f3148f2adbd9106e4fc127b0eb245a6e5e2c8b7f120f7a3ccd922d304405fc7b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a18dd09f55ebdbaa3e51497c6ca48e01afa792463e67ec268f35eb699757a612(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__803a478eea620c2f4aea101ad2c139ff61bfc08f94c9cd390f3f86a25b3258b6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3771d5b2050a918e79cbe62b26c47dc9d930224f9b232a579d3758104cd9e715(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cdd20ae0598bf4f5ab17f688f6dc8e16a290db959dac4c00aeb777c46d9d096f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e568c7471bca4a5fbdb86d8829e2f82291fbbfc64d5140c12039dad4e8541620(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__efc6d202166791dd78e13513ef818b7211b1237c89a4fe8eec43826e991b01de(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a64ba81a4e35cad87991a732732b14b071af41fc0a4b34248690b8a5a8a6e55(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f4dd770d8e555b90b8a1a3dc06d3047119d172ada0b00e766cb8061425ac3d3(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeComposite]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2740def14f2701ee5da18b8af8e13a33165b42ba81764899ba080ce12b5f1bf2(
    *,
    transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8deffd8b583039e63c027a821cb1273c49a0f8fcbb588d825991f39bca32bcd4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b19f8bdb79a779ccab85f101e240a4ca82aac7900c152b2012d0ae1f69662bc8(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b0877ba3d26192e5c906428398c18024927846ed63cb1d368897296899d219a2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f454d810622615ae6012527ef3899eb241e7a1fbb08c2ad6dd3710de449934e3(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dd8426ea6cd6cef26bbbca953d614a5c0f3f6ca31f0c7dd4399b0097edfdfbd8(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a7d3f91896ebdc05f7810c62149bf7eeca9819c587f18779bad7156eac8b92f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeCompound]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d06ba39d40ca278affef3c508aec59be25615fa1cff7a561e63475be30ec5e4d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ad5de9a8a4d6b5ea980903528a11f4e1239602ac2ec93a735ddd912a49545266(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c4577ff3e0011d8108f5d5ad34b12fbf358c09f162328421bde7033fac3a4a5c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeCompound]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cc40d549e22a1dad7b5c11db7f4c937a03a15944cf939ffcb9eb034de8ca7f0a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1be255678a79f227602016f356114de18048cb2d60795c7d50818d738ca602c3(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__42ca61401b67a870b796eadc8539fdc5bb7a4abb56531669e04090d0ed5098a9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c1dac3bdcaa245baa59df2ab2ca1b6ccf5ff6361e60a4a2818723ce5bebb5c8a(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__190e60c1a24288cd90b75de46297b1048ce1b0108cdc693cddec35397a466107(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a3a1b34beba6aa19c68b6d1da5ddc2ec8191e03370876a6c9e42c549e922f9f8(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeCompoundTransformations]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fb00181974fd7806be8e27a7995ac29478597bb38bdd672a162539149235784e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__049d139f40229960a67c9549e782c5b11b071ca07af6fa59339fbb8be5c42a6b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeCompoundTransformations]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__65987736f2f0658b232a81d1e3674d56ac6734fd7a20694ebcb0ab7405d8b5cf(
    *,
    brightness: typing.Optional[builtins.str] = None,
    brightness_var: typing.Optional[builtins.str] = None,
    contrast: typing.Optional[builtins.str] = None,
    contrast_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac0efeb1be68a4d27ac7968706a66f7c198d7101c8981b2ea2a771f880b3acd0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2147017bc9f8a9abd9c22dc66ade8d8bd3850c4930623ce553a2fe6fd8d7636e(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f85317fa97a55e26ff94763deb056986c6bff276066812f62c794352dd292853(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2f73230bdeb897b6d93801ebc98a26d46632bd3aa956b80ba2f95bfa103c5992(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8d1b42e3a22e7dd58c97ad397592be333c9ea03a5311fbcce3e09860ab4c770c(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6c73b33e63dc344edc0c94a84791990d0603eafe06df4e53586f2aef6357deb0(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeContrast]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__39bf37117ffa1e6012e96ec0138fd23912c606abbf3163fc5771d1e4c08710d6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fe87ad330e04aad9244192e65d5a02d322cbbe0c1bf88b2b6e8538ba17baa942(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__677c7b23f6ca7ff7dde480bb2bb3beb56d1801780269b1c4cea5155697c22e23(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f7943ce7b83eb82d3b59a3f8596751dff6b4bca879be8049d8edbe80a23c2c03(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__969a58fc9da9618ddc961af01492f917c828d8f096a43087afada8df2e080c0e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dc0ba0027fe8968ad9a8ae2e1db7ff267a534fd0d4c963378eaa6e4503b50bb2(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeContrast]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d97333530d55e371a3bf22de57314a725279ad97ab2fd8a46c050de4fa80646a(
    *,
    chaos: typing.Optional[builtins.str] = None,
    chaos_var: typing.Optional[builtins.str] = None,
    density: typing.Optional[builtins.str] = None,
    density_var: typing.Optional[builtins.str] = None,
    power: typing.Optional[builtins.str] = None,
    power_var: typing.Optional[builtins.str] = None,
    seed: typing.Optional[builtins.str] = None,
    seed_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__74b034ec479f9c48754cf7d2192f3b2d2ced0432c30fcd1592aaa8a034797ba7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ba41a463a103f99773b645b538d513adc6cf639bba8f21fcc117c3e163011a9e(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__70cb57ee280e41bd1f6b39b619f2787a9cbd70aaa9e6ebb55b3711e9f533ccfc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__36f6ef2dad66b873168decd3981d7b19e2311e57256bcf7d8fd156408ca0f2fd(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ba1113b0eba1fabc0b7b010565c734b421178b241a15d105c3326e9cb40df2f4(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0fd4ce7d90d66f2297d213f34a30ef09691d0a477a74bd2a5e59883234a75b52(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeGoop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d22805551433b4ab12c4407781a03064c82ea18cf6dfb5b8205314c9a8d9b48f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__306ce462bc009be671a2410c9bf122835df99eae49bfb500f67b578a6b514ca5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c4afce29e6ca4d5588a5e407dc6ec9b7ce7514e7990c6643bd8588d2e12b7576(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f3589f437e74f30b08afd52da272b5c0585ad718c3ee0cd42af39f1c34b40ad(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e5fb7d7c7ca3fe10517aadd4a8b4b9e447fe2a5bb6c5a08ea83c1991bc00ba98(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a90872fe948c7f0a5818c9bb01aff7eceb6fc0c922ab320af442349850549a24(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0d1ebaec1a92a1c05a43cb211c42f79e7ee19de67d37241d4f2f2699da54eb67(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__41ce1b088735c45c46d88c83ed10064bf9d1ce0608b28116e486908831b5494d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bfbe3912c34689c918ccde8abee1e9cfc29875260f4fe1bf16afb89b25f147d0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1e740b3fe77be36c8f551ed0e903d197f8077f20610040cf7282ac3d9986cef4(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeGoop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__098fe338278841e28b59615afa16de5e8c7a1d6597b83f7ca83ade56f5565174(
    *,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__47bd750f8b74856a0a49858d340f0a49068e06a579ab741279924ea0226da0cc(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6c1e28663dbe107f366d72971cd9fc25ba555b9421369bf3ada35b805c5fae4c(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0b0089bb347d4bc6581642e0419bf1d8b1e40f5c8303bbf19760ace3771bf73a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__456031cfd0e58541e80035345036aba667bf8031288af1725653ae7d31319be3(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c677691d834e2ba5b496e1fe06a088f0e720243395b16340da17f2307a6fc821(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1dae1037bf10bd8a74e3bbc2f495231abd44a077731707eae90691d553f3961e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeGrayscale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__60f0e5a14b3dcb0baee1c3a005aa037cb09d231ac92b6ddcc6f214a501da1169(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f74e3f86214fd4722fc12ac1a8f9388306f97af92e85f36f4c985bceb7e281f7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0943fe4f7eec77eaeedd9de5482db8eb280c07ea979972524d2e82abb9c7e378(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__efbe190248911686bb133fa2a4101cb79b83d8c07f7b171d1fc3857b05c39ff9(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeGrayscale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8797d31387bdadbd51a7a9a11e3f5b656574cb3a57d7b715baa31feea4bbee34(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness: typing.Optional[builtins.str] = None,
    lightness_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__041db53f79574d9e280b1c955628fe48436392526fc16e447c140a8d1c0826e5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dbf062bffd5d9c3203e0935563df4a76a84b83e277f73413c644b540f2021ef7(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c43821d815c617bd6d503bb1d84a2369db2d2536fac61918212e5fbc8151df15(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__42f71b5679e26666a205de23da96cf4774e496c5ab10e4b99797006531a7ee14(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e33b899b6d19f5c273681e486b38700bf19cd132bc00bbb7241869c6905163e1(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__de1797f5d4fee475af8efb002051d3ded124656744dd1a7d881742e77e55c5be(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeHsl]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__74c1b01a25653f41358bf8e0125ad48b99153b5d352854d28dbac83b2a85760a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9789d132232c0e31c07b637eae85bf57314f7901b61cb83b6159665d41fff98d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9f558c3bb2d15a38717e72c70ff723b59d0007c6101b286c520dde418f6d4995(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e2396419f75643b1449c73a8a66cfce8b38a8b871158f5f3954d10df4479f7bc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__57a8d8a0fc1a9ff81213d07a5fa4271a26573ff4b4ca1ed1f38dd75743c9b35a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__61ca194074aa594b59fd2f2f767344a3d7000cd29626fff93d1ee04fea3f0dd7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__790b8f3db1e6da7d90ec5028b80aea578a990b80abeb5334d6f8d4cd3425dfb2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2e7acdac403e902189467b3bb6ec7f7b59d9359e527923e0081dc39ce819a2e0(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeHsl]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__25cc74c0df52f0fa5b00d6b386df9b43d583b5d71809d2e8ef436db6bfbaf991(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0c6448965193b926934587dfa6e77c674adb9b6c187b00e428ff79f5e5aa1870(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3e5108e2e2f266913f2e93ef8847f3739160202d7774ec1979d43bd7d76012f4(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4d1c0cc83c1de1a875d2115987b1feb12dd15337c6c2857a1fff3ce8acbe1ea1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a57bf488b7825da548599ac5558c2a92e71f25c077a413f281e40d0431ee1d6(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__abf2167a532179a04785b38928b0728c733a229bd69c06d546e8d62c6e2bf776(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__36c7046a9a38623b62a63c7bfd1f9601bbea28ca44e27c16476b2b2e097012f7(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeHsv]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c903fe7cf7a82c43ad206df27caf986f2bf871603a0a9d7f048c04c324ee99d9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4578d285eeae04690fdfbc012cf7cbe16fb542bad0d1fe936514f00b9a5ea7d6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fa2b1f1cbdc9d5c24b562744c25790fd4f93a4ab13ad48baa0fdb8eea5c872c1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9cbf93c15cd7e0c088fdbd68c09fe4bcaba6356a096c291a2421ff3230b8ba28(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fc6cf4c10989fa8310954e93e16e1c04c3e713cc9e56af918cb7fd7cde5ea085(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6774595ca4d0a74b5187f5a7e6eee755818e8df163aec8b8e1d4248e9c4346e4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b3525a81cf7646556476c73c907e57971f3e571bba53b5fc3167109928d9b852(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d643441e61756f7c582357c2241238244e334926a5d0ee22cc1c576db767790e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeHsv]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__96122eba667f4949913412ff132c787675dd6dfa679dad9f5ad35f9d03b2a282(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfDimensionDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    dimension: typing.Optional[builtins.str] = None,
    dimension_var: typing.Optional[builtins.str] = None,
    equal: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfDimensionEqual, typing.Dict[builtins.str, typing.Any]]] = None,
    greater_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfDimensionGreaterThan, typing.Dict[builtins.str, typing.Any]]] = None,
    less_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfDimensionLessThan, typing.Dict[builtins.str, typing.Any]]] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3fca683ef02815840548c50fd56518c10bc45698a19d2b8264fabf3a3a953b94(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__831628e183458f235b31fe4b85ffec963e8b1bb300417ff78b00a96ad4a66f02(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfDimensionDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9cc4f41da40f41b48a883083410d17292958193d709e5eb62e7a6aa47267b623(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__622ee749fd03da4cc84e4346f0d1a76ce257dde414ad1c1f387345c2f52199d9(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfDimensionEqual],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__57c0b080e50c00532e81ddaa24070d4e1e811ab9c6afd0aa2a7f78c345651673(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__088382abc56ab6c6395f820ad60243c5115e88083b9f5ebb8d6df633dd85c8d3(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfDimensionGreaterThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a1db9c9adc42665b60c905bc312f124e5dbc950c20e785df031352af68e89963(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__24b444cd1421ecfece10df09d2739819813ea76a0d60b97d0ed2186f95d9b88d(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfDimensionLessThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__03b112cbd759d059b55e5d12b7e4ca441f8882b6c49885cb7f1923071e16ef22(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__63c5eee3cf1108a9a9f9a3c13b929a8703b2c6989bd35be7c1b33f65ebe6707a(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5a1141a62e8bd3e1b2b0bf9c4c5f3e4ef95bfae89e436589d67ab4e3bc0d6880(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6d0ac6aa5c172a2243770d636a21d80a7348c8d9b82096927b35ced469181b18(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__983f7f8fce98282aac9d8052f882476e8c0ffb8ec37f3dd1588af6873355ecd3(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aa892d69c7b24a4b0ad3625b6078747026915fad0645e0e72614e97e76247252(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfDimension]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d457d645d039d253c471c3eb6889d846cffdbf3bdf162331f5a47400ed105832(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a3884425bda1e23363dccb858ecd301cdc5aadad02a3eca638d72573c359ddee(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a0afc2c3e3bfbaad149358b4ebc38be8fbbea3d4f3b1e9ddde0e6a5b159a4f18(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df23ea2b014ba91753029093f4ef7e22e393a7532c175a03d644c2d8dadcecec(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__78a57bbc16b25402914b8b96d758b642feabf8fb535e9aabf1a93d2893c880d4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__33222cd1f6bc5e4802835d1538ec011136c07548cdfdaf41a493ac9fe2a58a73(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfDimension]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__583178ac0c42de626967fad0630baaad9ad58244a9d360326e474c91bf87d470(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfOrientationDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    landscape: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfOrientationLandscape, typing.Dict[builtins.str, typing.Any]]] = None,
    portrait: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfOrientationPortrait, typing.Dict[builtins.str, typing.Any]]] = None,
    square: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfOrientationSquare, typing.Dict[builtins.str, typing.Any]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4d9d94d7185b497052215c6b42ce4299a246f9615cf106f1a64665de1548a374(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c9daea9982e26431696d9a1264a6a043283829b78befb335d9ada2656032b25e(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfOrientationDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__78f7b8df4f140f39bc811b2e272ee9fa43ef4e5b2498d5356d23c10c16629c06(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__301ace19effd3a5af9f200ced929a1e2635658ed471597668deac01e252670f8(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfOrientationLandscape],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a1768e3736b3aba5781dd6671b63e4f93593c19458918df3a47d4e8213ecbb55(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a7fae4a5661c872264cc9bbbff6ee30f97522d5438a638f6dd39871bab4245c9(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8e6dea3a9b0ff065d8f18b7e87a3117303632298fd40fbd494edc2cebc35b132(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b18a12c6b139dc5b1ff87cb7e693aa7d2b905a443e75f0300c13693c9f31c9b5(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__39720d8bcc962041e4433cf45ab0dc9d41a5bdd2b8a2e9223cc57b567978b7a0(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__67e6eeb0fc166e2dcfcd86782ebd14b970e3ef66ec04a68f771f5d8d9c9ab38f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfOrientation]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2dd4fbfbad9f817522f1f741b8185595f314ea6f5ec545b40a5527bfe6b45caa(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f4955f939b761f7432be03c72ec7fdcd6836bf6e348ffc56e2668b90eeadffbb(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfOrientation]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e257599298310f12c5a68dc3e08edfdb06ee78df3e47db4b710e0fe0d4b8dfb4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__57e443541087a9639db03e6461a0426b393c55802d620b75d596699b75798672(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfOrientationPortrait],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e92db97ad0204d42affa43dc4461dbcf046426cbd8f64a6730c43df61b39e122(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c5ff14b76572b4454156cf1c98f9f3857b991a04e74082c2a08b136a164a3874(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfOrientationSquare],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0385c97105b540b48aaa74e11f4879240712f1575171b82296b9aba99777362e(
    *,
    colors: typing.Optional[builtins.str] = None,
    colors_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8720a2b79a84ae8ab9e50119dfec9b1d5aa96a8e6d11e0072541e1137acdce44(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d0f0f9b8f62092408a82f6defc4a9a6772444127d1edc269376988976fed855c(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4233c7056e550f0016a8261b55eb5bb5203490f2c2b0814761e81bb31f685294(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e46b44fa941c4d51263127848f31f09697668a98ec47916d080ed759dd9c8375(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6820b1b65b040a72664dc74bbffd5278cc1690dcc4112365ad2f52c8a482e8ba(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d8931c2294868894aa71e9ac59b767d2b9a517bb31780e25cedc90819ad85f8(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeMaxColors]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3d171caae1b3f0e83c1297bd0e53304ee89b32c70a33bca0f94d61b5ad5e1cba(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__03ff65bb4899869bd32105300c07f3f60d6e4c330ab599444af6c9ccdfa4f093(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fef29891c03b44d48f1e902aed92d4de62f4626ee5664b57b7f593936d6513fe(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d771f69e2312cce29497b6569eaee1d30d29f78013a6d590d7885a6228b910c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeMaxColors]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4d2152bd662dc10d400175830a3bccd445aaabe10546b6daf90a9aba06b35d82(
    *,
    horizontal: typing.Optional[builtins.str] = None,
    horizontal_var: typing.Optional[builtins.str] = None,
    vertical: typing.Optional[builtins.str] = None,
    vertical_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__97b4f7b81beb7e764fe1ee7d734cdb305d8aef5ec837a8c64702c4629a968b4f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e10f672c2aef6778984ea98f79d7fdea62d2f7f615af151fb5198db690963fb4(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d7ab0418dbcbcf4b99979fb8eab57e95793afbcb78bff5aace82c02142a3222d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1a045bef1acc8b046f3211f290d9883a7c4d28e3b0e5ba64784862274c7e2fbf(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__84bd9afc85714c32d11a3189218f10d68af94e92225ea6ec68f9c36d03258e18(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a7f7f3c633ae574676ead54c1a8c60caacc05739204dd47759ae4ea17b6ba7bc(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeMirror]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eda941b06d7087ebf9cbb51871bf9bae3cc1ebe6db37910d1af3e32edd3fb430(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9b123e2d97cf95e9830f32dc2063a3465ac16a2fd14a2c1e047a35d5901a4bf9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f1c700cac2b1927f989eddcc5af52178b0e8126c01b3ede050162b5f732df385(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c23877e9cc8fabeccac280e55dcf09d34652eca281477eaba073915c70876c89(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a3e22503a36060b60d95786088964cae42ac3052042706c6582a7cd36c212689(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__285a6c0c736db11f8ac002fe1cd539cfff7c5a7e6b0193748e9918699d075d57(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeMirror]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e7c90cd880dd5b21f788c7064a734119b68e135b1c3dc6f564a2c848d451bd7f(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0a0fabdbee03fd6e112b07c4e6c708b1a9c02e5315d2ffd8d6f47ec258a52f93(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fb34ea444077158040d5e5af0f846272878cf5238b1e0eca16f3b2020f46b036(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__357c0a6806ae20bdcf98395793d1140286688bd77f6c3642f32260e436c91a85(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc59185b03ec7284476ce8514d121988558e41192d213404cac19ac4259c9e5c(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6595a80c3d3267f7b5ca8a9639c03cde47777ef9a4c954e19d5e1daa6629b550(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__968fddea7c5e85827c158f111aac70eafe5e4ac18c8796a46211b41c6270ce5a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeMonoHue]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea3905c1b220c63845073ab0f7438c3fe3479e9f39bcb92f13ccae34f9b38cdd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__60a8c54643406fb6adcc20f45f075b1bfcbbcc6ca5ec8330d0fd5705e9806f8a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__41938d5d931c70c66b46a838a8e96a91e1d9fcf766085df2651ad74e4db4864d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ddd29dd24cf04cdb1a9d7452335f1695077b8597fa7e2867447a505741329a02(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeMonoHue]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1a2dc1d6f01363b774fe03cd5e7b9e37f692ba97a9964833854de8a5c95c5d09(
    *,
    opacity: typing.Optional[builtins.str] = None,
    opacity_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cbebeb51ca810fdd7af1cd396460839a8acdba29d4bb58fccfc3d8b03c79c93a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__70bb5841a2f65a00b6c1e6336a74d4e3c50159f1c1c31ea871276192f135a0be(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3d2ebe6c224ee1c823c75f891c33627e2e45763108eba8c8cf8341f956670785(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ac1cfb5978326497c6e746a4f00e7a348bf01325caf9e94783c00553f4f6a1f(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ebf86acb821f4550430ef37204e385d23a60ff72f55539da5a1fb4e8f738edc(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__90ad4b2d5f32f008c31518eb7fda076e331b56f6528e6303bb893711e19c9649(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeOpacity]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3f9144d531ac04a671df28e1bfea9f6792d082435338e1ecec23da0cbca01af7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2e6d2ff54d76511216b0e1f011b3c31f62634a3ae95140b32c337fa8a3121f86(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b23b3bc1ac7f2d56509a955de4c4ee1b3d84fa4b8b21be813d543388cbc43b86(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__504919608a2a4a46d9102f0df214d4a845355ce115c9fbc77281eafee012ad1a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeOpacity]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3aae944c278310fd60eaf9750834232d5e894e9015bc13fd446e3d4d0331c075(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bfbf01c7d76a391f7cd8f798724c7a0fc16d4368a301ca93c736c8fff4a9da46(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__06ff82b195253ae005f50e92f5e125e9a079e3fd3ea992d6ec1ce4b768b927c7(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeBlur, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__47199bccfb0787ed60d340702294a936cdf7ac06d53bba5b0e6a258910217f91(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeChromaKey, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7c3b1566ff990e513533e843440477d0df2c2c58aa9775e157475304eaebf695(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeComposite, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__384474008c1bf5af6c0c43d194f97ca8511f0c527554e34c9be01a836a0cfa83(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeCompound, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7e5e0027741af079ec98cd98ac22516211d6d50e53d1b29dbc69876514babea2(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeContrast, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9c2944f6e0a350d2ad01672ede43ff975e7683688cec73755159ff800c5bb311(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeGoop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__46603c5843dc7f14e8c86a4e309c94f4f753fe2867c4c3b2a55fa88a1d9f55cd(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeGrayscale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f136ed95e7e452efa42553de368d3354dbf29fd1ddfe8fbd476a2229d1ffb432(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeHsl, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2bee93dae6392732c05ab7252c5328a9419ccc1595153d8e1c11088243feb152(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeHsv, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__54af1d05d58db9bdefd7cc4634b9914646e1d2a5bb9b3e1271a8454a6a4cbd1e(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfDimension, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a07972f780a43f8bc56306ca0751eb100a3d829b593998b5cc8b657a0a3c8a4d(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__282e5f806154f49fe8ea70bdc7d8040c23db82eea3225434f447380d9a9d6f51(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeMaxColors, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__659a3c0c995c3dabdf4b5f4e9f9132bcb0a11ba6524076a78678727ed8086b82(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeMirror, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__17a55cfd7696d1f12c79c5079138f4fc4bfe1b2e6a251a5d9804cd6d6a161568(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeMonoHue, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__293d8eec744b420766f695080e9426d964fdb06f2e01aeb46455e5eb37fedd73(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeOpacity, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a5c7bfc76efb97e700239e456d0bc7bcc528509e9af8f48f96b4de599048a50b(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeRemoveColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a36ea135a9c73404bce195a540572b86bab94c2d0218e70d30c35c48dc095e3b(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeUnsharpMask, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb4c58ce2eea82dbf053e88eb0915fc4a1ad433854b8283356b061c31338be02(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscape],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__683c83ecb35a6b59cca3f44144c6c0ae8a260051c485fdd347627a89194b8c65(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
    feather: typing.Optional[builtins.str] = None,
    feather_var: typing.Optional[builtins.str] = None,
    tolerance: typing.Optional[builtins.str] = None,
    tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__470eade09498e8b55bc7819b43a807a45c46217094a05f55f832141a75800672(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__91731389016b722e8d643fa3f3edc04869c56e2091017272fb0e20fae6b7fd9c(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__840f0f67169c582f0dcc28970dd00bc1c1187173a8d6ca6ad0d4be763819bef6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b7cefcbaf418519205ad8812f3820a1a1058ec5220371f3227ff4f59eab6079c(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1559bb09353312ee976695cfed6b0e375ceb1e1ad79c64b0d7d37ae9eda935a7(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__830afb23def1c124b5eb115e4c903e25df378740406495ef47de443a1817db70(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeRemoveColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cfb108b20fa71963459176d04f7de1a32597a078c11649c8add7838f417ff31b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9fdaa71fa328d8256bbb24588b737910829d01f2ce75409492e3b4c0407f0bdf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__19117757725fe870d059a2405068c05d02f74bc487faf83a00ffc0dc8ebdfba0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b214a0f361fd3ce6b56eb4c8c58fae57e1e1c5882cba69c222bed6218c65a141(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f2bb6d97f5e31c25f772d6e537bee8c7ee41904b4a56f51ed3880451e77f4ec5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f76ec517bb654e14a107b287bc09b903957b32cf0bc45be3ac33a52221b77194(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__28af722ce4ff0326a865f13041ed394aef1d76b8694c531246bf316605fc4fe6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1b0739205b5b46c477e468bfba5984f6c9c4ce716623dc0d71568d34d0f0fe31(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeRemoveColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b567c20cdca9641d6c6520da9cdb90818c158cf915de3d259149418ddc635876(
    *,
    gain: typing.Optional[builtins.str] = None,
    gain_var: typing.Optional[builtins.str] = None,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
    threshold: typing.Optional[builtins.str] = None,
    threshold_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2163a2ab82f5a26a19b761e1d9e1429a733dd5607b6b93c1ce3d23cb6d4139f7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__caac77bd9332127cd411ed86752862a07d58af8572ffa48f2953f4e7b1938cf0(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cfd28fbdf7200955435429dea15c79c5504e39ae7f8fd4afd0a11a160f1498be(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3c50636c2c430a1e0444612fea763697343a90a02b329e42bb5ee00709cd4d77(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d11f09edac3d3910c9ec7b00562c1977fef5f6ceca3e50edf470540c8310b0a1(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b7950538f436bda049841fda222beeb919d2a31bb07f277357fb831d552e5215(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeUnsharpMask]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bf65ba93aae467c2ae4979d31ed7fc414cafc9f39af1164a158db4a6f77f7691(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0145762261fc5039c49b68df671ef2f114c0e8c3d08db1bee6422f3ef5cd7df8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d2833f2d63e8044dde86d21d2ab12c417fa35fc6e9986c9f532c9222b2130ea0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5c6b9778495335fbdcf1e1be1e41ec458c91f9816a736f06a88c6ccf68b72556(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__719de5c2d65bfda2a1c18333d1fe79c9e33753cb79a04e26595163d5bbdbda8a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cc2d330d813d2e5ec2b1a9bb783c1f8c9bc21f9fcb8f796026a883a7c4bda35e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__59bc5a1d8d7b880193e631c29122dd9b5770f02e2750994fd71ac6b5597cff2b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bd7147ab15882c9648ceec89f5e724e05ae4cc92e747159fcc2495162ea082f4(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationLandscapeUnsharpMask]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c580c193ab339df9b6194ce03b83d5bc5f5f4bfd216354a8262bdef953fe24a2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0cb655c712e3c43d1044a4e18c99c2044110f7a1f901da9b362a488fb32152db(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ae5b22a927a742e77f7a35f3bc688492d7bc3498945459309705a143c967a0a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dcea2a95c76c6057c0fbf2cd4ffc955cae9146007f0b91eed478c69633f65f83(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fcd05c2138fcdcf51a49b7838767d261f6f97190ccaa315d6c7e209d334ce30f(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__faee4a443ad525904bd614181be081a832959b7af57583d7e6c6cf3f814831fe(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientation]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fb731bff5072687eea3cbb77c1f7e2689706fb46515d8543664b09f0bb76d9cc(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__97bd561364abc4ba59624763d34354693f1f0e7cf62222ff234102a45b052ab6(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientation]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__942f97ab6fbd22d8e623587ef897ce758afcccdb70bfbeb41669ea63a21877d0(
    *,
    background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
    chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
    composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
    compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
    contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
    goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
    max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
    opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
    remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ccc73246e9f9ccfc5a7d16c1be32091c21c1ab7453ca5e5164051a1229e731b(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5de58daf0d530678451ed8ad0d932ef9cafc978fa7d167dee4a40bb0082f7212(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d0e5c2ce6eec4a679030a2a3ecbbb700db8fece8041e3019e58319e61f012b7c(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ed18aab7668a01e122195a9e21678c2e4e7100e60985a3e9724a11ea9389bd60(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__abbb2401cf8469d03fce7f3d8e1bcdf9f1625d1d563b1b0a19626b0260864416(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__baeed38b45ff6318a77bc2a9595c2e2bbdbdc0e1a8e652b6cb0fc98434c7ddad(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f3e8d69aa2bc8440035a3fb3df7e1fce69ac92c01fd6d68ece9e502df37e569f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitBackgroundColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fe927e42a0700f1412a7234352a356724df1e67ed0510185a8125c010cd5d438(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f0a2c483663f9906bec0ca905f4c5b0a0ff70d470df13093d144fbf0b76ae269(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2b1986cd2cc2e8106eb5fb8a083aed67b9d4562cf7c7cf918fff51005f5b3e4d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b0ca64e269fa38c00f6a4a2f17fd4f50c3bdbfb9402c82daa4908ae84a7657f6(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitBackgroundColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2daeb6fb3866f59dab8a975cc1fc0195d9f198343ca144b8379abce43ceb2a50(
    *,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4d1fc936da646a2246e2f16523011e9311a9094075480997a3db0f858616ef73(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b4577ab0f2e9ed74f72fd1c57eae732ed4b3a8629fd5fc8ea07d52879a6d6955(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8928c97341c3e15a7509e23389cc42af7f10feb49826d0f5819b4e99c9f0a774(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d34fdad195afa5ea4feb106ab4ed4dace300f6aa9b9ab8c7c20daa232bfc75c5(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__daf9d3965116b37a7a45fcac23469f76684a01609903e08558133c1379ef0335(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2645807a81d3a0a8a2ace914e8f24bb28906aadfe8cfda1fc874ff0d23ae32d1(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitBlur]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9f26ecb14c1d33d24b64aec86f6128a54a64173d8068bcf6b21139187454d662(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bfed10ad345ea729ee2143fed225bc3e0ddd889d2e9de66fefecf09793a70699(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__27bee2ddcde0e0247906d404dde9562e24f110c391ab8957a544d161797591b4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0deb93cf980534b7db2748a6b38a8d6206fcbf733421cc8f68259b7c0edd704f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitBlur]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4c7804aab33ee264a5eb73998829b8a298d753b39fa2600de5f00e5db0bd489a(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_feather: typing.Optional[builtins.str] = None,
    hue_feather_var: typing.Optional[builtins.str] = None,
    hue_tolerance: typing.Optional[builtins.str] = None,
    hue_tolerance_var: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness_feather: typing.Optional[builtins.str] = None,
    lightness_feather_var: typing.Optional[builtins.str] = None,
    lightness_tolerance: typing.Optional[builtins.str] = None,
    lightness_tolerance_var: typing.Optional[builtins.str] = None,
    saturation_feather: typing.Optional[builtins.str] = None,
    saturation_feather_var: typing.Optional[builtins.str] = None,
    saturation_tolerance: typing.Optional[builtins.str] = None,
    saturation_tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b9eaba923e72866d669bc7091d8c1f6cd1b6aa162dc100f0be2855cab30bce8c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0b5b47e54d8822c1a89bf455621d739099882a9f3df23c18ac617968aa7d4f53(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__566b3a300f560044f3189ab212016a77dfe645065fabf7c681613e38606a85ce(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7c37cbcf1d75924c839ae75796872a7046a20e5a5e6531a57d9b0aec644ddca2(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__830e2624706e5312e671894947b5ea9bd2956aa3552012c141166032c5cd13bb(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c3d0f106a5287f93ebfc519cb39a90a393fec512ef07de5b7c990eb2d05aa42b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitChromaKey]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ae272248c224f609f7ab3e2e49241987d8f2f83b7d94a295bba489f325bdae4d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__882f3fb5bb078f28ec488ea3dbc8f72232947ebf51de39e771b5f7c252f22d45(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__89682f1d5b7c7ca697b632308e9cb6f8e299016fe1ad1e95f3696a2c3baa50af(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4457265c5598b04082f99fca48fd461b7cee52ff19c9bdee15502bfdf53fefb1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c34118227668968ca1bebe1d202c7332eda8de4ff12242334f466773aefc7bc2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__75153f65e4ec41ffe09921cc4810be69cd0f2f1ab4ecd3b3e3c419a408db30c7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__80fbe010552e3dfe5aab781065684fc7e362e7cce48aec7bab756c1f83b32795(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__09b9c754c52f38a6dc65946a98f3c18aee59574e7a6d32b362da3b060628bf61(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ded47ec1cf40ea8ce4b3f58f1c414b93fed517525071c7ee3b359eb89aa72c65(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ba13476013827637d80abd629dfd157a14a6902417cc0dc23b92767637beea1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__08925bd1bb8adcefe53e64999672bad2bee8e270617b35efc6a9587b153d533a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ceafc20f632fdbaa50433cedb886494bfbf6c5bc825e1a679e6713d50a5fb3c6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__49be3e873c4fb30367bc6ebb629cc2020c7b83e81e982ee21896c29d86c26928(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__72c6970c06ad1b2403f75618c9ebcc200ee30309b335560457b1b3bad8861650(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a5206f1e258d770b5d129d55dc8b38a269023f633a458f37f1a2feb1c1791dc6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5addc19f9aafbeee9032cdd39eb016fb9054defa066eba7a236a100bb670c23b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitChromaKey]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bcc0f6701926c3ed1c19948a2c57197ed97625afe8730b110c26affa803ea4e6(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitCompositeImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    placement: typing.Optional[builtins.str] = None,
    placement_var: typing.Optional[builtins.str] = None,
    scale: typing.Optional[builtins.str] = None,
    scale_dimension: typing.Optional[builtins.str] = None,
    scale_dimension_var: typing.Optional[builtins.str] = None,
    scale_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f182256c1fd2db3c6c279d154b683bbdec0628f1c06b3f25a9f4361b1fae6e4c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f234b5b6e5ddd8e32d62656423d3b6f1078d07e956a965723cfbb40208250df8(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitCompositeImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a42c8a4fd321dc05f20b61755e3d37cb67774efb7b7de98e11a102f242667a9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__beec97d6e6f6216f59f69385a9050e8be7d818785ca6a12adac6c22e3a9f9681(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__47cb2cca3796b208a75990649a4bb29be9625ea9f820468e9e7fd2fcc84cc5a3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__03e893e58861de872dc3fc465538858491f5d184160ef4ee71dc5782f59c0735(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__07e818987cf68d51532ce742c87dbc7422fa460b1dabcd8307647c5932f0a93f(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__598d98e93e8e7912782f4f1f09d0b6ca704675f237732c8d501712b8c15ed848(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitComposite]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7c4c319dbf549b24d5419508dd94d2b095469f5724b31e25994836d4bbda8be4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__15601ab0c405f606afda5c1fcc5493a7b1b57f978694c9d7eabf4686d1c14708(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fae37c5828e8261f9e09798ca8ff0ca5ae2106d5f166b78a7963b9f3308fd251(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1daa87d01c53f875be494d5c621f8c0d68e7d76d2684f81928231eba280f7789(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__340621d37be302d53b9df298be23f448d6a1a1a0f0604e2f9d32223965fc3b8b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__467382f1cf4982dba3129834a0afb3810e34378801f6f51695e89fcf30f66517(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ce55dfc060eeed040afd1f8d5573cd5565d4008bcf1f11726a557124a6d8a0b2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e7b8748f6c48795a10be63f8f5e2223cdf16ed0b46a6ffe0c82f011d7917b782(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1d0dfa3bb820086e2d112315b4fbfe1504c5cdf9eef759a933a7f1bf41a01533(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5314357a48caa037f55317d60cb9b957342eb4c1a7fbe2744fc61d93cbd77036(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__51c9df50f30dd774fa902e2a3a234001cc02f9dba40321eaf089694e8741c43f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c6ccbb138b2032587ed842e92e773feacfe92ecd9fa8f07c6e01c2c67adf5ab7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c0ee56f247b51723209e0ef489b3ea5d445173c8cca17685f35eecb0e1f9bbee(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aa99fdf17d532657b52c7fc396921c839402f70422cf79290d1fe7f20d3ddfce(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitComposite]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__220805c644e801dad2dec10609029316bfe2f9aa8a580c87e571bf22f3f630f5(
    *,
    transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e2138a29eef57641100eb601c2909f40e3a624eb2ab70b0b498822a5190ac214(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7ca5b2f53bb82e3cf5ec335b0ef1ef1be871af6ae04950206f58cc6b34a6f96f(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__18e350d80be947ad5ca9688d24fb08f8060d31baf6b0fc78efb71864507ec281(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__06210c0ea0828e99408e083b9eef30cb204a2c6d7a6fd3b5f7dfd2fe0e0e6d16(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ab961fc72ce7d0b33bc9b3bbcf59fb67ef6b1db98a8af65f4865c4fbc18ae98(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a3d81415c040c0d5655b3383ad12fba81338aa5e71552b3856601209c9335128(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitCompound]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4fb74736bac8a63626d56e7113769f11b6bc8eba1a3c9ff3ec6722d17a47d79e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4985420deaca92570682c40714e0519dc4baa4c546aeb940d0b114cb5011a85d(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c6a2bdee05dc83dd6f205aa500afc199d8e2842cc39bcde0dcf7341e5dcd565d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitCompound]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4bca5b888bf7472410eb4c62394799ea647fdfd3417fb3873e9c95cc75518dd9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c9d6e8cda9203030faa1b40acadf7f1e799fad0c5836048a055d6f55d1b68c17(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__82f5d8e7394aec5740025f854815938a043df39bd05d676cad1470f4bfdb9983(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f4bb680b3a6388d6d894c426148c436938b528bb9e5fed9b391a5c8e20c261d0(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__119c5c21b4325ddb5e8148c29fdb58b198d9549f549bb1f1d44dec9be8dc1dd5(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__60941374e7ca61d056b7b71a6d5ab5906695a7461b98bbe228768cfcc44ccf0a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitCompoundTransformations]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b36a00bd4c30540ccc7be3bf818db4cf389c89a39efafaf18e3222b74769309e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e78dc460671f92028dc398419abe9363d2e04654c341b73f328ce81fdbdaaf87(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitCompoundTransformations]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ce5b6f3ecbc84b7ed52da552803c8272790ff53f0d0241fb4ed3d853e14bea9c(
    *,
    brightness: typing.Optional[builtins.str] = None,
    brightness_var: typing.Optional[builtins.str] = None,
    contrast: typing.Optional[builtins.str] = None,
    contrast_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__554c0b86c23ef3e93bdb4d6afdd2d3c016619e06a221344b2d7840a5c42add11(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__43a826a46ff08c189842de34308364ab41cd14ca3869fbc28e0d38e32527f659(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5afc394bdc081c5a450549acd4e40309516d888e0d7f8bfffd7a92a85a0b2c86(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1667bc37d0fe29238e6e4f29e54efb5b6ca33fe58d10fafb050bbc1cd92e09b9(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af44c87dfb3161b2cbb703b220d89b3c9f04727de1204bc837e94d52227e3929(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a6a63898b77e950d3cc4f1475d482d9fcf0c9aa88c1bc1805e851f3962ce825(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitContrast]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0cef8bbe0c2c266d423f0afad27307a13b79a9f87c5a18df8a4880aaeba90fd6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dcf10a8d393dbd2f6c66f61c5706db9fa989176ee2c84e6d3c28a703a2f7d737(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0a449c2a8ed06500c86f446e76a0330076aaf029844155586539acdbc490cb44(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bf9b0921b4bd55c1f21028eb574c11eaa70bdfaa266c6a2e327a0cc7aa56c52c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7987ce0649b43cf836b145fae32ffc212b5a58fdd9156b2d96eae7bf45ddb559(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e7e43ac52a58b219b259d27ebb480fb83a852c0629213aed40cf1585a3626fc8(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitContrast]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2f355ba5b17b2d60bc5cc0186ecd172fa8c3fe49503d2d8da2a16d71ebf8cc44(
    *,
    chaos: typing.Optional[builtins.str] = None,
    chaos_var: typing.Optional[builtins.str] = None,
    density: typing.Optional[builtins.str] = None,
    density_var: typing.Optional[builtins.str] = None,
    power: typing.Optional[builtins.str] = None,
    power_var: typing.Optional[builtins.str] = None,
    seed: typing.Optional[builtins.str] = None,
    seed_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df16c466c21971ae7ed40a2100d8012657f63519ffe9ec7f9265e33c140acb8d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__104860896917a4f400ced5950ff55dbf98f4120618975a162d6203315153ce1a(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__902b99def684b4f179d1732003fff16b19bd6545fd48eddc13302b731398f612(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a98e2cff1b55d1986020abf640f6dce95206ca55ab0860f8cc9ac576e365b170(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__18486bbb66de6d247be275e66f075655a20b54cf7ddfb660670d416b23631a6d(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__55f09c1ce54b3b7465ea2cd372e6e8b817148f33bcebe0f4ba6b5dd30ca13d56(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitGoop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9522c2c7e42f8ed52fa2fe986c2c220a5240b07e850c107fff3284a593c3ae6d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f616462948fb5e677e36d3f207a6d8e3547042375d041e0c7b7abf821525acfb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__832e8de061407c584fec1d6ee2a6da1b74a227068fb15f62c706a02d6a85b6f5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__07ef5a723320878d8d92ca1fafaf553fdaa5d581eaaf01c8aeab99e615e1469f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__288a9aeec30adefd5aefc288a4b7ceafa847db767232cdc5c5e8734391a0424f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7467796eb07a3dad218027d1981753d94ff5f2e6b7d0102beba71cb2784f04ec(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6eb034ee9e6e6fefd3b5c2790abcccfb044acab983ff79d12e6bd62e4b28a7c6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ffffa4e1204da721c99f32ed41060424a3113a9d7c324766e0fe1ce1d31c6e06(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fd93138df5931f8c623ba7a89b8cec5a81038b46f58bd5db1d23fcd4ba9037b1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e6ea5b86e04eedcdc8910297ee6ab9ed38c7cc93d6e7e92753d642fd1cfcc06a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitGoop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1165876772280eda2f5cea4be264652ef8f77ca47b98ab753dc3075deaa01825(
    *,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e26f757f90709c2ffbe375a153e0a35b123d7848e959fb591cdfe04810677d65(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3e6f9a58fa912b831f49360c0455040f2d02b9e3cd293fca44ba06852992a8ba(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fc5d6f33bd1901abdc628c8176d057261bc2d233bd0933a6191c007b75ee9fc6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6eaf2ce17c429aa9582665e24f7084140ebd9ce6ed12e7b0dd6a43493187c72b(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a9a2823c8a83e8b94de6b97f7f7fac543e77f8fc3a29dcd987120c51326eabd2(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__49fcf10a0b1d0c67bc5a269e5ab4c980231454733c562aa09204dd55cd5bae90(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitGrayscale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f563df709c9f800df7a5dd96f1b64b3f8f920f30431ebbc04bb0b95412a9faf8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1c58e3578869817ad1f8444e75ad61d8af85d66f3e37973da1fba916b64826b2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0573382aa661ded8774916d106c2e26254f726fc028caf2d4151fad250c7c103(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__15dfc0e9e6ff4e217d41a0d21146edc90d30b5efefe87403eab4e0ffdffad059(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitGrayscale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__63c17462c15f2251308e6b8f2f890158357bcbdce623aaf738af9ae4dae56f57(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness: typing.Optional[builtins.str] = None,
    lightness_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a9c4217bfe656e32ed41b807cbca4c2ddbf1834b28fe09db83ed10aba10fbb60(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__154d1dc9b977ddad7bf0df16a11e7b3e5a792f0f667b00acb2c49b6a8756d82c(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__da2c50f86a8cef66bd75f0ee91fd58ea3fff755fe0f7835d968c02e37da430b1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b7e5560d4531e0c94cee07f36ac60a6647270cc1853e0675f9231fa9df8e1371(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6beb25236918a1f2bc05d4f12b8de8730240e82e5c5b1e456e45d95b04bfb556(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__262667d999030c44d1f93ead0ced7f46541738e1f76573dbaa100116c9e7d418(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitHsl]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0c53295b8a487f67305b5aaf55bd4cefc48d7832b0cf9640b5a6743c6aafcb40(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c35bcce3457c3dbc4f9e0ff002132d74d13251a741f1b9ddaf135d4b51078480(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4c187de574fa03e07a9b0ddbb5ef628adfa60de36187756c0c43fd11b7061109(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5e28720a6635df448c8f4627b5990ee7aa2d92dfaabe4b467df2ca3905821e68(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__56ab07ae212c3d9afc14af91626fb52568f3515d4504200c31b304c0ae77ff86(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__37793536b5482300f42ed6d1b6e82fbc565864b37f9ae54c7dfa15067a82f8cd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__41993557339bfce3a2d55c4e1747cc55e7899aed844000bfcd1e96b4f91a01d7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__572e7caa5ac22e800d05db6e391bc159f98b04dac42225d31f306f74a4b1d2c3(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitHsl]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e9dbdebffea7761d6e733cbfb62110f0fdec6d9a39620085fb164ec9fc0f5cea(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1d8607f68f9caacf189bc749fe5318c693298fea8726c8d981beae68a6666df0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bf6772a8c1e2d9858aaf78ccab5962699ddf751337430fd37e4d0cf6399f287d(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c78927bed74f61507cf338773555e770f650c0f267223b10e91c90e965372f13(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6d9a78a7b73a14e04dd76007517ad7754e17115772ab60586e89c86e2c19d170(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a259d47a328f9054580494d0e7ce61a75e01b04ff11450935b307c13091358f0(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dffe63efa2d02726cc87ba2aa7d70033fe77163619542e48af7f443db9e1688f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitHsv]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4d0be3abe28ea669b9e80459c2a675aeaa49f7cd232f89ddbf19de61eed97bc6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__03c411ce93b5363f8722ee2672ccbf502fe30f03c017beaee95a506c6457185e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3708838340e4d59eab60f83bbbd0bd2018071119e268f374e6892cd38bed8d55(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d274adc5658c6d23ee27937bad403e74bb6229f82c124a9f27dfdf39f57d2174(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e9687fc2358b4a5d2a77494a207afe667305e98f96caa67df5a86d8b46d58c8f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1cc896768cf6ff99d7ce83b5e2920035ee08a9a6a9c8898b11d37b7a498270bc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__48526e715a832c4d6286e69de9edc9df8a5d2c123310db0464e175df5e2431bb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4564e36ffa1704213e36f307990329a9773511a15529027496d75a0d259c5a63(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitHsv]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__15608b8d71a220e06021322c7fec04c15a9a47d019ce8f9c7d7982a25d35ef26(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfDimensionDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    dimension: typing.Optional[builtins.str] = None,
    dimension_var: typing.Optional[builtins.str] = None,
    equal: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfDimensionEqual, typing.Dict[builtins.str, typing.Any]]] = None,
    greater_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfDimensionGreaterThan, typing.Dict[builtins.str, typing.Any]]] = None,
    less_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfDimensionLessThan, typing.Dict[builtins.str, typing.Any]]] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3969773359984f054f152e066e79e508b870083791b9d2ad11fee60d3046eabd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8053d2bb62446886b77f730fee2d6d2edfc7a4a081f7dd450253520277b3de88(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfDimensionDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2b4f95c111e20ef9094b485405ee729d934dfb903d3f1b8695ccb4dcdd2a1109(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bcb4b8bfdb86c3215880d1420da3ea02c00caeb22ed5fa2ece180512cfe96e93(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfDimensionEqual],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a92ba29c8bc6ca02af1f0adfaf2db06e177b288e061fd1244147bdc238d4fdc4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__96514850734867bd17e732ec5454cc71f0c3f4d652d783d17e51376e73fd185d(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfDimensionGreaterThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3505ca32b68187fa2cf7dcab666ca0d0a72e3839eca4020d27a1af6c0ef921d7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e5fd3a00061c4c1283feb7c6c4a75dbd01c85a0d508729bb8d1953ff40d36596(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfDimensionLessThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9aa6fdf1edd6a9242619e7ff96108cfbfb62bf68fbcd87109f9d6d86aa11c862(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6088ff6d3edecc5462478f58a574a3a8445b2a6cc034e38f8deee350ae491bfe(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b34415d4cf2b92e05bd295a71ade6b0ceac1399a7d9093dd4f81f4e031a50437(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__98dc6ccc8831d6e662f94c3383208de102aaf67d66cec778ecd4d9a2c76705e9(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__700f48490e998cea9b06ea32a867b5ca7bed90f17ea62ebf3cc718c6338d8a4b(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c7d2f8894e90a40910e573a561835060ddd26f6e7efbafdcbfe23135daaf3c8b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfDimension]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2b0adc9de9e6de7e315d5056ab289ca4fcce7a7b80e4930eb55a0cfb7751e400(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__084c2eef68770329d65bc305f423cce27dade471ee12257a2fa604e90c4dae89(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1d08473e28d971f093f7ce4b774a3a27e44c57b2c732b8679e227ac25d709dd4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b352395d387bd74f77b3bc6d18c388eda60dcedf3c09ef384448dcb5ead86a43(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f8131e080a2212d6c7b9110ef409c82e164b07752758a97bd76be60b03e2029(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d078b4b71da67c491dbd170f55b4e45a04f38c863c7fa386a5f488071cad8d3e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfDimension]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__775708bfd340cd5a2d2982527d5989a766ba07395e26534c6b22ab89aa5998f8(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfOrientationDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    landscape: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfOrientationLandscape, typing.Dict[builtins.str, typing.Any]]] = None,
    portrait: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfOrientationPortrait, typing.Dict[builtins.str, typing.Any]]] = None,
    square: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfOrientationSquare, typing.Dict[builtins.str, typing.Any]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e9b10c3488e819481be50e6da907b41e3be5efee295d5c7fb3358af4500e0803(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d0c7cb795d1334e13f23fc91707b05458c23e63e3987f53b57475497a895425c(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfOrientationDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__51b76c4bfa90e846f11b47d57d3a5d6eb82bd1db8ee0992c63691090e702d188(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0c899d0efcc0000f356d50c6bf1d1ccc56e454f065d4f9db4014024dbbc984c8(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfOrientationLandscape],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__36df0c0d95c85b4015c657a9c4e757d8bb8ce5dc62909325ffadb0e7ec974a88(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__997de73a6266a558ac7ad7ffca5557b49b1fc8e695fa2380e8e21ed78324a021(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4c60f5d1aa0aefdb977ca1b3923962caff077cdf93ed05195479823943518a93(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6a15cff9870df0df72f6794e135754be8c14ea7f4ee8cbd91e6ddbdff73528b4(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ccf899ded283d7a3de7d79e4962e261ed7b0ac70bd5d4fda5d43dc6db72d74ff(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a62e4cd67bea0c4eac21e59f55ee70958e2bb7552cf073f804ca4e8435808f7(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfOrientation]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a03ed4caefbec78cdfa38131d873fd7d580bc42b2c6524fbb99bff93071e1a27(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6d6be929112ecd99e2a27f3af77d66024aa85698666221d4d31a7b47d82ca327(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfOrientation]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc660f84956e07c7639b1c7b8a676f619bbcd90c748e63f41c896e7cad4436e7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__211ec7cc063bfddf52b480bd469815be98d6e6bcf261e6ccd726e79a1820d78e(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfOrientationPortrait],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__04817324992a823b76d73ff4c83c1cd573a77ae08728f5c94f7ac3972a8370b4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d67c7409ae73ec3d233a42d6342c741126ec3b4c7aeb5fd183c15d0f701df9d7(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfOrientationSquare],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9acc97f447a21baf842a80992c0e16160c96566ed8c1c6f282fb5efff50bb2b7(
    *,
    colors: typing.Optional[builtins.str] = None,
    colors_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__03b17621c51bc3dd4ac0b41c6e042f013b6c1d49f9a0c0f4e47f079048450d75(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d134e81dc3f74c855757354bec99c6093921af164d36eb129d76eaec2a712ae9(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d90c8376f61a9b755e6301c1c0e9e29667c3363d4b1a4faf5e36fb7cf7b3c5c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4f8370785bc753ce8bd5fd108c41d3fd31ef166d3e38846e106ad25511c38de2(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a2eab7b426b804b95eb0d1aea3d91bd2ef79b73012759c4e1993e1057d3a778a(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__50570590f823dd413f234ea231ead953f589db4ac918e33d49a4f6c9396712fe(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitMaxColors]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e97defd5ce1fd92ebdf794fef7cadc2bab245860564d3b4cff26481e5ac8cb5d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__15d86bc3f72eb99b9eee06b4b52bda6fcbbbe4140be84dc1387c4cebce16c3f8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f2948025b03fd22d0afb7262e49aba0a441f4d4f5a541b29f606a15a07934335(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c04e558a54fa6a085f09114de290157adf9d222ca397682578684ce55d29a98b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitMaxColors]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__55c7fe0aff36ffbea14bf36b2aa93e6a773c079154654b612f300c740c7f1023(
    *,
    horizontal: typing.Optional[builtins.str] = None,
    horizontal_var: typing.Optional[builtins.str] = None,
    vertical: typing.Optional[builtins.str] = None,
    vertical_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e827f0279fcee1a3cb3d1848cd4b535f434d9dd7c6cc7adbc4f1401111df5c47(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b276f667d20ab6484453cfaec16ceba49ebf37f12b166420d1a648bc3136cd9c(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6d621a6fa49c1707e73803282aacb72d33f9e42238c4a7a13a114879d610288b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7be112cb654a8a58d660df24faa54ba074a7c740c31dee63ea071184deb7ddf2(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__07dd0f5bf4d131c8eaa286a295b4c30eea3f7f1bda62e15672185ccd78eb1f41(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a5a808e54328dca77b4cd77cd894c1bc79b399aa089a53bec730d646f4f91955(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitMirror]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__22f5f5b7bd5de36388d0d502846f3c762ac6c5b584ad37e76cf8cf99603dceac(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__423ac422d8bdb651e3a091de7197b8d4d65033c325c850d8cfc8468c631dc0e1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8f8d8803236fee6d59966b3864978948ad6b6cf4ee4e9307b7901418608008d2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__054dea33b7218e18bdb93108d1e154f25250a2e1128512bcd542704baba521ab(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c17c0c9c90398356b356b766e74d3e1a39ee284365d5a18c79a906ea62586ee2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ffc726de7e267b5de6fb6995e36a51caf2c2b304a5ff4d1b02cd2064f5ac3f6(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitMirror]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__679514f15f0d1be4ad71a385ad1e26ec797bd0763a01ea4536ac684931c80f77(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0f4e6cf990383309b1f73df1065437b6e90743ee271ea142a13652c71219b2ae(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f179db281b919683a2eadb9f3a4a7f1f0075bcbdadb23282180d89ad74481f1e(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a08becd9adedb29d11b293bf28454043a172f6860d552d4303fd9116d667fc8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8f79ca6c8eb4cf3d0504d40aeff870581b87b89a008e7d2f24287535c5e62b65(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1c8b7b971c8f850c7e72d26df3abc1df32a10055ee5afa5d20fcae9527c8927c(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8576cae04b0143afb82416d82d1220d20330c956eb1fad4e8d275af01723d0f5(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitMonoHue]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1d96cf1a27f425d828964895f324663de78ee78e615eeea7e980aeb9fd35a4ef(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0d4b5354e1c83ecf3c48f381f4831583b8810ed4a5e5c11a74a0423bf8453fcd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__82a389c4208a76b01813ba0ca3a4379e1f6af8a6310ba57b524da2df5da156a3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3f4a13773bef209a57c6b9f67d46ce6a17681f327f8c942927bb16e6ede485a5(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitMonoHue]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__254ce50fe265237bf29acc64202691dd2e7c5530eded839ecc04a640b94e0f1e(
    *,
    opacity: typing.Optional[builtins.str] = None,
    opacity_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__49bea1358634580a5ec4e8b7f8ccc3bcd1f2975e95bdfa23d12d4ab25101511b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0e016a58e8e0101604e4569f2c094f74d43e7f87455662957868247a7148c360(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b6a08d3608930c43c023b8f064fc7d47a0fa36cbc046a9b65dc5b6a766423202(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6ebd9e386d16ba7da19a627c40404483f29a33551d2bab85c8c03b1c1794199a(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fe8d4be6c7ee2e9053c1c55c960d7a1a60dbf3e1a446be88a02600f24f42cdb4(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dbce8680f093c5f75ef2b2c46dca6509a4a3bf2b95a41f3c1e650cad23b13f5a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitOpacity]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fd20d5a81175c7d701805d5072a4c7b9e4544c913d384675ddebc95c2988617d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__07b2fcba5b7d2030c27c8afe0e95d708cdac10df64b34721c2084c071aec90e1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__84517c51e77472b9ab76a891565aab14b5383348a4cd99877f7519f921910cbe(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fe492aa3de178e54155b88d7f8d7d0d254b159837e69cbf5153636652f9696ab(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitOpacity]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a74a91d569205ce15694ccfc6c702ab7217581ea3a0bcca4edbab15419c5175b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d71ff311d248020043af4269c2bf248dda6b144068ff4f56c8d58d29fc5be8d(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__750e94e664e7e30f0cac7e77e6e49b5dc1380c01ec2ba6b3171a9511f5f3b1f8(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitBlur, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f7b67d69612ba1c43bca139f346fb2c612b7d08bc7bd29e5f8c63e831fa7eedd(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitChromaKey, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__761498b0915f9cb3c21bc9ed710046cc41747bfe2e25ec83290bcb76ae9cae09(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitComposite, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6d7d5275a43768f10c6c5247d5e8880441fe14d4c3e9d5d5d528f2b7d3bd9b97(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitCompound, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7dffd04ab72ea426677edc1f871b212cd591660f192cd251c1cdf5fe9d1ee89b(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitContrast, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__33996432dbc4271892db15ecca68f4bbd18aa435781b18a3755e9dbe74b3cdf7(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitGoop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__67fd572009fc26a10af862c9ef5b69d330fbe23a5e8f259a9f514a5a84b1c2f4(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitGrayscale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d8f83cf5438b71f10f15d9c6e223cf89007fb1c0fe6ced086dcc98f150f508a0(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitHsl, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1289727d6c79fee9844b1f0990461d0b9a638e880342d870f3cdb33d4238d9c1(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitHsv, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1ea96b0c4273c341861b300fce6497de29bb6001e05036fd5a80e989c359e0dc(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfDimension, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e7339e8490ec50b93a6214527606633d65bf7c830ace02a718b2c3ebe7141852(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea50c06a9b1f57edff5eb329ea6aca42e5170b8b6ce33d4d8d8841f88c346d89(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitMaxColors, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__29463ffe2718322eee234f068fb72141f0e0f0543e481fba881bb822e77c3fd7(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitMirror, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5003f21d8b70cf7555ddc0b37a14f2d5c1426e765a29e3e51f78ddacd20441a2(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitMonoHue, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9b49d3e53781b744cf985019ae4554c89ef2c4d5d4f582d3043bf02b272876fc(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitOpacity, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__60342ef79616bfd3e9c92434d80ab91fde01691f9743a2bc42f44712c8810d3f(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitRemoveColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d8feae396bebdfea563446bea426a62d3b8119c4cb86b86f4a073710973d7603(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitUnsharpMask, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7a3af66734a9ec890b4cde7186a443f6e183c15241d878bd90c0dc50a72bcea8(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortrait],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__28ab2d30668199136e3f3c5fdea36c0426040f55ef5daefcc22b61d6efd77a78(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
    feather: typing.Optional[builtins.str] = None,
    feather_var: typing.Optional[builtins.str] = None,
    tolerance: typing.Optional[builtins.str] = None,
    tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8d4b7e2e2febf109f41bf44bd98de8b7bbd61d2e1d119577d96d858b4ed9167d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9c1d67233c21a03c629b2aa2b5b146b9794678887a3fc5e7f9a1494ddddebc2f(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aab2df48ea1073e2d316195c00c0a8f7e50e70d637006f6b0b56ece9059cf06f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d469989314e9670a387c929729c74ac9dcc49f20a35c963d5dd071f6116eb05(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5cb8dc8e05e6720eca59f48befb9049d770241b6f96db2c78c4ccdc0cec53d32(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__db31f0880ff1f1dc5cb2cec835b578116323b712b937449c1b68c99df87061f4(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitRemoveColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__77a01d37dcc859b8fde7d51e55324266fa7b7a6b92ac6390b5a652df5f7b09a1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__647a4d017d9bda6d63302d7609ba0f518b3f11071cca6741d1fc3327b782645a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1bc6e3071699b2b16a29c4403fa2eb1b5b2ae1d4a568ca5e8287b30d07a4122f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b8fd45e7e74fb285032a2d2a9dbe63bc93f4de4bed1d588c7d39962ffe82ef1b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d21d85373141db6cfde272299dd968195ad872a834343e08c078a7bf0816a076(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b528f6f6e7d5ec47f63eeed8926a97f76efa3c6a4bbcb09649147ccf88449c8d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8dde6058d2411e38fb0058b5a635109333bfd0c2dcbd0a3f5c5e8f1c324308cb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4e16346d3dd821d15a85b5551a41612d054f86917872734685a9c5af8c4d8b10(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitRemoveColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__57c2be2b68825b38dc3c231b28b19b0435b4f62a3d8de10d4aa117e9e5f22a5b(
    *,
    gain: typing.Optional[builtins.str] = None,
    gain_var: typing.Optional[builtins.str] = None,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
    threshold: typing.Optional[builtins.str] = None,
    threshold_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4fee70a2a2ff4a65a23b90fb330c76862b700a259fce5a53f1097883441f7c4b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__604bc0caac7e518524311ead35814b9800a06d2bd16106194b643b2f7d4d9dfa(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2b0baa7656dbffc94382103295f56102c95c840cccee4e352d3d36bf338be79e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c8c3942ec710794369d4e0f8927977c636444e515edf2ae88417c0a0dadfe32f(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__998f9bcd52f43ff88e1d15b084e70da6778d112e519bd6bc7b71549f0c365025(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__23f3295e183ba73550e08dad49543b7689119c8155ee6642f6cdc6768adffcae(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitUnsharpMask]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__66a38dfd9e8947fc1ad4bcf237104ef4e7284a13b1861e10317c009525eaaaaa(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__76bc34afd497257ddf95372dbbbfe0e367965ecd6ce335f834ccceff767b3910(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0b75aec390d053c589bfb062d442759ce34dfe515ba83c3b11e8f09d691b1ba0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a52a51a0d278e82aeff88cf3a41410d0e34276e3463b52f95364b7a793566e7f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e8431ea32e50e09cf9732bbe4940aa030eb0ba6740058e1233b082c1be574b10(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7279e455bc214384fd212768f08d6141f6f6b67c4fdae8f86b2b533d2f63f5af(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bca0102ece25d6122afc503120210f5ec6cd7cb0ee5783a65d6f7209704801b2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f9cb676631d06fab7921179c7f480a0c9b9d578888ed10e841d672054dd0a6a0(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationPortraitUnsharpMask]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__17bffb9f1e2f016c4955eb20e54d18b7791951f68d38aecfd4cda40c80016fde(
    *,
    background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
    chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
    composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
    compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
    contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
    goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
    max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
    opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
    remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df2c658781d2d6f7ead6be87a1dd68690ab487a5923bf6078766c9c31733e367(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6391920febe57298ab54e1c8161a355ae1ddf8cec08429bc636ec1a067122b5f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__54e256c7cceadb229baf6439c0c91bdc1ae1327132dfe04ecce6ca16a30075b2(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bf3adb4e8c0415bdd897c17e0f1b0dc3e523c1f6e7bebfcac71bbfd55597c55b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bf4900c8028e0ac93a1497a05912567c4500d4107b9062648e60155e38ef007b(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__edaee6fd6c843f0d917d0d2f3ca899bd183e837eac3c77fe2aca64eab4d76083(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f16d6109b1101e6283586092373ae3791266954b527f7695e7494eedfbe94c1(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareBackgroundColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ed232c8f81d5ab979605f83152ae06a44f9bf6b0dc6f39ad84a8d38fbcef8314(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__93feb1afb6403863564f1e0ddc9a310f63c21057a73484b1b9a6d27a6f919d67(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c7eea26ceef55535aa13d74911f8e729ab3345a1cd6a071389d52db4c7fda8a5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a91af9d0da883911d43d6b94ca96c3b85947579287e503c8cbd53d606951180(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareBackgroundColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7698209bbc0c69a6bfe05ae8b3c4505f46cc95c17f2c115da7edad546d7a5e5a(
    *,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7a7d2006fa28fea8672b0cf9a5af43dec806da374c17836d95a3e6ba72d7e089(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__29aa7b68e139d5067049759968efefd0ec5ffdb8b983d2ffb9872e4b10bea971(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__007070d260ca13cdf2532b97c718137541aec9f238eda25f5649ba07a1e4d9d8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ab2465851988c1ec9508a894cdb94ecc829a5d7c014c306a7df675c16bf8f8d(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4057feacbb6b482071bf447c8eef878e88a72c4b0e3b181daf741ae91e0fdba7(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6281b2fbc11677de9f9abc8078a8ec927a1103d20ac146fcfea45c675b4d5cb2(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareBlur]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9dde47772b59ad8b92a1f9e710e160e700043711bf892376cba479fdb6cce149(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ca2fc79d843750553766bc5107a2672f92d47d3bcdcd632427edee7138974490(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__20dc426fcd736b260b8208e2b4e40d2cc2d0c93f86f1c826bf970ba9b1a8e41b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9b94b76f0d44844f0f93568d10091de117136c3e59735ca5d9a26ecc60ae0e2a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareBlur]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4227710b5d1354c24532be9bd5f1601fcf6c8c0add1dd8cec470e93fe5c89c29(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_feather: typing.Optional[builtins.str] = None,
    hue_feather_var: typing.Optional[builtins.str] = None,
    hue_tolerance: typing.Optional[builtins.str] = None,
    hue_tolerance_var: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness_feather: typing.Optional[builtins.str] = None,
    lightness_feather_var: typing.Optional[builtins.str] = None,
    lightness_tolerance: typing.Optional[builtins.str] = None,
    lightness_tolerance_var: typing.Optional[builtins.str] = None,
    saturation_feather: typing.Optional[builtins.str] = None,
    saturation_feather_var: typing.Optional[builtins.str] = None,
    saturation_tolerance: typing.Optional[builtins.str] = None,
    saturation_tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b9c687c45cb3a0c23233ed2777b0f8b75c46f1bb9ffae28113847907bb97329c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__90db1637745c1e75783bd3ae145e4e8e608fdd78dcb37d0cda43e2d93fa169f5(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a1b6e2eb6c71b438476dbd80d79446dac707b189cc800052257faf734779f7a0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d610b0b31a6f0af79d828ee252e3a23475fae2e4f2d9f2c8bdd20202e366ac0f(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb6c6776252cc07a0847b01c1e74626170b610c40f4d1d9bad8e23447b5c4ad4(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ff20f259107c31b28e2118aa7c6ef0cca6e42cb4f51253d16530dde801abb561(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareChromaKey]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8cf3e0dcb4c4eeb92ad42d139d8c064013d4f4085d1a9d21654921befd52dfe9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__19aae7ef7e1acdf8572aa1ee1c728c0d9dba2b8dca287544930f7caa4b1fddcc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a08251066b78e66a84f9fa45ecd1e25b09d00bc4fff1a2fedaa39042b3fed446(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1815ceb4a97c0767e9b7da2314922adaa31495691f8266f9f7ef4aed41219b2b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e3ac7ea08b8dec0924197db21a6ae3f84642df8b3f99d30f8c76439fee7d6c2e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7ad80f4ba9d78635b75486eba57e0b3f275dcfe01c7b24c5d5cd2373f9382a64(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d4cc8c50169e7472cacbd80b2eb3d875a91a6450f65863901979b65a68d71a7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__019dc38d6d3552126e65dec122ffed82997bfaf76231bef8509c2e2e717ef4fb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__18c46d378f30c17a4aa456c1dd1f6c9a8d4def77c13c1bab0a335a135d4a4d54(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__268c70dba9e82776636fb3042df0f12bcf79c488fb80833f4af8ceec4f979f89(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3152989252440c7c15b9bdd7c28e7d4cd116fe1b5e0e8a4fd1ce4f6b3436d453(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a5c25123284f416c1d2675b6bb091274994530b53294f316c19cddbbbddf71a8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b6656fc522f1f5e0fbea1a3b87a04cbcfef1654837dffbd470030fc98a575e3c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e47eaf42be07f47c1e26adb3d47edb5a92241006a54fa9c86ae22381a07138c7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab83506f6016267330ad16f6987acf8165216f4c04036532e96d429c3261f354(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__26eb5ea04c81ae3fdb5c9940683f05822659ac57ed7307a4c438b2590fece438(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareChromaKey]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6019f83516f0ca67746b53d2068ff0ec033e95968e4842b02de90f4f53e1097f(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareCompositeImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    placement: typing.Optional[builtins.str] = None,
    placement_var: typing.Optional[builtins.str] = None,
    scale: typing.Optional[builtins.str] = None,
    scale_dimension: typing.Optional[builtins.str] = None,
    scale_dimension_var: typing.Optional[builtins.str] = None,
    scale_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0d9e92eca5fc06ef0d6bbdcca1fca88050508335520e860c4d908769e439f1b5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__77a6929437bf6f0f8fc467c36ff891c86b8744105155d1c31d55a5f46486e539(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareCompositeImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e59d698da09aadd9443ed12857d261eeb712ebfa6878e670c4109960382bc067(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b3c8892ce01cdbdd08767e6814efaea29083ea60594c74dd5c381f21883cc402(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4d4aacd7e317c027788e624a74520bd7fd62e540c5498b6a905b08f42632c17e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__720e478e16e249ba74be4f045659e8cd4112be891c3aaefdcd88aeb9f9fc52c3(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ed0c47e0b70f760b33d2fc1ab1c13f0716365d2031c816cc37c0788e5c030933(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__807754e2fd9f4b262f229b81af450b07bcc95e31d4be7df84d944600ae59e4c0(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareComposite]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f2c76fb670ab1ec2cb6b9b3a1b1f68325c33b8f25e99138dc2c160d11a0f7f69(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ba2aa02e21123e0430ff874385c1dbd70f9945f0b644460f059c00654c52b900(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb343ececcd3f9f1d03a9ec9c8c74cdbbd156d6af67b16ba9d0f49c9acdb13a2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__800864ea4608ced74a3a6d723a8967b37f72ece441ff2a297baf8cbc5f1de311(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6c33a823e7c459544b2312582e3d2759e6d9bd1d437f593687b425a0123247cb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eccd87bf11d8cf98e0f2b91848c6d5c158918d46fc56ccbac9b0097d450a241c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cfc952091ab26806292719414cecad6f1ac4f93c441c9fa6c20c296ecebc3765(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__16aa0abbbb77c5cfc0f31e8def9e5e0c0c6dc7a32d6cacf9597400c0cb1cad87(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a227ed6bbd1ce00345198166da36060d0e45fe5429fe846088409a4b31ca2063(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab1feb09f5ead89589a2c1001ebbc9ace0e94da3f6cac62b834ddf71337b31c6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7dac3408093cd47f2dab2ecaf9b895c35735abaaf7ed3a4b3fb531c221b4aefa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__16540e10b830fac997c8811fcd1147a6f6e86a7b75e325dd94b22a1e6ac0af70(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0011c5faf56f3dc82d59a6bb4d707d2db35a63211e718b8231f7d28d67efb572(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1445499a56a01547bf5636083703304bd7af48c804e1d39c295d788985148e10(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareComposite]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6714535a739ed775f944eb278fc7f66d92b0b5249b037cd183e2da45ecddd7b3(
    *,
    transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ae42bfd232692182837d1c391d6d4770de61a5f147eeb0c72b18b1fbc49c7bf0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__182bc00c31765f2b075516b6507b9b88b6ece462774705f50837f02130164b3d(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a839ad71e621a1bb7ed27cbc1650b6d917c5e202038d123402664723b9fe98f7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6da36de52a7a727f765827c4f046c83028d3384e626e5e7660122a7c0bda12a2(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__32f3ae5f678b33e5d828dd343f22d968480df84e195534e42ed7f1c20a3a5a5f(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__157fe11873a799ee6717979a5edc3d5157a8c6e0c8404c40f7265927262dcb4b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareCompound]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b96b3eabf0173c9de3958150bb4147df73c900290dbb3707c4281d645c55afe7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ef68c9498388a78986cce7eb64753152d1427a45b40c3874728228bf39d96ea(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e79d62507ed35ae0e2b18353014972e5a79b543749da9e4cd283dc93e1d373d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareCompound]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__70858432ba75e97302c337d496293a9346314b9e7462db17daba20d055bfd5da(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8d718afd25722ca7474ed9d0af20ab5df71df34c73c18ca6df895588365c99a4(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__39ed477938d5f1d4a667a1556096f3aacde7349f08bdffba625b6165152768c2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e872bf68fa8cdde5fb57ce941fe1c58be3696330dc6368e6763c66719b3c45bc(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7238012066000eb2ba6814620210728bc28de721924a1b2bfefc07b51c6c19c1(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2758516238f10c52d31cf61848f8e4821109b8070859d249be00c78f5b8c634f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareCompoundTransformations]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6ca5d48bb94741f7a6bf04e6edafeaa840f8c316d484d31f874d4b770c7a2c7e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e29de3113a6b051ceaeab97f747ca240f28bfdf7cf02cb729cc60ee0c949178d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareCompoundTransformations]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__370f872ad7c8e3b646927459d2ee262a51371e839c04d62986a64e06b04644a7(
    *,
    brightness: typing.Optional[builtins.str] = None,
    brightness_var: typing.Optional[builtins.str] = None,
    contrast: typing.Optional[builtins.str] = None,
    contrast_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f4ebf628f8ccd70a1605a8506f9f89e1c15845bc4dc797cebb61188fd82ca68(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1411712d31d7bc2d826d402947bd87b8163a0ef141c9d55fb86f383e13689f00(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4133954be6a41456f0eec455d36854cdba4b424cd60923553556064527f81ac2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__201ed8ce22d3421410b3b812ce2255479897472b83bf6dfd1bb478101a698d2a(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__99d88873dd7b521d8aa637c310e2d24cd2772f22189614c381dd3172e346a7eb(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f465873312287d2b086da97c52d8e2e6637ba59ac37a49a1615abee51b4e7818(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareContrast]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7fceb0ac52a7005499cfd6cc3973660744c8329f720ae4a3ae30b8cadcce87f1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6a9a86f10d78a8d2f6bf4c4b826f892a3878c9e2040f1cee2856270a1449128c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__50cc91d45f2faea41812704d764f1480a73162e7dc1c34931803d20d682605f2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1929a452f243bef00b55760ffb40ddf592d4dff30f13a7027795438513619614(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0e50b130ce2f16dca92b2e47c5331aff273836ce4d92d2577d206924586f0cad(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9bdb647c1adaa92379c8eaa95aa2ec6283a7b153117a2c9fdb7c93f3d7765330(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareContrast]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__17dbaa5216c0902de3e5e46230f407fc84bd66f4e93123cc55f9686d32237dff(
    *,
    chaos: typing.Optional[builtins.str] = None,
    chaos_var: typing.Optional[builtins.str] = None,
    density: typing.Optional[builtins.str] = None,
    density_var: typing.Optional[builtins.str] = None,
    power: typing.Optional[builtins.str] = None,
    power_var: typing.Optional[builtins.str] = None,
    seed: typing.Optional[builtins.str] = None,
    seed_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c523b38f70878a762dd5c8fa7a50098796f27992d1ba909a70f97c0a08f3ac26(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f634825ff34784bf382718e9bc4b344104aea67dbc6e1fed1309c2960a792c8b(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__28d1cb55fbead36e3069a9bb1f579c9617020a57adf38f910241965b7fcf9747(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__71f1e8b49524b35e504a8b7c82563986c179b8dbf5acc0485e1c5d0fa8352c21(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ef6e83a479f9ac58b0f1cf61dd7cb26f17d947c3b82bcbe67dab4e197de78c6(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a35646504f33e30b20de25bdf5e296e6b0c01acecd89136e3d5f2ae68736ec6f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareGoop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d4971a7dba1b946d51d90807bee950eaead943d627365ad549f0c2b735f12f8f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9e095576d80620e199ad5611dbf4cacb2ceb71913240d839ee0a44a7d90e0a56(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b3df806fb649246eedac7b8bab85332073b1fc0264c5c6887821ca49f122275a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9472304f2d0a6c401a5a0c8275f5e791bc23b0098919810d77e062d2f6400c01(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cfef8c374710a914e69a068a705299d3dc49a63643f2a4843278a3a05f1b1924(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__948fcb383d6ef05773fa0e3c686f91450059c91ee519554c75fa2ff80a72699b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a3e0b0e025adfdc5a277756227d25d4bc0bd1816a850087ac491a0dd013efb5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__39a0e56c0a3356ad16a3b1dcae3ba134640b4fda1359ee634c80f76ba98c0551(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac824785df9523e19c84fe8eacb1d69979780de681a0d48c8dc95f277345a016(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e9f35bd88eaa08e63858c8bf2abaa56231886b9800ad91d13b795df85a49f7f1(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareGoop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab80dbe2d4529a17ae68c85a247adc7125b68fc9564a0767ac7c780d2c6713dc(
    *,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1126471097ab93349db8918ecd9ab09c9e93116f277d3a66e2f0ffb9332286f7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bd33f2ea69b7d6655b8b73bed1c6d4e0d388577a187dab5a952692261cdb8196(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c75d9e93fdb04ad586ad3608ef1e92a17eb0d5bdc1b6d8e2e81df41ec55d0f9f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__370be8a7d1fa7a3f4731fb486c0774c1d69823d5fe9fbcdf16a8bb7a0bed8862(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__12c40f5f64a22b350c9d1304b10314ab808e44a441b1a5cdf7f4c2d64075d2ff(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__da31e7c3c9a77e1d596ddb4909c2de7bb75ebf648b82a9cf2be7c94107f180e8(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareGrayscale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a1e78cf9bce4f3651d4e1087343d9cd28cea9627d12382220d128de2bdc825e3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d779191f6b63221322c6313ad18d4d67a44293e5c2c595a58527582df620903(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a7f47b5e1ccc88f0fd3d02979e5f6bc421fe3710f5d5f400d05046ed540f38e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3024b166a574a3ac218293ee193146350e24ecf7504a6ecf3bcb1264460c5d97(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareGrayscale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__228ddd1bbcb288adc6e115770ac593182b36828f1d84975c8746a1e786241528(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness: typing.Optional[builtins.str] = None,
    lightness_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8f139bf519f597cb2428b6280e22a06d3ba89108f494f070bf4e9be5f9a028cb(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f417d52b86a466f4e81a1e6e062bb364d31b8dc742f9398e9abaae36481e27e(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9de474ec012add2ded9543ba22b963d86a04186b1be17ac5c3c38e49e869b8db(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fed8b1f70627ee59004b0644522f9638e4e2053baabcdd5da17c98aa35122192(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4767a7f08a7d9048181661b65cce678d4b09c0e88d65bdeb487ce77730d58b84(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5114c61ad004c200d8a2131db0ddca20c70e9413303f5e0ce0631f30bd0187b0(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareHsl]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__653cf98549bb500ed668bbf32c4df2b08a082da119dafbbb24ceb0a1936426dd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__17b88bc52f4e23817433e097f1caa68c69228d1d9a12c51c98e6393caf331f13(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__100110c3c945f0d4cea666cd29ca48ff4061c5f78721417758d28e358c0de551(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__47c859d0b1823a268474ff068e0661b0d230df1a739af2735146d69c45cedf54(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8752f8f7308de3b71dd0d77303a1dae6c0031bc38e129c2e7a023fb8d5699445(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ce63dbffb6fab1724167598a4b19bbdb09add3e9da9966c7e77a1889c04ba0f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab021736f4f4db3406189b9c231e20b8624dfb594aed8b3a4554e03a4b33282d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__477af62adc38fcdd189c3de5091b3ae358288545934d698780a368fdf1f943f5(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareHsl]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c84f330168e3e0b54aade7d17e9e3e1ad6fad1dd2b2b74bbad2e4bba2a228661(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__05b6be478eddeb2e31548fe7c6ebb55f70e21eb1627e164834a63fcb6a33165e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3992e3f8d2b5c644a3f8170e4641a121d2c4d8ca0b0683f65369a6c03bdc2854(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__90129498e2c490fa2211a7bdf53fad9cff12661b3d058d084eeccbef6d3701a3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f1b24fa3ceb45a246a18b21257234ede840b5be25580ab47bb4cefc48eadb59c(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b06ca39b59390fbe62b97fbf262d9fbebb4202140ed492c3af25a9c1f2aecd41(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f423f50713313f2ac959672c15d5cdcb037b078b76fbd025065f3bf2f7a64abb(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareHsv]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__40547a8fd483e1cca587ba8aa34f975db66cf089cba5b5fb264c2fd3a9940573(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__916a5f7fcaa380e2c2f257ec7319b7af476920f007eaee07221c9b32810cc0f9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f482c5bb6cb3de3def3f9d5d8500e450417c24b743806efa7137120252ab3f8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__54b400075d3067ffd50df8ae2c01b7dec0a7204ff7e28c7f071f4339e3e5f352(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__77a47fd1cf254782d7c0337521197f10d379c393134ac8ee87afb07bc2780dbe(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ca6be21b76c25194f0aa60e1c5c070b2354aea5145ed608031df9b95cf4bb410(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__74b324c753ce86587412c3725d8b8c6dd7f1c72e8c61d8d618cbb81941cecedd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__694cdbbfff3d9edbfc72e4aa5b0289c8753eb835a00a471d7ab359bb331f299a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareHsv]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3e2ebc942d2438687049f03a09c18ce3e566cabbc7dc74893333fa4a7b52a195(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfDimensionDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    dimension: typing.Optional[builtins.str] = None,
    dimension_var: typing.Optional[builtins.str] = None,
    equal: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfDimensionEqual, typing.Dict[builtins.str, typing.Any]]] = None,
    greater_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfDimensionGreaterThan, typing.Dict[builtins.str, typing.Any]]] = None,
    less_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfDimensionLessThan, typing.Dict[builtins.str, typing.Any]]] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__937e1af6ecca8ea686457ca9d08ff3e328cc3a04ccea78d2772d675567198fe6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__83000bc5073943ad96aa182aba1767787609a3402307ee0e3145a295157cd321(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfDimensionDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__84f386f81d78489bb8a4bd75f75709c05914905af95538ef9e6519f9d749e42c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1cebef8a6746e7562c60d8aabf56932b7673dfd330734dba482af810e12e532a(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfDimensionEqual],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2b174eb3233186e907a494b04f17dde833e5b80a23dbbeb58a72a9ff824118ff(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__265a450c820a51ed1df57174579f04f9bcbfffde2afc79f3e68d586192065a0d(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfDimensionGreaterThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3fe44bc4429effa6904ec07796414102edeeebc6be3b4cc16752a0c0086d93a8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__083ceabd67def1676c4017034dfea6313534754c7a825977c16222e5860ed7dc(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfDimensionLessThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5251647e55330d7a540b6b85d7be0f94618fbdf9da6d52fe94283ea27ae25dc9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__443c9401922e186e3fc977eb391a46ea4432cb43f7202885ed401a5384e48ce5(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eeffb4dd8c533f2a7d21dad38849032133b81a223f70380f09ff5f8108234301(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3e8b7721325db97a5ad9f774b40284fb08e35c6f7f776162de687ceb38791c1b(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ee59801dc2842c84f8a8e686229291ece99b2990621ba16ecdca4fe8f241edd(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b4d721c7e603cbc5d09370e229241a936c4ef68217ca58c43cf4ac4029124064(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfDimension]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f374e7e02b874771e57c7d3bdddbb1ced69d299c042df5d300165edc0c2f4bc9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7a4ce7b4a05f263cb34c50e512afad75e06e78e7fabb17334d8a485d97c54b84(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5c999b6dcf97bf24146634984b34c185bfd25b2ecc252d37eb219211f70d2f78(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__517bfdd2b2902b5371025e7d629893fee0b4f94768da48a68809ce34b02f0543(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1b9f32a113b507aad0f890c6dc5f3666ad4385b774bdbaff4497709ac0a308b6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5284166aebce958082619ffa2488de1a5e181bc446d8475e510984dcb491d45c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfDimension]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9f5aa301b642af4556cf3d9767fefc5e9586d7f9c6f52225d32b574087d0b91b(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfOrientationDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    landscape: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfOrientationLandscape, typing.Dict[builtins.str, typing.Any]]] = None,
    portrait: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfOrientationPortrait, typing.Dict[builtins.str, typing.Any]]] = None,
    square: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfOrientationSquare, typing.Dict[builtins.str, typing.Any]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__97caaa4de4b63c3d7c3895b53c9b14d7c160420122f465f469b2245deb87788f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__063f7329225462612f773a6ab2a1ca32bd61874811622d83464616900a47d884(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfOrientationDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6ba90f2b034f63fb2ecd36a6353b71f72536816f8cda8d507f1a477ee2477714(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0d9cbc2bf4b1251b60a99ad71c4c282d7368fcf5fa4a86d1f14ae6159964c55f(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfOrientationLandscape],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__87f2501e54480aab84a5c5f3eebce5ccbc3e742ea11aad831ce912dabfbe8927(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7855d0f56087daafc1c129eff142ef18cc1fe5a7fda5ba183792243693527c94(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2586ec42643094b9d7201ebc1833f4423740db8b1525a6d9889203d1c036d5ec(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af465bc3b8162d6716164cc55dbd29d80a15fb3cc115e3608432033a65ddb473(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__10d3746677819063c439565326afbd07e03ff9b3b322d5e3ef7f16ccf85ff1b5(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__78d4184ba8499a9280bf8cc53afe63d35cd75efbb95d44ea573b1efb6711e4f9(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfOrientation]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eccbe02bcb0261ff4170e5c13048e7b2ccc3eaa41854927416267b78c773c0ac(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__110fd1d217e51668350b742d1ae0660afe60e817a0afb6c93fded9c1179ee948(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfOrientation]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8097ab6f4673133d94d35d9cf18e39204ec1046d24008b49efd9aad4873b4eed(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__255e178e0d8eb6a71c7406a86aa03817dfe75bd7dca2d0552497d71611acf234(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfOrientationPortrait],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eac16d54fd1bd2fa6c0cffa236e174fbf055866cdb2797ce5d63f38dc47b5519(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__872aef803b7c54cec4969e3ee1d57efc33d2f8bf2e15585d13bd67e761bd036b(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfOrientationSquare],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cbdfb3e1a6e22aada53af00473bb477ce7112ae912415acf5623ded8496c7661(
    *,
    colors: typing.Optional[builtins.str] = None,
    colors_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f5ff0f7b729ff139f3ebabe02b6be93141e9d33cb5015b680986565ada001f7e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__86ea9e19306926b91c5db05ac64e43ec73a73d02694db0aa33f80f1a89cdec53(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f9fc013315c118568da7d0741aa55a2f4fb986bea9e5f1b96f1d0d033a4cfb27(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b814f513ad2067990c0bfe9cdec90da21370b5dbfb3cdd83ce14bfa902b3cb9b(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2fb917d932a6e7a99e7d9a38a13286bd6f29c3d45e88ec75d13f8916b2f5d273(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ddd985849623afd2bfa136e2df6691a102e3f63d4969cf5c2207daec3c208185(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareMaxColors]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fbf762ee552d514cada93c918faee656a6bbf239f6ac209a2bbd33cff670bb37(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7212c82673e38bd160bdbf2e06efdb273da51c17c62c03333796da51aa3b385a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__803dd87832e56826b2e819c2a9f7cc07220aa673c35a80f912c34fc8694de889(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a33f2206217a54bcf9566557d3ce6cd018915f41b0fd9f2d1bd26db03533e9c7(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareMaxColors]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c5962d46655e19805a354326914c6f358d81ad5599166f249a4e0dd34055165d(
    *,
    horizontal: typing.Optional[builtins.str] = None,
    horizontal_var: typing.Optional[builtins.str] = None,
    vertical: typing.Optional[builtins.str] = None,
    vertical_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__654b771f34efd027caf550a344a78ac4338fb5268055e254fc4d540d104e9dde(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab10db49fe7362c623aeaf5ac19189d6da0a24e8ad5e09985a459d113779087f(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6a920d9791723b0c7a8fb0c8661fadcd8953fef220db6f253fcd2ea29e839918(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7f1b104dbc12fa659eb6d9fecfc2a102d6781bcf4ed6336c310b254d202a7dbd(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__22acd98e8dde60da9c484d3a34540870d54294db8c7b13803d5b85a673d04462(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6a109cb79d04b734a20b8ae1f6fa04f0cc86df8d5a3ee4f5b81c1080c8a9a56a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareMirror]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e2d5761c8fb9f39d514ac73cdee168b974e4fb50e58eb13f5194a03bbe2b8191(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fb100fd498675a16dd23b7e44b3661aec7686199663196e920b4b7c05361deea(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__57c93a4a732ad7b3c568de695c3b5a824ba7b6fea639b9bb44b05913a0e21908(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4037577bf301e438712c6987bb3c787bcf28abede6b237b2402e7f28a1dfee2b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__79d51ff8efe7dec89444a34e774f579014c3ba46d0e71122861081bfa4118514(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e2f779a70f21f10bb0bdea5923678e4ea1d33929b06e0409426feac44f205063(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareMirror]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0fb7dd79594a5cdff239932fb7f1f6040a13391e81c06cc48839bea6378b083c(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d732c730937d5a9f206301b3899c5a6af3c0d9ff7c904f67c14586c7389ab646(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7e0365b935d262205662fe435d85d83ca14db7611c38d63274a29d65991c09ae(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f757726dc1098523a4d679d5c79280f306c5b47f03a1a28d611219ce8dde04d6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7b7887aba44f7226fb4d226bf077500e01c9cc142e424a8e99042bcb0ac208dd(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f764f284522ce5f49f32fb66236785b3b7781b461b014896ccf9c57104e81426(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b84df2d66dd55d16422ed4e763fb882d5b86e70754282cd60bfbeb5aa14f72fd(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareMonoHue]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5b0cd27917bd3873be06a01b67fc471e53ab2006528b4558d92189e6c8feabdd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__41bd53f3a95054e75cd8580949ccf597ff4df28406ba9dc671ae44f60d306e5f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__044678719585b147ccd030710a400b6c9a11dd81fe0e0125a6b9f0ab5bc679a3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aa8b0fac638836ad43292573714177560e64a0fa7d9874daeefa4bd20c7a3887(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareMonoHue]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7e81ab5afe7260d27802e5ed4de4522a7e6b49bea0c0680dd2ddf6af7e2606e4(
    *,
    opacity: typing.Optional[builtins.str] = None,
    opacity_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b85814936120388b447704ab31dd76992fc923aa7c76a98f200c14a96df2b1ee(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ae46b9ddf461531fb32a8b5bc1432f740da353bf0b08c52d20e2097b9316182(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a0d7cb173d30ebc5446970e46a46900e0655ae1707bf597550b8924e05d3308c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__89f981d9ae677d8f7cc4f7f9804a7010d217ef7cd702838dae9a0a222e797004(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2504b8b9c570ebe66294660effb7dac1188de24cf7ae7681a1de2e2075e218fb(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6a3f929352851572134e654722e41f6bc999479f417e343f4c26f587aa350daa(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareOpacity]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__31053e37ab51b9df190146fb207183442ba6a0f51e00261c59be272397b36848(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6be04679177a9f6c91a3978ae63f85a368effc92d3597276ee845f9a297ae8b8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f4e594a0b8343915cb4008f6e2009afccf1d41493108f97bd538bd3f5c75e8f9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2da37df1a9f8820c8b0d450fce631a7a6d6651d6f49579764e8cb0872de20529(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareOpacity]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4697819f6b04f85e3196af94bcaf8868c20cfd67e85501dd51d0bb4f8a5b7e01(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__80eee45a22214c05d98612cc59ae783b8b6dd7011674970c3fe8b45c6085229a(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a37fc22d5f29870d434be13d668433274dee378a63dbedf1025ed0c637830652(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareBlur, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__51c2b7600fa7fde69cdd31f59f9e6368c78a39a98bca5f0a577d118ce8e871f3(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareChromaKey, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2af4e95ade68d411503caef35cdb97e9a3e7bf3502dac2b5952ce97a7f104e48(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareComposite, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__384e2af871d4d8f9100e30a01a76af0eb314f2b48ccc12e304ea861c6cd0782d(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareCompound, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__29832556ab43eaf8eebbe7376e9387849e23bec56681b5bfa39bf3c5ba322904(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareContrast, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a857bda28de0311a57a6d2a2da69dffd2851f58f7b9a8b90eefa17531cd1d008(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareGoop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c868409930d40d01cfd7e0b60501f6d256cc61732fff8460786df9682cc40e8d(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareGrayscale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__461b7956bba78db27984714c1da17c26ae371202fcbc29e6318b83393366ac0c(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareHsl, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8b33bbe86dfe646c9988583653790bd263271946949ab0d935495d14a80f8b92(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareHsv, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ebdddf03485d13bccdc35cc56c149057cf23629ae3755ab5ca267f68404dc0d4(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfDimension, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a057913815f06a281a5b9b8ef46fab356b40ea12b1243e61ab09676cfdab91f8(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d07f206a46ab644682b21fc2c388e0fce753630c07ebddc432c9b816dbb4511c(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareMaxColors, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c71c95d4f8d4bca2e8a3dff6b19f68f246650daae5da422e6649b86dd334e4e7(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareMirror, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea8fd05e73c9bb45143608d769e940757b4eea22478a320353b63f9f6f1865f8(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareMonoHue, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c59860aaf1309138cfc34fdb38284f74e4345faefac64223f5e9e84da8953996(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareOpacity, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__731f4877f71e592d542661968f470ac23d88af5fceccd0079d0f075683a8d3fc(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareRemoveColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__deacb294ed86c95dd1e79fdad86a578bf233a4b23a66d1c9e4a5bbb174535c3a(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareUnsharpMask, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b4f7b5abbc6a425b272d24ecd4c6cb2ccfd41f2fe04d0b636d743bd85759dab7(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquare],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0fb9dd7cdce2b9f54331897dca17b8e56286f082cc7511b81dd8fe86e628af11(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
    feather: typing.Optional[builtins.str] = None,
    feather_var: typing.Optional[builtins.str] = None,
    tolerance: typing.Optional[builtins.str] = None,
    tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7f34e4a5199b2e503f380ad9865764fdbdb25ace1932fc218f05889ab883c6b8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f2030c76a31910520554b5ae847a13dd45e6abd1913dad40a05dc460a4e3a548(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__50006e0df4b5a928965183deefd9decde73fa772eaac4ad61d3570c51783daaa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__768c0c7ea882ab0dc8233cbd287eb042b7a07f96b141e6df0061250d08e756d1(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__74dbe3f3536e222f2d2b0490b3bd716a7408d37262a3a5e6e539485b4ec7bac5(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__44ab206ccb25b25c87e1bf8f90c3958c9f7a57bc6ace1120acc15b011e5f1560(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareRemoveColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1e0606b5e64824ca0390aad580b961c900f075cacd9b88aaed9594572cf1975c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d1b900c2505a559e477913c63132644cd9c5b406d7e47f0f9176ae54ae84a20(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d74397682c66f925c9159d1e968f3ba7d67aee91f3401876f6a2e43871303a81(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__02d328a671435307da9642bd23c8b29b8901a7c424dd4df9c825c9ef0e08c46b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6cfee78f83c70a90cfaefa6e325e72c2ef05c44a5802e4f159a2dd69354df703(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__89710d87e1e33e56d2f1b89735788732727dfee031dc945151941224d0000c6e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__74499561995c182ba7a7efdd3482d9108945ef193dc4a42ec3d8f9d13d145bac(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__82a1eabf99c4f7bb3e224a1bba7ca2e0b4491b44a6153619a067fa1c81b93537(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareRemoveColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eaed53949806649ca8b1e0067c8a683b5ed3ee7272e8fa0e3bff9168ebccf0ea(
    *,
    gain: typing.Optional[builtins.str] = None,
    gain_var: typing.Optional[builtins.str] = None,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
    threshold: typing.Optional[builtins.str] = None,
    threshold_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fac93d6a770961711acfe9d975b5f8b2b8e19aed55228cecd048e9a64f0f064c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ac3ab471f97335a0240584551e4724486bec847c7ca227004c5630fc0fe17ae(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d8844db09268b68fcff9d4e91760571d0231482e0ee84fa5820da0176eb204ca(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d2585d6bbe42ef3b5459bf69e0f2be767be998956523ee463bf2ab3450217a9c(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__457a8e60b1fcc5eac41c32be6bf6c9f6e77a3d00a2af0a18a368c5a9d927fd08(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e846e5fb9570b8b04d2ef724700fb040f49e08c9f0f83f40a838a56d53e92562(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareUnsharpMask]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e66c8a1d793661a9f24f6626f944f6854a33b016e1b3c201c74b2a338414948(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7af6f0178401ed323a823061b83074a7f7d1163f3f88366d31b8ee6a7caad033(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__948ca200524cad816a3d608cc135820a7d57776ce0c403bda4852bcceacd9cb0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d25eb45e51092d3b49ad20a658f4aa62b3ab958daed3701ac6602bab7f8c76b8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0b2c9858ea101988ffd1a56cac6ab2f3d5c87b74e21eb88bcc625fabfcf13f50(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__99329708ee5be92cc21f79301d776ac8a88e5cd0fa526e6cc0b7f206247e0843(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__12a28824d7092a3cc4ef1763e7337459d4f01b36c976b936cc9706350aab8a49(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bcdfc9068b84d48fb6f8d6ac8b5c057d1164d43d47eb7a98da5f6ac82870e71d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientationSquareUnsharpMask]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__42a8bed9830557a9a75fdb5be6fd2c72e6f0b5c268805958c6a70258ed80e808(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7ed10b86d77ee20ab5b7e75d48e7059d35b1677635f72979543f78faca0b4b8a(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__53bd4bffe7f26ed0ecb8db55894324e9e746fa19d930f2c833967a260f7b1793(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7c5a53b3d99ba111105bb792432fa1f8ca2eb44df2ffb403db5ce2f4eb0a46f1(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e34f5b21d08a0019987c89fe3092a26e4cf437c21a38c4d048e50b3f2efd221(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__77772eebc1be9c1b149bb5dfbe5ea04985db5c88254ebc5c7a2da8217924ae06(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformations]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6b20dde4256df93d31e0e172b0f798c4b851be46c055d61ca205ace40c8a5e21(
    *,
    colors: typing.Optional[builtins.str] = None,
    colors_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ad3f3613a146cea4649541c6ec1245f8dc1732cbfbba2025b8f2453d9062f93(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__27f0895b68435b02fe00812016cc8a9d4faa93c8ca9d325576444edd6d18eccb(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fe1fd98d4b71b107f1e3dda71e9bd16f3e14f4b082f21de0647f60ac90646e64(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e71d7439e8f8c710161e0a66463d77e1fc2612e16794fdde551c175cdaa35445(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a512df44a04f5bd9572f88e62ce2710d66de8075592fbd4619c19082fa56d453(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__74eec4675436296bcdeb400e94c1fcdb382cb88e1415b6f37d5bb78b55e909d1(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsMaxColors]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1b3adc19236c3288d9de08570f555c7bd1ce910824a63a3be8c9222555fed49b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3c53cf649bd23dbc739f60187cc1c95923922bb187415fec4dd55bb816aa922c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__965ce476d4ed65af353ab1d3190109909e3274e5a010a2db81f1c55fbcbac596(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__06091002087d3cdc84b618b105ba250190868cc1c482782f4b5dd89f03cd4967(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsMaxColors]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fa25128a2ae0587b226051ff9017991270b0d882d2390421b8dd104a7e242a36(
    *,
    horizontal: typing.Optional[builtins.str] = None,
    horizontal_var: typing.Optional[builtins.str] = None,
    vertical: typing.Optional[builtins.str] = None,
    vertical_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bea58e6680f59aa75afcf3dea5068e1fd421db839db6f2229a516d38993faf94(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9f931f43663b5f21a7b121a96ebdf9911ffa71438e5d49b60415793a7c154315(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bde9ec2b28d22f87a84af3b26b7e5e7c488a10c1e22c992e2e1c5f272c5ef9e4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__52417060be6491b25fb9a23f54ae8b20300581ab65361907ac0b904a30da6761(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4bcb3bbea7e265d58820fe3cdbdb9e7a7f1e96c30cf121c2823f1f0ffe7957fb(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1159f5887e7936d7f279b1237abfe01942dc221cbfbb3957a3f5bf6b4ce54b05(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsMirror]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fb1115ae71e1e9b34e24f1033d7d6f3b9622050b30f45083e85889323d38db7a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1e3e3c0034c1f9b877fab62764aabe9ad31fb023f852b79e57f9db4f4fe226c0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d43cff59eb0accf181d4a9ccdc8d2aa67c75113305c91953e1ecf37550be8d2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e75cfbc3e63c1a4bf63d8d35ab6c60c0b564d1868bae4e9f5585458417cc56ca(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cbc9944fcfe0b238bef3ca520a0a3a5369db31d3013bb016e1dd821ed58579c0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__10b14a9e4d26816362abab12fc6f1b9f5dc1b1c4ec6ca65404b7a1eb13e92c64(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsMirror]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__021d1a2ea3c777b1a018d4f7327f919680b5ad144dbbc07eb97132cc9c0345ba(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9e2c4f46c952e05c738168ce3256528a605b061d0a75200fb9deddda00d5b258(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7ed69679a61a3f7817ec2ced0c98db28caedaad4c77592470093756f4c9cf7d9(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__db85fb5a133e7b25cd2076f8dcd2a1cc3650b33b957a332138a720991334a928(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a25c5bfaa2bef053211fb60de1148af24a497828f8e4f26ee67d16239fe6ee43(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6ece2d74e6195d2611a84d2bfb848c2fd57d5abe96c19d1ffbc3c83e32ff372c(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f03af1b03352e30687cd0846bfbebdfc02dcf6e258cc68c06d424d98013d2b52(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsMonoHue]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a5809cb8f11aa0ed459aa7ef629eea7a6e1ac4a5ed5eb1f7310f4a82bfb37534(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5d2ea9844191f1a40eb6188551b40d73bad3385bab1dd73adf4d355af216d430(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ac6d71208afc70c8c5fa0d0e08ddcb7086a9a4d7cd2631857bff97315266377(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ff77ff8b76d025aa6d9dcd2bb48da0e14b070ecadc63db7f112041a52ee510f0(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsMonoHue]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f65f680fee4be041fb74daf24f8503ca03c1f02520bba6283f8ecb25dcc6043(
    *,
    opacity: typing.Optional[builtins.str] = None,
    opacity_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__55a6b0bda801d449c080c64bb583149d76e6b97988582f5120c751d13be56a20(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__27e2f3fd0f5d8fb982cec0f22d7b41a150ac7242316c6397af2ade80a370a7da(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__676f9b7129c4a852e4664da16c1f739fff80d4c8e577caf379256ee8b1cb4803(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc82b8285a53188a4b01d513fba28c2707f3a703d318239e08652007927e884a(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f21acd67f6b2ba5b9f8243923a1d94cb91f9f5123939b4db6bb142c93230d3ea(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a2555dcbd7c5099430bb5c4aad56f3d522b4782ad2ad7ae660b4c1bce0e8a858(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsOpacity]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f884b20caa93879979650c094465e396dda6c5bd5d12ff82afbde50fd79d493e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aca68a6f450a276e70b7a4af61ca2eef7c2cb2392b8276b98a7f20e6304862bd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__86adea0ffea112f37a7496d799b0cab646961a54135c8706c121274aa73150f0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4b9cec68639d6a7c032140de76680cd8c811517fb5322cb92e26bf6224869292(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsOpacity]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1d38a71f0d24f74079470f6ab93edb80074412b5edffa9542e265ea5589fbe72(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0bfd9700851f6cdb86e853ca2cb79c756c0fcaed76df89c399cae6ce984f5596(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__11e43ae178ddec3922a25c6f9c47775a9fe5721a99b827d6629e6fa0ed156a08(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsBlur, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7bdfd8c1f5dc85fb7e6ae1562944d741f0f865f6990f8817d3e354bd7bd24d1a(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsChromaKey, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__716bb7ce39df9442cc4e0e2a3c66cbea6dd1da2a4cd714f0607ab4a78a3117fa(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsComposite, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ebd80ffcc6038d1566a01ab1793587a607df8d45b02b7695567914f765d48422(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompound, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b991575f5877fca48617cdba4bbc104351c500a6699972b98393b18d6c2f1dd3(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsContrast, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ba4e125adc1bd4db06f23309be6541760185076020a8328d1d0481576eafa68d(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsGoop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a3aa5db70bc8c1cca349c540d20b94f9cca239f849d53fa641c673b545893aa3(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsGrayscale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a5dc2fce06452ab5b9d8d0d364d6ecd36265e3c8bb99ab86e3e80835c35a0b5e(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsHsl, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ffe7d60a849455ef83257b9a6e9ba5843b76c4bcf1db15c53172f08f57926419(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsHsv, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6ac6f178b9cdffa331d77c7214225947aecf9b75f4b48fcb62a63d5db5a0fdad(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfDimension, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__29058343a9044ab334a847d289788f108b4772e704ffa89aa94bfd870579aab3(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d01f9624c805a5addc2460cc7b593dba5eba40da45d171a66f04c506ece7f30f(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsMaxColors, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fb424cfed4f2975d652c54ea4ff15e639ae8ccc56f4d8451b8813447b308c59d(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsMirror, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__42decacc63ab1e49e267d399368dfc70f62258a1b64e9be42cbe2fa163fe708d(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsMonoHue, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__826fe023247ce86f466a2bd183d69459943f1e965d5931b2334f3b365c4bd08c(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsOpacity, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8ba2400b769f0f71cd0d9770ce1fdcfa809bc8c781e72b3243ebe22055e170fb(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsRemoveColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e3326b6bc064b1dd58b4e9225f727aa3d2be788b9e70a722b3218a208ad76396(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsUnsharpMask, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea7063b35859821531c6b1b3165f095f353c1164676d761a4b877e160b2d5cad(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformations]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1aa14b8fee3b034c28f88a3d2f5850bf9c830063e1031bb38c310c5b670d9106(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
    feather: typing.Optional[builtins.str] = None,
    feather_var: typing.Optional[builtins.str] = None,
    tolerance: typing.Optional[builtins.str] = None,
    tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1998cdfe2af8d9ecfc9974eb34bef5fca09b89dc2d483d1bad455beccd629750(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f5ee1ed27df1f87cac080561f9dbd51aef9c3553ecaf86819a763bfb8eeec53a(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6427993323812e77e579b40dc5d843755d25d5cff739e05c6931c712eca345fb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__810b3b6fac5fb03470c033c4ac8fb3aa852990936aee0783545e3a5533c4b94e(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e7e68c581ab688e93bb10fb75e8c17cbbfac24356f07bced4ddf2796fe739e6e(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3cf5ac0b804f6f9ab43e955e8eda1e0a5f4f71f5a9908ee9c67fa7b5f1181c37(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsRemoveColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__568266c4602aa81d082da0e32b92c4793b3bb54ac6b285959ba0d392ffe98edd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c0413348a599d368888c8b4b212bde0e7ca51c0d3bbbb7b866765d44a56b13ca(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__033631f5aea458eb808eb5a1261b8f3487534342d27669c27b93d5f767ddcdb3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__05f898e26e67cf985ce4b1079e0649e766c221785f11d46006ce96f3f60a9643(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__017ac9047808167dba07f449db115e411ff797e60e3dd0cfd4a9578548081ccf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a069bca87f0d7a09e41e2893514f6bd4e8be402521b7afd094fd33e40298a82(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e970530e2b31e430fe9e8806b3a8f12ca005770a3b73e27593e7670e6aa81070(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__62ad5dad0bf2ee556f0726dd87af52cdf745c545be669b276b2eebf369514e55(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsRemoveColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e3d9bb46c4c3a6263c7de79f4d7ae39a33155289ed8b44554508fdb2361ee8c4(
    *,
    gain: typing.Optional[builtins.str] = None,
    gain_var: typing.Optional[builtins.str] = None,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
    threshold: typing.Optional[builtins.str] = None,
    threshold_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__75dcd50dec69cb2ecfc9f45be5c80c143064446ec463f2bb11149f6ac2f7926f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a2ea21d53152805d8f2f8fb727c58f9bc0e4888cfd428715b118f9afe93fcc13(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f2429b3efa16e0eb06ef3d2cb17aff972a9dfa7863a13db3810b358d9f34ec38(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6539f8ea991c2e6526f44ca3a41d7ed08ef7df4ee426241c41cdbedbf676c77a(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fa8fd4c2b10f5882df2df04014495fb697760f32d6bc56a3edc6780c1ebb0b39(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4b1335881d9068befd07c6248ddc68145ff1f233c8047b27d143df2fd2b84ffa(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsUnsharpMask]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__098d511ffccf34b1715f46709d9af1109cf0e66f19bb9ae4ea299f3356368d98(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7c95c2dce82c89721271829c8020cf2a4f3422d33f4298fa35295341e19d2f72(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4f9ddb8ecafd6309a7d2de7b2cd6cd881586dd6ba448bd256a86c7bbeacb29d8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__baac5607531b1489879aa0754e502824a35a8b721b2b68e89d348cc319e193f6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__118463a1bdf7e9a5a660fc3665c7058b551930a8e7366cce1485b692fef7fd46(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e27a2503ee98c0c58618f74924de3c7fb3a9704245605697d1510e2c782662e7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d5693ead62cfe295f5a316b7a2f9ad05adffffd25c289895bd918a0125c51caa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d1298a3e25b48ff01c135e405c9a09c5ce383bd52e8b6603c847d007664eed59(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompoundTransformationsUnsharpMask]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4dbcbe4b2ea80c2f2100647e4df7566619a43d2fbdae57cebdf5a36944ea58a2(
    *,
    brightness: typing.Optional[builtins.str] = None,
    brightness_var: typing.Optional[builtins.str] = None,
    contrast: typing.Optional[builtins.str] = None,
    contrast_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__49b9d07ef96423b127ebd2e6769c71ba015c61b25d220cb3947d8d929c5532aa(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c2d912392b0cc2f4d46fd238faeb1ed5b330a12c12ee37ff0a8c9f1494a488cb(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b4a613ac529cbc7e0944bf02d9e824872b176aab78262ba304d41c5be7106310(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ca5a3b58fa75318ff1cd9ae40e71d30254b38ca32f1aa2ea5eba96c1d648d62a(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fd45c4055b6dcf01fcd22cc60f93b63c2c083eed64f305a4485d48e9054dbe08(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cae002dd272a8318df9b33f30ede80b9a43072087424abd3901ac3f6ae4f1519(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsContrast]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dbc690446d91f6644c7fe043b99e94bfd73a16eeb528abd6de272d7829d68452(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5e7fb214dd0acd15646d522ed73a8c6c909790797376dec4efb219466c576571(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0df71545d304a6c30d7584bb56e587d0c947c5b773f1b7965b70cbf345dbde76(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e7b27a95ad8923a1c6c508a2c63db17235486f375964cef5303686f36e17e41e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__008384b551ebbd0fca76896b1b42e6d5d4312a03c55f40468690c16ed4c3499c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e16552e0317e1b34b0076aa93420fc0d8241c4e304e13af4a42625cece2e431d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsContrast]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__92f4350b78ffacd7b128edc2b15d77a935634edf5b4f1eb20ea4ad759bb26d8b(
    *,
    chaos: typing.Optional[builtins.str] = None,
    chaos_var: typing.Optional[builtins.str] = None,
    density: typing.Optional[builtins.str] = None,
    density_var: typing.Optional[builtins.str] = None,
    power: typing.Optional[builtins.str] = None,
    power_var: typing.Optional[builtins.str] = None,
    seed: typing.Optional[builtins.str] = None,
    seed_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__53f65d65d657f7220d44154a829da2505f8d71c00fa062ea417bea996fe951e5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__522fee3d9c806ff93fd81d0bc260d917c63921b960659eb38fc008f45f4871e7(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dcf17855966510d3bf309de297f802ff996a0afc916b1d812516bc876a6d3cad(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b9c942abdfafe5a1414a495744f8be132c880fb7a829b5bc8dfaa626753e9272(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__919a5b03d5c2fbb31f10e690d7fc9d942fcabcf5ee94068565e979c368193d5e(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__76f121771a975abff4faf6944b58b7b9cd6a47b63d4430f0f9549e3c79b01439(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsGoop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__47b44f54dc1bfba09382f7d0e5c4cc4c944fcafcaef3903c95beaeda35eba22d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__74ef0c08ce4c296245371fb36cb9c6444ef6f68647bae251179534342a1dd3c3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e4af1f8105ca4b5e7f3a30a398c4f1282c6914d92047d1bff8933d18d803df67(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ad767a52321bca3b7239b6c4458a8d8f3ad719ead2d491ae19da18e4eff701d6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d8bbef3255308fae852d75277a8206639e2fac696702afae37cdcd83c3e6c60c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3649f95c306cc229c60841f870226f541bcae63c90edaf3e344f788299377e0f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c8780599cb55805b1ec51ca2bab511d940773a341fe4e328db0a6a213a72dc24(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0748d478b41281404cf4f478cf72c3434aa82ab557ba82a5fe6db5e93ab12994(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2fde80d0bd0fe51306a0e7e97c75900799b18e32442f6f9c0a93b6b3f81bd9f1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d1c4d2a1c08a1737a405beedd54b719b73a201656e53dfe2319be8abee02e01a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsGoop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8f7d274963ae381f0152df080e513713fec93da83b16b2c6d5497bf2264b091e(
    *,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e37f556b23f7b53f735e58ca27e0d299bdcb136ebb667b81c3f02ab516bb7284(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__21360cbf085c461377cd147cb578982ae4149013319c8c027b428267437ed42d(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__85e0faa61f482f3b9c6157412e3d8a0106514117254ea31858e9a7c23ee5828a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5974c367227e6c5806c35ff8cd81de559fd63c2e8a9178be5c1a480fd9544422(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bddf9fd3ee41d3c2a18e98f988a00c2ff330eaac0abdc6cfc756f500b9694819(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1157402b1f72a560404e82b2727ccc60c2461b871e44dc4eb111eb9ab9c0d986(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsGrayscale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9df65ce7ff0ef6d1de4797b9030af9c805e0ee4b7c5259be0ea8f3869a7c0ae5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__89c6e2d93605565ffa58c4dbccfc59b8ae8e4a88d4b8ed0c7c187d2a04dc35b3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__58ad0d781f45848e862d32e3feb65182d95edb03d6e536d9f4fc307c8e2d0be8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b23e25f4bf379383d4ed088635ef24382a04f418befee37ddb59aabe0ddd5cd5(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsGrayscale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8e93f4a4c028f226092a258fa7181bd2e96ea0df5a8e73b8b7f67005d5bad443(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness: typing.Optional[builtins.str] = None,
    lightness_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f950e3b1b46fccd11e25dadece636683baedff189e87f9abf635634b1655421b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c5180f44fb0fd381658a56d4037c758bba8e0e3dc6d12c61bd12eab4e6e74507(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c0d461b316ed0fd16a56b1ed5a048d3d02e1045a93fe5e143a03d8693a2c521f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e05c6d2086812de987e640c6b2d40badc258e1438059e24e68988a2b23a47ef4(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__30b07c77b2faa5253284d1d57e322ef17145b2024c68d58bb7359ef9ddb4bdc2(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__936c0484382f0d157d2aeafa081c432db103b2b91269f870c5933c99fd5bd219(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsHsl]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d2f54b7006106d43c12c090ce4f480ccbcbb77148072ed69dba39cc2c17a271(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ce9fc479628e097a66d987946461d3c244bfe2d7c9198dd7a051595f193c019(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a5b739c81817c10e23f43292d010a5c11f57efc4c879565404bd17e186daf70(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2c2a8c41f7de154f9e1c622aa377711a0c963e290b639e7085501e3e1b6c7eac(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e01534452cdd422f31b31fe9469c26b45c8b94a6b1829bdaa3edb9d3fe7fe9fe(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ec70a4c4b4c99f89c453d2642f58286214901cc8ff7725e2c8e9302ef20676c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df18f596564d7dc5c74d6ab7c733e5ee05d1271ce4cf171d09e8ccf27389aee7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b8550e08623a3c2f3fc2bf8a12af0cf5ae7848053658d212e9ef6480e032f404(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsHsl]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0f02a6deb6e5165ae25c58de2f2f330ebef3eb78da83f843ed3c0aa5c3865b8d(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9144894e54efbd9a1d79bcd11b1abd5bde3bd95088f495146fe74bc897fe6763(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__76f5cb4cb4ec1067fc1bd27a248fd491303c1036fa636944aa2dc16e51ce33c0(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__44ea386e59d3c1dff11d7b6a11b45a78736d0b83dd1f590f9e4a2ee1bc8a136b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a10e7287015e56e4414d8e366f53d663f768d5941ecdf48b26bfc5738c51693(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1694f789ed6bcb77e2a66f83bedc4a01f6c9edd7d25125218494ed86b7bb779f(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b2131555a67d38ca6ebd70b6376254c32f996d69bdf4a46e001d275af1729b02(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsHsv]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c08ccf20cdca72f24b831a808cab75b07e8bf854a6837fc560d5a912901af774(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f7381a01a4e1f5a2fb777f01564bfe70888eb3e8e652d2587cb994d009a885a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a11352d6a301c571d2c4e038e8e9263d731deb128f61899d2bdfaa878b1c797e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ae57fc2e18ff1fa6a0f00c622763e5a71a3f39561b0a876cc5000c026dacfcf3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b7bf2b69a6c1e2557a43ec4801b07f8466b57a0ba64cd206248594a731d55cda(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df9c41aff2734b2aa798a37201f4de9a0753f0c7fb8335234633b099e9a53c9f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b1df125c6f6b6c02996795c533c2a26ce2e45b2507dcfc93da5952b5c3f7a2ef(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b2a7a778fd86f77da04905a8cfb6496197f3127c4460bbc63bd86f111654e668(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsHsv]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e7175d0feca651b70c4a91c71c0fe4c1a848e281f1d7fc912301052c06fa9872(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    dimension: typing.Optional[builtins.str] = None,
    dimension_var: typing.Optional[builtins.str] = None,
    equal: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqual, typing.Dict[builtins.str, typing.Any]]] = None,
    greater_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThan, typing.Dict[builtins.str, typing.Any]]] = None,
    less_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThan, typing.Dict[builtins.str, typing.Any]]] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8b4f22ea254a147b29603e5eaca532972da96a16041f6c453012abf3a3e5a60f(
    *,
    background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
    chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
    composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
    compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
    contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
    goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
    max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
    opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
    remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__071c1a92628c02cbe32bfd275a71980529a8d4affbcc68d0b10531e86211fabe(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__efb70c631368b061c8df8656a0b27ecd23aa9522e7a6fc1948d27d36ed06618f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__393109a4357c79c769f48c1356d0193c8ecf52f7c82ecda99d6ed5ae99e34b93(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3406b0c7a317949c9148a2e2203982adc7211d0446043440037164906e2465c3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__75d7f5eac874067db4333fc7b22ff27d27a6e9a1822acd9483694bdb70f1a787(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aebdc5b3c2d2d47470b675b4a8a1b21b3a6545f1f29211e4de048a8401ca2baf(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0f9f1518e189fb87e4c1546fbf6b1a7f11d8e20c11cced6702cc2b3e9633b5aa(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultBackgroundColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__77f2e5ae324a3bec545dbd15d5493e94e8d324c09e752da90399bf0e3ef268ae(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9f6d3d4d5d73534ecc56247c66e271a1439529ddbc46569fbc2952108a0d72eb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__49b12a224ca575a0315e9f754eec2b0988e06ae34eba88ecd0d77453a2de4cfd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bdd495153f020c8358889c04078538c2f84544218d5d2d08655c825ee3d82516(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultBackgroundColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e33e40f3450de3aa0db965d9b2e510b8976f215c2a94c1bace6a84b148b50897(
    *,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__89efe30467fb79b994fa93c859e4a9d60bfd5c55eab2a7d271995661ce25bd67(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c95c11468ba66b16b9117ad70db4663b018ae273588a8f8d0960289cc3104efb(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af926387c9d199d39be3fe67dd2ebb97a76ef124e0fd265ee2696bf52bdea474(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ae6fa810a363d5b97a2d40a49fc9fcdaff35ac045257a15aaaf59bd8542cdfbd(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__36be0a4e4b3a0bdbb7879aac77c902b74285c82833df50a4f650be927da442e3(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7235eb76a76557e1fec17639f83f15096fac279b2ef0f8da0dc71931779a618e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultBlur]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f83050f277464df81bd0373f098bdb2b5e1fdf7fce18fec9e7b779833d2f63d3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ea3f9ed913e1148b96085800223e820b5b36f307972a8dc5a2f4bdcd15588b7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3b3ea013d2d2057edd5c09e0948b2c4f5649b10373607414afc91e4e7bf0dbfc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ce1caec344b4d716ce23eea02bb2b26df1ccf638c19ce669db5c461554079db(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultBlur]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__12ba1c5cd5614b5698b83ff4adad22aebd12a1301f9be12884efb50e12ac66a8(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_feather: typing.Optional[builtins.str] = None,
    hue_feather_var: typing.Optional[builtins.str] = None,
    hue_tolerance: typing.Optional[builtins.str] = None,
    hue_tolerance_var: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness_feather: typing.Optional[builtins.str] = None,
    lightness_feather_var: typing.Optional[builtins.str] = None,
    lightness_tolerance: typing.Optional[builtins.str] = None,
    lightness_tolerance_var: typing.Optional[builtins.str] = None,
    saturation_feather: typing.Optional[builtins.str] = None,
    saturation_feather_var: typing.Optional[builtins.str] = None,
    saturation_tolerance: typing.Optional[builtins.str] = None,
    saturation_tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8fbbda4d925037cc6eeb05fcddc88be9fe2828a18fa13e438adde39a34c9f5e7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eae27dcb5f7b035b4358452b1a44f3a822c3cb5779d96ed7b9a3f8cbfd0ac644(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__74c21bad9ba92506a4ec945f588813f35866307fccb19a81fa5f25848f9a7284(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cf874d286d6b385f53eafc07f7c419bd3e4743e478269f9fe47a3e596cc8963c(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c7a7e4d31e88b61527d27baeca70d01f5953d9c20588178d7a956706b3aa46d0(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c9a950706ed62fbea2b99529252a0ede8ccca9d09c0165a21ee3ca6608871f4c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultChromaKey]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d9c5fc69c79dac93a610de0d5858ed7a79d4353b5dbe4322a85061e1789fe027(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__caaa1248fadfacb9d6677ac89a840d2ba281df93c81671a828d1899b120d5c34(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3b2c32c39218e094c9372766ce080a94ea1afe5a9203912f07a58affbd135fdc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__10ec8674c10e7aff6e39863fc4a6b0c5710aeb502839ce91981422ca4844e8da(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7189739bbd09d58b59406f323884fc316f7a6691f4b061040360e815abc024fe(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__36a1d686b0d907bb53f42a53caac419515bf2e4b1ea3b5ed272053a4b22a96ed(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__50ec50b760e8a5649012b20b8c17aa0660deffa3c6c6a557e36d62ab0df12212(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__92914d538db9238fc86d26afd5c14478a8b1f02dbe8d4787adee3a475b86cf7a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6cd63d8164828f870d5ee166ad0b72392fd97d9bb25057f7263098e21b236bfb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a8c9d0758e96f35856ffd3b6b4ab10f0361ba6c3f07dec6adfb6c90d965003e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__881c9424a92623fa51c621ae5ad4516c946978b47f0cc36c52055dc2e509fccf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c630654f3cc1164fc49e26552292b30108ed642b1a12637e001aa7f69cb88880(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__61fd1604cc04c0df63e0c07ed390811bca9bc3b768e850c8f175cf5521925102(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3f3f36a8673a97d8817dcdf58ddc0261a43ab2a959b2f6f89f55640c6a0fa337(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a1c8525027709933ee81e3fd57536a6f1affeef92df30af30b13544e4aa0e3e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f22c3f45a369bdefc1a32850014c54bd7b5f2098ffdb702361412a0414006dbb(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultChromaKey]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__22daa4f161b1997d58053941036af05c1ca465476b3e18a0ed617f29a72307c3(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    placement: typing.Optional[builtins.str] = None,
    placement_var: typing.Optional[builtins.str] = None,
    scale: typing.Optional[builtins.str] = None,
    scale_dimension: typing.Optional[builtins.str] = None,
    scale_dimension_var: typing.Optional[builtins.str] = None,
    scale_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ada14cddd9ef347ca322b2c9d920f18aa3a298b2b2608246aef25a46dfcf889f(
    *,
    box_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageBoxImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
    circle_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageCircleImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
    text_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageTextImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
    url_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageUrlImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dbd5c52efccb8dd5db24564d521390396e3687e340d00a307e5aaf31f0d959f6(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    transformation: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageBoxImageTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c1ce6e02094864043467d91c26f30609a2e3be241f237d9f173772c581079c99(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4af34b7c42d75c4b72bcbbc97e6785f1ab6b7caea76cd68fa9ddcf52a8298c8b(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__28c8a5a136577f7a85a3de52bbd11c2db34394e449f2abbff2e15f880abed269(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af9aaac1af9b6feb830097fa0b57a22585cd974863792e15c8acab9c0a95b4bc(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4d2b05b3caffc291e019b7b551758123abf18dc37e8876c4edecfbb5b9abd319(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f284a3cac10df82357a8c1a813eef145632ea13c4b8058a07a275b993a893528(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageBoxImage]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9f4b40890d19edc5238fb93ec14faf21f64636b1f97d356c205b85b58faaab44(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e1c6b75e4644fd23193d6d9f004de3d87f46c31d3c636d4586aeb7b082a1ce51(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5c01c784edcc46818a164cd5f4b7fcc45ef1a53980e12ca246a37792bd9f677a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a16c65274a2eb7ee2cf5967b9cce0b1370996ed98c864485a385470edda0bdd0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dae410f3db77f9ed366019c884808e6b80b1028d3a433afbda8023749c3c0c1f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__80750b7e56716410597836efcaa426cf7775822650e1be6bff7f482f1b65c9fe(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a2c449ca3479f842055a72b460615ea4ced4dc980ca668d218b6654ea0d0fdf7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c60bbd79af289871e4099104eab874b8b84b8050604582911eae9921407e449e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageBoxImage]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8c6a69c4effe86d16d5573cbce498b0b35eb703aff73071ed44c6a2beddb68df(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__39b60ae24b56a0c231d4be7f32f55d052a3fc7f2589f9e8bd2c8466b71acdb76(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageBoxImageTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a0c90491fdb25b1bee5465e38ff371ef75c4d36ec06253b1f188fbb017e0fe8(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
    diameter: typing.Optional[builtins.str] = None,
    diameter_var: typing.Optional[builtins.str] = None,
    transformation: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageCircleImageTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__20368ec3e976fd3e87e90475e89503c886373135fdbea10cd98e15c13260e9c8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__054c7d40c49e88a0ccaaedd7ba6b06dc3cee57a671f0f005a9df6c0110ec2e7b(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__add5b2630dd83b317aca64b21da434750b8c5e525917f3b3f8c39489173b6c8b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__062080c1d8f0f70f02d64a419014b14cb2a54db0a2cf4f09307fcaa2dc75885e(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f20e95f03b760f53527fe66367e713313c1161ec37a1f409f3694d83d0d9854(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__27d1f205595a4e5f46265f59bb2a9623f02352e34bbf45ebbbdd86b2bf481321(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageCircleImage]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__96895d3a60fc451d8074fbccc006e47088b94338ef19416f5e70e500f649ae76(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2930d4831afabd5cb204a5f3432a76b1e0026390e7a5f86b87820ba4f16e9c33(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fb46a46c8cfc4b0c62eda0ff86bf6fc7c22ea9c00ae4f03f26a31fd4df4f1b08(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0f6d42c53f8c8635de654f005fb2537d63b53fdbc627578d1477b4e2bce35727(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__65489d6224389080fe7ca127d9818bc239cf1886d78d165aff0882fc5a72a6ce(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a1052afabed53620f6ebff66dac552ab42dad4b68ba4e411a83a6c927ce4bd6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a2b77ff25190f4ddc7bb233d7eb252c1b366c0e916c596316f7cc250c113dd04(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7441f23fc5f3b72aaab6e0aa06820b28d558281b6442173369500a54994f436a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageCircleImage]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb91058191f4eebdb6ef83d1af0c8475ee11ceab846ba85641badddacd9f4cf9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dab20ccc202e4fb949296e672b3616233d469bbb0348f21a4244807882159952(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageCircleImageTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2c4f8578dff3d9ac0b773f01d8b0a609da3f9439423f16cc37f9688854c6e340(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a8351dd379c6bfda987b69f21648bad1161e528955574a9315f946870768316c(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageBoxImage, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__068f4ff6bed4455e112860cf01b175f8ba37109a38ad368a5d94247debc0b842(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageCircleImage, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f62159a2362ba2894fb76c7854144a29205d55ccd0b94c25c1565209cbca594a(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageTextImage, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6ed2c356a4d5a87032e222c9d1cb256521fcc9d0e8d48efad0a477ee787c44f5(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageUrlImage, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__63814743f0565c27355820c5e7ca77dce25afa12726d228aedf051637bee2511(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0c735a5abbe880cd582e7a9a77dc327710beeee7dce1f354aa62c9f53f6f0e04(
    *,
    fill: typing.Optional[builtins.str] = None,
    fill_var: typing.Optional[builtins.str] = None,
    size: typing.Optional[builtins.str] = None,
    size_var: typing.Optional[builtins.str] = None,
    stroke: typing.Optional[builtins.str] = None,
    stroke_size: typing.Optional[builtins.str] = None,
    stroke_size_var: typing.Optional[builtins.str] = None,
    stroke_var: typing.Optional[builtins.str] = None,
    text: typing.Optional[builtins.str] = None,
    text_var: typing.Optional[builtins.str] = None,
    transformation: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageTextImageTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    typeface: typing.Optional[builtins.str] = None,
    typeface_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4d6b35789753b4ab2d324b3c0ead2fe7222dc8101e16724b3a258cc6a04a48df(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__04c646411dc28747fed1b98aee48e701c58cbe1526f69d0f8b06196f80b54f40(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__144d54f575bdf3d750b8989e0f1e2c0c94a559c9ddd6c68c94ccf135b60ce939(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__90d60cddca9cdf91d941a463fa0033ec5df14979ace780b2bb2d305301af292b(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__61293f9ac0fee2e7f4024eafc99516a488b59f15d99850ae3e5962d95acee165(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9915209bd865ddf971fe280df816243deb21a40c2f538026f2f1e75f2479644e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageTextImage]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4be52081d993d45022f33c97cf23be00b40070b6d290eebd6d815f46d5b11065(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__46d858df28fd2615fd771fdc4bdc53f8bb61d6f5f8095d128b5450e45e99c0ef(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cb94893e4504436d31ee2082a703e21e9bfe392fcbc19956d2e0ab0b1e8b8af7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eeefc9324d11116575c6e30bdd5db824dcd3d5babedd7645f5cc4c3da256cff2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__57ab86f1284dcf684886ef6e3ded5045e37c66469bdfdd99a466cee3b7cbfaea(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a0a189d49532b80e681379fb666ba5c602fa6ccb7e8b6852fda2072e900ea85(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__537821f9a4f092f086d80c0479a609a7a1fcd20f1f83244b2c17679c14a001c3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f17e727acf8c3cfb76920fdc015385655baf00f72ce1b4a3b996af43519d0190(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0302d1a6e456fd7778cfb083b2b915931e50e3666eabe92a74a0d70146105266(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4471088775534125e5f14daf557c374328d03e5529be7ec6d133febd832e596a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__817fcdade0572c946d1786601c4c3f1b4c96f76b07c4b4ee629ecce636053509(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f786005a31d1839e10a624d605b64e9d9d4e9321a7caab359ca9c6065096ed05(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ff070350b2aa615c0d1c13de71dd123e612f257fe32dfa85fa3dccc2f56829a0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fc014142cc72db9cb43b059087e4aecb85a888aca786332b3b97da6286d95a0e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageTextImage]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b3bd8ce8e402dcccd87838b60112c25bba782273ba89203aa0ceddc178fb2a27(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__39c66fad9796b2b7957c8c8746cdb3e28688abb061b0b54241de7ef66407872e(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageTextImageTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c7a12e961a61959fd061507343a597411c9ab4dae4a9df6d6bf7bd9b6bd8ae6a(
    *,
    transformation: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageUrlImageTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    url: typing.Optional[builtins.str] = None,
    url_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3d179d960ad66e7739bb84bdc91053a1c079e764791eab64e8fd3f187f721e50(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b7ced8f2d0a07509d32b08d193544682e221998492161aaa3bd07c4c0fe497d3(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c66408bd26b06e29e834b706e14456768dc781c988fb183d5caf30b9f26f4948(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b2e1cf29c338b82575b8af7c10c6a1c25e2930e35de8807a68e0ecf0af3ddd4f(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d112b14f63ac3a5c44c1bb167461efba06c0777c4c7b9e96a7e63b2611b91cb0(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c1d7702d1c2776f6660e701dca1df97b914eb704c9f18ca22b10e732f934aafc(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageUrlImage]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be33cdc62a00e572f4e754f1093665a8d7353a83675fb81fb3ab45e895595e62(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e6fc1dc9424b9389f17cea96d7d06f554346450396b7657599b3cfa65db11446(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__da138c2eb7c8b412fe97350629e50325a5c89dd52add65eae2ffb434d4eacddd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__163b65733b3ff88fd72d9994af375d278675a0351471146aeeefd174ad4c814a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageUrlImage]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__555b03f12cb932831a72d36dc2779cf75d39efca569cd71e7f0489f82e26b06b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3b202d4e92a6fdf72346c9d6ba799e467573e5702e4f6d50bcd0ecd3b1390b96(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompositeImageUrlImageTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ec169258f75dcee4a88b36e024800afb633b5d184a271edaaf95921bb9247c4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d8414f23da0b546ad808e65ef1723d532883d38dd1d490bbd3ea2bfd1276e015(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dcb5305cb0ffda2bd3dddf8a38a16a2f46dad33ef0c0255d8edc44e81e5f979f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e483fccb677053c9e2ef81fd447402b90f4a18d3ad1340eded22b444477c1e0(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df6136a886e5f8952d9036d03b0777902bcffb0d259b3fa5019f8ff18673ce96(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d256871da703b83a97d5c4615a06df1d46547d805996ec6babf6e7e0addc30a8(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultComposite]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9031b1bcd8b4444e321219771b171d5b31922c924f1b41c72bc6de00b0444b38(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__51a3321fbef6920103e820e5bbbf999282569350a0fd6ab6d6d8e551cf7fcb63(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f95bd7c99f652f99519c9b995e397f6e9a7f79739b17314639f55ffe4c19ab51(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b006ab50245449ebab7be5621e1afc0041619f9ddebd1bb9cace89bc2efc833e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__561d51b51ba8070f6c8a0cfb58402717757c75b105db1ad00b67d1c430fac985(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d04ef6b2fb698d4caff1c5554292dda738828b016e4058b3eaecc2f02167b1d8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__313d492e13b36c08b8bab6882e43386be77d8fd62df64114dc7905867f2bcffa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1330d3ab871acd64c067925a25a7fef5f52b9f1276026a7d8ce388ecde27ede7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__817bcc4a91234f6fea5a3b173ec8d66439cecfa55826ebbc1f08e8c714aed22d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b3188c58ff7201424933c87d25dee5e7e8e645830545e71db6da97c42e4e7c42(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__147b722020e37b9044a6bbd360381e8a8415212e2e116912a966737d709d8608(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6a2c592625e8e0fb7c1d8b9984cdd26033c66d9999973cb28903530bb794aa85(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8f030607d3015886b6377933ffa2448f160ccf364bd350b76a47c123765ee44a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a9a1829005ce680664f94172c12efe0e8bbcccf4197c29507c04e8861b5bd8e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultComposite]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e4e1d7f577344231f00f270c105e18353f57ce3ab2c4f25424024e956480a4c6(
    *,
    transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__96512c0cc78401b035059026963a7b7c5b76ffea1a544f35e8118a596805bf53(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af0fecc6e3ff6c73926054a8f754d0798497b809481fde8748ee654f0f57759f(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__518f72b68e38c72f67cd55ead297791fdab1a6e26f933081d6c97c0be1dd7a54(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bdcdf31795364747db12719377ebe3e6129630a612758bdf61e19e8b6781654c(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__15940e2e551716bc24725cdb254c09960a603fcc453b06a00b2954e8c25b0aa2(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a516f1403d283ed294c2a6c296322f6eb2736299f6522a068b4a7e46a2da567(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompound]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ed5955bfd6db85179b0d747bc37897c36c12ab86c151bbfab41ef8fbe1dbebf9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a96ed93adb4eb813c156d8d2cb0a4a459096e21bf4906d2be508d0287505667e(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2775af5d6d22d6bb4093e79b802dfe4d7760ef9c36a37a87f8330a09f9eda131(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompound]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5dfd30e8ecbbbfb8e9e0450c1c3429a163270814743bbd99c0514845dd1fa37d(
    *,
    background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
    chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
    composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
    compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
    contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
    goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
    max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
    opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
    remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__01c4505f1210cde8eef3fac30cc527a704d48f5002787aba0d07ddf35f16b6d6(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1998916a03dbe9336ea1ecbfbea141b9cdcdbee8ca86aa966dc229b4320ebe2f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea25a6fa4f8a6a60763d5b0ea535b88a0b12d762c2b16cc96bf19bf0b61bca3d(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__24cf35ff8fe45a1833ab0faf907fa75ce83af3b15220c8500aeaf6bbd190af7f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ba0285bb093cdccc5576e8d3d9ccab8e989e2cd47c17beaa49225c3ab11e60a(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1738cff9fa486724c610ae50440d16612fd76c6649dff8ed5960ce78fe5621bc(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f835c007b99066207f73572bc9d0ef6b166f367a1addd91d0c9090bdc7e08e4f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsBackgroundColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a0505642686e589e0e6b5e3d248fbaf0e299b95bb54adea20903186ac42e17f5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5fee8b0058722838caa17a75ba4c8a620d8e4880d4eea191f80014c3adcfa965(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2e0d4dc96b5afb0c3c64f1beeb9a84530d3cca55d2c594d2f64272cc300ecd9b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aef3fff79245a77926a284358350ab5aa86653dc3c7395c9a71d52a126aeb221(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsBackgroundColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__abaabe3ef75960800b3866478a41db822eeb14dca606102e193d49aa433eb334(
    *,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1896721f7dd4fb0e8d6f1e144c4be35dca0d0567045f165be95bd4662d72d5ed(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1cc72e53f68b86291d44b0ae7b4c12fb4f21311e34bc0053c25cdf25f61fa46a(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5dfacf642dad2db4b21d2c5688735ca98fd56a7b3912908bffd3af26f6c482c1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bf47d9927e93e58006cb261e3f112e6b38ebe42e7ddfa1c5e6d5d3424b81a24b(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__856b22da318a4db941aec4bc15b44ed187a9dd92a6fafc85eb6234dd50cffe90(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a7a6c52f0d62f76a3a764e7c6c9c345af4b931fedf8f4b1e84e44b52e35f7770(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsBlur]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__330fb36f58cb72347d17fa0a5c39c611659922a214802b174b2e5448f5d82a5f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a12d8375a6e782603530978d4a794bd5b32d5c39004f57fd190662fa14f259e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c6199457d01503f26f971d4d9c33a69b96de7ca7acd665196556464a5615ee29(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a1eb9f248fc7032069f579b15da2840b450b671d3743854422c9cf3536b9472d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsBlur]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__65b065ab1ea37763c98ef61e05fe8ed38466350e64795b335c237a55b5fb5946(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_feather: typing.Optional[builtins.str] = None,
    hue_feather_var: typing.Optional[builtins.str] = None,
    hue_tolerance: typing.Optional[builtins.str] = None,
    hue_tolerance_var: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness_feather: typing.Optional[builtins.str] = None,
    lightness_feather_var: typing.Optional[builtins.str] = None,
    lightness_tolerance: typing.Optional[builtins.str] = None,
    lightness_tolerance_var: typing.Optional[builtins.str] = None,
    saturation_feather: typing.Optional[builtins.str] = None,
    saturation_feather_var: typing.Optional[builtins.str] = None,
    saturation_tolerance: typing.Optional[builtins.str] = None,
    saturation_tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2241e5bffb1bc31c8aac763f02b28daaf4a5370586272ea8bf3061172b8324a4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8db7fa9a8fbc29d3ed347682479cc6004f87cab8d552a75c4ce75c7d433dd314(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5aaffa54b9c62107f083162c9e26b1c42a3926ca81290fed549847d530f51d3b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__086b53297754355e2e578d3fcc1887d8186901b26aa46f775d216ddb4c4b96b5(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__233c6fec7d4199a73c8f41ec0825b01ba36c42709e13122a0a69a5eb4fc33752(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__364f754c0644e596d888962e59c08235b9806c3565d258be226196a58e8f625d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsChromaKey]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b266b242db3dad67a6e6cbd45da946c0ec5a887679cfc8274c1971f1af8f910f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ce5a7eb966e54ced874248f1f16c71f2c62acf3a678bf76fc83febf513e28c6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__22ca2e43a671c152f10e6da75d33911a028e4342faf04aa4d27671592c2f2f47(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f717637644dc0a8b353a8d3c1812389d774c69aec15217d9bb7d5c8130d7faa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__080d15c29015cead41c48651b08effde9d44e855c2fd9450eb389f1fec778cf6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d277ce609ac17e542265c8682a338205e12dabec675037831b83d804fddbfa82(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aa18879dd8a4152ef3dff9013b64573ad2c15dba051f40f98dcd30db16fce211(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__04107daf41c079d6dcf644a79461c865be1692123d8c7784a938be0265b65b37(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9be3569b2a00110da370042a59123de9fc68f940cd5762ce512387251e1dc97b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7a477e972eb61815dffdec9ba434f404e97b9eedc21a1abc94a53d32720efcb2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__78088dcc702e0b293aaf4566458f0d369f0b2c2a390aefa3e09138bb92df25a9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2248b936d3af023225b4dff058fc90755e607bc52e63abc00b182b5155987fba(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3b557b0c13040a73ca4b30aa28d6d58fc2fe17e21a2cad218454b4ae2f8a1fbc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2bf1a8035ddd308311e157661e7f80e51e4335a5fe7a73a8a05a41e56d2c31e0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__58b613582937e2348f59eb1ba68ae0e8253193c2c716d3bfe884fcb0abb7afd3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__64253901f3c18355c31d6f7d923587d82ff79dc9e6222bef6c9ccdcc352f62a1(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsChromaKey]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6772874f57188882a03e7ba4b34d614f8a7e65a25495ec609d7837abb704c5df(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsCompositeImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    placement: typing.Optional[builtins.str] = None,
    placement_var: typing.Optional[builtins.str] = None,
    scale: typing.Optional[builtins.str] = None,
    scale_dimension: typing.Optional[builtins.str] = None,
    scale_dimension_var: typing.Optional[builtins.str] = None,
    scale_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0d867c433b85de39f9dd949da0e3c4c44764311f72ecadaabd51f19dd7e607c7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1b3bc3837b94700fa287b7a01582fd7295f81e27354c3d7723313c84f2a9bca2(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsCompositeImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f32e8d7a2b605a1a33c51950df9b8b1ae8a480bde5e352e5e93e690167ab7c5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3363d17ff8019b9378aee62f19aa3840e228186606037b92970fa14dc2aa5607(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__50fa5027d3e9565bd73bdc1d51670db2ec6dfefff3d48ac74442b25d47a66a6a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ca1aa4b0986c24f5ef3327560ae9f435e96df019b699ef9fd612d87f52477ee(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c0282dd2525f39c48bce5d80b17ca371f23f3feeca0056efd3f59973d795afa5(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8600d38c4a8eadece0d66f6f8207676e71b85f53f2f6802f490bf369886d7ab2(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsComposite]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__83f1360e708e3273abcc887cb81f2da4e8416611dad675f52328b4cb35422dda(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__64e8af78191088bcf84755c19762f72b94e2f7944fea2bd970f89e78e1a5cd0a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3f30a3444b6cd38ddd2c6a60d0c5b304c6681ebadc4a9203764fd04b794fb841(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ba080d99002554fbd643d70d4ae3c584f0e2c4b3a08a8d4b889970983a17d929(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bd20cda1539d0a77eaad0b841e332031d451d1d7602dfe34d248506a14a361c9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7b20cbabb1647af66045f057c3c9d839abdabe254a498c5fed2f1b663786c2b4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2b767024f2379d547606d1a2030891b1f76514f4239b5f2459961b69d7ec5d86(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__97ae4f13b6462f07d67766b65ecfa2bdd48fede3789742e8420c8ed28004f857(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2f8e69e45edd5ab7838e5510bb0345850a5f041abc4a32a1f2ef3f4ecb1cf928(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6b80f2d93af775d7cbe048d8fa4c9807850500703e5868c0e053ff3e58de5bf9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__29d5ff421bc8eeb2c2a20dfd06e531b72559ee02fd366e343957571683ffe9ba(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__974fca1b15af52b94d9d75d0cd365d32a1f99f44f716088ad7d14f9a1f24084d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e73f7f2fa7de0119ff675ee1769f2447631c428ea7f441d6a362e8bb7233ffb3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0c0ada2d8d06b7eb3e42c885bdb0c0e0bcce71db1fe1223a12c52502803dc26f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsComposite]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0942b9081389fc93a095f6681323f8df91961b1ac4a560d8a1f1f471ab8d1835(
    *,
    transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eb9ccb14837922c6e0418ccc9fc5776adc144ec1f0ca041b6493ba975c548388(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__92314bd057ec87a33dffd1d38a82be4d6dc110afb9b8a67c300078d1d4728323(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3066ae21edb042bb8e73ff82b35ba7d25b8f35feec90dfbcb636cb854fe78681(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__01fe061ec3ceeaab1213433c7b3e53db775d608a125ae5dd33652fff987db684(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0f47469f5688a6038df4a3e1c075d9fc53a40929ca1ca5e265402933b2373ef5(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__16900e65960541e7e0911b7425c41e923fea4ebc9ab96ccc79cb55d5b6fc7394(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsCompound]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8320a203543fe4aed8f4368c2b35813b2cd7a8a439d80093274a9719bd69f879(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__254e87d66f112e56c42655c080de2ae93f047a337ba96262ba3c42eec5dd3798(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aa831089e4142f05261cd51b7c9ca13c2979e5859f7c535726dbdddce5fc7b1e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsCompound]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7340502b2b9cb53d198c10ea79698db3a2585532dc41728e4df2de954b6a35dc(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fe1128b451bb7951ae8c9adeda0a9e8784815f635531c9bd8a0cdfb95ba3a7ce(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__26134ab46bcf860c4749022479bc3eefdebd9aa10a4cef14092fac6dc7bea74b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b28fd4f1dc77db9381a7f393970da73c026b35b02b3e3e652e0445c60c2fe344(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ad8b25f41ede31838725774d8e32f75caa35095fdadc0a5f388a6dd3a18c9253(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f7f9e6efeaf78071be26c0c3028905c30cbbd4f38d652da95567403d4bf679cc(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsCompoundTransformations]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__44f26d50affb9095a9efc9fe1d952912f6acc74fb7cb319c32bb2645fdd8301c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b6f06bd80003d8cd7fd7520d534e6aaee3ad9f2df649ca629fc363e73b57e338(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsCompoundTransformations]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d49a21121fc1de95cc608762813bdc3741df6473364f52e4890db34edf6890c2(
    *,
    brightness: typing.Optional[builtins.str] = None,
    brightness_var: typing.Optional[builtins.str] = None,
    contrast: typing.Optional[builtins.str] = None,
    contrast_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b8d9ce48732b913c566f19da5c38a1ab604e9fe333022eaea4d94e3150756a30(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ecb3e0142341cea47fe5193208358c58a8f710f3de0b0b6960916ead5a1a23be(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f426b3caef4e56a4781bdddcc1dfb955dce7ce9339055bc20b1b8977eba539f1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c910a6ef1d6a6cbb4affed0ce8dee7f755ded385157e764a9d2b0e14c2ff4570(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b04739ac896f986b71cc85cf9d066ce5411e8f300c3d81908923f97d0628d171(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f993d6ccdeb50be5ab78221e8a1628bde015c43eb9a25b35fadd9ac7c329137b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsContrast]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a178c8bc9f0e4113eb94bce99b51ef0856284ef354fe28ce6f61b79f8d67c02(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fe4b29e834d9f4ca64ddda5954f3d8c73e765eecbedc329f8e713d7990d58831(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__da647c7b78c9eb4827390e7fa054e487b4ee6c3ca8bfcff4bdd4263364bba384(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ffa1769c03a11055b9b20a4e2a57584727224f51e25f959f6e914b608b019bbf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d347608d5672b1275026350e262ba718b131e29eb891e0def058fb297ff6fee3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__218691df426682f22460459d4c1db6524c63c4568002ce373ea51b3273320e01(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsContrast]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eda0b499850203091ae2e095c435279ff95901730af7c4593202028edb10318a(
    *,
    chaos: typing.Optional[builtins.str] = None,
    chaos_var: typing.Optional[builtins.str] = None,
    density: typing.Optional[builtins.str] = None,
    density_var: typing.Optional[builtins.str] = None,
    power: typing.Optional[builtins.str] = None,
    power_var: typing.Optional[builtins.str] = None,
    seed: typing.Optional[builtins.str] = None,
    seed_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6c010672d93cc8942a5ef787d2000dd5798d4b7dec251b59ea72cd24edef07ae(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9cbdfcc81055b01e5ecddb57bed7ce6107b5af535d662ddc05d8c72122fdacab(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1c8cc5d29e89f298ae8989bdb1ee143b9c4382da4db3c17aefc89c8ff5d5c244(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6b80274a8b555c0480e3dc728f8034fbb8a52b44670a8868f4248c42680259d2(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d670b142bc151978d2e563552d6fea8f0b5e8e34d97c363f7d42120bde573710(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__029415265b5f6073fe2248b29ce27f640483001a9eb8ef6ad1a813885d26fb25(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsGoop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b6a460ea3a392516133b7d6a9577fdd73dc825aab67f31b3c8d94fb5c61465e2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__038a8aec2b2190b3b5e89db270e838675b8ccce92aaa066d2429d8998766c72c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e7b927829d6b9d98d5717cfbf4651cf52b4ee8ce0e7b28666f273509c26b53a7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e9c296323e60c1076bcc796bf86483d11cc97d629dc1b3183929cd061a4b5b0f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__efdb969f3a064f5ca61832cab4f2820f8614247a16d7d69e1e0ba4cd008307b9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f391f5e99f6cd0bbdb83ed8170e12f3c76460858af09139eca2c18d49268ae6f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7bc23839f0c832e8edb3dd0b66e8c857bba110e26fef8f8b550940899147e604(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__264519fe682ee0601f5161ffe4163266d3d6663da3803d0529dc6e3cd0713b54(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0098f4808d703d1d3941e6f97b2de20047e6cdc617a9b93613ab9ffacfd77420(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__33a632d5c1eb1fc3c88f1ebf4240c6ba95294d5cc00c566eaad4fab3a1c6c0cc(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsGoop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7eb76d725b27c27e0d9cd6ffc4a0e38443929db19eecee5123f8f25a75f2f8d0(
    *,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c6e98b0af06c92ae40db830b176a24e16189c966b28fafa5168944e478e321e3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f72664b3438b9e34cb9e4343d8a60c3ce587374126eb264ba179d6c833adda54(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0b2024dcd848bce6b634388966f839e9320570dc99f9452e886f9ba099cb0431(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6dbb2423c61af8d3a5a20a843cf064f574e5dbc9757ee240669338ba2fe5412f(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cff66b5ff2f9d0eb4ccbe5650a5a57481307dca65671a46e58691e42a259544a(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5d5e6eb23efae455a444f45c7c2dbf09dc30c799b1fa9d8eff98343c92b5cbeb(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsGrayscale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dc6d67e4edbf4a5313987b570e80fb46f65a36d74daff0cd0ee052918887629b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__949c526305e7caef431ccb2d55ab303128234456e64c6b48a2387fd85defb6af(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__de0243fa34db75ef83caaba98cb0a6e620dfc57bc389f36225eea8b848f1a16a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7753172391788bb3c3646dcc995e9f1c2bedfadbde49706c06de0bce0e31c67e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsGrayscale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ddc99e2e0fb034cdb419cf0c954c59e0bbcfcbd4a19df22a179c90a1c947c9ca(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness: typing.Optional[builtins.str] = None,
    lightness_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dc38bb205e2e9632a55ac98c485c434bfc62324298d64cc124e6712a7d2be1e5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__118e7e5e136127a17fc6e07cfdf47586206608db96be5f27ff344b524366a900(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__00ccfec7a8412f6ed61c75493a82014a2b40490a88d1a7a908498e6d0461fa6d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f68b502595836edc40c7cbe99f836670b27782bd5d935086e4097a810a044856(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__516c7e7dba4a7e54d69b52cc7f78d788d0471fd9eb3a7c26221b01dca0586461(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__004e316f7b6d05666bbed13d66aa073fb8d67efc2c71db691538d403353c9759(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsHsl]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e8a6ed06e5a0b6e958d9bf8f0015d9128b1c9c0b83e5e7f13a591ff115a4bdca(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__48f44048aa2e152da112a0a2ab079aef8a627f536c36fc7f5e1a84b61de8148b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__92f2f8436a35aecde9c326abd2c7d6ab9921c9320ace13f91185cd24296acdee(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3e05ac99c75c989b8cb889a0bea474274d00e2639fc9f2d1b1f6086b3b54ddbe(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b386171ba4b1a4e52a9ad30bc01d938aa1929a6c6fbc9911ec1f676e2565c9fa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__247d84ae1c31c3442be633070d674161715b407abf1a510201293e9001f7b6b8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__61f1aaf57d58ced282d7fd42909aed05ac2be899f2a2c91659dcfefc81ba2ae5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e7355185359d31fd9623898a26848a8c84669382d68bb06c3eaf98370d4df3c2(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsHsl]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__43e3e11c2251965f87faaecbf354007def6f5dfe3424eb25e6e78c8f8e26b77d(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e8c36518133cc7dfd501728af614168836942922eed9c46ae1adf71966538d27(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__25ddf04078055e9d1c23a43146ba518fb21c6af6347283b22e36f1982dabb611(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b0c878e48c7887a03b8fd7ab9779b0184b77c0ba1cb8a14c4301c873f35cc5a0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8742ba557d12f410c19cadbc6e6474629e8caac15c637aec6bad43704cb3a3ad(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4e91e417c4cbc985ced6584ab9d0ec4c8607b701d6abd88b5757b06be28e0776(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8cb4602a5942d1380b2880062cc24139ba2b1db68a5a176e37cba3e7f89bdd09(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsHsv]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4686f477000d7774eb86fca2eed08dfaa1354060811a6533710e3d0dc7e27e10(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__97274cd743653315030497d105934a28610869ba1304a5e6b717528920b321a8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cc2840e1a3e3a267febec959b74981ff46c1dce621e4cbb41f5fccc0eae93bb3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2f03a2dda4930dadce76064c6bd3f4adc033e65b7fca20c76307966cefc61bc9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a22a1ccd2b8de72f42186731c4808bfcd421c945e058320ccf96adb44cf2c249(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be91d7ce43dc8baa4820deab87afb914fcc21ee16c59b8dcb8aa6c911d9d5b9e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c03a7247e0018e8a94e6cc18195181d8658942e495bbbbb4aebd6301da01b087(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1d6de822fa4ee28209754bd953954d5dde8cb29f4835e6ac3150b025d9279ab8(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsHsv]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb98cb41776f7ce39c481f1475c70620249b9f55fb97933fa1bbf94abb522c1e(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfDimensionDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    dimension: typing.Optional[builtins.str] = None,
    dimension_var: typing.Optional[builtins.str] = None,
    equal: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfDimensionEqual, typing.Dict[builtins.str, typing.Any]]] = None,
    greater_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfDimensionGreaterThan, typing.Dict[builtins.str, typing.Any]]] = None,
    less_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfDimensionLessThan, typing.Dict[builtins.str, typing.Any]]] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__29d2b4fc380f78c5304d715f191a1ab415106822400b114a67ac67913f57471c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f1459eadb04d01f6ba49d73fb04d9f95cb22f1f9caa56227b6fba8464df02b7e(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfDimensionDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7bf32b5823512f3b5bf92f2ea85b5400ebf696e81790f2f5d978a98b92bb9520(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3db35074266a8b9c4b65f7865bd9d72804ebd3242ac6e20c909edaaccc55d203(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfDimensionEqual],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f94c80f2a51116ccfc988d5dc878a3f6db4b3148cb198792092855513873a8cc(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5606d2f2c24a43f341a2dd07fdb5c530b8fa21ff6428495fec56e8b461496db8(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfDimensionGreaterThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__db26d0908c57917965bf9a7476a76f58569df1cc88eae0c9a203842bbb2c7bff(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__56cb7e649c736163dc9a47b3ae5f2044489e74247ff2b419b55422463a6707e0(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfDimensionLessThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__253f22f52d6eb290c0bc9f075aa9d41161d16be1483b15ba8961fd2af649077b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2af4a6812bd401c2608240df6ac200c67fb2e2b91298e419e6e0a745562e8ba6(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__beea246f05891b7bf56e489e967240d0af1c86c85bac425a8c1e5b8b735bda0b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0012cf730bc575608bccb6baaf93ec6450b416433aefbe3152d6fddb46688a6d(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9973066af600d51f33aa987ce16186f31d52001f15d9153a8db5a1627f522778(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7471d4af81eba61d7cb90e9816c87082c08f87fb56262a45cde04963fcedb4f0(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfDimension]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9f5d237808b9f6343f224978fa700cfc14f5f684bfd0fff1316ce8b42773ad99(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__123ff2de1149d8ff2c792cab8d81109539250c09a75513ec8fc038cd96af88cb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__93f6fe5d0eef0a2fb99018253280ff36dae2f4c3c09da166955b0fa161a5646c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2942655e3492b4531385b53b2de984942cb12cbaa3b39524d17caa8142303142(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b64925560e969cd2d26a0b75ee33f480c3eafde0543d1a7443d60958ba5fb569(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dc6e89e6d7becb6e4c69fe9f3bb14678795f9d23cbd4d1eb0158e1531212a02e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfDimension]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f903388838897121d9da692688de7ad1eb4e1bdbe23c11dcba09f778237b46ab(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfOrientationDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    landscape: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfOrientationLandscape, typing.Dict[builtins.str, typing.Any]]] = None,
    portrait: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfOrientationPortrait, typing.Dict[builtins.str, typing.Any]]] = None,
    square: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfOrientationSquare, typing.Dict[builtins.str, typing.Any]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fe793a690597de4e19b3773ca4e72351bf30a10c31470c683d33b972f1fe6446(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e6014a7ca2a535a08d4f2daf0b494f52e954d7657d55217f92024d27bf93821(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfOrientationDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0a6eadb79b33771a85ea4a38c4faa16134f39e65b1cde4a960806914e4518f20(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__899b47f6de2dda9ce5eaab334d4ab27799c35c911fadc3a53a4cece4cd49502c(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfOrientationLandscape],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__33b58ee4388a7f5e17472bf826c187d64f06d132e71b9f6dc4bce3fdb0803f5d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c4559e9040f8685aaf838afb11089ed468fa92c18196f2fa3325b32a5d6d7e5c(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e96df03cd40c84c4bfc3dbd75b954b498f663bf81a4f1da1aee84862253c708d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__18a165355527c4e001e2fae71f5895026a71ab629c26b127998bc763fe23b92f(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9730705a4911eeefbe9b6242981908df857237bb8bea68cf2e80703af441f6f6(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bfdcf94a4e8986b2dc1e2cd088ffd1419e24790a4b14669c5c66cbd0ecbedd7a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfOrientation]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1819c6d08a2a92eddc3d26c5ad7667a70afbe8c684a8c3802f79dd668ca28ebb(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__79db2491ebfa0d4526c4ed3a6fae99c7c8742c7de859de89fbdb002ee5477426(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfOrientation]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b71df14f04cb71b3954cf0eeb50da6a6f50bce4b40311155bdf2e6fcbca4884b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c6f2745eed02cbfca8d2973a8ce08071870c64157c8fccb56579b80be4e75de4(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfOrientationPortrait],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d1738d05acff7f2db60132da05574924fcc0ec6b479eb4b21e72a41c4baff68c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d833aae967c721e37fa8b69b7e4c9a0c2b3be9b698158527a56bf2ff60cd69e7(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfOrientationSquare],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__86e6aa89bc1309c7a47033532b14c5ac4a2a0e428614aa310b935c8b6140a29d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__826ac304c671a076472f050a3590e64f49cc1fd6608297811d2fdc7a51316287(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a23cf6910e0cecacc96b7818e2140c7ffbcfc83b5250123f980091a904e3691(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a63633aaa9c27a053a0f79f4c306504522a4eedc2dedc8961527926b7ccabe81(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f8e34d35d64142b5af98d5f45e5a8465d9df638d92f7d6e2587b2fad75646514(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__96c9c56a0b4b527142485f2660f1bfc90fb764827822bf5b4f06ecbc1f6e2ca0(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformations]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3dc7c8d20bc8efe02d46a30e36650e921c2ceb4386e38fc1f1d0d21f4db4a4b9(
    *,
    colors: typing.Optional[builtins.str] = None,
    colors_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__40bc94c26c01b3147b143dccdb4148e8c7cf6b2dddb89116687207c0302f5443(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__63f800a9bb821f104edb1410447d1120ba8d339ee42b844007aa4ebb9361c830(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cee2a629c139e61495c591d8f8de84d6b356de5aa447079fcc65aa7b8df8ebea(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a3991cefb8b14ca593698e3966182ebfb85efc1a65387dd31424b6284e7111b9(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fbf804c60e2a0169c62b9cb91e1ecd2f17f92a9777652aec947991c9f16661ac(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ed48ba1042807d924af9168e26d6605ece4ef7e40d06ccd6825ea86cdf54ae0c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsMaxColors]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fe2adc7b9889b03f5b52d06dd41a0abcbb926d02722d8b65c2cb4fdf79a00fdf(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bccc45b7bd3f7ac02f61cf884aa451e5780600fdbd238e5266d4ab431cb492ba(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ff600c53610e02e2d1892b0d3fd241b0fd359f281b1c459fcbc1d582d733111d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__52745cd0b7b09263f82d2bfe66daf06419763da7670c02b3bfdb52d2d74d5243(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsMaxColors]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9810e755482aafd716c47279fff734732f298976d5abefbd6ae98d53c64b49e1(
    *,
    horizontal: typing.Optional[builtins.str] = None,
    horizontal_var: typing.Optional[builtins.str] = None,
    vertical: typing.Optional[builtins.str] = None,
    vertical_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__82f8298676c67ebee788833e62f59702290e45f785d2b2d5306d1e60d3fb5452(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e10bd8d39fd579f4174f782c6c7cf45fac5e10d633dbda9c9faf533b40ce0fb1(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b9bb1fdb4234303bcd3ba9abeb7d424ef73f99f3c9331668ab602049d853854b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__59f00bdd331df4d064e549623dbfa5cfe5751dcf4de8a6e4c3658b93e90253d7(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cabc0fce8aed933da057bdac7ea17fc38c1156591445d9971c813dbf159a0588(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5437e114ff9eb8da959a3f4819061c55c5ac6a0f9540ab23ebb6cf956e26e4e9(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsMirror]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4f29f0311a6b56c846eb14d8e2aba5b0503af50915a526ba71280195d171246e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ef704f30196f51789d096993e57098281fccf45336fec772c7bf6f5b5f8e1faa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0c65ccdc3f0d28249c2d043b2344e26ca7024b2ee99281bf1a319fb3596b5545(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f6feb6194a5f08410200d8441e783854dd1071da7e8189edb7fc6230d896814c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__58f185365b2c522601bd161c278b3508631a7d8a84abd664c1d6a75962d68efa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9dd01ea697dd929f03b6b11238f1199d83d298a7a3d8791816c937e6330b96a0(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsMirror]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__277a85916b54a5fa633bf341531fd23d02c12f35e78a506483921fb23207328f(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__95e2d3cac5faa3e609146dd5eb1f2abc6fa4a860808235de0c216641ec7ad517(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0b9b2b78ec9c679c60385d3cbfdc93afbcc08f78c61a7098489e6c2924800b2a(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__989769a0b7c27f2288d575cc6aa6851bf69e30b0330a5b812a35441649baf18a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__89ed37942e3b6a67d278c04f03fb231d19b09db066a435010f217fe011941fc7(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3062d34f53876af2081c8509490c00fa95e6733ffbdee1b3ed25559ed1afc38b(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__68419eb3005f79df9b94497a1a69fa2bba16b1c16ff504f8cf23c9bac3667fa1(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsMonoHue]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4375919c16dd3c720a0e3b718e74438476b9a1b929782de8b0a6df01b603ca70(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__83e313297e7172e6cec3d45b2227f3cf5a5adaab9ba4b4b80202972246e88260(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aca8df470ed131049c9cb1c6629dc5e8fd399dfb9927991763710bce813ca25a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8bb8236ac5684ca35342b6d732b8680a175d6d8c2370ffbe51096a1a0b6457b2(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsMonoHue]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__88d50a288a433c69e32a9f049073b95b3889fa2d8ec5c150fc150d610f3120d9(
    *,
    opacity: typing.Optional[builtins.str] = None,
    opacity_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__40beda27f8b64a99eaa9ff9874402a12214d6d830f145df6f560c8d1dc14d1ee(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b000f3891949ffe4a9009c7c060fb1725d55233ea5d24c0fcd61bd1dab631971(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a7f24187c9a0eb9885294fba6909cf76d065c74bbdba305b2f66cde02603247(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3c339423301a9d67385e6505128f34a7b3c249f086ae6686194f47d75a4af3be(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab5483e94822fe49804913bd535f279c6c6747dc26e1664ddabe5e51a11edded(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af0929e53e1f31a0c73f4c6c8729e7eee2f5c940243d2fe524bd5bce68295d31(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsOpacity]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__15d54aebd8976bb14371fed9721db5f4f7de44abe0da803698d3e1011963af0c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d92a6217253a28953701af2a193cc042d3914c28bc24838a934d43631afeaff(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4e52e9bfd1311b8f5a28aba906f792e4c6b7ebb73494783618ddde059101a9b1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__79e9af3194f96364804308054c6c6c659c57be4e928224a64be44821a8ca2a05(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsOpacity]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0b609e64cfed14c2142ab39346db960f36555fe6c514db74145ebc1d532401aa(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d9405ef5f733a7db8e75cbc31168088a72b8f569307050ff50d18b90d3d1abe6(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fe1905f999e3e21249d7fda7a548dbbf591b7d65bb738f96ff597bc420d73b1a(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsBlur, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3894926aed5d85403df60b7f7f52de8a223658093e24de70d24c5da933d07789(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsChromaKey, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__76b0cb6762f79a84beb800765a49104e571766f7e6ca97725b8f7296a8a71aad(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsComposite, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0b4fb38fafdff4487d15df47191704a05aa884e2b80b4856ceabcbceefeff1d7(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsCompound, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__39ef68115fc8df7bf86eaf8db7b11e195144e473c9bb90367a1809f84832166c(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsContrast, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b87891cb553706e0509629831575797c64e97c85267b37a60d0998e30c3abb7e(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsGoop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9351a5199c7dda6dcc2b9aaf1b085c86b6050e28a16512e640d14239f345d5de(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsGrayscale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eaa7fafe68f973ac4c66d2ae135e9775dbef6b6cb29540b2857efbc8c3c23647(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsHsl, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__88cfeab27a0e070f08e129774c2ca27a0c198778b6977751eba9497228532f99(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsHsv, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3f266fc2a2ca5e67dc620fa3fec9e2d176921f047d5e7009915d8e20580d602d(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfDimension, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea489e0970c4f9368df59b1a736389de717c76c9a48f3079f4da21a30403b3a1(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bed02a182882c4daae7e724a518399f8af5b78d6b27fef57601aa4d30af9aaf9(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsMaxColors, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e7ed98d12dbfe1b395e46a3f7829fa1eb86b1040849c1c13c775b174d7fb58c4(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsMirror, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ce6347b87c7100b2f71669cf39aba080ce02c5783c2507580cd534a8f88e07b3(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsMonoHue, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b036ab27c7be38c4fd4e7979addeafb930b882a1179106a69b194c545f765696(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsOpacity, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__411ee9277e1adb8c33cd62f61a16a89857f86e01b026efa301e4c7f7b511d2d5(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsRemoveColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0237e739968646b86076dc1b1291d889aee23edfaf6780cb35cd54b1693d05da(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsUnsharpMask, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3c41d1a6f5908ba4284f5ba58518703e86c98c75447c2f14b45c6ca32ebbbaae(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformations]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7740692fffc42b25fc095bf7c94cb83379a2e6e3d9b3ea65797ba2e9f202c8fe(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
    feather: typing.Optional[builtins.str] = None,
    feather_var: typing.Optional[builtins.str] = None,
    tolerance: typing.Optional[builtins.str] = None,
    tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a8f4b363277b5548c130ce3cf64e5b2c6d5d385f0a56c81573c43379276fb91f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1b9615a6de521b7466fd23bf5c36738e488fce5ea897db1a4ee2232b23ad4860(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__017f7fa8f24c5ce6994e74fd8f300d4cfc4639a94ab2af018e3b2bbb90553803(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d7719d0beea533fdd2d9294b62167ff8149a41bffb1c014794e6e76178b2f0c2(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eead6a746277417a1d391d779f53ace1aeb1dd378aab5ee8a02902cf1fb409f8(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5b8e4a06bbe1f53812cc9e34dcb8862c0d3c32a12895dbf321ee95bde6e59a77(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsRemoveColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__342701d2aad51a7d097b99c97a59031d85dca72f5fd09c526e535ff9f51f6923(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__99449c0d13d48a512af375b4e47f1d01a535e5066ab68cd464e50860446fa521(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__151a4dd6e1024c331c8c7f7e6d6289aeb60b889d06eab9af645c81100ca9c926(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__04c8cbc044dad57dd56b213c60baa2a88e2ff6d4953e3d6ad880f2619f12a080(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e47f2cd60ffeee9a9b341cc25fe20d68c9fd228155dd805def47c261d21b349f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__20dd619595d3986dea3c54aeefb43629c3cf502bb1b4b0252fe61b3f7f5d640a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5b34b3d48a46d4fbb597ad0dced565a5e0f59f05d10cf60f65a1ced7b1b4a983(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__26a348117abd9fb8c6210c8176e824cbc0dbc491e1c302bdc62684b206bd952a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsRemoveColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9067fa58958fb92ebc354ffe554dfce8131d5832e2808488d9959ccacf68a6c3(
    *,
    gain: typing.Optional[builtins.str] = None,
    gain_var: typing.Optional[builtins.str] = None,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
    threshold: typing.Optional[builtins.str] = None,
    threshold_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d68d69d8567f8220c00c4dfabb64854b2b00b727c60cdaed5e5757032bef795f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ce2557540954ff65518cc0590d847bcf63d373edd891f33c6c5ade2c0a13e1dc(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ce5ba0abac5651389c330a9a004b60e0f9984118b4283a70fadb9dc739031d57(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f374474668bfa303d30f033550f40c954dcca10a40c7f10478f2dda9bc477f58(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__96ec2a57730b10b04794391336a3a9b090f42421d6673b9d7b18f6158272bb13(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a3c7e970eef8a5d9c00df0288af7fb9ffd65158d28dfdbd4abf82c37c7a4ef56(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsUnsharpMask]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c3c0a934f65cb222c6e90a4a1fd049f929501bb78d9108bf52e583fc336633fc(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__98b7e75482bfba4ec53766b5f619cc9fda2f37b4234f6c1c1c5b8e8b20985930(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__24f0d81929f7ba904790b07a96caa8d9eec79f229f80ec3ca37e7a53c2688053(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f86744c157af76f3a732da32ff88998ccfb7fad66571f6a1750f898019a0a1d1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f4375c19689c5edacdc4deeebf3f4e1c240873c1c99a83f8ed5065f6489be342(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a40f814d42f7b3272267b98aec171feed3b5287f49916e61e81558b5a1902de8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b8d288248f46d4e598125582d3de77879677cef9a4ec815a52d055cd4f2e496a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__925b4f5592bc384a173f29bec9d46e389c8b9b2a87f5bc07b950cb4fdde297da(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompoundTransformationsUnsharpMask]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f9f4efbe78255415329a56709877f62489a84e446b625ac52be4933ced1b6ead(
    *,
    brightness: typing.Optional[builtins.str] = None,
    brightness_var: typing.Optional[builtins.str] = None,
    contrast: typing.Optional[builtins.str] = None,
    contrast_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e2421ad8aab8ff1ff4cdc0e084964387d2d8413b80256ccc776f02a7848bdb68(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1a4683f454393b923cdcaab162d0a89ef95b0201e374c6d9edf99160ef10dabd(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__25c8ebe9cdb88c09808edc3b7c6a34fd11f9af1a216776d7cdf014ef13eb0621(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7cf62edabfd09db950af747dfaa3de7136b9439f4df01de746169cba84c45e91(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3cfa83c9107b81506e9b1392307e1af978f456c51cf218b7b294abb99435c490(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__36b81dd7b8df5d67c100845586e477666f9c85129fdd378688a22acfa83659a4(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultContrast]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__36565cdfae450ea474759008f57ddb8ab4e28d8f7e673bfd5242c7efd0897927(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab79043e8f799ec75a43c57d92b769846694b60e6b4fc9dc341803b4baaa4ee4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d343740ae4b6b59943dbdb5c9574424c17155e67d80ee1ed9958568b1c85db0e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c318c1ea690ffdc63a1d7950588ac7f4edd75fc299718ebe785579a555ba2948(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5a8eb2a4016e8965489ca65e6b6bcc0dcd7dc7a324541edfd8adb08de7f983d7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__613bd51e25de49a96467e966f056e6fff86170f4cb786c16da5875cb7fe1fbbc(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultContrast]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2e59b8eb29f4d72c76202b0985c6d4eedd59c2457e695806e2940ca75207ae9b(
    *,
    chaos: typing.Optional[builtins.str] = None,
    chaos_var: typing.Optional[builtins.str] = None,
    density: typing.Optional[builtins.str] = None,
    density_var: typing.Optional[builtins.str] = None,
    power: typing.Optional[builtins.str] = None,
    power_var: typing.Optional[builtins.str] = None,
    seed: typing.Optional[builtins.str] = None,
    seed_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a8a63a2eb2a9235d19583420776eeccf9f2da53ea7552f4d3e13b0d4af69a16a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f7044ccaf3d3d661d6ec92b4c5911f9227325cc056d3474a6d4ac9b8e24d18e(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__576fedf9ac1337f3c75d655ddd09fe3a41e85d0a070fadf96e52c5092d385023(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__66b0b54010dcfa9dee227cca318374e059f7becbcb44b5194633a0660d1777fa(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ee1d37e51629bf4d444dcc847c753b6f08c20cddcc614de47ac77b96d33ea53b(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__94b2f9241b460c7164201329ffc5dcb87b264cbe1f45bded9a7a7cc190991bd4(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultGoop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cb5b0c960172b66f5985a4595fb35810d432c9905b40258f2ee84f027aa7cc83(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9177da75c9f609e8ad1601274b2e61dadf79cbd516484d17cf81bf8570e34495(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__330716827835d5a02223bb089eb0b19aa6c1a6998a3df67ec544b7cd8fa25b42(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3829f8720a94981c7d56e6a80e11a3353d280af2f34888d8e35584b6fca7b44f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3b6690193bde51759065a2476684c04390c832c0fc0c7442d09cb7060072e496(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a3ff3e2243b43e1c1ea6896322d952c0b450cda11298f345ecfafd3808dbb1cb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d0e7032e16e318b15d60b8124f6da22e9e09579e02538e016d4f229aeefbbfa4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7256924670f95531eeae434547906d7ffcc75edabea77e7200e750b160bb1b0c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eed9e201a386714ba9001d0e971fd49400e857d96160865f0618c2a261a17e23(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__921f4b863d34dd3fc64744366deadf42625aa9a27f3b2ded43a370454852f975(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultGoop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4b6e1ae850e42489255bc8ce83c787e0211d10473574cc038d2dda13d2e3e4fa(
    *,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__47e74b7a0dc8c6f0fbdc8e1d209acea3ccee97be29bb2ed50fd8cdb975bd2283(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d4d8249599df754e3c46806cf0d79711415602792e3756c3f5106a50f11f9ccc(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c20c5820ba37fdfc12621795418f0cd1059ef4a84398f62d09a14b7681bb488c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eaf6f21615e1801a427bbc5ae2914a077e5a5b63838edc206b59c6664c1978d1(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f5dd54cbaf9d0fe6e3e10d166732e7b7cfd3b7680f8854db01a2f9f0633aac7(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7f39d8151cda9ca591340cce2f54f616509c6b4ed903e4b2d346e7be93dc27ab(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultGrayscale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f05718ddf06ae7a60110fc010b74a77585217b0aaa7a2eee0261a36e8a382e7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5170f64961855e6dbdaab761bf3896403a7e51597354fd228e95e45769704aa4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__075cd318eb5991593d955231ff8d3cf3064296cfd38caaeeb121bc75724799f9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5073e7c8c213b20d70ecb32828d99433132346fd566ad58ef35cf508bf326d9c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultGrayscale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__923fb34e052961bca4bd3dbd8137b3e3f70b671bd98966aacf27c18c57d8d4ce(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness: typing.Optional[builtins.str] = None,
    lightness_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eed080926b23f09fb4e63223702d4c9f2f64e8532c16a5ed437aa285ca63dcd4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4cb4b2c9be0c43a2b758cb68f2e60541dd6f018a1862d71389a47883b0cabc2f(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5adc70491229404c1f46a58e2d8f90bb92d0b7b9b7d85d3e5a3c248dbf3be354(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2fe377216872b0be3255825cded4e6dbb59fccef35dcde252a6f271269a9511f(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cf53c8b76aa9c3dadd17730f67b54c3d171c4b2238cb8dafc06090a271c0f2c2(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__76c549a98b749e6a0e9da906eb6cc0aa831113492f2405d31586f04aa04dca61(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultHsl]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__50caa1b72bec72e2bd92f8570e193b8fc3347bdbbbfa32a09a65cc72541bbadf(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__74a54dfd25ea5edd59841894912c7e4fe92fb15fed3417f85b57990f9bcfdef4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__68f9ebb5713754bc81c4942dde17d6674cb4d3d4a499c86d28c951546106554e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__40e4f5ad2f65585a55da30a775403b24516bef891b56f5f790c36cd249e98f05(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d900e10015f3f2722811c69fec863374395e5a64683246ebe0ac8c74a34903e4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__85a996b4b29fd3abda2781effa564c348e4dc956e4622e1ee945d1938efdb7e7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__743073e311d64103e0d1d040d892845c56d495dac4065af00a9025a0b2c01cef(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__68c368e436496f628e41a8a0a8a4ebf3d18bd91823443423722c5bc75b420621(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultHsl]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ae10609d49c0fad545d9a94162fe6fb61eae53b31313bbee2288efa09d703f7a(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d22064df43c7f68fadd1c40d56d25fe11b78bf003b98839bf6f3c05ff97d494(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__475371814fa18f102449521d009b5769cc1c3c141799f375dbead5936176eb29(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3d2fe18d86e01bdc5b490598120dd419666237cd2b8b22187e353482cc8db674(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d9baae7e7b40cf0d61f8e164d00663e1fb6d75127fdd8a3309cd54097739281(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4db66030e92dd075c162407f5a1f063658d9f9c7be31c7d914a6501b83b36f3d(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__255a0c976f55171a16ea2b21cf0adb4d5326c5541a2560914ac18631e6408643(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultHsv]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc6534a3d5898f38855c9ed2e058a4f90f5d6185368ebb3eea449999f861c0da(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6004d4e729d0ca5e36a4d44200019c3fd0e9c8ab68c383fce2376ac092e8203f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0dfd2bd7dba2d9876a38dc0276235b3f44e453da18d7da9275ed39a80a2929ff(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c1fae1d93bff4510d8612e13638b8d17675c1d45d928744740d9f8c1e714c988(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1ba2e52d137b40cb285c51a76e2c9a36ef1ae181596f71f998b3555e4beb022a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0fa8fcd7be8a55533c5fbf6b9d427a43479535d9134bd356cf3ec66e9195e322(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7b1f3dc72680fcc3a09ec55ad7061f4db356af3561fdffc7eb3bbf6b4f233b2e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__daeaff27f67974771cf284dbf8663c193c96d14e01d73d1e4611c725310ef536(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultHsv]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__812d7cf7ce50ed0e78f9752ca79d8e99302cbf8706ad1f809669d520a8094997(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    landscape: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscape, typing.Dict[builtins.str, typing.Any]]] = None,
    portrait: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortrait, typing.Dict[builtins.str, typing.Any]]] = None,
    square: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquare, typing.Dict[builtins.str, typing.Any]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ed81d2fc6e4e5c26d483e6e97a8c32e38b822035e67016aee36c72e3d63ff1f6(
    *,
    background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
    chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
    composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
    compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
    contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
    goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
    max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
    opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
    remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1b090d1146c2c645364910b4106a99b7d93c4ad4d296af66b23e962512b974c9(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__efc47ce87bc556a757e043f818031d999c4a06e9ec37fa66ef5a7e5180b11bee(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5c142242380de4741f9d231e2423837bc6496a84725bcfce11c4e3bba9c38da3(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__22115958e150db0e27d220204e3346f127dee61e2b5d2bc2ba8e5c0621e4a7b8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__75c9fefb6365738dc292409d872aa8170a2f463c272c604dae7227ee5deed073(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6dbf10c4624b2e9d44efa1de93d080317cadd53a377726da201f93fe315f6d16(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__09bec76f4a48e157bfeaf85cb798583c9918caf703ac0888e7e786922c50a526(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeBackgroundColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8fbab8d5bbbc28fb7ae00e3eca0abc126ffbde833ebaff2dbfe0fa8a569147d0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a258c1270a4f13a8dd71c0cba59b99b744588cdfc8c8ed6f1e180e4461725f98(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8d488487bab768f9c68e9bc7f612342af47638978e481c9d4c7af6a51a20196b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__58015caee0d22044f1efadeaa3c6eafac04acc6b1b16f5795165e2e6d5aac8be(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeBackgroundColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a05d71eebb26c845b7326a953bfc14f54f2768322ef3ff578c4576789061bfed(
    *,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dbe7cee049dd63e61be74000671487fca3313e7ac62c0beb6f2ef728a42f61de(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__38de88781203b7fb3ea9b3eba1bbe8ad18ed9d7e75cf7b28d3b87c4f33f67a61(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac2cfc9ced984ec55aa0049dae4b2e4a0efcf80e2c8e62e134619a7be5164a46(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__06116676222b520df49ca2ae7cc437df9c9b44ae8bb41861c75bb199536b2da2(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0bd7009fc94f979c559cbafd29d0f7fdc11babcdb3a85314bfbe474c05fd4c87(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__73f0c85318335fd9b41e1ac50eac60bdc55e6c63b4e70cdef6f7dbafa28a39fd(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeBlur]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__84efb35a76027edcdc7c0d0b6558c72b58dc22d27cb84d434ef29c05dd5fe538(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b708ac95175d29e6a25c7882145a55cb1fb6d087be45d642a276e41d064565ee(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e499d1e54f25aa87a6826fddcba99261ff8a3a208ec80d26d9beae318cf7fb9f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__415b0430ccf05dd959710b264a7787be1051b8aa5cd6857dd2107b941a1768b0(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeBlur]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__929bda55353cb4927bd5fa8553f1934794379d954056dda97d31dba105e7fc88(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_feather: typing.Optional[builtins.str] = None,
    hue_feather_var: typing.Optional[builtins.str] = None,
    hue_tolerance: typing.Optional[builtins.str] = None,
    hue_tolerance_var: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness_feather: typing.Optional[builtins.str] = None,
    lightness_feather_var: typing.Optional[builtins.str] = None,
    lightness_tolerance: typing.Optional[builtins.str] = None,
    lightness_tolerance_var: typing.Optional[builtins.str] = None,
    saturation_feather: typing.Optional[builtins.str] = None,
    saturation_feather_var: typing.Optional[builtins.str] = None,
    saturation_tolerance: typing.Optional[builtins.str] = None,
    saturation_tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__87319404290f2f8f27ce7d9b8130af4db44b5614df8a874ca5f4ab813aaf9570(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f776d9eb73da89618992e7cbea2d8a895a20430d5208e66a4db39869a1d5930c(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__35a54ca56549bf118268e631a9dffe661125a08e436370d5ced7fd66a128b42f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c3667d12089c94339ba045859ede6858531d6adb9033597919131be42a4fe0c7(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e3cb2bd827d9f17e6aedf45c02edc3ba1e8b6ac25931ee8498cb59ce877689fa(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b2d90bbf9b5a9b0950195eafe3e5581f72c0a784c7b3eae582c0edfc4ac1d90a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeChromaKey]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1702198a1f7edd23ad7824b4719e440f0b4dc137dcfa4d90a0fd2d128e32b913(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a2a1753a601d75bdb57a234a8ec469bef321721d8d6fa6b33f338004f81c941b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__629e04fa4e9c2c590291febe09c2032645b12582a39772cd9f6fd289ea58abf7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__05e5b91ad76fa3c241cde46af9f458c64dfa916b1629838ea998cfe6a6de9848(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dce6a6a2ad56d9a6890696bd5db567d7229cd8f74eb3d79e5dada744c5b48beb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eee74779bff442eefbaa1652bdfea1fcd711d116a570dd2b8107715d4f614620(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9af2deefaa22c033dd1dac9afad8f572527469bf31c007162d66611940a6fddb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f259332138a1a13b390d5beb83a17c7fba27c98613afea3b4943abaf7c6b4b90(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a30270195ad9986012c9055f4034e72d2a594830333acd08398c708193d719c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__58438b0f24d98d19a80bb4ce30de7bea397663741b8c9f711e131a04ad8f312f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2563140b4e8316ecbc5ca82a4ca68f823ec7e6715bc822a341d12eae438ccc11(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3287e8562de7e6ca423dbdd8e58e4f323a5282e9d1a339968f8052cd97353832(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e5e242b07c9d97b0062c8ef0dc467838b2fae7b4db04e66b6b61d979194f9e5d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc1b2ba52b695f78cf520429bcf4b9aeafa71eeaac3065af2fe58bffd537db35(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7c4051427abc6f78168981749ad3efad5a438df2267c31757f226088e24394cb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5a582a5fc1742300f7ce0a342f66bd61af1019b41aed5c43ec01c3145bd998eb(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeChromaKey]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8f9eede03ae29aadd217957d316f15483dd45ea2e7749e3f247ba96ebc5869aa(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeCompositeImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    placement: typing.Optional[builtins.str] = None,
    placement_var: typing.Optional[builtins.str] = None,
    scale: typing.Optional[builtins.str] = None,
    scale_dimension: typing.Optional[builtins.str] = None,
    scale_dimension_var: typing.Optional[builtins.str] = None,
    scale_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cef3db949d8115d6d7ed989d5f655283b3cf99ba1f4268fd9f615411139d7df3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b4b1c1da6d9267083f2aad2d8f4e9b56647933bb179eb54d5561bf5ea9fc67f7(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeCompositeImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4dac368a46f62d9db932da92555eb4608f13f51a07a4de82e96aa605a8069553(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__81f44bfab97335dfec39764c86e7610c8504091868c29aa5f0077a947c8f7ca4(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c38a7c7f1b71fc8f170b2b8cb6f675159f9b88848abac6d542a2ea67aea8d22f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4802e540025200b23a9a4b8377496b4a254c4444404ff083cfb04efe96eef1b4(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8e6e27e84e9fbfd9de5d67ae7f983f08a44ede1c04a1679c9ae0f257aa10e630(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3c71ff431b117436a3bb91dc3d20c06b6f57bcc9e48a8caec84a4e269f74bdd5(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeComposite]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ddca71e2683cf76e924abf4381666c5d5cf87fd2e4a4d5dd03d45f8b8d4d642(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2bf912ca5b8382389100c0f064ff2fa405de32230f854ddf3fb6d2133d69c173(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__80daf3b5454993b3a0314ddd95a9b3034b1ded1b21291850f43bff6412d1aefb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9e380833c864d53b4cd73d8de6fbf2cfb58556d6e8b46bedfa2c91ce2a18002e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3aa67c6173aa38c76d9f081821d835321a9c3ae9429c98d72f07dd3556a1fe44(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f360135413c3c5a513720c14215ffa26793650850aca194ee0816eaf6288bd5b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ef433752b679d38ded73953ce72a09422493d6d0777cadc685c74117d2010eff(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d627a2cd4524fd726ee85e08e383f8b086e25364241d87ac0ba9ce244e4bc65(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2c2b6ab51efda6646e59dc52cd52e8071ca6bc7937b451f47cd46562c0c726fb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0a40cbf771861a9b170891289384b23d79684270e4b6f69e8fa8f0ed8caaf915(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c1f3f0c89475a842fd2efcc093703b62ecaff7483b6c836102d05a03389da2e3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__876e5bee04e2981b72f2e0e765b6b56888282a6a275b4a0c76684c14b477165e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__74bfd3249a94f0fd549b7604b095b7c789a5f80ed3d0f54e0cf9ee0f6479b6fc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__24664a8c0d66b275a91e77e7b04060631e746e32fe99dc7f430b27cb0146288f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeComposite]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__59c91ea6b9d7a9c998a2c08051a83e46eb49e459e039afde1bb876405dd76300(
    *,
    transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9cde330dc43a3b61c8e9d7628118ba8503d970e43e319d9e2e1ae2b08c49e16d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8b6d76d9b05607f2ab1c5134af959802e06207a6138753b80b603d6420562526(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__578360b196c926e5071061d16ac2414e02750204c5c090634b213f3d6093892b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bdd431a5dbbf43287168347e778af64678af3e452435a7344ba826804faab285(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1da6d6767d185c537db058ca85b9785db00b0225dfb09cfb8c7976944bb6a606(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b01750280ee8743d5a33febbceb8d3b8e4d98c19abd55fb9082f9160cc13c109(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeCompound]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1d9c2dc86a235932cbcaf05d736880c60b5c3385aebbdcb9cf71c088efd35890(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__43beb4800a0ecce3cf9b4e2a9c3ff1376facdc54db7d4292e0c4764354e38f5f(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__86da60218575e5e6b1475e5f1509ebdd303f1f96f0c44ab0b0bc6cc99d472401(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeCompound]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c5b07904c0d5efc0c3b2e8d47d08308fef6abb4deee18e6fc8a0321e3ce11d45(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0e4ec7359fabdc7c807bb6c2234017a28d96fea7022f2a771383fb78179ac83c(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__48dd39be084bf2757078ef8ced7ad762af01164655cb774a2fada7fbe19c54a9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4b8d6ae9f5a1fb9781b0fd15a8cad4c32ae86cc882ba25731319b42cba9904a0(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__77a6ed6683f59d64af004c785272f7f4ce24bb01d348695b6da0f16f834b5c1f(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e10457ca7c7d89a3ac523e504b24e3896a203db2979c800a7e7732de357cca87(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeCompoundTransformations]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a2eeb3ade21cb2320077f8a2d47dc4a717fa5d1db419992f47698e5601e99521(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ba975180e352c3e590b0079719de68d924198196b1dd109c31c9d169b26fc232(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeCompoundTransformations]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2eb25217fbb2163ff377278d36bd482109c76547a35037613b905dbf080565d7(
    *,
    brightness: typing.Optional[builtins.str] = None,
    brightness_var: typing.Optional[builtins.str] = None,
    contrast: typing.Optional[builtins.str] = None,
    contrast_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1dbb6b45021f9234df99be4f625bc3cd2d0ff38f1c0ab6952bef185384512568(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0a3b4ce9f3bb3dec435a1113bbddf130796e7c5c7442187ce4784b1b7c5cbec0(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__47e871c577eb351aa62d17ad1a3413dbf72a976fa4e7e9c59005069dc2741538(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c9e4e91db44ad432996df32f9879256aaf66b1ba42122bd89430873b84f4e6fc(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ddc5fb67ec5b346bae661d03b659faa71ef3e7753e61649a56bdca72f6886a9b(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ffa3829488629ed1060420552db0c84654dbbc0c1f3300dc072709e59d85f28(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeContrast]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7105914af60684f40598b8d585c4d304ed69a050decda14eeace4cf755e3520f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6330188da0ab1b55d5d507acb473f5b20d26807d7b16274057231cfeb8899932(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__16c84810855abf70e5719fff2b8df1f1406a4ba391ae9828b34249a867136fb4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ff2507f3e9ee1984ef3ff954f4fcb2078b7ad2ab5cf51ef0cea4b32733288e0a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__55a2b2bea308b44ff56b7a099795638fdeb4e140cc715461be91aec0eeb2b8c0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5480f9e44787e3cf185d5db215b7cf823d20913b4bce8bd87ed2e88d311c262e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeContrast]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f772a9a2a6ac66bc883a7fbced035e758f339860b1ab2188bc1d1502f476007a(
    *,
    chaos: typing.Optional[builtins.str] = None,
    chaos_var: typing.Optional[builtins.str] = None,
    density: typing.Optional[builtins.str] = None,
    density_var: typing.Optional[builtins.str] = None,
    power: typing.Optional[builtins.str] = None,
    power_var: typing.Optional[builtins.str] = None,
    seed: typing.Optional[builtins.str] = None,
    seed_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__34d816a2e056abdc493e4415950780b294f3a0cd2672f97ddcd1fd6f0576b7c2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a0f3612b34ab10bee6031d865c379d1471981fa731e5694dd05962daeedf0335(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8438d17a6d29d39c79c528698a0e9959e4d2191feab24f58ce5c4b04833a51f8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__adac29b241ca20aed9f5f8058b5661f0a147e23a4b3f9f16139dc6142fe578e1(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d75266128b35094caf3f1161b6e0d3258a158661e093b6f112ae4b29333dd70b(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a65690cdbd2375961061bb3f2ecff8c2b9f979a1e08f96e2e8e0cba8097191af(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeGoop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__74baacf6d20a7a33b1409be57e2dcc5bb41b2c8c712e302ad1e6aed52464e382(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e609b55df030072648e5a3f20d70d514ec1b8a70c3a279d7e7eee9d10fe552ce(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ba7880f0baf753417643327f6c0967dc22ee3408f945617f237589edd225c5b1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b4d95cec5a278662d4b67741a84c08b02443f8a82a22958ce9c6f8dd9bc6ab9e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__122f34c65db0277479cbe851a6219aa130af8a5e7dd4d99e0f2b7e6e4736ac84(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8aba880851448b37d0df96a8ead06426596e83ce40d819ce981fa9a10e00d04c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fa85ae1a05a0c6115d79c985df47670747feb8936fac83c089773b4c71db9eec(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__377c47fb561b2f714fb4178643cf0aa706b8ead25750f467f335372c8008b19c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bf2ae86c5808107dc8d7cd1aa3581255fb11091d26565751c90a1a09de320789(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fba4be195f712e408ef66afcda89059ae635f0123ddfa81afc11fab89a22ad17(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeGoop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a81dab819882d5cc0ae1165b9f6aea16521dbe8b9dcdeec9916524edbd9b7855(
    *,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4c1572c77df9ff62999538613c95487739f17896763d6984b1c86397aca64733(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__07b2b4424ce130fdf55e56736b7b6188386d26779514595e7fd834e9870072a2(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d09a1567e4096c09ebeae3d37cdc409854b0726c94cefb75861297bad46962b9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__352fbcd243e951064696595aebc52f4b4881ec649d36f7ff926db4f808934d5e(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b226aca70e73a1efc477984313ca9724a61bf9836148af9fcaf2d87bacf8957e(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__36a046a3f76f89ec7c210ab734eac5f4d46f562ada2187d6d2b99934fccc25b4(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeGrayscale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__de85439d03ea5d110efdd4e23db2e1aa2f778b6229660d49db5082d3c5040cb6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d8bcc659acc8bcdbc70619ec965b700a34d5b250a1feec7148bc92e206f68f2a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__95515dcc3296c4b9ef4f59f1ff86afdfb1d5c95725ce507b2048971ebf4b9a2a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ffdd7659da4c346c00150a2a2487adbb6222cf08cd4077239ed7b37f8dbb8d19(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeGrayscale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d2732497060b1e0a66e191e57a4169bb480ba8b3274f8a7926ebfa32b67171b1(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness: typing.Optional[builtins.str] = None,
    lightness_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f409e58c82c35c238331aa302cc9c6b63fa2da6f2b87a94222d9adace6083a52(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d55e0b4c8bcd4f7700dc22311c672b9bdc75e8d7828927f59537210784e5b61a(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__69fb084836ad57f7811ed31fb621a69ccd5800f4a991bf0638542b1d70604723(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7dcc70b22ebdaf602ea958be242a55546b6271e2024129eb5f5ca4630cc89275(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4f8262592e2dbb34c3ff3462a4615887708a7209d070e7fd8919f0740ae90a88(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ec8a7911c04b9d38dff31171a095b6f5d2024a3bc0cf613acbade5574974ba66(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeHsl]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3f73fa4b923320577e1506529348cee71da28f9021f192c4b607d62e17649b93(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__85109562959df3ae1c3a311d86a54c82fae5c8b9b7e0b6611553bad65968b1f5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb15316cbd0649327a19b0a61e6fd8c940bffbfc31be8eba1d5c92e2220a26ae(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b0f4c5e17d17079913d42f4d195c4f03745b001dd851a060f0a8e40a5cfbaed0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__38621ab0987cb26589b825f279ab94e510da14cfacd163dac4f355cc3cad1d17(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__76008e3514fd33cb6802c18af268f123b710cadf6fdbf52c7028ff0fe9119815(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e523a53999e7ebd58b2488f21d35aad0651683cfac1d036a270394fd13c8521f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1cd51c55c729d4ab3bf36aabdb57911cdeb1bde47fe9a4736311bc041d635e75(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeHsl]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b8b7d5ae5f755c2f9518d0c63bc19bc10a6c0db79e2b2ad27aeb289649107466(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__92b90a6420f3cdc04d2f2ef975b353771d0bc7fb9375159477a1360a85391bc9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d7ccccc07c71504418f887abc6373e4fed2dd5207317afc9b24b2d34a7e9bea2(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fae8d9270c03e2726bfb91b02940c2567adf0a34e1a69a1a16b3ce9031a91ac6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c8aeb722cbf54dcfa9a63218f9bbbd733d1b74f9d61917327bd26d7695dee146(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8074847cb2448ab549c85121db16995581840411c4d82f6fca53ffe6d6e29bbf(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cc6ad1a15507bd54c1bea22d6dbab13bf444f2c0833b3ad539968d9f3fd54486(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeHsv]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__272561f8896224bdf18c1363d4e289987a70c3925efbd34e6093a404dacc4c9f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__de2ca3f6d227ee5272c9151bc3b852f1e96f5bc0788e7257aba11eacb5b8d66c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e83d1522492cc40bf4322a50e9ecfac9a7005370af5d1a651a34fbce0bbbe317(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea6b8e9fb423e70264abe42f0b3d56340eb98b430aed2f5fecbdb10bd2c4728b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__04a6079030a20cc5f18706ff1f52e4819a02e2e85f27bb2ea827092ea932f696(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__688de2aea3608e673ba1fe249923531ddaa953e4dfa18e3cca967be2e956717c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3f3ea0960e5cad53b308c3bed254627df26eb202392f4bb70bec4478657db8f9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0773c36ec1053c9d06e649bafc48d8cf1e407227d76384ac2786a98767bc913b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeHsv]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bbfe6059b84bc150e5c2212eae31cd0120a2220b638bc418a6974f36e24afb9b(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    dimension: typing.Optional[builtins.str] = None,
    dimension_var: typing.Optional[builtins.str] = None,
    equal: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionEqual, typing.Dict[builtins.str, typing.Any]]] = None,
    greater_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionGreaterThan, typing.Dict[builtins.str, typing.Any]]] = None,
    less_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionLessThan, typing.Dict[builtins.str, typing.Any]]] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__21b93cb020f4488085c2e3e4907cd7601e1c753cce54f191017e7b2e38339355(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7204641bd9c4fcf1dce4284d93b6407a2453d1f2705dd0c3bae92d762b3345c7(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9475fc4072f10d12c0678b5c3029e1865052b9e99af0755381c3ed3cfc21298a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d879bf1f2ec80ed3fee81af5852568f36466f3006f510d4b3a7426c206f4caae(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionEqual],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a0108f4427b1e7eb12f759aceff679f68e3acb30446b659eb6dab1552c308a8f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f331bc8a8e2befd216ef0ac473ef0fce0f99cf50f5eb578dbf7f97ed502220f0(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionGreaterThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d833ac858f6e6b82a5c53d6f4eea702e4bace54e211f817d8bc2532e38983ede(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__20b55bbbb1b28579510f55659e587e118b797d4f06c8643714c48855def0226a(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimensionLessThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__69eede250cb2a64f2f1c835913c5e2ba5089d67fde509ae1dd2fa88f9d619eaa(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aee02f8e4721f01503ccfb20821ee369d592ef585b2a98d4f4af68c053f5831a(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__56f6218eb91baef25e023236d883f9467affe9036d63a1ff83537774459b18d3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__96c4d5818913f3f8002aaf8486cdbe82b4d73853a2decf57e9c0a60ea36c3993(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ec01aca5e8cc9ac733d758a56f7e8ff59b0ba95f71f65d8a2f604d77d6672e5a(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__655c0fc09f3c3fc44ebbaf059fee2bd673707d2d20793c33d11edc5698b6af88(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimension]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6aa67970903068326c974573314201ada3cbf5db0c85549828fc3130acebe067(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c22d30c2cf9713aa557a5120b5afa52bb4de274052af2edcc7a1867313ed7259(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__63bf625fad0a592f70513b17aa94c906f9db41c87f5b44ce6865211e7b8fa5b7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ff790ea7c80609f0757eb30d5188dd276f02e4c32bff85f415fe4bcdea8a61b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__634a1c6cea9ac6de2eb0095e050403e7ce4fc19a2df2d2864ff56c0efbe4b961(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__302c1be6718c1dbf838390a088094821fc6ca40875d22ebb4d36a4bfc15e33ab(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimension]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__561ef493047e29cc7f7515518af2a1f04505eb94bdd682cd29d3be4f161052ce(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    landscape: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationLandscape, typing.Dict[builtins.str, typing.Any]]] = None,
    portrait: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationPortrait, typing.Dict[builtins.str, typing.Any]]] = None,
    square: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationSquare, typing.Dict[builtins.str, typing.Any]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dcf9aeb00ed676a132ac5c2e512eebb479c9ea58a05a567b72e2282df10a22c1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__28a597a3940624875b3a5f76c3b5656def226292e91af133e8ad3b00cdf234e2(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1250ee374df0879806fe99103e2058c78588cebccbf4e4bb51a4efa70cff7d80(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7a708fee843503f418c20f2a23fd4c469632cb4e6b7ff79495e75d8e3976aedf(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationLandscape],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ab5e0e66d35f670add51f4e5211048c0fbaa117c3a91687a15251476c873162(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1e1501b9f341e38629d597845035093e513d0d33b0e1b99350fbdef0afc7c519(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__79473a7d976f114fd22f55a8f65b43e44cd090e17e506f002d231852c36a5037(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5c4db52846664ffb46b90c5b498cd034f2896c8aab40358e78dabd9e73ddcaa6(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__04ff05fa6826ed9eedeffad771126f866c2ab682fb6af6d1d5a22c5c6731197e(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ab1a9fc1d58f3ea00b328af1ef7c9dd73bf8ea0bfd05864983ac0d973203b3b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientation]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__726171a809d2b3a6776aace04849fcf2a5d5105217e4acaf97ea4d45b8e83cb3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f3b9744af2facb0aa08e6f6133bec8b16050b9a9196fa9b75fb0673ea44b4779(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientation]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d9ba3393b80b5e8dee0dafe509c662048d42b1533f9cd8cba7490bc3d50b007(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__11a075667836eb93878b501f54487e2b5df8015e24a4f14b4b3f94897e2d9ffa(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationPortrait],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1e6433efe9bd06d2bd4eaefa25e7363878b69ebd93fceb754ecbfd4438aa8dd2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__88f3a112cdbd01d1fd6c616ae256863e5c4b4bd4fc96a8dfbb478968033bc9f3(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientationSquare],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__09470c5e5680028ca88615fc87b4739022f6603e75372e37e9897611ed96bc48(
    *,
    colors: typing.Optional[builtins.str] = None,
    colors_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__32952473ebf8e2a072eabe0a2c9f72ece6276d6ed75e062ec75b2f15c7b741fc(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d1c77ed9c422a143913b1aa3fa4da08a96d386776443c20ec7ef3a3f9f81c2f6(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e74fa66f706dead82e618ae6b81f5dfb385f3b9aac657b3354b4a573dd14e9ed(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6996b33b922a3ea60f677266295e8b3499db986df1f891062c3e9a093d653c44(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f2017cc26c697ab6eefa5bb748689d09607392c502f9f7359b930a3fad82ead(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__58513a844b8a323004300176dce7df27a58a70876cd545a677489e93865b3288(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeMaxColors]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__18a0d8d33652bd578c550c8e9890f0049aa510a64a8d84e0e950ae198bd9ef82(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb6cbcc76bfae0467ec10fdb2fc21bd50e6266cae7259e1f2dd1b0199859b697(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e62882ecdc6dc7e6bf76046add6472796be07493c6df2d97dfb3a115403974fc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f213bb6bd94f5e3099239b3cb46061f75bf877d6863d40c119a5671d1b2f2c71(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeMaxColors]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cdb10acadc9d472d9b576eedae6cc46ba2f1e26970e9b7e8447ceea94b61453f(
    *,
    horizontal: typing.Optional[builtins.str] = None,
    horizontal_var: typing.Optional[builtins.str] = None,
    vertical: typing.Optional[builtins.str] = None,
    vertical_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__50f1825c84a28d6985352e167e89b4d13df0294a1887c161259197744a043214(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b538387abf65c56fe440d591bebed657a4c73fe7c578edcdbeca4489331f9c19(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a15dde6d5184187250380dd1adaa3f5b5dfb483806e674e0d0ee9e8f0f2248c3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__63000d881450089a459d57711a57a4f79dd171267ca14167ce0c3544cb481658(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__49b1fba0beb16800498fc598af1cd5659410b6abd07d4e283c201d0c8452e553(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__12bbb0eeb76f53beff40dd9488412ea0f221e1ee514aa157929e6f5ae2fa72a8(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeMirror]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1440960f832165649dcbe0e5c29dda520d9f21cd1db8491bc55d83b96b60dad5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f86dc23cf197e641039d783374165fbb27505854a2fc6539de3f4b9f28f6db8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__287a1819bcc5dd9e7cc45f6413d6673c2380470c997fb8b5f627b27810e1352d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__94d74dfb28f45785761cd7dec81ae43cabb30a8394c8f8480c024f9234bfe98f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4d00543572ea9130a5bee6fd1bb344e7bfc6555d1d14590955c08feb4e9584ae(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1973779a5af723e21a5cc4cce700bc3d7b7c43ffb8f1d833d7d8065612817847(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeMirror]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e5e744f5ee69170c076947ac4bf77933da096e2a471758043e1f18d4ae78043f(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b68ec60956d8f9fb130872745deffbd1264f4c0dbe5438c5c433889c6c5b6763(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__17fa721b9e7cb55a3c18bd21f8928ce167321683c834b819efb09ae4c3baf1c2(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cfd02c6bcfb8e256a26e4bc3a82da4dd749f45937b9e69ecc36ea4ede9d201cf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f6d5cd73f5cab12ec4c1cf3186706b353d0c21142474055ee1aa474fadf07a19(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ded0c965668bd9b22c0e76af4ee58732fe7990be8cd33451f293b741816f007(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e9a781ce6268fdd3801b0ccde7a6de6faf6015cefabdffc93d891e1e31a5901b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeMonoHue]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8f2d2f01e056aad84d0c6b1a3b51b8e572ae34826a8549e9eb42eebe0dc74b64(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b97b1e36b799f69af662326e783b387027102c734e4137d82242855764946e51(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cfdbc8d5ab69363c4e7ef4699afa79fde67547907295397c3dd75ec3ef360ebc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5395a38db0eca569b079f0175bd3d00d490b2f6795c79aaf55963d46e0b0a951(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeMonoHue]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0db21bcc249fb966c4d44d2b7ba241614eb1dd70d22cc0c4aa8d7c097dde356d(
    *,
    opacity: typing.Optional[builtins.str] = None,
    opacity_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3c37b9ed17945446ef0f982a2c48f9de53f1f124e3dcd9fe9f37bfd5e7db0eaa(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df87905d076e96aecd49d906182ac3e142dcb58faa5828b3026534961f62e32e(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e8f5bdefa9414c326f61e6a6bca093916bc2cd5749325abce1af68aaa696a2bd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8419913764615c4325ed67eeaefee7a3fa2cc39a203c07d498e086c1dabe3204(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3d2adf09e99aef75806f66339a6a9be5bcdf03ed688a1208e5b883a00bea656e(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e0755af0ad16ba117194666fe49cfb36a16d0aae581aa9bc1ddf4c0353b1c3de(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeOpacity]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e0a577d94efe87d5a8f0a5e19a46969a57e4777f53105df5469b5eb12531af1e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b55495e3c3fa85488e224678b845cf0136bd24df6e85e8159215dab7202665f8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3daa50cfd6425959cf0fb10f9f82ed02e2ddeb45f0e28a21d7ba5a19f89979f6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f1da4904232ca580cafa00a493063c5acd4cf8678531e8302ca666315718f095(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeOpacity]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__264b3de9706f13ac5582a34a11479b5d76850c19231163896ce7ccc0dfa883b5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__269877fdc4b1037ad6f023d15459bb731a83c14d8af12d1c24881ff63f209faa(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4466a241bda24c9a8ddd8ccbb21a88e0714f2bc446b1ff9b58cc5d89424ed592(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeBlur, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eb1ed825a057184223f7d02247260fbed4b0c3f96ae0a2e526b3f5cc8faa81be(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeChromaKey, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__db17d11808df2c682e18c3b9b6753cd753a200b088120e014c4dc4a3fb1d8fcb(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeComposite, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1a4425548286ba2c9ad0646b4af56eae644ddbb669ef050596c64599c4b27b24(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeCompound, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__98eb26b7ef57eb478a0ca3c7e94e51e6ca65ef3daed5063815a748dafe2ca561(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeContrast, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0f35d1430aa196644e5c68d7ed2a254a4d34edf398e45f9968692c4c22d01477(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeGoop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a353c1d3ee17ab87cef139e3614e59fa41cd6d88045ed67d235e48f5db4ee45(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeGrayscale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7c751b41e06f604bf4b72d13ce8f75a6ef2a5508c60fab4b9e0ed2043c4d4fc2(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeHsl, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d6ca6f8f2d73e7f117f39c3264098f3ad72bca7a0e0ae2c7b239b069a2b8862(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeHsv, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f53c66889c867622f94662e82676f0865f791e5a5d90ca165bae6b6577e85a6b(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfDimension, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8f4d685b05d8342ff7ee6f420c52513c89f0cb061594533a92632e709fb0adb7(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f8c8146c67cbdbfa127d762718024dbef0c9da634ebd4d1119438d12ce69657c(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeMaxColors, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5da9079f554efd1b266864796ad9cc8b5d74c7c428620fd6243af2b88d81b18f(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeMirror, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6697519e22bec5321fe4a665bd388888a735b095eef3e18a7da432905f955f4f(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeMonoHue, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a232b7e8f991fc652c32f0dd3fb28de3334e17e9bbaea29e49c7cf5a70ce50d(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeOpacity, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dcd3823104eee329d4a3116fa9e4082f829735d2d402906842d67af382978f6a(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeRemoveColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ae2978eb59d7828fd8e48b00cd8e7242d1c0a82d561a29a4783e4e597c044656(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeUnsharpMask, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f424b2d6362a48c32cef94479efc0f4c9c228e04315e89086d2f3646d8e9128e(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscape],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3e41562b91f1664b2b1b501b36c98bfe125df3e6f1b7f736a34f1424d1775ac7(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
    feather: typing.Optional[builtins.str] = None,
    feather_var: typing.Optional[builtins.str] = None,
    tolerance: typing.Optional[builtins.str] = None,
    tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__81d314e46b53fe84a70175dbc450eb40bc25765ed6d895929115e8c8f10744fa(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3bbfe8e9c14fa10f2abc2c8f92da2e5984565b154bba2e69ceb361cb3f06e52f(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0a98e284707ab169f0d3ac8c522764feef0f2e895bbb18c2bb2c7cceb4672b33(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b8f56ef19993c96bd578b26d2f423b6ddbb14b19cc4ed44aff1fb053772730c9(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3b272bf4da097ed4470bd9cc18964294b11340fec8e450bee50fddf32d89014b(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__044323236ddacc6cddb8daf8091a930e246a82dc2a1e78f0e17b32b2a259e6d0(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeRemoveColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__855950f89c60b5515bfe60be3eafca838b130a7c8bcfae5b434f286d52db1248(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__26866ef6e50a9b80324ca998147acfac5124039473a1274d548bcf2a861e9664(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b3119883e59de86658294613c31393beea294c94bfcd8b4a796d84d8ecf1e01b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__95bab1a391503f2e5559dc61149612a3250f206c1dff87548edd0003f836c5f7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e652dad9a27655849e9608b1cb786d72dc5a288f0f7801d0fe8170f9418e2626(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__11bedfb3550f0bddc5094ba4cf28944c003e0d73445cead2a5d8d1cca0b3f066(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5b61baec40fb66163f0a0c3b18b68abf46a41c83ba954e2a57baf9872fc8bbf2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__554a9d01c0b6de5996b8a7a4358b13a7ab554cca85e1a63d6033d58970ba1b6f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeRemoveColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac0db8c1a2f9fd30f342b0cf310c634b9828bef620ef5b94152c564de4d8724a(
    *,
    gain: typing.Optional[builtins.str] = None,
    gain_var: typing.Optional[builtins.str] = None,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
    threshold: typing.Optional[builtins.str] = None,
    threshold_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ed95ef7f3749f1323cd86723b00f72661998fd13e06238d32e1f34362cb9e521(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__230f946e7e667e1366245f88175cea1b6434f1b93c69c141cc7a693e7027245b(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e94d602c6fbfce1821997dc0e26eff0b25cf2b4e449c72152bd6e55860a943d4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5e32435433a9397eb94a648eb4118c4a93db7a36f99ef5becd9d49853a2b4eab(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7a4363844765b5631a9de37614f479e945b38ee0a1b1b0ed50f9c81ca04deff0(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__42c75f9fc09264795447a7e1f4be3932b247187d37ca7117132890ac2594cb21(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeUnsharpMask]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fdea6e2870070c5a7d16209bd8ce47fb62d5fce9bc7c6428d489f88b85198981(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__387c81a564dae871ed15e41f2239d13c4f0af67d3687c96e3ccf7056251f3263(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4d076eaf26f381da2b7d26af549ebd920bf049b3b7d45b722f30bc9b799fb2a1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e10ba5de6bdd4a044f8466fc2e88a35a9588139b961019b5c5973193ad91cba9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dbef65f3bd3a19bd17382a9f2d05c20db9bedce22d91577b056cea7570ed84fa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__33a0ae21d9e9ba730421d48a40dfa83de006e103891f8a8d77b38c39aadf6924(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ed2d5e9870bfe6f5fbf3b536e26904fe8626da7573303caa0362391d032a9dc7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7152cb3d4ae3c96c24105b692eddf67a4461e3b8e65b32d497b61816494cac71(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationLandscapeUnsharpMask]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ad7a24bb881b867e6a32bf62a9d9f4b65bb6419c2d3a3ac3fec285ad5326baa(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f5e28a8c1d4f29488479fda57f2e87448e13ad9dc01677f9f332726a22a1616f(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__68baf241d3a3c4cc5248214c287ad4a98b52a300400c22cae2410b76265644eb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b860cc0fa681f2020deba3b6328befbc005b9a4898aa5ce6e74afcd7591b1257(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c614771071431caca995a4c5bcd405b9b8771e4347cbd4ee14ce28c96ee3bb4c(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4e286e9d4a55b137c60353deed284acb9a1feb55857bcf4a77c07051cced67ce(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientation]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9b8c546ca62404b75ab58493a3f052cf95487d6038311ea5364404ce02d9e9b8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1c273f1a08708c8b3d59caa76f1448b0c01aebd06c8f4884ce23c9a487aca855(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientation]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c86b46852e40e9e2c2b66b84f0625a5fa053ca37165533e286abbb0ad8820cca(
    *,
    background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
    chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
    composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
    compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
    contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
    goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
    max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
    opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
    remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2de4a9695f327a0f74b76e882ebf7f39661d127a6076ecad01459d5467dc4df7(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__98f00d4b804e6660f540ed0fc2b58fb3a00069be2d3e393187b4ff1aaf8ff64f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dad3ba961e4a73d7586ee4b6b956ffd3f270245fad4cb0978212ed79bb0888ae(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__225d29760034e8f64d735170d046de516e4282365bc9bc78019d74d60b3bc043(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__27f3162017c13f246c7d12c0ac83e03e21e473f9eb78f63981e34f1f636cb532(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ed4340404fbfb1ab2fa0b379f9734d3d148edef4b1557dfb7e76b2886f2ec2dd(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e19b5be773e6eb456bf07eb080e4bd73f0136752e803e8e4f9c1d3c82a1d5e66(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitBackgroundColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5d558fba3a5aea3e8dcda8b41bce3d2aaa1126d23b56f7e1e2c4a911466f3d1e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd8d0ead7eae46c99f6b5c82a050b4846dd08bd7658945881aef41edd2ebd1d6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea78a3b6438eb44d3c3a8e406568d2377a479beca7f6cc63c84b9d96f3e6d8d0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__02cdd2931a59413a901d82db8db1c58e0d5140a21797d9d1c335ed1205d0b676(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitBackgroundColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__370308d45c7e51440ce56301e67862a287230fe15e7d7e349c73cb2a76e42dab(
    *,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f4f590d2e2afa6080fbc2500e53dde6eecfc59af67296085e9f40698daacecb5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__07124ecfc7510046ae2ea87bf4e857032e21bba691de037f88d4ef7050ae1ba3(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6972b3931def2fb2407cc5b43a2e0415a23452a421fbb09bfeede2e3f062e18c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b3c2dac90c88da65075f40863982ef366186577f5148c6c2bd489654a96aea4f(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1c78f4eeec043a2a7e7407567fc61dc7342895a86469d0f5cfc1b233588c8e0f(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1ea6ed72af030d4047d744eb10ddd44c9c4b7eb9fc9879028ee072b6eed01f7f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitBlur]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__94e1afcd5d7d506b0ee331057eeca97c5a10f13e42bb1e8f0b0c7ebebb97a661(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cf68383084b4d63e9527321b42a99ef53dd6d9f4f7a5448708172f24d0ffded1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c11a99c637631e62099093ff57f797aa65c84091452811eb0231dc8b379071b8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__31e6d3ab6c1bcf953db3acd6b382f9ed47e3982ef895a187750aa471ca22515b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitBlur]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d1c92a2467ea640314ce2c9a6d8a7180ffc1fa373b1caac2ed66324c7c149dcf(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_feather: typing.Optional[builtins.str] = None,
    hue_feather_var: typing.Optional[builtins.str] = None,
    hue_tolerance: typing.Optional[builtins.str] = None,
    hue_tolerance_var: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness_feather: typing.Optional[builtins.str] = None,
    lightness_feather_var: typing.Optional[builtins.str] = None,
    lightness_tolerance: typing.Optional[builtins.str] = None,
    lightness_tolerance_var: typing.Optional[builtins.str] = None,
    saturation_feather: typing.Optional[builtins.str] = None,
    saturation_feather_var: typing.Optional[builtins.str] = None,
    saturation_tolerance: typing.Optional[builtins.str] = None,
    saturation_tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9071278d9565e3f2466515b3fcb24985d1e0fa3e7ee33d9b2f6456cd939cb3d1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d153355f9b841def3c3300fbb07a3bc206cc4205bc4c063c52cbc427d19a81ea(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6775e79dd3f94de01cc6ab9637b4b9f37c54c554687bbd500fe8798d65867653(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2cf3a73d4b1d516d64b5aa43b9f814e8d5d4e8eaa1469fd6c47796838210872b(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__49a9df210c3abdb7ef2f460d1014d6dfe11f50200444eb8fd04a999852b16fa8(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__95227f2beb9f3660b78ef4a5be28e023fd747d946a40f33c93ddce81c908d1d0(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitChromaKey]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ece9b9e393f3d645dfa90901541b4a71e4db6d4584c3c2d79728c2e01046019e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ec23585c76c1fbc7e958163a172e845831aa7baac8c327e2528e6fdda9a2fc7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bbd7d0b334cf00b15f77378b1c0e09eff8b9b808585c325f701d249e07254d51(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7489de44a5d9a8fd8f6398342711c57fac7651488c134dad57e9f20d3784b165(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__acbe82d6a5ee5c110cf6e64c3c913744b51d1e179a74fbd8d230fff41127a36c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d3d261816abc7cabe61c446f06ade58c999360601e25c927230500331313ac52(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__36f657882ac28a5c6744c8261f6862fd3bc8cbc7f3a2f969707050fb8f4176eb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__99c3a7cb90fd5d653825b6e905c6c6f7b41046af8f04c60983e7723691fbf9d6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5c1161735b01b386954b8a9ffbd20f7416ec6bac7a4806e454ca3c1341c97521(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e72058084d1fd729d32afb03e7f50427fe3cfd193e13f956c262ffae2a28bf3f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3558e9dbf2e2d405e2ceabe4964cc8b9c3cc476a035ae85b1638aaa52d25318a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__938855d35ed79f9ac565d56d359a48b7bb3dcaba0b518846866b4ee9059f6fee(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__484207747473927f2b0e6b356297a6c203307a2d6421eb892fc522ebbc5ad1ac(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d1c7daecc68a12d4f4e0303ca6a2b32f62aafe248ddb9099d41ca93a5d67fc22(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1548875d347ad55cacdc7bd00267c7655712476fe49ab25562d97f6b431c0e91(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9275c834f68544088fbd5f7b66d6102c9e003af92d2f0f79e09c53dc8b827e2f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitChromaKey]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f0c5728dd93b2396fc132449c6519660e35e1bc41b25e7317274c240ca4cc202(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitCompositeImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    placement: typing.Optional[builtins.str] = None,
    placement_var: typing.Optional[builtins.str] = None,
    scale: typing.Optional[builtins.str] = None,
    scale_dimension: typing.Optional[builtins.str] = None,
    scale_dimension_var: typing.Optional[builtins.str] = None,
    scale_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e241be495f0162726b5e8434e17f907a9c9ab233b34bce6f47f3a865bf9a8cfa(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__60e597d99e016ea136333ab2ecdcf94671e6575f07ab5cfb115f327d3649dcef(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitCompositeImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7f182fafc5f050f33ada2be0ca23952c4b18e249ec30a677be29b1a038a8b5d2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a248c07487b04b512a5f443dcc662d2c4c89e8d0b0581c8af8d050a8284c05d5(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c4797ffe453d9200b05130d4fe1c9cd6faf20390efb4c4e9636475a9aaeb9a6b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__341121bcfa50ccc8d89abb8856f3de440f00cd42bc9add10040fe7a02c04362a(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__80696a03801afc747e786cf8d49e75755176efbff1724c26fa387bbe6ebc8bc3(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a28e54df4c4cd8faf93f45d199c07c75d3bd547ff28e2a72b604a216e15bdb6(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitComposite]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ef54bd5e43c7a5b24a66154fccd8c66fa066d594e370a5f1bac745069eaf7731(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ef274a7efd15ce5ff759c942c483f0cbafd28dd81e3b553f50abb47cc1c37ea(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4080786bf68cea4e744d56ef710873509e50a1ac981815c25bc9871dc8d8feb8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__72b713cfe4ba96cf565787077b7c587af45faf4c4dfe253a12beb88fe8985d90(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f0bf6510f5eed7a483d34323e075806d1fd2349155f164a276960dd82f89ea6c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a089ff088aa610bb8bb2bd3e132047b01b449cad79c3e7bee7e854034677c776(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fdebd42632c52faa5db0135de3e45d17169f54a007c763ea36af895f3e60a3d6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__31cf7933300abd9fa09d4287972f81d49215e02df55ca70072f9370775bdb3c0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c7033f8a5673bb6714217f0ae60e1d28ffe627286776f9f0139777f7b29ab674(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__985fa5b9625feed49dcb9e0890ac5649c9ca4038b1ccfb9cf071a017b4c5e8b0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ec1429c73e208e052965299126efd69397d57f0ee89fcf5d3341074c9c37a1c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1d07bde125bad66168e73257254b62d13fc95756886f089470791dfb172f16af(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0d5d3b9c153c395cd5eae128bba91d9a30f9346e90479ec1bedb4e6156414f89(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f8eb15809eefe8c219ea1ad7a416689bdbea563b89d047a1f51729be50e7c8fd(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitComposite]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e4a57b0345bf9ea9a7f00fdfe7e5e7ecc8587695a42177adc3a0a3e26efcfc9(
    *,
    transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7506906cc4ef438c40fc0cc2f98b275710b0af9d574e345ad40bf2bb4c49d090(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a910384430535ac98a9ad5dc90315a311c01606542b9aaad8fb0483f77acc45b(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b351c6cfaa808b273b833cea0cd4dc0d10b78dcca322a446ad49692697fbc030(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__59100a681e7a2cf865930d9d4212403e0e71dbb3c2d3f0e8af708a119bd91e73(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__24ad37a717ae9935b8caaabafe2660a5cea6898bfbca46faf2895ece738e1705(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__40afdc7b2f12433034a6bd1195b4a186b29ec76a73179654d0a2680c3b259fec(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitCompound]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ef2dd3cdd20e039bc000617d04cffb9f823bda3eed914d31a24342a1a1a43dd8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__88b15a1be91cbb6925b7cbfef49e6dcde4deab1775172af0e8dd4b4c2314eeec(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1d8c2065fc4ba700b49ec8a44493b38bd50598b1cf32f47bf37a04e52868e15b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitCompound]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df723edd959a5a48df7d7fc3296e710fb82242ce35d7170d3ad791be344e3583(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e76bc0239f9233eb3156e8d84d08802ef07c56476a70dd254516f6c3b31ca36a(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bd97e51efb88070ffd5037e2a1e5ddde211e1e5ea00b0f39ea24828a29d3de78(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e29e51aa91428354f2d661218e2c74cbb7dcd68018dd22f6b80008b1e9b6c28c(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1a3ddfe2fc90aa24b22a6dbf8a165187202bf9020c1fc9993f564f1c3bd80476(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__06016216fa68bae1635c01220d159beefe3b8c65ba624fdcca92cd2bb2097955(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitCompoundTransformations]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__662689fc52e75e8505df687cef17ef41776b5e633045c10a5f7e97f80ab7f249(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c80e2c85e5509691f8d0a1a8ab2288cca30b380dbd13c3a5031f9c68a9849a92(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitCompoundTransformations]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e3d45a79f36f11237d94c33e05f5d0430691b7e4f351d4b06e7a4692bfac79d5(
    *,
    brightness: typing.Optional[builtins.str] = None,
    brightness_var: typing.Optional[builtins.str] = None,
    contrast: typing.Optional[builtins.str] = None,
    contrast_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__709368a74224401a8d5492e8f4fcd24bd5d17e13bfdb930ff8e318124a5a014b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f4c2c46368e546f8f3d9728dc21b2db373745b9546a263e473e16d007686e77d(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3cf82f47132a0cce75b38001d124f4c290a98d635b7a5ba22e95557649749f67(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ff962d857bf35ef099ffe9d08ce4453cd47c970438d2a310c64895d9749cd607(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e672739e3cf7c4fd1a8996974000b4ce49f6ccac3b020e36c36e45f40b9e61ac(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__949f1764d7b8cf8d28b822a359400f8202dbeebf71d05e6cb4ccfb9c684e929a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitContrast]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__10719fc5305df503ea0b4c4be918dd64b051a54d7629fe4c2e03252c32d41be3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6c71073e0fa1cc72b2f94d5657c148c0d343a2b7da813891dc6905e96fd44db4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__54682bebd380dbc15e2fac027f3e1a0d7879ded9542b3b79039804c2360e28f9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd72cad74ec1d4118046d0b5321c813fa7ca64a2c7704828a418a838651d08eb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5c7ac77be3bb79c211d7dee10ce9ab82630d7029f78d2b419b85097f9ec4a554(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__326f9e1e44da9d82b6e4b5505945bb91f47c64f0983fddc4b7ff07c1da59d60f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitContrast]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ee5c7c95ac238a19af7ab8839fdcfcb6f0394673a3e33de91e882f216ec02570(
    *,
    chaos: typing.Optional[builtins.str] = None,
    chaos_var: typing.Optional[builtins.str] = None,
    density: typing.Optional[builtins.str] = None,
    density_var: typing.Optional[builtins.str] = None,
    power: typing.Optional[builtins.str] = None,
    power_var: typing.Optional[builtins.str] = None,
    seed: typing.Optional[builtins.str] = None,
    seed_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab35ff9ef43eaae9700cc582239485fd907b86d79d3888f8c36234ac0acab56e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__602d2f8cea5af1bb56a42068ee57b431147ae9e3d2693f280169feb0c3a024f8(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b5c70f7fcb98d058292ccd5f0ef58b7c4f035a8a0650d63f36dec0f530aa4bbd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eab1739abaee8ab197d46eca35f799161ca92929ba8bf5708c73ceeab7106356(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__580ad21b16a1fcdca295d8ef79adcf76e6de2c22fcbbfa587d4ca4791dcfef09(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8db036d14b11f1a1b0b7525cd963f28b2fc627c694085cbdecf0a2f80693ce43(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitGoop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ad918eac7452155c6261aa9780732f749adcca11117f0f10574f76fc07a09442(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e33cf5377b91fb69fe8e882f9b685833fb728392bab345f2f20bdade8987558f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6c37ed9fe9bbff45670229ab9a6250881f7afbf4d9722cb941d02591ca6b405e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__999efe4c14acfbf95d94e4318027abe9b1c7761379081d69ea698b83f4742ddb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d0159ba4afc7910fce62a5972fe97fac1d02772d78e269ef5c1e3dfd4445fecf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a57a31a04cdee8ce8775906071459d502a14282d095800b3494f9e7c1f4a317(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__78e877d6de9525a9c867e5529841bda1fe90691df0576a8de85a3ed67bb2373a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d64e26005c08d172577388349b905e7225272aa437f574a1192dc0d4945cd5de(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bd199e4ff6e7aa156232b5b791da06e892aab33531ad6d1237c8189e0ae65aee(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8770e34d1b3c5887fa4373ffc76b88cb990699f39adea427ba10704976a84c12(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitGoop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f9f861cd2e122ccf552b5c69ac8885dc4519a8f8acdd42bb9125ba6680e3d9d9(
    *,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ec1ca280a039bc6157d3df57b6d780b84b7328f91d8f40413cdc7023163b0bd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__78f5ef46c3e2a7108e581aa62c78284d7f9dd7ed333787cf7de8e7645883b912(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4d33fd804e1a0d35f65381b35c59896d9f0980a3cd1a9b80c9b5cb722318fa37(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2e8e3de1bbb146160070a2893f5a7d7af3ab49b969e402aa120f320d5b954ba7(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__98f05186f7e5f8c807ceaf5645f4f103360aabf71b4dbd63021acef8d8d8e819(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6ab3a83d892049e554edc0d224757be1de2af975d42cc0d20c664e47e056c363(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitGrayscale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__beb16c3db888ac0c321fd16ab89db82a84ea6070ce33239c53e5289b0f2b4295(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__77cfd4aa51540df9db84a55b531b3d5c26f4e011befd9b882b7f20e31ba37c7f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d31c514d3251f8ebcbc6eb72293dc984104449af8877f62ee072485a9987cbe(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fc6267d00acc6e2aa23b593f413bb75a1de138e0042b80d31cbdb8acc654cb99(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitGrayscale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__436fb0ec5eae9a16e03f3ff0eccc019c775475b1712e1a6f951f2db30d849815(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness: typing.Optional[builtins.str] = None,
    lightness_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__05e568a35ee803eb8f779fcb31b2b084d4b5ab75955c238b2e83c34fb4e338c1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__659b6247711e162143a4b2d8ba2f3766816b5664f8b20cca1ed43487308754a0(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7a4f8435dbb43780136e8bebc79c0efac93d570a3c932527f0025b639d987554(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d03a867d9064e463b693a91819ec55135e08d32e71bd8b43ff295fa7d7cbe846(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3481a6c6ebae651736882419b0aa02a0116ecd5ac3e97d4000a9d66c7aae57b3(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f168c2d24ee8902374a6c5c583712c07fdecae9fcc2b9f0684651cc70be9c71e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitHsl]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__20a095a9a78a2db112371eb3e2e091da5ad4ff59201f179cc32971136efd646d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ae8382a3f1ba0aa68ea2abb243b6d446f68c5276aac30cff564cc0ea939b6511(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7b9040c93bee510c9176e95ea5e654052c443d53327aef1aba5285893ae86ca3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f8ee5896fef44e2d0a113870603637a54823f6f1b3ab7315688103a0a7a63a4e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__87f579f7d6ae704a0c3e245b80f44a414d4a08202491154154b6903fb1f70cc7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f4cafaa024e914eaebcffd4d51f5704ab1ce78a652b628cd95c0640bffd35a56(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__179e6c67f536d4205c21c6aadc7d20f05d1ae69dabae652867ea53fa7d00bdf1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5e5635414b3758413263dc480d54ab492e1cbdb80ea659af027ede86f9214325(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitHsl]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1a1c0df46189f6a1899750a5045e2f34e2d62a4e12dedb4b37e2b38948836750(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b9137e5be18565bdf8dd54dba447bd0f737dc8dc320b397cbb88f35f30f6ba0f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7001ba82ffa9c408f24524c043bc634a8bdf230eb80d20983dca9fec5255be3f(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__acc33184147732b75e6171db74b6a1583226070b8f21f9556e0f1b5d3652f7bf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3de8b8d03aee64cbdeef8f44680a0106311f46d3ff52bad4cffde6bdf5a95e2c(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__488052b48457185695eb02a5fb675d28cb5082e3b4299bee7a53869778ab213b(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f0a09c8232771646b4891b3a9f5cca5f91678d8f2c4ed25c74e6e4c834349c4f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitHsv]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b1c72fd785286ef298334011f7103145226b2ceadd2287de7831d7e5919ccfe9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e9de69d0bcd157234b4d4c4ae2e0fd65cccaabca9908b6aa1aabb46edc5c7d9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4aef9aa0816ff8d88a283f4704108e1a7888e3ec6e7c0c38e605cbe1b7a89823(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ebc7e4915578cd5fd3c7398faf634353d65cfbdba2e6f39599879d8aa1dfdbf7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3b4405d3c9dbf6bbb3dd86f84b2003727248440bbf9c2dbf41d98a34af48db89(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__621f725869e638421814e5d218a5fb1e21c7bd2cd6f681b490fabfd288049861(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4e6df4ee1478b6a8f52829a1dbd95b007dfad8e847e41f675fc423e9508cf626(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b5bf37e0e8ccebbeb6ba42f7ea33dedf910a9e96a893ddf6ba93020d542590e4(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitHsv]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__26d5b84126e861755af87a1c9712db4e6a6db317270eacb57b4b863cd96df4a7(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    dimension: typing.Optional[builtins.str] = None,
    dimension_var: typing.Optional[builtins.str] = None,
    equal: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionEqual, typing.Dict[builtins.str, typing.Any]]] = None,
    greater_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionGreaterThan, typing.Dict[builtins.str, typing.Any]]] = None,
    less_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionLessThan, typing.Dict[builtins.str, typing.Any]]] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aa75721ebbdd570043c16ce74e2e48ceddb848e748aaa5ca04230dde4e6fffaa(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d2a656eb4474ac4ddda9aae9fe774031d590a0b7fe646408c6b2da1511371534(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__28fa37833592076fca9af82112bf5b405a24830d83cea8793f5aed77b82c4cb3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f848647d40c1f863293b2f6be5c036763a4f9967055ea1c3982064f1b9f68126(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionEqual],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f043566b67eb003ea921bb06ecff2d2abd70d99c87fed3f90dcbbee54928ec28(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fa3ea7bed3b36070c452a5f71c92b0b03c06b4ab499688d38da5db055283ad32(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionGreaterThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aae67e9a0cd15a95eb08ee362b627a0c13243bfa2ef4198f2016d4fa7ad96556(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aeb8e77d4964e578816715bbb71183bc1d6432bd87dd5327afeb43d9d21f96a2(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfDimensionLessThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__02176d16fa298a5507d4cfe05fc6cf32bcb703d96b1e5706d983e9a71c874376(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f68dd4e091d7449f94edc97ce07f820337a959524434aa6c46d9a10e428ec45b(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fb7b09718e2ff022ecd2a90e226514582977324a473540b067b30cb5a8354a50(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb6e4b2196403f69507b4721c0a9bf57b39981164e8b088cf2a25d104d4ab526(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__101cc5395ef606f8c8565c9610004768bab765f9b9525a33d29966250c175234(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8cc0aeb1c3e4532caf9933e6558b8c64c74548f2ac7fc71d99f418ab2fd6655c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfDimension]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e9b99e76c6aa32f14c56d0d7ee280a0a9c84d197926ece012ba97bf9880eeb50(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__217eec65594b26b3427f3b2a52dc9485f31ebdf6559a714d03f3d6c9c747334b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4527fe63d79c354cb344378488c8904f4490b7458275ff95521596c0ca2bd8ff(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb96b2772435f5d64052ac76d22aed4cd434f3d3ef73621d1d934af3cdf7bce4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b6b74f73a811149ca12c252dbafb4aaf84842cc43d24f6846c93f8b72e4a9529(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__527fd57d8ca053f058ea2abb20b26cddc85ba5358a37bbde26efe651fdc42980(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfDimension]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e5602d88a81d30098b46e92c3ae3ef9637bd12844e52d753566317ef35b1e382(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    landscape: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationLandscape, typing.Dict[builtins.str, typing.Any]]] = None,
    portrait: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationPortrait, typing.Dict[builtins.str, typing.Any]]] = None,
    square: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationSquare, typing.Dict[builtins.str, typing.Any]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fc111cd5be80c452462c54ad7098b659f487c4a66fcc0fdae338800edd449b0b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d60d37a6fd54a47e120f44432e4be684786c1a4dbaff2525ca72b779f5dd6841(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5b057b267292950a968ab81d8cd775da6357d67d8b14a5fe915ee839885e2198(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a072f88381d9ef20bb67c7118a179e95956c5ec6b6cbf8a5869fb7e5dbf0780(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationLandscape],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d645aafa0817c70e5eec510e997e3f5103ec30556a993c261eefed717037efc8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d05d7dfd792032636532949b2a038fcdabd03708f9914226fc2e2e78f8b0d83(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7cf22a1100ec0b3f2e30dfb2c3b09cb254eab3b77cc412aba8cb4a13c9ee2f23(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__672a98258de9131fb40b6bde7209bb3e6a0046087bef612e72571b055f056c72(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__57a3cef648c071d4365fa1cdc5513ff7d2f22ab300179c0b137d799aeed4ab21(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab9de4cd540ce960d6623bc4b97ffce5b810f95ed7efd3b2f00f739c4fd70ca6(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientation]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fc1acf5df3e827660af169c0dd7165c2e85834a013ffc65425fc6086f203673a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9f07f9d3fb99b1a72a88f8ec53fea575af8c420c63a868edfd0aeb0507b5d7c1(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientation]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7a5f0b59c2d9b1ba3e17bbf11b894d7248bc0b88a657e10541980009c6b491f5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ec1240600e41fe46253b9677836b16e710b5a97b7cdd4a29066de71cb3da5a0f(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationPortrait],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__32f604af6c9f88f4c7d6f9d0984f6bb8669a064dc353359aa96bb45d830b62d7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5b1b1a20bc9800a961c55cf92b90db192862ae06beb9634574d14ca4155eb9e3(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientationSquare],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__08ac2487006c87ad398f1c746a001d75ae17faf8a41f384e81a2d4c5dd7216c8(
    *,
    colors: typing.Optional[builtins.str] = None,
    colors_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__99db7d16bce350721cd1b4d9f500826efffaa754679c12d7e7e20114920b8563(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__377cf9621ed6963df8fb0f3a649df09ec26b122cde2fa00c0fdcba55b2163e5b(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2c2e8545f760e37205d5258c6fd8b566ede12ec02767517d057323478f8843cb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__deafa2e00e11c7f63ca6f549dc93c3766e478b6e8b121d154c8e201eda3fb642(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__074e958441ada59b2c3cf39a2b90e5fdcb3d09bc37939f1700833c19843aca62(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bca54f4a3a51d5f0b155e5651feeeafb02a50c573d02a0dd6ba644a5aa4d9d77(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitMaxColors]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ac50396fb9e02f3f508c5d2ed1f9d4186116410715894b2131ebbe4279e6c73(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9803b009b1cf1414b62c1f79b99697b739c06a7bccd75e302cb1a67480c02f8e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__13ed5d208e68d4023e68807fe62c22e10820b9fee92fbbf355984aae25ac7be4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1ae2b245b7baf641f4624d265a28c04ab925337ffc2232b0319ed0341bb572a0(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitMaxColors]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__777c060780fd74b3a46f72c0c09fe8224fdb9d4edc813d988f64cf669c894498(
    *,
    horizontal: typing.Optional[builtins.str] = None,
    horizontal_var: typing.Optional[builtins.str] = None,
    vertical: typing.Optional[builtins.str] = None,
    vertical_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cb684e5e2a6782ff9299421b98b0dbf4298bc19ccf83910becb86d01b944dcfd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e8d8ab8b81a731438d5f45896cedcc17fc36c7599e8f03f63b25d5e6864d1b46(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__02db076d11fd1990811ce6eaf13984ea3e2e3165c1383cbef6fb5fdfca4c993e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fd9f60b81d4d78d84d0f0e747366e497fb351356b930ac50d00338ba21366f40(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__97323754a12f372b128958b7d99ab3fe90fba2979eedff1556adc92448cb8e82(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7094cb5d8ea87e7859a10ea79324296234665670a9fe84c2065598cb2283d73f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitMirror]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a261560832b398d40b2c67aa0296ec248478e88063fb68c5bca945ed6384bb72(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__23f8cc3254a75702d1a070c5d46dfcc97b4a17d3b35a01db682f4bc1ac811d19(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3cb083271f8f397b5b095b90ee99026d869be9273c834b0340be47c5bd8f329e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__300fe45309f74c91fafe4dd8bb67be6a4fef10f25d5db6cf7e3118bcacfbcbc6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5105359cb22b3dc6cbde504ad4e62a20164da207e5cd0845f55564dbab23f21b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0914b09e1a50663dafadab4f5eba388c852c80af0363f113efdbd5b08e1184ac(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitMirror]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__59bc4947f6292c907f63533714ba88776c51c89b82388b2acaf58694ea127bd4(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a7801cdcec283b82bea499d026650c2ce380d122766ea6bee45dbfb4e486e4f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d15ec16270dba7601fb5805c0586b073666d07294b7311b58145e096ba8f7a3b(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ec018edb043049c89cfbf069ffcdb896587720853a66356ece11e439884b9467(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d877e2c3646c736cf65293c908c7afb6a0605c9ca2a9b8bd6254890750e8b06a(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__955877542fa5f7ec65fbbebaea4d132e452cb7da0d8df5d60365b4643841895f(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6dfdd741cfde544b89a0b42154e9c9772f497910059fe4327c326afba9f230bb(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitMonoHue]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ffe8a4914c9ae44f007e26d30af9727e49eb4f804f4ff1c170183e2bbb5a74f9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fcec5f1c56bdfce4a43be56538ebd5c6fd0765253467ec7469b064ac25a462bd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d36001782420285751187608147cb4a0fe770a584535cfbd1cd49581f274501e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__509bb280f287cf4d1e0777171c04bb36ee09c22abce1696f67553f6ca14f4c6f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitMonoHue]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__acedb58049aa8533ecd8ac9eae95edef741bdf0b4240a2b958cede24d0ab3c1b(
    *,
    opacity: typing.Optional[builtins.str] = None,
    opacity_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cf212a823a0f4d74ae1ce333335f73f7c24b8be553c0a69ddbe5ca8b344b738f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d2fde803ea88061285c6183234bf89d67fdc1a1eb27863f7ff5cc05c7cb1500e(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5db541ebab2ff37df2c087d233c64f63fda397b5af6fbabf37f3a290b8678eba(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__52bc7508f1a5d7ced34800a7d62cc625354303e6c1f8d0109a1c3a180235a45c(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc3c740f698cc19ed80ffdb92d52ef276a63dbad7cc178331c5c31bf726537fe(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cb70c6fc8929494a69a4f9ef9d66bce38b59437770c8295ae7bbeb98a7e6a063(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitOpacity]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ce462b47f2b0f55bcaa64d8ca385f291f1c511e86c8e4b71227ccde87ce396a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d9f51b2a443fd251c02c731f59f4e79ef10021f5d059de1d0b9c06fa230406e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__624ce1955c14cdfac403649b421958f9d2fd55736a8f97795978f50b879477df(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1cf788b434eaae630e8c30b62e7c32efbc59e9ba9265d7a101765b660f1824b8(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitOpacity]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea876497d75593c986320862424c4853a509742abbc8ef56f047d2e781c6444e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fa3d6faa8ee595a0ccdec723da535a4c535d305c0862e3040b3ca2ce7513ff49(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8e8446d4cb2f880e5d7ba6e8618a6d8ce9184942d798bb2c82d1016a82b368fd(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitBlur, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__36481dea4e79c59df438c4418fcb8313d541bd775e7fbc7f86b038ec3c4fc698(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitChromaKey, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8e0e13aeac7afa6e3344631ff2f9211f402e5ce49d6c0140b729b1017d8a45f2(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitComposite, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f9da7c76b2f7884f1cdd28439a863185183827f071780fec400f4dfa98efd3d4(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitCompound, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__832c568b501bff3216f4ef80440498f0041cb8d7a855a1f9652eca527c4254bc(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitContrast, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c85abcd2c1126588011b740de2adfa9f030b2707e24efddea23f6e1783242062(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitGoop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3f592dd8d047ab5e68c6473eeae27ccd5dea3ef8623a8d42ab6c256fd605282c(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitGrayscale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__44da562189feddec9cdd76177f253442ba0e5fabd8a776304a3dc9dd4bae4c9a(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitHsl, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e528419bd5be571995539f6b646fdbc837af966a9fc8d2c67324542b55c27632(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitHsv, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f1deac63b6c91697e93dc73e585d79c870a5dce93b8298b14d86b2b66690294a(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfDimension, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df1898844ec30ba8a2e90f59052250c484d0acb08807e7be68926b082985376e(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7c0645d4a72605984e1b3d4fa8c19d73263c7ddc81ddeb749dc7b4b485ed6944(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitMaxColors, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a30b8e79f4b106fb798e968f2debd5424864959e0a70e584ce18e86e14eb7bd2(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitMirror, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7047f65b5f8b2b2eb9341e71edc88ac329187b12b44f5ce80794e007b2a85ad8(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitMonoHue, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__51f5520dc1fcf62da02766a656d9561b66d10d97a725d339ea1e0ac09356925a(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitOpacity, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f844c55f51e2db344f31e8dbb66113fb092aa78bc8cf9a26de33ee11efd06cee(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitRemoveColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__42b52f879327910dec16b345452437d17bcab440e0118c0a3a7e7e0b59118552(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitUnsharpMask, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__11b5f142e9ff1121640350748c37342aabef1c183377c0010849efbde9c1b313(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortrait],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b6b9f2cc05908f5a1f89ffeb1561be1e14478e81bce809b789bbd939cb40b99e(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
    feather: typing.Optional[builtins.str] = None,
    feather_var: typing.Optional[builtins.str] = None,
    tolerance: typing.Optional[builtins.str] = None,
    tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a814553271b450ac9a9b62ff52a2200d3c53387c5ebc42ed46ee9137042db7e2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ad81c51d6e8f8b607a2a83ab5cea0cffd10236005d621cd98a493a721d7b4cd(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7c463059626d32dc5ab5a6b77aa26fc8b98c5174686328d6f4e5341577b3db9b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__387c1017d8779a9f80cb6daaa59031933a6c5b1d885ee63c29524db75747f653(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c2f75193ae49e2cc229bef746f96fcb36b4cd3a2269c90c28d688f6ba8b68d25(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__44b621af7900f6afe3ff721c86024c8ef11372521b1cff148d61ee3c31f492cc(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitRemoveColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9e90806fa1f49af7cc687fb69323ca6cbbb3960c6dd954c2d98d043dbb9b33dd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7041f51b5e571afe30ca1e0cdbd96f0637e394d98c953258abb27726248abc10(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3d0fcf49d9c3ecf364dc07af681c32489f839bc1c8facccb5cd40e1771d44f38(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6a25588bc81181616283aaf8399d7fb4d5b053699fdb8fe5b01ddf5a1788b4a8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f4d563cec01e376ce886afc7b1d4ee39313f3fb6b242b139e2d345dde849a00a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d6f3b7474ddfb77b96ab9f104627ee2bb8bf995ef2623c85dca044b5300b6bde(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__05da70983c0ce8cc9492efa8bf44d1d5528b24bd6ba8a3bf516e5495fe1c4c9d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__46fdd44352866de6434a25bbb1bf397343d33fa71b9c0519d1ae56b3605b4aa7(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitRemoveColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f1a7539160676ae202d4b85288a9740ee68a549c5675b7d7261d4b03b36a735d(
    *,
    gain: typing.Optional[builtins.str] = None,
    gain_var: typing.Optional[builtins.str] = None,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
    threshold: typing.Optional[builtins.str] = None,
    threshold_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a77f4afbfadab5ee0327959d1d21519b4abe194557e2e53c382227923b528d7d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fa705589e3239d0986ee4f351582aed076a969d77eb05a98cf22b4f654689244(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8e547b03ae0955ac62ce589e923349718ee705056c692e545894a37b54aa9a5a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__92ac980cfa9b1fe1373b3d48064c7d49f568de016c2a4ec13161d95e455c8c15(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ff7db05ec07cc27fb456efd3e56abb41ad94cda7c95ea4493a9aa0969256b49c(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d4e2965b320b340cebdb18c66e2204b8742f17cabcd847c31b15278e83ee95d5(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitUnsharpMask]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c1b6ad74dadab67a52b8b61657e56e659730cdebdf2c2873a757857e8ddfe40a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__05972392be930e58cbc2635a69f585e5695a78593d8643ad2c8f61c7ca8ff64f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__43c45642227a1e69c47d52f5d1abe9ccfc1a454f895f4328fc533e475d9529d1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4534a7cedac18fd076dac3861a1af8a5e2ceae038e4b0d1ac47c1294265adba6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__13b121fffa6b143cf015541f82329d2d44e5814f3a4206bca7dd9769ef04e537(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8dc9da09a4a7c0b2c8af1b2c07e56ee1422bc05a974d51d4e0e490a0f82cf3f8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__33bbda3a44362fd66a00025cb8d0a185184ab866a9a00d80798e39f5c7e1052a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__196db9ecea09ae78c3043fa2e2275c5f45fbb2bfba7ec22f1263c4c78b89e4ff(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationPortraitUnsharpMask]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__80a92e11321337992be9f77355cb8125888ec9a896f63500abd3129b82ea173f(
    *,
    background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
    chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
    composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
    compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
    contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
    goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
    max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
    opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
    remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fbb9df42344c268bd458811d37d22c0c303cfedd29b479bd8607c3791016c8bf(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9f7600702a1bea1e8340ffa8595d6aec15db9a5494d61012ba1f2cd3cb64913f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__60c42777d0422d62d8f7f8280150f5921bdbd177e180a9406e71b87c15fe7fdb(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e57bcde178460f1e2af348b7778c7a4e99dda3e4765577d483358fbacb5bf56(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__803398f9426c8d9d316a374418256716c4c3b1296fd273eca4fe170460399fb3(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5a7ecba10bfacab61dc0da77dab48a9da4670b15e95f2ce172b83486a932c309(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4d11bd7dd60d2781c0304927cdf00e9dae24d7909fe540c6a743b97de5d62c65(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareBackgroundColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__086ace57e74a7d905d5d22acdece666f1daa03709427d5aae5b790098781c5d5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e7bbb80aee4671b1210ffb92f4c1ddb7dcffb79d9764058566e55b2085e75cc1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6b23944571ee8b64fd15097034612fe72834cbf41670f94674bfd59f3cfc742a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a1fb82327f05f98d37204c4dbaa324a4c220a6d04a8d6994e8c63ae63d23094e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareBackgroundColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8f249e1cb18241a9df11a08731ae68fa4d1cc8b94f269a6ac240f637d6810eb8(
    *,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__210e3b62786eaac956d81f4cd838d049efcaf1c9b7f2880d2da94f78f4dcf003(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a6a1b3bebef6af9e9a47cd07b2b3c6f634d8c977cda01e8c55d2ed45a15d45d5(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__913b5eda3aef1e1137fe7167d7c15b772b1be092bb2baff5b6d469adec64c2f0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5e87066983189651ac7d64dd6697cb87731c2a9edb1cc5fbc5b5579d903bff82(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4854c6fe86ae16a1ca50991b65ee6951428b7ee1c128914d659c96a66dfc1b99(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a2b4f80aa219c2ff1bc4956bdb4e252d40676bb49709951fcc766e25cff9e75d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareBlur]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__388a10889b7c8a5fe0dc952dcca2433846d2be8f9909ac834685d48add7a3313(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9efc7717d37316ad261c35ac0f7def34c38461758f6b555127dde9fa1c624a57(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e2d0977644cce961e4b921490dd1021fb59a895447d7116e69805b972d459c2c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a606533ea8482a717b5cc9cf665ae1addb93e1c75ea86938d762e683dfc14ca(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareBlur]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d49ce00689dbb286ef40753754dce3acfd7031a7da3198a33f618a9bff07f0cd(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_feather: typing.Optional[builtins.str] = None,
    hue_feather_var: typing.Optional[builtins.str] = None,
    hue_tolerance: typing.Optional[builtins.str] = None,
    hue_tolerance_var: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness_feather: typing.Optional[builtins.str] = None,
    lightness_feather_var: typing.Optional[builtins.str] = None,
    lightness_tolerance: typing.Optional[builtins.str] = None,
    lightness_tolerance_var: typing.Optional[builtins.str] = None,
    saturation_feather: typing.Optional[builtins.str] = None,
    saturation_feather_var: typing.Optional[builtins.str] = None,
    saturation_tolerance: typing.Optional[builtins.str] = None,
    saturation_tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e90254bb0e6e23ffa4757c9b1b908c2dc33b5fa12ce0481ca3e5e2ee6d37fe99(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2698d89669cb235c77d4eed9dbeaf9a1aef748b8a86af8c5f32b593a1b3eec86(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a172bddb3bdb58f6032eb9dba20263b1acf6984ba4d8f8e9e48027543701d783(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e10c63e1662787d0347b125da54bd5d01fe79b05a061d0e20c24e929204b66f2(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__de880ebf09588c2467c55e0c4930a88a136658ff3c1367a0b11912ae04cfc456(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cf71544a22e4443b87a105344e3797653392bd673fd34a3d6ee06d0d8493268f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareChromaKey]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5b00f9cc6a36eaa910562365814ae7d26ac8d09bb6efda208cd5d3b34a234709(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__45277f3010244dc073824feb0e65ba6dcaa003f47fde78d3379d961cc1d261db(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__62a5dc8715758ca47bedde539fb97dfa74595627980809ad708f2fa4e6e414c1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4cf083a2338c05dd33048f564325f68a02b637ca6dfa52bebfe22df38cf689a7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1de571a4501155d203186a4c1f3435ba8da3d5f4387a4c5e37656ea8cafe103c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5dd242642dafb92e040d67b5ec27e776a7d790c865670816926cc0b63b1b397a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3840128de3a0bc7f1514e2dadb14e0c40ff9eda45949606f0e494b9e352e1b9c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__544c7c18d43120e0d6e8d8a7fa7858a8a1c23182deaece98f8394a4341f9ac9b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9adf59e91499906487518610291e8c710bbdfe43be39cbbd69a14cc31658efda(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__41b962083344ad280b2e4784802dd078d1e888f9ad0a59d8a3c4c8890ab16fab(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6ecc45889624b00464a092075c83d13b7cff6ba8deff824b6f957a5572db60b5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ca7e6441fe671cf68f0f0f1f376f80ad0a1bee8669ab4382aa7fc1a1f344aeed(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2b3edd420bef599de4027037eb51f3ad3729c3121434bd82a3e2b6d5230abf3d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8e095d564066d7973308a67cc063633d5ad82424607f04855ccb19d1c5187259(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fae1098da9bdd7e2dc310698a29ef30bcc68c75273c4f38f8ed396054a0d864b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d6513217b90f0ba68b2a8187e834f492b54fe8e282afce8d644fbeb99344a055(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareChromaKey]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fa59eaba9cb97fd529e00da522cc2ecf8c01413625133db20e578cbe42f69127(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareCompositeImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    placement: typing.Optional[builtins.str] = None,
    placement_var: typing.Optional[builtins.str] = None,
    scale: typing.Optional[builtins.str] = None,
    scale_dimension: typing.Optional[builtins.str] = None,
    scale_dimension_var: typing.Optional[builtins.str] = None,
    scale_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d0e32dce4838bf34501b97aa6cde8aa0edf11659535586c827162d700505278a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a4291f2f0bfb7733b3f4af63255c4fcdb43a4f19abdb2ff56be25546020b6316(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareCompositeImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5d7269b8d89d5c7380a40dc549be08e47b6ac3dd97378109306b7d2633850d98(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0c979f22c775ff94e54bf2abb34c5fa1a8a019de55f25953f9f58ea6297cf438(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fecc06869e62fcb4b6d8a6f2fb52ee81e5110afdea25a99096e71ab1ef68522c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e3a71d89511077c27600ffcbf36e15b98a5476fb1e7e7e1baf245238b2651a64(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__870932c990c2fd6ddfedd0f234e9f910fceeebba6cdf3aa19fb6201b1de327b0(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f4e45c0e8efff5a5095d0d10345fba469846867c269be37d1764f8aac5daf109(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareComposite]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__747be4bbc3106c5ba4a57be97b40efd90e14f56beae72eb2ccd613bbd4514e51(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d9a0a3c49f33d2c4d5f8b17ac4f12a16f45648caedaf86f143e10880b8a58ed0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__afcfe1624cb0a37b553cce9e274d48bf2dd6d7813212055e4e25e5e1eab3ab3b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__942bd46b9650a459abe1137fee6d75be629b02fcb02ff7e9cf8314988ab99316(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__278468fb67a9516ac9aa930eb62a9a463d2814c4b139ad5d342eb780d17e3307(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__93af1b77f9ae3af8aa55378a42f22ace6caa84c9f2e11b63ac01a9cd8ffe1219(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ec5c3edd0ef256adc302c4eeb6b83c6fe5e3668de8bb46b89cc2a43efeb3205e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ce2d7e54d66aa063c3b05743285e69a22208e5c63c8edb013afcfc4f4f697417(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2b05f233c3b633aa314fc4123e8a550f80dc66901450895e638303b7d5702758(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__47bf629fc70ced474162d995544b3b7a7b927fc49f9da592831dc6ca308be81b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8172e0fb8de78f2d2a70cfbc4c4deac9fffc279819ac36b473c60be2b7cd54c6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__44ad9e9b13a1d1bafe5f816ef4741e6cab1f47113a34f3af92a3fd47eb8dc4b3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9c80903915471d2e5887d24a5ccc7d84b3baa9a927a8b0c3d242b7fb7707d9a5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__08aab64b671dc2882fbf38455cfece390804ed69914656d9a22020a2d4fa7c85(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareComposite]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dc7e952ef6395f415760cfb31ce8b2938256a6c9d844af9f40b710f5cf4879e4(
    *,
    transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4f016c9706a0ab5414dee39fb0eaa6d409b657bb112254ebbf4d9cb277b84792(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aac139efc4bf27bb9e01567d5b588e8aef302e55b9ed37b10659d55da8509f27(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4b7589132fc7aa8d21b080b28250f58201bd0b118dfcb1b4f316e67556c1d20b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__05d9ace34929cadcd62d29c801d3f062bef44645d21e2b3fb71e7aade6d69318(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bdb82f78c9cb8ccb9b9e43fe198bd77b2df7afad91603b673dfd2613396b05bc(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f1767293eb518942fff2f53972628a08afe654ab44f41212bee112a0004fba33(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareCompound]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0bcaa9eacd080d9ac4f8b78c54090e741e690e3adb96f2a22d9f63ab27cf843e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f85993b867585e46dca43208fbdfdacdc81e946d29b89c1e294ebf404da69e20(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4653772b756c6972d7c50f4c5674e561623908f1d2ba08f1a3125e6dbe0b09cd(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareCompound]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__24f10db8c8d827471735d10f8ff5d5870f486e712615f539a07df61585282152(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d7be54c5f2e14b317bf6fd837e8c2474df830d94894cf8d182624e02216f491b(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e36bf32f154601200bf7ae96d5616d496f052d2340c475d391c888b2a1d32913(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1ad062c54ba5d7c86577225826a517d1cedc559c2d9ca1e725dc056f9f4e3935(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a545035886e52f0fe160395bcb031468f0002a9da9ddfd41b588b61728cba3e5(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bdd1494d05d4e39129ca1997cbcd7e9de5c6d3735c969b1ac8fe849751be93bc(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareCompoundTransformations]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8911bce0990dac3c7372adc6cb2b82110255b40522755f79969bed7b12e6d211(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f7957adf223446e4c94ca1e962a8c818f30955a4e9bf8711d663c8deaaec91b4(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareCompoundTransformations]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a82fed95225c2747e4f734550530620339a8962b19ac4e152915681b3c4278de(
    *,
    brightness: typing.Optional[builtins.str] = None,
    brightness_var: typing.Optional[builtins.str] = None,
    contrast: typing.Optional[builtins.str] = None,
    contrast_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a0a70b5953c5dbae25976b360e06b1960013f18630c3be2b9a779676c8704307(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ffbcd14c4fe9de71de616c555367e59b1a3b8c60aa98e3d6ad653ab60c381f9a(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3abd23be4b723ef3e669a2f8548b7657d8acbbc3b800b1ac6517a193be8f97e7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d362ed9e83ee5390d15321e811ada84778ac921f8a24e901cfebe53e0350440c(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a900917e8edd17cd75bb655a481d70adde573a364b4eef30662c2d8d948cb26(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__125b71156ca6a0804129a1497e18cd7b4f7999ddfbd9908d3c152bbd7fd2ca25(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareContrast]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__190d07dae4f862a8d3b62e0a25160cd55af6ad46e19ff406fd656385f77d94cd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e5385b95d8d14c84afc7b2ea6049f8c433e87342455a770ce352a99908c9af67(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d80166b001800565f0a5637241ecb089d30ab57ed58bac381b7336f03b7d5815(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__40589a01387332a9c74e43d3c3eef3dea512f238a596f4d3217dc8b5cb3d5a78(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0a820dc34210662736f643dd45c8fa041ad79136b29d630a0513da1f4ac2460e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__54c6ce27ce20c36e8bca9e7c42e01ec423a25887d001026043993814413e5716(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareContrast]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9e7363566c0069f76bd391dfeaa7b37013dc1f62cfd3a8b6feea04972d788e95(
    *,
    chaos: typing.Optional[builtins.str] = None,
    chaos_var: typing.Optional[builtins.str] = None,
    density: typing.Optional[builtins.str] = None,
    density_var: typing.Optional[builtins.str] = None,
    power: typing.Optional[builtins.str] = None,
    power_var: typing.Optional[builtins.str] = None,
    seed: typing.Optional[builtins.str] = None,
    seed_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a61ebfa3f52307da2823383d2ed51255176c94057b44b5ec452dd750d224491(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c296e170bbc7b1dd71b0165b382ac5723439d0a357efd861831493883a847cb3(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3279a0ace45433adcf0ba461ef52885abd4079846724aeff78d9dfbcf9084c81(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__88be958b69153061ad57dfdc7419a9637d8526378f6c5db0b27b35438ba23bb4(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9064acc1390b64ba7ffb85a36aa4082995d2261668391574d9891c174b505b5a(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__19bb3fe270128bf5daad6fa73034330f607cb3fd47760e12bda574b6323d79cc(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareGoop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ea78f13fb375cdfd146c65748fcee2ae9a5c0bbe95a3490c336f9c2216902a4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__91d29ed9a7bf4b1c5cdf6dd5dc614d3bbdcbced5de667c7306874f2d23f04dc6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e3f92b1840cb3abe766a580ba4f8db16d5ee473b2ff8fa9f253e35cdcabcb5d3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ff07360c7ea0cc677435fdf725c45497f53ae79ce3ccd5d1d66341bcb1a937eb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3f61128b22e98b6f32f8c1a18cc243aacfc68c27ae3a482ff6d3254c019f54e1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e282ce2cac2dcec605a20f7457158b7b4f029c3c3106120e0f40442ab3f49ea3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dc80aa9803571faad0e66924b8fb191110052c74a44aedd2a75e3d0f616988aa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c71784df8adf48d7c375c58a8df471cfe9ea0b2ff8d5cab2f3cf43e0ad8a1b6c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6de43f660da241c21b985145b7ba53809fc1af197f05fd5fb39fd9b355143626(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ae0b30e712571ee55d239136e01eb4136a360415aec466d3a64c6b08c918aa1c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareGoop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6a027af00660d28d1eb306f88af8c1b9703435fd5f08156e248f9c935527a1bf(
    *,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__26d38a4f3cf4379cb69ec55ec6fc97484d04d254cd56ae89fa02336f1dabe1fe(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b14d46785db3019973db0d602c12c4874b996e29dcdfb731c3f9e50c6b49f44f(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b8b732b94a2d2a936cf20f43b042e88b6fb8ccaf43f42dbc7a6964b964331ac5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aede3d77aa182ab7fb7836d36f77feecfe46af43247fe159c79cedfcc3447b61(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fa33e4099f9b534cc7a209035c6598705a6244e85570986d10a154c96fffb90d(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b1793038863a4d6e70325d35e1ca5b590348b7957431cb290d9412a843b3845e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareGrayscale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__16047cc769c641858c4519b50a310a4975bca099a24884e4ec41c3cf01ea7abc(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b80622f835d70af549f4a3a94aff45a20f4372ac3ba050d9e576210fc162df87(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ed320682898898b1f4f79ee27194c397e8bba89a34b2ed3f8fece01b36b56a9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1ad70ab1bd48090b83b2854e8083c09c62d0b26dc3f845a9fd71f962b800eda1(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareGrayscale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ecca1af7aee48d6b892f098d43eecb9decc0c64e20bb5897e601e0a47af6207b(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness: typing.Optional[builtins.str] = None,
    lightness_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1c883790ce29bc118a318ad1c17b4117143dc0f2b8cfa7a6d4b36a3a5dd2d1b1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7b896d488846f5c6a5fca4d9093718791c0edfb52e3561caf82467995f352686(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab241ab20c6e1a893285760ffbb01b7253e2c47e35ba6ade09728d11da8a46d6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eafb8660f0da520faa0b64070253a695ef50398cfc7202ed12f86295d8c24493(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4eef250eb385010c7b8312c63839f6daaca19955a9d7eaef8af8e30342a7157f(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d6a9e315655defcf6238eba9961f5c35df7d697eea15850e29297b239a1b9714(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareHsl]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7e4e3b35e4a0f35f950e0452566a8ab7ad7dd16c563ad3e39742b6f421b4b15f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4f65002c374f279639a1db1a2ae39157bba2d50399ace9cc45a6e00311c259e9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__718b3752f672c2fcbd48864d5ba22da7087e38410911692a708cfa535a08c45b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e03df3ce9972298ac1134ccc0cf0182a20258a3d71b6751cb8b773aa132dd221(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__00b1c709076f0d3ab27ddfa5cc8bb3880bd22ee0c7568b57b2d2bea70bc8f594(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__431ea25587cab6f0bb328693296f1d3e5ba26c41b50b1a5c8b01f46d43ba6a4f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9527267476f42cc6f24d95e7fb4d95b121779d818cfcfaa9e61af2332d21bf44(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__43606e32264e411a86275f711e1586684737bdebc32b19bda0fa8a2a7980336e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareHsl]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ec18688ba63f0bc46690a8fab6763cd50124a7fcbfdcf3b7a76b7f1ec800af3d(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dddd846527cda253d16ac4176b7f561cd556b7fed2d01819029e6b325dd99d60(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__284b960160edd29e7e2b9ec44ba83aa97b61137945342dd3b06ae6a0d0f2a8fd(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f1625a49afc7910e34e30c1a87b538b4fd510678fa084f0870da8f70d4b38dc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__94c9ac831347481245198bf0b945f112db588c05d5ea2aa12aa5e6b7d75e5dc6(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3f0a24830fbe95201162a9303fe1307079f59226db9f81870175fea748a57d3e(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b97748febcb6f847e31073f45fc9eca6109ee6b71a95caa48bb6bf05afe3a0e0(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareHsv]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d062895c47e35cf343e63c40bd3585cda4a67b8861110c511b5f6d757ce4850d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__da132f69644552456bb4a355972ecc17c5bef561df7a9dad9382ba620ae3cfe7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ad50a32b427d4f13540d7e149afec7c3037f5ec76f4705126330bb24ac4b1cbc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d1e2243e03b7b4a860772e58f0f323bd76de9e3a794d4049e2c90a65b3208b8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6df36239b1cc1b45105c5ad815d7c4c001591e6a9dc89393e03eb025db3c14e8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2593894372ed56211fd637800212950034b15411e363f1881f114c994b8fb6f2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3aa033cd795f80061125b27d7c6ea9121fbbd813ab08307a7f30528e4dc65201(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__91c8d912d2dc13cb2f0cf5b622a04b59da45dd0b59cf6e9a6fe883dda6d4bd08(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareHsv]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5730163954aa6839b2cb4a08af89132258d173522d6cdb8e4f7b8f7d49a8fd43(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    dimension: typing.Optional[builtins.str] = None,
    dimension_var: typing.Optional[builtins.str] = None,
    equal: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionEqual, typing.Dict[builtins.str, typing.Any]]] = None,
    greater_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionGreaterThan, typing.Dict[builtins.str, typing.Any]]] = None,
    less_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionLessThan, typing.Dict[builtins.str, typing.Any]]] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df5670f4e5ea53e75510ba28a8ede500736ecbac2cedcfae0e14ea901bb91bce(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3b43355d1d85e1f5af3da4279655c25e52855848ffb5c9988417c0e4c16a38a5(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d0db53b95b248a5c2c5e21fc4fd64a4ad19e3168d386e92f6243e2fc5a3e65d3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f9d6eb6739769f45dd1c79d1d84a208117d3ec2a8e10ec5200250a9902d86550(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionEqual],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__75230855da63b3699cd0cf3eb62ba6fa38576853e3962c63c0c9b5d5446ba805(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd9f3d0fd536180c7b15d215b378a41d2fa640f70f0055df71bf91aa486745a7(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionGreaterThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3827fab5c7806e91631bb1a57210cbf8cda2cd9c306eaa7be7fd8242caa6dd7d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__475ae51100cd1035ecd7a80eaf55342b7c69556a4b49569c87d6ae3279fe0149(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfDimensionLessThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__09e4543bd635fc1bc485c253d1e0513b27370407c2749b946bdb58ce0b4ecb55(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ed3cabb419a85b77c9f9718c0c8c477f905edd9e8b49ca22aa03aa906e08efa(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c71a0c58255e96796dc3bae9f4ba4f3a6b41ace303ea875e37891faa41bb7a62(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__97f06d6f42571e66bbe23e9a1e93b87b191e270e4592644080551c70209fbdf6(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__14908e8ee6a51c8703b3e5cd4b3a2222fc2ef4b76a0a30eee0d81a1540168ecd(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e61c49d89a1080e800f6eea6a85ad8e71cd6f3dfa4e2190b82aa9e43c8491bf6(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfDimension]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__45d581b50fcc6acd9a2e5f3f5fe335c59103a60fcc2c7f96352d175ff574b6ba(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fd3b939a3f0c089f15f484051a021f99b2d5f364671fc1dd060bbd2d78bcb580(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a46df0698383ac60f9ef85a7c9e200df6ab9faeacb648da802c81fba9054eb0d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2fbbccecaee009b949e422853c0efa02d6795028cfed257c422328a613ee2a49(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3b6a1a814d3d26b518ff214e6d7a6aa4d6acfa0de9b3d103ebc23dd01a3fd995(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c1c1d56f0e734d0e06db6d59df6c7a9659dab2b650966dda35e72d76fc175185(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfDimension]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7187b17f0e225ba7a0198d0beaad7bbb2d0092a0c6144a9603f6f063e760afa3(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    landscape: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationLandscape, typing.Dict[builtins.str, typing.Any]]] = None,
    portrait: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationPortrait, typing.Dict[builtins.str, typing.Any]]] = None,
    square: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationSquare, typing.Dict[builtins.str, typing.Any]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7f0dddb2817d42261e2486d84b4934887bd0751f98e74ed767c8646e752602f2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__497e2d9711f9ddd7321ee01a9a4825169d2736f91d01c265baae04481b107cde(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4cb9f9bfe426cca3c5bdce6222b0d0630b1af18f9f1f2412f6aa5a22a96f3f21(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ba85a7eb9b329879a96bf4d1ed3b58d64d6eb1ab68611fc458a376788815523(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationLandscape],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__63e0758a8cdf03b9a09ce3efec5f0c1f3b06c1db66c13c5a8b8c7c382fb1af6d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__71bea8f600c6fe7a586058da632f4ec3d369f52b0baa3155316e4fd9a8460fa6(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d097b9c8450ec08a2959154c3ddc83afe9abd02cb127d249f99ddfdd18e2a3ce(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__978c4eb994aec2056eef8e3eecf55372313ffe5d370536d319ad2f815aef7153(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__037b3f46595f6e0164413902a44352c3715534896f9e6471f6d74428ca4183f6(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f6b1e42183b0a021ed547dd9dab47d6b1a4784e60cde1b8844c74b2c59ce0b5e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfOrientation]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4e4bee4a4635b1dd842a22b5e4f1e2c27e19415223e34d6be3443e36def3c212(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8c29c1c7bc30562dbef8994e7a27ae13a545b6cd539bc0508400c50000b43ea3(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfOrientation]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__171a277a3c4fa938c99627e3eb85a9d35b24e723072ec36c154b2aea50dceb7d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ca339176450a21e6bd0560c2a01c8c1698c6fb5e6a8b67efc6a7037029716b3(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationPortrait],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f778112b1b39a3ae7f1cba923a2863840ca308e1ae2fd0e648964073c9817f17(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ce38d3fd51e25f977d6328a38c5a207c4c4df0298d5c5684262f153fc2997502(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfOrientationSquare],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__94b0fdc429453e7a1bdc39767d9f4cabc528277c44658dd873f5c238a37d111b(
    *,
    colors: typing.Optional[builtins.str] = None,
    colors_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e50230bee952aea37539737bce8e6b1b1cedca43057850e378b14f7b67fff363(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3fe37e3053706855a1ed2351e9c2faf68f7d5036df5ac7d3177af8ce275e0981(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4f8db479ea053322a6d0e462d72ec0ca13b51851b3096ab69c042dd49212ddcf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2175690dd8f297f5ce03d98f71f514b1de08d1aec8e28d01c0664cd44e0ea1dd(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1e924dde3535b5f71064e8b8d49ba5e9744f24e53fbe0105b3908216409d24e0(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c0f519f2d2299009dac5b363d066351df6e3a7eda7a133592897f4da6c9be832(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareMaxColors]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7f2b7d253df37b40056fe555f832b629d74457507bb48e9a1f542b5c6ecfd2d7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__07fd119f9e3b84b2483b4da591d3e2839390406b59300a85b99dfba2533c20fc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__417638b289d0def5cdb527cde929c742bf3cbb78d41ac82790613b99249822aa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f367bf6b44dbefe9ec47cdf69ea41fd6a63c860f24535efa24f9ba04de0185c2(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareMaxColors]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e60bbac72407291d9ea9aa52d4b14ad2f7db7d11f68562c4026b2147f96931e9(
    *,
    horizontal: typing.Optional[builtins.str] = None,
    horizontal_var: typing.Optional[builtins.str] = None,
    vertical: typing.Optional[builtins.str] = None,
    vertical_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3e6b28e0209eccad94b9be61fe4f516b2ae1d344fd86a24547ff8d4654c00b11(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c5addb972d866a701110d3473d538ec01724e1843b8108cb0e65a78befa41431(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5223f90ca0dd658de2731abc6c1f3b53a3e64915289b73ef028da1e569eee03d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__629c2a0bd87e92a08803b8f82759c4f61b06921981852c80f43362913cd93ccd(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f060e1b8af7ad0dc2322c7e2756eb940ed944bca194cd28e10f9f867dec141f(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a4e03f1c88ba9d982b02e16996a5904c543c422ee3a07f3c7f54319c3076c75(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareMirror]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b98ee625d3634eb07c231cc1316d5c79d257ea5389ed9e25faa4d027735d2d9d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__46add8539138393eb1dfe9ecb89a31dcc27a9c6c44f28cdc91f7f707d561e843(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__424bb8f256e1ae8a43c9b4f4ee25f4d3570db2fe0d7c06a4cfbd48432156fcfc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ba5b3a5f1388c844b6c988cea6e7d2e1255c7eb264e1d7bc18c5d1fc0babb09f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dbb6b6ea54935f4429d29928bbdbca05758804d76985f77278873223d0fd1768(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2c06bc6dab4bc6740173439b2dfa20499946c731e1b64ab7983687e0d402d6f1(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareMirror]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__72f9fbd2f0dbbb345fceed052015f97011ea9d143ac998d561ac4f927421bbc4(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a5837d987145dc25b3e098cce730952e3e6bb42186e33a73122ae446378b8380(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e5b87acbd5e0171298e1f2c5e2a7a1e31652194ffc2dae4a53e160655b742d01(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d80037b7be37f5ce8c952f152282db81587577765249da89b65b7aad324c2a4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__adef71922d6b5e7f48271ae09910baa30a1e8f95e954f1c34ca467a0ae8bb4cc(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__db21fb1352981e35d690827833417bb8170b730b9db9f50912dc9d4e345978c1(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a7b904a8e6fb90d916c7eb0ae35ad2f7463b8a81037c5e6145b4c85bb27d4f73(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareMonoHue]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__74b956d070e3a0f0c48835b917028a6f6f645e5a26a9283d526f3157ad3cb7c8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6a1b274a91bc7449e7ade528f26609168996ea81a7067b6b80081204942f7dc9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fbe4938be42812a1bb0465ea73a1a41f652fca2506ea67e3a225a2007857d3d7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4921dd5632d52493c47518b5c83b6ba8cdd2a09e1d501fbb7d732803d5726b26(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareMonoHue]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab0001175da794fb7a74727158a2586c0578d997639a54f37c9096388151936f(
    *,
    opacity: typing.Optional[builtins.str] = None,
    opacity_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0d08fb91ea7721de077c743bab7948481ff8c4ccc0a832db39cd7edb60ba19b8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ccd239b60165d4cdf66b47b22b0edbed66189804d195dc95fd3175332624020c(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__53d29c929cea51065cd68f64e15be9377046a8adca9d9f2f92b57a38a3fa6480(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__45fdb02a5c20a20c3134490379d5425fdfba5c7c6559a3a5903e84dc44a577e8(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f17a1e7551d07f1b3a97512f676905b62f8224b0efc208ad35767f4eba3930b(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b3f9d1a97733ac41503bf6727ab71d205b80e655d18bf0c46b6633133503f6b0(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareOpacity]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b13e9966a2042165d4b01d3360dbddba7e9196d9e8710dbe6e8a89a1b7b0ffae(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b147309f96194e3a25a2eb56ac95c5d48aed76a67e9d498ab8802ff1c0ac6367(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__91ebb0b67bb238f0ffb8865bd4bdb40128c77b8189bda64cdcbb0c4055455bd8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a8da61907846045802f434fd7845fa2b28f325f8f82a9795a75b79134ad2991(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareOpacity]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b66a9e865ef44ad18c7bff5d3a9a390b0693ba2bdd8cc259e6c5296b33034505(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3c02c05fa5cad5d2df4203046557306912096b37adf1b9cd6a59df97103b62e1(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b0d32ae843247c1103409a59b57dbbcb6f473d82c0a09d797b64442a79ad219e(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareBlur, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9da8bfa4b946ffc5a62b8c3bcc898cae0ef792cdd989acf8f46f2ddb743f50a3(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareChromaKey, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d612e75cb84b7bdee26f6790b5dcd4832d2de058a45abfa4793060b44419f37a(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareComposite, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fe7e56c024c07f286664a9ae260cb855b67b68290fd2fd39c4d913a8924f8026(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareCompound, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6cb81b5bf3445a9340e4cdc8aeb9001009e73450894b470ca1183bd700113306(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareContrast, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6d6b56cf2465ca7f2eda17c4cfc8c990b40e4ddf226f6fad84b7d19fa46b6ff3(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareGoop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fb1ec26adf6cfd76d732e312f71a9da80fb2c2c29cb951ce16a2188823349008(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareGrayscale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4696d94631406a40acfab81c36aee5e6e5801b16accdf0e4ce388321867b4a55(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareHsl, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__37b49ad3aed81aa6c3c5498c0c9c663304438cae1393099f9a3c6be6946e1103(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareHsv, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5439fa2ad75e245a924c646d8cd44f1f3bd3f7ac582a93adad44c4cfa84e7be1(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfDimension, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5b12862b48858a6e4ec659ca3b3947cadbed5c759f0eea8aa315152d2cd143ff(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0e3c240ca910c7a61febe6845c460fc883deb348eabb3f1632df0853fb4f1b3a(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareMaxColors, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__47ab7e49177b2e0bc66e6233a4a03284093e51bf6520e1eed30a457dd56c3f6c(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareMirror, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fb4d1ad8cc6c8e2b318113a29a713044a7e8481805e0dd31f031c5f41a89900c(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareMonoHue, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__756938609eca7655f23cb55a142290a5453edaf93c36155b3091ff8f639248cb(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareOpacity, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a3b7d3b9f02da8876c440589fcc94004dbc58e1adb9b7d391825b7c0706da8d1(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareRemoveColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__edddfa846d641cde0c384f9573145421eeba69c4477949144581d914f3737d82(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareUnsharpMask, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__48bbd2cd5949d6252967f40a8843d4f9db01b42e6493d01282d1e018166db3b9(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquare],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eff945ce062a897cdd61659747ae4a9915fbaf2dcb777a79627d1ca83411e19b(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
    feather: typing.Optional[builtins.str] = None,
    feather_var: typing.Optional[builtins.str] = None,
    tolerance: typing.Optional[builtins.str] = None,
    tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d7737e0b73aa49facfbcc9e402fb6ddcff516b6b220894927f2eb67da9dda0c4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__22e99c337c174a59137ae1471aa7ccebe2c396dee22c2d198a949d7524aaa936(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dd35a1fa90289fa3c7b52fc7d06ec3efbeca4a5dda88099a3389432382a2aba3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f0b11ed356256dd8b326a201827afe2d858f15e9146950fac28785ef7370a5c(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4d1267cc18fea63e9de195c7c998bcdbbc50674022e58957e2951d7735484e73(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4d15f0639e538a8187437cb36b84e048df02e9e2473d4445bf84164992f2108e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareRemoveColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__70bf8a030d69b0ebe163fd875476d5fc4afc118d746f2a068696c35f5cf3b86c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__34fcf6950fd5cea87e6685ca7c513c193166012bdbe4d9c327ca865342337c89(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1fc7be2cae5d995e903c164fa67fa611a7fd3f1eacfedf36db1e87b69661a61b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__69b2dc5b2c194bb98416375045472eee7703706a00e54dc882fc3840466b69c2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4e862ccc2dd035d081871cffd232a758b30d59b5def49f7f36024c0a8ffacbc8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fe7b6645c7e2654585076449116979955b71f65b26a5a0942a277baacf5a5fcf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b4ec1dfdf2f4da7d85175d3d3580113a1f7891dbdc9eab1f83c85bc8e9ac151d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cc2efe3e5cf2c785b3e46eee397a3342401652e49dcf0e8640b653aba9514535(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareRemoveColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c4c3587847a4870b7846081c0349e66c64d67141cbf86d44c495e4074e17e634(
    *,
    gain: typing.Optional[builtins.str] = None,
    gain_var: typing.Optional[builtins.str] = None,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
    threshold: typing.Optional[builtins.str] = None,
    threshold_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5e511b6e90bb70095a588be1302c4bed8452d958aa4ad223d876f3014a08095f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b18987b9a59e5de26840ff7afa92f942867962fa0bc44e9f4c902bb5807c3a75(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f5b49aed546fd3b11bd84fe7530a911aa103286f724d17004b35bc41a8c7d64d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a55eac6db8d4d5d709677c25883cc6632f89459a9541348428fab0e9b27b774e(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a1399453338adc7ae2d2c5cb2f9e58f49bcd3e533a0d3319fe470322c7bf9efb(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__17cdd6e9ae623f5d3ab5047374bbb38ee5546d00d306d1c0d65bea1b98014b30(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareUnsharpMask]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__355768cb1e1da4955fff79807aed8737d0bc078107aa74091f75f3b3545b5018(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__83dac015064f4319f178438b23f3c97360084adef230eefa8ab07e3d7c51dd9e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c3816457ce43311ce97bb4c143ae57258327b6e68422c2d863dc6e63dad9d1d5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2570fc41319dd18a780a3c2be57887d1c110ce76c7cd32d07641696967e78b14(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ee05f810b7e25f87606191771956dfa148520859381e81b6cbd88a14f193131(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b68266c61e20056c4d6eb4bac1fadec1aa6c6acefe601eb8b173815044f49599(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__13cb8458fa73bb4e825a7a84d4033ab73a6e3b112bce4078e27694e2f6351f81(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df7199fdc86dc82e42fd1c152d9dbd3f5e0e02b4d16ec78dcfa8f850da5783e1(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientationSquareUnsharpMask]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dde1b85731750c31f4e9e8ae0890343171ac8ccb0d4a002f0302cb462bbdec28(
    *,
    colors: typing.Optional[builtins.str] = None,
    colors_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b30d99b022f55082d559e9d07e073b58d1fa18b34dbddd79a7d1bce49670174e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__34fa87bae198866ff1b5594601fc7dce8819e9c4bc1e1095fd8818e21ed03f75(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e6cb73606631e207efaba4ffb51ae5b311bb45ce9d23c1b725983aea2c4345de(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fd315125324de66b24f6f493293d52cf94d28a41fe449e30686c0f4d06b5030b(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__097b7575c03d380cde09e79dd968c02b8b1f949999b8ce26b35039758d1c4fda(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d800b5986616d3188a74301a9bf7dbb1249bd2203ffa30259f0ac5e775aa6e99(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultMaxColors]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__307393d2947a226f6555e231703ebe1f4731e1968e3d79c1b2afd05a22a947c2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e80646d96eb292bfc34dd763ac59ef69e1ce22f47e922992bcad058c38af5c02(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__52a3705b7669b5b58057740ee4ee7d3e9d7c8824c9e81df697750bb896a3c0ad(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f818806f3a101e18ed6580d0c1e0ad50c19f27d8c89c62c47c93b5e764712a1d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultMaxColors]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__46abeb0709519e9643d1bc55d057daa8e36cc34f9f91a3846fcd46c7f4e8d1da(
    *,
    horizontal: typing.Optional[builtins.str] = None,
    horizontal_var: typing.Optional[builtins.str] = None,
    vertical: typing.Optional[builtins.str] = None,
    vertical_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb45369942267749cd24bd74fb637b2b2ea5d96d9df9352a23408f9a4e61a9f9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__86d4ebdd589278fad665badc1a9089720f414358a446548c1de0d11b422fde29(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ee0e301a163dee66bb472771d3c01a6ea57e384870025008f320d6814dff954a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e6c5697d0e5c34748a038cbc354a7bcb4f1fcdee42df41c40794c410743e48f1(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__86873f5561c60630d6279558f9e71a4ae0557856933cd37b642359a0ff3dc435(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c45015927b13149d7c8a2d954fe6c4a75e32ed012dfde966f4746854a353d82f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultMirror]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__872355dc62ded1f56882983d12c3a4b94e91493eac2d1cf1040cec14350497c5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__24acb7995ba77eef7494b66c77e4f07ee34a4ec7f410936d6fa25b847f43282a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5a38b748436673446d26fc94af3d83f2915192b7833b9e1045b56fd8c8e8b2bf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__15c2906a745a727ba0300d24bc2f0cfa6259a4f06c43490ddfa12e3aec927675(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f65c6f8878288c6964f5f06dcc4cb6347af2ec09197251d81f0b0dd9313eba11(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1737bcfa0ca55ec70d8936ad44088f7fc76b6f83ce237f0021b48c8484236cc1(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultMirror]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__564d68ccdf4bfcce6dfce31a39ee8c0008f12deae28402a75014e9efd4c9a737(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0aacc19709f080302eaabc742c0555d7b7d73189ff316e1c246c2c78f459a88d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aaef1aeb51012997ffc5a0c6699f61f163998c7287b7f7ebe82f3a54500aa616(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fa1d6483834dbc698224e7e6b30f3287984bca8a85d1f88f99be447d5c098ad1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__498bdfea4eec4faa2b2d57f82adf370e848f4984350e2915c9a81c3c91671bc7(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__29beb5cbd17923041ffdc94544f4f3c5f95e6608a96327ec967253d0c4486aa8(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9c729d83b5fd80123f92b1b7ba34c1f05d4d355ce5ef7b14e24e45b63b2aa77d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultMonoHue]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__050b568025528041f6a25fae9ed6d06f8a4fe4669f154a1bb4b017f7457d4fb0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cc4ff00c115682e9211695c84ea6af7305ee0c49717e010af019287e37c71a6a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a8dad2b05f8f13ca1184699cf63009879cb5f760157263c822f23a1a4106c0bd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__105257bb8e3fb464d4397259d1105e8403eb97c697bef354fb420b8214c7dc44(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultMonoHue]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__52dc232a6ba4184692a173f8736b4679afe04f249048303d4744e2028d2631a9(
    *,
    opacity: typing.Optional[builtins.str] = None,
    opacity_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1fa7bb0c49abe715d905187fce1f10a2a25763874c385317c8f69dd71939200e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__67a7afc8c65a9172718793c6469c70159e13f0ead10162e4dc75bd07ffd63b20(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2902f6d04e5c21e1f00d2b120e1297743b54c0763418729c7a427dc701f67452(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cddb846028233002c6a955128387f5ace29253d25e705ac349dadae4334855f5(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4986b3be08dbedde82f0aac12b99bb12981ebeeae86d950f27d6b4ba0c0bd53b(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__10a9b37a75146937e819778b26a5fc5772ddc72df5290d0630f26d7a47490e14(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultOpacity]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5783703d5bcd2946ae9d0d1a71d358cc4df457fd0cdd5e7a026c4fd593b06fdb(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ba01d6c6cf82ce4c1309c22dbda470b2e7a89bd37935be3becad0315522cd191(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd271581e7c416b033b178d2b05885da9f004d97f91f79115595b32c9400a201(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f596c1d55222716580079149f20e806acdd2e35f17a599ead8611a470e210fdb(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultOpacity]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5dee1e440418166c2e74781579a77b15310c513a25e0066d0907915e5b514a78(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e9e81794fd9cec050ecdf431fa01f8b9b3aa3db2b8857d1e992db3dbcbb0a982(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__306cc155b3bb8ada8d5f3efa44a3a0d5a8f80909702c6fcdc41de87168e337d3(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultBlur, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__65fcc06d542a52c29572d7edd3fc4755728ae20f5ed3cde8c0bb1957de7e4099(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultChromaKey, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f28b4d78ad9016c598e72d9a3b6d7783be7f3c60d2e45b81c4d2b30d84cf2b31(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultComposite, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8b38c223d3d5c645fae6c371a42750e8e26732083c3e163a145a4f2f6e99c8b7(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultCompound, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6ead590d6a37127ef4abb5b1fff06108e5894bff7102615dc5b41ff8030fb2ed(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultContrast, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cdc9e5727426f580ac02535b168b2e65ff901caeedee13296c5b8a4688729439(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultGoop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7e6da450daf60cd0233ae3a8f014ce09138ddb4349f8eeb59b6a1827663645d4(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultGrayscale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d545abf97b4b70751c90fcc6e08f2e1098f82b02dc2598c892740071540fb05f(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultHsl, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a308329c4876c03157e78773cb46acda0dc7ffef18688e4d94c67b69cdbd508a(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultHsv, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__470849b8ab0db031f5a02909b50f81a82ec99bbe8cc9407c9fb1a50f50209920(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimension, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__135cb9e6dbe477e771f65c1e529b83051838958ae1dedefbfea427636738f4f7(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8b8441ab2bb383d02d8f5c58bc456b632cc9ce789c10b3c62cdd3db813d4f462(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultMaxColors, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1dfdf2d755df75087ac8659929536cae3fa1d2ab83dfe8208deefce32087bfb7(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultMirror, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__20094dda3ef8da450bff3679c5e6482dd5d5aba2209618fec7947e1acc8a4605(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultMonoHue, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__54c9c202a280e1040177a9de7fe1b10f285d0a2ae543edb6ba98ce25d6e76c79(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultOpacity, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e568c2d70f4ebb8a3ba5eff685cb5e6793eed48e286853a0c0763d62229a920d(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultRemoveColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b515d77f5fe98a6890fb182dd90fd1a0ad744763aead456bb42ec44f4e0ee82d(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultUnsharpMask, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f84c49f881b7ad733b6ec34e9e6ee943c9f7b6122c56d361983f5c8a4bd5b500(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__db0d9618b4e5a4524b4d4d074705d12e57c1caa19560a404ddd28e9d43a2b2a0(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
    feather: typing.Optional[builtins.str] = None,
    feather_var: typing.Optional[builtins.str] = None,
    tolerance: typing.Optional[builtins.str] = None,
    tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5a10d30e3ed448eb3ac71f7686689eb10b48202ecc9027dffdc4a02256b7a01e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e0621176bc8ff8347c26c72480290b54fcc725b8ffa9efc14c8f93c03a60b51b(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__40c2b5d46cec8ea41755ce7510afbaa5873190200f0ceead2b98e8a6254f59ab(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__29f54723362fd389d9aab4c4340c96b62d1cebcf68efdfae98a7db9973c83b22(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4bc8c9883a02d9d9f74cfe4a4a0c553afe5d347649a8b40c0b87c62b19a96dba(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__97d7614ea854c413fc80459914198accddcaa99d49de55d7b3f29f0c179bf211(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultRemoveColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d9d773d6995da8ecd43973fc9bcdf88c4f3815bd6c17dacb635f1b626cdc3e27(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d8abaf0f8b66d1c3907399e023ba1b7772db4d2f5fc55438ef9e3e4bf47b4490(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b84350667535bdb78c713cd729b81ca24b9f775bd0beec72944813cb6e05b29b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__69f0f18d7aff85d4d1789305f53ed5ff5285409937aa4aad01c196f48c59a2a6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1c653786d2d26b2ced5305b431392d0d73a23200254ed59ffa39a1e94adfaa43(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e184f64978695d3defd087c36d110f109094e56b55f8283129314e6dd22bb554(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7b2c627228fe26686e2e00d9ca6aaeb6550b788a30d0242fd11c8ec2f674e326(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6166ec397c291be374b352682079569dbfb06b07bd62a67df19f4c26afaaf1f0(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultRemoveColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3c413e98f45836a8ae3e7a14a53f9b360c10cf258828040c767426be770aa646(
    *,
    gain: typing.Optional[builtins.str] = None,
    gain_var: typing.Optional[builtins.str] = None,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
    threshold: typing.Optional[builtins.str] = None,
    threshold_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4921fbe4d1f81f95f731747dc54ae382d39897fbdf13d09ac7c2c5fd53af54f1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4122ed0f00f4a89bf9e2f67a269eeec1f8e6114e3089b26401641c5b832a20aa(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f34e122767164122173e3d30757d206269c1a98bdc5b39e2f317cf23e65e63c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4db22232857ab8532e7d98d9dd485adcf71e59d55b35677748a7b616275be63f(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ca20a36258b87d66c296061cb8ca625bce0ecd70ccc80a3ee27e5321b4a5f9e8(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__11bf1d5a833d159391629086e7ba72dd581dd3fabdf067830450ecc357963ed9(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultUnsharpMask]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e31c511a96d1c1451f4da5029c03bbd28694fa7406b7d168acaeb4fdad63e59(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bae727892d690f2653a1a25b4ca6dbeec9080c62cf070822480a91c5e6f49a79(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f54b8f0285cd9f71c937f3f62d09e34332f2f5f4ec94a71fcec92b94e35719e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__75e06a763cdde3f699219490c862f54518f2974cc3e6678415f8c20d5f1f9b2e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__21a05813c90d0443278dda1e94d73217af707576fa903de36b926b257d79b512(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__693fd14853bf26ee6658e7bbd03fa53ec9338e85063ecef3ad0a55a2a83c4a4e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__982ffb50d62e0a764f8255f21f27701d707e1beb43508eeb219fa6c93fb6d463(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c220e101ce7da19151b35003f7b18d4c2b12ff6074135d99ed2e9778601d5568(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionDefaultUnsharpMask]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__145697a9a907979a87dd81bc6b9cc2fb29887664bf9153641de47d845933103a(
    *,
    background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
    chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
    composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
    compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
    contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
    goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
    max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
    opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
    remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cba85f5eea881057cd452435c8e246739639edd734f8be355cb1eff76ad3fb41(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e3d7f15824de2063e224f16a760cdd6e749bf03e6cce561bdc25734733228d6a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7898124b2e7404512a4b11b90890b6d48925cf7e5cb65f3182123ff1a178567b(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__75bd644a21051347a0b36894da0c481f5d6adeb7e274655c18c51d56639269e9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5eb6d30fdf423fa23abe008e91260538e73d77c2ede16ebbc12bc8d7e4cf7e37(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea6a2dc11387006b94995e47c92a8c3c81870afeca0ac04cfb54277f9c17b771(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc5d223e6cf9bffc52675d5ab7a80c7a6b71388a25e0794ea6839c265d9c6874(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualBackgroundColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ceee0c6f531d12fde5962896bf6825d215e863ddc59975960cc08978a0d701e2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2dc9861c86b2a4711df2f44d420b48175f8e12092571582521059fdc4b42a5dd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d52d5845f6cfd90274435c5069f38e17d60e92953a9605ccc59b5d91db005a95(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4f77dc682c9b721887a6597f2906ebe51b5f7c25fbb6334ee3ea435c43c578bf(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualBackgroundColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__49fcce9b764083daaee613c0c3ad9cbdd3f383b0e2b40db775c1224a655f6451(
    *,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f8b44566a85ad34635e52606014872cb170fff0851f13c11b7500e32e6212877(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e28332a2cf2eb9074299e254db5bbfce4d99f9980f0e12eaa22100899357fde5(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f380f792cd3b148353cfd6f4a38e664ce2e854f61df0402a58de99d1f4b5cdf5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1a7679f12e2f7c49ee5ed9e70cc260eb206607f5898b6285dc0d4fbf90a9bfda(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cb681984de922bf7b0e14ecbe038ecef54c3134352fe7eea1c6c46e1b7251004(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d09a6544d3edd60fef4ba029cf8a5d8613cca9d6d0ee185051f69d3e81dfd4a0(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualBlur]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a9edce24e48779d4f211b195fa92afd8164bd18e1ca0090846f5898ec8ec71d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cba8a6afbb90df92858ca61b861b4d44951af1f9b8ab9e9eaf44033ff07cc0dc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0bed96d3786d292d4f48b000df92fe2b8f18503f64c8832be10f91b372002d52(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0a23de960902a88c909ea2a3df31e9adb987efa9ae1a7134dc77b0a51886402f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualBlur]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__10ccb3adf9f2bc583ba26b91f589283ee453e57d63c7bbe6e52636e690e9afec(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_feather: typing.Optional[builtins.str] = None,
    hue_feather_var: typing.Optional[builtins.str] = None,
    hue_tolerance: typing.Optional[builtins.str] = None,
    hue_tolerance_var: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness_feather: typing.Optional[builtins.str] = None,
    lightness_feather_var: typing.Optional[builtins.str] = None,
    lightness_tolerance: typing.Optional[builtins.str] = None,
    lightness_tolerance_var: typing.Optional[builtins.str] = None,
    saturation_feather: typing.Optional[builtins.str] = None,
    saturation_feather_var: typing.Optional[builtins.str] = None,
    saturation_tolerance: typing.Optional[builtins.str] = None,
    saturation_tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5287aa82438baed16552bbb1f7feab7697881979df1eed7ac2444a9efa91385b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7cb7e33eb202aba42b6892ab70bfc8a1c7612c0efbb68802e78c4183e6c14fab(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__63b6672fb35ba7f9ee587f91665da3ba6c678639b702b8a261899e08eafb5901(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__605df6aee3e22a38c2283120a7ce08fbb8fa7a3249ae7ab2d213924bc23b2f2e(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f4fd24030441d684fe67a179d04594acfe11fa3108a7dcc5bfefc1229c5bb4f(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f8b081df84e7ccf9e9c3eb2abd6992691a03101c5b7a4f39c7b61931fdc744a4(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualChromaKey]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5372f2c0f8a11bc9ba533ca323923a07341f1d7ec6d3e1da441194c48f76b562(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6d7205fbc4ff0a847575cdfbe50d374275a1603921b68a400baf643e92115e1b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3915dd96303ad469db7b0d1485d1e0634b1df322650bd4ba66721a1d1a6baf31(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cf3b8ccb415d6de2384e7764026b565e03a5eb11866d86b68bbad25fff27bf16(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f1a0caa1fc236d44165069f98511952e0bcf1a6a5b660b9cbfd3ee090a85a909(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a5cc0196da21dd8e17b17a9f91cb1d9089dba2e797a6d3f2f406f64e5b098e7b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c449a5b11e23b5027cd7fdfa23ec19ae9cf12f48a39c3c0e6a4686827628bd11(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d371c5ea66465821f2531afb9d7577c1a4dfba7f3ca7308415b94df268717115(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__68fe010982faaef262cd07a11f2591a3e2c0ecf780949a1f1969ef923e4954e8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__86d5845b7a5670a98ee869ff40d665966b27be581bc0a7e004bd0cb492ec65c7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6494935cb5c457857f933142a3d9de7dfb8a2a34fc5025ca20713ec0d6861e8a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__73a8d9476412b46a11ee67a6de126e9ad63188c4939ae0fd7d7a5cdf53a1abf9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__37035941145893b2c7edd8fcc817e6d0023ff64dd254ad9740e013a632766a61(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a537c99bbf2a9f874757d677a8ab644aeb06a4396672a42b48b1a3d7942ebbea(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ba7b3aae3d2bcc31054ffb87b33aa0bfa73fb5cbb6c7284e8562acd2b509963(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__15a0c129d6449567f8ad7f7d68522fce0a758f467fa9b897ef7305fad629f849(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualChromaKey]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b7a575d215ff786660e29797da21daa822482a3bece7cb293db0d04568402ccf(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    placement: typing.Optional[builtins.str] = None,
    placement_var: typing.Optional[builtins.str] = None,
    scale: typing.Optional[builtins.str] = None,
    scale_dimension: typing.Optional[builtins.str] = None,
    scale_dimension_var: typing.Optional[builtins.str] = None,
    scale_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e1806bb724f34c89d45e0387ba2f0536a9efdceac7a6eed9eddd927041177115(
    *,
    box_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageBoxImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
    circle_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageCircleImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
    text_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageTextImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
    url_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageUrlImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3798c662d36da4700077173efcec1380264cb54fd89bf789abe01f1499b4be48(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    transformation: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageBoxImageTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__06cc2846c606705e98f3d3674ce2213994025152d82c1549a555002fcd0075a4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__250ad6ddc199a915576a6796cc4b51c32277cf81ba2918a811f83926fe13e9b8(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__02602b5f157cdf2e69ea58edf4f450fbd709f514b8fefcb68d9fc16a1fef843f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7426835ccb8c6dbe2de55fb79fa9b27ae80c99ba583955f3f1dfcac7fe03fd65(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f10c0effda2794469fe01a93e1884c1c9eb54bd8a82dbb75644a3a912444654b(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8445178aa920acd9373cf3c59a04995b3844f881ba674fdce2479aa403dad1c2(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageBoxImage]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ed09c7fbbc63eaa7168ac9b1777ac3db62e338fc4ba7086c12762d0fb32bf21c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__26b62edc1706831d4970f3dc5f8c81468b59211e463d729ee5f4a663c217bfb5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a60e0d5bcd03e8a81ec7f78fa4bbb13b98e126e944bf5133220ef6465b8df24d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0de76100def62f83ab53a517a90c18772df280ff3f8c0b8e394f6675e64fc2cd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__566d5237b7e5e88c478fd424cb8a8c4b00cdc78afa3898d4dd90a20fd7bc5f5d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b25fc3f54a5a592b178f8ec2ecddfd6c739cc9a9b6ffff4e80e627aa75d3625a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__28cb5c0f064f873f9266e1d9e4d4671200eb2e11cda442eac32b39d2b4f50f97(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6d5e6d1f101f680c651f9bec3b42fc7fbdffd7e5f270cba8382bd414d3342da8(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageBoxImage]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__50d63a22ce81d2110288c245ced74af574f6b638b5f574a0c2a4ae64495eaed8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f7c7a5304689b70ad32797f1bc5bcd108505fb66b955f23a7d8564c3177496c7(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageBoxImageTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3be9ea4904ab4572243dcf0ad99a9719a29fcbe7fdb7717a113df097bb886df7(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
    diameter: typing.Optional[builtins.str] = None,
    diameter_var: typing.Optional[builtins.str] = None,
    transformation: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageCircleImageTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fa6ec643bd93f4d3859871f06482ab27fe9da3051c719d27f52df5de8d65c829(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__24bf8138dc04a9a38c0fa9703c836d56b98a29434fea814bc3ceff07a7be3d79(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0b8a6ec8fe5ec1babcb2aaf64818464fea383206db2ec7e057bd4c79ba45a37c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f9f3318a4662e9f3d4efc817c3c727b3e0354c3c916e3ab3b6561f521cee431c(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8325d7bc6f7663fe8c4d12dd12197f4c5d83796cac869cc0f8b3cdbb09d7e1b5(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__48d3416c76b4ef40a78675e0b76b369cb34af79bdc2fe4bea2b4eef2f2076c5a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageCircleImage]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ae513458a0682ccfb019b70d675c31bba1fc9c7bfd3e54bc0b7bc9c5758dd0f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a5251efbfcb6508deccef34fce113817f2bae2344c99260f3fc47a8b92ff417(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__24c683f4f4d34a86d1031e112f179ae507e720a4f09df965ee927405c86fc5ee(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__80544c56365d79d569de507c89240f105c5bbb73a43db47eca11fc6812c39d4f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dea13930ed06db0f39fcf8be14d7301046b46909a84e14ddb8a54286d8790d2a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f30f6d62b5ea42c46835a9a2b89aeb2ae05bc52d4f24d50756c9c9976ffd1f3d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e6012e33c73ed05057d15a9326c941bfe335d936c086ecf493bf25f636789ff4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9875670729ad10e24810413e4b424bc6852b140c35bb456e8f61bf7c48c62ee3(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageCircleImage]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a46cf4da1742afc0221384de7e630e30e4dabbb69642a0ac0c0e08a1f705064c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b2f80cd433d428d4fb9e921bd171b248533ca09e1512f94beb367780a841bf9b(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageCircleImageTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__60d45d89df12c43617e058e450e840f77e0e5f12907ab3930f131cfe9af33717(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__071fa9c15524b31b056e199bd8a5fb8c2ac949ef0777de3b264066c0d5bf102a(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageBoxImage, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__36db84b6dd6cb09b38b87a178b601a53589a59da9934fb40ab5c16e01ebc632b(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageCircleImage, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b7c8b16540f04a02a0137d6a37d385ccd12fbad7fb6084b23036c44826da0f63(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageTextImage, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c1bbacb71ee20dae1ed0b8b4f3fb401631ac67ad43e96d351345c6d28c1986d7(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageUrlImage, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f2f62d78529b22fb5d413722f94c909b8d9480535088f6ca4738dd5e4ec9d91e(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f01ca37a5a22041b8ef2d791503498d1245c903f9d315892af719c662e9c3463(
    *,
    fill: typing.Optional[builtins.str] = None,
    fill_var: typing.Optional[builtins.str] = None,
    size: typing.Optional[builtins.str] = None,
    size_var: typing.Optional[builtins.str] = None,
    stroke: typing.Optional[builtins.str] = None,
    stroke_size: typing.Optional[builtins.str] = None,
    stroke_size_var: typing.Optional[builtins.str] = None,
    stroke_var: typing.Optional[builtins.str] = None,
    text: typing.Optional[builtins.str] = None,
    text_var: typing.Optional[builtins.str] = None,
    transformation: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageTextImageTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    typeface: typing.Optional[builtins.str] = None,
    typeface_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c80fdd72f8bf664c41f55ad90a6112b044245485bd7567b151ae414892336d23(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9f672ded4bae51ac6b867159bd4431e4e10beae770bcceb7a397105c6712bd4c(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a66a69c553e09e00422cbe9ddb6556936afa811b408cd2f6edce504ef8880ba7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__504a87915aaff0744ad614425ed3b34e6c27b01cb2e52229a480b0ea6a60b7dd(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8b4ec16d71fab8dd7c22ca7417d5336bbab6748f5795de6614a1aac38469afe0(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__15cf6e7ad33d6f8a9838cfca2344215a70e1a713b5526fc991fbd90ec117c8cc(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageTextImage]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab5af7f9771d14517a878feb6675b8678f4b944f14f112c92d0a15fc08fa0659(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b46d57fcf0c9a7c134d93e4790d0b9bf60216f8ab349baeedc18737e0137c439(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__029c9c899b939b6ecb4bc316aea316500a8c4f150fd0161e91f62136fe8acabe(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2af57b0141d0731bc08ea7614492c8e9b125fb6310f36253c5e34239f0fafc8d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4e1cd4e31590ca827ef88199f15cba2599a84972070f575d245686b4717ca9dc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cad3803673576b79f3fc95d15641674108d61149a17d184010f7ea3fcf406bf8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c54759dd52c756727b28e0595a440311bfe74a97e880b566de977683981ddc88(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2266dd90a062c4af44075cd6786b57d0a4b7df98b6593c3023f7a3f680b631f5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4e578148830fed57ceaff61b45bd3f1ba30eff64ad8e332f0e4dc64b724ca726(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4c9be7e91098e603584aa7600d79a35554c4ba28ee72656034fcda42927a998c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__557b289359aa84b1323f0a8ee729ac852d13c45980433c743a0cfc2ccdeb7a6a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__62d016b40bde964bd96bc77ed5c8959d010fd2792afea54892eaab6ca3370074(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__12afa1583d103f2b1a4316000a63614ed57ca76c0b41b50442e016099601f5fa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ebcbde6640fe56324538fa99d3f8b0ac2f7c8856fbfdee1f08e95986c28e4220(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageTextImage]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__235c527739b21efd868714130809e8ff2baf557a085daad38e398860f8c2ac45(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4f27e71f87826cc923ea18e81aa47b3b1fb96be112f0657651712cbf77a8abbd(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageTextImageTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a9769978930beeedbf67007aef43aa4153ca3e8b04abd518c594ce61a5183756(
    *,
    transformation: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageUrlImageTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    url: typing.Optional[builtins.str] = None,
    url_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f83307111528300b987e6ebd8ca3a0f2c53c030564816fc8385d544a07449534(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9b8fcf0cb50ca2bffdec6676f5d84e22e7e7791ee440ffe496dd27f1380035d1(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1b76004b5d88c26b87c9eb0144f12f0e1cc4bf29240eeef3b598923e5dce0040(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aa2c18f7248fce7d2eaa8213abfb629b3087ecb40fad5df824d126c6c8e0e104(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__170066cf96d1d67b37adb80bd2740781c3028d7285e6be3f2529ac045b8dde49(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b262765be3a213b0d57da83d3ba2b9af5351bf2c151b74a6181eb4660c94ac08(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageUrlImage]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__75efe32452bdb651d15a6f2c9554f6991ec67425475ce1cdc94a153f6ff77054(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8bc6a558dda757a7b63c296c0813befa7c1394c37d65fbd09e37380fb0d03bf7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__06de89ebc466e6b83cdd3662822973b33e563424f875ecabc47df97cd478a71f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7098ba7f09e5ecdb04ceba449eb4bad75cc3391e10c1817c0b89ae13af97eeca(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageUrlImage]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0e53dcca1e71e0c6c4ef6af10c375ccc88e7fd60d919e1860174e68bd05109ee(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b4bd9a5b83d738868f4aa259c3e1483fa4fb180b02c1c55da05b6a14cf2989dd(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompositeImageUrlImageTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__109e3bf4530653fd3675aa3e3084f6921d47cc3cdf7deb7a1f2008234f9a4023(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9791fb08416c8a4921ba652a3a248e7b48d85f7151e0033d40b0d83497c80163(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f9bccea7418d5c8ef34e7ca79cf52b755abc0702eea42dfdc6f144134dd24ead(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__093fdb26ca553279f2eec5f9cf5f1a04fdbee473f49508e6622f6d8686539c95(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b592bb600adb77293687a628c8e41e2b365e4bee62bb1c30428e575395312fcf(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f34cd5eda130ca33a7bc2ef9ca656895fe41693bc7595f26898eb2f47452df60(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualComposite]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__79cc26cd94e73ba508fdd507a060413bde73f6adcfd5607ea4b3e6f5b410e9ea(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0533521b6ea2491b48731fd2ab693431e6389d13222f3a35c32c4c6ba49fa993(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5a72c4669c3e78e58bb96eb84043b678d88f8c3832cd427c6e276dc52357818e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__96bb21a5fc1ed065faf545f02b7146d084d3478e59e812674713ab886f90db56(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__575a0558dfc64b29f1a3ad33fea5816db25536e2ddd75e348f8b6fffcc155aff(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d1b18e868bb5279b4c6d26f0a0e0f6ccaf91ccc7238848f91af4fe9c3b063dd7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ef8c6419d89cbbb6fab9de1c4fa7a55a897c08969ecc70b08e635049613398e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c1f4488fb6e59e780c380dd3931e9ca0c631075584b894c86780125ec7676dbc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__675248d285b1343160ea2a0284fc087bbb7fe04f446fa639e5ca44a6ba2b8a37(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9cd8ee64008794fb08b4e0ed0b3658da40ce81f2df335f2dc1b58000dd08f57e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a2cd8477daff79a5f0b9e10a4b24093b622bbdecaad62b5435ef26a7614b4f8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3580a92b8f13296a7e42e5c1587cc192a7ace6e85bd79f48503d217de72cd5ac(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b842a4d06369076c7534cb176e3418f5c6ba48d38732f80c614de7e6591f1dd5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__71610df9ac3231e589bf4f091818f0bf2b97091377ed301462f2cf07cf752926(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualComposite]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__97e3d72057bf96f867443755a3b5f1a634d12c49cfe7ebf8754f8aafcab48300(
    *,
    transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eea81651fa064dfac8ccc5934e94004024cfa2439201ceed716bbdbd583c9585(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__13f6614657777a504141414a3182735a9529bfd135c3900a9a714628b7eeb0d2(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7fb792a8f0e7dcb52c02284ace9d9237a3dd15cfab6e0b813736e4d6de92a0f3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__83dd7a1b89e7c527ca6e6ea71ebf42ffba3f019da92c03943ffe3e5a4b6c8a75(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__abaebba85a46033a3271fc3c18647434c734c71274af3ab636c7186b3f809921(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a0edcc450d4710f7f0ee6a11cb57f3297489910c5c07d8abd299bd855e452ea6(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompound]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d096b5b224ea4f4d98a3c619ad53c099c9f97f74854aaba57922e0acacaccebd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__70a901ec73eac029a61142575b1f9ee54d1dfbcc74885fc282f204c7a7100ff7(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e4e757b8698d7d170f8d9d0dd366e6987159a175170153e50b285aee27ec53e7(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompound]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__987bc2f3c291e2c482fcfd26aae1b5b9a4ea246e8e5afcf400aa10689d06ac93(
    *,
    background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
    chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
    composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
    compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
    contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
    goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
    max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
    opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
    remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7db6881eb8ac64d546893dd5be1d55d156d86566ee61da05533637f3820d8f04(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__82fbd4dabc8cdbc4e499d3a37f3783a0b267578863c3f2597ab2f83b6b84cd9c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__35202eccbb4e37440f9aa39d5b52a407a44ec5eddf9336ac7a82440e8439148c(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a2e847657c14088359e0e06d595d724f931e9dd007f522fc745e33dcb5805bdc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f2463dac6fb005c2c3d68543c99b5a3b5a943951a288ffc2f28ec55fb8ef82c(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aa30bd0fc189145a9fb96f610f8c3d559a342c61455dc21dd7cb2ba189c9825a(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c279636d28ad10e819a90049dd07dc00cb8adbb5e11105c38170c00828c9d738(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsBackgroundColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ce08513d8abfe9ab39c6570f19d6a1319be35ab9dcd812aed706c1cf317b1cd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__87fc77b87350b5467ff59699e3b7d9c100210577fb3b1254f753440be81336c4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a09ed28e4a5075a707e19a9a3fa1f04a35a8de04d76de9fff5a16c9cee1075c5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f722ebef4abe012d5803ef52cdd1e4614ce38f18fc5ea01276ae415caa2aee3a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsBackgroundColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fe9e7b2f63a4083022859db76a4440a631d12fef85bc2bd9ac69bc20eebd5f15(
    *,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__170701698556e4fa78a6f8d72f95ed0d9489205a092c1e6ba2c557f8f2689c62(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7ee0026b02f911f65d72a0eb88119021bc40eb30203ff77e3becfe8ed87d6611(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f166b9dfdc6f420b13445d9b1912d63bb5bdf8717cb53fdc505bd95889cc32b7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__42e0044c191ab493a9a1800df8fc0816221c56e683395d20befab595472736c0(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0220d0cbb2a7ddcfd6380d12bbefcb70031f52f7d6c41b2e6191a33947400a87(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e93f2486e14cf32f259c5d9884ffc0471d8475b81101e48e4b3eebfd76b9f4f8(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsBlur]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a4e6d5085a0eaafd6dd88f1deedb465add08fdd2cefec351a3836b9c31351297(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__46ce96ab527826a871b9d4d099fcd2ada72a967c4b03ee9f181bd07310bc04dc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__40c5337f9a212b352d852bfc70af77e153934a6197c232f75b07481fb5eef60c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__94edba580e78403ec384f3c9d0f0a766dcf2704bc1c8f1470249b601b88ac537(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsBlur]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7ca72e6398d4738980bb9d49b1dda2b3b78d5b5eb3f3e9431d2e11cd6c2dcf12(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_feather: typing.Optional[builtins.str] = None,
    hue_feather_var: typing.Optional[builtins.str] = None,
    hue_tolerance: typing.Optional[builtins.str] = None,
    hue_tolerance_var: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness_feather: typing.Optional[builtins.str] = None,
    lightness_feather_var: typing.Optional[builtins.str] = None,
    lightness_tolerance: typing.Optional[builtins.str] = None,
    lightness_tolerance_var: typing.Optional[builtins.str] = None,
    saturation_feather: typing.Optional[builtins.str] = None,
    saturation_feather_var: typing.Optional[builtins.str] = None,
    saturation_tolerance: typing.Optional[builtins.str] = None,
    saturation_tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0a05659f2a662b1e748a3b850953d5bfeafe087431908c10a436825b68036246(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__94d27ea3ef776f1e1584059ec4fbc116dac2e0fef382f80d24f115f599e9638c(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dda9cae3ce41c0eeec9e7a9861bd76c5be37220a1c9c8432ab3b5f8c794b4abb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4954b94a79cc2770cb094d7fc79002f9a730714ca983cb3d772e81dc01bb5033(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__560b05ea60b7b1bcdcb8ce918b683807103775349b75510568ee9cb258855730(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c921bbafc301f72cd0ccfb3e38dc5df2a2958bf99fe10a4d6131647e3c3fce2a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsChromaKey]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3f876735323836b1f7e0fde3216d421326606a32581f579d9d00511b1b8ed2b2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1db156c86efc623b43c433801b81f2f4bf98d954282aba905d62326c11ae5468(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bce585c7ebd70299be32ac432437618af49165ad5e0066f611f040257af2d71d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c21cce08af13b77c2665f927139fb009fadeb81bb6cf24f031546d9e3a62d9c3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e9f2d21837cb583bb48716fdb76db845d14f1ea2353cabb37bad40a6e32c6524(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__72816ef992e7970f1431fd495811137b4c0a361bd4ea4a7141694420c63d6c94(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__29aa222924ce9c09add4330a72000c47c8c78729998979195ce4b576c93e5f53(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a22ec423faef02e0c60c77d50bc4179fed910fb409b743b59fba895cfbd8ebe(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3659efee2ff924d66955125a9c7d65c12f329034a1b594139c51c972a64ea47e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__95a286a0c6458ff3a5edac0df8141951b6fbb2ed619a917fc8f6e63164139039(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9c7ece7a60ffc29061f55a2486ff9e04b786dba496ca843e348b1dffff49a5ff(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9bfca96d17cf51587be418ad583612a6fe6711aa406f2bdf2d6d10026898f1f5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3d7b2012fd09a88a2fb44c1642ac0b03d9dbed4e5600afcbc1214a4228806c47(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7e5c579faf36190adc14acace3f74cd2b64bce3501ba3d980ecac1152331dff4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__93e61c6c0aa3f5dd0613739cc9785b6ef88afb39c611256208b5d08d7ccb86c5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6c85e4d8b02747eaa281949a32c92280b0b5b96f864872d5279396b568034a79(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsChromaKey]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7821aedfcdcd5d05f2f36562114cdc8476bd8fdff72598501c1833334c3fef66(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsCompositeImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    placement: typing.Optional[builtins.str] = None,
    placement_var: typing.Optional[builtins.str] = None,
    scale: typing.Optional[builtins.str] = None,
    scale_dimension: typing.Optional[builtins.str] = None,
    scale_dimension_var: typing.Optional[builtins.str] = None,
    scale_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f448b81332cafe84a673a69bcd344fcbf445ea8311ac48fbfb9a7f1af3d7d9f7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8ed71adb5907093cac10ffbbd85bc58d12a8b1c4a25ee9c81580f881a2573879(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsCompositeImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__118459bacbc9170c3dc598ef76d26ce4cf51c5cd403b58ed564c178a12f66e71(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1044f95798dd1872ad6fcd4e335c060d5a86fbdcd26d1eb09fb117d1049c84e9(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e6376af7b71c1342194e675ec9dcc47f4a6c5640b472d8dd8039ff84d215c960(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__31becc3628583eafd9ddc7fbe05b8417d5ac0d68351106e77a9dab6dab5823d6(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b3af7aa1441a86d8d3754dede090184ebda3b31e39f4e09d51d06e90086a3cf4(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9aabb1e4ddedf966c35e5ee1346fb2c1a6c598d508cb973e979ac84a5c7b8efc(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsComposite]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__54a1ee5ff1a67b6395936f567a8d45e641b51e086df2fb34de9e8ebb8ba78f37(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__781ee2af07805ed7c00523f4c58d90dc3f9591f27725b9ec1978c0dcf1fd9181(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__deb82e2191c5e51f01f50866dc39b141bd4a36652f7bcd034f627fe52362d975(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a5190cd23d46d3253245edada9faebbcba3ead0375c3dc2868f3cedfa9ddfbe(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f0eba1d4bdb8b09c2037260377409c735d556bcb4f53a1e0e65adff736f5ed36(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__22ea793cc4f625e7c68eb811d99a18c15f8838f1735386e66f39283bf91a741f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0d614f8cbb060bdbee781349c190145fccef71ad8efd56ec579107d3d567eef0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f86c7647a23fbd47a7d1dcf1d133465706b632ecd1e8d78671f9138387391490(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a0a3bad8933aeb789fb7e6333064a65e9cd3f30c1765a6d79eb865782dabefec(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8bd2f10c4e4fce65fe8ad9ca04c4509e87ce054a108b56b48fec21aaebca1ad1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be00f2447558ffb0c4144a1eb90db588f47b8c33ae80f262516cb9e10c0107c2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__297ad56194b90330159650983eca922f2bb234795b273d5580a82797bb02fd67(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1eadd4dae33ab409ce8fda76d46dd90d5e17e5802dd0f5659348810069fa247f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bfe666e1d86c64ea0fe70798f00a34fdab1cdd325aa0ec8aeb3c8c1e92c48e6e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsComposite]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1019dc156db9c994fb5dd2d7b8da0e1620b4ea85f8ed7aefea3334864cde1be0(
    *,
    transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__63992b1e98726499030f39c8d28b256bfb87835760d7b2ddd153a829ee9f293d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fa138de3c52a16653dbaa76659a038c74a5ec67adaf7acdb0a5980129f114371(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__333e12e84b2eab2a463bca3fd13e3cf2ccb981b9f7d5a31f454bd35965b0e660(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__87333d370a9362e0dc6381099940f0cc5918e7adb32ab90e2ac7c89df73e66bd(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6511e308af7b1a0c548294d98d17dff245513084b399f3d3a24c57e4c047cf98(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d9d2fc9f294ccb1afcb24d61f69b0b28a599378cc35a78bf38d57a8d5b118f60(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsCompound]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c3e58b4e1beeb8888aba67e2d450c7a92d5c0467befc942a5a7fad9580ab0189(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__460e1de22b7cc8c5b20aead0696fc54a8df0f7f09bba2daf936a061741811520(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f866e9a9df9d0fc317032fe9515e41ab7a52baa7b8b78699d2a9e8f92509eec0(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsCompound]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__52e0ecb2609a6508f8013af659dba887a7b34ed641e134b5e689599b91bba6d1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cb2caaecd5a4545b4fe40e647dc7ad285a16d01aa174e1308ee1b0c9dc3df4cb(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__680657bfe23f6ef904155c49c468bb3fd88ec493c644ee48e22be5e6395cc6b7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a6ae1933c643f161edf86ce8357bbeac20936c2c9fdf7678fd2d4420c709f30(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d8b2e0f5883fd5c56cc4de53455181ec4be4cb8ea32d37489ec1eed05a0e6b13(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__56c719ee90b196901f380b100fd09ccf2ce31e2c68d448a03759c3d38148e02c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsCompoundTransformations]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9bd1a7a42ee865bd8c94ead23281a4f6f1a77dde8786a728073d3edf67ebd6c0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bfa0203dd8a801d2415f99d752f02447e9419056982e6f4169cbc65c379a3407(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsCompoundTransformations]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e8db0c15407d35973b3bb3c19525b4ac87ad519fbcb6605bec6e68b82f88d7ea(
    *,
    brightness: typing.Optional[builtins.str] = None,
    brightness_var: typing.Optional[builtins.str] = None,
    contrast: typing.Optional[builtins.str] = None,
    contrast_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d5f1f7a2eccf77b91350e7a9569125cf2db9c85a6bcc8adfc5669a35d48a348c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4f0179facbf93f1ef61e80af3cd96f7fdb6eb9dd6dd596f7b7e849c2b1a64e0f(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a0a42286642181b5cd983fdd019a77bc7030280551fc834bb2a40ebe97df243d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ee5233552fa2d9ad26486e0c9371b3ca9e4cf6d67872a67ad5882cc20da17519(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b69129db200550bc8b5a6bc0a0159f9730b5d45cc97adefb534571f0b5b40f1d(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0be3b4d8dfd3f8dc45e31ce67df204fb8f32d8de9e6664d20d529c8a05e15be4(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsContrast]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e00ba0312570f1a2e67ade6b5084e54abbf16a2a7c82b03c207707084bb6805(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__252776b33f8e0eeb1468d0eef00a9bf9aa04366d038bc1a8bca39ac599f17acb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__19a8e0926dcc36213bff35060ae761b51be6b3ee1c6653e52d996d5ed78d2cf5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__10d03686a77a9e3e14ed6600d03b9ef1cad85862abcbabeb2b128e6b947f46e9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ef1f25d69cb64e38a0dad90b14e2f46f47507df958a99886124acada01cc18ba(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0825be49c1660c9b9bc779345835727bc0828ad001716aab4339f11d1c4a50e7(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsContrast]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__00131cf986edb69eb79ab853989f1dc2a7adbd896c99f76ada569f6e03dc0e29(
    *,
    chaos: typing.Optional[builtins.str] = None,
    chaos_var: typing.Optional[builtins.str] = None,
    density: typing.Optional[builtins.str] = None,
    density_var: typing.Optional[builtins.str] = None,
    power: typing.Optional[builtins.str] = None,
    power_var: typing.Optional[builtins.str] = None,
    seed: typing.Optional[builtins.str] = None,
    seed_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7e5114e4c59eb4ab2cacd67e9180b09b6220fd0be75135be8726e4c81963a412(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aa0fad276415f1f9ccb754a73f4f01cda4eb642c12d34f65291f51d6ede66ab2(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b527d381ff82c3eb5735427f591907fac0478db6f39fa2481056511af2751dd7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__06bf2fd43ae8cdd782549f31180b9039156f648dc67c59df3b5966c705d196c3(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5b3615b761db49264e1a339579c8e6417c470397432da376c4a270a005952e7c(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f1bc261803f674d835e5185cbfcff85d0c3248182a5bfc2b0e0236bf0e7ef48d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsGoop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ff3b194e85144fd7dbde7ca8a374a81427ad914dff846faf0c0b4afd5264cda9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d04c75b1b48e40042ffe2bd793c96ca25ef5b1e996213ed30ad4467763c146ac(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0dd67e2c0f4c1472929b1db2e6a33aaae274499a39992bcccd17a497bfd00071(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__60655bc00e27e16fc1fc000a6ab7662f0b518cfaef12c6b4a4e903a6c0447aaf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c6af758815a8283463126b5c51652fd53131ec7fc9eeaccde37b42798b5f18ad(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd76aa411b44a406675963e624cd4ffd15aa7b4bec3627e1341f6ed9a4544248(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__14db1f25dd4c9f52954845eea1a7b0e6ee9796305e3e3a4b10510b53c1b128ab(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4cb8cd608a6e227301e4fbdbd2eb96cee92b970c7e15f639333c946203f9650e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ed69aa0d38761ac3e19881e0eaef1c2307941984e6d846737a4a565bcf029091(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bd8d0310acb25ac6f3eee1fb31f6c76b49b1d71e3d1fb8782682796d87dbe584(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsGoop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5d81e5b1c72b1a27c27572ede58de1d881883d653a457034b383a7987704a98b(
    *,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__62524147c3e881408f5e76a99b3daa0684e268efb1a0d9085d199db55d87f873(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5949ba650cda4de42cc398df881e00d05ea8f3c4d63bcf5d726b03862ff9f2f5(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3e1a846fd1823a81c8d2ec9ffa5a6ce40db115cbb596510785b7474ae73d5034(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2f18ad1385abc6f8aca6150473ff9cc287cfcd6cd2bcd9a6d708799a13162101(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__39e523af21eda7060804c1a8de5651ec0e7898fcc9f6870d0126a80380c15bf3(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ecd692923d674167c1b646b8f356472494ebb192fafd620dd3005888c64e6b07(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsGrayscale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__da2d8772b3d3b94cd39dd24cf10cb56a53afec24c99009a903612d3c983cff8e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b4dd3a8afcaf674c96463c61565f0fad2d95a760c6f744c99690e1169ccbb2c2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4f48e5b2bdb80d101677daa1e32eba20c09cc6036c4526748a1ef395a408771b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__afb8d21c92eca08a50cac92dda70aaca9378e08ae4941f8cad318efafd91f3d3(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsGrayscale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__425f7f06d84ea759ec272f74a599f7dbbbb120dc387e8a13d235ca9170f8df25(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness: typing.Optional[builtins.str] = None,
    lightness_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__38756c72f0a6bc9495e78dd42903ae148d843dcd05ba49e5208ce872c7ed0d45(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b840413ef568f9789f45990315584c90ec0de6cf2182b50ab8ee73864a8cb8e1(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6cb1de8f0dfaa62fdeabc4b17ca16c94daa3cc94aec7d8292d5a90e990a114b1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a6e112878fd6b17dd17b4dfc317b3c34dc27df49ed02659a91a6d3348c58a06e(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f1b63bab0fded52419d05e30817257badf71ecaaaa88de24bd14aae6fdf11ac7(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df8590d5615a085ddeadb2bb5bacc1b547352ab2b3665a3993f5cf475f874fc1(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsHsl]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__096fe857dbc914a82f69358564a15323fa0858e2bce8571e33650003902e06ea(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__190fb87a7e372ffcfc01b0621b2f8d1595614c46b86f3107a5f3dffac6e65391(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c57a4c2f7bff5cbd83cbce80a908b86f00e74c9b41016fc75f02e9add81b4d37(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e3914719aa9b23d37450cb2f90dd3e24f562adeb7009d21df2c08cab9ca942aa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c5b8e5a4bbfaaf356475b92f42cee25fe28e26a5421170b4d4ea39a0f1f08ae8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__40e4b36d9b06ed9d184ba233ffeffd070b3c953676330b555ee0646e167dd788(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9c1eeaab358d7e12dcec8d00fc0ad3836836432794bed4abc6cbaaf72ab473c7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ba55d76dbeb59f4e89aaa87c50153ccc2593bef746e834be9cc88848db0f4c0(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsHsl]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cac30ecbe015a8e99dd07791cf55e219144f1ac6fad73795ad452be88d0beeb0(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d72c4c235e11482f9d7409b17c48985c3547dd4bc5cac50a51025bed21189e10(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__acb22d39880b883d3676a96d325b34691a0773857ef2b74df2bd0bb9e45ec6dc(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a21e38d7954c69bd610b55c965ca4a402812a946e7ca2a7cd42d3976acd764d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b749674bcf04dd5c531020c9c0ac0f77ed6ad86c2f83160210dba9165e838442(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b5d4b6be6f983497d59860088e1e7bafeac4d577c0713bd670db4bc9229f50fd(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e1d86bcee19bfaa3e7278bd401a37f9364301c10769596abef2c1b588f3e3d5(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsHsv]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__03071586d65e37b50a56b92bef81e08ee8b1adb59530bd04037ee19b15474a12(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eca3654aef330db71296a223387c487d6af1e3fc90b5988426845a9598c72697(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ad74173ac37f3a56bcedb255b5ff6a372a5ad0c60af92385144bee845b0cce4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__02210eafd504e2c8fa57017c169bce7d8f568ccf1e406b4dbefd84bcc3c5e6f9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f6b80f4093ad4c7863bc7f85824600846c8528d955441a9ae9db05939f3e3ec(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a1d8b71224daf1309489a58a6af288061dd1781f9fe328b55eabc3b4b932a4d2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3771c6b32c9374e6b7e224af617ab105d9f826d8a4100f2c7b04cff98ad31fbe(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2e4aadd64e7b38e4ef10903156300a85895559079a695bbf0886b60521a87b44(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsHsv]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d7821f88c7aca982fef40fa747abc60bcb7e44ec00ed9fe03583914842df25b2(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfDimensionDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    dimension: typing.Optional[builtins.str] = None,
    dimension_var: typing.Optional[builtins.str] = None,
    equal: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfDimensionEqual, typing.Dict[builtins.str, typing.Any]]] = None,
    greater_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfDimensionGreaterThan, typing.Dict[builtins.str, typing.Any]]] = None,
    less_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfDimensionLessThan, typing.Dict[builtins.str, typing.Any]]] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__acf52728ba9aad36d2d29e7959c0fbd9b1bbd8ae1712d39f9b618a25cea249e4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__835cec57e34266b21c69dcc07ed136b316a0603d3fe9d32dccfb922f18ff23fb(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfDimensionDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a0cd495800635ef525e4ee4ccd92c78345dd38e2a87c2a0c740d88960591e1f5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c3726f2128072b1cc9eddd4c3c742f0c0d851d490ef616fc06f8ce809b6bfba3(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfDimensionEqual],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aec5fbee0311985689097c7b5d485a935845df6c2c986a3ab2d9bcb0f343b0c1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__33359a352134e9d46f12ae71b671f9cf69ef7c0364a02945decb0c1a57bf2d5e(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfDimensionGreaterThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1593f854b0b0360d927aa54ea478e5785e6c36c8c862b2b03265b9c640ba5c78(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ede0de36e51e0806fb2f0fa18731080251210a1be85a796f035a6324f1cb7371(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfDimensionLessThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9e746e47a10405faed15664bf0f5cf5ec3027129cbb5b3a7bb39162e33e7ffd6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3c38bc52ce9483835402adc740d164022672c26174af9ae615d94fad193beb09(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b1cb05ba534c0b82e23a81b4b67407e979487c0356e7d092279dbf9274eceb81(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0107c95e29a872bb97421b64aa349ccc273a118d915519d0e121166dae1e777c(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2fe16c0acc288c4e013ac7d70a603f381e384fda9357512c32518016d3873d3c(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bee2d362c3dbb6f55e602e9f528a8cee70c3ec62ce3450c1d45a23ce20686431(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfDimension]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1d5b9a42dcee67e596e5b0a7343ac6e497be7b979c691e61a19f55905ead516e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df7ddca21cc9f059cc665834a6c2984de601470485ad04aa0c51a8fb57d18a4b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a8a8b4c6b7eaa3fe687ad7246ea77f8f7ef50de95973cd028ebebb0203f770e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f31f5634040dd5d0305f36622a328a2e80c938681068ddf04e9596e5defb5a6f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__52247c72731c3ad6787acc9b11cb32ce3d70dc1ede0462b69f3e860065946569(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8c806544888a2b44ca6a8d7a13fa55acd7ed4bf368b132267588333fbbdc9d2f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfDimension]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__20fcd4b99c2676e6c728aa70951c36d6caea076e0c3e3c3912826ca71b04b96c(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfOrientationDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    landscape: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfOrientationLandscape, typing.Dict[builtins.str, typing.Any]]] = None,
    portrait: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfOrientationPortrait, typing.Dict[builtins.str, typing.Any]]] = None,
    square: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfOrientationSquare, typing.Dict[builtins.str, typing.Any]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ce7a4cbebf60432a3bbc0fe66db5ec8638d6d797c785be956c9af6b67debb65f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dabb8071e42f4189e5d3ad32ebbe94ec6b77ffd6b314d2b27580c23203025d3e(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfOrientationDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a32464eb1deee501b3255375faf99f53902f6c90e23ce5f43a7c747afdd0e09a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a01b143c82a53925f19c1ecbed27614ecd954d177f8008c384704f479d6155ef(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfOrientationLandscape],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c700eb56989d5cb3d3369219c1324cb0e5c0aac6f9836a9e2e74bf9e7c61d23d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6ede2a436e33501d1da1db638e7eb19bbdb4e86c0367752886e1d08dae81d00e(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a87da312e5ea701f4eff866f427c02bec6ebf1338f4fedc465db42373f8f28dc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__001ebc6841167a3ee6fd9b55c8c47d691304ca8a07368d95ffed87e3bf2dd470(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a8c91c69361b04c4520d223c87351c8da3f249c4c577e63ce413d41db0d5460(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ec2cbe37989bb40ac5cabea838e7b63eccbe23fea116a98d52024949d4b9812f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfOrientation]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2982498db41c51d6eb7162135e63e000c179b4895bb451fcef12c535e7fda776(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7a01064e1e803dfcfbc5985269096fc07b3ca310ecf871a82e79295ebc6df834(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfOrientation]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9f10cb2240cf0f69f1254565adca822abbf73d2637c479974ae0a3f211f1f666(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f54943f8b3a9bd680f7a61ebd85d6ba03f5c7235ce39ef011edfd8c589a12531(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfOrientationPortrait],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a93b9c9a37d02799c1821e133bd76876bd18a68fd2e1ba0485f9e0b3ede1361d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f46d3c28bda6af98d8e5bea1a82f538144394a37610124224eccb15b87645c6d(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfOrientationSquare],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__01d7572e16a33fbf5bd799c57639d91ca03bf3305406d5dcf260620adb163435(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ccee27e20adcb37217152d1fa893e785de39257e262e3e3d1208675a07b6c5b0(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bfb7fef8a61ae8705f9376c2c8fd45c11841ae9540c809c5931d8f56123db12a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4e97ae02aeb774958995aa63d74813ed6f0e7d66ffaf7a6a4ffdfb13adea5a40(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__475ae1fd3aa5d71887e51acdfbf3810a79b2249732cafacd2f2c3070b0f76675(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__25395ac92aa6af62fefb79c083d1fa4fdfd6b44280d0581f38a08bc4dd48db58(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformations]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__493b7cae163745dc202812e9f63db4b24d816f276e4746918f07c6995fb919d3(
    *,
    colors: typing.Optional[builtins.str] = None,
    colors_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f7a52892899f0886733cd89a36df0394fba8f57ddcf38414b3aeb37339a05618(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a4012bcbef918b73f99672028055687280f57f85375befc23833eeb866db2f2e(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4d0df8c26dd2571ea1ea445ba058a27e8c4383e3db2e11c75ca42c3f21b17039(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1633b054046ca77c0d32cb50f7744b2356d88386da4a39eb1304b78f29fdf6fe(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2512184edb7eb3b965c49c3d3b07071ca38ef3fd27b0e47b282109020b61656e(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f681687d269907c7b616865053eeea0e7510be317b10f9b085e6d1546dafb38(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsMaxColors]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__14b58e1faf78143759abe56c08eef0a5cdc3964aaf231b138f56e6dde85fe3a1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e28c2be1eb428bcb84c20824591f0f0b9186beb58a8f3052fcbbd967eac69ae(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f79d75dfc32c327fb0453d105536052d88efdfad02896ef6b57dd41f90922e7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9177aca7c759d4d144c42d793f595db3b060c2f560a3dac0f5ca8ac25f894d4b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsMaxColors]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b12f5dade0ebbfba059d0f1779593ad8a3da90aa8e8d9a5cd4d78d9375b4fde0(
    *,
    horizontal: typing.Optional[builtins.str] = None,
    horizontal_var: typing.Optional[builtins.str] = None,
    vertical: typing.Optional[builtins.str] = None,
    vertical_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a5de552f608deb1bce4902fdb3a6f4e34b94a17c7f412e278d791791548002ac(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2c706579156ad1ba8a984e756a22e1cad3729ec264eff1fc116ca48ace78cb0b(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__53f425bc541053e6d02a7ccbbb257505658072e39ad2664df06842b6746f9456(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d9105ec5484043d63f802f0b05c099a0eb27b83c85d20e15af2caebf36048b62(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__27a927d3821ea71ddf5f12b629288530768d4142b28c8ab79601db3eeca30ea2(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4092e8bceecbcd14aab9df22d03a1fc2eb8b061dddd5bb1d8a6c0e5bbc1b1925(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsMirror]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1d493bf49b2ed2fbbbac9462e534e4aa53cadeac9a909ef5ebf2029d32e3430a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6c1bcbde8bc0fb49f7d222d5add9d5314fb0da52d5880391f7977597655252a1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__99980a4a905554c9a3d053046505ace32f09592256dd6a509febd1b860239099(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a810940a7bf9feb0768ee6efde1de8d01adccb467be8632f9e1359e8d9bd537(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3c07a648774c1301a8937974570f0c3112b4ae0d75154eee42b742d710cf2f56(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6cdcf6a214354b00b2f27fb02636a38d97a76c9b9f389744aad04cb164da18e8(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsMirror]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a275c7c8b986ea65694b1f320869cef476a9a0f9bf01484ac494a021d0c497b8(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fe7ac6795d6215075a2bb19c3624d97ed4aabf8a8b58a3e09f48296f5676a95c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__64f9960a1a55c4aa04d7482a04bf901513d444a5ad6858306c9baaa6b8c65f7c(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bfbdfbaebc195cc3c07e820f8dd434b5cea671213133687d94fe09b403478cbd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6496c3d07dea3a11bedcd478e52ca9b90dbcf92144a9d9e761debe0bf0c3a828(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__68c74bdbfdda1d7df8dbe9cd24709bac1b2de9ce3eed1bd771b585c89762c203(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6d61aa4d46cba1737b70d9cdb352a157e5f03def6968c1dc4754b411093173cc(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsMonoHue]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2567a0b4e1470ae02945ea17940c044a762274315d7f030e574a779ddd01d874(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fab0ce9560db5a29d992e3b695cf9218b25095c6af7644824e5d339f310b57d6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__840745aa60605c924e22535812266db1c5ec5b7c06c242a90894c7ed50e96660(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7ebe911627fdc6775c2ded7141763214be6f9dad3d8f84350197219ca0df9887(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsMonoHue]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__42d1debdfba935f945ac3a9e7ec4afbb3a20ba9dc800b02f6d22ffefbd8a5436(
    *,
    opacity: typing.Optional[builtins.str] = None,
    opacity_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f544b86bb3e93fa81371cdee6b8747a90c4e67381446bef049bf54d6497ea361(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d5cfe60c362c0a2940e9f1f913fe53e87e0cd959089155a9e996d9b3127ca12c(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1dc9c502ca2e87caffca3c045bb7a604557337eea5edc205ddda6996d8f7e74a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9506d714a1e029966ef8624cce90fb1c98e2fbd81bfd98b3ecbe02ca17a72321(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e9088c32a3b3982e98248e1010839a2149ba6dba9783b09266ac2252ef84b888(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ecb3ae6c30fd3530da4b4dd84d23819b83bfd199b23e76b3f74c4590616e0f3b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsOpacity]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a5536736445962b82ccea06a7ab4b00d459dcf00fca852aaa7248684d2ca964(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2698076bc326f4636b5c63b984735e3323e04bfd44a39ad6e6cfbbe58f348325(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__063fe61e07c33375c39ed3c860df56c0bd237b918dfc3b54882da28b67cd0275(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bf49e1d57bd2d7c58308e2b9d613be649a9430fb5dcc18954ab4169e396f34ea(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsOpacity]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__afc18cdfacf98b0ab7f9089367283b41445eecbe2a966c5dc901ac4fddeabe12(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__08f91d7caa68f354ee7db8adf736e403b1eff0eef5e1c81d867843defb34b520(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f4a1c1bfc148c91512e1bd4bbd2e83b47b93b668b124d79ba627385c090f6ec3(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsBlur, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__70d3216b184beeaa05009fe5466428565862c62a809ee287c7dc66f1bbbf68f2(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsChromaKey, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a504f09f39733ecaaf7738260b3d0c45a0fbe9b532249b23798167b5ed88d30(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsComposite, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ef4917d2900b86f97af64a60e8241f992c826628ea031540a082224d06329cc5(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsCompound, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7fc7233a7aee27d29e263483af4d2d9b9b00863e276c699994386f32785a3fa0(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsContrast, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ded9febab81a3916605a1c97bca194d429c9d609a6907e6c8748750c2864d71e(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsGoop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__379d38f2660ce07674b36b27b25acc1dad867c63f0698748480aa8f12c66b809(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsGrayscale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9df5897dd2cbab571af503d2e1c57c3bc29f2d62cfceb4e2849c92dcaf626ed7(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsHsl, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__095e12341dfb96ec1f2ffd331e4ab10541de66995f07113b557a6d8e87cef2f5(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsHsv, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__420483932cbb10a0108e6047b73b8530da3a46c143c81e948b52acb723dee850(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfDimension, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__31858cd5e3e1baf7f6d38465636bd8381d30e3b9e1a306e85a87c79e751621c7(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7f67221950b8ca3b2d175bbb8ec5a050e6da006e2a5b1be5996f73b90e298a41(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsMaxColors, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c818323d123fcc9eb3990c64057f97cf021b7932e168282696309364a9241304(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsMirror, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__313f50ae5ddccef436f08afc02d47dca9dd5489bf81e476be2dd776eda1da928(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsMonoHue, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__10954fd30e6af61c5b613c93ae48f36a66cb4845b0153d171138d8fc79d0f1e4(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsOpacity, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__56068eb12a135afe7252d47b5a4da50d78d1a95a7b90b0c7719dc030f63d73f6(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsRemoveColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__58b5d548021c65a719ed3493053ee103e9f4c861386beb6ab58ad17372498657(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsUnsharpMask, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__378a1556098a3064cca954a0dfd37bae63954315a2527b8311ee319959b72fe1(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformations]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bf89b0a8e674253ac3ea2056953c55430fd01edc72167b23835553a63c678784(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
    feather: typing.Optional[builtins.str] = None,
    feather_var: typing.Optional[builtins.str] = None,
    tolerance: typing.Optional[builtins.str] = None,
    tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9f1382ff1e7abf124461a7291140255618badef7276ed8ba4958bc742abe80bd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3b60827175b0ef8381dd4bf992355e39b239441bc77bb4425ab515b6c2cf7c13(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6ebacb6a8682105bbb499a7ef0635e4bd4f012a39ace267796b1a1cfc3f9ac2a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__43f48311e64ba7f9fa16cf810c579e164d2d3c3abccec29bf12355cb70971517(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f9286921f9020d3c41a4c3f2927263cbb35ee25b37797c98e11fd0d7af53172(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__02890a6205df5521ceb7306516c1ded801d21c50338cfe8b2d27a1aaebf13667(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsRemoveColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__74df4ed6d57976dbaf65f4b07e71c2afd25d65a5605961e13ddfea8c4089925c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f66cdc1acc2d812dea8610c000d07791ba6f0869e5d8966536d4fa825a523041(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e1c423a799b48ff93e365ec5ff4644cfee196d25dbaab8fe4826ca35cfe643f9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f8bdd93270a99e763b4e81b12322bcc2f640cd0e16fdc873f4c7b3e153726809(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9aec51dc52a61aedeff6e24044d33df40fa4eb47d65cacbd18366809674b0f16(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dc52961c1fdf95234368ef2b0cf1c6db0ef5ebd679001b2a86bf270a1b981244(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7b20a323e1138b9c19b4f9bb0a2207e68baf28988e207eaf44f56809e6770ef2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__32b1c7a72aa066e1db097ca20a1e2f290837c111a5c91275457f7dc46533cdf5(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsRemoveColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b2ad61e9bd9023dc4d81c57fad707c75c082a93350c9bd84ea40808572b125f5(
    *,
    gain: typing.Optional[builtins.str] = None,
    gain_var: typing.Optional[builtins.str] = None,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
    threshold: typing.Optional[builtins.str] = None,
    threshold_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3e4a204843d5d55e4cc53693f5eb17968819bd48aa78d490e00387eb8354d24f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__72dab8cbd38282cfe7379a565f51640c58449762908be8472d6990a4a8e591e9(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea4660ec8e7705cc375370fcbcf19b8d64481049ea1e39d976010de7707eb069(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7182be4aa918ff85688116d3043298b994cf04ab544a4b731cea0e31fc710f67(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3903d634418129a22c8d39b3ed54bf91d222928461eb644785a4087f1d9463a1(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ed68cc54a76dd8ca67d0b8ae6516c39750f2ad8176f540501f26182d5fc44c15(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsUnsharpMask]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df3e9616826229c00535effdad59fd2e95e0cda1440ef7ed1d504e393a7ed43a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fae9dc50d6d3b7528f3848703e8f5850612d2013acf0368928f806f82b18326a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c9736d78596b36108a52f332d5f8fd313b7eefca144efb5b7f06fccd2ba5b0dd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d48f8d85ee0b1ac7d67f8a6b4c74f4e970c27ae13af238599646637705c0344e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__251583761778c79f225b59d9b9ae324a76cb3f0aad4d139ab4528970030a6524(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__64ed6d584e499f7ef3cfa202c493ee8eb03215f2515cab967192ef6ac9063f70(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f0870783f4f7be530c1ebf76365d6ef8db1b040ed4516aa4ad51bf93f76b06ae(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ef256f672e85edbdedc1a06485168b2e23c378d66df841ddf032bc348fcda73(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompoundTransformationsUnsharpMask]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6cd5c580f7a7caf4633a35dd6291c175730260333831c601178a2cc71ba0789d(
    *,
    brightness: typing.Optional[builtins.str] = None,
    brightness_var: typing.Optional[builtins.str] = None,
    contrast: typing.Optional[builtins.str] = None,
    contrast_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b035ab80d700868b711e20d700abf69bc6ad5b679496523d8c856e19ce82cbf4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__582f4c90e1a2e7bcef7c67aedd076287ee999ab0bb2a5dede2506666c1f0644e(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1e13969439eabdccb5a5a6bae6caced4d2f72243f3b95174eab87db8cd3dca01(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc9cbf32c86546ab89b746603d6c6ad6f96ccf44824202a141028f70e33c943c(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__80a8d08271dba7a1cb6995d9c5f63db18bc98ae469ee6a64642437a167e94d33(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e313f71aea2858d9544852d61b79c872fe2ee30e6194f9843df253caa5b6f435(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualContrast]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7c26428b60888ffd356c588ccae33cc4352a752d2865645fbf7b054d29e3afba(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9912efae50ed2767c67ec22311b2b30f522db74cf16cf85280590402e63fb311(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4716d9b6e112c3e014aa5da90c9d8208f48b3086e0c938cc58975ac8e3e4105d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cb75f345ba4c65ae9e5a7d1dd9d71c4a4148af175cb7bebf0416531d6b15ef68(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__195ba1db7f27ba0c3ea8c14d01a103ad984e27d7af1a6d25a57b074f8fd70167(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__45cb52f784d1eb83d24299930cac5f8e8567c94f10de51126f409b1527a40292(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualContrast]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__439c4f4b1231e38450b885b358e21db30f15dad31c60a2993ab03c16f5edab95(
    *,
    chaos: typing.Optional[builtins.str] = None,
    chaos_var: typing.Optional[builtins.str] = None,
    density: typing.Optional[builtins.str] = None,
    density_var: typing.Optional[builtins.str] = None,
    power: typing.Optional[builtins.str] = None,
    power_var: typing.Optional[builtins.str] = None,
    seed: typing.Optional[builtins.str] = None,
    seed_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__99583062faa7e020ea3f278812d8ee2909cce99394202ea5dfbd04c6308c3854(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6db1104e09877dc127891928b206c53456bac7e5c2bd9e0342e3e596e66f5eea(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1935af1e2049941d61c750a51e86d4e99980c93accc5feb2335515d86dd089d0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ce2d569ffb6aaef62087c9f43fbfe87d76e8f3ccba22e9fa50c5d48a98cbae6b(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8db6872132c2357861449795b63d16e00a0b92049d254cbc8a44a2b5b52bc243(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__60942224887e643291e4666ca6634eaae0479876d0e12a8daadf2eace4dc1bcf(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualGoop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__95ad32367d7ecc67858b6fd4b0208a57ec972e87c4eb9a50e5a4fa11329a74af(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1ce5a9be24f004a7b9b7d1c1499c01a09b949a80d6f5ca9377fa1f9fbab97ef0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9780ce8b9dea09ecb629b704ebd458abdcd886d48065f99ae8b4a8be087be39f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a659142be5a7070eb83943caf98d736d7340b3ef67928c2eea61dc02b3d44dff(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__38c5533a562ed5689b4347daf7dc832df3f5ef06ee40cf122093052188b3caa0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e718cbd30a28496c45b4fc8fe3237d0c9247fbdf105346002f9e3ffd7a0264a5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c64433594c959b7a44fa8f337c3f0a37cf68d084346ae694df6005f046c0ef33(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7ebe3e9d7d81c1c2359cd8fa15507936af8a71fcaf1a11d65ab573a5dc4305e8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__03beb5034a38468367c3959d0f9668ca000f36ea2a159d1cab9b4708718849e6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cb5a96a37033fd01ab10755717fc7c038f4c97592b75f5e52a6f1a5fe7e8bb59(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualGoop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__324262d7021c5123d38f1725c0fdfdea4f2228f7929a819b63934f1168c848ad(
    *,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6d9a44697c05bad1835000f6133b3ebfc07d4fec98139d0745850c81bbcaa1ff(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__60a7661277d5aedd8ecc00ea8ee3d1977afd347982d7959d88281c9a1fbeef22(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1b51538d08ee06aa4c46912759695d5e7d6e990080e8ebf46297ca94144e697e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab38946d145fe36f31809dcec3fbb254b2c26f9e8a4513442049111f43a41044(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__10edea145bac6599b90b50d3b86be2128d47113fc37ab0c3d14eb8c28dcf411d(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__30cfc50ad0eaf07f21047258ee6e459b84797e0ba8e2ebe572255eb8f88c84ff(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualGrayscale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__923fcc0c586138a9b3bd6800922380fb09955c93644246e8c2ab4ff38419e04d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ffa553feb75f232251765be8e38e9fb248402b949d83420155869bc87fdb922d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__36e6a7cc462b40f82eb5db51e9bba346febfc4d6673f38afd78357f5ab0c2044(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7c915ec43c867442d1288228b1444bb1fdd0a121659b821d74e8a68b7007a544(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualGrayscale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__823468e353429a3697ea3f972625df4fc021580f57ee9f84e8d761e0bf077909(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness: typing.Optional[builtins.str] = None,
    lightness_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d20d79fa2f27f0c21f31ef78dec6085e308ff52c2f6035046cd6a2c77db06de0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__89722187701ec858146dbb0ce75cfcf8e860ad900c00dec533707d10f3d06f1e(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__55208d261f42a95fc6d84f2b3194f453efe50251fb9fa9879041ee8a8ed46f5a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c08d40194be40ea04fe7a8759b0aa79fc018fe8c9e1e6c0f7d2af76011e62d48(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__064724c2064bacd462ff4b6b956927f1c62f30c21a011d2a3e44bf3be9d525b6(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f697761a4fae315b69385a64021b312f233986b43d717b0a04ae6d0d86bf9f4(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualHsl]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__deb29819dc7055d5fcaba3a3966886551e87ec2a92a437b75020d66986132376(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4926e206a92c564977f0e312eb08fa2ca9ce1cb2b3fc832e621dfb2bc155b59d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__53f89f27f608a19946a2eb072734d3de19fe27f4916f6f4cfa3ecd12253fcc81(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__375d2ee90cf051337276ef98bcb45df5c1440e1666d8d7e26a56f38c047f1609(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5e5b65cf3dcf545d453b333146647b18f40c5cd89ab7fe87fa55a5cb99865843(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__20523ce08f80ffff9c7c59d2008844eed719f372e1b06658897f59058a650ba8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aab9247fe90d8b08104df62a9d4509c004f628df4967ed1a370c5774248e0ed8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2e46e2c1418634d3a5267bd1552a0196411d453926f177a9e5854c48e1b1e984(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualHsl]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f86a7011036e5a698eaf31611cd8d65a91f6cfee79056d6607b1ebc1305ed46(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f0b4e27657eac63f75f3363201ce8c09f8fa26a37dd8b9b9f39541f26f14470c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__296c626aee867079429c211cc51c407c3914b59d7b4bb70e1a5d4d1861a9f40a(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc7856371d07fe24b479e9f21efa7d608c724b1bf86c10a4cb4e709703e57803(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__689ada7c54e5e6f1d145bb37aef83bbb2cfe55095be1b0ad5cf20958f3d4d846(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__23467b8b39166d1cbe4ffb822f9a95cdb437bd9f9809c6ff5a5d37056660b989(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dcb89eb28532642ef4c91508599a28bbc7380253cd01968422f17f0e2c052db9(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualHsv]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5b45813c59a295d78747021f59ae0566b110e2449af1ed66a168b969ed7a0da5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8fd93112764375b84e6105f57ffa67c3e1f3ef620fd49fb062883f4041545bc1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__faabdacb971f382f032809e40da0f65e20a82690075836e9dff723b6f76b7a0d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__99193a0af7dad8de31e4421655e7ed3127a394c1c2e7aa86aba082de64f44eb4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a21cbd4499462a4294f3d458bf5a413b7fd35dded9626632f497b983a71e9e81(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__52431585d2faba9fa0e3fb7c3afb63e7b81ffc550f8766440a5514e18d00c81c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__da8c6249367290e35e4fd31da35a5798947715949f42ddc5008aea0d1fb84314(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__981f45275a7f75d3226e8f71dfff11f1b4c42cb419381ae67a63b5ffcb2a41df(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualHsv]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4c74e94849e459e53b622ab27c9e115f04c03f84f649fbe2a7ba8ec750059da1(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    landscape: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscape, typing.Dict[builtins.str, typing.Any]]] = None,
    portrait: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortrait, typing.Dict[builtins.str, typing.Any]]] = None,
    square: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquare, typing.Dict[builtins.str, typing.Any]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8c6dfb1abcebd993f0d48a9d60154456708478d1790798ccce26a64035c6daeb(
    *,
    background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
    chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
    composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
    compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
    contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
    goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
    max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
    opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
    remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__067f6a99ae290b9bd98e2de5d854bf3fb2830a2bb886b22f288227a3cd46de63(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8b3222356974978e92621f1d7f380f42d08235e4d3f99f493343af50dd170fb1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e33b1962a2038be89cc700ffdfe31ad8e68288a551e27a0a57d5f838d299314f(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d0ed72a85a10743f742634c58b251203afeeeab1f755c4a30cc4c7ba7eef1783(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__39c3f2285ddca0110dcee620f5bef5df94ede32d6f3e0fed39915446f792684a(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1616d73b163b2f2c8452027db57ab82b755005494a15caf8b510613d0624ca58(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c48718a96b5cef37781504f6c99e8c78d2a4eff92b88778f35077006a3f44670(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultBackgroundColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f17b66da60775690eb3e826caeac2aa3900f6b112d239c611eb0afd8ad9dc76(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a6b619f3350df9196fc0afadc483cdefce609ecfe72054acc09710a249e489a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ea19df2504d9c9819935e84dc87b8e6d406821e77c79a62c6e601c663b02b4b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__59d072cfefc8f4bda90b74bba6a7ec4720ef3f7ba2a4e111486717a6101d63d6(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultBackgroundColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c25717671425690a3ddfe51267b59b2ca43ab9c83a704b6657cd84645778ff17(
    *,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d3982894fde2e42825cd613b120e00121459b1b0edcd0060c48d26188740305(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b139132c5b483498bc48ff2ce292479224645bd082c799e6efc8cb36f7f62043(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ad81e874c250ab4e5d4da560b0e756f65332d9b0a069df2a30f6073c61c7dcf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__515d62a7ed7a46b2da971386f7c36b598c2383f9d730bcb13e83b65e325b7374(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__606f6cbed84a16f319af4b98bb1e0663c22472a12cd5c90b603c6a6afb9a383b(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fecb358a529e6df84faddc5602932a47de603a60bf7060ea6469622b5051bec3(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultBlur]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a4aa7b31f0c662710b7184b1b1971c12dcf2bb22b0f5bdcfbdd6f25ff6e2313(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__572403b25e8dcebdd4347a014ffc7838be7bf63c2cbcdb7c9d21456e4c4e6283(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__22fc821ad9fb4a9a5f418326af2cf24d9728d4814c4248a54852275c5fa22762(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3fc1ddad860eb21861a7548bf270e8b7bfb8dbeb65d3323ef38581e3650e113f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultBlur]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__94db0a910454ff8a6c228ead1c6ddd54ba5432472412e5490f8348c22ca1d4a5(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_feather: typing.Optional[builtins.str] = None,
    hue_feather_var: typing.Optional[builtins.str] = None,
    hue_tolerance: typing.Optional[builtins.str] = None,
    hue_tolerance_var: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness_feather: typing.Optional[builtins.str] = None,
    lightness_feather_var: typing.Optional[builtins.str] = None,
    lightness_tolerance: typing.Optional[builtins.str] = None,
    lightness_tolerance_var: typing.Optional[builtins.str] = None,
    saturation_feather: typing.Optional[builtins.str] = None,
    saturation_feather_var: typing.Optional[builtins.str] = None,
    saturation_tolerance: typing.Optional[builtins.str] = None,
    saturation_tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__58a51f8e1abb76b0308b62f742cf60fe1f485ec1e29088007546bda4f0244357(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__30047b086e28798b1b0acddaff1c77bd0929a1f3eca561c2bfc768dd0e7927dd(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7333a6a0cdd8ddd8a4c33e4e964c03876c337d70837c8e2c27f609415b72d5a9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7e75404f28ac1ae8bf40e9182109fc5ddd9ae72aa9560219829bc95b2c961d8c(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__458ef7afabad7b5fa4349ca8f7fa385a967fda7cf52bbe859fd302c0457b2572(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1116e1b8e753b6091b5361f6393526bf2e33740b47d11e6e95be069dd7508c02(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultChromaKey]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c5b9aff35f3e1ad8e0bfba93e2e279f5a5a564eb312dc461076bf5425c12459a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__47a1e8d6386b61fe5cb788938c670f724984fd3c580c9277580d74b693048593(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6c1d7cfefb5e112a8db2d23ca794d65ddd0c9df789225255690d06ec5cdb0ba6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f0e60e8ce1d7b6b485005eedc07fdd96b76e280167b457d1a9dcc7a75aff474e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__677a2578732db5ff66b8d67d4f7bd90443d6d2c21fb2ce06fe2aa0d9cce2f710(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c0a2e8fddf8cc48fbaf8a7322707e6ab3715f92ec6bb0d47bc9206e49262ac20(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6a47e75ec800c39adcb49749737800e2eb013f4695a19d3a678b60d9f661ba6d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f50b2bea79e81f379e7327037d7a260b907fe456e00a1d9a2f41bf14a5d5b607(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__86b2867ded3713fb102fc61d092365977cadee395f489181b5d2460bc1114613(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ffe836f445b8b59c3de5021eef7fcfb040733a38cfad4cd3a8c07c074b2eded8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2215ae078092c23911dd349d1ac64a5ee9851279639a16737bab5d43d73de096(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5abf2569a435e801aa96d7ceacd18e3322979f92a6c3e9ca3d865632bc1183b5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__964e2038cb9adaa426874e507cbc5e94625f3a2bf2342860a43596f17fbee0ff(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dcccfdea5d0c38294fb2f6f60f0a9fca8f9ab8f13beeedb7812b6e391ad404d3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d7970ca02190b473685f2d157ba7596c0cb3175ba3df3745bf92900bfd66dbc4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e4309b41b8575dc3c7ff6df679792a6d243ca82d8c90694c8f7fd3c89a41cc76(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultChromaKey]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ef21d05d601c7691e151195d47ade6828dfe334911b96f1004e4fb1ba2ab020(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultCompositeImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    placement: typing.Optional[builtins.str] = None,
    placement_var: typing.Optional[builtins.str] = None,
    scale: typing.Optional[builtins.str] = None,
    scale_dimension: typing.Optional[builtins.str] = None,
    scale_dimension_var: typing.Optional[builtins.str] = None,
    scale_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd90f6505c0f50c4dcfa7a6daa2719b507cd4d578ac6bbacc6c825c5c406b964(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c2f60ab26965f9911725e9718e05f1119dd458681efdc867aacf048824805717(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultCompositeImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea9d318e80fda64515f3505a3cb6a6c9659bb31282c266c27565b49d19ff88b9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__de88cc74788eb906b606b55ef3809a9a17e9bafd76c22fe0a2d445768d5f2442(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9cc14dfbfd07d30a6b04ad0b5e7284bccc03a663a8b1398aaae9a6e1db23f6d8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__42cb11bafebed3778ea48cdcf1347aff664841f4884fb84db94581088d2f0607(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4248bdeb18ba23860163defd41d2bebc81d324a471d1111f4f79601934b0195f(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f93533a9ae44d006b0fbe66102d96e079a426fbb05db7737e350478919861d5(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultComposite]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ef1c1ca14b3009d82beca119f6922fb2f6864f6eaa4563be4c087d59eba0900(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8e7f62924203367bc7af56bc596382b5966dba8eedd738ccf04c60e35b62a308(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7254d49d915d46c0c0cdd1e4bb34962e0153ce237fdb489a95c7785a1437264f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3cdb5f797dced3c7f8d7ac04e01c855852d0607094862eba8d316724b83ccf14(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9cc4e328ed16c2c7e2737db1ee03c87ab7129b218524677a437dadbc54b1b62d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c7e4ebd74d664ffd9d4f7ed948e0b39283c4f53a9e13e8454d495ed42c76a61f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__37df2c585e4d3a901858332dc0fa19788852615006787adb9bf608b95d590563(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b1a7cca5cece6d84e41fbad0cc89a2fdca54ab21a1f87d02e61542a26daaca1f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7634999438960831396bce62f05fc9ab4beb34a9d5b82c342947efb5c18e840d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__61664f664585120d1d361b2720e8325ee5268868e998a339ea740e5a628358b2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__48553d2d3877c79c48b0e324aab7640c2680ac634c68783e51e485bfcda7cbf5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ede291dd793924103d61b2bf87ef2cb5f5a7280a67558e1e7db1cafa92074d96(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4172f17b1ab70ffe9b74e7e75571b3ad25f031c84c6a7fc22222e31992dd0313(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fbda4f23e7ae450762e343389a192ef7320a9f8408ba12b48578cf1f8018c72a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultComposite]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6d3c19cc0ff03a72e8f4f521c5bacb136a2de2fc7aafc97cf862b75ff561c4de(
    *,
    transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b6085e9dcee0700cd2c06cf5994e1279f7634ca1f4c327acba4337ac0b7bceed(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__01506f7f6eeea41a6f5c4df1fc77a37837d123784acbde53d182562343d82fa3(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2b6a946ee545d66d505813b83122617a9c17858742e388e62bce053308b3b912(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f182d55883d72b361bd9faf5726d968205257c369520ea25fc217887df1b4a13(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cf0e50b777c091574a3916610e32b11283004a2acd6208ee517bd685d92de514(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7121273c3058d197ac1f68e03d4095b20630b84810c89cac4a4269db1cccb29d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultCompound]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__65aa3e8a52f75707a9a71816d238491a36af3ba301845c1f787d50fab8c175d7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dfc2f2efd5515e6656fe0b7a107639489779fc3be2377798da6d634692745f0f(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7fef81ec9f3b1f9fbc18212f96087bd769b3f588b50df1666a44e185f1042d53(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultCompound]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0a906c3279968cc5b1860e0936a3d9d61b31293fac4b1aee985c463b94363dea(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__79c5fa12206353c124909bd41b4de25547a44837cfc9aba1689fc15c68a71e72(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8af7a251024ffce61061c3437200c3c65d742ed544842ebb24bf1a39af1825a2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e174290e3a123c59e95c3a05af58d88ce2744724975c136acbfc4fc8e15e9433(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bf98a0d0dedf106015fe6688d63738784587c2f92d0888bde9b0f65ac4dc492c(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab9ce0fdaa65180401ac391f9c3bb46a67dec3ca2255663c7e8eebecd8daf020(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultCompoundTransformations]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__83c935448de249c92d188830ccceb17e66661639512e5e56728c0a610189fe70(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__28958f408b8f2648bad550ffeef816b95bb506b73f51999bf0a2db087630d1b6(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultCompoundTransformations]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b12a91d9656da2d2c3558f5465b8b191854437821d808e779376d4703ae204bb(
    *,
    brightness: typing.Optional[builtins.str] = None,
    brightness_var: typing.Optional[builtins.str] = None,
    contrast: typing.Optional[builtins.str] = None,
    contrast_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dc2a8fb1ceb6dac7c96991535e6d27cfa375fa785c589481970a6ba54a176a58(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d08fda94ae6358c8becc62e258e175d7a300ef6edca97a0da46388f78f3c808a(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eb278ae995bd9d30edc4125cd57fb0e9c199b53c6acf89de59294a499c9fdb69(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1d7f78e54beb8e5a489144bc6ee0daffade35e96ed4b06c9b5eb8daffea9cd16(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__86e6ccff1ef1b51411d2ade4680ac15a859c4903ba10a37a1fcc208bd28da334(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aaf76bbc1555545098b20e944d14450a771d2e92f8341ce364451160311f3ac8(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultContrast]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d3b2d6c87cbaec0db3446a06e3f315151e77d6e890861119b88a2a32ccc24023(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__41f94570dfc0fee23b52dd8295fc5b6c96e991a68d2a200d38422a7b8940f304(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0351ca28cd20fa1e4f2151d394f911ffe6d5ff14f5bc255819f5ef3102465de9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__327f9caba851de1492abaa5796111a20d083cedae4afa8cf81fb9b9bdb7d3812(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b35d60b6f62113e6d15278c2f5ef3d8a61e4b59c13bfdf200060e3cb700423d2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e8ca18c5ac92c6ed5a68e21795652ae07614b5d10eeef8d951759e6053cb07e7(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultContrast]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f998af54c3fbba3acd3291b084dcf93078c62a0b58d4e3c260cb4765bb7a073(
    *,
    chaos: typing.Optional[builtins.str] = None,
    chaos_var: typing.Optional[builtins.str] = None,
    density: typing.Optional[builtins.str] = None,
    density_var: typing.Optional[builtins.str] = None,
    power: typing.Optional[builtins.str] = None,
    power_var: typing.Optional[builtins.str] = None,
    seed: typing.Optional[builtins.str] = None,
    seed_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e22ddcaa364d33a20bde4dad85a42a74d106cf4b56420be749c7e439649dde18(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f7f40ea12d3fd80c21ff8c4d659b475858c064229ef1dec1045584279d8fbd08(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dd42b22ff0251b9c6474712c3d95a63f9012bec98d93d6aa9078510844f5a7b1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fafea5ee632c99568b566e3c40ef815338391d7cce69231b1f0e36853f7a67cf(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__17ca32b2f1dd816302f06baa675644f3f9396b3ac1c66137e64be4d109404c15(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1c5161573a0f4bced5f2f8a46ea37af2319674ad345f416fac224dfdff382cb7(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultGoop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9c6c11e5a15eabb080c5579902b2eea56ec1932a5115f0691b22755f4bb4731f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb72665f6d6f551a42a3bf66f0a00d975ce2f728c0a5281678ff4125e9d9eb02(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__68da4bbdcd33a6830688867ee0484f6df90425c464dc37575b186e1eec3a609c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__17dc943dfcec12caebdf680df0ffaf331d2f9d986ac0876c28ba2d97765d455a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__787cf84367387881dc7d581087c162a32dbb5988bad408fdc43ec8bbe0433c5f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__45425557a750d74fc0489064f52a7cec0ab6ba2a554bfa5d57ecfcc17dad0a82(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__22cdf3155e1d56a8c039d873b95c821a266daefc99530e06f4f1ad7db7cfd3ac(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ebb63cff01acac8408ececd92d39706b300b26b244f355d7f984772db65db1c2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__935b23cef881f2a8cee67419048fe71fbc99247af17217bed7583b14efd65c04(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__55327bf0d470fc963c2c7ddd9b09907f06dc3b35ce5eb0506ce13c27e9dddb56(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultGoop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a7b148d3d64c32b9d63edcefd8d35679d21bc528d218eee3fcfffa70164da6c9(
    *,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0f0bd1d026a21f45e300a7e0c2bdb4d2a937fcc8951cf8423f72b86c3f82c71e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__420327f4e8d3960d3f1a72d7c8cd43908fd7c831d86d880d985dd38fb7b5ee1b(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1e4f634002a245982f70134181971633c67db8eca57e4485da08ca3b64b67d8b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__faf9673239ed4d074e3463cc11fc22c3f84dd28853e27c5d340695edf5ee7dbe(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__26c1c8b487a7d5067ee2d5895d6e994922a71dbb1bb58bb59fb512953c79d49e(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a721ffbed67ef0ba1935c52d1c287498f23e653f7b8076f970398d82aa6cee4(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultGrayscale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1676f39ac9904e63e2186cd7b3641556c1a80d57f9b20d50cca05570cf63191a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3093845289dcc28f1e7a6ba397c110e97cc5266c4a39d01ffba266d623384060(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9227ea63e7e0f6eca085dd542018a4719cef4502924b87dae2a56883cd7960d1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ec6b35b24742e40117fb7f168ee38fb5005fcbb6dcfe6758327397185e426f4(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultGrayscale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b086002bb34e09b5f6d583ad4e8435cb78fdf6306ae764f5830df658a9a0dd07(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness: typing.Optional[builtins.str] = None,
    lightness_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cabfbdb978e6d47bbb4e9a8437058be4239dbf9dd0c3b88c5287ec9e2dca443d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__400a6129ab75b3ae296bf1fc7aa2bb64212f138000b83cdc36a995175a8d43b9(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc390b66b0be53fda0bafe6917f73aa84da396879a2fc9456a86a872a63dbee3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5001016e28e5feaad9bc492a80812e58a6c6eed38251e71e2b147bdd36d11ee8(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__406b8f7e73c26d99addcefc3b1635eca77efea95e0aeabb296fb0d3dadb883ef(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fc8d9baae208578d1a4da81945d1fb9abfadce6d7bf33531a9bf368703c98f7b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultHsl]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d3391b8dc3ff0c16eb5da6bec4c4cffca47dd69827acbc98add95003df963a20(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d98c473b7b88dea6f3fd5b990ceeb39baf25c07eca84a18e69c44712619d38a4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__667343203ab05ecd8ace0f1129e76ee34dde0210ae4169de42705087e6805400(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c679638f4dbe6732f122bfa18bebcd09a726b49083aba0dcc363de49086fc7c4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b6cffab524ff258ac9b9d32938e928b1f2e05485df425eecdbefd5dc719846d2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6b744798b738454339be7c7fadb199892181d152d2ce2b4ea56be790c01c62a2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d6d6af37fb32858259e673e165fc6ecb70a8613f7d2292787699ce69bd880594(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f157c354ccf08442e89ac6329a87bc8baf5fde18cd4281257fe1d1027551bae7(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultHsl]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__76d094be0cc95395c503c5ee57350ddb732419b42bfdbd013d9291a9710143a5(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__52ce92e2ab8cf6a249a0bee39a464931a82c51a81b5697819b6477ac5528efd1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6d2458e4e91bff139088a4f67a4d4b3c5cc64ae68687a95df6b266b35460c94c(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__917db58c455b876b0a204a10355a1f2bcc245eaf7e9ecb175995f70d4c289137(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b084abd4985d192d1b3860ac12c04b7ac9dba7bbb8139271cf7a6d7b6b8ce618(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7006f209ecb88e95a230b5b5ed3edcb3bf48572863343ccb48ede5fbc5fcfd22(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a08706d749518bfa711dfa69ec493165afd1a893837ddfacc7afa2674a3e71e1(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultHsv]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__996808552206bc466a3a00b30716ef7de2ba2ccc450c3387055015320795c040(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8fef9774386fbf2ceda9a0257017c205902629178cf63e57d5d46e27c39c86d8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__99c15e4be2fa5cf68c302ca1fde37ad6e66c7f8d34fb287d8e7305e5b0adc7a0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__131b31869a23916f6f0f57277135e04f32e033651b21fb9b9a1b76e6fa8160fe(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__525d2453558efe2006ab7f2b4927a563ce7651e4534ac9c83b2c07d2547e26cc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e21ac28c559be627ea7491539cc9a2d4b58c92a4da59eb66bfd7c4e8c43beda2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ebee772125397b79beeff500755a80316410568faa57f389b0e967afd08e3772(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9b5f91ee5c97cb835fa35e9296b8ceb0ffcc891385bad3265bdc1de097ee5d6f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultHsv]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d0a4779af13904ff73ae1db5a1228b2092e42a8f9407025469c2761ed75a98cd(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    dimension: typing.Optional[builtins.str] = None,
    dimension_var: typing.Optional[builtins.str] = None,
    equal: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionEqual, typing.Dict[builtins.str, typing.Any]]] = None,
    greater_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionGreaterThan, typing.Dict[builtins.str, typing.Any]]] = None,
    less_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionLessThan, typing.Dict[builtins.str, typing.Any]]] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4cca6bb147820645d4f0b522dd7f8a4dadf4bfdf9162f71fcc0c71108aedd536(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__84a4ef73c872c5f140879f76ed7f7d28225cc43a2fd2aef9fb62fb9ed7beff0d(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c8249202d90bd1cdafc643baffdf18bd983ded06de08efba4205b9606db02e2b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7122c26922c044f141e01c70175ff3de4d7a29427a30eed7bebef154de5b88a2(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionEqual],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__548350a63f73489cecdf485c3c804d553d19c5c030b4f74baf7bbf160f675a25(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__786a673fc7a1a93adf16c0cf6c2bd61b5f0c3f167f265aad14414085a743c652(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionGreaterThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8df1cd1942d4d2f0864ffd342cb7ac5ecd76ab2e22465d8647a92312af86ba44(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__30c09a5cb305c04270248c89ca2652efe79a1d6861b128c2a2f0d2f709d54eaa(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfDimensionLessThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0daf3790a37fdc9be4005c8bf8a76e72b094924a12955dd319b5a119d8e4b139(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__97509f93d6ca66ea1897ce7c58b2d832a80fd7e98a6e19f1d97b9c1ec327d03e(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__420b23a7b65c934e945b4b5c283c6212bc50b290328cbcc71faadc9859c77691(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3c4897b127bf59f0258bb5520241f54b44331fff05e7422375ecceb8861f1224(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b7318ca32f805950f3da0acb9a6a8b824267addca5471eb364ee6aa15ec76125(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f45e5007915309af7b371d85bfb30877a5fcc6e0555db923c57d9027bc3dfc6(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfDimension]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__14cbffc7eac86bde2bb49f424933426368c9d6dc48797935643877778710ea81(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7dee7674674abae1f9cd5b1ff1e55a1f8524b4d4e5d8e6b0f8a96d257821412b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__75109bfed03a430e7ac86d27913f40f4b5c1b5ebe352abd18042a645a86d14f1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__213c0b7bc2e461bf9d159ff04d80989cd52e2285b4756337b94a3cd5d21623ee(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__61761755235376813a096e3c9da14b9cfeeda1aada213ba4ef84a4ed0581a16c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a0a46f185a323bff19e088fa69486e8d979c98ddec82f143cbd682bfca9c0b0(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfDimension]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__27d3c4b5e9dacf66f110ed65c50e41f5b1c7d87e908f2a553924201abc67e94e(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    landscape: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationLandscape, typing.Dict[builtins.str, typing.Any]]] = None,
    portrait: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationPortrait, typing.Dict[builtins.str, typing.Any]]] = None,
    square: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationSquare, typing.Dict[builtins.str, typing.Any]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__71cc6a43ede8b0f2be90bb3a577d3c75f177441f01cc26680c4bf10f9563b42d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b6c0087a5540f5a669ad2f01b140b2ec6fe6a5397405c2e3df6cb3cbdb4062c0(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4974f2b133ab6314f5de4efd64ce3773dd9ad6a8d64f6005810854aaf1ce3247(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fd9111c9eb7c313b167efb0379eda2413d97843ff765dd24b86f42570f0543eb(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationLandscape],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e74c4a8ae03cab8fb7344d31c8546dec08459ee7a230b0fc5a5a71a3bee4653f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__da8f7e3d7afb8f1e07d50ba3638d68fa73c6d002cabd3cfb2d047053f8f97629(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__200d734737b0d19cbd2cdccacb2cee9fc2dca7816d7fc0057fee032496059b23(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__91a35de5598d77bdcc4f354e043b1481b1928a10195155cc6e7472c4eddf3f10(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f0460b8e5be5e2f23675065d564ce3aada9a65b3d2b97b29e306d2d98f6afe3f(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e7b473384611cd67a5dae9615e5320d077e4a0949cb774a7629a3a4a40f7074d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfOrientation]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a09fd9835c4f8334c2e7d6bcb19f4b3be960b5175d12e9c8203b9d0c21588a5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__20a52ed96740aa0b77fa109928ec1419fcd5f9ebcee9c1625b569c69fe33eef0(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfOrientation]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7f2eba1d54286224ea7cd894edeec7c535bb681d4385439c35b397505e5766aa(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__40e39ef75254f1225dd317e88a4d379edc3ab9ecbcb107fa2ae2b4a4136261f6(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationPortrait],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dcd9e2cb6009716f6907dce2ab77ce21886a1c32fde42354df59ce9e8644ff04(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__60a8a1b15817be5982861afee3431dd492b6c6b6226d6afdae2a9bff68df68f8(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfOrientationSquare],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9536bea18e2b4f6ff01825fda89b17dccbcfe6e8132936400665f367af7048cd(
    *,
    colors: typing.Optional[builtins.str] = None,
    colors_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__800ad1ad2d6690998d42c8c27a27c1fde8bd666ce91f62139ea422b517d1f48f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__da2c4f1bb568deda3147be0d37ad23611255b32ccba7fdc1fe0b35742295f81c(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f3c06190cd04eddeaa3d7760c4bc3cd16ba7c790959f87a4a777dec57c0144ff(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8486dd7cfa5084e8cbc2697c59441359c2977bd315ca7e87bf6d89dcf0d531c6(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__36e67ebdf71901cf1662414ae0d42008a00a291e29ad331ff51c2953c2d1f6a7(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c84f07b9c32862cddb8889525e2442905d2fcfd1b0eaac055c4ff95142c8a413(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultMaxColors]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__75b67bbf77c826ed72d62c23b05389ee420d6609ed20ff571affe5c068fd928e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a1afcc4f48c9c95a65660dac665cdb5d5b36330059e777ce158cfdb66aa1491e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__305043bcbb7ffbdaa28059a82bdffd2b28b9ed142971da4977b40c4fe6579915(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__196232ef1b1eb031b8442ef2eb454963712feb87685d8b67d30301bcbaf3e145(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultMaxColors]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__75116d6d301afd7ddd99e3af0e9bc3a7d1e5302624ff600648bafb4aef796e3e(
    *,
    horizontal: typing.Optional[builtins.str] = None,
    horizontal_var: typing.Optional[builtins.str] = None,
    vertical: typing.Optional[builtins.str] = None,
    vertical_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3e66b9e3ef4ac01288bce7cf42e7c75738aa3e694ac527745fb7b6224c5c03bc(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3d5d1e4084b2dfe84415d7adaf609fc5c016392d951193bde895fc91b23095e2(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0fb1c693ff6e9c6b51c44e61c61fbc036a66573891f7e24aaa02bd20e80f8673(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2e5e45552c5323aea9ba72cf2fc71c52f8405880f8b8a0026b00432f7415e29c(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6798a5b0d7f99d82955ec219a48c107dba693968c558ae6c940f997937dc58e5(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e5536615beb377c990c4dafccda6967ee6fe35fd9ab926f406d5aa3206e63d93(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultMirror]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__63d9670550030544bf289052b93a3a457508eb46e21732311393680dbed02eb0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__34f42c84fe5e9f75f4efb8d24fd8d35429ced5895d3cd9bb092b70f9dae9e8b6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dcb71e62b71b55fe91fe0c124fcbfd14f78cf8fd52e22a38980ca43d6cccc230(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__07c435ff554bcf6ddf7613241f02356764bb0feeb7e121526d8802faaea9923c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__07743a0c5d7d18cf96f957caa876109b3449365f3011fe8724c0a768f75e0028(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__328ef7123de3c325dd71b86ca387924b47d2198994e41d7890e0a08bffb365d5(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultMirror]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__039c00127d0f683046c26a192ffef1d16605f817dcdad3c2f7b5b36bb0b3362e(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aefe183ade04fabd58dee11a6d907bbfed8799bf48b5452b5d48cf4f3a2dcf5c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__32fbf0718e0be23d38b8102ec5a5b1df577aa822056f68ae40645f0661d14442(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__653d88ea07809f03f1d1bb1de667936328481331c28d67c41ff4e1b018572e10(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__17f08207c7253f67ce3dec0e5ef78bb490c65e5b8a1a240314f8f61f8cd02837(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1e95ac5ce5a56d9cdf4121e8e2ba746c5470bb234bade8dd74a66b3dd0735325(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__907178ac1de75060076f62b6a661a9d00adf0121a05334cd4dbf9d6a19251a27(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultMonoHue]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1369521879bab9970ae988b490cea9a463bbab6c051d3dd17bf8ac6917d406ae(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab28b25d83070fe76175eefd00217bec0cbf01757bd3089e0cd3f7efc55b1d18(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dd8fb9f726ead3b0b8383ffdc12531c67aecdc16535f73b4ca204ddbbc7c7a83(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2628ec49e13e8c53770f16973cb6a816800987ea168b1a94d6256b3e4be4ac6f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultMonoHue]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__50a439631a2b40d6e1ff74db594540d98592d81f8bff241691ac99047f7f8622(
    *,
    opacity: typing.Optional[builtins.str] = None,
    opacity_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ca8aa0d2f21874612f128c79146d3b10b74a31625d7e86857536792d091974b1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__57a613bafd38719e6bcd1dbff4b575d2a9989c2ea30dddd1bda2a6d815e2f4e3(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__69f8a69c6ba1bd829bb99d4a8b6a4032edf3112a273f6785248d42ae4d2df488(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a738bc976ec27ff4d01a31c800260a62bdc5fe171e808018d4d193a9d63affd7(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0b5477ff00d072927aecb4c6d860aa40ebc3d93af0e437ae918d9c6d2f13cb0c(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cca502364d0b15fdf623993b20860bac56757e2fac4dd1269162322e670673d9(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultOpacity]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f4f387aaeb17a9b6626dde4892d0a2a2f8e787ff691ac095950abe75a7c52e7b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5af88eef4dc6e34cb1fe673792906df49e88ea0eb03ae1bafa5db8bf746ec782(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b8a5132bc9ab3c099f44c794afa45363e2d312ecefb0473b24b5bfdfef51ac89(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e48f0dce20cae68e2329179ff6ebf58a4f4a5be7c5c67636525ce68784f72824(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultOpacity]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f2c09f0233f6fc59132c6455bdebc5d3b5060fe193dba6d019ab5c4b3a7aa4b8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eb8e4e25a4785252e8d9c0aae9600fff8b6b834688ba750a687a675d6ab585e0(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4865604a324e23852173c5390bd1650fb4ffdbf23b56efc8d3d08e86bfc43cfb(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultBlur, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3295473571dbe2a4b3390cd934e7aaab089a0568b3a788fc5ed35582b54971ea(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultChromaKey, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d2bc9264382937249b530931c3bec5463b65f2194f6782a5f28de20b0a1d9bf0(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultComposite, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e33aafeee63a848356161c806e4d68a93a28b85318c2db672a650578eef62f0a(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultCompound, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__22dc9076e542ded790afa2c234540616253d23531e5bbb63beabd0d2438ad58f(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultContrast, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a2eb70c2b3ad8b80e82ab2a15950e9b91ea94509d1b8d11aeb7b217f610fe89(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultGoop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__585131bdb6f3b64132715162ae25fe5671e290c7f597c62a970209774236cdf4(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultGrayscale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3e690dc7f1daf743ac07cd23d3213a2ea74d12fff15281bac14f2983046cfe22(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultHsl, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7e5a39503e06cc0beaee62fe2258aec507f4939038e3d0d076512d3c572b2c06(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultHsv, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__41bf0e19497d2a131f97f905d2b748739274224fa46e3ad7fd1d94badbdce879(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfDimension, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1883ef2df24396e02172838582558c665b24e0360f578895f0a6baa7ea86606b(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0b09cd609677bada9dda946dba9fcecf2ddef4f31e9ac0a57772c317620c9267(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultMaxColors, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eb2d184c2dd4e7543ed76f3f34a07be2a6759f1cc3f047f0ffa5ca8d380ac271(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultMirror, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d179c195c2efc9b115eed9f7d082f3a82cf0726556070cc2d949085078ab0e1d(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultMonoHue, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a5260c90227368caba51b6394077d6bcd9c548c8374488e1d10762adbb571b6(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultOpacity, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6ca89776094ac7a4a5272ac26586475c1708e3e04e11b205a4e149976163030a(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultRemoveColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__97d9bcd26e2e67c26b238ae5388d7214894b296046804613050bef07478c1ea9(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultUnsharpMask, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f420f12e655519df989be93c613517eaa79c7673fe433bd01e488dcc85f83f1b(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__21776875919ccdee7b050012cba5aadb09d790746d5928f19eaacaac01586754(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
    feather: typing.Optional[builtins.str] = None,
    feather_var: typing.Optional[builtins.str] = None,
    tolerance: typing.Optional[builtins.str] = None,
    tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b3869ea777484730c11e7f8bfdb12dc2a695dbe60fcd6381cb3101b3bf6ad6a2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c6f49d6029ed18b688178be5baddd60791d365ca55d0ca288486bf99d22be7b6(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__362d349f28ba913b168b5cea39880f97d07b1b47e631a2c135fb08b0959f404a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a8f58855468d5cda71e2169b27c89ca06d31a296cacdad588de00febbfe67bff(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__13c3b0497a6b0e6b1296ff8ffe65b54db9d69d5985c7f54c8ab57f7cf358e318(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__46125aa7924d84e456301a5d31ed702b5d3d12abaa92dd8e731419da66053c54(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultRemoveColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8225e465f6131834bfbefa626c3351ae5702b78c987fdb480e146f32afa05b6e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bffbb1d126490e32da51c191e7b92eecac530a33ba802e77f8bb5636c05d4257(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a99a2a042c7b0b13e70531f891c101661265bae63c3c5fe2cb547ac774865a98(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__029d04d8ed6e95010529832ea9b9824d1d2064a194139243ea4ec6b872db20bb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__973372b4f2b394fae285240c238eac65caed92b451d5042dc08434e2f5079f37(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__51510fc625847a0a713b5a052aae8f11e649a55d66ddc65b42c81e4a76e9991a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a84708c06eff4b9f59f57c58f9bfbaec837b4aae9872c03375003c0ae67cffa8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a8a2c090bc203179d7a574930c49fb994cd83513cb3ea7ba3094a3449ee77ea(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultRemoveColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f711a4a1455059964f6aebe1a738c48fb7354579c63dac7d186ae5250fc8a4b6(
    *,
    gain: typing.Optional[builtins.str] = None,
    gain_var: typing.Optional[builtins.str] = None,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
    threshold: typing.Optional[builtins.str] = None,
    threshold_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d4aad8c340251f6cd3c9c070a1b448f1afc978130d001752ad5eb6527830b69a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e4bac021aeffc90a015f8327dce35a006be6ed31566405f5bb199720b410e5ad(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5956f3793ace44533e078e805d6191a6ca85ec6b2f1bc9db9a86aacd7d2a86d8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3f6e95d28fedd595fe7a1a59a7fe9c2801debd9f2ef055722cf1c1b9798ec356(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b4a3edec0d341d59ff478674a9689cc54e21977a8fa3f9395b37083c04a47d2d(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__07eae9c352762e5d447c8eb76d2b3ff6b9bd6c673a2e0604bd4139f519649342(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultUnsharpMask]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c1bd56ece0a74e6b5d1fcc4671d8ef232816b6cc77cec479854cd51a77a67789(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__faf19e41c436a370d8be76b00638d2b9f471c759b85b61976b3fb77096010305(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c67557bbdae152523ee474a0b73635e4c1b61744aa4d7893be1d547f722ef947(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__88d23b3e253c7078979843b25844a093d2b1afcc94cbcd827d57491930a0c0c2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5c00e71600bc231371b9ff0b19094113161776caf3904cf2baa749ac716695a7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f74014ddfe9045079c28b23a58e5cd72dae08619f6054430514c1ae2029b8a3c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fd106b37702151e3288ff2c65ddc168dd36e9caf1e4ec59688149ccf3195b1e6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__81cb84d4cd2ece2239f3cfc579bc2e06633cc5940d165964539bf5af3722f689(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationDefaultUnsharpMask]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__72c249f41687406e5efdcfc822fe4071db10580ba9e95a4d206b192f78579061(
    *,
    background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
    chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
    composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
    compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
    contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
    goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
    max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
    opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
    remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__261c8359ecb3e8a83afb54077cb2b957517e0ade4e588549fcf1d8c5337ded48(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__05528d4585fec2883c35385b4525fad5cce19f55276edcfcaeb4a44ba2066a5b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7b7b5decfb10dfcc040984ccb28ef5fd8f22fbd372e0aa4378bdd09d6bbdf28e(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3e1a760145d7fd3e10f363b8fb5fcd4cff0247342b8c1b836c55b8e37239c148(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__abf5d815e7f0eb619d071e82063e62586f03540d172c051868a53085068efc59(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cf073719a8ad08a8c5d35a8a02a9b2baa138db18f007167b2b63d21b46206776(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__323e1355f62384b9d548363d96f6bf6c29835a5f55d7fb7822e8770cb0bbe80b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeBackgroundColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4aab99bdd08cc7985954a75d335e87407c1b53addf0c4d78792ee96b4e3c69c8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fa46012804b340194c4a0a977ee0aa8e480a1f80fe608f537a2dc7254bcf141d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e5bd8404279ef9e773edb924e2dd88ab15cc12f53bf9aba159f09d6476b28ac0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__17ff8e88f05885cf98af430de3e6fd38ecc3a27c12803565ea156dc42fe4dea6(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeBackgroundColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f73f8dc9f2778d61eba4d36867acf5dfff929061908f7d933f9acadf74298348(
    *,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3986a51ef9141c191b02460100c3e553fed6f67c3b458eeac986f591260c96ad(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__552aa6e087f95d1201009c533c5f0ccdf2f627eb7240c1b11cee54535bdaf2f0(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bdd5c8648b34b1c887ca7e7c11bebf0da31779a7657ab6722d481b3fe71e16d9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6498675d42a13fa06711cb34cfe73a4337f52e24a7f7ac7b401cf20d81c39ba9(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__29d7ade66538965716b2f7f6493b0bafcbbfdb1834fc28896350a596d56d4f02(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ec65b03c3aab61e04b71afa866997460fdb25bc4883b06d26b92c11c0a1d1b4b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeBlur]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d578e34b60b644f5e44d289e9883304ef8e1ca27c6af2060a7128a584636dd29(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c528ce70e2ddba8fa9c912982d89d2d84220d705a9aa3927bd1ba01dde406b42(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f2ba3e4e6e0150135382c1d4976dd7df554eddf1b3d800bccc0ff8a2f3023037(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6c3f09830fc612637d2e6a7b566f80d11780aa28a4f4a1680cc0115ec411b2af(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeBlur]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d93036c2014be6d0e952eca6752ff64274022e3f989ef346b746be6e03ba493a(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_feather: typing.Optional[builtins.str] = None,
    hue_feather_var: typing.Optional[builtins.str] = None,
    hue_tolerance: typing.Optional[builtins.str] = None,
    hue_tolerance_var: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness_feather: typing.Optional[builtins.str] = None,
    lightness_feather_var: typing.Optional[builtins.str] = None,
    lightness_tolerance: typing.Optional[builtins.str] = None,
    lightness_tolerance_var: typing.Optional[builtins.str] = None,
    saturation_feather: typing.Optional[builtins.str] = None,
    saturation_feather_var: typing.Optional[builtins.str] = None,
    saturation_tolerance: typing.Optional[builtins.str] = None,
    saturation_tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0f6a332f2ca169e02ab0aea68556f35f52e25a02caa720b9d2c08d6b38b3351f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fd390d7c076c766d680219b4276207efe66c06c1e959f92dd601cd0c823f68df(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f6347eca960571120423660dd617b328c3b668e77493a28cb61333c025a30297(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e7f7a55801eb041e838e52fa3cfd97e3f128ffa099e54a7acc4240444618350e(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__869aced8a098dfbc814afc8a7a3ba900d6c46e4d65c19dcf494bc262f9ce5428(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c6e4b0c472c2e2ccba4a3620e78856a4256516a6ff76840624c587afc20313b1(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeChromaKey]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7b9a69d200692d8249a1bdfc390978164ef3b8f589c4c802746cddc9c27062f6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__861375a66d011209f60fb279df3d8c7fc73367d83182e9471dc629492c5b5315(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2369193494a7794101b74297de372d7825ca1a31b5e8eb9dfb16d7d470559b39(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__376c82d35c1ed2614b94cbba3bf644ab5bdf4896c91f4a96560f77cb8df2a89f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__03529fb28961b4338807bf7c964def272fc0c43b10061a0a66ce930d574ca69b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__48221721720aefa4a7578eddacfa142c59161f344dd02556a1037d91efbe3a81(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3e7c822683d7d80bea2a763313c9534ce1e5ecb403ec85bfef7f461f8ac272fa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__221ffa40a47d13e928134322f26b45e670f03c24d54e45aa4a71ebb4e9b9f3ff(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dac716361f3581ab23561bdd8b53f0cc15dcdb50909cebac9a48b0ea3fec0e61(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c2992bf2f3a8703efa682e97179f243c381456a83614eb7ac5c749c23f027959(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__02f5bbb174267a44dd9d63c02bc96d8f921027850d74a37920975ba5fbce1196(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__723a0e0b6ca990533fdbfd9c850506563355404d53cd34e45e27e52435bbf063(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fad148cc2f585143132c34e6248c74686fc88a4bdf4d9a6aa84e8fafb0d02cfd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f5daa161b03d1b2bb1ebbf40c27389fcde17444251dd5725a68d385d8c3142b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__40e8b417dae01ad6c8ecbcbffc96d0f698ac593cb0fa540c238f9cac53638a44(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__980fe031d33e5d42bcf873157ec310285bb619e5c0d173cc07a4a58af225f24d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeChromaKey]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cb3ad5b5a74e67a11318fc4b1e82b653acb37d6a6c18badbef9a9f73962b6f4a(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeCompositeImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    placement: typing.Optional[builtins.str] = None,
    placement_var: typing.Optional[builtins.str] = None,
    scale: typing.Optional[builtins.str] = None,
    scale_dimension: typing.Optional[builtins.str] = None,
    scale_dimension_var: typing.Optional[builtins.str] = None,
    scale_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e286447ef32d0552602390f2ff1c2f123bf0afc1edd3fa445246a0312137b5a1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f98cfe4feb9678c85536f829281a6c40fd965f6326c97da150d96aadbe2d93ff(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeCompositeImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c1dcda11976dd4e8c8d17fc160452f52fadb654e60a062e14e93b641a8f5cb10(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a837547db0a6674606620a4db9c471330cabf07c63bf31e9f49155b9d7b25c4(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eab8834142552a988d85fee5a32f2d3cd067a11dc9d35d90107f04903be5d17c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__010776ca75840321c6e3398dd83e6b48e4ca5ded202fc788e187df2729b2878c(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d9f4e40f1f8a5b504c504c1206288f64878fd7d0dc576c6af16b89b3a142402a(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__272ba852269898ee05cf19cb3c6d8ea582b8a954a3dbb5e3d8938be4b55a2f63(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeComposite]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bd3890dbe291f8633bdc11c5c0eee07026161b1bf2c2de9ac00929313e6a67fd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d4a2049bef9eb707a6f901c00840e9bacb229887d3d246fbd8ee497ebf79f972(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e08cc0385b797a6f3c445236494471123b1767540e50e0144deb91c1d0d52188(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__428c4d9341921f89c33db0be009770cddbb9d9b4d8e6ccc1569d70dbc0417944(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a6ca0577122385f95a9ab9923aee090145ee2f6d10a356ebc10e60f577650140(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__63de7a64760b59849f1e59d1677747ed36ef77d50ca96e8c687c54dce2224b30(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5a9fcaedf6402176ceaa84f98aa287bf3d54b8469792e86d0f62195922dc0ac2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ec2fdc9ca37def3219817e8c48a4336f4a49965152cea3778c3cd03a1ca6acf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ab1faa8cfbedef13269db6ff08403070609cd3ee0447483c9dcba9254c2558c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a59d23275e2af124695f29e6b23b2735198a50cde567d54d7e599f9e21965aa1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3c4763773b800fe4bbad01f932125ea831977661b6ec09a08d1e87e05e861dfc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__465a5a8e7733265421f32304577832136e8de028dee2bdfc4352b5dff68d926d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__55c3980ed1df494f6f7bfa2e11e241d6c674b7612d5c9fb2a5a3b2d39a5f02e6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__92d0075686c03e0b9235d38c438102cb8ee098ed613da7d1aa9b4df413d2c69c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeComposite]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5bcac5fc1e63f8c38b3afae72f5776e611e84214b689273da517012967028044(
    *,
    transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__95511528dca0ded388fe5f404e1c8434106d991bf8181e14da5f8036807e8e3a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__204ed1403c3371a33bc52b47e2d9b0d4e1efd342778e2bc7b68ec1237d40bd6e(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0b4e5e8a1881e93de9547d668c9294b4bbb7d6be2aa108d27c6773ecfd066b43(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__85eba9358df58dfe1834d03676590f8d4aa4143073db69e1b239028f8f401dd5(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d5554e4e7970894c7f59ddf7238ed4a422c05802cd8c9f21a7a26f093a82c765(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0a186e426f6f1d0d18ba4938274a785c28ba646ce296f36bc59d0bca092c09fb(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeCompound]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ddbc9d3faefe90d5d83f9a7fc94a1a9d937821f418a5a650ce03068b0ea1208d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d1778eb16187c682f0ede46439508dc05eecd1295eac78a2a86cdc0ee8c1a87c(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4377a703a6e494bf4055203ffb770d95def445515491a5733f87173b2923048a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeCompound]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c747740a13e9a61434de2d323a0f1b33cb025caec9a21b9ccbb535a012578990(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3548819900991619589b6a839408a085e703229a2a9f61ead8822dcbf8ae268a(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__11f76fbfb34290a01d2250411082d902d5988e2b6c1b1aed3805c475dcc9d9c6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bce884813842af16bd9b638b700c55f31319815f26777c8ace27459a785d8d5b(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__69c71403dd4c2b59e3fd878478452e077f889431256c874c9df5206e1f89066c(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__51b70824c4f00bab7c96fc35d99670f851521b68b49467d1a465db0432cf5476(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeCompoundTransformations]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a5d385905257838f3d579080b544477d497b974ab6bcb50db7d3da1f3a8c1354(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__06a5d1f4ffdc5da4c618120fa87c8a06f6724086badfc72543f4671a3eec0dd4(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeCompoundTransformations]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f2310efe9af6265633bc79fcb5fb1498b8abf07d2fdfea0cdb04425dc90d3d10(
    *,
    brightness: typing.Optional[builtins.str] = None,
    brightness_var: typing.Optional[builtins.str] = None,
    contrast: typing.Optional[builtins.str] = None,
    contrast_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__67bfdd91d48edf84ead342ea2625ed857dbeb24f55438b1f96a595abf97d0d3f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__25c24772df037c6c93ebf2bf38c7c29e5a1de9abd04ebf2698d73d7e571ad5f5(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2e1104b090835896de6cd85d6358ff0c590e15dd20b21b93fc531e701e25a7eb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__98ade1af2ba89c0fb768acb99522bb09643f069a28824e2ad86ba0074e345f8a(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__238bd101b5a5465e86c2ed34f5f39ab39e0671d780644a135b8ebe437c9fa47e(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__40b310bfdc468c5241d644d232a4b00f88fd7f0b5d1195e93d59669ace3eda2b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeContrast]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__562146b8b66df224f77e9aec5890772d78d5f121d05102809609fd114103d764(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9c585e78c0753a1af5fb33911475c9d284edd25917a48e72a4f726648fb7596f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a0cef544db2a9bf8b0411dc19ea049d55b67b3255b523d0c1b744eaa4fe55cd0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3e2d7e8d695efb34b6a90113f7fe8130300cff9f75f8e300207af6c49cae11c8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__762c0afbe7ef4d8bd566164c5948915be08430535b1dae3a33569b78526dd951(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f2b76fd12545d33a5476bc020864204b8f385fc9b0c00ae984d076a268357a29(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeContrast]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6a0515800f48f0bace5cf3d25ff449bbc8623dba936881178c71ac1a860360a7(
    *,
    chaos: typing.Optional[builtins.str] = None,
    chaos_var: typing.Optional[builtins.str] = None,
    density: typing.Optional[builtins.str] = None,
    density_var: typing.Optional[builtins.str] = None,
    power: typing.Optional[builtins.str] = None,
    power_var: typing.Optional[builtins.str] = None,
    seed: typing.Optional[builtins.str] = None,
    seed_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eb6c4c239759648fc2b3896f28acf413a2f01c37a56508b57f49265af9b0f51a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__59ca8bd85477a805f2d9a7f9e086cf1b477074fa11c6a957bc0f56fd24a9c438(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d1233fc287f35e74c4ae4f2dbe0e9ea46ae4e6d5f827c09c80e649bec32ca422(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__18978ad22147480dfb3c265a284affe10199143f50c32190fd567692ef2fd13b(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__66b6b6b32990354613b8e1145cdc2842ba416f2b7b642cc76645c0100780b0f3(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0de9cfc3cdb71bbec7e3ac528b9bf0d771c56e77d1d0857175ae0e418a39aa80(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeGoop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__46ed9ec006f04bfc99eafc4cd6ac74cb6ce55b4c19d10316d5521721db1178c6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f777396e16d7bd2f023ddd4c843a21f1cfab15be89991d1c73e8dd0cfdd887e6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea2c63c2b8a54fe917a4c9a621b063f38497cb5032333a67cc8f5524e5fdf356(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0b666aa0e84c7055bda39666f165b42000fa21c480fea4abf4a9ba295348a95a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0b7408776eb49c22e1e5c511f602697ec96936a8ead90559cbab38a0b6ee24a4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__166b40b527cf7dbd9ddcb8943e3905cb8294c08fae2354aa64a9794bc3cf1237(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1fcd2191788c4514967bb5d34a7fdf763c5c16a81fd7448f93539f76f8d5280a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__efee4dfa18949d33fdfd1a77ae5bb2fb6deefb4e2490957899f19b2b2be760e5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__515d71ec7f0cb202ba031f31a4a85e14ead1643f29ffee2a710977b937e90454(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3c797628ee0a8fc1d4fea12731c334fa1f9a474df4fe51f6e2423b7a9d3f3775(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeGoop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c20091bc57ec0554b0ffd4134d7f0c1882cba4032ab35c44f30d43093350fbdd(
    *,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__623f2100f7ffed09bad87f29fab7cf0dc7c6e6bfa37f76652801ea4dc2ac13bf(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ba523b8285c2200d38fe74e0d595ce65aeb8ba76611156f841342bf1301478b6(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a5e5dfcc8a8ace3672f8dccf9bb1bfb7bb4b6b8cdd4e51d244d902272d1986a7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3db9a3b22bed0ac9556d5ec77d7f012194731e88a6a16211c1cf829b53936587(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__22e06014e43e8ae4489e2ff2fa4c308a23708eeeee79274f35df86edacabffca(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__17a367406cde642052ebee2fa43cab624c5957b71118d07ea625ebc8baf3bf13(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeGrayscale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__02126000fd0299153ca11a0dd99a99f5fbe40f52aacf7e4e9c683c237fadf9c3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4de1a69915d385d672fe884ef1f8e918f90a5e2cde70b3c1e36522cf8d584bd7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__de58ced230f184865a8acc9f63d881befceb7158cf9bedba6abad39aca32219d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3c34b10ff9c29a24b8b520529c137221f780fbc26b51f4fcbe9223762b71ffec(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeGrayscale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6cd9fb3ecf5059bac134c26c381f10d0dfc8a981bd03d76eb7ff8657ffe7a55d(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness: typing.Optional[builtins.str] = None,
    lightness_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__446b0d104f548fed95ca4b8d01ce513cbba25590ba210da3706414e62afc729b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cee9556155865cec7d55cba4b8df6fd9b691e8c2fd1ec4e61f9ca2f625657e05(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__29de40a7c532373566b34eb88905fca7973ab43e3e469e4410a8132e938e789c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ee8e41bdab999b579b33c2721f080d71f5d3ebbc94948a0761bece197112ed6a(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2844ca33a0656fd90badf9cf2b3eb7a70fa3d514b43bb69b82e52a16e686350b(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__04e4ab2e3766ede347236a36f8d6a90762378d90414781717066d48245934dd3(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeHsl]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eb2ec2f59ea2625ac08c517dee5049d5927b5d6a566cc81f96e6385586c86708(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e9783d00bdceb9e5bd2623e1921480a050c8e7742559ed179ec264b6f5f5cab6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e9d0fcb2c1bef8618eaa886476f18c69b8223c3ff1fb0a0d3986df926851535b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5c181cd3f9a05821fbf9cb29c1e61e9d728b567483bf8f4de9210c8a61f812a0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__157380475dcca79fb39b6a1c9b2eced72d20d213d6166468af55d279ce7f855a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1930165c2d7fff938d2ceb1a66899e141c6cd919db0fa0438304425474313427(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f07e9303893d8af1eb4239cb860422ac1424908c2f4caf798c62d44aa1756328(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1ae6bcc7edf25ca385094c3a97d11fce5ee649da81f38e5832b0ba979ea88353(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeHsl]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eb7eb761ae13115b0e7c051fb0cce4b1493cf3911d3da5d282c3683dd224f989(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e4165ee6960f6e21a4f8fd4f8c1c7f574b83198d5eada64810c8efef7a94ea18(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0c43154c1ac1a2647cd00514247ab3869b814d2c9f48a4a70e8a7aeebb9165d7(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2f1c4790a7a279439794c42d623816e66daaecc232e5786d084400adce91f933(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0b2feee3b646161256dc4d50a4706bd962a8ba64aaf9343d02ff76ffd8b5c693(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bdce612c8e299eec7fb435c0074fb62b5a0e25efc2f2f38867053a610bc010d9(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b8aba88f77c8453db76151db485bb3c9528cf61132585396bc59e8fbfd252f80(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeHsv]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8f556ce2a4b356da3d53efa31eba2beced6fc3e035c99eaac0c7f855ee3b7468(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__79fd5ca50ed6c42bc4279937068b13ed11aba8e232ff6c897dfe5635bff403df(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1202e3fd21cfa1d236fa2b76cd28968ef0a6275b12fd08ec2be0e49b689afc8b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__37bf6b09c55e6d7846d3f48a381ecda51c3b764b2b3f1e3fda551c68f8a3d83f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__36ca551b60e74275e492d049dcdc5e54d2a62ebfdfd44fec6e51c63405dc5814(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a1aba3c5efa1a8cf550e4aae9db4f5dbe9a9c98ea16d066eddc985db6cff5bc5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e64330a6d880017ed4014aefecb81b7311cd74d149cc88e57171c228140f6cad(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f8a3e205cd7608c8648a0ca36c83e27bbc2957b1dc163f69dbfc4d4c96c950d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeHsv]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ddb91b76696b1d5e46e81e071027fe6fc0a5cb7c384c125896328f8e89f3661(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    dimension: typing.Optional[builtins.str] = None,
    dimension_var: typing.Optional[builtins.str] = None,
    equal: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionEqual, typing.Dict[builtins.str, typing.Any]]] = None,
    greater_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionGreaterThan, typing.Dict[builtins.str, typing.Any]]] = None,
    less_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionLessThan, typing.Dict[builtins.str, typing.Any]]] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4fde8c547ea14a1df22c32f5e556fb987551b991f0e772d2744bb37e45d20f3d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f68ed68f3ce10fedc684b4d305a77399f1f40964be3be80cb2c5b0e78debdcc8(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1b3860335fbe9662c679a962e3e68a10d75958ddaa41a6d6d22b52369e607de1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c08caa9f8643025fb57a1087127db77832d72b96649f8a365defe4763bcf5ca7(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionEqual],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a11ebad0c22cbe2a9ad60376dde814c77d805faec51bd60fbec115a212eb7a8b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a238046f73be62c82a11e347d5377255c4dd60f9e24118934ebefebb2d6c12d(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionGreaterThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0c2e838b1bbb59b7d93c75bef65b7bb2a82430ee228186e26aa5c0bb96c9639c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__00537ab34b2e6071adfd224e3f0b628eb3dd09563398aac337fd6d88b18777b1(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfDimensionLessThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__199ff0e3b43160ce3c08b07f9bddb45469bd47de4442ab2a8fa362b711a704ae(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__76fd314cc11a425840034c5005811782b9c28e67bf73754759d02260724f669b(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__584ad30295d854736b2113334767d1eff0e76fc002d99c0b8022d65cb75b6bbe(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__847834bec73ee7f07b1be75c61fef8f9c8a7e3e344188cdce879263d66035576(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4e5872b179119ddb226b9b73e17fb21e7ac740eb75ccfa9265093fdd45958d6d(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7c2bee37accf2495f1c48e3e92341597ccee92f5defd59fbdd6ff44fb0339082(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfDimension]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dbe22dfd4df0b3bcce738d77c8925d18dfab3c21534e1effba1f73ab00bd5054(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8cda70d3efa1914626c6cb4408ec06a649772d5f3cad4466aef7e28457456097(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6bc814b9e0de99e1751a23292bd47a5aba142d5973cc0c82b5d6ea4018b38de5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e21aaa12eb143ca557793b2415abdf1313a0917bf84210d544b53435963a8a04(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bcb8b1b0519ce19ccaddc3c3babfc722ae17ac4fbd99ceb2e1fde1d67e4be7ee(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5a5ada8f5a948b1e1aabc63940fb538886354e1868a66c8d17c3d5647b4eba48(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfDimension]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c3690ba46634684f8b1367feacfbf0f09e07afaf25d2e03810d8663f6a126c03(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    landscape: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationLandscape, typing.Dict[builtins.str, typing.Any]]] = None,
    portrait: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationPortrait, typing.Dict[builtins.str, typing.Any]]] = None,
    square: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationSquare, typing.Dict[builtins.str, typing.Any]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__24598978bf639970e433485c0ea7a0212656cca93d107ea286dc902ff11be401(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b08f8f4e465a57e92f3b9013c49d306b25ab06b77097443afc9ad5e6fcef12ac(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4b729efe34954cee48e9e9f064735a6a54492c97167f777f4b4d9d9ce962c473(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c10a1897639d32535672625b340cb0b3c6d3a10ad1ae82ae2bb2a76104d3db39(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationLandscape],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__989f5a4e0b1e7aa98288add0048d7025f429051832577d965252165e7022dc94(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5d60825f171bcf161f5bf6473eb026cff26524f321460bbd23f90ebd19adb9c1(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6c37ac526721d5fa1d4752cb99a2a2c740b9ae95362fb40d7443045ddf8b122f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__52e73f0b2e1f7480b980b0b7ebc4d324e81c38863d44affeb2bf883014ee0d87(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e07182835c87635d7c8b2808d94dcf459f0e248f72b8f246be86e7f7007f8af6(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__700d0420cbe60060d8ecdea00895ecff6efd381447c1508d6bad202ef67ef9fb(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientation]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a84bdbb27326cc8371b4087d0875ea2473ef1306b1893fa471a18e9a3ce923e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1396e540b829791186a4131369fd5cdd9bf6257919644dc688d6d5d51d0c9968(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientation]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9529783b53bc37a0fe01e2648ca1d9ee040373eab41a773ee084a5c49c7b6dcc(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__320842865cf6a4f79205e8f6bda6b5286a4f4f94780a2d8f6e637384b4c9543f(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationPortrait],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4eb2a02ee2afe5694010216f9a039fdd965597029c58151fbff0acb66e5045b1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c98e7f858f5fa9e88d8395acce291b1102611a2a09e500145eb7e9d127645347(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientationSquare],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7cdab73f76e602ec2d84fc0648558f66f83ed646927e5235151e9ef07e6796f0(
    *,
    colors: typing.Optional[builtins.str] = None,
    colors_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__791accb2f2b83969239fe180f802117fc70794e806ff1933744d956c30baf744(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ffce9468286ff9e8c0a43cdab61e866574748879c6187825762667fe14f3604(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__53cbebe224f83bdea25d0e2118a6f73a074868985c200cebc2572bfa41d5e94f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__21bbc71478dee7af212ecbeb6a4131d94d14633f1151c97238fede842acd95d0(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c858ebe6e1ac776711149daf37e860a12e16969dc7c66a8899186d510ab46221(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f6d884433ad6878fc8349ac60ee3c91fa5384e767d8e2d3413e583431075c2d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeMaxColors]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__33250c72580ecc926793ac01bd3ca13979abf621f502892b144eca4ea02e860c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__90dd7f6e986f0fd61fe2e46946a6e84ad9fce9806f4cf38531366992ccb24f3a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__342201168220fc7f6fcef25f125be038ff04da1c22e55891f9d6489481794541(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d3a8533d5ff87d3293038198054bd813a5bbb22427a4456aecc770e832374702(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeMaxColors]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__290d4676db48c583447275074363015874920dcd3e13067abb332be7683f14f1(
    *,
    horizontal: typing.Optional[builtins.str] = None,
    horizontal_var: typing.Optional[builtins.str] = None,
    vertical: typing.Optional[builtins.str] = None,
    vertical_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__19ed4b5bb8c1ff7aea2059efcb20d2c533573d6bae28e4319cd83b46681bd7bb(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b5b2cdc8a251bcc0134194fd5179f3887f29ef0eed9e4c7773bf1bc419544de1(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3e153125658fd0a6b8c7ddf21e788318b0fb66deb0e11fb72bb915982e9ab43e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__239a508394761ba769231f8105735ed245839c71384df1d4a373313f5a7bf122(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5dc63dcbd8180b371c29afc0bc9cda1af49561408061444be177fcdd67e1dcd6(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__983b48182b202f93637495e0e0754a76364a46bbbccd7536bcad461507cc3302(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeMirror]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__78e896a9a888a9dce0b070194f3e0e8f64e97926b943877b234d0bdef793d8e8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bcc709f96eb89831b2c35141194e19f31c7ba1504cd5f7041e1787077df4e885(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d5d71650e85d62deb3c8856dfb29a19bd242b9eb608b7afd1fcb9c25a47c7b24(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7366a958deea516028f6bf36e9111ea2f2b161d59e015180c04388057e0a0974(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__14781c1b8149bfc2df084366acb6b379210933ab017c71d63d23b7840630f8a5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3b7d6dd819b3e1db4866359c2b96c15e92cfe6e6c77befd2bf4877ea7a41f769(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeMirror]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a31e4217c4bd1a7efe7b83f739e4f95c848685dc3098094d1c1063563af65bcc(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2c259e37f9479cb9fc812ef89c9f8023c007b57e5a3bf634f5c80026edb97cd2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2e1bf61ea68b855ea4170054c5264ae135c3e623d6d7dd3fb6cb1d9cb72b050d(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df6b8d954d434bf7008dd7f69dfea534997eece3467ef4052970408b19bc47d2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6cd5e4b71931ead0e179b54bcfec00229077bf5db4c4c9eaaf30414024442de4(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__21244e27821d1a11f01eaa002d74292c7b33f48f13c7fa99712dc6bda909d3d1(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__81fae01dbd969c8e0708f36477fbb8eb6c8520833ef23913bb18b4cfa2aa92d7(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeMonoHue]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a8bf77c3b840498f9ee1c9ae60fea4c8d7726dab73cb3c6dbbdd398730655df4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fc29959d134c49f871eeb8a3e0ad85ad6d52ae1a4c3780bb96af5810734cce7e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7f3c1778c51835d47f2717114ce8a9a1656c58ce933e02c076a76237532a3522(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4172aa4662f6eb5773772bb4688f410f06dc65c3e64319ea765ab2bf57390058(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeMonoHue]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__50b5fdbc77598d9d0f7fb8379cdad619196e8e58818309df37221296883299b6(
    *,
    opacity: typing.Optional[builtins.str] = None,
    opacity_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc64e87686a306b07525a10a26f00efb73433a0bce705c7744550eac97056d2a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__996f3ce719ae4bacf94a6c874d346410c5af67dbfac8dcaef0603fc7c2417d3b(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e8566ca62c45b8327b2fdbb75b6274205867e5f750a3502ec6f1aa4aacb943ec(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4f1da102073b2106a02763c9928c0902548145a394b643103d0aac7cce6324d0(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a295bad4a960bac9f7791ceb765ad884c4ca4934776877e15b2705619b9d886c(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__248e3d8879189762911ed9f55fadb653baaa494a6e990b85fdf5e09cceb814f4(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeOpacity]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__76c4cd924ab661126d47f302d15b65e33dd338e5361b2507153aa23e5869138d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__848ca4212dd06845c0681189a1afc4b02e5992e6fc283ec64e72ad04920d73a6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a4539df99c2fc43ddc2c9e016b4d6872be18b4a4b1a90a4c13d094e76214d443(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__622b53ddbec5acb0c6e20562293bf23a9ffcd091896cfbe1fcd5201990928e8d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeOpacity]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__73927c6f7414511b1ea0e917d147c6af9ff87a3da469dbfbca296db890f2a6c1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9f3f77339b59cd4cecc9986b958cd394112ea4fe23924861383a0ff91aa4eb64(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__197f9767ee26770b78b4e6dfc884f3e9bfe161bfc0393e653c930d46dc215273(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeBlur, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__62299027a598b5180bc1f6802ea2970d42cd54717000ec76cde07dea1f5af8b5(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeChromaKey, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2cd49588d764237fae4c6c89d7d63d1b2fe6966a9f68e38a78ddb48414ded339(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeComposite, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__077ac0e2afad344917ba2f981ee3010f486a660b98b7133f568506ae0889180e(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeCompound, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3e51433de9795104d1e008851b2969ceda71f37da5e9811aa8143432ac61eed8(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeContrast, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__385eba9afc0f93941a08c837e12e7e4d2e3d595f918e1b8eb3c99a5f64a362b5(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeGoop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e607f84aca765fcf28b8c808e2e774db1f605901a97477947ea347de9bf1826b(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeGrayscale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5c6392782512097ffbbee6eefcff20c89e371c633920d9a4f308713885e87014(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeHsl, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b8a7586e612db211d413e95095d5f6e585827101509a2982462785f07fd4f7a4(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeHsv, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b25b5dc866e254bb92b2767d64f140ea5226f16fdee0e86d68972dfeb794d570(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfDimension, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ad5f69c5b8884f9e6242537bc731358f9add8040b6aca23722213e7d21c7b52c(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bf4b82728609d499ed38d1d3ed8bd84c38b4a8d44b81dde46e8b3e63501d377c(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeMaxColors, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af960875a411318416189a65864ef688a7bab9bcf83ccc24a8887712d175a468(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeMirror, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__285677527ec60e85ac325230b544e4e4376bfac98acb0ad28478586e23420952(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeMonoHue, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d0bdd4361b2e5a4d14f7acfe32c1e926d1724023014b3d60d9231252dd29bb7f(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeOpacity, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b9b48393a016acaf2ac1f1a6ba8333108d7d3b5fd61bd35813e844097ff9eccb(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeRemoveColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f778fe74eb25e68379fd237665960e3d5f724baab9187225273293d65ca10bae(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeUnsharpMask, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d4f746dd4508ce99e0946623c07b304049681d1710f84bba2df29319d53e56ca(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscape],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ec4410d792bac2b68a438f9fc77263b1a2a6b18e986ea09a8b4650b33b9681cf(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
    feather: typing.Optional[builtins.str] = None,
    feather_var: typing.Optional[builtins.str] = None,
    tolerance: typing.Optional[builtins.str] = None,
    tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__27f37a6ddf9213f3d90e8b01cc750527a9c78498efafb90db8b6b8ccd7366860(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a4e2c33087a71a2ee0f772cdf907d307331722058fd1baf055fe12551f5a17c(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__61145387b279cb288b18d3990e25cbdefa337e9adda4472f9fb5c6734299d78e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__edc0d4dd388c30cc6289c66bca0c530297f595ec42d73661d81e9b0dcfc55aff(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__27e22b69faf320302fe49579a427ac3f1baeea29d1d1fede4b93227c4d579c5c(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__985bf68085a3b6f3a7723aca09a6972b2c10a4cb37bfbb44c9d3a54a52fc4bdb(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeRemoveColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e659f2b1df43ca65fdceff374aca6dc85fa814cbb0280f2391dcc47633ae8167(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d661b2df8e1aa57b9fcb4907f68524d65dc8bbab03306813902e80e527f4db03(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__225359840b48e64db097e4f4d4fbcc611ac8aa8198f2caf2db6ec68716cac932(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__594ca233893f65c4e421b3d55c2566ef95f3f49492b55a00ac10a9c93c421dc4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3bdf2806af739532fc7cbb111a76f71bf1f498eb70a5a591443276c1f3da7250(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d26e8d252cacd13d5b9766d2b411b410ec4582ce73a3a16b0aa57070ca4ac208(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eecc81d5df4e3f4e9b4de13c1c05042a2e054680921b451fd8d5266998d4cb38(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__86a46e51e56f3eac6c3444f157b71f718e515caf54d251049b28bb5b3849d8b9(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeRemoveColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__64e69820bddbf061db769c3b54db34ed030e194702721baa3d334e6cb5989145(
    *,
    gain: typing.Optional[builtins.str] = None,
    gain_var: typing.Optional[builtins.str] = None,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
    threshold: typing.Optional[builtins.str] = None,
    threshold_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dc98f75e956cad08aed1528c43dbe17b3b0b461a95583f9bb10a9348786cdad0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__58617eaf0a12adabf85532abaa1dc192cbcf21b5e039d7a9ad0d06bf7cf19521(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__17deb46b224367eb4ffda6ba771a0e7b72adaefe65151aad17f99619267aeb7d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__39f5eab435701eaf312377f8ba33e23febb4ff3454a89d483ef6986e0322cfb5(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0850764cbcbe3a1f0005e8cad02e1f384a2a5ec3b65d55918df0718ef166a0d9(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b35621889e24a9bf05831acdeba4107081163a32fa9cea92a80668b2a7497212(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeUnsharpMask]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bd0dcf5485f0d60e250d95b9381bbf0c8f9f67b0ab02c1ea9befde6ff93cfdd8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d38c6039ba354f6ef800aee5831b4561c5773e5be755d70547e7fc23000224e0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__05d6e7795225d434acb0d43579157d0330fe6cc4bb900ec5263ef21d4537fa8e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__93140e14a30e43ebb3fe3f4e720279a3479bc9a3c9a40734099fc613b19a4b40(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__238f27117c927859808800b61a8fe8d52a226203cc7249bc651db15938421157(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__667839165b8e128a863f6b67acff214cd0643b85326255cf8f74280e86f16a8f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0b470c27dfb34a04dee63942b93ec236d53673de1059cdd2debc09ecd2ca178f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f8f1b4806f14a06120edb412d255ce92d146d8a7130eb69a0c4dd82589fcaea5(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationLandscapeUnsharpMask]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c8a988d923e3f7479e3aa1975482b13672eb1939fbb531cb18b7e65d29f963a0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4795e5fa9739ef7777ff38790f44c58b32cfbcfc9c0c0fb6b70099da76557222(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__70f76dea056c7558ee878907af24e241f320e4780539308136f6beda41996a2a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__518937602253b8bf1bacc270edf367c0f7ef6b54f91712d294a414e9028cb8ee(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f598e503dd5b3f1c589b5752d310b7115fd84d1dfe337c8cdc6787ee70bc032e(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f64114c77d22e86703c3b85620e69a810d56fc6346302b2e3c7d0a25cad8ebbe(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientation]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7afd206b56af1ae18234b5e70ecead3ab32ca771194c129d0317e2c2200c8450(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2588fda5fdf40fb0d93d4eec0829195ec9214c6cbff0b5064e994a93f34deb13(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientation]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__129d83de3c91312d2266a343e0303a4e5b1b76fb4bad3222938f815d696db518(
    *,
    background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
    chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
    composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
    compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
    contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
    goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
    max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
    opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
    remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0b922de4cf8100e5144f994c3f62de1f057c36b04be8b9f6391e5d0b5feda417(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3fbad16c3cac65e6f2b2d08676aa2c843e6074e57bb51331fc5c78084384e35f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dccc0132ca9068d4eb4c0cdc88f1e6bccecb17dbac1b802095906c36e3b4b049(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1aa26e372a49025e7fcfa2f45d8e8b128dfe3b4ac715679b81a127a6436a8957(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a37504d5a70578d00939de340d33b27707b43382d9fa5f2777719ffe3b1a2aab(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2f0a08a2908f3342ccf771eb8c6c5f06cffb9770325422fef376d52d0a9f283b(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__389e7692e32fb1f8c5d0b34589d468799458df281abd6ed2b2872d04eebe45e7(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitBackgroundColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e7f095946f9ef27cf50bbe78d612ec87d46bc87cca0cc297bfe69c1c02915a8d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__056e405b25fba6741b05f272c1693d14e897c03f98f2e7e50804bdcba7fb028a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5bab6318004e30115aa4203690e84d3590024eefb6b77e531219db1b07e60528(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__00f8b51cce579e3c72903856afee18f11c894997fb0b2557fa24fc7a480c123d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitBackgroundColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__092e983e7d603b840eb7478ee2f69bc098711e152eec2dbd5eb5fcc04dbed7ad(
    *,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a86f8e8b7c651d9469a30de5600f8aefe81efa8867a0e37c0f9fb1a8788d13a5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2841f8741d0f637f2ec42dfd2887c43eeec60537bc4a81497e0da7080460f487(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7581c4cd1d4589f5f211ee71fda73313adae47afb57240824ad5e085efc6b24a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__83b6aba6c1d881a30d8622e4c2e49ade9c515ba3051c280e1b52a4273dacfe79(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__23f9b26b3b0e641cb7cdc481e6e9490f3c0426bc1462b5ac14c65e62b26a258f(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fd94d857c7aa92daa604f6a230484c1b4db8ec022462b8652ff5bd5bfd95c6b2(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitBlur]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7f881acb2728f79999d08577d1341b16c618e98f077c34125ea8d95ad6914252(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__36c195c422429e6a1d137ce8c2bae4dc7c477a65ceb49965540969a11cc33fa1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__959e0bdac9c5794792f7250fe7a034f65ce322fa219e1da01232b2b7c0dad1c9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7e41bc15f6efcb2c4ee687526e46e1b460be313eeaa1305cbad5ec9de8f532a4(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitBlur]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__56b52e3ec699d6b33d7ec89d7a6a9455caec565d635cd33827a059c17cc28016(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_feather: typing.Optional[builtins.str] = None,
    hue_feather_var: typing.Optional[builtins.str] = None,
    hue_tolerance: typing.Optional[builtins.str] = None,
    hue_tolerance_var: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness_feather: typing.Optional[builtins.str] = None,
    lightness_feather_var: typing.Optional[builtins.str] = None,
    lightness_tolerance: typing.Optional[builtins.str] = None,
    lightness_tolerance_var: typing.Optional[builtins.str] = None,
    saturation_feather: typing.Optional[builtins.str] = None,
    saturation_feather_var: typing.Optional[builtins.str] = None,
    saturation_tolerance: typing.Optional[builtins.str] = None,
    saturation_tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3bb82022ad410fa7409376f87fe29cbc6332d642643670222777e3a84a4bb7f3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ac16e37132330b089af3f915b0d4bd13f76188b112eaa3eca03fcebd689691d(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc1dbf5b0795dfc68d343a517027d771eba5ab9a4ec9d7f778c5d8438428f48f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__11509e8ad3d01a7ac5e8317c969db41f0e540b64fb50eff1dcc4a72b3b846996(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7c79c844e0131dd82ec1034ca76502ddadebd675502f5d1dc518b0d518c01555(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e3a36cc6f396fad49996e0a7dee83968a9e43650e7a144cbaf79f5cb989bf4f9(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitChromaKey]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a1ae7c30afd1a0b0a9655bff4dc9999717a09bbb86bd97ddcb394559cd4e505a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d27cd764ec8b89ce57c72f86165f60492506368ca22b7ca9b8e1256cab33a965(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__67a834d8825ac4fb741d84a254f15ae618705c4a25d7fdae2489f8821a68dec6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__80049f49b1786d2230ae3b6bc91d232c95436b28a74e2f67038466826c154223(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__75abc6b609c423aa91dbe19ab6ad506b351f8519a495a2dd05621d58a196ced0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0edc7c3d170b37e314300927064c009b9f90ca91a1513be1c92d2cbfa979a712(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d6af28e55064f0b065c759381ab76124b9701de78549b8995dc12ed13c51c63b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__da6a4b83e997d3ecbcfc03ef57c88f3af7833126ca1ea331f3d022677bb15244(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__19a504f22a58e4e4661c745d64250fb75595bf92b291dd57a3366eefd417c5dd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a504f75ab344f95ccfa48ccfe95a25d4a3cbda96740c3baf6f20102408a7ab1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2185f349aa6e6dbc7335f6ed1dbda4398b7c9b697fb573d62d2e3e6ef256d816(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__996ef16768c0d0ed60aab0c8f452e0d2137ff7f24162902d6510b4ad63adc785(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__95186010c94f038e9e6bc55cb112da1622b026125a29d344d860e0a42e8c9c22(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__92742209cbed61b99a5b017faba7618e67c229ec67990e1c1f494aff764434a6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4d5af003ae8412c4dab85d96b1db046ba07dc6602da3690151b647d40e1d861a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e5f7773521a963ed0b0b3a321152a4d9e21cca8d8783ec21e3c2ef81c20abb5a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitChromaKey]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ee899f073d750dbc49153fd192c110b78c60d930fc16ae237ac4c59971da75f(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitCompositeImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    placement: typing.Optional[builtins.str] = None,
    placement_var: typing.Optional[builtins.str] = None,
    scale: typing.Optional[builtins.str] = None,
    scale_dimension: typing.Optional[builtins.str] = None,
    scale_dimension_var: typing.Optional[builtins.str] = None,
    scale_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__78d0db1b2b1bd050248c22b6cea8d965ce8f792d047a98bd9b9ad33be46f543a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5c33819dcf1715bc470fada990ef3710459b0b3b35a6275fac8c2d9cc3b45c7f(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitCompositeImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b49b44df1991c62162788985e5c904aba2fb888d000b8088d8ae5b1dd8584e31(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__573583115a10003de260e65d4910d96dbbe0f172b7a9c54c546c484ffd784a38(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5d915273b8ab92b8c2ccd761d69a84ed1d584c07117ee48de3ae3e44e92bf70a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__15efc3e4f9939c186e7f8e2f95c907e53ff97f40bc3ae386867dba0fa4831f4c(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__891f0c14cf6ac3121287007b577663a422a682762831e85ce1ad8fab5b1f9edf(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c63455d8637d30657214fe96647ec017fbc434b6dae09cbb578f31f3000c6de4(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitComposite]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6fab967669bb3a5608cee397cc116b89f553da6ada184d3dc8dfeeb394f2cc57(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__58598ae3b97f76383a00d149d07427c7f0a7b6a23fdbb8e3a29577284f39f89a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cdd1e0148f0ac05b030a34c2206ec0f70625ea4ff802681e69785e0a186c3413(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__79e15cb1e241c21cff4776697aa1300040a40fc95f1b7c0e4aec6f56d6e860b3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f5d6083cbd9cfcae82158d2a41ac6f4e50cfad8b51196a6ee1f4f20958c1b879(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8478911fae1b288fb348f1f77ca2fc5b99d66efb92f736372ac9a8913c9df886(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5e5d30c1e38c0182cc3a4f15d18318eed2192325ae64434e1ac4dbfa669809d0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__692992e1e3b0e62a4b5e18a9a2e23d7b2ab011bb5ddfe3ff0e3b15f07da4212a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aaa33f6aab2c4ac8dab03857d92191e4384709fd2dc621c7f5f4ab783ad9deea(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac24bfdbf83140c862824f76ccc396fa7ecebc3f20be75887153e0c50dd936af(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__557cd5e4887c0c64bf136c536be84b6222712eaf92c50c2c616e0ce775c4854c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e45a7ae70d3b9233b69f78d5203f15c3f82303fc8971a1ec0a245ca03d8ca9fa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fbcef9387d619ef41931b07cb28c2b4aebe7c9d4399eec7d1d48b1b70394476f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e73441df6a5dce04cd13c951d88e13fc8a226c8026ab0600517f0376c93e9a74(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitComposite]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__94d684facc77d0d4eac5ea73e58106b29e6af3e38874d4219151af563d1b52c0(
    *,
    transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fe49769948aee69d1266acf49e7166398936e22e2a133ec5820969a3847be13c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ce8b2caab2fdfdf844220b5c5be0fa1ccae90908957dd3f9a1efa46a29d3a159(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7c41602209e12bc760831f869e25a1d6c6670bab1a4e9748ed0553f3eeeba3fd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c27cdfbf3faf7026d7f5eff9644a5e9d680c5b2df5560be7cc4c0b8330d82c2f(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__24cb90e66de564af238d3f07392686354387c366be17d3c6bb134215483e1339(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7dbfeca2d6a2e1f51527c750c49362445e8142b1df5e859b7a426fa2b109065b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitCompound]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e1e2dd9b972ae933b5d17519c8135b9fabb304955a2baed78f3f33726fd744ba(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a939fd3de5a0b397806af104659abe04b4a8558225c97484e6c2644d1999913(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__93305cc8430001cad06c2fc0faab11eb0d2c3b2be85b58ef1d97e395cc33ab06(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitCompound]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3f597c1ebb949377af61427f3068a2b0e8d10ccbda207cbf99437433d538ec15(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ff9f1b8dd5772a7bf71eb77c2b6611a8c825988d4b9a4699fca59c7b48c604b7(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aed2c0f91ced8b5b55f15f535fc0a846be377f983ac3ae1b5ce30802d182790a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cabb75d90c4d54e1199fc14d9fa33a8ed18766818cf56ca8ed854bef4d21c1b6(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5e4147288469e064e775f207b6873aa26f861307317491fd920d00df87ac45f1(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__55c50b042efdd6177c68d7f0b908ee166b2fc3b76250d9723c14edc8ad74c43a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitCompoundTransformations]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__963108a4a60a1747f012bcc12ab9b93a47f0fc20f5541d0db47501c69ce15bd6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__949da8a69cb71e748dd4eeafe5cf747c90609b3ff44191c0b42241a2ac533715(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitCompoundTransformations]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c911bcec5662e3800a8689d9f57f6978a086a7064bd9edccf5c088c26d7775b3(
    *,
    brightness: typing.Optional[builtins.str] = None,
    brightness_var: typing.Optional[builtins.str] = None,
    contrast: typing.Optional[builtins.str] = None,
    contrast_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__38fc3004090a16b92c5d8ab5fc42a9c834de139470bca76598532e103575ef59(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__30855af6299253832652a25bdff35ba05ee78d3e0341f22672aa9dcff75872af(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aa785e1be8c9c9d0e54574b77566d1eb2df32b0dd352a9b9525b046dcaf986a5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__229e72b6053d783640e97ed3d8da6e14459ea0e4a99b174ea8ae4e558e62999e(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a85cd0deabbc17e0a2a1c0daf97bfc722aafe3ab602c0b740f69c682af545213(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__51933e38cbbefa9e16c45b4dc77d7cb89c6e4976a339bc14f16c9e424f0c8595(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitContrast]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__361ec59884815b53f1fd64eff0c942e160327e8cafb3c2969283bffe36508daf(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5d3f99cab24600a58b00faa64ffb0b5ff352737fd9c127ce7212f2cf46616cb2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__465d6c6d254626f856176dc976ef3d75c6ac765b4c041ee435d9271bd861b5fc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a857edaa13ab50fd301969cc473f08a6b0f545bae6a84e5d98c95802669fa1a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e15760789d6cf44735a6e38d1d51346a39bee9d279407b2a0f31d19aec3bfc47(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5e1a21f7c006f70f8639c04930b180e1e79736d9851334f02fdf41707195f0ff(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitContrast]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__04c7aeb1cdf6636173338024add50d0110b24d972bf858f1b0854e37e211ba83(
    *,
    chaos: typing.Optional[builtins.str] = None,
    chaos_var: typing.Optional[builtins.str] = None,
    density: typing.Optional[builtins.str] = None,
    density_var: typing.Optional[builtins.str] = None,
    power: typing.Optional[builtins.str] = None,
    power_var: typing.Optional[builtins.str] = None,
    seed: typing.Optional[builtins.str] = None,
    seed_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__74542729bbf8fc59f17e8a1d2a916fac72e2ac588dab1e90509e57966c0a4714(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b8d7b22cbac1b39cf23ce2ebc217a95decfaea39d76521719d8ba3b0f658df6c(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c291748d485dd97c7bb07fbfc2ffd76702f35231842a1669900c371a9adf60b5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7ece4b930792b70b00fab512a93772bd5c52730f689ca30d47865eca3886b5a8(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f4c182fc4c15e90c790314256a0efa1c0fd40ce0abd9b20f778af015cab36336(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a12f2e7b2561e008277c23f16ac57721bc541b87825c65bcc321eac34fad2afe(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitGoop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a75fccaf0b64bf517471f5d500192c58bb2554458ae5e3f5cb90a70d3fe593d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__06af2f89306268b8067c6269786993720efb833daa338860dd8b10a67f96e9b7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b0b369f0a0796a4ebadf797242df4b72c777bcc526f573cf2175a246a1b31f33(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f1c9eec40018fd992e7c914f1b3f511841fdc21d00bf73560c62e464a83d9d47(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__134dfb2bd3368b623c093f28e1dbc1f6eca1a4a2eb20f5ad2fa4842e29b05bcc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d202159a274d2b4f9971af43dc8c4d607f00c48bc4252e4d31558cf32ca7b09a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__30ac672141fe410f28599011753b28ee8beee85208d5fda66a9ff13080e1b4f8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dd16fb28b161ca3d250653fc9f932843f64d8cd078adbfadb2618acbb556293f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e08a2a6e817012e323b5e3d11c376d0b2da095b9de8b7e299820ea097eb0ff6a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__01dd51e69e0e7efcb653b1bc4f852359df8395f6075a1152f399bc27de0309b4(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitGoop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e5d31c3fded234f8299a0ee7d011021907e26a61082733069297f88348473b4(
    *,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8f096d73edafee693c017387d6f6572988915e266cd518b96f7cba5dfdf34050(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7b330c810729aab244fae9665198870942afb51c3865397fe2d70248ee1721d2(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cb1897520305b90e20ce15cbb92422870f407fbf1ce57dfdb9824d727b175ca8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__66b49d117111d11dc325fd23015821a0606e2fede12d9095213261e940dc1cc4(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fdb8551b3a377de7f1968b4dd1262d93183f28cf7cb35ea7d6a258f0388cdd38(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2f5efda5e521cb717b9849b84266294add236966dc9c7a99060d5ba57f981d6c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitGrayscale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ec958715809bf471349467900a7b30d841a0bb4a3ef10772a853cfa5b8d5fe43(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1fd94155967cd90c16a39b98d48f63a54e0dc4bd872c4affe61f164c6f9ceee8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ca908e12237fb6f559c0d73f1cba887a772223f5cb8e13350091b5c3dc603d5b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3afe479cb86823376d7de274ccdb45b753c01fcaeec8902fff0314da7c716548(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitGrayscale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4c5ba99d84b99b2ca2ca2e4dcebdb13614e77bacd45885ee44c2ec5e321a0dc0(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness: typing.Optional[builtins.str] = None,
    lightness_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__84a5b7f48effd83c9ce9af3ea5dd8b277bc27a4b157f476a02ed352c5619d44a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__233bd46a2ed2daedf1a921f7fd226f1cabc8dc3ddeca81f2c2d0989eb199a5c0(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a73368d4697963c5b0cbb022d7354ef18918c5c94b8f9097613a49aa8815bc1d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3e931128d6c01e6f9d700875b4d3c079359ccf48cd9021695bccd568281025ec(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be0c19e4b5701755505c0a7116764de2e8148e94a0e826309e9033882db269c0(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2c272d580aa5e8c8490093600b9da50bc66e271e65137d6ca01b0963547442cb(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitHsl]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2cedd436997a0ae2fe5142a763e012c2c6547f821f8e103cbde4ee84ec3e0f1a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5d174fa8bf4db5133f64d66c0da895120d64bfb32f02edbe65be0e9933942f30(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0edea85fedcb90fdc870128e5b2a331028699ae87af71f654f66ad6d30df845d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f1dd2a5cf0644ee31245303c9dda5c9e75843cd97b1e32eec983495eacda71c9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aebf12a38b0f80c3a7779e6f99c3537b23fe3c4547250e408311fee82639fa53(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7b3787e86db0b02ee11f8b69e9ece76eb4daec338e00366c41d4dcf81dfa0fc2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__178df3ec57fa1ba6a2a36dc53e0b906202388c95e2d75a38bbf60f7a05924d03(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6c50bdcded98803d8db22e1de16a10a29d89458b7c0ef60043b1a5b5c11366b8(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitHsl]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c0e1528dde240b2149856751d735f87c4b28e33823ba8bc1d14a515fb0fbff55(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__22da26befe9c062c1e97453126f917792b9ec4141a77eb5a6e7a1f16d9aac5c5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b7191921d666a8d12d3036da2e7d91ed4b7c1773f227539b232826c1c5bb1d5f(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cc976dad16260174b4b30cd143a8322116917b2b70d8a57eb9c794f058e6a993(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__57006ef7c9ae7ced947d8bbca87b25a4a7eefc46017553bb6eff0e92df238d12(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9f96a885d545f1c55a600f09a1cafa21f2e6ccd3dbc1777c95c95afdd6d07f5d(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__00475a4fef0692b0d2aec5c3d7bd7180750e5c5acc861ab38d67d08647e07e5e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitHsv]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__87f73c1cea137b027d81dd5514269d9494ac6f8bf5af7b90c942d9c5d8f3062c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5399c38604e6b0d08aa4c613ad7bcd6b49a629dfffa313723a1da189b72bb3c6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__925752f10808e232599cc501fed8d8abdcb6c5b0a03e500199bb1c06e5f8a97d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fccfa0ceb7a2d50de018cf89ce296a7c41ba8775053aefc281a2b0ec3bb2cf27(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__41b57b1039e198f2e2fae09574c0e2e2797569b929d767a72b55f9fa03cbcccc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c5ba7514ab2a7f5ac35f9a1e7663c1d22d0f39a9d3ee87bb6b99ae6a1712e831(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7cd6800287dd95f259603f21fb44264ffb31e6b5c1cb56481b6e08a621f41afc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__72044e1a615d46b8a4e2faf9b459e573f4abd0851060f7a8ebe4b90e9a642eaf(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitHsv]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__764e34ec24d9b860ea2257b433b9383615917741e8ff0765695c46fbc30e1d4c(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    dimension: typing.Optional[builtins.str] = None,
    dimension_var: typing.Optional[builtins.str] = None,
    equal: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionEqual, typing.Dict[builtins.str, typing.Any]]] = None,
    greater_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionGreaterThan, typing.Dict[builtins.str, typing.Any]]] = None,
    less_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionLessThan, typing.Dict[builtins.str, typing.Any]]] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__236823344a27d34bbe90a734a347c24a653f738b396acd4b867e9b3e2612164b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2af101d84759683f56a7fe5ef3f18ffec2caeea2a5adaf0e28a369fef1cf3c19(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d16f0bb845f038ff42ef997075117e07b6477f6cfbff0e8384cb6f41c4897d0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d9ed05866a1cddb3789d9777d3f21e9672a9432b7ab35b0f48a44d21d5b34a3(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionEqual],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f11f2fb2671c754fbf346a86e2ca6e105e6fd5f02643a09e1c9d6e5b0a08ce2c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__22b3dac1e1741e4e988a42523ea9d423d4b5e7686f2ac8c110b28c3b817184f7(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionGreaterThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__45ac8354616532d6b8be167a6ac8b337a8a4f09cf4ad3d842e21a5219663e219(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1cf7e68e23e27859b153dc49222ccbbc7328818c9f5a03ab7bed61454f615c33(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfDimensionLessThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__17525b945c50dfa363dbcfd8cf2e101171badfc3d605186f5ccdd627c8e07ebf(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__105c7eb9a4ecad0d7980d7200ae9d5b65796f91321b0301a87edf9d7b783951c(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__274a9226cfbef431bd8826d8d52ac72dab886a5012e25a2d27d0b5b522fcd289(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a3ae77a8a3c8f7fb2d9f54a487ec2888d16e433c10298b8d29251929ab8c5171(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__31ad5e4b08ee602f544710ab760f4873d078398827ae541a89d3fb49c832116d(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__549bfa0df3b78744c6b40c4e899eeef74a4c4fd194269a9a622399621b59e979(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfDimension]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__51e4d1ee6b625c72c071410c5d8fc69549997ab73dc7a8970b06aac4b124cb9a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d2e413e043656358bf728d428fee05db3dcd6429a3ef71e42c3ae76425fcda52(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e43a11db5e680127972572deea5a0afc142160620a7809688091d5fe649d5be1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__24e99f4b4ebf51e9f0250885791514d960aa17bfe576f37c3761b3532f08c152(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1cb35927d7b6fb73798f32c708c554c4337f5728fbbf5d7e1d6c08994e5a656d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d072beb138510ec606f152e1dd2fcb1acdc859fca6429f8e154856b32ce5c51(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfDimension]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d581a95f782e09a857b1e4cdcf16ba6e8a7b1eaa40b4aea7f5290f2121b5b6fd(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    landscape: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationLandscape, typing.Dict[builtins.str, typing.Any]]] = None,
    portrait: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationPortrait, typing.Dict[builtins.str, typing.Any]]] = None,
    square: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationSquare, typing.Dict[builtins.str, typing.Any]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8fedad078882f47bf04de4339ccade5bf4290df1a613fae3d58968043177c4bb(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0c6920ba22aca01038c02243e29de411be3625ccf4866712432c7e7c31722cd2(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a93a74f595321f63ff3190885c677a57acc8a889c792d25d7ac66258da8d4afc(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__91b32ca1698de4b58d08a4c54b21158e53ffb306b36ac72a2640c8f1dea8455d(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationLandscape],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c211d3cd83b329cf0756aa2959b8e76ccae92946f9874f52309d49cfed8fc61a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__319698281836804f2daeaca0642b0f9a35de0eb914c4f02d471e70e88b4209b8(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__89401592f45efee79aaf66fb6b0dc59ab53ed262b796c42b1bdbd5935ac7166e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__010d2e7af342a9f41c95a2befd1c3878e058883fe251e2f0e27af754b8c41f24(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fed24424cc9afe38e877f7ef502a7c8e1414ce07a69ee0319157ee5305e15824(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a71b0fbf97e0f1de58fdc65acbbc4d91473ff884930a4d338105282c1b1a1fbc(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfOrientation]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__84fdfcca26a8c04950f800272fdf64ba0f5a7c7e655c302a1e2a926e6235e4b0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__370c21772b1cc381bd3f6484e527a1d59099b196bc8caa4b182ed28bdb0c7e16(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfOrientation]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dbed07300c6ce67343aab2f98ffc0eb293edb56f31f63a18bb65155d0101f297(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__85f77992d756579babfff7b518e735684ea70c2ccbaff8381139d7c4e34252d4(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationPortrait],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c899b42fb0d53f3156cd870bdc556e525e0778ded4e53c6b2b474c440d314499(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__15e96ee2d75fe627167bd5f2a9e926f42fa7deaebdc1071cdf6b51f6e7e3fc53(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfOrientationSquare],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__65f40e771755941849b68b9f8be1b513002ce0fdc4529b794e650baeed9fd6e7(
    *,
    colors: typing.Optional[builtins.str] = None,
    colors_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ed54fd9d8fe50212e443f96c36028ad931898700a19748fa2db6f19243829402(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1b40fc0b1853b27d4162907da4e8a4704b08c86762826d1b9d6ddd2eddbebc42(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f16edf3377d78dbb8cc309a5127165a7d4a8688e23ac1b4e2772781b18775db(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__60918f238cbeed52733c579f1ed0a663c7c06e9a5ae6d5ecb33d5a6156c038cd(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b945f09482f16b3bc0ce5744e345f68f9ba998c51455becaa6fdd7ca020dec86(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a0e177f81c456ecfce0f4547254c936984a2a60b6c48be99fd3d3e9ad81c637e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitMaxColors]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1003e78fd079b9e656ab935a0bae96791defc04444f7d0a32eb3161db6f04f52(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac20101aec26c7128d22538ca07a80b6f9e16480eac67278056d0ef65cd01c9f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2bc4f2208e77799c33e6962b44845b81eae39ad1b5eab8a8815dbf808adbdaa3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__021b7da76cd7c9a8cc6212565849c1b1e694a6f8ec6e3f190fa59ec279ef3d25(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitMaxColors]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7e33665eb408b367833134696df8905cf2275fa6046c81c46d8a5e8bd38ed41d(
    *,
    horizontal: typing.Optional[builtins.str] = None,
    horizontal_var: typing.Optional[builtins.str] = None,
    vertical: typing.Optional[builtins.str] = None,
    vertical_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2b8550f823010873a736fade5dfcf94889c700f80a0307a542df624fb060d3ff(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ddb20967fbffc46fdcfd64a3f451c6bfaa9ce681f52183c835baf5a3fb324071(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f4434f7dd2c41e4161cf3f804cc4afa72c7105ed2792d92c48992b97233d0693(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e1e184c8060ec2f9fa41fd8f46ada127edf67e34cc7d5e6211c59e48f25f6526(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__31d9717275ee2d2f1afa6d31b26d3d6a90dd0184eb0b0413a2c4329f5e020bda(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5296771291a5babcb95ddae07b8a66f6b28a367d3fbb1a64813217b0110c5e3d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitMirror]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1d510a613551a66ec566f8061ce820df5e4eb08f403bdb8e2742254c06303357(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c8e9aff00cf29c8fe920676b4a542c1a6034206ab79f051bd31f35f6dcd782a9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__89f0457880b51601cf5fc7dd2ef4d00b316c44025a9d9c25fe85b0c97c0c93e3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dc5ec611504bfc222a741410bb908178ec4d90d714382405795132ae3332d3c6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f579013792f9164cc3fc293d5a559f34e4533862bef07da1a3098bbe61d0784b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b949e77b94d30096c5ded10c35298be60d9a3d6a9e7de53d9405910fa772d785(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitMirror]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8d90be897fa313456eb99d32a55d5331cb3b464cdbba0c8e94f28e37ceda52e0(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5c30a0bb3c82b8110d1d63a41930e044b5a16d572af5e7040554d33cc1147dea(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__345562be573d1b710a5fd83e4c1c9fbf05b10602d9ff97fc4eb65f1762335b22(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cff4b869feae8ea8fb4e809d10d09d22c3498a9acae509a82fc99c5da8091e15(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__903f0ce7099673e263d437fcc0c98548b58ad825f2c76562493269f2fe73e26d(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__20adefd512fe8733124096f269bddfe2b660bdd79a4da762803c229c7182b53b(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1d1cca5b9ca359760a035ea562a5d3c62e74b5525c6a72a7150e199acff63df8(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitMonoHue]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__866449c141bb4242f2f33e488086018f0429d69a8b571073972469459de8156a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__54daf97d89242c1eb35f73096c2c765c0504ecf425e9159a0207c644af70452d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb7a696f11331569bcd6dd0e60797994309db882cdbf92bd6020b8a465cb35e7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e4457e649d14afa4152496389b79c566c734cad3934e3154f66c4cc28934ef78(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitMonoHue]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c9f40ee3743d5cce86b853e006f64516c13be5bccd46c1a08f051d24c8d1b9cc(
    *,
    opacity: typing.Optional[builtins.str] = None,
    opacity_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7bbc0b2181db813f1d14b58ae7116dbdab150dc6733e153afafec19a5047443b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8dbfaa4ea063d25a5eeafc1cf02ab0634fc8bb8aff8928c4f5c1de5fae5b5128(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__91fd96fa398209965c324bd995726b9cc781d89fa228d905bf0ac080ee50fb4b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__139e0f58a9777ce02dba6de536a8165b02b5d3d2a26ff0e737addff98e2b1484(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__65f869348166c11e993a6b5906a9a612b77668f2b9b2e8bd9337b3c21eaf9256(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8080b02af5026b3b7f7f2e2d9bb2eb884432c0731eb235e78d66d5541ec55f4a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitOpacity]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4d34eedaac131a887ba977b7121da97e8eb7a43a64736f9d26c9434330089c3c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ba526b33702923a1df3513c0f6fb172fc3176f9a4154405611747f2354e0707d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__263813861c549e401458622fb665561389a96ce984f84dbf44bc8462a8d2a511(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c8f502bfa3b8cea24cfac7e97c756c78e9d3e8ad3be60d7a5c4fa0b823ec8af7(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitOpacity]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac81e2ce1662445f7339100db3b3efc1bf4dd59621548f23ad49715ac463277d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ebf072652af976139490f50a50c96971493f9647b58933a6831f626ac91b7ef(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4308fec4696862fc8f1776f9d94f069a35323fae462a4ff0af37d06f7bd1196c(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitBlur, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a21d2324a9e07369c0804ae6751547a2cd216143582ab6521bcb5c864f9dbb7e(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitChromaKey, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dcd9287c3cac5042eb25343233a194f41cefd93bda0ee8bc3881db143b4e67c2(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitComposite, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0a02b3718994a2b9f2db54aebdbb247f07341fea1d5073e2e2e4370e9b0dcdc8(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitCompound, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__625e053c25318d2454e51635304539435d0752997a761f42a38abc7ffb731f27(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitContrast, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cc5e7dd52f16fea769fad69190d01939ec74d8602fbd2fa2fd8740063cfb9d51(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitGoop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0118a8a119aa3cc8bee4db1a2e4c6bfb5d6777093d2dd29cb59c594997ece49f(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitGrayscale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5e43b3d3b7d8c25ef69e039512f22253b81b0251e5971ab701d235c4c18367ca(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitHsl, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__03c90a8f1b43ec6eecb541ed7313005ec348643d81610707338ce3237bb74f8c(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitHsv, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d6e06e2b15adf5a07d708adffb52b6f2584dbf10091818ad4baf2b5c3456120e(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfDimension, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__219c9fa8e31f82c710c874a81539d1dbbedcfd7512ac86cbef0276f2b28f1859(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b3c0c7eec5acc1eff4d26e9f4f400c5da22a9da0aae2dffad2d6f50e78cb26f6(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitMaxColors, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__19b4fa90defc7d19fb3061fa7f432f4cdab2024285b05b7e1babf86cab0f6af1(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitMirror, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a8293a85ec17f02af87d6d6854441d0aac3d93115ee44de6c0c4957a93bfd862(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitMonoHue, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d56ecd9aa7559d9b1ea5af4c21e8d10e5385680135cbe2e232157e7b578d05a0(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitOpacity, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bd278cc0b6e1ad2511957dc2260545001295db1cb3c848a583b1aecc02084382(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitRemoveColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bdec854dad8f071218312c2aa126489d69d9cc5c8706fe379504dda3b15d926a(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitUnsharpMask, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a5d42ed786f4319af034380adf16aaade5abb478b7d673de628c397263f5bae4(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortrait],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f48391653144686d381c44d2fd934274a51993f661c1db0eac1f13cfebd3c289(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
    feather: typing.Optional[builtins.str] = None,
    feather_var: typing.Optional[builtins.str] = None,
    tolerance: typing.Optional[builtins.str] = None,
    tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__27c2cfe6feec7bdb4d6d25c691d3d860adce80398b27e7e2a3365cfe59b96478(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__afb5266fc67fb680222cd0caaf67e861f78bf7e0aa7ebea64b6891b9b4a30872(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c9c9d2e579b759aa70646b800db160135075526f113b4b84c97f812f46e025f3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c87c65a14b8e754a2d36a9e9ac9cdf9c53978ee4941a87f13e1a65304163e9ab(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e14c5d6f1471b1dd7b338162bd93910131b9a06eecd8e05941283a95f877ec4(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e045e6f67e0980d8d30af32ddbda7cda113ecc962c90564958d1c57ddc2eb3a5(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitRemoveColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__736b9240a1906993527839944c4fc477a197aff17ed1443224f4062bbb7df7ed(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c01473cfe6e3f680a3686e9eede7a96514e319c56d9c468c35eeace62ec488a1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1bd9ea4065ea24c67416cd762d72f3cfaaf7852b8559d841f6bff8b11b50c322(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ca61f2438f04ad55247525b313b360d6633f52e8550c2b038c7765232eecce08(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fb0299a562a6d597ed2a93a4f19bc83e87dac4122a0b96ae79af07780f0b8d94(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d1778da4e1684eab68a5b87e8c5e85c0c2aabc7472fd7a8150dea426a46d674c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3e93aba2ddf8cf77163b20658a5f66f810831ab1947e1ff545c5cc93f375a65e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__36e6aff33ceee99182bd07571f772d97f77323c6c03b9230eff17ec554389f19(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitRemoveColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0787c82b222509db206e4ba1d9acbb3cf11ef2c6fbd9898448a42c9fccf603e9(
    *,
    gain: typing.Optional[builtins.str] = None,
    gain_var: typing.Optional[builtins.str] = None,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
    threshold: typing.Optional[builtins.str] = None,
    threshold_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__75aa43466b38e1768f7999f84b30bc10780ae5ce65d0b5fead80e2d25990fac2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__19563a57661471ca91d5e0875dfbf82d3dc7cbc456e425211c13f63366092656(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__88181e259885a6a34d570c861ca43b33f79065fb54ea76289102adc7143a36b1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e7045fd2a57d0f9508e019994f1239e1079778d35e3a622bb1822999ecdac65e(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d65ab33ba2189195f69620bf4bd2ef22f8347d07efef1f46457a767781d474f7(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aad23e7d5797a5913641433149a6796bba16571d3b4b31ef978ab959fac74072(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitUnsharpMask]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2256bfaa41bc261e639495ebbc30c38102df53a7e6eae1a8e6255757232a8a91(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a42e9f49f9c4fa32681184c463f1fef79f0343eb1a249b64a7d2dbecbc8cac8a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b772f57300dea56df4adfc17628a91d30f4c0b5b18fcff429a80c516a4fdef59(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__79e4a7318863f5c9f9da040a052eca3c4f34f637cc2c38374aa8788547023a36(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a166086bc764be62550d9e3649e31b29bb530e25f47438725f80c62b50efdda2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__605eb32d01e15dc39584d55c6822ef822c0cd264cf4458bc28a3cda141e924f0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__230763a0a29454a71bd4b7cef2a57d2024f3beef1c0b439acd880058554176a9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b9ae3a76843c34f5325c40ba10f7f97fdfe04d010ac479bc664ad219a5103f29(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationPortraitUnsharpMask]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__226ce60a972e6769c8637b3fbd4a629634e8c7117b29da69a75ab16dd6a21638(
    *,
    background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
    chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
    composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
    compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
    contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
    goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
    max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
    opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
    remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c366f5d75e1791ebbe3596e8baa51dcf41668d8291fe6006009574e70b0658dc(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__207c01ceec300b2f37fb3b7cfee9f155201fc30da343291d522d285eb29732c1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__084c59bcfd83f0ecd3615f490a843c71cb9e0ff18e25438457a3a7095a2f2b79(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8b1fc770a04f6e07aadae8de8af899b47184581028dd52e6eac53ba5fa01db0e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b60a2573086bd8eabeb65271181e5d9f62557c4b4989a2d7b42700a5cda5008a(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0cfdd08d218eed23329093bb634ecf2ad0c5fc70e7e9b644635b625fa9be3309(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dcf574fbc296fa0c984fbcb6ac74ef0ba034689da02b39393ad334afbf11067b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareBackgroundColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__91329f4f27984f5c03054d576a2f35caa344f11f6ddd9fc48cbe55664b85b80a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cdd57947255cec1bf124ff48f387b17a47d284a215367521c3f79f4810d86cc2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4c2d699cec3cf8809ad94a4849013ede2cfca9ca103565fc97da95f061163701(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__79b69067a56b9202b8bcfe61dc376aa5687cf5549ebcb04a4dd27a90c79d9263(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareBackgroundColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d79b33576d5fc872b5e264710d35252d51a4a5aabb056b7919e2ddeb90955e18(
    *,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__baabf7a56feb0a0027143e37518ab3b4c236e76618be3713ec93f1299991cd5f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__499a9f210f055cb9012f559abc49333c0a08c68131d371289c37a79d41e439b0(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__48028e579a8e6decf396f7043441ce2e293c33b916ec1e205e4e92daf7c8ab7f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3585da1e696eb1b699a6e0e398b4e863465b4e79b525d8fd28ab1576642f96a7(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9f0274163abba783bb21e829d89e654549321bf2bf6e74ce7754c6d4dcbd6e50(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f9d9f245fdb6da3b1caa499a20cb597dc64c90837c3979de99bac7ea0aa663b7(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareBlur]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eda929bd2798e0fc564ca3f01242cb677ec45a4892cc5d0b201410fed765e4eb(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__44ae64c4c73916c7e17e3156c664367afabdce0e3d98840a2b7af16dd9d19964(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a107075a2b407690498548db98e4823d42295ea149c681691252505cc419e9f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cc0fb63ba6b865e8eeb4bcb4a1a2c099c8ee54fbb6b906e3f9c13cceb21b90f5(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareBlur]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__97eab9858a55bbe0ec6f41231ab1e1035f582f2065f424c2ee4dd633cd0db9dd(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_feather: typing.Optional[builtins.str] = None,
    hue_feather_var: typing.Optional[builtins.str] = None,
    hue_tolerance: typing.Optional[builtins.str] = None,
    hue_tolerance_var: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness_feather: typing.Optional[builtins.str] = None,
    lightness_feather_var: typing.Optional[builtins.str] = None,
    lightness_tolerance: typing.Optional[builtins.str] = None,
    lightness_tolerance_var: typing.Optional[builtins.str] = None,
    saturation_feather: typing.Optional[builtins.str] = None,
    saturation_feather_var: typing.Optional[builtins.str] = None,
    saturation_tolerance: typing.Optional[builtins.str] = None,
    saturation_tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aa0633fc5bd69e32d19527ac87434f606ed45d6b456ebb109b207f24567281ce(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__781250bedf2cd548f12106c1eee99e3de7177813622401222f6260c59c419ea0(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e320e7a1ab49aa2594f50405f557a5a949555aab586fd7c96d077d60d3a340c8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b13c848bb6206216e3dcf3abc2bc1ca3373bb71bf28310581368b45cd1bd9e54(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ef6fd87b8152fdce627684f1b35af6a8c8d7c63df94a88ac0ee60b956a9853c(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7ba0704a2bc8d3c8ac9f7479264a673bcae092280a5b86e6b8d7c5dfeab13a02(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareChromaKey]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__07ab97c83b3212d62418c8130b5269f4e37704cfeabf2ec5f68739afd8b2512b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__85bf0a77649726877b9b67a054e77bc5b2dd3fbfbb70d98c6361f7cceda80d56(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4b4b97b52f02a61dcd0ee7364a8c513518dd2420a78934ee86b8e4b267369579(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7bc170d184bf8df1921fecbaa98c593129bc47e5fbdd27f4c94d303aca0c0506(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bbb55a94c4483d580a963d85ebd6ec06481f8dfc2ebd98d4985ff390e674fa12(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__62c37f78f6966f819cf16f65a533d188aa2c94b1f1f298d46ec8311a8ca361d5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__75c13355040158ebdd43b7d4fe3be0b02aaef59b7064ccb82e1f0596401f19f7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f05a19487a4cc31a104812ec5bf9b11999dc6fa921e11e6ef5dbd735eeaae899(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cacb86994c903647f9e97b9058630c67bb1751e78e8ce0d5a3e892841b616d67(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__27ed869679d0eeeaa775cd9b2c5e639ef5aadae479ab0c5ba728e690e031f6ef(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bd02daadd2d6c021ef1876a0e7327f4d6fd4efd565f9408aee1ed5b7e86fbcd6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5bdf97e44c7c1853a23d383bc3a173733d6068d74643378f2abdc84418a8247e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a4ac5091dc4ea01010527185055d365ad15000fd0bc28ba9bcc2d1450089ad92(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3e267ce26374b4d5830c0ded66b9ef08975ed086e8000c064ab219e4c79ef4ad(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2b797cf9b0ec47991a317c8ba3bf161cc5e3dbffe9d9f3621e14bf44d365f2d4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__de1bfa1daef8d43ee10468acd83d376667af43f9e858264f24eafe96b7a9788e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareChromaKey]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ce71f5124368f6309aef81fdc2ff7a6b12c6fb496a6b184e42ba3a2190632b0(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareCompositeImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    placement: typing.Optional[builtins.str] = None,
    placement_var: typing.Optional[builtins.str] = None,
    scale: typing.Optional[builtins.str] = None,
    scale_dimension: typing.Optional[builtins.str] = None,
    scale_dimension_var: typing.Optional[builtins.str] = None,
    scale_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0083594a12887ae723888a10449818ec28148516c384813b374acf177c415442(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__50be7d83a7328abf7a524db125c67a7e7e8a66cdac3c789015b9b5aa07e7c45c(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareCompositeImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4098fcbd313b75706e944e17b451be3c4b387139be3b5381467ba8e7dfb0130a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b33203a61d6bcb54abeffcbf9805b4a83a8e5b8bdf51bf65df10ba2ff68d953b(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a0347bfa188c4f1456afa85d3b8acc8c76a2ec943748bc01ba1fd9fcb5098a10(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5dfd10ad529e14285acce0fac00db6d800063295b7ee9101d12317d5deda79b9(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__867b237e903f1e81175dbdff2a56f727365786311760878d1d07697bda215a50(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fcc5e171bc199aed6f9d6b3188439d4319a4e418a6adc14f1b768622f9519de6(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareComposite]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__305749af8a417270931d0adcb46ac510bddb0cfb82545b3b485633eab9209390(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1eecf1683a1c2e36d7ad818acdeac168378e6c93e5b15bf424570437feb56a2e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__351c8f358730c03159a3620b384dd9f702fdf1017a61616509dd9c409f54bb29(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e00d4199f8e7d2200b9e9af5ac1af58e8a811fc52820cd9079a03d823c87faf6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__860cc9a570048bb412b16b3c7693357805a11a36b2165358e09427faa0f04f42(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1b7cf4df9b31f7ca1b9a4ac061b4c2196a359e6b10e3e549fc655d00f6f6b02f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7b0e9d64b45f9fe49192ad4f89b60b59e8becfb3a1b2619e08e23be8fc0e9211(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a4615c9663529dab313ef774ed82a400cf3b9fcdd2b58952d7907187d5a6f322(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aef9ecedc3f368465c2e8e90a71a9629787590c1abd7d5a79478877edc066ba1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e6cec46eddd470f4f3840b17774238a53a639404764fe1d4854bbcc18d24cd2e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a3758060f8893defe9fa21f148cb40db889fe287bac3ca5678a4ac26ed53c30c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4b493af0b32dc0d50fab26351642864c67c1ec79ed8c7e267ebdc481674ecec0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4c01fb74070028e198479ce1c575921c1bbf074db216a123ae6c95e11dce06e3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b6dbf61559b10578c236aa629a0de60bf88a1d173f9bdf006f9cbe3c26e97a05(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareComposite]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2e03e17228c67b0e4ea28c18c57d4a15bda0bb753369162a7739500888814642(
    *,
    transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dbac02ddc8d5b89250f35da12d4af7dac33ff8898006b9889fe7787f388f2c1d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b3f014c48267397f12e135adbb02da7bb2e1ca0dc5fc40451ff26c5039c64116(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__820469cca6670b6b199e37e71ff5ff78a1f8e6ed1cd9927096068fccd5f27198(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a7ccb21e7a9c0342e25086d5ddd1f453520317a88831b2673f105e2ef42b37c(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__06332e25905b5196bd17f362917e0106b94bd5e2abd86cfc36cb74b4dd6a9bec(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ef789d54efa53d5506a0da66e0915cf159bc3e1ce574dd3054c209a20f03a938(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareCompound]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__848fe6a15dde124cc94dbb5137a1e7b116b9703402e47ae608de74ce82190b9c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__23632f1990e7bf896fa7cfe03a0dde54ca124edf856347295da414a7fa6da02a(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__576fe2d53dd6f7f18322dbad559a8325911930e52d2474dd8f1cd1c43628bfa3(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareCompound]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c740d5675432884c6d8451ff820f0bb7bc0e3ed0a545198257bcd472708cbac1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e93673e3c613de49f64705b29f0b998b009d3f0a0efb9d8a774b858592c5e37(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__596315e170eaf6066b451dffe7875235a365ac7616b0819ffb78beb6d59c8a69(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a2f66908a9698434dc302751dc3896c9d801cad635c880a531b20a940314c0d(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__16084f5a4f8970db2276fab96e7f8b20ade20b655b6ec1663f656159f394d506(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__33297919123790b726c07c8fd5135f5bd240c58929ad89949c87abaa5f96be1f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareCompoundTransformations]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b8cc750d224943679c5e333cede0c353fddbc988c92d61c5992a0f9155764be3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__49c3b2f5fc9cc46806900b53de0a588edeac757cb88376b48d45ce4eff98eafb(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareCompoundTransformations]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__28d18d3a201d2e72a6a94cd5869580c1d12f46e33ffeb6aa0d5420e2e52df272(
    *,
    brightness: typing.Optional[builtins.str] = None,
    brightness_var: typing.Optional[builtins.str] = None,
    contrast: typing.Optional[builtins.str] = None,
    contrast_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eeb4e29b3a975b2c26cbc99805b008f15c840e769cdedb35f60c003d5eb02ed6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__74ba5fc6455b03011b9a79d714694503dad6aef9f760159544c5c47170485b1b(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6ad6e7d3cca5400b2f7a8bb71f19f85003b4fb4cfdc519f8936d909f98c43564(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0921fae3aa25e6b0784f06fb3cd1b5e5e102baffd24480a0ea5388e7edea12fc(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__72683ec77a603dc16a59709ab5dec793e615dc9724e813ab3ef764ccc97d5153(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f530a1ee82b5be71f85e118bad524894fe79c6ad6d2009f37436b89555819bb9(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareContrast]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4602f0c5946273d3d3791d886d957d46fc0829ec0ebf0aa63aa0987e1ae21ca0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ea0924ceece89132662ac2dc480ec96d8befb7f5ac06966ab6e9abfe06ff515(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8b3ffb23d1ebade863de75d671389d30dddb020efb7bc41006b560ca57c99273(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__58f7ef86ea5df9fa818157ea73adc7a45a02a06ac0b11b037cbf7a937dece2bc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__00231e6cc70bc6f2aff2be6cb42cf0c59381becaba64a12c3591e743800eeb03(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7a60ca389cf42e4262ee3c42750603bde56d37f66d23eebdbd2bd52ff8460f08(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareContrast]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e98ff83f836727abc9cb54c2e24b2db522ef05e349ba10257b6b8ed95743580(
    *,
    chaos: typing.Optional[builtins.str] = None,
    chaos_var: typing.Optional[builtins.str] = None,
    density: typing.Optional[builtins.str] = None,
    density_var: typing.Optional[builtins.str] = None,
    power: typing.Optional[builtins.str] = None,
    power_var: typing.Optional[builtins.str] = None,
    seed: typing.Optional[builtins.str] = None,
    seed_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e4e88d98d7c89d150895a74bd22b68fb5a11cff3795cb2cd23607957cae9b62c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__729a710443d0353bf4a852a08e904f587f652b4d194c650b9b1c40bed0883c1a(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab461dc6adcf9684fa72a6cda7635f1f3cf367a5891258dcb704c6d02d18d818(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f76b6f634c94c3b8329f36a0d617aa16d7a37a6b5aad9c1567513d7d00bddee4(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8b210a0195c2f2692b3c2c0f3e0c84710a0bc0ddc4d34fd3a15232629aba2f3e(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dd83d4f02f96bff76d98d69eb4274d15a62e7cda6fb3b5285a493cabb79ec586(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareGoop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ab22e1cda5a57fdae2a086d738f1d201755a4e94d0ba782d49a89bae1ccd00f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__08f957b2464d0b83be7627d4624feaa8d4735f4603ebaae5c9c46f9fd7944cd8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b2372c687c51c4a49cd94d4150323e8cbe043aa5bfef6a392318c2372ca3ddf8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c0ac9727ffd503c67211293ea589db2afd4cbb236a7e6ce73fe2354da45c514c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8eb32374b9f897fbbd96fea204c8ebc313d16b32a8f8b16ac2dc134bbf3c56d5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__48a6187808ebb2fb308e1c503ed6b6b0c290b58fda8e8835db2e3410059e07f8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b2ae2cfd35f9633cc19ec4f20c542c83ec204f132e752b03395101f7bebb6d2d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__07b2480dbbc530eddb1cea49671c02ea93255e6aba0c4cd1f3a07d097f23f6c7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__13b8426fb0200754498e41c15f336b5d9dea6e0c35b4bcd4d05f70558ec30bd1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a515e00b040589dfb898937def17f1f894d8a2400a4274babe845b2d8f16d510(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareGoop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__47d3d87a113e465c7e23c397bf9f171133a77f4c3c3883f57e8f5364fbc84834(
    *,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0bd89d8e70e31499f848ca3c5b49b7d43c38ded2387125a914513ec78403fb1c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fc19e9a827f0e281b8e17b7f9a309db99f86441e753d8d96c4cc99a3826cbe5b(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6d6d41fa378e792073546a35fbbc6ad9abf2ee0b8cd67aa155120533f3ef93ff(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ec409b5b2bb5c46425f45bda9a14c2e3e7e970716c1bd8130a92156536aa39f(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__546c160af719cf84303fd59f4600a7147fa80bb985b3443f460f47e99837cb57(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b23f16f411c7625a2554a08e41031d122f7426cdd8539c782c939d3e46c0b847(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareGrayscale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c599ec0c069cf194c1fdb45539476c15d7cf171a48fcd92b7245e69e7f215337(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cb2ed0469389d221c9e07d4f23c810e1fbd8de1dbf1bbdd12f41288c3082d7f2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__20b28d26b35bee852f9f5b0f1827d8cfe611b3d0f9ed0d663ea6808856cc1e54(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7c4428e174b24ac5559d8de53551592fe6bf1c6065acf920895b76eb091b4650(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareGrayscale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3b51a1182792df7e707898dc76e4e752746311a2d8cbcabfff76757417deaf5d(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness: typing.Optional[builtins.str] = None,
    lightness_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__21c747bdadd8134e6607223c2333593698b46e23a2bbd0e14f80834e2d5bbe4d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d5a3c89b8e8353ef6776d5c7532f137acf828935e7256c072e95dc8a59417c34(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d0431d7ffd188d34ce0aa16e0a9a08b230707b77dbf2f4e9e238e496bdef1b38(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__66306b74a2437fe45e0fcb6f33fe58dd0da043d19726d720390a287cba0e4ad3(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f60f6535546953ef6370b19accae3cfebc4388370c3b657da17a4b496015d49(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0cf8df18d218fd0cee7aea8de8e6fae0ac87dfa647a33c9136df900444f4e700(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareHsl]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__32693c2c48db2d1904c9416f5708ca4e4d5fe66ec27d9a3e6c783b14c0dd8c8c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f3bfb3c08154a05ae2e7c0b948a855acd09b71687421b60e054f6cb868cec703(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__11577aaf756d377d9c33af99beb4d99664fb91ed1e84176fcc573754bfc80643(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d64aaafd62a653473ef39dab6a16314876b460b7cfb356a0efc62cab0bf8d250(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__44005185589abb418fba2a77e89963947006c215a24a1c47cdfefd272028ead8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b479813d04a9139adac3f2bb954bf0bf95c156f0d1e5711c887c0e1e205a7f46(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__db71d95a3730626820dce700056fdb7e4e46c73846b4ff75d4527e13f4cd6e76(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__105f224538eefdb6512714ea07a9c22aa511ddd780325460c2703005c6140bd1(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareHsl]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4e164396beeee0ab079fae0276f5de2c7ac6d21bc9e6063877cbd1744ed05a71(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__708a1e80baf70d5c864aebd7252702c9758ee674fffe0ec03ac96f74e5e8a59c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d0266c7c63a98300bad1864cf2f0cfd7d18f64a8403f9266e5b94aebde3b29c3(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8dbd34acf1cb9023d266a4b2fee81ea9f520529f34a1be10b9ee2591e6897cc6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__86f846c1074f97bb73b691600b81790f9adf915cdc61270a37f5cdf815fed6b7(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f82f607acc2bb58c310f4081db151664b1fe37080f64a0d4390be0f48913c43c(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c96efe4061dde856ff6c718a65ea721875d2a0dc2c15f8a57dac17cdfe36e66a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareHsv]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e3b4d6abf7c558614f7ca59a8d1c60bba475f031d53a66e998a9f3eb6ca667b1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ce17338493bc6cb3cba2785c62abbedba9be4319dfaadbb0d4a836542cff2d93(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac2393b9b89805dc072f31cecf9bf4c233ba6d75614a075d6a0359abf3dfe150(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d1c0cdab35e733658f1eb47558815e714ed6f4be634ef89d59ae08755f8e21b8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__60b389aa94c701c7e10f8fa6395b2b0cd8676b8fcb87fd938a738b3060c787ad(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__62559e283b5284530de50a98f21ce1c5bfd43f7ed139c3075aac83d0233dbb0e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e683752555dcaaf6c461d5a8cbdbfdad1b9d556ae0d4b632772027cf8f452e60(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9c39668f035c4a50443a81bfd40870ee54a24a3e5c3df448e4a9be3e08b232b8(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareHsv]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__09806cca6d1a19083f0e52deef1f57ce82ea89cfc3786016e0623762fe6cd6a4(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfDimensionDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    dimension: typing.Optional[builtins.str] = None,
    dimension_var: typing.Optional[builtins.str] = None,
    equal: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfDimensionEqual, typing.Dict[builtins.str, typing.Any]]] = None,
    greater_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfDimensionGreaterThan, typing.Dict[builtins.str, typing.Any]]] = None,
    less_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfDimensionLessThan, typing.Dict[builtins.str, typing.Any]]] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0edf51b54ade4aea480fc5a7a75f6acf9e3c5b1b996025bbc796fcb1ba87a1c0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e455866740db8130daecb626b45737680bb0b6a14ccadc3d7adc74788ba6a421(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfDimensionDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__60c48cd25369a33c3df3f90c30d27244d95b55952d7d73698638b536f9497b77(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d28ae69cd1a38c391bd533ff73298a13e7c6abfab266e6b2472252dbc2e78cc4(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfDimensionEqual],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7ff4d7cd200b0733a1f99f6c5045eab6e4f8a5d46e780a21390b3f514c4e6323(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fc1e926ccd12746e8326ec267eaa5f29336147b4647d538fae581b3057326822(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfDimensionGreaterThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8d5efd8c2a27077583f44fd48ad45e8c64c887da725af1e84bbd7e86bb0409fe(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a17a6c2a62577e38421590ae9a62455b06a43fbc8fc68d2638bf812b389f4cfe(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfDimensionLessThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__31ac39fbbcccb56411cca297301057f2cbee32c5110e62e69d9be52ade5ca705(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__56f4cb34fb04432be002e18b5a8618602bc48ff4f1cf0d54d4ddb101d22c18eb(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__88708c5e6859749061cf29be2c7ed1165b79931a1cdfcd251419701929782c1c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__acc3ba84297e0611d8645d6f792ae0a46320bd804cb406b90c8396867806fbec(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dddfa4c58d14815afe8884d08eb439f426ebdb879b662a8f982eee4302f50eb4(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__79b58da3c97498ad9c2917efffb2b3a8135f60669fac71c6d57471738de51ff5(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfDimension]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b120ce023389ba98797343c0a90d1afcd5f642d659d8827b0051c4ffdb2b10f9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__96f9d8f56dc76cb1e4a1f8c41a406711b024fcceb29bb55048a5307247db90c1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0667620eebd14ec7d1596e502f81bf2af08b2733cbcafb304bc24a3cdfadcffa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0e0fac2619ed147af7b4ddd00e70075fe8f253388b7c386cea8d1a9efc6809e5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b7c4b5b287c2ce917602fff546d335194a80590442bccc67fd671affa5926261(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d5723ee5050b0d745e22a0599da4b7ec4acbda44a5d01bbf72a79131576ff01(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfDimension]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__effbca679f9da7a22a7a5cfe69deb0ae88c4a5c4211dc4723db37a95177c568b(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfOrientationDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    landscape: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfOrientationLandscape, typing.Dict[builtins.str, typing.Any]]] = None,
    portrait: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfOrientationPortrait, typing.Dict[builtins.str, typing.Any]]] = None,
    square: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfOrientationSquare, typing.Dict[builtins.str, typing.Any]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3e2eb7dce4c4bd6adb029cd4ced8e9123d4b64fc3e7bc4512ec9a12043ade205(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cc8858233513016ca2df4c1391d315906744f336b77130e16dabad4bffc45070(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfOrientationDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ee65f7431fd9d92d6d0b38e292966e864b4d9244b8fd5ff039654f4590cda086(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8716aae59ac7e68cdb9da085d6b1b7e1a46a744d35c6c961a71f83a69564deb3(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfOrientationLandscape],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cafdde48bd7b6c146837b7be317a47174a9d2e864b4bf74ecc80918d7f790030(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8c22cc1c733cb4f8ef549c0f95dfd8c128f27922ffa492b0221afdd864b2a355(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c928d6fd5048c1bdcd185de94a3843cd1f78aa9e5ae1248443cb4359f9c2828d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7e3a645be474c3a8268b3642eaed52e3ac18598be2e09affd268dc4a08e297f9(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd5e7905f47696467b1a27142c7243b05ea43dd0445b9fabba20d73f6a2a8fd0(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9216cf0c15e6d0608e33205275817904d61a62c19bb695905d3a9078589c57ec(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfOrientation]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e8bc4378dc54e0a8109b7aafbe03d82b2fbb3d21b20bd28dc93b6faa507c5af9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__67e53a55a539f3fa10faebfcb6336e1eb329a44d0c39c2386b3164c6583c66e5(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfOrientation]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f28c6a9e41e3c72c8cca1b5093d550af5841f8e59531bef963ed297622dc222b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__14577c40be73ec1997c673d018ac135505abd56ef68cd808ad5d3b42b1b08d54(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfOrientationPortrait],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__19b1ad273ab7f105a447167148c1fec5c9ddd2ae8029eea3e1e7bbb2df37eb12(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ced34867e517b5c199a5a979f248a024ddd9cf716f8a974ac9b9ffa0cd1f5556(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfOrientationSquare],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ae58b5d4cf0ee55eb49fa27c282b651651b9b56cae16322a217da34d6345ab75(
    *,
    colors: typing.Optional[builtins.str] = None,
    colors_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f50688bf5a8fa1aff386019b51f0a1c0480356c1db753f709f35f8c28587198e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aa34083ceaf908e3faae3038696d5bb8739c0b40d8da4b9ea50e91056de0c865(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d3f8e97e98b3fb5dd969b4319ed23c4822dc1851bf363fe3618dd7fbd20b923c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__32e904db0be33bf94ce45b92627dd92efae48ec58ef6e00d91cad4ef85a2f95b(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c7a7d33d6fd60d4a588982d9afbb1b2bf0c631a90bac5b840a3b47bbce7921d0(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6723be53dd7577cb6f3bddf4d36e880a89771a5fbc88d49c42a986586a56c642(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareMaxColors]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb17fb9bcfab5ca2bebaf87aacebc02e894ea5b84c2e9cb9b685299b1f56f3cf(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c25bf118f59fbd810fb9f4c7623724a401fb3fe43049b617b3dcedc0ae32eb74(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e0752db714ca9992a290262386a155921b013ece247fcbcdf257eb8466732f41(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ca9856d0e0e048110e0f4b52d859487448bc6fc16360e5de3afc1488e5b3c87(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareMaxColors]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__98aab48e15095395ac3e0b73fc044369eca7d63218380a438e832c6f95c7f9c8(
    *,
    horizontal: typing.Optional[builtins.str] = None,
    horizontal_var: typing.Optional[builtins.str] = None,
    vertical: typing.Optional[builtins.str] = None,
    vertical_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f6d21ccfc869ce9b664b883c95d5b6cea0b3233fbb509785647e42dcb9667f19(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0d9564355a0d8b0903979b5a36b8b072fa8d286e4fda2a4badda7e6c6496e312(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__26aff56f2389e138edf5dbaaef071cbb4afef6269087f49d0230783356e4003c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0519272e6ae6542d87b47854fb11c328ff7f733a6e15f2e1e06196e1faa684b5(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ec4e82cab0e5c94103a35a8640c9901bbda62e7f99fe90595e418649fb0c1484(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ff453d4a73421d510af1ce2d5e459d338fd83480f5221bbb1210beb5b7e92d7c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareMirror]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d488cdafe728f6dca8af50dbe645c9075232ff87dae23288c4260ad4fbcd6f4e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__33913f806c8bfa43d1346b26265aa8062eb3fafe922e2d5c522c71bae9852179(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__86ff371439f98b5a930ce38dbfe04bb56a649d51497626082d026172d2d9499a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__555597099b9af65b2f0b0c04eb98aec61b9c7720ca0738e007148b1bbea780d9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c46e2ce48f453d84253dcb251a6fd85159e4fdd6eba77cf6202f18a2f2473406(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f8a11c52c02cfbcbae6aa266c59068ec51e1c7540698636f50ef0ef9f363aa64(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareMirror]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d2f78dbf033bdcbeaafe6f75992ba7aa96f9d9b049c84ac883128bec7a0cd97(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__548cdeae67744902087643fb33ceb090cf1b456a71ca7c9f5da123d6fde124c1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7f804c085acae7526aa564a0524d709418995714e98d8911fbd2675eda227676(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7a8f9bf0b13917bbf3f126aaaa343ca48e30f05ae0af3ddc9324b843c43a624a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__83e9c1074de44289928c377a0e2772060c56d7c40b06a050ff16aa9268b8e084(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a1b1d3fc387a74b9a9bf6e33163c5f71bcb50d8c1cd038166a0ab4eb25d4475(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8c20a721e70261ad81670f4ee9f2b6e5ae66cf6f4436601abaeb49d351953d01(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareMonoHue]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__84a485182afbbae68301a9b8b738783339229a433b8e5845844666df9843b64c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7fa9a09ebd577de99003aabf91d96d28308d12c95966c8cacc8e543876d399d3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c279957169b1045b10ca7fa743d49f1d88ec326d93fcc2d32f020183135a1dc4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b096e37130db38607bcb67a21722b1c6fc273d819bda5c9b219bb5323fce6382(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareMonoHue]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc8b7c2f36e904a689c9a7d68901219796bce56632be345bdf051a48d9f087a7(
    *,
    opacity: typing.Optional[builtins.str] = None,
    opacity_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c42bd1bf2fef96895b0ba2cda10d47e253a15bee3c33104ea7d2b345b58b88da(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__92bf4fc2d49abb9ac98addb7a3692b6c1b92aa45796002db081b03facb451c1b(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1004a93de6bbe54c887d852f955964e363d7cfd8881293f4ccccaab0476e9699(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eda81221e19dfb7740c6577deb5b5c44a03ab92f04d331a5a1e491cd8e52ffe8(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a943f7f27e983a649814d2af497dfdd670f4864691b0c6dec5cd2eb6c6e16aa(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aea5534d7aed0f5c9d2647ec445e74c95ec77bbfd1c18b533e29b9537cd3d489(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareOpacity]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a19b5014380c2edf862875ad2f10c99bbe5b2c79330e89bcd8c02f8a801c9e2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b8bb5310c90f3c7d63b221414ab2417f61c6611746fd53c033351ec65e1823d8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__beb362023a4f0ddd48eeecd7945414076e2af867d57c7055007039ebd5214740(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e0d3f772c4d369e849892e00e861cc57dffcb1e96b01f98c6bc33f21ea2b15e2(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareOpacity]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ac31201b48c3006fe12999293ed8b1e3795ba5877c331ee32673c61051a9f1d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__58f25540e0a47b0e9db08577cc821462eea67eba912441d3c063270b1ac124e1(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b225fd875a521aae1eeb31fc8881f3aefa8df298389d2069fba4333ffbdd4093(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareBlur, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__701f84f2c986233b0fce5648e01e17aead8631b95ffac326f1f8b996b29f470a(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareChromaKey, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e5f91bd2b08912eb5fd8330f6d1b1d2d1ba70bef664233f49c3b3e431fb66a00(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareComposite, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__36e11ef2cf995141b07710af22439c3091cfac2b117526c7423fc54c26a3bd63(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareCompound, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5136f823ab02993945e930c401c8ce2422537e170034bf6653b5a0b447ddec7b(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareContrast, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__46e8067a7ddae647577c9f52ad6e001e00e26fd402a9122000096410167e571e(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareGoop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb5666f0a4dd827a5ebdb66eb55774c0de7e64658608a79349335079847f6e45(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareGrayscale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__76ec4656b8ef08cd98e6cae03e7fea088f0c550c23f787358bd174e8d61cb893(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareHsl, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb4876c3719d9d88d2667381eea1f57ca8dad417e5f9cb22556deb2325b38fe3(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareHsv, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f8b5cea832c35a9d3227b3e5aa599f06f6e19ec0a8c7fd5b436577b57bd1e9f3(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfDimension, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e5519b99d0b0acec3bb52b8714e7177714ac4b79927473238121cf128a40fb42(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__143f3eb00c8c2d6a63f0504a7bf48c06b7b6de1e7d2ed75b7b3d69b273cbe6a0(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareMaxColors, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__30a98d5b160333ad69675a3eda0161a653f792bdfaa9bbeb99df31dac5dcb119(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareMirror, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8f7f188dc8545e6eed201f3ae9ad55040a420170ff401cf5241165ba7b020286(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareMonoHue, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__36193df4db95ef0d08ec8db671089d6e37d44846d4c4c0146818c2535c82e7fd(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareOpacity, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0318e65a9e4ebdaaeb8e18f93a42117ff2ad5ad950a8ac1233000aded0e3277c(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareRemoveColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e773eb3f2b53fa4f3f64dedb4d02e0c992ef9a2732945bb8c7bd43d2ddf9b9ea(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareUnsharpMask, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f7124dbb9e48ea6417ee29648c1a7b3c20e42ea9e39642f822f7a6eb3f5fab53(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquare],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af6853f18daeea9d763b6e4298bbdf100311f9f734f0510f3477be9fa29793fa(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
    feather: typing.Optional[builtins.str] = None,
    feather_var: typing.Optional[builtins.str] = None,
    tolerance: typing.Optional[builtins.str] = None,
    tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fa64ee69d196e532bb7bc2b0b2f9737e93514f6592d9c8c413cc44c0cb060742(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__151b304edd5f3b5a65d5459dfb70220103324ffa43c970be304f0a2a6482b86e(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d7ee235a6cc001f94bc27f7ee26d7d592d51dc9442c7128fe1e68f17fc6dda0b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bcce1409df21fb725d6e1a47634d0bbe3d906ec4693374b7773ff35ea60e6f4c(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6a6771857bd1fd825c9dd1edbb7c16d1dd7beb687033cfe881f995dc1f14aa66(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__31b1274dd963f80bf0d375c56058263df54d286c6c79e41b77d440e45041ed66(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareRemoveColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4d5ef04c0829fe36ce4605d62c033693655d400feac59a8abbf96b21af8c7ba8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__32ea3c7db6d7a7b167a5666119127c7e0936f1c076518df8578676571a810a9f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4e6a810c0c76eedafedd776bccfbffdf6b9b56d6d7acdf37e6f34ad9ed1d1b78(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__67897a234ed2044a4484a2d328139799fbaba70aafdfbed67a853507473979e0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__50b7bb2553ad92cb91132f63d01912e6ef98734a194d1c0ed622185905c36d01(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d9fab79b79ff31f76a3dfa826bc0f87941a13666febbc5e42f3b060d213698fa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__131bfa80808d394f4b0341fa63c526d715dc301c4bf1c8ef94c882d8364fb9d3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f4fb666027393997c9e9feabd7553145c67b11a3b86ce9e9538a5183e1bc6824(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareRemoveColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6307199ee18ab6f3ede2571fa1475a8de95901c6539c6c812700952feabbcbea(
    *,
    gain: typing.Optional[builtins.str] = None,
    gain_var: typing.Optional[builtins.str] = None,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
    threshold: typing.Optional[builtins.str] = None,
    threshold_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c4881a77ef03bdbe0f57c2fe1980adf84d54c2fe87176d36d5e17c32f1d9219c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__65c817d7dc1630e3091fcfe40a15aea570a881a113b06c1cad7dbb4db52cb6d3(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__44f1f584a37eb9dc3516eedb1fc2c2c84cc69192fb1621297d801bd7b8a3a3d0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__edfb17fa83060ea20aad11d7f64fdef73921afe1098136fa7f45f8c5759b689c(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8696136fd1aab0923596f1e7bc25b65ce8c384f9bb522ac9f9d63f11338f6a64(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8c57d089580bda34f194da1ce4a79434c0e029c4036c4b6fe736cccfc86a6609(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareUnsharpMask]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__871e86bc0ba29fbdc24b8af0eb908974cd0a933c76f0a6ba9af2e98bb90c4243(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__42644ca73e20189c41f1bcdc65cc5229fc7da72b9d4201d13b7a3e1f76f36f9b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a28ba2be01310bc2eefd28e2265cf018adaffa38a7eb14a8a8324781cd1f947e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4110ce59dcd826793dd5f14d9b13482552f5c0805d59309ffeedbeeb146b03c6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c782b0fb75681b851c53eb4a82248eb9b4c771d77844077a45cbb49c8f3187c7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f972d0640c65c726d40a868719b2bc8788b505bf35f53851d64337a630690e81(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b7c06285ec8abde997810ae95fe1693bfc5fff490b5b69be18ce6fa24ffc87f6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bf476ce36467623032f272dee4962ad55ff4f07ac8dc4e5b374afe63f9d710d8(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientationSquareUnsharpMask]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__31bdc5851bda2fe8ce01d06ef528920c0f173b3e44a6712023f67122a324d3e0(
    *,
    colors: typing.Optional[builtins.str] = None,
    colors_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__adb6a4128f5227bc0639c0150ab9bb1aeab8b74a3aeca327f94bce1ae4405198(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__25076ab5accb37aee93fe88de0e4e0b77479fee485895629a383cf7d35d3df82(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d201edbbe363d50d2913a8aefa832d1d24ba75cfdac3e46068a1aa69b1770a71(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f57da7365dbbc9749eadf3bb77bec88d8ec92731ecf1292e6db5ee5b00b4d900(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7323d420d5b04bba3baa9b5ace2f86c1f366f8174d9562a4c52e5a9169047b40(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__949266e09500de1b2ee1ab1ca15efadf9a4fa6dd8e6bb2cc426f3a88e67ede04(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualMaxColors]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__963ab82e1f87a0df4e7c20be76b8f0e90846327e6d0084082278c0963b9abecf(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d7c2022dd137512e3dfbe46ead9cca3cf679d26dfef49df8c1f3c4233b62c2cb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dd372968ec3a2298668282b3f8892b6658d0ee622e7011feb90cd5ca5d373940(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__42c178824330143ad5befe94a170a24c8a67c41ff2474c121fd884ef1967b700(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualMaxColors]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a86bba8757e1fd7cb25cca0aa611cd1b86dc7dbe91a14eb70255f5f65a84e1d2(
    *,
    horizontal: typing.Optional[builtins.str] = None,
    horizontal_var: typing.Optional[builtins.str] = None,
    vertical: typing.Optional[builtins.str] = None,
    vertical_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0d379f70a630f748ab39447c29b7291225ab61bb53a8d1e142c7d9dd72f69fb7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__136221ccdf836e3c0f63bbe9e49457541d964f5e348fa23592240d011d65cd28(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__05323dcc6d6b3b43615bb2bed15f971dae7cd2c01d0fbe0f05df4b90890afead(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__93f7f94c6f949de68f105faaa086467c067e341d1bbb6890346265e8f89db9bb(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__975f8815d9b605c1eee4e259d12302fb998d7a66ff1ad0ea4506a3a2a9d2dfae(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e42bf29731f13ddafec3a792a9a39bed4b4c687d668b7cb980b023da9b6afe98(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualMirror]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ca5b0bdc98f61126e8058546cb1bf74954f123e8bff82cc463bc67416e26f5e6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__10c14d879476333f375221393ae9f1d3f65f3a62f112d958e386150c29dd681b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__12d46d29bd85148f3267df0914d74e958bad256da2c11be786a94c1fdced1b7f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__07d40fd5dbfe65b2ea693394b7579105fa4ebfd845aaa947b9427a81f057eb65(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__05f8a7fc30155f416b6cf12881d67b3b2b842bf0fc700bd81de8516bd3d64b73(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__59c48e86270556c2ab7952ed57dd862319251ba84f019218ae3c671a80ce5e4d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualMirror]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2cceae01d61bafc2d48870ebe753773f4b8ecd47ea0c6f0649a87fb17c93b1eb(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__64838bb323eb924a40f7fd2fb211017937a7438140ca409c2b9728b8e40e235d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a1aec2be37009568722a8b2cc5568e7a7e405e7f27a9e55d160e91a973e79c5a(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__acc5595241b8eccfd4b6151245f6fc8b8f4522c9f554638ad8c852a2422f8cc5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f4ab8c9174651ce20bf3ac1e00e23d5fb8deac508d9fa0be34d8f08331b7b8b1(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5167a71aed0675a6d02be5e4d0849d8d582112c6e0c27309e370f02d2639a0d5(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d36ca48dd0764e280cd9d2cb1d680b9f26e34986caff89bab942789b2e0c37f3(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualMonoHue]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6db6e1a211b7c54000d4e6724a17e457378fff578bcee8fe2378581db0483414(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__531fb297b6b174390d9d61a171cb34f054a7c8f76cc98d46dc20e110744d05c8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5aeda7b5ab14caee4bd9fb05abf72c81081fb2f5815c745e060283a95f7ef47d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e89a6e02d935613d3bff7ba2c8616757d627b4e3a44c490c60adbb9830243779(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualMonoHue]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d0a4fb91459175996970e3c5af1621bbfb72c1902a633327c0182b3c5872efa3(
    *,
    opacity: typing.Optional[builtins.str] = None,
    opacity_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ef426b0dd6269b75afd3f6aefd7e4a464d226673d1ab78694de6d75c92a67cc7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ec1b50be28b3057086e2e3f0d94a158f105160c84b6ef4249cfc20ab6cc931f(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__53bd240a28b7a4bb0d9c502a58c88ee616d75546caa6afc68aabafc2b62bd5e0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7858a7208daa179ab84c5d710e3ea5c25c5b81dc1eaec975f791f28e828fc1b9(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e07f9d41233d55eb5b233b2247ce78b316a246abc264341f5e73aafbbec948e3(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__774c2b3ee070b0040d8fcfe461c1efe9a4acad9e017e5351b5b0896e9f245e73(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualOpacity]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__38d696779f7f165d1d5d2a48cad3470b84fffff274e772f5d12650d6f86eb762(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2e3422a981eda5b7ce7a60137c1194fd01a8e26807c91ad73191c0f8e093a119(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e0014cd495d0f079da9f2e669290a985b2e8e39995ff578fddba0524ba78e07a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9683c68cf047903c63b93967d37135eb0a112970e2eefb1cef397dabb165ed4e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualOpacity]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__055e1f2a00c150c3be72ecb688826ec664e78b9366ab1d0fc5396b12db1f20b4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cc7058e4c60c0ea143af9d287e648016690ba99c96d5e98012a60c7568bb699b(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__435b383d8639bbc118b38898d3f48c3b78c5167ecc49abad2c3b16af1b6d319b(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualBlur, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7f6cb848eb45ebb9a0238a35ea621993caade3445d3114e16f61b8999dfccfb2(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualChromaKey, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c5b50fc9c6b98b55df202007b2c214b7ddf9a6e72f02caa6e4437e644160aada(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualComposite, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b5e8e17feebcc90883814f91f35b1dfde007964d5d053d83d1396cc473f1234c(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualCompound, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__50a07fb3f31fd0938c56fa8bc9af58c9e0d6a4be0e3b6c8fde960b012cb336ae(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualContrast, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e4982941fbfc7ef4320513946715233c1040f3bb2179dc5138862f01e4c995a0(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualGoop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5e579acf15f2c0af002471a7a64db25e6a94a5b9996f83b349d45e17e2c5099c(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualGrayscale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__62a826e6179ba48dbc6110c1a29a70980f6840a600d0d8faaa120bbb43bf88e9(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualHsl, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__33c225b39e0b4af8a58fd49cedf81192957f389ed7a17df1ead891862adcc371(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualHsv, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e6b50b577fd03559e45bd599c81011ad2a0eff5408917418ee327f4e831fb7bc(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimension, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__403d3df348c39a2bdeaa8532cc0dfc209202f1799a9b81154c33a1c16fbc012b(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c4c4dffd069f8d8bdfc1e9d7f5fd9f64b097f24617d23e4db778011caa102b06(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualMaxColors, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b93f0f7fd91b16a00cf0b73e0b25827ec9eeb6201730ede293740ca6afdd6ccc(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualMirror, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__893095dde3d8466834bd637e76a6a9dfd0f5f17737a954bb8b177cca384fb450(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualMonoHue, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ad6e85ed189bb728c6de03baeaab2afd638620c7f5cecaa0cb35c41abc7deb9(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualOpacity, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ab93f6b505e28dd9baa6b9270c6d60a692d9842227248902b0e2e2c20fa536f(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualRemoveColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__db7949c61d2f0447337c67c4f2dbdf1899a55462e7405fe27738d47df4b8fb9c(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualUnsharpMask, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__768d99a09ef08cd9241fea3b90b6e95fd649b895e7a55354cae3d9777e8b5448(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqual],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7353a628d685b1aa4afc81bb26030fd231ec041cb5b124e2fc548b8b0e83059c(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
    feather: typing.Optional[builtins.str] = None,
    feather_var: typing.Optional[builtins.str] = None,
    tolerance: typing.Optional[builtins.str] = None,
    tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__00c9811adb4810885f11d7794534cd15bfdace349a581842df473b11c79e7a35(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d9bef3564d89f7ec593739c379c4cca3873f55d9666fc19f49f8cf1537731e69(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e8e4f5c3268c4fb96de57816b6b93a91b69cfe79cf21f940d81dd580e5629a31(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9b94b7dab8a93fb6fef38de06aa96641aac264a9e4e93ee74c429f6de643d8c0(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e2624b7186cbfe2ff15b8af405a6801d2a46f580f51c510bc9479a2724094656(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5bedfa7a4719f9aa7c4a6e296c4bddb427d5f9ae11b4dfdcb5e3139b8e50078a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualRemoveColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9552639bbe4d1f9497b9947bbbe808220a558a741c2e3738392adbc275f4030f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dce9bf77584d427b2bfde2b0a81683908290557dc04cdd6ee15c84485e26f89f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6956e2e3fa2215284c461f6a2bcaeae4e9d8859b43358788218e2306046a0e7a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5aa4cec0bb4b7582ef6d6c11f310eb15077fe83c7a482307f8cb57c91710eb52(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e1080429e8e5f5bc647b874179cb9eed9962a8ca35e9bdc3a3b980d6423f901e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__00c7f2aeb3492b34b55bcd987cddb23a4e68182009fade30abb40b19441ec4ec(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__13245bd3c5abc0562273d2833b36916e24c669c2cb23571a57c862d9c654d941(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__da2463fde96e9603eb048d6be853be9bc32c496642ecf3b8b18874f826538fe2(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualRemoveColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__36dcf03fff65449c1abfe6d71d8aecaaab480668f6abe55bc9e71ac77e8ea8a2(
    *,
    gain: typing.Optional[builtins.str] = None,
    gain_var: typing.Optional[builtins.str] = None,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
    threshold: typing.Optional[builtins.str] = None,
    threshold_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9eb29a289acb87d012689abbf5be51571920f5f53b35156250a2506bd9af1656(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__290f07fdebd10c63550aa0ff79ecb7da0d9f67e24c8a6430304b2159cfd0ae68(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__255194de63620dc13182c50685fd59b785c5ac2801dd6bb26b22322d2a9b4f97(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__97df1eb5a813003a533e2287ebacab7a3bca219a67e294853badebf1b98ac59b(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__29c38e438437ef347ffac6be2bf5dce603fce320a537e2049ec938a399d9bc1f(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e8f31a9b161fa3ab9c12eb581dfdcbc9565ef88184c6eb20e696d983cd311fcd(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualUnsharpMask]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__06548171515acb868b12a87f6ab6b5699914af2343dbca4bcdeff5dd8cefde85(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ead07dc035a91174e5dfd1ecbf38c0b753a0e6e3da4074401e82f8fbe7b6129(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__67a280bdfb3ec60822250143fb51606454b9308e8bd7f0fb547eef83b1352cdc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f39abbe28d5ab8e32ab666509db4e6b85554bb6d8bab5aa1eb7a4137b67530a2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4508074abd876c806da7a677df6ce45c2baabba268fd944a9c83ee818f4a441f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0c7a52622c3020862e96884f5acf8a024a5a8417f2babe9f34ae74974bfcf8e0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5fa8b1ea76e2bf0deac7f376c1a1c62837ed22a7bf8de8f9896ec1421133169d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__84a7a885cea9b010ce1f9c16ed8713bcf56161f85bb104b66833a4dc24adabb9(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionEqualUnsharpMask]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__669732a7f9e7879671afbf9a4402e3d496ce82b4fda02befa6b337167fb22538(
    *,
    background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
    chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
    composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
    compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
    contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
    goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
    max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
    opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
    remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__61446f0736f7a286fda268f7b8a31a433ce8edbb52e3db6e9621a65f5c7d0814(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a1a762f22100e583752c132b847595b3a897c6f697a26d9b107be0929e7b61cd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8fbd0474a9813a4ec7950e572e901aa37a854bcaa9e9c280fee257b5f344c666(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e4ed613c1fef10de17a979984a730dcaeac36b2951189b2d9cfe4779a0262c45(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f11d3a18cdef6989b2f7d4b9ee1a1bd87459dba24782df89cb6e7b5bb9bd74ca(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a953215e2b66709693de1d0e8a9f35080c26c5aed75aa7db1adf51f12a181df(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fa94abe6914e79615b799391ab1cea6c6ce0b79c37646cf75c386443b9ce5ca1(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanBackgroundColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7af37f43ac643c041eab9c61b4372af41a78bb3dc53b913cf4efe1f16c8a45de(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ffd75bda0769335260136b972ff89d0bc712736a2f4b842ce83814f3c43c717(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__47235a4b28d206a3f10cccd17284ea448e6a6767eb25cc6e2e62c4b02c19e0d7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__75b9b3d17bd276d93619f0585b4ecbd19ea5592fb9adc0119fcb02da1bd94256(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanBackgroundColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a75405b9c9eab93c18e774ad7495d9f440868dec1f311ff685f596d0d074e168(
    *,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cb8df54fd118eb2031a5e44311758e23446c2e7aabeb43512ee410d377c6bd56(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__043016bf242698dbd54735377f1e45ab7854c0a58a6dbe3313b606910fc2b2d4(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fa288dca59f9e30c2db8d35c41b349f2832a8f444688a94049751913d2f2a586(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6bb99e6fc613127717fdd480c88055ec06d22915c9ac9c13f49debf6f4c9da88(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__89550a80fea88689f2ca9f35c3706bdccba2154b11f86a977bf893597e2d1410(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d2d743a65ceb0732c1474afdd004e9281d7e2ef7776f1f0640f423df4a5e7f05(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanBlur]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b52c39488398abe3171ad18dff8b4b333e0e49c565f9ac6e0446fb0961855243(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d9fecaf5a8a8077a2a752af474f2ad19d674072bd103878b1a38248dc118e701(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__45537f33e3b5fe785740ba6285577d0b2bf0af12af179a359da4ee599e0e7ef4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__13063aa5c94a1e7fc6f02f853d91fc44f9f133028044d6b4e6863a761de53abc(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanBlur]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d50ea82d53c1624068c954c2649b9d20df0b4811c03c7dc4d9f67baeb73a36e1(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_feather: typing.Optional[builtins.str] = None,
    hue_feather_var: typing.Optional[builtins.str] = None,
    hue_tolerance: typing.Optional[builtins.str] = None,
    hue_tolerance_var: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness_feather: typing.Optional[builtins.str] = None,
    lightness_feather_var: typing.Optional[builtins.str] = None,
    lightness_tolerance: typing.Optional[builtins.str] = None,
    lightness_tolerance_var: typing.Optional[builtins.str] = None,
    saturation_feather: typing.Optional[builtins.str] = None,
    saturation_feather_var: typing.Optional[builtins.str] = None,
    saturation_tolerance: typing.Optional[builtins.str] = None,
    saturation_tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5a57b1a61f2590fbfce26629f52c87018f43abeb8a78d3e203db53f7e795ab25(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__96d514efa8b89c1e949b322cb3e8f080387bfb909a8ede662b619a035189197f(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9c813d88538dff5de5b3205127c4bf469a3b4e1b11227c73e1e44ed814de4c9d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7b3039beb24629910649f47c87d12c53c7d99e031e2ea7a60810ff19b69c8077(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0e56b80b60b6b1c9b1b70255dfc17a66b14381307dd9eb439b9962f3d85ea533(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__098d73e39a5d76128d56a591170b72cb184fe93f64e8f59ccdc7cfe7e5da019f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanChromaKey]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a8c3e27b97b9f9dc1d70b1f85de374f54325e2eda7be8e28741d4d1c73907ab(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__22979850efa4c136c9154d26d95e83d828bb3b5b70b13445dddeb39e32dd7eaa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dc9995378454f605a1430da62eb95aded265a11407fc809afea51dec2c16e0c2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a6cf425594f7fa22f02501cdee291802d4025cc4c58245c172a8749f027097c4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__23988f3fefba02e9fe8ea2757d6d5747bcebf76aa18a74909bdc358864f3d3cb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3e660c5f75931b9ebc934e83355aa0143cafd41001cc538238a9bd34682753e2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2c1bde6981ee07e8889e2e597b37370639bdb4ab16d97157553202b92b252202(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__31b0426b6fc16ec7b6d099db146fc1a920df06aa7e50370fc6d017edc6ecf372(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d3e7c05d6d4b64386f28c809d3d26034bfe11c31dca18e2bb9ecc221d0a9b32c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__849ca8db1b92a4b886996f68f3303fd1aa460ffdfc23e62bdd138b9c54be9c79(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d51252d02eb7635f303fa9a5113b41375cd7a5dd8b7d9a0aca6c2be8a1a0a71f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4796a572be02d14143a2f2dfdc9113e0d5bd8b16849f4e1454bddf30fc6f9e1d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4612c5545923f0c062c461425324503cb367ba24f1983a0befdccb8afcfbbee2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__84b1dce74e6b14e307683653d908f0f84637db22e09aed49dc846b0d4313fdff(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__20a9c7965910e7fd2455b58444656d82c492de8ffd3fbf9c04327470d06ecf3a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f577a178f77ea044c24dc7f3280845648fd23049ae48e337d6eb1c655cba6965(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanChromaKey]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7ff450bc758df184cd2d887e9e307feb0f148a12d9b1fa6e77ddbd57960b13f1(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    placement: typing.Optional[builtins.str] = None,
    placement_var: typing.Optional[builtins.str] = None,
    scale: typing.Optional[builtins.str] = None,
    scale_dimension: typing.Optional[builtins.str] = None,
    scale_dimension_var: typing.Optional[builtins.str] = None,
    scale_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f277d78f058e2b94256c71388c83de6d4dc4e7e068656cb2f561a79c10af0c9e(
    *,
    box_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageBoxImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
    circle_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageCircleImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
    text_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageTextImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
    url_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageUrlImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__95c5363055e3d335ce5d3ce2300ba54e0a8101da9be0151ef45d0853954cb999(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    transformation: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageBoxImageTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1968207cb88a202a2ef63a1a72f02655728a21e006f5214dcc102520869365ee(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1a12b1050e357cec75dc376bdcc6fa76b3bb819555b51326dc27bfd8f42d32da(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1da5aac1dee0537e4c0cf706a7b1966a65737b2a210f84fe8f34acfcbd0d934f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__de54e576f4f46a68d4d321f3c92a1800b390586ce40b7eaf2accb45969fe31d3(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8cc043cac27f744e0582027f47efa087eb844157a277c3c3af21c672e9c9fc47(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3db3e53ee07954f4e8c58c1396e7e4112e04eda0e9005d5d540d9efd87e418b4(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageBoxImage]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a2c9ee18f6d43e43552a4b7b472705239a3c51af9eae95a01476e4f4725fd772(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f227c65343f6ea43a9ad77f6b5690831a86b5b823ac8f25dc5539f0b672bfe27(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a50f6b03871a76e972a76dd7188d111674c2c43c61b9b9723facb5338391096d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bfa25f326b0ae16a163eb6e47b4a095bd80d5f4982dd400ed34a64e07b3d1464(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__47e7d774cca53142964467506389123bc1366fddb447bf810fea1019fda30e20(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1eec6ae46ab2c0cab295e628abe383727f71721aa37438c496d34fc07166721f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__248bbda0d7cc147a9921565ae80d75d1b78fbb7052f96dd5bdc8fdbdb7880772(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d97221fcb53148adead3d85e5f48f02aa47dcde6b1a6839ab09ca8a275193b41(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageBoxImage]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__240e0e8b79c4f278e36ec3a8ba35c5c4ee9214697dd2c7a2fd44deeca365707c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__41bd98439facf5a111deb0d2da052b8c400bf1bc4a51eaefdbb77035a058223c(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageBoxImageTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f996c92d4bd2644e99c64326190282ac287edf5b16796754b71b639662f5fcfa(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
    diameter: typing.Optional[builtins.str] = None,
    diameter_var: typing.Optional[builtins.str] = None,
    transformation: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageCircleImageTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__34827c599c9b8f60a472a453f8137c353e79f0bbf4922906849c33cb7f29e8d7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7a3f5ea94ee616b157b25605e0ff243935295ddaaaa4155550f5c04387ea4087(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f92a9b51a715d5bcef4cf7854fb6554cfeaad0cd9d33bae65ff874aaddc73a8f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__38ac9af30f2fd755e48519f95d6990b472544782744b030639d283ebcf7ac745(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e11ab83ee27bd9cef4e8d5bddac686b4c23aa3db76f0be9844fd09f319012752(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__68a537568bcd11ffd5e4ca561b7644ff020b940ed37017e6da82ac36a62083a6(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageCircleImage]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e508ffac0681a85b5e503207783847d73bd5dc3d7d6ebb8f78f6f7988bfc0a12(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1a2de7b4237f65696e69516ef1839733389211b625220ae1dba1dc02a86e84cd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c0cba032beda8fb0ddc4b93ac97c9083716d77acc984848ac033f7f7d7478e70(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__09e4a027ee65624d3823dcface02765256bb9783baa43d959562f7320d9947aa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ce60f72125d29b9a42e9f1b4bc0159398dd03d9dabad41bf9628a897a2b3db2b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9588890a7b25272ece7d1c05f556c871bc966c95bf6c9b20465e01c5cc3ac6f1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b486d9ffcdbfb16241cd590507c8432a07227e4860784e3395db51234ca040af(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fd1b0e3b4ad5d5446da5ebfe5692acdea2faed29ea42f4fa156ce2d089b88ffb(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageCircleImage]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__97031dbcd4be79d8e06b92327f18558fc9e5e2e20b337dcbe5281e0a947bb81a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f7ec34fa559f0a41d858b4444e859cc48aee360aface4b54d21d840aa465eb52(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageCircleImageTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5d437810c14ba2fba0f07d41bfb00c9208c03958b32a82df2a2d6f27127210d8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6252bc7bf2f935d211ea4c238c7ad1811c05fc07e2fc100ce8c0bad5316feb83(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageBoxImage, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0d4012297f660b5c9299c6a9aa0694b3f9b8e1c916ac029cd6b373caa589fc77(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageCircleImage, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6004c13aa706f5be9b5bad5c8bf72d3aa715e7241b496df8d2f2e28f4706a301(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageTextImage, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0f3a9b3aa0b829b699bfc2bfc44cdf0a286f0ce0312311e9aa4a975f3cce310e(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageUrlImage, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a1cb3f2a6d0ca8933d9ff80509151e736750107e80fb7ac6e9ddd1ec5a69fbc1(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d5db8dccbb7f9236a3d4241b938280dda4e11284bfd04d4a3f0487dc3a9e2053(
    *,
    fill: typing.Optional[builtins.str] = None,
    fill_var: typing.Optional[builtins.str] = None,
    size: typing.Optional[builtins.str] = None,
    size_var: typing.Optional[builtins.str] = None,
    stroke: typing.Optional[builtins.str] = None,
    stroke_size: typing.Optional[builtins.str] = None,
    stroke_size_var: typing.Optional[builtins.str] = None,
    stroke_var: typing.Optional[builtins.str] = None,
    text: typing.Optional[builtins.str] = None,
    text_var: typing.Optional[builtins.str] = None,
    transformation: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageTextImageTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    typeface: typing.Optional[builtins.str] = None,
    typeface_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2e80de910790f4ff188f95f651f89e707f7de756cd833b9002a7321db706400f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5387ea3c9c945b287c97c891a2d7671a61d36b2e5e0203fafe588d5e8a0d0d88(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f3b480282bf7b18c94cc6eb760e89f3f2a51840f36f8963c94ba8577acd9e000(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a347aad655426e4707c3d3da14cb91f6fc232d50045748e2745119093db92bb2(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__505fd578a87e9e1c621931b1671b1cfe014339a86c3bc59e0ed234d863eb94ed(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d715a1932618a3ac533615b3c890dc3905bea93b9371e9f233cae2ab1054e81b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageTextImage]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__031f17b4bea8c15d9b5845e06c83c86bfb0a62ad90c395460ea8b96b529a20a8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__168a6cbbd655755c40d333db7120592fd5f33957af08a66a134a4c8322385d64(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dc0c81553246957756dbd757da473afca64ad05cc1d6848d6237adc5c002b90d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c1e6b4366f489c1172e053ca662e57083e495bc353d85ad1aedc2e9763eb57a9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea7b3082a1ab2d7c67dd7e794074d65d6a6ad4e10bab97e98bdcf7a6c457d4d4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bf06df5a6616fc95e7c12c13f5356040e4c94a8c5740fbe41fc702971486247d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3193c28b3d51088dd21a30cda59c60c91ff203d4b864ac454ccd5d36f433e0a0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bd222ee28591c585a6c459f873057bb0e20d50b143f1d28e48d9552808e37fb3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a9f0e61d866d9f1ee35f17320d2d5c2a030ae7a303ddc2aca581898f4ab3c356(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a7707db50c5dc2cb9128ca37a0ae901b1643e4c39f72f089877c4ee7f5f2787a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__22a16a537625b478b9498111643ae0362452388db3c79409b53e79d588d0d9cf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f8e5ae5ca0d6964eac01c5ef40863a559c86b9da563ca7a4e04fc7cf155db7f5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6de358f15e502156d8ac2a7257a28ec4f74d09e2d0b493fa1fad2c3bdaea4f5d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__05005e08269a172f657703d870a95b5f74ffb35f5c9622475cdbe975c8abfcde(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageTextImage]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a375a7ed58226df6dada366f167491d263005a815b09ed518ca8cb25d6fbe8ff(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__291408be1c14ee2d9e09821996bfb474ff981a0630357e6203c32fc73f7eb7c0(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageTextImageTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__71135d32c1a2e0318ab8971b3ec7dcdc08eb4d1ee18a6e742bc7a8bc30fe185f(
    *,
    transformation: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageUrlImageTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    url: typing.Optional[builtins.str] = None,
    url_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7337c8281142a9df6c152d36bc5df3832629d2bb0cb526cc9863534948e4bea3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2c23694122984d819bdec7708dc88aa9e1fd58b1dfabaa5f1c7e9229fa810b71(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a47d5fcef359ecf4c689e9ac2f9223ce80834082178b22b9129ce643a0b59c3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__68419269681c70dba168eba7ca5c8bada595b460a3d81de82df54de752c5a248(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f4ce8d45e4ff5c067a6b83261f68857a640544e6512752f37dd235ec3f0e0f3c(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c1effb57536d0d05102f8d2ce104c834f5c3eba9c4e5481e8d97c8e958d3a3e3(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageUrlImage]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a7a74696ffbb1e7236d8bc9e7f1b5f7dd5d1bd2326fe9d0ea0ab17c43e1ba65(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d1041b6c1fdbf755af7a7e84a9b38c17938943954554e0a76de3ab922c44ec3a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__095ecb2174de2ca0fb99ec9162d88d4241db793727403683ca13be2439558ff8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__991e7eaf287d899411df466feac5bf358bacada72d5fbff2ef042866ed95c00c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageUrlImage]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__91f5e07b22d7b0bedaaae3b1e40175a7c24a6f8d20ffb3844fdf56bb815925e6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__18e54b672ea7878b5ad868262e839b3bc903b0f6534284ff3da0234721f47481(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompositeImageUrlImageTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af7d64013d54ae0b7b642615ff1319e676eb7aa283d163add96d998553c014da(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__463e8bbc876c1407ccab6b98f475d8eb32382e9c3b10ada45fdea33efc8e7278(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6b2ca8ac8e000efe6fe51ba4fb2a42ceadeab466348bf7cd68c30b9ef259bd89(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab57c4a235a0aeeae9f162da9d5f5293c6ae6cdaa2f6e5e47e53d538cd526b76(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9fb2ad741d09e537e33c60ce2c7da064897173a72027e17de9b7eb7e163bd0c0(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__977ebe586da37709c3b38eb7684b27d3236d07f9d45ae130840e3f2d0bbab5e7(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanComposite]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d75e65acaabb9c0920f3d24f1fe94f28d6347230b9f9515e0d9ec9ece528113a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__10347314080e15c22c3b58f2ff71518e62ca3254099792fb24b9ce8b5b883c3e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b590957d2fdbaf9aee6802ead52955e594e6cbbe16e650ad2b92c0cac030eade(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c30b8d9d77222b7e36035772bf9996e067f98bf64b92b640352abdc5b7cc105c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af52d2c6597a026ff50875ae15278429151c4e3c2f18e78be752117dc27b08b0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3022adedeb3ec2f0feede20f0060251ef3d49df1544ea822474a0c318415d95c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e00d264338b1c517d23e96b91524c086e4370b8a56816b96ef77dafc2814f799(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__283b60b69a64bde4e0502047cf7909798dc33c10ef1faf863c0f73a742fa680a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dd55c98d9084aad638083c0fca60933a81fac9fcb1d949e79b44f375b49f0909(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4f236d1483e3a7a2eacf0d21aa2bf6b9f19def964bfdbdcc80c22936aa9c5dc1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e1c1772558324a1896b8bdbea7fcf65fd78aed9f8e3351d7c2fc3edcae4a240a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2e6e63bfd0d0769003ec25b2910806525ce7652c46e47a32b1767082dffecdc4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e6a2b460bbbe790641e62b3037efaf441f64cefc917e5ab117270973a9215e1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__26b875f69f5fe79e7b47279ce53917ade376d1a9d813bbe941348864b99f6243(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanComposite]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__969d02847912390fbf47e043c5c2b09bcc4f17286895ba1301797f680814a179(
    *,
    transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7468ef4b850c55f592090113cbc3bdad78991d45ad04ba884471d57d0864b57c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c20469d6cd5c710b316331c4a576235870175447ffcadac4a3df05e77b7afba1(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c5d510afe5128173fbf30a91f0c24ce8bb5acd9e9b2c20fbd8ce817564a560a4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__42ab5abeb7031c9503fc75c9de11f349a80c6de68bf1408f47ffb51175b720ae(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__54b84a89d4cd1f702997ca1f806ae43d649bf1d1f54f68e846a8cf982e4f5544(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ce7ec6049db836012d53de6eef7b22a30afd737316eeba6e8fbc232700bd17ab(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompound]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9dfcc161fdbb7c439e7c9d3555035214b03f76e7317bbbcf20fd8eb41a5141f6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c19ea0e68cddbf18059827b1a0401c803b9857fdba8b25f9813f19e13a960328(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__37f38dd0f3a64f9f56116ac31a3fda94ed6d6bcd52f61f3002fa41ce8ad1db08(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompound]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1522fa390c723db386a68c77d3985b6b4ac6273a0732ae341fc0944f6c0a6be9(
    *,
    background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
    chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
    composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
    compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
    contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
    goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
    max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
    opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
    remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__36b9302cdbaa92a854cfa654421b0f9c682c5c6491f87cdafd44d6080e8933f3(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0513aba8406e7c573d5fb826829fb0e0cdc757168440da36bff4cadd09bc6072(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__062750f1c2aed235365ad8bb6ef325ff7be42fafa395a3617f62c5a1ce013e52(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__45763f13a175b1ec62b6a4baf2331b00a4020dd2628682af08acfda42a221bbb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__09f711d2459fa1ac09bea1139af763ecbb4d325a9d157a523563975e6fe52610(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2f33f41410f43a468fc103f48a38f704c1efc0299bfb224e65c10fe809777394(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e63897b6626957f8c54331665c04e49e62cb0c08e0e19d454d353dcbd8522eb2(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsBackgroundColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bf54574087a69217aa155449b28765e138fc7eae226404e4c2cf7d4f3aec1a4b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eb0c194d297daea12aeabb3d853a93d219b309c109df2806484d0c1c680cb369(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aaeb147e58556dc77b23acce9c92f65b5f130c090361d7bbbaa56d1418c46295(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1032c5f1d166b2e48093e0aa748f02acd624eeefa938c7a0c8c56737b3b6e370(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsBackgroundColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__74c527fef282044da8dac317a9982ac8b64b6e3e2fb944352313a5e8c2dda53b(
    *,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f84bd17642d9923d6d39ed7acd17b63c4d6f15c4fb30bee03ff2df93b78729b8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__792853911b2a4318623487b720e421d2838b244504902e73f3ca48e624cf5747(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e2c0e4873f69868d9b6398575fb9614e075aa4e30d6e38823abb297c4a290a5a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0205d6e71b11d6bb342d30e1d08227c066be87644b69f2816d054d03b4935d45(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9530bdaf1356fbc5d359447b5cf3ab775345c0c581a3e0aef449b0e795565401(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3b3a3869acf9e3d30e354b4cb6b44233c6c7c6af2612b2143f8efa2e3dc801a2(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsBlur]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fa88785f97211e27ec9b5d046d09a65a4313c79e5e0e139e50a4dfcd233eb91a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4563d309b56cedd9f1bfa8601687eba09db939f45e0feb1bfbc1f03d2e8970a8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e15b1427ed13f531ab8778a6432bfc18b939203641d56efd5cdab0d1f266d58a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1c0391bb7ffb4b86d56cb74d140e952c84c9abe02d784fda5d3cdf8c93dd2b01(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsBlur]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d8f933e4a1a834c92477544e2c17bc9c948903f36c6b69aaa7bbecd9eaf072da(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_feather: typing.Optional[builtins.str] = None,
    hue_feather_var: typing.Optional[builtins.str] = None,
    hue_tolerance: typing.Optional[builtins.str] = None,
    hue_tolerance_var: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness_feather: typing.Optional[builtins.str] = None,
    lightness_feather_var: typing.Optional[builtins.str] = None,
    lightness_tolerance: typing.Optional[builtins.str] = None,
    lightness_tolerance_var: typing.Optional[builtins.str] = None,
    saturation_feather: typing.Optional[builtins.str] = None,
    saturation_feather_var: typing.Optional[builtins.str] = None,
    saturation_tolerance: typing.Optional[builtins.str] = None,
    saturation_tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c34234ae9adddc4ebbabc3936d396673f744b1885d5a3c533da9867053e4df55(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9532ec0bf2fcca43aabfdcfd2b9d8d76f021755a5af5f9c8d8fa009eef38a811(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b879a801ef9e56b6d8d382a4204e35b55e71e72e59e55a6e9ade52acb367ec36(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__00e769673122a35fab868d9f336402baf49a21865ae50be032cf54ee9795e349(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7596e208d5c56e29249e857b6581f4d691cb5ecf3800738bc5ab73fcbef47fa0(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eb138b770ccfcd10e2e6f54fca62c7fd4d58ff3083a777e0f885f0d61140db37(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsChromaKey]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab16df7d87cfd63aed24e6cde5ce99f2f91224ecb2999c89020b53433ac6c3ec(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__443b884922784c2c1ed90effb54ade8c7e7f664bd0a986fe0e8296577e17eba0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4692a00de3d8b0c535386765b352a3823ee3ba03911e11e6974edb7386e36517(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__554662c7cc0363f0a2816babfcc6cfc7907bf3a9619ff7a1ec52fa035c9f1a50(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc48b7833f9d0ad13ead1123847edd3755199bcddd1d40f5e13540f0efb86ce1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c2a7d8aaa12a08e0e18a7aa3b8a777b30350456a537b09a816b709b0d9b4e271(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__24f519676868aa55d144e0abf3cb0c338dca0fef1d5d4eb53d1e73af265dc02e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9508a307ed5b9a02159d66a754a673832e22661871f05f4d843b22357e46e86d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f697ebd008411fd187b3d591ca1ef46393e8f2e5c7e85023555f3fe6881edf5d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fc8f06fb272d5f3cdc0aa8a5fd7d1a861845b3289bc4d410eff2afef0919c3c2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3034a763010d1390baa89d338b98935ac7f505af23dc7b1c492ba13ebbf1b2fe(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e530764b0f211c23e85ef6daa6a56023024335a7cb4ce2e1e984545f9b8abe0e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__80506f584b79d1d68f46d7d707b7ce3c4f00839129c3d2c145b6d0c1ec93f458(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__69466cde5f6ead49a0c70a678577c31396b675a906648e092cc323fc1fd7c0a1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b6a8fb3febe475ee463d88af1667a988507715f6ebf3431b74fc1b643194ba2a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c7e835a1edb3bbb6fff7c0ece7aca72528eb43f79d14ac798ea665df2e6ca613(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsChromaKey]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b7f708c401c9238148c597d34851999319854941ce241d4a2611be05db9fa266(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsCompositeImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    placement: typing.Optional[builtins.str] = None,
    placement_var: typing.Optional[builtins.str] = None,
    scale: typing.Optional[builtins.str] = None,
    scale_dimension: typing.Optional[builtins.str] = None,
    scale_dimension_var: typing.Optional[builtins.str] = None,
    scale_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d6e694d11f13c6288e864f50d8b25508412d2d63e04110939f61a94fa8385b46(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cb36ba3c145fdc473bcf2b620f7ae15fe8718f257292488f5e79b78876831356(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsCompositeImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__83e4003fd80b0bc69280365fd222e4cbf1dc4de0aadd436e5c7af5d3b25ba544(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6d242b77c18ec4e0e8f2670632a297808e1cd93a67260ed58b6d071088b18470(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e17edebdb6fb86851550efff5650f3f9654df77b991661d3a278aaf67b872c93(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fc49a87030b047f06478497eb104921daee87f10a57adf4fcb026ceb9e0ae82d(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f6b4a0eba7b4fd93958745c20d88b38919409dcd5edc84b05ed82cc5e6f2a6e1(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f2a9bddd4c85d4fbf1682120ffa27212bbb05ea14f3ffce54b602235825accea(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsComposite]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__220d308c7e157b418d8ba309ba610296fb8fcd54312993ddd6d1f085b963d336(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c6140533c5b272fd2f91a2b581d6c4ad1308004d327cc698f67926a186cbb2a0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ca5c981e8a9e83b6fef5480f5d6679750a07ee9b6a454f484eb47d63d4266c93(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8b9a01fe2663df103c64126e99193a8a7bb44984c5313969dffe8f1a2c8a03c4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a1b4941084da5af28fa770e9ba7a028522a982d631c391d8f751d5f4ada2f8ea(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c4723e6d6561f87ae5a07d2f17de40de227d826cdbdc123e75ec7851b7eef416(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__61e068320588efc7ca47cbdab4c88bfaf98d5d4d6426d2af845c6d23153f2788(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__708488a54a7ca1659732b319e80ad4a24bbda7b47913311de5f38fc3692e5d90(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8917ec567956744ed1c58e27a64dfc54c3a0cb246861f711f618ac4586d03995(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a0339a6d59921f8550de88c8d3c29b229e608b2b6ad826fa355ba57bd82a659(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8daa781334516887127055699908d1d3c79d4e1a4a2b0d91cd9c9415ab877cdf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__731fc9de1ac86cd7c63cca5d5cd2edacfe5a34af6d11b55ddd28792b1b827f34(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__24d8d7e1037d64c2440d69a6c8e4a5e58b03ef3d373ac054f5ee5f571feb71ba(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__213b4e00ac99bc4663dd923428c9f3deaf0ce621fd2f53776066f8df665eba85(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsComposite]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f32a1eff674ebe1471579e67b27e4ab51f617a98a423da48c1d84ce376d070b2(
    *,
    transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__555d54729aa40b570df118bbc201eeb10ebf4475155b5314c99675d0b82f8acf(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c62afded5eabaa0a8363e2743a3a416a0e64646d658a04e4277671d66f3b0c69(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3f9e8fd8357012d4568abf808bf9674caf1ac87bfa00937e82c8526fb7144e72(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2040c10919313aa9f8c4d3992752c9dab651e8e6930b064a1a28ca250b8f7fe9(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__93087613f14498693fa995b42ee774c81975a07e214a8a129f9d1d46efb73669(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dc3160f05cd2d7bc2169768da84c232273810bf37bc04287655787113f430a98(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsCompound]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5acef1ccea9482764d48836e551cc12fcf6b50f8a5c72390881cb32bda33dc3d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__487f146e5163a82684d7f6db097d4523423d808609cc3d29833a3927d258bad9(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e27d6bc19db96b7e1bfde917533e85f6da0398b9774ea685071a4690b06367f8(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsCompound]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3fee5bbe2b294b46162b17051cbf34ced961583e88b9d8dc1f5f1ce9ab4beae9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af9949edf4bc3616a8410f99e75d822537fe6c5e104f7d627fe0e649517c9435(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__baca81cc418d743e332891dc0d7989f629111a995aa26cdad9e3881924a8392e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__74ed722a622ca0f8cda1778911aaa2893a59f7588543d6427655d0048a2e3c54(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c13d22aa34e0aae86950bb935371332f438ed3d6d022cdeb6ed2a60e23dc8ba5(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__521df1b5c3e0b267f16caa459b996c0e7ba94433d49fc1aa0cb4acf2eedeb5d6(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsCompoundTransformations]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__77380891af49f6757bccbf81ba4cead1b723bfa5b0a253c136b2f03d2f8db212(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__578f3c570845c36c096a18e48d65ec0d394905cbfd7fcde9e00cc222da9f28ee(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsCompoundTransformations]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1e344ca0f20c99a8b3c3b8aeeacbee6bf4094fa8c409c8463244fbc2ae5c489e(
    *,
    brightness: typing.Optional[builtins.str] = None,
    brightness_var: typing.Optional[builtins.str] = None,
    contrast: typing.Optional[builtins.str] = None,
    contrast_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fa2c9aed6fe007e42aa243f98d0260e18167ec52713a2f01db3dc3af8d667a4a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__57a7c3a4f3f2e87b89b0e3ea710402117aa9f2178946280aa265d8c8125476fc(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__695ba37c29771799e97623468aea80b21492df87beb03423ba8535ef54a3dc22(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__532ee297d77aee8f1b82575b31f94607f7449988b0a204877b9e81df0b8331c6(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e3fb07d037d77a0d5ac413f57b3779f8712e5ca0447d047343e5b33da2bafeb6(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b6038fed4184e786f4da119474a8f7da69d603529fc2cf1a046369715d7209a8(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsContrast]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a5f8857d042bfc1298c4e6f521f9cbbb6109831b506acc32bfc0a0acfe3f5fe4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f20f1ff0a6a6efe55f6adf26c50b4c4e5f83117aacc46e2d65c2330832d97773(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__427b914e2368fd2e6ddd75d49ab2750016f098774e136ce875616e2436fcc1be(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8d722889d0c9ff906cc7dc2dbdbf5d1128720ec8eaedd64b38201d650832064f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c16e4c18f0e6b7cc5095aa209903b0588c8e9ddbcc2fd133e394a1ee09069593(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__82f5856468ac40e5601a42398e903add7eb902cb8c9f737cd4f08dbbf2d57730(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsContrast]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__837c893b24fa5893b9ceb53504df9bc6cb3f62ea852524750e9045e227fa6a75(
    *,
    chaos: typing.Optional[builtins.str] = None,
    chaos_var: typing.Optional[builtins.str] = None,
    density: typing.Optional[builtins.str] = None,
    density_var: typing.Optional[builtins.str] = None,
    power: typing.Optional[builtins.str] = None,
    power_var: typing.Optional[builtins.str] = None,
    seed: typing.Optional[builtins.str] = None,
    seed_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__92bd98c8482952862b8fbef0243fdc14ac77a628446105496be1bf2d31f761ef(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a291d70783bffcc974aa2f5bfc758dda46b4b3422b592ae44b3acafc62acb4da(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ba09e2c9f11045375e9ca9ce1b4ef2df3d420b99a075c619dc75f7869c2449b1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7dc226e7ef27f01a47546c5c1e51c2fad873f6ec68d8cc83561cd3ae1339fdef(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a5225641cf82918ea79e355effd202e271c927e0c930fcfc3efa08429b61526(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__488a3a2a3c9548ac2f48a15e61dd0c03be6b880ebac7fd3d2f7ae4d63bcb1dbe(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsGoop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ee6cb31b41d2454d49eb4adad41bb37c706ac1868e0e05ba6132583d2353165(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__03c2efc12159dc6ab1f1d565a36c69eab2c8467f8f01a2a4597cf48b64f75ced(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__deacad16ebe5e6f237f3440fad3547a4efa712f46b7c37a5624be6204af50b2b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eee51749e62cc3c4b757cc3c0346ed8a27e5445b12a30c68cbf6bbd087c6b953(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__47d0594dde4d619eaa740240e5bdde29b707edbd8f44d10087d2ddaa6dccef30(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a8ce3e35c2ebaea6faec31ae77ea266c34d16e3531c01dfbc84f5e06b9b42d32(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ecc064ac57bed9bf80424cbfce61c8021fcf2b754bc61a0d6b8140f1ac8b5e25(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__692bddcdfaff39f910df81447dd0955d0d5f3e68ed8b486bb135d73a0258b79b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__24a4153d255ea4c73c9a315b409b708ca54ceeffeec1ba7a71c2d9a990ef79b1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__84614352922b2e1007036ddbe82ed135b22afd322aeb6a6909184e6adb6199dc(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsGoop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__33cd0d5321771948a1ea3e370459713d2dc7a4ae6e18bd76679c3e96b9b30d74(
    *,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2f933ce3149ad758e1038d26a397079eace329d0de66ed2aaa3ea7ec5b29a5a4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7e16f7528bfb92fc3a214357b0b9a518d872aedeb8fa52db5d61810122ec8c94(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5852862dce7e0e480e3451baa5a19d56cc13ab04e23fe608a65f4ab711a174c0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f1ba6253e050b3c034b5199df1f0612ee52ae6b3c11cfbbdac30831e117c271(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b8c01355f3ed65b1090b9e633a4310bce03ef9ce6f89060ea7422971ff93fd9b(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c189da86c7ae9d9d824778db22bafb89184dd279998730c42cd3307dc0d426f2(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsGrayscale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6dd362f36ea13690f42093fa44729128b5e0399d71d9c0593d19d67965aa5a3c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f82e777ffbb50a48411f606ce37ca9c9c95a3ee6291a648122ce0f4c28e9f301(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__45c83e3e0716d2b54bf2da1f3878625d987abc654cd2160918c9825ad1dc5726(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8fca06c251aae466f0faeb615af73f3819bf41d8da5b3e1753fbf6b2478b662e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsGrayscale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d2a63c07b532d502f1b6442882be6bb3d10d72643b327e1df2d5e145528b38f6(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness: typing.Optional[builtins.str] = None,
    lightness_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2dde498de802f81a84d85a20aedafe027b77a59b6381a195985dc1da9834a7d7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1a06055f1224fc93c08ff5796f6e83cf690b0110f1ad710feb9eb9363cbe234d(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2bdbf1d60fbd14d57bd7c7bd469de38c77da1182f578a26c314ea8cafdf4b1c7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6d32af8d2766198a260fa05d7dc33eff1dd4cfb886a98f1694764e38d98b8d5f(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f65445b5f3021bcbca2d02df82e862fc4dcb733b923851aaf50fd1e986f7585(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fe7f6fb996e80c08546903be9ab947acef0f5f71979283648c7a09ed8b4750ba(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsHsl]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b89433fa53e1a441f1889bfce8e645cfc8161cd286aba597111055518ea86045(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f9097193359d97b13683d4206fbbf8ad48a6eed21ded64222aaef6d15412eb6c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4cd2f06cc24de5ec11feb695caced89ba71d65fdd779809f159c455cc1440c4f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a7fa6bed1ff71ce7a5641109df1dca56e93571f7e1a0bd00d3bfd4091ac78947(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dc58374895756f47a7c20d9995578a36511412a57feb175a044b0f3a0ab67b34(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__502346a937f770265a2dae513749bbb1e1fe39b0e8b3412267d9241d693bbc06(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__334e9a58d994ef450706e668beca617b5a907fd3881e8df1cdac18b11c50e6a6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__27139d53f40f73adfa23d853db6122c848aede0f6627a9bdf4dae9c024364018(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsHsl]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__845c48a1221b4c2ecd2edd68936b2326dbef29255af9cc050b0dc0ad22dbe32d(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ad8a6fe6ff3d77c9545a32e1741039c963acacf698bf0e9410999d9c142f2761(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e4f02f0520d9efe416a7e36533fd84496ef2aabcac291b49e1f436f6dd4fb02a(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5631e7f1466875d24f4278a467cf24070b5ec61ffdf96cfcbd45fc313b5549ec(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c91e9ebfd5dda465e5ecb17ca31b32ab8d8967428e48bf2351ffc93b595b4c31(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f95410446f142e8d5ad3177c674d62a29718c2a3a43b766a67c7e4db07e8c269(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b847ffde135b01796cecd94dfaea26447064ed87ad11a26bf59b252f884bbd57(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsHsv]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__33067d16c44236d58d22eb232bdeeefd8118380267b2702ff7d9c653b6d088c2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3d072ddb4ab58d7daa37c2ba3843bbf2c5152ea89ff8626bdf84b77d901e0565(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a45e83d905539ebb5fab3383a7222273a77447d9a4615fa2059c35a5c0486c77(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df066d7b0db7ed5c4b08dc654a4540be1f8fd6eaa1580c9ff1e18e665b626ea0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8314232ec1a54288a5583d3ea09c9131a0c392f6bc088a01c1cd83f6ef2146c6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fdc9d0b9815b9887fcdf2d39f4ead91cafdca0742158d93afb8c85f2029de408(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a21a1b312c83c23c8b2acb83d61f4904df1754adcf864c5196f51eed5a73a1fa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e2affe4b3204be90b4d35712ae48a2d16119c7086fd19ddeffbe864859665849(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsHsv]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a8faf5acd5c266f445c86f45b9ba90ed09a5f78d3af19da453b18cbc2d61f809(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfDimensionDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    dimension: typing.Optional[builtins.str] = None,
    dimension_var: typing.Optional[builtins.str] = None,
    equal: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfDimensionEqual, typing.Dict[builtins.str, typing.Any]]] = None,
    greater_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfDimensionGreaterThan, typing.Dict[builtins.str, typing.Any]]] = None,
    less_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfDimensionLessThan, typing.Dict[builtins.str, typing.Any]]] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__94ffe5a593ecf6d3d1ccd644bcac2bee3eccdbdfee2447bff9b930cc5f41473a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a7b46e263b2b70ba40d1a443b5336c8c110d243a88dd31946f36c8730321952(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfDimensionDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__683db23bd6ccf1645442f608a227b84d742120d493696d029585028abdd01c09(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6065fc3dc84a094dd37236b76047c807fdb256943f873978f9d920466ada9c0a(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfDimensionEqual],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eef1b7f5fa423bb0011af31e4e1af1f483106e64ced2a3e96a2a52f2b4e6772a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__111d3ae73eb295d0b2ed2c5c3760577456f0537a65655c74f5832b6e3c7d12f5(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfDimensionGreaterThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__298881d9f5fba807bff3d22ea5a8f3b95604842fbd13d5e6ee15936e3022c43b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d1d8675c7cf75c0abc5d2fba3a0c6204eac2ef07b759151140df15c6345a80a0(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfDimensionLessThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ce1c7f991e00b12b0f52a2b0a05b295723790b8841e2e9ce2d3547de3694b910(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d1d85370712bb03156aca3339325a778d22c81f58159379e09e3734f861e815(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0bb1bacf1c38c8011152ea26c834b7ea9149f9fb11823a3d25b880182eb67d57(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6860c0d30c0d044fbeb22583cd23ec8dc8ef68b46a6c70152b6cf54153e4df92(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__99fc7c7de8dc0bce540314618f065c142719a878c79266135e8024e2fc21bfa2(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a4753d87cb5fd4128abc17645e470f01a761b3e29d9eada13229f481d6954e1e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfDimension]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__acf8e989fd1ac1b2b822c5997444b9847743d8c5a3c38319d093a9e2c7c4d1e6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a03f51295c832517e0b9e7aaf23fb06803315db01ad703ac4696f5f5fd441c63(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cb2e5b67c9c56ddf735fe09025863bd56d365b05fe5482db5dde817859ff2e9a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1b8c5496668dca36776b7a2f83a841b3ec21fff2002d246c4f87a18ae5f03873(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ae3d2fd7b51a6950bd3f86b1d82e1b0ff08f985cf6a8bdada6854846c0e4955f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4fe2a474f909b7692d91c541aa5f8cf026e5b42b1bd948b16fdbad9e599bd480(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfDimension]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a7d26466f323221e8d8e557e75293c8f05bd7f1bc8147436a170c57d8f50f148(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfOrientationDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    landscape: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfOrientationLandscape, typing.Dict[builtins.str, typing.Any]]] = None,
    portrait: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfOrientationPortrait, typing.Dict[builtins.str, typing.Any]]] = None,
    square: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfOrientationSquare, typing.Dict[builtins.str, typing.Any]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__686e22ccc7f609cc6c3bcccdfbeffe1f018d85b74559212c83dde490846dc2d1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df2af4eb017fa15d0dcb060925718c2812b9f4738c0c69f386393d03a8cc6874(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfOrientationDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc74dffc9757d2e2b2bd3b21af6d4c1621a85e2c0ea1f046afee5fce01e760e0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7eefbca0da177401aff14ea82d4d8b03d933e35d2adad73a44c34660015292a8(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfOrientationLandscape],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d52409374b171fc3dc6f34a4e0c84d1be3f7742f513e2a60aaa0ece96009da07(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0a9acd91169eb290a3e601ba152f7011075720b62e2fc0e7c3dffbbf95e45d5d(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__154a355ada5c32de5d7ef8d5b3413ddc78401ff4353fc296a87fe99c67e001a7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__23a9563f4e73b15cf07b1a813ca982c70bec347e0749875578d22e8f78abdb15(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cb931d36c23b9259bce5c30db7b590436ceb66243d513f30fb35dc307620f6fe(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c1a32f00af1f10d41c134a7e27e2ebf4eaa420f663d6a844d6f08120241c6a45(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfOrientation]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f015b37524fd1b0601d280b98f7fed74f832ae2366892fce56485c2ea17dd55(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__efbad3bdc722af82261cd80bd6bea852f1836860e63cad8936d738fcc828342f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfOrientation]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a246283e99c772356c14b192f0aa61dd3a12f8fb3d536e07d89d86387b7ce686(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a29b86f73558e47c0138c372296cefbf925b58b6078363ea76f8534a4fe9438(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfOrientationPortrait],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__482ed60a77db2c345910faebdc7534e3e7c1a782cd6f3ea9ce0ebb4b574f0c6a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4f9b4eaa38db01bbe14a3d68b53a19db3b4add30dfda7f81f1a69f4e32977c3b(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfOrientationSquare],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__521ed6e99694f478f51ec44af4e3caf4039d0a5e175c18bc3c6a9d076641a51a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b4c8b74f9df560129ecd77401a9c4a5c4dbfaf4ab9e62fed461dde0f9e636564(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1b94c16563f7d353bbabebbeed3ef87acfef9b9fb2582bb54f540bf736a04984(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e79ee11dc3922a977525f5e71f8e467dc54aa22b2571c135af518968d1a43d3c(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__80c9806fb114b074bb62bf8d5c8b3c7aa13acd905a1644597154fd9c1a65cae0(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__133e5e59e92bacfc94db7ed7988882783a2ff5bd80610f7d6a566695d6474693(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformations]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__adb9e2bc35aeb80d68e3d9e0e7d1603e6b8cffdaf1446672190ff9fe2060a6a1(
    *,
    colors: typing.Optional[builtins.str] = None,
    colors_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a025a175a323f4cffbfee6847667ca741299daddf4ed54716a09ae0fa34b5e63(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7e1b8cee1af4db9f1ab4eb57aca8e5419ef75fae7429af81412a115964f7ec9e(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__43789855ee69dcc26ba06aa5511d8d93cd8e461135e7b372862c8ace568fb241(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__05df3334a4773ef6068473477c403aaf1285fe6e4a4a160f495af1caf9091c93(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__527e0c5caa861a2bfc1b87dab046bdeaae20859738313f08e2d7757d549e7ca5(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__faf459ce02eba9a72d8f0514a279f41f94d6d30727b27b50288d036a87908a3e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsMaxColors]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__02343f901bf4585d8c68b6885b50c6438da95319e87dcbb421ca2c1accacaaeb(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b974a16aee06ca3f2ef742a53c5a35e9d20716692ddd195778f36fca2c90ddf0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__03c64f87468e7a588f97facb9249d307da0ff58a1bd3b7164c8e380f258874ef(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__748ab5330abd85d0b9ca7fb6397d864bb168ddf88850203b5ff16b93c9091ae5(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsMaxColors]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bee64f8218d4cba23a139105377df618dec07daf59011976054bd9c88de0adc2(
    *,
    horizontal: typing.Optional[builtins.str] = None,
    horizontal_var: typing.Optional[builtins.str] = None,
    vertical: typing.Optional[builtins.str] = None,
    vertical_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__32d6ac89ce5bf9a7fe907e57a15daf77333f7a5fe24fe798da5867db47140597(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a6240fc42d13b0be06852e23a5f22a5eb14a7097fd0eb23c40f8df10981bb337(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__79ab19af80b96ba0d80b1de8c446c06cd9cc45422391f5e9a0e9535c0bc41d84(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f0256876960bfb150be96503e35dbf116a7426ffd64bd384b5ebe6fb95d09011(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac0255b652b79e2c3ba3d25a6590e42d94a5be632759a3d8db4259092b84df26(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a4f4c1539b6ee585aa34a7d313011a50588fe87b740ccad594b22fae1acb69eb(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsMirror]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__679036a766d7211727e5608cab45fafb33ef61399ba8dbb7ecae93dc0db4d17c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1bea1d7dabc98c9b08eeea8e6b1cd5a0496843ce2bfe81a38af7e1dfe91e5986(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__24d3f6b1aada8f721b7a117ffbb83e54b16d878056029800acd5350bda30f7df(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__63000b4acc643dc294b35a362cb50cf1bfd169204b5bfbf85eb8485a2bcf4ed8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5bd5f524800c3dfd3e6d710f49b76ec968389eef359feab015c909d4c1a24493(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__72419afda8348f2ca45cc1ecb08ce5ec916d2189b80bf22e6499cfa7214292d8(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsMirror]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__628aafa195504b0075c5402079b0e137f326e21b8daa8f1ef07db6d59fac27fd(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__933ba4ae81e35ed4bf4258fc7613546e2366ad7706fc41366a6d67c86f8c0c21(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__649ddeaa8ac8aaceddedcf0c0b812dd56a9db7d801fc9b9ba000ee4c8c9a1d04(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7a9b1e3c79ca52e44b803066eb81e0fed1bb3a710fc0a34706fcd41c3e00188a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ba2d607e989ebf4258c85298adf76f9bc9614bbea8d9b5feadc93035db99c08(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__98e82205e67feff4d3dca721e6074ec4c208a4dfdd16d7ba6d2228aed04b030e(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__184c7054f70f1b2183338f528b8d7cca0d66b5e3917ef8223d725d513399491a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsMonoHue]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3e1e8ee4f7e074659e1c23c607c538fd0f13fe09a6e633389b3ee68bc336c880(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e49ad97a84f4bfeb4f0a1dd15cdab9155c943e79d242010089bcaf5276cf333f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4c1b0cb138fe23f600fdc71c910457d133050452d7edd1ecb0d9c15e90547d8a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0bba1a0b78ab31cf268fd1256a162157c2e63941a16441bccec9da96147f4593(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsMonoHue]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1224b3f912adaa3256f391fb784f4d2f5ee8bf72fbc4ff69d741ab9b7f131877(
    *,
    opacity: typing.Optional[builtins.str] = None,
    opacity_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__28b30a4c4438e94ed4b372bb0d2461178913b21460296eed6b26404315327414(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4e15ee191ef78d98e65d2b9b68f3994e9b9e7f93358faaf251c537257b09c4ae(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d5efc5748ed7d725d839e5aa75dd1872d5f25c33141b157f9ff0054176676d56(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__05b065e6794d982eb6071a1edda903f2fca5b1643edca9c494bdf39522bbd2f1(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3f1ddd626013d3d113f79dcf428822f52c05c9bd2b2e9872e70bfc8abf3aa70c(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c5e9c43398889930b2beb2ca78dccf974ac14209c16ad451253e91eb5bc090a1(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsOpacity]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5fa65f3b0fb769e21022216e2a7dc3cfa12a58cfbf97ecd115691a105737681c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__06a2e9bd4ae8ffeec3c8b5d9049189d3f09ef77f9672e0e4295efc4ff3e041d0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab36381bef263ed4ed81381e9690a6d3f2e545c003764ba221f5d1343879fdb9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e7dcf847613805e15f6052c288cc0603f1eee3d40ad99ecfda429d8a36b245e0(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsOpacity]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1e1f0e9dcc4c47f3e858935aa103ade4e8ab6db32dfde4442b06aea8059422ce(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7edf63bca3e0476344699d288d0546cad15dd4b594606542a0a449c6f49cc5c2(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__59bcf412ac44cf15f470b1af630fd89db27eec99f2b33f4b88da81d6768d09b7(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsBlur, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dfbcfc4ad6716b40d78041a4d44c0802c21d7c0db764a1e340710ee674c9e108(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsChromaKey, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bfc3c7a5d081d6a530d6d44f2db2bc1f60a201a34ceb08310a5e7f5611d30dba(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsComposite, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c91fa0bbda942264abf9644f13f3e98c584100a1b62bdbc10675ee362949f058(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsCompound, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__68ba6a1cd351caf6c6b66b7104dd3de80a319bfdac58992da3c57342035f52b3(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsContrast, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f95ae4630f75635650f37be934d4f2249e74fea859aef99bcaf6c3045734d44c(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsGoop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7dd3af9038a64a27d4d48765b02bd6c39ff3608f8bd129c2de08263f2c279b7c(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsGrayscale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0a5e358ea4c27ae8a8771510f328d2966f159b8cb44bc0247f16f0eff9e87971(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsHsl, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9c076a9e029749285c72d8f3b9d33e2ffcc8364ea9f7711759919293ff5f24c2(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsHsv, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__22d52df2c8756b67c039b86b3a8b2e5d5ccf27867a0fb73ad35b74c03012cd68(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfDimension, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__51db7890b2f05a3e43e30b1561ee765e641c80274503a08844618069d4b04427(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1b4b88f29676145cc31426b284d58107074cb28d6aa9671343477e96b22f5f81(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsMaxColors, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d396d4ef85bc9fb572c1c459412a9b59d2a458307df600b9d4a76c6626cfbea6(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsMirror, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__164d2a4cebf3ed0110d2220f98859d9796712c4fb14c852ab33269458a24b188(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsMonoHue, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f0daa28bdaa48ddc58872671b47f60e1133e9abc61f088299c03d89a0138de3e(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsOpacity, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__01ef8aef6667a1e25f530665f3a1d8368310e4d6ebe4c1bca8bc975118572b9f(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsRemoveColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__95ef975b8929b2db583c227d00e276e2923a044158cd8b6416e5c5b508666466(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsUnsharpMask, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__76bfcf03a45e606a343db4321434ad4dec6606c2f65ba407a7dfb4fa0b312499(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformations]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__15945c450a86c62cc15d66d963c97540317eb86d71065dd158a0238fff0dc5e8(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
    feather: typing.Optional[builtins.str] = None,
    feather_var: typing.Optional[builtins.str] = None,
    tolerance: typing.Optional[builtins.str] = None,
    tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8b09f19175da03814d5faf9533da780ef5900396ba3912cb2690be1fcdd27209(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e04affc4d9db8fec44948cab63af99c8b7853e878d654cc1bd25a2fdc6d37667(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9fc5723ea6e7d1cc2a6765b57a837ed6bb3ace8d20a44a46a600d84d6054846a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fa1f6e1212e7a76a8031c545438d57edaa65f1c63eb070c031b592dabd7831aa(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fa5c7ad8f68d6c998a9d6d151de1d55cd0ad95202210c5e947059135f06046c5(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8b24865e0f1dff25533dc835850562f983b821b3d7beead0b92f1cf931bf745b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsRemoveColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__13372854a08e4208eeddb221e7067d1b1c86c38b0f1473950ff289513fab47da(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__52abcfa2c6f6d90a5f2dd8a04e9c15b1c0dd1c9fefdaca41e9022aca22903e1e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6623bfc653ce464d9b27e4b0b0297691dc8736a3b7079483836ff6c24c48af1e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7e3589196e63a8e9458cb5a7095cfa6fef23fa70957a0ba3e793897dfa26e7c7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__42ad2287a9c12336f1282a2026ff4ef73c8d768f5a0ad484902d97df81d03b50(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__acf8214d23a2a1c17cbc1bf0619b727b7d2bfa3ef4bc55a56ed0a4e5f53e5d09(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b245c056187fad9c9c9199207010f583b226897a88470dbd20c5da17b70c8467(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3cfa7bd4e023547ba057466c50e6b10d81eee389d8c429b0a74ddc135dd68aa1(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsRemoveColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__41b15911c0be63bfe7788a9a8cb0e96bd9132202f4abe6439c3f175d2d0ccad7(
    *,
    gain: typing.Optional[builtins.str] = None,
    gain_var: typing.Optional[builtins.str] = None,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
    threshold: typing.Optional[builtins.str] = None,
    threshold_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__058d2f9f8fdd984cfefa0ba0570548ef30c7e2a51d3c55c2bee8f181f2c52fbd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__84304c892fe71908e634dbe009be8ba70754201624bdc0490ebb92f718121c61(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__503e81c52e9f715c53f90c731a4c88823dbcb647c95a5c903995a126d11cd80c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ba146b8bcbd9f83b8f3b0a314d45ac5790d8821577790511bc20e0f5d0ebdfe2(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2e0d97d5b09a09df539760303bec76623aaf18aa9be6e4ce746d8c8931001b6a(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__428682c4d6dc5ed3904872f053fbc4d63c5ffb929f44125e740bf3e3a07e8316(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsUnsharpMask]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d97a0fdf4d29428662cd2f27808e22020b78d67b12b91f6f41a490df1de43348(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9049d397b6f37b19ce2aab33a439d06705489ff2d7a99700a5ff6743f1553324(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4e1253a7bb1c11fe2255088935a0a97935dab759f944e07279e00a629b417be8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__36e663d99857e082eb016d5b559303d9f48983ce06cdd2437d37060fb0460f51(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d60406b786f03007f29fc364e5eb8919a686c7044ca79dbfbaa7d7c07a0688bd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a780051506f6389100f1173913a0efec351785db3c3b3f1a192aaf66adf381f0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a9a883b5094b401f9d4588b275a429dace4e13ad630bffb979f5a43fbae0ed61(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d8fa19ba58eabc8983e709f1ad6a092f467259120b011fe417b9919230e41eab(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompoundTransformationsUnsharpMask]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__80060aba6a94218456b24f009c6cc760e0fae9fbe794ec599155cfd1c8042bb1(
    *,
    brightness: typing.Optional[builtins.str] = None,
    brightness_var: typing.Optional[builtins.str] = None,
    contrast: typing.Optional[builtins.str] = None,
    contrast_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ff7bbf0fc87456bbffd2f855eec522563a60e65ad71eac4df02ca19943045826(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bca2193da9b46ef416a2591000db048bb5d9269aa444fd0ff41a9cabbfdfdeea(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd712dc610d2ac2e98cf28f4d4ababccb2e8b2c71e729549ec6a746f56778641(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a1f9fb3797745d10712d6bd6da78444c03d849e81edc01d0cf62c5942a2caab8(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8749ff8cd2ac13806cdb2266a7f1f062b257d8af3b54f241a5044cab78a36136(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ff9ed6de229f98e75c3c8fda3fb310ccda088c83ec806273b72fe5f72cd9b1ea(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanContrast]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__22147dd71ffb61bc060f7afda90c77007cfe274a9f4694d8c5ff57441118918c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4b46e4bf4b53ce133fae978bb901d53d32d24900250ae2027adcfc14bd1eafac(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ad291dd032173f3edb8d07de30078b284a1337910293bc1172d128d782aeab6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a0bc40edbe65ca2e53656dd1166042b4ce725d0868a1111155f9ba8e4e464bda(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ac0dada099a1d36c8a4d8db4e71271c3de3d20a91a360365b071c17b20cff03(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0dfb54032ed980ae13b26795a56a1913c80b6a1fc154ea864ef46338de658288(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanContrast]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ec09e03b7ab9edfdd88368ab4fc76fee173315ea462533c30735ccd0b4f43bcb(
    *,
    chaos: typing.Optional[builtins.str] = None,
    chaos_var: typing.Optional[builtins.str] = None,
    density: typing.Optional[builtins.str] = None,
    density_var: typing.Optional[builtins.str] = None,
    power: typing.Optional[builtins.str] = None,
    power_var: typing.Optional[builtins.str] = None,
    seed: typing.Optional[builtins.str] = None,
    seed_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a0da73facbe34cead9c91fa6ff388b87f3c2d7634e8904a6bc291b800a62e28d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a3453736b36583b49ef7b0bd3e83c55e5fb12f346aff4a092edb8cadb152158f(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__31225f6ffc0feb9f11198a411b8d8f02cf2bfa067ced453f09a3e0c4f34e2f86(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a8d83d8321e0310c8818c6f04bb7472ae55943c41c7502957fad331f4ab0c95(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c63837dc8668ec2041bb67573e6809d97f0c99bfef598db09583de9959851905(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__150ed55b1397d979450c5c62c6b907ee5c07f33588e38d942a41e398c7d36548(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanGoop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1255061de50856116a65eb69abc95c93b7d84e22773049e8d3ea82ad84a9f0dc(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4d24f611b606bcbbb4064cce95f47dd1f28133eb2fc02d3b5084b4563ad5e045(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f2920851ff4a23898b0e84db087c90066232b3d81282d0afbcddd14f76ca227a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b22f9f89f0f88123c9c4db7c4bb7fe5c790d9322edaa16df53727700fa89e861(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__64edbbd7979d74e5b56cbfa09f28fe9b602e7bde219359b88d81747fba56ef75(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__db152472fc054d43f46536d90cb8810eee6c6119de8bde50f038be2edf427e84(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a2b792fd91dfaad942d495bd98e9a05d3afd1a27068a26eab489abc500e4cba(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f73114743672dba566887e4b082325bc05c1c527870440a4cecb1008a5f48bc9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__597845b9d7e055bb56af8c590e7a0afea15cbedbb5f45e511321feefa38d2056(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e9dd3c2f13413ed1430462b34a36579fab0596cd446cb8d0fb83911d812872cd(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanGoop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a510d23acbd12c7ac832cd025c2a0c0d94bebb8a155e2178236e0ac821d8061(
    *,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f2e251c92762a32ed83b7f65c035325ce9504b709ebe6ede3de8bdf16de480e2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__caa8d11d083d3b10e702f2c3e93800b4ed194bd5b8dd925fb5003be1eebf2f00(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9f297e1a46a1337d9b3cc319a0be8e42ed46c0bad28bbb8997888a7bc0ed3a19(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ce8143d8e569f00ef80621550bab22e2cbceb38bef0d1fc775744aa7e2c2e6e(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d28e067c05f2fdb038b8f2f12c235d0c99515c60e682242c8d0e12f9d1bfc95a(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d8351805ce7e7ed981212da9364b8b788f50249ff1831e1e82902a5010b2598c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanGrayscale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f01ea475561d4d243d6b0556e70e138dd5834346bb4c37c2732889d55866971(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7062892090bbdf9f4dff65a3ead80908f3c4c35205b3a8338ca738832e05fff4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ca43e55a941b556f1b1889f28f99732aa90b732b7230e176f3a9b624e39f16a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b96251985652d16bc0085237d88cff62638b1b5f49a72ce7bfabadf952c51fd8(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanGrayscale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c3c0baa169c160420f7ced3496386130e61488e4266f7e513e077378f67a4619(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness: typing.Optional[builtins.str] = None,
    lightness_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab9f01b2eba3d80fa3413fce119b2b3122b6c3d0c957e0fa80b98e85c250ac31(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d06d3272fd7e9c52edade408ec64fac8596514a6f5de81be948ecc0ffcd15856(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1fd18af39ad59a548e07820862b3acfda2cf8d79600907d5812b509b8b855a65(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9faab00f6b25b4814bfed7b7436d0fca4d7c1302da54c72ce99a8c2c7f9641c5(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__24b2338972344e1cc565de1ac22209c987fa6903e817c9a598c784d3793f5d0f(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__53b5f23ab63f5a30cc010aeb1cdd221047b09ec6bda4fc524cec6acad49cd855(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanHsl]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d59a53bd803c52df3079f1b908addb038064fa35ff261c5b2824f6e040de4fca(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__45759adaa196e9ade56dd9c0bb89a19dac82c5d8b5085daf978d9a132ef70a8e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__07727281ff64ec860d9576ee6d1289094cc9bce216750502190ddf312bf5fdb0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e2485b93c1ca7ad59c6e435754d88da3a52a52f6dab2ff41ef1bf31d1b76ffdb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f9c0572663c6d9f5bf1e867eddfcf33dd6a7f7d48883b9b6f6becfdb1fe1bff1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b4e55f0cde2b3a8e859accdcd75d6486f109e0723e6030c2dacdbc3e66ca9535(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9f50dfcf5d6713476c5be055fffa382ec5cdf3c05b51a856d9384f651fcf3ffb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__15849350d03c092b583675a0d3d4538900054b26692ae1316df05c58e8c36fe0(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanHsl]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d633b9485f6373a87920a4c897fae42bdd83cf9e953e1eacaf2b9a9823cac797(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cf2a6b13ae143b16dc18a116619f776ac2b2d99708fefe761110e2489a5b8890(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d43f24998355450ca023b5005d82cc5893cde18a72208c6f8c27788781a32049(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a3dc3c252ceb07f70647ebf66d2cdac2d0be4bed16cac00dd5967ab7a0f1800a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__16b969999afbbe6340e991c689aee0db072c6428d8b2650a9d3f5028335895a1(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__31b1ebe0a56034d1d724f9a3228198600ec0a99f9091c3e59813f44d82b7e79e(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ef332e0e0b09e0b45e238998ac581f270352093ae11f731407e7e985a7d8aff(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanHsv]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ecde75ae45a0019e45f7975f4082abc0f4377ee97c0e4ca284c436aba0148149(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__20223ae72449cf258c5cd0eb44696fc6c352c1ed55fd566820f3bb4503934cc3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ce323c0a3cf42b0ab64e3cf08b9dbccc350e8beb3296276e6f7a188b28be67cd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8e351350161e401b38e5773666d4e2c25a846b3045fd7072b4dc67c5ae658c3b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c0b73a8e9b279d51474b56f9c4d751482fca91c5493e254213a47a3eb35c2317(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__040e3cc14b03bf978e74699b98f9a3d7049967239612210de4c7333e7009a3b5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ef974fa9d1f9eda0776115f40443a4dc864648e3611f0f381989396168079e6d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a0a2a5cf45b9b5f3c3d264f4bdb367ef19a320828b5cf09bfe5b69ea0dadd209(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanHsv]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__16c6923cba9585a93a71e3800cf6bad8aefa944711459321d8816dfd1817bcde(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    landscape: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscape, typing.Dict[builtins.str, typing.Any]]] = None,
    portrait: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortrait, typing.Dict[builtins.str, typing.Any]]] = None,
    square: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquare, typing.Dict[builtins.str, typing.Any]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bdcb8fe7a36daa363eaacf739c1bafa16f84b366268b14cd7c80a15799d40a12(
    *,
    background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
    chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
    composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
    compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
    contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
    goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
    max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
    opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
    remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__460d3c39c9d80640ac1d685bc65e24981deac0956ea61c331a85cf79c723075d(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__da9a795a283a5ad540216da2339197133f275cabfe022ac4df68e30f13e8464e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b5c6a03fc2bba72c2d707dca98f7b3bb45e3ddcc01acbc66902a58df10e5c27a(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__47456f01780e6e081e9ad1d0cde5e9b7c03f963d0499dbec170221ebb967b71f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1da4cd9d706e2dde5ea6e5f5c0fc73171e0c71f9a05fe4ca5451fd08208ac9f7(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0268c0a1a5c32bd831c5125039ae6f5a49674ec35411462cdd77fc9c487be02e(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6ec3b3fb16e8d568051618b565c904828356b2296ddefcd5fa807798268bbaeb(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultBackgroundColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c6feaffcb265eb8645be350f5e811d165429cc2c619d0d729dc3e909f30feb80(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0bce02603e03b5bac79fb697cb91e6a4a59bd3c88853db07b017f470167eb1cc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eee47357cd8917ccdba2982b5186fee6e79236a975e15bcc6e9ba5e5806b4472(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab8d112f238e48a9de59628af98985932cb543613e897121204404917e2298bd(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultBackgroundColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a0d3e393de9435c04a764c2f5753fbfd27fbc321a5e6538c4b6c361c19998d9e(
    *,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cf12d073fd94701eefeb0754266235946a6f9605a7330e186bff9e8fd0f66603(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cca2f7019fd21493c33b110aaec1bf95e3c3e8ab50722959f8958208e92b96e4(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__73d8876fce23fba375f932bbb5088eb06de31d3ff131d513c502e050e23603bd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__43cff4a31588d1281f8c229f2d6d3c40b27435097eef512555ec1d9d4d5cdb9c(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d62d8935891712a5d272c3905e80ac7d0defa20c0a63e92559c386b50a0550a(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8c00c40de8cca1eb61ee9a43f68df2d99cc3b830d78f9a5709502de86948d6f1(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultBlur]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__97192be23655ff075eb030b29a8ebf1ac5a77b841e04c117a677dc238914ea10(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1042434a885161113b2bcf774d3b747421f0e9bdf4de9280fe06868f206b8f10(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b8d5d0ca88a7a0f59f9464018ff64452cb42bb129685327a866bbb422963807f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8369a5e24d3b8060cfe3c5cdf0fb14785ab4c2d7cc3d315d22acfe3ae79e9544(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultBlur]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7a9b6344c52b3a2af1ddd20291fcc0437feacc6a34b6b942697ffc3a202e2af2(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_feather: typing.Optional[builtins.str] = None,
    hue_feather_var: typing.Optional[builtins.str] = None,
    hue_tolerance: typing.Optional[builtins.str] = None,
    hue_tolerance_var: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness_feather: typing.Optional[builtins.str] = None,
    lightness_feather_var: typing.Optional[builtins.str] = None,
    lightness_tolerance: typing.Optional[builtins.str] = None,
    lightness_tolerance_var: typing.Optional[builtins.str] = None,
    saturation_feather: typing.Optional[builtins.str] = None,
    saturation_feather_var: typing.Optional[builtins.str] = None,
    saturation_tolerance: typing.Optional[builtins.str] = None,
    saturation_tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eef8a2a874cb210d0b8ea75b8b26b366ba8c86a48dd516500ac2ce862a07dc25(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__36cf65809ca3eecb0878490bc2e4aa110bd29bb91cabdd936e432ea7137a7c2b(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ad385fa192e6202453120354de39e3ea0d922b8539a2507827ce6018860ce33(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5827bc7f850bd9cfef2db9ccfaacd5dbebfe1e55fa412d6936587dcc7c23d0d4(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7e3a3476dcd871443f65306fcf6fa3d6febc909fe248601f0ddb476884bc97bd(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b0d6c501e2d37cbb747c27c794827491f6508931595441f71ca83e99b03a352c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultChromaKey]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4480114e4294773fcb8ca65d87dd66b77d57424b5974ccc4e65c2ef58e1816a3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3e9cfd46cbeaafad55068124a9f6f767c97f5b91916dd98b3853ddf1e49af086(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0d7e3b17484c9fe9b42864b1fce792e1fdfc0ddf84efcaece8f954c5b046fd3b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__13eb642ffde37c23487dd0e5f56e3a7bccde6d7865d8a6a6633001a6a45f4c40(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__95eb1f571a4cca856cf59510618a1187aa341140cad443fe7d93a79081394d1a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__75cd14296213759f2477422e1d8e90b92c9518efbbb7d03278be81c20143a123(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b09677dd8c7940b8897805f75b82f3afcb89f679eec2e69cb1b69c1e6eb2e5f0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ca9bc83f2369a72af9e99c34443ebd2a1ed4f7483fe9d075d885c9259df0a4c4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d7f6d2697eca4cfce5a983a6e4e1744493883b9b65cbd0fee22c9c3c145bc39c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ea50321a981ea9e9981d998f679a2bcb2e4f7fda2dc1b2fedd284a1edfa22f7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c2260cff0f5b522a467d55b7702ec4e54b55dd168bf4e029f21af82935a981f8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ce8e02afd4ec96c16cc7032d28384975ff1b0ae1e8d05de92992750195154c8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__05251b4c75277caba16e735fe80b9346d520403ab931bfe0ef51f1de642dca19(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__da0b982efb158f307668d88b16d389b61ecddf0fa60faff2cec042e72daafc43(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e457f6a507899c1b8a237971c1e218a08efa7814a12127e6334b8d2ab5dd1643(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__28fd7c75c05b1e6fdf1ed3de214de19b0b5fe4510d36a912644ae30a1cc0979e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultChromaKey]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__06ee8b84340171e8220f71f34a6d81677eef77fbbf311f9af309548b5c104338(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultCompositeImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    placement: typing.Optional[builtins.str] = None,
    placement_var: typing.Optional[builtins.str] = None,
    scale: typing.Optional[builtins.str] = None,
    scale_dimension: typing.Optional[builtins.str] = None,
    scale_dimension_var: typing.Optional[builtins.str] = None,
    scale_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab28e04346f25fd92703841806d8339a1aabb8e24dbae7bcba555d3068a68238(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0963561a70af347b581037e987d98ce177d2707c92da1f05b54097470d721f68(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultCompositeImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6510e8ecc00fe6778928ed1bf04a7b787aac982206b1b3d5339357e1fba330c3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__29af3296a0de51f28bac257ddf11129a9573ea377440e95130c75b1b70bcbb0a(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab7b362aa71d82ff958295c9de52cc70329221f50012ce46aff9a455e17492d8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6675e148573bc85bb25796ae182027967fad3fef0404bd245e43638ced6960e3(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__24dcb0ea06cba69560c2eba81c9600ff1f3c03cec2be5832018edbabff3a574c(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__40f55d412d5b04331f2025f06afea214c58def7acb949b420425ebad10e8432e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultComposite]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e2225c7368d54c89eb95f87cb97e2e50b2140133131b91da59d2cad4fe22a865(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d79f0c6ac3049038364d0c90d8ed78b80617ab4ed66d3beb0b2dae9e7a727a05(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__76d85691026a9d3989675e7185215dcf12418bb0050947746508c785b23645b0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e4933bba095418adf32fe00de76662be34922daa1d74e3151d4ca0b89dbc8ed(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__481d2fda23f15712c44852d73e7f1daff55d457c7fd77077d071f27ad87fab4d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__420c3c5e634e3072149a1aa58be97eb2f347614c92f685bcf67e4f3a65eda1d9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__998a07026afcdf40ab5394f6ee2406d50ccd02e0f49ec1297f35814de3f50c20(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5a529d808095c2b6f42014b6f0227e27c8f3d9b4249524ba4a4f3e374cdf0ce2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e7d9289c511710c759a9a38f0c87aa869fddc6a42f089b5edf9f0808a5befd82(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e442885ac4daae0ad67c0ce27ef55911ab1d7fcc7542ea5496f43ae8cf0f5a69(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e2aab934528430793680c258cab0844e360f070aa9dcf89aebfc7150cb29805f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a194bbaa1c3bae0f07c8a1e080e53051415cd5471ad4ca1839d066d2c7fdb1d4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__170a160663289289f6cafa98df02f6acfabb7420f722201f9fe8630d57578c1c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__87113d633212ef5afc5238ddf559ae17aaac9cae0073e7a0a1e022d64cdfd33b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultComposite]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__78a475e7708e2e7bb4bde5fd922651ba5768c121110ffce0883b63c3b7fc0a3a(
    *,
    transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6af222c2baccb064da95bd1ff0a20729c61c200afe36620195e25618859d7ded(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c0fffd5feaaf15f5b471f946a1836de3028f1d5c87ea241a7783a33a468aff9e(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__06c943657229bf5c562e67eb4fce4c365357daf1f24466a163406c3646580b9e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d56ce3f267ce38be5667f064db9243b58903388b64f55446a26e4de1245023f(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__82462dbe19c11ce424b6f5fc76978a1edf3750bf558ee112e2b0365ac09d673f(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f075a7c452ad93ab32e6630687e080fd519f961e95a951a0625795bafc80e19e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultCompound]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__893c3bfae0da71fa9a9b10afb4d309d161a3afa1351c303f631713bd11644b34(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d4a766c788e1672250da26b550c991db7fbb8f26693840c2705065af6dae8d35(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__66d22412e913dc36d4397f9014f3b5f17a83dfb3526b2a875ae268d7fe332788(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultCompound]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b2669fd0531e7874d3d8073061aa315006341e8be5249ba3c329aa13211c5da4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c10f2f9d086297d9b035cd34e4043f925f128a91139566b0f1fd34ee8765a6d5(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4c649a6d545cccdc85969fe7e99441e992b1c0c46aa9079f1fc346cb354bb850(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__55a8380f83f7106b6c2e30904f7b08b9e56e2049ce410628d23e023c6393352b(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__73925af45eb03545353320768cddc2adbb764039e47fd13c8dd22aefe0660e31(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0efa7a5707ddebb2ffb67d6373ccd719c090467fbd10060eca7847b2f627caf3(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultCompoundTransformations]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__93fcf67811f3c158442b09645882ed59580b086276ddab799a10d34e6eb6d688(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__53d19bc0d5c9d0abb1efeec946bb8073b7fcbde57799b3dc2d659bfb90ff729a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultCompoundTransformations]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__43f5a721575389f96d6ce47efca1b404d4818adb3fcb0d9474f2329a5b379ab3(
    *,
    brightness: typing.Optional[builtins.str] = None,
    brightness_var: typing.Optional[builtins.str] = None,
    contrast: typing.Optional[builtins.str] = None,
    contrast_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc662201f23dc146f6ab954b95448128f551befe96ed778aa24c586b9cc1ba4b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__56164205f333865c4540550f9d0b55d11b828abff71a096d87081c2d62e29ebb(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__69accd37b68f51181e1733a8e61767c6185ed981dd3c5e2c62c3d3630dabaa1e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ceae83332705eb50703a6f23f0e440722755c57641205eb79473c4750a7d425(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__56ca3a675c985802b63b2875179795120c373a6602805affba8a05f10d7e49ca(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__272b4384323eb58f9d531e27c42ea593859d0f33d9eb0e99bb73a6fb9ac6fcb3(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultContrast]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6a7718756592dc423384d335fa3ea97bcb81b05c54a7318da3fe061bb30ced1e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__28254a0d3807bef79a4bd6ab946a571299b39d1b51c609d6f8f94ba658eef50a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d65d051e262c08219325e4071cef1cfa37048f8bc9955d4fede4fe22f99a2c24(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__662d15e0d0a76f6573f93e9385ba6f79ff6fa13efafa2742bb891d341be50732(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__18903c32c80a24637c18976268e8aaca76afbd59da36125fa39ef8af879868fd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a70b0c258327cb657b9176caa470c7ce2e77d2d3183baa5519bf4c69361ef216(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultContrast]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1727715b548740add1d49b7eafe052270b9c4a415d76d440c8543c8ff790d3b9(
    *,
    chaos: typing.Optional[builtins.str] = None,
    chaos_var: typing.Optional[builtins.str] = None,
    density: typing.Optional[builtins.str] = None,
    density_var: typing.Optional[builtins.str] = None,
    power: typing.Optional[builtins.str] = None,
    power_var: typing.Optional[builtins.str] = None,
    seed: typing.Optional[builtins.str] = None,
    seed_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__94a30451cbb1553b1db0c3e194087775098652c28e84146bce7e4e5f01d2c402(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__865f6a71995559f83823f2873ad0595b32a06fd54be5b333828aa8a9a759558b(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9232e3ca35be25fb19b9aff0c0ca89ae4b1d65c54024856bc50c9e938856ca26(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ae2db63400a76f8b682db995bd4b34e63d9080bd60b126007af1eaec6248790a(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d07289769ab833959f26bd8e70c9eccd3d4e1471b5524a54abe8f175d4fa63a8(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__256bee94e8d46e3c7f391bf99a278cbfc1dd3d9bf4f51ec43b3a45c8ac607e81(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultGoop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c4475ddc9bac9ef20ccfd36ab108de3a0dae0e0ef4aa11b093d9cee1d9ff1987(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6a35e6b07d0887dae8a88bab9439a0e2099c288343f5f44b22e759c477e87fca(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__907f5b588c13263397cbdf4bc681aa16aca50966d84ce8ad3d39d0e0ac2e7a49(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0bd736c373d6933b42cf872aad7b5a0f38d6d5c7f12b78ae912b3e1e458f069b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7f9ff0632da6521dd9d23c2ba096220b53f0ecbe821b87bd4b646e90a8ca761a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d91ce3b04db0deed910f1c096c2c58221595a30ba4751957fa7da0ef757cf137(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e0669117ad910b6c333150d16cf5ec970c856333f950ea2b6ffc265bbf52ea37(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__50d579922eef3c1b47b815e34059fbc4e4343787668b37b8fd3a8acbf2c6baad(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a768fa15938aa6575413ff2c95fd19f9f91761add18fc49f22772bc922c6a90(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a44f4047fe43fa1df29a6c3501dfd8548f41803d6dd6c13844cfd34d9e63aaa(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultGoop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__77ae4264d9e36f2bb79def5d16129e27300cdc6744834bbdb62ad9ffbae1d7b1(
    *,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3317cae27c947a344c7a7e55639fd2c158bf21590207ec6504ee205807af40e2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6874e155b67f7c8a88dfeb87e7e97afb1c100fa6917e2b0730b3ba3200691286(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c62c0b77e94f71aa37782f149ca613e216b69d72719e9925959e441938f95003(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7e245b85c5e1f63826566e538566622e880c74b2a28e67fa5bfce9b6d6185266(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2e78693ab6fc36ad99e7669d70befa1f4853c62cc0aa9d82a8eb97e2c9ce0403(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a1aca137164626a5b346d572fe26a5c786192445a63ce01f578299c7d26b302(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultGrayscale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fdf1e3ec901813f3ececa3132e2e03842658a498723c92d120640855775dbb88(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__29a42d9ceb03e1ee42ce8276db33a552adbede58a702fe29f164627ebdc63f2c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ba207ca304303232e2f1f6e0214d3729e2a25adfa4fe1297eec124c6c3b50130(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__911af5536451f892bf5932cd1c6999b4b93feb81e7be0832af98393864f6cef7(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultGrayscale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2e0565c0bf8cc3ab424845b9d0d00a01226bc83932febf01404c4a4304fa6644(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness: typing.Optional[builtins.str] = None,
    lightness_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__29f423b9ad48a96d5259d4d1407d33dc1717b3336b3d4290d323366fee4b8006(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__86b528572af8de1736330ca01e0494e0b74b6d71b5c19d21a14f1e4188591211(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1291e7871a3d123222b216acc54a2dd0b3f29089f54429654585e83912ed1762(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6a88b296a3319fa9ab3f1990af31e72651dc2c5b95d2920e207a4950e47e3eda(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__db61eebada994c4ef6f557425c8f689ce8636be36741ab976c1998dd85ee9835(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9b40e2f7d4bd7d809c9eda10d589294519160df1c3c519c6826f57ec658b5502(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultHsl]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c6ba1c8e00ce0b79c795b0219e9fd82dcd3f0249d28e20b94f2f2d523b40d6a6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__068854419254c124abd064e5a8305fd5b88aeedd60615fb7cf11aa992951b9c7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f30f2d94298a70f72a92e58197ea59c16cd80e6570daae531dad5e1af96f394(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__178772569aee27c2e3955280bf1fe237b4d7a8701b680fd3cf74897934eb8c7f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a2d0740feccc0a4d152c64187fb7ea39bee805981519d300f5257573232149a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__97fb250524ec7510d8d1fede5ff2fafc2270588f7dd9efcf421802ceb033d348(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8b0a55be7393e23089436623fa01ea38fab8e1555cdb384044783d3de12b840e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__40da64448f81f18c57a610160fd3a347ca1a3787b8e45ab8b93d9a7306b29717(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultHsl]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d74324633366cfb7f43c4b99ca6eeda27ac71826908f71fdd0bc23ac593977e(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c71c3e9119b3b084076679f94db47149932d835d25b76163a05a495d86fd481a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d05bbfd2ac3736d3e078e23cdbe9eada50f12e4d13bf24a6e0b4bfcd6baec275(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b0aaaabecea965c3e55035b305aa79f840d6c52a370af3ca12a4db4b5f5e39c9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__22ed97cd78fafd8ca407b2b14a475ee7191d60fb76995527660a214b1372d6f6(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f22309eba46479db00744602d179e99032008d16fe9339a1eae1dce4d0ac858(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d31bec0d71d51ee13a7919a15a8fd4da5e0afecf2a18e71ff1207dc6d82eb880(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultHsv]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__62d9d289bf2d55fb168904045b1b50d9ca46383981193567f0227b8de7c32fc3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5641170fd27c3f308edfb52c01ea7de81f8e788932252deb1079663bd9231931(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b4e995ee23351bfa033490461dbd6c24886a70b8d85b0fd37a7a91e7fd9f4d9b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__15efc89ed8bce6d38abf92ebdbfde0b986ddcbc100752d26e34bfdbae857d9b9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e22c2721ef43d5609c22e53fc8f4d420348165ebcff13caa3f733b21c3ffce09(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1fea7e0f08529923e08f818cbdc91cbdb81857cb692a2fe2752b15a4f9d05c22(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ede2a445f16d7627264acedfc0c4e8ef864d394306cbb4659715f0050b48069d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d70e983faa31716a4cdb352c4383f0771dda499155ae6806f0896116b9efafaf(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultHsv]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1266761775bd8d78ae958cb869e9ae2dfc46f42c9c2471f34e08fbf321a46f96(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    dimension: typing.Optional[builtins.str] = None,
    dimension_var: typing.Optional[builtins.str] = None,
    equal: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionEqual, typing.Dict[builtins.str, typing.Any]]] = None,
    greater_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionGreaterThan, typing.Dict[builtins.str, typing.Any]]] = None,
    less_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionLessThan, typing.Dict[builtins.str, typing.Any]]] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6958bfdf69c75943dcd93bb4d4d7a9a8bdd04d09ac2c101ee22ee62de7c1dc80(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7f0adc98772a1648e63ce567637b9c7def7327ea51c3624eec55d73fbcffb0b3(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8282de526445c9f575b000df6ea257a4aff68acfbadbbb8ec0fe20295a39885c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f282f136b0c4af5e1e89d73eb971feefc5cc63608cac776f5498c53dfe77eb3e(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionEqual],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__36082c0a298b415da1b1ddf6d94b64c171f2c6e6723c680dc6e5b9b78eb808db(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d618400d048b9630a96c8c4c11514185a5b229f271eb46bfcea02a8d02c9dafc(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionGreaterThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6cfd5d3be6471c60c5dbb53cfeedee6911370b5e79fad5f7ecb4743b0485ac8b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__697b1c4ab6f96240fee0dd03c2bbcaeca151fca59d389f2dcb39a0873b90cd01(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionLessThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e591e39ac742ef374a2df71887fbfc35d31df08a3fb8b1d7f6f7c0454c0c27d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__838f20302e9379e743b7b2f142bc45e845c50c6fc3b1c9b9deebc1c705e56f91(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fe426a27c835eec685ec76ba117117d83876929be46ac2297db66d6bc73238a8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f7de2d35219f2aa67490f8560ec07f1933e59fed78530c1333e3d2053c4ad0f4(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9671f3231a74b9c4b370feb9f39c75bf6ecd21ae0d370ce9798533a5732a3a78(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__99663152586cd6778f71a01de8bdaaa2933a79abed4ae123cb4a132b2497578b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimension]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ad3933a2737858f9eb39af987ceb2511c39954afdf95d343fa9d4462e23cafc6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__403db2903a5d7f5681393080e16f6a34df001a3f27583a59c100309e9b0f71af(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f094f0f0eccf8bc2ae68c4c732b0642e5713d59eb9072ac53f86e89a973b4bfb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fba59a0c41aac3e30bbd0d65d6e650e9c0e913b56ee7ab271af043277631a0d8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__348af317caa5bf2cf5be306b1589852a51ef8c4c4dbc7681152594eeb924d467(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5a4e646e4f8c527ba895bb42a8bfea63ac45d13d0649ee15f71b8d3b470000e1(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimension]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7733262eebf23d441123486a1c9c6971c144c5c0c250c9c70cb745b7db72b48f(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    landscape: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationLandscape, typing.Dict[builtins.str, typing.Any]]] = None,
    portrait: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationPortrait, typing.Dict[builtins.str, typing.Any]]] = None,
    square: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationSquare, typing.Dict[builtins.str, typing.Any]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4e61f33ac8a1f663b0a3f0b152c30778cafd6d30f00edc6bcccc20e3293157dd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__910a2547b7218d024eebf1c9383443b49c755b1888a48969c8fc60bdee157804(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__738366e36470630b99bee0a1d84511a997fc26ee036d4770acd22ab0ff6eabb9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9f42af440dc2c19179d31e7af5d9b4def1f0a43ae61c2a58c147786c704975d7(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationLandscape],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__13edb5c108ba5b980413f867f3fef0022b9f158a9a9bac2602fb3ec832ada746(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__857b448f90b3a4479b50761bea0f67e362fc3472ecdf187ccfeac149ff96d7c1(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8176ad5422155502d6a57f29769d25977b2e2c960eaa099f2eff944ad9a18476(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6905c047af4c44199306dee9d837b01dfd6b5255f57ca864943ea5ec97310019(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b1f16ad537591c380cbe19f40021ccf7e4230f5a819a4fc827095ff12bb03ea1(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5aae8c842690a23f252ec7ff796777b96954cf83ac586b5bf9e7c925ccfae97a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientation]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__037a0454550a62b78aef2760a3e0236bcf2ea0a8570f4073015c1c60849697c6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__92c5952b047d1b5d797bd5e67f358da11eda080903a46c1c6cb420dbe5f9e936(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientation]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a90064a5da66c621366890532b2e4ff5260399aec782ad040f3b7d4c21308ee1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fe58a88d2a9abe5a8336fe0268e044a317f1871c8ed3a0bee1441dafb7bbf003(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationPortrait],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__295898f745e61fbfae89039643707a99c5263c61cb7f7ec8f78d709c9559a1b0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2063980bfad37cab178d635a8ba9540517ec97ce8d166ac94d65a2ecc5d710f6(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationSquare],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f315a36475a82c0f0b0ce4df28953a41bbb39d36f80325ec44871d63f9a1b977(
    *,
    colors: typing.Optional[builtins.str] = None,
    colors_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__596f12d6b55c12b0b06a342c54fd2dbdd87b90c4675182c4b45d63db242289a1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f00bc5489561ad4c753dec4ccfdce12428437b2d3a824a4145249b0a87901a99(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3d9fa42d27994ff8188d3156a5d0955469af62092db4dd7854da105df9e886e0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__edc97837e8072323c7efaee80136af9e5585ee2a3817b9b531821d6dad5a7ae3(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__88f4853b8813d8664763308e6133af2476e0aef87b088756058e9fe943e6e94c(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5459fba41372ecb421f15a7a19586d75ac94576628b22265e0e5c5fff8c9cfe7(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultMaxColors]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__97c815dcc102b410464fc7e9b0f165bd6c8a6d76f2b2a18383c216a4649979d3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d76a334096cbb641ebf625cade63e1eb9f30785eee185f8b606fa2c6d9f2d9d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8b6100025295fe1b1fc874f33cee5c738fbc5193dcb90b0f8fbaf9e22ff0a3b8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ce698e08bca1d6f9d66b6c1230ef26647e2c8839ea0d8c9ac58ee3754e19a950(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultMaxColors]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a684a956e8f3251729da00a6d56af350f672d134ebd2f5909c6436c30d066449(
    *,
    horizontal: typing.Optional[builtins.str] = None,
    horizontal_var: typing.Optional[builtins.str] = None,
    vertical: typing.Optional[builtins.str] = None,
    vertical_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9bd98add09ecd9c2f50a3a49987d767359a71b52aa8ade06c66c1db06a475e52(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4dcaca31017c0be7676463f5d1792cc4621684cbe7ae7588164a53257b97f786(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__675c8ddc8fbc624afbc441e9bab362e5f5ce2ce2d3bc7cd6a5dafcced28fe64a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1587abf9e66d631659a8bbfa5133ce4252beebc352aec18907342a0200e5f10a(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a0bab03d4c2af627ab7be22826b500de8e6b6ff335bd36426cf55a5222d8ad6(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ae4c28b9f366e94496dbe03003aa92821fafceb8c5ed46264fca621c2d05c8d1(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultMirror]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f4d4d432f5a5f12d426bb79cc98012ee25ac3fee93616d402a732825ea1b34fc(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__76bd4aa83a76e50769a401b768f03d1b016b788dc6eedf305b6fea049dcacf6b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f67165bccec71072abb0294904ffb6b1e3e8e1f8366de1c46102ca84f7af8d0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ff02694fab1c90f88926b666d5d3c2f40fda74bb96970de25965011121512b6b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__59282cbe474826793ec1062c72b609b1e78ecf61eb08c6167623c9523c8ba4f6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7efc6466639b42c7222a6ecc966a2a20777f8b54ba4a56496ea68bb74cb16a5b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultMirror]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8ad5e84e328df404f184fb40cd1b89fb9d0c83b0fd676373bd231e4ab4ed740f(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__71066d9d297dd1b98402dd6c276d459ac4c0153e60d03e3b988d6a23fe304ea5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__90b65a4a955604bf354012dac5a61b0f80073af9ea9aba22c197ecf4488fe7c7(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e682e8e5f04dbbc0be1341e8190c33ec1ec43714b8b5a1c58d08edf17a24a803(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9e55b4db01d0346a54bd1ad721da34f927fec700cf9a6383116f853e07163c8c(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c420d04e6bb812e4f73446b7e6e591853009d740fae49731713c8010a1ec3247(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fa37b225a0f64b3d53475e24883bdefbaeef59f72c0ac64cc7c16be91f7a11e5(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultMonoHue]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__86e14cb2a8db0fc4f053517b5c44c3fecc514988efa4af3c6db7785587bd480a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fb879716802204c905fba0f90967e904ebf0251cebc8f38780e52b2a7c9cc6d6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__40e3b2acd4ebc4222024c25a412a40a485aa9649a83996ea5e4a9bc5c9f7ea2d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__24221fe7defcf945a5f5e9f22525e94f23b9d0976683ec3f0c89154f1df1e22b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultMonoHue]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f83de1106c50fb2add4da048ffe702f3472d2a15771b9540b14249fcc5ad0895(
    *,
    opacity: typing.Optional[builtins.str] = None,
    opacity_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a619ed9bfdf7716af2736c389c96045c458b5fd5009640183390c1b3b2d73fc(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d4bba8329dcb50bb1d0d844a6303eaf40a1fff95f4af3b3220a00b77ee9be7d9(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e2a9564ad060017af6c93b6b170268965b6a02273563ebc7c4451f5b79ca48e3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eb97f1dc441b14db68babf27375ea9962e0a7e5295aa4b46582cc4de71584cb6(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c87a2e86e355efd812d8264a6e658522347bf79e6ff94215b25ed868b02ebbf9(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__115bd3f4d8810f0696d6ba51f8b36742fd83ab133c531d847d2f451a60913324(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultOpacity]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fb22bdbf6491a8cd577d612a340ce4af5dc5fcdec4a160ff5bdd61e1d121f691(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__16ad5922792f6e539457c92acfc9a5501d5bf9509eba214505bd4df582d83a83(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7430e11e732da14d53ce971b9b0920437a65d66154fbf026f2da3a0564c25913(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5a02a8b0318f0405de2149e4d01f6d51e0e15b5da58c06147b62d5a82566525a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultOpacity]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4c9e05c89929ebf3e1a886ab0524a2af1d5185e1b1124c598224a52110309932(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__50613441aefc1d5eb7e06e03983976f3d8c81cad39231f266b05eb1b11a3c83b(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__256e0e6feb9602a619e3f075379845a6bff18d423b93eb87dd2d7bc1a122b4ef(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultBlur, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ec015d8cbc42fa0ca912b212d20c49f480b5e7ae89ebc341a147ff9f563349a9(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultChromaKey, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__53507b894adc74a59972c6854fc07547be0e247b2c64f1f28013793547ce5060(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultComposite, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__25dcddf2da45fad5cb6d9cd1f0d7b5c91a5d46f580e60c5b473ca11b54baa43b(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultCompound, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__25345fec16c9184f1d3e51e212512fa30628c204d8edbcef9db4d705d690b122(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultContrast, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__75de6f008df6895bd16afb729dfb55edd536e0dfde654926a354d5c2e6847b34(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultGoop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a3e604905e791d6294e1443d85ea1c17a21202d83a9df40b5f29fb104e825930(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultGrayscale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6d4894f68bd2a4a03cdaa614ce41bddf5f2c6af7e0a441d808ababd31936deea(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultHsl, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cbd225cf298d0f745aede1b774c742ed007d197bb05cf2b5b4bdfa7210a7fbd5(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultHsv, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac6db9e3c76851f3080075a27dd6f394467a43fff3417c6c935a395713d25be8(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimension, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c653cca852db456caac7fb3c61c17bf3ceee796ff2181fa45053188c1656db8c(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4b4525cb8e584da3a907f621e94d66f8c8849bb879f0ab9d8249b25f363eb8bf(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultMaxColors, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dc98d060a7f3548ad1e2d3f332dd71f6e7b14dcda5a1477d0ed23e6af9bdb2b1(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultMirror, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0b68ce6d722132fd651510849edf9b836874f12677c1c0b3f291cc73bc606a77(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultMonoHue, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e9449a0cba6793d971bff310d295e46ba48f9e77db47828f7110975e387eba3f(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultOpacity, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__55449b5b7a9a9806b08eaefe402b6079d880fab8a6be1f4660b20ddf8d4dee4c(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultRemoveColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7ce66e630bc863ee553ae86cea9291836ba4b62fd6d674fda771bec1814b912b(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultUnsharpMask, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__99c5eb9eeffcac7e28be237a1cacb763ad5bfd58ddabca84a34dd9cd6d58e1d6(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e66c47e564094d4d913b45794c1c1297d7f5b59117d8128c005aa2ca546882d0(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
    feather: typing.Optional[builtins.str] = None,
    feather_var: typing.Optional[builtins.str] = None,
    tolerance: typing.Optional[builtins.str] = None,
    tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__376ebdf6474497f820aee2d830f35fea39392eb93cf4889025529b66e61e8876(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7267070f78b4fe7112c6cd32b23c4c450376d30dcabae0e595142b350f827d44(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d3fd639dac02388fa14009934a677904c47dfd64a9c037943e6d289deb331b9d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a58836901ee46de7307ffe42ff623f29fe2a23d4705d9ba57c11792dd2e00fee(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ddf359e587cc77f665924f3aea8984b02b9d2b2f7b004ffd0f0675b24555298(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cf90153293d4f01210f5b78c1b4ac64b0db56b3c583b4234bc677483e515e19c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultRemoveColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__148cf20414e3ce67651242e887bc32b54eafacda0b96f1bc732d8140327c7b05(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__012e8a5f3ba880fd034aa80d34da9e6844ec7c8f0cb3aed42f53e1602cfe258f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4c5f8e20f7ec397db924abc36b9f066b9c0903c7e0d44afb408d21803647fbac(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2cc47a1667ca8248293f359b66fce1aefe7b9902b34f7ed16c167a663891ceff(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__842e6fc2ca67c64e39a45a9d560bafcfe30e7a6451f673f9c6712724f827467f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__20e72c0d273960fd677b88b06dd29512bb251aac1efc2b3a4785bad3e6f0838c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__17cdc164e19a3bd834d9445a6f4fd1bec7bcc940f330310fbcfae22b01670ccf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4d18b959367fbbdcab81cf2c89251e7d691c17159ba5834956cafa1ca186ca2b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultRemoveColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fcdbe91eccf6411872bba7ab5370088635afc20fefc1b17daea346de43e6379a(
    *,
    gain: typing.Optional[builtins.str] = None,
    gain_var: typing.Optional[builtins.str] = None,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
    threshold: typing.Optional[builtins.str] = None,
    threshold_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3250d6de33576b0762dfbc1337a603ae5e53842ef480edeed72eb06461c76615(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__71df996f1853b0f557318441a05c31ee79859000e75aecd1dcaf2022e01da60c(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__99ad67af368e4d73248ff81dfbe04f784cf02b145ac636d9562fb25e46e6ac7e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__582c2a3f7849d0f393b3a5481c890c6ba9443877f94fceaac1ef4eccb123789f(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__70ead67de830506b0f783d9d268c5cce8c04bd0d99d489e1d0d0a20527554b72(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ef24f75783ff52f47b15ed4686d5746dbee79a5a51792f49d2a02924679f9151(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultUnsharpMask]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2c31cd869879e7680696537010e02a7982976400e871e3a4d79f2628f8768d03(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7140e12a477a73aa791a82dffdf0ebac67d71b09f3a434e6601201a15aef3ef0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__09849357a25c4ec25d67cc9b963f4f20f23f4d74b257c0ccd9ce2a29bb450ce3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__69e9d32887ca0daf86fdad6fe4f4fc79e9bb758b99b1418c787895df74508fab(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__15e7b66108b5ea2ca5e87266966abb6b1c9470446516afdba71003e71fc8eef1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d5f8cf552f61b7ee581be8026cf7b8ade9b1f3dd9cb369f69691bd91f34e22fb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bcf335debc2dc939a08e7b9f8105d7b6b0d7636cd6327435cfc2be5c8ea158e9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8ec9128630685c7321849b0fad113ca5f0d822efb2cea8aff0a19ec3a6803183(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultUnsharpMask]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__74057807417b9e37bde4b9b7519e04a729225dcb2ff7fa1ad55afc14b07d26f1(
    *,
    background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
    chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
    composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
    compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
    contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
    goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
    max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
    opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
    remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3c708d0e3e4c91c3d8208b04080a32dfc5a4ef0a45599da40a144ed11f645713(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c38169ae339e81df352bdd1e2b9f432a3b184c1bc0eafbc0f1712815c42e5a48(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__61cd84f0a176e5c50b6b854a77b080ea4f6aa455d7c6c36240075c1d9ac25af8(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__182da7457c6d367b41a7f5afb17ab2450db3b9fc0771d87ed0607cbd947a8c2b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b9f0c8aa846014e8a1ce457d1f7328114655b28cf3e5f23f6adb6dfd00d808e6(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__99e7691bd98a749b5b4344260fa408b00a74389042e6edba3e433a099a752ebc(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__026ef2371c2dd9507e5e2f6f0db3fa1a09e0e367b98b13f654c8e74227e2bf86(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeBackgroundColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b7593df349f0a7b2a49bfbe4608ce123763ee66262264d7ddee5a38ea2a7f35a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e5fc0784198b0726293f64c2d260a9a8120ceca9df8126fa3832a5d6ae353e39(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e6b318c2b6608af1ce31b175951d4ded2186b1bd7f763071c964189c5e069d57(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b5cbd9bbf3928e8032678a6940889224080be51dc3f04e45e7801c5501f0ff9c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeBackgroundColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b03ca5486b8818c28c0ee1b418bb1451671500cd477d5ee3757530221db2c3c6(
    *,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e5511bfa70132da7648a5eee19d721b4856141b88ac4204fbda47f07d1a4f207(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e50f0fcef6c785dcec135c6802301aacc08775f721b7ebd7453ac0eb2d81d8d1(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d68a285ada4ebb2d392c95d16bb14f53edac13d84d77cdb142e14b9c905c9a82(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__844398bee0f847b494f818d68f99ad2e4092e71660d41cc9a5fe8317fba56ca2(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__da321842808b941e35a5ab03f835abdfb5e188a73e17b86cf1210b08e2381a51(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b0923c5778d89b1d7635bec760a96b9c3b99407b290be3e20a53372750abe9be(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeBlur]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b1ad82050f9c3c4d3f534899935de9372790e55f2009bb4a7b4e6654f5eb86b3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5b77cdf277b938ae86a0582e0e512f8e4cdab367e81d618572b18c4251cf2707(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ad21e2787ed91d13999a0c3061ef9dae2c6bcf19f052e28ae77ee0faeff189be(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0384f312a8a53cafac163ed592950d549cf014d20763de94d6ef6f2080f058e8(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeBlur]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8d000a3bbd75917ea036e6de30f033b96bf2837ad58f75074500a1a46fc697fd(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_feather: typing.Optional[builtins.str] = None,
    hue_feather_var: typing.Optional[builtins.str] = None,
    hue_tolerance: typing.Optional[builtins.str] = None,
    hue_tolerance_var: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness_feather: typing.Optional[builtins.str] = None,
    lightness_feather_var: typing.Optional[builtins.str] = None,
    lightness_tolerance: typing.Optional[builtins.str] = None,
    lightness_tolerance_var: typing.Optional[builtins.str] = None,
    saturation_feather: typing.Optional[builtins.str] = None,
    saturation_feather_var: typing.Optional[builtins.str] = None,
    saturation_tolerance: typing.Optional[builtins.str] = None,
    saturation_tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2407d4efc6e835722dabbbe825139de0874aae232a37b4b64e09c51950bfe660(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8b48c4a90c4357465c45b91328c70ce921219969334b351831930ed6837eda7f(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ff3e1a3e30661eb88282b5bb13cd2b465169eab480decea58a0a84a7aa0ff3b5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f7ae1a5736e98b1897cc23bf71e7309284443d6a17f5b0806b24b34006701cfd(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5a09395547a5136b47c588f4ca5c2144abf6492d8d1ad0e9a5e543d37aaeea43(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__799b7267f46b80ec069ba28e003c711d5b31656a2dd1fa7cd8472cc84ff6ca07(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeChromaKey]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e3a8454aa54dcba44163d49b29b8beb9478866dde59c8f191dd6d5806b5aacbe(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6afba74c5819d20fd3e221283d21835cb57a29dc3dce3b7c7922b98c379e4752(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__95d54ce8b4cfdc1967066d87cb9205468041a59eb4fd348235ac347ee791b090(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ce16928faef4bf5b224617c80305810f3bc7da2510d73762aaf1aba7291d9348(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e673ebe0d3684b1a3ae19f7464c719099a0e9af1e63610ea0ad7ce775b64f404(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5569b3026b47390cef09a3b6b3163e7ddccd44634e2eb2f702d70fd988fb1970(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d2552ec3f421431d5e798be157b99c48d592b442beb2a4c2bb8c854327dd3bd8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea6a14ba94c522cc4d4e96d1ea68891523e21b0998eb2e2293c8f36af250e478(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c225afc35d36cdda3219625b553d42b4483d324bc554b0e0a33934c54ad70a4c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c59dc0ac6a29e53965e50db041813f58c8d6f1b035d17887ccd60884e2086718(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5c5b8e7eff8257ce477b06b0bd1bb27d6b76c2efc14c0e4359ca99e302b965e0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f4087f8aeb86d404c6532a328e83fd1f20fef56d02a8d8e0adf78b0ff529b112(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__914d8de66572d6cf3db690e46f65a09fa0b8151057f040190e4464db0bbbcfae(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ba6c46f06d7220aab105261770782b68dc6ed59ee94eb6922e729c3cc63d255(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ecfd789215da6bdf9a68fe0433902921e953b222a05fadacb53ff0ca6c2527e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2870bfb70d9a79c8f4f93f0b765184fabb338fd0205b4caee04f28236c7e2a82(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeChromaKey]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__879b8c37d0b62bf7c750b26e1dd5e0a865f6847964ae055be403817c275c1fae(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompositeImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    placement: typing.Optional[builtins.str] = None,
    placement_var: typing.Optional[builtins.str] = None,
    scale: typing.Optional[builtins.str] = None,
    scale_dimension: typing.Optional[builtins.str] = None,
    scale_dimension_var: typing.Optional[builtins.str] = None,
    scale_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__46ad95b127da9f57440f1a143122eb6e9c1c78bbefbe87f599655aec71c5f82a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4e2eb7294ec9c00635158d2ec97941c174db93c5c291fff848740b28eaf4d076(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompositeImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ed73d51c4f0f39b4c78a8648c718db28bfc0f559c19dbac6625fdf691fdff667(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a7e7d302d3d8f1b20d9e48badb595149f25679cbbb10953103e5c671d9ebfa38(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1ee00e023348a92221939172cf9445a76f02f7a4445e6fab4fa366e77a167177(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__46e90353369f46f1324253e39b638ba1a8d29e248d46142c1cd4050fc1e9a837(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8da4cd2738c15e01dbcea7d7f58b3a6f5d676e3c5a82a4a2b06beb0cd541de2f(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7984c1aefa978849fd640dc20e8cca5e0c369f2ec0961b2bee195eca22414137(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeComposite]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e6c8343ecf2fbb41bc92aa228978fcd46521c717f02016fa95164fc33d23a37c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__103d016042fddf1bb517b1f15712dbdadc08614cefedfbe672a8efed32e8ceda(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__809bbd672dbd16d8ae55c00723b01bbd2535bfdefe64cd61c822fd11502676d0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e2646ba09e440c71181ab3fb557d4defb470c3d1cbecc9c63a5b5bfbbcbeb88a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__19b79b7deafcbfbea753e8142da3075a54588d269bdf9068e918539deda6d3de(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a367fc1a9b1063c584efb3358b8d0400a6b50250ecd9a858ce6d2b2fae8b9d7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ac69cdd504c81416b899286de130b9feab7568fdc6c2c07817e9079a631cac4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b3bffb2134a44658eced10c8c29aa6821c293890f56200d1cb4634842c2bce8f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9458cf6d159638c99b8a478cb0b27be0a3fa6e13c0c2ccac1e20a6224ba16b7e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__03868d038c128acadf998742d837ac8e40ffafaa3c5604e25fe3f69fa59e64a7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__614a8393d9ca7b8e0fc2e0304fcee83a3d444396f8665bcdc0f8012c4fc37439(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__04126803c197c8b719707be1733fb8655b3eb67370d528ef1d8e68cc3d394e28(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__27c146e5674494c526f9fbf0c5f7dea014efe97d870c30859a4733beb97e8ae3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__552842d191a3df32a3821fec6c478edf845900194d9103f6c32e3e5cf98aa416(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeComposite]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c94819f8835248d09e4861024b7a87adf1343759bd153c24769aa0868df93be6(
    *,
    transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6937c70b33f3b361e2758fcb899b3bd36b9b910388afc54c6c3b4f3e8ae75512(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cebf023cd6c122fc9de11d138c27ace7d03aa551a797ddcde458996f04e785be(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f20b5d25999f694ff44e51d9e9925449bf1d9605b5383827bfd466d448854bf4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb6f2b54a9d0c77e879ef323ce7c219ea6e635647da4ca0d617668bf39dccd95(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ce0d854f944417a9b6a47d48c3d3c6f30d8e74417e5e7c31de6eb42857d77ce6(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__61f26be91d78e492471c1e0a0023e28cb1ec86f03e55b04e14553be6018f5e18(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompound]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c62d80e1f75ef5690f378875c068b89fca0031d1235db20adf5c23b454517bd5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a039c72aa282442abaa3d7cbda1d893a382d55731f39e17dafa6326df3e33213(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ec759e3ba5fd2f7bd6e5c2e21e2a7b81092cb9d790590d97cb3b474f67d8049(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompound]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__01efb5470bc6e96f0354dd00f78a9bd9326616bfec4c3b3432d96d11fcbc291d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__443f22c765dcab8b1ae921e1adb14f941b311ee369f899df338ceaceb0470a05(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fe9ef370be3a3cac9089632ac2642f6dba8921e4d290906a3be56bcf468a2024(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7f22cb8f2ef3ca555d4c5985728448a191b2136a22ad2c4f9fb515deb5f68ba7(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__41e46abdc35c276f66326f8e9b6d622c90c49356074277570c9a7e247d10fbf4(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e1af6ea85e8243ff2b7d50102a62f05393a7d5de6d11db8612aabb4b9da97182(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompoundTransformations]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bccd37ab90079887d4a54a8b69fb05ff6e39d7f787c9084283834ce5b6327e16(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9fd8bf8023f8ffefaeae29eb820b578a1e071e9d6578d16022caa87d8c2bccf3(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompoundTransformations]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4bc16ac194cfe128f68c03ba0e67a6c3746d76fbb50876fef5f915877599cbd2(
    *,
    brightness: typing.Optional[builtins.str] = None,
    brightness_var: typing.Optional[builtins.str] = None,
    contrast: typing.Optional[builtins.str] = None,
    contrast_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__26efa185a5e8c714a82130b9a29654369bd98719dcf9929281c9393034114689(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7c948c67299eed5a7cc86c511eb9e771985fed02af6879fda82709a0200c2d50(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5b40936843057d3c17cad54b9676fbc2b66f85789b1c0610f3c5e324c6f100bd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c5090c27fa9143e97bfefd1c16f28ccbfa19dcc873b041624c1f2a770b987ada(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2116fc16096fcd61c7472b14007eb3d2cb31dab682a1171014e2545d562f2e23(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0dffe42fa7720d4103ceec1a2601fe34be69bd3d1667fb194188b334f55be56f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeContrast]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3e8340bd875de79a3253d35e108117907c8f693634906eb142d6c20a931740e7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9388c09d4119deb40d214450e17613dcb37018dca4e2d10709bf754210f1099e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7c2ccb6b51caaf9064bd8b4b44b188117df0bc34807c149265848cee0b00536b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9fdb5a333cd457984a6dd0200e904e53cc96e6e5e84579681a651cdd31e3df8c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9b71ada2431a9bb619213b05582ed68d84dfa4ebbd246e3e5bdaa8df911123dc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1bcb8ba37fc8e4415ce89ce7b4e997d46255c2b1a1d64609c56a779aa721cd8a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeContrast]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b62d66619014add41a601bdcccd1b7a380c099c496c69aae7e34359d3cc1d86e(
    *,
    chaos: typing.Optional[builtins.str] = None,
    chaos_var: typing.Optional[builtins.str] = None,
    density: typing.Optional[builtins.str] = None,
    density_var: typing.Optional[builtins.str] = None,
    power: typing.Optional[builtins.str] = None,
    power_var: typing.Optional[builtins.str] = None,
    seed: typing.Optional[builtins.str] = None,
    seed_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__706cbc7c6335496de747f2263d1f514cfae2ce101cf0adec240a55d1d31a964f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5a9b14a899b660a74221354c4bfad8c5ed0b81e170475a36d986491e5cb54cda(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4959fda8cc68921a8f8b844966a023b05564512a093dcace3ebcde77afa854d6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__965fd1eaed4363698f8c2707c49cd6b729b9847cf74f5a01d6fdef41744c8d8a(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__abfa5c579e4e4c981160d4cafcbff8e6937b55134532239be61586f939e9062e(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c7c5cc5e67e447e17952d7a37f74b8e5b085723a2d31b926d001996e82c30a86(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeGoop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fde31437f5c3d4e2f9fdb8b2203f15f2884b3fd103dc5f3b11c536fdc9fcf592(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4c258e6ea94ae38a4e134304f940e82c35b4641644637c033da886054f69a4d5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f3102755b926b9e9e71b0a2688e2054a688f6acffdd1eaa3e2316097351c0682(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6d7f2a057122665905f898af8f7ae42752e843f95de351ae0fad683a05e6af58(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e06a6ac9609c9623a4800744eceb6d4e853930850394e5737769e8ae384812a6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ef46c65277625e7fe62fc84fbadec55ff0a70c8787ebad8006bbd58dc8d4948(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1b7f7f8f086fee4f56db57ec129f51b648ea2f7367e97f801da687d0dbc3a948(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5c9eaf2e6a2c7da53a0b9eb2b6546f0745f8a0d0c605aadc27af3ce8000716cb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__73b0987f6bccbf013586bb6b0aaf9b2ce4c17c8c90ea0b05d0a667bef9e83c87(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8de39caa5ce01080dd70a5a329ac9996b533a225be0318eced8c710d556d10e0(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeGoop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__36094c180dd8aa09882d2abb80cd464b2a1ef7ad3053825f52427e1f6df6a1bd(
    *,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__59ba88ed05c7f501e85a400cc62b626d78826c64ab85842d5f939403589c7f88(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4229a385ddef89871f01f4e401d6316508c5542193e3af340841481c812322c5(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f3b5a018e3766c0b585764e0a96679bab19f86d66604494ed0e44663db68344b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__57c44e24e15a4600c9a7e21c782f3791927d9e2103ac1415923bd1ae0cd0200b(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__57a1a7d12f9d7c045770a7c19fe0135f42053f8e98e219cf7853f1b458b7e638(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__24de2f4f56eb4431a5d4af11c2d9a100298095b7ca4c715537540b314721a458(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeGrayscale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b99148f426a85e15a1271ce4728a57f8e9b36cf982b7425b12e8ddf9711ad2f9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bfcd76c30dc62a95b9426d4f8c89e7fffd78978223c0acbc0e04bcb05ae78a35(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d891bbb70af76ea8155d5ac7b6b6a271919f8575e8e812a957925fe8817a1fa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b0bd6102182971e7ad3c4ae4415e1d6433dbb4cb6b25d7b831085e32dd78acae(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeGrayscale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__87b4d5542663b02068a7617e1dca5994aa05e3905be31faa306087400fb21784(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness: typing.Optional[builtins.str] = None,
    lightness_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3e008e0c2f05aca2a62330c77b0409233d59990a4d09d8ec287beca0ecc86fa9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c164f7f536a2b9c24af9a83b26ba53441a5a3b9a672bc20476b97a113866431c(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b99724fb9eda6104664e90ef9eb1de72bf01bbbf5392eac5a735a3ee836a1195(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8eaccfcbf7191a6a883e12fe7f6d2ec38df5982fc1a30f793288ea6c23e480f2(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b4cb61e2b2f823f60b9fdc24f7512ba3dcae0bed5e69826588f90e48481f86b9(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2c2753a18580c26314ae9b1cc328f75a1bc96ee735eac1049d672a437669d176(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeHsl]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8b8f7bad0acd39d05ea81d8e49c3d13cbf1bf7896befdd985884cf85462dae04(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__427354693ac73071b1ba3c80b3bbbe2d4ff6455c44fe06eeb11c9ec389da4e57(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e9ae407764607d9f5c745f2b5be48dea095d54b47743a39d3ba6ecf417084862(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__41ed0eccbe6eab9e2ebdb3d93d9e8ca704a1a402846d847fdbbaf9650c85a435(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__161bff45edf0445093aed4816a541d1eb83bab96ae5666eca443ac001daf2b67(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c423ab39727a406e1746df99938cb5569c194c8c9596ad16118e53125d9d7e4c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a688b26a4dd084af53c57bffa1529d669b1ea4887461b6dc4300eb10d99a397(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a5f243a1158c35d3ae46da137d038cf347b6d233cf5024523d1ff00033dfefd(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeHsl]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__13dcc9d9cf6b4a43e5aef4f47a123e8fd6a71879015669b7e75d8f8964e36d52(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6c72c614cd46efa3ef35a539e9ee13f61b75134dc4b4fccac467bee929b3418f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__853c1abd2161cf813d3f3043ae06dedad3026830a80bc5d06b51f518eb03bbaf(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0f6adea6fb21cb0fa4496531a3ee360794945db903161016a6c2c6bb310376ef(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d96e0f2787675be22fcdfb6ae70dc0d036b1fa0fff61409f6e542c9dd99fcb12(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__718bdf3651b9651d96a9ef24879fedcfd5e33278d4adcb86a56be05c92ab4a24(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c37e571a017f1e36d3c98fca64b3975d297a32797969b8bc6ef4885cddac372f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeHsv]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b796880831a4a793da5adabb7757c21755014c659fd867450671330a929da22c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f9fa31c348ed3d4e03ad7920af105870fd8b59eef34fcdcd4eb0f39e4dc806b6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__33f7cbdafd12360068bc97ada011b798db26c1b4cf8c76f8b408e1d1ab704978(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a43d8509b660eb21b7e2860c216b51bdaedaf448756fd1c24eeb60386e0d5fb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__20a4b492f59c4bf408df7344d68f3ad0bf4d320d673f51313fdbc3496ffa89bb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f4c59c083218906f616862d3f63ffbd0589657a624c2d74abd2a641cbb493622(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e479073a996386b58d90c230d1d4b7a99f7f314e5cae4f5dedadfb81af328735(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a9d1cf5dc3d02f58998703ca2ef7d9098c0dd41263390a92fb2017295654970(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeHsv]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__426ca2a445d68471a19fb663e6d666943f0f2ce356b6578f8995b20ca098b318(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    dimension: typing.Optional[builtins.str] = None,
    dimension_var: typing.Optional[builtins.str] = None,
    equal: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionEqual, typing.Dict[builtins.str, typing.Any]]] = None,
    greater_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionGreaterThan, typing.Dict[builtins.str, typing.Any]]] = None,
    less_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionLessThan, typing.Dict[builtins.str, typing.Any]]] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2bdc2298ca45070e16b70b4ed6ecbedfd79c05fcb596b117b3458a5d347814f6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__289593fbf599f7bf0ddace3e67e05e215bb41f5940ae4ff33f113fb1b518e0e3(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c3e1bd8b962ec78c6678a86a9351b4dff7f763ee87576d9c8c1c6eee407e3bf8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__618ea5ca2ea0d5722c3fbe4a3f2e2a31a94bd4688e7067c4720a45212988ac0d(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionEqual],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e4acf1936c106369c68456f249f031f42efba8c5127667d03fbc8a329204d343(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d438c15e750069c91fa101e9dd1363380685a0b80da79e6242d59ac839b6813d(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionGreaterThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3719cdbf34d11cd777b814e9399d47b40c565d86846ced3350cbf357726ce864(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9321724972ea3926b236961ca0834093679365c644695f925aab1599b9ab7821(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionLessThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ca06fb374082cfe325b0a8fe31fb656d9f7644d6f90941e0efb58f29d28013a2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d89390544297c0ec6e90a7782a49bbf15de763b45f4811d7137ae038e7961382(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__836da1d5bb5e6404d263a94e33404f14a8b93c9ae58b38425a4ee6b649b34107(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cbbbfc38fbda4a6e9944973b4e97945765c6f729011871a409dba996e9623b93(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d5d059bd31e1af107cae6216519bdac043ad0aed99b49d7c0f99e26b08ce3052(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1b34f995c1f6960136df89751ace0725387f9956d4b9610f1cc6187f2215c863(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimension]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f55e0160ab5a83b35d695b6619c98eb99a263ba6be96ec980bafdd9343d5f545(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__85553cde1aab107ba5b5d8f0667d447d00e15aa82cbe522b6e194e0cd969f6c3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__41fb95576f2176f8f17d8a0546f468d082e8c07051766f1cba40fa27a7f7d3ef(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c1f1330f128d74180fef728fa91c80df048d12dcd3d84124ced965b38f8273b6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1cba1aa54bc1054bd7a743fc2960bd462a259d6a36c3502af81cd27e55055ad7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4c1e9725faa83503d1992dcfc2fba6b58c1b2a686cdec1e44d8b81c05de2da2d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimension]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__105a3e0b8b20259fadba0472364270e778743f023d54fa7dfb3527e6d69fe463(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    landscape: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationLandscape, typing.Dict[builtins.str, typing.Any]]] = None,
    portrait: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationPortrait, typing.Dict[builtins.str, typing.Any]]] = None,
    square: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationSquare, typing.Dict[builtins.str, typing.Any]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8b8d4f461d5b0e45d272963deaa0cb3cc8d49108269ec2e68eeeaa4e4688b432(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c803b508dc20ecc764e9dc2e235ca36f18ab2e00bfb515bad90dd6b14a303433(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dc4ae8d15e9c38837c356059f8a7e24f38390be6c7916102011bc03f686e9417(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4fedd7445b06b457cefd9f2fff22c25f6c05e86518fc61eab7e1c9f55531454d(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationLandscape],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ca7edd5d73c7c9ef017bc55eb2262faf4bf0196e6fc97ab3cb9fada4f8c7862(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ca8fc88f6e5fb1ce4aeeaefc4b41fb332b91a8b43c4fdbd1e331243e14d65c2c(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f8b3796b131c335d77090513f1749d6efa21adef2092ad1fe9ebcc76a08ceda(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ef2d2479bb83192a7b27a42a52339ee8aa9bc247123f4ea69ce52d44f2231ddb(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3768a575aff176f7da5cb9d465e891c69a502f97cdd51ef43d411ab1561b461d(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__86c6cf0ab3c1c9b2e1b51e4e3333c54824773523ac04de7721ab991b4a87ebfc(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientation]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__34b63b81d471acd1d5686ad330ae5ea4009ffe9fc86a00d4ce7ca21d7343cf66(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__39a55eb2005a760ddd4a22574bf1eb8b45d3c07269e132e01ea4f4d6cca6da41(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientation]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__13464edab2a2d64b48fa819dedfca326442aae212da53c7bc18b6656f820c47b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__15820a1d66d8cc263a17519ba849805139032964dc6a15bc7871d03f8319929f(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationPortrait],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9e7feaf31805f7732e85a3dbd9fa1ddd80879cf92b22cd54bcbdb0d7a63e4fff(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9987db841561e03edd65f0554712475241ed0702778a58d640b216298689c3b4(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationSquare],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__118a874dc2fa541829c346ebe2b7469d36745ed3e6cdb102d7119405cb65c810(
    *,
    colors: typing.Optional[builtins.str] = None,
    colors_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1fdb84276e2d50d714ebb9294f906a87cd99e0a329a735d616081469246b7dee(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f853d387bd130bfc846cc3ec7e3f7fcf0fa9bcaedb7bd3dbdb5810ac37fab7a4(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0f2ba9bcee9c5bc58ea8ab3a8e28956ed45a63e2a81bd324b7333490ec064041(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4e686742a05a55df22f1ca839eee266d701913d50507423ba54735b126c76bd7(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0d48d4a3c348f4f6c60dd2151a8d673aaceff8f2f445411794ca413ea373a855(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1a5d289a1f7c625c9670f73290eaa1f68cfc143b385468b53042d6d8addfaf7a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeMaxColors]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__461234c6289c29d4f8bc349114d7d534a21d1dcd1c3b599fefdb4eec8547412f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__695bd0b1e89e4e69a9e49650f170d96a36c9307759bc3d8affe9cec06e65d821(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2e7f9d4dc696fc2b269eb105595fa824572a30585d458b5ccc35a06ebf0e6a13(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d16d9a9d6252680af2e874a1b76e4bd3ce1ae9d70a06bafbb0657f0f667f24ac(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeMaxColors]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__718984a5b57df32c22c8085af770320c1e786f95445b94b76ce59960e892f63a(
    *,
    horizontal: typing.Optional[builtins.str] = None,
    horizontal_var: typing.Optional[builtins.str] = None,
    vertical: typing.Optional[builtins.str] = None,
    vertical_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6c330d1ac52e52741bc70c4d8acfdf0501600d3b33109e04b6bd545484eb5047(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3206d9b5ab8732fc29a8e53717d41bd68d1240535b3a524da3a350ff1e5cc0d7(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__00d33e9277cf2ab13b48662441c7018eb491770ee937d593cc9c68c6068990da(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fb29a757a2cdc5149d16768cbf5a93e9c8780e698ab8a3ffce78e3485e57442e(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ae7b997ad6dc8298403be1e7f415de33010c98a7463504cb7c07d7f47c459bac(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ab6c09669761264e6d1e0af79df3c045f8fa5f9a41bc64def90b8f66b71a6df(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeMirror]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c1d891b2ed2a627d872dc3994b7a297e197e155eaa406937b3eb4796b7254e51(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4608e5759a70ffe8e78081e3513235f18086c643e4f722ba965ec5d77b5e1cb1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6afc2500477037d902e8ccd99c8ff355709877db00d85ab7cf3b65fb7619542f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__976c083d021f4b83a5c2940b88f5933c78ece2ca4251d9fa3c96227230b695ba(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8d41556d6fd8f97dd4e074808c63fd07e4913f3576586f9a84ce8723dc10dda3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af1fd5b7e59978efe72b748440d82f97cb3ae76468046367d4513fed562df6f0(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeMirror]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__17742550556bbbeecac5727a442c8f17966f54f015a531b66b854290b6f7bf7f(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__41656097bc8a0027db5f213f7099b30213eb3fc99da21d33886d7bd1b91f8aee(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__78ab41610a445e9664364295c79c2e61b9f92311b10ec34235f09b0bf0769ada(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e246816c07da7a106cfb688c582af1fb204be569ff4a93a273841a25865330a1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4b17efc7fd6baacc7ec57a09f7c0532ce561f905e89c9bcda34b23a6e87532cf(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__47d6f658204b00470c0e9b88d203e6ffd9dd093ee3d29a9926190cd6fe6c95e8(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f8f8e8e29c7b218126f9c9a13b462abadf26f36447730f4f6719a15c3a6b62bf(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeMonoHue]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__213f6d87be950b39c51358d8f26ce492cb83af006d0314bbcf9cf7aed340ddca(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f9039e2cd7a6be27db0182816896d470c9e7bc6e919b27d3508a4ec20916a5e7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a5f68bbfc4d5425cad60b86b0b5fceae30251a5fd8e7c2e900fb96586537267a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__95735fb43793f01ca1bc2e1fd37e83bcd74517f5b21e4f2a0de34ac76addccdc(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeMonoHue]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__15a1190b215d152a5be36497209df63a06d782b9d5f1b5454c9d7a1b8d9f2dc1(
    *,
    opacity: typing.Optional[builtins.str] = None,
    opacity_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fcf1dd1a79f8648a72802fccad8ebae30f8d3f996a69cfd50fafd914871bbd07(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2b5d24f21d022453fb8c0b64873e681f668c9959e1ca1d411c68dede900da649(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0de9e75e30afb8d00763760032f80ac9927381631c0ebe88df277beae4f05732(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7c6886817725b2ee4893096d9039b73469f45f14af6488ebe06d66ea95759eae(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d002ed4f813ce4f518a778b7b23ce9cc4ab3f580047ad9ff4d4e8fe823a15e2(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__40bccfdae03ec2b3fa4a3f50fe158816618a0f5c77a17cbc18119c13b4162b58(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeOpacity]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__800ed189f0c060e9627fe8974546bbaa06ff25797e1a0fb441758a853cf7162e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3e744f1cf72f857a5ac6cddf371b446ac1def80b9d78b4ef366b2ced7468cbc0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f54ffa05f31947043e83e1d3e59be4241dc2e8329b6ce26062f38f4d6ecb9f85(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7efba14c40c5af552cb19f69c1fe2f064c9bac36ed03878e131fd8708b36e406(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeOpacity]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8851b38e2126502f6cbe702ddab720ae0e79afbefcfdca9c9750166dffd293eb(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c862680f3c1beed3d292156b0659d37885d825532b947b044eec4ec4821ab691(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f76096c4aacc9477c84d35ba67bb8a8e288ca1e4a0cebc7207263eba415df5e(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeBlur, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__110aed8c3137d217f69f0daaf508241437d3ca6a0cfcb5b4ddf52cff06d960af(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeChromaKey, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df6071bd559616aee19a63ed08deef47c064b8af74ea59c37290dce25a67b557(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeComposite, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d321556a703ab01b326dd3adc06cfa0076397fa2c142e3960244897ffb800825(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompound, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f06236ea113d90eb1bb90e8284f856393c5f1a7583b0412e9b7b53aa9a5e544d(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeContrast, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2f37e5fa100731542831f4138552fce136f2531f24c79cb5f56e5da79a868abf(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeGoop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1a67a2cfa8e08b1128cc4881619113f25a1a2d1bf39eb1e3c35f422f95841cb4(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeGrayscale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8c902cb63c9da3d5af3deb50b45883e6858f21d36581e806a2928b6953949bc1(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeHsl, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea8f658b20d8dc480e9928ac29b2c8bd98dbd5e5c0a09c20268e212c3a5686ca(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeHsv, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__20d6a5116d458aa9a3d67232d4b19a85a4d52906b752e4496771c020f1a49c05(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimension, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c2dbbaf2364ace4f457b7b7377286d235bec6cb94ebe4e9f6d155c1a866378e9(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__34b160e76fa228047ad9c153040e14c54927e02588d723d6cac22e7fcfa510a1(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeMaxColors, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b8c6c85e633f530424374cf378548c67808294d8c0e93fcab661f5c3b85e9668(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeMirror, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e00d349dc156138ed5d82560eea475c1cf86c48ae07b02686143579c5128c467(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeMonoHue, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e076c8054f3323937f15baa5314d81cdf53a7389a06cdf9b3ac42ebb8aa3db8c(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeOpacity, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c065597856c69f36a592d99b2d6c033e4f027c215ba8110338ee49867b520af5(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeRemoveColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__48a405cfad59341365cc81e207c98fc5fd16c5c2681b00438cedc3e58012846f(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeUnsharpMask, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a90e038d4bbf9277a9e0bebe56cea82f8cdf478b67607e54cb62c12fa1802935(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscape],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__184f0df824e18ae06076e2dd7538b5b72a054aa6bbc2569d9da658c79c5aa22c(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
    feather: typing.Optional[builtins.str] = None,
    feather_var: typing.Optional[builtins.str] = None,
    tolerance: typing.Optional[builtins.str] = None,
    tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8f54856dc5d78b0f4f8272bbfc748db595d6e2a05303c578a491bd2ba86617f7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b7d51a2faa64ac59069eadaf4630594687b9a9004f69aed0b79fe3153b9e4cda(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__349a434df5e0c1f8dfc80a37c277047d0bd7d1dcdb50668ca9166fb4f414f92e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a5cc93edcf12a93df74846ce630199c4d16c466b0a60b55d380562017f2aa943(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__67302de9222f083fb813dc64afb448284fa62d1f3073f673bb7be5d57cdf6d49(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a612e133f0f9148febcd3b212e1abe331a8a35a13d82efb4e0fd7b54995d23a1(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeRemoveColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d9c3ce3c159e7ae5451b7f8875478faf722e575de04a880b52abb0b5afb44cb6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e37cb745652aa33ffc3ef86cf91f35f116d02904384b7565b4e45f015b93906c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a99becca4ab18a22c86c8dd8640fe3e8fd2165ec2e58e2c19a6a93d6ac570ff(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__52eec929a5fcc7154fa7abc7e9af8630b036ce91bf964d8a255ce69a34869deb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__67c5a009d2eb8461de449efb404e193521d1920a0cb49411a473af32f1119ffd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c9f6719553a4d2d670fb2dcd803b415b1776cdef6aebf92c0b2085ce64d08214(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8efa74c15f805293c751929272a2daef4e8c6cbce0b76245d82778304542c3b7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0fab5fff98a27fa209d3ab8d721fd0e26d4fdeea3c23308c471f0e959efbf339(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeRemoveColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__18b20d39ab241ba27cea92ee3212b4e4bbca595fc97fcac9e493460da946576e(
    *,
    gain: typing.Optional[builtins.str] = None,
    gain_var: typing.Optional[builtins.str] = None,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
    threshold: typing.Optional[builtins.str] = None,
    threshold_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3e77bfc8638a84dfebe6dcd4ff481b592bb958264809f376f2f7fae3dee37d63(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__15367f7e56382559b6772c107bfa3afb88fd660fc77deca3c9aa9047b975e4a4(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3f436ca3926d69dde670ff29e395fb476f9b09f8f366d0e3f40352b6e3968179(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3f9dd706ce6e029bd482fc19c498f2d92010fd88e98caa9546c0e4937b8afcbd(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e816379f7b4931ebef75db34209a8cd1f0f52e6466f8b55bfdfd0382eefc4068(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8d7b0d0edabddad47ea25589a94d00c18b4f6dd0014c2c4361c8b409e5dee13e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeUnsharpMask]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c6ae23a2f8cb6139b3d51784e4eab3bc6f846c2e345470dc9cf8a389f1259a94(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__358d17410c8231796005d7a0612df1daac5a841267db5bafc166e65bb5af9319(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ada2dc28d8fc9918a2805e03f4403936902126e4ebc60fe3373ca35302ad02e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__36da1f04ba97cc3f9f4158179aebbc6611ae5178e1ad747a23aa276c1d5630b2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9b659564a77482d0c8e580ec97faccd9f8bb599d81a6a4a5e1324e8439ab1c3e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b2856fce806708e3979b1532012db44e5480db69e9688426fc8bb6cac8fdd697(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e58d8b51325c12885b6f66fdbfae3ca773a7e4842a6633e0b12aa941903266d6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cc41299995a88dd33c82b470d1c4c7270464b333f5b6af891f8a9de54c1b6325(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeUnsharpMask]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__64c48cd5dee49c23f452144b9437d8c202f6326fd60cb4b7c864eda0404a89c1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__706b95f8d14862040edab2d57fcd259c53358c9546a57ce889f61113160cbe80(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a8298f4f0f7c915d244bd22c5ee28c415d34a98cb5feeebfbf838a7950980b77(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__abc7fdc9e01d5f44c5977875a4e3f601ba957d8e688838e5f3282b27a0d311b7(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e8ba8e4272edcd528a066fcaa0fb5890d340e3b1dd8ec056254b427274cd0ca7(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__552609309c74c4ca0aa9c8e0ba31260e4f354c4bb35eca6ac7fd8e259af21d7b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientation]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e75794b671f88e6c7abb9c642c8dfcd0ac3866e92c9d2d141f54328fddeb5844(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__08974fcd16cd862c3f63f6913686d8c2d9c994d5bd20557145f7078843404757(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientation]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ccf085e80bb12790582e24f05966973788da19c13960cf911cf8b00b02ab40ab(
    *,
    background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
    chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
    composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
    compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
    contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
    goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
    max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
    opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
    remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__520b45ef87c5d231cc937354bccaf7c5a19abf70ebda24c0eef120b4818bedef(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__94a2274b40d3b422043de3d626d45e518aaa04a3b080ccd99484f26b600d530f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__253a7110c8b12329008100ff982dc3afadabd394bbc295328b344d2bcbffebf2(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__53132e1387ee5c65540d73a1ca7399de8b60e1d824460976be09a166df0243b3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7ac8c32a3dbe9235883ad07b9e98e93ad02fbdccc2d7d4ab79303ec78b4ca638(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f7281912379c30a2a03af52483e9f58106822219eeb9c8461c937cebd8c3e63f(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2b68d1e64eec0538f982e45ffffd53d833c9ca9446ae33b7a76c21670963286b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitBackgroundColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__60defc60f965812c7284ce3c259a765ddb6e592259bf3fa1a93d3dbcbeeb1c7e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b97359bcf475fd3e67338d848a613df9e5c834751e376ee27fb8acdbaef092f6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__73170b7b40dc47c6cb4b5128a50bc95df9f203a1224e5b570f1293d8e2ebf3a1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c3168d76a31da5dfd9c5ff9778a2404f3046dcd44b3233ac56cbc3e1b0f8fe9e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitBackgroundColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bbf38b78492db117bbd9174312094e10fc10a1e0ed4aae13c7cad2cd3f233090(
    *,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b28ab2decbcd867cbe4f7d207dbc1b4cf7706e2f613a73085258765dab8c6585(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__76f24e4c6e61ccdde1810093d41d334d792965aa14503ce2895c65efa4c9455a(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__85f509a9c03b72196d8b93db8c39111cd8f046d194cc9aa92a8d119c4e930a54(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c49534dc5eb9d8a96db81e7525f168c0cb7702cb1a1e89ffb045f5612d2adfc8(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a3102f79586f8c9c4dcb71d4a04f2780d7f40f224c19eda8f7a9965a5b69d42f(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dd9a70cf946e7bca853faa02a542b0e8ec7136753f41fea374c8491e0a06d38d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitBlur]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__24be42c915311bada4af6fc241f6555d96b0d662c1bca95e290949b319462612(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f7abca6522cc5a62c4d96ec068ca6e00d96ee80c2d99c60b8a6e93ac0426ab0a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__158032c89ddee59c312e1a842d68bcc18175573ede26e2c8f599fc4c1d1b3328(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__21fe60439152ce5ff269cbf013de79404f63e92f5522bdf78a8ea4dd5e056af8(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitBlur]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__084289d3b0d478e74016b5d4a60519e690963fbff0a1ce314ed076086a3638c6(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_feather: typing.Optional[builtins.str] = None,
    hue_feather_var: typing.Optional[builtins.str] = None,
    hue_tolerance: typing.Optional[builtins.str] = None,
    hue_tolerance_var: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness_feather: typing.Optional[builtins.str] = None,
    lightness_feather_var: typing.Optional[builtins.str] = None,
    lightness_tolerance: typing.Optional[builtins.str] = None,
    lightness_tolerance_var: typing.Optional[builtins.str] = None,
    saturation_feather: typing.Optional[builtins.str] = None,
    saturation_feather_var: typing.Optional[builtins.str] = None,
    saturation_tolerance: typing.Optional[builtins.str] = None,
    saturation_tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__232feea8d258980349739b6a5fd87243022e68b6a3772bdc14cbddeb244acecd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f5fb906605df697d151af659c99179a6ec8df3c4ff2d01b55d6e77759a0f206d(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4d20b95711bd66197a5d7544c93798884848b86ae5813dd2ab82c32516efc281(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0848bc9d92b147e26defa2ff74de89706a0229cba75777aa432737f94553b221(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__30b4b215a0465fe3ee441e9737476b38e3307709354a6b636325545ade4044be(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__da21e610152be4415e4254582422d89547b3c7c661334aa42a6e0a9126a9d20f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitChromaKey]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fc7f10a2a3d327c20f94d8eec85ee520d55211a29e7e18ed3c20f134d89fbf85(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fa4b38da7f8ce4bfe33fba9316f14b58375fb831d7cdba63c8e10c9c9cadcac6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__04b4330d2b238d49d1f217ca413d82ddd5e5c9facba3c0c26ecb4a00512a0720(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cfb6a75ca44f45ca0d3243b89514f57c03e6c1f6ce1ebae0735ad5b554042b31(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__54c72b0900dfccedf56ff072e32d5f2df88c8d9f18916a056e73ca058cb21c85(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__35ed6258811df8d9053d4fcaad1da83799826b927bc1ec234ccd95c761402d8b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ae245ba64cd3fe17c134607853b4994b8fd72303be1903b8617e18e74d2e58e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e775599854856e2946d2c0202a87c5aa77ae2447aef511c232b091bdd9eb373(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3682b24edf87e54b882efa4018fe5cb422b2fc6766acfe946c7717976f8dde28(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__229ad021729661311647b74d96280910448e524af93a2738914653f1cddc80a6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__42f36c60cb158689dc5d03903486870e462ab2479bca16bb06de578bf9991121(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__64ce21226c87ee2cd1a1f7194ced9bf6a4f76d6b84b7cd054e244d0b346c7a67(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f69eda4dcb72f4e5e1975a39cbaa3578c539f3b169e3568788a5aa3a0c60f512(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a622c6be95481b8633e33f631b509d7142996ff8052661ce24efd97f479507c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dd87cebc6eeb3b34334421b15d90cb36c06cb2914d9d2f498b0c573604b7d99d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f642030b48180faf4948a3923feccfcb630ffe9dc8bbc40de6e6dbb12052e8ab(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitChromaKey]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__baae49c3320dfc833b958f06b01161fa146eed79d5d2067bfc519689d6abcafd(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitCompositeImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    placement: typing.Optional[builtins.str] = None,
    placement_var: typing.Optional[builtins.str] = None,
    scale: typing.Optional[builtins.str] = None,
    scale_dimension: typing.Optional[builtins.str] = None,
    scale_dimension_var: typing.Optional[builtins.str] = None,
    scale_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4535aa483f08fc02954bea5269de3055bbbe7a442c82b62659e923e130899cda(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a2d45d9be23b79ebced5a5553b4df58b113e5368902137ce018ba68e780f520f(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitCompositeImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d925f441f98d3bb2edf50817eac88bb8cca2b4a43bbb52a8e3f56be6b8449d94(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__38f579ec3ca7cd26a1623b956f08514aea19640f68ded1d439906b5c26923cf9(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4fa658ba1099c80e51123b4ce4a2d6f09e14e218ff990cb60af6023af1e63138(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bf0601084a7292c6552201bc241cf9908f798227d44a18d90c9641405b563db0(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af053ddd7c7056537146e8c87346f406534cc3eefdd52f22fc1d1f682a7e8bfc(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__50ecb5c2108956b67337893b85ac65bcaac1ae1aeef1a60ee78aae502ed47266(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitComposite]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d510e6cfe31eb315c3eeb6ddf2d64522fc9f53cc4d14ab18ddf738cc8bcf275(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1cab0744b7df9ed7cba8ed647672d61d3347f2b59622efef2e19dae58f1b5a5c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__172f40a926cdac90430e65b4ecaf21448ffc02ca343f21a6b2ba75b7a3c7a7ff(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8d74ab847d25495ebe5798a531d7ffb2af3d415cd0a7ea7a34121b79f24732e7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ff8bead652c29dde5110e1a5fe132357ce3694b78efd23136cdd4dbed6a39d93(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4aaf0fa9d3b503899b4a66813fea109749afec146d348504d6812747a87b0dd5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3839e607b807660f57a58ff18ba28899514c470a6b4b98d2f2c89c66952657bf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ca69f656391f0b6a0395682f90bcc5dcb1d6c99916e202a38457f634e5538339(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d5b1c622c0431fcc7a190b823316bc5395ae1c88a981a73deb38e73ccc54021(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9664a914e3a813adb24f8d8a62cd20ef267c4cd9599cea9808ca5d312f6ea808(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__916d35ee149ef349568d29ac1d2296f8cc2ba2ff581a01629eb1cc4018f30be8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2b2ecebfdf42b93e436796aec3d6f7590132461dd2e68bcf497c1930341d2b5a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1531169be34a719ae8bfe6793a75c3d76cfa01f4556e5af6f2b506738a86d3f0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a63ac52b3f1cf3417b364cb90285343be72f2f1cd95d800ee2803449fe520c2(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitComposite]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7ea9f2af98b7b05899934f30e0f5ec33efb9a2dd5e3424993eb490a003cdd028(
    *,
    transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fe8c7e05773d44ac2501c210901fb45e162cccfbad6ea3550442c912fe3c8bf3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__316c944451d42177c6feb6978b8ae6ac636db930237aab4e286b58704fa30b1f(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__da6171e1c93e86e3d626a12d2923348b16f7c034ec4a4a87c4ae7201b3cfb843(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d5a1ef3d90ceedb85feb15da6079805bdb07041ae8c4714a66d302acad8d53c1(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e2611e914cea7b567576bee012d6e79828eff7cc71c68d6df181a9107626dd60(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e0472df97b866ea06ec413c5d87cfbbc95c1004e20d964e3d571428067283846(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitCompound]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a26e12ac65827d9626864d5feb6f9b3016b357004fed89f95d7b7b641f8c3c82(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0e8d4afe2bb53653ef4b9d41d78e4ced11930324608f10e1c9adbb44d098d9dd(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c094b84fa32977723811112d0b18d7b23edccf3fd8f3a129997372b1e22b049e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitCompound]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9b3dbb6fbf06f5983bb902e90d6d478fd44695ce2e48d14f98fb4bb5115150d3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f655688589222abf28479ccb543fbe23e600a0282b5ce8da289b51897cd4ff30(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__92e9952f70d0e978f22191b73940f50af01b2c04462172c6c255c6bef9128532(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__91fb70543457c26ce097731d54e5fa58d1ce2f3a183ccb5cf2abb37a668a9d9b(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9e57db023e5f885a71fe4b870670045bb2ed30dcca80430705b23187db3873ea(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__076e258d88c8d7169670b5154add4841176d3e95c7b0c8a122be77587acf7afb(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitCompoundTransformations]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bdcd712bb513c974d0ba9a7ccbf6b698794d5834a2213d4c70a6fa52ec43c9b7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1c3f8a5cfbad72cf27919f9356ffda4cffddd7cb030b529a647c1801bca42fe3(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitCompoundTransformations]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fe315307f25b5b62714994c64501e5a5daf7312a41ff1c635fb70b7f78f1e428(
    *,
    brightness: typing.Optional[builtins.str] = None,
    brightness_var: typing.Optional[builtins.str] = None,
    contrast: typing.Optional[builtins.str] = None,
    contrast_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__41c2036ef657f29bfa27d1ae728127113e9c95373f8e1b70cdbe2b5e46e55d1f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d8150506f1a943d2038f7e5d031df39fe63b51322da8f50f9d19eb701c0f33c7(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__541a79b268ba4feb2bdb8adb6f4ea8f400fe5ba4a1ccc332b9659c7cdd1d88cf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b54448dbeb76402f3e4d9927d06fc82cc8daac5adc9ab43cb8fc88272be20982(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a31fafce11b38e27dc945f2a025dc98dd622fdbde12785d444dbe95e658ba009(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e42a8f625fde4ce5237747efe8923d4fbb4c578d74547c1206edd86d36dd0c3a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitContrast]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dd8c4d68bb3848ad159c99299bfe8cffcc0c96d3c624efcd6f3e7a6012603fe2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1e4667309f7b64063abd5dec809125edfe02fa52c63128c3269d77e31974e578(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6aa300549f538f6c048278ab724e16315fa25779f4bc1993b27c2f1f6168da3b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__62bf018b181638778bfee495cfc6111ee9d38c9c74dfd6abab2c8a9aa68ac4aa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7631e701302aaa41271196b87b39faf08af5bf1b9f380f87df98fc4f76c1ece3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a2eaa46b6bd902568378c88d82efde2e712bc0ddb1b0131f5b3d10702c4d7e54(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitContrast]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__914ba5c990f456d5f9a188430bfaae866ab814b64da781c1c612fc6d1bcfa464(
    *,
    chaos: typing.Optional[builtins.str] = None,
    chaos_var: typing.Optional[builtins.str] = None,
    density: typing.Optional[builtins.str] = None,
    density_var: typing.Optional[builtins.str] = None,
    power: typing.Optional[builtins.str] = None,
    power_var: typing.Optional[builtins.str] = None,
    seed: typing.Optional[builtins.str] = None,
    seed_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ed4f6d182b0766b737dfe3c058ac952169c4bb0d882e6755f2618632b513bf64(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9e5398f2dfe963b283bcd3147c3b5c539779136abc0bfed50972ecc8ef143fc4(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4e7027e78bc38245a1107ab5a83cb8788f83af1842eed69b850def828da29919(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d9027042e613e6cb98a028a1e889052a86c9f69ba07b5daaca1a3f538e90afaf(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__88f2fa31788b5a96380ecf113ec71c1f7243e0b2a0f411f699b20c5bba014060(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3513808f3568ba850b3fc499fd638794dceba9fbceb4c644988b70c03c9fab79(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitGoop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4979b9a08fd918215c73b17d9a7e0ccba9e3a6afabcffb834033eb6a52997c8c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__995a7cdcd27c1523bf812b113861bf829227939a6029548a4fbc47498edab99a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dbf4a7927057e3985e0ca45c825c252e4bba25d6d0a4255fadbafc4a1320fa24(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__216b46fedf2782487743316487b152c9da80cc33f3b0e7a68de6e65575dfca9a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c01ac625157f850e92fceb087ae8e1f5cdea0f769a960cfd525121ed7ef0afa3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9e485bf652c1aaf368a09e87f4a7d6084b0326f8fca97907281ac007fda648c5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fd8456f8f14026941fdfb9c26fba3d99d81034ae0bea59ed2ba34f8f2a17daa2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__021a04ae8927475a869e5b9af82db60be620bcb20d5217517b6bb85d045d6447(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__28058984f5abf9b0047d58537c33defbc3b11c1780cc2c23fa758e79de215f1c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b4030777381d1735998cf1cca93e71b63db2281ea77feb83cbd46eeb5551dca7(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitGoop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__57f22576dcce92604154bbfcfb2e8bc528a1772f470a7c17ec5afce2b54b6d51(
    *,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__059cc072ad217baff365536ee6a50c3345466b89bef9a3746f1c0ca9bd1c5080(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__476953079f98e9cae84f753b40f1ba20f9c7e855c719b86439abfbea129c4223(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d5d1896618fceedd2dc531d781bc7c557c34b3a1e8a4ec887f491bc127b1d08a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a24c11e50b33391e2db643044f9725f9730ae9bbb3877b7e546cbadd22c12b1c(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__35df3ec70b0c1668bd097bad12a464b102e101c6e66ced3cc3bdeaf8a94940a4(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0244c092e3db48c61a03f5eb195464be2431cd5013d02cdc7f97bf99dde87e97(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitGrayscale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1d8add85b393417f739aa5c952f1d4a192d929703f3310010406f5335c5b0313(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c0758817c15b6a9970279ee44e51fbda8cfbbb07612e06c34239c39966965e84(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__53ed35f34420d2ec128787100f7697e9a91ae92de576708e745666e97c9d8c08(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cff7e7a2039d25de4eb398a0384e9c413b3c37ce534adbf5c433aba5df2ea8f9(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitGrayscale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__147d0b454bda6804de033685e7258ce3f715bba45bb6ee755c68ff7b0c3687c7(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness: typing.Optional[builtins.str] = None,
    lightness_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__08852092f6c78c616f01221b53b58bc13b4ff92543d5c1c661f24389a6bcebb2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ca5909d9f1ed2b3dcc883749d45be73dfd0ae761f1ae7b68ed06a679a3c172a1(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__14f58d06dbb4a98c4aefc3f6a5dcff3db83e5e3a00900341219c1cbb3708b066(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__842ba712d8f18e18bb70bf46f26f86a0c30ef94be9906869a11804bb57df9614(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e210185d1dc454287231465425a118ab7c4f2820e80556e5f00c83d2978068d2(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3114f2f536d18acf2a13b8dd60cac621d746a127061084fe361c69d319ed796a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitHsl]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__37ed707843e1b674e93e5a505dfe2a333b629e536690de992505ea9684975907(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d463f0f46f9c1df1fd97524aa7f575626c11d798754251a06d158f80ff21b8d9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0564bcee5997590823a69eefd43de93f9beeac90cd0df5c24260c5e38f1911e4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8e607403bb7d2142f2341af35eb9e43e48901adfa82b7fdf59e3c6cbf5a76b7b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f7c3cb901e79f01601fb1c755b4bad51e5b1aa3d3d1595210f1e48122794e837(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__65eaf05646df5aede9a08cd91de577b4e7d1e806a24862e460b147ea9283aad4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dbc608e7622fcedb1a4adf4f97c56b016119f71c27a54c8fd04a138148e02b81(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__884b622f9c7c3c71056e304388358a631f78f90d2a119b9a48bb1aa76f5bac14(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitHsl]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ebb4d236938361dc161d987b01d73c975aa962542da5571fa40e0c8d8dbe8d93(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d8dfd0d6ba8cd7dc537fc281d94f7c684372a234fde1b4219b5269dada6c9f3d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3b48bceea1af563e494ab8386c4e0e2ce88ea6a73d0d05869db1a786653ba6e3(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__03c97daec16fd5fb263e11c418be14336461de42ce6b3312f85ea1849bfd82ea(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7730e24ae717b451466b859674289f8121d49806b2080d221a1abc84cb883aac(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__edb585fb713408cc67be10c75e126cb481beb4e0caaa4310456d73995413990f(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b17f0e0448c9b122324d29dbdfafdbc36709fcce2ecccc792c6d2af41c121cc8(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitHsv]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb28424a2ca9fa984f48217097f8f570cb4e73572ed6254414e9675a7134d278(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5b05f7e7d9284ed8f8dcc9077f07ed3add6952aa2176dfb2d80963e1fa9ed84e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7eaa454f59ce26646f49a0ac450f22806ef3e05768cd95947a5df1b756cae7d3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__098cecd033aa28c42711cbb405b0d0cb6d5472016c3e019daca1701c5a39be64(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__779e83db07d5c5e68ca8e18f4af0cc319e54a6a02b10828b8cde0ae886c52022(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6218ea7dd628fe49dfc3f1bfdcd182f2e1b4e77c97e4f0808651d5c6d528da1c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0e99d09d3ecc1af2eb3e564143951b962e8bd9a2b290f64dd100cc955799afbd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af369136d5327c3c12e04e86a68b37e7be827e714e1dd1a70aa9efd28f844749(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitHsv]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d5ae19a2cdc33eed4eb58ca1231533644a1877f0878884655d17f1e9bd380cbb(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    dimension: typing.Optional[builtins.str] = None,
    dimension_var: typing.Optional[builtins.str] = None,
    equal: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionEqual, typing.Dict[builtins.str, typing.Any]]] = None,
    greater_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionGreaterThan, typing.Dict[builtins.str, typing.Any]]] = None,
    less_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionLessThan, typing.Dict[builtins.str, typing.Any]]] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6b4177daf79d8db3cf292aef84cbcb37b3f64ffe0a6ec72ffd871154957783c6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__162e54a77d58a0318b8b8efe9c2a84385c8efd31df1142502c459da3c6387822(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__37acbe20ab8c77b6d5fe3bd8b2e7038b245c48ad6afbc5d6dafac98f3075d75d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__66b1d32c43d9291e9805cff1d7510967537f8a45ac4c52cf7ec66a84b6eabe83(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionEqual],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3010ccec2bddc3aa900dd8f4035241052bf4966f3196fbf764d29812a612c3e4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__56dd19fa6e4eeaa392bb4da594bfaf02e04f16d2caeb0a509a275797458889e4(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionGreaterThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f5fada983a36087d540c64cecff1e974ba23a2dd1d293f16cf707f24d5619c7c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__690022e7868ea40ac9875640bfa49c8be1bba5f1610c023f26aa81cf75794cfc(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionLessThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__73f9360fcf196eb817f4a9d946f0c36b8fdd6e81fc0d3115fd8c43d899adf968(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__46ed390f4105ff90c2ab57667f8be55676022d1bc9ecc09f71131afacf2d7567(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__edbd4a5db618e0f933eb8c8fb2534bac3b3869c89794e135ffd3c91d6be9e06b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__678d90dea4a501a457a370487762466b8ea7d840492759b5049bd34003956f49(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3baf832feb3b88ee7bc9611859b5b40a6e5ad1d685537d2b88c84e9e078714fa(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9dbfce985d4e15f6988f47e01dfa0032c122dde2d1358b51e203b642fb37cbbe(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimension]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8fedf0edc9920a3975356bd53d9a82ad67be4c8fb98c205b66c7960fd2cf61ff(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9c022a084272c98cd526c9fc0014ac6628a6d64fe99776dc2a3873f24001227c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__529be2d6f210c5876659439e375bd8f5203b5888a7360c0b83e4ff9ed2858ae7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c63630a5e64642f9940d587a73c20d9268712b27cd57f747a67bc444ed67115f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6adf0f03568286368aa70246ee7e69c8144132d97dc4d0946099bd2d6e4608a4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__61d54acd941db4a99668619892ed9e3894c0c31d9b4c72e5d044cc9ab0520b2d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimension]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e64a4f09610a40446c4edee302433d4b5a734eadf0942d0f3ee2a0017332bf85(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    landscape: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationLandscape, typing.Dict[builtins.str, typing.Any]]] = None,
    portrait: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationPortrait, typing.Dict[builtins.str, typing.Any]]] = None,
    square: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationSquare, typing.Dict[builtins.str, typing.Any]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b5ba81b65550ceb811ecda27b4389966394a7fb613d67c1f7d02825a0c34ee4a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d81a8f91132f16d99c0cf75cb9c2dfaca11779892137b606ddb793e6f0e69e5e(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e2060797f5818ee0aa0d63c195b6910f5e578255e2afdf4f1cfbe2dc889261a9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__31e2d90d3891f7d06c78581cd3eddfb049fb56169f6b49332d2d3c93ecf4c470(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationLandscape],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__368afbc815bde1176678630805917c8a1006930fda2e4660843d5fb8d4129c24(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__77c4d4894a48f3b553e644c92a3064d9b0fe6003a185f7f02fc881cdd910bfe8(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c34b1fdb9ffa32f752f36f96e8fa9b85236a7473dc1dd709b20216590e1c551d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__487cddf98296cb855e41b3f05f6c85c8af7f3f347f8e7413cc4367f50f355da9(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b95c47b0c05c4344e15c5a1082fda020aab389e1937f9554cd4243d56a896d1b(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__53afecf1d6929a05cef79f0aee432e520d3456da52a8ba13b871415b216d046b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientation]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__438f10e8d5d93da97d2b1f5f30c21523e508909b75268a9109b6229b36eb6b1f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b025c8fd091406cb2a73d28a9654f599ffb59882353173fa145d32f88b1d4fe4(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientation]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__68ff9637b55346d9bef82e65b2b3b840771daf61a85d7fd79bdcc10d522f89a0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__da211956d50b852794be3d3c03b1027b88bdf13c1672e42a3749d1f3063f8105(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationPortrait],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__518175753908f31843ebc41618d1901da6cf7a3e50eb5870f93f711f6be3d566(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b078d1e2b5a0689afab70930efd78a6995edb76974826a207536df681a19e38a(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationSquare],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__79c9053142e278030eec6402a51c4e4a576570974fa32c7718c873f04f8fe310(
    *,
    colors: typing.Optional[builtins.str] = None,
    colors_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__936c8b9a7e70cc7122e167b2c10c2294f45e7988dcb885fc862486a2129a38ce(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b375a4c7e691a6e0b6288b7f46e9a1d8cf84b0ccbda826106af8c31f83770fbb(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__932df9cf3e6dacc2a70d3589fe6b2823c1bb8701c9bcb94055eafa089f46e896(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__077da1488f3528397687767ffb192e4d15907da81f60d0b3affc561040686617(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fb5b61a0090fbb7e06b2dfd3e5ed9924f9a5b2967b670d1f84cfe575f29caf0f(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3290a6ac147ec982e80f6b0321e0c89832f372ef264e673b8d5a1e7356ed2ef9(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitMaxColors]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5031874097c3d7475f8d4a27c085d26516bbe54c7ef08df9578b01be1d1e2f76(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9dfa93f9e0c21e3100a152b512849603dce03314c66a25ee7e70c8e12aa1158e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a4b59add09a9589748bf149f6fd542002117aeedf2e71521e38e5c726ee63b40(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e0f32fe916c70991e43cf610759a214c6e5de6f639d7807110829d4cb34cf72c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitMaxColors]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__30cb37476b929bef65376c86cff69f65c6b9e253a07a108144d8f35fb116b226(
    *,
    horizontal: typing.Optional[builtins.str] = None,
    horizontal_var: typing.Optional[builtins.str] = None,
    vertical: typing.Optional[builtins.str] = None,
    vertical_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b3b8c5aed2cbe7d4dd2aa86a879d1c870ace45293b6492b42d0c01769a4e2054(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__67b6b5ac36e78de3a25660adc3569bea82e222e4147322cd7ead5db2bc97498c(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e74b4a7e6993201c4c8754e6fa5923701975cb767279f148e16ab0a40d76e944(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__15c97681d524282e863299c667c06a4527a968e330855074473fc763195dfc72(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3b54359c572a5f46e0522563baab23516e5fb3640a40f8cdc74a2ff9cf1ef965(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ce356ce811127b7165ce10bfd5f3ff5ce88e9b274ba1b508bd1d9c443af9f129(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitMirror]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eecb82953104ad50496b0869461b3b6b1c01bc30d60ee7c921df5344c0d48ac5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ede4ff0a8f072ee95fea49c2f921c380370ceb89a884f08d46234f5f17075b8e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__33b4747fdd741145e79bcf9b9a4e317e72c022056c069123c898f868c76a681a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dc5db4dd2f4d6422718a7516a0d1e8a14abcdd7f87b37e2fc56da2a809c746e0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f55e6b5c23b6ea88554a4ab33852dccb1f04f8e4db3d399f3305c5b68b0f8bc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a4c63924e04e4138f938ae89111e201e439f0a6af0f023fc014d3e4384aef665(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitMirror]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fdbde2d664cd8ab291a749037ab2103ed50880a043f625b37532a5b6e39133c5(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f3da579b1aeb7a9c661131f2127f453cc492c2a88dd599a098c076713c7b7763(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6ca149f6b2ad1ccb5d44034b489f5dc02f26935e18945c63fc09bf90cb3705b3(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__21a3940e35d5fd756ffb49fb06a47268d6fb79b1da148997326c9f9c950159e9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8de1681e34569f20a5629924d84520de4a663fccf5297f82f038e2b538825e98(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9bc012a98ba2a271e3e75349aca99417435c673eb95d0e72a22075cbd520b958(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b192d43deb08f55cec8968a58ce2ef4a0f3f4afdbd243317d51af738e28eb6e9(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitMonoHue]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a0c42d992cdfd6385c516e6b5f8b6c0d322d546abb5c8e10e093f38d3e8f5c8b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__860b34c1ec7b622839ddb4290d355bd0d545bd271a6866a929ee81ba8de8e64b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f3d662c308ff934fc5c7ae3ab7bca6eb303af845e391ce7d7f65a647e05d482(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__31f6db3c51386ceebfa987755a711ab1f1bbbc80e1c96199cb89503412805fe3(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitMonoHue]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b666ede5d8b62d1a91f7143986757ee248eee8c4d98c5601139e9b21bf2183b7(
    *,
    opacity: typing.Optional[builtins.str] = None,
    opacity_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d88e01056a8a0dded3c39482caea4a291d282c3324d26e4fa36c542a5b6958d9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4fa9f13bcdb83634190b1e5e7843ffb3eba8688967e2000973982753a8333f69(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c49294ea5a7fb9ab93ff54fcc5f6effb965321ada7f3d1230c392dafb336c8ed(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__52d04e83a42f20a4f23c85992b4c7e3610a9c45664270d335396f1835f4c3d2d(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3063f4bd40f039a949285ee2ad6cdeb01f3bc4be09234c41ec6b2981c6e2d239(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2fe7e9601b9d75e6fe97d9d509b3864b74848aa25cd2cc6ba5f5baa4bf36abbe(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitOpacity]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__138ce017a82cb3e80b1f44e4bb59f6a2daa9984848f655f496aefa38af6ad99d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__85bc94894320c14627fc49778c9cef025fb4bf89bb646f2f17b914b554be54c3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1cfe99147e64114e131308038cd642a3810f7cf8e2613b90a02ba6bda79cbccf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1a54af3916b8ca0c5630796737877beb01cce3201dad9c01eecdbdde3a77ee67(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitOpacity]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eb74982dc289137f17d8f8bcf38f92a4c1a8177c5ff6204d9de3f4b12a0f1f29(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0c123bb82b7f31dbae755e7d2b23629dc46179194311a5ba4551efd10d08072a(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bad32d5ac244addbfc7c030d66b194d36fe983411abd90b6a428906171b546d6(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitBlur, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df34f1266b7bfcb731d07826afe46f898060cdb7d63926c0c5fe8c717b11a3f3(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitChromaKey, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0589385ba8fe80edd8e191fdfc3fdbd5a0172c56c5105c52673e5949958454e5(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitComposite, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__56c6c393c374cf74e156066f105a2aa003352611adbe85415daa04069afb2ced(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitCompound, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5fd2fd329d134708238b50238f9b7f0d7ad264ce8459c7cd308e185f7ae8e465(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitContrast, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ae21a641302da74ade7b252ccdebb7d7c1f5ee702ce3469daa9c5d1d482512a(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitGoop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e8631dbf41596af73dc32fcf89fac583813bc76043082a1f58493f32dc0895f8(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitGrayscale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c28116f2d7295d29781b012fc9f79b614ddc68e63303795b1a53a885c67648c7(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitHsl, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__34ad26273b0a573ecf7c719c5925e93ef8615efbede22ebc38db42cb70865c74(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitHsv, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a6a5dfa0479066519094de29d1965b61ab0a77a16cbd50faed4ae9941e8ae09c(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimension, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__60b5598438ed419b4e67219881376039c314fb89d0f1c894343d729f0da0abc0(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8e70651d87512fb565a9c10b0e7e4a15f391fadf6b1e5fc38f2da4472150a74d(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitMaxColors, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__55f32ef8defb87c2eb79fc9e5c27947dd0d8b5e3b338ceb6ece97422e3799886(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitMirror, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d5958cace0fac0828b46a99243945cb1a4eb765778f0b5550c916d9da93dd795(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitMonoHue, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__93d5be0b75387a565dbcb8481bd8b36f012783eb32467addbc7f431f9961eea0(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitOpacity, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac3a6b12bd6e094fb5dcfb2b2a3aee05f9375613ab0ab169770850cc6ba24a44(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitRemoveColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4201b189c828da246e527d238fbd1631dd250c30e82b0f69435d1b284fc4e078(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitUnsharpMask, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0d75914fd007cda3d5db2171ece79080a2eb4e86541b486844a89f9cb1080de5(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortrait],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb01700e27483f300a3192226e7fd06a04e0e1fd65692d9ff2eceaba6d0d7463(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
    feather: typing.Optional[builtins.str] = None,
    feather_var: typing.Optional[builtins.str] = None,
    tolerance: typing.Optional[builtins.str] = None,
    tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d619308cfc2624068ede9110c4a52b3285c5f7126d674ceb834c170aeb4c35c9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2963eb4bdd0773cc1f2d7cf5d80b22b671e2140bffc3a5512da0d139aaeb2b2f(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be4a4feccfa15d9fae603ba0a3657192f4b584e8c2792e5bb80292a9e2643fd3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d271ddc5de5d1e3b96057cd6f26d2273d09f85dbe8f243b3ded64a19d667125a(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a0e690b8a3eb4b9965333ceb35549f88ca57731173e7d7f47c3cdc43cea89128(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4b616463642beec5e6428cc6229b0f647d8a7a27a386bba724901344e06d1a65(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitRemoveColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e8d0a82d5864753e0d732b2de7a638063e479f220dbdd5748f87b037960d2e16(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bfc0112307a7f95924723ce27b32d0e21e1993940f0d375ea88337f63282ce6b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__54db0bd6debac82c6e5c3d3698b98c924d02b05136a1a0ed152c4cc642673b3c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5d9b0db050c1052a9538c5502efb6ea0c78b8ed13e0e2a332250a641b83af3cf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0df384cad53ac55182791ea60560406cbfd16c0555ecc5cea24a41b5588ba4ea(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__91bcc91022c14965f379918fb8172ea05fdf25d079c77354940aec6409ddaa44(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eb7381abf417dbf3ec0be8a61919faf669f0e571d7b318487a83e31c7ded2c7c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f7155faf3d2a7cde968479f675d1e90e99f70f9cc41c13d9caab51bf2ee89557(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitRemoveColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4074f6152797e635bbd895dde37b4fbc26d13145033f2f877dc7fe2dae95b897(
    *,
    gain: typing.Optional[builtins.str] = None,
    gain_var: typing.Optional[builtins.str] = None,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
    threshold: typing.Optional[builtins.str] = None,
    threshold_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8086b9a20c8c09d69264f66915241f48b9797d7e2279ed9da4a70047fc592363(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__84419063026d21d083cdf9ff1321c1bec063bd4cd64a1f4e141c18d86eb11bde(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4e29661d78f81c5f74a6856324fe56fe0f5434dddfd00a919921d2430f54c0fc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2c5b831630a90b4b46d102b4860f7c164589c8c47477c04aa715ea1c52f11ae0(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__28307762e6d6f3717012b5df7fd5ced9a9ae96c096a13ae72dfd216501da144c(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0a5f3aa5fb427ba2e30aa9e43740529efc539584f87b9a57cd3285c376754639(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitUnsharpMask]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4faf549f88941d8dcbc009ae5cc5ea66aac16bf0c9ce6eb9ff12745f4e10d729(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5c59964a782d60cfe3fbcf1e61cdf762086fa0269b3d1d063e19f9a78dfc6506(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__110a113c499f162497003436e0116ae6c8ec2ac44b65bc4b2040754733badc8f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__057719649868f5fabe7b4359d864f7bdcec2a980e964e08f83c11ade9d83408f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1fec857123b2e2a06923cf50a5607e67abd6c38263afb957e566f554b1efb39a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4cab64bc5f0f8bd4170100326cd7962a2dd28e009842bd8479476da9a5dbedba(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__efe56419fd64a91bd61bdb190c434a425a09d842bf9816c87651a984f62bd343(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__578a583dd15e5fbb211bcabda087c8feb989b3fc3320952097c4be4469d02921(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitUnsharpMask]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__da3d0862030208a388598740349747fe0c8d42dbfe9a9d70ff89077540eac6ce(
    *,
    background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
    chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
    composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
    compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
    contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
    goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
    max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
    opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
    remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e2dd351c3425a8b78dce695b282e135aa40089c6cb4f993f5fee38987d4e84bb(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5bc606a66aeb8845e5109d0cabe7a905852ded1b085706e8a02b4079142a04d9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a8dd8a7fba8d30b8e68fb9eb6baf1a709bb2c0c6149129cb257427085fb4df7e(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6bed7e57c16d617a0955468ce7ebf019ee11ba7858a5d63d75be9d80e60613e4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__518135ca78f6e9a98e3eaa575fe4ff3f11b0a5131157d9d86f89d550829be5bc(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ec57364e16c562a970eabec74e312ec9b5e80af06bf9bd7cfd0cbc73bc0cd606(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__29ea11015b4e8b575412ae36c5477776d6a7ffe6dcbe7974223b6d81500d2e4c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareBackgroundColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a60552a18a6bf56418eb1fe7a6b56c1f9fcb8736cbd99cd621792bd179f10b6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__488c5ac7345b9c0a44427f5e266a8dc0e0bd96e73a0daacee7580ef57627109f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__944a1ec986ff003eee0c011e2acfb81d2b99f714802710756b67bf71184291af(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd489baefb789ce6d841e82752baaf590e92ff1190a4484bb7cbb15b9617cae5(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareBackgroundColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0bd454164e3c08098072fdb488e34835e2873cb27e8d1b836e0569bf1bdf230c(
    *,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__33ec05bcd5c7cf248c14f4ad7be7811b015e797f4f6b905654cb47e1db95f0d7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b117890a4ab0fcf8dece5da15b2d02d9f6c972b1bc721231bef421527f8108d0(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__320a61d4d1b954210e7a3071eae601a1e96d7409c8f985d8d5f9d4d274686d4a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b083b246751dde71bcfa6ef1ee6c2b02e9bd20ad46f6dfd1090c622a6eb64aca(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__889da0551b733a10693e153719308a38144b42b20cf7878f8e3e6ab19fabb733(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__03f048084557374bb6d1e83bdd4430ced86abd59753b215ca1effa8560190f0f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareBlur]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6ece48690d63d25df2bed77b82cdde3c51225e1b7f6fec3007860024afbf1c1b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c3991210386f00d565054697f93751070c8ff2a46f2aca18c6cec73f6e2dc394(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4e8b3afab7b77d2b64426160392dd2d1aab70d03ab00c4dfbdab0b5c36ceeb62(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__03a0856de4f4b186d65717333d9083c2172fbcba426b5cb001d172f29b36be3e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareBlur]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6acfc7e4fefbc4ed87f384733a5e9374c1fc286328fd46f0a1cab7c7924ea3d1(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_feather: typing.Optional[builtins.str] = None,
    hue_feather_var: typing.Optional[builtins.str] = None,
    hue_tolerance: typing.Optional[builtins.str] = None,
    hue_tolerance_var: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness_feather: typing.Optional[builtins.str] = None,
    lightness_feather_var: typing.Optional[builtins.str] = None,
    lightness_tolerance: typing.Optional[builtins.str] = None,
    lightness_tolerance_var: typing.Optional[builtins.str] = None,
    saturation_feather: typing.Optional[builtins.str] = None,
    saturation_feather_var: typing.Optional[builtins.str] = None,
    saturation_tolerance: typing.Optional[builtins.str] = None,
    saturation_tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__db5be663c9c5ed29926e949185fa29cac679a9dcee25bb58b38d3dbdcd5bf570(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9625878ae6ac588cee9d9742d9d81db03b5f9ea01cf3dc73378a97e7735d5b81(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__93238d6a0e91171f4911d1fee3843af12b9ff90221ec7c514dd6110952c3f0ff(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__00b703ba08c0c499a7e5dd3439ac981783b3b481ae053fbd687c2fad395585a3(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0551d0af47c5e2f8072f924f145c265a09d4762702f35c1c3030ddd14cf31b73(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a1c58d5a457bf99ab37f738942ef70b598c4128fb10448e192250f19bc4dbcc(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareChromaKey]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7442fd9bde55caba1adbf03a1a5876c4998061a42f482ddea307e69cf68c4de7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1ec60240f978e23c9d778c483a179888eb5bd07d9b6a72e30fd18ab60acc1495(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__01e85c93ebf6d523a1a1e711b005eeaec8b504708cd9f17db7eade8d77b5e245(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__01a04865287fda1bfa5af6a278291496615ead95a76dfef27175b400e4ee23a0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1830866252ddb1bbf089f344788b9d9353c03a9b94c7f4db282c189510dfeb8f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__49f3c4568d57f039b0dd26641e4b207e95272e0d55f20178c0884d48727258e5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1cb262354551c7aa691260638386a574a35fe59c8915ccb68e27c7f1acdfe54d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__84076807f1a23d8762400dbcf3ae63f4adfa39a3b55d4702fb43c484f7ccdcb8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c0811163904482ea5c61b7ced4802ae1fffb36e2c95701cf7eace51680ff0d2e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f33e24831737aae1227b1cfeb98a5052263c02372df5628364da133271642ba(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5c797513a4e813a776f32cbd855a10376b79fa90bd0d3b0a1d7421397e392b79(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__49b7f4c8a4e99b303636b9385c5562dff4a26dbace86c8547f4d02ce4231ec39(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af4595883718ca1b3085ad0d0654ac9a49ed4a5ab9bf3fd4833ff67b3a485f18(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__10f620edb5d70fd21b17adb002db88e135a3acf8060fc2f3029a4b342f19b871(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__67170188432b30439f4a256a56241ceb81cd5f53d09c91b3eb9079f2493b77a8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__37e647c6939b0051dc668b2f06de144508b9462220a7fb844c3fa5788b2dcb45(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareChromaKey]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__284251344fbf173c8869e392150554bd081700c469f3ca89d8e95939cf3b9f03(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareCompositeImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    placement: typing.Optional[builtins.str] = None,
    placement_var: typing.Optional[builtins.str] = None,
    scale: typing.Optional[builtins.str] = None,
    scale_dimension: typing.Optional[builtins.str] = None,
    scale_dimension_var: typing.Optional[builtins.str] = None,
    scale_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__28a36beaef7595b198ef31da3120872a3140e94b1ef135d620e54f3cfe684184(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d045662fb2865b6f306066ace4bbf85e422f062e41fc6fe09a613c2040318047(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareCompositeImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c67c6ba956c3c2214a3307f9243431c6bbbaebd9bb8df397bdc3a13488b28e9e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__99d6a34e8ae637daba86bb1bdb9e48447e256d6bd5f53a22d3fab3aed3566608(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3d6b5cf461d1941bf866f3f8401d423d272fd6440a8e6dfc24cb50f93161fcbd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__379a5849ec9c44295549a5638add73abab4a870a07437fe2008d6e2e0f2f2b10(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d7b23b6ece8f0ea131d3fbf8de75f96004acba89b65ea06a41f501f5b132bf3(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2119cda1781c2b58fecc3cdb3fcaea7236dbc9be1c610d7ed260326a690d0004(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareComposite]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c21331aec94d94739f0fa97aaa02985b6b8b13929880455c2b3ecc790c84e4ce(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__68ae2eed8fbc0c268b8e3aa96599adf554ca0b6f4a028abbc77487d01509952f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3fa4017dad689d8d02472ed397ae7ebf10111bee4eb6f594eb362dec240bb561(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d0f32a642ab5ed126374939d6bb07a9ef835e3fd4302a655df65f3a0fdeef886(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4d93c5cd11da509cfc63d2d4e904d4ff00b27126b990a59644c98bcff1b24674(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__47efcd874362edecb0ef4303d048ebc477404dcd333d5dcab56c42aae5306133(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__46f8c237bc68663b609cbea6b46b639f8a8a04b9868c22b9cca398f47b31b506(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__42bb38686dce40a410a7732d37382e7ae5697d8f67bb98737974ca76a50ca6f5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__89e0c2feb62c1fac6a6dfb8b43c79e5be7ebfc3c874f0807097d8b6cf6ffa802(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d60fef5d064a019b3531da29561a9183cee56d1c5c68e5bb6934cb0383b34f41(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__463537524534d2e3a7b2186b1a1a02e23c34a411c8df8ef3dc37ba7fce37cd40(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dd6776646be0af4b90b9870b5e635ba0a43eda0970c565d7e782941bd03f49ab(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0b7186ad00fc735964f351b8cff63a574f93dc08653231245e954ac4bf33781c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__53197ad0d1c9462c98649ced6b0fa898199fa6958782379598d23ce82b6c30b9(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareComposite]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__409f532f7ed10561c9905858f13ce26b7ca6de7b94138fea6c5d007377b97f6d(
    *,
    transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a6ca4d660b4f3e2a21e6b11ade847928722c5d70a1b3ab0728ec1d24790c4670(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__22b4052e233cc0c90a56c90880281bbe6176ef917f11e3e36189b56d91d349ea(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f906791e97d90aedadc7d2f524723ccf5e8d7fe7b9b4ecd934410ad32dd0bf5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4b921c2205301005cf8217204d964eff5f687c4e89a7d7b245932547ff82c5cd(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e0251cecd10e6090162c5b513cebc78077693466d65239ffea2678f3cf173303(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8795ce930a6d589acc5281678bcde54e7367ccd977c38cf4ab492b8266a25cac(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareCompound]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d63ee38f27f5f6f043cbf070a4a0302f194bac9058ae5a08627fd39ca84e1139(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a0967eaf4915f1de024ea7540cc750228dfbba5de8edff1fbad7234e5b369671(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__471485b13fa35bb990dd0d5cba25f36c7eff3c41530d3d31145d2cbe4577444d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareCompound]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b7f24cef8f234a86957a290e412969fd01c22106eb61f46630d7d85cad4b843b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ba8a95ca6f23754648d8379c5878df4f7b3f590a2f1676a7885e67d56fca4aeb(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab504f55db1ea59521a401d01a529afacb21c1adbbaeabdc604cb3050c87323f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f24135376179b235b4acf14d1e8a68265e946b0a7c28c6dbf0ea66a7e41ab5a7(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e0b469e59423a6b06e94ac4c844cc998d9e8a6b14e111dada06e384e27117c19(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2f7efbe0d252d11d955618ac8475b6b020f5e52944e8bec33f7ba44f450b4b49(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareCompoundTransformations]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e8c855f9d4a5bfce1dfaf041a53476687f042f969b16a07a69c4f0f5fe270abe(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e79260610c67b8a65b4769cfac79ff03f4469466f8d19e169f23d78b4476017b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareCompoundTransformations]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b594d5b78a0847bf84a6c384802e3c9254bd4204b631fc59125feb0ffc690a0b(
    *,
    brightness: typing.Optional[builtins.str] = None,
    brightness_var: typing.Optional[builtins.str] = None,
    contrast: typing.Optional[builtins.str] = None,
    contrast_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f4db26e0568d5724ec625a2621c912083b595da95b9efa9947f339cb34d63916(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f03f8ff99463cead32bac78629a3ac8d803cd75fabff0e8cc0f9fa9f8055e52(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__94f105d50e73c39730a062fae0aa12e43d2b736ea58d71b05491ba2989a5de63(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1acbcf876c3b71712dc2d14dba52660ae16e05d53cf174377e666de86844fd5b(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8d36722ef21fc5ee5ed64b201d6d206a85f1dcdd88ecaab1a778502b6b4364a0(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4546fd33a7cfb12354248925e68cb8f8f50bd65569e6531ed5ac7fce66bf4d59(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareContrast]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5418de26c277206fd2dae33ac9b639440c93b6c96f771cb3369b46822d366df2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0463983e7394f4375172415ec0ec1b5c4dc4e87d71429cdf5b52e25cd02bbd23(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bcf8d68fd66c54be8bc95d911cc7d3d1f0d674a6b38d37a1de667927b8824d41(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f143527c656f63a3a9c699aad2af61b99cc0e7454f0046a4c2f19b59ea94c98a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f45017f590c0e377873f30786b216ca1461c252c773a8add66fe01cee835bbc1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aaa6d71936e26ab851a2c9f8569843c6640da912aeff1ee46b7ef67249fa1849(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareContrast]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__97de330d44411a7b9953fd1a34bdb5dd871efba51f73fcb1b2f1dc002bb95eb1(
    *,
    chaos: typing.Optional[builtins.str] = None,
    chaos_var: typing.Optional[builtins.str] = None,
    density: typing.Optional[builtins.str] = None,
    density_var: typing.Optional[builtins.str] = None,
    power: typing.Optional[builtins.str] = None,
    power_var: typing.Optional[builtins.str] = None,
    seed: typing.Optional[builtins.str] = None,
    seed_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7af6a8c3308f83c5909fb99b97b5f5008a594a66c8c65c7223536a9913cc9eb4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2b38e531f5cf8e7e9de69b6ff7efcc39ef8db398224067416936d7ee78aa6a57(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__27472b9eb34470f16ca2b800d7ab556eff2dc23ffb3b5dffe516cea7205b41e2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__39716902f6138be201cc57355bb08e905fcca1dc549c02d43d57bb733d4801a1(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__57c91723c91a40612aeb789b704ff2d68c03837e2703f2d84186e247d765263f(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__471112fea2e8fd8089ab4d4daed85177c372ac33761ab0c1c871ae01c2054ee8(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareGoop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fc93caf5e73cab480492943b049a5b091e0b8bb0efe2c319930af06594f83c3c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dddb5a589bb603dc7d4f53aa2b43c698a075c7beb8b08f6ef87553759df9a1d3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__203ddb20fb5ed98da28cce17d57092b4170aa15a4205b8d909ae755def59b5cb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__732011ea5e34cbdd45aaf47328b1426f834bd9e567eef3820671dfe9363d64a9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3d1901666fdb42ee249041ae926ed3d439647c566acd52d08de7ae0baf1414fd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1922f3f6fc30fb78588a0d2049e796d99b7d072c99f3167c3db2d16067bff23e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__91d9b96399a05ac63d8c6f7b0bb8a54aac1b8c7c98e359f6e98c351bf85f1c57(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3fc7ec431dd502786d482afce27ceed0ee63d1c45abd2e8067bf74ecc05c1e9b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e482d2cf6264fe8b8efdf967e1d36e099514b4f1d33c76830bd0b38bd2a17078(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cff1fc8fcf3597f0cc6172f0abb0cd73777198ab493d205744f7dbef4a610f1b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareGoop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9db159671120825cd8835c569237e15db215e3de2dba6fb5b8204ebad6ceabda(
    *,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0d15ea0b28868912343c57c9ece71946d651c9bef185b6979d963b1e093a667b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f55e6e70ad7f9f52d63a718282cb84e609b8a33d375b793dc0eabc1f8d54cad8(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__258238bf018d94ba5b243893a29142dfd1ac2f48e08ef5e86cec361f2c07b788(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5c4e2214f4f78b59f5618acf353b9d95bd4b0c0b23f7152dfa9d373338d7d9bb(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd1db428f5df3e97c2234d6f851ceca2c528880db53bfdbe0a40e0a2d0eec5e3(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__31db496a065f0d63746dd40dfcc378340a79308e46e4086078edebd8e8a6a20a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareGrayscale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d0c081850b2deadbcba950ca3c65f481f1440c475fdf9a821f4992f8b765b2b2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6649de040bfcdb20d5f9882446cb8289db27c0e3928c798469c61d7af7841dd0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5efdd3fda789da1ecfb5f528241a3fb688a2f9115bb1f9ea9d64fc20fd9e3d12(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f96d0621dad307464af8a6451dbf13aca4c90093ad5532cc8338946e89f4c197(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareGrayscale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4abb1884d9ba1acf04daa7acf3d802443687f17ff6c4c559b1860b7f9de6a454(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness: typing.Optional[builtins.str] = None,
    lightness_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d5c4b297e1424ac887fc77908bc6344529c06577e0f04c16435ae3825406863f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a6399704bfa3ce4c7a316c1f1433602eefe280e798b26bf9d70c554f9cb65f0(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__952af77999d325fc73358c853eb46ee35a4747679a22646db882e72a9ebf586b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b0685b56186f6e105b05591d6f0d5b5f63c6806e21db2701aa660516fc595e05(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f624446e3101e5eebcebf8c2003b7f56b95e6b6107baeaef483e3661b7c2b76(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__07b758fe8fb1d3f6ff1db7cba287d8debcc1fece35e64815da5161d1c4d24919(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareHsl]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8190f08cbcb8db399317806fe7f4e5748c763d7e8b6b73c34558e423f158e2c1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3e95c7d178fd685e952319d0bed57905762beb2429ea1b064570177e9f784eb0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__28f25967562fd5a15c94ff1b1d7dd4b675580afbf214419dea04edfbb6158c42(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2686a216ff390c8e842862aaf662ad920b4d1cc3d807713978db1942ab855761(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__84217a7eb1470f920cfc995f835487166e00ba6ffaeb7a596a7858ff4114736d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__210a5269d4e0d7d0818b81378e473a4151a009c16a2e05faa024032ec80eca68(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__28e71db58eae8fa2566f4d031adf822d62d4626f247cd6a72fdc40588146fb34(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0a4c14ce2c1cbe7aa96637dcf16f88bd8cf982cc8c0298045c188e31d4c6821e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareHsl]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__66f84e9a7fdd60f83962fa9faffc35100f02c69c15d7eaeae9afcc2056f03bf5(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b4341a634d9a6878026b640191fa6f1382fe3ef2caf797fac5d5f1c8f4d13b80(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6c183c64d8ce11495b5c2fd36261307766c4aabdd821dd314c1e026bac6d85cb(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e8f22a249355737210fbac87a9556eb83e35b149ba3eef25037acb0c013ca8c6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f2fc21f0e1647e0f45348626a21b1d78cf619ac39a5833894462ea243fac2b7a(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1d8fa3bae57f76e9b5c2ed89fffa735873682e908912369001b7c6f3f6ac9db4(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__52b7a5cad29dce33f1c6b3760e4b86b2c4668cfddd41cd1b0711c5aa6c7e99ff(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareHsv]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a38b60e920c1d041273cb95283d473c72e56109188d4ca800d862b2e539fc14(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f9ffbf97204fd063c49205ba734e89edec75069bdc3f9e39352df3d8b8150da(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9b72dc7ea1bf5284483fd25bd67c3478569046abdfae03c14062f11eb037d33b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0e4ecdf202a2882c9238ae3287a159545a387d7cf686a5b4ebb7669ad6a8b839(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d413954f6fcd0b1e47705a3ae30abd927198db0fb01b27f18822b43a1faba4b6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3faf3d8504f72c9783f9a5ca601323976f670fc4745b58c016383b9fd17dbb05(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0cab4f9a99c914ac6a9fc4cc30a57b5d943d9c35c83d5b8a78168cf6a331ed35(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__81a8c92ad1d47d80d777ddd07b788ca9e1745797e1aa271519723b64db8dde81(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareHsv]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fc03a3fcfcd891c12167e5984939f546e95ada9a75d5e0adf8f468f298e5f1c0(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    dimension: typing.Optional[builtins.str] = None,
    dimension_var: typing.Optional[builtins.str] = None,
    equal: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionEqual, typing.Dict[builtins.str, typing.Any]]] = None,
    greater_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionGreaterThan, typing.Dict[builtins.str, typing.Any]]] = None,
    less_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionLessThan, typing.Dict[builtins.str, typing.Any]]] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c2af1e765a0775fa662d7012ca93a27d14b823f141813aa9e84baa857e275fd1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__090aaaf50671ef5407f504d7c5b8b31d0a485e77a5eba4b790b4003f7f312623(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac2261d6e3e51090cdc59e941f80d8e39a0b2441e99327f12084a082b1c187c1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__249fd8bed6cd76383bb151fbf50160ba588e082a58437e55a14656dd8e7bafd2(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionEqual],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e30b9515c67e8708d9d94be3616792f6f1dbb39fa50e0f5b7b5415b1b2a27786(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5fed07e46885bd37f5c4d89f403b6eb189c265abbb70be5e8bb50023fa253e90(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionGreaterThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__560f1ee9d322a1d26f898d3443f09e13d5ec70cdf6e5549fef7ecb04fd0f0903(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__58ad6d38c1183a11c3a040663bd81ebdb7afbd657c5bd190bbaf7fdda0f7dda5(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionLessThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8af8a62862326115568c54567ccbe5dc388e4075b5fbcd9ca3d178fbedf073be(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6438d3a2f5ed04364d832a26ce3ab4128090f4e0b8384adc8d62bbca0a1c1b43(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8e92f01d16c0846bbb6d416634580fa72f8ecd6c4a36666390b966be67455eb0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7ea972c19e0c7296215ffb1743adc5da16d4edd30cb7e180a5da1b24c43e0609(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ed6af028963bef429b0677be5d221bbd4d6dc7f007e87507a159718c662a6496(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d7aa453e5d3407441337fd976587df9963546d65f69537d63c677e322e93896c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimension]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f6fd532257d0ddadc8696a11add1d96c799f74fbe52dc2101ac7ef3eb9ba274c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6cf3ba2b532d20183699759d646f857c73a69412f46d14a6f893a3f2a4e75766(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e1b461d951cc799b24f48ade69e4b39332a3b0412f04789a771500e6c1a768b9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__546518542f3608cbd88915d680e075181cc7184c66108d3e07fe37b6853061d5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__041f0495feaace07f39845c55c6f54870c74cb70c131cb7e244c2ad4727847e5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__87884da90a57c6892515bfeeeb56ba7d66a4e97febc3df70bec42c100d594f4b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimension]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3b72dfd9467e1e8c67ecdbeb3923f8a8108f341d357d09ed869b68bff009a2ca(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    landscape: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationLandscape, typing.Dict[builtins.str, typing.Any]]] = None,
    portrait: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationPortrait, typing.Dict[builtins.str, typing.Any]]] = None,
    square: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationSquare, typing.Dict[builtins.str, typing.Any]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a8572f245e924c086d93ff23b5514658606b2ef15bf9195442dc8be223c1b6bf(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ab00241015dfbc1fff47a32c9d02f55a729ae0e764023cda8e6ed889ebfa4c0(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__43fa8eab2a043ab4a2fea88d4c87e5fb6581ca44da18bb28e88b4f3df3ee2c40(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9fb107a20b737d1dea9ecfd509c429b8c23962991cd2d68339b8701487969ecc(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationLandscape],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8e395c2288d175026ac8c5322c9a553fadefaca21c5dbc6609f30add3e591d8c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__465e6e49e65a898fa1ab7d7110cd8160b2dd4a90894dcc6e10db887cdc86ba11(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__06c65b272295ea93ef923fe15d4e1347727a2badf2b2de5557021d945330d545(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__23652a7dc6bb234167c969208a04f0f192c9807740c01895c2cf3bfa51a8581c(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b22153e6eaad69725aff52b96c77bdc82cceeec1d1864864a9b49b50e27439c3(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1b08185e329ada21621ff1e08ff920c2785f45525bf556020edb885065becd4e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientation]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ef046de13fece00de4ed87ea1785cd3a1fc0b37d14e70fc275ede5ed0f3ae10(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__83884782ecc15a014d907a93eb792e240c17055dc668eda94d4dc9454e21e306(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientation]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d4476d6e0f76fe91719dc09795614ba150f43ccffd64521ac481dfaeb9c44673(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__80ce901933e883da00f87acbe75bfeb7f9a84ddafe6ca91bb1c6ef2c4955a653(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationPortrait],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c90d00b2157f5a869e484743d3aba545650801f222722a4ba4250e762b4523e6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__07e31f0357967779e451c9867e25a424467c93cacf8d1b04a77bc4f9fc68913e(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationSquare],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__76a5edce4388697dbcba16ff1d9490cb8e0729ab8ae0a7cbb3e6e5c9fa9fbecd(
    *,
    colors: typing.Optional[builtins.str] = None,
    colors_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__86c7321e8d7b066a897c9fbb8ed35b775b5e7440f025190579d3a6e5aef36f88(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b724ac88806e3fb25660de7cfbb43877c6aa33038b9927867bf0240cd5111142(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a212cd532de63b0d1ea4424fbd5be46e00b317cdd878faa1e9caa14a208cbb14(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4702ebac34783bd3e6c148389bce35cfdfdd0e32d7b5b223251b8c67bb79758e(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ce5ef6ff1e5e14218d2fd7bd0049e518ea50f54690c6f0e1ea4e7523f5a33f0(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a58860cc7ad1d62deeb04a50af708aec212c3cddd3301195fa8ec326b37fe0b1(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareMaxColors]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2be1a773b766444cbb38f646ae3b219575e94c5f69f270d338aacb8efd2f5ff5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__884299e837fd023f0a5dcb9c056c6a66eb0647e4bf42863bcffa519efd06617f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2f62fdee8f909eb0b180bb9796133d162728d3c4d43c7f63c20ac3d4da7521e3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eb3ca1a5c227da001cca083fc4036f4d0aaa688a28dddaf1e220033bbbb20027(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareMaxColors]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__96aaf2aa22b68d2030c0443eddabb9b5ae43c4dddaa42d2a91bc657f7a482b70(
    *,
    horizontal: typing.Optional[builtins.str] = None,
    horizontal_var: typing.Optional[builtins.str] = None,
    vertical: typing.Optional[builtins.str] = None,
    vertical_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2be8685bab3f0b8d1df387f70cb37b23316983429d8bec3ad61e96a18c6a3cf3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6caf82b5ae802a59e43317a8eb41e8d1be15e620dfaa095cb8f8c871f3aba2f2(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c694148711da528ff050974437acdab3ab14fc154f9cabc2189b5a576cb78dcb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__348318c3f8fc4781b70a3ed41ef15a3382352b627cf8ccbe1653486d00a816da(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab1f975b1f18e20f9c734f9be00cc61ea5c7204a94004d0577d3e928141a7eae(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8eed1ff13708ca82f9b27760209d76aaa38ee9e7b72adb27c5fd5885ede4cabd(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareMirror]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__61536256546464341096ed8a7d8df95d252a81c6ef1a990fe5745cf96d16d82a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ef926cecd5db69c42e4586ebea65796de303ac8a16fb37655b11e8c56e1f4394(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ddacf2a4fff62e22114f4d0b5d578edd2968ffb48ee5998dfbf2760a33841345(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__69b164b82462d3923de3c761881966e758763f3f3333189caafd789792b4d2ca(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e21cbab26b05405193561b2dfcae28f5b416395d1949e6393cb8b8dd5e77b493(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b62c95db8016636b6ead248bdd91e73fa84431f79bad08a1385f5e83df24530a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareMirror]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__54df5758b6ee7e5720f0bc1e213f7624d1f7d8a9bc460815dec16a58eab34996(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fab20cc6a5cd76f90461a9360c9034d97d28d034d18c62c3ed5e5afd283ad3f4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__abc2e10dc7431ba5f757902a1522b96db0755d81d5ed153b8e49b30d9fd02918(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__37ecb02b5c4af69e2388093ad8c9c84a2caa186629e2277725e237e48f00aa9f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c9aca6deff7c48cd852b32516197a6a36e9733b6778cc48e4bdcabd4a2dd1714(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7e8fd9a2db8a88f0681ce1975dc00548b62e0df0a501b1f21be7aed7de63bb6b(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2c3357495646537825d40f782534d48e98df4feebd38eace511edac42d340e81(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareMonoHue]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__268f52aac196d9aa97f07ea52241f0495579dfcb40c06125c216b6c40dfd319f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fdec3505dfac07069a5a3e9edee18386433f423d0c8876ac54ede07b1f54a0f7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0f68ec3348aa4ac0fd3328c14644ac4e52f6d64c435e912d47b7a1464a358ac3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c6cc8f40888a145c5164384077632788149729a4c20038f31437d34e06888946(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareMonoHue]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__32011f9428034b519da7c3487a184ec7100eeb51c61ce1ee68e53dade7a4afb4(
    *,
    opacity: typing.Optional[builtins.str] = None,
    opacity_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2edcb5193eaa9c44a0e05ade2ef43f10b65c479916fca0d900e564714bc830be(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__08ce1e30b4d6ef06c3409c1d8c6fb0b235ad90854014b06c48fa2c603b8f0e0d(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d3ed40742ee4216e94b5b0befe9188645fa695b3420f666657ebcb59e215a102(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e2a5c38f1196e90a1d3b7618ea6924aa2badadc14ef122b5370c64b772dde08a(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7f64a9073c5d6d24f7bc36a5934352176f8975f13f5d8f93d05120eeabc4e134(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aceeace7fe809f6649988b7d0273a854d28f74bfedeb61a6ff956eea7a26c854(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareOpacity]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6499750e40add33266f21b185d678e3c26e1ccbab07690b09b33d5dbe207ae2a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__52dd0935f18d0f51252d1096e253a7bda1e322a358e398b059564c6e488ee82f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5fcd13cf84e244fb8a177109e624d8f2b438db709f174fcc5d99f32386a0a762(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f0691bed645baadaaa50bdf976447fa1dd0ea10e6743fa7a9b54ea5d67310af1(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareOpacity]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6d2923b73e77e3d5d6df74b8d39d5f927d696fc638ed50b60e3319c6f30923de(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b10ddc741a2e826f98d1fe4a7d8abf0f27d7a0c19dd7cc4125ba257d4e55ba8a(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d09c4c0cec6c6a576df472bd30640af85910f4f0aa3bf561b9f16b609aaaf572(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareBlur, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f0be2d96260f8beb5590380823d9860b61acf3127b05cca4803100df353e9a10(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareChromaKey, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__082d697b7e037311b36869be7dcc9f3fdd629eaa08bf9f82112d10bb77e04949(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareComposite, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ead02bec4131042fdf560280b73fd87647af85a1db653a4e9ad1c99dcc809e7b(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareCompound, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__03bec5e91ff63900eed74a406f0521ef7a380c729bb2236f59260fac26d10672(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareContrast, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a9d1bb5ff7ae596c4686b9fd01e2ea48cc9487c45db6e0fa24b14d72a65ac78d(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareGoop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__515af96ca581b88d7c8c3ca301ad9369909b8ec23c30ff8610ecbde62e130faa(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareGrayscale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a01a163b7c7a586617883d91cf979f3f6084ab5b72198bb223be63d03c486ad3(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareHsl, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a533d231a46d11c600de0c5c9b39364782a08e89b917da74db5d39e9c2db5146(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareHsv, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d82745d0e5b3252c2107231059e93e6fcafe9fc3341507582dc3ea63e9787e0(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimension, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__51e8d31371234efae1138b9b00178f5a5d23521f743316fc364b8d6f65a2d1a1(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ce61bd978ea90ec30048ac62f62b156d2cebe373bf6faabcbe13247135d17843(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareMaxColors, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__28e834776b95bbd5862579e780ba1553a8337be7391a4e2955dbbb5e654c6ea4(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareMirror, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b041738cb122371b7b96164f3f54fbaa8207f793bd3c9531daa25190e6bdbca9(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareMonoHue, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8d92c35e7c6b050d6a92348bdb048cd978cad3d7ef70c600d252b8913439c6a4(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareOpacity, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df435ba9ae75abef1940ec84388c77ab0b8e7dbf22a347bfa9b9ac72d5fb3d5a(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareRemoveColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5432dbe4029d74c8e2fb7e4134ead3023d19380b7ff81390999253d8a0a7f4f8(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareUnsharpMask, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8fd4964efdc669b6cf49edd889cf28f9cd393800d362a4ceebe8a0724af31d3b(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquare],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a0e0c8f49fc8c35700a7af27f9c68d15d6c3c166089367e53a1f15fd066e489(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
    feather: typing.Optional[builtins.str] = None,
    feather_var: typing.Optional[builtins.str] = None,
    tolerance: typing.Optional[builtins.str] = None,
    tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__39e38f7dd7cef6a229f1da9417c9e5c529e82f785c6860abfe399e3771824bab(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5eb70082e31a20bfc67761cca685b65c2bc95d7780df6a0b4d1807ea79765e55(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__935fec050b41cb526d8a5b5c232b6267fe24dd5754437cbce6dc85cea8a07efc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__da199fec837623738fc07b2fbe31a955d36000939a52823727966f8f881de44b(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__15e2c1b09bd764224b56067d07861efcea8f850ba06516fcd808f16970006d46(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__078949d539bea3b4b2d1b75ea1a4fb5a0ab2668a89602dae83c698d362d1eb45(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareRemoveColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ea3284c38e1f9c6aa94a4c3823e7ed514b586f1cc27b56e384ba56ac969a8b9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7bb513a78089c6a23e8def59db9e5bc533ab37847a4bc1aff59700ae8e9afd43(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e2e9af0610997e08864b15500ed4fc6f1e0ff93abaa32f70486286070822d3b7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f3b4df7e144e4fe1266c8307daf0ef74370db0d9e9c2a02ac0db21a42bee26b1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3b029141a7c4400a84592760ff0f6641a7c74adcc4eb33a23e03059cbb6d0043(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a9b002122f40d72675913e44a68f34665fb61b4bf8629c5351e3e72c7bcef239(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b8357a7fdfbe5d8cbc9ae634e181f6b3ba3cc99e8283eaabbfe3c96fda683c07(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9c65c8afa53e3fe8cb92269a9ffc386d90ed971fac554b7c2afa7bcbd37b13bb(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareRemoveColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a9d3b5067da0fec9c172cc6320932794125614472748396a2463bb6c1a89c7db(
    *,
    gain: typing.Optional[builtins.str] = None,
    gain_var: typing.Optional[builtins.str] = None,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
    threshold: typing.Optional[builtins.str] = None,
    threshold_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5c44908927f0979b80846a0523c6b40091a4b27a5dded22fdd69ee64ae1e6eb8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a0bfbc8d46914f9fe8b88a92c257badef5baea93d0c42c4853053cb3d1788e36(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__04abc07d975dfcd22b9325f923477fdb4967d4361988fea06267cad50490bbcc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__55f202c30634a9189dfde2df911bea5365585229adacb6c290ad88b443f50142(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__30cb6f2d34459572e52989c32b3fb9d6f1311e82d6efb232dd71ccf409430068(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3c5a0a8f14edf2ff10152e94257fa1cc212eb422029c737f038b8415e6290cd1(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareUnsharpMask]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e56305800a8a951a46b66997d7ce70fb776347401df5e164ff9b89ca11fc14a2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__59fce487eca048e489020b5e9955c1100b3344991e55b1dd5a1976dbce0902af(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__60c8b9aba47a8e1bc4c27c9ebbe5e7ef0e2b3f9eda5bca700a2a2f24f3e6d3bd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__592a7f42c51e390a8dfaa592580dc16381f672ef5e0ca165b2ac5748d6d29bd7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8af11772817c2831e43b1c6d1538937b9e441590937f99c3670af11af530893a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a525674d9f4b2bd20a47231bfd03066680bd3a9c2f41c007514f684e0710bff4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e27c128409f179049d9fcb608c6c4a70b9880e2ea6be8b9b180b4df4f2434904(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bdc3430a1a29237ff3df05f042038144495703e3be9a947474afe8c0beb31c0a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareUnsharpMask]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__61cf20a2c71bdae5993d1ca40138d220fcf4e0818bbb45e41b261ccfc53896ef(
    *,
    colors: typing.Optional[builtins.str] = None,
    colors_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c25de982ade43fbab7aaacd1f731c1656ddac04ed1ea3e5c9e7456d0a7da5a6f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ca20d848cd0c8458df2e429dfec5896384767b764a5b7d00d011ff5c5f98d58a(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8ac926375cb54f3c06001f452274fffaabbfc9f96c471e85541ea0b8e57ac49d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__221262b421ded9eef86bc518f994759f38a85f01a666ba0b81b47699c5850179(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc6c373363ec40b71f1090d1d55c4a213583acfe1bff0fad0b76fff4a6636859(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f81235ead2dad15c72b95ad368f3e308e182ab9ee7e9a6b23980299bd3dc5876(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanMaxColors]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__38f5b11d7ca1be7080ee19061c896706b619ba2aa4b9fbf23788a9846efbf3ef(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3640886f33d4c0b10b326f89eed8553cff14f109303b18331222cdfed28f12e0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f4c2b90c19c74bc8f3deef0ed9250e5bdd30760c2b393f27fa494d8b9affa613(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ee08502425fb7547a08e045ff3a2dcbb58cd472f57cd1fc96670cd557ad0e33(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanMaxColors]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e6cef02a42ff134d891676c0cc9d05849d6dbac679f8aab0c17f3ea5a9e5bcf6(
    *,
    horizontal: typing.Optional[builtins.str] = None,
    horizontal_var: typing.Optional[builtins.str] = None,
    vertical: typing.Optional[builtins.str] = None,
    vertical_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__856065d547fdb649574ce9de81c2775629e65692ced2a70d517347346ed6e91a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0953698e5f67705e5adf076baec8d51416d9b46958b58abfe7bbfafc3c5b8403(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7a269f6cc9ed1d0e15ce834ea936bb7b025ecfec9413831c6ffa094633ecac59(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c69b247255200e2e25dcc129ade09a89de3344e0a71b5308901d18d982026242(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e2f843309d2d93b4280081fd416c6c4fbd243745cc3455041ef134a08858b1c(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__91bec000a04669f6168c4ee95e06b7922ea500aeda7471930b9b5306e56b0cb3(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanMirror]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3bea206fa63dc6ae445bcafc2c40ad14f5e5eaa9941d40e6134df9a6dfe12737(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d9b19d89efbc34fb7dae4020a7c8d094c0ce23e1374ed3e772ae636cfbaff93(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3467979f3c31dd6b17ae58aafdb63b9ef68c17225159e4f8f155db016a2ef979(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__27b2ae0ff72bc36f81c564a3ae8a0fcf39a3a8e1e52557229a22e6b3dd85bda0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8dcc1fcd599eacfab10a2ee6e9aaeac88c145a9ac7e7ab338cf883fea8a70626(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0917b793b205b87ebd8909e4be792f81c70ef77b5ce82df75ed29bb492e9d1ab(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanMirror]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__468750b6e01a8e9db098471db585e35cdf532b53ee4c86bdeeef74252c4f1ec0(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__98e1d63282ecc6280915d306e6fcebaf0512f2105935d5813fe42f897e38cb95(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0061f18e603607ddd02107c84f61fac742921e929fd697980a4db53c15831c08(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__baad64cf033992c3a51ca3d5d6a8134ca4ef273227a1fe1d41909513aee45de6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2b1e4482db16137125f86226cb70260c93e3244877a06dd512233a7fe06d2aad(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__273bb156ac51491894d02722c0da718d1cc2853427974fc053e633f9b5f3cddc(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__29e676d940ade88858e700b71482599fcd841f2540335060b356619777fbde6e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanMonoHue]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__12cf55e8a31f3789e235e4a7ee791404ec2afc809d0121cd7d15e502ff189095(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__753644c4a17abb1e26ff7712601064ad0c4728b1afad339bb63a93c51a1f8b8b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7dab871d2f6242339cb0fb7b0a8280f94c680b01dff7cc4c97f7d6be026f3609(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f412a22ea4d9f98567a2f9d76ad96e3caa75ac4e2f51e09bae6d426c8959beb(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanMonoHue]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e520d46d084b793a149b85e03c8e7c9893b39ee6404d8f52a8f22d9d72ecf08(
    *,
    opacity: typing.Optional[builtins.str] = None,
    opacity_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9cbcec5ea2a0d6bda2b67c5c5451c8a993e639d6ac34e182786c83ab03d6b18c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c727eb2fd7a9c46bce1b9cc17a7952d9544feea978991aae8cafce9e9ee2eabb(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ae4842ed8ae6ca606a4482aafb4c1142a7e9f49cde68909c6bd9d534d7efdd1a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__88ae434db19cc87bd6148ffbfe0433ad1861820ae5284a07f068fd8fb58093fd(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af37cb4dbc5c5dda3969418bfd1ea34d046946844645aca27c6594076637d985(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4b868be0be52ab51f99d98e9a5208d432fc211e02ae269247bfce3c7063de7b3(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanOpacity]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__25054fe820948ef6e6d678c965e79dbfd17d4892af6e8073a182f617bcd1d815(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__89a8abebe9762fa108e165242e72659cec87a41ca23c6b52c99eb248da5a7303(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__206e5a02cc4359451591cfa2cce7b0879e3191093995eba77660695ed3b41f94(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__744ab2919ad39af44862b56b302b44c27547cd8b3341e73a43b3011eb5a13bc0(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanOpacity]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__509e3f9bba4f5db7e9809d5dd3e46d4023e344b95793aceb7eba26cf0b6f1187(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e9d1ba2d0c726bbf6275a2cb5fb72318caf50d21aea303e0097e0d86807ba6af(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4d980ba9b88185a816c8bf45014d2c345247ffe5752707fab6e26b35a95ab75d(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanBlur, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__37550e96ddf59bb3d55a28d36592fcf0cc6fe1d070f3bb07a2ec6e277204348e(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanChromaKey, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6343da286d225b391558f6cd14c65654a8b6035ae77ccb1b9c3a658993548611(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanComposite, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__33313b477157304f7f72b8808a271af6c8e1177144d177907ae20bd352410e0a(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanCompound, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6529c866be0ec61ebc394e5f4c4c22f290b26a3f2ec98e30668da0b480903940(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanContrast, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__05774a4695e8aca3e4f0e63669f04ee2c3dd7490ffc10ebfc96cd344fe01d24f(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanGoop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__61d1e34f541ba5cc0a1aebbade335a7e002f495fb39e50c1406f5c6bc5e008a9(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanGrayscale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ee726fc9e3ecc36a769995d4578bc602d815a51bbd57ba8c4f7264db498a4b6c(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanHsl, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__652a4c85081f4811d396e7eaad40bb9a2b50a1b4d82080e70639c471efb57651(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanHsv, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bf46c2a3944b54856f4ab3c5120d5c64b4b6325748955e0da1c11f1c49a7a1d7(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimension, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c137293f44a30e3993dbdd2c0cb214ee1b83feae7c9ac300c2f0625ac7645ed0(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__427789b710642174aaa6573c0a882d8746baf67538bfc8790c40f38dfca37288(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanMaxColors, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__404223ebc96784ed460601a1cb98ca1ee59cbdd757bc2ac5df78c8751c4f2a24(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanMirror, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__56b9adb51dbd2cfd01b4c88790fe4381e131ada8ac52f615c9cd3198a93a925d(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanMonoHue, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ee242069629a7dd7b929e74ae86cb077d6ccc02fbe6d5d68eb2fb7be0e0d12a1(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanOpacity, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__674c866ad45f566e508f1928bda5cb6fd05e12e85f3a450f100ae49d2e74919d(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanRemoveColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9cc4810170d090ab3b4e552aacd612823fece7602028cd9841c5f88b214a73c3(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanUnsharpMask, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4470a72455fe13426fdb0024e691457b541898fe038b17b9d463dfd6aa145841(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ce8d436c41a58fb9f41634e508a68e181bf39a84f89ba2a16b2c1aab0a505b4d(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
    feather: typing.Optional[builtins.str] = None,
    feather_var: typing.Optional[builtins.str] = None,
    tolerance: typing.Optional[builtins.str] = None,
    tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e85c38086d9e4705b979c7af27a02cc36e38809ac577861c872dc558c5a1120d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c1b1ee2283478607748e125a302add56449c2e5c7a46b52d00b3966ea0ed9beb(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5db562518885292448b5d8154661e2b115d4edaa55cb5829ac155a69fcc1b825(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__335eebe3e0e2f99a18a6427251444002a2caa04038e33cc0c6e379811bc65174(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dc505ce2d5399c9a200cf61356e0a08d56c14abdbdf518c05d2d014df5bf1417(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f43faa86420afb6b30573d32e9b515f1d505a1164de8fc67c4738ee0dba6e9f8(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanRemoveColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__94baeb056eff31030d08b7e67f15a7216d6180cb6a631c9c92a36d84ca3958c7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__79265c62a51aa89776ff3e1d381ac16ff988fedfd3c3d44f52869259ac9109a0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9c287c86f4cd7dad0aeca716f4cfbe224d70b7f39b6454183d3085cf4cf19bc9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__80abed16ef5b4ada7d622e0d3de99fbffb6eeb128005d56f858f600019f22294(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__96b0bcbfaac6a5c73251271da2776971c45b2d9e37a3571085842bfd1963f6e4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b1db3a8faf0e49f94ef1dae1d0c621f6c8e0c80f8e23cc17b0976275e1e0125d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__41c974832272076ea5a16d4dc1a98729eba9682c0d8544997334f25e6bf18a44(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fba592c11c148bb78c3d750077669b8335e34aab3f636841b8b33c2838ba1f4c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanRemoveColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__763e5cea3ef57eed1f3dd18ebc6ab5fd4ea2af3fec246cb252f246f5b5824b27(
    *,
    gain: typing.Optional[builtins.str] = None,
    gain_var: typing.Optional[builtins.str] = None,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
    threshold: typing.Optional[builtins.str] = None,
    threshold_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ec512caaca3086eb86ca5dd0ad8d23151e7ead7244ac2b01fef1285d144f7b1f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__47380474b13d3542d13ebf47df5d628bf8d73ae37d5a621d103d2123b70aba3f(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f0e5a7a42b8fae83d09ad55737153fa74fa6079ac29ff9070b5b0d67b1264007(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__afb7c8bf6e0f2c1870c17cddb969394b39b57b775779e3ab344a1f42ef90e0e1(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__93a9245069a7c4fa382cea6030227fc82224fd01199e6dd2dbe3cf24a7a045a0(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7bd01e6d1fb1863c11685b2ff7f9a7197867f1afcb0b6db33cd6907f692f5356(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanUnsharpMask]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c9a492ca2db85deed09cf0415a3045b914280319bf046839ff3ebe4015025361(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__afdc82f409d41bf265b152acc446fda43280a7980e8a980b30a6ec9394eb56af(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be490ed96c45901d846770f69eb632865b603c84bb7a113e1516f830a277f9df(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0233a3595d55adda7a5160bdff2d68780de6b3f4be74b4fec335dc9e8fc0b19e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__76a44d262abe94058b91bd2d675148b4f2f06179486551c635044ada6cbef30a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__781f8df057db2ceeb0f1e9732aad60bd23d2c90c91ab314eb0c177ab062e463e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4132d7486589b4a1380f7e9d889379e2aac9943d7501eab534cb45f35070d598(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2fdf39f750c45910691ce554ee9babcfa75d1e5f737260f6160fadc10aa4cf8c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanUnsharpMask]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__40ec9e772ed9b7d1787156d1caf52f4df25fd1651961f01b2f20b9d0bdfeb982(
    *,
    background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
    chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
    composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
    compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
    contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
    goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
    max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
    opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
    remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fa526e58a7302d16244342d170ba215f39b137dee74c88b58c0daa599f359d1c(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fd52c9218a2bd9e89b69c0e32e12f02bc5c1cfec59778eda4c8a250408e4e2d7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2f2cc8c84a1e834caeb253021195974a989d7d0570232d47d24de05684720426(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2e75dd835de0e064a5e7d069491af7b79dd7e240261d8fc3828bdfc4d54b3ece(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aec1aaa6c4c03a0861e91420714b25767867ac6d39a1d4c5016419b0ed889efa(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d20f94c3f8ae024efb125a54d74388ac41d16b90035c63cda1a272e2a23e18c(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ad13196927d5cc463affb412c4be3c9db38027c81a6956952cf0b898bc81c9c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanBackgroundColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a8a0d7465a0893c70cb472bc1379d7a259cf2ccf06927eb0684b4e539002c5e8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5d658bd13b15b12d97107cbba958907702887a3f83cd03ec64469ff060ab4973(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c9027a8d92c867f1ad83ba0e4ac979c9ab61251aaf243c672c7b5c1bf9193f0b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6575880f5f7986e28fabc4c22382af41b1e634ff825cef82d7d1039e53438adf(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanBackgroundColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__52565f56b7c453b2e0ef07d01337a760b45e482940d5e24c58694ddbf9895bff(
    *,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__92bfcac9486c925bc08d5b3067334c26537cefc597cd3f3a433b6b01837cefda(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__05a8cb1d1ff89ac571c7e819b1fee15ce8904f6fee0afcfc12f291adc53cca2d(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__131c69c9f26040c65a88450c677c6f2a49fe3984f40bb10305b6dd7e58fe1d0d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__212c5116cbf093d4222575a4617d94df27cf36c1b4e580e523255d8ecc393a40(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__88ee990cf4f8bfdd3ebc40b0ab74815935593f800fe55ff85a2bdd58f8452d24(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1ef33d2b3311894dbad1937976f3249f5658274a8e6824442cfa7b42978d89f3(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanBlur]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d0f3d0fba1f1efd544579103e9f2b1386eea8351e50c5946c3cf7a8e8ddd4ce2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__28a4ff473810073f2e441bd6b819723dafb3537af5f50f682f3166a34ec8954d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1e43a47c569255ade82996fb5a9839e9bb39112d9b4e8700ea949d0fd925cd0c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4742a28c408b344d0f0a6fe859b94fc8b7140286efd7d74e0d4c359848af2a87(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanBlur]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5b1dbeb80c56d3ebf441c9cbb4d3444bc30bf1a897a439d4651a1d752dbc9cba(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_feather: typing.Optional[builtins.str] = None,
    hue_feather_var: typing.Optional[builtins.str] = None,
    hue_tolerance: typing.Optional[builtins.str] = None,
    hue_tolerance_var: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness_feather: typing.Optional[builtins.str] = None,
    lightness_feather_var: typing.Optional[builtins.str] = None,
    lightness_tolerance: typing.Optional[builtins.str] = None,
    lightness_tolerance_var: typing.Optional[builtins.str] = None,
    saturation_feather: typing.Optional[builtins.str] = None,
    saturation_feather_var: typing.Optional[builtins.str] = None,
    saturation_tolerance: typing.Optional[builtins.str] = None,
    saturation_tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c57cca5830533e9b3a085812304bb8e26b6358ccf95fdae18f85fe2bb004df8c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7861ce20e7062f88eaa25d1d84c0a4f0aedc9e7592f6a0b9ef1f3e8c99e1e74a(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bab2717fd351b4e0ba28b0ff84e54f7bfb18fc574ba78af1a15853575f7e8514(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df1f1a52eb85866767e2bc08670c5e6e4fa263e05a036745e0b4db3f2f322947(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b57d12dc0269222947fc164a1ded9769863ae7ef89b5714742faac078be0ef73(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__826d8037e0976a8c1fd612523dd3ce52cbf1413492170e5862d6487167746330(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanChromaKey]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d3f8b04ec0a18cbe05c7073d41c9ae4e2cd536eb037c4929caf9f2ad09924548(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__17611f7e994471ead912cb7f717f3486e6b080e88c1b839265d41535ecc973df(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc8670fa8136208871dac6c7b324e6e951df7ca8758dfbe6343e4187f23b63c4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7768602a2b9b20b295cb1023eec47f193d7df26f1e4320d2a3ae0e8750256f24(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a2c94e1a7fbb7ee797fa64a2830dca097bfae787a8c315e1fe70a05fbed8c3fb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c9d1a0cca213b2fe40068f512e6f16a9a94b4affd43c69bb00045dbc3f7c4967(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4319aedaa94f3fcdc3b47ad3a1517811db9c5350f9f65fd9c2c9a3c349e6c21b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5c7d7d4641aca056cfa91a6fe1ee181c081bc73482104ab79275f728e43fd9fc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bd5f265222424d1e68400fa50d11c355177332da98c985fdb8768064036d907a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6be2897dce65232a07901f3d6d50d990c3cecb0c5073cb56395987e4c50cfb43(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ee83719e3b4ae17dd105587bab56c8b967e6c1010cf0e6c6869f367cbc184057(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f1b106c4f37b642fcc10f5e8791a1f1b7b36401762e1c98e894ef5edbae543c0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__75d8cc34b1da8db0237394698d2c077bc1eac324caeaf1cdaad2f25168656d0b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__87531740f6c410eea755b5d696491c6260830667e544863e2d34c190bcf9d30b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__21c7f95961122ff0567794f718c72ca8dd569d1666dd00d1516a1f6e0e71160e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6ba0724e2e96e2a71818a58cd40d38671f3e7c187c046a1c80c841c47b9b42bd(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanChromaKey]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f103c1e670b6f0e89cc9a970b441ab29f042aea32d08495ddc99103582558b39(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    placement: typing.Optional[builtins.str] = None,
    placement_var: typing.Optional[builtins.str] = None,
    scale: typing.Optional[builtins.str] = None,
    scale_dimension: typing.Optional[builtins.str] = None,
    scale_dimension_var: typing.Optional[builtins.str] = None,
    scale_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a12dd12d17da03cc270bce2ae03c6571d86d8912308ea270b436ea4fa9c946e4(
    *,
    box_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageBoxImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
    circle_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageCircleImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
    text_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageTextImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
    url_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageUrlImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0c3c37a469bfd6c6b61a74e31ad79d658852a0b2c2c7e98fc54579981585d0d0(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    transformation: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageBoxImageTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__efd283372aec20f62603beade79905292b237907a235d6e08235920b471c49b5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6ace8077e09e94becfd4a30049c1d55e9d2624e7d6a0e7f2083d4264e006ea78(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be6fa563db4e6da7ccd3897811f0d5a30e1bfddad486870ff313f9bffb329106(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__60b6fa300d5ea7ffd5f9a4ad127ddfee91e3569c67d5342afa14c87d53413e5a(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c63e56902e94efb592de22e1f196248f9b01038b3430f2bba32ffb75dc7b06e1(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7766186e31da3ce4cd6d3b4f0241d6ce11a3b771012e0be7df02ae98a642633e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageBoxImage]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8ef19cde9cec152dbe4319183866fd1603aeabd53306f988edb142038ae028d8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__61ec055726f8fe3e8b8aa8b386340514045d94c2beb43510a9ff87d2a326a25b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__37bc3c09f8fc285667937e733f2433f175aefd2d75098d8f6d0a2e5fb8ef6bd7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d0e3f6b9019d6665d3a6c78e45fa5a3d1c01045ca84b7cc03e7d01783570dc7e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__83736ecd6a883156fa2e4cacb26598b11c74c86beb4d664f012d0a4204347dc0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a576ba748e1972de83d8504c621747fe6fda33b8bae3958c4ca0620fc0b9488(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d8b9b01e7d21c79f1ad15795d1647ad7e688ca14aab37208c1050d0fc2900490(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7c72fa111dda724ac31c006d3e30c7dcfcde0bc5336b3d0278883ff297c6b8e7(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageBoxImage]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ec364077c885ec36957f37757ad500cddd19b22ee0e4f63903a883c51a5d18ea(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8c888e99d74ad378164d906fe24116c51eb3bdf408066ebbb80b39b07e5d753d(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageBoxImageTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bfd20c02c16b1bda0d02e68a4297cb4d99a308e54004ecbbde509fb31fd8ab11(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
    diameter: typing.Optional[builtins.str] = None,
    diameter_var: typing.Optional[builtins.str] = None,
    transformation: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageCircleImageTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d0358b54d7c5f735114eea5a942038ec1581a6eb110a1b770e0b1747823a8bc2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5a0e26580475db513f280e128edc33284e6b641f283bc97adfe78e9faa7858fe(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2611fd0a58f8d18af217e2299a2351eb9e6ccf76fa38843dfca6d80305eda2f2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bf6893b1d670be52a93c226f6bf9770db3949a697c9befd2923af67e98e77072(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f6d86f6ceb3473de4f29091ef940aef17e3dc9c1b07cf2c4227a37ac12022945(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6529276c624816010c9edecb0644c7902943ec576a3e4aa716ef94d8a0b52dde(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageCircleImage]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d1ee99e153a87aa63ddc59eb748f65ed3dcccbb80cfda6577951a9af9f4adbb9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0cc13d8d76c5b317971b436aa52401c8a7aee4312c01236c9ac392c66d3090ab(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__085c826da8f1646414fcc1fa0fafbf6ae5e6fcf8f1b5a7488d0ad47766e510ba(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a3f3b4d7a4758d3bb5f6dc2f8a4dea537a537f21d87ed0ad45d0f31cf1e4ca64(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__95e55653c200c52dc0e174027c12fc5147887aa2372f5c406eb846f850b0f91e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__55ecfe00ef2eb623a364f585da24afe06ae75cf0dba64fa088463774031a399a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1c1445d2535fa78b815188204e40f1ba079d38b6cd6de25e9b679e38978c5404(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__00f18da29aec5e2601b33abe37f0aae91394daa8b0500649757630552ca7ebba(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageCircleImage]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__189541316a72168f2defabdabb8eaa2d111caadf698c538f690afd4e85617084(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1e97394c373275872f009f5b08fc9a6551ce932e622afc019b25e468296d2ed0(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageCircleImageTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__86bf1a90c44864c947cdd2702ce3e265818bd250f3556fb384f6fde483280f7a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e4d833d0183c9b1953d61847d929a53a1be11629e51906d4da559ed1b3e5df2e(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageBoxImage, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__603fae559399ad2dc41d9b81751cec3457a79ea0aebb659934df682dd2af3d71(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageCircleImage, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0179a8ee7a1b743490a6f2b2dc9f72cd6cf4e87dc7674ffb9c309549b21e9d26(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageTextImage, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__435bcd305651103ba05f69469907932152fb80b5ffc64205d4e16b7f746f8ae3(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageUrlImage, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0cc49941debb0757f468f84993142f8f2efda79a580d93957d4753b6d247e27b(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__276f62deae4b9f65aac8ff90825ca25b1e30fcb6ff69e1faf890f4ec14517a66(
    *,
    fill: typing.Optional[builtins.str] = None,
    fill_var: typing.Optional[builtins.str] = None,
    size: typing.Optional[builtins.str] = None,
    size_var: typing.Optional[builtins.str] = None,
    stroke: typing.Optional[builtins.str] = None,
    stroke_size: typing.Optional[builtins.str] = None,
    stroke_size_var: typing.Optional[builtins.str] = None,
    stroke_var: typing.Optional[builtins.str] = None,
    text: typing.Optional[builtins.str] = None,
    text_var: typing.Optional[builtins.str] = None,
    transformation: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageTextImageTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    typeface: typing.Optional[builtins.str] = None,
    typeface_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4dc1b7cacb5455ea95f156e3a58ab8efbddca7e54ec27a5ebad1300b4e0df7a9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c2bd3162a1dec4100eac25f2745add015cefd7086cbcfc17e27f51fe397c6e99(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__03f4d03d570e9656eba893426fecc843d17a46965112c0110fced29dd4acee40(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2eb23bf646070c6c3dfbbbd2b022c7e37430b5a4472f45a1a2484dc57857d06b(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f5b15a240a01bafe5b9d6a3208a534c585c028ac5db6fb03a7a989387ba2ce13(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__246b51021472978aaf7ba1308c3b9539d1c5c6590023815dc457bea4985f36c6(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageTextImage]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__17fd340af4b50ad26c0d0728c172f4b9a0a70ac547f7c2b37bbc76aad707f564(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c51400f0d2f76ce6f1aa1e21c293486a9ecb6b82a969f58e7274b6ff2b710872(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b90c600365b2c8f1a51df1df435f6591c547c8ce694d3387ac868f679240f395(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c01ddfabe02d17059449b37cead98cd14eabea2aca7b738255d7c725dfce5518(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__36f2aeca76bd8104b4a3703721b1ccaf258fa9b5e8b5ca41d79d8220c589bddc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e79bef0180f367f5fc5fff8977a383a501efe01010c82919883a558b8d869ef9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c5f1434c25891ba6ee83b429130639fe069e26f5e44d043dce3fd75d72357e6c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3cc75db2295372dc8551e47b1b0c63000a19cdb57135280cd77058ffa729876a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__513564ce8900df846a99ae786f67ad095338ebdd74f2d847fd506e0a9110973f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__67eb09c003af137e09bfee0cacbec022ccee4ee3b77c7ea889bd27359550fe9a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__90caf5493db1bfbff0cfcb5ddf86ff6059056c3d2fe75ec8556f6692fbd77d09(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5501f56521a1f0fd2d01a000efc1ca7c461e7b8189efe6243304b97bc2a4d8f9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7ad3185ce324f49ab2bbeae3a8f270c707ed6b10bec0157ba46057bcd1804ed5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__288e061072517338af7e11acff7260b977ec44b121ceb575f068984f893f3500(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageTextImage]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b915898a6175996f2dfcb7e8dac6376b0f6e4c563ed02309253252b5e04a088b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__03991712c733206919c9bca16c28de2e0ede01e6f7a350efa2acc66267eacdf0(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageTextImageTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__56b32649cc6ca7a6403c9c3d79b37452c659872a71daec960b3d7eb49bf4dd22(
    *,
    transformation: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageUrlImageTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    url: typing.Optional[builtins.str] = None,
    url_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7284957023ce88f4f356dd67304434c2d02abd688606b84640f13f46d6ae71b2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__062eee1cd0d5d4b7434ce45ae12445b0c347325487edf6e5dae3adc711201ce3(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a1cedfa7af3e856cda4d404de80be763bac95fad724776d01284d7d0262923a6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__39952b8963e5f15053456b6736638cb0315ec7bff0fcfcd0b03ac207efc8dc0d(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e6e6b7f7ce7e345cb4d919f31776676dfa52f58e017d275866286f408e269b7d(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a4fd6a269b49eaff178c85e1e87c3aba3da41234bc087d96a02793d4ead07c33(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageUrlImage]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b97066d1d1e4d8f8199c443900e23e8707ee03b32b79e68a1d706708523fb72a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9845a649cc3a667efebe5d77edd6cbdb34337e36f2b2ece10677330680feba0e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b3d5e0fb7cf4bbc62d7a329bcac4c0f934dfccf1f4ade39d1d8c5eefb0cbbebb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d493a83f8768236b9c1468b87a64a8a698781f36034ab28e6a04223cbe0c8a2f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageUrlImage]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f06eb3e876749ae7de724fc660ec6a2ce56d899e453a8853031c9f0b5a20da4d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ae5077488c1592755ba536120a6c35ff409d341bb3651c5c5c886d4befacfb89(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompositeImageUrlImageTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3377cce592e6fd37f7c92d3ffefd9fc515c848de841cac7b1ed180df93de5350(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b25d7ea49a7e5d327928df480f146a7b1132387be629b2e2d0cd96dc4a86d2b0(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cca2b6554265ba5b6ff09bd0b796e4abce45d566b5adb6a781284a01de81bf5f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e81eae6c74a168880e4d3b5a4f3d3026e72ae8559ff7c43caf2b307442c0ff18(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__85806b2f61bce829249ac1c571cd5e38061de2d0c355c1901d39247cca97e9c8(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2f10ab71a14870bf8fd1d062420d11a154ea10edeeac5c3c9e544539c36f53ec(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanComposite]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5a91ab5b175805259651325b9e7d8ae4c2e3af6318558f63d62f4abd829038b5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6853c8310a58a645978784c5833ab1a1f8942fc13f03cc1a64feeec937560cf9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__075b4af6887b77646de3e1b491c5c076046d83dd710f8c79b08b41802d2568b5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__52280f5ebb44c8b29e7ceee7635aacb430a1aa8ad2c78cff0159f9e8eea9cbe0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__660036ba379a41b928ef06a37c783fe173b223641233f783f3dde710e734d3f8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1e00952cb5bfef1cf572b1df0e730bf105b8344fcc205aeda8ed8b6a202e5350(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ebfc229bee6263e622262e131be5c64338cdcacecd3a173d0a9fe3c5a8836bb0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aadd9772d1deceeb6d976577632cb89f0aa87b26827e5c817e98bbe94800c751(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e904b51ad4f1acad1ee5bd0ca99a2232ce96fd233a49b35fb43fb753ddf9ff2d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f97aac57287883df6b4c56c6ff6fe58028a3bf388ce52c4078a443c9e8cae2fe(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ece7509187d12babf44fec87b33efba88fda960685d4477563dba2eaaaa82ba7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__589a051bdbb0f0652236ccef76a37cfc16073eeb33758d58a49c080554fa8df1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f21aa68ecbb69b58a49bbd44f0fa038226203d887207bdd0e859634763aeb2b8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1e399880ffd05d44ba0a458697cff5d4bb06ab8ab49b877859e85ae48f5a58d0(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanComposite]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6de384b7bd66d975f097726fdae7d9b0aa6944c264ba7da5f407ff06ab057969(
    *,
    transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f684fc154479ebaddb8dd052042784f6240da5c85526800c8fa34b272f7486c8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__246047c1a16029b01ec5ac13a1679cc1e105da623f9e7a02d94b43afa466451e(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eedecf239f34652dc71a3d0a11f2a174384224ba0828b99075a8318c41b66721(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bfc44a9fde59fb2f1224b4fd044268101314086a9b98c5414d753f608c0e9347(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cbe97e488c58fece48759a03308fd8a8f6eeac2d2b3f37d188f4dbe1e6dbbfe9(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__62907ba7d004ebf7ac64807bf808a6d6718e4bf43c23b61786ce7f15802c6b1a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompound]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2e4360d45eaf2d6e5dcbf88fb4b78a215eedd78106b283fba537fad2aa2deae9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__18297cafde5f43b6e2b42d343991fda9cd44f0cc1a1071f00845bda64e90b777(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd4cb090ebc584c5ddd907d1dcc542c023d7bdd206164fc6d6caafae757484e0(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompound]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__62661424489361ffc02169a08c2cb22fefc8f51e8aff9d8b15512fad31e096ff(
    *,
    background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
    chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
    composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
    compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
    contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
    goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
    max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
    opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
    remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__31987f3bf6c17e9640ccde3294310d8ff0c22e2fc819226e2cd6837fb9107515(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a209ef4f1629897e7f2c9ee2840c19a6ca50abc39acd3ea35f501bedf2a06ab2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__14f9956444e56566352c7e225e34c9dfe41961795f0573d0b44fc2b6460dddc3(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__72a554d97dd806d85d9592b187a46d232d313011e041a22dec361c74ae2f5586(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d029e5a24982bab22d6d57ed57b771505b430d98335e01a4b71dcf9c762b5b58(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c1baaac30e004b437191f5d7f0e015980d9300fc97d426afc25ae43677a9013c(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f7586e757c97ec4c4d1a7cc3c38f3ac47f3346ea198875f1605b62c0770e229(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsBackgroundColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8035764b9361ac6e2360cb974b70afedc937c02d1270514937ae94f1693b9482(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__870ba1c6a11a21be1c7208cb9e6b78ccda78cd3d354f021af44a1526fac3f4c3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__da460d0ee70b7a972a79684919bf02a3b3fcbb7dba40ef70acba7258d601433b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d64a353e00907d53a2555d1b7d69b9cc0c79d00411f5a1c34549f345ca9c8465(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsBackgroundColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__477e6af053bb5f2e37d40e8362be48324133fa3b245ccdb7df9dd7910e0e3dcc(
    *,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3aeaf83e9f682bc537b016f17561ebf3db48d4d3bf2f0626484ccf0bb3fb9ed6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c7f096af91bda9151a15985551ff7907fa35ad956e1c4bb91ff1a2be89bd1108(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dfb93f951411d2115f3c062553e43e76294d85886d8682b5d9a780f2671bd526(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8ddbd81f56aa40846a25fbd640f231868d45166f3939eca02d231e4b92fe65c6(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ce29a3f7d98e102aa01e096c0135d2c26ecd67c3eb4faa37fb2d06ce0f933381(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__223efc09fcaa28a1239bfa91f515276204802e209b7a168360bfa98b3277bc31(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsBlur]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a0a3c3b6c4d3c3916c4d9386574241353cc51c48baf54abe748bc1c623e6a420(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5db25d3069ea3ffeb0a76318975915f7d9b16dd2fb34a410f64e81c21cebfee6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__afec1b146530b89951c95db28b4168728f5168a1f94d21d1404d0ed3a1fcd616(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__01bb286233018d05bd1383b30379ab6e9790b5c1673adc9cf58fec0fb478a239(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsBlur]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__715cd1b313c2c65c85c0d211839ec1dde4470a779f506d57e0e687fb8fc7b95d(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_feather: typing.Optional[builtins.str] = None,
    hue_feather_var: typing.Optional[builtins.str] = None,
    hue_tolerance: typing.Optional[builtins.str] = None,
    hue_tolerance_var: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness_feather: typing.Optional[builtins.str] = None,
    lightness_feather_var: typing.Optional[builtins.str] = None,
    lightness_tolerance: typing.Optional[builtins.str] = None,
    lightness_tolerance_var: typing.Optional[builtins.str] = None,
    saturation_feather: typing.Optional[builtins.str] = None,
    saturation_feather_var: typing.Optional[builtins.str] = None,
    saturation_tolerance: typing.Optional[builtins.str] = None,
    saturation_tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ddd493130a35b2ff23bbd1588c3eabc7c77b8918219f2aa56cad58f2e774984d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__38c43b489d3fbe1dbc287ef9a07dc2fd92f4ee5bd9bc6afb5b95d0b3c7ed54d6(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c44d772002b7e5dd87605e36b0be7be2313dd63e6742c1a5788159293217d8dd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__15a839e318d0a824d4c43f41ccfcc76c4d9136680dc5b07c86df06ea6d6d892d(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__caab870f71b0915e301828c38d6c5afe75a290144eda4d30408bc9b4e7e04b55(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac2a0f680abb6625fee678ac1332a48e30beebcdd066f3697771ad074038a846(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsChromaKey]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__383b8d32a281121b14657eaa775abe97940e28890c4a906f1fa99bcd32179117(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1713d974b8a0ba60d304ae1b0dba09335899e1316e9b349cf4937814c4335008(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f74ed63d69cc7a520e426a3b512f7e20b2a2993ea6d2d918601182a7efccb736(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__39e68d4057bdfd0007d69f472c96a2ed76525555c60613f2b0f7578d51620ab6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f730e95de4b58a3d49aaa443fe77432516db66c99cdca7d74531b73d175634a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__89913dea8c458d835717717b08429c71ba5d1b3b998bbf1e96123ae4fabe38bf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__140cc815e2add982372ed2260442c1bbcca6c46fc67663e078ea0d5b7a9a7b52(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__db9d98d31cab43a863af9a73a6bd07bb9445a68e5cc5efb823d05598ee5ea5b6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8839e4c09a6ad0ffcf9ca9bb222572a20aea26ceadfc57d29827daa0389f3546(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__57865ed4a74fd49262dba45a3f56557d737f852056d5655a792b62c7e4d8e34a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__07d816c6dc2f5fd0f7c4a7bfb12db973db4800157a0bbee37290ad59db8671e0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__34511a9060597f0e438fe1c2f68abff40b383925922d3bbeff846a8daf73f4dd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8fe868bb672ec9721043ba669f19155d2116cca7efd7f63bf3ed0f7ad8e682f7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__db558d55013091423d27fbada7027b340ef5180d6e145ba8e48e04e048513ba7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__90024e725acee2feb76ac320dcc73d21fa62d8cc8b71d5b872a53f743fb68afc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eaad4480221c61a37ed15b7eee2fba5c552fb1e23efe86738ee73159a7cbb4b9(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsChromaKey]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc451c094d545c1166ec9544ac27a2f736fe67b5f271bd2c0b2e7b610f78fa17(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsCompositeImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    placement: typing.Optional[builtins.str] = None,
    placement_var: typing.Optional[builtins.str] = None,
    scale: typing.Optional[builtins.str] = None,
    scale_dimension: typing.Optional[builtins.str] = None,
    scale_dimension_var: typing.Optional[builtins.str] = None,
    scale_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ae878dd29cc4573119a269a97daa6a29f933816aabfb7f577df07eaad4ca6d01(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bfc1b20ce3f03c8cb3005a1f3b5f91ad619bb66d9ecaffa0867cb3057ea8ed61(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsCompositeImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b5d8f6b46acb5c87a5e3722b2d41fa7c951e12ca7429d25ff406f4780bafc623(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af0e7e17f34a46a132c3263e6c4ee4fa435937adfb59f2c8199fb2c911d72b8c(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4cb3290a8794bec60b83109caa07efb4680d128c4fc36739d848a2fd8d734459(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9e3aedb37d36cefc0bb4d59ff87e93f517424ec05e1dd41cf63ab1a66515d3e8(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f2f85ebe089f762a340d9baefb4a2e279bdf2f4e731d0f26f16a618c4526b5b6(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f5558ef8339b963ac6b5ffa9225c729e2dbac251c1664ff20c8b7d21632187f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsComposite]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fec31dfb9e0901deeb6447a13e87c821e2f8ff2e0d67866a4429d703277a804f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8450f11c43755b5a42d9d1273d87e579000d61f74f041346350ab76535e2550b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af3f582c0bed6175eff706c3018d9e557bb18205514b6769046f79d8ece4ba1f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1ec14811813f4aeeb385d5940e0e1f335925837d8a9a6d67fbd04630814c9f23(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__16d8b5dc6caa5e2610c8c498e7c8b84a7326687303a76554210d19f80e75cedf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cc271afd11a22dfc52d3a85ba58d0bf7e6b3e0823a77cd75c120ec7a319fe1fd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c59c1697c815c4a535c03d22bc91bf77cbac9150fd48d0c5d97305e19b94413f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e25815249e303d89f6a576e6dff80d6a896b08e478abb9f7cfdcc6e5cc2e1625(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f19b2875d82544999513d6b3215eed50741aa70edd5dc96b3623be3d07b8582c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__99d1235f8b45ae01a8d3e7e161654d1bb3864f6d605a96cfe18aa3f086d0c051(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__263ff155a3b0aed634a9f69be607dbcfc2e38b703ded4058284d9bbaf1e5daa1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bbcd431a2e0f48cd076b0e5c4b31a1669da7d0e780eb99f1a1a2ecbc9cf4e35c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bf7310b44efb92c8a3f8dbc3fc1b8111d587eefeaa6e23f51f4456ee47df4543(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f573502fcec785e23f64a1a217b6955d75aea9f280e606705e554c15273b20e6(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsComposite]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dc3399442fdd5992f78719bdf73ec587c85e82d443f38db1c63d2740599bdad8(
    *,
    transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__953d087bdd5cfe6829238dfa43ef735d4eef73c9bb16f9ac7c4badefe8024413(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f5f52dac835370ad307e0006a40e4d08420be2e57a2e736af98493f1006e45c0(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__37896c1318f38a99b41c595dc624e8159810780e7e84cc8291cc6c70e1ce6769(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__492ca459aefa28444eb3aac20bf1f588f3ccdad3aa49cbf222b72b65f4b6a7d3(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3727e2a133e14be613058029c864660cc6ebfefcd26e428ec8a61c3386c0e101(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fe8392635fd66ba8a153f95ba68d145fa70a36f8a50cdbe7dd7683f4bb7265ba(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsCompound]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__688d8daa6795abcdf3c77b7f26239d6d3b429cc8da46e1f78fc44743542caddc(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a18a7e88532c8080c9a3c683d3b4c69bd59a8f6cfb43434fa63a49f40c395718(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__196ca71ffa1e7b36e8d9b571206757196eebec513cb2f712ce4ef6933f715ea0(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsCompound]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ca0f8c1db7260d1ff4807da8f18f0344d9d8201bd623efa6ae7679a92fb4a438(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__620ae1dce5af61e4a8717a84da02f5bf9eb62803945438cb41634b9cade8a9b1(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5aee3154becd5b32eb7e321818abb9acfe715b12f786a719ba64925c10b4cb37(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__093a3c002f4f97c3b1a920ed66b92b0ff02d126412ef3e27952e7717c5a9d2e9(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fd27dfa3a40e5f4c862a30b3ec5c53814dbe481949425c46b056e1671b153f82(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8c4ee1093500e61ea2d4807f6e10b8515a889bf02120395d4f6cbff655a76cb9(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsCompoundTransformations]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7c1e05489dd5aba938540e144d5dc37e9862d931f82b23874b31aaef94d0a013(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f135d0921d0fd28e52892f07866d3f38047b8928dd8a474cbd579464eb23637f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsCompoundTransformations]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__860d8cf8725891afc6ffdf566e634e1f3f51443a10cf3d99acbf5c4f576c8c86(
    *,
    brightness: typing.Optional[builtins.str] = None,
    brightness_var: typing.Optional[builtins.str] = None,
    contrast: typing.Optional[builtins.str] = None,
    contrast_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2f3a306a18831ae503e37e247fc54d52fbe89cde6b288378015c3d9997996749(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3328483c39074f5f263f4729dac81e0640e14e67761629decc724d25f88652d3(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__daa603a6b91fdd820e09a405cf5c492099ac992f0488fdb7f64e46889e23a430(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2858bbcdea39e4b223bf717f659fea7043d52ccc928a815daa25fffeebfa476c(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e1df083fd2d567c5de8c13dd05953616213c02d4f7ebb80f76a3a4eabe62dd1a(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f69f00454b2a935c2e2130e5a9f1ebc2c4b441f0660ddb327a7e8ccfbdc852ce(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsContrast]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c419531470236af5a8606668cd9369816c9978f8d39e55138d5db287b36e6de9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__23bebaf1627c62f7f4f68424892f92f418199452df44b358af5b6bbad21a4910(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__30e6c1602bba5eab4ebe327f252538378c61681c2c3aa734bfcb3641f52dd42e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ddd7f7846dd8f4a07885ca86f1cab46e8125141a093749c5d9b47e197fd5e0e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0342e330c254e9b66d103198f7ec4e80e89d7b2251cd3891a44158ded76b7ecc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c20ba7c33cb75419f0d2e1ecc3e30d25d0dd99629cafcb9f2fbc439684a22683(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsContrast]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f8afae5a76a24c88e8a25b19ef10205444b46144b432a0a3a66c30e941c10821(
    *,
    chaos: typing.Optional[builtins.str] = None,
    chaos_var: typing.Optional[builtins.str] = None,
    density: typing.Optional[builtins.str] = None,
    density_var: typing.Optional[builtins.str] = None,
    power: typing.Optional[builtins.str] = None,
    power_var: typing.Optional[builtins.str] = None,
    seed: typing.Optional[builtins.str] = None,
    seed_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__30cf2752a9b323dec8d69b43bd50bfcb8dc8e41119af1182ef100360be973440(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b8073e2fdc7c4716bdec3bf4520e84ce809390b9fefa6e744cfee5a2b88d87b0(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f7809751a0d4f0fb12c7b4db439461f2183a887d8f7faf715e132bf13e99a60b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1fafadccb404a3e22d91040dc7fe7f7f08dd08c10a9689c6a84c634c9f884cee(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4382eafdc2d10be90c2e827f85002700501358d263b2b1f77b174473e92e94ee(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3613c28ae7bdb886ae34cb4b720b462ceb9315cc3086411fde2700ec761aa729(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsGoop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f9c462b253da39f745f32949f6767473a49e57f4b4a6361939154a3c9a129e10(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1820a139e69151bdd80273d6525b4ae4d85ea6b1b763774121298db42f21e87e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d80ef1e2a438eeb73b063a8e02459f03f256e435e42e89b0e1efd6ead7e8660(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__22d6ce0053492950af853bac016649bc5f8a141961fedf329427f87bc94a176c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e09cbedb289ec5171e0b4b76d9346fc04625ec2ae5ae2b1bacbfdd6e5a4080b5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b31d7dbea01bfa815e95be0354115369de43ad4880315eeceba8eab0e3d2bc12(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__77e8d3991363abd50392b6d4665d0f6f7b7d113fbcf877f71ef2b40e7a9a8ef0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0964be94d4d6f5591bbd5b84a5bd42cb3ef93f8022ad31a79291ca842fe2d016(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a101a89c85af3dd509b6fd3be30e18414e8b97ad7b1658a1525bef1f1ddc1db2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d833e986efde4ca217234e2d4eca5ba88cdccbef96e54ee4708d0fec8def5ea7(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsGoop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4d63a668abdcef8a0afb3bebaece9094d6b70cbd047580c105525d5cd202e8cd(
    *,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1bedd7dbb335791e420bde01f778ced80a7ec545eca962495d4d02049c5bb331(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7424c22f9ae2ca17c3b02df47032970375d358ee0a550073a23b237efec378f6(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__302ccfdfa981815ad11ee00c37967acb06feb94edc31f74808d7f3c270e2235a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__30bd26cbc722ba9b6dcb8185da95edf9a8d18f29f720e20ef347470704cb3a77(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab781fb5b9e3ae268d90f04f3022c56fd6c8abd71bdb35ce641d9aba6ab4a52e(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2e3245460d832f5dea76d0a76b64a7e4ae10540abff5fdfed6a8990b35417582(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsGrayscale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ad0f3e006a722e479591a00bcdd28e7c3242c3b5a30a2ad704923aeac889a94a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__65b22c19c17a04818d6fedd2083bde59c33cebae012c9b779cd594a92f8cdf79(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c3d0065bd45a4f9951f79c6d1b1bfd2bf819f21c2184554b9a5c1d10a98b8d17(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__67060c4bd70ddc0f7b884faa26efc04a23928fb98ea371de0dc6b2d857d7ca78(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsGrayscale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a34afb7ea5c16ae90d89a689cb818a982619af816765ddb5ec23bb1e5a199b6(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness: typing.Optional[builtins.str] = None,
    lightness_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1b5196a4352eae4a7e51f9ecc18be3c8b4f28df9f544cde239e5a7e03e01f69b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__906b5bebb91dd2e68d31db832948adeaf386d73b8ab0a93924fda9d0e8a9a23d(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__73fcf281c9e253bca6eab9b9af14c362797e3e17359b7df24c3167ec99aedaaf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__336d12bfc3f5adb1ebf3d6c974896acb8273be1590d92911229824f5d99e4b85(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6250ecda5532aff9c8b10ee6e85d172f9db8baac355e69fd4a01a65ec2d37ac8(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d1f93ac9092157330a7fc05086674aca3df51388146f1681442d09852204681d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsHsl]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b5c7407efcd0ffb2ed546efae543d6f4a438b76b333231d30b10f98fa82efb67(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__53018a8284e2e9d615e93e6c6cea5e585487445d102789f3db74cdac7e1aca0d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__492377ebcf055f25fef45b06cb57cd0fb3fc584fbc7db10d7c327f163241e3e6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__97afd368461d3112a5ff42b702c2175e4c4fc32939cf901039babf21849342e9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__24334ce739559d70dff655ce5160cbfccc5ad065905b28b1c2e5f08f391732b7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a4043dc798a1d43655620ba6a650a26c592e85337a8d546710be4ef20aac3846(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5262d9ce80aaf8c55d4951f6b5999fa15bf66b712b8b2d032c22a6817a2db50c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__79ad6540190841a9dcae9a75233fa69f28ece659140a7667a8e36d6ef8e49791(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsHsl]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d94e62ca1104addca2bc7267d5a9fcda35ee4c84286138553ec2d4e6adce61ac(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0d92d2a46a71004c6e606a95339074fd9be2b9cd4da64c08015e3e41f941a49b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__010b3c2e16c618a6bddf022781bfce622a3c2e2723eaddf5e4c232bb40c1f39c(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__113f2797a9632887e7492c1f36daa05b1a0a08bdfa66abfea67822ad8338913f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__514ac514c279b31acfa4de50819e8a7f59b5f2c4be2aa8b7cd31d72db568cf5e(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4332c8f750b6a21696b3db06c82d30ea9275aadf32795f518a7e24286500d2d3(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__84de561cb01ccc5e693d1da7443ca1bc5ec26e81c551b64a5e7927540ab7ccce(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsHsv]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__040b01e8afc0763ef48b9928ea5d48cce099afbb5e6e94022924218bd0753c04(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9b3ffac72eb81c64a700d5f7864fc2e3b7cb72171b6a65a219f09431aa2e7512(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c0dde8b53b32e7a644d0b85404b6bb0672bcecb2f776abc37470b5b4c4e97d4e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b1aa022805c9cbdb06e94ec671f166ee08c5e8fbedb9d1ea310a46b5e337f18c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cc474a31d508fa309d6f498b24cb1af9e32268de45d81434c88fd79fe59c8753(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c09911cb608f235272e68898c7f578c36dcb94a1d102549f96fe914197793bd2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7a806b4132ffa1cededc56dd091a1986748276fb8cc11e310996051494a2b6f1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4d5897924f8ef4749a5570131e5d5b6543c4af6ee23b506dda3f4b4b7f598f44(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsHsv]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ada8040878344cd533e3780315ebbda1f2ae708391ae4852282fcb9a5be73715(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfDimensionDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    dimension: typing.Optional[builtins.str] = None,
    dimension_var: typing.Optional[builtins.str] = None,
    equal: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfDimensionEqual, typing.Dict[builtins.str, typing.Any]]] = None,
    greater_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfDimensionGreaterThan, typing.Dict[builtins.str, typing.Any]]] = None,
    less_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfDimensionLessThan, typing.Dict[builtins.str, typing.Any]]] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__77470b772e740ea2ac126a166641a8193dba165b25624c29a8c8254e445f7579(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dde802d0a2c12dab277d11855bd2e30b9281e952e851fd79f091ac5193f0fa4c(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfDimensionDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a5fbdc81716e91fc0c6ee01b6a30280bdbe9e7442ca8b63e71693781cffe5145(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__706142ba01a16c28622db175553311e720a3c733b7abb7155a4a0c309ec704f9(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfDimensionEqual],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8926ab76d51b3ce4d15303197066de10f777f383c020e4b0dcac9b9c51ab00e3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f62c19e9831e632d78aa095e4033b256bd54469b9b39e87f3218863d1eb78aaf(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfDimensionGreaterThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__771704959c74f3e19278355206520d663dc1045a1a9339c6ec49efe935e34103(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4d4eccfb1ccdb611c3841958c6ac27f2b35b87c724a6d129518d52c80090c41d(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfDimensionLessThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__514f5866e8369b6ef13ae55625e801aa97f38595bc92d8e90c7becb646bd1227(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3f4e445c10bd9f81ad35181b35740c068d4a498f016e5d7ccb4d25422c4ea5f5(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__658f01989702a682b6b15bd346405bc56eb11c572b9d304c9a89d817877688ac(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__51113a72a9b83df744469ca4a0223e2f25b221f33b8d898789d01b434025627e(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a20cbcbad88c74f923b4296e207684ded2a3ca17211d0eeee21bc5ba825d322(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f24ced4ba6eef72fce4295025e5c03951ccb2ba08b5a3630a7074d82ced3dfca(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfDimension]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7c57ed715ec489e2a229a33eb25f6083e376dc6ad163d2eabb9dd60c9cba64ee(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__12e664c81971c6d2aa1715ac69ad3973cae9ae6c16b1c28646604af66d09bec4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1523f7b26898d5e6a755fd3a6e3c6d59fea06d820dca7c3e71a9e456ad4ef40e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d4948a141f057a6a7f9825cc90b5456b77d35aa1ef82e0a9b7bea0e0d039eb40(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__17ead594755c77ada38897d7ed060d1b555aa350974e09cdf9184d1da72b0cb2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__68e471b80844cc41ae0c69c9f6772f9e2c53985225814b3131abf9d300e8665a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfDimension]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__00b78d3853d34132095d80913f775e5448bf15b4674e9d9dce119c772f640f06(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfOrientationDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    landscape: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfOrientationLandscape, typing.Dict[builtins.str, typing.Any]]] = None,
    portrait: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfOrientationPortrait, typing.Dict[builtins.str, typing.Any]]] = None,
    square: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfOrientationSquare, typing.Dict[builtins.str, typing.Any]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ad7808e899da88956eefcf14b0e53c091181730deb661e5c2e7cac43ba221c3b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__10d2100969f9e7623435eb8c57633e455768b7837df599190dfc9207eafd0028(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfOrientationDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d7b45f29b648e817f2284e05b543dcfb7d757358f499f70e06889fb5a35994b7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__344be53f6a7a9b9e66b953a4405887972d321f605ab1d6a05127ac306a3f9987(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfOrientationLandscape],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__16a01f4e3c9c8dd5def7daf387c331ae7e8d19eb374dfff227a9bbc4fdb089cc(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__134a28e77a49e1230e28528a6b198a92f674b399ecce54d35f8f2fb05373946e(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b04d7c7d9b8c3021ef533772e9c766b040010efa4518ca7ea90cc018d8815b18(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__71d303aea03c2a9ef2a5210385c366817f9a7454ff139e86a7fb62cf2cc53198(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__255711831b3379f64162ee40acb9936bcbe3536f4788b88e38b22a8f86c11f08(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f1622246f28ae51e0e278ec4f74ede7d25262872e8d573fdcf365597a5a60730(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfOrientation]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__775bbb3cb35530fec68f36a283688dea3732b87be48767a0801f77941c687fc2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b0af1827743db2f25aa573ef5fb08c862437865061f7602ab68e818645997993(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfOrientation]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__22f4982a50537088ed1e3ac9277b0217ba9326bcfea1c97d50b0c7ae0a9aa808(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6fd4f2fcc118aaba6d0735c60c024bcddf2a65ba0ef26c712bf47fe3e2000c16(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfOrientationPortrait],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a45d5071c8fa19e4d96104092e424e35fa601e9ea4e65b90a3ba85a2957ee686(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__098b0a86bc781c34fc14015d1948899ed8f6fe77f8d4db80826c0b0c87d4d4a0(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfOrientationSquare],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7cacd69cd44f2515b732e595dfcf999232f1461767ed863e8cffa61026781d94(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1b79215dabcee10b44b4817ed91ff94bf91d3952d485e0856154a054b6f6a0b6(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4219a811027bb227bd3713a187bc499a5adb079abb8653161462859d02d52788(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__08c058a95f075c2220b1976e0d5fc4af8f490d74615b4e5d093f93d43c8a35fc(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__17e12915fd4236c65e801af60e9da16bec3683fe93073132121dcfeae89dd218(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd33e3ffcee3c981551691ee2179541513beaee751a9d47969b26848c18bbcbd(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformations]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8ab5cc8cdb903579a774cb7a9d558f4d73d630e8f3730d8225c919a71d94447d(
    *,
    colors: typing.Optional[builtins.str] = None,
    colors_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c823f8d2d69dbb6e9e33e45533e71c154c88172f3112fa2e87a1268a238ce2d2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dc10cc47de635ca37a24b0dec487a0b4ec1e01d2b767c75261f485ac72497b62(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__12d304b7a8c196da305ec293bf8c944d986612519b8dee2e9d0666549042382c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__352923f6cc38bab86823b7860f522959ee2158625d0a61ec5869679f64d064ef(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1e69947114843e4f41524c4f017ebfc9522345ebe6e3018b290a320fd16c20fe(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8e6e40c52a1e136a041ab1a3f816017e4a7a2c7aa59d29872aeceaf5afdebaa8(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsMaxColors]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af5426604cb7f5ca4bfb409b5e810cffb9a46f8006585e3291e371f3f5484fcb(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ce94735ffa643f0b27390d86e37a59670f1026d8f1c0e77a2b478c8b87a7a092(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0566e087d42faa24c8bb83294db2a947ea4f5e41277670c558d01ff9e55e93d9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c1661c9ea0d98b084c30105f7d6208893c9ba121f7db604b557af9eb84be99eb(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsMaxColors]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9f9e8a3761f44ce05dcfa82588f137b3288bca8d01deb0971eec8aeeb04558d0(
    *,
    horizontal: typing.Optional[builtins.str] = None,
    horizontal_var: typing.Optional[builtins.str] = None,
    vertical: typing.Optional[builtins.str] = None,
    vertical_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__337f71f8b68438c0ff84d35d47319792153ab6e5befec627fa18380719cdd39d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dee123e139cb4d35c2d508902aee5b9a57faab26e97405b834d2e2ec936b83a6(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c6adb400f1918a97d1999aae94a82d6faf26119012beea07105ee8b5cd2a734a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a4e7e6b764240f24304ddc83c7af540822b20b586fda4fe9093ea262f0ed1355(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3b1c559667ee4da668c5de8c8114921bf103421413f321d36ede3a4f246024fb(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9c05fb235f80d4654e1ad2f7bd570ad339704a43e419d361440c91c0319200a6(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsMirror]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9f810a09dfa46d5a35c1874122beea98099ad6779fe3260f8afa7605f8fca12d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4fd939eac5f9708c6bf3b49a1f4cface0b62dcbd69d2a31859cf8f98b3874365(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0b81adda1c0e072766381b86ed64de00805d5d4c499f65edc755ba252fc29200(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__71ca9dba4243338aad446420f6ceec2872db84f9b06fbbe892cc0fdda1118793(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__699918ab8a90b10ca9e81ca5e2a75c0b194d256ab087abfb5c04ab0d53730b28(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ccd0634c4900262ab0c92d179b4cd0dbfb87bfefbce48f1c99dcdfc1fced926b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsMirror]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2b3168a2b08d4925dfedc2e6ebed44d3d66fb71613a611553ac3e0a40ea255a0(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4110be9847a35077219e2373f3d4e34911c60053a33b4586260fb7806eb37d30(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2535c100c0de4960876ac48f3eed56d18ba6668ada6312806a49726f51db9bde(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1fa1272adac9b2d094e8eff612175c7d739a45ac8a1951e41c8eced476d9f434(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c181dbacf684b0ef54d6a4be582cda520b1c9a71b206996f070663f50958ec9c(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fe324661368c52cb3f87297c3db303bc6e6194e97fefb4b78a7810d2d4e6fcdb(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df4faf6b09d5463d32e7de9095f2436942320be91f2fc91f2d61c043be596c30(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsMonoHue]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6a0bf2e7e4337cf1eea8a8318efa27a115e982ff2818692535366625e88c4f86(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__97ca1446614d7eef7b24a30fb135ff7e27cbf31ceb5b8b79c5581a7215c7f5d6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__400a0d05eaa4cbdf55f0b3fd4347c2aced0b6b7e4f9f33b82074d3e9313ec6a8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fb9985c0648deef725c45a967a0f76b8b714e2c3649ed71cd98d5c9a6ac5de9b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsMonoHue]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e3a16c665772a7ce8eafa0c68201b15cc6bac9622c9e9e38c3e4a7a763ce6a49(
    *,
    opacity: typing.Optional[builtins.str] = None,
    opacity_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f0c83128963cd1dce3ac3a7b57dcf33bce037d3c6718e1ed66ea241e25a5bc6e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b9e4b7b0677ea33907e8b3bb971a9054b5665d21c4ce19d1122bb3b0ddbddf4c(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3544fd7b10f5d085a8e0825b1bc67c5222430730b70f97aa6fa079abc916faa8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3412b05eec12f14118865cc520c79b87dcd70db829d6cfb02eaf11cd2a77e2b9(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8c3afc3f9a2f6dada3027391aeac8c9e87324e2b8153ad31a6ff4e28b0987a2b(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ae779a604e2d9ca358cb323732bc1cecc393fff26ea71731bec38a43105b81e6(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsOpacity]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c9badb1e3156be519e49725e187e412a7211fd78d8c960636c556935f3af6a7a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d2824e149c1dce4462395b4a3765d0f5b4c4e5a93b2a6da9129b57250f32f69b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6cc374c643ea8fae189ed52b6b4ad9e47bcd14d4f2009e9801ec34e7c457c9b6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0eddebf54dbb1638c7cbf9b29f0669642075448028876d8a5bb31b90aa0ce7a4(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsOpacity]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__157bbbec67f1872f32908292d79212d7733044123c86447af1da26a49fbb6c95(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c63d826e9994c26f81a5c6590adbe44931f0aa4586d05ce0ed3a054c72575fdd(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f206441757246fcf392c7744066135abedc223f72ee7f637543d205409331bd3(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsBlur, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f31eb066bd617ee91d3d4db79fc287f6d1f69b128073022a8fee1ededad410e(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsChromaKey, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1afba2190741a6b8d0becb3eca19cda115e6fac6e73b89a23730013234471f20(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsComposite, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2cd43b48003b440b566de02d858bf0cc8ee3145138c8abdd942400c94ea628d3(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsCompound, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__31df2df163d561ce7eb4b6e021698a003f1a1753b11145e50f97e13e563e1ceb(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsContrast, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__068f0c3cfdb66081ba23c42e908ec7d13496b0d1bb517544984cc27227b85702(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsGoop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1c082688f47440201abb16dc1d7d33e7e89098bc29e4956f3bed71935e6a186c(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsGrayscale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3819c19beacc03601e0f69b245fd0760d217a7f1bbedecdf73363e743f7316c6(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsHsl, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b99b3328ba1d5171a670105ae389bd78cd3647d5fa5ec15c5387456d2546ad31(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsHsv, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3dfdd06894efce9b6c8c3b7089bae822741e631420fff08fc89669d36a027ccf(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfDimension, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__705165d83e835f9287e20a9bc4cc5fd498aae66ded65aaaa055c87fda419d0ae(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__20bcb011e26df3da89171bd59c20b2301d142849fe500095bb2387d0707b5f81(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsMaxColors, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__de70fd5b3c84cfeca0fdc8f0843a4af0bda7ba73bf8fc643a9bd9d4dd08a46c0(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsMirror, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__afe9c500ef77647531684a49ec30fb25f88a55ecfc824460e0979562499e6435(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsMonoHue, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d5867c842fdfb9907cb392a5c167787f11bcd813dfddd84b2ffabfd08acd9340(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsOpacity, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__25efaff4c252825c4a4d21569de2843332c6170dca39fd821450f5f8a04fd301(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsRemoveColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__311a7a6b0d259789a322f39ec6eb9132cb01842808bb8a26b32c50c40f885a96(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsUnsharpMask, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__da28297c19c52def805e45faf5589bf8a6b54482e6815a2d57bb507f8c1b0e3d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformations]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e355adde72354ced96c8e4eef4e433da9941170c5f28744bfbd0d90808c11bab(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
    feather: typing.Optional[builtins.str] = None,
    feather_var: typing.Optional[builtins.str] = None,
    tolerance: typing.Optional[builtins.str] = None,
    tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1fbd9ef17a337b8deeac589d079ea11e37f974867e1dea0d14c7f92b0ea9230d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4c94788286d79ab4b7d45b3ae9a0a703fe33d1c8dcd79605f05cd1b2a7d81118(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__16fbce41aeb272a475c217e573e94f7a9f78c36053cc2d5856462b7d75ac6c7c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9297e18fb4788be3a362c77c6bb1c6de94b05f5471c746656b2e9c027747cf55(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b63f16ff179ddc08268fed965551343df87bc5d68a2a8817d902c90f1acf71ab(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d3b0149901520a5be87cdd091050096b83fa1351216a65b0b5f6b1a1c49d8a9d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsRemoveColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d0dcb8894e351b86313a474d0b83db94b410246649aae3a24b5bb003557523c8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c0ae46f010988f3800a7870aab2bb101fab5edf1323d193c390aaa64ec3af92e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__64eb4378b1bd873227693ddc97aa0797521524ee562ccb2ca4d33db20c16db4b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df26d019708ed372d89bd0f9d60a9c34f629d6d91afd50df70a17ccbab9273b9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9f7fa7c09a92f2ebac1cde32a5f402aeaf82ba7860f915bc841cd2ef491a4fac(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d5adae39945e7b89f5d038f4d3fc861b30568c05c84cce64c77d75c4620ae3ad(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__79ac2000f0c11ee6dd8e8648a4991403fe7436b9bcf99356db2bf3083727c763(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f1c424183b889b1bd707d7783511e0e75d5633341609d1d3fd9ce9499a3f8dd5(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsRemoveColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3b1e88a49d587fe02423390dd23db37eed391beab61ae4a928b81be895de7b2a(
    *,
    gain: typing.Optional[builtins.str] = None,
    gain_var: typing.Optional[builtins.str] = None,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
    threshold: typing.Optional[builtins.str] = None,
    threshold_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b43975d428ad83376a71125bcc3466de0e1fb5462ff6315c0b6a7e379a6f407c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9beb6750fc6001c15c8e0d88567104ac4ed84b7bff442af90279eb7cef6dc54b(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9991f9bb5401f6fca52264c7a17f9fe26712515e7b4dca714c4765388036e729(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3918404092597ffddcb8f84acd1e8c44af8635aa3e66bca06e62ac11d90d46dc(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6874e5a825b510ab72eb3d711f36b4046665816f2b36583584de230eb9b49d52(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__559cdb2166b1cd4afbe88fdd2ab05ac44d2516d7770be8e1ac2369a79469d631(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsUnsharpMask]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b8c6c0f23dd9319b6c41bd06d80184b920207c37e8984e71b55149c7ed1f38ff(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1ec2082cf98f258588549099fe839006f7dca019ebcb9a68848c60487c0ac85a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ebebf5e847961e61eeb9188d1a6d4bc725b67e5051ad3de7c6d11b152de74a0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1d57b85328065c8479dd8ed1447eefbc237a28ab793d69ae8b3ace728f41a168(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__933300f92b0a90f37b32bfe7f575b83f3067af839ef77b2dbc44cf1ecb7ef3e6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8f673caada516810f734b8baee0573df5451d44e90e4f1700762f284d6223605(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dcc7acb30b711ce0b393bb865959a8724020d8f03cb74d561eb1555869d110dc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4d0c5a9516e336dd2b57f5ac24610f889d1a53bf4ad380d0a8ef07a9d239c47a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompoundTransformationsUnsharpMask]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__30931dd833684e601cd97f26e17a0ac0b13308b8d3f193643eedff15253422fb(
    *,
    brightness: typing.Optional[builtins.str] = None,
    brightness_var: typing.Optional[builtins.str] = None,
    contrast: typing.Optional[builtins.str] = None,
    contrast_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__766f1d278c2485bd1dbc2b93ffb51c1ae3925ba40eca2e9e4011dd8f3589fd5c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea3230294e44f5c49ca7482ac9766cc1bdcae0c5d662a1d37954c2c3469b6427(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__80d54f887cfcf9079d4d61f98575414d9b8f8718c568b4fff6f15b2818ef7bbc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__98e2c73cac282eab4a708ef36fa363eaf46c643bd9b842db63f6cd80592a7b2c(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2864ebe5c66e403107e1b0663ecc7e891793983ea444688a50dcc78f14032309(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__45c2aaf6aceb62ff4a6fa08c0b7416ef20956038a77352ad768493a9ed7dcf60(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanContrast]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e115bfed70aad6586e415d9833dae9d7d9899b27db635e7283c52fa97ba9b79d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__707c18ddaac8e9a7b2a0d73f76518dd682f9fa9ddb48f973cb52c78986670048(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__db525e2e94489dd15e1012003d22b7870f6d8e1593a6a0d7ff9895a184affc5e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e698565b0c541b11c89375f2e49c9537f63c142c12ed7b775de650873b6b1c37(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__377a625bdde4d4a996872788175cbef0958df9f51449134d4c374ef6f3f87565(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__167ec7e011418bf2ac95a476e71c41b2446c60471bf1307a69af4ce8bece8bcd(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanContrast]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bfca03cb0caabe7815c6cb1b56ae9b57274aba9c6be7495321f9591fb3d72270(
    *,
    chaos: typing.Optional[builtins.str] = None,
    chaos_var: typing.Optional[builtins.str] = None,
    density: typing.Optional[builtins.str] = None,
    density_var: typing.Optional[builtins.str] = None,
    power: typing.Optional[builtins.str] = None,
    power_var: typing.Optional[builtins.str] = None,
    seed: typing.Optional[builtins.str] = None,
    seed_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6d4c4f60c47075e82039ab39476438a9defbfe3f458390189b7b0795cc7b8338(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__00f8e0deb7345c4a98b072f0fd8f53eeb5fcf3bc8402dabfd29104d640145ae0(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8ba519447b9f6cec95ab2cf99ab2c9b9c54e7fc864f541b83fe3c7e84996b10c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__baac1b39f39cd4a2cf037ad52d24d5d97a30d89195fd307a2d4a0a28a4f08683(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3451f6fa1d56195c0d94b66ec2f59ca19968135498f354f5300c80cf633aef53(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bf4d049c29e56410215f8751c5b60257304c8c6f4dae06f28cf266577732af28(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanGoop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3b5b804a26df33da0b68f65b4d21c08518c247933e9597742c90c869c94d77f2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a316afbdde0e257b2a6cb6f4999ac71520e8f98ff3e6a669dc04ee31e046ceb6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d5d9fa21f327d2200eea55ea2be964cdf443cc32055f3c8b72db594040c1817(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e6b7244d49ac183a66abeb963fa8a813b68ece97bc1355176a292d06fcb837ff(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__904c375fb825914dfc28afe846cf12f2db4225d02bede42bfffe2d95d335e652(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a5cdece2d50d186454eebebab526980e509a32935c654bab606b875474037c82(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f23ef609e76cb87275a5e30e965e39fdd0e039fd37aaea4608dd1e9df7e90d31(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7334b89fa8693e7f8c78c63dd5e1f67b6e2a9f7826eb3717f170e3314f292e88(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cf80af28dc9ca69c84e5a5c30a49e4c179e09a3aa4639060b70ed0eb9f4c4222(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__899e8c6964b779b6323fa848cd3ae75867914c5374e7d07ec831be5160747abc(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanGoop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b9de35cfe9cdf70ab31ff6225b4f8c551c3969a39087029d8150820305680af9(
    *,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b64851f56d6b691ce3c67d0e65f2b68f532a8ad43cc5f8406b7b608156773be6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__984be948fe608d34164a13fc80413fde0d2e8728ab423450ddb4491dc3ff44a0(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f9a5e31ef09a8f542c32a38f33b014c2aabff9d0411c8d5e5379639f4a755c85(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__59c2b3b14764ce1c470831fc82011db92f95552c1bfbae2fd65004cc3bea30a0(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a00ca8d6cd66080f52983ff80d78a46fbe76e03f57bae8f53c60632ca8be738e(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9919c09e00526613bcd2779d301d360ae35e11fce8d0a4cb488a69ac68748005(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanGrayscale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__efccec90aa93d8cee4dc857930ddcecd39bbd1cd03ed806e0c4db452e53a7148(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__46ca9c628eda4b257735d0f034c56b987753254c89c86fa5560d40c4c56140ef(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7c3ef0f1f015808aa1598c10884f8d27e8802d0f437f13d48e925b2412ba43ca(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8d48440bbfa761f47660772d73635ab0d620e7856dba402a60738852dd117874(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanGrayscale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__de8311e947f25b7a41451f558514e61b83a02c02538058fe174b3c97c3f151f3(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness: typing.Optional[builtins.str] = None,
    lightness_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c4ed1ed88b3cfb2d84e725ec759de9d172930001c3683010524463e024702390(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dd9e5a6b8b05349c950b920612eeb5a90db012da642ac1f95477c5671c8cef75(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fd71332e2ec35a77a48e0c60740b51a8eb697727dfb63fa6ad96642d8db26f18(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c2c6825a48c11d60c4424d4cd070197bbe98048a25d6d6269a762df9efe4aaae(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b0368887b3f9ad2346b88e160e1c76a2afe188ec826c3cef0bdd628d2d645006(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5c4f85c4101c44242125da829e013019d42df37473fd944a5ee3564e78c12ea2(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanHsl]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__92c3d2b1c95fbc7e7882918918c3a20bc3f22c3c8c451a09777770fe76413765(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b2730ef494b12bdbd6d915099f6db57de3a3ef32bb871bb14ceabcf1005b1895(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__48d07a315c89066cd9cdc2ba26fed4cc179fca1ea7c0a3d9b197f9b53ca73b97(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a1a06b2db999a2c3f36a631a198ceec4ede45e4f9aa015303c229257cfe570f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__87e38ba3cb759a0d8ea8f2b5c4a04ffe938dd7ada45eac0dbd63ac8d3d35e8b0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc27664be7b3921c962f2e8297df1de6da485a096c91ac8e78e84207b01f0926(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b0d83c1410e514771a35812859d5ff1c0d69e7f61af3380bc9c4b66b811a7141(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b1e06c50d2ae3a87cb0f09d2eadc7a5d35c1fbd243fa1006f86dd781531d106d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanHsl]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__68d8a68a5aafafe447a6f405c4c6a07ea175b247d515577e7ac1fd39f9bf744b(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1d87ce5f22c5e8b1524137707d28a74304a95e728527bce6f6cefb2bf3e58ff7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__425411e644d3c2af6b555e5efd5b871dfef0657af31bcfd4a983b5e0511a6307(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2b73e4a1b36e44b76c8dce2441b323439965a861bddd525e6e2e21aef5012ae5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__51d74f2103183eedb0f3d1d75d1b5b4684859517c0f758a4bb65654f201f3054(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4c4f7ccf59c93d8e57c3d664979d4baea61d1c82b58d088564ecce67c836be20(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b575833aae3dc595253c6de90cd59ca3817d5a5dff3ea60a2112199c6dff75da(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanHsv]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__749ea702cf2c426aadc3c60b5b4f35a4ca572e7d7c1ce20c6bc9dc3f9948337b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2e17ecd442139f02cc09b315399cda37c77a97d0753c82145d3c72858c6a670f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__07fcb370996ed2443da88e708437196e9889b4860e0066447e461ca01877a788(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ab6794cfc5cc43d6662c08680e8a478467e38b9aa593ab801a3d929db710bab(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c548219ba8a75dfc77c80e2c01edef7f026425943371ba9f7455c8bce140b2b2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__12069e2d74c85d626ab95f848205abdae9ec2a9882694df739fb6d6ff414e09a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c2c8d7383ffc19a578130c23f4af92fb022f5f653bfcbcff3dafe2d063bc026b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7a4fb2d6e676e8d6d24aa26c85c6751d1043cd98a7f13253de2079d43fe13c74(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanHsv]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8963f8998c49528bf2cf7e82af9106552af01957bfa0be7408335d00ae1d1df5(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    landscape: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscape, typing.Dict[builtins.str, typing.Any]]] = None,
    portrait: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortrait, typing.Dict[builtins.str, typing.Any]]] = None,
    square: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquare, typing.Dict[builtins.str, typing.Any]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__513df90afd964673c0e5e99d79ab4190ad6b697c6d85a9bb699dc8a69d079bfa(
    *,
    background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
    chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
    composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
    compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
    contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
    goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
    max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
    opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
    remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__08696d04d22eca33355e217e31a972aa31388b0377ac133fed3f3e47ec672e40(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__398053a14efc86d48d1129c41ec008503bb3f05132f89ea4eecdaef92e16f3fa(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d0b4caa1f8a47b33d16d03b280bc1e2537ae050c9c94f4d2a6171fe5761fcde8(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a11ac3e6137f059e33078ef6bd717dbcb9f7c571a840b91aea46f1bd85932611(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__36c2091e7e0b0c85bb7580950b209afc45c0e4438223b933adacb752355ad05a(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__74c07ae5413a425f2d04ff689f87af4b6cd9e1007b0ca0712f53053a7193551b(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__59a170ffc70234b88cd679d4ce01c3905abfa0f0c204011039bbd591cb971f67(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultBackgroundColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__010a6d198409cbbae615b0bdb983b2ccbe181d76b4aed75a1b3287b6ba778bf7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__81b99bb774dc40e88cd64a64a20d5ded192aa8de5df6159ddc21ff4cc4416fd2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d96aad21dc9fee0b3ea08c63318491ad27bbee07bc1fe4b0e7dd5e344d61f655(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__85b3b7b0117fbfa31c9acac059cfcc9881f9e64e6e78fc1c8962c87f538667f1(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultBackgroundColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1b41ddb0c68299935bc57058608cbe3c9216cdce34f2df78a944e2f420664a01(
    *,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f63c558dafb50421debfc756e945cfeb1163320698966854a04c5a77bfcafe40(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__52b73d771e79b923f84984fd8579b295293c8970151769ad52a3dcaaab33c16d(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__079fa73a5be2498bf7d7c7693d49227d3cb99cabba9d64590506185db6175300(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b12e6c11313da3674b1e0e6cb3d6c653d55be71ca1ef10693b74dd45bd10c5ed(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a56642202ce4204c15e92ecdb94bb603a223e93366b8a524a1a1f2cb05710232(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__823117d6162bd53503ff434723e2b1b3fc0e79fc2f5e10614d06998f62b1f36a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultBlur]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4c60548c06d2e33ab7e570f6fcd0974d471bbd751a458a8b4c58d909bf1e5511(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__558252b4307da4b5338cb375f561e560a6ca830291442d82e1c5bcb964c7bca9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5812cd03d94cc562bc568b93a058319ff31c18a00b3f22596b0fab4a82e14cad(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fa7fb55decee0a04bd9e66a44240665da9aa5706e40fc24872c57409ad94d9bd(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultBlur]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__de257ffeeaf57606f3f21491e10be526628720e36f5bfcd41c843ec785e95bcb(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_feather: typing.Optional[builtins.str] = None,
    hue_feather_var: typing.Optional[builtins.str] = None,
    hue_tolerance: typing.Optional[builtins.str] = None,
    hue_tolerance_var: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness_feather: typing.Optional[builtins.str] = None,
    lightness_feather_var: typing.Optional[builtins.str] = None,
    lightness_tolerance: typing.Optional[builtins.str] = None,
    lightness_tolerance_var: typing.Optional[builtins.str] = None,
    saturation_feather: typing.Optional[builtins.str] = None,
    saturation_feather_var: typing.Optional[builtins.str] = None,
    saturation_tolerance: typing.Optional[builtins.str] = None,
    saturation_tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b44bfaeef4344175392d28f94a5daa28ae1c75cde57939a5d2c4fa883f6e746e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__768c303a4c680ab4247a0118f318e37e0196f1d13c1fc9295526d70f923f5034(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af91394ff8d8dcf7b8ec9edee978a55889c149d51c759aa969a056a02df5056b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8f42b0aeb3944883d4109ea2cff58bc5d94826b96e38d0cd4c1bf1d90f175896(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__42cea5e7394e26e0409cd3d8de6e9f6e2c3aa1927b90bf6a197ee444ea255d17(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4304d091ea826cddf33ec6840f206a073991a827ebee72117e5cb98c97ef0ed5(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultChromaKey]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__54713e73398d59cef1e9fc07ce97e43ce7ba0b614bbe023fd5b9f6de27587770(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__826636004f8147459975ea48498e7d3cb926e23c88b5e20d27779bd442ce590e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df68cb8c557a09a7d7401e7e997f5c81f9f0bb9ecaa36a9830968edc9273238c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__676a5d1c6163bb63dc44ac8713ca6db6736800de5e3e2f2cdb8cf5b948a4d84c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5d756123206f5bae3bb87838d29d9f9d47593e233066f9af24acfecbdf9ab179(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a783afc8eba85516d4b702ef817196723bef157436dab2d9bc9891df4e0940ea(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6207016802647f0390ccfbf3cf9c0be52caa335225d73df71490819bd41cf022(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__da5bc1888b60cbb738906d0f86e22c874ec60a44a1a6f00efd0b882737c5864d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f7e4f272de110e92cbd26dccfc508b980f4da4e3f0ceb6e3b742daacd0ea7b50(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d2b8eb04574aa8ac4896eb9b261d3f66bb1e0ed34adaa1d232c9cd61e6f58a65(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb3854155ca44b292e8e7ce155459b459bd964e64aa43595b7bfbb52990c83c8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__247663dd4ba5b0b3c5a9b2e768e6923d5210a631037a5a0237e1a2dd9783ba05(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__674c25244fafd3b2c9216183c03c76d8bc3fd065f8214a4c5613e228e5e6442b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5d269251018815e838a88cc6b15d272e41e964899ef855964739d7fcf36c9e2a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0cc5d747e03b80e18945de44558f33c3d228f7ea78e9e613521b5e1d4759edba(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8e68afca742002fc8f39dd660577729547310dfcf1b2bd8c683cd51f38e4f963(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultChromaKey]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a2d44d30733de02308f449300e1077b1da45411b268d7ea4489bf09c5bd05119(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultCompositeImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    placement: typing.Optional[builtins.str] = None,
    placement_var: typing.Optional[builtins.str] = None,
    scale: typing.Optional[builtins.str] = None,
    scale_dimension: typing.Optional[builtins.str] = None,
    scale_dimension_var: typing.Optional[builtins.str] = None,
    scale_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e21302339ec6dc78ce92a4128d4e93f69879a7aeae3e9dbf6ff71237de98dade(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8d9e532d145122e63aa6a8ba24d288cc821fd1201290a578d7f33421ce3aab44(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultCompositeImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9bff6c5ba6fa9a829432f0baabecfe0d1c7e20c2c92f18bb2107544c2e526d52(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1292afee15406323f8287bd696ed6c6b8a262c111fac39062ce74216ccbda5f0(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2efb7966f36f7b83220521194a874c0943b8ff17584530fc3c030f924814be30(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__64086d76ea24272ae765bc121779fd817633922ba9e6ba7b18eb52b164bb3ea1(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c9d3c3c453bdb88b5d790cb70def8ae37b4313f6377d1c17b0ce49c33ea93e6c(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e202a46bcf786abfb495a8c8a1a56a8e894bd11af1e33fd9d1b326d3c10ff387(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultComposite]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ce298239cf02e69d37da9895af5761219c7d2448bb13c88edbc0af7c84450c25(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__300bf0054ea9b8b2d6bb6a2b99377216e7fff7638983265d246dedcd85507fe1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7edf577bcd67f710d1c93822902a34a6f4df9d6e9ddbc8729c4ce9a523c0a7d9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2cc1e0a2e9f5c49d3024be1a3080ff7df2c64651ec137d5dabcbe3240d7990d4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__21e3d09013448b80b450c24e190869b353c88469613b24c13de54c8da38d0b04(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7e1ccf272828ba3c02695e976962155b839295946f3604033818ef09ed6555c7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__449b849e1f0cfe36ddd55bd63630dfe953beef2fa134368d4b5b675b6b7bb9bb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__13774bb7a5887b5794d06255c8251029dc9e851e1513ac0954322d593897bcc1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1c7b5e07e1ea9eaa2368478a87c0638a5e28bfb5839b11e07199ae9c82acc0ef(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__51053d73993be4ed0e06fd8e6b3e0d770b0d9cb14a93824c9172feb7ef0184e1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5eb99eca80d528772e91dfaf02aa0fbf41c5a07c80fac0b3b39f4e757acdbf01(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__153fc93a1fc1932c7b43993457cccbfe65247cd6ef129b9fbcb07dae7e0980d5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8e204be6f8db35ca2bdf98e9ace95bbd0e8ee58e500fbb85365a40a6e2a05b4e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__87a4d20eaac0e480aedeb17200afbdfeb72b94aa351cf2f711f6ecb3f1b4567e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultComposite]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__da2fbf7eb3c5968692c70bf0b627a8fb49f8ddbe88d9082b1c3ddf7730ad1732(
    *,
    transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e5d9343c76ec076bc92a6ce7006a67136331a73d56e4e7be909f43545b4a93e9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__83a015e5bb083387e798313d117b9aa0376aeb3dffa5ade2a53d6c25f38a444b(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__10175bf3a1e509ef637efa7c3ed8dc6452f3289b2db4a2b783ce97ad4f529a99(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3957f464cda06b843d1bfbfd317b3734f8ae31c10d3b3220d5b10e089d08bb83(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__73fe40e9a1229563c1364c67b4428b396fc04183ccc9f8655ee0e9737e594388(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e2a606ff06e63732eab7464a07e300e5fac11f7cfcac8472955791c8d613eaed(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultCompound]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__98534b10e3ee958360edf03361f378bd43cf330a92e632fd0aa1a0850af3a74a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2c577c00e77159e5255bf258fa12239c960127d25d229678773f818c506b3563(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cf94d7d799539671cda4003f36cce55e4e1ec9e73e4583f6e7952435ccb526bd(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultCompound]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1c9aa5bd4a0f0a1c896e2f14a4d6b6e3635eb9e8e1122ea3ed7d8abf23ec325d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ffa2bc4fdeba0ee7bfa9b9c6de29a7b90eb91b2cc5a330995cb300befb778b47(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7b9f54c8daa0c9bfe920d4b8f83e702429f9a28aee752ae7b0461dafbd774c5b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ce4f19929c08f3b161065436a7a76d7d780303ac337bca2997a0d0e2561f184a(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5682b5f9a502c4e7f30f5cee6adddd42fbdaf4eea8ffa48bd46262e24d467cb1(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dbcfda22062aa36ecebf80ed13e9feb1a671144962ba94896c4427d789b96896(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultCompoundTransformations]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dced925a747ac4bfc8649279a503688ecb8d670de2d1e59785b71c74c9ac6e16(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5440df1655af7ae9b8277c0ea341d42894b75a04464579d8c96a670d2c88e867(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultCompoundTransformations]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b7c81a5aca30a54b0bf4e2de5a60dce10240d97ac74dfaa2184f896bf6fab3ea(
    *,
    brightness: typing.Optional[builtins.str] = None,
    brightness_var: typing.Optional[builtins.str] = None,
    contrast: typing.Optional[builtins.str] = None,
    contrast_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__76779bec9900b334ec741f3fb75a5df5213f057f09eee27c22393ee1f616031b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ac79c571a2f0b27b69e2c318729a8b1ea3fbd93a1c9d66811372f43bfa851c7(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5900fe8ae90ac204cc7b18663f5217ed25b4d950a3394cc4966b76820dfc11bd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8053ffaf821a204ba2c0f07fdb690f3a5fb5258d430611d07ac5bc653771b6db(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__08bd35ea12c0fa6be4c6963c17d7d7c77ccc015e498b6a54a474b5e7ddfe0f12(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__524815e37dd0489dc419c3ebdb95238917a34872cd407cf10c014b16350d5a17(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultContrast]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c59130fe6f6fe7e781e2a1b35863cac3666946d09d63144a7b72e47145366209(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f8817d70d61a069d11721e1c9efa03360d64bf311211bd7ad4e1d9e4074df96b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be0af9225b474c86cd6843f9f5552d6d39f2136c2042fa8fde872c3f450525bf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__54b80349925ab0539ef4e9b9d2e3d89f5d2967c2b590dfde5cd2d2c94847b32c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5bc7aea0fe079a22075fd301640349f83f54f55097b7cfe5f78a4d30ba9651f4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fc626f3ada530a63068e7cc2c63e8f7e2e556ff3eefd4f41f6cf1d3a2765a611(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultContrast]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__076ca5b2c84c75451151c6b9f4ff791ef87e09342a45bd19393d5bd19258363f(
    *,
    chaos: typing.Optional[builtins.str] = None,
    chaos_var: typing.Optional[builtins.str] = None,
    density: typing.Optional[builtins.str] = None,
    density_var: typing.Optional[builtins.str] = None,
    power: typing.Optional[builtins.str] = None,
    power_var: typing.Optional[builtins.str] = None,
    seed: typing.Optional[builtins.str] = None,
    seed_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2b480be0ca0ab954d0a08cf3a34ec45126f5b48dd58d1375b8e44206ea63b7bf(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b7c93e464bc0bba6c9ef69ac4e7e291451bff25288c1135a619a8cbedafe4481(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e8f7453d0138e995be258277365cdf3adad059dd81e6cfa64e00e82a8d0cdecc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3993c6d93170da25a1fca1ae4ec478b0f5a2933f083239bc47cdf06c03972c14(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__50a78a8da71109e7c621f25f3945d248b0817df4ec53f0e7890484e663946d82(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__35bc067fe1efab55dc75a0e8ee2cfd4d2a26ef879b39e13b0c7bfd9e6ced1e9f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultGoop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f17f934095593c9cbfc8651bf480d6e3c049880cdf5373e514101db89120834a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__286d31a59770b800a76d08128473f5c6f2a01943e1b5ef324c419a170496f63d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__392ad648f8082f4b769ecf541d33ebfae7c2f3255af6f80ab14af1dc54947c2d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__99a8d50e1068806576d1c6e55e5a9b6a179624442b7532a3ff22b55814f8cc9e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d65cfa0583a4578cea8dfbe625c256759f504c9c19f5279be593a5023849c6a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__17b3851bdc8e0d0283c0a6d1971d1098a0a5050cb93fb6f35b6476e5400672d6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3bf2ef55584c217f0d1c8626e3258279f96ef35aef445c5ffab556a935af5692(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8789e93ca0358592eddeebb3868d76da255967d32bd98b95d6cc8be13a3c4067(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__135d7b71da627a4718d947894adb688b902f183f93e492ce46b36528eee7c6a6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fc2db1d239ac8ce1aeaa19fdd78a8467ad0354d83f11232876bb2c18ae59611e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultGoop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c99aade156790f51984356cc9ab20b2cf99a7b6ab025ddc8b3deaa91f7c8bdea(
    *,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5a51fc497534f3f464f009acd52fd5523245682c9a6182f3239b156c2265b566(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d744021c8d9b000b5209784163b3c0de29d4e900ccd4a53e5ba05e5041df8316(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__21f207e5eb2fe39d07a373ff2d86e28a0fddd5dd416b556dabd4425e223fca9b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__84a78c3cbe736fb4ee530f84edcf8d60c1a4b580b12ee663db164d1a099a82c9(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9793f20b22e2c72d89a30ce70a5e0957fc21773b11a2746e9a3a8de8543f1abb(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__73df18598643c41075f15c3625c6d9ce6702c3bee0257fc0666ede49e28d9339(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultGrayscale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3d8ff9250ceaab2e18685713ca164ac67468aebd7994b4c11c5e5d933fc25035(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b9eedded43536917cec732fe082d5112deb80f8854c5bb28f6764c4390dd36cc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc5e3716fd39f9cb4e9ee44c4b1c762379b0c022354cde1a98c7ce41a273ace7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__190ef417e3e7b5cc69b5a35737ad708c0b0430b3409b9f760078590bf7794d02(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultGrayscale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3723eb95d67cd3312207c84fb72e9769aa1d01fa4b116a5c6facdb1d2ae8e77a(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness: typing.Optional[builtins.str] = None,
    lightness_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ed05823619fcfe3cc7c6ccd187eb0b32308368f935a11c88ede7018381eec7f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fa6527dbfec96a0ea19ef34472e474dceade54eba2ce2d33c6371a75b39c6c92(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e9dcd72e994d712c4f74012484c5837f3da32f32ea95d87b22563145ba55ccc3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c1a3a518de9ea94fb694e10b106c5bc22b05de30364df9ab9e0efc449a43b4c9(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9536dabe29639e9eadfcf30ede53b028e4926cb49321976647d9f2d7db45f0dc(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ca2abf120b546e615f6c5df70bb3d9cfdb23b93ee83c272287c3fc76e25686e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultHsl]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__35bd1ecbd59097b5af9e9192db4f7fda21fec0b437b07231efa1d51fd5298c3b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5b47ac5c8427a327e2b716cd510b9a2eba96f137f38205a3ca9e427c2fd2bf16(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__382a0a64e65f6e895b2d2bf18821a6253158d48657085bb19ee6540f7f7bc64b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1c297d9072211f761a338bf2cff2da4757e041fb0f782abc6244d7602bed54b4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__91e19a6472bb377f9899c6e8ec488fe1d9d954ae297452902bf53f28f401d763(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b2a34fbeb5dcdf732ad0006e8c0a6b2e7b581b9c076b7df5a2f571ad35b145eb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__27ea5abfa2b32b29993e5fc343e6dedcfbd04c3e097beb17e5feaab50da801f1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b2998f7e46b6a8d5d6791c96c4485e960be91651f0e72ce150d943fcb8534bb1(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultHsl]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__08a8000ff8b5bd5f719191aca34eb28b8c472bb5707bad2dbbe524fed07639da(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8d37f1b2a1b7fa8636c4dcc91b8ba739461de7ce0a86b97b5556867e3ffbbc8c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__40c9946b23ff6be8ff52177c4c80bc9159af785370dff959d9e35265a64aea6d(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__99ab3f04206eb38573b80e4d54069e6fc2a6a7fc6d0590732205a3a7ec31cda9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ac4f78d3951c32d4da38110fc7e06f91b3ffbaea3f4da1749af27fd55199bc9(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6a03af1b6bc1100f0e772bfa3dcedd1c18e5d8043283eefeadc9911887d9bc2e(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eb735c20a39d6b0f30ad5b567c21e3dc6e196e83900e5728ae17f40501bfdd2e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultHsv]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5128200ea14a60d5dff80886503e8ce3f6c16a7daeacad02a537a2a3147dccc6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d090ae7e2b4d9561d69d0306b0b9971b62b373e882a46cf3a9190e85a102ca79(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f1dcdd2bdd26abdc6a79bdfbc03694d5fd5345115693a9af84313e7c90ad7a53(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d819b0201207ec67712ce41d9ed28442fcc93df57350e9701416408cd51f6875(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ce3f46eb8dee7c506f7686d3b763a3556d613bcd34b32f6466a24667cf5b268b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__83b36c5c975f9ec29b2786dd14d42cdc8340e399cfc54dd4e29828a0621dff31(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__603471142ab8de3fecb11c2c2ff827170c622408554863454c3f52e9b1f2aad7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0c5f65fa97617b3082a0471ede35497d60e042fb681b12635cfd1efb0c1e24d4(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultHsv]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__94be4d4e5777b120407d7542d6b6747751d0069aa4c5785a0393798d971e4ad9(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    dimension: typing.Optional[builtins.str] = None,
    dimension_var: typing.Optional[builtins.str] = None,
    equal: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionEqual, typing.Dict[builtins.str, typing.Any]]] = None,
    greater_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionGreaterThan, typing.Dict[builtins.str, typing.Any]]] = None,
    less_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionLessThan, typing.Dict[builtins.str, typing.Any]]] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c81cbedc14a4d7c81b70ec6501c779c8ba0ee523c708644599e4f9c318b42c52(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6a12859cc648c3ec30bc4f5cf33368305b6ad1a410125cae275640fe5bbcfc9c(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6ac786e32176294f76025aacc323b8ab503984e99cc4f22865e13766ec1b8f79(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__909efadb0b4981cc44f08630a0b9c8b9fb187abc478291ff0d312e2cbd30765a(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionEqual],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__26209a520bf32c83d1950e2b19abc34658dd7d5e1d4c1f0791bc604f62b9b4c2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2732878563f31f2d7a9d844183d36c3708f2f0def6c6c7f02d18d6c687bc527f(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionGreaterThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e1e0a59454f09b3dc5433f2841512d3f1e4738361b3aacb8be89f33859c519f1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__58425695af7c55162152dde4628697c9b1ade1b4e0a87587b8205343b667a6b8(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionLessThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e2bb78d6246bbd5ec7e7d5e6b3c0491c41b61e62cedae0f7d6afb6d7b3196747(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2e20ef1d84b3b0b76d9102b259ee50c55dcef48b292f4d10300b3cd482ea2339(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c109eba8dc2175dbf96f28ec1926721420a64af6b60721000ecd3ac65ea94e2c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1211df9e6c5fb509bddf0baedfa5de38f186b8fb6f2f0bcbcf7d66a6296003e2(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9fe176aab47d605d74ca9b5829b6d09e323b5b3fee771e4a3c06f3c24fe626cf(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__248f4a332772eccc8b4e8945897b3248027f1344ddb944119ba98ad6eb284185(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfDimension]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3c0950c08391b708886edccee4d0b11bcd7ecd8d293ab4c3040599d46968c216(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4cae3272f50c8c88327a0061c122dd17caf9fce742c31b5da53f7c7b0f4efe90(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b66229f9016b799a61d5f5eabcece6565ecc1ba62020aaac4ae8da41aa4cfd40(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5a2762a93da3ee2f140bfe760c412c20237133c5711e0f6ec00fec236957ffff(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__56a2a7e273902a779f02eb1b65c0e0f8b7c3446f5110a07facef20b33061fe22(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__148e1144794aad53d2cd8e68eb36a32b2b2e4b49fcc13107d3c4400054904cd1(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfDimension]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__afd58adc8abe56f96c635f7d46cce4a15cae6091e8b51ec480f6cd00f8efec57(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    landscape: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationLandscape, typing.Dict[builtins.str, typing.Any]]] = None,
    portrait: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationPortrait, typing.Dict[builtins.str, typing.Any]]] = None,
    square: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationSquare, typing.Dict[builtins.str, typing.Any]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c3795d0370d3aa288752f3c9949d6d423c17631a5b74dcc1ad37027e0d42cc03(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__728560b521be2d9852e346afd8836c0a4980e76675491a55690c443fb28eb597(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0602ead788b427acc46bce11a9c7bbb5bb6e9e3f17591a0d46369f2c5e9ea5f7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6bea138ac4aa1893ca2298e699841affd90905446746b4a501a721e9d0945a1e(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationLandscape],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d2e657eed4ba354d9e663b6237015b933c500818b88297364a08a62bb91f87e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df5fbb6cce09305fda28a984597819ef9121b21620123af57db45f35f26368f9(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d400968ac6c6e47bcbe4f01419cf6a064c8f56061a962d57fd49fb148d0adc3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0837775156f5cb793dd8a4b741f9f30f1d626f31adb3c6d6193440e39191f63a(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5856e0be5b96c362fc89257c707e9e60705b1056dff5f8fc923c46297047879a(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1204cb35aa73172bef6b62a6d556d5be764263e72ff4ed2226e835ceecb24e37(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientation]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__614abb051daa80f823a6bff9854ae53292628f2750d127d45bd63b204a687dca(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__65f0e52fb4340326d1b0e93ddbdc192da9ed92005e05b77813a7bc7f9b038425(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientation]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7c80265500eefbb49b6bb4b6b8891ab53a6eb77a6394af4325e1fc1f696b8e21(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__68da77710d8ed42d49745d0b038e821cd4eb1ab591ce0155f6325d16fc3c85bf(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationPortrait],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5d65da2d577d1318c66d9433cad26e32b1f8593529147f5428e0480a304f3404(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__08b58389847ead8797b8a508380e806d24f264861a1cdca00c37ce250b9c2c43(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationSquare],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__08e05b029912fd04ad6632414d7c345019e6024353f5ec8e6309c5b6087adb57(
    *,
    colors: typing.Optional[builtins.str] = None,
    colors_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__52a263934cb21dd88c95dece61b07fab6b231170efa6b786d8b6d6d19deaf699(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__333efac1966adcb163d180443a1f9e28f1a0c67415c44c6d50e265a1f2cd3096(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a75cebc557c5f73aec91d4b5eced89e428966bfbe4db494767b8b7e16e5a591(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__322d54e2718ff3ddb676f424c2a5997438b202a800121ba4203767b2920e6599(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d19d7aadb638e9af1386e18051b0f1d6034b7989c51b5a5b7555432546d21c5(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d7a34f7f31afa8fab611a2e4481fad502e136e5765074f1dc9710e36ec935e85(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultMaxColors]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__37a18a39d0248c41aeee6744efd3bebd0c423979589316780cf2e612c048d872(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5c898cb3aaa51d507ad1a1716b5764a44d7ab1d890cc03cbfd58f249e9cee1a6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8067912ce4876871c2dbd0a4bec74d74818a9760ec7ab5dedb2d0ae683960b81(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f6d75600d3d154c3edad766b2027b26cf25b2161306c1b25c4872984a8732c3e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultMaxColors]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f53ff2c6535031a9d6c6a94417dd56ebffba2c72d18cc560d1b4f098f6342773(
    *,
    horizontal: typing.Optional[builtins.str] = None,
    horizontal_var: typing.Optional[builtins.str] = None,
    vertical: typing.Optional[builtins.str] = None,
    vertical_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8d21f241853886efb8f90d3b4cb483865a4519cff9a0d6a599fd012e9346bfcd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3748e95733ed5390fc8a22ace12ed003ad0e521ab506b0c318998b3b5a574597(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dd2be6d116c3b185407b459492c1ca44cee7433a093347a9592692a305cf1540(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f8a8dc975c72a0bfed235d1c91bdbbac9c943fb0b5b5fe2eb5f31734f8789084(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1c190424909f8018242dc49265b0e839ce827308775feca20e6080fce67149a8(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__92e949b2ebcb590289494d655f1a32eca9a5082b75cd105b5a6b9ae6e95be2a3(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultMirror]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ab7b4b7e8425cdeb6c98e03ca3ebc8ce429f40da6846fb04a153018f28d43ab(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__212302996f5473a3ce2debbe54bdf3b2d23fa18920b049b6d5ca63a2ea21796b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__79c6d9e0c01869cc6b829165a1b2a0c92ec8b817e92242fd775f7e05263b5553(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a2939c0c20c74392062bf0237d6619b4211db2b35c0320fd0c6cb883bf0ea79d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d060ddc9d772c384d19302756c6eec23c179c31a57ee52ea94a9f3c0b01368cd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__764a9a3b59ee58e95e187c784863b2266110958466643e31b406c47b93b083c6(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultMirror]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a375e0891a4f11fe8b6d4ae3fabbd426379a65de75652e8477205a59f23319c9(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__db33209be32853119649324d2178b0e1f47d5b7c1ac6d263f045c7d47d48795a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__46ea524e0e530bf4c09d10af6e20779c2c77f8cf5656f2bc372ae5cdb8745371(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9cc6682dc01ec3bc2a35a28a1f77d18931f9a7025bc01bc96e61658162b24b80(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2b962395c0e86c77231a6c4e5b4d8ae7ee42bd35fb8fa059f1d3cb80648b4838(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4f90b3de158520fb0bb3b10198e719bf4ac6b955a7abde84401bae343946cae6(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b54262d32ed38e60e543b9f81a87b051b08df98cc37e3c36dd09e81b7bde254b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultMonoHue]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8361b3a9926022ea61a6542ca6040f7145c26c0dce463adfdc3f7eeea40e92a9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e4ad5d0297eb9a3758c127c920a8f52cc58e71b70cbf1d42288eade4ec129afe(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__acc0c3188595dddb7a485a3097081b45f6fd41f6229ef97b22770d60c3e0eb4e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__36421c9b782118bed662d35a2174b19711e538beb638efffc0e45e85c5214c8d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultMonoHue]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__721621daf82aa85a16b0c446e3c36fb7e35e71dd43c5b822751a0311c341996f(
    *,
    opacity: typing.Optional[builtins.str] = None,
    opacity_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5bac8ef58a1ae6173ff525b59d80170dac94ab1e68863946f42cd70649a4949a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6563c784b6a957174a39ddf5fa68ec9a2755eadbef514d64059b30839c9d1d5f(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bde67026db07dd67d293fdb022bfac1a12d1c3ac7e2346fc9d2add1fa2aba5f7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b488d9b752755d9b3093f8025cd92bd198d50532555f637da615f668b780c888(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b35aea769ac4ace61368152a5227e20e37cfcf6ee547b910cce0bd4a327fdb51(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1984dd027b0a3f7047e8f21a0f02d7596bf054fc6bc036b9a89fc23d45ef7c14(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultOpacity]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a39eaf33556cb80f1c3993452109412c21bb2f7a84b4cb5958142165388d537(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7aaa2461c978e3f08c7ed5ac1826820272bac4eedf1e39057334bc14403f7d78(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__188f30e9f5eb309b8c1f680f4caec6fa37b098832d97998075a7f60783c1ef52(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__533835c72eedab8b6e737b1e927f90174ea193c6cbb2a96afc73b3d4099409ad(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultOpacity]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1df8af2410df2342f7c612a9a225f9f9fbe9910ff5513422c3f3839d803207c0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d4b2cf7742a461d967e737fc5b31db081025e3d964bbf656a13b50eed6c22dc(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ec049956326c782755fa71eb925e8882d79d3b7e8e67d792ce0884ee9435de6(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultBlur, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__078faec4f2497df97882db93e0df93697c91f123ce16c2255fc58e692a0b81e8(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultChromaKey, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7704dd9e6e34eac9fbe70087ccb9e541358aeca82d872b15399246c5bd0c2155(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultComposite, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__85716738cb9c6c3e42878f294d2080df01bed6cddd564cbdb37935dacce0b033(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultCompound, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__91a896ef2ce553d3fd77f01afc98d32f55e3f38a9613e693d44eff1cee7aa3f3(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultContrast, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__22c8a315eaebe8fc65cf6252f64d2574ce78fd1b36c5571a68b5c85218a398e0(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultGoop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__52bcd759c53231f052e9bad744cf7f9ef1cec4481830459d0bf2573417ee090b(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultGrayscale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ee2b4a3586a95f45528dbb1a457e3790292dad05b65e022a1718e6c55af1a142(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultHsl, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ecda2a47e6b5d3099b4acdf402e9475d9c3acc0c5c0cea491ef76fe58137594(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultHsv, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5fff0d8c556fff0cab6d566d2867e0978ff38da46a3bb71a81af3969e17593f7(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfDimension, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0215f16f7b27f354f72d292a0e1c03326e0067dd2fa7555ab81fca3086e24dcb(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__727f2d805d5dd69ef15f029c117327f6c26b2d72b47a0e3110518c9b405d7cf3(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultMaxColors, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fbd7e4b9672b2afc816f9143c5a8138dc83edc9303c3daeaa64471bdc602af6a(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultMirror, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__042e74babba702954cebd87c36e46bb33a00f3a5b3d451db8288c46fdc137bc5(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultMonoHue, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4fec228ee515f6910161031132e29e9dc0e05743809453ec34629c189ff81eb4(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultOpacity, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8f80eed090b631b065050082c780e38bf8faf383f6e544a63060057e4a9db604(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultRemoveColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__73f5335d3f55dcc24e7e469e417e7157623d7a3951c3b8a9f228467c14e2e252(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultUnsharpMask, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3b8f6d3a5fbed86c19bab37e6257e327db0ac60e26fb4d89bb0e0c2e993a2041(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6c07c80649b575ebe6fe4e67cfbff1911177e821d094fba855d0cab23ce49e43(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
    feather: typing.Optional[builtins.str] = None,
    feather_var: typing.Optional[builtins.str] = None,
    tolerance: typing.Optional[builtins.str] = None,
    tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3eb4111a2664832339e0cbbcb8f6114d420ff01d5ab4aab3679f5dbd510085dc(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ce7b3c14fb86af0df1932c31ade78f3ea3eb56174865ab959850cbb48f8f0dfb(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9cfad2f7ad680189604ba73c6680227e5ddb823714c7230bf41a2f8f47b4eb7e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__13361778cc008e5e146b351eea9160084c0f93dea204ff83bcd7e3d2676796a3(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__983399bfa3cf0d9cc4e05d253f0155f175a490d5d99a734edf5f8c84cacd61af(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b24ce0c89735f9b70f6f882ea828e405a99a31dd1e0e91e16299225909968cdc(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultRemoveColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4f1cce89c66a15694a78b4e0ea53ed968e3e463b0bcfc75f837c71027f8362dd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7938009e1718a773f0a70f2690ba231c591704e744be9e61c2a175eea8ef0ec4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dea15b702d6c57c39ddedd82780eecf2058328bf38f7ef2642f9a615392535f6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd55796150165be45a12cf12a98ac5d9441331fbde3fbd624be4fed2a0cca800(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e55efa1e027415899e431cafe8177ec37fb2727f7a28aad31ba8593afcb040c2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0090b743772124af542b055c7b1bc8a892fc3d2bff3eb8dec495150430ad43b5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c5018bc55b0042aad56bf76d1bad3e084cf20a07aee5f3916ccc84f62ccb7a29(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e1fba184103e2a8650a6a7bb28fa2a7d3d01bc135a5b0fa1a6c11c79d1f07a4e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultRemoveColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2770e147166beac14ff3a6127ce0b7b76fa96b1960fa5fd21880c9c904d294f9(
    *,
    gain: typing.Optional[builtins.str] = None,
    gain_var: typing.Optional[builtins.str] = None,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
    threshold: typing.Optional[builtins.str] = None,
    threshold_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a6422a749648a3ae48cfef622d0c51043559f869be23fb5aeaf076df670fdda(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__144af244c79a9b971087c99913bf396199b92679ea02b2e1609bec3b556efe9c(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4e97bf37e6aea2769f5dfbad529afceafa2edc6cb338df8c1320d2d172d43e7d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__99f1c93c3649ac29787580609c8881c04a6b9e5aff5a406b1e9c0722d08bb36c(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a11abd60313796d11a2d1f9f23d6298ab6491fbb73ee3ca5d0ba4e960de3da38(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8faa1c5f558e87d041204e1ba755f12b9c4eb83b1b5a76849e845ac4a5ec7897(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultUnsharpMask]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eafba247f52d335f3a299ec442f7f88a292202c9baa17f45cbded669fe8a73dc(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__38ce62d47a649003467851b65a37881815cdae795ac414afcf366fda2ef2050c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__98d45085bf42ee4684ff43f23b58b359383363fa41cc6f22a07b84ca9e2a4cc5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2c611d84eb28d8e4fd356274e1896fb1384edad88b4bf2c1ae3c4d81f344ac77(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__909e35c4c7cee1365885e4e9d44f46351b222e444d5ab417f5881d02ed6d13b2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__db9610bed175704c710e1b30a9e0543178a0a9763d7fbb8786cc34b372c6bfb2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c74c17548378ab8bbd2cbbb74a165e421c2800f63787291a83c90344bacbd34f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb5e19cf14946d7fd567641333f23a4d13e1f23611520cac1cda9d8cd3d88f5a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationDefaultUnsharpMask]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a570637f2a5df459da07ca81fd52159f264825c6dc3604c05d87dc8e63b57826(
    *,
    background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
    chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
    composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
    compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
    contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
    goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
    max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
    opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
    remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df56829bdf492134dc0d9cc433a50327e9285346625508d034e705ff1e31adad(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0847bde104f8bf2c37e4c92073eee2c87bf32835470396ff9793ebc80b869201(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8edabf645bf4b461d5d3763f5fd080bc75281295ce2e58c69eb8af157b31725d(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f66a30ace6c8b2c3c8fe53c1e30e4d65cdf744a8b5dc50e40f6b6fdb074174d0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c9547d1bb23bdd592af95125d35c32766e22655eb735c75f9892f1f8ec891408(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__607c91100c8bdbb2ddc771223236662113ebf8e282461d930484b4dd8ace4ac7(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a64488e79130a7e41a92b9fcbae4a7bc3062d4283ac9bec111cc53a282598382(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeBackgroundColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__54d6ebcc1677d787fd3b23e6b832ebc824afc5c6256a56dca4848f93f79a3c97(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dedf0a0a0279bec0c631cfe30f12c9369e953708d9af3c781324440e49e14758(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a9fdc248ad421e2d6d00e3216c1524a9fba9b2c7d502e1fc720c6fa194b87872(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d89d030a1c698894a10d52f8feff5ec56bbb229b4a1dd77076dc3169e0d93dac(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeBackgroundColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1b8c83b84fda76ad55a911420f6b299e69961d2bc7229e841b9d90635dadac16(
    *,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6378a463d4411cdd90417b4fc0bf29cd13f50d748e3830b4ebda7a46813881d0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0350d3e6c4cb62496b64c8faa0b467c89de8beb191e92c1e9e2150e2fd9ad6e3(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c41b1a304343f6934af452b20ec6278a30c09e54d3d10ce2118db8b1b408395e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__54519598591cb83db3db9b1c6581e164c64061aacad2922caae5c5b5ecad43e1(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8c24024699cf986c3d7e02d04e65b7e81a41bb4374e0d51632e49aa5e8367f8f(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__12ae99904c6d4851012b848d67628ef73cd18ac87bc91c9d7894e8fe93431f5c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeBlur]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c083758e0e730a1159949d951acc8c6c54a8dfd80e4870ca9c6894a40c1237cd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d5de1ca5f8fed110dc83069d96a2631410b640f23c8a94b21ad4a5067779780b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__baafca79a3233646ce33c5b6c817e7352158420506a077eb773c1b203516146e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7e9ed37132773ae3048b537c595786c5c620048fb56b704f7976450c775ea231(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeBlur]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__46569a0aed820ddb6e2d4cfbeb8fef426b5a7e9836763ec47816f130a9398007(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_feather: typing.Optional[builtins.str] = None,
    hue_feather_var: typing.Optional[builtins.str] = None,
    hue_tolerance: typing.Optional[builtins.str] = None,
    hue_tolerance_var: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness_feather: typing.Optional[builtins.str] = None,
    lightness_feather_var: typing.Optional[builtins.str] = None,
    lightness_tolerance: typing.Optional[builtins.str] = None,
    lightness_tolerance_var: typing.Optional[builtins.str] = None,
    saturation_feather: typing.Optional[builtins.str] = None,
    saturation_feather_var: typing.Optional[builtins.str] = None,
    saturation_tolerance: typing.Optional[builtins.str] = None,
    saturation_tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1a226e32e0b86c94412ecfce06c2e793720d2fba0f408915efe5ef72929a311f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__76470d44296b5e82f3a1382d3985c4c297a0266ade9c8f8cded0766039318b4f(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1e1cfe4d3ce7ade1909899e7b5416ad87b4e582d6a025a9514dd1e0dc759724d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0e7cff84e3b916510a4a603cd05c4a78d98f6422f05fd710d44d5f648502020a(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e6780fd6708bddda00ee549362adee3e133f828ece32826c8cac10029272cf65(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__24b05b9e84d602709e19e9f7ebc4abfa4c8d884e8c186233907a966d6a6397c6(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeChromaKey]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bae8f224b29de65eeee5666a0f102fe97a8bd1181ba491ee469fe15fca69e66a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__66b33f3951a813e6b3a1cf1dc2f84b14093381bd6e89baf2e38b01f90d4007cc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dffba70ec564b70c3965a650e4965f815eda7a9eb7592be939e5be49812a830e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a55275dd391dd7d1b2edb1024a1c0bc6ffd6d912e4b4f3024b46e2a835fb3f50(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__59a3f12eaa9478b7fa7c46c7990b0da96f6ff6f6e97c2f572e90decd7d5c5794(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f7b3e829129bd323904d1e27260f6153d87b3819dabdaf2fddcbb95ea04122be(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__00d47ec49665ff01c75b80ab6c218abdf9fea1e11b39491e44c5c0178552c6fb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6b8fa62bac9bc551ad08761f903d7e9dbde44758dd885a767786f1f64335937b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__75a4172bc41a2e94478ed93f056d2b6005e03c0a6791d1b23aa5e9a34d655b92(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__03f8e19b563f3ac7fec96b566e7acce03bd1490c5fe8686b839d932c8c5b759d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1837d6349cf51dc59795ca7d2d85da5409467ad2594abaa78ecf372afd6ab7ef(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1bfd15781cba3f8869c5209535588c22d15d29602fad70bcffd7099720e11ff3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2083f389deb973a9651642ca9071f2c71ef7f1aba58ca501bff50fb01f270f51(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6157abb4e7574946439067d545f04bae242ee77169b523ae28dcc46889e4f83c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ce6217558b961b3e7cb3ad5ee8b60c5337bc39a8b7c1d3d3d1ae1bbb11368b9e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d9dee5c70dca35db9a941cb3e48e58e174761bc039267e56314c86e048c782a4(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeChromaKey]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f9d62bb0375640936416b6ba8fe6a59869b982f6b933d5ab28d28eec3b55d2c(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeCompositeImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    placement: typing.Optional[builtins.str] = None,
    placement_var: typing.Optional[builtins.str] = None,
    scale: typing.Optional[builtins.str] = None,
    scale_dimension: typing.Optional[builtins.str] = None,
    scale_dimension_var: typing.Optional[builtins.str] = None,
    scale_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__04b39c1d56853096df9a46df0632416c0655ad5ecb43357d7a9d29a04c9c0a7a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b45bdff48589ab0d0a8d06f3a74a55fb639079f27071b95b6f25ecae0b8cc1fa(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeCompositeImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__201b8e306e692c8425fd543150cde92377f26dc5e4fe353617fedc6243b9a5ec(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af7417ea4d65f45cb6ae5b8b787eebcea03931c0f305eeaaf03add5d8b48af7a(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4f3f31b3ffcc96bbed61b17d07a7cbdbb17d6a194412bd86c5e62e8616e72384(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd5339d8ab19a613055ad06b37b5f15ac1e26e6fb20d2c81adadea242597da97(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f5e592582fb4c1408cbbc02e7ce2fb50385dcb4b4c0ef357b387558226f52313(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__001c238c418d7fa96bfe35ebe3d5d507e931bea410b16dcf4a9db9a183a31ef6(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeComposite]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ebe22f6dc9195d1c692558f6a2983db1a33feeecaea6f780c73c31997aa3cdc1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b2c0a12e0b655100ec2f6e11115cc0fddbbee3f494df774c742d0a34e2a6d19a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__722f1f4bf1ac417bc690de7daea4c04a424d58b607b852ab028ca03873f1003d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5c10b80abb1857c44634adf960eb7da97237dbcf8600aaeca5c403cedec25c15(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a8578a0f4233f7e2c7b4828c1018f12c4da82dfc41615cdca774e25b6a0149af(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d412f6586ac2920fc0c1acc47865498fce28064745d05ce4a4642667fdd9b02d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__02e9abcd903520212c2c8d8a932ecd844c938eeebc4f0b27798b60e2d263e35f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d4c2d5a3bfe6c40826856e627bab2709d64de669b0bd45416e1d9934be09606c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__70d222bd6828416e5bba8e5843902c3b6ab7f50973ffe44f44efc64f0f144d3a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d8d5e7da1e1415d9d797d595fe07db6099d42fa7c73fa97061ae73c9e80e8c44(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ef64cc8f51beaf96def619669efccec17545e7d774cfc5c058a55255906eaac(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__570f7d446b3ea3463ef26d4ddd934c28feb138468ef5ea4f8c76c82431f4cf38(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6cb094589df628ffbf100d81f18987bd42b3c5b590f398055e2242ebcdc18fac(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d74acb86709fb353a9f993bd9d8b8dbc0e71cb8f1be889730a0728e18eda270(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeComposite]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__147cb92de3ea63dca754bde10ac6336c58a6f2a0b984aeffa09b9531953c7746(
    *,
    transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cf2b4702d21844322ac42bedcd2f52d879137f9c7cbc8f37fa7a7381c25a06c8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6a10c756df03de587a75e7f3983e3f972c67a1fce8260174c9acbae9a8abea44(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f7039e521d7fbb0e20de7a4c3dd6e2e276fa772189c2ed6e1ae20f4ae42031f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__999441166c6e4fd1d8406dddecf6df5e77110a893fae0d238bcc99ec78625bfc(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cb8fe9571fdebc7cdbab4aa98e3af2f19a561ae1c7850ca702f66bd3eaf2072d(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__66ae16576ff009f46e0952175657d6c6073df75b3a7ab4f97d4786afcf588142(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeCompound]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__556de510affe892fa3577d9b5d225cad6cfb08354dbe2cbf7a72b053b2debaf5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c81e4456a71da4b1669bde776b4552acdcb0a9a3a8234e6ce318e59a4a3a9234(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9264edc653cbbe8ef08721624014fd106a888c3dd6ece5db089e579ee674ae79(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeCompound]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be8da6ad747adc549cc06378ba3c2ee873ebffe570d7f8fe1234770a03425b8c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ff8aec2ef0c17cb2fcf6ad717a6f737e7d18fe42227fe8b248d84beaa15e357(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__40c9aadcdf26fe2bbe5b755d520339b081e9ae7c8d579e390182b244392d6dfc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f848ccffe29787959bfd3cdef0be27b9b6c5effe38dff163a0bc5c7b632f5be6(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fbf1a49c6d59d46d1066f170f48676bf675dda0f2b9b02d7ae3f150aa651458d(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__39559e61851579790eb067da16135c1d1927db8fc0b23d21c2527280da2a7180(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeCompoundTransformations]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__855aaa308a8044e9c52a563278bd1f49171957ea8bb82f81895fbfe6e7f5f1ba(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__27ca06ff19dda7153fa478e9772e7052fc55b7ca414e92265363560141df8ab5(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeCompoundTransformations]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1b608d57a9cd8b305518b58b048c4ab3327026906d3074bf1cac57df1977d08a(
    *,
    brightness: typing.Optional[builtins.str] = None,
    brightness_var: typing.Optional[builtins.str] = None,
    contrast: typing.Optional[builtins.str] = None,
    contrast_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fc6d767529cc1d1197d5fab8e3ed8c7f5d20647f11c690bc8c33845f9b2a3d58(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1355f657716f8dfc0565b6d991ed3392bad9a6796e55d37cf66e9ab61a03d024(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fb175b279ac135aa2ad41161e8d35d85b5c41002ddfc61e4d973995009836eb8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cb44bc9692d6700d68b0efe255202949a3e0b32e5eb72087f1577044f4b15686(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f9341aebba22405c8d6306df28a98cb833f4e876f410d11a91602062dcc29b3(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ce410c3f69c12051bcdca4bfc7517eec49783052ca56a5a4b4c79edee9f723e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeContrast]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__09eb692298dd4cff8b20e74b359d887bd00ab41a9788cefae43f0f65fae78678(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__548c0a53ffda8c6c03828a4aacd7a0df0178e3882c053c6b74f2fb46a0daa3f7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d82eca81331d5c161fcd3d14e1c4e62fceefd42777ad6e1206394536dd70224(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d2b21cdc39d45c7935a10595e26866a53a0f98179c4a3b5e4e4f0c0355a4e14(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0eef0acf52168596955c0c72ea65a19256c1aa1509c329320c07ef37fe2200a5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ddb02eb79591e39bbae96d30f7a73777b6f625696ede8589b3d5acad73f94115(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeContrast]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__73241696744707bedd6b86549b574ed5105b2062e65dd16482c09c8f1c015975(
    *,
    chaos: typing.Optional[builtins.str] = None,
    chaos_var: typing.Optional[builtins.str] = None,
    density: typing.Optional[builtins.str] = None,
    density_var: typing.Optional[builtins.str] = None,
    power: typing.Optional[builtins.str] = None,
    power_var: typing.Optional[builtins.str] = None,
    seed: typing.Optional[builtins.str] = None,
    seed_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__14cca1d59b0ea9ecf474cfcc7442ef0e760682c172a7799f35526055dddb5f85(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d7af76d8d0b8e71b861023a9298b7f2e1ef381e2b2550c4e9cbadbca17cfeb60(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ac51ad6a589595c3b8a441624231edf9e528b7924b58b8abd9a1d417e1bc403(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3304b92a1248f52e1e04e4638b85b805ce2e14875d5e0b989d12553b4da85e1f(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d00d3c2e1c2e78fc9d36e8d0354f22fb5785b4788e8405a3010edf372868f6e8(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc0e61e2b3e4f8631809e8b187251b9a35ac9aed8fab6f3a9e35c1564bf3e328(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeGoop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd546f095e75ec354e3ef37d94ae3f6d3c3071e2dfce6d38df273439116d4464(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__99731487c23e6782860d78e4652249788e964fe2bb709ca6d89d7ccd7962e39b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5da64d9d5723d57f42cd93c27191d52b66b562198630d53304c5b4c97a18ae38(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1041ad48de9b04595477cb3043c480b6e12a9b4192ee85c4cdb0c9f6b4cea74a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2305ce9489cadd3a8eee0f42629477cd831f582a4ec1fc24c2d20cd694f73d0a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e34182cf049843a6d135b269ee3d638bedd1cb2eb18c25b48ba44102cab013a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__026ffa44045475c6fb079437c922e2cdd3dda8bc1cd901166853b1a534beb0c2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7f235d5a72b1260f534f26afa617219ccf9c93fa40e354d988ee2b6e48ee94ad(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6c89f5d3781e27b11eefa271451fc72537f86c888ed410ed286269f838330dc6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1289c860234a7a041d9475b44bcdaa14dc382db34f570aa77ff7056a31d5acd5(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeGoop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__96a97217be0abe142dc5939da63bbfcca0363b1b138b493259a43665524394d9(
    *,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2481ab766ae1b89b52acca0d0d21c61fc007846038a4cd176ddaab1ef03cac3c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b69b09bc223593c8d73bf9b29f4309efa06fa9e1cc9eac394d3e46f1bbc4448a(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f8c380ed17bf04dbec1b1791e5d4c5ca1d97cd963842ad511423f3a966fadd0f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c50b531a187897f40d6b979319aeb319919d864a4e9e8d1ceeb563a9911b5835(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5d0c074bfb0b291dbf97cf3a838761afb943748e2bb03f14a5384b3409e85753(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f1c125aaa64e6a7eaa5d9db1585c60e09df4d4e3552696e1bcd3cdceb1892cb0(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeGrayscale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6bcf0b627e33323f50299abd158d5aed96fa7d3ad5fd4968eff62c779b6c7f1c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__819e8b63dbd385d083ea9dab3f7cc7c7e9726b93b7d8076cc704ac99edfac448(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d44cfc712b88ebd5ab0811ca7d2c3522a1f3091dbcfd64e29abab317ad879378(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f63428f6f1ef6b4582de6deab75d750fd11b8d686b8918e602412621b6e9dec9(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeGrayscale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a84119a0e3c295535c0cc21cc3291f4aa7fe13386633cf38e322224dd23118f4(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness: typing.Optional[builtins.str] = None,
    lightness_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a10c74d5391a17437db815b13f998890a915bb682a805bba58f67c72559e3634(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5cb881f8ebedab9f7ccdb1140e0a66269f2a3732de1f723c714069f47315097c(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f0fd67e8c4fd47de94ec14c3535cf6c7265ed4d35205b8256faa51169b6798a4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aae2cbd93ce3ea237b5fbcd7a6da9db78e83df0d30a28e5a6edca44c7a8b5f1d(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__000525fb416a4febc890526a04cae4f8fb85fba827fd5b81d2999fee71fc07fd(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__22b61bc8b4af2ebb25b11d058397123e083709331d14613b8758132574ed87b2(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeHsl]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a81769d18d3b85f47b5e99ac423b79867e2503cfcc2f60c82efa095b90b138a5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e92c4bd85b16dd2e251f1f18c2e05e32fd6c8978a1beb31ef3a25b4d15bef5d8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__388b3fceca8e6a4b0dce93da7ab98f2c0b8fc85ba341bde045495ac5b4f37cf0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__82ce1783e6b9b396b6281377711c348b5d4313747bbd57a098e7a556bfe2d885(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0789da31a049456cf14006d0479173c1747790ae8f78f90bb17ab81b479f5b61(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ae4a6c1f470994c23fd5431a72f03d2f33bb4378dd1710e99f2f617a60f5c15(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b4f33e2f8c7335e1db2d0b948a0f5cf7f6eb626cf3f6f33ad5b49383dc2fb40b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4bc0a524060c16d09cc1a2367935dde627c3365ccf2a439dd4a353ab1777aa2a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeHsl]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8b512854e4e497f7a4466a61a6738e6cadcb660b204f4ff5f7b4b2c98f442710(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bbd436b6315817bee9759627112b7c881d772ed3618b12d609a06eb0d4013b0f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__79c05174d09f1a47912aeccc6cd9e665ea39e4cc54bc4c050a1bc1296329266e(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0d325d83f093035a4dd431af30ec02aed90233518c0fb2df81c97410f563be0f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b60ff1f28d325b22852311fb0bed9b5580292b84600137d66d148363308e2dd1(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__44e91013745cfc26951122ecb423b6a6d48c730b79510152cca1daaf68369e63(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__35399f0cbd79d1d5f659a1c3873e9cd9aa840466fbbe39f857c6900cbba90aac(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeHsv]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__550709f8d1ac75839c3c3ec10f77edde8edb7bcba2a9d7daafe9fa8e59fb55a5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b39676c323b115a03e58d16bebe43644834d2e819863b511e15a1b530d3442d7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7b016ced2af960699a3f11075f74a68bb679f351e043c237789fdb6f0b7d196a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ef5c8eea160f366b85f049578c40f9f77e4fcc4322d58de219f8a49687e098f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ce75fd6d084b29aeb8831612fefac4ffb19fc329159948c0a08598203ccaa846(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eaa20aaca15eda8fb84cfea7252dc99e49afbfc2a6b85ef7e8c1c55773eb8829(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be20827b873bfcd2ac7ef4672899fc5c3018f2984ecc7b4e2fabd847b98bf4a2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7a290dc3d5343d6ea1de1fecd50ee26a651df4fa7a17816a118dab4ed2e2fe9b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeHsv]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7eac17c62ff0c531e766df9a84b0f8e107c776be7bb8b12ea8abf6ffba4e8166(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    dimension: typing.Optional[builtins.str] = None,
    dimension_var: typing.Optional[builtins.str] = None,
    equal: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionEqual, typing.Dict[builtins.str, typing.Any]]] = None,
    greater_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionGreaterThan, typing.Dict[builtins.str, typing.Any]]] = None,
    less_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionLessThan, typing.Dict[builtins.str, typing.Any]]] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7cb38b1cd5e363c9e03dac52a0fd5bc95aa0dfaf0001334e756510ad97e12097(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__236a635f662c35e67633ae9f9bf0ec810684ac6cde3ece4e15716f35a06a3eb5(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a20ce681c64df6bee425521b11a72ae813872687dc0f958325927269f753de8c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e3a504cc45c127195453d34ac8da3a45cba9440e7779c5ae756c63b9fad7db66(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionEqual],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5939f89e9afa131030ae561dec519c1ed6a4a628e28e34cd8e3050999c056bd4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cb8c03062999040648e3cdb1d63d24c21c0760bfcbfba357d55337436105e56a(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionGreaterThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0aa2d80af39a57a126d65712b7764e79328b4ddc3202a73fe0b0f753125bd0d6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c70b9c9557e22482bdcb17865c10a229b492901195efef7bb213ec38b7d2cdbc(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionLessThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__52722f743aa41c1842c473b076850ad2facdff94be38eaecd8cca02409241e42(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5bc0cf97534996ea75a7748066d7c33bf242d644dce5275390ecd3a05c179cd1(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__362a90da41225d6d3528636712cb4fe38af0ace44daf1cb46bf2feb8a94deeeb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a2fa85450acade0e2d00e4c4b3f1ca15829d81899f278be17e6d84ad1d74eebc(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__535545b713a55bbfd15429685d43ac699a9cf70d4621c82c20fbe47d1d93fca6(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8d46230e9550898df41cf085176d784fd37c71ff6292231f2c92e89755d79b7d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimension]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f22d6d9cf158a668bda620636167644bad42ba233e336f5f85d91d5be9e5ac7d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ad02f2058321594d46ab2dd327a86ea110e867f813cbcf226ee0e28462ac1282(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__30093dd6f3ca3cf228723090ee87ae6a8e7f1661847a304378f3bf7a3f00ed92(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__80d5a3bed71f55feade1fa1c08b9e817e334a462ade6c5429abc62eef949dafd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__09ddc0fee2481d1cc2920c303cb43b8e37e90a8afddc6354043e1c8ea7ac06e8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__adc014294237e7627dbb254f3407c6be7b826bd63616f15fb690c13a4a61847a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimension]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c33a299a7b5d602f48c510cf7f4c423faa3962fbf813f3bf9ff2e09bdedc1311(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    landscape: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationLandscape, typing.Dict[builtins.str, typing.Any]]] = None,
    portrait: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationPortrait, typing.Dict[builtins.str, typing.Any]]] = None,
    square: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationSquare, typing.Dict[builtins.str, typing.Any]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8f1f14e3086335f377eccc7f2b938cdbba6ac90d80d15bba74fd6782751935b8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b26bb208fb3b3b6698a691f11a45cb301139e9950916b2dff228ea3541f60d84(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f1559038320b0a8154446f3ff540dfe235a86541fab5309d5cec0e72931b8d24(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1d677621409f2d628ab4affdb095c58b99119870bcdef7fbcbb4480f93695a34(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationLandscape],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dfc3028ac1ea7b7b4f725e50dedfa833768b9e8b500e1aca34244fc6c387caf9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1538bc38af6d35c94e93501d6d3ac2896ba44c91b8a3b0cc28ad030d748c5fb5(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be8fb21f5b90994e85356036447dccd764432f4d90cbba89efdef40443744a19(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c201ada4099b318a16b45452344254b6d39a45d5ba28b6306ea610461e91f726(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d057303da46f2c27017acf37caff124cc4dcdaeec4fa3427defc2f5100178e33(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb9c42b6fc429e7095b740a0cf5a12c4765c0d1cc7054f3366e5309fb243a2ad(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientation]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c94b4a8c65ed5328d7ff6bcd37e9bec06143547cc2afb3e8d9873c22ff1581e8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fc2524f932284fef6c7838f618e4c0e0d719265c43c5b1e9a30c5dd728857f3c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientation]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__089ecb4b169e82ac097c347a23b9017584926bc827d35f7729ce47775d70eac2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c049c5e3e6e3d2bb4a873856f6694e3db94fab3f0aa6e2c2b0372502401d2193(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationPortrait],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__96ec7481ae4fc3475927b1c2fa53ccce6279dfd59dbed18be198f19a50b80519(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__672db176c2a94d780de80c6e8d6c5fbb9276276a57721ecdab0da05d0a57f3b1(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationSquare],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ca3831d0b041c6522c2b186e2986fe129199da4e582938267fc08bbaa68ba7a(
    *,
    colors: typing.Optional[builtins.str] = None,
    colors_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9303ece5ad27896493ef0ef6b28985531b82daa049556ea4c5c851dc32f30ed2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a8aab7629ce92433f6ed3f21d0f5116124e2bcf8bd9d5a2463014b0c6d8f6a01(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7fad49420ef49fd5c3179335cc328e90dbb2398bb4a31630942ffa7ea05929ad(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__638f48ff648b0b351b3ac8cc37b313a18013ad1be7754c89ec0e9053b09bc5bd(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__532c8d22ffe1bbbab2bd8cbf041fc79edacde068df532b8762fda667f6c835dc(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e9c313facf048a1de0b2b66722aeb3571ec68eaa347496ef0b8d36d707aca354(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeMaxColors]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0bc7fcc6fe0a1bee223672d8fa168e7c7b728418049782bad81eb83e48c34c69(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__01559e54df58b0d58624de427f599d60d8acc8619374e25d767cdc080aa249e0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f4d6aa62b82d1fef60688d2e75d7bbf37511e7efd41ffd2d8def17a709f54f47(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c669ec149ac11f5f086c79758f957c4ae89bd7876e036c39060dc934392a580c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeMaxColors]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__770eedd9321b192322257ea1cb1d57dd514e50239119df1a6827dd5226ea6279(
    *,
    horizontal: typing.Optional[builtins.str] = None,
    horizontal_var: typing.Optional[builtins.str] = None,
    vertical: typing.Optional[builtins.str] = None,
    vertical_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3517fd63ba865e697e761e5656422708cd9460bba1af833bef25620438066a90(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__033b6884a44bc68a196943477cec8145b174fec8e96fc1f5f4bf0c76b69893e7(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f73482f12e4f0dfcc4504964d76cb19ca348854a80e676e12811e0e1ca80922e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ef7f45a3d7481705250f45fe50ed51ac44a6f1424c80530672c0394bf87a3f51(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd825eeeb26309c348aeacdc247d13c786eee74aacac6d94a3443ea887baeba4(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a86429fb2203636d0c917df4d7e67d54d937fd4b0b2cf6da9757d6253a5e66ff(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeMirror]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b13bf1f354f6ae31ce833693ca0a3fbf0edb610046ded141cdf009071573a710(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8051be3db28cd176716f8dc76b80a32b746a7d835dc349ff7c90bfad243be456(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__540c5ac5ee62d729fc42b56ab167454843ba6172721de44ce5869bea7af2ac6a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__254558dea48a7006a3034f20ea227f426dae6448a74f32d09e2f16bb9ff64e93(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d6ee9d6a2ce60491d264310e58d32ce4908063d2e642a91ca9f9290f9bbde16c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d2940dddcf2f08e1ef2854ebb51c39c4ec3396672fb19e38dc47103b70034e6a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeMirror]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2c58672ad636ec89269c297fa50e0c9bdefdb4b74d12bb001942f85a6583620c(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__441fc98d17d2573ab7663914bd079e0a9cb8d6525067ace40437ae3690a05f7c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e79f409ab1cd82cd56b41e4f1d9b7228f8b3ead2a3685e76c8a0f2d9418b82aa(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__973692339be75ade37c462c318a6aa326c072cfda85ab1b90916d8f799766404(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b8862ae0129477d3d52081fdcec2e647ec4523dd567868bc06b1fd89233780db(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a888305e04e6d213bb52cf6da8a6a7f01926684e537775cc51bb08f819e54e9(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4dc8fe0d48605f70dfede4f01dc1beed86c603aa2bbec0d948f244b1685640e3(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeMonoHue]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a47189224cb811b214f3ffe4af113d2e733dd056ec1b489b7968e4fa00c348bf(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c7a851a2ee3a8c7bcea632fdeb6c9677d7bf456df2ff579c0e0bce82e6e3bc2a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9abafbc7cee6bcefea0dffc96467867f870f93f68d0d0df312ec9e1b27b81766(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__62e7f98b5850442bd2871451bdfd7e39c233f3004a64a23e6b2cc09684888849(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeMonoHue]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8e1d6cc7056cb735d731ee3cc3114c51f1ce4aba9f355c41af49f55b9a384283(
    *,
    opacity: typing.Optional[builtins.str] = None,
    opacity_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e07e93c77c6570042d12f8262696a845185c93c2bd3dee6746fb6b0b3ae1f662(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6c4119bf6d52dc5bf1f60e12fea50cc8d937e9f305aa66494879fd79c35a9c4f(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__54828574b00474e0c0b3547505930cb8b60846c5b36a72fe8ee491ddd8afd2fe(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f701a35668e6669ebb2717897b62a9c3591ff4df6f82e14b662de972807295f(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7f763978f3f239056e10d3920517b6ce6af2a1687c9c995c73d3f86629c1d274(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__daa29a8c430d9a60168968acedcd384ea0a9e4ce6ab0487a54c9fd742acc4814(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeOpacity]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5b000443e20b3fd79cb1c20610ef3e594ad0d2bfcdee8d47d7ad6733400a6c17(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d096fe04e4af290d0fad007d85fe622391574dc0fdcfb33074d9984203d1cc7e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f302189e53eb73cee1517f931b8161497e925d547cac948ebf7c8c8a8f56b652(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f9434761eb9d9ba702faf48ae4efecc552a9deca43a69baa16898235a8cc187d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeOpacity]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9978d9afcc61f5e934163a149b86b93e6dc62e7dda6d76e4ad18cc8c9502f455(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4bb8f5646990c08b1c9637beca341e370e8d40d8dcfad365b4e389884d1be677(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__379470ab22f0011dd1c7f748aea702112720d77b38dab3de6d4c5f1d7c3e6e2d(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeBlur, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dc6d2907707803d6344924d49b9318b8942b8a7a83a2c5b1bc2530caa89ce948(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeChromaKey, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__62affe9b8a4990b7b7347f9d46d760ad391449217baf979f7dfb010e9b79ebce(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeComposite, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ef8f941e8e8e734766f5b29d5e32141765706ff7811196dac865a543cf363fa0(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeCompound, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9de54d79220a2a088955e080739add7367e425dc51ca1d0d22bd73fdd562bf3b(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeContrast, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__46624c6134c345bcbc7e4954059c6cdf3c22383bada6d542e92fba61c9f6e1d1(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeGoop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7824954c8d04a9c52db5e4f93d3867b764c54b33f0cb0c002bbb803efcd8512f(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeGrayscale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3c57dd0fd22b763262d36b96a4ca7480b195e782727a1c6afdfdff6708b15e75(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeHsl, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b3d59b0b711488eb166d676e065061e0384a293ff5df93d5ba8dbe2d0ffb72d8(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeHsv, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1cb468ef8ffdf72dda72feb1574cdfe655e8e46b6fe10ace1632e455ac40d147(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimension, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8bcabed9fc8a5c4e97fa75f54dbc6ff5d66eccf419a14a35458883c7e100ed67(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__97b52bcc99135e97df45e961b131f08dbe66678600d97819d05725c02d61bce0(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeMaxColors, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9075af5d5db0ab9947bb02f88551995d8c7a3e1cb84c24d7233c74c43d6ba74a(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeMirror, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__45b7c440acbe78121174a8669da5ac988695d009677e886f4973ae9f00afde6e(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeMonoHue, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5483aa3f420565908bfe0308b231b6bdffea558f3be1b38f499e0986ccefc52b(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeOpacity, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__58a98d8e403eaba48e1a6cee71651f27a26787e53f02a27b280cb896b0757c25(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeRemoveColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__15e15905b29321cde49c287841442ba1cf23f2d2c7c3072daa88ffca18bd1a4e(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeUnsharpMask, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f59329af735a2acbf2de884757f6179b632c393c9318dce452dac9b678c9b247(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscape],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2e9b4e6e79f83328ca9c2aedcc47958e68431d76d816024e2b1f19f3021b4090(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
    feather: typing.Optional[builtins.str] = None,
    feather_var: typing.Optional[builtins.str] = None,
    tolerance: typing.Optional[builtins.str] = None,
    tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1964ca8b108068eba8e754a2643decdcd9216014ec44fa813603846621dae06a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__07ddabe7b818d44aeb85a97ba3437b4b090071f1e8bcfca32329dfd5fb42bfe0(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0440463f0bcc1d893381d241ce646d1c77851b5dab1ae93879b78962da529ca6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__28e7abd9f637232f0b584594710df52f94931071bdf166c218133d3b19bf2dba(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c494da6a5d1c5126fa09b7f19e5e2964e6ff78b697f28f4f192c88ce26c0c1a3(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__347a5aaa936d61b7af0e4452526772444a5dabb8756e3695d4cf55a594902eb3(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeRemoveColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aa584ee703b8a8b6d21fbea6f1699e02c4b4eb0f4521a9b835dbce07caf24ddd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__31c003b4fe9f45695979a771cdedc7f7235db2e25e99fd9ad81a89486ae8481e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f60e300519d9a66b7f3a6abf055586232e20621f5133eea03e457b7895ddd9ae(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e7d04ea34e9c4f0488133cab2626daae83e5496523a3f3edd2ae9019c319f66(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__058e1a61c34898137f81fa148c2f0fdf70e9a7ecbb60e6b093b768459e59d422(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0e9b65537c5a09f07c8c65c8800c869da634a21852b9ca1971d027e6f0ba7755(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__663fc9b72f13972e413cd5a10f04c33584aab207816ba6807c2cd0df21832dbb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dede1a9729e58d8f5e62a5449547f5183a5422a13139aed0999f03f4418baf92(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeRemoveColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f7d68a4cf982e1b1ce00bf4326402eb49416e2aa0dbbb18c648447b4bfb58155(
    *,
    gain: typing.Optional[builtins.str] = None,
    gain_var: typing.Optional[builtins.str] = None,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
    threshold: typing.Optional[builtins.str] = None,
    threshold_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d2c0097bc0fae1128f8db79cb66cd6211fd548bfce846fc907d2c5b0cb7a9656(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd8eb716c42d903d1697f460d8d14bc0c5a606dd7267de1b511ee94168998c71(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5d47f89e7f2b0676349c3a2f6fc2ca7c00c5124c7d56681c4bd8e38d7d781111(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1ca7188b41e4c70ca35e1dc26d3a67495c451d41fb1f771d7b5af5a49e6fe42d(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__50341ca3b57fed6e97408a1a7b65b79e9f1f212fe8fb62e499cf54a9414514ce(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7dc8be37891e70f04e6b63b84d9073aa0d02dbf1bbccd5862bd885d4b15ebf48(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeUnsharpMask]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__098f9db49edbc875988a971c339ccec9b60c4b8194b02742c42b658a28ad64eb(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d90013f3ad6c554032f11c1e217f4737a44bd0f5b00faada14a3745ef5ece203(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3cd07404537a26ff591b7f447c9484cc44964ec1b14ca3e09ecd7b834bf8f5e7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__779772fde14add819d5a1e111e37834f898da5c2c2c8236b3dfd338a82f3d2b2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aa625fdfbf861722b3f06c37037315178504d652eebd0817cb64008e117f30b1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b471117a02891e09c257307881d7f4655ff9a1c6ae54c0ea3375bf00ee6cd9f0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e9bce521530c259cc54da4d8ef8400541e5bebbbdc1be86406423a008cb3dda(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ef6226f985b7e218d6d97c8f720c46de21a1e52ee438f5f64892c6be679292b5(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationLandscapeUnsharpMask]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1b91f2fad7bf43d477cb711fbf22dadbcc2f63162f80272ee2c145f1e20972f3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__10c3a4932be2c66929a9a7e9580ee2523ddb0df6fa6fdefbc952b74f94583edd(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8886b765e984fadf2cb5e4ba35717a2e8bb5c386d9e95510a642ad050047cc16(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__11b6ac987c49200575115a053978d8b6b3063218612889ac3bb8cabf072de5e7(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0643ce6149123cd5854e09a6e7a934a95ce0a2e18dc7f45f72fcb66e13554dd1(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ba6caf173f4802e0f5c2b73c2b8eb27bb85342fd36b5d9ac9512bc3756df661(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientation]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4af877e7b18547bc02e99b813cb481d230ee9e8f7c1e14c23cff0fda231541b2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fac4ac28147e10b94025b9ac8574660cf2b15cfdfa148ae80df5ae5ea6275096(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientation]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5bdd5c2de27555b9761f8ec6cb9d32b12544994eedd5bd6ef7e0ed8e3e82444b(
    *,
    background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
    chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
    composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
    compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
    contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
    goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
    max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
    opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
    remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7f82b8f25160812a6f108b0992ab058646fa56ff14d41a2eed0eb51795007560(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c7af6b32ffd338eee7ca54b610ad7379ae673e37126367f64cfbc50088760e43(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ebfab112093473de83f3730c4a46005d8c31462916eb2c264e18be0a9b0e731(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6d8b00fd55b93d770b5ac5ade57c23bc85ff944e3ebcb012cdbb4e512b828d6b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__14e401151d126ed86840de50b39b590b9834041ee8c749347129c103dcbee4c0(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d7d6e7249ef26b63b85b65f75612beb8746f7ddfa046731551fdd4997f2eef2(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a0d5074fcccff4901df6040e34efcbc82234cc9e11ec2ed52e5da9674f6486fe(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitBackgroundColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__79c4ec37d2a230f808dedc3472a072f5a649f3531e087becd16064b00634e7e0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2add9f01cb363eab6dfe5a784866242ed97e76a4b690e185ee29a3225c138906(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__23f8af219f6f33e36d1c1e0de62fd86fdc1ab4cfd6ffb3fe93114c486c70973c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7ebed7cb54102917eedb36760534b0e5e4f5f3978a543a8a98fdd92e31f25c73(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitBackgroundColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5eaa5dc78c730b850ded876b7cf14d53bb3334a3a8afbbd434099d4bd8f0b78e(
    *,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3d07ffb69f6466a46ca021dcd7e12f81dbeb9464f56668cf973654307237d772(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__99474b1f20e0c61bfe25d13bbc89236ce90a04954472f4112c7af4f6ce925bce(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__18088e98e1577d24f806c3e4590366a9a18c060fc13bb49a25033ba4bf163846(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f7526538840759dd177b02da01f3e9433a22ecb2fc7f634e9d6da41ebd81080c(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8547b1348f94421a704032aeb1ded094c0365dcf120410c8b2a12e4d048e1955(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b54866d36a656e3c43640999afbff34ada322a10056c60edee9ee8f8728d5532(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitBlur]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__061c95401259330a0af333713332b0e64d617e22ed0543ff6ca2d7d21473093d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__17909ec96b411c89beba31d462a7e4e47ce6a61aa8a961a3d4ee9d276465a238(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7172e0117b226b821622aef067146c475bf3963644c83563112cd6997c284cbe(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e79dccd773a0ef7f85a0dd440aaa530b8c9432966d857117d768e1c07f79e4bc(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitBlur]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e7dc3256b3f94f40f0f447de02fc55d142924381cc778325684a3c14d16ff7b3(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_feather: typing.Optional[builtins.str] = None,
    hue_feather_var: typing.Optional[builtins.str] = None,
    hue_tolerance: typing.Optional[builtins.str] = None,
    hue_tolerance_var: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness_feather: typing.Optional[builtins.str] = None,
    lightness_feather_var: typing.Optional[builtins.str] = None,
    lightness_tolerance: typing.Optional[builtins.str] = None,
    lightness_tolerance_var: typing.Optional[builtins.str] = None,
    saturation_feather: typing.Optional[builtins.str] = None,
    saturation_feather_var: typing.Optional[builtins.str] = None,
    saturation_tolerance: typing.Optional[builtins.str] = None,
    saturation_tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3abc861450bc72476182f3a7405e058eb58f4c80fee80db04a4761f707f3e0f6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2882f6142eaf1a5de2e6c178369f371ba4a53178036be45dd2553b2c3e4518e3(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__46e8e89fa75eff521754c9d2c4b1df498b63eaae7774171d7304a3ccea09dc96(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4274eb3a03b0635b2e78f03005807b16d3c2e322b21e354a2d43deb1fc0925ab(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bd5598085770826fab362d97571aecf254131a175b9b0c2d3a8380d5f969737c(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__72f675079249c7d47a603b67fe01ef589b3ce68f6563ce02b2ebfc2d27685696(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitChromaKey]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__82ebdeac94fc3c00a2c39bca7c74f83ac04cdcae951861d7a1039be149c8c8c5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e91d41db94e9647a758128ff29f4dcbdbd74d7854eb7e962a6f803cd24551139(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bf5596730a23bcad09b214d66c8a7edb181fc15b49d469d4a317fc77d3daf333(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__78d14df19400f7179da01cbdf7dee6bcf5ceb70b26abde8058d7e5adeb155ec7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0493e0d634eee36a6ddf60cb315f3651d727a8fd293ea65e22e5a87ce3b6f773(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f9bc7eb1348c4c34e7d971e469f9ea8e2d254d5ec98afe1c17e4c871f5dc692a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bebdc066dd453c3bf0d4b1b32618ca1358b7f77418a5fe19f2b8d792b7e1c516(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5270c7a80f6e61dc5b475e8d0f868a894b2e32abaf2eb4011be7deeb0f8fd3c0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1507b58167689d8b73296a57052d5006cc3e0714c93d0503049abf9a01fd54bc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__28d4d9ed9926d3847a65ebdab516100987baa29eabb94a761b8f9f2897e7ce33(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__49829d1db2981e787dfcb25ff1b3b48e28d846d21d0743a8da9cf512faa33ac2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__83127577da1db211c98a6d3333818a2a903cbae758caea14794228e8ed65c381(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__926b2199e2e7f47ef2c4a809e1a731a1505f83ad1869ae20f22ca585ef4e7b77(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ed4d72762e57bf88ad185db017644d9b931ce3f8db5f29137fc26e6aa273c08e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7914396a59108aadac396af6caa23ba7480084065062bf1b52a3dbbeef6a65a4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e6cc6ef1d1d05982bd0409c440ae881113f598f04328a6bc5f29bf253ac2a31d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitChromaKey]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d33766d0a43744f01e52a18550777960017f4606714d5d258fbc4dd0b4f4145(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitCompositeImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    placement: typing.Optional[builtins.str] = None,
    placement_var: typing.Optional[builtins.str] = None,
    scale: typing.Optional[builtins.str] = None,
    scale_dimension: typing.Optional[builtins.str] = None,
    scale_dimension_var: typing.Optional[builtins.str] = None,
    scale_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a66c4d4f98fc4cd074aee4ba542c203160f695da19e20284fee3c9533357d295(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8067377fce2a4dd6d9d125c765aec0fa4b3fb06639504c724468edbee3be70ba(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitCompositeImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__47e249a54f31047adc45f4809905821a0c4fab490c4d0db62794ebcadc43a08e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a8ef5ba183cee88a477529b5083c10a9640234debe660dbaa8d22fc65d708361(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7147d6b156dd4f64b99b8a97cc9799ba878d1e58c2024e1f7df4456dc690e0e3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__44974cf4d3cdd5a89701b17a89107eaae8c00883df71217a89a9b16dd4cfe1d2(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__63ccf403100877c58506e544aac216208aac4756eefbcb4d5093587c1924d732(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__675f937ac0af45a3875a85d14eff4ac9fceaed90fd0f3f4aeb1e9c3a379b6ff6(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitComposite]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c0fae84899de3ccdcbee8eebd1455fbbb960fca019f7730d0d3b3d39562e7365(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__512a7c3f0cf14002357dfdb3f98fa391e855d7436ca6f4492f2281a4032bb6cf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0f97ca8a036609fc2292a8fadce6da43eafa6693b966b5d4c9dded89d0e9bf06(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__298f8aa79bee7f6ecad668723d6bf7b108d3c91a3a2ce9cfc55f321f9cb0d51f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a335030f57844542a848f18508a1abce3695c5ff2da9c2b83854da34b468c70b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b34cfcc89951e3c1b25f00c806e570ef98b8a332478e08a882a9fb9312b6b21a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__34f6f2d2154dc844ea4330f3dc58566b468cbe618dbf62c3b75e5772de32140e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5dbb30bd66a4a53aab7c8c520f4dbcd140151cae3603fc0935ca92e882299c8e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ac2bb4a250fca289274f2fda86770647baed38bafa796057aaabeca7c8f6378(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fa7f263d71813dfdd6e329d261e0cd0ef901f451f82e93082179e5123fcd9539(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__69c6960f8bfb7c6386ab67fe3788c7e1435b9f63dc841a68c9e7761147bd0dd4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8e5b91c1e40ea1282d4a636e94289797e4060ff4af76c658a2521665185b691c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d55f1f24c61ff22a58eb383121e355ebbc4f007f671af746e0bebcd4a05147ec(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__779c7e608450a83192a237c88d34098f1843ae67e483fc2a936bb46101622dd4(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitComposite]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fc1815f341403b32a87475d8c35827b6e910c3085341c08a4b7f1154ed61a48f(
    *,
    transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f6e6530f69bb109568d5223518dc154177236411f4bead3525ca4eacfa28f0ce(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b56c2e274a7f3ae2a4905315a8268b51ce85875dba2dcb4570d36dc02b91fac9(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__95fb48c03c2e8a442ae52eb3ec4523ca37426f28613883b58e164db7241b41a3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__415215a92dc86670487d741b8594c01f42c07cf44aeae911cacad4a41d68bef8(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ad080c839a1b01677a64e92c8924206a523504f4dcb9bb15b005fb7147d54c19(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bcbaec178b54cd054a298427b064029023f5890aa85d828fb53bc3259e030a83(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitCompound]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0c65ce276aac3031b65844a5aaecf010b5df5809b46b835a240b40b3e37e3ded(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ebf6aa802b0817bef80b9b6187a3af710a8647ae1d66f9cfe75ff7af544f2ff(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__756adace0e3aa1f070ec3ce76854aa828c3565a6cda944917f4dad58f0b95b2c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitCompound]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4c624d1a0767b266f83578600b319402c2217b95c2f8db5660998a27da410eb5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a44523e5f251a858039c353b382b951113740c50af5253b83a0c5f05e6a40593(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c60b9030be21ba5aa7ef004dc16d695f42fd228a46ceffa665cd13899b686fd0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5d5ad5ae554804c6ffd8186bd18ab5223a70a80673df327d26f1c7eae2541b3e(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f1bdd2c8faf97d6f275b25e6a66689c334ed7146e6743d0e343e8953bb601782(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0daa22820906fe342b46e59880aac38e89cafd80d8c1f3f4e1feb7c0df5d0c3a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitCompoundTransformations]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d86842511d905bdd6ed31241368cb5602aa127c49e37326304bdc113b5f7c58e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__386bda9948d1c082400eb1fe534ee3e54c176ae92a2f9ff971b01cb4941d82af(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitCompoundTransformations]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fc8c86755ba5341dcd0a8867797407d62c7b995dd0b2cc8f82e9b94e02119514(
    *,
    brightness: typing.Optional[builtins.str] = None,
    brightness_var: typing.Optional[builtins.str] = None,
    contrast: typing.Optional[builtins.str] = None,
    contrast_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__18d933f557d0a3d0053370853999405412be5401625a435df4bcbabd3a32c352(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3403e23315bddc4862605a54cf90628dc7b74febf1a13ea46005c3ac84db3ec1(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c1efe7a5636913acfb938bcb4ea7e622020c58eac5bff7f7d4835b0e3ca05e06(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__273322fe25b4f080a241be09217137cdb6c3f529fb4d9eaeaf54ec2657235de5(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__08e7b3bb34102398a0f4191e3c6f93cc0ef9b80851dd495470504f7ad1668307(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b661e549829b8140bd8a260a568b2b78369e58dc90d83464bd0457c12213aa38(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitContrast]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1a64f43ee2ed3e0e09ba2da6e83df6292d5e17be99d9afcff7f9e26e6339b97a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__367dad26fc5a4101c10ff04fdad64d8305bf02d35b64a650bff15b3bf5c7c239(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3316a8445347625ca7784ecf3f39e61de3d0fb9a3b9eaf47eb06254a3645a947(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea12fa71a6cd2b095c0c2edcd8b918b1958cdcf2fe7f195e0bdcc4aa8662bcd7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__90dc468e76d8dd6b49541ddfb86698d2a33ff390cd6bc6c6f6a2a8e0bc0c01b0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b59d7e3a10cc5cdaf1f337b3be041e8137c0924e8591a8645dd98e56719289a6(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitContrast]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b1202a075bb1d7b795715215bc90d744817cb268bd4259683da8f8d4d02dc297(
    *,
    chaos: typing.Optional[builtins.str] = None,
    chaos_var: typing.Optional[builtins.str] = None,
    density: typing.Optional[builtins.str] = None,
    density_var: typing.Optional[builtins.str] = None,
    power: typing.Optional[builtins.str] = None,
    power_var: typing.Optional[builtins.str] = None,
    seed: typing.Optional[builtins.str] = None,
    seed_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__41d79a29bca1e62c0c2e81e3a20c81d0b52d9c3f5f0c7bd0a180ae9e56011a84(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6c69a51312e6b600b714184fbfe787270d84ed76fa1ee771d08b4318ce318c18(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4d55fe3cb06fae33d7281a8f3d35daa0030afa09f4e27d5e15bd5a9ec65a4df6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__548b020397453e71459d7ef022dcf1cc25981a50e20075d26c63b3d86558ddb6(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3814ed358d1b5a4eab08e8ae0908e518373731e9ddea41413b9dcd6435435239(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb6b661670f9faafe61404c57189dfb6d2123edb37c45e01d79ed693e1925503(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitGoop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bdabe8790e620ab04759e1f9bc4834f2ba42cab6b54be877455a457978e2607b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a2a022a38c963310a478ae123b7a56c725cfe1098e9ffb0577708592d14fa7d7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__98dcba39f0a26d14ac71de2b9a6f004b3ccb3b7d08e5736658bdcaf47248e76d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5e98335d03c459f7d4fe90b24f07927802f17122c2c956dbb345209b394fde3b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4f81565997a95d81d2510a37a1d1a9090ff9b4972050e54fdff48663d5fdb267(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__25a62414ab4a3509472a8ffce589cfe9f51131b45423dd01f4d55587d958803f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c14e3c230aca05dd3d2b9583df9c34467f1665829de03d096357c77f125317f8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__33ad8706ce906f4ae28da2f3bebb22e9e0e667e354b2a00e0428dc12c106389d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f0291ca5b083a554de392ae34b2d812d2f2c9d60cd296abe58263fa3ccb43426(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__00a561ef12d6511ecec849b546001624a4f4e029efdd51b94ec77fa555fdecb5(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitGoop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0810abc6cd278c3902466c13d175bb783dfb61155faef224fac22f69d8a97792(
    *,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2e94151cf9e814267e8fa9d62d23f4190609d3c2365432ab74d09b833268306e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0c4f2319e77dbee72cdc6bbd8538578f1e521895020c4f2b19a7d26c6a8c0096(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a9895799f7db7e41f4a7650a9834269fdbd7d88fd1bd3db3913b40889f68224f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aa8208f10659e00820de8e80f3a2dded37b455c2e141828a1e675a24cf6713e3(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a405583db8b6d3f6a7c3b509519a760ab245e76a803ea5ff3bdb113b6d09484c(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__00a8a45b0f12ed6b7588edaec07a4167d018d965e830198b0e0688d3076b2de2(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitGrayscale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fa2e5bd68b1c1de437377271cb217194e96e8a59e9fd9c1ec77b23c11c562e76(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d9856151a6965309f4c00ba017472bf2f76f8546903fdcc6481f84017135495e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f994e05bd002f8305b1f4baa84c6b78ea58cb7feb4e65410fc602f4715f9e58c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fb3d9d69a3f539434eaf48a5b8fe2425125e98ee9e50f2c974b2488c23ffe5db(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitGrayscale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ce2dfc7a1660108c82bb517c5b1a8178ccb31d2075eb75a0632165ea3d524e6b(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness: typing.Optional[builtins.str] = None,
    lightness_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__743a9eee62e322b015a8c1dc01c477637df1e2adbd5cfbfe370589df04bd6ac6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e880e964dd4a558cc775203625c623c274ba6c061abb841d596c84ea8350f9e(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__55a6e87862a52f735653e7440be0834ea84b539cc6f18b19e784556a2d5d8e00(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9dd585e61fd9e73a9c5c45169a0de22918814fa32c0a7875e7b3527089dd9ac3(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e255942a7f1814875ceb78effe9ad2976da37d8d6506cf3f33bee8b0f707e251(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a297d8a2b10b894d96506c75967ef6b33b5be4d9a2ceb95b357fd6ac5aafd5a8(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitHsl]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7a80952cceca87d54d335764e213f28c0639b6ebd6654f29b290445af713c0cf(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__336f9894c459123607792ef0c7b19ca3dbe896f09b8d7ef13e4eb57d9955da88(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ab6e25ecaed7e501a56a01a14c5c0f1fd22bc3e2c706fbc1d2231cf8f624146(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__631845ecefbf15ca62a6c3b97f1836c21efb4cabca5be12e240d74aeb6cb2227(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__89280b28c2b0f3557bad97102b0e21176621b61fb9ecc19462594f4d8f4acdfd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3c64eafa22de8435e8802b254b99fdf5e2c7ecfff8c32fe0bb90399d679e5642(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bd30096880fe653320bbdb092278b0636162bde2ae29f2fbceac862ead6fb60b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__68fe37939617a5dcb1b31817f3fe494544a3a19ca43444c5d9640197f7f2ec2f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitHsl]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f74866b1badf42514148e2d7bb3a5767351b72d66552b9264041c28737a08ae6(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__90ad0a33c07a8a4c6f1eb7a8e0451c86c26194f229c18c27052d21eed2078d29(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__85c188b86d745ef51872506bac34b9ea1211a714e017a2ea0c78005208daf873(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5158e83d34afd1466393b6d61b6317a6dee9ad4a352e116cbfe7b63d1a121934(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0e17b1bf97fa8ba2600c9dc4fde6a028b7406cc3d75b47339dcebc881aa68d94(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__94176f92c47f1f2757564883be518905178003b7da066b611ace945eb2d11f4b(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b4b25b45207552add41a0c743199a78d8f9f9d2da110fd114b9374484a018032(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitHsv]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9264345bb8c347c15428129565524d9a5a4ca0058d87dd3696258752f17779c6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__84bad497f18edfa82067976339e136c9df613ed0dc9ebd190f44d4a6dc742324(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cdc8d7b14a8c43d8163ea885d6f25d4504046128d21397fcb53158fe966e32cf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1e4bff9a5b62be4d3ac213518f5e0a041a3934639091fcd4e2832285d4188a35(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fd489c67401c4c0864631b92f5cf296a2a3289620084809fc8c2428c89451e79(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b570cbd82cdf8e605979d2d0264bac45ade07eaf276ce30713281bc8de3e7430(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7b4597929e8d1533569aabebb0b3681b7e723455abe7ff85ae3d5c273677f4ab(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b211b3746da5117b01af55d38920388378958faff6f74f7eaee24ce13c714c18(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitHsv]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e26e01889f5fae1aa4639193d2fada7ebf406b4ad317e756a12eeaf3484739e(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    dimension: typing.Optional[builtins.str] = None,
    dimension_var: typing.Optional[builtins.str] = None,
    equal: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionEqual, typing.Dict[builtins.str, typing.Any]]] = None,
    greater_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionGreaterThan, typing.Dict[builtins.str, typing.Any]]] = None,
    less_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionLessThan, typing.Dict[builtins.str, typing.Any]]] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0f75dab71e61c2ca764539168f02a452081bfee6dc266c0af57c670d7d4484ec(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b897d13591c1604e80947f3a71c163babf71bf3ccecb2140a877a8f9580795b2(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a7f989afe4f1d7c22303c16c555343a22b1ccce662fdcae3adcc74e68965bf21(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0cb8ff3a708fcd6166b4ceb0681631875e704d1253a9e084ace6a3f986d04a52(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionEqual],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__657c59faffcc9637d0919c52b9667dd0de4e90ef57372bf078102015b2861006(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0a0dd6bcd87fcc25e2da86bca444f3c3bbfdae4e98426348e0390dfae1ce9e64(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionGreaterThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1a3ba4d3c600ec3c1e74579a61680c4ed1eb98ef45ff96b6136b50755af038e5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5eb9cd3b7a4108fbe95455acef960e3d5fa6986b7ae38e49f0a98b718682408e(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfDimensionLessThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__612df7fdd8cc22b33f99f23a5934843021a402b3e5074f6997347a8ee10c3031(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__268a4e0bcc3484d8e4cba2340b5b91f65e4ce1b51431f989d139d72b95ee2315(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ac00592382049b0b7a8085d3de332e75beb0d5f9bbcfe88dc4d3502cd96e2d2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dd62c173d6dab1a803a863d4db2ac5c91d10ad35da061142aacb9652633397f0(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c8570af5f1321e5305109707dfac38104aae97abe560bd660dcb2da8e5e39610(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__53d811d597519e0eee76986f05e54f9811e6a99bfc1b6249ec9c6a8fcac71dd9(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfDimension]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fab08d736c2c1b9762015bd4f0740e40186af32bb56e0f4b5e5ab91fd681840b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7b3d3ff2781e9e87e0c2ccbb2de733be9bafa66f73ad413895bf00eb72b6e188(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__898f991390f48ce8bcaa80e5307d3407988a82edeab493a91c3ac96b25d1cbb8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__918706e09652d2f50344028c44ef7e30db0d6a94e4a5d9c4e91ddc0fd45794c8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__53587761d61aca8e300704c831316db6c86dc93342d4fd96b03a642c3ccbe5ad(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__734ee7424222c187e6fd24f7b7c4693206a9cc60104417dbb0d35a6612ddcb8c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfDimension]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fff88cfa2136f181d12c7d20a65097bb3d51a7b48ce904169aa0baa4fe404f00(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    landscape: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationLandscape, typing.Dict[builtins.str, typing.Any]]] = None,
    portrait: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationPortrait, typing.Dict[builtins.str, typing.Any]]] = None,
    square: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationSquare, typing.Dict[builtins.str, typing.Any]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ddf0d3091de51ee392cc8856cbf8a2efcd51c75735991fca07e124abc9621548(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ad63fea47633578dc738f0030caf9e55b5db1e3a50ab79b67657dde8338b9ab2(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__17054f97f588c47192c6edd94378fde41b1179cf4501bf28d9d98628a056704e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e30fde230db0ea7ff0e385d0ce7c557c8849d3de6f27fd1dbcaad6878e148f23(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationLandscape],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5d943729d8d325f2af505899157bdce220c5b1e73efe949fbef45e355b57480e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5e031af6b5ef2b9dd4f9db6f054853c905d5f8e8e6d5cdbccd22067963cefad6(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__238dff9656251ee346f525b0a03dcbef566f7a7c69175f40b0a059d892009ea7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__254fb17ec71ef453f284cc23519fc4ff53a7ccbf74091502b7448d8cffb3d371(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__567229cd86beff8cdfc12efaf0ef0a4251517eb444d5a7f3124a1a77b145a01d(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b9d0b5b9c74449cb59c25fcdf88a3c073bcb1f668a0213e6cd56ba143aefcc0e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientation]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dea474fab2fab211a6cf8c12cfe8852a310f42c54ed03e874749b9cd7e8f93a1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__59e309e08f8a4fafbf6ef38c39ca6592c1e89ddb637e63e46de9452ad3bc2955(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientation]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ae71ffe781d672349fc086eced6a428f86a53431f3767b325a6d3431010f05a2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f0bab730b7f61918026d8a46dbf9371fa434f9d19594f33412759c366c75eefc(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationPortrait],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fe6e71586b55588186e177626b15274c36c8fa5bd5444ddd4b9b2eb137e2a3b0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__04a3ab523336906b45fc184ff2fa139160eccc0720cb9c983a4a56f3d3f4f12d(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientationSquare],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__30d2d17f7f6def19b4525622e6d95c758cefd5d670866aaedc2b5e263d017830(
    *,
    colors: typing.Optional[builtins.str] = None,
    colors_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fff4dc27342f4a5132d1c5cea1496d6ecc26b86ac3400a8778158d4b39c13da7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cb9ce707a90c7598ef5dd285e48492e5e55695096d3da1df2ebda759aa28e7ab(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a64fcf5cd51c7db926ae040fed8a47ce1ab259bfe938a8c8c25a0c47a33c0a57(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__621ae2ae134372c17a520af81429170616c61812ee368a5e2d4cb30543f47c5f(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6ea2f0fdca40a065ce819f0269188593d674b4512b9022cf412ae9e5a8c63ad1(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d85291f923eb5f736557d9668b9d8d3c15f643233adb4355812afc28d6f1a349(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitMaxColors]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ffdafb925a118335dca8a111b1d83d3c216477c730df5a18369392cac93a1fd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f9d94418713db31927400e05e2b6b7f63aaea1fbdb13fceda1ae2ba3a9a36560(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__201eb2fa03d5d41d89da6ec3382c23f433b4b8deda8d5c0e739261a12026d362(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__24711ef2b4b11f31ede0aeee4ebdc598f8cfe082093c218eaebeef0a2f103094(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitMaxColors]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f034281e0000cb7a1e5bd20fed59f49d15ef87782de356418085ca59b7e02928(
    *,
    horizontal: typing.Optional[builtins.str] = None,
    horizontal_var: typing.Optional[builtins.str] = None,
    vertical: typing.Optional[builtins.str] = None,
    vertical_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cf9101bb70294e196dfae95d4fe59dfefc61d73beb05975791f025bc61ebf378(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__38b85a00570e43a0b5a45da39110d2c3f348404844d5ebdbd2557b8ccbc3d9ce(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7c5773a18375af22c4ae814e79ee029c73d783764bd178099d961cf9ae3483d3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__71aee85f67735d4afc327d5d5a704164a807f0f985eaa8fc521fb0cf6e55b83e(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e4fb0585c6bef31c10008ac691f574c1fd2e4f8745f211544dcff34f2fac846e(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac334391288c95cab1c8fda995eef2490a937a9a904f36b3e45b8881e09607b9(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitMirror]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d95867388ee81fbedd4c0f214c3a2058f45612f6c90506076f8b61037be0bdc7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__66829e1390bdadad8e6ce8f5fe79901a35c8e4b838968c3de5b4263422244482(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2c4f10b1fc41f8ceb4216ab2d8207585491a4448e537d165338e638eea65519a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4b21c97bb0b496ca132b2f5e22937e09bfe7d0b4719ca7b5062de6f8d92549b7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__60971e0c8a354fec595c1a29653bf0ad18c7210ea19066164d015932f5d1ef46(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__59b238247c97648f00b364b3ebf13475225a1ff5660430952283340070b725fc(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitMirror]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9b603c5b98d9ababcf981391d0ecb236db98a9d2ed0a5157a204cbc3f8186b7d(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0595c823e91e156559a85354c119520daade14d4d69a90e48f9ebed45060078c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd3d067bea40590e920ebb25ea634fea609dd0882a5506332a6e3bb64dd5e714(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__07b238f3149be311dd4ee5dee382ce35cd50c5ac6da195c6b95b6f286d1e0d99(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__33edc83247d9a324d1c90e23837f765af4e184230470a50c6be6d2a8f74c35f4(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f53e07b6a2fb409f34dc033b7b59e0e723640a84c2341da1874a3f78d0672038(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__45734b9917091bae20271f6cf77f27bf2b974bcb227230d50a46f02b8cc483be(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitMonoHue]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__01d8fc3cdc44517823a23f2f0715ae2a9d03f2e0fe6a7d154677444da9ba5b5f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d41bcf50e896f6babe51049bc58480570a37aefcbb279ffcec470ebf99b80be(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c06c1d2b2485795992e2a4fac80bf676dfbcc67ef2361ebec24e317d860f4f59(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__05238f8bd8b2ef3ce1e57cd4d9313ce67e1ff3e8b1eeee0c35b186bc7c806c98(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitMonoHue]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c9cb29260705f21d033e5bd7fb15cf4d1f3fe134c55e040d7b097aec3cbf3dca(
    *,
    opacity: typing.Optional[builtins.str] = None,
    opacity_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0268f63b5eb245ff6df4ca413e95bf8f040de28420c95e67a3730a4c2124bd90(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7e587c349b0f4050572bdcfc1cff1ca6fc92871152f6f5517b387deab679b4d7(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e431c033ecbb8ebc848dd353d78f587d36d8f23818b4661c06bd682121ae2409(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__067ef0ae3f61462510e8ea4ff5ef87ba09035e341d9240ece0c139abda95a727(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__619a41e8a0416766ab5df929fcc5c13c6ce495352b939cd8673edf1b3f39f33f(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d0dce92c5bf89b48422e49f732f8f6c3bcc99f92c7c47572eb9fcc38d02c8aa3(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitOpacity]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8fa99d8768b49a989f3847026adc6376129bb3c28119bc4e8ece1fcee7ad3ef9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4bfc5be45eedca626512fe5d4b7c1cd6d28f6a7abbb1323ff94f99876cdc4368(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__365c41c6ff67fbbd025be8b08ebbcd8f1677eef432de2348d87e06f26637cb9d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6730dc587873643fcf3b5922bcd181f1b23fa24942514a1d388c4733b9bc71c3(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitOpacity]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5db6f46a1592444fdde033331f98edf420bac3407eef1ce6c2e3089a6735b31d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0c53ebe126da53fc7f2946d4676b10c148c7bd7c66efe7285cf98aad46e31255(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f57a565c506e472db2a8c307b9f5286fe84f3db4260ef44a8c1004241811958a(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitBlur, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d98c53c4b41bccb325a93e23600519b70cb5c359c9dfdffde4dd326837484f87(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitChromaKey, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5c0816240dd36b959fc268dfbd163874b4005c60e3fcd924abb7663b2a6e725c(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitComposite, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6550e61c9eadd25c8ca1729be82806a108053ed77ab44800bc4f76e3deeba579(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitCompound, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__580ce156465a9d698e57a26a89012130347683022a9c270aebae1483a83688d1(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitContrast, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9690de5c964e2c4762abbdd656191483f69a4d5ca902e2388e0eabc130198cf3(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitGoop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e12af74dc8c46b2efe94fc5f71706d1483d16e7f86763b25e0f4750e0050e19d(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitGrayscale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a796a4ac9892b3fe9da8c9a6df16a75db7b771c67ebdb99cab836cf133c28754(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitHsl, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e8bc488c248964bc9f68a1e5143e0e6e094d2593d03b111f6164ca7876808f7(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitHsv, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__06f80daa88a802cb2e259d944febc030414fdf7ff706964805fb5b0a7855c191(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfDimension, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b6f9ead83d538d7e0e6a1851ef3b578f6718b738022ba9bc4aea6859d7d6f953(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c787d7f79f308b2d04923a8b06df4dcfebfa1a9f61cd0b8ff14787ededc4fd89(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitMaxColors, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f7024d368bf80fbfabd5a9aa2fb3e1e5218d2e1faa530c92b07a90f5f44b23cd(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitMirror, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__60257a6881984d60115e4be29b0caec39fbcec631b1cb6f52f26dfae320a91a8(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitMonoHue, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4d61692e7096982cff60016e29685408bc09ded732fb5af88659219c6fe8aa4d(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitOpacity, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e11d332d6a52bb1d6c758219c0f7f7b4af6b022751dafda461ff36770bcf6b5b(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitRemoveColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1faab68dc48a0909617aa3b19487e82c101572aebcca0fdb55b8a1686da178c7(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitUnsharpMask, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f544876e194b61820f3688a03410acf5d217dc81170325d84283bea45868ca2a(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortrait],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__64e86d93f990a69986a7c091e6d67ea10326541514fcab77d6cec25db7998acb(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
    feather: typing.Optional[builtins.str] = None,
    feather_var: typing.Optional[builtins.str] = None,
    tolerance: typing.Optional[builtins.str] = None,
    tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6773a9afe0291121f50821848ed2cf568be62ba58e6d52844bd523b6ce68feeb(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d2edb9ba48fa624d56f9ecd7c7833da20349a36ce80338fa7f6ba4ced4083c81(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c6b95e4f5080e8894079c8fcad03f99c44a90275a9d31d163fab3ab73227f6d0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a2efd7e338dbcb61310f80a9476a2159c887ce5e40f658ef7c8450ea1dcbd7b(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cf64444719efc8e4f2b3e7fa75a2f2f060571e2fba61330bd513247f05bfd0fb(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__434346d51fa7875e5ea99052b022e8e1377d4fda40091cf9556b04685ce72609(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitRemoveColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a95454ccc5732fd2c80b92b5f684127d697185e4840f0c974a23f20d4841259b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8feca5784f4376e268ba30cce228632f2b18825c0850267a594bdb79651286ac(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__002c0b8156b0d639d2d814e732b30824cc27f41a2a8a759bbfa30dfc15c7577f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8e9dbbdececae0cbde65af12f738a1e211f04f66b2b090efe60d176c93051e96(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__de6668c745d585463397133473174367ef180f459090ced8398bf8ebe8529add(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a67d73cf74c2d2c366764f4a204ea9e6fafe019f932b1bb0af542609ac147ce7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ba84969e036629d9854fb35bd627930f774a823f3e22221ebe582921444124b0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__090cfaea2f5166fcbeb8710c2d305f1c434f9afcc658488d71118197b0f1a542(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitRemoveColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__716738f6b201c8870463fb24aae1c00561750a590a7a93ade226a28ea11bc442(
    *,
    gain: typing.Optional[builtins.str] = None,
    gain_var: typing.Optional[builtins.str] = None,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
    threshold: typing.Optional[builtins.str] = None,
    threshold_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e9dcb6c19a6bbd4708520beed68be1f6c5d1a6c274ca935de5cf55caecdd122a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a1c2436e0933d14d67e2ab6b2a7d17619540941b897f2cdf216623152ca0f8f5(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d8d99bca686a638a8ecfaddfd67d9b53e24f1cfd6030303906b7c76ace16f52a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eb6844b423b2b72015d0b7ab607baab40be375ce58dc3997adcdb69a5ff6c32f(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b14aa9f3b4b00c06202851769dfdd874bf77886e4b5e51fa6df8c1127de88f66(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e3ea30b6afd6d54a32526af734eadc54c2e93fe468445dba240f36748cf5a717(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitUnsharpMask]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6af0da5826c3ad5f13013d302bfa9a360c4fcef022447875478fa2778e21ca49(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ed45a62beb1baebebcae058a4a0b920604416ac5f66dbae48b3f25a2e7e191aa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__24c439a461bef68b415cf20cf492c5f6642aa61e913a95bad1dcdba86d215a63(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ced94df4fda9099b128b0e6ca4880c5aebb22d791a45906999a457678cda975e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb5d390ef7f0d4096a33ba4e23ffecf5b1b0b45e6872c16336570443f4aded3c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a3725547e04a6092e2df70a2a0affe18481c078af074321ca1b3e97bad56997(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0eb7d8fc80cd74efc499cc06f2c4c04bae68dc5e54bf22f504021f8ca749bff1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__13c5b8cd1975489464d6883f44c55b877fd755686a9048897799a093f6e77ee1(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationPortraitUnsharpMask]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a4bf2fbe085084b498aeb1fba2a2bdc56ebb66ead418da87b8474ced78e5047f(
    *,
    background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
    chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
    composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
    compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
    contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
    goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
    max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
    opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
    remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c7532e1e1d3cd5d2a4a6f84c5a95d066608fc490007ceacd79178c26b8e846fa(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ad9ff46cdb532f5c74cb142c70914886ce139ffac780d3dc6f7757ef309e8226(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__01cc90286a241b2f94cf7b14d74dc97e236761c68dedd2c7c3d9d76ffb670ae8(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__491a774a4fe91e5f11baa7d033cd71c9c4d9051ac8003561012368fd0e80ceb2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d07ccddcca82b9b41a59dce17320fa6798927093b4bd932a4496bdafc82106be(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ce5f863ff6bae93fd4c089e34f992f6733a4c233da32d7a2d61d2faf529bfef(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__19296697db44d34a7cc1a0b1dbb625d5dd50abb9fd50b9cf0ff96177890b980c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareBackgroundColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e31ac4cf588945e9a8389702579a556547c0ed7d7947b8424d5c120e6510a429(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fec28fb096a89e081513ce90091cd3b29065ab44ff3dec0a30c4e818cb2f840d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4703a129c6f8a04762b809a352f200e6aec0320f80aaa6b46f612ce9f58c37da(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__14720fd43303115921f193de05ef8041c2dd0480749dde2349a28af3dccfbf79(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareBackgroundColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ae835f28c30d838f77ecea63d0b850276988807ba890581a97cd7b66fd03fafa(
    *,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__489cc80855ba3dfdac2beb27b01dddf2b8921614b8e9a1abb6af84317c094484(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0fb3a463f62666d58511382a4f0aa61cb89210cfc80179ba33093a33ed4fcd9a(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__86f616d773fe91222b8870a50557c8a6ba7e25819d0ada8d2ffbe2d33653ed80(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__74070f0c5a1ab2b2dc12d6ba4a0158a6c772ddf35e458328fd51879e309efab5(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b7c85110b246faad8e28d7faf10972ef33b5ef84a52592df5808cbc3d61e5696(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a9eb5870e0607f1b08acc04eb9214f2937d9c22ca14094db0befa4e07e08db59(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareBlur]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__584dabdf3c4ab166f5ef06d08f0dc160e62eb646f9648d601327a134290a5ca1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__756e358232b3cd1eb8f55397d7087119ab73cacb8f8a3582d0e94bab791b876d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b9812c4aa3855f0013dc7721f89b9246164edd742f786fc879e02d284ffce206(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__041d43302eb0597cda1ed1a053aca73111cb24b20c89881dd9203f6ff33b0fe0(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareBlur]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5de568ea5c9430289cfc8834503287c162189907a6e6e116d410328762b2b049(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_feather: typing.Optional[builtins.str] = None,
    hue_feather_var: typing.Optional[builtins.str] = None,
    hue_tolerance: typing.Optional[builtins.str] = None,
    hue_tolerance_var: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness_feather: typing.Optional[builtins.str] = None,
    lightness_feather_var: typing.Optional[builtins.str] = None,
    lightness_tolerance: typing.Optional[builtins.str] = None,
    lightness_tolerance_var: typing.Optional[builtins.str] = None,
    saturation_feather: typing.Optional[builtins.str] = None,
    saturation_feather_var: typing.Optional[builtins.str] = None,
    saturation_tolerance: typing.Optional[builtins.str] = None,
    saturation_tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a1505d2cc5f071409ee7b818ca4e2fcd288047555b9d4a302954ec8a96e9631(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab5c2e38afbda9a27e8c3ebf7d3c20207fb37802e2ed2a9380defaeda18c9aff(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b9f75170e0acbf22a554250adddd143d310d55c7e8e5fa475857e0413e4652a5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1e4c678a878278bce2dddb5c5a6184137cb81014e94873f730638f788f33c552(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3e2d7f8afbcd49e15392b68f21fd99d171d0670725a19e07b47afcd2572b4da3(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5581626b39de584f5ee117944144bed9f00d625e0ae278321588fc02f5d54108(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareChromaKey]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2c5b32918f59afe8efc6d0b6695d25cd4d0ddbb4f689ee83f07dd8f00da84941(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ec4e8423f8432cccb19c0028b022dddacb06a04bc35285fd5c4cf4d16ce1601f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__52f141d42c77f75c4d9746f9fc029639507d7279c37464dc4261432c60bbc329(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b6c2b25bacf3ba0877d8eb0ffad1c0cc20b2ce8003ff9db3c130ccb74c772d11(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c5f72530cc0009b57b400d20f2060190b198739785d86c924cc2a9a2cc4bfc3c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b2e9ea51398f267f4a6d2f081151c36c86085ca66d061aea48ac490c1a748c2d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a212c30e6f3968f16fdce86edacd4b56f119395d65465abbf9e6888485d0acc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__197793f36e98ccea9634b56fd2dfe591ac677878f8fee4a5fee826333b82f9b7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__72a4a671cf423ab7481f39c26dea165be9be7e5e80a29db2353f496bb732bb40(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__017e351d3b16f7fb610654ffe238ed942437273a5c7afd7e050565f9867287d4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__18a645e46a0274f953587de7530ecc2cea64b20c05880ac53c0451ee987b20b9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__53340bb345c0d872408971a94aa34a82ec29e15152d0eb6c5c84c27970b5ae6b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b66251e8706e27fbb27120bef7f9cd78c49787cb492d74f8920832a75304500c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7c5a48b07121acc4fc1da54cabea7f7d86578206b856082a9b852c3ba4dd137a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__55e5238d6759828ee0aa5fe7d281ad68b91f04588234dc525073853f68fbdf67(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c8b20cd31feac89b4be705319baad54837e493ed2daa439e53b1aa6625f53127(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareChromaKey]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5c768a0b8178cdbbad6eb03e5ff4cb7778fb6dab9246927465707cade774e859(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareCompositeImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    placement: typing.Optional[builtins.str] = None,
    placement_var: typing.Optional[builtins.str] = None,
    scale: typing.Optional[builtins.str] = None,
    scale_dimension: typing.Optional[builtins.str] = None,
    scale_dimension_var: typing.Optional[builtins.str] = None,
    scale_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__496e8fb75583ccc2ed8c658219156ac1500c6783492544dde3fff9a10a14d8d1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f477996636e8e62cde5e28162d7c51b52fa4747a746445850c8eede1fac3ce1a(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareCompositeImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ad57a3b9ed42afe648d9e282c99f4696f3c074e526cd7b7bed869d97a188eba4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1e5f37e27c58087ef865e442af9520efc672706fefc0fff5735e649ff1274728(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c1a37dbc0f1579ee00c102eac5ec2f5490b0173e630390e473d8613c656abe63(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9e52641930d6cdd86b1c14165eb17025d6f0e65a9e8e05cd3e03857c03ab933a(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f425641cf1d1461606fbf795b832b97dd0af405baacbae626b6ebc91d1df1c9e(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__05c640bc2864cded330d71737d0a70812b0e3a9811721f4d73ab035847010d5a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareComposite]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0001d5fffc66853396c52778950d3d6b2eb255f1ba7d1288db1ce53870063bd4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c7ea3510c9003c70fbcfe947b08427a5bd4d0d4619aa8f6fa1580fad65d8bdd3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0225118ac4fcd38c09a1f9fc34894c44b269eb812819fb5bbcd54a91952a103b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d5c821f157e38cb8345c087d371e1828d9502997455a31aea3632ec3468d4037(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e9b8bf6da3f177fa20b9a40f6e43af81e2654c17701386c5965bf6d8f1f88762(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c8076e3d29dd6d42b448797ae52c14dbbcac56408224be1350743e580138b548(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fb3eef524a9c2c1ccf860f9f898702f9a60ca140fa472e9ce001b765f513ac7f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__74d0d2d38f9c5d236ae3212ae79b4f466dd547ca0434425234dee8d5e25854a5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0c91dfda5ea55815838bfe40755ea177f8009c52a1fb20d9f80019c423d60d5e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__58cea4fb10afe7cb25b43715e00b059deb03d93bc2c873b1b8b2b380035e5fc7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4849cd1207fe59a320bb081a2e8ea1f91d7d04ab3d8d205a5d7f77829cf190ae(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9b7a8b85ae550e9792a614e0765c72004e553cda4d1e386fa6fc4ccadf500b8c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df05e3b7b8ea61adb1ef6db1804c825d7a62458d327a3d51c87637b0de1d1968(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f1d0695682ffe8e2e2a1a983628443fc0daaab28bec961e4fb230417d4b41aa2(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareComposite]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__34976b813eaa2268cb13e45ba43421c8a06ca137baf3c60bfc416fb80180b680(
    *,
    transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ff5f003b88aa895c9517518e525c158e19d5fecc3a22c5fd3778f979d576d6b8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__11fbca7e8f7287f80f183d993ec2f9232df70606ae69e78d2094a43546bcba3f(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b0a5209eb3c06c0b23fa33f4ad24094ba0f3694f669aacf22387bf9e87e37229(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__74cd8eba5d7c0cd76d0a614075c56fd4477ac9a0436d2fce896fff541a3e2344(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__76ba30af4ebeed8cc508fee88023065a5de3a306bc3486d34522406b66a82113(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8d9a9d741de24b8e082ef071b535d778cb8424dbf246deefc2cfb501776c6d94(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareCompound]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c196ed2db478cf0799420fde97ad3119f4c02cc5e7f52a6c9280795ea5ff6d86(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__601edd37ba8eee4ba033297f671d4dc00bb4c6812c67925c6407156468168c1e(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1ad28f22ffff42f6a3b8cc510bb33fe7da38d4d429c799836c73220253f64015(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareCompound]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6ff877ec19177a06238391c83636f029eba6cc63e1ed3b994873e4273064a465(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be5fbd33d1ec5f3f1141c684a7d5051fd803503d8ccc4b358a091a11e94acef4(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c8909379438c9f203eadfb7795428cfca24be15950179814b30878ae1a28ade6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f8306d1eabdbf0d88d09cee6c8ada481201fb686627d486e3a93812eec8fb202(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__026ffc93ce6d39e68173d3e05e030dd6d851a269933f7e16e98a6e9daf92da17(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__39d5a549d0b2c90cb4dc6777d913e70cb648bb538913f270901ae15b8f9ada3e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareCompoundTransformations]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bd66b7b7c05b072a9a3c523517d03cc9a2c684e80f067aa18ef400a4add44fae(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__59a2c3cf1060896b38f9385bb5ab6c46ea098982d0270d6725e9255ecec3150f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareCompoundTransformations]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b873a1a9619fad9dc67b5891b7eec49e2088cdcf515b5c12a1a8e11c01de0179(
    *,
    brightness: typing.Optional[builtins.str] = None,
    brightness_var: typing.Optional[builtins.str] = None,
    contrast: typing.Optional[builtins.str] = None,
    contrast_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0d49a0ea7248625e2408a585a15b57cc7552770149115c69e2d5f0e721732d89(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a9312d4af0cd03a6d62be63948d29eecc650dac0315c922bf65c04fc8d004c20(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eede703525582d3d414bf563a6c5af0cc3bf992e9be5126695e56b027222f93a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__98f6a6cb45dc3c97c1093e5bcd14db5ef009ea0e68728ab28e2e1bf6d5fb8e46(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__91c12f18f4622f03d40e61dc7168081177c259646bdc9e28bf66c6051e5831e4(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__360c50ba262e77a7bb070d509190c5f4a2785d6c94917aa7b2281dc938aab143(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareContrast]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4507b45bfa5408e6fe9e7d983836bf00edfd74574e0b45e5c269d4baa8794fca(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__62f0abc232a31d94246d08043f9701ddf95f47db93c53c8c31d8405f91da03a5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a8c555270b9db6ded63f0011545a709081ad3a366a87c497da0458cf2e5e1c77(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ef3d62d3a9011a1927f3875c264260b6e52f4726f5733aa3964f725ff7812891(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__00cf2a6b072f89c9cd4363e71861e39068cd8ff193487643351fe087ea70fbb1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8c068d22026af9d48b54d8440bc9a2c40f9b18c1d1b9b88b4ad4706275902992(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareContrast]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4bf14a601d8e66e239c407d1300881218a5757475d8124458467177fec013b39(
    *,
    chaos: typing.Optional[builtins.str] = None,
    chaos_var: typing.Optional[builtins.str] = None,
    density: typing.Optional[builtins.str] = None,
    density_var: typing.Optional[builtins.str] = None,
    power: typing.Optional[builtins.str] = None,
    power_var: typing.Optional[builtins.str] = None,
    seed: typing.Optional[builtins.str] = None,
    seed_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d55325d148a1da8a2d33fd5dba6c79417fa0a07af6205da14f0c531a4d89b0b7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__79996e81ecd8bfe87f0d37eab5a288b72c8922f454f8fca1e179cc6024159cbf(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0c54015b52c7ceb51c721f9cdc033c4284d27d14e8e5ef9b632f329aad3e6a16(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a6291d9b0fc75edac63066a706be0e1f2795850838d2b06a636cd41e1a8f69f(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fe8c3d5d71f02cfd44f5ad1b085c324aa23aefec561ac2af6c0fcbad6d60efe6(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c0b7d0747e9d550e7b24426c3c1096c712d6f20881e2ccf362c5ba703112d461(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareGoop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__18d752bf4894c821caeb4f7e15eb02398a2331cc13312b20cd38d836f5d80907(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c80d18e18c044ef435ee1e75778232fb720db3929531f13ab9db8283b17d0d6d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__32ae99ecbc0645b3ebc6bd77162da677481caad31186cd812f69a8a393c90377(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a1b7b879c78f177e0d710325ee5b3666d8b6fb1cc6b3c99ece787d53ad59e4e8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b627b10ba6f2e3787c1d90ce312dd91530df8fd6898a6f27fe9ad87a4287ed43(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__71130159417795bc3615c8a48f0011b1f2e098557c2cdd8e31b553834376acd8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e98635c0c17f4474587aadb1803347252d40ce041d42bfd903303b272a6a7e03(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c8cf88fc5ba8f6f886e0e98edd557c89f71c903c815c925192bceb336dde58a0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1487d576a5acc086254c9df0246bf80db712630553a8aede57f204dc4370731e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__20eb7369450bced20fb082095f8dffe15f4d364f8b9a26f36a5a271d51fdae7c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareGoop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__003d4fd04faf555669a6736927b55370c6174ab5b6b6f3b4f6888372d6e1e2a6(
    *,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__916d3c4b1db01f5d83a8e23f564482411ff6c1f650f769320865284b8fb499ba(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__07896e602a80bbfbb627f3a13c653af1d535792c7c4462aface135e12b95e942(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a80c9a0b8a42c67fb71d45e61d6dd0a278ac214e9312d80e7d42377daf8f54f8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ae7dc6be09ef9b7060d488bef1c9f334c946f50988f8e1b15c959dac8780d0ed(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__386131954b68aeff16c341341c34cbd9f569750badc8d8f8517e35337ff74bc5(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0a7efdf7938ab71538c92bfcf281db05529de5f6abdec128e72bd666a3f2c3bf(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareGrayscale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d2a528b93a574249e7515039597cf3a25012ee226753959a5ffdfd4f506b67bf(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f73e672a3b2a09df137e0980888f3c94aa704a7b1ad69a5e640b98e1978ad49a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4c3dce7f4ae00a2cfc5c194579e3be228417aa18713ace791151d2877252f893(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__81e5758ba49117bf8efffa4172081d71bdedb409149bf277858b94f8bd9cc19c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareGrayscale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ffb56915e47de493aea92a593d1eb0a180f284062cdd4475dc6490f3d026cc88(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness: typing.Optional[builtins.str] = None,
    lightness_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__043352af7133f047ea4721d18be51f65737e37a29f7ef739f0a3f0b7802d006e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f039e59de686aa50f5674b6b3f9e8089ca4cb04dd312f2d37e2d4cffeda60491(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a2143bd217a3d92fd7c693c05ba734d6378f54ffd532089527def1d73ddae544(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6391373a658deb06963ef9f04c31a9592cd03e96613a8b37fc7ad9ea955c2edf(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__648f0819ad7588c08fac6672125adf244b43dbed9e97f2bb4c48bd318459c20b(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__416a882201e27ba4a37dcbca90b64b66362339cf6fa8dfee7a48217ab495c4d5(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareHsl]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eb790fe14d7e4bca4f7a11cd8a7b5152a449730202c32ad3c76217e009a56154(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__72098c445e283880b678a3e0245b58a7f35150042627025d8e356be678e4eb44(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8e43c359dcf0f38cf4d1c4620a11751114f3b1b5935844f04c6fab7ba235326e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7f024ebca18375e4f6615a93ab4da58f2f3005a34df4b7d95e7a7b1fe8c6517e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f61184f5e10e5aa6bb21bd8fd88d80326aaf8c9fdf77e429cd919aec569e134b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5492b316c61cd95528cffc39359fbeb6f2fa958f16fd27b06211603143550e08(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__944d22d1b3d1ec28a24b2ba5b8d5fb9bb4f59f238841bbf8ed6c2cf526df7931(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ffc47abd5f3754e8d6690d64d2e35e9164571e738bf7d386d3662c584702c72(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareHsl]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df04ce0801d90b3c75ac726cbd79262a186efc10e0d4a03f225efe47d124d5e9(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cc2b0591626d73c326d4a31b8b04deaab071d3a938ffbb65539238f83054b507(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__95f62a431a0846b1bf2c0097beace99db5d91e6b8762d46913006b687f388dfa(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b5d172180956b2139991660f85f74a4069a7752dcb606dd27d2735960d9b3727(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e82b079044c486f24cce43f1ab2dd910b4b0713dfe827867d5d06b1d5978ce2d(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5286b2dc052ff5bf1cf4d3ae0078ff73c78b6471b3379ff56994d039bdf5e222(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e6ab6a5c9224f615eb3c29ae0a42f70d5697dadade878e0a2116a751db409177(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareHsv]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fd6204394cc3e418b0c82c171cb7c9aa1bdcb2b03df3f4a277ab074dd319603b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0a3c1ddb094ccb09eb3c85c4a311e792e23cbcb9506fa08df80bd74a5787dd4b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__493cb16d08371566a8710b6f7fb7bbdf8630e119b7b13c54c92d74c1e5b32d79(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fbe57dd930ea1d396a8f47c1ab1ef35cb7a6497a5122532744706acfdcd012c4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__21226770d890686a378ef6082dbf5885fbe1342d93280e3ec645ed8c6b7b36f5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c191fb7179181d6357ebe161e170813fd1fc39beb0dab386c91e6b4e7fdac206(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__799ac486e896df2b0894a9df6a243dc846023846bd9bc4154445e14de1ce8e52(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b0aa5d8294962ab59ac29ff7d5dfec98de871a33aebe7bea482741f4d077936e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareHsv]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc1bfc4c1225f41f14fc155420bb49a71268a54cbadefcb78bc28fd88a198b95(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    dimension: typing.Optional[builtins.str] = None,
    dimension_var: typing.Optional[builtins.str] = None,
    equal: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionEqual, typing.Dict[builtins.str, typing.Any]]] = None,
    greater_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionGreaterThan, typing.Dict[builtins.str, typing.Any]]] = None,
    less_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionLessThan, typing.Dict[builtins.str, typing.Any]]] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__763650e7cf930c55a3c49b766ed6c448f288bf6596fe7f1a1e102d6c5aa19794(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__09a11497345dfb157dfd384836e3aefd71f3c4b8cc2062f482ac9e34b6fa3778(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f3b51448d58b95812e43fe616b22ddc16e0f64c2d8d535050bbd9f895ba40c1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a876dfa89db48501e71703af1861987620afa08cc39b37697ea36f2d1dd60ddc(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionEqual],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3b0db3b0285dc67f3b5e9ac6e7fe51e0af975a5af176cb2f027b7d0ed1324d03(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0d82a7fbc9b4d1c4a18ff377fedfd3eeb0a908a4109db4e9093fa6d21c50209b(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionGreaterThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4521a1f169d6ea1dbce3315aac6317012f1764128d4387aa3dc78c5b95140023(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__33580ee3967b36e2e23e2c8a3869c98ce78d0464f67728a672002e5675e54291(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfDimensionLessThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c4de812e21e3e8c22c7072a0db796b68891778dc63ca3ff6bceb9f2dc2ecab90(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7b3c2456f58302929cc52ee3b2f2ca86ed41c8fafd35028a72640b911861f912(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__282f2d0ca8b9d98e7f02f731497578e4fce115df56601e2671af3d12ea6d8f36(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__596bb6b8224ee3f56a500fa7e4d7bb45ada1227c4f276b30f19f86c2c3f79b91(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c8b3327c44289d3c50768b491b883a25e0932d5139c1f427b9e760d30b22ea1a(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fe50b00dc778007522e682d5ea7d7a9c2ab9c6e2938fde14dcb37baa8f677b67(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfDimension]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d958e6e8c8de213bc3c3eb47da7377b86fce8a0c85de134226fd2c18fba379f6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7b3a5928f7c92d4af742e967c4840a881b3bbfb21ffae50cd8cf7a94537be536(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c808b0d589dcf8f63be064aa17582b403a067729b968b0128aa4ceaa0619ec3c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__47f2a53ad42a61d71d7de8007b549b1c63805cc356d31a368fede3f775adaf82(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b53f2dcd46ead972e8cb0d52bfcb1aa5076cc55301eae290e9375f2cd9395481(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__39cd3ac73c4b2d2ce2cd63576a23960e3fb2193f9cacb016a1e660fdd7459486(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfDimension]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ff8e08bd244357291662518da6f04344cc02cd481c29d4c32deff736b106680(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    landscape: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationLandscape, typing.Dict[builtins.str, typing.Any]]] = None,
    portrait: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationPortrait, typing.Dict[builtins.str, typing.Any]]] = None,
    square: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationSquare, typing.Dict[builtins.str, typing.Any]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__996fa3c8c221fb2c78e53fe7a59813f696aa5258660b6d23db655879580bfe24(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__868d58b2bb69a8aae2a5fde713ccd06544e8b09329d8b9e892e333fd12cd2574(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1b04400caaebfa5e86f334a88f5cd35296772a11cf45acb6e2f6684748745f84(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f94b6bbd0487dbb071fe55e77a59989738250810cbe8e02fda660b7a76ccacce(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationLandscape],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f6543043a1c023049df69c53829a994a59f8ea5632de9d56cc564a32ce042f74(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__03ded372fd244df705aed20c58eb3e22132a01bdcd7fbd6e3a38dd9f98352e36(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__afb2eeeb727d52b1531df11a075675e4be78d4926257f203a49eea409657a9f1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c6e1f03eeea36b128fff80fa6c95f3a2961cd05d6ac007035d10186e011f154d(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__030c4da8b9a8e6406f9718f1e99822bfd0aa91a1634cd84bf702f6b238235701(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fb35b9116c5fca811f5af860c15b2ad4294ef66156c9b0ed231fd4d3c16a7733(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfOrientation]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__615c655888981574ee05e8d1872fafc3ac030595bc8aed217f10646b580f6118(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b6367061065cca6763e9d3f54b489195e50e20b61ed6ee1f8a268530674d27a5(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfOrientation]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__31623efc3bcd3c7260c1e249d488c5c35fb477dd453b752b1aaa0e9c156fa173(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5103e014609480813e361f0ff279bab57bfc444bbb506233fcdbc83e36cff9b2(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationPortrait],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c8ec9b1c865a1f29c38bb75a8d8efb9a9bb6aacb7af6a839cad75e067b146a63(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a99afed6e85c00ec108b1144cc3740fb995437b661b1c5d9a6da0df3d434d820(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfOrientationSquare],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bf2e878b804d926a8648278ecb6fa40d6e0b329ca018dda33d83723cea7c4dce(
    *,
    colors: typing.Optional[builtins.str] = None,
    colors_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__29c058cbaf0991b706b84b049f3a79619276f7d6499c033032dafe8e881911ac(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7a638213ab66d5a59366dd32982ab51344f0d26532974b254eb05d286e100399(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8c10bb9e1db22b143906b5944c23e6b89c10297085158fc0849db6d4eee12289(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__99775a34e0106caa849214c96a58dc14aefc54aa9da1d4d138b65dc602cc7f9d(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__011edb2bbcdc8bae35b844512d3e10179f53769b960d5b4e078690b69b318868(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8ce8b8804459e5e4ffd7700536fa1a1cd777854717cbf2b5b2fa539b35e67270(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareMaxColors]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eef9f15b582837ca22abde3c3a6be8d162d5f1b0e3a744704a87e9c9e9392877(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6c472cc621d5406e5a525e9fa3887f07ed2db05f5d74cd4c3ee4aecc46479565(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b9d4f7a365d6877f17cd2b7cdc4ed4b5de9caee8c6998656cd371bdbe98f4319(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3673a8fae182999bff86e95700a205d9a50e7ab32944aab90fb7fd6ae0493b3b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareMaxColors]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6cd7e877a303ac75ece7d8f15e3d362cd1e63d95ee2000114fb30112e22d6520(
    *,
    horizontal: typing.Optional[builtins.str] = None,
    horizontal_var: typing.Optional[builtins.str] = None,
    vertical: typing.Optional[builtins.str] = None,
    vertical_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f705ea4a787f2880b71f0434274eb9465b4053c6e3dba089d7528b021a67008(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fa06ab2e732e425bf683a7f88243677bc750d236b4f5b628c26b93985d6240de(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e3d6912336a00e0f7e58f25be35c1a8c492c2aaf267c90256d78c5cc423d49df(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ca60459d411618cf51e0a80975abf38ef1ea7fb7f708a6ca64a373fdd9fd7bf(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6c0773f44ff93e57399d16d3cc4dc56c6e7548ecff8624ba37d843879e847732(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8ab5c7323ff499a7b25c00b14fa6052d6aa2ca7ddd4118f87680022a2c15babc(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareMirror]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__14bd3e562eb8640ecf987517d5c84a91883ad00a3244949f4ab0887bd1009c82(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c689b4c439612fa6e155d0f3e67069b2719acc5740ef35f60e8ab9d628d907e5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cc0e6d5e7de692126a5fab0475357363fbe7013a7b6744d2b3553a6eee2a82d4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e0c5333095e23cbbd95897a3fc7da20b21cc75bc948353a33c93d95a390ce29(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9c74bc0c8835d1b419a3e2f0df6b3c1a337c8939b225fe9102737b8353d5e6cf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8bb7913f2c8c290dd033dbe3f4fbcf1af5a0e2016c54b02b2f9e6dbf87e0de0b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareMirror]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__59dee7bc0da7c8dca9cd61161b1f03eae3df3713606d70e84d81be366d61cad1(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8ced702f26e50134ec03c730d98ab70e65d673789cafe5316b7edf74809ec543(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__514517fec3e733f3aec2be223b5aa581aa4f1a15c941a980a184eee7b1237d78(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__101b3c696cc239e402d9215c6ee45444c7d4f9bb4cbd7ca08d0384a02b987263(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f565b24da56b6b0dbf7f40ee26e42e690b5611ceb23b70bfad7c0e3b48eb2ca1(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c2cf219e27483f90341d424118b2fcc99c028f01806cceac48265cc8b13c29a4(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ec558e06879f6212d3a556999b58c300b169658c7e8ca7c7c4b5e3b1f89a042(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareMonoHue]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__43c3b184446a569c162b95fbd6ca282d432b880a4a91bac318f4384f17f05629(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3e1e8cf7ca254dae743adfa03e385a81ba98d0b87c9164c45c660afa39ba5319(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1617fdccf7a8cc4ac6f39cdd8fe1927a06efa61f99f7d40794075d77283a7d9c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f39ad0b2285552dd68993fd569c240c0fcb29f50f03360f3471122462c3cc14a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareMonoHue]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bd5a5b44b472ec2ad3e914f46d9aed09c3feeaf33130702b252da06e92c6e801(
    *,
    opacity: typing.Optional[builtins.str] = None,
    opacity_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a8341613c12963088679f2747d7eef197c05d1a1273801905d0d62c6738908ff(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__57a40ee354c9e760131583f0b46cd52dc5f213346d303c9846ece52d03224a38(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8b2c7956bec237b51fd2e717de1426963381f2d3d871939047b5e7ec0d338309(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a81933d46bb7ef08fc2b634ab3d50551f7293d73519d15c2b485b4e998f84b2a(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__630523157d9cd99e40e9368089b27436cd78d29354aacf9688280152bedd5869(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__68914f24f5f6521d13693c5e127364023b5d0226228a605eb6166ad580aa23d8(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareOpacity]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cbf726f21e3011b98cd0634532b9f6ae3e21e2f0d30faa81a3a2d670a33ecf83(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3c8e63835e87075041e0f47a20867b211cb14ff43adc3f624a195e39ced36ff0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e05f5a5f608f44b936888ce0d3fc78d5066e4d0a6a2f9b5ed2ba7316fa0d54c2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__42a8e792ac4321a0c6991ee26c7295650ebdf92e0e5e0102c51865afff408845(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareOpacity]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__396908d9c0ec5bcfd8d6a8c0b93da9bfed73af37242596435fa9412f132e65f3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__53a9e4d08614fc7d99f2c6aff9f5c616b1c37c6dadb425758f344c51d10b9a75(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__297270deeda4c14f02295a582c4ec5a03f6f662e54d8157ad68724ea56893e7d(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareBlur, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8cd7d2f4728a11d88e0e9ab4d0e27e52a88f818b242e057038984b3004fab1fa(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareChromaKey, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5bfe828b8b812a53d6aa69eecbba235514e0df172ea57aa3df37293933808b67(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareComposite, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__82fae2e92e21b4cd2324b3fb7a388381472af28b483410195a78b233e9dfd3b4(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareCompound, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__da8da1986a00e45e58fbbccc34587963f6a735c83b324020b15fcb42cf09c80f(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareContrast, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__acfe5ff72bf3365139d39422e78cdc43c3e5126ff35979875f9c565535938e90(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareGoop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__43876e47369cc8be3870e08a60587d85fdbfb5727c7e08cd7071419a52c02142(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareGrayscale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__12a84beea7df92faa0b2e57c567d13cdefbd47aa238553e244d54059dab206a8(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareHsl, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__720c63fcde5955e6049e29e3c8c80b7d27d7e3c3fc21ec4b246e756d8efded8e(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareHsv, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__129caa3b7257035a6ea0f934606d345966bba64fe64920e2a963fda618ee9e52(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfDimension, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cdcbcaa00c2c70e68d9abf56cb3f9b4daec898286899caf70591097b8cd19924(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fde18d1c36dbe7ad33c5278872ad40b7a3ea068f4b47601634d39b3d6177f351(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareMaxColors, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6620789a8ed35544375cc7946045f8016d02d7c7846ffcf0c49f5c6dde8f28c6(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareMirror, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2152fde975b3609e152c09fb5751040d99492b187c91979b29a8a781376ee747(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareMonoHue, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fd6210896ea2df193b612571f411dfb1b9bc9f121d012b5a33cfad349b50c56c(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareOpacity, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ae404b081bd76742830efc037236289c485858d95b1f88de17ed7e5bdea04072(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareRemoveColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e233531c69c30f8527aac443b6156a3bafdec0690dc0c51bc83f6e00523c1ea2(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareUnsharpMask, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4645eac2256e126aa755c1853dada88b4154b8748b10ffa5c3baf889bc80aefb(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquare],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a4159987b4ece1e25a2b644b2a6462b63bba51457356224621d558bb2e5cb1e(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
    feather: typing.Optional[builtins.str] = None,
    feather_var: typing.Optional[builtins.str] = None,
    tolerance: typing.Optional[builtins.str] = None,
    tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__881ea29020003e5b50ed805b7c44e0297750eb5701ad75c152174009a3dbbc64(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b47a9fc16870f92978c928645aa77af874392009644b1af59e1019f30b84a401(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2bdaddd9174bfa406969ef49ba78034eb62ca66ece329f03cb403c843d675243(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b2c2dca082dcee8032bd49b9b58739210e7f4bc957f62a5162c9a5050d4168ea(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__342d256d01fc6f5831f36abdb44765e84b123c0148d5493ee3a3375836e1f79f(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a2537b18372ab46f2efc58c93c1a2f9ae60221f60b4e67d75181dede045d28fd(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareRemoveColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b9684f05a485775e5d2cc88fd354e115942edbfdf5e602e97d26524fbb9166bd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cff0e56222bbc5f360a86e0447cb886db661aed132cd9801fd5b3d5284f5a219(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9930da6e7481cbe22f606dd796b088f4082beeb5492f9c35a518bbb6d4f58db1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__418a1a91eac7838eb52fcc87dd64533d14d37d53c4ee4183dc9d9d7acaffd520(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c2f401b4fb3a0faa624ffddf0b70cb4dad1488ad66fd69872b9087f1de799798(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dd88dc4663be2a254112a3dfb6ca9036e9fe82ae706b6212f55df52673d39748(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5989923cf84c9a8cf3e232e8baba57d6cd1fef6d95f3804bbb660e001116d25a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5644ed5eed034c24c8263ece3a25933a1491e60a791860fe912a75d98d343ce1(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareRemoveColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c609ee229d4a67489de8a0b1b3ad7554b65c3985d94dbb6d4cc7af0cb868329b(
    *,
    gain: typing.Optional[builtins.str] = None,
    gain_var: typing.Optional[builtins.str] = None,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
    threshold: typing.Optional[builtins.str] = None,
    threshold_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d5a3bb86258e283e401f8a2816d24e984106cb8a5864684b34b55a89fdbff1dc(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d4dba86f4fd725b396b68cbad05d4a0d087332ba5d2a70d3f16bbb1c5f6184b(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__22b0a973d63bf7b0aea51f6f0dc321918379aa4f2c93e0d58d5d520d34c9f837(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f9e58334317fe4e04e2b340fc9b326467cb71ffee100aad219ea45da366cf418(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ed40a635d130eef09db82480d7a0769166a0c114061ca638fd7220c21037fe3(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b2b29bc1c039aefcdce15a97877b561159c7265cd4b739f48acc4cb4cd1b80f6(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareUnsharpMask]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__437ad02d02861e782991ae8fadf931be50167d5dc1f47753f7e9eb5f6885bbcc(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ac3249a84440c71450313b25e4b3c4a40ce3dacbdc8e87ea43b0ce599034806(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__57dd3fbd33d971e3d0965ca21b208a041445bdf8e3a9c45cf75bb1141b984240(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a56c5fa5524647b76acc4e7a0f397902735a44026441ac9f789a5d759bdcc66c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__09bb0bda45c990ca2798a021b323916964adcf91b5d3ac271c0bab97f9b16bf6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d1c336f7bef381d2235d54d193b3f5db4b1c09652c16e7fef71c8cf260e78ef(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ee64eca6223836a3d60f7686204552e6b0890b204d6316341417abdacd81045(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9b6fe030009c657badbbbef94d6adfe2561ba8702dd98c6ec8200d65a7cd02e4(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientationSquareUnsharpMask]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ba680ed70f1976004a620d30a825b47e80fbbb670d89e3bbc29e77166ce99e9(
    *,
    colors: typing.Optional[builtins.str] = None,
    colors_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__319e9947c6149471c2e15231b48d35bc0344dc8d6c5c7627b4fcffd4ec63be48(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6fc251597547fcb0d6572b04cb6121b35fc3139ebff81d3208d6510ddfeb262d(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aa92fa33d7e18368ae8b4359d65c18b776ec7e3bf4583688ffad5e265d3acddb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__66f44a9d0ee447ebe360be34a69bc200ae2cc5e3fa1fd615c1fa1429362898d7(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__11f864e2a8f914e2d3a3278bf1fc92ca810ffd9bb9e12f3a040345c7656b707c(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b8f35b45dfc2678a7a8cefaa1ce7330f44038214aac16d0ce9b90d99328fe3ee(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanMaxColors]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fa33a96ee9e4a24fce9efffb1eb16524c616045cfb2e9ffc2d8a556a3a52d575(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__00546e6819401cc7fce46f780e0425e0bd0512622ba76244e86cf26b8371cfbc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c688913160d53b14e9f10cc303856fe69903bdf3a2eaab005f9255be96aceb3d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cafb0afb54702725d39c0a2d8e7124775e5d7fda9aea8c39b424557f77992d35(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanMaxColors]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab25245ea38e9863eedd1b0ce6602b595ac9ae60bf50d6cf5b01c484a03dbc25(
    *,
    horizontal: typing.Optional[builtins.str] = None,
    horizontal_var: typing.Optional[builtins.str] = None,
    vertical: typing.Optional[builtins.str] = None,
    vertical_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__92596bdb0c53bbd12071861e700ef27c8b014ac1ec51dc5b52d600a96de6112f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__85ef42d184b63cd7d34b875f6e90b602c4300927347debbb30165d94e6f6188a(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cdc9287b5569e982a665004fad14a9faf164912d26805f874fc90799978f0f48(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a0c78628e0d1229fee3a16e5b5d58395dd8141bf2b74013b2745f88b99c94a5(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__11246b2b369088f47aa6e02e5119e7da99d96ff84ae4e1368b8b49a6ec003631(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__065280d63329875ab4c6cd3536e21344fdd171d744bf77428e5ef23151761cd7(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanMirror]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__843d0ded2edfd87d700ed0e0e523e3d3df6593e75fbdd74ed787de9ee195313a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__45e25327f045b60026f9ea6b5d2dd3dee389c6361860a3f9eb79681ca986efd6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab56d26c417bce1f9a49cd727ef7fe046293db15b6b1c9fda34439545c6479b7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__80fa4393c9dd6ca0b341e950c4c3ef7452988594d2cf7671eeff3b7e1bc89d9e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__809f0af56547d421992e21c6fa3eda5d14fd9a11c7ca9f539c95ca53f6ed1968(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7e958cca876936aac18257659f33daffb2253e2def19c9474b68b71480395bc9(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanMirror]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd073209e92e1ad8cab13e9a4613243903c77df96e7d7f1877621fffe8510816(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9e2f6a034d2ae292e332685fd80e2d738a7be219a16e027f57818d96e379334a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a8a18809ca358313216ea1cd7e7e7680b2555e76047723e6bd75174df4852c79(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__179724959dac509986f5d8051805f03a8e3d67c8d04f83f05ee5a8ddb944c5f2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__16d4010e18e767922f26168006ca9d7f78e599f89018832bb47fda41b742a3ee(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__385f8910cf1ee67fc534aa19a5d7afadc1a0a39558907cb834f8a57c48cc420b(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__285f8c4b987988f6be2eabbf33e2d806a21d2e00c41b9431ad3fc0640bcf55ed(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanMonoHue]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__15d9e857495b0b1e6ab3ee1be817661e3a0e92b87d6248efc446d8db5855aaf1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__443d04b8477d4ba10983990a2012947d4e47f70f85a9d92f8f014bca8f00a793(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__503fd1df4d771bc91b8aff9acec3c6570a7c90105807489f25fa6171dae13e81(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__42971ee35a5bcb62e895bdc9510aa6d2a46738ada0d52a863a29509336978aac(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanMonoHue]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5988d9fe80ef763059f6c1542e651dac53a5ecef8138a6d18f56ebff832cb279(
    *,
    opacity: typing.Optional[builtins.str] = None,
    opacity_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__78f604d60de301b6619a9c3fa81e79bbf4fb7036e72e43fdd156a6286f3334f3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8b5ee93811e8997d0a5fb7c98ce59406340e2c17f74f763e1414b7111db9c354(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a19b51f844b4602f17eb9fda2483311c48033703ec0a2f68fe21fb629f5411dc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__669775e69f2403bd0ac7a43838552e3ca2b8a839efae879f4e0f0c44744d1b68(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8d6c311b27f8dc5c67b2f03a373e9ffd92ffb285d4a7568f077b893f0190aed8(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f9582d6ad67b6a9aa7a1e07c435b8aaa7dc262715bd9aead8dd397fac1011788(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanOpacity]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b65d0146b4e2a410080c64442bdd29b61d5ee9d9e36f39baadcec4f343db2869(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__92467b8209ef7227f71e289118aa3b15f0492430a38c91d3ce579d9712e4d994(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__72c31efa2b21d661421f7512a4b057c0f749440294140dd8871fb9379157b9ce(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4de756ad4b2e1d29488eafa7924f08bcb6af67f0bd2d74047eff320aa6622c86(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanOpacity]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__47070e26c8a479c8200ab5020d20d03eca694b4e376d9932595d91a39bcd9680(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__780f7f60001e0c3c659103182edbbf5cd8e5eecb540ece98a5739db050207cab(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b20b85b51255190dce0bd2658eeede482eff54ab2597859fe211fa4199aaa24e(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanBlur, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac0071d04071cc96af510ac65fb58308b30f4c1701e51eb5bd1abf147badaa8e(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanChromaKey, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d3afe97f84b61c81264f9461e5784dbbfd699727d1f8cedeff5f90a950cf876(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanComposite, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b6e51e1c8185ec3731f7d4cdf178807aa42314705a6ae20fac6f5e32daaad6ae(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanCompound, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__522eb574dbd7484b67d55c563d63b467ae2299d3e247078b20c2ba853b0e7d69(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanContrast, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d3eac5c762e1493f3e204df2c2304fe3d6ce1af444ed94f2883cc439cbca418(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanGoop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__24a6e998d5d9d8a92bd5509127c7b4cf0fd381a1d236e6874ba42a21fbc599f3(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanGrayscale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6772150da709b30dc3fab66d250435439e1ecff26f7e9e38a5ed549c24b9a055(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanHsl, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e82648770fdff250dd51d621b953db8db5c2e90de08ec53795f7d588c4cec996(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanHsv, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__65619f902136953bcbb6217fc965624f1e279ee72c8eeeee397c821089c0daa0(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimension, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a9db21286bf87b7ab0aa83eb96e40d2c25544889ad63a916f5ab1054822c1697(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4f02eb8da2f072fa9cfa3e8af4053dd9897cfa13e45a2bed106a15522e2289c1(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanMaxColors, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7f54e302fa7daee6e139249ee84568be5121719417d5b59b79e1335b776a5d00(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanMirror, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__46e0506bbee5df991722f7c46052cc4f5a9d2bdcade4e710ce0be82c55f2b016(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanMonoHue, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__051d494a8636e609ac9e71cf50c0556ccd8cefd3a88ef6630d654299312004e7(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanOpacity, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__37456b4078c4a3b34c267cc0d1caf5bc87e17aae72639105b5aa9f7fec7a5105(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanRemoveColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7afc26e7864c99c1d7d274ed13c718a65dbbc9808453c0376402480a22f05760(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanUnsharpMask, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__51969e678cf728723a5faa149dbc68d99fba8ab426a5326c84a4ba2e9d52164a(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bf50264e31b195d2892a770f941c81b01b8b99b382eceac8a3f055b00f3c2256(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
    feather: typing.Optional[builtins.str] = None,
    feather_var: typing.Optional[builtins.str] = None,
    tolerance: typing.Optional[builtins.str] = None,
    tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f67be7bfd2043bc1cc8bbe82efb02a63d50245519865f2152b77de21f5a8243d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__67549f6e009e059419e37696173fc1135f6b26210ef8d67405db0ae3cf180108(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__801aa160eb1dada9cea8bcf46c633b016804fed360f3949389bdef017a7c120d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b811ab8d25e9d8761a442807916eddec71856047ef19c39ddad025decd53bb67(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e2746277d30f659ccd678f94a18daa63a3bac96bd685f675db98ece20c97d7f5(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__690b6fc91ca20d30abbcc8fe525786bfc7528c8ae8a926aad882288de4af9ac4(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanRemoveColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e534dcfcd16f8d08546f1f3c4c962e7527e88dd7b243128b55270abfe0393c39(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d5eec395c9aae2fb221f946e7d6473a7b2f6c8144fa2d6508e63c787c174c688(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fe19ded5a1ffbce67c68aa2524daf474cd0ef02b13d713c9e8a77f19bb64648a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ca7e58557a81ea7de0731307351d47169c2f2341838b21cef0302c09bd9e8127(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__03a0a80c7ecfec7423b9e01a19b4af19f027c5da40dbfbc7653957f3859c7d65(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__85608b27e1566d176476ed3ec14338c06f8b3e72226d25f4368bb9936444903a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fbb33a863e50b00000f77bd28c3f51c08fbb5049bfe904e9ad4e6afd2780359d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2eb98fe490cd9fc05292fa606e0cc4b46d08f25066eeac58de31bfafd5f11400(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanRemoveColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ed949424004820b5b8ff4af62bbea2e40548c53438d21a82444105afeeb0bda(
    *,
    gain: typing.Optional[builtins.str] = None,
    gain_var: typing.Optional[builtins.str] = None,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
    threshold: typing.Optional[builtins.str] = None,
    threshold_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__64676bf7e763e9bced2b4b663d19cd8800dfd5de9f5f58490827084de3c2085e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1d519807e262a2743dcf526439e2a860a1e20111b79e1bc38859ba3d74dd24e1(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__19d0c3a484cbdbe4b8e47431734bf19bdbd3831f173a3c78e4ec7d0ad1e02fc8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b3ebea64d9d6aad342b9adec1bba360c7767a5c8c8903268e1374ade3b89044e(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d75f157ed3f7807a249daf2dd50eb67910c7f9f92d2d10f77e0c2496666d65b4(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ddef13fe2fee245722c1d25583b761b5cee2af9f8d036f1fa6dfd90410e02be0(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanUnsharpMask]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8c10404cb2f8bffd77281429746b0525c7eef1604e16dee67997211cb290af9a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__34e8427facf21c9eb13b32be9c4cca4837d5e8551dc041386e89c8ec9bad495e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__754e24107e27c30130ba4be6a31d8597bd4ac8f80717c7a44af17a6ebda6cc16(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b09017d116f9132250a0de982a02b471bd0851bec2f66ad2f1f9437709426660(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__350a5941339166da28dc7b46551aaf6074dc97b2024beb9d6c3ba564f83f24b5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__437c9d098004cce44bacd0f938777851affe1f598e94128ea74720c381285bc7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e8f0f52167faa5146fad1dd8aeaae5e3025c6ff7a18d13d3c916b07db9bd539d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a12791b64b57e8f68a0ac05225e8965b1706a5f4c5b0afcf307952b8a109dee5(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionLessThanUnsharpMask]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__77e688740101e8b497a65b97b890043a1a0906cdf59af1f34b2a22ab2d5ebbec(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__70897b7815ae46fd20f51b72d1d5dc328d51ccb837ef4b1ee453d9eaff63dfaf(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c920fcdb27924ce29fe7979fcce7c9130a072c636b64a204f36b4eab8a40f724(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__82fb1f20c8ce70c42aabefbf486032a166c827acbfa976a8dd3620a723e162c7(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__792099dfec0c138bcbb13e30d0281c2d42f47bfec5a7204171f5db3c55369de8(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2daf95c8ff3686cf0fc0db5d30addd04d3310ff9e96d9941372ba55729d9f3f2(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimension]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__da85c7322c164b446f70fd271a9e254e741a48aa8a8ba7bc132c7070e6e5f8a3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__256e6f4ef18ae281afa8271586385f801ab41723ef05a45e82f54a2590ed1b2f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__977e122794246b545340c2513be8c6ad2e195ae483c7d371a24c16bd8d40f5ac(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__00979a96753594873d7d3552666643901e97cac79ff4b1cf08cf6c18e1d4181a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e78e9204c9c0cad04ef57715b5a9e4a0cda8175a48966b7ba4a8ca0ba4a8998f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__61d34507ed71dc6c4c7086933b96ca443f9058dc853eba870a026c197e959521(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimension]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c55d4243473d7b6e14936270f1bd0ef14d5afb8d3950d1051a02deb6bd02b2bc(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    landscape: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscape, typing.Dict[builtins.str, typing.Any]]] = None,
    portrait: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortrait, typing.Dict[builtins.str, typing.Any]]] = None,
    square: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquare, typing.Dict[builtins.str, typing.Any]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6d4371616902b5878646e0034d02d45f0c1f0fafc4b85cac0479a05149bbdb03(
    *,
    background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
    chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
    composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
    compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
    contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
    goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
    max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
    opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
    remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cc40abaee755003e6b46372c626ebe4958f7da070acb6e91e495174620b962e6(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e6c51309ae3ca7ef7e0af9540c8105d6afb0a8e09fabac194d6fd7f34c304030(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bbc1f72b33a0ed47ba9baa9a8757f5c3450afe16effec8e18fd19ecc7523884e(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__69e27cd9f01e26ffec38294c82e232fb11193ac0ed3e0714486757b3d10d40a8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__29b9d7dae9abef2142c084e7ad95df0effe33e1e4ef1b8f6e90f673a5ca584b5(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__345d02884cf0203dfc8815afffdd39b10d7c687f8db54f176a98fdded2897209(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1b3ae51233f01d7be10d5bd13b01699a10b591467edc07632ad1a45844491a9a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultBackgroundColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8c392b7772259535f53b47d5f5e31cb113a37214be46fcbb1d3f490c84dd4f59(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b654fe5e71b4929b13471c12b4c05771d16f80ece32f28e778dd280333a8ad07(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d1ab853c7538dcedd00cfef0e14930bdf7a812b6ac90e5de1880622fda85874c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a92ddeb0f79beb683980bdd8b1ee5fbfc2333fdaa2c8eb0f1fbcbddf73b8c84(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultBackgroundColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d9ca2b12b90b8bac33be94e993e1c540c3756f14f998548b2a9a4fd056e8783e(
    *,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__57623b8c7325f68b25c7f4c7c08deaa9053076b4e66d42dc47e7b7a521d2b7b5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a742d7cdcfd18799f8e87f7695fe70ebcfcf2eb18ac9b8de4fe66980a880f5af(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__53489502ad6ba07cb9adfc59ec3941976d3ee56d1c14988e86c36aaccf0fb64f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d52ab900a0c592530146c0dd5d7b0b8cc0ac8758585ca1ad32a10accd8c209b8(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4c53de0d7b520f0d8f8a582e66b6063eb4724358062dcd48f315e4a39a585c87(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__73fdd4c55c8288af7e14949216123a890e209a265c3edae7344514f1821ffaa3(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultBlur]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__329d09676dc13fd3fbc0ab843f76c366be59e457363cbf8dd013b684ddac8eee(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__39568a4cf96acf8a112aa9669d6830fb5a89c27a0da9224be0628e0091e6433c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a072854469e408e06663c4041740450b250dd65abe73ea73af7fadc10faa5542(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e3190ae543360fcb8630e0041f38a4207caf51b092bc7f9260304c78dbc971f7(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultBlur]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a4ad1aa04c68b82620d7264a59c1f87f75ecfe46e78ebb6a2027713191bbf31c(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_feather: typing.Optional[builtins.str] = None,
    hue_feather_var: typing.Optional[builtins.str] = None,
    hue_tolerance: typing.Optional[builtins.str] = None,
    hue_tolerance_var: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness_feather: typing.Optional[builtins.str] = None,
    lightness_feather_var: typing.Optional[builtins.str] = None,
    lightness_tolerance: typing.Optional[builtins.str] = None,
    lightness_tolerance_var: typing.Optional[builtins.str] = None,
    saturation_feather: typing.Optional[builtins.str] = None,
    saturation_feather_var: typing.Optional[builtins.str] = None,
    saturation_tolerance: typing.Optional[builtins.str] = None,
    saturation_tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__87189a4561d57c700d802e54864a56b3d23d575b9da72a8ecaaf974d8383dac4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ca56da53f2bfec65c16c5d42443c66c4dbe0d542d26ffc2b3c304fe4e213983f(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__265d4e36207394fcb332fb34ee68fff7557595c3208afdd6aa023ab29bcb3b7a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a0d6046e6e216ad98a71c5f2575298aa579c04ec8dd939cc4b1eb7cff957a04a(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a4d10155733ecb75abbe253b37ccc64fb281f7f8ba2ea2a10c714ecf6d2784d4(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be4a7e4a6a0e1260c2ace7fb1c65b6f98bf7df2683c6ef1f3da1581f693e22cf(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultChromaKey]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__33240ecbcebb3ecf7989ef2969c25017238a9532bd7a3599383b7d54233f52aa(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7b63462a574af8823be3502d48e0abb60a4f2f9dc035f9085d8096816c1fda77(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9752acc8c74ae631127d2b202ce0962fd96715a4d8d8653d374072fdec42be86(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6ee257940e90b3d7b9f57007c2957f4070e3ee98980e181999c3f5989939d61c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4dfd5f4825eec36d24516ca9fced60e5ce14128088705ef0d0feff64f41fc861(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6afa3408d899ecd43abc0ec4877707e7b2a4bbee84b98a3c904ec131499bc12a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__900b3589d4d22d197e357322af5d4dd2dab68895dacbaa3f75e8088375546af1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__87662f52441c795724eb418a658137ba5c5d96227ec3566a2870e0393eb26a8d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f49f448bfb15017421d389caea4cfabef11e0fe9eabd1aa123b2a8d620292e88(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__19a4ee5e6bcdc6789163b77387257ae13d1a7c4dd1db48c4007ffdace942dab3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__417812d784fbc9766defe5178630fcce3b8b099b08ba8c6dea851ac5573dc6a4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fbc63188c889d55e3b449ff24122915bbdbe4be1ed0202c6f43ebba08554059f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a44e7f25d11b8b01129933d12c861cf2d7b312475c14298ffa0afd5a2156e6d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__919ded2eef2d0799eed878616899fa8a68105eea45b79265c4e90e0c1dedf704(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e31b2cc180ba14fa9523038f4c3b5e285c20bacca35e9125deca64e054a64bd0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2f313e010790cfefabf31a331ff33178adc461499e4bb851d09600d87190ad00(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultChromaKey]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4262f574ed02609d3db1674b06cbe734bcd2afe6ef20301cf65554057e7bfd83(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    placement: typing.Optional[builtins.str] = None,
    placement_var: typing.Optional[builtins.str] = None,
    scale: typing.Optional[builtins.str] = None,
    scale_dimension: typing.Optional[builtins.str] = None,
    scale_dimension_var: typing.Optional[builtins.str] = None,
    scale_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9c415cfbf4cc45013500ce77fca698c724ac2e8699bba424379afb79f7bbabc9(
    *,
    box_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageBoxImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
    circle_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageCircleImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
    text_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageTextImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
    url_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageUrlImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__906eb84757ca4e1997aac4b05d5f7194ae4e5b8621b17178786dd17dadc65534(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    transformation: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageBoxImageTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0bcbfaa7e05cb39c26ff49d6513c31c0d3a6a17529b040898e688e03c43c9777(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__96860b23a6b04031e0a57d5a0f60b12ce8fc501c9cbbb3f5d8c5a0f83cb7c39d(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__52e49955e696fab1d027cf7bfe4e4e26add8fab732cc8ce057a633fdb8c5bbb6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1d78520e9d283ef812ef97021282c81a8978ce068484b1045f64e811122349b5(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0318cc5df3ac94bb6f87df3ec6302c01cbe3d5445cfdbf07c8de2e9b2f3075b9(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__074ca92c91e002beb665e83822acd7364c0321cdecaad29a4697e6a66ca8bdba(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageBoxImage]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7a619925923741e2557b32082012939427233a6b11861f360dae305c298f999a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4fdaa0ba6e1cfa0016c7c9a10e4a2639f3ddf5bd5b21f29efdbbf16aaad3cb6c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4536a388269d06e15ccb19799e350d8230d89f07921b307cabfe6f5e31d1f6df(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__81ca5971f5cf0518c7b3e78ba29849cbd909711cc3bd248b54ef51b6a5db4ed0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a4f5e0378c42091bc6aaed7d970135581ab7cf42f5ab1a0ed9838532262c6de(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7fa116c4145cdbde254591156ee8f243c18cf9141cae424e1c7fb0d3a8ac0883(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a077d1ca7d01fc8ae638de7b664155090ceced33365f01f781ca5f6ce90879c4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3c413b710a9d06568f6afdd7d725bf0446ba1ab3dd32b8dd913ed04a765a8e9a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageBoxImage]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__48ffe9d5b6adfb7f511e0d1a0e363ee0838e1018696742348902ddee9df1af71(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac11fcdbdfa2d174f993387d8d32381c3ab0d8d15d0204c47513a47d9f0972d5(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageBoxImageTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e7c022b0c79003203344e239e44276ae2365416ed9e9fc19090b3e41374e29fd(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
    diameter: typing.Optional[builtins.str] = None,
    diameter_var: typing.Optional[builtins.str] = None,
    transformation: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageCircleImageTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e4e825450a12f02a5852f22377e2095fb41a2f051d2d1253c7bab8d1ac98a586(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f350125b9fbbd86c303670d0c73f7b74e7d502239012610beadf5769184855d2(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6636b5c18b13709411d541a148239976c07ac72081df4a15f1b05f4376a55447(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__24d5d1f0f7eee26bc16dd381ac5041b21ab10633eb9f42fceb9b4ff35e2f7828(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4805413f045b73aac01c4bbdbe7d1ff7fac126408cb0613eaff5aedea4dfca56(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e7f79d1bfa93bb7a697ed338e97b297de412ea283a26d05b2f388c2a0dd96112(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageCircleImage]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__55a54e9e624bedd97411e67933f3bd70c81d09b41257c959a83aa5ac8b73a3b5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__980d621a095f800e9645179b5649c18d6b652f7ab2a22831c4f6978fc5bf6cb5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7ea561616802daef773071490dae5606c4c2ff97302494c2b94b6e034770c018(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__635354f0b1dfb1830bf8871714629bb85770395818540944fe73672f22fa32a4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9e98b094e9d579d0feeb342a68abd6e20324b9eaaf0f5394f7f97100ab9aecf0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__93f8485fa4ae00137f6a713241e662c9ec2539b3da7266949a7baf4d3992e588(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a64db7235b76f024e4f9acdc9d19d64005d7d6297621c53f7356de8a111ec077(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0efeecca5fe21894767aeb9bfe668f939391e15b84728fc1c167711be229a03b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageCircleImage]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__965118815c045f0469eb8786b4fc169c1027ebc162f1149518815197c4efcad4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f41d151e5054f99b478aff9db8134f7f49e17a1607d8bfe7e70f9dbe399e720(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageCircleImageTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9fd41c16ba0c6549435c3c8a323b2358b067910358e1d48f28793537ac63fef6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9e6ca0e2faa41c47c0c42d1ff942f13f77acbca02ca572d080ca43de80840c9f(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageBoxImage, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a885edeb3ba669e61b2a48a7fd4b16ba6d6bf33d882169ca3341b865d2169f4(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageCircleImage, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6ad18fa29c0f2e5ad02ce65988a33588b7abb7e53e099e86ab741ad52ce6cf15(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageTextImage, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__378bdd96805ef3039776634616672a9aa5f2a338a36aa39f151e4411a72602f7(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageUrlImage, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1e4c2d07bb739697bd2adc750d0e577bf14ff5b40faff2d053ad7707558a1b27(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5d6e1d3a8319b2e908ab6e87898817de8de9707b1bc6815f620698fbc69868ee(
    *,
    fill: typing.Optional[builtins.str] = None,
    fill_var: typing.Optional[builtins.str] = None,
    size: typing.Optional[builtins.str] = None,
    size_var: typing.Optional[builtins.str] = None,
    stroke: typing.Optional[builtins.str] = None,
    stroke_size: typing.Optional[builtins.str] = None,
    stroke_size_var: typing.Optional[builtins.str] = None,
    stroke_var: typing.Optional[builtins.str] = None,
    text: typing.Optional[builtins.str] = None,
    text_var: typing.Optional[builtins.str] = None,
    transformation: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageTextImageTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    typeface: typing.Optional[builtins.str] = None,
    typeface_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__93ffb91089fd06eb09b748cabef8c86b47b7b007d55e27da323086e3857671d2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c30c027ad02ce630362b25e66d56fc812fcaaab87d102fb531be289e6da309d2(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8058256b1ba4bcf0f8c40e4d5c4da988a2b3236fc1e99a6b957740780c1cc0f8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a9ea813fa8f1cb740e18994c36aed2791bd2f17c394684e7e48651aae01157c0(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__edb4a761542350995ba948a13c1b5a080a104a5583187d479e8d317aa6f3a08f(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0faad5ce95a85e82c497591ae93e40a6fb99c2139485d9bdaa3255a5f20da242(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageTextImage]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3577dd0ad07737f6766b1fbb5c4df1178dbc5d42272a4ce21c8cbcb3f8b25fb0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3b3024746d2a4af17369815a422ead6657693cbb4ed86dd1f7290537f706dd24(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a8731ff6a391f785b55c6153a8f77d3bc253e602bcbdcd0a18bb7e5fc6eea3bd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7ad07b76e8a84f2afc6019bcadda585804f1c2efab7845a982cd5da08bd041e0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eb3a603c486f7161674da255e1458002d197967323651f1f29c8d83fbef3c737(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__95d27781aa7ece5e0b12e7042c98fd013cad444de28a614854a0b3a8f2a1e70c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__694a2e900b47c096a8b718577bf9ce6a4f8f2375f4adf1da96560d034071addf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__de6f2950891f66dcda8751ccd9fb141a44995e77b9be3c0a219557adcbd4a1ec(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a00cccbdbbb06a183491435a43f3bc9a86f2aa0b9d8038cb9117a6f741d3199e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f25b4d8814ec5688fabd713163cf8c66fc500b1bc66d8779bef0c566e6ce536d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d7069a55a723a4f01cc2af1c2be2e11f4e23af01cc998362b50ba5fdd5a2e65e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a31e650f834b20aec34abac38a18bd2d26d39ea4f768777675468a05406f698b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f08f4e0e97cba76dcbb7782122428938fed184f9a089fc343b8c1df3ad0a040(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ee0d5e07118e45d3d4e73f8c1e13c53afaff93b118f9d12de0663ab1e2a34b66(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageTextImage]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c534fd7a5c1564294505b348fdfa2d323c721134a2fb4944bb1946629fce7dcd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__429267e245a77e1e7b6c447c8a6c88b6a6b047f658d3b22d3ab7d32647601b76(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageTextImageTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7c8e1fea50445aed68b52eb0529c2d2cadba04d06be08b3072715308b2f146f9(
    *,
    transformation: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageUrlImageTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    url: typing.Optional[builtins.str] = None,
    url_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4b33692a47b980f8ff8c9ffcd5e7a4a047f1c12e2ee4a7d888cb87358dbaef23(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ba470e100bb6eb59fac827e844c5a10a2a591c579c6a38b56bfec4dfbe79617f(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e2b3adf79077447acd93fda92cb2fd7a959f4f628a124b4927d0668eba23986f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b219a35e8b021d9f73dbbc74814cd5b5ec9b904ba73d733c66be7832cbfd7fe8(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ec5d43d3c555eb38373a6e7f9ab6b742940fe60a9e116ad7ae9b88830883e04b(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bdac2f01a114f50d4afbe6a9806985feafcd0875536fd085c4093130b9989b59(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageUrlImage]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fbe6ad6577a7f48f540b1c9c36801f7a8a6a2547140182d3518c91ea6c48a767(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e3098b931c29c88434aa2b55d76b9ffeac5ca1df14554e40160b4bed6aa5e109(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__986dc32c2cca3010a3af4990ca7d322c745be77aa8f18cc50df3c84daa7500e5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a4a72ab93897b1542715d35cfc277f394dc7e08638f940b61f20fa0c230ce83f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageUrlImage]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__19b502e915a2ba59615ede4177600e2529e267b0728464e41a603bf0d1995521(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__16eb18306a009e5c6f2bc49685632b354c3939f41debe084454f90efa61bbee6(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompositeImageUrlImageTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dae26812399dc2bbee29266769f813c5de9aa299c1e3fe72af3289c0435182c0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cec58f45b1b1fc8f60f876fcfd417e1fff5cbdf83bbf994fa069aedb9b2fd3ee(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5503325a23985a13603b5bcdf2aad7de3f58cefaa451abb84cd85893cfdc68dd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__caffadbe94c544ad2cda0ad3fc6a1c54858350c953a0318c4f75fc24895ea058(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__87d0ab689a51eddde9c910a35dc74afcf91550694d7e4a4ab0b3e4500a080638(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ff42bc4ee3d6011d4d8f45ccea8a3c6555b4735695fd24f3abfa5276f2454088(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultComposite]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b871fd5e5ec977fac62ebd291346c1925839444cdf91373d3776ee32ab30a969(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1929db512f798802270a6ce18784833ac4b07b52c0003fa1a9cbd0190fc75e72(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4dbc7e419332af6f73f9b73dd59e982f86a561d218f058e37a90cf16afdc9241(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__15d12fe654470313af67bc362843f28c15d6769fb6c9c884e0095844c286ee74(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__96ef6bcc0c98fac5645d5a92573b0be611c2dded44fe43954769df4e1419ebf9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f7c6a34f2ced6663ffe1fc12b0a488875c07ce382c2fb69da43d33dc560ba835(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__90f783867ab27d6926f83dac00ae931189daf3589865dc07e513917124939a01(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8b66dc65c8068efec02702751702221927649e8a002e6abd7127cdc73d994da6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8e8cafaf9b16be663d63ad0ebed9172d210e759ce201c0153e6026b5b0d64114(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__49c057abe3713c82c70604d81344b7c8703b7488b6ea2908633fe6cf4c1b3275(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c7d53fb3174761067936df7886f6482b9008526671d6f77a7ff1a5a8bb377101(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__85b154c0929790fee35e7387f75c44129d73931cb31d22368ed023be743da942(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dc9ded17c800b217a4fc05ff260df0b5bdf358fe19ff704f3cd78856e15ac48d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__603d29b544801ecb70623949c21eb48869e784689d41977674755626db8170da(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultComposite]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__86e68a131ace62857a7338e13facbb2ad8503ee864138b78fcd6b041655c3287(
    *,
    transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d85d3895c32ecb16721eb26fb85e21677299f483253a156b73cec34eb7c399cd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be692895610c3562ea762d8700859d4b115f42b008c113e17c8296b453d80bfe(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8cf81cdaff1a0233ac05ac586dac4d393954d61eeb3466aa79fff9d2d1725038(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6919ff98f1d66bd214ab9e548508ce54bd7e929f6342101f577b711d2bf40a77(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac0c7f5e6a93092ca1458c2d148d1e673f7a9cb4234c4c3b3a51818ee068b1fd(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__819a7192262b8cb0cc70638e273c5c9f9e89d84ee232c892485a3625edf79ad3(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompound]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__159007419ea9c3ea28d45f2696a10fb2c03091b9ab8a61c27dc51156d0dca4af(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d66472afc2e817f694f816373bafef5aa0113c67b9d0633f5b17687cec6d795d(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0c5fbf2ebffa6511456847dedbcf3db3939092cc4a565d326b1b62e002552688(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompound]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bf6117440473832aa488024d7d88e2abb3ba9accd534e5eb226a62e5dd6eddd6(
    *,
    background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
    chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
    composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
    compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
    contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
    goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
    max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
    opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
    remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__765364e1408361523eb14b936e6ead8b36df2fb08e04ce5171b2320ee7091b1c(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ad3992163115257c404ea76129e7d4b604efd12450f78a267b278fa3bdf6fabd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b643a5e08c58e8f2d6e7a2c7b8ce12cfc1c4acb53da58526f99991e2f946c226(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__914143d6e53370b1690c11365bae4a3c423cf13c2f510ce5727492b62f44c667(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c835ba8f788f6271b0f98a04a83ad14fd039fada3e26b487b2ffbaf93520b270(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b769785b0131f28272ba925d58c6809e38d809d5c17bead3bfc44c30c0c25046(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4931c13099bae700e5580cbb194774cc6e809acd866daed0f1202185211a11d3(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsBackgroundColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e2d2e3bde71e1d9bc200cde3fb9a59983ecb18f2c7726f484d0bb410a626325d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4d1058605e5511f9f8ffec6eae9a5c7fce16c2316b8a95768bb60c9570919fd6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb2e692330400279d6904540092c95e2d07fdb779a1bd7eea30feced852ffdee(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__987db98ffb68a568e509a2f5225ddccf8f281bbbe04dea9df4833eec9b32c31d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsBackgroundColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d123b62c3a973f01f047c6f02232190dcd60960bba0e2346586afc1a4360099a(
    *,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c290522ac4ec88ae7d3f91095920fc6338c1ea6089e303fb0c9e7ee9ddc17ae8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__94744a516495453870064002de0a2e1627f941eb60ef0cfca6ca0f164d8fa3d8(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0969ac921101cf849be51c69ebf3a22ea7c69a40bcb56a5da23cb21b9f4f2a79(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__36d89e344b1fcbd87697e1874937ce85ec49b0c087ea2e274040b059092325fc(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__92df1696247d068bf365660610ed50c465d7349543cab637370422a69e1d8d95(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9f7653dbe3fd3ceb5a2c180cb09cd8d010288735b4c817a10f513318b68fcd68(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsBlur]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be434e367c2bc139c45644dc26c81f07787ad221bc7dd56eebfe09c10c985086(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a7084a81302432089a71dc62020a7a613d23c8ed87ea585ce1c8041148c04730(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1890e9ab315b83a5aec2b62887cc3aeb9cddc7c8930eb48e4eb1259598cdc325(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__303a1c8ec93f9011262bc0415ff7da2c6320f227e19d7bd96c68355a430e4013(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsBlur]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__78d3efe84e7ee0f53f8425473021d3b609931bff98afe6020489216ca46875c0(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_feather: typing.Optional[builtins.str] = None,
    hue_feather_var: typing.Optional[builtins.str] = None,
    hue_tolerance: typing.Optional[builtins.str] = None,
    hue_tolerance_var: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness_feather: typing.Optional[builtins.str] = None,
    lightness_feather_var: typing.Optional[builtins.str] = None,
    lightness_tolerance: typing.Optional[builtins.str] = None,
    lightness_tolerance_var: typing.Optional[builtins.str] = None,
    saturation_feather: typing.Optional[builtins.str] = None,
    saturation_feather_var: typing.Optional[builtins.str] = None,
    saturation_tolerance: typing.Optional[builtins.str] = None,
    saturation_tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9c6eaf6b102ffe8329866ebc1b3ccece7474eb756274ea6507ee7b08409a1174(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ec9ac985d852b332104910218b29e1333290322feec9db5507044fe76a00d238(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ae3489d1c4443d9d3c45bea594c4a7af73eb9143bfa3602826142f6088d812c8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d64acb0d05b53648f210ede91dcc6da62a937eb16f7de6c5869ae5e27336a9dc(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3778e2a8804486c8b7e724ed128337d96ee93c957b07ff1e838919b5f4d28495(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__94749529254c87e06478bbf4fe46b68c85fb624acf74fd4a65b13e5157b27df6(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsChromaKey]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__90ae8396eb62dc5ed4c02bd7d8b261d245628a2729c9f2d3e5ab040ae2cdeb96(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f4547ac55808c984042ce86301d8095794779688a2f68baa85ad064117b0a478(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__011e0660325e1925455610a7e6fdf2b346f27d829b3cbc6e5c42e56c3630b102(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c64b00d27babb5f510c930e85800b66f99960262d71518d81a8c37d996cea2f8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c98b23fa76e04ddc5bdb060a5b44905ccd50b514004ce4ef5eb53640b9c0b71f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a072a3fc38267b68c2c44796a6dd98acf3adf114fc5fa08ffcbc84a10efb7528(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d0ad37b1fb1ccec42dca8afd9c7b969beb296c3dd9cabbd6738020e11955dd50(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f5f4aa2f835b0dc9a87f12997664d3dc373d9e8aa264a6b837a3163b0df0b69d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bde445343944048b92e057fe416e626eef3c91bbc235db48c851496af7ef85ae(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__91e8776866e85d101eef29c10647c6317b76512a106108b3b51bd1b410538ee5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__84f09a03ad06c840af94aad697e37df24f7d620c5d0ba1b54dd123d9409e8658(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b5ca95e195e626fc5a262dff39822079036ed250deb196c51556b9cbee8cb507(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__460beba263bab04adf218b6435010072d85eb8461cd6694205e1b3441baaa96b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f8effb6a03b68a630a61eb5977e7f80395b9ccc822979b499c6c01bc0153ae38(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__97437583be7797371711c39d6160876cc8d85b9bf457c79f99bf13be264d3afc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__345fe5e6e27a5397df558a1e1f39ae3aa1f4215fe02990d91df60dae43569c2c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsChromaKey]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__61737aa7d69ee182d368b58741baf74da7fdb5b72f96c9449307316eb88a82f4(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsCompositeImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    placement: typing.Optional[builtins.str] = None,
    placement_var: typing.Optional[builtins.str] = None,
    scale: typing.Optional[builtins.str] = None,
    scale_dimension: typing.Optional[builtins.str] = None,
    scale_dimension_var: typing.Optional[builtins.str] = None,
    scale_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b15455e8da92b00791b0d669145608944f4b74dba69450eb82c483794d0477e0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9f75b774e362d9a0a0aaa68e3104c8738453331282b0ead13a0e1de97ade0aa4(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsCompositeImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5156bed4969371720a88bfc7e94ca18a038816cf9f0a23581e88231b0dfaa4d9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b5bc91f4a667341b9d2d71b2e5b676b0f5c8885b32b569472d7186b2f434c6b8(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b974539fb9c09fee9425aebc7f89a94a5e79b1e6e08ec70b8fa4b52359d283c9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5bb88751ab9d03b7b7a80abd17958726b599f1f0246f009f100f1100310766b1(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__399782bab81b24aaad2d70bec0de964cfa0d0beba13d3596e312f87f8e376277(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__228dbcc714b4c29cce6d2ae4b6a7e8a48fca33c85757d0d6537550349fed705a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsComposite]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a7f5f6c498d517baaf18bf0c01eddc895bd3e9aae621055dee42fc357b453b7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f90a23d216d583998782c241f4fd3e91afcb8ed6c420a3eade35610e8e21c76b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a8ae407a448d9d99427620580ddae815f9640c9ca11a2c8cfdb1a7b95dd25bd2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7e28cb599057a0780de0571b95b476fac24c8754c0c4a7526e9d49ca46b74852(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4b230befefed3423c71453a54cf1571e0aadfb38d1f359064b9443ea9fea8757(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b649d9fa967ea651df5df680b5b42bb1d84fc07b1d868bdf80b45d2a7840e0f1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__98d5266ac9024cc4f372f4cbcac73c218ce301ba50a552f527538214c5607fba(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__662dd560e525d7b94d769e9c03cfe7b6613021b58059763bcf4563d1d90487de(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__014351366451abb878f070a314cc25609b3c61bb5a1f2f2177e0ea3302842206(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a18825f7067784ab3ccfc9808be13f9360ac103f4e3d04e61cbdf87aa2d05cd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__305715e1e88f0fe83ee945facd87a9499ae248a964431d4efc2c25c759d612a0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__02100b622e2073bc58d07611979183bda3026c711f8104aca985f61b0b8a5bf2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__950c3a0dacc3f638edfebe9d52cef0d6c0bef0adb675f7a8aafb8fce64e34301(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6b87b5b642d347cd295e941458b43b0379db64d212dbf0da9b6ccd0792560113(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsComposite]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2fb951fd716da617c93a70a944a2692a39131bfea6d0f05671a52876c17227d5(
    *,
    transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__19ac4bebe249c892fe568b7f96c2719e1d524537a0a25c70ff72aac9e27c5a66(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea0137cee092095ef7d7e414d57bec9ae4552ec873d7b01e9be1e1f53a1c9fa7(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__28bc657d935b70b7ee910348aa053c1d536c085f75f577bee14582c726227e97(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d9fbbd6f41ebd25f092bce27bcf21d93e8e48151e50fd2a5f0ec8b64886e59d4(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f5c8e4f24f8c6cad54ae16ce592a3aa1c74b54e76b65e142ed49d0e2df68be1b(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__02335ef1b4da1ae760dc7597dcae3920f5dc645e7f037259eab1cbcc51646488(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsCompound]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__11f95ce012d7ae5b6ade8799dcb7eb83355ecb5cd22b6ec1fa2b35736d5af5fb(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6ef7976dbba143fbebc6c0518be53cfa820a836dd60d15aaef5db530159a8da6(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__486475fda19497ffe49507500340001ed105bf0b7b254dc661645bfb423ccf56(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsCompound]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4718183a03cdd8f245e02d9ba0975eba719b34700a73ce10d8e853c2daec3c1d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab5a947c32c23d1b738a2b04d4908ac379c0a234b3df7a3e3effc8603580e187(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e54bb88f2a2339774b421127941e2bf94f49f7bedea0b9f5982de012a14079f6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d03429948704f7fe320062f8093f16d39066d0b2d4b5d363608a103a1ac8d9cd(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ca8aeca93886320a0537d59afc3506c5df3886f55629e76d1a65e77d705639ac(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ffd80dda6e08d74a30f71ba9d953128cf89b3bae9f573f54a28144fb91dd183d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsCompoundTransformations]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2f741d948165b8b3ec893eb9309668275d5ede30dec5ee3539d531a66502571b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e390f854c4bcb343a9b91381e7eccd820d8475c943047fba2291851fd092a992(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsCompoundTransformations]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d7366dbfe7ba0b5cb289e8c95bf19b31631e297e6c381a50357f8bdb52c323cd(
    *,
    brightness: typing.Optional[builtins.str] = None,
    brightness_var: typing.Optional[builtins.str] = None,
    contrast: typing.Optional[builtins.str] = None,
    contrast_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__054a1f6400223600717b262d4bafc5fb0a70cff574c502ceef4a0ee6ba08af25(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f5cf0a0f7592edfda87c853d8251095add126f769343d8f1b99202660081fb5e(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6d6a4f14e152cc102db64f82a058f54ee1794fcd5c33b33a8c5242621d63f050(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e6a5ef44535eee674099d41157165f4feca3cbb369165eea0fac7896af02c952(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e66bee7e959a6d23bfecbf2681700ad859a51146a2df287bd4c1b05ff0dc554(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8b964fb6192d9bcd156f825fb421d59a52e7777a17efc8de55501f878097a631(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsContrast]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a6cf03fe3c772ec091a85593f6c40fffe319ec1f7fdf2ff86d466b8ffc42d54d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0e49a1a9eb7326b08f8d8359821d78ac94fa507a653147d2a387f26b820113a7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac3011649a61aee9ea6d7b50231b498915001b91b727fe62da3897ee45d62a78(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d37bf2cdfd68c692e2a465d513b0b82200257e9651138c2e9fc9b52f4aecf0f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea3c3e3c7b68519d58a72614be9d555b59ffabe29f6b291089c27a25509927f2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__15cc139ec86a6aac1620031113669c35e5b21728ab4a20f9f6a6f16fcd0c6072(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsContrast]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__99d777738d062c850cb9dc29e238b9d9849894b0d4d5c57ffdb10a28594da464(
    *,
    chaos: typing.Optional[builtins.str] = None,
    chaos_var: typing.Optional[builtins.str] = None,
    density: typing.Optional[builtins.str] = None,
    density_var: typing.Optional[builtins.str] = None,
    power: typing.Optional[builtins.str] = None,
    power_var: typing.Optional[builtins.str] = None,
    seed: typing.Optional[builtins.str] = None,
    seed_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__02ef48f2e64d2edb74b0ace5ae680fcd8d5056978a1eb1a000dc85cdabb8016b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ddbbb28b451ea448e9fcd1f7a7212b9cd0576ddc04914baae8b3ccec13925d7(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a8a245018b9b2ca7ce1f5713d4cea09e8bb8aeea5fe2fc1f4868d4eab74a281e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__13485dd2bd416c40a3a563880e5bfdc4559815c4b3139f9caeb548118d627e21(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__38e27f24bc5b609636a85d9964dad8a3402648b36a8b73523c0725e916d9c644(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__683291736d9d52e7bbcf74b508825f56e9dcb3f150398bc1058ab6b9aea4df31(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsGoop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c1a2224146764936406d5e64564edca1b8e89b8fd88c1a449edc8f988b2018fe(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eaa678cee5cf8eccf1ae06efc75079c17c53794224fcc2994fa4a29706d6e982(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__691cd2100ec4388cc09b6fe12d6d28d7961e0a83fb0937e4e4dbb847a42f61aa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__159a318e5856845c42a4271d1621b332c0fab16c070f4310507ab48153d80702(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__21b0e3b51b2893298e5964b428c1bf8c0d191fdcc06193db70d43c45c879ee54(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__db77ddce50b1a8e62b70df9986606f3692f4c676a4672bb2c7a121bdbe282242(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac48d1f85d3f96d756b2e923596ccdc8f1cf479f691900969f1aaebffd15bc64(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8c458971b79dbf6dedae00d428eb826dd7d2f26a056de8524b07d15e0b024e6e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__490c712b2bd2df7fc26d5480ac63153607a6dc279ad0341e4c034194219d2b42(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9f2b18bc29ee2d9a96568eed537ae0a724279125f8647009f603b99cf9cce659(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsGoop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b1460c9d8a103ca31cbf87002d4edad0ac795236df701536a71cb0117ebbe30a(
    *,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ff33ce8e93e2437c408ce54720425e99b45dc78075e8ef9a136535faa6f3b2ae(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__28f063ea3d0998b8255e4372a2871037e663b617bc94dec23ca73fde0955c4fe(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5e834c6649bad841734393e3b8f16393ac550c707dce9b6489c808d1db74f097(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a637e4d4bbfd1bd23e74d9101b8507cf2279518fe6e29946bd1b6e53befc35d7(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__96e266e713143ffd473a755ed2566c12089d0f914d935276a3b74589d816ceb2(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__97fa19af722f5fd2015eda9cfdb2a716d35b7c4bbddc4f4bbd732698863cdf87(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsGrayscale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dcd77d028c1b09f10058d3122e2ca9fcacc7fda1a80c3fabedd0425261046cc0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c55068bef23d5e4ddbc06bfbf3249034e53d33d9de2c8a3a7389ee4997875c47(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__83313d57c2642d7c68c865cc3c4e4682f93b4efc0015505914fee84e858bd141(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__330136e3bc0a38dbc1f7ebe759f0392aa7afa693d61d6c7897d1f96fd8e54f75(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsGrayscale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__408ada661eb5ab00e1a25119912afb0921550554725ecd5315b3b655eb6b1de9(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness: typing.Optional[builtins.str] = None,
    lightness_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c1a4ca7fc6d16959c93d80d4e871ce28dfc0c5d6cf48c9cbbbf67a3b97251d52(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__38bfeeca3269c44341742de98b889a4dcd28a32c5c9aed088d2fd37129b31d65(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d17a0c281257fde555e967475064cea7e6c2f47879053d8c933e98f2a41364b7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__38854859639e9ce90624ab62846d46a259d87d329a0d38fa62052e2074d3107a(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d845fa73760c9f9481e9f20ee5e90ced1679179de924de8d5f1e871ef57fbcf3(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9c67097c576a2a4109271d446d50f630ba4a20167bd15631c1dd4e9966625f2c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsHsl]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5e68dcd33d756c8ea17981890fbcf46b96d9af7765f116a99fd05da4fd537e31(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e01656214543929a894bceae2ef6baed87f99aa34a4464ba400a3c55d5a983c0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a2649b21a80045d44050c427e664d0784f8e8ff9addfd64735a9615ee4ed6fc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a99607eba8c9f1573e853d4447e9c3c56837d207e110fa1919ea4681ea402eb3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f60760ce29d2d9d8dc1172e4ec4a7791be7dc56f44b68b80c706ae95bb3621a4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a6cd90f4404410841f9ecc0054ee842aa324c6e832b7ac7d3370f90471168c8e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3b5d4fe17292d5728d726dcdaae3f57cc237ff24973ebf5e926b9d9b86ef6ea0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__68ced46a27c307043009ca90f8e35da6f6ceda883dfbecb248813977d4785372(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsHsl]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bea5e7c3e0d16e62b73a6341419e24c1a77743903e2688237d913a235c1403fc(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b07801143b35a6389c2cdf96902b001509a1b517cc51362c747cc46967865c0f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__59d1889082daf64be06216be77b4fa30dc9f8798dfe03ea59c0475cf82247f9d(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb9fe110e9ba0139e5ff8bb2718f1f30784382b821c85199c744b0d940205b39(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f4d03dce06434f685fcdb8d4e4048679edf8d87612f08f70a137494fe66ab81e(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2c6a067f8a91c71cb398a56432c217f238275ed3a92f66c6426a77d70435b299(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3d584ecee9db2eaaee5ef9ab41f6a4200e2d545161d0e254ea62dc45dd5ac6c5(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsHsv]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__37ac2dccf3e92b4eabb85e723349627e0ec8d2146455cd3fa707a38bf8407119(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__65305436546640cdac331b03fd72ad0d7583c4868f480a3e31cafeb482a98f00(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d9a06c65a13e8e0f250103360bc82ce8f713a45a0faf164d85dc307b39407e0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__504076737db4ffeef0b9b152ce62e3ef46be0c75ee8aabbf6478e971927ef732(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a3bc7cc4f37f5efcbdfe6b85edd47e3a0c58dae66001fd7cee6fe1fbc0b150e9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__94cc9c6896398f98dc13984733b76c2f338077a9410125e612dea84377b32437(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0994c59fc682df61a8dbdf8b92362b80715b87ac5fdc5975baf07b803daac179(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__36d42ba3e1a36285b5d2050f79d548608578f0e81c0a7b436ad47d54ed4b9912(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsHsv]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__75e252db49256de39d6cb827fc9a598af759f10f3b4f2f9f129f0781d4c7e994(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfDimensionDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    dimension: typing.Optional[builtins.str] = None,
    dimension_var: typing.Optional[builtins.str] = None,
    equal: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfDimensionEqual, typing.Dict[builtins.str, typing.Any]]] = None,
    greater_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfDimensionGreaterThan, typing.Dict[builtins.str, typing.Any]]] = None,
    less_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfDimensionLessThan, typing.Dict[builtins.str, typing.Any]]] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7c50fe725481baf13e3e20ee59f3bba2c16afa38b86408dab4eef829612f20fb(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c011b975f3c83c59fc802e02678e9feaf953da66ca1e3029a2a9c2242ced500d(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfDimensionDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__87acb2cd0dc2f3b9a0e7e611c91be8e5c06758656fa6f2eac177d2cad280e174(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__488223990003cc027db03ed95be89f52c937235bd0daf5fc919cb453de7ceaea(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfDimensionEqual],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7e721d66994bfed8f1a39a29c18f120e50ef5dd9619be1bd640cedb15b1dd953(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a823872fdcf69b7e1e395d9ef26d4c36f0d8d17512e6a2a32dd495e79d24e3f9(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfDimensionGreaterThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__063d560195024ba473f4608f0d8e597f20e6016ef4af74d52b9ba013492b14a8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a39d3dd999336637631c0fd50a167a1cd006f5085662565ff8b0178b4d118f3(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfDimensionLessThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aa951af7aea88c058594e37c25092c13a508be23b4c70a9e72b2edc87ad3d9af(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5300f3fc348e1f24005f63f265495affa22205f9ecf19ac686f87dda56405597(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c0ff720cdd7a972a8a9d5ca727158cf1cd6c9eb676bb38cf51238d3769cee333(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7b683caed4e50613a2e5b6f64d835be12f92c8171d89be031d5aa1fb4f7c5faf(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ec5d5d0ea4a70bbfba41b8c06f66c90cecf763783d5135c611c0f75fd6f7e569(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ea0f1afd94f0fa839a75ccd3cd983d7d9b70b475de281df810115f19daf1e2d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfDimension]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b8560be268a5729e1e78f19001d567193ce2026628051582b581abdb4f7e14c0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1699690af42802b0faafd85b1c3ad6a68df523442739110128ced9ddc0960c65(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d568bc4a6ea625ed69b0080c48ebba0f5c7b0d14b5ec7a9735eb617c7f8e6d2f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f01dca14551b3c87486be9ada262e4e1f61bc05a2c0d5e29593047ba95286cc0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f696a132a9eddb1b27ff6e02fd3f4610ac08c4278279d7ad28dc53c7f4749f3c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e35eb33c048cc371be4ef44f04c9433e04351e1fb28f2a6c2f54723a1385b1a6(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfDimension]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5cbd5ec43fe04a9cc2b771cbdefef6658a6c02213201f7b46a95775ce4b2bdd9(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfOrientationDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    landscape: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfOrientationLandscape, typing.Dict[builtins.str, typing.Any]]] = None,
    portrait: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfOrientationPortrait, typing.Dict[builtins.str, typing.Any]]] = None,
    square: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfOrientationSquare, typing.Dict[builtins.str, typing.Any]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8b17d3f41f339caaffbe18e1ca717ce65945c093c282f4021bd2835d21f5f73c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__143cddf3ddee3be026f7f0a93973c7e44ac223db96633540d0ae9aa93f133f7e(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfOrientationDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fba84228034284cdeb8a79c85d0e16b7f268e33e59af68d2dcac231eeecc4ecd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d9d737fd05c2460f69db94f239162185e65fb5e7513e5e5403d7afae637bf14e(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfOrientationLandscape],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7f6abd2343b81c8a7e9fc17af801bdac2b6849134274a27fff5472754719e80a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0034c0cfc27bdef37093575c008554626c5271b30eb3d81d99d48a2efca4656b(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__57549e66ba55a5ee970367a1890f0bb5ca2528b5bf47db49e45786e5a535bd35(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__04690822ccdaa89aaad9bb54bc9793908eb053837167e2d3b0221173259f1492(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc202c5e51e07ac6c2cae85bc29af7be7a7c399a76bae416140802901a78928a(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7916556afa70e2c95bfcd559ba7127ff854ffc7d38d513919a20b2c0e4ac95f5(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfOrientation]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0bf166f5e0464e8d14b8fea9634e925bb7a4cd15fccf635b3ab32213dc8a91e1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e09de157a8c3d9d0817bb314fde33d5756bab587edc4a7edc5e18169c44bcab7(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfOrientation]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__94362526fb1e1c69e8eb4cfa7550881d5391878246e573ccca9a7d577dbbea9e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1e553d1cf3207e590ef8ad700e2799311e3086eeb65ae10e8ba8e35683dfddae(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfOrientationPortrait],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7be2176e69a9b588d24c5a20bb267aa7f8552f3cf08f1cf729a5fb201965d4d6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a31259649384757a6b25e23f860e4425f6d31383d490924da69d87e97cbdf99(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfOrientationSquare],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a31b900bd21a8b539b2f07abe1734e68f78d26d9e79f1daa27f070ea877722a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__21bcd4b8d697b319e9ce3e35186a43546f234c5e9c33affb8e1c670402bf2422(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__26abbcf2ecd8fd804325a93df746ec165ab993d41f3eda50cba969abfeab7cf2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fb18d13dd0afdb7445d20c1fd42c342e6f496f42f334228baffd9a257627a4cb(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b0729087f5c71569b68d982f95733da745fc60d61fc94b18c3f75d3dc77e3abc(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4d63e075bc507c2567151da7822e35f86d8ebb8641e581e2825893c8541c3e73(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformations]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4f94825f1c17cb1128087ae9e5ee5e0a9d57576700116d94ad8d17d63cf09617(
    *,
    colors: typing.Optional[builtins.str] = None,
    colors_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a13ba9531a942b0585d662d996d78bd316c7bd360f99aaa25e86946b282a9f76(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ec780e46925f2676a9c1f1933fcfaf3ef06d0dac629e4ea8385bcdf557d6db3d(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__93af304150ce8756fbe860634e988bbbb360cb895c3b17ee7a0b9a83f1e7a239(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a57d0e60c4c5e7cb60c43a8e0598322178f8e33fb29709c35f81f54059502b34(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f97b2a7b4d50481285a996aeb920a93e85fa6c8ba711f9dd865d03cc933d053(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__04722e4ef37e5d1eafb4868dfd39d369b773a7c7aeb69bbde686090741828173(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsMaxColors]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd060a76e6a26abcad85d05154db8c823da16f358e0ddfdfa2acafd865410960(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f53dafb84f9022703b2126c643a15a270cdc34d5f2d350c9dd9902d60366d8b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d272592d9df199cdac6e3bfd3ab1d5762b49aba7314bf6dca710ca7baec5c42(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb32a2f6f0b83abd4ced147b69cf2828aceac11e925867c0be4a9d04163ef78a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsMaxColors]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__74658fbdfcc1211255d8ee8e777c815cb49593822278092afeb585f18225aca6(
    *,
    horizontal: typing.Optional[builtins.str] = None,
    horizontal_var: typing.Optional[builtins.str] = None,
    vertical: typing.Optional[builtins.str] = None,
    vertical_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5a8856284e29579a50c497f3696befca36212d5445aed7f0c364a8848e6b22b2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b2048151e0a1c80e5a576d36c5dd2e74a84c8d6081f354aaab0d316a73ed70df(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d2ecbd53edac983e6e3032d91acfdbf49e24a1ba8706ad1be9e0991e3e10ceb7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e5a912b9720841806d3e2745f4619a0a65f3fb86849b0edd1159644f028746ca(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3c45458ab41d19b30c4a19621cbd9b7debac86d0bbdfc163f93edc1f21127182(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f0caeb03b1f843be8ab16d3f767023eef7cd9acc9e6df5f3cfeef5fb1e5c2de(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsMirror]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c51a5f6f697ae1828067fb8a5dee28482f5929622260c11701eb710349a821d0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d69f799a574bf6bbec8c347c1b869051a425354937a384c80b8e346175d29d64(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__da32e9550e5d6e2a9f9464a67172f6cbccef33566b97e3f6c94b35a8c0f3e72b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f6b506a68a7e2e56404e122cc6588a10c4811a9946ebd3168ee927a47b6582f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__817d999b4c69755bed6e13c1bf666a1d3c505cfd067c3a86606cd0fb82fd2f2d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e2bab851896ebcf8c39f01943e9634274e872635c4747812482c35825bc4dd44(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsMirror]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b4994950e438079072c0f1058d324a6865edf4d4c07fab846baef55aa6bd0a7f(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__944baef387b432b79395ca13b4ae9b572211907969845fdf191abebad983c5c7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f5bb55291a6b64ee9c432d70e7730bc1fa6672c107c50bb3f6385d6f3597496d(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bf7f5ec1d75489708b3ef34f5447db0a04bb4dd361503433404274848a23e02b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__39bbb2bbcc9bcd8ca8447893428f2cc0c9191d9194c50ecf052405f7138cb1b6(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cc2061b0e03333e2c81f1c51fd3a3e3a4643da8904dace3e83e0daadc3478e85(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__31fd34b490c41c4eb5f02b8ddebbebfe89f570f5d0d3811166e6ecf0feba4890(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsMonoHue]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f99cc3aef4104b796c50997c22f382da546b998e4566637327728eec945965a6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2c9753b0b9786f3bd118705dd2468bc700878b9b5c3a322d5c14c6eebc9b571e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__22183e9a623a8ae6256951a87ef80ed6e025e67ece7c601289d6339e800ca9bb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3664f80f00aeae027945fd6547aa6d1845789c98d4115179c6c1e63c5ab0dc61(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsMonoHue]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__29328fdcdb06e246114936d80e9bda6c751b41560464d2b76d211ca28e81837a(
    *,
    opacity: typing.Optional[builtins.str] = None,
    opacity_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bbebe71eacb52155a66f9d6641127debd1e35455664ea8f47d26db6be33520a8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f78e739cc73749bd7c68fbf9cb637a5d0c4169cbcb9652a9d2e57fc23c7dc411(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9c04546bb02bc772fd5417607422fb5c7b89b3b1df6c29f669a4cfb8d379968d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__763219467ecc927ea907fc2d517fe137c2c83e1872973d7a5abd84f9227a097d(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__47a67933bc3a24077bf7c036cab9150c79333e1e9c50c5644d1c391a8064517c(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d29feb99fa71be269c31279b9ace6a2d4edd6fd8d9a1010cecda12ff0a68ad0(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsOpacity]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9c013be158e3badfa2851717710a7a3d877d21bd335e3d60a3df83137801fde1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eb6e2efa17d6d21e06c70e2c2b29af98c5752cf1efc329d825f623ea8cf4f74e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__09f1bed5c423d58658004c62371bf6bef3ea0d722d1da942d02700a634788cdb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bd34e709203920d539a5468393c68f30cf357ba642a63c2f0c9923c8ca1ea7d4(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsOpacity]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__30672b071a2621a9a0bc9f79aff3c3ecd889155da7840788518523c8297688e6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a76264b092df1bb208f17950b62841b5e901fbbd0545d113b1a7bb5780f39f6(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__15c2861bc4d9a42d017096a93b526417ddb914bd7ccca4a0ef2471f11363fdf3(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsBlur, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__42aac006b14c7ed8d9da3f433942f4051727ace81f7d3f8f3db3624b9f4b218f(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsChromaKey, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a15e9740c390a75ff112d6fd2b76d9804804e6c270d10da1f8556f52003eec4(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsComposite, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__861271f55baa1bffd43de7849248ca3a3164318fdd062b23b02a973ebd8a1d3c(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsCompound, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e60821a2b5fdbc507bb5e83fcb8b0d40fd5dd8c15447df2836fa7ceb8519072(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsContrast, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b8e232a4c9e0d433167e26422421a657bc07d662fe45c59fd6ca61baf7e4ef51(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsGoop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0e4aa83f2e85c6bce1ea9f10bad2f61097c8e44b25e2e88aa53048112118ba7d(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsGrayscale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b1032b58831577cafe3a299b2709043a821df91dedf92cbe5a86d3955ed4f8cd(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsHsl, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e2892acd47b62bc4b8b86e9adaa54b053cb7c047e457f6dce3358aa5f9463091(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsHsv, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e2c7c9d55d740e20a77ecb7099fd295962d7960a4c9fa6926193173024def2b1(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfDimension, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a6f717071501ac027615954fb2c8ab65bc2b3602bc3030d3dc6fddfbab5cb2a0(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ed9e9f4c5c53593ced3e36bbf31d4dc9d0c6cb06f935ad2d292b8989633f0e03(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsMaxColors, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__99298aa652d0fcbfb82c9448af45510a3d48a9b6f4951ac68b713acce1dcb163(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsMirror, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7bc0ddb1d0a7a3ac8adf62bfc4256b13b1f72180fc82338a11b44748aacf1f7a(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsMonoHue, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a87b2dd44e7726cc2880c29a2201c05f3075346a96c0bda5a30045275d8e845e(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsOpacity, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4739d31ecf6db6ecf4f24d6852d45882e0034ac680d943eb49db6ab5d4686b21(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsRemoveColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f410049aae7decd4210203ef101ebe54c49be900ae617a37cb1c94040defc9f1(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsUnsharpMask, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1232d84e01c57ad90627756218763af9f80c2baf0265cd50994c0fca2c30a926(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformations]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0d8b34a32adec3b7ad4d34ac696cba8d50fe45001ea0329f2d0f028201072311(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
    feather: typing.Optional[builtins.str] = None,
    feather_var: typing.Optional[builtins.str] = None,
    tolerance: typing.Optional[builtins.str] = None,
    tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__30ed53995b2d62d126e199181201fd782b0e1ed6a88f6228bfc3f0d316e81b70(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e9b8527090bbda6abdee7c95259b74b2a947ca25af474f1958b21d89a9ef60ef(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__47a55b15a22ad662ba9f931a1b28b150bc95a6cc7084e445fefe9dc9ae449e67(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a1990d2bc12995de458f6e414698f307c69f8f636428bab569eacf1bed311268(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__54fc3fa71ef9b23292799a481e84656bf30b93da79ce265a113e6eed6e0182bd(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c492dd90e367523bda42aa739dbf577feef7bc3151f814f8f82b7d17d944de4c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsRemoveColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a5a344db893747295eee7c85af3307b0a6aa30ff0790a4501868b191913194b1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aedec6a5c578b3dfaa3fbea8a5c216aefab15cd574c19b9a9346f5d54f587a7e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__737ff7d5bb04f0168695144f9e61bfb6053a005b3b977407739c570d35a2215f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7078da25a39db724d3a7692adccc4a0fd94ef8a68aad8ef15a658880cf2afde2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__88d1475224b3fdb8229d333ecb5865596b99d20229528941bc9255d67d706813(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6441affb399cdeb47c5edaceb2b512b25f53e5bd6780a675f96de4479b6cf7d0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__26bfd664b1cf08f99faddebe4475b7e84607682d07edd6df839649b93cad65e3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc09e6e8a22f8a29eddac5c28336363aa41b18f6f8a6291657a6f38ab8300f2a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsRemoveColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8dd8eb10f88a30494a8219b3368ec953f5016da0961c257c41ca08b08441bdef(
    *,
    gain: typing.Optional[builtins.str] = None,
    gain_var: typing.Optional[builtins.str] = None,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
    threshold: typing.Optional[builtins.str] = None,
    threshold_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6cf95c0bb20993e31131c9ac64ce9fd83f46a916052274a93e187e4d97f75f7b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__32cb4a53ddb95e3247807c6d9b29f6e9a330114f145edd809dc436f241f7089c(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__47f09f95a28022df9178200df3c60e29a4cc77b8b4ce3ddc2e01a69f0136e770(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e1c6bc836176d92d70b3db3a42014742bec216ed2e5047985a67c58bad6feb6a(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__929cab9149f84cd629f67a326cc54629467101ec2ef80144fa4d8bbcb7017c2f(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8d18c5069c0d6e2dc5d9bebee4f9939ae1bba6dc6b501bcd9fdc1ce23e3032fe(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsUnsharpMask]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0c24fc1ecf5e09f1a386ba44e129b306ea550699ad561cb3df870b9426c6b4db(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1ebbc401b401474c1dc32d9008b6a5bf55afdf2e4d6a8f1ce100ad43f188d76f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f65ada1ae33fa7cef11b356f19e2931f9d877fd2ece8a13d72de82defb3e9c03(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cc37f0433fac1e9227ab591471445d6b8083f23c4a4d5c712a446c0ee25f3da4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0d02fb5297a6df611becfce4a781e44350230505af98c9b2c1bd726eea3209eb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9fa392f64593bcb5ed54097e6fb4bcbabd8a7cc3212ef3307d61c39e2de142af(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e747395014319fe956792cf130978f1b7fa2c1125636b2d164369e4febfa3ee(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__753fa13229812e2fc99fa11df9be6c75fa88975dcd39cad5699a7d148f1fd418(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompoundTransformationsUnsharpMask]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6ebf001447292d1b81d155d2f3767af91122ede2d7fcd6a1323d4b88c970c9bb(
    *,
    brightness: typing.Optional[builtins.str] = None,
    brightness_var: typing.Optional[builtins.str] = None,
    contrast: typing.Optional[builtins.str] = None,
    contrast_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9df785e9f33e2c2c41293d61657b442208aa1bc15dbbbe74aa5b77266611036d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d94793db22f1868227257786837a0e317910fe50f29170cfb8ef4d9cb73cb4bc(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e9fb52fd007dedd10fc4e77cb1eb52a3179f9341a478360ea91718c12f164be7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5c5eaf99e1f2a4ad307b89a2022dd6bf729822eebcdde3d35694131d4437a1a5(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__57349d85da0fd3286f0b74e788bd62fba3a37c70e7aed6097ed15628f46e112e(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c69ea5ae161127ec1fc4474bddd74c4dcf5b187c8bef5cbd1c622298571a7a26(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultContrast]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__58af10a90a1dab357b9ac4fe65607ec46d412a97556773bccdf639d5dba70c63(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__19f77ba0eb605fcaa645609788625f86889a85cb85c934b27910826060c8a7c0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7164dab67045e19e4306c27ede7856c8e120baea494c85a5bb93c00298e06233(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__42ce0640d5423940698adcbe1b36388dc57e8e8a50b1c5858dcb93b0a783373c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d4ba5886e8c569d191a9af3fea0b0049b22b2d604400fdabf7b344013b165c2c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d684045c91bc92cba927417c12736b685695576b91ce7d28fa8d2ef37022b3d9(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultContrast]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__902f1ac016bc9e6c3b2bbc06c3793fc9d1e39391c6511a05f1d9fd1b99149e66(
    *,
    chaos: typing.Optional[builtins.str] = None,
    chaos_var: typing.Optional[builtins.str] = None,
    density: typing.Optional[builtins.str] = None,
    density_var: typing.Optional[builtins.str] = None,
    power: typing.Optional[builtins.str] = None,
    power_var: typing.Optional[builtins.str] = None,
    seed: typing.Optional[builtins.str] = None,
    seed_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aa739973034ce8d0c6bf6a27b3c0a8cb0afea18170ab354426403b85303bea11(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__50d2470ca06b438d1e539f0ad586f4b33008cca682eb43256d0c3166f6e01914(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__525fb4f1a2b535586a48656903d2832f84ea81725c232e2ec3d2d2eee985decc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c13c3ed9f937f5a0c9835816dffad9db77895f288becb21c609639403cd0ee9e(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9cc2a6c61bc32a58851154e52120c33442c836ea4eac6f2ab43fca6520180583(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d90044b13d6635615b40bac85cd98931753470f68e6032f52f4bd54ed3367951(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultGoop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8c82ac8f8dd96ba361e4311948fb2e0ff0927b4d0f4de2602d7f2ccbb6892d32(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3dc4562dd50136123f7704a11e8b3037412440fa900a03fefb7d3c3f68ab2f1e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d6db40e84ae1fb9661be20130d4803c4a5c7a71c68b25a8a163dae839d38585f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__095e65e7340e662aa79f5e955f3554f6d0dcbd797d1ba1ee160be254470c32b9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e4c520a87a14d10bc59457f0194918de8929279c6ea21cf9f64374978ab91ba3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__87a14386ae639294f4d3e6d4deefb353546943aeae93df4a52322378b27350e7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e65988987680213d3df4d80c14f289af07dbaeea7b26fa23c128aeee1cea6161(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d2eea36ff45ca3e501d616203bb0495daebd578caee403e69b156ae34f02b31b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9b9bf91560293183cf5536b97ded85f863246ee29947f7de02d44e6ada961fe1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f52cef2158127e47621e7543f46c2a0a39a34f274536752b94d1773b9fc6a28(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultGoop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8d5e8bb70fdd88b7959b4e06668df9794f5cab664b4058736b19f94c1a945e2d(
    *,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ecd70a2855efa825c19c82f032920b7931c84ed2918bf9dde883a83fc7389711(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__39a6c007207bf873debdbfb847bcf53571bc442153c783180996950a4760bcc4(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bdd6952f4880fdf24a122ed53ace13974b82349d30c29943174f76ec6c56cdbd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ee7f22aabdf14d124c49c938b256e05fe9cbed838413d80b15c08f67a9a3cc34(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__88325cba9b9375ee9c5fc8412336ecaa34667934a15a7c8671d89bb8be46fd7a(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1964d6504659e989d70e1f319a48754a2a1abbde9bb536c4632a8c51d4e1f2c7(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultGrayscale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7f937275b23abcc05d417483f20335bd8d7281407563a5a73e8241aac171fcd8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ffee2f640676706c25b16791e26399ddf59e9fbcaa75b6b1642be8e40c6a48d9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d2797a89cacdd34d518ced678f69a211e012a7a2baa38c0b34949a7b62421a5c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ff3d3f85c9baaddbe4f5b8b309700c49a7bcd1e3809f20fad81083bc59f507b4(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultGrayscale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ecd89b4c2845a99bb46384c6887c7fc9ec98d6f0e0b94112a29714fcc9292f79(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness: typing.Optional[builtins.str] = None,
    lightness_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__174c0281840504184b49b9368339233909489d35cac72db431171c28edc9c9d0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8b61065da847bd79d4a33f9157ceab924750a23290da076751bc6cedb7a89402(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__934c7b3e9ae512c867e25601067a705e57f879d2d26127a5b365b35d7b8cd69a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a04d9b378464e4b8725cf2982bb1c510194f373a1e62ba582e9aca55969f270b(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__58ff82dec824f4a6f0094e14a30991ad14e9445b568dceb40309778fafc4f7ff(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__253da17d7c05d7436f96dfe26c004da1f8a755f9df6ee41a3361e5bbeaeec05d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultHsl]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af24be336e0ce17f62bdd0acf25d6eab97dd9dfef63de2d156c2a35f9ca709fc(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__291a381eeac233931839e7754bb914618129e83b98c1b66ddf00d6ec2c3c0cd9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fddabc47d211fd217f6faec639138a9b5bdade9be2934a310dbc8817a4d35a42(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d652937350e94f0bca9a283de938bfc309072c8c94c64018432377aa73bd23e4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b2e72e8e762cb231b8c0f807d2c9bbb2b3434059ebc3c8df946ab5c727bc7aab(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4e7df423d0844168b6f49cf6b0277979fc555a89f00008adc37cbcd5329e80e1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__958401d0208baef7e3b70dc888121cd4e091f3a860f0f9e8ece91575f5e9ce39(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__021aabcbd1980d975f3369984ddce298319df9317f01ea52f6d42536989bb7ac(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultHsl]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fa8cccbce46461b8bb8ad733dc1457ba1741d5e555272fea8482e1f0170ce032(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3e982edd8f33a486fb64e6e3c9e2a71271d65c1b779733fd2fa619e4c61320bf(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__45143cfc70bacae879a93a2c8438fc2338183b925ed59041494f2c275563c255(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9eb6efddb453d5781489da3132973fa6d9529dba88fb0f7284b043db605b38c8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__efd0aaec0039ae29270637fb5a30481c46e6fbf7c71e501f20f7a855a5575c0a(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1d8edd76c3b56414a9c13f510c87f8395e9cd23abea52ab561db468dace37fd9(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f18ba03a0c499911e2736b2e2a41bf1ac18f9cbd8afb5d1ef433481886bc8ae5(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultHsv]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6178a402a96cbbc61871807a9a6cc425279f586811c737e2ee44be90f0e4234f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bba59be36e15d15f4fc00ffac148b980b8613838c24e298f01b6c3dc90cc7f29(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5de41df5437f661f43f11840d56e119baeeab64c0385954a1bae44b038c652be(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f7e9e999053f57051639591281324c8bb6c21c93608f942734c8c577e8ecd765(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5a07b9b9c905f1cf4b617a5ad65604c5f15b72a8683cd9376236adb701583902(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__25e2abb58ff989cbacd866f87020d1525fca86244433489297840b56595a46fe(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2aab664bd1ab21a93ebccd6ca24728eb6bb0a8b365447281ea60d533b670f4d4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__697960b8d1f3c159c056470de26709e73d2a7095f7739ae3879002f942dd3282(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultHsv]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__98fdee42a073c53351a2299c26209e0307dc14b69b7e60446d25e0e1c57b22d1(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    dimension: typing.Optional[builtins.str] = None,
    dimension_var: typing.Optional[builtins.str] = None,
    equal: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqual, typing.Dict[builtins.str, typing.Any]]] = None,
    greater_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThan, typing.Dict[builtins.str, typing.Any]]] = None,
    less_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThan, typing.Dict[builtins.str, typing.Any]]] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b75c1f01c16f7ec6129802e6ef6b01d4d8789b276f07f83c90036229d961dbb7(
    *,
    background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
    chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
    composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
    compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
    contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
    goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
    max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
    opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
    remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6401beb3dbce5014cd4ff0bad4b9b282f2961f9bb7d63d43f159c87e1a584320(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5b2f22cbf56dcf0cbf9062046af717de76fa1cc800a050fe8b8ef93332f6dedb(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dab92c8ea2890ad7bcff746d716b37b63ac638850ae7cbdaea7e76d19c2c26aa(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2be91dbbbc2b6733f2a23f093b29573d0255ae11184d5c0b7a3e1d9282d82b7b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6dcc6c0976d1efe67e57acd9806b9f01f7f71cd15619ef419d9f0dbc80557591(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb4704747319b43dc64689f5e9d0985e90618fcd35ee78e330f8e5bd64d10ced(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__564040eb99e9cd3fa2a36741f34e812ecfbe46bf80c15ebaad496de974be6279(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualBackgroundColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1d5df9d7ac073fd835477cd8d1de6aa96d005a89ea03c5ecb5b8c86030065308(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__935e66051e78d30fed5c5049d1acf0a5f97cd13163435aebcf435f031680f808(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d0f110394f6c8db6fc1d06b0eb4b3266eae703632842c1705c6a54f38b66a8cd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__58ab0a34af5a9803e26d041ad3b06b7269cbf5ff0abda7aa866ec002a04a0a93(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualBackgroundColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1a6c919d974cdd1f8122d965592d1e7690d5526771f52199cf8ad03e96b87fa7(
    *,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7c0359a840f8d69101b535d1d77cfd37fd96c9c39ca46e0296f4e7023592e0ca(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d2023aec000b26ddacacd8d74960cb59656a3183c85b6264b76f42b1ea237183(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5a0131092d21808061fb87bdea5501b032b88910dc7f3e278f796efbf9794403(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4bb6acefb931209c2476ca822a29ffb35f8987367dc5b52282cab9fc03b71eb7(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d86dd9ed3efae0796659cff9d03dbdb1e255d14677a6c50527d6f7863337860e(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1de50dd19df60417676549793bac03c1271b26d4f3909213733655c114970454(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualBlur]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__912b56a01e82fddcd253442bf914a28a4a0b5b1260a2ed6237f02383d1e23306(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d7e8f8e0133946249cee93e80954945fd6d852813f34be53b963e6d8fd3a7a63(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__124e43a3219ae90664c3fdd2979c09e1335fbd7ac9675fd4da54a3a19b1c8596(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e7b57545583e11870c688ea9e64b3fa57ba5c11d7c0ea9d612b15338fd9495d4(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualBlur]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__007b1698748997797532dfec4ba2576eb085528eb9370dfd3b0b4488be6d8448(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_feather: typing.Optional[builtins.str] = None,
    hue_feather_var: typing.Optional[builtins.str] = None,
    hue_tolerance: typing.Optional[builtins.str] = None,
    hue_tolerance_var: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness_feather: typing.Optional[builtins.str] = None,
    lightness_feather_var: typing.Optional[builtins.str] = None,
    lightness_tolerance: typing.Optional[builtins.str] = None,
    lightness_tolerance_var: typing.Optional[builtins.str] = None,
    saturation_feather: typing.Optional[builtins.str] = None,
    saturation_feather_var: typing.Optional[builtins.str] = None,
    saturation_tolerance: typing.Optional[builtins.str] = None,
    saturation_tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__842ae8ed796a78dff3255730284b51a2f26b9cf978a43106b2094575e02c075d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aea7b999329d967606f6110ad5955dab3ecf374b4a0b7d2e456064de21dbe5d8(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ebfe20b58a66c6c6bed54be893bc2a1335343beae64b3702577cdfcf119f37dd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e4a0384a13980fe5a83feafa9a56b5f63af18ee3f81cc084a6095a7e312e659a(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4be24422e357f89598fab0224239393ba9019e6b19b03e215be11790f1ad0fe1(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fc3cf809d878a3abe015c868fe0c805f38c30e67761c079e71370bc4ca600737(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualChromaKey]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__da59a2f08d574da02942eee1971ea72c4bec57d5d182836c1a44ea5958223399(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a12a4a0f6b2dcd29b0f3b7214e56f50a7c2be642f57687a9fa34f2409ba759dc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__80352d811510b2d12206e0a7107fa202bfd81546b2e568c7be58e9f4f3a6c1ad(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5401ebcbe1df2ccebbd5735ee9791c85966f2e6d923ccb1480c5fc3455031737(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ab25c03afc7e49b48578efdc2a9c3373d3f8ff119f99953c2e1418d93bb9c1f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2e64a293b62b74506e637020aed914ea7106c4eac6a325aa994d9db8f3fba4e5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__257adb3ae416bd6dfff2c2919665d9d407eb285faa4e6cbeaee1a169eacea1e2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__10de4408311ed121e754721165bcc9f58190c12abadc9f7650124f61b8dcee9d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eedf92140ff9421b0568e0c96c6bbe2c810c5a0c4321b16fbbb94a65908461d0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f353e85067bfff0def48e89a7b5191f65d4e9841af57e1b22292cc2b7020fc5e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b5b4201581aaa81cd08cae9433efb36204a4a2650f38af0612402a63f417a195(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8630840ac8916c783f283c03950247f54e517f12b4b896eeba55160d12b637a8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9cc99dc40f8a6d29e8276cd339fc4e689548886c0467bec263cd2a26d7c7c1c9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__81cd01640ec14b0daa24513bf06fb374fce0bd4ef52339f3a5001f7a6623e5fc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1e95639c3c71c200dd868173dc34f7b2da43f27b456e5ea63477dc1d05e4aea9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4596029c75970dfac6e32c35db1d1e0112a68b65f415be65151303b1dda53ecb(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualChromaKey]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c21466378f6fc7db571c18023f229cd550625d7d5830e6c603a24de764a157bf(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualCompositeImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    placement: typing.Optional[builtins.str] = None,
    placement_var: typing.Optional[builtins.str] = None,
    scale: typing.Optional[builtins.str] = None,
    scale_dimension: typing.Optional[builtins.str] = None,
    scale_dimension_var: typing.Optional[builtins.str] = None,
    scale_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a249830f295f3a8111c8e0bd20cb09b6886a2b97eed27633bb29c038e5b5831b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__90d12082c143cff5ebe9216b0854c146dec8331a731b66d2e5ee0f6f432dafa7(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualCompositeImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6cc133c90815baefea34217f3f44a2144ef535fa4b2039ea2535b90e8ee6f525(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dbc379ad690c74e491986db4efa909d472486f1d5af8d1afdadc2519fd972fdc(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1a9d388195778f6c7a2666dcb11d82b7bdaf4de0f1ac1a1b4e3c1383d5523473(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__626305ee259d1c86e2a256c86cb4aed34208bfa3002fba7754e07514cd184498(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3fd02651ca57adf1f674ae0f7a4f808a91ef0b3d850ad52031f9a14d2568ffb8(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b65daafd78687d2e02bcec286da26096102cd4a4c295f44eb1b4714b1581c8e8(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualComposite]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__de4f50d42d6a0737a0616e6f2835cf52b2b2386d62fa929bb9a0c760af34bef3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e4b76c1d8d68d87f943ccbd1ba8c76e88411d95a75b223a66ab253859647e0c8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a4b336d99c961be69f8463c83f5ad3ca7f4c814f7ef91583d0a5780fa223b9f2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1cdeebc50ebef935528db3cf305d6aac985633f3c23154110d3ded1b4eda9652(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b54fd50658258d847d6bfee7d89914ba625ea5d1ebf4f001d13e46d26d7b2f3e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7b53b2b361e0124647d606db405f2a23002820eefce33a12ccea4f63bd9fdd7a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__89f30cdecb884910a508b6c6ac519cdb5ec7d473b2385fc7186dc6f79605fd8e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8446f492c4e64d19d4a20b137a6f6b16cf234f0ff9d2d3fe2705faafe3cf9107(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ed34c22d5879ae94c15db9800b8b3ebace6cda0a9bd5e25ae55ce92b0f171f1d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e4a40bd1ccab670cc11280863d243afc36233e449bf351346b022dcb4f12ef75(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__087697730d5ae7206a11f11675f9a59ac52131a93d50e9a5644cf4a7a757a1e5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__757d836e8fff0e0d100d653ec45893beb1a90dd593a5475b79d1351b425dcb02(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a19b54777683c463d9b4360b15f33bafda31230047eed0269f538f5ae31c5c2b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7ba5c4a414d5b6590550082346331023773d8b47167d17489883c97fe3f76376(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualComposite]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__430e6b57bd2de544bf59926c738a5d6e9cfd1cd936b6b49e04b919be8b827978(
    *,
    transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__97ecf8e9223abb95e70e9aa2bf28928bd8771cbd430828cfa1a5bf5acc4a1811(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bccc3bf8abbea4d6a0f598f712e2d5137605288630f9aecb58c1984518641c7c(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a3609cb8ab15dbd1b4d8f02a1b35aaf8cf907a7489e79cc78564cb606180621e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2c6845ee7d463b556cd4d684cfb1ba8575282c70d765e98495243c4a730ca90a(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__924602fcc8b5334ef22f7ee9548ede969bdfc1d86cff6801c2957b55f0713078(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2821d3b92f0d4b7092f06b07c93606ef3cbd0776c0b95aa35cc17c9a565698d2(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualCompound]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a3215b9631fcda5bdc89c289479465f8371c6978f0ec3a592ff7b6e4fe4bcd57(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eefb322489e4213258f319179d4d3f2749addf67c5bb302003f23e01ca9b1734(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df3fded13790b553bdc13c2f0cf7efb84ae453236d7f45d86d3927817bdcd0fb(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualCompound]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__628cba713061046a070ee5b0100a027115340b53c9e9ed6810eaa57572932700(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5aba76384ac40b3496afd406e0037c34c0c4171aba59e77a353d06edb86c7293(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__69bde56cd6ca0f288ffa9c955c4230b0b077ebc1d4e5ba91a4b58d17d23e1175(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e7bacf2f20fc29c6faaffac0c86ecb6941a104240b6ed1b519f8b9451e3a9c88(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__623c0f3548248af29d7204ff11822fab24c4543447abc55a6f02e247488b9847(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0e533cf80b379bfca4a72031f378616ee30784a78e58973770fd94931c7d37fa(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualCompoundTransformations]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__64c48eab53d3b30ab46b499fad5f7e8be85f8060bedcdc257f28a4292075e22c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e9b59c26a9e493a9429fb7625c80dda90d2b4c3ac7bd4abc8c973a294820af01(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualCompoundTransformations]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f8bb3459fd138cc7e35a83e1bc627771e95e5355c82948f7fe35020ddceb327(
    *,
    brightness: typing.Optional[builtins.str] = None,
    brightness_var: typing.Optional[builtins.str] = None,
    contrast: typing.Optional[builtins.str] = None,
    contrast_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0f86c837d3cba7eb98f3dcc551eadd9c78bb7c9bf08312f0dbe98a0faa26a72d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb73df64b4d8f122a5f53b9bad5777610eb40d520c29b0c8dee702cec6e355ab(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fce84a1b12e14f2cc6447177cdb4867ac641692e3dea0ace6b1ce84908295214(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1a5358f7838c05ece3b6470a8da846031eb2dfea85941dc844445637f35123cf(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d9061f1399a89b4f3c61676c6bfc64f7a9e5d93ac24096e09928534555bd2815(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__db3b0c369b0bf5484ffc7e8bc8a61b94130e7be6a99185eb307287f445aacf56(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualContrast]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3249dc33349490329b7b39dcf23970acf424271f3b480cc36df42d963fc0e302(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dae7ec8dbb6b52f047fee46f05199dc33d4e0f2ebe573b5d0711644bef91aea3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__36308cb5dca9001b9776d0bc1d0accb1b0dacbad25fe96a0d04a1f178eb35141(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__382d26b750b281f716eb60056ff04d083d36a45ff0203fb7275502ef19bee84c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3666ef8f1da2919c70eae2e5a39ab8e862ff5a5773ccd068b6d540aea6f61f7c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f55dc7630d4771bfe1e1981878cfc4ce881705b471b083d46cbc99831cb1228b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualContrast]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__15e2687d1374dda0a2706f8f9f3b564ac6e72b949e980ccd61237d4cde0b23cb(
    *,
    chaos: typing.Optional[builtins.str] = None,
    chaos_var: typing.Optional[builtins.str] = None,
    density: typing.Optional[builtins.str] = None,
    density_var: typing.Optional[builtins.str] = None,
    power: typing.Optional[builtins.str] = None,
    power_var: typing.Optional[builtins.str] = None,
    seed: typing.Optional[builtins.str] = None,
    seed_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c9ee979a9b038b7b9f7ebfd0756e9411d4a7352d23f9f6cb8341672b9b4b6068(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c98a6b91c45a69632a3bfc35a5cffb64770d98231c99e37a35ce7ec1fb4c77be(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eee5b520bbd35a22c27beb624ad08993ef31103e3f528c588a064f61ca0d14c7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4383ac2798c104c649582a2cd213c683cbc26217df29a2acc3eb93d77b95bb79(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__88949a685338262ae05b2afa937e09887f6daa650e208dd0840f8885f9823dd4(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d23e6b83cbf22877634fb883a08e41d7c4ec1c78353e07a3940f8a371d2d9a4(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualGoop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8168e6194efdc2991b76c0d4d57207b08609508c3555c91975576d9e7c87763c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__317a986d1ef4ecf33e78d5500f96d94b91bd81f3b6589adad7c5b8d90b8dea28(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0389134764a3df29f71fe42cf0f2cf3841af41361dcd08482955e42f53672c15(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f6ab8befd3690ec1e87eea0836781a44347eab73af9cd4e50c22ac3956d0c9f4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cb38fb9ca76de69ef5e891b66f74f3519a502de86672e20fb198a59971896cdb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e893361f11f29a62f5c624150e1ea323440e9d96fcd5e58416a7b54d7f1281c0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__58cf3809ebc72ae587efd7a9e44da6c33daa4c7059193dc85a8f15ae4a23d892(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7a8fdc3350dcbcae2207e5e2e201ce37bb39ebc00843d313920355bbe127aac5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0557788163d114ed3587a7719744d6bd9df72d33bed69f4efc408ee56bdb40f5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5dd5d428b701a9af6596b8fca4af51b895a74cc83b8bfbc55103991d8612429e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualGoop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ad21d808ddf9ceefbfe67e471d379e011d70c830181e9db64101b83150ad4528(
    *,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c99bdf413704379ce5ebf6197d84d3e310c14f91686e19f96c8f77b68e1cba56(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e4529ad54e218ce6a9ae76f9bfa5f557755bbaabb3c3d096e5b754fd7894be5b(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a3e1e9f761ae29731eca76630dbd733c120cdb801de40d2a872a53da0ec8f5ad(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f02738ea79b64878189d3862ec1beb93585d42b07d6877342c02fa04d5161986(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6661061cbfce6f22432a1773b81f1185a94b89d87538c6078016046ad4c58e62(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a39e120e19a9da4d1c6de358f870c1d0702eb08e5d0e083620e6f4d3438f13ef(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualGrayscale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3b989b14eafc8a2b4cd5bb66f992c6a086357b98980e3949c55b09f9f6630424(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c016b914f1f705282c4dec3c1c3ff79183d29fa3a212cfa8c065c76c2890f4c8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a0149eee7a2499994c69deb2db87bc0821116ae1c77ae99ab61b30d825c276e5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__151e5b33d16caf1b26832e34d8d145979a62e140ce03ae0de1d98da83a7fa4e5(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualGrayscale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__91ed6f35b548a2f3eb6c600e08b5d8b28398f710168bedaab9153c806dc79386(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness: typing.Optional[builtins.str] = None,
    lightness_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7fe5623e0fa8c604e9d30d088205b9dcef5b32f65da0a160021ca5b51219f4b9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a991866504b2fcc5799f626835131f4eb42b25731fec54885e2b9ae4afc8cc68(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1feca9705bef2787853bd0e68763712a96b42e6499bea2111428c372858e4f84(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b07a21474009f1d4bb3d2fa726d6d711d982fc0efc7e584e6714a90aa66fb5c4(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd938f1409b7b7d931e9d9e19b9754c55a500e7e2db2491c04654b002faed47d(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__05262a78d36d7feae5d3756dcf98df2af5eabf574f06ec2d0179b38d43821f54(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualHsl]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__66abc18e5368f1b7200c7821a09aad1d80b307b24bc84cc45c40902c53bcd537(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a42d2a6ad1cad279afe97b5a20cc237ffde9a3fa4e960f5befab786ef8dad94(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__53a7e71370cbe9e21ef61175efda2033e65692ef47af99fc106be9cd99e02e01(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3f8b738089cca2b2c690b3a96b720c6fdbb47df1992e3c82d80cbe7da818c413(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__83aded0c17fbed414d83119ab636c85942217e1a69b1521790a6cbbd7f43cce8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f17707f67931d9c9540501c6dafdeb2ea6110d84dd39fb8daeddea031a7c33d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9f4166dd5e86ce5c38cfbab76efe1c0ef7f7b82ac9b235dd4b7fdeea3c599821(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__22fbeca720678a0c1ed0851ec29109a820f2eb8959626b5e607ffec6314d3473(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualHsl]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__58e81929fa1c0ede5469be85d30c8eb937bd59cd999700d58a963dd7f865762d(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8450bef7806c14fd704e5163dbb0af20d847a7152950cb11a1e79dae69c0ff78(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0bdc06319c0c65ae91a9da25f4e9e9111efb30cc8087d321e163a1cbe6f7a9c3(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3cb609b73e251620cc476b78ac4f8ce7c4fb32a1b8352cb5554c3dc25fdc0f28(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7e3750ec74fa1f542f0df13ea90070d69e311845a9c09139f168c8acd849fe14(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9cc421d8435ec13fcb580d5a2e74f68af8a4b64b25c934080836f14c7b7deae3(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bfcbebe3593d8c40cf3cf13ed4165a255dbe4e6d638ea893fa6eac8afe28da81(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualHsv]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ae8f8e41f585a04c194de10d115f48def6beffddb1618e36049405d448a62614(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__47d26b4d5ba8bf9416978d25ce740b0d866d6ac1fde33c546b971d009a9758e2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1109270fc81df42daaeccc880bdfc444e324808078ad80b089f423e3ebda9994(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__327589ef50dc68461a75c1a308656d8b4492fa6febc7e57234ce3864e6d8d0ea(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c48bce09ffd6a856faa94f1f6689e149b56bb7c36c2e937dfd81e508d20f67e8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6d14b17142ec677eeb1b1850b41d18aecc1baf7968d667e3698272253a3f3b3f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3953cbe553ba4500be1bce74c0b513b0485a662053280bbb2a0896ab3aaaef6f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e24f822cd899d4018b6651948daaaf1e9fea2ab94bebb6efe13b05b44df1f006(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualHsv]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3c4e5deb87b20737137e741dde6c20dbf63bdc151a08dbbcd3f33c9227282847(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    dimension: typing.Optional[builtins.str] = None,
    dimension_var: typing.Optional[builtins.str] = None,
    equal: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionEqual, typing.Dict[builtins.str, typing.Any]]] = None,
    greater_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionGreaterThan, typing.Dict[builtins.str, typing.Any]]] = None,
    less_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionLessThan, typing.Dict[builtins.str, typing.Any]]] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__56d842f8b0e787d1e7dde6fae6ea2a6cc832151fee1029ed68b62809491e2f94(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b94e5eee0964ddf089b7b3e824bbc919f5ca4fdb932bc8fab269de558a1ecec4(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0493f8a54c96a776d5c47a014c94fc2a41f0e1b1435cdd4671ad7703dab3b8c2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8c3644b6ae54b5e9f5243987eacee5f8a229444aa39fdf9d1b213642aa0622bc(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionEqual],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c234a4ac08a26e70e5d0cee733fc3d10546686073b2ea6bfba621ad761a78adb(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__53079379c67c29b64f4ba9fd55b71d87902eaf84a2333a473d957e76dd488256(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionGreaterThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b9ae7720993f0b1825a7bb94db9dfea3575539e5324677f1e46831571abf09d3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__131db8f53fd0e931c2f0f04e5d9d3a29c58c8e9878766654d8c36ec8a0ab1eb1(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfDimensionLessThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3c9c95e2596cd619fe269949eb14a4299c68abac904c410b59fc643f85e3bdea(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__07ac4b2323bc513f42797183eaf5e112b8023e681c1741c0a3607d907872e5e4(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__930d47953f8c1822085529ddcbfffb399675f0a3c673c43334343098eab3a970(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c9dcde1bb32866047ac0be927a9d9df20e135dc93a79e17420a41ebe08ddf3df(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__efdc077bf94f8a7919679d410bf70a17d4678bae0e244dbcc06388c54b6b5df6(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__020e12263875847cc9504e8c12bba6ccb60e2dbeb865f1778ee82ea9bd2568d1(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfDimension]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5a192befac224d07a71114d5bd677d119e6a51baed7017ea3ebe622294859812(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d69a95d73c373ece12b1ddf4d727d2f37f721b0b95ab243ee185917047a24b34(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c27e26d8551067d9c1f7224f4ea45c5286cabd895d849227f10e149b8b2f0100(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d31356aa60bd7fe9c30f8e5baa21d5c35b781dd47c24ff6d42bc64aaaf0a820(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8ba06b8fe5b388a675561f259329105cf6ac72cecc61c277bbe1ab9e77551181(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__855137f1b57d756fcaca18c03ddf00b7219074a484c2697c5ee02fa17a9d77bf(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfDimension]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cc7a2f46d35a81044394fd9e71e2b8c66ba052a2f7a040dd636c4a161b49edfc(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    landscape: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationLandscape, typing.Dict[builtins.str, typing.Any]]] = None,
    portrait: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationPortrait, typing.Dict[builtins.str, typing.Any]]] = None,
    square: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationSquare, typing.Dict[builtins.str, typing.Any]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1ff4ebc4f1d8e401e11e18efc94ad26040e38f13614f6769dc591c48ee809d05(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b073391c4d0feedec5275faf10088f95ab8f6a715ccb87865d621eeb698e4df9(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ba186dedffb8004a694e23ec274d237d878e27d82bf3b6ada52343bd570b8e5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aa56192128c9f20190fa4fab9876e3ac6169323d15815f4551c8a4f3239a3cc8(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationLandscape],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c98617a685a74db418387a4fb006694ac2f0a7527c45529550d43ca8460b4125(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3991a67b90cff75681136e985bfe758482f6280ed64d5ddb18df611db59e0b25(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1d958a82ab966bf9d11bec766219b72f4dd15b6c90eaddf77e88c188b385bd5e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3378b51f4a877397753d422d778c6d0fdb8fdcb0210c0ba780e6f5417b20b9fa(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e08275e4c03dce2369cd8ce0961bdabefc0be294cab6046c0027e0d8e236335b(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__67a3568eb968b046729e0f65f68fdcec2ac66473ac4f3deeef59ba058d6f7814(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfOrientation]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__77e3730c805a54279421422985bcdb29a5a67e0e1cf0cbaf959c98add9fd71fa(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__053ead163539b3a589f8227673008c743805844f9159ff953b9757a9b0bc42d3(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfOrientation]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__da69abe91456c4d5f457e4b181d35d8bfdaf1056c482736c7dc626c091b090c7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7ba0daf9daed4f5313b8e3702aa1e9a7064231c236608e3d965f2724aeb2e8b8(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationPortrait],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5187bf21389bfd5a5097125c09d6b8905e2963f3cd354d3d30231ef773c24e2b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__91f05a9bc52566d563cf5cf0558a75babe6efe6514363500e663050501f2df63(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfOrientationSquare],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4cbe310da7a74efcd97b4aac947b47e91c1d7b46060e425bf94cd3151c07f7b2(
    *,
    colors: typing.Optional[builtins.str] = None,
    colors_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d19847ffbe21b47ce64bafa409571bd835da4a0bd2c39ca680333deefc70ce28(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc44791cdb1de977033c7e08f97a95d2c6aec066766bf7c6ecf28a6ec0298f1b(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__22528d2a6b16d23ebb9c694128683f5c93b7ffc3c7414ec45f7f96722e0de392(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1bc3992c5580b41de9302b686b0c7b1783415a4132f2eed048e0e32c67584119(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a8415b7d10be2721dbd4a04291b715395a408aeaae98fc02182d68402077e16(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6a60177f154a162cd48118a7e01742edd5813e9e736ffac12d94cc9bc314fed9(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualMaxColors]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__647e2f4bdfeb361a52995d9c24cb8c0c8d34657b31dd8bee8c239babe0ccb8a4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__29a9338bbf6f6f6ed57e07fdd4ff3cd55dc02d537b950148570420b5e10ad0df(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__26428f03d7983939df73bb8b32edec3eb17c4a930126485baeaf323baf452ec4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__139050747a864382f27763f35f2394e5bf6302f3f37ae1ec51cc7a8a8e69f6ca(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualMaxColors]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6b2c117356d4259e1ad31ea0978af8444cecfeac47c1c870c7d5819e9afa5f92(
    *,
    horizontal: typing.Optional[builtins.str] = None,
    horizontal_var: typing.Optional[builtins.str] = None,
    vertical: typing.Optional[builtins.str] = None,
    vertical_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ed3434c48bebef8f59e5aefb2c1e6b63c74f82eb0feb5d5d4e77c86c7d26a9f6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5d435f1edcb2f2e0ae687d80f3be217c82d143cde87c6ff3788020b398beaa85(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__970197595e5fc191297e455f07c46bfb1f4f66e20d0ff1cf925de45dd8e36dfc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aaaa36006c795e8d662eaeafa84521a8fe23e3b678f6f60c6ffb2365da8f2617(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b15caa34e22f83b80908d5129c47515fba491f32ab2ddab8af4556675c8aad2f(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be6e3cb9161cf5e8927706486913a70b9a27c09ea5e468bbc10a03fc44ad5e5a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualMirror]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__def720cc8234b59c318bd215a85466b2ea9625116124852d4f6c7a0dcab21678(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a27a90bb21e510a6996e32062d18f5338dd730e56d4932b7fa37a55914e6d659(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3b6ad1e16a6bd420cf3de9962bc7128ce7c2854b675e1409f81b24af8a619905(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c7b97b009f77145fcf896c975e5524971e665ddc1f29ec38ae23aa81ea1ce61f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b7bcfd64ec82f7c5a060e28f4bd49ebd1c0133082c7800696ae062a7ab377766(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4481b87079191f0954e9e62b1f51870b3b26dde695287aa54c59a066dd45b082(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualMirror]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__753089555b321906be44861fce62d7ad2a86ba0470e7717794814f647808c266(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__21680f6b1fd0e4ac06036dd2b2e92c1601302cdd211a1ba1a582d60df2526596(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6be1801399a8dba0321a08179186db9f323e45c5bfc37325566cf74d685b01ab(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fe64a3ed231ba8655c11a43c593b355008d69ba4449e84d5c6bbfa922630c2e0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__10e2fac16a89b75505b7c5e32ae365a940c7cd0e02c7e5c00fa418ce0cd1c678(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8aae8f7558887346f70afc7ab18df5c9f9374d39744e23ecd62c5ac2bdbc776c(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cba062631ee3b0b5dea310241bf706b396447d4de7c7438e77c56e6b39d4bfaf(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualMonoHue]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c2fc855c28ee4f9c6d70413f08118849c066ed1b5cdf0b2bc684dfaafcccf358(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f54f4decad4d2b01d4302bcaf38f1caebfe3257dbf6b83410c1da8e235369917(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bd8dcc9695634c056cb8a7ec1220fdd67db88b72a8f8ed628d4c3eb1014d7291(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__90a17f2cee0d389d3d66430e295a64cc2217970ff198f037969e57b9a89c38f4(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualMonoHue]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__18b38357dd5c088cac2522f009a1e110f1414a4775f40b84659e1e6b1f406b66(
    *,
    opacity: typing.Optional[builtins.str] = None,
    opacity_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4d34ff3b3f70310b9d7da6f003f3bcf2d7087aea61de8f177d82fef282649d68(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__34d823e6fdea65a2f19d99a08f494af9713d8c784eca285b9ec07febfb1aea55(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8b35b7a4e27bf8c93f918dd9a2879c6907ea8aa1f3dc3603a01f6b2e114f9e6b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__47b20aca2d1d01aba7e1402cf463e659db28cb4b114b20d5b5a1fd2c0d5aa33d(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__19574c54e57eacec681d8768d27844b7eaf4b875d945a620684a12b5ab443deb(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e4cfb97e4fa2074ede2392b126636bd4444e153cd3f3c0835a579de15fb16bdc(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualOpacity]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__65e9c91ecdcbc9abcfe743775c2f69666e8bf404f548d6abf66ebb26ec7e0c59(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fbcebd38afe129b747f960281caff03960e4f26afae5bf1c153ae594a0f34b8e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__89b519be31fca106860a11f153d9175ec1e7e750eefa4956e8e96e412fab5b21(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__85f9791335bb2c8f6a03de35a440c795960d7cca34ff83a02ad36905d695b61e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualOpacity]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1b21eaf628b9da348ed63d4448dc8997d0065acde5faf0d7bcee597b1c2f5c1e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4445a277b1968b2db0ef5ef2a1a6bba599852b127ac2ea7d0b69b6c58c23afa0(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c2671472d12d81cf5e8bd8fd4ee7a35e1fef8c93991771a01f6e9c23d4205c75(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualBlur, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c4e8de2c30d8eaef67d629ef2913145342dfe48527174ceb677a8af12ba40436(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualChromaKey, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f360d85fe35c46f70ff0c3b576a1214a27101ebfcdfe7ca49f3ac273ab901e05(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualComposite, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b203926f0997f2b80216dcaf68afc4773763abea7eb2ee010535916e3e93973f(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualCompound, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3adbf92506f112f23e2f88aad766830dc4ff076a7e84ff6069580ce33b582a00(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualContrast, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fb84ffebfe5f2303bfb086e7a5516a5fab60e2645a4f5a99a8870e9c485aa3f1(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualGoop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__21eb42242780bf0c7f8221cd78340ab2ee0cdf3db42333da672459d2d5082a8d(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualGrayscale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b419e4f284580604180ff8e8c48e92ed3bb6c06abfe51edcb4352adbe9d0f1fd(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualHsl, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ffbf9b2d7bb58aedda6ff97238cdee17c8320bc82d7893582ef1b72678fccfa2(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualHsv, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d415dd5aec1c57d25a617d2ba9c52b388d830e7dff127a8472df1f4e69d4e0b(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfDimension, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fd4ac9e2481afb56060aae6bfe4604976b689b4c9c3799c67b88b9cf71db4f82(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a3d7bd3fbf32c3ce8bc23947401e2743c15b268d2bfa888df1f06af11e45e4c3(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualMaxColors, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3c269a46a86da7fcd5524e0f27863a464e10923294a8d4a02e5271a5194a5f98(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualMirror, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a8675c32a60382f1c46259bd696feade96bb9434e3e12d984d912842e5682b88(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualMonoHue, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__79ae743b3ff8fc467b9b1db7f0004cb3d5ebbaa718a21dff8d670c7f7ed5ab59(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualOpacity, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__58a46f6618d07c0431dbf59447dad99b8c4068e3037cf9b57248bdb3bafb6887(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualRemoveColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__43af8d8ae943c86d8fcfb06402e74a32791a83c0d97ef1ba73c7ca5bdac202c1(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualUnsharpMask, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1552c133d4fc62a52180303a87d4304906a3614b85db146466316d4db78451d5(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqual],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__463fdc0fcdd7a6486b7ecdeddfc8654627369b7b0ede753c6527be74e48cab3d(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
    feather: typing.Optional[builtins.str] = None,
    feather_var: typing.Optional[builtins.str] = None,
    tolerance: typing.Optional[builtins.str] = None,
    tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__14f6e0c5ba0f84065b0c5fa0c10e46a38c7c9142fbce1cb126c96c491858a843(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ec6e6a6e84c63d9977eea6ce3a654aacb03405d07a3f9b6bfbfb1fb0e8f5acb5(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d7b17e4a14d2e3bb7288733ed90c9a77a0d1b7d9e359e2a966f448c3c23e20c8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d9b52a865d85e954421055747b337f6ee8d7373f9f8bddbf35784f5b6f0fe3ed(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__50a566ba135d3300bc893da0df40eba9dfe205885cfe9c263b1532387de579d0(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__34143cde20beba4ad8b5f57981aea76c90dcce4787a4803b3970a97c1d3159d2(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualRemoveColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f6e8a49d9513b1070beb87021c1087a27007bc6c10d209668949d9416e009ca(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__40a0d2810182d7493d15fd5ce9d0d2e03694566f9c26d5606cf8d244f40f2847(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2733d9cd4850d17bdd21a7c3b9f09c3d73eb547791c30cb678c92aab0892ad86(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e6756651f7aefed76e1b76696b486d7d3bf50d9bc8bedae76c5d01b2a938e071(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__724c4fa3999251f726c15afbf88f2773163424f5372d2b07ffd98d3bf438a1c6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6c000598880545deb2ef39e868dbe126f84650ce44496509a95dd0c883ca11d4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bdbeb66d98e10d45687bbffbc2fc1ab61bc6e985ab524dd39ab58498bb344a91(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ad45a71af4a29c26d5265b69c70a061616ef938cc245e247f07930f3953f9820(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualRemoveColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e0d691030dad1a6c28291b8b00c98d09e1293a84f0ff5c240400b95c7b85cf85(
    *,
    gain: typing.Optional[builtins.str] = None,
    gain_var: typing.Optional[builtins.str] = None,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
    threshold: typing.Optional[builtins.str] = None,
    threshold_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c5f36fa617a4cd10a0b33c03403a4cd4b01facfeb6c790cff01b2eff8c644aa8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb9e3899111418b86267b4a1f88693be73e08ff52a869bcddbd0ff46be2cd6f6(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bdcc35e31255b54bd4ea8b7feaf1935064babb95853fd4c60cacd30f5470bc86(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__87aabca4dafd2ab2e1e53811edb4fc21eb53c7e5292b5bc9574e48985ef29942(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__696da4692992cd4704720738e189e37106f683e1d3e031516b92448115f19f19(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__04520a9bb3ccc49fb0cbb545f4d45c6e3ce23115f346e7e34e4def7f152a9f74(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualUnsharpMask]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__815967abe14de6084833dd4af90ed1c4b45883f01ef07e78bcaf7ac92ffcf600(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3e2d382462dd2371de75fd5ae51b1053690abe4679c919e1103b79f7ec74693b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7799394329778fec44d6b0f7c6e7bfda28a635ac86183962bcdbd0a88b9e80f8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__51e6b41909dc75b9dc888cd3a0872dc6abdc263c44804941f301f31114f31f07(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2bb68df6344563d93ca35ef34f05f82b51961602f8d552676dcb9736245ec002(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1e5cf13c9fe72618e824b5c012161b176e32a82136e5a961cf4bc706f7131e8a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__19ad497b1523300bf0798816a8aac16f61fb7c2b6fcc7d4792e303a74b4309d0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__deafeae9d715859c4f812fcfb11a07c19eb91d3454da6e3e3e080bf69d8e2245(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionEqualUnsharpMask]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d3dfaec7b23b8670b7817d763ec65b1d3472d39f610e9a22a7db96d95996348(
    *,
    background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
    chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
    composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
    compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
    contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
    goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
    max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
    opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
    remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__33e836c6a4c1f12b0dd2e4d6fb66249fff1675c1744a83d91dc7c1678379635d(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5fb26c7fe500db57cd857cf4fdc0fe65282365291c9ee22e41c81f3970244825(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fce704a042b2f543c1485e507e1c97c862512d7f845e3cce814cb050c3eaac96(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bdfa969ef4f549714bb4e4954c9eff7ae13bc86c195aaa298770828ba25a2646(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1fc8e3273e820051dcdb5e77f9ebd57234dc2e1018ec3c704d92022a748bf0ba(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__60294a110e366b04858d9026a8899c39c618af83b1566a2d159dedf92177df0d(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9e15ed3099bd00378c2cf4d1b15a19dc891ea6f11a28656fc07117a12a3ba043(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanBackgroundColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4bb14c3fa70c6869f10f176e79cbc34aff7bca2b249af847b5310b78dbd19124(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7419674db1c84e446badfb6c66d2e2ea30cefdf0782107c7ff48954bf81cfa1e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b1460665b2a663a5d761d5be83f4dea39090d2e9e454fbcac4bc0b1925556f20(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__def6624ff799390c14002c0753493f5d99c6481e700a9b4dc52b62478b79d307(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanBackgroundColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__677d2bada7df06d31bc987c25382f2a5dc174d65f3451d2c74e960d4350d8549(
    *,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__633499c77728ca4d16ee8b750e7b52f0b52e4ad6554f3c8f35c5ddf391ffa946(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f904c407068382d8ac09b4b89386d7fe0ccd3fdb6ec0ea855872f405f3c7f73(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eb7ea2eecc2c2256d70b3a35dfa6ac8ce211f2908127b92d44c702768da7a9d2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__db5d58a1382f9b50db1ba24f43b85386aa7e948f388112ac079fecedef954d5c(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3b6f599c73e981de75d71dee76f0b6e18b724914bb18dedb83b3596c5e0908f4(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b3d6803c76b55a3902e197a1e5a624c77835b5310192d57905faa8ec1cca11a9(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanBlur]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__505f10ebba576e40385beb3c70edda98e03d8629b4fc3052204f44c7bf85afcc(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8113f86b81f101e0f13df5b010a9a3d38b271ae0c198f6f5d803943435e02352(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2c572eface558d4c695337de6b40f8e0674fb805512f0dfc87a8c3c98470bb82(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fea1ffd2f0b5e4d14386b3a500c2d8ac4ce63f80158f12a55b12ad5b0ac05667(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanBlur]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0935d0506ed110d8f443caa10a55946621e4c9b61f775f06f67f3fc980255593(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_feather: typing.Optional[builtins.str] = None,
    hue_feather_var: typing.Optional[builtins.str] = None,
    hue_tolerance: typing.Optional[builtins.str] = None,
    hue_tolerance_var: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness_feather: typing.Optional[builtins.str] = None,
    lightness_feather_var: typing.Optional[builtins.str] = None,
    lightness_tolerance: typing.Optional[builtins.str] = None,
    lightness_tolerance_var: typing.Optional[builtins.str] = None,
    saturation_feather: typing.Optional[builtins.str] = None,
    saturation_feather_var: typing.Optional[builtins.str] = None,
    saturation_tolerance: typing.Optional[builtins.str] = None,
    saturation_tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b8bfe8448946b18bc64215dcae6cbebfd4b18aa203edbfe9475b875d05b3cfa8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__13a473ce116d0c10d4d4f890edd577a5f9af8e1447ce2d12ca44626e458bd95f(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ee393f9b9b7229c8acc48b027acc21946d7082d0a33005cc0f97ae5e6264720d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d0455bdae95a68577c0c9de7a97d6ebd024c05953e762d1f476b4b8d8440e6b6(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a6f330ec57b320784f83ed1098b8937d9a317e16a891abd2909ac89c6faa8ae5(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a6269f65b0aadda8f597ba15b418bfc2fea5368337f6705a84e426126150c78(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanChromaKey]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1225c5b34dd2b9d07ef287f2365b9fe5bd8a4ef53e6d980fe2f71e067e4b595c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__536466bd85ff7d7bf6d3185f861f20c575584756d7749c8849e16c6ff6288b8c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1617bbe9da3393f959f3ef1df5d2b15dd59b8269b969027a3ee420530840305e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7290baf0224e67198c84b52e7f172ecf484fa349f867034aa879a0c39c746395(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__21c095990e1b606d9927c81a950a9eb6b169a35e772674458e55c6fb44b0436e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fe2d597d0f53a18bfd3596cad71037af722d85bfc96f6902a00ab173ea42b782(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e92c7f9d7456e48b035cee4ee2f55af1c4df053f363376d47689bdc581511acb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__57ff688745cf7298840476eb8d16e4c41964236ff3511075801d8494dfc5d8b1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e94b16c319bac66bb72cf47602598487864c8c35cebeacf52636b2f23d90cd9a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f146e5deec0b9fd072c95fd5666395f621592b2ee4dda903096ffe333dcd6d9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__788aad7c0b9094e97716a0e4191197077becff64fc41605f600e2f7bc04111af(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d00776e5139cfb12d38bca5554c39bae3af3f56cea04757015c516e8c2eb410a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__52c6a1e8bb1cf159ed42cc288f3e505f866cf2a39433adf8d2c9eb4223305159(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8e811fdb206778c633c536a7d37bf2299227850d1896818906e70af28fc30baf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__abcc3db3ad1c8307efa3458b05183af7d5963ac1db5643916d896530357b022d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__79d6984094b59d3eec4b352b1560ae473775e5b47ead098e406d20373d87dc94(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanChromaKey]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7ce37b093bb97103ec3c8b832d709fe0e1b28ce566b41a62ed92f64e1bb23f95(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanCompositeImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    placement: typing.Optional[builtins.str] = None,
    placement_var: typing.Optional[builtins.str] = None,
    scale: typing.Optional[builtins.str] = None,
    scale_dimension: typing.Optional[builtins.str] = None,
    scale_dimension_var: typing.Optional[builtins.str] = None,
    scale_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b5aec60548fdb39f8466aea53ab3d3d788560e70461f512de598aa9008d947ae(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a837649b6729335c0a0382d248fdd425d17824b724fa362b77e05a762473f22(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanCompositeImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4833c9f4d6bfd3e5403bc4959bd29d5d0e262e6fcf63b43409a0682a73889e77(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2e9e022fb4cdbb39725c1589a448f4de77f98af98ae615583e359bbd00bfcad2(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd2df0ddf580cf7fd8d280974bc3f644ef907d9d587a579b399d94ce1f2a49f6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bfcc9c78bad9c4dad4499d557300aee315a66caf38aeb3ac0e61aab20282ee62(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d62ec0bf02341b9edd90ce050ca42648d93f06b6b8f4305291a7e7a817faf5f8(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2c2e9fb7dafc7ed73d926bc63edb89b9030c6e8f1bb23f3e565cb4d8d38cf049(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanComposite]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a1ae2ef513703bf5127fbd0a4a4b8468b7d77902382ff0007e4ec183e491ba92(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cc6be49ad7aedfda3edb441dd73136d6f0fc3f174e53456d08fa01b38bf0263d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ee2a57b11fb6a6fc2cb4eedafb25b140f1c1790416eb7486f2a56edb63dadb6a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0c66b95f91766dd24828c5cfeebf88280d16577809608ff51e991465977a248d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d51b2054f38bbfd96b874ffc019fdc0bf5c0cbdf71cf69f6995cd0aee1b5f58b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__efba290fbc189613f44d62ae77675ec30ec59ea6687c76265d72aa172193cc44(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__016af40f602b84e7bcaa282bbff938ac23adc53d11dc7b456bf6847fd1f98b82(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b304d19a300e7396249f82993f74b2d92c5b6fa9002b8f37c85a5f9f3cb37e4e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b5f67b6f5457437016f5ebeed9953b47f6cdb05501d100b291040d7caaeb60da(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__33533dc8d3235ccb19828e212404d539b4bcf69fa07cab021516f93b37374525(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d9ec00e800594afb8c4b28c07ab95ca559026a8370afbee3a84a4d2c58035410(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__34c4dbad37825b3f21db19715962e66f774b71b4350992074c0696467f1182ce(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d8b578a525f66df6a4b6df177409718ee391810c92823de92b639044120ad513(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__06e7459a5fbfd8440a260dd738c40435a3e0a8f4f768a89ba62810fe990a1dec(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanComposite]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__98b0678006ed4c771959b21d42477e1e768623734b876ebdcf4126fb5b63f204(
    *,
    transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0c18ab1e782c2b4306b616953bb2ab26e339e17fa5ded7d6949a7eae0efc2ca1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6a76f29a07cad40f52a2d04a89495e662bf7f57e9b7da498d6eb9182e24dd8b8(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a30d412d85e14d3ce2763251361940939d2f3a0f687f06cdc7b8a2bd045873f3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1754817b28214dc0b84e286cb18a7506979a5a12cbd7cfa98f4fc0966aa6a19f(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7791b35dcf620e549e0d4173a6e595720fbb074e2de34f07d1d844e4720bfc4a(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__11999de5d6195b19b1caa8ff3e9d5331fc458f0cb8bf307c8bf072299ff25370(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanCompound]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7724fe6370716de9bc841c4f3ec8d9986e3677eb8b4d86843c983155fb29ab64(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ed81f50c983434a00a07e3afd864fcde9bdd1aaf952d3c68c898b24cbf2b861(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c79d39e502615c76fe60232b823df4852430e2e5d9f5bec5d4846253222f5756(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanCompound]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a2c18371788fa40c6d68b1b5e579102f3eba4a351a1f2666c8d7ce5cd018014(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c78adb3427ea2d51352fd765c2c5d1b395b9fabd5f33a06654b600c3042c8c28(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e213c42047886386761067619243afb1fe792da54e64f3c0a575061b45b4039a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5cd1a448fa76205677fe0803abd8689491a085c35900076a7d5aa8025370327e(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5641e94b42cee1b093cdf51d6540810f3f9e14eb42328c99b2cc7052eff61411(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f056073998d884ae7e9f96eead1503790082f3c6651bfb8abe214e40bc891223(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanCompoundTransformations]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5d6b20f3416cb062b42218a0cf3d90460184c97199bf4100d505f42a684a8bb8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5a634191278ba2ddbc952483e6a3776da294fd6d65e27dbe8c12c7dd28a45cb8(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanCompoundTransformations]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e685f891e716556ec22dfd9342c862d590d0f201a4d3e6218f252c309b221d7f(
    *,
    brightness: typing.Optional[builtins.str] = None,
    brightness_var: typing.Optional[builtins.str] = None,
    contrast: typing.Optional[builtins.str] = None,
    contrast_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__96b05f90a42fe14e61c96a16ea5dd8594c9c8ea1f128b976531b2010c02a038b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f4d0a9e057676e493b9d93c8cb96b37fd6023ed40ab43bdd2a0159b96f01b02(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4e43e91e8901d2e0753878a0a173a05b10e69ca0f9dd421147733b4176c21dab(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a029521b31294ecc6a052c07d7675891cec5be8dc8e9f467ab818f75a218d8d(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bdca1231f3b0a4fe1aadd22c74dbbdfcc563054c4496bc4b29ee64d75803d44c(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__57fb79aaef03469cecd5bcfd8a564c49834b1977b1be1e788e5514a5d9782a13(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanContrast]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9b06bd5d0210751a4f92850028a293c119aff46cc3c35d6a58e36b570e6e6950(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1e11c1bded5316ce54d5f7cf3f1407a000de35df6f83d1107268c005a60e51ce(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2962cd1f61dc0812cd384043e2860652899d53a7f75fc36e94103f3a0da00a2e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bec1651f378e45c58e5b37596c81220c3dc3c2714fb08c6485e792c23684ad1b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__73a21cd1b32a382e1135623fd6d5e5baa7c1dfc45cc32386cd2bd9d15ef345de(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__871865a9958eb638be9af6cb0bee8dc342f0de38b0cd16fd3ebed0a2dac170d1(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanContrast]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4bdfa31dd0490a64f23fca47659ed25ecd985fefeb0c301faf53b1995cbe062d(
    *,
    chaos: typing.Optional[builtins.str] = None,
    chaos_var: typing.Optional[builtins.str] = None,
    density: typing.Optional[builtins.str] = None,
    density_var: typing.Optional[builtins.str] = None,
    power: typing.Optional[builtins.str] = None,
    power_var: typing.Optional[builtins.str] = None,
    seed: typing.Optional[builtins.str] = None,
    seed_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__45a31897ae50bef2c47c7093fdeb3f2999ac58273f75117ff396851f92084c97(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d8cf4aa1ec687fe10b40d3178d14fd48428bf14423dcdd4f4f41724e9b550913(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b1c2de053441a33f4eb88aaf32894007b08e227200407b1523c65232825a4c90(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__78e664d01f828bb99ea144b149903beedb93fe088f914e79d250b44542d70444(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a52ecac1aabafee2876b44d7a45993e72e4d569a3025cfbc9ff637fd5de0fe4c(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__352b8396f2d1e5bb6b35b2e77d340f13700b5c4bdbc3e60862a5f77f921e7dfa(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanGoop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c7ac5ab6f4cece08536d6a170b0b1a772bd7813c601127c254aced4e10f97c08(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6ce5e8a7eec4bd8dda1992dcccb4a5f1e9dd06ab5c43a672b532a39bdf696935(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__888b858e83c4d7956ee8a3e435cb9dd0d1e1765b46e0cde125d7a6b1afdfd382(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ae8ef92514071582da4a62c64a9ffbc7018e78a392eb9680ca2ec230382c66be(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e3b8a9909d48ac7d76454491ba4adb0214ff10a7013071be986be779abef54dd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6aa849af9db5b11b108fc3c50b8628b1439ac15a63e4089f3fe97c2a044909d4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__74e4e50adcde8ce3ce3f6b1b52fbdb97d7f82be32449a4490a490fe5e9d5c071(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ed86238d6890e6c8ccc64164bf190fd8a1cc2133456a825ed7983ec298af001(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__06fc0418026e20a9238e9469a7a0d876cac3d4b21b6b6816ee81129ad99ed3bf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__285cb4a1511be77a521bd98bbdcab60e93c4fe4391bd586e1ed33d2301d7972f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanGoop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d7a30b702dbc58e12392722d8b15eaf2f148e259c9f6d672dfaf5e44c7371a17(
    *,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__252297b9c51e9376594c24f98d13ccdd604c12207f2e1fe9192a65f8e4364704(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d598148bf2278fa92bae1a17ddd9ac929ff57b600fb8c2221cb41c4d79ed342c(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__421799cd5d3ee0dde97d20d80876793a655d4519327655b3e2aa1eddf7032aa2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__625fc077e3e9cb566420bea62b8e53ff7d7c81d88f1a76b4c81db3e93bab0040(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1fc4c28405e85edf868adec42731191f9b5530cccf0027165227a3418a0b6c9e(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__362791a9471131b3ab6119535fb01fcf53a24f72ef0862f0961714b96a7c58b9(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanGrayscale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7b4bae4d35e1df975816cacb2cdef556c28e91cac2c3b4bf2abca18654ebef34(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__db0ceca86355374a4a05147592f44aa3e2efeb60ee20b4f293ea8facdf262ae9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dd671e7e2041265487efbc16efec0c3ea2f43fa333f74f7cab7deb889485c387(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7097f860aaa67cd9edc6f101061f5e405720e00492052e95b431556e1bc449d0(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanGrayscale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__583898a80388c49ed3a74fed4d0821eb5d810f6aa8e689f728924a521f011ad1(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness: typing.Optional[builtins.str] = None,
    lightness_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e7fd5044204d8091b8f5530c654af137e7a5f2afa6703c153649255acf68d31(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__56fd6193f79fc8c1ff2fae70a779745734bf839d0dc8f296695eac7f83f1dd2d(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__78ebc8aed2bd4d072a7c4e28c6434d80887bb664fad29479ab0b9ab757552713(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b612ecaa6731c940c5584101ac0629d7662179a0e5020f1c05ccdbc4410dcb35(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e371ecb145e43158c03a05c766ac0c4e9efd93a1a29ed3984279eb795c7a82f2(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__30397ef062dacef48193629c716fdef0b11e9d1f781af9522e929dfe665cae98(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanHsl]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd9aa49f8931f23ce852e17a22f05af902d0a18fc32169275070e64afee2ebc7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fb2f95d41e72e8c1db978962664e05655af86aa054f1f1ae727e5896ad3eda3f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2e945da579b84a5ec85034fb00cdf4db6a4696287d234a1b2704be4a2bb27242(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__91166331054a984a3a012c409bc9015e6fdfb94e79b5f1904396d31d148959cf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__21f53fca7b2de6ea8ad50bb92afec0a2ce2865b0f92681c8156997b181a80033(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8d6c36ae4c6e52684b1e3c4988966ba0e9dcd24e53fe93b0a3a0a81abf4cc8a6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__00ed4a46e43150637da291a30f08efefe88e8ea0b3c2db26831f171c76c0eae4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__57c60ba7cd6c9dd77af7eea8b4bcc1acf3172433c7a4945e8fb7bb03b0dba568(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanHsl]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9beef736a01b45a4a56d3dec640791d2b148f0716aef72d7b17fcf9c800951bd(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__913a9599f85260524139c92fef1c29de5adf947b97313ca13f54f617a65ea7e0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__32889d542e69102e6d789fda152d572797c4eb6724f1d4a5574372e7209e3992(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f36d0873b909a6d70c7e94f7c8feb86e5cc12fd27dd9635b806e9269d3a07d06(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8661ade02f3747f2a3265978dbbfd9dbfb1eba6cdbf1c574884cf83a2c2d7b61(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c4a6ae84b494d03af195d8b932494a4b6664071b0a25669657ef6b4a7e6b2669(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__881d3d422f8da051b83dac61a4c36ca3c0d438552e66f28b62ad62bde4f8be86(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanHsv]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eb414a59a7cc95ddd9ac475c36f9790fcd57bc3d14c5e7cbb08d0692a3bd7080(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ffaa9ccbe3ad995c55d7ffe02ef484b35a4324ac98d1117ed294888b3653f641(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c8467287f76cfe3455f937f28ba60154062133a0be0e2253cb80fd8b59fc2bf2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__323c2c4535fed730b72d3e1698d1cc3a2ee3c4710cc5e2c6a205166e2f3ad849(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__076c986bc82d85ba2b2d60b4db56f1128e22f8ff86398bb9e8bbbce05382b8bb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__55a28ebcb9d53e045e3f9fc8357d4fd6d8f6ebc840e9105a141e8e25a0d11258(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3c8256ffee6bd865bc05e8afbf919ba08ffec92512f927b804bf18aee6e7e032(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__15b0d4d5b0d28a9f49d1e2ce79a861b340333ba63dcf20e92c9bb0d8fffb4e88(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanHsv]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__258cdeb5eb25cca0a3b7a683195dd6fbd4c50a68175c1e8253c8ad78e79b6d61(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    dimension: typing.Optional[builtins.str] = None,
    dimension_var: typing.Optional[builtins.str] = None,
    equal: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionEqual, typing.Dict[builtins.str, typing.Any]]] = None,
    greater_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionGreaterThan, typing.Dict[builtins.str, typing.Any]]] = None,
    less_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionLessThan, typing.Dict[builtins.str, typing.Any]]] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0dd241d81f071f80bbc08d22e8ce8cdfe44026b1cbc697010915ae63edeadfe0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__879b63a22bc25ad70976ab8dec3002923fe18ac427b30942b9410934516b5fd6(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__605e312e8ca6224266eef0b4ef64f47ee2ef29f2bf23e081c2bc6a4fe2f03e71(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__547b96e19ac0b7c143809c6ac77cd5ec372e65baf73f50781a0caa0541ec0521(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionEqual],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__067340a10d919ce50b78c401742a9af6d962ea62da88b1dfcde1e91ee590f1c6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9e17a9b7a66a6e6fb33a549de10c860ea3c487fbe6b4a6d2ae9ea8bd7948e01c(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionGreaterThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__70b952f59d2741b744a2b3b154537550722f84307653be574a25e4635cb8769b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d1b2ae389753c64dc96993fece8c79e3345e4298e17c5d997d0c5dc0869c4c0a(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimensionLessThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__78cffd63519bb20d7bd8dcedd781f05115b5c1d796ec9f3356afffe1852b94be(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c6cb76b2fd3f801304e03962d73e6e6eff65d5c5e2209a6b952284599c7ded92(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ba2f371abaf4c7bd7dce7f903d8ba87c75ca5bfc7379a1b722a1666ddde1fe1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__810c675b2a62f89fcc2f602fec1b6bafb4a38a3b529448619659914f96970fe9(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a135986640fffed3ef8e91aa41bb786ae69200b831422486216f6b1c51549f1d(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__82be291ee3e9b384804a26e188d653c9d02ac03f375322956db86dce20897911(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimension]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__20f0b96c0b167bf185baa9bf7db7fce547672a1e4ebaa132d211e4240ad39fa6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eefb8088d268aaceed1cf7bcf69eddcab61341900657ad66a0b94b53363546cd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__700968cececdafcecac49bcf4347eaf31e62017676188a6e253d88ef6ac996fc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__44abc5f766ad652d546f04d622ba17ece8b802f9fb9eee7fa5ba312d1a2d609e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3df4e6782abf1b12d085dd338aebd2b60406204f16c7133ef52061f0b78ac00c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1489263812d7609dd226b03bb949d3b9b9739caa99f6d492b2ab58eb35cf0d41(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimension]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6acc4d0a06669d8fadf3bc4a509ee4f8dfa685a03aaa024011853f7372893b9d(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    landscape: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationLandscape, typing.Dict[builtins.str, typing.Any]]] = None,
    portrait: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationPortrait, typing.Dict[builtins.str, typing.Any]]] = None,
    square: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationSquare, typing.Dict[builtins.str, typing.Any]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__380427f4ebf3e48ffd2897fa7cafeffc512d061c5c5d0a03269e1f1901d1f7ff(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6924aaed4deb9a7596aca5ce70fead8ba8f8d661cda0380efeec19cb4c16e0fb(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8e3abc20c976de6983549c256e3777afe919f94fb2aa807d45c29edbfaf77c19(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e772a70ecfd587a0a469f3514154eeb6b9d6aeec21b954f63cbf255f4f21bdeb(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationLandscape],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b10f5bd77d88686e80d53ba12eebfa44c87abaff8b87dc2fb2f82e6782b1044b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__80b29f71c3efb58a62e6857daa2647bd07556aeef99d8b15e5f3685935ee1b9d(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__03136e3af39c2cdfdb9bf70c69bacaa416c64149ce02595ba47801d0f7b172ae(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fbb8fd811dedd382b1de0f9627b86c3f504688f1dedfc555c29384550546f511(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__096e8220f0592155a286f1c7155bf68927f7b8c4270f24a1cc67d1ece4288723(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ddda58eda0d3fd9ccc5490fe08510941d5c8273071a7192c4a7a6d648d90fdc(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientation]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a36e9af03813b06c55e259e33a802da1c5fd19fde88d3258854f8af8dc17ab40(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ead8b01ed18bf16d95e81a5c43e92e4024056b4cf36abc9046f0042183bc0cbd(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientation]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__07f7537fad246dc22c33f25164ffb31d9dedf152f34b1e7d6a0a85339408e58c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__30d74effb15f20f8d278627a7e2539c3e22b6c4aa594d22b348355f5363efe5a(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationPortrait],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d87a52377926ab65d070a4171f88c926153e643297534dc228d19a7b745610f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a6ce4f5e6305512696e9f78883c37eb893fcbf47f878c6d70d6932a340ab58ac(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientationSquare],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__01c70657eb248a938f874085e561ed867f33cff51e4c8cde3ce8a97235ce8bc9(
    *,
    colors: typing.Optional[builtins.str] = None,
    colors_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__36621c431e515747a0828afb89772e5ac8b0d7e6fce022bc358fe62312509152(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__10d576bf5c84d7ea8ddd1d1313c2128dbcce70b3eff4718d0de1689bae0b0f94(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e18515dd2fac349bf4ad71549352e8aa8ebb00d66db70ee768e94de1738b69a6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7c07564ec43f6c64b52902e2440be63ded320d7b218bcf3ce11daf15e6fd1938(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9c58289bcc76c2769c1bc5b23e9ee0435611075232dcc2e575bbb250fa35beee(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3df344e341f899720fc2ce516e0144ac460b3cf403f836b8976957717c3ef453(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanMaxColors]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__77a5f6f7f54b2e8170a01e2d2c50f2e643a7068ff9ba7e068f7cb9bd3e68d062(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7c0fa9e9b1d628e8fbc913a3b1df1065ebcd5cd49dc753f06907498891515931(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7a7b10ce0598b4480793dbac4a0ba16821ad12e214c002d6959ee8e908c3771e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__76be198eb1f2b94f97ecb8ca6d7ea1e970d0495dab064e0c9e71bcebd863fb96(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanMaxColors]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ee61cff270ad2bc00980c08ff3613235eea459df3ba9d1ea71ee5c2f9b59b5ca(
    *,
    horizontal: typing.Optional[builtins.str] = None,
    horizontal_var: typing.Optional[builtins.str] = None,
    vertical: typing.Optional[builtins.str] = None,
    vertical_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1efb990a8509bf763de2b4a23f2b6d62d0206ad5bb72f9e37dbec7cf153c5fa1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1e3d0a36c2918ec95cc72340e368451fd17883090a3c4e1111cb86d6dc1c790b(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f766f13bc0eab19122e74784995a14942b73f33cdff492842a0f4576d440a4c2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a68d1d968083c082f2a27de9b732316568962f1e08b8a6deb91657705d282fc(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b4d7daf1879f447c1163d7d034882a76f8c292dac194e6a030abfdbfbfe39501(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__794e4ac72a1ff65086b61afb8922f5df825321242e210aac0ec7b8eeca7671da(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanMirror]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7705ef99dd22cdc35df9d52b07d46ff7ba4d2b5d96406b20a8a60cac1d08a7b7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cc2f5f7ed4e3f9f009e962d7158244db4e27533f9b692cd324fd87b755256d05(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e444f25ebd95e82ffb9f5673a76c8a2b07fcef959daaea376a7f4c746dbd95ff(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__daf04381380b598203479435f7acee761991c71b9262a928cf8475daac3f0b16(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__476f2674fa94b496e29f57cdd5c13ab96ae956acf9e6b7abd7008d35504d0cf1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ddc923fc5e060644a60045e23b6da88eda98128cef676642dc710e461349d383(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanMirror]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__56c7e24f6b730eadae4577348cf5b0dbc701ad77c05f5b1615da4d86937bf648(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fdf968360c898ba94b63c53729d8e304dac2bfb7d60886afc2264fa76b1c4e49(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__25c40525882bd0bed3df716aee0ec6c5778df173dc5ced6e0f9406300fca4a05(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c55bfc0e48def447cadbd01181a08bd14824fe5545262bcbe0354035d3dcfb85(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b2252e71240169252695b621b656caea037e702f0bb4ec25d9f19d3a62d3209d(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dcb5156d10d21d0030c889c5a52d1e1065bd718ef2ccd310444e495bbb52d246(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c2774ecbd60a6a5fa33d2591f00782578963f0bc78e52ba1960ac9d4b5b1eb8e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanMonoHue]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f96d0b0b5b8bb1f69fa6c10878c7177017fa8a100b071c4817fe64adde12d076(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b532b71bd81be8c3459c3e9a8d35215377dd5a8a7e22de35aa2a88f0cb6d6a49(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be98b7caccacc6a799f0d6da325793e91bb234d07136db64df585a41007fbca2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aefeddb6fa496bb884dc33ab835acca0635b24cbf4eb9da8573fa1f0b64aac78(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanMonoHue]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bf351135fdd2c5cee839c0c1825904a261182ed18adb48f840891794b1d5104e(
    *,
    opacity: typing.Optional[builtins.str] = None,
    opacity_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__26e056b1c9e2f41eee8d6461128f0262811316784a5dce0b70aba2f275250289(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0a03d8f1b94029a55d45c935bbec0402f3deebb0886394b86c1471dee367dbad(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fd8bc6480007e69d2092463dc512dcdd2bb8173163ab834ffd67655d2894dc03(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c1814a85970d4190821b2ee63549c996a845bb06417b86f3c0e25296da536e47(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ca5c0eed4720744d9bc7442a6cfa4ff8459500481fb6eb878db58376b081a42c(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__98fe7fecc0ecee460785c6b9991a5a323255a222e84c54c75b8cd2a125740ec0(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanOpacity]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a79f371f6e661d2591a54d8ea670da82773847b0d5aaca3dd7e288b5de3c871(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__676992d4063dbccbac0ebf4275d485eaa02124a0c69760686b44075197768f86(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5c2c67d1fc9bf5bdac8aaeb51a54c9c39abcc77b923db4a9e7c3b97f5c02bd2c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__76c4e9e99f912d40dd398122d84d876d15e2b80fe19788ab7daf72edfd85674c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanOpacity]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2850442bf8888ba6fbb4dc352864ec4dfd8cc52a4a7bf124ffbc28ed2f200b5c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0a48457d984c234144e6ce5a7486b82c7d8234ea13eb18927e495785885bf259(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6051c03baa6feb1b94087e35c7c3655814f453b1762b6de27f2d4c50ae407ce4(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanBlur, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__087e30148d482b0e36522b6dbcbe94fbe231cb67cb3564bc42688e939e4090fb(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanChromaKey, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b03623ca61b1198f078407e0c12c168eac1f7cd8e936f1770f7e78d60e3be1d6(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanComposite, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6fe84d013c511d3fcfdee4fd1839c7b8a2f86fcaf609df0efe5aa923d3992224(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanCompound, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6b999cb54c4a4d63c4e38baab91119497a158207e9499ab69f0d34fab7266a6b(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanContrast, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f5322f87ce250c18b8b227361c4e74ce757faf1a1fd5fcbbae0f812402015fb7(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanGoop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a96bbf0ee6b3cbc464ec852408440e26b9965979e96da26aa09fe27c18a7955d(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanGrayscale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1b69e5017ab885f42d2eb3690fcf9dc59909adff56e14ca902edbe2b0878d565(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanHsl, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c467e8e0d92e24555c94b9caa65fefff832667f7298923e091197ae358976b6f(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanHsv, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__acb69ff0138dbb001ddc9919d48881575b6e19f4fb41caefee89f0be6e6a6445(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfDimension, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fe0b41a868f8602d9e9f716b8a5ae9fb1e143059a42989840403b03f2a0d694b(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__63cceecd66ea649f3e8f9785d053211809226c9376eb1ef2c015067e4a05d4a5(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanMaxColors, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__44fab764cf8bb78474f2ff5f293de6fceb40a757113e9882d9dc1948d168f560(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanMirror, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__17185ed58b44bca81ef4f454d77f9050915403e7e39139825a2c108cc7d7092a(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanMonoHue, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3fc9fc2b16ce8f1543b0bda0eceb92037e4fb0bfeaeb1d56229fdc55f0c062a8(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanOpacity, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5d865343a8a8ca3ac7b8bcda3ddc3e14b9efa14321a82e00b6f82e623f93a72c(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanRemoveColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d4b3c4abae61870bd5adafe7e58a0bfe5a4fc9ea58e2e701b58bf84fb103b5ae(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanUnsharpMask, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__49526ed3fbc4f14e843af35c307c1c8f17e9f6ea1f8f652ba90f7f5a91bde017(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a424de58106f2a14ac1f15b995552af8bc7baac0df359ec43ac9fa17c974dc91(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
    feather: typing.Optional[builtins.str] = None,
    feather_var: typing.Optional[builtins.str] = None,
    tolerance: typing.Optional[builtins.str] = None,
    tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0280c2415de7d6ccc06b2bd6df65eec9a31d68007712916c1c2e114349eee028(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__28b9262cd46b877a52de214e4abd4edbdf04e430f2ebd958bef0c6821e73e47b(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f683c20cdea1b9364413493dfb255fd64719a596746e6f00a5cc8ea59d6b9843(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b93c0490c3a9e5eebfece3a2da421ac97d2f42a7bca653704dd94ce152b1ca8e(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9580532077856d5fa7ff799291d010671aec7c4a1e3e50397c8b0ab275e40cb0(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__557bb731723ae9f09205c2ecd30ab9dc3e01f279ceb86907041fdf2f5f48a0d7(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanRemoveColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6c5a0035041b3062e8e55abb78fd040038472eed7d67f52d597f984ea7e27365(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dc7e14e8d421804b5e1579eac02576efbef6900bfd56be8e51cc704152df2519(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8f9a98eaef4e65e62fe498a85cae362878be8fe37d453fef38f59489ad9f80d5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f56c6ca49e941edb325236c29d02666efc188d4c2f9ce4f54958268c8aa3989c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__78332b0276fc4c1851d6f2e2ad2226b50b33b79201c20dd035653e955064ff28(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__98f8d63c2069c23f6f22b4c24bb1483bd00fb99c66c4561fb1275298e5a27024(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__628b4c7001dde9eaf27a84fe79608f4036b55ed89dbdb4e419539002b6bf2a64(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab78ed3e91372d4eeaf501231f00d6c29b06f72ea744c7d446edb5613cbfe0f7(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanRemoveColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bee04a6ea920c1b6c33da632db07c21a076622e5c944766f5510788b22d1e17d(
    *,
    gain: typing.Optional[builtins.str] = None,
    gain_var: typing.Optional[builtins.str] = None,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
    threshold: typing.Optional[builtins.str] = None,
    threshold_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__89c5f9d1122eaa1f0056a1f78e1b4d8a671314eb5e26f0b80f4232e617295a56(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eb07b1837356e30833c2cd2e2c95c9d22410f6708e9316235e96e09a682a8f51(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4753eda9c8ec6d6f1e6f536cb7ddc3cdeb0004a3f643c6f28fdd00e3c297d25a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6b15add6928ca8ca3d80b8574d692583224f555d6dd4351958fd9416d80f3f8c(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aea393518d1749f26ed2086d042b414cfe22ccfa21b3de99936acd6daf5e9e80(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bf17f12b6fe72a042f298ffc0098e29158070fe8f40ff70db30264479b6e2d5d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanUnsharpMask]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__442926cc2eae50b9456bc40fc2cd98617ccb56caf30b56d76730d4e3e0427925(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__279a1e40f14f215d4c73472d769b79b0e48d4d914eaea72a0f0ba2c157bbdf76(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b0d5431d5765b5ac5083dda554730fb4214a1754daade3aad4fbecb3a254babf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ebbe59aec9291194e6b1dd5b54d89ac1ad700987d50e73a52e68ad5ce41645c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__096db9a486083f8f63a101e3534f709d7be203f063727e6e7aae48e7d0d50ffa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__292e28c0a660fa1501ff773bea878f26575ee47970d4fbb79796bbf5218676c4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a33ec2449007f8d8af025f0e29b6250d35bcf02f65dc884961ba5d5c29f52c67(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9959d55bb14301ac0e76ecc5733ed702df87d7d54e3cf074bf544e5f5e562c41(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionGreaterThanUnsharpMask]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e11095c4fb4502f24d086a98d3aaeb575ebc8a898cb5b7e532de758e9a36d4a0(
    *,
    background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
    chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
    composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
    compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
    contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
    goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
    max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
    opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
    remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__90a9001caa6bfc80c9e6dce5c9602463dca7e5bc73c74f191e9c618926c522c8(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a6fd43b69308c2da51318a6e9041ee4650a143c27fcad04460ad64f66904e5bb(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df8e489fd95fd6d9e2bf63b0113ac177f55b306ebd6b105821fbeeda20e59c85(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7eb23d6cd62d2166d1a9a8770375b7e14e9f68b4f3e391f468faf536301f45d6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__10500b39b3e608703613a45cb3b675ae2297ba2abe020190e229db94126f5224(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__78fb403401af28739759ff0f15074c1b46230d11e5e4500707f33e06f6d88d34(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__28a505403a6ad63eea79bb06a2506db148ea8a78dc87dc42d4c71375f2db06d1(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanBackgroundColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6d9f6829fd94938a4b6c62e1ecbfd8feda1c155ed562b9ee98549ea8d2bf4f78(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__28efa6ac8a6ebdcd7cdda52989821cdc8cebc47ff072b9db8d8c9b8dc05a8218(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__29c19a0473e036aaef51d8e81724b80c73a5887ac300b536adad2741f394b7d4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__72361b9be4e359691261a07ba2d81e587d2c0117e3ec302571fc0c98ca2e521d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanBackgroundColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7e616da7c6129e77434e0610efe24e4948278b05a491d3317644d91abf39c547(
    *,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7b0ab0b6ac2dd1ee25c87982040b6565cc5489e82e89cabedbf04c018f509d8a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8f5ff029af552dfb0e3ad64752151c803ade8d69bea20bce87c7d1660a177f67(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__732be4923f4be4e7db2a97a06e5e75968799d39c04d2def79de0ed3f9c39049a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e89b162d5693aa2e5aa29bc54d83990d671d0617d2207e7eecf7a80e1e61bb6a(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4e6d705e7be7bb154745c59488098ca6548b0b5aab67e19b1238675531999cef(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8007d500070826bb5159918a6aa8f58a0058ecd818b749c5866d6030432752e7(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanBlur]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a30f75dd03838200755ac014af07c82253a5432c9280202c2cc435e8a1736057(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd1513262b47404156630d1ea547fd74409a6b72c2dce9090df005f2605d54f5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__596e84cf8086eb8db8d8c582c06551664f09cf09fd6f1671a6b963dd7d7084dd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__81a53ae15878f175081d2073128788e6328533033bc2bb4e470d6b7c7898933a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanBlur]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0e8e217d40fbda959d25fa1bdd3636c89f8a03b486d65e6db3ffc03a78527c61(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_feather: typing.Optional[builtins.str] = None,
    hue_feather_var: typing.Optional[builtins.str] = None,
    hue_tolerance: typing.Optional[builtins.str] = None,
    hue_tolerance_var: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness_feather: typing.Optional[builtins.str] = None,
    lightness_feather_var: typing.Optional[builtins.str] = None,
    lightness_tolerance: typing.Optional[builtins.str] = None,
    lightness_tolerance_var: typing.Optional[builtins.str] = None,
    saturation_feather: typing.Optional[builtins.str] = None,
    saturation_feather_var: typing.Optional[builtins.str] = None,
    saturation_tolerance: typing.Optional[builtins.str] = None,
    saturation_tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7bd417c92bb04db6d3785f6c96c49817d1111c08f30710cee4fb489ecad06639(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e8e78c4140f969085a6baac049c87e83b2321cf1a1865ba8ba2a7884cde05a18(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__48c985b132f4a8dee06f8f05563fbe4a5b214e3a6eeef4365cb4c9ff98d2838e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd28046fbaa0a6c72bd5cf1ee2940597306cf6d749e9b393e785dc88a12f786f(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a985109e91115722edd6454650c8bf0f5449ac468a43bb1ec4371115589fe26(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c204c510f45f8673e4b7745411b95f8e3330135c4e9dbd2dd3eb6aab275b1dcd(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanChromaKey]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a342a2a94b2bb96c169e87b5ea8bfaeb8f42ed61def6b1a462648083e1591fb(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__35a116c396cb8416e5813c7529b40149fd64ff8b07889e01a5a9da3012a360c3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__684b424471cb57c2545184d4bdc93636c22dac3a6cdffbf160bb7c4aeca8c55c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f543016ec5015d07147deaba64d6cbcda68e9f39ac88f1dc8d733fedf645708b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__743998aef102e8e8dfe9d5d2b34641f455a71b01092299f8e41f6ca82bae6b85(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f51db227f5c109c9b19a655a2b94444a3e16e23e8529e1e572a533ead1770e16(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d15e9499841bdd8f5f224062f1b20b2ab616bbfe4e571c33b7d203663e28352(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__addd6f17eeaf531d939f1dbcae4fadba6ea2039f47330b27424ef3170837cf64(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ef7389d65d957721cb04682f7f8b8072df87da877bd7a59f6d2c337805effd8a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d9a00fc7235001ba4262637fc721c39f9b888fbded0c064b0526ead487bb6860(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d8b76663a126189b75dd3d2f42b8207362fbb549ac9541162994e0e4f5785602(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2bda7ee76ef5f5059fa264b02a0a576eff7a826b8eb23b3f50a7c5687f19fa2d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9543186fc3a980d28e89138a70eb6bc4b5b336b1c2735b79722bdf2b6747f302(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__694a4edf48d72e6f479cf28b9632d3ba606e9fb4f9c667098346aac4065c6cb2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d4a40afddff171f1c29ae192bf16703643b05047b7704673af624e7e9d9b772(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__09aaac82e292b3c7a586dfc3c95ae261074f1dc029c8a4ddacb6e4dc113706ac(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanChromaKey]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__121ee21183b6bcebc62efe1a0ef4d0ff67663a7c03262b0077d4bb4133b173c7(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanCompositeImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    placement: typing.Optional[builtins.str] = None,
    placement_var: typing.Optional[builtins.str] = None,
    scale: typing.Optional[builtins.str] = None,
    scale_dimension: typing.Optional[builtins.str] = None,
    scale_dimension_var: typing.Optional[builtins.str] = None,
    scale_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__51e647e09cb59cefa64e53c7e34d37b8163e6c65ffd8daeab7024671b6cdeac8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__75066189cf2d83926dfd730d986b845c131ecfe1bda83e60b0a8155507e25920(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanCompositeImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dac50777053eba531364d0ec50408081cfd2b3e0373a6fd0477513695221e3e0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f616ba16233c7d1f675f40191e1f1450e0c3bdf39068766d47bee41c0507f663(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9fc9a6b80e1e08f63b25d26a35dc4960fa12cf485dbcd2dcd4d49e49632259ec(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8bd8bc36d728cc539371c6f2097d6e19505f4ae60c06abecdd30c128ff2b71dc(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f577f7b168f848c65941c7308278f4d25cdee7a5dbabebaab3181e23502e965f(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f68b46625778d0d86021cdd49218cd4ff06fe834957501a99c6cf92db5424498(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanComposite]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7ca3c036df2c32d838e4bef1a12ad04c779feafd4d3f1f117293be740d1110a4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__91ba19cc2a95e2419845c328064962a0fa2473481542ca7a995baac5c4d87109(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__80b085cc300019ca99323e6d816ad0bbef5d006a4a6664d6d384116513d87b06(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__12c4bf1ecd43e29befeade7b5b42bbb9d5887bf8283deec87d6121dfed8b2319(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__71260db5338f341c9bb830268d28f083348b3324c5a22de17982fbf5208e6735(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__77d49811062a7d07a6aadd75f27be75fd95d0c19a7c20896bcc1bf87b352be7e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7e2ab153ea360a8c5e744528556cd51f4b339b724ed6210f426e8c2bd7da894a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ae94cab445f9b5ddc2c01a16c8bc5c8f74ee78ec0d3da7033a7f5466cd85dea7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__27eaa3cf37da25f0962a40be7aca2da402054a67b1fe98cc64587bebf54093e8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1a0c5a180851521b7a1f3315fec9071310c963892a5064a8b1784528127bc6c6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d63d199cbbd85477d2f01bd1aba55533c31c20fb11dd2f2211151d8f905ab220(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ebca0195a7017fbce8baf35c8b56e345308818869d049c42c19aba4a3733e76d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e08a579005365ef7570faf61a72e720ca59492fd847f3fcb78198e6b471684e4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0b12647607760ff435082acbe51c0ad7337f4c92f9765ec98336f67a80353763(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanComposite]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b43a52c8ea20df47d5fb04c5230b90899c95f768f42936e6cd9fa62d011d0d7c(
    *,
    transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__27f8e071f83de16052cac568189f00589892028d068c341833537483ebf5432d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5b5e021cdbdc4613bc76e5531fc992131a37d151df3f72ca9a13090b066bcec3(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__03c8c5d29bcc5b332cef4ac7229cf1bff6f520f0f6e8a81486ce0259ecc54b47(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d54ed00e21630853f576ec776fd00ca8c3e1cf44d73e7705b2556a28dc31ac0b(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eb45797e7b9d076aefcef3390d5313b79baa50f61d41b8c1c7e5ab6725c27690(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9558f8e81370d10f630c9c900a8998e705aca49543f304364f3dcf6d9ddad803(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanCompound]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9b3e2b17373954ffd1eb4ed88cb6ff80a8461cbf04c979d14936cbef41353534(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__722c2c74e4646ee6465163ff0357627cfa308cd2bda31569990c9dfc58f1f9cc(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__76329a0cf700c969a02594330fd263b421e20d75158ccc7d5950bbf1954b62e0(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanCompound]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__247ac14831d9f1c5b0ba4003ff750b95eb156449edf61880eb71c5e4e5883299(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7e077362e1f07bcbf13ef726348690c4deb37dd7561a59de3d1a06e56f08f3bc(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0568a05c62276cc2af46e1b2382ca7eedaf12994a63edcd3a75361fc8e9cfb77(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aa990faf75bd1f696c3df66dbb0d693a814de5f07e501ea53de52fe70f6b48ce(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0971ee0c9fa66650dbd289af1478dfa123a23156fab05d1b7560f8459a7a7521(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3d1836662d819bb70bd1cf5f8194e8b7a7d6018d2aa80a6699b532d3a63247f6(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanCompoundTransformations]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bf776ce95f2056d3b1468a4e47d70fdf24ddc657641d42834c8a942c9c577b73(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d593dc22eb34f2a3c6431798e57665439ac007c0a94fd9586509c21c230fda4(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanCompoundTransformations]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__64db47df6f35ee2b546bf0244d897bcbda3336743f14838b894370b5c8345e20(
    *,
    brightness: typing.Optional[builtins.str] = None,
    brightness_var: typing.Optional[builtins.str] = None,
    contrast: typing.Optional[builtins.str] = None,
    contrast_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0d1d7df6b4c0ed294df593bb3cebe2d0b5c009de864fb43fdba7912e1edae4e5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a210783e0fb9589a08e519bfa62e168e111c3ad47e52cf1322c76deeb4612e0(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a60a6ebc12250a7957d8381d507b1293818f0bb5d3cc84c0416126e88e6c7119(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__818e939d6086e8e3054ded29ab80e21ab08114002497a6ccef07b1fb1e12b15f(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cdf041da37533b75006a67702853e31edf0465977c66a7157d7df84c8769a72d(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8b538890b27563feeb06960b632e6b501cd28bd40593d1ed70bb7d9392448398(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanContrast]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1a874a8cbf77bfa59b496c6d029dc443b5c33cb9d41f639af7a119bc809733d6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f08c426e9fdd5472aa4de82a84139f66646f10a2a39277f49925b78cdcf08ce0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a98fa0b30ff295ce6ab49390d6f86477700231b45fed158575bb8016fb81df21(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8e9f34809534cf0abe655aa42a8eea2a62ff80a3b45ed21d6d7a56874606fb29(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a06eaadc570ea06e6f6f7d756be1769e14ebe4812cd59ebd89ec02d9345fb3dc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9631f12ef03c6b51cea7fa91e44c61017a2967b4ae571fa01167ff3cedcc0c2e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanContrast]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a074f37b6ff6ea285080025250d148ec02bd79b13ef03827f0886b9975f82b6b(
    *,
    chaos: typing.Optional[builtins.str] = None,
    chaos_var: typing.Optional[builtins.str] = None,
    density: typing.Optional[builtins.str] = None,
    density_var: typing.Optional[builtins.str] = None,
    power: typing.Optional[builtins.str] = None,
    power_var: typing.Optional[builtins.str] = None,
    seed: typing.Optional[builtins.str] = None,
    seed_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8700771149f18e00b01131e4d459bed826ab75423b19e7693f945f8c83a4200d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__50332aa48891b8e8cc3af5dd971c5eae2a1c9f0e452724a3a485c09390d81bb9(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__743977e96b8ce3737f56ed0c13f662b6daa4a2051c225b67b72f65f0e4d7ee64(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0d31da2d3dc2d118c9d919c0a51f1f7f547fcd47976f042fed033383aa0bfd4b(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8cbf56eeee62ef0643e5c48122eec08f9e81568afc81a2ae3b8265355df49303(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e29ae08eac3795a9f95ccb674b591a6cd35241cb3e7a265f343b1da0db5de1d7(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanGoop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a268941f7db20602b0835b63c1bec5462b707976861d0bb7d9d96beaaa3b579a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__517bc980b12f4aef024369435984ceae8ac7ff1791b745413d7e18ec9f3ed74b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1bed3dbb40f06a212aa8f6f0b21abf5841820bacc6d8c73b971b8fe5857e77bf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3e6a80a1ed0156d4b1a9ce0edd9ef739286401d2d958978c3ceb3d10cdfef7e0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a01f87dfad8ea87920ddaa0bd60a8eae37f8f4dc3187a28a0435b0d885360662(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7987c50d6d7f3a18d15750aaaf5c1240a7d42543a3dde8b72dddf2a8d0a78f38(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b4fa73ae5afde20a375eae4fc5e26f0fa79e3e8e4c497e4368e2db3926dc4087(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f0444914296c5def576d13eb97692e9bd482ce842d504215133eb3d31d961c18(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d06060d2639aea560f6b83d90ba3adc1cf853db2a645ddd8056b95f8c948e4fd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d1da431ed5796c3bebda09dab2996d87356a56184b3e7f39c3d6a9944b55209f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanGoop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4f66bda0b155f4352bdc032af9f47070d8d5cada27ab4a78b856d0f49d5d84e8(
    *,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6c64c9394175ffc89f0d723bd2bad8de6f191a0e9e49828bd186f736b980277c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ef54945ad9ee049de07ac842769dbdf8fe6c0eeae3603043d6064f7e9048cd7f(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b7e600b589157c7370123b276a768f258711ffd136f733bb5d391aa3427e1d0e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f905320d120f8416764adf61b2ea964e9258e4a4caa63687fa557c2be906c74d(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__89725d9848912be951d1a129eddc708e07b32e7265fb75b827f5709bb9d78591(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6ddb2d23b53e70f523414ccd980c0bd861cc86aadc45b6852d8797023fb6b5a8(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanGrayscale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d490ea665dd0c94e973777e990376d1b46cda466984458a7b40710a82da9d30e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9178f451125b4248a71693df2973a7cb234c5639950013c1089606b8e32f3e54(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__34ec2a1857280c635c58016ecd9fea0894438e802789b939c8dba20a016e8f3f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a956460786d05318f239876d9e7d99e658d0d56169943c22823b110a56114177(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanGrayscale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__07bca4c7bdfd3990a23e34dacd9456478b50cd3fa0b9a288dcd3b5b62c5a5ca0(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness: typing.Optional[builtins.str] = None,
    lightness_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__34e3e8f68247113ebf66d807f6fd9506dfbebcca7f953ffbe34dc4702b0d0867(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d385e5244dfed25c3d66ab0d3992a2201615bb18b8287c0b787989bae67dc7a2(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__251bff43df8a6a4b1098e228e8779b33c41800953457b2c8c44674c7ae47c2e7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eafafe9c186cc65fbe8748c417b26ccaa1c0c5b81a44f10dcde10cfb146f496b(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0437bcf243af9db3a22e1179c725b7e34a313c935fd0c68228362191ba816ba7(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__67489592dc355b07602feb4550d2f614ea11d8638d0d21944165dcc8a2460a88(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanHsl]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1544eff99b8fa0ba2db638342d8463aa5200079b2bd097a1a9722809071fc407(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0e8cae7f6fcfb4746cd2680c772a423696af354673aa68b1b1260dcfc782966b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d0bc6e04f59f0a5980c11c42409ef2a401d67265b663e2b1a1d40819da19e312(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b89e406f17fcbf164523a03b3fa71e10f00e8d2813c8abd4b71b3d727920c84e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1661f566ab2d481fb4ba38d8d3b6c008a96cb6a5f8898669c3eae6107458f57b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__31d2f254c059c23d7f6a281e56d616da9871e4c782c41d1b8f6945a76aff8dbd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__715f0a97fc15bdcc7d564a3f41e863aeb79712a8237fa925d8226b0a6e33848c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ee04d5631305c2b568aa6b8de945f2560fc3fc0894206cd21a4dd4b7a91bd541(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanHsl]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__181fabbd06c4ea02975ca2ddf099210560b14fcd26d8229f9db008e5ad67c2aa(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ccbcccaad7c9a1e21f008d2701797790292da880b588b92ac3cfb021bfc90735(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__60413b27536cb350f55fe0de144414c49cec098bc830ef75b31c8a0660ebefaa(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__29d61a0521fd8247905536de415b75c298c94d809f7376c8b1dea7eeaee634d3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__56edb99cc31a4538a3ed99ca245306f4feefc96d80aefada7c59b4ad37a3fdbe(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__081c87064757fff4a6a594713d0cffec5597be5721da494f8a7d4c5b50a0047a(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__80c5e8ffd729a5f2b891ec9d6756c2c801b75c8737ec4c863bb3a4138dbf8841(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanHsv]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e119d43a4a68b3ff570869e88de0c8a48c13f907e4896952f103f34dbdcf7479(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__68e0f5f60629ab72067095fc91b8358ec67ed07a52f5a7e96d322ff9cd356ba0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__337d10a6aa33f4ab67284c45582e97a26db85bcfc2d35a567a4c9320b04a865f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__833f92b760d966601dc53b34248a354e330006130f59280df85d611fca2ee240(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e034aedcea76f70ff8ceffe1fd7f1de3d258b6477777c885e724e8d371b23aa9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e1b5645266036e5c4b57f93b526b3d15107de980fbe4a17f1b9203bf2e73464d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d7806e9f92bec11315c8fbda59e78bf622eb807e4448453e6291c41c410db6b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__85ca3207014423554ce08c9ed5ad4beafb6b47f45f3bcb892f5941b9ebda9e4c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanHsv]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4c7f7d3519ef880ffdd61c29cfd16c50fa88898c98e4420de6821387fe0c11ce(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    dimension: typing.Optional[builtins.str] = None,
    dimension_var: typing.Optional[builtins.str] = None,
    equal: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionEqual, typing.Dict[builtins.str, typing.Any]]] = None,
    greater_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionGreaterThan, typing.Dict[builtins.str, typing.Any]]] = None,
    less_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionLessThan, typing.Dict[builtins.str, typing.Any]]] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2e642a604ef0324c47ce3ea529aa748e1fcca5321e91d04e686bf294c9fd5bfc(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__412f49d76020bfcb03c875dc60235ed0fa95c3f0e180ed8879c2bd790eddf6f8(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__19610fd1b59ed16d7d474c97a7b287e80d0ae413f2e69131f904ede4ebc80fb0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__62b1e5160acc1233f22ed8ce278c208cb85819067f5393635944693ba130ad75(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionEqual],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea3f2c47f6b512c15c4a0bf7d0c7c99a1079484a9e4759518b0ed7b668eb5cfa(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a0f5e7a1c46ffe07fe21fb5a1f91def9f6bc4335504396cb066e2ba0a7a2bfdb(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionGreaterThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__deaf73a642ee8e74d9ee6c96b976d890acc58476928d0e065369aae4cf017b69(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bfcfb532ef5146bb88a8154e206bda9a28657a86cba5b3d624070bf072f3992f(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfDimensionLessThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eb26dc2d5ac9db7572fcb6df2469f2b80b2c9c68aefd966f84b3bdb7ceda89bf(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d3e809593cacb8191a66281f00236e8ed2a7f00baae0d9ef4a41cecde34c4496(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1aed8b68b5a0af810e7be84ff515b7fe63ea912ca8e9a632234a73f8f9a7ed4f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eed5b895e6ef5da5a3d992552dbb5cfe4cad87d32ef35e014a7b1aaea39a49e8(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e602950ab357df7a264cf3e4611d3b764537aacb02ad2d0a964242b946604d6a(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__87818d2fdd49a995aeddaa1264d27f9ea6881f44b4071ad1d660c46d4a219dc8(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfDimension]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fc95157507eeefe5d2e3a2b4447119c1b17e7f86c23ba4eee2a4fe6439dc2938(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__139d512ffef0c90c40770e6ee638146efcbee83a9cf45c1575da0c56158e63a4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__10349961bfcf98c75f986069f179c3dfc7bfbe058ee72f4be0a943977470c19b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d6782499383c277d59e5a63d087132b2f92ee5c9d1d5f6852d236dc72ca6cb5f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__642a6c3bbaf78d5edffc5466ff298cfb6e78d864e647eeb7a1e0192f19e29bea(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__448cebf59b768d997ae9ace6de0f174eb78952b65313b8d470d7b723d80fd273(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfDimension]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__51e029ab2be799c6a6ef35820b5e2aa630c4b57f60965154cde968ee27bedcc4(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    landscape: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationLandscape, typing.Dict[builtins.str, typing.Any]]] = None,
    portrait: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationPortrait, typing.Dict[builtins.str, typing.Any]]] = None,
    square: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationSquare, typing.Dict[builtins.str, typing.Any]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__694a3047e7538424924972009a27c3aebd2cb9f88a86962541facaf3b095d3d9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9469eeb6eac943c0f63a9109c438f26244f13896da19af922da843131c5188fc(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d72d90df4bfb8ee92ad171f2265f4c6a45984a09a95797562f405aa32370046(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__49a2d65c92a26a3dc600cb1f2e2b95a3f009da1b5b6637b0e506ed44292ae6ad(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationLandscape],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f412cbd21994dc8d15802099cb7abe32f97a0cee2430271cd4d65018a18ae800(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__199ede77a41435614560ac40e39f18f57243d66b259ac375d233da726738e93d(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__62023cd137477baf6b82ac25bf358e3ecafd8fc52f6dc59d3dacffb61f3c58f8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df47b0d2ad2d6c8c38c7f9332362a1e41640eaa992e3b1831f109779e326cefa(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fd9818181f9258b58f13a4d73afb232c1e9f1ed230ee134cc5d84b2b950e9920(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7a26324c8d39eb0151276a5b7716a6815a5e6ebf7271158592f23177ec9ac729(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientation]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__77714ffd8112921aa9194a22ee477e1cac5cc95c4194c8c1005968534710a093(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__71311bcffc36c5e5a8f314a64165c1df2ec3a79a593671aa923ac95bebc55e5b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientation]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e6fe8f790eb61a19d91bfc05edb1785f67b9549ca9f617ce24b6a69c98b8d8a9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df9e49a2ed628f111c4a27f0b639a6c3583d2028c7f92a7d0dc122d8125e921e(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationPortrait],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8668c0039938ccaeae6b66c820487ea733ca1a57d17518ac05c7c2c4a585517a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b3311efc92ad5be7802a4838856d4cbc8eb62649ccae4cb5c1b5fe60f09abf99(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientationSquare],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a8df196e33ff34bc53fd36dfbf06ba978a2c7a68584bd1baab36c6fd740452e8(
    *,
    colors: typing.Optional[builtins.str] = None,
    colors_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__486ad48ac83a867e9e44d6b6c7a6276e75888b8605d179b39b74cfe16c81f34f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__acf805f2c9acc2b1aa02ef2f81892668ed67e0325c89bf49c0a37d0d561d32d0(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ebd1215e505d362758c8e44b0097b45b5734f64b7289e7521b077492647beba3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__047648730da2f3d2d1eb59c04699c1eb69d2670b0c63056d3a5c00ec3314dddc(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1c2c295a482d79c455e2d9d34c4d517380c4348ade5daf72aacd61d125606ca7(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f3a7afe7424bffe34c78864f00b71229a09764fbd3fdb2c8d144ce9d167cd1c1(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanMaxColors]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dcc9e89759234c9b5f2b3e9b76bbb7480c85f325293d29dbd37ca956e0f73bbf(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b1d28c67b941654c3b1a4cf6621f61dd43fc824ca7327ec143ab89cc541e93bb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8092500e2da23b9ab21f4fc6a71ba03c63419dcb0d0f84d3043215ea37bf5fea(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__07e1ef756e0b3e2ee3d4448efc66ad03ccefd8b0488e7bc35e37c695024013df(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanMaxColors]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__731ce0fcbe24eac7680a003567d9b7faa4c605d403bc17b07c9e360e2343d261(
    *,
    horizontal: typing.Optional[builtins.str] = None,
    horizontal_var: typing.Optional[builtins.str] = None,
    vertical: typing.Optional[builtins.str] = None,
    vertical_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__412d179234b40821af00dba79e23443bdf4489a3356eaf686b4e7bd8fc54305d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be9b21fb6faed4e96c66d5d8a45bcfe8eb7941efd016f9f28c609fc39dd69f56(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ec90c1095937bb692895d3c9aea6006a940afcdc5151658c80d1ad3f6a460b1b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ee49b6fd39a6477e88f8d409fcdf9677399895b0ff79cb8bee7138e07810f2d8(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e15b01ba7860f68547e93ceb2fe0288bc252ce9be3d9c55493dc1d465076e13b(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e1efdc33848f1c6dbbe8736e42665724a20472ffe5bb8a074ed46b8b9168f237(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanMirror]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fa8ea270c3f672fc058319c82119a3eeb70ab2514abca0d6315242583e3afdd5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8357a8d2f8cee687f4a4e79332505ab13fa64ce8c5398f8d934dd55177c4a32a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e4554e1626a29a947f9ee9c39283d4b9e2d3f9013964418870283af5ba6e078f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6b95b85c21e9972b2d7ce9fc389d6049240c26ff3cd261a5f2b45d07147832c8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d143380b2026411313c4647a01b8384567ba41d5c2f8bca271967030b805083b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__82c611089a1e75d015689affd7bb21007683f8681dda5f42ad57287d787b520f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanMirror]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__66d2458f4ee484c0db7cd69f6231949ef4dd57a201429492b997f6a29d921f80(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9c37f24a9f67376207f19ae0705af6100488d73cbb3dba06a6114720237c66fd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3d2c64e40c6dfb30420a3f406cb5b6785ba4501e1c53ffc4f50d59390e2899ef(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d5d5832e535319bdc275d9075d2997f63189da9ba85aaf450d4b163890b4ac7f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ce92fd106ac80a3c55fd119cf43930caf1f9bb545b2d76de9b4f3723d69fde47(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f5811b56202369ae7c973eb01619d639bc2ff3583a188da29adef3e2e55e48f2(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__68a3801bc0859e670320ceac03c8aaf61aebd94a654d6bd3ffd18cc9816b3865(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanMonoHue]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3e4a9d16e9112ad8124a80725a4f1932c3365bd319bcb7a6c6cc0b520ffe73f0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac0a52c8348ae1efd92080e5ebb1b79df8089c6e897e7a945b68c57e3b99f267(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__75b3cd9cca3fcb9fd89216f4168fff5ba00d246ad68c7a4c65ea10c1d4dc7106(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__481332523bd34491dc2f6280453c25f769341a39ba5f069708ac0879eed3898a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanMonoHue]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a533db0da8a88bf18758341fc7fc3d2c48fbf8b9cf0afbb6cb95323400f09c3b(
    *,
    opacity: typing.Optional[builtins.str] = None,
    opacity_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b7493b486eeefe8d747db5d519836962f8277e7ed42db4821aee4b037cacc42f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7437f95b4d7cf6860a92ed9d9478ba94c56b76456f8a358c5a1c5a6b3425e228(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1c627822f4a4b23c6253e61fb11e08770f750fc976c6fb5dd2df322795e0daf9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d8d559aebf350595bb89d295d4c5d995884f8bdf7b837ffc8f8877857fb39efc(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3037a23d42842db1d379b05d418031884cd6cc25831b26f51b6770fc55053925(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0a921e62b47fdd1d6f1b9c371eafdce70d65eef117763ed52427c46a921bfd5d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanOpacity]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b8ef8eaaefd9099a96943c5b6e59eb66b3803e0c65da0371ef47e8dac9ce231b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dd6512ea4970e40e1ea904cbf67f26fe93c36dbf7b70df02aedc86d439deead1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df32bc4bc4ca02d1ed9faf90ef2dba24a9787290d711bac15958ff1e8e8541e5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d423e1f911aff496447a82bc7d0c9b59e31f2413aa88fb6d40243e758fc76592(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanOpacity]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e144c8cf3f0d89cb052d5f2a83f554f4fb96aa956254d8e53b2d57f69d0232c2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__78a5fa93dccfaf1f69cf7f2a0fdb264272d554c0a6da34946822b71ae8776ec3(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__946531e9631417793d9c78c8cb31e1f6f7d57f77159627f14898da4f47d25cf4(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanBlur, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be3e8a31c67af91d95a284e7f3d19736814c9895cdfef2c30bfe9caeb52030f6(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanChromaKey, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d2b77fc304f10923c264ed17d613d43bf6e8234a737e9b79f59dd02f66383fd(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanComposite, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__354160f38bec02568102665d25d2c600541178cc827577fc191a6809dfd77cc0(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanCompound, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__76953b312899df5d28cc9fcccf4bcf134a68e92c89703ac95524463a6e8033e7(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanContrast, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__849259cc9d0322bce65785c7800f4afed7dcdc808f80c77b7bb8be19da92fab0(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanGoop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b06dfb6399209411f351d5bf0fb04d2904ef35ad06b61907ed0b76c391f6abb3(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanGrayscale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d5e8cb40bbd5a0e2fa974b66fa1f0896be1f9bb481646425a2c7775cdc973a2b(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanHsl, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ebb5fe789ee705e4041e29c391c99f16685a8971110757769ac8719a0fc848af(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanHsv, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__343e78f2dfff04fbdd1f1e79662d67875295922add781ea5ab71601997a77682(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfDimension, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aacf151175358adf93b8352bc2ba56c695b406f362e11607de1e09a6577f6d6a(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2970d906b8f449bca9fb8646e82f9ecf300a4e7893919c2de976504d5ae5ed41(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanMaxColors, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__28349d9cf34628db185311d3da49df45168c175eb05a113b10e955693167c6fc(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanMirror, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1c7ea9132d77df8299b86796e68045fb1805491d97cc4b2f4b697a6095ce5f6b(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanMonoHue, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__da4f5c7894acfae5ae277d12494fc329624562a56c65b29a8d755201a89af2c3(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanOpacity, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__52a5114fb1d76a1304b7054c76ac8d34ecdea04baa5a7b658da5d26d038f40cd(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanRemoveColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0bd7d7dde642e5f01ec363d624dd24aa251d5ec91ed04d63ee7346bab9264731(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanUnsharpMask, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6a83987b0f3a57b4dfd824a127b9b539d93545341235e026dfc71d47931a4a1a(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4da76a265da996350af4dda12ea5d0a816c152b46ca013a43ec3de7470dfc317(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
    feather: typing.Optional[builtins.str] = None,
    feather_var: typing.Optional[builtins.str] = None,
    tolerance: typing.Optional[builtins.str] = None,
    tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c98e6ae57ef43918bb4e3ce9b0747986d437ebd3b1a56d7f3a68157716d67819(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f9594fa525b85fe10b5a977001a71a3bcefacd644ff559cd2b3cb6fcab0eae9c(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__53cbd82f2b52408b3468f61e69de392fa4f863f3a73e75a47f66824c1d93810d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__adc18aa9b1c086c658fd0d22b9f3a8b6315ce28f37c5cb0a0accb9ad96cc2c01(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3886cbab4f04fef219c3adc7d65c30da517e87f409cdee702ff6a232ff73c4b1(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__11e3bdb047f22577a51b862bf1b39f70e84703452edb8c15e8f7f5440df6bc13(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanRemoveColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__741a9de33871d333f8f7827b3465924012d2cc79e3d4fb7fff2cd380bfb077f6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb74c7e46eddb85f8b4950eb08f2dda3e7dd753af0a0aeb3b7a8d3676362c050(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d6854c67bcb2a4357e866a4dc08701f3f0c391bde86de2117a29c8185f5015e9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__81afc20409f6bb4ad831ef27ca4ec2c850632f70f0f75d98888a1974d2cc9518(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a6a0cc892c1f9a5bd3ea01c943e4dd20bbf05a9d10ac7314af976d702e2f1057(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5c5883a3f59578deb2ffe8d56cddcab685a2b90c4b1065047d95961e5f43afdd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a2f6b1adf92794e7c8616a7b27080bb0f8ec2dcfc536c85e245476071b9d5f15(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4b57066594eaf52d93f4d662ae94e04141ffec89d61ffe25b631c4b2ba8d6def(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanRemoveColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d231f7780c0ca263ba7f9524db6ee6fd6337af72762dca9b9901a137cd6ff7e2(
    *,
    gain: typing.Optional[builtins.str] = None,
    gain_var: typing.Optional[builtins.str] = None,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
    threshold: typing.Optional[builtins.str] = None,
    threshold_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0911aafa65c320c1ff1d905239b795cad8f083c9dc015b9aa0ea977af35dbf71(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9c8b6c44ed99d6d46a35f78b6e1bf64b002484090167c8edb7aabf89b49a80fb(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b4f4254fb4234b6ac5a5d50bdfde09d90158df3b123d2fbbcfe9726ff2e8ac20(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c7e61a3a72bba5286f982bb7d835221fe59dc77d1ada61099ae5fa976ec98026(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2c710111e5366c590857c0d46f551f1e1bbabfb409062c067fac6e00054abd51(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__da6c71ab85f4ee7c7d47f53f7e6002f123f06d53b6826169b5fcee4d7692fdc2(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanUnsharpMask]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0566f1ed4ec1a55c96a942be6bba32aba6eda3f9a160b5a841db03bef26d5efd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f3826b6c46ccc42716b4ce2c03b3936fc8e8a41de9dd094654d0900cbbbbc4f8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__648956bf73aaa01b70984c42b4bc0de447fa81d75ebaafb39f1be5bd5ccc95e4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fb420b03efeefbdc26441cdbaff02e78258474c2a065b0ecf1b1a190555a3bd5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b098d4b4e47ef2147ab29976650410690b64df57d859f2d5474cd7fec31604fa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__54253230a7def1efcd45b4c49d7ad1259d7b1a82055dd7bb0d6e66bcc7220171(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__080f510120cdc08fcefdc9f4062ad71dbc23d46278b7da2e1b1a6b3e96dc39df(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__086f0d766913bff74d86166dd933f1aa31eab4266104beaffac3d425a20ddb4f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimensionLessThanUnsharpMask]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b2728fb89ad7f816248816f561a65aa76751c69d602c11d27127528ba6e00f8b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a4866b187be7b66c870f318d93da42dfe4c739f3b0b1015c42c97db1400d96e(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__61c99a1f2c3687f730261b4da48a6b237d1d64a29bb2d1825b94533dfe17a8db(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8b2599de16acefbf0a66c56151cef1b0057c97487d7278556d4360736f3115ba(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e6de2d166e1b3067ab7d31a03049b6230373a1bfc10623b487ef6594fe77de6c(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f773c53de0cb57e12b499872ad64678d33d1b1db9628a33cc986efc664c5e91(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimension]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__73870f8f5714287317b3f66a09ed18f71bf8162e4f8d88871de3f3a148a5a6d2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__75e8a2da3959413720a1b251d238f80ef6e3ccf9c99e0a48b017f16a54cc67d0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__077903efac80858924b1bd0aadda272d4b418cf9753964a7ea9cef40e06697aa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f0ed1a43708dfb8a3259a5fdab74f15146c3b5b03160817f554d0904394d3670(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ec003a0069f19a62f33662383a4204c5ecf2d34e8d019df937c56bf35ea55cd6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__596cda135d2c7bd47cc514e53fcc2d57907870b9880eb4db6a76d45feddd24ed(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimension]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2da7c5fb603889c5ec70ade1d0e4e1e210e2f28243f83ecd33b9e02d2c889b28(
    *,
    colors: typing.Optional[builtins.str] = None,
    colors_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc643e2a78b66fe7762197b4567b6a25b5becdf4e241f0f4766b9c8168d9b9bd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3dec8787a4b2615125086b81c5eac14d4a912114e382d4531c634090082c849d(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab6fffcf6afe58d57467cf97cfbaee63def6b44ee733eb610a52c88634c14718(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__adf71f00f64d9f7d918b3362bf49607a95bc80a0dfcbac9d804d123781304cf4(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ddc68ffe78eba1b0f4a66d8c4f2118973c9d565a451c110e7c9036af966b4c97(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__73f528f6a013d128c731b373b9d84c567d588900f09849acfd27836b488ba3f9(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultMaxColors]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__89975c0089623d22cb3255f2ce085a66a6a5897f2370c883a645a00b52b6769c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__829f6e647c620719b038fbe4464b78774abf06bb1e129d2bedcf34448416d93a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1ca64ef6dee958dbebee05a5926a7b075fe6552fd8e15fa7aef42a45fa0ab5d7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__56a2f99943910766524cb1410598da3610cfcd2332801605bb27bc4917a73863(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultMaxColors]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b55066b9c64cf6f3c6dad96ad0b64627f3173e7318050de5e189dd435d800135(
    *,
    horizontal: typing.Optional[builtins.str] = None,
    horizontal_var: typing.Optional[builtins.str] = None,
    vertical: typing.Optional[builtins.str] = None,
    vertical_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c5d747b1f3dcbc80d003ccdb7557ac3d5ae0d8732fc6d6d230c65a503dc8c90f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c150c7d4c7a707b270ce70e6ab75e3c99daf2f933ad85deb02b2631fe6ba9009(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__64c13ec81e0677797272f41a31f87381fe11333b7ca4b3c3d0684b923d3e2a48(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__75d83e5e2a25b5607c2d90bae1e77d1656dd1b0099844e7220710a35ea0c110e(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__796a1c951951683188cf83ebda9e3f4aaa7b63c811167f948d9d6b8387d40465(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7c94b07d6c0acda6974f68b11da9d62ad38b22633fa6b8d13b7b30491138f527(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultMirror]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__57405753809a3bc2e4843251f148ec0cddbaa373a8bbde96e7251ac28a472eb0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5598d5a659dbe3ccf7709cfa6c75448396b729dd80b6fb9b98edf70f8ea09b5a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__88deea9d993618441a191f882d627d3876563234e98ef524022bd378204d8b4d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be92e0199577de917c6c5cdb14859cd426bb0cf44eb8421ed654878fb2b87a3c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__18cfb2832d8a5a7ded31b7f34f995fc072a12d1c6ced535aa0ebce19d72cb12e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7b637b9decdc2007a9e1f5e1fde3de2a084ed1d18aef886bd847a6d15d20b51c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultMirror]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eaf739f32bf7acc9a03bfac4de76a3b5e58a75d9c6bd4ddd9c68a60efb0d140b(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ffe4e72c7e7ce0eac017bfcd3415eea852eea6fadac51765cdb3f0838644642(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d753e8086a78dd82268a5917eb236ecb6ee7ea0003bd173234076b751f02c6a9(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8af7a6f5e002392fcb80944447ea01b9a9449dd5cda8e786555791c8a6dd47a9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__19b89c18160f6753e402e4c2ff837e5ad0de8d806a5bc91c475df592b761f8d1(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ee4ee45d25d23708a4849aa6af950bbe16db1f50677da9573b48e3e717a1bb53(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3fb926d6778a6c0315175fac35b5a176ba19638dd619c8f8107f68a4dfb8690e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultMonoHue]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__77aa61786a8fa880f508fad3ffe8d1735dded75e1d34cea7752db467dd83e144(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a7345313dfbf82592091b68c2b08ead8c2c7e90b2f3ede7adb320e66d771cc72(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4d542db0bb673a4cf3089bbcd769fb00f4a51c983836e89c3e784346a42f35d1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2eb84c233576fefee277586399f1d40e7231512cbf803a51b72237cd62628c27(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultMonoHue]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e4667a2df1c4db02602a93795e49c0e7b47bd397d7c6d20452dae2940548f38c(
    *,
    opacity: typing.Optional[builtins.str] = None,
    opacity_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c7a717fe5e569232925ae6f208d4a4726ddac94015d1bc64962d1e6489609678(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__584f1bb316a25bfa7f1ebaed6073facc0d2bb90ee917c94f5385a252cd07ee1c(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c8b60159754ea5306070713d59b167cb03f805a09d5efa6e492a74f9104aa62f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f8e2ed36065adc84eb89c58514bf05618dc6daebfcf94c09961b0adea24ea50c(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e51250e4d80afce26034112a6e3f5e8b9375b1d26d2ab8fcd63c5c7cf433bf36(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f9864de5f252b37caec3f86f55f978dc67155d06a749b61a1243c61bdda295d0(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultOpacity]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ad41b284036c0344e04f7b980655337c0a3b98dfcb31fe8353affc33988f82a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__39a81bd254d28a24e7ef01e81cae4835ec0113bed44c01dfa86215bafc62b88d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b92ed1c22588a50080de14529ae389a2b5d65f4b173fef3acc87085ce8a12c76(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1e5440d2d75870b7fc1ecfa8b10d9f3d698bda8219e8584d7420cd9cc9503d05(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultOpacity]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__77df161c4f3dd30a009dd53c8ba2b84d7824f9029ca8d28eca75e1fe1440c98a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3fa55917de40a4cf4baac0451a912bdbcd4355d11f036c70d57092c18b9b4b68(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__605708a33386546c857882a4a9b1ebb44cdbe0bc0e0e50a197c584296edbafed(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultBlur, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6c6536a60914889cab08382ee750a5d9d40c727e7e4826d6c72e739522cb00ea(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultChromaKey, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__14d8065e92f57dea90721e5cdcb623f35b2ce82080ce24aa3bdb16790f9f308f(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultComposite, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d311ae6e97cd6e5a097f5a3fdb47e893a72e0f42f6ce6db93859c3439ca046b1(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultCompound, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__295171c128e96b9232c1a5204f843cbb52a92085ad8d86891bb9f2f92900e97d(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultContrast, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__57d32c140e89c3e64bf48d43b46b26153254533321a41e70f47a6ebae781eb11(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultGoop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__58a868b6fbcf8ecbc2186c44afcdb19a5e5d710e9bb71ab09313a21b62d8e19f(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultGrayscale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__451b661a1e3be1cbfdfb3f481ab1bc8651c054895f607132f64763d629eb032d(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultHsl, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0910c41db28a63cf0d33f9e2446f71ac76593bc7461d21d8b2b86ee7ca48c6fd(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultHsv, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cc7f6497fa5b5cf8795d9e20f5ea0438cfadf4ba09fcb28767900722b8ec38a0(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultIfDimension, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b30241a4a34c7ba0e553efa461bdf4578664fe5e1934ac805bdc4b2c6c5251f7(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a86e38b079ba1f45bf8ae29d0dd9cfe576686537b3426a17029cab1b4e71710(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultMaxColors, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8862c3a15349295465f5ec2553cd7683daf0b3706355da3733d0c3ad7b0bc5bf(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultMirror, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5bdd3fb0ccbfd46708d95112ee2a396bcc9c0591583a371ec48b7c741ad02d60(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultMonoHue, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd1bfc4bec678e8d75efe7a25a1e1276102f87a6365bcb985e38c14affb82ca5(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultOpacity, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fbcbd9d36d211be494d14cb485835f8741a1f10d7986a30f937ef055cffed484(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultRemoveColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__945ede6ff5508d61b76ce2f44055977d2571d601e813a29f42d9c4d89c59f187(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultUnsharpMask, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3cd8013286bd02cfd4122c4b9940f7d750bf9959810573baf6db25a416735645(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ae298af48639c88bdca1f60a13edf87eca9e7cbbc7d5aea9d76d24d827774b5(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
    feather: typing.Optional[builtins.str] = None,
    feather_var: typing.Optional[builtins.str] = None,
    tolerance: typing.Optional[builtins.str] = None,
    tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5249dac80e2e502a7aa62f89bd52db64dcb3cb9cbbec32aa517c1d4ce439abc6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c11c980bd958fd90a37f179112dbb32922b35b1bdf3d6ed82e9135249b97ed56(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cecf5a1a0e031f1a6fab40bf5be53d3c902bc5bb5c5632b9a732188e39bd9125(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__986df07e7d7a2902ec65e0a7909d9c11bff57c3bef74aa65c3fd9779f8a79e00(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c2043c0688ffd7b96acec4e5e55c62ba56ad6259b39c2dadbac9f146186ff0d1(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__791c74eb5213e84288a5381d059251e488f300330406e103dfb3f549dfb9ff99(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultRemoveColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cc5f34afbdaf36bcba6ff60d254f0530b05b4be8c3e7292a47682a024650b5a2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__531b28d52a123f7e2158cc3287edfb25c0b121f35bd028a24ed18ed9c1ddc958(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__99d8219a69c9a46cb6f9edbf4574fd46fefadce01d6f6b99716b1c6607f34074(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__56bd37a7a042aa07c94d16614e99d88722fe358006abc08ad25cb6e7669c757f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9003a8429b920bea6361b251a97704b2048c6b670a045c9f489d83346bf4aaee(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f2653ef99ffdbfe11ed4e2990b2812eb8d7124ab393bd3fe6453a93dce3b0ee4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8731ae7528e107074484e93c758430bc21fcfd74266cfa52ef983afe46d98d35(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7c6fc6cd1d9c2d035b8115ca91dc1eab9ab269af59e7818356b55ec19c9d0480(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultRemoveColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__91d0a738bba9de5e86aa043089efde443a20a4ab601c2dfaf1cf1c19d0c7d0c7(
    *,
    gain: typing.Optional[builtins.str] = None,
    gain_var: typing.Optional[builtins.str] = None,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
    threshold: typing.Optional[builtins.str] = None,
    threshold_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9b4711f9dadabd0bf95c844ff90a6918f2fa5756512b213f793c6caa853de75e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__73f52f25177d143b9d4d4aa03a9771488e0610947820dd2f9aff3fe86cdf1cd7(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__64d5f279b1f2a2e385e150e03f179ad419302abaff1ec91977ea42b4b844d8dd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a22b2bd2bc4065b6666f1fc0c7e41c8bddbc5ff15197ffca75005bec5267f027(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8922dde66c47911dddbc399a023e534be6fd4d24b1b5873ecfe3cd25afec6643(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc0d6e3cf2caff86d32f8588d0f010dd3a6189714e0c4ecf864c6fb595871c43(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultUnsharpMask]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ca7e0cdb32859312280fa01c1fc170e59568aea4d5663ab3fa462cfb9b3113ef(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c03afa5f6565069bba512d31e1cb26c8d69d80ad0d39a8a18d298b4fb030dff7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7a9d7a8a34a2767e45181f7329ea830de4922b969db4f6c830a6487ef599c731(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eda6140076a9fe06063876ff228e288859e8f91493cb403e7f3a95ba6b69c34e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b82477412ffb71ebc9267117494136d7676263316737deb146623c89575b6b41(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f75b2dd94168cd3405a9f36b0a9f6893d0925e52288e4f6be763b1def71aecb2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__14997fd54474cd2195a6a1fd3c6ac067a38cc358dd6c0967064d0bb022c29908(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a152c29ebc72e0de105d752c0297bd4bc7b4fd535845ebd0b336e538e2de1008(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationDefaultUnsharpMask]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__07b1553c1981a3b4e639e7180e938cee0a90af5044c4bcb83c2772c330917fbf(
    *,
    background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
    chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
    composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
    compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
    contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
    goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
    max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
    opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
    remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__63eb2738a8ac92690c6e41d300b17c13e2b5f3ccd24c92afa0ae386984a5cd14(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__82ea0fa3decad029c690aedf00739597a9cb09bd35171b8fc73f7938281c9d37(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__31a4eb9f7ba53f607d2e3bf38ba160ed5ed5eba0fb9460436bd6098f0c733cf5(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__51694c0d4d3193cdfc79f235a064b7db801d1af429ec58f00ac554d8f958343e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4809ac17b1a049a5f9389031fdf2b38a4b17a60345deaf5977f97d2be8c42c4c(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a0ca516aef0edee212d4f365b15aaddb8c6ae2ebf55eff296d7d556b8cbc135(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9c200c31fce97cbcceef2050c86c10a8332602fffc3f39a7bd4cf4dc8eb2ae70(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeBackgroundColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__95b1293f5490a102aa21557fc699dede630e531cf93d33ba80d92e8d7a1ddc76(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d1fc83fbfb9811720f397ad3d174db45fba88a9cac10415244e9c8c63b3fd2f4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f06dfeb9f2786af47efd9bd6cc646ef77b4af74235a274280b85d96e048cff76(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d4d516f4ec1a19e453c61be4e95adcae37a8ddd177c77a9035ecf93bb9fe6651(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeBackgroundColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b22e9750327f6280e3d52e2bb0882accf7ce4b9afe7cbfdc9147ab75542210f4(
    *,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b75c7ed3331986b6ccee4d2d56630b8ac9e7c54536004c8da06dfb7b04f385ec(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e8ad4cfd4ba8c2d8030ec8895a40f1d9f02cc63e804abc049a5e7ad4c075dfb2(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5332b91fac34a42e95ef69ecff186df675867294cf0b62d7c26e6cda2bb61511(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6acc0485209650757f87f25d87bf3d79ee75be6cd0d5f71dfc86dce8d5a95084(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ef20e066f2a9a56a4def6e6fe6a971fa96ba4248cd589ea012cf34c4f677ad45(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9072fad7a8e4d22ad5fcd47c6535258ef6d237d0bc502f8b358c5459db967f99(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeBlur]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0e6ab784a9a46830486152c634e76c3020336f086ce69860c7f42cf803d53b83(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c4c40c2e0291b539e9471eddb60e89f3014127d6db2bd6356e27199470f0e755(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__53491869de31627817a456ee0bd0fa20242f3bee66ee8febd83e1bb35ad84637(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__10e65177ae620182bd48a0983c931a0e2c3054ec8d72ece942d5a612dec08666(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeBlur]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__28491b5f67ea0a2c2f019ff0da411fa18fd0df5bd750ff2846e089c11646aed1(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_feather: typing.Optional[builtins.str] = None,
    hue_feather_var: typing.Optional[builtins.str] = None,
    hue_tolerance: typing.Optional[builtins.str] = None,
    hue_tolerance_var: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness_feather: typing.Optional[builtins.str] = None,
    lightness_feather_var: typing.Optional[builtins.str] = None,
    lightness_tolerance: typing.Optional[builtins.str] = None,
    lightness_tolerance_var: typing.Optional[builtins.str] = None,
    saturation_feather: typing.Optional[builtins.str] = None,
    saturation_feather_var: typing.Optional[builtins.str] = None,
    saturation_tolerance: typing.Optional[builtins.str] = None,
    saturation_tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9fafd1f8321d6a6c831c9b34c0bda85f45d7dd5c7e6762ee2b36a31d6036ce11(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0d417416a4b840ff0f9104d4e4a03353e01fe2fb732adc311d4127068039ce93(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__639b8dfe3291d8e59a526cc2bd8e3660579fb86311577716089ab4f97891d61b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e7612eb1f86d0b98e8a90b86eca07897409ab09d05b809f4199cb68d7cb47f5a(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d6f696faaebeef62a82ef51971633575afc039674eee3b5881c4c360021fc92(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e8820d208800114c8e471eeb98a4b6062dfc521cd202f1219ab7a5ce31edd484(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeChromaKey]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e444bef107a4e8792472baaa75adaad5de83f7212fec65f0092ec4be6e814bd6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d3f781450be1e2f4567f956e2e0af31342c84e322850992633cf9f71443decfc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__002cbc086387b4e4c47f95a6a80cc2dd585d5f76316b6b8b6e87a1512d35dcba(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7dc1254493cead9803191b41be2abef0a257c590e82346aa6f518d68f94779c3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9792e6f0497b17b266d1fe85806021c263a99579be53524c847d547c16a51d58(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af4c30957a29a03bf2a8b2d1edc2839788f41be06dfe17a4f5eaa2ff5c652390(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bae01e24a2cf2b0bdcc6276e477eb672e53ad94ecabec0fe332a2fd8efe1cf0d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d05e83d4c68c641892e7d50380d8d35ca36e9b3eb243ad5cf35d606b06d3522f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d5c352775e744f58932b8151b79ffaa1823bcf0fbef7c10eb938dc088e307975(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8bf12f936b3302908959fe0eb668ed5c65316223901c2f8ef38897403eb497b7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__976c770d7e6f451a0152ce316b9a03adacd51b2a8254f72bf055a26d8c512792(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b0386d6e6182afdcf926f02fc2c6d2dddc15dfc91db8cc12e6f63163d99954e6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1b38452ee44afcc935e13fe562bdafd596c1234ce0885617288300e834b01eb2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e30df59994725aa200aa2e1109fa84fdc707131df7ee48de22ac871d403c986c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5d0f5233c542baad23313d485a02343294adb99672bea5de933e78d266fc6c16(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e562e9273865e944e804114ec6d5a0d8732f97991f915f271dd6005e63faea11(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeChromaKey]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e26bc6e7739df43bdec2a54b56c45265c921949c545bbe35f90871d4328d66d2(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    placement: typing.Optional[builtins.str] = None,
    placement_var: typing.Optional[builtins.str] = None,
    scale: typing.Optional[builtins.str] = None,
    scale_dimension: typing.Optional[builtins.str] = None,
    scale_dimension_var: typing.Optional[builtins.str] = None,
    scale_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f3524c0f6113bd2f2edb0bad0b8d6b227da6986d68e6d886e9bf829dd266ddad(
    *,
    box_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageBoxImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
    circle_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageCircleImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
    text_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageTextImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
    url_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageUrlImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ea5a4fb1044d9d24673e27cafde83c0b720cc010bd68529f10057001b61bb1a(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    transformation: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageBoxImageTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e76c1af611cf6ee306f8342702a04ef98f9120dc109291e0ce3a939bff6f1411(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1abbbc082b58715eef11b22ca16de3f13aa99c3237c9fc1d656bd5dde9ccc547(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6d3f0e356999e2d8b38a97838b34ff8f962f3d91e0ba13ab85ebf9feb87a4cb8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aef52906e83c31f8a8398ad4ecef72966cdfe3b37ea15ae480924a8f88d339b8(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__87072dcde45e56b247217ddfe6d1d59983519f40a1733d14a60ff6e741d6646a(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__623660262c4635e8837a77849cb574983617c72fb503156761c21f503532cdd8(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageBoxImage]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__84141c54db4458df8a62499c6d67c3480912809c1137b140210fabf51a476bfe(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__01e419a0c9e71d95572843959ba8a072a306bd230cdedfaeb498bf858d4c778e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9f6ba68f1409c6b86bc05ef8579ea7baf69792e73a491fa97f2a3d207e9a2a51(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8acf19c47a60130d7a0f08ad8b6b45df2d526568837819dcb20dea073f31f567(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8ca8dce8ef16b6d4c02d079f817a66357447757a3f40cedfd792645a61a3f8ef(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__806b62225bf7df108e8f502f353eed381ef9582683df16ea4ced3d4aca3f306a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9765600dda64568c687cffead203c7d35655072b98cebefa53e7b8d05137e48c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__da80fa3498693d599d0edf4b24e74a40d8bf79f0834dc2318f71383f211e4245(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageBoxImage]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2cf95b2124df48e8e5f7d24ce1244b62b58fc3828e5f0e5fafa6451a62a4b45f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d251e40aac7664a4c24f5d6a6c63e6554ac549fa0cb9d586b2834cb66647e3c0(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageBoxImageTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ceb65534122f7f3ca16c264112495db663fe5e7dafa2167f10868a8383a14714(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
    diameter: typing.Optional[builtins.str] = None,
    diameter_var: typing.Optional[builtins.str] = None,
    transformation: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageCircleImageTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__32ae8cd0c5d246a5fbccc03256244ffb97781815002631cb7af8b399fbee412d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2e45a23863ba3b78a48575b21c4f97af9e23f469dcc67bd02bdc5430b9c39bf2(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d3f0c6fdfe8b99e5ea83ca8998fa00782f8fa5fad9279e50ed5824cf26e369a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ac2c4b97e377404ad941220e4bc9b0e090fa28f8c12338724f72b1f79a12316(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e9d8058afc24a5fb0838409b973c9a8974c3936f80410a6b7ba01c7e6b914314(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2c724cd35ab0f41f675c3922360c2925929dff0003872e7d7f485eda1ce56908(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageCircleImage]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7f67a5fccd54bdcde6b0293ff5794ecd1d89e5e3e8ed7fab12bb0dc9bd1df213(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__58090bd1068c7f8309cd9401488ededc6aaf41d2049601f213041e6fd227e87b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__270e1c1f5d32a3fa5c38dcbc51db4ae5b93361869157a26676fef9445926b220(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__04ea756cda52152723da7dd1c3f32381a6c931824a2705c038e425f03560066d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cab2d9f9b5864a7838c0b16524109da685e7580d7f8aad59ffea644fd7b9019d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2e0f163782293fce88bb4cabfd658d19c8d624257a0ac2c594b464696a3dbbb0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c38c4c5e82014750019cafc4fe111b6fc41985c5395a591e759fc0a9d200ff35(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dcc4f88173b2791466f38d5df1ea3da132d1c8c9b91e32217dd10b080ad7bb3d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageCircleImage]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5afebc95e62e74d3017d6304e638e1504d533bfa3b464e095ba8a94fb78c57ea(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__27e40e68fae9724a3c46f67485ec16ff6da2a296c14ce680ea900e054d925bf9(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageCircleImageTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__354b1ec199909f10cefab51e41a7390e0ccee36cd72716030c2297e1ec2d9358(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__15e4ba44590446ab15a79f4fd294862494b65d34bf120fd895a2bf871df4e6c1(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageBoxImage, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dc9074da98c93be23288bbbe33a67333f5dffc37b4e70fe580449be7e0e75f71(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageCircleImage, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a0cfe10673983aa1e6ba8863967eae845af64b8aea31cd065199b22a4b0614cc(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageTextImage, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e6bfc04b07e8ac4c208415004bdd95bf61cd214f8c168162f98074d4f7d80935(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageUrlImage, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a9671962c727e76b0989a1b40e25564fdf00b64b6f09765753cea18a9d87af56(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6da12ea36e00ce71655a76db43983a3988a4db378de43269d5ecbe793c3b9f97(
    *,
    fill: typing.Optional[builtins.str] = None,
    fill_var: typing.Optional[builtins.str] = None,
    size: typing.Optional[builtins.str] = None,
    size_var: typing.Optional[builtins.str] = None,
    stroke: typing.Optional[builtins.str] = None,
    stroke_size: typing.Optional[builtins.str] = None,
    stroke_size_var: typing.Optional[builtins.str] = None,
    stroke_var: typing.Optional[builtins.str] = None,
    text: typing.Optional[builtins.str] = None,
    text_var: typing.Optional[builtins.str] = None,
    transformation: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageTextImageTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    typeface: typing.Optional[builtins.str] = None,
    typeface_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a1f338c113b8048839df9154f564cc88a6362d0bff12e442d31e97ae14c9ff1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cf1b21589c3e2804c0b8e3362f8a572cf6aab2fe0816746ccaa603c2ca6bf51f(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ff0f52e9bcd6f316365cec4ee397ebecd04b7e1e3d3a884579ce4b99295c947e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e14c2befe426a02130983775624b3483a4714365a94592d7e3b23037ba6f2cfd(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df82421c52cb4801722e63ec2dbcfad78074716e199eee2d12599281eb5cfcd4(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fd12343b60822497b05e8463a9cfaebe054967b315f007bd04953feab2b4b98e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageTextImage]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__82b3e7b19b1b81ef1eb4617ab184ebe6ee2555a91f89b5a1a8833182b72a1487(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc06acd3a7a557c9b37cf3ce88360f58d242e63a93c9d66769aa11d85b991f9d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__addb4920c1c17a6a36610cb14222e76fb6c970db6bb2d663adc194e2c766c9c7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__37b623cf27aaa99745cb6efdebde3e2f73a48fa6c911827c9fd8b3baae8f5e4c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__831869ae22720a0cc3ae861709bd2474af6df80d4110bec3f883aaa3d63447f5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3dd93fb2048e93d6586a592a38c9c3a0a1e180df86693e02bb3608fe57e5863e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__311ecdb8a28707c76397dba7fcf0d9cc83e25344b61bafd12b6f70e277258601(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__de3b175d960504dfb229f2835e592a790ab7b7dab2314720b1f6782ca31fad75(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b0ab21f4b528794d0d269c5953aaaf3ef4701e856abd660af870dabc0d4bd339(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__015b88c873c0b9e70cf4da06c3a4467549aab2b00868c38fdb9087a9b1059475(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__91a7b5a88550955f83c25c9a08ceb8f53c1d036c72b801d30b6b79717d629d15(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6ee8449b0569a2fd7a489df591c019e649e6edd7c933501834457e31eff9d775(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5223453a7a374748a65b26b365369093c5e11d3a70b77a932014c24a55336bf5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__745891320379e666a50c56927823e3c2f1369546154d9e1213bcc510bc1a6574(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageTextImage]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6702be1fdb350e5f9911d13e8592fa9482b1e2d861770e03d7c58f5028b5d18a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d6eeef3a4a1559b07a4a291033feec2a8d97d1d72c25c8c82982691c00ebbde0(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageTextImageTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__61c1d6a2223ceed24fcc2e0a690d9c6259aa6454cda4e92ee797beb3529bcff4(
    *,
    transformation: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageUrlImageTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    url: typing.Optional[builtins.str] = None,
    url_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__53d6ad74c2222eb8a3e5b6f25f129d764ec2febba1a527cab2f756b5cca6d7ed(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a62e9201a8b309c2fe492d749c3a189522cd6a796131c0f0bb160e1e5558093(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f9b061ac43211a46f1f2caeda8fddad057b4e8d74dd7a03e7f05b2b26209ccc9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dc571a0a71ffa581898565507c2a20cba4edadc3ff4e788d10dc13244e73c8f4(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__429bfe9a3c3f7a30dff8a2b76d4859a613d38aa4224da2d89bec52a8c0b47a08(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__548379eb88414874dbc994b8b20eaec90bdee7d5eba4af2faceb7226951a6d74(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageUrlImage]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d4b1dc94a61d06360bcae30b931bf1f8cb2dba91f8859aa0397fdd4d61d67446(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__29ea2b73f444c2c1d2faf036f4a86304ee1975bdc72af4826faaf3722d53bd7e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c96c3ec95c8c81691bcc31831be99dadcddf64269aacbede17b3745e9fb67856(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f675aa2b069c3305e84e906e3e5145ad039be040a99f591dc1f9589f139cbc9c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageUrlImage]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dc9b1a425223a41651db124169952cd4003fbf60a2543a660142dab35e4bffb0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__57d7f63afdf1ef8883f657f9c47a879ec6a992b59bbe1cbfe83de8d013e4dc73(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompositeImageUrlImageTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e6cfe1081e1f74577e8bbd117fb2ee9f35f9da54455bad78f2ae75032081e3ea(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__87581e4caaecc79098db4e59ff9df731efe891848069c1179616f10d1d7aabb9(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7987fa68e9049f5be1c4d86583de31e15a2e6b3a94cdf815db99eebcf6eaaf59(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__56cfa770adbfa33342e56ed87009b1474310aa16efa2de624389b06197bdd786(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6c32d359c2fabe0e33b945abf9c6d5b1b1fc4663ba3f20c0c7f1db864736e320(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f4ddc848468ab3ebd212d54b24fa824899efd8d24a3c055ef05b8e96fcfded79(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeComposite]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e4525cd2a3627cc3a983c529e88ae010811c0087c3a7b73736d7e3dbf7c7071(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9c38c9e6792902b04687fd18ee6ccb650fb631266905868170ca381e625053fc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c59ff4b9132209696d5f748ab82faee1dbc16203ea0325d1ffbcf1d8168e1b17(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea28fcedbb699a553e9921b19d3729e1028cafe37cd46db08c207bdfd923b7ee(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__068db589274ade3af3196b6c2d6df79652ac97dd4ee00f38adf2f5a55d7cd5a0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eb83b95fa3085b5b084ea5548edb6aeed0075f4738b717bc4ca4ce18007563f4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be9f49f6dc58f8bc4dea405e74d8a210bcb59a9f62dbc61221119c0cdafb0999(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cf67d75e15b2a8519a98f489876b5e5d86b0ba83da6d529d86e7c14d129efb01(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab6701d4ec1517c04da18fa9c8a8ba340e4ee0763ec99c76946e55679bc3051d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__33b8ca26d8b956fcfe8157c1991a2ceca0394b117c1dbd608da95c68b33add4a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ff0bf1af47fc71f6d01f04130dab496335a8a401b92e6d765c68aedaa88dfb0b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d9c476df653e93649522a6619bdd41c49b5ef67f0d674bad0f587dc51027b7d3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__53d72ecb8b8faa41e54150399b960ef4e27fdf204bbb49f299f4b92e5a5d411a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0631bed4c3f3e65c399952ca48d7ba227dbc9405d6a6682e9fcdd5653d916f00(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeComposite]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4654c7cccd1a87b5e861d033d0abaf84176a2d6db0d60c6d22d322dd9fe63487(
    *,
    transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__190e1be2f0c28857dbf66d687c2718d8075eb51b9a4ac34d874f8d09500d960c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__355a1ac2d382cfcde8f135ecb137fb01af5af02839332731fcab1c26708b910e(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__83bf954e483810c27ec64369f8245fc01c206daf591556668f41cf48b489728b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__28b8d732b85120eca628bcd49fb538292181dae8890af6933dddc4d97401e9e5(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a40fd6ac539afdae3b4632747750efd1231c8d66683507f1404399fc020ece2f(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__777623c939cadc4389f580b92158c878f3aecb6f1efd7fa47229a603f78f86b4(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompound]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4e7ed524d0d8df7c300ba81bdc895231cd36f707cb6be841737f60e83275eeda(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3b49000b50d0c9b4b1a1cb7c83d891925ad92cb18f7eaaf78a3bc7f96094bb43(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3042a037ac84564626dacea2309be365aa06cd2208a2bfc86c3936f49f46e462(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompound]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c9594502f35ea6cf356caaaf1c5a9f71d8228170ec3fae7b2e25b0844514af9d(
    *,
    background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
    chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
    composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
    compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
    contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
    goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
    max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
    opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
    remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ee5eb1c7a900e8578f4e7240c7c0cb6852294735fd160f85d53973db04d68d9(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af8c978d216b029ee828f442500f8dfb5358c5d67fd2ca01f04386bb13ed1649(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__34bcab6bf79e6a91b3917568fc1f16ed0843ec707a63237602ddf982c2f3f39b(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__12f10f3f64afd32716ccbb842706d23d20306f4ce9d89fdcece196745296e4f9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a739fa25eaccc3244024b1b6e514cae31ed5c05feb0a33782d21818add93b59e(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8739ed703ffbd9a2552b110590aee3d9e14328372e2638372b70e5dc30adf1e1(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7f4ce8bc79eb270e280d3a6470095f363f3d0cedecf1c5d848ff590dff9a2d9e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsBackgroundColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b996ced9e234d4d13cb01fb38e710539ea18fea50e7baa8de44615218f67b7e6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6d88d994255c115d152ac3352c10a3428762c40bb84c3aaa05c49505aa6bd773(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f9e890e5699d82c160f026e238fccd3c133665ae2a003c835faab6577740bd9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7271786d682b2411d58b4abcec7b52dbaee409ed4e248c8cc1362032340a25f4(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsBackgroundColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__38067af2ceafc2b1bdaf7eec6ce67a4e84cd9fa01385a9876926c464202657ff(
    *,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e4b0e8df4a70c45ba5e0c7895756dd274332a8db504ec2d36f85368a053a358b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a623bf4e0c3b90b0d4f10d5689e31d8c8044bf2750a6b1f9eb60b9032d42017(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__680926c6772d36af56de09c5147f0198ab9617b665f46278456ea0e5671f5bdf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__77eb45031c0f1c85b6164732ffb9f02ebfd9aa295b9a587b68277a188c9ad88d(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__68f0ba2fb3876f9b5d306c7305c2bd3417cf1665e98bccff801f51e0c6a21485(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e432aae69d238fec19127eaf365352a853fd07a0ade664c034951acee708f2c3(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsBlur]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__04a56e8c6c48c517ccabe9a426ac5558089a56008a645a25737ca1e687d4751d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__567db3639fece5e37b253d7278de6e1b112759d9863969cfaf3c004d3354559a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eb80c2155a5b853c461bb7360e7936e6695edc0501c5826648d8a3790392a166(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__034d330609692ffed5cd989e6e1fc7bba4853214e59c2e82805853c9363b80a3(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsBlur]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2be6cb54b9a3926e7b95b1a00811138e720527f9bd5efcac4b0ba370e8747510(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_feather: typing.Optional[builtins.str] = None,
    hue_feather_var: typing.Optional[builtins.str] = None,
    hue_tolerance: typing.Optional[builtins.str] = None,
    hue_tolerance_var: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness_feather: typing.Optional[builtins.str] = None,
    lightness_feather_var: typing.Optional[builtins.str] = None,
    lightness_tolerance: typing.Optional[builtins.str] = None,
    lightness_tolerance_var: typing.Optional[builtins.str] = None,
    saturation_feather: typing.Optional[builtins.str] = None,
    saturation_feather_var: typing.Optional[builtins.str] = None,
    saturation_tolerance: typing.Optional[builtins.str] = None,
    saturation_tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8988cb741f2f5341faebe8240fa9e3318f8cd352308dd4f103db338747f158ce(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__486d7e585e145a9b4a047acb9e407f57894326147e1661d3337c089bb4063733(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f2de56b448dad24aa38156abdaa5f063496f84f63d0504c7d7c93245130d8947(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bd77736df14e7180be10b951ec68a3c9ec6ab55bbf0189e7ee342c79cef321f5(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c3717ce07e3c46b081dc0b52f3978c52c45c1a78b70f6fb570c43ffad76b4498(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f60554f7decdd9728508290b4313492ac8f852d0203edd6b70893f16ace872a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsChromaKey]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4117a9c5e036b633eefead571e84566607229facc3a4e58d87584538495547c0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__822f5bbe60f63008d7f17846f26ae04e3d2f6fbe1e082f12c28d6bec70f5bd9f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__31fcbb8ab4d3a4d5a07239700c50befa7e6b6d7fe0a1e75e8e8c4b66b0197815(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1673558f2999b1d34bc6fd15fe132c132efce2c2aa25034d4cac3d682a78a3ff(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d932025cfa2073bd5d574d173fa4a3082990cd2e9e9c8808bdf2de462f700812(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__86b6a0c31143b0526b018093b74476fec89c610dd2fb7079c8fdcefe9cba3ecf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__41f3653176aa9c5e11f3f655bd9c5e6eb31107710cc60f026cbf4fd3f46f795b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc90f14fa4ee7c329697cd20dc9048f0e92144ce47eb0c59db099aff84a81e3a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fd723dcc98c693b326244cafb7474f6eb5b018ae5feb138cf8b76aa33208db79(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__093c3cd8ad0bc5dbe7e6cc3d6f80de48f5fa038670dc0c34e26839c9e7f173c6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__12702199859b445a8c0d5d54fa14727ca4c8b0c038050853e80cef47ded9bcc8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__08a822f3715c87d91d50eddc59039ad61ec0babef7dd0ed4ac4f6ee00d4ef626(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ac8a223f2e052e372e64d9412f360e057155490a1de79c90c68a8c15e99b073(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4f29f3f12366b7cb9972c482db83d3e3af5b8ff613339ac04ef06cc30b373837(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aad4258a811de36aafe931986bbb126aeb60a02932a00ce10c364fa441fc5c6b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b9e89c1dff6294d52008ce099e21b8d381bf2150c4260b74f9090cd17ecd3da0(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsChromaKey]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2daa143f1af6168cd6918d28f81cd72812bed1cc82715de8d14842c6e0e334ff(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsCompositeImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    placement: typing.Optional[builtins.str] = None,
    placement_var: typing.Optional[builtins.str] = None,
    scale: typing.Optional[builtins.str] = None,
    scale_dimension: typing.Optional[builtins.str] = None,
    scale_dimension_var: typing.Optional[builtins.str] = None,
    scale_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d350a2d8de709bd67a5563d6784a2716533f88d2aed8a446f8ce642f4b6d7697(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__80df09c2519b7c8d6c0a79200d04743205ecc8f5d901cfd07bd1e0e371a3d618(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsCompositeImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ff6a6bbced4132a3390e7f4f2244e9bcd484debdc115b9226e2b15b71631b715(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__37c66a21777ae804b957c3faa3dc0b5e0291fecfd9152cbad398e4ab635d66ff(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0d191a0658cebfe34e4377582e80aa2474f8620db816fc705a781670b6debaac(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e39f73030a644ca8745c833beb673a1b92662269ceac59c71b7f6ffb3c4303ab(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__982838ec7851131079416607327c3193eb17f8a1a05d1ab253a30b3452d1a0d1(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6afc921169583571d71b4a972c21da93c2e081628d0ebb3bcf9b0d604e6e4393(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsComposite]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f880e1ff99c4498492e444f1710ea3634c5ef8a856be5e551edddb429f5e915a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__77094d6839187afb9ab4738b18103b0fd1ec44cb6e603d3f373b3df207875fdb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__52a25c289f0465bb6c5f1a99d968fef47422d285d5c64a06b179554d3357de83(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2e2db677accc6b067b6308cea698854bae305c36ec2569145344afbd88cd4ffd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f73f7db7bb8ffad380c9e1590c5dd042c982d33d1986b2f81aa0d9ebfb5fec95(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9993f33423802179abcd1953bf47aa12bd59399a05229d6ffb1873fb3adabb36(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a2a8dae1832ce31b9a59c7b1c83f4f8b3a420472f64005831ca8899198b09a17(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6932d1c9a81175cb7b1d4ce3c6c34d029ffbf64bcb4e55bcf13414d90a7d46ae(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__444f133bef29e3c116ccb83cf7413f6415bcd89cbdcbb26400d3e696f5491384(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__397a4ba7297f075c0b0be208cb9ae7086b8a6c8e185c39697f22f6762586ae7d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5629ae6f49f4d3ba17aaa0e29ec27e3ff0579fd92b983bd3fa85386d9bfac800(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__59a5fb5e6e03137cfabc8eb4f3105fd87db360daadea71ffdabfa840585a6540(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0d286518775ebc705045e9f1919a2abd90bc0cf422b36b69c03e81ef1282633b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__82e833be7c4d728bc425978b49f6254d18c55c1e7782b9baec0163f21d6a1d02(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsComposite]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a5c20b94936874eed2191949a7ccdd469124f7face7dfa4c237eeac06ed4ccdc(
    *,
    transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0482cdd193935d91dcda86045938b8c77507d415a729a67af79789ef7f20f9a4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c758c4d99e83897da0e1e1c457811433c4f5bcab48e611487b74955be0f1dea1(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac040c67f68c1b74e08ad1cceb5d8c59eb7a4772869ddb54eb77b9cca19ff6a2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7e11268a9b6d546409fed24a82dea7068bcf01c1e53ae48144d82498d1d878d1(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f1198c2895f0f813ef4b7c28784726f562d2d8229b3e12ee1d6b44c95ebf5151(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__57badaada354cc769a9ac4b3ddb639d7b1a5321580ceae736cdccce88e954901(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsCompound]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a7374cc527923aa220813fd77b4e0e868869ac207ed532dd0855b826196de995(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8275a057deec0c985edc9ace96377b5acd703970bb2d5a3cf1f968f170ec86ea(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__84435b6491bd4da1770ef7ea8f7460307a63a85b95b1170bc0574de7fdad37c7(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsCompound]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c13d733a86d47aae2ea74e496edb08835c568a4c7769325651272fff4da5add1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d94aaa00afb676dff2ba8c51e2060a09676261ba33ea594208a5dc6420bc5b7a(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__71fcdb64947e39dd63fadf58ad437b54a12024af614d94464a04643f09988428(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__85633a36fd05d513664ecc5c1f712a33f90f92e5e45a5d156df23b8f5d557aaa(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__83082d6867b713c3a3d799b0327d53df975656ce5e4f0697ae166ae3dcb7d607(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c42e21d4ec37adace4f52d27072ab0b00449bacc0f13368e6fed72bee45b1293(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsCompoundTransformations]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9927d120432087f0b4d0d918546a6cceb32edce46aaa8932dcebdee8254a5ebe(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ff9de041cb1f3e893fcb83caa21ba1e97480ebe61c442de2514d5de53e94d6c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsCompoundTransformations]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2b0c991786e4612204185a4940abe6b5edee7361a947ab369edbf65d4f9fa4ba(
    *,
    brightness: typing.Optional[builtins.str] = None,
    brightness_var: typing.Optional[builtins.str] = None,
    contrast: typing.Optional[builtins.str] = None,
    contrast_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9017ee3178c0fe2b01e6e85515d3fd890040b6b6726c836d02e0cbadfd1724a4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__31bb8f45301f407c59d79d80ae82ad00cf490bf3d8ae02cca6388a09c250b16d(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0500db6a03da49af24b2dd5b6970d17381ecfe17f3a9563eb1827da9a6dab922(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__412ee82a6c16ba7a628e9e570f88f0b646341ea34089df7a46ecb05df7be5fef(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea52f455fda6525c7a906107b4c20e9d6f980aad902314c0c3a089f970fb0fcb(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5a40a819b555e749ba272dce8eed925796a1e80bd9ce6c89b2cbbd15c3553b6c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsContrast]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3e773d81b1a7d06a6064695d37ffea538f8f80fa3cb6e22844f19331fb01034f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__45b96baf3bd8c82a6a88d74c0b93ed5da8df3907e5288352c1906d908429b744(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d22eced0647768b8f6e2d69947a8b81896927ec460c005dfcdc729faf24e0cc0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e7501040662d74823719323ca7ce1d3262490d3fd53bcacd6ea9f4be9205ee47(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3f4ec71dada6e600f167a266da47dc946f1cfd7cdcf1f7289b904a1fc8fae723(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b38f6a80afaa6b7124e9f1c2dc83557ac550ffac4c9702e4d5965fb5a8f483f5(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsContrast]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e6d48dd7d74048aace69a19016da5563c35508986b24d12f2cdc782663feb8e2(
    *,
    chaos: typing.Optional[builtins.str] = None,
    chaos_var: typing.Optional[builtins.str] = None,
    density: typing.Optional[builtins.str] = None,
    density_var: typing.Optional[builtins.str] = None,
    power: typing.Optional[builtins.str] = None,
    power_var: typing.Optional[builtins.str] = None,
    seed: typing.Optional[builtins.str] = None,
    seed_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0655a16c8c5cddbb2a01e1ac0983048773bc68ba8b0f9822ffe178476d28a80f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2bb32355e9552009a153025ebae9deba54948377180173a09790203d210f2edd(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ecbf9d1f9ce9640e5fdb8f10af259728712e77bf3a3614130a661a86cbdce22(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9cc032cfeceab970de73809e527d9d9228d5ea406a9962496dfca255c8021799(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ecd07e447dcd36bed05a14607df15e64e13d3f34e3ec6e2de1f5582380862dd(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__197cff57450ef08797fc5c7d8b70c1212197e58f4cb4f1e025c77b0bda54aee0(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsGoop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__36ea6d99aa01f29e51f52ed104a7c7c249a1290b329247a1f52a53e139370cea(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e5a34e03532e936bb2f9ac8ba48e13015f97edad133e013fbcd81be62113995a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__87ece1c7cf60d116300aab03a3da4fc6688acb2e78b461ccbec6d19cbfeb9cf7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__87faf3c9d69e0ec18e1c6987822ef4b93e1c53ef525ba7e8d0fd98898a663a03(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0b0be3717f02e2a2189ff8ce4c368ee35a5c9a0f84173420825e87e1741110e0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f7a4d84998590c40d5e6cb59eb7bb8405d84eea9025d8bdecd46b310a40fecf8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4e087dd86c6e894f9ac7fd06e5954a8193f0b5476e6a37710496a4e6de5d79f8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1e2feb99bf76dfb0483b8f034cd4d9a5fb5179b6974b87fe25004098158b0d22(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c50a91967b238c667c4215748aac1469116672fb2a141fbb3fe3398d7e392180(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f54ab4b42225e87c2258ecd281f563ce3198dd5265929851dfe65fcf5e5f1c7(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsGoop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__beb6d65fbb072ce74017084d7e75ab1f5b665de0df96d4f78105197376c5dbb5(
    *,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__547280b5d4e490beab7e18f2e31c24824e26581a022761029ac58f13a6d13afd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__27d88ec200bb7d926c8aa6734242146a9380f8e425de1a29265f79f9cdbe42fc(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__219d22dd2d091565a21a06036f566e35a06f5b4f37df486be451cae3c3ad6280(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0c406892594ba2081cc4579383f6bdb268371281724d123beb387bfe682c9629(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__630ae294de533be1057966030a131036c56d9d6110f4e14fe72ee9506d3ae84f(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__41262562a7c8db28c789d69aaf5ad6003be8ead712e8530a140c3e9ff87514b2(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsGrayscale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a6fb95ba1d7e1f20349bd3e46172bf21506b79d6d490c7d17d1f30d4b82d89f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cf40ce14bdba794ad403207410d0ec68f27fdf84463f444634a1da45609bc02a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e42f81dc8f87bbc55609d3fa9ac5d2fdfd44aa413172a6c97d1f52bbd8be35ba(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__09ce12e84d9e9f4e21e2dd4747d9dea0d180193c8de2a102c96497a19908e92c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsGrayscale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d11ddb8ddcb78d7cdc3c85d0d44d4ec005b8aa02f0f59a27fe6361bd61597861(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness: typing.Optional[builtins.str] = None,
    lightness_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__889546d5b1a6a36bd4e9aa4964ca5e8a8332bf6444785e3e4f659183c7b8e398(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__43a311d3792dd065757b27dae47267a237fc8e2e446acbaced30ddc495985627(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0a410e39d22eb441766aa652bb06e06b26cecc334dc772e589c84dd68d053aa9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea26e523575c234419ab7785e5599f9d045fc7452ccc3f7d910562cf11a5d85b(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ebb792675e17ab68fb1fa56365ed3fada9fb747db82ac06dae4fcab009339cb4(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2952cdf50d86bb294508b94ba478690ef4945ef5c3e6dee0a47c932b33c9d0d9(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsHsl]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f36086988f4a4eb99a38a29662a15ff8a88d030a048d7dc83588e36744002f0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e2c321d7f3235ef848b6b841f765790f064e63051a198277258fa4e7c61a9641(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eaed9bad8e92afef37b23588447785d5248b7066780d7a02669decc2bc94239c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b00917a0414c304277293d455d968f975dec380109990ba9ee8746c1a7ca7752(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d24905518c0f837418236590be6c36155774e5dd23c5004a1b5849f003f4d7f7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5896f086ee8661ae527858ce3938c0c0371ce73ff4ad93a7602f5a1ae032eec6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ce867d8a5918c871ebab631493041900c1a454c286e5f068b0683a72b3d2b02(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c8199960bfc8e4257e882ffdf223f0352aa691e641cba016afcc4f7d4e66a72a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsHsl]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__17e0b53a52003a13d150360392361b06be5f2eed437d6ab1ad0c95a056e2e521(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ce2f75ce5b2bec5247547a3d2f60de4c4221cb3a159fec40acb54ddf1d804fd2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8c852947d13501c1c6617332d67ee0d50d75b36502fd9e5ec4865b0dd1117c7b(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__13158b7ad50d2a304242d664c949b1e54f9c7c782ba0be4f1c650834e7d33c93(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e637b61a859f1c300481b8cd9d0008bbc5c71a399aa5fbe7e16e391e8dfeaea8(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eeccd47a3a39124a9c4817473424a59f9050ae85b501f6219db1745766bf8348(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ced84947c6a670c86dc6bc011d7163091f89da2814d703d457b7936911323f40(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsHsv]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5186a78cecb75a0ca51bf0cc246e63f89c986036a44ce169f6e173273e7b5c99(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b6cbc1adfeb490ae387a6b11ad464d33876b3068720607f8e376bb6a4af0c113(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bdda8bf84cc4bedb7e36ac43d6ced11489d8e4c25667d240893fd084815d614c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d7f425aff942b6d7871b046ea873770369ab6d7a9fd0ca79387f012e9c6f050(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8eb1ca682ca474cc147aaac7e50199733072954a2942dee28799c8fa25b0f715(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f0b47b2cea2b57a871c587a1354f5d947ebc95fb09f3ea7d1695d6cfd0842aae(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9f52da13ef8a5a3bf040db5f4da31236b019a9ec72dff84aff133d18cffeac06(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8ba535924f1fe107ee676591f32f44950286f62c1312cd5d6f225efc1f4065c4(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsHsv]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b5acd0d835cefcc7173804f68fe36369b98449022054770fdedb88e977e4b41a(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfDimensionDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    dimension: typing.Optional[builtins.str] = None,
    dimension_var: typing.Optional[builtins.str] = None,
    equal: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfDimensionEqual, typing.Dict[builtins.str, typing.Any]]] = None,
    greater_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfDimensionGreaterThan, typing.Dict[builtins.str, typing.Any]]] = None,
    less_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfDimensionLessThan, typing.Dict[builtins.str, typing.Any]]] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b8a0102746bb85409102fc127f59d07a2ec1101960918d5ba7226974a5d8bb33(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e2e0ad45007b67e556d1128d65ac0c9cd8587c6bae957500fdc97508dc96ef75(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfDimensionDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f511322252f12c66ee0bed045a3190da821af277573e6db20f15e41db4f34d61(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af400171143518c9be4a0ef67a30a75a716cc93e8da93dc166b5b6a4b57494af(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfDimensionEqual],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__083644a0f33799df27ee770571d4426d55a7039fea4883220a65dc4d736aa80a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e7e1a7b392c1d985ddfcfdc78ea60ca9b69463b6a770ddced82e7619dfe03b1(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfDimensionGreaterThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__da1f2d6e8881110cd83338f8581f4b101c6b83889323a562fcad39145d18cc7c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ba9cb5db6f1fffd08356395214decf79b665d45648033ffd3e654bc037f912bf(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfDimensionLessThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__690e186e04ecf978d1296f1fff0115b2f0a8c7983a5c2c7f2dd7bcd75db9d599(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__249f3e43f83fa5a88f98f6371fa6d94b02d32f9964bfaa151d2f0393cd81519c(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__356212c0753d4dfee3ab058eb409f4ce579ee01686672708c36213c4ba7df76f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cbfc9b699c92b7fe2ea869ee0d5daf91d85ee02bdc9509db0eada92c890d4ca9(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__20f7e5cb529dbbaa1d8caf048a31d9695f60cff1ce0bfe97ec9987343f55c632(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5081879c2875229dca6471c936dd8eb68d260fb119ab15da86409826f4e321e4(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfDimension]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b5ee46da82c7d92b5997fed1087b47f4304095761d91e6e9ba0284ba80facd3a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ce9b0c0a269996564d5a64ea00792214bf1e626647243b341d2a3ddd988095cc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__262131cb04117bc85a9a1e85fedb5c1ef947688fdb3237551b0793a1bad38d73(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ebf19715c2f88dfbedc974779cc45a0dcd7ef6f16e127f9076e0c190bb72b5ef(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__038366eae7c285d48761a80883c48fc3b9a321cbaad49a2f8d5f38142244f77d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4e28e88625a3033e40a0f18cc4b05501a0f4f19cfe2d24bdd9e1c68422d5d716(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfDimension]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__04fabac9608ed214e2789b12e4a6c62578ca715da505c4fe1882d0c8e8a19526(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfOrientationDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    landscape: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfOrientationLandscape, typing.Dict[builtins.str, typing.Any]]] = None,
    portrait: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfOrientationPortrait, typing.Dict[builtins.str, typing.Any]]] = None,
    square: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfOrientationSquare, typing.Dict[builtins.str, typing.Any]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f8db131e078703dfbba6d36f2b3fbde0f7e30911c7379079faab0ea13adb8cbb(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fb08a8497ae08bb417a361fdb6fc9d7cf7cab8743d669c40f74fbb4ceeea269d(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfOrientationDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aae3096f4666267a4e0998af1a2d5bae73e7c5ee00d6d29f3289681144072653(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc5e123e3f71d6871057c1822ee9412e7e1090f29d4eabd95e9ae2bf34157a83(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfOrientationLandscape],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__112fe984b88cd9f6795771b7cefc453d2c81b073fd3d510e7edb7eda99703f1e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ed3ca9dc827ba6a5d3e09957f5e6bb7733e1df725e1a771c6d28110e337837c5(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ba7391c9a722c3b42a80beea857ea207d6449eb3e0f68251a33a62b4957ab764(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b8c8bc3c265077bd21e1831ebd1f53c03bb14dc09ee257b2c6c3989c171a614a(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__998456c47eaa6e93bfff9f31eb6f2283f68ec19deec4c21cbe1bb23820354fb9(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6754feb47a0ad2c381e142c0bec517c61b627beecb11b8fed19a8ee6463e0209(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfOrientation]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9e8eebaa63c4f059dc194d653946865c18ba39aeb51d18659d3b6d1dc648619b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__991ed18d01f1dce8bb40847626c69a5ff8a0919734e7f4120b823c8a0e0efc0c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfOrientation]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__91296a6b8969524d9a12d1dc512fbe67dab4c45790f31fa6b1db977de569d291(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2f44c731271e547001f840052761593a33130c59e3c70b691363d81e9c153669(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfOrientationPortrait],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a7bfa7defafc378d6c98f0bc5d4ca62950ecf431d74418eeaa65298b769121a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b78e750f5e06357757787d353979300ce3239cbac4223c023dbe4c9803648753(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfOrientationSquare],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cae3a31dff5106eddff018a0ec4868a0763f48a55c2031f2943108ead47ff67e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__afa603c99e07456b9c9edebbdb5a8643d28246e0e23ac5d95c31f990ddb93915(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__65544c7c4edc1291c9ce7d75586be8744f8c4889453befe7f0415840048566bb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__61e41564394e8b38b2924e3b19bd4f76094117a5601221c70c74c3858f3e57b5(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c86e5470fe16e1b2eeebf0065992b541dd8f3100c1aca7094517d3d8c572e673(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1291e3abccb3655de8b75d08e82c0e6db987d3434f707c113f5c90f6378af855(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformations]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c2501368f44cd811987874645c24701f2223dcebfbe944ec44abf96287db92b2(
    *,
    colors: typing.Optional[builtins.str] = None,
    colors_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ea1206e1088afb5c996788202658290eb6771e045c87d87fc8c62af23bbd3bc(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9fec7a07a514cf44a18d83f23be88cb3641d2f0fa25000a8d284b43626af6a06(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__53b98c8dcad8d98127f303f02f30d63976dd9423cf6b523d742976ca955c5328(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0b03134ed8ae783ff78dfcd8b114f9fb5e5e52a8d92fc8569541c47950be798d(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2b3f6d6bc500e91d9a5ddd8af572792a50769097359c65006007756e47ee26bc(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3633f23859e6a88e6135685e585961c5eecd73d44497d83a2f18be60ebf012b7(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsMaxColors]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__955922de5096dcec7a32a661578410bc99f52353ea67485e408f308e546a4618(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c2938a4860d8826804af6026aa271b57345e5c23e4b7db7d832aa49f94256816(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f25c3cc2441a28eeae6da8f890f2e36a65a1f91ac04adbb3bfc9424860c697c1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea7d66761008668c26da02318847d2def589155c280ac5cec553c152795a2d35(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsMaxColors]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a0d82dac5bb3e4d651aa9a28b25c93aacfe66b1f4647da73d53c7b0cadbe9079(
    *,
    horizontal: typing.Optional[builtins.str] = None,
    horizontal_var: typing.Optional[builtins.str] = None,
    vertical: typing.Optional[builtins.str] = None,
    vertical_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7ec375bfc1ce0a0cfc825da079d9f67f5fe5ccf3a14258b971f6e58d25a5be29(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6b576922dc92ba323f87de42f5ca7b6c05be486f2bcba77bc8af0add7db3a48d(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3512cf7395e6e6f259b37b34bef2d06ef0770e4aa21ae52ec4719534d0b434a8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8bf3cf18c04d24dcf4e7dfd4baa2e35c2dfea44f4025475b20e59e33d40fcda9(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__980ffe0dc54c1243f90340d8e4014bd905293c0dd4722b4fa978aa5670e20cb8(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4b5187b18946e686d6b7507e1e765732c30db51c87ef3873bfb9e2072acf9f7d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsMirror]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__acf8d7d9d589d7b84a23877972495c9f29c1a0e59d8dc4364bae1015da3930f9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7302481a3e0fdc8387158a93fe62f1279e52bc7e5a9ee4cc377353cb61faef95(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3087b42f491848eee16fdbb323a07acadad73c1c902c26f2c11c7d7913722bbc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__34b98c94ef431e821c021dc1166af357263425ba772b744dd944edda82b5a843(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__830497f72c654e8514ec5509bc9b127c5158f711ecd7ebe6ca5c01a7cd67f600(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7707428125608c1b148625d52019944f3a57d9ffb18c24cc5b13041eae1c5319(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsMirror]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dba95a5e5c00065479bbdcb1cc64503b062807292e83ad55eab80fd0a4b100b7(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d9901138111a931a6fc10c84dcbc98e661ceb16edf4bab5bb5ec4777eb7403b3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a9b2d0d85bc8ad01665fe6045102d0cac27ccd6a997e693dca3413f75b2e5d0(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d7cc4b8d382b9a0150739ae69e0ed90719c89a48c4a3ccabadbbb2ef754e3b8a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__07c5d77d9b6e646a1b141484773176cf999bc552f2d4d251bd8d3186d10ad201(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__382c504029d21befb85a00a07bcf4a503d2bd97997ec8df1261b343a5ddd74a1(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e395e07cb0f20c86ccadc5aed6b163e9dcf2d268f9edda37e323183138a3e59(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsMonoHue]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bbdcbc2831f1b7b27f847d367954339ab6e7d958e6d4a4990db46810558c3316(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f8115be7723f474bbedcedc2711868b580b6e8ffc1222cc5e2a1b9b0b3268a9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__49614793dee196856722ef7949393e4ff2b9c8fbd76caaadbb408fd1e659b9f0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e250a2af46c1761e45e563d51f8b5726e85bce2743fc9ddb5bac0a190a2b8a20(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsMonoHue]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d4a2e74c9cd1c38e6f60dc3bb3b7f9cd95f05eabb4396578ad31c2658fafa379(
    *,
    opacity: typing.Optional[builtins.str] = None,
    opacity_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__80ccbc76422830ff68aae1a641684402f69f3bed1f9fab31c15a3f2c248b4950(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__56ce714425d43b4324e6092ab39474f5d6eb032ebc05fa3627be0f6f20f67303(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e61d467b89b6a5c71d6e79daf986d6c3117810e6ce0c4ed3136bd98021838d2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a4c6fee72bacbc74a8782c97cca4fcd3ab61bdafc87a92c000706824cfa73f50(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c274a9d084064abb7dd1df36169bae74df22d0511f1c04b4eabcf55bf67fa599(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__57f8339aed39f40c808d8c35b472e2e6ee3104170f080fd8630ce2ea4cfd22d1(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsOpacity]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ffa9763ccaebbf0787983fcd2ee1865894e608145bf67fded50441303bcd4bf5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__604832317b023a77939c9209e6f0e12fc9b41e4d3067eace7690abd359a101b2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__de3c1ebc6c5f604321551eeead53076ef7ff14bcbd49b13e50ccb5f1a0c32c09(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e41fc2a411a8be797bcdfa6c5127479595b454d8136e636123ea84924b114624(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsOpacity]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0f635b186503f56dd6446e332808f6b53d379fa92d55bb8a34df662c9bddd7b6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__789940e54b4e9ce429d1b58dd6acacc0b78867bcd21aa716dbea4a7048558552(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__db3b7146831f808929a18c661d6c6b9ec5cb3610945889e474dda6a2a8089c9a(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsBlur, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__04adb027962ae81a119583e958a00fa6613cc14cf5e97812a1dae0de1f9ec778(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsChromaKey, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0135039cb2c191371fd5a93926ff30d2e3662c061b874c6e793a35cc1d5fa4b2(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsComposite, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ee674afdf477fe1c4e679fb41a58fcd0894e9ecd3fbdd1d40458046a01bc77d(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsCompound, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__208e9da68e0f376f94497175b5f038369510f6e7179adf5eadf20abac4df237d(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsContrast, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__49af1b0761b19d838e1f42b4dcc5506e91472e6b509a8d954e1d4f862c2579c7(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsGoop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4bb1f716d738458274fce754eb1ba93131ed6ec91a5bc5879728fdd217f2d3fa(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsGrayscale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8384131d26d6e091368e6bea0a5b5bc442e62ea696454c3758005923d3c1bbec(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsHsl, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__19b18edbb5c5204b3a8b0e8cc8eab5d773bc4c071ca8ab7e133af96aa90e26f8(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsHsv, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1523fed1c9fb44e6b5cf03fcd7dd2bb18ba0a1fafbe14664ccaa779ee5133864(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfDimension, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f22577b7b9d36e8c6daf31c3d444d570af7a3b72ec6140a4efe4f33d26b07275(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5c8ac3c2c4ddab9a7d4c4fcfeacfff77b8c86603ba557c7c982cdfab23732cb5(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsMaxColors, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0c69bcae21dc150eb5453e97ec65eab1711d5ec94e3175c1acdacf2d1e582d6c(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsMirror, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__31e977d8d38b5aef0e3aa0a2eab9fbd7e0020024aafd0ab603788e39aa49e44b(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsMonoHue, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8f5f47085afa8d1828203739fc1e0df08111f4a2b4f6baec5fd2da9056371238(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsOpacity, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__75d775798204bea596ce8ed964763cf6c93fa489e649d593c42a243a5d55aae1(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsRemoveColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__13c03eaf5570de2ad74a339ac8327d5fdd2aaa9f028dcc67718a5330eb9c106f(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsUnsharpMask, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1c25b861af50a8025399916c06d96a8092dada31fa7fcdeb3cc761e6d2ce0a77(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformations]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bf23b074f76bcde96d4f8ab54358e0aff6e52ee66e0cc42b9b5dfa179e35083c(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
    feather: typing.Optional[builtins.str] = None,
    feather_var: typing.Optional[builtins.str] = None,
    tolerance: typing.Optional[builtins.str] = None,
    tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fa66f72118aa5e6e2687d0a48512ea903abfc8c1d385e291d44418b978c47887(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f30015fccd34ae832725224e39e117c819d31cfc23249ceedec43419bb3fb241(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ef51affb621d17063187f817f7cf4b5726a08a8ca10a32569f6bf89434f3d5ee(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5e4746286644803888ac9e0bc5e1d4b8089a12e1ea1c3e6d4526d242c6966499(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ab4e635c041ac7eff2515345b7bf7903550515c6914d19c1c5509daa27d6bda(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__26cc47671699aca0ea05629afeb9ca61ba6476436e68e4a2e9502f90501a91eb(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsRemoveColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c4e976cd91d79f6656bec42ae4b44bf001f5a67bbcb18606cd97f3b29499157c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dd8401fb3affc93c7a6e73491ab030110e07916c876068721a57b389e5c897d2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1a12083989865313d44d20025ad014edf9033717203d28418eaf809411e36aa9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f869b03ae18b9e8558ec5013d0fe5223fb370dd4b956004ecc8e13da8f7e75a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b3d0136f175e718a1fea7dac91a2803dfb4766095de40d1cd308a8b912f23da9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dce993468733384c6b250f4c558b0205f3278b68201912f65cb6f92e661a3f66(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6c9004a06ecee745693a151bb4b54358fab9a39206265af7e13e922af2ce869e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df6991fcfd2694b960e09f3258f61452360fd7421953a7e30b8c117deb6325d4(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsRemoveColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc5139576a80ab741c8fa53142ed1cc2f262ea42bab213f7dabfd32df83aed03(
    *,
    gain: typing.Optional[builtins.str] = None,
    gain_var: typing.Optional[builtins.str] = None,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
    threshold: typing.Optional[builtins.str] = None,
    threshold_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__16a4c6361cc4a5cc2477b46fd48d95088ee559e13bd07e9bb1cd051e0e2f878e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f80dbae9a184182a9f438740fa6012d844c74c3c0498b46f88e1c249d5088551(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2db49dad55167a4af7ea3645695419758119c79a16e8f29bbc878b49d2a32a0d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a9c21231b41046aa7cbc3efaf17dba8621478e26e0555eec0bf1533c7ce58699(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__056ace49bd649626f63e3b95caa889ab294c597f4121e80187fadc229d057835(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__625c1675648343d77f0d83a8b3631bde3a91cbdf5bd54b66a8e20d3bea4f84ce(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsUnsharpMask]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__86e538ba0b4a69ee019b32b4c30806715731b0e368502e0bac8ce53e7bb26597(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__efafea157b62a694987452df60c3431698a6840a1f1cb9aaf8d4ce1d9ef180e3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__85cdd4f6ecb078e8d75c5b54c059f9a01e23832cdce6954d79fca12aa4f2cee7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cffaf014149b4b389a807867680b16eb0427f7bbc4400ddb473062f8c9f3e196(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c4d7a897e7fe5ba91a06eac97778eff078492ba3238f80e5e5d42f6c29df0020(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9f32c790606d7690df7fdfc9a41e4c1cc202644e0e815ee47bab23d981373f26(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5c2e9f7a007dec22e452700db3c406273a1dcee38567c889def9c0fd7a0195b2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__670cf4ac1d83f51d12f6e49ce0293491fe17a7da0103d90e1658f4297063c282(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompoundTransformationsUnsharpMask]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f87420c87f786a1056e68b0bb9be0d3418c147ef09e6acf0de2a8000e9fbef06(
    *,
    brightness: typing.Optional[builtins.str] = None,
    brightness_var: typing.Optional[builtins.str] = None,
    contrast: typing.Optional[builtins.str] = None,
    contrast_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__75f3f4faf7d496702220bff46ca7f7cb9cb4c162d830e56794a52951ccc88423(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd995d50633276ef340c9573b5b064481df02cde4e66e8694e6c5806f6a24749(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4218530f4bc297b3f39f636cd22c8d1c0e5cd3fd0188cca4ccd826d244d8e567(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ec33e06d95a6bc7a12b0e0aa5558eacea5496254905062f28a225c509ade9481(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__afad2ffc2581a36b7ba4b71e36d0f640fadea8df518959432933ea73d930e339(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__34e3a4f7b97ca8f1f5df8b002a64fa3b733e2c79f8266c9054aa56eff4411d41(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeContrast]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5882bbab58a923a929bb7349ca04f49277a26e837e2f9d9b607b551fbea63306(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ee0efb6e4771bede075a4fa7bb0f1703cfe34b969201542a2a10503ac8b0b75f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6a18dd61946d2afd5499780093fbebd3b0e40eb9697e6c220fa3b68f65b7d509(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b965d4d940917a5afa8067ac65e251667336a2f77920702f0ff31ca248c2f8aa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__33dc23a5dcf85667ebbb9cbde74efb569a0c290868d98973080844b47b5335aa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9755f6eaab856ed0b615e762d9af5bd73fe10c3054ea5d3e8c680ddc1595924f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeContrast]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__19f9083761d13c93b34cb32bea8ba37beb9a4836d8eb053d22a61c32bc7a7e4c(
    *,
    chaos: typing.Optional[builtins.str] = None,
    chaos_var: typing.Optional[builtins.str] = None,
    density: typing.Optional[builtins.str] = None,
    density_var: typing.Optional[builtins.str] = None,
    power: typing.Optional[builtins.str] = None,
    power_var: typing.Optional[builtins.str] = None,
    seed: typing.Optional[builtins.str] = None,
    seed_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b32a1667e5040ee92d322a88614f9b1f8af5501d18ea113cf2f49911dd061091(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__98a0dbb6784c44b4d7abb02d6bafdda77704858b82fc3dae620387f37632fdf5(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__788e1908a37c5c01176376545738c830cb975ef82618156ab64e33f7b8b6c926(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d52934a884701152d19a00628ceeef2c6fb668366a77bb1cefd96eb6b3f0454a(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bd24f493ce2e0ec83b18b305d25b5891446593c5fd302155a63448abc653e5e2(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1deb54984a0afc4cd9f3ad8778c419325648b7c61bc618667554840959daad4e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeGoop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e7bf08531a8ef1a891b9ced54b3629dc551ce22ec741dfc9ef2f2d297e23b236(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__58df99c592be7e85ce07808a098e653d403ff4102e4286523a3cd78d6b2e7bf3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__456cf59b76ea08e7d594472d85a5f56d9548eadf439a120c2ef3fe3274eb23c7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e95e5631bd255ed2c4610e4447b98c4407470e45b0b6865b9a5c7334be93c1d5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d51c9113567a353b472b4792f8ba21ace952011e25900e8f25696a26cecc96a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9e984470d845dc9c7644781d600ce8579b9fa5b7f38e47dce34440d980aa2475(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__55ee97fe4cf83fef4d9d7fcc8fceb3c8e06feb0e314a239279837fb502d51e91(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7eb4135c818664c258a17768786edca942d529351da4ef074f19071f6b5a7241(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3e912aff6f5a20d337209d5ba401bee9825e8d082f6558784589947a2cb91dcf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8fd4cca5c630cd297128aa0dff3b19cbbce68b43e2ea5dd31a8730b588a90a98(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeGoop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__02b2a86c53927c70e8822d58acb540c335c204eb8bf826a6fdd1c93842d67d12(
    *,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__423b91b5840fa678a99c58a3193ce418fe26a3ab57084f91aab9663accd71e05(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2aa69d4228ae6fd3cda2969e0bdefdc94cb97c584ad70d3ac54a90fb2586aa1b(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ff284d40df193589da7bbd4562b8f712abbe99dbac071dde4c5916d102a3bb5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8e01d6fa1ad3197b97e7ee1abd74393babd3834e5b786f250b9e3a88ed55bdfb(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a2ce5f66eceb7e7486f52f0da62175b687dfd508a3baa0127b181459eec109a(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d4ce4b0a67b55a2b48e30ad9b2e103a8f9523be33ebde11ed09203810543d414(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeGrayscale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c16807d4c65eb758cd0352ba0ffd8f499cb5f19cc358451d590bb1197ca3cce0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0454718bf7cf81f5999894ebfbf13ffa9bd286dadd7c1470200e6b971111c209(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0cc3a91110c02b4e1a9d7fcaf55f157f6b17f5998f113e605b2f069d6e86053f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__adee473c9a0ebdf742e4566a83e253ccc42ac86ca5e3851d4deb9ec8ca40f670(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeGrayscale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dbe696a52c4aa1681af7a715dc84661acaad1e5b841724883c23af3fba77870f(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness: typing.Optional[builtins.str] = None,
    lightness_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__879bf58dc43394493175f3153e0192e0f403da76b9de841bde7ec34e371760ef(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__686c1a981f01632bd523199eff2897dcb91a71f7aa55989e5a439544ce67c3c0(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e179ede5c659cd681d8710441723ee7bdf65d4ca4ce09cc660869baf9baa2cd0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b81bdef1e32d98750fecb618fc2f931bb3c0039eb95e3821a0431c0a40cb5727(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__07aba5aa9c7ab0f7495ab5a93d75630d642f47d51ba583b423e4fc0f569f2a9e(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__986efc2a344d5e8f5800f3d4b225919209b5f3ad41da54e35934e0812162ed68(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeHsl]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7ad1042f1292e5bcad9f38cc1fc10d2639e1546db84ad8a875d27426a0046b16(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c523aaaa5a15ca761ec581db52075b0d526510ced699c8f1f19666d9f75c4312(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d16cb5edc0940e7bb7379373cf2a515985866c11aa33eccd81631b78ba0b5d10(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c53cfd896671300eeac6ffff547f8937dcc71777d3835f79b3f36db563abd681(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3b5cdbe3e9cb5be55dc46d98d0d9f4d204a1508ca8c9ca7a3f7e210799fc0804(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__077c9db8dae06d88fb98c66078580c6ac9bb6dd78f2e6a23144f49d9bc3ab118(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f137e6c9db5ace86bad2a95493347302f02bb6b486a94c19063334ffb6a41a00(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__05f7eac93296951ee817caaeca202c126bc5a26b186af240fd7e1074668556aa(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeHsl]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__de1681e327803868a5198a84a8225f2aa3a4a9f1d0678b7b8087aa1a75396508(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e8ca66916ea1dd416c2560997f3936b672f54a0b9ff0a0ccf5b0fadac704fbe7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f481aca4c13a21e4db1213a122bc03fa30321b4aab56fd9d2179211d65a76fa(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4c976469667bc06b34fdbd94a22e697e593c97f8f68cb379b539fe12931b9ecd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ae085402ff84f9c15525c8d312b108e680fabdcaac2b8d6e8ade0d0deb26ff7a(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fcdb3f9bc1cbb8576469c3137bf6330e3e3fb316fe428010ac5a775c6b37706e(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__84ea30765ba4bbc04b4252f7d212467030e092b86be9de63346a3da059c66192(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeHsv]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__22ec4b528e0d19d43f60962c7fff0a19cc010f8910c7804fd2faed6ec655f407(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__516e537c42333011db0445f17d9ae68a879a76328595241268963ea0293878c3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b97dc75fdc4fef13b710ce024b672b71cc23ae3749c84f7e8c84a34488000cc9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__08e5505a9b018b41d1c1fc6beacbfc3fdf3c18bc28de0b849526d3c35f30a093(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__08e40d5b0058f880d1380f68b829bd3d77a26ee8e848e695a2c06daff3c7632d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d796d3035c1577cd3b4c0a48527425bf902514870dfbb71d88a333b6eac009a7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d09467d141ad7b49006c5f693734dc368c1a09ebb0fe333ffeff14689e1ca674(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4252c2c1c1d423808fe3dcac7126bc52b6a0497a421a3f8cee3c663da53760f5(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeHsv]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6832c75900f4cc9ed1c179973bf1c1d4480590c53bc906a8cb06216437f05448(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    dimension: typing.Optional[builtins.str] = None,
    dimension_var: typing.Optional[builtins.str] = None,
    equal: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqual, typing.Dict[builtins.str, typing.Any]]] = None,
    greater_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThan, typing.Dict[builtins.str, typing.Any]]] = None,
    less_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThan, typing.Dict[builtins.str, typing.Any]]] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d029a8a046995bd6b3b03aa33bb1f5c174e79b4620d3af8d8d41aa2324225a87(
    *,
    background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
    chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
    composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
    compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
    contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
    goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
    max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
    opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
    remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c59f0f150a1fa275b069c4cb9772b8e8e38619c7418bcf5c3ffac894bb786139(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f66ea25f6b0bec88720cdbfc070dde9c36b91a6146e5321b9d17aeee920d514a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3afb2abf13f9ad2d5cecbc4c72d0e6e5965a5e0c4b450fc188ef52f37aa654c5(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__38be0da7ed1e3d853339ec8db9776084acdedf27b50621d6bef822b8157e0b58(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__707e8cf66cdd0920affd249f24dbe726dc7e283e88d054be836ef1791c116245(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__94a99106f237ae5fd243d5c439c4b2f90fa3d446ea0f9e540d1a945017e5331a(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bf4daed02e35c1de8a100d211cc8c3b8f5e49318298ea62260c07d8042f60fb9(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultBackgroundColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__424cfbd8fc475450975f9527c60906bd458ce1dc4fcfc781236680980fa1cda3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e7fa1077e778ca25ba68e47bed6aa785340d4d9e23e7855b768023587ee8eece(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a7cc26b22d94bdef26a3ead75a412986194c0f9fd26b6216d54eb4f7a0fbc2a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e7ffc75a4a4a1541af8d32aa19b15368e734e06ae259798c78c95bc819f4a55c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultBackgroundColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0aee361f48a04c744d29b57a4c468cb430f84254dbd4e63792a2326be276470f(
    *,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ded2b458589586f615216e43ae2724e65d86e0de888318633f0407b280cbbb0f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3685d8c61d10595f9f9bba294a406d65c59cce6d8cd6ade36cee0e5fff4ef676(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a7e52135ed26570a98e98a3e937cf5e1b48163fcba5e8a589d0f863519c9fd1b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aa2a2c8b612b87712a2e851208d263b3224237e2115133a2346a2630a310cf84(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cb9d46694cc689fc910802931270c1ee174d77cad71c3e95d67f94d362c56a20(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f9eca757bca05c7cbb7b54781577a47ac862c28b45d070690b69712ced7d34f6(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultBlur]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__473f2c5b1c7ac802d5a89d57131928d13eeaa4e2266dbcb7d1e2d8ca7b6c09af(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5989a2b04bb8a76fef062d57af96b51e6c11877c2b26dad76f33a3d72ca152e7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cef868def54519335d86475cf909548a36610f29f3658a97c5ace65942645eab(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1e0aee7542b3233442dfe8b6d5f2c0248a3f4fd6cf29d07eb68f7299be2e48e6(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultBlur]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0324fe7ee0e6e1fc2f9a97fda25a84bc2e214c830efcdf650c4f93d80885a29c(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_feather: typing.Optional[builtins.str] = None,
    hue_feather_var: typing.Optional[builtins.str] = None,
    hue_tolerance: typing.Optional[builtins.str] = None,
    hue_tolerance_var: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness_feather: typing.Optional[builtins.str] = None,
    lightness_feather_var: typing.Optional[builtins.str] = None,
    lightness_tolerance: typing.Optional[builtins.str] = None,
    lightness_tolerance_var: typing.Optional[builtins.str] = None,
    saturation_feather: typing.Optional[builtins.str] = None,
    saturation_feather_var: typing.Optional[builtins.str] = None,
    saturation_tolerance: typing.Optional[builtins.str] = None,
    saturation_tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e971806507a5cf3efbc966e9bc4c8e5d7f409f5887c4386cc0d96948bf07daa6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4fcab4d32c9cde3fda55e1852994ec5b819601dc58feeaa415db013521a44791(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d2f4597c0f99744fb26470b681151cf9d5db048dc07a9129508b458142671554(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c7957f24cf48f3924953725dce18c23495360f97541a07bebc0696765705595b(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6ea2b467ba07d7edb9da37f9e4af455fbbb9bbd1e2cba49bff39ed06e593c4d2(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__451c6cb799fcbb0e37377b5e53d6cf32d82b8cd5224e5f1e7de971675ec585d0(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultChromaKey]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5472b3e9482d456a2b26f6bb2a100bed5cedba5577e4baf656534d677ba7202d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a93d49b832d6f07178e3e4964d8fdea593d79438aa5628343812f444d1fed28(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d15ce6ab8a4e9a60d7e184429c8a9a7650fa56d8bf3e2208aa5359fe3236333(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a1a20482ad53d9b1cc70c01e49118dbc184d50d0fc9bc4dffb4039271484c68(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9b2c3b98242fd7c5c308b6a957d9c7602ac555aabf21a390256fb003817bccd1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__60107f4bdaa59d5e03a3dca8683ce0630ed207f605defbe338f536a6233cec1a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7933d3b096630583a1fa07876804743345c2d0ed4bbea47a1f92e981c393e796(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b598e520818c7274bf27f16fc208cefdc588d39d465b74d81d8f5b732f813409(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8145485ef8889411d7f74481ded917160eb58a8dc8d62caaa89fb652eda8efa0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ec8198f02c19a0cceccf7a59123ed01546491052771b6afe9a4410d09c52ac90(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__51a0538c77c298490fdb73252e7d448d709ec69adee0a51b11cffc6b28587aa7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a19a9ebd7f8ee5abd285dd3e9eec788fba160bf733d3a05dcd3dcfa5a82531d2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__321756cd7491be815811192f05fa30b46f860939aeacfd4bcf6786fe271799b5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3bcdd7ff90fab0dbb5e4e11022d37743706d30d25c4b9e376c40d6808683546b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f93e1a25118630cb4aa29759ff709e65ee77ca1dba9ad2f5454eebf9d4787828(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc87cf4d577bf740864cc6a51cc84afee44b9dfd7fc62adbcf8f877ec78fdef6(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultChromaKey]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__27530e1a486ec4db4cdc4e0e68f7ea90edaa1cba097bc288a97ba3b232b3b1cb(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultCompositeImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    placement: typing.Optional[builtins.str] = None,
    placement_var: typing.Optional[builtins.str] = None,
    scale: typing.Optional[builtins.str] = None,
    scale_dimension: typing.Optional[builtins.str] = None,
    scale_dimension_var: typing.Optional[builtins.str] = None,
    scale_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a566e8af0ded49fa3053995c4c60520fa987e97bb4ac8948e1b5c99f07f6231(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f8993a1c30d6e5d6ec19ee0a07a3c5459e4f9c9409ae7156325d7d2b5a43c7db(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultCompositeImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__499ecd3a79a37a2975691ced034d915baaadca68d4ba6399c8ffe6b394ba2135(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2868cfe7af17a14359775b0b4c174b3216b45ff4e853ede92cc6699190149da4(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ac47b11a24b3b0a045ec4146cee51ece6e16bf17a8081946fdbe5ca9f37767a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b6b5cd2db437364d2d7d0e109ffb782abe4299280de4b51d6de7d09bf9d55eb5(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ff3d0b41396536c1c48b13085a5ad9f37d4c8647d6824b8bb3e45c041dca3c43(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__90a0054a21f98ed78d7417900817cafcf7961c781934b4e9e14a4b2aa952891a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultComposite]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3439738d6b8251764a6a2c61770ced81eb1b02ce757fea27748f79967a41b9ee(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aaf08d0f8ecb6ac39c68fb1996f4a9eddf14379f4fb60841a17307aca558f2ea(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9eae45e287fda899faf7c86965ef133163b250ab8f98167037190908b518cef8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dd47fe3a550b2a85b66a49c2521c0d23ccc42242034c2f07511bee3dd18a816b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fbbea83a94c94ac1940af4d88576e9bb031db470dedb669868eccfdf52e7dfa9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__890b8f797b3340d77161daa3f0bc1b4cc5f9f3661eeee78ac02cbd58cf80f50b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d950d2d3057ee75df72b9d21468b5516a0013982adadaf4b182f988f51c4e059(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5a2473f624ada920d6ccedc86520f33d2ec242f66a77d96487e0fc717d1630fd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__33017926413f4fcb5b7db949d5bc5ae98bbb45cfb5916f0fc6b0117a72e41cd2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ebd6e3bc009cf1301de6bc826aa8efa5e1dcd57dbb6f1a8e5a4ae262454ac74(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__065ea6e5adcdb6bb17167c705d0d993121cf3f70053cfd7b47566ae6feb0a35f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__de84de63ed5a349905e345cc11b844f16be34a189684c596cba2669e9d71de66(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__66f13a4591b9f6fbd3b47f966d934314f2df54507650287bbabba107d734dba9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__49a3520e9cb3f5995befa256a5d4b4dcd38e81f6b7a1e1436898e587c496777e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultComposite]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__43725ab86e669cd2f694ecbe404468a0988ac2a24552ca132fe5b6def4d98efb(
    *,
    transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4f7b723e6074fb8dc18874a6887d01a82c70cdf8e4bd74c23845cf5560e26690(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__803dc42aff83a8f2c2b2627f82c749dc36282da53db81b3e17402d81a4338440(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0d0ab4c83232c95623daa9f7d313f8ffbb75ac354c862a15a06a7c64e3e0cddc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b28b68968ca73f935a00692e92f94faef50c8de73e10edb0c28ec763151fc6d8(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ba9255126d17274a3c205de0432a2d45004954f3ae5ee76751f595ad1d8b5b5(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a424de0e03527865e10f707d72267895bbbd8fc08ea29b53d6d49fae6b7c76b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultCompound]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cdffa48f818600f30017dc7f3f9fadf00d0b3373e266a8594e8b858b8e70e6fd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5d53f3f4aa231744a851d236b89c022a2a0f0f87a62383ae23c00905195ac827(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6c81728348ede11600b1e6290e86d0a94887909380c01afe9bd82ce5ef18ef46(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultCompound]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5d0287ea13cdd74270523b021fda7edecc84b02d9290922cf24c3ea03c8c28b1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aae804115595c3eda96fa20dabdfc666d6df11cef0d8be615365d2ecf6a61f37(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d1306c4e2b57476a15e1a502e73ea85469bfe8d1ca015b5052b5cd40b9c558d8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__556dd3dd8c1c9ba5b5d62ba715378bf32e844e6766847c4f039fe20f8eb7ebff(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__93eb157da36525674cad6173afaeb56b636f4e0e9a32c7b80889b9e767ff6557(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__267b5c4e43b9bd6e42c08bf07028a2f3a9969f12e89391924ce4c18a12cffb90(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultCompoundTransformations]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a1b83eff74e6181703563392327567dd4b3ea76c876be9ab3745f9785ddf7808(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ee07c485f4226a5b393c2223ff91e1a81ee110830a65387c936cc5d155faa1db(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultCompoundTransformations]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b404b09336ead1dd0f927532f5b57dda43b943dab626e899b0906d7ec3c17216(
    *,
    brightness: typing.Optional[builtins.str] = None,
    brightness_var: typing.Optional[builtins.str] = None,
    contrast: typing.Optional[builtins.str] = None,
    contrast_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__24edde252f2fa5a7a137be7df608f285a89e90abbcc0085449c3fdf543c2c057(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3448ecfcf762c3d950abd2d3ffe44309081802ea0053dcde3f91750bd5b1e264(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9f62051eb71209d3ff13e438d8fba3bf3df34f703c208401a2234a0afcf0b45e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__044bb23ef8df60f0e895d547d24ed63ddc2606742a4d6a22e6b4c74384d6ccd4(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__07b9b13b2440123c42b3d44e011e8540444256a7148e622c69eafe2623183f58(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__48544cac09db2f4347365023afefb83edd5acf324d0cb3f8a70f5d44cb72d2c3(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultContrast]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0566ad76f376f5d54c311ff3d4de8afd1045ba5e73a7dd942da8d2967761aaec(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2e08b87a2624dc81e88b1cc91915c6b5b60fb3010fa771ff5b4ab91efe23aa8b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bff5f5524981861a4c014960eab7b21c0748c21fcc0d129a1f14969dff3a91c2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5b0670c0b3ad0d8b545c2ceaf8721dc7044d1206415efa1d7ee8f8057c3afb6d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a48d14c7958cf754e583c82c9a974b8299caa8a8a94463ff7c7a204dc511207(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1ffefc4572aee782ad90e7268bb6534633f71c268d96abcff95ae8cf23aa7e15(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultContrast]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c53d8da897a0b7909680381d7d45263cee074c3ad1cab860f91dde77ee134b68(
    *,
    chaos: typing.Optional[builtins.str] = None,
    chaos_var: typing.Optional[builtins.str] = None,
    density: typing.Optional[builtins.str] = None,
    density_var: typing.Optional[builtins.str] = None,
    power: typing.Optional[builtins.str] = None,
    power_var: typing.Optional[builtins.str] = None,
    seed: typing.Optional[builtins.str] = None,
    seed_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ae53ef0d5824df487020bd18606779b5e11313a46340a3454fa90e74b72f3be(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ba5dafee3decdcce366627d6c7fa1ebcbfbaa1e00bf8842bc4cbfefc82e80ebf(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__37605ee63110ef61392e289ec90182f122462790020821fde317e79570f949b9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6a491871527e39967f22a502fa07a03d317cf788e4b8044505a99e06f081ddad(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0453ce22029d3172676d5f6e3c1083a2b1897a3cd394e3ea07f0571fced448a9(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cbbe788c3934acc8e192f211c8517e2825fe780ff9feee58468edd6db234dd87(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultGoop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__580032493d61fb673291daf3e43f3e4996fd92450c63e6c71f7baa5efb2af726(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__891f0af9d90b00140a6caff500896848604b3d60072c69d8da48cbd97f2e9e42(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7f8ae04bbeed015d8027f539f20fd19cb3b7a5f9a2eb6f66dfaa79764b4581b4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2b4ba90d863c8f3158b88008a68785aaa162ae58affc09d3554b69292bfd92cb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b046f49db4c2bdae6ea27968631ebd6999d36dd71df78625eb1e673247c4b04a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__86797416519b8ad3e6f5b004ba511762059082df8b0b0350e8ac4084f4c99c24(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c1fe0bb4b36ac4727f868d590fc4ea98b250012fa5c0c17e54a6bc7145d13edc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__630edbed808a10f83c736b4fc30638652ab9bbd4b86d1cd7d3bfd578cdf8645c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2dd54f1f7596d526fcd92bea40c99e7095ff1818c4536ab7bc9c76bdc5cb2d9d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d51eef1bc9424410bc620571a39bc2aefa38233253f816386912a33dd6b50271(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultGoop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__292002317521d6fde579ac1b1557457dc40a67d38be26fd85e54c2089043a92e(
    *,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__65994f8169e342ea9aa2492018d0626bda063a22963e25d7e49d6b32c68baf51(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ca62170873571daae8f00870e6082c9e56bb8b84bb2cb0792cf4f4d1482d14d2(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1e268d946e49057b6d2796790501881a31c3b51f0f81d38923d01e53e0d450b2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a39ec7224a914a78f508ed6ef31fa78eab6651c1dbcc2fc6a8268c58b6cc6b44(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8c6e88e0ab500fe9aa6f31bce8c7fe496550d8df6bbc75838b722c60ec0e7859(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f52f8af8e0987b132091ac47100bf45b3f3ca762aaded868605ebc86f1197738(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultGrayscale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__68bb4686b3111f56f2110695f2e5046f29a4ca3c50fc097af4737dd32111ea29(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a6b4fda82c397715f6776b5049466494cc06030fa1fa5365155379c47923cfd3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a672ca642afb4940ed31b8f7aafeb29323c87173d4889beafc5af0314c041a42(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__05913e59e8de9d47ecbf7ffbeb3d3df2ca05d46e4748bd405756d6e4c569bdbc(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultGrayscale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__98c1cf2f3ae665eee7ced7f068348d7651265cbbdf572aafef69e80175f7e0ae(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness: typing.Optional[builtins.str] = None,
    lightness_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e6cc97b8c11d09ef18ea74cfd5e0132d0291bd7c7083555cf89e27bd9e442c0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__baff14eb1123c76c4b452319c72ccab957c447d35d99fa4c9ca695a952d02edc(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8eff524e9c096f038a45134464d9546552719775315af7490ec3432b3c750523(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__95663abcaef17b1f9d5dd86256efa9e003544d5c437d72d5f0fb219b09a7170f(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__90f4321d99b258e11006224d14c533909a78309a498ed798590993dbba8b620c(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb53757b38109014e1a1b7ba8c7da5fd046a00a2791bdb20122b3e6b4524840a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultHsl]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7966b370f351827f3295274a06faf71af9f7b6e169824d5465882e45a552f5a7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a188a94bd87f897f35168484f3448f30a6674252d8bccf957d4b8679b3ea3d7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f43b23bd84527d52448e30cf85c0dacba1af492631f8e8d3ce70149be8fb3d62(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__50d836f5c70de62a1654ecc1eb86cf3fc7413e8b702c2b035cf540fe63993b68(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c3643887ae72d41d7844434e96dae834f83244883cb30ab73529e5c77492d1c8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7ad43e5b1a31d4f4c5d16e892f3074b6393a58b8f2f646e640090159c218bad2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__04143f2e4a1a04a8c541ed69025d1b070f6313b8ef068d4f92a9c2bd27b33f94(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e182fd30709bd32f0dac46b310f965ddffe1f703d3b629a6b9a706d2ce8421a6(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultHsl]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df0ed2a9df2c0fe32a007feddf6fbf812823a8e4490a92eb507ba2ec5556c28e(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6ab033ec5b21256b3690d5a154406cea2e28572558a489b4790dcf7ccc7e7f4d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8748cd5a9d74313c560bf98cfefea04ff1663e82002e4d87192049eccb81a1e8(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f9cf4b7b4aa86d570d3b043be1bcc9fe90f8de45c6faef12358815ddb6004060(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fdeaf0f827f0d2a7587a12c3d318db3bbd26c00117f573f46f889bcd832a0af8(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ecf8fe7e3fb96c7ef84157679eb93e84fadf79b7e44677e44e7bb138951b5e51(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0d51b7f3f6106dbae9607b18742ff55cee99d3c33c49e1ec88c090ff777e55c0(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultHsv]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d7b015302cb6a146b55d18ecb59a82bfd5aa335fb89c93e94a395be8a9a60e3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__98ffe0cbbda97182d8132fb3f135681f7f30f47f69a663560b7f6d785d381ba5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__faa17b3c2abf50febda8e272e579709369c0a9818624d2899189862bed6739af(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f6aa244e7ec22109b9f367910d1ea12ad103215e83afff466016f8b257a7852(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3d52a4f3cc930814325db57675f6980f154d63a199ad969e19e604604cd5e059(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d6f3b9996b36b189d716da33ee0622414df14a37975c9f22788a1b177413fee3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ae85ef0203d09030f9b9044a33c4dac03cf5cfc22e5c223aa0a61dedbef2e563(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__10e6f9fffada15a4e05f4e27c8c86c2e0e67ccf580c64721dda50f067ba4c1a3(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultHsv]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9c48bedfb24068036801d63ddfa825feb449b8c80c08f744014ba7a8b2ae437f(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    dimension: typing.Optional[builtins.str] = None,
    dimension_var: typing.Optional[builtins.str] = None,
    equal: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionEqual, typing.Dict[builtins.str, typing.Any]]] = None,
    greater_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionGreaterThan, typing.Dict[builtins.str, typing.Any]]] = None,
    less_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionLessThan, typing.Dict[builtins.str, typing.Any]]] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4c97b213466c5b13b3977cc2398a5fbf579ad58e04fc3e16323ab4139d6713f6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0a9ff5c01f37611521631fc67360331268fb44a39cc105f13e855978b3d48ac5(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4124f65cbcd01c91bb751eaaf5838f24e96872d5cdf820b1efa064180e54080d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7ceda55f0fb54998b698882e622140a98ac39796e1dcaf4529fafa5df4c59091(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionEqual],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__38d6bf38caf3d41cb63a98f5eaddafdd6e2e3c0ce2f307da39df568cfa1986aa(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac7b8ccb8aba6b7e6493c33a080b2bd4237db8abc59696f47699e18b50b647c1(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionGreaterThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__efb3465dbd4487d14139913aa1e211e26b489f8fdc8d118dea890a073e217cd9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__94e26a840da08484b195782f465bc1423ca913adcaf00762a6734726786e19e6(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionLessThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f2cc814d992e823eb6942b0a114bde199613115b406ddbd97d7e537678ff7280(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cc6414105ff38b65e6dd8c82633da68a3de5ccc5e95248022db4bf322b9dc6a3(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e052fde3b5055fef83602932fe64d1f815e7b7bf60720998f404c69164c77e4a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__25d912df0c50db97db7d2a1d01dc186cca05e24d0c171b9ad6336d5e1acb8e18(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__22e553bbcceaa75ddc6d9d994b2c1330e7ae39a5eec2d5bd8e0e06312291a293(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1b0b26bb4c73e9c1f811fb31623fdc3e67282030e17dbcfdfc45fa7db049289d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimension]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a7561891ce62dc79d73ce56194152c04698bbd3b9c444bc79906c1cd33162463(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__849dea0ee18694d83a28a522d319d79d535854739751a64019e7efc970ce9cc3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__041000f7f1af5368ca50b573e5907333fcf0a90340d1a687fd7fed779300adfc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5224a027ea9e47def1e9fab92ab4d6c33f53a3a117a1d68083321b916b722238(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b16b9ac1333720cec11cd34921599ccd057d9b74fea9ec35fdde5c743d19a446(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__60faef8f52f4a921b467df8d3686dc48d416d138dae68f2c3ced475b98921990(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimension]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f8c0df47cca575ed2c47bf92e85456799d9d2cf03df06f9cb4a0c3401363b4d7(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    landscape: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationLandscape, typing.Dict[builtins.str, typing.Any]]] = None,
    portrait: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationPortrait, typing.Dict[builtins.str, typing.Any]]] = None,
    square: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationSquare, typing.Dict[builtins.str, typing.Any]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8810f1e70285198ff06d208e72469b542c7bdbe9e15d64573e1df858537b15d8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3c0dcf3de0e2d936598e1ebb284ba6a35d33a12cb929d2fe6a0590f0fc40e8ad(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__117fde96ab227d6ac5bc89fd9266780116d47175e1e196e6aea43ed52bffea3f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__978b20a3d7036587c45cb9456a0e3f0b77cde974631e5bfc70704a929442edba(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationLandscape],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__46d8e1ffdcb9834731313fe5101cad0a08459162fa1d13ea3e446e75d942a348(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__178009745a86b7fde1ef5fbe58070428102678ebf2e010d991474603591b0d22(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__49b515db779829c78107dbd2792004e357a937e136a01ba6d6aba19839cf8b1d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c95b590f210ce71da71169d667706b7fdfafde84b3c7a7f4f6200a3da209798b(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bd8c2c669131039a3924eed4fbe2d3730f0ca6d592b100dbc0b755c58aa8e744(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fe63624f1b01b6dfb89052ff89844f1e9d82980377063163249633e86cd52c81(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientation]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__650f0cde4669e87c0f38712cd1f4b0220b7558beb203042c45d4068c2d3e1f02(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0db0d7bdec595a4a190e37716da535f6dc5f542a631d7ad719b37d4360280eb5(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientation]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8622d515a4ced318f9dde18e6d761843c90a19048c9743f13e69299792365a89(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__398e4e5a84fa30b221d0e3e9152a01df102d0a7323e37497f2a85babb51e9161(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationPortrait],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7531658f6cae148deacc507f73548b7bac8af974f1d984f4bb0f41d26a295276(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__38be51255255532a366f6cb14213f10b7a79d5436a1b438dd2b81822c54c4d3a(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationSquare],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8f1f5e6cf9e71dddf4fa8ad6f4f1a6df79ce1f9b1613826dab17895d9463db73(
    *,
    colors: typing.Optional[builtins.str] = None,
    colors_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5fc48e40cb25a6e60077a2fd4a846beff8be182071b8c66e26ab5d9bb4fdfbfb(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0e3854f9f84ad59138ebb6444f2c8bcac7d34da1843a2071a40252b32e6e2ff5(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__db69e2186bea2c7bed241befb73e27663ae72e561c3e3f8bd81905ba27f9dc0f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__27a8363165d0675884488f17eefb0061ace75647adf029123239f6c5cacb56e4(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fb3bcf66582626c9d1b3b306f3099e159f6045774818ada16ab29c7620e9e05c(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__580bba499286c5c724f48430e8798ab81a9b7672ee821787c09af5d438cba658(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultMaxColors]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4d6177fe4f83965e90f4421f495957fe8722ca4bade14a4d6a2b64dc9911dc48(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__21909fe79b1bb605bb39c6ec780b454b3bf5d20da1b7698e7c72f021d03161f5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__269a93d3543c4009deae08f53c38c615e65ee96422e39864294111df0c676de4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac3e520084d9119cb9981c5fd6e9466639badbfa1b93c0cab0a4d818f791c3f5(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultMaxColors]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ccdf059fc4e13f3f26ae2908a33ff6b037690f438c0a92bed204c57fd850296(
    *,
    horizontal: typing.Optional[builtins.str] = None,
    horizontal_var: typing.Optional[builtins.str] = None,
    vertical: typing.Optional[builtins.str] = None,
    vertical_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__238435485e5ab0d7316aa1222cb9d6f2ef94ec32fea8785ed06192a6c04fbf72(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__44028f7c6754f35ee5c71e36f11ba8f586da4863ca595a9d06b7f3425a301c12(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__06722712133ad378ce43b7470987b2d60271db14f0a3ebcf06392b89c819344f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1ff3362bfef32ff29f70384d1c91930b25e4543dfd8263f69bf0abaa60e1045e(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1db80a9045e28c3a5b8036a2364984399ff04ca774706dd115ee59c5a4badd7d(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b01154b1c5934710850c7940e91774596f7417196302ea702826d3f6b821c183(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultMirror]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__98b3b1018aa4a033c034c64a530b5323fabbec3bc6ee50cb3fc4e716d6272976(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c078d5846ecde6b498539f5e2d274386fa6a502b974e258cc5fda9869b005a9d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f93cc146e4afa025da94aa0af8f0a094a7ba0ee60adaf82c71315278bcd0876(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c614fb7a81a0e5efd8b230b4a0b840f2cfb2fb22ea73a7f1257cb67fe215bdad(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ffa8a286d7a1bd0e5686d59ab0572502ae292bf5fc80550ce53d0ca499c959e6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5bf3f9f38b1f75733dd404f0722f0aea05fdae02fdc10b6df19752bcceb1b4f5(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultMirror]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ac79045f96ba7af1cae39ea87a3251390e539d517b5aad2eca0e74b9b2cbc2e(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__19e9a97c4ee23a0dacc6cb7f98e24de384bdb08d6ec514c0b4fc14dced66fe1e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1bb1c311e7759cd1e6f2325e3bbf488524862eb11e28bfe63c4c1005f6608ae0(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__364a2af369fd8c309423bbd40a9a1c17ff698e3207bdae571e7571b3a64d7f4d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b51a0458b0c82492b991dfdb9c58427a2e98ccb04c59ec7884f1be24969f6d4f(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__da346ba5c30e982cbda05684e0d270e13d53c8bee0a90f3c3fd67d40a5824fc4(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5a59928eb2fa58941c6dfc165b7c3e8725adc930b77b940e351fe43d8d7db183(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultMonoHue]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5e92b6fd99d974afe8bd0a718eabb1ea3295a0df4ac58f584b83e87a3be54ae9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5becb8676a80d499b050c75e5bf4060d2ce77a9c9228cc949439ec397112b632(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__823090e00a5d9cd4c47e0257ffc19888c3ddbe93844d4c03fe35ccae015730c7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c5eec716a51e6cd2f719f82672c7a4a4aaadaf907a3a5e6f7782f85f88985bfa(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultMonoHue]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1e6b220747e8912e3cdfe326bac4ac27196c4c07c715eb77b0ca601355158b41(
    *,
    opacity: typing.Optional[builtins.str] = None,
    opacity_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a3527d4742319c0ddb709a7c4ad57578f6c019d0261d6726318602be0ec4b03f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f10e7c33ad39fe09b1838761e14b83caac6dcabe3cf4ec218ff5b512ffe86fa1(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e36b5ac3234d61ceccd0682fb6a18ec18e74b96272cbd7e85c36b67492deb837(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e71af81a45a8a507c21ad1a2f1551c373f459b4b16bade45722d57366cdaaa05(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d652b9c249e90e2fb5fe70107b40d58eb23290136fd412a26fd64d0478c2c8a9(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7efeccb40c19389ab2ecbb5f7f3537021194cb521be96dfe6567d6ac5db1a3a2(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultOpacity]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9174df6a76b549653d69da7c68bae7a5925b68e6971a3f98499e7e0043b767d9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__620b81816e9cbf38b0c31d8a6c243c675c42283e1842109681a71284fa8f3d4e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c11fa631c94366328063292527c5e08c6b6c6af565878f166c26d0ceeb1a29d7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3e4b895ec338fb6617f701038f5f00c3270bb9bc6bc54773279cde1198d99f01(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultOpacity]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df264eb14fce29801d6990293ae8983b190a1cd8a94a3b9616f068f266a94969(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c0aae0b01f6dc2f23c9bee04f478998096c9ceaa35ea95ea196e7d223cbb1ce0(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__496229b988de61ca59a1b3db84e9e26223f70c01f4760d78a98103c5942c0ea6(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultBlur, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e4522276fc8fc55a6c3ea10ace36bf85c1390ad10a2254f39fbed979f9eb098a(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultChromaKey, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__064e91e7ca35848d85dc8031972a7733d6abfb0575f77251033fd32f71410d3f(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultComposite, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__26cc88770c44e4fd23d15cb783897c6f0b0849f612a4cbff1db3635431979218(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultCompound, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3fbab278effeb3768c8b7444cca61e92e2db4b20894d6b2ab92c8931b36f6dcb(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultContrast, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4b3c28764ea0ef663815cc87eabe6ae77fe7154f8c985251608acb18b6764701(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultGoop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__903476ff208d51be9fe6da2f3edc919e8ca7947a346d5cc6391a60296a18ce97(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultGrayscale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__60a76c9def6dc70fd2676996d2472d60f71e9c46bfb7a495480cf352357ee711(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultHsl, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6aedafd8d40e0efcf5032ba912701423a0089614f15e0a496e55da2c06767f71(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultHsv, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2136264c07ff06a54990a4edb55ac256bbec63584e03f262ac717d29a2aeebda(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimension, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7e81c8e70e2966d7431d0c2c40408652008d347790825f74ec546e4891d6f31c(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__20a910076d51dabf131a0ed0a4cca81623264ea807f615925c12846efa4056bb(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultMaxColors, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c3862393134d484ac28aff7bb3983e93939c91ea11100bab503c02af33db937d(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultMirror, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__04f200091841adf6ad6f741b7b8957fd217e05fdfd0bd2b6ee5359387a3a22ec(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultMonoHue, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3d9fa13b869c883d06981a90af82878319c77171fbc10428f469792fce23a2f9(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultOpacity, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4bdcd9ee9cb00d1d9f886e1d5924a0553003527002c30f1f5d1dd4147274fe03(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultRemoveColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2248ed34aeee217fed8679963a5d8c7fe688c859ae83728ef29c1f44a313dff6(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultUnsharpMask, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c4382cd2bc0251efcc91399263ad91d3ec6027a24f0b5f664097b02e2fa29d98(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__47f2febb20432a440688c7e7e9a2b476a8df4fb9d6c22d5912e600613d69f0bb(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
    feather: typing.Optional[builtins.str] = None,
    feather_var: typing.Optional[builtins.str] = None,
    tolerance: typing.Optional[builtins.str] = None,
    tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__07868504443d38c5e33e7d0dd480113676879b9416bc3fe26c12f9636f90b515(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0b91f8781b7252c35987b6ce2b14392b48e13479ee51549b5a44a692b6b89cae(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df14781a894c022f5c8a5e5325cf266b9621cf9db781f69a703b5ab1235e5fae(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9dee5af693ed964a85a371433fb14528efc0602ed430d85f4c4619a6a04d1b56(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0eea3ba058e59324f3c2909a904379bca9074e98d6dffb7d97cb249f43bfe335(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ea34fe63e4f0751477c70103c8945a206d6171285f062dcb5a25d508c0e6ba6(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultRemoveColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6c821ef2537ad5b0d5f1564cbd92db81cb4daf1c18da098225906b575e4407d5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6a614fe2902f0aebbb148c2bf6ece439b2ffbaae50efacd847efb11ba627c2c5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__726b4c3f90d250091b54ac370747c2383d583bd9b9300b9b1e60ad847b11d887(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7a78ac244f7879b03f10283f5fd6eaa53ea1523f14c4758f1a7fc44f775e32bb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d9fe9d8479c8885342555eea63d8c824fbc28c07fb53b02ebf0480c4888f3dd7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fd70b4b6fed624849d3b2dfedd500b04405c88682963564d5944c4cf8d1be136(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d43ed58894c08e62c10f3d8630ca96c33d275528e22d866228a79070501f7f0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be06dcf532a39a8e76485acb3d04bd3f78b62af2460847996920a8d53fe16857(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultRemoveColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d2b3014c7384a6bd2b8003b3c5a28d194043d95c5945582de8ef1c083975263a(
    *,
    gain: typing.Optional[builtins.str] = None,
    gain_var: typing.Optional[builtins.str] = None,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
    threshold: typing.Optional[builtins.str] = None,
    threshold_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a38ac3f2b4001ef35250385855bdcd5d7323c00b67f9fc170d48ecae14e37eac(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__406b252182eec816642d4cad3f0773d65277b512a7c247e8f0574d188879d470(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a3dd303e162be2de5925193418c3141674d713878f6d8fb26ea1fec43b4bf972(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0bc680dff695ea3a0d4aea69104fed5c6cbc159b01b7139ffd149d0bd190453f(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cf55dbe1cd1cad9629000d8ab3d3a70fc2cbbca62195b4957eba3438cd8c2f5c(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2e6e15a1365296ac415205e5fb366a4e769dae6c0f7462f430683bb2ddc78986(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultUnsharpMask]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d3e42a40024eba770375138b174deaaa1833cb2314181dae9bb6f97e8cb0c953(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__413b5255c9cfb688bb7dd843f608eb4b8fbe13784f5c8729b8314304a68dcc72(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__08be03b86b137d86f66e771d7caef783905f17deb403a2ed17d8d2a760713b01(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c12b28065135c7894399bb944b065684af05305c4d93d1d3a47d3e29b7a2b896(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d61d13564021dc654617c7f2f549e6b758b73c2e04c9a243840ca163c8c6276e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dbc4f64de33558eb4401d096bbf39a1fd2924a492bbe33c99fb9802d7697b926(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__169175ed3c96fca2c095d5d8c574d07927d46f4b270409f5806ec497a935aead(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__183a44e0a52189353ba3e9861e24820f9ce4dafcd710c710c5e7db81f56b29a4(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionDefaultUnsharpMask]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__714db6d92d62932d9650997a9e537180a27473a2832c35d16e4b431e774e040c(
    *,
    background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
    chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
    composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
    compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
    contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
    goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
    max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
    opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
    remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__28ee60e73c1ae64b10b3676c1bd3f583c52ee648610943d25c6fd5dbeca1330b(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e4cb7311ab88de689dfeac825ef1906a5a1fbc059b2b474936b7fdba6cfe496d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__895bc430c337e93c41359276342fbe371694d4f30ac33f601f272e4361172608(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__224644f2fa5608ce8c46407bf32733c3babafd2566880ada6631761cd0b503bc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0303b81025d16be70714a0faafef215cc86e87e057bf04d47dfdb7da1a5ee358(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__17f24d22d6029cbd5177813c9272a77f5d9f77d853f123391e2a6fdf6f87b14d(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ec51807209f48fc572df0d3840b5ea25d65c5d6025f7f5290382d41fed8eb1e6(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualBackgroundColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cdea54a1eb090bb539e2447335bcca6ab50970514aa1fc41ac4dafa5cc7d9735(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ddff6e29f3d3cdc522fb1d6435577c946736abbeffdbcf27d20daf623b045966(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__800f8ed1760451e86aeac00944cb8b1b5aad018f3bf40bc2d451c8479b8b8fcc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__57ca41f4a7de175f66f6ed4b8ac56826e219f5b20f053497e35f955390a57e1b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualBackgroundColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ef4b35d7b0872db373545205ebef791bc0448ea8fe1576e5a9991cb19f91ddf(
    *,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cb9143d125a559770d39736b9f2e84a25a97e1f24ff6992d662c1d713b304703(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__43ae67d9845dd64263c07060b807153f4ced8065666832b38216eee16f59a10b(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4da296092a0f0fcda4181580a42c605b5fcb395c24b2d051a6a851c87a1d9f0a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8e012f815153f3cb8719d15de97aef9ae9a067fbc04692764fd04e5352ad0fb8(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b7c96167cd9773917db32ad88e2c3ae5d0dbad8c85d0e7f2b638de7ec4170f6f(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bab6ec97d44fecd1d5ecbba635140a92e63e03ed31cc1b39d9253d9fef230f94(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualBlur]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__81b354ab3a830ff71417c11a12735dd5eeedec3cf804507034b8dd3af1461e24(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5b6dd8c640b320b01b61c417d00b7966b4830d442a8a1401ea2f3fefb68406a0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1cb82cc0c5a1588aa3cf3225c0ba1703fb8edf9bda604212f085e678726dab58(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8993dc42caa8a09d5886b3a0a8ea66ef11ab8a9c2898e3bd3b2f9036ed905748(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualBlur]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1afc7919a90abdb5fba3655fbe71a6178756f9fcd86da00f67977699efb15b04(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_feather: typing.Optional[builtins.str] = None,
    hue_feather_var: typing.Optional[builtins.str] = None,
    hue_tolerance: typing.Optional[builtins.str] = None,
    hue_tolerance_var: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness_feather: typing.Optional[builtins.str] = None,
    lightness_feather_var: typing.Optional[builtins.str] = None,
    lightness_tolerance: typing.Optional[builtins.str] = None,
    lightness_tolerance_var: typing.Optional[builtins.str] = None,
    saturation_feather: typing.Optional[builtins.str] = None,
    saturation_feather_var: typing.Optional[builtins.str] = None,
    saturation_tolerance: typing.Optional[builtins.str] = None,
    saturation_tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__96b0fa4da39472d44ad271e2b56b3b459e0868dcc95ccbbb66296c2cd07d246a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__871aaceeeb901a3c3588764ef9cfbfece9e45783b4154c2d051d430950edd2ef(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dd81a9594cd600eee28c39479a6b0f9cde8214d36c9809afe7fbf905f70fee8e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__03401fb24cb842d6845ba99d7afbb46103fd9761e136bbf980b6723eccfc1aef(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__47e667ad046a2374522149c9493056f7ef83e1508f4a82fc6c9f8a02fce63fa1(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c5db70c606c4341d4bbfb5ea0a570a1cdc14239831c3915e8af9f08f52b09a87(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualChromaKey]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d3db47f5d95c2f1b2c46c93fe0fdc294f45203164eae95e86b11231e269255bf(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4f3140d66b25dff70847af7a4f3af9a613f57893ef463891ee9ceef8bec4f781(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1d46495f6efb7fb83b2151e067b5cca676253d3a6c7563bd873c67aaaab22116(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__583449708ef640d08e3e6bd1df7599d48584ad10dca6d9245d3bbadcfb97e017(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a6f9ba463dd5a2497cee980553ab33ec05514fe2a5d251c519f403231a946e9b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__082dcbd12129a63d77c0a128258e5f637f784db9222d47f3505573f1f644e4ee(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5c70358056ffc41e5f7130fdf474e7a702f1c5c13b4fc762cd21e28ebe15b204(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__68ec33b6dbb2307b39e9c575386a15a741c4319807d58af3966678dc87000bb6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1fbab38bf4e84f1a5a3b67ef1669fe8aa5b57d56177e4b6713feb1e3d511069b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e3ff7ac82e45d9a0228d0b29acc23c1954ce264ddda935b70d94dee2c0f7198(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2c4980e69da5522c2eb54d5819345d390366451c89ddf987471c9d932a592ad8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__365ef1ab733744abff1dcb56f32eee38e2e2daea95c17f2f3c84f83708432785(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1cc313b3f3f3680f9ddd55fffc337e8993fa3c1e14066dfc479f726f3d2c80f6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dd59dfc3d626fac2c20f1c0a7124eb359676a9de98f92454649077cf71f02683(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__39ac58a305c65a954fd5c053e360052f3358da4a60ddca80016c520adf70f669(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9085fd0f6468e286051e80c9325b43c4063488906dc165a91c5b5145b0c50106(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualChromaKey]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cb3c50c0c33ae937d52d1cf9f3f4f1fac4e1b17ef9f0f1b7125c4dff06597842(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualCompositeImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    placement: typing.Optional[builtins.str] = None,
    placement_var: typing.Optional[builtins.str] = None,
    scale: typing.Optional[builtins.str] = None,
    scale_dimension: typing.Optional[builtins.str] = None,
    scale_dimension_var: typing.Optional[builtins.str] = None,
    scale_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__94d92e97b693e46a0d18bff4c3104280f3ad2d9771bb166d8744b317a8cc27b3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__239eb977bc26d0bb13e0d9bf61ef56bdbfa1f97e54b2e5ac62c6488c52d7a53a(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualCompositeImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d465f3a648b3287fc09d5867b3942cbd2afcc502fe9a5802ee6792b16f391536(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__31975ec7e7af03efb1d870bf87d3b60936d80b3afbb01a4d9452989058cb35ce(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4e0d56e5bde4af3051a346ff9209fa701a8aaf2d9a1da552f8c343c560dcc3c0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b8a3a3b323844194ebd2fd95209324d3973ae8c7dc7d1b8858fee8f747e9e2f9(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1b697d1b4be389caa0b7729c7c65a0b680fdb0db575cc17c470110dd55860bf5(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__01cfcd4a55e2f265a266c8ac11bf89e3f68d5fcb2c33ae62f05e9f3efe7e20db(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualComposite]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9b34e52e56ca972270e0dcc5d2f2200c682ae0c4bff28604b10486d72625d46e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__11860cc03b74923824d9bdf6dbbdb6b0b71740b8b9e609ea3fb0a15d7729bea4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6224c71b1c8484fca7710a633c12d262c25b515d2e004842b2a1d3653f94ea04(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__035faf3c91886ad1d2617bd16a3926c000fb9c7e12bc8afd28eb41c4fcd3a4d9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6452597bbfa4a0f01108b73be5ac81d69b816c951957669c1f185b37dacd13dc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ae225ada48b2d4fe6a9402974c085ab11af186f4ea508ef91bebebbd2614077(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cda4b8853d30cbe7a63dba6e6be913d0bcb6264d5daabc7d43610b08e286c716(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5a469244d1e0c34a749037f7a86d4e4e59dddd062e5ba89fc7a39e9080ad1fcc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__68f1970a39fd9032af0d80098d004aaefb9cb03c354cc26275af2f9cf193a997(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__52aee7ead20b0e6db0ae181a33d47f366704427b1471353f5c9a7ff7f90b2bac(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cbd361e96e867336d70ef2899ad79b6c955ef3eb59510879d43104907ff41874(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__29cd613f5835f6d4c8a3affb8c25ea09c2e50658f2db9c195a4ac5062b52e5df(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__84517bd99f0078371a95f9bc928279eb2e17fd330780d85afe6c91ec2d42522b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a6f973f984811d4304f6bc1de4f7b3f977ea87c274b31434cf293c4bbd6bf4d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualComposite]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be22915b789c71bfc2b6d05559b255a03b0a313cf72509a1edd0c5dc5493c4f7(
    *,
    transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__103f2774d0459fa5828747383eb0cba5a67ce358c7e9dde0a1340d7cb5fb8926(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a7b9dd9334ea1a6d7fb2b7116f613ed09cea9eba525c0481269a427f683c3fbd(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__23d0d0c0dc78a64d95d6e1580cb25648224b9a0f2378791757068d97c209dcbf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4f7c798ed05237c4f6bf2f49bd80f210698bbec7d0857525a8dcd47698665d53(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8b599d016bb1fe65993fcf8fbc0a84a4fb85d38c8d010febcc6a2c0cc0a0f1c6(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6476503c84eca655f280051497e6a087afba951294a214d6a54580531576f3e5(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualCompound]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7fce88821c0ea2af045181fff1570a2aac6b8f2f402582aa1069073a46244436(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d346b4ead3e1c68965d84d93856a5a63e14b3806c4cae028144dd10c3646e9d8(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4c2e9ed16ab820c89f92c84e4f97c1eb93a99f636b2c9c0b7f8bbfc50b00efa9(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualCompound]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af3f9c6625b13991ea25f2a06f8212552ada93ec85ce5f5e90e86916c0a34d77(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7c60357c4c625493868f95462ef837b093032e7c257deed8295c3cd58c835e4c(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__65aaa7a49974cab1619ec73c6c2d16ffc9492e366f58fe4bcb97229d11c3c039(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__79c42efa13dc769906bb03158ac01c861e7c8a17062dce01d13a0fb493002fdd(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3efc5956f33f4034bfa8c6a185df4c0e7d67457b88c23aaca0b6f002b97c0a66(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__782ec86055f1e3c35d5049ba871c2742208d4a2eb5321a5509a02c185db5c628(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualCompoundTransformations]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__daeb445bceba8aedc1c1cfe5420e50011fc744f0161cd5bb8b7746dd3961653c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dd3ddad3d77843c111e17338f0a781c738e55ce24f25ff75e41f146456db2d01(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualCompoundTransformations]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9aa7b73535844aca1b07aa69f17f61237fe065241876e5f1bc0aa121a9efa538(
    *,
    brightness: typing.Optional[builtins.str] = None,
    brightness_var: typing.Optional[builtins.str] = None,
    contrast: typing.Optional[builtins.str] = None,
    contrast_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__291fa519f1770a374b32ebd7a354974ac15e238ee8ad598982437d7d98621d25(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__381244d4197c1e7f84355d8dc9845d7512886df43dbdade16aeae478c639aabd(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4e3a4e2636bbdfde99b9b648b64b09f368f947dde388e6c0ecaf6e42d0c30837(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e2a1832b9215910703222d449958d061d6e0bb91e14a73a95818d261eff918aa(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1aba479dce6cfd3ef4421e8f81d9aebedbfbdd32d30ae6dd07a49a125f7b842c(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__adccd0cc4ffa67007429a8cca4f6b793ff4c9400ec4e62c280544420fef179fa(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualContrast]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dc59a7b0be83fb01f617d799332b7a8203795984b5664f7ce8672a97b92b6a9b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__181314c97de1b15d64a7150482e4c658479b707cf06d4479ae4b4bf1c334b16b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__95d0605f0665a46d9fd0626304b169adae4ff888d0cc4e60d7d9f782d2780fc6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b86c15d79f74ad3f0afeb4f52dbc925e19ac2eafa81ebb8fa6d777118cce0a81(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__96f778519fde9b668224b663f15aa570974e1dc396a057cd336e99a8c507b426(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__99df597fefeb5a04d4e59a7a7ff1ed13a1e8f736eb2c3f5b202ca9f361bc5896(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualContrast]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd1eac37260eec4d78ec8973b3c9aa66b757d1c9f78557f25fd48993888ddc12(
    *,
    chaos: typing.Optional[builtins.str] = None,
    chaos_var: typing.Optional[builtins.str] = None,
    density: typing.Optional[builtins.str] = None,
    density_var: typing.Optional[builtins.str] = None,
    power: typing.Optional[builtins.str] = None,
    power_var: typing.Optional[builtins.str] = None,
    seed: typing.Optional[builtins.str] = None,
    seed_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5bf08a1d505b5d2314ccef724988a6016c994e74ab0d3f04425eaa54080d4826(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__216e9be505af1820bb4c7986a3de14a915a8a74496f92307266c5c76c5d6838c(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df5113ec6c76f1b46d7c67fd5aea109b51d4ae7ac2fe4219f2bc2def5167a42a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6aebf9842753f7be5c36617ae71ec1354b2d328ae2568fef3d466eff7dd31532(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0b375aab7dd0befba34b8b2123129425451130f6e92284037eb6873260ac8a7b(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d07ded153aeffc6126d766fb21f441873742ff83a08629d6281b83f851f0eb28(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualGoop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2fd5deed8cde82f273e058a454853de89703a941d1e141eefccbae11343cb815(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cae6b2a1d0d448d67515ae5e531ead9b71f62bca0f9ee24f57fdd2a51689fbf6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f4dce19edea78e7944b0932e8b6d1c98b346f180cf1b4b3fdd9a52d2ce3a759a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__642422318c74915af2b5acf732fd299eb5e734b78555827f0bebc5118514419b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__37b63a7168ce44e917ead07d01be3245428ea42752ee37956d52cdd2ec0e886a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__841e0e80e18e1ff1dcc10293bfd0f822646655ac78c4eb99881870db8097ce9c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aafa200413bf3b604855fff1b4c746bc12455445f0202a133a769a941d53b02d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__836afdc70d955c7f05b1bca90a1d8ca4b52e80208ea1fe55029c119279a5ee16(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c8d057171738285a1bfe71700ab143ffcc9043ab7e0dd05662790856fe0e444a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5a028f4136b406cf2ed6a8639af42a8cd21d3d4b3c227178ae9171a455f4ca9f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualGoop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__768bb36849c37f0a7abf76f3253c44e0529fff0c4684adc90b49829477e69a7e(
    *,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0b0be8943257d75a5b0d4819959dcb26ff6e5716ca17ea0f29debde981748ab5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d6b9abcd438b479b9c68c870d6953c51b5a22f8c3d6df3c75c8fc00b830df1f4(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b14eeef94716df03c4895b32c786256e77ab256ac9354ac10f21d46f00612969(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0afed56edfe79055ed1672e567a6c7d3bac1d814432afae48d4aab734fca852f(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f20e31572ce9be6bb4734e4c4fe22f8342533995dd6f6d094723e2110bfc7776(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fc5cc84256d36c39f697ffe0580e92f8c244a9c7d38b081192214c59a4bb3d42(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualGrayscale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__573eaa1a9990d0d35f0babecce709552db76ca78af3f1cb0c4992d4bfddec81f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__72f656d588695dfb9f925860050a40f419ce85befafedeed060e0f4267a6f566(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a5e9cea434e68fcee42b01fe9c49b2ae7363345696f2c033e1709a444f8e8a5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0d3413a288e4ae7f404fa64468bf7f0cb6713b411d59f3c3dab09684806a3d08(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualGrayscale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__77be28c69c937ce70ac165c61e4e9caef0079384e9243fa6d1310fb1968d962d(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness: typing.Optional[builtins.str] = None,
    lightness_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b817a6f7ce9300667f4eb2f35aabc2917e7cff993329c0b3a8aed1979eaf5c1c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d0e54e8dc921523bd54627f8ee4879184ffc44afce30f579e5bcfebe9d9efe34(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bbeab4d9039e71129e188a7a525095f4fc1d71da8ea6a4d37fec49a2fb66dae0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a69108b2acf4b41b16755eee61469a37e85fe2dfef2207874434958fcd8bf998(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__15fcad66abebaa5d015599d7ad585c82313e7c2c36b78ab7ee3faacd9b13b4d1(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9be803193129d0515f2c9d4d0c14da3568edef0b14d07e74da7a62bb7638e560(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualHsl]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c57db13c6477b21d17e1affb503845231e57586e864b807ffd7d78b43aae2957(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__837e56bd647cdd3d6df53c9430121a46e85292c828070e60536d08a9757ee0e2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e7055196b684331fc1b166ef8207533394bc7096c220cf680902eacd10f79c5c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__92b0e7fde68dbc7ae58dc9f23a62816c88b6bb9e2e22606b53bec028190c2195(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a642bffed09f6aee8b97817f9545e43cbec8d082336332fe7eee36f7b3ed0a93(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d7940ed52a8286ef5753f979399f08f63b29403860268c940c9fb744751eb64(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eb0260b95dac1111fdc51853d93f731383f7090279f35871666da6ea18a91f56(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__696fcb0cea0ebaa6abfe61954d44fc67e1444381a01659de87408ac4265705b7(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualHsl]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2c6a2d02aa0df46194e1be3a928b53f95fde29ceb8610e73f0e975e15a613eb0(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2c6895c852f359124744749680ff8172a9aadb5e88c25b832c3929d84ce0768a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2e0cbe23b1030fafabbaca0dbf0d5aff9ee3e9446989294ced12f217849be4bd(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7e4a22ed462e51657c70b976529eb2e6615bf8cb26d370cc9ad1e8eb96bdba0b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9300df89127768058e2ba2fcbf472c763c88c65dc0e6de3b208a0e777ead56db(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__85a9c9393e8c55495bd2183067625273b506b81f7d9e63fa34a634ac05c554fd(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fa380b656ff32c653fe05112592201d22ab6a5ca3679c2e872863fad95730fd5(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualHsv]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e54d615c8190627633c290f7ebbfa886fb8be41fb48078330114b01df96d4f43(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dfc165291734a8360f3aac235b1b50b191f7f6a79697af316413f208b241e008(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__59da591af9bf1f77bf3b4c10dfd831a3523381efbe35e78ca81880a557f53e0a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4253d176f8a0aa0e6bfe9afb6e1211dcea590baa7710d7f246b57363a0edb809(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e04301a64a1cd327e288deafd6509319ee2993f734f9a77c237046da599bd0da(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__22b4e126e1e7910e5aa74941eb809b70c40ee87e631b3f0dd2a1fa4d663f7b08(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__70c3c8e08cddcb8632072b956306892e714a244fac128177326edccb0241403b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__36f556536d42b6480a3f3ccde2ddcf0620e6b34cd2cde094645a529a5a488be8(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualHsv]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f5ff147915175975a146528304a1a0edf2e5de367dbc2cb4b1db3d28403f687c(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    dimension: typing.Optional[builtins.str] = None,
    dimension_var: typing.Optional[builtins.str] = None,
    equal: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionEqual, typing.Dict[builtins.str, typing.Any]]] = None,
    greater_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionGreaterThan, typing.Dict[builtins.str, typing.Any]]] = None,
    less_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionLessThan, typing.Dict[builtins.str, typing.Any]]] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6c7508779c7266c691ccdbb7cdff779f38fbb235ea8e86cec3853df59a939b2d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8616b4e2be2021dbe000a44b29c5686731e039d433d8df583b261280e713dec2(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a21f1ba3e63091b3c8c22eb68583749b59bdafa6c32c54c9f31029bff3d7129b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bce5337b44868db80db7e7d09dbeeb5883f55dc6a207917a55f759cea2e83080(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionEqual],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fa46cca0229881191b32e7a3388a08cf12d10f7a8d5b3e8fad247455fb85a6c7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8be6645cf801328244c0ee842ee66bd394b97d4a0732d01914e0052a6cf46197(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionGreaterThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__156c9b73b1a85bad9adc79ae2868ecdf2f5bc900e6a0b57e5f3d0f981c23b0f2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a740e9a7fc53c358ce9ba8cf441f5f6b696c96b19ca5fe4bb00015f78190a364(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionLessThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a46fa37af3ed2ee02eef999d6f05d4aff5a147ffcddb884b48c41dedb190eacf(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1c104075c5417cec21dfab2cd59116eb71eaddb3aef5ed1dbaa548d6e463b188(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__191f2c0e547f72f3db857be732a4719c4a2c9297811b62d8fd81d687470c46d2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3f6d8f5384ef621c7b8ebb4af90719e43cfe4ad96c36f78e808c3d2af89b701c(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__08ae310a4ea60e242caddcba17e77062ea6b353e6b5ca88c0e6b190cf3740854(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aeb9ff97937dc83d1f1d14f2740fc650259e12b7990e6c46fe8531b48ac8b124(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfDimension]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__77df8f3f6351aafc883beeff07926ec295f816a397ae7b64bae43be6a6391a85(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a93bab11396627286ce10104d26084d4f52fecbe0f195918b5b1c932d80127e6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e3a4773ccc20ea17b90f5ce4abf7d36bcbae0cd4dc545b91d5b766ccad909a36(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fd6326377fa554e98ab348d7117f29899adccf0a3b0464ca3b91eeb17fcf136d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__30044ff7fd0ee0456016581967bf6c14f0f296f7d4c55c3d8580a724ddabe69e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2681d09a497679a06706f877fba15fce0d601185f2496ba98cb486e361c801f6(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfDimension]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a47b4a1a3a4f88a76c5bc113f46bc2872613df6828fd41a6e44ab586bf93bc37(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    landscape: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationLandscape, typing.Dict[builtins.str, typing.Any]]] = None,
    portrait: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationPortrait, typing.Dict[builtins.str, typing.Any]]] = None,
    square: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationSquare, typing.Dict[builtins.str, typing.Any]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab843a3740c084cc316ba1bdf11accc3208f4b1e81dca244ceb7e609f7b5b0af(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ea29c79bb0fae685ff3e8297c41c5368b6ef778a877ac73472333dd8204f6e3(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb68409f92d51259859ddb53ec1d7ff9156be2dc89bf66508530cb9ba2f8c31a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9e74284f96bf08926223f4e94064cbe5074ab1d431eaef6e5262d8ebd91b89e8(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationLandscape],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__579df7f84b50a3781bb2c2c708e68b72d688b83bfc501b7294902d4883a76d45(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fc43aaebe3fda95bfd7460f20c220644da810b1b8314444c534b3f534ed76086(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cf82d046ca4b1a41b382a49315bc47a23030b46bdb550362d544ab76f4e3077f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1c25ed2ee6f63ac30a2845b10cf91a64c52a8a9b2159f8ea730b4c73ba857b13(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__33faa2c9e386ec79cb3a4919053787d0b54ee73aa4b550b88dbef9ef748a9283(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__55f316f1d505a9884b395ae2ce70c0a72d5cc0b1e804cc97aa0e5550daa89f23(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientation]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f86fed22c36accbaa9034f9bc7537c21f9f8356d5da5b545e4f0436b2713a8d3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3235874d18390ca89a92c218a8c57126ab08370948d90fce194c284cd93d5813(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientation]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ca10fac9905b2e7671d86ac908846d1ab5ebb614aeb98e38e0cae523c1bb937f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fbeef3cfc2c3b1b67dcb0ee1d62b56406f5a3dc93a062169605e4ec9e20e50d3(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationPortrait],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f3a60da5169db281ac70d6450a9f87c526800ba357cae55134bb2272efef29b6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d8164e1e52a57b28bf2c0aad24cd7116572e31270688190085821c6c042d150(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationSquare],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0a5cbdc2fdbe7a23a062ebb4bf639b5343ad51833f53e7a410b210d763d88f0e(
    *,
    colors: typing.Optional[builtins.str] = None,
    colors_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8b7aba05df2af8fea72ddbe181f256ac98a81685d3071f495fb729b71e3cd9ea(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__535fef9c9a1f203623ae2cab972b66195a36f48c4cc1c457574a49d024a4e099(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e29d5792e5fc3ef6323634c956dfdccc97ba18773c67d8366d9296ba1643274d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a9689a1374539ee2cc1512460b2bd67b3bb61437060a6f7174d9f15a9ca7ea7d(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f02985c56f4b82b63394366d581865a687691cdb1d1d19a686209655cd5179d0(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5d556c065dbe7fd54380e89e89ac604f0a2dff683ba6019788d5c1eecb75d903(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualMaxColors]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8f065e8a2c0ae39b6c9794ec777a7fa60e9b5cb4fe85869897087c813cb74493(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6c5d2c4ccc444e093fa40bd0b77fee8e2b251245bccedc41ffe50bfae81edbb9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0417daf90634fa93254edb24a78cc0027eba15b417e74ef39f02ecbbef08d84d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__51e145c0e1c6b1dfab8023a6d34efaa010c5e480a4c92bdad97fadc7623428f5(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualMaxColors]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5456822da24015faa8c5ce2c9aeda55a8d18d40049d9f85fc78647b15d86e0f2(
    *,
    horizontal: typing.Optional[builtins.str] = None,
    horizontal_var: typing.Optional[builtins.str] = None,
    vertical: typing.Optional[builtins.str] = None,
    vertical_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__709b95d810a6d251a1409923f521c9c2c093371e9ff3c4cf1ba989fb577fab9c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__690929b6013512ded80bfe825656adf8223f6bed3345ecf1a23ca3786d0d7401(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__29bcc6de7d47daf23156ecbff3b1eb257978159dc9066f82637007c80c17813d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__964eae34aec31bff508a5dc4ff9e26c6019b32c0ca2017fab7a2c8a790b2e4dd(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__179cf5e3ec74a6463cc82d5487a7b7f6975a4647c0e799bcba83c38bafda0b86(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c3b854bfc62e3ed9586bb6cfee09b56fa5290af7d0d3d2304acbf84affa30ca1(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualMirror]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e415ab055b62e33628808c4ed46725f17cc8721ed8d79268cba90ee796c9693e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7cd1aba49eba80206582a5b8578b3e6e3b3793cc1726a204bea9d082574e57c1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9bec1e56d29465e3a59838a1cb56994481e919969952d4291e8a7f90b1b4c5a9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cb1e4cd2c7207f40107e8ea92a3af72717d1a2993687ce7729392ac7cb842efd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6c4d65ca30724fe034d98632b399f1aae83b281e38c3c67e8f32a284757c3203(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fcdf515336d313fcffbecd4cbe74c98ec75e9b21d3b7cb2413ac4b56b4c2366e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualMirror]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5cd901db8080a1355c4b9611ea79a5d0e225f8d69155e1110629e9b6942d4c45(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5fd8210e7fa5e4d6f492ac316a396ac486c32f46a172e16666c458a646d7c6c7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b9568ba625865858b4c137a6d1e177d3c3ab05ea5416622647de62c5bf778033(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b305dd7c749a9b4bc91de95e8d599b5b4a9f903a6ffa2724b807ed4e8c9f944b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6cb603c2d7c874471e6992d9c2a4adb9fa037dc1467e680c922007d252917837(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ae24ac170da33fb78b51bc8bf056de18b6430c3f280982f3f37d7f6fbfc1a4af(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__340f7c3dcbb6df28d38f86e502561989509113d1864cf4571aec594037f246a0(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualMonoHue]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9bc023db7084528af83e35660bc5483e23f375802ff0bc532307ccf04307c994(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__824951026a553f91cbb0d5f6991bfe18774131c3043bf73b2c27cbbd6151f313(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aa238b6d8a61012a878f025386d95f0ccdfe61babfb400ecb63217d49b5f8d6b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__63c65f3f296a3221fe3f20855960b19a65a9e19beb86917b53009260e534cca6(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualMonoHue]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a31a010741c31403eeb62a76d0bf212447e238b2f3605aaf56d0896927c0b28c(
    *,
    opacity: typing.Optional[builtins.str] = None,
    opacity_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dc4217d9f1a717e542c13f20225ccc2143a3bca6f4aade65e4451c8f147e6a40(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0d62dde397a49a98b6124c5c2f7591f423fbcb6db93aa44ea0a8225f8e980f5c(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ad6d4d12970f5f1eb744ba51f00f508aebe8649365f9028c520c67050ffa0c04(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0196779e5187ad0763aabd1863f3e6d5a76e8cd0e1d0f9fc0ea6147625bed8be(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8d6a9b67bc2925b74073a55640d42ef4773fe87377613991b5811c7e24fc6723(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b010ef38c8d5fae383e2676c9f61c222905cf73a7d9586028d25e6be99a9a17c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualOpacity]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__332804e7f05abf92f74336e0d7f353b8efa447cc590474d1d9a9e724dcf8d381(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b0e9290c82f0b4f45508aba719b4d30bfb2ee9ece5aec7f780564d4de626428f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__58fff9612e396cd5fb4b84b287a8be123eb5113e3b12aed75ac2c1d4b39c58c7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7698f21421327331e982403f933a07b54277118c64e913ff86961c2accebb363(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualOpacity]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__532ed1c4bb9caf9c6591436cac672a1152508b12f065513af00e5a6c37acd3b7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b9714811fec077982196ab3673abafedec974e687dd7c8cee08f6b5daaa5d328(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2f474cfaac7bc2d9048006da6f22faf40673a5f294d448276f467305156d06a5(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualBlur, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__19b59ccdf880decefb877e81778f48495c8d32ee82cd61f0ee9f9f0e53580401(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualChromaKey, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ad0b97beedf3c4683925033f51f2f235afb2adece4a7fb73a7db612146c61c5c(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualComposite, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5dc82610548cae67fd66fbb5d55349386e65272c9be811d806b3c2da719f7e2c(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualCompound, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__88e5f57d2ed52b2f8df210799465db3fed571934f9274d4e68504bc6bb0cb9f1(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualContrast, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__352429794d8159813b35f4ef8fb6ebca34f5997bd27b352d29970a03c8528dbe(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualGoop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b7d62548d6f5bc7cceabb1982a8e421107ac632ce8fe92326976f9659f0142cd(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualGrayscale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e7e4f8c181cfee63c5a1bef359657e706d97ca981ef0bf219fb05c3e13de70bd(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualHsl, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9057ce1beedb088e8fc751dde4692a9a765dfe4ec76459b430aecd981c810b4c(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualHsv, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__718c4fbe1482994314feccc353417bdff1aecbc079b3b67e8dbffbf2547a1aa0(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfDimension, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__725938c829b40dea3e29828e57449a06bfc5840cedd77b88c0aeaa1f5fbf421e(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7b1e10b2507aa0cbbf8a53c083607ab8b31070a1d44e6df7336c74e1967ab3a8(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualMaxColors, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5677a3ed66c43a84625a970c061d2417984c0b8c0e245f217e8c5c39c2d8c2e6(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualMirror, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ce4f25795f9a9fdccc7e930b5b7b80365e1b2e74d5b32dc1271a3eae16cfd80(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualMonoHue, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6731f3f52e29f653d72c708ef5586a8e094be4015cc8e1ca58c7a6caea39e1b8(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualOpacity, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__54f8c116f414153495551faafb28f5e91f2437ced167fc423ab0ef38466655a8(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualRemoveColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__622874884b868de60520c16bfc4603918abe3eaf0e9cf15a862f6d5f1aad2afa(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualUnsharpMask, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc7bd7331038bf2c667a0f899f242c232c20f2fa6610a6fbca3e912fa1ec6efa(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqual],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__71985494962067235a2c3280fe217d470aa9ddbcff17f0781d0a15841a41af02(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
    feather: typing.Optional[builtins.str] = None,
    feather_var: typing.Optional[builtins.str] = None,
    tolerance: typing.Optional[builtins.str] = None,
    tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d4815d9c6f9e959969668eeebf8ede82ed4bc0614b399c8da09d437ab9e3434(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1465586b77273621727feba9b7109e56c87533406dc7c56a43e8a04a69f3ceb7(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bef28f24e16bc8104bd47f08da0bfea7f07fad58fa0ca90504dcfbc3c8b2d970(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ab2a79980de677e19f896348317d49f6080f11554ee3df9fc17955e04c47a58(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__171ee99cd6849daa972f91238874d9d9f7b99f556d6d6182a5b5e71f65572df0(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__743057f79fe138ddfef44738eb741c565ea1536d9dc4528890676ba301111b64(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualRemoveColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c3a959225e8e3382965e71ba08dddf4c5822f8808d2bfcbe5f6a8a8f17f7f699(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7c36daeff45c64d6871b6c846288184081c90b21acf768e5c575245939b9b30f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__07e2abd680e076abf29277d455e6ba95511c4cfafb07ecc159cd093e4b75a829(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__045df1a1a0e99279dd81ee21b900f055a11e4f075ae3edbb4840477a0846ddcc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__73e30c99284c1a1eb533b4f44a346a688f2a1ac2f4849edbc060688dbe4ba71a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__00d2f0e32f00048455ac6325046e33f2b283fdab176f37209248a008365b4ac8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5bd1e2100456eb654d187ba2d11b51612042b89ea364e8f71f6bd22101ad8e09(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__51b77d2413cf5588e7c17305675026faa30c0e566add76a76d05fefb35dcdbe1(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualRemoveColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0d8791f0cc3e50f7eb0902e460d4b00e9d4a11099f0162b206e4b8e7b845841b(
    *,
    gain: typing.Optional[builtins.str] = None,
    gain_var: typing.Optional[builtins.str] = None,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
    threshold: typing.Optional[builtins.str] = None,
    threshold_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__54ca4c3919fd14c3f49d009db95956b780f762f70bb695af20f5a3c6830c4de1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ac3fda06b118cbe01c034cd5029d89994721a2c2b2c706494083087c1439372(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__37e1526c8c3d7ff239c4320362c21f863cff7497fc99670391794693433ff24b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__72286111ca537f01a0db23c8e09bf4644761a19f693e27ed8af2569029701c81(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__723fce3fd2361223132d6f360f0ba40a8e7ae41d5ac7695954f92b7078e54973(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__276740e26ddbbfc0fa7d385ac38069c9cc20f60e5080a3a0d5ac8ccbb421aca6(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualUnsharpMask]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f0390579e3e5725a939299e83241aa7a984ef05046ccb34347c024dab41c49ee(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1417520805af2cad5c2b5e0bfd0ac8381f1f9db2ea8ea6df9cf61c2227b2ffbc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eef953665f67badaf1f891173fb1250b76a7bee2656b5d0549e1a17e789d0690(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd35428ff331d33fc375c92caabc783798f7f520e5175112c6d12ba214d07250(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__65a96f7b71cc1854765fa532259659f6a528ad464b3cf4710eb563762befd946(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3051fc00e5cd7e3a517228c20d28b13fcea69a98b9fa7c31e26a9d34a17beced(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1c3a7c8b86aadcd47f9a84383c609e640214d5a9dbbd9b9474ac737f737c6b5d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3fb98fb40760713fbaac2d5c0023b89bdfcb7328d4f827ced06bdb597ae33025(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionEqualUnsharpMask]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b4227d89ebc7005d6e232a71363e85d6a0aa7158b489a037ef3af5b12938a9f3(
    *,
    background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
    chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
    composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
    compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
    contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
    goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
    max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
    opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
    remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__839c7fb0fcef0ba37ae7166001cb9591e6fa18e0d73a9ca831b997bbb6b247ba(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5e222592f4da633d7051c47aff6e5e01ccedd48939d04fc5a19c8744c63ab6cd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f1b7b20f096d725a6b83324760c80c743431558fd58bd8eac25706b98c8d601b(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f7e70c30474a460fee63d90ee12dfeb5087ecaefd884926e6753efd7f5715d08(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7b6766398634d2d5450a85df2ea660f10d6e83707cdc306d626e98e24e8dfd04(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a0867f2dbf42973bef6dd2759034b907cd29c1e79734fd4e9b3ad2a4da941d18(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ebda05ecb71cef1cc4c2a971cdb2472ec077fef5228dc01dfbf1b38d89109474(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanBackgroundColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__21e2ad684046d73af255e8de8031e4cd2d6f17ea132d149d3b7e39be502fedbf(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__16cec6d12ddd165815b9bf7e2f7dd452159b1e57f6cbaa11080a4e699b54bd5e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dd3a697feaba07e64a3ef0a5678f751a252366fc48be55600ac4fb5d240c8b57(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__250a99e67792de8b6eb225649fffe920afaf94a2915c158ffc812aab9d45c6bc(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanBackgroundColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bdc3a1b72a3644fb94ba38439dbab47d72e0a47239879c738ca20e54faa1359e(
    *,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__65b9c400d2bb78c8f7b6926dbcba41c0ead51cff802b903efac6f5ad4296df60(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b20dc3b0a6ab83df3c3d6ace848957f0adf61f7371ed6844c90be3f7201adcd3(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ed0075c582d494d1e055d3c9884280f72301a56f0db575036c5996f69207fa50(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3e505a7b231f64e987efd939f4036b835716181522d96f824d55d689300c1077(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b9d5a22d0be0f7691cd942036edb6c700720c76734b433e839d11128f83cd082(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__71b2cf0a727f6f9b6a3780e86f7247e3b54662c92d61bd14c0ea61ad207a1e8d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanBlur]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__21984b299205438d9a7529c5f44f08e42987e5f0a0b74ec6ec77f3fafc6ea2e7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__29fcc7d5b9d196a5474d55cec60eaf7da3e4edbe4e22e2c6dbb84075d1f2a478(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b4e3d0122f6dc3a78b1d5a9c45799ad5e26e4b52637bc958d5059ebe27f7fbb3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d3808fd9a439cc28e06931a1e5eb8ff5ad603f3d207148e5d72aeb5aaa03041f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanBlur]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ce1122842a62cff819ab28039008a3e8e1dc191befec46949a0c526833ae6d9(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_feather: typing.Optional[builtins.str] = None,
    hue_feather_var: typing.Optional[builtins.str] = None,
    hue_tolerance: typing.Optional[builtins.str] = None,
    hue_tolerance_var: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness_feather: typing.Optional[builtins.str] = None,
    lightness_feather_var: typing.Optional[builtins.str] = None,
    lightness_tolerance: typing.Optional[builtins.str] = None,
    lightness_tolerance_var: typing.Optional[builtins.str] = None,
    saturation_feather: typing.Optional[builtins.str] = None,
    saturation_feather_var: typing.Optional[builtins.str] = None,
    saturation_tolerance: typing.Optional[builtins.str] = None,
    saturation_tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__396f1733b73c5e9f98a4112095d6b23b632a6c728cb50a40cd297efa2379033c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__09d4f4b94653f1f4b81efe71fec7f6e1bdb66643ee0c73e60283f9879ef7dc12(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__61a3f10d141ef2e663445bb7a5e7b29a9d881335695d9be0041be4e21d2eb116(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ca17349b965e106b81d83cad2aae4318a48e388463f0538773ec71d45d54def(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ed424cff5fd67981524b9616e4176b8971ff802795127960dbfa1c4e0e42b4d0(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__135bb5a149956fea15eddd435e287aa19ea5420c78e7b76623d5d7ac3a3f0ca1(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanChromaKey]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__70d0566d4175adfe35385a48b3d051a7b1d44f5f67eff8738ebcdc9c1c23cf6f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d4d303667d0b4c027a5bbb3204f545a4da180b189275ce43ffebafc14b756437(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4bc048e3025845017d5bc3a3cb6c711d4e1be0f9a2acde96139d48a0eec57ded(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__171428bf58267c827fda6b24ec8f164bb23b9537f964a4759daf2cdaaec52bc0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f51cf26deca4c664bb41a93c7a9cd50d8d6a81af655b53730de77cc63f322af(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__81798e8b12302295f3c640bf82ec2173448dfc0b657387e3ec9f6eb8f915d25e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8798e265c3a331ba77541a68761941fac40432c6314e1d1c5e1ddb686aca06eb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__58f3ac80238fc82983a439895d589b2a52b0a012e3dde5b7288ab920b22ae744(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0fe6c89f2677fc482e2a4f3555dbe65b8c22d96f2a946150e877b2056a5cd8b2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d38b382b2e9d699588326738971b2c5f6e0ab0bf370f1611481ecc335964c48(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7996d436961e7d0bda6bc069db286f1eb81fb7e64797e0aa5102c06d9715f6d5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f6223120cce3707b899168bd73ab5f73aebdf4ca5b2fd159331e553b550422a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__929d58b3b6373049a4aa2912561ffbfc4f8a0ae7625b745cf86516040a5cb594(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc4dcb1da34e4526ac62eed4682a6286b6426c0d369bfe0d69dd61699266d9f9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e1664ec272af27cf9bdfffdf92362c3da6e8f5c4af93e64b848e81e86629249e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__608f619dcad6b4cc56a9179b5f0de9104ba02621dd93325a9ab700fc916c180c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanChromaKey]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__894feb7b1c5e823098e03a3812a49be59ec9cdb18fde47caf19e52d856f47f6a(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompositeImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    placement: typing.Optional[builtins.str] = None,
    placement_var: typing.Optional[builtins.str] = None,
    scale: typing.Optional[builtins.str] = None,
    scale_dimension: typing.Optional[builtins.str] = None,
    scale_dimension_var: typing.Optional[builtins.str] = None,
    scale_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0eff61400261b693c6b6f694e0c10124012f987549ea45fae48955798605d53d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0754b90503dcddf0f1d56d9a30cbfea676034b7bcabd196f572c17c4ec82e9ae(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompositeImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__51e7271ecf0728b5464f72d2d5fbeb714f7e07d8d4fce10863c9f644b90d706b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__032731e869821a9ffec284dc7db0b9dc75c5a3e382f540467ad909b283ff521e(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3f7d1a5b1715cef10d101b23768b5624c0b8b1f69ac06a3b2eb8aa6f954da31f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6688af4e4c72bb101924b4bf7867c5ab6b2cb135d9cfe4a9dc7c314f789724fe(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3e1afebf1cb9ccc795dd21d284a979388892ec9b86f19fd7e1bebbf186adb345(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__968b8cea067e4fa47c644dc83e2d4a154540808e0fc7bda010dd10c7cdc0996e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanComposite]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__513a71a6ef6a38703100356b8a6e4e1e2b6ffe6a5db4fdcf0b3e98223f842f84(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__10f02062dbe9836c32fa0405e8728db3f4f042c81429bfde2dc6532bce80a0e9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__61227858770dedec14ee63a69c2b16fa5ede2cd73f6a0b3f15501cf3d5bc72ea(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a4adfb42cdd80fb0c7768728fc56446cd9046c5481fe7480f2d10712c5b563ec(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0692791683c4e03126ca80a4ecd89e82077f771febe53ab9b03b57475e4f900e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__23f35b2d8a5c5d7765a772283cb88b237bd66486662749e9e725b9af2da89d94(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e524dadd8d5bee20c64e08c697edcea3028af1d648e0a4099a6222114f2bf4ee(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dd6c6919d94727dcf59b01aeed288cf590a97c01873165dcee2aa1de70282e8f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3e01951f6f196ab977583dfe95712993f9cd3abfc5bc669d8c50874dabd8c3f7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bf6619c60441388fd554ac2e9d6507e609557316b3b3db6a3fe62e7402cf6fb8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eaa0c6863e725c0bb3ae5bb31dfa91a62fec9d479fc8bfc63a782031132a08e3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__70abfa2aad4313be8e4336102b5d50b8db82a8926e95193fd18fcc4879d906e6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__706d4806400cf5391e68521ba689d59f802d7c6007b700fb5b3eabf85fcb74e6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dbcb18229050c55a36bdcd3e87ce039e780fe9fee8ab9703634198998a5b3c24(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanComposite]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__604031195322dd7bb84e4aa2d48297537dcb07fbf5e4487025ae7eab6ddd8383(
    *,
    transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e3ccb9d01f3e3dd30cd47112d75958296f03321b6089b1622e1b0f6226fe832d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__89d1457693f20cc69dfc7b7c7809ea54dcd998a61b7855343a7f74c65b66bb5d(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab2bacdffe7b13cd77ed714b87066530b95e92a434bd691fd9d96cb23dd42257(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7e229738236de31d17ff2c0b4b2838232b7194546ea9abec118c9ff0345ba18d(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fecf5d2a0c2bd81381971964ae002775df24800d8729aa4de51eb076f01c8cf3(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a642608eb18d200e61f901f1968c858b363eba525d06ebb51e0d94f74a1acbdf(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompound]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ff344150f5cde543bdadca0f39ed4db4da60565ed1239ba678dddf2a7abfe723(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__108f50edee33a0c50158290052f517954c4c1dee6f8ed7daee3f9b59d8e39779(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a729a30c11ee1094bfa9489262b4aa8f736766a985727302698858a7a135ad7(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompound]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ebf661bd4f6c22ee29fb160a4b4070e157a0e1e1810be7d0e519296b7f0c292(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__590f31194b018ebf2d7fca376ff5d07f79380d7be2c6481379e08dd425b2aeb6(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4adcc617c5a3a45fd1986573a65deae9478efe9cd8758de5c35325b1ef344573(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__38691ba093452162d2e8980afa0e4eaa792608895d8df7c198cf9f5fcb11f2dd(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4d530801ea267def94e65ec9d6b212a45fe644a366e972e5b4860271c8ecab17(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a1525059a4399766cfe04865d8e5624c6a453ddde91670b4b83bc0455cb563e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompoundTransformations]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__88a53f86ab4a5cb66b69550a88fae5baf6b23e4d8170009b9a8bc1a1e6a8afb5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__61adb0c142c8b3e1704eb261c1c7f2cacf28c584322f2f34d1df62d94ec611aa(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompoundTransformations]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5eaa34ede69f8796d551440b0af10db5e6d3d8748473588019c19aaab84d188c(
    *,
    brightness: typing.Optional[builtins.str] = None,
    brightness_var: typing.Optional[builtins.str] = None,
    contrast: typing.Optional[builtins.str] = None,
    contrast_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0841766f14dd938bdb79d79e70b6640bb6aa51ede20ee76c771f97399b667421(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3cc3489e1e1833485bf4b717ede5094355a6512d94cf872091cd1420bb90616e(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1dcf052b54f2099654c2c85a7b76e522228437357d0041b8ee16766b5dfb6faa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4efc827a16819c40aaf19712445f76fa82e447b353d95b8327411bbd5228944f(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4d75ffd5e68dc7354e96df31e0007d5feae6290affd3cad1005bf1fe7fba10ef(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__576b511fade97fb3a613cadce84998feeba31106649580ff6a3d5eab5e4a15a9(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanContrast]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a6c14695a3f79e1d6029ef7012da2fa04107efdbbc80e53469e4c343e4a290ee(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b947339285332054d570f287c81c868e59af6a6d660e4ef84fa2fa4bb1d39220(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fb7895036ba7432021a5220b93eebd5834b28b8b8cc2d723e4f0c437afa8633b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__da39adb2340e3093bafbb9b07038cb89408a3b67725943dc97cf2c06e6e42602(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d67639a13a542b95c9cadf43bf09c1075a0bba5717a5faab2df56b8e0caa77f7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b2cc9a4f9b7363fa74a55966d1c16fa98a7f6b60ac24e2b7cbbe9aba7311b9f9(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanContrast]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4347931dd64b5ecdbd9dcc0b7017f75916f70ccb054f9dc7cba453a72e9f6284(
    *,
    chaos: typing.Optional[builtins.str] = None,
    chaos_var: typing.Optional[builtins.str] = None,
    density: typing.Optional[builtins.str] = None,
    density_var: typing.Optional[builtins.str] = None,
    power: typing.Optional[builtins.str] = None,
    power_var: typing.Optional[builtins.str] = None,
    seed: typing.Optional[builtins.str] = None,
    seed_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ab6834351fb0bfe1769f4034a1bef3e93448f083be80e5a2df1c6922e9f0513(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6364f3df8adad0ef84f900655f3f9f4ea08cfbbad1a04de74a1aef0a9d94d039(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5a977ca393c43a1e87bc83afcf895ececa80234db7cd9b4528d1be3a7c5cd4fa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f7ba748c2ea09732a5c603d997a8e5a20dcf3f8b21d97863a4862c3f44bfcf44(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cbc430bb7720a52477a8fdf6a174417ecd351fcace9f5725525b8e8c9ccc73c4(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bbc7f2a6aae4a05e6536c1d47c40ee6103b4e741d2f16a5942a46a33ea76f404(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanGoop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8ea9db087e9efc705600f26fc7644be76c9c7d1b93cb303883962c8dd168614b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a7a3d25e03030cceac13a27b06de0affaf45d2778b7c91948ec43ae6c6045f2c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__19d958caffa55ab022c99faaf4b559d963a165d9765731ebd3b80384792013f9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ceb56abb24686cb454d0cafb6594682e7baefbeb72f0a8c4144ebeb24b2fcf40(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8ee13cf0686de8bfa7927cce1d07a128f3d2f8118280f27f88f77533d11e2578(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__424b60e1d9992947836c021ce912d6848d682ea0202c8fff6a8e3e24184ec4c4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4daa31315cba6631f8f5c80f8567bc435c943ea3afd9906b55e63da8cc2ec709(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0a3a0deb1efb288111f2fff90b766f572ccdafa27d246f5841d2da1527d71585(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b344881a36a6ea004d59eab8b579fa1613e50fc6200578be9e8891700450edb3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d64d635ffd037b015972ac5f25059853415f67b5dd770c059e9ea36a11bd24ef(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanGoop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1ab5da82e8f78dc654d9dc692dbd79562f07bc51cffac89920b9ce25a0aa9749(
    *,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f573ff2254d6bad66c8d7a1af6a70512aa59f283cb51926f2d76a33d22888f01(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__170433e2ad94add7a7ed5ba980e17cf1c6cb8deb795ea329b02d85af5e1fe59e(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__81c01b54763a205654d5a16f050de5551c5fe6368544076ef7556df5d81ebc18(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7b10cb618bffff2b978dcfd7c6736889e6bf78c353de4910750d7505350605fc(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d023f4458323604263ac34041acdd60f2f24787fb7d30e95ba0adb48f7f6dda7(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e64c2814271464b538e393983304d83fcb037da99c251bfb6898631a3f39987d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanGrayscale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7ecba19bb2b4a8d7f7edfcdcd10850060f224e0fa0d20a663611047b39934984(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0133894af960f4fa279d8f3c37364d652cabce3394d2f9e660962a65d0451e58(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7b560200e14f17bbe7908d4c77ba2a2a7ebd1f39b5ab76fca7db2bc81a4266a7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9c6984285a450fdaadb67744718473fd05e17315b228c2fa75e074ad4ebfe81e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanGrayscale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f81d870bffb06c4cd1815c49e39b8402c4b771b3c2e07d6f802bc4afdb86906c(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness: typing.Optional[builtins.str] = None,
    lightness_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6c04a071d55db0db0082793247811a2d70437eb963b5878a676f9467ba65c730(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a7dbc3af32a5ce651c777ba0443f905d8b920fa9a958163577eb98d1a9f43f75(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1de5eff344eeed3d20e30a776498746338b83d971794af25988b43ffe4f46379(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9993b5964a8c718abbfe51a2bd368cc1192d6a54b486051a6a302a1dce381214(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c75cdfcc94c788783b0691b60e6bf1363f7b0c2409d2a261b377e818331575b2(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__73901231584127c9b179ba35d6cdef171337b18afb31f3cd0150cd3996b0bb8f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanHsl]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d8203658e68745c524ea6b453183c168e8bd889a5a62b0213e3adb520c72dea(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5923375334d1e247e03d725fcfbfe198115be567d8622fd1e1fba79ddd18976a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__707e5d68727320cbeaecd68984d54fc658278fd5f1d5c9338a666b26bc907984(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a59cc3a157264bd2464dce8c96073043e3dbf877376364173fe369058fdbf98(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4af75fa20cc14fc3a1112eae6deac1bb1cdb89bf38bb09d7089922ca9e14c3b8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eb1027433d6beccf7d97619cfe53a12a0b456d31d42ce0f5c2341dff9c44afb8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a8cb40028dfb25f2b37ae8c0a3eb8402c5751011ba74e991900bc79c4f3cc5ff(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a0ce6918eda7b7a5a517b6b0db93975f04823106b4d38b63310798264fbb5f01(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanHsl]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__366a89426c52078fcb972f44c1fbe201f315728fbb4503b31716f3097802b7df(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__17c88ab2aaa8658be20c722e2dc9307670f7f4f0f462eaeb5622b3714e17c02e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a0c0b03b57cb0f7bda386e42796c480dd74a995f84b1b689fa033d2de73db14(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__797735fd45956ce1dbb93e8681fe63b5a459cb84f838e60899125ed07e0d7112(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__383e5f19270909796012de82290bab950df8e7088a35879c4dcfe19ebc77960a(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3c172dc27eb946bb21a0110f8723c63cf5918cf7b9b1b5028299ae3be1725063(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8b2f8beff099bddda647732ae6ab9d7c01eda7fe54767258e9768022a18ad1dd(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanHsv]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a5274b74883f254aca25613772cf603d2794aca094e3b9f86410b0a9744b3345(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__65ef89acc2cf0d17ae6d561c3b04af1af50959edd93ca2a6ecd4f234e156699f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f3b05aae5e481cb37aab2baa36cd894a5a1916a918d7d768c26ce98cec8d09b9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5b10fecb7f11159dbd86edcf73afb5a4ba664e227a04543e82b9d40b15e3fa45(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e5e459a355bb5d6ef2b301e97fcbfe58b30c7448b018feb2d5575d69d762a701(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1df6e68bca4779ea2754312bfd33abdb8b61e5ed26bdb84b9113472c1b072951(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__65c8240827754842d2ebd5b87a7cec534cbc03988a104a3c73df80d53190f6cc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea9b4fcf0e54ba71c85a12db3926b4e6b1fc564ef7b1aa2c45586298f34c3b3e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanHsv]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__277ed9a9ae57fd24a0fec571b068f5b5b875f61a3ad7053264310ab86ff306b7(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    dimension: typing.Optional[builtins.str] = None,
    dimension_var: typing.Optional[builtins.str] = None,
    equal: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionEqual, typing.Dict[builtins.str, typing.Any]]] = None,
    greater_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionGreaterThan, typing.Dict[builtins.str, typing.Any]]] = None,
    less_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionLessThan, typing.Dict[builtins.str, typing.Any]]] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a63a504a327b328ca3e2b24f95ec7e83fd68b4be71a965219d3c9b5398a90c72(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__85c204995b5d3feb31681333f74b0080d4be1b2d286dd14d95dbe603041f258d(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f722f3cacb7779c642a11e67bde2ff889f99bfee9cbb7426e53ea90025422b7f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a2cae17ad72ac9e5818551d92aff6d4f5db2c45fe987da8ea385e11e2d3897b8(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionEqual],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__180276bf13bebd96464f775afed32bccc46cbf3cb61f134c06fdad2ab0adcf7d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0627798b65de5ab7e246e1056c94ba91f12bd36311df0d5d6062e2115fd0c2fc(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionGreaterThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__92583ecde8f5b498ab370cb3d78a1c5aa38f3fda6d2c8a38ab93c717e12fd87f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a47d7f7ce9e2f5856ff82873411e0092ccc02686d8e28a3cfef793c3a51d331d(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimensionLessThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bebba9646d004a7d4ba49bcec0140419059f7d8da791c7727ab62187c0c4a87f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dfa91acc19ca806f4fb555bba9a52a43ea36431719bf0ed4fd4ec243284f4505(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f4b13adeb14eecb62d9e083891e6c38ef35f1c8dfc1b1386fa60d8a7f623cb26(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b967db5c004ab9e17e1a78796bfc5f10f0c58bfbb863744eb954cf2afb9fcade(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a710862e6ae769c23340c29a6afb32a72762f54b9ca86e659001999872c876b5(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__13649fe660786791a64f2cb54917d901f6e1fb9fbeeb0cdf1b33ae0831bc9448(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimension]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b49c17f3a0d02c2a8457ab1ce4e6aaf04da0ccbce1bc8fae5b2fe2209680a43f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eaec5e7fe8e1436da68a8e675036124ab78af30f9bbab78b7e928237c100f675(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__513815cdc8b3db3d856230c67d711948a7b87efe1c1b04d1d483ba12602d1bb9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__76c91437bfe162c96d6e435517a255fe36b9174ec703ffe5306479d23ebff223(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e1fd05cca11fadd5b99f6811117eb7cd7e6095f155d64f4ce95025b9b22e42e0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1d1903c31ec2fcb19f81440478bdd9d946c1b530ad317c734e719c9f109ce5c0(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimension]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a2351e17cb6ca853a210fe9589999ae8facc926d07520412c7bd9a0a8dfd0799(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    landscape: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationLandscape, typing.Dict[builtins.str, typing.Any]]] = None,
    portrait: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationPortrait, typing.Dict[builtins.str, typing.Any]]] = None,
    square: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationSquare, typing.Dict[builtins.str, typing.Any]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fa6328c179d2e9fb200681404bc890e2b2652dc85c46e34ca0ad3fc5f7ab472e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__91a35fe50aea9fd8d6d5aa4b6e08cba76d62a274e3e11485dab1142790f784aa(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bac9d45ae1a7430daa0c25b6e49311a863f2dcd472fe049761dfc7786826f6c7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__640304fbd95ad6f9b769b4e9bca4f87b06251a14b469f79fc4b4280098a296fe(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationLandscape],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__44f6064b962ec2633d28cc4ed818067d14e71fd77640312ac5626ba33084a83c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__73cd736ff14d67880634535653acf4b6ac81cca5994ec06f239197aa502acd3e(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f1284f0921bf13e340a8a9ee338dd5e36cf05d63cedd478a160d803550daa25(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__45a82169cbeeb18ac79ecd11367b808da99b30bac891f58b116c783029cb8502(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8242857c08cf2113b735f0504cbb896f78d066659d11b1e997381ceed672c53a(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__73400b82b555d2195321668a0e1ab58fd8163860e2856cd7210331cec99ed832(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientation]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5478e74b08e34a4863607bb8fe308c0924113061a815a3ad0c0133677dc6b8ee(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f59204d6e33243a7cf35b31fcbae69e521c4ec9f1f2e6a81adc175bbb098cdcc(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientation]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__28b0ceba4fe8bd4f2dc11040d29736fa7f28b158c3b68fda9ea11e8788ed4bab(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__376d5f81bf49e89bbf5befecfeefa0887b7c851d819b2e9feb703a0b6ba07504(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationPortrait],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__71985464f50fc55a21000eea637b986108d2eea8713f217452c789f1b70ee5f7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2890af9ed2a03c75c3296a54467898f89cfe1f54edc00b04a735af86cb66dbd5(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientationSquare],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a560b6e475c810c22a60aa418be66b85c70a65c05ab5845f05e862af21c7548(
    *,
    colors: typing.Optional[builtins.str] = None,
    colors_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6de0b3a28413eca10b58761a3a2355b8dc10b1d902dc40c6d95e7a2c4a723fa8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__41e74653b5fbbf1b76966768d311dc9a24df754f1774f42958c983b96fcd20b4(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__677054b0f2b0598a75dcb52009154c227cfc65463acd1fc4ae1e9a93a0076231(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eda901de90782300ed6cb4f72d2656454e7f107b32eafe2e823af3810227d7e7(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__adf4571926045874e5372407e5efc0a515eb36823730d77f18bee94b252caa6a(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3dd9faa766e699166fbce67e9aa2ca9133c8ac34fd32b137950c642636b5e11e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanMaxColors]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9bbad307f8dabdda39cc07985533d134e1359f3a8e70fb3f9585b88c5c2780d5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4606e71d8e66fd52cc3b28376964e2661c5b7f2819e2350f62b7140f97f29a7e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a8da01dc69b6be0107ee173ff8663cfa5ad9b099daca847c76512ff77e4c60e0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__48a5647880b584ac7dc465aee1aee306bd7e707b1d472ee45bf142d323dadf53(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanMaxColors]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__793c1b37c7cccb63dd16705affd0daf056146bc8fc2772f2ed8508cbf74909bb(
    *,
    horizontal: typing.Optional[builtins.str] = None,
    horizontal_var: typing.Optional[builtins.str] = None,
    vertical: typing.Optional[builtins.str] = None,
    vertical_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cddbdb987db8cc0f59c86c40ea64e159499f88c9cbc6167421eb8af3a93b1f9f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b1d2557e2e79b44e15bec276fef147a347d244433adf0f6f3eccf17848e78da4(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c15bc63e2ad6f9a877dd49a0b8ae324a45b1e8d0608e1e066e747f4d757c5d82(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__69d4905ade6f09f5676c01e84437f0be1cae22a2622f57c9d6a65fe8360d414d(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2984e088a342e75dc2873cfcdaa1f103f00135b968def4dfb6e298629eebd766(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8f65fba8b8fdfe49ae8d0e8cde36c5b509063e9c3a8578485fa086518e0132a6(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanMirror]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7122bfec6117cc73c64ecf1fe89e1d59951aa652cc4be3a1830b1d08709d208d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1ad0f7e9129d1098b5342a9d6dbb6d021a8fe06f1f1886a93a2c01c0a4cdacb6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a8c1672cc2c678fb5f25140f460f1c218e03c5932af4c8dee92a1b853aa037f1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0dc37afcd338d84340f403b88c526b6ba5ef575ecbbc41824bfd617185be1dd0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e3059e30f70f0761ef2fe38198e9334ae4605b7037142df070bf50f89c41095b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a51aae9fc40687ca36cced7c014cd21a975927c551dd6835cbe92567b3ad6390(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanMirror]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eeff8a5525d8ae28103646da3f82782d823bc59601adecb0e68c73a131ec982a(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b4c3b43dfc5230d186da519e1f7c0f428922cb158e8567d1c5f7b8dc00637bb3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a28763d42e9f8faa80ee21d186a6868118a1d9168317cf5a656f2337832cfa3e(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5e8543f77cc64547d3d3b4b2bfbb3582aa1d3d240fffe594d412f842b4cea89f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7e3b7f60485c1740f7b35026e7d0412e119604b8560d3d01063288e442dba0eb(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1664c5621c41db9747a5a696cf0e1716f2f8a66a1dff00bfcc4ad012a0bfa15d(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a89b82df37950e694889bd8417c378894f087728d312159adf385201f067b6f1(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanMonoHue]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e6baeae00527cb5a668b4232140f1522dc884979acd774e39e0871949551d1b7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9291588e7fa9f82e27617e3c9dd39f1bb47d4cb39e040b64b0abdaa865628c44(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0f93c3a6d38b944df0820e9ac8a21a3065d6e9828772d0878d2aef31ba7c4336(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__648c4f04a70ba12df48463bce0dda7f06ce414892b3fdcdb237984e1bf8a9593(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanMonoHue]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__41a60de0bc40f3e9b2cfa68676aedb5017f1ad9e70340e242d8c487eeb47ec63(
    *,
    opacity: typing.Optional[builtins.str] = None,
    opacity_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1abbd5e9f58a41a76fe2fb253721284b42b0190f4cee413d59e8076ec7e49dbb(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f4c6af17a40e7f767915bbbc2216d1ff79eb5f9f1e7fe47395344aaee5a33ad0(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8946ac5341de25c8c8aab268d844f55e29c175f7f9f69e6e6b54a860bf5ff644(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__64797b83c30ffab70d54d3b5883ad28ce292196ea37277039600e03445bc8283(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__baeb15c9c44c0324e07b8488897aa9b50f2fd0dfa4664711f6c94eb5a4c522fb(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__26961b7ae634a9c875078862471705827263ebaa6890b9535024d3b6db1dfc15(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanOpacity]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7b22c015be2ff9999b8cc2a1905468e0710f6e2405961c6a678b95aefa7e29d9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4e921f8c15b14a7ef8397ea423316355901d4ea52aa602c6926f42d8075408bc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__25fd4b7f109526e9a9deb2c2f980d0eaab2e68ad611b1b3c6e91e03ff26ff5dc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5b989ee576f847a078209f1d71ae30af2d4da0bcbd41da99d7a38496f4293aa8(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanOpacity]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9aad4508b803d56f00c3aaa6e2d3180680f98748a7d1c5a2131431f9ced5902a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__45e65623ebd454c9c9ece9db5ad96304a70d05f9101481d9362618d8f035462a(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0463a7555ebf1c63c2a4fb06e476e63fb4f8aa477a48f1a7c792d13299d307ac(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanBlur, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3356064c2a32257cbe87b992230977571ca45cdb13c382eb9489b5c229d34ee6(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanChromaKey, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0be9889688443e68cce9c6b511e1586e4ba763025a28d4dbc15ffe0dfeae47bf(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanComposite, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2acf04298d507a5b62507d5e76d0f56467b112fb158fbfc23cd00ed616f95c3a(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompound, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0bdbc492e436147610880b5ed028ec97be36e063a187cdd2e0429c9d310f1e0e(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanContrast, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8e49309dbbf9950f81bc4886c1a6f0e10fb9ae984f863cf0ed468840a0f2a8e5(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanGoop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cf2959e29d51eb30e253b908c410c10483985cfbbbecf1daa20d44df6b71bfda(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanGrayscale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__db842ac101aa684fc239941c511c150fc553e7ec4a74b819905e790e050bfb2a(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanHsl, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dfddb98edc3f5b5507b6838da670baa64687948aae1c8301b3262b34afd98eef(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanHsv, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ce77f262e15da71e5fbd8238c60a4766462c96465065060943eb4864322344e9(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfDimension, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__350f39dabee97709d5f8eda7410bf8300157f3e9237f6caff06767adbe56b256(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__586ed4fee44d45a316878abac0d59303b40a9296dc62f45a51ef410156a50707(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanMaxColors, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9f9d28fa4b6c2b7dd6173bcb6077b7b4a9dfacb5da7b0deba8daa011bf71c132(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanMirror, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__24e6216b02332575364b6969e603ac867095d877386044850ce36d95c5957413(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanMonoHue, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__51c95b897d90aac19193643bf7be0de142282c449bad49c2fecd4a26b14f7ab2(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanOpacity, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0e2c171cbb7c1d40a6e525f861c80e56777936517e7fc98b88e2fe0fa1998ad8(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanRemoveColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__21f8df5dad236946ae30fb90ba7676223c68c59b004248becd3d54eb3186a083(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanUnsharpMask, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__62bfffafdc09c912fa64e036f59ceb2f0459290392e163654738fddd0af48bc2(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c344e30f9760864441e9a11c88f14aca8b66086eddab337e6750f8e53e5320bd(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
    feather: typing.Optional[builtins.str] = None,
    feather_var: typing.Optional[builtins.str] = None,
    tolerance: typing.Optional[builtins.str] = None,
    tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__536c1789415997c8820d2b4e1abe2261fbad02352ae2f97a0e38c1ba2d6be03f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7958e7dbe3525f4bec4f4a1d45a991e0d13c73310abc106b59036ffb98de24e8(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8cacbbd2c69f035b4deb41f1770dca4d17bddb9a223fe740e7f056fdb5aa548a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__47978ee455d5fdd4cb2feedbbdec056411258470f261cdf2e07c01108cf9b45b(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b8d86f399b98b84516fc547a5b68a6a3f4b9c7bc912be66ea972b5732ce09b64(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__91cd94c488110c09f1046851af331be4ac05001fe29a6822352082aa848c0839(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanRemoveColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7471d42281117c0b05af1a68fbd85060042b1e9dd1ba01f650209cf0e82be669(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ce85f242c7dbebc0d86269c50e5828d91e763ae9dfb78ffb28fdf3bd4c572fba(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__46d0385fd31418cce7f865248674ad3d9bc670152be9bbceadcb7c423b39fe24(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fdf3d8131a84b4d50ef69aa0d22213ceb46b215237b836e4729ff7e07d9f5142(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a40eb07916cec7ee52a9f0b7c76e4c7abea015b74caa78b5b59fa41afc8db24(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d59d27c58ce69598d46632c3568468a149339c697a680cf041bbb00123d98079(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__30875814c87e54d7ba11ebb89f37e5ef4a9457ef73e90c25390e82896d5cb7c2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__793faef9ac98e656387f8b11b46125032099216c93ea3ee2dbeafd82e1c78fbe(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanRemoveColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__93e2a1b9599b0fa52e8e86e4b87bf713615f46860cfbed276c72a79e45759a88(
    *,
    gain: typing.Optional[builtins.str] = None,
    gain_var: typing.Optional[builtins.str] = None,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
    threshold: typing.Optional[builtins.str] = None,
    threshold_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4655406c9e843dde15012c29bb75deaf2d0d422bd6a09335ddc68196fe1ce6d2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b9d19052d974031c07ffa02ead13c4003785de894561f9837c7a760e3b38f74a(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__78ff823e7068b38df9924f25dbddfbe6ed02fb4edd0f19f02b1931e6b691b991(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c5fb396e648575257852e7ec65ef8ceb96b37672094fdcf96ebf295cdad7d1b3(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__47669a300f2df18e0343a4bf7541d2290078ac0965b6fd31ce967f988966336e(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e3071fe0b7f3b00ac2f704f2cb487d1de9356ea4650e26b5658bc5aed64c04e5(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanUnsharpMask]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__04cf92720012241d4e858d49ba4d8a43d3f4a10c1844c1b4b6c13e111fbb313e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2c246a32f7ec2337a31efa82d2959b452ca1e12451473bc42e984e8830d7967f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__62239f549c7b8f5cf135b35b38fa858fb45c2103f43db9e5a04d2485cb3d156c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ce895000384f9a1e1c5b3e9382aabb22f34f0d0f00082c9a0f831fc55603946e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__46ddb291765a851b29752e8707602ca07064d60f33285b7438feefb506fb2efe(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3f246403fb58f0353f6c1a85b4043eea1904300f477320657b1310be016167ac(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ca979c43e8c9268bd78d27b695af049a7c811f956df992e981814a8f95bf181(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a7ad58a1bb033bc53b5bbc67717f0fb4e6b9b3d4f84478b9a6b672e9c675db5(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionGreaterThanUnsharpMask]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__913e41e98ca6dcd47a1c43651d489ad5d1d2f0ab7c63045b6de050fc3729c3ae(
    *,
    background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
    chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
    composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
    compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
    contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
    goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
    max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
    opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
    remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__322fc16059a748e9ded1a1e89e6983d04d5670107565515ecfdf36e5fd97185e(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1bab3e4a81934b2272af14d1473f647081ac89c9c169fb300526581800ca2e3d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__485aa88d16ef0948a5cbbf8b0147483cce44d2839c936bc480e6164ecc9edbe0(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fa1c2c84a54bdbdc9cfac650be18dfbfdb677b6dcd9b71171f8ad7996aef9c62(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dc7a0fa000c29669ded860414c138ef306949a7d55c93d067daf9804c459e91d(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d81d82090b20dddb4ab9db65b43c49d3bc75df863f69e3dfcee76d54266ad643(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cc4d1ab461fb6f61439604096d8715e5183bb3285b43a42ac0c844042205329c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanBackgroundColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__91f7f0d900ac6e1e961bef94d2ca09aa12d42b0c25391ff77f2e0fd59ab587c6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__152ac4c50e04022a818f6577c7c9333806c6914be7d80c1f5278ee13edaaa6c8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__18a178974dfeefaabc0b28cb6ffc90a834b2ce27ddd5b902e41515de91b363ec(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f5bd08b5ee05170ed452565c6ac4bed62511657775ba34cffa8afa8c0742937(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanBackgroundColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6bf932ed17d2b5c1957cecae6d6dd957ebff7c4f155d57209e486d02105aea92(
    *,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cb67226526ad328326a19482d80a279a52866a0cb93a0d6cfde7db9961f8a6a0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8ee5ca295f61c66eb80286c9a02d53f580d05926d79631617516a8a0336fdabe(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fb59258592f280df6eeb1b5a9c8e5f4414506c084687a49ef5b74130c18de9e1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d46589259137a0eea731385e503699c51211f5b9fb971cb2299737a48ef61a07(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e8ca54cd3b27c00855b26c49a571a7ee4f0aae9ac159848bc64dcdfc69bc3308(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4da8d28dc370e839b8a99b392618d6243f1958e7911ef4c22bd07ecf3aea5446(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanBlur]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5510a7d85c19e3d407039582144d3559d7fff4f42eabc56dde2270ae3a830fa7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__38a874503b084f9018015491a16978e5283db1bb323e86aed63d8d7ecf29e94f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4474cd792560623ecc021ed01aaa80173795a8211ef5a57e161ffedb98707e65(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e16d8a7cc915835f4a25e9b4ada15243d58261f33b1841139ba4aed634facf9a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanBlur]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb4c763e48db8c0da89ccee58d4da629b49c1331dac812e699a2a10bf492bd67(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_feather: typing.Optional[builtins.str] = None,
    hue_feather_var: typing.Optional[builtins.str] = None,
    hue_tolerance: typing.Optional[builtins.str] = None,
    hue_tolerance_var: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness_feather: typing.Optional[builtins.str] = None,
    lightness_feather_var: typing.Optional[builtins.str] = None,
    lightness_tolerance: typing.Optional[builtins.str] = None,
    lightness_tolerance_var: typing.Optional[builtins.str] = None,
    saturation_feather: typing.Optional[builtins.str] = None,
    saturation_feather_var: typing.Optional[builtins.str] = None,
    saturation_tolerance: typing.Optional[builtins.str] = None,
    saturation_tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dfbd150c7634f9ea19b2ace670554d12d20c41d71285736a33ca57810400ffbb(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bf485a5311e6d5c555bfc200027c4b843d46f7136e7468a7f26e339eabf66d8e(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6376e45bbbaa4703ab9cd0be65d4d50ac95fd08bd5ad466d40129cd7c0617061(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b3a3188bdc2dd6969ab6e275c97b1fefc85c78efbc0a42af158b8c49b3c4002f(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7064175a9614208f4bb89981c66db1424b68ed4f492523fbc3fad17729f3c9ab(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__05ea33e8fc243e230fc6f0b5bec6c71c7fc8a20d73dabce2617205dbd8ffb64c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanChromaKey]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f4079c3e439b7015ad3771fc1f8fb7f8ba077adddf02399a97054fd44e19321(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__74c41b7c1e6e9f1df2d8a8bf0d5e37e3a405adf3a535da2acdf7b000d4a7efde(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fcee8f9cb21f53840ce9020411919efe33eef394ee2b8e3bb98adfbb83e90ff3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8145d7c1e2ae959f3b097243f1352244243c7f08ce5ae7b4a4320980b4eb7427(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d4a30df95f6cd0862df98055f7dea0d4e8c9e93019017b1221b333d49862f8f8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__86322952edb0da905c2a6d0be9acb21e7446047ad5d2a115872a2b11b3539479(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f76ea858f541ef66eeb32a33ddc865b847e941502d465ed1efaaa43476a99b10(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cf8b9626f2e22ad16d69dfce8f00d72b48bcd36fd67c826e874ed3d6dbc0188f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a4b3cdc61cba06c163f24856ab0d5936d28c4f2816ed7f9b1dc42050f78339f0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8da67f7c67fec49d162371edb51f9e737e8be48ecd0497566ee811a831f065c5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3cbfcef9aca98c93f604fa508e3ceb7a3fbbce928f9b394d762ff3daa821ff5a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1b8e21a18f3cb18469946ed4dcdaf5f409f2d2da8dcb7905bb7d17d45681a984(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af4f097e6dc3dcebdf58b5b97fbc69b94dd8f97032900becc796c4cd4a8d80b8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__963c7c23b09c6cd06ce3f1ee1f7fe6d7e36bf7f797136ede95ba01869ddea44f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b7c5cc569eca460a6d708533ec806225e4c7e2c1f1cce23d239f845b2b3aeee9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__063e188a73f6e1a1e5045b53717621c2cc201ab935323cdde595401a41be0a7c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanChromaKey]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d87fbf63418843478d7a79042c70ed7069c9b4b4a3e08f9b15301ec6a4bb393(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanCompositeImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    placement: typing.Optional[builtins.str] = None,
    placement_var: typing.Optional[builtins.str] = None,
    scale: typing.Optional[builtins.str] = None,
    scale_dimension: typing.Optional[builtins.str] = None,
    scale_dimension_var: typing.Optional[builtins.str] = None,
    scale_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1e36bd98525b9046777f6cbce9c7027b51014938b3259a657bdcd4dea50d584b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c4b3bc270877ae8c703a55330e61afdcf2e43ba29ec1d4feacb7c5f75ccdf7b5(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanCompositeImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0bdb8265c86e2c860e2b4b51914cd1ca1ac6a9091a256e409d91e606d7cd99e9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__16267bca95d901e10e70002a06535227a054b15f87b6b446ca18ad767eb0cae3(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__05a35efb6be00a4de37351a638b248d5d60a3030a2ed6818439164b9576e6f83(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cbd6680cb63355da7448f65d5d6b4973cd877872be04ed2d6d8a5ad6bf999221(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ac64272834d18a350ed7d1f7ef196589be710c63c13319310abc231e0599803(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__554baf26a9d2331b3aa8b35d1d64859a2b3482b148a22fcbe2b3aca827d74855(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanComposite]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__23a010266ace8034da7128b6c31927075e2cc382228510e9c6e43f4efb516cf9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b5f90a9fbe3909771c7d64d3c029636b169a7d6e4d9b0a9bd145dd49f176b8b3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bf02395356e62658a12951865f26741c56ffb3fddf491b36c3aa47e94c857552(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3c5ccd9a111b3a09dde19c256105b17bd6864742215650e06640c269bfaaec11(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6c3b8eb271eaeba379c42517f48674ad6ae20a7d384454fee8d7133b9e0198f8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e8745666113da0298b5ad609ce56eb146ed2a96cd97bd70f58beb6084c4204b3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__46ee8daece4a0a750bf3d5853951b18a81aebe48690977ee2d364772400e447c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bd97f5f6bfe2591def442aaaf1db267140bf81de77da22036d1ab5e2a99b5b8a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5921d3a83a049f26bbdc5a5ced2d4f3451946cff32479312629210269dee5ece(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4456f8f9206fbcbd1ed1ecbee8c1f0117d05386e97b8640caf302762906a20eb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3c6bb197b4db9a2e083a71e7a6a45bca43a62a1cd70a454d17e9f9d8d31f18fe(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5a336ca78b6e78f283fb2ab7b45c2b0f156b0a9f635f87fa5c78a095daf18af8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__44561ed273ee353fd2d3cd824849e16eddbee1d1c9f015542336ce1519c6bbfc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__10ba7628fcc8946acb458830ffeaf85bfbfdd2d77cab19a58aa1a1f32c1cec5e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanComposite]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1595f921bbd98d9821fa107e8744c04a359748394adccd61d5254615fcc707c8(
    *,
    transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7368a154be4afec7535a66fd50e32f6badfc9d96539c815753b4b9ecc0b2d69d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a1eb75b793b04b46c16adabe55787c5b1f4ee5161fd5dec592a096ed03ff5eff(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__91a01655fa73f546513a7fac773610fa6dcc689f52afa3e9b16a16a8ae306f4b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__43e61f48311f043bf0e3ce19684288144bd598d1914bc06be5a93b6666cac1bf(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e429d6c1499884fbbf4d8cc2cf6e82faf00bf4d064e7019a95479cce44d60a78(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f597a38ea8ee9d84e38331061cfd374b8ea3513cdfa96671a10259c6ba7e3e48(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanCompound]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__674b26a94f6378f7a0081d668ee814f18882ef44d662bae0d7a788415ac63441(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e8f5d16b465fbce4e7b670f6500789213b360d21ec29f2baf59bd838d25e285b(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7ca745839d597aacb9daa43033a0a2ceadaf4e8ddaf6767d0a42df439f8c9c53(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanCompound]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__872e6537f8e6b9e99de58f3f677e2d8d08896919ba95664d70dbb5945d405fca(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ff7f94a75752b14c6f37a9853480d8d2a5b906306a0600966454294c16ad0203(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ac43f31b1319082c56807321bd341671fef7d6f9ceb1bac9fb2a229b4d93ead(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb17300551478b4c2498a6f8619f5920e58a4f6e1ed3740736d8f041ba77044e(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__98db10e6b34ad7bb6e8ef9b9d677fa375c6720be098b5ac32da70e81aedf099f(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a1e2dabc4ab006c38bb4128392c4959dedf33abdaccfbd1ea4d5c84152a99012(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanCompoundTransformations]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c2757fa4fc4f1c8b135dfb1baf767b48b4c1d1eea548b678470848459be79469(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f0e2b2b97d2dcae1dcbc450acccc88118395491ae5c6eb61ea97cd57e1aeea8b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanCompoundTransformations]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a9a3501462a628f5514e4f052dcf4383e499ece21c591b7a5fcf694b1c9101d(
    *,
    brightness: typing.Optional[builtins.str] = None,
    brightness_var: typing.Optional[builtins.str] = None,
    contrast: typing.Optional[builtins.str] = None,
    contrast_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__adb7ba857ca143bf698cd69f00a02d9782141079f4469927666b909adba4ec10(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__456a2b5bec23eebce35ed952f6dbef6ff6bcc818ddbc993921faf45a5433613b(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5c16c3c6f97b3d1d31203da3499be034f8720361ec0d02a6c65331eb9de7011a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8ba03a36ad5394d8036f9beb75713222d96966e09f0f64ccdc69c83d1b4d8c7c(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7cce165152fa94d5367a0aac330049d54c99c8427316525a50320d9b0929734c(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a3d2ba92945e1045d23e75f7b95f7e91600bc164e4a58c4108c39d73c6432389(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanContrast]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c81345c224a6f35aef7211df73350364a3b818234d76e7bfd82aae6004c42c28(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__48ed764998db72d1cbb6d7f97c07968cbe441d531f3c18d54a174013c3e79449(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3572ce8186d19527e6e46f9378b5179bea4a2f1220cb36489956949fd7681039(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ef97c70b7a6a81b7231627727ec737a6e627a99e7ef50f1d3a05fa17af2ac153(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b2bcb708e4413823f1445a7b65a3d6c327cbc2ce28b499d0d4b262579f7986bf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bcb2c3408fb544b0ed0795ebd8c72502faec36f5facdbc5683eac1a469b7c728(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanContrast]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__77e434c3cf6282a04e3517d9180be36ad1169609d64d7660589e43d312c4493e(
    *,
    chaos: typing.Optional[builtins.str] = None,
    chaos_var: typing.Optional[builtins.str] = None,
    density: typing.Optional[builtins.str] = None,
    density_var: typing.Optional[builtins.str] = None,
    power: typing.Optional[builtins.str] = None,
    power_var: typing.Optional[builtins.str] = None,
    seed: typing.Optional[builtins.str] = None,
    seed_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d230ee11f6391cf68e116f60098000010feed22adcd3b7fc805415c7790951ad(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__98df1294b8ab4afdf7d3d8555eb61921ad833fe4a9a91aea5781d268044c9668(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a9162da40dab088399781563366c37f1bf000f5b8d484468c4568432c9a78993(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__79fac613ede76d0d8b802d329aba17e5711c85e7fce16d0fb165a005a9cee4e4(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__14092ad34002cb6a7c2a0966595190961b6fa7defc8fe3dd9680e291ba887999(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c36e11c6e9665b28983003980f9835a2352ea3ee616eea8dc6aa1481f26b4f31(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanGoop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1a782fd5034d77f4b4b33f378d0ff3cd6eecb168caacea7d54f5f79ea157781e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__00536ab58454b6342736a2489cfad4519f86e7fd4d8ed2a45a3b49983264d0ec(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f609460e7ecbe7e4032062530189c8633ce501893a8d9e47c3a1450c9c40fa00(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__38ade8e1672afb89da2e35c07682e5d9fa4b716b4ebe2945337ab317bffa3dc4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__45bec1207974b36fc268ec43c7259547e552d2bc2cfb2c3a4e2812d7fa04b2e7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__24f1af24110be2362d99ae6d572ed0b98c9f21495cc3e3835e5d11cde2bb8f29(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__93e5c7d65d52f08e9b8dfcfcde583b2cf880d8e6d0ca13f7c469232be34fc207(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__18ede557fcef937cbb752ab8a54a0bd0f809a4962f94fb3aaa5292bc817df737(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dadc95bdb1e344951d63939660ff394cb23ea8bf8852bab803ee7d1ea126cb95(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__abbf91d17b415a91af34bbe6cc5f34ab6eb955282ba13a16e528e9ffd2a17cfc(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanGoop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d0c804fe2ffd9212d74729316dfaaba7f156db8ea5cf1f417db8495501360298(
    *,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__944da86dce9b40f425f5519c2280c4302f1952e4aeb4cc6bba17c9790be3b599(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b2b000fd7e4469a7178fc9dee440cedb8da75d8f893e2818fc8f3811acbbe985(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9838290847c1bf8f00eb3bd886b7da6d4292dfffb62aa38126db23d97dad0258(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cba9effba4e5313494d3bf4cb69a82f67da677b13d5482513532d650b8e17ace(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__916166ca187c5aa9e2075efedf81b710bea50e4b08dadba804a9155e8abb895c(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__495848179f19af584f321bccd0109c2e59235400cba9ee58ff2cc592e82e4a5c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanGrayscale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__51178c19688e0695bc7aad23835023846615ac2fd8388df36f9b50601d7f4845(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ae18254b4f934eda13781055062191b7fae4ebd742a18c8e04b8073b6f7f06aa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b39b682d3b4f284a6d14af9779fd1528113f72eaad6c9e6c08dac29ac39806dd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ae28b1430979cd45e45f243aed803311581c34f722e1a7494c83b64bc3e7e5ec(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanGrayscale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c772213d95f9dc313d9054d46553e67c744836f71cc6c68e346927f6bc52f334(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness: typing.Optional[builtins.str] = None,
    lightness_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a00894f6205ad50aa244c634d4efc2a29e9fe021b201337fc4c2b2c84612a26b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d326a552834c6e848d879a7cd74138f9c191f87def5c66cd9b85a799ebf0dc33(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__18ab5fbb82bc2f926f40b8724c64e9212cd1871840c6bcb70b781ea0e5a85174(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ed78da30c2aa35a3171291899f3f91e407f20324eb95f481e8b104b12cd6de8(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c929771f1c233b6a90cce007ca305664c7ab6ee5917c1cbb5b6bd15a820519e6(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e21c2916cf12cc12d8b09e03dc21692e6f6e91d80eff089f71908510071e5318(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanHsl]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b2c8a3bc119736e1da46a3129450bf4776ac39b72764811099b5870089309522(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__88a052259fc1b53f6ebd3198804efa74100e7f11e4a94b095f37eb9f481b9b7f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5bb572fcea01ca268151a6a8877208e92ceb2b864b180ab92fd94c25dbd9a37f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aab1129acc0391f5b49b5bda87d0c1670e58c5aae3f087b5ce96037dc353626b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6d9c35504b5e244631be7899cd2f04d795becb10e82a6e83751fc67a4b3e2626(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__53a8d958a24135e1b9f3e52259f6d6369cf71ff5b5c19d5144802e7c5488e9ff(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__88bef94fc1265d2707fea0eeb8aca236760de3fbb6a7f19cf6b180a4a9ebe3a6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__625ef6b15644d1b31dc416b1a11df32ed25751194ae9ced792a7b7b4e0e84d22(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanHsl]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cf23057e25ce93f5a090986f3c44ced71f6952e69743aa27d285c78beeb52866(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__82e559e6a10d8f7bdad226ef1457f323548f3a62317bbd9c511e349b740e226f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7adb0931ece3b1feb2f48552359d72be9c4188a8342072937c26910b606f83b4(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__76c775cb6c2162b75b6acc30cfdece7be8fd93c2e5fbb994baf4ab1924b139cc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f10ac2d8189ecd5992807faa2b812a3c6335f2d9fa10d844274c0e0219863872(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6315aa320bf192d24510af6140ab748aaad68710c70d365dae3b58ebae149997(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a0af4eb4ecae612793ea1f128e672652f7127d5f53f5afd5f93de0b440518b1(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanHsv]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__15f7a6c4cb7c6a7dc2d3bf21b508184ca0d702e753b1e54fd765def3e26079b4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__610eb2025639348eedea82c177d84e5df4a5915bb95de117445a183245cb8a4c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bcd9d1c544aeee604639a6b783eb03daf0e2700e8a55ef3753daa14195017b6c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__357d054168306845454fe6168902fc837ec9fdea0539717da3dc9301c087b5c3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c045cf8883361d622a9e59b596a063bd8b5c588b84374c66046bb16e57ae1869(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea83806b5eb05d73f459d7287211a6073ae549119679f3d4f813fde954bc8d7d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6752006e992cdb71820ebb075b937d842b6d54dd010105c7b35cbd5a47df2974(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a34fd0c18d6eb2e90a5bfc97130904516b7fdc6775ca14066f045e55c1704999(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanHsv]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__844ca183f557dcc7545b553ee0aca863b95317578587d8cf714079360e42650d(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    dimension: typing.Optional[builtins.str] = None,
    dimension_var: typing.Optional[builtins.str] = None,
    equal: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionEqual, typing.Dict[builtins.str, typing.Any]]] = None,
    greater_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionGreaterThan, typing.Dict[builtins.str, typing.Any]]] = None,
    less_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionLessThan, typing.Dict[builtins.str, typing.Any]]] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d1de5776a6c8a0c53215ba3d1751bd7a04bf7d6223f69971a826f0236845e766(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8cb5db5ea7bd0d395acae86690b1d998f632294f5a7f113bf882303e990cdfa0(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__493bc9607af8d61ebc018db2ecceb723111619bc9e489d7cf85de0fcb7853a38(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6256ff942cb66f7834761409b3a3945a80769e6b7e168dab8aae2dff8408a767(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionEqual],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aaf605618d0dd796277b2feacae9b6d74db560c6113fbbcbc6898bc7b81b2982(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e7ff2990000ddf5e786480675394e98dfafc1590bb319fcb4a5c550bd870bdbd(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionGreaterThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3036dcae3527e1b618fe18afaca91118aaee91a3127d02b814cae13a845aafef(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__966b3f1e6ea02227efb11b4b4d4743c2dfe0e2b0d8b2c28085125787015b802e(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimensionLessThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cee5ecb9974dfb7ea7ab0f74da102291e2c3650aad41702278bd88cc38c19030(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f2358d87d96713ed90fe3b2b0e5d1ed3e32a4341af85e2aa2cd3850e72f57385(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4e7141ca77cbd16ac52941202565e677799bca516527a7db33618fe43f6d1622(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cbf9c052f0e84fa16f314b5d171e7ff01e1edf5e73f2f7403c13c1caeb7856a7(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab0487c4441dd7398b08cc2086ca5e721bc4f667a12f8b9149fcdb270ff6e00c(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd82e062bc3bde8ce583230ffd706ec8ba36aeacb51a4815bb05fc934137eaa0(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimension]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__84329fd9016394b9af0c185c5398033b8fc730298a5c43b14e1facc65bf625ab(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__75ec9f2add95d057340acc3f31a67192d75d3808d2feadc12772678ef599e535(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8fb02207493f00551ae3473bc964bb44d665a42a8fbb1d52da15cf55878d8f9e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d3dc263f35ebda9930bdceeb30bafd1aefe761eca1dd62beca1d860954bfd132(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1aa392fdbcf22793cdbe881943c66ddc01caf51203f660cd5ee361c093d577ff(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__316b872d966abcc3d39ba2c8d5bb17126bc73af0b7c74add5b815d6d4ac227de(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimension]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__645338b91834ad4c83d2df6fce2724e814e7ad7a8e169f96763cfb4bb6082edf(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    landscape: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationLandscape, typing.Dict[builtins.str, typing.Any]]] = None,
    portrait: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationPortrait, typing.Dict[builtins.str, typing.Any]]] = None,
    square: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationSquare, typing.Dict[builtins.str, typing.Any]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9038f1c13fbd08507050d9f34fb51e8d2a3617f27d9d0dfdba62e56b44321ebd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6aa2b960b495be677b98911cff94accdbc0dbfa6143bda6a73eeb4f50adf7fd7(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__348b174aaabe18f383c08764a6119d2192e85b3fb9718256e654ed7eb7e723ea(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__806e8f2c23efd5f2404b3ac8899e3a7c6f17ca2e31410b61f30e5c4cb7eba952(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationLandscape],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1b2c37e4c65c0515dca35beb34bb503d2802004f60a82a624a5fc5e9c779dc59(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e4a9f365e4a2f4a69a1fbdac938b87e532e36c05d2274c3622ada060bc538804(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8808b43f90bd734e75776ecf1be9e4396135f75ba487ae59d70953ea0bc4561e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__16a3ad1ec41be275c85ecffbc18b6836c2147215f5b1f60fb5d6e126fc3f7a04(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1cceef1f3c5c0584f9b717b0fc0eb73344e5507a0879dfcebba30e2e9fe02ebd(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__489d8278dc0d9fa3b9988699ade28587337bfc6a566911327fd7fb47dcba06ba(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientation]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__48099098b82d3df8c8d6fb1cfcac721a5ba76914f8dd644dc0e9ebccc8d36978(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7e32675475c89ea648c6e8667ef623475aea87e0e9524211ee38776108164fd8(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientation]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4673e4072bc6d89ced3faec26912f8fa4dc8e40b1069f0f9aedca6ed63eedbbc(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__44ae36768da36351567b2700e6f39d8020f4032e708c402eb8eb4441e51c8b5c(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationPortrait],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__271e4d02e0b336d62f479508545b451543b119cc08d2fea61e99c60ccf444e26(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__50d2a59173594f16e2114ef1b52ff472ad06e220881281ffb8778fe1b2a07d8c(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientationSquare],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eab7b2f8a18e2c500eac38cb8decf0261de0c566aa9270d62f06f77785066d79(
    *,
    colors: typing.Optional[builtins.str] = None,
    colors_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a1894b32912bddcdcd7885ca7cea0b52d2740205744b8ae5e567d61e9ff2e2e4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3f2cc97695b7ce0ec52f61b6e4efec0cba6e80cc6b12cd74ec64c43b82b41c8f(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3c55aa4bb8db5ebf6d69077b64d24557ab7e158c32ac050c3341b134f6f430ee(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__de0b4057af34027389ee40522842846b2023d883fbd08110ee406b7191cc490b(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__58fbaeada404ea1ed22f1bf4c5fcb9e00e10807de8d8e93d6533e727b6f901c9(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3c55003fb1df5442ebbec6502bd615b409ea96068394f82386bbc19805d4186d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanMaxColors]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a246f3af9270ed9ecdf2f2340e269f8e30228c45d5bac523f5a92ae915fcdd1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7fe817e7a864be9630c9c1ca6635e8f8b9ab5ec4310f9d65810ab61bb0df2e13(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fb9b9c9b25eb19766051dde4853f4e9afefe5631674972e2b5b9c812be4a9e90(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d4967ef4642e9c841f4301b0275c36de03de15db9dad9576dc6cf701d9fe2449(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanMaxColors]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__39afc6f99a02ca4e0198718cf5fab1198a33e89a5610f6a745f54ceed319633f(
    *,
    horizontal: typing.Optional[builtins.str] = None,
    horizontal_var: typing.Optional[builtins.str] = None,
    vertical: typing.Optional[builtins.str] = None,
    vertical_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__037a3fb4e0608be8473a932c0e130aa50767e422a559431a02fbc757fd4ea31b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__847556d625d06f32511291640113d153899e080f524b3eb1d1338bc38ebc05a9(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a343c1895a1dabc7e04a22912744f4ddcfdebfebae74de436241dec88ccefd4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fd1f6694913aa7f6681e2375ccf5187cd12499ab8efb96fdb1a466cfdf9c27a1(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fba91463fbdd17ba73d3f61792c4daf1a046d9cbbf912edc7ea66d419a817f8e(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__234c3dc86ba8cd8a7e60dad7c393c054a53b98e0087f6a278f6660d7be0d298b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanMirror]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__610bd52c5adb1e7330efe1d86d4c706b2ebef17aa3a6e337f0637fe99ae6d3b4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a2a9a9d0e470d437fcead8143a12aa77852dc7695e202f66c77736c0e800750d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b609cff8a5b14f815e214b4fcdad5f399a4f82f5e6d8c82879c36855f3059e47(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__01184e246bcff032770bd35a5599de415b95c5820d06f8bf30bac6127709f200(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e9defdd0a2c2b1b52c8844981c96646a811ebfb85a7fc747fda3fd618beae778(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eec286587b9395675ea6d1fc6e43107899c435ee34b1f002c054fadc9c918577(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanMirror]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__467c6b0654f3414ba51d2d9f537d31880b13f66a236491ba1f18531ee1575d17(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4d8b1f607aa0fb0a87fbe63a38963cb1083b4cadcfdc423e10ed18cb24960ce6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8cda007dc8158f069e571cd250a7d7168610fbdc042d97c7ae91fc333dcd7d73(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__462c1fd741727648aa1da7af54183106a03a89a807a234dc0933492443a35dae(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__26de6fe64b082752da98eb4d9698e8a8847eba33bc8949e78ccf3b7c7a646df6(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d89358086e7d0e1f5f6ee945d85eaaf9acd8f2c84f4aba94ff475ce02bdc4d7e(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2f27a57adfe00ba273f599078a9a52745e342c6418e0ef40b7b8f061f4b0d690(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanMonoHue]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ad93581b1553f6d113a6c0f98eec611f608d87700d3b31728caf57d07e75aaf8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__93a3932f566e66310427bc8a5afb6f7e867b39f59aa9513889e615e545023d76(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__201039bf159605e46e4c1eca1fc158cdbf04fc6ce5f0d391ac2db5621ad500f6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__546a27bda27b17735ac1cc24aa9e0d45c9288a5ac9e2871e26d6ceaab36eab3e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanMonoHue]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__20b12abe1442c0316e16577dd66a9c69b9c263e8c4b440e81a65225fc81d8c4c(
    *,
    opacity: typing.Optional[builtins.str] = None,
    opacity_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__feaae36f9541fc27729bfccaa474467d6944a6f775fa47f0bd23ab7d9a446602(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0a102a3f1fcbe5e0b049348a5e835c14a2119507e9acf6d8025526355b465e9c(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__74e711affa9f7fe02146facc5d7a999980969dea789141c38d9efe8e47101767(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b1304f387923684016086a4b19d6a70c7fd18eb5b87cbdcb767250ce432d3ca8(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3738f73220e44e96854d23530a9705e6fb087c82515e46f699dcef6d9cbe11d3(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7bca26419564ca0cae02425d074ef4ec10ed214457d01189b8180f58fafa2b7a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanOpacity]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a021fdabb4d5c4e6219c984f2929ba12578aaac2da359b85c83caa26537cc0a0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9b7f7da97b5442b8d0010a3cf861e5d57d6d4089b3ec9e339a4758d841f542de(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c62307c3ea5f7d17a364d009ee8f723d35e5c5b08c486de995524a5e7f3ef365(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__50baf1a21fee8c89b216415844e47867d468e7e2f9883fcdcb08ad2ee7541f68(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanOpacity]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5440201ab70edcef4698d6e27dbeacc3c8337fb8ae367deadedd6a1bcc817a46(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__14539ea062b1bc5cbbf797e5143a1b2f35584317f6aeea63cea219656736260b(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b000e7b06299ce132fe1249fa1c6b1c0d9d9dbc15b8418c345abb60b5a67254d(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanBlur, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d70409cee45f48d82fb271c8996e312993d8542808d9ad9c82a565a9445dccd7(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanChromaKey, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__12eabdd41d1d5df867f0122203a39773ffffbde7019932ee86d60f3a98ebc3db(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanComposite, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__999b33e209a7958310e442fcb938524f1db3542a368ccd2838b4a771fe38d2ff(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanCompound, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f60406cd344638437bf30a389e0b94e9c019e4dadd7ff82c842dcec0ee45aae5(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanContrast, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e69945ebd6f87b711df5feb65c16def9abc53bbed4a5fe4abe76ff43e36cb45(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanGoop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cfb77c532e1e70f40babb5ce5ad184aed5db42283104e1ea82028a39ce922187(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanGrayscale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0721c921bd1537fff436f3a0b47200d0b7cb919c15f414c984c58d775c247045(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanHsl, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1fa769c56d016b121082365c5334a5f608632d199f5b1775ce13f879bd95cd8d(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanHsv, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7a9eadb14ef04076a252c3ac64a30ae8223848d2b9ff66711f41aaa42a16c568(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfDimension, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0c0097115d917dd888001ca8e19483b2caca785256755da8120e667935695b08(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8590d79cfe226d6574981fff6be181bb1f95aef0276a236ecae4e7e3139af1b2(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanMaxColors, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__28b2ce6fa036967121c09a96b204e966f19fad9a70c39a85dda90c1836474ca0(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanMirror, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e29c8451c5906d420d1b4c8526a1516f6e79163a90afadc4590ea69923e95d1f(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanMonoHue, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__30fd5558da3753ec3f66c9668220d2e58dc15b3932be214f411a463defa943a8(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanOpacity, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__096b31f700e76b16c6d48edde49de5f93d25294b13b2bd28b7933d2842316c1b(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanRemoveColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__34e2a66ba0df3144a5d3e0e261461bc59df70621abb706892e1c7a594d38548f(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanUnsharpMask, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__749e5322fc4dc44f4f06a10323df6cee0860e8b76491db2a759d19c915c5fd6c(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6815ff56ecc39564d7e7a236d947a7b0f3e0104785db2c89001cf867a59a3d87(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
    feather: typing.Optional[builtins.str] = None,
    feather_var: typing.Optional[builtins.str] = None,
    tolerance: typing.Optional[builtins.str] = None,
    tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0edcc2cda24efeaf268dc2d89959fb69e49af09d8a92c9e1fb7b76a662dafae7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5a7b8696778240dea4ccb51f03e11c8781d6c5df464ab3029e223fb8c1ca59c3(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1510ed00a0114e99e566abf434a40ebd18361cea247098996ef914f23e78f79c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__74c868f7a3c648f54dceeb03cf2adf6e8d4baba910e7f83070509946b2e10722(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__34c67160063676d99019840c1333c02c0d425bf2fc51cc205519a6288c6ea4a9(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__31a2db0b242ba8beb0013bfa44349887dcdb562ab4d1e7345581bde5944b04ad(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanRemoveColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b9e963f020b3b7276d7879f66475a3d63e26ca4b24e5bec17e218edeec9af9da(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c77e9f543021cb9277dd851d4f2b2330deb01957568acb3c665ff324b593a837(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a21e32abae9a865680dd69aeef61c413f1abfc4dbea8440ca21671cc3bdd1608(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2e710dce96522b4a2f236d591785059c99c602c975c42ac8c568ec5fd61efeec(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0cc6096b786ccef8ee8832df5de26243d01c22310c4716bcbc884e85ecbdb258(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dd08817b25222cda96ad0e08d6bbcecf894f39b44af2b30923af41f24c4e1591(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f88f18f97ecec45d38964e4c6c99dca7f63934768c76007766e76b6e03626d31(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c0b10721701afc1b9285a174f446a12ce4176f3737e8f29e7f8cb4f64288c8af(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanRemoveColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8ecb2ebb8b792cfc622d7d7c8500c22f53e8ab4d6fd126814c89219a1c173187(
    *,
    gain: typing.Optional[builtins.str] = None,
    gain_var: typing.Optional[builtins.str] = None,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
    threshold: typing.Optional[builtins.str] = None,
    threshold_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eb817c8dfeac0a2e352632ba28c3d7a823a643832b1d3a59031ad99ae6d08c7c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__67a72dcd2e4fc56c06bee6146f4ea8a7fd42cf5ce16b3f45b22445c969b15b6f(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5185325f017828a27c21c5efe396f66c673b491c98beeee331802c2bd88d435d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e0de14670cdedaa0c03a28b19975e13f1dfd3aba8deb3dd74f86de85ac6b1409(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__47112a5d736acbafa1345baec6d92666c96fab7970f59af4f42bc65adaf1524a(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__455d9c2b1f2074f3fa9252985e73cc2125ce786116dd66e834a0fc1f9348be99(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanUnsharpMask]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__20c6193b3b241063c80e545d1cc0745337f21972a663d026ceea10b7b9c3614c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__11c352bec3357e3865c124525432776b7d11d5db3ee6cca42e846ef97a62683d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__97c90762093fe0eac6022ada72311694a599b6aebfac7049e081096a299bd713(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__42f966d7168498e3b732bffeee2d4fd60774ea4fe1e8d872d8b4b7f115058332(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4bd1221198cf00f0bea90d9bd1a0edc06f59de59e2b56ce8d30a7db87886c686(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__40f0466eb493d8780244640fcf68ce2786d50ae084d94f2488719e7ffbf790e3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b2b9827ddfa4dfa4335275f468f6a8d1f47902b733200f1d03ff1c2ca636075d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0451f2d8f7a73840272a194e62797226ce25063bdecf0a1d71777f39115c2182(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimensionLessThanUnsharpMask]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e8877a8ac2964c551f60ef334757143fbc7ca34e9e0d410850be39769f8fd41e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d7359ea34a5e9a3080108a07fc28f594d1cc54a11648a07449bf6ea59d80cb34(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__96d86d09835a414124bba54a7ed8949eecb9156538e36dbee58c3fd5380bf100(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7cad569700b98523105eef11c873b1ffe53e9aca550af65559337e8c09aadef1(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__67c200ab29c45196531c98356b5ec81dbda0ec34ddcc9b1db5780e91a9a5a49d(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__42c4ac830fcba2eac7ffdb0bf50b89d34f4e6c7c0839b88fec54dae96e0e6c50(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimension]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__853a3fe9c35f5bc19017ebbda0d59ab4160b806f5cbf875fa492d12515d3a751(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e8874b3414d5ac9d193876c6bed1be9a22144a79e00f8205e6b5344c5d85569e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3716f4ae2704663d184e9ce3d23d24888301cbdcd3eff04070a7aa5c152493ff(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__42714635ed0d516ed7f35bb93d1f6fbaf054d5418ceed0a7a2fe165662b63d52(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e5794a1024c2da21629ee8ac7318a4a3405d3d4d5bc9ba7e37a35e936f084cf8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e6b29d276a9b474a2227934f756b60c1dcd60fe2f6cec122ce3023d96b64f4a4(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimension]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3475062fc15d6791e9cef72402abd6c48f4ef32afe222d560122a2e01663f086(
    *,
    colors: typing.Optional[builtins.str] = None,
    colors_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__954ae67629bd8bc2c3a87d70462d0401e997daf040d13a68a469b69eb5ec9982(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a34ca5802aa6cb2fc2b7d964678c4086b75c712ec403f6eaac1776ebcd1b05bb(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cccb2be04b0199d87f44185d90a30eda7d9b21f477bf1b841c077ba46cc8a226(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__25bf71a6aedf6d1d37c7c7e8e1e99312833d97500fd7bf703e391b2829643b99(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9f3c5b6f7fdfaed3dda0114329181f5721a90032382dbcde52920dc29df0bddd(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__34a9005f78a8aaf66a69c4f9d64f64b41722ccb04321ce636ee9cfc804e543d2(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeMaxColors]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__95e5bab21e6f458f3348835c6107d040f0617025e209d6dc3522054faee46a83(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1b747b03dfe59da5402646361208270e40cfa21e0404b4ff8ac5c29952fe5b4d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__704fbeaf0e43d28615b1a696a6784c21efbec468bd79eb111d76fd01ae7f06b1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9f5dd405f24dcab86c991c26710f6be0f86a84e34d9a1158887a3fea5b54d341(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeMaxColors]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__872458755cf51d43c6b30031b8adcecc4819d313d9d4f360560ed888dba85df0(
    *,
    horizontal: typing.Optional[builtins.str] = None,
    horizontal_var: typing.Optional[builtins.str] = None,
    vertical: typing.Optional[builtins.str] = None,
    vertical_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__75558bfaa2f412c03dd3ffa8ccbe4500a70406ffb06390db34fa8fbb1c87aab9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7c8767184d5fb03b9d233df51738740014f1f621ad9b132387df105c2a6c8e1d(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__589c7953448b8560f5ab2d394833e1d3884d9c6eff416e60c2577ed9768c23f6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bdf2488df575c80430bd894e925f95a4d6ffc764989a7ea0b8027957d7233be4(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e219fbffa863d1fc625c324279e95625143cb93e5c2260b4285b14699c9fe223(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ccc46d147043905ca7c49778355988072d18370e89d12772fb529a8748f17369(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeMirror]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__acce14c7264f16c721a9af74afb59aad2d377a658daeba1cc7e5e60e1c075631(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__94ebbc3cb3c8bab635abe3dc65f43fb3ebc33d64a8c2f30463f590532c9e70a1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d1cb528b84aa4928420937d814779901a83dea23c4a319f86835733aacb0efb5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__704b25d490a0452653ecc91cafa90f6576ea49e252aac95fe42d47548b891d7f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f617bd5970fe68660bd047aae09acfd0ab2d2a0cccf9bc000147f6db8bd148c7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__29101d22230b6dcbb75383f725b80984e390888ca3b89489e55747995a1fa524(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeMirror]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__39dd8f653d140e29383125c57aebb15cecc17d8b39b0ccaaca9c798021e44b05(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6b938e7f8b3a54f1c629bed7806df40b2726abd5f3a3913b91f00eea36e4b9db(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cef02c29974ddb3cb046cf9f3876377c907f0ea2c1140ef066fd47bd1a27f259(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f3266e07e5210801e5e7cb02e8345a8c74308270a537c12889ae3095d94220b4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__66cce3f9575b16b2690306326c4d9c1c7fea4324eba590eb4b7b603cd2c17d82(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__41c9ae5ddfe1954868d2e3d5568281dcbc0bc45803e8ae23ad71ac5174fa2db5(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e20f5e9eee328270c60b43014f24f4253c4688543c03438a1f15c622dd6de263(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeMonoHue]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__56b921518edb661af7ac214309662df1fe2bac981d31d184efc66c6c1611f764(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cc42cb1b9d25cd4db036b0646665fb4b51f45055a3eae9c1120c2b905a6c1771(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__178b50bd7815f2b1b58a3321aef539dd8c50cbdbaa5777bd7aede66c1de385a4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__de0592bee3fbb003f31ce31275ec5d14bd060a0fa21cf31f457a06d556e0cc7b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeMonoHue]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__50e8a02a42dd0a341d4ee5c3e1cd4fe2df08c4c23c7c8e857ec878c57c13d25f(
    *,
    opacity: typing.Optional[builtins.str] = None,
    opacity_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b559c57d6bf87e660fc0130c909a9235bca3779a32a4bcc7c4416c2adf631c1f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__acfd3f32737440b049cbdf31c434463fe5f09233d05dc2dfe3e8e44550591c92(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a6981fa1fa423ee28944518b6dac38414e86e67ccf0c9472e57ce751ea3a865(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0d00ff359d3edc42f617d651a1a0295ca66acda7e8fd14b995d9abb1fe7d9044(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8aea52bb49515ddecdf6d1ba46482bec2f7d6a4e5a2720b580e25f936b02be1f(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a4967bd29899407eade2a34452049e4a14c2a3dc7cc46014fffff888d9fea87d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeOpacity]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__87cc2d91bf208156fedb82ba2ff231b65af1960d294f1c0c00bba39d181b97dd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__77c4b87d88dd06430eb01ed91a4075c4d6762914be2c4517d1849f1bb2c6e9e2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6c6474d10c04b99366954ffb0df08cc02c9c13a78f43abc2a48d5f718a37b66f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e432bace0cc3b7528084a41295ade2bf1779fd5ada394bcdd9acd785c4bb0325(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeOpacity]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3c03c525ca2acceb98a210d778ffb1cf2a6bb328d0b90d3e5c20d00207913c14(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d9f828cc05a843e3f02714f11db366b32124175d1cd12e44ee9b68479e02c740(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fa6767c1fa47a925e2ea8a296631508dfcc329cd0265b1fda23c01676ef28025(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeBlur, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__13d2198bb14af970abd918937e6ef8fd5d5daa0e6ba8a74c940ac87866776f2b(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeChromaKey, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8cafef903765582548d1721375607878a3a2d8d73d12fda4a44697f38bdf99a0(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeComposite, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__15e97aee62aa90d5466956ef26a49e86d9ee5c210a99e2b64efef44e923dd677(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeCompound, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c9fa440f8730817e923b1ac9de9d0ad0dc595cf3d57cadadefbf8139483593b5(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeContrast, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__730d3201678aad03227aec6a184e53fe409d8259750cce5090bc8cca967e72f7(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeGoop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__96627c9cc80cb33c24dbabeeebbd42b1ebbc6caa0de1a426cab81338e478c123(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeGrayscale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__77befbb7242fa56fabdec20def0f8b8c9d7a2dcc3d3dfe1f1d1bbaab5babae86(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeHsl, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5a203bd17ced9ca3dac971730999fb4a24fe48093b1fd30ab03cd9c399b17bec(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeHsv, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c22de40ba26d31d55ddf3b25a916b943789b67931cef20ba0cb5d7327f3f5dd6(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeIfDimension, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e6e55be45029e0dca3ea675b44dcf5e7c067134b67fe2c7425e4ee5a59d8e1a9(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__333e1ba26872fdd67839d2a1ff85de050074588816e79a0bc37669a81d583b58(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeMaxColors, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8857aae5b2217b47b941f0cb3005ab8cfc3f10320ff2d6893f56718b83b47caf(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeMirror, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d23796765a002ecd26fac70cd8ca151a9f553d94357f532825d1439eb169bf06(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeMonoHue, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9e92bc3e9e2fc4eba9477fb59cab414ba6d763561c5be3fe63a974a0311909d4(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeOpacity, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e1f639dde5c06306dba0fc1140e9ce9985f7cf434be468e8de87ec0db09c56eb(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeRemoveColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b01f55e214ffa776c819e5397cc6b9aae786bac268bdff7bede70f1f00c6d96c(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeUnsharpMask, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__162c7fb3b65f277fd52feb347dab769dce3a3b66be1e5231d05e91b4de13b6af(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscape],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cef0b3f9701b17c04984c551a661e0f11e0dfb12fbf57e1678373a51d935fa64(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
    feather: typing.Optional[builtins.str] = None,
    feather_var: typing.Optional[builtins.str] = None,
    tolerance: typing.Optional[builtins.str] = None,
    tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fb8d6cecf65626003fc35c3bc06cfef8275c89a2bf87b2d118cf07ee93d71a81(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6555e3799e2cac8971b5841364e11f9be4854761c25b70afa6d0adba338cb629(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__efeb3207a1be4483818a4764ff1457814343a30f6447040a822eba725ece8f5b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d7c3038055f3cd7bdbddba0847dadada0c5881ad5886a3e2ae5d4d92b0006ada(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ec207aeab4fa73bf6f9719a32fffb4c61570b2636cc28a1131f3ab6e1bb58de1(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3b97103180e95418ec026da5f08fa0f6fa39a53ec4c463eb93f3fb1213c0de9d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeRemoveColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b03e48e1690beb1cbbe8679a08a5b889f6cc47024c9b5dc3c5a35f5960401d6e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6b6aefaed4c801b480853375dd5a9caae19b5a013b62840d46c779f01c8d181e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0353e7519394edf6813525a937a754166786d803bc2770cab2ed8341bb41e4dc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__64c4f25cfc04e9fac3587f62b0b0bcfecb2863cb25f36ecba425b2256a51bb16(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__621a50d40c93b5b84506d7e994aa69dfec7b757830d9ce94cc61545b5baf0e54(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bcbd28ad0f71577ed173ec271d3de8e267f2b086cd4609e9daedb10434287566(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cf5bc7ded168a322155143c6aadc0c7f1b56b959c74f8a80bfebf86d616aa375(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__feac9da18a46a302405894fe28df8c011724cbabe8803474168dc514a295f3bb(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeRemoveColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9566124c2bb9846157da7609fb5d991cb20a1e318d5e63e30d2c928ac67f6f76(
    *,
    gain: typing.Optional[builtins.str] = None,
    gain_var: typing.Optional[builtins.str] = None,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
    threshold: typing.Optional[builtins.str] = None,
    threshold_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__91525357e572184e62a9df3a264284b4a597030ef2f3630f491f162244265f5d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a72090980a4d367001109ae3d67d3d6502c4b8b8af5cb30a4ddab60a7d516c79(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__232252c5e3560b2e91566224500de53d0fbb4ef557e18039592d592286c03c33(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f6276a4ab97f326669dd9bd33557bc737508f462abc77fc2f22a82b07518388(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f5250196f0e4846feb1921fbec63a054265682b4b7c3efbf536d41b0e84643fa(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6d1d9a7a1e88a2dda77e96337d9829d62e4bd79ca2536d00131613752f75f1bd(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeUnsharpMask]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__41634d1e6f6d62cf940926fef4a93be23e57d143ea36cc4f7bb635936bcad0a3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3bbca4947caa321f394ecda34dfcbfa186f8a35aca26247c1ba0e991eac1379f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__17df0e4201fe8f12552f29c06fd846aacd03fed075b42299e86d8b304e1b3938(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ca779cd12d204fe09687e554aace8774ae96bc207835a1b818e1866b8074213a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c25197644e659dbeb6ded4a20116b65a0aa74fbba7892ec16b57c1c636fa675a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__445b223ac2b957c963f5437fbc8afc0efeaa83251663876e46406207ea90c102(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5e5b3e130b24f1af4810069b1e1257a54fe6c49f292aa294093945a7deb53fcd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__07d97e9ebd0e656aca7c870101f16ce6d92665ade53bc4ae2ed6d8f7c61d5454(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationLandscapeUnsharpMask]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3491f1c16f9fc7ac6e37dd431a4f9780f9b66639c5db3c26ed84c380b8e98410(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3c32f00ca1055d10b7dd45e8f76199b68466251a3c2d849aa574ff5a11a864b3(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__90f2c4d8597be5e3248f35102197beac08bd5b2bb4057d1daa5f033db2527f43(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8f476b4d23c1effd5a8605855567df9e423463a0f9e0577b41cb121bcdb4fc49(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__752e76c6eefda2830036ddad33d520ca9ed780677607db399cc4b7b6410d0f52(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__db68611e46d6b3a41293e15311c65b4e6a2acd93cc95c657a26d6b8f00223ca7(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientation]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c74d1f05a30fe7dbd30f3a6ed168d5ecf275c4c665c9fea2f9d0cc9c50395e92(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a6aa77d5cd5a515d03f13651463a891caab9c832cd4583c3638bc9d71d6a8228(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientation]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__69621a44ffcee1796b305e9faa73742bc20f4c1f4898073b22de0f83f40365d7(
    *,
    background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
    chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
    composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
    compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
    contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
    goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
    max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
    opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
    remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2fd2c07a39288a3c91ab489cbfefb45186689c0226655f55b44640139ce9cdc7(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__64840646e5b7a3999686f23184f3c6deeaa63ebca26ffd2e4c2bb87b9b90a207(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__00cfd01e2ba3d03d2e3944d30452bd043346e1a9a95cc2fb119868a32a20a56b(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be62826f5bf5f07ce34b84e958dad2363855580dd1e71ca8baead9e41ca1a204(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fc130a651faf79f2cfdc5a33caf4c7367396a0495ddf908d9253b44d238f047f(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ccc9a020041e144ec6460eaade8fb70c97bc7c7a01f52397a0beecd8bdab8dce(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ac1f7adb76f77dd9dab0b9c161096b8fb077cba5e3a03c7c4b0d2bdeae5eafd(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitBackgroundColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2fa441903f3e192746246787f1858e65865236581a3e8c2f520c2dc2d8146222(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f5c436a6efcb8879cdf1a60423c357a3eb271b0d4787d5cf98208d43689d0dca(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c112b77bbe64925620eaf82e1d023c313f0cc9981ad68f60f43cbacf80cd5590(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7ce975705507d7ea1909bb18765862ce2319674619570994268a3d770d2ec17a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitBackgroundColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ddc3c3a545171aaece2c0b7d59e32948282805837bed8b5cdbf21349d43cbbd9(
    *,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7563fb516c77fb3359569150ec25bb848271c5f41dbb07ff6443c567cfb3a61b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__60aea7751026a3d60ae0d2452ab81402f37f358d6956a573226c492c490cd0c8(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e1d17d6ebfad2f37c8d9e144dff8d17b9759a31b5193a7013e28d0957a462de1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1dc15461c360eaea53fd4d9b8cb266cdf87adaeb74587ac4bafacae1a64fbcbe(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c57f6c83445b0f32586a32ebd20ff35e476df659f3bf936b3ece21621f2bbc2e(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__87640aa91a1dfbb399b296ad0d43bdd3f05e7d5567f3dda8c0dc1eced2427b08(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitBlur]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2f2f579eba576a2e3814cdb6af40059b32ec2f2af4a796d0dc62e01bc201e184(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__faa4790e0a97d87a586fe2af439d069ad443efbcf7afcd24380abd58b64a434b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__03476b1e17450636794d2602f46adcacbaf317d067b02401485a4ad9751eb209(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8e197ec573b7d38170ee6b35cf4a23d86b8abaea19b07a163338b1d82e0ee972(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitBlur]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c143006a84149b2cd338de8d6a299ab9f18a572c47b560219e94eb58a6dd5ce8(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_feather: typing.Optional[builtins.str] = None,
    hue_feather_var: typing.Optional[builtins.str] = None,
    hue_tolerance: typing.Optional[builtins.str] = None,
    hue_tolerance_var: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness_feather: typing.Optional[builtins.str] = None,
    lightness_feather_var: typing.Optional[builtins.str] = None,
    lightness_tolerance: typing.Optional[builtins.str] = None,
    lightness_tolerance_var: typing.Optional[builtins.str] = None,
    saturation_feather: typing.Optional[builtins.str] = None,
    saturation_feather_var: typing.Optional[builtins.str] = None,
    saturation_tolerance: typing.Optional[builtins.str] = None,
    saturation_tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__34c9aeb6574ba5de353d53618e77a9e3ae92eb50f679b4c984b9f02ec77f99f5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__837633ef61ff4847ed6134e9c09ec080125606c0cf2834f3942fff9ec2ce1138(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__552902520ff1515cfb4d23740027ccaf9763f3188cc70a083f719f464dd5c9de(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5c65110b1be572a532ff6203f52d8d114641ab899ad5b3af925e4f761cb940a2(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5d869470f5cee26665f0cb00d2bd052cec1e8bb1389573664de3141bf923b105(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__60baa05c5e92986e8e0f8e2685f2283ae919daac348ca4a1acd15d86dbe3f406(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitChromaKey]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__810e84020d19d9d7a752731c4d1f33b0bd6f137dfaa2b74d22ecc62a72c44ed6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c5c53fbbda10977752e9887c4775ecf94635152db84fe30493e25e893424cb52(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__157bf2170746f6f25b9f785c824788728849f1475e16047f9b66cbc0207ce434(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5fb4bce3b567cdbae52b848b34cfdc73de3af43bb5fac3e8eac0b6324a0c135e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0218e460a6776a29365a342bdb739528ec03070311f2688cf8bfa76310462c3c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__660b5d0f47e3f9d2354f076b87f91926dfda931c07db8f76af9de5f2a4a0d6b1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5352589ea5bd792b7e1d0caa023c7131e7690ec28cbbfc3d28fad77d113938af(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f64cd197c5657ff14c6cb0e406a350a4abb51dba5f8eb8e62b27e4ff41cd3b7f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f3fbd72ef2f86a4d3bcdc5f46587918d99dbd5075769d1fda5757d565477d8e0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b019da8bd80d18f08a0af206ae5f22065ab99e0d827dfdc765ac27c02b6a15bd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__650ec81592748cc199fa35ace56e831543c4e720bd5d53a10ac81c06ffc5d2cf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__028abc4015b8d575723f88a8b605ab5f710ce0674a4685f7e2f74e716140de96(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__19b011168f6e80f7f72e3067fb54d9becb7f0b1873d9aff4f2159846278446c9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8115fcd0711920dcf7d0e360d01ae9e87a5a71395b1a75b43a41470235886660(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2568892c039c950778aeec5c103fcfec695c582f83db391f3c8933074fd1b60f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1acbcd3cf4f76619364de97bdd1d1fa19767d5f254c5536649d621ad4f69cda5(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitChromaKey]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e9df9c035f666baf2ac8945f98ac7be9594e1559f7f64c1d1702b95658f16a2d(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    placement: typing.Optional[builtins.str] = None,
    placement_var: typing.Optional[builtins.str] = None,
    scale: typing.Optional[builtins.str] = None,
    scale_dimension: typing.Optional[builtins.str] = None,
    scale_dimension_var: typing.Optional[builtins.str] = None,
    scale_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ebcf98616abddc99180fddccfb081a2f2800a73ca8cd937483e648190b9c02cf(
    *,
    box_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageBoxImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
    circle_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageCircleImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
    text_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageTextImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
    url_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageUrlImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__921849e583d0b036e029bf0051ed29c0bbadef3d8c1c15591068f5bcc4d14914(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    transformation: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageBoxImageTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__770b254692255eeddec26e834694d09e6d2edc34f0ceb5ce83de76830a1c7e80(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__25ecabc896cfe488ed0ac1f85a2118ad13df305a13c4fc7bf6e529bf05a574bc(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__055314fbc98f6878eaf65b75efb65df042fd42f887e33ecd7d224155ebed445d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7ea852a654fed2f8e025027dbdbe72baf7c0e8b9448e091e4f7712b70c191fb7(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cabcedc106f81f4b81f398fd999cc748fbddee78eb1c48381589bfd73a3f1e77(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__74607873ebe758e4c8ad58a105aa9f112691b02dbebe219f5fe7f2e698ff2f2c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageBoxImage]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a96e33b79c317bce46632da769d82bf5c294d630954312a6b68a6d7768128a2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__50511d8d846c90ddb8a8fe3fcc89f7914b43a8234fae21f09a697c30011b39fb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3c57af4dc8b48001a4d826a88271688b918f4fe99b817da74aa2532c1736bc55(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__826d4e609a454ad70fb0350a03946286685aabaf809197a99219dfec68b13f19(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c6ab4d47c72daac70a1de2281afb7ee9f1d638e653afe088e6a1a5e7cc33f20b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4b7acbf06f909b65b115b03d74c76513af5cc11da334c18744905188163bac50(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b9edbf844712782751323d3f02cc96a7bf413a4cff1ac1958007d19caa672789(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__34916615dec37e8ace6fb374c5f90ff597665804ace4b40d2d9d3f6ab2080359(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageBoxImage]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7a4b02e4939229df17699ef19fc48d2263e75e40620abe337944a7820bc7b2d0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d32a64650633e45c8220c86539aaf2922432a855aea269b9f32e8896a7f6d2f4(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageBoxImageTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a32274ac3fb966dd4f6fba9bfb05084b327d66194505b74d53f2180eef1cf0f2(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
    diameter: typing.Optional[builtins.str] = None,
    diameter_var: typing.Optional[builtins.str] = None,
    transformation: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageCircleImageTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__175b42e7f368852c06e3e0d62ae4c776fe1df705d970b21ecef37ecb6ecdd29d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6a1a04dc927311117a153fe44b7a31314e219f0a4073bc46e5f8863980ff7ca2(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__305a27da08d33dd881a89c1bfc54fc41dc1d29a2a2d6cce1b9b3519aadbde948(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9bdefd72b25396a1f8dc2da3990539f6985f9b287f78a7244b14d9ffa057e78b(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4df2c5f1115f491f71820fd0f1c75051e699f070db19a1c79bd8ea535e33e905(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c5808627071e8ede236a9bb171fe9d35bec9cf610055e5a8ad5efc2907fb5742(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageCircleImage]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1931596b0da7217f099bf13c5570c48f3587720dfe5067ac440cf4b9d8b13a3c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e288eebd67f40bdc04efa32a81a9be37fd5066157fd88e2fe5a07b590d9603b1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__02e8294da28364daa51fa4ebf20ce45453cb993891247b558fd19daab5ec8ccb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__db67cb82c27dac2fa37c50c12811602d709d743283630a44d7e664190007dde0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__19b9989d5e25e65abf8c636438f91dacf7ea1f94bed5ff7386ba0e23b753f810(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2031672c7a31b9925e9ad259bd0e1b23ae3383661b48211a684de24b3620ccf4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__138d7852cbfc3b8b85f01309cc7fdbc74f0eedcef483d4bc2f607b48e1d27719(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b760f54cd88f22e3c01c1122ae07fb8928566b3d5f9aa673d2b020f238bbf0f0(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageCircleImage]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__08673219a1725ff163ee82feb768c6cabcb57e23c3663ce9aa400f72688eb383(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e8da601ea29bea81c8d1ea56ad708fefaf112b0aa387fd31a10b5d86935687bd(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageCircleImageTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9166f058751d40088e6a08ad23a7ce760031659a94e24e85316e869457aea949(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d6a1d40482f179902449b74943c3189fc737ed05a2e1a2caf37db2bdb01daad9(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageBoxImage, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b109248b45afc24f0e60c6a299c8c5210990d44b431ac32fab96eb54dc791c30(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageCircleImage, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__58c874169b4f31ec41d242b42b5e2d36788c1bbecbdc6ebd06b0c14728f67944(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageTextImage, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ee629d7c8c9349a87ada6be487f3b6c79867aad814c5ee19232c8afd665b6bb3(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageUrlImage, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a2301fdce6e1644faa0d9c2afea6b37841c13893b8a83ed8cbc22c111d3970c8(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3556a3a5be309d5dbd08f823277128526498ecf6a8dddcbb9660a7179ec916ff(
    *,
    fill: typing.Optional[builtins.str] = None,
    fill_var: typing.Optional[builtins.str] = None,
    size: typing.Optional[builtins.str] = None,
    size_var: typing.Optional[builtins.str] = None,
    stroke: typing.Optional[builtins.str] = None,
    stroke_size: typing.Optional[builtins.str] = None,
    stroke_size_var: typing.Optional[builtins.str] = None,
    stroke_var: typing.Optional[builtins.str] = None,
    text: typing.Optional[builtins.str] = None,
    text_var: typing.Optional[builtins.str] = None,
    transformation: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageTextImageTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    typeface: typing.Optional[builtins.str] = None,
    typeface_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f20c28b26c7842084aed00cefcd3f28a1830e64680ec56524a398f8e9c89cc61(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__223f02f10807886b47c03d5463af6d90e2c52039cfc41fac7fce8ff2cb2e6375(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__198017118cb19538873c082e55be1f8651a5f42265de19ea8536919bb18d2118(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dedf50de275e160d1302e61b9053442b0556d94ba613871fa693639759286197(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__21e18787bf1e52252764e85730a71991181c3644225817bb3c092408d39b8f9b(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__82a477fb282b09abd7b1ec0df859522ed2ad951e2fa5bcf2e73896b130f074ff(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageTextImage]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c17875bd1e9018a095716e080a55b4b04efaa556e6845061f8312a28258142ce(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c2356de6c78a0bdd633f549a3fed0059f2cdef8a70bb09f4e745b4e35ae9aadd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a5482dd14242f82cdbff83ab1e96a71404e1cc6feebae707e53eb71c4f4be1b4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bfeba03864f05a902e002ee52d255dd44de103478acecdfff435d829c3c57ece(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__45336edc3e27ad2ef3360c4d8a8a8a31137997c0857c4987cbd22cf37b85e52f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b72885f8d131c0ffeb5a05e202e9f4012948125f8a6eaf3ce637e3f0fadca8fa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__00322bf4372389fb703014959af441c1a6f524e631874e2ce4fb1df779a326bf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f785c01ec0d03222439d4103d6cf69b767947d0860301bb0d0bbb6875824b3b0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d3b61413f8d1503fbcddd711f1f279d5b215414e5032526681e95ac3bb74bb1c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ec088a9661b550777d3c88ced0f153f2bace138a00149ef7771edb67947f515(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cb0fe80262395a64ec3caab53946805691e2c69cd5c232033e68e27d8568f3fa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a2280082b9633bc2140d66256a5423b6814c6ffa4690f7054661edfb247f2602(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6150deb2c5c3e300bde0585613272a12cf44aaa2f756d6e0e896d210854a460e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dce3a60a11daa19a5d80a52ca6a056a4ac56a11306fd05cef0280ede524288e1(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageTextImage]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__92a0ed8cf2eeb721c42123b592994c51b0713b80a155aadf8b5932e667457651(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8f32dc3e8e3cd5ea031705aaae7ccdbe0bf4288c96083ea880ebd943ddc942db(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageTextImageTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f1ce7a552c1441e5e443a585986df583d404804da08790f8a03a1507713c6d99(
    *,
    transformation: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageUrlImageTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    url: typing.Optional[builtins.str] = None,
    url_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__454ac020b2d85637c1a7b55d2a94eb52143fd4a7257f1cb38cfab49c5867bebf(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5118ac7e56607acedce501a03877fae11f20c62d91b012a8e77f4f4d65666a5f(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d7b0738b871db30fa7d93cb7904c2b12b09fd05ccea6828de939296ef3a690ee(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b55f4c821f4f7c504404365f40f62af55c2a530390a3a390d49567abf77cb5a4(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__12841645779e0186ddb4069a13407aae7b7ac450f9e74f4542367f97a8ca86c9(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b6ea570f1263b0f1db1ca8988ae81101f03ed36dd76a5bfde5b0f3dc9b511fbf(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageUrlImage]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d0c590834f362315260046f3087bd326ca9a2da0ac02e5a63bf484ea84ae376b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1b10a9036f055d97d5aee61bda4f54562cbcdbebbe86dd8b6e745e20c8c8389d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ba4b8157f43933edb6cdf2c290c9f948008a2436a3dd413ae815cecba99268c2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ffc5fecf95e640caa7c5bdad26e01ad8feaef660b5edb61433606fcc7a978961(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageUrlImage]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b77d63541e1a98488ce5fee819093a2a79025529c1b819057d54d21a33e3ba02(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a7a308180208120d07ad45573c06d3074ab3ecb982a0db4aa3931296d2a8d8b4(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompositeImageUrlImageTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0a4314b000bacefa8f4d49d68e47a8bf465ca3f11a5deca5471d75ccbf15ad7f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c0adb75609678f9ce1aee47cdb31448fbf94bc598af5de7948c549e5cb751cf1(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__542fcb6f8994986576b426a212a03aabd088aaa1a163ac93945677df4763d149(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5251ab022a73489f2982af31390fc59a27d673e3888ad709cf0fe84aae2cad86(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bf238fbde26fde3975e084baca3f502f03083150ec74f55e4be7d87cec08eebc(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cf1b5bbb2362c4e16366dadfd6591e1dd708c1e9e4e1f68e05473da8af61465e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitComposite]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6b657c1f8fd03fdeae88b03ef804a2ffeffba7edf4db498087ccee7ed88131a5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__89a71d8425a2be02399660d3199885bcb8aebc857862a609b1f3e8b1e8736ed4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9f69942685063f835d45b9b9edc7d8ba96d7f770e21a7113fad223c0caca615b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e12903dc79d408b8b75f984c677ebe9850cd402aa1fca25c9e04782ad2df73f9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d13f82f3cd27a040b57e4e0384c4c8982ca2c77cb1722fa33dcef5e9037f401d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8564c7d3c4f72069a8dc6ec2e0a8a1f57dd0698687f4b53b77b4d1e4c6c308a8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__640b3499174346a6163675be4290f23f54f99270041aa899fe0e5d9bc6f3b8c5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ea5a677c254db016f72840359e984e4d42a7971fb701ef1c31262e26302a733(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cddfc37ca4dbaebdf02c76388b85ac732fe2ecb873918a5af36869af4f54bfea(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dfb72075beafdad4a93ef2b01ac945f8a31cb015daf4c207dd42387d6784653a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__214f9dac9d4700ddb35e971449025884bc4dfb480809f4228ee6a9facfec54b0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f20e794d0b708f80a5e295f1e59d1f1980ea7ede90dea15d686236df8a4dc739(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e3638a7d75235696a1c8d0e2586a0ca8c16a1994ef7797b9fae3258766f1eb12(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6a5e0f4972ce2b695784d86093b32ee43cb8abe489916eb3c6ab570502d4708b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitComposite]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb06f7437ed4747bad845434b1c087cd5fabbef2eaa95353f232634aa9e1e49b(
    *,
    transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__64aee2edee707ecb41548de01ca3f47bfb99a4f336d9e28d15412e75dcffdbd0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a985dc7dbc2942195159586518aa62008e1fbcfceb314ff34ed1ee77f044d649(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5cacc92b3bbf02c5474b902c575accac510325bc60fcca02326ef65b3e27838b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9545ac7b5a824b8d250134e9f79973272bb21175714b250d83f7c3c94b2366d9(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d2031655efe90fd6c18b779e4a9d751178370c6573172bc4879a914fbd0bca6f(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fac48ec634f4a4ecf6d3341f7a9b8663589d4a272353637165b854b2d7b4410a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompound]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f409b2dac59028bddc7afa8011cba3ee2f40b45b5d7b308b156908fa52aca69d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5dfee8fe19f03d145068f7efc86ee6b577fd97e1551fa8586e320d779e9eed8b(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__75114c8ef30246595ab519d2a29ba93dcfc34e5f6d1850bc84cab1252201b59a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompound]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cba58d5e07a585c8fe8c349dbe84a5812161544f297e3a40f5f8abbf0f55e273(
    *,
    background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
    chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
    composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
    compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
    contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
    goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
    max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
    opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
    remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6016a515b6387ac1d92f2c35f33759b9b01e0de5196b1db89b8c3e90eb7fc139(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c2d8ec12c3f521b80ce0c5ae459aeda152cf93295dbd06df8f0e95219f78405b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d450985559b74a0386e712709591ea0ddf51a5c90beb37cb27a22faed4150a94(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a668894c100a57082b39c8799d850d8c58c29517ac7222c0eb5bffbb805ca9de(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5d71f2e5efc270d37fa0c0f2e545d0afcac0048547d64272d2cf4fc05faa1b20(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9c9ae1d9b502fdc210f1147148d12d48f839f92632c4efec8d394660779fb37d(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5e96a55318abe2ff669688e4e01484c8e7d27d961c64fcf69253cddf08170259(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsBackgroundColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0e4a2d1d500143b3b90cbd031317e4f275801de3efa8e0cc9f0f53c880643346(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__154e22f3ffd46205360f46c0a4732c65d7ca5f03dea1de28bbbb3257e44e1ffc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fdbbf3e76b6dd38888b651d23458c0484372bb426f1885b7d7d5812853ba4207(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__63f94610b420db53bb234452ada81e184fe21f07a3fac3f4386ecebfaf4a3e01(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsBackgroundColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3c34db33c2a867e38d6ae26e0a60d6810f61500139b946ba60c2bbcb2eb7aee6(
    *,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2fac5f4fe948e8364f88dc03cded72c3f110d445e4951fdef911e466dae84909(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__260315feb37f0725530baac32799357467b5e3c178b44ed32d7eb1c06d33efdc(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2e21173fe44acc8ba94ac33c64759acf2262fa4bb42fda0f3b2f3b4b25664df0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f5384d7aaae3420304d2fae120edfc621c528fe097825cea8583d5b756b2e7bb(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4493fe45198f7e59a594892d8498492177b14708e150829c88a34189ca4cead0(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c911aa7194b8d404caaf10b5cb284246399f2fb49dd7da4fdcf9d9b64088a925(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsBlur]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__691dc55dbdc852ed70f0d408af946ffe19b22165c1c5e7c19c65981642e1539e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__61747f7177d80e6807b503980731b0c8ee6d70c4f3cf0fd0434d6214772a6dc7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0469d13bcb1fc5694cca0d6517d859996b1d9a224a835ae583af817147c89102(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__654ad649c921d8e3d8f0bbed5c1e515603e57762cea98b38ab9e5f3ad379fe74(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsBlur]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a8e0086adad8430e07d6657aa758afe27744d0e2aaa10a54e2d14bd7a501879b(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_feather: typing.Optional[builtins.str] = None,
    hue_feather_var: typing.Optional[builtins.str] = None,
    hue_tolerance: typing.Optional[builtins.str] = None,
    hue_tolerance_var: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness_feather: typing.Optional[builtins.str] = None,
    lightness_feather_var: typing.Optional[builtins.str] = None,
    lightness_tolerance: typing.Optional[builtins.str] = None,
    lightness_tolerance_var: typing.Optional[builtins.str] = None,
    saturation_feather: typing.Optional[builtins.str] = None,
    saturation_feather_var: typing.Optional[builtins.str] = None,
    saturation_tolerance: typing.Optional[builtins.str] = None,
    saturation_tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e445a80ce67a2aa338deae99d5bd92be6c91910010bfab8db7d192a047175092(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__155d108dd5e61f8541d72e43807331be88b83a379c0751083e6686b94cfc1bbc(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__11bfc3620e76197ebe2fb5d156700849500596c77d6c95c8667ead657732e3c9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b8f1c0d43112ef3e841f023b7250b92dfed90830de2b72ba339d1c4ed15525a5(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b6feea70dc0f1c60e3f980ece637e317670bbd6c2b136f30f3a8b7a68b23c852(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__737864b0fe5ef6a582e0879609e96f92c7f7016c8ddc28015a07791a0526e429(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsChromaKey]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bec1bf689db5fdd4be1db5f84396b8692daa49fe87342a3a3506a5f3361ed143(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a01d62029049816bcb06eb5217e2f6f4918a7a52f4164fdfd3d1c1a64c778c9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f7b540094dbbee5d24d09a86e16dadb57de16c956bc420e504d91973ebc68880(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8c3b3eae98689d171669ac57911fd25da2ab19635aacb5ff8fc51281810891c3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cae5de5b110d1f2aa55ac5d4a0f3b1bd2d186a55a317274d8406d2227ca867de(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__55a46a3c8138a9e4282803a2bd181dac2be2a1b316c71c9fb191065f5c7c7fc0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e1e8b6d39802554a42756a665916ce25ca60aae95545323859c1e6b4e6c2a4dd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5eabab69f7222be5cf30794994cc273a4d65d11dd7201c59cda5d534d827a0d9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__283ea54ff3b284f28999641c45fabf603a1bbaa5d7dcb17325f2b951752af519(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__148d41c2c0cf09ceb25891250dfaa26f30ad38b6f6b14a661882708696997c56(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a89187480845ac7b69f3b09446fd97698449c3973d33c87c864774f59c33e8a1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6eb41538100710a608aeb63c9526a24c13a7c8cb28f92bfa966dab61a60065a4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ebea3a61c894faf7b1ba16c4a9dbffe7ee3785b5adafaadadf96cb9951cf26e5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fa9251e91f9b2e591d10a8c277dbe5befc85a4f4340338f29c2f4ecbe68c389e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__289f688996d145c3f93ab4739e16947075b2c8d5dc62317b2a6c910bb8f28632(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__60f6b9fc5a4b6bc7a43701d588135c7f371ad2dbdb411d903ee8799acc34ac35(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsChromaKey]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e2fe6b8367d1ee6da7ec17c7a5c5bb7bc34bf06408be17a207133c9173ba8810(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsCompositeImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    placement: typing.Optional[builtins.str] = None,
    placement_var: typing.Optional[builtins.str] = None,
    scale: typing.Optional[builtins.str] = None,
    scale_dimension: typing.Optional[builtins.str] = None,
    scale_dimension_var: typing.Optional[builtins.str] = None,
    scale_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__63ccf1762394586facf1a6967192b3a51d545e0d96c784a9e240cdfd25e16759(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__921593ef3e9f4fe0de95e6be41f8a29de02e06045228bd1cfddfe51e08a5e4e0(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsCompositeImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7c12aaa72507964bf87b83e0b610e6be5575563ca282c73af6ecccb0333c3660(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0187c91d8a79eb681ae248be4e67aa7d4cb84a6becb9659257bbb9fef0b84593(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__16968068f9e2274e0664263fc7fff125253fe443bbc3ae4d8231293862562d95(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dd831a31d9de1f26e8801eb9161814c36b9fb16faec10508e20e098b87e1dfad(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e96da206669c24079f1563155fe3b286e60b9412157b8bff9b47c118bf4bb249(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c33bd1e1b3081e0749c819e2dde4569dc8abdf52961f92197533e2f0a901a29f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsComposite]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5a87eb7299afbc9d5832af9f81a255b8600e40b1ccbccd3b6b29bba0af08dcc8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__26aea2c7715b028597b839503c05e536871890821000b5128ac1c39c65f84010(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__51b6a0a830759db8b8a04e49875ab16d184fd1796df4643c611f2911e3cb333b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__36ce3cbb5b3858fef004098c69c08d90a098516cdeda1a26f65c824ff905620f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5230c399a23f88f24b3c019fb71001c31192ea354363cc3a9c81ec8c45eb3713(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__78bc56abdefb8dde02b017930b6f642bfe9e9add51e14bddf3547195829faeaa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f0fcba8ca8bf1d17cf7baca38aff686a2ebd71532f0df858c91318be57cc29a5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d0305e83f4be00aae8e2f02b054b8d8e578139277ceee0a4f0d0b15dce9a231f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__74df533468739485a35821d6260587716d15a1937032b030f065302c9f4d925d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__45d4f21ee3f286d2e9eaaa5a36e02207a58d31f5ee405be6dad33a86f5a3a10e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dac49bf98396786cff914d1403679856138999efbd1dc26bd6e4790d8f28377e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__15375b0be85c08e34aa52ed66aba7b9474c63cf79cdbc96780f4c6293776b3d0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__05f7a4cc3a22a155bdbc02377688f0b62968031b939be137260ac20a1fb943a6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dc421ed2af95203b6e8511c0ec1f59dbf7422f100dab7e06bf93c7f58c7b08db(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsComposite]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8e9e01e657aba59d26c16c8cd0f0f1c7b08b0a2647b2fe9dda2bef47bc1b828f(
    *,
    transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ca5e6c2a2995ad87524720adb66f7a29c35cc2b94504542f07a43786d0bd12ac(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7a1caf577d512a123fb0c6801ee67c70165b228417557fefd12c4de93f917c70(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8901f9d59cfcb8b0775f0123393f07cb971104dbc4419a00e4c4153e66baa1c1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d0e6dc9d2dca38eaf1d4fdd7623b77e6f52a38503250c436ddf8c9cd7c6321cd(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__72cb9ca8c581829bf9547b58ca02ddc658b12731de897296ac1b1c03889c7539(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0798ce86fcfc9198f9816cff171a1e59b0dc0fdb724bb37e4c78f45518aa9ba4(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsCompound]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1914a2ee7f53de59856b97040a01608c9f576abb608dd5e6567e51dcbfc5ebd5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3dac10cbd742d948d335df6509b2ad3ef2f3bb13a1fadc84db00381d4eaa48f5(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__47956ea28f371d866a36f867de710a79c61f7c076522dec3a5810e23ec2e7f01(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsCompound]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a449f2f022bff3d9f07bd21425c950a02b1256e051d183702bf8a92534ec098f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f3030172d1e2190c7b64f456ac9ea8b59c7602c80cd5868ca853324d30fed73a(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d102c67b7f4bf6b7b8bf227373a4699de4c571bb027ac943c68202edc2cff3f1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__05d6bc3b742d680ca1708e2ced048d2f7478212e8e72d851982a56c6dd459bd8(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e6ea488a757318dd8e3b5107f9f628c2aa375644db920b3d7466365001076a5d(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__39a81d73afc014d17b3c51a1185cfb4621d97cfd614a5a0364a9e926126d3afd(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsCompoundTransformations]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3454588cf36017cfa3c2784b878853588c4f151bc63b7d1646d307f2d1a41018(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d832a9d741e52ec0b70c443352e7ddd3f2ed260e553c9794bfc046ed43809e9(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsCompoundTransformations]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e2203d451c37f251b19e00825685389c9f17e038cfbd5f6790c49d1528377e0a(
    *,
    brightness: typing.Optional[builtins.str] = None,
    brightness_var: typing.Optional[builtins.str] = None,
    contrast: typing.Optional[builtins.str] = None,
    contrast_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__95748b5cdb3c69b3540270b224f873a3442173d1e6eb6f507ba0c92d8a2e093c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c68ee2349a68a78cde4b4ddedc1df636a7b78887611fcff0b93549a7f3be9853(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2b8520090e819a3d07355da026ffeefacb8dfe1f914a81cb340cde0a1630be3a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6621bc643adfad557f39f0fab4e914a6f3904f148d67519e528aa5179cf95364(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a0ce44ab1abda369f3b99198ec8f7a0ba1590d1af537ff27436e0e3ea6888086(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7728094b0a02e1539aeaee99a27b7362c47b917c06d44c7e7e49c48f6fde9d7e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsContrast]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea3d21b7a92fa87f1d9f1d6443e41f945ef83c40afa080de34be4e1f3cc13897(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__94cc01a3656ceb84646681fbd3a64152c9a908a962e328662b9fc42448226ba7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__124aae644bcee7e2fb9a7b4e26adc2609640ddf83c065f1ad7a28c781fb4cb0e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5a1a3c16449993f4977309f4266b9a478b412032bb5791506ab2f5e7ca9d19ed(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__07444e2d4c61f4bb02527c426d22b720d816b9294468e9efecba743bf40a5b8c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8ae74f6cf8655c9779f67f04c2cb63fb42ce3850870bca5103a2d3d573870c5c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsContrast]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b33277604b889d6a6179cf031b657b2d6e6edc7bbc3235ffbb23695b9bc345fe(
    *,
    chaos: typing.Optional[builtins.str] = None,
    chaos_var: typing.Optional[builtins.str] = None,
    density: typing.Optional[builtins.str] = None,
    density_var: typing.Optional[builtins.str] = None,
    power: typing.Optional[builtins.str] = None,
    power_var: typing.Optional[builtins.str] = None,
    seed: typing.Optional[builtins.str] = None,
    seed_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__24824e89e4e3d87481306df86d1dac30230bc300181184792586547de329fa99(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a427791c6fa9c17af07505590073a62f9e8d31f0056c390ae181a850429cb59f(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a080f9eb7caf3b46dd095e67a5d7552af38be045edc2aa0322f1d7b098acdb42(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1586f1f6612054cb5fa3f8ed3a92f99896d989c79b9e0f539221a559fbab7e92(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e4cb0498cdfa019bb6ffbf5634b8323c78acbe9eea09bfeabc38352d180ad330(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd85ff3c6974db83b09b313c569c3fc699df07e67c65d312c4f0745bca0e9857(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsGoop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d6c0ad84cc5485b6bf6c882c4f152e11cf347a31d608d2fa01fa3505b8ab2fed(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__81cd5e6f0661943229e39bdcb51385e4dc7823728b3e3912498a8ae8c512b68a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e4a2e235616a26ee72648af2883987f24f2089d709c96bb0289c67e68277f406(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fa29561580de64b352a0723ac9629a01e462e082f65793308d93ee090841f5b1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bba69b153097882e1b116e3a396bc882f710c105b1dd8c5d0b7d5b8fd0971b73(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__09a2d9ca5bd89a404b6f6764045b41d1989c26c8bac9c0edbaca7410abdf9141(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__83b6e10ee7d8ed3da7515d3b7f891016142336670ed4222cb8d7bf90cc48100d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c02fdfa450b09f72df9d97830bb5d1cc34269aba3b564d43b88194d2c813ce45(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__501de0b5ead232287c5464758bcae6639d3127cd15f7a39d917954129851800e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e7dd616d08d712529ea7b98758235b7212ba691c8cd990be070909594aef8269(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsGoop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__894b83bceb0fd64cfb90105072ec7b3685ff578a60d33735080947e25d78cf25(
    *,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6c9228edd49d6389c73a629e57e4a88243cf12a2d5f08bbf359ef8f65437ecf7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__abc60fe105c36bd286b96b055638499ef3d8afe620b5131894630bf47edd7df6(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__61198f283c79ab28331d3832d2a351fe5065898276b99e0f3bdad335831f6e04(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3fcf73e7d212812f54c67427c33639eeeb0825ddb91dc3a07aef21d986553b90(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5fe63a5aabc18d6385e44c35992eefc9248fb3bc158bff53050a7d4e38794b1a(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ddd5a260d9a317b50d5f65b655f6328b75dc1fd82cb35ce8f0a5fcda7f9a7fc3(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsGrayscale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ae45a3fce6bc195f1a5e272eae65e61970fe2f250f098b45268f2e2abdcf80d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7a5efcc1720e90aab680292a2bbb9416bfec39026b9831db6333ce4528e1a4e1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__023584f80fcada55bb49bdd2b5e614a92bc05400dda1374ba147141c40653e46(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5a0c4523d9948bc983283374d3911b095525fbcd953892aa176a30872677a8f3(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsGrayscale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__49caaaa438afafc70b10398bb3a641596accb75afb6f979b1351f7f964674755(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness: typing.Optional[builtins.str] = None,
    lightness_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d41ab14dc8d3655deb8b60900e25079bd22478a3eb308c6762776c7485e29173(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3f7ae6d38965b5e35eeebab6f67363c46f35cf353501d306521ef6b5f8092161(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ef855b677d656682ac8f33b980ecab59e6ab4638683c4842d2fb66b90d81e843(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0bd2d76a891dd6019d672ef14737ba042951a53714662d0fcf5269a7f19b1b03(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b7f5a3ec819a777ece8075f1b0d3c3432f91d3027503acb2b4a51548fbee8b06(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4e01415dadbf0acca96aa63d1bdc82dd4c97e6bd3497abf378eb25b7965d11f7(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsHsl]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab114efadafe9f0eabe648db6c8d2bb6aac5633282395d76c3ced6d7f25c042d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e1956acbfd51f5c2d76857b8c35cefcd4f940b55a97f014e5454cdc65df31ee1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2872c0376eced0c80aabf28aa0d2b9ae7b9d06c39900a5d0c42e7efaba4b8165(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e0c495dc45d982d44338be997f28012df34714f5a30bc38a11d941f59de0e54f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__436630569c2741b470bcc96510b6bf72b67cfc148aeab86a935a16a1111f41b5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bedcfa9e184f628b61d126594119363cd02c287eb92a56bceadd1f4e6066cd3e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__734f449c27a3ba0b069a35d4fd4aab60693cc6de795109e8f5fd838f224bc9e0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3d730f45de86d202e779660a5e06b03e90bd48e3c3c51db3fd9629756542aeb8(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsHsl]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d5dfe1fb0339122c861ee94850e6e7d24db089296f542d447fc05653fd24d2b5(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a401e9f1727377300bb65ce889d02c269f0e6aa9dc639415d5f8e25bc11bd15(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0f7a7febfb67ea3f11d881ac949e588adf839a44c221c9aa8ad55c2afd8bc2b8(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4bc9232b16ff4b731e110d1e028b64c9fbc8b3952fb7517beeec865ed43c9320(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2887d560bf1163db86e30851edf11475915b77b2b032921ce1227bf7e77e19a8(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d02ac139ec40d2527b341ac602c3238c5149aab24e2086ec364f944b86aea5d(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f1a3a7f474673de82c03a8c92c554a11729935729802779a1a7b9425d7171427(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsHsv]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__02af5cdf4332b2adf16a2b311b9b8260e80c93216313192a8e84c9db8ea9ffe6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d57496b4c5eb0da5b895351e5ab3a4a182872927c064113299a0526955f06af(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__638b3b00709ba870cba7d6e6777185a7e5e08a4ce9541d688a4a7c14f1585d16(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a9331c072e85a610df08500c9ec2c6aacdf05bfc616d49b09e42588580fcc0a7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__76fc6adae9ea9b245f84a9a4c6f56d7c43bfa34e7bb13af4b09ec1616b9f0ddd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3fab33e8da40d2a18853c322a207a0b9c63a0a3dbae488a458b5889eba50cec9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fa5155ff04432c9cfdb0c7e1ce8bec93a93edc770fc24c88a3c4a26058fb13f3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__adfce17c293d74b6c804f8cd353a1bd12054b7619a076bad1d688adfaf8ad34c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsHsv]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3b3c37fc9a19ada38b014d82d3f0952d92a3eac695620cb9f2bcea132fc2b1c1(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfDimensionDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    dimension: typing.Optional[builtins.str] = None,
    dimension_var: typing.Optional[builtins.str] = None,
    equal: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfDimensionEqual, typing.Dict[builtins.str, typing.Any]]] = None,
    greater_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfDimensionGreaterThan, typing.Dict[builtins.str, typing.Any]]] = None,
    less_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfDimensionLessThan, typing.Dict[builtins.str, typing.Any]]] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5c5b9d80a120ed8731b01647b8be98622cf6da4b80a0391a73b83df2d7679e26(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dd9bf224bb5fb83af1ce0ff97eba1434c72cb4d780203ff987d84f7f8f1c0c4b(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfDimensionDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2880330d06201eb53e54325785ed076d6922bb66aa82b8a6cfbed119c593bd88(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aea31a8f47938d27449a4e197c49007690b2351b69a941d3c18587c3e185a009(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfDimensionEqual],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a98f1afe2f20536229668b85f9229c54d6bc5c2e16bf99cceb660386340f5c03(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__40e4a277bf20cf0c77f10e1af3a09eecf3968c244a0150e2cd81f98c5050beae(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfDimensionGreaterThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__53de8f14138aee041c6c14776e619c5387a396c10f17500fa04524c8d5e6d4b8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__11f7b11d832865e3832fcedd940a3ba32493a4fde4a6eaaca689314e08159e6f(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfDimensionLessThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__64d4f431103e5952d786b202d712b015aaf276f2fd9259e6076d37cd44d3ba4b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__78fb7a18d3b5f945bd8b5693f8f48ef7c8fec4bef4d3e40695610165b45752b7(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__40b99d3cbeedcce45de503c8d912dba2930b7cbcd6752be80b325041b29dc66a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__07c783fefd0b6c7fca8bad44ede77771d750433d3ff08ccdba3792d43b4d461b(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f7f3bb66c0b6c52c922d4bd1054511a9f89c6850ef78fb74df1a93b7cb4aaec(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ed22e11266e69ad96b7de62cab295fcabd36e21e403525dfed133592c2c54a6(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfDimension]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5a2aabfcc41b0982c204dcbaa11d991345802b31cb01c4bd6a2f15b2d9e378d1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__97529cdb2eae9ea6b0bb168d534574c58d07d7ae17dd12d010127f334a7aeeb1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1a62c42c2f7fb9f12a2a7001c9d899d2bd819af1bc1b5299fc7d576cc1f52bf4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9037aa3b1b3b86f2e61bd9edfd0d7cbbc17cabd598e9792693276a1fcbab8c8d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__11f264ebf0636685ebc1ddc36f101d71f284f2cbae8c61f379903e9fd5188272(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fb928b23e394b2c352170b3bc27adaac22cbf014abce04f97c6f3dc1bebefee6(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfDimension]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__975599c86e6f02bc3727088247589ad590fc06188ff088acbf68e2540642a730(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfOrientationDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    landscape: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfOrientationLandscape, typing.Dict[builtins.str, typing.Any]]] = None,
    portrait: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfOrientationPortrait, typing.Dict[builtins.str, typing.Any]]] = None,
    square: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfOrientationSquare, typing.Dict[builtins.str, typing.Any]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c7fbad6fa057f3225710e7f96486830cb3b4d4a25ef5054377e36b2f4fa723ea(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2b0388c9e59ba0bd0eb4a46e1d2263595e4bd800f6e01c214213270fc283287a(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfOrientationDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5684e42a796c67d0ec35c4e1d5b685f5b1f8e6bf69394659c51004ea1292cd6d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9e7ec2c829cdec4a2ccc5dc408fceff8074e9f00809e351c3679c7fa11044b01(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfOrientationLandscape],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e854d262d3d668692fcbc668a81cf2c9673446031f9120e739bc52dee6813ad3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__37a79e92879b5621fc10f26009c33c2ca2c071541448a523c915516797c2fb0d(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0d037cae0d90c5669089e36815158670dcfdb13b20c144d9ddada30188517e5f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3eb1dac7f9aaee9c6a4639da923ed3d0c7f393b37f7b74837a348c0358e9b1d0(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__55e28c55229b16b10eca6663c10f42cceee86adcf028b94e1697b55834970144(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0c58d7217315f6dd8ea30d75f08025342b430bc3abbb855e2fb970933d2df7cb(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfOrientation]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e098662fc0430057c1909561e8525f50f337214be299108b41d5f4a02db8d4d8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__772b9b8b7462b4d3104fd25254a03afdff318cfde8957327de6a6c2ee8ae33a2(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfOrientation]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bbad738149d0c8465303b1133553782c8ab9ea8bcc8caaa8a071671746936a97(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__067045e357d1db8fa1a3812e333fc7dd558a0f121f219a250930e4b43b9d6bee(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfOrientationPortrait],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__80870c16b796151a5f5d8a11274aad8b6105fe572dc54279ad46d7c60229ab62(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4b2d697df9fb1b999b233e38cb24e7438ad431fe4bd37a4c32df96268757f5d7(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfOrientationSquare],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d8eb6b6895d211d547d2f22ae8459535703906afc2424be36f32cbc4f76de5b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0a4ce0fde97bc39ca4dc498bed2f88bdcad0bbc5910b29569a04c0a315a6755e(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f8a5ab63ac5c23dd2c12d448971ebd92d7271b58bcd66f4b16bc90edb528be9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__77e51c6d1ff597ceb7c8a3f291974c3e6559be2eab90ae7d7056531d1ea53b7e(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0c355cf480dde900779e79ab2f933e94d46da692a553b94cf4656a7748242377(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__63dbf5e6bfba7bff3569f112db140390bc878d919c97539e375e6c1ba8d9686b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformations]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ccd987d12244c3611e18ff1a8ea78b6b443b2e3df283b25d5b22104f68d6aab6(
    *,
    colors: typing.Optional[builtins.str] = None,
    colors_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f27ec4d0a537550a0493ee05c6f1a8533b062c18b88fc4930bb73e6b767d9a5a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__842f3f0785c00cebfd6f6c945628e66547bd7d133e2f7e85f2158ec226cc116a(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__93c71d93038a0257a8b0530c84ff5ba6500eacccbc244575697c5ae5f260debf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__60d347377e344e2097b05b63b8dd6d07dd3bb17c8c6649e1aa5707315a638deb(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d022c8469f74696885c877551229ec3ca94c233c255cf3bd082320e0997d4811(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b0c7ba74f0cb64483929b0f18f22e30c669afa8299017b68a2a9eddd90bfbd94(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsMaxColors]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6ab841c83825d96e48c87396555d2f328a31a960197cf7c8a9f0133cdd395467(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__330d96b7d68cc78de6d9c68ecbb261032bc9bb873b4a62143d9cb2ad78d32588(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__32ba8816ababba56353c7dde74a79a6f89845249f7422eba5bf8074b31aeb3cd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c3e7149e253c67421536ea849516c6440dd6aea260b66f1ae3c9c0fd6b800805(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsMaxColors]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e80c87b5042cc6be754e4e0092bbe31ca809a7445253c8e24c14290149f45434(
    *,
    horizontal: typing.Optional[builtins.str] = None,
    horizontal_var: typing.Optional[builtins.str] = None,
    vertical: typing.Optional[builtins.str] = None,
    vertical_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__221da8f90c854a77002eb18ea2a1c4727f17fdb671594fbd0e7c5745d23a3e67(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0fe14d207a5deb9f286c503c82e4431f2e59991f04c2c48543dc3c14a7501004(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a679c0c499cfb800201c18b5ebdc34326255162459b9a9cd8db4890fe65169e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__20708951214acb955c6f40875f9fa7def8d7b3c34af7e5a6d40d76f99a66e704(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b6b4039f8d3f405af8bbcc6f801ac6775ce00b19211d1915af6a126b0b54b60c(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__183886b452ccb974ec50b82b962a63ad5591e02676a0fdf665aae05580ca20e5(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsMirror]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f65b5ae2e053e5af44c81835ab94f77ddd00326857f626600fff212dd6fc4fc2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__42d993f22a3419c38a055d01e636e162b60adc82ae759cc6f5c06262d281c1d2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cc42b3f916644b109a5f6617040cdf42962425e45bbf0c6f0cbbf04004c8db9f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3f4563fc1d3dec67dff5bd91b27e236b9cb92f84dd8062c5a8e0c8d449e6ff22(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1785bf20d210cab1abce076da85bf9dd85256ef01aac6aea5aaee468fcbb67f4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__877c5d240221f5455551761869b944203e73830c9273e54fc48299322dcea293(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsMirror]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f0e6b85244bfb711a1f4f97e7ad93d01c59ebcdcc19a18d5b75bd1921413a96d(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__28c1bab35cb028f6d3399731c0f1e6182faf6cb30b653fec729f7354ae99e13f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__04b59cc06a5fee3f6469a05d97149c5dc55d51aebf66b83f95623a7bc92264fc(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__180b4c55802c070edf5d11ab798e55106819214b34f97ebe21b98d1580334753(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__59b1c8dcbc181cba89207bb67686f51bcdd4d7a8d278a562cd3ce374c1dd655d(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e22e0de953d41521f570ae5af5dbf3d249c634c77eebee45bb16dfb0de3b4f6a(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6a02a06afa75e06b99c97572eb5a0b0192cf36c76c3c70802a57dc56d8a1476f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsMonoHue]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9b74baf74f8d5e782b6623abe754cf7693f78e03210ab6a3eaa61f56c59dfa71(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fff1bf9a4eb3b46b156a2f74cc988ee6af70f3c249873741dff076445c65054f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b69b61e1866b20ccab3e761b0f028ced1a11db9d757108b956d02aec5ba474c9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__699ccdf868320033c3684fe55746d9c5be7acf275929c47434713f49560bbaae(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsMonoHue]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d8b4ade7a01f1da87a0b5ea1c5ed197e8e832e96e54f4a822244a7f220d5b445(
    *,
    opacity: typing.Optional[builtins.str] = None,
    opacity_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1770e1fc80134bff77a7ca235d265ae2b25aa928c8361a46bf70884c2e396249(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__25bb0306526b62297c3765b3c8af44c6b45125344d5dcaaff0eff27f07e054ef(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4abda42b5c2de0d173349eb3aee681e59931e638378a77fad8880ffac39a2717(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e8bd9a81a920d83df839eadc508ffc2aed0b938a37324b8c0f893104461248bb(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b1d7c8ba6b0f0528b629b2d90b85ca49c53f02e1ebb3d03f2dee2980b7540c8b(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd8616145ed0c81a26507f07f1bc98b5d118b495b40a4c909af6c950a4e02fc4(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsOpacity]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3565e23d9962d6760aabd4346e9c9d46db5eac9f47fa336c5fc0847df889d297(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__72cbda63f21b377f4960bd6a77540c075be19aade7be308f076e46dde3cebeb5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__938bea2859a46713566b4611217bc6d39ec869cd4f341b2e9e49c75c0ac898cd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f13eaa459481cbec132257d05ad5f26ad17722410ab822500ae40f81c9384020(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsOpacity]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__66d48f0b6749be2af660117e191f130c919133b87dd77addb306768603c45644(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d3caefbcaa13fe18a118b503107661865e76653476f4c5eb9c7a1652c7f75e51(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__151973698be23fc56feaba30ecc7519979d9899622cdacaede254257fbae1bc0(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsBlur, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a6000a3cf509125354dafde38e96fb9c29509769be99a56e29c7d06fbad2ee49(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsChromaKey, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2575cfce11424a65e29d79ebe71a72b06ec26bd94c5ec20a6868431792845fb2(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsComposite, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__47b73c75b68328656be738d3d2b8b2b3cb1e9f6cd72bb86adaaa0ba0b3fd2cf4(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsCompound, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ae3d49434f5ed700ab57b7ddf8790110289d5c410d9d2935de1568a1930d5710(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsContrast, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d195fec3c2dda27733e7d296994a7c2a37126ac16d26a83c4a15ac19a925bd3b(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsGoop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4e51b050e88bca34ea2d8ca6ef1f26a1c8bb5c3889e380bddb047336ba12c400(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsGrayscale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1a7f9d39bc7b5715643b3ddbd912c912d48aa63e5436595572b7ccf054dc0a12(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsHsl, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f11f3af1f01955df00d89215b7b8b78471e7bd6c732928f5e528430917774f91(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsHsv, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea752f0d5c6dfbf4cf782bb04041c2588f6df4be64ed2d7899dd30392dc8a99f(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfDimension, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be85f7b9dfbc16a0e875188a884a1d9bf4ecb8f639963119d459c483f540acc6(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4f3b70e6ce23dbf3c38a3b6543b6557468ddbaa0694c6b1f7629dace4fcc1119(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsMaxColors, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e6147737aad5c8f29619ad959b2719446c2b1585bc88d1abbbc71c93009fc40a(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsMirror, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5af6561b8ad48d695d935a990ab83e11bb801ef9e4c86986c24da0486e5f8815(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsMonoHue, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7810de5af66b0662e1565ab5f5279afb930bf1c9d5769cbb01dfc0c49b6cec7e(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsOpacity, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__22eda382e6d1f2b0a850b13cddd2cf0f1a4c7938795be8712fea7511a1249b57(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsRemoveColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d4d99b3353d01a646828823e94573afdb053e7014149ac9772376f7936e1c427(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsUnsharpMask, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c8bda7d42ee2754c81146768caf99b3c306ab56ed135938425898add5cd9d22c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformations]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dc87cfce7d5c7733694b1ac796f622f3420fd35264da630201d56b8c68d9f963(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
    feather: typing.Optional[builtins.str] = None,
    feather_var: typing.Optional[builtins.str] = None,
    tolerance: typing.Optional[builtins.str] = None,
    tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1c12d8fd07d7c946ee3e183e046fbe130a6aab2015c134efb301453fe956b8b1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5e2561808e5f1e6e1a488d9351e1f34a2b66d26a8879493d78ae74b9d7651cf1(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__779a5cc363e0fd8dee2687fdc55af10e3af2f60a2698b3fb1d1ea11acf075662(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f1e030fed30d7d39962af9c86a74d2552cab9bc332bb9cd4cb22e870c0f1619c(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0bba483e465d912e3cfd3b17632a8f38b4e38d5e1e5c73d460d16b2ad55f1e5c(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7831954baf594373a024f4337ac1554ace367fdd64f56111e1af62a2c05b4e46(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsRemoveColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c8c911fa0d03913fb3f005957f603b272d4c49846e77769d5ae5c5f0b2ddc2f4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a8187df61cca6c44dcb550838bfb86bda8d1e0a4fa04e2a8edeea1fd62f2fd9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__857f533777cb9be24a682a1b2992d7bb88fc4e7316133150bdbb99f51377663b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1843de1d51604380e8ab5eed6508c9d418ef62e0b81f7082db7f9523cb3b8a2c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0641334bbed02ab46f69794acd92c7b07c40a39c56cb5670ba8c2ac54b6bb339(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b2af4dd72b536bcace060c868a15d0127a7d208fe6480f33b85ee159fae95c33(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__595854ea41e758921fc5a0d9760834b80ff529fae147c9fea9c0fabf6cf0ae83(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__60b1998fceef376c812515aef52dedacec4c3077a3b1e16abdb536fe86da57c6(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsRemoveColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4285c80f838f1741fec6b3884c16b7d42fec6e2f27263d476d2b1c1355796dd5(
    *,
    gain: typing.Optional[builtins.str] = None,
    gain_var: typing.Optional[builtins.str] = None,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
    threshold: typing.Optional[builtins.str] = None,
    threshold_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6204e8e9ebb69cf48029f710ff17bee0a1733d006a7a87db72a0be28f92f72b3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a96365980c0ca30b21b46c92ff2cfcb41a0bb1a4df84c5a24699edee9871a765(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dc4e9f8d41ed3fde878606d4dfe2a37f8b7a7d2f3274f47e27dff026fe2c7bf8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3568cde30f816494ef35301b223bd15b6373436ecb8714668e8390c4c3c524db(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1da1d36a50251acfa7b9f80a88da1af75f649550b12d1b6e88559aa3ee15279b(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e86dec00f255afe876793a6d0c8458bf0302734e6dbc3ad26389e44933c7e1ad(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsUnsharpMask]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c2df6faa17f7c8773d008a0caa11cfa83343430f0cdc9defa462f1761d814471(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__94b61f8cc232df4f47e66d94c978fb52a9034c8aca612a5af86c5e7be36ceb48(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__487f9175a4e2c1f3d061fa1a9183cfb0c8a19ff5f17cb02a9c9dbc04e14c5321(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5fc95ce02f87174c592a480772b7355a1bc2cff372fee7023e2c490046fcb164(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cdf03de271f0bc0939cb0aa58b24a4a7487014de6891293c07e0099de558d327(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__569563016460faf72525064ed9f07b50c36d35050478becfcaedcee71ad0b4a6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__41b53ef3b6115e27a1f15578c32e27c6eb915dcafa994000bfa6ad215998a394(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__15b3b89d28f0582d6e45a69b6d82f7e8d3ae95f32ebddba96889d8f40bd18cd3(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsUnsharpMask]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__def202acf10ced1611a1578f93022adb8d8742c5fb4edf173171975cbc8f7c81(
    *,
    brightness: typing.Optional[builtins.str] = None,
    brightness_var: typing.Optional[builtins.str] = None,
    contrast: typing.Optional[builtins.str] = None,
    contrast_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1efd71bd01458b1ce31185b41d1b886ace9e5d2abacae8544c8086bdb704fb3b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6280908f7a4ae433461a45bbcd8f1196903fcff8e68f8f9f3745b77ce064d7ec(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc2b8948c2b40c6e679f8d3d0a00826e987142cada1b2f23957537e4f72de2fe(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__45877f6e43799227a8108fe98bea09764a1858e1b1b1d482f2ece4e757e19a7a(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb967cc274e6b0497836a9e2c60bf3d56151117e9f87b957574f34069ca218d1(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0e86163da7fc1822f5511bbfe32afbeafe17a43d0cbd2db6b96685c49800f764(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitContrast]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3e593b1cfa93efd8cea8f804e6165adca95bf8bf7ccf7385a99c8df4cd69cac0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df5ebd7039e28cb2585baeb19df41a67b68132bf56ef9e6244707573ca70ab68(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__345d2100c6b963a4305bd9a7107bb7d1b699a80a0f3e792e83619da5abed258e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c8008cc20501a9acf67171747e5ca05554428400450c88cfcf2e91052db2744a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8b4d210ad9515d3d9ff3d800ed045b9b9a1a280a67c2fc48fdfccc8b4b522611(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2935adc8bb66a781c7f0b63fc37661116703d412f433075687419e5edd51c067(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitContrast]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c6d7e745176eb2133a4363be29de15a1b5094c0eb03a881b7c90340da9689631(
    *,
    chaos: typing.Optional[builtins.str] = None,
    chaos_var: typing.Optional[builtins.str] = None,
    density: typing.Optional[builtins.str] = None,
    density_var: typing.Optional[builtins.str] = None,
    power: typing.Optional[builtins.str] = None,
    power_var: typing.Optional[builtins.str] = None,
    seed: typing.Optional[builtins.str] = None,
    seed_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c24e919f0aec2ce50fcb126730996d5b6c67f3ab73ad63df26b05dde1614c58b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8d3d8b9856f8e37a217a458f98eda050e78d252ab41b8976010cbffde38e58f6(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a08d9dae7fc3764e2a13ec2cd6666e866fcf8d91781c5715de3f950fcecc144e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__503cb90ce89f874b8c835c7435cb736314736053a04d3704722549289d3fc629(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3170cf024dae1d180c527905e3ae17face341b935c754492aace5937cf301a21(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b908d72b67f8ec02c0523bea4b38e93c746dcf08f0e4d1327d4eb5689d4f6a43(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitGoop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5d1dcedfc7eaa1f4339a59f719f026254b6068260dd470afb3decc385eccabd1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f641f84ccb241813dea380dd5c638099750f8dd65a9ffb655e99632a1ebc35fc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cf4a54046f0d7ced535d28aa1fd134bd50411f29428692bf652c4b01187c5bc6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d2b77a1ab08c52a0facead24b61edf058a897048bf3e1dfa66137249d79812d6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8c075a182eaf8b02811adc5e45ca21c913a35ab900892b3405be17895d377f5a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bba55ea2ab4dd2e2c11c1ac4e12ba38ea17562d0b5161e59c43f893b0826a715(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e656543586cdd499c38c7a33d75e4df07f5a157171bbf54c3d424334d2fb9c2f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1ee3553134c7cab130690503f0764f74e92f6bcbf0a7ea69c5d8d504ac4e740c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e73dc91c4151a7a954d96ccdeac8157ce0ced6591ebbd969b1d08797f7d7a965(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__06660339a2c58993c940fe0837ef562c283cb88b5d75033d49de5a6e5f9a1e0f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitGoop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0c4a0674e563e321e0119ac239ceedeffb8e745fa384829463e9374cc54f6207(
    *,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__818f1ea0651f3b2a750ad0a19617d24d8b081490ebfef16aca7b09b7b060cb46(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e95db0f13c286a848b34b44a3207f6a6d8b0b14a67a9d74a2c34edb24fb98d4c(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1453b1db210ec61cc7bb80fd7d5dc8e4c282608470364eef47a50d21b8ca7809(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a7d6d5f3aed48732e8616745f2693ca041e58d0fb99bea4376ab2dd0b6d4617(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c5992488c735296f7823f5ee30b391d3d6965ce3391e5754ba6fb0dd34d06fa0(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__076c5e1316e85cce5986306c0e8accc5b869f32aae1b7b81d52504944bb0ca0d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitGrayscale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9b4adf02b5e06fb265dd94006bbfe4c924da2f9c12616f52f264c902866e47a3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ae7c20dd7e35c95ea0cd6e17bd170840d12b51e9abe54fd3a02a9c3b51c2c82(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b71e61d387f81912567b14b0b2c0757d428864c467daa9171c803b4363c2cc9b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__769f8c8141fb562f7d517f94789988ac8708098a3bec826254a675a6b3bf6d4a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitGrayscale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7c9117b971ccc79e0a1cf26e13bb750496a23f0fbeeaee3dd45707cea27af1dc(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness: typing.Optional[builtins.str] = None,
    lightness_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ccb64e7257952b754250040ce2c38f5c5927c328a0d6a77259b7836c5270372(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ae40bf79b37c9642298a7b1659752b4c936eef315da8d6eae5fcab87dd984e42(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__90c42134673e90b62d4eb4117632c532abecce97d642d4f96ebcb06e67ae83d2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__43efddbbf5c87fad128ee12ab508cf91849b1270a4c0ebbe650d13a752995863(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2058396db07a8f3361d5420503ac7fea6fde405193d26a0eee862fccbe0e47be(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__29ffa3b7c68c8de65d3b8ea295609e80016f3f5527e49ab734427041d3559856(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitHsl]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__14101e056c3fe3196de23a0e7ff68f721d26265e9a9af2ecd74256ae385d2a95(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0744665b0e912e87768f8770a301080bba1fbe75a73a5d561dd555296eb65282(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d809c8ccf0fed85b8cc1783327e08fbd327616aa5f8868f41ccbae093b830628(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__41d42cc5ad8e0cf98baf2cf28088db8a1a5d644da3f4841c5305f382bb65920c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a7636405c0543b15a21ad07ebba81718c3857dd7771400d5217f80de3e936bc5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__84e0a6f7fac6be9645e7c3592a6f35a970dc65355ae64161521ea14966bcab5e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d4616684d4f8d9d05b95c41df69b2908075977ef9dad3cc4114c4bb2a8dc743(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8ff0fe9fce8a2e70a7a4f95ebb01dfe060e43ddbecd2f4656e47cf9063845323(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitHsl]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1e65a480ac32434be9b33cda0cbe804ef09b54e304c86ecea2dd758d72681022(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__07d25a5a1c14c0cf0046a2b49cb30ac59c4570c434898dd55374f63cd05a7042(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__52a1a2e326feb4eb07f3a73f6072882c0b3cce4e47ee5cb0c6bfe4e87565fd42(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c4e9392cff762488c7f4ce292e0e2a30867caf9935259c25b2cef80e02e9cb03(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__675170f4b99ceb86584cb9fcdc3b09dceda4a6fe00395ad7706e34094b7eef40(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a190c3b04dc578fd84507831dc0e8e4b96716a742083b92a62d197033284850(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__974e142857972d740b32947e611b3f07bb7bbc11972ca15401a4184b04dc43ef(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitHsv]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ff3aeb4a900d1d0157829368a68c26e1fc67038a02f1b094a4b7274d97cb5236(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ad47b5c7d1ae04ef2d388bbbc4df7c9370eef8e484f24c3a9a2233ae050fd452(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__970224b4d457f83890e6af6019ad0278433389cd0c7fd26c270b1ea212a78007(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aca3689a12ab90c3531df1c5f6b6f73cf3c723b8fb8c340afdb3bd33ff600e2e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__85c173df607d43ac1ad61f81e9fee3e49f7609142cd5a3d230966d3c0f523396(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__93c01d3594a3b34241747c883d83fbcd417d56855937cc8629709c5d09fa1d10(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9307f2006540c6159ab8e5b79231e783efdbc3c38b2d48c458b51c788dd06f8f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c7b0d0d45bc656eff66143631804fb20d17a07f3899895844802fac65c117115(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitHsv]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__db849b91ad0f448f6c8d9f6da796d79f75113b71b6a1a38088941f1d159c662a(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    dimension: typing.Optional[builtins.str] = None,
    dimension_var: typing.Optional[builtins.str] = None,
    equal: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqual, typing.Dict[builtins.str, typing.Any]]] = None,
    greater_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThan, typing.Dict[builtins.str, typing.Any]]] = None,
    less_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThan, typing.Dict[builtins.str, typing.Any]]] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__73a6067b0c04e8a37f5e51546de32ecce4b7ed463f8386e5c9764c0acb1f92b5(
    *,
    background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
    chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
    composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
    compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
    contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
    goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
    max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
    opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
    remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__76db49e2ee11a87dd37523f2d17c4ce1a85077574385699c19fc34c92bee6be3(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fc30d7fcc57892bbd960a9a115cda0da5b500f32ba093104525ff81b994092fc(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__34244e0570f73d46eb1a95945aa0fb8f8d25d51ce8f9b220c869e9f0ac61b228(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eaf2d2ee5fd5359f1b08e1559965cd5ccb25e304e746e0ae6bfb086061b386ea(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__189414c7db5b9042d6b75b82dbfda7e5b8075a9c0a4a9795cffcdf619af82b61(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6bddcd185b3cd0813e5603543b6361ec526b87a0bc74d0c32fa9df45d6269ae5(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4d69f387a011aa65714d97576cafbb5109178c878c71cb5b53db0a5592c101d9(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultBackgroundColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__51be0a1059d7a19d15dcdb62edbc466c633b7590f451f0b1e711e56262b5559d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b6bf20153d039813bb84f90c968db317efb6def4dd287ecc3773174f732233bf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__428d8733649097828188b87bee8344705d7ea7678070633feea49f77993de4c1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4495ac534142125908c547b3612b1c0f1001de60f09f5186c8624bb55447a710(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultBackgroundColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__79c17df2730f32fb9f8e9d5a14097b589d572c68476b828c310d15efb557d617(
    *,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f820289da0344b93fe63139b2728c8d4dbbb558ee3765fab3a18d0762981aa84(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7e97ce30918fc0b6f652a9a420bf879bda5f7ca98b6ce6e4275ca66136eb6a75(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__492e4d005759049f1a7ca8a03922ff48014a89db2d01f0ca1f1b6f69f7202cc8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5c15ecf3d716be2ef51b94bfb1215287ad83ecae710043e46e14faead94d1822(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0a2754da82089174c00a91c793520d1e0aba056dccbd2392830dcd394de7f988(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7535b857741a27162f1bb20c9c9241b5152d28a7dc809c3ba967b667da7632b9(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultBlur]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3388084293c76687b4de0905ac61ebec8aa3c4d73874399a63efd6333ed69aa6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c5326250b0ccd6855ee82e4b1711e3158849e1d04d51d9d796a5b33d46676638(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aab7ed5ece87f98b592f9d13280beefb4725e5a5156a59351e06b8de5b73f5ba(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fc3e231e21a6063cc93afe7cc7e3fbf13c4c4df4288630806bc742267043c83d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultBlur]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ed5ca04cf566f573188441464e832b6738203465699d44d7c5e1ee310f205815(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_feather: typing.Optional[builtins.str] = None,
    hue_feather_var: typing.Optional[builtins.str] = None,
    hue_tolerance: typing.Optional[builtins.str] = None,
    hue_tolerance_var: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness_feather: typing.Optional[builtins.str] = None,
    lightness_feather_var: typing.Optional[builtins.str] = None,
    lightness_tolerance: typing.Optional[builtins.str] = None,
    lightness_tolerance_var: typing.Optional[builtins.str] = None,
    saturation_feather: typing.Optional[builtins.str] = None,
    saturation_feather_var: typing.Optional[builtins.str] = None,
    saturation_tolerance: typing.Optional[builtins.str] = None,
    saturation_tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3d654647c417f8cfb7df566d91aed8857f599d2e0edc814450c63c7ca57afe83(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bd2f5965e5b2913f5dae1965a429d2bdec165a980312f017955688e1b8e0b5c3(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eec49da051f84f7f6b36023c745cf3c167548fbfda22f883818fce1a479e1791(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cddd37dad09351af1fdd44d108b4a3c501e41fe349c5c130b665e9c58fd30455(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d6c2c5e4a1087a3c364940c4ba01cd6a1425b0ae502e098c337d91a4cd59495d(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d8342e304a01344f78afcb3af1f32c3cef2a62a2abad7cb6764b46feac41d4a5(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultChromaKey]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f58bb50e02ccb8482ae338e557edb01c6e31280d57b68c40cbb2e07b87bcb011(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6bbbafe737c4cb66152c7fc0c9bbcef7766758bed9a2711736d6848cf4aff2e0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a523d740db2f4f7115c3a1cab0cd290e9236146be1a69ad5ce86c976ef4665c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__31f67e2a575c4debfd196483edf11370906dc039ce8cd8c90e9344d612863755(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f13eb5adedd82b6ede00818013f64adaff947b0602c111373e0d277caf99bd8d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ff61f8d72b3b6224ab5ef775b10875789e4100b4423d093c246332c52126d86(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ceaf43ae35048c63adb6c0c367671d1dbe4ed7e59f77dfb2ad775e1e00e94e4e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fe1d9881061b127e26c9256b74d7e983b5555f317e290b06b444ca2c97da636f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3c867da4842bbc4f51954885aac316abeec107fef8fd152ec737baa74b967e79(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0800489b48d382d97c4b51ce021ef652cea2c91b8afd0e9566b60e82132bf9b9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0f5c966bab87f61adc1e42f75149a10342890d82ecee77ae816d08af3b0f6eb1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3d5a282b4e87437573c2f75a61d6ee76b11b8929570feb758536be246b5ea108(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6297e0c9e221c2fba682de9a8e3a307c2be505f739862d5861e7fac0d5a3abcd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8b80c89e90e8a565dd8e707ebe1d1f756c6f9965c1c048570eae9f02e2637dc4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dda2ada9ac0a725181281a8aba7b035ceb937e22fbb9084b00a6cdcd091ea419(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e7eaf35f40819b16413f07ec86547f07e0299e88f2ee474ccb1fde75db65812d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultChromaKey]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e1a9ca04b9014e23481e9ffd1517634060320a341c2c009d6ed5ecca5c67f657(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultCompositeImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    placement: typing.Optional[builtins.str] = None,
    placement_var: typing.Optional[builtins.str] = None,
    scale: typing.Optional[builtins.str] = None,
    scale_dimension: typing.Optional[builtins.str] = None,
    scale_dimension_var: typing.Optional[builtins.str] = None,
    scale_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd12e0be1f7bb790a4ef9e365b7ff5f77496eb6ccd3759385cc52f1e36101ebc(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5da1302c0398b635b6146691b1a03065425745a2b44bcbe1299957006ce72e61(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultCompositeImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3fd977a6768b4c4ddaec2edba501bb1acd4eb250277757c57b149f83871d17f9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1dfbfa46f0b22697964ae7c663ec0ef2cdfa401399971d97be2281c702bf3b93(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__943ab9aa33c6d9f5f68c1151632e1210ee39dc096618ca26ea9f3f1ad95a1da1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7e512365669e7197b2a248af6b92962343703d2e1ea359c366b890d1becf4202(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df8dca750e55d6cdcbd3cc1a1ee6e7bd0fdbcf7fb59582d98f91f7b926f0cc79(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__307cfc1668dfe6ca9f267e5f7ea00f573d471827e0bed656caec61bfe6ab4c68(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultComposite]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__91765dee6784067fa36a8adfb0064389e6a74e6af9e80202e4f0626f662b2ce4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__877a0302aac00b20b0d1e1b31c3e5218570fe577dc9a30ad36b7a280d88cd373(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6d11718934aaa8db891a876a6669bbe8b6e1b46074b433d0edc4deab277786b2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b808e9d3a19e5f7ce0ee6bfed01e930101e136709c682270187d97ce36dc86fc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c589a6e1aa4746f265333f0b7e488643b33d0582ff7b261a791e70502ce481a7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cf6edc8e59ccc1764f9b545ea595d02c955b98aba21cab949f75ad9f6cb83d2e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a5bf0113b183434298014ca5d125d051b608755db32d2421e44260d97d53dfd1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dee30db3c0691e2809dfd5cc9d643f1d82f14012242af4503c5fcfac90ac5731(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__63db7db8f5d633111084c0b08585c597e6ec51c9409a10047bb6723c6498b7ae(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d6053ddeff0472592ba3b458a8c73e4bccf58d2fd7cebf21364667ffaf730303(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b935f1cbad3c5a4e25a051f034a5f7cb65a52993779d658082a7cb4bd4c72af2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a1dfce5827b3f7b06600279db93a97e789f9c92cf6db1ba935276548ee9ecfe5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6379c2c1bff48e2de5a2b98151671094c0d643fa8fc47c9c707899e343251db5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8d551c3370d040df28bccb05749d449a5672113141d612a2477c619684f5e0bc(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultComposite]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f3a5feaad255d60331ee814025317e432925c11cd27f03cf4e2fcdde9bfd003e(
    *,
    transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__204add88ce49b388b542d00af959fd30409ef04b58013dfd0f18cdd474f6ffcd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__02a4fd1224b14382626433d7dff0520cdae57d2f24fea67c4201bf8569d39702(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3eb50ef3f583a4009bc0072017d5c50c9da9a83baae32220953aa767523044c0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8eaa327bcf8383b998d302daded4c8c4e155dfb60f5928a48aed1790de5be8aa(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5395914d7f09d67221a3bd05cdcaf9805cf5175d4706029ad7e4cc1add9787c5(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1b72bc9c7df2f8685d590471a21bb020a58462c67fca7537188487f1790a8506(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultCompound]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__32029de4dd5fc5a4cc1d7efe1f23b58ded9309ea74adc7efd0a1cb424559f697(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c5eca726cf36f34b7532b534f42d10f6a40e223a9b991c355eeba168e9a6b2aa(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__78c5c61d5e815b1202567ebf5ec7c1e89e7eb8c05189823d77b432d6d3d62648(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultCompound]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd5ef83699a634a64ecb085b422a1241ba3e566a34e48788563b5bf3428826d8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__12e5cff09d7142030fb6142381e47d4475eb12d460251fac574ea60716730977(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6408008c83589f5fa6da1b8e3f47caf7c21508b588574d31e5adb27252c52c6e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__256179f65ee3af516f428fce8ba18daa958784653102e9038af3102f0ce6dccc(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cf79f08b96b557cb690e792f34ef29d02263c4e3cc4724f45b3c9dd896f2d2be(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dd105f6f6f032a0b0b9c3b3e8281c279aa4ffcf606a29074d5ad724bc72be220(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultCompoundTransformations]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a385e8c712762a1562c932755b6ab742401769f121ecc53ad722380c3e614332(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__024ae8249a9195d988bf1149a7811d2876bd1f93faea7f2c2a64d2cecf2c7c02(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultCompoundTransformations]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f617fa8ed791dd217c228561a4e8c7ca82530f05fc82efe84205896bb03d93dc(
    *,
    brightness: typing.Optional[builtins.str] = None,
    brightness_var: typing.Optional[builtins.str] = None,
    contrast: typing.Optional[builtins.str] = None,
    contrast_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f7ed25edbe59aaa7b5b8344b651ffdf83efee8a9a9f5fd19118cb073b7c017e8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__21f12bdfee7644d588acbfd908fa0750a7dd687f6e06c7dc6acdcfc21a834eb9(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8cba66c7dc65ad65e7e00b1f16ffecd06197f380f2ea47b77a2f090f2dc9edcb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3c90c25fcdbdb1ee3638a496f32bc238624167bde1fa225db4222a05ec77b800(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d05cd32ed56084a108efd1f2537732b8c3c87e88cf0c44cfcf4691c57a711d93(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__53787261900ec2d9fa80ea8bfe3b37f314ae93ec1c01ff3d8b68a8955cb7e462(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultContrast]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__276abf6c431f2923f37f56ac027d8dd47ee7193a852ef4fdc832d66e32185001(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ea018ae86dadcfddb4c99baf8433a8c7ab8588d80d913df31f0cef82ad3c729(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__312ea16f4abb0fa33c7637185a93b876fda63704646ed08bf610fe20386ab22d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__28d8765e3de08c3de0f2425f7d5862c3ef0acc6331b2eeed8d971c3ad3d5b4b6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__49841169882a87d894ef2ec2ed1a029605718f88092a6fbbe74fc82f5af12a44(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a4c63ca766c5cb91843dec2cfead698bdb533eb47024a209eee703173f1ec26(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultContrast]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c77806c01527a840598593d2554a823d6990f0bd03424f84a354137ad7631bd2(
    *,
    chaos: typing.Optional[builtins.str] = None,
    chaos_var: typing.Optional[builtins.str] = None,
    density: typing.Optional[builtins.str] = None,
    density_var: typing.Optional[builtins.str] = None,
    power: typing.Optional[builtins.str] = None,
    power_var: typing.Optional[builtins.str] = None,
    seed: typing.Optional[builtins.str] = None,
    seed_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__33eab7ff205fa28d40b9bc783ebce7bba92f1315cb469d749f9dac1c43258acc(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__89c7dab26718f8c46660c10479a1ebec193e966354c0c65b77e717e458eadfee(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e80fe4e7ce200061d0088b60fb6b2ff611e30318e65ce4a8e1f77c5944149149(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__801fda73d7aee0822f2ffc7cabb1cabd2cb35faba3c05db342d98ff6eaa7f365(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6fd5df473b861dde0e71d8ff0c7080e823fe617a66e418957a7e3364cde79239(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fbc0baf850c87fa35396b3f2fcc1ba8eb66b8a7a0594338c019ba84fd2e7c2e5(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultGoop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bfd8e2f39d955a322389f36729918f54f3a7422b71a85a001b85809728534abe(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f0b648be366af419b4ff38b085bf7b48dbfa86fd1d02a0dca309eec542c201d2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cb8ec3c02ccb341868c99e1c60757fff390312f58bbed735581665425c7efc75(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__50ac770ed20c7d4d165dc10f0963a65bf7f36329850415f1b974a65c6cbb43ad(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a28d371a76adcadafdee2e4357d0f617d42f2b160f0649babde533c16d71ebf9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__20dc4afbaa7ed32c7c4119c1041f040200cc9a1bb3c7e53eb621273766104011(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ef419ca9a9ab67a02f474ad85d1f1eeb6a7678cfdcefbca9c85680330a58dbc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a9386b4b8c4e65b7266ea71c5c4aee5c95f26a60f18b720e197e445032d10d23(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e7e36fc9cfad75725d69523b893920b6e6cb436ed85aafc461c4ffd8b9294682(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ef592f5ee07105a2b55dd40234df86018b62be0e271020c147d8e338a36471f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultGoop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ace1f5065abbe6b5b83e3e0a879ec37361648f895e811c65d6107a3dc63315a3(
    *,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ba9fd0f1e14290967538383689583188235964ae20f7ed94711553bcadaef57(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__50c79bce18d04c13f5ea1e08da506743cc3b19b60633380f58ed1d17476a509b(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c1605ad52da25d7642d83f60df6480491b942d3b93cdc82f91cd72952d0db621(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8893db66256efb72d01997e53bb7156ea405d507a0d5a13c09373e51b1e5eaee(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__efec026931546372b56adf1aacf0ec084d53425325c9c6ba2b60ba64bb94e2fe(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c866fcd9392d58a4ecbe5a56b4edac642c3a4bc40ec03a99fd6cfa317c120255(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultGrayscale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6233e09d034195faefbab7c7d574da3c66ed04328cacc756fdcb61e30404be16(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c15e4378a36d7768ea11cdb8b7f12353c21d636e23f82ff77ffd56cf7a989be9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__785f0a5a1a945bf61a8f2608fcbff6a714edcf1d6fbc4055285a893f415eda21(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3421750e089bc91e87bbbe8462ef8439ebc7fdf0b4380f4f06cd1d7ef4a4ad12(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultGrayscale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7701a9cbd039aa76603278385d94025c8b4e26aefe2ff8cb3b20a283683315ff(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness: typing.Optional[builtins.str] = None,
    lightness_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__72a62a7bbfddd79a6015921018c424a35607256fdc5a55a52edefe2da284ff07(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e0d7ce7884824492de72d5f09e605b404b44c3cff81c1cd630d9592bb723155(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0deb30569989014d0c5de3ecc2f60a0dca1ad343585d0233c6451b5322da38ac(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__53f314dd031537a9e96641c8a0ea31e93eb9db63e4af796884e2e865a459fc88(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__abfa8dac5d6c656fb1908fc2fbb2a1b15409282dcc38d0eedf51c15562a09ea6(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__45b45ac0a834767bcc84167a94ea12cee0d708545d7e561f069476b48ce7c97e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultHsl]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__da9892b30b7a0c2fcb8ba9ad915643c411dadd1e6006a50ce9a6e07d634b9671(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__725673aa37402b401ef61db87b200fc0c8e5493f8063583a2835e57e54b2a50f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6eb3b33cdbf5109ccc6888cff2c6ea9c14d42797e1a451a35e225b28c8e2aed8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__589c2f560e220a0ff040d0e21dba4bff27a965d2d722af5b3d239a2eac278bc3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c249ec89767c0fac06275625d0c9053e9d1c1efb407a522daee8cd60fcce7dc3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__655788c0abf315b2e8eb9ccb2ca69e282367ca56f18596f5e71f261002032dd4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0d54bf93684146a34d36fd16f893bde7a54892a14ec8336d9d55bcf76a43eaad(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d53e0e9fd101e5bb7b912c2454561b672d1810f8bc2404d99dbe73ef3ac7cfe9(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultHsl]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__30205b8867b7f3c356100c6cf088208a7cfaff4f92d83c56685ce8cbcc47be91(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e4a3abd5df1a5c63ddde52af7a9ee98d3b7719ffdc89344845e5e37a822e7552(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__79e51824b3b1f6412f42165802788d5555d97a5cb28d4987e8a63c62a7599030(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c21316e029a48f796cc799a5f1ea8ef1c38ff51c29f461d821af7fb458248e49(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e9b5fa43b9985961cbfc4b1b97fd696fdab73b592639b4d6db983d179907335c(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1461db4ff27ed90f1c1631226a79e32bf50a0001c2f784e15c1f32175949326c(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c94a1c75a04dfffd54d49aaa563dcedb1b153495f57f3d73354b5a92856894ff(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultHsv]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ec5bab644db9f05bdcc742347298066f52a1bbbdbb8b3246d48addfc2a653630(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2eb0ba3ee6f2d2a1353a8ac174978e2bac115f7304817acfc63b30c13eb6a8da(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__432ab031cd5b5065c4d3ac0c774e46627af60915df1b621875d215ebc4ac5203(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4f1d482f48aba993caa7bdd09023b60f55da03ea7c6ed4b52ee9fc1cabaeb2f7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c494df40a5f1a91b7ba99ef9aada22b4ded0b77bbba614eb8420307acd6c4dc4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f519f95259a31abcaec6034d145980c700a4e7ef5356939d7eebf94e8001845b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b4edf0da5a2ec0a6ed8e6b43fc786b14f483963fcadd2c75c6c7bac30119c53d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__23bf60bbf7047c7e6dedeb94672980440f12add6e42c7ef659b78a013aa8c0e5(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultHsv]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__93a918e31b2731c46c485387506a520ba2bfe884f9026a17d54d6d927616f015(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    dimension: typing.Optional[builtins.str] = None,
    dimension_var: typing.Optional[builtins.str] = None,
    equal: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionEqual, typing.Dict[builtins.str, typing.Any]]] = None,
    greater_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionGreaterThan, typing.Dict[builtins.str, typing.Any]]] = None,
    less_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionLessThan, typing.Dict[builtins.str, typing.Any]]] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__10b152a3d61b60c2ac8acbc45bc4de56fb25d3fca917b1c20d53ede9eddc1e45(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__828d344f00608a83b35ccd1d773b2f85c89cb74a5fdce9c0c210abbc77129f05(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2e357ff68aecd3a264cf9a7ada17eef05e6af9b6f367cfff121da36219b82c72(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c270c600abf062b33f4e414b5db32a9f0ef62dd533ebfca3fe17819a1d0bc920(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionEqual],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bf8ea68d536a0382011fad7a04e736aaadf01fc8c44c54cb987b94738acab3a6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d032f436f2e3bb50cc7976ebb5e36cf0c930712badb986f2bf25833c328fccdf(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionGreaterThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__88fa486f5df9b4938ce53da24b4cf814ea02570f39b178c942f204f8697cd17b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dc715e49b1e60b91c2d3e3215f4e8bab1e5d33daa591d42c22bd46c230efbe1a(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionLessThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__30a36cc0d51ef609c128d7bbf13bef4d65bb8cf496f19f0fa5c02a8c5809860b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7516f042a9a377ba81e92e3ba7a96084942ea5d367c63be7f4569793220dd9c6(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7f4241239f3f7c69091d51b6d251e4258164bd78f6aa23fb3d7bb5c52d575664(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__382efe72473e89ee6b6a1d50eec3eea52001a63d86c43f5936ca9d0ae37dbc66(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0dcf2913fd1256056824860d1001433fdf8240337774b1b02665e1d7a22645ee(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd831ef9a6f379abf289d040ef9b763cb5512bc5183c475fc30f6dad6ea6dfc5(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimension]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__170d24ca6a54127685722630a4fd818ff07e888b8778bcd42838ce0a9e4bdad6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__77fe7dda768ea2fa570c4e2af06bc72c54de1ee735123a99110fb07866b94006(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__da356bc7b8d6fec05032ce35f5a084688cf110edfa7e32820a6673009b005df4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0bf6525ecedc79bdd377b85976525011ca02c1dc5ed6ee143bbd8288635af9ca(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__372ac0aa7c2b55a56a872836f33fe82c34e90ba79aad37eb8077a714a05f8d89(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1060a12a5390126e2f57fd653ff5c0033747e51526d11f495a409c297fd35a6a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimension]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1e870bf50e2c44b1cc20880c31e49fd79e1d5035ea96985d31d5ea6f79447741(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    landscape: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationLandscape, typing.Dict[builtins.str, typing.Any]]] = None,
    portrait: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationPortrait, typing.Dict[builtins.str, typing.Any]]] = None,
    square: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationSquare, typing.Dict[builtins.str, typing.Any]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2fedd71a6ce78f847ec2ad0d5316221808fe1f07004b37279f9d1d54684857b4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ff695d7863782fb7440d7a8924bab2ca41a6276385fd10597a34f67d4749cb2(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d37962cadeaa35b417ec38d96e457381c441b9ecccfe8e41d490714d3df75a4f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4b3b7782f8fe6b3bb13c5867d2b56ffa31c039ea3c9a67b55dc2b86823e37525(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationLandscape],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__379c06dac7123de1673a4b54179697dd21d9f43185c3b57c1122faaa3ccaee61(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f4bfefd79d3191bad7b8c0fb3c5d48e5bc3f9bb93b24215d8478a0abe021b1e(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__656031c369bfb3e7a89d40fef8157574cad2924df8310ecc02a48b707b349c9d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d2facefe2ae5994d6da5a95b30ef1d6e6e6c6f90a569fb51f49132af292d1540(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b7873caef942dd18a7d8574fe5ab2ab37f175d28c3db11253468218d8292e985(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1a12a293654f53e105ac0dacb07e1dd0a1f172af20773f3bc14de5d474d05ddb(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientation]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea45bcfc6f1ca9fe58890ddbba732d72eadff4dbdffe1cb75b0f3ffdf460a100(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c7c9877555096a9317dca26b4ff07ca9a6ed4fa8a42ca8fcf6828d8e082ad346(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientation]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__72c02e98da978fbcf38110d768031b61b7d350653fb6a383589f298203a33f67(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e8d2d3dc5b73ae2ad5e00176dd4bcfcd6059538c98bc1da566058ebbf6f2ad51(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationPortrait],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b5c3edcae5273b8ce069c96a589ae3d17c905540682bab2e9ea5d3014ae42909(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a91c7d75aac73554bdcc61ea5d152b6d9aa13847aad870a2cec0f6ba7d08e28d(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationSquare],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__20990357d58e04afcdcf4ce12d4591f648001d6b9c16bc2ca947dea966822e5d(
    *,
    colors: typing.Optional[builtins.str] = None,
    colors_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8fd358a4cd0645292ddf821becf8bac34dbe596eb4d9f44c35bf7aac4089765e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__102f7ae09660e411693c4dc28bf817af164869af46987db60b04b0abb26cbaf6(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__43074952890dabd14c21d356caf1bbc809a4532babc7e84f3049e766c0e45eb8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__212255d1a0ed1a57c4ae3d42eb4a49285a9353d074f81ddaed90249c81d31283(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0a97c546aadcc3126faaaaf33cbc6d930ef5e3570cd9aa9a521b4dc86028ec24(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab33b6f752eb1bcfa2afd29a9a6d5ae8597bb0e20518fbc329dbca74caeb0a64(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultMaxColors]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b65ea84d61cad8a87e38bf751cdf68a3a5d3c65adbdeb944c7261135908fcdb3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c7bc1ab3b3ea14d9bfffeb009b7cf85da4e1802915c0a45582303356d1d05f84(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__888410912924d54c67dfa214b4bcd9edd1ade63e0432b07f78112e0a190d4eb5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__44420b3730fe978fba01e916d7643f52e90515bd0b79eb468fb60f79cdf87ca1(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultMaxColors]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e9deeb727e1c4aa4178c0433bf094c8aa568aa1b40059f49cd5a63a7d5347c67(
    *,
    horizontal: typing.Optional[builtins.str] = None,
    horizontal_var: typing.Optional[builtins.str] = None,
    vertical: typing.Optional[builtins.str] = None,
    vertical_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cc0ccab8033a131c39b00484ed70c2db7e9cc590d2f410eca685c25fbfed5051(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__33eaa97cb3f019d834ed3771a4126f656480dd7d7046da1ee7a160a80fef8918(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9482349390748612a4f87aaea0cf46506318bd343d234b5659573f6c43077f9a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__99b4ae6e753ffec1d33f981529795ef6d695ccf2a410f614e4eb5f375df09316(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f727517dd19b732a457548e186eaf1b2ce815223acce0f7b05b8898d728779d1(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f6ced9e746b01c90628ab558925d323d3c345251349086cf7dd96e09c2c8779a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultMirror]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8f838692057f79417035d02c5e9ba0d5213986e65b8c98f66a698e21ebb8b56c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6681bd17f680bf85b24f1bd48f92b4155003febbaf13399eb75b3cb4383cbd5f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eabb386680641b1714d3f30298b116abea6a51eb612ea8540cc0a59f85ae1241(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__227bb3aac763eab2b6cc97ef95ca93e8048bea237cafd567043567cf9ac900f8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d65c4b782f727e853f55cf0e5c441d3d6af61efc796fe80191f1f23d2617f9bb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5c866fcf4b4e986cfc49a056ef4c474c93b3b1b289c1dcd16c280ca7b2c3216a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultMirror]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7f35d63e0899e289384e8a03c1fcbc134c8bcd4c7437c35152f90ff755a37aef(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0d5b45c63fc4947f8e8647da95228247c002f8e43fe9ebe1e8381f9b02656ec1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8e3f94ea3f63af279a5ebb0eaa7fbce9e1a1ec51461f304d67aeaaa71afc9c14(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ec9f17c0da2348f9e1933dd8c649424260fc9c9767f895aedb33d49d431c3947(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__940e26c59fd039e3cd89a870146b9b82b92e4edb935018e1a5d6823135f47fdf(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d96b1a70849526cce42cf62872b232da41d2b53d03c2296a4828941869d36ba0(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f4ec5294e566e3bbbc045ba3d8b2424596ac90f6c19d2f7cd29db28eae7748ba(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultMonoHue]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__37903aaef29c52591d04d7fe3f4a2dcc9e91a4bb126954b83147e064b4b26b1b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__19892c98529762e286c880ae9bf960bed0499625fe0949fae538b7211eab03e2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b4cd90d56c67c0def2f6fc742f0963735c85186d6b63987ad3c82c4177971b08(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2569aef0aecdf34afc032e0ada7e4974940d613cdcba15290e5fbe92bbf42cfc(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultMonoHue]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1d01a2b42a6498a69d685615fea442992cab9e161bb0a09c4251b62160f7feeb(
    *,
    opacity: typing.Optional[builtins.str] = None,
    opacity_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cbf0e5d81685dd0975c28518a1936155503701a2121cc1518b8df989d0d6fc35(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__98ce6f3b38ffa234d42ec3c0547f07624ace78bdb726e681bd664c1bcdafb4f1(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__666e88dc1241c26e05b49e8bad1ca2cab603e8ec152471956234c6dcf961fbd9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__801fd578f0c2ab9052ea89a3449a3935154a72c0ff3bf1a67fc5657bce3bf0e9(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__652402f2ea5420e0820e8cc039c119c1cf3466ee9c0c11dbfaf55dc444e0e39e(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2f724d9ba065d06fcedc3c4380e4d236732b2a468d0a0934677343a10fcbb866(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultOpacity]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0814eb3adb5173f03bcab5be22a345c382475967e32819b07a4625543fbe1b99(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab4ffbac6b66318f1018a7b838b8dd85483eaf0b2c6bfab9c36c050f943aee2c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c1c57ada712e56efa4862ad079114527306c0c0029d165c199c9fb82622ed2b4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c82e78f77fc62c77562da2e8cb869fd9d21ad5d8a73e1b8275786d27f41dead1(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultOpacity]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__164bc971332aa9f087fe8e36e37ccdea1254bd4c8e5f2687b26b2b305b56aa86(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d4e2488ca06fd6943ad32f17db02cb07647f4a25a5467218a066935480d1ebf0(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__51bdc9872bf010102cbb39d6e0b1619724a46b3c89af874e8fe4c41d78024013(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultBlur, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__10fc31dc502e83953dcbdef876b2f6f495a466ac27b1450c37743a703a8543ff(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultChromaKey, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__895b206bbac4d9bdf232463e42cd3c08c2555a3c7f3c15f6eeb46690154cc80b(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultComposite, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f255085a0c8af8ac2e84d588f9ed3b5049b7d02fc32b04a0ab150010c14e0192(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultCompound, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d54ec5cff4bf461ca3fae24df9d282c1c78e6dc28dc78794390b155eef8748c7(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultContrast, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__06b1c53c16ca351134a00f10140cba8b8fa25bc533207321c48c140200282329(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultGoop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a131205cb97d242be8375425895ab513147537effef9b636d4c200459174316(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultGrayscale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__47da944c8d6359137fdb90b2cf92a95f5d44f7fef6d42e6228d9a8007bc61ee8(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultHsl, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f0b98c4c65ace438a5f85b16a2206949d37d95dcaf72437ceac329855ceb6600(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultHsv, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__67a6218df6cfb3f410ea040e583ba802ab9a71b5420a9c18f8521bf5c942e2d5(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimension, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3f2dec45d42529d4236600f06f8f991676d1422b72c31bb8afeebed65006bdcf(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__136cc079bcc0deddbe477c7c3634cb2d440da95a241047b4a7115ea49d4a5bd5(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultMaxColors, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af162935fdcebb348a8327e4ad3606d95f0736262077229e1f27c1589f11687d(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultMirror, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__782b984ecb618b56673874ae443f0bfb2d3494d60a77f8a87463fb650c02db9e(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultMonoHue, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd842e2400ab96a786e9b59df7d05c8ce7c19662da44d60c90e2d96078ae3a67(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultOpacity, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6408f464a49c636b69e2ee6d321ea205d9ced2d5762af3aa9f22141046c9da17(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultRemoveColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a23beda8a83f521176bd3f6e00595fe881eee5afe7ffd6d54708b9e858df6f61(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultUnsharpMask, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d203fc5614e09b3b57031704a1bb96a936e175275313241c03651bc4f693a226(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__24a3d76ff8f41c3c55af51f29ffba0157e150270cfb1cf4daf2b4e5d60ab9a17(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
    feather: typing.Optional[builtins.str] = None,
    feather_var: typing.Optional[builtins.str] = None,
    tolerance: typing.Optional[builtins.str] = None,
    tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eb0bd9fb120e48d900d92af4adeb2730577664eb8cb80064a8c04396c1c77af2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fe7cdcba6f645751b7807aedbffbabf73e5ef5baef7a0741fc49e0ef1e4f4d71(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f49cb7d11e40636af6e25f8368e6f0fd7ae7e71f3e19f5800631a5de86fe5f5c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__05d4041bfee3da6247c11b7643cd7b3704ea7bd3361bc77fa36a71961f6cfbe5(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1074079e7a0b0342c86acb8d51dc6e9939082043bc590e84e328bc670832df37(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ee322ffe1d1db72ebdd66118bfae9f22dead9dce027f0d9024d5f30644aa73a1(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultRemoveColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8ccc520f5cb3d4bbf7998546c3ae93dcd1808b1db0ac30c5159035f610278953(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3be710174d831f86435bec3bef676546aa7486401b68a0797287e90dbd1daa91(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__89cdae5c613cc39252bbe9eea09b04eaaee00efcc1e7454b8da5ad9ea64d5b30(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2004ef61a80c9d9cb3313f81dff82b910bdfa009cc2c44dcb2b2aa6ff624b2c6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__28466e82ec9910f7907384ee24d4fa811da4d7947051aeb80ba8ff9e7d4cbcda(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f718a34724c55baaa68423f0efe25c6ba5d2a6689434edb9e02c44c4336c13fa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b8566ae7810ac19549a05b71fc47320e8aff67b14864889459c3752067d0eb9a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f4bdf38ebc5ad152f01163f88441f886eb227d5cd6d02c6fbc41a512811287ad(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultRemoveColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__13088be7c4c2c843daf3800ac8e1f08799671f1eb94ebbf4b7b47cb11874ee7a(
    *,
    gain: typing.Optional[builtins.str] = None,
    gain_var: typing.Optional[builtins.str] = None,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
    threshold: typing.Optional[builtins.str] = None,
    threshold_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e6c6d0da4d6e27b63610558b4abd3ea176e48b960d4f3f94ae8cfffd6e1daf2e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1acb7a486f48cfacf83db818c879adfd2e5122078810f9f99bd26b358995e980(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a115dd69f2a1db2fd997873326dc78054114af009247a40b33e48ecf830aa1e0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b529f42e3d7d382d8efcf16cfb0836dfb8430839366e9a8712381ba8a668cfcb(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd8bf32a002f73e4042758e053543b27f646fc77cc8b6a3a1a890ef17efdc424(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__295ca8afd7a13132d09b1cbd3f4bbd011a1d6d4d52d7c63e89e98bd1e0dd6cad(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultUnsharpMask]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b76e0d89f940effa052aa889e2ffb6ae818b92598082bdec071130b8ac0ac8ce(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c8560e35e59387e324e27c598f549c5c32713cbab05ce2bb6cdbb9dda7f1fc29(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2c72bd2fa761ac991fe7d134aa93225b39156850078268b17152b5fff3e55132(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ade88583d7cba9b22c237700ae683a291e2c3906fc0300688edbe93784e23c8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__67925507fb656fb5f1a8af976e1c1ef3161e05481cd6f8f305a7f1489c768f3a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b6b5e589ac51692f24a3d11ae9cd0de21e1a6d6a2f248c5d4b2f2dd59d37efdf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a7b195ca0ed8e6724a31809c5bccc37c24f192a35ed27bde76dd9ae1c425d63(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__11cec6a63dbe593194179f71648db5584f1f7b76dff4bd990ba83b2f5b150da4(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultUnsharpMask]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2099b9d535cbb3aa55254c9709ad5f8e8fec4602013d83732ac3e8a469ff522d(
    *,
    background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
    chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
    composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
    compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
    contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
    goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
    max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
    opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
    remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2807adcecb2a702480ce565bcde680f13768d155afcd427d360c20476216e1b2(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fd428af5983038cbef5e3cf1c2ed116b1bb809299c3f42aaf6dfe9f49036024a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1bd8842ea9d1b9e226f6e7f9415b1c7dfa124aad6678a0898b6636a0148b1751(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e569260a19ea061642f2ee3189af5f84f4093559a92cbccdfe273cb4f74041bb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__90d17a976878b1e792ae7c53b762ee6ed870679e6159afa5e498a9569168e116(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3fa99c6adc32d5e91afae3a9a6551a1005fb4c8f2ea9cebc35f019f5d9b787d7(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b51da16804980f9ea7b1dacea45185930c41849a178ce3ba360f6ca1670d62ae(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualBackgroundColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7e80b74b0e9cbed1590f3e10dd5e19461a37acdb0d58c167dfa1b9dc74ae6151(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a65d90a882964522d7f4c8b3792d94265f8d88206523e7a16291ba29bda5b2be(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__978f6d29d83e5356e64c8b414a7fddb385a2a2cb753a79618894b20f141576ee(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9bde5b4221bb947ecf0e737d737c7eebe720bee4c021711170da1d8d5ac77747(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualBackgroundColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__14457f1527b7ea98563e94d3d516b3e6a2329a1df6fea8ef58a1b11416c1abc5(
    *,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af6ccfce82befe2f1d721f80a9268408c024aa7ce5215ad829c5eaf68006760a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1a33eaf7ff4df77492a4adec6a0243838e3258aeb330a1c9e033a59076202a87(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bae550586e3ced5f61187bdaa297a217cdeeb37189c621a5633c91a6e40d7f22(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a342294d9a9097852f458780b2ca255fa6be1cd0786fbb2d10db6b1b41ab5c4(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4332245a1aaef41bee601790803e0bac47bb6240326cb518e242c220dacfcbe6(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d0c4598f64604bb5d29ee8d5c72253b3900554043d97f77a2cc33060abb2001(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualBlur]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b755ba2b18f6c324995496e7d4ac3d20ef12c6e69f0e85b052e0763201face90(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e4b5c8b54864beb675b02f43751803152c6a61d2cf0729c8bbb91ebf04b75d29(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__007b080f1127f0f817db818c186f9762f901f26cfa92421c5556b3dccec7297b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6cbb02ee6212e470418748d6192771efd17b81189482f269644fbc8bafc045fe(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualBlur]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__91ee24ffbbb1d23761bad71d61d016517917bc65de4b82b5345bdb2fff4d0aa4(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_feather: typing.Optional[builtins.str] = None,
    hue_feather_var: typing.Optional[builtins.str] = None,
    hue_tolerance: typing.Optional[builtins.str] = None,
    hue_tolerance_var: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness_feather: typing.Optional[builtins.str] = None,
    lightness_feather_var: typing.Optional[builtins.str] = None,
    lightness_tolerance: typing.Optional[builtins.str] = None,
    lightness_tolerance_var: typing.Optional[builtins.str] = None,
    saturation_feather: typing.Optional[builtins.str] = None,
    saturation_feather_var: typing.Optional[builtins.str] = None,
    saturation_tolerance: typing.Optional[builtins.str] = None,
    saturation_tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0bb43fc5520d4f5f538707ff768edae1c42399167a8d0959569e0ed6a0074429(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e45a435f5282f0dd544405d84a3c012432e5e733d5fc319fb9629316805f4868(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__618195223614d6ef92a483301834689a62582529aa5ad0f2200078050fa01c99(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4e585dd79114e6387ba1682414c07817967200339bbd636d2ca20b5da93686c4(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__74ff545ff46edf5204e7a90de84b448e48f072c3c09911818a7779f1fbba801d(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d73b540dd6d934913a0a90c98afa6640899039b58ed34a08629d193e448e1944(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualChromaKey]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8ccab9dc84def8f7b2e9d5bc0e01b848972b8fec05fa5be52e12873d34e9dbbc(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a971137a9c65a9995e5b29c336b830b13e09e75545335f25db8d6a54096eddb9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9eb8b55b6d82ed5f52484de2435bb99eaad3a14d0a4c9fdbeac34e2d73760bf6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__54676d0592fde5c8aa44a964817eaaec19d0a1bf503f47c390b851982d33ecab(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2706cdb36ab4c0b709c5b06b8ecb34c6a13f87eca9d11741c52c73af1f4c2e82(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f8da2ae1f780d73031b75aa977e536270e05a4ac825cba6ead1701d7ce00863f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ce802b12709720983bc026d884bdbab484501e590714b5b4719418cdb88336de(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e12a835ec10834122dd2a2a61ffcf69e185975141381397cfdfcebc7709c3311(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9c92cbe07c98db9ca9af18acbecb753561e2e0a0f3fd9b358906ab4c75dc1fd6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__08f0909ffa6240346abf2dd1fab64c6ca723dbc2143c8befafcaeea507f95c9e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__da3e883887db1f5407e2dde88ac9d2793e2e5fe6abe219f1bed379e6aad9a598(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c33aef6e6cbfe64fc5b720b55d5eb0bbb2b1ce73d4af87edc65f2010a95a0605(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e4fa892c6c96e7568267127854d24c978aed4302b4796ab995c3dbcbcbf2719d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ae69c5ab4cca8159d74a5a1f18ac68a8e940636a66e69580ba8c7b2cc818ea8b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7c9c3d77d9a0773258a3c4757ff50511e0ab71404411e1483b9369224e859b48(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ef9f41a1ee6491e2017b72f9612a99f9f4a87aba2d3e4d33ee7fdefdb26a3cd(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualChromaKey]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cadbee98122cc61af440b82c108cb9e3213531d034904580fe28ad53aed3705e(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualCompositeImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    placement: typing.Optional[builtins.str] = None,
    placement_var: typing.Optional[builtins.str] = None,
    scale: typing.Optional[builtins.str] = None,
    scale_dimension: typing.Optional[builtins.str] = None,
    scale_dimension_var: typing.Optional[builtins.str] = None,
    scale_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be34637629cf2cfd6082ae09c2d8820773a6f0326957a329231b24fe4cda5719(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dc0d97733f066bd9f38432f9dbe0956a35059b8613af4d1d71e5d6a35502c6dc(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualCompositeImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6038c7d6802961c85638332f39f7ed54110708b781b2cb9b203ccec13e951260(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__12b1ba16e6cadd274e32010108a699a858f642a8723ce3612b5df68c5f52e2ac(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__47b4c094c20226b5aca011aa7a2fa0aa36c7b04d16becaddeec035bb8ae60ee1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0cc786715aaf7d1af0e2cf86077994a2d359a122e7b60e95cce083e7ad3edfe9(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__88b98a10cea7b5591ea4e23fda0e73f7c2102ab0ac095cc4f899ceb99d8e3da4(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0088158ab89b319b2dbf39f6a114fc5a4c04c5f124d10e25192e10ca362ac235(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualComposite]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d1ffe13cbc5b0979d9f0eeec9f9836862ddbc2e1a98f3418ef9e7eea91f1b70(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__869aa6d55d7528c38591f68a1772862c1c5a58fc91170255fd1d810c04408ba2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a1e099ba09c2417fadedf826b4b128edfb17813384bcb0fc5607a15f6995145(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c1f37c2166c072200d30aa65ddf25e7a701b7b18428e00838deaec5d7e085dab(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__35ff8ca62d980680e3fbdb31db485ea9dc4312ec25934b27fe67f62bf0f3e0b3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c9697994f2c317cfd48bc5fc876d457e266776b3c8b5ee77bb90529d81de3897(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1106d5ee35577e088ba4017e8e3e00febe9f4760b018dd5c852771fb8ec5b021(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dc961a488552b51d864ae71d99a99161db294867f4d4211b2b77f19d041486dc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__446ef96dddbabe3e25cd6940eb2b3ef586a014f97f2eda9922c029f5f2be3695(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3bfbfdd2f799041cb5b184ab6aba727d19f3ba307bc334d1eeeeae550e21dda3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__504832df3db78bda539182ead47b8505cdbe2ce91352dca92b84f4b3b17dadb3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2632e7ce9b191753cc101f7b65770bd913c0c096c6f60dcb242aba6b9ab16984(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8d3212f07425917f7c4abe316d161cba50f584fae56d0dc234a77bbda40952be(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ae00399e3c633945e1a7c41d482565e555cdc6e0397103f0a5d922b64fac4946(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualComposite]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f9bd9704dc0fe061e6ff860e9fad9e780680e7d37f42bad0001bf45bb236c6a9(
    *,
    transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aca45515802b961413109f2b236e3c94f1e94d4df48a95a3582923f8e456c6c0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__576bdf5f04075d4e85ce3b47c4a1b060dd330121e5fd53a6c8bdfd545fb19927(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fc5fda7e4fdda8e8fc879b62a23231c88ce9723c4845ddf8c017d066c3962296(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a5cc93d134744a78b0879b73577c8b5161af201b2e9f83c2d7fe856df1b2643d(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__352bef2026111831ee3a4c970eee96f5872027a32471a1102c565b9c896513c6(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7596b7f7bba1ea7541d8abcca8a24ba7249b1f6f057e44894056195ac65a64b2(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualCompound]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__acffa869920238457656d2182812a2904b976437acd9559ecc398a173e25dd5e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f3fe167ba2ee77131feefe930c67c3ada358b829915eaff55a0923680dd189ea(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__895a0b19175abcdb9ddbd5cff1a487646b1c79510145bc63f82214a27398a893(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualCompound]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc6a385d348a9b23315bb50aa41b978533d965b60cab8d0c89c1056f686d8873(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b9e00e6fb17d30cacb326ff2796826430cbf26171a72503fbc628d17f61e0e07(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c06f5a9f102baefbb43cdf9f825b1592bd971057ddf6b9fe0d511bab03a1b4af(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__41d62f5c9dc4b5cd0ca47b1595571ee550e652cc232f432e1cef16319af0154d(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__006e64d4030668ad13871a26fba98966bca912991a082645956c7f3db89a50f5(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2439a17a450498f38d9eaefa9aa96a632fabbee4ceb6a3eb1355804ecc18b1c3(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualCompoundTransformations]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__62c521aaf08affaf18c27ea21ca9cb721cbea7aeb9777613c3b5f2205347751a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__82c19b85d396e7319e93b5ac992afa13b5d1287b30d9005f0e35dee86cce2153(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualCompoundTransformations]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__471edd4b15031ee643b8686c000c0303a8adab3ad9698018a283943c70438c77(
    *,
    brightness: typing.Optional[builtins.str] = None,
    brightness_var: typing.Optional[builtins.str] = None,
    contrast: typing.Optional[builtins.str] = None,
    contrast_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c109c9149deb7cb23e514f20e84ec44fcb3bd4770c17cdeaf256dbf48ec04760(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac548fd91337f0c48bc093d6594f555bc704296b4cd0a780bddecde844316d81(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__48ee2402c7c4cc443b253267b4fc262f57ce9c8349e6f489967662e5071242c3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1510dd39545f483b7bdd3e93136d4e1fb4626fd716e112d17d0e327a8fb67c80(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3063c142e81e881619fced822bb3c8dee84ca645cf87e666abd21615605fdd10(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__33192a63294d34c80571774c989343c9abc05ea7d095093ea52ad90cf0069389(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualContrast]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5d6ac5cdac7fe0cd2efdc6fab2938c1d09f077a2fbe15d8e5d54e330afc65cf8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__393029bd10466e080c69d1a2f1906942db562bb484eb404a1512899cc69140a8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fed8d30247f4190b1ff29093bc2d3985fd9c168f8408339047ae862782b5ebac(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d4261ba6a1243eded2056d86f4a7718af281cb158f7a3438bf28147754a50b00(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c47e6f9b207a0c16d73fadbfc84b09b6c90048763c3276f279b4c3635c9afbe2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8c60a89c864e6f3407bd127c3b50d3d4ba214ce06267baeabad85f67b09d2cb9(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualContrast]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__336176b7927532b8c04f2ef7d657f5c38efc6bc47b82ee77e49283003691e08f(
    *,
    chaos: typing.Optional[builtins.str] = None,
    chaos_var: typing.Optional[builtins.str] = None,
    density: typing.Optional[builtins.str] = None,
    density_var: typing.Optional[builtins.str] = None,
    power: typing.Optional[builtins.str] = None,
    power_var: typing.Optional[builtins.str] = None,
    seed: typing.Optional[builtins.str] = None,
    seed_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b0c892967737f2c228efe7e0e7a0f183fa58ae99e8e3853c60327795aedfca28(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ccc0c2428c9e6e68739ee868725e7629b6b5be310ae7e2b60f9deda94d5a03d8(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9bdbf18bdfe613658c176e857950542d1b73c09abb6c9f35e70c7ac699c4ead0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d8d9c904ded4ab26545710022c79e7cf5db88eca38ed150b158f8114c01ee960(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1af559bb974fca5ac30186010784f6f584b9a7af59e4567a93c77b2620cbf060(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__74b372b17b9a4cea9499fe504eee274ce55913c8746d16949a8e8d3c97c07cab(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualGoop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8c17a5d16befbcc3411e112667a1a563a6d554102c3cd068558dabe82e53845f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__88018507bafadb2d37d97f27745a67b76e1afaaf8df17dd4303b4da17ebe0f15(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc1681b6a28e9dbdaa5ff8610ec6454ac969c23d35ce069a3496b56e637eced2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3fff0f2d01510e05796d913a55fd1013c826027902d46159be2712e5c9e4e03b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__404d95be12210167e0063ea92c0ae61b32a87ef7c0420430d9ef498ebcfb8697(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c0e625333d02fd5f211e174c37ba9c50aa005a363bfd4e771e0dc6e39742f834(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ec6d146e279bcdde733b79cca76fc525d6c21852e7045119f5eeb9074393c62(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ed3fd3ef1d015b6cb83942e0056f0686123db1c304cef06737399136557b6fc3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5543d22597f80f1988acc2acb06c635d70ad60ea818db659b6473a100c05f526(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cbf29320dbfb7f57354991ad612cd01bf2cfc20c90c65e534579d3a19d7dc68a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualGoop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__279352e3ad1d6f45bfb46a4075fbda3d9298455b9a29af86f135aef0cfbea810(
    *,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__475bd3900a18f9e5b799ca8b672ad3fa6ede91fc11a2ec6f334cc58a44688854(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__443209be1f8a6e90d48a2a86d763e66c6b4e6bd8f3086cbe9080ea1085d2d94b(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__319705fdf4894f858b8f0c0cf0c2720a7b81e80f6a292144ef540ad919626e77(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3e0f680a23a544beb3fa47f1b804ab789ba29627eb1c151e26f3439bf8240198(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fec5d4c65938802e3d68f84090f3541b99c3f063045aaf120c44280f3d23078a(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c865ef4d35361c468e317bbde7dce6a7cc14bc8f66bc3fd09bb41e163aa83d39(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualGrayscale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a9b941db556114e408bb50587a427b5d1aa8e3dc35861dc979645871c2fa4189(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e2456bf36a4ddb96f76968373455f11ad5bc5f82af15e3e0c86623c7727c06c6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f74b0d437749615b1c0266ceecc42a0d7b5b43bae0949fdb743950dfef08a2a3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f026898208446849c5ea491480c47dea6219edbc3dbd5533f92f3ec7c70556c6(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualGrayscale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1dee581a4b64a8b568e3b678d6a59147838c86f1e11ad2d229af4fc57e71d7ce(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness: typing.Optional[builtins.str] = None,
    lightness_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ed821d8e88c9bd1007dbc5be87f9609a8c49c08b6590cb76407c751d81cf0e92(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9fbe7a8e232c18fa287620f10622099d391c138fa34981c6cb25a4bb0c94e56f(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c11082821649fd9c90d1b1b0edf1e1009c5977753101f658efb869bb99285ee7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb094bb33338b9886c30d0fea8b5b54cc3492107efb1fb310a63a645e3efb926(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d3e3d4e026b4f0cc688232bc06ba3e1bc745cc69352db7fd109b554e1510d56(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ae1cb21195ebec9c3bc4c599dad5a06977f56bfd7a0d4681a2367d8c77a33849(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualHsl]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__369a6da902e88daff95ecdd5c55a466f0c4e23c9e7a94e18f72f64202dc3ae61(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ccbd9d122931ae17395587a34d4ef3783514126ab2235d26458faa0ad0eb863(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e4034d4dbe4b073914c90741883de00ca75d34e78f9fe32fd6f5b2901e5bb1eb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a140c9c0bd4de1617f83e9f32089eeb9f14cff984576f8f343bd83520bc04d2b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__772468d4d65178b94f8d623c426f76a059b74fee438ab2c9095fdd0cba02ffba(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__58825b875d4b400808b23520aa083891e27c8ed741a889fb626a535baa94eba2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__911de98db8f5f70861dd2b99c41dcec7f7852e4a93e938818738414bcb30edbb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2fe84e40adf7c9a4d962735d2b713014b7723f7318abfba4cff8288fe554bf1e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualHsl]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__232aa06281720e6f8c9d3e7ed2fd41fe554cb28a61d2f298cd90e56b063b49e6(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7de50a89f26441e9e3b8808f00949dda75385c34dd7a35ba9021a6f9828cab48(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__edd0653458d64d5d30d46b54d9ddf12c0aff137a6f47126599c992e48571e9d7(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d450f3c7fdda05d92dcc8fd6a0b7a16715db6a31288c96bcddff1c4d1f7b2075(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d1e76dde79208f9bf0450e87735c5d56a32bb23ec65711f68dd181653c71dd2f(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dc8af64d67309e64b2942be18192d461878288fa261ab2b6a3b75f906e1ea385(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__65e1aeb8230670d68824f5def09bf8c3d7b0f59de978ee2ef6062ad9fcd5a66b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualHsv]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__552a25f90b263e1421ba4fdc5e2414e822143a1fa4fb8981eaaa4bfb141b7d4b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__efe3547d69011528bfeed445b35aa71473bdd8c3397d8552ce5220781b6b3b86(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c217c02a58510399608be3fa559c35cc8afbbe74d1c754264e078bb537a716fd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f41f945e7cdb101b8628d0ab2689d591e0248bfb3ad19db36cd2843cb7a1369e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__776a655cdc89efafcafc98ff1587a6a7fb2b40ac9c0354baa3646352fd799f7c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ed1c5c90734e8574511187e1deab286b5df9e9e44e7d7f5d13dc657957a19b9e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ef3b7091a3ea70e59c337b894787c8006f155f79bc58dd4f43c51399e91562a3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__956213f111975cab9731df2828e93d78c99e686741a20c131e2801604b4113ff(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualHsv]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__81a606b5e852de5642b0216fbc90c2f3720399da5d40d3b9da5daa4ab9276cc9(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    dimension: typing.Optional[builtins.str] = None,
    dimension_var: typing.Optional[builtins.str] = None,
    equal: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionEqual, typing.Dict[builtins.str, typing.Any]]] = None,
    greater_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionGreaterThan, typing.Dict[builtins.str, typing.Any]]] = None,
    less_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionLessThan, typing.Dict[builtins.str, typing.Any]]] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__145b60bac96a38ebfe672c7c69ce301f911056e26462fef63340fda5d46c7577(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__38deefedb1fcda8eff239e3deeac6376c4db8a65a312eb5c49bcc9740c0b3032(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab084858db04e225125b11e96a770df9350f5fb3b17ac79f071351137638fe95(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d8feffe3c4fadddcde3580bf952899741f3f5c8183a1023f0c6bcd869d911710(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionEqual],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__28e8b6600aa2e58c2d9fb7a6257b2c2369dcefdd96c6241ca1f1abbe48fa86cc(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__80ddc414bffb2fd309217f1975778f58b498ef0ca04cc4b8fd1a31b5bfcc8137(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionGreaterThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__579a36839c3fe708af3410ce4695c8bcbfc9f260b23b2b9470ff942e78c9d6cd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__54c27e96fcfd5a48e09aed820a6c012eb2fa12cd8aa3fe084fa588173b4d9dfe(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionLessThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__41b32dd886b348fdc953ba9d62a870fdf279f544f4c432deaec4a8b330004fd7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__16d4b5c95200bfc6de925efcecf766ff529fa51dc1a526347a926a68e17a08fa(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__68b57b933c256055df553a79b7dea4e81a3ec4a57b42456cca6a347d05849956(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8285d576b3f53734e40f4d49ffbede6d02ffd907e9f62e87755bbc2e0580509c(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__157df7d190b0db3586a7ee7c6425afa712d997691984e482c2dd0a96b193ead1(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3f30a4f8e92ee8718012cffba860d91a2ebc7351c8590d81b9df0967735bfa42(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimension]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__73eb8e230298529a7c89a539e0b15524b24e0fb50507dffe5acf7582b20671ef(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__410f94ecb444d3f717cfa7edc864d0bcb8d703b5ab4e692608c08602555fb862(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__34a9f6716e69a8ac30222ac2cb481a30c82873d8affaff1e39415ef886a35c3d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__677fb16e44f9b9fd26b789564982eb954021dd7cb7b47840027db051d30332ee(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__36cac7c4670c8fbb41811cf08b38d21540370ab32983d673d00689eed7dbca06(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__19775ccf74a4caf2e9e2d486e446ed1561fce035b55a368059feaa06a464590b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimension]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9e924a714dcd544b2b74a5a97963df0a5980a061e40b51f7e76eac299b7e6d45(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    landscape: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationLandscape, typing.Dict[builtins.str, typing.Any]]] = None,
    portrait: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationPortrait, typing.Dict[builtins.str, typing.Any]]] = None,
    square: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationSquare, typing.Dict[builtins.str, typing.Any]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7a2f22cfc29bcb19b58fbf2bd1e9e909cc659e8e3acfaa360300e922eac3b1a8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__63181f3dd24b051332c833ec36989c328033805b2581a25fd5452e17844e6650(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b4a5f2e10f38f50cc279333c6e9d79ac16b300f9408c7ccc4735ad62635c1404(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__87b022de5f5b1c2d6652446fd866b012c726bbfb56beda837d33d0525657cd10(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationLandscape],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0136633f1c60710e9e0e67d9ba6dd28fe9a0ca04638dc075d5b28856474bdf35(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f4ff9180fcd2593849019db5b027305ff40a7e76cb9c0edc000ce94c0f94cad8(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__17bdebb824477abbc2763888f9065fa120326891a36a5d4656c3fa713bdca2b2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1e350b7304627aa24ea639aedcb0622c687f270d28d703466d9241850315de0f(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__743f4caa2acfff098b3511ff818e8c3d95fae064c7f3664e11a9a52fe7f768ff(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__71d87644a073aa10af3882e2e3216268ed76c981c7a1500f0c4b7933fbc5d59e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientation]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__847351e3c1f87bde002bac40b102425c3337cb8e0ef5bf7b00ac8a8bdb26c3a5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9f6cd26073b56134900596b493d3e55a32ccc2ddd54e9cf456ddcd2e2ff68471(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientation]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f86eee80eaef9a13124099fa55f1ff6aa4ada134f1eeb0912b9bf1cd71028091(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fa62ae133ead6c9cc6c157eccdb5e4dd3db4a24a3f53696bf50f523a1026f59e(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationPortrait],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d00828fbd40bf6fe91b56c2453a6b485761a762b03073b469ba69361ae23ba4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f60ebace3671a6746add199ddc30d8ea927e9819c2055c2f727e15cbdb2f4471(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationSquare],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2cbf81abf7569e355df6935b79bf106966685ba586c7c29699ada2ea8fc52a3d(
    *,
    colors: typing.Optional[builtins.str] = None,
    colors_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e5b40a895e340b3eacd570db776e1fcd33a13534d78bab38bed30994f8bd1da4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__239e3cb3ddbb7d11331e665d761c6d585ed0bb007c71339d1c04adc2e08941bb(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__92aef9b767c83cfca47acd2d35deaac1f612214fd2214105bfad41251bb10d12(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__92b7d0309fcb7aa9ee78186ff4a7cff3ab1fa64a96c870e68b75c3fe98878f0a(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__75002e6d7bb60a1a93b88de4e263de0b7cc5fe075e4634898f5894c7cda52160(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__03f514bcce7bfb97e22af01e3fd0ea59ce27405940c764477bb2388f35a8ba87(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualMaxColors]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7b64ac344eef9e7379670c53bb1bf685b4655a6d45f17f17baeb8c6f1ea0d66b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cf53e7aee0de5f04bda36e60cdf05b56e61d6270a9d6d937b88d708302ce6ba2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eefbeaa57200d5740d954b8ef1e19c3be8945038ecfe238c3794feb91b4ab499(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5fcad2a4f0917001aed9113d4223af844520fabbeb66385af5328e60640aa1db(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualMaxColors]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c4298dba321107849339bd84085d4dc3d184e8897cf11f9143c88078526e55c6(
    *,
    horizontal: typing.Optional[builtins.str] = None,
    horizontal_var: typing.Optional[builtins.str] = None,
    vertical: typing.Optional[builtins.str] = None,
    vertical_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cf76160e0ba7b6e76f4a3c655201f609094e0f8abc8ef06cbe43684610804420(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f495b5eaebac595f9a8ecef950c65ba40dcbcf6279bb5b7e53838a006e1794d9(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__97f95fe0ee26992c006b5dd26bb108c8640eb8669ee3ae9b6ba719b2aa21b081(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd7b879803886ae51d6293055b177caf5984f296a4ace54579aa61f0546ea6d9(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__22e0ef29d4a3764f21e1f0f27af2de2fa9dc60e7c101071dc62abc2cce14fd47(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f9e3b836582d8914edf2abdcdc32e1eafc02b99299c8880f9645da5867004fca(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualMirror]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a2f6e4e03517addc0ff46020e0d207ead24dfa9256b68974e1f01fea937efaba(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__495427de4c8d6f7be20d281b28a2d3691fd48dc7d74ac0be373e70951be519aa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0725313fe047af47d267dd2961f2d1b72cd251fb112e05f0df586273e99c3f78(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__514938944d3efe16fcdc526850c9e2ace5e093d673bc3c25d869ee185bae3531(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e49876a9ea1974aa38616c7f0dbd439f5113e293fb6e8e7b58653059f3d5d864(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b08b1fc42dbbbd7d1fdc09ba39832a207d739a19a2e17b25f1b98ccadea85650(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualMirror]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b14642c5495b843d6c47a9fb5e6720b667c6836465b465b10262a87c21dd2c9d(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__198eae6abfd010c109b00b630d8eb2619ba06e69f261cb7290161f89b08d9d66(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d3402f7cea88bacc9cbe017f948c811d060d7ef6543d7c682a878fdafe1ccb86(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b27f5b69cfb9f9db63c16e40acd809350dca6a821ab27a4486a2bb3c457c7b10(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9c1348f9ed524d1a6232ea8aa804e1e6062b0c35901093281730cbd68d6a6c37(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f3ec52c3b2d9d491a9cfd768eed2f65d66f3229e030df6877ecd07ae78414c27(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e2e834a1cd008658797b12e3516b9ae0332c66f8097d4018b79f011997614212(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualMonoHue]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bea5447eccd5029448a8dbb076dc0ca0d99abb07fb5c142bceac6374d499d026(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3238520f6d6cfdfc9bbbe92c0baf1ab3580eb69b8eeca4c7f80d8b33c8c6bab4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9eb691a567a7bc2c897ab55a8e649afbfa2bc324c283138e729b0be6d4e0363e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__83e32cf81f988410512c28c176c71cb7209815d98fb2bc6700ca7f7ae396115f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualMonoHue]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1bc4ef3b1deb7006be1a82de92642621a5d3bb3ecd7c67bb9935c84ad90bb06b(
    *,
    opacity: typing.Optional[builtins.str] = None,
    opacity_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d58d12194f289b83715b9d300eb717ca41e36991b866d7f4e72829eb76576cb9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9dd5e24509b9d6e4806567bc5b7ed375621b6b4f75c19fd4d25462c14721b662(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__61488988b78b04853b41b84c9087c9321baeebf8c81ce488c6755612de9a5512(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1409c30389627d87cb7929c4402d3967ab8cfd5f29a551d31d244ba933036268(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__30378fea24e56f72aab79fd4240abf87d926811c17cb713357223fa664f69427(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aaf90c02c0c04ce51b744d59198815a707bbb00f84bf165568792e92a21d13fc(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualOpacity]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cf34743cc25db8db98c8e894aca2a40949a7316bdcc28b062bc85cc5362a7a24(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0d485ca8a6044acf62abbf1f38c82c6d0248d603465c8bbcf7b0e7d884cb0573(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f2547face475d494d78cac571cd53c3b3a4bbae4ccdc836095031fcdb181998e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6b00885b629c97cd86782238cddbd6b4c265dc2f9b04f8bb944efa6f0847426f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualOpacity]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__783d2b98bb95a37d910158084c139311c8c28925b2e74e48b6f16c7267d13d83(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1a9729a9b1b0e1a6135c07d4c1708743a5160cf77f225e766a22734b0aaf108e(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__70fcaebf860fb11bf450ce9ac32542c114a7b64d14fd2d985752f7e92ebe82f6(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualBlur, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__21805fc5549682f35ada359a1f8c85a73af3d62acb34f527f04fbd13c1f723ee(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualChromaKey, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fcca0ec9c35b1785022c0ba626400ac50f9948457965ea19fbb4d0d286e7fff5(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualComposite, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b3b0453566b4e3efe9cc1d5a826fcb0486459bcdb72919286716cfbd86af371d(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualCompound, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__88eb81a9534c1d257f9cc03364c320fc8566872006826a63c6c061e994950591(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualContrast, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7f663900115114d958a77a5e3ba7869a96e5c2a6f8c632a8cf98afb4df045815(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualGoop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__17e2045fc4b926510b44b12dfac29e3b9ac7b4657793057cfd8ecb1b377347af(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualGrayscale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1d6dd59a6df9f98e4713cb6f0834c702e2e1b4de0ae252d56ac37b36702c4312(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualHsl, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a14f9b03e308968dcce52bd9bacaaafafa6406530b4d147dcb6c8c3caf2e48b5(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualHsv, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ad10bf9a471d18382c5c6973ca0665b8ba89c4b95bc366564f58c36d1345d61(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimension, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__91f74697027893156b3fa0d18907641564d7285f3ad2be5a6b52add7e8ba7586(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7f556d395f72c42364e45a4a91282bf266ce13607ae3d61406f212967f266746(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualMaxColors, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cbc406eca9bf464711fd607d73f2017bc9a0039bc6427b7f5968b9e0c30dbc2f(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualMirror, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8f7ac22c62d0126b8bc7395bfaaf888f4853c39e0925812c68f17bc4326e3245(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualMonoHue, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__517ecc3696aad148ae411c6c35f245400e08f97906092a87cb3773352d566af3(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualOpacity, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd7c69a9d2b7d3f2fac3abcb8d82ea11a039311f7c5980cbf127b8d96ac8fa99(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualRemoveColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac3a50bca450efe8dac87b6c503aca65b7aedc04362d00041780a2160c5ba341(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualUnsharpMask, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ae429b111640b28664793a01e36275a33d567ae0196a954367329104a046311(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqual],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d3ea131693e345f0bf0fd8322a1ef03a92da16dac80a49d74640baf3189c5320(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
    feather: typing.Optional[builtins.str] = None,
    feather_var: typing.Optional[builtins.str] = None,
    tolerance: typing.Optional[builtins.str] = None,
    tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9b8dbb6f81d3de323a3cd512dfd239d37e1a719293d1f0108e5d2f69749c0635(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__29b733fa6094bdbe2c72a673de5d79c6ff4d85d8044005a0cb78ef181c701e36(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e9a5fb6f4479d9abddf4e74e4ddbe3bc9956cd154d70e8a31c492ea76f5070a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a10869ee299b6c7f1b30d376e21aeedbc54d60845ee0bb584990328d07192b59(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cec08d251935312f9af5c3220fdbd66b7d6d34e5d4418dbf3d2c9334e3dcbb17(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__98398684a404e5b0b7ccba846fb657ba0b531f9095983bd5f7610ebdef70afe3(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualRemoveColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3cde0e1950a5171e268c2ac565f673288865cb44042da6cacfae79f84cc7783c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7c21ec855cd61c314d3682142ab71ac1870aebfd6fc695dc6da381a62dbc1ffa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d151ea83838c900925a83a955237707de0728b4d7d849c10bf0f5aaaa02483c7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8069a8fec15d16f1ec6dce1aca3aea5ed7ad0971e62d00b163955ff9856ceee7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f3def86c4234e31538dcac397ad7745655b7be4cdd59efa5af69a83317897e05(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__90c99ac3d5ddcf4f951a0967ea3bc3e7240bbdbd2d7f17eb8f81ec05a197b14f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3bc23a87f2a4e6939087fd8a1c5ee3b3007832d21ad226fe66f2c2245f0e8ea3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f214626d2b0835b9e8acfc1efa255e7d58a66edf9fc280001de0ec8caa546e0(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualRemoveColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__92264a8d6005914f3f33e32c24dca704d8364b096cca0d2394491aad3ef08f68(
    *,
    gain: typing.Optional[builtins.str] = None,
    gain_var: typing.Optional[builtins.str] = None,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
    threshold: typing.Optional[builtins.str] = None,
    threshold_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a68c51564750884e7097d932a045087a4a480bc3859c81c69104e76f0214c261(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9e167099ee366b7296071765483c5ac875435f8247f4a0532482aa47280c7d0b(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__774a9787ffed950d30c37df633624d91278038a358a9d2589de2c6dd717df841(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b4157a1f7586a4196a592c8524c6fe22327ff4eb7cbf31cd072168102e85ce28(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e30fa9ebffda974586ae8909c23e39aba2638932d5576c8ff2d0760ef62fe7f(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e9a156151d8fbb80990bb57e8882a511210209828704494f712fe096c1f7bc60(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualUnsharpMask]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__22ae7f53c30a7599f5e221068d04f6251bc782c40139deee74703c0aa6c96b52(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__552a5e5a23553ec6587ba3d59d77ae8022c519d3fbc1e5ee2b129f4a227df34b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b26f3c1207c20723a8d71c615d943ecf99fbf9bde14a837ad916dde85f020b95(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d1a3a3f06a23be662b0b734aec33b7383bf64eeaa78077df4f0c20b111cf8d74(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b14db237d741ce71aa1bb656f256a9a4659484dd09f832b487669477a36cc5e6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e4b6c17f439051ab02b8c38f3510596d4ea5d041879df85c4c6859e3741f32ce(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd148cfb7f4ef272e5af763c75876c97f681331016e161a635d2fe51fac2bf19(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b4d25be7d101fb323d57d17ad4f29d205b80c1690b592edf1adf416e31b1105d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualUnsharpMask]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d750cc7377205782a81268066e59b80cc48891d12302b3ed0b3b6386f4715e77(
    *,
    background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
    chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
    composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
    compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
    contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
    goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
    max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
    opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
    remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__290bd336dcbf391fe4fd2d1c1341b00d3da61a9138a0d37deca2671df15586e1(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6919daba2acad38f340dec75ce255a73f83419891bac87804ef196913f4808b2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8e7d678ceac9b653dac2e8648853ec4b4ede71e15c083afe12c3b3ec0bf047fc(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__780da4ed51a23cfc51dc9a3d58aef1865d116daf033251a132b019f6d4490be6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__47bf1b996050a25b47fcb45d9c2fd776dc2f7a55b5a83ba28bfca03695c37305(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__303cfd6326638be22b4fc5596d5aa41c3e904fe66167ffbe102ea8dfb0c462f8(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__66b3f0eb3bb7c512437ab410db608ab2dfe3c618dc7a6391af4e6904250d2725(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanBackgroundColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d4df626dc29d1adadc0d257c1c193b170b65f544849069b19cc80498beefaf27(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea98670d500bf585e65b87030212f3ed0906e9433a5cb9192740723f0663f8fe(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fba93e10cdf79ec4cd5fd781138c1d0b2c1cc0c11b056663e38cdaa4e4968242(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__511569ae0b615934a1d838b6793018ae0fdb608b69360431956c87d9f2895d48(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanBackgroundColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cad0c260fac22ffd677743c0743ab2af2f3076108f2f591104596cc3bcef2431(
    *,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb8b662b8621cd57273b38d01b37ae130a50572a7c0b20c9fcdee5f91a92f76b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4aca9a43c0ac59d0608c8c9776fd48de9a41f0afa93c247427b07aaf90922ca3(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ecbffc14810ecee99110e8f3abd4983b4e1f5841bd8af5095300e71a25e255e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a06009c55f5799dfd12d0b3a69feecb85454074f98b2242a5df48cab2feb947(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a509d4cfbd794119d2e8cd2250156ab033d79fc6177ccc8a91ffb3d76a57c200(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c03a4a4527cace6f7297fedbdaac15fac489aa6b7663210c989b5662b0c35d27(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanBlur]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6d1bd5c4cdf3d0f3c52af719346d1df0bc20bb92281b30a91e2b01d2ac3d6dc9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1e650182b89783032e79ea52f66815442cfca39877d27af371274e1344a99d73(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8730121515725dfe4c01a356c2dbeaa39fa07c3b9c3922945d27f3ab38c854a4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b9513b96fa5f8d10d57e4830e3c8e021c12597e700671319d0b6ca6a35906f6f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanBlur]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2588afd0d49734d7320a9e3a0a1234acf413e76e1fb35fb73b7ea684bd60d916(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_feather: typing.Optional[builtins.str] = None,
    hue_feather_var: typing.Optional[builtins.str] = None,
    hue_tolerance: typing.Optional[builtins.str] = None,
    hue_tolerance_var: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness_feather: typing.Optional[builtins.str] = None,
    lightness_feather_var: typing.Optional[builtins.str] = None,
    lightness_tolerance: typing.Optional[builtins.str] = None,
    lightness_tolerance_var: typing.Optional[builtins.str] = None,
    saturation_feather: typing.Optional[builtins.str] = None,
    saturation_feather_var: typing.Optional[builtins.str] = None,
    saturation_tolerance: typing.Optional[builtins.str] = None,
    saturation_tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f0084589c2d1cfb66d159dc81f01326413534e2166a884ec64377f50434ca6bc(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__88ca0d9a68e83063ffe58743a80c664f9c0a42d10f38391fba00924abc6293f4(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c276884f40637b68c658b32053b712ebc39f81260c4a5f29a5485498b9b8b3ea(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0d3cbe5c929d1decc7834e8e3dda12030c92718632610b6732c039511cf006ae(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6ef682e2921241542ca714307fabd17847d18922f0f053e296c237662287c9f6(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__36e11eeb1e9d70f3968bd9dec3ca96f9731ab3a60b4d8ca3f05c00d739ca3dfe(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanChromaKey]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__704e0bb154bfc5eccece66ea7735be0bdbf5e96bf62749a03fb64fead36aeb8f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__905b6368959633858a4e98b48bf070a2fb6a75a1217e0f3ea1c5f6b23b2b58de(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__36aa489e8d0f62170857124d6ad2aae001b8be2fea9612907c2fa9adcd0bbd42(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ed96743a9fd413ad47ddd335e19da08db06d61c82efab9e332c60340e2bb7102(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__67df94ec41ec6f977b5afde0ae6a134fba32ff6fb5a6e769a46e2667f5716579(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7a98d70ff83ccb7f1a5b7ff0daed48b62cf60a3594a954f01c314249656afa52(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4b436d867e0373f09893466aa1da32f588875fa7f45a29678b3d5f18618317b4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b189aa93cf0905c7d428d02f6c6d811c0b4dbccd07739de8dacdc9e4731dd0ab(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aba7480ee9feeff4b05f05bbcf29771212be9a6599b020d258b92a60669cc453(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__60a8df7cc237e82fd1126c2de36c1fab16410b92f4c26b99dcfa2edc11b77243(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5b9cdc13963ac7e13dce848bfa2721483a8225abe41687d4652d31d08a409e38(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__18ca2fe122d18e95e07d8d0990e32b25bc6b32b2a7cf5f9efc827d3ad93773fc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b97df8db75eed9773e620b2c7a0370f2d95ca2892e9107b2332c28c013df73bc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b374b1ca7866e95d8a90bcdd902202b0452186b96667ca00989fc5fa44e7f8f4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ccd5b03d9f594f146314b12945fe1f0c8309620bdd9880e3fe430305fa5dba11(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d0aa47ff264ee3e9e3d1df805a6eae95cabbbb2be7219a1182112db592466271(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanChromaKey]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df6e1adc933c5062d958c27edbefc60067337827d96e417d1a7c519698becf1d(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanCompositeImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    placement: typing.Optional[builtins.str] = None,
    placement_var: typing.Optional[builtins.str] = None,
    scale: typing.Optional[builtins.str] = None,
    scale_dimension: typing.Optional[builtins.str] = None,
    scale_dimension_var: typing.Optional[builtins.str] = None,
    scale_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__07c01a7766a43f8f837fa208909ec6db23330bc9b2548bf69dca5e41fc780990(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aa6ad784965d2a73d3202739f012f21ff041fa1f43a4b256ebd8483453fe45a0(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanCompositeImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a2ad081a6dca0b0261d9b1e34fc578707123b862dfba16d8c7a95d7e8d767500(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__25c00af45b0c12eac173d361c4e4f45acea23adc93a21ebe9ea22f419f15843c(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__070dbe96add653c9a4368519e7e610c75a07710c2c44408c937b7c2abe6305c8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2da3f3da6f56f299df0d1ae07c0ef051a0bfd96ab841bcba30c917d1a5892811(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e5ebfe03771bc1b2d5283a277b6bbf883181e13cd8ad600c63b2369d132aaa9e(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0dd4b797c99570eb69da3fe1acf84a3e0976ef8bd468793d8573fc727f24970d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanComposite]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fd3956ee50ff8885c06300575755f2a547c7c999b3f051452ec04b0b087705ab(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__15386877b8e6858cdc3dcddfad206891a11ac17c3a49d0239601901652620d2e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__191dbadebaa1ed2ad70cb2ae3a99ad347d4b98c4501cd0941e2d7221085ce53d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e2a8262fd51870ff5dafd02fc80015fb8521d5a1a0ae6a3833a1ae575964ac37(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ffa1e7946a1d50bb3f3e1242f399acb231f0fbf16f0fe9d567bd84852dc57454(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a332af47bb067e5b39bc470b2e75f0470db7ac64b7cc2fab7672784ce2dfbd8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1496c4e24cf38511548d3540df04a92b07732bcc62555c24224187c64b2200a9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b3a767a4b4e42c26668370894b90debb28f5e73d7a1fd528d15231cfb3402358(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e1596863f0433c2f8e6fb023db082528d8cfe4a2ba7ad8960486bdb9d139610b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__04a00fb4a9c765556e99158858069a82ea330f8e25901a92f013442c95d5a42d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a867086b9b59de34b74280a752cd95f358c6f59c6d17996e07272f7e09241572(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__90eac1f39db43789776ffcbf1636e20fc81c543e55b4ccc9896c54776fc2e8a0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6cb5e33d1c872f2521f4560d2271292268ad1e479ddf226fcfba150bd726584f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e3115a37e4ba0d9ae595b39e5ed9e7955bfcf7269de70358ac5984c792264e72(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanComposite]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8e53b3b54dfc56472b41632ce3ce4ffdd2f778ce22a36d2373121622b3e752e9(
    *,
    transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__196318e2e711d41238e6d228fccbddbafd98719946f32b0abc242b17c8d805ac(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e9ef47de65d16278840ca332420cd76f25cf4493319085614407a3f4141dfc0c(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__13a17a384a3bdb7c73a04c382ce71054ef11e473d2238978606e1069fe58e040(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ada4d9a6da7b6a6bae104197a9701227793ae3006ec739e089dbdee5fa59a611(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c5b4fc85a215bc4026c209d9a8792a06cfa4a42dc558d796a9bf1ce3f4cd3771(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ef0af3ced37270369e8e67784fde896c73e16256572d39459583c50816788804(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanCompound]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__79095bad7a8a354fecf9e60c2608be519ee4010da61db543c87853f93f91cdff(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d0a4ff8f272d05800a59b015bc14ba03935bcc8029ad853bb2430a7a708c647f(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__13f7dffa60cb8594d28bf75e382a187d20c0710a3bb0fe946047820632ff26cc(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanCompound]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9393cb5ca1c53773c8edbbe2d84e1e0d1f8c498c55ccf3bc8c6a21f044ac6d8f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b80019392a47770d4fac94267c46815da978142d0fc312d48771aa73864dff01(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7545691e0f9e9833d59dce1a937fd8d371c5610166987d14e291ed48a70af938(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d34863ae2eb2c34830bc2d4a71c2688f8557aa92fcf3c57f17a3c06922d43855(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7675ef4dda4539d3ef3bb5bad88666c4d33b189eb5b259d1990ce6dfef79e773(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0978c13725a67c0c50780772a1632a7a7cc9e9e0c49f534a88361b3a2f289e0e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanCompoundTransformations]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5e9f4a1046ccbae847e53da66ebf0a7cb2b81d72d58fa0b70b41d335cf3f3657(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__071133b5ff205bc82658533f06bedabf6e9eef5fa288809359e786f1ac711b09(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanCompoundTransformations]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cb74241bca3359c2cfabbb7bd511cdbe07df5f7caed4f88bb928633cb64b4fe0(
    *,
    brightness: typing.Optional[builtins.str] = None,
    brightness_var: typing.Optional[builtins.str] = None,
    contrast: typing.Optional[builtins.str] = None,
    contrast_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a822124752975806982560c66496deb02699aaeddc2ea14f3708d7b2a4ec796d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c4febd0c06738a92735e1ab41a0f987cbee70449b0c5061525091072c88ed2ff(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__59e55916ea11e2618b63eb7ee1cac9772b8dde3f15c76967efa546a9ea91cf4e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e46f6fd539a61e9b7838397ced48a09fcae69debf2c7b2c580cf8f93e419b1fb(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d6495894b912dbb4e6eff24b1d8d5b099c5d2ae686143f637a0879d6584cece3(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8627639331e0e3ac06d1fdddf467300d9d9d27dedd76e37ea47afc892e652172(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanContrast]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e479b0e61e829ff4cac090665ee45b88be38bc3cf963cfc788f18f688b3a951c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__26aed966cb7bb8055922e5a45d6c245ed5a3408e6aecdfaee8b50d7d9f7a5c55(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__51fe3f82a13f8294e9bef4387e4c4b1e48dd5b86d1607a68e8875ee33fe0b005(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2353e69d55129b8565116c7c572cb9b4b661fbff76392c0ad6225b8cec2a6229(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__da66e3bd8f478d6b0b93681d0e8973dc1f17011fc0724b52944d36001695018e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__773ac663c382955c8dfe8093ce61acbee9e81aaaa2d2588274f9309be3dd11f9(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanContrast]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__53d531cb3d92e3599ba0d20083a9d4da84d11c5d8e3f4313fec559b8504a57a2(
    *,
    chaos: typing.Optional[builtins.str] = None,
    chaos_var: typing.Optional[builtins.str] = None,
    density: typing.Optional[builtins.str] = None,
    density_var: typing.Optional[builtins.str] = None,
    power: typing.Optional[builtins.str] = None,
    power_var: typing.Optional[builtins.str] = None,
    seed: typing.Optional[builtins.str] = None,
    seed_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a6b945b6b1788c5bf1d913e8dccb8170e8c1f1931bfb4521aa4c9a33459c04f9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__21d4f37aad7a00b6fdae68c4cac6024a29e8351b5a5af50c4d74e9ff3762198e(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d57a36b03d7d7c63a55b5dd9ee262bb724f11eec84439b0715cda39265a7a7be(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2587f2c33c1cdde7bd5531213fed66a6dceb1112204d32cfd8a0c74d27c69ed6(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3493eed3920c277bafa3b7db7f2f3643b083bba70e845d8d9ce7f20c64016060(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6ffbd7951ccfdae392d057d99a83196c07d30e7763c9fb1f0a838bd8a70ede98(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanGoop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f63d6eea55aebfa10b8873cc38dd3f90a4810b81856538bd92ac5524db5ffc3c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d7bb088db598779e4a79580879f7dec1c34c51f3c401ab464e1d027cd887d3de(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__19ece81cc4d8e0f191623b8351cb21ce70650a4efa339b64fcb61eab70a01263(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d007ade4038118a0c66c4c3787f4282aea1dc785ebff4ff3a84900ceb7040fd0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8df505d1d41533960cef579d8243a6aa5ba7dd707581eac78fadea4078cc1e4d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f3feb26b6d87214ff08c22f239d6af8831c32ecf57505832a0af10349411a668(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__84fe0b7cb9b2064118ea885f43576d827c025f9bbb939dc4273fb9e1819ab840(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ad14dd81f1bb572bdabecfe837f71a372837b794b986abb1b762d22fde7f662(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__743efe19498a681dbbf7f6241305960c37022719e311d9dee318c444bf20470b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f3b843bf5218f2046a594b0122a3f4ad1b64f7b479370244d2dbfa8589e669cf(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanGoop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__09c081c653e0579e38e601b17cdfc5f2a56151cb2b22e9a9005103fc198f4182(
    *,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__83c756f8a9dcb986d3c518303cf98cf85b344715d400bd94725bb72d20a2fa39(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bae860838249771734e4d8e9c93a3145499e957e91b9aa7f21ab86d719f2b3cd(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0e6ea1d576bb901186797fed79f80dc365d023e4c2211bd0c3bf5400e004cc55(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9eac1b7466e4f30499b3f4dbcfb011bd0fbee8767ff70a78de656f7d1ca0853b(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2497eac620524b234e1e969697272bc8c3088059d968b2549fcc27aa107974cb(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0c3502ef21fd1d02acb432f014e71913b13eed8e3f26c9adacff09fa0c0365f2(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanGrayscale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__abc0dedbedea4a0881cff7222eb303bbbb46d2b2b3fa9a74ee1bb95d30836b54(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d28b79f33aab96db8f1ba33e71326340d92f85de252d36e0f7c7b7892478ef3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8894b7083d32f42a308c6118ddf6687264619b9e3dc39c7138047dbe1e0cfb09(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3446430fa6831f6a08171c862d975d1bdfa6986865b3e5183baf29767ad365c9(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanGrayscale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9eb470fce3e08abb51c4d195371ef8c0722cc2e25b50e7e081ff73ed418724fa(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness: typing.Optional[builtins.str] = None,
    lightness_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f506424fba439676b49901f3b1f1d3cf8a79375e6892712a9b3c7cf7837bc962(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__da5fd386f488d3edbdd3f805e851b05bcebfa6a9d49e211fc64fde7a8025e5b7(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc488cc4ee670a01883616b9431a30d1bf4a783ee19852a4490d021583baad3d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df20ba526482826dc3501e9a84dfdb61cf516f13691e0b74f83392ed7751dacb(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__75703d638f46b1c77d155705848916a031688a0cc645e7e25ebce6329da7388c(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__56b8bf604d8222b90a2e981c64d91cb2046f0ffd19e62821b06c33ad8ef2f8d5(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanHsl]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__24f7a160ce34b9b00a8dc801ce7a139390bc4b80f00991f2f0e0ed449084f13e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a0f4fb7e6377f5670ce453b99651552b26ce58e97206129e2247a65f1c9e9f5f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2c8dc4cbd7fddc924794f5dd12c7a04441fc0e204877fecf09b378409e40c5bd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__07145bd873240846099b61a1acda5bd0836ce4a7978091081a7a80a542a041f1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8431403213cc9acfa4ec25e5212b3a1eeffd5840a683592189c925d6d0721925(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c77d20d384be518474c622cf19891ed2d3cbbaebd35b2116579456a1fda88f95(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__82a2823ee1ea06190980e5c5bb697014357664de07989b23ceb9bf7d9b5c4c80(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1d112cecf4e30c44dd615943874f369e27725c34bb4b76fd9c45c3e262479598(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanHsl]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aa45ac119bb8d118c761c77b9f976d740ea4b6889ccc2b3bd77538c08259a588(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__470d0b34cfd1f535aa1babc126d3b8ad4a58427390d5f1c912dcef86e219e489(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c6a53e79f25014ba2235edbd3c38c2c6934034dbaa787a0eb2d49b3ffb151869(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3f5285dc9cc9538eea2337113f1f487f8cd14d2bb88e40209db3b6adde186f02(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__60c31ae393c36f34de4fbf17804faef3fbe3e1006cccd8855bd9e25046518516(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4d5a9f7de9b5501bf9f7852af91beba61105dfa0b170816a61806b06810623d8(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__05b179f06ae5db0d60f22df29e5d81b4ec3d85c92a7e84e2745c82975050c84b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanHsv]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d551209535668e9ead7f7d8ba177fe3cda8a02a6514a2af4170838459cb90870(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2586984a72362166026ed3bb5e59171f3fd7a09c60d5fffd7aa36316be8d1de2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4dff4d4f56dd695964a388c886230729fe2691ebd8190a44e1b762567ceb7ce5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b88ffe91ad932d00e0a3b2aba5a9d42f415740538845e14ebbf92eb4bf272832(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a11de03913442e479273ab40f5de8d5009483dd9330233182132044dd1e1119(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3bc112493960a8bc2ce538e45ca417045806a31a079f51d7799497df98750cfa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5c9533506992e8c677c8f8b8e892241e1acd9dcee29dac1dfcd17339a8af6ad5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__864360bb1259fef3231a9e70b30d1ac97a81bf5afa056b80aed3d56e767587b4(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanHsv]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d64da2088731108758af0d4f9e6187c56401524d187d2767cbe073040d7e0304(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    dimension: typing.Optional[builtins.str] = None,
    dimension_var: typing.Optional[builtins.str] = None,
    equal: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionEqual, typing.Dict[builtins.str, typing.Any]]] = None,
    greater_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionGreaterThan, typing.Dict[builtins.str, typing.Any]]] = None,
    less_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionLessThan, typing.Dict[builtins.str, typing.Any]]] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__66edc8b6f040ea47ee277f327bb466ab77a603a237b253430c524b4dc5c06c74(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ae66a154204dc5ebe745a863ee0bf15bba12c3cfcc26ca6de590cec4017c9b79(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b0af8ebcbec5c3d12c77451b8490df31bf7cb6264ff0aeffec5ab05674bae6bf(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7e6e038be699d32cc475c1cb06c21ef969d79401d6f17ec27ed0e3e2c93d6a56(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionEqual],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e73115e32d521cae8e4716488e804cb2ef0b863ba9cf8514fe89dcd94e4e737f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f4edea749d6eb07f9338dc8e20b3dab353d7771a37068e57e390dbd90867911f(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionGreaterThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__11bdda87b92699efa101789de7da36a3f521449bd3b878edf8e3a3549f15ec08(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab4aa18c0656d9db2c9d7fa64b7c82b200d01a79154d79b419f9abbe12f5959a(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionLessThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ef8f9eae64fe3a738e0d2dca0199eb0cafef3cefd62d70884375e59a0176a120(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__274170dbfa2d8261653ff303f5037b9b23c0a892a9123b213d47fb8ac84a0681(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7f3700d440a404021776058f8d51a8cf2a62f8d1aa661d5347e1710a39afd9d9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0685c1dd296779a9df20cc970069ff2020185e54005c30b8d5f5fc45b99396ae(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__94fda1b6864a2586bc2e0b2064aea4dce16209de57f3542448b7d7d014401f27(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f098126d5546a57d734d7fc275015bd6af014e6d74c9138abb5a312845979a2a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimension]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__363208d67a89dfdb9c8aa434152da5477dead7fcc65cfa630c56542836cfdc40(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__03e7d7e86655a2b95247eba8114d3256ed830de9911006b9707b3b60ef1bcd4e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7ce96698e71fb291fcb268525cf0d3e27a8bfdde544df0010fab8a6c2d4e3f46(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab781a6bbf66714b8f91a5c85b5d6f8b5584b31f236d5d6ba89dc98bb28ca2bc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aaec42db0a99c73904c0d2435f88dd877633341d9266030e218c1e566a7989ba(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__968acdff3415a82ee3bf4c9f034eb5181cb3205f27e44fff85cc1459e53f1926(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimension]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fd090ee6c69eec5d201bc66d386d0ac0fc0ced888e992dcf89d5931ad99949a8(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    landscape: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationLandscape, typing.Dict[builtins.str, typing.Any]]] = None,
    portrait: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationPortrait, typing.Dict[builtins.str, typing.Any]]] = None,
    square: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationSquare, typing.Dict[builtins.str, typing.Any]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__44d0be8360926bd1d8ab1d554ad82174018fdb334f22242dcf23cfc76f8d20b0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fce70e0e4aa8f52bed61785d9f979ca50e87f05fbed1c1fabdaab45937c34636(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df7c5a3d9cd6691fb5c1a2e20c299f72c64e489123de8600d2e5d32f0b67a91b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1d0a47433d038ffb969923c7f12147aa61cdf232c32f5e1a80518880a9799f41(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationLandscape],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__adb621e39e65cb3b65b0239c6ed1b91bd476e542b9482f009b2a0144873f1a8b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3884c18c10f228273f4142761dfdec5a84827dda9b0a20a4f020919ec0a4502f(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__45cc814551a36d8bdb119950deea02f2ec747a83bc408d5f20771b9b99e3bc2c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2b646f918c10c59ad00fa06e33974bf608a414a483147e7290edd7633a4cda2d(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f275b22f83b572cd1abd89101452e12f0e26b71eb12183f6c8687d2963317d7e(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__95fcd445538bf79b71023437ee5a966ac5c90ec221f821a4c525af1e4d585058(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientation]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__466d7458acc590456da3840cceaf571c44900798956cf9c2ae5fbb67eb94b4c5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3f6e8725aed59ad848ca3d97fa23461bca829d5125a8ead2e7239a3ec9528c61(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientation]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a9e6f9814f901db43838974176f672d48ebc1d48d9d0df677d2f05f780d83d56(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a71b90ade41dd38d00df15a7c2ada4d638b2a030efe25fb0c7276d676568fc9a(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationPortrait],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__446cc18742313004e6481b1642ac2ee5247b4971b09c873a67754a70391ea336(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b2042224be8fa9cc6e5e7403b6c7ba4f1b83b2fe70d9fa09ed0ab79270daaedf(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationSquare],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__37039f16b506ee029a488d68de57e73410ea8e4e04b86fa9945a027e9defee11(
    *,
    colors: typing.Optional[builtins.str] = None,
    colors_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__13743f4e80aa3093e46c0cc16bc08e0c671d7bc04f8a6862a7a4ccb5535440a2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0f6eae2f4a08d5183caa898c63c9de2c9d8cd442398fa7974966a3d277260765(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f67607b6236605b9c5fdd9970f46125e3a9056d5f4def99f12a6fc46786e516a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2cadd19d001e0197e5773984cb695114a8d2a279a77d6707d28bac4f29ed6d8e(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f7f1ceb53c714a796bf0727ca20fa05ea763ba10395119085f70d0e2c0bbbb0c(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__84017c6ff6caff8990a56700b416a7ac1a02f6e4aeb212c3aad20e2ed1bc3fb1(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanMaxColors]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__02e89e49c7d867449b3abed69c8edbf3e3ffcba0dd5ec648e6bcda1d0db5a32a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__02f51fde5938acbd02010d9aaaf86519571b2414d3369fc99f7f57118e8a4fe7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4db4fde280c251a1402e6f669373e205442306f7b3dd934486ca4ef6fa894367(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cec0994d4953852a00330aec39af0d31b4dc88e9b6b4c01e966d384606049508(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanMaxColors]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__49785963fd20826e409ff51d725be129b7274e98e72084bdef6aec34d0acb68c(
    *,
    horizontal: typing.Optional[builtins.str] = None,
    horizontal_var: typing.Optional[builtins.str] = None,
    vertical: typing.Optional[builtins.str] = None,
    vertical_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__81ade2afb007045dc4a77b698abd90e25eb8f240ca789a448ec0580e825afee6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__60beb7db3d085398287ac9e32387bdf7cc3e4f0c8262395c32ee38fea6230ee0(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__144002ff6b6ea83ace0d693bfe89d61f786d99b8b2362fbd42c2dae76b5f9b29(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3fa0550ccfdc6f39a01f298e5959f38bc851d6880141c8d1925fb867ab9729ec(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2154c1a72a83cfb8b2ac468d4ed2d774ca7be10d21b5aba3afe71ab6bc1fa043(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f822456ac9b86505cf47ba2a3c331acec3170f6b34fbd68c9d061bab898ca7b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanMirror]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fa97a6f733f5941efed6f0d79a0765387d86382c43db4ff49767b5e11a3aec31(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6420eae380805c68b04acf553a15d9590519d72ce9f9c40d7b81741d7abbff4e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3816ed20969db60b995130b5936c6ae95463cff9d4027bbc0a5f55901fc2f636(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6c903dc0655d3b5413f289a794707bb222c5a60fa8a69cfbf6114232da54fb51(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e66202f6ed2d1aa24ba91b4837716d012a09d2b887a1a860dd040df8da0113be(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__87c7ef1f21a9d41d7367785ff9a954022fb1614a01982d3153f4bf2421c9dc60(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanMirror]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df4677ae8b5bf7186569ab20c00d789baec71e9ab37d3dc75537afab8bbaef6a(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__53bf46bbe3dd2435c2b9da605428dfeb9b43ae4eb69c495ea0c324195b8ca1a8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ec21f6e86283c586b981bebdd3a705e0018066219d55f0c14b8cddf7f8da1eb3(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__29184365e481eb38c52fabff26560c67e30a2e7d5db7c29d9168173ee1184c60(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__69b689c735b4ff0760878a1909b40b0c5b2adfdf7066428c7b815fc96ddff6b3(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__337c94b5d13ac1fa6aeba67dc37675224f4ee9190397bed11a74e25e33c739c8(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8b73aa21a61a20edf452514518ac33d613b4eb179eb4b023dfd1a19b1957e396(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanMonoHue]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__143ca7237901c08ea69f29c3a5073e1419996eaed6dafdb3c09f0c374ad871a3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5d1e117313f7d132b0742936ec23a67c58f50993c26eabd9143ae949a763c524(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e88b9e3e301608e88c62481caefdda87e96fa982b49aa4be6ac93a28092af0fb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e7024d72c22ad938bd48c76567fbd8ded85a43be7e616be8c13ed1b51d2d07c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanMonoHue]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6a55cee7dbcbdffd588b9f892901448452466d493ae36daa82c82a5855fce21d(
    *,
    opacity: typing.Optional[builtins.str] = None,
    opacity_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b7947accb36f935098982d4e901328184a274a5135ac505b0690be0cd1440cc4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3124cc30f0bb646f313014766378f7873ea38c86565928dd139c7eb010b3a82b(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8f057ed77bcb78e2699ac84268c82a8b01b8e4f18c3c9a3bfa4695a13aeaebbd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__189da537e5f3cdba40f5d996b7a3c3717e262ca71d8f3de8e60882c740db95a4(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__376c27bb3df64b11f02b950fd7d41d804f80fa75338e43e2278aa9d05caa9240(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__edc64eaefbb625a2f0852ab280af74dde992b320b474240ae9bd6cbd710f340e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanOpacity]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e6fb06c7386acfebea83f2092a7b740c67828cb3fd6eed5a2ee1112579c6000(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8e2ff4022f5dda2405c0ab9279ac03f0bea4457f84c0e9a1b99db65ab9e490ab(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8f2345f0e95dde31110e9708c62332a3a7b1d120360218fb5c446f421f5fd307(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__62adf70b98ddcedabe0be6126b610c076b1427cd7277a86337ea8d77f527bb19(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanOpacity]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__10787bcce3775be961cff49583a620f35909275a6cc4f27f2c78f54753eaa07d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d2d59d6170f05f37121ec0934b77f41c23bda6df8bd99834d697d415b016249f(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__53db6e5f3abce0885fec361cd86a0a4214f18740c74b5e5823b160222d3a51df(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanBlur, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c5e451bcd21fa8bfde1ebe7c4b50d2272ceed85fb92c6885f2dd9de53de268dc(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanChromaKey, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7411a46bf52dc16777cd4d7dc794649d4a704860fca834f7398f4b9c25204859(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanComposite, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__78a1ae2b07ac4b6a74579674079cdc1f200f1afbbf33deba79fa6f1acda8277b(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanCompound, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d3f518259d18f110e6c2047e879c1407bd2317609364b12ddb99cb0f289f0901(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanContrast, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c87ed5ad3149826f0220912e9660650045f5b46a41b765dddfce215658d048de(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanGoop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc387804aad7cf0dc285e2ce2d4309a338e95fba1352d0ca420dfab2ba983c76(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanGrayscale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b84f0d339f60b54f8f49a5c13b09ba44be460db96e6d51a965a4c59cc4d51662(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanHsl, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__48d6d3b504349cc2331fb9532b96ec64220af8aceb3d14db99ad39d6026e4767(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanHsv, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b168afcb7eeee6fcac846abbe30e7e129193b39a59db325e49db54fb1b5be36f(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimension, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e4032dc9aa3b6023b5fdc1ade84723de1cd7df01032a83f4ba685753b4fbe416(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3fc165b32be09a1b5caee8b296b07b4427402ab4883cddd0696e6cf14ab02e76(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanMaxColors, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1ef2f7cea7358c9fd02bd6cf7796ae19dcf518d67f9f25b6cc6268fffeb79901(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanMirror, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ca9ee5b1fbb923ea802a2446a43ec9689d99c5f510f41ba755bd84959abd736a(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanMonoHue, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8adf985cc6fda4f52227b25a4296bbd044c25d695ba09dba63ca0f7a6ce8fdd0(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanOpacity, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4fb0830fbd72c889f51cd493dcbe465a55f71cd43dbea767ea9cd632c3acbf8c(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanRemoveColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e4ff3de85cd86df7f29b2866ce385f5520dc94a7b128b061f24bf0e9f78b1391(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanUnsharpMask, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__322fe2291dd519667e8d64d7f659e32acad6e59aaec26e84da85761023b0621e(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c5edb6c34c4a284d26dbb23c28f0f9d5db1f70363b279edd25e94e817094cc39(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
    feather: typing.Optional[builtins.str] = None,
    feather_var: typing.Optional[builtins.str] = None,
    tolerance: typing.Optional[builtins.str] = None,
    tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dd89218fca2ac13d965cff4f991b3e2796aa6d2aba0781a15cf98be6c4699538(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f96b61fa1e16ffb860756ba262c9c41cd472710d0a8c67fde75b0c93b3761cba(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5eab7c090d9f2eb7568a0373a752a8ab313f1d040b7d85cf1bee4a8cc4062672(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__79999960d4fc8f322a76a1df5522891ce15e656695f3fc411502d6f7adfee2ac(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fe2bc0ee46bc37862c015ef0a176de6dcadc8b485d3ebed0a29b9ba44d33f9e0(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__41cfda7325037a33c570fca0814d49de112b9b4dc92d32440ab25fb1452a0b8f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanRemoveColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bf317cd9e96d30dcbbbf9cce121c6e56ea3f956d7bd6d84d51249de830fad017(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8212c23080f741ac693538c15fa3b3ef3c61e774a685fb6395844f02c56dbe03(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e3ac4ee6192ece59eeeeb15e724c9dcc484556bb8905f2dff1babfaf0d562cc6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9062d0dfd5e1fe744ea82213dc33c294f5a0d12548930ccc56b9cf202f0cb1f1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a1074166d84b337fcbe245580481395b19cd7dca62d639ede28b9d1130e0de9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a17c3f6ba0d06390d0e67589319a5615a8bb5c6a7ef7a8729585a3f0c50ee96(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4f41ca9c56d3ae2d845a4c0a9abce6a45a67acc6367fce858fbace50b7846bc9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ff7ce1a41ddd3622994872aefbf91eace0fdaebd15364cfa952ed617aca61fb(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanRemoveColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__87ab5b5b3ad88b9f8e021152df6e8f7d5aa4ab7a68b19ffda47d57733483cd4f(
    *,
    gain: typing.Optional[builtins.str] = None,
    gain_var: typing.Optional[builtins.str] = None,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
    threshold: typing.Optional[builtins.str] = None,
    threshold_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__76781b9d0e16eee818facc181ce5b7943e94b670af70bba93ce1ea93738ae7c3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__83a61337d36b3d2b491fd41de8db34b4125799c3209add84fc21c7a45db77589(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d80d505a0ee5482111b80e6a0dd43cb35564d48f0460bb6b6b927513dd122742(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__11488edd635dbba30cc57af7bce9be700fdeb4192936d620d54082d7d888f8d3(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__15d1c58d028d709f48d770f6515990a1c479a6eb4c1977bdf89ec622f3c04a36(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a0b751ab5a0ca05506c59c99c2152aaa7d4f1fb5bd69f30f2f85aa27bc76215e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanUnsharpMask]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1a35234cbd548b253d79d6c1db6490c784fad2a74ced77dfccfba4db80913b1a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f7d166c5d5485dd4f978093583c792615c2988ee1f907b8816e9bf389d4a24a8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__15d925e539ad0292cb27d4a135ab74f47c9920cc6de86620a32f107dbba98ff2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__22ea21e9866c0c9c42c1676d699e5156da109829fa4a070713a2d1174ee1f50c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e3131a3bcb92d2a1d59fdb27777466b0981569f2fc119d5dc6e909601d6ed44e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ef78b0996904906cb574057e594f632e95533e3de5fcb5eefffcf07952429077(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6316a49c9b4cbb992fcc61505961a8bffcbc17e8c8df616957af9101c2571dbd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5b9a0bb5b92215697415abd19dd39fa122d3658900278fbcc25e247a27497cbd(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanUnsharpMask]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f164c6abea37353234d6dcf634a24392fefa933c4a543537aedac7b23de1e9fb(
    *,
    background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
    chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
    composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
    compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
    contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
    goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
    max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
    opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
    remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d37d3662c1f64e266cd702bb42988837b5ec456c01e1eee849b230de2b4e79d(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__58fef943497ed434de81d36bab160096808473fd129a5f9deef1e3c373bca003(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dc5cf4c778b5d63d81c403e053ee211f1a50dab45a13f6d26791adf3648f8c30(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a18769162ae2be277eb8a37dea2f9782b75846b116eea83d3ab91579b80e96b2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__37cd1f6a2a1da71a3b6b069862d164be8feb733e5d88f3f19d181fb7a1525438(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a004323bc525c8ec59290536d01775f070282ae7465d64eb2b7f4955b9633aeb(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b9afc0165e394d3f3fb66bb9b9dd7032060144ce18c3c7cd03a220e2bde7b83f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanBackgroundColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd08a11c15cb15366edcbc508632f6cf5b62ccc3e539ae447ec69e51002a20af(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__82bbb55711bde28ec8b17e93b15fb3fee482b3fe2509ef262cdefe41f2f48379(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b792f6b5457e1021710224f21b22daa7440173f7e303a221af28fd82d42ea79b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c8e4671f5e39b2c2735221a8a0e6668fef6c8e94a36baf5de90f0a0c8884763e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanBackgroundColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cb330e85dc6d8fde9d2979c24e2179de0cc348a3c8c688c082dc30e11f4be65b(
    *,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a17bb1572a0f5b6b1385955c0ee542b5efe20710b41036593eb6a88bc204e7bf(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__84a055d94781465987100f5ee2e9778cefbf795c3871dcccb361cab805b55ec5(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7e32cfb84fd0781e793754f1e2be14d280894121f27964ea5d34b4bb71e6b46c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__12089b16155c6544948829f462e70d5a1a9067aeff8153952afaee94160b01db(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__956f34bea2ddfc66de7a5af7e422f3e35ef4193b4c3fa31ddffc23a89fa9cb33(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0c8adc0a4ac141bc5b042941fd828cbee5c14d6f71408df67e5c600f947ae1f2(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanBlur]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2acfe89de6baee55035ab5edd538399ac8fbe290ff3ea4e40dd01bce26dc72fb(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d5778a660c6e2c0b4e93f86d5cc5a2e6a2f8a38dbb1cae34e6723684be6a052d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4336c990ef0a700465b06ebd187f1abab54afa366df9dd637aae99140be4956f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__106f508920d119c9436420444f02059cf6d2a67657311b37fc197ecdd61083a4(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanBlur]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__985458d56db4ea60fb367229aba3b859f6b6a2cfda8ac725d302c2a2599bde8c(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_feather: typing.Optional[builtins.str] = None,
    hue_feather_var: typing.Optional[builtins.str] = None,
    hue_tolerance: typing.Optional[builtins.str] = None,
    hue_tolerance_var: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness_feather: typing.Optional[builtins.str] = None,
    lightness_feather_var: typing.Optional[builtins.str] = None,
    lightness_tolerance: typing.Optional[builtins.str] = None,
    lightness_tolerance_var: typing.Optional[builtins.str] = None,
    saturation_feather: typing.Optional[builtins.str] = None,
    saturation_feather_var: typing.Optional[builtins.str] = None,
    saturation_tolerance: typing.Optional[builtins.str] = None,
    saturation_tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d73961a7e03e43a30d594625e8983a33ce676547b6ddc3be1657cd645950a6cb(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__587e8179498d4d996fab8dbf564921e74c3ca48e0fd68097121102f9411036ec(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__de7cd02c1c1093b896fe0a08ac4528a704435b87908b7340d890fb3acb47e03f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0dc28de9c9be6a49d1ce8c634446b54c8e2f66014be270ff945afc558bb46ee9(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4874f02c4fd2bd30c9c1f7294513969309658038a71aaf044266f7c24b91b9b1(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__57490e96588b2d8dec109a8307c6062a78ba7d15c89ef394ac56bc96a1bccf3d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanChromaKey]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__850c01902a3ca7a6699e9dce2eae21319892db8eeeb5af1f8d54df3ae7a943d8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e38772f0275dbfb4ae27b0256794dc6418f763444f6a70030647efd3d61b0a2d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__30b978ad6c57bee79a473e25b49d6e22a55118b8370be644b5033414ecabd004(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f1f3af61d904c7cc3176af46640065d7a1dfe0827234bc2a3988f06933b7110d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__de0c02769aafdd076ade1e4cb9febc636c544a9d63049189aff12918bec15f01(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cec0430f80a07993b4bc9245a67d239d50126e131b1eea043151ea1a405a8aa4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__656a7d47b8b13948c46d2faeca3ef3e23ef81f08917cf57bc4131c1542db257b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__da6ff6d59d2dba8793f727b04f0645e0261f38a6f8646b7e6b27bee5d1d5e99c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fbbbcde42de5b8bc7b755eb884814ae880b0829eeff339eee78bc23fb337e283(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__832ae0f0c44c0b3f23bfcafca4ad6050fb1cd38e9099553c0098af87e7ed47b5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ee90fad8f5f3431c0dfd9769c53b067311eaf8bbcaad328ac0b4ca9de4cca365(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ff772435892516ba6711cbaa84d09528c49ce159eff1c6c267fe59a0ab10e6db(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3222253189180f0d6ee2703d68381f54744b73d67cdd39674a9547b2eb703ae4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8e6ca17e70cdb316bc96c9b7b04ceaa065e5362d9abfad32f9ad192ae3571572(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__61b67f56d78099c81238d7aa1c1f51c79240db2f3dc08bb26f4b58705aa7b285(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e4ba01343128830387b29f9a8a7d879ccd6680e8a22708bc0248f76168f9716e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanChromaKey]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__49038a48b6c532c6f55802b37c8cb19e37a669363127224315495b6d75f4c767(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanCompositeImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    placement: typing.Optional[builtins.str] = None,
    placement_var: typing.Optional[builtins.str] = None,
    scale: typing.Optional[builtins.str] = None,
    scale_dimension: typing.Optional[builtins.str] = None,
    scale_dimension_var: typing.Optional[builtins.str] = None,
    scale_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__12d0f636d0bb0e86029342e8a4350e21cd15a40651f3a4c22d4f980afd159cce(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dc22f1c678b07e543cc5a2c0a43563f7c6aced71bf193c001d5297553189b36e(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanCompositeImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d40304f44ee010d0e4581c8b89564d5557952bd88c266d8b5c8597bc5badb84a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f3b371c4554d5412ec434a1efe90c696311c20704c769cb710e02ee2835ebaa(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cb1c56d3c71aa445b173ae56e38a3f948f145f3d3b91fbeda64c356150041d57(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dea95f3642a58ce3030403484d45d5150031b06d135df777140e9f438eec874a(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1dbd6e628da1b09df325625caf871231c0310f4d7a8bb441d9c683f351646079(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dd936b018003fd647c5b60f8977863f4999bbd43317c0252e590aee4c953ce7b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanComposite]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__99501ba257aebf6e9a0b4a7218b2b8314e2c87fea4f58305e97784da75630180(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac50dabb49c9e09af853c706836e135ba36408c3a89c96315ec57fe9f0abd60a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__74ff186708e1723fcf38305e035994548e740f011034e9102f3c0bea0b92fea3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6ff4d0ba5381e8e1cc21237ccd25130b98ac56707b98c0cdaf6c7eb7e12c4e4a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__11126d2377a572794a2a63e7ac557ca01e42d09823c51fa6d19e6c7481575b1b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2827b7bba76424b913d402743874d5c2616db55826cbccc647a52e68fbf3865f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2f665e1462efa21ea8d746bd94b5e98579f9bbf96f4ba3fd2e2de3df056bf938(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a5333d18122257e8c6d791ce0c88be820d340eccc75765a282cbfeee0677001(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__900ea66dd233fdeb6a480b928aacf7cd9e20ba92b5a0c4fea8ef73781c75e804(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f2d0130c94d00326892a0eab5e2f5204b2e9c84003e2c04cccebd735e372fb88(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a56bac8efd0c34c4be86af9cf7db9ad055cd3a6ebdb60bed60fb0d3cd910910(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__edd33ded2f4942777827f9032c3a073d6abe65747413bf5df5ac902b0bc11474(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4750699115940b2bdc09051ea2bfac5308d7b35a0551eec2b90161e127e4a563(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6a676488c6e863047348983d67c5b3a39e39e284ea894f3cc1102d6823baf221(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanComposite]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__504284d5d223f09d4f3dfce17f42a4dd828d3537165611bead69986dd7fb7d52(
    *,
    transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__910e9395bf84828a94b13b3a8e6d86ae7e07983406d024436032b740dc289efc(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be6a7b7526d21a8414a1850ba4679fffddf87e371647f7f4ecdc2f55687cb6cf(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c88217a0669d83accb8caeec217298acda85a748db9f10d854572bbfa089c35b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c5c3b9ffc38aecb4bb9b7c367a8a8005ce06bc49563359875002963953b29785(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f6e43820f2553ed1f831f7b3ca99db58f813c1af9f284bdd5ee8ec3b49b4a50(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fc25be84b24ea1668dd24407ee2fc3a6619de6b827625d880627da420d63c851(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanCompound]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e8e2d070e5b0edba1e73d2b1bdef40d09bdddf20a49e5abf67b64cf8c9be6fb5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__156646efd718f9f208c59c57a0d5447270033bc33c8ed85557a9ca7b47a46ecc(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9fbc1e80372af8cf81e21a084cc68f1d5403e86555d377838078ae46824cf5b2(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanCompound]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f2747cd7c2f0a974982bdafbaf74fd46977431c4af9bbf12387242faeb13153c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5412b739b583a74d76f2e87d7a168e1e55529b6f336cf7064d7bf9a5b83e411c(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e75c09c6b56e7b7977e6144a9f29a042dd3eb568e5e9a0b406caebb105a1e00a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__41e3b0017266891e01a7d9463d0c3819e66e49f421764e34f42ac6a8af0e59a0(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f5b32b54aa7824f7d7c004728e72443d3729202a959f748f06ece58f133a4e92(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__18ceb9f711ccfb94d3fcbd667d5fc415b2232d7ec1ad3e35c38c2f984cf0848c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanCompoundTransformations]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__45918a71c0988dd2b25e1617d008d74fa2aa6ed6c11ba1a45ab2ea85bea9f357(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c79c7f5d4eb533edf1c933de487345eedb0dc8d27d82a36b6598609abbb3240c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanCompoundTransformations]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6448e2e0510bf6054e99489fe94d58a1cd14fe9da5f1bb23ec10fc59dc0127d6(
    *,
    brightness: typing.Optional[builtins.str] = None,
    brightness_var: typing.Optional[builtins.str] = None,
    contrast: typing.Optional[builtins.str] = None,
    contrast_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9dc7b0b9e85988a8e479c2df604d019c17a4cda0f3ff443ee518bc89ddbb6b2e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__04dd13c639ea37b90ebd290080b065fedbd25cedc6e29e93c7ca2c85642f3f99(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ee7e3f16330a8a7d42e4bc9de9e4bc817b4651503238ef832dd83112e76ba4a3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1bd50943751f9d7ed1d08c556a2df05239b8b7ce52b1267d71f6e5053198201d(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0d4fc9b7beccb520d74b87cb78c5c60b788ccef22a844ac9f1a82f94ff31b7c0(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d0541f5f71bcd5c88da65639029ad6ff252e041974db4312dc8f6afcb058b844(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanContrast]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b2269f469ccc271058d5c971ce055f535251c0c81df8a257a96891ae966a75e6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d6b3e675755b00e59e23f00dc281a3fc8df1c56dbad2febc40dff85a77ab6727(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__276fecf4033c65b5d388dd29b14693c016f1433ece96d7828e5166713e1061e7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__813cb08ce5c0f56e16c6539abfe50ca5098ce6c7b85b95eae16f02eb1a8ecfff(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a7249670ea8453a6d56a6b9b71af15bc24714983715f6f28ff3b7a6f5204a94f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be330e9b8c93ec8389183c3a70dcae29195fefa997a68a368a07f65c29d77211(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanContrast]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2dfbb9d16aca8078ae6d9389ee9e1bc8a2fbe1ed9819a35c47cff097e85caaf9(
    *,
    chaos: typing.Optional[builtins.str] = None,
    chaos_var: typing.Optional[builtins.str] = None,
    density: typing.Optional[builtins.str] = None,
    density_var: typing.Optional[builtins.str] = None,
    power: typing.Optional[builtins.str] = None,
    power_var: typing.Optional[builtins.str] = None,
    seed: typing.Optional[builtins.str] = None,
    seed_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9497033ed16705a3374701aff8bf05ef934703dfad9b46d198a903da9d09f61f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__58e77bb444b9cddf5c5254fe6cdab8bb4099e9ab843bb14e3430d8cb109623bf(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2acf0b4267727ac7fde37d41a9ee9e2cbc6f715322642d5624ab766c56ff8652(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a53289e7282f6bff1be9cbf64b949365e8628178243f0b2eb0f604cd2a0f210e(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d84776da0f59279b5209fbdeab299f476cf005dea3742b299a7cb10c1b47d12d(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__98254a267a679ed2f44d80b8f52fb1866e0832824651a84c102a9d1f5c8ee4df(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanGoop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c5f1c34a96a68a063f721dc571d0fdfcc9c6ff5dac42eccd84d91d6f1516e02e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5d9ea30d1c49c3ccfcfe20ce324fdfd6e73823122deb9a0cd7c5e7da7f93c7df(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__06a5466e618de3f8265bdc9a9b8ffdaca9c36d40b4417b18511ccfe50f3e57e6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a25a2d7f3a8dc621fd2d76d9e6280f470868ea7fe9f198f74890b7e4ef9a9bd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f06abde92e5369d82dc282ce118fc41db62969df286984a7b9bd8ca6923b56a9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fc8b73f54e60d4d1e850a96113063e1a4cfe428a99353fc2fbef8060d6d3a940(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3070121e53d09d5d72f358c0f7f059f7563fb77a8201b0209fadd1514fcd720e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4c1db0984e65d503f0b6d217ec64302de373bfa90f013e28769d7b0fd5f007dc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d76828a43da03985d33b735318192d53bae5b7ae7ba891aab7d74636abc09ca(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ac6bc31fd70894e96fb42832a3e5d3f7894b128f8f9654a12b2c9118b6aefb8(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanGoop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1e2e872165a2590918168d5a376c81c2e25aab6b9b4031a3c00b01234929b410(
    *,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__daf9101ec2efcf02c04a1798077549f6efb915dcd7582bd7511c0b008f5e3e3d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cee0785450348be2c905a41024da3d4300c8b9664364e66dfa4cd2f9ce6dc5b6(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a53cc703da1045f4b98e758a8bcb3273051f4339fa2b95e54017a9e22ceabc23(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f2aa389d08962bc75a91c73edc8e91a1abf332a2519a16b505439d107a6bbe82(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f644d412571dea986010ecade98ea0609f386d2ba1c5cd2837387685d09d4b4a(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9627b7e5aad29cd5bf75581a198e687868603a088a20285de32fd3b00e5721e9(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanGrayscale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6b17842e668651f07e779cd39e7ada2a4b65e524fb01a76527181ad764a2303b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__997c906fbfdceafdc6e4c8031727e19132e33d34378869bfcdff5aea706d602d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c5a8ca2e45621138fdeaeb84f98b175be627ca2a7a345e723e69e58acf5cea07(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fbfe2b241987c0182a36452cacd50d81f3c11e48df347ae4282c4a3c76e1aeba(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanGrayscale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4bd8d1e19e4bd830eb9dcffd1efc7c54bc0c30914ca496c1ee4f9f618d25cbbd(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness: typing.Optional[builtins.str] = None,
    lightness_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__37087ff527ad21e048f84efc035e527ce43bc7c8a7fc0e08e8eeb7f121d95170(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__387f5e7d4518fb37cc62e78c8c72cc9e54454b6ee4e3b0484e5f2617f4853611(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4156331d118c98d97bdbe743e0d4c4690341ff260be9ef74661970e3e2b8c230(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2f6bea5220db4e0b81604a54a7014b86d2e13153386196c4d81b1977da6f4c78(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__21517c36ae0f121f7df5bd9cfe3a2b5f7a21996733d98d77d1124b559014ff43(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8975d79215bfd0a16aaee4fd7243c165874f661ff9c1adde3bcaf7db5fdbc45f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanHsl]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__60c4738b2e663681e61f137b88728793102a04a1026d0d1d69103a47a71f98f5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__38d33d55c2d24abd61f5277a98106497644977cd067b381e2528795c76e33ae4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__12fd1ebe111a8512c12360c8f586142589504cb8ba78d942adcbf6af18ee4d0c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e69991a1da82cbe24d17987ac816bb2a4a08c15cd5d6ae064f55ead68ce4f232(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4f3b774d192acc795e82998b2ce897f45100b540909855c459680fb92ae210f6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8428b5c26b5c6451029848cf9dbfd5dd7991dc971310a78f7847c9861c886121(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac46ecb195a63d7d7d77e930f50e27ab0a1605cd0cf94761b9a5fee18c366ee0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__196801816fd03d0c04450949b7c8ef2213edee99543440020a106c77961310d9(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanHsl]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3d1abfedc444e44fcd3800557ac948386a470d55cca29689f7a90cea80ace0bd(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__72e32e7fb40e376ef7191682fa1bb4f111b593fabbbfd142b8f4842a50118cb3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__392487253cafd5911486019b4dc3b57a81b286bad3aa5d4a7a1d9a2059030b5e(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7dd3e59c71dc539a208f79ad6c841fb0d1465dff3cbea49f727b9137283bf9c0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8579366a88271425ebb356765a0037456f98f91b784565bf884b7805b1105f73(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__96f9b4191da5770b588c496c1b548e6151deac57a2e55f6e85529f70a4f5ddc7(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6c2a71565eda9005211a9f6344ce34b1867efb9a70221483c6bcd1746d752757(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanHsv]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__37ff8cd5ae66e76611f0896dc709a412336f1896892843a2c6ee9715866be148(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e1437e74244d76afccfb42aa2c98338813fff12cd0ef3131b719b124890567f9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__192f61066d6c87b79b797c6e0d23d3dee624c076ef062c1501a62696d0bd24bb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a7ad5fb088cab6c658e3bd21ef1108f8bbf6f177213c71aaf8fbe4a86ebf6c74(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__20b9f6ca036227c487c65c2a7bbe5e202eb6a46e052c95bd2073555ca15fcc6e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5e617048947243a0deaeb0f2c64dcb4e8d5eac909e6f74cefc4167a4c74a6c81(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a3ebbc20def926d7d8929f60f3833efe7c0f886bbb06551053809bdb6a98e727(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__935b657c169aa3d722de7ffc4c56fa804037086fbb1068b99a0b8efb931a968c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanHsv]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__39abfb502f935d640f90e8c5b870d446b6e874ce18703ff17f21514381888d31(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    dimension: typing.Optional[builtins.str] = None,
    dimension_var: typing.Optional[builtins.str] = None,
    equal: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionEqual, typing.Dict[builtins.str, typing.Any]]] = None,
    greater_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionGreaterThan, typing.Dict[builtins.str, typing.Any]]] = None,
    less_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionLessThan, typing.Dict[builtins.str, typing.Any]]] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e68b7788b6cb8c44cb976778ca04801cbf3cb9b298097a2dda1e6a714b6f6299(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5af023c659abdc0cb351372dea1d5c05d6ee8425d0a047471ff55963aef0da78(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f3e3d2e355df6456af2edce24f90a3c431f19ded8347e605d0e4c3a48a473f3f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__92747d52c0be949c513b5c3a75145fd621516602158b918d86b02c05ce6af77c(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionEqual],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c416a4d3a6f2365f14e2cf184aaee67e7cfaa3b6cf157cb4382760f453df91d2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9711d121920917cedc1f46773c4eece557fb8b18491b3bf1fe096d350315a9c0(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionGreaterThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__54932db3b855bab3566a13663a6e51b72efee124cdbe45a930b925656445805a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6a0edf2fd070a6f27d51a7c660f36b098e1b665b5c2d9695f2a436aea888094b(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionLessThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__360f38562d298925f35af80267e31e3a5033b304e015f35ab05a822235c758bd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__300a21aade30da0b343aa87a4348e4beb6b5bba3e3f7845e8d29862b564e9998(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e99057565ab705ec7cc371c0cac3997f983fe866bbe2d9954dafe1e97273d837(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2eb34e227c89fe5c6c026a69dbcdf7391d4d6a07dcf2dfb1f9e06b2d05bcdefb(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__58d3bd72e29ce632bc6b80064c94be57f9e196bd34c652e519acf0d3f17725a3(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a2bae3c91ba70503dff4dfac088ed1b40137f898a36b0de6d935824a5d6a6de3(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfDimension]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5fddddbd836a86516aa92e0fc4b0771f64eb25669b6adfce8b5e738b7c179739(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c8472c80bdeb83101e85a5fd3bd9b9111a7c091aff3d51983f03b050b3aa3ae9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4dad7737cca9faf3c272348c0ea1d33b57927429d80c5220ea8cb1497eeac39d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__606524b9c49d48c339c20f48e5a7f2b4906ac353e6343ec57466bc2df7b17929(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__de9e4359850819b2c0415bdc974c74b109470f7a33e38778acc44f7dda5cf74b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3948acf0a0f0b49e75971787778af9442b43353bd363e8c8c952eb77b45b61b0(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfDimension]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ffa7565b021b47364e915d482025352a3ee8462a64adec03197bb7202e823c7(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    landscape: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationLandscape, typing.Dict[builtins.str, typing.Any]]] = None,
    portrait: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationPortrait, typing.Dict[builtins.str, typing.Any]]] = None,
    square: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationSquare, typing.Dict[builtins.str, typing.Any]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8c545a9662f8913d53668ad879b4f61c67f44815abda8104d6ac5f489ee85960(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0051466a71ee429731966742bc6592cd59cb1be1ec567f3e4ed75830b1f5fe0c(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7436b3a0cd4de5d0b068cc7bc08a53c6b146879f517c46c4a3c1765939171712(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d460a4718b5964bcb2cdcdc3e8bf2394d4cc45b038afdc8bfcce78e00a017596(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationLandscape],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__36d64dd2473d9ac3dc87fc5e7a29a2abb3981031e5eab33634cb7b15b8a30154(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5c0d298a7648418a5f35a69d55c2fba0e78d0179631d6bfbe18bfbe8913a7802(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6ed7ad3d9c074aba57631b79844c719990289ac77882c4953b4ee8e73ba2c86b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8ededf31dddb7acfaaed03711c7f3f1e4321e112cf14a6ead748711a98ecc410(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ff51015f297d6ffd0251533da91b822c5f1006c1b2d68d046dad2655b8f89b39(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__07aa8d50e873ce53c99241c7bfe0fbb7e00841d96c838048502f674233bc022b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientation]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0eb02a2314014b859c519a537bce989fea386dd8c054e5dac6cff6823f705901(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f0643323a86b9a42f16426eb236fd134f537a0c40ab0f2610cd8a68536fab28a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientation]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4f5da75ccc1a7abe176c63f1a6bb2f86f33c00514de19b6e82c46c4fdebc5f95(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e5bb40f182e458b25fe6ef95727ec7ebc3177f09dc12b0a0154d3f5989753cda(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationPortrait],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__88ff18d13b24aa3326e80b2c3fc15d1f3377878cc987d7354b8d74caf4516274(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bcc1716f1647b8b80a77bfdbd50ec9145eb5eaad18d1a62000e61bba012597fb(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientationSquare],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a50129bf4d301f3fb8824a2f64e9ca79ff22a738eecad1c31efc0c8048058152(
    *,
    colors: typing.Optional[builtins.str] = None,
    colors_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aa3f9808d6ee94f6c6b1d13aca3ce56e1d874c9513480de4e42eeebca9f629b9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a7c91236a8e8251e5e020e95afb919603870c736beb3fc2a33c1faa988f92242(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2f931e3ade9d454a953ed4721b3b29f6dc98ee636a8da1e629d9229ad591c189(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__68eb0e409d1260cd9583f8ae410682b19960aec1dbc588d44ba2cb7a264936b5(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aa71d0c8101611ec2bc1f2b3b72c560ecafdebb686ebb4d852f5241397ef6674(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__18163a057059af574fd31c8f0ce6688c20279eaf5e69e60668d9f04b5578f592(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanMaxColors]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__40e9af155f21206f936ed343868dfb6f33b58ee7a5f388b71ce82a1ffe7dd024(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a3809985f81db3fff80c22e387548e4d167c6d7b58d9afda724e8abb5f1e54bd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dcccbb07e9be806654397855918937d050c7b774fa6b4c0f02547b3fc2f47a2f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d1a75a2034a34006fe88ee1649c7f1e0cf37d505555320c001aea927837be4fd(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanMaxColors]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c1983cfc44ed2f2c67ba7e55f623b5727f2a5e71c8e79e313944597e76f2e520(
    *,
    horizontal: typing.Optional[builtins.str] = None,
    horizontal_var: typing.Optional[builtins.str] = None,
    vertical: typing.Optional[builtins.str] = None,
    vertical_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e28ced0f9fee5b2cef9967771d805285244313bd20773a0f26d0de48cd369b71(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__519e58bc6a05314ac29ffe49689c5bd673ba2c01cb5281485c788632c0cc2d49(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ddc6b7d785bdf4ce99d25adf6d96d6f24a03248424e30c64e40475569c991fe(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aecd9a5313aca5b12a06718adc687a22e20a5c8e4fe5c0e10c374314719423e2(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__61611b9a50a1058f37e56a3b86ab1fa6cb92786dfa226ba30c3a51475994c429(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6329b9a2b7cc50acfd7d018eed588782a60146ef2baaad57f121a86206862b3d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanMirror]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3473afc63401ea07cf04d3caae5b4298c0e7f7a6234b224ccc4b5f2ceb5529f5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__38cc5f206e216b0f1e3a2b671a51fb1f861074f6925d385cd2b27db78dc950d1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__db3ec77d6c257863ab24e13129cc015b106db775fbe7da0d50e72289c2c27683(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d4840b23f37003f830d6ca32803af1cb5a7a08869b336f658c372a93c0b28407(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__57db5fb0c551cbcc3f035c2f1347d9cc938e3306b93b082cc55e867111639992(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3f54058a32a209f3f08b03d12b726683fd3b2d1ce154a805f4e8aad46e74fba7(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanMirror]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__51f59ec6e2eb594a5e6c5a3b6aec3c75b8a5a49223fe894d24a054bf2a0778fe(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7712ccd23a55ef728ce302d78a0c4716d26479d493c7e1ec33fe7a8cac6b14fc(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9c80e88500ec394a07433e0258833c77fc9899a39a3d1fab28c85456838751dc(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b8399f9425e04ececc0f0b2a8b56029cf57ed66ee10b92f46f290fda764c676c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5e145e2941e51ff3ec887ee84e32beb683ed8fbc344feee5fcb0bb1f3e79dfea(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e435a0871c7dff81a7510c76f0091f7cee2fe99462925986e8d910b6cce2b43(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4444cedcc2a81dde69c4a27c5bbd36889011e5f0b091f91bbae06b278f381b13(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanMonoHue]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f6840585bb1b56687d42c2fcffca9c81494fb605836d7ebcb08e02a3135b3e8b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6a8088a9c7213aff3bc8b598fcd74db3d37740655bb2cb8bd11973ad5c8cf603(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__58faf0055c1f52c89e1ce9880996cbb8a0c2bc83de44f051b9926a59696f0308(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4b729b5e6836dc3c2e146c7ca1914afd892f88d26316873d62eb505dadc841ca(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanMonoHue]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__535d2e96048596930da3b8fab59405fb7bea939e1402c5ad9041157194121511(
    *,
    opacity: typing.Optional[builtins.str] = None,
    opacity_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bf773ba00f0684fed1ddd685921270347505ac59d54698e215b746790c97f894(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2fe84602208ad6aa6b7ce8b7bacd6c7415d7ef2660016cd20488de6e2aee68e4(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c5fe2335e09e99c362143684ec62a40f54db0753a176ed3fa81c90d88013ea59(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fccaf9f55d0683ae0b4da522146d8056869dc7255cf9e526577106099147b674(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__75e08719f418c7869cfd935b11f08e96943ec4659fff7b59fbf90811c3767a1d(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__639c775fd1c4dca826d57eb4faab58d9e6dc1f0966e0c7458676d477544935d3(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanOpacity]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__694fcffeac55853204870806bff780d6c262691197291a54dab1aee8eaf73d9c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a12f6e7d3bf11f023bed4d56cea853556a873a3534b3e78b83a4c31b74c89471(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__096b8444c674623e18707c5e75bcdddef606e6aba74f5ec167bfc22906d470ef(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e9a74e375d18094d389fe442d605a84b087c41add383a9fb837b3d7b7d8fe43c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanOpacity]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__504597e6aeefd9d5217d633bcb32685a037e29d7aad52f656cc48b499cb2d122(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__746c4fdee515f644babd6127c7f79da1252eb64c9e3e6b3ad0bd6cf24fd16102(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9b67489e63c8b120f7a96c20d18715b93be92c19acc2e77484a0dfa2698a042a(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanBlur, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a6f282c36222b33b83a604d0192a091194f9711ff0048c08f84a401d63c505af(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanChromaKey, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f455573f84fd2016014c5cc7483c309ed12c5f8ec3c204f3adaa1201f8eddbea(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanComposite, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e61bc4b541f1e61db7d051aff99621c98983b18893f4e031d1ff3f3a3e37c980(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanCompound, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8befae50bd246d5027ce701d0620b505c8dfc32145b886586a1a26f45056714e(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanContrast, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9c0ec5ffbbd1ff160142eab0e17f56acb166a429024702e2c450cff1c9a5c63b(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanGoop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__701b94e14b29d90667e2de4567e0b6f440f6bfab41a175d5377791358912765c(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanGrayscale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__457ecacd36439140d5a97106a88c4707aa5eb5f9d1b8a447cfe8e34d3576916d(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanHsl, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1cf90634abf87817f7863383507ee3d9807c5df8a1755b970ce4da7dc7e204b5(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanHsv, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b5e46ba6e48017410afe7f064d2738667d8de7fc87b262054730eda280be8b61(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfDimension, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1043058755eb2c447a3d85bcd85950c7a04ed1fc3c630a3356c4f59e78432428(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fd823faff0c0413d3d2a2d7b30b43c712413ae2d8229d72f95a213e69294947a(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanMaxColors, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__21c40e76a6c10b62b553606d06780ff8af9d263f9a7261865bf8ae9f3e053fd0(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanMirror, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f81709fd2d1a0da159b394fc36b1a80e14da9e1429c3cf6e05037b9395f367d5(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanMonoHue, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b2ea81573a750d8e4f5487d172f7f4deef54757bee3fd87ecb0686971e8f3a5e(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanOpacity, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f2bcfbe851a73f1b9024aa88dd925ecb6cc0cade222f619add47a4865879c96c(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanRemoveColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6efa457a5c4d91c1aa3fba1770badaa5bb2c7347c4580b7607a988b1970c921b(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanUnsharpMask, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3f482538588aa0946578bf524c809a8329d91d3bb751905cff7b0b9112ffb2db(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1858765d9c5b00a19388bd57e56d1bf318d50293a47be5538b8457aade83e387(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
    feather: typing.Optional[builtins.str] = None,
    feather_var: typing.Optional[builtins.str] = None,
    tolerance: typing.Optional[builtins.str] = None,
    tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ce6724f1c26427001b01481441a861a54ee5bc7fb59e94ecf486a67efd9d465f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f3bd055039bbd524be1344e224248b7d43fdd8d97ff04cca87f0d0ae145f3a89(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b0081dd862d026dffdfc7c705b280475daf822664f9b6a7b7baedfafe4515186(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e75a0cd4e17b4631418982d939591412a16f2bf81a2000b065e9215bc7b2c3aa(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__45396e079437cbf57d04604a8e3b43e1ede821e2b2d710bec70a564547d2e79d(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0e5afd8f91d3d83e9feae0851c16afd76675196f0fabc0e03d8184a24b5a8f8a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanRemoveColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2dd1aed81e098b42d5ddd2e82a4f0363f3c75c3e83e45b08d8cff0e7e89eb74c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7b9c5d5fd94de6f6b565ab63df960f21fa3681b216154afeefa91e78ccf446c2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c647ff8edb58c93cf212e45adcd1ba8dabc6845ae2efbe6c85db4fa3856fd915(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__636bc31f894d58c8a114f02c69e532f49a2b9b4b7b33821c55cbc3a84c220945(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7353ebde7e5f9c0127f9347bf000c7a7079d45b95d3037f3e2f166ebe17aa274(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__67b68105c81aeddb5fad92ce49cf0403176a179702c74136f6142fd21c49e640(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df09a22b1c6ce6a5eb40281fc16d439508cbb75f1abcacf5e98266f16de150fe(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0d1e3269e7d8241ed828fda50a6f0c4fab33d8efb6c341039f3c9bf1f8c251fa(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanRemoveColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f06ead0ea85b81f1323c29c8063c22361538a4aa78ffbc73359c186c5e9d58dd(
    *,
    gain: typing.Optional[builtins.str] = None,
    gain_var: typing.Optional[builtins.str] = None,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
    threshold: typing.Optional[builtins.str] = None,
    threshold_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a2092af77d36ddfaa015c1632319e2691c8130fdf3edc37516e53c61f6d3074c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f44ab503306857c3ccae5385c4cd7635ec570fb78ec9eedd56efb76a54115a2f(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e5e4b58d6bd572ecdeb59dfa3106995637dde122fde3d8b8d2063811121686e8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1399b0fbbfb4ef161bd9b58d2504337d855b8bb4266a67b55efc0e537da4f50b(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e9f020d4c67da3d7c6cc8ed347b40b1748daae72992641300ec82f7d30124855(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a434063a48313ca085ecb1087bf1064db3046703bf9ba220e9a9f03459574b6(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanUnsharpMask]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__95318143a668ed91610524a571a9288bc09a85fee1f9b38c4f829fc9818d65fe(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f6ebebfc569cadcf4dd21e625332fd22a2dea650074f4561f26dba659c4ff0e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__efb6051fb26b84b238cb4388e63276715326de95daf02d1f9331887ba93e4918(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a23ac13955c59352db71484a512e3294828c572474029bb8853c8ebd0cba710d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c40b44fbca5e65c180c9038dc1f81f07e9a992f814fc082197f71dbc35263826(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bbc3534ed9e8b598b74d3c8fb7774f42fadd2da438985083116103e30e4ec61d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5656de7e54245732b62e961be74060de00fcc063bb9a9303c3ac82f81d84f291(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__88598b55d217f6f302811239b4b0c587d7f5e6d3daa139a0ff9a7cd826c65a74(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanUnsharpMask]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__90a756df1637bd4fe11f903fe7d93933c02bb62fbcc2a6bcc91923284dae1d9f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__422fbc2368d16d87f8a073a6271fcd8b7ce1709b2dfd587a5692ab481d6a158f(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__92ffd894d3ab020fd405b7792ba62ad2104d6f7ca3e7b47ad5508335802ca335(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__37c2b7ac4b2cb59d083c907347f2811c10c560197108fcb49fd7363ac05a6926(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ce3275e91c8da916474167112a74a9720e246917e361e3423a14ff14f4f82715(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__757a9bb0f3001c10ad6e4851ff28c42b3a0bf62773fc53cf41a8e2a01df0802d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimension]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0d19a6e5b902a084e443c7175ccb1247043ad7ac05b6346a5c7b13228f512174(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9dcee752e0667b97625b449561269f6a85c72c71486d7373efe0a8e6a2cdec50(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__62fb3485de2e9cfbb81c610da08ed51a671e4c5836d05bedb62af72a8f4cdf3b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e163d90b40f01374a427ff04ac49bdbe6af46240ba2bba6230da5519a2e4a992(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__afbcef633fcaf91c3a6eb6b1664bb11a84c9f8cb0803218f66af9583b97209e6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__08efc22d7abc47f3a19260eaea93a667e6006a399a31c33aa2932598f2e8a839(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimension]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__17a2de514489d5b150e8b31d960201755b15397d383eed07f04dd61d39536934(
    *,
    colors: typing.Optional[builtins.str] = None,
    colors_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__40c6d27bd3b56e0f38e3a4730f29df1d94bc7843c3cceae5654a6554c4910510(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__98456ce859bc919aa3e572fe75b7b06bdb763f5b95619c923d128851533cee3e(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__65a81cc8fd8eefa739a2cf3b1e128422e6661ac2af9635123ee295b9ae77f2d6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3c4c04c795ded7157f65df46686e814475a211c8fbbbcd11ce545010183091f1(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8f00ca1185db4e9925dbeebe9f206e10e7bb07333b86f6ad577438a3d4d8409b(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5be2507f791fd8d47a6b28cfb1fa928e87d1cb5b2a04378d2d2658e9ed4e66f2(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitMaxColors]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__052c073017f0c3ec79d8b7b4e4969a1ac24da4f02ba6e44db4d952a4a3911f8f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__00fb8d8848ab465f9ef11bb1531cba98c565a708826b202154873cbc0e03dff0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__310be680ca3e00a24dbed1e51a64de405b7470455fb48120f3fbf06430756b2b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1c7f82f1e07ffef93d879830845f2265e28170f801dbbb6ece41669acba0f0e3(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitMaxColors]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__218f0abe02ebba743d698974c9421e749be2bda5908859d9ce1b3ef0062e105b(
    *,
    horizontal: typing.Optional[builtins.str] = None,
    horizontal_var: typing.Optional[builtins.str] = None,
    vertical: typing.Optional[builtins.str] = None,
    vertical_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9682090699185f877c05a33904be4fa534a38a982fadd2224a68016bd8c1a2eb(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__656981ea0bc9c26c19663f16d0dd998894673c8956c620d7629c67885940e86a(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__78e5839f68bd0efb8bb2d25a80bcfff2b1b4b951b6d76430496f4ece5490ab6a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__21232a1da2cda00b5974b84f86e3746a8c3c4ac7f50a68664a320f6f4ccd19f6(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc04de0a08989c8f2e22c26b3c6148680ac8a0037152bca2031e610560dc3106(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b82c2d628e9bb293fb2b7f5992e61f80380152c55ac60047707008748a511c34(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitMirror]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c7cc6353b3450f467dce27fcbdf7e9e3cacae7e698170ecffcd28bb3f84f852f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__74afb1af1be20def94a6f92e0ceab3788adf96541aceed5731523018c12c3eda(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2fc6495e0887a36989b118f5af57c9d7fa48cd7fc9ab65fd2e13f09155e8fb76(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2f8ff84a8b88cbfec047c394f85b6cc8a71b9e677323070fb068f017807d32de(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ec3412e9cd78b60c9f3632f05bbbba93952edcafc06ae7de2da906e41af90762(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a4ad505dbacaa0f4f8cc42e50fac92edf3b6a0f753ef2118958adac440b14041(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitMirror]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__141c604b221e6592c7dd425573cb5ea617facefb1ca88d3c14f20ed0b283b494(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ca2b17790572d92b4401abc556c45c1f2d89e8b13a9784bff2f798356bdb414(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__613b35f6879f31a48b785afd801cc5a12629a84fa51641fd4f691fb6f1ff5712(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d33467362a08f4e2fe3009b3a89945116f524a1da3513b9e971ba4b882eb51c3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__75a0f7717cb9ed2b003b9db0c781a09f9a8e4be426feb3b230126479c9a43625(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6aa7256d8b48395bd3f2bc9bf748f79e490cad06170d131eb729fbfea7d0b7c7(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d5b29bd7f11b489bdfbd2485435799e3ed1a5cb2b0437c2b743386281a20b66(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitMonoHue]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__27074fec7be74e2f4d92598d1b8782a8cdfac1686432a8877755110b0625ab16(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a8828b2c23542ad50ba7b229012c82a5fcc85621e193e3d2fcc6e7a1c801c329(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9dde7c47ada54bc285365ec5aa35b597de0cb8e6d5a42b4095ea55d8b414d710(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3f33436c26a52d97aba0f5b28d2c5bbc87270d540406f8e3e0807740404a027f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitMonoHue]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a071f351780c77ab8bbf3c04915079c97dd8835b74e34e9d6752be963bc98510(
    *,
    opacity: typing.Optional[builtins.str] = None,
    opacity_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5a48aed242031fe5134f22db720e605d01e042916a28ac421ea26ce8a3aeb5c8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e8b786907f49fb8f56fec7c8e3cb7a9718553882d8c4a965265095ea64873600(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3dbb02d2f7e0e2e286a42177cc674d920e4d91b61fe66276ac222d9ad339daca(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a52906016fc60682057b3a20f1c6f6754a54327ca1807231814310170d8751f(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fc75055459ef1fd9f75c11ef8bb5b5717d267a887c84c84386290598b6761a46(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6a7c376e0a36223366ec2e37cb8bb2376a8164a18712e3496db7821f0214564a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitOpacity]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4620c0c86c192c37380ec0a3e34a12429fdb8305d8c207189cba50bed0bce7f2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__505eee4604834dddb07581f24a739608607c7d5cf2f4edeb8dab3b7746756796(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__642abb9b39dfd473f6f8ca00814f6866344f3bddaf8a8ae56e0f6b38e1bb8eda(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7bfd49de2fae1abe178f0f915ee78b142e626598d4f8397ecb68914909d62946(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitOpacity]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__24c391c7087317ea32adf125ef0401c7c93b5ed7887fb40c43a60159629f186c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8dc555344efd0d22c00e4b22f32c38712cdd656f9373f4393aa69d3b15c2f3ad(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__80a9e8edc116a5046cb64ec831a70dc7ab513635aca2b61108e5f51b5dc72e30(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitBlur, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2dc9526e0de7c3a31b5842cc44a83e2655ffccde0e3bb6afcbaff3094ccf7ab9(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitChromaKey, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cfea13d9eea1359f5fe50b90b71260ab4da7b689b2aa3e969fe2cebca2b224c6(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitComposite, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__60a22ddd66ed608c85a5cdde3c876160acb5f8feecb803a10d972bda77db6246(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompound, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8e7d81807320215f4baf7478162b943fad4b14a2f7b997fde4f0a67f4e46b2d9(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitContrast, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__228320cb6565e2c8467f6849cfebac25be564ac06ea17f7dc427e43368de398a(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitGoop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a1e1788278de0f1c88b8b862d1fc8f40ce5166470d86ea9930da71b13fc8a996(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitGrayscale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__88c20755422b18f4f5ebfc08043ffa3f1cda697645ca641bf5a31e4e1ea61429(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitHsl, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e29d9c8ab07226876b83891ba4307deeb5d73dfa13db199c624f6d51c4044827(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitHsv, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fa8895d8300403a8e1ac8a26cbc18ff586e7567d006405f264162c91fe887ebd(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimension, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5c2f5e03c71407ff97b4d8ecf37ea29e6a202062c06e1f55ccf21d04d2bdaccf(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e9ddcf8fbb659a26c5443a4395071f1a17030e7fc09b1789b030c99237cdd838(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitMaxColors, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0cc3de6fb6b5ab099fda9f2e6789382410d2ceecd306cd7da28fcc21910cf38f(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitMirror, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d3d5cdaef3be6d17ea0c8124ae1e9e9d6ee7df7e467cfbc579a3a94225db99ae(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitMonoHue, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dcae4bae2cbcaccef2cdd3bc5dec6910fe779c5c0f2366ce97c9d04c4517c51c(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitOpacity, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5893113cbfa6c100f99dd45ec89d8e31e391e64b78d26f1f0efd09ab8aeb0e4a(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitRemoveColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2f9737fceb269aaf2e317009f16a8878cbee9ddf6c1ec77192eb3ff74ddcde77(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitUnsharpMask, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__74135cd740e15ad90b6d77af26b8b404d5401ebdf2e2aa7d7ecc4fb617e68592(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortrait],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d8d6d569c1aacb215ceaafc38c5dcfc4b2a00f64171ddef59b44bfcc4246197c(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
    feather: typing.Optional[builtins.str] = None,
    feather_var: typing.Optional[builtins.str] = None,
    tolerance: typing.Optional[builtins.str] = None,
    tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4564b4b63a96b97eecd46abd9ab33bab443253887e69313aca3d304509db558b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eed0a70a3782aac8ba8952b4c93b4e7967270eeb4dd6d08d3fe16a8afd887a81(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a978a1bed24e0529b069ca4f1f9907bca9eda2cfc0766f54dd9cdd87af2e48c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a08b0f7d3db4344f8148312b1b0495e6013979bbfad2ae8ae861ab5314605e72(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b13b8e0cfb77ec6b21520ae0f3a3924febb3b83fdd6cd8f3466f0bcff62444ce(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a19f5a7bc81941741f09ae8288832c8cb676c07039cf0521b06df6bcfad385d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitRemoveColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a263d1da18ef214d9ac70c302201586d0e349c02d09c0fbfa57bcb0d7e30acc6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aaea313d4b2a513ab8cb02bd0ff3065e30a4fffc09dbeefa70c997029479bf56(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2989c0d52436099f9d927f5a9c8e17a7c24b37aeba5ee5ee4416abaaec8ffece(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d31454ac090051c50af8a7afd4569d250504577876da6bd757f8bd92e323cc7d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bfc1d35e543b4d6fc0bd4ebd3c122de4f6040aaf7b4afd1c52cd2612ba4d6652(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b66692417ce52f5348046dc7270f5fff9f756798adc475ade028844fb8dd5ddd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e7220ae0561ae185ab1fab7ba2de7da67ce0a74cd281b559094172b387f88f09(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__da3a457c6892afbe49673bcc30770cc49e6ee53aedd8242b571c74cca2cba483(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitRemoveColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2028dafa24186c1b7658087915ff7253ed826f117b4e7f55b22211b49564b5f1(
    *,
    gain: typing.Optional[builtins.str] = None,
    gain_var: typing.Optional[builtins.str] = None,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
    threshold: typing.Optional[builtins.str] = None,
    threshold_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0eb8cd4383baaf0f416cd55d25c852203790500430d9f1d8f2f978341ffc09ae(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__969bb790c266ff743e701d8e834d7e6448a91fb5776c21f9c3d9afb26dc46b95(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__76b4ed1a652399651f4e708113cb59ac112ee7d8a39841d68bf319534fdb519c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__50faa1df91e9bce27cf24c2ed81892c1a497f4dea77a34a8503a012af1c5a8cf(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__13e34ce71e58a0e5c7d8c802c6aa77e07dbf96c02a5befc8a044f949aa38f2a9(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__20793a157d1695822ef1ed37bfc6958a770eb25d42592ce7896b6dfeaccf181f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitUnsharpMask]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__29cb99c097f4fdc221f4b141a754361bf310580ac0d9fd4e2416b3916679f3dc(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__206a0c943ab10469f9707afce462a9056580c55ebed12dfa8134b1f994052398(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__131b2c357bd00103f0bbc6b06aaa47f0ca09f7dba4c2e5b055535a982acb9783(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8ae67c6f85df441f021433850b7f4399e7a1a3afc564c036c325ae07b5fa1ef2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d99c6d5be7cfc5e24a436c97848dd8b367ed556047d7d940a72d5fb14b613af2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c304b9aead4de00c5ba22cec002acbef5022853c5ebdb4e9cb9da8cb11756b57(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6aa9d0a57abdd0aaf909e7a5b7fdcaf6fbe59b6a519c0ccf733ae4ec502415f4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab93762e3b263a4c0eee928b6b04782e83d72cdff0260a653604bfd40f4d12b4(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitUnsharpMask]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fde2d1e04e55ef3283e54705b446aaa6bd8e0fa7e4e45d5f4e5049773e8cbaf1(
    *,
    background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
    chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
    composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
    compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
    contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
    goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
    max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
    opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
    remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1a334e186e59b23ac957e073a329f11681e1f4a7b795fdcf08ffae216dfa27b4(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__37366c200fc970175f65a045bc273b670537b416e6b0ec20b46096c8938529b6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__65fed233ce009324ee1df6e8069b1eed9e5964d22daff9dbd6cba57d170f95cf(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b3088613822cb461fa3bb6d1fad0647ad3a8870f3cee3e2da9627cdd7d6952be(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d3b90a7a33accbe4277852b63627101446c5ab2b44d7fe89de4a3edc1eecc872(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__35bc75c0f51917cdfda54cfc92afe1eb41f28aea76062035c0a495316e096489(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__70fcf8eee4836e6cb163cd72ffa5051ee0a39ad2c26978705dc16db0a70f2358(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareBackgroundColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1431f4adf8106ae97a446bd99a06bdf0e9ef77ef64e8f53d0fd1afd813b78222(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ffcee53886aa9a25c4754ff04dccf0047f23a6a4d4d42825480ab93923fe584b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__75c3db87d587fdc9d8f2a17abe971036f622adf18f33e553227b8f4bb8b0ccee(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2b173d8012b0fb8cf0d5b56ac7254994273fcdac5d9c230beb4e80f7e2c5323e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareBackgroundColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c93f1162d4793b84dc173c5f494884ae2fe13c2cd215bd4c10a90ba28cf6a741(
    *,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__72f7a0dbe5587edc24963898311c3558a6d36feb01c16b3a5c0692dbf5934f01(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eb224f05a3a8af5503ce17ffa31a35bb64230cf44db9c3176c1bf48d9c1bb2e3(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bf91f0dde4ebbb1b62f981046f76eecd3c8fefe7286ed6d1f6b7a3f92fd2cf21(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__22f663b28777ce71a3275e549f063616702bf446c7fd882dec9635e23fda94cc(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b6c71d6efb211cc0974a23259f3b2da2f9bc712c97d52e9cdb599401bece1cc6(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__da2658e055ceef05630f21d0ed8e7f0a9fc09a263287611ea55f88c99e1bbe8c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareBlur]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3eef5130ef126ad780f805395d62bb7651687e6988496c53929e6105502eebfe(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b30674cef0058cfb59ae226d4788564c980aacafc2e02bfaa583e919acaf992b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__771def2f29d6c1dbd4bf71f51cee3800c0928f176a9e2b62b83401a401a99daa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ee23f9f3ec5e31ff0d8f9dac4ee2b433ff44c6e0e44e13a67d754fe67cb98430(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareBlur]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cc9e936e1666e9c899cb2607e41a641c7fdfaf34b6928653fe5801495ec20180(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_feather: typing.Optional[builtins.str] = None,
    hue_feather_var: typing.Optional[builtins.str] = None,
    hue_tolerance: typing.Optional[builtins.str] = None,
    hue_tolerance_var: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness_feather: typing.Optional[builtins.str] = None,
    lightness_feather_var: typing.Optional[builtins.str] = None,
    lightness_tolerance: typing.Optional[builtins.str] = None,
    lightness_tolerance_var: typing.Optional[builtins.str] = None,
    saturation_feather: typing.Optional[builtins.str] = None,
    saturation_feather_var: typing.Optional[builtins.str] = None,
    saturation_tolerance: typing.Optional[builtins.str] = None,
    saturation_tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0109e22311eca04d7ac9d181b5b65b8219609d1efaa65caa991541db756a9c4a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df356fc058bf6254a703e631214aafeeff7425ccdde55424af12673dac8ad650(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__23d37e1afc4248fb0a6f4358d5f855afcd4b86d16b6180fc90e3bfed8d962c80(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__612b14c086ae3e469cf33a44de7f6b15c329332e44c5490829d65598b5deb8ac(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3cf098b935f61f67bc752b2db98b99fbcff09fa7928840e99d076e164ecc0d58(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d0b1a91dabee6914e4e1ab58d9180947b2a204ec0f38e71c953b20328c007cb3(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareChromaKey]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f0b02445d04d7c3fb1313b139f55989620b4d61f3c4dfa4cac7aca0c2a50c024(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d1b4df0864429b23b5a4a6c62ab2f624448028e81092aceeea1d735ebebca9be(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__50550e58b318b4e4460b4552562a8ffc64d77bc144d4e42df542cd64a8c89af9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b30b2efa39212c1131d412790e0e6bb4a5e57315527a2f40446c331c6f8294a0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__55076e4bc39807210e5b72ef649139cf813e19004ccd4c4f939d3de049f6363b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5b40649b7769063d156cd6979a4bc14ef9095c492254f6010c9e2615505220d1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dadb0f61b0a67bc95de6c582eed15a872d3067a6bdc340a4534a07de09c78c29(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__80429befee2bf51e1810a0702dea9483f6a5d0c60da2d84678750cbb79a80359(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea1eb70d21fadcd85de41d3eff5712ce5140dd353cd9044accf2cda59f82b27f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__408ebd2e1250c4c4b88a27866cc952ff46e6b158977457f1853bb8fc71d9ba27(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__76c0855b31dd42e6494866aef2016e66fd64364d4e0c4259a2d66e8c4a5cce1b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fc76dd69a9230eafa5bcebbfecfb96a401d4043ce25407b9955e5a9a64916d93(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e2e8a282dbdb5970442e5e9335ad71df0636ef1bd71d4b43b0c57815013a9c83(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__56baf62437f1168962f04058a4a28bd249421baa9e8878e5d79b9caae9464122(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0a1d736587781842fb9f63c8b361adc7b58147a633b08f6af5e6b7bb96c448fb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__124cebd425d12de13494fab2c926c8ce76216ee97fa6425179dea95628a797a5(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareChromaKey]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9bf2cbbb71bc6ca66e816cd36cff1448469ac2b6cb1b5e0f2fbd72c48f99cdc0(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    placement: typing.Optional[builtins.str] = None,
    placement_var: typing.Optional[builtins.str] = None,
    scale: typing.Optional[builtins.str] = None,
    scale_dimension: typing.Optional[builtins.str] = None,
    scale_dimension_var: typing.Optional[builtins.str] = None,
    scale_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0500a5cdea8166cbffd9b93cbe6b6d957985f915190b26b404f11fae397f2430(
    *,
    box_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageBoxImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
    circle_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageCircleImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
    text_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageTextImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
    url_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageUrlImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ee2aef863f0c1f044a24775f4e932886181b33be8b1e5077242341b2fc027dbb(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    transformation: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageBoxImageTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1c14520f3e8b623e54e6bd44ab8eb61be18a64a982e7928a6668d9b4ad31e06d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b64a8c9265896040a3a6f3fab0f4372f0aca1f492f7da518c0df89199bc92567(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f45f906f7e46103175798bb03cac25fa92b691fae0a7178bbf8d9a18c6f0961c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__19229d7bccdb9e7b8c681c7f15119b56e639447dd3ab4876fc8d951812665b92(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__13490a71402102ef45738d08883d65b7f974a607a9fbf0d35843c474122ec8f4(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__51c4da75aa36e7577bbb23b8d5ac315af425765e31f1d8fd7a68b1fa54d1227c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageBoxImage]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__556e815b7c90133b3ea1144e8615600a99a4bc19ad2efef8e950b9fa4aa2357c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b962b7b98c3bfe0427b84886d497cf556e7aade1d972c61cf9bc883093006f59(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab1d4fece1666aa04db12db125f97fdf3a3f6194bd12a27cbb97a1188afc4ac8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__15e3f62e929f87860523e29312c5c790d9326b37e3db98420539f701ba045d7c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__43f609b0315bbdb6885d966d3eb856947b1619a38df3a8fd95135dac686b8c83(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__298777cfcd4bb4e0cc05047c018ecae63bef9232cf6adc9d6277d0c0f113496c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__455c9ae88087640efeb8db83dcf1e879fa36b1d42d4eca39e09d25beea9101b1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__214f75e2d75380f3dd0e7c4b4621286cb7e8e4060395d5b56842f6413ec606d2(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageBoxImage]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b39562cab00b38a0da8e52501a959fcd903610ea628ebb616f2a39078d6631e4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0e72870bb4cfc0b8a216b86491b1329eb90b7a6cf8367d9a445c0b2af8d8542e(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageBoxImageTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8664304ad6e808ffa808a3040d042a53f4983a59d9b281b67ea9f86d40548f8c(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
    diameter: typing.Optional[builtins.str] = None,
    diameter_var: typing.Optional[builtins.str] = None,
    transformation: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageCircleImageTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd1bc95b8bf714fce1a7749b358f415022538178d237ad13fa1f9c9e252c946f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__48b9ad5b0ec4df7e2a22e10ff4b06ff34c537e252e4120da415e5f5766c389f2(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8fee449b6ec4b048c236b1a0f9b05e5170a2fc2ced99c7814ef7d407ad6e2ece(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4822f42e380b6c2f9c8b60bc216428552b2303066aca60d00d5a98b2dd6cb02e(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b1d1fa003f92cf9072fd886a0c57ba8684d638352ff2289d392c50e60a5c009a(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8581df7b7b4e0cd3bd0d41e1c097575f404cee208306ddfe6a5e9c5b41ad9e52(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageCircleImage]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6728aeb57ec30e31e91ff5129c53d02e148adbb93e70962ed4c0746546a45542(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fbd3377f4699f6cce3753713790c4c3507433c091fceca8860b6ee54d921410b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7fa30f3e16ed20e6dfcadd0bec8c3773444ed9d195bf02966298a2163f5c9040(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3e282a4c2ac1f8168a7fe3ec575145b169fcc192846e1beef36c763649c76c76(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0330a4b12ba7deb09b3ac7cd404355c56266dcf7908564542e53384a402eba14(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cb39ac9ac61daed8493351b2cfc0cd41e528c42befb0ea97a9b69926aa477022(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__374923925af89713d13f0984fddf6ef5c1a2594fa36e902a75cb6736a1d00a8a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d7e9646d175b88cbc5e569e8c8627e8227335dd0bc0fce8573becfc314b088cc(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageCircleImage]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fbaee11f4e150bd797b9bb08ff65aecba2a4a38f83e48d29dbf10e8f533c8e90(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a0438f9baf0f218d2c445564e9f68ad04e76653f7f2650e40d79b8877d3211b2(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageCircleImageTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__176801e26f6700bc83150c1b43233f7961de2ee7b4dc58e6ef8c592a7ec7b77b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c5e9e972576f8eb739dcbea3e4c1812367a25e4f190a0d2dbe27b7492770c064(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageBoxImage, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__11147f3b872af76640f90a5000459205d7493c962782ff6740e9b31ebbe12958(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageCircleImage, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ba3ae2852817b21c106451175a7c6c50b022804124a48073442c0a1b1121d0e(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageTextImage, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__593381c563ba07c377875177100522eb20c3029cef041a060901c7c7a4de26f7(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageUrlImage, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fc37440f5088422e5708af59176064dba70ef4c95985a8a0959a780c4dfec280(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dc2bd63c1f74814f72b0d433943883d88a40c0365245c9db26e62362aaa67e6b(
    *,
    fill: typing.Optional[builtins.str] = None,
    fill_var: typing.Optional[builtins.str] = None,
    size: typing.Optional[builtins.str] = None,
    size_var: typing.Optional[builtins.str] = None,
    stroke: typing.Optional[builtins.str] = None,
    stroke_size: typing.Optional[builtins.str] = None,
    stroke_size_var: typing.Optional[builtins.str] = None,
    stroke_var: typing.Optional[builtins.str] = None,
    text: typing.Optional[builtins.str] = None,
    text_var: typing.Optional[builtins.str] = None,
    transformation: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageTextImageTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    typeface: typing.Optional[builtins.str] = None,
    typeface_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ec90b22803a1e921e2502db0ec363bc5452cfefd0c05cf19e0c96e65811bc169(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0dbf5ba3bdfa60d7c44255bb681d606ace99cc922abe9d12fd19024897577a61(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b5b589bb702a548e682b201cb1bfb7f408b63f7d3146496e87239a69d42220a9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8c471d0413d5ccdb664ad7444cecdbd436f9b7c1df22e317f319b74fda7caa79(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__66433ac73249e422884020e95fc9ea6d82e44b7f84babc2bede87a961f5fd4da(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ba79c078f92ea12bad90e2f70f3dca474857efea2a141c870f390c26fb06664f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageTextImage]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f800026ef17c62f834eb0cae6e131ce20a0ca6d885cdc462e53014595f33c741(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__73235df27d6155bff287c729c4fac4e4ad1e4d13b68f235cfd84ab62d8908bd6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a2dd9b3bccc7b922dccce51a524e7ee8063d819c89650c6e6dd4769d566de454(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a5d352b55c7aaa308a9d9635e529d1b87463ced8a6cf7a8cd5261feb4f38722(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__65cfb721d9bc42e90f8d383a296392ad5be6d093b806334d1335c260610db793(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c9aa2a8ca9490a62c1a559133bcddb531544c1ecc77e11c3b59d19f26367e7c7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b02e9c41a223325dbefbfcd62fc9db65b956c4b0933f372fee07e92751d17bc7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6679b72bb0d56a9f7b70c06bed11997d82e36e93143d3eb569da26ef0694497b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c0f2671b0644ecdab869f08e9eb825fc262d94af08721af0afbc4efd886b13ce(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b15a22504bbfde520d77eda3304663da87e80c92ac889b5c7f3999843e8c94d9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__51ac005a9407b13ec44fd27f2531cee637f1dd5caa9ded203fc439e4ebaf3194(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__503d5a639c7d31f251ac5f83d76839c30be5700d810fe73a6c836b1e2e8c6226(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__98bf504af1330607c8d8f926a3ee9e99928ce2177c1840f3cd527029d17bc255(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6516bfae04ae4c53ec917302aa062738bdbe726ef60fa0d5b116a7eb1c1b924e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageTextImage]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9381318927d28c03af3cdacb2f2118d8b454993a064dbe1029c1e1540ad2ec5b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9191a95b2ff46037f1618d05fbd08189743ac79ad4051026a9ea430da9935c63(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageTextImageTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__783ef07ad0983bd89b593c8d1087b95d5a57a8dfda1059480e436ddc8d8a6e2e(
    *,
    transformation: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageUrlImageTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    url: typing.Optional[builtins.str] = None,
    url_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__73c6e9504f723444e865d1b313ad55b3cd67b0fbe2c598fcbe0e4348cdee9f19(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__328a3c7c78e680d8d699bcb811ea64afe3299ae64ddae78ee477fd5c53ec641c(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__41742388e26a54536fe2f28f419c080a2cd9f452079d79a9d76e42d501ba416e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fa89091d0c7a6c55a22c877f860afb9d589c137f4dd75ec31ef2659dc7f61c09(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3afa5f7ba4f7cfb0b30ae54816eb64b62fb2c53bb691912b7c8bfdc4a2ea449c(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__75eaf5c6a48118d588444a907d41f0fced0082d578db889201d6da0d3bd59387(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageUrlImage]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4116e5927c8abcda12aff5cdf971d7b27febb150701a714b9236f3f8cac67a87(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c06a1d56ffb16b378932621b1f918b6d64dd4104225143d475b2364554e4e2ac(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__24a60dfc09dc3ea2ca134d97445f32799e667313db32c08593f21d7788568480(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d93a4da2954920171772b5c9aca24787326f82cbcbd1602a3ff33d0ef20f08b5(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageUrlImage]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f4144791cc2379dd83a44919702ffab236e52b4e4ab81a1073b212d7a086e5a9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7dd1b490912d469ca48c6d6dd5c4be5c36e32d61e0f9e3d6b7f5148ebc8e3a40(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompositeImageUrlImageTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f7730af0579f0fcb628119e7a5d86291c585938b001f9570e61c30251a823072(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0376e965f3f37d387373333afd21fb2c626886db89748f2e9fb6cc70913e7c12(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d1aec2e00315ba419d9d18e6887d4a455b37a6abd001d6a79e46ffd3a948e143(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__88a8c98c5a6ce8554b99b264cf91479c9f0cb7e707bae745a3eec339ee24dfcf(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__da29f326c1cb96b2638e67fc71718c4e0b693e74e628970e833599de2017da70(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fda3452797096163dadb3f276fd3f0308389179dd36b7ee57df6fceb8182cdce(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareComposite]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__96e2190df8fb5a5a2fa8dd2f730657083810fd18b8a302a55accff60dde47020(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e70c9c1217cf52198e9dc7bd5268b5eb9e1420dbe6590356886a1ab75c4cb132(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__764d5dfcc8bc4586d393403974df89d70efdf5cd8d389aab41c31f69eb4970ab(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__73c62e5b9b9ceec32f052a7fab9c06636f5f564d8c8c80ad3858f9dbbc3cd938(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__464694a77e1b59a1ff623003a89293ca1dd7dac4245563cd1cea3ac2c69ebe42(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bdf53602ee5b07eca1647ae436113d32e6c1f34e7103e362ca375075b537cf93(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__318184380cad000e755b37626f449eabae7689b00c027e8a0c41879da0a62ed0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8ac53c8cc3b546bf006826af1b795ff72f2ca4a7aadd1f1e575c0c65ea8ec740(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f59dcf19c184165a71711373eac913bb8e6789274025fda43818dd34c89262cc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bca67dbb5f85b60f86dcd3efa91e7b65ea74390eed3012923a48eefa447f985c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fc422597e1c750e080559e1a158c40f9c5356a858f1a22f58e92cfd01bbeb8d2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5b1fbb3eaa1cbea4c6874c468dfd411973a6912c698a59c8b2efd6bb2d2fa357(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__baa68ffdb4e01ad43553a55dfeebef0acad29060797c89f3b71521103f48af28(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5e5192fd748ec4f23c90f343a6327983fa1600bd6b47b39e4ab619ef65718e86(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareComposite]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bac33009b30bedc808ec5f57403eabbbd4bf31e1a04566cf2d41f84131fac239(
    *,
    transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b0fc55cfcc35339275e2a98599f9d1d00798d5635bc063011471be25eccd8bf5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c3c285d5bdc8dec82669e8c0d2658079eb06405a35909cae2e8e9c3cb1bf5c62(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__787084001875cf755e3676028843caaccdfca85cd163d88c39217a50145fdcbd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__947b9a995fafac9e5eb36d849c40d58a5573937e3dda359d26ff8efd6a5a0cff(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d65165d690ff965faf7434551123e52ad9d4efb23b17d766ad7f950827205e0a(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3d37f6805fd8527bc18d04a5f4f4fff1ba8f37c7417346828755f3ae960a3886(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompound]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5b91289c29146b3aa8f8869fef962314724a2a0a904aac7f3e82cc3294507407(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d8883027888985738e371c8689f7761cb5636d85b04b6ee6cc50f67d8dd8c58(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a7d841a9ee06ff12f51d3ccc4be065db0451fe5717787c19b3562800879eb25(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompound]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e9b6aeaf6214af24514696e3859844b987411867fd813f54d1aedc01ccc09807(
    *,
    background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
    chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
    composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
    compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
    contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
    goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
    max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
    opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
    remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f2dfb33d4bfe6f1ecc43630d7e097743a2ba0e439b0cab75db1b0473f6349a9d(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__15efddd01d9629946b4cd9974e44dd399af05bff07c3c48fdda7be26cfa1a189(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a432ee50145ded53a29672cb95162c853858017e83041696064f9f1c08f770e0(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__68e23d01aa867d1e1220ed7db77cd99970980fd3ec56dc42e528e7b908f48f35(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e682d6424a9fc73310113cb5c30ee99137489ce9023e7fb1973c0fa3f99b228f(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1d57ea4ce3b43905355fecfbadc7abe85b3d5d599f7f1ea1f3e64a85d9f89a32(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f3c7b48fc43cbba4db1078cd5e54b19e01c37bac38cf56068ff04ceeb06540d8(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsBackgroundColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ec539fad9e32121323bc2e5d0de11b50a0c3551605d3478e8057c2e8a8c7a4b7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0c638328f38049baa684f1fa9647b1ddae7b1bf585f9aa15f353b2ed064bd725(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b646176c6772d1b71ac99fb1b24a1df334a64f2375e208d1c95f6c2adea7bed1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be61c2f02ff918b9002a2c0f46d7e8db9fa6fa659d0cc8af35c79d5a2f836337(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsBackgroundColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__84eb4bfc7028a86f9ded966bd6496de9b7f748781feabf34ef4d9491a9b6862a(
    *,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d23254bafc454192a6b004555b521daf2a399130e333f31a4311e02dca5a834(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b7ea3ac6a9aded229342956738fb3242b28b42e0c4e81130bfa6377b1d676939(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d42c6c37324a293744740e98ef23017a26586b2b12bc8e69131af02337260180(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7be66739344fc0cce823ac6dfbfb995ec4ae7c44db68b251298eda61789884e1(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6cf2f91400c40837b4f3e7dda155a57fb4787a2246050df40909caca4879d4e6(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0abe15a6707adac6cd80a8f838771031fafdefe506a39521b8ad65ba4051578d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsBlur]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a7311542c47e50c84678a8c637e27c79a3797c4595ded1eb2ce3b9d37074374(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3aeee80f03ffbc5d48080b95d549b612a90d50421d99214a4075f977dd260444(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__45f419eb3994d6e747e9726b626d9711bc8b217a2d9a9ba3a659e3a652b5074b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__15877f39af7aa2528a0d356cf397abeeb5a9c00ea11ddf3421e1746b358b648f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsBlur]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__45adfcd848ed4a37f2ddcbc4a61cd1e5f7fdf6fa1b98aa8c8ade59e3bd497a3d(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_feather: typing.Optional[builtins.str] = None,
    hue_feather_var: typing.Optional[builtins.str] = None,
    hue_tolerance: typing.Optional[builtins.str] = None,
    hue_tolerance_var: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness_feather: typing.Optional[builtins.str] = None,
    lightness_feather_var: typing.Optional[builtins.str] = None,
    lightness_tolerance: typing.Optional[builtins.str] = None,
    lightness_tolerance_var: typing.Optional[builtins.str] = None,
    saturation_feather: typing.Optional[builtins.str] = None,
    saturation_feather_var: typing.Optional[builtins.str] = None,
    saturation_tolerance: typing.Optional[builtins.str] = None,
    saturation_tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__96ec818c86be8dc7db5477694e17873a3c775bebd1f54a4f5a075b294d9ae9be(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0bab0f35247d6823a0801565160202ba7e1679f34cd1248eb758bf6d82b9da03(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7a9c9fcd88ed2de783e52c9149fbf86a33ac0957b3b1191a4af922d36ccbe9ca(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b48b3112e5ea9d8bc719213aa089158d22ea5072a544848c01630c9d06d14451(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1c131a2c43d13c0a37c6a4f2b3e48ecbd92034f1136e0559f5b01dd75fd8e1f5(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__98e4380662312f145a857b918462bdeda35d98e3589db545a027ec712fece648(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsChromaKey]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5bef388c65ab96583e60d2abfd10250bb951cb23238289b32b524953dd43e5f1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f3a95c33a356c8181992537598e7cfefa39480c9b04c5c7f8037deb97ae0fa2f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__34bd938526f10f062d4b57de6e94334170ec94bc79bffbebd1fe38646fd4f604(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6a8e93ab69ee3e03de603993ff23ae2ff570721e9f527fe35b86435126bed0c6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ba43aeeade8252428d118fb3b8178b56879f875720b4db5751a6ee2c79f98ccd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__61f9a8b48c09e50ce8db4472a6e59523ef40ef83a6817e2977692809d38a2455(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2c52cd6b951e529bf921ecb4f391e3c312091f1552b4dc48f2fae9c88ce94f2d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8f112ded0ee2d29ef06b8213badf5bc7d26b3989a2721d81feb3bede4403ea39(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5cfa2db06ae54375994e9c74f69571f38af473ec549ee9eb2bf252ea985398cf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0c349574bfe4f84480af585878144b2cdf9c25a3825c475338ab6f52bc3ab116(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aa16dbf53ee10cbdfe9aec239039fca2a355c4856a431191e3c8818d3732739b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__231b22d736e51f93cfcea0b2f26c585ff0da50b997f244e30d585621b5d82012(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bdad4622e410ea419624005a09bec5949c74fe84e7ace1d13f1fe1c2cbcabfb8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1c9bf4536b6d9f35f7c4a88659b6aa75b8bd7ac1b1b289e026331dece8fa0f8e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c12e3c70e39602b19dd488d15078fbe445900297f33af48ae67d38c4c1b0b233(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5800b0654233f8b5ee5b2f018966fbbd124c1baa29792b1bcc30295b6db56a43(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsChromaKey]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__74791e42461090ac73130fb379aad82af18a648aa5a4ecc133c8679aef3ed695(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsCompositeImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    placement: typing.Optional[builtins.str] = None,
    placement_var: typing.Optional[builtins.str] = None,
    scale: typing.Optional[builtins.str] = None,
    scale_dimension: typing.Optional[builtins.str] = None,
    scale_dimension_var: typing.Optional[builtins.str] = None,
    scale_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0c1f2c4f582a70f8c1329f626a095a79f1db1a6a1d199397d25eeff89ebfe57f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c5e543f34a066eb6b14cb92442626541d408fba466bdbd58fd53be32f8fea1e7(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsCompositeImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a14d4454fb7a49251bc79fca563aa9a16e5214f73f8b63c91291fd06927a70c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__87e9e0ea79347473c397bbdb2b7c0a3578175e41531d86f184edfcd8f0df6ff7(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f19590b24e1b3d9f2e3b7090563489ce3629325cb93ca2d21ad03acdf6927449(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8c1485fd3d246bbed22bb2126db280bb61b07dd123081fe0106e2aa8051930bf(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a5daf55ef8bb367aae455e782b88065e9283adb4bf900da2e9a98adc36aa956e(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9368d1ae85c00e9fc63b90fa7998c59dcc18553b57e6426a941f1ee966b34be0(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsComposite]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f3fc847ae91cbc4ad89a0d543821900c213449251cc92f05cf6985f969aea67(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0868c796294da9d8b19b95548d56feeba7509bda1c8315a1e22de9d06b0dcd8c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__40aa97b74cec65c12208c46dab154ef7eeedc07d4c5377c4aa26b1f9bb7aa5db(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3138b1c89ee6cecbc107996bf4d8cdb91e2688e621a430610efac5fa415f4bf2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__14e74f859a6dabd13c6c9625c9af028207a266d601f86d0019a3078f525f3101(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e7af10a7264a89a35ec47e351623a85ddc2ab4ae779dee93187818dbc9d3cd86(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ca418d7056545f98c6d2a38058e685312a10409631a0daab09547dc24f7e2dfe(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dc37a1ffe5719d33f0157ef6cd7b01f8c4bb7dbb621f0e63628c3e89758514ed(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2770095a5cbb7bdcf1f4d7de0872c864e8861d473c72bc0ecef0533dd5293bca(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__25a0019ca67354723c319d6edce15ec6395544eb488f22a6fe5fded2d9aecf0c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dccbcb21b20a70284b6b193725f1cf872fc502db3c4b819d9b8835963206a27a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f51fe35b2654f04042af1dd50907b797151d165673613cf5a57fac0db5f26e6d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb28b03b65d88e410a22df7ab4d99082dff99b5a03d48a532cbdf1112eb54b38(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a0ba04f05aff40b8341d1d429dd90d326827e02fc7ece60345f5718487040ab0(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsComposite]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b8599cc1883b81d7d940a87f8ca47f5905d859dfb320a510d3edf0bf75a9902d(
    *,
    transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1fab1883c23750897a9bfaf617d0e28ceeb39c4b21620bc57cdba75028803140(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6095db2aaaca1203c808be56f4b5a591de6447ce4f8a8e37a52a22b53ea43a55(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dde07d2cc33a80051ac4287443328de1cba1be6b504eb3290ff233c79dcfbbfc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fbdac4fdba547cd71c102ccce38f4717623eef397139a19c4f70b08ecee121de(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cbfc838162cce0a0d1b0c0523cc75488f04b51dbfe1b22fa519d0e36a7b62128(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6d6fa061c12a76305007350d4e8f449f14f924a6ab77d3810e7918f83d52c846(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsCompound]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b67b505229c6d9270faa70d281be2752eac1b07822e6ef7a9b51c9bc17e5607a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__de748c6a3b3aecb4709d59c918c7be11d7fa9b423cd9d23621d606e7d426287e(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3d6a0e091a47604718e19b1417bacf2c4a3008855a616d61d34efea0f7af8586(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsCompound]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7ee78e236dd782b8ec4863cae74a2f4f23d72874b24dc329ab736055b1eff9a9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__43d09a74b7e023fc083cdc872643c56bb6a02b3240ce960b490be532c1de22c4(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__917b6893139015d57dcee2ba331a8ad81559d122ed370113efbff2cb71d69f47(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1d3aa752d122beb6320fe95a63d48ec01753e8ff64e055ddcb547212c8b0d449(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f1ea8ca11d567de5392e83618a0bae5a14ec1b3fb7f1686967952e3632991d97(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__87f3d65370a5a1bd94059b2ee9dbf2747e90e9b2dbcb7d71eeaf2db1812fa995(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsCompoundTransformations]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b5b20e34c5a59ef6e1ed4398381cfcffef67243db8ac456e55449e76fbfe4a7e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f1b2ce1474f09fdf940d1c6f104becb357b0ee07c72305c30b95b7f0d8159404(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsCompoundTransformations]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c89c3240950de4e0a5ef7ed28e6f762e37f035d313466ac546a01ec1b9ac92a9(
    *,
    brightness: typing.Optional[builtins.str] = None,
    brightness_var: typing.Optional[builtins.str] = None,
    contrast: typing.Optional[builtins.str] = None,
    contrast_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4d61d0c1b2355dbeee60ec2882353d644b48681c780fab4714452cf0b0a9ed4c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5878cf3fd529278b8478be579f50c5f097f2b69c6a3924af548e8b39936c890b(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b4fcdefa357257c84712194de5a0367e9d2ec54ae3d420577438a1cc89b42f24(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__217ad8100c8b38afdc6b9140552d610a3a5ed95573fb4f06761e87fd3c6c9997(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ef295dae282567da572a865a85af52f2919706acc5a46635ecd32745f2a2663(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b27cea39df3652cd3599df903df1afaf25ba2cde2bc6a0922d6caad196bbd505(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsContrast]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e985f9af3ce02b3f2596b731e693d113ca2f01a3cb672aee11d4276e41c828b1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d2d3f683910dd546df311dd98793f994fc3f5f257130327558625c34f88b088c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__231ac8c5260fa86f089266a0294e39f62667c8aea563e564b6c6ee24586a63ac(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1860cf8b701e5fdd61271e1a13b297b7f49ea1c763a6ce677146ee80fc293973(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e9efa7806270fa01fb6d3979022d00b17c2f500f0119454bf2761da729f90fe6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e1ff1733803b243ef579fa4bc6e0df9a2c4197d12b7d44eae01d24c76b5e3b33(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsContrast]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__69cee8929e39050cfc9447553c5c29868ef9886e84301942a500b85a56397afe(
    *,
    chaos: typing.Optional[builtins.str] = None,
    chaos_var: typing.Optional[builtins.str] = None,
    density: typing.Optional[builtins.str] = None,
    density_var: typing.Optional[builtins.str] = None,
    power: typing.Optional[builtins.str] = None,
    power_var: typing.Optional[builtins.str] = None,
    seed: typing.Optional[builtins.str] = None,
    seed_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__025b1d8c775d35b6b3f02a9a41d2a51b6093af471e7fbc1a98e6f963a4ee10c2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e122705fee2cf28115d08f02796c3c66665d1639d05b142a052c7f6ae4e9fa76(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__152da460258d261b500a1ebfdf0599cb8b984f8df91156fccca0809f9e92615f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bbf9ae4839e2d326f386e23c4a3331ec54796a979b41340731ae0b864bc8548b(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fad60949c4ccdb221a782d726ae0811cb4126c1987cf5da60bf60f6ba7c938d3(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b4c07777ee5b0c72081bfbdfad4d59ccef25191f77b9959876a228508a24ea9d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsGoop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__560659baf2f2156ec659464b7c1a2c4febb6bf337cde0399e0c607ed82077d81(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f06627ed0a66c31892e335bc07971712f0c98c265bebe2d861cd7df6a3a14287(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__93b41b86eec6def9bd733e7511e8d29c6dbb4a25d3eca68da485e042d3dcb317(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d732b15d3b6d75135c33839cb929e15e6a0653e7e768c12e255e904df9d30acb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ffe973f44d9657cf722df67b6dd2d675a86153c58a0c5714383d14ee7537cfe0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9e52fa8305de2671723da8ab96fec20630232682de5582ac0a76d73e3fe44084(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__788c325217788206d88368273bc06fb101c41e2cdd1a87576cb443060b1eb71a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fecae9999f00935d480afa8d96bd054c39cafd9c6188d78a818cc0998f81da3d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3f5d438922da7118f0f285d4e657c2c4bb062ffc64c398a70efb380f866dd9bd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a0407bc132443803be7ab53261c514190f18a3445038a067a528373838a1b52a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsGoop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e7bbe3f35694c58da3a692ccb68c08f7c4f902a79f011d390fe689481a3f2398(
    *,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d01c26bff4b16dee3c4a40590f27a6090c13cd8366fca3e8de07d3c3fd3bc068(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__380f8eb33af42f1fdc0b04570b1ff266fa3ac1f41946a5704ef4dc01ed9cb455(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8dcb9ae0416ef9cc94d56c2f55967b1bde847c7bc6e1e089ffbdc4305c3c125c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d2b67c159414c5384b03ae9ac2898af6d43a0199149a6ce16a6fd7d4e0f1fdd5(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9af9d1b84d52c2bbb4a3fc4fda3dba11e878d2b0794b4b44553c9438067b83b3(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__10b5c0f1a598c6e760e78cdbc5b46cc0b484914a2542302f525bd41f92f3c24d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsGrayscale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e48cb1a5c2fa726ee0c22d77f42aafba2cc3176f48b1229be4f038e58ffd5acc(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5e1ddc841301945eac874e469f29f4cf82e316b5e20819e860ebf8aac14d6152(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__01ba121ed5ece7211b7e39d562bd221994023f3fb7dd31e4b08165ad64a24f10(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0e6d14fa9fadf55e0a75399363fe413f80d34a021f95f5e9b0e04241e8bc780e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsGrayscale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__623d0666fe6e70796601b7f2b95296fde636c1f5aeb47c6ac3c0afa3b64b0c37(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness: typing.Optional[builtins.str] = None,
    lightness_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__80c25b435b8ae202c4186be6bcb4719139d148a11be1a580a9f79bde1493bee0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df866443b349b1304000966e40b7f146f407bfed2f8669f53f2bb71643fea356(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fa084d3bc75d7ba8c141ca7c8b9688e8488a3096c8f975a6b95ed5ee9dd611a8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__31be8cb681e09527597fdd82e8b73471700b179e2a485252e73645157e35604e(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2030187ecd2f8f2c73c8d61c684b72043da32215a95372832bcae9efddbf5392(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6ea8a359f8cf4e6a5893fa3343bb37e95d25e05f6f4cfee9d0a96e25da9cf1e0(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsHsl]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8be4a75f49ff22a364a3b82213dd69422f37a7893b01267323203b9caf1e1d7d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__855335c5cc207f9e6512300f48eb95ce8939b1b23bfaaf7623eb619a1acb5e84(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dfb313c6004fd601a82a76461300e251e4e2f7c14d9e09b2b09d1d24f547cb55(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__76f0c87a751edc24c85ae3c4923c3a86db5e855b8b2b39968666820d0e7f0b30(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d4668fc1f2d726920f25e015497ae89e2bdb0d6bbb3f3bf344f04be5f46b1712(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d57f61b63f1b86adfcc014fb1da409ff0572243e2ebcbe3d686cf7f16081a758(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ba58ab113e578c8be93d24cea232bc107d5aca09c36d9897765c59165612a05(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f482e5125fab862ce8621ac426b1e0a56c24d64162f9c551dbc2f2a756b7077(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsHsl]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__989ff064fae5dcdd80ad9363ff513002d8ac1c749a7ad615ae3c143b590c6d7d(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__277fb57a0c329b7365dc11ab3bdfd7dfcf644e3f78e883adb3c166564047a9d2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9c37d370323c8581e5130b870da7c8240299965bdedd44e0c29a0ebc18803c1d(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a9b1f0b6b5142eec0e913960554e84700a46d88a804e03269c25e611a0523a1d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1b923ec8a67ff36ca1073050d331c86d68e2daf283be50ac50a5d17bd5a50493(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b189410d804f2f5161c84906653eb58c1a8fef05318ffc0f951b16bb268a3346(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b917afc6f14f46f92b7c131e79cf7f51376386e90b3ba8305c359be68a4e15f3(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsHsv]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__187c57643df0bc707210c652e8f3dbcaf85751cac8b47cd43260463c9b144a3e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d735a6a5d36eafe9a3cbb438c36a51450708c5547026963b374636d9702a6515(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__26841096caf7fce5c86baf0fce525dbce6fb0d6f559f421881dd896513c4a14e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4d3df65b1d2b92f15ac0e7e626a815d6f15e1c952231872945f9eb5365159ceb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__86a4d38cc43b7d05bb24551879d6b82720c3e0edf1d6e441c83c52172d01e4b9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ab06fd72aeae9d2ed3d1124eac02248490db3caa55b6285c4bd2c963b01bacd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__25572bcc0685d22630d6340f7a615f51dcdff16db30947a34cadb2cc722c9338(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0d45204d29215484be89239858daedc22b4443ebdb3a259be12f902ed5413245(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsHsv]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bcb3cb6d8c771579f3d46dc99b44c00b94215803b02f51eb84b7b644aecf7ae9(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfDimensionDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    dimension: typing.Optional[builtins.str] = None,
    dimension_var: typing.Optional[builtins.str] = None,
    equal: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfDimensionEqual, typing.Dict[builtins.str, typing.Any]]] = None,
    greater_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfDimensionGreaterThan, typing.Dict[builtins.str, typing.Any]]] = None,
    less_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfDimensionLessThan, typing.Dict[builtins.str, typing.Any]]] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c107b119c6586fdcdcea4e72c4db559b6168db6764e35284fb0d94f887747713(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4621c23039fee60c0d3bce7f5cb53b314586e6dab323d9cb900b1ef01da1f9f1(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfDimensionDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7159902d79b85f36a3bec0ba18abdd483059813abd72a19806d62cedae4d1dc9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__471ec5cb6abe61969791cfa6b93220d3336f4743bb609c52d335dc85b34dc001(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfDimensionEqual],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6dcb80e8e570295715fe31a13acfac030666d1d7164ac4540b2c16ee8895a4b5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b26710b2bb3e8cd9259a7684673ff69a4d59f8c6bfa4b034d4f7abbad0dfb173(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfDimensionGreaterThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__63c5b3759519424a0a5e7ea4a158ee481c1835e8f4394088736c36955d02f12b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__025483375da1060d672ccb2e3c823c8fdc76fd95d095b5b98c4fe9795a20c3c8(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfDimensionLessThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1aab8be6c8a71cbb28eb9ff30a6089de81d0cca63272e51d2a221fc60c2a482a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__29de2bfb27bc16837576991431062d93366abdba4ac1700c5d0332a20d05fbcb(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__07c67f5df216b2348f800214846468290e4bf1ebdf0dda66c2a853d6f91096e3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9627ba0cd3dc31be9ddd377a5a794b3171c281a7de30c76cb04c1858bd192e45(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8bb3d81119a5f784dd4b478e733618f3c7b91e41f754149b61623090bd03161e(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bed7a9309a0cc495604751a45d42f9a49ef9427bb015040eec0f884f6d80c081(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfDimension]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3b86fd6e4679490a55e6078c0256301315c1dd8cf7ef4931dc5c646a7a26f2a1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e0a3be1a347e1230ea7dbcc559790cfadfc669f9ae8cc6acd2200cdfd7740efc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cfff90b8dc8f8799c734fd6501f3715f38ac17d45d54107adc1f1e74bab7a5b2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__42e1e6a51018c788aba6d8617b9c62dc286c604ea22c16eacf89deb662b6ef81(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2160647ddca760b30c4c50faf69ada1fb1bac64c0ff42ef115608982b9d686f2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a61ca23959c30cfe2d617bcd4a3d0e6d03e02d3cdb4d4408b75db7f6ef47dc9(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfDimension]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3750a40ce8ef664a0fe640b1cf0e1d454b1387ce59194f6c2d4607eed1f7b359(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfOrientationDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    landscape: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfOrientationLandscape, typing.Dict[builtins.str, typing.Any]]] = None,
    portrait: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfOrientationPortrait, typing.Dict[builtins.str, typing.Any]]] = None,
    square: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfOrientationSquare, typing.Dict[builtins.str, typing.Any]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1938c106dc0def1d2dc8b802db90344dc308f8d67db0101956ab8cdc97379e19(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__34e9c25f5c1616cbc6df8e5b1002fe410351a14775ab5e851c21083b0ee812f0(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfOrientationDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ff0bed37363824226caf07ea95b6066eb2ea1183399c20f949918f4323276e5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e8a2968f79b1ce788ff25b6dc52a1ec2cf72cc98db5447c14ab0c452a8bd19b6(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfOrientationLandscape],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c142bef703a3b51d272fe5de20eb5384f54f93761c6f384b7f421981edef2b09(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2b6795ff8c191d7fa6e0f6bf518adb936121bbb7bc1b201015d5a2a0319ec32d(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f0ea5e813685f8d9d608cd5e3073356ce0727f7ba9881befc12393aaa8b4047a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6da548cd2ccac45966696c7e1ddcbb34eddb1a297fa223ed1781d02f0b67d9bb(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c3b333d93d27c0f752c9663f33f2d9b6ac097f4bcbd146fd11be465567cd85e0(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d05d38392b6a6add3dd49f39d746ee2a04236864081f9053d7a14c06f162a232(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfOrientation]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a780dd841adafbec6b23373396f2a36d235bd319b40a38fc6ba213df4165719(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d380e62fd7f2e0e041969f2d698cb3cfa32d3d7b6114b5b6cfbb2d1c89d623ee(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfOrientation]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__08dec2ad71f8d6a621d08272aa17a8d1ebe58a10b1a105bc088d573e09ea89f3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__88615cf4cf65db3ca4ea311b16b4c0f9eef3cfb84211c40cd98a4ac69ee22a85(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfOrientationPortrait],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7002ef69b26c404b5de41bc9dd2b5bb27c83ff30b01a97cf3b60f5a16aac137e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__00ddc6c476db7f9c27a2b216efbdccc8db691d818f2e91b27f06eaa485eb8a81(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfOrientationSquare],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6b4c1f92d684b41f3375bab1ded8419060a3854f91014465ccff62a1bf27314c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__14d092879fdedeeff257fc4ccd9183e6309cfb5d69fb4da7c14cddeb24facc6a(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a4f730ee9c0abd65f007efc3195ff0a37af30e2e35f9c3749f31e97b669ee3a2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc4bf7d48fa6e0aa43006fb6c452bb02d25934218464dba1cfcb143aa5ea3604(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d9203a3e49e67631ca9804b3f4d64ff93ed0d8125b277ffd48e708dc7cff0f5f(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__13126cc6cb1c85d3fb8d98e5d60d65b7d8931a3b420f8d41dceb996e98d53668(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformations]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__51a45bbc821198afd2488ee981d7fb8240b7494e85a4e93d1439d33f6a78b354(
    *,
    colors: typing.Optional[builtins.str] = None,
    colors_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__14a7bedde0cd2ffc7ec281537217e34c4f3c89bb9b4e1124b9c0ab2ff4222961(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ed3cbc1b89e170969812c1d943829694a2448d2fa7a8d8f09d4f555134861a08(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ddb147b452ad8f7a8e833eca61878194ec3c51dba92e8b5068130d9ff336376(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__72830643adc520e3e8f55f08758e8d4843f2646c53eb8373808422e96fad2acd(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ad1168c9cdac3914c9340cb067685ea97181c87cb6c48e12d35b69e313558e97(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d5d1aa7cf479a910627b088271babea2d4d4defe95e0fb03045b5381abf8d7d7(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsMaxColors]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3cf0751d6b23cfd71c42389c81850b34c0dd4fe727b1db526baf8cdf305f75ae(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__becc81c640294607355b574197c723384ef790ddb643591ffca08db4c2dae77e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d6ff6ad4f0333f7d9a05c49485ba1cb92481491399fc818deff285ba4b41cc11(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__359e3bc175a34bb5fcca2e0a8744735d4d5875dd2efbfadfb6ec11d673e952a3(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsMaxColors]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d1ece8f9775edbc0f62d5d26a40165681f62b9d99643bef40ecada794f7656fa(
    *,
    horizontal: typing.Optional[builtins.str] = None,
    horizontal_var: typing.Optional[builtins.str] = None,
    vertical: typing.Optional[builtins.str] = None,
    vertical_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__429803f2bb2179b182a303ede6666071455c074ebf9fe054fb1a2cc16ba4870d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bd200882396c1efba484c64b1763f77384c6a38f8fd107f1aad3d2b0419e5a14(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b344002b9c710099fe8d1cbedb2416e7a32fc361d11717da1757bb1a12b0a5b2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__423c32c22422166279a2e02636124362e5b0e28abeee0887d2c0914a87795536(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__099a73ed0aacfe49fc70bd33ea9b40cd2f339360fa892b4585eb61d8659f8ce5(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__59a085666d4cf56533243e37d364e497d6926d7a96c50320c19715bc869e5f46(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsMirror]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a124d8a3c1095022a4646bf6c3a58a9dec0717f7625f98affe70fd8363332bbb(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6657ddc57ece7a21e2f3379291d7400a9faf42fec80d84d7aafcdf505bd7d5d4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__471ed9c47a2e62f9d9a341cba1a1e5bfd1ddb014cfea3ccbbcc2d6771ac55eb8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__20bb04fdc39aaf2a8d0293d51b35ac7873ecf65a1ded262b628d0640dc626d20(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__beecb6a8d60ca512c10b8c185f332ffae6c236ed2f7094467b890c9b7123ab2e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7ba89550c798aefe7ddbb144f4f2950359ef38d1cd6b5e1dcb246b8430a4d262(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsMirror]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a9069903890cc7bf37945802af01b03b92c5fd612898fc6d9109771bdb5464e0(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__419bcea43f68b2952569b810b9a2e82e10ec6c28adbb9aa253fb92a5cc978ff8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e343e5c7a4a9fb42fa1b200f63d10a288c5a453838da05b963696f666860c6ce(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__05adb8b964cb490f01bd9b4f11b3ea328f699bedf0c2b062d390f35de3cd0f5c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c377f3fd41c3622ff2e57c7baf17e080bb9bc1e2c5c6df0019cd3bdad498591e(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8f999588f6e2f9feb0321cd4e4228ee6320a6a7ba7069ada130e8855a6e1fb87(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9b82b7b58b3c65e796ce24fbd4eaaabbd457e423735421afd56b59289bf107ba(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsMonoHue]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6c1efdd9d1f2940ad3d5fa637dd05d721fceac6e492b2a00b0af12bf96e654a7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd910c7a61455e441d4e76ad9bb14851845fa123172436092b2e2b99f54272cd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f92b8ea0bb59da2c68180780fd31f677f00098af881d261dbcc303e954467523(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5b39843a656a28b94f1dfc76c52f02417561eeabe880bf6af01a2048c9324e49(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsMonoHue]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0f5d86ffab85cb752b524ad64337773b7a5ee92e5a9d2bbc50bbe6586e403303(
    *,
    opacity: typing.Optional[builtins.str] = None,
    opacity_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__22552e9622ce6bf131926c18cb16ddb940c818a093014cbd81045307e1ffd71c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__457ab7c87e63921a25c8d626c7683846584ec7b7a1154fdf7414a17ba6415f8e(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ccc64700124a93c6989b7845962116631beed79a441e18ad4d016a0a36a4e054(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d00f07c6b59cb35d948f27ff2ca5b1ea33e9fc76e6ab685d6c80bb8a9a98b8f5(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e9c8cc26271c178ed8a43da2345b007a78626459f2885b66a61de54e18ffae7f(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__198f156017594751664d775b9839d0ae2403fb5d088a9e7a7617c3e909bed8b8(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsOpacity]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__58ac69fe22681e36d4d02aee94ebd37207959890054865cb0d5aa00d08ef200e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1088e9587cd6d84d49de948a214a03fda2bef88b116916c53dbc71b8064a223b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ff622e945d56b4737b5306781a306a10940f73d8751ce8f5b89eb5172e996a50(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__750b3f6e549430bd555dc53ba7febe8caf84876fe460dfc503827d60d38c2cfa(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsOpacity]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__83f3627d1cf7c2e554e23dfc5e9b616b70faf4bb7c5632ef95c8a3754a702716(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__80631cd1089e5ec3fd446af2c3af17085007b476c9d920b433baace9b28f15f2(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__430501bc7718f0e0da8f971ebf5d355f2b7abc392ac02bb417e65715f0618215(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsBlur, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__103d3793f7b966ed68bc82b8ebc35f548f02061dbc39c80cbb5cc843b0b78078(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsChromaKey, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9673f914cc5b53972d5835824184e565223908297f2c3be954ea52e4edfac3c2(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsComposite, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8d5150a3b251b574631a654c1e78f1d1e30a2f146a8b6f4bf5d386012c259aef(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsCompound, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__35fc1a0df8774ab3e19343bc9cc5a90df74cdda34d552a49eaca825a159fccb8(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsContrast, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9c1e5ed164adc25f144d2f9eb685694ec23db5b2a79e25fca688fabed9680985(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsGoop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d552306ebc33d3163c0ef4dfd41a2d0a2aede4cc8662a031a5e3a92493b5ec0e(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsGrayscale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__79459511c3118e16a6d66f268efb3ca176ceddcba7734c27063d994fcad2a4ac(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsHsl, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f48fdb61ea2d98cae52b7d16cd0ed73215c348cb32611e548dd6bd8a2f23ab7(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsHsv, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3b27731ffae5b4a4e99058d77d70a99f9571939df4c7084f424da3dafdf130e1(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfDimension, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a88aa7b4da0151307f67dd9ad75e21989b36fdcccd630ddbf7c1d46786d23ca0(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0423fca8c1b8eefc9b763935f95cd7e7b2920d150320843b306318b4a04245ea(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsMaxColors, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__995ae77184c269fab8623e8589cb36eb79f4126c0530432558d5ff1b525177df(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsMirror, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0b012b27336820c2297ccd379ce39f76374098b29949d4b5651b2219881ee59b(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsMonoHue, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e8c20857daf928fb2c6679ca008a0fedb0a8dd514c9b82cf60b6933610cfe30f(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsOpacity, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__90104574e7af4156198519d2529e43783e9b77b9298883bfa9106d01f114647a(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsRemoveColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af522bd6eef2b1f292454afb27232c21d60892e2587f7a9be5ff8879e455ae07(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsUnsharpMask, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6756c07f5f8efefe50b2a6829223687c8d9643782b12f66fa9bb349bf66e4f43(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformations]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7824c0098e70fdfe8c457868a8eecdeae77790cab4c56e0268b01a5b348f584a(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
    feather: typing.Optional[builtins.str] = None,
    feather_var: typing.Optional[builtins.str] = None,
    tolerance: typing.Optional[builtins.str] = None,
    tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6401dff8abd610c6797ad5e2fdb890d670dd1689e9c4f78dfb5dbc3af2406bc6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__031880c1a6b0b0e064e5ec6358e7d5cf34e0773015fd09544dbf04a8e0a6bb46(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__37c956f01d1d80bdf6f484c010e59bf3da34566fa7c8df15195cb00b37f83af6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a6ff49e17937064ef637a991842c0094ab7a95dff591445503bdf3e9004b2a52(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ba2ee10e268107abfcd966a910d2e63419898bd038d4c5ba150661b0621ad13(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a861085c72ac3aedbad65a50a7a219a1dadd9b35ede9350208f32a496fc92358(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsRemoveColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__39acce1363edfb15b887e93dbb41d5741204759773db154ecd40466dd7385745(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8407b4b140d58bde9e2a81d01963cc3d8ac7b703796973ec5440ff07b0a41110(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__493b24360b8ce67f23ee02f6402f39c437333378bb771788bd61b3872d511193(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__475267725a3098d381c783673baf4f172858e78672570c6673cb9c0999106fd5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__972d9a01910de0bb6ba66a0e7cd8320984e7d132e60616fba426c4a1456e8af8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5b83f185625d48d74749ed0fb1643ca6123e75e9304c2552456513a5f2fa8c50(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c0729e94bd230b8ec698c57316d7f7eb54a90c332d0eddc49ba54bd924e47438(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6be98487985b9af1c924b979d9c5c27a3d6be6e9907efe0006a8af1d484023a1(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsRemoveColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4957d00d61c3e959ea2c0aca0ad014ba69de7d89d5efcd6602f7f3e28afc6eaf(
    *,
    gain: typing.Optional[builtins.str] = None,
    gain_var: typing.Optional[builtins.str] = None,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
    threshold: typing.Optional[builtins.str] = None,
    threshold_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__438514b8b056d0a5800b0a4fab196851aabe73228df9b9c7b1de3fad83491cf4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6221c7716b8b858def6bda8cc2d028da615782294ce91aa98f2ff3025d4154e3(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e0347455a1aa2fdc54fc3bbc9126ce7cd7262d76d7753a2efb9b676f02c3a145(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1444a7e492d4099aa7844314cbca34991af8ce62f0b962bf0a47c3949d995efe(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9cfb6aa84fb68edf447c19b1e0075595ee1d8a3f2babc300e6921b9e3be07a76(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d2d776ffdafee03f7add704b960e8fe3693cce19968e1e1fb79a7a75aa5bc24(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsUnsharpMask]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c49cc3e42d8237bb4b61b4ce1a1299328b2686089b5a341d13f4a03e1c26d2e7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eb22c4744430baa1c8eb684b65ee83ceb3bca53c3b8ecd61258177d4b26c54a0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__43bef0bc8d227300ea8e20ff37396491650a71c16377e7a2f203d97b9f3de22c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__108507978c00e4061600784fd1ebd521df5171865533701b083723a9ed251d9b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c77d2ba10606b87dddafcd9cc4bed839319ce6acce16635a4bf08471df8406aa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__154fc70513651ed6da892940f9372d984314b1161c523c3c56eee22d304a6288(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__77eee404e0218e05a8eee1c77e0a1ac7eee656ab7a34bb6f9069d5dcff052a5d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d88e265b8a04944310dd2c9322c736e0d9b4bb6cfcfd3729e5de5fe903723236(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompoundTransformationsUnsharpMask]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__95d03fa11becd20fb75966324f26d1554e9d694616f0329b2a63d48910695cf3(
    *,
    brightness: typing.Optional[builtins.str] = None,
    brightness_var: typing.Optional[builtins.str] = None,
    contrast: typing.Optional[builtins.str] = None,
    contrast_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5e9f92b48ab7caa69ffa0f16d7d131925098aad65c9572174575321031f9a20e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a601041600f9140637501d9818b616ccd6570fb97af7f53daca03d612b54726(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__afc08c3b973a439252102f08b08cd47452e61c9cbf81636276ad511a229c74a2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__de105dc82857bf379ee7930dd8a1bf156a31845323d2225d889dd8813d5035e6(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f40b03f06fcb50b3a37966a5be93763b039320568ea3cdcd4c478b7ea06eeedf(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ddc441d592e67d6f68e5773995afe2bbca2c11553f3580c51c5e1d27ee51456f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareContrast]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__49e086feee580a1c1e657bc7d5116f9ee29cbe0eff44db8e096a3495a71fb214(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ae87a58469582e938bdabfdc0e8f1a7dcadfb0df37420047c8076b9beb68d724(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__726514f4eb21e4b825fd317d396510faaec3965cb6c4bd306723085dbf0224e8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__817943b7152bb929f424c867a270434dc34098dee82dee084b2d0d140bbc667d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a239b0c3ce722e0de6b9978cad525d2387f56461a103e8f3d168d09e969a2c55(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__531419de21eebf176b2dc750c6a4411cd6887824e57bea3ffb8be8ab1f2a064a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareContrast]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__21b8954e1506de4e4026fe1bc494d3ed6fc47d6a04ded58c6e3feb6052d7deff(
    *,
    chaos: typing.Optional[builtins.str] = None,
    chaos_var: typing.Optional[builtins.str] = None,
    density: typing.Optional[builtins.str] = None,
    density_var: typing.Optional[builtins.str] = None,
    power: typing.Optional[builtins.str] = None,
    power_var: typing.Optional[builtins.str] = None,
    seed: typing.Optional[builtins.str] = None,
    seed_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__46c8a55edcfd66876b32e06af5d51a5f88c286a59df06ebd840a8335a6dba234(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e7e40d13a9c930d8420121772d0b3ab9b01565fb74f82186464122acf5834196(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c758282efdf3ad15f3908c6b2aa1af10d7cd29c79d223a872dbbccd329c597db(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a111ba289ef224a419e25cb07f8d6168e6c3f762853f3b2f4d540307bb9f342a(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d52cbae84ecbfe92cef11699eee06a2a1c67a59494465ba41398347272011a56(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c843a3223758d2970ab4b54112df7fa15d87593d0c02e3962879d35553eea36b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareGoop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7f75486d62ee16c2173de1a8d5abb832d5f7aba519ec083ea03efc882b296ec8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e32f62673051396d7c78cdea228ac12f2c34a8837eb006142cf8dda9ea594472(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__177b241899cdf51644298cb53e0de7f6e74d56099a9607a493dc3e658cf5009e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__83ca94330492f4a8de67e520a3009cb98002323418868e5fe396d82b1d104e62(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__62dfb08835d555284767e6701b1cd498fc2cbe405ffa8e25778af7fd38e880ac(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3361fd78275852df7c828f7ed730a41506effd69c08a5335ca30506c288cc976(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ef56b6060b6e9324c497583931c4744760c796c29fae7f133334f5107646320(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__08a18261d5d6780a34070993636d28278104b461f9e95271ac55339f63b2e09a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__72ed1fc7a1e85735f6f7894ff9ef9666bb32e5fb007302afd563339f74ac6abb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__51aa9be4d13907fece28b592eed705ab133b0eb9d2142904f9e7722cf3d2ffa9(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareGoop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0691f6075ef366c2fd784fd360e726ab73de1ea703969ab8971eed07d5115484(
    *,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__693ead22ed34a10b39d8640d092b1e750d28f465207a4ab7a21948c2bdf9b7fc(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a171a288cc352000d27f9512523641f73cb345b947e8ecd4178bc9ad6c8f21b0(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5484956369c155b3a28d6c21393b208decdef42ec4a40855839af49364358a77(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__61f3838d971854fc381a25d460b9ad2146e840c7f0b624147714c928a0fcda91(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ef1fd95ace88f7050feafcd8cd85ecc940b3ce4ef2970fd25d75559a5e9bfdd5(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__85b2b40312911e34d440429207a86d5012ffadff6d6558142570674f946b5cb3(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareGrayscale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__313f3e1ac65d07efb0bed62cd6d3c5e99341b8cf4ff07f023fa4fa682e3e493e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b898e2a267d5ac7715b4118c88cc259cf575414ded54bb9b4a24002f27d88b3b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd1786f117dc9a1fa94c65d128afbaa93471222c86954d307a9e5db45141126b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__77e31ada2fd54e05dfa43575d8ea9b808e024fa3ac53129f6b5a9ae45f1fe6c8(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareGrayscale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__88561735b0d8352dfe9805546432a5d3b1721c8c320f14070735d068a1f81ad1(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness: typing.Optional[builtins.str] = None,
    lightness_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2bc42f29456a9f46d3cc905cb9c9035804561861ede8767df84581a945482cd1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e627bbe6bbe63ecf824deaf95e66d0759074f68efcea8b9c8b2c32cb52b6e07f(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd3ae9484937ea0419dafca404ec0403a3d0a0b16ef84c5c22d8fe78cdfdc414(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7f90adbe28a0facaac9b90ae8b47a4f8a82189ff410b7e2916a2060e59618954(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b2beca44d35c8899343639cf177cb8b080a9815d94f14d31e8aa5caa3e1996e2(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7b2eb969488085b1d4aaef8fc6f616c9fc3113c4b1e1c19b9f0cfbc6aea94bc1(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareHsl]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__038f4f9a4aa9ebae3fede2f6351e2c3bf8292de911b5851c47d1781adb9795bd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c372d2aad1c9bdbabd5718b8e1c60eadb3b722a8014b1262bbe3671a24c7d394(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fcf17462c363dad73826cf6105f2135af6afa1b242e8e014c235dbf99d1685a4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd02350b8b852487e04caffd67069a8867b856b34aba08d799d9eb63aa1c59e0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c893f4c9685058fdf8b788d1b06d0e3a6ee6f85aeb45e3bbd4e1b01279975b37(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b748799cac258c6bf3ed2890d2fb2eefab54e2e741d7bda4f53c195f57d032ad(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b73fa47e336c040614de24f5c3c3975c919040903355e3cbcc04a5999f4ed8f8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a4cf1824d3cb30296f2b68559557a1f6ee3fb5c27079353d700f5d11a0f2a85e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareHsl]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be7ffc538606f114a952469278ac50c49d47eefa21970ad7ee04fa8ddb667d70(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f1c505e7d703e0ce90c7a2f11a3a21888e404882474a759197ee185f3deeb003(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8b92da3c7387c76eb65062eb837f02262eafe661296dea3f7f07bdbb10aa68a0(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a6ec63cdbe2c9d9508071087f459c76843b4b4f1bdd938882f84cba8b02875d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f37e05683f7ff93c35e7331122ebd623013ea8f6aa50c2daaf1371249f1db371(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__474a375186549b8835d750c4af69b32cb2772b0a5cbcd4623fc37a9751be94a0(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b4fcc5555350631f52c63bef7c5bb339651ffa36ea4d2395777972ab057b7398(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareHsv]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2b50ef65a921c67d870906e1210c8ad91338442ffb375dcd0d7b4d820bbbe5c7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__21bdc16610ddaa6c93ba3cc0ccf51906a9ea46b9c847a4f8b402682f028d9fa1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__595da34993038c3b3919257612aaaa807fbaa594852e6bee4f41a0d3c8d2a52b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f3567280ce2dd7c5e7cf9dbb587bc7c7ff8cf4fc584be5693baf95dc3030d04(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8f0db29a18c77c7548e0da747ab6c802ff845f09c93b99e070182096679829e5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__38643110bcdf3c36b2c1713981c69db52fffc5b3aefbdbf8b55abb4a8c3ad669(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a21db23299a76cdaaaf2333e60a16071cb96ac59a208c1f56d8ed42382f9ad0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__870e8c266d1e419fc8bc6ba4a57c9471c69cae0d31a916e8b06494341c031c6b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareHsv]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dd216e69e8ea1556a8a46c0e29ee4e3df7e98256129783f8ade7a38071beebf0(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    dimension: typing.Optional[builtins.str] = None,
    dimension_var: typing.Optional[builtins.str] = None,
    equal: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqual, typing.Dict[builtins.str, typing.Any]]] = None,
    greater_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThan, typing.Dict[builtins.str, typing.Any]]] = None,
    less_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThan, typing.Dict[builtins.str, typing.Any]]] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__378ae9720b26a21cd264ff6cf97a7aada4f2ea3ddcccced4eeed78f9132d748e(
    *,
    background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
    chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
    composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
    compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
    contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
    goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
    max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
    opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
    remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8c0c874c5586f85362216ad9092862399145f4b88367756e1a617df9f75d5ebd(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4578183470463584307c008c9b78fbcba48ae3039d1e7dbdf20ee3c8bfc6ef07(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dc9250c520aaeab29c2e9b7e2e405592e40ac0e3ca1d095c89063ef9df8b08bc(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4d712cc69cce539e3e5611e0df516182e28369ea3630951a82b5b770176487e1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fd5b00ee37c0d863a525831772d33e9d0071ca17a18fafc1c43581866db9f2cc(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ce45f53a98d20b77a6d5dc2c8cd21a61a4f63940ecd23bdc8a547c00a54246e4(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__29b1df3b4b4f75a1995c9f2b67350595302f6efeaca929a7686ae7ea3537fcc9(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultBackgroundColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__caa7e7dc6aed84321a52dc4dd480ed810a3ece29e317816bd00ffbeff7372aba(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__035d889de5e43f085ea0796324bb0dcaab131e87129293cf55a87541642a55ce(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e65430f6a05df680bcf4664a2659291db0f1a74a4fa1f31cc881428fc6505166(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__26a223b293a02e5400824ee7b35ee906390dfed18c1bc5320677ada5655af849(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultBackgroundColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__450ae21020db30bb866be805e39d06f5d374f4f244f36a5098ab57973a3c0caf(
    *,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6fbe87f3475784ea75a31e5625a99db6829710b3fa90661baa9d6b81904fbd0b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e67593d1ce88f130c3d2b070b48ff05c6f8ce81b763df8f42ebaf8d315289622(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a51e209ed44d2923c56cb2f8907c3647fe1885d7b6f389da4e353c3281847e32(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__96d02651e1d9773d66013b0acc61300a9e3b349fa7e9a195aba31d9b5ab32590(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3726229b5c9bc009c15dfc7c17dbeb2715e4046c3f1895151a53cd4e5581c8bf(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__69926ebfc6d42349339cd137cccb5078f4e48ad48d4a0382194104bca1fddd11(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultBlur]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5557758617ab22d25fef4565adc5f5f6b52108a1b734f3087bd06a4beb62018e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__877a3816b8f70517f0e9677429e3cf70a7451b92d0375373ae5966f7467349a9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5bc6c52090334c1c9269e806822cdd9d053ee420735248ec5e22cba1200be816(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a158d9a1d89fb02963ac3a4d32b8cdd2dd8797bd80115605940d297a2e0c8e86(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultBlur]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__806d36be01ad8f3023f76d696bf69bbe6170e5c384d046f42f0a2a99cd787e81(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_feather: typing.Optional[builtins.str] = None,
    hue_feather_var: typing.Optional[builtins.str] = None,
    hue_tolerance: typing.Optional[builtins.str] = None,
    hue_tolerance_var: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness_feather: typing.Optional[builtins.str] = None,
    lightness_feather_var: typing.Optional[builtins.str] = None,
    lightness_tolerance: typing.Optional[builtins.str] = None,
    lightness_tolerance_var: typing.Optional[builtins.str] = None,
    saturation_feather: typing.Optional[builtins.str] = None,
    saturation_feather_var: typing.Optional[builtins.str] = None,
    saturation_tolerance: typing.Optional[builtins.str] = None,
    saturation_tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__93fa4754f597f31fc0a58435db30b1a7c77977bd7afd7a18d73d10c6f54a6029(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e6c24849cfadc3f03842809c7887f7685ceef07f960c7353b04b8146fad22df7(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0d71b110083d6578758e5d66842bd1d23693e73ea6ba6bd363c348aeeed679a2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e52b645bc077bf93ca43ffb924408f89f5db843b5ae4bec11dc33fcba466b578(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__72b084bcf4a21a448da1083d607acfb99ffcdf81bf89ed45d4891c64ae6bccfe(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5cdd7ccab359967aeb66fa59244790ea3f850e90b14573f9de1fd0a93086808c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultChromaKey]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__769de7e545a2e96078210ee720731ba4d92944066f1ff0a73ad3b3d6940bcde4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d4c3c00773d45faf8f3a0d34145a6e72cebd7eb1795f8fca3bced2f6c0067cf2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3224bdf88ad21a43039496c68017d3f6ea5ab06bebef36418a53d2242c9f85c8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__82d09303e19927cf7617114dc0ed1422541af081899dd6912d0b31a99093a68a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__13bff16c2b74c848f61b4cc6b2bcc13341963d91de7f6693783ce4957d2a5805(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eb0a1b3e9a08ef6c7e7f1b0911f998d9f38f24c719c4e76ec7dd5df011e4d252(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__593f9add2c1fcafc3f055ed1dd7708d0b7ed6ce81a30e7088835de886ae75459(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2f16c247cf9c7a1201b9fbdcd8aa1ae766db7ee365448879873bd13d74823b58(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__00f432c54b917cb5e6c454d3f2693a0a361f6ba7007983e009444831da839a87(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__88d15c666ea8a11ae59c00644c0608ff7ab70773ff522b2849f81675d51d74a0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd8511be5def94aff31856d70909a676b371763ca460d63fe1b490b85a05669e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3221e4fbc6b671742291091e617f0e3d290763093b4d764c0d916ed1e1e2ae77(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__89c403ce42276b87b823a64b17b2cf00522a7e90c666075d01d2f47baa92635f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1c5cecececf110b2014fa89d008adcd41619629d9d665a1254efaa4d3f9aaa48(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__357c9a5d4b56d170425bb7cc62c2baa4151e3620f4faf86335df78f7a879d9c5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8fd3c6cee6c20d2d9422bc62d4dd0a5f9638dd1cb7a43fefb0d198042af99e78(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultChromaKey]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__331f03d0cfccd77a5389ed6950575b61eb5745f35286318d94ac3051be9d7544(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultCompositeImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    placement: typing.Optional[builtins.str] = None,
    placement_var: typing.Optional[builtins.str] = None,
    scale: typing.Optional[builtins.str] = None,
    scale_dimension: typing.Optional[builtins.str] = None,
    scale_dimension_var: typing.Optional[builtins.str] = None,
    scale_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__08c54be6618e30eafa521a5669715a44d2a0ad4433a58ca0efbf8113398838b2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f8f24866f96066b02bd82696512797720b8978e7d2d7ba71120a7c006405f450(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultCompositeImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4cff544e9af14b1abfa4df12e8012c1e4c4ad6bff1ae2ca40d975ebb0f1e1809(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d0c6cfc5d6154edb2ad9a3b100d1c3ad44b8f6776731de7f5f699ba5ccf20845(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__958c040e1db170547cac738500b172717b0efb83670068e8fc7336b2806a0a53(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__138009b851ed8b27919c093bfccd6d51f9396bb8dac0534cc052feb64fac2ec5(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1840c3b46719185a294c3a849874a781c113f1efb834523c400325c235da965a(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6a9a56d9b8e4bd54e856a153376b891c81ada478e16f3f0b058f4be938e7526a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultComposite]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a8cdfe6f8fc7d95b84946ee5963f5a3d970df0e671346f39446f723eb1d407cc(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cb066365afce230ec516152b150bd73e0cac7dfa3c12b5a625eeb9eb0f5f1bce(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ee13f75ad3829e772729569f4229995dbdb8e9466d8d8d5ac5c4ae4b91bf2468(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c4405b21d9379a0b37733f5a5e2e0466e23da470859c2e1f7dd73bbd553d8ba9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__98949c7c3fdaadf589874c1629d20fdcb0d664c4b213903544c05b6f2a456dd3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dd4ac3e9bda89efac6531fc57fd1464bc5854ec9cf8a131e6cdede88147c59c8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d9a2f4236341d0fb0240d615ffa0d296f8e87c48080668d35756ff8689bddcf0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__66c5b6f2e9ff569bc01b4cb45a2489c28af067d57f9e0f04de360842e86e9688(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3365829253ff875ce08a87506f6f348efe37c7168eee3c01ae1d1efbef3905be(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4c231b21e906d86b41eb03813846ace9e1485ed194f5b55c9da08291f7874f15(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__10cf955ff8e5cf751363cbcd2f4494471d7e38d825065a7f042cd5ac784d4dbe(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5245a0b4366cf6e3455f94bbc817dc0656e6a5b74b45b25c7bd847787cd294bb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fb1589dd6322a5d2e9d38cdf32081685f7f2bc52b40e1d3dfe2da52b03bd3d4e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8d9d6032633534e39eaacbeed9babce785b558a4a4620c589f1fae2b1c262938(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultComposite]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bbe3459d98c15e3416f9e93e8b68e0ef4af3741177a4bc8d061e342319ac42d2(
    *,
    transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cab375127b6dad94b122effb73093c92317da2fb638a733f26d32fb223a45108(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7039891800924d21dbcefed831106b10a594705ffccaf1be3218ab93a492d8da(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c5a4cc261412b6d0ca493fa9ca55fe1d76990e1e402a52c768611b9cb3dab32d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f67e88f929b5e11dab85ad7f61c488b62caf0580b4031262baa8f4863858ccee(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__70de3cb22f32ab8e3925af6ccd22b39727cd39abab4b6c98cc0940ba21f899f5(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c3d3453df1171888fe63f42c1220613969f4fbeda3baaef0b99e98e2d1c42f17(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultCompound]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9c04aca2c616030018aad6b9ebb07af3ea2f85ec241ef625d4098696918af5b3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b8a5252dd9ae4ee42f4fb563c82db4ac594d70c6e0a5e4fc0bccfb062d3d11c7(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cfe9503adff467e5dc42872fc7492db13bfc6202be88bac120a4b8abf2edf12a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultCompound]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2f6b29f67219b541641817defda11c296e9a17c6472e7671c06191f014b9e973(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8ddf9459eb3ce6df92c8b617bd6a8f8b03d97e7a45d01973def55c2f547b541c(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac5cf07291cad2999c31e22675e23d76d9dbe6cbc11d3c69b96316cc2b347cc6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4f46b33a1723832caa148e080d8aa53b9e7193543cb2fe0d5d50848398be2502(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2543951c8017a3bebb0d132a54ebe7f0b2b65aca9e7faf4b91a9d67e0ddd7541(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b4d173084e1de34fc0c795e64970ddeabc080df6b0a5b7f5759710c5dd9e37d9(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultCompoundTransformations]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__80a5f0fc11bf273413546477e94ac31aa634d6ce302884a30b89f228504060f4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3f82db996f7709ebecc5640829cedc8afb4713693bef0c33a8b6b13bbd7993d4(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultCompoundTransformations]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ad2e52dda1213d37daaf233b1155c1c2901d9c6b78b8188f36161e7e0ee5ee00(
    *,
    brightness: typing.Optional[builtins.str] = None,
    brightness_var: typing.Optional[builtins.str] = None,
    contrast: typing.Optional[builtins.str] = None,
    contrast_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b588cbd690f8273b03368da0c1da61b9b4f2fe5231f76d4342b817106ec443f1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d7314351da9894f00260af6a372656587c601a038631b21230bf99fe69736e7(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cb12478aa3858a7e74909799a098fe0cf3c55fa862998ec9202a16cbde5183e5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__468fbd5d972abf0c9974ce457a27f9e7855dc5abaf52797d7a241090030726c9(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d6ca00407a17df1e36b6fbbbc5accbb0b45c81d35b691ea477a598443fe94486(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7b9b5058ebee4881c2efc898975c30a6dc860745f45998d11a54b924f43eaefb(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultContrast]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a4c888d39eae478f32879923980d359991478ef99f32b26733be9b68082e064f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3273c88cb97c25dbbe1d98eaf8ed068800f8369417d680ecd4da000314186093(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__117744d250c029fd408f10048543424f8ed9eef5e4952df232cb896c1c143a8b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a835cfc8aa58cd845fa8d63a2aa728d14883cfd22b211ae2b13ea6d01fedb070(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d4c2d8d37ea9f099eff59caa798047b7b7e5af3a88644866375948c8d03ad544(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__18ac913f15fe02c31c27c9813ed20f0f862d2f09bfaba394ea936be6a7b79817(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultContrast]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b5ba8dc606620541424adb036476fb761757c8df02a275f704b8cb6dd86b058d(
    *,
    chaos: typing.Optional[builtins.str] = None,
    chaos_var: typing.Optional[builtins.str] = None,
    density: typing.Optional[builtins.str] = None,
    density_var: typing.Optional[builtins.str] = None,
    power: typing.Optional[builtins.str] = None,
    power_var: typing.Optional[builtins.str] = None,
    seed: typing.Optional[builtins.str] = None,
    seed_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df9a8966afe37928531f4123bcecded0bb2ac67d32d740a75539ab853290e22f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d023ac07b3ea50ba073ca25983ab6e3be900e756f7c3985a06c8ebe5a8ad17c7(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__031b631ef3d1f58534d73152bef8ef40af9d911f0b71d8d2e93d9f53e3ca78b3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ffeba32c0ffcb561c388621c66af46dd70baf8bd301f138b55d3d2d3faf62702(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__28d1f6fda604ab966c53adb3cef0c5b459937fe44e5269ae17412ef91edcdb02(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__102b6a56b583849481de864af3d466e995e42b1ae0522984110edc92b3ce4f4e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultGoop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e1038a53f60087afacdc06bb884a9ce73ae9408207be3300ffc7575dfbacfa5d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d8dde9a94b2f02f7f54cbbf58579b739854bf002ab33b3e22ffa1002c02e5ad(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ee2732ad667ed1f7dacb11cded52f89d5533af099a3dccc243f4c72aefed5d8c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__03c0116e440825740eba1ad27afe3055d2753592f5ca3ed77a6ecca3b78ec309(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3809dd6640b03caca5cad9bfff4ea2d6ee181c96db126c880c426a6eaaccfe35(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__07195b557f70fd1c4a67e8418039805111b91aefa64feddf75235ac27895ab34(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c98f250e180f47f429c569d8eac901e48e589013dbf16b12f71ca6ffb289db13(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8e3e8decf2aaafba44a28683c2463ede3710af1d03e2036db3a5036b85ecdf44(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7946161565d24749d6662764916d2e88492de47a73fc87008f8fcafe6316ff20(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__02a288aa55021a19ae6f9850e3f7b315f771698fe1bae032c469009a96585275(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultGoop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__46dfc5c080d4b727c53e9e924d75ce3c05bcf93a6c673f28bde482d983117867(
    *,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__305212325f824faa5d4090c9a7798a7daf4ace27e94aa83f0b6adea6cdd6f92d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b41d249ebdd475e935b55b4a1b37e20db22aba64d434606c957c7093de0f8d70(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2bfe3c09406670ca2cce150b517336dc8461e222057d1cdb3a1023e46f9928cf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a4d803e7f2269a99efb6bdc16331bc27ece1943d38c2e30f34ec8d97cec82efe(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__172b5c26d662b8aae5c27c0ea93352a49d7091fc59b41fde859b2110fdf025e6(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5c9f93ff5717d39c86a5cd379023d444b6daf3189a351637081d3344ca26cd94(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultGrayscale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f9cd6843bc4099fa42cf84fd7571f100ec5a34f777ddcf964252289956a12c16(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a52a485ee574e282da7814de7ab69000abb55c2e2662328b54559631b9abfc05(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__529762f778336ee7184e0a6f752b47da917ad001bdcabf4fed5baf27b8ff5545(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__996684303f2b2a068ea062d193e731610e58b55a6d15ff268b39f7e9f752daf1(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultGrayscale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__40e0264878007ed333d161cb78d00a993697d61817dfe945917882902475ec20(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness: typing.Optional[builtins.str] = None,
    lightness_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ef573b26c79446a2877a777729019ce48401236ac419aaeabf36839b6db4b7aa(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c57c6e036a4d4f2898f062fe6dea31ad097d2b1f9b38193079fcc796b4ddf61c(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ef3ceb0c630749ba20e5ff4ce7d9b8c022647d1a6326f27e5411ac0677beb574(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a51c18e9e151f69e9b5d284e9c1c25aa776afcc03df10dccd4ae90d2c9b5f213(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4d456edf210c08ba3435d9512602feb3afb7690025a24fc4e06be94de84b2800(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e2ffba1a89be383223875e2f8b0889f1a5c6dd0822818ea9078b92da490b3d04(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultHsl]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d2210817f4f38c57bf0648114a1e320755655829779d087389f4fa3447fe3b98(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7b5e8afdbd31a64fa3d2d4c3296e17a0d0e87bfe89b0f4e9fbd48b978cec1a6f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__48be0e52a872ad14dc9f1622d2623143fdbf5e0b2bbaf40295a1556d4d361f7f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cf5448a6180784910daed3c9297d78d10f42fa1d9d8336ba9d049c785e15f6f8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1ad64041c557edd147a9ce4f2651c47633c343b71a521730021e3117761857b9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f75e56055b37968af3fcb2edddf1045f67d9c1d8b9f05274eac23ff114b5bb2a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3d4857ad6d991c05a8c8571a44c9481efff617a7b0bf4f52b26ad483eb4d376f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d743f9159d0a2a02fe89de059271fbeb778cdfc8cb6eedea6e11e5c2b48da29c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultHsl]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__760196e2171bec33e4ecb865c3bef6aeff40ebf06c34f7df66ada9be1e350848(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2cdc56708e5bcec10115c64e377b52e90fe48b8494ffa8e183800ad4bc5a9b73(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fd52402a15422685ba887503b24829caf76ce468627139df57f0a212fcd6a2f1(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__07f63bc68d03774dae601c3dc781529cbe2de0d4efe7eda4ec80fdea4a5cd025(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d98add280e964881e8b9b2a26696e1770198808d3432cf7695af5bb7b81c4c35(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6960e0a5a6857973db6ed1a2ef5c0d936826d1094d968d5c247dfbad6eb18b62(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b5c8c04c5fec7b5f1af42b91a571fa6995ea9c60c6ba992e56d7a5f7e83a98e5(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultHsv]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__58bf48114a1e5bdc50dac446be4b4de1b8290a51c8b6bc8a3301e3621ef96886(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ffa3f908a7659077725a81dd464535cb3a4b958f2923985c13ebf604c150786f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4741d867d9a9d05e675bfceb7eb315c9a46c8d14e9a27f6b42e8af7d1d2515e4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fb86565a7d01255a906df6001f47f9cafdce8908c952b05392699ae0f1a057c6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df716c45f61868acdbd423f9617a97e84c39f24de723e29ed9f0e13e2f3a46d8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0d698f545365ade38841d32737a3b678bfb233687d922559c1481cd657a95d9b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__68dc6be063860a19e276f3d13be0679707af605c099d1c2bb7c4e80319aaf013(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7fbffe6bba4a45a75bba16446a8d8c1dc92be7f2bd569da971cd034497186517(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultHsv]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b091d9c6b5b272d07171e33acad77cd4ffca3b3fd446544b8da3c475e89eb470(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    dimension: typing.Optional[builtins.str] = None,
    dimension_var: typing.Optional[builtins.str] = None,
    equal: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionEqual, typing.Dict[builtins.str, typing.Any]]] = None,
    greater_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionGreaterThan, typing.Dict[builtins.str, typing.Any]]] = None,
    less_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionLessThan, typing.Dict[builtins.str, typing.Any]]] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__54a91cc572edda24e35f491eaaff98f1bd5220b1416dc35dc35894f05dd02d51(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4d813a7ed6499d7ede868a914c36a2586982596ceeebbe1a7b8539d9c85ab982(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9b0059c6c4a38173044037699124bd46bab106fd99b06a9878060583a8d3c92d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8eb572d458f76363c07f462db348c40c9b2111007d1e6b2b7cd1d0b2d4ac89aa(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionEqual],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__23a618edab7a462a9b156e080e1d805810ef0dd55b49972409b50ffc419c0199(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__22870b2f592214fcc53d64d6f7bc3320dbbc43acc96e5c41b8669063cd9881c6(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionGreaterThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3d26bc3bb5f3b01cbb719ab5cd1336529918055b72a2a21884fd2758228995af(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b878bb7334916ad13b11fd6ae45c3d88eabcbc68adc6901e5b4df63d39eb7d20(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfDimensionLessThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f59d1b1b6cb2950adc5fe7c469b35f0856564fdba7d94ea343c5d4d52b7467af(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__00106576ca05ff32b569c20a4412a4fa5f261f64181426d95902b3818ad26cd2(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__efbce9fb47b8119115abe68a9618f52caf6e592c98d0fb77f65d15d929f0058a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c1267db8d4013bbdc25f06815959d12ce9b3f2cc4e0a642bddd2773d4801a1a9(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__544dab6c96c550d2f1e3bd7c830378aef62952edaf52c020e1f480609e4762d0(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b3dfb5de8ce4cd458be672f0fb454d9f7a2b6c14ef0572d13f8ebc233a2597f7(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfDimension]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__23ef456b74e8562d9a8dfab1c19cc1cb7d43aa3ad67b1d8e6007d3d5f8b3e330(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a105b8e02a871d6d0c525eca77199597b48267f5c42866f381c95f938b52ee1e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ff07060c3a0446b580d8994b6ea3209d3c09024b67c46d53028d65bb2d4373bb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d325e61e447fe218d6122620f2a91949c77a22907f1a93ad79c287632f93a23a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__086c24dfc3ae8e7558a2d50d9a336f43030a6017f5a64c8cc83a69ab634deb63(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9b4f789639451b67b8d00f34405c8b0eb1ca23472f1cc09992a84f7ef8de29a6(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfDimension]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__237697e2318fa57b7643b51d9c7717da38e0661147d56559ecbb4c9f0c8db87f(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    landscape: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationLandscape, typing.Dict[builtins.str, typing.Any]]] = None,
    portrait: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationPortrait, typing.Dict[builtins.str, typing.Any]]] = None,
    square: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationSquare, typing.Dict[builtins.str, typing.Any]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ef4f94e6687b5d04107b55121d6b33d764e79af093acd47d357b2fd5e2fd0c8a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b97ff7cbd3394a2e5be92a3f78c14ee0d057a5c74361a8bc14a2bfd95a5d807c(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d493d9e094fc361bf97277e21e9c3957bed3779762275245d7211a81a5b207a8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b3a4ed3548eed24d2c237a26e214515051d709082b4e02aaded474691ceebafc(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationLandscape],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b80801494d8dfc3afcbe9ecd0623a09fb920ede9a5468abb96c2774052b162e8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e73eafb5957595bd5166ea5c646842da20362e4500785c8d4051e73f17f54203(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f3f826bafe7e0f6316048b4f85c20c6e781e95f07f7fd0001e339b428f702950(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e7faa3d3529759237922119984e94540b28cb37793795c4f744e93a7598e5f94(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b69862d0d126a67e3ffcf0c91a25796d33f6ccab35388eeb98b4c26aa493ea49(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__30468cf8db039810fe12b1b4df43e5221446678fe51e9b4429bd6599da334584(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfOrientation]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__397e83c36654858159e4c0d2d7cd28c4d25ef828918170c236519d592c44d893(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d6613ba2359692996231a365407c2155c50f33d33dd328713a9b8f5563632728(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfOrientation]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3929c20ea2e7aec76e4542175da1c33514ea906ef76ff9d5f8564ab2a10872cc(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0be57ea9b3dda5f7d00466a6511191d985c67e0d60824ab0fb678da0ddeef58b(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationPortrait],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4cf0de67e44bee121d47e248f44af1a07040dbc421f8794194e9a359da0b9e1f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b952aa1ebacab85716a05449cd054b7a6469c269dd282a7c4e404a992652f666(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfOrientationSquare],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a2bba9b10df9660bdd6dd5fed0681e72d8c87a0fb6e22666174f5dcb91a6adbf(
    *,
    colors: typing.Optional[builtins.str] = None,
    colors_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ed51aa85db36c830420daab62d329fc5da948224968064554528404ed2f477c6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8b213b2473abac0b6abe644b2406056c98a222939fc6fb13c2dc0bd832d753ad(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d30887086a231c776ebb0c1bf42931d6a60a0426f50959c810ea1a2e40b09725(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7c180303d40ebc2e40a64ff95e60c30df534e475235f304e3ccf0c9a7da24595(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a4763d2f61a9d03ee82da8236e4ab522609bd8a2c518dc5c4898e542a380b748(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ebcde74e4694103bfcbae924fa62ae24dfe83bfde25c7f0f394a3b2c9686b2ca(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultMaxColors]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8b8cfce98427ed52e5f5044b6ba8de21d20abddae92802e89c9189db5b78265e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__42393e5133a4621b79efa1c132497c1594f42f0f192089f64e436e39b65967b8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__95b85d17be750edbebb4e18dac209f53221489bd091e2030b40b2ca2f67b53ef(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9398dc3f65f9e165a7ab42e6c7f84c3196114afb82e10d5486df5c7b81c5b984(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultMaxColors]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__390430ea7d5daf35fd28f2918e01794e9c641a512d943adbd37b5ff8613119b8(
    *,
    horizontal: typing.Optional[builtins.str] = None,
    horizontal_var: typing.Optional[builtins.str] = None,
    vertical: typing.Optional[builtins.str] = None,
    vertical_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__39f76c49b6b8de4fa6c2df81b0d847dffa071e3100b24be04d82d48c00e97b31(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__79d34de655dd63999a778500071a4bdb2e8c43e1661c6b9bb49dc2b11e631d77(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc05d51fd80beb16c176dd0ec53ca7555e8658fc8f071b98ae2f8c726388740b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0492df0f01a7ca821a7d72cd887f3f1916de2f94cea49982cd8de68793b62a65(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__58d587bbb589bae78ebdb64696adaef29640609fd8612949c8f5b56b08ddbdf5(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__08bd2243b6296c02e727532ed42caf05530129187a5c75bdaeb56b0bead855b7(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultMirror]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__024bf865e11b7a5e2d3e332e0f591538f02e1e51df80ee49fcbf4fd23e09cb57(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__445cb5d54e5a535d968e590da9c8b43b44aebc1ac54c8d937d8d8fba42312853(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__deb3d38d24dd78baeea6121c088fcaab9af9981ad2a4fb02aa4ab79f77083872(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__67aad7226296ce5c54effbeaa42391bd9df86021542c5cca3265c133313c1ead(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1bc0359fd8c3f9561d134094e915cabc5dc8093ea10b42cab9c41909f6faf953(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__25354ce00192d3e3cee3ee2644a22ce4a626b43f2a3efde9f3cc6936f56be3f3(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultMirror]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__224a8e058b902ab61cf279b0d56f3bec791457c0664fde69b656b40b7c7b09c1(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1faeb95996dcef09f5988bf342cce9cbb909a7da34209ba7634d4f520e999f29(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0980028272c4b6c3a0d7cb53e70c1a43ae9a5fcb25f0138962b2c2e269c0d01b(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__82ff8e4ea6820177930bf72d537d438cd077fc0f1196337e06abdfc6aaf32be1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bd955b69d9cac34b77a184dc1a8f600e34561701f2d156c991350fae54e021fd(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__45aae5a4a9c1f9790dc6184352c4b58d466b4a2482b6271c7c9a86b10ee16ed2(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d8fcf31d9025ed142fd2218347b42d9516d9b6fb009f297c5d2914f8f23335f8(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultMonoHue]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb83dc3a47510ad07dbb881f3005981c6ff6b7dc0bdde7109eb2efd694f14bf9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__07c6d5fa0b869672b22d5a8e0c91c6599a6c08f1d7b05a98ab23735c3df5316f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__75ec1024a6273659372fa18779f28b5b6bd5ac6def7059774bd3d170b77aaa14(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a71cc00418d6297d69eaeece40bca85a3ddd2ef1bb1fcdc3f6e180190a89360(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultMonoHue]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c852fb59c2d4d9a7b1f2ee9ba6ecb02444d0016858e87323a19bb6c09080cced(
    *,
    opacity: typing.Optional[builtins.str] = None,
    opacity_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7312492d1640422ebfc99601d4005110ea3801e22f9f4b085eab8b17aa6223d8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5b497ab39d91c8a8a1b2a525f7bf4eb2f66e39a9be5feed1f770cf7e12e3098b(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f3caa48bc7b485f61744a52e50360c529f2a9bc731b4175c45566b8c63789f42(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__563048d3d51a16a176c17d63a7545d91e10f819f77e11b6975334f9f93e26c0e(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__90a09254bcb00a53a665d4d6dd97cd6595017b4238d6a74445da178c03f7440d(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__37b04f173a238ac059b6d44d3a8e21e284bb5ca44360632464fa26b42b6b4cb9(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultOpacity]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__304b4eded9ef3c49601c9428a9762700209dbfc33edd38af45101a7dc02c5f3b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__64eabc8db74365b5dd9da41b97a00f671b59b58eecd1bcee0b4140ea6778f6dd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f1ff4132a0b09287426316d8711f7423e27b356157ca4ca9328d1cc31a2dd4da(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2451b6e06cb93567d0e0a7641b9b3ecaba3cd496b4f291c1f8ad6588dac7f47c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultOpacity]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5dad12cfda8d905c5e303bff7f6493382acfe4404b10f38bdc6bbbe454ee741b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__71935e84712ff1d0c5d17db73436c6c52963dbb246ee357a3538bf8072c11385(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__530302549aaaffe1d8e13bbb1297774d1d1925c71def4aa51b8ad1e7e199c223(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultBlur, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1e39c277c511ff673cfbfc108896e3af93c30323ccd1b5fb4386aa230eefc1a4(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultChromaKey, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9fe7c09dd26ccf0696e3b37d686d2f2f35d6d5feade5f1fd7659c0a78651a9e6(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultComposite, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d0d64f2a62986b515ed0c3c7dc92b6d59be41cf545229ad308b33575c01b760(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultCompound, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__76458f862d908b263fa2580a0020aefd8c98bd954903737afaca07d99adc2b9f(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultContrast, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__adc9a832781b0385a4b0e5cb7303e03f59f75e8a3d8235d46ed452b33ee622d8(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultGoop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__384967d58623bd59e36e925d4536305705776f41941a3e91e7ef40dc14d4b53d(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultGrayscale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc705c5b29c54d919f74a0d8cbd50cdb88fce181216fc456dad265b4f48c3214(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultHsl, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0f3ea7bd1ae6f52466ca22ed26fb32d87079203642acebda4450a1ec471f81ac(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultHsv, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d449ab71eeae470fe9ed645e5f7d1b5f31e67ce24060c2ea2013c47be4d04a89(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfDimension, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ebe6d1c405a9f0e2dacd88221124947b004b3c8ca1fb2eafca7aa5f4fa877af3(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a0b9e8d46707d0cacb9a1613a4443be6c5247ce24279870806b7f6f6e3370502(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultMaxColors, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3c5a9df2c3ee8ac0fa1d394b7adb51363025a1970be870f3a7b32c8b1f6fdc13(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultMirror, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b689ad11ec59d4b2d741853cd4d87c040a2b595c32ee35d588d6f5f3b7710515(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultMonoHue, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f0ca9fcc207cb85419b2b6aae7817c863e64d3ca4cb95ef405e09e373f9b39f3(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultOpacity, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2dc2c8e3ab280f5e85abde6fe1ab040668daf89122ae1e5d82d0b822ae2137c6(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultRemoveColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__44e2ad6aafaf8b37f807aabbe8beb70866f8ec55dded2bcc734b2afb5196716e(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultUnsharpMask, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3dd60dce6c3b2ffc2302e87b415c767d6550732eb7f1f3008b93a68308990124(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__60965c311b364fb9ff6c7ec1f2055c1223280773a283b53fa1ec145077316b4c(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
    feather: typing.Optional[builtins.str] = None,
    feather_var: typing.Optional[builtins.str] = None,
    tolerance: typing.Optional[builtins.str] = None,
    tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__52cf7898175b97b5c4338a179028b5ca7915d549837fb328e751445f5d403e5e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4aa07d2865ae6e0e6ee7b9eacf91ed309684b6ca9ddfa5c4f330b4e170285f58(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4f427e54892b4aa142a761057d2bc3e8570cb8bb87769978df74c460d646ef68(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c88cbb927e62012d3beb4b1fd021435a52e7007f3c4193d4b7a6ae09cc30c62f(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__792cb28bc2a7c6a2789022ca8ccc8d228a711a0c8e720e701db77b1383322c74(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__18d01f684557275da5f997ba0e6c58131c139f321d6cb0300ff7a44a5d421041(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultRemoveColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__28eeede4b37219638ab8f1eaee3a8c95a2a00b1aa05bfc625874bcd13414d7a5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__830c06c8ebb8fa9f55bb9d396c14ca89b211edbe659266d8a6a5615df78e7c48(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4c26cb4534c470c192fb17a6d1b4c5c756c2c5e664129d871b8c784f0364e2cc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__31afc8bd461ac2edba9b0218efa2599601f1368534b82a0c2bacf86d7cc6d8e8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d253af619f0aa025482ebd259e2b069854daf196da5331d7df316289b2280ecf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ff6e5463304b9c02fede73331f4f4765de7c2ac8a0a77e62455996a0c1da55f5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e26d3483261f9df724a1b536de8a5cad89c4aa4f392991a91005382816b6f92c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__da56d02727fc9946e5edf4378ea53872499afb6b4f5f7c919f85c45a1ab048d1(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultRemoveColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__632e277301b4ebc6c75e88b52f88db04bdc20d8108fdfafb99fea5bae28f7ab9(
    *,
    gain: typing.Optional[builtins.str] = None,
    gain_var: typing.Optional[builtins.str] = None,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
    threshold: typing.Optional[builtins.str] = None,
    threshold_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bf3837e364c39ae06c320d700d4ad109172a6b2580b0c550e8cd082dbe6c876d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__655648e19bfe1ac8f8ef9e8452b37fe869b461166c6eab370629e7222ff78315(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__616bd5557d5c79da346618c4c6f57fe900b13f8d62cd238987f165020903040a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aacaa55ff884e24b05d8e6ef6e2313fd0ad1e49b5e12089bf3498c031fc2c860(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5df5a8b79b9723ef581d4c64d7183215f351647fc7328325ab8e995d5e3d5942(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c67f6645c60aa4dd3a4ba8a93d391f355c66fe9d73aaa98d4d378e33dda15da4(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultUnsharpMask]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__24f562abd8a6795fbadde0669a4a3d580c64919c5d81d4658846051f0a3e09f1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__97221a0bb56eac26ff4b292d5684f6f7c9abb154c67c0b708a44166aeef8081f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ac6689ac9c46fb412fd59a4ff3f3a3ac2a6996ed54aec549b3d937741bb2641(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0b106132b9c3f3de999c3346a2f1e86ec85e334b67eb9f93c388967c5159d65e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6779b9f0ac7242fcd37b6dbaded810d8632fe7a49ccd87f5c05a829c1078b8ff(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5b4f306ec06b8fc2ec5573413545e33c94774aa1f633989fd6cda952671049db(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8803d88a5b08b3096ba6126af2393d5cc674da864dfebf312eb77d3c894ed0c9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f4bd2200d7790d7855df529a987bb0893bb91b7beaafb953592e7e22d65faf0(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionDefaultUnsharpMask]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__38f68342eb83e1b42b0b16ee18c87094c3a0bc13fd9605719e4b64dad8a2ef33(
    *,
    background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
    chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
    composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
    compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
    contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
    goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
    max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
    opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
    remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c922358068dd186f1cad3befdfd4588c978b0258d3f3888dc36543a049c59f26(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a8d5c5552a08bf53a7b03af90ac577b9dcc5ebb27f01b6dce228dd368793fb47(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4d038be8766c3b8f75832f8ee802c559798b5524fb3b92ce6b1ed9eaafc9c109(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c555b2611afc362e9fdabb3c72f2365c683bdd1e3711c49762e75def720f4ae3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ef27b7d55e2ec4537aa192c9f3f4ed1a084aea3d975e36b1a8f1ef8365430a09(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__216d7285c4c0ddd79e60304ce1518237cf012b9bcec0da9a3994fcd92c109304(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5821815cf1b1fc43eb87912a1fcdb1b038e10d2a2680c1be92b848164737b15b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualBackgroundColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__78eca7d31679308eca76b94c212e6c206c3db44d2c2791c4311f5df72efbb8b2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5c71ef0b80d49957d574726b7c71de9343fec779c6b8832d6314a28c30696e80(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e44efb49d9457ff68812f3b25cba152073381a06dc47116c6a6cd08712fadf4f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6475e3cfc050311837874aa5c356ebd078c815246a0589543887ca87dad8508c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualBackgroundColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c11e17e5a78cec1067deea1833fcde49c2282a8b706e56a7c01d2084ef5a6243(
    *,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5c0a8ef8d6441eaa1830de261626d7386079c5ee890a562a133a25fbf8cde27b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dc7c141620cd736511accbd02cebe35b0d7f746b0cd574a66ca80ffb78e15cbe(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a359c3b4f88b0a1b12e630e1a80b88de4ab420bf1d1785ec432dc46e23f6efc7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__31389ae787a16761d5f722dec9e4a06f0922497a92b539ed8df07318acd3b8dd(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0b3fd789f0fcb4d5d48ea1f1f7e032ec457687bda451b266a65e096ced275d67(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2cd2310009130f251ea5d5f7869982aff1bb73b3faa3f22d50687e3392eff804(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualBlur]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__beccfec7b0fd92026b60a7cff9ace590b3a197083057f275b776eed7519eadb6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9f8938bd5549bd12f689e1e3879e4e16b28dc3023b59d5d858cb47a78accac01(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__246daa1cab2246c2436402face5c34b409819b87a4cfd5c374211c817a6e3184(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fa5e972c643ae94607d744145095ee6d609dc1d9afdd3359efdfa75f3361cabd(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualBlur]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c7351f9e98762ccc07336b52b1d770d439411fd492ec40ce4e15cc65c6f91a0f(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_feather: typing.Optional[builtins.str] = None,
    hue_feather_var: typing.Optional[builtins.str] = None,
    hue_tolerance: typing.Optional[builtins.str] = None,
    hue_tolerance_var: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness_feather: typing.Optional[builtins.str] = None,
    lightness_feather_var: typing.Optional[builtins.str] = None,
    lightness_tolerance: typing.Optional[builtins.str] = None,
    lightness_tolerance_var: typing.Optional[builtins.str] = None,
    saturation_feather: typing.Optional[builtins.str] = None,
    saturation_feather_var: typing.Optional[builtins.str] = None,
    saturation_tolerance: typing.Optional[builtins.str] = None,
    saturation_tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e6f9e26bf9c13d90028f5b1cf54570e4dafff0a12946bdb07a6601426b8a3a0c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e2cb2b381c29576ebff9483525691f10099352dbc83350585dcbb120a9785993(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__45515d25cc7e98dd18c829629264d6cb480fb979182a7e63cad06610b7ff4d76(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__21384da469fcb5d87621fa25c79946011ec1b871df216963aba125d6b4b7e37e(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fcb2a57a077dd5654669adb9c8f78a826567aa1bc78cc0a803f66683c37188e2(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__44b2c3df6da9240b1835f04190b10d33ef595de8017b05f53f2b34a0247f20c5(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualChromaKey]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__45b21a8a6232fd82930e9afcd188eadec51cfb14d22e46e44044fbb61738c7c8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d79d18a8017336edbcbdd3866b5d92d1d4bdf001066ebf76dc1ad14c7b19dfed(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__57d700413fe244c9ae9d668d620bed22198870f9297ee92a8bb04ea54d8246ac(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__832b3a7f86fafe23cf77462e8860ea3ba3a588d42f239d115978b71aba9e2083(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a44adf9d2750eefdd793631a34c31261ccf1942d62cb0c45f0d6b4547886b140(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c1dc19c2ffa971516c899ea996bec24380d43c0fa92bf9978f08e418e572f8cc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__87ce5a1a85620a8501408befaedd56a04abbecea105c1dfe178a19df4c82acda(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2741fc7779d0465df985ab99351e2156e19a79f4d6574c4b92e981a3d97a74d2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a1ed7b1693f605aa11cccd15159aaa0183233daef5917c2e1c07aeeae231838(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__32e993aff049555875325973635e2dd1a8f0566d01ca83b125b27cc99022645c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__33a4ef8c7dcce1a724633cfeec2889a9070f6ad99a5babf1f93df707de340161(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__82aa0f6e352adf895249f8182958c6090499d7751acdee025f0c79e0c9ef6b6b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5b5dc0c0f0d11fec426075b948fdb0ab206293f1b468f8e06a2696c9af83d08d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b10f83ad7ff8ac83a2449749e7e15a5ed2c2056b518d621973b47d2a7a8f6911(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5b96d2559ba60e104deef2b5dc02f9aab58fa2f7ee0b2be3b115ea58a21e8316(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__331d02c6746a2a91cf921de1dcef2046b97c6bd24cfc5ebeb43c971a8f253452(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualChromaKey]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fde04c2c140d05c2566e9e066fa0663941f608c8841552c5a9274d5cf2977430(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualCompositeImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    placement: typing.Optional[builtins.str] = None,
    placement_var: typing.Optional[builtins.str] = None,
    scale: typing.Optional[builtins.str] = None,
    scale_dimension: typing.Optional[builtins.str] = None,
    scale_dimension_var: typing.Optional[builtins.str] = None,
    scale_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__72d5d9a052df27f52cb74717c50814ed630997a51d4ea136cbe18fbdbd9ebb8c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__807a395f1f07c6984c9f300b4e956cdeb25a95337f2fda0384d3102405c400e9(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualCompositeImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b409ff34edd5ae9e380555bbcc25131052ccf4874bffa5337fea9fea6f8237fc(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6b1dd1a567c3d8ac72751b8eed459cbf5177ea1285c3c7fc711c49cbf66af309(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5811772de176aceccd2a14a69fadeef529df8d099c118d3e03731f8b8a1130b1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aed5fa3643b6036487c1c33c19915fc1a8ac0b093039a23ce75024b62b31d046(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac4f21e322fe4fe6c9a1ed1dbcc531405dbb8209ed280f88b6cf98d8d72efa66(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4df93105bef8d64c0e0eaa6610b167efc00d555b195c686aa17db0e4328dfc01(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualComposite]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b1214f9b8d19eae3c25d4fc74ab39cdbb3df96512e50a0e4ebb3e214dd1e0573(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1ba00d53b4132486614b652d21397d5a09db9129b3cb68e34c6fc44a09f0db4b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cb27ba89781e28b7b825782beb508dbd6408d3ad387f2314f7305c109a91d28f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c2163ebb67d5f461b3b578a648d10d909e357f112f78c4a5c962b474a1474f92(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ea1629224ce22af8c2648a28751d7f156c0530367c385f7a40c24c298915612(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9154a71a7fe277a812b4a91173a6700d6bf9715a5f9bea20079f9bf9fec6477a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__94d342036c14df1ec44027c72e357669fe7ac1eb5867774bbc7d1abf211892bb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f82ae30011cf3cb969dcf7d126a65c8133837a13c380922c024b6e0c4f75171(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__764972b294046c9d6422045846c2d69ceb48ff3498f809bb77682a29090ca507(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__664eca8308414edb49b629e58a3cae9f02a540b38c6e02ee2682b8f37b1e8c59(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6c6667cd0d4882f8b17d45db734d7ece7929dc69af59207a7211feb63babcfa8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7bf12c41a710febbbb2e916854771d6d732df4d72e73fe53ae26f6a0f74ba4cd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a27ac4caa31faaf3ac4b63f9730b984cc54c9049608d4b083d3c2d0f4132ea79(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ecf821ef91cd7a0a230d3a33293d4ddd82c7ced757ebde951f7c3c3be64ddb5(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualComposite]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a5dc9577606a3def934c51cc74c8679b365d3969eef2c61e84b38d60f6c4a94b(
    *,
    transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9fa576089e4626815f9812e2acd786b097ac4b08e1bd39e931c02bde807f4265(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f44007586f94c45ff005bc2402305a7700262fb75cac37f07dafc86d3f44f0bf(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d11d4b613d1330824a7101101e000129d9920a9ddb51c10c42fef4548fd8c8b2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__861bf0e0a273e5e84f9df9fe553d3088dbc51b29c887f8edc4bb500f64ea9050(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fb7ac5a445e35c00f0d7a64dc7ec9a1bda99ce258ec34bffe6a0fde3dc221a22(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a924320b30784c7f2c028e3067e20348cc22332367be08edea07bb0a6ef433c7(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualCompound]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d574a47cd29cfb5b6caf9e2dfae639f6d6f069e7d33b7386e53f74580ded7cfd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c2c2fa04dc3188df652a1b1a283d2ff52256e141a00c95783ef924ca7e93aa91(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ce7e54a80b820b277c80b83b21011785f33f3ead0a2f5f5aa55da2c7a2da7f73(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualCompound]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__46e1efa2ae6185d0941753bcf901e18c4301edb76060a51b14d7c0e11a44aebf(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e0062467a733fed115e4dcf20ac625602be0317c35a2fc66964e058e6bbde396(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9893449ac92ad26ad3ed9829b658c307e07f6df969950e6085faf8c3aedc1ff4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9c35e5cfae53af0b199bc93d470a64775f7135d2a433c26384ce60717de0ef66(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8da6b4a65feae15c1f097ffdfe89bb37f24ee7ee28e86d78962fa30ec9efec74(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3cfcaf1b3c28ef15548125eedf4d5c4819624b689a830a61a955a4c2177a4e1e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualCompoundTransformations]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dfadef6ea0f7dabae4301fc4cf9806ac9db4754fb86fb5ecadad7eeefa077c14(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7ea68f955ba13cd0eec96342a00522871fe461c4cd09978f476337d28d4ad187(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualCompoundTransformations]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e4ffc5bf27dc43da4a8a75956b2db5c3d5e8e3c5794d640205ff83e52521ee77(
    *,
    brightness: typing.Optional[builtins.str] = None,
    brightness_var: typing.Optional[builtins.str] = None,
    contrast: typing.Optional[builtins.str] = None,
    contrast_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__652c47c766ad5bff610d34691d6cf74a7f8a3119f4c2efa780f35cd41d0bf4f7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c15f3772629a5ac69f23ce428016738f89cccb83d30d5c09137ed9eb26a4ae56(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__44e34f78c2e386e18273997a52483a11d0c7be397e3570be27b27ca5606341bf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a7308247ba64b6bec7490de1b05ae700c97b451aa61219189128ff1ce36fe352(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bf8f6e829471990c39e1730e72538691e8aa72dc0c8495be6e815ed922fa0996(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b2c09ae7f9bee107906e9ae8a729cd3a9f6bc898324169cd349fc5b54780e02c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualContrast]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e4a7a4a0513a43f48eb6c879cc1880664c147fc9fa9451a8ad7285b03d25e40f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__53de9c2efd452a8d35c786055ad7f5a0ee10ccfd9d8f933be2c7d63f8e1343de(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__28b3613be0d6fd984fcfa3656089537735e84f9f2ff7b69c0e880595b93483e2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__095b207dc759d48522aa567770d16e69e2d4bf2496c495e6cb9876553071c5c5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__edb20eecc66c3046f500cc0f40109cf2ea1068130f971ca63de19df00ac52535(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cc94f27adce45a18c3785028e4ee6f9ef1dc656aefb171e0c05d8a4a6b8e8d7b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualContrast]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__67be962abd5af87566e6d142d8465aa3edeea05c68427303c66cbd390434c2e3(
    *,
    chaos: typing.Optional[builtins.str] = None,
    chaos_var: typing.Optional[builtins.str] = None,
    density: typing.Optional[builtins.str] = None,
    density_var: typing.Optional[builtins.str] = None,
    power: typing.Optional[builtins.str] = None,
    power_var: typing.Optional[builtins.str] = None,
    seed: typing.Optional[builtins.str] = None,
    seed_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6179e1bd49d399d66a78a0c29879f860fa989764f754083a8c6d6c84cea3d57f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__28004d0296a30ed4561c591229f21325b681eb59fee0379b992931d85f1413a9(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e8d3270f4050e1c383dfbaa624c3e04a94b5d04d893b052a687ff2d372510fe9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__69852b7f62faffb1a22bc9c9a773e09824db288bbef6a25c9a8aa97b3f98f3c9(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc58813b037f36d7ea89df981f147ed2bdb7f146d3fe45a7cc3eb8fff0217707(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0406e1e6e8a738b5342e45ba4fbfd51823d3a46c49c12339499f86629b713037(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualGoop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7c7eaf8b103f9888030adc8362bca1c58664626b7e38ad3ebbe53e4b2906cabd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__630ecf7c04c195283bc396213784562d02953a1e797916456dd349e73d1c1911(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2968c90f660321b59ce2de3bb06e806bf0e0f948efe05a05c514aa6251edf5f5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__486243c59431bf11e093da232c803265a7904d8d5f4a47cb446d957e7d7eeadd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__853cd51203b2ff5b44ffaa42a30fba323adb286228f64bff704ee9a325a60921(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f351e2f017f9e707cb7ac98c634f33e18b9837c25884d005f3017d5a0b479423(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__280bd3cd7320c385d0c4aa3175ede49bf41ede1bd75a642d3ce79b48372c4aeb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__31464702e6016b21830a75fd2bfca310452c7c86f7c61fe57a8f292b3f15ed6b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ebefdf06c5287aa23c4cd3d2e9ebc133cb695a4a839c2d9bba74024baf0cfad(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0b396ebd5c9c9db4af4ae49582d3099cd721854f284af2c72670aa913518f512(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualGoop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3922ef640714c97f76ec81ad51805108d5b457c2ef199d8890674887fee9a4b2(
    *,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__038ca998d4dc838be83d2757292b451a823164159269196079e86243fa6a6b39(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2f0b1e689d844df20ea89454513faf9636aa4d836d33d829b406e891f33c7a52(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d79293da3eef22a6ae2c93ab018dbc31037eb03659f7e7d73e3bc6dc37db1bcb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e52bb3b6b64883f6ed6ebb07f54a6d6cd6de2e831dd3c341b572a4ffd6bbf784(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e955d007f82613a00819a58b3ea63042079fc6dcdb14a5cee0b7df6f5aacbd0e(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c04683bb39eea9cf57c924e479e8557494814a7a11fdeafb1b4df18d0e6cca6b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualGrayscale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2fe479277a83689d469f3d3e7951df072f57635c45de8460e0b6bc5981b041a3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5d5e66c687ce97dc7eba8f54bff973ae0bdf700d2de7fea5bea6531ddbde996f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d59ec7df523ee6186929bd3dd18773e6e701303c9b5b4ea2566b3116f4e060e4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__526316e996e6c8a7eeedc7e95a4eb662409e3d4c8ddf884a16b1d8c143b17d16(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualGrayscale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5efc94ef5abffd624b535d7a6cf995948ef7446aba81d584d5f8733f120f3e0f(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness: typing.Optional[builtins.str] = None,
    lightness_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a6ab0638580e5516f4d5959d7d13952e3b39d0e31f202944d4d38c40bda875c5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__32be4ecd28ac91b3a178d1d49c053c951674bde750fba9dd1487458b1acc82bd(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4702c8de7053dc258d6f54fea038a336562e175428a6850f9e144191a2cbdcd0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d80f3da17423bc13e01e8a6c96b5154f4510eb96a5841315955941e173823084(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d3c175d82f83f0865639c50429c8b4c968f828dfefba9649444ca4ef2477558b(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc36d9ce722c14ffcbc5236eba8b23d146eeeaf3845d467c11142a80a9822192(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualHsl]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b9b4207cc1e17ab1d48ccc21a9f1414af7221f1e1cd31fc302df65d759427a9f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a31c911c2d4a4cda9b26c21a7d6d5ee5aac1ded8fd3f7738ee9c05adf7a4764f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2aa4cd8102c6c134787938ad874091f00ff146072473416b5e4cec69c136a650(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c4ee716838aa0fe8a0e33eab27996337a592c6b79077b3ed2e4970286ac50dca(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__25b1a9efcc02fad7fcfb3ec4d630c99e2bc32b16e51a0275ca01ca54decdb220(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__23274d1132f719a23604f3f64ca3b6819ef5b62c4929f7d98a2ffa79e38a6b61(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bac578f81f7fb469b7b903a0e2474ba5949c33106093f73bae83a1c2c2a4b3bd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__625d10888367815865e4b8278f3943efd65bf0df4e681e2a5739d89708b674ff(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualHsl]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b05e776cd4cf29036932cfae475404f993cf299d3b617d92f3b1ac647ca093cf(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__075079ec9550557ddc3a0c9721d169c14cfefc6579d9e9e0ebb914a4bfe7b778(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__40ddd0fe075235a1350a246219abbb9a0b4db7e1835464ce8e405837a42cb84b(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__618139e6d2f91137063a86051ed7b7b6395ea9587d251378c52b7469bf751603(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__06356c3f1b7a2675f9e9075f0e929349a8a8657bb0c74b5aae093ccdd300a95d(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__00ff6a261f9502a79a45130b3e20a8fa8a8b6b08353917ef11193f68ea95fb22(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b1538a225f9ad2c9ddd021520ea3570d3400aaae2033d9e14b20fc8c21b7dbd3(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualHsv]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d2066ac311ef7d8889bec5a17e1da22c2459aba34b79993b6c11874776bef7fb(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__efc8f1535f36967a46e04374af07473e0dac1106562b8197c3fd83d546cbd5d3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2e54b528a143bcdad002a159ff1e025545b77a38a965305e873025f7f00ee834(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af728854c3706d17c7878238b277fff4f92df9879dbfe9371abe73c5dbd158c8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1913716aab9646031d7a6f6ef5410abe657355213f0445a09432a4be615b6b86(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__51483882fb7f9b0d674ff1642cf70b581fdb6001821cb9781497732f584cc503(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a9121c3adce8c46ee7ba86e08651e6e0ac71b4f9af0f5d450f63c1964591310(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2c84173be1b61fd5150f0070a590191d39d5be20f8135e93d9c4dcaa37c749c3(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualHsv]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__393381a9612b44cc92a765d6989896433e9cf1ad4d970a2b100164bc69d48331(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfDimensionDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    dimension: typing.Optional[builtins.str] = None,
    dimension_var: typing.Optional[builtins.str] = None,
    equal: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfDimensionEqual, typing.Dict[builtins.str, typing.Any]]] = None,
    greater_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfDimensionGreaterThan, typing.Dict[builtins.str, typing.Any]]] = None,
    less_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfDimensionLessThan, typing.Dict[builtins.str, typing.Any]]] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__93beca5718e44d258462ec2f179fb1f42b83b6cec71088efef80cd0ea7c876cf(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__99716a03e742139aefd6a55da66c25a78a99c1bc706bf290b40ba906fab58f6b(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfDimensionDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__77bf4ae68ce960147ba231452b021c5cbfb45a336e3cd6724b7280b360286022(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__85512f86e57f71c746f5845c1fc6414ff8aa9e878981f2dc5676c7698eb68bff(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfDimensionEqual],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ede1d7adf6e7ddb2ba8786f7f74a5857f1b1c7795edd91ce1ef6e19f2e687486(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aca8354e0175a18d419a811e8fd56b935ec1d8c10348ce0eb4bb790525a81f07(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfDimensionGreaterThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fbf665f8ba9fc1542f3b7e705b289451efd373d3d8c84dedd05e27eca079a0d4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d9bb44ecd2435288fa3fcf024081404dd5131a8e2beaadf03fcb2987ae000ec(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfDimensionLessThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0058909db05be213c6a0107dd51e4779d443187cd6c3ebdf8e566d0af5b2f52f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__20e1224d4ee614c799b162a2e46d35167f6568008cae2019f8ef37631fe52aa0(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d86471e8f8a3c2d4ed5310a3a5383fa88bc6468c565e9f72d1e219cd9801816c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__84831047ca5555e714dc6f0de928dd35e45bcbc3b931c959e40f2daacd726823(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4187e40fc369ebfc7793b6d56bb1533649839206ee4061ebd4139862594e1253(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9694589a4b5a10d6dab769399db9bc1d711ea84b170595b08b73df44420a4a76(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfDimension]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__12a3bc55b14ce0333ec79fc47063e008b233fd54f3df0e9f59b9b5bd126ae959(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e9f49685f41cb07e489d35797dfd271eca190f76b024fd00fdfdb07a4ad58c0b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab80b4a3862bc176081e77ed653f998745476e9ed5416aaa4feee10b899ac80c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bfaf1c4650604df100d22c0ccbc326ef61ab5d1fe6539781630183dfb7ef0785(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1315a357c4baa971b25580094b2a18b283415065ff78c929d87d00e483964591(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a168f41be41f52274b955cdc72a9361cb659987704164a2059909b13a99125a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfDimension]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b8cbeba8507808a157c94266848e546db6745718c7544ca61fc86bd8594b745f(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfOrientationDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    landscape: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfOrientationLandscape, typing.Dict[builtins.str, typing.Any]]] = None,
    portrait: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfOrientationPortrait, typing.Dict[builtins.str, typing.Any]]] = None,
    square: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfOrientationSquare, typing.Dict[builtins.str, typing.Any]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5d09d4cfc52e41d86d4bfd03257fc85a5201fd79f83155db803ea82fe181bab2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__31ec7e3a0c9abffa4986252a0d6288292ef79bb14ad0170b8213e803a933e27b(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfOrientationDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__49e08f40c5d5e406364b12a933b1a2c9f8258c8d552c97953b8b363db0a5643b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a84524810c5ff3075be5cb100b7e4c86c58387195626ea70b6d03b59538697d8(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfOrientationLandscape],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2607438c7a9fe037289d3472863dbb8ddd0749806a9a54b76b08871c1a65b59d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6b455416b8554492e5652b0d3d9f637ed2aae704e4315563728bbf8690bec86e(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__16757d96796e610222ea8505353c552d94f46396bff4d5d3e0b797d6382d4157(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e32fa223cf60afeb5e4996b33d86d60f472b5492a56f022279c19f4fcfbd2f88(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f9cf0feac87d6f58c5ddc66d77f695c618649611bf4cab138ae3b662be6d63a2(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__202d2b69bd6b63562a670ce582f540e33290f5c498a7e9fa3e586a54041b59c1(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfOrientation]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1c43b196495471024d60bdc3d91190cd43b59ffaf2dcd4caaee700532226dd42(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f6e1e14d136b88d7f6ccc8de41d04d7e451aedc4ac82416552f30802c0c5485f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfOrientation]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8e78ab5c85cc42b145b31c7905d06aab16be24139a8e8977ec760dd62697a9cb(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e14356f06639e21a786fb7df786c7f6562a8c1fdff2de26af428acf9fe4a4f16(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfOrientationPortrait],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__47fda28d6d07b504d4b7e0f2557d9b5c9540cbdd19422985d2b3359d86ef7bb9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c64eb98546480325da6db54dafb264cca619af92c0c978e8cc2d1a37f62aa984(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfOrientationSquare],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4126fb5d0cfd8d46a80f83f3978255b7905e1a59f0a2a2e725b6d988b2916c29(
    *,
    colors: typing.Optional[builtins.str] = None,
    colors_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b929ae7bbee4d919749e876a606f06ab5322bc471fc97998f9c6f87cb0b33b1e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b483239be98393d60b5f43e97d490b583f654e2b14b14a3a23a4b0593d6fe88a(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dc17bc50a51d557c5143e10ebf031fe747c52897fc0fa763247230de3aa43c26(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e975894d6e4ac9ed36921b678a5256c65d7050aa15ea840379aefbda88dab591(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ba5622b666ea5c6666fc548a3bbf0a12873fac175ae5d0b9e40f26c09906b7f8(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8db8a68484ac1dd8247ba414b37ec65c41c716b43e933641aa7dfa75397367b1(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualMaxColors]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b49b7635779983c42aa984b079e33df9a97abd54a5ed269c7f78355f3d70b799(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a61cf7fdc560caee4a0acbca6e76a27c42645ebdab008d400e209b4f6c973bdb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c5677ef701ffff1ee4eaee5e2246fe355c255eb80126019cb64291d4f3575cc6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a64e3a7d4b0e6ae584e572d38f44bfb34e725e40c2d2bd55a916ccfccf4e6c14(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualMaxColors]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__743c257a8be1e456f95f1f2eca3ae383a30d6821a0d58bd64f1835b3732965ef(
    *,
    horizontal: typing.Optional[builtins.str] = None,
    horizontal_var: typing.Optional[builtins.str] = None,
    vertical: typing.Optional[builtins.str] = None,
    vertical_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e5c07ab45a9694690f214956cf9f2e8aed72ef236b9697e9d7fc33cb369a5ca7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d6b41be91419bf9bbb3ff725d6e7b89b307efadf7bb34ad7eb41cf689a23529a(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f866452db93ac6583565fb3d6479e17788ad9f09ca8d6b0e73c0c538c08a001(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2313203f41fb383a556e335c7f090698f322f53a1576f8ced5ceaae8b42b7ef1(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0716e015dbc55811bbfcbfbe2b5826dd03f1dc95ed763513af227cc43e3e62d5(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5615ff8e4920143d7115d044b08fd5302e2b437d082ff77bb59bbc793de304dc(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualMirror]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab35a3a81ca1edae15bde52a8f605073ae17939f248f9326692c6b59e19a8951(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__17b927657385589ef0455e0572d445e0b9c1941d74f95ab2b4dc1940299808ee(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b76a463243788d144a336b10da27bb9df3eee5906f3546ef01f0da4ed3587cff(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2746a97b3c2e4d2d2a42c63267cb5eba12a4d241422b06dfa8baf2d331eb1760(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__492ff1280e2a3360c380c824af634546a31bcf3efd21e9246be8672031160501(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__11967942b83abe352de4d616d4d328c78e461b8bc5c318a070b11c69049c999e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualMirror]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cf4c78e2bad5f808ad586f76dc186f40a57e0f88afbf18d36fc83867c1e8a9e7(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a9dafa35ab57feba01bb2b988bd5d5f1620b8d1d3818d360623b29dc9e4dc543(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__76b5f66becd7c9ac92f14a702ded294a1be696d93c4affde018f500c43e38c7e(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ae1c818f828871d93a4182262345657d68699172c8fba664069389aac0ea66cf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__debe4ebf8ea72a6c2bf6bdfe504b75499976e528c8923cc387a6ef6dfb7c6898(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5d89403a9e0d015653d68760ec3c3ab73e23d3fdb018e9894b09e409779f9cec(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2130998f4bb2d77aceae32945ef1daa5f7bd4b3d011851ba876f78b6d74b3c1f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualMonoHue]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9539607b11ceb4ef789bbb84fc13208fffc5e7f5fd76d98dc22573e3393e77fd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c9d005468c6d216b14480794fe656ff024b826f1b7b0cfe87ad1b3ae05e871f8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4c39c4bdaa9f69249834e1a199fd82e5738feecea4528d77c38d18b3f76bad75(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__31fa2573474656a9118531fdd3c4a4a3846e740b4d73d77c5cbcb4a6bf015221(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualMonoHue]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__58ff3b7d561b1df03162a844d3eb5d882563abd553d23ffcfa346643f6fc13b2(
    *,
    opacity: typing.Optional[builtins.str] = None,
    opacity_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__20f972b3a5a9adf078510321969c71dc0240f19ec15392d25c32490bd8a35351(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__61946d346fafca1ef35c8f31b3f070d3d958b3b3ff55aa7e8be6875493fb76c1(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__804667386b326089093a395184d04ca48c55af6f1fbb5252c533a9f48326dd31(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e495ae510f6dce857edbb4ec85e3b55fe4a8d7f0b6e1524abc831b44ac3a364d(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ce48b1dc4a6452db77bb0a59fe3dbdd80b03385d6f99364b5e74665956ae71b7(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__262459e2b1e150438e3e18b08c6348740c8c3e1869bd256af8e3d74eb58a144d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualOpacity]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ed37032866c535de218ea19fd9fe4cd35756e1c2d2bb462675d89172bf39eb6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1ed7242615fe3f628e073238d37b47944e664f6633bd8ecacde47a75db576068(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8bd5d26a85ca461d07d6b145a633a506bc8f2d8f080d31a74a877d106eedd8df(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__860810813a63255c48f1f4b4cae1e75d9017b69606eb6743d11046bbd27d09b0(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualOpacity]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__83f0bc5d17b70e1784a98f17cb29d341b4487b13a6425b1a8718f2f9b5ecf934(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e8a3ef6ef809ed43564b498588a8899b4ea2cfc43316acc538314c5e06390cd1(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__58c1045ae84e212f1f2e5d570c0f9271ae9b4f71bccd7af68d1e792087054a2b(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualBlur, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__830c9484038377a8fc1fd8c759e5ba2acd6c6580eeed64b6bdc70b72e220ea7d(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualChromaKey, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f17cefd46061d1a02b2537d56745a94105e490e6ceb1d4eac7176bef0155ad57(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualComposite, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__302fa87b13ac674839536104bb66659c490310c64ddde3c95db3d5782b668f64(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualCompound, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__19cf4352336262df202b941b7f1568b2ed9c8e5b581da7ea7c8f2cfefaee35a0(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualContrast, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cc1d2b5ff1b102bddfb2aff3aee9acbf9f3da85751f27db340f1b9bdb5b5f81f(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualGoop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a90e6454c61f6798b5e7e47c905d805be515690f1a8f6183fc815c34d20f44d6(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualGrayscale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__27f0b81db523e78e8902cc6a8c45afba7dd4d3df6dd9d0b116996ae36e1746b8(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualHsl, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8373a635706e2c39f1dfe4aca1c3fdca017548b8e16c4dfa24e2727e14fe9a92(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualHsv, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__78b661d08d53b45d15a2d4fc6403a8405d332099f3259d8aab2077c4030d54bc(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfDimension, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f28ff92de3131cbec7eed0f38c2d09bb29f4c703dc87d0c9339755e85a61186d(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5b817a89bd086bfdc464395e438762df99831bb0c2e6e21cc02ed4d1ccd28882(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualMaxColors, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__18df0989cc018440e2d1e9804cb4e056ccb51ce4402b3ab43849478419f91296(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualMirror, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__940c1e5da25f23566897b649a95e5d9e72a71e4de5536afb6bd21e3295f9f449(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualMonoHue, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__60b36d07b3d33428b3cb80d9b367c86c7e046c20fa5b86f3572783136446df0a(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualOpacity, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3b87873fb2b5329c5b163ff0afad6c7ce534b0c3a0ef2126be77da3768c5ed5f(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualRemoveColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__10172b6e6faf6e282c8a7ad0645d05a39ddd645535216725035666a85e0f6682(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualUnsharpMask, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3e8ab95b14a56f59c259ea5b3388631a77fb5120591c93826cfc865d5f8133e0(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqual],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eeb380a40c877e5e6913733de33e13726f45902ace0c739ef7d97765691f789d(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
    feather: typing.Optional[builtins.str] = None,
    feather_var: typing.Optional[builtins.str] = None,
    tolerance: typing.Optional[builtins.str] = None,
    tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__416c7f0fe98098389d29491a5e25ed9d23db518cc31b014a377c6403ad0c7c99(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__99c8da31d0e188239fa5ccbb92a7840f4404f6109aedd80214031c3081147734(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__059dd565dc67f364155026dcc64a9abe4a9ab3b681b32a0e55ae02575c42e260(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c724c87dee0c46871c9df187111600a337dd3804ea123e8367e69d09d55ad62d(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c0422631af0c4116915899c60a6ab5276f6b4c22a3c69773b8d56832c9f97241(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7c4fe37d4f65159291787f40b9d280cab3c2a0bf2fa3cad84946910f50cbdae1(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualRemoveColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8e4945926d7554e32a2c9e3b4ec4d7255e5faacc90f3327bf79be1419b2fb767(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__425ba1d2a34cbf3763f18e00559d2a8efbe3cdea4bc44db0f00a1a80f3833389(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__541310009c511f3de1386abc7cf6003c0cb0e287ee2e57c922a3a86669b56210(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__82bb5b856cd22a9a2b33d6b1349d178120ddadd0930ee0ca23eeb142fddabfd0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5cd8b61dfeb6a1f2951fbef03e7f14a4b9c63857d7924697d756a72ad403159b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2951ae9c17ee3e86c8539eb24944f522ed6a9f1e309c18619917cd7eccec6eb2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4f06d4c647439a88adf15f445db7389c77c42be4635fa858c731633e055eaa2e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f243e06fb5cd6deb88bc7e3ad31d5de6ebdd3d44cc3e199023ba7826a29fd0f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualRemoveColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__43762e2b5037b0744dc4a4c8432278fbede14dc2762b1811c665c14ec07b7a6f(
    *,
    gain: typing.Optional[builtins.str] = None,
    gain_var: typing.Optional[builtins.str] = None,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
    threshold: typing.Optional[builtins.str] = None,
    threshold_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__189231920890a688b49469c59125561cd390a2455d130e883daa249f4495a159(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1dcd3975256822f8273c248a9c701e34cdb0d4f13626187414ee8f4ed3d20226(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__97b2e90459c5dd56efb9f893307895e7ab88c73aa5a7032b72ae612fe56ad539(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1db53757cd067d5116102138d8ba19c14dc12554958fc593d8c61d4f8911ef91(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ad7987c0c73e2e3a9e99be5331f1e4d71ebbea968e8db5f15cfae3582ef20401(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e4047c454ade8252ad0a3cef39fabd72634ee06a0f81271838947c44fc509df7(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualUnsharpMask]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f5056410bb1dbd09e5cff75bb5b1e8232e751e63baf6b7fbef1cc2b1321093ec(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0a0df1f01a50982d3f169a1cb78c9a99f0e69e276239bd8da3702ebee2dc6288(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c9efc5679804e36df92ee50a7f59acedf6c35c34dbd13d3440aeccff894e3253(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cfe7d2c2571fd39d9367921a408b04dffb606f535b4c06e5f16f93c563bb6fee(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__17397c8c80928b838549742bd244cd04b1a32ce188860a0ec394a48354e6542b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1dd005c34999173e149d807643d8f6dda18447fcb54fa47f4ee603b27e69ccf1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0d3dbf82044a37fc45ff34c9bb7bd73da473fa7f25cad4036936e7eec789e9b9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__82347f75cdd9850c1ac9f193f4078f30f0a82a20324ee5b78bda1668e1f1c0ee(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionEqualUnsharpMask]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__45a1855a5e1814ab06aae25a04b8b3cafed930911632aeaa4ac6c9922f2c1fc8(
    *,
    background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
    chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
    composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
    compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
    contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
    goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
    max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
    opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
    remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__de08085164709bdc7a277a55b13a55afb5b6105fccfe7b3b811416e7d46a0d17(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ccaa71bea555d3673a51fadac321aefc39772e6df720d93125bb7d591081c68c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__704eb0232008a6b97bd3c5852af0e72c34add1450e5a9e577f48b7734d144a8a(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c5c332f7a5f94de4150d2fa26ff88d5661364223198927344fd3ac0afea8ff4e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4f03d91df51a63f6f1c55b9066d827cd35ae5bbc0dc226548e00b02203ae0819(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__32d2a2e06373909d369ebeef2fc057684f1ec435e03c6b4ebc24c5331852f597(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__006c6c8fbcf504e11738602c38aa4acd32a60c344cc19550a6bcc6a9b7e628ed(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanBackgroundColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f29c8aa2be6c1bc825387cf72542813013398bb7b84de85b0321d9a8d2abf48(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b4a5311f40a59e4d35ac8022f2ae9bfd791812a8bd750fcedbee868b3746ed28(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0b0d7f5344f71ff6c4259131a58f49368ca34d92d7cf7ff3d6c01785efac9f7b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__599fd7f48b25fdeb9d62c554172230bf0a29c8cdeac72d068db6e33dbfd20c3b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanBackgroundColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b5a061f715fa351dddda5969e704f953357e928cc9c25920673293852769534c(
    *,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ecb5a1975720246ce364da8d370be6e4bbcf79038337e25816ff743d02f9c94f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0f483b83791c4b4374628caa6e9a6f7a3a07cbff7b08e4dcd6b01a0bdfb7ce22(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__96c57a75e32ad591fd32fb398a9a4894977ab3319620233d849b41d72cdb9554(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ff6b1728f6836ad8c2b164a273d31cb3a6962e3e0237b02930b96d3ab023a2f(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__535d69a756232da0dc03f88d6a4a945198755cd8ac07b5e3b62881c22d1f860b(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6c2a036be54757ff53d77cc4fe33f776ccdbd88f3a84be0e1f21c769db5bdb45(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanBlur]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bfd0220b36c2e9a4bb22a2dc50ae46b72a2cfcd4a0f46e8c408f8fc50128ce3d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e35e980b7ce8f2df8a7a63a00e58edc1ec6d896be1ba47a37509923d0e46b2e3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__75c2241cf41ad3d61bd3c9f0cd9c34f17f640db7d7ff37c5973ca1037897a67d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b720cc9def983e818fbcef9c1839491192b5c412554af735982e10b3a895ea10(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanBlur]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__48e0856c612f9d8fddb7b3d8ff02fef09da6ecbc3977182a45da107f49f65c12(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_feather: typing.Optional[builtins.str] = None,
    hue_feather_var: typing.Optional[builtins.str] = None,
    hue_tolerance: typing.Optional[builtins.str] = None,
    hue_tolerance_var: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness_feather: typing.Optional[builtins.str] = None,
    lightness_feather_var: typing.Optional[builtins.str] = None,
    lightness_tolerance: typing.Optional[builtins.str] = None,
    lightness_tolerance_var: typing.Optional[builtins.str] = None,
    saturation_feather: typing.Optional[builtins.str] = None,
    saturation_feather_var: typing.Optional[builtins.str] = None,
    saturation_tolerance: typing.Optional[builtins.str] = None,
    saturation_tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__97b221f3b962aed9eaef0d5cefd81ecc894699d6f5ec6ccbe59f336b5b12de77(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0c238e479260ccda80c6bd4d7f348a3b056a85453bce97cf676913bada23abd6(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cb7c1bb97502fe8b716caf10c51450a3717c078e00e7784705c3112f5648a35c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d2ab54afe8edacb14b4bb3c90aa9b98d075976b7b6ea563b88af299534593082(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b407dbcc58c2951d7772bfd8488efe35f64818692742921867994bc1b954fd86(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f7bdc2f8a05ef0f3327070e0a6f8880670a1d3376da6061a8033f0474ed85ae7(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanChromaKey]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c6b4042795931215fcc9e585024948c7433748f3e31c3edcce3b8ed08fb142c2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a6b80f40957400a41343bb5eba32e5a5a3a0a92e96a5d4b3b7d10d9f3c2b3c39(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a2e60959c07fac60703170234ac7f3e25c828f4523d3bf6bed6099e7e844d7cb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6ea2793cc5ccae15625613c4ed3d01ee785af3f27646725efb9c310c13c92e10(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e1a7b6cdd87d4b7df1b82da82b2c80e49c66e46b9caf2e3b471dfeb5bcd97339(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__696d5eaa1a8e5bc368cd7be1d614ac213784a0e22bf65bd1771df0866aab6ee6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be3215afe020b70ed2a00d291dc1103435fd158dfdc3852ec30a13147fbe5da0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3e110f8bd5ad0f8c5a6ae921f73d49c5ab01c8d565dbd9776a266304c5124e04(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5bc361f22fe31c6fc71336ee503158c41fcac5270be603f2dc9df2e8af57e527(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dd172eba82ec1f2209f9191db13dc96a21e092c0b90193680c2d88f580761bbe(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__616cde063f39cdfffde8f4148280f42bf6c08b13f33850074b37ed4983b5a35f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a21cdc145f686f273cb130a8684f05ccf256cbbaba259daff8f7c974318002c5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__143a09071146d6aabc018f9edeb97471d3792f4e8e595f708b36974796a15777(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__185aa12101c2a6041d71672bbf70ccd90e09ab8b3fe4bf126742ae9203f21928(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__245d41fc03e5f98b2e3bc8aafddd5aa90a260c861270b6cdf1da28e1bd14702e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__10a4cd7311afd77a61bec43449d1f1fde8446d730dfbed6c216ff81c7d745f27(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanChromaKey]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6d325844e3d5183e4acc750c498741cbc319ce6b81af2028f3c2c746dbc00b9c(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanCompositeImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    placement: typing.Optional[builtins.str] = None,
    placement_var: typing.Optional[builtins.str] = None,
    scale: typing.Optional[builtins.str] = None,
    scale_dimension: typing.Optional[builtins.str] = None,
    scale_dimension_var: typing.Optional[builtins.str] = None,
    scale_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c92c30c475a32b8c72af6c8954076b03c41c57d4fe90e3521464371a92b29724(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0e94f221855d9783fedf5efefc2b3b828f4e0ef0c7d649c523e5cf33a8337698(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanCompositeImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__80f9d0f379e44123507b0d906f27433a781322667914a22f71851ff4d05ebc27(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__27cb098a013694ad20f732ab0393e0c66b6ae349d6bfbdaeb8d6aa2158e9d868(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d828ab175fc2cf8958e192a2427f41c5218b46e7be30218f9d3ba060d6253a97(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__29bb88e2baa89f9eebe390a026ea5ce382899fcce57208270427f28a62b37f79(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__692788b2e53ee82bc9eba42f1c5e54024b26c8de573d7106b614ccee94995289(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ddf07c741bcf228655446fd90dc1d0526db4e1a696edc717bdebd3d4c93c6fe6(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanComposite]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8468c17e8cf2fb359d6152205ddc2d3225e88fb350856abb79500eba44f5f8a9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__931798f35cde848c40d0fd10ddbb753f91d2afb243108fb11aaf9254b898355b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fe367792f07c10a4eb5710755f01469957c515b2fd926f3dd4554dc371371492(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__43d36f06b9a46d079db827cb6d54a05533e9157c45e1424e5f3cb6fa13222d5e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3b7a3f3702a584f8cc86cc7bbeaa0493042dbf071e1108d92973559328a09d79(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea89fa42723f76d001ed0adfdb44b87589c1c7c7a137ec18df89f4b824298af5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__05c63c0369e74c86222333c55a96335f24b51158466ff530d95ffba4969cd450(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bdcf7d06d4b57c82cee92979b6bd2495a6d9da1c89f31f65fd567c81a0c69562(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7790e90708ffd977ad7944973a8ffc220e83d784676bf785fbae0d148e74b563(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6214bb3be0ee7ad29b64c210a3f4edb5a7fd33f60ce8ba110f174f1929e7a42a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bba45bf42cf0776e56c02cc4b77b6a65b80318d6070cf632ae65ce686ee52772(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0c58a1a93b27e7df4dfb422077330f972beab695f4ebcf5f0a3d22fea5ba0ca2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ae39f8b25b783ca397651288cb7356254c88a6034ed98db2ffdd156c9fb7c9ad(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9c8dc900f1334fd9d970d62fe9626a69aa96dc98b5459955983e6b779c62ce42(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanComposite]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__89dd4f83dbef2c93d81dad85d65e310c08006d3318e34bddec02c91a6479965f(
    *,
    transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a1623dc771a357688baf028a26a4511ce2f181fa435c96789b1dfb569f2c515(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ad3f43e2ce25b3eb433c8c14104bad615a9c27b1bbace910b793cff63cff265(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e2d1a522160a6d26af165156ec41ac3e479dae91ce459eb5a6c5ec95c7c5ebfa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__69d1f3ca9aa417915f6799bfb42e9c29c04041ba4d2a474aff9237bb10bd86d1(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8eb5504ff6dd4f56700b884cfa9026d906455f196abe5ce2dd3baef130d5d910(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a9b95a09b0671dcc3bc6e048ba4fc4084744513b61cb1a74df2308295d85aa9b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanCompound]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__30039e999ad02caffe54b574600573729b0b20610c8dec17d9124f600af4c778(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__993880b46b1e949c46c796543d322d05ecff02c6517492a65b34f51410d9b287(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3f2f8b26450daee21488574f39ee232ee305fd6aed44a8cc145d530ec605caf7(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanCompound]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be41f0ee9bd902fef7ebb69d27f5e967fc278c710815b301f94fb78e490ad9fc(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__740f0c44479de9b312b2905b56a922a038847fde834dd5c7a7d66025bf78a342(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fac6281d851f95a357ecebb6dbf846d0aaec12d66ff2d2d244c0d1c478988ef9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0d0f779b5385aed1f9055fab7f2cd1ea3e4b3cb9705b6d3c0c97110f6c060d2f(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2826b8a39d3b96aad2b1a49c9abca4a5a15c1240204f694566afcc5e095cb298(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e7a09e94b69ec534b2da96a1a55976b7846e85e106ef23127f48a1e284e66dbb(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanCompoundTransformations]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1612a5fb5c11be0e3abc521e26cdeb0bb7d8cc0fa75417c6d835ce83f1f396d8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e1919bc1fd5761c006091873e453346d98550e67e79ff66568fff692f6571fbf(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanCompoundTransformations]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a0a9ff7f22813a0ec97686de221d95d5909b3d6510f10a57c6c6a5928af583f0(
    *,
    brightness: typing.Optional[builtins.str] = None,
    brightness_var: typing.Optional[builtins.str] = None,
    contrast: typing.Optional[builtins.str] = None,
    contrast_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__989df813390c8ec46d8b29d1f6f0abf960c691f7a9905e9cec4638ff96225c8f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5caf54ef5bfae4309c2df5dc02f09fd5e934798cc9a797ba069e67c15ac5dbc1(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f8e7829f2e5708feec15f95b8d3cca94837acc8cf9a97ee2969b568d02c72346(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__742e9f10632b143e99089f8825e7fe5dc0861f4d038e10a2c29a6d770b68dc38(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__891dd8f2ce24e2fd3069e53021cf9862ffd386d753e88407627eed2be2ddfc49(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__53900a832011f8f0c8b31f9286843c591644a270492de9019b69898860f9d6e4(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanContrast]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a829e42a909be947600f0f584f41696b2af6cd5f3d5456dc2e1237e8f1bd34a6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a13b4b46e3abdc376a285d7ece5ef6b68612862713b3d68bec878de3e2a871bf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5113a71977745ad40202277e71c8ae76af2876345cf0eadddbdb047d685a37d0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e445ee42882453b54c2edd1dd98821d5ccd0f4049002d64268fc842fb83ca2df(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__069b5ec58d1eea0e22d0fa5a509d0cc39c837edbaa759660f7d00d3420064827(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__80ff803619251e580fedfb518ea53ecea5f9bb6cf32fdf11fd279a478e9ad9ce(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanContrast]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fe19db3922fed77c0745a63b2d905851e8401cfd34ae499dce56cf07ef7a9a1d(
    *,
    chaos: typing.Optional[builtins.str] = None,
    chaos_var: typing.Optional[builtins.str] = None,
    density: typing.Optional[builtins.str] = None,
    density_var: typing.Optional[builtins.str] = None,
    power: typing.Optional[builtins.str] = None,
    power_var: typing.Optional[builtins.str] = None,
    seed: typing.Optional[builtins.str] = None,
    seed_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8ba5fc29b525fe94703e52c6853650ec925c39c6cd4dfa89f7b2c73a4f1007d2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e28d00202c8e2d60b2d970ea52eec05fae420f9c36578b99a021409e6b8759bd(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__763a5d52ec780847212e5ca1cb14e5c313e7dd1d0c9ebe5d9c3624e73e921d0c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a998eda9dc6b7bd22e7d8ae8ab141802d83aff2df63aa1ea66eeaa6affb0ef63(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__56fc9994b89964cb380f994d9b2614bb3187f33028f1cc18fca7a23e690872ba(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c3883bcc7588e4c2cc56942c399638ae78ddc35ec96b5228850bf69b1ae4540a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanGoop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c39ae56085a2b04ca3219748fcfedcbca93a8a532260f4cac6a07fb09c615d8e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__996d2afd5727980645994aaa506a6f1361dd2a7141fdb7b4c8a9883472283bd1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__db1442f741af8f1be9b343c245b4ab92476edf5a44f0a795a39ab788fec896ac(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__10b0bdd208777610cef01aada0875fc302a75df6a1640605ef3433a8dbc20435(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c9943c2c98e27ddb29a8210cad977ece3f1e162585f9e95f3ea5f8c0f5e935e3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d341dc991c100452e0e8578525d571989b084f0b94ecf8bd3abeb782bc3a87f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e52d849418c8893cd9bead66c3ce688892cb3053efd84974b7433fbfd0020cab(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ba2c4210cf2fcaa9e0ea107c27f2c1b0d6e5415d148d7d4a482d6d8de6c9ab84(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b89ef214d630ad74b96d23a6275a7a85386574ee971194848172a06eba5e184f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__767631aa2b672f21fc720fb0b527939595cfb811871f14a30af190a4bf83ed4c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanGoop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2f878eaac1a3c091c83d4ced250a43f54a632e688dc443fafeeb15796f5987b2(
    *,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea2b70d6e22c3ca87f0a92e00025adfaba936de8fac6839d80d1117a49e51e54(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__892b54f712a79a7a8e8b1e4331a979400f2a17971c92127c3691c637c4462dc6(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d6185b9526f1da0fcb8a758d6d0396efb53d36fe5d718202ebcc19070fd9d2a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7efe3bfd29ea037f7c12df7ee8f1fb566050d39ba967abda36c79d632dc14b23(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a3e4a20688ee87030063daadd39aa3af4c77471e229f9968796f6aaef0eb82e0(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a65a6bc4b783e02e207bf03448eaedfc38d95f27ec1d9a16a68e07b974277acd(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanGrayscale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aa7283da71641944fad175c49cb6340b997cb691379e8ae2c7760c8362ea069a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__17a0435a5944792e6e27dc7401c96767b5fbfb392f1893a7d86a0369c1bdc392(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5132286bceb7217e50323024fc99bcff120606aba2c0141ccec6b4a38a416c33(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3d840c476e48c5b3020e56e617bff0e48b331d7e4134b04fac71da26f0415575(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanGrayscale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__90dce537685b08484221d91954f52a3d3a47830396194369e0ee2f869fd29d83(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness: typing.Optional[builtins.str] = None,
    lightness_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__98cbc98520877c3542aacae7faa1f473ec27ea999a89b08a2cd3f1ed03aea451(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f79e7a2bab0828e7fcbfacddb35060720b77d0492dfb731895c3fc6c04d8e5c(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__efb579025d7222cde59f3278e8cb6ac5cd227b25ad780785165e8728c746d81c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7612d8f8e1b2dff2c2fffd89cbdbb2d11b4ae2abeb94149900cc9e3745fe3eb2(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f28147bbb577e124748014f7ca5a709030cc0d8a83ac97d129917322537669d2(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fb6724fa13b6c11027ca369600cca0a9540c7f139dab2a5a41eb8d2338f33bd5(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanHsl]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__03968908d9c2ec2e594602f726d055b88a0ed083b41e0fec13309825f508a141(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f9a0caceb02215efe6d319d6294cc5887652b16a2469b73a6d3cb1ff76f5dc36(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8ad5e16e9b3603c09cdcb893f9a05fb7903279753c13a9734a8ca4a3fc39b092(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7a2c161951f4b72ff31ee6355d03ebe9951f92cab227e52f4eed39041bb9e718(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a881573b47e280e6f64bc6f9e6cb4d67dfd9d205e264b9fc383ec82347bb0ce(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__103fd33c30744855d17b6a3351f52a964503d13864f960af10886c8141c8b33d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9e2d74efb2c6af2024f0850446850a6b847448c7662f74110987c4a50311f575(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__202716805bb2eb8200ef5c0ff73fbe29e86dea59028259c50ae1dcc58ba435d6(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanHsl]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__65b3653a140591227ff1ae9f8729f6c07a0e1aa565d5b1465a14518393d83394(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__edd9fc42ba7c9525707712572eb0ee0c27f1e0f0bef2cbbae375ec59779f854c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c84407811c947ecb22ea9e1427b2f3b04e291967bbcffcdaf63582699be932d8(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1fcfcb5e5c1588553086b28d79eadb89d77687aa6e1344d91f779ffd8dbd8430(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ee02150afd8b6efc1416169af20086103f85aa3b8a189128fb6c0a1742df6ce(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6eee32cd8f60747fa88243c13a70cfc3fdb9aa8ad936ce311456d162a126996f(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9852381f22599320e26a0ea4d2da807f8ebdb92e403d7e485ec0a77a89f62d25(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanHsv]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__16bcde9732c18a7ba916e13e16bd7ba7e45b1a31a488983f80ef2a1e277c07a8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__29568949ada5beb3423534f28969998ea53eed2d312f3f26b69cac12e49102cf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc9ef63bae279b4a195c43fe8d5ebefe4220c0baea07816908513586340e9f80(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2e7d58a63400dbf74d61149b9dac9212bd7cff3d052d782544789244b19f52ff(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7c34a8d4ce99e9b249e2f5bc422fe9a65f4dc9f584ec66dd9c8f952fbd0df532(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7a444ecedc83caa0fb8ca1b44cfbb5a9167969380dd9913b9291bc31549f4b09(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3d199ee0dacc7008ef8da0a6bbba3480a195f072e5d7346b367d663ff4ed91aa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8feabc1db564686bfbdf6ef5aff4330ea0c0a6bc5ef81cc9bcda11ffb23eac89(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanHsv]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a34c4e0daa6780216432f53fdd4564eaca11c7701d145e2217f94f6a73b91af8(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    dimension: typing.Optional[builtins.str] = None,
    dimension_var: typing.Optional[builtins.str] = None,
    equal: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionEqual, typing.Dict[builtins.str, typing.Any]]] = None,
    greater_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionGreaterThan, typing.Dict[builtins.str, typing.Any]]] = None,
    less_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionLessThan, typing.Dict[builtins.str, typing.Any]]] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__36cd7f8592795644009e43b93c94b499eb8864cb23a1e9e767ad56c33b2f1b76(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7a54a5825c20933c970a985735d65e55ba6df01135ec02fce55364b131d7ea2e(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0c392a92be1f4a83c9c998885739b3cd2f6a1ec0fc1d7fc5a20da905a9c1c61a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9e5d8bcb08771bb27797e4ff9fc7fd615aae3c2ede2b243a6fb7d0616fc720e1(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionEqual],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__00d9454ba4683546fde35beedecd8225bc7643eb50f5de68fd352535d9921896(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a856cbe872d5ffec3b4ab51676d87a230e6619c497df481c97bb93f207024da(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionGreaterThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9bafa112dc3f852bd6bb099eda056bacce233a350d868009af6fb2607a4fd10f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__89f3d636e27f546db3e110bb28b3f710f5ee5f5dca9e874350bcea48be38a7d2(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimensionLessThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8bee668343937d9d24ef7f1763fd0f358657e7c25bdbeac7322a86a4d925b608(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f85a4dc6cdb4834e7636f0d45e4522bf40f54c19d854005326939290b54d262(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9c84cf803a4b555f54ea30fb0651ace62123321d610d12c3df2c03e45b815b2e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__516cb338a024d68521eb39a7eb3b886cf9b77bb4a45634adb6d2cf0c87fff2f5(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c65070e531d58368b420662f7d910e72792df0bfcede2ea8ee97414474680b5b(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fac580099065a752eb732e10ae08f5af4a9a812b18011d16f7d65248d199e969(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimension]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5a96cfe8fd4b6a5d679e6770b7ff693782db12b91447df21ab44b1731ef57e89(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c7fcd9c7e888632ab162c37680cc7ab6d2b13f3aa92ea257d2f26057a0af20b1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d804104cc518057e4cf54e88c549c025703c11eff57ce9871ecccf8c9c76e8be(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__53d50dfea25037b9e3562d6be736affc245e0c5e5008fd09857cdd4175dd4cfa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f643cb146f452c81a52338c70b09841275494ce02856ecdc74ea4ca5865d5069(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9e9b21d6bf649b49a69ded5f08569ae77da952f1b6dbfa97290a87ebf39631e5(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimension]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e5afa49f35933bfc2958d9f91964d571cce9e339ae8bb982e8e5948d4697e1b7(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    landscape: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationLandscape, typing.Dict[builtins.str, typing.Any]]] = None,
    portrait: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationPortrait, typing.Dict[builtins.str, typing.Any]]] = None,
    square: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationSquare, typing.Dict[builtins.str, typing.Any]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e231ff3232f316bf4669cd860cbfce35a79a765cab05cdd81c850bea25b3dec(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e0b7fcd80a92561a6e9fb62a8320476cc3a14594283cbb0b163afdfb325f3cb7(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d2705c61b2bcce29e41214a9d8f5ad7c7908cb89aec37975a06b45b56b5c2b45(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__29f9cb6033aa8d106b0c6ec7f8799ff4b59ea83d20b965d15024feeaa9de1c9c(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationLandscape],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a945729598c6d3f669c2696b270c7dd78f927c0a1232a379372c60704cb5a956(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a7a864c5a27001672fd9db02d3781c1d2ea62b71024818485badaedf57a74c28(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__48fe7498fd515ec2486527270c61152b0709a20d40a3de2c0ca4680bf6840fb7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5da95dd3dacff63131130ae2b20665702e606cad517b766dbbb015994eb70f84(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__da6be360904fdb71b6773d8afb9c028d7e39109b285822ae34a730dd9fe128fe(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a020a150f437831710c176d67426dbd7bc07103baae94d9904e8376e29b4fe46(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientation]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__60e8146d01c3494b3e734759123454010defe12b5242f5464b1b788774d9a85b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b45d228ab55e84380109a8371cdce7d733d87f0dd5a923e0b73eeaa91c8d2d45(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientation]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e4f3f5efa292ba3674dfe978ea4c2bd57280b8baf960635acc9877cd93f125da(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__13b546fb96a39dd0c412c0e1c100a5f25b9ea1f81310b3c152b344557f879afa(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationPortrait],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d4ae01f823bd1683dc4953b94d0eceee8ee46bec30c9c3018c4b2c1ccfb15fb(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9bbac0480bc6ab4db1fe4c3d57c6a870b6fa0b83bb65bf505d63e6c8519fc203(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientationSquare],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac6bf17d403c92672c592f7944ce403db79b22b88071c2b262e6b6e05964f4c9(
    *,
    colors: typing.Optional[builtins.str] = None,
    colors_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a34bb56693b9bd42e99c9180cfaf67e4ef7d16a758c9aff9e794a60e42b12e2a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__609dbe9dce85526633b8c35ed7443909bd3c2b5d9c3762b66d6bf8d0774336c0(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e88100563edb31c489d7d27bff89be5d86ed71d681b321c702f291f0f0d5ef6b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f0c265809c7667d5dfcac3c0f15fc88ac45b98de37dbc55302ac40932a1c8538(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a5e7ce4af5940293bcbda9a81e6dfcef1be4cb50f4ea8964b9c46ae49abc8d77(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3677b3bc5e80653425298d6104386a36c4f678cb52c22b1ad8cc1ba72124625c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanMaxColors]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2972fbc7a7c75556b79d8ea9c8e1e3541ee4d2398acbc0c84bb306ae3d570cc6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8988a8af13b5e6773b9507847a4ef4c991d3f295b85a07be6429db5c03296475(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8f5444fe0ce8097c187d580c6f9ce6e9ea346046c07d2bf9b1535d5801515405(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e07e9161a86bc150a943bb273f91031e546d3133efecd9cb627cc299f0f39aed(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanMaxColors]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ca036daa74af8b134ff4955aff9785bdea334fb0b3fa02a20ecbf73a8ae6b69(
    *,
    horizontal: typing.Optional[builtins.str] = None,
    horizontal_var: typing.Optional[builtins.str] = None,
    vertical: typing.Optional[builtins.str] = None,
    vertical_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__87f2386116f7604d1af53098c116cf0d12eca512c00de54776a6d3a05939b958(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__badadf5792ee6f97371eb8637dbb2fe2e9dec3c6c01328b47c91ecc6e08f19f8(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2006f511e28ffd98cedff7f4ed9f47c71044134718b8a827f5e429271b0f201b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8908db83b6fcd9f6f3f5938fce05293fbae40e0011f6867b92cbbd7eeff1f11a(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c793b3b52f7feff3cc4aba865a782c6392a262822d079909d1d65b7a9f7e8b7d(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3cd9c2a28ca52a69d1d89ae59c8f3b47338bfa18f20104b57dedb47a7e65f329(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanMirror]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__255e4fc950e7448282cb7eeebba86d8641c28deafadc3e23c20dd8dee0be201b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d328755855a86355c79e231706ce30b2c9d599ad9f2287b02e3eff2449fd696(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__423f2e1937a7059bbee2c5a4d1db68d11b00d3f8a7927e07cf0a37ec19d26248(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ef43ac34ac65f1047a116ad6ff3af3690762cd5259e4e13e57821e0177fb35c6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f4029b8d40160a11581703c0355504447a37f4b6429bc9b11b2fdcc2a9faef1a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ba1f897855707bd09d26a2c148acb5e5ecf42e5cca15ef837e0d2ada6532e318(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanMirror]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9599ebc216fa4250ce430ed7e0369607f97ccf1fb35973d52c05fbece8aca233(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__74c1997044d4d2a7f9645e93fb25e2321f46e9efec78ccba4b485d06f7232396(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__98b4e697f4bc85a756ade3ac57e030f57f341e76d3468d3f7ffa99ffc0db74d3(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__99f7568dfe4432851ea9dc49e4c7f91f010642ad3bc4ee991447912c781006a0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be817c79d131fea7ff25e4fbb4f111677c0cb03dde38556e17ee8ea18b4af16e(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__617dcc5eb93887d33b5cf0492c37c8276517f3d6ec1bb49d4cdca4bb545ba18f(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9f3d869654720f693c58873a50256e2cea2caad5f1094b36681dc6beb8cf4de2(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanMonoHue]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c73ba6f49bd5d02528a19ab891ee91c765d226c663cb582389b8f57c332590e9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb38031ad4a474947ef1b5eb3e853343304431b93247d8949e5911a0fac3c153(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b65e035e085d545997bd3466d001780e10c33bdbc4bdf45fc93a4b9edd95d670(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3dfda074423531e610fdd9b8fb498803d3bae19f3dfef736c0f801e93a7faccc(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanMonoHue]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ecd888c662a6b3c3484134121cf65c5ffa2c794768c1e43a46957043106b3e76(
    *,
    opacity: typing.Optional[builtins.str] = None,
    opacity_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7024f363a06615b0a33d795b690e6a504bb3f6732fa8ed69deef381cf20111c9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3046e1959cc84e12e1c4cade31ddde80546f44f64835b47b805b8bb6b065d8d6(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f821d6a864776b36407ce128b4de7586211df8ad1748fdf8d70c97c6abc9f84b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4cd09042bc43fc3f8b9f484c40d8e6a267cb722e3dd6fca8691f0d69858df110(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d4928ac2d17b789bb22439cd1299eb50c35571b5e9823ceca1e3a2b8cce617a(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d6fef3bd9c3c9abe650ec051ec46c73e562b8a4b740e956e6b0a27768cb5fbe5(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanOpacity]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__72634591cd2910ce1bb731f94108ef0fb5a71a14c1cc31779e40e2b3a224104d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e83283e881625a81fd2e98530b9e6848e6de3b61b8e7b793a64e8578478d055f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__936150fac57affcf794537d3e251aeabde34cb6069b80284f2c6f102faf2b724(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__103102cd0e07d5679d5c79ad369ab282a599d343f92d8c0535e09281765e8ac2(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanOpacity]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a48f4d0afb08bdab14a11369b538cbcad6efab5c0ae3b91edcb3d2ce34b81ac3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__485050d47b3ef503f5d2b7bd66d7d3300084a2d03d61ff2c069c1a36a5030da6(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__20d5547076469f324926c4a890a48f3d0e581c4d036cf5ad8f5fa38064c62989(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanBlur, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fc29edfaebca9fa71d66cc3a5bd9bf36c5a67845a56ab98f728b840089174c68(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanChromaKey, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f7e5bc92762a5f76c3bbf79390b4058965b0e3d5b23129bc660a7a6aa634e5ef(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanComposite, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__60fba4cf4665eb090cbdc22a04a5288f97edcea878204921db444facf56ed05f(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanCompound, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ff10ae9eba935177908f93f23781551b8301069dec208dfc5884f706ee8f9fb(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanContrast, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bf745b566c6bbbeccb4e619f10854aee1b845589fd62f1dcbf46e77724c4b447(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanGoop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ee465692fa5e66c86d24a8ced3b34a56d8cbfd457dd1e2302620c64a5965710f(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanGrayscale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1ae5b45c53b31ab6999f93c722453b984982f5c8d636cae47f8e50fc0da46ad7(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanHsl, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__607aa2ecdb57b5a41f5b226f6441928c5f18deb9d09aac9bd1556b8270256ce4(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanHsv, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fa13a6d51387b5484e4f5301db0e48a1be980b63f91c3a4ed743e79bc35d98d0(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfDimension, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__13e148129d8223f97691a3e8deb34afdf2c7c36763b3e9908d60b0a8734532ed(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f127f75f1c165923f02d2cea55be666b07e1563adb8c8d95563d6f4476d3c86b(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanMaxColors, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3c11367ecc2ec61577f476206638e1d308613aeb6bfdb74c8893e40814b0aa3f(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanMirror, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7618406e05908ce18bc3ad785f0effd6a14dec400593384c0e2cc5facfd632be(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanMonoHue, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d783cae53f3977bf331994959d8cda94ad8880dca1479dbe808f8f51522ad84e(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanOpacity, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9594e6017117f6259fdb3a6bc204e4224a76948e56a3e5a207aa126754be4478(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanRemoveColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0c0447f36d6366a20402807de4ee6b89837e6e0079d0de4649b149b1567f61a2(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanUnsharpMask, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9975111876e5327b6476954d1d356b271e0828ee3ccfb609890ab4de5b9e908d(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__803c07275b583987c625a3cca186af18eec3071a627dfdba9356aed64e807af9(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
    feather: typing.Optional[builtins.str] = None,
    feather_var: typing.Optional[builtins.str] = None,
    tolerance: typing.Optional[builtins.str] = None,
    tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4f197b752460a77f92f018d7d5283a474c058298afc58a321b1912fa2d0093a8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e03ac70ff2e760089984b75963bad65d0bcc0b26c5ef56cd885cff790fffd6c4(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e89e326bd72696421cae76f76b21a6f900d4a4eadf6a6059463eaa9b2e312930(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e90cb282a68725435becd1a2d0637b10c9d12202275f3764265c6f5aa62b55f6(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d8c117f8577308aaae191ee53730920bf64189b9a23795b37dad95de6ff8a75a(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c06c8250a564c7e3b7de3b45d2f07b92e401ddcc476f029aa93c2a5045cfdfb6(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanRemoveColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__62001fbec57e060501ea6b6964036f225ccaa978c7ef3415b8e41075c341dae4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6bb0e399a015a35ab9ce8c3ef0b40a32d5668ef1aa9b4e3a5b9cf9861a4d7a68(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eb15d97333d11363f1c02a193ac2d16561f57b158ed580e77cc91fd9499e4535(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__866a2cc7b82b5c0ecc3e2b98c4c28ab5c1e94ecf69df54f38192f13f939135c0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e5a040b006fdd8be7584902baa8d42b7b59171028767c686749394d9329fd4b0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bf55b976d850a375bdb5a74d04a4b6c70025ef1916c6c025e2fbcfff2920f638(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__21e6333d9b574896c5066d274eb766238e7f04a782613d301a03e02b7b8b5eaf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0689da878ae5aa311314f21c59de5d0f71851e0725ed69031e25e4e9b7a5bdd4(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanRemoveColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a545a253e265aa050da5c655f596c66b39409b018bec7843e632849023153cf9(
    *,
    gain: typing.Optional[builtins.str] = None,
    gain_var: typing.Optional[builtins.str] = None,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
    threshold: typing.Optional[builtins.str] = None,
    threshold_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__01d6b8c966605fdebeca736e3c7cd1ed8e3892f52bb7a07743f4bf3dda5945b9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0393b02a500b599f0874747cb1e4e57eff7368208dc193d2898bc4469445f248(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c4926f53648523d674b2bbcd9ab454709409e2a21d28cbccdd3854a40f43cd21(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__40193bf07c2c8644eeef34aaa82d00a2494c6967396b41dafce3285eaa429f3a(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6eb90095dfd1e2cab1a50af2cce6bdac149228cc86a4fe15242f62a39d92ecc2(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a51a0b30c9d3d925bb3487ac905c1f5ce2c1837ac64933f75ccd6d3ed30cc3a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanUnsharpMask]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b37dc92bcab03e6006d20bfa9afe4bf44a9ece424b2275116634d9c4b8e56517(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__885c4a8095b2959a8ee176b7a2fdfc82d99213c813277982451bfe3e79572cbd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3452d478d7eb3ec869465a6dea1408f84f2d88da9163a3d282dd2703ff1b9ffb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3067c8b5d2e8ff65cbc7c41a1df30ae2b0bfc534751593bbea23225d14fc6852(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5fa1b37891a48dbbcc88beb1aaffa2501bc10ca4383b0b2cc021098423d406e7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__39e0cb39d3292f09844838a7c6591a9be9c774912d7ea8e2f3d91802e7c55696(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b9c9e47aebdf6b10bf35592048dc3014708b8723ebe84256234a0e2bdbd8c0f7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f477684b76ce89d273e38db1dd2037ce84ea8dbc19f24206f0818c5313d8b521(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionGreaterThanUnsharpMask]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__281854866461f4ed3c27e6068a66cc403d58dc59e89d4572e7b17cd29429c0cb(
    *,
    background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
    chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
    composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
    compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
    contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
    goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
    max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
    opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
    remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fcf0a02ecbf55f116bebd145fe739cc4bc1efa07898658b990c36dae25d53501(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6ae80af1a7435e9874ae536dfd6558d5b5d35a89f586996cacac9c9511db3519(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b24654cd27a0a72c5827915c7b72934e0adf7b32131e7df7af1f5fbe31e0e4be(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__22c23ddbac9c3c88753f2f53ab0d63d32c5daafb69efa30e8c6b4ad9542878a7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eccf7f6e0f952447161ff2130ad5ed1533e4ef1fad91201c42c343f5737e4071(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d29215b0280938505b600cf6deee5bb0bc4a2647e31ea87e04b30157290a566(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e4bd384cf2d5e1330c2f447be58e52e3296edc9dc32d0b4330d930ccf9e55e22(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanBackgroundColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__18dbc08e8e8dffef4406556d2774539d6345abd9b3930eb28ad5c9ffc46363ef(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__170f57fd30163b5550a8b5fb1768ab54b0b008e8ad2735d5be6e725561da2170(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3646e620ad84ed92f8bc351c09bfaaab08fa661c21ec5c0ce1b7a5f4334098be(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d9b9448aaeb638f6c0138d2e82406a993b474d1f5c595fdc768103a796055378(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanBackgroundColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__574e8ba4760cd9e99d667ff998cc6d7f8aca64b7f1306794d3d4769a1ff3cbdb(
    *,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ad0fcbf11b2841bdf6beb9bdd008ab120fa70aa89c46445e0cfaeca6772b2579(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__105440442cbadc05d6b25f0c19e77ca2ae765ad7f6cc320fc2d8b7e087c6552c(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__640246e31b5c35f2e15dec7de57934d72410411b2a85560e47071e8c93b4c1db(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1d17b446cc66ae72bd9df9f95e2bab88dad222de610755140c40784f80d68616(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__36fb51c2882334d8d1f1b95e5a4453045dfa58b8f5ebaec50d5fe9deccb2cb83(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac5d6dbb52a1ab2875467cee90f4c634a327be5a57a815d75d846c5c2bb6f528(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanBlur]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__340517e56c61d442d5ba5475012e5561fb88280f07655011537b220be7aafc3b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d30f9cd7c09d8f1e5df5f98c1d88460ea61bd1e988dc2e071ab21e5c1c357ada(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dd0a1e7f02b83755b1b1b582e7c1fca48a174f8e03b16299709518eddc0a1206(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ae6e04c689d881f2225fa73ec446085b4ae45795ede374227c7018b3196f0adf(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanBlur]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f5050be6add95661e99d44b543498c28c67ce2b2391d0d55461b1345ad95d1c3(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_feather: typing.Optional[builtins.str] = None,
    hue_feather_var: typing.Optional[builtins.str] = None,
    hue_tolerance: typing.Optional[builtins.str] = None,
    hue_tolerance_var: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness_feather: typing.Optional[builtins.str] = None,
    lightness_feather_var: typing.Optional[builtins.str] = None,
    lightness_tolerance: typing.Optional[builtins.str] = None,
    lightness_tolerance_var: typing.Optional[builtins.str] = None,
    saturation_feather: typing.Optional[builtins.str] = None,
    saturation_feather_var: typing.Optional[builtins.str] = None,
    saturation_tolerance: typing.Optional[builtins.str] = None,
    saturation_tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ae4046eb149d3d37963ff4b9057f7ebf06fbf2b235c0e320e5edf942d2d15c0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2b38af8b6983b552809156896e3c0e1c0307aafd8de780311a62fc0de4e084c1(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__412c14e0ee82ef7f7297ae8eef44777a61de86660213266d3a2954cb0f4755f2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__63fed677876376dd9372eae5861cff79bbeab5d1e1157d8992a473a7863f2724(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac9c7812f6e890896f3e4dbd7ceecdf198bff367420b9e67c4375e83f2bf7c01(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__25224385fd607784bad6d44d15a6dc647402e276406a40a6d1b8f7fc24ad7523(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanChromaKey]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4316abe51fbb3fa86626d1e0b3041650dc027bd3227de8d2ac911f9a4dbace50(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a7fda9ec37f90d2eb0f2c70cc78445caf8ed9e9fc39f6987eb9eb48df94e2851(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__50435fd701b7afd08f92c056ee14b8f1721c5e08afc87c699108d6ba289b87b0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ae2aa9058f2557838ff618a5883159c877876521d09c175f91b16d5127c783c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__64ef5901326e266e4afa8e3b696749fefe86fc779e938e8a87817b08a2dee07e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4e4d8aa7153b15eebd01ba5a18e6d46633bfac06e44c32d0973a84f4490add98(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__96b92d7e4ef65e10dbba41693a719caacdd83688908d81631054c7dbc502dc91(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__50e7268e2f6f2a933b0aae1fdaf009cf31f2cca2683bc31e2d4814fa479d4993(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9751b5168a4c9c02953db905ac2963004d8f18460bdad3b9e76971eec9477761(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__07b1b31a68e4b86c78c243f6bb44575b13a87e02826d96952343745e11d582f3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea7d17bf9a1e47d6017365dddfc7f38ef3bd43468a4dc70002230fe38829cf93(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f16a5dcfcdadbd17add06f742d4ca5593196f8e35e0fc283c092a6397dd4c42f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ce1f4c291b62a96b250ed61af4eaf12dc18bfce8e1b6bd2452ad6f6f4266deb7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c00c61e5bd927a377ba6ac2ab7e47545d9fb427f834473770cecc4ae7627a4e0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__256d1d7c1ad20ec0ebed693f000ba68d8d972d4a4787613e9191d374f59f740d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e6347d0f931edde525bdbb42445e83ca9d2db754c186b4a3da6f9f22d721d88(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanChromaKey]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a0ad5476817e160d7604ba85d790c8ba89e4d9aa4d9f6355cc1580bfa3ece6ba(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanCompositeImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    placement: typing.Optional[builtins.str] = None,
    placement_var: typing.Optional[builtins.str] = None,
    scale: typing.Optional[builtins.str] = None,
    scale_dimension: typing.Optional[builtins.str] = None,
    scale_dimension_var: typing.Optional[builtins.str] = None,
    scale_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__242aac662e5fd521d6297a9b928872c24df5642b428ef53517fa82ff42a54d95(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e913a037ae91bcd25409681d60e1d47be66048dece95f41e8e8c82a2ebe8911f(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanCompositeImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__22172c1c919bf1ac95c3a4399b566f658e38f5ff36ac7dd0a4727f72cbf8b7cd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e25cc0386ad32c560d3db334052da990d6c641c40b5400887fab8e0609728504(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2600a56ad47834a65bfb3f89c2992169c994eaa42d6d688ffd595b67612dee39(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__55463f36d0e6eb8ba4e9b01b18ec3109ad569252798d9e60414344320a4c8aa4(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4cc62c182a0e1df37c7eb46754709886a214ce8bb9e864bb8837a353ba3d3b04(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e1c73feebc95e475ba2865735ca3b5e1fcf88a798e0ae7557fc9f84301f85041(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanComposite]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eeb6a765b333dc05073504af8f331680e4971c2ec08e9b56aed48371dac392ed(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5d01fc50b03f3b9b58fb7b87d55c8f6ce44de4a4e5c25691980126ec01d67731(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f8ce763bffa6c0d0645fb8e375b3b3b24f57cdc42327b24a01fc1baa1734fc04(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4e2176969b75d6c74eba2df300f3c3a55a67742c514eb38cf88887af4e52fac2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d3e58e99bfcb5404d6644ca2cafa197bf42844c2dd577483ecbc176eb4b989ae(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__29b39bb12d7e84cb38c7b718e94c634ed6017f35fd13e7c0764e36eedb5ea0bd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5a9c9fa01dada2f8f66413d304fb5352d6f2c87e786ddf142689b175190ad3dd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1dc841343e3ad9e75387b8c2bb98fff590708c12391824462a73b4a41b6ef1f1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__48f50c26525b425b0e4f6fbbd222d8c590f321604aaaf083285205a71fd5723d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__db8fb6162c18eeee16534d0472d160e2ec7ff30272a102d25f4e00f45885717a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ad7b7080a97d9303e638e40b4512f11e6f5e69ab13bf520df374a6a2dd8aa39(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__03de32caff4e3cae5f0faabfb646a4ba4ac3c7c0a5be2dab266d23b7da66471d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fdab9cfbbff25ef697e1f515788ca42d3c86eb21d54bcc63f051b209f5f26eab(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b6426cf40660eaf91d6a1ba25572c8649fe767a06dbd3e6e1ecf99432aff8791(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanComposite]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a976c1d293e28bf30960c4b17978985ded0d44bf21814b660439e733e80a3844(
    *,
    transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1c97e7a1854ea56dfb0686ec7c441f0655fbda622d98024c54ce88f9ab4066da(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__824c9b9858c3487a455ac745328aee1e0206a47012a981ef7ba7ada4f6169da6(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__74e13c9cb39577854a26db7d820a82abed533e747145e381264b0f9b173498f1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8bf27d99eb3d5f93633327dfeeccb7a5e25de31a0a715734ecd4e8151429a5ee(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df9b585f6177f758908c4d656eb07a9778dbf566ab0270bdb4a696f192a92018(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0d9579aaf5455e9101322db6e298354685d4ebb2cfda5c7299ee2d1a4a17b24a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanCompound]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eab45720eb240cb6b9d404ee8ad7da6747d65c733b2c94b46e542d28a421b902(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__21630122ea666354fdaa74dce2253e88d755c5980b0d1a8e688fe5c9f0eb99a9(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a78ec8459a2970dcfd616bcdfe2f166ce22d277d84c238c5cd96a3e6a66970c6(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanCompound]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__66e5536bca3ada973b9318b9a47f7c49e2c55d52005a50c38f67b87919f35389(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__68853b18b6be6ee2a02ad45e0f83e54aa08d16e820637fd928d625cab7ae8158(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f7b2059f740b5393d399587f3ea714e4384374de3033a81c250cb908fade79ad(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__083dce7abc6cda7b2cab8ecef39ddbb0b4bc2f9813db1e2c2f60fdbdd2460dac(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1b5eed422a536cbc094268c9961c484c321a9333424d52d62e1957acde41ba45(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__67162188dda7ee4bdc11ae56570771eedb9cea3187c6f8f50481d87f9317cdeb(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanCompoundTransformations]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__626b68250eab483050d7c6d34ffa33bca7db3aff47b9043a794d5d14248465cc(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6108ffe643b8bd36f0d45819f182ec069a34f95d81bc34386b784c2e60a61084(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanCompoundTransformations]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b0d2c9a1b68370ebd84ae8a4a53a8caa607acb9b85b28142fde915afdf7156e8(
    *,
    brightness: typing.Optional[builtins.str] = None,
    brightness_var: typing.Optional[builtins.str] = None,
    contrast: typing.Optional[builtins.str] = None,
    contrast_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f6e3b7a35d2da18eaeb6910c578280444047072179a6fded43103bce12823e6e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1ac856d57ef630eca1f3518f7ee1cdbdc95c5dacbbcb5d3d9c9547733cc0508a(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9c86e35fd0860f6273396a596208c86a3fe933ec6387ab30f7fb62735b58dd2d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__85c51f25e07b706708401b26f688d591dedcb5b05de4cc7e235f3d580a442212(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d9a8575bb7687d5b35e7b1772b53b2dfe67604c39d6a06deb794da5e5737a0a6(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7c25cf28f7bfa3b761d9c0e2573d39a93b70e3489ce6b04d7ab6128ea2c555fc(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanContrast]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__003a5e8160cd2f7b6c4b2e5dbe21289b51ef3ab43926f45b0de420a73e1bff05(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9b9ad197690cc58c68d7d7d6cc48bf9dd8427c3d00016a413277015869c090a7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1ae0a4ee2b31320e34d3f13622c6973db97d113c1f85336973829c15e2fd4fc6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3dc2b67cf0efce2666d911501bd25ea9d24a65c665810a7e985aac95fa207cdf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7cc1fa3e0ba8429d40afd7b796969f5e9c1f982c494a9d1d8c3a54a97d1e3e4b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__24272feff92b8d94e9a18faffc25638a02b226e08b7b1f2c09ccfcfa82502877(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanContrast]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0756f9b390e334a9a47b2393b7dd909197b143954d679713b361555672f984e1(
    *,
    chaos: typing.Optional[builtins.str] = None,
    chaos_var: typing.Optional[builtins.str] = None,
    density: typing.Optional[builtins.str] = None,
    density_var: typing.Optional[builtins.str] = None,
    power: typing.Optional[builtins.str] = None,
    power_var: typing.Optional[builtins.str] = None,
    seed: typing.Optional[builtins.str] = None,
    seed_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f621a4fe1fe9ffab94a89871becb6d7136d6ff93c982a0c2db3fdd1935d352f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__96a2e18b8e5c0f956e2a0da4acd2792fdcb9489a8df8c34b3c098d28c57f2c36(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd175aaa5d3f73166de39999afd33549d4476e57d1a043de0fa91877712d0252(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a6e5ddc05939ee617d8a637a314a39cfc9540c134cf8176607f19f0b54a6c26e(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5e456cfbbb5e218cc09f58ff6832d9d3de0633de175064a901cf1ba2df32428f(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a539d86440db47282329dbf27570d3cbde62bd503d0b8d8ad6c3a5c2853aea3(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanGoop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f6ae4eb6c272eaeb2d86264b4b0f4990a306ce877d968dde9d70f7354ebed057(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f401bcb527f2ae27230eedc86bc8bbfb7989f9cc77959955fe9a797f6016b691(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bfe713effd54b88c19c4ae9b49fe40c4c4da2fb3a196a51114783ad7853f8681(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b083e93595680d2a5d391003130523c46e3106f90d820a07b6039c5cd3daa568(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e13555efdcc958b80b03b79226c25caaf815d7c6d2b143858becc16ab67e60e7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__974b814e24d3aec8cc54d30a95b730c8d969dc7633210199823120c871feaa18(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__17eefd02f8cf7f096ca097ead5b352f2af3a29d000f6e62a87fdc52e8ad5177a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab70da322de61839903e46c24f853e804c69ae7edd78597685d8dd7c79adbcdd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0f09bb045730421369ae0be943a582dcd74f0ed62cc694d85b1d26d74f24a578(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d26060c4124d19e7b28bec8fbbf1d10c3f8efe59364b2f7bbfabc5ca7668d9ad(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanGoop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5e660631bc799618315ade0818e06d86925862b5bc5fe8e0079313c16a7f1465(
    *,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9aca5a4e40c04fe6a7002ef596d54142286086d9d171c188a7f85fd6c26b27b1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f741e2fea9f75e42847f4f667b3a38a572d788093d581571556337b64c6c6906(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ca4c9c7f92fb9f2a5fbae22f93533c2efa15880f62df147bc89d1fa658719331(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1149afbdb49af66c9b8188bb46baac5bcff772d17c311bdd6d2d19bbe7de4096(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__35f020248e6b998e2eaf43ccd261e9b5cad76637eaac5b91cdfdcc78d0965687(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__25f86ab60a2623f763711010e263b9a2dd2a70c25f61328003db4dedf5003dab(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanGrayscale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4bdeace9c2ea84a17e2809edda11a3d502549b7b6d2edcbf4d0ffaca3aa98850(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7ab20724b7492952b1c4f555b69c819a01c3c511f366e0cf3cb418e620c0bf1e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2e6e1c75fd17bc4e1dfbc233ff5d8ca4aba0e643a4df937d25332b68e58179cc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f0bf41d4c1027e002ffefc0b205c417e670fb4ae6c545be83fc0f169722881c0(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanGrayscale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e37f4b4af4d1754a39edfd2f5c10e99ede2ca0ab17d5b496ad1d0a51e446193b(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness: typing.Optional[builtins.str] = None,
    lightness_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c7e4e88a0e87a65c2e5885bf20ab3183f4ff7b58b6aacf8f51929e325c1913c8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4c2a5b708c1e42741b6933ab09a1e4f8276e927bf34eee8ed3a4107fc3961f73(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5c2966e8378b25aca3f4b1f4d57ee7fd03d352f8d93ff63bb0bbd6daebd61c57(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__210c9575177e4a7eb6d73ad2ae4c5c4ef024f967188281aaaabcecd270179627(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c50bbe9a0eabb88883c1967d5292cbf03fe9833f2170b375bb6136a718c85ae7(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8fbe8531730bc4204c56f0c994861d92dcbe60e96430b2e5298c65300cec5b57(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanHsl]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ae7644ae3a27ee2664ec608ae56fdd64e64b64b2a6f46672644fa127a97890e7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b28d94b34ff5b6e1ea8c04a8f31016ab4429fb604017afb77e50a0d0ba741bc6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__811ba0a1e3a58052a260ff37e2f060d120e619c695092f237adb19419e64ff73(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a28a850fddcf2c32b1929b33716d4f9e7e88d3882e8c1e1dbb86787a8863aa6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0169a370e68d377b8ebff628673f770f5f3ca4c4739b23ecaaefe907aa861491(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3b87a8afd3ea90f2ac30a2d66b267a245f2d2a12efb3ec5de30dfe9aa07445f7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8209564e6295aea80fff0f810054aa7b6111687443ad9e1793bf29cfe00cc41b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e8438cb93207ad3fafdeec1f7cd2863326e2d8cc89dc71a87c03e1a2379c7dd0(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanHsl]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__509e153aabce96cbc43724b51508c05995deae2c439253e6fdddeca163076234(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1d3829a635c680306a01f48513b3287894308922651e9d690d4891ee54c92055(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ed6c2897fa44096ed62770fd177bc16c2a90e2cf42844f1adc565293d67e8ca(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8f3e3ee868206928a2871a3cb5aa9ceff27fdf18d8b34621f4999686ca9fe7eb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2b6ce16226becdd0cc5e944d4f5953d10c7fcc808429e58fbe6afe14e1209c69(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d74b9abd10dd7ecd7c2dcd8b8c390acf9f37edae406ab3083596e959876543e1(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e60f87bf7837c02b6871dd889b960c8a14849cf58d211f72e31b64af65e96dd9(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanHsv]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__33fc9aa684d9ed61dde43cad3cf332b355fb8e0943199a8d081dc26f5d34381a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e3cf8e3b8ad4608543b348c0a7f821bc2b008d657779239219c1e73480c93cfd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d718d9555ff4546bc58f00bc5ae0215316b4ab9bdf2062063657aee130483a14(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8477498ace37a304d38162cc2a9ffa6973b8a5351dc4111ba3d33a2bffb554c7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b663b3447ef1922fa4e2cb3de7877804fe858d4b9afb824c2e8179f7154df8f2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d6ae5f41875a843263ac5e4dd2e5f4f9eebbbef047436137ec5e2efe542e0b3d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f9eef443a2346278f4ebec7b0fe254027665d282f2d7525c3899d167026d249(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab3affad75f8d473ff8d2ec8e274ead3bdf8713afbd837c4cb27ea92425d0f1a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanHsv]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__10e71c4a6a14e6d6530079977f25c6e26c17caf3a46a83deaa09e76dd2331199(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    dimension: typing.Optional[builtins.str] = None,
    dimension_var: typing.Optional[builtins.str] = None,
    equal: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionEqual, typing.Dict[builtins.str, typing.Any]]] = None,
    greater_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionGreaterThan, typing.Dict[builtins.str, typing.Any]]] = None,
    less_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionLessThan, typing.Dict[builtins.str, typing.Any]]] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__49273acf4536d04f1df18092de0d219af1476a48fa07958a58556dd9ab081108(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8133b29d9b0afc4574a2398514a42f161137480a131dac3a69cb912053ee740d(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__136625bc615791e37d7548f4cd49445a6ddea94fc5e4bbf4accad05fcbefbfd7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8dada5465169c935ef663e9823af2587a874e66af1bbe72ddd389659ee02c382(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionEqual],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__08cd688ead40371ae2171cd0c2356e4f2099d7dab72d9452cfdcb19ad2d6335d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__38d28d7d7dc8f866a45b2d1b7083526051b5c5300af6bb02a964318f276652ea(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionGreaterThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1d3cb43ee16027f841c14b8b5f3e901c5ae8dbb84bde4269c9c977f6b05ecb49(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2c5864dd0adb74a62b4ce44b56d9beb862ad8018a1d5f1755d10314524863c49(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfDimensionLessThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cf539fcfb88af0e84fa75cfbe32f40f16e257b9264423cc362b24aab99d7427d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0b6bf93655bf18dd2080719f61a9d3e6e63f40dd168da91d662add8e5b4f1450(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dfc4c5d68f4dbc3b79d043b184bbb2d8bbad1713409a9c98615324936174c8f5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b8a3205edb04fe9212f964af296a3cdf3e840e76486907dc0a713da447e7d3a7(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__20b8242b930ccd55237251226c1a6d7ca093ca27cfc72bb31cdc3591c6c0fd88(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0e0d800f0448890a6439144b2c1da0a7e0f533f72deba32a56857ab3e16375fb(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfDimension]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__68b3dc5aa3ef9ad1e081ed9e3aaa207ccb974e80bba43f34cd06f3d3ccb2f2bf(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e9cb934eb73469907f14d5bde226525cbdc77449646e2cf28255c64a789c6e45(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fc626fafc137c4477ec4e756d96689b891799f465baad6151e0086fa75f25882(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d10a7da302c78d90cec2604be0cfcf507e8d970d6051779c61e148d476a2a41(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d7e7f71f3d68d41a16a44931636fbe0886c18e0e251d2be303d557a0c85ca130(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7c41e6c61533d7fc610d8bba8f04ca7d0211f70af6af4bb2b41521a1cc79fa6e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfDimension]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__121cc42ebc0465c1884499e813eb96ab1e4a7fedb952202f90a7c8e7e6ca1b39(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    landscape: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationLandscape, typing.Dict[builtins.str, typing.Any]]] = None,
    portrait: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationPortrait, typing.Dict[builtins.str, typing.Any]]] = None,
    square: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationSquare, typing.Dict[builtins.str, typing.Any]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__40398543ec779ee2923d5216f86195869019b40bdd1d20619428994c282361ab(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d4b8c8ca9bb92cbfc73e646c203cb8c14f5e3d252e6ceab74ac9dd08580cb05(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__605e033dcbdd4b998d00706610115580c5a8ebe49d24e3e2d0b8bc97a4cfcac1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6ade9fcf5798b0e83f7af48dc74f8058651d461f5ebf0d01b709adc9a51b517a(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationLandscape],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__39303c86a003570d0f1a105d17bdddfeb4b31883802d36998df623c43ea69bbf(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__03a7084a07ad8251ff1a4a00a5d3a429fcbb8f68a99110fd354b5248f8c989ef(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d4e421514e6de4bf24a396a78ddb418740a36a90a4815ec716f303c0d8ac4cc8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8911b66882d903cab6fd499bcb87eec8255621e973eadffd439b456ef26b2b8c(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4e70d295eebe48e8f012fbe0006a20fce0818692541ee522f316fd52d5ff826d(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__63217fd3a1e083255aaae66beea48aa75e8148b1680ae37ccf3d5f1f3d753afa(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfOrientation]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0559e9e8d609ee26fbeaff41ca572dfc3ab635086b043b2ad4e7b5e7892062ca(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a6f1371481c7b73d53de4edca838ef7df368e9c5226064fbb4fdd248cb3946d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfOrientation]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6b5f8745500f1ee527f52929cdc672669c3079d67d27f04089090a905548822a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__45a68e09e6eec9a085b3cf46ce25f0a25047db86c10b49bb09b74f0cbed76a7c(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationPortrait],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8efc1b95d518010a0ea59d1e81cdfeea85d728978c3f8168a3c089662eab7a59(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e14f95c1b17ead812e411fb5bdcf4ac18356fb360ca3377e9c65c1ca1ad27a82(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfOrientationSquare],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac6bb4db2f0242f8db028659c408d4123101fe5eaec7a9a20f34113392d7e621(
    *,
    colors: typing.Optional[builtins.str] = None,
    colors_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be6f18c8dfd13d9a89565ea2969711a359a1729ec2327a5544f979603fe9f59a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2983d172152aa9cbad75160e203cf5fcc56567e6aaf14900a295aa5d5ae6e7b4(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5b9468f6dac6f53a856aaacaa875db55350c8a49326d35c119e2455a36258838(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e040530ba229601999441f6b37328222dc6b7d0d007c852ab00df83c3e0db54(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__abbd4f7b2921b093e078071e110ab8897923dcf3308d5636441ae08ff077aba3(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__32dac6b6c56380bcab31ca110fd86b2265feca864e4adbf0967c98a0e7ac7575(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanMaxColors]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__61d7a91df89ec93dac629072fb5cf5c17431f40c0ceae2bdfb5fef8e855f3172(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3cb05561e73e0a3fe81dc38381749d83e2b8c4a140f2088e07874d9824b55617(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d013c8c9a573e13f2594edc244a11453a3486a17aa02a4c949631f12c172f50(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__864632653100843c878ce73b26da57321fa7e83909b2756ca831eb050c22374b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanMaxColors]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f1d8393aeca793bfba06a39dac1353bdbf406f77f9a6eaaec0d964883038c061(
    *,
    horizontal: typing.Optional[builtins.str] = None,
    horizontal_var: typing.Optional[builtins.str] = None,
    vertical: typing.Optional[builtins.str] = None,
    vertical_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d34623e8f9bc4cc93847168b84fd186a03c6ed034de60c1e62598ccad9a2b8e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__db63ae7a58d04b650a260f4a9b04cb86382fa65f558aa3447f9aad443141abfc(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2fb82e21adecd0f64cade2b62a8886e4f38dc317f11e785df080053e5e9915a1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a9c5575baa914eafdf2a9ffc0d871fecc4daac0f2015246444ab2331b0fae81f(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fcc51bbffb237c17ad0d902fdd147c192d9dd71ae39237e62ca60c242b0510f3(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dc584369e189b67944475822f9bf478119b1e4f130bc3fe5015184856d2c7d6c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanMirror]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d7c6e973cae21fd98856e389171de6b6e80bc8ba66671dfe731ef71937fc2610(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bdbfab1e84070522019189842b962eb93f3b936b6278d2aa4f83951765c8f906(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a61f2a56f18aacf40ae6823ee582c8db34182fb567e4cb38236b39ca0f88b012(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7cfe39a5cc9ba2003e9935d7505d388239f1d4df11a4fa35877a5c3dfdcf2c11(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__db844a8b4168c8a6ca823756dd59e37a660c8e49e965663d2ae5b134f4292546(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__929b7db6ea5d9edcb67bda5f8916da31f907d583399403b32bda0d913846780a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanMirror]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a267596c1c081802f9416247f7af92ee70cf6a4e9c98d233499ed6362378a900(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__944195402c4609682597dd29d4eafd7826c1a670c1d652b03a25fe2505e18271(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f30cf70761fe825ca3a9e87aec59cc81dc15929c95e041a169aea7d78562602(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c62b6c691791d2865dc1e52e7304c1eaa9aeeef76f76b9808cfff8baf4acb17e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__03b634077d69b694e7afdfdd5b6781de2679d53ebd592bad6d1394021ffa5c2d(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b0aacb0dd32c3a769b8da355d47c77d96a2b82eccc4fdf23211e0810ffeade62(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__daf04258d96f7b870f1e7b94d54599e3359aa4e137662e029e1504f6c8d8f047(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanMonoHue]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f6c280e831aa59c645861cd29018a445e5403dc20003cd287aa93d6295597e8e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__92612de651f9dc6ae897d5c2ffd05d22bae31a5394cff52187ceddbf14a89ed1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1e6a527e19c41c6e6ffc562de455e0a10588a3d2a802961d57bdee662771436b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3b0861a5456218074a880e0c37ad5a010c5362c9e4f535e3207f7df5d99edfa8(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanMonoHue]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__740d323368dd5ca8fed4017e22040a9e2b9e4bc3b42a740ddd443ec7cc317891(
    *,
    opacity: typing.Optional[builtins.str] = None,
    opacity_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4303c0ec666aeb19fb154169473bc8580d934c9592e7406e50ec6aba294f8e3c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8b8c1a53aa92e6a5268a7f68867f17a7730e5974b391016207d2b78686231190(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__61418ced43e45139c56c5ea61ca5328a40f52ec614cfbda1d0dff8b6a5144f46(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__790ab8c7f015cf677bfdd68d4688761f78da05edc34ec377db275d228a8667a9(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__42bdb507da679f72326805fce223eff5be5e3036d54b2d1f2ed86fd58f9dc844(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4cfe46ba619c0069c49381908fd756fedc07d2fd01875870e733b43f16074f47(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanOpacity]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3564a0e82d2aaa13cdec4f95cb007df08a71acf0b821255b4e7d1ed99c6e1343(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7ac5776f380de24c02e21047105a4a4c5e149c5a3d55943ecfcea093b96aa347(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4f60ed8395b6782e8a5c35063d0f5a058ac8b1eaf93c328c61317806466840dc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c8461cd9f6379d869eddc5abae124f215678d928aa161f31c46b9e28380e6455(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanOpacity]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fda97b700da68f09837746436094ceeb58040ceafb8d07ae42888db64a19ad6c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__499b412f6709cdeb774f34ebb2443712fc99abc1951f77016a143a5262e88551(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a9b2cea88bd219fd0679a60d85e59bf89a576a64054f511e1540540415e9362(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanBlur, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e3a5ff29c7c53948c1fb441efe06f0e37bb8363ce1a0e1cd2b2e5107ea69b48(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanChromaKey, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__51a1715a809e74f39b9cb8e0f815425cb84c05d10fd4894c9c836c0ceeca0a94(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanComposite, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__893f38a2c770c5095382e07969f127d72459e4858ba00b6c9030abdab0c3140e(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanCompound, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__52958bf990c31f130e7fbab6e0f2cc9dca1cdf2894e3699e1a8d2c14190a43e9(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanContrast, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__09aa6e0c79e335f325ab7388f2098f8d646c041b16c73d616b57e64debc68e2c(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanGoop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b1e1b1f58f623b98a455157eac4293f1b5b8e6ae500c7b70be3a6ad5a3be6d60(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanGrayscale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9247c4970379ed46759e9a0affa60d29e18b8f4d3dc3d69df11074ea9b14bdda(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanHsl, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3c36cfd7f0f5cd4c9959ced027991f584a527bbbd4460811d8b36d71b5eeb5ec(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanHsv, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bcb27a730fa328ab6845e6e3d869c919d88c6d4064bcd6261c48a5a429a7d049(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfDimension, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac86d32282dae7061676ac219df3d7850b2dd710598ea500fe66c9520a8ea18d(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1c22b06a8ba3bb86de31547e94e7a404cfdbed7da7be333fdda52483adb95fe3(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanMaxColors, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5736d4be9aeaf21e288e20893b17ea90da9743097973df3577cf0ff59fee7f75(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanMirror, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6fb576e907a25058ab0c3483a235b5de4457d1fb4b965e70316e7d86d0d88def(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanMonoHue, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e69e088096c0af948ac7499222f835ba8b72505a35dc43a20fee535c6eee2d02(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanOpacity, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__40fbdcaefd7cd93a193b49a809d318409ca698062d32a17e34fc50dfe658c5e2(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanRemoveColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__de32fc280bba3bf50ec26f19207aba912e9f857fd9c37c2473b8bcbfe80b937b(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanUnsharpMask, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ec34a25f31414308c6877bf1324f0caccb7d2678adf7c46a929ba29d4a194147(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9eeb3d87b909702dfd1b089e6ee82fe099b32f6322af5d07a4e1b77db3aa4e81(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
    feather: typing.Optional[builtins.str] = None,
    feather_var: typing.Optional[builtins.str] = None,
    tolerance: typing.Optional[builtins.str] = None,
    tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ef75796f3cf4d0e2be006fd455affdddab7d8e9fd3256b5ed1b17f8df63d29f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1bb8e94b84f3628a55e8bfcdc229b9f052c5132afea2c92cb209749320f5c364(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d0045b26431008af384b6736c2f1caf6450d7699e6c925658124c85605598cb4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__58e367d4bdd3bdffbc529f5252dc2f6602b9f2b7d8f675190c3b3b13b4a51141(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__16db809f8253f2852acb2339eb2a743ea910d1f3cfb27fe2cd82877c9aae6ed7(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b4e6ea8ad1e373e37ec6e6728f01ea896896d0a8caae144ea6bc805c26c697ab(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanRemoveColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__52271d9d634c884ccbd1494904fda1681474c3dff19ddb47cf7ab5b2e0d7ef27(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8c3d7f43e84cb55791e685da852427436b0863ce09ddbf5c707e3c38ccbea1d2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__348cb9940df4dc07f6538062a1dc4e15dda94804ed49d8d1ec20db99b767a7e0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b0926097e1739a147ded5fcbe04ac346206e8c7a6ab9b78c4df2d1a3a2d3501b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2e99e53e31e4ed7d1ffce2125a599adeea14da7f4933a14c4659bcdf2a0d66bb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5499d5dcccb97cf38b0bb53e2c558096622bc551102097ee2c81510fab8beacd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__806ddd24139757187660eed948d2f191ee97fdb362515fb1d34e5ca0d2295021(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__667b794571c305578c9bc42eb48a72c5c2d0b551149ec3a897942a16fe98cf03(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanRemoveColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6b64b3d5bad094c3c5cd3074767bdf10daba5b09b95bb49c6516b667fbbde654(
    *,
    gain: typing.Optional[builtins.str] = None,
    gain_var: typing.Optional[builtins.str] = None,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
    threshold: typing.Optional[builtins.str] = None,
    threshold_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__418e2122d8415003230fb528f50cb6d4c5352ef761e37ba61d419239e834dec3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__46e7c858523172149bdcc5093deb7010bbfb706acdcc7404ad82d9a148553302(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e7b3dbeac84691483f612792eacf15350d2f521d82758d82268bcf4bc81029ea(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8af1c5a54f0477a1800e39251c1c1485423ebd3aaacb3480087642ff84fa48c7(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5d352572e811272d57f9be99a465b96108ec5da966facbc7fd3adef450a250aa(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8d718f6536c4e8970531ca8448a4be629c6f5d8da2b6ef0a2cd8e9b0d76a435c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanUnsharpMask]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7c9cfacfaa603c93319ffae29d35f1f3e74b08edf6b0389f7e0edba9174962a8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7389b8b817401d0ad81f686e5c5f5f3608bd0ea321bdabffa4d5f2451cb0fe76(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c68fb13e8522538dfcb6c90c15fdfc1fbf098bfafb1eb6a2344fd390d58020f0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__25848f7e716badda96292ada1e5804c64a7e0772c6e8e8947002ade2459ef6e4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__55782794a0d398afe23dd4f0f8bf82f1ab07fa4446457c40e3781fe3b2d0a323(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2cbc99ff1fffc99e091b5841b103364383c93f75728dfd02278b18b49c318b45(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af57382960e935b8069707ef45b441b6c6834abdd1ca6108a317e956ea7e496d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7370c102e6e3782cb3fad5b9188a8a6b004c8d259b881ec744d7be9c118762f7(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimensionLessThanUnsharpMask]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3af951f678ce01f394b4e955e6c7dcccf7e7ba4b50043fe9601f09303973a9dc(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a4d6a244bf2e499a5fa3be7779746c7e795b9e1f0b189e95f37af185550e21c6(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2671fe68ebbadc9b50f4c06125dac33597585afa5f60977373752cd75feb4fdf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a964f65dc46aa113f1f372be06b7d4670f7d1c0eded2d8e85e7839597bfb0bce(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__75cba9f7d3aa5595b2f3f265b7876a240fd2982fd7a8067a2b7ab8fbbe86e36d(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__775e9f01cb6b680b0039ce67987c3e12a3986d582c4d53d58f960f4ce298fc50(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimension]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b34658c75d2f35d24be929ff30a358caf2eeac0d3a5988dc9faf4765cc2c0e6e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a6f47928caaf870b4be68bc59c4c5f0045dcb33ffae884f4c7ab5cb77a5fc700(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b647b579fa2c0eb37dc130ba329f72d801332765bde69a37151b642041cf5c8a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f9d9102b2b1ca50cc9357caa16e28b0d4cfd7b83ed9a311d0d29c39fc0a31d2a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7e15f05c3d62baa65fa5bba1dbc10f357ae066103e4f2e6fe759612851462db9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b2e8a1945bfc408f6df9144710973d51c05218de69a2f2d4ff76313cf290a2dd(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimension]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c350698b63c04bacf631792f9a6f582a9b0d9f8eeb5881d7639d54a14bfda59a(
    *,
    colors: typing.Optional[builtins.str] = None,
    colors_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9fdd45d319066bb7a97b744890c32343524c569adbfde709c145bb9a44142681(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f1247898b9b88b138b254fb1741d72f328358b76dad384d1bb7db13439466dc2(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b5090223c52fa60737f7e4cf6da2383b721ea0feca0ba79952c8252c895c90c0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e68c1388cbf5edb36e673123ceb16bf1b36b2d63b1f4d5cd8764aa9d8a422ee8(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e777b98ce51b6d7cc159fd12a36f19b266631d9b6b420b6137d3880b3f6482b3(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9451e5d75b920378fcaa0f6b458453767770e01be59ca29e18cce3be6ffe8ed3(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareMaxColors]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__06815e9161350e2bcbbad39256e62903dd1521478bd76f1773557371eb7f2854(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ae79749a0c3267ff33009c181843d88c020611e6e1fd9e844758387a733043ad(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__346cc14174801e157b25f868bb1ca32b119e7a23d784ebadff1ef1414145a293(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__644d81518476886d839a2d368c9ba9a4442c4617fd51d3730b114261e5d3efda(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareMaxColors]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1b20d9400a165a7747830aec436175a5109fc00741a31aa532b03387e5ee4295(
    *,
    horizontal: typing.Optional[builtins.str] = None,
    horizontal_var: typing.Optional[builtins.str] = None,
    vertical: typing.Optional[builtins.str] = None,
    vertical_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bffab46fa1255c212125b56a13c90bdc80ead6d124dbcb45876884e9c323fd62(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__88520f81535ed767104a1752035e2cec1ed4f902bcd8655a35c0d5cc2f5c9893(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__868f3e0f554e7398ad3709a34db26213b00b2c547d37327779360433f3225360(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2c4eee29bbc8cb7243f0bbaca1e729702e227c8ba240f9b58eef99f72ecc73bf(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__618234439834f3cc133d9e3e6eed6b764d1546de524eabe4e83ee83e3068a6e5(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__71a6e73771e8aa48147a1939169e06547733af6de16c438ae5a4d797252cca43(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareMirror]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__90e9c741609aaa9a2f11a48bf9f6e7cd60e4e42beb20f38f26eb843355f24ed0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__99a8d8d15c21d2343f44f2f22d6d7220c17b14c2a55548cbc149513e73fe0180(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__80b8c11bb2163239b07001113a5d81eb09afd177d3e8f2080044c3efdc8a7261(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d21bfef86c8355a9d88661bacb8f300c8d556a8efdef7405fcee9dc48f3c7225(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c72474655cf46b3b6cdd1181e2992866eaaae3c37dfa69365da157363233a5ba(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f277c227834a8427aec04a50b6018f5ccc957e0c7fb203f62ed6fbeaf12199f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareMirror]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__632948b27dbd217adda95ce74f257ce048a4343ea543209aba78d61a43f47144(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1659c9ca041b7aaa5e06b8e74a951be55f187922138fed4ca39043d869be7efd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__77da94019b1c72d36d30002b8f06addff6ef1481eaf77c544cd8f80f2a58573e(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd34fd92e70ae36a630003dddefc75f938f4bd5841be44a7f3fa07985d15cc94(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9fc52c75827aea4ed4f3a7c203283ef03cddec7e7b13f68de68c42a28f7d8404(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3fb53d2330cdcfff64f43f5cd70e40367c3e94976c8e2a94888912fb9e7b577b(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__86e0659ca67687bf215f6f18aa0fff3cf227fdc379527db85650ba438d604231(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareMonoHue]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fc4701d3283632d409d61bc2f531598c652e9207a7c3e5ad1c10542678c849c9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__820a16cb6c095dc1e0111ec77ee41f85b9b9bd78e079ab2621c5b46c1604f6e5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__afd4b7b636a8d1f932c6e2d8d31b451dbf621f3ba75eb85f0539adb1a15dfc82(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e1169075f9ad2bd28dcaa205e569e426fed6008601f4c9248533cda4af91881f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareMonoHue]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__43deb0d74b506b9ef8ff54bd82f595a623969afd54d170f1ce7edc0f5f83ff1a(
    *,
    opacity: typing.Optional[builtins.str] = None,
    opacity_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0323015d3bbebef572efb736d2c99809351f8b2a2fa63bec1f21ee9c6a7b083b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7a2bd3bedba5b0d639f07c3429a80b8c6de69ef7142d7cba6e10a43bc88b1d2c(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5abc686610754a528c13cffb0085dd96d9435cd8e496005306181b36aacbad19(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aca50911f53c088e8f7ba89f57b5a18586a904965b6263db04e88240dc31a3a9(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e1604d088174856b2d9f101db54a3e207b2aa3f83b9227d01c245a573125dbb6(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d813ccd10b026902b1235091675996818d2fb1472d7e0933f72a1e0fa480284b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareOpacity]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a2978fbe71750ab27fbd72144260bd4728f96c520ce2ea8a35ad6ae67d3aceee(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f73ff1af03257fca779a8355e339037c6f4902a917be8fe824c20cc4e3bdb34b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d9764520e418bb4e3926efcd09952b1776e0281f3449d5afddc8baecc5def820(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e26caf742d83c1e97f43ea6ba74138b90631ff2802e30d2760ee928b2b780443(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareOpacity]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d734da07dc311caf31b71c3c8acd89af91328c89b5224583d3e64cc85a538a6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7a6fd0c097bba1562686959c85f3a477acfc6b31f12a6c65e73e8e393653095d(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a838b8e8f52ed3b20b42b21043899f75241c75e69afe63f0c6d22e3e9718a78f(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareBlur, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f69f4ece1eee458b71ac7720541f232d76f2515fbfbd7fcbe93396a8ec6619df(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareChromaKey, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__26e28a8f4e0312ce43823ac6fe6d65e7b69b2b0b75b7384b4799412601ea1a33(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareComposite, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3791d267bfbb60004129c40b9f7db731338d386ca83c1d0180e3287abb731259(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareCompound, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__13eaa2764ded42232a4ed6dc2ad0996a27ac656938362cbd579efa794096ad85(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareContrast, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5c112af0f03d3755d0e6ee4a1685fd05de3d1a51bab1b6a8c0d31f199df82e71(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareGoop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ea9b1edc16d1d257ad39f1706583b31b6b0a5e07e62e260cdb70ad3f2a68227(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareGrayscale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ca01429803c3aa11a1500ff6e7ae0bb04f32465dc959f1f7d0b6dcabcaca55f4(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareHsl, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__301242b6d4437263b2f597f5c7220bb8a2caebb57751e7733916010eb51505c1(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareHsv, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8e9ed35a88e40f93fe5289268c2dce702c4fad7a4cbf74c3895c25b3b3a85214(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareIfDimension, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9f907c82e87bd7953406c6956130a744d155f88c375bbb720d5e556c5bc28187(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__21cfde728808418b2bb0211144ec62a76d821ac44c7d987313ea1a934a03c477(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareMaxColors, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__97d982ea8fda498baffcb3469d9462bdb8ed0fa6d2cee1d71cf46604485b38a7(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareMirror, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b213eaab76b399bfaed01efcfc0ef94a5b96a696e237c6fc1d33d70ae7d7932f(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareMonoHue, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__51e764acd8f89bafa29e803172fcf7f132351b5543392992939c246356582e07(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareOpacity, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8e82eccff7e8531bde930196ef8e745417a4a64ef93a48e3ef30a064aa574f26(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareRemoveColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5a710d4fbce72afaf56f1405033fe325fc9954f299843463177919b84111d17f(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareUnsharpMask, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5e44fe3d17114ae11d54b75b1fa9686bb7bfccdbdb3065e0c06d0204d0f7771b(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquare],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2afb0d09bd27deb7866b1209a1334e9c8739877c667a89e15ecc14a1a3f1bc94(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
    feather: typing.Optional[builtins.str] = None,
    feather_var: typing.Optional[builtins.str] = None,
    tolerance: typing.Optional[builtins.str] = None,
    tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0d372982429b8adf0593362337bc11eabb2f3fdfe11c19185294272f0a5cc526(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__273751fb38b3c53e7d4d6a2808b7d27079b2b32a4c515f7f5419e8ad1e483355(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__782c1c46faf95df6f719f04b4a0b920fe7b456bf2fb9e57e2d5482043eaa704a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__734b0ac8147954ba6f54637a8d683e41728fd4680ac42fae262e09c94fe67016(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2b852ead06b72d138e8b99095c9a389b149f6137e03a4348ba2fbfc8977e6363(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8461b8d5ae629a3649f2d3365df7d997c4e92eb502e8814c5f360878837e8d74(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareRemoveColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7b073fa5f9ebd40029f2fe3b98a7c20eb6b40fbd744c56719e4f1d806d7ed41c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d1cfb3f60de88915024ab2386300415631c9f60c8340c3864a2d91acb12b09e9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eb4496348339ba8b57229f695fd7030fecb6619c9260cac437da9e44ae167adf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d4f7a5cdbc5e04bfeb2ef67876332a998372d125f8552f9eb140597c5bf5d258(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c234eaba8d1fe48a4e95777e4d319f514224b971a0daa8acc232c79dc2464beb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__34038f751db69669e38ef9617a63d665b109a9686b8b1231f69d7127c1e3a308(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__84f70d7a2b1217b32d6381e989164c145661f75338f51d81454ad3c3e2849518(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0aa5f5635194897149058d6844b3c01e2769693e53e63eeb83b6c39732be83e0(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareRemoveColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__22754ee1f5b20695366d0c666ca260f787ee4354f1af9105b24a7bf2221f0fd4(
    *,
    gain: typing.Optional[builtins.str] = None,
    gain_var: typing.Optional[builtins.str] = None,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
    threshold: typing.Optional[builtins.str] = None,
    threshold_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1db575fb02e68b2b5239d770879ec5ff5248bb3da76287abad4a28a0e4ade342(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c91ee3482c415d3d26d64f71d6e73b3841a1a2e789cc80fcb5d66b8a66735c5f(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e1b2f0e155519766cf4210da97d7364ed074708696aafb0ca74eff5fba3381c8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__98d3877026f1da576943dc349ec4474317f09de110c8ed4f0f1fe0f68f82afcf(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__daa858afa3bda7871515b43c46fab66e1411dcccf06f086740d830fd5d8132e3(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1ff7ce41c632011817bda78cc43f047b5ed00cede73c3af6109824ded30ae8f3(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareUnsharpMask]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ce7cd06837cd0760f30297b0401529621639a2654b03a31a00f5e1aa8207df7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d6c6bb1dca497f9d84db4633536c997279e76208aa3a72baf38a06af296a36a6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__de8cab2f00721d28dc07de3cc6061f13343c767c0a72497c57905b8927598196(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4227bf3ca964816b4bf4366bbba41047c72b886d33f7bda19f20e394da34440a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__28de90b84ab98cf6aae3e779de37af5bf1f804e300557c3ede90f76730963ae3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6fb1f5d4ab28a48c256ae43bbf36afe869d38bce7e8a81c15b19d9aea6e67b93(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8195bcb52ddb3d8788e4c40cacd3c7daac78e284dce2300c69ac87f3826b714c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ab7ac8d119a39f5784c586258167464c64942b1d72f0ccfcd315d42508c91b6(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationSquareUnsharpMask]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7c06b99930c543cdd5143b9fc9085f24e9b3da6e4d8ecdb77c97c81a60967283(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d455f9f9d1657548b13d70b7007048e2545c0667b62f0e153ad98bdd92bae355(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a184d550629e1c5152548913135ebb1406084a2e2d027775bbd238e77119ce3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__60a6ee8aea2aaf271198c42ba66498f8f9941dbc58fc8ea5e62b6e6187a93338(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e48b6393c76886f48a3cbe054d3cbdad093940796944e4853686cfb3c0f68f12(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__357ea0850bdc630294db3af035790cb2b8de81b87fe83f5a2986c4f5bdf14e73(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformations]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bf958555f31533b5f817695211bae6d9b94b015a1cfa98dc1e5b66565529eab2(
    *,
    colors: typing.Optional[builtins.str] = None,
    colors_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ce6335439f0e7d79770d308247dff2262e542cc62cc3797c31ed7a2173153e5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a3f312f425971f59b5482b55c1c75a99cdb116f5168a83fc36ca728e58ee4a0a(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9eec94818be97bede66553e16de7dbf6752e8c0d7fcb14b84ac3cab1b24aa8a6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e767386c869aba5ca079d284bb9f027169c8775e277ac43a5eb9f9daf8f5e83e(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fdb291e4dc1dc3c3aaaf8d8865692fa47b8bd22da68cba98751a2cc73558d87e(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e241773f612931d54103a6465b7771a763dc1c928c52aafd322e1f89a10d74a3(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsMaxColors]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f8e7a7ebcd5ed6c02c427b2bb471c3c391223cbb119cc73fab6b3ef361d4ff61(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a6e28d37eb7cf2b3465e43e476dc0a0b005bd9a61032f164872a731f61e03021(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1ae4c9123462eee2d0716250a6d05740c2988ebd0f2f3746b2001e7491c8419e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3d122bfc6b8a28eb1c9e06ce7c5693d8d44aee72dcfab6d67d5c2246477bb4f0(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsMaxColors]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3183901d75b2e2c17ecf697c51cff6c53e7bf91ed51aef4ba8bbc64b461fd8cb(
    *,
    horizontal: typing.Optional[builtins.str] = None,
    horizontal_var: typing.Optional[builtins.str] = None,
    vertical: typing.Optional[builtins.str] = None,
    vertical_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c2633054903cafb87fd561e1026e7bb198a20d1effb71b344a82cb1d0458bfd5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c35846d08d4e9da5a9e04744624a64c4ebbcf7ec04b4ee7f34eecdd45beaa575(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__398fb3f9e5e3d4e5f726043e385f72be5bb9d70c8f25f3777554d721178a7281(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__094cc735a008c188677e72692d217449b229abcd3349eacc20b21f352a5baddd(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a1c0570682975c055d12c6ca371aed99559e02a761fb88bb8045b713d43b7651(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e451fca464ca52d15f8d2d1849370e0990c0a8b508e19b66ac35c8136a218850(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsMirror]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__37dfaf12c60695d5b490a9a2e342b5c7d44ee3aba3a2d22980426306a316eb00(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d6b11b383f4b15f01324a4eaae37ded6b0ef10511d967fc12ec105f1383c5ae0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a4d9d5646080dd8b38b5d33ecc1d8f500123340ffe826a8f01567559e688ed62(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b1cdbc73432dfc3de92c4be46bc4ce5273707370ea841f6348da3aaa26dea0ce(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__68a3714b2985dc642eff211b3eb9d863d79e7ab6a2da1bcbcd06bb342d3e52af(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8ab476157b8843230d55006c34206ef13beeb3f544ec9297d836f49b1016ed78(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsMirror]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d0828224110a6674e2a3c0d9f72fca65b7bf9d1b0cc228d8739b0bea4b63f93a(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a2f032a55aa3f23c4438e8de158533b5974d95702bd0e8f09905a6947e934ef6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__041eb3eced7a2ac44fb37ffd850fa54ead71294f0ee56406e4626ebf8896c080(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0c9bbd78084636d06d75700648828bd133f0e0a8a90a1e81e11106d85f515865(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__54d5bc9d5f98ceb62890baede4edd61d60367474e99fb8fde84926291414e1f3(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__470b1f28cbc5bed40dc5e8fe0b395bcf5829f00f1eb8616de187e65b7737f127(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__669f389c497a9af808df85d2fc025d6cc2707fe5eee8cb663292d02c65f7fecf(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsMonoHue]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d8777bebe294404f13e431d354be255423b29cc4f98b8a8f3c875e6129454600(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d74b2992168b46b3c7d914f61355d0ee80fea7293294f3173a6c6e187581f8c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6bf7d651f57168ded3a622c5ff8be34a303e3e3e3dc27f2307d1a65ee65af074(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__73d85924c7be4a142ffd455030483e29d99c825b84437cee5b2777568fd6bc27(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsMonoHue]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a85573015ffa2855ceb4469ee95eea8ed5064f37df8efdf9eb55977017fc99ca(
    *,
    opacity: typing.Optional[builtins.str] = None,
    opacity_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f72de442955d414c9290793a0eedc39061fc73b74f54ee28926774296c0c4907(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__88f412b5d7bfc801b2c0aef5a05c5b0190647585e79c15f48cf225ef6085a109(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a54e6d5e535ce280eae00dc1ca8af481b036f2d13a10457813e99214f1c5ba27(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a5522a1a378a4ad5947fab8bb5a5a9ab8a74eb85f3a11a90af07a19395253f55(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eaefb3d6b349cd807cfff0b71fd79e82b92b0b48cce582c55502b7bd5fecd6bd(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e12a383c172b83a72881248bad6d2f187c7df003fc19766ee409c212745501e9(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsOpacity]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f230b6979c4827724d598e543611fcd0fbcd007638708c4eddd6eeacb8e5cfa(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9f29dea7e6c509b0e01d7ae0aaf548a9f5075b76da4f9e1ea2738bad39be0475(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__02351a7369e2e43d22cbf0cd9ce316e0ed5cdfc5c107896c0e5e080ac99efa6b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__14f233fa75d0edf0212656dcc667c35cefc4c7b8e6743dd2c903c9228a7e7012(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsOpacity]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a8515c841eef63cceaf5d8f08d74195070470653a25b6db84f11d52c73dc3105(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c03e1261006112ed996ac947b4bb2bd5cc9c4dacb73d114debf94ce70aed4810(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5b08241e7abaacd6490b835afeabbf42e5b014a9b778003d428673f90a042ab0(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsBlur, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8af72ebbadfa1b70e384a659fa132211d35c5381c9c4163c90dabc95722e267e(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsChromaKey, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__16a1d1c9f40c8b747e13e0aea15ca79d509c066d1a2125d7daa4e07df2b302d1(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsComposite, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__32c0ecce1b977536b62276b460ac4f15f6c6c58db9324b5eac318f947b9c5351(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompound, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a0858d5248d2abff619a727376d49eb5ccf37e45984efe20c748340ea4cd4716(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsContrast, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb33032acd67ace1d9c0d048e58ec9bb259e9c64fd685db882b7c44f7b66f280(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsGoop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f965fcfbe7655578d8c116cab50b6a9a5b0d0f7871d96603f0ad6c088aac3397(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsGrayscale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6ae40c9f2894e1df209915185249fc43c36f2a89c7620987c297c7146e95564a(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsHsl, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9056ffa593d30dc56c7fec477bb2acb642ec23540ee5f98b3328e6d10b19788a(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsHsv, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b23982c0e3b1a2932daf4cc03f9cbacadc625256fc994cc6bab22909737657f0(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimension, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b58c99b5a108dfe878f54f9b8edd8d182c3939431a9b2069a4b7e44ffc51ccc8(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d2240aaf107108c09ff7e96ba40cd4ee37f785205ba2d0656e2f9933f6c8311c(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsMaxColors, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__34933008d61b5ed1b1a02a129d0ce7f04b7e02c1e753d0999fc2c6b74bdd48a9(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsMirror, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__143fe64218e4b22c2f4bf486171ede39c436b5fe9d9179f193edf3a8ca2c2691(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsMonoHue, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e95aa54b895e9f93143dca4f6452bd7cf658283fa466ab92303c53d8949342ea(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsOpacity, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab78354fb3949446abd0030500fa4bc7532e919353d7990acb46e66b8675e5ec(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsRemoveColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8017f23ee8b2f3b229217029928f1ddd7600eec4d69162302eab2e65612dace5(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsUnsharpMask, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8e9b6c2e845d7166dc0df296dfde6ac191050c441fbce9e351275b42649af00a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformations]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4bff67005b729f3a22730ad37aeedd57a6fb6388d055faae1b62cb56edccd804(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
    feather: typing.Optional[builtins.str] = None,
    feather_var: typing.Optional[builtins.str] = None,
    tolerance: typing.Optional[builtins.str] = None,
    tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__12ded0dcfdec623db6221f9372a4b4f7e961a9d670b48a9db119436bbd7ed7a6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3e06536ed8cb3341beeb7cda743d7287193acff3c7cb29b129ca1b10d479230a(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__73fe544963815a7d39e6e67d12707179be132ef3bb7fb4b48c2c3798d3b799ab(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__25315419c90ce9403fde9f7b2ecb4725cbda84ca38375ad023ff2767a1cdddcd(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dec3f7869add0969700e6dadf7d747525608acb89f9d28a40374ed9563fc6e1e(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__238a5bf1e4fd7d7d20044bffca7b3e033028513d78fed4ff07873e949a59ec31(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsRemoveColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__811067e5eb108ca1e49aa8d4afb2e77cf31ce8565a82b778a40452059f1580a4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__723bd23a5825dda3aa4dc24f623003bf2e2e4cf0fd7aaef81421f3bbc6459558(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__109a45045e53923d31b03a2934c8730dc71a1bbb26843aa955c546a424d7e8c3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bec7ceeee75cdbd4023bb5066fc2d258772b5781ae972ca40eac59ec5a467ee2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e8c3e0a43adbd7ca70053d4ab497da41baffbda61b34ace72afabfb2656f530b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0dfb9ce5753b484b62c1e17a012f0622b1ad1342dc028fe20c88c8c0de0d57bd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b5084b361fd04475604e211c965a29867d5841c1c7f7307b657b6eebf2b6132b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__62e3df16b9438a8b53fad7af784e531517c5eb81e112a5479c20b531f8dde0de(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsRemoveColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7c6180b03c60091419e550b12a55a79f822f1371a1ebe07d3a5052037e56d1aa(
    *,
    gain: typing.Optional[builtins.str] = None,
    gain_var: typing.Optional[builtins.str] = None,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
    threshold: typing.Optional[builtins.str] = None,
    threshold_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9fa8f68c450ce1e03d9016b6b5632bdd94b63daa62b9d7359bf28f1f451bf666(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a2d2eb6393b8eb8720876310f3cf0a1e20fb3678e5158308dba4a12ba41d8b0b(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3062cd772b2b9182bfe7f12dd42cf72925cb4ba8f3132d7c4bdc19f64b18b0be(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a43111372ff1b0ee57bcafaf91cc5995791a4833322b35d84de06c2e711e3d21(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3e6c010659efd09da12ddca10aec4ee75b92125386c8fe2e428f1810f69ac520(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__75288cc35e2a3db7934abc623e7298a9fcfc4672c9b15fd2b1d7c188363e0d75(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsUnsharpMask]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e0d8e79feee9f87a40ac8e0991778a4915101ce7fdb1b10c9c8b554d276251b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ef2f575c5889fea0e14d32850807986b3b74d189b7231fbc75bf66c74a308c22(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__05eeae90d9a7b2018e18bdd825a03963c24a5f671af9d42e213d2b6c5f8b1cfe(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6c815c7908b085084b0dd457a0e4d0f207073bb887c13362a010e67c67a4267f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3eba1837dc39795ac8590c86c86e93da9f34597c2e058644e1c1ec3019c2fab8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a07daff33eac9baeb916542bbb0f44859022480c12d455ef8f2e833663645df1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e3458021990ce3e86c5f744a0f0af68796d515eeee5041b42d916fbc11793306(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a7e143e30458c5293d54c94663b3bc865df8210fc5b39b8fe8b2906f2dcdb72b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsUnsharpMask]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bf59c345deb8d31de42602dd30951216f6deadef172dd6e278906c52e9728ae9(
    *,
    append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppend, typing.Dict[builtins.str, typing.Any]]]]] = None,
    aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAspectCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
    chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
    composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
    compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
    contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
    crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFaceCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFeatureCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFill, typing.Dict[builtins.str, typing.Any]]]]] = None,
    goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
    im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsImQuery, typing.Dict[builtins.str, typing.Any]]]]] = None,
    max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
    opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
    region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsRegionOfInterestCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsRelativeCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsResize, typing.Dict[builtins.str, typing.Any]]]]] = None,
    rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsRotate, typing.Dict[builtins.str, typing.Any]]]]] = None,
    scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsScale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsShear, typing.Dict[builtins.str, typing.Any]]]]] = None,
    trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsTrim, typing.Dict[builtins.str, typing.Any]]]]] = None,
    unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__40469326e5e44412f7c9820ab1609667892430fa832f30ded55adbf5ea33fb51(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_priority: typing.Optional[builtins.str] = None,
    gravity_priority_var: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    preserve_minor_dimension: typing.Optional[builtins.str] = None,
    preserve_minor_dimension_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__57c9eb235a16d83dd88a116303eb48f7abfa7a01c6c1d985a1d65c93d4658b82(
    *,
    box_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
    circle_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
    text_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
    url_image: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImage, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__087f80c5a9b4960d5321776af549f56d2b6fc2975d6d88187e34fb9a3f51d1ed(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    transformation: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__21c5b73d6f98c725b950dc7de5ebbabe48b66f2fd9e3edc44bd8571a30cbb6c9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fe9c9ee4e0dcfa6f28e1971c4dbcc52bce21afea3d5040e3ed300c5308eea435(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4b9dc9e6114c0f8467bf9192cc3be2ec26e181bf68bfab93a16b8b9b4c012fce(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea5255a8a234a0a2e5f0485979459aaa31a7bc5124c4a6828464f6553e5ab5d1(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f4d49b75cb96c02ec27043143d03019812b436533a86b255127b2a910f150fa2(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__715f80429e463651f482693bcace06ad8f0b05719fd57c0cdbe85e5a8589b975(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImage]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e80a1697b41fe4d768a7d48ba3dd4f743b136b051ab65c9a51b6e9c70b322a6b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d7ef12a7b78065fdbe8bd91587404749864e0ab99c87e0705fd51e6fe0335b2d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d6aca3c65e27d6ba5f387e513568b1c9bbc370e870ef70d2cd047a771e469242(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a8f3c0a5a676c4e60a9e980c2e46e88d488252a20335a3ba8af6b28934faeccb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1deffa5ed6e7c25479e3e126721fb0decfb5b41f8140667e79b7d8331ef31e84(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__50eb699f908912a987072239a81c0613c2a747e828b8d6887a161df3a8c4ed2a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e3c07a26949956d8edadebf01822ef64021ec78e2e0b55e5466c1416fe4983df(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4d43785bab6d8e3e7c3157578e063c95152efb869c7144f7a0c1a5099c7a69ee(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImage]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b57bf7ade4772c48a5d459fc343aa598270e08f9356b34d62849b30ec8a33801(
    *,
    append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationAppend, typing.Dict[builtins.str, typing.Any]]]]] = None,
    aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationAspectCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
    chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
    composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
    compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
    contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
    crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationFaceCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationFeatureCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationFitAndFill, typing.Dict[builtins.str, typing.Any]]]]] = None,
    goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
    im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationImQuery, typing.Dict[builtins.str, typing.Any]]]]] = None,
    max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
    opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
    region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationRegionOfInterestCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationRelativeCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationResize, typing.Dict[builtins.str, typing.Any]]]]] = None,
    rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationRotate, typing.Dict[builtins.str, typing.Any]]]]] = None,
    scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationScale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationShear, typing.Dict[builtins.str, typing.Any]]]]] = None,
    trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationTrim, typing.Dict[builtins.str, typing.Any]]]]] = None,
    unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b6db311bea1abafd70fec83a56a45c22ab1ea90155e08ca5ce5537dcedf1a8d4(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationAppendImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_priority: typing.Optional[builtins.str] = None,
    gravity_priority_var: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    preserve_minor_dimension: typing.Optional[builtins.str] = None,
    preserve_minor_dimension_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__155150b12b9717194394b127956393a51e445b89747f71f7e42285475cdd92db(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0a2a16401708df2f0ffbdf282f1b081ff3ed8bb371fa00fd8ed54fc1491c1179(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationAppendImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__39bc0607eec7fc3876e3fce4efbcff979cd72a6fab74a2ff0f3ff2844459c946(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__25f7a89447320f9926f23b6845b9ec4130f3796c91856c97fef84b97f1844a53(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0f4761b4fe59c277fda2140e4ec978981a7dbb0c1cd55f2a7a143caa34bbb60c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a5c9379effe7ce34ec80e68e8d04a4f44336e7cd9fe7103eb74bb81c1a9562cb(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0fe1250217cc786017637e2ceb33582c48d42a720eb1718e9df81215b025acb7(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ae19e4b04a662d5c58ff2ceaaddd5ac5ec60746c5fb1062bd7ff4c9ecb933d73(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationAppend]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb2de65c938e0780a4959aacad97fc9f2f8e2d88aaf5ac53f10f48a66721d390(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0dba69fe3f61d92d895e8c1be4d9c093f64148c1b49737cc7800341fa341fe1a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__36f313cdfa6ed3ea4a9962716b9cd9a52cc234124291593b08e64fb111cc5285(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5bbfb9e36f701862133f4ce64f9034f9719d93d7edb4655fa0e39fe19eece506(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d22c9ac32c228d2a9b37b91c3b1910f46716e51941051abb6b34e5fe1af03f0a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be462f71589aa15b0eacca927e8e3eee6f5b96ac6de4841c223c726327597bcc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5364be47a14afd726a76cf1e41726408138265d24d6fbec097fbaa15c1e3ae8a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dc73b77e933289780cdd9bf0a9737c29449c642b41c2cc99a6257dc52671c85f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationAppend]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1673a860c2793512336b495706d5a48b2898b3f79335b7d278703711b9141af1(
    *,
    allow_expansion: typing.Optional[builtins.str] = None,
    allow_expansion_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d688fbf344180295d9b1369fe79c6d2723a5ca37128b36599841e5d225eb97a1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d012927c2e87cdf65a6e53e998f2f69b996648db0d93416032453d77304f8395(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fc877555a5c6d173643dd79e520afcbaaa3fb651836206531444e68a5247a028(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7a9b1c81a8b54d94a3ed6cd58eb5373a43e0bdc8bd1cf3eb0dd1f6ceb41ec4dd(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d21cb2f18a337871d4bbae1244f6327f57ce06dc0193f76f6d8b095efa54e402(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ba18b8fdaacd18fe61903992f8ea9663f703c09bcdc1eba574b0ead98e4b3ac(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationAspectCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__425c0ef7eb85648fb92198db7e1d22697fb4501206d5da57aa0d5c35cee7fa2b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6b281d49e2d97133e6f26278a4172110c77466743a34f628b452dbafc6083b67(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5655f76c4da7ef2e6e0df2e4bcbe0a3a9ce4267a1c68af4f7b21b09c06f792ee(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__89f60a55228232ad6f94f9a044fbeeb77d34bbcd485b0e15001f7b3c4fecc594(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ef8c36f2a0da76f814c7a7cc73fc3d235b2f97ded7c9b70340392d1ab382735b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0e5a15a9398609c240cfbb08ef1231747d370ddb2fe6382a1b20afbe8e60f7d8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b7ff039d15747b5289f699c55178179166fd7b030cbf4a31610ea8aba4a52e26(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__34632a3fd996a7d88a24511d17dc7cd56b016cb705770ccf163457eb29801f59(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__40b247b428e3c291139d39072d6c32e7f81c7d149e70481e8b406f59ae6202ce(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3864ce3ab360b36b03a5f4ded24a8a0edf9e27fce87926161d7ef95c7e6f2664(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2be16777866ef73592262b9b880663ff45a70b20e13a5b223431debe0c1aa0cd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__68ef6c9a2e808af2b58735de7cfb89f35253545b01ae431a71c98524cc37cfb7(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationAspectCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__13186aa4efb7660e93ce17080f27bc0b6fddfcfd5d5b248efca4b1b225c83b81(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__04282ca55c49fd6cd25421339dbf4fca35c3ef099be6e2725df7a4a8ec24ddb0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1bc4de741b66ea2660ecd0d0f711c5d8ff255433dafc62761c0ae00ec40bbec7(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a923d3fd113fc61399f71cdc2ff358d57f5f9ac4f5303baa6943b99c4701ee53(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__404223f03dbccfde666d18e65d54ac3cb37a1b2f6eb79b12b5fbe257d1afdc8b(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__564e4cefd978080f77c6944a306946d42ae6e3d38df189468566e424f417f25c(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8b8a15f3c423a4b6734921aad99ab28409bc836cdceb82d26e2ad29e0ff453a8(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationBackgroundColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9c28cb8c71a88c52c2a1304d6f32959cc09098dbfc666e68b8b5b5e5a3c89a59(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1083d40a5f644cbf7181f7dede5df41f75f89431826a630985e72fc1d3898caf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__988047f4465fba8d5ba57294634dee40554c5ec178c61a65cf10a9fb9f9d79ae(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a4bd361d5572c4b615b3689a937097e8606adfdf326b4033d60e89b250e5698d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationBackgroundColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d350ba131d9800991c15abf9f5e99f57a35978893f9c08f1704520debbabf57(
    *,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__776ea2113c0e4e44efa70a6cf44ce41d7fcc0dd88e2201f5c7c4cffc2abc433b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0be522c1ada3659628dac234971599ba8418e71c3cedfe02a2b443930c7e62bd(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5a539d7540f5d862e8958646d790096575fe81595f58165ccc9e124bf4521d62(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eb4d267a21ed58d32422da3cf9e5fcf5ec1cc6cc128131e39f0d72b8d197c625(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e289c4318b2ed2e68ce0c1123a9bc3a26c5d630afa2e9c1ee27b6cba1fc976eb(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f5d33ec56d0590af47a4da3d95a39c3cf4f4da419d2d532cc05c4c79b1a98e0(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationBlur]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__70a3d761ece9152e61bb05dd727cf9fe51e84ef3b3be824920b4bfaa2fbdf923(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__86df0c4a5e7c80ac7550e0a16cc7998b01850835d8b71ba25fd01230be9f9c9b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__629ef945cedb17edab003354e0a10c7ab9fb9747f7d50fd8d28bd5b6c0e6d751(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8408de57ee61a63b7411165b4fb5588093f401937f31f7db7254d5ef0d5c66be(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationBlur]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__69909065f0635db0a84366e689b2844d96d538adc7a00c3b9acd8c8de15d26f8(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_feather: typing.Optional[builtins.str] = None,
    hue_feather_var: typing.Optional[builtins.str] = None,
    hue_tolerance: typing.Optional[builtins.str] = None,
    hue_tolerance_var: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness_feather: typing.Optional[builtins.str] = None,
    lightness_feather_var: typing.Optional[builtins.str] = None,
    lightness_tolerance: typing.Optional[builtins.str] = None,
    lightness_tolerance_var: typing.Optional[builtins.str] = None,
    saturation_feather: typing.Optional[builtins.str] = None,
    saturation_feather_var: typing.Optional[builtins.str] = None,
    saturation_tolerance: typing.Optional[builtins.str] = None,
    saturation_tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a8102ca68e242fdfcd9b5f3c8b95d02e1d35ab27bdb5a61232953147b772d96(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6ae65790c88fc1582898a4f3a76cc1026463bc23580589bbcbe68903e64a0129(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f2858f566d248cc46ed155df0e92c635b2963d51c2db3e37f10de9e321a18a94(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4b0f6a067ee33f24af153e9a772bf66ef52c5270c05258cf528b395407b3985f(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8fac82627cdf89a9a406ff25c04d4b69b9ace79e3e185881e55acf8f6b053c02(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a6ef7a49989d39f0c7f445d2b0668d8b50c2a2acdaf35cf0238dfa094b9bc5e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationChromaKey]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9029cc6a49b2fab328507ebbfbb517c591ab259b1f56534d94f05f7a4aa4aa3d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7846501524c72a1e98116b8b4a2ce1ddc3709aa49b033de056754a800f4efba8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__24aba8ef230ca3a1c4aa2b27152a79bb5f58ca2178547e1aa89b90412c80f389(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f5231b3929b965cabb20cae7aa7929ca5780cdfa392ce9fb9710759ef4ef2b02(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__89eaa7e9e66dc9ea1a694933e6a355a2764be7e2dea1c9a280e8f70dda86e847(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__80cb4437d6be84ced00ba1389632aadfc0a4da5f4dcfc04270c9973ec6b9ea8f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a94ee3aaa72c8df1f11bc0f9148a3464a9d9e2b7f7989594f8d28114735fbaf2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f3175d0db508e5ab2e2f3f102a742ff3e0060715bc8c5d4d91370d55afe08551(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2133ef1345ea25b0cc1a706261cfd960325b9aa314c2bf1d6f644722208b5766(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__153b0295e89252082033447124eeef602ce4b73e5ee2eb0451002cb722c13ca8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7721552bb78e30cbcd66f4f63eba70d28e94daefaa5a8d9722e13118629f3c3e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7681556c47e1d2ebe5c1a7a4a6d6a2e1b3b1c6266b195cbaff89dca0aec460b6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ae75b9af852cbf54c29424dc2a1de5430c6549c938dbd9f485f103f0c8b0376(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e726e5d403c878406743155b081af42180d0a8c3b87f72f024757075528550eb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea5af0d28eb2675bff58ada4cf2696fb30284d1630f0dd4d11a1501de2e342f1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6988e9ec73536c78443a01dd3534b9acc0cf75604b0f951f176a030377a5b294(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationChromaKey]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ee4e648fbcdc86ff57b9a4f07f4789fa29518061c30fbba15725184062b75c4(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationCompositeImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    placement: typing.Optional[builtins.str] = None,
    placement_var: typing.Optional[builtins.str] = None,
    scale: typing.Optional[builtins.str] = None,
    scale_dimension: typing.Optional[builtins.str] = None,
    scale_dimension_var: typing.Optional[builtins.str] = None,
    scale_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0d15f4d8b8ee9facda5bb63938c2e6ec3cb3b3f02508dd2f4d43652c8862249c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__50b1f9e39ab1dc1b6b14104c7983f55c6feff1a2bf62e7303fc3ea705fc5b698(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationCompositeImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e59983c997427586601a9b4842e2784a12b6ba658d08b3a3602184eee61f82ee(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__87eeaabebbec1a72b5c647fab0de2af32f23cb7112408c4516d9fa253bd0fb0b(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5748b248cebba76ba3228dfae3ade2140f31bb92348ab362d49c129d9f3d7ce2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1d4a7d0cf1895df3b883a28e4af6a0d4d208e7c6a9c417b7ebad8cb2e7e89cec(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a975392b82f21017809227d67f4ba00e725bddad4a4556b51e26c2e49e66d4ae(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__21f8990fc9c0babfb73bf899afc14cc6119dda78a2f9e743d36628bae563d858(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationComposite]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2b713eb581e9c3f322419c149519a196354e03f5915a35e4fddd299ae53a9ef8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__626ed45d2a7258325341e113bd2dad31958c2653494dc38ab9bc6aeefe7cb6b1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5fd1e86ed5ae85e41f2480cac80861a01be873631eef1914cffafced1c6dbdbf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__47628e83a25dcb46e900dae30cf64891371fecff64650b9c48af3ce17fb9520d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__13330820f53d2dce1679b0f871fa0b27a0187a3dd778155030dd0ca52bfaa986(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2b531c6421752919a74539cfbe14b7fb5b3477c3e9a09e247171abd8f8886b57(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6386f8680c2470c114c30179270904640d3a30308765f72fc3a6e42806c01b99(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a29e1d4e77a253b097aea369774e1140d736d8dc4b7f770ce7ebb597b5e4d2b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4b626aa97ef154df85238b07a5fcf771ea79443f4b7bbc0eb1a916483ad22dc1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e7adb160b4bff166f74e3afd97134bda9b58e98e24dce65f30a13ef45dc44588(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aa1b9143d49e8a7a6c4182f447778ba7979e6f7955113ec76ca294491a7eebd7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a292699e47a48badcf1cd85b41dd2f6b20440854db325bb7168873b4fa29362f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b253234d579ce19d0e3f2165a3212575f806920b26a5d797b8d1180ccc158a2f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1891a5e59c51e197bbc223951a79abf15c4f4d45117a38d475959bfef98c39c3(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationComposite]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__32c8d623645b35bfc9639606bc01a1b849f49c4ef43c68385509d0c06a527137(
    *,
    transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__caebd8b2159fda4e82f0365bfe1706c1e3fa8bff2fe8c8d6c0cb3a5010fe4cf9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e5b4a96625e2805c40183e08ac05b1c0bed392f5fda58c66a404b0f8ad34b983(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__14380dac9ae49e9654abc673bd671ea757cc5b8a4d2c0aa9fb9175f864c96cda(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__05f7e454bbcc7da29d63c3433054292db863afde456ce208df443669973f0812(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__67c5ad6e6c474b96e0e796997d4401ce7a657b6a196d8de3b6ca76bfadf9969d(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__800ed29dbe142af681e8fb4fcd51c32a9dbe95f385cdf9f8465d9c0c8ede28d3(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationCompound]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a3ac33f12d80625bf43bd8b0e31580b9dafb0b4437d2b3fcb525ff9f1487af0d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__64a0b553911037146347d37345a43696862f182479e12702e2c8223842720a6b(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__09c857dad06be213c80b0f778727e918225abbfdb5f347c073a67666f7ab7350(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationCompound]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b81cefe50298086518b5a2d8f19eae297aef3cc627c830230514fa146cd85167(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__67552e8a247b0fbb146c74c99a75a7c59461374d5e698ed6b84b30e57fe7b764(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fbec378c17a9a953fa9dccf09312ecaba39335ceb039db22929fded0e2d00e64(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f46ef30376f04fbe398caa9f60434929c66c7a27b0327fea252a35f5e3b785e(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e096eb0731e0633974d866a9c1932861941eb46238504c3a9177c85c4d494a69(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__96e331c22277a23fabb2192a920e11eb6b0c971c6ddc0244cc23700643180a93(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationCompoundTransformations]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3d7d0a90265e5c4a06e55e5e89e9c149598f120d42226553129aebc8cb83ba00(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8d413177f0b7afc5a9d40a4f14ad43ad4d140f5c01b0edf6cc47810765759f77(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationCompoundTransformations]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__17db9030e59331613c98f6754c871ca3949f7201cd88c4431e61baa93dce22ba(
    *,
    brightness: typing.Optional[builtins.str] = None,
    brightness_var: typing.Optional[builtins.str] = None,
    contrast: typing.Optional[builtins.str] = None,
    contrast_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b0e07b1c0d582841d859202970cf71acf540ed9695d544e0b3534bd078d5f8f5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__551df55dc7c404a9e97a33fe7ced8afb641050ee2fc64ccf15dc741a0cfb135f(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0521bf92ea356a29f5b3578342f62017b3ac03ba4085f98fa2685af1d010513b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2703933a3af52b24a91962825dc0ceaed441ba81ae33aa626ccb18feac6efd18(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a5abee1b829d516d3cec20bd06a92f87c270782d301a04520d545ce6cb7b80f(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__68ab79612705f865ce86b045b4d52721ee1fe9fcdaa1091de7b6af6ee8d2cafd(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationContrast]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__269620048ce2798337a67410dbffefa84cf0d0217cd5c6fe1512827234a6fadb(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__059e7307ac7a4146854c04d0d668bc5fab029b37f0497eb6f452ba043cadd6c6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__85295200fc12b347e2f7907203f5f2eac599f72976c2a954c3d2ac126333f1a5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f24bfbd352c6649957db03a8c7034ff796c94a7545017eb4bc5d6d69d0747e12(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__738f77f2dc8ee581f3099240d5c831d05d515b869e73fc4be20fc4daee41c04f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5477bc5fe6ea7f0f1876054c06356589cf06314c14772c9c8295e54a990b0d36(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationContrast]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__978a169301768d2ef2fca6ef3bb54b2226cc5fcdc839aa894bbf33fbd80068bb(
    *,
    allow_expansion: typing.Optional[builtins.str] = None,
    allow_expansion_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__78ed87aa3b8fedb4e4ab9194f42a0c26f0abefbe5193196c1d42b4fd4646c056(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__727b764863ec14fc3ed318a93ebf7a87db8e579f4baaf7571f68484287c0fe60(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__617fe5840ab39bb514f7511bb92bd7da328a8576b65a0e75210287e551c070c1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__10952a4606d2c03c047cc32890419e7df76002472664602cdf9cb61680774f09(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8ab32eb12f69ca901343feca845d5cdc0fa33d5764c8f9edc1003e339bea60bf(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9c6875426b0db2b435a2a9bd98d1c46266489d73028fc3660300ce6bdfc79999(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e8480af38367880054311a66d9dbe6ed137e9f9cfd5e8a8d265e9ad4cc94e2b6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__003bdbeb5e02aa09cfbd6264819409c27d19138b51138924c8d60273a0dda860(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__813b35eaa29e12b90e01c0cd2e5c46b502eecf863aabae35509d900fe3580615(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7219ae78975d2739c0213e1644d296e8cbc79b5213a0c602ead3778ef6b4e8d8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__73385375fd1551d9f6433ac49b85661a6612d5968d1a804e3c0b6ab866ded93f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea1837bafd68370a013d8dac5b7bcaca92d327b9720f26eba3bed53b887bee31(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9980000058d2996b5e92a019ab90951ad2ead31de34ea089de8af2d3fe55812b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b220deba9b1d964d8822cda609113a51578802835d66f8444a462825d01ac261(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1a0968d18a99f15a6b25a7cf516c19ef9cd480db9476ef0669be500482f02afd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a1192c801ec16bfc56d99ea456d61db11038f0e69c3b1efb4e998be4db8019d6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__533f989b6a8f1077b1b7c4785827cc6b6930b22ed27a18ccc1678e73c29b2806(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2b0f418b82d16dc19d90a79ab46246272ae68368947384a614ee9e69246f5175(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ba6dece10a6a260a91dfa0091782e081ffc7dc8c751350e772c03581e157c05(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ff55c7aa09e4ccec5795d8fd6b253af2e3f9731f55bb4c96c351c3378fb33c31(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__27e98e229d2490c984c30ebda3b4c343fd4523a552c263727300298e42d180a1(
    *,
    algorithm: typing.Optional[builtins.str] = None,
    algorithm_var: typing.Optional[builtins.str] = None,
    confidence: typing.Optional[builtins.str] = None,
    confidence_var: typing.Optional[builtins.str] = None,
    fail_gravity: typing.Optional[builtins.str] = None,
    fail_gravity_var: typing.Optional[builtins.str] = None,
    focus: typing.Optional[builtins.str] = None,
    focus_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__974278d19e61428daaa372e2433b5927f8aad207c21faf2748e98255f2fb5698(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__24293bbbca96ac33fdd7f9de958381919dc2106119b556a582676300b904e357(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__00c01f4cdadd12ef8a722b3d76918412ac6c2f1743993c99a9fa90a0840e4e6c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__209c51e01d50d1dc5688cbee5588adfc3940ab4b3b99e03426343acc8dd15011(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f740ae8d18363143bc8d1b5dda59dd2fe1bfb1ccd8126460abc9f04361f52269(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5d0f92823f173c72d17c03330bd1194275cefd6519978606373cf63865393d7b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationFaceCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2b778a0df1cecdbe0d36ee9390685c66b36672fd01585ba4a630c9a351f92940(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df233c5e6d3ab32e397de5ee6b95b392d9fae4537118ffc3d1158fa930e2920d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__695e54d411fa1f03ed633165ad41e9f154b1cd07a7c7c7b7fa9f577cd0862f23(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__698a29540095b4e0fb7c961fa59e7bacf3a6189b518ad87b6b5fde3ee93c220b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7bf2c68c8228b05fe370df95b4fa6d85074c45b74973af106b7f4b5fd2a4fd22(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0185eac279ae33c416ea31184d59e3596fb412f39a1c292f903b6498d585ac5e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1a1774b21406997d14456e8076c7dc1df52ddcf8de018efadfbb06dad8218f41(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e08b8e47898e3a8129bd3665568507c19c8fc99077dabb10e42b68ce56b2c17d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__15910beaeb09833a5148060d9cce48599da28d1cfc752c572a1612fbb8453ea0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8f720f4363b6b9a46eead3e8bd26ba77f248779ae9e0b9fcc6b590fbc1810efb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__83bd614a5c881b4e8fffa5d42294488ba16ef659d44420a145c8cbf351bae3ed(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e83a5013d5414d41f5e8e28ba53db1d5a04c211418c7103f254a7994e4e7194b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7fff3e45c2d4cbb181bf424a1e9f1c7346f520102e460f99035d2670c5c9efea(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af7d9ee1c9b8bffaa723a8d21b8c4299bb85fba061b78d03bfdb96ccf2257f68(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a6dad5ddb1146e44ee78e586f50d3664ed48f5fe02c5ecdbac042655c09ba0e4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c100c7a233f316696f9c7ae947165274b2ce19dfc6196083c06956c6c3cbfef8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c0625687f878628a4b7ed7f9b101f6e5543d69cf6f9600066a4e82958be43e66(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1e2cac64c80f2aeed370f4d5e87d5703fa07aec43e1e664157417c96bf40aef8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__877466f849429be92c35081cc52bef27118645ab93ba48403e81bed340b8d8b4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__889ac4a5c2915fe96fd697672a43e8d4154c09845ad0481e2ec4a6415e4112c1(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationFaceCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c6e4b1b50ab0b353f63d060bdaad2107656211722fca78341bd7991fa10f5597(
    *,
    fail_gravity: typing.Optional[builtins.str] = None,
    fail_gravity_var: typing.Optional[builtins.str] = None,
    feature_radius: typing.Optional[builtins.str] = None,
    feature_radius_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    max_features: typing.Optional[builtins.str] = None,
    max_features_var: typing.Optional[builtins.str] = None,
    min_feature_quality: typing.Optional[builtins.str] = None,
    min_feature_quality_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cb7198de47332993892ba8e9f747cf929c9b4ae07b42a03228ac86545fa6c395(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__74fecdbe66e9f5e76a48d35d51b9d0a9ab26961275131f9010900ca0110c31c8(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d1dac18bd2ab699080a4ad83d3cce3620cd84a48a9da681d21a8d9bf7f8ba1f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f0fe2584d5778993c8eda32bcda8f98bed2c57de892fb27b92f25d825978f9e(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__57aa49903ab2bb83efce1a7603e83b2ef8e6fc58aabf19b7bc65effdd7d7e3d2(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0a464633908f91c27240ba47448ef4ec6ffef915b06484e64373fda31df33624(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationFeatureCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__585dfc3efe0bb16a729e336a59bed611b095921b17efb53ed07949fd80347bc9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5145f01096755964dffe5d66f722f9703c3205910a75966af820e3d2a7bba45e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a6b8c2077df76781abdd0156f1e4785c313ff8d1c6c35be2d59a07749889f816(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bdf92a55e5cebb345a3fa6a9684d0538571f693d956bfb6d9d01f492a48fa9d3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f909062f403fe3805c0e9fbfda71847198422c8bde5fe09ccc41afd56d796106(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ae2f1fca636cd44ee51129a24ceec0995c2f6f3a0fe0a2493d31a4619c565359(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c8a5196a5cdf011c5d2d22c7ceb3ab17cd2f27e7d46f4b7e342307f58c665027(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6ba104bc24910a1fcc21783462480eb97c423f5f969971e5537a5cd1760677d2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bbfea382fb4f00e6b13d8f18ed1a9ab3932262d979978ab9e1dfaff3d6087c21(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4f52f8308b7e27ae1d5202d367173127490f741087c0c766da3330550273b736(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__902ca6af7bc19e7cb05b58e82328c459bd729ade466492c9064ec36eba94969e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d65dbbca1f511a386523589587ce80a074a6044c85af87364d82905181a0e33e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__46b05752c091b34f82402da127e1b0f5408eb37adb04ac135ee8e3bcb576b94b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c389e3cf5879c4608bc4eff2360dd4f578ca45908b5106cb123b30fa022e8923(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__91c40b4f5c159351580214a0a6e3b8f11e4734bcfe4477c46ff57c886b209fae(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b5a81dc031d14321a65477b8384f2ce5b1c439ec21669d3f9218a2c1b03b18c4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__00e09db6d5d9e2c66681bc87e4519c6c91ac451a634fc4ccedca5976bb9840d6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea26dbea854a571865dbf13f75adcd731bc0cb2f88aafad022e464f0a9bbccf3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dc27a99d2fe6b7032aca1eb28058f081bfcbb75b85a93bce7d4c79a2efa8a89a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fa576968cf6511f3e88ed5ef54b94a9862982c75eb24669b07a5c3e20c12f25d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationFeatureCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7ed46a9f80b434181808f9e919b9cfc79e984319add6ecc836fd2ae5b1e81f78(
    *,
    fill_transformation: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationFitAndFillFillTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a30fd6ed83f84839f43cab610f5549ac5d060a9ad8164d02bbc9788b57e296e7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2b4696ba7fd8738118029f1979852acdc623ee0c894c39bfbeff039f5c90c6ea(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationFitAndFillFillTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fc4218f4a2ed503bd169bc37a45d7089420d995d992bd1c23c1780f8d942a003(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bf4236dd901dd9029c420d2455e2591b3907d477d39d2bf0ce6409e8d616db93(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__31f856e663df2a49718f7a6a15c1ee2c683e84a3e7f85de370ebe8207814a725(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__13e1a7843cc8805dd588d74c49633482d2a50536f3ffdf73be5f8ff1a4b4dbdf(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__93b6a51d97a4bcb1e5dd5ad70e4007b617a176b129a9359113319ee044cdf09c(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__42956a67fbc4ea1d1d78429bc27f79ae9082704b82ea36754563ae6c1f07b89c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationFitAndFill]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9512a306b393435b6a841bd7f15e52bdb17ad20d59987f58c1c12b574fef92e5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e4214066cb1fba22b48a4077d52759b8a73a2e03d2b7b08e43bec69d044a9cad(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4177e0c0d8567b989762da2d8a9c4323f188ed99fc759e0c7bf60c721df8083d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bebb4cb04c5cf4507361723e80b9333ddd6b8686c0d48318291c8d4f4c35936c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4aa3a6fa4a7318ab066a5d0c6a405deaca7bf4dabe8d6a9e9e73f49bcc3b58a1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ae46f74ef4bde82f884f421e7d4953f7840a8b28bab37a78e6f653e4d790018b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationFitAndFill]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a1f5f874a5d3ec9bcebba011afaee069f62b33d356363ee39de49e9dff4606b(
    *,
    chaos: typing.Optional[builtins.str] = None,
    chaos_var: typing.Optional[builtins.str] = None,
    density: typing.Optional[builtins.str] = None,
    density_var: typing.Optional[builtins.str] = None,
    power: typing.Optional[builtins.str] = None,
    power_var: typing.Optional[builtins.str] = None,
    seed: typing.Optional[builtins.str] = None,
    seed_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cb6fdd4a09531759d776000872da612461632d1ef063e17d9bb34a00ccde0434(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__02f42b04bc2f3a143e48df86cab38d44ae83b4537323a2d0421f5502bf422de0(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e95d5079e81bae2522130e182cc21133b1128fce8019dcd49a989660c9aab42c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__44c324fe1f5d7499268009d00fb0021b1be8335827e5ed684ff532ae701c4884(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e49ff221de92466543af18ef9d8622d35fead16b58b4b297019950422e28e613(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__75909a134fd3c46258221081fe7e2d6cd94c523574efa1b05dd0cd02004a33a8(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationGoop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__83b8493a5bce32fb3812306759555b70d6f7828a4b413d407f32bd9c7f8edc49(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ca47302c7e56588c91653d926740e16cb3b67158297b64f2d3ce0ba4030f239e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__65a8c8174716122986a4e216504beecc3ff40879e7a154700812f991a9cda850(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7fa58835992ea2028a0c74e8b42bc06cbe45c693ba2aa096b0157165ba466eba(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4aa54725033298ecf56990fd31eb2e6c66d6220cdef468a592021430c0cf6fcb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f5fe7f558908dd0992c8d3ad83a48e2c0063f36d778259a3038de5c1c393a175(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0308aa91a5c4375948d0e400a4186408c6982f9603e8749ebc9eab2a4552adf6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a0cd848c1b341e234d84682ae6ca2d8908e6cf6e1087386361e61175616fc38(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8bf3725a01fc29d40b4cddf886d985a1016099f1bd0d2c1a1e27d12801c3dbf8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e489382ee43cb88d5ec63403b01d77f1cbc94fbc9ec3f3a04f70301b5ea5a170(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationGoop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aebdff91e0b79e8caa781f36f8d64c35b7a3f7df288857067362097393b1f0fc(
    *,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__540a4f4d9fba77bc116d589f16185020e275e229d660becb42ab46a279a88457(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__864fe51f6e2393418c4b64280db9ddcd55931e93b20fc51adc69dec4f2920ff3(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a4e4149d5b222b76774038d5d267cad03f79c1597f10ef187bf960a431e89db8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7bb60dc3460ff32c16998fbf4cbe713d60267f23699fed92c309ea215beb7973(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__59da27a7f02de4ea93379e5c3f9c8c7f32b380f9e8ab18123da3171aa05037b0(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b4dc442e43ed6ac41d0ed6a3227319ad7786420f0afa6f5b52195f915043476a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationGrayscale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9f566769f1a208c1ad50fe65b7b01761fc028c7fb8fe341625344885544fd9ce(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3eee9cd7f8bfbdbf0544091f4735f3027bcd5cd7a961e9dc3c7c6a9c5aab0c09(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f7c389c8ee58f0ffdcbb1dc6d3693a69709a8d7b87378031e6d0a2af3b3773e9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7ea7167c813a550ebe4343906adefc5cdb47b938bd5bbbd175c8b8cb4469470a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationGrayscale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b7f4b4eaae12d584e954e7ea6a43d52596080b7a14eb71c1c8e2756760fde02a(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness: typing.Optional[builtins.str] = None,
    lightness_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8f82f92cb892cfdf3fb61a1e4d496595f8a8aac03c1c6d24acbb0821983b2d5d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dfa8c0f6e41e6266c49aca40410a58e486096d604511a5c6366f4b0073fd506b(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__09c6ed311be25833ac0d0d07bc9229603ba211b12a3ee353722c6fe5c6bf0115(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ade54b9ca5943dd8a2d3c11dd7c7e696166357d2e1b8f5ecfa047e6c3679a382(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__40b567d106f8e77c9bb729264a37ad42f17b91008991c61c58d730158d63511d(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6197938336fc793ef9ed1ef6183ed696a6e2fae5c87dd4b0665b6298135c755f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationHsl]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eb6081a1a8a70c7e76fa06e77f624e58f43bf4899efebb92a6251775cbc16c99(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0d91cff179e49f3f26627e1c7a9675d4fcbbdfb94a72f6c0b78c6b80d46c1ac5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__55dbf2a522d64927bf55964a1a34fbe683e8a7de0e53cd61b83725c6d8948f53(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__00aa4dea4d82b1f8d88e21188f59b99720a9e71c0a006de824a735d54165c254(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c365a0bc5da37bec645d4c664c0bf15f1a537d0bf60e398bdb31267a79e57064(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__03fb5eb2c8a4ccd9847fdf4e93cd59c66f841920583eb7e406597ac146120054(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d4ce46c9b160a22034d4c1acf7af66edf74128d86ab6599a83a881f1fc555b89(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2f46b04a35aec68f74e3a32e792010fde18fc53dac2198be180518a87e490499(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationHsl]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b25e85fb412c4b0d76eee320e0f09f941232653c89d832292bd619baf81dccbf(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c037b4d22a0a4ac646de1cb0c7acf5025338702209b230462ecad4e85056eac9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__feefb6f0c0ce9045fa9b7d441d2d7529ce0a1374911c2b609bb3c3eaf2755768(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b24c01be9ef9ff2eeb974bca1d7a53119622c52a2d12b1887bd5af5c08861a33(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__03434cbcb8afc776ee7aed7bc157fe1faefe2ffa631ac9b857a3e8b0f29b19a0(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3597d9d9d1c878cb08ccf5220c2cf67ffc9af1d0e34c976f3880e34a7286c9d2(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0abb127c77a05ac7192cd12b5ee869cca33f4f07e65d521e776c5d90f102e300(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationHsv]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3dd230cbf23608ad65b347b4e609ba9abb478844dc8a14a9ed3551093e43c4b9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ae536a7cdeaac244c87aeb6c8c385808652218d566f9f10ad230ff409b28cd4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__89e481c45c767a6d4a5240a7e022041e962ee05c4aebe23ef8633c0d25e1bdd9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f6f925e3e0e28211f27ec52c4b92cb983e12f9247d0d7695e42d38156f4ec14(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__77b653c81419336fb85e06b356ee2f36c33f45d1876ad0167d79c8bff99b307b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e4159d1f493c03dd92b089fe1b6c5181b21614228932b1b404d98bde0cde68f4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__627e49f62ea3ab8a1a99fcbbafee21b584894162b56633c33f726944e4d0d5c8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bbf9a9a847e1e257c0ce43dcd967c22b0e9416f836680b532dee62161de8d346(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationHsv]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3375b728c8384d02b79fa4baf92ae3aa192451666fd681404a1e1b33b4cac241(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfDimensionDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    dimension: typing.Optional[builtins.str] = None,
    dimension_var: typing.Optional[builtins.str] = None,
    equal: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfDimensionEqual, typing.Dict[builtins.str, typing.Any]]] = None,
    greater_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfDimensionGreaterThan, typing.Dict[builtins.str, typing.Any]]] = None,
    less_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfDimensionLessThan, typing.Dict[builtins.str, typing.Any]]] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4cd4e81bab1f229f6fada9d3316016a0fd1d72a1777e0adb229f8e32502e75bd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a7c84a3323fd2abaa716d82fca810172e339f02cf5df7973b4c1824ab13ca725(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfDimensionDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__873672a5edcf551eb1aa34c5bbb95749b1e4ecbe978ae34721f5701ce6e51102(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b95941e9ee29446af058c4c932d233a03e347bb9ae87412d438606cd42af603d(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfDimensionEqual],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f1aa8715a145c82cf751a31b362cd9e2bd901fc6971569592a66dc3c93e6a1a3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0caa24dc97eb18a95486da3094d93bead7e2379a4e7f3e1c93053aa27d9ff2f9(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfDimensionGreaterThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__07e3eb3aaa31e727b878605ef04d26f4d751fea3aeda234ed1b293f68cd5f6cd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3fad04492175a188d115cc1581d3d4e9073bda88572b0340f1c9f3cbf31e3607(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfDimensionLessThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2dd950ab0253d035a35cdbb7675d88953fb503411420f6ac3fc95008cdefb04f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c3b9a770d1a8674b954fe17f47d4ac3bc5e58be58a21ac9675b9c14425be57b8(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ea8d63cdcd129391ac05fb96bbacbde3de53ef07aece28541ff6921e007398a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1034aa5b6c142cb3525c4ff0bcbcf36cfc639abc35ed40aac04bf32377921282(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1d0f7722aeafe6e30c5fa09a0ea5740b93de6f2c8c435e56be0c80da37b0f659(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c107930c3dfb6846672c5755122f511b1d8d5db21a8c8e048f686d905fdd20f7(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfDimension]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__76c60d085ee37487e638d3f5902a6cb8fc2b4cbb84242ef8c321d02dba4367ae(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__71a639dad04c13e60ee50ba56aaa3344c44f0b271460aec7e269877be23b7f8b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__169a9fc2091c8b1bf177f496238b694f0acfc841fd4d21e1a9e19652c82666bf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__830053a5130cccfdae5ed49714c575838e7edc59cd2c15cde935086ea59f29fa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d54022d88e860ef9a11f70f56c5dc2868caf5d7bdb306079520a4147af9fc37c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__771d348270d0f0eea02d9ff3b3b34bb5a63abda8db58467b7a877ab3297268aa(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfDimension]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b8934af39b7425c15e7283000d28da2ef54a49c2e31b69879b683986f334c57d(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfOrientationDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    landscape: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfOrientationLandscape, typing.Dict[builtins.str, typing.Any]]] = None,
    portrait: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfOrientationPortrait, typing.Dict[builtins.str, typing.Any]]] = None,
    square: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfOrientationSquare, typing.Dict[builtins.str, typing.Any]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d929339da189f1e2f8aa60cfaac9249516e16cf87d01c490aaca66bc737e905f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ed9549ea040e0dad25f181e11294767f8ffb42a5d8b24974eb21b013a3eb1f11(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfOrientationDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eb563af5c4ae917709bfffedcc36522ab8e54369306aa6ff02199c4c18adacf0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__84e2404bc76d4227b9a8eafe6cd87a0399a0f11ba52dd69766e3047ecd777a8e(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfOrientationLandscape],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d67a879089a0727eab9c8852a9593763cce0cec888c4d65457afedf25dd465e6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__655f0c9f563e4ff2cfb0d6721bb5338a1c881b709c056f9bf45d3f2b5eea1ecc(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__98a72e32166178c4436292f6c9ce450eda751de160b3a79ce8b83e9c1a3aebb1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d2fd7630425cf41f479020d126cdc985b9fc793326196175a6a5cb839f3d56dc(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__15cc78e8f3d9542d9c697c3753d426fe1315c032bc8e6f26a40d98f4c560c480(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2cfb231b93f1315939ef62c023f3ea6861caaec745d2826aefed8c4f6d597ada(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfOrientation]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c6d1e410b71abcb37572e8a6772f08885257672ba9e18d4055030caa0e0c2f82(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__75fbfa3ddfdcdc25876cd0b2f8dd9eac1cd288b2c53b350ce5279aafe7da6435(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfOrientation]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cea2344d0dbfea201c4f689ad1eb0a52207c5042e460e6945b4f4033ec67044d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2515f9eea1d5db7589a4a933fcfb84023f6fc1f3c064a7b423421406d51a99c6(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfOrientationPortrait],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af95f25bcd941f1c7dcb48852a398da6b01b8dc28f33a2423f57e5ab5eecb31a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2699712642f13ba410d5673d0155e821d72d66ad73fc1043e2f443dbbb7f25cc(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfOrientationSquare],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b87de97123f5e3f31fa85450823cfc6163ca98b667d45278fe4ee8d32ee23d68(
    *,
    allowed_transformations: typing.Sequence[builtins.str],
    query_var: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab60bde9291229336db93e76fdad2c7a8c1ee58408998504c8fc9589d14c14a4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ff54eb6fc07b109ceb3d6e18f833312af0b90bda46d9d3a1446c5a440883284(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__39705cdb4f510c7913f69221f80735dd31fe0a5383a2b40362c42f230b696580(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__09537a663213ed34b79f9c61a9c904737c4dbd4f712b556e2ced17e3cedb0293(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a70c2cc66ffed624707df49889d6b6801152ca83e1c08f1d1a6eda37f2109d95(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0968aa500a63a7a9467b61b73c476fd75e4095f1354319fc1c7e3cceecec21a5(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationImQuery]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ed4968e70b8ec865473b56f4269da34d704d982f09f8fd384a4030beef771617(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__427203b87f1406d505c9ab241f8ca696adb353afb66bd80124303b50c9917e95(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c1fd9a25d6ced651eeddb6c7156fe0134735df8a413d571d19123a1e28b7a5de(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df9bbf3543168f874326341944fa567884b48ab82fe52031ec678bf42ce1cfdf(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationImQuery]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__38c17947830ddd2d5044b163efa4918282a70d409f2f9723d82a375e156c1ad5(
    *,
    colors: typing.Optional[builtins.str] = None,
    colors_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5c03dbbc5b6aaeb1a4d9c31c5d1a6ab35c6315a1686356de152965beffa02416(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__91b9abf3fbed85d5b043563f42c2078ffa81bfa6faa32e8f0e21728169ccf9f5(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a7e8ed4bd77b41c39372aaf28eca26a1c026e559c835069c434b82a2e2d52ec8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bafd93c2e0b9c1c8b186fc8c185c1b03bc28b840b8b2d6ea619d1b66efe9fad4(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a17bc6a647a8332179293b42bee0b97b6ad4c53633ee0009060d3bafe9cf9ee5(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3f93bb8a06e5714739910013e4e7b35885259248b6481201c70ef7ff38ffeac0(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationMaxColors]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a028f28692e26bad8782e95647611d552bcedb6eefd23c62161fefb8f60f5273(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d7eb89f88a0963ec8963386c339cf0df8eec47f2b3e94c3abd8dbbca4b90b853(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2beb097210a8070ea80f2ee2d570f5f0c570a822305e1794ccbdf6a583d4d421(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__22db725c2e2465b9afc4214a9c39619a1b16cae793c6f615787057b2be782bbf(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationMaxColors]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8afb233fe1d9746c3ebae4b889269b50b8db1b54c2e9474796d541ad4192e9cf(
    *,
    horizontal: typing.Optional[builtins.str] = None,
    horizontal_var: typing.Optional[builtins.str] = None,
    vertical: typing.Optional[builtins.str] = None,
    vertical_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2dd1260d8775f9c0c2023e2a7523574dd680ed9ac78af6474b1e0fd7a1f3afde(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1a92318186c4764f8a0445d6cecccfe09c0170f4101597a2044bfec181fc02d5(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5a77419b9d0307586995c407b81f810d347ac1f2d734e25cdc27f7319608ef7b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c154b239d6d7234adaeec10091a908fc7167bcab1b22ef3f6e8e7557d43c1485(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a741f819215646654d17af7c98ef95ecb218995714910e5a16b06211562535e3(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1173dd52d81c554e8d0f0bcb5cb10a30e811df0669c0f1ebf0329d912a35f1cb(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationMirror]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a2b8efba80be7b18df405c01a17342e3e30859be81c71df28c38abcddf35b51f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4f7bd437305bed0a93841e10b709cd4b5fe46062718710a603951f96a6d1758a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__60e0e1a4ef0399531f2190407ee9e8d441309c903ee2f80e84af4044a8260026(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e8d19a75c2ac59e36772cffd0a6dcfdb6318e2ac580a8e38d6502fb045ce2cf1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be69e2958da06f7e8797113e15b130f6cb477a7d3b7948353a5e46a5921cdbff(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__77565c4be52b2f7cfd75ab36b05749f50fd516eb662a20a77b235e763f043356(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationMirror]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c6d24c4df3310feb06e041394b77d5db06738a60f7346d1935df6e75c8a476e9(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a6cca37522c4f057dbc860c3831087b82263c67bf3cac13a528aa9ac7ae2b98e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5517732c00733fff93268b89ad3d386bf8e91ff3eb1cb3f741d6f06cf35429fe(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bf4c1670083700912234f893788c7b115f13aa4f94972551db6dba8889d35fdb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ca860012b7c66741d5ac368be49f968c35063e0255be082872ec7e5605d95a8f(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__02303abab80998254d80e0b29519c93a3526a156b0581504fb19fbbfe9b7f6f0(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__271e31cf57288235eda145d89c7eecb6444ddd9c6cf8ecd3fcadc4302d2feb6a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationMonoHue]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cdd884c3a9ee801f60cc45fa2d64229177c886f7fa8d4ad70a373108021e1b40(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__850d48b30cb2aab1089d4b22053fd6051dfcc13c9928d3ab717ef5345677ab51(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f97c7e1589c31e92b25fc967ce480169e48f1418a98f70738e29864df9d4ced(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a1fc6845cb49ca99b4b5d102ea86329480d84ddb119ed2ad0213d77399cf5f06(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationMonoHue]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d75a1f0a008937925b5ac03b494aa9da33cc01b0475de40d568d8f65ab67b03c(
    *,
    opacity: typing.Optional[builtins.str] = None,
    opacity_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__62500eb310fd7314218e7d1a672e0791e31d73c3fdda3506a3d6668249e0142e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a1ceda3b0719fb1cdf8e1af3cd8084fe4f27a826bb31f548d9d308d6312a677a(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fd21d7be556cbe7d228367b0853315900526b8081e4ea2ea4e6e1b4e7ea1957e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__15971f8d1758cd90ae29e7d640e3318d650414e676326cde8ec714ced649b0b7(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ed14504da7d3821cd0e218de0aecf5f3780c06f6bff1f132a05724822f5ada79(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e3846b51e6d908ac9f78ce654e423bc3b7434161ab5408cd7f2d6d4e033b18cf(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationOpacity]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__65ed6e7bfd222a36ff585e50607a6509b92ef37b1ba99afd65baf7af0c4b2d1b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__588147b939d33cd935a1327f93e03f353a92809f0cca4f05dfe0011e0967b2af(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4c699e2f52eae3981a2f1056807b1788cf221985ef55c2bd8c652bc51b8c5221(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3683e3103ff41b873ed696e4bf7c57017664125fe3472e4e2950ac3a3084653c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationOpacity]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a3c7b3ed3a49becb366652db051b1aa95a27319a43b6d78cfb3bb27b0459dc1a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0331769115a04959c87e59f714557ec68e8a5e276d72b5cae333adae573a0914(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationAppend, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8b89bfd07a017c3099391fbc37a3cf5a5c8a039dbac5ea731be2c9d40c5796a7(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationAspectCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d822619593cbb366aee60eea3c0df168e4cbec65b1ef594018e3c953c3124de3(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e1d9517364e7f81be8e120e6423963c8c6bc179627da1898e1c2f855500b3a45(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationBlur, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f3151f287c4b4658d9644af31575689c1645cd1bc5a5f4ea5bd6ca7ed44b32e9(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationChromaKey, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5970c1fa1d49ae0754bf307a746881cbc8f62f3aaba9f76bdaee448a0d10baf1(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationComposite, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__059faddc6e48b87031d66b3460e6f7a520d29f272723b6c514d30dc76624cb3e(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationCompound, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b275e629ec48d243bb01667c0f65444b517667e62fa916bf23e09c677a5c38fc(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationContrast, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__65411b87bd67145de183ed0c08493665d166dcc71a5958bf5bd37664229868da(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c049529dae01b8ab4792fba55c1b92918ef2f1f6c0b5a27007a81981dd6d8f89(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationFaceCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b04abb4fbd1cddba5d512fe6e8464423c52236b1d418479cb3a7e3b4be1cba9c(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationFeatureCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f156f9275d872d489d5953a86237aa4d363293c59acab79e8e2db041a71fe3d7(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationFitAndFill, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__61902067de9f57c5bb7daf5644c0d91477bacf1d1907645bef089d57a4b1c2c0(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationGoop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be3e78ad940d9064b74a4c9888b0069e1e0d2955eb8bf566e5d6b218a7c15f8e(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationGrayscale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e09d08092ad61b124fd7cb6c89c3ba5730c1b88eb655c4ab48ad8f430ca708a0(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationHsl, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f552e5b997c12ea1eb05a5d9a6bdfb1ab3c83598bed81f523bbaf7bbec85e722(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationHsv, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__74e12ec73f6ef11a290f1d636528122df4f565e4fae4a49dd75cacc1f408e078(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfDimension, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d8f0fb0434d6bd3e8844f099489f438fb54a95b0b4abc6780153479a179a4c1(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3da58448cfc292b57d688d51c24cbf3c36aea00c7173a2bd8cb6ab50b679b9d5(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationImQuery, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e857f7ee7333021666a8c419276446d001091818598ae6acc29146f2949fa655(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationMaxColors, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7ef7c2db277a14b2a9ec634c881e367235328c7b8b5480343f78badd1525e4a0(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationMirror, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__69592073253f0be7714edfb5bbffc4bc1c0f57011e4f2c1fac77980f2a2a0982(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationMonoHue, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__12df4c9f0f15f1d34fbf0f8a44719f06b9ccac715f2ce29be172bfdfa8ff2fa7(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationOpacity, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__56537332d077396da95353f4b97812e17d1bec5178356ecce3274c5f4d60ce1e(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationRegionOfInterestCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__995c4103eacbf627e3334b1989e49a6d6a5bc8f12cacc7107504dc305f0ae150(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationRelativeCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e85fb197352af329d81ec5231141e2d03400400e3154498ad89f93ec350c2955(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationRemoveColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f8f62f648f3435644d8ec47b9245f46999878432179a9f78bac376b6f60eb625(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationResize, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8d6aa6ae562b642145206c0ae30af90c575d4a6e8f7b0902edf3fb7f32ab217e(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationRotate, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d574a6ad7e8c8f7da4b9888dcfd6c69ad9f06c41f0b26656aaf63834dfd72352(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationScale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b6ab2d49bc3dafb18ac7f90353edca6e022e6f5318e0d5d4fe4b9e9df35a6b06(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationShear, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6af7a47cd5a268f6d2658e684f9771c3db476a3c489a63b4e5189822cd22a6a2(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationTrim, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a3d0d71179a4a256cf25ddbcbb8b9993818230d6ac85fd47b9f0abb391350e7(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationUnsharpMask, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be884e6a1be2c22a0aaa12f46340d39eabe1446666d999a429b05cf6c9932a91(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a9e4d916ba7ef840743c699e91707eac19f81b501d263a77181a0565979db087(
    *,
    region_of_interest: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationRegionOfInterestCropRegionOfInterest, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__18eeb45fc238398d49a5a8db2926cf412e3e5e90d0ecc9608d61241447068a59(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__92f081f52feebd547767c65f88a4b9fd2b3db18d3245d581dc2374b35fb8c1ad(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__59432e79ecc0c75cf489d41d8a1b29d8a4365c05a85fb8fe5e02d63e1b27b708(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5408b4605ca28dbae037f0a731b1392cb105a8533068eb3556bb318779cea805(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd9b0d43818f3ca915cba930d8053d951d42403caa186d350f873329a7daf79a(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__02c9d3821057ac816ed3aa9f3e1003b436217ebb5904d549f72918ac4ff829bc(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationRegionOfInterestCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d14718e05549db24ecc56124a734e077942942fc91fa45ac560016b527dc65f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c011a16ed2425e02ee494df64a412d98fa39743ef00e3daac7c47a2eaa48140a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a0a501e800c71acf5186634d9032b7f6d894178ec2f60ea041b52eab538f7469(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7732dca521e68ad39fa8e3fe63ac76b583e10c0332c0de727b33939559301444(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ece86d9a88ca2b4026e7da441f0379437f7e667228a3001518656666e6ddcd4c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0575b90cfadcc62202c920d7239ca10e5672384159fe66ebc2559b2607656258(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a3bcb1a15fde553ee12ac7e51058606f25f621424d49c95a87ab6ea097748d78(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ef6dd3cb79bfe97200102a48ac1b20a630ec34614a16da4acfc9224cb467476(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e6fb59d24df37d5ea4f111e76407f48abc2fbf54e6e51f486b7e6995812230cc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__80a11aa9df38d189915b9334affa79bde661a96c7d56334e224cd9f7f94fbe06(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationRegionOfInterestCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a6701eff0a0e8ebd0c1a2a363c6fa7138d402d9c82fb63a49ae48f0756d93da5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b90b5fd5634b8f4532d0fcd50ecfc8dd13620e5926724bd09bb82038d96099e2(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationRegionOfInterestCropRegionOfInterest],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a6e4a5074ea9fbad68b0cb7e28f34c8ceffefb16552f02f148fc28e06250f778(
    *,
    east: typing.Optional[builtins.str] = None,
    east_var: typing.Optional[builtins.str] = None,
    north: typing.Optional[builtins.str] = None,
    north_var: typing.Optional[builtins.str] = None,
    south: typing.Optional[builtins.str] = None,
    south_var: typing.Optional[builtins.str] = None,
    west: typing.Optional[builtins.str] = None,
    west_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c6cf280bf12ad3e712dd2764fbe9af9cadbfd7203e991dc505b5711f7ea7b6d9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__958bcaac7fd8ebacb1ab10b545503703ca42be37e35c26e4ec7c63ea4f02d1b1(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dfc4c824a57b34df7190bb0d577571eeaa469af99036cf0998a670196833a3e1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1d2aab6ec6c87c66eff2941ce7e992a9c0762f1ee4db4574104c673f7457f4ed(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7f144397f9cad311a2ccc5af5b527001155b2eb0ed76b6fb482f5d2a03309e00(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__77723a0cb44eb8ad199434015482b87a2ea3ee3d8fd13af53d9543056f790b71(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationRelativeCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2b50c707ca7bfa173eb9d9ee57da16dd85f4c3f4310fcbfb722b6517b4ad065d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__37917f43761d0b747fc62d3d5dfaf17bb6779b39607c193710ca98f6ace94f4d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b4469939759cfad2f2674e294c418416f90fe523d7d8334a5928fccdb2fc9c76(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__308eb028b2aa27c249e22d0835fd21e333277a9e3569ebc44dccff4529c1187b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__689654be8ec9b781a92783560298bee4ae129e9e3ca2ef025f1f42d17f5bbc44(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c4820b0c99baa9a5a79c08bd29ca175ebedad0f1a9c00586188bb9253f71a288(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fb5c42560e007aba363973732ad294f90f1061f0cf5da6a5460c93d30c81de83(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6918b475a7368ce73a0c64a8076fbecedec3feeca3fd1faa1a29fc7fe42d06ab(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__91df78aa98cc1cbbd166e6ccd2893ae215bd6dc2dab0a10d3d73a3168f97eda9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0f1a03d0c5883e8aeac774c3ec5712fc20586b5e37d46c6483d9966722cd2d5e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationRelativeCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__37ac8bedf745d09de824325b28b44bbd743ddadc32b6f4af6370ee4eeea28701(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
    feather: typing.Optional[builtins.str] = None,
    feather_var: typing.Optional[builtins.str] = None,
    tolerance: typing.Optional[builtins.str] = None,
    tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e9bea6cb59b665961165c25b8df65759173dfa18a4a8959f3d9a8058d9f76917(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0cfea71921fda4fab75c0fe4785966bf37a0bc8ad1d318809c030e34c8545c8f(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__940afa00b2d60cbbd2d1317633e3075f738a8fd2544dead3adae35bce2489235(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b35295dd982561fd8fb195d324f39b6eaf92fb23c95d6736e314a320585787bd(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7e984296db8b86fc0f9483d7a3556efdb83290d937288af354029717228148a1(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2f03ea578e2518c2104f6792d5753715de8e8ee3bcc328898785543029b99b6c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationRemoveColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2934d72a8e4efabe59baeb466288bd06fea758d82ed9dea21bd831b893973f83(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a36495f58eb15872692537bafac523ec05b4000872e17b2147bb8c353efc0d69(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ef489ed21eb89ecac3c65ddc234bcdec048789515e320f3522f9a29f1ef99ce3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__24b43c2c4fc0fd64f0eb9675935b81fdc5d69d180ea6b77a882b6a640b475c1f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__96675395a1c0c19d4a827b060c319a3882e79d0a9a641fafbb4e76f83b9b1329(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__35e3dcd7f2654344dd607addc1418adfd178e3be91e24c0461d74414955b1a14(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__73a4e7c4b9d4fbf5b7fceae1ffab9df0e6e73375f7d08e0afd1d6ba3f3da84e2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fb49d83e1965cf84fb11db87406f050b7a76f6c37c13500e87b06e080451e5c4(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationRemoveColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ce50661f59997981618ffeefe20eee5b4f665092930ee1fca84a91a91e2e9c0b(
    *,
    aspect: typing.Optional[builtins.str] = None,
    aspect_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ef44b1841faa976d95e92176f3613cb63f1a62e2ed5a257b6f881e61f18f4a10(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b7b18a4bc3aeee1c3b27b9463cd17086adb4c4dc1c1c497e02c48caafde26dc4(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__26d3b149bf3b132b7f24d4645e81ed887091c6aae795956fc48b63e95172e4cc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__513bf899758e1e56eb4e04fd96612aff868975837b8ea769537345e76c1bc3af(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__536877b2705792f7e37d8e3c859c0129e424d3193b2e6965250e89224128c48e(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__46cec2a3d089665cac2648ab35866aaa1d027fe256b9d229bce8fb5bad970eb5(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationResize]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fe7dca02410ed0e2bcf17e9af500c84c2631404aba0fb348bf13dd203966e7bd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__819e12077beb5b4ba8af5cd911af88b08afbf912e0fcbfb5eb7cfb1bcffe2783(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c1ca6e5507ee56666fee49937cfe7a6ab618910f6f38861a81daaa2893014c05(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9eb6a790f075a35a98da4c0547d7e30cc8bdf5ee39d152c561c125c9f18ef422(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e7f5dee33fff6fd6ddb0dccb8dcf9c5dd8579cdad6306ead1b099cb7910a556d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ff8e5c49e0f564dfd80bd206377a85f4dba60593ec7fce20f7f8bd701057fd0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__00bab9af0ada47e6ca6f959e0b79f7ff261aad4cfa76f596a29f5e85ca3c0457(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__037084c2373fa64d514453c4a2351c982a4629f2998dafe17787cd0129e24de6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__55bbbc7367956f34f50304503557331fa0966ba9c924b2efcc8bfc0730a26d01(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__73f663b423d0dcba4bfb9daf06c60e7b4f08a1eae25afea6de22e7565aba4976(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationResize]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d962251849052023db3ef334feb4059c7f5c46b879bdd5feca5774fef315c72d(
    *,
    degrees: typing.Optional[builtins.str] = None,
    degrees_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bf025c44fc812d5f0c73da77396ceacf7319b39de07c5754ba6849d3e9c119c6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__66e9a539cd2d6c51a1dba748d7d523e7c718bf55271f136065cfdd8c3dfe2ac4(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__11965b46a1bbfce89a2af8780e90e3f904e60d931ed861ea5d3c794b325e467b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e2540e59e47314b62a28aaec2a05d333bf5a3a4a75057e88cc67100b2b8acc56(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5accf0b417782507f88202d400dd28f8fac4714dbcd041ec63d766ae37ca05cd(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3753d382ea6aaadaa3efa678322cf96036f5209fd2847c1cb0c98d33f3ce6e44(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationRotate]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__312935c5a57fba8048f4508934d77d10cc2d34740f00766138af2655aeeaa5b9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7bf78714e7df5c8d376590fe4a40cbc04224c25209cea385fe4b56f2f1bb3219(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be01a1f1c0c1df84873e18d4107bada79b0baa6f44383ea5521464e57e1f7725(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__465152eef9a7d54ef2c428cc05a58a320090aba57f39d5c83e231a9de8734d98(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationRotate]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__040c59d596a010045e643143ac2b73fe3200a33a4590146b01b1ba23930fc296(
    *,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0eb3a8a6c459918c485cfa401cbc601949e99d9cc3453701b89a81071c50f224(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1a4e3d339b2746690f246e336c60a356174f2290393ea98316dbad420c4dc9f1(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9b2d8edaeca6f8ae09aa2da6543491c92abbc9b90874d8e36c8b3591f593c967(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d69b3e10248f3051e158561aabb17bd9750511aabb698cc185c1132e2166d437(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dea96b0d2bd05121531ff703ae25189aee56356c89964f7aeedee8cf703f024a(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5120ca9c4f90465e27fda56b8ec11a0f25418529e02bcfa3dbe4af652b48b786(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationScale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5531f87ea635af344a702253436b6ff750e530004d91850d7abf32ed9f0ea6b6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0b216b799b491ab7a98f065244ee9dbe57da06d9ead4c7cc8b4118271bc053bf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d545052ac6e51595dd40cf5a94a991a62676b871610a9344b91ac1ab47f4f18b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7fe16f7dedfa7da96c6dc288f1e6f6c160f82d43c735dc8527cf171d71252ff2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__08b0e49094082c55b994ec4c188251e99ad2ca1bad642ab3674fb1755f7ac443(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5b73c3a073e84e2f6013de05b277cfa21bf4768385ae3d61831c545a1c344a5f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationScale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f7b047677e63f3f2ebef53bd2fbced572f2d3755cef1f2e207e7461cfc4bcfa0(
    *,
    x_shear: typing.Optional[builtins.str] = None,
    x_shear_var: typing.Optional[builtins.str] = None,
    y_shear: typing.Optional[builtins.str] = None,
    y_shear_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2fd1af883e4318d703c023821921582df8f4d69f1372dd2ced4cf084cea694b7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0fbde4b1549ff5dae1e5eee5773042901748cb5c0a83d25d6aa9cc99663b36c7(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1bbcf8f710acbba42b36b1942be79d0abc00f83a84f27018f325fda0dfcf935c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9b1b2a9a4d3eba2424920b57ff18119a70d5ee5be472bdd2617201ed0012e923(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0136701be5621475cb3663dbbf059640a4fc64dcaafd14352324b7b25372e7ca(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e9325db7326946944ba88e4359175a0674992804cd6d63023d7c12d30244398a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationShear]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__357bbacc3c28f8870fe89e6f8a671a518dab5f4fef08433aa627f9fd9ac92ce1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6ba845ae82446b296ce73700373ef298e8c55b9833807753744e5542e6921677(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e987c2bd28bf3414238e078febbc34cc0298c5ecac3baf81a271bb1ce617c27b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__942b8a1fdbef8a4c2d4e3c008a2dc317827bf34977e2ff4e9ae7224917b71fcb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d5b2e97cfb148fb4baee8bc5657fc2529125a498da2860cdce44ce7def3f073a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ba7a6f5c6b431c45b443ff1e78eadf27702281f9e3d53e3be73054767a5f601b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationShear]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__89d5e54966987fc92c216f003aeb587b24779d9e6991f826cd836ae3740f3338(
    *,
    fuzz: typing.Optional[builtins.str] = None,
    fuzz_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bf50e5c6a60be216e53da52d3b56944f79516c7dec1096bd2b77d9ad63a85da7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d15891ed29441e48ad9b3430ecdc627ad5ba35b95fc40256297742a1bc4612f4(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__045a1fa8e9690cbda1d696f397f332e903b856aa44e68be9fda85caac3ba6d82(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a327ac9737b81f6738a3ca949f0e0e8b0337ae8067b219d241e956a3f5806835(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__620be186aa668790f451c388de7fa37bdf16ff9c7ad2f551712fa22abbbdb532(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5a8492c02681042e861195b060dfa5c789872d8631750f2f597fa7a5286f4e09(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationTrim]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__195d451546663412f52fcfd8774bc87960ae3ac814ca3cdb1b41dd4b1dfe9d8a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ec24a90163bbe123470b25f7c42e8fdc2abe6d4b039e49bba7c584c3378c5a52(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__560dbb3cd9342eac7fe6526480e2f9e97ad082ce69bb391af2857096c4e469fb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9c7bb0e24ad62b91f161820ef186a6634b59f3b13847c333d4f4f8553ca66bd2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c8a76d8b87f941fc90610405064ce33dc7ad7ab2c5985b914756ba9d289d8759(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e4b9f5de7c2e14cd0c252cb955b149622622e58a15bcb8832824864f2a51853(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationTrim]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__399652be7e4fc0f029e480c551b44d9772f90d9d8147bcd552de265e04902db2(
    *,
    gain: typing.Optional[builtins.str] = None,
    gain_var: typing.Optional[builtins.str] = None,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
    threshold: typing.Optional[builtins.str] = None,
    threshold_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__424647279cb87451c9ad9cd0621e17a7c3801194fc91a69cabd366c14943e8a7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__71a514ce0ed4612ef90c67aae9677d3b056cc257b4a1cafe16a2f72ce3f46844(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b64a0f6d0d9b368392905edf25a458d364252dbdf3b9e5d88dfeb1fcd9a23e63(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8afec551eb6e6c2233363dfc92d545d17cb4232176de8b82fa30dafd65d57277(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a92ecc91c202c9535b458b5f1f226e4740eb59c36136fc722efb3d2ad2733d05(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ce0882b05c0f5877f2151ccb110ee49292183105636ad2414f5354d56e41e40d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationUnsharpMask]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5abc53611979646574f1e1083cd38f5b4a83fc4fd3f8f20253063356ecd99156(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__992771b4632202545ea9942efae44b3238eda6b1f97f4099bdd38796ac0fd877(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2e54b96aad77fdffd20e9eb3af4c1e7a6b1bda39ac62de9b8119e95e46f52aa3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__de3e3a540830a43c7c768c77ee9f780cbdaa75cddd5d43a223de60bd473ddf93(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2f6c2a43ddbe65110ac97f5c618a0b2139fa89450b63fa29423d23c200e8b591(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d8fa852831d6dcd7d7d7cdd2b6fe260f1f660848c9680d93854e990d086ce07c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a88ecb2b067c5a3b16504162168172048fb792ca6aa0b0ebf8e8e95834e83878(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__835d24334377b7a9074bc1ed5ac50a1f188407da8a2ed948ad3d08ac6f668162(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImageTransformationUnsharpMask]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fc3ab738051b6fcab1bb1357602786f260bca83f2e56de60ef48288babf3e3d4(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
    diameter: typing.Optional[builtins.str] = None,
    diameter_var: typing.Optional[builtins.str] = None,
    transformation: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ec7704c978f2a9580d354bfac8dbb7b2bfdd520fc48ff1c46d602641509e9c6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b0e2b5e06ba54a1561fdb17361122e885a0fc720f13c49c068a7ea62ca409f82(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__490c5872dd89a27bd73087a845b0d853f01f2e887ebe9fa59adf33681b853c52(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0119f9982880fc40bbf124a0d791b1e122fd4cc1cf3482afd7a46591085d73a4(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d4f85133b5e9edbef858dfe23e2c6dcc96c03cbf4b8320408526490592feef8(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__78724672d05c32c980bdd40bd5ca2e061ad175917858ddc25551a578bb10dbce(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImage]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb064e3cce74940caa473e1653912240dcc8703e9aa17e86481a5bf9a0223032(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d6dd14218aa5a5aa8a392e3b20cf3c83f7d494a512ebfb5c3d9d20d670227bec(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6b393f662e9b0a4a07734de3e76825276308ab35b89024264c0149a9b204fc73(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__91c8a2e94e861a7b5e4068621e0b4ac62fbd01aa289a491f9b5f60b76c33ef56(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d5328890ae4af6ed394cd033a5923f1dce6782f42608597bc51258e7de129776(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e71a8f64663139eee7b9eb0895103c25cc0564f4e3cb648504365fe6ecdf3fbc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__10b8f03aa76aebe313d8ee977c4d735420125bf3f276b92c53d13abe818d53a8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c63d0f09411a9e46beeaf64eb432a3b06c66fbb8a1fa75c1452fd277748beaec(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImage]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e593c69617631d130257e37f966c90988c34dd63147a44de87e6597900acdf5d(
    *,
    append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationAppend, typing.Dict[builtins.str, typing.Any]]]]] = None,
    aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationAspectCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
    chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
    composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
    compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
    contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
    crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationFaceCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationFeatureCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationFitAndFill, typing.Dict[builtins.str, typing.Any]]]]] = None,
    goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
    im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationImQuery, typing.Dict[builtins.str, typing.Any]]]]] = None,
    max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
    opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
    region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationRegionOfInterestCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationRelativeCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationResize, typing.Dict[builtins.str, typing.Any]]]]] = None,
    rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationRotate, typing.Dict[builtins.str, typing.Any]]]]] = None,
    scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationScale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationShear, typing.Dict[builtins.str, typing.Any]]]]] = None,
    trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationTrim, typing.Dict[builtins.str, typing.Any]]]]] = None,
    unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__031b9f5dc8e6d0de350a255ec59a59000eac3f6286cd298e6a85780f7f647977(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationAppendImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_priority: typing.Optional[builtins.str] = None,
    gravity_priority_var: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    preserve_minor_dimension: typing.Optional[builtins.str] = None,
    preserve_minor_dimension_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__56ec11d579bc3e47d0c70fce189e4e95844dd939522b5bf445c8bb1be452184e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e72e9b4ed9a2f827e14967cdbfa758e64182ab4e8b872d36d267137220c6e677(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationAppendImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__febd5f0ebe374ab2c5ecd4d2829959981148cfb4baacae7ce6c4b86b9a0e05e2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__581e6c813528ddf29f66c3b0368efd1d8f4804794a45c6018e356ef8fbf21fad(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__49c508fa8ea47ed14db4d70e0cc9606e51793172bbc129eb362d9ab9a31bab64(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dc23d933c1185ffce38ceb4ca83bf9fcf0867b7c72705d79bc02954fa91fa76d(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__adbf3b80d44328f8439018a888c1c533d794d7cdab3c7b7d1b88cece4fbcd423(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__77549b1b141b492c196f90d32a1171f78d78188f0a6716018dbfec6eda201d06(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationAppend]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6af847561853d928adb3f049fbe5e4c07e6d024163d565a5b51c12e0aea04582(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ba965d4341d6f26a7499562bc1486e06a32d903e47df373c50cb916a5561c58(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1e71108f6e1f5e216f4fb4e6f7e0bf36c14947a3256f66f5b3708e4bd5df9d9f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1ee8decea5dda1e60e8757e1f95ce4b5f70ac68f0e1a04c1cc936e01e150b579(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a030b310a749dbbf206377299479717d5b7c34ecc67ac5cc024b10f9c921b3e2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__35c4d9eab25f685e29c0e802c93f9c49244229c3137cd44284257721695b287c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3055b3eb7e558272c5812362d036bcbe2d712997e3c1ac94cbcf7ae739ef4208(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__09a831d79aef9da0745886b52ba76545b9b7eac18ec2f08dc47dededaa3f2021(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationAppend]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cf5ff2b1471e036d0f98dbec761b6ed531e9111d5fb749311c4aa66678c3976e(
    *,
    allow_expansion: typing.Optional[builtins.str] = None,
    allow_expansion_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e8fb593d12f61fe7f52b43cec40bb1a9f028dd50bb52fdf3941da438b2ac4179(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f6cb822d0503d8e5982bcee2d43a0a82f9726f69ee69d473ddcd46b74b7c8eb6(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e8d1609460515c2ec174dc306c983c4c1bae6958ec6cb229247113043dccf1ca(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ef529417c5f754ef1f05fcef1e3dfc8aed9ee318f5344635e272c673d2d4f5a1(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f794e6280056ff093414b18bc928c2ff94ca8c7422682ca9a9b25c605ad6d4e(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a17127d7b950299ba793195a8ae29214d2dae9aeb568b0af680df8e04163e93e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationAspectCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__743d557e9153f96bd3e46c27057e729cdbd92a960e2ed03e2bc3d5db24d311c7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8b479a47f9e7f86849d996fc57700a7260d578000221fa75b159328ed40808bc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__425662a2e8064934d9b9a6ed3713473ef58e49f49bb356315e5cf1754eb7ed33(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9386561180c016fc8f9a6bd3adf39df9125daea7d726f3fea7a155ea3c636f53(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__974a598e2f63b3fe026edbb90e6712ef4e7b732774c3241e67f705a36633a847(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8925b697e91f4430b198a9e421a97e8ac76cfc4340cb932a2640f40279f6594a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3dd0cf140a0be033541b008caa0aea8c126981d532824dc661e926530ce04a25(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__270171f7b07b6ff691c0a33be3e2c6d992e1f10b275ee91f70870095af18238b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c813ffad4515ccdc6207dbda98f7193b412eb2ae8d6abef85b39e196ca9eaf27(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fbd0020b6980f9924171a48108e5bc6af8d4b4284906b25985c21c32c2fef818(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__337459a500ff3364391419b56a494338ce0b5cfcce0d4e39a21137193ce97b65(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__255e25ccf323a90a14db824c21ef7e8541b0b847ea33a88a24484aa6ed3037fd(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationAspectCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1654cb92ecebcf975dcf80e953edc6d4b8936b8e79f4bbdd8739380b172b09a9(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e8ef5281487629ae4534afb9403e6afb4bab612806877cc5e6f9fb4be0b0b922(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b9034ab79a8c5cf2a9b7d42ddefa7662b85ad9f3c6db3beb22d0e625321d12f2(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__128a72c0c0b266e24862dd9a044315bcf6fbeeffb06300e988e56be93e95a9b1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ddcd475ff43bb2d7284f0f511ce90e6d602c72c187748bb3bb8d1cd41cfc21cf(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__781078b4fefbc47c4682b95c5c706b1c349628c47ffcb488cff35c795be74ccb(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2f6fe472f2e67809a9c027d5c6872e99cde37431e785227a0eb4eca149921dce(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationBackgroundColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__35f3162b378516256b3876c7117297753d42b6f9efe3fdc0e367d498af32f2c3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6daaba9582995a152baa836e55c2d8276a7a7628af5f57fd4582a50edbd579bc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c76f2d7449529470e7e536c9a504c1307bdad1543794218c8a8c1c7ccf7c3a77(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ad9943b3ad0900e5aa332cc216420604bef7a61673051e2e667bd45c52d2d150(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationBackgroundColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8b2cf0e640bac8f01972650b10f445f0a53a311ff6662742203cbdcd009ae3f6(
    *,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d38ea603394885fc7cb4ac868b223230332cc0229a4df41e1e884d4d75562b40(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__40f12c1caf779c46eaca686b8a33f34435f799de8c804c7c0a66943553f9fb08(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f2412688b6163c4fc3a283e2f85f6dbe0abf2d7ad6f0a180fe92a260988ad2bd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c91043d2b580f91ddf9de26e7dc496cf6084cc51517038700b282be9f797ed95(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__891d379f3e64767c87e43f28b47cea02d5003ba679644f22c6ff2c5dd75c6cc7(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0c2ecdb47106cd01c7d5f1bc06351516a4006ef95aba71fddad57573c040e417(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationBlur]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__11f03988d27001e6a52556c244837ba3c5171e4958857b51b1fdb29685d34d8d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__978b001aef966e443990e6e39cda7902b9c9e9d696d1018a7164ce2abe0b85c7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__57bd5a7ef333c488ca63ef5146bf11e91b5c95728dfe69fe1e941a235ccd7f58(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__58a2437760e2d421f79ce19ed72c7d9eb583611c5a3086a605f4098a0e7932e1(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationBlur]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fd359383794185ce92587e0a78faa649f8073c02ba7cb6a314971660a2b09754(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_feather: typing.Optional[builtins.str] = None,
    hue_feather_var: typing.Optional[builtins.str] = None,
    hue_tolerance: typing.Optional[builtins.str] = None,
    hue_tolerance_var: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness_feather: typing.Optional[builtins.str] = None,
    lightness_feather_var: typing.Optional[builtins.str] = None,
    lightness_tolerance: typing.Optional[builtins.str] = None,
    lightness_tolerance_var: typing.Optional[builtins.str] = None,
    saturation_feather: typing.Optional[builtins.str] = None,
    saturation_feather_var: typing.Optional[builtins.str] = None,
    saturation_tolerance: typing.Optional[builtins.str] = None,
    saturation_tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ce0e786cb2e3a86db17fddd3420dd0b3947cdfc53b0d78857ebe189b72e0525a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5018d6305d556e30e610ad57afe1e90d4505abe25ef03c2aa86e00d9a073424c(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__12119e14c786fb8c0fe2126c387d6985c14f89d4775374d5c693a2890d53c1af(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__67afc6a7d9e4367df25e5dcca41eb7a988920389e83e0787932c116c5ffde749(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9533e0295edc0c389366164c195cbc15a18b1e53e9d11b9ab519174d99cf783e(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bdd0bfb4e601baea64be6597b9d99a5b98f6f6523efc56e978f2478859c5d3eb(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationChromaKey]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bdcc7bb3761d0034b55cd57bfc318ef01e9fc6f5c05b755e21ede8e0bac9ff00(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f1a33be938aab30b081146cabead6650ebc48dd31f6cb63bd780f38fba007a50(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5fd3472e9bc39becb6c6522d30f6ca1afe83a30be9a013f5ae65bba312f99cdb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__da8fa36f87f59c35e1f963c68feb771fe79d0208d774ccb8c81eefb3c932436c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab5244e86e4d23359b27dd7bba37697fc63aa7bbc45fff6a1b8c89d305777510(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7e37afc5bf13fd3545ee36ce2c0af62595a043a325e0617d34533d83647f6206(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c2f1bf271229bd053bc47d6b5cd19948542e281cf6a1f82da91e77e6de7c3f84(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e8d1aa935b66de6912a672b770384259a9170c82853a998ddac148d66b0b6c1c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__78d151a0e0c8666d69c0a5e8206cc2448298dfaba24a858c200fa9e71df0ebde(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eccb505acc1b4b58cf0c79e374d973e468246d813e18bbc2d76614085c504430(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a85891f8d91f8995fd1f9c4c5228d881671dcd436e8908746c3cb462485518de(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__04958afdcdeae9b8d77baab9015d651a71c0a6f8697f6a8f28a295e45072ebeb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3603183827195847a60203257ef6f8f6076ba45d51e30eb3bb5d91ee432aeddd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1125f66d0994ba97566de193e342370b5c016cf717fea7b88d11bfa16df2b859(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1a405c13565d9349c08fa3e50d43e2b883bd91d95e6b3a05913b7899fa1c94e9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__30db4bcafafb151a437fa80b5c170968022fd82334a48f102260e2029701d2d3(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationChromaKey]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6c1e3f9ace6736ad7ad3c33da953f1f0d69a9b5e0c2a9e6c5d54e6faa59c3e4d(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationCompositeImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    placement: typing.Optional[builtins.str] = None,
    placement_var: typing.Optional[builtins.str] = None,
    scale: typing.Optional[builtins.str] = None,
    scale_dimension: typing.Optional[builtins.str] = None,
    scale_dimension_var: typing.Optional[builtins.str] = None,
    scale_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__971b1eca754e4a747ab7828f3332c82b371c0cfa65e04337138a49a7c65be73c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__68df4d41254120417aa63b295fdaad319989bf6a9c730eefc0762ebcde6892cb(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationCompositeImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__905367733ee6c683470a22ca53d41ebb3f6b73f5ef42c9818c3b54317613a77f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__507be29d02164ecf0480a868870e357f3ae04b2cfd676a7620aa3b8ef04daa9b(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b90d9f7cc5e3d6cb99b87d99d143c07bd4918d45fbd68fdef4a3bbd23f709d69(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2aef74deffe1508c387112e68c9352d7d4b5cb413385d732bc1c3bec6300c524(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ee94e6ffcc3d6be66f8b489fde725c40cfdcbaecd28378b9aa5c1144904e6a6e(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f2ebcc49134337296bc791438235784f3e4da447c40512578ab02972c9e0a275(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationComposite]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d34ae57b839760211e8e5b7656051098eee77d90aa3dd5013ba58e1ebe98f5b6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1d8936192113969cf631b5fade2d903bd4ed89736f9d7632b530caa206b36028(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2e4b39626f9a0fd14e5e6b043051aae09efe08a2bde8ccea998c6602eba252e1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d7ede5e5ac1031cbc71d964cc418091000063623dbad41ddd8e88d9fff2fc1cb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1ab6703197502f7af55e853ca883bbae047e26a36bcc62927ade41aac8e681b7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ba73d710e06144d23c00588e96e73581c76c4c254f058c1dafef7eb99a0be3d5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dd4e3ebf835e48be8325e29485d8b4ce716d13fcfbc88dea2c0e3d8c4e57c0ba(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0de08673bae5e664a777057a223aa781b05c9917d78faa085e85c52b5fce3e85(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5b9a7ae9046c7d05844721f82eb35540ad24e116aa5690b1aba1061d0684bd9a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fa7cf25388ec62811bb75c7166705f26bac88461f9e1a264fa651413bb13828e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__861673fd28f01fe02457cf893cd5d87e7f1f3861a786606ad03462f64dee2b35(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e4b65e402550fe742a9d9ebd0c1194a4b2bdbe6e9204adb6d5c345cd060ba0f7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__69ceea4808d34e1f4ce6e0944bfd5de870833d9bc34731dc4d746b3c2ec68c38(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ea2d92fc7a7742fa520af4d8ece639b13f23fa550989e29dfdcc956b2d85275(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationComposite]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7c0267d18aa144cd2bf8d11b31facf7033a5ba1e6785cd090e2686925040243d(
    *,
    transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d3f31fbfcf8625cbc48500d77ebdbab7a125db9e1978ed210f64016fdf06394f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0a866e9feea189eb9b5e128d0160c8bf7fb1e729164302fefcd00621b33421c6(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1e1b028f92913fc990068c6f62fa3fc4e43ea0ceb0e69b9e82d2c9c63974cf46(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f7440f0052076d5d5972133946f127776bc2b6a5a604b05b006504e267f770a8(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e4e386d17c55e0128c41e1720f39c0af4c551d7f4527a510ddfb40b45357f1fe(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aba7cdadf729bacfd0e1420a7bfc751851eb7ff6c56889b18124bae643d39e3a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationCompound]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__242d3137b9ce861e00b032a21ed8bfed15184ebf613425aa8aa9b0fbdc72d410(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__674a6aee420ce438b3d4d92e42beee6ef1ee348ce2f1a19ba69c13840e93fcc2(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b4231d03e8473fb0ad09d0abc9841ac55aec7b32ab418f2213c10e4c040fc4b0(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationCompound]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e817cb5a90754141a0ffed8ef83eb40ec6ccecc99951c18c6009264098211ca5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8d4e756f5f6ced58aae094d54208ff5513f7de49304c8f7616cd319cae376a9f(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f86a0c676c6b91064f3140a415e59b33c2d989cf21a6d4fc3e9155cb77b9e1a8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d558edc3372e9b831311b3b2d7bbd154dcc2baeba98b4c8e1eead662463a147(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5abec25c6d584175d66f87b2bc67aa454c3fb27275705af33d96cc42820a0636(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b79790fb576a670f102b1eed5af94a52cf86b4853da3d16855e2e97b98973d78(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationCompoundTransformations]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a2e1b409be81ce8457c206663c9ea016253c1a9b4aeae9fe4c96fe671a6e945e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__079c1ebe42f443a95f337f2b898eee3f5deda01cb8e447e1545b0727b5309715(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationCompoundTransformations]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d6d0761e7608877bf98d33c39727fc86b0420e02f9f86d058638fcb5c5898f26(
    *,
    brightness: typing.Optional[builtins.str] = None,
    brightness_var: typing.Optional[builtins.str] = None,
    contrast: typing.Optional[builtins.str] = None,
    contrast_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8735ff8add76e3d613a59d827b26dd77f7d535d380fad2f7814a41e1ea595e08(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7cdc8013fb1c14c043134e28a2aa7d40c185dbf844422bbdc4847771394bb987(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ff09347668fcd4fa6a4da1dc42bc48d4ef7cf75dfb909144850ca73e77df981c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d01ca45199b7eb042a899b4dc38fcefa454d9921bdf03032e360fff3cb55ffa6(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__beb5b912c31a32a947412362a4d317d021cc164ab157ea521429d5a68789ff9d(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4d49d634facc3f537ee2a032a688e8520b32824266fd2760e41e7f824ca7519d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationContrast]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e7425e17b0175de0eba1223d450fb6961afe486cf0792ace3538327427b9e3f9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b08e1cd8ad4a86776ef73a879d0824ded980ee5aa0b3ec370f24162b81f6f71a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a41aa03805f1a3f0fbec84e7cb8b919875cfb8db4295c6c711f5828c3119e78a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e3948739627c625c5bd15dd79cbc30d3751afaf342f92d5642418ce5a22d9438(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a1f0d01685edf9cd00ceb78b691e1f428546e732c6dda10abfeafd9eeade7a83(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f7961823d43c9ae250bb2c9d705c34c50805fcfedfe9ee135ddbf24f1c4188fb(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationContrast]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cda57196c4d1ccd62781ae843a71dcfbff962b4b9b08a9267ea6a60807204116(
    *,
    allow_expansion: typing.Optional[builtins.str] = None,
    allow_expansion_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4f18fa5225570674f2d2de38c8d3919387ca07f12accb1e93496549a0d46a28c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__438bd80d9e816f7a1b529d31281907429341b1ffbadf0bd185ce7ef3edf658aa(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1093cbc97f6df7014dc678d61865af41378f18bd1dc6116a15b4eb1d96b78eda(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__66f33e45a4b49a238207a09e6a5345d806d6d4cf5906af4225018de877d17775(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__558cb88cb6fb53c2137d3c2fbce6efd71a3a65fb991ff84b5c98647ba8aca9b2(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7ebbd1b3b6ffc62fb28733a01330e4a4797613adcff0e2f242b875c8763f01b7(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__db1a8708fd0fcd7b73eed6bf7635bbd66458388a43d884ef776240e8fe21cb3f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__01d6cea248d637f4db19f3007d8aa100f67ebb97017aec9fa71111a931a11374(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f864160794f628f990d77fc12a18b3763b4cf4957da581a1ecb849ea1c95e028(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bd51540a44f5708c6b356ab3e902ecc7cb2c61e05441f134978b06015b085686(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__413a8b59af0b84824491fdc7c4557ba2c51d3655c93686fb106cd9b2163b8c26(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__25510fca43eb652e1844e6550bf2f0702a05ed173692410fdd986c54fdbaffb6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4d4f7762a51bd61f5b576d20bca23ee03202c952900a7d226c8f5bcfa1a9ec7b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c72de201e481020109be6bb6fbd8f21fd3fbf5ebaf9731431f2f874aac8b479b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b7c04aeca441d114ef6e524600a5dfb56f7f00fb3f5ec0c963ac5fe92d3a3dd3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5b93ea3ebd2fd3e079f475ad60b6f4d4a8645770ae572f964fa27e79c0c78b64(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8b2569dfc9e6c657036f70d6b46e110039e4a67aec8ee8d85ee83036a7a393ec(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3601c3dcfe9443ed817b1f9f46583d41cff2030082c5341eff2d42be48fdb733(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1e314e47232550984420e74b72b8cfd937ffd727ac46f4a27c6f099e45dcc620(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__747c7de712373a0a5a9e6ce81a259a3ce9a551e6f6eb9cb8d3ee3bfe3ea28405(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0f93e3667ec62504f21b91f26a52d539ff81e37e47444bb1d03316534b7c417d(
    *,
    algorithm: typing.Optional[builtins.str] = None,
    algorithm_var: typing.Optional[builtins.str] = None,
    confidence: typing.Optional[builtins.str] = None,
    confidence_var: typing.Optional[builtins.str] = None,
    fail_gravity: typing.Optional[builtins.str] = None,
    fail_gravity_var: typing.Optional[builtins.str] = None,
    focus: typing.Optional[builtins.str] = None,
    focus_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0e0e7758e09870bc1d634d459eaa91119750473c8bcae8668002aa9af0711676(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ef6acfec12a2d59045432e013fce3168bd97e4dd113ee3f3e2f018b70e2d2bb(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b927f9dbbf1080a737efcd983721169feeabb8f321b8962f4986f291fb007130(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a2f0fb27c03ffc78635a0355e62d8653439f6e32e56000f6467c0658e08eb45c(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9555b5ac6914be4daf0249f40201789a626b5bbb2854e1b51a6ae2ff5e490b27(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8533d89fb7dcd6687bd3dbfff42336c3eaefe146b484f613c0b9f4b7519356ca(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationFaceCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b8f3aa1d607e0af3422db527e03198ff526652c9967d306314704f2cbac99e88(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0fd37f13d94118d36b1c70461ec35e3cfa8238070dac78212b076b492640a89f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a1cb2ef5b82b7236a7d3c66dceda899f6c156a3c33d24a3d03f6a5906dbfd33b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__878081ce18a6d9c7edf5a76d66921d75aa600c89f3318e43b3d4ea8e864d16f0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__00f80b9a80460e8cde101120a4d54dfe483d789f3289ed60f12b7f91c8b90d68(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6bf9e12f3653b4e35e69633a1a525aca9e1c075efa3bdb1b94069a5f3b7697e8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dd95ccbf00810cf5b69209c5644a23021376a99372f2a05b1d5313ee6c5745d8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d4188e5a712d88560269e8cb9946184edd3ac86196f4b6c917e9a6ab543224c1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9066048cadc1391279345fc8626ef26b42ee265aae5c3beb46bcf639c413097a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__790ab47f23e4a2a93061e48ce3da1efba5f821b47f4ecdd267312059b65f8588(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f1389f98329108ea6479d560318b6372e2c0ca46d74ce52e2a811b1d7cddb982(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__067ce19342b7bf86a643c9d90b2ee640cbac49d0068c0b36d6e3e1533a88658a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dc719f7dec797684cbdc43d13eacba695609bebf7f53ed1185ea8b5a042264e3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__02bfe9c3e79a1910321f4264a2ecda96124d94f3f1e897084b2c55efe6273cb4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4976f0dede48d2c8094030ce079696af5c2a015346bcfb04c81f0fea58b18350(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7e37f30f2acc1c065c3882554ab264d173eb3122b66b1c50583e5f97f0a64afb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__56b66edee80a692c53c5f3617cd7b1d1681db1f0391525853efad827becccc45(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3290f6208ab12166d080570f4b973f33c14dab70077d5abb67d25e0e867404dc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__482017bb1ec56503525850720c62f9ff1462aebdcb8cf82a50e7e42f4a9ecc20(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__85d61a05822cc8a11e63e6656493e6b2aad8301d3ddcc0a54e14124f7bff87bd(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationFaceCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6459cfa0225ad708bcabc4d88e6f49e552284f72ad8e9b01651b65bb9c8c3b95(
    *,
    fail_gravity: typing.Optional[builtins.str] = None,
    fail_gravity_var: typing.Optional[builtins.str] = None,
    feature_radius: typing.Optional[builtins.str] = None,
    feature_radius_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    max_features: typing.Optional[builtins.str] = None,
    max_features_var: typing.Optional[builtins.str] = None,
    min_feature_quality: typing.Optional[builtins.str] = None,
    min_feature_quality_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d0e32002016ec0281b7c8bac59688e2d7cb8013181139eb10919d951ddf89d0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d9a28329d6e47716d0e15bbea70b0bd366e74324ac614c0daa5e4dc8227c0f2d(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7ea9f8561ce81e36ef26c9d752a770c6c59bb492447d01d6db0ae44308bcdb63(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__648a3f5c5cdf73f58c3f09b08c0709fcf858f305819559ba10b013fa324f5b40(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2fd0f5cb514211e103339b9e70d3ff9dfab956d96e0324454ac66d4e7daca98c(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__99fbbef73a263b1467220a0f25f84220692406134581891fa1cd6b83102d17bb(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationFeatureCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7b8b7b8873bb4670783e41e318a2a48b018d72f5463d052c1037bf573af476a5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d6a2983bf7a5434dc836e73de2ca8de95e835bc6db3dc994874eb9c4e8660a59(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9e8ea0c229314623e869da6b746f87e4cee4959af3e1228e68b75ad7c009d0db(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a32709bde1a9963495d88ba2b7f4f2a23bf21eb46ec7c3481f8795323c3182d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dfbc0cccea58b0bfa7faabb8068d75c06dde8a0254295443273cd2fb5f1f7a27(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__16d5f055e0a094e6fa6f7847fe645022ab7d1340d7fe9c88ed3a0d7ba0f30def(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cddeeae99b32bcdf5e2b4b6621c2fc61326b722c43d593cba965b5fed2932f5c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9729024536e6ea2121610f809357d78b122d670d80849f825a27e6a987d3d488(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab2101a002b5c07b1a9649ca6260b6b7644943a0de3d183ca35bc324410729c1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__826a75d7fc26f290f17ab52bb8a64978f70c4ea393116c62037852d8b7870a0a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a8268d828aefa91d5229313cf07c6777bfaca9d3a0c08c4a8f5b7f0290ff761a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__59a928b64fb8fb923064ec86957e79518225abb8ee208824f95273bcaa478ad0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fac57b3b6a97aebb7a48cdec4acdce223f9e45e659317bf08f2022872ec344a4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cf4012af428b9f3079b2ba7b0d8a5b2203f20a6f7e055ca7cfe60a9363622683(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__09248c861810a2188b19b0a3da05a0c1b87023003b47effd3a01c688717ec2f4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f951c67e7e4f1a8e5db885b8afd9fd340d20bbd4e175848b31544f6c95aad0cd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__16f6c3ff8d2f8eb143267b313f6abb0aa86ad076336b0c7bc9f23e739c69d102(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dcb4237a62ac004899b0037e70fdb94676f4c53cbaf4d1f2b4e89954aaf73896(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0e115fce980ccf20315ac9e3f050b55f68587ad39c3959a5d360ffe86538cc38(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__39ba288a67860d2450258957bc816d292e1075ddf1ddb7c6a0e0122ed427c653(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationFeatureCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__54d0dc4144e342499b60e560e1d230d5bcd2c5af83b160a63f7eb935a592652f(
    *,
    fill_transformation: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationFitAndFillFillTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c22d1a91333ad5a98ea05d4f60129bbc47b5a4e909deb6cf69a08f9468b78508(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__556f699d471d04c18d9f215e8d05c055300c8bbf764f249110995b93cab5bcb4(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationFitAndFillFillTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb8d11620cf4059088ec04173060a541ea07ef0bef75a1876e8c70fa236f7244(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bcda21e770e87d8e058015c21ff50bd858aaf6899415d4d65a279f5e97f79b89(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__61565d1b58a271e695c4a82c59eb46a70499bc6b642d208c6e1c3ca95f104e06(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__733e8fd005c5cc9993627d3cd205e2a299a2be0aaa6aa918204fb68d433bf56a(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4e5c8a555915b80ec633e6cd228a5dce587b99fcdc8d9c1b5c3482aafc46199e(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b87168a002334f2532ae512b3a97fe4fbaa950611508725b49dbaa145b3453ba(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationFitAndFill]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__80c302b90b891c021a1526dedbe68eb1e7e9b33101fc6b2cd5c94e6a9be9dd03(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__02fd909646f4b133d6e0b4127934ddfa729a189518031cdcd9874bed73b6f52c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ca3e515a33bd6a21ec2441a6bbdbc7b771a6b776ddb7ce6d3d2e8f31283b24f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3d1ef1d0385b7b181b0ae45c9331f7eb59a13487911640e0192648012377e9da(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e84a22583b5606fead14a4aa62ce22216bf5f075712e71e28e0b77e8d47f0f41(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f712aec5e28b890c686591ec0b2fced0b9364a0df3293617a6d2475e1ec83308(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationFitAndFill]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cf4c23499e673bbd737164048cfa882003b219a71785f5b31fc1f8691d14cc95(
    *,
    chaos: typing.Optional[builtins.str] = None,
    chaos_var: typing.Optional[builtins.str] = None,
    density: typing.Optional[builtins.str] = None,
    density_var: typing.Optional[builtins.str] = None,
    power: typing.Optional[builtins.str] = None,
    power_var: typing.Optional[builtins.str] = None,
    seed: typing.Optional[builtins.str] = None,
    seed_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1d4be1568e12cff06e5eb91838c41da56c2835d8acb683e5fbd91f9b55529128(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__215e3c870c151914389ec4b7117d75f6c87817fe3713805f4efb8e3df837e968(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8c0c89a2934688abdde9d283e425a9c167e4180022557cc96f513eaec628a2f1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4d27c8c36bb73d978a2cec0940c75adf233339fb9ee4d436f4cb2f2b9cf16e21(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be85f30708ec72296ff1bd408f849a546a5584db2f61b951d59a6fab8787abd1(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1429e947732661d2da7fdf371989ce09cdee9a097ea9c542c41744ea5b14e4b5(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationGoop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bf263bb0fa238894717a2b1e475acf03ab00663429a89115c9668182f89fa069(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__83ec2bfa6cd8b432f487d7a0d19191091a8bf7730088b3206ecbf93cd8ad4a9e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1262138d0d613e3aafda065e3efca13c85f6b5dad415a72dee1f3ef7ba2b780b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1eb95cb79956901b802ab244f44e6a4bc36b9956d0c5ed149ad71ea09b66b4d7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__da403187ced504c27a050cc90b25fa486d77933778ba16dfc70e4dbce2d1af67(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d662f39c748a46f37527b648bafec4c29210ff6dab5e0b05a0e30f0bd7c26a3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9c66002d2fb7af7e34fc27df54cc72de04bc136384cc116de8d5a4481332d533(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__10ea398e75e5d41de470de71d5f66848e65eeeba3554d8901b13a394c17e12ba(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__03e8e8ea79fee0e5bb209f57876f82b738c44353e4747ba8c1387e1e8a145fb3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5209839759d7e42309c8421dc9f1664626d21de7fe373528ce663547d88e4c4a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationGoop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fae7470907f60554b09cb6cf2a06789a7d7c6c1b1db2073d3bb1ce8fa45730ed(
    *,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__42fe1ad6001f27ee2165d336b5dcfdb20d567f843c6b296161516fca2f936e06(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__471f1fd33f284f40b5fe2534d93f4bd8911b8a825480e53e353d6a88c2ed832f(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f9570df51ac24890c078a2a416c35c18adc4e0ada73b4f956f69223ca754b5d3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a13797460840739a486177ee651f2888a5fd4389c8dd4c53ba8e8f00c9b0cc08(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8e9d9aa1ca9222d0c14d1217aee90f3ce068656b06a64e6ed2410cfae5541629(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__42c0ee756e8c12aa98d6a66163d3bb0387c4d84923f7f70839e210e3e0475f7d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationGrayscale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f63f315ecfca3153658fd5c87254b3d6270f82b2cd9abe3049cf86fa05f45c20(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5a60669e9d32a0febca77dda6984d1eb67ac569b525926f53dd4a41d36f0465e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0118e4db73110863296c798b32aa69bc008ed180dc7f5be64800aecc2fdf8f05(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cc8f7805f844cd051a122f235e683d4e04a7126ead59c6686f21c8ff042d5060(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationGrayscale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0486bf56728fe8b5427a6a1c53836e39b3f3c889391cce7a4cd2d25c4a1b53c2(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness: typing.Optional[builtins.str] = None,
    lightness_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e5b9c3442c083c9003f604406ae18dec8c611c79b5edc2b98bb44e7dabfd5741(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fd51610e9bd0a773694b6376f98a2af8664274df36b4c2aea88df7cc11a24abc(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f9c2964efed8b36a0d5be51aa5172b1b64a869458f6eeff93b6f0479da18b8d9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be2e52d0ea017b5f3058c4bdb2ca5e867b4bdaca4db347b10873f8c1fd6c5800(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6bd5a660c30bdc439d2c7a1a6bbb59044943b1b3a718777569177520101f29b9(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f7d11ee628f2d70b794dd86bbf88d6d079f23bdac76e25fd9b38b6c819001fd2(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationHsl]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__60334ac3efbbf0e36e638fb2ea1a9f35d4bf2b63bd6ffab64a20a3428178a05e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ec4f54e63d85e141a1f5edac5ed7d82fee0bc768850e93ac95a68a5961a5262e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__534f3dd094bef47f48071ceb576ed771ded364ca186ec39e00bfec8ec44308ab(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0fa6cb0e84e79da9db05fa0fbc5986702f27a3a0f7e7033d701520b7a101e8d0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__31d39daf4778ee93039fdc9ab8b626a5cefc3992de714d136e3ef4f774e6a696(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__79fae0a7b15d06f7ccaf15862085366f0c0b547c25b6988b64e54a731c18e704(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__70c1d68a02a76001a9638539633cf58bf6249937e9c70cf35dc1705349d28f32(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f0375238723094cceb1fbbf19a05a2d2bee38ca47245d53d1fa8c2ace97d9de9(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationHsl]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a4584f02f1a3d85a1887f8c0fffbc49ac8fac098967cab25cb9d460e0cbe9256(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af80d8eff4ed1938de724a38ba60c71435e04d7d9cbbf483ff98920ece909c38(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__620b1027ddafec944e2112219a86596ac5931f625dc6ec7cc967805eb56dcaae(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__695b07f52b1ff746f5d4c6716e88bb63c0cda20267f313ba306ec96a02cc09e0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c6b2604b1e61eea4c4c045f098e9b744c96ad21d8c7c6a236b0b3961da9295ec(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4fed4fe567f1881c584257c2248448d58f849c0236d0fcd5bfcddb854808b183(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__39a1edb5643e97d0c695b5a68018541e84b632306a2c769d0b5f6520f0c25687(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationHsv]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9bd0831bd9c9dae0e23e23a90481aa1d3a558376342708e2efc64706891e8686(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0581184f776aaefbf31273f0b2c1dc1bfd154643804c4dcf57bf6a1c3885e0a8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cbee38e5d63d2347606b47ad4bd86f2843e78f55a8cd31c38b7c23ad53313c15(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b6754d30fd49bc787d4329f7091fb1757c0b8f38da5f75074d6e1daf88d64007(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fb32a7ef5544ebe64a650662e085870e26a7a995d6906f8d5a37372fb3752cb9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f84fe5cdf4a96e9410f1136ac44d2a7c5649a46f0265c876bd8e99db3a7f7d2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aaa2cd4bf5dad19415c0fc285d81b4a8cec1b56810dd3f7d84b91d24acdb18da(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0c84a8d945eec6cce6f131d643ebb893657745b6299f0dad2c76d271836a2341(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationHsv]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e7ea378e630ff63bfc18bad22c8068757603d9f3d81a7d44423e204d5b6b1272(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfDimensionDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    dimension: typing.Optional[builtins.str] = None,
    dimension_var: typing.Optional[builtins.str] = None,
    equal: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfDimensionEqual, typing.Dict[builtins.str, typing.Any]]] = None,
    greater_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfDimensionGreaterThan, typing.Dict[builtins.str, typing.Any]]] = None,
    less_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfDimensionLessThan, typing.Dict[builtins.str, typing.Any]]] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e3202d67f27a8ac5b9e81f3699348d10952d69550a0da54e504c98a4cc3f0d5d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__113b6f91fe21378ee692051d85dce9c130f9522a701a4552ac94336de3050582(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfDimensionDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ee49533513a13b788c45c6ea4edec9d13b2d079b456257f3bc17f3d6428f4b61(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e69c69860053bec0d45b99abafb5287e537943d356ea6d8c278f8b7efef09e2d(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfDimensionEqual],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__86a861d3c6ac551092c659cb4543160fea8e8cace54c4f4c1e44fb5d76287cce(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fc7ff9833f8d273cf418263545c7b3567029edbac5b8fd908daac903f7c42d1f(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfDimensionGreaterThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__676d05c7cedde48a57c17734017ff9d9c4b1aedb40e892d56f01db0100e833f5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1c91fa4d2afafd1fd96cb358d07e4db24d01bf4f541d6ee48a9100a7f0843537(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfDimensionLessThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__399caaf28fcdef170df4666f68578010527948d70312e3629525dac26a7f7710(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__72a5d2b088dd3f99329c6970160b5f675af671b067e517a392756599440d925f(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f19eac15165370f6d44b41abf8e98d5ac50edf279e5a1212a0b666a789cde427(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d7ea326cae3c431905aa441006c073d2cfc22f5e1a4e68c4061e2913bffe653d(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8fb7e3dacc4a7396c54eb7653e3bad501fa452c87267370a649452eb30563882(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7e64a6e985670e9becf8888d8cec8003dc8263709d1aef4ae392b4bb3316d603(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfDimension]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d67943ef9a708c5b89c13ef219fbd405d6c86c2b8be9ac071f12b5ac15015a3d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0a74788ef2835011afa60f8d0f58fedeb2b853acf9b5d113c7a9cffdb00c24bc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f04ca611c8dfd408b4d6f8ee3817410fea345d88464b7f3e7a6adef73641f689(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cbeaa98f467606ed9e3000fd94b851b105983794c2d6aecc8f515960cfaed38f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5a15aea99dbb50dabd131a8a97fd8162a5fc67523fb50eb5b573946e8ab56d4e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8016568045cd98daddcdd2d3fe126349633d566bc023e786dac9b207f417d850(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfDimension]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cea0059201f8fb6d4e0f9527d3067862da2a0ed4cd758330636d466cbc24ac7b(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfOrientationDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    landscape: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfOrientationLandscape, typing.Dict[builtins.str, typing.Any]]] = None,
    portrait: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfOrientationPortrait, typing.Dict[builtins.str, typing.Any]]] = None,
    square: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfOrientationSquare, typing.Dict[builtins.str, typing.Any]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b146ff9510626b779b10657566f414fa14ddb8acbf52419ebb4aa5ba70ff19ff(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__95924f0930b7e0ba940fc22666dc3606e689fcedd79539d50b7e12aab85e21e7(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfOrientationDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__68cf1bbee3c0d4f41601f4f67b178d9dd09a9276c48108dddca03aeb9b1ad3bd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6a415fa980bb88d8154d3fa39f860e9dc44a90460f3266f8a4c0d02c4340ad3d(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfOrientationLandscape],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c0642217c1a6585b69b97e838462a469b50c164e07e6a308ed370bab23192edd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5a5b1d8997ba28694f88efcb6c44e5ccea61b13990e481ae62c1e5b82e5cf02f(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__218beaf3f5a8dcb26430d5e4a51df8713a8ebf3a28bdea34609d326b99db5c56(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__85aa8ddc3ca422638b11317edd6892fe5a56e64d700a3acef87db050670e3c8a(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bbf25d1995a7607522ad3f13504461d406823b29798fd1a415d9b059c590138f(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1530491d7f1cad9813d95e20161c95e2cba6af255d429df914ac508d7ce1578e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfOrientation]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ad02f68ac7731fa4ea7f5999ee93053774d2b1e6d28d18c1cd9966a19039177(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2802a045b19cbd1bfe418c0f5b1b576213999ca336ffbca043cf9ee31033582c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfOrientation]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f4c270916b7bb9ed4d1eb0f79f8a6e873df9e7b81cc3bb4e1150224a851b5c4d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8767cb42e0918f685f9689b55ae97706bf7a564820f6692f01de1686115d926c(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfOrientationPortrait],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e0f930575440601ec28b8299c4e69bba4b6f9ab505bf9b9138f726694b54ecf3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac77af70115815b607aea4bf3f4f81d3d1e479bd4877946b964e6396be43372a(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfOrientationSquare],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6179fe29ffcf47d7beea1aa4e92016789f195fbb59e2f73e1c414d6d8fa8a6f4(
    *,
    allowed_transformations: typing.Sequence[builtins.str],
    query_var: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c76d2277bbf7335c8212f25416b229c0b6d3b8a39e64251cfaf9a1babe37fd2d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__28136507e4dc717fd25e577c7c97ececb37862787c3ad3afe3f65c71e21ba49c(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5814a1c28f620021148d8b42b23ec7f61f153f83787fbfb8fe263d4f391e4aed(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9bd58f703454af2393b5b5df81a5ce3d5a0c81b84b2b61c9c6612c89da13bb1f(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__27a708ccf5d4462ee07b4394d86b99b193cb8c1ab18f9e750ad3b57c29a174ec(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aaace832debc0d0656a4870050011cd2afd2cd0a6abd8cd50277d92dabf16914(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationImQuery]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a2637a4873fea54d32f630d90462c91de0936d0242e17348fdb8cccd056651b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e20786e871264c332cbb4417b50ee6e6e8371331c439b103b030433de709c23b(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__82bed6a515aa2e67ea919b8dc211f9b177f6349218902ed7e6be5002a41faa58(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__728f1f2d22bfbb26d7b7c0170a777a6c459e34271e3448b7779762b891d1ce98(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationImQuery]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d3c3f468e1fc48d10d3abcc05261ea29840ea7cf84864c9f19f6105f21dc76d1(
    *,
    colors: typing.Optional[builtins.str] = None,
    colors_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ab14e06096c2615563dacee97561f1334854202d1644f315dce3db24b43ff98(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__022217e66a5b2624ddc1266fceeb63903193c211787edf3a988abbbcd785468d(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__227d95145a61e9640bd9930277540deb8aeaaac247cf6c797c879d37429d8d92(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d985a093ef763008ebf9c6349d1231fd136e56070c3576537c78f32da06259a(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a9b8ca157cabf2b998615ae230da8bab357b569573d28476e9fcf4b705fdac9d(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c68afb1a62a750fded72c9060679a7e863456104a28493428c8d1702c49ac9f9(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationMaxColors]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f514f1df8791bc9da149273f56e8b218e4e3cc4ea962d474079c9b73e0234e8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__590c71c01d7adaa3cdbb86d7a7182b14d4eab58d045ea80f3c44a1f747c6a385(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__78f5567ac52c2ca78ceccdc7d43bff4a5f89aeac2c72d5e078263c3c4a317d08(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c325e5f2d12672fc28278e87d7f36f7b4630e1fe8b62efaaa49f8b2bbfea54d6(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationMaxColors]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ed6b27a2adf8fa9c4e5c76fd07a4cbf373939bd3a4fbff49ed7ec0712cc10b7(
    *,
    horizontal: typing.Optional[builtins.str] = None,
    horizontal_var: typing.Optional[builtins.str] = None,
    vertical: typing.Optional[builtins.str] = None,
    vertical_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f6e4a3bad9b424596f6b0537f2391bbed0b7968f005bfe72c80373bd1e32b7e4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__56522ca0c8b1474e486a5c7cd391d4c61fd13b9a0bb914b3450df1fc9bebca19(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6691cfc654d7651a89d8cf6de5c74ab4af393e89fe833106944b49cc0bce0015(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8dc84dc8ad478a3166a7e21ce3d9943f158fb6acbdd944cc0354743188535743(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__131a01fc08d025b6676c200f27b299a75df4031b419a6d7208363116850a29dc(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2e6814bf6659476533050d8e8347d0917e08bbb49fc9d77bd336e49e342ba088(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationMirror]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d7edb31e8a1648e9bfdae8d7eae7b13ddc17d60a526b64f56230f763aa0e939d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c8e2c898cc77f8af7a9404a5ec63cf2d90dfc7b17d3fdf33567e3a0f20ba5745(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ecf4e5eb442468c1b4711fa43231be278825ee672a269c0d26c842e59eae9991(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6247b997d187c101228ec07dba07ccc56b7667e08ce06ea1b5aaea05b60683e3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__de2c022cff87ce4c100301413dc6fcec340f95e5b4c34b2b15c666a9a5e1212f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac4dd3a7c05882992b84a7406dd67809e5daf120c1f518c89ad799436eb89c5c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationMirror]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__958dcca45669fed26dbcaf9e17456cf7147dddf411be276b25fe0c4b87eeb2da(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6289376e109d62a78be5ede865ea070ed59df417bdeee58da60a2d25eb5560b6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__02b9e659f0d69621b7cfc68383590837b73d8fef6382616a9ec1fa841e1961cd(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ed4ef2e92dd4249b4eae45ecd3559a69a4e39bfa3afdbb439e3114bd06544393(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__356a4fab250cbec036dd08168136b210b647099d28c34f2c4ea9ac0135746e86(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ca50e9b58d465009bbaaf0e97ae6f85bdf8d9c34298096b02f3de9ffd5506e94(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f6ce8131b476fe8d982c07df82316f988a60a93a8c8ca0f952bf3c0cf4eaffd4(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationMonoHue]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e0b02cc9a110967c496b264f48d52cb1fb1f6d3ad929eca09cdd3683cf59704d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__364b1ecdb304609f4fecdacdb3d7d7ebecab802141417f93ca06c742b2485331(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__65b6e952762aa62604706dd5034e8455920fb8b6c5f861277fe59bfcb7cc040e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__686210ae28f53c0054a842c19d1f2dafde8f1871c26ffba2a992ca86c880af03(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationMonoHue]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9dd0a3e68281cbab3e8e2cd438a563aaadac1a98f843de1fd6d3f2f9afc6915f(
    *,
    opacity: typing.Optional[builtins.str] = None,
    opacity_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a531903a6bf9a64573ce2d13d64d75e9145d0a32777bd8ece1992e52bee6be8a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d99d5bdfecfd563a726fcfd411ddaf17a1df2dc4b2bbd467bf93c46d03eee4a2(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fed1b66cb87e6171cd952a7b78711b787482082ef297219904c79100bf796d35(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a11df75333ab9398d9051e0144ad8b9bb950c98aa802a351ad7fa6758fd8d79(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4cf607aa3279854ecc555b4de59517140037569e522e8fcc75057c8e4ac09e1b(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fd5d45a879a875f8c67f13496eb9a00aff162275d3fb490fc45f7da0c5593085(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationOpacity]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e7e6d7f8ebb46cca993fa88b27df9dbcd8a9199fdcca85f8e79440ef9b61a635(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__88d86f2f6a4d2b697ec06861c8f7814ab7e04d449c90fa67ce3115b3e54cb79a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__197b1cfb41475dcc75d00a15d6c0393fa90521e578438b0e449a10416586b072(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d197b605dc472b4bd6d8e86af69157678aafce73567b205edb7f8e8886381bc2(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationOpacity]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2fc24bf139d3a87382dd0b213e0999c20d19eba54795e0f43aa508e8710cb769(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e6b95590d50ccf863fdc7f0d9e6c83a39ff479fc8e0ed2e5e3a8e7a52ecfaaa1(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationAppend, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__982b6db1c628f5f1b474646802a2e5a20990ace25682f53153a50dd0c4a6ac2a(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationAspectCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4dda560f4653f8f77721eea21a8f04e4d02297f517453358020fca6b37a00b2a(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ef24622eacefd35302077c59806dbf205888db8e1df35021cb4fa55ff9e9cb14(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationBlur, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c2c718355f05211312b3f6095dbb7e96ae761dbaae4500f10bbe3f8edcf05d33(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationChromaKey, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__887af053102a0c0916c77ff9a76ca9b55da2f4ad08a30a8a550f29c2f31a0f23(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationComposite, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__29b324805272964c93711cf27d2de3fc3851689ec3842ce0f2dbe99ad7c4f230(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationCompound, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__46d0406a2d728709009a0c2c78f7b2c4c31376197fc11b538004a4b04a96ffab(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationContrast, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__234851b81f0d44109ea5677a22f6338df32371c957fb5bd6fcca126c4c4538c1(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc8faa53302c70148f3864d6c38a2f07246684fe27a7b4f21ffa22b5544ffb08(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationFaceCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ce707d1f7d40167fd23023d9a096a33f1f7f1d1cccb0b7a60b9781f16cb09d23(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationFeatureCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fb7fab1282bed3be5c9f5b7dec1c5379c9fff2ff6c5af480cb6af77cba6b5aa5(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationFitAndFill, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__837015ab7f6456ab1a2a0aadfa005a551f9ef2db63e65a35729c41f9a0f3943f(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationGoop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__41aaa394bb3f62ce095d3d47bdcdda82aedf296de8d1cd9dca7df94a0b5333f5(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationGrayscale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5dabf26aa5fa8aff0f4a066917fcb7f96ccf54ecd456bdc07da257faa4d31037(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationHsl, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7584ac1af29e579996ecb95b81200aaf25109cbc245d556f7166e3c630811dae(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationHsv, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7f979a25a6f20d71dddb01eb24f882f965672e3c2fdfb15b6a1731e64c8f843f(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfDimension, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7b4ce9dd4c1232656a80a52c1c64ecc4ca72f53e8535e69c6cb95c92f42c279b(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d441f28d76b1c1b5e44888dccaa2672ebec06aa9eef28b6e21c01936d3e65b3(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationImQuery, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__15a8a23d69096e3f2d4c541be5a1be573ba249b6486754af539dbcf26d625f6a(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationMaxColors, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bd165a02fac82bf3972bf2eddfb6e2efe7241f1efaecc2e8037e86fe91868e35(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationMirror, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__640ecd76041e9c2d56ffcf836eb38d2e2d836e2a5dc9eff56e3731e75f55f09d(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationMonoHue, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4c380892f136bf8ce9a743418fb2c884ce0632b3c3b878cba78eae4b03213b4e(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationOpacity, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1da5af7e737c9a5d6aaca5e265bdac1d6ba53fce8d045e948ceddbb998b3c114(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationRegionOfInterestCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c454d9508d808885a53a30c5386c6e490cc41023289977d5a24ec399f5976a36(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationRelativeCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ed2cabd92cdcfa5637a1580e90db47427b3617d4fb2176e38339f574279d1e73(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationRemoveColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__22877278c65a26ac0db730ee75586a2a5d18b5eadced6414628540dbbd61f21d(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationResize, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__879a5edddc03c53ccb5db08707323c238af9173c98174e277ff247a065d6fd50(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationRotate, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a81c75fa8eb9f107f3ccb2d42a6861350d950e373e165ae9053633e8869e4f66(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationScale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1d43e9829456f8776b537d7d9273457d8606a747a804f4ad76c02186e966c741(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationShear, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8c31e921fc9ed36e111d7e990d77c8bb81eaa6ab6d19fd0a2621363b771d0294(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationTrim, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6aec40641b51c2b77e41496607acf89fd65f5775440a0595f6f37a299ca0819a(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationUnsharpMask, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc225e7138da3fd40efcf8cdcb90dcae08b545813a7c8423142af12e54fd1d80(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a75b4b60c3e4aeb50703a7dfb9bbdb767f710170a2c7cf60275b360b40e0a5a(
    *,
    region_of_interest: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationRegionOfInterestCropRegionOfInterest, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4083070230142de377a23416197767618325e5a0faf104c3b28b2cbd200e5366(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9e3e4279c2a65cb22563a4d97780f539824008a75879765cbc134ea18d86d736(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__166dfae403e68b07c579d893b520e2319534b5aec6e14b6cd018b02870531e87(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6ac403d43337ef1c6352896177b9b7d3371cba8b2dd4bdadb3425fc395ef2ad7(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6ea0cacd180c759d3e76b916290f07332dde62bb87c95631b7ecb1aa6f291b63(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c5e4145ea2bd49c9706ed744c43cd1131e0041d3bbbecd37b3538a0192be3625(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationRegionOfInterestCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3c48bb50e604dde3c4b3850f4b9230d26becfdbf428c12e60102c474a16daa48(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9c074b6c83fc8423fd288102f601184097e6319a28cd67e57b1b528ef8fa1b8a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e769bd3b0975ba8f09f559b6e96ee66a7cf303852a5d6c520b1e1c8b3bd674d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d8139af8d0b872d5176184b572e98effdbc89957774b891db0ee6cf49208a981(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0404ac59e88e646daeb8bceed20bd75afb35e81e96ef17630b85018ea9f17282(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bbe799d973a9b9da4c37cd6a06b9f4fd1b1e7d36698f0f5825bf49475c126768(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b6a02afda702d2ec3c9daf217e13d07d573e380f9ad5d1155aa0ded1379b926e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b099177ca7e80f6da7ee936456397e5ab6ae21ecaa261edae92556cb916fc285(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__10de32f8b679a40300111daa3021e5bbe7c3f85a65c01771e06429a57054e512(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5e3c055384d4a98f20c594a43fd6e32dd1f5e29338436f342bedc6029d3c7efa(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationRegionOfInterestCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9e01fcd77f5c6831c483236a4146eec9b6866598ebb668a4fcc411c29703e1c9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__92d68513b5f5dbfa695bb0500ed1975cc19061d0311a2ea3bed3e3623aeeff55(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationRegionOfInterestCropRegionOfInterest],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7ea4f516a493d7ef38d0e2acb637cf80e5d09083b4a2a93e4fba17e55280d50f(
    *,
    east: typing.Optional[builtins.str] = None,
    east_var: typing.Optional[builtins.str] = None,
    north: typing.Optional[builtins.str] = None,
    north_var: typing.Optional[builtins.str] = None,
    south: typing.Optional[builtins.str] = None,
    south_var: typing.Optional[builtins.str] = None,
    west: typing.Optional[builtins.str] = None,
    west_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d89f60ca79594441d2165a7978942a493933b20b524c795e199549045d9ac64(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b7577f51791d79d227cd938c1a79b8eeea596db2c64e3c4856e677dd2cfea9a1(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__14038dec01e6d7887253da6a74a50a5dfa1e1a4e8871245906157d14fd29b17e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__18d0e887e8fa63712c487d64cd4ac304331c5fce7ea350c2d7e16f8e90c642b8(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f31a16c42b0a02cf725974ee74bbf5b33f87721bac3e5fb900768dc970a4e439(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eef1d50829a67e639fd1440e7a9affb81ed00e3b3f947e3d4631ca1f301f6da2(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationRelativeCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dccb78f40a9f20a656b77f2936fc8417f32f2a7d204f480eab8c5921f8d1c745(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e150ab41b1635388eb95c77bc98ff167b2ffe0a0ef1c5bf9eab067f6019159a6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__472259650579c09c5ddfc990292f3b9279cdc5779315dedfa2e4c584e2bc5de4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1d5b29c1ff972f403e67181c6497f8a7c0421e7576ec3bf7be3c00eed8d6a1cc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e288233a36e2aee9d7ed3a679e49cc40d0d07c12ba205742083fe9a1796ff3e7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ca9c2651443439fa17fecc382e4c0a46c7271521c3163a9e2df17f61c3179d9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__73f24fdb04ada7e522f4453c895ee9cc1480ac3d5febaab59003a114eabc4c1b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ace3fd51fa102e84a9c145d61b6311b3f5efb7845a8b3729c426aa2f4b64cf22(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c2841d59797ccff5be15a2c042a79f3912e4440edde321bd3b074f41d1850dd0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__48f5067b3ccfdcf5380b5ba0274666dfa08bd7b5be577da7330bff725a05b43a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationRelativeCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5d4ee1674691308d01d7c5d98dd52225a56afbc89a92475db7c8900fc090c2fa(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
    feather: typing.Optional[builtins.str] = None,
    feather_var: typing.Optional[builtins.str] = None,
    tolerance: typing.Optional[builtins.str] = None,
    tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6b272bc78961ca60efdad863597fe6949496f382f9959c172425a910245d2840(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__290c6ce7e128f074787c1def05d8723fcb6dc3e7f7ebb584fbed10f3dbf147e9(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8968520867555cd56142465331eed53804fd7bc286d5ab8f2be0d0e9884b28eb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6b2b0cbf288aa415752c4a636079786ad83acd1033583df852e0141ccfa4fb2c(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea31d91e10eb244580f3468d41a29abd4fc5a5b2227bd220969bc2f703c650fc(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ba945c1c2ffa8b8a142abf5cca5ef6e48ebebc66fb58aaf021caf1e2f273e66(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationRemoveColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__697a933da99c40e3ac5c284e934778f1bab0608a45f5e671d0aee143370d1ee1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__97a7445a82af2e7599aea15c707bcc49784805182750b35e49ccef54508153af(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__02a7182a50aecb76742cdb0030117ff15d9bfdfa53871f2762088dc165455f75(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__28dee3264b3acfda151d404e0ae830b962245a92535b93fc7fb36c22d8f9f6bd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__72fc8aa380aec697f8bcdc2f0933e54026ee56d206c184181b4f42f87fd682f6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8b441e6a03edfbe3cdc088f8ebbe5f58a376d882de8662541bb04c13b41a8cc2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2e66845f2c79d2ff3dbeb348c19bf335ea69ad40fa07e6dd3f05c545f3d19aef(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8d3dcdde4840c62a8447404bcef79cade407db49f283d3f2cc6436c3b95f0164(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationRemoveColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__635b161fd751032d07f8b2f8896bf0c81e0696d97cf9ab0a63250ff441c7d3b7(
    *,
    aspect: typing.Optional[builtins.str] = None,
    aspect_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5806cf29c45ea7c48f096a8ec2b23f2ba65c40bcd762119436673aaf756792c7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5c6fdc608fdbc10cdca793bacfb4c8d9825a79142ba1068e6a3f9457cb5e9fba(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ba8fa6d24baada891cc580cfaa393ef7accb2c72ff7e244b708b9cd1da9a147(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3d6a9f5e6ae29ad5fd474c390378a89b582af5e34da8d87b6b8cdd564dbc16c0(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cba5adc1cb0701729befc71217b315272e171bb36871b7436146ca252e43c0bb(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__772d68b46a8c328aaabd4b564f209da5b81865d2f6397645201e945701db2fe7(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationResize]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__57c9873513ba7825abcc02f6003b42ac290efe398f861288181275fc36a2ffe0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8741ed6dce0c1b08eaa9f20c3e4c973109ca739d9d79a97d325c34356bcff6a9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aa4445362c23599e415ca68d8f0c50d39fd4a03f8eb82d38fd150b511c9e66ca(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ff59a1291570f49c781141a98f9e04dd12648ea7d3df827808c520d1f734f45(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__24ec4537f56f06285b84027208de87108f2b9d2b9bc22e4660661bd60da4712c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b6be9889e3cf09a19127cb934b6cd1a9a20a7a91c295a0de0cfacd04b84269c5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__14fa9c380856b7311bf99d9de22c6c537b9b13792f7b47d5ed6be259b5754be6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dd022406b51186e2dd57eb725ff1cf24c51554cda7db2a073752922aae60c709(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__090d0bb5c33e58b225fecaff1da2f0db5c9c7b06c3395932d8a9a5583c62c96c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1cd91a73ce52f11605441ef0df39a34570e5029f848e3bf2c3e68c58534055d5(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationResize]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__afc01e50a25c03a5077933767e3ee83e17dfd0ca4d23cb9dc4b4e027494ccb96(
    *,
    degrees: typing.Optional[builtins.str] = None,
    degrees_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a09f9c9454f7cd106e60141aece251e85c1e546cee7ae6afa03a2e652fe33e80(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6ec60c7f80eb47b78d970bdb8bbc3d5ae999b07b9041c327313529c3fb7583dc(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2813b8a22e633db7c83065eaa9fe5ee9ca1eaa98887c2aa481f00d0590950521(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b9457593520ec3bc1408ac393daf727688fc72195b6c03284c04f0ee0eb9839a(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__141630ff49309ba4ef572d7522a9627101030ab1f2796b81d93ced78331e5cc6(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d5111fdace177faa9fa5028103f16a71daf8e6e939ac9f3ae04b0ec0a540b924(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationRotate]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8434d2a4bae091a3de3c25c39c54b264dd68389c5f2f0bd89e793e91d96fcc1d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__feded2e2addb6b1c44fba6f544f56b550e5eb42e1f56fb4addd2d81320d0a6e1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__45d683450b54fcbfa38797aa771f7e64fb46ce6bbd0502517a3302fde748439f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__34a8828fde0286b1497198b6c67e9c10d681739088cb76bfa237887b433a94e0(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationRotate]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4c5d111e2638dd38c0991c461209e4cdbba1c34df94e2822e18e6dec1dea7113(
    *,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ee8cd547fd68eba84f28249dda4dec226113e35198186622d5278b8f2968b36b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ff684068c678daed03ac75b29503dd2fdc15cea57e708f5411fa851ef6f6008(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__68b247112806e73c6b6d963e52b3c0c639b71419aa71ba28491c80de4da9e409(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__56e85596f7e84d76bc7400c0141fa04eaf846bb37d412ead76ed7b4275bd8bd7(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3f30b29080e71026386ac9d95a4f26228a83e12d5f2726c977379307122adc30(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7788ae081b27efba21a3d82f3561a3e8eb28e83b560571d805a7b189a39534ab(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationScale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4bce6716b2f7a1749a24becf2aacb0126b64002f77953f011b34d179ddc3634c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__40a6fb834f5c09075f15b622ad68bd934d663a2d34f45b50ca5dbd9c09af7037(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f1f6d516e04b9ef325a6ec24917bb738b8ff049c8cf27aa20a74952b46ba659(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fb5cb6d4bb1d09fcd81749853b3e4e2e7af37512435cd3a8a3d007dc82838987(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f6e5a27d9736ff10105c93a97386efd356e9917d5ae5a8f8cec7f79768374da6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f02b91813bf20d985c864985297c18fbf9bf0c550ada4cf17d7ca6203bd154f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationScale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8f233af17c77380809f46a72db33472df7941801178ed68550cfa67fbe6199f8(
    *,
    x_shear: typing.Optional[builtins.str] = None,
    x_shear_var: typing.Optional[builtins.str] = None,
    y_shear: typing.Optional[builtins.str] = None,
    y_shear_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1b43ce1b2c94fec674d396839d1c75b884e487688d661ed182c5988b7878ebb0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__54b3b4a8d8ab8a54554f05acd3a786df5740b9aab27def784da864ff9d7230f9(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__384b5da1a0941b44168725d8b8d6e8e407278b148491265431c2aa4d9143d255(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1cd8f7626948f86b2d0e62dda74530883e15b899127e478ee4b3c1b535c18d94(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a7d9771bbd011e7e11694229c4330a7cd765c8f29418aff1120bf6f77c15e4f(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__84c0c8f4f8af21896c1177332c824744b52922b7b31ec88514300fb8845a4a6c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationShear]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2dae629f3c636c1f21e949835ef0842122f72a5b78b6ba0f9cc482dd2c45ec86(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__591d6500a6f243814943e65038a6153f8c505a4bbfea4e02de07ff137506b5c8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a8f9469c3164ad5ccf4bd022ffbb34cf2554ef4ff717d23fa875948deeb39e6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6b65fd814981a97eba04e2409338b5519b4773934ef0f997a2b30f93d33f3950(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__46f1c53b7e4c5915520cfe1bbedd35dc05f17e896de5a467f295859de7e12c37(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8868c3caefaa237f3d82e832da377a6907b8c38169150ff27578d3ddf7e8116c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationShear]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a87779201e0aaecf11271a706bc44776e98294a13b72701a2e33ea5206d3d641(
    *,
    fuzz: typing.Optional[builtins.str] = None,
    fuzz_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1261baab9e853e2a67896246965a82df5d854412ca1deb866aa5760858039f70(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4eb9217a57c9420a6916bd08824f08c068e2369220ec6d6d0ed33c37d3d33fff(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c921194ce50195743aefcf041cc84ad0acbe30b471534e7d688a128b71694362(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__68ec4f5b8360dfe405210aff6b23ce0f86a881ba57f86f104a1397234705b0b0(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7ea5bdda167b8a97970d992d455dba06e203634d257902c9ec6d4b2b0d8cbdb4(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__28d8b838f2e355d9f1d034fe3e888ee2d9b6b24fe49c73dfca0ee8343b89de60(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationTrim]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d909e8da0e5e69287c6a645a2af57ce02407aefffe77879ea86c06af6e11ffed(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cbfc51634c65be812adb3010086f5ef8e528fdb1aafc2b695388cea2735ba1ed(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6fd2f06c32a58326ef66aee8115ae7637dcd77420bf65a3a4203989077537e9a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aafdc4c453b9d8327869ca57c08810e7c9d6e050cdb9fce22edd7561423ee3aa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1886630b67e9658d05b6f583af96dc0be8204498c55b0e5e68ea3e565b6dc47b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f0b538ce134221245f8ebd0680bea3fd979a343aad249d779c1893582ce72a08(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationTrim]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d18b55a21fe8f6f97d2a08c4a36d9c116099c0af9b4a4b3da94c179859ab1bff(
    *,
    gain: typing.Optional[builtins.str] = None,
    gain_var: typing.Optional[builtins.str] = None,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
    threshold: typing.Optional[builtins.str] = None,
    threshold_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a4d7f9bd285a93531ba722e6c62d4e50e4cd84697d05126b2d371a53e57db5ce(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__535ad640e071fad5b7feae943943c253879975751c8719d1af5c58ad99760592(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__85dbfba01e9b3ab62681567836b7ebcfb88ef80850eef54241a9d491fc662c9d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bd89a4cb75807a21cf1507856f34ebe46ee98e96c9541d999fcb12590ada0705(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2f74ca0cc89c89c1b0122480dd491f68c2417f83da92e056a509f9ef39e6b23d(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be7f45b573f62618c9aa9beb4b72d9325c7626fc46df9af7e4e245f25b8f0a85(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationUnsharpMask]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__daa875315df324e64023ed3b3cdc9df4c042a4e0c7842b26c705767ccaec1ed6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ee80a8b48d3fd129574d20c6080223941c1fce348a5706670cb44a63f5862eab(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__904ec9b54ca70742aa2259d8e7fdffee7fdbb37b4074c74da113013b82a7025a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b06d1fc8e2e14f0d15dbb3aebe01da60a5b8ca2603270129d5bac7ee6eb602e6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d8235446b0d4556d3e96bd8efc9a38761efae38dff2d0fc62a177cb0100588f5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3f9276cb847927d904650f6675d1ffbff04abeb5b2c210bc858b6c3e427b4666(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1a9b35384c1eae51581f8435dcc6b67e2553b870c0260713ca5f00f1d69092c4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__91a537a483e0e7204e18bf6b167a4422a174eee1593cac67697028a5e1314c48(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImageTransformationUnsharpMask]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__417136cccaec1e4ffdcf1ab5af35cdae6ea2357303510f587b7516e0cdb000ca(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dc44a0922fb233b32f88113a2d01e1de64f8594e5b99a2545f1ab324769fcd44(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageBoxImage, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac078b54969234695cd4aff7310f65ec458e20c608ef783431f6be80e6de6ef2(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageCircleImage, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b83b44713b10fd2ba0da771dce49739cfcf874c2f36d5a71574986d4595d8032(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImage, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f811e1fc7a0f71702651070ffdb1d70729ec87154b7a9c072107aa21ffb1fee3(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImage, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d90f6897671e63d8294b828fab6e3e611104619850674c28f703c470fb4c7c7(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be04ed75847a005538cfb2455785cb52e0687ae684c9423931e73b9f9e5dd806(
    *,
    fill: typing.Optional[builtins.str] = None,
    fill_var: typing.Optional[builtins.str] = None,
    size: typing.Optional[builtins.str] = None,
    size_var: typing.Optional[builtins.str] = None,
    stroke: typing.Optional[builtins.str] = None,
    stroke_size: typing.Optional[builtins.str] = None,
    stroke_size_var: typing.Optional[builtins.str] = None,
    stroke_var: typing.Optional[builtins.str] = None,
    text: typing.Optional[builtins.str] = None,
    text_var: typing.Optional[builtins.str] = None,
    transformation: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    typeface: typing.Optional[builtins.str] = None,
    typeface_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0187c207de92d6fe0db85ee73760ecc557e1dce6fb3f238c49b9b1482441c0de(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fb8369766e5c88f5fc72de617cf6e9e80b020d8712ceb1356e9110e8f3a4eb08(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1ce1c0ed5110629c64b61426450608bf920ab6e5a0ffc3ac594c2d1ace672924(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__17c1c208b956ff16fd44d77534cf903827766de057a4928d616c33784f1472fd(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__68deec2c4d2fb0f0d0c5a78e43120413ca7da1703bde20db1b067ffc8e74e2b5(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__78dd074676283bcb96b0af7c7227a086ff1f733b34bc0ee8649d77520b0901fe(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImage]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9c3a6088c519650871dc625adbc5ca0352220cd78bcfb762222b0af6560b0d6c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b1384b8f2a708b6d2d95dee20bcf04a8991b26802439dcf65aad7d138296da11(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__43d9a3c9c8ce83d5b119910290f754698c9adfd0d33aac8900780e12d4d446fc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b1554b933e34767bb580c89d30fd5d080903a5353a9ce414267d010584ce8e14(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4b58f258885ee088c6057f56e917bb1c5714cc0848dc6016832e21ccf5cb1d0c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0a926f3f5a44eb857cb86b7f1acae0ca83baddaec08bfd4bab675d43bae027fe(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__991562fc40e49171f58a12006b9912ced76a2dcd683f3b2a63ecb7bf7c23e4c1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__92375f171024bb9491eae0dd1fac8228b1d53b6cd6266be8cab16e7472939e18(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__32f8b27081307d6aaa46fb4f49c150c5292355f9e124171f11896784ed0e9eab(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a5a6ebcf6718f939a1de55206ccb9161d7a787ac27339976e27267c66a3ca58d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fa1b8477e5c633521fb77e56ae55889f95a9edf454e59e1517c5e0bd84674d0f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__063c04cc6a4177d78dcf82502e2fcd82fed2eecc04cc94d7fe3be82c30faafc6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__47a3efe47733e8db6cb3435ff8f22bdd7a79cb6edb23fd0000cee59a0f78d2ae(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d0193d14b4155b072e8a2fd92da43cf4c48d4a1ca7da46be0f4843d506792297(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImage]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af961fe8d9c3ed0d239c9012ff885f341f2bb9c3fc5e9605c1407e0a72746c23(
    *,
    append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationAppend, typing.Dict[builtins.str, typing.Any]]]]] = None,
    aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationAspectCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
    chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
    composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
    compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
    contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
    crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationFaceCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationFeatureCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationFitAndFill, typing.Dict[builtins.str, typing.Any]]]]] = None,
    goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
    im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationImQuery, typing.Dict[builtins.str, typing.Any]]]]] = None,
    max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
    opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
    region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationRegionOfInterestCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationRelativeCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationResize, typing.Dict[builtins.str, typing.Any]]]]] = None,
    rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationRotate, typing.Dict[builtins.str, typing.Any]]]]] = None,
    scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationScale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationShear, typing.Dict[builtins.str, typing.Any]]]]] = None,
    trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationTrim, typing.Dict[builtins.str, typing.Any]]]]] = None,
    unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a0d0847848d274f280c2cc45c642879d3cc737c8a9eed5770c0ba5671d206747(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationAppendImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_priority: typing.Optional[builtins.str] = None,
    gravity_priority_var: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    preserve_minor_dimension: typing.Optional[builtins.str] = None,
    preserve_minor_dimension_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5e3fa51de49729fea8b9fa10437bfa485afbdc99409e5d8c5523a150f5e2c1ba(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b6f73432f7c0a375f67cc35e53e324a015924c43fde3ce6963fdce3a6fec7ade(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationAppendImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__05e02bee7bf73e7acac453fc9f27db34822597f531b0128536c57c8e8ebc70b1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__926ea3687ce4327e130b42704c23d1e58cbeeba5a03ccc21c06eca3d00f5890b(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4de8c409f32d4d1b8be6c76ed25a1301bcb0e183310be42571a357b8716f6561(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1374175e27a5ddd06de4af24a5d573d76b8d34d4ffa0c81b72d283ad123eba0e(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6d48a7dc329306bb02f9296b5ff554e769ba249fcc69d41e503a50f55b9aa7eb(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c64b1f55e529172ce7866252b5d6ca4b677e9a420b1e1ed5141bc30128510594(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationAppend]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f96c0f61073d3d57ea4a4c7b2ebd66f8f220c9e16393aafce96034ed63136acf(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f7888066ea66f608d5ef8e7bd645d1c25fe132ab02204fed7710e501da356b91(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab09433e2b6f66bcab5012a7070865aeccc0a28c30d2c99739ad4dc3d690a88a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__916d3467ce0007c1b8a06dc3285afcfea9077eddf4254546cedca45921f2f3f7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a452635e27db21c440184ec6156d251a01fe9191deb282e75174f749c433fe0d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c79ec849de3d8b3cf4a6b44802c42a572c00dc4f7c24e3cbc289412173effe1c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__19a34e258476ca6d5afecb6df47c2ad6621fb0e2d54c0a8dca0e8ac2af0a10ea(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8588fae6ae720e26dc787e242c549bd950a33f549ae304e2bd1266ce5f4d109f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationAppend]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0e262776c5e4e72ed246121bfac713676961f73c05c60a8441479cb8c932f9f8(
    *,
    allow_expansion: typing.Optional[builtins.str] = None,
    allow_expansion_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c734a61fcc010f45391bd29feb8092fba9a8db3c2117879102939c6fce9bb324(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dd775edc13c95a05a2440a6fbe9c2344ec3236acd6d02497bc341a9c37ee5da9(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__139677411c61f7c7e48795495090b5e99e3ec2ed2e69bc7303726ee3abaeefb1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__22478f3831438ab6f3eed62eb8ba12c3b51152b88a257828f0b3e4589948b036(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8460422beba9055e1df10bff847894ea7ecc420f0fc7cfd2bd7b2146bb540e2f(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__80e3bd5223859bdb7c1b8d819b5fef261d77205b4b39918233bb8d33237bdf81(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationAspectCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b29018e962b7eb53426c9a3cbdae465b3d584647978f37cf4384fa4a654d70a2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__29a7646893f55accdd93d2587e90c27eb7fd0784639e511c148b02e6d7208d45(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__13e643529c012f1d88337640f5d963199152ba1b6cf2554a4bbd7070b73fbcf8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__566a0425a7c9ae9c2444a64827992dac094c44a0698959c3dea137bf8a5cdc90(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0c3ce1330e1197601a94cdf79c893e573b1ad219682c00268e3f5fa50fc9e17a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5172148acf86f844e6b4d1ac019898686641ebb872210afd6f2bcb5a897db655(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cc6a277db18c0a95d37bbecb186c8d6a06b837b452ec4b7fd8a5271da0fe2042(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__93c9fe0a349a64a5aa82c5d182d8eb1bb8163ab12de8a2ae3e3409f680e7ea70(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5a9478d7dddc68c5c619d8d79e2d2376f4f91c078db65dc595b7cb8ddf48bcc5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__149bb344a5788096417598182c71cb3c83206c985973a9463e6be6b6e99cbb8a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__65cb0ddc80ec4c136b06cbc38a9f1f15b7ef43c3553660f564eb377ae40ef57c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__75c2b1ef00a2661757e3629700dc7d57da5bc0a3e67a907d17556e5b02e63a3d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationAspectCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e6b26f457b7344a6816cb53be72441f28755964c246ab6ba8965703d266eb3d4(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__82ebfc081b93fdf74632b88fbe98f1d1c2f0426140a880b3231e305a4a321154(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__07846f7d3ccf7a62d8c6d1e0708f7605d866290621a8d76c6cda44d1f5d1a3e9(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7eb380acd1b733789a99e05bb102f2b869a38257152096228b0fb3b8c27b74e6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__75ec3c768ebeb3506fe13eab5ae7d753350edee23c3d1f05c00c5d9b08120fc4(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__41119e8f9fb76fc1eff87e6238cc73c29accc0bb4751fc17f3278b95d3b4dcb1(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ba973b966fb9f93d1c8def15da7ede19fc346b2f9c92fb6b2b13b2173316e0db(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationBackgroundColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9e648ddcdc696067faa47007f205a2cee396501ef24e393595f6c2c243a30ed1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f7d7c6d6bf806e5089f9d29db78f24345dc66affabd919bf0178e8d6d4d11ceb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__342e4d60c09fccf3cc8ad14cb94e0f4dfa8f0a8458d440c413c68eafa0076104(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4beca366d6922d40fe0aa6eed37049bbf8293340aae3e990a493157b56257d8d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationBackgroundColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f8ab06d6746461b09c237665f1de0d460a59749b95cc0a54facdddfd86844ce(
    *,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__32f8911f97883a51cd3ae38d2dbf8dd45f0410b45ae06c8d746efe2df48a484a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f93a0ff0b892b2105b6236f09b2d94f022d50769d88009cfb7e2a23c040c3b15(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__557cde2a8bdbed3f8e5f3d8c26291691081fd516d8000b7ffc0d8f1258a6d280(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__04fd21f27ede0b96d8c51aece06c3fb1477d34d7884932ea5ce6826743dbc9a9(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__854072b1036805763f1cc741b8be8eae0d1131f0dc2baf49aeb362a28f3c9ba5(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__44cc697f73c25a8516c60898052b65c5dacf7448c39540f3c6bfc9a00b98e449(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationBlur]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a80ad53d7ddbaac480e8e9b1a23a80355d1912144d79e53db1173f1fb52008e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1bab105667f325732785a62f7470c555fd660548490f65dc70e53837f43fe5cc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__60ea73c5e7533fb7a9da563965a11170fdaee6a6f4b2fdc5a78b1bece9378d02(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d6f40ad413fb7f0c2444f7060b9136e7c6dd67e5d8abbacf8097d98e32fa51a6(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationBlur]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__32228c75a664fddc6e1f0f1d7f40981e26043a85615d733516db8cf4ea3bf5bd(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_feather: typing.Optional[builtins.str] = None,
    hue_feather_var: typing.Optional[builtins.str] = None,
    hue_tolerance: typing.Optional[builtins.str] = None,
    hue_tolerance_var: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness_feather: typing.Optional[builtins.str] = None,
    lightness_feather_var: typing.Optional[builtins.str] = None,
    lightness_tolerance: typing.Optional[builtins.str] = None,
    lightness_tolerance_var: typing.Optional[builtins.str] = None,
    saturation_feather: typing.Optional[builtins.str] = None,
    saturation_feather_var: typing.Optional[builtins.str] = None,
    saturation_tolerance: typing.Optional[builtins.str] = None,
    saturation_tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f5adde7a0a26f8e386716a31941d51de368a57ad9d1f26343d324bf2e36a0bb(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea820f2714ed649cb8508320696a739a5a5b12b1e7f087a0e5db97131a130e76(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7fcf65a603600a1fd65bd6e81d9017935b1ddeabe210636e9b433791763798ef(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__75bc92ffb844f3ac2cb42cc887c7509b58acd9d1b7dcea2a153bf1999761d44c(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__40f5bbc6e1956287bed4e9ff831994bbb2dd54717e7b643ab5fe9d92687002dc(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eb40f4ded2ae923e76875b4c1f6cada76f1aedafd8ac20add81e356664ed6230(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationChromaKey]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__40cc0c1298502fe8eeda536ff5917552bb831f768397f37f7840a088e1e4ff3b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0baef5d613ee6646f29d8d628a1a511724ba7567690a255ff744b2c7451a230b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ef2e8297fbb3476964cd5189dc597ab93ed350c8d029b917f069d77ef2452bfc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__34bfe2eba4589d3a84ca9ff72b240aee5dc5568d2ae2e4552f5a857fea270f7b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__29011340eb5f4a08b796ea88490275f0c6609c473daa1ea93788cd32fb5b2e3c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c36bf2ec05e8325dc848f2448cac796c1e1e6c0bf276e1818881ac898f6ac781(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8c270dd616397433216a5148e46670c12dcfdbf33e75f291ffe9aa0a1f381811(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9cd7637747ea13adce7451d484999077cd9396e1c6541ce8dc134e2947bd7d88(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8725efa01bd2cb6dc1eae19c1042c7ffb3a89fda1155e81423b18b2ee6c728bc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ef69ff20fd032d6b6ff7d2743e91f31419915ae8e328bc55e3823541cc6d8280(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0a052fc8d5e1d4205625a99571946e774c68735e09f838dd61034507a81bdabb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c9cba9c42b63f9f9e19cbbad86783535bd56ea23ecfde8fc22ed9c32cb618961(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__493a32de63d05279aef2fcef6d8dcb3cb9c6310ba6cae2c516a68eb4ffb1b7a4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__984ebe1b6ec3527c1ebb029462c354f1a7433c876087cf484e64c5e0a668694e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__09d9824912082329c0893d0ad8f76ab078fda306813bdd91faaec4ebb2595190(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2001b23079ecc99b0b1904e70094f09f902df1fdae351b0967b90d5a2b037148(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationChromaKey]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__87eafd7e456348849b94d8548140acce3c53768a5bf585aae9d3fb0271d499d9(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationCompositeImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    placement: typing.Optional[builtins.str] = None,
    placement_var: typing.Optional[builtins.str] = None,
    scale: typing.Optional[builtins.str] = None,
    scale_dimension: typing.Optional[builtins.str] = None,
    scale_dimension_var: typing.Optional[builtins.str] = None,
    scale_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a0d5afc04bae74e3ceaeb41d0f87d38de3602fadafe0a6429c38945b9ba81ddd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__45174bd0ce271593e26bcda11aeb4b27e4f8c1592fab7437b8c97d806ba98ebf(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationCompositeImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__351582479d426e789a2941d35073fa1a70590131c316e6e99e2a39fe2310fc67(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5d5b27b97ecc27774bfffdd9c1170dc8a2cfd6307ab9297cacea7bb2d1f7ddf5(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__84aaf4a0d70b99660e2127534545eaa315ea5ed21bc7e9557e3c80c335c71ebd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f1f7fcf1bcbbc01c3af94e1728b382bdb28fe06d79250ab07076c8ab882be7e0(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d053f0c8b3dc81e933dded72093c7e996c72b86434abbab3f7b2da11e8b8dd99(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7882b8d37e433431fcecae931cc1b0f1b691d54ec34f351ab8659d8efecdcc16(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationComposite]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__77144c8ae1b0bf4a127248590744cd40049d389a36643f3e45b8cfed4c26004f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0bc7d48f1b630c437be817d9f96eb5f93359dfef870b4a1a04ce7e7d50362df7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__28df57f5584f2eb11b9bc9e5898be9ba6caa83f558d05801c9a9c97e247d744e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f57b54c5f5d52037eb9d20066c2f883ff8dd51414c692db9134e615d151037a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__51cc6971e1b311686455d6b0d7749eeda7fb62d837119be8b3a3717a8ba9f449(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__edc850ec8df138e280746101aa30262362a01c8adaa86ce1c1c291bfe4fde085(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ffcf459bd10b88b3cf5c3418bfd886365eb31e0d4489b1c82a52943656632ba3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__244037c88e3cb26fd3ebe57685213ce655d2eb93f5846710ec04f8ae6fe96561(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2630dd70768a952813cafe0d22ec085abcdc8402bf972dabb0f41a3862735f31(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bea6b4efac1c2cd0b3b02e990514cb493e2325921c71a60a105e4c11441a01c0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c3b0887b504ec9965b5421d17dd6fa73ec72e401a4234be6860da01f59bcc2f1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__67df5c16bf6e14a025a6c141db2350ffb2690e25785cba2b0da798a057871fd2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b38de1a126b0ee8d6ea22cb891d2478b0cb538237f506902605a21c4aa4fb3a1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__48acd6bce5cb018a7a19a033552acdfb3ec8f7b6250e9185a3c4d73f58909159(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationComposite]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f58e7bb793b7892e45edf41395a28de33587b4840cb9402d5c6dfb218591d44d(
    *,
    transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__85f61962638685258723f2c9090923bd6ca27d2958f2768087d2e8583a0edb0e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__908db4e92303fb2e8c17f3de91f726d2830ab0fee0df1279de0fade097e0c27d(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c9a8d882fe222bbdd56655cdc65512e9bf52aed2ff31193d20c76ec284b4aa73(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__116caf8ab8241a527e0aeaf37cf38aaeadf5c555d947aef3020d33cf0496292d(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__99473c39680dee1000bc0f2222b252c6a191b858607e12556ffa058e21049ffa(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d06a21ccbe2fbb40db27c013dcbdf0e2acc80e68319de109d948da073273cdc4(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationCompound]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c56680f78e7759af52d677998f4a7130b5195b25a21d693ac7627ac0d08f1d0d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1c3a8f6db57a280f5e1367cb786e8e2b04df9f4f6461f19ab1c89ea7045d607b(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e469aba73614240c32166815f3e5078d528d77c8b1688472aaa4dbb120cb7535(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationCompound]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__92f0edacbdf65acad0eebf197be1bacb6ee55b693195af113c4233381d0d54fe(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f0309413b58d8592480534ab3dc0fefef6f634a2952296466e5c48148701edfb(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eb22d99dcaf540fbd38b314a722f69fe34321ac4b2b54dba93052ed0f67fbe03(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ebc99bcbf8f0f250e2bf12cd15cac494c4f73559366bbcdbcfe8376995c1d276(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0181c82b986e132bfe4cfa4c562c4d5f20b406a4c762f6609ff7afdcbdebfc23(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0375ec9eaae0a10377bb6b5cae63eb4b9d6975ece0b338262d48e12825246f7c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationCompoundTransformations]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a4c561217736b98aa7fa9dd04c4350cebf2dd2a6f22f14fc117947362fd96f74(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ce277e608895e4659a2f61770b5bd81d4f04a9ccaf3c44d5e7225327e2e4168b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationCompoundTransformations]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aec56fd199ea3edfcf2ee200f410e49f8b01e66113b4eb389ecc80f06900a00d(
    *,
    brightness: typing.Optional[builtins.str] = None,
    brightness_var: typing.Optional[builtins.str] = None,
    contrast: typing.Optional[builtins.str] = None,
    contrast_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2e6c9ef0f5062d3c4288e515ab819f492e4a6b3e059a2e5622b5373632396013(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d5eec0514e83234f402c1ed89bc71c61cb3bb1da1dc4fa4df0c5d4a6808d0d25(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ee7cc1e7e74915911ed5a8dee4a8d1baefa771e66596afa91edb6d7a778c1167(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1ca0d4b3cc4177b792402bcbc92fc6e36e9baef2d827cb6b39c867fc3445248d(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9951e1878f88935f815972a80f045f61688c6e4b25f261d22cfda27e53af977b(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fb10c3b3534d49a49cb5f03acb9f1a06fb90fd62c3d882952a69271b5a5cf796(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationContrast]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__125aea9f302a9868686c5db3126fc9f19010cc12a0c46f409dba67760b01e0cd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__327772cb172e0435178912401cd471a96dda994a1bf66c35cdcb2e6520223ef5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cefb3fa4877e701fab64220b7e3ba21c234d6b35eff1b54f522108ee48dbd5ad(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__35dd4dfdf1bbd3314ea9c36a196134704996036ef68c1ebe704fb0e9f88e2329(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__84989965ee1e10ec5d4800ee92574e7d00a6be2bb148bc32940b5ec54e327cb8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cb10b28103ff092b559bd166fc1a4fd5dc8928c727088b69eccea8110e3d5b8b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationContrast]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7306a7655422e5a941f644ed755109b9ab39bbb34f37f35c07ced9c28aeda740(
    *,
    allow_expansion: typing.Optional[builtins.str] = None,
    allow_expansion_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__676cdb77781520505229f62ca0bc410b58f543b5dde72e5ea0bbc1a6ba34a45e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e86600085528da6414b04c22f36f1d17bfa46241c3bb61c02b5e583cec8b5433(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a246f1a3ac688b6657b7d12478dafa89ab06ca085d1407315dd315cdde0890fe(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e99edb9fd866095d0a9f5bd6987fc17c4599173fec2e16ba314d852045977c48(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ca45eb779f973bf4fd90565b99895a0bd0ed01f5499db6c977eca759be57029(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a92ed7274926a6b48601a86838d20754eced8459b30b56265dfa9c677202780d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c5810a7c75186cee186c524b3e6c0793622d51182805d7f1964cac654dcc10eb(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7bc7e8ee60fc57245f3e8ed0d8a33a40609551c02f0a077c32d91e998f089a01(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6954654574a01a01fdc1c467308c12f568db434eab5c7541b8cccfdea1c0b3a4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a2eea20150cf90a48d5a03f07c08fe0427bc3a940e9341f48680837ec9560938(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__414928af59722ce943752b58f5a836f983c52cac94b160ce024a2895d801deca(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3c7480ea76b8ed33a6bcb80bd5f3ef4b4927e08e0d45171cec5244d5e4bdeca1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__67a14fa9b3cd37510241e59f81782f5e1cb31e3cf2aa9b36632bd8ce59e59435(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1da1d6eb748b480ffe0fe4f2384407b5ac3c62cb6732d1c197dfa1b519c2ded5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5a98e5b3656de79ed5c4928594db8a769b1aee42e636ebd5171486ab794c1a9b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__deb6a543e7157efe340a3d61e574bbe142735c63a8d6a1f33805270d8cfe0c4c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__70620b5a13d5167ab7875daf88cb05bc7177dfbe201769b38c5ce7c991984669(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1a27ed65d9dd3621d022c776c7ed290b230b7b8e56a5c8f63eaa95fd58bdf523(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8b2f318452a918d7c120b67995fd6927ea3b447c4e0a861cf81c3364d47cd5f6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__db678e2485db9077b6c0b9654857b8e3d454cad55032f2340e4ce8c81c038b84(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f42ded627018952faacc67a95d2843efe5dde841c78e55df93e40603e39759a1(
    *,
    algorithm: typing.Optional[builtins.str] = None,
    algorithm_var: typing.Optional[builtins.str] = None,
    confidence: typing.Optional[builtins.str] = None,
    confidence_var: typing.Optional[builtins.str] = None,
    fail_gravity: typing.Optional[builtins.str] = None,
    fail_gravity_var: typing.Optional[builtins.str] = None,
    focus: typing.Optional[builtins.str] = None,
    focus_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f1a3ed8f44500b777b2a444b51c48acf0101d4fa56cd4f918920d87771925d70(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__05274f23b69c0ddcc005b9b226f8bca173a6f0ca90174088b79def77122ad37b(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6d64522b2366ad2472165aa93dff791c1d42c6349c52febac5d9ce9f88ae795f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8800727d10f44cc7dbc929919e8e795c5f1024deaa600ed21acd5f5edb036279(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a2c11343468de6f3c1dbc1050834becb611c06fa17fc54ae78d40164aa7103a4(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c53b7811a053ee8c46a11ec62361de54583678c16e8e57a2caba48b0823bc74a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationFaceCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__becaf2ccad2d3ed123616e02e0c21c357ddb375a2f0d4880c74f5d7867d936db(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__025e67bd2b3dcc30d8847ad838341bfed184891644be2a9fd3cf2bd89ed956f1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f760b4f21789ca18071aebbb926a00419f14a655ecdf5c1c900834f2365471f1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4021371044ec805bf040e4625a03eccb2de5e26e83384e4b9fe2ed1f8a51f796(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f384644baa90d826a24808e9be6a20d0bc6dd23314cf4dc86c66ded50c50f4a1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c23f96c75973eb20b29d619413d26f654e527ecc12df7fd703c2210cbd226c24(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c122a3034d232c1bab9003c13d224aeb217999e9ffd6163b3aabb03da53f2a01(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a588196462fe280d1cc6757066c3921252413d72be28055b0026307a311d3881(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__41bea81ea55c197abc07db3c49815b2e59508e433f808c8c8dc3edb3a6b312b5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7aa6a9c46968b8eb440b64b58ba69bb27a25ee6cc1540170801aad94ac746399(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2c352be7c7367b1e933d79a34ef8e0e257582d13e94b94eb8fcc32901fa7a234(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__272de261e3bd1a398d618fff3dcabc762896c13cdfc4aa5411e88eadafdcebc2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d1712e0301fdd2b8fdaa1fb6ad69d5622c82967bab05d97fe5abd7b5da4f32de(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f90b55069507fcd749db7dace6cccafc3d82f70fd715c34d2f80ad91a355671f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3623e3fe412e469822c489fd83e488c8372f68266f4398f84b0c3bf52b82c701(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eb8985d13a961076e231a7f2bf5ddd83039401b95a9efe12bb6fb68f679b0b08(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fc3e7987969c3db6228938a0dc3bea1c1067b5fcdba6c477310574468c1df2a9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2fe6f625424e4566b3abb06fa1a7cd800cbe7c640722a7d745738402385cc912(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7acca0f7e70b00ab094c56edd961cc89e851bb86fd6febbe8eaaa7542e9c5fad(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c15f42baa7fedb8d4331df0e7163216097d22fdba345af218f8a11973f004887(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationFaceCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__de73fa0cafda879bc1543ef6b553fef8b656cc301f977f008afbc35244602698(
    *,
    fail_gravity: typing.Optional[builtins.str] = None,
    fail_gravity_var: typing.Optional[builtins.str] = None,
    feature_radius: typing.Optional[builtins.str] = None,
    feature_radius_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    max_features: typing.Optional[builtins.str] = None,
    max_features_var: typing.Optional[builtins.str] = None,
    min_feature_quality: typing.Optional[builtins.str] = None,
    min_feature_quality_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__37c08887474a972aedb104dbbd64a764f224a2a9e4b31afa8d129f0a808a5968(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a702360bdd8e9fa98465d2adbf320e0b3fd588e772b3f768ce76d31d8c223b7(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2718c3e7dde4c3de22a7a78ebdb02773cf12d33e2ac61589dddff8f27e4633fb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2c8a1b07b2120549ad9de472929982f5d48eb73bc8c261f23ada35bc3e205aff(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a8b3d1c70ad12c808c353ef00218d0ace8cd493fe8936535f09ce0fd05bee43c(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3d9bf7f0fa7e2d795b9ca8927ba1b5fe48410d614edce95e29b305e49eac8ca6(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationFeatureCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2dccb19bf89dca13f22893d4cf6649165791b1aac9f73de1e194ec3444996de6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__54c4862f628f91886030f7ea2249fb82db6aa6c29a80f1590d945f397a751216(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7f54a6c5b438c92ad52fc70adbe0b3a5927c22e316428ebfe65660429050755c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cfff417571048c836ebcce00c06d8925f9d7ac95b7d0dfa56609bc15a462b03b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0a964c666ce602baf4804fe803c42f104f192ec9dea5ce9753243572feaa956c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e8a31e609210f80d2a81f56504a9294279535be537e7fb5660b6a22efc4ee102(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c147276a1c913b6dbc153840474510322ad888cad5a568cc3f8d264ab70f1e01(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ade32497f4be5719bc3ec8b17d72379a7a63a354a52f10840b225418ac590ffc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f1938dccce82ee731933f83e9fe3b8aa6c212c1acf6f73e5869c5d5615464c5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cad0e2d00fa92b5154373836205543bd6fe893c7393c5be9c7648f0d41eddeff(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0b8e1ab8eb2f45275ca2070d175a984c0a488d4a1ebf20ba136b67dbdc687d8b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f56c8f5a8f4fd2880674cf8047e085daf84cdcf4fa81446615d05d6093d6ec59(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3d27b936dde9bf0b0e6864e6bb07fda83ecadd3455bcab6d968cd2fa883d9e43(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9942f025abe1353053d1bd6b6a501c78a9eb5dd4f641ab35cfbafac0dcdc06f4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__72d7637fb8674e5195eb6e09a09b9b28f33657cd9926429ac6d53c36579cc2ab(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb0fcef97b3033f6aa3244db78934353302e7094d2874c903f1808e16b157f1f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d3c3e47d957d313c95dd0585a4783f20022a30b28c2b6617eb7aa1428a9bb1dc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__33a196f14c8973bc4e92eefa3f1e54ed2c70fd6ff31c7e38d9ce019919fc26bd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3f759c757d14d1e4d274d03d061d0c30d456e4f6ad63a08290e5e34c6ea2ed2c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__51c5ee69ad911961a2901c8da40a35d7cf52bceda98ff9a8365e856206ce7dce(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationFeatureCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__927227a4c1b727d342251f8ce3beacc1b725026a09885b1b6615f0abf311d825(
    *,
    fill_transformation: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationFitAndFillFillTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__822c21c5d416f662f1107a66b757f60de8e3e230289cd4006572127fa2099fb8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fcd48529ee23c366ff8b57386581f0880aa1616e2ea2622bd8f7839dc80c110f(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationFitAndFillFillTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8ddf40a1be3b49dcb1183908d499da5c43bffdeaceaf1ba1a8358c9118a02c64(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d057b7e6b041dd01d13cbacea5d1fb4354014991af2f1c44683dbbae7dfb601(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9849c171f2afe77b158bad15f01800b9058b9d7dd94a6b05f29f530a12fa6340(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f4299c7aec03df887965b3c8e206a02ab9e685b5db7eba28b5d25880b47f3c3c(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__43a5bb1d30f4ef0be62855cca2664847d909bad3b00dc41c92a7cceb2a2fbba4(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__558340eb7835085dce9d3fe99c9b276872874fb9cc6d6e032328026304bd7c91(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationFitAndFill]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3c63b9398a4149fd605eeee4fb775bea085151011cfb9d5f47fff98e48578679(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7b8ab72e90dd0fa62a9a6730033542ad1b2465c481a54ccc104e860fb9e2cc2d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9b2a871b0633d1460b3b6758144fec5f8d77f5bb82544a414f13dc03c430158e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7be3c957b3e9a94d62cbfbb7141d7a86f3e1d760416bbea1d8b754c424dc26a7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c4acc9075f5299748d01cfa1dc0a8b1c5e90be505c325c982409950b83f283ad(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f79c65dc9cb8e5ac129673e776f78418ca939655cb4ce0e250a8079a0755d44f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationFitAndFill]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d93f646b369dd9b1b78bddaf136585ef9d12853e5adb0c71e25218242a5e94ae(
    *,
    chaos: typing.Optional[builtins.str] = None,
    chaos_var: typing.Optional[builtins.str] = None,
    density: typing.Optional[builtins.str] = None,
    density_var: typing.Optional[builtins.str] = None,
    power: typing.Optional[builtins.str] = None,
    power_var: typing.Optional[builtins.str] = None,
    seed: typing.Optional[builtins.str] = None,
    seed_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__74cb9181c6210febde50ce2c62171da223edd6bfc515a5bd275715ce0c1f965d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ba912131c4ef807c82251c12184048cebe10044b81a1b4d762e552ae8b35e567(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a844c316bd7f748b48c839722b906756acd5a9b25e6ff04d73bbdebd9ed65ba(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d9b1a10f5a6d6d4c10a2670d3b7da9ea3579fa743a2ff0a1fce182c43950ef46(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__70407caaad908dc2d03de9d7350a0724365eea7be83fe7aab9e30142ba3230cf(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a0e468ed07a7865b10e0347b632dd3e6a8921059a98bc44adf3d0d676b0f643(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationGoop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a0d3b9b838b96fe2534f09432d639a2979b5607e29951c5f992944090d209508(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ee976ce6c7924a69fb22462bc85c0deb7f7ac206c6f648e809db5f97a969fa3e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b83553e1a6aa6c89eec6b173adb07925f2d77cdf6df2a691cac2f9abfb31d48c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f8d5d4140d6e5f5666671b1c00dd9479f4c3f34ce2b3142d2bf53d91a1256b9a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2c0275c53a6db815708d2707ad7c6eb6ab236fb88a3f453f2728f45c0b6cc2a0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ac2310b5b76392bc83c9b7365768809698e9457f133148e79fd0580c0f4b749(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c1d550d895eaf500c37ee2d0a212bf4742b1f7a577e86f45ae073b9be82a209f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__37af77ccca165cd8f5f2fe783e6e0e68f919e274f08f35da104d93cd6f00eb94(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__59de438de4091a225617df6bdb57673a76d9f4d1a4da1e28f551b0dbbf56cc4d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fd2039efb9b9dedc4a8653142f41c8fd4605aed307975e0545854564b0a98a15(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationGoop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7baecdda2eb4701e071d50fdd7df9d11a09debdbcb22b349a100a8b51b76fa6b(
    *,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7c8342fc9194536a2d8e8aba1ad0c813406ad8b0ea29b3237d2ad0ef89681d15(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__87e4296f4f5721bef0d9a1240d34080a56cced00f196669d9638677924b7b7ea(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7f6f1b21098b367c0887099ecbe0382c002209263fae569b26982f2648b3d393(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e83fa97a7bfc13f1d31d50b2d524c7a5afd01a5d1328c1c151772568fa9424d9(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3dc2c270c690c6626bece888e481eca4b028f2990f3650a3eb15d14cde605d7f(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5855a417ac44593038202d7b9e1d78f80382d9d9c90865dbac1726a95727f3f3(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationGrayscale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5eff6e9987b2b43c1e38ab55c092b030a8ba643077016ea9406744bf68943410(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8fa037980624ecf6d7754d3195a769bf5df522d23856b71c5ce5e54d1bf779a5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__46bc5ab2982cae57dc6de4b15740ccb1131a2f66a3adc8165e5b174625cb2aea(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4b221e88ce9723deb16b5811e3b20600fdb33fc57d62aae76990a29d47e6dfbe(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationGrayscale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4715566057e85cb02ba45fd95abb0f5e42aa9ac6bd45dfe01ce773dbc59aeb06(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness: typing.Optional[builtins.str] = None,
    lightness_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e7220ed2625fcae33932371dbb2eb4735411dc3d64c47a418c74c2b3d733eaac(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8f3dfeb6510a61ed1659037b232e4607985b3b6d52e98040562fba5483de3a8f(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ca9f72ca12e7e2dc13baaa57f4bce6a5cf0f9433f301a2d33c4654859188021b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2984a184a480a3db9eca167ec59726f3e05507d4e814e6791247852897b24a4c(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a15560f007cbc96a1fa0cffdec397d5002bcb4d9c074cbafba75f8771b6c1021(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0a155cdc51571ec35ba69c63e549d1804b6a65e450c13f96070d43ab43895949(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationHsl]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e819d4028aeb8b29f7e24546132ebf84e95216198894eb172a69aff647c6ec22(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__21e0c590654202d18f744b0411738056359f85eae23a3fbc0026b088911dbf7a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3357c730b26b48fbc186ffa1c7efee7ba1544deb97dd2706a867a9954fc2a23a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2f6015069dd3fec29c209eff9a570d0cd7f863715d0c06adff172a266704a993(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ca5ebca46db34d38620559d3669a7dbf16a8d51fa4ab6b33ac06af44d65eabef(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cf8dee90f16383ab9f31d09d5e0b17d7a22f232278ee22947db8515eb8a732cc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b14caf1383a0a01791acec8a14c99e0aa93089111367c9b00a0f300640b4aadc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5243235fe41a5d403b8f07baf0c7aad6f2fdca94d51f0c240f3913134819d776(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationHsl]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__51c707527795fbf1af32c140e85d21a4e14c1107cbdc2270a4c049de8dbadcfb(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    saturation: typing.Optional[builtins.str] = None,
    saturation_var: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ce2ce3ed9cd7e339d88d7d48d8c9b6a68b125b80e14910206435c1cbaf905070(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f22d0d3848ea5a4a5a13006e093db0f0d81a98a9a28ff021d1056f0807832a1(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dfcabbf62548b053709ad16ce9853bcc41503d1ed78db65b3e3c476803f0a301(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e105adaaa7a5e7fd01b918a58b653e6a6928b407458de49be831bd690ac45a8c(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ec2411707256e5a32c0cc1afa24659876c61a8d4334280c012d7f411974d0c7(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__39b74aad3d4e82f543e18c4d6fd8de99dd27b573fc9ecf84427eb98c57e72d45(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationHsv]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d1e0849d5a9b7363693846b34899db0156d12e218122124b70e66d7e57875c44(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__11064446f853bc53e1db3dc8585502200925d6dce5c9a36cde7db8945cbd5d35(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea3bdc8c76e3263c7e359d6410ddc533b83eb60fa6751ba0e0809a6f1f551960(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2edf1bdc57c32dcc33fa87548898973df008fae7dc4748456af7e7f372b7edde(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__00e8fd0f11be083f91eae99a2c98030f3171bef73f09f020f6afbb3881c7d586(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5763f0246be36bd1900ae1d7c790626b4a058fdc8f085c3c7a23ce643c1b2329(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eecf07b83c33d99431db165966fe244241193510fbd4afa7bafb159ef1058e9d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af22f17882a68a3b0423c5fb278e977e0b5c7dbb2f79e354a25bf68b566aff66(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationHsv]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a21d229e345c9f8ffff2c173ae819640d8d898e2fb376931a216efb21b33d14(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfDimensionDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    dimension: typing.Optional[builtins.str] = None,
    dimension_var: typing.Optional[builtins.str] = None,
    equal: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfDimensionEqual, typing.Dict[builtins.str, typing.Any]]] = None,
    greater_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfDimensionGreaterThan, typing.Dict[builtins.str, typing.Any]]] = None,
    less_than: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfDimensionLessThan, typing.Dict[builtins.str, typing.Any]]] = None,
    value: typing.Optional[builtins.str] = None,
    value_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2080e987dea9fd0460cc35d24d7f3d07a483d65af82f51f64eace3ddd7032444(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8367561f9ea9c4f39f26e22e310fb604b6aab4567d204a3ec3669b61ef85e7d9(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfDimensionDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__78c95e8ccb5dc0e72d0807a22ac54c3031b8c52898278c2e66c8361ae0e56a6e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__24990b141dc4ef4418adec49e1ca0f8d902dc17fa24673eeb5418199dec3322b(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfDimensionEqual],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8456a30da9ec32c671d5da29602637df88dcc097cd905cd6a9c6be6c387f2bba(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e0fe1feeea0af17af3e9c942c3e4a47526c8b53c13d1e985cb5597b898fabc4e(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfDimensionGreaterThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__33f8e25bddad2fc4447d2c089620f715e0fc29b2179709fb8d6596f420256e25(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__41c9ebe1d708173e3aac81ce83a470f422ab245e907eb344b72fe1ffc223d76f(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfDimensionLessThan],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7983afa4d789271af3e6fe4737491b8dff760fbcf4891fd58e770b6760fef0b1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3fa1b63623d91dc2185e6a9d4c3a6032620f41bc94dac51d36096057b145fb12(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eb54dd6e4243090aedd738bc153b5dc9dd8f367c75c52582c26e8ea5d533fde5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b630f497d5a3723205f179317c27a488616e18a60c52c774053681fa015dd408(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__59b51978817acc371443cceca391d572db28fb3dd6583955a703d75ea906bc6c(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6ced45dee025f2ef3ae7308f033777a0d04195c02faab903dd6fd7cfdda3c0ef(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfDimension]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c3a25c5b9a522e336b8fe32c9ae022fb557865a0fa94a9466b347638ad745a78(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2853d67b5dc0989d8dc545cf2f48e7b12fc657e4fa42f0c004e32d793e0da50c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__549f4420367be2df316b4ab1f04dd369458a4a195044d6d07e7cf7ec7747cdca(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__33df4e90c2f630ae7b9033854015be4a5d3a4ef1f5382eb08c0cab3c81b8d0e3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b7d196244b2ad10dcd4e417b13bfaccc3f398d6b9c44d3b1f033ec5b6af65907(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__33375a2b56a2f0b4d6573cf9bf365b139c477b3aaf95debea24d0922d29228dd(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfDimension]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6322ce0baa2c73a410c37160886d12430bf6a9b20f4293e205919b314978f08b(
    *,
    default: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfOrientationDefault, typing.Dict[builtins.str, typing.Any]]] = None,
    landscape: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfOrientationLandscape, typing.Dict[builtins.str, typing.Any]]] = None,
    portrait: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfOrientationPortrait, typing.Dict[builtins.str, typing.Any]]] = None,
    square: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfOrientationSquare, typing.Dict[builtins.str, typing.Any]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6fb85c0ea4883ef4bf5d6ff6b456bd7fbba436bd2c70caad046808ad4b7a1b6e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c2ba94fbeb61121d96ce65b7f4fbe1a666ec1b7e4369e8ae14f6cc3090cefaf9(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfOrientationDefault],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f2c791da24c0aedc6780d78ad322e089622398b95325cd8220b4d168f71db889(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4be8aa8051a603379766205907da5a20ff4247e1c1a62c549a626d9d311474af(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfOrientationLandscape],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__05bad461e01dde452bdfa73375cefbd6aebd42eb90c7f66588bf4ccaddae9983(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__871c3a83bbe4a27815a699c13299feb17976a5408ea2c347fd1faca4b6f6e18a(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__350e7f266b76c29b53f05662ef49eb56113d24a3c097aa7dd11ad5aea7333297(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f7abe2a11bc6bfbec5cf583c56431c56520f1c04049e0f48e25100e782943b3(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5b1ed857437d2595a4725315599a5335decccc6547e71b500c2112de5379a452(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eae7df739a81c49462fe88451c58a3047ca6b343a7a7e7fe14a11a6ebbe47aa4(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfOrientation]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8bb032a1918c42664648b541578415902b647ccdab62e7da9826fe48abeb07bf(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__35caeddf56ea16ef3941351900fb526786bf3a3adb7aa826bd210be223d94fab(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfOrientation]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a596a5fc8ccd96d8b7b0042d992ffadc55a22f7168b6d9fb4e0d2b32d0d75f48(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1836f964125927d9703db0dc3604a71331da050e13446f6aa203093b9856ae58(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfOrientationPortrait],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c73b9ff939e3e54233176e917065adc2cd91dac507e195d3b82c65102c211136(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d9991f629efbd2a4a4a44d925b4ae6765b97042be1b0642ec7e4d33738a940f5(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfOrientationSquare],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f6fb8e6c06ba262bffeb98438107d4227a324d1aab5d85869b8827bb3d97d77c(
    *,
    allowed_transformations: typing.Sequence[builtins.str],
    query_var: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__56e5d09318b1d7ae65ebef197116e9a10b607488a3bb9a36210e4e6f11e06c35(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ac69af078c27965327565ee73657aea325182d6016dd3113f3093d89b42117c(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4e740d2f3ee92c590978b4ba04f9789ab2bedff31412ba0622fa609a5955287d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__28b7d516ec68a019e2e13968e88c3448cb440540352f8b122c49f06ffd77badd(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7ddb664e0e75328a82dfced167ad4d84f266c7be0b197d6909c0eb138009e4d4(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ba8af3cb29cc633dfd3180fdf6d6d508878ebd3a124b93e2e86197832ce27e7a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationImQuery]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8e06114aee05107e62b043ce8f5499f0b25edbee2d8e3d5efd587dafe9f6f70d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd4627fab9cd7336c9f759865a27056cc053a58c236b2f51af16b4e11f5af3fd(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__746f5407964b6e3795f6d0b1f59aaee99a5799efdf8f587002b9fbdac30d53ca(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d25d6406c4aa17915212ea70e96e8863facce9791d25acfcbdfd1e02ce80a3b4(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationImQuery]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__42c1106337d32df51259eee88c64935d03f0892032978fcac75b54c02380c8e6(
    *,
    colors: typing.Optional[builtins.str] = None,
    colors_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__519392fdf4715f34c792628ebccddcf6a9a170d1e4103435906e7494a804eafd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b406a3b8387eedf11e6cb46393ab7a0bb09eec8ecb6d00df657432c588a8b962(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2be6bd04f879103685c9a50c0b7b5462fbc8f04cf63b2526864367eeb09dd902(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__345504e174d05c71d8c57ed113c9544eb775b722a35ffe35534ac8d6535c8f8e(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1314cfbde9d76d08a3c3c84fa6f7284dc285d048c6d8feebafd68be7e95c92c2(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d8e0ca5c595f5be8af72b25cc059c09a1a5aca8c75ea1eb01942ebdbdb3385f3(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationMaxColors]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be5ce23ef9a528a18cdf0802da5a3430c118d5e7040955196de634e4f16deaa9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__65d76f5dcf2b341b552ed188084427208a61414fe1e6ffcc93a7c90b66405558(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__42793e81364534b58e1172c7fcb5e5d4e1270fda683b5a059ac023447fedf125(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7c3c34ccace52dda0bdea2d5ffdd0a6e3577b749933081e375df9e9bf9c7abca(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationMaxColors]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7ba49fe06e24a604be9b757d5a2c51d4459c3a0d890ed6e65557652a45e45bc7(
    *,
    horizontal: typing.Optional[builtins.str] = None,
    horizontal_var: typing.Optional[builtins.str] = None,
    vertical: typing.Optional[builtins.str] = None,
    vertical_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d678c9a402a03a08c2965fd68d1e0cc6c02eb18ae8e1906dd83f02e293926407(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cafb2ba587f8a6146478435b838592d8b448ce30383d87119f592612ae823888(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ed020364a60a701465e53c0a099bf729c1ed2a3ba35fed275b003093753bd842(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__32cf43fae02d97e53d00b5ea6bab05b361aaadecf0ff6486dcbf116ca9c9d1bc(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__71da8ceda65afb8bbc9d677dc3ca264d9e21b87bf3e83fdb6e2fd472f9135a81(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c136ed9558f6f70c954917877a2834346b380d0a2bad3533d6c89c81e36fd53e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationMirror]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__20ec2bb492b953e221221fa3c21538dc9bc08f0e853c82667ba6d498648998a4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__522381e6d27f1517e9f070fb39f233216cfd6fa609b0fde52e00c8fde995b3a9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__21e810159ffc8c6110b3857d82fbc21f3f8cebb1734c29bc3af0c3a03705545c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__effe3fe6d85bf1000afb95799b1b6595c2f63ecf92c76912ad680963b6f7817d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__58dfb07e7b8ea60cc42967cbc6128752d787d3a7523055f072f1de816948787d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f23adcea327bb9ab2334001491861c5a074a824d4e74aaca1c3d2eef4f6c1692(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationMirror]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f82d48740b6e438d81c2f82169625ff00147b78f7758ca0a739253aa7bff239(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b0154aa8f31f862289388be6133a5f595f06a752a51671995ff6fdb7c9da0645(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a0da851d5b40e35e5e7fc20708493485c4712858c78446145720096f4925ab15(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__732c7713c0136934151d40ad4146dd5f48fd889e7802ad7a813ea24bccd73b2c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__16666ecdc6602bd014d553c0e38ca98e202ea189452147acdc066b0da81a2c8e(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b4e8f89db29c561d23ab0f0fb7a7cb46b677342681bc7652ffcfcc57c913cf05(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ea3a82c13057e53f8bcad3c74bca582bc0bf9fc6911c66578a03aa858cf4bcd(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationMonoHue]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__021c7dff10da7fb96423bdf4d376584061508d2eedfaab86dc735dd0e1274aa0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__89e55f47221452284750e946dea4d574ff0456339d787facc59428b1664f61de(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__57cb33ce7b6a49270671a0f711cb23ea6ec78a92ffd88723aac7705e16f23a31(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a37eba3f8c4b41aa06fae7acd2dce2f184061704cfb21ef191648b9dd5d5450(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationMonoHue]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__015f41966032178dacc1ebd6e7b6155cfe5f6fb40c818651fa8e50b92f8b9f96(
    *,
    opacity: typing.Optional[builtins.str] = None,
    opacity_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c08d4369f7f637dfc8a595bd332f7e9ed0e61a6b0b82fcfd913adbcdbbccb2ad(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8838f16dfe46626dff7c749528fd56fc74301d7a272ddb8fc2f38ec557c93c27(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__11c03ed25b47cd81e602936b1207c7c983f64693e2b98dab3af76932a4dd6eb5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__463429f2f6600cfed9b4a632901c904f5b02225a5f7d08f9a7d273cd3f2f0911(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d5f519670d1936b6267ce67a3168b356cefe735d42faf68cbcb4539957ead232(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__68e652b36ccf5042ffb9080ea0d197a1e0a03fee414a3df0366ba7a13bb89cbd(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationOpacity]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6b564807e28227ac04f01ec159ffafa4d29a3e37011c65eb27b508b4cfd83f31(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac7c8ba7ed6ee17f06d38741df296a217d9dc33fafa3a64d189824e2bf3679eb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f6bdda2ee64a2576d3314ccd45adc5d4970b971e289086c102099e7ad0b31f17(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__788a3efa9b9954665c289a89d69a60394175dfe967b480ea61a61f920ae93c48(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationOpacity]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__82695e73580de9eb9d4623b8bdae25283e81d71fdaed75673c840f86f74c7792(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d308fd93a6920d8bff163cb7e55e9359aa9692f46ef1cfc322ac04296a56bb4(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationAppend, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ccf1f1774bf53dfda01fcaedbc47311c281f3338e4bfc5f19790e9221763407(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationAspectCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__025904b17d0dae399dd7db7b2fabb63bc53db4c81b8e818c50b5201e6de0357e(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationBackgroundColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4cb96cb4a1767462ef34619088382ea9a39932811838fbc95bd3cbe48cbca6d9(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationBlur, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b971357b06cb7d0b264ccaefdca9f67057e0853e5707eaa8b1526e22dcacdc96(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationChromaKey, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3f1a517b16d93d6f0f6e512dcd2c8fdc09b8b6fb7be7fde6b424955f1332589d(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationComposite, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8832bf5be76d8de5a49b7bb7afcc8d6be2507145752a3bc4ef3c279909c47552(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationCompound, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__46fd389f1696feeb8ad74738d8e99b11ad4beedc64779f3610b407e6ce036821(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationContrast, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b8463bc7367b953b5c3e721114b201388ad17ef02f4e5224fce0698e96c311dc(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bcb72db0e9a5b52adcdb97e29a08384abf1cdb1996133be775f2b53e990cb247(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationFaceCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e9db29472de6eaa7af43adcaa895be9caa0910d139c482e0861189e89ee3cf99(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationFeatureCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__064ea2173b36233a61534f795390f0928e90b80e8804ddb967901d2466b1d28d(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationFitAndFill, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__744ad14e72374e5554cc78bf27fe5c035c1760284a14f36cd327621c74a2591a(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationGoop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4fa174d4810550fb1f67cdb69aa54f95d8e19d29108cbe12e25b018a168cb9dd(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationGrayscale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__43c04483d9f8cc306132ca70589f50ed0ebbfaba6535533c23006221220f2676(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationHsl, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4124fd33b4cea87aa3a4f41bdcca3c58b8679c6778607f0a6009d4de89d6dc77(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationHsv, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__17edd892139617f98f788fe25c7b9c1582d906f97c3b962dc74ab4346b25574a(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfDimension, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__054e2057b3e01ca40bdeece07744f8978dfab023ba19e65aac9b973abfe75df7(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationIfOrientation, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dc1f124fda43d33cc1d49a1d812bdd6496f6759df9bb3c850e4aa643966bbdda(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationImQuery, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4d0c8d031224c104310cdded563035f3495167e6fdd5b2d7e417e9fbc98423a3(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationMaxColors, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e2442e5c6943a20a6fb70989706129374b04b9a02ab1b311a4b0e908ebb63e1(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationMirror, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f8044cbc26784cf499e1b1f1b2f8a824ff191aaac70d3ae407574ba164fe0c5(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationMonoHue, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4690947be38db44510198c04f58f85e5468d7c2062c3871a83b54b5839d81bd1(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationOpacity, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a904b318d215bf8834248a12ddd472a6bdf248ec1e1021498f753ac1c684030e(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationRegionOfInterestCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be541c7d4ae12aced41e1c848db741fdc4812a6213a29d87745af28cc3f9bf3d(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationRelativeCrop, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f0d673b760294c0e6874800f1607c38a5ffe8097cdc610ef13102497117f5b74(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationRemoveColor, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bf69b606d8d5224ce0bc455883ee465323e62eb084a3e4c89e368baba249d795(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationResize, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__393bb9669dddb28ce719590aee8b840e8ff2b3cdc56d54d6944475862c17b835(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationRotate, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bab25a3dbf5822abc0cbadb51bffd2d2e17a1f4c10da5686abed43a39777e00f(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationScale, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8886126145b3cdb5a883c3570955b5506413ff06cf753354fe3106c573f8baef(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationShear, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__89e090e92d7272ca105d3747d39815369aa51331fc40cadd1340467427c462a9(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationTrim, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f45fea574e488c2aafcfe0e2de3b73498e896fb5d14ccdabcad2ed7cb5337967(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationUnsharpMask, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1e553c5931f5b3f0c59f269eaed5647559aba36c29d9972d08ee03e84c63fe56(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f126b74d404a46cc5a3db36b82bb5f35765adf5160d98fdfbf288a9800ad3f0b(
    *,
    region_of_interest: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationRegionOfInterestCropRegionOfInterest, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    style: typing.Optional[builtins.str] = None,
    style_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e2ab9b1e9ef80539985e741b1e636bedd1f40fe4d7e8bf5ef6a0dee28cf92cee(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__02950378e2d42307bdf0323e61b435c7ce6e66f1d6c290505ab232266a10af5f(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__991004422550dea7f9a7a4614caa1da9a8b7593909fd1618d3f3dc642352ee51(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c5a57db6ef1cd531252e43a1d0d164a7a9844841e026a22def28917d51b6d7b4(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b424a034e7c30cf433d4e9005af35c9a4e9f07d1f4ee0c28b16d865b917125b2(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4f1f7961c4e494eaf4e1ed6524e0ed286081971424b7ebbe9324f1e340aff51e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationRegionOfInterestCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__198266631d338f9515c5efcbcbd83d763f2540de42248debf87dc463454a8a9e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__50b4b474553eed98207b4408208be5879f27deccf3a52900906bcc1d476c4134(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__936ae7c0b361ae1401f6a0488bd6e4ea03594650d4be910e0aafc6c0756aca71(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1865b7206d882452dd66dfd60a829a3d08bb5a5c712bf5b8757706de3e32c62a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f027a33e601f317e8c2015d618f8e599bc38041c2f6b2fb825c9d242803fc6d1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__149f32913a657d9f8768c86e3c030083ad2911c53c620928e78f04208de5d831(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cf604ae238f05fe6ffb0bbf828cffd9567a9c029a81b84832376e12f72b9d6aa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ff716a30c02524479186e17ec95b14e2160933e9edfc84a3917c3a2f09427c3c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5a5237431952d2029c5a9fa9787c7eb68fa3e791dc303e5d39c93594389004d0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__32cee28ce55c5cbd20a69d13f224e23b2c04a5c4cdf3eef9b251130f81f84ce8(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationRegionOfInterestCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__383be52998d64487cb5dc71f1365708dcacbed04e45255a039c550d843306b18(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9142dbfcd89398b85ebf3256c52698a2128c797c18c35ac7e1e728bf8b5199eb(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationRegionOfInterestCropRegionOfInterest],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c9976949944abc80ff33e849ad5ad65471c186ee3705bd7000627a5b37b2e728(
    *,
    east: typing.Optional[builtins.str] = None,
    east_var: typing.Optional[builtins.str] = None,
    north: typing.Optional[builtins.str] = None,
    north_var: typing.Optional[builtins.str] = None,
    south: typing.Optional[builtins.str] = None,
    south_var: typing.Optional[builtins.str] = None,
    west: typing.Optional[builtins.str] = None,
    west_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__308244057da3cfeff3373575a367d09899c6b80b822644a4a3a76f815b153fbd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4262cac6e9304c75ee1f0b3327c7ae8e46cfb07505a8a102908ed262001b6dbd(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cc0c6735145e29d1d3d0fffc1ace213e3354c6c91021c3ee21201a50ce846c7e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__759fdb35951d542c72f79cd240240f66528796c27256b2c2fe0247c645dcd2d4(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0c8575e8d63f639cd0c799381b90158332d9e35ab935b0649abbc58b4c935798(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fb0b067c4c51f3904bc187904207cbda32a121682a522f206406b7e943e99d14(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationRelativeCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dada95568ab3be23ac8a5ac0fef6635d4a91654c68174fecdbf11948ec59a376(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b2ee4aabf2fdfaa86fb3debe59cb57bc010031de40ec0105c3ef188f36525568(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e3cf10c55b0389e0dad814db66d1e3ccceedf3099f6ee8d2c15ccf6fd6d29f5e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__24a482008734d11c7bb6d7adc8e1ba5cd2fc17ebeb6ca92354eec041c29dbbc1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b0eadb6d3a8d35a25156b30eb69b3b3b9a4335f8db684a761daaa11534de0e39(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8df2828020ab1c646155832e88780f91e276e063a404ce2e2412b82c1ae79853(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9766c461724bb9e3a251adf427d4fbd1eab53de6d5024583dce312777fb6e275(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d0cffd8a93973b7546588e92ee18453f4eb0b8d4813f62352d88bb6e8c365e87(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c38891fbfe50518289cfe7e5c8dd9d581e6dfbd3c4d2ff04240f5cb8beb7c7ec(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7879b25baf5cfc8a6b3c6ef3ffd5f14081fa750b8048e9e88831457e68c815c8(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationRelativeCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d6aa14027c9239c1a32d6c28c9a0adf6f89cd0e8d18fc2a8243c5a097684bd8c(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
    feather: typing.Optional[builtins.str] = None,
    feather_var: typing.Optional[builtins.str] = None,
    tolerance: typing.Optional[builtins.str] = None,
    tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__840926818164a5a32cbcad1240960038b3180e599006e253ae0fcbf8cbbede40(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac771d2d4242a5feba968eaa1aa17d516398add6cd5fe901089f50ea2056e3c0(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b5672e76a860fa2bbca480d6a6ca469baf2e2399cabe94d739dbe9df999aaeb0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f1ab34594d1b1ff8b045905c3c9ed241c1d861d00b1c231fb180f2b9514edf81(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fa5f30b0e04f2439277d5816568b5439ad624226d4dc813a7e556f25dfd813c6(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9379b631897be1b5b02613639a1d25620abd4a4a01b5fa44e0db09a48f19c2f8(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationRemoveColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e8f336605ee0546ab38c677fb4de3bc3a91ddbd983f047378042ffafcc933068(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__58110853affb9e112f298581d42f3cb964b8e8b0d093dde0a05cc7d9e9634fbe(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ecf7b8d0f8cc4f882e86fd9258a042f0931fc1030730b8615edb7ebb2bcc0e58(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3572f69b4e88e638100383836287861431de303a06e39bb2be9f67916050e774(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d406ff9061c10da3342a1d67c697667434c8b6a1e2364f7c179436ad5f890f58(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__51f56cfb1f0e9cd4e9b10139487f6cab3825b955065bc9ee00fd9c6c52a0ce99(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f4208e392029df00bc89949bea4acb8b19fd4539371ed41c530b3313c8549754(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2b522411c176aadbddaf3d56da02199800989e440355d926bd64ffa8610ff5f8(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationRemoveColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0cd38db3f6b702538ec5b5977d17ede2b9e2cd6382dc74d14a2d2355a545c002(
    *,
    aspect: typing.Optional[builtins.str] = None,
    aspect_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    type: typing.Optional[builtins.str] = None,
    type_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7b1334f5bbcf35c1c6930b985b504456ad078dfba1969b24f61ef38e0f7b51b9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f99b60c007e6ac800bb501cf6fa80a802a234a99a834b05f8059750435964c8(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ef180cb7b1fc282f5da4d6ecb54976e108db0d4ffc936ba3b7c6593dca3ff59b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__48de6f168c18058196e07184f3b1c4d24e3721fb1510d96c43b3d8b765a93c62(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c78f393eadf6ebb91952c4c0b52575ef6a79ded27d866f42049559dc4c01f5bc(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2383b8d09b05c7dffd859610e5b2ff7228aa53014666b12d0a6ac6e7dcfe4bd6(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationResize]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6ebacf6d72e188506d79ad10ddb02cc0d83256885a4cee985ae87dc77d675c5e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__39f46c9c6a8868a20f96463841ef3ae9b58e60e4a7dd162ce86fec6e2256f290(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c061a85ed834ebb35bc7968c73cd37c05f50a1c950b648d6507d4a00b57f0f20(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f1341fce133b420def97118ce865433a6e54f1bb49cfe759e4c55e9c9b3fca9d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__07b1ffea8df90fea690f407dfd3ea9ba066ea63d5c83f1e9149b65754a50aa7a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__983393fc92d618f0e67580688bb77fd26232bc402d589846bd016ca6a6eb2c87(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cfe68a599f6f6773ac4bdf244c9bea67612d807a06ba5077eec5b1a020de188f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__12b36ea0c8233ece7872aefdc6f94fbadb0f277c7a5f53f1b5d1c536865e59ce(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__49a0d98b634a39052bc6576472bd7a2a2a0ef7621d2853aecd7513d4ed37f35d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2289f85839d8985661bb7f2abe83331bc3d2230ad44d04814ad638e680c8a40d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationResize]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__39e995e3a19609df823a515538c387319da6c4b1ee8b56f3f8e7387c44d86962(
    *,
    degrees: typing.Optional[builtins.str] = None,
    degrees_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5e6dbd6fc3cc924c6904254cc6a7ed2cac695cb62037aad4f34df9f5d28fa494(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f655d2db4afa1ad8e0aa7e13516dc92c18b561bc68dee37136279251e48a4f8(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__94f00c45df41e64ee70b1377719dbbe4ee2279509083ed705d2e8ed3f2bde578(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7e407f287e29d12fb3b78ecec9b237315e18853d8372593b8af87e810495ca32(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ed15964acfaf4bc4d3327d66eda14ec9ab0fa07b068b5ef985378e7a0bd067d8(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3fb933d4c99de4cd1d93b9ca4f18f703fac062233e1c42cd4cfa9bfae42f41dc(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationRotate]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d70065a0866589ab3715ee7cb1c279433f2ac080fcaf7ea951c0199b6768e4d9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2fc36151bcf92073d5713b9f4f07ea061c5067d476ec121e354ae824971670c9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fb304e5d381ae7ff07f2a5643f37a329d326c1eb54524daecfdef8dc6bf5d8e1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cb6ed81629b0c022cf24a8c0681adcd9998684c17d670895d567762c2486266b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationRotate]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a56d359a9a606d9b5cd1c50864612e86a12176776aa11590e7f86ac12d7eb747(
    *,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac29048eff3da4a24365b5e2bfaafbce5a7e6c38a394f3020023779d9cc117ba(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a2823b8deb8c5416a5b9325f4210ef2557110efbe288656c6a82f72f7fdacb19(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bd90a6a334f02e60bbab37f703b3414f8edabfaacd997a6621e2b801bdf5fc3f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e965dbd85d80aad9d59f4684a284d6032c6931f31b921acde51b955bfd200864(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4873ce96ee3f195eaabc8542ed13bf7c1d5766d853f415c5ec11f3d2f8a939c9(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b60f71dda669647d124610e8818a0ac6f96c3cc191358437220752b025495478(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationScale]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__52c1d9d2b06ec53ff2dc2680c101260ac3642e6dc3e0c963f8312319c7853870(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb900bfbacf16cfa7c687203c4c33eb9cffac4fc50abc05ddc3cab2a405d4594(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af3455fc0a8e8d3517d91827c57e8f42a93808ce79c9d0fc2020fd7a7a385551(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__93aaf8cd8f8f7a04063737b253269187cb4fa7ea2e32073406145113c972f105(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bd7bc44d82f0dd2f07bbdb75e220505a7cb56296c15433d70d304b1594d45ddb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__82b97e4fdf3d20c6454c866e1b7c9b9eca1e4e40b0278a6a732b1d3a0e44a7d2(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationScale]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c6c65de18e8c6e6708890ea50edeb3fa39eff224ce37727c3d2af9d625e5a709(
    *,
    x_shear: typing.Optional[builtins.str] = None,
    x_shear_var: typing.Optional[builtins.str] = None,
    y_shear: typing.Optional[builtins.str] = None,
    y_shear_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2228cb77059b356a8ada49bcb9eddddd1e02c5a3e13c7b0ee39590bb147a6cfa(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7c03adbeba60f833360fc0e9d4f26cd0604801abf413a2533a0cd2fd076d36c7(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__310f3e44705d6502e4bb0d4c1f10bf7764131edd64b3bb8bb5871d418cba2269(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4075141bd50453a42dba54a44a60bbde5be1f353057203e047979fd6a671bfe9(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b14f01bba91434cdd5636c16e7e1970572a7c695797696c0ec696bd5fcae8f79(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3f77d69813ba469601c3e4294e4aadad61680e5f44b78e1af6edec5207f53645(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationShear]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea773f31af5e404887540370d6aeb66aa9db00277e96db17f05799016d970131(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0aeec3932547ca1167ce9a56244f17c073987fa347cbeeeae420db56abed4345(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b60467f2008bfbe5050c65596f77658b54077593b714fb0a87798bdaa52a7b86(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c7b59ac6c822cf159cfee3c387c8b0ce14b295c2a159e44bdc7060e37580133c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__569014d90187dc1cd3a8124ed88f5f3047d9187f4201c7dbb2a73d8ce484ad2c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__21c47ffe9043095f9bf598788f99ac88b68e48ed5f60896915fdcf97331f901b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationShear]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8ee8d2e1f35a2b0c867b187fb2332f05b615b3e6bf1b1a69f4c1525535d3cca3(
    *,
    fuzz: typing.Optional[builtins.str] = None,
    fuzz_var: typing.Optional[builtins.str] = None,
    padding: typing.Optional[builtins.str] = None,
    padding_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4353ba51e9410b747091c8a00cb51078feb443c7c6c51c7ebba8ea4c5ec4450c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dd6e4f9881167f5aad6e28aa17afbcfff52aa75193183985979df7b92a2c50be(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a40d6367e3ecbae996d2c411e901fd6d434e61527d1f37029e5ce5710b4692a7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ea8e490da8ad6085e2e657a1a683ca5b5f77a66c95764cf225710ac854c0bd1(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__afdb185a9bb0cfa02e3932c565d5a4bf8adaa01481db2cb367b5b7f17740412e(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b7d6214351103b84e6f1d7fd7e066d43e464bcdfeb7d033a2a43d2b8833c5f56(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationTrim]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ede8f4726cc6460314795d0f8056272fecdf086dc839e065b6f456b18a24f63c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5dbe70788b7564e9b4322f27b09117c08e3999942ff516da99215cf61235dacf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8dc3de6289674008396b533a2aa0505fcd6b7347d174a0edf2529a724633605c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__678c883ddfc3c1da9546b77b2b059f9e3c2b23fe64a74150614b91d88edeafec(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3577f81f1acdab5123627422014eed88f539aa15f3dc14addbdc7a0329ef1333(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__16c748686862ae7e9b3e1e7178c0fb2f22e8e3ab2475ee89b268d4f180925b31(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationTrim]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a1fc87b8cc1cac0dcf2bbfa1fe89bc85ef8d65d8480867b3e647a3caa1ea337c(
    *,
    gain: typing.Optional[builtins.str] = None,
    gain_var: typing.Optional[builtins.str] = None,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
    threshold: typing.Optional[builtins.str] = None,
    threshold_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2aac4888410b789603396ae0d616d4940c8763b7932b9653765412c0bc15682b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b108b54ab7fe852497a860b33a92e063d6260ae1b26c4abdcfc94742fc1e1bbd(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a6235134b2d3f55aaeeb923152dd98fc46fea1613047b7be44b49f3f3424b0d0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b40025f9081a82b7ed0c7175f79f44200d69b6c547d211171606d04b2f3d74fc(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a2f6fe961d1553dc86f04427ac8282612a13dc9858c0a5fe397f2eb4ef981bc1(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1644744f4c59713b625076d97d2ad3fdfdc94b7add22718a86bdb34b76f1590f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationUnsharpMask]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5b0238c5845ce1130472ae98a1a58de4f59b31f3cb504782899eb63630232c6b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__55f210029ff83da029f4085513b8d55cacfbfa09684be53f65212934762543d2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5caf7350137f2d4bfe036c5e05fa5dc98e1a3978c5475ec2ec89eec7f66ea31a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b1fac1b3ddf78de3a946b6d67daf42e6a323c4528bdb60cede5f5ed22785aef8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e49d35d4763647613c60a20af54a31feb5c8a7f6348a2126ad1aab19bb8c9650(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5fa45fe81ca2aab8a07314875c441d08cff8d68fcc95314c6294cc47a7e56f13(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ad49172cfd66d7ce8d85301c342ef5a16ed9334ff049bf5b236c2ae09941b2a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__61b1e78c6495fa4964953e5dc8a3d9e4514a92cbd4eed54c5cf4f87beb4b021b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageTextImageTransformationUnsharpMask]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d181b7d2bfd8b174331e5a17f30376009779a261f8412e115c4b37a67b262afc(
    *,
    transformation: typing.Optional[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    url: typing.Optional[builtins.str] = None,
    url_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c3eee714f625377316916f9c68b6a210b93c07e6f03d2e9564f86b0d759d121c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be1223c2fbc97d7179a46b467beb4350944fb4fe7a8eb9a62a19ca5f1a9a68bc(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__040637e33442054985a7d2e561878d691567780f5f5236ce5bc85ebcda042ee5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__737183fc79deda7bc05a3eadf13f686fea8e2afdb7ef39c570d129abcc8efc2f(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6ce1c80de5cb7bc37e62a2b54fbd696445bc2a0a88b139ff04cde26cae4b9f23(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a9fcc4e9ea9438e4c1bf40139595839c66a4f4c3a333d07df0e23bf0e5591a1c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImage]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a68c246a68a04cc46832200308b895f071083ab5e0c4c2d0e9f63f91e7a81de(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ce749bc5f613b5d952a91d4c3873a528ec067d5f05de432dcab770e1325e3ea2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d5f0d872b01fc41187d2a749704a0b1dbad3871af0487129fc555d45f1ec0d54(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e394d319429e2e40aaf47c3ee120835fd833c309fcb6321079a5fe6c67277ade(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImage]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9c53ac741bf4657a5f6a91c7f85158ed9f97865cce0421c49df02a38c90c7297(
    *,
    append: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationAppend, typing.Dict[builtins.str, typing.Any]]]]] = None,
    aspect_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationAspectCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    background_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationBackgroundColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    blur: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationBlur, typing.Dict[builtins.str, typing.Any]]]]] = None,
    chroma_key: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationChromaKey, typing.Dict[builtins.str, typing.Any]]]]] = None,
    composite: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationComposite, typing.Dict[builtins.str, typing.Any]]]]] = None,
    compound: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationCompound, typing.Dict[builtins.str, typing.Any]]]]] = None,
    contrast: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationContrast, typing.Dict[builtins.str, typing.Any]]]]] = None,
    crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    face_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationFaceCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    feature_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationFeatureCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    fit_and_fill: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationFitAndFill, typing.Dict[builtins.str, typing.Any]]]]] = None,
    goop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationGoop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    grayscale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationGrayscale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsl: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationHsl, typing.Dict[builtins.str, typing.Any]]]]] = None,
    hsv: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationHsv, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_dimension: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfDimension, typing.Dict[builtins.str, typing.Any]]]]] = None,
    if_orientation: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationIfOrientation, typing.Dict[builtins.str, typing.Any]]]]] = None,
    im_query: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationImQuery, typing.Dict[builtins.str, typing.Any]]]]] = None,
    max_colors: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationMaxColors, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mirror: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationMirror, typing.Dict[builtins.str, typing.Any]]]]] = None,
    mono_hue: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationMonoHue, typing.Dict[builtins.str, typing.Any]]]]] = None,
    opacity: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationOpacity, typing.Dict[builtins.str, typing.Any]]]]] = None,
    region_of_interest_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationRegionOfInterestCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    relative_crop: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationRelativeCrop, typing.Dict[builtins.str, typing.Any]]]]] = None,
    remove_color: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationRemoveColor, typing.Dict[builtins.str, typing.Any]]]]] = None,
    resize: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationResize, typing.Dict[builtins.str, typing.Any]]]]] = None,
    rotate: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationRotate, typing.Dict[builtins.str, typing.Any]]]]] = None,
    scale: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationScale, typing.Dict[builtins.str, typing.Any]]]]] = None,
    shear: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationShear, typing.Dict[builtins.str, typing.Any]]]]] = None,
    trim: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationTrim, typing.Dict[builtins.str, typing.Any]]]]] = None,
    unsharp_mask: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationUnsharpMask, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__342d65aac4e8c7fcae7093f78402950c0563f57e87794f25b2047081595427ce(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationAppendImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_priority: typing.Optional[builtins.str] = None,
    gravity_priority_var: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    preserve_minor_dimension: typing.Optional[builtins.str] = None,
    preserve_minor_dimension_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a4c7646f770dc778bfe0b00d4b919e9eb9389911f96247c39de51b6952e4e1e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6654494739ff85fcabe507068dc58d06d1af0b5164225cb7c4b6379173acf086(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationAppendImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f38cca77ea95ea8ea37001053476e116f9d4bcab637b1273a64a23d0e9977df1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a8c2f0fd0309fe56b5888c12cfdad16ffb8b8250214a97227022dbb2096b4911(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__20311c1cb8a20ba09324372b2b6c90697d1d2090252a15ba599e1b79a9227493(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c7996bf263a796bca74270371cc55ba51e73c6a37d0d3fc4c3230204471acca7(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__721d052f6949da1e40b38dc2357488e28f7d6ccc0a830f09c2d7c08b3f0f60c3(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__255d1647caccc13581b490ccfe9c61966174bcc3999110494823af662579d57f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationAppend]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4d66b3f2ea28d11e3a753d76001beab1202978d404d66060dfac61ce6697014f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6a83b61c3c273206022ca617ddf3931abf9701f1f9acd062bc3acee2eeae0e1b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5d83cb140da0f475720c992453edea5803d0c3573d7e8eb529baf3804a535b12(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__04318ccba173005a7d9663ed033ab7daafd21bf32ddf5112e9c20dea9edbc190(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b9b945e6339a8b0ae8ea87c2a2e79ed77451b925407107e242a1386afbfcd048(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c880a67c7c39464ec2e1b49a5fbc07953ddc817b472a466c98592f91fdaa2172(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__73ba4a99f8e570f34d9d7173bdeb9c7ac9c5270d82727ec061d4f9713980f8d5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d95d3e85f6bf23f86b8fa76b2cf6428ec6cd249facf4436279a97f2dd9d925d2(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationAppend]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__44455b78bd36e47c25198b01f1e23a17cbe0beb06f3b8c8fe35ee50fef99b587(
    *,
    allow_expansion: typing.Optional[builtins.str] = None,
    allow_expansion_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9e53e60681e4f42ae0451fad850688b7494b0621cc228ad2d0348b3a1c751e3d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1711be50ac723b5de5236c9d07af628b78abd28ec8830d414a39834b6af75c81(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d1b8081ac45c5f598605343552a141c930b7741b7d29a8402473fcdb1de37bf3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__079f6c2b936fa3db7fad506187708059d8322df789632d18c439a377082a2eb6(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b3bde60523ee44dfdf203654e0d74637be01dd05a01aa81ba52ef0dbbf50bbd6(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__096d38ddf4307a18ce4c3e280a467c888131208008b397aa4848a57ff7d8956d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationAspectCrop]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4270ca270f0d435573a09cd40133753808683d22b41595a912401fe46b4468ac(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__32b26bb9c6d8eff4763a4ce8a2387fab0ed3224388a4652df2313a4eb9094e3c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f4e800f37c094bda5a0df711ed7bad20c64c24a40c2cfc48cc28d09de64ac00(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4b347247f382124ddc5c02e6f506e4a3d35cf3259f159b0eb74673d11fad494e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ffcf52b2972e98e89ebc85ab7cbab43585db1d0ce063b6454e14f43c04df51e5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ecf6e42f882504c7cbb51f6e3bd5e114c715c807a7ed3d4bcc3e9d806d637ec3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ef8262125fd2952677d71d78aeed532ad8c88f4ac24cc7789fdf7261e64934f5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__83858675786e10ac3044e9a1c6a1c8c35da134d2c5c537279cbb224f1dbb4323(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8b00e5298ce4ac0d531899f4f2da570043e2b4cd63e0c6c2d45561b0e108311c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b4e688d98dffc8c3b906856ca94691f4df5e19daaec6093c7795834843bcfe64(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__81c6fa06b784e42e32cc040934e4747d0d13e457f8f47e4b1d6040c8ed926bb3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7871ac0e63837931c21aa602ae4d0e0e04d65edec4aa04a8ae6b56df6888b2b8(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationAspectCrop]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5242fa747b953437dbf2e6fc49f41279ce9f579474b37db148d2cfc95fa74126(
    *,
    color: typing.Optional[builtins.str] = None,
    color_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__14c822537e0f4f58753d7d9a1bb5d7ae80b94babfa6370b40a4b9606e5af22be(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f125b9e1a8866d4759a9090f81626c65f870ec87bd1896f63adaa1f4c973740f(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__22347bb8aa5d868c9917cdb18cd13a66d0217c25ebc5cf992b495b33fb3bce84(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e0992569425b1727a5760384992d01f7ef8ba0f59262058a91eaa5441606b74e(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ea05b81eb7e92548da733645cc227c9a05941225b469522812317bc1797f805(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6612856e5d33f0efac3cdd484cb9de3dfb8d917b1ee3b7896fb0efee7bf6e5a6(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationBackgroundColor]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7b8a788086ca0e2dabee15c5d2a72ff870549fc1f3118d318d27530769a26aaa(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f00d5fef6a43efd6b0d3a92da0d75630a8ae6f3c50dc50764d105373c83df571(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__301266238e4d1e3d9ed020e0fd5b804a212b020f92eab9140ee9f6e4446ad199(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b17ae5e1a49d7b196cccb28c21daf90ac9636f0bc542c61b892e8da7cbd4b84c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationBackgroundColor]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a4eaf494eacdec894208e01672d5fd5f91fde132338291a259a7f73e7a0e678(
    *,
    sigma: typing.Optional[builtins.str] = None,
    sigma_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a3c6920dfe6345be4b9519aa1484af849e1656885e8a3b801e0a5cfba12edf9a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__06160257e64fa289b724bea5d2e8ab5da2a599297d4102d10f78bbb0e1be9fca(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2207d6d792528dc05d1e780dc4594ca1d752d3e4f9dbf5467ff1854e9e5aa0a1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cfaac72b9dcf7e942a978047709ee36cc7856e91436980014a2f55d550c58998(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8ec4b2417081fe3fa87e5c47a17256f25a64dddb66e10403369dea5a9739e5c9(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c87e2795b88a72f0fb748eb14272925fb89b12d1247b0a1db8661732d3d37b81(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationBlur]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__017a44c741be5fba4d21ee244c7f3fd0b99b39d919054d10ed089bf1cbeb82ac(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__689df0ce18828a0f3caa9fb08e29677f70552f5d9e6c75083df36267a0c15941(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__acbd13d334467b24a82bad7dc371b3ef5e0d34d3f033ef5e910255e4507bbb77(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__68f57df8ef5a289565ae582472f8eac82bafa10ae31151b70d7bccc4b59ec89d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationBlur]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__45dbf6246b415c94fe2bc9f97eca26488c3878f475a90e86a913034646d86c08(
    *,
    hue: typing.Optional[builtins.str] = None,
    hue_feather: typing.Optional[builtins.str] = None,
    hue_feather_var: typing.Optional[builtins.str] = None,
    hue_tolerance: typing.Optional[builtins.str] = None,
    hue_tolerance_var: typing.Optional[builtins.str] = None,
    hue_var: typing.Optional[builtins.str] = None,
    lightness_feather: typing.Optional[builtins.str] = None,
    lightness_feather_var: typing.Optional[builtins.str] = None,
    lightness_tolerance: typing.Optional[builtins.str] = None,
    lightness_tolerance_var: typing.Optional[builtins.str] = None,
    saturation_feather: typing.Optional[builtins.str] = None,
    saturation_feather_var: typing.Optional[builtins.str] = None,
    saturation_tolerance: typing.Optional[builtins.str] = None,
    saturation_tolerance_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0e022d62f9b1d60fe2d57ce578beb7c3cf91ff3d429ddad3a2ceb27a084533c7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__36320fb229dac717f5e50c1382d05e12a388a275ba8de2ea8201c4472f7a7fbb(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d6b39da49969f1f657fa96ec08931b20976aec72f47767596e6c5869d785f450(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6dd2f4a9b9328a97bb5753ec9ebd4d2d88bb06a2f46f85b81953cddb2469e3b6(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bcab15c1d7091bad8db0a80ae8dcb6dd7450b428b02eac219245ca23be8bab65(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4186779501b14f7c4c04fba86525910d3d6eb21bbc60969c888defe0980f61b6(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationChromaKey]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c529988b5a9a8057a4ce8ec509b43387c381ea407d3f0aa29c8a1164b26f2d7c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c5ed2f9047b420b0ef5453b2d530fc3be641684822fd99028b4eda90d1b2a905(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__93b3778d9877dc7addb2a227aaaf23ad144d1a807eae74a3a0a7bf6f7e577e33(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4592a87c8a4e4e483773207174aa92f0da9f6cee6ec9abf54edbb0e0ec233955(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b6034452ceba4588a00769bbb2a644b57b294306a8f77f1e6b69970283f0a9cf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1a15c0c9537550f14378c2be07c168f8347e78497019585b762ee0b82bd5c3ab(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__41f20a412544fdc8475fcfc5c01be125cdc135dda3ca762a2656852593943f14(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6eebcb8541ccb9a1b9c469d8696c38c73f989978b8f94a524013f184796b1894(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fa3eecc64a7c11f02c8179ee1081930edc963ceba35f6dbfbb55a4bb7b5ae6a4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8f3b9824e8a5c78bc043fad87c980293c27650c3a8aa25872560cf87c9e52e68(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__051bebb281d8a8261ad739da6a0e54583eb43ab3c3ee797eababa558c277d58b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__72384bf62b1b590624ef86fc78104e3433d95e701fdc0314444f1eff5920cab1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2b2195a481ee86b02d061a36efd2e0bff97914f85f1196aebbb1a96f21debc2a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9b785e07ed0c845c635d77f8d0aaf9afda02d7d928662f6a7faabb1394438185(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2858eee6577c47385bf54abf3d9f6034b2869abc4fd36a2411e29c452d5941f5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__949e39adbae010953daa00d0acaf12c902d60e02e15206557a1b6a547aaacb0e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationChromaKey]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a85dc2b10fc3b60ffb5d1ad298454cf5608c685684a5199ac84a1bbd19dbd550(
    *,
    image: typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationCompositeImage, typing.Dict[builtins.str, typing.Any]],
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    placement: typing.Optional[builtins.str] = None,
    placement_var: typing.Optional[builtins.str] = None,
    scale: typing.Optional[builtins.str] = None,
    scale_dimension: typing.Optional[builtins.str] = None,
    scale_dimension_var: typing.Optional[builtins.str] = None,
    scale_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3f5b8de4fa7e292e8a98e64d9131bc540b71941a3dc0692207c59dc5493ec99a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0269195247e0107e8083c74f9bfb8921c82c269c7ed31f9bc7963f52abf5fef8(
    value: typing.Optional[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationCompositeImage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dfa12630ea50ae7eb6f2626cdbf0199c52eed3fe3129f2126b22490b25459a25(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__48c1b71829c69477517fcdef414b7110958c1f37ebfef9fdc1aeba5734079221(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d4c9fc44300d97787bca18cd4a9188d53d2ce3d786c78d0812caa04daeaffe41(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd51a917dacefbc2cd94b732341608ddc4c03cddb74cae647f961c980e31d507(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb17610df514de3b5233744da808ae79baa62e05b057ac9491c84e92297ae530(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__772ee7318ea8359364bbd1b8a13a5c8c8084e13654242b677754eb7c16cfbe54(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationComposite]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__45f90a4ba09c1d01a55bd004a2b370a87b755d4661e1ed7120351140ed8bccf8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__239681d0fd325afa69e221a3f480460e94466f4c2aadcd082f9939167f8d7b0c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b00a76476a3e83c5fc5f90dc1c00e5374bbe35bc6e1e40c58b40e844e0017c9a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fdbd0a311f2b39262232a5966a660cbbdaf356a4c724d040069cfebef9d10a82(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dc704923417c40efba5ec1b694eee87cd339af4ba9f99f497220a46577c13b0b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__68a6e29ce4751b04b228142d85400dc6194d367b89e17cbcc7a60ef396ae25f4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2f1382f70c6885ed25b5510dc6befd6a0280c42e33ee702482e57c563564fb28(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6fb9eca53cf0b4cb8eafa575b3bb58fc1e32a33be158af17ccdabfa314a03097(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3f108f7720a82331758fb575490e05d53e86a244fd1da7c23436b44cb8783444(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4fa9e5c8bcc02335a04845a7171f69d21b82d8a55a6a586de77dcf9381580aff(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a7d97cd35aeecda3d444d8493dbf62a6ffddc2109026adf4cfdff54a80c06824(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__206431a530dd0bb69fce999f19043505358f3d9a26c2d9667f4e9ca006a0818c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d7ad7619bf10778ead10087e9619dfca8c5b6c75ac931e17ba3020be290fd2a0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e55aba129cfe5ca0c9b4faf9c32777c8ce10898697b89d10539ac8063f25ce1f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationComposite]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b473e60545f55e74410623a3b1f62f8d66f41b64836060e7e1b0ff5194a447e7(
    *,
    transformations: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2bafcfa6156e8228afabeff108eb19420991d5732b52f582143821cf6847f10f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__514617949c2c5a5380d7528baba3090804860173b51373382574b54e75f30161(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__60221f8490cb83bc5139fbc49e7578fed693fa8a30f5cdedec189fdece039f6a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__097228a2583a8c185c6c4049535a8b442ff6f287c8764cfbb62ca4cbe46f75c3(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c66f29916c0d30cfd3695351dc3bae9721346a30719379193a32ba2ca0fb1b61(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab6cc5f59e5e85e862be87bed82ea8fc722a950ad089174bcfec4e3dc3143669(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationCompound]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d823b86bb1b3fb196c4f0b90b21e40c61e9500384754f8d8534ef0cedac61fe4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5159e739e16679aadb1c38975ccbc9dacc86b8af6406f2df3814e5da82959785(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationCompoundTransformations, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e051128ac9b41c4de2524fe555de1d42247b636c02804dc80f3ffc68f5d49ca7(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationCompound]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f2bced747e26388efe3b61ba12e9a5d67fe9d393c4acebe6d89bf6a655c2c23d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a7782b6087bf2d2ba5463512fbd302e2598ddbe722c41818c2b60f08b7948434(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6946da4fe59d848906f668b642fba5792968a7486b3f1bb0cd8dfa06e58268e3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b46cd1459a2237443f484427eeb103fe418f2eed2cc06185be3a87ea3b7b9127(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5d9ca663a2015a66e14cd4b8ebcbd07caf5a9bd56e7369c9dc4e11a10feadd53(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__508ae840b573a88fd237ed17d3ffe376562d3f339249ab76a41f9eb613011463(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationCompoundTransformations]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c727a0dfc99dde5469903f183fd6a37d9d99bef85d086a21dfe5922a2919715a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__56313e2a1961539b8257b1e922dcf391fb6ea60e2c1bcc4cfda09c2da7f8027b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationCompoundTransformations]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__12c5e45b586695a7685b485d05f12100c216d5b1b1771f20b2fb2d9d42c74e51(
    *,
    brightness: typing.Optional[builtins.str] = None,
    brightness_var: typing.Optional[builtins.str] = None,
    contrast: typing.Optional[builtins.str] = None,
    contrast_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__325482d99e2b1e58bf9b1b28cee323d56ee3fd9dcdc4190451c2670e2dfd3273(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f663979784a98fd9e60fe8e6889921cd1757bd108daf6bb2297758825eaf72d4(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b0d99692c0be9d4777509f6c8c79dacf3338b4966caf0ab8c39fd3d0d9729817(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__60be57ffdefc800bf432a9a740ba6fd661decdc7c4b2f5aa2331b79a320bfc82(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c9987b6e879ca8c5253c8a2ed548a6b10e8527f76fdf8e767099ed0353b7922d(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d2c71465704feeab7e2cb29cf0da1a270dd81bfc5447cdfa5ec9d8258d8582cf(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationContrast]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a64202a9c2ea1ef9cf619308c2092405c863a4a14dfe4b93fee9d1e01d81eba(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c2c24bc62e0d9fae160873c530b96e5329c5c58eb7e843bf6bf41d70e7c966ba(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2aa99f70227154f2a8d0dfd9428118e95210542485a6bd0de156507f542a18c7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__886b981fbc3a07dc5516e692ee624e28b7013c6af7454492257c81a2700c9faa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__54877fadb72f11c178d18547f6a08ffe6a26c639140bf2b40797ebcd44ed572d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ddd1e1e0034865b3da0d110a9f16560b0a8253759f12b90cda52f95deea5a72(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiImagingPolicyImagePolicyTransformationsAppendImageUrlImageTransformationContrast]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0e8ab59b11f56b7fce9ad393b34f57ade9a368b81b7c5c083947023acd392fcb(
    *,
    allow_expansion: typing.Optional[builtins.str] = None,
    allow_expansion_var: typing.Optional[builtins.str] = None,
    gravity: typing.Optional[builtins.str] = None,
    gravity_var: typing.Optional[builtins.str] = None,
    height: typing.Optional[builtins.str] = None,
    height_var: typing.Optional[builtins.str] = None,
    width: typing.Optional[builtins.str] = None,
    width_var: typing.Optional[builtins.str] = None,
    x_position: typing.Optional[builtins.str] = None,
    x_position_var: typing.Optional[builtins.str] = None,
    y_position: typing.Optional[builtins.str] = None,
    y_position_var: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__798735a25302af882718eb6a9957b5c983554129228699ca35c09e0f311dcaf5(
    terraform_resourc